# NASTRAN-95

[![Build Status](https://travis-ci.org/ldallolio/NASTRAN-95.svg?branch=master)](https://travis-ci.org/ldallolio/NASTRAN-95)

NASTRAN has been released under the  
[NASA Open Source Agreement version 1.3](https://github.com/nasa/NASTRAN-95/raw/master/NASA%20Open%20Source%20Agreement-NASTRAN%2095.doc).


NASTRAN is the NASA Structural Analysis System, a finite element analysis program (FEA) completed in the early 1970's. It was the first of its kind and opened the door to computer-aided engineering. Subsections of a design can be modeled and then larger groupings of these elements can again be modeled. NASTRAN can handle elastic stability analysis, complex eigenvalues for vibration and dynamic stability analysis, dynamic response for transient and steady state loads, and random excitation, and static response to concentrated and distributed loads, thermal expansion, and enforced deformations.

NOTE: There is no technical support available for this software.

PREREQUISITES:

    -  A fortran compiler, gfortran will do. On Linux, Windows (mingw) and
       on Android using CCTools.
    
    -  GNU make.


HOW TO USE:

    1. Run make.
    
    2. Avoid the "-" character, it will break nastran.
    
    3. Place your problem file in the "test" directory. You'll finde 
       some in the "inp" directory.
    
    4. Run from there ..\bin\nastran.sh xxx or on windows  ..\bin\nastran.bat xxx
       where xxx is your problem file (without the file extension). For
       Android have a look at the android.sh script. For Android you have
       to link the program statically, otherwise it will segfault.


ISSUES:

    -  This is really old stuff, unmaintained for over 20 years. Expect
       something will break.
    
    -  There are some features missing in comparision to the commercial
       Nastran versions. Some entities have different names.
       E.g.:  RBE3 <=> CRBE3
             CHEXA <=> CIHEX1
    
    -  The CQUAD4 and especially the CIHEX1 (the Cosmic CHEXA) suffers from
       shear locking. Two test cases are profided in the test directory. 
       This could be improved by implementing selective reduced integration
       as it is described in the Fourteenth NASTRAN Users' Colloquium
       (p. 28ff) and in: http://paginas.fe.up.pt/~rnatal/paper.pdf.
    
    -  There seems to be no corner stress output for the CQUAD4 element,
       whereas it is calculated within the SQUD42 subroutine.
    
    -  There are no optimization capabilities, exept the FSD method as
       shown in the NASTRAN DEMONSTRATION PROBLEM NO. D01-16-1A
    
    -  There is no predefined binary result output, as some users may be
       used to PARAM,POST. Nevertheless it is possible to write an op2 file
       via DMAP alters, which then can be read by common post-processing
       software. Basically insert 
       OUTPUT2  "DATABLOCK",,,,//C,N,0/C,N,11////C,N,*MSC* $
       after the OPF DMAP statement.
    

      SUBROUTINE CIFSDD
C
C     THIS SUBROUTINE INITIALIZES THE CIFS1P, CIFS2P, CIFS3P,
C     CIFS4P, AND CIFS5P COMMON BLOCKS.
C
      INTEGER B1, BARDF2, BARDF5, BARDF6, BARDF7, BARDF8
      INTEGER G1
C
      LOGICAL SLOT
      LOGICAL FPHYS, FPHYS1, DMIFLG, FTHRU, FPHYS2
      LOGICAL GRDMSG, LH, IDFREQ
      LOGICAL LFLSYM, FFPHYS
C
      COMMON /CIFS1P/ B1, BARDF2, BARDF5, BARDF6, BARDF7, BARDF8,
     1                KM1, SLOT, IDRDL
      COMMON /CIFS2P/ FPHYS, FPHYS1, KM2, DMIFLG, IBCDS, FTHRU, FPHYS2
      COMMON /CIFS3P/ GRDMSG, LA1, L7, KM3, L0, G1, LH,
     1                IGDST2, IGDST6, IGDST7, IGDST8, IDDSF,
     2                IDFREQ, IDRAD, NVAR, IDS, JMS, KMS, LPLF
      COMMON /CIFS4P/ J(20), KM4, LFLSYM, FFPHYS
      COMMON /CIFS5P/ KM5, IC, IP, ICONT, IAERO, IPOPT
C
      DATA ICC/1HC/, IPP/1HP/
C
      B1 = 1
      BARDF2 = 0
      BARDF5 = 0
      BARDF6 = 0
      BARDF7 = 0
      BARDF8 = 0
      KM1 = 0
      SLOT = .FALSE.
      IDRDL = 0
C
      FPHYS  = .TRUE.
      FPHYS1 = .TRUE.
      KM2 = 0
      DMIFLG = .FALSE.
      IBCDS = 0
      FTHRU  = .FALSE.
      FPHYS2 = .TRUE.
C
      GRDMSG = .FALSE.
      LA1 = 0
      L7  = 0
      KM3 = 0
      L0 = 1
      G1 = 1
      LH     = .TRUE.
      IGDST2 = 0
      IGDST6 = 0
      IGDST7 = 0
      IGDST8 = 0
      IDDSF = 0
      IDFREQ = .TRUE.
      IDRAD = 0
      NVAR  = 0
      IDS = 0
      JMS = 0
      KMS = 0
      LPLF = 0
C
      DO 100 I=3,20
      J(I)  = 0
  100 CONTINUE
      J(1) = 20
      J(2) = 2
      KM4 = 0
      LFLSYM = .FALSE.
      FFPHYS = .TRUE.
C
      KM5 = 0
      IC = ICC
      IP = IPP
      ICONT = 0
      IAERO = 0
      IPOPT = 0
C
      RETURN
      END

      SUBROUTINE AUTOSV
C
C     THIS ROUTINE GENERATES OSCAR ENTRIES FOR PARAMTERS
C     THAT ARE TO BE SAVED IMPLICITLY
C
      EXTERNAL         LSHIFT,ANDF
      INTEGER          SAVNAM,OSPRC,OSBOT,OSPNT,OSCAR(1),OS(5),XSAV(2),
     1                 DMPCNT,ANDF,VPS
      COMMON  /XGPIC / JUNK(25),MASKHI,JUNK1(2),NOSGN
      COMMON  /AUTOSM/ NWORDS,SAVNAM(100)
      COMMON  /ZZZZZZ/ CORE(1)
      COMMON  /XVPS  / VPS(1)
      COMMON  /XGPI4 / JUNK4(2),ISEQN,DMPCNT
      COMMON  /AUTOHD/ IHEAD
      EQUIVALENCE      (CORE(1),OS(1),LOSCAR), (OS(2),OSPRC),
     1                 (OS(3),OSBOT), (OS(4),OSPNT), (OS(5),OSCAR(1))
      DATA     XSAV  / 4HXSAV,4HE    /
C
C     UPDATE OSCAR PARAMETERS
C
      IHEAD = 1
      OSPRC = OSBOT
      OSBOT = OSCAR(OSBOT) + OSBOT
      OSPNT = OSBOT
      ISEQN = OSCAR(OSPRC+1) + 1
C
C     LOAD HEADER
C
      OSCAR(OSPNT  ) = 6
      OSCAR(OSPNT+1) = ISEQN
      OSCAR(OSPNT+2) = 4 + LSHIFT(8,16)
      OSCAR(OSPNT+3) = XSAV(1)
      OSCAR(OSPNT+4) = XSAV(2)
      OSCAR(OSPNT+5) = DMPCNT
      CALL XLNKHD
C
C     HAVING THE VPS POINTERS FOR EACH PARAMETER, FIND THE
C     DISPLACEMENT IN COMMON
C
      J = OSPRC + 6 + 3*OSCAR(OSPRC+6) + 1
      IF (ANDF(OSCAR(OSPRC+2),MASKHI) .EQ. 1) J = J+1+3*OSCAR(J)
      J  = J + 1
      N3 = J+1
      N1 = OSCAR(J)
      N2 = 1
      OSCAR(OSPNT+6) = NWORDS
      OSCAR(OSPNT  ) = OSCAR(OSPNT) + 1
      IPT = 1
      IST = N3
140   IF (OSCAR(IST) .GT. 0) GO TO 110
C
C     SEEE IF PARAMETER IS IN SAVE LIST
C
C     LL = ANDF(OSCAR(IST),NOSGN )  REPLACED BY NEXT CARD, OCT. 1983
      LL = ANDF(OSCAR(IST),MASKHI)
      L  = ANDF(VPS(LL-1) ,MASKHI)
      DO 100 I = 1,NWORDS
      IF (ANDF(OSCAR(IST),NOSGN) .EQ. SAVNAM(I)) GO TO 120
100   CONTINUE
C
C     NOT TO BE SAVED, GO TO NEXT PARAMETER
C
      IST = IST + 1
      N2  = N2  + L
      GO TO 140
C
C     CONSTANT PARAMETER, SKIP IT
C
110   NWD = OSCAR(IST)
      IST = IST+NWD+1
      N2  = N2 + NWD
      GO TO 140
C
C     PARAMETER TO BE SAVED, PUT IN OSCAR
C
120   OSCAR(OSPNT+6+2*I-1) = SAVNAM(IPT)
      OSCAR(OSPNT+6+2*I  ) = N2
      OSCAR(OSPNT) = OSCAR(OSPNT) + 2
      IPT = IPT + 1
      IST = IST + 1
      N2  = N2  + L
      IF (IPT .LE. NWORDS) GO TO  140
      IHEAD = 0
      RETURN
      END

        SUBROUTINE INTPK ( *, FILE, BLOCK, ITYPOT, IFLAG )
      INCLUDE 'DSIOF.COM'
      INCLUDE 'PAKBLK.COM'
        COMMON / ZNTPKX / A(4), IROW, IEOL, IENDRC
        INTEGER BLOCK( 15 ), FILE
        NAME = FILE
        IF ( IFLAG .EQ. 0 ) GO TO 10
        CALL DSIPK1( BLOCK, ITYPOT )
        GO TO 700
10      IEOL = 0
        IENDRC = 0
        CALL DSIPK1( IBLKB, ITYPOT )
700     CONTINUE
        IF ( IRETRN .NE. 0 ) RETURN 1
        RETURN
        END

      SUBROUTINE OPTP1A (ELT,ELOP,ELE,DTYP)
C
      INTEGER         ELT(1),IWD(28),COUNT,EST,SYSBUF,OUTTAP,ELOP(2,1),
     1                YCOR,ECOR,B1P1,IE(1),IPT(21),IMAT(1),NAME(2),
     2                DTYP(1)
      REAL            ELE(1)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /BLANK / SKP1(2),COUNT,SKP2(2),YCOR,B1P1,NPOW,
     1                NELW,NWDSE,NPRW,NWDSP,SKP3,
     2                MPT,SKP4(3),EST,SKP5(2),NELTYP,ITYPE(21)
      COMMON /OPTPW1/ ECOR,E(1)
      COMMON /GPTA1 / NTYPES,LAST,INCR,NE(1)
      COMMON /SYSTEM/ SYSBUF,OUTTAP
      COMMON /MATIN / MATID,INFLAG,TEMP,PLA,SINTH,COSTH
      COMMON /MATOUT/ OMAT(20)
      COMMON /NAMES / NRD,NOEOR,NWRT,NWEOR
      EQUIVALENCE     (E(1),IE(1)), (OMAT(1),IMAT(1)), (K1,C1)
      DATA    NAME  / 4H OPT,4HP1A  /
C
C     POINTER TO IPT ARRAY - ZERO MEANS ELEMENT NOT USED.
C     UPDATE IPT DIMENSIONS AS NEW ELEMENTS ARE ADDED
C
      DATA    IPT   / 15,17,21,11,23,  25,11,13,11, 1,  5,9,7,9,19,
     1                 9, 9, 3,27,27,   0/
C
C     WORD POINTER TO EST AND MATERIAL STRESS LIMITS
C     WORD 1 = 100*WORD TO OPTIMIZE (EST - IF.NE.0) + ALTERNATE
C     WORD 2 = 100*WORD FOR STRESS LIMIT + ALTERNATE
C              WHERE 1 = SHEAR
C                    2 = TENSION/COMPRESSION
C                    3 = ANY/ALL NONZERO
C
      DATA    IWD   / 506,201 , 500,200 , 700,100 , 709,303 , 700,300 ,
C                      11        13        15        17        19
     1                800,300 , 810,303 ,1718,202 , 910,202 ,1011,303 ,
C                      21        23        25       27
     2               1300,303 , 800,303 , 800,303 ,1400,300 /
C
      NELW   = 0
      SINTH  = 0.0
      COSTH  = 1.0
      PLA    = 0.0
      INFLAG = 2
C
C     COPY POINTER ARRAY INTO CORE
C
      DO 10 I = 1,NTYPES
      ELT(I) = DTYP(I)
   10 CONTINUE
C
C     ZERO OUT POINTER ARRAY
C
      I1 = 2*(NPOW+1)
      DO 20 I = 2,I1
   20 ELOP(I,1) = 0
      ELOP(1,1) = 1
C
C     READ IN ELEMENT TYPE
C
   30 CALL READ (*120,*170,EST,IETYP,1,NOEOR,I)
      IF (IETYP .GT. NTYPES) GO TO 110
      INTYP = DTYP(IETYP)
      IF (INTYP .LE. 0) GO TO 110
C
C     DECODE LIMITS NEEDED
C
      I  = IPT(INTYP)
      J2 = IWD(I)
      J1 = J2/100
      J2 = J2 - J1*100
      I2 = IWD(I+1)
      I1 = I2/100
      I2 = I2 - I1*100
      NEST = (IETYP-1)*INCR + 12
      NEST = NE(NEST)
      IF (NEST .GT. ECOR) GO TO 200
   40 CALL READ (*160,*115,EST,E,NEST,NOEOR,K1)
      MATID = IE(J1-1)
      IF (MATID .EQ. 0) MATID = IE(J2-1)
      TEMP = E(NEST)
      CALL MAT (IE(1))
C
C     TEST IF PERTINENT STRESS LIMITS ARE ZERO
C
      K1 = 0
      K2 = 0
      IF (I1.EQ.2 .AND. I2.EQ.2) GO TO 50
C
C     SHEAR
C
      IF (OMAT(15) .NE. 0.0 ) GO TO 50
      IF (I1 .NE. 2) K1 = 1
      IF (I2.EQ.1  .OR. I2.EQ.3) K2 = 1
   50 IF (I1.EQ.1 .AND. I2.LE.1) GO TO 70
C
C     TENSION
C
      IF (OMAT(13) .NE. 0.0) GO TO 60
      IF (I1 .GT. 1) K1 = K1 + 1
      IF (I2 .GT. 1) K2 = K2 + 1
C
C     COMPRESSION
C
   60 IF (OMAT(14) .NE. 0.0) GO TO 70
      IF (I1 .GT. 1) K1 = K1 + 1
      IF (I2 .GT. 1) K2 = K2 + 1
C
   70 IF (K1.GE.I1 .AND. K2.GE.I2) GO TO 40
C
C     CHECK IF PROPERTY IS NONZERO AND STORE INFO IN PID POINTER
C
      IF (E(J1) .NE. 0.0) GO TO 90
   80 IF (E(J2) .EQ. 0.0) GO TO 40
C
      IF (K2 .GE. I2) GO TO 40
C
C     ALTERNATE PROPERTY USED
C
      K1 = J2*100 + I2
      GO TO 100
C
   90 IF (K1 .GE. I1) GO TO 80
C
C     PRIMARY PROPERTY USED
C
      K1 = J1*100 + I1
  100 IF (NELW+5 .GT. YCOR) GO TO 180
      ELE(NELW+1) = E(1)
      ELE(NELW+2) = OMAT(13)
      ELE(NELW+3) = OMAT(14)
      ELE(NELW+4) = OMAT(15)
C
C     NOTE, K1 = C1
C
      ELE(NELW+5) = C1
      NELW = NELW + NWDSE
       GO TO 40
C
C     NEW ELEMENT TYPE
C
  110 CONTINUE
      CALL FREAD (EST,0,0,NWEOR)
      IF (IETYP .GT. NTYPES) GO TO 120
      IF (INTYP .LE. 0) GO TO 30
  115 ELOP(1,INTYP+1) = NELW + 1
      GO TO 30
C
C     EOF
C
  120 I1 = NPOW + 1
      DO 130 I = 2,I1
      IF (ELOP(1,I) .GT. 0) GO TO 130
      ELOP(1,I) = ELOP(1,I-1)
  130 CONTINUE
      IF (NELW .NE. 0) GO TO 150
      CALL PAGE2 (-2)
      WRITE  (OUTTAP,140) UFM
  140 FORMAT (A23,' 2295, NO ELEMENTS EXIST FOR OPTIMIZATION.')
      COUNT = -1
  150 RETURN
C
C     ILLEGAL EOF
C
  160 CALL MESAGE (-2,EST,NAME)
C
C     ILLEGAL EOR
C
  170 CALL MESAGE (-3,EST,NAME)
C
C     INSUFFICIENT CORE
C
  180 CALL PAGE2 (-2)
      WRITE  (OUTTAP,190) UFM,NAME,B1P1,IE(1)
  190 FORMAT (A23,' 2296, INSUFFICIENT CORE ',2A4,1H(,I10,' ), ELEMENT',
     1        I9)
      NELW = 0
      GO TO 150
  200 CALL PAGE2 (-2)
      WRITE (OUTTAP,190) NAME,ECOR,IETYP
      NELW = 0
      GO TO 150
      END

      SUBROUTINE STQME2( NTYPE )
C
C     PHASE TWO STRESS DATA RECOVERY TRIANGULAR MEMBRANE
C
C     NTYPE = 1 TRI-MEMBRANE
C     NTYPE = 2 QUAD-MEMBRANE
C
C     PH1OUT CONTAINS THE FOLLOWING
C     *** NTYPE = 1 ***
C     ELEMENT ID
C     3 SILS
C     1 DUMMY
C     T SUB 0
C     S SUB T 3X1
C     3 S ARRAYS EACH 3X3
C
C     *** NTYPE = 2 ***
C     ELEMENT ID
C     4 SILS
C     T SUB 0
C     S SUB T 3X1
C     4 S ARRAYS EACH 3X3
C
      REAL    FRLAST(2)
      INTEGER EJECT    ,ISHD(7)  ,ISTYP(2) ,TYP(3)
      DIMENSION NSIL(4), SI(36), PH1OUT(45), ST(3)
      COMMON /ZZZZZZ/ Z(1)
      COMMON /SDR2X4/ DUMMY(35),IVEC,IVECN,LDTEMP,DEFORM
      COMMON /SDR2X7/ EST(100),STRES(100),FORVEC(25)
      COMMON /SDR2X8/ STRESS(3),VEC(3),TEM,TEMP,NPOINT,DELTA,NSIZE,
     1             CVEC(3),CSTR(4)
      COMMON /SDR2X9/ NCHK,ISUB,ILD,FRTMEI(2),TWOTOP,FNCHK
      COMMON   /SYSTEM/  IBFSZ    ,NOUT     ,IDM(9)   ,LINE
C
      EQUIVALENCE
     1  (PH1OUT(1),EST(1))
     2 ,(NSIL(1),PH1OUT(2))
     3 ,(TSUB0,PH1OUT(6))
     4 ,(ST(1),PH1OUT(7))
     5 ,(SI(1),PH1OUT(10))
     6 ,(FTEMP,LDTEMP)
     7 , (ISHD(1),LSUB) , (ISHD(2),LLD) , (ISHD(6),FRLAST(1) )
C
      DATA LSUB,LLD,FRLAST / 2*-1 , -1.0E30, -1.0E30 /
      DATA TYP / 2HTR, 2HQD, 3HMEM /
C     ******************************************************************
C     ZERO OUT THE STRESS VECTOR
      DO 5 I = 1,3
      STRESS(I) = 0.0E0
    5 CSTR(I+1) = 0.0E0
C
C                          I=NSIZE
C        STRESS VECTOR =(SUMMATION (S )(U )) - (S )(LDTEMP - T SUB 0)
C                          I=1       I   I       T
      NSIZE = NTYPE + 2
      DO 20 I = 1,NSIZE
C
C     POINTER TO DISPLACEMENT VECTOR IN VARIABLE CORE
C
      NPOINT = IVEC + NSIL(I) - 1
C
      CALL SMMATS (SI(9*I-8),3,3,0, Z(NPOINT),3,1,0, VEC,CVEC)
      DO 30 J = 1,3
      CSTR(J+1) = CSTR(J+1) + CVEC(J)
   30 STRESS(J) = STRESS(J) + VEC(J)
C
   20 CONTINUE
C
      STRES(1) = PH1OUT(1)
      STRES(2) = STRESS(1)
      STRES(3) = STRESS(2)
      STRES(4) = STRESS(3)
C
C     ADD IN TEMPERATURE EFFECTS
C
      IF( LDTEMP .EQ. (-1) ) GO TO 200
      TEM = FTEMP - T SUB 0
      DO 90 I = 2,4
   90 STRES(I) = STRES(I) - ST(I-1) * TEM
C     STRESS VECTOR COMPLETE AND CONTAINS SIGMA X ,  SIGMA Y ,  SIGMA XY
C
C     ******************************************************************
C
C     PRINCIPAL STRESSES AND ANGLE OF ACTION PHI
  200 TEMP = STRES(2) - STRES(3)
      STRES(8) = SQRT( (TEMP/2.0E0)**2 + STRES(4)**2 )
      DELTA = (STRES(2) + STRES(3))/2.0E0
      STRES(6) = DELTA + STRES(8)
      STRES(7) = DELTA - STRES(8)
      DELTA = 2.0E0 * STRES(4)
      IF( ABS(DELTA) .LT. 1.0E-15 .AND. ABS(TEMP) .LT. 1.0E-15)GO TO 101
      STRES(5) = ATAN2( DELTA,TEMP ) * 28.6478898 E00
      RETURN
  101 STRES(5) = 0.0E0
      IF (NCHK.LE.0) GO TO 250
C
C  . CHECK PRECISION...
C
      CSTR(1) = PH1OUT(1)
      K = 0
C
      CALL SDRCHK (STRES(2),CSTR(2),3,K)
      IF (K.EQ.0) GO TO 250
C
C  . LIMITS EXCEEDED...
      ISTYP(1) = TYP(NTYPE)
      ISTYP(2) = TYP(3)
      J = 0
      IF (LSUB.EQ.ISUB .AND. FRLAST(1).EQ.FRTMEI(1) .AND.
     1    LLD .EQ.ILD  .AND. FRLAST(2).EQ.FRTMEI(2) ) GO TO 220
      LSUB = ISUB
      LLD = ILD
      FRLAST(1) = FRTMEI(1)
      FRLAST(2) = FRTMEI(2)
      J = 2
      CALL PAGE1
  205 CALL SD2RHD (ISHD,J)
      LINE = LINE + 1
      WRITE(NOUT,210)
  210 FORMAT (7X,4HTYPE,5X,3HEID,5X,2HSX,5X,2HSY,4X,3HSXY)
      GO TO 230
  220 IF (EJECT(2).NE.0) GO TO 205
  230 WRITE(NOUT,240) ISTYP,CSTR
  240 FORMAT (1H0,6X,A2,A3,I7,3F7.1)
C
  250 CONTINUE
      RETURN
      END

      SUBROUTINE CONM1D
C
C THIS SUBROUTINE COMPUTES THE CONCENTRATED MASS ELEMENTS
C MASS MATRIX FOR THE M1 TYPE ELEMENT
C  DOUBLE PRECISION VERSION
C
C
C ECPT NO.  NAME              TYPE   DESCRIPTION
C 1         IELID             I      ELEMENT ID
C 2         IGP               I      GRID POINT NUMBER
C 3         ICIDT2            I      COORDINATE ID FOR T2
C 4         M(1,1)            R
C 5, 6      M(2,1) TO M(2,2)  R
C 7, 8, 9   M(3,1) TO M(3,3)  R      MASS MATRIX VALUES
C 10 TO 13  M(4,1) TO M(4,4)  R
C 14 TO 18  M(5,1) TO M(5,5)  R
C 19 TO 24  M(6,1) TO M(6,6)  R
C 25        ICIDT1            I      COORDINATE ID FOR T1
C 26        X                 R
C 27        Y                 R      TRANSFORMATION MATRIX
C 28        Z                 R
C
      INTEGER DICT(7),ELID,ESTID,IECPT(25)
      DOUBLE PRECISION MM(36),TT(36),T(36),M(21)
      LOGICAL NOGO
C
C
      COMMON /SYSTEM/ SS,IOUTPT,KSYSTM(56)
C
      COMMON /EMGPRM/ DUM(15),ISMB(3),IPREC,NOGO
      COMMON /EMGEST/ ECPT(100)
      COMMON /EMGDIC/ DMM(2),NLOCS,ELID,ESTID
C
      EQUIVALENCE (ECPT(1),IECPT(1),IELID)
      EQUIVALENCE (DICT(5),DICT5)
C
C     INITIALIZE
C
      IF (ISMB(2) .EQ. 0) RETURN
      DICT(1) = ESTID
      DICT(2) = 1
      DICT(3) = 6
      DICT(4) = 63
      DICT5 = 0
      IP = IPREC
      XOF = ECPT(5)
      YOF = ECPT(6)
      ZOF = ECPT(7)
      DO 50 I=1,21
   50 M(I) = ECPT(I+3)
C
C COMPUTE NON-TRANSFORMED MASS MATRIX. INITIALIZE
C TO ZERO THEN FILL IN NON-ZERO TERMS
C
      DO  100 I = 1,36
  100 MM(I)=  0.D0
C
      K = 0
      DO 110 I = 1,6
      DO 110 J = 1,I
      K = K + 1
      JI = (J-1)*6 + I
      IJ = (I-1)*6 + J
      MM(IJ) = M(K)
  110 MM(JI) = M(K)
C
      ICIDT1 = IECPT(25)
      ICIDT2 = IECPT(3)
C
C PERFORM TRANSFORMATIONS.  IF CSIDS 1 AND 2 ARE EQUAL,
C T1 = T2 SO MASS MARRIX IS COMPLETE
C
      IF (ICIDT2 .EQ. ICIDT1) GO TO 240
C                             T
C NOT EQUAL. SO COMPUTE T = (T ) (T )
C                             1    2
C GET T1 AND T2 IF NEEDED
      IT = 18
      IF (ICIDT1 .EQ. 0) GO TO 130
C
      CALL TRANSD(ECPT(25),T(1))
      GO TO 140
C
C ONLY T2 NEEDED SO T = T2
C
  130 IT = 9
  140 IF(ICIDT2 .EQ. 0) GO TO 150
      CALL TRANSD(ECPT(25),T(10))
C
      IF(ICIDT1 .EQ. 0) GO TO 210
      CALL GMMATD (T(1),3,3,1,  T(10),3,3,0, T(19))
      GO TO 210
C
C HERE T2 IS IDENTITY AND T1 IS AT T(1) SO
C T = T1 (TRANSPOSE).  SO INSERT INTO T
  150 DO 170 I = 1,3
      DO 170 J = 1,3
      IJ = 3*(I - 1) + J
      JI = I + 3*(J-1) + 18
  170 T(JI)=T(IJ)
C
C T = (T ) (T ) IS COMPLETE. INSERT IT IN THE 6X6 TRANSFORMATION MATRIX.
C       1    2
C
  210 DO 220 I = 1,36
  220 TT(I)=0.D0
C
      DO 230 I = 1,3
      IJ = I + IT
      TT(I) = T(IJ)
      TT(I + 6) = T(IJ + 3)
      TT(I + 12) = T(IJ + 6)
      TT(I + 21) = T(IJ)
      TT(I + 27) = T(IJ + 3)
  230 TT(I + 33) = T(IJ + 6)
C           T
C FORM T*M*T  AND STORE IN MM
C
      CALL GMMATD (TT(1),6,6,0,  MM(1),6,6,0, T(1))
      CALL GMMATD(T(1),6,6,0, TT(1),6,6,1, MM(1))
C
  240 CALL EMGOUT (MM,MM,36,1,DICT,2,IP)
      RETURN
      END

      SUBROUTINE STRAX3 ( AGAIN)
C
      INTEGER IFORCE(25), ISTRES(100), ELEMID, IBLOCK(22,14)
     1,       ICLOCK(22,14),CANGLE
      REAL    SAVEF(75), SAVES(75)
C
      LOGICAL AGAIN
C
      COMMON /SDR2X7/ DUM(100),STRESS(100),FORCE(25)
     1,               SKIP(25),BLOCK(22,14),CLOCK(22,14)
C
C SCRATCH BLOCK
      COMMON  /SDR2X8/
     U                 DISP(9), EFORC(9), ESTRES(9)
     3,                HARM, N, SINPHI, CONPHI, NPHI, NANGLE
     3,                ELEMID, UNU(123), NELHAR
C
      COMMON /ISAVE / ISAVEF(75),ISAVES(75)
C
      COMMON /SDR2DE/ DUM5(33), IPART
C
      COMMON /SDR2X4/ DUM4(51),KTYPE
C
      EQUIVALENCE ( ISTRES(1), STRESS(1)), ( IFORCE(1), FORCE(1))
     1, (IBLOCK(1,1), BLOCK(1,1)), (ICLOCK(1,1),CLOCK(1,1))
     2, (ISAVEF(1),SAVEF(1)),(ISAVES(1),SAVES(1))
     3, (NANGLE,CANGLE)
C
      IF ( AGAIN ) GO TO 10
      AGAIN = .TRUE.
      NANGLE = 0
   10 NANGLE = NANGLE + 1
C
C
C  BRANCH TO INSERT STRESSES AND FORCES INTO FORCE AND STRESS OR
C                                            SAVEF AND SAVES
C
C    KTYPE=1 - REAL OUTPUT FROM BLOCK IS TRANSFERED TO CLOCK, THEN
C            STORED IN FORCE AND STRESS, NOTHING IN SAVEF AND SAVES
C    KTYPE=2 - COMPLEX OUTPUT
C    IPART=1 - IMAGINARY PART OF COMPLEX OUTPUT FROM BLOCK, STORED
C              IN SAVEF AND SAVES
C    IPART=2 - REAL PART OF COMPLEX OUTPUT FROM CLOCK STORED IN
C              FORCE AND STRESS
C
      IF (KTYPE.EQ.2) GO TO 19
      DO 15 I=1,22
      DO 15 J=1,14
   15 CLOCK(I,J) = BLOCK(I,J)
   19 CONTINUE
C
C  OUTPUT FORCES FOR THIS ANGLE
C
      IFORCE(1)=ELEMID
      FORCE(2) = CLOCK(1,CANGLE)
      J = 2
      DO 20 I=1,9
      J = J + 1
      FORCE(J) = CLOCK(I+7,CANGLE)
C
C  OUTPUT CHARGES
      IF((I.NE.3).AND.(I.NE.6).AND.(I.NE.9)) GO TO 20
      J = J + 1
      K=19+I/3
      FORCE(J) = CLOCK(K,CANGLE)
   20 CONTINUE
C
C OUTPUT STRESSES
      ISTRES  (1) = ELEMID
      STRESS(2) = CLOCK(1,CANGLE)
      DO 30 I = 1, 6
      STRESS(2+I) = CLOCK(I+1,CANGLE)
   30 CONTINUE
C
C  OUTPUT FLUXES
      DO 32 I=1,3
   32 STRESS(I+8) = CLOCK(I+16,CANGLE)
C
      IF(KTYPE.EQ.2) GO TO 40
      IF(CANGLE .EQ. 14) GO TO 100
      IF(ICLOCK(1,CANGLE+1) .EQ. 1) GO TO 100
      GO TO 90
C
   40 CONTINUE
C
C  OUTPUT FORCES FOR THIS ANGLE
C
      ISAVEF(1)=ELEMID
      SAVEF(2) = BLOCK (1,NANGLE)
      J = 2
      DO 50 I=1,9
      J = J + 1
      SAVEF(J) = BLOCK(I+7,NANGLE)
C
C  OUTPUT CHARGES
      IF((I.NE.3).AND.(I.NE.6).AND.(I.NE.9)) GO TO 50
      J = J + 1
      K=19+I/3
      SAVEF(J) = BLOCK(K,NANGLE)
   50 CONTINUE
C
C OUTPUT STRESSES
      ISAVES(1) = ELEMID
      SAVES(2) = BLOCK (1, NANGLE)
      DO 60 I=1,6
      SAVES(2+I) = BLOCK ( I+1,NANGLE)
   60 CONTINUE
C
C  OUTPUT FLUXES
      DO 70 I=1,3
   70 SAVES(I+8) = BLOCK(I+16,NANGLE)
C
      IF (NANGLE .EQ. 14) GO TO 100
      IF (IBLOCK (1,NANGLE+1) .EQ. 1)  GO TO 100
   90 CONTINUE
C
      RETURN
  100 AGAIN = .FALSE.
      RETURN
      END

      SUBROUTINE SCHEME (IG,INV,II3,INT,ICC,ILD,NORIG,IP,UN,Z)
C
      INTEGER         Z(1),     SCR1,     RD,       RDREW,    WRT,
     1                WRTREW,   REW ,     SUB(2)
      DIMENSION       IG(1),    INV(1),   INT(1),   ICC(1),   ILD(1),
     1                NORIG(1), IP(1),              UN(1)
      COMMON /BANDA / IBUF1,    DUM4A(4), METHOD,   ICRIT
      COMMON /BANDB / NBITIN,   KORE,     IFL,      NGRID,    IPASS,
     1                NW,       KDIM
      COMMON /BANDD / DUM7D(7), NEQ,      NEQR
      COMMON /BANDS / NN,       MM,       DUM2(2),  MAXGRD,   MAXDEG,
     1                KMOD,     MACH,     MINDEG,   NEDGE
      COMMON /GEOMX / GDUM(3),  SCR1
      COMMON /SYSTEM/ IBUF,     NOUT
      COMMON /NAMES / RD,       RDREW,    WRT,      WRTREW,   REW
      DATA            SUB /     4HSCHE,4HME    /
C
C     THIS ROUTINE IS USED ONLY IN BANDIT MODULE
C
C     ZERO OUT CORE SPACE AND SET BANDWIDTH IMPROVEMENT FLAG, JUMP
C     JUMP = 1,  NO IMPROVEMENT OF CRITERION SELECTED
C          = 0,  IMPROVEMENT
C
      DO 10 I = 1,KORE
 10   Z(I) = 0
      JUMP = 1
C
C     READ ELEMENT DATA FROM GEOM2 FILE AND SET UP CONNECTION TABLE IG.
C     ALSO, EXAMINE MPC EQUATIONS.
C
      CALL BREAD (IG,INV,II3,NORIG,Z)
      IF (NGRID .LE. 0) RETURN
C
C     NGRID = NO. OF GRID POINTS IN THE PROBLEM
C           =  0, ONE OR MORE SEQGP CARD IS PRESENT IN NASTRAN INPUT
C                 DECK, AND/OR QDSEP ELEMENTS
C           = -1, INSUFFICIENT CORE SPACE (IG TABLE TOO SMALL)
C           = -2, INSUFFICIENT SCRATCH AREA WHILE USING CTHMCK
C           = -3, INSUFFICIENT SCRATCH AREA WHILE USING GIBSTK
C
C     MODIFY IG TO ACCOUNT FOR MPC EQUATIONS AND RIGID ELEMENTS
C
      IF (NEQ+NEQR .NE. 0) CALL TIGER (IG,ICC,INV,II3,NORIG,Z,UN)
C
C     SORT ORIGINAL GRID NOS. AND OUTPUT THE LIST IN INT, WHERE INT(I)
C     IS THE I-TH ORIGINAL GRID NUMBER.
C     ALSO OUTPUT ILD, WHERE IDL(I) = SORTED INTERNAL NO. CORRESPONDING
C     TO THE UNSORTED BANDIT INTERNAL LABEL I.
C
C     CALL BRIGIT (INV,II3,INT,ILD)
C     BRIGIT AND INTERN ARE NOW REPLACED BY 17 LINES BELOW /G.CHAN 1988
C
      K = 0
      DO 15 I = 1,II3
      IF (INV(I) .EQ. 0) GO TO 15
      K = K + 1
      INT(K) = INV(I)
 15   CONTINUE
      CALL SORT (0,0,1,1,INT,NN)
      DO 17 I = 1,NN
      J = INT(I)
      IF (J .LE. 0) GO TO 120
      LOC = J - 1
 16   LOC = MOD(LOC,KMOD) + 1
      IF (INV(LOC) .EQ. 0) GO TO 120
      IF (INV(LOC) .NE. J) GO TO 16
      J = INV(LOC+II3)
      ILD(J) = I
 17   CONTINUE
C
C     METHOD WAS SET IN BANDIT -
C     METHOD = -1, CM ONLY,    = +1, GPS ONLY,    = 0, BOTH METHODS.
C
      IF (METHOD .NE. 0) GO TO 20
C
C     SAVE ORIGINAL GRID POINT ORDERING (ILD) IN SCR1 FILE
C
      CALL OPEN (*70,SCR1,Z(IBUF1),WRTREW)
      CALL WRITE (SCR1,ILD,NN,1)
      CALL CLOSE (SCR1,REW)
C
C     RE-SEQUENCE GRIDS WITH CUTHILL-MCKEE ALGORITHM
C
 20   I = MAXGRD + 2
      J = I + MAXGRD
      IF (MAXDEG .GT. MAXGRD) J = J + MAXDEG - MAXGRD
      K = J + MAXGRD
      CALL CTHMCK (80,1,2,ICRIT,IG,INV,INV(I),INV(J),INV(K),INT,ICC,
     X             ILD,IP,JUMP,UN,Z)
      NGRID1 = NGRID
      IF (METHOD) 60,25,30
C
C     READ ORIGINAL SEQUENCE BACK IF CTHMCK MAKES NO IMPROVEMENT
C
 25   IF (JUMP .EQ. 0) GO TO 30
      CALL OPEN (*70,SCR1,Z(IBUF1),RDREW)
      CALL READ (*80,*80,SCR1,ILD,NN,1,M)
      CALL CLOSE (SCR1,REW)
 30   DO 40 K1 = 1,NN
 40   INT(K1) = ILD(K1)
C
C     RESEQUENCE NODES WITH GPS ALGORITHM.
C
      K1 = 1
      K2 = K1 + KDIM
      K3 = K2 + KDIM
      K4 = K3 + KDIM
      K5 = K4 + KDIM/2
      CALL GIBSTK (IG,INT,ILD,INV(I),INV,INV(J),INV(K),ICC,JUMP,ICRIT,
     1             Z(K1),Z(K2),Z(K3),Z(K4),Z(K5),UN,KDIM)
C
C     GENERATE SEQGP CARDS AND OUTPUT THEM TO GEOM1 FILE
C
 60   CALL BSEQGP (NORIG,ILD,JUMP)
      IF (NGRID1.EQ.-2 .OR. NGRID.EQ.-3) GO TO 100
      RETURN
C
C     SCRATCH FILE ERROR
C
 70   K = -1
      GO TO 90
 80   K = -2
 90   CALL MESAGE (K,SCR1,SUB)
C
 100  WRITE  (NOUT,110) KDIM
 110  FORMAT (28H0*** BANDIT SCRATCH ARRAY OF,I5,20H WORDS IS TOO SMALL.
     1,/5X,57HUSER COULD USE ONE OF THE FOLLOWING OPTIONS AND RESUBMIT ,
     2 27HJOB. (USERS MANUAL P.2.1-1), /5X,
     2 53HINCREASE SCRATCH ARRAY BY NASTRAN BANDTDIM OPTION, OR, /5X,
     3 53HSWITCH TO CUTHILL-MCKEE METHOD ONLY BY  BANDTMTH=1 OR, /5X,
     4 57HSKIP BANDIT COMPUTATION BY SETTING NASTRAN CARD BANDIT=-1,//)
      GO TO 140
C
 120  WRITE  (NOUT,130) K,NN,II3,KMOD,MAXGRD,MAXDEG
 130  FORMAT ('0*** BANDIT FATAL ERROR - TRY TO RERUN JOB WITH ',
     1       22H'NASTRAN BANDTDIM = N',' WHERE N = 3,4,...,OR 9', //5X,
     2       '@17/  K,NN,II3,KMOD,MAXGRD,MAXDEG =',6I8)
 140  CALL MESAGE (-37,SUB,SUB)
      RETURN
      END

      DOUBLE PRECISION FUNCTION DK100(I,A,B,M,N,X)
      DOUBLE PRECISION A, B, X, F100, CAPX, XX, AN1, AN2, AMN2F
      DOUBLE PRECISION  AN1P1, S, SF, AMN2SF, AM1F, AN1F
      DIMENSION  X(1)
      F100 = 0.0D0
      CAPX = A + B * X(I)
      XX = X(I)
      N1 = M + N - 2
      N2 = M - 1
      N3 = N1 + 1
      AN1 = N1
      AN2 = N2
      NFAC = N1
      ASSIGN 5 TO IRET
      GO TO 1000
    5 AMN2F = KFAC
      AN1P1 = AN1 + 1.0D0
      IS = 0
      S = 0.0D0
      SF = 1.0D0
      AMN2SF = AMN2F
      GO TO 50
   10 IS = IS + 1
      S = IS
      SF = SF * S
      AMN2SF = AMN2SF / (AN1P1 - S)
   50 CONTINUE
      N4 = N2 - IS
      IF (N4 .EQ. 0) GO TO 100
      F100 = F100 + AMN2F * (CAPX ** N4) *((-B)** IS) / (AMN2SF * SF
     1            * (AN2 - S) * (XX ** N4))
      GO TO 200
  100 CONTINUE
      NFAC = N2
      ASSIGN 110 TO IRET
      GO TO 1000
  110 AM1F = KFAC
      NFAC = N-1
      ASSIGN 120 TO IRET
      GO TO 1000
  120 AN1F = KFAC
      F100 = F100 + AMN2F *((-B)** N2) *DLOG(DABS(CAPX/XX))
     1            / (AM1F * AN1F)
  200 CONTINUE
      IF (IS .LT. N1) GO TO 10
      F100 =  -F100 / (A ** N3)
       DK100  = F100
      RETURN
 1000 KFAC = 1
      IF(NFAC.LT.2) GO TO 1020
      DO 1010 LFAC=2,NFAC
      KFAC=KFAC*LFAC
 1010 CONTINUE
 1020 GO TO IRET,(5,110,120)
      END

      SUBROUTINE DECODE (CODE,LIST,N)
C
C     DECODE DECODES THE BITS IN A WORD AND RETURNS A LIST OF INTEGERS
C     CORRESPONDING TO THE BIT POSITIONS WHICH ARE ON. NUMBERING
C     CONVENTION IS RIGHT (LOW ORDER) TO LEFT (HIGH ORDER) 00 THRU 31.
C
C     ARGUMENTS
C
C     CODE - INPUT  - THE WORD TO BE DECODED
C     LIST - OUTPUT - AN ARRAY OF DIMENSION .GE. 32 WHERE THE INTEGERS
C                     CORRESPONDING TO BIT POSITIONS ARE STORED
C     N    - OUTPUT - THE NUMBER OF ENTRIES IN THE LIST  I.E. THE NO.
C                     OF 1-BITS IN THE WORD
C
C
      EXTERNAL     ANDF
      INTEGER      CODE,ANDF,TWO,LIST(1)
      COMMON /TWO/ TWO(32)
C
      N = 0
      DO 8 I = 1,32
      IF (ANDF(TWO(33-I),CODE) .EQ. 0) GO TO 8
      N = N + 1
      LIST(N) = I - 1
    8 CONTINUE
C
      RETURN
      END

      SUBROUTINE MODACC
C
C     THIS IS THE MODULE MODACC
C
C     DMAP CALL
C
C     MODACC  CASECC,TOL,UDV1T,PPT,PDT,PST/TOL1,UDV3T,PP3,PDT3,PST3/
C             C,N,TRAN $
C
C     THE PURPOSE OF THIS MODULE IS TO REDUCE THE COLUMN LENCTHS OF
C     UDV1T,PPT,PDT,PST  TO THE  LENGTH SPECIFIED BY OFREQ IN CASECC.
C     THE CURRENT LIST OF TIMES IS ON  TOL
C
      INTEGER CASECC, TOL,UDV1T,PPT,PDT,PST,TOL1,UDV3T,PP3,PDT3,PST3
      COMMON /BLANK / IOP(2)
      COMMON /MODAC3/ NFO,NFN,NZ,ID
      COMMON /ZZZZZZ/ IZ(1)
      DATA    CASECC, TOL,UDV1T,PPT,PDT,PST,TOL1,UDV3T,PP3,PDT3,PST3 /
     1        101   , 102,103  ,104,105,106,201 ,202  ,203,204 ,205  /
      DATA    ITRAN / 4HTRAN/  ,ICEIGN /4HCEIG /
      DATA    IREIG / 4HREIG/
      DATA    ISTAT / 4HSTAT/
C
      ID = 1
      IF (IOP(1) .EQ. ICEIGN) ID = 2
      IF (IOP(1) .EQ.  ITRAN) ID = 3
      IF (IOP(1) .EQ.  IREIG) ID = 4
      IF (IOP(1) .EQ.  ISTAT) ID = 5
C
C     FOR EIGENVALUES STOP LIST AT NUMBER OF VECTORS
C
      NFO = 0
      IZ(1) = UDV1T
      CALL RDTRL(IZ)
      J   = 2
      NFO = 2 * IZ(J)
      NZ  = KORSZ(IZ(1))
C
C     BUILD LIST OF NEW TIMES, KEEP/REMOVE LIST
C
      CALL MODAC1 (CASECC,TOL,TOL1,PP3,PPT)
C
C     COPY DISPLACEMENTS
C
      ID1 = 1
      IF (ID .EQ. 3) ID1 = 3
      CALL MODAC2 (ID1,UDV1T,UDV3T)
      IF (ID.EQ.2 .OR. ID.EQ.4) RETURN
C
C     COPY P LOAD S  (+ HEAD STUFF FOR NOW)
C
      CALL MODAC2 (-1,PPT,PP3)
C
C     COPY D LOADS
C
      CALL MODAC2 (1,PDT,PDT3)
C
C     COPY S LOADS
C
      CALL MODAC2 (1,PST,PST3)
      RETURN
      END

      SUBROUTINE TA1B
C
C     TA1B BUILDS THE ELEMENT CONNECTION AND PROPERTIES TABLE (ECPT)
C     AND THE GRID POINT CONNECTION TABLE. THE ECPT CONTAINS ONE LOGICAL
C     RECORD FOR EACH GRID OR SCALAR POINT IN THE STRUCTURE.  EACH
C     LOGICAL RECORD CONTAINS EST TYPE DATA FOR ELEMENTS CONNECTED TO
C     THE GRID OR SCALAR POINT THE GPCT IS A SUMMARY OF THE ECPT.  EACH
C     LOGICAL RECORD CONTAINS ALL GRID POINTS CONNECTED TO THE PIVOT (BY
C     MEANS OF STRUCTURAL ELEMENTS).
C
      EXTERNAL        ANDF
      LOGICAL         EORFLG,ENDID ,RECORD
      INTEGER         ANDF  ,GENL  ,ECT   ,EPT   ,BGPDT ,SIL   ,GPTT  ,
     1                CSTM  ,EST   ,GEI   ,ECPT  ,GPCT  ,SCR1  ,SCR2  ,
     2                SCR3  ,SCR4  ,Z     ,SYSBUF,TEMPID,ELEM  ,ELEMID,
     3                OUTPT ,CBAR  ,PLOTEL,RD    ,RDREW ,WRT   ,WRTREW,
     4                CLSREW,CLS   ,BUF   ,GPSAV ,FLAG  ,BUF1  ,BUF2  ,
     5                BUF3  ,FILE  ,RET   ,RET1  ,OP    ,TWO24 ,SCRI  ,
     6                SCRO  ,BLK   ,RET2  ,OUFILE,GPECT ,ELTYPE,OLDEL ,
     7                OLDEID,BUF4  ,EQEXIN,ZEROS(4)     ,QUADTS,TRIATS,
     8                PLOT  ,REACT ,SHEAR ,TWIST ,BAR   ,PPSE
      DIMENSION       NAM(2),BLK(2),ZZ(1) ,TGRID(33)    ,BUF(50),
     1                BUFR(50)     ,GPSAV(34)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG / UFM   ,UWM   ,UIM   ,SFM
      COMMON /BLANK / LUSET ,NOSIMP,NOSUP ,NOGENL,GENL  ,COMPS
      COMMON /TA1COM/ NSIL  ,ECT   ,EPT   ,BGPDT ,SIL   ,GPTT  ,CSTM  ,
     1                MPT   ,EST   ,GEI   ,GPECT ,ECPT  ,GPCT  ,MPTX  ,
     2                PCOMPS,EPTX  ,SCR1  ,SCR2  ,SCR3  ,SCR4  ,EQEXIN
      COMMON /SYSTEM/ KSYSTM(65)
      COMMON /GPTA1 / NELEM ,JLAST ,INCR  ,ELEM(1)
      COMMON /NAMES / RD    ,RDREW ,WRT   ,WRTREW,CLSREW,CLS
      COMMON /TA1ETT/ ELTYPE,OLDEL ,EORFLG,ENDID ,BUFFLG,ITEMP ,IDFTMP,
     1                IBACK ,RECORD,OLDEID
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE     (KSYSTM( 1),SYSBUF) ,(KSYSTM(2),OUTPT ),
     1                (KSYSTM(10),TEMPID) ,(IDFTMP   ,DEFTMP)
      EQUIVALENCE     (BLK(1),NPVT), (BUF(1),BUFR(1)),(Z(1),ZZ(1)),
     1                (BLK(2),N)
      DATA    NAM   / 4HTA1B,3H   /,  CBAR/ 4HBAR  /, PLOT/ 4HPLOT    /
      DATA    TWO24 / 8388608     /, ZEROS/ 0,0,0,0/, PPSE/ 4303      /
      DATA    PLOTEL, REACT,SHEAR,TWIST,IHEX2,IHEX3,QUADTS,TRIATS,BAR /
     1        5201  , 5251, 4,    5,    66,   67,   68,    69,    34  /
C
C     PERFORM GENERAL INITIALIZATION
C
      N2   = 2*NELEM - 1
      N21  = N2 + 1
      BUF1 = KORSZ(Z) - SYSBUF - 2
      BUF2 = BUF1 - SYSBUF
      BUF3 = BUF2 - SYSBUF
      BUF4 = BUF3 - SYSBUF
      NEQ1 = NSIL + 1
      NEQ2 = 0
      KSCALR = 0
C
C     THE GRID POINT COUNTER (GPC) HAS ONE ENTRY PER GRID OR SCALAR
C     POINT IN THE STRUCTURE. EACH ENTRY CONTAINS THE NUMBER OF
C     STRUCTURAL ELEMENTS CONNECTED TO THE POINT.
C
      DO 2001 I = 1,NSIL
 2001 Z(I+1) = 0
C
C     OPEN THE ECT. INITIALIZE TO LOOP THRU BY ELEMENT TYPE.
C
      FILE = ECT
      CALL PRELOC (*3200,Z(BUF1),ECT)
      NOECT = 1
      DO 2026 I = 1,JLAST,INCR
C
C     IGNORE PLOTEL ELEMENTS.  OTHERWISE, LOCATE AN ELEMENT TYPE.
C     IF PRESENT, READ ALL ELEMENTS OF THAT TYPE AND INCREMENT THE GPC
C     ENTRY FOR EACH POINT TO WHICH THE ELEMENT IS CONNECTED.
C
      IF (ELEM(I) .EQ. PLOT) GO TO 2026
      CALL LOCATE (*2026,Z(BUF1),ELEM(I+3),FLAG)
      NOECT = 0
      LX = ELEM(I+12)
      MM = LX + ELEM(I+9) - 1
      M  = ELEM(I+5)
      IF (ELEM(I+10) .EQ. 0) KSCALR = 1
 2021 CALL READ (*3201,*2026,ECT,BUF,M,0,FLAG)
      DO 2022 L = LX,MM
      K  = BUF(L)
      IF (K .NE. 0) Z(K+1) = Z(K+1) + 1
 2022 CONTINUE
      GO TO 2021
 2026 CONTINUE
      CALL CLOSE (ECT,CLSREW)
      IF (NOECT .NE. 0) GO TO 3209
C
C     REPLACE ENTRIES IN THE GPC BY A RUNNING SUM THUS CREATING POINTERS
C     INTO ECPT0.  QUEUE WARNING MESSAGES FOR GRID PTS. WITH NO ELEMENTS
C     CONNECTED.
C     (BRING IN EQEXIN AND ECHO OUT EXTERNAL GRID PT. ID  G.C/UNISYS 91)
C
      Z(1)  = 1
      MAXEL = 0
      DO 2037 I = 1,NSIL
      MAXEL = MAX0(MAXEL,Z(I+1))
      IF (Z(I+1) .NE. 0) GO TO 2037
C
      J = 0
      IF (NEQ2) 2035,2031,2033
 2031 NEQ2 = -1
      Z(NEQ1) = EQEXIN
      CALL RDTRL (Z(NEQ1))
      IF (Z(NEQ1) .LE. 0) GO TO 2035
      FILE = EQEXIN
CWKBR CALL GOPEN (EQEXIN,EQEXIN,Z(BUF1),RDREW)
      CALL GOPEN (EQEXIN,Z(BUF1),RDREW)
      CALL READ (*3200,*2032,EQEXIN,Z(NEQ1),BUF4,1,NEQ2)
 2032 CALL CLOSE (EQEXIN,CLSREW)
      CALL SORT (0,0,2,2,Z(NEQ1),NEQ2)
 2033 J = Z((I-1)*2+NEQ1)
C
 2035 BUF(1) = I
      BUF(2) = J
      CALL MESAGE (30,15,BUF)
 2037 Z(I+1) = Z(I) + Z(I+1)
C
C     DETERMINE BAND OF ENTRIES IN ECPT0 WHICH WILL FIT IN CORE
C     NDX1 = POINTER IN GPC TO 1ST  ENTRY FOR CURRENT PASS.
C     NDX2 = POINTER IN GPC TO LAST ENTRY FOR CURRENT PASS.
C
      NDX1 = 1
      NDX2 = NSIL
      LLX  = 1
      IECPT0 = NSIL + 2
      LENGTH = BUF1 - IECPT0
      OP   = WRTREW
 2042 IF (Z(NDX2+1)-Z(NDX1)+2 .LE. LENGTH) GO TO 2050
      NDX2 = NDX2 - 1
      GO TO 2042
C
C     PASS THE ECT. FOR EACH GRID PT IN RANGE ON THIS PASS,
C     STORE ELEMENT POINTER = 2**24 * J + WORD POSITION IN ECT RECORD.
C     WHERE J= (POINTER IN ELEM TABLE - 1)/INCR * 2 +1
C
 2050 CALL PRELOC (*3200,Z(BUF1),ECT)
      IZERO = Z(NDX1)
      J = 1
      DO 2055 I = 1,JLAST,INCR
      IF (ELEM(I) .EQ. PLOT) GO TO 2055
      IDCNTR = TWO24*J
      CALL LOCATE (*2055,Z(BUF1),ELEM(I+3),FLAG)
      M  = ELEM(I+ 5)
      LX = ELEM(I+12)
      MM = LX + ELEM(I+9) - 1
 2052 CALL READ (*3201,*2055,ECT,BUF,M,0,FLAG)
      DO 2054 L = LX,MM
      K  = BUF(L)
      IF (K.LT.NDX1 .OR. K.GT.NDX2) GO TO 2054
      IX = Z(K) - IZERO + IECPT0
      Z(IX) = IDCNTR
      Z(K ) = Z(K) + 1
 2054 CONTINUE
      IDCNTR = IDCNTR + M
      GO TO 2052
 2055 J = J + 2
      CALL CLOSE (ECT,CLSREW)
C
C     WRITE ECPT0 AND TEST FOR ADDITIONAL PASSES
C     ECPT0 CONTAINS ONE LOGICAL RECORD FOR EACH GRID OR SCALAR POINT.
C     EACH LOGICAL RECORD CONTAINS N PAIRS OF(-1,ELEMENT POINTER)WHERE
C     N= NUMBER OF ELEMENTS CONNECTED TO THE PIVOT.
C     IF NO ELEMENTS CONNECTED TO POINT, RECORD IS ONE WORD = 0.
C
      FILE = SCR1
      CALL OPEN (*3200,SCR1,Z(BUF1),OP)
      BUF(1) = -1
      LJ = IECPT0 - 1
      DO 2062 I = NDX1,NDX2
      M  = Z(I) - LLX
      IF (M .NE. 0) GO TO 2063
      CALL WRITE (SCR1,0,1,1)
      GO TO 2062
 2063 DO 2061 J = 1,M
      LJ = LJ + 1
      BUF(2) = Z(LJ)
 2061 CALL WRITE (SCR1,BUF,2,0)
      CALL WRITE (SCR1,0,0,1)
 2062 LLX = Z(I)
      IF (NDX2 .GE. NSIL) GO TO 2070
      CALL CLOSE (SCR1,CLS)
      NDX1 = NDX2 + 1
      NDX2 = NSIL
      OP   = WRT
      GO TO 2042
C
C     READ AS MUCH OF ECT AS CORE CAN HOLD
C     FIRST N21 CELLS OF CORE CONTAIN A POINTER TABLE WHICH HAS TWO
C     ENTRIES PER ELEMENT TYPE. 1ST ENTRY HAS POINTER TO 1ST WORD OF
C     ECT DATA IN CORE FOR AN ELEMENT TYPE  2ND ENTRY HAS WORD POSITION
C     IN ECT RECORD OF THAT TYPE FOR LAST ENTRY READ ON PREVIOUS PASS.
C
 2070 CALL CLOSE (SCR1,CLSREW)
      SCRI = SCR1
      SCRO = SCR2
      CALL PRELOC (*3200,Z(BUF1),ECT)
      I = 1
      IELEM = 1
      DO 2071 J = 1,N21
 2071 Z(J) = 0
      L = N21 + 1
 2072 IF (ELEM(IELEM+3).EQ.PLOTEL .OR. ELEM(IELEM+3).EQ.REACT)
     1    GO TO 2074
      CALL LOCATE (*2074,Z(BUF1),ELEM(IELEM+3),FLAG)
      Z(I) = L
      LL   = 0
      M    = ELEM(IELEM+5)
      LAST = BUF3 - M
 2073 IF (L .GT. LAST) GO TO 2080
      CALL READ (*3201,*2074,ECT,Z(L),M,0,FLAG)
      L  = L  + M
      LL = LL + M
      GO TO 2073
 2074 I  = I + 2
      IELEM = IELEM + INCR
      IF (IELEM .LE. JLAST) GO TO 2072
C
C     PASS ECPT0 ENTRIES LINE BY LINE
C     ATTACH EACH REFERENCED ECT ENTRY WHICH IS NOW IN CORE
C
 2080 CALL OPEN (*3200,SCRI,Z(BUF2),RDREW)
      CALL OPEN (*3200,SCRO,Z(BUF3),WRTREW)
 2082 CALL READ (*2090,*2086,SCRI,BUF,1,0,FLAG)
      IF (BUF(1)) 2083,2087,2085
 2083 CALL READ (*3201,*3202,SCRI,BUF(2),1,0,FLAG)
      K = BUF(2)/TWO24
      KTWO24 = K*TWO24
      IDPTR  = BUF(2) - KTWO24
      KK = Z(K) + IDPTR - Z(K+1)
      IF (Z(K).EQ.0 .OR. KK.GT.LAST) GO TO 2084
      J  = ((K-1)/2)*INCR + 1
      MM = ELEM(J+5)
      BUF(1) = MM
      BUF(2) = Z(KK) + KTWO24
      CALL WRITE (SCRO,BUF,2,0)
      CALL WRITE (SCRO,Z(KK+1),MM-1,0)
      GO TO 2082
 2084 CALL WRITE (SCRO,BUF,2,0)
      GO TO 2082
 2085 CALL READ  (*3201,*3202,SCRI,BUF(2),BUF(1),0,FLAG)
      CALL WRITE (SCRO,BUF,BUF(1)+1,0)
      GO TO 2082
 2086 CALL WRITE (SCRO,0,0,1)
      GO TO 2082
 2087 CALL WRITE (SCRO,0,1,1)
      CALL FWDREC (*3201,SCRI)
      GO TO 2082
C
C     TEST FOR COMPLETION OF STEP
C     IF INCOMPLETE, SET FOR NEXT PASS
C
 2090 CALL CLOSE (SCRI,CLSREW)
      CALL CLOSE (SCRO,CLSREW)
      IF (I .GT. N2) GO TO 2100
      K    = SCRI
      SCRI = SCRO
      SCRO = K
      L = N21 + 1
      DO 2091 J = 1,N21
 2091 Z(J) = 0
      Z(I) = L
      Z(I+1) = LL
      GO TO 2073
C
C     READ THE EPT INTO CORE (IF PRESENT)
C     FIRST N21 CELLS OF CORE CONTAINS PROPERTIES POINTER TABLE WHICH
C     HAS TWO WORDS PER ELEMENT TYPE, 1ST WORD HAS POINTER TO 1ST WORD
C     OF PROPERTY DATA FOR THAT ELEMENT TYPE. 2ND WORD HAS NUMBER OF
C     PROPERTY CARDS FOR THAT TYPE.
C
 2100 CALL CLOSE (ECT,CLSREW)
      DO 2101 I = 1,N21
 2101 Z(I) = 0
      L = 1
      CALL PRELOC (*2120,Z(BUF1),EPT)
      IELEM  = 1
      LSTPRP = 0
      L = N21 + 1
      DO 2107 II = 1,N2,2
      IF (ELEM(IELEM+6).EQ.LSTPRP .AND. LSTPRP.NE.PPSE) GO TO 2106
      CALL LOCATE (*2107,Z(BUF1),ELEM(IELEM+6),FLAG)
      LSTPRP = ELEM(IELEM+6)
      M      = ELEM(IELEM+8)
      ELTYPE = ELEM(IELEM+2)
      Z(II)  = L
 2102 IF (L+M .GE. BUF3) CALL MESAGE (-8,0,NAM)
      CALL READ (*3201,*2103,EPT,Z(L),M,0,FLAG)
      L = L + M
      GO TO 2102
 2103 N = L - Z(II)
      Z(II+1) = N/M
      IF (ELTYPE.EQ.SHEAR .OR. ELTYPE.EQ.TWIST) GO TO 2104
      IF (M .GT. 4) GO TO 2107
 2104 I = Z(II)
      CALL SORT (0,0,M,1,Z(I),N)
      GO TO 2107
 2106 N = 4
      IF (ELTYPE.EQ.IHEX2 .OR. ELTYPE.EQ.IHEX3) N = 2
      Z(II  ) = Z(II-N  )
      Z(II+1) = Z(II-N+1)
 2107 IELEM   = IELEM + INCR
      CALL CLOSE (EPT,CLSREW)
C
C     DETERMINE IF THE BGPDT AND SIL
C     WILL FIT IN CORE ON TOP OF THE EPT.
C
      NUMBER = 4*KSCALR + 1
      IBACK  = 0
      LENGTH = BUF4 - L - 4*MAXEL
      IF (NUMBER*NSIL .GT. LENGTH) GO TO 2150
C
C     IF YES, READ THE BGPDT,SIL AND GPTT INTO CORE
C
 2120 ASSIGN 2130 TO RET
      IPASS = 1
      GO TO 3050
C
C     PASS ECPT0 LINE BY LINE
C     FOR EACH ECT ENTRY, 1. ATTACH PROPERTY DATA (IF DEFINED)
C     2. ATTACH BASIC GRID POINT DATA (UNLESS SCALER ELEMENT), AND
C     3. CONVERT GRID PT NOS TO SIL VALUES
C     4. IF TEMPERATURE PROBLEM, ATTACH ELEMENT TEMP(UNLESS SCALAR ELEM)
C
 2130 INFILE = SCRO
      OUFILE = ECPT
C
C     OPEN ECPT0, ECPT AND GPCT FILES
C
 2144 GO TO 3060
C
C     WRITE PIVOT GRID POINT ON ECPT
C
 2131 IF (LL-LOCSIL .GE. NSIL) GO TO 2179
      IF (IBACK .LE. 0) GO TO 21311
      CALL BCKREC (GPTT)
C
C     RESET /TA1ETT/ VARIABLES
C
      IBACK  = 0
      OLDEID = 0
      OLDEL  = 0
      EORFLG =.FALSE.
      ENDID  =.TRUE.
      CALL READ (*3201,*3202,GPTT,ISET,1,0,FLAG)
      IF (ISET .EQ. TEMPID) GO TO 21311
      WRITE (OUTPT,3084) SFM,ISET,TEMPID
      CALL MESAGE (-61,0,0)
21311 NPVT = Z(LL)
      CALL WRITE (ECPT,NPVT,1,0)
      IF (Z(LL+1)-Z(LL) .EQ. 1) NPVT = -NPVT
      I = LOCGPC
C
C     READ AN ECT LINE FROM ECPT0. SET POINTERS AS A FUNCTION OF ELEM
C     TYPE.  IF ELEMENT IS BAR, PROCESS ORIENTATION VECTOR.  AXIS AND
C     THE STRESS AXIS DEFINITION BASED ON GRID POINTS MA AND SA.
C
 2132 CALL READ (*3201,*2138,INFILE,BUF(1),1,0,FLAG)
      IF (BUF(1)) 3207,2143,2133
 2133 CALL READ (*3201,*3202,INFILE,BUF(2),BUF(1),0,FLAG)
      IK = BUF(2)/TWO24
      II = ((IK-1)/2)*INCR + 1
      LX = ELEM(II+12) + 1
      M  = ELEM(II+ 8)
      JSCALR =  ELEM(II+10)
      MM = LX + ELEM(II+ 9) - 1
      LQ = 4
      IF (M .EQ. 0) LQ = 3
      NAME  = ELEM(II   )
      JTEMP = ELEM(II+13)
      ELTYPE= ELEM(II+ 2)
      NTEMP = 1
      IF (JTEMP .EQ. 4) NTEMP = ELEM(II+14) - 1
      IF (ELTYPE .EQ. QUADTS) GO TO 3083
      IF (ELTYPE .EQ. TRIATS) GO TO 30841
      IF (NAME   .EQ.   CBAR) GO TO 3080
C
C     SAVE INTERNAL GRID NOS AND CONVERT TO SIL NOS.
C
 2141 GO TO 3030
C
C     IF ONE   PASS, WRITE ECT       SECTION  OF ECPT LINE.
C     IF TWO PASSES, WRITE ECT + EPT SECTIONS OF ECPT LINE.
C
 2134 ID = BUF(3)
      NX = BUF(1) + 2 - LQ
      BUF(1) = ELEM(II+2)
      BUF(2) = BUF(2) - IK*TWO24
      ELEMID = BUF(2)
      CALL WRITE (ECPT,BUF(1),2,0)
      CALL WRITE (ECPT,BUF(LQ),NX,0)
      IF (IPASS .EQ. 2) GO TO 2137
C
C     IF PROPERTY DATA IS DEFINED, LOOK UP AND WRITE EPT SECTION OF ECPT
C
      IF (M .EQ. 0) GO TO 2137
      ASSIGN 2137 TO RET
      GO TO 3040
C
C     IF ELEMENT IS NOT A SCALAR ELEMENT,
C     WRITE BGPDT AND ELEMENT TEMPERATURE SECTIONS OF ECPT LINE.
C
 2137 IF (JSCALR .NE. 0) GO TO 2132
      GO TO 3090
C
C     CLOSE ECPT RECORD. WRITE GPCT RECORD.
C
 2138 CALL WRITE (ECPT,0,0,1)
      GO TO 3070
C
C     HERE IF NO ELEMENTS CONNECTED TO PIVOT.
C
 2143 CALL WRITE (ECPT,0,0,1)
      IF (NOGPCT .NE. 0) CALL WRITE (GPCT,NPVT,1,1)
      LL = LL + 1
      CALL FWDREC (*3202,INFILE)
      GO TO 2131
C
C     HERE IF ECPT CONSTRUCTION IS TWO PASSES.
C     PASS ECPT0 LINE BY LINE FOR EACH ECT ENTRY, ATTACH PROPERTY DATA
C     IF DEFINED
C
 2150 CALL OPEN (*3200,SCRO,Z(BUF1),RDREW)
      CALL OPEN (*3200,SCRI,Z(BUF2),WRTREW)
      OUFILE = SCRI
C
C     READ AN ECT LINE FROM ECT0. SET POINTERS AS FUNCTION OF ELEM TYPE.
C
 2152 CALL READ (*2159,*2156,SCRO,BUF,1,0,FLAG)
      IF (BUF(1)) 3207,2158,2153
 2153 CALL READ (*3201,*3203,SCRO,BUF(2),BUF(1),0,FLAG)
      IK = BUF(2)/TWO24
      II = ((IK-1)/2)*INCR + 1
      M  = ELEM(II+8)
      NX = BUF(1) + 1
C
C     IF PROPERTY DATA IS DEFINED FOR ELEMENT, WRITE ECT DATA ON SCRI,
C     THEN LOOK UP AND WRITE EPT DATA ON SCRI.
C
      IF (M .EQ. 0) GO TO 2155
      ID = BUF(3)
      BUF(1) = BUF(1) + M - 1
      CALL WRITE (SCRI,BUF(1),NX,0)
      ASSIGN 2152 TO RET
      GO TO 3040
C
C     PROPERTY DATA NOT DEFINED. WRITE ECT LINE ON SCRI.
C
 2155 CALL WRITE (SCRI,BUF,NX,0)
      GO TO 2152
C
C     CLOSE RECORD. RETURN FOR ANOTHER PIVOT.
C
 2156 CALL WRITE (SCRI,0,0,1)
      GO TO 2152
C
C     ALL PIVOTS COMPLETE. CLOSE FILES.
C
 2159 CALL CLOSE (SCRO,CLSREW)
      CALL CLOSE (SCRI,CLSREW)
      GO TO 2160
C
C     HERE IF NO ELEMENTS CONNECTED TO PIVOT.
C
 2158 CALL WRITE  (SCRI,0,1,1)
      CALL FWDREC (*3201,SCRO)
      GO TO 2152
C
C     READ THE BGPDT, SIL AND, IF TEMPERATURE PROBLEM,
C     THE GPTT INTO CORE.
C
 2160 L = 1
      ASSIGN 2170 TO RET
      GO TO 3050
C
C     SET POINTERS AND BRANCH TO COMMON CODE TO ASSEMBLE ECPT.
C
 2170 INFILE = SCRI
      OUFILE = ECPT
      IPASS  = 2
      GO TO 2144
C
C     CLOSE FILES, WRITE TRAILERS AND EXIT.
C
 2179 CALL CLOSE (INFILE,CLSREW)
      CALL CLOSE (GPTT,CLSREW)
      CALL CLOSE (ECPT,CLSREW)
      BUF(1) = ECT
      CALL RDTRL (BUF(1))
      BUF(3) = 0
      K  = 8192
      K1 = ANDF(BUF(5),K)
      IF (K1 .NE. K) GO TO 2180
      BUF(3) = 1
      IRIGD  = 1
 2180 CONTINUE
      BUF(1) = ECPT
      DO 21791 I = 2,7
      BUF(I) = 7
21791 CONTINUE
      CALL WRTTRL (BUF)
      IF (NOGPCT .EQ. 0) RETURN
      CALL CLOSE (GPCT,CLSREW)
      BUF(1) = GPCT
      CALL WRTTRL (BUF)
      RETURN
C
C
C     INTERNAL BINARY SEARCH ROUTINE
C
 3000 KLO = 1
 3001 K   = (KLO+KHI+1)/2
 3008 KX  = (K-1)*M + LOCX
      IF (ID-Z(KX)) 3002,3009,3003
 3002 KHI = K
      GO TO 3004
 3003 KLO = K
 3004 IF (KHI-KLO-1) 30091,3005,3001
 3005 IF (K .EQ. KLO) GO TO 3006
      K   = KLO
      GO TO 3007
 3006 K   = KHI
 3007 KLO = KHI
      GO TO 3008
 3009 GO TO RET1, (3041)
30091 GO TO RET2, (3205)
C
C
C     INTERNAL ROUTINE TO SAVE GRID PTS IN AN ECT LINE
C     AND CONVERT GRID PT NOS IN ECT LINE TO SIL VALUES
C
 3030 DO 3032 L = LX,MM
      GPSAV(L) = 0
      IF (BUF(L) .EQ. 0) GO TO 3032
      GPSAV(L) = BUF(L)
      K  = GPSAV(L) + LOCSIL - 1
      BUF(L) = Z(K)
      IX = 0
      IF (Z(K+1)-Z(K) .EQ. 1) IX = 1
      Z(I) = 2*Z(K) + IX
      I  = I + 1
 3032 CONTINUE
      IF (I .GE. BUF3) CALL MESAGE (-8,0,NAM)
      GO TO 2134
C
C
C     INTERNAL ROUTINE TO ATTACH EPT DATA
C
 3040 LOCX = Z(IK)
      IF (LOCX .EQ. 0) GO TO 3206
      KHI  = Z(IK+1)
      ASSIGN 3041 TO RET1
      ASSIGN 3205 TO RET2
      GO TO 3000
 3041 CALL WRITE (OUFILE,Z(KX+1),M-1,0)
      GO TO RET, (2137,2152)
C
C     INTERNAL ROUTINE TO READ THE BGPDT, SIL AND GPTT INTO CORE
C
 3050 NBGP   = 0
      LOCBGP = L
      IF (KSCALR .EQ. 0) GO TO 3059
      CALL OPEN (*3200,BGPDT,Z(BUF1),RDREW)
      CALL FWDREC (*3201,BGPDT)
      NBGP  = 4*NSIL
      CALL READ (*3201,*3202,BGPDT,Z(LOCBGP),NBGP,1,FLAG)
      CALL CLOSE (BGPDT,CLSREW)
 3059 L = L + NBGP
      CALL OPEN (*3200,SIL,Z(BUF1),RDREW)
      CALL FWDREC (*3201,SIL)
      LOCSIL = LOCBGP + NBGP
      CALL READ (*3201,*3203,SIL,Z(LOCSIL),NSIL,1,FLAG)
      CALL CLOSE (SIL,CLSREW)
      NX = LOCSIL + NSIL
      Z(NX)  = LUSET + 1
      LOCTMP = NX + 1
      NTMP   = LOCTMP - 1
      RECORD =.FALSE.
      ITEMP  = TEMPID
      IBACK  = 0
      IF (TEMPID .EQ. 0) GO TO 3058
      FILE   = GPTT
      CALL OPEN (*3200,GPTT,Z(BUF4),RDREW)
      CALL READ (*3201,*3051,GPTT,Z(LOCTMP),BUF3-LOCTMP,0,NID)
      CALL MESAGE (-8,0,NAM)
 3051 ITMPID = LOCTMP + 2
      NTMPID = LOCTMP + NID - 3
      DO 3052 IJK = ITMPID,NTMPID,3
      IF (TEMPID .EQ. Z(IJK)) GO TO 3053
 3052 CONTINUE
      GO TO 3210
 3053 IDFTMP = Z(IJK+1)
      IF (IDFTMP . NE. -1) DEFTMP = ZZ(IJK+1)
      N = Z(IJK+2)
      IF (N .EQ. 0) GO TO 3058
      RECORD =.TRUE.
      N = N - 1
      IF (N .EQ. 0) GO TO 3055
      DO 3054 IJK = 1,N
      CALL FWDREC (*3201,GPTT)
 3054 CONTINUE
C
C     READ SET ID AND VERIFY FOR CORRECTNESS
C
 3055 CALL READ (*3201,*3202,GPTT,ISET,1,0,FLAG)
      IF (ISET .EQ. TEMPID) GO TO 3061
      WRITE  (OUTPT,3084) SFM,ISET,TEMPID
 3084 FORMAT (A25,' 4021, TA1B HAS PICKED UP TEMPERATURE SET',I9,
     1       ' AND NOT THE REQUESTED SET',I9,1H.)
      CALL MESAGE (-61,0,NAM)
C
C     INITIALIZE /TA1ETT/ VARIABLES
C
 3061 OLDEID = 0
      OLDEL  = 0
      EORFLG =.FALSE.
      ENDID  =.TRUE.
 3058 GO TO RET, (2130,2170)
C
C
C     INTERNAL ROUTINE TO OPEN SCRATCH, ECPT AND GPCT FILES
C
 3060 CALL OPEN (*3200,INFILE,Z(BUF1),RDREW)
      CALL OPEN (*3200,ECPT,Z(BUF2),WRTREW)
      CALL FNAME (ECPT,BUF)
      CALL WRITE (ECPT,BUF,2,1)
      NOGPCT = 0
      CALL OPEN (*3062,GPCT,Z(BUF3),WRTREW)
      NOGPCT = 1
      CALL FNAME (GPCT,BUF)
      CALL WRITE (GPCT,BUF,2,1)
 3062 LL = LOCSIL
      LOCGPC = NTMP + 1
      GO TO 2131
C
C     INTERNAL ROUTINE TO SORT AND WRITE THE GPCT
C
 3070 IF (NOGPCT .EQ. 0) GO TO 3073
      N = I - LOCGPC
      CALL SORT (0,0,1,1,Z(LOCGPC),N)
      Z(I) = 0
      J  = LOCGPC
      II = LOCGPC
 3071 IF (Z(II) .EQ. Z(II+1)) GO TO 3072
      NX = Z(II)/2
      LX = Z(II) - 2*NX
      IF (LX .NE. 0) NX = -NX
      Z(J) = NX
      J  = J  + 1
 3072 II = II + 1
      IF (II .LT. I) GO TO 3071
      N  = J - LOCGPC
      CALL WRITE (GPCT,BLK,2,0)
      CALL WRITE (GPCT,Z(LOCGPC),N,1)
 3073 LL = LL + 1
      GO TO 2131
C
C     FOR BAR ELEMENTS, STORE COORDINATES AND
C     COORDINATE SYSTEM ID FOR ORIENTATION VECTOR.
C
 3080 KX = 4*(BUF(4)-1) + LOCBGP
      IF (BUF(9) .EQ. 1) GO TO 3082
      BUF(9) = BUF(6)
      IF (BUF(9) .EQ. 0) GO TO 3082
      K = 4*(BUF(9)-1) + LOCBGP
      BUFR(6) = ZZ(K+1) - ZZ(KX+1)
      BUFR(7) = ZZ(K+2) - ZZ(KX+2)
      BUFR(8) = ZZ(K+3) - ZZ(KX+3)
      BUF(9)  = 0
      GO TO 2141
 3082 BUF(9)  = Z(KX)
      GO TO 2141
C
C     FOR QUADTS AND TRIATS ELEMENTS, STORE COORDINATES FOR MATERIAL
C     AND STRESS AXIS DEFINITION
C
 3083 IS1 = 12
      GO TO 3085
30841 IS1 = 10
 3085 IS2 = IS1 + 9
      DO 3086 IST = IS1,IS2,3
      IGP = BUF(IST)
      IF (IGP .EQ. 0) GO TO 3086
      K = 4*(IGP-1) + LOCBGP
      BUFR(IST  ) = ZZ(K+1)
      BUFR(IST+1) = ZZ(K+2)
      BUFR(IST+2) = ZZ(K+3)
 3086 CONTINUE
      GO TO 2141
C
C     CODE TO WRITE BGPDT AND ELEMENT TEMPERATURE SECTIONS OF ECAT LINE.
C
 3090 DO 3095 L = LX,MM
      IF (GPSAV(L) .EQ. 0) GO TO 3094
      K = LOCBGP + 4*(GPSAV(L)-1)
      CALL WRITE (ECPT,Z(K),4,0)
      GO TO 3095
 3094 CALL WRITE (ECPT,ZEROS,4,0)
 3095 CONTINUE
      CALL TA1ETD (ELEMID,TGRID,NTEMP)
      IF (ELTYPE .EQ. BAR) TGRID(1) = (TGRID(1)+TGRID(2))/2.0
      CALL WRITE (ECPT,TGRID,NTEMP,0)
      GO TO 2132
C
C     FATAL ERROR MESAGES
C
 3200 J = -1
      GO TO 3220
 3201 J = -2
      GO TO 3220
 3203 CONTINUE
 3202 J = -3
      GO TO 3220
 3205 BUF(1) = ELEMID
      BUF(2) = ID
      N = 10
      GO TO 3219
 3206 BUF(1) = ELEM(II  )
      BUF(2) = ELEM(II+1)
      N = 11
      GO TO 3219
 3207 BUF(1) = 0
      BUF(2) = 0
      N = 14
      GO TO 3219
 3209 BUF(1) = 0
      BUF(2) = 0
      N = 13
      GO TO 3219
 3210 BUF(1) = TEMPID
      BUF(2) = 0
      N = 44
 3219 CALL MESAGE (-30,N,BUF)
 3220 CALL MESAGE (J,FILE,NAM)
      RETURN
      END

      SUBROUTINE MMARC1 ( ZI, ZR )
C  MMARC1 - This routine will store a matrix column in memory in compact
C           form and in real single precision.  The input matrix is 
C           assumed to be stored as real single precision.
C           The column is stored in memory according to the following scheme:
C
C
C  1st word = row position of first element in following string 
C  2nd word = number of terms in string (ntms)
C  3rd word           }
C     |               }
C     |               } = actual
C     |               }   matrix
C     |               }   string
C     |               }   data
C     |               }
C     |               }
C  3+(ntms*prec)      } (where prec=1 for s.p.;  =2 for d.p. )
C
C  The above data repeats for all strings within a column
C
C  Argument list :
C     ZI  - Memory for storage of data (integer)
C     ZR  - Same location as ZI but real single reference 
C
      REAL             ZR(1)
      INTEGER          ZI(1)
      INTEGER          IBLK(15) 
      INCLUDE          'MMACOM.COM'         
      COMMON  /ZZZZZZ/ RXL(1)
      MEM       = 1
      DO 10 I   = 1,15
10    IBLK(I)   = 0
      IBLK(1)   = IRFILE
      IBLK(8)   = -1
      LASIND    = MEM - 1        
      ZI( MEM ) = 0
100   CALL GETSTR ( *7000, IBLK )
      JROW      = IBLK( 4 )   
      INDEX     = IBLK( 5 )
      NTMS      = IBLK( 6 )
      ZI(MEM)   = JROW
      ZI(MEM+1) = NTMS
      MEM       = MEM + 1
      DO 200 II = 1,NTMS
      ZR(MEM+II)= SIGN*RXL(INDEX+II-1)
  200 CONTINUE
      MEM       = MEM + 1 + NTMS  
      CALL ENDGET ( IBLK )
      GO TO 100
 7000 CONTINUE  
      LASIND    = MEM - 1        
      RETURN        
      END

      SUBROUTINE SDCOUT (BLOCK,IRW,AC,N,VECS,VECD)
C
C     SDCOUT WRITES A ROW OF A MATRIX IN STRING FORMAT USING
C     PUTSTR/ENDPUT.
C
C     BLOCK = A 15-WORD ARRAY IN WHICH BLOCK(1),(2),(3) HAVE ALREADY
C             BEEN COMPLETED WITH GINO NAME, TYPE AND FORMAT
C     IRW   = ZERO -- ROW NBR OF VECTOR = AC(1)
C           = N.Z. -- ROW NBR OF VECTOR IS IRW
C     AC    = A VECTOR OF N COLUMN POSITIONS (COL NBRS MAY BE .LT. 0)
C     N     = NUMBER OF WORDS IN AC AND NUMBER OF TERMS IN VECS
C     VECS  = A VECTOR OF N TERMS. THE POS OF EACH TERM IS DEFINED
C             BY THE NUMBER STORED IN THE CORRESPONDING POSITION IN AC
C     VECD  = SAME VECTOR AS VECS
C
      INTEGER          AC(1)    ,PRC      ,WORDS    ,RLCMPX   ,TYPE   ,
     1                 RC       ,PREC     ,BLOCK(15)
      REAL             VECS(1)  ,XNS(1)
      DOUBLE PRECISION XND      ,VECD(1)
      COMMON /TYPE  /  PRC(2)   ,WORDS(4) ,RLCMPX(4)
      COMMON /ZZZZZZ/  XND(1)
      EQUIVALENCE      (XND(1),XNS(1))
C
      BLOCK(8)  = -1
      BLOCK(12) = IRW
      IF (IRW .EQ. 0) BLOCK(12) = IABS(AC(1))
      II   = 0
      TYPE = BLOCK(2)
      RC   = RLCMPX(TYPE)
      PREC = PRC(TYPE)
      I    = 1
C
C     DETERMINE LENGTH OF A STRING BY SCANNING AC
C
   10 BLOCK(4) = IABS(AC(I))
      J = BLOCK(4) - I
      K = I + 1
   12 IF (K .GT. N) GO TO 14
      IF (IABS(AC(K)) .NE. J+K) GO TO 14
      K = K + 1
      GO TO 12
   14 NBRSTR = K - I
C
C     WRITE STRING WITH PUTSTR/ENDPUT
C
   15 CALL PUTSTR (BLOCK)
      BLOCK(7) = MIN0(BLOCK(6),NBRSTR)
      JSTR = BLOCK(5)
      NSTR = JSTR + RC*BLOCK(7) - 1
      IF (PREC .EQ. 2) GO TO 18
C
      DO 16 JJ = JSTR,NSTR
      II = II + 1
      XNS(JJ) = VECS(II)
   16 CONTINUE
      GO TO 22
C
   18 DO 20 JJ = JSTR,NSTR
      II = II + 1
      XND(JJ) = VECD(II)
   20 CONTINUE
C
C     TEST FOR COMPLETION
C
   22 I = I + BLOCK(7)
      IF (I .GT. N) GO TO 30
      CALL ENDPUT (BLOCK)
      IF (NBRSTR .EQ. BLOCK(7)) GO TO 10
      NBRSTR   = NBRSTR - BLOCK(7)
      BLOCK(4) = IABS( AC(I) )
      GO TO 15
C
C     END LAST STRING
C
   30 BLOCK(8) = 1
      CALL ENDPUT (BLOCK)
      RETURN
      END

      SUBROUTINE DBMRLB ( INDEX )
C********************************************************************
C  DBMRLB  -   RELEASES AN IN-MEMORY BLOCK THAT IS CURRENTLY
C              ALLOCATED AS THE LAST BLOCK OF AN IN-MEMORY FILE.
C              THIS IS USED TO RELEASE THE NEXT ALLOCATED BLOCK FOR A
C              FILE OPENED FOR WRITE BUT WAS NEVER USED BECAUSE THE
C              FILE WAS CLOSED--I.E., THE LAST BLOCK ALLOCATED FOR A
C              FILE OPENED FOR WRITE IS NEVER USED BUT IT MUST HAVE
C              BEEN ALLOCATED JUST IN CASE THE FILE IS NOT TO BE CLOSED.
C********************************************************************
      INCLUDE   'DSIOF.COM'
      COMMON / ZZZZZZ / MEM(4)
      COMMON / SYSTEM / ISYSBF, IWR
      INDEXL = INDEX
C CHECK IF OTHER BLOCKS ARE CHAINED TO THE END OF THIS BLOCK
      IF ( MEM( INDEX+1 ) .NE. 0 ) GO TO 100
C SET "NEXT" OF PREVIOUS BLOCK TO ZERO, IF IT EXISTS
5     LINDEX = MEM( INDEX )
      IF ( LINDEX .EQ. 0 ) GO TO 10
      MEM( LINDEX+1 ) = 0
10    IF ( IDBFRE .NE. 0 ) GO TO 20
C FREE CHAIN IS EMPTY, THIS BLOCK BECOMES FREE CHAIN
      IDBFRE = INDEX
C SET "NEXT" AND "PREVIOUS" OF THIS CHAIN TO ZERO
      MEM( INDEX    ) = 0
      MEM( INDEXL+1 ) = 0
      GO TO 700
C SET BLOCKS TO BE FREED AT FIRST OF FREE CHAIN AND
C THEN CONNECT FREE CHAIN TO THIS BLOCK
20    ISAVE  = IDBFRE
      IDBFRE = INDEX
      MEM( ISAVE    ) = INDEXL
      MEM( INDEX    ) = 0
      MEM( INDEXL+1 ) = ISAVE
      GO TO 700
C MORE THAN ONE BLOCK IN THIS CHAIN TO RELEASE BACK TO FREE CHAIN
100   CONTINUE
110   IF ( MEM( INDEXL+1 ) .EQ. 0 ) GO TO 5
CWKBR SPR94012 10/94      INDEXL = MEM( INDEX+1 )
      INDEXL = MEM( INDEXL+1 )
      GO TO 110
700   CONTINUE
      RETURN
      END

        SUBROUTINE DSRDPB
      INCLUDE 'DSIOF.COM'
      INCLUDE 'XNSTRN.COM'
        NBLOCK = NBLOCK - 1
        CALL DBMMGR( 6 )
        INDCLR = IBASE( INDBAS+4 ) + INDBAS - 1
        INDCBP = INDCLR
        IBLK   = IBASE( INDBAS+3 )
        IF ( IBLK .EQ. NBLOCK ) GO TO 10
        CALL DSMSG( 102 )
10      RETURN
        END

      SUBROUTINE FILSWI (NAME1,NAME2)
C
C     FILSWI SWITCHES THE UNITS ASSIGNED TO THE SPECIFIED DATA BLOCKS.
C
      EXTERNAL        COMPLF,ANDF,ORF
      INTEGER         FIST,FIAT,COMPLF,SYS,ANDF,UNIT1,UNIT2,ORF,UNIT
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG / UFM,UWM,UIM,SFM
      COMMON /XFIST / NFIST,LFIST,FIST(1)
     1       /XFIAT / FIAT(4)
     2       /SYSTEM/ SYS,NOUT,SKIP(21),ICFIAT
      DATA    MASK1 / 32767/
C                     '7FFF'X
C
C     SEARCH FIST FOR POINTERS TO FIAT.
C
      IF (NAME1 .EQ. NAME2) RETURN
      K1 = 0
      K2 = 0
      N  = 2*LFIST - 1
      DO 8 I = 1,N,2
      IF (FIST(I) .EQ. NAME1) K1 = FIST(I+1)
      IF (FIST(I) .EQ. NAME2) K2 = FIST(I+1)
    8 CONTINUE
      IF (K1.GT.0 .AND. K2.GT.0) GO TO 10
      WRITE  (NOUT,9) SFM
    9 FORMAT (A23,' 2178, GINO REFERENCE NAMES, IMPROPER FOR ',
     1       'SUBROUTINE FILSWI.')
      CALL MESAGE (-61,0,0)
C
C     SWITCH UNIT REFERENCE NUMBERS IN FIAT.
C
   10 MASK2 = COMPLF(MASK1)
      UNIT1 = ANDF(FIAT(K1+1),MASK1)
      UNIT2 = ANDF(FIAT(K2+1),MASK1)
      N     = ICFIAT*FIAT(3) - 2
      DO 12 I = 4,N,ICFIAT
      UNIT  = ANDF(FIAT(I),MASK1)
      IF (UNIT .EQ. UNIT1) FIAT(I) = ORF(ANDF(FIAT(I),MASK2),UNIT2)
      IF (UNIT .EQ. UNIT2) FIAT(I) = ORF(ANDF(FIAT(I),MASK2),UNIT1)
   12 CONTINUE
      RETURN
      END

      SUBROUTINE PARAML
C
C     TO SELECT PARAMETERS FROM A GINO DATA BLOCK
C
C     PARAML  DB/ /C,N,OP/V,N,P1/V,N,P2/V,N,RSP/V,N,INTEG/V,N,RDP/
C                  V,N,BCD/V,N,SPLX/V,N,DPLX $
C
C     INPUT GINO FILE -
C       DB = TABLE  INPUT FILE IF OP='TABLEi'
C       DB = MATRIX INPUT FILE IF OP='MATRIX','NULL', etc.
C     OUTPUT GINO FILE -
C       NONE
C     INPUT PARAMETER -
C       OP    = OPERATION FLAG, ONE OF THE FOLLOWING KEY WORDS,
C               'MATRIX', 'NULL', 'PRESENCE', 'TRAILER', OR
C               'TABLE1' - ABSTRACT FROM 1 INPUT WORD TO FORM ALL OUTPUT
C                          DATA TYPE (INTEGER, S.P /D.P. REAL S.P./D.P.
C                          COMPLEX) AND 4-BYTE BCD WORD (1 WORD)
C               'TABLE2' - ABSTRACT FROM 2 INPUT WORDS TO FORM ALL
C                          OUTPUT DATA TYPE, AND 8-BYTE BCD (2 WORDS)
C               'TABLE4' - ABSTRACT FORM 4 INPUT WORDS TO FORM S.P./D.P.
C                          COMPLEX NUMBER
C               'TABLE1/2/4' OPERATES ONLY IN TABLE  DATA BLOCK, AND
C                THE OTHERS  OPERATE  ONLY IN MATRIX DATA BLOCK.
C
C                IF 'PRESENCE' IS ABBREVIATED AS 'PRES  ', THE USER
C                PARAML INFORMATION MESSAGE IS NOT ECHOED OUT.
C
C     INPUT/OUTPUT PARAMETERS -
C       P1    = RECORD NO. IF DB IS A TABLE, OR
C       P1    = ROW NO. IF DB IS A MATRIX
C               (DEFAULT=1)
C       P2    = WORD POSITION INDEX (BASED ON S.P.REAL WORD COUNT)
C               IF DB IS A TABLE, OR
C       P2    = COLUMN NUMBER, IF DB IS A MATRIX DATA BLOCK, S.P. OR
C               D.P.
C               (DEFAULT=1)
C       (ROW FIRST AND COLUMN SECOND - IN CONSISTANT WITH SCALAR MODULE)
C     OUTPUT PARAMETERS -
C       RSP   = SINGLE PRECISION REAL
C               (DATA ABSTRACTED FROM 1 OR 2 INPUT WORDS)
C       INTEG = INTEGER (DATA ABSTRACTED FROM 1 INPUT WORD)
C       RDP   = DOUBLE PREC. FLOATING NUMBERS (FROM 1 OR 2 INPUT WORDS)
C       BCD   = 8-BYTE BCD WORD, BLANK FILLED IF NECCESSARY
C       SPLX  = SINGLE PRECISION COMPLEX (FROM 1 TO 4 INPUT WORDS)
C       DPLX  = DOUBLE PRECISION COMPLEX (FROM 1 TO 4 INPUT WORDS)
C
      IMPLICIT INTEGER (A-Z)
      LOGICAL          TB1,TB2,TB4,MAT,PRT
      INTEGER          MCB(7),NAME(2),IVPS(1),OPCD(7),FNM(2),
     1                 NMVPS(2),EI(3),AT(2)
      REAL             Z(1),RSP,SPLX,SP(4),VPS,X,Y
      DOUBLE PRECISION DZ(1),RDP,DPLX,DP(2)
      CHARACTER*7      NTY(4)
      CHARACTER*10     TYPE(4)
      CHARACTER        UFM*23,UWM*25,UIM*29
      COMMON /XMSSG /  UFM,UWM,UIM
      COMMON /XVPS  /  VPS(2)
      COMMON /UNPAKX/  ITYP,II,JJ,INCR
      COMMON /ILOCAL/  IL(2),IL3,IL4,IL5,IL6,IL7,IL8,IL9
      COMMON /SYSTEM/  SYSBUF,NOUT
      COMMON /BLANK /  OP(2),P1,P2,RSP,INTEG,RDP,BCD(2),SPLX(2),DPLX(2)
      COMMON /ZZZZZZ/  IZ(1)
      EQUIVALENCE      (VPS(1),IVPS(1)) ,(Z(1),IZ(1),DZ(1))
      EQUIVALENCE      (SP(1) ,  DP(1))
      DATA NAME / 4HPARA,4HML  /,BLANK/4H     /, AT/ 4HAND ,4HTHRU /
      DATA OPCD / 4HTABL,4HMATR,4HPRES,4HNULL,4HTRAI,4HDTI ,4HDMI  /
      DATA FIRST/ 12 /  ,IN1   / 101  /,   EI /2HE1, 2HE2, 2HE4    /
      DATA NTY  / 'ZERO', 'INTEGER', 'REAL',  'BCD' /
      DATA TYPE / 'S.P. REAL ', 'D.P. REAL ', 'S.P. CMPLX', 'D.P.CMPLX'/
C
C     SUPPRESS ALL PARAML CHECKING MESSAGES IF DIAG 37 IS ON
C
      CALL SSWTCH (37,I)
      PRT   = I .EQ. 0
      NZ    = KORSZ(IZ)
      IBUF1 = NZ - SYSBUF + 1
      IF (IBUF1 .LE. 0) GO TO 1220
      FLAG  = 1
      MCB(1)= IN1
      CALL RDTRL (MCB)
      IF (MCB(1) .GT. 0) GO TO 20
C
C     INPUT PURGED.  RETURN IF OP(1) IS NOT 'PRES'
C
      IF (OP(1) .NE. OPCD(3)) GO TO 1240
      FLAG  =-1
      CALL FNDPAR (-5,IL5)
      IF (PRT .AND. OP(2).NE.BLANK) WRITE (NOUT,40) UIM,OP
   10 INTEG = FLAG
      IVPS(IL5) = FLAG
      NMVPS(1) = IVPS(IL5-3)
      NMVPS(2) = IVPS(IL5-2)
      IF (PRT .AND. OP(2).NE.BLANK) WRITE (NOUT,510) INTEG,NMVPS
      GO TO 1240
C
   20 PREC = MCB(5)
      CALL FNAME (IN1,FNM)
      DO 30 J=3,9
      CALL FNDPAR (-J,IL(J))
   30 CONTINUE
      IF (OP(1).EQ.OPCD(3) .AND. OP(2).EQ.BLANK) GO TO 200
      IF (OP(1) .EQ. OPCD(4)) GO TO 210
      IF (.NOT.PRT) GO TO 45
      CALL PAGE2 (FIRST)
      FIRST = 5
      WRITE  (NOUT,40) UIM,OP
   40 FORMAT (A29,' FROM PARAML MODULE  - ',2A4,2H -, /5X,
     1       '(ALL PARAML MESSAGES CAN BE SUPPRESSED BY DIAG 37)',/)
C
C     IDENTIFY OPCODE
C
   45 DO 50 I = 1,7
      IF (OP(1) .EQ. OPCD(I)) GO TO (300,800,200,210,220,90,90), I
   50 CONTINUE
   60 WRITE  (NOUT,70) UFM,OP
   70 FORMAT (A23,', ILLEGAL OP REQUEST TO MODULE PARAML - ',2A4)
   80 CALL MESAGE (-37,0,NAME)
C
   90 IF (.NOT.PRT) GO TO 60
      WRITE  (NOUT,100) UIM
  100 FORMAT (A29,', NEW PARAMETERS USED IN PARAML MODULE:', //5X,
     1 'PARAML  DB//C,N,OP/C,N,P1/V,N,P2/V,N,RSP/V,N,INT/V,N,RDP/',
     2 'V,N,BCD/V,N,CSX/V,N,CDX  $', /13X,
     3 'OP      = OPCODE, ONE OF THE FOLLOWING KEY WORDS, BCD INPUT, N',
     4 'O DEFAULT', /23X,43H'MATRIX', 'NULL', 'PRESENCE', 'TRAILER', OR,
     5 /23X,28H'TABLE1', 'TABLE2', 'TABLE4',
     6 /13X,'P1,P2   = RECORD NO. AND WORD POSITION IF OP= TABLEi',
     7 /21X,'= ROW AND COLUMN INDEXES IF OP= MATRIX,  INTEGERS INPUT',
     8 /21X,'= P2 GIVES THE VALUE OF P1 TRAILER WORD IF OP= TRAILER',
     9 /13X,'RSP,RDP = SINGLE PRECISION AND DOUBLE PREC. REAL, OUTPUT',
     O /23X,'(DEFAULTS ARE 0.0 AND 0.D+0,  PREVIOUS DEFAULTS WARE ONES',
     1 /13X,'INT,BCD = INTEGER AND 2-BCD WORDS OUTPUT', /23X,'INT =-1,',
     2 ' IF NULL MATRIX AND OP= NULL, OR PURGED DB AND OP= PRESENCE',
     3 /13X,'CSX,CDX = SINGLE PRECISION AND DOUBLE PRECISION COMPLEX, ',
     4 'OUTPUT', //5X,'EXAMPLE - ',
     5 'ABSTRACT THE 3RD COL. 9TH ROW ELEMENT OF KGG MATRIX, AND', /15X,
     6 'ABSTRACT THE 3RD RECORD AND 9TH WORD  OF EPT DATA BLCOK', //5X,
     7 'PARAML  KGG//*MATRIX*/C,N,9/C,N,3/V,N,R93//V,N,D93//V,N,CS93',
     8 /5X,'PARAML  EPT//*TABLE1*/C,N,3/C,N,9//V,N,I39/V,N,D39',/)
      IF (I .EQ. 6) WRITE (NOUT,110)
      IF (I .EQ. 7) WRITE (NOUT,120)
 110  FORMAT (5X,'SUGGESTION- REPLACE THE OPCODE ''DTI'' BY ''TABLE1''')
 120  FORMAT (5X,'SUGGESTION- REPLACE THE OPCODE ''DMI'' BY ''MATRIX''',
     1      /18X,'AND NOTE THAT P1 IS ROW NUMBER AND P2 IS COLUMN NO.')
      GO TO 60
C
C     OP = PRESENCE
C     TEST FOR PRESENCE OF DATA BLOCK
C
  200 GO TO 10
C
C     OP = NULL
C     TEST FOR NULL MATRIX DATA BLOCK
C
  210 IF (MCB(7) .EQ. 0) FLAG =-1
      GO TO 10
C
C     OP = TRAILER
C     PLACE THE (P1+1) WORD OF THE TRAILER IN P2
C
  220 IF (P1.LE.0 .OR. P1.GE.7) GO TO 230
      P2 = MCB(P1+1)
      IVPS(IL3) = P2
      NMVPS(1) = IVPS(IL3-3)
      NMVPS(2) = IVPS(IL3-2)
      IF (PRT) WRITE (NOUT,510) P2,NMVPS
      GO TO 1240
  230 WRITE  (NOUT,240) UFM,P1
  240 FORMAT (A23,', 2ND PARAMETER IN PARAML MODULE IS ILLEGAL',I5)
      GO TO 80
C
C     OP = TABLE
C     PROCESS TABLE TYPE DATA BLOCK
C
  300 TB1 = .FALSE.
      TB2 = .FALSE.
      TB4 = .FALSE.
      IF (OP(2) .EQ. EI(1)) TB1 = .TRUE.
      IF (OP(2) .EQ. EI(2)) TB2 = .TRUE.
      IF (OP(2) .EQ. EI(3)) TB4 = .TRUE.
      IF (.NOT.TB1 .AND. .NOT.TB2 .AND. .NOT.TB4) GO TO 60
      MAT = .FALSE.
      RECNO = P1
      INDEX = P2
      IF (TB2) IXP1 = INDEX+1
      IF (TB4) IXP1 = INDEX+3
      ATX = AT(1)
      IF (TB4) ATX = AT(2)
      CALL OPEN (*1200,IN1,IZ(IBUF1),0)
      CALL SKPREC (IN1,RECNO)
      CALL READ (*1210,*310,IN1,IZ,IBUF1-1,1,RL)
      GO TO 1220
  310 IF (INDEX .GT. RL) GO TO 1210
      IF (IL4 .LE. 0) GO TO 500
C
C     OUTPUT REQUEST IN S.P. REAL
C
      IF (.NOT.PRT) GO TO 350
      IF (.NOT.TB1) GO TO 330
      WRITE  (NOUT,320) FNM,RECNO,INDEX
  320 FORMAT (5X,'INPUT FILE ',2A4,' RECORD',I6,' WORD',I6,13X,1H=)
      GO TO 350
  330 WRITE  (NOUT,340) FNM,RECNO,INDEX,ATX,IXP1
  340 FORMAT (5X,'INPUT FILE ',2A4,' RECORD',I6,' WORDS',I6,1X,A4,I5,
     1       '  =')
  350 NMVPS(1) = IVPS(IL4-3)
      NMVPS(2) = IVPS(IL4-2)
      IF (TB4) GO TO 400
      IF (TB2) GO TO 355
      RSP = Z(INDEX)
      IF (MAT) GO TO 360
      K = NUMTYP(RSP)+1
      IF (K.EQ.2 .OR. K.EQ.4) GO TO 400
      GO TO 360
  355 K = -1
      IF (INDEX+1 .GT. RL) GO TO 400
      SP(1) = Z(INDEX  )
      SP(2) = Z(INDEX+1)
CWKBI
      IF ( SP(2) .EQ. 0.0 ) DP(1) = SP(1)
CWKBR RSP = SNGL(DP(1))
      RSP = SP(1)
      K = NUMTYP(RSP)+1
      IF (K.EQ.2 .OR. K.EQ.4) GO TO 400
  360 IF (PRT) WRITE (NOUT,370) RSP,NMVPS
  370 FORMAT (1H+,70X,E15.8,'   = ',2A4)
      VPS(IL4) = RSP
      GO TO 500
C
  400 IF (.NOT.PRT) GO TO 500
      WRITE  (NOUT,410) NMVPS
  410 FORMAT (1H+,70X,'(INVALID REQUEST) = ',2A4)
      IF (K .GT. 0) WRITE (NOUT,420) UWM,NTY(K),NMVPS
      IF (K .EQ.-1) WRITE (NOUT,430) UWM,NMVPS
  420 FORMAT (A25,' - ILLEGAL OUTPUT REQUESTED. ORIG. DATA TYPE IS ',A7,
     1       ',  PARAMETER ',2A4,' NOT SAVED')
  430 FORMAT (A25,' - E-O-R ENCOUNTERED.  PARAMETER ',2A4,' NOT SAVED')
C
  500 IF (IL5.LE.0 .OR. MAT) GO TO 540
C
C     OUTPUT REQUEST IS INTEGER
C
      IF (.NOT.PRT) GO TO 505
      IF (     TB1) WRITE (NOUT,320) FNM,RECNO,INDEX
      IF (.NOT.TB1) WRITE (NOUT,340) FNM,RECNO,INDEX,ATX,IXP1
  505 NMVPS(1) = IVPS(IL5-3)
      NMVPS(2) = IVPS(IL5-2)
      K = 0
      IF (TB2 .OR. TB4) GO TO 520
      INTEG = IZ(INDEX)
      K = NUMTYP(INTEG)+1
      IF (K .GT. 2) GO TO 520
      IVPS(IL5) = INTEG
      IF (PRT) WRITE (NOUT,510) INTEG,NMVPS
  510 FORMAT (1H+,70X,I15,'   = ',2A4)
      GO TO 540
C
  520 IF (.NOT.PRT) GO TO 540
      WRITE (NOUT,410) NMVPS
      IF (K .GT. 0) WRITE (NOUT,420) UWM,NTY(K),NMVPS
      IF (K .EQ. 0) WRITE (NOUT,530) UWM,NMVPS
  530 FORMAT (A25,' - ILLEGAL INTEGER ABSTRACTION FROM 2 OR 4 DATA ',
     1       'WORDS.  OUPUT PARAMETER ',2A4,' NOT SAVED')
      GO TO 540
C
  540 IF (IL6 .LE. 0) GO TO 600
C
C     OUTPUT REQUEST IN D.P. REAL
C
      IF (.NOT.PRT) GO TO 545
      IF (     TB1) WRITE (NOUT,320) FNM,RECNO,INDEX
      IF (.NOT.TB1) WRITE (NOUT,340) FNM,RECNO,INDEX,ATX,IXP1
  545 NMVPS(1) = IVPS(IL6-3)
      NMVPS(2) = IVPS(IL6-2)
      IF (MAT) GO TO 560
      IF (TB2) GO TO 550
      IF (TB4) GO TO 590
      K = NUMTYP(Z(INDEX))+1
      IF (K.EQ.2 .OR. K.EQ.4) GO TO 590
      DP(1) = DBLE(Z(INDEX))
      GO TO 570
  550 K =-1
      J = 0
      IF (INDEX+1 .GT. RL) GO TO 590
      SP(1) = Z(INDEX  )
      SP(2) = Z(INDEX+1)
CWKBD 9/93      X = SNGL(DP(1))
      X = SP(1)
      J = NUMTYP(X)+1
      IF (J.EQ.2 .OR. J.EQ.4) GO TO 590
      GO TO 570
  560 IF (PREC .EQ. 1) DP(1) = DBLE(Z(INDEX))
CWKBI
  570 IF ( SP(2) .EQ. 0.0 ) DP(1) = SP(1)
CWKBR  570 RDP = DP(1)
      RDP = DP(1)
      VPS(IL6  ) = SP(1)
      VPS(IL6+1) = SP(2)
      IF (PRT) WRITE (NOUT,580) RDP,NMVPS
  580 FORMAT (1H+,70X,D15.8,'   = ',2A4)
      GO TO 600
C
  590 IF (.NOT.PRT) GO TO 600
      WRITE (NOUT,410) NMVPS
      IF (J.EQ.2 .OR. J.EQ.4) K = J
      IF (K .GT. 0) WRITE (NOUT,420) UWM,NTY(K),NMVPS
      IF (K .EQ.-1) WRITE (NOUT,430) UWM,NMVPS
C
  600 IF (IL7.LE.0 .OR. MAT) GO TO 650
C
C     OUTPUT REQUEST IN BCD
C
      IF (.NOT.PRT) GO TO 605
      IF (     TB1) WRITE (NOUT,320) FNM,RECNO,INDEX
      IF (.NOT.TB1) WRITE (NOUT,340) FNM,RECNO,INDEX,ATX,IXP1
  605 NMVPS(1) = IVPS(IL7-3)
      NMVPS(2) = IVPS(IL7-2)
      K = 0
      IF (TB4) GO TO 630
      BCD(1) = IZ(INDEX)
      BCD(2) = BLANK
      K = NUMTYP(BCD(1))+1
      IF (K .NE. 4) GO TO 630
      IF (TB1) GO TO 610
      K = -1
      IF (INDEX+1 .GT. RL) GO TO 630
      BCD(2) = IZ(INDEX+1)
      K = NUMTYP(BCD(2))+1
      IF (K .NE. 4) GO TO 630
  610 IVPS(IL7  ) = BCD(1)
      IVPS(IL7+1) = BCD(2)
      IF (PRT) WRITE (NOUT,620) BCD,NMVPS
  620 FORMAT (1H+,70X,2A4,'   = ',2A4)
      GO TO 650
C
  630 IF (.NOT.PRT) GO TO 650
      WRITE (NOUT,410) NMVPS
      IF (K .GT. 0) WRITE (NOUT,420) UWM,NTY(K),NMVPS
      IF (K .EQ. 0) WRITE (NOUT,640) UWM,NMVPS
      IF (K .EQ.-1) WRITE (NOUT,430) UWM,NMVPS
  640 FORMAT (A25,' - ILLEGAL BCD ABSTRACTION FROM 4 DATA WORDS. ',
     1       ' PARAMETER ',2A4,'NOT SAVED')
C
  650 IF (IL8 .LE. 0) GO TO 700
C
C     OUTPUT REQUEST IN S.P. COMPLEX
C
      IF (.NOT.PRT) GO TO 655
      IF (     TB1) WRITE (NOUT,320) FNM,RECNO,INDEX
      IF (.NOT.TB1) WRITE (NOUT,340) FNM,RECNO,INDEX,ATX,IXP1
  655 NMVPS(1) = IVPS(IL8-3)
      NMVPS(2) = IVPS(IL8-2)
      K =-1
      J = 0
      IF (TB4) GO TO 660
      SPLX(1) = Z(INDEX)
      SPLX(2) = 0.0
      IF (TB1 .OR. MAT) GO TO 670
      IF (INDEX+1 .GT. RL) GO TO 690
      SPLX(2) = Z(INDEX+1)
      GO TO 670
  660 IF (INDEX+3 .GT. RL) GO TO 690
      SP(1)   = Z(INDEX  )
      SP(2)   = Z(INDEX+1)
      SP(3)   = Z(INDEX+2)
      SP(4)   = Z(INDEX+3)
CWKBR SPLX(1) = SNGL(DP(1))
      SPLX(1) = SP(1)
CWKBR SPLX(2) = SNGL(DP(2))
      SPLX(2) = SP(3)
  670 J = NUMTYP(SPLX(1))+1
      K = NUMTYP(SPLX(2))+1
      IF (J.EQ.2 .OR. J.EQ.4 .OR. K.EQ.2 .OR. J.EQ.4) GO TO 690
      VPS(IL8  ) = SPLX(1)
      VPS(IL8+1) = SPLX(2)
      IF (PRT) WRITE (NOUT,680) SPLX,NMVPS
  680 FORMAT (1H+,70X,1H(,E15.8,1H,,E15.8,1H),'  = ',2A4)
      GO TO 700
C
  690 IF (.NOT.PRT) GO TO 700
      WRITE (NOUT,410) NMVPS
      IF (J.EQ.2 .OR. J.EQ.4) K = J
      IF (K .EQ. 0) WRITE (NOUT,420) UWM,NTY(K),NMVPS
      IF (K .EQ.-1) WRITE (NOUT,430) UWM,NMVPS
C
  700 IF (IL9 .LE. 0) GO TO 1100
C
C     OUTPUT REQUEST IN D.P. COMPLEX
C
      IF (.NOT.PRT) GO TO 705
      IF (     TB1) WRITE (NOUT,320) FNM,RECNO,INDEX
      IF (.NOT.TB1) WRITE (NOUT,340) FNM,RECNO,INDEX,ATX,IXP1
  705 NMVPS(1) = IVPS(IL9-3)
      NMVPS(2) = IVPS(IL9-2)
      K =-1
      J = 0
      IF (TB4) GO TO 710
      K = NUMTYP(Z(INDEX))+1
      IF (K.EQ.2 .OR. K.EQ.4) GO TO 740
      DP(1) = DBLE(Z(INDEX))
      DP(2) = 0.D0
      IF (TB1 .OR. MAT) GO TO 720
      IF (INDEX+1 .GT. RL) GO TO 740
      K = NUMTYP(Z(INDEX+1))+1
      IF (K.EQ.2 .OR. K.EQ.4) GO TO 740
      DP(2) = DBLE(Z(INDEX+1))
      GO TO 720
  710 IF (INDEX+3 .GT. RL) GO TO 740
      SP(1) = Z(INDEX  )
      SP(2) = Z(INDEX+1)
      SP(3) = Z(INDEX+2)
      SP(4) = Z(INDEX+3)
CWKBR X = SNGL(DP(1))
      X = SP(1)
CWKBR Y = SNGL(DP(2))
      Y = SP(3)
      J = NUMTYP(X)+1
      K = NUMTYP(Y)+1
      IF (J.EQ.2 .OR. J.EQ.4 .OR. K.EQ.2 .OR. K.EQ.4) GO TO 740
      DP(1)   = DBLE(Z(INDEX))
      DP(2)   = 0.D0
  720 DPLX(1) = DP(1)
      DPLX(2) = DP(2)
      VPS(IL9  ) = SP(1)
      VPS(IL9+1) = SP(2)
      VPS(IL9+2) = SP(3)
      VPS(IL9+3) = SP(4)
      IF (PRT) WRITE (NOUT,730) DPLX,NMVPS
  730 FORMAT (1H+,70X,1H(,D15.8,1H,,D15.8,1H),'  = ',2A4)
      GO TO 1100
C
  740 IF (.NOT.PRT) GO TO 1100
      WRITE (NOUT,410) NMVPS
      IF (J.EQ.2 .OR. J.EQ.4) K = J
      IF (K .GT. 0) WRITE (NOUT,420) UWM,NTY(K),NMVPS
      IF (K .EQ.-1) WRITE (NOUT,430) UWM,NMVPS
      GO TO 1100
C
C     OP = MATRIX
C     PROCESS MATRIX TYPE DATA BLOCK
C
  800 ROW  = P1
      COL  = P2
      ITYP = MCB(5)
      IF (IL5 .LE. 0) GO TO 840
      IF (PRT) WRITE (NOUT,810) ROW,COL,TYPE(ITYP),FNM
  810 FORMAT (5X,'ELEMENT (',I5,'-ROW,',I5,'-COL) OF ',A10,' INPUT ',
     1       'FILE ',2A4,2H =)
      NMVPS(1) = IVPS(IL5-3)
      NMVPS(2) = IVPS(IL5-2)
      IF (.NOT.PRT) GO TO 840
      WRITE  (NOUT,820) NMVPS
  820 FORMAT (1H+,70X,'(INVALID INTEGER) = ',2A4)
      WRITE  (NOUT,830) UWM,NMVPS
  830 FORMAT (A25,' - OUTPUT PARAMETER ',2A4,' NOT SAVED')
  840 IF (IL7 .LE. 0) GO TO 860
      IF (PRT) WRITE (NOUT,810) ROW,COL,TYPE(ITYP),FNM
      NMVPS(1) = IVPS(IL7-3)
      NMVPS(2) = IVPS(IL7-2)
      IF (.NOT.PRT) GO TO 860
      WRITE  (NOUT,850) NMVPS
  850 FORMAT (1H+,70X,'(INVALID BCD WORD)= ',2A4)
      WRITE  (NOUT,830) UWM,NMVPS
C
  860 IF (IL4.LE.0 .AND. IL6.LE.0 .AND. IL8.LE.0 .AND. IL9.LE.0)
     1   GO TO 1240
C
C     OUTPUT REQUEST - IL4 - S.P. REAL
C                      IL5 - INTEGER
C                      IL6 - D.P. REAL
C                      IL7 - BCD
C                      IL8 - S.P. COMPLEX
C                      IL9 - D.P. COMPLEX
C
      MAT   = .TRUE.
      TB1   = .FALSE.
      TB2   = .FALSE.
      TB4   = .FALSE.
      RECNO = P2
      INDEX = P1
      RL    = 999999
      II    = 1
      JJ    = MCB(3)
      INCR  = 1
      CALL GOPEN (IN1,IZ(IBUF1),0)
      CALL SKPREC (IN1,COL-1)
      CALL UNPACK (*1030,IN1,Z)
      GO TO (900,910,950,950), ITYP
C
C     INPUT MATRIX PRECISION TYPE = 1, S.P. REAL
C
  900 GO TO 350
C
C     MATRIX PRECISION TYPE = 2, D.P. REAL
C
  910 IF (IL4 .LE. 0) GO TO 920
      IF (PRT) WRITE (NOUT,810) ROW,COL,TYPE(ITYP),FNM
      RSP = DZ(ROW)
      VPS(IL4) = RSP
      NMVPS(1) = IVPS(IL4-3)
      NMVPS(2) = IVPS(IL4-2)
      IF (PRT) WRITE (NOUT,370) RSP,NMVPS
  920 IF (IL6 .LE. 0) GO TO 930
      IF (PRT) WRITE (NOUT,810) ROW,COL,TYPE(ITYP),FNM
      RDP   = DZ(ROW)
      DP(1) = RDP
      VPS(IL6  ) = SP(1)
      VPS(IL6+1) = SP(2)
      NMVPS(1) = IVPS(IL6-3)
      NMVPS(2) = IVPS(IL6-2)
      IF (PRT) WRITE (NOUT,580) RDP,NMVPS
  930 IF (IL8 .LE. 0) GO TO 940
      IF (PRT) WRITE (NOUT,810) ROW,COL,TYPE(ITYP),FNM
      SPLX(1) = DZ(ROW)
      SPLX(2) = 0.0
      VPS(IL8  ) = SPLX(1)
      VPS(IL8+1) = SPLX(2)
      NMVPS(1) = IVPS(IL8-3)
      NMVPS(2) = IVPS(IL8-2)
      IF (PRT) WRITE (NOUT,680) SPLX,NMVPS
  940 IF (IL9 .LE. 0) GO TO 1100
      IF (PRT) WRITE (NOUT,810) ROW,COL,TYPE(ITYP),FNM
      DP(1) = DZ(ROW)
      DP(2) = 0.D0
      NMVPS(1) = IVPS(IL9-3)
      NMVPS(2) = IVPS(IL9-2)
      GO TO 720
C
C     INPUT MATRIX PRECISION TYPE = 3 OR 4, COMPLEX
C
  950 IF (IL4 .LE. 0) GO TO 970
      IF (PRT) WRITE (NOUT,810) ROW,COL,TYPE(ITYP),FNM
      NMVPS(1) = IVPS(IL4-3)
      NMVPS(2) = IVPS(IL4-2)
      IF (.NOT.PRT) GO TO 970
      WRITE  (NOUT,960) NMVPS
  960 FORMAT (1H+,70X,' (INVALID S.P. REAL NUMBER)  = ',2A4)
      WRITE  (NOUT,830) UWM,NMVPS
  970 IF (IL6 .LE. 0) GO TO 990
      IF (PRT) WRITE (NOUT,810) ROW,COL,TYPE(ITYP),FNM
      NMVPS(1) = IVPS(IL6-3)
      NMVPS(2) = IVPS(IL6-2)
      IF (PRT) WRITE (NOUT,980) NMVPS
  980 FORMAT (1H+,70X,' (INVALID D.P.REAL NUMBER)  = ',2A4)
  990 IF (IL8.LE.0 .AND. IL9.LE.0) GO TO 1100
      IF (ITYP .EQ. 4) GO TO 1010
C
C     INPUT MATRIX PRECISION TYPE = 3, S.P.COMPLEX
C
      IF (IL8 .LE. 0) GO TO 1000
      IF (PRT) WRITE (NOUT,810) ROW,COL,TYPE(ITYP),FNM
      SPLX(1) = Z(ROW  )
      SPLX(2) = Z(ROW+1)
      VPS(IL8  ) = SPLX(1)
      VPS(IL8+1) = SPLX(2)
      NMVPS(1) = IVPS(IL8-3)
      NMVPS(2) = IVPS(IL8-2)
      IF (PRT) WRITE (NOUT,680) SPLX,NMVPS
 1000 IF (IL9 .LE. 0) GO TO 1100
      IF (PRT) WRITE (NOUT,810) ROW,COL,TYPE(ITYP),FNM
      DP(1) = DBLE(Z(ROW  ))
      DP(2) = DBLE(Z(ROW+1))
      NMVPS(1) = IVPS(IL9-3)
      NMVPS(2) = IVPS(IL9-2)
      GO TO 720
C
C     INPUT MATRIX PRECISION TYPE = 4, D.P.COMPLEX
C
 1010 IF (IL8 .LE. 0) GO TO 1020
      IF (PRT) WRITE (NOUT,810) ROW,COL,TYPE(ITYP),FNM
      SPLX(1) = SNGL(DZ(ROW  ))
      SPLX(2) = SNGL(DZ(ROW+1))
      VPS(IL8  ) = SPLX(1)
      VPS(IL8+1) = SPLX(2)
      NMVPS(1) = IVPS(IL8-3)
      NMVPS(2) = IVPS(IL8-2)
      IF (PRT) WRITE (NOUT,680) SPLX,NMVPS
 1020 IF (IL9 .LE. 0) GO TO 1100
      IF (PRT) WRITE (NOUT,810) ROW,COL,TYPE(ITYP),FNM
      DP(1) = DZ(ROW  )
      DP(2) = DZ(ROW+1)
      NMVPS(1) = IVPS(IL9-3)
      NMVPS(2) = IVPS(IL9-2)
      GO TO 720
C
C     NULL INPUT MATRIX ELEMENT
C
 1030 Z (ROW  ) = 0.
      Z (ROW+1) = 0.
      DZ(ROW  ) = 0.D0
      DZ(ROW+1) = 0.D0
      GO TO (900,910,950,950), ITYP
C
 1100 CALL CLOSE (IN1,1)
      GO TO 1240
C
C     ERRORS
C
 1200 J = -1
      GO TO 1230
 1210 J = -2
      GO TO 1230
 1220 J = -8
 1230 CALL MESAGE (J,IN1,NAME)
C
 1240 RETURN
      END

      SUBROUTINE UPART (USET,SCR1,MAJOR,SUB0,SUB1)
C
C     UPART ALONG WITH MPART WILL PERFORM A SYMMETRIC PARTITION OF A
C     MATRIX
C
      INTEGER         USET,SCR1,MAJOR,SUB0,SUB1,RULE,PVECT,USET1
C
      COMMON /PARMEG/ IA(7),IA11(7),IA12(7),IA21(7),IA22(7),LCORE,RULE
      COMMON /PATX  / LC,N1,N2,N3,USET1,PVECT(7)
      COMMON /ZZZZZZ/ CORE(1)
C
C
      USET1 = USET
C
C     TRANSFER OF PVECT TRAILER AS LOADED BY CALCV IS NOW BY /PATX/
C
      RULE  = 0
      LC    = KORSZ(CORE)
      LCORE = LC
      CALL CALCV (SCR1,MAJOR,SUB0,SUB1,CORE)
      N4 = N2 + N3
      IA11(2) = N1
      IA11(3) = N1
      IA21(2) = N4
      IA21(3) = N1
      IA21(4) = 2
      IA12(2) = N1
      IA12(3) = N4
      IA12(4) = 2
      IA22(2) = N4
      IA22(3) = N4
   10 RETURN
C
C
      ENTRY MPART (IA1,IA111,IA121,IA211,IA221)
C     =========================================
C
      IA(1) = IA1
      CALL RDTRL (IA)
      IF (IA(1)) 10,20,20
   20 IA11(1) = IA111
      IA12(1) = IA121
      IA21(1) = IA211
      IA22(1) = IA221
      IA11(4) = IA(4)
      IA11(5) = IA(5)
      IA21(5) = IA(5)
      IA12(5) = IA(5)
      IA22(4) = IA(4)
      IA22(5) = IA(5)
      CALL PARTN (PVECT,PVECT,CORE)
      DO 40 I = 1,4
      J = (I-1)*7 + 1
      IF (IA11(J)) 30,40,30
   30 CALL WRTTRL (IA11(J))
   40 CONTINUE
      GO TO 10
      END

      SUBROUTINE OUTPT5
C
C     DRIVER OF OUTPUT5 MODULE
C     COPIES UP TO 5 GINO DATA BLOCKS TO TAPE, BY FORTRAN WRITE,
C     FORMATTED (ASCII), OR UNFORMATTED (BINARY)
C
C     THIS MODULE HAS BEEN EXPANDED TO INCLUDE TABLE DATA BLOCKS.
C     ORIGINALLY IT HANDLES ONLY MATRIX DATA BLOCKS.  G.CHAN/MAY 88
C
C     ==== TABLE  ====
C     OUTPT5 CALLS TABLE5 TO PROCESS TABLE DATA BLOCKS
C      . UNFORMATTED (BINARY) OR FORMATTED (UNDER P4 CONTROL)
C      . IF BINARY, EACH RECORD IS WRITTEN OUT BY -
C           WRITE (OUT) L,(Z(J),J=1,L)
C      . IF FORMATTED,  5 BYTES ARE USED FOR BCD WORD,
C                      10 BYTES FOR INTEGER,
C                      15 BYTES FOR REAL, S.P. OR D.P.
C      . A HEADER RECORD, WHICH CONFORMS TO OUTPT5 HEADER STANDARD,
C           IS WRITTEN OUT FIRST, PRECEEDING THE TABLE DATA RECORDS.
C
C     ==== MATRIX ====
C     COPY GINO MATRIX DATA BLOCK(S) ONTO FORTRAN UNIT IN
C      . UNPACKED BANDED RECORD
C      . BANDED COLUMN  RECORD (FIRST TO LAST NON-ZERO ELEMENTS),
C      . UNFORMATTED (BINARY) OR FORMATTED
C      . SINGLE PRECISION OR DOUBLE, REAL OR COMPLEX DATA
C      . OUTPUT FORTRAN TAPE INPI (I=T,1,2,..,9) FOR UNIVAC, IBM, VAX
C                    OR TAPE UTI  (I=  1,2,..,5) FOR CDC
C        (DEFAULT=INP1, UNIT 15, OR UT1, UNIT 11)
C
C     THIS MODULE HANDLES ONLY MATRIX DATA BLOCKS, NOT TRUE ANY MORE
C
C     UNFORMATTED RECORDS CAN ONLY BE USED BY THE SAME COMPUTER SYSTEM,
C     WHILE FORMATTED RECORDS CAN BE USED ACROSS COMPUTER BOUNDARY
C     (E.G. WRITTEN BY CDC MACHINE AND READ BY IBM) AND ALSO, CAN BE
C     EDITED BY SYSTEM EDITOR, OR PRINTED OUT BY SYSTEM PRINT COMMAND.
C
C     CALL TO THIS MODULE IS
C
C     OUTPUT5  IN1,IN2,IN3,IN4,IN5//C,N,P1/C,N,P2/C,N,P3/C,N,P4
C                                  /C,N,T1/C,N,T2/C,N,T3/C,N,T4... $
C
C              P1=+N, SKIP FORWARD N MATRIX DATA BLOCKS OR TABLES BEFORE
C                     WRITE. (EXCEPT THE FIRST HEADER RECORD. EACH
C                     MATRIX DATA BLOCK OR TABLE, PRECEEDED BY A HEADER
C                     RECORD, IS A COMPLETE MATRIX OR TABLE, MADE UP OF
C                     MANY PHYSICAL RECORDS.
C                     SKIP TO THE END OF TAPE IF P1 EXCEEDS THE
C                     NO. OF DATA BLOCKS AVAILABLE ON THE OUTPUT FILE)
C              P1= 0, NO ACTION TAKEN BEFORE WRITE. (DEFAULT)
C              P1=-1, FORTRAN TAPE IS REWOUND, A TAPE HEADER RECORD IS
C                     WRITTEN TO TAPE. DATA IN FIRST GINO DATA BLOCK IS
C                     COPIED TO TAPE, FOLLOWED BY 4 MORE GINO DATA
C                     BLOCKS IF THEY ARE PRESENT.
C                     AT END, NO EOF WRITTEN, AND TAPE NOT REWOUND
C              P1=-3, THE NAMES OF ALL DATA BLOCKS ON FORTRAN TAPE
C                     ARE PRINTED AND WRITE OCCURS AT THE END OF TAPE
C              P1=-9, WRITE AN INTERNAL END-OF-FILE RECORD, FOLLOWED BY
C                     A SYSTEM ENDFILE MARK, AND REWIND FORTRAN TAPE
C              P2  IS THE FORTRAN UNIT NO. ON WHICH THE DATA BLOCKS WILL
C                     BE WRITTEN.  DEFAULT IS 15 (INP1 FOR UNIVAC, IBM,
C                     VAX), OR UNIT 11 (UT1 FOR CDC)
C
C              P3  IS TAPE ID IF GIVEN BY USER. DEFAULT IS XXXXXXXX
C
C              P4= 0, OUTPUT FILE IS FORTRAN WRITTEN, UNFORMATTED
C              P4= 1, OUTPUT FILE IS FORTRAN WRITTEN, FORMATTED
C                     (BCD IN 2A4, INTEGER IN I8, REAL IN 10E13.6 AND
C                      D.P. IN 5D26.17)
C              P4= 2, SAME AS P4=1, EXECPT 5E26.17 IS USED FOR S.P. REAL
C                     DATA. P4=2 IS USED ONLY IN MACHINES WITH LONG WORD
C                     FOR ACCURACY (60 OR MORE BITS PER WORD)
C
C              TI     10 WORD ARRAY USED ONLY BY TABLE BLOCK DATA.
C                     TO OVERRIDE AUTOMATIC FORMAT TYPE SETTING.
C
C     OUTPT5 LOGIC -
C                                                       (P4=0)   (P4=1)
C     RECORD  WORD        CONTENTS                      BINARY   FORMAT
C     ------  ----  --------------------------------   -------  -------
C        0            TAPE HEADER RECORD -
C              1,2    TAPEID                             2*BCD      2A4
C              3,4    MACHINE (2ND WORD BLANK)           2*BCD      2A4
C              5-7    DATE                               3*INT      3I8
C               8     SYSTEM BUFFSIZE                      INT       I8
C               9     P4 (0,1, OR 2)                       INT       I8
C      1A,1B%         FIRST MATRIX HEADER RECORD -
C               1     ZERO                                 INT       I8
C              2,3    ONE,ONE                            2*INT      2I8
C               4     D.P. ZERO                           F.P.   D26.17
C              5-10   MATRIX TRAILER                     6*INT      6I8
C                     (COL,ROW,FORM,TYPE,MAX,DENSITY)
C             11,12   DMAP NAME OF FIRST INPUT MATRIX    2*BCD      2A4
C      2A,2B    1     1 (FIRST MATRIX COLUMN ID)           INT       I8
C               2     COLUMN LOC. OF FIRST NON-ZERO ELEM.  INT       I8
C               3     COLUMN LOC. OF LAST  NON-ZERO ELEM.  INT       I8
C              1-W    FIRST BANDED COLUMN DATA            F.P.     (**)
C                     (W=WORD3-WORD2)
C      3A,3B    1     2 (SECOND MATRIX COLUMN ID)          INT       I8
C              2-3    FIRST AND LAST NON-ZERO ELEM LOC.  2*INT      2I8
C              1-W    SECOND BANDED COLUMN DATA           F.P.     (**)
C      4A,4B   1-3    THIRD  MATRIX COLUMN, SAME FORMAT  3*INT      3I8
C              1-W    AS RECORD 1                         F.P.     (**)
C        :      :       :
C      ZA,ZB    1     (A NULL COLUMN ID)                   INT       I8
C              2,3    1,1                                2*INT      2I8
C               1     0.0                                 F.P.     (**)
C        :      :       :
C      MA,MB   1-3    LAST MATRIX COLUMN, SAME AS REC #2 3*INT      3I8
C              1-W    LAST BANDED COLUMN DATA             F.P.     (**)
C
C      SA,SB    :     SECOND MATRIX HEADER RECORD   3*INT+F.P. 3I8+D26.
C                                                       +2*BCD   +2*BCD
C                                                       +6*INT     +6I8
C    S+1A,S+1B 1-W    FIRST THRU LAST COLS OF 2ND MATRIX
C        :      :     REPEAT FOR MORE MATRICES
C        :      :     (UP TO 5 MATRIX DATA BLOCKS PER ONE OUTPUT FILE)
C
C    EOFA,EOFB  1     -1                                   INT       I8
C              2,3    1,1                                2*INT      2I8
C               1     D.P. ZERO                           F.P.   D26.17
C
C                                                               - NOTE -
C                                                  BCD AND INTEGERS IN 8
C                                         SINGLE PRECISION REAL IN  13.6
C                                         DOUBLE PRECISION DATA IN 26.17
C                                         S.P. LOGN WORD MACHINE   26.17
C
C     WHERE   %  RECORDS A AND B ARE 2 (OR MORE) RECORDS ON FORMATTED
C                OUTPUT FILE, WHILE
C                A & B ARE 1 CONTINUOUS RECORD IN UNFORMATTED TAPE
C           (**) IS (10E13.6) FOR S.P.REAL, OR (5D26.17) FOR D.P. DATA.
C                OR (5E26.17) FOR S.P. AND D.P. DATA (P4=2 ONLY)
C     NOTE -
C     NO SYSTEM END-OF-FILE MARK WRITTEN BETWEEN MATRICES.
C
C     TO READ BINARY TAPE              TO READ FORMATTED TAPE
C     ----------------------------     --------------------------------
C                LOGICAL SP,DP
C                INTEGER COL,ROW,FORM,TYPE,DENS,FILE(2),IZ(M,N)
C    *                   TAPEID(2),MAC(2),DATE(3),BUFSZ,P4
C                DOUBLE PRECISION DZ(M/2,N/2),DTEMP
C                COMMON  /ZZZZZZ/ Z(M,N)
C                EQUIVALENCE      (Z,IZ,DZ)
C                DATA     SP,DP / .TRUE.,.FALSE./
C     READ (TAPE,ERR=7)                READ (TAPE,10,ERR=7)
C    *           TAPEID,MAC,DATE,BUFSZ,P4
C   1            K = 0
C   2            K = K + 1
C     READ (TAPE,ERR=7,END=3) I,JB,    IF (SP) READ (TAPE,8,ERR=7,END=3)
C    *                        JE               I,JB,JE,( Z(J,K),J=JB,JE)
C                                      IF (DP) READ (TAPE,9,ERR=7,END=3)
C    *                                         I,JB,JE,(DZ(J,K),J=JB,JE)
C                IF (I)   3,            4,     6
CC                      EOF,MATRIX-HEADER,COLUMN
C   3            CONTINUE
CC               (EOF ENCOUNTERED, COMPLETE TAPE READ)
C                CALL EXIT
C   4            BACKSPACE TAPE
C                                      BACKSPACE TAPE
CC               (MATRIX-HEADER READ)
C     READ (TAPE) J,J,J,               READ (TAPE,11) J,J,J
C    *           DTEMP,COL,ROW,FORM,TYPE,MAX,DENS,FILE
C                DP = .FALSE.
C                IF (TYPE.EQ.2 .OR. TYPE.EQ.4) DP=.TRUE.
C                SP = .NOT.DP
C                JTYP = TYPE
C                IF (TYPE .EQ. 3) JTYP = 2
C                IF (COL*JTYP.GT.M .OR. ROW*JTYP.GT.N) STOP 'Z DIM ERR'
C                J = COL*ROW*JTYP
C                DO 5 I = 1,J
C   5            Z(I,1) = 0.0
C                GO TO 1
C   6            CONTINUE
CC               (A COLUMN OF MATRIX READ)
C                IF (I .NE. K) STOP 'COLUMN COUNTER MISSMATCH'
C                GO TO 2
C   7            STOP 'READ ERROR. CHECK TAPE FORMAT TYPE'
C                                     8 FORMAT (3I8,/,(10E13.6))
C                                     9 FORMAT (3I8,/,(5D26.17))
C                                    10 FORMAT (4A4,5I8)
C                                    11 FORMAT (3I8,/,D26.17,6I8,2A4)
CC             FOR LONG WORD MACHINE  8 FORMAT (3I8,/,(5E26.17))
C
C     SEE SUBROUTINE INPTT5 FOR MORE COMPREHENSIVE DETAILS IN RECOVERING
C     MATRIX DATA FROM THE TAPE GENERATED IN THIS OUTPT5 ROUTINE.
C     OR SUBROUTINE TABLE-V FOR TABLE DATA BLOCK RECOVERY.
C
C     WRITTEN BY G.CHAN/UNISYS   1987
C
      IMPLICIT INTEGER (A-Z)
      LOGICAL          P40,P40S,P40D,P41,P41S,P41D,P41C,COMPLX
      INTEGER          TRL(9),NAME(2),TAPEID(2),SUBNAM(2),TI,DT(3),
     1                 FN(3,10),NONE(2)
      REAL             RZ(1),X,ZERO
      DOUBLE PRECISION DZ(1),DX,DZERO
      CHARACTER*8      BINARY,FORMTD,BF
      CHARACTER        UFM*23,UWM*25,UIM*29,SFM*25
CWKBNB
      CHARACTER*80     DSNAMES
      COMMON /DSNAME/  DSNAMES(80)
CWKBNE
      COMMON /XMSSG /  UFM,UWM,UIM,SFM
      COMMON /BLANK /  P1,P2,P3(2),P4,TI(10)
      COMMON /MACHIN/  MACH,IJHALF(3),MCHNAM
      COMMON /SYSTEM/  IBUF,NOUT,DUM6(7),LINE,DUMM4(4),DATE(3),
     1                 DUM22(22),NBPW,DUM50(50),LPCH
      COMMON /ZZZZZZ/  IZ(1)
      COMMON /UNPAKX/  ITYP,II,JJ,INCR
      EQUIVALENCE      (RZ(1),DZ(1),IZ(1))
      DATA    BINARY,           FORMTD,         SUBNAM             /
     1       'BINARY  ',        'FORMATTD',     4HOUTP, 2HT5       /
      DATA    ZERO,    DZERO,   IZERO,  ONE,    MONE,   FN         /
     1        0.0,     0.0D0,   0,      1,      -1,     30*4H      /
      DATA    MTRX,    TBLE,    BLANK / 4HMTRX, 4HTBLE, 4H         /
      DATA    NONE  /  4H (NO,  4HNE) /
C
C     IF MACHINE IS CDC OR UNIVAC, CALL CDCOPN OR UNVOPN TO OPEN OUTPUT
C     FILE, A FORMATTED SEQUENTIAL TAPE.  NO CONTROL WORDS ARE TO BE
C     ADDED TO EACH FORMATTED RECORD. RECORD LENGTH IS 132 CHARACTERS,
C     AN ANSI STANDARD.
C
CWKBD IF (MACH .EQ. 3) CALL UNVOPN (P2)
CWKBD IF (MACH .EQ. 4) CALL CDCOPN (P2)
      BF = BINARY
      IF (P4 .GE. 1) BF = FORMTD
      CALL PAGE
      CALL PAGE2 (1)
      WRITE  (NOUT,3) UIM,BF,P1
 3    FORMAT (A29,', MODULE OUTPUT5 CALLED BY USER DMAP ALTER, ON ',A8,
     1        ' TAPE,', /5X,'WITH FOLLOWING REQUEST  (P1=',I2,1H))
      IF (P1 .EQ. -9) WRITE (NOUT,4)
      IF (P1 .EQ. -3) WRITE (NOUT,5)
      IF (P1 .EQ. -1) WRITE (NOUT,6)
      IF (P1 .EQ.  0) WRITE (NOUT,7)
      IF (P1 .GT.  0) WRITE (NOUT,8) P1
 4    FORMAT (5X,'WRITE AN INTERNAL E-O-F RECORD, FOLLOWED BY A SYSTEM',
     1       ' E-O-F MARK, AND REWIND OUTPUT TAPE')
 5    FORMAT (5X,'REWIND TAPE, PRINT DATA BLOCK NAMES AND THEN WRITE ',
     1        'AFTER THE LAST DATA BLOCK ON TAPE')
 6    FORMAT (5X,'REWIND, WRITE A TAPE HEADER RECORD, THEN FOLLOWED BY '
     1,       'DATA BLOCKS WRITING.',/5X,'AT END, NO EOF AND NO REWIND')
 7    FORMAT (5X,'DATA BLOCKS ARE WRITTEN STARTING AT CURRENT TAPE ',
     1        'POSITION. AT END, NO EOF AND NO REWIND')
 8    FORMAT (5X,'SKIP FORWARD',I4,' DATA BLOCKS BEFORE WRITING (TAPE ',
     1       'HEADER RECORD NOT COUNTED AS A DATA BLOCK).', /5X,
     2       'NO REWIND BEFORE SKIPPING. AT END, NO EOF AND NO REWIND')
C
      BUF1 = KORSZ(RZ(1)) - IBUF - 1
      IF (BUF1 .LE. 0) CALL MESAGE (-8,0,SUBNAM)
      OUT = P2
      WRT = 0
      LFN = -1
      IF (P1 .EQ. -3) LFN = 0
C
C     SET P4 FLAGS
C
C     SET P40  TO .TRUE. IF USER SPECIFIES P4 TO ZERO (BINARY)
C     SET P41  TO .TRUE. IF USER SPECIFIES P4 TO ONE  (FORMATTED)
C     SET P40D TO .TRUE. IF P40 IS TRUE AND DATA IS IN D.P.
C     SET P40S TO .TRUE. IF P40 IS TRUE AND DATA IS IN S.P.
C     SET P41D TO .TRUE. IF P41 IS TRUE AND DATA IS IN D.P.
C     SET P41S TO .TRUE. IF P41 IS TRUE AND DATA IS IN S.P.
C     SET P41C TO .TRUE. IF P4=2, AND RESET P41S AND P41D TO .FALSE.
C
      P40D = .FALSE.
      P41S = .FALSE.
      P41D = .FALSE.
      P41C =  P4.EQ.2 .AND. NBPW.GE.60
      P41  = .FALSE.
      IF (P4 .GE. 1) P41 = .TRUE.
CWKBNB
      CLOSE ( UNIT=OUT )
      IF ( P4 .NE. 0  ) GO TO 1
      OPEN ( UNIT=OUT, FILE=DSNAMES(OUT), FORM='UNFORMATTED'
     1      ,STATUS='UNKNOWN' )
      GO TO 2
1     CONTINUE
      OPEN ( UNIT=OUT, FILE=DSNAMES(OUT), STATUS='UNKNOWN' ) 
2     CONTINUE
CWKBNE
      IF (P41C) GO TO 10
      P41S =  P41
      IF (P41 ) P41D = .NOT.P41S
 10   P40  = .NOT.P41
      P40S =  P40
      IF (P40) P40D = .NOT.P40S
      IF (P1 .NE. -9) GO TO 20
C
C     FINAL CALL TO OUTPUT5
C
      IF (P40) WRITE (OUT    ) MONE,ONE,ONE,DZERO
      IF (P41) WRITE (OUT,290) MONE,ONE,ONE,DZERO
      ENDFILE OUT
      REWIND OUT
      RETURN
C
 20   IF (P1 .EQ. -3) GO TO 60
      IF (P1 .EQ. -1) GO TO 180
      IF (P1) 30,190,65
C
 30   WRITE  (NOUT,35) UFM,P1
 35   FORMAT (A23,' 4120, MODULE OUTPUT5 - ILLEGAL VALUE FOR FIRST ',
     1       'PARAMETER = ',I8)
 40   ERR = -37
 50   CALL MESAGE (ERR,INPUT,SUBNAM)
      RETURN
C
C     OLD TAPE. CHECK TAPE ID
C
 60   REWIND OUT
 65   IF (P40) READ (OUT,    END=150) TAPEID,NAME,DT,I,K
      IF (P41) READ (OUT,185,END=150) TAPEID,NAME,DT,I,K
      IF (TAPEID(1).EQ.P3(1) .AND. TAPEID(2).EQ.P3(2)) GO TO 70
      WRITE  (NOUT,67) TAPEID,P3
 67   FORMAT ('0*** WRONG TAPE MOUNTED - TAPEID =',2A4,', NOT ',2A4)
      GO TO 40
 70   CALL PAGE2 (6)
      WRITE  (NOUT,75) TAPEID,NAME,DT,I
 75   FORMAT (/5X,'MODULE OUTPUT5 IS PROCESSING TAPE ',2A4, /5X,
     1       'WRITTEN BY ',2A4, /5X,'ON ',I2,1H/,I2,1H/,I2,  /5X,
     2       'BUFFSIZE USED =',I7,/)
      IF (K .EQ. 0) WRITE (NOUT,80) BINARY
      IF (K .GE. 1) WRITE (NOUT,80) FORMTD
 80   FORMAT (5X,'ORIGINAL TAPE IS ',A8)
      IF (K .EQ. P4) GO TO 90
      WRITE  (NOUT,85) UFM,P4
 85   FORMAT (A23,', THE 4TH PARAMETER TO OUTPUT5 DOES NOT AGREE WITH ',
     1       'ORIG. TAPE FORMAT    P4=',I5,/)
      CALL MESAGE (-37,0,SUBNAM)
C
C     TO SKIP P1 MATRIX DATA BLOCKS OR TABLES ON THE OLD OUTPUT FILE
C     OR TO TABULATE TAPE CONTENTS IF P1 = -3
C
 90   LFN = 0
 100  IF (P40 ) READ (OUT,    ERR=160,END=150) NC,JB,JE
      IF (P41S) READ (OUT,280,ERR=100,END=150) NC,JB,JE,( X,J=JB,JE)
      IF (P41C) READ (OUT,285,ERR=100,END=150) NC,JB,JE,( X,J=JB,JE)
      IF (P41D) READ (OUT,290,ERR=100,END=150) NC,JB,JE,(DX,J=JB,JE)
      IF (NC) 140,120,100
 110  IF (P40 ) READ (OUT,    ERR=160,END=150) L
      IF (P41 ) READ (OUT,115,ERR=100,END=150) L,(TABLE,J=1,L)
 115  FORMAT (I10,24A5,/,(26A5))
      IF (L) 140,120,110
 120  IF (P1.NE.-3 .AND. LFN.GE.P1) GO TO 140
      LFN = LFN + 1
      BACKSPACE OUT
      IF (P41) BACKSPACE OUT
      IF (P40) READ (OUT    ) I,I,I,DX,J,J,J,J,K,K,FN(1,LFN),FN(2,LFN)
      IF (P41) READ (OUT,250) I,I,I,DX,J,J,J,J,K,K,FN(1,LFN),FN(2,LFN)
      IF (K.GT.0 .AND. J.GE.1 .AND. J.LE.4) GO TO 130
      FN(3,LFN) = TBLE
      GO TO 110
 130  FN(3,LFN) = MTRX
      IF (P40) GO TO 100
      P41S = .FALSE.
      P41D = .FALSE.
      P41C =  P4.EQ.2 .AND. NBPW.GE.60
      IF (P41C) GO TO 100
      IF (J.EQ.1 .OR. J.EQ.3) P41S = .TRUE.
      P41D = .NOT.P41S
      GO TO 100
 140  IF (P41) BACKSPACE OUT
 150  BACKSPACE OUT
      IF (P1.EQ.-3 .AND. LFN.GT.0) GO TO 430
      GO TO 200
C
 160  WRITE  (NOUT,170) UWM,TAPEID
 170  FORMAT (A25,' FROM OUTPUT5 MODULE. ERROR WHILE READING ',2A4)
      GO TO 40
C
C     NEW TAPE (P1=-1)
C
C     WRITE A TAPE IDENTIFICATION RECORD (NOTE -THIS IS THE ONLY TIME
C     A TAPE HEADER RECORD IS WRITTEN)
C
 180  IF (P1 .NE. -1) GO TO 200
      REWIND OUT
      TRL(1) = P3(1)
      TRL(2) = P3(2)
      TRL(3) = MCHNAM
      TRL(4) = BLANK
      TRL(5) = DATE(1)
      TRL(6) = DATE(2)
      TRL(7) = DATE(3)
      IF (P40) WRITE (OUT    ) (TRL(J),J=1,7),IBUF,P4
      IF (P41) WRITE (OUT,185) (TRL(J),J=1,7),IBUF,P4
 185  FORMAT (4A4,5I8)
 190  LFN = 0
C
C     COPY MATRICES OR TABLES OUT TO TAPE
C
 200  DO 400 MX = 1,5
      INPUT = MX + 100
      CALL FNAME (INPUT,NAME)
      IF (NAME(1).EQ.NONE(1) .AND. NAME(2).EQ.NONE(2)) GO TO 390
      TRL(1) = INPUT
      CALL RDTRL (TRL)
      IF (TRL(1) .LE. 0) GO TO 390
      IF (TRL(1) .GT. 0) GO TO 220
      CALL PAGE2 (3)
      WRITE  (NOUT,210) INPUT,NAME
 210  FORMAT (/5X,'INPUT FILE ',2A4,'(',I3,') IS PURGED. NO DATA ',
     1       'TRANSFERRED TO OUTPUT FILE')
      GO TO 400
 220  IF (TRL(4).GT.8 .OR. TRL(5).GT.4 .OR. TRL(6).LE.0 .OR. TRL(7).LE.0
     1   ) CALL TABLE5 (*400,INPUT,OUT,TRL,BUF1,WRT,LFN,FN)
      COL  = TRL(2)
      ROW  = TRL(3)
      TYPE = TRL(5)
      COMPLX = .FALSE.
      IF (TYPE .GE. 3) COMPLX = .TRUE.
C
C     CHECK FOR NULL MATRIX
C
      IF (ROW.EQ.0 .OR. COL.EQ.0 .OR. TYPE.EQ.0) GO TO 380
C
C     SET FLAGS FOR FORMATTED OR UNFORMATTED WRITE, SINGLE OR DOUBLE
C     PRECISION DATA, THEN WRITE THE MATRIX HEADER WITH PROPER FORMAT.
C     MATRIX HEADER CONSISTS OF ONE SCRATCH WORD, ORIGINAL MATRIX
C     TRAILER, AND MATRIX DMAP NAME
C
      P40S = .FALSE.
      P40D = .FALSE.
      P41S = .FALSE.
      P41D = .FALSE.
      P41C =  P4.EQ.2 .AND. NBPW.GE.60
      IF (P41) GO TO 230
      IF (TYPE.EQ.1 .OR. TYPE.EQ.3) P40S = .TRUE.
      P40D = .NOT.P40S
      GO TO 240
 230  IF (P41C) GO TO 240
      IF (TYPE.EQ.1 .OR. TYPE.EQ.3) P41S = .TRUE.
      P41D = .NOT.P41S
 240  IF (P40) WRITE (OUT    ) IZERO,ONE,ONE,DZERO,(TRL(K),K=2,7),NAME
      IF (P41) WRITE (OUT,250) IZERO,ONE,ONE,DZERO,(TRL(K),K=2,7),NAME
 250  FORMAT (3I8,/,D26.17,6I8,2A4)
      WRT = 1
C
C     OPEN INPUT DATA BLOCK AND SAVE DMAP NAME IN FN ARRAY
C
      ERR = -1
      CALL OPEN (*50,INPUT,RZ(BUF1),0)
      CALL FWDREC (*50,INPUT)
      IF (LFN.EQ.-1 .OR. LFN.GE.10) GO TO 260
      LFN = LFN + 1
      FN(1,LFN) = NAME(1)
      FN(2,LFN) = NAME(2)
      FN(3,LFN) = MTRX
C
C     UNPACK A MATRIX COLUMN, AND WRITE TO OUTPUT FILE THE BANDED DATA
C     (FROM FIRST TO LAST NON-ZERO ELEMENTS)
C
 260  ITYP = TYPE
      INCR = 1
      DO 320 NC = 1,COL
      II = 0
      JJ = 0
      CALL UNPACK (*300,INPUT,RZ)
      JB = II
      JE = JJ
      NWDS = JJ - II + 1
      IF (.NOT.COMPLX) GO TO 270
      NWDS = NWDS + NWDS
      JE   = NWDS + JB - 1
 270  IF (NWDS .GT. BUF1) CALL MESAGE (-8,0,SUBNAM)
      IF (P40S) WRITE (OUT) NC,JB,JE,(RZ(J),J=1,NWDS)
      IF (P40D) WRITE (OUT) NC,JB,JE,(DZ(J),J=1,NWDS)
      IF (P41S) WRITE (OUT,280,ERR=480) NC,JB,JE,(RZ(J),J=1,NWDS)
      IF (P41C) WRITE (OUT,285,ERR=480) NC,JB,JE,(RZ(J),J=1,NWDS)
      IF (P41D) WRITE (OUT,290,ERR=480) NC,JB,JE,(DZ(J),J=1,NWDS)
 280  FORMAT (3I8,/,(10E13.6))
 285  FORMAT (3I8,/,(5E26.17))
 290  FORMAT (3I8,/,(5D26.17))
      GO TO 320
C
C     A NULL COLUMN
C
 300  JE = 1
      IF (COMPLX) JE = 2
      IF (P40S) WRITE (OUT    ) NC,ONE,JE,( ZERO,I=1,JE)
      IF (P40D) WRITE (OUT    ) NC,ONE,JE,(DZERO,I=1,JE)
      IF (P41S) WRITE (OUT,280) NC,ONE,JE,( ZERO,I=1,JE)
      IF (P41C) WRITE (OUT,285) NC,ONE,JE,( ZERO,I=1,JE)
      IF (P41D) WRITE (OUT,290) NC,ONE,JE,(DZERO,I=1,JE)
 320  CONTINUE
C
C     CLOSE INPUT DATA BLOCK WITH REWIND.
C
      CALL CLOSE (INPUT,1)
      CALL PAGE2 (10)
      WRITE  (NOUT,350) NAME,OUT,(TRL(J),J=2,5),IBUF
 350  FORMAT (/5X,'MODULE OUTPUT5 UNPACKED MATRIX DATA BLOCK ',2A4,
     1       ' AND WROTE IT OUT TO', /5X,'FORTRAN UNIT',I4,
     2       ', IN BANDED DATA FORM (FIRST TO LAST NON-ZERO ELEMENTS)',
     3       /9X,'NO. OF COLS =',I8, /9X,'NO. OF ROWS =',I8, /16X,
     4       'FORM =',I8, /16X,'TYPE =',I8, /5X,'SYSTEM BUFFSIZE =',I8)
      IF (P40 ) WRITE (NOUT,360)
      IF (P41S) WRITE (NOUT,365)
      IF (P41C) WRITE (NOUT,370)
      IF (P41D) WRITE (NOUT,375)
 360  FORMAT (5X,'IN FORTRAN BINARY RECORDS')
 365  FORMAT (5X,'IN FORTRAN FORMATTED RECORDS - (3I8,/,(10E13.6))')
 370  FORMAT (5X,'IN FORTRAN FORMATTED RECORDS - (3I8,/,(5E26.17))')
 375  FORMAT (5X,'IN FORTRAN FORMATTED RECORDS - (3I8,/,(5D26.17))')
      GO TO 400
C
C     NULL MATRIX, OR GINO DATA BLOCK IS NOT A MTRIX FILE
C
 380  CALL PAGE2 (5)
      WRITE  (NOUT,385) UWM,NAME
 385  FORMAT (A25,' FROM OUTPUT5 MODULE. ',2A4,' IS EITHER A NULL ',
     1       'MATRIX OR NOT A MATRIX DATA BLOCK', /5X,
     2       'NO DATA WERE COPIED TO OUTPUT FILE',/)
      GO TO 400
C
 390  TRL(1) = INPUT + 1
      CALL RDTRL (TRL)
      IF (TRL(1) .GT. 0) WRITE (NOUT,395) UWM,INPUT,NAME
 395  FORMAT (A25,' FROM OUTPUT5 MODULE. INPUT DATA BLOCK',I5,2H, ,2A4,
     1       ' IS EITHER PURGED OR DOES NOT EXIST')
C
 400  CONTINUE
C
      IF (WRT .EQ. 0) WRITE (NOUT,410) UWM
 410  FORMAT (A25,' FROM OUTPUT5 MODULE. NO DATA BLOCK WRITTEN TO ',
     1        'OUTPUT FILE')
      ENDFILE OUT
      BACKSPACE OUT
      IF (P1 .EQ. -3) GO TO 460
C
C     PRINT LIST OF DATA BLOCKS ON FORTRAN TAPE (P1=-3).
C
      IF (LFN .LE. 0) RETURN
 430  CALL PAGE2 (LFN+10)
      WRITE  (NOUT,440) OUT,MCHNAM,BF,(J,FN(1,J),FN(2,J),FN(3,J),
     1                  J=1,LFN)
 440  FORMAT (/5X,'SUMMARY FROM OUTPUT5 MODULE', //16X,'DATA BLOCKS ',
     1       'WRITTEN TO FORTRAN UNIT',I4, /17X,'(BY ',A4,' MACHINE, ',
     2       A8,' RECORDS)', ///22X,'FILE',8X,'NAME',8X,'TYPE' /17X,
     3       9(4H----), /,(22X,I3,9X,2A4,4X,A4))
      IF (P1 .EQ. -3) GO TO 200
      IF (P40) GO TO 460
      CALL PAGE2 (2)
      WRITE  (NOUT,450)
 450  FORMAT (/5X,'THIS FORMATTED OUTPUT FILE CAN BE VIEWED OR EDITED',
     1        ' VIA SYSTEM EDITOR',/)
C
 460  IF (MACH .EQ. 3) CALL UNVCLS (P2)
      IF (MACH .EQ. 4) CALL CDCCLS (P2)
      RETURN
C
C     WRITE ERROR
C
 480  WRITE  (NOUT,490) SFM
 490  FORMAT (A25,' IN WRITING OUTPUT FILE', /5X,'IBM USER - CHECK FILE'
     1,      ' ASSIGNMENT FOR DCB PARAMETER OF 132 BYTES')
      CALL MESAGE (-37,0,SUBNAM)
      END

      SUBROUTINE TA1ETD (ELID,TI,GRIDS)
C
C     THIS ROUTINE (CALLED BY -TA1A- AND -TA1B-) READS ELEMENT
C     TEMPERATURE DATA FROM A PRE-POSITIONED RECORD
C
C     ELID   = ID OF ELEMENT FOR WHICH DATA IS DESIRED
C     TI     = BUFFER DATA IS TO BE RETURNED IN
C     GRIDS  = 0 IF EL-TEMP FORMAT DATA IS TO BE RETURNED
C            = NO. OF GRID POINTS IF GRID POINT DATA IS TO BE RETURNED.
C     ELTYPE = ELEMENT TYPE TO WHICH -ELID- BELONGS
C     OLDEL  = ELEMENT TYPE CURRENTLY BEING WORKED ON (INITIALLY 0)
C     OLDEID = ELEMENT ID FROM LAST CALL
C     EORFLG = .TRUE. WHEN ALL DATA HAS BEEN EXHAUSTED IN RECORD
C     ENDID  = .TRUE. WHEN ALL DATA HAS BEEN EXHAUSTED WITHIN AN ELEMENT
C              TYPE.
C     BUFFLG = NOT USED
C     ITEMP  = TEMPERATURE LOAD SET ID
C     IDEFT  = NOT USED
C     IDEFM  = NOT USED
C     RECORD = .TRUE. IF A RECORD OF DATA IS INITIALLY AVAILABLE
C     DEFALT = THE DEFALT TEMPERATURE VALUE OR -1 IF IT DOES NOT EXIST
C     AVRAGE = THE AVERAGE ELEMENT TEMPERATURE
C
      LOGICAL         EORFLG,ENDID ,BUFFLG,RECORD
      INTEGER         TI(2) ,OLDEID,GRIDS ,ELID  ,ELTYPE,OLDEL
      INTEGER         NAME(2)      ,GPTT  ,DEFALT
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /SYSTEM/ DUM   ,IOUT
      COMMON /TA1ETT/ ELTYPE,OLDEL ,EORFLG,ENDID ,BUFFLG
     1               ,ITEMP ,DEFALT,IBACK ,RECORD,OLDEID
      COMMON /TA1COM/ DUMMY(5)     ,GPTT
      DATA    NAME  / 4HTA1E,4HTD  /,MAXWDS/ 33 /
C
      IF (OLDEID .EQ. ELID) RETURN
      OLDEID = ELID
C
      IF (ITEMP .NE. 0) GO TO 20
      DO 10 I = 1,MAXWDS
   10 TI(I) = 0.0
      RETURN
C
   20 IF (.NOT.RECORD .OR. EORFLG) GO TO 50
   15 IF (ELTYPE .NE. OLDEL) GO TO 30
      IF (ENDID) GO TO 50
C
C     HERE WHEN ELTYPE IS AT HAND AND END OF THIS TYPE DATA
C     HAS NOT YET BEEN REACHED.  READ AN ELEMENT ID
C
   35 CALL READ (*5002,*5001,GPTT,ID,1,0,FLAG)
      IF (ID) 40,50,40
   40 IF (IABS(ID) .EQ. ELID) IF (ID) 51,51,70
      IF (ID) 35,35,45
   45 CALL READ (*5002,*5001,GPTT,TI,NWORDS,0,FLAG)
      GO TO 35
C
C     MATCH ON ELEMNT ID MADE AND IT WAS WITH DATA
C
   70 CALL READ (*5002,*5001,GPTT,TI,NWORDS,0,FLAG)
      RETURN
C
C     NO MORE DATA FOR THIS ELEMENT TYPE
C
   50 ENDID = .TRUE.
C
C     NO DATA FOR ELEMENT ID DESIRED, THUS USE DEFALT
C
   51 IF (DEFALT .EQ. -1) GO TO 100
      IF (GRIDS  .GT.  0) GO TO 75
      DO 80 I = 2,MAXWDS
   80 TI(I) = 0
      TI(1) = DEFALT
      IF (ELTYPE .EQ. 34) TI(2) = DEFALT
      RETURN
C
   75 DO 76 I = 1,GRIDS
   76 TI(I) = DEFALT
      TI(GRIDS+1) = DEFALT
      RETURN
C
C     NO TEMP DATA OR DEFALT
C
  100 WRITE  (IOUT,301) UFM,ELID,ITEMP
  301 FORMAT (A23,' 4016, THERE IS NO TEMPERATURE DATA FOR ELEMENT',I9,
     1       ' IN SET',I9 )
      CALL MESAGE (-61,0,0)
C
C     LOOK FOR MATCH ON ELTYPE (FIRST SKIP ANY UNUSED ELEMENT DATA)
C
   30 IF (ENDID) GO TO 32
   31 CALL READ (*5002,*5001,GPTT,ID,1,0,FLAG)
      IF (ID) 31,32,33
   33 CALL READ (*5002,*5001,GPTT,TI,NWORDS,0,FLAG)
      GO TO 31
C
C     READ ELTYPE AND COUNT
C
   32 CALL READ (*5002,*300,GPTT,TI,2,0,FLAG)
      OLDEL  = TI(1)
      NWORDS = TI(2)
      ENDID  = .FALSE.
      IBACK  = 1
      GO TO 15
C
C     END OF RECORD HIT
C
  300 EORFLG = .TRUE.
      GO TO 50
 5002 CALL MESAGE (-2,GPTT,NAME)
 5001 CALL MESAGE (-3,GPTT,NAME)
      RETURN
      END

      SUBROUTINE MXCID (*,Z,MSET,MSZE,NWDS,USET,GPL,SIL,BUF1)
C
C     THIS SUBROUTINE CREATES AN ARRAY AT Z(1) OF LENGTH MSZE*NWDS
C     WHICH CONTAINS THE EXTERNAL ID*10 + COMPONENT AT Z(1,M) FOR
C     EACH DEGREE OF FREEDOM BELONGING TO SET -MSET-.
C
C     OPEN CORE IS Z(1) TO Z(BUF1-1).   TWO  BUFFERS NEEDED.
C
C     NONSTANDARD RETURN IF TASK NOT COMPLETED.
C
C     IF THIS IS A SUBSTRUCTURING PROBLEM, MXCIDS SHOULD BE CALLED
C     INSTEAD
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        LSHIFT,ANDF,ORF
      INTEGER         FNAM(2),NAME(2),X(7),Z(1)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25,SWM*27
      COMMON /XMSSG / UFM,UWM,UIM,SFM,SWM
      COMMON /SYSTEM/ NBUFSZ,KOUTP
      COMMON /NAMES / KRD,KRDRW,KWR,KWRRW, KCLRW,KCL,KWEOF
      COMMON /BITPOS/ MASK2(32),HSET(32)
      COMMON /TWO   / ITWO(32)
      DATA    NSET  / 20   /
      DATA    NAME  , NONE / 4HMXCI,4HD   , 4H (NO  /
C
C     ALLOCATE CORE - CHECK DATA FILE AVAILABILITY
C
      BUF2 = BUF1 + NBUFSZ
      IF (NWDS .LE. 0) NWDS = 1
      LGP  = MSZE*NWDS + 1
      X(1) = SIL
      CALL FNAME (SIL,FNAM)
      IF (FNAM(1) .EQ. NONE) GO TO 220
      CALL RDTRL (X)
      NGP = X(2)
      LSIL= LGP + NGP
C
C     SEVEN WORDS NEEDED IF SIL AND USET OUT OF CORE
C
      IF (LSIL .GT. BUF1-7) GO TO 260
C
C     DETERMINE IF SIL (AND USET) FIT IN CORE
C
      LUSET = LSIL + NGP
      X(1)  = USET
      CALL FNAME (USET,FNAM)
      IF (FNAM(1) .EQ. NONE) GO TO 220
      CALL RDTRL (X)
      NDOF = X(3)
      L = ORF(LSHIFT(X(4),16),X(5))
C
      IF (LUSET+NDOF .GT. BUF1) LUSET = 0
      IF (LUSET .GT. BUF1) LSIL = 0
C
C     CHECK SET REQUEST
C
      DO 10 ISET = 1,NSET
      IF (HSET(ISET) .EQ. MSET) GO TO 20
   10 CONTINUE
       GO TO 240
   20 CONTINUE
      ISET = MASK2(ISET)
      ISET = ITWO(ISET)
      IF (ANDF(L,ISET) .EQ. 0) GO TO 240
C
C     LOAD GPL INTO CORE
C
      X(1) = GPL
      CALL OPEN (*220,GPL,Z(BUF2),KRDRW)
      CALL FREAD (GPL,0,0,1)
      CALL FREAD (GPL,Z(LGP),NGP,0)
      CALL CLOSE (GPL,KCL)
      X(1) = SIL
      CALL GOPEN (SIL,Z(BUF1),KRDRW)
      CALL GOPEN (USET,Z(BUF2),KRDRW)
C
C     LOAD SIL AND USET IF POSSIBLE
C
      IF (LSIL .EQ. 0) GO TO 30
      CALL FREAD (SIL,Z(LSIL),NGP,0)
      CALL CLOSE (SIL,KCL)
      SIL1 = Z(LSIL)
      PSIL = LSIL + 1
      I = NGP - 1
      GO TO 40
   30 CALL FREAD (SIL,SIL1,1,0)
      I = 1
      PSIL = LGP + NGP
   40 IF (LUSET .EQ. 0) GO TO 50
      CALL FREAD (USET,Z(LUSET),NDOF,0)
      CALL CLOSE (USET,KCL)
      PUSET = LUSET
   50 IF (LUSET .EQ. 0) PUSET = PSIL + I
C
C     PSIL POINTS SECOND SIL ENTRY IF SIL IN CORE, ELSE LOCATION TO USE
C     PUSET POINTS TO FIRST WORD USET, ELSE LOCATION IN Z TO USE
C     LSIL, LUSET ARE ZERO IF FILES NOT IN CORE.
C     LOOP ON NUMBER GRID POINTS - EXIT WHEN MSIZE ACHIEVED.
C
      MCOUNT = 1
C
      DO  130 LLL = 1,NGP
      IF (LLL .EQ. NGP) GO TO 60
      IF (LSIL.NE.   0) GO TO 70
      CALL FREAD (SIL,Z(PSIL),1,0)
      GO TO 70
   60 SIL2 = NDOF + 1
      GO TO 80
   70 SIL2 = Z(PSIL)
      IF (LSIL .NE. 0) PSIL = PSIL + 1
   80 NDF = SIL2 - SIL1
      IF (NDF.LT.1 .OR. NDF.GT.6) GO TO 240
C
C     GET NDF WORDS FROM USET
C
      IF (LUSET .EQ. 0) CALL FREAD (USET,Z(PUSET),NDF,0)
C
C     DETERMINE IF IN THE SET
C
      J = PUSET
      K = J + NDF - 1
  100 CONTINUE
      DO 110 I = J,K
      IF (ANDF(Z(I),ISET) .NE. 0) GO TO 120
  110 CONTINUE
       GO TO 125
C
C     LOCATED A POINT IN THE SET
C
  120 CONTINUE
      LL = I - PUSET + 1
      L  = LGP + LLL - 1
      IF (NDF .EQ. 1) LL = 0
      Z(MCOUNT) = Z(L)*10 + LL
      MCOUNT = MCOUNT + NWDS
      IF (MCOUNT .GE. LGP) GO TO 310
      IF (I .EQ. K) GO TO 125
      J = I + 1
       GO TO 100
  125 IF (LUSET .NE. 0) PUSET = PUSET + NDF
      SIL1 = SIL2
  130 CONTINUE
C
C     END OF ALL GRIDS AND MATRIX NOT FILLED - NEED IMMEDIATE MESSAGE.
C
      CALL PAGE2 (2)
      WRITE  (KOUTP,210) SWM,NAME
  210 FORMAT (A27,' 3016, MATRIX IS NOT IN PROPER FORM IN SUBROUTINE ',
     1        2A4)
      GO TO 300
C
C     PURGED FILES
C
  220 CALL PAGE2 (2)
      WRITE  (KOUTP,230) SWM,X(1),NAME
  230 FORMAT (A27,' 3001, ATTEMPT TO OPEN DATA SET',I4,' IN SUBROUTINE',
     1        1X,2A4,' WHICH WAS NOT DEFINED IN FIST')
      GO TO 300
C
C     ILLEGAL INPUT
C
  240 CALL PAGE2 (2)
      WRITE  (KOUTP,250) SWM,NAME
  250 FORMAT (A27,' 3007, ILLEGAL INPUT TO SUBROUTINE ',2A4)
      GO TO 300
C
C     INSUFFICIENT CORE
C
  260 CALL PAGE2 (2)
      WRITE  (KOUTP,270) SWM,NAME
  270 FORMAT (A27,' 3008, INSUFFICIENT CORE AVAILABLE FOR SUBROUTINE ',
     1        2A4, 1H.)
C
  300 CONTINUE
      CALL CLOSE (SIL ,KCL)
      CALL CLOSE (USET,KCL)
      RETURN 1
  310 CONTINUE
      CALL CLOSE (SIL ,KCL)
      CALL CLOSE (USET,KCL)
      RETURN
      END

      SUBROUTINE DPSE4
C
C     PRESSURE STIFFNESS CALCULATIONS FOR A QUADRILATERAL MEMBRANE
C     ELEMENT, WHICH HAS 4 GRID POINTS.
C     THREE 6X6 STIFFNESS MATRICES FOR THE PIVOT POINT ARE INSERTED.
C
C     DOUBLE PRECISION VERSION
C
C     WRITTEN BY E. R. CHRISTENSEN/SVERDRUP,  9/91,  VERSION 1.1
C     INSTALLED IN NASTRAN AS ELEMENT DPSE4 BY G.CHAN/UNISYS, 2/92
C
C     REFERENCE - E. CHRISTENEN: 'ADVACED SOLID ROCKET MOTOR (ASRM)
C                 MATH MODELS - PRESSURE STIFFNESS EFFECTS ANALYSIS',
C                 NASA TD 612-001-02, AUGUST 1991
C
C     LIMITATION -
C     (1) ALL GRID POINTS USED BY ANY OF THE CPSE2/3/4 ELEMENTS MUST BE
C         IN BASIC COORDINATE SYSTEM!!!
C     (2) CONSTANT PRESSURE APPLIED OVER AN ENCLOSED VOLUMN ENCOMPASSED
C         BY THE CPSE2/3/4 ELEMENTRS
C     (3) PRESSURE ACTS NORMALLY TO THE CPSE2/3/4 SURFACES
C
C     SEE NASTRAN DEMONSTRATION PROBLEM -  T13022A
C
      DOUBLE PRECISION GAMMA,KIJ,DP,C,SIGN
      DIMENSION        NECPT(6)
C     COMMON /SYSTEM/  IBUF,NOUT
      COMMON /DS1AAA/  NPVT,ICSTM,NCSTM
      COMMON /DS1AET/  ECPT(26),DUM2(2),DUM12(12)
      COMMON /DS1ADP/  GAMMA,KIJ(36),DP(26),C(12),SIGN(3),NK(3),IK(3)
      EQUIVALENCE      (NECPT(1),ECPT(1))
C
C     ECPT FOR THE PRESSURE STIFFNESS CPES4 ELEMENT
C
C     ECPT( 1) = ELEMENT ID
C     ECPT( 2) = SIL FOR GRID POINT A OR 1
C     ECPT( 3) = SIL FOR GRID POINT B OR 2
C     ECPT( 4) = SIL FOR GRID POINT C OR 3
C     ECPT( 5) = SIL FOR GRID POINT C OR 4
C     ECPT( 6) = PRESSURE
C     ECPT( 7) = NOT USED
C     ECPT( 8) = NOT USED
C     ECPT( 9) = NOT USED
C     ECPT(10) = COORD. SYSTEM ID 1
C     ECPT(11) = X1
C     ECPT(12) = Y1
C     ECPT(13) = Z1
C     ECPT(14) = COORD. SYSTEM ID 2
C     ECPT(15) = X2
C     ECPT(16) = Y2
C     ECPT(17) = Z2
C     ECPT(18) = COORD. SYSTEM ID 3
C     ECPT(19) = X3
C     ECPT(20) = Y3
C     ECPT(21) = Z3
C     ECPT(22) = COORD. SYSTEM ID 4
C     ECPT(23) = X4
C     ECPT(24) = Y4
C     ECPT(25) = Z4
C     ECPT(26) = ELEMENT TEMPERATURE
C     ECPT(27) THRU ECPT(40) = DUM2 AND DUM12, NOT USED IN THIS ROUTINE
C
C     STORE ECPT IN DOUBLE PRECISION
C
      DP(6) = ECPT(6)
      K = 10
      DO 20 I = 1,4
      DO 10 J = 1,3
      K = K + 1
   10 DP(K) = ECPT(K)
   20 K = K + 1
C
C     CALCULATE THE FOUR VECTORS GAB, GAC, GAD, AND GBD USED IN
C     COMPUTING THE PRESSURE STIFFNESS MATRIC
C
C     GAB = RA + RB - RC - RD
C     GAC = RB - RD
C     GAD =-RA + RB + RC - RD
C     GBD =-RA + RC
C
C     GAB STORED IN C( 1), C( 2), C( 3)
C     GAC STORED IN C( 4), C( 5), C( 6)
C     GAD STORED IN C( 7), C( 8), C( 9)
C     GBD STORED IN C(10), C(11), C(12)
C
      C(1) = DP(11) + DP(15) - DP(19) - DP(23)
      C(2) = DP(12) + DP(16) - DP(20) - DP(24)
      C(3) = DP(13) + DP(17) - DP(21) - DP(25)
C
      C(4) = DP(15) - DP(23)
      C(5) = DP(16) - DP(24)
      C(6) = DP(17) - DP(25)
C
      C(7) =-DP(11) + DP(15) + DP(19) - DP(23)
      C(8) =-DP(12) + DP(16) + DP(20) - DP(24)
      C(9) =-DP(13) + DP(17) + DP(21) - DP(25)
C
      C(10)=-DP(11) + DP(19)
      C(11)=-DP(12) + DP(20)
      C(12)=-DP(13) + DP(21)
C
      DO 30 I = 1,4
      IF (NECPT(I+1) .NE. NPVT) GO TO 30
      NPIVOT = I
      GO TO 40
   30 CONTINUE
      RETURN
C
C     GENERATE THE THREE BY THREE PARTITIONS IN GLOBAL COORDINATES HERE
C
C     SET COUNTERS ACCORDING TO WHICH GRID POINT IS THE PIVOT
C
   40 IF (NPIVOT .EQ. 4) GO TO 80
      IF (NPIVOT-2) 50,60,70
C
C     SET COUNTERS AND POINTERS FOR CALCULATING KAB, KAC, KAD
C
   50 NK(1) = 2
      NK(2) = 3
      NK(3) = 4
      IK(1) = 1
      IK(2) = 4
      IK(3) = 7
      SIGN(1) = 1.0D0
      SIGN(2) = 1.0D0
      SIGN(3) = 1.0D0
      GO TO 90
C
C     SET COUNTERS AND POINTERS FOR CALCULATING KBA, KBC, KBD
C     NOTE THAT KBA = -KAB
C
   60 NK(1) = 1
      NK(2) = 3
      NK(3) = 4
      IK(1) = 1
      IK(2) = 7
      IK(3) = 10
      SIGN(1) =-1.0D0
      SIGN(2) = 1.0D0
      SIGN(3) = 1.0D0
      GO TO 90
C
C     SET COUNTERS AND POINTERS FOR CALCULATING KCA, KCB, KCD
C     NOTE THAT KCA = -KAC, KCB = -KBC
C
   70 NK(1) = 1
      NK(2) = 2
      NK(3) = 4
      IK(1) = 4
      IK(2) = 7
      IK(3) = 1
      SIGN(1) =-1.0D0
      SIGN(2) =-1.0D0
      SIGN(3) =-1.0D0
      GO TO 90
C
   80 NK(1) = 1
      NK(2) = 2
      NK(3) = 3
      IK(1) = 7
      IK(2) = 10
      IK(3) = 1
      SIGN(1) =-1.0D0
      SIGN(2) =-1.0D0
      SIGN(3) = 1.0D0
C
   90 GAMMA =-DP(6)/12.0D0
      DO 110 I = 1,3
      DO 100 J = 1,36
  100 KIJ(J) = 0.0D0
      K1 = IK(I)
      K2 = K1 + 1
      K3 = K1 + 2
      SG = GAMMA*SIGN(I)
      KIJ( 2) =-C(K3)*SG
      KIJ( 3) = C(K2)*SG
      KIJ( 7) = C(K3)*SG
      KIJ( 9) =-C(K1)*SG
      KIJ(13) =-C(K2)*SG
      KIJ(14) = C(K1)*SG
C
C     ASSEMBLE INTO THE GLOBAL STIFFNESS MATRIX
C
      IAS = NK(I)
      CALL DS1B (KIJ(1),NECPT(IAS+1))
  110 CONTINUE
C
      RETURN
      END

      SUBROUTINE EMGTAB
C*****
C     THIS ROUTINE OF THE -EMG- MODULE PREPARES OPEN CORE WITH SOME
C     VARIOUS TABLES.  CSTM, MAT, ETC.
C
C     UTILITY ROUTINES ARE USED FOR THE MOST PART.
C*****
      LOGICAL         ANYCON, ERROR, HEAT
      INTEGER         RDREW, WRT, WRTREW, CLS, CLSREW, BUF1, SUBR(2),
     1                PRECIS, SYSBUF, EST, CSTM, DIT, GEOM2, Z, FILE,
     2                EOR, RD, FLAGS, DITFIL
      COMMON /SYSTEM/ KSYSTM(65)
      COMMON /NAMES / RD, RDREW, WRT, WRTREW, CLSREW, CLS
      COMMON /EMGPRM/ ICORE, JCORE, NCORE, ICSTM, NCSTM, IMAT, NMAT,
     1                IHMAT, NHMAT, IDIT, NDIT, ICONG, NCONG, LCONG,
     2                ANYCON, FLAGS(3), PRECIS, ERROR, HEAT
     3               ,ICMBAR, LCSTM, LMAT, LHMAT
      COMMON /EMGFIL/ EST, CSTM, MPT, DIT, GEOM2
      COMMON /HMATDD/ IIHMAT, NNHMAT, MPTFIL, DITFIL
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE     (KSYSTM(1), SYSBUF)
      DATA    SUBR  / 4HEMGT,  4HAB  /,   EOR/ 1 /
C*****
C     READ -CSTM- INTO CORE.
C*****
      BUF1 = NCORE - SYSBUF - 2
      ICRQ = JCORE - BUF1
      IF (BUF1 .LE. JCORE) GO TO 10
      ICSTM = JCORE
      NCSTM = JCORE - 1
      FILE  = CSTM
      CALL OPEN (*30,CSTM,Z(BUF1),RDREW)
      CALL FWDREC (*30,CSTM)
      CALL READ (*60,*20,CSTM,Z(ICSTM),BUF1-JCORE,EOR,LCSTM)
      ICRQ = BUF1 - JCORE
   10 CALL MESAGE (-8,ICRQ,SUBR)
   20 CALL CLOSE (CSTM,CLSREW)
      NCSTM = ICSTM + LCSTM - 1
      CALL PRETRS (Z(ICSTM),LCSTM)
      CALL PRETRD (Z(ICSTM),LCSTM)
C*****
C     HAMT AND PREMAT
C*****
   30 IF (.NOT.HEAT) GO TO 40
C
C     HEAT PROBLEM THUS USE -HMAT-
C
      IMAT   = NCSTM + 1
      NMAT   = NCSTM
      IIHMAT = NMAT
      NNHMAT = NCORE
      MPTFIL = MPT
      DITFIL = DIT
      CALL PREHMA (Z)
      IHMAT = IIHMAT
      NHMAT = NNHMAT
      LHMAT = NHMAT - IHMAT
      JCORE = NHMAT + 1
      GO TO 50
C
C     NON-HEAT PROBLEM THUS USE -MAT-
C
   40 IMAT = NCSTM + 1
      CALL PREMAT (Z(IMAT),Z(IMAT),Z(BUF1),BUF1-IMAT,LMAT,MPT,DIT)
      NMAT  = IMAT + LMAT - 1
      IHMAT = NMAT + 1
      NHMAT = NMAT
      JCORE = NHMAT + 1
C
   50 CONTINUE
      RETURN
C
   60 CALL MESAGE (-2,FILE,SUBR)
      RETURN
      END

      SUBROUTINE BORDER (GPLST,X,U,ISTORE,DEFORM,B1,OPCOR)
C
      INTEGER        GPLST(1),DEFORM,OPCOR,SCR2,WORDS(2),ELID,B1,SCR4
      REAL           X(3,1),U(2,1)
      DIMENSION      PT(2,3),ISTORE(2)
      COMMON /BLANK/ SKIP(25),SCR2,SCR3,SCR4
      EQUIVALENCE    (WORDS(1),NELMT),(WORDS(2),IGDPT)
C
      LCOR = OPCOR/5 - 1
      CALL OPEN (*150,SCR2,GPLST(B1),0)
      CALL LINE (0.,0.,0.,0.,1,-1)
    9 CALL FWDREC (*100,SCR2)
   10 CALL READ (*100,*9,SCR2,IFLAG,1,0,M)
      IF (IFLAG .EQ.  0) GO TO 100
      IF (IFLAG .EQ. -1) GO TO 9
      CALL FREAD (SCR2,WORDS,2,0)
      IE = -1
   20 IE = IE + 2
      CALL READ (*100,*30,SCR2,ELID,1,0,M)
      CALL FREAD (SCR2,ISTORE(IE),2,0)
      GO TO 20
   30 IONE = ISTORE(1)
      ITWO = ISTORE(2)
      IF (NELMT .EQ. 1) GO TO 50
      IE = 2*NELMT
      IE1= IE - 1
      DO 37 I = 1,IE1
      IF (ISTORE(I) .EQ. 0) GO TO 37
      IP1 = I + 1
      DO 36 J = IP1,IE
      IF (ISTORE(I) .NE. ISTORE(J)) GO TO 36
      ISTORE(I) = 0
      ISTORE(J) = 0
      GO TO 37
   36 CONTINUE
   37 CONTINUE
      J = 0
      DO 40 I = 1,IE
      IF (ISTORE(I) .EQ. 0) GO TO 40
      J = J + 1
      IF (J-1) 38,38,39
   38 IONE = ISTORE(I)
      GO TO 40
   39 ITWO = ISTORE(I)
   40 CONTINUE
      IF (J .EQ. 0) GO TO 10
   50 IG = IABS(GPLST(IGDPT))
      IF (DEFORM .NE. 0) GO TO 57
      PT(1,3) = X(2,IG)
      PT(2,3) = X(3,IG)
      GO TO 60
   57 PT(1,3) = U(1,IG)
      PT(2,3) = U(2,IG)
   60 IG = IONE
      DO 65 I = 1,2
      IG = IABS(GPLST(IG))
      IF (DEFORM .NE. 0) GO TO 63
      PT(1,I) = X(2,IG)
      PT(2,I) = X(3,IG)
      GO TO 64
   63 PT(1,I) = U(1,IG)
      PT(2,I) = U(2,IG)
   64 CALL LINE (PT(1,I),PT(2,I),PT(1,3),PT(2,3),1,0)
      IG = ITWO
   65 CONTINUE
      GO TO 10
  100 CALL LINE (0.,0.,0.,0.,1,+1)
      CALL CLOSE (SCR2,1)
  150 RETURN
      END

      SUBROUTINE HBDY (ECPT,NECPT,IOPT,RVECT,IVECT)
C
C     THIS SUBROUTINE CALCULATES THE GEOMETRIC PROPERTIES OF THE VARIOUS
C     TYPES OF HBDY ELEMENTS. IOPT IS DESCRIBED BELOW
C
C     THE ECPT INPUT DATA IS
C
C     POSITION    DATA
C        1       EL ID
C        2       FLAG
C        3       SIL-1
C        4       SIL-2
C        5       SIL-3
C        6       SIL-4
C        7       SIL-5
C        8       SIL-6
C        9       SIL-7
C       10       SIL-8
C       11       VECTOR V1
C       12       VECTOR V2
C       13       VECTOR V3
C       14       ECPT14
C       15       MAT ID
C       16       A-FACTOR
C       17       EMISSIVITY
C       18       ABSORBTIVIY
C       19       R1
C       20       R2
C       21       CS-1
C       22       X1
C       23       Y1
C       24       Z1
C       25       CS-2
C       26       X2
C       27       Y2
C       28       Z2
C       29       CS-3
C       30       X3
C       31       Y3
C       32       Z3
C       33       CS-4
C       34       X4
C       35       Y4
C       36       Z4
C       37-52    NOT USED
C       53       AVG. EL. TEMP.
C
C     THE VALUE OF FLAG INDICATES THE TYPE OF ELEMENT
C
C       FLAG     TYPE
C       ****     ****
C        1       POINT
C        2       LINE
C        3       REV
C        4       TRIANGLE
C        5       QUADRILATERAL
C        6       ELLIPTIC CYLINDER
C        7       FTUBE
C
C
C     THE OUTPUT DATA IS PLACED IN  VECT AND IVECT
C         THE FORMATS ARE
C
C     POSITION
C          IOPT=  1             2
C      1        EL ID         EL ID
C      2        AREA          AREA
C      3        EMIS          SIL-1
C      4        ---           SIL-2
C      5        SIL-1         SIL-3
C      6        SIL-2         SIL-4
C      7        SIL-3         AREA-1
C      8        SIL-4         AREA-2
C      9        GFACT-1       AREA-3
C     10        GFACT-2       AREA-4
C     11        GFACT-3       N1X
C     12        GFACT-4       N1Y
C     13                      N1Z
C     14                      N2X  -  FOR FLAG = 6 ONLY
C     15                      N2Y  -
C     16                      N2Z  -
C
C
      INTEGER         NECPT(5),IVECT(5),FLAG
      REAL            ECPT(36),DXYZ(3),RVECT(16),V(3)
      CHARACTER       UFM*23,UWM*25
      COMMON /XMSSG / UFM,UWM
      COMMON /CONDAS/ CONSTS(5)
      EQUIVALENCE     (CONSTS(1),PI), (DXYZ(1),DX), (DXYZ(2),DY),
     1                (DXYZ(3),DZ)
C
C
      DO 10 I = 1,16
      RVECT(I) = 0.0
   10 IVECT(I) = 0
      IVECT(1) = NECPT(1)
      FLAG = NECPT(2)
      IF (FLAG.LE.0 .OR. FLAG.GT. 7) GO TO 210
      IF (FLAG .EQ. 7) ECPT(16) = PI*(ECPT(19) + ECPT(20))
C
      GO TO (20,30,40,50,60,90,30), FLAG
C
C     FLAG = POINT
C
   20 IVECT(3) = NECPT(3)
      RVECT(7) = ECPT(16)
      RVECT(2) = ECPT(16)
      CALL SANORM (*110,ECPT(11))
      NPTS = 1
      GO TO 110
C
C     FLAG = LINE
C
   30 IVECT(3) = NECPT(3)
      IVECT(4) = NECPT(4)
      NPTS = 2
      DX = ECPT(26) - ECPT(22)
      DY = ECPT(27) - ECPT(23)
      DZ = ECPT(28) - ECPT(24)
C
      TEMP = DX**2 + DY**2 + DZ**2
      IF (TEMP .LE. 1.0E-20) GO TO 210
C
C     AREA CALCULATIONS
C
      RVECT(2) = ECPT(16)*SQRT(TEMP)
      RVECT(7) = RVECT(2)*0.5
      RVECT(8) = RVECT(7)
C
C     NORMAL VECTOR CALCULATIONS
C
      TEMP  =(DX*ECPT(11) + DY*ECPT(12) + DZ*ECPT(13))/TEMP
      RVECT(11) = ECPT(11) - TEMP*DX
      RVECT(12) = ECPT(12) - TEMP*DY
      RVECT(13) = ECPT(13) - TEMP*DZ
C
C     NORMALIZE
C
      CALL SANORM (*110,RVECT(11))
      GO TO 110
C
C     TYPE= REV
C
   40 IVECT(3) = NECPT(3)
      IVECT(4) = NECPT(4)
      NPTS = 2
      DX = ECPT(26) - ECPT(22)
      DZ = ECPT(28) - ECPT(24)
      TEMP = SQRT(DX**2 +DZ**2)*PI
      IF (TEMP .LE. 1.0E-20) GO TO 210
      RVECT(7) = (2.0*ECPT(22) + ECPT(26))*TEMP/3.0
      RVECT(8) = (2.0*ECPT(26) + ECPT(22))*TEMP/3.0
      RVECT(2) =  RVECT(7) + RVECT(8)
C
      TEMP = TEMP/PI
      RVECT(11) = DZ/TEMP
      RVECT(13) =-DX/TEMP
      GO TO 110
C
C     FLAG = AREA3
C
   50 IVECT(3) = NECPT(3)
      IVECT(4) = NECPT(4)
      IVECT(5) = NECPT(5)
      NPTS = 3
      DX = ECPT(26) - ECPT(22)
      DY = ECPT(27) - ECPT(23)
      DZ = ECPT(28) - ECPT(24)
      RVECT(7) = ECPT(30) - ECPT(26)
      RVECT(8) = ECPT(31) - ECPT(27)
      RVECT(9) = ECPT(32) - ECPT(28)
C
C     CALC. NORMAL VECTOR
C
      CALL SAXB (DXYZ,RVECT(7),RVECT(11))
C
      CALL SANORM (*210,RVECT(11))
C
      RVECT(2) = TEMP/2.0
      RVECT(7) = TEMP/6.0
      RVECT(8) = RVECT(7)
      RVECT(9) = RVECT(7)
C
      GO TO 110
C
C     FLAG = AREA4
C
   60 DO 70 I = 3,6
   70 IVECT(I) = NECPT(I)
      NPTS = 4
      DO 80 I = 1,3
C
C     CALCULATE  DIFFERENCE VECTORS
C
C        R2 - R1
C
      RVECT(I+6) = ECPT(I+25) - ECPT(I+21)
C
C        R3 - R1
C
      RVECT(I+13) = ECPT(I+29) - ECPT(I+21)
C
C        R4 - R2
C
      V(I) = ECPT(I+33) - ECPT(I+25)
   80 CONTINUE
C
C        (R3 - R1) X (R4 - R2)
C
      CALL SAXB (RVECT(14),V,RVECT(11))
C
C     2*AREA
C
      TEMP  = SQRT(RVECT(11)**2 + RVECT(12)**2 + RVECT(13)**2)
      RVECT(2) = TEMP/2.0
C
C     NORMALIZE
C
      CALL SANORM (*210,RVECT(11))
C
      CALL SAXB (RVECT(7),RVECT(14),DXYZ)
C
C     AREA OF TRIANGLE 123
C
      TEMP = SQRT(DX**2 + DY**2 + DZ**2)/2.0
C
      CALL SAXB (RVECT(7),V,DXYZ)
C
C     AREA OF TRIANGLE 412
C
      DX =  SQRT(DX**2 + DY**2 + DZ**2)/2.0
C
C     AREA FOR POINTS
C
      RVECT( 7) = (RVECT(2)+DX   )/6.0
      RVECT( 8) = (RVECT(2)+TEMP )/6.0
      RVECT( 9) = (RVECT(2)*2.-DX)/6.0
      RVECT(10) = (RVECT(2)*2.-TEMP)/6.0
      RVECT(14) = 0.0
      RVECT(15) = 0.0
      RVECT(16) = 0.0
      NPTS = 4
      GO TO 110
C
C     FLAG = ELCYL
C
   90 IVECT(3) = NECPT(3)
      IVECT(4) = NECPT(4)
      NPTS = 2
      DX = ECPT(26) - ECPT(22)
      DY = ECPT(27) - ECPT(23)
      DZ = ECPT(28) - ECPT(24)
      TEMP = SQRT(DX**2 + DY**2 + DZ**2)
      RVECT(2) = TEMP*ECPT(16)
      IF (IOPT .EQ. 3) RVECT(2) = TEMP
      IF (TEMP .LE. 0) GO TO 210
      CALL SAXB (ECPT(11),DXYZ,RVECT(14))
      CALL SAXB (DXYZ,RVECT(14),RVECT(11))
C
      CALL SANORM (*210,RVECT(11))
      CALL SANORM (*210,RVECT(14))
      DO 100 I = 1,3
      RVECT(I+10) = RVECT(I+10)*ECPT(20)
  100 RVECT(I+13) = RVECT(I+13)*ECPT(19)
      RVECT(7) = RVECT(2)/2.0
      RVECT(8) = RVECT(7)
C
C     IOPT EQUALS 1
C     CALCULATE G FACTORS. STORE IN NEW LOCATIONS.
C     WORK FROM LAST TO FIRST
C
C     CHECK FOR ZERO AREA
C
  110 AREA = RVECT(2)
      IF (AREA .LT. 1.0E-20) GO TO 210
  120 IF (IOPT .GT.       1) GO TO 170
      DO 130 I = 1,NPTS
      J = NPTS - I + 1
  130 RVECT(J+8) =  RVECT(J+6)/AREA
C
      DO 160 I = 1,4
      J =  5-I
      IF (J -NPTS) 150,150,140
  140 IVECT(J+4) = 0
      GO TO 160
  150 IVECT(J+4) = IVECT(J+2)
  160 CONTINUE
C
C     STORE EMISSIVITY VALUE
C
      RVECT(3) = ECPT(17)
      RETURN
C
C     IOPT EQUALS 2
C
  170 IF (IOPT .EQ. 2) RETURN
      DO 180 I = 1,NPTS
      RVECT(I+6) = RVECT(I+6)*ECPT(18)
  180 CONTINUE
      RETURN
C
  210 WRITE  (6,220) UWM,NECPT(1)
  220 FORMAT (A25,' 2154, ZERO AREA OR ILLEGAL CONNECTION FOR HBDY ',
     1       'ELEMENT NUMBER',I9)
      AREA = 1.0
      GO TO 120
      END

      SUBROUTINE CYCT2B (INPUT,OUTPT,NCOL,IZ,MCB)
C
C     THE PURPOSE OF THIS SUBROUTINE IS TO COPY NCOL COLUMNS FROM
C     INPUT TO OUTPUT USING CORE AT IZ -- MCB IS THE TRAILER
C
      INTEGER         OUTPT,IZ(4),MCB(7)
      COMMON /UNPAKX/ ITC,IIK,JJK,INCR1
      COMMON /PACKX / ITA,ITB,II,JJ,INCR
      EQUIVALENCE     (ZERO,IZERO)
      DATA    ZERO  / 0.0 /
C
C
      ITA = IABS(ITC)
      ITB = ITA
      INCR= INCR1
      DO 30 I = 1,NCOL
      IIK = 0
      CALL UNPACK (*20,INPUT,IZ)
      II  = IIK
      JJ  = JJK
   10 CALL PACK (IZ,OUTPT,MCB)
      GO TO 30
C
C     NULL COLUMN
C
   20 II = 1
      JJ = 1
      IZ(1) = IZERO
      IZ(2) = IZERO
      IZ(3) = IZERO
      IZ(4) = IZERO
      GO TO 10
   30 CONTINUE
C
      RETURN
      END

      SUBROUTINE CYCT1
C
C     GENERATE CYCLIC TRANSFORMATION MATRIX, TRANSFORM VECTORS
C
C     DMAP CALLING SEQUENCE
C
C     CYCT1   VIN/VOUT,GCYC/V,Y,CTYPE/V,Y,CDIR/V,Y,N/V,Y,KMAX/
C             V,Y,NLOAD/V,N,NOGO $
C
      LOGICAL          LBACK, LCOS, LDRL, LDSA, LNMULT, LVIN, LVOUT
      INTEGER          BUF, CDIR, CTYPE, GCYC, HBACK, HDRL, HDSA, HROT,
     1                 IZ, MCB(7), PKIN, PKINCR, PKIROW, PKNROW, PKOUT,
     2                 PRECIS, SCRT, SUBR(2), SYSBUF, VIN, VOUT, OUTPT
      REAL             RZ(1)
      DOUBLE PRECISION DC, DC1, DFAC, DFAK, DS, DS1, DZ(1)
      CHARACTER        UFM*23
      COMMON /XMSSG /  UFM
      COMMON /SYSTEM/  KSYSTM(65)
      COMMON /PACKX /  PKIN,PKOUT,PKIROW,PKNROW,PKINCR
      COMMON /ZZZZZZ/  IZ(1)
      COMMON /BLANK /  CTYPE(2),CDIR(2),NN,KMAXI,NLOAD,NOGO
      EQUIVALENCE      (KSYSTM( 1),SYSBUF), (KSYSTM( 2) ,OUTPT),
     1                 (KSYSTM(55),IPREC ), (IZ(1),RZ(1),DZ(1))
      DATA    SUBR  /  4HCYCT, 4H1   /,   HBACK  /  4HBACK    /
      DATA    VIN   /  101  /, VOUT,GCYC /201,202/, SCRT  /301/
      DATA    HROT  ,  HDRL  , HDSA  /4HROT ,4HDRL ,4HDSA     /
C
C
C     FIND NECESSARY PARAMETERS
C
      NOGO   = 1
      PRECIS = 2
      IF (IPREC .NE. 2) PRECIS = 1
      LDRL = CTYPE(1).EQ.HDRL
      LDSA = CTYPE(1).EQ.HDSA
      IF (.NOT.((CTYPE(1).EQ.HROT) .OR. LDRL.OR.LDSA)) GO TO 310
   10 LBACK = CDIR(1).EQ.HBACK
C
C     CURRENT DOCUMENTED USAGE DOES NOT USE NEGATIVE VALUES OF KMAXI
C     OTHER THAN THE DEFAULT OF -1     10/02/73
C     LOGIC IS INCLUDED IN THE ROUTINE TO USE NEGATIVE KMAXI BUT IS NOT
C     FULLY CHECKED OUT.  THE FOLLOWING STATEMENT NEGATES ALL THIS LOGIC
C
      IF (KMAXI .LT. 0) KMAXI = NN/2
      KMAX = KMAXI
      KMIN = 0
      IF (KMAX .GE. 0) GO TO 20
      KMAX =-KMAX
      KMIN = KMAX
   20 IF (2*KMAX.GT.NN .OR. NN.LE.0) GO TO 330
   30 IF (NLOAD .LE. 0) GO TO 350
   40 NLOADS = NLOAD
      IF (LDSA) NLOADS = 2*NLOAD
      NLOADT = NLOAD
      IF (LDRL .OR. LDSA) NLOADT = 2*NLOAD
      NUMROW = NN
      IF (.NOT.LBACK) GO TO 50
      NUMROW = 2*(KMAX-KMIN+1)
      IF (KMIN   .EQ.  0) NUMROW = NUMROW - 1
      IF (2*KMAX .EQ. NN) NUMROW = NUMROW - 1
   50 NUMROW = NLOADT*NUMROW
C
C     DEFINE OPEN CORE POINTERS AND GINO BUFFER
C                POINTERS                BEGIN    END
C          TABLE OF COS (2.0*PI*N/NN)     ICOS    NCOS
C          TABLE OF SIN (2.0*PI*N/NN)     ISIN    NSIN
C          AREA TO ASSEMBLE COLUMNS       ICOL    NCOL
C          (NOTE  N = LITTLE N, NN = CAPITAL N)   N = 0,(NN-1)
C          (ALLOW FOR (NLOADS-1) ZEROS BEFORE FIRST ENTRY IN COL)
C
      BUF  = KORSZ(IZ) - SYSBUF + 1
      ICOS = 1
      NCOS = ICOS + NN - 1
      ISIN = NCOS + 1
      NSIN = ISIN + NN - 1
      ICOL = NSIN + 1
      JCOL = ICOL + NLOADS - 1
      NCOL = JCOL + NUMROW - 1
      IF (2*NCOL .GE. BUF) CALL MESAGE (-8,0,SUBR)
C
C     CHECK DATA BLOCK TRAILERS
C
      MCB(1) = GCYC
      CALL RDTRL (MCB(1))
      IF (MCB(1) .LE. 0) GO TO 370
   60 MCB(1) = VOUT
      CALL RDTRL (MCB(1))
      LVOUT  = MCB(1).GT.0
      MCB(1) = VIN
      CALL RDTRL (MCB(1))
      LVIN = MCB(1).GT.0
      IF (.NOT.LVIN) MCB(2) = 0
      LNMULT = MCB(2).NE.NUMROW
      IF (LVIN .AND. LVOUT .AND. LNMULT) GO TO 390
      IF (NOGO) 410,410,70
C
C     THE PARAMETERS ARE OK
C     PREPARE TRIGONOMETRIC TABLES,  DC1=COS(2*PI/NN), PI = 4*ATAN(1)
C     MOVABLE POINTERS  JXXX=N , KXXX= NN-N
C
   70 RN   = FLOAT(NN)
      DFAC = (8.0D0*DATAN(1.0D0))/DBLE(RN)
      DC1  = DCOS(DFAC)
      DS1  = DSIN(DFAC)
      JCOS = ICOS
      KCOS = NCOS + 1
      JSIN = ISIN
      KSIN = NSIN + 1
      DZ(JCOS) = 1.0D0
      DZ(JSIN) = 0.0D0
   80 IF (KCOS-JCOS-2) 120,90,100
   90 DC   =-1.0D0
      DS   = 0.0D0
      GO TO 110
  100 DC   = DC1*DZ(JCOS) - DS1*DZ(JSIN)
      DS   = DS1*DZ(JCOS) + DC1*DZ(JSIN)
  110 JCOS = JCOS + 1
      JSIN = JSIN + 1
      KCOS = KCOS - 1
      KSIN = KSIN - 1
      DZ(JCOS) = DC
      DZ(JSIN) = DS
      DZ(KCOS) = DC
      DZ(KSIN) =-DS
      GO TO 80
C
C     ZERO THE AREA FOR FORMING THE COLUMN
C
  120 DO 130 J = ICOL,NCOL
      DZ(J) = 0.0D0
  130 CONTINUE
C
C     OPEN GCYC MATRIX,  GET READY TO USE PACK
C
      CALL GOPEN (GCYC,IZ(BUF),1)
      CALL MAKMCB (MCB,GCYC,NUMROW,2,PRECIS)
      PKIN   = 2
      PKOUT  = PRECIS
      PKIROW = 1
      PKNROW = NUMROW
      PKINCR = 1
      IF (LBACK) GO TO 240
C
C     START LOOPING ON COLUMNS OF MATRIX OF TYPE FORE.
C     FORM A COLUMN AND PACK IT OUT
C          K = KMIN,KMAX  ALTERNATE COSINE AND SINE COLUMNS
C
      DFAC = 2.0D0/DBLE(RN)
      IF (LDRL) DFAC = 0.5D0*DFAC
      K    = KMIN
  140 DFAK = DFAC
      IF (K.EQ.0 .OR. 2*K.EQ.NN) DFAK = 0.5D0*DFAK
      LCOS  = .TRUE.
      KTRIG = ICOS
      NTRIG = NCOS
      GO TO 160
  150 LCOS  = .FALSE.
      KTRIG = ISIN
      NTRIG = NSIN
  160 DO 170 KCOL = JCOL,NCOL,NLOADT
      DZ(KCOL) = DFAK*DZ(KTRIG)
      KTRIG = KTRIG + K
      IF (KTRIG .GT. NTRIG) KTRIG = KTRIG - NN
  170 CONTINUE
C
C     PACK OUT NLOADT COLUMNS  (FOR EITHER FORE OR BACK)
C      IF  ROT OR DSA   WE ARE READY
C      IF     DRL       PRODUCE INTERMEDIATE TERMS FIRST (EXPAND)
C
  180 NXCOL = 1
      IF (.NOT.LDRL) GO TO 220
      DO 190 KCOL = JCOL,NCOL,NLOADT
      KCOL2 = KCOL + NLOADS
      DZ(KCOL2) = DZ(KCOL)
  190 CONTINUE
      GO TO 220
  200 NXCOL = 2
      DO 210 KCOL = JCOL,NCOL,NLOADT
      KCOL2 = KCOL + NLOADS
      DZ(KCOL2) = -DZ(KCOL)
  210 CONTINUE
  220 KCOL = JCOL
  230 CALL PACK (DZ(KCOL),GCYC,MCB)
      KCOL = KCOL - 1
      IF (KCOL .GE. ICOL) GO TO 230
      IF (LDRL .AND. NXCOL.EQ.1) GO TO 200
      IF (LBACK) GO TO 280
C
C     BOTTOM OF LOOP FOR TYPE FORE
C
      IF (K.NE.0 .AND. 2*K.NE.NN .AND. LCOS) GO TO 150
      K = K + 1
      IF (K-KMAX) 140,140,290
C
C     START LOOPING ON COLUMNS OF MATRIX OF TYPE BACK
C         N = 1,NN
C
  240 N = 1
  250 K = 0
      KCOS = ICOS
      KCOL = JCOL
  260 IF (K .LT. KMIN) GO TO 270
      DZ(KCOL) = DZ(KCOS)
      KCOL = KCOL + NLOADT
      IF (K.EQ.0 .OR. 2*K.EQ.NN) GO TO 270
      DZ(KCOL) = DZ(KCOS+NN)
      KCOL = KCOL + NLOADT
  270 KCOS = KCOS + N - 1
      IF (KCOS .GT. NCOS) KCOS = KCOS - NN
      K = K + 1
      IF (K-KMAX) 260,260,180
C
C     BOTTOM OF LOOP FOR TYPE BACK
C
  280 N = N + 1
      IF (N-NN) 250,250,290
C
C     THE GCYC MATRIX IS NOW COMPLETE
C
  290 CALL CLOSE  (GCYC,1)
      CALL WRTTRL (MCB(1))
C
C     IF WE HAVE TO FORM VOUT, USE SSG2B.  (VOUT = VIN*GCYC)
C
      IF (LNMULT) GO TO 300
      CALL SSG2B (VIN,GCYC,0,VOUT,0,PRECIS,1,SCRT)
  300 CONTINUE
      RETURN
C
C     FATAL MESSAGES
C
  310 NOGO = -1
      WRITE  (OUTPT,320) UFM,CTYPE(1)
  320 FORMAT (A23,' 4063, ILLEGAL VALUE (',A4,') FOR PARAMETER CTYPE.')
      GO TO 10
  330 NOGO = -1
      WRITE  (OUTPT,340) UFM,NN,KMAXI
  340 FORMAT (A23,' 4064, ILLEGAL VALUES (',I8,1H,,I8,
     1        ') FOR PARAMETERS (NSEGS,KMAX).')
      GO TO 30
  350 NOGO = -1
      WRITE  (OUTPT,360) UFM,NLOAD
  360 FORMAT (A23,' 4065, ILLEGAL VALUE (',I8,') FOR PARAMETER NLOAD.')
      GO TO 40
  370 NOGO = -1
      WRITE  (OUTPT,380) UFM
  380 FORMAT (A23,' 4066, SECOND OUTPUT DATA BLOCK MUST NOT BE PURGED.')
      GO TO 60
  390 NOGO = -1
      WRITE  (OUTPT,400) UFM,MCB(2),NUMROW
  400 FORMAT (A23,' 4067, VIN HAS',I9,' COLS, GCYC HAS',I9,6H ROWS.)
  410 CALL MESAGE (-61,0,SUBR)
      RETURN
      END

      SUBROUTINE SORTI (INPFL,OUTFL,NWDS,KEYWRD,L,NX)
C
C     WITH ENTRY POINT SORTI2 TO SORT TABLE BY 2 KEY WORDS
C
C     THIS SORTING ROUTINE WAS CALLED SORT BEFORE, AND IS NOW RENAMED
C     SORTI. IT IS CAPABLE FOR IN-CORE SORTING AND FILE SORT.
C
C     THE NEW SUBROUTINE SORT IS A TRUNCATED VERSION OF THIS ROUTINE
C     ONLY FOR IN-CORE SORTING. IT CAN HANDLE INTEGER, REAL, BCD(A4),
C     BCD(A8), BCD(A7), AND 2-KEY SORTINGS.
C
C     (95 PERCENT OF NASTRAN ROUTINES ACTUALLY CALL SORT. THE REMAINING
C       5 PERCENT CALL SORTI)
C
C     IF INPFL AND OUTFL ARE ZERO, CALLING ROUTINE SHOULD CALL SORT
C     FOR EFFICIENCY
C
C     THE OLD SHUTTLE EXCHANGE, WHICH WAS VERY SLOW, IS NOW REPLACED BY
C     A SUPER FAST SORTER, A MODIFIED SHELL SORT.
C
C     THIS MODIFIED VERSION ALSO SORTS TABLE OF ANY LENGTH (PREVIOUSLY N
C     OF WORDS PER ENTRY, NWDS, WAS LIMITED TO 20)
C
      INTEGER         OUTFL,SCRA,SCRB,SCRC,DIST1,DIST2,DUMMY,TOTAL,OUT,
     1                SUBR(2),L(NWDS,2),TEMP,FILE,R,BUFA,BUFB,BUFC,
     2                SYSBUF,BUFIN,TWO,TWO31
      COMMON /SETUP / NFILE(6),BUFIN
      COMMON /SYSTEM/ SYSBUF,DUM38(38),NBPW
      COMMON /TWO   / TWO(16)
      EQUIVALENCE     (NFILE(1),SCRB),(NFILE(2),SCRC),(NFILE(3),SCRA)
      DATA    SUBR  / 4HSORT, 4HI    /
C
      KEY2 = 1
      GO TO 10
C
C
      ENTRY SORTI2 (INPFL,OUTFL,NWDS,KEYWRD,L,NX)
C     ==========================================
C
      KEY2 = 2
C
C     IF INPFL EQ 0, CORE BLOCK L OF LENGTH NX IS TO BE SORTED
C     IF INPFL NE 0, INPFL IS TO BE SORTED USING BLOCK L
C
   10 KEYWD = IABS(KEYWRD)
      NNN   = NX
      IF (NNN .LT. NWDS) GO TO 350
      J = 30
      IF (NBPW .GE. 60) J = 62
      TWO31 = 2**J
      IF (INPFL .EQ. 0) GO TO 30
      BUFA  = NX - SYSBUF + 1
C
C     MINIMUM CORE REQUIREMENT = 2 X NUMBER OF WORDS PER ENTRY
C
      NZ  = BUFA - 1
      IF (NZ .LT. NWDS+NWDS) GO TO 360
      CALL OPEN (*370,SCRA,L(BUFA,1),1)
      NN  = (NZ/NWDS)*NWDS
      NNN = NN
      OUT = SCRA
      NREC= 0
   20 CALL READ (*430,*170,INPFL,L,NN,0,NNN)
C
C     SORT PHASE --
C
   30 LEN = NNN/NWDS
      IF (LEN*NWDS .NE. NNN) GO TO 365
      M = LEN
      IF (KEYWRD .GE. 0) GO TO 40
C
C                     - INTEGER SORT ONLY -
C     IF ORIGINAL ORDER IS TO BE MAINTAINED WHERE DUPLICATE KEYWORDS MAY
C     OCCUR, ADD INDICES TO THE KEYWORDS (GOOD FOR BOTH POSITIVE AND
C     NEGATIVE RANGES, AND BE SURE THAT KEYWORDS ARE NOT OVERFLOWED),
C     SORT THE DATA, AND REMOVE THE INDICES LATER
C
C     IF ANY KEYWORD OVERFLOWS, SWITCH TO SHUTTLE EXCHANGE METHOD
C     LIMIT IS THE MAX VALUE BEFORE INTEGER OVERFLOW
C
      IF (LEN.GE.TWO(16) .AND. NBPW.LE.32) GO TO 130
      LIMIT = (TWO31-LEN)/LEN
      DO 35 I = 1,LEN
      J = L(KEYWD,I)
      IF (IABS(J) .GT. LIMIT) GO TO 124
      J = J*LEN + I
      K = -1
      IF (J .LT. 0) K = -LEN
   35 L(KEYWD,I) = J + K
      IF (KEY2 .EQ. 1) GO TO 40
      DO 37 I = 1,LEN
      J = L(KEYWD+1,I)
      IF (IABS(J) .GT. LIMIT) GO TO 120
      J = J*LEN + I
      K = -1
      IF (J .LT. 0) K = -LEN
   37 L(KEYWD+1,I) = J + K
C
C     SORT BY
C     MODIFIED SHELL METHOD, A SUPER FAST SORTER
C
   40 M = M/2
      IF (M .EQ. 0) GO TO 110
      J = 1
      K = LEN - M
   45 I = J
   50 N = I + M
      IF (L(KEYWD,I)-L(KEYWD,N)) 105, 60,95
   60 IF (KEY2 .EQ. 1) GO TO 105
      IF (L(KEYWD+1,I)-L(KEYWD+1,N)) 105,105,95
   95 DO 100 R = 1,NWDS
      TEMP   = L(R,I)
      L(R,I) = L(R,N)
  100 L(R,N) = TEMP
      I = I - M
      IF (I .GE. 1) GO TO 50
  105 J = J + 1
      IF (J-K) 45,45,40
  110 IF (KEYWRD .GE. 0) GO TO 160
      DO 115 I = 1,LEN
      L(KEYWD,I) = L(KEYWD,I)/LEN
      IF (KEY2 .EQ. 2) L(KEYWD+1,I) = L(KEYWD+1,I)/LEN
  115 CONTINUE
      GO TO 160
C
C     SORT BY
C     SHUTTLE EXCHANGE METHOD, A SLOW SORTER
C     (THIS WAS NASTRAN ORIGINAL SORTER, MODIFIED FOR 2-D ARRAY
C     OPERATION WITH 20-COLUMN LIMITATION REMOVED)
C
  120 IF (I .LE. 1) GO TO 123
      J = I - 1
      DO 121 I = 1,J
  121 L(KEYWD+1,I) = L(KEYWD+1,I)/LEN
  123 I = LEN
  124 IF (I .LE. 1) GO TO 130
      J = I - 1
      DO 125 I = 1,J
  125 L(KEYWD,I) = L(KEYWD,I)/LEN
C
  130 DO 155 II = 2,LEN
      JJ = II - 1
      IF (L(KEYWD,II)-L(KEYWD,JJ)) 135,133,155
  133 IF (KEY2 .EQ. 1) GO TO 155
      IF (L(KEYWD+1,II) .GE. L(KEYWD+1,JJ)) GO TO 155
  135 JJ = JJ - 1
      IF (JJ .LE. 0) GO TO 140
      IF (L(KEYWD,II)-L(KEYWD,JJ)) 135,137,140
  137 IF (KEY2 .EQ. 2) IF (L(KEYWD+1,II)-L(KEYWD+1,JJ)) 135,140,140
  140 JJ = JJ + 2
      DO 150 I = 1,NWDS
      TEMP = L(I,II)
      M = II
      DO 145 J = JJ,II
      L(I,M) = L(I,M-1)
  145 M = M - 1
  150 L(I,JJ-1) = TEMP
  155 CONTINUE
C
C     IF CORE SORT, SORT IS COMPLETED. IF FILE SORT, WRITE BLOCK ON
C     SCRATCH FILE TO BE MERGED LATER.
C
  160 IF (INPFL .EQ. 0) GO TO 350
  165 CALL WRITE (SCRA,L,NNN,1)
      NREC = NREC + 1
      IF (NNN-NN) 180,20,180
  170 IF (NNN) 180,180,175
  175 IF (NNN-NWDS-NWDS) 165,30,30
  180 CALL CLOSE (SCRA,1)
C
C     IF ONLY ONE RECORD, BYPASS MERGE
C
      IF (NREC .EQ. 1) GO TO 320
C
C     COMPUTE OPTIMUM DISTRIBUTION OF SORTED RECORDS ON TWO SCRATCH
C     FILES FOR MERGE PHASE USING FIBONACCI SEQUENCE
C
      LEVEL = 0
      DIST1 = 1
      DIST2 = 0
      TOTAL = 1
  190 DUMMY = TOTAL - NREC
      IF (DUMMY .GE. 0) GO TO 195
      DIST1 = DIST1 + DIST2
      DIST2 = DIST1 - DIST2
      TOTAL = DIST1 + DIST2
      LEVEL = LEVEL + 1
      GO TO 190
  195 BUFB  = BUFA - SYSBUF
      BUFC  = BUFB - SYSBUF
      IF (BUFC .LT. 1) GO TO 360
      NN = BUFB - 1
C
C     COPY N SORTED RECORDS ONTO SECOND SCRATCH FILE
C
      CALL OPEN (*370,SCRA,L(BUFA,1),0)
      CALL OPEN (*380,SCRB,L(BUFB,1),1)
      N = DIST2 - DUMMY
      DO 205 I = 1,N
  200 CALL READ  (*440,*205,SCRA,L,NN,0,NFLAG)
      CALL WRITE (SCRB,L,NN,0)
      GO TO 200
  205 CALL WRITE (SCRB,L,NFLAG,1)
      CALL CLOSE (SCRB,1)
      CALL CLOSE (SCRA,2)
      NFILE(4) = SCRB
      NFILE(5) = SCRC
      K = 4
C
C     MERGE PHASE ---
C     INPUT FILE WITH GREATER NUMBER IF RECORDS = IN1
C     INPUT FILE WITH LESSER  NUMBER OF RECORDS = IN2
C     EACH PASS MERGES ALL RECORDS FROM IN2 WITH LIKE NUMBER OF RECORDS
C     (INCLUDING DUMMY RECORDS) FROM IN1 ONTO OUT. FOR NEXT PASS IN1
C     BECOMES IN2, IN2 BECOMES OUT, AND OUT BECOMES IN1.
C
      DO 310 I = 1,LEVEL
      K = K - 1
      IF (K .EQ. 0) K = 3
      IN1 = NFILE(K)
      IN2 = NFILE(K+1)
      OUT = NFILE(K+2)
      LAST= 2
      CALL OPEN (*390,IN1,L(BUFA,1),2)
      CALL OPEN (*400,IN2,L(BUFB,1),2)
      CALL OPEN (*410,OUT,L(BUFC,1),1)
      DO 300 J = 1,DIST2
      IF1 = NWDS
      IF2 = NWDS
      CALL READ (*450,*275,IN1,L,NWDS,0,IF1)
      IF (DUMMY) 210,210,280
  210 CALL READ (*460,*290,IN2,L(1,2),NWDS,0,IF2)
  220 IF (L(KEYWD,1)-L(KEYWD,2)) 260,230,270
  230 IF (KEY2 .EQ. 2) IF (L(KEYWD+1,1)-L(KEYWD+1,2)) 260,260,270
  260 CALL WRITE (OUT,L,NWDS,0)
      CALL READ  (*450,*275,IN1,L,NWDS,0,IF1)
      IF (IF2) 260,260,220
  270 CALL WRITE (OUT,L(1,2),NWDS,0)
      CALL READ  (*460,*290,IN2,L(1,2),NWDS,0,IF2)
      IF (IF1) 270,270,220
  275 IF (IF2) 300,300,270
  280 DUMMY = DUMMY - 1
      IF2 = 0
  290 IF (IF1) 300,300,260
  300 CALL WRITE (OUT,0,0,1)
      DIST2 = DIST1 - DIST2
      DIST1 = DIST1 - DIST2
      IF (DIST2 .EQ. 0) LAST = 1
      CALL CLOSE (IN1,LAST)
      CALL CLOSE (IN2,1)
  310 CALL CLOSE (OUT,1)
C
C     COPY PHASE ---
C     IF OUTPUT FILE IS NOT SPECIFIED, NFILE(6) WILL CONTAIN NAME OF
C     SCRATCH FILE CONTAINING OUTPUT
C
  320 NFILE(6) = OUT
      IF (OUTFL .EQ. 0) GO TO 350
      CALL OPEN (*410,OUT,L(BUFA,1),0)
      IF (INPFL .NE. OUTFL) GO TO 330
      CALL CLOSE (INPFL,1)
      CALL OPEN  (*420,INPFL,L(BUFIN,1),1)
  330 CALL READ  (*470,*340,OUT,L,NZ,0,NFLAG)
      CALL WRITE (OUTFL,L,NZ,0)
      GO TO 330
  340 CALL WRITE (OUTFL,L,NFLAG,1)
      CALL CLOSE (OUT,1)
  350 RETURN
C
C     ERRORS
C
  360 J = -8
      FILE = 0
      GO TO  500
  365 J = -37
      GO TO  500
  370 FILE = SCRA
      GO TO  480
  380 FILE = SCRB
      GO TO  480
  390 FILE = IN1
      GO TO  480
  400 FILE = IN2
      GO TO  480
  410 FILE = OUT
      GO TO  480
  420 FILE = INPFL
      GO TO  480
  430 FILE = INPFL
      GO TO  490
  440 FILE = SCRA
      GO TO  490
  450 FILE = IN1
      GO TO  490
  460 FILE = IN2
      GO TO  490
  470 FILE = OUT
      GO TO  490
  480 J = -1
      GO TO  500
  490 J = -2
  500 CALL MESAGE (J,FILE,SUBR)
      RETURN
      END

      SUBROUTINE MBCAP(NPHI,CAPPHI)
C
      REAL  KM , KBAR , MACH , W(10), P(10)
      COMPLEX  CAPPHI(1)
      COMMON /MBOXC/ NJJ ,CRANK1,CRANK2,CNTRL1,CNTRL2,NBOX,
     *  NPTS0,NPTS1,NPTS2,ASYM,GC,CR,MACH,BETA,EK,EKBAR,EKM,
     *  BOXL,BOXW,BOXA ,NCB,NSB,NSBD,NTOTE,KC,KC1,KC2,KCT,KC1T,KC2T
      EQUIVALENCE  ( KM , EKM ) , ( KBAR , EKBAR )
      DATA  W / 0.0506143,0.1111905,0.1568533,0.1813419,0.1813419,
     *          0.1568533,0.1111905,0.0506143,0.0,0.0/,
     *      P / 0.0198551,0.1016667,0.2372338,0.4082826,0.5917174,
     *          0.7627662,0.8983333,0.9801449,0.0,0.0/
C
      DO   200   I = 1 , NPHI
      CAPPHI(I)  =  ( 0.0 , 0.0 )
 200  CONTINUE
C
C     COMPUTE CAPPHI FOR RECEIVING BOX
C
      IF ( KBAR .LE. 0.0 )   GO TO  400
      DO   300   I = 1 , 8
      J  =  9 - I
      ARG  =  KBAR * P(J) / 2.0
      ARG1  =  W(I) * ZJ ( ARG / MACH ) / 2.0
      CAPPHI(1)  =  CAPPHI(1) + CMPLX ( -COS ( ARG ) * ARG1 ,
     *              SIN ( ARG ) * ARG1 )
 300  CONTINUE
      GO TO 500
C
 400  CAPPHI(1)  =  ( -0.5 , 0.0 )
C
C     COMPUTE REMAINING CAPPHI
C
 500  NPHI  =  1
      XB  =  0.5
      XU  =  XB + 1.0
      DO   900   I = 2 , NCB
      XL  =  -0.5
      XR  =  XL + 1.0
      DO   700   J = 1 , I
      NPHI  =  NPHI + 1
      DO   600   L = 1 , 8
      X  =  XB + P(L)
      ARG  =  KBAR * X
      ARG1  =  W(L) * GO ( X , XR , XL , KM ) / 3.14159265
      CAPPHI(NPHI)  =  CAPPHI(NPHI) - CMPLX ( COS ( ARG ) * ARG1 ,
     *                 -SIN ( ARG ) * ARG1 )
 600  CONTINUE
      XL  =  XR
      XR  =  XR + 1.0
 700  CONTINUE
C
      XB  =  XU
      XU  =  XB + 1.0
 900  CONTINUE
C
      DO   1000   I = 1 , NPHI
      CAPPHI(I)  =  BOXW * CAPPHI(I)
 1000 CONTINUE
      RETURN
      END

      SUBROUTINE DSNMDD
      INCLUDE   'DSIOF.COM'
      INCLUDE   'NASNAMES.COM'
      CHARACTER*12 FILNAM(100)
C
      COMMON /SYSTEM/ SYSBUF, IWR
C
      DATA FILNAM/'PUNCH','LINK' ,'LOG      ' ,'RDICT   ' , 'INPUT   '
     *,'OUTPUT   ' , 'OPTP'    ,'NPTP.ZAP' ,'XPDT.ZAP' , 'PLOT    '
     *,'UT1'      , 'UT2'     ,'UT3'      ,'UT4'      , 'UT5'
     *,'INPT'     , 'INP1'    ,'INP2'     ,'INP3'     , 'INP4'
     *,'INP5'     , 'POOL.ZAP','SCR23.ZAP','SCR24.ZAP','SCR25.ZAP'
     *,'SCR26.ZAP','SCR27.ZAP','SCR28.ZAP','SCR29.ZAP','SCR30.ZAP'
     *,'SCR31.ZAP','SCR32.ZAP','SCR33.ZAP','SCR34.ZAP','SCR35.ZAP'
     *,'SCR36.ZAP','SCR37.ZAP','SCR38.ZAP','SCR39.ZAP','SCR40.ZAP'
     *,'SCR41.ZAP','SCR42.ZAP','SCR43.ZAP','SCR44.ZAP','SCR45.ZAP'
     *,'SCR46.ZAP','SCR47.ZAP','SCR48.ZAP','SCR49.ZAP','SCR50.ZAP'
     *,'SCR51.ZAP','SCR52.ZAP','SCR53.ZAP','SCR54.ZAP','SCR55.ZAP'
     *,'SCR56.ZAP','SCR57.ZAP','SCR58.ZAP','SCR59.ZAP','SCR60.ZAP'
     *,'SCR61.ZAP','SCR62.ZAP','SCR63.ZAP','SCR64.ZAP','SCR65.ZAP'
     *,'SCR66.ZAP','SCR67.ZAP','SCR68.ZAP','SCR69.ZAP','SCR70.ZAP'
     *,'SCR71.ZAP','SCR72.ZAP','SCR73.ZAP','SCR74.ZAP','SCR75.ZAP'
     *,'SCR76.ZAP','SCR77.ZAP','SCR78.ZAP','SCR79.ZAP','SCR80.ZAP'
     *,'SCR81.ZAP','SCR82.ZAP','SCR83.ZAP','SCR84.ZAP','SCR85.ZAP'
     *,'SCR86.ZAP','SCR87.ZAP','SCR88.ZAP','SCR89.ZAP','SCR90.ZAP'
     *,'SCR91.ZAP','SCR92.ZAP','SCR93.ZAP','SCR94.ZAP','SCR95.ZAP'
     *,'SCR96.ZAP','SCR97.ZAP','SCR98.ZAP','SCR99.ZAP','SCR00.ZAP'/
      LENDIR = INDEX( DIRTRY, ' ' ) - 1
      DO 15 K = 1, 21
      MDSNAM( K ) = FILNAM(K)
15    CONTINUE
      MDSNAM( 8 ) = DIRTRY(1:LENDIR) // '/' // FILNAM( 8 )
      MDSNAM( 9 ) = DIRTRY(1:LENDIR) // '/' // FILNAM( 9 )
      DO 20 K = 22, MAXFCB
      MDSNAM( K ) = DIRTRY(1:LENDIR) // '/' // FILNAM( K )
20    CONTINUE
700   RETURN
      END

      SUBROUTINE CMSFIL
C
C     THIS SUBROUTINE GENERATES THE WORKING SUBSTRUCTURE FILE AND
C     APPLIES ALL TRANSFORMATIONS
C
      EXTERNAL        RSHIFT,ANDF
      LOGICAL         TDAT,XTRAN,XCSTM,IAUTO
CWKBI ALPHA-OSF 9/94
      INTEGER         SCR3, SCSFIL
      INTEGER         AAA(2),ANDF,RSHIFT,BUFEX,OUTT,
     1                SCBDAT,BUF4,SCORE,TRN,SYM,COMBO,NAM(2),Z,SCMCON,
     2                SCCSTM,CSTMID,CGID,BUF2,BUF3,BUF1,ECPT1,TWOJM1
      DIMENSION       RZ(1),ECPT(4),DOFN(6),LIST(32),TG(3,3),TG6(6,6),
     1                TSAVE(6,6),TMAT(6,6),TC(3,3),TT(3,3),XX(3)
      COMMON /CMB001/ SCR1,SCR2,SCBDAT,SCSFIL,SCCONN,SCMCON,SCTOC,
     1                GEOM4,CASECC,SCCSTM,SCR3
      COMMON /CMB002/ BUF1,BUF2,BUF3,BUF4,BUF5,SCORE,LCORE,INTP,OUTT
      COMMON /CMB003/ COMBO(7,5),CONSET,IAUTO,TOLER,NPSUB,CONECT,TRAN,
     1                MCON,RESTCT(7,7),ISORT,ORIGIN(7,3),IPRINT
      COMMON /CMB004/ TDAT(6)
      COMMON /GTMATX/ LOC1,KLTRAN,TRN,TT6(6,6),TC6(6,6)
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE     (ECPT1,ECPT(1)), (RZ(1),Z(1))
      DATA    AAA   / 4H CMS, 4HFIL  /
      DATA    NHBGSS, NHCSTM,NHEQSS  / 4HBGSS,4HCSTM,4HEQSS /
C
      BUFEX  = LCORE - BUF1 + BUF2
      LCORE  = BUFEX - 1
      IF (LCORE .LT. 0) GO TO 620
      LLCO   = LCORE
      IOEFIL = 310
      IFILE  = SCBDAT
      CALL OPEN (*600,SCBDAT,Z(BUF4),0)
C
C     READ GTRAN DATA INTO OPEN CORE
C
      IF (TDAT(3) .OR. TDAT(6)) CALL SKPFIL (SCBDAT,1)
      IF (.NOT.TDAT(6)) GO TO 20
      KSGTRN = SCORE
      CALL READ (*610,*10,SCBDAT,Z(KSGTRN),LLCO,1,KLGTRN)
      GO TO 620
   10 LLCO   = LLCO - KLGTRN
      KFGTRN = KSGTRN + KLGTRN - 1
      GO TO 30
C
C     READ TRANS DATA INTO OPEN CORE
C
   20 KSTRAN = SCORE
      GO TO 40
   30 KSTRAN = KFGTRN + 1
   40 IF (TDAT(3) .OR. TDAT(6)) CALL SKPFIL (SCBDAT,1)
      IF (.NOT. TDAT(3)) GO TO 60
      CALL READ (*610,*50,SCBDAT,Z(KSTRAN),LLCO,1,KLTRAN)
      GO TO 620
   50 LOC1   = KSTRAN
      LLCO   = LLCO - KLTRAN
      XTRAN  = .TRUE.
      KFTRAN = KSTRAN + KLTRAN - 1
      GO TO 70
   60 LOC1   = 0
      XTRAN  = .FALSE.
   70 CALL CLOSE (SCBDAT,1)
      IFILE  = SCSFIL
      CALL OPEN (*600,SCSFIL,Z(BUF4),1)
      IFILE  = SCCSTM
      CALL OPEN (*600,SCCSTM,Z(BUF3),1)
      KKC    = 0
C
C     LOOP ON EACH PSEUDOSTRUCTURE
C
      IFILE  = SCR3
      CALL OPEN (*600,SCR3,Z(BUF1),1)
      IFILE  = IOEFIL
      CALL OPEN (*600,IOEFIL,Z(BUFEX),1)
      LLCOLD = LLCO
C
      DO 550 I = 1,NPSUB
      LLCO   = LLCOLD
      NAM(1) = COMBO(I,1)
      NAM(2) = COMBO(I,2)
      TRN    = COMBO(I,3)
      SYM    = COMBO(I,4)
      NCOMP  = COMBO(I,5)
C
C     READ BGSS FOR I-TH PSEUDOSTRUCTURE
C
      KSBGSS = KSTRAN
      IF (XTRAN) KSBGSS = KSTRAN + KLTRAN
      CALL SFETCH (NAM,NHBGSS,1,ITEST)
      NGRP   = 1
      CALL SJUMP (NGRP)
      CALL SUREAD (Z(KSBGSS),LLCO,KLBGSS,ITEST)
      IF (KLBGSS.EQ.LLCO .AND. ITEST.NE.2) GO TO 620
      LLCO   = LLCO - KLBGSS
      KFBGSS = KSBGSS + KLBGSS - 1
      NIP    = KLBGSS/4
C
C     READ CSTM FOR THIS PSEUDOSTRUCTURE
C
      CALL SFETCH (NAM,NHCSTM,1,ITEST)
      XCSTM  = .FALSE.
      LOC2   = 0
      IF (ITEST .EQ. 3) GO TO 80
      KSCSTM = KFBGSS + 1
      NGRP   = 1
      CALL SJUMP (NGRP)
      CALL SUREAD (Z(KSCSTM),LLCO,KLCSTM,ITEST)
      IF (KLCSTM.EQ.LLCO .AND. ITEST.NE.2) GO TO 620
      LLCO   = LLCO - KLCSTM
      LOC2   = KSCSTM
      XCSTM  = .TRUE.
      KFCSTM = KSCSTM + KLCSTM - 1
   80 CONTINUE
C
C     DEFINE OPEN CORE ARRAYS FOR NEW CID AND HPTR
C
      KSNCID = KFBGSS + 1
      IF (LOC2 .NE. 0) KSNCID = KFCSTM + 1
      KLNCID = NIP
      LLCO   = LLCO - KLNCID
      KFNCID = KSNCID + KLNCID - 1
C
      KSHPTR = KFNCID + 1
      KLHPTR = NIP
      LLCO   = LLCO - KLHPTR
      KFHPTR = KSHPTR + KLHPTR - 1
C
C     SET ARRAYS TO ZERO
C
      DO 90 J = KSNCID,KFNCID
      Z(J) = 0
   90 CONTINUE
      DO 100 J = KSHPTR,KFHPTR
      Z(J) = 0
  100 CONTINUE
C
C     GET THE TRANS AND SYMT MATRIX FOR THIS PSEUDOSTRUCTURE
C
      CALL GTMAT1 (SYM,TT)
C
C     TRANSFORM THE COORDINATES IN THE BGSS, NOTE THAT THE ORIGINS
C     FOR TRANSLATION ARE STORED IN ARRAY ORIGIN.
C
      IF (TRN+SYM .EQ. 0) GO TO 130
      DO 120 J = KSBGSS,KFBGSS,4
      IF (Z(J) .EQ. -1) GO TO 120
      CALL GMMATS (TT,3,3,0 ,RZ(J+1),3,1,0 ,XX)
      DO 110 JJ = 1,3
      RZ(J+JJ) = XX(JJ) + ORIGIN(I,JJ)
  110 CONTINUE
  120 CONTINUE
  130 CONTINUE
C
C     TRANSFORM DEGREES OF FREEDOM FOR EACH EQSS CONTAINED
C     IN THE PSEUDOSTRUCTURE.
C
      CALL WRITE (SCR3,TT6,36,1)
      NHMAT = 1
      CALL SFETCH (NAM,NHEQSS,1,ITEST)
      KNEQSS = KFHPTR + 1
      CALL SUREAD (Z(KNEQSS),4,KLEQSS,ITEST)
      CALL SUREAD (Z(KNEQSS),-1,KLEQSS,ITEST)
      LLCO  = LLCO - 2*NCOMP
      IFILE = SCMCON
      CALL OPEN (*600,SCMCON,Z(BUF2),1)
      DO 350 J = 1,NCOMP
      KSEQSS = KFHPTR + 2*NCOMP
      CALL SUREAD (Z(KSEQSS),LLCO,KLEQSS,ITEST)
      IF (KLEQSS .EQ. 0) GO TO 340
      IF (KLEQSS.EQ.LLCO .AND. ITEST.NE.2) GO TO 620
      KFEQSS = KSEQSS + KLEQSS - 1
C
C     LOOP ON EACH IP IN THE EQSS AND GENERATE TRANSFORMATION MATRIX
C
      DO 330 JJ = KSEQSS,KFEQSS,3
      IP    = Z(JJ+1)
      ICOMP = Z(JJ+2)
C
C     GET CSTM FOR THIS IP
C
      CSTMID = Z(KSBGSS+4*IP-4)
      ECPT1  = CSTMID
      IF (CSTMID .LT. 0) ECPT1 = 0
      DO 140 JDH = 1,3
      ECPT(JDH+1) = RZ(KSBGSS+4*IP-4+JDH)
  140 CONTINUE
      CALL GTMAT2 (LOC2,KLCSTM,ECPT,TC)
C
C     TEST FOR POSSIBLE GTRAN
C
      IGTRAN = 0
      IF (.NOT.TDAT(6)) GO TO 170
      CGID = 1000000*J + Z(JJ)
      DO 150 K = KSGTRN,KFGTRN,5
      IF (Z(K+3).EQ.CGID .AND. Z(K).EQ.I .AND. Z(K+1).EQ.J) GO TO 160
  150 CONTINUE
C
C     NO GTRAN
C
      GO TO 170
  160 CALL GTMAT3 (Z(K+4),TG,TG6,IKIND)
      IGTRAN = 1
      GO TO 180
  170 CALL GTMAT3 (-1,TG,TG6,IKIND)
C
C     ALL TRANSFORMATIONS HAVE BEEN FOUND, COMPUTE THE FINAL MATRIX TMAT
C
  180 CALL GMMATS (TG6  ,6,6,1,TT6,6,6,0,TSAVE)
      CALL GMMATS (TSAVE,6,6,0,TC6,6,6,0,TMAT )
C
C     DECODE DEGREES OF FREEDOM AND FORM VECTOR
C
      CALL DECODE (ICOMP,LIST,NDOF)
C
C     FIND NEW DEGREES OF FREEDOM AND UPDATE EQSS
C
      IF (CSTMID.NE.0 .AND. IGTRAN.EQ.0) GO TO 220
      DO 200 I1 = 1,6
      DOFN(I1) = 0.0
      DO 190 I2 = 1,NDOF
      L = LIST(I2) + 1
      IF (ABS(TMAT(L,I1)) .LT. 1.0E-4) GO TO 190
      DOFN(I1) = 1.0
      GO TO 200
  190 CONTINUE
  200 CONTINUE
      ICODE = 0
      DO 210 I1 = 1,6
      ICODE = ICODE + DOFN(I1)*2**(I1-1)
  210 CONTINUE
      GO TO 230
  220 ICODE   = ICOMP
  230 Z(JJ+2) = ICODE
C
C     WRITE IP,C ON SCRATCH TO COMPUTE NEW SIL,C
C
      CALL WRITE (SCMCON,IP,1,0)
      CALL WRITE (SCMCON,ICODE,1,0)
C
C     UPDATE CID NUMBERS
C
      IADD   = KSBGSS + 4*IP - 4
      IADD1  = KSNCID + IP - 1
      IKKIND = IKIND  + 1
      GO TO (240,240,250,250,240,240,260,260,290,290,290,290,270,270,
     1       280,280,290,290,290,290,290,290,290,290,290,290,290,290,
     2       280,280,280,280,280,280,280), IKKIND
  240 Z(IADD1) = Z(IADD)
      IF (Z(IADD) .EQ. -1) Z(IADD1) = -100000000
      IF (Z(IADD) .EQ. -2) Z(IADD1) = -200000000
      GO TO 290
C
C     COMMENTS FROM G.CHAN/UNISYS  9/92
C     250 AND 240 ARE IDENTICAL HERE. IS IT POSSIBLY AN ERROR HERE?
C
  250 Z(IADD1) = Z(IADD)
      IF (Z(IADD) .EQ. -1) Z(IADD1) = -100000000
      IF (Z(IADD) .EQ. -2) Z(IADD1) = -200000000
      GO TO 290
  260 Z(IADD1) = 0
      GO TO 290
  270 Z(IADD1) = -TRN
      GO TO 290
  280 Z(IADD1) = -Z(K+4)
  290 CONTINUE
C
C     SET POINTERS FOR H MATRIX
C
      ITIS = 0
      IADD2 = KSHPTR + IP - 1
      IF (CSTMID   .LT. 0) GO TO 300
      IF (Z(IADD2) .GT. 2) GO TO 330
      IF (IKKIND.EQ. 3 .OR. IKKIND.EQ.4 .OR. IKKIND.EQ.13 .OR.
     1    IKKIND.EQ.14) ITIS = 1
      IF (IKKIND.EQ. 1 .OR. IKKIND.EQ.2 .OR. IKKIND.EQ. 5 .OR.
     1    IKKIND.EQ. 6) ITIS = 2
      IF (ITIS - 1) 320,300,310
  300 Z(IADD2) = 0
      GO TO 330
  310 Z(IADD2) = 1
      GO TO 330
  320 CONTINUE
      NHMAT = NHMAT + 1
      Z(IADD2) = NHMAT
      CALL WRITE (SCR3,TMAT,36,1)
  330 CONTINUE
C
C     INSERT MULTIPLE IP CODE
C
      IF (NCOMP .NE. 1) CALL EQSCOD (KSEQSS,KLEQSS,Z(1))
C
C     WRITE EQSS ON FILE SCSFIL
C
  340 CALL WRITE (SCSFIL,Z(KSEQSS),KLEQSS,1)
      TWOJM1 = 2*(J-1)
      IF (ANDF(RSHIFT(IPRINT,19),1) .EQ. 1)
     1    CALL CMIWRT (1,NAM,Z(KNEQSS+TWOJM1),KSEQSS,KLEQSS,Z,Z)
  350 CONTINUE
      CALL EOF (SCR3)
      CALL CLOSE (SCMCON,1)
C
C     GENERATE NEW SIL,C LIST
C
      IFILE = SCMCON
      CALL OPEN (*600,SCMCON,Z(BUF2),0)
      CALL READ (*360,*360,SCMCON,Z(KSEQSS),LLCO,1,NNN)
      GO TO 620
  360 CALL SORT (0,0,2,1,Z(KSEQSS),NNN)
      KSEJ = KSEQSS + NNN - 1
      I1 = KSEQSS
      I2 = KSEQSS + 2
  370 IF (I2-KSEQSS .GE. NNN) GO TO 400
      IF (Z(I1)   .EQ. Z(I2)) GO TO 380
      I1 = I1 + 2
      I2 = I2 + 2
      GO TO 370
  380 DO 390 J = I2,KSEJ
  390 Z(J-2) = Z(J)
      KSEJ = KSEJ - 2
      NNN  = NNN  - 2
      GO TO 370
  400 CONTINUE
      Z(KSEQSS) = 1
      DO 410 J = 3,NNN,2
      JJ = J - 1
      ICODE = Z(KSEQSS+JJ-1)
      CALL DECODE (ICODE,LIST,NDOF)
      Z(KSEQSS+JJ) = Z(KSEQSS+JJ-2) + NDOF
  410 CONTINUE
      CALL WRITE  (SCSFIL,Z(KSEQSS),NNN,1)
      CALL SUREAD (Z(KSEQSS),LLCO,KLEQSS,ITEST)
      CALL WRITE  (IOEFIL,Z(KSEQSS),KLEQSS,1)
      CALL CLOSE  (SCMCON,1)
C
C     PRINT EQSS SIL LIST IF REQUESTED
C
      IF (ANDF(RSHIFT(IPRINT,19),1) .EQ. 1)
     1    CALL CMIWRT (8,NAM,0,KSEQSS,KLEQSS,Z,Z)
C
C     UPDATE CSTM NUMBERING SYSTEM
C     KKC IS TRANSFORMED SYSTEM COORD. ID
C
      IP  = 0
      DO 540 I6 = KSNCID,KFNCID
      IP  = IP + 1
      LOC = KSBGSS + 4*(IP-1)
      IF (Z(I6) .EQ. 100000000) GO TO 540
      IF (Z(I6)) 430,520,420
  420 I1  = KSCSTM
      I2  = KFCSTM
      GO TO 440
  430 IF (Z(I6) .EQ. -100000000) GO TO 530
      I1  = KSTRAN
      I2  = KFTRAN
  440 KKC = KKC + 1
      IF (IAUTO) GO TO 480
      IF (KKC .GT. 1) GO TO 460
      CALL PAGE1
      CALL PAGE2 (5)
      WRITE  (OUTT,450)
  450 FORMAT (//45X,'SUMMARY OF OVERALL SYSTEM COORDINATES', //36X,
     1      'PSEUDO STRUCTURE ID.   SYSTEM COORD.ID    USER COORD.ID',/)
  460 CALL PAGE2 (1)
      WRITE  (OUTT,470) I,KKC,Z(LOC)
  470 FORMAT (43X,I6,14X,I6,11X,I6)
  480 LOOK4 = Z(I6)
      DO 500  J6 = I1,I2,14
      IF (IABS(Z(I6)) .NE. Z(J6)) GO TO 500
      IF (Z(I6) .LE. 0) GO TO 490
      CALL GMMATS (TT,3,3,0,Z(J6+5),3,3,0,TC)
      CALL WRITE (SCCSTM,KKC,1,0)
      CALL WRITE (SCCSTM,Z(J6+1),4,0)
      CALL WRITE (SCCSTM,TC,9,0)
      GO TO 500
  490 CONTINUE
      CALL WRITE (SCCSTM,KKC,1,0)
      CALL WRITE (SCCSTM,Z(J6+1),13,0)
  500 CONTINUE
C
C     FIND OTHER CIDS THAT ARE THE SAME
C
      IIP = 0
      DO 510 J6 = KSNCID,KFNCID
      IIP = IIP + 1
      IF (Z(J6).NE. LOOK4) GO TO 510
      LOC = KSBGSS + 4*(IIP-1)
      Z(LOC) = KKC
      Z(J6) = 100000000
  510 CONTINUE
      GO TO 540
  520 Z(LOC) = 0
      GO TO 540
  530 Z(LOC) = -1
      IF (Z(I6) .EQ. -200000000) Z(LOC) = -2
  540 CONTINUE
C
C     WRITE PROCESSED BGSS
C
      CALL WRITE (SCSFIL,Z(KSBGSS),KLBGSS,1)
      IF (ANDF(RSHIFT(IPRINT,18),1) .EQ.  1)
     1    CALL CMIWRT (2,NAM,NAM,KSBGSS,KLBGSS,Z(1),Z(1) )
C
C     WRITE ARRAY OF H POINTERS
C
      CALL WRITE (SCSFIL,Z(KSHPTR),KLHPTR,1)
      CALL EOF (SCSFIL)
  550 CONTINUE
C
      CALL CLOSE (SCR3,1)
      CALL CLOSE (SCSFIL,1)
      CALL WRITE (SCCSTM,TMAT,0,1)
      CALL CLOSE (SCCSTM,1)
      CALL CLOSE (IOEFIL,1)
      LCORE = BUFEX + BUF1 - BUF2
      RETURN
C
  600 IMSG = -1
      GO TO 630
  610 IMSG = -2
      GO TO 630
  620 IMSG = -8
  630 CALL MESAGE (IMSG,IFILE,AAA)
      RETURN
      END

      SUBROUTINE APDR (FILE,Z,CORE,IN,OUT,WR,BUF,TYPE)
C
      INTEGER FILE,OUT,CORE,WR,BUF,FLAG,Z(1),TYPE(3),NAME(2)
      DATA    NAME /4HAPD ,4HR   /
C
      WR = 0
      IN = 0
      CALL LOCATE (*20,Z(BUF),TYPE,FLAG)
      IN = OUT + 1
      CALL READ (*90,*10,FILE,Z(IN),CORE,0,WR)
      GO TO 80
   10 OUT  = IN + WR - 1
   20 CORE = CORE - WR
      RETURN
C
   80 CALL MESAGE (-3,FILE,NAME)
   90 CALL MESAGE (-2,FILE,NAME)
      GO TO 20
      END

        SUBROUTINE CLOSE ( FILE, IOP )
C***************************************************************
C                          NOTICE
C
C     THIS PROGRAM BELONGS TO RPK CORPORATION.  IT IS CONSIDERED
C A TRADE SECRET AND IS NOT TO BE DIVULGED OR USED BY PARTIES
C WHO HAVE NOT RECEIVED WRITTEN AUTHORIZATION FROM RPK.
C***************************************************************
      INCLUDE 'DSIOF.COM'
      INCLUDE 'XNSTRN.COM'
      INTEGER*2         IUNIT
      COMMON / DSUNIT / IUNIT( 220 )
      COMMON / SYSTEM / ISYSBF, DUM1( 77 ), IDIAG, DUM2( 21 )
      INTEGER           FILE
      NAME   = FILE
      IOCODE = IOP
      IRETRN = 77
      CALL DSGEFL
      IF ( IFILEX .EQ. 0 ) GO TO 50
      IRETRN = 0
      IF ( IAND( IDIAG,2**14 ).NE. 0 ) CALL DSMSG( 2 )
      IF ( IOCODE .NE. 1 ) GO TO 20
      IF ( IPRVOP .EQ. 0 ) GO TO 10
      CALL DSEFWR
      IF ( ( INDCLR-INDBAS ) .EQ. 5 ) GO TO 5
      IBASE( INDBAS+4 ) = INDCLR - INDBAS + 1
      CALL DBMMGR( 4 )
5     CALL DSXFSZ
10    CONTINUE
      CALL DBMMGR( 2 )
      NBLOCK  = 1
      INDCLR  = INDBAS + 5
      INDCBP  = INDCLR
      GO TO 40
20    IF ( IPRVOP .EQ. 0 ) GO TO 30
      CALL DSEFWR
      IBASE( INDBAS+4 ) = INDCLR - INDBAS + 1
C SAVE INDBAS TO ALLOW DSBRC1 TO CORRECTLY BACKSPACE FILE OPENNED FOR WRITE
      ISAVE = INDBAS
      CALL DBMMGR( 4 )
      CALL DSXFSZ
      INDBAS = ISAVE
      IF ( IOCODE .NE. -2 ) CALL DSBRC1
C      CALL DSGNCL
      CALL DBMMGR( 2 )
      GO TO 40
30    IF ( INDCBP .EQ. INDCLR ) GO TO 35
      CALL DSSKRC
35    CONTINUE
      CALL DBMMGR( 2 )
40    CALL DSSDCB
      FCB( 2,IFILEX ) = 0
      FCB(12,IFILEX ) = 0
      IF ( NAME .LT. 101 .OR. NAME .GT. 320 ) GO TO 50
      IUNIT( NAME-100 ) = 0
50    RETURN
C***************************************************************
C                          NOTICE
C
C     THIS PROGRAM BELONGS TO RPK CORPORATION.  IT IS CONSIDERED
C A TRADE SECRET AND IS NOT TO BE DIVULGED OR USED BY PARTIES
C WHO HAVE NOT RECEIVED WRITTEN AUTHORIZATION FROM RPK.
C***************************************************************
      END

        SUBROUTINE QOPEN ( *, NAMFIL, BUFF, IOP )
      INCLUDE 'DSIOF.COM'
      INCLUDE 'XNSTRN.COM'
        COMMON / SYSTEM / ISYSBF, DUM1(77), IDIAG, DUM2(21)
        INTEGER           BUFF(10), DNAME(2), ITRL(7)
        DATA     INIT   / 0 /
        NAME   = NAMFIL
        IOCODE = IOP
        IF ( INIT .NE. 0 ) GO TO 10
        IBASBF = LOCFX( IBASE )
        CALL DSIODD
        NBUFF  = ISYSBF - 4
        NBFZ   = 1
        IF ( LENWPB .NE. 0 ) NBFZ   = NBUFF / LENWPB + .1
        INIT   = 1
   10   IF ( IAND( IDIAG, 2**14 ) .NE. 0 ) CALL DSMSG ( 1 )
        LOCBUF = LOCFX( BUFF )
        INDBAS = LOCBUF - IBASBF + 1
        IF ( MOD( INDBAS,2 ) .EQ. 0 ) INDBAS = INDBAS + 1
        IF ( FCB( 2, IFILEX ) .EQ. 0 ) GO TO 20
        CALL DSMSG( 5 )
   20   DO 30 I =1, MAXPRI
        IBASTS = FCB( 2, I )
        IF ( IBASTS .EQ. 0 ) GO TO 30
        IBASHI = IBASTS + ISYSBF - 2
        IBASLO = IBASTS - ISYSBF
        IF( INDBAS .LE. IBASLO .OR. INDBAS .GT. IBASHI ) GO TO 30
        CALL DSMSG( 3 )
   30   CONTINUE
        IBASE( INDBAS )  = NAMFIL
        FCB( 2, IFILEX ) = INDBAS
        FCB(12, IFILEX ) = INDBAS
        CALL DBMNAM ( NAME, DNAME, IFILEX )
        IF( IOCODE .LE. 1 ) GO TO 40
        IF( FCB( 13, IFILEX ) .EQ. DNAME( 1 ) .AND.
     &      FCB( 14, IFILEX ) .EQ. DNAME( 2 ) ) GO TO 35
C        CALL DBMSRF( DNAME, IUNI )
C        IF ( IUNI .EQ. IFILEX ) GO TO 35
        ITRL(1) = NAME
        CALL RDTRL( ITRL )
        DO 32 I = 2, 7
        IF ( ITRL(I) .NE. 0 ) GO TO 35
   32   CONTINUE
        IF ( IOCODE .EQ. 3 ) IOCODE = 1
        IF ( IOCODE .EQ. 2 ) IOCODE = 0
        GO TO 40
   35   CONTINUE
        NBLOCK = FCB( 4,IFILEX )
        IF ( NBLOCK .EQ. 0 ) GO TO 40
        CALL DBMMGR ( 1 )
        INDCLR = FCB( 3, IFILEX ) + INDBAS - 1
        INDCBP = INDCLR
        GO TO 60
   40   NBLOCK = 1
        FCB( 13, IFILEX ) = DNAME( 1 )
        FCB( 14, IFILEX ) = DNAME( 2 )
        CALL DBMMGR ( 1 )
        INDCLR = INDBAS + 5
        INDCBP = INDCLR
        IF( IOCODE .EQ. 0 ) GO TO 60
        IBASE( INDBAS+3 ) = 1
        IBASE( INDBAS+4 ) = 0
        FCB( 8, IFILEX )  = 0
   60   IF ( NBLOCK .EQ. IBASE( INDBAS+3 ) ) GO TO 70
        CALL DSMSG ( 102 )
   70   CALL DSSDCB
C        PRINT *,' QOPEN,UN,CLR,BLK,IOP=',IFILEX,FCB(3,IFILEX),
C     &     FCB(4,IFILEX),IOP
        RETURN
        END

      SUBROUTINE PLOD4S
C
C     ROUTINE TO PROCESS PLOAD4 BULK DATA TO CREATE LOADS ON
C     QUAD4 ELEMENTS
C
C     SINGLE PRECISION VERSION.
C
C     GRID POINT NUMBERING IS COUNTER-CLOCKWISE
C     GRIDS 1,2,3, AND 4 ARE AT THE CORNERS
C
      INTEGER         NEST(125),IORDER(4),SIL(4),KSIL(4),NOUT,CID,
     1                NSURF,SWP,SYSBUF,IZ(1),ITGRID(4,4),IBGPDT(4,4),
     2                ISLT(11),NOGO
      REAL            PE(3,4),BGPDT(4,4),PPP(4),NV(3),NVX(3),LOCATE(3)
      REAL            DPE(3,4),WEIGHT,XSI,ETA,EPS,AREA,SHP(4),
     1                DSHP(8),TMPSHP(4),DSHPTP(8),VI(3),VJ(3),V3T(3),
     2                GAUSS(3),WTGAUS(3)
      COMMON /LOADX / IDUM1(4),CSTM,IDUM2(13),ICM
      COMMON /PINDEX/ BEST(45),SLT(11)
      COMMON /ZZZZZZ/ Z(1)
      COMMON /SYSTEM/ SYSBUF,NOUT,NOGO
      EQUIVALENCE     (IZ(1)  ,Z(1)   ), (SLT(1),ISLT(1) )
      EQUIVALENCE     (NEST(1),BEST(1)), (NUMINT,NEST(25))
      EQUIVALENCE     (SIL(1) ,NEST(2)), (BGPDT(1,1),BEST(29))
      EQUIVALENCE     (IBGPDT(1,1),BGPDT(1,1))
      EQUIVALENCE     (PE(1,1),DPE(1,1))
C
      DATA    NDOF  / 3 /
C
C                 EST LISTING
C     ----------------------------------------------------------
C      1          EID
C      2 THRU 5   SILS, GRIDS 1 THRU 4
C      6 THRU 9   T (MEMBRANE), GRIDS 1 THRU 4
C     10          THETA (MATERIAL)
C     11          TYPE FLAG FOR WORD 10
C     12          ZOFF  (OFFSET)
C     13          MATERIAL ID FOR MEMBRANE
C     14          T (MEMBRANE)
C     15          MATERIAL ID FOR BENDING
C     16          I FACTOR (BENDING)
C     17          MATERIAL ID FOR TRANSVERSE SHEAR
C     18          FACTOR FOR T(S)
C     19          NSM (NON-STRUCTURAL MASS)
C     20 THRU 21  Z1, Z2  (STRESS FIBRE DISTANCES)
C     22          MATERIAL ID FOR MEMBRANE-BENDING COUPLING
C     23          THETA (MATERIAL) FROM PSHELL CARD
C     24          TYPE FLAG FOR WORD 23
C     25          INTEGRATION ORDER
C     26          THETA (STRESS)
C     27          TYPE FLAG FOR WORD 26
C     28          ZOFF1 (OFFSET)  OVERRIDDEN BY EST(12)
C     29 THRU 44  CID,X,Y,Z - GRIDS 1 THRU 4
C     45          ELEMENT TEMPERATURE
C
C
C          DATA FROM THE PLOAD4 CARD DESCRIBED HERE
C     ----------------------------------------------------------
C     EID  ELEMENT ID
C     P1,P2,P3,P4 CORNER GRID POINT PRESSURES PER UNIT SURFACE AREA
C     G1,G3  DEFINES QUADRILATERAL SURFACE OF HEXA, QUAD8, AND
C                 PENTA SURFACES ON WHICH PRESSURE LOADS EXIST
C                 OTHERWISE SURFACE IS TRIANGULAR IF G3 IS ZERO OR
C                 BLANK, SURFACE IS TRIANGULAR
C     CID  COORDINATE SYSTEM FOR DEFINITION OF PRESSURE VECTOR
C     N1,N2,N3 COMPONENTS OF PRESSURE DIRECTION VECTOR IF CID
C                 'BLANK' OR ZERO, THE PRESSURE ACTS NORMAL TO THE
C                 SURFACE OF THE ELEMENT
C
C     EQUIVALENT NUMERICAL INTEGRATION POINT LOADS PP(III) ARE
C     OBTAINED VIA BI-LINEAR INTERPOLATION
C*****
C     GENERAL INITIALIZATION.
C*****
C     BEST(45) IS THE DATA FOR EST WHICH IS READ IN EXTERN AND IS
C     READY TO BE USED.
C
C     READ FROM PLOAD4 CARDS
C     P1 = PPP(1)
C     P2 = PPP(2)
C     P3 = PPP(3)
C     P4 = PPP(4)
C     CID,N1,N2,N3
C*****
C
C
C     X WILL BE THE LENGTH OF THE PRESSURE VECTOR FOR NORMALIZATION.
C     NV(I) WILL BE THE NORMALIZED PRESSURE VECTOR
C
      X = 0.0
      DO 10 I = 1,4
   10 PPP(I) = SLT(I+1)
      DO 20 I = 1,3
      NV(I)  = SLT(I+8)
      X = X + NV(I)**2
   20 CONTINUE
      CID = ISLT(8)
C
      IF (X .EQ. 0.0) GO TO 40
      X = SQRT( X )
      DO 30 I = 1,3
   30 NV(I) = NV(I) / X
C
   40 NCRD = 3
C*****
C     PERFORM TEST FOR PRESENCE OF CONSTANT PRESSURE SET SWP
C*****
      SWP = 1
      IF (PPP(2).EQ.0. .AND. PPP(3).EQ.0. .AND. PPP(4).EQ.0.)
     1    SWP = 0
      NSURF = 4
C
C     THE ARRAY IORDER STORES THE ELEMENT NODE ID IN
C     INCREASING SIL ORDER.
C
C     IORDER(1) = NODE WITH LOWEST  SIL NUMBER
C     IORDER(4) = NODE WITH HIGHEST SIL NUMBER
C
C     ELEMENT NODE NUMBER IS THE INTEGER FROM THE NODE LIST G1,G2,G3,G4.
C     THAT IS, THE 'I' PART OF THE 'GI' AS THEY ARE LISTED ON THE
C     CONNECTIVITY BULK DATA CARD DESCRIPTION.
C
      KSILD = 99999995
      DO 100 I=1,4
      IORDER(I) = 0
      KSIL(I) = SIL(I)
  100 CONTINUE
      DO 120 I=1,4
      ITEMP = 1
      ISIL  = KSIL(1)
      DO 110 J=2,4
      IF (ISIL.LE.KSIL(J)) GO TO 110
      ITEMP = J
      ISIL  = KSIL(J)
  110 CONTINUE
      IORDER(I) = ITEMP
      KSIL(ITEMP) = 99999999
  120 CONTINUE
C*****
C     ADJUST EST DATA
C
C     USE THE POINTERS IN IORDER TO COMPLETELY REORDER THE
C     GEOMETRY DATA INTO INCREASING SIL ORDER.
C*****
      DO 140 I=1,4
      KSIL(I) = SIL(I)
      DO 130 J=1,4
      ITGRID(J,I) = IBGPDT(J,I)
  130 CONTINUE
  140 CONTINUE
      DO 160 I=1,4
      IPOINT = IORDER(I)
      SIL(I) = KSIL(IPOINT)
      DO 150 J=1,4
      IBGPDT(J,I) = ITGRID(J,IPOINT)
  150 CONTINUE
  160 CONTINUE
C
      NVCT = NCRD*4
      EPS  = 0.001
C*****
C     SET VALUES FOR NUMERICAL INTEGRATION POINTS AND WEIGHT FACTORS
C
C     DEFAULT INTEGRATION ORDER IS 2X2
C*****
      NUMINT = 2
      GAUSS(1) = -0.57735026918962
      GAUSS(2) = +0.57735026918962
      WTGAUS(1) = 1.0
      WTGAUS(2) = 1.0
C*****
C     ZERO OUT THE LOAD ROW SET
C*****
      DO 170 I=1,NDOF
      DO 170 J=1,4
  170 DPE(I,J) = 0.0
C*****
C     SET UP THE LOOPS FOR NUMERICAL INTEGRATION
C*****
      DO 350 IETA=1,NUMINT
      ETA = GAUSS(IETA)
      DO 350 IXSI=1,NUMINT
      XSI = GAUSS(IXSI)
      WEIGHT = WTGAUS(IXSI)*WTGAUS(IETA)
      P = 0.0
C*****
C     P1,P2,P3,P4 ARE THE GRID POINT PRESSURE LOADS PER UNIT
C     AREA FROM THE PLOAD4 CARD.  THESE WILL BE USED WITH A
C     BILINEAR SHAPE FUNCTION ROUTINE TO CALCULATE THE NODAL
C     LOADS.
C
C     BILINEAR CASE WHERE THE VALUES OF XSI,ETA ARE INPUT IN
C     EXPLICIT FORM DEPENDING UPON WHICH NUMERICAL INTEGRATION
C     SCHEME IS BEING USED.
C
C
C     NSURF IS AN INTEGER WHICH KEEPS TRACK OF THE SURFACE TYPE
C              NSURF = 3 . . .  TRIANGULAR SURFACE
C              NSURF = 4 . . .  QUADRILATERAL SURFACE
C
C*****
C     CALL SHAPE FCN. ROUTINE FOR THE BILINEAR QUAD4.  INPUT IS
C     XSI,ETA,III AND EVALUATION OF SHAPE FCN. AT INTEG.PTS
C     WILL BE PERFORMED.
C*****
      CALL Q4SHPS (XSI,ETA,SHP,DSHP)
C
      IF (SWP .EQ. 0) P=PPP(1)
      IF (SWP .EQ. 0) GO TO 200
C
      DO 180 III=1,NSURF
  180 P = P + SHP(III)*PPP(III)
  200 CONTINUE
C
C     SORT THE SHAPE FUNCTIONS AND THEIR DERIVATIVES INTO SIL ORDER.
C
      DO 210 I=1,4
      TMPSHP(I) = SHP(I)
      DSHPTP(I) = DSHP(I)
  210 DSHPTP(I+4) = DSHP(I+4)
      DO 220 I=1,4
      KK = IORDER(I)
      SHP (I  ) = TMPSHP(KK)
      DSHP(I  ) = DSHPTP(KK)
  220 DSHP(I+4) = DSHPTP(KK+4)
C*****
C     COMPUTE THE UNIT NORMALS V3T AT EACH GRID POINT.  THESE WILL
C     BE USED TO GET COMPONENTS OF PRESSURE VECTOR ACTING NORMAL TO
C     THE SURFACE.  AREA CALCULATION CHECKS THE GEOMETRY OF THE
C     ELEMENT.
C*****
      DO 230 I=1,3
      VI(I) = 0.0
      VJ(I) = 0.0
      DO 230 J=1,4
      II=I+1
      VI(I) = VI(I) + BGPDT(II,J) * DSHP(J)
  230 VJ(I) = VJ(I) + BGPDT(II,J) * DSHP(J+4)
C
C     CHECK FOR USER INPUT VECTOR TO ROTATE LOADS
C
      CALL SAXB (VI,VJ,V3T)
      AREA = SQRT(V3T(1)**2+V3T(2)**2+V3T(3)**2)
      IF (AREA .GT. 0.0) GO TO 300
C
      WRITE (NOUT,240) NEST(1)
  240 FORMAT ('0*** SYSTEM FATAL ERROR.  BAD GEOMETRY DETECTED FOR ',
     1        'QUAD4 ELEMENT ',I8,' WHILE PROCESSING PLOAD4 DATA.')
      NOGO = 1
      RETURN
C
  300 CONTINUE
      IF (X .EQ. 0.0) GO TO 330
C
C     CHECK FOR NON-ZERO CID AND NEED TO ROTATE USER'S VECTOR
C
      IF (CID .EQ. 0) GO TO 320
C
C     COMPUTE THE LOCATION OF THE INTEGRATION POINT SO THAT WE CAN
C     ROTATE THE USER VECTOR PER CID. THIS LOCATION REQUIRED ONLY IF
C     CID IS CYLINDRICAL OR SPHERICAL.
C
      LOCATE(1) = 0.
      LOCATE(2) = 0.
      LOCATE(3) = 0.
      DO 310 J=1,4
      LOCATE(1) = LOCATE(1) + BGPDT(2,J) * SHP(J)
      LOCATE(2) = LOCATE(2) + BGPDT(3,J) * SHP(J)
      LOCATE(3) = LOCATE(3) + BGPDT(4,J) * SHP(J)
  310 CONTINUE
      CALL GLBBAS (NV(1),NVX(1),LOCATE(1),CID)
C
C     NOW ROTATE THE PRESSURE LOAD
C
      V3T(1) = NVX(1) * AREA
      V3T(2) = NVX(2) * AREA
      V3T(3) = NVX(3) * AREA
      GO TO 330
  320 CONTINUE
C
C     NOW ROTATE THE PRESSURE LOAD
C
      V3T(1) = NV(1) * AREA
      V3T(2) = NV(2) * AREA
      V3T(3) = NV(3) * AREA
  330 CONTINUE
C
C*****
C     COMPUTE THE CONTRIBUTION TO THE LOAD MATRIX FROM THIS
C     INTEGRATION POINT AS NT * P * V3T
C*****
      DO 340 I=1,4
      DO 340 J=1,NDOF
  340 DPE(J,I) = DPE(J,I) + WEIGHT * P * SHP(I) * V3T(J)
  350 CONTINUE
C*****
C     END OF NUMERICAL INTEGRATION LOOPS
C
C     MOVE DATA FROM REAL ARRAY DPE TO SINGLE PRECISION PE
C     (NO MOVE, SINCE DPE IS EQUIVALENT TO PE)
C*****
C     DO 400 J=1,4
C     PE(1,J) = DPE(1,J)
C     PE(2,J) = DPE(2,J)
C     PE(3,J) = DPE(3,J)
C 400 CONTINUE
C*****
C     ADD ELEMENT LOAD TO OVERALL LOAD.
C*****
      JB = 25
      DO 430 J=1,4
      JB = JB + 4
      IF (NEST(JB) .EQ. 0) GO TO 410
      CALL BASGLB (PE(1,J),PE(1,J),BEST(JB+1),NEST(JB))
  410 CONTINUE
      JP = SIL(J) - 1
      DO 420 I=1,3
      Z(JP+I) = Z(JP+I) + PE(I,J)
  420 CONTINUE
  430 CONTINUE
      RETURN
      END

      SUBROUTINE GIPSST
C
C     THIS SUBROUTINE LOCATES ALL THE G AND K SET POINTS IN THE SPLINE
C     COORDINATE SYSTEM AND FORMS G FOR EACH SET THEN
C     INSERTS THE G INTO THE FULL SIZED G MATRIX
C
      LOGICAL         OXR,OYR,ZAP,KCOL
      INTEGER         SYSBUF,OUT,BUFF,BUFF1,TRL(7),TGKG(7),OLDID,IZ(28),
     1                PCSTM,PBGPT,NWR,TYPE,NS(2),PROE,PTE,ISNG,SLOPE,
     2                PG,PK,PROL,PTL,BUFF2,CTYPE,PSIL
      INTEGER         SCARD(10),CCARD(16)
      INTEGER         SPLINE,USETA,CSTM,BAGPDT,SILA,EQAERO,GM,GO,SCR1,
     1                SCR2,SCR3,SCR4,SCR5,KSIZE,GSIZE,GTKA
      DIMENSION       TL(9),ROL(3),AN(6),BLOCK(20),TGS(18),T(3),TG(9)
      DIMENSION       TT(9),Z(1),SRARD(10)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /ZNTPKX/ A,DUM(3),NR,IEOL,IEOR
      COMMON /SYSTEM/ SYSBUF,OUT
      COMMON /GICOM / SPLINE,USETA,CSTM,BAGPDT,SILA,EQAERO,GM,GO,GTKA,
     1                KSIZE,GSIZE,SCR1,SCR2,SCR3,SCR4,SCR5
      COMMON /UNPAKX/ ITC,II,J1,INCR
      COMMON /ZZZZZZ/ IZX(1)
C
C     CHANGE IN EQUIV FOR SIZE OF SCARD OR CCARD
C     NEED TO CHANGE PENDC
C
      EQUIVALENCE     (IZX(1),IZ(1),Z(1),SCARD(1),SRARD(1)),
     1                (IZ(11),CCARD(1)) ,(IZ(27),NGSET) ,(IZ(28),NKSET)
      DATA     NS   / 4HGIPS,4HST  /
      DATA     TGS  / 18*0.0       /
C
      PENDC = 28
      NOGO  = 0
      OLDID =-1
      LC    =-1
      NWDS  = KORSZ(IZ)
      BUFF  = NWDS - SYSBUF
      BUFF1 = BUFF - SYSBUF
      BUFF2 = BUFF1- SYSBUF
      TRL(1)= CSTM
      CALL RDTRL (TRL)
      IF (TRL(1) .LT. 0) TRL(3) = 0
      NCSTM = (TRL(3)+1)*14
      PCSTM = BUFF2 - NCSTM
      TRL(1)= BAGPDT
      CALL RDTRL (TRL)
      NBG   = TRL(2)*4
      PBGPT = PCSTM - NBG
      TRL(1)= SCR1
      CALL RDTRL (TRL)
      MAX   = TRL(2)
      IF (TRL(3) .EQ. 0) GO TO 1000
      I     = SCR2
      SCR2  = SCR3
      SCR3  = I
      IPASS = 0
C
C     INITIAL CORE CHECK
C
      IF (PBGPT-2*MAX .LT. 0) GO TO 993
C
C     OPEN SCR1 TO LOOP ON G AND K SET RECORDS
C
      CALL GOPEN (SCR1,IZ(BUFF+1),0)
C
C     READ IN CSTM AT PCSTM + 14 ADD BASIC COORD SYSTEM
C
    1 IZ(PCSTM  ) = 0
      IZ(PCSTM+1) = 1
      DO 5 I = 2,13
      Z(PCSTM+I) = 0.0
    5 CONTINUE
      Z(PCSTM+5) = 1.0
      Z(PCSTM+9) = 1.0
      Z(PCSTM+13)= 1.0
      IF (NCSTM .EQ. 14) GO TO 7
      IFIL = CSTM
      CALL GOPEN (CSTM,IZ(BUFF1+1),0)
      CALL READ  (*999,*999,CSTM,IZ(PCSTM+14),NCSTM-14,1,NWR)
      CALL CLOSE (CSTM,1)
    7 CALL PRETRS (IZ(PCSTM),NCSTM)
C
C     READ IN BAGPDT AT PBGPT
C
      IFIL = BAGPDT
      CALL GOPEN (BAGPDT,IZ(BUFF1+1),0)
      CALL READ  (*999,*999,BAGPDT,IZ(PBGPT),NBG,1,NWR)
      CALL CLOSE (BAGPDT,1)
C
C     READ SCR1 AND PROCESS A SPLINE DEPENDING ON TYPE
C
   10 N1  = MAX + 1
      IFIL= SCR1
      CALL READ (*500,*20,SCR1,IZ(1),N1,1,NWR)
   20 J   = 2
      TYPE= IZ(J)
      PG  = PENDC
      PK  = PG + NGSET
      PSIL= PK + NKSET
      IPK = PSIL + NGSET
      NP  = NGSET + NKSET
C
C     USE A K POINT TO PICK UP POINTER TO BAGPDT FOR
C     COORDINATE SYSTEM ID OF SPLINE
C
      NEWID = CCARD(2)
      CTYPE = CCARD(8)
      K = PCSTM
      J = PCSTM + NCSTM - 1
      IF (NEWID .EQ. OLDID) GO TO 40
      DO 30 I = K,J,14
      IF (IZ(I) .NE. NEWID) GO TO 30
      PROE = I + 2
      PTE  = I + 5
      OLDID = NEWID
      GO TO 40
   30 CONTINUE
      IC = NEWID
      GO TO 997
   40 GO TO (50,100), TYPE
C
C     SURFACE SPLINE
C
   50 GO TO (51,998,51,51,51), CTYPE
   51 CONTINUE
      IS  = 1
      PTL = PTE
      DO 54 I = 1,9
   54 TL(I) = Z(PTE+I-1)
      DO 60 I = 1,NP
      K = (IZ(PG+I)-1)*4
C
C     BASIC COORDINATES
C
      BX =  Z(PBGPT+K+1)
      BY =  Z(PBGPT+K+2)
      BZ =  Z(PBGPT+K+3)
      IF (NEWID .EQ. 0) GO TO 55
C
C     X AND Y OF SPLINE
C
      T1 = BX -  Z(PROE  )
      T2 = BY -  Z(PROE+1)
      T3 = BZ -  Z(PROE+2)
      Z(N1  ) = Z(PTE)*T1   + Z(PTE+3)*T2 + Z(PTE+6)*T3
      Z(N1+1) = Z(PTE+1)*T1 + Z(PTE+4)*T2 + Z(PTE+7)*T3
      GO TO 59
   55 Z(N1  ) = BX
      Z(N1+1) = BY
   59 N1 = N1 + 2
   60 CONTINUE
      K = MAX + 1
      J = K + 2*NGSET
      NCORE = PBGPT - N1
C
C     CORE CHECK
C
      N  = NGSET + 3
      ND = NKSET*2
      NN = N*N + 3*N + N*ND + ND*NGSET
      IF (NN .LT. NCORE) GO TO 70
      NCORE = BUFF2 - N1
      IF (NN .GT. NCORE) GO TO 992
      ZAP =.TRUE.
C
C     GET G FOR A SURFACE SPLINE
C
   70 CALL SSPLIN (NGSET,IZ(K),NKSET,IZ(J),0,0,1,1,SCARD(6),IZ(N1),
     1             NCORE,ISNG)
      IF (ISNG .EQ. 2) GO TO 998
      IF (NOGO .EQ. 1) GO TO 10
C
C     REVERSE SIGN OF SLOPE COLUMN
C
      K = N1
      DO 80 I = 1,NKSET
      K = K + NGSET
      DO 90 J = 1,NGSET
      Z(K) = -Z(K)
      K = K + 1
   90 CONTINUE
   80 CONTINUE
      GO TO 300
C
C     LINEAR SPLINE
C
  100 GO TO (101,130,101,101,101), CTYPE
C
C     CAERO2 PROSESSING   BODIES
C
  130 SCARD( 8) = NEWID
      SCARD( 9) = SCARD(10)
      SCARD(10) = -1.0
      IBTYP = CCARD(16)
      KD    = 1
      DO 135 I = 2,8
  135 TL(I) = 0.0
      TL(1) = 1.0
      TL(5) = 1.0
      TL(9) = 1.0
      GO TO 102
  101 KD = 2
  102 CONTINUE
C
C     FIND CORD SYSTEM OF LINEAR SPLINE
C
      IF (SCARD(8) .EQ. LC) GO TO 120
      DO 110 I = K,J,14
      IF (SCARD(8) .NE. IZ(I)) GO TO 110
      LC   = SCARD(8)
      PROL = I + 2
      PTL  = I + 5
      GO TO 120
  110 CONTINUE
      IC = SCARD(8)
      GO TO 997
  120 IF (NEWID.EQ.0 .AND. SCARD(8).EQ.0) GO TO 145
      T1 = Z(PROL  ) - Z(PROE)
      T2 = Z(PROL+1) - Z(PROE+1)
      T3 = Z(PROL+2) - Z(PROE+2)
      T1 = Z(PTE+2)*T1 + Z(PTE+5)*T2 + Z(PTE+8)*T3
      T2 = Z(PTE+5)*T1
      T3 = Z(PTE+8)*T1
      T1 = Z(PTE+2)*T1
      ROL(1) = Z(PROL  ) - T1
      ROL(2) = Z(PROL+1) - T2
      ROL(3) = Z(PROL+2) - T3
      T1 = Z(PTL+4)*Z(PTE+8) - Z(PTL+7)*Z(PTE+5)
      T2 = Z(PTL+7)*Z(PTE+2) - Z(PTL+1)*Z(PTE+8)
      T3 = Z(PTL+1)*Z(PTE+5) - Z(PTL+4)*Z(PTE+2)
      T4 = SQRT(T1*T1 + T2*T2 + T3*T3)
      IF (T4 .EQ. 0.0) GO TO 996
      TL(1) = T1/T4
      TL(4) = T2/T4
      TL(7) = T3/T4
      TL(2) = Z(PTE+5)*TL(7) - Z(PTE+8)*TL(4)
      TL(5) = Z(PTE+8)*TL(1) - Z(PTE+2)*TL(7)
      TL(8) = Z(PTE+2)*TL(4) - Z(PTE+5)*TL(1)
      TL(3) = Z(PTE+2)
      TL(6) = Z(PTE+5)
      TL(9) = Z(PTE+8)
  145 DO 160 I = 1,NP
C
C     BASIC CORD
C
      K  = (IZ(PG+I)-1)*4
      BX =  Z(PBGPT+K+1)
      BY =  Z(PBGPT+K+2)
      BZ =  Z(PBGPT+K+3)
      IF (NEWID.EQ.0 .AND. SCARD(8).EQ.0) GO TO 150
      T1 = BX - ROL(1)
      T2 = BY - ROL(2)
      T3 = BZ - ROL(3)
      Z(N1  ) = TL(1)*T1 + TL(4)*T2 + TL(7)*T3
      Z(N1+1) = TL(2)*T1 + TL(5)*T2 + TL(8)*T3
      GO TO 155
  150 Z(N1  ) = BX
      Z(N1+1) = BY
  155 N1 = N1 + 2
  160 CONTINUE
      IF (CTYPE .NE. 2) GO TO 169
      N1 = MAX + 1
      DO 165 I = 1,NP
      Z(N1+1) = Z(N1)
      Z(N1  ) = 0.0
  165 N1 = N1 + 2
C
C     CHECK CORE
C
  169 K = MAX + 1
      J = K + 2*NGSET
      NCORE = PBGPT - N1
      OYR = .FALSE.
      OXR = .FALSE.
      IF (SRARD( 9) .LT. 0.0) OXR = .TRUE.
      IF (SRARD(10) .LT. 0.0) OYR = .TRUE.
      IS = 3
      IF (OXR) IS = IS - 1
      IF (OYR) IS = IS - 1
      N  = IS*NGSET + 3
      ND = NKSET*(1+KD)
      NN = N*N + 3*N + N*ND + ND*NGSET*IS
      IF (NN .LT. NCORE) GO TO 170
      NCORE = BUFF2 - N1
      IF (NN .GT. NCORE) GO TO 992
      ZAP =.TRUE.
C
C     GET G FOR A LINEAR SPLINE
C
  170 CALL LSPLIN (NGSET,IZ(K),NKSET,IZ(J),0,KD,1,SCARD(6),SCARD(9),
     1             SCARD(10),SCARD(7),IZ(N1),NCORE,ISNG)
      IF (ISNG .EQ. 2) GO TO 998
      IF (NOGO .EQ. 1) GO TO 10
      IF (CTYPE.EQ. 2) GO TO 300
C
C     TRANSFORM G TO SPLINE COORDINATES
C
      TYL = 1.0
      TXL = 0.0
      IF (NEWID.EQ.0 .AND. SCARD(8).EQ.0) GO TO 190
      TYL = Z(PTE+1)*TL(2) + Z(PTE+4)*TL(5) + Z(PTE+7)*TL(8)
      TXL = Z(PTE+1)*TL(1) + Z(PTE+4)*TL(4) + Z(PTE+7)*TL(7)
C
C     MOVE COLUMNS UP
C
  190 NRGS = NGSET*IS
      K2   = NRGS + NRGS
      K3   = K2 + NRGS
      NCORE= N1
      N1   = N1 + NRGS - 1
      N2   = N1
      DO 200 I = 1,NKSET
      DO 210 K = 1,NRGS
      Z(N2+K) = Z(N1+K)*TXL + Z(N1+NRGS+K)*TYL
      Z(N2+NRGS+K) = Z(N1+K2+K)
  210 CONTINUE
      N1 = N1 + K3
      N2 = N2 + K2
  200 CONTINUE
      N1 = NCORE
C
C     TRANSFORM G INTO GLOBAL
C
  300 CONTINUE
C
C                         T
C     OPEN SCR2 TO WRITE G   MATRIX
C                         KG
C
      CALL GOPEN (SCR2,IZ(BUFF1+1),1)
      CALL GOPEN (SCR3,IZ(BUFF2+1),0)
      TGKG(3) = GSIZE
      TGKG(4) = 2
      TGKG(5) = 1
      TGKG(1) = SCR2
      TGKG(2) = 0
      TGKG(6) = 0
      TGKG(7) = 0
      IBCC    = 1
      SIGN    = 1.0
      SLOPE   = 1
      KCOL    = .FALSE.
      KN      = 1
      KCOLN   = IZ(IPK+KN)
C
C     KCOLN PICKS UP COLUMN NUMBER TO INSERT
C     KN POINT TO COLUMN OF G MATRIX
C     SLOPE IS FLIP FLOP SWITCH FOR SLOPE COLUMN (KEEPS KCOL TRUE)
C
C
C     LOOP THROUGH COLUMNS OF GKT
C
      DO 400 I = 1,KSIZE
      CALL BLDPK (1,1,SCR2,BLOCK,1)
      IF (KCOLN .EQ. I) KCOL = .TRUE.
C
C     COPY A COLUMN OR OUTPUT A NULL COLUMN
C
      CALL INTPK (*340,SCR3,0,1,0)
      IF (KCOL) GO TO 995
  330 CALL ZNTPKI
      CALL BLDPKI (A,NR,SCR2,BLOCK)
      IF (IEOL .EQ. 0) GO TO 330
      GO TO 390
  340 IF (.NOT.KCOL) GO TO 390
C
C     LOOP THROUGH COLUMN OF G BUILDING COLUMN OF GKT
C
      DO 380 J = 1,NGSET
      NR = IZ(PSIL+J)
      K  = (IZ(PG+J)-1)*4
      CALL TRANSS (IZ(PBGPT+K),TT)
      CALL GMMATS (TT,3,3,1,TL,3,3,0,TG)
      GO TO (350,360), TYPE
C
C     TERMS OF SURFACE SPLINE
C
  350 CONTINUE
      DO 351 JJ = 3,9,3
      A = TG (JJ)*Z(N1)
      CALL BLDPKI (A,NR,SCR2,BLOCK)
      NR = NR + 1
  351 CONTINUE
      N1 = N1 + 1
      GO TO 380
C
C     TERMS OF LINEAR SPLINE
C
  360 IF (CTYPE .EQ. 2) GO TO 370
      IF (IS .EQ. 1) GO TO 350
      TGS( 1) = TG(3)
      TGS( 4) = TG(6)
      TGS( 7) = TG(9)
      TGS(11) = TG(1)
      TGS(12) = TG(2)
      TGS(14) = TG(4)
      TGS(15) = TG(5)
      TGS(17) = TG(7)
      TGS(18) = TG(8)
      GO TO 365
C
C     BODIES
C
  370 GO TO (372,371,373), IBTYP
  371 GO TO (373,372,372,373), IBCC
  372 TGS( 1) = TG(3)*SIGN
      TGS( 4) = TG(6)*SIGN
      TGS( 7) = TG(9)*SIGN
      TGS(11) =-TG(2)*SIGN
      TGS(12) = TG(1)*SIGN
      TGS(14) =-TG(5)*SIGN
      TGS(15) = TG(4)*SIGN
      TGS(17) =-TG(8)*SIGN
      TGS(18) = TG(7)*SIGN
      GO TO 365
  373 TGS( 1) = TG(2)
      TGS( 4) = TG(5)
      TGS( 7) = TG(8)
      TGS(11) = TG(3)
      TGS(12) = TG(1)
      TGS(14) = TG(6)
      TGS(15) = TG(4)
      TGS(17) = TG(9)
      TGS(18) = TG(7)
  365 T(1) = Z(N1)
      N1   = N1 + 1
      T(2) = 0.0
      T(3) = 0.0
      IF (OXR) GO TO 361
      T(2) = Z(N1)
      N1   = N1 + 1
  361 IF (OYR) GO TO 362
      T(3) = Z(N1)
      N1   = N1 + 1
  362 CALL GMMATS (TGS,6,3,0,T,3,1,0,AN)
      DO 363 JJ = 1,6
      CALL BLDPKI (AN(JJ),NR,SCR2,BLOCK)
      NR = NR + 1
  363 CONTINUE
  380 CONTINUE
C
C     COLUMN FINISHED CHECKSLOPE COLUMN NEXT OR END OF G
C
      IF (CTYPE .NE. 3) GO TO 382
      N1 = N1 + NGSET*IS
      GO TO 384
  382 IF (CTYPE .NE. 2) GO TO 383
      IF (IBTYP .EQ. 1) SIGN = -SIGN
      IF (IBTYP .NE. 2) GO TO 383
      IBCC = IBCC + 1
      IF (IBCC .EQ. 3) SIGN = -SIGN
      IF (IBCC .EQ. 5) SIGN = -SIGN
      IF (IBCC .EQ. 5) IBCC = 1
C
C     KEEP SLOPE NEG FOR ZY BODIES AND REPROCESS SAME COLUMN TWICE
C
      IF (IBCC.EQ.2 .OR. IBCC.EQ.4) N1 = N1 - NGSET*IS
      IF (IBCC .GT. 2) GO TO 390
  383 SLOPE = -SLOPE
      IF (SLOPE .NE. 1) GO TO 390
  384 KN = KN + 1
      IF (KN .GT. NKSET) GO TO 385
      KCOLN = IZ(IPK+KN)
  385 KCOL  = .FALSE.
  390 CALL BLDPKN (SCR2,BLOCK,TGKG)
  400 CONTINUE
C
C     SWITCH FILES FOR ANOTHER SPLINE
C
      CALL CLOSE (SCR2,1)
      CALL WRTTRL (TGKG)
      CALL CLOSE (SCR3,1)
      I    = SCR2
      SCR2 = SCR3
      SCR3 = I
      IPASS= IPASS + 1
      IF (ZAP) GO TO 1
      GO TO 10
C
C     FINISHED SWITCH FILES SO OUTPUT IS SCR2
C
C
C     IF ALL DONE BE SURE SCR2 IS GTKA
C
  500 I    = SCR2
      SCR2 = SCR3
      SCR3 = I
      IF (SCR3 .NE. 201) GO TO 520
      CALL GOPEN (SCR2,Z(BUFF1),0)
      CALL GOPEN (SCR3,Z(BUFF2),1)
      TGKG(1) = SCR2
      CALL RDTRL (TGKG)
      N    = TGKG(2)
      TGKG(1) = SCR3
      TGKG(2) = 0
      TGKG(6) = 0
      TGKG(7) = 0
      INCR = 1
      ITC  = 1
      CALL CYCT2B (SCR2,SCR3,N,Z,TGKG)
      CALL CLOSE (SCR2,1)
      CALL CLOSE (SCR3,1)
      CALL WRTTRL (TGKG)
  520 CONTINUE
      CALL CLOSE (SCR1,1)
      IF (NOGO .EQ. 0) GO TO 1000
C
C     ERROR MESSAGES
C
      CALL MESAGE (-61,0,NS)
  999 CALL MESAGE (-3,IFIL,NS)
  993 CALL MESAGE (-8,0,NS)
  998 WRITE  (OUT,9980) UFM,SCARD(1)
 9980 FORMAT (A23,' 2260, SINGULAR MATRIX DEVELOPED WHILE PROCESSING ',
     1       'SPLINE',I9)
      GO TO  1001
  997 CALL MESAGE (30,25,IC)
      GO TO 1001
  996 WRITE  (OUT,9960) UFM,SCARD(1),CCARD(1)
 9960 FORMAT (A23,' 2261, PLANE OF LINEAR SPLINE',I9,
     1        ' PERPENDICULAR TO PLANE OF AERO ELEMENT',I9)
      GO TO 1001
  995 WRITE  (OUT,9950) UFM,SCARD(1)
 9950 FORMAT (A23,' 2262, SPLINE',I9,' INCLUDES AERO BOX INCLUDED ON A',
     1       ' EARLIER SPLINE')
      GO TO 1001
  992 WRITE  (OUT,9920) UFM,SCARD(1)
 9920 FORMAT (A23,' 2263, INSUFFICIENT CORE TO PROCESS SPLINE',I9)
 1001 NOGO = 1
      GO TO 10
 1000 RETURN
      END

      BLOCK DATA SDR2BD
CSDR2BD
      IMPLICIT INTEGER (A-Z)
C
      INTEGER         RFMTS(40)
C
      COMMON /SDR2X1/ IEIGEN,IELDEF,ITLOAD,ISYMFL,ILOADS,IDISPL,ISTR  ,
     1                IELF  ,IACC  ,IVEL  ,ISPCF ,ITTL  ,ILSYM ,IFROUT,
     2                ISLOAD,IDLOAD,ISORC
C
      COMMON /SDR2X2/ CASECC,CSTM  ,MPT   ,DIT   ,EQEXIN,SIL   ,GPTT  ,
     1                EDT   ,BGPDT ,PG    ,QG    ,UGV   ,EST   ,PHIG  ,
     2                EIGR  ,OPG1  ,OQG1  ,OUGV1 ,OES1  ,OEF1  ,PUGV1 ,
     3                OEIGR ,OPHIG ,PPHIG ,ESTA  ,GPTTA ,HARMS ,XYCDB ,
     4                SCR3  ,PCOMPS,OES1L ,OEF1L
C
      COMMON /SDR2X4/ NAM(2),END   ,MSET  ,ICB(7),OCB(7),MCB(7),DTYPE(8)
     1,               ICSTM ,NCSTM ,IVEC  ,IVECN ,TEMP  ,DEFORM,FILE  ,
     2                BUF1  ,BUF2  ,BUF3  ,BUF4  ,BUF5  ,ANY   ,ALL   ,
     3                TLOADS,ELDEF ,SYMFLG,BRANCH,KTYPE ,LOADS ,SPCF  ,
     4                DISPL ,VEL   ,ACC   ,STRESS,FORCE ,KWDEST,KWDEDT,
     5                KWDGPT,KWDCC ,NRIGDS,STA(2),REI(2),DS0(2),DS1(2),
     6                FRQ(2),TRN(2),BK0(2),BK1(2),CEI(2),PLA(22)      ,
     7                NRINGS,NHARMS,AXIC  ,KNSET ,ISOPL ,STRSPT,DDRMM ,
     8                ISOPL8
C
      EQUIVALENCE     (STA(1),RFMTS(1))
C
C*****
C     DATA DEFINING POSITIONS OF PARAMETERS IN A CASE CONTROL RECORD.
C*****
      DATA  IEIGEN/  5/,IELDEF/  6/,ITLOAD/  7/,ISYMFL/ 16/,ILOADS/ 17/,
     1      IDISPL/ 20/,ISTR  / 23/,IELF  / 26/,IACC  / 29/,IVEL  / 32/,
     2      ISPCF / 35/,ITTL  / 39/,ILSYM /200/,IFROUT/145/,ISLOAD/  4/,
     3      IDLOAD/ 13/,ISORC /136/
C*****
C     DATA DEFINING DATA BLOCK FILE NUMBERS.
C*****
      DATA  CASECC/101/,CSTM  /102/,MPT   /103/,DIT   /104/,EQEXIN/105/,
     1      SIL   /106/,GPTT  /107/,EDT   /108/,BGPDT /109/,PG    /110/,
     2      QG    /111/,UGV   /112/,EST   /113/,PHIG  /112/,EIGR  /110/,
     3      OPG1  /201/,OQG1  /202/,OUGV1 /203/,OES1  /204/,OEF1  /205/,
     4      PUGV1 /206/,OEIGR /201/,OPHIG /203/,PPHIG /206/,ESTA  /301/,
     5      GPTTA /302/,HARMS /137/,XYCDB /114/,SCR3  /303/,PCOMPS/116/,
     6      OES1L /207/,OEF1L /208/
C*****
C     DATA DEFINING RIGID FORMATS.
C*****
      DATA  NRIGDS/ 10   /,
     1      RFMTS / 4HSTAT,4HICS ,
     2              4HREIG,4HEN  ,
     3              4HDS0 ,4H    ,
     4              4HDS1 ,4H    ,
     5              4HFREQ,4H    ,
     6              4HTRAN,4HSNT ,
     7              4HBKL0,4H    ,
     8              4HBKL1,4H    ,
     9              4HCEIG,4HEN  ,
     O              4HPLA ,4H    ,
     1              20*0         /
C*****
C     MISC. DATA.
C*****
      DATA   NAM  / 4HSDR2,4H    /, END/4HEND /, DTYPE/2,3,1,5,4,6,7,8/,
     1       MSET / 1001/ ,ISOPL8/  0  /
C
      END

      SUBROUTINE FACTOR (INPUT,LOWER,SCR1,SCR2,SCR3,SCR4)
C
      IMPLICIT INTEGER (A-Z)
      INTEGER          BCD(2)
      DOUBLE PRECISION DET
      COMMON /SYSTEM/  KSYSTM(65)
      COMMON /SFACT /  FILEA(7),FILEL(7),FILEU(7),SCR1FL,SCR2FL,NZ    ,
     1                 DET(2)  ,P       ,SCR3FL  ,XX3   ,XX4   ,CHL
      COMMON /ZZZZZZ/  Z(1)
      DATA    LOWTRI/  4 /
      DATA    BCD   /  4HFACT,4HOR   /
C
C     INITIALIZE MATRIX CONTROL BLOCKS AND SFACT COMMON
C
      NZ = KORSZ(Z)
      FILEA(1) = INPUT
      CALL RDTRL (FILEA)
      CALL MAKMCB (FILEL,LOWER,FILEA(3),LOWTRI,FILEA(5))
      FILEU(1) = IABS(SCR1)
      SCR1FL = SCR2
      SCR2FL = SCR3
      SCR3FL = SCR4
      CHL = 0
      IF (SCR1 .LT. 0) CHL = 1
C
C     DECOMPOSE INPUT MATRIX INTO LOWER TRIANGULAR FACTOR.
C
      CALL SDCOMP (*40,Z,Z,Z)
C
C     WRITE TRAILER FOR LOWER TRIANGULAR FACTOR.
C
      CALL WRTTRL (FILEL)
      RETURN
C
C     FATAL ERROR MESSAGE FOR SINGULAR INPUT MATRIX
C
   40 CALL MESAGE (-5,INPUT,BCD)
      RETURN
      END

      SUBROUTINE RCOVUI (UB,LASTSS,MODAL)
C
C     THIS ROUTINE CALCULATES THE IMPROVED LOWER LEVEL DISPLACEMENTS
C     ON A REDUCED SUBSTRUCTURE WHICH INCLUDE INERTIA AND DAMPING
C     EFFECTS
C
      LOGICAL          REQF       ,MODAL
      INTEGER          UB         ,SOF1       ,SOF2       ,SOF3      ,
     1                 BUF1       ,BUF2       ,SCR2       ,SCR3      ,
     2                 SCR4       ,SCR5       ,SCR6       ,SCR7      ,
     3                 SCR8       ,SCR9       ,MPYZ       ,TFLAG     ,
     4                 SIGNAB     ,HORG       ,BMTX       ,UPRT      ,
     5                 SIGNC      ,SCRM       ,Z          ,RC        ,
     6                 DRY        ,FSS        ,RFNO       ,RSS       ,
     7                 UA         ,BUF4       ,BGG        ,PID       ,
     8                 UAO        ,RULE       ,TYPA       ,TYPB      ,
     9                 BUF3       ,UPART      ,LASTSS(2)  ,GIMS      ,
     O                 DUA        ,UAD        ,TYPIN      ,TYPOT     ,
     1                 TYPC       ,NAME(2)
      REAL             RZ(1)
      DOUBLE PRECISION DZ(1)
      COMMON /BLANK /  DRY        ,LOOP       ,STEP       ,FSS(2)    ,
     1                 RFNO       ,NEIGV      ,LUI        ,UINMS(2,5),
     2                 NOSORT     ,UTHRES     ,PTHRES     ,QTHRES
      COMMON /RCOVCR/  ICORE      ,LCORE      ,BUF1       ,BUF2      ,
     1                 BUF3       ,BUF4       ,SOF1       ,SOF2      ,
     2                 SOF3
      COMMON /RCOVCM/  MRECVR     ,UA         ,PA         ,QA        ,
     1                 IOPT       ,RSS(2)     ,ENERGY     ,UIMPRO    ,
     2                 RANGE(2)   ,IREQ       ,LREQ       ,LBASIC
      COMMON /ZZZZZZ/  Z(1)
      COMMON /MPYADX/  MCBA(7)    ,MCBB(7)    ,MCBC(7)    ,MCBD(7)   ,
     1                 MPYZ       ,TFLAG      ,SIGNAB     ,SIGNC     ,
     2                 MPREC      ,SCRM
      COMMON /NAMES /  RD         ,RDREW      ,WRT        ,WRTREW    ,
     1                 REW        ,NOREW      ,EOFNRW     ,RSP       ,
     2                 RDP        ,CSP        ,CDP        ,SQUARE    ,
     3                 RECT       ,DIAG       ,UPPER      ,LOWER     ,
     4                 SYM
      COMMON /PARMEG/  MCB(7)     ,MCB11(7)   ,MCB21(7)   ,MCB12(7)  ,
     1                 MCB22(7)   ,MRGZ       ,RULE
      COMMON /SADDX /  NOMAT      ,LCOR       ,MCBAA(7)   ,TYPA      ,
     1                 ALPHA      ,ALP(3)     ,MCBBB(7)   ,TYPB      ,
     2                 BETA       ,BET(3)     ,MCBCC(7)   ,TYPC      ,
     3                 GAMA       ,GAM(3)     ,DUM(24)    ,MCBXX(7)
      COMMON /PACKX /  TYPIN      ,TYPOT      ,IRO        ,NRO       ,
     1                 INCRP
      EQUIVALENCE      (DZ(1),RZ(1),Z(1))
      DATA    SCR2  ,  SCR3,SCR4,SCR5,SCR6,SCR7,SCR8,SCR9 /
     1        302   ,  303 ,304 ,305 ,306 ,307 ,308 ,309  /
      DATA    HORG  ,  MMTX,BMTX,UPRT /  4HHORG,4HMMTX,4HBMTX,4HUPRT /
      DATA    K4MX  /  4HK4MX/,  K4GG / 110  /
      DATA    GIMS  ,  NHPDAT/ 4HGIMS,4HPDAT /
      DATA    MGG   ,  BGG   / 104,109/
      DATA    NAME  / 4 HRCOV, 4HUI   /
C
C     INITILIZE
C
      LCOREZ = KORSZ(Z) - LREQ - ICORE - 1
      IDPCOR = ICORE/2 + 1
      TFLAG  = 0
      SIGNAB = 1
      SIGNC  = 1
      MPREC  = 0
      SCRM   = 309
      REQF   = .FALSE.
      IF (LASTSS(1).EQ.FSS(1) .AND. LASTSS(2).EQ.FSS(2)) REQF = .TRUE.
C
C     GENERATE THE PARTIAL LOAD VECTOR USING THE NORMAL TRANSFORMATION
C
C     UPARTIAL = HORG*UB
C
      ITEM = HORG
      CALL MTRXI (SCR2,LASTSS,HORG,0,RC)
      IF (RC .NE. 1) GO TO 6317
C
      MCBA(1) = SCR2
      CALL RDTRL (MCBA)
      MCBB(1) = UB
      CALL RDTRL (MCBB)
      MCBC(1) = 0
      UPART   = SCR5
      CALL MAKMCB (MCBD,UPART,MCBA(3),RECT,MCBB(5))
      MPYZ    = LCOREZ
      CALL SOFCLS
      CALL MPYAD (DZ(IDPCOR),DZ(IDPCOR),DZ(IDPCOR))
      CALL WRTTRL (MCBD)
      CALL SOFOPN (Z(SOF1),Z(SOF2),Z(SOF3))
C
C     DETERMINE THE NUMBER OF OMITTED POINTS
C
      NROWO = MCBA(3) - MCBA(2)
      CALL SOFTRL (LASTSS,GIMS,MCBA)
      IF (MCBA(1) .EQ. 1) NROWO = MCBA(3)
C
C     GENERATE THE VELOCITIES AND ACCELERATIONS
C
      LCORE = BUF4 - ICORE - 1
      CALL RCOVVA (UPART,0,0,0,SCR7,SCR8,LASTSS,DZ(IDPCOR),DZ(IDPCOR),
     1             DZ(IDPCOR))
      IF (UPART .LE. 0) GO TO 9000
C
C     CALCULATE THE INERTIAL AND DAMPING LOADS
C
C     PID = -M*A - B*V
C
C     CALCULATE THE INERTAIL LOADS
C
      PID = 0
      IF (.NOT.REQF) GO TO 100
      MCBA(1) = MGG
      IF (MCBA(1) .GT. 0) GO TO 110
  100 CALL MTRXI (SCR2,LASTSS,MMTX,0,RC)
      IF (RC .NE. 1) GO TO 200
      MCBA(1) = SCR2
      CALL RDTRL (MCBA)
  110 MCBB(1) = SCR8
      CALL RDTRL (MCBB)
      MCBC(1) = 0
      CALL MAKMCB (MCBD,SCR6,MCBB(3),RECT,MCBB(5))
      SIGNAB = -1
      CALL SOFCLS
C
      CALL MPYAD (DZ(IDPCOR),DZ(IDPCOR),DZ(IDPCOR))
C
      DO 120 I = 1,7
  120 MCBC(I) = MCBD(I)
      PID = SCR6
      CALL SOFOPN (Z(SOF1),Z(SOF2),Z(SOF3))
C
C     CALCULATE THE DAMPING LOADS
C
  200 IF (RFNO .EQ. 3) GO TO 300
      IF (.NOT.REQF  ) GO TO 201
      MCBA(1) = K4GG
      CALL RDTRL (MCBA)
      IF (MCBA(1) .GT. 0) GO TO 202
  201 CALL MTRXI (SCR2,LASTSS,K4MX,0,RC)
      IF (RC .NE. 1) GO TO 209
      MCBA(1) = SCR2
      CALL RDTRL (MCBA)
  202 MCBB(1) = SCR7
      CALL RDTRL (MCBB)
      CALL MAKMCB (MCBD,SCR8,MCBB(3),RECT,MCBB(5))
      SIGNAB = -1
      CALL SOFCLS
      CALL MPYAD (DZ(IDPCOR),DZ(IDPCOR),DZ(IDPCOR))
      PID = SCR8
      CALL SOFOPN (Z(SOF1),Z(SOF2),Z(SOF3))
      DO 203 I = 1,7
  203 MCBC(I) = MCBD(I)
C
  209 IF (.NOT.REQF) GO TO 210
      MCBA(1) = BGG
      CALL RDTRL (MCBA)
      IF (MCBA(1) .GT. 0) GO TO 220
  210 CALL MTRXI (SCR2,LASTSS,BMTX,0,RC)
      IF (RC .NE. 1) GO TO 300
      MCBA(1) = SCR2
      CALL RDTRL (MCBA)
  220 MCBB(1) = SCR7
      CALL RDTRL (MCBB)
      CALL MAKMCB (MCBD,SCR6,MCBB(3),RECT,MCBB(5))
      SIGNAB = -1
      CALL SOFCLS
      CALL MPYAD(DZ(IDPCOR),DZ(IDPCOR),DZ(IDPCOR))
      PID = SCR6
      CALL SOFOPN (Z(SOF1),Z(SOF2),Z(SOF3))
C
C     PARTITION THE INERTIA AND DAMPING LOADS TO THE OMIT SET
C
C     GET THE PARTITIONING VECTOR FROM THE SOF
C
  300 IF (PID .EQ. 0) GO TO 400
      ITEM = UPRT
      CALL MTRXI (SCR2,LASTSS,UPRT,0,RC)
      IF (RC .NE. 1) GO TO 6317
      RULE = 0
      MRGZ = LCOREZ - 14
      IDP  = (ICORE+14)/2 + 1
      DO 310 I = 1,7
  310 MCB(I) = MCBD(I)
      PID  = SCR4
      CALL MAKMCB (MCB11,PID,NROWO,RECT,MCBD(5))
      MCB11(2) = MCBD(2)
      MCB12(1) = 0
      MCB21(1) = 0
      MCB22(1) = 0
C
C     SET UP A NULL ROW PARTITION VECTOR
C
      Z(ICORE) = SCR2
      CALL RDTRL (Z(ICORE))
      CALL MAKMCB (Z(ICORE+7),0,MCB(2),RECT,RSP)
      Z(ICORE+8) = 1
      CALL SOFCLS
      CALL PARTN (Z(ICORE+7),Z(ICORE),DZ(IDP))
      CALL WRTTRL (MCB11)
      CALL SOFOPN (Z(SOF1),Z(SOF2),Z(SOF3))
C
C     PERFORM THE FBS TO GET THE LOADS ON THE OMMITTED POINTS.  WE
C     WILL ALSO ADD IN THE EFFECTS OF THE DAMPING AND INERTIAL LOADS
C
  400 CALL RCOVUO (PID,UAO,LASTSS)
      CALL SOFOPN (Z(SOF1),Z(SOF2),Z(SOF3))
      IF (IOPT .LT. 0) GO TO 9000
C
C     IF RECOVERING A MODAL REDUCED SUBSTRUCTURE, CALCULATE
C     THE MODAL CORRECTION TO THE U PARTIAL
C
      DUA = 0
      IF (.NOT.MODAL) GO TO 900
C
C     IF RF-9, SPLIT THE DISPLACEMENTS FROM THE TOTAL VECTOR
C
      UAD = UPART
      IF (RFNO .NE. 9) GO TO 500
      UAD = SCR9
      CALL RCOVVA (UPART,1,0,UAD,0,0,LASTSS,DZ(IDPCOR),DZ(IDPCOR),
     1             DZ(IDPCOR))
C
C     PARTITION THE PARTIAL DISPLACEMENTS TO THE OMITTED AND
C     BOUNDARY SIZES
C
  500 ITEM = UPRT
      CALL MTRXI (SCR2,LASTSS,UPRT,0,RC)
      IF (RC .NE. 1) GO TO 6317
      RULE = 0
      MRGZ = LCOREZ - 14
      IDP  = (ICORE + 14)/2 + 1
      MCB(1) = UAD
      CALL RDTRL (MCB)
      CALL MAKMCB (MCB11,SCR3,NROWO,RECT,MCB(5))
      CALL MAKMCB (MCB21,SCR4,MCB(3)-NROWO,RECT,MCB(5))
      MCB11(2) = MCB(2)
      MCB21(2) = MCB(2)
      MCB12(1) = 0
      MCB22(1) = 0
C
      Z(ICORE) = SCR2
      CALL RDTRL (Z(ICORE))
      CALL MAKMCB (Z(ICORE+7),0,MCB(2),RECT,RSP)
      Z(ICORE+8) = 1
      CALL SOFCLS
C
      CALL BUG (NHPDAT,500,MCB(1),37)
      CALL PARTN (Z(ICORE+7),Z(ICORE),DZ(IDP))
      CALL WRTTRL (MCB11)
      CALL WRTTRL (MCB21)
C
      CALL SOFOPN (Z(SOF1),Z(SOF2),Z(SOF3))
C
C     CALCULATE THE CORRECTION TERMS
C
C     DUO = GI*UB - UO
C
      ITEM = GIMS
      CALL MTRXI (SCR6,LASTSS,GIMS,0,RC)
      IF (RC .NE. 1) GO TO 6317
      MCBA(1) = SCR6
      CALL RDTRL (MCBA)
      DO 520 I = 1,7
      MCBB(I) = MCB21(I)
      MCBC(I) = MCB11(I)
  520 CONTINUE
      CALL MAKMCB (MCBD,SCR9,MCBA(3),RECT,MCBB(5))
      SIGNAB = 1
      SIGNC  =-1
      TFLAG  = 0
      SCRM   = 308
      MPREC  = 0
      CALL SOFCLS
      MPYZ   = MRGZ
      CALL MPYAD (DZ(IDP),DZ(IDP),DZ(IDP))
      CALL WRTTRL (MCBD)
C
C     MERGE DUO TO -A- SIZE
C
      DO 540 I = 1,7
  540 MCB11(I) = MCBD(I)
      MCB21(1) = 0
      DUA = SCR4
      CALL MAKMCB (MCB,DUA,Z(ICORE+2),RECT,MCB11(5))
      MCB(2) = MCBD(2)
      IF (RFNO .EQ. 9) MCB(2) = 3*MCBD(2)
C
C     SET UP A NULL ROW PARTITIONING VECTOR (OR FOR RF-9)
C     SET UP A VECTOR THAT WILL MERGE IN A NULL VELOCITY AND
C     ACCELERATION VECTOR FOR EACH DISPLACEMENT VECTOR
C
      NRO = MCB(2)
      CALL MAKMCB (Z(ICORE+7),SCR3,NRO,RECT,RSP)
      IF (NRO+15 .GT. LCOREZ) GO TO 9008
      DO 550 I = 1,NRO
  550 RZ(ICORE+14+I) = 0.0
      IF (RFNO .NE. 9) GO TO 570
      DO 560 I = 1,NRO,3
      RZ(ICORE+15+I) = 1.0
  560 RZ(ICORE+16+I) = 1.0
  570 CONTINUE
      CALL GOPEN (SCR3,Z(BUF1),WRTREW)
      TYPIN = 1
      TYPOT = 1
      IRO   = 1
      INCRP = 1
      CALL PACK (Z(ICORE+15),SCR3,Z(ICORE+7))
      CALL CLOSE (SCR3,REW)
      CALL WRTTRL (Z(ICORE+7))
      CALL MERGE (Z(ICORE+7),Z(ICORE),DZ(IDP))
      CALL WRTTRL (MCB)
C
C     ADD THE PARTIAL DISPLACEMENT VECTOR TO THE DISPLACEMENTS FROM
C     THE OMITS, INERTIAL, DAMPING, AND MODAL CORRECTION EFFECTS
C     TO GET THE FINAL DISPLACEMENT VECTOR FOR THIS SUBSTRUCTURE
C
  900 NOMAT = 2
      IF (DUA .NE. 0) NOMAT = 3
      TYPA  = 1
      ALPHA = 1.0
      MCBAA(1) = UPART
      CALL RDTRL (MCBAA)
      TYPB = 1
      BETA = 1.0
      MCBBB(1) = UAO
      CALL RDTRL (MCBBB)
      IF (DUA .EQ. 0) GO TO 910
      TYPC = 1
      GAMA = 1.0
      MCBCC(1) = DUA
      CALL RDTRL (MCBCC)
  910 CALL MAKMCB (MCBXX,UA,MCBAA(3),RECT,MCBAA(5))
      MCBXX(2) = MCBAA(2)
      LCOR = LCOREZ
      CALL SOFCLS
      CALL SADD (DZ(IDPCOR),DZ(IDPCOR))
      CALL WRTTRL (MCBXX)
C
C     NORMAL RETURN
C
      SIGNAB = 1
      RETURN
C
C     ERROR MESSAGES
C
 6317 IF (RC .EQ. 2) RC = 3
      CALL SMSG (RC-2,ITEM,LASTSS)
 9000 IOPT = -1
      RETURN
C
 9008 CALL MESAGE (8,0,NAME)
      GO TO 9000
      END

      SUBROUTINE XPARAM
C
C     THE PURPOSE OF XPARAM IS TO GENERATE THE PARAMETER SECTION OF AN
C     OSCAR ENTRY,AND TO GENERATE THE VPS TABLE.
C
C          ... DESCRIPTION OF PROGRAM VARIABLES ...
C     ITMP   = TEMPORARY STORAGE FOR PARAMETER NAME AND VALUE.
C     IPVAL  = HIGHEST PRIORITY NOMINAL VALUE IN ITMP.
C     IPRVOP = PREVIOUS OPERATOR OR OPERAND RECEIVED FROM DMAP.
C     INDEX  = TABLE CONTAINING ROW INDEXES FOR ISYNTX TABLE.
C     ISYNTX = SYNTAX TABLE USED TO PROCESS DMAP PARAMETER LIST.
C     NVSTBL = NOMINAL VALUE SOURCE TABLE.
C     NOSPNT = POINTER TO PARAMETER COUNT IN PARAMETER SECTION OF OSCAR.
C     IOSPNT = POINTER TO NEXT AVAILABLE WORD IN OSCAR.
C     ENDCRD = END OF CARD FLAG
C     MPLLN  = LENGTH(IN WORDS) OF MPL PARAMETER VALUE
C     ITYPE  = TABLE FOR TRANSLATING NUMBER TYPE CODES TO WORD LENGTH.
C     ENDCRD = FLAG INDICATING END OF CARD SENSED.
C
C     RETURN CODES FROM XSCNDM
C
C        1  DELIMITOR
C        2  BCD
C        3  VALUE
C        4  END OF CARD
C        5  ERROR ENCOUNTERED
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        LSHIFT,RSHIFT,ANDF,ORF
      DIMENSION       ITMP(7),INDEX(2,2),ISYNTX(4,5),NVSTBL(4,4),
     1                ITYPE(6),OSCAR(1),OS(5)
      COMMON /SYSTEM/ BUFSZ,OPTAPE,NOGO
      COMMON /XGPIC / ICOLD,ISLSH,IEQUL,NBLANK,NXEQUI,
     1                NDIAG,NSOL,NDMAP,NESTM1,NESTM2,NEXIT,
     2                NBEGIN,NEND,NJUMP,NCOND,NREPT,NTIME,NSAVE,NOUTPT,
     3                NCHKPT,NPURGE,NEQUIV,
     4                NCPW,NBPC,NWPC,
     5                MASKHI,MASKLO,ISGNON,NOSGN,IALLON,MASKS(1)
      COMMON /XGPID / XXGPID(8),MODFLG
      COMMON /ZZZZZZ/ CORE(1)
      COMMON /XGPI2 / LMPL,MPLPNT,MPL(1)
      COMMON /XGPI3 / PVT(2)
      COMMON /XGPI4 / IRTURN,INSERT,ISEQN,DMPCNT,
     1                IDMPNT,DMPPNT,BCDCNT,LENGTH,ICRDTP,ICHAR,NEWCRD,
     2                MODIDX,LDMAP,ISAVDW,DMAP(1)
      COMMON /XVPS  / VPS(2)
      COMMON /AUTOSM/ NWORDS,SAVNAM(100)
      EQUIVALENCE     (CORE(1),OS(1),LOSCAR),(OS(2),OSPRC),
     1                (OS(3),OSBOT),(OS(4),OSPNT),(OS(5),OSCAR(1))
C
      DATA   INDEX  / 1,3,2,4/,
     1       ISYNTX / 3*1,8,3*2,7,3*3,5,4*4,4*6/,
     2       NVSTBL / 1,1,3,3,1,1,4,4,1,1,4,4,1,2,4,2/,
     3       ITYPE  / 1,1,2,2,2,4/,
     4       IC  /4HC   /,  IV/4HV   /,  IY   /4HY   /,  IN/4HN   /,
     5       NVPS/4HVPS /,  IS/4HS   /,  IASTK/4H*   /,
     6       NAME/1 /, IVAL/2/, NONE/1/, IMPL/2/, IDMAP/3/, IPVT/4/
C
C     INITIALIZE
C
      OR (I,J) = ORF(I,J)
      AND(I,J) = ANDF(I,J)
      ENDCRD = 0
      IPRVOP = ISLSH
      NOSPNT = OSCAR(OSPNT) + OSPNT
      IOSPNT = NOSPNT + 1
      OSCAR(NOSPNT) = 0
      MPLBOT = MPL(MPLPNT-7) + MPLPNT - 7
C
C     GET FIRST/NEXT TYPE AND MODIFY CODES FROM DMAP,CHECK FOR $
C
   10 NEWTYP = 0
      ISAVE  = 0
   15 CALL XSCNDM
      GO TO (600,20,601,410,570), IRTURN
   20 IF (DMAP(DMPPNT) .EQ. NBLANK) GO TO 15
      OSCAR(NOSPNT) = 1 + OSCAR(NOSPNT)
      J = DMAP(DMPPNT)
      IF (J.NE.IC .AND. J.NE.IV .AND. J.NE.IS) GO TO 602
      IF (J .EQ. IS) ISAVE = 1
      I = 1
      IF (J .EQ.IC) I = 2
      CALL XSCNDM
      GO TO (470,30,470,470,570), IRTURN
   30 K = DMAP(DMPPNT)
      IF (K.NE.IY .AND. K.NE.IN) GO TO 470
      J = 1
      IF (K.EQ.IN .OR. K.EQ.IS) J = 2
C
C     USE I AND J TO OBTAIN ROW INDEX FOR SYNTAX TABLE.
C
   75 I = INDEX(I,J)
C
C     INITIALIZE IPVAL,AND ITMP WITH MPL DATA
C
      IF (MPLPNT .GE. MPLBOT) GO TO 580
      DO 40 K = 1,7
   40 ITMP(K) = 0
      ITMP(3) = IABS(MPL(MPLPNT))
C
C     CONVERT PARAMETER TYPE CODE TO WORD LENGTH
C
      K = ITMP(3)
      MPLLN = ITYPE(K)
      IPVAL = NONE
      IF (MPL(MPLPNT) .LT. 0) GO TO 60
      DO 50 K = 1,MPLLN
      MPLPNT = MPLPNT + 1
   50 ITMP(K+3) = MPL(MPLPNT)
      IPVAL  = IMPL
   60 MPLPNT = MPLPNT + 1
      IF (NEWTYP .EQ. 1) GO TO (620,100,110,120,570), IRTURN
C
C     SCAN DMAP FOR PARAMETER NAME AND VALUE IF ANY, AND CODE DMAP ENTRY
C     FOR USE AS COLUMN INDEX IN SYNTAX TABLE.
C
   70 CALL XSCNDM
      GO TO (90,100,110,120,570), IRTURN
   90 IF (DMAP(DMPPNT+1).NE.IEQUL .AND. DMAP(DMPPNT+1).NE.ISLSH .AND.
     1    DMAP(DMPPNT+1).NE.IASTK) GO TO 470
      IF (DMAP(DMPPNT+1) .EQ. IASTK) GO TO 70
      J = 2
      IF (DMAP(DMPPNT+1).EQ.ISLSH) J = 4
      GO TO 130
  100 J = 1
C
C     CHECK FOR BLANK
C
      IF (DMAP(DMPPNT) .EQ. NBLANK) GO TO 70
      GO TO 130
  110 J = 3
      GO TO 130
  120 J = 5
C
C     BRANCH ON SYNTAX TABLE VALUE
C
  130 K = ISYNTX(I,J)
      GO TO (140,180,210,280,200,290,470,190), K
C
C     NAME FOUND. NAME TO TEMP,UPDATE PREVOP AND SEARCH PVT FOR VALUE.
C
  140 IF (IPRVOP .EQ. IEQUL) GO TO 190
      IF (IPRVOP .NE. ISLSH) GO TO 470
      ITMP(1) = DMAP(DMPPNT  )
      ITMP(2) = DMAP(DMPPNT+1)
      IPRVOP  = NAME
C
C     SCAN PVT
      K = 3
  150 L = ANDF(PVT(K+2),NOSGN)
      L = ITYPE(L)
      IF (DMAP(DMPPNT).EQ.PVT(K) .AND. DMAP(DMPPNT+1).EQ.PVT(K+1))
     1    GO TO 160
      K = K + 3 + L
      IF (K-PVT(2)) 150,70,70
C
C     CHECK LENGTH OF PVT VALUE
C
  160 IPVAL = IPVT
      PVT(K+2) = ORF(PVT(K+2),ISGNON)
      IF (ANDF(PVT(K+2),NOSGN) .NE. ITMP(3)) GO TO 490
C
C     TRANSFER VALUE TO ITMP
C
      DO 170 M = 1,L
      J = K + M + 2
  170 ITMP(M+3) = PVT(J)
      GO TO 70
C
C     DMAP ENTRY IS = OPERATOR
C
  180 IF (IPRVOP .NE. NAME) GO TO 470
      IPRVOP = IEQUL
      GO TO 70
C
C     BCD PARAMETER VALUE FOUND
C
  190 IF (ITMP(3) .NE. 3) GO TO 500
      LENGTH = 2
      DMPPNT = DMPPNT - 1
      DMAP(DMPPNT) = ITMP(3)
      GO TO 220
C
C     DMAP ENTRY IS BINARY VALUE
C
  200 IF (IPRVOP .EQ. ISLSH) GO TO 220
  210 IF (IPRVOP .NE. IEQUL) GO TO 470
  220 IPRVOP = IVAL
      IF (IPVAL .EQ. IPVT) GO TO 70
C
C     DMAP VALUE IS HIGHEST PRIORITY
C
      IPVAL = IDMAP
      IF (ANDF(DMAP(DMPPNT),NOSGN) .NE. ITMP(3)) GO TO 500
C
C TRANSFER DMAP VALUE TO ITMP
C
      DO 270 M = 1,LENGTH
      J = DMPPNT + M
  270 ITMP(M+3) = DMAP(J)
      GO TO 70
C
C     DMAP ENTRY IS / OPERATOR
C
  280 IF (IPRVOP .EQ. IEQUL) GO TO 470
      IPRVOP = ISLSH
      GO TO 300
C
C     END OF DMAP INSTRUCTION
C
  290 IF (IPRVOP .EQ. IEQUL) GO TO 470
C
C     PARAMETER SCANNED,CHECK CORRECTNESS OF NAME AND VALUE AND
C     PROCESS ITMP ACCORDING TO NVSTBL
C
  300 IF (I.LT.4 .AND. ITMP(1).EQ.0) GO TO 510
      K = NVSTBL(I,IPVAL)
C
      GO TO (310,520,530,390), K
C
C     VARIABLE PARAMETER,VALUE TO VPS,POINTER TO OSCAR
C
  310 K = 3
  320 IF (ITMP(1).EQ.VPS(K) .AND. ITMP(2).EQ.VPS(K+1)) GO TO 330
      K = K + AND(VPS(K+2),MASKHI) + 3
      IF (K-VPS(2)) 320,350,350
C
C     PARAMETER IS ALREADY IN VPS - MAKE SURE TYPES AGREE.
C
  330 L = ANDF(RSHIFT(VPS(K+2),16),15)
      IF (L .EQ. 0) GO TO 335
      IF (L .NE. ANDF(ITMP(3),15)) GO TO 555
C
C     CHECK VALUE MODIFIED FLAG
C
  335 IF (ANDF(MODFLG,VPS(K+2)) .EQ. 0) GO TO 340
C
C     VALUE HAS BEEN MODIFIED FOR RESTART - DO NOT CHANGE.
C
      GO TO 380
C
C     CHECK IF PREVIOUSLY DEFINED
C
  340 IF (VPS(K+2) .LT. 0) GO TO 540
      GO TO 360
C
C     NAME NOT IN VPS,MAKE NEW ENTRY
C
  350 K = VPS(2) + 1
      VPS(2) = K + 2 + MPLLN
      IF (VPS(2)-VPS(1)) 360,360,560
C
C     ITMP NAME,LENGTH,FLAG,VALUE TO VPS
C
  360 L = MPLLN + 3
      DO 370 M = 1,L
      J = K + M - 1
  370 VPS(J  ) = ITMP(M)
      VPS(K+2) = OR(MPLLN,LSHIFT(ITMP(3),16))
      IF (IPVAL .EQ. IDMAP) VPS(K+2) = OR(VPS(K+2),ISGNON)
C
C     LOCATION OF VALUE IN VPS TO OSCAR
C
  380 OSCAR(IOSPNT) = K + 3
      IF (ISAVE .NE. 1) GO TO 385
      NWORDS = NWORDS + 1
      SAVNAM(NWORDS) = K+3
  385 CONTINUE
      OSCAR(IOSPNT) = OR(OSCAR(IOSPNT),ISGNON)
      IOSPNT = IOSPNT + 1
      GO TO 10
C
C     CONSTANT PARAMETER,VALUE TO OSCAR
C
  390 OSCAR(IOSPNT) = MPLLN
      DO 400 M = 1,MPLLN
      J = IOSPNT + M
  400 OSCAR(J) = ITMP(M+3)
      IOSPNT = IOSPNT + MPLLN + 1
      GO TO 10
C
C     PROCESS ANY INTEGER, REAL, OR COMPLEX CONSTANTS
C
  601 I = 2
      J = 2
      NEWTYP = 1
      OSCAR(NOSPNT) = OSCAR(NOSPNT) + 1
      GO TO 75
C
C     PROCESS POSSIBLE DELIMITERS - SLASH AND ASTERISK
C
  600 IF (DMAP(DMPPNT+1) .NE. IASTK) GO TO 610
      CALL XSCNDM
      GO TO (470,605,470,410,570), IRTURN
  605 I = 2
      J = 2
      NEWTYP = 1
      OSCAR(NOSPNT) = OSCAR(NOSPNT) + 1
      GO TO 75
C
C     PROCESS MPL DEFAULTS IF // IS ENCOUNTERED
C
  610 IF (DMAP(DMPPNT+1) .NE. ISLSH) GO TO 470
      I = 2
      J = 2
      NEWTYP = 1
      OSCAR(NOSPNT) = OSCAR(NOSPNT) + 1
      GO TO 75
C
C     USE DEFAULT MPL VALUE FOR PARAMETER
C
  620 IF (IPVAL .EQ. NONE) GO TO 470
      OSCAR(IOSPNT) = MPLLN
      DO 625 M = 1,MPLLN
      J = IOSPNT + M
  625 OSCAR(J) = ITMP(M+3)
      IOSPNT = IOSPNT + MPLLN + 1
      GO TO 10
C
C     PROCESS V,N,NAME PARAMETER TYPES AS /NAME/
C
  602 I = 1
      J = 2
      NEWTYP = 1
      GO TO 75
C
C     ALL PARAMETERS ON DMAP CARD PROCESSED,PROCESS ANY REMAINING ON
C     MPL
C
  410 IF (MPLPNT .GE. MPLBOT) GO TO 450
      ENDCRD = 1
      LENGTH = IABS(MPL(MPLPNT))
      LENGTH = ITYPE(LENGTH)
      OSCAR(NOSPNT) = 1 + OSCAR(NOSPNT)
      IF (MPL(MPLPNT)) 530,480,420
  420 OSCAR(IOSPNT) = LENGTH
      DO 430 M = 1,LENGTH
      J = IOSPNT + M
      MPLPNT = MPLPNT + 1
  430 OSCAR(J) = MPL(MPLPNT)
  440 MPLPNT = MPLPNT + 1
      IOSPNT = IOSPNT + LENGTH + 1
      GO TO 410
C
C     RETURN TO XOSGEN
C
  450 OSCAR(OSPNT) = IOSPNT - OSPNT
      IRTURN = 1
  460 RETURN
C
C     ERROR MESSAGES -
C
C     DMAP CARD FORMAT ERROR
C
  470 CALL XGPIDG (3,OSPNT,OSCAR(NOSPNT),0)
      GO TO 450
C
C     MPL PARAMETER ERROR
C
  480 CALL XGPIDG (4,OSPNT,OSCAR(NOSPNT),0)
      GO TO 450
C
C     PARA CARD ERROR
C
  490 CALL XGPIDG (5,0,ITMP(1),ITMP(2))
      GO TO 70
C
C     ILLEGAL DMAP PARAMETER VALUE
C
  500 CALL XGPIDG (6,OSPNT,OSCAR(NOSPNT),0)
      GO TO 70
C
C     DMAP PARAMETER NAME MISSING
C
  510 CALL XGPIDG (7,OSPNT,OSCAR(NOSPNT),0)
      GO TO 390
C
C     ILLEGAL PARA CARD
C
  520 CALL XGPIDG (8,0,ITMP(1),ITMP(2))
      IF (I-2) 310,310,390
C
C     CONSTANT PARAMETER NOT DEFINED
C
  530 CALL XGPIDG (9,OSPNT,OSCAR(NOSPNT),0)
      IF (ENDCRD .EQ. 1) GO TO 440
      GO TO 390
C
C     WARNING - PARAMETER ALREADY HAD VALUE ASSIGNED PREVIOUSLY
C
  540 IF (IPVAL .NE. IDMAP) GO TO 550
      CALL XGPIDG (-42,OSPNT,ITMP(1),ITMP(2))
  550 IF (AND(RSHIFT(VPS(K+2),16),15) .EQ. AND(ITMP(3),15)) GO TO 380
C
C     INCONSISTENT LENGTH USED FOR VARIABLE PARAMETER.
C
  555 CALL XGPIDG (15,OSPNT,ITMP(1),ITMP(2))
      GO TO 380
C
C     VPS TABLE OVERFLOW
C
  560 CALL XGPIDG (14,NVPS,NBLANK,DMPCNT)
  570 NOGO   = 2
      IRTURN = 2
      GO TO 460
C
C     TOO MANY PARAMETERS IN DMAP PARAMETER LIST.
C
  580 CALL XGPIDG (18,OSPNT,0,0)
      GO TO 450
      END

      SUBROUTINE BTSTRP
C
C     BASED ON MACHINE NUMBER, BTSTRP WILL DEFINE ALL THE
C     MACHINE-DEPENDENT CONSTANTS NEEDED IN NASTRAN. THESE CONSTANTS
C     ARE SAVED IN LABEL COMMONS /SYSTEM/, /LHPWX/, /MACHIN/ & /CHMACH/
C
C     SEE ALSO  PRTPRM, SDCMPS, SDR2E, AND UPCASE WHEN NASTRAN SOURCE
C     CODE IS PORTED TO OTHER (NEW) MACHINE
C
C                ===
C
      EXTERNAL        LSHIFT ,RSHIFT ,ANDF   ,COMPLF
      CHARACTER       MCHNAM*11, MACHOS*7, COMPUT(22)*11, COMPOS(22)*7
      INTEGER         SYSBUF ,OUTTAP ,TWO     ,COMPLF    ,RSHIFT     ,
     1                FCB    ,ORDER  ,IDATE(3),
     2                ABCD   ,AK     ,RECL    ,ANDF      ,
     3                SPERLK ,QP     ,M1(110) ,M2(110)   ,MCONST(220),
     4                HIGHPW
      REAL            XX     ,YY
      COMMON /MACHIN/ MACHX  ,IHALF  ,JHALF  ,LQRO
      COMMON /CHMACH/ MCHNAM, MACHOS
      COMMON /SEM   / A      ,MASK2  ,MASK3  ,LNKNOS(15)
      COMMON /LHPWX / LOWPW  ,HIGHPW ,NWPIC  ,NUDFLW    ,MXFL       ,
     1                KSHIFT ,MTISA
      COMMON /SYSTEM/ B(100)
      COMMON /TWO   / TWO(32),MZERO
      COMMON /XXREAD/ DUM(3) ,IBMCDC
      EQUIVALENCE     (B( 1),SYSBUF) ,(B(22),LINKNO) ,(B(40),NBPW ) ,
     1                (B( 2),OUTTAP) ,(B(41),NCPW ) , (B(42),IDATE(1)),
     2                (B( 4),INTP  ) ,(B(34),IDRUM ) ,(B(55),IPREC) ,
     3                (B( 9),NLPP  ) ,(B(39),NBPC  ) ,(B(91),LPCH ) ,
     4                (B(92),LDICT ) ,(B(95),SPERLK) ,(MACHX,MACH ) ,
     5                (M1(1),MCONST(1))     ,(M2(1)  ,MCONST(111) )
C
C  DEFINE SYSTEM RELEASE DATE
C
      DATA IMNTH, IYR1, IYR2 /4HAPR., 3H 19, 2H95 /
C
      DATA    XX    , YY    / 1.2E-38, 0.3E-38       /
      DATA    MVAX  , ABCD  , KA   /  1H1,   4HABCD  ,4HA           /
C
C     MACH   = MACHX = HOST MACHINE
C              ANY SUBROUTINE, THAT USES 'MACHX' INSTEAD OF 'MACH' IN
C              LABEL COMMON /MACHIN/, CONTAINES MACHINE CONSTANTS THAT
C              ARE USED LOCALLY.
C     NMACH  = NUMBER OF MACHINES
C     MCONST = ARRAY CONTAINING MACHINE DEPENDENT CONSTANTS
C
C
C     COSMIC/NASTRAN SUPPORTS ONLY MACHINES 2, 5, 6, 7, 8, 9, 10, 16,
C     21, & 22.   CONSTANTS FOR OTHER MACHINES MAY NOT BE EXACT
C
C     -MACHINE-    IBM/  UNIVAC   CDC   DEC/    DEC/   SUN   IBM/    HP
C           DUMMY   MVS    FTN   FTN5    VMS  ULTRIX SOLARIS  AIX    UX
C     MACH = -1-  ---2-  ---3-  ---4-  ---5-  ---6-  ---7-  ---8-  ---9-
C
C           SGI    MAC   CRAY  CONVEX   NEC  FUJITSU  SUN  AMDAHL  PRIME
C           IRIS        UNICOS                       SUNOS
C          --10-  --11-  --12-  --13-  --14-  --15-  --16-  --17-  --18-
C
C          INTEL          DEC/   DEC/
C          LINUX  DUMMY OPENVMS  OSF
C          --19-  --20-  --21-  --22-
C
C  MACHINE NAMES
C
      DATA    COMPUT/
     1        'DUMMY      ', 'IBM        ', 'UNIVAC     ',
     2        'CDC        ', 'DEC-VAX    ', 'DEC-MIPS   ',
     3        'SUN        ', 'IBM RS6000 ', 'HP         ',
     4        'SGI        ', 'MACINTOCH  ', 'CRAY       ',
     5        'CONVEX     ', 'NEC        ', 'FUJITSU    ',
     6        'SUN        ', 'AMDAHL     ', 'PRIME      ',
     7        'INTEL x86  ', 'DUMMY      ', 'DEC-ALPHA  ',
     8        'DEC-ALPHA  '/
C
C  MACHINE OPERATING SYSTEM
C
      DATA    COMPOS/
     1        '       ', 'MVS    ', 'FTN    ',
     2        'FTN5   ', 'VMS    ', 'ULTRIX ',
     3        'SOLARIS', 'AIX    ', 'HP-UX  ',
     4        'IRIX   ', '       ', 'UNICOS ',
     5        '       ', '       ', '       ',
     6        'SUNOS  ', '       ', '       ',
     7        'LINUX  ', '       ', 'OPENVMS',
     8        'OSF    '/
C
      DATA    NMACH / 22 /,    M1/
C
C     SYSBUF  =   LENGTH OF NASTRAN I/O BUFFER
C
     1      200,  4100,   871,  1042,  1028,  1028,  1028,  1028,  1028,
     2     1028,  1028,  2052,  1028,  2052,  2052,  1028,  1028,  1028,
     3     1028,  1028,  1028,  1028,
C
C     INTP(X100)  =  FORTRAN UNIT NO. FOR INPUT DATA
C     OUTTAP      =  FORTRAN UNIT NO. FOR PRINTED OUTPUT
C
     4     5 06,  5 06,  5 06,  5 06,  5 06,  5 06,  5 06,  5 06,  5 06,
     5     5 06,  5 06,  5 06,  5 06,  5 06,  5 06,  5 06,  5 06,  5 06,
     6     5 06,  5 06,  5 06,  5 06,
C
C
C     NLPP(X100)  =  NUMBER OF LINES PRINTED PER PAGE
C     NWPIC       =  NUMBER OF WORDS PER INPUT CARD, USED ONLY IN XGPIBS
C
     7    50 00, 55 18, 55 18, 42 08, 55 18, 55 18, 55 18, 55 18, 55 18,
     8    55 18, 55 18, 55 09, 55 18, 55 00, 55 00, 55 00, 55 00, 55 00,
     9    55 18, 55 00, 55 18, 55  0,
C
C     NBPC(X100)  =  NUMBER OF BITS PER CHARACTER
C     NBPW        =  NUMBER OF BITS PER WORD
C
     O     6 36,  8 32,  9 36,  6 60,  8 32,  8 32,  8 32,  8 32,  8 32,
     1     8 32,  8 32,  8 64,  8 32,  8 64,  8 64,  8 32,  8 32,  8 32,
     2     8 32,  8 32,  8 32,  8 32,
C
C     IPREC(X100) =  PRECISION (1 = S.P., 2 = D.P.)
C     RECL(X10)   =  DIRECT FILE RECORD LENGTH (USED IN FORTRAN OPEN
C                    STATEMENT) BY WORDS (= 1), OR BYTE (= NCPW)
C     QP          =  REAL*16 PRECISION FLAG (1 = YES, 0 = NO)
C
CWKBR3    2 0 0, 2 4 0, 2 1 1, 1 1 0, 2 1 1, 2 1 0, 2 4 0, 2 4 1, 2 4 1,
     3    2 0 0, 2 4 0, 2 1 0, 1 1 0, 2 1 0, 2 1 0, 2 4 0, 2 4 0, 2 4 0,
     4    2 1 0, 2 0 0, 1 8 0, 2 4 0, 1 0 0, 1 0 0, 2 0 0, 2 0 0, 2 0 0,
     5    2 4 0, 2 0 0, 2 1 0, 2 0 0 /
C
C
      DATA          M2/
C
C     LPCH(X100)  =  FORTRAN UNIT NO. FOR PUNCHED OUTPUT
C     LDICT       =  FORTRAN UNIT NO. FOR RESTART DICTIONARY PUNCH
C
     1     7 03,  7 07,  1 03,  7 07,  1 04,  1 04,  1 04,  1 04,  1 04,
     2     1 04,  1 04,  1 04,  1 04,  1 04,  1 04,  1 04,  1 04,  1 04,
     3     1 04,  1 04,  1 04,  1 04,
C
C     LOWPW, HIGHPW = MACHINE NUMERIC RANGE FOR S. P. REAL NUMBER,
C     USED ONLY BY RCARD, RCARD2, XRCARD AND YRCARD
C
     4       38,    75,    38,   321,    38,    38,    38,    38,    38,
     5       38,    38,  2465,    38,     0,     0,     0,     0,     0,
     6       38,     0,    38,     0,
C
C     NUDFLW(X100) =  FLOATING NUMBER UNDERFLOW CONTROL
C                     (USED ONLY BY FQRW AND FQRWV)
C     MXFL         =  MAXINUM FILES MAXFIL CAN REQUEST VIA THE NASTRAN
C                     CARD, USED ONLY IN NASCAR
C
     7    16 50, 16 50, 18 49, 14 75,  8 75, 16 75, 16 75, 16 75, 16 75,
     8    16 75, 16 75, 16 75, 16 75, 16 75, 16 75, 16 75, 16 75, 16 75,
     9    16 75, 16 75,  9 75, 16 75,
C
C     KSHIFT  =  SHIFT COUNTS USED IN A DIVIDE TO CONVERT A GINO LOC
C                RETURNED FROM SAVPOS TO GINO BLOCK NUMBER, USED IN EMA
C
     O        1,  4096,   4096,262144,  4096,  4096, 4096,  4096,  4096,
     1     4096,  4096,   4096,  4096,     0,     0,    0,     0,     0,
     2     4096,     0,   4096,     0,
C
C     MANTISSA BITS, USED ONLY IN SDCMPS
C
     3     0 00, 24 26, 27 60, 48 96, 23 55, 23 55, 23 52, 23 55, 23 55,
     4    23 55, 23 55, 48 96, 23 52, 48 96, 48 96, 23 55, 23 55, 23 55,
     5    23 55,  0 00, 23 55,  0 00/
C
C     DEFINE SYSTEM (42), SYSTEM(43), SYSTEM(44)
C
      IDATE(1) = IMNTH
      IDATE(2) = IYR1
      IDATE(3) = IYR2
C
C     MACHINE TYPE IS SET HERE
C     +++++++++++++++++++++++++++++++
  100 MACH = 19
      MCHNAM = COMPUT(MACH)
      MACHOS = COMPOS(MACH)
      SYSBUF = MCONST(MACH)
      IBMCDC = 1
      IF (MACH.EQ.2 .OR. MACH.EQ.4) IBMCDC = 0
C
      I  = MACH + NMACH
      INTP   = MCONST(I)/100
      OUTTAP = MOD(MCONST(I),100)
C
      I  = I + NMACH
      NLPP   = MCONST(I)/100
      NWPIC  = MOD(MCONST(I),100)
C
      I  = I + NMACH
      NBPC   = MCONST(I)/100
      NBPW   = MOD(MCONST(I),100)
C
      I  = I + NMACH
      IPREC  = MCONST(I)/100
      RECL   = MOD(MCONST(I),100)/10
      QP     = MOD(MCONST(I),10)
C
C
      I  = I + NMACH
      LPCH   = MCONST(I)/100
      LDICT  = MOD(MCONST(I),100)
C
C     MACHINE S.P. RANGE
C
      I  = I + NMACH
      HIGHPW = MCONST(I)
      LOWPW  = 1 - HIGHPW
      IF (MACH .EQ. 2) LOWPW = -78
      IF (MACH .EQ. 4) LOWPW = -292
C
C     FLOATING NUMBER UNDERFLOW CONTROL
C     MAXINUM FILES FOR MAXFIL CHECK
C
      I  = I + NMACH
      NUDFLW = MCONST(I)/100
      MXFL   = MOD(MCONST(I),100)
C
C     SHIFT COUNTER FOR EMA SUBROUTINE
C
      I  = I + NMACH
      KSHIFT = MCONST(I)
C
C     MANTISSA BITS
C
      I  = I + NMACH
      MTISA  = MCONST(I)/100
      IF (IPREC .EQ. 2) MTISA = MOD(MCONST(I),100)
C
C     NUMBER OF BITS PER HALF WORD, USED MAINLY FOR INTEGER PACKING
C
C     IHALF = NBPW/2
C     JHALF = 2**IHALF - 1
      IHALF = 16
      JHALF = 65535
C
C     NUMBER OF CHARACTERS PER WORD
C
      NCPW = NBPW/NBPC
C
C     ZERO FIELD KA, AK AND GENERATE A MASK FOR FIRST BYTE
C
      AK   = KHRFN1(0,1,KA,4)
      KA   = KHRFN1(0,1,KA,1)
      I    = 2**NBPC - 1
      MASK = LSHIFT(I,NBPW-NBPC)
C
C     CHECK BCD WORD (NOT CHARACTER WORD) STORING ORDER.
C     IF 'ABCD' IS STORED INTERNALLY IN A-B-C-D ORDER, SET ORDER TO 0,
C     OR  IF IT IS STORED IN REVERSED ORDER, D-C-B-A,  SET ORDER TO 1
C
      I = ANDF(ABCD,MASK)
      ORDER = 0
      IF (NBPW.LT.60 .AND. I.NE.KA .AND. I.NE.AK) ORDER = 1
C
C     CHECK SYSTEM LOC OR %LOC FUNCTION.
C     IF SYSTEM LOC FUNCTION IS WORD COUNT, SET LOCF TO 1
C     IF SYSTEM LOC FUNCTION IS BYTE COUNT, SET LOCF TO NCPW
C
      LQRO = 1000
      I    = LOCFX(B(11)) - LOCFX(B(1))
      LOCF = I/10
C
C     MERGE LOCF, QP, RECL, AND ORDER INTO LQRO
C
      LQRO = LOCF*1000 + QP*100 + RECL*10 + ORDER
C
C
C     GENERATE MASKS
C                   7094      360         1108            6600
C     MASK2  = 777777007777,FFFFFFF0,777777607777,77777760777777777777
C     MASK3  = 377777777777,7FFFFFFF,377777777777,37777777777777777777
C     TWO(1) = 020000000000,80000000,020000000000,00000000020000000000
C
      MASK2  = COMPLF(LSHIFT(2**NBPC-1, NBPW-4*NBPC))
      MASK3  = RSHIFT(COMPLF(0),1)
      MZERO  = LSHIFT(1,NBPW-1)
      TWO(1) = LSHIFT(1,31)
C
C     TWO(1) = LSHIFT(1,31) = 2**31
C            = +2147483648   IN MACHINES WITH MORE THAN 32-BIT WORD
C            = -2147483648   IN 32-BIT MACHINES. A NEGATIVE NUMBER!
C            = -0.000E0      IN SOME  32-BIT MACHINES
C            = +0.000E0      IN OTHER 32-BIT MACHINES
C     NOTICE FOR THE 32-BIT MACHINES, IABS(-2147483648) IS FATAL!
C
C     DEFINE COMMONLY USED PHYSICAL CONSTANTS
C
      CALL CNSTDD
      LINKNO = LNKNOS(1)
C
      RETURN
      END

      SUBROUTINE SOFI
C
C     MODULE USED TO COPY SELECTED ITEMS FROM SELECTED SUBSTRUCTURES
C     ONTO NASTRAN MATRIX FILES.   THE CALLING SEQUENCE TO THE MODULE
C     IS
C     SOFI   /A,B,C,D,E/V,N,DRY/C,N,NAME/C,N,IA/C,N,IB/C,N,IC/C,N,ID/
C                       C,N,IE $
C
      INTEGER         DRY,FILE,SYSBUF,XXXX
      DIMENSION       FILE(5),MODNAM(2),MCB(7)
      CHARACTER       UFM*23,UWM*25
      COMMON /XMSSG / UFM,UWM
      COMMON /BLANK / DRY,NAME(2), ITEMS(2,5)
      COMMON /ZZZZZZ/ IZ(1)
      COMMON /SYSTEM/ SYSBUF,NOUT
      DATA    FILE  / 201,202,203,204,205 /
      DATA    IBLNK , XXXX/4H    ,4HXXXX  /
      DATA    MODNAM/ 4HSOFI,4H           /
C
      DO 5 I = 1,5
      IF (ITEMS(1,I).EQ.XXXX .OR. ITEMS(1,I).EQ.0) ITEMS(1,I) = IBLNK
    5 CONTINUE
C
      NZ = KORSZ(IZ)
      IF (3*SYSBUF .GT. NZ) CALL MESAGE (-8,0,MODNAM(1))
      IB1 = NZ  - SYSBUF + 1
      IB2 = IB1 - SYSBUF - 1
      IB3 = IB2 - SYSBUF
      CALL SOFOPN (IZ(IB1),IZ(IB2),IZ(IB3))
      IF (DRY .GE. 0) GO TO 60
C
C     CHECK THE EXISTENCE OF THE SOF FILE.
C
      DO 50 I = 1,5
      IF (ITEMS(1,I) .EQ. IBLNK) GO TO 50
      MCB(1) = FILE(I)
      CALL RDTRL (MCB)
      IF (MCB(1) .LT. 0) GO TO 50
      CALL SOFTRL (NAME(1),ITEMS(1,I),MCB)
      ITEST = MCB(1)
      GO TO (50,50,20,30,40), ITEST
   20 WRITE (NOUT,1020) UWM,ITEMS(1,I),NAME(1),NAME(2)
      GO TO 45
   30 WRITE (NOUT,1030) UWM,NAME(1),NAME(2)
      DRY = -2
      GO TO 130
   40 WRITE (NOUT,1040) UWM,ITEMS(1,I)
   45 DRY = -2
   50 CONTINUE
      GO TO 130
C
C     COPY SOF DATA INTO NASTRAN DATA BLOCKS
C
   60 DO 120 I = 1,5
      IF (ITEMS(1,I) .EQ. IBLNK) GO TO 120
      MCB(1) = FILE(I)
      CALL RDTRL (MCB)
      IF (MCB(1) .LT. 0) GO TO 120
      CALL MTRXI (FILE(I),NAME(1),ITEMS(1,I),0,ITEST)
      GO TO (120,70,80,90,100,120), ITEST
   70 WRITE (NOUT,1050) UWM,ITEMS(1,I),NAME(1),NAME(2)
      GO TO 110
   80 WRITE (NOUT,1020) UWM,ITEMS(1,I),NAME(1),NAME(2)
      GO TO 120
   90 WRITE (NOUT,1030) UWM,NAME(1),NAME(2)
      DRY = -2
      GO TO 130
  100 WRITE (NOUT,1040) UWM,ITEMS(1,I)
  110 DRY = -2
  120 CONTINUE
  130 CALL SOFCLS
      RETURN
C
C     ERROR MESSAGES.
C
 1020 FORMAT (A25,' 6216, MODULE SOFI - ITEM ',A4,' OF SUBSTRUCTURE ',
     1        2A4,' DOES NOT EXIST.')
 1030 FORMAT (A25,' 6212, MODULE SOFI - THE SUBSTRUCTURE ',2A4,
     1        ' DOES NOT EXIST.')
 1040 FORMAT (A25,' 6213, MODULE SOFI - ',A4,' IS AN ILLEGAL ITEM NAME')
 1050 FORMAT (A25,' 6215, MODULE SOFI - ITEM ',A4,' OF SUBSTRUCTURE ',
     1        2A4,' PSEUDO-EXISTS ONLY.')
      END

      SUBROUTINE KROD
C*****
C THIS ROUTINE COMPUTES THE TWO 6 X 6 MATRICES  K(NPVT,NPVT) AND
C K(NPVT,J) FOR A ROD HAVING END POINTS NUMBERED NPVT AND J.
C*****
C
C                        E C P T  F O R  T H E  R O D
C
C                                                                CARD
C                                                 TYPE   TABLE   TYPE
C ECPT( 1)ELEMENT ID.                               I     ECT    CROD
C ECPT( 2)SCALAR INDEX NUMBER FOR GRID POINT A      I     ECT    CROD
C ECPT( 3)SCALAR INDEX NUMBER FOR GRID POINT B      I     ECT    CROD
C ECPT( 4)MATERIAL ID.                              I     EPT    PROD
C ECPT( 5)AREA  (A)                                 R     EPT    PROD
C ECPT( 6)POLAR MOMENT OF INERTIA (J)               R     EPT    PROD
C ECPT( 7) TORSIONAL STRESS COEFF (C)                R    EPT    PROD
C ECPT( 8) NON-STRUCTRAL MASS (MU)                   R    EPT    PROD
C ECPT( 9) COOR. SYS. ID. NO. FOR GRID POINT A       I   BGPDT   GRID
C ECPT(10) X-COORDINATE OF GRID PT. A (IN BASIC COOR)R   BGPDT
C ECPT(11) Y-COORDINATE OF GRID PT. A (IN BASIC COOR)R   BGPDT
C ECPT(12) Z-COORDINATE OF GRID PT. A (IN BASIC COOR)R   BGPDT
C ECPT(13) COOR. SYS. ID. NO. FOR GRID POINT B       I   BGPDT
C ECPT(14) X-COORDINATE OF GRID PT. B (IN BASIC COOR)R   BGPDT
C ECPT(15) Y-COORDINATE OF GRID PT. B (IN BASIC COOR)R   BGPDT
C ECPT(16) Z-COORDINATE OF GRID PT. B (IN BASIC COOR)R   BGPDT
C ECPT(17) ELEMENT TEMPERATURE
C
      LOGICAL  HEAT
C
      DOUBLE PRECISION
     1                   X                  ,Y
     2,                  Z                  ,XL
     3,                  XN                 ,DSCL
     4,                  DSCR               ,DAMPC
     5,                  D                  ,KE
     6,                  TI                 ,DUMDP
C
      DIMENSION
     1                   IECPT(4)
      COMMON /BLANK/ICOM
      COMMON   /SYSTEM/
     1                   ISYS
C
C SMA1 I/O PARAMETERS
C
      COMMON   /SMA1IO/
     1                   IFCSTM             ,IFMPT
     2,                  IFDIT              ,IDUM1
     3,                  IFECPT             ,IGECPT
     4,                  IFGPCT             ,IGGPCT
     5,                  IFGEI              ,IGGEI
     6,                  IFKGG              ,IGKGG
     7,                  IF4GG              ,IG4GG
     8,                  IFGPST             ,IGGPST
     9,                  INRW               ,OUTRW
     T,                  CLSNRW             ,CLSRW
     1,                  NEOR               ,EOR
     2,                  MCBKGG(7)          ,MCB4GG(7)
C
C SMA1 VARIABLE CORE BOOKKEEPING PARAMETERS
C
      COMMON   /SMA1BK/
     1                   ICSTM              ,NCSTM
     2,                  IGPCT              ,NGPCT
     3,                  IPOINT             ,NPOINT
     4,                  I6X6K              ,N6X6K
     5,                  I6X64              ,N6X64
C
C SMA1 PROGRAM CONTROL PARAMETERS
C
      COMMON   /SMA1CL/
     1                   IOPT4              ,K4GGSW
     2,                  NPVT               ,LEFT
     3,                  FROWIC             ,LROWIC
     4,                  NROWSC             ,TNROWS
     5,                  JMAX               ,NLINKS
     6,                  LINK(10)           ,IDETCK
     7,                  DODET              ,NOGO
      COMMON/SMA1HT/     HEAT
C
C ECPT COMMON BLOCK
C
      COMMON   /SMA1ET/
     1                   ECPT(17)           ,DUMET(83)
C
C INPUT AND OUTPUT BLOCKS FOR SUBROUTINE MAT
C
      COMMON   /MATIN/
     1                   MATIDC             ,MATFLG
     2,                  ELTEMP             ,STRESS
     3,                  SINTH              ,COSTH
      COMMON   /MATOUT/
     1                   E                  ,G
     2,                  NU                 ,RHO
     3,                  ALPHA              ,TSUBO
     4,                  GSUBE              ,SIGT
     5,                  SIGC               ,SIGS
      COMMON/HMTOUT/     FK
C
C LOCAL DOUBLE PRECISION VARIABLES
C
      COMMON   /SMA1DP/
     1                   X                  ,Y
     2,                  Z                  ,XL
     3,                  XN(3)              ,DSCL
     4,                  DSCR               ,DAMPC
     5,                  D(18)              ,KE(36)
     6,                  TI(9)              ,DUMDP(227)
C
C
C NOTE THAT EQUIVALENCE IS NECESSARY SINCE ECPT IS A MIXED --- INTEGERS
C AND REAL --- ARRAY
C
      EQUIVALENCE
     1                   (IECPT(1),ECPT(1))
C*****
C  BRANCH ON HEAT FORMULATION.
C*****
      IF( HEAT ) GO TO 200
      IF (IECPT(2) .EQ. NPVT) GO TO 10
      IF (IECPT(3) .NE. NPVT) CALL MESAGE (-30,34,IECPT(1))
      ITEMP = IECPT(2)
      IECPT(2) = IECPT(3)
      IECPT(3) = ITEMP
      KA  = 13
      KB  =  9
      GO TO 20
   10 KA  =  9
      KB  =  13
C
C AT THIS POINT KA POINTS TO THE COOR. SYS. ID. OF THE PIVOT GRID POINT.
C SIMILARLY FOR KB AND THE NON-PIVOT GRID POINT.
C NOW COMPUTE THE LENGTH OF THE ROD.
C
C WE STORE THE COORDINATES IN THE D ARRAY SO THAT ALL ARITHMETIC WILL BE
C DOUBLE PRECISION
C
   20 D(1) = ECPT(KA+1)
      D(2) = ECPT(KA+2)
      D(3) = ECPT(KA+3)
      D(4) = ECPT(KB+1)
      D(5) = ECPT(KB+2)
      D(6) = ECPT(KB+3)
      X    = D(1) - D(4)
      Y    = D(2) - D(5)
      Z    = D(3) - D(6)
      XL = DSQRT (X**2 + Y**2 + Z**2)
      IF (XL.NE.0.0D0) GO TO 30
      CALL MESAGE(30,26,IECPT(1))
C
C     SET FLAG FOR FATAL ERROR WHILE ALLOWING ERROR MESSAGES TO ACCUMULA
C
      NOGO=1
      RETURN
   30 CONTINUE
C
C CALCULATE A NORMALIZED DIRECTION VECTOR IN BASIC COORDINATES.
C
      XN(1) = X / XL
      XN(2) = Y / XL
      XN(3) = Z / XL
C
C LOCATE E = YOUNG-S MODULUS, G = SHEAR MODULUS AND DAMPC = DAMPING
C CONSTANT IN THE MAT1 TABLE AND COMPUTE DSCL = A * E / XL AND
C DSCR = J * G / XL.  A IS ECPT(5) AND J IS ECPT(6)
C
      MATIDC = IECPT(4)
      MATFLG = 1
      ELTEMP = ECPT(17)
      CALL MAT (IECPT(1))
C
C WE STORE ECPT(5), ECPT(6), E AND G IN DOUBLE PRECISION LOCATIONS SO
C THAT ALL ARITHMETIC WILL BE DOUBLE PRECISION
C
      D(1) = ECPT(5)
      D(2) = E
      D(3) = ECPT(6)
      D(4) = G
      DSCL = D(1) * D(2) / XL
      DSCR = D(3) * D(4) / XL
      DAMPC  = G SUB E
C
C SET UP THE -N- MATRIX AND STORE AT D(1)
C
      D(1) = XN(1) * XN(1)
      D(2) = XN(1) * XN(2)
      D(3) = XN(1) * XN(3)
      D(4) = D(2)
      D(5) = XN(2) * XN(2)
      D(6) = XN(2) * XN(3)
      D(7) = D(3)
      D(8) = D(6)
      D(9) = XN(3) * XN(3)
C
C ZERO OUT THE 6X6 WHICH WILL BE USED FOR STORAGE OF KGG(NPVT,NONPVT),
C NONPVT = NPVT,J
C KGG(NPVT,NONPVT), NONPVT = NPVT,J
C
      DO 50 I = 1,36
   50 KE(I) = 0.0D0
      NONPVT = 2
      K2 = 1
C
C IF PIVOT GRID POINT IS IN BASIC COORDINATES, GO TO 70
C
      IF (IECPT(KA) .EQ. 0) GO TO 70
      CALL TRANSD (ECPT(KA),TI(1))
      CALL GMMATD (TI(1),3,3,1, D(1),3,3,0, D(10))
      CALL GMMATD (D(10),3,3,0, TI(1),3,3,0, D(1))
C
C AT THIS POINT D(1) CONTAINS THE MATRIX PRODUCT TAT * N * TA
C AND D(10) CONTAINS THE MATRIX PRODUCT TAT * N.
C
      ASSIGN 100 TO IRETRN
      GO TO 80
   70 ASSIGN 90 TO IRETRN
C
C FILL THE KE MATRIX
C
   80 KE( 1) = DSCL * D(K2  )
      KE( 2) = DSCL * D(K2+1)
      KE( 3) = DSCL * D(K2+2)
      KE( 7) = DSCL * D(K2+3)
      KE( 8) = DSCL * D(K2+4)
      KE( 9) = DSCL * D(K2+5)
      KE(13) = DSCL * D(K2+6)
      KE(14) = DSCL * D(K2+7)
      KE(15) = DSCL * D(K2+8)
      KE(22) = DSCR * D(K2  )
      KE(23) = DSCR * D(K2+1)
      KE(24) = DSCR * D(K2+2)
      KE(28) = DSCR * D(K2+3)
      KE(29) = DSCR * D(K2+4)
      KE(30) = DSCR * D(K2+5)
      KE(34) = DSCR * D(K2+6)
      KE(35) = DSCR * D(K2+7)
      KE(36) = DSCR * D(K2+8)
      CALL SMA1B (KE,ECPT(NONPVT),-1,IFKGG,0.0D0)
      IF (IOPT4 .EQ. 0  .OR.  G SUB E .EQ. 0.0) GO TO 85
      K4GGSW = 1
      CALL SMA1B (KE,ECPT(NONPVT),-1,IF4GG,DAMPC)
C
C  RETURN  FROM  FILL  CODE W/ IRETRN = 90 IMPLIES G.P. A WAS IN BASIC
C    .      .     .      .      .     =100 IMPLIES G.P. A WAS NOT BASIC
C    .      .     .      .      .     =140 IMPLIES THE K(NPVT,NONPVT)
C                                      HAS BEEN COMPUTED AND INSERTED
C                                      AND HENCE WE ARE FINISHED.
C
   85 GO TO IRETRN , (90,100,140)
   90 K1 = 1
      K2 = 10
      GO TO 110
  100 K1 = 10
      K2 = 1
  110 NONPVT = 3
C
C IF NON-PIVOT GRID POINT IS IN BASIC COORDINATES, GO TO 120
C
      IF (IECPT(KB) .EQ. 0) GO TO 120
      CALL TRANSD (ECPT(KB),TI(1))
C
C RECALL THAT D(K1) CONTAINS TAT * N.
C
      CALL GMMATD (D(K1),3,3,0, TI(1),3,3,0, D(K2))
C
C AT THIS POINT D(K2) CONTAINS TAT * N * TB.
C
      GO TO 130
  120 K2 = K1
  130 ASSIGN 140 TO IRETRN
C
C SET CONSTANTS NEGATIVE TO PROPERLY COMPUTE K(NPVT,NONPVT)
C
      DSCR = -DSCR
      DSCL = -DSCL
      GO TO 80
C
C A TRANSFER TO STATEMENT NO. 140 IMPLIES KGG AND/OR K4GG CALCULATIONS
C HAVE BEEN COMPLETED.
C
  140 RETURN
C*****
C  HEAT FORMULATION.  FIRST COMPUTE LENGTH OF ELEMENT.
C*****
  200 X = ECPT(14) - ECPT(10)
      Y = ECPT(15) - ECPT(11)
      Z = ECPT(16) - ECPT(12)
      XL= DSQRT(X**2 + Y**2 + Z**2)
      IF( XL ) 300,300,400
  300 CALL MESAGE( -30, 26, IECPT(1) )
C
C     GET MATERIAL PROPERTY -K- FROM HMAT ROUTINE
C
  400 MATFLG = 1
      MATIDC = IECPT(4)
      ELTEMP = ECPT(17)
      CALL HMAT( IECPT )
C
      XL = DBLE(FK) * DBLE(ECPT(5)) / XL
C
      IF( NPVT .EQ. IECPT(3) ) XL = -XL
      DO 700 I = 1,2
      CALL SMA1B( XL, IECPT(I+1), NPVT, IFKGG, 0.0D0 )
      XL = -XL
  700 CONTINUE
      RETURN
      END

      SUBROUTINE SFETCH (NAME,ITEM,IRW,ITEST)
C
C     POSITIONS THE SOF TO READ OR WRITE DATA ASSOCIATED WITH ITEM OF
C     SUBSTRUCTURE NAME.
C
      EXTERNAL        ANDF
      LOGICAL         MDIUP
      INTEGER         ANDF,BUF,MDI,MDIPBN,MDILBN,MDIBL,BLKSIZ,DIRSIZ
      DIMENSION       NAME(2),NMSBR(2)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG / UFM,UWM,UIM,SFM
      COMMON /ZZZZZZ/ BUF(1)
      COMMON /SOF   / DITDUM(6),IO,IOPBN,IOLBN,IOMODE,IOPTR,IOSIND,
     1                IOITCD,IOBLK,MDI,MDIPBN,MDILBN,MDIBL,NXTDUM(15),
     2                DITUP,MDIUP
      COMMON /SYS   / BLKSIZ,DIRSIZ
      COMMON /SYSTEM/ NBUFF,NOUT
      DATA    IDLE  , IRD,IWRT /0,1,2/, NMSBR /4HSFET,4HCH  /
C
      CALL CHKOPN (NMSBR(1))
      CALL FDSUB  (NAME(1),IOSIND)
      IF (IOSIND .EQ. -1) GO TO 500
      IOITCD = ITCODE(ITEM)
      IF (IOITCD .EQ. -1) GO TO 510
C
C     CHECK IF ITEM IS A TABLE ITEM UNLESS SPECIAL CALL FROM MTRXO OR
C     MTRXI
C
      IF (IRW .LT. 0) GO TO 10
      ITM = ITTYPE(ITEM)
      IF (ITM .NE. 0) GO TO 530
   10 CALL FMDI (IOSIND,IMDI)
      IOLBN = 1
      IOPTR = IO + 1
      IBL   = ANDF(BUF(IMDI+IOITCD),65535)
      IRDWRT= IABS(IRW)
      GO TO (30,80,30), IRDWRT
C
C     READ OPERATION.
C
   30 IF (IBL .EQ.     0) GO TO 50
      IF (IBL .NE. 65535) GO TO 60
C
C     ITEM WAS PSEUDO-WRITTEN.
C
      ITEST = 2
      GO TO 520
C
C     ITEM HAS NOT BEEN WRITTEN.
C
   50 ITEST = 3
      GO TO 520
C
C     UPDATE THE COMMON BLOCK SOF, AND BRING INTO CORE THE DESIRED BLOCK
C
   60 ITEST = 1
      IF (IRDWRT .EQ. 3) GO TO 520
      IOPBN  = IBL
      IOMODE = IRD
      CALL SOFIO (IRD,IOPBN,BUF(IO-2))
      RETURN
C
C     WRITE OPERATION.
C
   80 IF (IBL.EQ.0 .OR. IBL.EQ.65535) GO TO 90
C
C     ITEM HAS ALREADY BEEN WRITTEN.
C
      ITEST = 1
      GO TO 520
   90 ITEST1 = ITEST - 1
      GO TO (100,110), ITEST1
C
C     ITEM IS TO BE PSEUDO-WRITTEN.
C
  100 BUF(IMDI+IOITCD) = 65535
      MDIUP = .TRUE.
      RETURN
C
C     ITEM IS TO BE WRITTEN.  GET A FREE BLOCK AND UPDATE THE COMMON
C     BLOCK SOF.
C
  110 CALL GETBLK (0,IOBLK)
      IF (IOBLK .EQ. -1) GO TO 1000
      IOPBN  = IOBLK
      IOMODE = IWRT
      RETURN
C
C     NAME DOES NOT EXIST.
C
  500 ITEST = 4
      GO TO 520
C
C     ITEM IS AN ILLEGAL ITEM NAME.
C
  510 ITEST  = 5
  520 IOMODE = IDLE
      RETURN
C
C     ATTEMPT TO OPERATE ON A MATRIX ITEM
C
  530 WRITE  (NOUT,540) SFM,ITEM,NAME
  540 FORMAT (A25,' 6227, AN ATTEMPT HAS BEEN MADE TO OPERATE ON THE ',
     1       'MATRIX ITEM ',A4,' OF SUBSTRUCTURE ',2A4,' USING SFETCH.')
      GO TO 1010
C
C     NO MORE BLOCKS ON SOF
C
 1000 WRITE  (NOUT,1001) UFM
 1001 FORMAT (A23,' 6223, SUBROUTINE SFETCH - THERE ARE NO MORE FREE ',
     1       'BLOCKS AVAILABLE ON THE SOF.')
 1010 CALL SOFCLS
      CALL MESAGE (-61,0,0)
      RETURN
      END

      SUBROUTINE XPURGE
C
C     THIS SUBROUTINE PURGES AND EQUATES FILES WITHIN FIAT AND DPD
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        LSHIFT    ,ANDF    ,ORF
      DIMENSION       PURGE1( 2),DDBN( 1),DFNU( 1),FCUM( 1),FCUS( 1),
     1                FDBN  ( 1),FEQU( 1),FILE( 1),FKND( 1),FMAT( 1),
     2                FNTU  ( 1),FPUN( 1),FON ( 1),FORD( 1),MINP( 1),
     3                MLSN  ( 1),MOUT( 1),MSCR( 1),SAL ( 1),SDBN( 1),
     4                SNTU  ( 1),SORD( 1)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG / UFM,UWM,UIM,SFM
      COMMON /SYSTEM/ IBUFSZ,OUTTAP,DUM(21),ICFIAT,DUMM(14),NBPC,NBPW,
     1                NCPW
      COMMON /OSCENT/ X(1)
      COMMON /XFIAT / FIAT(7)
      COMMON /XFIST / FIST
      COMMON /XDPL  / DPD(6)
      COMMON /XVPS  / VPS(1)
      COMMON /XSFA1 / MD(401),SOS(1501),COMM(20),XF1AT(5)
      COMMON /IPURGE/ J,K,NSAV,PRISAV,HOLD
      EQUIVALENCE              (DPD  (1),DNAF    ),(DPD  (2),DMXLG   ),
     1     (DPD  (3),DCULG   ),(DPD  (4),DDBN (1)),(DPD  (6),DFNU (1)),
     2     (FIAT (1),FUNLG   ),(FIAT (2),FMXLG   ),(FIAT (3),FCULG   ),
     3     (FIAT (4),FEQU (1)),(FIAT (4),FILE (1)),(FIAT (4),FORD (1)),
     4     (FIAT (5),FDBN (1)),(FIAT (7),FMAT (1)),(MD   (1),MLGN    ),
     5     (MD   (2),MLSN (1)),(MD   (3),MINP (1)),(MD   (4),MOUT (1)),
     6     (MD   (5),MSCR (1)),(SOS  (1),SLGN    ),(SOS  (2),SDBN (1)),
     7     (SOS  (4),SAL  (1)),(SOS  (4),SNTU (1)),(SOS  (4),SORD (1)),
     8     (XF1AT(1),FNTU (1)),(XF1AT(1),FON  (1)),(XF1AT(2),FPUN (1)),
     9     (XF1AT(3),FCUM (1)),(XF1AT(4),FCUS (1)),(XF1AT(5),FKND (1))
      EQUIVALENCE              (COMM (1),ALMSK   ),(COMM (2),APNDMK  ),
     1     (COMM (3),CURSNO  ),(COMM (4),ENTN1   ),(COMM (5),ENTN2   ),
     2     (COMM (6),ENTN3   ),(COMM (7),ENTN4   ),(COMM (8),FLAG    ),
     3     (COMM (9),FNX     ),(COMM(10),LMSK    ),(COMM(11),LXMSK   ),
     4     (COMM(12),MACSFT  ),(COMM(13),RMSK    ),(COMM(14),RXMSK   ),
     5     (COMM(15),S       ),(COMM(16),SCORNT  ),(COMM(17),TAPMSK  ),
     6     (COMM(18),THCRMK  ),(COMM(19),ZAP     )
      DATA  PURGE1  /4HXPUR   ,4HGE     /
C
      CALL XSFADD
      K = -1
      GO TO 10
C
C
      ENTRY XEQUIV
C     ============
C
      CALL XSFADD
      K = +1
      PRISAV= 0
      SECCHN= 0
   10 ENTN1 = ICFIAT
      LMT1  = FUNLG* ENTN1
      LMT2  = LMT1 + 1
      LMT3  = FCULG* ENTN1
      IF (FCULG .GE. FMXLG) GO TO 610
      NFCULG= LMT3 + 1
      INCR  = 1
C
C     S = O 400000000000     Z 80000000
C
   20 S = LSHIFT(1,NBPW-1)
C
C     INITIALIZE FOR FIRST SET OF DATA BLOCKS
C
      NWDS = X(1)
      I = 7
  100 NDBS = X(I)
C
C     FIND POSITION OF VPS POINTER WORD
C
      JPT = I + 2*NDBS + 1
      IF (K .EQ. 1) JPT = JPT + 1
      IVPS  = X(JPT)
      IEXEC = -1
      IF (IVPS .GT. 0) IEXEC = VPS(IVPS)
C
C     TEST CONDITIONAL INDICATOR (NOT HERE, BELOW TO PERMIT UNPURGE-
C     UNEQUIV
C
      GO TO 200
C
C     INCREMENT AND LOOK AT NEXT SET OF DATA BLOCKS
C
  150 I = JPT + 1
      IF (I .LT. NWDS) GO TO 100
      RETURN
C
C     TEST FOR PURGE OR EQUIV
C
  200 J = I + 1
      IF (K .GT. 0) GO TO 400
C
C     PURGE LOGIC FOLLOWS
C
  220 XJ1 = X(J  )
      XJ2 = X(J+1)
      DO 260 N = 1,LMT3,ENTN1
      IF (XJ1.NE.FDBN(N) .OR. XJ2.NE.FDBN(N+1)) GO TO 260
      IF (N  .LE. LMT1) GO TO 240
      IF (IEXEC .GE. 0) GO TO 230
      FILE(N) = ZAP
      GO TO 280
C
  230 IF (ANDF(RMSK,FILE(N)) .NE. ZAP) GO TO 300
C
C     UNPURGE (CLEAR THE ENTRY)
C
      LMT4 = N + ENTN1 - 1
      DO 235 M = N,LMT4
  235 FILE(M) = 0
      GO TO 300
  240 IF (IEXEC .GE. 0) GO TO 300
      HOLD = ANDF(RXMSK,FILE(N))
      LMT4 = N + ENTN1 - 1
      DO 250 M = N,LMT4
  250 FILE(M) = 0
      FILE(N) = HOLD
C
      GO TO 270
  260 CONTINUE
  270 IF (IEXEC .GE. 0) GO TO 300
      FILE(NFCULG  ) = ZAP
      FDBN(NFCULG  ) = XJ1
      FDBN(NFCULG+1) = XJ2
      FCULG = FCULG + INCR
      IF (FCULG .GE. FMXLG) GO TO 620
      NFCULG = NFCULG + ENTN1
C
  280 CALL XPOLCK (XJ1,XJ2,FN,L)
      IF (FN .EQ. 0) GO TO 300
      DDBN(L  ) = 0
      DDBN(L+1) = 0
C
  300 J = J + 2
      IF (J-2.EQ.I+1 .AND. K.GT.0) J = J + 1
      IF (J .LT. JPT) GO TO 220
      GO TO 150
C
C     EQUIV LOGIC FOLLOWS
C
  400 XJ1 = X(J  )
      XJ2 = X(J+1)
      DO 450 N = 1,LMT3,ENTN1
      IF (XJ1.NE.FDBN(N) .OR. XJ2.NE.FDBN(N+1)) GO TO 450
      IF (J .NE. I+1) GO TO 420
C
C     PRIMARY
C
      PRISAV = ANDF(RXMSK,FILE(N))
      IF (IEXEC .GE. 0) GO TO 550
C
C     IF PRIMARY FILE IS PURGED OR HAS ZERO TRAILERS, PURGE SECONDARYS
C
      IF (ANDF(RMSK,PRISAV) .EQ. ZAP) GO TO 300
      IF (FMAT(N).NE.0 .OR.  FMAT(N+1).NE.0 .OR. FMAT(N+2).NE.0)
     1    GO TO 405
      IF (ENTN1.EQ.11 .AND. (FMAT(N+5).NE.0 .OR. FMAT(N+6).NE.0 .OR.
     1    FMAT(N+7).NE.0)) GO TO 405
      GO TO 300
  405 FEQU(N) = ORF(S,FEQU(N))
      NSAV = N
      CALL XPOLCK (XJ1,XJ2,FNSAV,LSAV)
      IF (FNSAV .NE. 0) DFNU(LSAV) = ORF(S,DFNU(LSAV))
C
C     IF PRIMARY FILE CONTAINS OTHER UNEQUIV D.B.- CLEAR THEM
C
      DO 415 JX = 1,LMT3,ENTN1
      IF (FEQU(JX).LT.0 .OR. JX.EQ.N) GO TO 415
      IF (PRISAV .NE. ANDF(RXMSK,FILE(JX))) GO TO 415
      LMT4 = JX + ENTN1 - 1
      DO 410 M = JX,LMT4
  410 FILE(M) = 0
      IF (JX .LE. LMT1) FILE(JX) = PRISAV
  415 CONTINUE
      GO TO 550
C
C     SECONDARY
C
  420 IF (IEXEC .GE. 0) GO TO 425
      IF (PRISAV.EQ. 0) GO TO 435
      IF (FILE(N).LT.0 .AND. ANDF(RXMSK,FILE(N)).NE.PRISAV)
     1    SECCHN = ANDF(RMSK,FILE(N))
      IF (N .LE. LMT1) GO TO 430
      FILE(N  ) = ORF(ANDF(LXMSK,FILE(N)),PRISAV)
      FEQU(N  ) = ORF(S,FEQU(N))
      FMAT(N  ) = FMAT(NSAV  )
      FMAT(N+1) = FMAT(NSAV+1)
      FMAT(N+2) = FMAT(NSAV+2)
      IF (ENTN1 .NE. 11) GO TO 480
      FMAT(N+5) = FMAT(NSAV+5)
      FMAT(N+6) = FMAT(NSAV+6)
      FMAT(N+7) = FMAT(NSAV+7)
      GO TO 480
  425 IF (FEQU(N).GE.0 .OR. PRISAV.NE.ANDF(RXMSK,FILE(N))) GO TO 550
C
C     UNEQUIV (CLEAR SEC EQUIV ENTRY)
C
      LMT4 = N + ENTN1 - 1
      DO 427 M = N,LMT4
  427 FILE(M) = 0
      IF (N .LE. LMT1) FILE(N) = PRISAV
      CALL XPOLCK (XJ1,XJ2,FN,L)
      IF (FN .EQ. 0) GO TO 550
      DDBN(L  ) = 0
      DDBN(L+1) = 0
      GO TO 550
  430 FILE(NFCULG) = ORF(ANDF(LXMSK,FILE(N)),PRISAV)
  435 HOLD = ANDF(RXMSK,FILE(N))
      LMT4 = N + ENTN1 -1
      DO 440 M = N,LMT4
  440 FILE(M) = 0
      IF (N .LE. LMT1) FILE(N) = HOLD
      IF (PRISAV .EQ. 0) GO TO 480
      GO TO 470
C
C     FILE IS NOT IN FIAT -- CHECK PARM FOR TYPE OF EQUIV
C
  450 CONTINUE
      IF (IEXEC .LT. 0) GO TO 458
C
C     ELIMINATE EQUIV FILES -- CHECK FOR PRIMARY FILE
C
      IF (J .NE. I+1) GO TO 455
C
C     PRIMARY FILE
C
      CALL XPOLCK (XJ1,XJ2,FNSAV,LSAV)
C
C     LEAVE EQUIV FLAG FOR XDPH
C
      GO TO 550
C
C     SECONDARY FILE --  BREAK EQUIV
C
  455 CALL XPOLCK (XJ1,XJ2,SNSAV,SSAV)
C
C     CHECK IF FILE EXISTS AND IS EQUIVED TO PRIMARY FILE
C
      IF (SNSAV.EQ.0 .OR. FNSAV.NE.SNSAV) GO TO 550
      DDBN( SSAV  ) = 0
      DDBN( SSAV+1) = 0
      GO TO 550
C
C     CHECK FOR PRIMARY FILE
C
  458 IF (J .NE. I+1) GO TO 460
C
C     -IF PRIMARY, IT MUST BE ON POOL
C
      CALL XPOLCK (XJ1,XJ2,FNSAV,LSAV)
      IF (FNSAV .EQ. 0) GO TO 300
      DFNU(LSAV) = ORF(S,DFNU(LSAV))
      GO TO 550
C
C     -IF SECONDARY, WAS PRIMARY IN FIAT
C
  460 IF (PRISAV .EQ. 0) GO TO 480
C
C     -PRIMARY WAS IN FIAT, SET UP SECONDARY IN FIAT
C
      FILE(NFCULG  ) = PRISAV
  470 FEQU(NFCULG  ) = ORF(S,FEQU(NFCULG))
      FDBN(NFCULG  ) = XJ1
      FDBN(NFCULG+1) = XJ2
      FMAT(NFCULG  ) = FMAT(NSAV  )
      FMAT(NFCULG+1) = FMAT(NSAV+1)
      FMAT(NFCULG+2) = FMAT(NSAV+2)
      IF (ENTN1 .NE. 11) GO TO 475
      FMAT(NFCULG+5) = FMAT(NSAV+5)
      FMAT(NFCULG+6) = FMAT(NSAV+6)
      FMAT(NFCULG+7) = FMAT(NSAV+7)
  475 FCULG = FCULG + INCR
      IF (FCULG .GE. FMXLG) GO TO 630
      NFCULG = NFCULG + ENTN1
C
C     WAS SECONDARY FILE IN FIAT ALREADY EQUIV TO OTHERS
C
  480 IF (SECCHN .EQ. 0) GO TO 490
C
C     SEC. FILE WAS EQUIV - DRAG ALONG ALL EQUIVS
C
      DO 485 IJ = 1,LMT3,ENTN1
      IF (FILE(IJ) .GE. 0) GO TO 485
      IF (IJ       .EQ. N) GO TO 485
      IF (ANDF(RMSK,FILE(IJ)) .NE. SECCHN) GO TO 485
C
C     CREATE AN ENTRY IN OSCENT TO EXPLICITLY EQUIV THIS DB
C
      M1   = NWDS + 1
      NWDS = NWDS + 6
      X(M1  ) = 2
      X(M1+1) = XJ1
      X(M1+2) = XJ2
      IF (K .NE. 1) GO TO 482
      X(M1+3) = 0
      NWDS = NWDS + 1
      M1   = M1   + 1
  482 CONTINUE
      X(M1+3) = FDBN(IJ  )
      X(M1+4) = FDBN(IJ+1)
      X(M1+5) = IVPS
  485 CONTINUE
C
C     IS SECONDARY FILE ON POOL
C
  490 CALL XPOLCK (XJ1,XJ2,FN,L)
      IF (FN .EQ. 0) GO TO 500
C
C     WAS SEC. FILE ON POOL ALREADY EQUIV TO OTHERS
C
      IF (DFNU(L).GE.0 .OR. FNSAV.EQ.FN) GO TO 495
C
C     SEC. FILE ON POOL WAS EQUIV - DRAG ALONG ALL EQUIVS
C
      LMT4 = DCULG* ENTN4
      M    = LMT4 + 1
      DO 494 IJ = 1,LMT4,ENTN4
      IF (DFNU(IJ).GE.0  .OR. IJ.EQ.L) GO TO 494
      IF (ANDF(RMSK,DFNU(IJ)) .NE. FN) GO TO 494
      IF (FNSAV .EQ. 0) GO TO 491
      DDBN(M  ) = DDBN(IJ  )
      DDBN(M+1) = DDBN(IJ+1)
      DFNU(M  ) = DFNU(LSAV)
      DCULG = DCULG + 1
      IF (DCULG .GT. DMXLG) GO TO 910
      M = M + ENTN4
      GO TO 493
C
C     CREATE AN ENTRY IN OSCENT TO EXPLICITLY EQUIV THIS DB
C
  491 M1   = NWDS + 1
      NWDS = NWDS + 6
      X(M1  ) = 2
      X(M1+1) = XJ1
      X(M1+2) = XJ2
      IF (K .NE. 1) GO TO 492
      X(M1+3) = 0
      NWDS = NWDS + 1
      M1   = M1 + 1
  492 CONTINUE
      X(M1+3) = DDBN(IJ  )
      X(M1+4) = DDBN(IJ+1)
      X(M1+5) = IVPS
  493 DDBN(IJ  ) = 0
      DDBN(IJ+1) = 0
  494 CONTINUE
C
C     IF SECONDARY FILE IS ON POOL AND PRIMARY IS NOT - DELETE SEC REF
C
  495 IF (FNSAV .NE. 0) GO TO 530
      DDBN(L  ) = 0
      DDBN(L+1) = 0
      GO TO 550
C
C     IF SECONDARY FILE IS NOT ON POOL AND PRIMARY IS - ADD SEC REF
C
  500 IF (FNSAV .EQ. 0) GO TO 550
  520 M = DCULG*ENTN4 + 1
      DDBN(M  ) = XJ1
      DDBN(M+1) = XJ2
      DFNU(M  ) = DFNU(LSAV)
      DCULG = DCULG + 1
      IF (DCULG .GT. DMXLG) GO TO 910
      GO TO 550
C
C     BOTH PRIMARY AND SECONDARY ON POOL - IF NOT SAME FILE,
C     DELETE OLD SEC REF AND ADD NEW SEC REF
C
  530 IF (FNSAV .EQ. FN) GO TO 550
      DDBN(L  ) = 0
      DDBN(L+1) = 0
      GO TO 520
C
  550 J = J + 2
      IF (J-2 .EQ. I+1) J = J + 1
      SECCHN = 0
      IF (J .LT. JPT) GO TO 400
      PRISAV = 0
      GO TO 150
C
C     POTENTIAL FIAT OVERFLOW- LOOK FOR OTHER SLOTS IN FIAT TAIL
C
  610 ASSIGN 20 TO IBACK
      GO TO 640
  620 ASSIGN 280 TO IBACK
      GO TO 640
  630 ASSIGN 480 TO IBACK
  640 IF (FCULG .GT. FMXLG) GO TO 900
      DO 650 NN = LMT2,LMT3,ENTN1
      IF (FILE(NN).LT.0 .OR. ANDF(ZAP,FILE(NN)).EQ.ZAP) GO TO 650
      IF (FMAT(NN).NE.0 .OR. FMAT(NN+1).NE.0 .OR. FMAT(NN+2).NE.0)
     1    GO TO 650
      IF (ENTN1.EQ.11 .AND. (FMAT(NN+5).NE.0 .OR. FMAT(NN+6).NE.0 .OR.
     1    FMAT(NN+7).NE.0)) GO TO 650
      NFCULG = NN
      INCR   = 0
      GO TO 660
  650 CONTINUE
      NFCULG = NFCULG + ENTN1
      INCR   = 1
  660 GO TO IBACK, (20,280,480)
C
C     ERROR MESSAGES
C
  900 WRITE  (OUTTAP,901) SFM
  901 FORMAT (A25,' 1201, FIAT OVERFLOW.')
      GO TO 1000
  910 WRITE  (OUTTAP,911) SFM
  911 FORMAT (A25,' 1202, DPL OVERFLOW.')
 1000 CALL MESAGE (-37,0,PURGE1)
      RETURN
      END

      SUBROUTINE ALG01 (XDATA,YDATA,NDATA,XIN,YOUT,SLOPE,NXY,NTYPE,NWOT)
C
      REAL      M
C
      DIMENSION XDATA(2),YDATA(2),XIN(1),YOUT(1),SLOPE(1),A(21),B(21),
     1          D(21),M(21)
C
      IF (NTYPE.EQ.1.OR.NDATA.LT.3) GO TO 210
      A(1)=1.0
      B(1)=0.0
      D(1)=0.0
      N=NDATA-1
      DO 110 I=2,N
      A(I)=(XDATA(I+1)-XDATA(I-1))/3.0-(XDATA(I)-XDATA(I-1))*B(I-1)/(6.0
     1*A(I-1))
      B(I)=(XDATA(I+1)-XDATA(I))/6.0
 110  D(I)=(YDATA(I+1)-YDATA(I))/(XDATA(I+1)-XDATA(I))-(YDATA(I)-YDATA(I
     1-1))/(XDATA(I)-XDATA(I-1))-(XDATA(I)-XDATA(I-1))*D(I-1)/(6.0*A(I-1
     2))
      A(NDATA)=0.0
      B(NDATA)=1.0
      D(NDATA)=0.0
      M(NDATA)=A(NDATA)*D(N)/(A(NDATA)*B(N)-A(N)*B(NDATA))
      DO 120 II=2,NDATA
      I=NDATA+1-II
 120  M(I)=(D(I)-B(I)*M(I+1))/A(I)
      ASSIGN 150 TO IY
      IF (NWOT.EQ.1) ASSIGN 160 TO IY
      ASSIGN 160 TO ISLOPE
      IF (NWOT.EQ.0) ASSIGN 200 TO ISLOPE
      J=2
      DO 200 I=1,NXY
      IF (XIN(I).LT.XDATA(1)) GO TO 170
      IF (XIN(I).GT.XDATA(NDATA)) GO TO 180
 130  IF (XIN(I).LE.XDATA(J)) GO TO 140
      J=J+1
      GO TO 130
 140  DX=XDATA(J)-XDATA(J-1)
      GO TO IY, (150,160)
 150  YOUT(I)=M(J-1)/(6.0*DX)*(XDATA(J)-XIN(I))**3+M(J)/(6.0*DX)*(XIN(I)
     1-XDATA(J-1))**3+(XDATA(J)-XIN(I))*(YDATA(J-1)/DX-M(J-1)/6.0*DX)+(X
     2IN(I)-XDATA(J-1))*(YDATA(J)/DX-M(J)/6.0*DX)
      GO TO ISLOPE, (160,200)
 160  SLOPE(I)=(-M(J-1)*(XDATA(J)-XIN(I))**2/2.0+M(J)*(XIN(I)-XDATA(J-1)
     1)**2/2.0+YDATA(J)-YDATA(J-1))/DX-(M(J)-M(J-1))/6.0*DX
      GO TO 200
 170  JP=1
      KP=2
      GO TO 190
 180  JP=NDATA
      KP=N
 190  YPRIME=(YDATA(KP)-YDATA(JP))/(XDATA(KP)-XDATA(JP))-M(KP)/6.0*(XDAT
     1A(KP)-XDATA(JP))
      IF (NWOT.NE.1) YOUT(I)=YDATA(JP)+(XIN(I)-XDATA(JP))*YPRIME
      IF (NWOT.NE.0) SLOPE(I)=YPRIME
 200  CONTINUE
      RETURN
 210  IF (NDATA.NE.1) GO TO 230
      DO 220 I=1,NXY
 220  YOUT(I)=YDATA(1)
      RETURN
 230  IF (NWOT.EQ.1) GO TO 254
      J=2
      DO 250 I=1,NXY
 240  IF (XIN(I).LE.XDATA(J).OR.J.EQ.NDATA) GO TO 250
      J=J+1
      GO TO 240
 250  YOUT(I)=YDATA(J-1)+(YDATA(J)-YDATA(J-1))/(XDATA(J)-XDATA(J-1))*(XI
     1N(I)-XDATA(J-1))
      IF (NWOT.NE.2) RETURN
 254  YPRIME=(YDATA(2)-YDATA(1))/(XDATA(2)-XDATA(1))
      DO 260 I=1,NXY
 260  SLOPE(I)=YPRIME
      RETURN
      END

      SUBROUTINE TLODM6 (TI)
C
C     THERMAL LOAD VECTOR FOR TRIM6 (LINEAR STRAIN MEMBRANE TRIANGLE)
C     ELEMENT
C
C     EST ENTRIES
C
C     EST ( 1) = ELEMENT ID                              INTEGER
C     EST ( 2) = SCALAR INDEX NUMBER FOR GRID POINT 1    INTEGER
C     EST ( 3) = SCALAR INDEX NUMBER FOR GRID POINT 2    INTEGER
C     EST ( 4) = SCALAR INDEX NUMBER FOR GRID POINT 3    INTEGER
C     EST ( 5) = SCALAR INDEX NUMBER FOR GRID POINT 4    INTEGER
C     EST ( 6) = SCALAR INDEX NUMBER FOR GRID POINT 5    INTEGER
C     EST ( 7) = SCALAR INDEX NUMBER FOR GRID POINT 6    INTEGER
C     EST ( 8) = THETA                                   REAL
C     EST ( 9) = MATERIAL IDENTIFICATION NUMBER          INTEGER
C     EST (10) = THICKNESS T1 AT GRID POINT 1            REAL
C     EST (11) = THICKNESS T3 AT GRID POINT 3            REAL
C     EST (12) = THICKNESS T5 AT GRID POINT 5            REAL
C     EST (13) = NON-STRUCTURAL MASS                     REAL
C     X1,Y1,Z1 FOR ALL SIX POINTS ARE IN NASTRAN BASIC SYSTEM
C
C     EST (14) = CO-ORDINATE SYSTEM ID FOR GRID POINT 1  INTEGER
C     EST (15) = CO-ORDINATE X1                          REAL
C     EST (16) = CO-ORDINATE Y1                          REAL
C     EST (17) = CO-ORDINATE Z1                          REAL
C     EST (18) = CO-ORDINATE SYSTEM ID FOR GRID POINT 2  INTEGER
C     EST (19) = CO-ORDINATE X2                          REAL
C     EST (20) = CO-ORDINATE Y2                          REAL
C     EST (21) = CO-ORDINATE Z2                          REAL
C     EST (22) = CO-ORDINATE SYSTEM ID FOR GRID POINT 3  INTEGER
C     EST (23) = CO-ORDINATE X3                          REAL
C     EST (24) = CO-ORDINATE Y3                          REAL
C     EST (25) = CO-ORDINATE Z3                          REAL
C     EST (26) = CO-ORDINATE SYSTEM ID FOR GRID POINT 4  INTEGER
C     EST (27) = CO-ORDINATE X4                          REAL
C     EST (28) = CO-ORDINATE Y4                          REAL
C     EST (29) = CO-ORDINATE Z4                          REAL
C     EST (30) = CO-ORDINATE SYSTEM ID FOR GRID POINT 5  INTEGER
C     EST (31) = CO-ORDINATE X5                          REAL
C     EST (32) = CO-ORDINATE Y5                          REAL
C     EST (33) = CO-ORDINATE Z5                          REAL
C     EST (34) = CO-ORDINATE SYSTEM ID FOR GRID POINT 6  INTEGER
C     EST (35) = CO-ORDINATE X6                          REAL
C     EST (36) = CO-ORDINATE Y6                          REAL
C     EST (37) = CO-ORDINATE Z6                          REAL
C     EST (38) TO EST (43)  -  ELEMENT TEMPERATURES AT SIX GRID POINTS
C
      LOGICAL         UNIMEM,   UNITEM
      REAL            IVECT(3), JVECT(3), KVECT(3), CC(3),    DD(3),
     1                G(9),     G1(3),    NAME(2),  F(5,5),   NSM,
     2                XC(6),    YC(6),    ZC(6),    Q(6,6),   E(6),
     3                TRANS(9), QINV(36), PTEM(12), PTELE(12),PTGLB(18),
     4                PSUB(2),  PSUBT(3), PSUBT1(3),TI(6)
      INTEGER         XU(12),   YU(12),   XV(12),   YV(12),   SIL(6),
     1                SIL1,     RK(3),    SK(3),    TL(3),    UL(3),
     2                IND(6,3), ICS(6),   IEST(45), NL(6)
      COMMON /TRIMEX/ EST(100)
      COMMON /ZZZZZZ/ PG(1)
C
C     INPUT AND OUTPUT BLOCKS FOR SUBROUTINE MAT
C
      COMMON /MATIN / MATID,MATFLG,ELTEMP,PLA34,SINTH,COSTH
      COMMON /MATOUT/ EM(6),RHOY,ALF(3),TREF,GSUBE,SIGTY,SIGCY,SIGSY,
     1                RJ11,RJ12,RJ22
C
C     EQUIVALENCE  IEST WITH EST IN COMMON BLOCK /EMGEST/ SINCE EST IS
C     A MIXED INTEGER AND REAL ARRAY
C
      EQUIVALENCE   (IEST(1),EST(1))
      EQUIVALENCE   (A,DISTA),(B,DISTB),(C,DISTC),(CC(1),C1),(CC(2),C2),
     1              (CC(3),C3),(DD(1),D1),(DD(2),D2),(DD(3),D3)
      DATA   XU   / 0,1,0,2,1,0,6*0/ ,   YU / 0,0,1,0,1,2,6*0/
      DATA   XV   / 6*0,0,1,0,2,1,0/ ,   YV / 6*0,0,0,1,0,1,2/
      DATA   RK   / 0,1,0          / ,   SK / 0,0,1          /
      DATA   TL   / 0,1,0          / ,   UL / 0,0,1          /
      DATA   BLANK/ 4H             / ,  NAME/ 4HTRIM, 4H6    /
      DATA   DEGRA/ 0.0174532925   /
C
C     ALLOCATE EST VALUES TO RESPECTIVE  LOCAL  VARIABLES
C
      IDELE = IEST(1)
      DO 10 I = 1,6
      NL(I)  = IEST(I+1)
   10 CONTINUE
      THETAM = EST(8)
      MATID1 = IEST(9)
      TMEM1  = EST(10)
      TMEM3  = EST(11)
      TMEM5  = EST(12)
C
C     IF TMEM3 OR TMEM5 IS 0.0 OR BLANK,IT WILL BE SET EQUAL TO TMEM1
C
      IF (TMEM3.EQ.0.0 .OR. TMEM3.EQ.BLANK) TMEM3 = TMEM1
      IF (TMEM5.EQ.0.0 .OR. TMEM5.EQ.BLANK) TMEM5 = TMEM1
C
      NSM = EST(13)
C
      J = 0
      DO 20 I = 14,34,4
      J = J + 1
      ICS(J) = IEST(I )
      XC (J) = EST(I+1)
      YC (J) = EST(I+2)
      ZC (J) = EST(I+3)
   20 CONTINUE
C
C     TEMPERATURE AT THE THREE GRID POINTS ARE  DENOTED BY TO1,TO3 AND
C     TO5
C
      TO1 = TI(1)
      TO3 = TI(3)
      TO5 = TI(5)
C
      ELTEMP = (EST(38)+EST(39)+EST(40)+EST(41)+EST(42)+EST(43))/6.0
      THETA1 = THETAM*DEGRA
      SINTH  = SIN(THETA1)
      COSTH  = COS(THETA1)
      IF (ABS(SINTH) .LE. 1.0E-06) SINTH = 0.0
C
C     CALCULATIONS FOR THE  TRIANGLE
C
      CALL TRIF (XC,YC,ZC,IVECT,JVECT,KVECT,A,B,C,IEST(1),NAME)
C
C     COMPUTE THE AREA INTEGRATION FUNCTION F, AND
C     EVALUATE THE CONSTANTS C1,C2,AND C3 IN THE LINEAR EQUATION FOR
C     THICKNESS VARIATION
C
      CALL AF (F,5,A,B,C,C1,C2,C3,TMEM1,TMEM3,TMEM5,0)
      UNIMEM = .FALSE.
      IF (ABS(C2).LE.1.0E-06 .AND. ABS(C3).LE.1.0E-06) UNIMEM = .TRUE.
C
C     CALCULATIONS FOR  Q MATRIX AND ITS INVERSE
C
      DO 30 I = 1,6
      DO 30 J = 1,6
      Q(I,J) = 0.0
   30 CONTINUE
      DO 40 I = 1,6
      Q(I,1) = 1.0
      Q(I,2) = XC(I)
      Q(I,3) = YC(I)
      Q(I,4) = XC(I)*XC(I)
      Q(I,5) = XC(I)*YC(I)
      Q(I,6) = YC(I)*YC(I)
   40 CONTINUE
C
C     FIND INVERSE OF Q MATRIX
C
C     NO NEED TO COMPUTE DETERMINANT SINCE IT IS NOT USED SUBSEQUENTLY.
C
      ISING = -1
      CALL INVERS (6,Q,6,QINV(1),0,DETERM,ISING,IND)
C
C     ISING EQUAL TO 2 IMPLIES THAT Q MATRIX IS SINGULAR
C
C     EVALUATE  MATERIAL PROPERTIES AND FILL IN G MATRIX
C
      MATFLG = 2
      MATID  = MATID1
      CALL MAT (IDELE)
      G(1) = EM(1)
      G(2) = EM(2)
      G(3) = EM(3)
      G(4) = EM(2)
      G(5) = EM(4)
      G(6) = EM(5)
      G(7) = EM(3)
      G(8) = EM(5)
      G(9) = EM(6)
C
C     G1 IS G TIMES ALFA
C
      CALL GMMATS (G,3,3,0,ALF,3,1,0,G1)
C
C     CALCULATION OF THERMAL LOAD VECTOR
C
C     EVALUATE THE CONSTANTS D1,D2,D3 IN THE LINEAR EQUATION FOR
C     TEMPERATURE VARIATION OVER THE ELEMENT
C
      T1BAR = TO1 - TREF
      T3BAR = TO3 - TREF
      T5BAR = TO5 - TREF
C
      CALL AF (F,5,A,B,C,D1,D2,D3,T1BAR,T2BAR,T3BAR,1)
      UNITEM = .FALSE.
      IF (ABS(D2).LE.1.0E-06 .AND. ABS(D3).LE.1.0E-06) UNITEM = .TRUE.
      DO 90 I = 1,12
      IX  = XU(I)
      RIX = IX
      JX  = YU(I)
      RJX = JX
      KX  = XV(I)
      RKX = KX
      LX  = YV(I)
      RLX = LX
      PTEMP = 0.0
      DO 70 K = 1,3
      IXR = IX + RK(K)
      JXS = JX + SK(K)
      KXR = KX + RK(K)
      LXS = LX + SK(K)
      DO 50 L = 1,3
      IXRT  = IXR + TL(L)
      JXSU1 = JXS + UL(L) + 1
      KXRT1 = KXR + TL(L) + 1
      LXSU  = LXS + UL(L)
      IXRT1 = IXRT+ 1
      JXSU  = JXSU1 - 1
      KXRT  = KXRT1 - 1
      LXSU1 = LXSU + 1
      IF (IXRT .GT.0) PTEMP = PTEMP+CC(K)*DD(L)*G1(1)*RIX*F(IXRT ,JXSU1)
      IF (LXSU .GT.0) PTEMP = PTEMP+CC(K)*DD(L)*G1(2)*RLX*F(KXRT1,LXSU )
      IF (JXSU .GT.0) PTEMP = PTEMP+CC(K)*DD(L)*G1(3)*RJX*F(IXRT1,JXSU )
      IF (KXRT .GT.0) PTEMP = PTEMP+CC(K)*DD(L)*G1(3)*RKX*F(KXRT ,LXSU1)
      IF (UNITEM) GO TO 60
   50 CONTINUE
   60 CONTINUE
      IF (UNIMEM) GO TO 80
   70 CONTINUE
   80 CONTINUE
      PTEM(I) = PTEMP
   90 CONTINUE
C
      CALL GMMATS (Q,6,6,0,PTEM(1),6,1,0,PTELE(1))
      CALL GMMATS (Q,6,6,0,PTEM(7),6,1,0,PTELE(7))
C
C     REORDER THE THERMAL LOAD VEC SO THAT THE DISPLACEMENTS OF A GRID
C     POINT ARE ARRANGED CONSECUTIVELY
C
      DO 110 K = 1,6
      DO 100 I = 1,2
      K1 = 6*(I-1) + K
      I1 = 2*(K-1) + I
      PTEM(I1) = PTELE(K1)
  100 CONTINUE
  110 CONTINUE
C
C     TRANSFORM THE THERMAL LOAD VECTOR PTEM FROM ELEMENT CO-ORDINATES
C     TO BASIC CO-ORDINATES
C
      E(1) = IVECT(1)
      E(2) = JVECT(1)
      E(3) = IVECT(2)
      E(4) = JVECT(2)
      E(5) = IVECT(3)
      E(6) = JVECT(3)
      DO 120 I = 1,18
      PTGLB(I) = 0.0
  120 CONTINUE
      DO 130 I = 1,6
      SIL(I) = I
  130 CONTINUE
      DO 200 I = 1,6
      SIL1 = SIL(I)
      DO 140 K = 1,2
      K1 = (SIL1-1)*2 + K
      PSUB(K) = PTEM(K1)
  140 CONTINUE
      CALL GMMATS (E,3,2,0,PSUB,2,1,0,PSUBT)
C
C     TRANSFORM THE PSUBT ROM BASIC TO GLOBAL CO-ORDINATES
C
      IF (NL(SIL1).EQ.0 .OR. ICS(SIL1).EQ.0) GO TO 160
      K = 4*SIL1 + 10
      CALL TRANSS (IEST(K),TRANS)
      CALL GMMATS (TRANS(1),3,3,1,PSUBT,3,1,0,PSUBT1)
      DO 150 K = 1,3
      PSUBT(K) = PSUBT1(K)
  150 CONTINUE
  160 CONTINUE
C
C     INSERT PTGLB IN GLOBAL LOAD VECTOR PG
C
      DO 180 II = 1,3
      I1 = (I-1)*3 + II
      I2 = IEST(I+1) + II - 1
      PTGLB(I1) = PSUBT(II)
      PG(I2) = PG(I2) + PSUBT(II)
  180 CONTINUE
  200 CONTINUE
      RETURN
      END

      SUBROUTINE Q2BCS (EST,PLANAR,RMAT,ET,IERROR)
C
C     BASIC CALCULATIONS ARE PERFORMED FOR THE QDMEM2 ELEMENT IN THIS
C     ROUTINE (SINGLE-PRECISION VERSION)
C
      LOGICAL     PLANAR
      REAL        EST(1)
      REAL        MAG   ,D12(3),G1(3) ,IAREA  ,D13(3) ,GRID(3,5),
     1            G2(3) ,ITWOH ,D24(3),VEC(3) ,G3(3)  ,ET(3,3)  ,
     2            G5(3) ,G4(3) ,SADOTB,RMAT(3,5)
      EQUIVALENCE (GRID(1,1),G1(1)),(GRID(1,2),G2(1)),(GRID(1,3),G3(1)),
     1            (GRID(1,4),G4(1)),(GRID(1,5),G5(1))
C
C     MOVE GRID COORDINATES
C
      DO 10 I = 1,3
      G1(I) = EST(I+10)
      G2(I) = EST(I+14)
      G3(I) = EST(I+18)
      G4(I) = EST(I+22)
   10 CONTINUE
C
C     FORM  D   , D   AND  D   VECTORS
C            13    24       12
C
      DO 20 I = 1,3
      D12(I) = G2(I) - G1(I)
      D13(I) = G3(I) - G1(I)
      D24(I) = G4(I) - G2(I)
   20 CONTINUE
C
C     NVEC  =  D13 CROSS D24 = K-VECTOR (UN-NORMALIZED)
C
      CALL SAXB (D13,D24,VEC)
      MAG   =  SQRT (SADOTB(VEC,VEC))
      IAREA = 0.5*MAG
C
C     NORMALIZE K-VECTOR
C
      IF (MAG) 100,100,30
   30 ET(1,3) = VEC(1)/MAG
      ET(2,3) = VEC(2)/MAG
      ET(3,3) = VEC(3)/MAG
C
C     H = .5 * (D   DOT K-VEC)
C                12
C
      ITWOH = SADOTB(D12,ET(1,3))
C
C     I-VECTOR (UN-NORMALIZED) = (D  ) - 2 H (K-VECTOR)
C                                  12
C
      DO 40 I = 1,3
      VEC(I) = D12(I) - ITWOH*ET(I,3)
   40 CONTINUE
      MAG =  SQRT(SADOTB(VEC,VEC))
C
C     NORMALIZE I-VECTOR
C
      IF (MAG) 100,100,50
   50 ET(1,1) = VEC(1)/MAG
      ET(2,1) = VEC(2)/MAG
      ET(3,1) = VEC(3)/MAG
C
C     JVEC = KVEC CROSS IVEC
C
      CALL SAXB (ET(1,3),ET(1,1),ET(1,2))
C
C     FILL THE SUB-TRIANGLE ELEMENT COORDINATE MATRIX
C
      DO 60 I = 1,3
      G5(I) = 0.25*(G1(I) + G2(I) + G3(I) + G4(I))
   60 CONTINUE
      RMAT(1,1) = 0.0
      RMAT(2,1) = 0.0
      RMAT(3,1) =-ITWOH/2.0
      DO 70 I = 2,5
      VEC(1) = GRID(1,I) - G1(1)
      VEC(2) = GRID(2,I) - G1(2)
      VEC(3) = GRID(3,I) - G1(3)
      CALL GMMATS (ET,3,3,0, VEC,3,1,0, RMAT(1,I))
      RMAT(1,I) = RMAT(1,I) + RMAT(1,1)
      RMAT(2,I) = RMAT(2,I) + RMAT(2,1)
      RMAT(3,I) = RMAT(3,I) + RMAT(3,1)
   70 CONTINUE
C
C     SET PLANAR FLAG .TRUE. OR .FALSE.
C
      IF ((ITWOH/2.0)**2/IAREA .LE. 0.01) GO TO 80
      PLANAR = .FALSE.
      GO TO 90
   80 PLANAR = .TRUE.
C
C     ALL BASIC CALCULATIONS NOW COMPLETE
C
   90 IERROR = 0
      RETURN
C
C     ERROR CONDITION, BAD ELEMENT GEOMETRY.
C
  100 IERROR = 1
      RETURN
      END

      SUBROUTINE XDCODE
C
C     (MACHINE INDEPENDENT FORTRAN 77 ROUTINE)
C
C     XDCODE DECODES A 20A4 ARRAY IN RECORD INTO A 80A1 ARRAY IN ICHAR
C
C     XDCODE IS CALLED ONLY BY XRGDCF, XRGDTB, XRGSST, AND XRGSUB
C
      CHARACTER*80    TEMP
      CHARACTER*8     TEMP8
      COMMON /SYSTEM/ IBUF,    NOUT,  DM37(37),NBPW
      COMMON /XRGDXX/ SKIP1(3),ICOL,  SKIP2(8),RECORD(20),ICHAR(80),
     1                SKIP3(2),ICOUNT,SKIP4(2),NAME(2)
      DATA    IBLANK/ 4H      /
C
      WRITE (TEMP,10) RECORD
      READ  (TEMP,20) ICHAR
 10   FORMAT (20A4)
 20   FORMAT (80A1)
      RETURN
C
      ENTRY XECODE
C     ============
C
C     XECODE ENCODES A 8A1 BCD ARRAY IN ICHAR INTO A 2A4 BCD ARRAY
C     IN NAME
C     (THIS ENTRY REPLACES THE OLD MACHINE DEPENDENT ROUTINE OF THE
C     SAME NAME)
C
C     THE INCOMING WORD IN CDC MACHINE WOULD BE ZERO FILLED, SUCH AS
C     THE CARD TABLE AND THE MED TABLE IN XGPI RESTART PROCESSING.
C     MAKE SURE THAT THE INCOMING WORD FROM A 60- OR 64- BIT MACHINE
C     IS BLANK FILLED IF IT IS LESS THAN 8 BYTE LONG
C
C     XECODE IS CALL ONLY BY XRGDTB
C
      IF (NBPW.LT.60 .OR. ICOUNT.EQ.8) GO TO 25
      DO 22 K = ICOUNT,7
 22   ICHAR(ICOL+K) = IBLANK
 25   CALL NA12A8 (*50,ICHAR(ICOL),8,NAME,NOTUSE)
      IF (NBPW .NE. 60) RETURN
C
C     BLANK OUT 2ND WORD (CDC ONLY)
C
      WRITE (TEMP8,30) NAME(1)
      NAME(1) = IBLANK
      NAME(2) = IBLANK
      READ (TEMP8,40) NAME
 30   FORMAT (A8)
 40   FORMAT (2A4)
      RETURN
C
 50   WRITE  (NOUT,60)
 60   FORMAT ('0BAD DATA/XECODE')
      RETURN
      END

      SUBROUTINE MODA
C
C*****
C
C     DUMMY DECK FOR MODULE MODA   SEE USERS MANUAL SECTION 5.3
C                                  FOR MODULE PROPERTIES CHECK XMPLBD
C                                  OR USE DIAG 29
C
C*****
C
      INTEGER IPARM , PARM12 , PARM13
C     INTEGER OUTFIL(4)
C
      COMMON /BLANK/ PARM(5),IPARM(5),PARM11,PARM12,PARM13
C
C     DATA OUTFIL /201,202,203,204/
C
      RETURN
      END

      SUBROUTINE SETLVL (NEWNM,NUMB,OLDNMS,ITEST,IBIT)
C
C     CREATES A NEW SUBSTRUCTURE NEWNM WHERE
C     - NEWNM IS AN INDEPENDENT SUBSTRUCTURE IF NUMB = 0
C     - NEWNM IS REDUCED FROM THE FIRST SUBSTRUCTURE IN THE ARRAY OLDNMS
C     - NEWNM RESULTS FROM COMBINING THE FIRST I SUBSTRUCTURES IN THE
C       ARRAY OLDNMS IF NUMB = I
C
C     THE OUTPUT VARIABLE ITEST TAKES ON ONE OF THE FOLLOWING VALUES
C          4  IF ONE  OR MORE SUBSTRUCTURES IN OLDNMS DO NOT EXIST
C          7  IF NEWNM ALREADY EXISTS
C          8  IF ONE OF THE SUBSTRUCTURES IN OLDNMS HAS ALREADY
C             BEEN USED IN A REDUCTION OR COMBINATION
C          1  OTHERWISE
C
C     IF ITEST IS SET TO 4, NUMB WILL BE SET TO THE NUMBER OF
C     SUBSTRUCTURES IN OLDNMS THAT DO NOT EXIST AND THE FIRST NUMB NAMES
C     IN OLDNMS WILL BE SET TO THE NAMES OF THOSE SUBSTRUCTURES THAT DO
C     NOT EXIST.  BIT IBIT OF THE FIRST MDI WORD IS SET TO INDICATE THE
C     APPROPRIATE TYPE OF SUBSTRUCTURE. IF IBIT IS ZERO NO CHANGE IS
C     MADE TO THE MDI
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        LSHIFT,ANDF,ORF,COMPLF
      LOGICAL         DITUP,MDIUP
      DIMENSION       NEWNM(2),OLDNMS(14),IOLD(7),NMSBR(2)
      COMMON /ZZZZZZ/ BUF(1)
      COMMON /SOF   / DIT,DITPBN,DITLBN,DITSIZ,DITNSB,DITBL,
     1                IODUM(8),MDI,MDIPBN,MDILBN,MDIBL,
     2                NXTDUM(15),DITUP,MDIUP
      DATA    IEMPTY/ 4H    /, NMSBR / 4HSETL,4HVL  /
      DATA    LL,CS , HL    /  2,2,2 /
      DATA    IB    / 1     /
C
      CALL CHKOPN (NMSBR(1))
      ITEST = 1
      CALL FDSUB (NEWNM(1),I)
      IF (I  .NE.  -1) GO TO 500
      IF (NUMB .EQ. 0) GO TO 20
C
C     MAKE SURE THAT ALL THE SUBSTRUCTURES IN OLDNMS DO EXIST.
C
      ICOUNT = 0
      DO 10 I = 1,NUMB
      K = 2*(I-1) + 1
      CALL FDSUB (OLDNMS(K),IOLD(I))
      IF (IOLD(I) .GT. 0) GO TO 10
      ICOUNT = ICOUNT + 1
      KK = 2*(ICOUNT-1) + 1
      OLDNMS(KK  ) = OLDNMS(K  )
      OLDNMS(KK+1) = OLDNMS(K+1)
   10 CONTINUE
      IF (ICOUNT .EQ. 0) GO TO 20
      NUMB = ICOUNT
      GO TO 510
   20 CALL CRSUB (NEWNM(1),INEW)
      IF (NUMB .EQ. 0) RETURN
C
C     NEWNM IS NOT A BASIC SUBSTRUCTURE (LEVEL 0).
C     UPDATE NEWNM S DIRECTORY IN THE MDI.
C
      CALL FMDI (INEW,IMDI)
      LLMASK = COMPLF(LSHIFT(1023,20))
      BUF(IMDI+LL) = ORF(ANDF(BUF(IMDI+LL),LLMASK),LSHIFT(IOLD(1),20))
      IF (IBIT .NE. 0) BUF(IMDI+IB) = ORF(BUF(IMDI+IB),LSHIFT(1,IBIT))
      MDIUP = .TRUE.
C
C     UPDATE IN THE MDI THE DIRECTORIES OF THE SUBSTRUCTURES IN OLDNMS.
C
      IF (NUMB .GT. 7) NUMB = 7
      MASKCS = COMPLF(LSHIFT(1023,10))
      DO 50 I = 1,NUMB
      CALL FMDI (IOLD(I),IMDI)
      IF (ANDF(BUF(IMDI+HL),1023) .EQ. 0) GO TO 40
      ICOUNT = I
      GO TO 520
   40 BUF(IMDI+HL) = ORF(BUF(IMDI+HL),INEW)
      MDIUP = .TRUE.
      IF (NUMB .EQ. 1) RETURN
      IF (I .EQ. NUMB) GO TO 130
      BUF(IMDI+CS) = ORF(ANDF(BUF(IMDI+CS),MASKCS),LSHIFT(IOLD(I+1),10))
   50 CONTINUE
  130 BUF(IMDI+CS) = ORF(ANDF(BUF(IMDI+CS),MASKCS),LSHIFT(IOLD(1),10))
      RETURN
C
C     NEWNM ALREADY EXISTS.
C
  500 ITEST = 7
      RETURN
C
C     ONE OR MORE OF THE SUBSTRUCTURES IN OLDNMS DO NOT EXIST.
C
  510 ITEST = 4
      RETURN
C
C     ONE OF THE SUBSTRUCTURES IN OLDNMS HAS ALREADY BEEN USED IN A
C     REDUCTION OR COMBINATION.  REMOVE ALL CHANGES THAT HAVE BEEN MADE.
C
  520 ITEST = 8
      CALL FDIT (INEW,IDIT)
      BUF(IDIT  ) = IEMPTY
      BUF(IDIT+1) = IEMPTY
      DITUP = .TRUE.
      IF (2*INEW .NE. DITSIZ) GO TO 525
      DITSIZ = DITSIZ - 2
  525 DITNSB = DITNSB - 1
      CALL FMDI (INEW,IMDI)
      BUF(IMDI+LL) = ANDF(BUF(IMDI+LL),LLMASK)
      MDIUP  = .TRUE.
      ICOUNT = ICOUNT - 1
      IF (ICOUNT .LT. 1) RETURN
      DO 530 I = 1,ICOUNT
      CALL FMDI (IOLD(I),IMDI)
      BUF(IMDI+HL) = ANDF(BUF(IMDI+HL),COMPLF(1023))
      BUF(IMDI+CS) = ANDF(BUF(IMDI+CS),MASKCS)
      MDIUP = .TRUE.
  530 CONTINUE
      RETURN
      END

      SUBROUTINE IFP3B
C
C        CARDS           TYPE         REC.ID-BIT  CARDS-FILE, CARDS-FILE
C    === =======         ===========  ==========  ==========  ==========
C     1  AXIC     -----  AX.SY.SHELL     515- 5
C     2  CCONEAX  -----  AX.SY.SHELL    8515-85  CCONE-GEOM2,
C     3  FORCEAX  -----  AX.SY.SHELL    2115-21  FORCE-GEOM3,
C     4  FORCE    -----  STANDARD       4201-42  FORCE-GEOM3,
C     5  GRAV     -----  STANDARD       4401-44   GRAV-GEOM3,
C     6  LOAD     -----  STANDARD       4551-61   LOAD-GEOM3,
C     7  MOMAX    -----  AX.SY.SHELL    3815-38  MOMNT-GEOM3,
C     8  MOMENT   -----  STANDARD       4801-48  MOMNT-GEOM3,
C     9  MPCADD   -----  STANDARD       4891-60 MPCADD-GEOM4,
C    10  MPCAX    -----  AX.SY.SHELL    4015-40    MPC-GEOM4,
C    11  OMITAX   -----  AX.SY.SHELL    4315-43   OMIT-GEOM4,
C    12  POINTAX  -----  AX.SY.SHELL    4915-49    MPC-GEOM4, GRID-GEOM1
C    13  PRESAX   -----  AX.SY.SHELL    5215-52  PLOAD-GEOM3,
C    13+ RFORCE   -----  STANDARD       5509-55 RFORCE-GEOM3,
C    14  RINGAX   -----  AX.SY.SHELL    5615-56    SPC-GEOM4, GRID-GEOM1
C    15  SECTAX   -----  AX.SY.SHELL    6315-63    MPC-GEOM4, GRID-GEOM1
C    16  SEQGP    -----  STANDARD       5301-53  SEQGP-GEOM1,
C    17  SPCADD   -----  STANDARD       5491-59 SPCADD-GEOM4,
C    18  SPCAX    -----  AX.SY.SHELL    6215-62    SPC-GEOM4,
C    19  SUPAX    -----  AX.SY.SHELL    6415-64 SUPORT-GEOM4,
C    20  TEMPAX   -----  AX.SY.SHELL    6815-68   TEMP-GEOM3,
C    21  TEMPD    -----  STANDARD       5641-65  TEMPD-GEOM3,
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        LSHIFT    ,ANDF      ,ORF
      LOGICAL         NOGO      ,RECOFF    ,IFPDCO
      REAL            NPHI      ,NPHI1     ,NISQ      ,NI        ,
     1                RADDEG    ,RZ        ,T1        ,T2        ,
     2                T3        ,COEF      ,A1        ,A2        ,
     3                A3        ,A4        ,ANGLE     ,GC        ,
     4                SUM       ,CONSTS
      DIMENSION       GEOM(4)   ,Z(13)
      DIMENSION       ISYSTM(175)
      CHARACTER       UFM*23    ,UWM*25    ,UIM*29    ,SFM*25
      COMMON /XMSSG / UFM       ,UWM       ,UIM       ,SFM
      COMMON /BLANK / BOTTOM
      COMMON /SYSTEM/ IBUFSZ    ,NOUT      ,NOFLAG    ,DUMDUM(8) ,
     1                NLINES    ,DDD(14)   ,MN        ,DUM50(50) ,
     2                IPIEZ
      COMMON /MACHIN/ MACH      ,IHALF
      COMMON /TWO   / TWO(32)
      COMMON /CONDAS/ CONSTS(5)
      COMMON /IFP3LV/            RECID(3)  ,RECID1(3) ,RECIDX(3) ,
     1                IEND      ,REC(3)    ,REC1(3)   ,TRAIL(7)  ,
     2                IT        ,AXTRL(7)  ,OPENFL(6) ,N         ,
     3                A1        ,CSID      ,NI        ,NISQ      ,
     4                A2        ,IBUFF1    ,IBUFF2    ,IBUFF3    ,
     5                A3        ,BUFF      ,NOGO      ,OP        ,
     6                A4        ,IHEADR    ,IBITR     ,IFILE     ,
     7                NOREG     ,LAST      ,IERRTN    ,ICONT     ,
     8                NOAXIC    ,RINGID    ,OUTBUF    ,VEOR      ,
     9                ISTART    ,IRETRN    ,FLAG      ,IAMT      ,
     T                SUM       ,IBIT      ,SETID     ,SORC      ,
     1                IBEGIN    ,MPCON     ,NWORDS    ,NNN       ,
     2                ANGLE     ,K3OR6     ,NPHI1     ,ZPT       ,
     3                NMOVE     ,CSSET     ,NOPONT    ,NON       ,
     4                IPHI      ,RECOFF    ,NPHI      ,N3OR5     ,
     5                ION       ,NPLUS1    ,NOSECT    ,COEF      ,
     6                IPT       ,COMPON    ,ICORE     ,ISCRAT    ,
     7                ICORE1    ,NCARDS    ,I1        ,IAT       ,
     8                I2        ,T1        ,T2        ,NFILE     ,
     9                NADD      ,NCARD
      COMMON /IFP3CM/ FILE(6)   ,INAME(12) ,CDTYPE(50),AXIC1(3)  ,
     1                CCONEX(3) ,FORCEX(3) ,FORCE(3)  ,GRAV(3)   ,
     2                LOAD(3)   ,MOMAX(3)  ,MOMENT(3) ,MPCADD(3) ,
     3                MPCAX(3)  ,OMITAX(3) ,POINTX(3) ,PRESAX(3) ,
     4                RINGAX(3) ,SECTAX(3) ,SEQGP(3)  ,SPCAX(3)  ,
     5                SUPAX(3)  ,TEMPAX(3) ,TEMPD(3)  ,PLOAD(3)  ,
     6                MPC(3)    ,SPC(3)    ,GRID(3)   ,SUPORT(3) ,
     7                NEG111(3) ,T65535(3) ,TEMP(3)   ,OMIT(3)   ,
     8                SPCADD(3) ,ONE       ,ZERO      ,IHEADB(96),
     9                CTRIAA(3) ,CTRAPA(3) ,ICONSO
      COMMON /OUTPUT/ DUMMY(96) ,IHEAD(96)
      COMMON /IFPDTA/ DUM(521)  ,GC(7)     ,LL(6)
      COMMON /ZZZZZZ/ RZ(1)
      EQUIVALENCE     (CONSTS(4),RADDEG )  , (Z(1)    ,RZ(1)  )  ,
     1                (GEOM(1)  ,FILE(1))  , (SCRTCH  ,FILE(5))  ,
     2                (AXIC     ,FILE(6))                        ,
     3                (NOEOR    ,INPRWD    ,  ZERO            )  ,
     4                (EOR      ,CLORWD    ,  OUTRWD  ,ONE    )
      EQUIVALENCE     (IBUFSZ   ,ISYSTM(1))
      DATA    IFIST / 4HFIST/   ,I3,I4,I5  /  3,4,5   /
C
C
C     GEOM4 PROCESSING
C     ================
C
C     OPEN GEOM4
C
      IFILE= GEOM(4)
      I    = 4
      OP   = OUTRWD
      BUFF = IBUFF2
      ASSIGN 20 TO IRETRN
      GO TO 1340
C
C     SPCADD OR MPCADD CARDS
C     ======================
C
   20 ASSIGN 30 TO ICONT
      REC(1)  = MPCADD(1)
      REC(2)  = MPCADD(2)
      REC(3)  = MPCADD(3)
      REC1(1) = MPCAX(1)
      REC1(2) = MPCAX(2)
      REC1(3) = MPCAX(3)
   21 ASSIGN 28 TO IHEADR
      GO TO 1470
C
C     MANDATORY SPCADD AND MPCADD CARDS.
C
   28 Z( 1) = 100000101
      Z( 2) = 101
      Z( 3) = -1
      Z( 4) = 200000102
      Z( 5) = 102
      Z( 6) = -1
      Z( 7) = 100000000
      Z( 8) = 101
      Z( 9) = -1
      Z(10) = 200000000
      Z(11) = 102
      Z(12) = -1
      IF (NOGO) GO TO 22
      CALL WRITE (GEOM(4),Z(1),12,NOEOR)
   22 CALL LOCATE (*23,Z(IBUFF1),REC(1),FLAG)
C
C     READ AN OPEN ENDED SPCADD OR MPCADD CARD INTO CORE.
C
      I = 1
   27 CALL READ (*1540,*23,AXIC,Z(I),1,NOEOR,IAMT)
      IF (Z(I)) 25,24,24
   24 I = I + 1
      IF ((I+1) .GT. ICORE) GO TO 1580
      GO TO 27
C
C     COMPLETE CARD IS AT HAND
C
   25 Z(I) = 101
      I    = I + 1
      Z(I) = -1
      Z(1) = Z(1) + 100000000
      IF (NOGO) GO TO ICONT, (30,610)
   26 CALL WRITE (GEOM(4),Z(1),I,NOEOR)
      IF (Z(I-1) .EQ. 102) GO TO 23
      Z(I-1) = 102
      Z(1  ) = Z(1) + 100000000
      GO TO 26
C
C     ALL SPCADD OR MPCADD CARDS COMPLETE.
C     NOW CREATE SPCADD OR MPCADD FROM SPCAX OR MPCAX
C     CARDS RESPECTIVELY.
C
   23 IREC   = REC(1)
      REC(1) = REC1(1)
      REC(2) = REC1(2)
      REC(3) = REC1(3)
      CALL LOCATE (*35,Z(IBUFF1),REC(1),FLAG)
C
C     OK SPCAX OR MPCAX RECORD EXISTS.
C
      ILAST = -1
   38 Z(4)  = -1
      CALL READ (*1540,*35,AXIC,Z(2),1,NOEOR,IAMT)
C
C     MPCAX CARDS ARE OPEN ENDED
C     SPCAX CARDS ARE 5 WORDS LONG.
C
      IF (Z(2) .EQ. ILAST) GO TO 47
      ILAST = Z(2)
C
C     CREATE TWO SPCADD OR MPCADD CARDS.
C
      Z(3) = 101
      Z(1) = Z(2) + 100000000
      IF (NOGO) GO TO ICONT, (30,610)
   33 CALL WRITE (GEOM(4),Z(1),4,NOEOR)
      IF (Z(3) .EQ. 102) GO TO 47
      Z(3) = 102
      Z(1) = Z(1) + 100000000
      GO TO 33
C
C     READ UP TO NEXT CARD
C
   47 CALL READ (*1540,*35,AXIC,Z(1),4,NOEOR,IAMT)
      IF (REC(1).EQ.SPCAX(1) .OR. Z(1).EQ.(-1)) GO TO 38
      GO TO 47
C
C     ALL CARDS COMPLETE.
C     WRITE EOR AND PUT BITS IN TRAILER.
C
   35 IAMT = 0
      ASSIGN 37 TO IRETRN
      IF (IREC .EQ. SPCADD(1)) GO TO 39
      REC(1) = MPCADD(1)
      REC(2) = MPCADD(2)
      REC(3) = MPCADD(3)
      GO TO 1300
   39 REC(1) = SPCADD(1)
      REC(2) = SPCADD(2)
      REC(3) = SPCADD(3)
      GO TO 1300
   37 GO TO ICONT, (30,610)
C
C     MPCAX CARD
C     ==========
C
   30 MPCON  = 0
      REC(1) = MPC(1)
      REC(2) = MPC(2)
      REC(3) = MPC(3)
      RECOFF = .FALSE.
      LAST   = -1
      NCARD  = 10
      NWORDS = 0
      CALL LOCATE (*130,Z(IBUFF1),MPCAX(1),FLAG)
C
C     WRITE RECORD HEADER
C
      RECOFF = .TRUE.
      ASSIGN 40 TO IHEADR
      GO TO 1470
C
   40 MPCON = 1
      LAST  = 0
C
C     READ SET ID
C
   50 CALL READ (*1540,*120,AXIC,SETID,1,NOEOR,IAMT)
      IF (SETID .GT. 100) GO TO 130
      NWORDS = NWORDS + 1
      IF (NOGO) GO TO 60
      CALL WRITE (GEOM(4),SETID,1,NOEOR)
C
C     READ 4-WORDS SETS UNTIL -1,-1,-1,-1 ENCOUNTERED...
C
   60 CALL READ (*1540,*100,AXIC,Z(1),4,NOEOR,IAMT)
      NWORDS = NWORDS + 4
      IF (Z(4) .EQ. -1) GO TO 90
C
C     CHECK HARMONIC NUMBER
C
      NNN = Z(2)
      ASSIGN 70 TO IERRTN
      GO TO 1420
C
C     CHECK RING ID
C
   70 NNN = Z(1)
      ASSIGN 80 TO IERRTN
      GO TO 1440
C
   80 Z(2) = Z(1) + (Z(2)+1)*1000000
      IF (NOGO) GO TO 60
      CALL WRITE (GEOM(4),Z(2),3,NOEOR)
      GO TO 60
C
C     END OF EQUATION
C
   90 IF (NOGO) GO TO 50
      CALL WRITE (GEOM(4),NEG111(1),3,NOEOR)
      GO TO 50
  100 CALL PAGE2 (3)
      IMSG = 1063
      WRITE  (NOUT,105) SFM,IMSG
  105 FORMAT (A25,I5)
      WRITE  (NOUT,110) SFM,IMSG
  110 FORMAT (5X,50HEOR ON AXIC FILE WHILE READING MPCAX CARD RECORDS.)
      NOGO = .TRUE.
      GO TO 1530
  120 LAST = 1
C
C     FIRST NWORDS HAVE BEEN PROCESSED OF MPCAX CARDS UNLESS
C     LAST = 1, IN WHICH CASE ALL MPCAX CARDS ARE COMPLETE.
C     GO NOW TO THE S-SET MPC CARD-GENERATION FOR POINTAX CARDS
C     IF LAST = -1, THERE ARE NO MPCAX CARDS.
C
C
C     S-SET MPC-S FROM POINTAX CARDS
C     ==============================
C
  130 REC(1) = POINTX(1)
      REC(2) = POINTX(2)
      REC(3) = POINTX(3)
      NCARD  = 12
      N3OR5  = 3
      K3OR6  = 6
      SORC   = 101
      ASSIGN 380 TO ICONT
C     TURN NOPONT OR NOSECT ON IF POINTAX OR SECTAX CARDS EXIST RESPECT.
C
      IBIT = POINTX(2)
      ASSIGN 140 TO IBITR
      GO TO 1460
  140 NOPONT = NON
      IBIT = SECTAX(2)
      ASSIGN 150 TO IBITR
      GO TO 1460
  150 NOSECT = NON
C
      IF (NOPONT) 160,370,160
C
  160 CALL LOCATE (*370,Z(IBUFF1),REC(1),FLAG)
      MPCON = 1
      IF (RECOFF) GO TO 170
C
C     WRITE RECORD HEADER
C
      RECOFF = .TRUE.
      REC(1) = MPC(1)
      REC(2) = MPC(2)
      REC(3) = MPC(3)
      ASSIGN 170 TO IHEADR
      GO TO 1470
C
  170 CALL READ (*1540,*370,AXIC,Z(1),N3OR5,NOEOR,IAMT)
C
C     CHECK RING ID FOR S-SET PASS ONLY FOR POINTAX AND SECTAX CARDS.
C     NO CHECK WILL BE MADE IN THE GRID CARD GENERATION AREA.
C
C     IF (SORC .EQ. 102) GO TO 785
      NNN = Z(2)
      ASSIGN 180 TO IERRTN
      GO TO 1440
C
  180 IAT = N3OR5 + 1
      DO 360 I = 1,K3OR6
      Z(IAT) = SORC
      Z(IAT+1) = Z(1)
      Z(IAT+2) = I
      RZ(IAT+3)= -1.0
      IF (NOGO) GO TO 190
      CALL WRITE (GEOM(4),Z(IAT),4,NOEOR)
  190 DO 350 J = 1,NPLUS1
C
C     COMPUTE COEFFICIENT.
C
      NI = J - 1
      IF (N3OR5 .EQ. 5) GO TO 240
C
C     POINTAX CARD COEFFICIENTS
C
      T1 = NI*RZ(I3)*RADDEG
      IF (ANDF(I,1)) 210,210,200
C
C     ODD I
C
  200 IF (SORC - 101) 220,220,230
C
C     EVEN I
C
  210 IF (SORC - 101) 230,230,220
C
  220 COEF = SIN(T1)
      GO TO 340
C
  230 COEF = COS(T1)
      IF (SORC .EQ. 101) COEF = -COEF
      IF (NI.EQ.0.0 .AND. SORC.EQ.101) COEF = 1.0
      GO TO 340
C
C     SECTAX CARD COEFFICIENTS
C
  240 T1 = NI*RZ(I4)*RADDEG
      T2 = NI*RZ(I5)*RADDEG
      IF (I .GE.  4) GO TO 245
      IF (ANDF(I,1)) 250,250,280
  245 IF (ANDF(I,1)) 280,280,250
C
C     EVEN I
C
  250 IF (SORC .EQ. 101) GO TO 290
  260 IF (NI) 270,320,270
  270 T3 = T2
      T2 = COS(T1)
      T1 = COS(T3)
      GO TO 310
C
C     ODD I
C
  280 IF (SORC .EQ. 101) GO TO 260
  290 IF (NI) 300,330,300
  300 T1 = SIN(T1)
      T2 = SIN(T2)
  310 COEF = RZ(I3)*(T2-T1)/NI
      IF (SORC.EQ.101 .AND. (I.EQ.2 .OR. I.EQ.5)) COEF = -COEF
      GO TO 340
  320 COEF = 0.0
      GO TO 340
  330 COEF = RZ(I3)*(RZ(I5)-RZ(I4))*RADDEG
C
  340 Z(IAT  ) = Z(2) + J*1000000
      Z(IAT+1) = I
      RZ(IAT+2)= COEF
      IF (NOGO) GO TO 350
      CALL WRITE (GEOM(4),Z(IAT),3,NOEOR)
  350 CONTINUE
      IF (NOGO) GO TO 360
      CALL WRITE (GEOM(4),NEG111(1),3,NOEOR)
  360 CONTINUE
      GO TO 170
C
  370 GO TO ICONT, (380,390,400,410)
C
C     S-SET MPC-S FROM SECTAX CARDS
C     =============================
C
C     DO SECTAX CARDS FOR S-SET.
C
  380 REC(1) = SECTAX(1)
      REC(2) = SECTAX(2)
      REC(3) = SECTAX(3)
      N3OR5  = 5
      K3OR6  = 6
      SORC   = 101
      NCARD  = 15
      ASSIGN 390 TO ICONT
      IF (NOSECT) 160,390,160
C
C     C-SET MPC-S FROM POINTAX CARDS
C     ==============================
C
C
  390 REC(1) = POINTX(1)
      REC(2) = POINTX(2)
      REC(3) = POINTX(3)
      N3OR5  = 3
      K3OR6  = 6
      SORC   = 102
      ASSIGN 400 TO ICONT
      IF (NOPONT) 160,400,160
C
C     C-SET MPC-S FROM SECTAX CARDS
C     =============================
C
  400 REC(1) = SECTAX(1)
      REC(2) = SECTAX(2)
      REC(3) = SECTAX(3)
      N3OR5  = 5
      K3OR6  = 6
      SORC   = 102
      ASSIGN 410 TO ICONT
      IF (NOSECT) 160,410,160
C
C     BALANCE OF MPCAX CARDS
C
  410 IF (LAST) 510,420,510
  420 CALL LOCATE (*510,Z(IBUFF1),MPCAX(1),FLAG)
      NCARD = 10
      IF (NWORDS .EQ. 0) GO TO 440
      DO 430 I = 1,NWORDS
      CALL READ (*1540,*470,AXIC,Z(1),1,NOEOR,IAMT)
  430 CONTINUE
C
C     NOW POSITIONED AT POINT LEFT OFF AT ABOVE.
C
  440 CALL READ (*1540,*510,AXIC,SETID,1,NOEOR,IAMT)
      IF (SETID .LT. 101) GO TO 470
      IF (SETID .GT. 102) GO TO 448
      NOGO = .TRUE.
      CALL PAGE2(3)
      IMSG = 366
      WRITE  (NOUT,445) UFM,IMSG
  445 FORMAT (A23,I5)
      WRITE  (NOUT,442)
  442 FORMAT (5X,'SPCAX OR MPCAX CARD HAS A SETID = 101 OR 102.  101 ',
     1      'AND 102 ARE SYSTEM ID-S RESERVED FOR SINE AND COSINE SETS')
  448 IF (NOGO) GO TO 450
      CALL WRITE (GEOM(4),SETID,1,NOEOR)
  450 CALL READ (*1540,*100,AXIC,Z(1),4,NOEOR,IAMT)
      IF (Z(4) .EQ. (-1)) GO TO 500
C
C     CHECK HARMONIC NUMBER
C
      NNN = Z(2)
      ASSIGN 460 TO IERRTN
      GO TO 1420
C
C     CHECK RING ID
C
  460 NNN = Z(1)
      ASSIGN 490 TO IERRTN
      GO TO 1440
  470 CALL PAGE2 (3)
      IMSG = 1063
      WRITE  (NOUT,105) SFM,IMSG
      WRITE  (NOUT,480) CDTYPE(19),CDTYPE(20)
  480 FORMAT (5X,'EOR ON AXIC FILE WHILE READING ',2A4,'CARD RECORDS.')
      NOGO = .TRUE.
      GO TO 1530
C
  490 Z(2) = Z(1) + (Z(2)+1)*1000000
      IF (NOGO) GO TO 450
      CALL WRITE (GEOM(4),Z(2),3,NOEOR)
      GO TO 450
C
C     END OF EQUATION
C
  500 IF (NOGO) GO TO 440
      CALL WRITE (GEOM(4),NEG111(1),3,NOEOR)
      GO TO 440
C
C     AT 713(?) WRITE EOR AND PUT BITS IN TRAILER.
C
  510 IF (MPCON) 520,530,520
  520 IAMT   = 0
      REC(1) = MPC(1)
      REC(2) = MPC(2)
      REC(3) = MPC(3)
      ASSIGN 530 TO IRETRN
      GO TO 1300
C
C     OMITAX CARDS
C
  530 REC(1) = OMITAX(1)
      REC(2) = OMITAX(2)
      REC(3) = OMITAX(3)
      NCARD  = 11
      REC1(1)= OMIT(1)
      REC1(2)= OMIT(2)
      REC1(3)= OMIT(3)
      ASSIGN 600 TO ICONT
  540 CALL LOCATE (*590,Z(IBUFF1),REC(1),FLAG)
      IF (NOGO) GO TO 550
      CALL WRITE (GEOM(4),REC1(1),3,NOEOR)
  550 CALL READ (*1540,*580,AXIC,Z(1),3,NOEOR,IAMT)
C
C     CHECK HARMONIC NUMBER
C
      NNN = Z(2)
      ASSIGN 560 TO IERRTN
      GO TO 1420
C
C     CHECK RING ID
C
  560 NNN = Z(1)
      ASSIGN 570 TO IERRTN
      GO TO 1440
C
  570 Z(2) = Z(1) + (Z(2)+1)*1000000
      IF (IFPDCO(Z(3))) GO TO 571
      DO 572 L2 = 1,6
      IF (LL(L2) .EQ. 0) GO TO 572
      Z(3) = LL(L2)
      IF (NOGO) GO TO 550
      CALL WRITE (GEOM(4),Z(2),2,NOEOR)
  572 CONTINUE
      GO TO 550
  571 NOGO = .TRUE.
      CALL PAGE2 (3)
      IMSG = 367
      WRITE  (NOUT,445) UFM,IMSG
      WRITE  (NOUT,573) Z(3),CDTYPE(2*NCARD-1),CDTYPE(2*NCARD)
  573 FORMAT (5X,'COMPONENT SPECIFICATION',I8,4H ON ,2A4,
     1       ' CARD IS INCORRECT')
      GO TO 550
C
C     WRITE EOR AND PUT BITS IN TRAILER
C
  580 IAMT   = 0
      REC(1) = REC1(1)
      REC(2) = REC1(2)
      REC(3) = REC1(3)
      ASSIGN 590 TO IRETRN
      GO TO 1300
  590 GO TO ICONT, (600,870)
C
C     SPCADD CARD
C     ===========
C
  600 REC(1)  = SPCADD(1)
      REC(2)  = SPCADD(2)
      REC(3)  = SPCADD(3)
      REC1(1) = SPCAX(1)
      REC1(2) = SPCAX(2)
      REC1(3) = SPCAX(3)
      ASSIGN 610 TO ICONT
      GO TO 21
C
C     SPCAX CARD
C     ==========
C
  610 REC(1) = SPC(1)
      REC(2) = SPC(2)
      REC(3) = SPC(3)
C
C     RECORD HEADER FOR SPC-S
C
      ASSIGN 620 TO IHEADR
      GO TO 1470
C
  620 LAST  = -1
      NCARD = 18
      CALL LOCATE (*670,Z(IBUFF1),SPCAX(1),FLAG)
      LAST   = 0
      NWORDS = 0
  630 CALL READ (*1540,*660,AXIC,Z(1),5,NOEOR,IAMT)
      IF (Z(1) .GT. 100) GO TO 670
      NWORDS = NWORDS + 5
C
C     ALTER CARD JUST READ AND OUTPUT
C
C     CHECK HARMONIC NUMBER
C
      NNN = Z(3)
      ASSIGN 640 TO IERRTN
      GO TO 1420
C
C     CHECK RING ID
C
  640 NNN = Z(2)
      ASSIGN 650 TO IERRTN
      GO TO 1440
C
  650 Z(2) = Z(2) + (Z(3)+1)*1000000
      Z(3) = Z(4)
      Z(4) = Z(5)
      IF (NOGO) GO TO 630
C
      CALL WRITE (GEOM(4),Z(1),4,NOEOR)
      GO TO 630
  660 LAST = 1
C
C     FIRST NWORDS HAVE BEEN PROCESSED OF SPCAX CARDS
C     UNLESS LAST = 1, IN WHICH CASE ALL SPCAX CARDS ARE COMPLETE.
C     IF LAST = -1, THERE ARE NO SPCAX CARDS
C
C     S-SET AND C-SET SPC-S FROM RINGAX CARDS
C     =======================================
C
  670 SORC   = 101
      NCARD  = 14
      COMPON = 135
      IF (ICONSO .EQ. 1) COMPON = 13
      ASSIGN 750 TO ICONT
  680 CALL LOCATE (*760,Z(IBUFF1),RINGAX(1),FLAG)
  690 CALL READ (*1540,*740,AXIC,Z(1),4,NOEOR,IAMT)
C
       IF (SORC .EQ. 102) GO TO 730
C
C     GIVE RING CARD A CHECK FOR MINIMUM DATA.
C
C     CHECK RING ID
C
      NNN = Z(1)
      ASSIGN 700 TO IERRTN
      GO TO 1440
C
C     CHECK FOR NON-ZERO RADIUS
C
  700 IF (RZ(I3-1)) 730,710,730
  710 CALL PAGE2 (3)
      IMSG = 368
      WRITE  (NOUT,445) UFM,IMSG
      WRITE  (NOUT,720) Z(1)
  720 FORMAT (5X,'RINGAX CARD WITH RING ID =',I10,' HAS A ZERO RADIUS',
     1       ' SPECIFIED.')
      NOGO = .TRUE.
  730 Z(4) = 0
      Z(3) = COMPON
      Z(2) = Z(1) + 1000000
      Z(1) = SORC
      IF (NOGO) GO TO 690
      CALL WRITE (GEOM(4),Z(1),4,NOEOR)
      GO TO 690
C
  740 GO TO ICONT, (750,770)
  750 SORC   = 102
      COMPON = 246
      IF (ICONSO .EQ. 1) COMPON = 2
C
C     KEEP DOF 4 FOR PIEZOELECTRIC PROBLEM
C
      IF (IPIEZ .EQ. 1) COMPON = 26
      ASSIGN 770 TO ICONT
      GO TO 680
C
C     MISSING REQUIRED CARD
C
  760 ASSIGN 770 TO IERRTN
      GO TO 1510
C
C     BALANCE OF SPCAX CARDS
C
  770 IF (LAST) 830,780,830
  780 CALL LOCATE (*830,Z(IBUFF1),SPCAX(1),FLAG)
      NCARD = 18
      IF (NWORDS .EQ. 0) GO TO 800
      DO 790 I = 1,NWORDS,5
      CALL READ (*1540,*840,AXIC,Z(1),5,NOEOR,IAMT)
  790 CONTINUE
C
C     NOW POSITIONED AT POINT LEFT OFF AT ABOVE...
C
  800 CALL READ (*1540,*830,AXIC,Z(1),5,NOEOR,IAMT)
      IF (Z(1) .LT. 101) GO TO 840
      IF (Z(1) .GT. 102) GO TO 808
      NOGO = .TRUE.
      CALL PAGE2 (3)
      IMSG = 366
      WRITE (NOUT,445) UFM,IMSG
      WRITE (NOUT,442)
C
C     CHECK HARMONIC NUMBER
C
  808 NNN = Z(3)
      ASSIGN 810 TO IERRTN
      GO TO 1420
C
C     RING ID CHECK
C
  810 NNN = Z(2)
      ASSIGN 820 TO IERRTN
      GO TO 1440
C
  820 Z(2) = Z(2) + (Z(3)+1)*1000000
      Z(3) = Z(4)
      Z(4) = Z(5)
      IF (NOGO) GO TO 800
      CALL WRITE (GEOM(4),Z(1),4,NOEOR)
      GO TO 800
C
C     WRITE EOR AND PUT BITS IN THE TRAILER
C
  830 IAMT = 0
      ASSIGN 860 TO IRETRN
      GO TO 1300
  840 CALL PAGE2 (3)
      IMSG = 1063
      WRITE (NOUT,105) SFM,IMSG
      WRITE (NOUT,480) CDTYPE(35),CDTYPE(36)
      NOGO = .TRUE.
      GO TO 1530
C
C     SUPAX CARDS
C     ===========
C
  860 REC(1)  = SUPAX(1)
      REC(2)  = SUPAX(2)
      REC(3)  = SUPAX(3)
      NCARD   = 19
      REC1(1) = SUPORT(1)
      REC1(2) = SUPORT(2)
      REC1(3) = SUPORT(3)
      ASSIGN 870 TO ICONT
      GO TO 540
C
C     CLOSE GEOM4
C
  870 I = 4
      ASSIGN 880 TO IRETRN
      GO TO 1380
C
C
C     GEOM1 PROCESSING
C     ================
C
C     OPEN GEOM1
C
  880 IFILE = GEOM(1)
      I    = 1
      OP   = OUTRWD
      BUFF = IBUFF2
      ASSIGN 890 TO IRETRN
      GO TO 1340
C
C     GRID CARDS FROM POINTAX AND SECTAX CARDS
C
C     NOPONT = 0 OR 1, DEPENDING ON THE PRESSENCE OF POINTAX CARDS
C     NOSECT = 0 OR 1, DEPENDING ON THE PRESSENCE OF SECTAX  CARDS
C
C     RECORD HEADER FOR GRID CARDS
C
  890 REC(1) = GRID(1)
      REC(2) = GRID(2)
      REC(3) = GRID(3)
      ASSIGN 900 TO IHEADR
      GO TO 1470
C
  900 IF (NOSECT) 920,910,920
  910 IF (NOPONT) 980,1110,980
  920 IF (NOPONT) 930,940,930
C
C     LOCATE SECTAX CARDS, READ SECTAX, CONVERT TO GRID, PUT ON NFILE
C
  930 NFILE = SCRTCH
C
C     OPEN SCRTCH FILE
C
      I   = 5
      OP  = OUTRWD
      BUFF= IBUFF3
      ASSIGN 950 TO IRETRN
      GO TO 1340
C
  940 NFILE = GEOM(1)
C
  950 ICARD = 15
      CALL LOCATE (*1090,Z(IBUFF1),SECTAX(1),FLAG)
  960 CALL READ (*1540,*970,AXIC,Z(1),5,NOEOR,IAMT)
      Z(2) = 0
      Z(6) = CSID
      Z(7) = 0
      Z(8) = 0
      IF (NOGO) GO TO 960
      CALL WRITE (NFILE,Z(1),8,NOEOR)
      GO TO 960
  970 IF (NOPONT) 980,1110,980
  980 ICARD = 12
      CALL LOCATE (*1090,Z(IBUFF1),POINTX(1),FLAG)
C
C     READ POINT CARD CONVERT TO GRID CARD AND PUT OUT ON GEOM(1)
C     MERGING GRID CARDS FROM SCRTCH IF NOSECT IS NON-ZERO
C
      IF (NOSECT) 990,1000,990
  990 IF (NOGO  ) GO TO 1110
      CALL CLOSE (SCRTCH,CLORWD)
      CALL OPEN (*1570,SCRTCH,Z(IBUFF3),INPRWD)
      CALL READ (*1050,*1050,SCRTCH,Z(9),8,NOEOR,IAMT)
 1000 CALL READ (*1540,*1070,AXIC,Z(1),3,NOEOR,IAMT)
C
C     CONVERT POINTAX CARD
C
      Z(2)   = 0
      RZ(I4) = 0.0
      RZ(I5) = 0.0
      Z(6)   = CSID
      Z(7)   = 0
      Z(8)   = 0
      IF (NOSECT) 1010,1020,1010
 1010 IF (Z(1) .GE. Z(9)) GO TO 1030
 1020 ZPT = 1
      GO TO 1040
 1030 ZPT = 9
 1040 IF (NOGO) GO TO 1110
      CALL WRITE (GEOM(1),Z(ZPT),8,NOEOR)
      IF (ZPT .EQ. 1) GO TO 1000
      CALL READ (*1050,*1050,SCRTCH,Z(9),8,NOEOR,IAMT)
      IF (NOPONT) 1010,1040,1010
 1050 NOSECT = 0
C
C     CLOSE SCRTCH
C
      I = 5
      ASSIGN 1060 TO IRETRN
      GO TO 1380
 1060 IF (NOPONT) 1020,1110,1020
C
 1070 IF (NOSECT) 1080,1110,1080
 1080 ZPT = 9
      NOPONT = 0
      GO TO 1040
C
 1090 CALL PAGE2 (3)
      IMSG = 1064
      WRITE  (NOUT,105) SFM,IMSG
      WRITE  (NOUT,1100) CDTYPE(2*ICARD-1),CDTYPE(2*ICARD)
 1100 FORMAT (5X,2A4,' CARD COULD NOT BE LOCATED ON AXIC FILE AS ',
     1       'EXPECTED.')
      NOGO = .TRUE.
      GO TO 1110
C
C     GRID CARDS FROM RING CARDS
C
C     COPY RINGAX CARDS INTO CORE AND TO SCRTCH IF CORE IS EXCEEDED.
C
 1110 CALL LOCATE (*1240,Z(IBUFF1),RINGAX(1),FLAG)
      NWORDS = (ICORE/4)*4 - 12
      IBEGIN = 13
      ISCRAT = 0
      CALL READ (*1540,*1140,AXIC,Z(13),NWORDS,NOEOR,IAMT)
C
C     FALL HERE IMPLIES CORE IS FULL.. SPILL BALANCE TO SCRTCH FILE.
C
      ION    = 0
      ISCRAT = 0
      IF (NOGO) GO TO 1240
      CALL OPEN (*1570,SCRTCH,Z(IBUFF3),OUTRWD)
 1120 CALL READ (*1540,*1130,AXIC,Z(1),8,NOEOR,IAMT)
      ION = 1
      CALL WRITE (SCRTCH,Z(1),8,NOEOR)
      GO TO 1120
 1130  IF ((IAMT/4)*4 .NE. IAMT) GO TO 1230
      IF (ION.EQ.0 .AND. IAMT.EQ.0) GO TO 1160
      ISCRAT = 1
      IF (NOGO) GO TO 1240
      CALL WRITE (SCRTCH,Z(1),IAMT,EOR)
      CALL CLOSE (SCRTCH,CLORWD)
      GO TO 1160
C
 1140 IF ((IAMT/4)*4 .NE. IAMT) GO TO 1230
      NWORDS = IAMT
C
C     NWORDS-WORDS ARE IN CORE AND IF ISCRAT = 1 THERE IS
C     A RECORD OF RINGAX CARDS ON SCRTCH FILE ALSO
C
C     NOW MAKE N+1 PASSES THROUGH THE RING CARDS
C
 1160 IF (ISCRAT) 1170,1180,1170
 1170 IF (NOGO  ) GO TO 1240
      CALL OPEN (*1570,SCRTCH,Z(IBUFF3),INPRWD)
 1180 Z(2) = 0
      Z(5) = 0
      Z(6) = CSID
      Z(8) = 0
      NCARDS = NWORDS/4
C
C     27TH WORD OF SYSTEM IS PACKED AND HOLDS NUMBER OF RINGS AND HARMS
C
      MN   = NPLUS1
      ISYSTM(161) = NCARDS
      NADD = 0
      DO 1220 I = 1,NPLUS1
      NADD = NADD + 1000000
      IPT  = IBEGIN - 4
C
C     PASS THROUGH THE INCORE CARDS
C
      DO 1190 J = 1,NCARDS
      IPT  = IPT + 4
      Z(1) = Z(IPT) + NADD
      Z(3) = Z(IPT+1)
      Z(4) = Z(IPT+2)
      Z(7) = Z(IPT+3)
      IF (NOGO) GO TO 1190
      CALL WRITE (GEOM(1),Z(1),8,NOEOR)
 1190 CONTINUE
C
C     PASS THROUGH SCRTCH CARDS IF ANY
C
      IF (NOGO  ) GO TO 1220
      IF (ISCRAT) 1200,1220,1200
 1200 CALL READ (*1540,*1210,SCRTCH,Z(9),4,NOEOR,IAMT)
      Z(1) = Z(9) + NADD
      Z(3) = Z(10)
      Z(4) = Z(11)
      Z(7) = Z(12)
      CALL WRITE (GEOM(1),Z(1),8,NOEOR)
      GO TO 1200
C
 1210 CALL REWIND (SCRTCH)
 1220 CONTINUE
C
C     PUT BITS IN TRAILER AND WRITE EOR FOR GRID CARDS
C
      IAMT   = 0
      REC(1) = GRID(1)
      REC(2) = GRID(2)
      REC(3) = GRID(3)
      ASSIGN 1240 TO IRETRN
      GO TO 1300
 1230 NCARD  = 14
      ASSIGN 1240 TO IERRTN
      GO TO 1490
C
C     SEQGP CARD
C     ==========
C
 1240 REC(1) = SEQGP(1)
      REC(2) = SEQGP(2)
      REC(3) = SEQGP(3)
      ASSIGN 1250 TO IRETRN
      GO TO 1260
C
C     CLOSE GEOM1
C
 1250 I = 1
      ASSIGN 1530 TO IRETRN
      GO TO 1380
C
C
C     UTILITY SECTION FOR IFP3
C     AXIS-SYMETRIC-CONICAL-SHELL DATA GENERATOR.
C     ==========================================
C
C     COMMON CODE FOR TRANSFER OF RECORD FROM AXIC FILE TO SOME
C     OTHER FILE
C
 1260 CALL LOCATE (*1330,Z(IBUFF1),REC(1),FLAG)
      IF (NOGO) GO TO 1330
      CALL WRITE (IFILE,REC(1),3,NOEOR)
 1290 CALL READ (*1540,*1300,AXIC,Z(1),ICORE,NOEOR,IAMT)
      IAMT = ICORE
      CALL WRITE (IFILE,Z(1),IAMT,NOEOR)
      GO TO 1290
 1300 IF (NOGO) GO TO 1330
      CALL WRITE (IFILE,Z(1),IAMT,EOR)
C
C     PUT BITS IN TRAILER
C
      I1 = (REC(2)-1)/16 + 2
      I2 =  REC(2)-(I1-2)*16 + 16
      TRAIL(I1) = ORF(TRAIL(I1),TWO(I2))
C
 1330 GO TO IRETRN, (590,530,610,30,1240,1250,860,37)
C
C     OPEN A FILE AND GET THE TRAILER
C
 1340 IF (NOGO) GO TO 1350
      CALL OPEN (*1360,FILE(I),Z(BUFF),OP)
      OPENFL(I) = 1
      IF (I .GT. 4) GO TO 1350
C
C     WRITE THE HEADER RECORD
C
      CALL WRITE (FILE(I),INAME(2*I-1),2,EOR)
      TRAIL(1) = FILE(I)
      CALL RDTRL (TRAIL(1))
C
 1350 GO TO IRETRN, (890,950,20)
C
 1360 CALL PAGE2 (3)
      IMSG = 1061
      WRITE  (NOUT,105 ) SFM,IMSG
      WRITE  (NOUT,1370) FILE(I),INAME(2*I-1),INAME(2*I),IFIST
 1370 FORMAT (5X,11HFILE NUMBER ,I4,3H ( ,2A4,12H) IS NOT IN ,A4)
      NOGO = .TRUE.
      GO TO 1530
C
C     CLOSE A FILE
C
 1380 IF (OPENFL(I)) 1390,1410,1390
 1390 IF (I .GT. 4) GO TO 1400
      CALL WRITE (FILE(I),T65535(1),3,EOR)
 1400 CALL CLOSE (FILE(I),CLORWD)
      OPENFL(I) = 0
      IF (I .GT. 4) GO TO 1410
      CALL WRTTRL (TRAIL(1))
 1410 GO TO IRETRN, (880,1060,1530)
C
C     HARMONIC NUMBER,  ON CARD TYPE ..... IS OUT OF RANGE 0 TO 998
C
 1420 IF (NNN.LT.999 .AND. NNN.GE.0) GO TO IERRTN, (70,460,560,640,810)
      CALL PAGE2 (3)
      IMSG = 364
      WRITE  (NOUT,445 ) UFM,IMSG
      WRITE  (NOUT,1430) NNN,CDTYPE(2*NCARD-1),CDTYPE(2*NCARD)
 1430 FORMAT (5X,'HARMONIC NUMBER',I6,4H ON ,2A4,' CARD OUT OF 0 TO ',
     1       '998 ALLOWABLE RANGE')
      NOGO = .TRUE.
      GO TO IERRTN, (70,460,560,640,810)
C
C     RING ID OUT PERMISSABLE RANGE OF 1 TO 999999
C
 1440 IF (NNN.GT.0 .AND. NNN.LE.999999)
     1    GO TO IERRTN, (80,180,490,570,650,700,820)
      CALL PAGE2 (3)
      IMSG = 365
      WRITE  (NOUT,445 ) UFM,IMSG
      WRITE  (NOUT,1450) NNN,CDTYPE(2*NCARD-1),CDTYPE(2*NCARD)
 1450 FORMAT (5X,'RING ID',I10,4H ON ,2A4,' CARD OUT OF 0 TO 999999',
     1       ' ALLOWABLE RANGE')
      NOGO = .TRUE.
      GO TO IERRTN, (80,180,490,570,650,700,820)
C
C     CHECK BIT-IBIT IN TRAILER AND RETURN NON = ZERO OR NON-ZERO
C
 1460 I1 = (IBIT-1)/16  +  2
      I2 = IBIT - (I1-2)*16 + 16
      NON = ANDF(AXTRL(I1),TWO(I2))
      GO TO IBITR, (140,150)
C
C     WRITE 3 WORD RECORD HEADER
C
 1470 IF (NOGO) GO TO 1480
      CALL WRITE (IFILE,REC(1),3,NOEOR)
 1480 GO TO IHEADR, (40,170,620,900,28)
C
C     END-OF-RECORD ON AXIC FILE.
C
 1490 CALL PAGE2 (3)
      IMSG = 1063
      WRITE (NOUT,105) SFM,IMSG
      WRITE (NOUT,480) CDTYPE(2*NCARD-1),CDTYPE(2*NCARD)
      NOGO = .TRUE.
      GO TO IERRTN, (1240)
C
C     MISSING REQUIRED CARD
C
 1510 CALL PAGE2 (3)
      IMSG = 362
      WRITE  (NOUT,445 ) UFM,IMSG
      WRITE  (NOUT,1520) CDTYPE(2*NCARD-1),CDTYPE(2*NCARD)
 1520 FORMAT (5X,'MINIMUM PROBLEM REQUIRES ',2A4,' CARD.  NONE FOUND.')
      NOGO = .TRUE.
      GO TO IERRTN, (770)
C
C     RETURN TO IFP3
C
 1530 RETURN
C
C     EOF ENCOUNTERED READING AXIC FILE
C
 1540 NFILE = AXIC
      CALL PAGE2 (3)
      IMSG = 3002
      WRITE  (NOUT,105 ) SFM,IMSG
      WRITE  (NOUT,1560) INAME(11),INAME(12),NFILE
 1560 FORMAT (5X,'EOF ENCOUNTERED WHILE READING DATA SET ',2A4,' (FILE',
     1        I4,') IN SUBROUTINE IFP3B')
      NOGO = .TRUE.
      GO TO 1530
C
 1580 CALL PAGE2 (3)
      IMSG = 363
      WRITE  (NOUT,445 ) UFM,IMSG
      WRITE  (NOUT,1590)
 1590 FORMAT (5X,'INSUFFICIENT CORE TO PROCESS AXIC DATA IN SUBROUTINE',
     1       'IFP3B')
      NOGO = .TRUE.
      GO TO 1530
C
 1570 I = 5
      GO TO 1360
      END

      SUBROUTINE DTRBSC (IOPT,NPIVOT)
C
C     IOPT = 1  IMPLIES THAT A CLOUGH TRIANGLE IS CALLING
C     IOPT = 2  IMPLIES THAT A QUADRILATERAL IS CALLING
C
C     ECPT LISTS OF NECESSARY VARIABLES
C
C     POSITION     TRIA1      QUAD1
C     ========     =====      =====
C     ECPT(51)      EID        EID
C     ECPT(52)      SIL1       SIL1
C     ECPT(53)      SIL2       SIL2
C     ECPT(54)      SIL3       SIL3
C     ECPT(55)      THETA      SIL4
C     ECPT(56)      MATID1     THETA
C     ECPT(57)      T1         MATID1
C     ECPT(58)      MATID2     T1
C     ECPT(59)      EYE        MATID2
C     ECPT(60)      MATID3     EYE
C     ECPT(61)      T2         MATID3
C     ECPT(62)      NSMASS     T2
C       :
C     ECT.
C
      DOUBLE PRECISION G,G2X2,AR,EYE,XBAR,YBAR,XCSQ,YCSQ,XBSQ,XCYC,PX2,
     1                 PY2,PXY2,XBAR3,YBAR3,YBAR2,T2,R,SP,T,U,R2,S2,DI,
     2                 DUMDP,C,A,D,S,J2X2,DETERM
      DOUBLE PRECISION XB2,XC2,YC2,XBC,SX,SY,SXY,XSUBB,XSUBC,YSUBC
      DIMENSION        D(9),DI(5,5),J2X2(4),S(18),NECPT(51),A(144)
      COMMON /MATIN /  MATID,INFLAG,ELTEMP,STRESS,SINTH,COSTH
      COMMON /MATOUT/  G11,G12,G13,G22,G23,G33,RHO,ALPHA1,ALPHA2,ALPH12,
     1                 TSUBD,GSUBE,SIGTEN,SIGCON,SIGSHE,G2X211,G2X212,
     2                 G2X222
      COMMON /DS1ADP/  G(9),G2X2(4),AR,EYE,XBAR,YBAR,XCSQ,YCSQ,XBSQ,XCYC
     1,                PX2,PY2,PXY2,XBAR3,YBAR3,YBAR2,T2,R,SP,T,U,R2,S2,
     2                 DUMDP(81),C(24,3),SX,SY,SXY,XSUBB,XSUBC,YSUBC
      COMMON /DS1AET/  ECPT(100)
      EQUIVALENCE      (A(1),D(1),G(1)),(NECPT(1),ECPT(1)),
     1                 (J2X2(1),DUMDP(1)),(DI(1,1),G(1))
C
C//////
C     CALL BUG (4HTBIG,30,SX,12)
C//////
C     IF NO TRANSVERSE SHEAR FLEXIBILITY EXISTS THE H-INVERSE IS
C     CALCULATED DIRECTLY.  TEST AS FOLLOWS
C
      IF (ECPT(IOPT+60).NE.0.0 .AND. NECPT(IOPT+59).NE.0) GO TO 30
C
C     THE H-INVERSE MATRIX IS GENERATED IN TWO PARTITIONS
C         HB IS IN POSITIONS C(7,2) TO C(24,2)
C         HC IS IN POSITIONS C(7,3) TO C(24,3)
C
   10 NOHYQ = 1
      R  = 1.0/XSUBB
      SP = 1.0/YSUBC
      T  = SP*XSUBC
      U  = R*R*SP*T
      R2 = R*R
      S2 = SP**2
C
      DO 20 I = 1,72
   20 C(I,1) = 0.0D0
C
      C(7 ,2) = 3.0D0*R2
      C(9 ,2) = R
      C(11,2) = R
      C(13,2) =-C(7,2)*T**2
      C(14,2) =-R*T
      C(15,2) = C(14,2)*T
      C(16,2) =-2.0D0*R2*R
      C(18,2) =-R2
      C(19,2) =-6.0D0*R*U*(XSUBB-XSUBC)
      C(20,2) =-R*SP
      C(21,2) = U*(3.0D0*XSUBC -2.0D0*XSUBB)
      C(22,2) = R*T*U*(6.0D0*XSUBB - 4.0D0*XSUBC)
      C(23,2) = R*SP*T
      C(24,2) = 2.0D0*T*U*(XSUBB - XSUBC)
C
      C(13,3) = 3.0D0*S2
      C(14,3) =-SP
      C(15,3) = SP*T
      C(21,3) =-S2
      C(22,3) =-2.0D0*S2*SP
      C(23,3) = S2
      GO TO 110
C
C     THE  MATERIAL COEFFICIENTS FOR TRANSVERSE SHEAR ARE CALCULATE HERE
C     AND THE H-INVERSE MATRIX IS GENERATED THE NORMAL WAY
C
C     GET THE G2X2 MATRIX
C
   30 MATID  = NECPT(IOPT+59)
      INFLAG = 3
      CALL MAT (ECPT(51))
      IF (G2X211.EQ.0. .AND. G2X212.EQ.0. .AND. G2X222.EQ.0.) GO TO 10
      T2      = ECPT(IOPT+60)
      G2X2(1) = G2X211*T2
      G2X2(2) = G2X212*T2
      G2X2(3) = G2X212*T2
      G2X2(4) = G2X222*T2
C
      DETERM  = G2X2(1)*G2X2(4) - G2X2(3)*G2X2(2)
      J2X2(1) = G2X2(4)/DETERM
      J2X2(2) =-G2X2(2)/DETERM
      J2X2(3) =-G2X2(3)/DETERM
      J2X2(4) = G2X2(1)/DETERM
C
C     SETTING UP G MATRIX
C
      INFLAG = 2
      MATID  = NECPT(IOPT+57)
      CALL MAT (NECPT(51))
C
C     FILL G-MATRIX WITH OUTPUT FROM MAT ROUTINE
C
      G(1) = G11
      G(2) = G12
      G(3) = G13
      G(4) = G12
      G(5) = G22
      G(6) = G23
      G(7) = G13
      G(8) = G23
      G(9) = G33
C
C     COMPUTATION OF D = I.G-MATRIX (EYE IS INPUT FROM THE ECPT)
C
      EYE = ECPT(IOPT+58)
      DO 50 I = 1,9
   50 D(I) = G(I)*EYE
C
C     (H  ) IS PARTITIONED INTO A LEFT AND RIGHT PORTION AND ONLY THE
C       YQ  RIGHT PORTION IS COMPUTED AND USED AS A (2X3). THE LEFT
C           2X3 PORTION IS NULL.  THE RIGHT PORTION WILL BE STORED AT
C           A(73) THRU A(78) UNTIL NOT NEEDED ANY FURTHER.
C
C
C
      TEMP  = 2.0D0*D(2) + 4.0D0*D(9)
      A(73) =-6.0D0*(J2X2(1)*D(1) + J2X2(2)*D(3))
      A(74) =-J2X2(1)*TEMP - 6.0D0*J2X2(2)*D(6)
      A(75) =-6.0D0*(J2X2(1)*D(6) + J2X2(2)*D(5))
      A(76) =-6.0D0*(J2X2(2)*D(1) + J2X2(4)*D(3))
      A(77) =-J2X2(2)*TEMP - 6.0D0*J2X2(4)*D(6)
      A(78) =-6.0D0*(J2X2(2)*D(6) + J2X2(4)*D(5))
C
C     THE ABOVE 6 ELEMENTS NOW REPRESENT THE (H  ) MATRIX (2X3)
C                                              YQ
C
      XBAR = (XSUBB + XSUBC)/3.0D0
      YBAR = YSUBC/3.0D0
C
      XCSQ  = XSUBC**2
      YCSQ  = YSUBC**2
      XBSQ  = XSUBB**2
      XCYC  = XSUBC*YSUBC
      PX2   = (XBSQ + XSUBB*XSUBC + XCSQ)/6.0D0
      PY2   = YCSQ/6.0D0
      PXY2  = YSUBC*(XSUBB + 2.0D0*XSUBC)/12.0D0
      XBAR3 = 3.0D0*XBAR
      YBAR3 = 3.0D0*YBAR
      YBAR2 = 2.0D0*YBAR
C
C     F1LL (HBAR) MATRIX STORING AT A(37) THRU A(72)
C
      DO 60 I = 37,72
   60 A(I)  = 0.0D0
C
      A(37) = XBSQ
      A(40) = XBSQ*XSUBB
      A(44) = XSUBB
      A(49) =-2.0D0*XSUBB
      A(52) =-3.0D0*XBSQ
      A(55) = XCSQ
      A(56) = XCYC
      A(57) = YCSQ
      A(58) = XCSQ*XSUBC
      A(59) = YCSQ*XSUBC
      A(60) = YCSQ*YSUBC
      A(62) = XSUBC
      A(63) = YSUBC*2.0D0
      A(65) = XCYC *2.0D0
      A(66) = YCSQ *3.0D0
      A(67) =-2.0D0*XSUBC
      A(68) =-YSUBC
      A(70) =-3.0D0*XCSQ
      A(71) =-YCSQ
C
C     ADD TO 6 OF THE (HBAR) ELEMENTS THE RESULT OF (H  )(H  )
C                                                     UY   YQ
C     THE PRODUCT IS FORMED DIRECTLY IN THE ADDITION PROCESS BELOW.
C     NO (H  ) MATRIX IS ACTUALLY COMPUTED DIRECTLY.
C          UY
C
C     THE FOLLOWING IS THEN PER STEPS 6 AND 7 PAGE -16- MS-17.
C
      DO 70 I = 1,3
      A(I+39) = A(I+39) + XSUBB*A(I+72)
   70 A(I+57) = A(I+57) + XSUBC*A(I+72) + YSUBC*A(I+75)
C
C     AT THIS POINT INVERT  (H) WHICH IS STORED AT A(37) THRU A(72)
C     STORE INVERSE BACK IN A(37) THRU A(72)
C     NO NEED TO COMPUTE DETERMINANT SINCE IT IS NOT USED SUBSEQUENTLY.
C
      ISING = -1
      CALL INVERD (6,A(37),6,A(73),0,DETERM,ISING,A(79))
C
C     CHECK TO SEE IF H WAS SINGULAR
C
C     ISING = 2 IMPLIES SINGULAR MATRIX THUS ERROR CONDITION.
      IF(ISING .NE. 2) GO TO 90
      CALL MESAGE (-30,33,ECPT(1))
      RETURN
C
C     PARTITION H-INVERSE AND STORE IN C2 AND C3 LOCATIONS 7 THRU 24
C
   90 DO 100 I = 1,6
      IH = 6*I -6
      IC = 3*I -3
C
      DO 100 J = 1,3
      JH= IH + J + 36
      JC= IC + J + 6
      C(JC,2) = A(JH)
      C(JC,3) = A(JH+3)
  100 CONTINUE
      NOHYQ = 0
C
C     THIS ENDS ADDED COMPUTATION FOR CASE OF T2 NOT ZERO
C
C     THE C1, C2, AND C3 MATRICES ARE GENERATED WITH THE FOLLOWING CODE
C     FIRST GENERATE THE S MATRICES IN POSITIONS 1 THRU 9 AND 10 THRU 18
C
  110 DO 120 I = 1,18
  120 S(I) = 0.0
      DO 130 I = 1,9,4
      S(I  ) = 1.0
  130 S(I+9) = 1.0
      S(  3) =-XSUBB
      S( 11) = YSUBC
      S( 12) =-XSUBC
C
C     COMPUTE HA  AND STORE IN  CA, POSITIONS 7 THRU 24
C
C         HA =  -(HB TIMES SB + HC TIMES SC)
C
      CALL GMMATD (C(7,2),6,3,0, S(1),3,3,0, A(37))
      CALL GMMATD (C(7,3),6,3,0, S(10),3,3,0, A(55))
C
      DO 140 I = 1,18
C
  140 C(I+6,1) = -A(I+36) - A(I+54)
C
C     COMPUTE  HYQ TIMES HX  AND STORE IN CX POSITIONS 1 THRU 6
C     (THE FIRST THREE COLUMNS OF HYQ ARE NULL)
C
      IF (NOHYQ .EQ. 1) GO TO 160
C
      DO 150 I = 1,3
      CALL GMMATD (A(73),2,3,0, C(16,I),3,3,0, C(1,I))
  150 CONTINUE
C
  160 C(3,1) = C(3,1) - 1.0D0
      C(5,1) = C(5,1) + 1.0D0
C
C     THE INTEGRALS FOR THE  KDQQ MATRIX ARE GENERATED HERE
C
      YC2 = YSUBC**2
      XB2 = XSUBB**2
      XC2 = XSUBC**2
      XBC = XSUBB*XSUBC
C
      DI(1,1) = 1.0D0
      DI(1,2) = YSUBC/3.0D0
      DI(1,3) = YC2/6.0D0
      DI(1,4) = YC2*YSUBC/10.0D0
      DI(1,5) = YC2**2/15.0D0
      DI(2,1) = (XSUBB + XSUBC)/3.0D0
      DI(2,2) = YSUBC*(XSUBB + 2.0D0*XSUBC)/12.0D0
      DI(2,3) = DI(1,3)*(XSUBB + 3.0D0*XSUBC)/5.0D0
      DI(2,4) = DI(1,4)*(XSUBB + 4.0D0*XSUBC)/6.0D0
      DI(3,1) = (XB2 +XBC + XC2)/6.0D0
      DI(3,2) = DI(1,2)*(XB2 + 2.0D0*XBC + 3.0D0*XC2)/10.0D0
      DI(3,3) = DI(1,3)*(XB2 + 3.0D0*XBC + 6.0D0*XC2)/15.0D0
      DI(4,1) = (XSUBB + XSUBC)*(XB2 + XC2)/10.0D0
      DI(4,2) = DI(1,2)*((XSUBB + 2.0D0*XSUBC)*XB2 +
     1          (3.0D0*XSUBB + 4.0D0*XSUBC)*XC2)/20.0D0
      DI(5,1) = (XB2*XB2 + XB2*XBC + XBC*XBC + XBC*XC2 + XC2*XC2)/15.0
C
      AR = XSUBB*YSUBC*DBLE(ECPT(IOPT+56))/2.0D0
      DO 170 I = 1,5
      IC = 6 - I
      DO 170 J = 1,IC
      DI(I,J) = DI(I,J)*AR
  170 CONTINUE
C
C     THE ABOVE INTEGRALS  D(I,J) CORRESPOND TO THE DOCUMENTED
C     VALUES  I(I-1,J-1).  ZERO INDICES DONT ALWAYS COMPILE.
C
C     THE DIFFERENTIAL STIFFNESS MATRIX IN GENERALIZED COORDINATES IS
C     CREATED BELOW AT POSITIONS A(28) TO A(91)
C
      A(28) = SX*DI(1,1)
      A(29) = SXY*DI(1,1)
      A(30) = 2.0D0*SX*DI(2,1)
      A(31) = SX*DI(1,2) + SXY*DI(2,1)
      A(32) = 2.0D0*SXY*DI(1,2)
      A(33) = 3.0D0*SX *DI(3,1)
      A(34) = SX*DI(1,3) + 2.0*SXY*DI(2,2)
      A(35) = 3.0D0*SXY*DI(1,3)
C
      A(37) = SY*DI(1,1)
      A(38) = 2.0D0*SXY*DI(2,1)
      A(39) = SXY*DI(1,2) + SY*DI(2,1)
      A(40) = 2.0D0*SY*DI(1,2)
      A(41) = 3.0D0*SXY*DI(3,1)
      A(42) = SXY*DI(1,3) + 2.0D0*SY*DI(2,2)
      A(43) = 3.0D0*SY*DI(1,3)
C
      A(46) = 4.0D0*SX*DI(3,1)
      A(47) = 2.0D0*(SX*DI(2,2) + SXY*DI(3,1))
      A(48) = 4.0D0*SXY*DI(2,2)
      A(49) = 6.0D0*SX*DI(4,1)
      A(50) = 2.0D0*(SX*DI(2,3) + 2.0D0*SXY*DI(3,2))
      A(51) = 6.0D0*SXY*DI(2,3)
C
      A(55) = SX*DI(1,3) + 2.0D0*SXY*DI(2,2)+SY*DI(3,1)
      A(56) = 2.0D0*(SXY*DI(1,3) + SY*DI(2,2))
      A(57) = 3.0D0*(SX* DI(3,2) + SXY*DI(4,1))
      A(58) = SX*DI(1,4) + 3.0D0*SXY*DI(2,3) + 2.0D0*SY*DI(3,2)
      A(59) = 3.0D0*(SXY*DI(1,4) + SY*DI(2,3))
C
      A(64) = 4.0D0*SY*DI(1,3)
      A(65) = 6.0D0*SXY*DI(3,2)
      A(66) = 2.0D0*(SXY*DI(1,4) + 2.0D0*SY*DI(2,3))
      A(67) = 6.0D0*SY*DI(1,4)
C
      A(73) = 9.0D0*SX*DI(5,1)
      A(74) = 3.0D0*(SX*DI(3,3) + 2.0D0*SXY*DI(4,2))
      A(75) = 9.0D0*SXY*DI(3,3)
C
      A(82) = SX*DI(1,5) + 4.0D0*SXY*DI(2,4) + 4.0D0*SY*DI(3,3)
      A(83) = 3.0D0*SXY*DI(1,5) + 6.0D0*SY*DI(2,4)
C
      A(91) = 9.0D0*SY*DI(1,5)
C
C     FILL IN SYMMETRIC TERMS
C
      DO 180 I = 2,8
      IH = I - 1
      DO 180 J = 1,IH
      IC =  8*(I-1) + J
      JC =  8*(J-1) + I
      A(IC+27) = A(JC+27)
  180 CONTINUE
C
C     AT THIS STAGE THE 3X3 MATRIX PARTITIONS MAY BE GENERATED
C     THE ACTUAL MATRICES DEPEND ON IOPT
C
      IC = NPIVOT
      IF (IC .EQ. 0) GO TO 200
      CALL GMMATD (C(1,IC),8,3,1, A(28),8,8,0, A(92))
      DO 190 I = 1,3
      IH=  9*(I-1) + 1
      CALL GMMATD (A(92),3,8,0, C(1,I),8,3,0, A(IH))
  190 CONTINUE
C//////
C     CALL BUG (4HTBKD,300,A,54)
C//////
C
C     AT THIS STAGE THE QUADRILATERAL CALCULATIONS ARE COMPLETE
C
  200 IF (IOPT .EQ.2) RETURN
C
C     THE TRIANGLE SUBROUTINE  MUST RETURN THE FOLLOWING DATA
C         KAC,KBC,KCC  IN POSITIONS  A(28) THRU A(54) -I=NPIVOT
C             S        IN POSITIONS  A(55) THRU A(72)
C           H-INVERSE  IN POSITIONS  A(73) THRU A(108)
C
      CALL GMMATD (A(28),8,8,0, C(1,3),8,3,0, A(92))
      DO 210 I = 1,3
      IH = 28 + 9*(I-1)
      CALL GMMATD (C(1,I),8,3,1, A(92),8,3,0, A(IH))
  210 CONTINUE
C
C     RECALCULATE THE S MATRIX (IT WAS DESTROYED) -
C     PLACE IN A(55 THRU 72)
C
      DO 230 I = 1,18
  230 A(I+54) = 0.0
      DO 240 I = 1,9,4
      A(I+54) = 1.0
  240 A(I+63) = 1.0
      A(57) =-XSUBB
      A(65) = YSUBC
      A(66) =-XSUBC
C
C     EXTRACT THE H-INVERSE MATRIX FROM THE C MATRICES
C     STORE AT POSITIONS A(73) THRU A(108)
C
      DO 250 I = 1,6
      IH = 6*I - 6
      IC = 3*I - 3
C
      DO 250 J = 1,3
      JH = IH + J + 72
      JC = IC + J + 6
      A(JH  ) = C(JC,2)
      A(JH+3) = C(JC,3)
  250 CONTINUE
      RETURN
      END

      BLOCK DATA SMA2BD
CSMA2BD
C
      INTEGER         CLSRW,  CLSNRW, EOR,   OUTRW
      COMMON /SMA2IO/ IFCSTM, IFMPT,  IFDIT, IDUM1, IFECPT, IGECPT,
     1                IFGPCT, IGGPCT, IDUM2, IDUM3, IFMGG,  IGMGG,
     2                IFBGG,  IGBGG,  IDUM4, IDUM5, INRW,   OUTRW,
     3                CLSNRW, CLSRW,  NEOR,  EOR, MCBMGG(7),MCBBGG(7)
C
C     SMA2 VARIABLE CORE BOOKKEEPING PARAMETERS
C
      COMMON /SMA2BK/ ICSTM,  NCSTM,  IGPCT, NGPCT, IPOINT, NPOINT,
     1                I6X6M,  N6X6M,  I6X6B, N6X6B
C
C     SMA2 PROGRAM CONTROL PARAMETERS
C
      COMMON /SMA2CL/ IOPT4,  BGGIND, NPVT,  LEFT,  FROWIC, LROWIC,
     1                NROWSC, TNROWS, JMAX,  NLINKS,LINK(10),NOGO,
     2                DUMMY(202)
C
C     ECPT COMMON BLOCK
C
      COMMON /SMA2ET/ ECPT(200)
C
      DATA    NLINKS/ 10 /
      DATA    NOGO  / 0  /
      DATA    IFCSTM, IFMPT,IFECPT,IFGPCT,IFDIT  / 101,102,103,104,105 /
      DATA    IFMGG , IFBGG       /     201,202  /
      DATA    INRW  , CLSRW,CLSNRW,EOR,NEOR,OUTRW/ 0,1,2,1,0,1 /
      END

      SUBROUTINE CMRD2E (ITER)
C
C     THIS SUBROUTINE CALCULATES THE H TRANSFORMATION MATRIX FOR THE
C     CMRED2 MODULE.
C
C     INPUT  DATA
C     GINO - HIM     - MODAL TRANSFORMATION MATRIX
C     SOF  - GIMS    - G TRANSFORMATION MATRIX FOR BOUNDARY POINTS OF
C                      ORIGINAL SUBSTRUCTURE
C
C     OUTPUT  DATA
C     GINO  - HGH    - HORG PARTITION MATRIX
C     SOF   - HORG   - H TRANSFORMATION MATRIX FOR ORIGINAL SUBSTRUCTURE
C
C     PARAMETERS
C     INPUT - GBUF   - GINO BUFFERS
C             INFILE - INPUT FILE NUMBERS
C             OTFILE - OUTPUT FILE NUMBERS
C             ISCR   - SCRATCH FILE NUMBERS
C             KORLEN - LENGTH OF OPEN CORE
C             KORBGN - BEGINNING ADDRESS OF OPEN CORE
C             OLDNAM - NAME OF SUBSTRUCTURE BEING REDUCED
C     OTHERS- HIM    - HIM PARTITION MATRIX FILE NUMBER (RIGHT SIDE)
C             HGH    - HORG MATRIX FILE NUMBER (RIGHT SIDE)
C             GIB    - GIMS INPUT FILE NUMBER (RIGHT SIDE)
C             HIMBAR - HIM PARTITION MATRIX FILE NUMBER (LEFT SIDE)
C             HGHBAR - HGH PARTITION MATRIX FILE NUMBER (LEFT SIDE)
C             GIBBAR - GIB PARTITION MATRIX FILE NUMBER (LEFT SIDE)
C             UPRT   - USET PARTITIONING VECTOR FILE NUMBER
C
      INTEGER          DRY,GBUF1,GBUF2,Z,TYPINP,TYPEOP,TYPEU,HIM,HGH,
     1                 GIB,HIMBAR,HGHBAR,GIBBAR,UPRT,HIMRL,HGHRL,GIBRL,
     2                 DBLKOR,GIBTYP,HIMTYP,SGLKOR,DICORE
      DOUBLE PRECISION DZ
      DIMENSION        MODNAM(2),ITRLR1(7),ITRLR2(7),RZ(1),ITMLST(4),
     1                 DZ(1),ITRLR3(7)
      CHARACTER        UFM*23
      COMMON /XMSSG /  UFM
      COMMON /BLANK /  IDUM1,DRY,IDUM7,GBUF1,GBUF2,IDUM2(4),INFILE(11),
     1                 OTFILE(6),ISCR(11),KORLEN,KORBGN,OLDNAM(2)
      COMMON /ZZZZZZ/  Z(1)
      COMMON /PACKX /  TYPINP,TYPEOP,IROWP,NROWP,INCRP
      COMMON /UNPAKX/  TYPEU,IROWU,NROWU,INCRU
      COMMON /SYSTEM/  IDUM3,IPRNTR
      EQUIVALENCE      (HIM,ISCR(10)),(GIB,ISCR(6)),(UPRT,ISCR(7)),
     1                 (GIBBAR,ISCR(11)),(HGHBAR,ISCR(9)),(HGH,ISCR(9)),
     2                 (HIMBAR,ISCR(8)),(RZ(1),Z(1)),(DZ(1),Z(1))
      DATA    MODNAM/  4HCMRD,4H2E  /
      DATA    ITMLST/  4HHORG,4HHLFT,4HGIMS,4HUPRT/
C
C     SET UP ROW PARTITION
C
      IF (DRY .EQ. -2) RETURN
      ITEM = ITMLST(4)
      CALL MTRXI (UPRT,OLDNAM,ITEM,0,ITEST)
      IF (ITEST .NE. 1) GO TO 210
      CALL SOFTRL (OLDNAM,ITEM,ITRLR1)
      IF (KORBGN+ITRLR1(3) .GE. KORLEN) GO TO 270
      TYPEU = ITRLR1(5)
      IROWU = 1
      NROWU = ITRLR1(3)
      INCRU = 1
      CALL GOPEN (UPRT,Z(GBUF1),0)
      CALL UNPACK (*5,UPRT,RZ(KORBGN))
      GO TO 15
    5 DO 10 I = 1, NROWU
   10 RZ(KORBGN+I-1) = 0.0
   15 CALL CLOSE (UPRT,1)
      LUPRT  = NROWU
      KORE   = KORBGN
      KORBGN = KORBGN + LUPRT
C
C     GET GIB MATRIX
C
      IF (ITER .EQ. 2) GO TO 20
      ITEM = ITMLST(3)
      CALL SOFTRL (OLDNAM,ITEM,ITRLR1)
      IF (ITEST .NE. 1) GO TO 210
      CALL MTRXI (GIB,OLDNAM,ITEM,0,ITEST)
      IF (ITEST .NE. 1) GO TO 210
      ITRLR1(1) = GIB
      GIBRL = GIB
      GO TO 30
   20 ITRLR1(1) = GIBBAR
      CALL RDTRL (ITRLR1)
      GIBRL = GIBBAR
C
C     SET UP HGH TRAILER
C
   30 HGHRL = HGH
      IF (ITER .EQ. 2) HGHRL = HGHBAR
      NROWS1 = ITRLR1(3)
      KOLS1  = ITRLR1(2)
      GIBTYP = ITRLR1(5)
      HIMRL  = HIM
      IF (ITER .EQ. 2) HIMRL = HIMBAR
      ITRLR2(1) = HIMRL
      CALL RDTRL (ITRLR2)
      NROWS2 = ITRLR2(3)
      KOLS2  = ITRLR2(2)
      HIMTYP = ITRLR2(5)
      IFORM  = 2
      IF (ITRLR1(2)+ITRLR1(3) .EQ. ITRLR2(2)+ITRLR2(3)) IFORM = 1
      IPRC   = 1
      ITYP   = 0
      IF (ITRLR1(5).EQ.2 .OR. ITRLR1(5).EQ.4) IPRC = 2
      IF (ITRLR2(5).EQ.2 .OR. ITRLR2(5).EQ.4) IPRC = 2
      IF (ITRLR1(5) .GE. 3) ITYP = 2
      IF (ITRLR2(5) .GE. 3) ITYP = 2
      ITYPE = IPRC + ITYP
      CALL MAKMCB (ITRLR3,HGHRL,LUPRT,IFORM,ITYPE)
C
C     SET UP PACK/UNPACK PARAMETERS
C
      TYPEOP = ITRLR3(5)
      IROWP  = 1
      NROWP  = ITRLR1(2) + ITRLR1(3)
      INCRP  = 1
      INCRU  = 1
      DBLKOR = KORBGN/2 + 1
      SGLKOR = 2*DBLKOR - 1
C
C     FORM HGH MATRIX
C
C                  **         **
C                  *     .     *
C        **   **   *  I  .  0  *
C        *     *   *     .     *
C        * HGH * = *...........*
C        *     *   *     .     *
C        **   **   * GIB . HIM *
C                  *     .     *
C                  **         **
C
      CALL GOPEN (HGHRL,Z(GBUF1),1)
C
C     PROCESS GIB MATRIX
C
      TYPEU  = ITRLR1(5)
      NROWU  = ITRLR1(3)
      TYPINP = ITRLR1(5)
      NROWS  = ITRLR1(3)
      IF (ITRLR1(5) .GT. 2) NROWS = 2*ITRLR1(3)
      IF (ITRLR1(5).EQ.1 .OR. ITRLR1(5).EQ.3)
     1    DICORE = (SGLKOR+NROWS)/2 + 1
      IF (ITRLR1(5).EQ.2 .OR. ITRLR1(5).EQ.4) DICORE = DBLKOR + NROWS
      ICORE  = 2*DICORE - 1
      IF (DICORE+NROWS .GE. KORLEN) GO TO 270
      CALL GOPEN (GIBRL,Z(GBUF2),0)
      DO 90 I = 1,KOLS1
      K  = 0
      KK = 0
      CALL UNPACK (*40,GIBRL,DZ(DBLKOR))
      GO TO 50
C
C     NULL GIB COLUMN
C
   40 GO TO (42,46,42,46), GIBTYP
   42 DO 44 J = 1,NROWS
   44 RZ(SGLKOR+J-1) = 0.0
      GO TO 50
   46 DO 48 J = 1,NROWS
   48 DZ(DBLKOR+J-1) = 0.0D0
C
C     MOVE GIB DATA
C
   50 DO 80 J = 1,LUPRT
      IF (RZ(KORE+J-1) .EQ. 1.0) GO TO 70
      KK = KK + 1
      L  = 1 + 2*(KK-1)
      LL = 1 + 2*( J-1)
      GO TO (62,64,66,68), GIBTYP
   62 RZ(ICORE+J-1) = RZ(SGLKOR+KK-1)
      GO TO 80
   64 DZ(DICORE+J-1) = DZ(DBLKOR+KK-1)
      GO TO 80
   66 RZ(ICORE+LL-1) = RZ(SGLKOR+L-1)
      RZ(ICORE+LL  ) = RZ(SGLKOR+L)
      GO TO 80
   68 DZ(DICORE+LL-1) = DZ(DBLKOR+L-1)
      DZ(DICORE+LL  ) = DZ(DBLKOR+L)
      GO TO 80
C
C     MOVE IDENTITY MATRIX DATA
C
   70 K = K + 1
      L = 1 + 2*(J-1)
      GO TO (72,74,76,78), GIBTYP
   72 RZ(ICORE+J-1) = 0.0
      IF (K .EQ. I) RZ(ICORE+J-1) = 1.0
      GO TO 80
   74 DZ(DICORE+J-1) = 0.0D0
      IF (K .EQ. I) DZ(DICORE+J-1) = 1.0D0
      GO TO 80
   76 RZ(ICORE+L-1) = 0.0
      IF (K .EQ. I) RZ(ICORE+L-1) = 1.0
      RZ(ICORE+L) = 0.0
      GO TO 80
   78 DZ(DICORE+L-1) = 0.0D0
      IF (K .EQ. I) DZ(DICORE+L-1) = 1.0D0
      DZ(DICORE+L) = 0.0D0
   80 CONTINUE
   90 CALL PACK (DZ(DICORE),HGHRL,ITRLR3)
      CALL CLOSE (GIBRL,1)
C
C     PROCESS HIM MATRIX
C
      TYPEU  = ITRLR2(5)
      NROWU  = ITRLR2(3)
      TYPINP = ITRLR2(5)
      NROWS  = ITRLR2(3)
      IF (ITRLR2(5) .GT. 2) NROWS = 2*ITRLR2(3)
      IF (ITRLR2(5).EQ.2 .OR. ITRLR2(5).EQ.4)
     1    DICORE = (SGLKOR+NROWS)/2 + 1
      IF (ITRLR2(5).EQ.1 .OR. ITRLR2(5).EQ.3) DICORE = DBLKOR + NROWS
      ICORE = 2*DICORE - 1
      IF (DICORE+NROWS .GE. KORLEN) GO TO 270
      CALL GOPEN (HIMRL,Z(GBUF2),0)
      DO 150 I = 1,KOLS2
      KK = 0
      CALL UNPACK (*100,HIMRL,DZ(DBLKOR))
      GO TO 110
C
C     NULL HIM COLUMN
C
  100 GO TO (102,106,102,106), HIMTYP
  102 DO 104 J = 1,NROWS
  104 RZ(SGLKOR+J-1) = 0.0
      GO TO 110
  106 DO 108 J = 1,NROWS
  108 DZ(DBLKOR+J-1) = 0.0D0
C
C     MOVE HIM MATRIX DATA
C
  110 DO 140 J = 1,LUPRT
      IF (RZ(KORE+J-1) .EQ. 1.0) GO TO 130
      KK = KK + 1
      L  = 1 + 2*(KK-1)
      LL = 1 + 2*( J-1)
      GO TO (122,124,126,128), HIMTYP
  122 RZ(ICORE+J-1) = RZ(SGLKOR+KK-1)
      GO TO 140
  124 DZ(DICORE+J-1) = DZ(DBLKOR+KK-1)
      GO TO 140
  126 RZ(ICORE+LL-1) = RZ(SGLKOR+L-1)
      RZ(ICORE+LL  ) = RZ(SGLKOR+L)
      GO TO 140
  128 DZ(DICORE+LL-1) = DZ(DBLKOR+L-1)
      DZ(DICORE+LL  ) = DZ(DBLKOR+L)
      GO TO 140
C
C     MOVE ZERO MATRIX DATA
C
  130 L = 1 + 2*(J-1)
      GO TO (132,134,136,138), HIMTYP
  132 RZ(ICORE+J-1) = 0.0
      GO TO 140
  134 DZ(DICORE+J-1) = 0.0D0
      GO TO 140
  136 RZ(ICORE+L-1) = 0.0
      RZ(ICORE+L  ) = 0.0
      GO TO 140
  138 DZ(DICORE+L-1) = 0.0D0
      DZ(DICORE+L  ) = 0.0D0
  140 CONTINUE
  150 CALL PACK (DZ(DICORE),HGHRL,ITRLR3)
      CALL CLOSE (HIMRL,1)
      CALL CLOSE (HGHRL,1)
      CALL WRTTRL (ITRLR3)
      KORBGN = KORE
C
C     SAVE HGH ON SOF AS H(ORG,LFT) MATRIX
C
      ITEM = ITMLST(ITER)
      CALL MTRXO (HGHRL,OLDNAM,ITEM,0,ITEST)
      IF (ITEST .NE. 3) GO TO 210
      RETURN
C
C     PROCESS MODULE FATAL ERRORS
C
  210 GO TO (220,220,220,230,240,260), ITEST
  220 WRITE (IPRNTR,900) UFM,MODNAM,ITEM,OLDNAM
      DRY = -2
      RETURN
C
  230 IMSG = -2
      GO TO 250
  240 IMSG = -3
  250 CALL SMSG(IMSG,ITEM,OLDNAM)
      RETURN
C
  260 WRITE (IPRNTR,901) UFM,MODNAM,ITEM,OLDNAM
      DRY = -2
      RETURN
C
C     PROCESS SYSTEM FATAL ERRORS
C
  270 IMSG = -8
      IFILE = 0
      CALL SOFCLS
      CALL MESAGE (IMSG,IFILE,MODNAM)
      RETURN
C
  900 FORMAT (A23,' 6211, MODULE ',2A4,' - ITEM ',A4,
     1       ' OF SUBSTRUCTURE ',2A4,' HAS ALREADY BEEN WRITTEN.')
  901 FORMAT (A23,' 6632, MODULE ',2A4,' - NASTRAN MATRIX FILE FOR I/O',
     1       ' OF SOF ITEM ',A4,', SUBSTRUCTURE ',2A4,', IS PURGED.')
C
      END

      SUBROUTINE DSREAD ( IUNIT, BUFF, LEN, IREC )
      INTEGER           BUFF( LEN )
      COMMON / SYSTEM / SYSBUF, IWR
      INCLUDE          'DSIOF.COM'
      IF ( IREC  .LT. 0 ) GO TO 701
c      PRINT *,' DSREAD,LEN,IREC,IUNIT=',LEN,IREC,IUNIT
      ISTAT=0
      READ ( IUNIT, REC=IREC, ERR=702, IOSTAT=ISTAT )
     &       BUFF
      IF ( ISTAT .EQ. 0 ) GO TO 777
      IOERR = ISTAT
      CALL DSMSG  ( 101 )
      CALL MESAGE ( -61, 0, 0 )
701   WRITE ( IWR, 901 ) IUNIT, IREC, MDSNAM( IUNIT )
901   FORMAT(//' ERROR IN DSREAD-BAD REC NO., UNIT=',I4,' REC=',I4
     &,      /,' FILE NAME=',A72)
      ICCERR = 0
      CALL DSMSG  ( 101 )
      CALL MESAGE ( -61, 0, 0 )
      GO TO 777
702   WRITE( IWR, 902 ) IUNIT, IREC, ISTAT, MDSNAM( IUNIT )
902   FORMAT(//', ERROR ENCOUNTERED IN DSREAD, UNIT=',I5,' RECORD='
     &, I5,' STATUS=',I9,/' DSNAME=',A72 )
      ICCERR = ISTAT
      CALL DSMSG( 101 )
      CALL MESAGE( -61, 0, 0 )
      GO TO 777
777   CONTINUE
      NUMREA = NUMREA + 1
      RETURN
      END

      SUBROUTINE EXO2
C
C     EXO2 PERFORMS EXTERNAL FORMAT SOFOUT OPERATIONS
C
      EXTERNAL RSHIFT   ,ANDF
      LOGICAL  UNIVAC
      INTEGER  DRY      ,COR(1)   ,UNAME    ,TYPE     ,UNIT     ,
     1         ITMS(50) ,SYSBUF   ,A        ,EOL      ,EOR      ,
     2         DITSIZ   ,Z        ,ALL      ,Q4       ,T3       ,
     3         MATRIC   ,TABLES   ,PHASE3   ,WHOLE(2) ,SUBR(2)  ,
     4         BLANK    ,SOF      ,XXXX     ,SRD      ,PRC      ,
     5         SWRT     ,EOG      ,EOI      ,SP       ,BAR      ,
     6         SCR1     ,BUF1     ,BUF2     ,BUF3     ,ELTYPE   ,
     7         BUF4     ,RC       ,HDR(7)   ,TYPOUT   ,BDIT     ,
     8         BMDI     ,RSHIFT   ,ANDF     ,OFFSET
      INTEGER  EQSS     ,BGSS     ,CSTM     ,LODS     ,LOAP     ,
     1         PLTS     ,SOLN     ,LAMS
      DOUBLE PRECISION   DZ(1)    ,DA
      CHARACTER          UFM*23   ,UWM*25   ,UIM*29   ,SFM*25   ,
     1                   SWM*27
      COMMON  /XMSSG /   UFM      ,UWM      ,UIM      ,SFM      ,
     1                   SWM
      COMMON  /BLANK /   DRY      ,X1(3)    ,UNAME(2) ,X2(6)    ,
     1                   TYPE(2)  ,NAMES(10),UNIT     ,UNIVAC   ,
     2                   LBUF     ,IADD
      COMMON  /SYSTEM/   SYSBUF   ,NOUT     ,X3(6)    ,NLPP     ,
     1                   X4(2)    ,LINE     ,X6(9)    ,MACH
      COMMON  /NAMES /   RD       ,RDREW    ,WRT      ,WRTREW   ,
     1                   REW
      COMMON  /TYPE  /   PRC(2)   ,NWORD(4)
      COMMON  /ZNTPKX/   A(4)     ,IROW     ,EOL      ,EOR
      COMMON  /SOF   /   X5(3)    ,DITSIZ
      COMMON  /ITEMDT/   NITEM    ,ITEMS(7,1)
      COMMON  /ZZZZZZ/   Z(1)
      EQUIVALENCE        (COR(1)  ,Z(1))
      EQUIVALENCE        (Z(1)    ,DZ(1))   ,(A(1)    ,DA)
      DATA     ALL      ,MATRIC   ,TABLES   ,PHASE3   ,WHOLE          /
     1         4HALL    ,4HMATR   ,4HTABL   ,4HPHAS   ,4HWHOL  ,4HESOF/,
     2         SUBR               ,BLANK    ,SOF      ,XXXX           /
     3         4HEXO2   ,4H       ,4H       ,4HSOF    ,4HXXXX         /,
     4         EQSS     ,BGSS     ,CSTM     ,LODS     ,LOAP           /
     5         4HEQSS   ,4HBGSS   ,4HCSTM   ,4HLODS   ,4HLOAP         /,
     6         PLTS     ,SOLN     ,LAMS     ,Q4       ,T3      ,BAR   /
     7         4HPLTS   ,4HSOLN   ,4HLAMS   ,2HQ4     ,2HT3    ,2HBR  /,
     8         SRD      ,SWRT     ,MORE     ,EOG      ,EOI     ,SP    /
     9         1        ,2        ,1        ,2        ,3       ,1     /,
     O         JH       ,SCR1     ,BDIT     ,BMDI                     /
     A         1        ,301      ,4HDIT    ,4HMDI                    /
C
C     INITIALIZE
C
      IF (NITEM .GT. 50) CALL ERRMKN (23,10)
      NCORE = KORSZ(Z)
      I     = NCORE - LBUF
      IF (MACH .EQ. 4) I = I - LBUF
      NCORE = I - 1
      IRW   = IADD
      IADD  = I
      CALL EXFORT (3,UNIT,0,0,IRW,0,0)
      BUF1  = NCORE - SYSBUF + 1
      BUF2  = BUF1  - SYSBUF - 1
      BUF3  = BUF2  - SYSBUF
      BUF4  = BUF3  - SYSBUF
      NCORE = BUF4  - 1
      IF (BUF4 .LE. 0) GO TO 9008
      CALL SOFOPN (Z(BUF1),Z(BUF2),Z(BUF3))
C
C     CONSTRUCT ARRAY OF NAMES OF ITEMS TO BE COPIED
C
      IF (TYPE(1) .NE. ALL) GO TO 10
      NITEMS = NITEM
      DO 5 I = 1,NITEM
    5 ITMS(I) = ITEMS(1,I)
      GO TO 70
   10 IF (TYPE(1) .NE. TABLES) GO TO 20
      NITEMS = 0
      DO 15 I = 1,NITEM
      IF (ITEMS(2,I) .GT. 0) GO TO 15
      NITEMS = NITEMS + 1
      ITMS(NITEMS) = ITEMS(1,I)
   15 CONTINUE
      GO TO 70
   20 IF (TYPE(1) .NE. MATRIC) GO TO 50
      NITEMS = 0
      DO 30 I = 1,NITEM
      IF (ITEMS(2,I) .LE. 0) GO TO 30
      NITEMS = NITEMS + 1
      ITMS(NITEMS) = ITEMS(1,I)
   30 CONTINUE
      GO TO 70
   50 IF (TYPE(1) .NE. PHASE3) GO TO 60
      NITEMS = 0
      DO 55 I = 1,NITEM
      IF (ANDF(ITEMS(7,I),8) .EQ. 0) GO TO 55
      NITEMS = NITEMS + 1
      ITMS(NITEMS) = ITEMS(1,I)
   55 CONTINUE
      GO TO 70
   60 NITEMS  = 2
      ITMS(1) = TYPE(1)
      ITMS(2) = TYPE(2)
      IF (ITMS(2) .EQ. BLANK) NITEMS = 1
C
C     PUT NAMES OF ALL SUBSTRUCTURES TO BE COPIED AT TOP OF OPEN CORE
C
   70 NSS = 0
      IF (NAMES(1).EQ.WHOLE(1) .AND. NAMES(2).EQ.WHOLE(2)) GO TO 90
      DO 80 I = 1,9,2
      IF (NAMES(I) .EQ. XXXX) GO TO 80
      NSS = NSS + 1
      IF (2*NSS .GT. NCORE) GO TO 9008
      Z(2*NSS-1) = NAMES(I  )
      Z(2*NSS  ) = NAMES(I+1)
   80 CONTINUE
      GO TO 110
   90 N = DITSIZ/2
      DO 100 I = 1,N
      CALL FDIT (I,J)
      IF (COR(J) .EQ. BLANK) GO TO 100
      NSS = NSS + 1
      IF (2*NSS .GT. NCORE) GO TO 9008
      Z(2*NSS-1) = COR(J)
      Z(2*NSS  ) = COR(J+1)
  100 CONTINUE
  110 ICORE  = 2*NSS + 3
      LCORE  = NCORE - ICORE + 1
      IDPCOR = ICORE/2 + 1
      CALL PAGE
C
C     WRITE OUT DIT AND MDI CONTROL WORDS
C
      N = DITSIZ/2
      IF (6*N .GT. LCORE) GO TO 9008
      HDR(1) = BDIT
      HDR(2) = BLANK
      HDR(3) = BLANK
      HDR(4) = 2
      HDR(5) = DITSIZ
      HDR(6) = SP
      HDR(7) = EOG
      CALL EXFORT (SWRT,UNIT,JH,HDR,7,SP,0)
      DO 112 I = 1,N
      CALL FDIT (I,J)
      Z(ICORE+2*I-2) = COR(J)
      Z(ICORE+2*I-1) = COR(J+1)
  112 CONTINUE
      CALL EXFORT (SWRT,UNIT,2,Z(ICORE),DITSIZ,SP,0)
      HDR(1) = BMDI
      HDR(4) = 10
      HDR(5) = 6*N
      HDR(7) = EOI
      CALL EXFORT (SWRT,UNIT,JH,HDR,7,SP,0)
      K = ICORE
      DO 114 I = 1,N
      CALL FMDI (I,J)
      Z(K  ) = RSHIFT(COR(J+1),20)
      Z(K+1) = ANDF(RSHIFT(COR(J+1),10),1023)
      Z(K+2) = ANDF(COR(J+1),1023)
      Z(K+3) = ANDF(RSHIFT(COR(J+2),20),1023)
      Z(K+4) = ANDF(RSHIFT(COR(J+2),10),1023)
      Z(K+5) = ANDF(COR(J+2),1023)
      K = K + 6
  114 CONTINUE
      CALL EXFORT (SWRT,UNIT,10,Z(ICORE),6*N,SP,0)
C
C     LOOP OVER ALL SUBSTRUCTURES AND ITEMS, COPYING EACH ONE TO THE
C     EXTERNAL FILE
C
      DO 1000 ISS = 1,NSS
      HDR(1) = Z(2*ISS-1)
      HDR(2) = Z(2*ISS)
      DO 990 ITEM = 1,NITEMS
      HDR(3) = ITMS(ITEM)
      ITM = ITTYPE (ITMS(ITEM))
      IF (ITM .EQ. 1) GO TO 800
      CALL SFETCH (HDR,HDR(3),SRD,RC)
      GO TO (140,120,990,120,120), RC
  120 LINE = LINE + 2
      IF (LINE .GT. NLPP) CALL PAGE
      IF (RC .GT. 3) GO TO 130
      WRITE (NOUT,6340) UWM,(HDR(I),I=1,3)
      GO TO 990
  130 CALL SMSG (RC-2,HDR(3),HDR)
      GO TO 990
  140 CALL SUREAD (Z(ICORE),LCORE,NWDS,RC)
      IF (RC .NE. 2) GO TO 9008
C
      IF (ITMS(ITEM) .EQ. EQSS) GO TO 200
      IF (ITMS(ITEM) .EQ. BGSS) GO TO 300
      IF (ITMS(ITEM) .EQ. CSTM) GO TO 400
      IF (ITMS(ITEM) .EQ. LODS) GO TO 500
      IF (ITMS(ITEM) .EQ. LOAP) GO TO 500
      IF (ITMS(ITEM) .EQ. PLTS) GO TO 600
      IF (ITMS(ITEM) .EQ. SOLN) GO TO 700
      IF (ITMS(ITEM) .EQ. LAMS) GO TO 700
      GO TO 1100
C
C     EQSS
C
C     GROUP 0
C
  200 N  = NWDS
      NS = Z(ICORE+2)
      IF (NS .GT. 13) N = 30
      HDR(4) = 3
      HDR(5) = N
      HDR(6) = SP
      HDR(7) = EOG
      IF (N .LT. NWDS) HDR(7) = MORE
      CALL EXFORT (SWRT,UNIT,JH,HDR,7,SP,0)
      CALL EXFORT (SWRT,UNIT,3,Z(ICORE),N,SP,0)
      IF (N .EQ. NWDS) GO TO 210
      HDR(4) = 2
      HDR(5) = NWDS - N
      HDR(7) = EOG
      CALL EXFORT (SWRT,UNIT,JH,HDR,7,SP,0)
      CALL EXFORT (SWRT,UNIT,2,Z(ICORE+N),NWDS-N,SP,0)
C
C     GROUPS 1 TO NS + 1
C
  210 HDR(4) = 10
      NS = NS + 1
      DO 220 J = 1,NS
      CALL SUREAD (Z(ICORE),LCORE,NWDS,RC)
      IF (RC .NE. 2) GO TO 9008
      HDR(5) = NWDS
      IF (J .EQ. NS) HDR(7) = EOI
      CALL EXFORT (SWRT,UNIT,JH,HDR,7,SP,0)
      CALL EXFORT (SWRT,UNIT,10,Z(ICORE),NWDS,SP,0)
  220 CONTINUE
      GO TO 900
C
C     BGSS
C
C     GROUP 0
C
  300 HDR(4) = 3
      HDR(5) = 3
      HDR(6) = SP
      HDR(7) = EOG
      CALL EXFORT (SWRT,UNIT,JH,HDR,7,SP,0)
      CALL EXFORT (SWRT,UNIT,3,Z(ICORE),3,SP,0)
C
C     GROUP 1
C
      CALL SUREAD (Z(ICORE),LCORE,NWDS,RC)
      IF (RC .NE. 2) GO TO 9008
      HDR(4) = 6
      HDR(5) = NWDS
      HDR(7) = EOI
      CALL EXFORT (SWRT,UNIT,JH,HDR,7,SP,0)
      CALL EXFORT (SWRT,UNIT,6,Z(ICORE),NWDS,SP,0)
      GO TO 900
C
C     CSTM
C
C     GROUP 0
C
  400 HDR(4) = 3
      HDR(5) = 2
      HDR(6) = SP
      HDR(7) = EOG
      CALL EXFORT (SWRT,UNIT,JH,HDR,7,SP,0)
      CALL EXFORT (SWRT,UNIT,3,Z(ICORE),2,SP,0)
C
C     GROUP 1
C
      IF (ICORE+13 .GT. NCORE) GO TO 9008
  420 CALL SUREAD (Z(ICORE),14,NWDS,RC)
      IF (RC .EQ. 2) GO TO 430
      HDR(4) = 8
      HDR(5) = 4
      HDR(7) = MORE
      CALL EXFORT (SWRT,UNIT,JH,HDR,7,SP,0)
      CALL EXFORT (SWRT,UNIT,8,Z(ICORE),4,SP,0)
      HDR(4) = 9
      HDR(5) = 10
      CALL EXFORT (SWRT,UNIT,JH,HDR,7,SP,0)
      CALL EXFORT (SWRT,UNIT,9,Z(ICORE+4),10,SP,0)
      GO TO 420
  430 HDR(5) = 0
      HDR(7) = EOG
      CALL EXFORT (SWRT,UNIT,JH,HDR,7,SP,0)
      HDR(4) = 0
      HDR(7) = EOI
      CALL EXFORT (SWRT,UNIT,JH,HDR,7,SP,0)
      GO TO 900
C
C     LODS AND LOAP
C
C     GROUP 0
C
  500 N  = NWDS
      NS = Z(ICORE+3)
      IF (NS .GT. 13) N = 30
      HDR(4) = 3
      HDR(5) = N
      HDR(6) = SP
      HDR(7) = EOG
      IF (N .LT. NWDS) HDR(7) = MORE
      CALL EXFORT (SWRT,UNIT,JH,HDR,7,SP,0)
      CALL EXFORT (SWRT,UNIT,3,Z(ICORE),N,SP,0)
      IF (N .EQ. NWDS) GO TO 510
      HDR(4) = 2
      HDR(5) = NWDS -  N
      HDR(7) = EOG
      CALL EXFORT (SWRT,UNIT,JH,HDR,7,SP,0)
      CALL EXFORT (SWRT,UNIT,2,Z(ICORE+N),NWDS-N,SP,0)
C
C     GROUP 1 TO NS
C
  510 HDR(4) = 10
      DO 520 J = 1,NS
      CALL SUREAD (Z(ICORE),LCORE,NWDS,RC)
      IF (RC .NE. 2) GO TO 9008
      HDR(5) = NWDS
      IF (J .EQ. NS) HDR(7) = EOI
      CALL EXFORT (SWRT,UNIT,JH,HDR,7,SP,0)
      CALL EXFORT (SWRT,UNIT,10,Z(ICORE),NWDS,SP,0)
  520 CONTINUE
      GO TO 900
C
C     PLTS
C
C     GROUP 0
C
  600 N  = NWDS
      NS = Z(ICORE+2)
      HDR(6) = SP
      HDR(4) = 3
      HDR(5) = 3
      HDR(7) = MORE
      CALL EXFORT (SWRT,UNIT,JH,HDR,7,SP,0)
      CALL EXFORT (SWRT,UNIT,3,Z(ICORE),3,SP,0)
      DO 620 J = 1,NS
      HDR(4) = 13
      HDR(5) = 4
      CALL EXFORT (SWRT,UNIT,JH,HDR,7,SP,0)
      CALL EXFORT (SWRT,UNIT,13,Z(ICORE+14*J-11),4,SP,0)
      HDR(4) = 9
      HDR(5) = 10
      IF (J .EQ. NS) HDR(7) = EOG
      CALL EXFORT (SWRT,UNIT,JH,HDR,7,SP,0)
      CALL EXFORT (SWRT,UNIT,9,Z(ICORE+14*J-7),10,SP,0)
  620 CONTINUE
C
C     GROUP 1 -- BGPDT
C
      CALL SUREAD (Z(ICORE),LCORE,NWDS,RC)
      IF (RC .EQ. 3) GO TO 680
      IF (RC .NE. 2) GO TO 9008
      HDR(4) = 6
      HDR(5) = NWDS
      CALL EXFORT (SWRT,UNIT,JH,HDR,7,SP,0)
      CALL EXFORT (SWRT,UNIT,6,Z(ICORE),NWDS,SP,0)
C
C     GROUP 2 -- EQEXIN
C
      CALL SUREAD (Z(ICORE),LCORE,NWDS,RC)
      IF (RC .NE. 2) GO TO 9008
      HDR(4) = 10
      HDR(5) = NWDS
      CALL EXFORT (SWRT,UNIT,JH,HDR,7,SP,0)
      CALL EXFORT (SWRT,UNIT,10,Z(ICORE),NWDS,SP,0)
C
C     GROUP 3 -- GPSETS
C
      CALL SUREAD (Z(ICORE),LCORE,NWDS,RC)
      IF (RC .NE. 2) GO TO 9008
      HDR(4) = 10
      HDR(5) = NWDS
      CALL EXFORT (SWRT,UNIT,JH,HDR,7,SP,0)
      CALL EXFORT (SWRT,UNIT,10,Z(ICORE),NWDS,SP,0)
C
C     GROUP 4 -- ELSETS
C
C     OUTPUT CHANGES MADE BY G.CHAN/UNISYS   4/91
C
C     IN 90 AND EARLIER VERSIONS, ONLY ONE ELEMENT PLOT SYMBOL WORD WAS
C     WRITTEN OUT USING FORMAT 2, AND ON NEXT ELSETS DATA LINE, FORMAT
C     10 WAS USED FOR ALL ELEMENTS. NO OFFSET DATA WAS PROVIDED FOR THE
C     BAR, QUAD4 AND TRIA3 ELEMENTS. THE NO. OF GRID POINT PER ELEMENT,
C     NGPEL, WAS THE FIRST WORD ON THE ELSETS DATA LINE.  (LINE=RECORD)
C     ALSO, THE 90 AND EARLIER VERSIONS DID NOT COUNT PROPERTY ID, PID,
C     ON THE ELSETS DATA LINE. THUS THE TOTAL NO. OF WORDS MAY BE IN
C     ERROR AND MAY CAUSE EXTRA ZEROS TO APPEAR AT THE END OF THE LINE.
C
C     IN 91 VERSION, ELEMENT PLOT SYMBOL LINE HAS 2 WORDS, SYMBOL AND
C     NGPEL, AND FORMAT 25 IS USED. ON NEXT ELSETS DATA LINE, FORMAT 10
C     IS USED FOR ALL ELEMENTS WITH NO OFFSETS. FORMAT 26 IS USED FOR
C     THE BAR WHICH HAS 6 OFFSET VALUES, AND FORMATS 27 AND 28 ARE USED
C     FOR TRIA3 AND QUAD4 WHICH HAVE 1 OFFSET VALUE EACH. NOTE THAT
C     NGPEL HAS BEEN MOVED, AND IS NO LONGER THE FIRST WORD ON THE
C     ELSETS DATA LINE.
C
      HDR(7) = MORE
C
C     READ PLOT SYMBOL, AND NO. OF GRID POINTS PER ELEMENT
C     SET UP NO. OF OFFSET DATA FOR BAR, QUAD4 AND TRIA3
C
  640 CALL SUREAD (Z(ICORE),2,NWDS,RC)
      IF (RC .GE. 2) GO TO 670
      HDR(4) = 25
      HDR(5) = 2
      NGPEL  = Z(ICORE+1)
      ELTYPE = Z(ICORE  )
      OFFSET = 0
      IF (ELTYPE .EQ. BAR) OFFSET = 6
      IF (ELTYPE.EQ.Q4 .OR. ELTYPE.EQ.T3) OFFSET = 1
      CALL EXFORT (SWRT,UNIT,JH,HDR,7,SP,0)
      CALL EXFORT (SWRT,UNIT,25,Z(ICORE),2,SP,0)
C
C     READ ELEMENT ID NUMBER, PROPERTY ID, GRID POINT CONNECTION INDICES
C     AND OFFSETS IF THEY EXIST
C     (ERROR IN 90 AND EARLIER VERSIONS, PROPERTY ID WAS LEFT OUT, AND
C     THEREFORE DATA COUNT PER ELEMENT WAS INCORRECT)
C
      N = ICORE - NGPEL - 2 - OFFSET
  650 N = N     + NGPEL + 2 + OFFSET
      IF (N .GT. NCORE) GO TO 9008
      CALL SUREAD (Z(N),1,NWDS,RC)
      IF (Z(N) .EQ. 0) GO TO 655
      IF (N+NGPEL+2+OFFSET .GT. NCORE) GO TO 9008
      CALL SUREAD (Z(N+1),NGPEL+1,NWDS,RC)
      IF (OFFSET .NE. 0) CALL SUREAD (Z(N+NGPEL+2),OFFSET,NWDS,RC)
      GO TO (650,6100,6100), RC
C
C     ALL ELEMENTS OF ONE TYPE READ INTO CORE, NOW COPY OUT
C
  655 HDR(5) = N - ICORE + 1
      IF (OFFSET-1) 660,  661,  663
C               REGULAR  QUAD4  BAR
C               ELEMENT  TRIA3
C
  660 HDR(4) = 10
      GO TO 665
  661 HDR(4) = 27
      IF (ELTYPE .EQ. Q4) HDR(4) = 28
      GO TO 665
  663 HDR(4) = 26
  665 CALL EXFORT (SWRT,UNIT,JH,HDR,7,SP,0)
      CALL EXFORT (SWRT,UNIT,HDR(4),Z(ICORE),HDR(5),SP,0)
      GO TO 640
C
C     WRITE END-OF-ITEM FOR PLTS
C
  670 HDR(5) = 0
      HDR(7) = EOG
      CALL EXFORT (SWRT,UNIT,JH,HDR,7,SP,0)
  680 HDR(4) = 0
      HDR(5) = 0
      HDR(7) = EOI
      CALL EXFORT (SWRT,UNIT,JH,HDR,7,SP,0)
      GO TO 900
C
C     SOLN AND LAMS
C
  700 IRFNO = Z(ICORE+2)
      IF (IRFNO .EQ. 1) GO TO 715
      IF (IRFNO .EQ. 2) GO TO 715
      IF (IRFNO .EQ. 3) GO TO 730
      IF (IRFNO .EQ. 8) GO TO 750
      IF (IRFNO .EQ. 9) GO TO 750
      LINE = LINE + 2
      IF (LINE .GT. NLPP) CALL PAGE
      WRITE (NOUT,6358) SWM,IRFNO,HDR(1),HDR(2)
      GO TO 900
C
C     GROUP 0 -- STATICS
C
  715 N  = NWDS
      NS = Z(ICORE+3)
      IF (NS .GT. 6) N = 23
      NS = Z(ICORE+4)
      HDR(4) = 16
      HDR(5) = N
      HDR(6) = SP
      HDR(7) = EOG
      IF (N .LT. NWDS) HDR(7) = MORE
      CALL EXFORT (SWRT,UNIT,JH,HDR,7,SP,0)
      CALL EXFORT (SWRT,UNIT,16,Z(ICORE),N,SP,0)
      IF (N .EQ. NWDS) GO TO 710
      HDR(4) = 17
      HDR(5) = NWDS - N
      HDR(7) = EOG
      CALL EXFORT (SWRT,UNIT,JH,HDR,7,SP,0)
      CALL EXFORT (SWRT,UNIT,17,Z(ICORE+N),NWDS-N,SP,0)
C
C     GROUPS 1 TO NS (ONE PER SUBCASE) -- STATICS
C
  710 DO 720 J = 1,NS
      CALL SUREAD (Z(ICORE),LCORE,NWDS,RC)
      IF (RC .NE. 2) GO TO 9008
      N = NWDS
      IF (Z(ICORE) .GT. 5) N = 11
      HDR(4) = 18
      HDR(5) = N
      HDR(7) = EOG
      IF (J .EQ. NS) HDR(7) = EOI
      IF (N .LT. NWDS) HDR(7) = MORE
      CALL EXFORT (SWRT,UNIT,JH,HDR,7,SP,0)
      CALL EXFORT (SWRT,UNIT,18,Z(ICORE),N,SP,0)
      IF (N .EQ. NWDS) GO TO 720
      HDR(4) = 19
      HDR(5) = NWDS - N
      HDR(7) = EOG
      IF (J .EQ. NS) HDR(7) = EOI
      CALL EXFORT (SWRT,UNIT,JH,HDR,7,SP,0)
      CALL EXFORT (SWRT,UNIT,19,Z(ICORE+N),NWDS-N,SP,0)
  720 CONTINUE
      GO TO 900
C
C     GROUP 0 -- NORMAL MODES (REAL OR COMPLEX)
C
  730 NS = Z(ICORE+3)
      HDR(4) = 3
      HDR(5) = 4
      HDR(6) = SP
      HDR(7) = EOG
      IF (NS .LE. 0) HDR(7) = EOI
      CALL EXFORT (SWRT,UNIT,JH,HDR,7,SP,0)
      CALL EXFORT (SWRT,UNIT,3,Z(ICORE),4,SP,0)
      IF (NS .LE. 0) GO TO 900
C
C     GROUP 1 -- NORMAL MODES
C
      CALL SUREAD (Z(ICORE),LCORE,NWDS,RC)
      IF (RC .NE. 2) GO TO 9008
      HDR(4) = 20
      HDR(5) = NWDS
      HDR(7) = EOI
      IF (ITMS(ITEM) .EQ. LAMS) HDR(7) = EOG
      CALL EXFORT (SWRT,UNIT,JH,HDR,7,SP,0)
      CALL EXFORT (SWRT,UNIT,20,Z(ICORE),NWDS,SP,0)
      IF (ITMS(ITEM) .NE. LAMS) GO TO 900
C
C     GROUP 2 -- NORMAL MODES (LAMS ITEM ONLY)
C
      CALL SUREAD (Z(ICORE),LCORE,NWDS,RC)
      IF (RC .NE. 2) GO TO 9008
      HDR(4) = 10
      HDR(5) = NWDS
      HDR(7) = EOI
      CALL EXFORT (SWRT,UNIT,JH,HDR,7,SP,0)
      CALL EXFORT (SWRT,UNIT,10,Z(ICORE),NWDS,SP,0)
      GO TO 900
C
C     GROUP 0 -- DYNAMICS
C
  750 NS    = Z(ICORE+3)
      NWDS0 = 3*NS + 5
      N     = NWDS0
      IF (NS .GT. 6) N = 23
      NS    = Z(ICORE+4) + 1
      IF (Z(ICORE+NWDS0) .EQ. 0) NS = 1
      HDR(4) = 16
      HDR(5) = N
      HDR(6) = SP
      HDR(7) = MORE
      CALL EXFORT (SWRT,UNIT,JH,HDR,7,SP,0)
      CALL EXFORT (SWRT,UNIT,16,Z(ICORE),N,SP,0)
      IF (N .EQ. NWDS0) GO TO 760
      HDR(4) = 17
      HDR(5) = NWDS0 - N
      CALL EXFORT (SWRT,UNIT,JH,HDR,7,SP,0)
      CALL EXFORT (SWRT,UNIT,17,Z(ICORE+N),NWDS0-N,SP,0)
  760 HDR(4) = 10
      HDR(5) = NWDS - NWDS0
      HDR(7) = EOG
      CALL EXFORT (SWRT,UNIT,JH,HDR,7,SP,0)
      CALL EXFORT (SWRT,UNIT,10,Z(ICORE+NWDS0),NWDS-NWDS0,SP,0)
C
C     GROUP 1 TO NS+1 -- DYNAMICS
C
      DO 770 J = 1,NS
      CALL SUREAD (Z(ICORE),LCORE,NWDS,RC)
      IF (RC .NE. 2) GO TO 9008
      HDR(4) = 9
      HDR(5) = NWDS
      HDR(7) = EOG
      IF (J .EQ. NS) HDR(7) = EOI
      CALL EXFORT (SWRT,UNIT,JH,HDR,7,SP,0)
      CALL EXFORT (SWRT,UNIT,9,Z(ICORE),NWDS,SP,0)
  770 CONTINUE
      GO TO 900
C
C     UNKNOWN TABLE ITME
C
 1100 LINE = LINE + 2
      IF (LINE .GT. NLPP) CALL PAGE
      WRITE (NOUT,6360) SWM,ITMS(ITEM)
      GO TO 990
C
C     MATRICES
C
C     ON CDC MACHINE (NOT ANY 64-BIT MACHINE), FORCE ALL MATRIX DATA TO
C     BE DOUBLE PRECISION SO THE EXTRA DIGITS WONT BE LOST GOING TO
C     OTHER MACHINES
C
C     GROUP 0 -- MATRIX TRAILER
C
  800 CALL SOFTRL (HDR,HDR(3),Z(ICORE-1))
      RC = Z(ICORE-1)
      GO TO (805,120,990,120,120), RC
  805 TYPOUT = Z(ICORE+3)
      IF (MACH.EQ.4 .AND. PRC(TYPOUT).EQ.1) TYPOUT = TYPOUT + 1
      Z(ICORE+3) = TYPOUT
      NCOL   = Z(ICORE)
      HDR(4) = 10
      HDR(5) = 6
      HDR(6) = SP
      HDR(7) = EOG
      CALL EXFORT (SWRT,UNIT,JH,HDR,7,SP,0)
      CALL EXFORT (SWRT,UNIT,10,Z(ICORE),6,SP,0)
C
C     MOVE MATRIX TO SCR2
C
      CALL MTRXI (SCR1,HDR,HDR(3),Z(BUF4),RC)
      CALL GOPEN (SCR1,Z(BUF4),RDREW)
C
C     COPY MATRIX OUT ONE COLUMN AT A TIME, NON-ZEROES ONLY.
C
C                        ROW NO.  +
C                        VALUE     +
C                        ROW NO.    +
C                        VALUE       I  FORMAT OF ONE MATRIX
C                          .         I  COLUMN ON THE EXTERNAL
C                          .         I  FILE.
C                          .        +
C                        -1        +
C                        0.0      +
C
      HDR(4) = 20 + TYPOUT
      HDR(6) = TYPOUT
      IPRC   = PRC(TYPOUT)
      N  = NWORD(TYPOUT) + IPRC
      N2 = NWORD(TYPOUT) + 1
      DO 830 J = 1,NCOL
      NWDS = 0
      K  = ICORE
      CALL INTPK (*820,SCR1,0,TYPOUT,0)
  810 CALL ZNTPKI
      Z(K     ) = IROW
      Z(K+IPRC) = A(1)
      IF (TYPOUT .EQ. 1) GO TO 815
      Z(K+IPRC+1) = A(2)
      IF (TYPOUT .LE. 3) GO TO 815
      Z(K+4) = A(3)
      Z(K+5) = A(4)
  815 NWDS = NWDS + N2
      K = K + N
      IF (K+N .GT. NCORE) GO TO 9008
      IF (EOL .EQ.     0) GO TO 810
  820 Z(K) = -1
      Z(K+IPRC  ) = 0
      Z(K+IPRC+1) = 0
      Z(K+4) = 0
      Z(K+5) = 0
      NWDS   = NWDS + N2
      HDR(5) = NWDS
      IF (J .EQ. NCOL) HDR(7) = EOI
      CALL EXFORT (SWRT,UNIT,JH,HDR,7,SP,0)
      CALL EXFORT (SWRT,UNIT,20+TYPOUT,Z(ICORE),NWDS,TYPOUT,DZ(IDPCOR))
  830 CONTINUE
      CALL CLOSE (SCR1,REW)
C
C     WRITE USER MESSAGE FOR SUCCESSFUL COPY
C
  900 LINE = LINE + 1
      IF (LINE .GT. NLPP) CALL PAGE
      WRITE (NOUT,6357) UIM,HDR(1),HDR(2),HDR(3),SOF,UNAME
  990 CONTINUE
 1000 CONTINUE
C
C     NORMAL MODULE COMPLETION.  WRITE LOGICAL EOF
C
      CALL EXFORT (4,UNIT,0,0,1,0,0)
      CALL SOFCLS
      RETURN
C
C     ABNORMAL MODULE COMPLETION
C
 6100 CALL SMSG (RC+4,ITMS(ITEM),HDR)
      GO TO 9100
 9008 CALL MESAGE (8,0,SUBR)
 9100 DRY = -2
      CALL SOFCLS
      RETURN
C
C     MESSAGE TEXT
C
 6340 FORMAT (A25,' 6340, SUBSTRUCTURE ',2A4,' ITEM ',A4, /5X,
     1        ' PSEUDO-EXISTS ONLY AND CANNOT BE COPIED OUT BY EXIO.')
 6357 FORMAT (A29,' 6357, SUBSTRUCTURE ',2A4,' ITEM ',A4,
     1        ' SUCCESSFULLY COPIED FROM ',A4,' TO ',2A4)
 6358 FORMAT (A27,' 6358, ILLEGAL RIGID FORMAT NUMBER ',I5,
     1        ' IN SOLN ITEM FOR SUBSTRUCTURE ',2A4,1H.,
     2        /34X,'THE ITEM WILL NOT BE COPIED.')
 6360 FORMAT (A27,' 6360, SOFOUT (EXTERNAL) ENCOUNTERS A UNSUPPORTED ',
     1        'TABLE ITEM ',A4, /35X,'THE ITEM WILL NOT BE COPIED.')
      END

      SUBROUTINE REDUCE
C
C     REDUCE BUILDS THE FOLLOWING DATA BLOCKS
C
C     1.  PVX  -  THE REDUCTION PARTITIONING VECTOR
C     2.  USX  -  THE USET EQUIVALENT VECTOR
C     3.  INX  -  THE REDUCTION TRANSFORMATION IDENTITY PARTITION
C
C     THE FOLLOWING BULK DATA CARDS ARE READ
C
C     1.  BDYC
C     2.  BDYS
C     3.  BDYS1
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        LSHIFT,RSHIFT,ANDF,ORF
      LOGICAL         INBSET,FSET,BAD,LONLY
      REAL            RZ(1)
      DIMENSION       MODNAM(2),IJK(6),IHD(96),BDYS(2),BDYS1(2),
     1                BDYC(2),MNEM(4),NAMOLD(14),NAMNEW(2),ARAY(6),
     2                ISID(100),CSET(6),IPSET(6),LISTO(32),LISTN(32),
     3                MCB(7),IBITS(6)
      CHARACTER       UFM*23,UWM*25,UIM*29
      COMMON /XMSSG / UFM,UWM,UIM
      COMMON /ZZZZZZ/ Z(1)
      COMMON /PACKX / TYPIN,TYPOUT,IROW,NROW,INCR
      COMMON /SYSTEM/ SYSBUF,OUTT,X1(6),NLPP,X2(2),LINE,X3(2),IDATE(3)
      COMMON /OUTPUT/ ITITL(96),IHEAD(96)
      COMMON /CMBFND/ IINAM(2),IIIERR
      COMMON /TWO   / TPOW(32)
      COMMON /BLANK / STEP,DRY,PORA
      EQUIVALENCE     (RZ(1),Z(1) )
      DATA    IHD   / 4H    , 8*4H****,
     1        4H S U, 4H B S, 4H T R, 4H U C, 4H T U, 4H R E, 4H    ,
     2        4HM O , 4HD U , 4HL E , 4H   R, 4H E D, 4H U C, 4H E *,
     3        9*4H**** , 64*4H      /
      DATA    NHEQSS, NHBGSS,NHCSTM,NHPLTS/4HEQSS,4HBGSS,4HCSTM,4HPLTS/
      DATA    MODNAM/ 4HREDU,4HCE   /
      DATA    PAPP  , LODS, LOAP    /4HPAPP,4HLODS,4HLOAP/
C     --------------------
C     CODES TO LOCATE BULK DATA
C     --------------------
      DATA    BDYC/ 910,9 / , BDYS/ 1210,12 / , BDYS1/ 1310,13 /
C     --------------------
C     CASE CONTROL MNEMONICS
C     --------------------
      DATA    MNEM/ 4HNAMA , 4HNAMB , 4HBOUN , 4HOUTP /
C     --------------------
C     GINO FILES FOR DATA BLOCKS AND SCRATCH
C     --------------------
      DATA    CASECC/ 101 / , GEOM4/ 102 /
      DATA    PVX   / 201 / , USX  / 202 / , INX/ 203 /
      DATA    SCR1  / 301 / , SCR2 / 302 / , I3 / 3   /
C
C
C     I.  COMPUTE OPEN CORE AND DEFINE GINO AND SOF BUFFERS
C     *****************************************************
C
      IF (DRY .EQ. -2) RETURN
      IBA = 128
      IBO = 4
      IBF = 64
      NZWD= KORSZ(Z(1))
      IF (NZWD .LE. 0 ) CALL MESAGE (-8,0,MODNAM)
C
      LONLY= .FALSE.
      BUF1 = NZWD - SYSBUF - 2
      BUF2 = BUF1 - SYSBUF
      BUF3 = BUF2 - SYSBUF
      IB1  = BUF3 - SYSBUF
      IB2  = IB1  - SYSBUF
      IB3  = IB2  - SYSBUF
C
C     SCORE IS STARTING ADDRESS OF OPEN CORE AND NZ THE LENGTH
C
      SCORE = 1
      NZ = IB3 - 1
C
C     INITIALIZE ACTIVITY ON THE SOF
C
      LITM = LODS
      IF (PORA .EQ. PAPP) LITM = LOAP
      CALL SOFOPN (Z(IB1),Z(IB2),Z(IB3))
      DO 2111 I = 1,96
      IHEAD(I) = IHD(I)
 2111 CONTINUE
C
C     II.  PROCESS THE CASE CONTROL DATA BLOCK ( CASECC )
C     ***************************************************
C
      DO 260 I = 1,14
      NAMOLD(I) = 0
  260 CONTINUE
      IFILE = CASECC
      CALL OPEN (*2001,CASECC,Z(BUF2),0)
      PRTOPT = 0
      NREC = STEP
      IF (NREC) 200,201,200
  200 DO 202 I = 1,NREC
      CALL FWDREC (*2002,CASECC)
  202 CONTINUE
C
C     BEGIN READING CASECC
C
  201 INBSET = .FALSE.
      CALL READ (*2002,*2003,CASECC,Z(1),2,0,NNN)
      NWDSCC = Z(I3-1)
      DO 203 I = 1,NWDSCC,3
      CALL READ (*2002,*2003,CASECC,Z(1),3,0,NNN)
C
C     CHECK FOR CASE CONTROL MNEMONICS
C
      DO 204 J = 1,4
      IF (Z(1) .EQ. MNEM(J)) GO TO 205
  204 CONTINUE
      GO TO 203
  205 GO TO (206,207,208,209), J
  206 NAMOLD(1) = Z(I3-1)
      NAMOLD(2) = Z(I3  )
      GO TO 203
  207 NAMNEW(1) = Z(I3-1)
      NAMNEW(2) = Z(I3  )
      GO TO 203
  208 INBSET = .TRUE.
      BSET = Z(I3)
      GO TO 203
  209 PRTOPT = ORF(PRTOPT,Z(I3))
  203 CONTINUE
      IF (DRY .EQ. 0) PRTOPT = 0
      IF (ANDF(PRTOPT,1) .NE. 1) GO TO 2199
      CALL PAGE1
      WRITE  (OUTT,280) (NAMOLD(I),I=1,2),NAMNEW,BSET,(NAMOLD(I),I=1,2)
  280 FORMAT (//41X,'S U M M A R Y    O F    C U R R E N T    P R O ',
     1       'B L E M', //43X,
     2       'NAME OF PSEUDOSTRUCTURE TO BE REDUCED    - ',2A4, //43X,
     3       'NAME GIVEN TO RESULTANT PSEUDOSTRUCTURE  - ',2A4, //43X,
     4       'BOUNDARY SET IDENTIFICATION NUMBER       - ',I8,  //43X,
     5       'NAMES OF COMPONENT SUBSTRUCTURES CONTAINED IN ',2A4/)
 2199 CONTINUE
      CALL CLOSE (CASECC,1)
C
C     CHECK FOR ALLOWABILITY OF INPUT
C
      BAD = .FALSE.
      CALL SFETCH (NAMOLD,NHEQSS,3,ITEST)
      IF (ITEST .EQ. 4) GO TO 290
  261 CALL SFETCH (NAMNEW,NHEQSS,3,ITEST)
      IF (ITEST.NE.4 .AND. DRY.NE.0) GO TO 291
      IF (ITEST.EQ.4 .AND. DRY.EQ.0) GO TO 297
  262 IF (.NOT.INBSET) GO TO 292
  263 IF (.NOT.BAD) GO TO 300
      GO TO 2100
C
C     IF NO ERRORS, CONTINUE PROCESSING
C
C
  290 WRITE (OUTT,293) UFM,(NAMOLD(I),I=1,2)
      BAD = .TRUE.
      GO TO 261
  291 CALL SFETCH (NAMNEW,LITM,3,ITEST)
      IF (ITEST .NE. 3) GO TO 296
      LONLY = .TRUE.
      GO TO 300
  296 CONTINUE
      WRITE (OUTT,294) UFM,(NAMNEW(I),I=1,2)
      BAD = .TRUE.
      GO TO 262
  292 WRITE (OUTT,295) UFM
      BAD = .TRUE.
      GO TO 263
  297 WRITE  (OUTT,298) UFM,NAMNEW
  298 FORMAT (A23,' 6613, FOR RUN=GO, THE REDUCED SUBSTRUCTURE ',2A4,
     1       ' MUST ALREADY EXIST.')
      BAD = .TRUE.
      GO TO 262
  293 FORMAT (A23,' 6601, REQUEST TO REDUCE PSEUDOSTRUCTURE ',2A4,
     1       ' INVALID. DOES NOT EXIST ON THE SOF.')
  294 FORMAT (A23,' 6602, THE NAME ',2A4,' CAN NOT BE USED FOR THE ',
     1       'REDUCED PSEUDOSTRUCTURE. IT ALREADY EXISTS ON THE SOF.')
  295 FORMAT (A23,' 6603, A BOUNDARY SET MUST BE SPECIFIED FOR A ',
     1       'REDUCE OPERATION.')
C
C     READ FIRST GROUP OF EQSS FOR THE STRUCTURE BEING REDUCED,
C     PLACE THE NAMES OF THE COMPONENT SUBSTRUCTURES INTO THE
C     FIRST NWDS WORDS OF OPEN CORE.
C
  300 KS1 = SCORE
      CALL SFETCH (NAMOLD,NHEQSS,1,ITEST)
      CALL SUREAD (Z(KS1),-1,NOUT,ITEST )
C
C     NCSUB IS THE NUMBER OF COMPONENT SUBSTRUCTURES
C     NIPOLD IS THE NUMBER OF IP S IN THE STRUCTURE BEING REDUCED
C
      NCSUB = Z(KS1+2)
      NOUT  = NOUT - 4
      DO 302 I = 1,NOUT
      II = I - 1
      Z(KS1+II) = Z(KS1+4+II)
  302 CONTINUE
      NWDS = NOUT
      SCORE= KS1 + NWDS
      KF1  = SCORE - 1
      NZ   = NZ - NWDS
      IF (ANDF(PRTOPT,1) .NE. 1) GO TO 282
      WRITE  (OUTT,281) (Z(JJ),JJ=KS1,KF1)
  281 FORMAT (48X,2A4,4X,2A4,4X,2A4,4X,2A4)
  282 CONTINUE
C
C     III. READ BOUNDARY SET ( BDYC ) BULK DATA INTO OPEN CORE FOR
C     THE REQUESTED SET ( BSET ) FROM THE GEOM4 INPUT DATA BLOCK.
C     ************************************************************
C
      KS2   = SCORE
      IFILE = GEOM4
      CALL PRELOC (*2001,Z(BUF1),GEOM4)
      CALL LOCATE (*490,Z(BUF1),BDYC,FLAG)
  401 CALL READ (*2002,*490,GEOM4,ID,1,0,NNN)
      IF (ID .EQ. BSET) GO TO 402
  403 CALL READ (*2002,*2003,GEOM4,ARAY,3,0,NNN)
      IF (ARAY(3) .EQ. -1) GO TO 401
      GO TO 403
C
C     CORRECT BOUNDARY SET HAS BEEN FOUND, STORE DATA IN SECOND NWBS WOR
C     OF OPEN CORE.
C
  402 NWBS = 0
  405 BAD  = .FALSE.
      CALL READ (*2002,*2003,GEOM4,Z(KS2+NWBS),3,0,NNN)
      IF (Z(KS2+NWBS+2) .EQ. -1) GO TO 440
C
C     MUST CHECK THAT THE SUBSTRUCTURE IS A PHASE1 BASIC SUBSTRUCTURE
C     AND THAT IT IS A COMPONENT OF THE STRUCTURE BEING REDUCED.
C
C     CHECK FOR COMPONENT
C
      DO 410 I = 1,NWDS,2
      II = I - 1
      IF (Z(KS1+II).EQ.Z(KS2+NWBS) .AND. Z(KS1+II+1).EQ.Z(KS2+NWBS+1))
     1    GO TO 420
  410 CONTINUE
C
C     NOT A COMPONENT
C
      WRITE (OUTT,491) UFM,Z(KS2+NWBS),Z(KS2+NWBS+1)
      BAD = .TRUE.
  491 FORMAT (A23,' 6604, A BOUNDARY SET HAS BEEN SPECIFIED FOR ',2A4,
     1       ', BUT IT IS NOT A COMPONENT OF THE', /31X,'PSEUDOSTRUC',
     2       'TURE BEING REDUCED. THE BOUNDARY SET WILL BE IGNORED.')
C
  420 IF (BAD) GO TO 405
      NWBS = NWBS + 3
      GO TO 405
  440 SCORE = KS2 + NWBS
      KF2 = SCORE - 1
      NZ  = NZ - NWBS
C
C     SORT ON SET ID
C
      CALL SORT (0,0,3,3,Z(KS2),NWBS)
      IF (ANDF(RSHIFT(PRTOPT,1),1) .NE. 1) GO TO 2299
      II = 0
 2203 CALL PAGE1
      WRITE  (OUTT,2202) BSET
 2202 FORMAT (//44X,'SUMMARY OF COMBINED BOUNDARY SET NUMBER',I9, //55X,
     1       'BASIC',11X,'BOUNDARY', /52X,'SUBSTRUCTURE',8X,'SET ID',
     2       /56X,'NAME',12X,'NUMBER',/)
      LINE = LINE + 7
 2206 LINE = LINE + 1
      IF (LINE .GT. NLPP) GO TO 2203
      WRITE  (OUTT,2205) Z(KS2+II),Z(KS2+II+1),Z(KS2+II+2)
 2205 FORMAT (54X,2A4,9X,I8)
      II = II + 3
      IF (II .GT. NWBS - 3) GO TO 2299
      GO TO 2206
 2299 CONTINUE
      GO TO 500
CWKBR 8/94 ALPHA-VMS  490 WRITE (OUTT,493) IFM,BSET     
  490 WRITE (OUTT,493) UFM,BSET   
      GO TO 2200
  493 FORMAT (A23,' 6606, BOUNDARY SET ,I8,61H SPECIFIED IN CASE ',
     1       'CONTROL HAS NOT BEEN DEFINED BY BULK DATA.')
C
C     IV. READ BDYS BULK DATA PROCESSING ONLY THE SET ID S REFERENCED ON
C     THE BDYC CARD.  IF DATA DOES NOT EXIST, GO TO BDYS1 PROCESSING SEC
C     ******************************************************************
C
  500 J = 0
      IERR = 0
      CALL LOCATE (*580,Z(BUF1),BDYS,FLAG)
  502 CALL READ (*2002,*600,GEOM4,IDHID,1,0,NNN)
C
C     CHECK REQUESTED ID
C
      DO 501 I = KS2,KF2,3
      IF (IDHID .EQ. Z(I+2)) GO TO 503
  501 CONTINUE
  505 CALL READ (*2002,*2003,GEOM4,ARAY,2,0,NNN)
      IF (ARAY(1).NE.-1 .AND. ARAY(2).NE.-1) GO TO 505
      GO TO 502
  503 CALL READ (*2002,*2003,GEOM4,ARAY,2,0,NNN)
      IF (ARAY(1).EQ.-1 .AND. ARAY(2).EQ.-1) GO TO 502
      Z(SCORE+J  ) = IDHID
      Z(SCORE+J+1) = ARAY(1)
      Z(SCORE+J+2) = ARAY(2)
      J = J + 3
      GO TO 503
  580 IERR = IERR + 1
C
C     V. READ BDYS1 BULK DATA AND MERGE WITH BDYS IN OPEN CORE.
C     *********************************************************
C
  600 CALL LOCATE (*620,Z(BUF1),BDYS1,FLAG)
  606 CALL READ (*2002,*602,GEOM4,ARAY(1),2,0,NNN)
C
C     CHECK ID
C
      DO 603 I = KS2,KF2,3
      IF (ARAY(1) .EQ. Z(I+2)) GO TO 604
  603 CONTINUE
  605 CALL READ (*2002,*2003,GEOM4,ARAY(3),1,0,NNN)
      IF (ARAY(3) .NE. -1) GO TO 605
      GO TO 606
  604 CALL READ (*2002,*2003,GEOM4,ARAY(3),1,0,NNN)
      IF (ARAY(3) .EQ. -1) GO TO 606
      Z(SCORE+J  ) = ARAY(1)
      Z(SCORE+J+1) = ARAY(3)
      Z(SCORE+J+2) = ARAY(2)
      J = J + 3
      GO TO 604
  620 IERR = IERR + 1
  602 CALL CLOSE (GEOM4,1)
      IF (IERR .NE. 2) GO TO 650
      WRITE (OUTT,691) UFM,BSET
      GO TO 2200
  691 FORMAT (A23,' 6607, NO BDYS OR BDYS1 BULK DATA HAS BEEN INPUT TO',
     1       ' DEFINE BOUNDARY SET',I8)
C
C     SORT COMPLETE BOUNDARY SET DATA ON SET ID IN OPEN CORE
C
  650 CALL SORT (0,0,3,1,Z(SCORE),J)
C
C     TRANSLATE COMPONENT NUMBER TO BIT PATTERN
C
      IT = SCORE + J - 1
      DO 651 I = SCORE,IT,3
      CALL ENCODE (Z(I+2))
  651 CONTINUE
      IF (ANDF(RSHIFT(PRTOPT,2),1) .NE. 1) GO TO 2399
      IINC = 0
 2303 CALL PAGE1
      WRITE  (OUTT,2302)
 2302 FORMAT (1H0,46X,44HTABLE OF GRID POINTS COMPOSING BOUNDARY SETS, /
     1    /52X,8HBOUNDARY ,/52X , 34H SET ID      GRID POINT       DOF ,
     2    /52X,34H NUMBER      ID  NUMBER       CODE ,/ )
      LINE = LINE + 7
 2305 LINE = LINE + 1
      IF (LINE .GT. NLPP) GO TO 2303
      ICODE = Z(SCORE+IINC+2)
      CALL BITPAT (ICODE, IBITS)
      WRITE (OUTT,2304) Z(SCORE+IINC),Z(SCORE+IINC+1),
     1                  IBITS(1),IBITS(2)
 2304 FORMAT (52X,I8,6X,I8,7X,A4,A2)
      IINC = IINC + 3
      IF (IINC .GT. J-3) GO TO 2399
      GO TO 2305
 2399 CONTINUE
C
C     WRITE BOUNDARY SET DATA ON TO FILE SCR1, ONE LOGICAL RECORD FOR EA
C     SET ID.
C
      CALL OPEN (*2001,SCR1,Z(BUF2),1)
      IST  = SCORE + 3
      IFIN = SCORE + J - 1
      N    = 1
      NSID = 1
      ISID(1) = Z(SCORE)
      CALL WRITE (SCR1,Z(SCORE+1),2,0)
      DO 660 I = IST,IFIN,3
      IF (Z(I) .EQ. ISID(N)) GO TO 661
      N    = N + 1
      NSID = NSID + 1
      ISID(N) = Z(I)
      CALL WRITE (SCR1,ARAY,0,1)
  661 CALL WRITE (SCR1,Z(I+1),2,0)
  660 CONTINUE
      CALL WRITE (SCR1,ARAY,0,1)
      CALL CLOSE (SCR1,1)
C
C
C     SCR1 NOW CONTAINS BOUNDARY SET DATA FOR ALL GRID POINTS
C
C     CHECK THAT ALL REQUESTED SID S HAVE BEEN FOUND
C
      NRSID = NWBS/3
      J = 0
      DO 670 I = KS2,KF2,3
      Z(SCORE+J) = Z(I+2)
      J = J + 1
  670 CONTINUE
      DO 675 I = 1,NRSID
      II = I - 1
      DO 676 J = 1,NSID
      IF (ISID(J) .EQ. Z(SCORE+II)) GO TO 677
  676 CONTINUE
      GO TO 675
  677 Z(SCORE+II) = 0
  675 CONTINUE
      IBAD = 0
      DO 678 I = 1,NRSID
      II = I - 1
      IF (Z(SCORE+II) .EQ. 0) GO TO 678
      INDEX = (I-1)*3
      WRITE (OUTT,692) UFM,Z(KS2+INDEX+2),Z(KS2+INDEX),Z(KS2+INDEX+1)
      IBAD = 1
  678 CONTINUE
      IF (IBAD .EQ. 1) GO TO 2300
  692 FORMAT (A23,' 6608, THE REQUEST FOR BOUNDARY SET ',I8,
     1       ' SUBSTRUCTURE ',2A4,' WAS NOT DEFINED.')
C
C     VI. PROCESS THE EQSS FROM THE SOF FOR EACH COMPONENT SUBSTRUCTURE.
C     ******************************************************************
C
      CALL OPEN (*2001,SCR1,Z(BUF3),0)
      CALL OPEN (*2001,SCR2,Z(BUF2),1)
      CALL SFETCH (NAMOLD,NHEQSS,1,ITEST)
      NGRP = 1
      CALL SJUMP (NGRP)
C
C     READ AND PROCESS EQSS
C
      BAD = .FALSE.
      DO 701 I = 1,NCSUB
      II = 2*(I-1)
      CALL SUREAD (Z(SCORE),-1,NOUT,ITEST)
      IF (ANDF(RSHIFT(PRTOPT,3),1) .NE. 1) GO TO 2499
      CALL CMIWRT (1,NAMOLD,Z(KS1+II),SCORE,NOUT,Z,Z)
 2499 CONTINUE
C
C     FIND A BOUNDARY SET FOR THE COMPONENT
C
      INXT = 1
      FSET = .FALSE.
  737 DO 702 J = INXT,NWBS,3
      JJ = J - 1
      IF (Z(KS2+JJ).EQ.Z(KS1+II) .AND. Z(KS2+JJ+1).EQ.Z(KS1+II+1))
     1    GO TO 704
  702 CONTINUE
      IF (FSET) GO TO 735
C
C     NO BOUNDARY SET FOR COMPONENT - IMPLIES ENTIRE SUBSTRUCTURE WILL B
C     REDUCED - POSSSIBLE ERROR.
C
      IF (NOUT .NE. 0) WRITE(OUTT,791) UIM,Z(KS1+II),Z(KS1+II+1),
     1                                 (NAMOLD(J),J=1,2)
  791 FORMAT (A29,' 6609, NO BOUNDARY SET HAS BEEN SPECIFIED FOR ',
     1       'COMPONENT ',2A4,' OF PSEUDOSTRUCTURE ',2A4, /35X,
     2       'ALL DEGREES OF FREEDOM WILL BE REDUCED.')
      CALL WRITE (SCR2,ARAY(1),0,1)
      GO TO 701
C
C     COMPONENT HAS A BOUNDARY SET, CALL EQSCOD TO ACCOUNT FOR POSSIBLE
C     MULTIPLE IP NUMBERS.
C
  704 IF (FSET) GO TO 736
      CALL EQSCOD (SCORE,NOUT,Z)
C
C     DEFINE ARRAY TO CB - DEGREES OF FREEDOM RETAINED AS BOUNDARY POINT
C
      IST  = SCORE + NOUT
      IFIN = IST + NOUT/3 - 1
      DO 705 J = IST,IFIN
      Z(J) = 0
  705 CONTINUE
C
C     LOCATE BOUNDARY SET ON SCR1
C
  736 INXT = JJ + 4
      FSET = .TRUE.
      NSET = Z(KS2+JJ+2)
      DO 706 J = 1,NSID
      IF (NSET .EQ. ISID(J)) GO TO 766
  706 CONTINUE
  766 NREC = J - 1
      IF (NREC .EQ. 0) GO TO 716
      DO 707 JJ = 1,NREC
      CALL FWDREC (*2002,SCR1)
  707 CONTINUE
C
C     READ BOUNDARY DATA AND UPDATE CB
C
  716 CALL READ (*2002,*730,SCR1,ARAY,2,0,NNN)
C
C     LOCATE GRID ID IN EQSS AND SETS OF VALUES IF THE GRID IS MULTIPLY
C
      IF (NOUT .EQ. 0) GO TO 717
      CALL GRIDIP (ARAY(1),SCORE,NOUT,IPSET,CSET,NO,Z,LOC)
      IF (IIIERR .NE. 1) GO TO 718
  717 BAD = .TRUE.
      WRITE  (OUTT,714) UFM,ARAY(1),NSET,Z(KS1+II),Z(KS1+II+1)
  714 FORMAT (A23,' 6611, GRID POINT',I9,' SPECIFIED IN BOUNDARY SET',
     1       I9,' FOR SUBSTRUCTURE ',2A4,' DOES NOT EXIST.')
  718 IADD = LOC
      IF (NO .GT. 1) GO TO 710
      ICOMP = Z(IADD+2) - LSHIFT(RSHIFT(Z(IADD+2),26),26)
      GO TO 711
  710 ICOMP = 0
      DO 712 J = 1,NO
      CSET(J) = CSET(J) - LSHIFT(RSHIFT(CSET(J),26),26)
      ICOMP = ORF(ICOMP,CSET(J))
  712 CONTINUE
C
C     CHECK THAT THE RETAINED DOF ARE A SUBSET OF THE ORIGINAL.
C
  711 IF (ANDF( ARAY(2),ICOMP ).EQ.ARAY(2).OR.IIIERR.EQ.1) GO TO 715
      WRITE  (OUTT,792) UWM,ARAY(1),Z(KS1+II),Z(KS1+II+1)
  792 FORMAT (A25,' 6610, DEGREES OF FREEDOM AT GRID POINT',I9,
     1       ' COMPONENT SUBSTRUCTURE ',2A4, /31X,'INCLUDED IN A ',
     2       'BOUNDARY SET DO NOT EXIST. REQUEST WILL BE IGNORED.')
      ARAY(2) = ARAY(2) - (ORF(ARAY(2),ICOMP)-ICOMP)
C
C     UPDATE CB ARRAY
C
  715 IF (NO .GT. 1) GO TO 757
      NENT = (IADD-SCORE)/3
      Z(IST+NENT) = ORF(Z(IST+NENT),ARAY(2))
      GO TO 716
  757 NENT = (IADD-SCORE)/3
      DO 758 J = 1,NO
      Z(IST+NENT+J-1) = ORF(Z(IST+NENT+J-1),ARAY(2))
  758 CONTINUE
      GO TO 716
C
C     BOUNDARY SET COMPLETE, IS THERE ANOTHER
C
  730 CALL REWIND (SCR1)
      GO TO 737
C
C     WRITE IP AND CB ON SCR2
C
  735 I1 = SCORE
      I2 = I1 + NOUT - 1
      II = -1
      DO 740 J = I1,I2,3
      II = II + 1
      ARAY(1) = ANDF(Z(J+2),Z(IST+II))
      IF (ARAY(1) .NE. 0) CALL WRITE (SCR2,Z(J+1),1,0)
      IF (ARAY(1) .NE. 0) CALL WRITE (SCR2,ARAY(1),1,0)
  740 CONTINUE
      CALL WRITE (SCR2,ARAY(1),0,1)
  701 CONTINUE
      CALL CLOSE (SCR1,1)
      CALL CLOSE (SCR2,1)
      IF (BAD) GO TO 2300
C
C     VII. PROCESS MASTER SIL LIST AND ALLOCATE SPACE FOR CNEW
C     ********************************************************
C
      J = 0
  800 CALL SUREAD (Z(SCORE+J),2,NOUT,ITEST)
      IF (ITEST .EQ. 3) GO TO 810
      J = J + 3
      GO TO 800
  810 NW = J - 3
      DO 820 I = 1,NW,3
      JJ = I - 1
      Z(SCORE+JJ+2) = 0
  820 CONTINUE
      CALL OPEN (*2001,SCR2,Z(BUF2),0)
  840 CALL READ (*860,*850,SCR2,ARAY,2,0,NNN)
      ILOC = 3*ARAY(1) - 3
      Z( SCORE+ILOC+2 ) = ORF(Z(SCORE+ILOC+2),ARAY(2))
      GO TO 840
C
C     READ NEXT COMPONENT
C
  850 GO TO 840
C
C     PROCESSING COMPLETE
C
  860 CALL CLOSE (SCR2,1)
      KS3   = SCORE
      SCORE = SCORE + NW
      KF3   = SCORE - 1
C
C     VIII. DEFINE PARTITIONING VECTORS PVX AND USX
C     *********************************************
C
      CALL GOPEN (PVX,Z(BUF2),1)
C
C     GENERATE PVX DATA BLOCK IN CORE
C
      JJJ = 0
      DO 900 I = 1,NW,3
      ICODE = Z(KS3+I)
      CALL DECODE (ICODE,LISTO,NROW)
      DO 910 J = 1,NROW
      RZ(SCORE+JJJ+J-1) = 0.0
  910 CONTINUE
      ICODE = Z(KS3+I+1)
      CALL DECODE (ICODE,LISTN,NNEW)
      DO 920 J = 1,NROW
      LISTO(J) = LISTO(J) + 1
  920 CONTINUE
      IF (NNEW .EQ. 0) GO TO 960
      DO 930 J = 1,NNEW
      LISTN(J) = LISTN(J) + 1
  930 CONTINUE
C
C     FIND DOF THAT REMAIN AT GIVEN IP
C
      DO 941 J  = 1,NNEW
      DO 942 JJ = 1,NROW
      IF (LISTN(J) .EQ. LISTO(JJ)) GO TO 943
  942 CONTINUE
      GO TO 941
  943 IJK(J) = JJ
  941 CONTINUE
      DO 950 J = 1,NNEW
      IK = IJK(J)
      RZ(SCORE+JJJ+IK-1) = 1.0
  950 CONTINUE
  960 JJJ = JJJ + NROW
  900 CONTINUE
C
C     SET PARAMETERS AND CALL PACK
C
      MCB(1) = PVX
      MCB(2) = 0
      MCB(3) = JJJ
      MCB(4) = 2
      MCB(5) = 1
      MCB(6) = 0
      MCB(7) = 0
      TYPIN  = 1
      TYPOUT = 1
      INCR   = 1
      IROW   = 1
      NROW   = JJJ
      CALL PACK (RZ(SCORE),PVX,MCB)
      CALL WRTTRL (MCB)
      CALL CLOSE (PVX,1)
      IF (LONLY) GO TO 1070
C
C     PROCESS USX USET EQUIVALENT
C
      CALL OPEN  (*2001,USX,Z(BUF2),1)
      CALL FNAME (USX,ARAY )
      CALL WRITE (USX,ARAY,2,0)
      CALL WRITE (USX,0.0 ,1,0)
      CALL WRITE (USX,0.0 ,1,1)
      MCB(1) = USX
      MCB(2) = 0
      MCB(3) = JJJ
      MCB(4) = 0
      MCB(5) = IBA + IBO + IBF
      MCB(6) = 0
      MCB(7) = 0
      DO 975 J = 1,JJJ
      JJ = J - 1
CWKBDB 8/94 ALPHA-VMS      
C      IF (RZ(SCORE+JJ) .EQ. 0.0) Z(SCORE+JJ) = IBF + IBO
C      IF (RZ(SCORE+JJ) .EQ. 1.0) Z(SCORE+JJ) = IBF + IBA
CWKBDE 8/94 ALPHA-VMS
CWKBNB 8/94 ALPHA-VMS
      IF (RZ(SCORE+JJ) .NE. 0.0) GO TO 976 
      Z(SCORE+JJ) = IBF + IBO
      GO TO 977
976   IF (RZ(SCORE+JJ) .EQ. 1.0) Z(SCORE+JJ) = IBF + IBA
977   CONTINUE
CWKBNE 8/94 ALPHA-VMS
  975 CONTINUE
      CALL WRITE (USX,Z(SCORE),JJJ,1)
      CALL WRTTRL (MCB)
      CALL CLOSE (USX,1)
C
C     IX. PROCESS THE SOF FOR THE REDUCED STRUCTURE
C     *********************************************
C
C
C     PROCESS THE EQSS FOR EACH COMPONENT SUBSTRUCTURE
C
      CALL OPEN (*2001,SCR1,Z(BUF1),1)
      CALL SFETCH (NAMOLD,NHEQSS,1,ITEST)
C
C     UPDATE (SIL,C) REPLACING SIL WITH IPNEW
C
      IPNEW = 1
      DO 1002 I = KS3,KF3,3
      IF (Z(I+2)) 1003,1004,1003
 1004 Z(I) = 0
      GO TO 1002
 1003 Z(I)  = IPNEW
      IPNEW = IPNEW + 1
 1002 CONTINUE
      NIPNEW = IPNEW - 1
      NGRP   = 1
      CALL SJUMP (NGRP)
      DO 1020 J = 1,NCSUB
      CALL SUREAD (Z(SCORE),-1,NOUT,ITEST)
C
C     WRITE EQSS ENTRY ON SCR1 IF THE OLD IP NUMBER STILL EXISTS IN THE
C     REDUCED STRUCTURE, ALSO UPDATE DOF CODE.
C
      IF (NOUT .EQ. 0) GO TO 1015
      DO 1010 I = 1,NOUT,3
      II  = I - 1
      IPO = Z(SCORE+II+1)
      IADD= KS3 + (IPO-1)*3
      IF (Z(IADD) .EQ. 0) GO TO 1010
      ARAY(1) = Z(SCORE+II)
      ARAY(2) = Z(IADD  )
      ARAY(3) = Z(IADD+2)
      CALL WRITE (SCR1,ARAY,3,0)
 1010 CONTINUE
 1015 CALL WRITE (SCR1,0,0,1)
 1020 CONTINUE
C
C     GENERATE NEW MASTER (SIL,C) LIST
C
      ISIL = 1
      DO 1030 I = KS3,KF3,3
      IF (Z(I) .EQ. 0) GO TO 1030
      ICODE = Z(I+2)
      CALL DECODE (ICODE,LISTN,NDOF)
      ARAY(1) = ISIL
      ARAY(2) = Z(I+2)
      CALL WRITE (SCR1,ARAY,2,0)
      ISIL = ISIL + NDOF
 1030 CONTINUE
      CALL WRITE (SCR1,ARAY,0,1)
      CALL CLOSE (SCR1,1)
      IF (DRY .EQ. 0) GO TO 8612
C
C     WRITE FIRST GROUP OF EQSS
C
      CALL OPEN (*2001,SCR1,Z(BUF1),0)
      CALL SETLVL (NAMNEW,1,NAMOLD,ITEST,28)
      IF (ITEST .EQ. 8) GO TO 6518
      ITEST = 3
      CALL SFETCH (NAMNEW,NHEQSS,2,ITEST)
      ITEST = 1
      CALL SUWRT (NAMNEW,2,ITEST)
      ITEST = 1
      CALL SUWRT (NCSUB,1,ITEST)
      ITEST = 1
      CALL SUWRT (NIPNEW,1,ITEST)
      DO 1040 I = KS1,KF1,2
      ITEST = 1
      CALL SUWRT (Z(I),2,ITEST)
 1040 CONTINUE
      ITEST = 2
      CALL SUWRT (Z(I),0,ITEST)
 1043 CALL READ (*1041,*1042,SCR1,Z(SCORE),NZ,0,NNN)
      GO TO 2004
 1042 CALL SUWRT (Z(SCORE),NNN,2)
      GO TO 1043
 1041 ITEST = 3
      CALL SUWRT (ARAY,0,ITEST)
      CALL CLOSE (SCR1,1)
C
C     WRITE BGSS FILE
C
      CALL SFETCH (NAMOLD,NHBGSS,1,ITEST)
      NGRP = 1
      CALL SJUMP (NGRP)
      CALL SUREAD (Z(SCORE),-1,NOUT,ITEST)
      J = 0
C
C     THE CID S THAT BELONG TO POINTS THAT ARE COMPLETELY REDUCED
C     WILL BE ACCUMULATED IN BUF3.
C
      JJJ1 = 2
      DO 1050 I = 1,NOUT,4
      II = I - 1
      IF (Z(KS3+JJJ1)) 1052,1051,1052
 1052 IF (Z(SCORE+II) .EQ. 0) GO TO 1053
      Z(BUF3+J) = Z(SCORE+II)
      J = J + 1
      GO TO 1053
 1051 Z(SCORE+II) = -1*TPOW(2)
 1053 JJJ1 = JJJ1 + 3
 1050 CONTINUE
      NCSRED = J
      ITEST = 3
      CALL SFETCH (NAMNEW,NHBGSS,2,ITEST)
      ITEST = 1
      CALL SUWRT (NAMNEW,2,ITEST)
      ITEST = 2
      CALL SUWRT (NIPNEW,1,ITEST)
      DO 1055 I = 1,NOUT,4
      II = I - 1
      IF (Z(SCORE+II) .EQ. -TPOW(2)) GO TO 1055
      ITEST = 1
      CALL SUWRT (Z(SCORE+II),4,ITEST)
 1055 CONTINUE
      ITEST = 2
      CALL SUWRT (ARAY,0,ITEST)
      ITEST = 3
      CALL SUWRT (ARAY,0,ITEST)
C
C     PROCESS THE CSTM FILES
C
      IF (NCSRED .NE. 0) GO TO 1063
      CALL SFETCH (NAMOLD,NHCSTM,1,ITEST)
      IF (ITEST .EQ. 3) GO TO 1070
      CALL SUREAD (Z(SCORE),-2,NOUT,ITEST)
      Z(SCORE  ) = NAMNEW(1)
      Z(SCORE+1) = NAMNEW(2)
      ITEST = 3
      CALL SFETCH (NAMNEW,NHCSTM,2,ITEST)
      ITEST = 3
      CALL SUWRT (Z(SCORE),NOUT,ITEST)
      GO TO 1070
 1063 CALL SFETCH (NAMOLD,NHCSTM,1,ITEST)
      IF (ITEST .EQ. 3) GO TO 1070
      NGRP = 1
      CALL SJUMP (NGRP)
C
C     SORT THE DELETED CID S
C
      CALL SORT (0,0,1,1,Z(BUF3),NCSRED)
C
C     READ ALL RETAINED CSTM DATA INTO OPEN CORE
C
      J = 0
 1065 CALL SUREAD (Z(SCORE+J),14,NOUT,ITEST)
      IF (ITEST .EQ. 2) GO TO 1066
      IF (Z(SCORE+J) .EQ. 0) GO TO 1065
      KID = Z(SCORE+J)
      CALL BISLOC (*1065,KID,Z(BUF3),1,NCSRED,JP)
      J = J + 14
      GO TO 1065
 1066 ITEST = 3
      CALL SFETCH (NAMNEW,NHCSTM,2,ITEST)
      ITEST = 2
      CALL SUWRT (NAMNEW,2,ITEST)
      ITEST = 2
      CALL SUWRT (Z(SCORE),J,ITEST)
      ITEST = 3
      CALL SUWRT (ARAY,0,ITEST)
 1070 CONTINUE
C
C     PROCESS LODS ITEM
C
      CALL SFETCH (NAMOLD,LITM,1,ITEST)
      IF (ITEST .EQ. 3) GO TO 1080
      CALL SUREAD (Z(SCORE),-2,NOUT,ITEST)
      Z(SCORE  ) = NAMNEW(1)
      Z(SCORE+1) = NAMNEW(2)
      ITEST = 3
      CALL SFETCH (NAMNEW,LITM,2,ITEST)
      ITEST = 3
      CALL SUWRT (Z(SCORE),NOUT,ITEST)
 1080 CONTINUE
      IF (LONLY) GO TO 8511
C
C     PROCESS PLTS ITEM
C
      CALL SFETCH (NAMOLD,NHPLTS,1,ITEST)
      IF (ITEST .EQ. 3) GO TO 1090
      CALL SUREAD (Z(SCORE),-1,NOUT,ITEST)
      Z(SCORE  ) = NAMNEW(1)
      Z(SCORE+1) = NAMNEW(2)
      ITEST = 3
      CALL SFETCH (NAMNEW,NHPLTS,2,ITEST)
      ITEST = 2
      CALL SUWRT (Z(SCORE),NOUT,ITEST)
      ITEST = 3
      CALL SUWRT (Z(SCORE),0,ITEST)
 1090 CONTINUE
C
C     PROCESS OUTPUT REQUESTS
C
      IF (ANDF(RSHIFT(PRTOPT,4),1) .NE. 1) GO TO 8211
C
C     WRITE EQSS FOR NEW STRUCTURE
C
      CALL SFETCH (NAMNEW,NHEQSS,1,ITEST)
      CALL SUREAD (Z(SCORE),4,NOUT,ITEST)
      CALL SUREAD (Z(SCORE),-1,NOUT,ITEST)
      IST = SCORE + NOUT
      DO 8212 I = 1,NCSUB
      CALL SUREAD (Z(IST),-1,NOUT,ITEST)
      IADD = SCORE + 2*(I-1)
      CALL CMIWRT (1,NAMNEW,Z(IADD),IST,NOUT,Z,Z)
 8212 CONTINUE
      CALL SUREAD (Z(IST),-1,NOUT,ITEST)
      CALL CMIWRT (8,NAMNEW,0,IST,NOUT,Z,Z)
 8211 IF (ANDF(RSHIFT(PRTOPT,5),1) .NE. 1) GO TO 8311
C
C     WRITE NEW BGSS
C
      CALL SFETCH (NAMNEW,NHBGSS,1,ITEST)
      NGRP = 1
      CALL SJUMP (NGRP)
      IST = SCORE
      CALL SUREAD (Z(IST),-1,NOUT,ITEST)
      CALL CMIWRT (2,NAMNEW,NAMNEW,IST,NOUT,Z,Z)
 8311 IF (ANDF(RSHIFT(PRTOPT,6),1) .NE. 1) GO TO 8411
C
C     WRITE CSTM ITEM
C
      CALL SFETCH (NAMNEW,NHCSTM,1,ITEST)
      IF (ITEST .EQ. 3) GO TO 8411
      NGRP = 1
      CALL SJUMP (NGRP)
      IST = SCORE
      CALL SUREAD (Z(IST),-1,NOUT,ITEST)
      CALL CMIWRT (3,NAMNEW,NAMNEW,IST,NOUT,Z,Z)
 8411 IF (ANDF(RSHIFT(PRTOPT,7),1) .NE. 1) GO TO 8511
C
C     WRITE PLTS ITEM
C
      CALL SFETCH (NAMNEW,NHPLTS,1,ITEST)
      IF (ITEST .EQ. 3) GO TO 8511
      IST = SCORE
      CALL SUREAD (Z(IST),3,NOUT,ITEST)
      CALL SUREAD (Z(IST),-1,NOUT,ITEST)
      CALL CMIWRT (4,NAMNEW,NAMNEW,IST,NOUT,Z,Z)
 8511 IF (ANDF(RSHIFT(PRTOPT,8),1) .NE. 1) GO TO 8611
C
C     WRITE LODS ITEM
C
      CALL SFETCH (NAMNEW,LODS,1,ITEST)
      IF (ITEST .EQ. 3) GO TO 8611
      CALL SUREAD (Z(SCORE),4,NOUT,ITEST)
      CALL SUREAD (Z(SCORE),-1,NOUT,ITEST)
      IST   = SCORE + NOUT
      ITYPE = 5
      IF (LITM .EQ. LOAP) ITYPE = 7
      DO 8512 I = 1,NCSUB
      IADD = SCORE+2*(I-1)
      CALL SUREAD (Z(IST),-1,NOUT,ITEST)
      CALL CMIWRT (ITYPE,NAMNEW,Z(IADD),IST,NOUT,Z,Z)
      ITYPE = 6
 8512 CONTINUE
 8611 CONTINUE
      IF (LONLY) GO TO 1105
C
C     X. GENERATE THE INX OUTPUT DATA BLOCK
C     *************************************
C
 8612 CALL GOPEN (INX,Z(BUF2),1)
      MCB(1) = INX
      MCB(2) = 0
      MCB(3) = ISIL - 1
      MCB(4) = 1
      MCB(5) = 1
      MCB(6) = 0
      MCB(7) = 0
      TYPIN  = 1
      TYPOUT = 1
      INCR   = 1
      ISILM1 = ISIL - 1
      DO 1100 I = 1,ISILM1
      IROW = I
      NROW = I
      CALL PACK (1.0,INX,MCB)
 1100 CONTINUE
      CALL WRTTRL (MCB)
      CALL CLOSE (INX,1)
 1105 CALL SOFCLS
      RETURN
C
 2100 WRITE  (OUTT,2101) UFM
 2101 FORMAT (A23,' 6535, MODULE REDUCE TERMINATING DUE TO ABOVE ',
     1       'SUBSTRUCTURE CONTROL ERRORS.')
      GO TO 2400
C
 2200 WRITE  (OUTT,2201) UFM
 2201 FORMAT (A23,' 6536, MODULE REDUCE TERMINATING DUE TO ABOVE ',
     1       'ERRORS IN BULK DATA.')
      CALL CLOSE (GEOM4,1)
      GO TO 2400
C
 2300 WRITE  (OUTT,2301) UFM
 2301 FORMAT (A23,' 6537, MODULE REDUCE TERMINATING DUE TO ABOVE ',
     1       'ERRORS.')
 2400 DRY = -2
      CALL SOFCLS
      RETURN
C
 6518 WRITE  (OUTT,6519) UFM
 6519 FORMAT (A23,' 6518, ONE OF THE COMPONENT SUBSTRUCTURES HAS BEEN ',
     1       'USED IN A PREVIOUS COMBINE OR REDUCE.')
      GO TO 2300
 2001 IMSG = -1
      GO TO 2998
 2002 IMSG = -2
      GO TO 2998
 2003 IMSG = -3
      GO TO 2998
 2004 IMSG = -8
 2998 CALL MESAGE (IMSG,IFILE,MODNAM)
      RETURN
      END

      SUBROUTINE PSTRB1 (IOPT)
C
C     THIS ROUTINE DOES SUB-CALCULATIONS FOR PLATE ELEMENTS IN PLA3
C
C     THIS ROUTINE IS SIMILAR TO STRBS1, BUT SINCE THE BASIC BENDING
C     TRIANGLE (IOPT = 0) IS NOT USED IN PLA, THE CORRESPONDING
C     EXECUTIABLE CODE FOR THAT CASE IS NOT USED.
C
C     PHASE ONE FOR STRESS RECOVERY
C
C              IOPT   = 0  (BASIC BENDING TRIANGLE)
C              IOPT   = 1  (SUB-CALCULATIONS FOR SQDPL1)
C              IOPT   = 2  (SUB-CALCULATIONS FOR STRPL1)
C
C     CALLS FROM THIS ROUTINE ARE MADE TO
C
C     PLAMAT - ROTATES AND RETURNS GP MATRIX
C              MAT    - MATERIAL DATA ROUTINE
C              TRANSS - SINGLE PRECISION TRANSFORMATION SUPPLIER
C              INVERS - SINGLE PRECISION INVERSE ROUTINE
C              GMMATS - SINGLE PRECISION MATRIX MULTIPLY AND TRANSPOSE
C              MESAGE - ERROR MESSAGE WRITER
C
      INTEGER         SUBSCA,SUBSCB
      REAL            KS,J2X2
      DIMENSION       D(9),G2X2(4),J2X2(4),S(18),ECPT(1),G(9),HIC(18),
     1                HIB(18),TITE(18),T(9),KS(30),HINV(36)
      COMMON /MATIN / MATID,INFLAG,ELTEMP,STRESS,SINTH,COSTH
      COMMON /MATOUT/ G11,G12,G13,G22,G23,G33,RHO,ALPHA1,ALPHA2,ALP12,
     1                T SUB 0, G SUB E, SIGTEN, SIGCOM, SIGSHE,
     2                G2X211, G2X212, G2X222
      COMMON /PLA32S/ A(225),XSUBB,XSUBC,YSUBC,E(18),TEMP,XBAR,AREA,
     1                XCSQ,YBAR2,YCSQ,YBAR,XBSQ,PX2,XCYC,PY2,PXY2,XBAR3,
     2                YBAR3,DETERM,PROD9(9),TEMP9(9),NSIZED,DUMDUM(4),
     3                NPIVOT,THETA ,NSUBC,ISING,SUBSCA,SUBSCB,NERROR,
     4                NBEGIN,NTYPED,XC,YC,YC2,YC3,ISUB,XC3,DUM55(26)
      COMMON /PLA3ES/ NECPT(1),NGRID(3),ANGLE,MATID1,EYE,MATID2,T2,FMU,
     1                Z11,Z22,DUMMY1,X1,Y1,Z1,DUMMY2,X2,Y2,Z2,DUMMY3,X3,
     2                Y3,Z3,DUMB(76),PH1OUT(200)
      EQUIVALENCE     (D(1),G(1),A(79)),(ECPT(1),NECPT(1)),
     1                (KS(1),PH1OUT(1)),(G2X2(1),A(88)),(S(1),A(55)),
     2                (TITE(1),A(127)),(J2X2(1),A(92)),(T(1),A(118)),
     3                (HIB(1),A(109)),(HIC(1),A(127)),(HINV(1),A(73))
C
C     ECPT LIST FOR BASIC BENDING TRIANGLE           NAME IN
C                                                    THIS
C     ECPT                                           ROUTINE   TYPE
C     ==========================================     ========  =======
C     ECPT( 1) = ELEMENT ID                          NECPT(1)  INTEGER
C     ECPT( 2) = GRID POINT A                        NGRID(1)  INTEGER
C     ECPT( 3) = GRID POINT B                        NGRID(2)  INTEGER
C     ECPT( 4) = GRID POINT C                        NGRID(3)  INTEGER
C     ECPT( 5) = THETA = ANGLE OF MATERIAL           ANGLE     REAL
C     ECPT( 6) = MATERIAL ID 1                       MATID1    INTEGER
C     ECPT( 7) = I = MOMENT OF INERTIA               EYE       REAL
C     ECPT( 8) = MATERIAL ID 2                       MATID2    INTEGER
C     ECPT( 9) = T2                                  T2        REAL
C     ECPT(10) = NON-STRUCTURAL-MASS                 FMU       REAL
C     ECPT(11) = Z1                                  Z11       REAL
C     ECPT(12) = Z2                                  Z22       REAL
C     ECPT(13) = COORD. SYSTEM ID 1                  NECPT(13) INTEGER
C     ECPT(14) = X1                                  X1        REAL
C     ECPT(15) = Y1                                  Y1        REAL
C     ECPT(16) = Z1                                  Z1        REAL
C     ECPT(17) = COORD. SYSTEM ID 2                  NECPT(17) INTEGER
C     ECPT(18) = X2                                  X2        REAL
C     ECPT(19) = Y2                                  Y2        REAL
C     ECPT(20) = Z2                                  Z2        REAL
C     ECPT(21) = COORD. SYSTEM ID 3                  NECPT(21) INTEGER
C     ECPT(22) = X3                                  X3        REAL
C     ECPT(23) = Y3                                  Y3        REAL
C     ECPT(24) = Z3                                  Z3        REAL
C     ECPT(25) = ELEMENT TEMPERATURE                 ELTEMP    REAL
C
      MATID  = MATID1
      INFLAG = -1
C
      CALL PLAMAT
C
C     FILL G-MATRIX WITH OUTPUT FROM MAT ROUTINE
C
      G(1) = G11
      G(2) = G12
      G(3) = G13
      G(4) = G12
      G(5) = G22
      G(6) = G23
      G(7) = G13
      G(8) = G23
      G(9) = G33
C
C     COMPUTATION OF D = I.G-MATRIX (EYE IS INPUT FROM THE ECPT)
C
      DO 50 I = 1,9
   50 D(I) = G(I)*EYE
C
      XBAR = (XSUBB+XSUBC)/3.0
      YBAR = YSUBC/3.0
C
C     FORMING K  5X6 AND STORING TEMPORARILY IN PH1OUT OUTPUT SPACE.
C              S                             (EQUIVALENCED)
C
      XC3    = 3.0*XC
      YC3    = 3.0*YC
      YC2    = 2.0*YC
      KS( 1) = D(1)
      KS( 2) = D(3)
      KS( 3) = D(2)
      KS( 4) = D(1)*XC3
      KS( 5) = D(2)*XC + D(3)*YC2
      KS( 6) = D(2)*YC3
      KS( 7) = D(2)
      KS( 8) = D(6)
      KS( 9) = D(5)
      KS(10) = D(2)*XC3
      KS(11) = D(5)*XC + D(6)*YC2
      KS(12) = D(5)*YC3
      KS(13) = D(3)
      KS(14) = D(9)
      KS(15) = D(6)
      KS(16) = D(3)*XC3
      KS(17) = D(6)*XC + D(9)*YC2
      KS(18) = D(6)*YC3
C
C     ROWS 4 AND 5
C
      KS(19) = 0.0
      KS(20) = 0.0
      KS(21) = 0.0
      KS(22) =-D(1)*6.0
      KS(23) =-D(2)*2.0 - D(9)*4.0
      KS(24) =-D(6)*6.0
      KS(25) = 0.0
      KS(26) = 0.0
      KS(27) = 0.0
      KS(28) =-D(3)*6.0
      KS(29) =-D(6)*6.0
      KS(30) =-D(5)*6.0
C
C     MULTIPLY FIRST 3 ROWS BY 2.0
C
      DO 70 I = 1,18
   70 KS(I) = KS(I)*2.0
C
      XCSQ = XSUBC**2
      YCSQ = YSUBC**2
      XBSQ = XSUBB**2
      XCYC = XSUBC*YSUBC
C
C     F1LL (HBAR) MATRIX STORING AT A(37) THRU A(72)
C
      DO 90 I = 37,72
   90 A(I)  = 0.0
      A(37) = XBSQ
      A(40) = XBSQ*XSUBB
      A(44) = XSUBB
      A(49) =-2.0*XSUBB
      A(52) =-3.0*XBSQ
      A(55) = XCSQ
      A(56) = XCYC
      A(57) = YCSQ
      A(58) = XCSQ*XSUBC
      A(59) = YCSQ*XSUBC
      A(60) = YCSQ*YSUBC
      A(62) = XSUBC
      A(63) = YSUBC*2.0
      A(65) = XCYC *2.0
      A(66) = YCSQ *3.0
      A(67) =-2.0*XSUBC
      A(68) =-YSUBC
      A(70) =-3.0*XCSQ
      A(71) =-YCSQ
C
      IF (T2 .EQ. 0.0) GO TO 110
C
C     ALL OF THE FOLLOWING OPERATIONS THROUGH STATEMENT LABEL 100
C     ARE NECESSARY IF T2 IS NON-ZERO.
C
C     GET THE G2X2 MATRIX
C
      MATID  = MATID2
      INFLAG = 3
      CALL MAT (ECPT(1))
      IF (G2X211.EQ.0.0 .AND. G2X212.EQ.0.0 .AND. G2X222.EQ.0.0)
     1    GO TO 110
      G2X2(1) = G2X211*T2
      G2X2(2) = G2X212*T2
      G2X2(3) = G2X212*T2
      G2X2(4) = G2X222*T2
C
      DETERM  = G2X2(1)*G2X2(4) - G2X2(3)*G2X2(2)
      J2X2(1) = G2X2(4)/DETERM
      J2X2(2) =-G2X2(2)/DETERM
      J2X2(3) =-G2X2(3)/DETERM
      J2X2(4) = G2X2(1)/DETERM
C
C     (H  ) IS PARTITIONED INTO A LEFT AND RIGHT PORTION AND ONLY THE
C       YQ  RIGHT PORTION IS COMPUTED AND USED AS A  (2X3). THE LEFT
C           2X3 PORTION IS NULL.  THE RIGHT PORTION WILL BE STORED AT
C           A(73) THRU A(78) UNTIL NOT NEEDED ANY FURTHER.
C
      TEMP  =  2.0*D(2) + 4.0*D(9)
      A(73) = -6.0*(J2X2(1)*D(1) + J2X2(2)*D(3))
      A(74) = -J2X2(1)*TEMP + 6.0*J2X2(2)*D(6)
      A(75) = -6.0*(J2X2(1)*D(6) + J2X2(2)*D(5))
      A(76) = -6.0*(J2X2(2)*D(1) + J2X2(4)*D(3))
      A(77) = -J2X2(2)*TEMP + 6.0*J2X2(4)*D(6)
      A(78) = -6.0*(J2X2(2)*D(6) + J2X2(4)*D(5))
C
C     THE ABOVE 6 ELEMENTS NOW REPRESENT THE (H  ) MATRIX (2X3)
C                                              YQ
C
C     ADD TO 6 OF THE (HBAR) ELEMENTS THE RESULT OF(H  )(H  )
C                                                    UY   YQ
C     THE PRODUCT IS FORMED DIRECTLY IN THE ADDITION PROCESS BELOW.
C     NO (H  ) MATRIX IS ACTUALLY COMPUTED DIRECTLY.
C          UY
C
C     THE FOLLOWING IS THEN PER STEPS 6 AND 7 PAGE -16- MS-17.
C
      DO 100 I = 1,3
      A(I+39) = A(I+39) + XSUBB*A(I+72)
  100 A(I+57) = A(I+57) + XSUBC*A(I+72) + YSUBC*A(I+75)
C
C     THIS ENDS ADDED COMPUTATION FOR CASE OF T2 NOT ZERO
C
  110 CONTINUE
C
C     AT THIS POINT INVERT  (H) WHICH IS STORED AT A(37) THRU A(72)
C     STORE INVERSE BACK IN A(37) THRU A(72)
C     NO NEED TO COMPUTE DETERMINANT SINCE IT IS NOT USED SUBSEQUNTLY.
C
      ISING = -1
      CALL INVERS (6,A(37),6,A(73),0,DETERM,ISING,A(79))
C
C     CHECK TO SEE IF H WAS SINGULAR
C
      IF (ISING .NE. 2) GO TO 120
C
C     ISING = 2 IMPLIES SINGULAR MATRIX THUS ERROR CONDITION.
C
      CALL MESAGE (-30,38,ECPT(1))
C
C     SAVE H-INVERSE IF TRI-PLATE IS CALLING
C
  120 DO 130 I = 1,36
  130 HINV(I) = A(I+36)
C
C     FILL  S-MATRIX, EQUIVALENCED TO A(55).  (6X3)
C
      S( 1) = 1.0
      S( 2) = 0.0
      S( 3) =-XSUBB
      S( 4) = 0.0
      S( 5) = 1.0
      S( 6) = 0.0
      S( 7) = 0.0
      S( 8) = 0.0
      S( 9) = 1.0
      S(10) = 1.0
      S(11) = YSUBC
      S(12) =-XSUBC
      S(13) = 0.0
      S(14) = 1.0
      S(15) = 0.0
      S(16) = 0.0
      S(17) = 0.0
      S(18) = 1.0
C
C     COMPUTE  S , S ,  AND S    NO TRANSFORMATIONS
C               A   B        C
C
C                -1
C     S  = - K  H  S ,   S  = K  H   ,   S  = K  H
C      A      S           B    S  IB      C    S  IC
C
C     S   COMPUTATION.
C      A
C
      CALL GMMATS (HINV(1),6,6,0, S(1),6,3,0, A(16))
C
C     DIVIDE  H-INVERSE INTO A LEFT 6X3 AND RIGHT 6X3 PARTITION.
C
      I = 0
      J =-6
  150 J = J + 6
      K = 0
  160 K = K + 1
      I = I + 1
      ISUB = J + K
      HIB(I) = HINV(ISUB    )
      HIC(I) = HINV(ISUB + 3)
      IF (K .LT.  3) GO TO 160
      IF (J .LT. 30) GO TO 150
C
      CALL GMMATS (KS(1),5,6,0, A(16),6,3,0, A(1))
C
C     MULTIPLY S SUB A BY -1
C
      DO 170 I = 1,15
  170 A(I) = -A(I)
C
C     S  COMPUTATION
C      B
C
      CALL GMMATS (KS,5,6,0, HIB,6,3,0, A(16))
C
C     S  COMPUTATION
C      C
C
      CALL GMMATS (KS,5,6,0, HIC,6,3,0, A(31))
C
      RETURN
      END

      SUBROUTINE OUTPT3
C
C     PUNCH UP TO 5 MATRIX DATA BLOCK ONTO DMI CARDS
C
C     CALL TO THIS MODULE IS
C
C     OUTPUT3   M1,M2,M3,M4,M5//C,N,PO/C,Y,N1=AB/C,Y,N2=CD/C,Y,N3=EF/
C                                      C,Y,N4=GH/C,Y,N5=IJ   $
C
C               PO = FORTRAN OUTPUT FILE UNIT NO. (DEFAULT = 0)
C                    .GE.0 MEANS NO LISTING OF  CARD IMAGES WILL BE MADE
C                    .LT.0 MEANS LISTING OF DMI CARD IMAGES WILL BE MADE
C                          ON FORTRAN UNIT = IABS(PO).
C
C
C
      LOGICAL         FIRST
      INTEGER         IN(5),SUBNAM(2),NAME(2),TRL(7),ERNO,PARAM,
     1                TRL1,TRL2,TRL3,TRL4,TRL5,TRL6,TRL7,EOL,EOR
      CHARACTER       UFM*23,UWM*25,UIM*29
      COMMON /XMSSG / UFM,UWM,UIM
      COMMON /BLANK / JO,PARAM(2,5)
     1       /SYSTEM/ NB,NO,JUNK(6),NLPP
     2       /ZZZZZZ/ X(1)
     3       /ZNTPKX/ Z(4),IZ,EOL,EOR
     4       /PHDMIX/ NAMEX(2),NAM,IFO,ITIN,ITOUT,IR,IC,NOUTPT,KPP,NLP,
     5                ERNO,ICOL,IRO,XX,ICARD1
      EQUIVALENCE     (TRL(1),TRL1), (TRL(2),TRL2), (TRL(3),TRL3),
     1                (TRL(4),TRL4), (TRL(5),TRL5), (TRL(6),TRL6),
     2                (TRL(7),TRL7)
      DATA    SUBNAM/ 4HOUTP,4HUT3 /,  IN/ 101,102,103,104,105 /
      DATA    ITYP  / 1 /
C
C
      LCOR = KORSZ(X) - NB
      IF (LCOR .LE. 0) CALL MESAGE (-8,LCOR,SUBNAM)
      IBUF = LCOR+1
      JONO = 0
      IF (JO .LT. 0) JONO = IABS(JO)
      NOUTPT = JONO
      ITIN = 1
      KPP  = 2
      NLP  = NLPP
C
      DO 1000 II = 1,5
      TRL1 = IN(II)
      CALL RDTRL (TRL)
      IF (TRL1 .LE. 0) GO TO 1000
      CALL FNAME (IN(II),NAME)
      CALL GOPEN (IN(II),X(IBUF),0)
      NAMEX(1) = NAME(1)
      NAMEX(2) = NAME(2)
      NAM  = PARAM(1,II)
      IFO  = TRL4
      ITOUT= 0
      IR   = TRL3
      IC   = TRL2
      CALL PHDMIA
      IF (ERNO .NE. 0) GO TO 9400
C
      DO 900 J = 1,TRL2
      CALL INTPK (*900,IN(II),0,ITYP,0)
      FIRST = .FALSE.
      ICOL  = J
C
      DO 800 I = 1,TRL3
      IF (EOL .NE. 0) GO TO 850
      CALL ZNTPKI
      IRO = IZ
      XX  = Z(1)
C
C     VAX MAY HAVE A FEW IMBEDED ZEROS
C
      IF (XX .EQ. 0.0) GO TO 800
      IF (FIRST) GO TO 100
      FIRST = .TRUE.
      CALL PHDMIB
      IF (ERNO) 9400,200,9400
  100 CALL PHDMIC
      IF (ERNO) 9400,200,9400
  200 CONTINUE
  800 CONTINUE
C
  850 CALL PHDMID
      IF (ERNO .NE. 0) GO TO 9400
  900 CONTINUE
C
      NCARDS = ICARD1 + 1
      CALL PAGE2 (-2)
      WRITE  (NO,1) UIM,NAME,NCARDS
    1 FORMAT (A29,' 4103, OUTPUT3 HAS PUNCHED MATRIX DATA BLOCK ',2A4,
     1       ' ONTO ',I5,' DMI CARDS.')
      CALL CLOSE (IN(II),1)
 1000 CONTINUE
      RETURN
C
C     ERROR MESSAGE
C
 9400 CALL PAGE2 (-2)
      WRITE  (NO,9450) UFM
 9450 FORMAT (A23,' 4104, ATTEMPT TO PUNCH MORE THAN 99999 DMI CARDS ',
     1       'FOR A SINGLE MATRIX.')
      CALL MESAGE (-61,0,0)
      RETURN
C
      END

      FUNCTION IUNION(I1,I2)
C
C     I1 AND I2 ARE .GT. 0 BUT .LE. 654321 AND CONSIST OF ANY UNIQUE
C     COMBINATION OF THE DIGITS 1 THRU 6
C
      INTEGER K(6,2) , KK(6) , R
C
C              DECODE I1 INTO K(*,1)
      I=1
      II=I1
      ASSIGN 10 TO R
      GO TO 100
C
C              DECODE I2 INTO K(*,2)
   10 I=2
      II=I2
      ASSIGN 20 TO R
      GO TO 100
C
C              FORM UNION OF K(*,1) AND K(*,2) IN KK(*)
   20 DO 30 I=1,6
      KK(I)=0
      IF(K(I,1).EQ.I .OR. K(I,2).EQ.I) KK(I)=I
   30 CONTINUE
C
C              PACK KK(*) INTO IUNION
      J=1
      L=0
      DO 40 I=1,6
      IF(KK(I).EQ.0) GO TO 40
      IF(L.GT.0) J=10*J
      L=L+J*I
   40 CONTINUE
C
      IUNION=L
C
      RETURN
C
C
  100 DO 110 J=1,6
  110 K(J,I)=0
      DO 120 J=1,6
      L=II-10*(II/10)
      II=(II-L)/10
      IF(L.EQ.0) GO TO 130
  120 K(L,I)=L
  130 GO TO R,(10,20)
C
      END

      SUBROUTINE RCOVMS
C
C     THIS ROUTINE GENERATES THE MODAL SOLUTION ITEM FOR RIGID FORMAT 3
C
      LOGICAL         MRECVR
      INTEGER         DRY        ,STEP       ,FSS        ,RFNO       ,
     1                SOLN       ,RC         ,SWRT       ,SRD        ,
     2                EOG        ,EOI        ,BUF1       ,Z          ,
     3                RD         ,RDREW      ,WRT        ,WRTREW     ,
     4                REW        ,NAME(2)    ,FILE       ,SOF3
      COMMON /BLANK / DRY        ,LOOP       ,STEP       ,FSS(2)     ,
     1                RFNO       ,NEIGV      ,LUI        ,UINMS(2,5) ,
     2                NOSORT     ,UTHRES     ,PTHRES     ,QTHRES
      COMMON /RCOVCR/ ICORE      ,LCORE      ,BUF1       ,BUF2       ,
     1                BUF3       ,BUF4       ,SOF1       ,SOF2       ,
     2                SOF3
      COMMON /RCOVCM/ MRECVR     ,UA         ,PA         ,QA         ,
     1                IOPT       ,RSS(2)     ,ENERGY     ,UIMPRO     ,
     2                RANGE(2)   ,IREQ       ,LREQ       ,LBASIC
      COMMON /NAMES / RD         ,RDREW      ,WRT        ,WRTREW     ,
     1                REW        ,NOREW      ,EOFNRW
      COMMON /ZZZZZZ/ Z(1)
      DATA    LAMS  , SOLN /   4HLAMS,4HSOLN   /
      DATA    SRD   , SWRT,EOG,EOI   / 1,2,2,3 /
      DATA    LAMA  / 102  /,  I7    / 7 /
      DATA    NAME  / 4HRCOV,  4HMS      /
C
C
C     CREATE SOLN FOR RIGID FORMAT 3
C
      IF (MRECVR) GO TO 500
C
C     WRITE GROUP 0
C
      RC = 3
      CALL SFETCH (FSS,SOLN,SWRT,RC)
      CALL SUWRT (FSS,2,1)
      CALL SUWRT (RFNO,1,1)
      CALL SUWRT (NEIGV,1,EOG)
C
C     IF NO EIGENVALUES, GO HOME
C
      IF (NEIGV .LE. 0) GO TO 430
C
C     COPY RECORD 2 OF LAMA OR CLAMA TO GROUP 1 OF SOLN
C
      FILE = LAMA
      CALL OPEN (*9001,LAMA,Z(BUF1),RDREW)
      CALL FWDREC (*9002,LAMA)
      CALL FREAD (LAMA,ITYPE,1,1)
      NW = 7
      IF (ITYPE .EQ. 90) NW = 6
      Z(I7) = 0
      I = 1
  410 CALL READ (*9002,*420,LAMA,Z(1),NW,0,NWDS)
      CALL SUWRT (Z,7,I)
      GO TO 410
  420 CALL SUWRT (0,0,EOG)
      CALL CLOSE (LAMA,REW)
C
C     FINISH
C
  430 CALL SUWRT (0,0,EOI)
      RETURN
C
C     FOR MODAL RECOVER COPY THE LAMS ITEM TO SOLN
C
  500 CALL SFETCH (FSS,LAMS,SRD,RC)
      IF (RC .NE. 1) GO TO 6000
      CALL SUREAD (Z(1),-2,N,RC)
      IF (N .GT. SOF3) GO TO 9008
      CALL SFETCH (FSS,SOLN,SWRT,RC)
      CALL SUWRT (Z(1),N,EOI)
      RETURN
C
C     ERROR RETURNS
C
 6000 CALL SMSG (RC-2,LAMS,FSS)
      GO TO 9200
 9001 N = 1
      GO TO 9100
 9002 N = 2
      GO TO 9100
 9008 N = 8
      GO TO 9100
 9100 CALL MESAGE (N,FILE,NAME)
 9200 CALL SOFCLS
      IOPT = -1
      CALL CLOSE (LAMA,REW)
      RETURN
      END

      SUBROUTINE TVOR (SL1,CL1,TL1,SL2,CL2,TL2,SGS,CGS,SGR,CGR,X01,X02,
     1                 Y0,Z0,E,BETA,CBAR,FMACH,KR,BRE,BIM)
C
C     NORMALWASH AT A POINT (X,Y,Z) - OF A SURFACE DIHEDRAL -
C     DUE TO A TRAPEZOIDAL UNSTEADY VORTEX RING OF UNIT STRENGTH.
C
C     THIS SUBROUTINE CALLS - SNPDF, IDF1, IDF2, FLLD
C
C     SL1, CL1, TL1  SIN(LAMBDA-1), COS(LAMBDA-1), TAN(LAMBDA-1)
C     SL2, CL2, TL2  SIN(LAMBDA-2), .....
C     SGS, CGS       SIN(GAMMA-S),  ....
C     SGR, CGR       SIN(GAMMA-R),  ....
C     X01            X-XI1
C     X02            X-XI2
C     Y0             Y - ETA
C     Z0             Z - ZETA
C     E
C     BETA           SQRT(1-FMACH**2)
C     CV
C     BR
C     FMACH          MACH NO.
C     BRE            REAL PART OF B      (RETURNED)
C     BIM            IMAGINARY PART OF B (RETURNED)
C
      REAL           KR, KD1, KD2
C
C     VARIABLES DIMENSIONED (2), FIRST WORD IS THE REAL PART OF THE
C     VALUE AND THE SECOND IS THE IMAGINARY PART
C
      DIMENSION      DKI(2), DKC(2), DKO(2), KD1(2), KD2(2)
C
      DATA  PI48   / 150.79644720 /
C
C     CALCULATE  BS
C
      L  = 1
      CV = X01 - X02
      SL = SL1
      CL = CL1
      TL = TL1
      X0 = X01
      EE = E**2
      TE = 2.0*E
      ASSIGN 50 TO ISNP
C
C     CALL SNPDF
C
      GO TO 1000
   50 BS = DIJ
      SL = SL2
      CL = CL2
      TL = TL2
      X0 = X02
      ASSIGN 100 TO ISNP
C
C     CALL SNPDF
C
      GO TO 1000
  100 BS = BS - DIJ
C
C     CALCULATE   DELTA-B
C     LIMITS FOR SMALL VALUES OF RADII
C
      EPS = 0.25*EE
      IB  = 0
      FB  = 1.0
      FC  = 4.0
C
C     FIRST CALC.
C     DELTA-KD- 1I, 1C, AND 1O
C
      ETL1 = E*TL1
      ETL2 = E*TL2
      ESGS = E*SGS
      ECGS = E*CGS
C
      DX01 = X01 + ETL1
      DX02 = X02 + ETL2
      DY0  = Y0  + ECGS
      DZ0  = Z0  + ESGS
      ASSIGN 200 TO IFLLD
C
C     CALCULATE  R-I  SQUARED AND CALL FLLD IF LARGE ENOUGH
C
      R2  = DY0**2 + DZ0**2
      IF (R2 .GE. EPS) GO TO 2000
      IB  = 1
      FC  = 6.0
      FB  = 0.0
      GO TO 230
  200 DKI(1) = KD1(1)/R2 + KD2(1)/R4
      DKI(2) = KD1(2)/R2 + KD2(2)/R4
C
C     KD1C AND KD2C
C
  230 DX01 = X01
      DX02 = X02
      DY0  = Y0
      DZ0  = Z0
      ASSIGN 300 TO IFLLD
C
C     CALCULATE  R-C  SQUARED AND CALL FLLD IF LARGE ENOUGH
C
      R2 = DY0**2 + DZ0**2
      IF (R2 .GE. EPS) GO TO 2000
      FC = 0.0
      FB = 3.0
      GO TO 330
  300 DKC(1) = KD1(1)/R2 + KD2(1)/R4
      DKC(2) = KD1(2)/R2 + KD2(2)/R4
C
C     KD1O AND KD2O
C     SKIP IF  R-I IS TOO SMALL
C
  330 IF (IB .NE. 0) GO TO 430
      DX01 = X01 - ETL1
      DX02 = X02 - ETL2
      DY0  = Y0  - ECGS
      DZ0  = Z0  - ESGS
      ASSIGN 400 TO IFLLD
C
C     CALCULATE  R-O  SQUARED AND CALL FLLD IF LARGE ENOUGH
C
      R2 = DY0**2 + DZ0**2
      IF (R2 .GE. EPS) GO TO 2000
      FB = 0.0
      FC = 6.0
      IB = 1
      GO TO 430
  400 DKO(1) = KD1(1)/R2 + KD2(1)/R4
      DKO(2) = KD1(2)/R2 + KD2(2)/R4
C
  430 COEF = 1.0/PI48
      BRE  = BS/(TE*CV) - COEF*(FB*(DKI(1) + DKO(1)) + FC*DKC(1))
      BIM  =            - COEF*(FB*(DKI(2) + DKO(2)) + FC*DKC(2))
      RETURN
C
 1000 CALL SNPDF (SL,CL,TL,SGS,CGS,SGR,CGR,X0,Y0,Z0,E,DIJ,BETA,CV)
      GO TO ISNP, (50,100)
C
 2000 CALL FLLD (DX01,DX02,DY0,DZ0,SGR,CGR,SGS,CGS,KR,CBAR,FMACH,E,L,
     1           KD1(1),KD1(2),KD2(1),KD2(2))
      R4 = R2*R2
      GO TO IFLLD, (200,300,400)
C
      END

      SUBROUTINE TRIAAD
C
C     THIS SUBROUTINE COMPUTES THE STIFFNESS AND MASS MATRICES FOR THE
C     ASSYMMETRIC RING WITH A TRIANGULAR CROSS SECTION, TO BE USED BY
C     THE ELEMENT MATRIX GENERATOR.
C
C     DOUBLE PRECISION VERSION
C
C     THIS CURRENT VERSION ALLOWS FOR COORDINATE SYSTEM
C     THIS SUBROUTINE USES THE ADDITIONAL ROUTINES DKL, DELTKL
C
C     THE ECPT FOR THE TRIAX ELEMENT IS
C
C     ECPT (01) = ELEMENT ID                              I
C     ECPT (02) = SIL A                                   I
C     ECPT (03) = SIL B                                   I
C     ECPT (04) = SIL C                                   I
C     ECPT (05) = MATERIAL ORIENTATION ANGLE(DEGREES)     R
C     ECPT (07) = MATERIAL ID                             I
C     ECPT (08) TO ECPT(21) = STRESS PHASE ANG.           R
C     ECPT (22) = CORD. SYS. GRID POINT A (NOT USED)      I
C     ECPT (23) = R-CORD OF GRID A                        R
C     ECPT (24) = Z-CORD OF GRID A                        R
C     ECPT (25) = 0.0                                     R
C     ECPT (26) = CORD. SYS. GRID POINT B (NOT USED)      I
C     ECPT (27) = R-CORD OF GRID B                        R
C     ECPT (28) = Z-CORD OF GRID B                        R
C     ECPT (29) = 0.0                                     R
C     ECPT (30) = CORD. SYS. GRID POINT C (NOT USED)      I
C     ECPT (31) = R-CORD OF GRID C                        R
C     ECPT (32) = Z-CORD OF GRID C                        R
C     ECPT (33) = 0.0                                     R
C     ECPT (34) = EL. TEMPERATURE FOR MATERIAL PROP       R
C
C     ANY GROUP OF STATEMENTS PREFACED BY AN IF STATEMENT CONTAINING
C     ...KSYS78 OR LSYS78 ...  INDICATES CODING NECESSARY FOR THIS
C     ELEMENT*S PIEZOELECTRIC CAPABILITY
C
C     KSYS78 = 0   ELASTIC, NON-PIEZOELECTRIC MATERIAL
C     KSYS78 = 1   ELECTRICAL-ELASTIC COUPLED, PIEZOELETRIC MATERIAL
C     KSYS78 = 2   ELASTIC ONLY, PIEZOELECTRIC MATERIAL
C     LSYS78 = .TRUE. IF KSYS78 = 0, OR 2
C
      LOGICAL         PZMAT,LSYS78,NOGO,HEAT
      INTEGER         DICT(11),ELID,ESTID,ISORT(3)
      DOUBLE PRECISION ZA,AKI,AKT,ACURL,D(81),AK(81),AKJ,
     1                GABABQ(9,9),R(3),Z(3),EE(63),TEO,DELINT(12),
     2                DELM(12),BMASS(9,9),AKM(81),AKJM(81),AMT(9),
     3                Z1,Z2,Z3,PI,TWOPI,DEGRAD,ZMIN,AA,C1,C2,C3,
     4                COSG,SING,ER,ET,EZ,VRO,VOZ,VZR,
     5                GOR,GZO,GRZ,VOR,VZO,VRZ,DEL,DKL,C4,S2,S4,DGAMR,
     6                AJHO,AJJHO,RHOD,DGAMAR,CONVM,AREA,C2S2,
     7                ACURP1(27),ACURP2(9),AKUPH(27),AKPH2(9),AKIP(9),
     8                GABABP(3,3),D1(27),D2(9),CONSTS
      DIMENSION       IECPT(34),ICS(3),ECPT(34)
      COMMON /TRIAXX/ AKI(81),AKT(16),ACURL(117),AKJ(144),TEO(45)
      COMMON /SYSTEM/ KSYSTM(77),KSYS78
      COMMON /EMGPRM/ IXTRA,DUM(14),ISMB(3),IPREC,NOGO,HEAT,ICMBAR
      COMMON /EMGDIC/ DXX,LDICT,NGRIDS,ELID,ESTID
      COMMON /EMGEST/ IDEL,IGP(3),DGAMA,DM1,MATID,SPA(14),ICS1,R1,ZZ1,
     1                ZER,ICS2,R2,ZZ2,ZER2,ICS3,R3,ZZ3,ZER3,TEMPE
      COMMON /MATIN / MATIDC,MATFLG,ELTEMP,STRESS,SINTH,COSTH
      COMMON /MATOUT/ E(3),ANU(3),RHO,G(3),ALF(3),TZERO,GSUBE,MOSKP(9),
     1                SETMAT
      COMMON /CONDAD/ CONSTS(5)
      COMMON /MATPZ / PZOUT(51)
C
C     COMMON /MATPZ / CE11,CE12,CE13,CE14,CE15,CE16,CE22,CE23,CE24,CE25,
C                     CE26,CE33,CE34,CE35,CE36,CE44,CE45,CE46,CE55,CE56,
C                     CE66,E11,E12,E13,E14,E15,E16,E21,E22,E23,E24,E25,
C                     E26,E31,E32,E33,E34,E35,E36,EPS11,EPS12,EPS13,
C                     EPS22,EPS23,EPS33,RHO,A1,A2,A12,TREF,GE
C
      EQUIVALENCE     (IECPT(1),ECPT(1),IDEL), (DICT(5),DICT5),
     1                (Z(1),Z1), (Z(2),Z2), (Z(3),Z3),
     2                (AKI(1),GABABQ(1,1)), (BMASS(1,1),AKM(1)),
     3                (CONSTS(1),PI), (CONSTS(4),DEGRAD),
     4                (CONSTS(2),TWOPI), (AKIP(1),GABABP(1,1)),
     5                (ACURP1(1),ACURL(82)), (ACURP2(1),ACURL(109))
      DATA    IDEL2 , JAX / 0, 4HTRIA /
C
      LSYS78 = .FALSE.
      IF (KSYS78.EQ.0 .OR. KSYS78.EQ.2) LSYS78 = .TRUE.
      IDEL1 = IDEL/1000
C
C     INITALIZE
C
      DO 40 I = 1,403
 40   AKI(I) = 0.D0
      DO 50 I = 1,3
      R(I)   =  ECPT(4*I+19)
      Z(I)   =  ECPT(4*I+20)
   50 ICS(I) = IECPT(4*I+18)
C
      DICT(1) = ESTID
      DICT(2) = 1
      DICT(3) = 12
      DICT(4) = 15
      IPR     = IPREC
C
      IF (R1.LE.0. .OR. R2.LE.0. .OR. R3.LE.0.) GO TO 7770
C
C     COMPUTE THE ELEMENT COORDINATES
C
      ZMIN = DMIN1(Z1,Z2,Z3)
      Z1 = Z1 - ZMIN
      Z2 = Z2 - ZMIN
      Z3 = Z3 - ZMIN
C
C     FORM TRANSFORMATION MATRIX GABABQ (9X9) FROM FIELD COORDINATES TO
C     GRID POINT DEGREES OF FREEDOM
C
      DO  100 I = 1,9
      DO  100 J = 1,9
  100 GABABQ(I,J) = 0.D0
C
      AA =  1.D0/(R2*Z3 + R1*Z2 + Z1*R3 - Z2*R3 - R1*Z3 - R2*Z1)
      C1 =  AA*(R2*Z3 - Z2*R3)
      C2 = -AA*(Z3 - Z2)
      C3 =  AA*(R3 - R2)
      GABABQ(1,1) = C1
      GABABQ(1,2) = C2
      GABABQ(1,3) = C3
      GABABQ(2,4) = C1
      GABABQ(2,5) = C2
      GABABQ(2,6) = C3
      GABABQ(3,7) = C1
      GABABQ(3,8) = C2
      GABABQ(3,9) = C3
      IF (LSYS78) GO TO 102
      GABABP(1,1) = C1
      GABABP(1,2) = C2
      GABABP(1,3) = C3
  102 CONTINUE
      C1 = -AA*(R1*Z3 - Z1*R3)
      C2 =  AA*(Z3 - Z1)
      C3 = -AA*(R3 - R1)
      GABABQ(4,1) = C1
      GABABQ(4,2) = C2
      GABABQ(4,3) = C3
      GABABQ(5,4) = C1
      GABABQ(5,5) = C2
      GABABQ(5,6) = C3
      GABABQ(6,7) = C1
      GABABQ(6,8) = C2
      GABABQ(6,9) = C3
      IF (LSYS78) GO TO 104
      GABABP(2,1) = C1
      GABABP(2,2) = C2
      GABABP(2,3) = C3
  104 CONTINUE
      C1 =  AA*(R1*Z2 - Z1*R2)
      C2 = -AA*(Z2 - Z1)
      C3 =  AA*(R2 - R1)
      GABABQ(7,1) = C1
      GABABQ(7,2) = C2
      GABABQ(7,3) = C3
      GABABQ(8,4) = C1
      GABABQ(8,5) = C2
      GABABQ(8,6) = C3
      GABABQ(9,7) = C1
      GABABQ(9,8) = C2
      GABABQ(9,9) = C3
      IF (LSYS78) GO TO 110
      GABABP(3,1) = C1
      GABABP(3,2) = C2
      GABABP(3,3) = C3
  110 CONTINUE
C
C     COMPUTE THE INTEGRAL VALUES IN ARRAY DELINT THE ORDER IS INDICATED
C     THE FOLLOWING TABLE
C
C     DELINT(01) = (-1,0)
C     DELINT(02) = (-1,1)
C     DELINT(03) = (-1,2)
C     DELINT(04) = ( 0,0)
C     DELINT(05) = ( 0,1)
C     DELINT(06) = ( 1,0)
C
C     OR FOR THE MASS MATRIX
C
C     DELINT(1)  =  (1,0)
C     DELINT(2)  =  (1,1)
C     DELINT(3)  =  (1,2)
C     DELINT(4)  =  (2,0)
C     DELINT(5)  =  (2,1)
C     DELINT(7)  =  (3,0)
C
C
      IF (ISMB(1) .EQ. 0) GO TO 180
      RA = (R1 + R2 + R3)/3.0
      ZA = (Z1 + Z2 + Z3)/3.0D0
      RH = AMIN1(R1,R2,R3)/10.0
      DR = AMAX1(ABS(R1-R2),ABS(R2-R3),ABS(R3-R1))
      AREA = (R1*(Z2-Z3) + R2*(Z3-Z1) + R3*(Z1-Z2))/2.0D0
C
      I1 = 0
      DO 160 I = 1,2
      IP = I - 2
      DO 140 J = 1,3
      IQ =  J  - 1
      I1 =  I1 + 1
      IF (I1 .NE. 6) GO TO 120
      IP = 1
      IQ = 0
  120 IF (DR .GT. RH) GO TO 130
      DELINT(I1) = ((RA**IP)*(ZA**IQ))*AREA
      GO TO 135
  130 DELINT(I1) = DKL(3,IP,IQ,R,Z)
  135 DELINT(I1) = DABS(DELINT(I1))
  140 CONTINUE
  160 CONTINUE
C
C     MASS MATRIX
C
      IF (ISMB(2) .EQ. 0) GO TO 200
  180 CALL DELTKL (AKJ,R,Z,0)
      DELM(1) = AKJ(2)
      DELM(2) = AKJ(7)
      DELM(3) = AKJ(8)
      DELM(4) = AKJ(10)
      DELM(5) = AKJ(9)
      DELM(7) = AKJ(12)
C
C     LOCATE THE MATERIAL PROPERTIES IN THE MAT1 OR MAT3
C
200   DGAMR  = DBLE(DGAMA)*DEGRAD
      COSG   = DCOS(DGAMR)
      SING   = DSIN(DGAMR)
      SINTH  = SING
      COSTH  = COSG
      MATIDC = MATID
      MATFLG = 7
      IF (KSYS78 .GT. 0) MATFLG = 9
      ELTEMP = TEMPE
      CALL MAT (IDEL)
      PZMAT = .FALSE.
      IF (SETMAT.EQ.4. .OR. SETMAT.EQ.5.) PZMAT = .TRUE.
      IF (PZMAT) GO TO 210
      KSAVE  = KSYS78
      KSYS78 = 0
      LSYS78 = .TRUE.
      GO TO 220
  210 RHO = PZOUT(46)
      ALF(1) = PZOUT(47)
      ALF(2) = PZOUT(48)
      ALF(3) = PZOUT(49)
      TZERO  = PZOUT(50)
      GSUBE  = PZOUT(51)
  220 CONTINUE
      IF (SETMAT .EQ. 2.) GO TO 7780
      DICT5 = G SUB E
      IF (KSYS78 .GT. 0) GO TO 249
C
C     SET MATERIAL PROPERTIES IN DOUBLE PRECISION VARIABLES
C
      ER  = E(1)
      ET  = E(2)
      EZ  = E(3)
      VRO = ANU(1)
      VOZ = ANU(2)
      VZR = ANU(3)
      GOR = G(1)
      GZO = G(2)
      GRZ = G(3)
      VOR = VRO*ET/ER
      VZO = VOZ*EZ/ET
      VRZ = VZR*ER/EZ
      DEL = 1.D0/(1.D0 - VRO*VOR  - VOZ*VZO - VZR*VRZ
     1    - VRO*VOZ*VZR - VRZ*VOR*VZO)
C
C     COMPUTE ELASTIC CONSTANTS MATRIX FROM MATERIAL TO ELEMENT AXIS
C
  249 CONTINUE
      DO 250 I = 1,45
  250 TEO(I) = 0.D0
C
      IF (KSYS78 .GT. 0) GO TO 251
      TEO( 1) = ER*(1.  - VOZ*VZO)*DEL
      TEO( 2) = ER*(VZR + VZO*VOR)*DEL
      TEO( 3) = EZ*(1.  - VRO*VOR)*DEL
      TEO( 4) = ER*(VOR + VZR*VOZ)*DEL
      TEO( 5) = ET*(VZO + VRO*VZR)*DEL
      TEO( 6) = ET*(1.  - VRZ*VZR)*DEL
      TEO(10) = GRZ
      TEO(15) = GOR
      TEO(21) = GZO
      GO TO 252
  251 CONTINUE
C
C     PIEZOELECTRIC MATERIAL PROPERTIES STORED IN TEO(22-39)
C     DIELECTRIC MATERIAL PROPERTIES STORED IN TEO(40-45)
C     TEO(22-39) CONTAINS E-TRANSPOSE
C
      TEO( 1) = PZOUT( 1)
      TEO( 2) = PZOUT( 2)
      TEO( 3) = PZOUT( 7)
      TEO( 4) = PZOUT( 3)
      TEO( 5) = PZOUT( 8)
      TEO( 6) = PZOUT(12)
      TEO( 7) = PZOUT( 4)
      TEO( 8) = PZOUT( 9)
      TEO( 9) = PZOUT(13)
      TEO(10) = PZOUT(16)
      TEO(11) = PZOUT( 5)
      TEO(12) = PZOUT(10)
      TEO(13) = PZOUT(14)
      TEO(14) = PZOUT(17)
      TEO(15) = PZOUT(19)
      TEO(16) = PZOUT( 6)
      TEO(17) = PZOUT(11)
      TEO(18) = PZOUT(15)
      TEO(19) = PZOUT(18)
      TEO(20) = PZOUT(20)
      TEO(21) = PZOUT(21)
      IF (KSYS78 .EQ. 2) GO TO 252
      TEO(22) = PZOUT(22)
      TEO(23) = PZOUT(28)
      TEO(24) = PZOUT(34)
      TEO(25) = PZOUT(23)
      TEO(26) = PZOUT(29)
      TEO(27) = PZOUT(35)
      TEO(28) = PZOUT(24)
      TEO(29) = PZOUT(30)
      TEO(30) = PZOUT(36)
      TEO(31) = PZOUT(25)
      TEO(32) = PZOUT(31)
      TEO(33) = PZOUT(37)
      TEO(34) = PZOUT(26)
      TEO(35) = PZOUT(32)
      TEO(36) = PZOUT(38)
      TEO(37) = PZOUT(27)
      TEO(38) = PZOUT(33)
      TEO(39) = PZOUT(39)
      TEO(40) =-PZOUT(40)
      TEO(41) =-PZOUT(41)
      TEO(42) =-PZOUT(42)
      TEO(43) =-PZOUT(43)
      TEO(44) =-PZOUT(44)
      TEO(45) =-PZOUT(45)
  252 CONTINUE
      C2  = COSG*COSG
      C4  = C2  *C2
      S2  = SING*SING
      S4  = S2  *S2
      C2S2 = C2*S2
      C3  = COSG*C2
      S3  = SING*S2
      CS2 = COSG*S2
      SC2 = SING*C2
      CS  = COSG*SING
C
      EE( 1) = TEO(1)*C4 + TEO(3)*S4 + 2.*C2S2*(TEO(2) + 2.*TEO(10))
      EE( 2) = TEO(2)*(C4+S4) + C2S2*(TEO(1)+TEO(3) - 4.*TEO(10))
      EE( 3) = TEO(4)*C2 + TEO(5)*S2
      EE( 4) = COSG*SING*S2*(TEO(2) - TEO(3) + 2.*TEO(10))
     4       + SING*COSG*C2*(TEO(1) - TEO(2) - 2.*TEO(10))
      EE( 7) = EE(2)
      EE( 8) = TEO(1)*S4 + 2.*C2S2*(TEO(2) + 2.*TEO(10)) + TEO(3)*C4
      EE( 9) = TEO(4)*S2 + TEO(5)*C2
      EE(10) = SING*COSG*C2*(TEO(2) - TEO(3) + 2.*TEO(10))
     O       + COSG*SING*S2*(TEO(1) - TEO(2) - 2.*TEO(10))
      EE(13) = EE(3)
      EE(14) = EE(9)
      EE(15) = TEO(6)
      EE(16) = SING*COSG*(TEO(4)-TEO(5))
      EE(19) = EE(4)
      EE(20) = EE(10)
      EE(21) = EE(16)
      EE(22) = C2S2*(TEO(1) - 2.*TEO(2) + TEO(3)) + TEO(10)*(C2-S2)**2
      EE(29) = TEO(15)*C2 + TEO(21)*S2
      EE(30) = SING*COSG*(TEO(15)-TEO(21))
      EE(35) = EE(30)
      EE(36) = TEO(15)*S2 + TEO(21)*C2
C
      IF (LSYS78) GO TO 254
C
C     PIEZOELECTRIC MATERIAL PROPERTIES IN ELEMENT COORDINATES
C
      EE(37) = C3*TEO(22) - S3*TEO(26) + CS2*(TEO(25)+2.0*TEO(32)) -
     7         SC2*(TEO(23)+2.0*TEO(31))
      EE(38) = C3*TEO(23) + S3*TEO(25) + CS2*(TEO(26)-2.0*TEO(31)) +
     8         SC2*(TEO(22) - 2.0*TEO(32))
      EE(39) = S2*TEO(27) + C2*TEO(24) - 2.0*CS*TEO(33)
      EE(40) = C3*TEO(25) - S3*TEO(23) + CS2*(TEO(22)-2.0*TEO(32)) -
     O         SC2*(TEO(26) - 2.0*TEO(31))
      EE(41) = C3*TEO(26) + S3*TEO(22) + CS2*(TEO(23)+2.0*TEO(31)) +
     1         SC2*(TEO(25) + 2.0*TEO(32))
      EE(42) = S2*TEO(24) + C2*TEO(27) + 2.0*CS*TEO(33)
      EE(43) = COSG*TEO(28) - SING*TEO(29)
      EE(44) = COSG*TEO(29) + SING*TEO(28)
      EE(45) = TEO(30)
      EE(46) = C3*TEO(31) + S3*TEO(32) - CS2*(TEO(23)-TEO(26)+TEO(31)) +
     6         SC2*(-TEO(32) - TEO(25)+TEO(22))
      EE(47) = C3*TEO(32) - S3*TEO(31) - CS2*(TEO(25)-TEO(22)+TEO(32)) +
     7         SC2*(TEO(23) + TEO(31)-TEO(26))
      EE(48) = (C2-S2)*TEO(33) + CS*(TEO(24)-TEO(27))
      EE(49) = C2*TEO(34) + S2*TEO(38) - CS*(TEO(35)+TEO(37))
      EE(50) = C2*TEO(35) - S2*TEO(37) + CS*(TEO(34)-TEO(38))
      EE(51) = COSG*TEO(36) - SING*TEO(39)
      EE(52) = C2*TEO(37) - S2*TEO(35) - CS*(TEO(38)-TEO(34))
      EE(53) = C2*TEO(38) + S2*TEO(34) + CS*(TEO(35)+TEO(37))
      EE(54) = COSG*TEO(39) + SING*TEO(36)
C
C     DIELECTRIC MATERIAL PROPERTIES IN ELEMENT COORDINTES
C
      EE(55) = S2*TEO(43) - 2.0*CS*TEO(41) + C2*TEO(40)
      EE(56) = (C2-S2)*TEO(41) - CS*(TEO(43) - TEO(40))
      EE(57) =-SING*TEO(44) + COSG*TEO(42)
      EE(59) = C2*TEO(43) + 2.0*CS*TEO(41) + S2*TEO(40)
      EE(60) = COSG*TEO(44) + SING*TEO(42)
      EE(63) = TEO(45)
  254 CONTINUE
C
C     COMPUTE HARMONIC COEFFICIENT
C
      MJHO = MOD(IECPT(1),1000) - 1
      AJHO = MJHO
      AJJHO= AJHO*AJHO
      RHOD = RHO *PI
      IF (AJHO .EQ. 0.D0) RHOD = 2.*RHOD
      IF (ISMB(1) .EQ. 0) GO TO 300
C
C     FORM THE ELEMENT STIFFNESS MATRIX IN FIELD SYSTEM
C
      ACURL(01) = (EE(15) + AJJHO*EE(29))*DELINT(1)
      ACURL(02) = (EE(03) + EE(15) + AJJHO*EE(29))*DELINT(4)
      ACURL(03) = (EE(15) + AJJHO*EE(29))*DELINT(2) + EE(16)*DELINT(4)
      ACURL(04) = (EE(15) + EE(29))*AJHO*DELINT(1)
      ACURL(05) = EE(15)*AJHO*DELINT(4)
      ACURL(06) = (EE(15) + EE(29))*AJHO*DELINT(2) -
     6            EE(30)*AJHO*DELINT(4)
      ACURL(07) = AJJHO*DELINT(1)*EE(35)
      ACURL(08) = (EE(16) + AJJHO*EE(35))*DELINT(4)
      ACURL(09) = EE(09)*DELINT(4) + AJJHO*DELINT(2)*EE(35)
      ACURL(11) = (EE(1) + 2.*EE(3) + EE(15) + AJJHO*EE(29))*DELINT(6)
      ACURL(12) = (EE(3) + EE(15) + AJJHO*EE(29))*DELINT(5)
     2          + (EE(4) + EE (16))*DELINT(6)
      ACURL(13) = (EE(3) + EE(15) + EE(29))*AJHO*DELINT(4)
      ACURL(14) = (EE(3) + EE(15))*DELINT(6)*AJHO
      ACURL(15) = (EE(3) + EE(15) + EE(29))*AJHO*DELINT(5) -
     5            AJHO*EE(30)*DELINT(6)
      ACURL(16) = AJJHO*DELINT(4)*EE(35)
      ACURL(17) = (EE(4) + EE(16) + AJJHO*EE(35))*DELINT(6)
      ACURL(18) = (EE(2) + EE(9))*DELINT(6) + AJJHO*DELINT(5)*EE(35)
      ACURL(21) = (EE(15) + AJJHO*EE(29))*DELINT(3) +
     1            EE(22)*DELINT(6) + 2.*EE(16)*DELINT(5)
      ACURL(22) = (EE(15) + EE(29))*AJHO*DELINT(2) +
     2            AJHO*DELINT(4)*EE(16)
      ACURL(23) = EE(15)*AJHO*DELINT(5) + AJHO*DELINT(6)*EE(16)
      ACURL(24) = (EE(15) + EE(29))*AJHO*DELINT(3) + (EE(16)-EE(30))
     4          * AJHO*DELINT(5)
      ACURL(25) = AJJHO*DELINT(2)*EE(35)
      ACURL(26) = EE(22)*DELINT(6) + (EE(21) + AJJHO*EE(35))*DELINT(5)
      ACURL(27) = EE(9)*DELINT(5) + EE(10)*DELINT(6) +
     7            AJJHO*DELINT(3)*EE(35)
      ACURL(31) = (EE(29) + AJJHO*EE(15))*DELINT(1)
      ACURL(32) = EE(15)*AJJHO*DELINT(4)
      ACURL(33) = (EE(29) + AJJHO*EE(15))*DELINT(2) - EE(30)*DELINT(4)
      ACURL(34) = AJHO*DELINT(1)*EE(35)
      ACURL(35) = AJHO*(EE(16) + EE(35))*DELINT(4)
      ACURL(36) = EE(9)*AJHO*DELINT(4) + AJHO*DELINT(2)*EE(35)
      ACURL(41) = AJJHO*DELINT(06)*EE(15)
      ACURL(42) = EE(15)*AJJHO*DELINT(5)
      ACURL(43) = 0.
      ACURL(44) = AJHO*DELINT(6)*EE(16)
      ACURL(45) = EE(9)*AJHO*DELINT(6)
      ACURL(51) = (EE(29) + AJJHO*EE(15))*DELINT(3) + EE(36)*DELINT(6)
     1          - 2.*EE(35)*DELINT(5)
      ACURL(52) = AJHO*(DELINT(2)*EE(30) - DELINT(4)*EE(36))
      ACURL(53) = -EE(36)*AJHO*DELINT(6) + AJHO*(EE(16) + EE(35))
     3          * DELINT(5)
      ACURL(54) = (EE(9) - EE(36))*AJHO*DELINT(5) +
     4            AJHO*DELINT(3)*EE(35)
      ACURL(61) = EE(36)*AJJHO*DELINT(1)
      ACURL(62) = EE(36)*AJJHO*DELINT(4)
      ACURL(63) = EE(36)*AJJHO*DELINT(2)
      ACURL(71) = (EE(22) + AJJHO*EE(36))*DELINT(6)
      ACURL(72) = EE(36)*AJJHO*DELINT(5) + EE(20)*DELINT(6)
      ACURL(81) = EE(36)*AJJHO*DELINT(3) + EE(8)*DELINT(6)
      IF (LSYS78) GO TO 256
      ACURL(82) =-(EE(45) - AJHO*EE(51))*AJHO*DELINT(1)
      ACURL(83) = (EE(43) - AJHO*EE(45) - AJHO*EE(49) + AJJHO*EE(51))
     3          * DELINT(4)
      ACURL(84) = (EE(44) - AJHO*EE(50))*DELINT(4) - (EE(45)
     4          - AJHO*EE(51))*AJHO*DELINT(2)
      ACURL(85) =-(EE(39) + EE(45) - AJHO*EE(51))*AJHO*DELINT(4)
      ACURL(86) = (EE(37) + EE(43) - (EE(39) + EE(45) + EE(49)
     6          - AJHO*EE(51))*AJHO)*DELINT(6)
      ACURL(87) = (EE(38) + EE(44) - AJHO*EE(50))*DELINT(6) - (EE(39)
     7          + EE(45) - AJHO*EE(51))*AJHO*DELINT(5)
      ACURL(88) =-(EE(45) - AJHO*EE(51))*AJHO*DELINT(2) - EE(48)*AJHO
     8          * DELINT(4)
      ACURL(89) = (EE(43) - AJHO*EE(45) - AJHO*EE(49) + AJJHO*EE(51))
     9          * DELINT(5) + (EE(46) - EE(48)*AJHO)*DELINT(6)
      ACURL(90) = (EE(44) - AJHO*EE(48) - AJHO*EE(50))*DELINT(5)
     O          + EE(47)*DELINT(6) - (EE(45)-AJHO*EE(51))*AJHO*DELINT(3)
      ACURL(91) =-(EE(45)*AJHO - EE(51))*AJHO*DELINT(1)
      ACURL(92) = (AJHO*EE(43) - AJJHO*EE(45) - EE(49) + AJHO*EE(51))
     2          * DELINT(4)
      ACURL(93) = (EE(44)*AJHO - EE(50))*DELINT(4) - (EE(45)*AJHO
     3          - EE(51))*AJHO*DELINT(2)
      ACURL(94) =-EE(45)*AJJHO*DELINT(4)
      ACURL(95) = (EE(43) - AJHO*EE(45))*AJHO*DELINT(6)
      ACURL(96) = EE(44)*AJHO*DELINT(6) - EE(45)*AJJHO*DELINT(5)
      ACURL(97) =-(EE(45)*AJHO - EE(51))*AJHO*DELINT(2) - EE(54)*AJHO
     7          * DELINT(4)
      ACURL(98) = (EE(43)*AJHO - AJJHO*EE(45) - EE(49) + EE(51)*AJHO)
     8          * DELINT(5) + (EE(52) - AJHO*EE(54))*DELINT(6)
      ACURL(99) = (EE(44)*AJHO - EE(50) - EE(54)*AJHO)*DELINT(5)
     9          + EE(53)*DELINT(6) - (EE(45)*AJHO - EE(51))*AJHO
     9          * DELINT(3)
      ACURL(100)= EE(54)*AJJHO*DELINT(1)
      ACURL(101)=-(EE(52) - EE(54)*AJHO)*AJHO*DELINT(4)
      ACURL(102)=-(EE(53)*DELINT(4) - EE(54)*AJHO*DELINT(2))*AJHO
      ACURL(103)=-(EE(48) - EE(54)*AJHO)*AJHO*DELINT(4)
      ACURL(104)= (EE(46) - EE(48)*AJHO - EE(52)*AJHO+EE(54)*AJJHO)
     4          * DELINT(6)
      ACURL(105)= (EE(47) - EE(53)*AJHO)*DELINT(6) - (EE(48) - EE(54)
     5          * AJHO)*AJHO*DELINT(5)
      ACURL(106)= EE(54)*AJJHO*DELINT(2) - EE(42)*AJHO*DELINT(4)
      ACURL(107)= (EE(40) - EE(42)*AJHO)*DELINT(6) - (EE(52) - EE(54)
     7          * AJHO)*AJHO*DELINT(5)
      ACURL(108)= EE(41)*DELINT(6) + (-EE(42) - EE(53))*AJHO*DELINT(5)
     8          + EE(54)*AJJHO*DELINT(3)
C
      ACURL(109)= EE(63)*AJJHO*DELINT(1)
      ACURL(110)= (-EE(57) + EE(63)*AJHO)*AJHO*DELINT(4)
      ACURL(111)=-EE(60)*AJHO*DELINT(4) + EE(63)*AJJHO*DELINT(2)
      ACURL(112)= ACURL(110)
      ACURL(113)= (EE(55) - 2.0*EE(57)*AJHO+EE(63)*AJJHO)*DELINT(6)
      ACURL(114)= (EE(56) - EE(60)*AJHO)*DELINT(6) + (-EE(57) + EE(63)
     4          * AJHO)*AJHO*DELINT(5)
      ACURL(115)= ACURL(111)
      ACURL(116)= ACURL(114)
      ACURL(117)= EE(59)*DELINT(6) - 2.0*EE(60)*AJHO*DELINT(5) + EE(63)
     7          * AJJHO*DELINT(3)
  256 CONTINUE
C
C     EXPAND ACURL INTO (9X9)
C
      DO 270 IB = 2,9
      IC = 10*IB - 19
      I  = IC
      DO 260  J = IB,9
      IC = IC + 9
      I  = I  + 1
  260 ACURL(IC) = ACURL(I)
  270 CONTINUE
      DGAMAR = PI
      IF (AJHO .EQ. 0.D0) DGAMAR = TWOPI
      DO 280 I = 1,81
  280 ACURL(I) = ACURL(I)*DGAMAR
      IF (LSYS78) GO TO 300
C
      DO 290 I = 82,117
  290 ACURL(I) = ACURL(I)*DGAMAR
C
  300 IF (ISMB(2).EQ. 0) GO TO 400
      IF (ICMBAR .LT. 0) GO TO 350
C
C     CONSISTENT MASS IN FIELD COORDINATES
C
      DO 320 I = 1,81
  320 BMASS(I,1) = 0.
      BMASS(1,1) = RHOD*DELM(1)
      BMASS(1,2) = RHOD*DELM(4)
      BMASS(1,3) = RHOD*DELM(2)
      BMASS(2,1) = RHOD*DELM(4)
      BMASS(2,2) = RHOD*DELM(7)
      BMASS(2,3) = RHOD*DELM(5)
      BMASS(3,1) = RHOD*DELM(2)
      BMASS(3,2) = RHOD*DELM(5)
      BMASS(3,3) = RHOD*DELM(3)
      BMASS(4,4) = RHOD*DELM(1)
      BMASS(4,5) = RHOD*DELM(4)
      BMASS(4,6) = RHOD*DELM(2)
      BMASS(5,4) = RHOD*DELM(4)
      BMASS(5,5) = RHOD*DELM(7)
      BMASS(5,6) = RHOD*DELM(5)
      BMASS(6,4) = RHOD*DELM(2)
      BMASS(6,5) = RHOD*DELM(5)
      BMASS(6,6) = RHOD*DELM(3)
      BMASS(7,7) = RHOD*DELM(1)
      BMASS(7,8) = RHOD*DELM(4)
      BMASS(7,9) = RHOD*DELM(2)
      BMASS(8,7) = RHOD*DELM(4)
      BMASS(8,8) = RHOD*DELM(7)
      BMASS(8,9) = RHOD*DELM(5)
      BMASS(9,7) = RHOD*DELM(2)
      BMASS(9,8) = RHOD*DELM(5)
      BMASS(9,9) = RHOD*DELM(3)
      GO TO 400
  350 AREA  = (R1*(Z2-Z3) + R2*(Z3-Z1) + R3*(Z1-Z2))/2.
      CONVM =  RHOD*(R1 + R2 + R3)/3.*AREA
C
C     TRANSFORM THE ELEMENT STIFFNESS MATRIX FROM FIELD SYSTEM
C     TO GRID POINT DEGREES OF FREEDOM
C
  400 IF (ISMB(1) .EQ. 0) GO TO 410
      CALL GMMATD (AKI,9,9,1,ACURL,9,9,0,D )
      CALL GMMATD (D,  9,9,0,AKI  ,9,9,0,AK)
      IF (LSYS78) GO TO 405
      CALL GMMATD (AKI,9,9,1,ACURP1,9,3,0,D1)
      CALL GMMATD (D1, 9,3,0,AKIP,  3,3,0,AKUPH)
      CALL GMMATD (AKIP,3,3,1,ACURP2,3,3,0,D2)
      CALL GMMATD (D2,  3,3,0,AKIP,  3,3,0,AKPH2)
  405 CONTINUE
C
      IF (ISMB(2).EQ.0 .OR. ICMBAR.LT.0) GO TO 450
  410 CALL GMMATD (AKI,9,9,1,BMASS,9,9,0,D)
      CALL GMMATD (D,  9,9,0,AKI,  9,9,0,AKM)
C
  450 DO 460 I = 1,81
      AKJ(I)  = 0.D0
  460 AKJM(I) = 0.D0
      DO 462 I = 82,117
  462 AKJ(I) = 0.D0
C
      GO TO 480
C
C     CREATE AN ARRAY OF SORTED GRID POINTS
C
  480 DO 482 I = 1,3
      ISORT(I) = IGP(I)
  482 CONTINUE
      I = -3
  484 J = 0
      DO 486 K = 1,3
      IF (ISORT(K) .LT. J) GO TO 486
      J = ISORT(K)
      L = K
  486 CONTINUE
      ISORT(L) = I
      I = I + 1
      IF (I .LT. 0) GO TO 484
      DO 490 I = 1,3
      ISORT(I) = -ISORT(I)
  490 CONTINUE
C
C     TRANSFORM 3 X 3 TO 6 X 6 FOR COORD SYSTEM TRANSFORMATIONS
C
      DO 600 ISIL = 1,3
      IPP = ISORT(ISIL)
C
      IR1 = 3*(ISIL-1) + 1
      DO 590 II = 1,3
      I   = ISORT(II)
      IC1 = 3*(II-1) + 1
      IRC = (IR1 -1)*9  + IC1
      DO 500 J = 1,3
      J1 = (J-1)*4 + 1
      IRCC = IRC + (J-1)*9
      IF (ISMB(1) .EQ. 0) GO TO 495
      AKT(J1  ) = AK(IRCC  )
      AKT(J1+1) = AK(IRCC+1)
      AKT(J1+2) = AK(IRCC+2)
      IF (LSYS78) GO TO 492
      M = IRCC/3 + 1
      N = (M-1)/9 + 1 + (II-1)*9 + (J-1)*3
      AKT(J1+3) = AKUPH(M)
      AKT(J1+15-J*3) = AKUPH(N)
      AKT(16) = AKPH2(IR1+II-1)
  492 CONTINUE
C
  495 IF (ISMB(2).EQ.0 .OR. ICMBAR.LT.1) GO TO 500
      J1 = (J-1)*3 + 1
      AMT(J1  ) = AKM(IRCC  )
      AMT(J1+1) = AKM(IRCC+1)
      AMT(J1+2) = AKM(IRCC+2)
  500 CONTINUE
C
C     NOW INSERT  AKT AND AMT INTO THE OVERALL STIFFNESS MATRICES
C     ACCORDING TO INCREASING SIL VALUE
C
      DO 550 IJ = 1,3
      DO 550 JJ = 1,3
      KI = (IJ-1)*3 + JJ
      IOUT = (IPP-1)*27 + (I-1)*3 + (IJ-1)*9 + JJ
  550 AKJM(IOUT)= AMT(KI)
      DO 560 IJ = 1,4
      DO 560 JJ = 1,4
      KI = (IJ-1)*4 + JJ
      IOUT = (IPP-1)*48 + (I-1)*4 + (IJ-1)*12 + JJ
  560 AKJ(IOUT) = AKT(KI)
  590 CONTINUE
  600 CONTINUE
C
C     NOW OUTPUT THE MATRIX VIA EMG OUT
C
      DICT(2) = 1
      IF (ISMB(1) .EQ. 0) GO TO 650
      CALL EMGOUT (AKJ,AKJ,144,1,DICT,1,IPR)
  650 IF (ISMB(2).EQ.0 .AND. .NOT.PZMAT) KSYS78 = KSAVE
      IF (ISMB(2) .EQ. 0) RETURN
      DICT(3) = 9
      DICT(4) = 7
      IF (ICMBAR .LT. 0) GO TO 670
      CALL EMGOUT (AKJM,AKJM,81,1,DICT,2,IPR)
      GO TO 700
C
C     GENERATE LUMPED MASS MATRIX HERE
C
  670 DO 680 I = 1,9
  680 AKJM(I) = CONVM/3.0D0
      DICT(2) = 2
      CALL EMGOUT (AKJM,AKJM,9,1,DICT,2,IPR)
  700 IF (.NOT.PZMAT) KSYS78 = KSAVE
      RETURN
C
C     ERROR EXITS
C
 7770 I = 37
 7777 IF (IDEL1 .EQ. IDEL2) GO TO 7778
      IDEL2  = IDEL1
      ICS(1) = IDEL1
      ICS(2) = JAX
      CALL MESAGE (30,I,ICS)
 7778 NOGO = .TRUE.
      GO TO 700
 7780 I = 126
      GO TO 7777
      END

      SUBROUTINE SSGHT2 (FILE,DELTA,UNI)
C
C     THIS ROUTINE USES THE TEMPERATURE VECTOR DATA TO CALCULATE
C     LOAD VECTER TERMS WITH THE EQUATION-
C
C     DELTAP = (K(TI) - K(TO))*T1
C          WHERE       TO IS THE INITIAL TEMPERATURE
C                      TI IS THE  NEW  TEMPERATURE VECTOR
C                      K  IS THE TEMPERATURE DEPENDENT CONDUCTIVITY
C                          MATRIX
C                      DELTAP  IS THE NONLINEAR LOAD
C
      INTEGER          ELID,SUB,SIL,NPTS(15),NELS(15),IP(4),SMAP(52),
     1                 FILE,FLAG,SINDX(4),SUBR(2)
      REAL             MATO,MATOUT,TEMP,UNI(1),DELTA(1)
      DOUBLE PRECISION CONSTD,DRTEMP(3,4),DRT(4,4),C(12),K(9),KQ(9),
     1                 DR(3,4),T1(8),EL,AREA,RBAR,PI,FACT,DETERM,DADOTB
      COMMON/ CONDAD/  CONSTD(5)
      COMMON/ MATIN /  MATID,INFLAG,TEMP,DUM,SINTH,COSTH
      COMMON/ HMTOUT/  MATOUT(6)
      COMMON/ ESTOUT/  ELID,SUB,NAME(2),SIL(8),IMAT,AF,THETA,R(3,8),
     1                 MATO(6)
      EQUIVALENCE      (CONSTD(1),PI)
      DATA    NPTS  /  2,3,4,3,4,4,6,8, 8,1,2,2,3,4,2 /
      DATA    NELS  /  1,1,4,1,4,1,3,5,10,1,1,1,1,4,1 /
      DATA    SUBR  /  4HSSGH ,4HT2   /
      DATA    SMAP  /  1      ,2      ,3      ,6      ,
     1                 1      ,2      ,6      ,5      ,
     2                 1      ,4      ,5      ,6      ,
     3                 1      ,2      ,3      ,6      ,
     4                 1      ,3      ,4      ,8      ,
     5                 1      ,3      ,8      ,6      ,
     6                 1      ,5      ,6      ,8      ,
     7                 3      ,6      ,7      ,8      ,
     8                 2      ,3      ,4      ,7      ,
     9                 1      ,2      ,4      ,5      ,
     O                 2      ,4      ,5      ,7      ,
     1                 2      ,5      ,6      ,7      ,
     2                 4      ,5      ,7      ,8      /
C
C     READ DATA, 45 WORDS PER ELEMENT.
C
   10 CALL READ (*480,*470,FILE,ELID,45,0,FLAG)
C
C     CALCULATE AVERAGE ELEMENT TEMPERATURE
C
      NP    = NPTS(SUB)
      XPTS  = FLOAT(NP)
      IF (SUB .GT. 9) XPTS = XPTS*2.0
C
      TEMP  = 0.0
      DO 20 I = 1,NP
      LTEMP = SIL(I)
      TEMP  = TEMP + UNI(LTEMP)
      IF (SUB .LE. 9) GO TO 20
      IF (SIL(I+4) .EQ. 0) GO TO 20
      LTEMP = SIL(I+4)
      TEMP  = TEMP + UNI(LTEMP)
   20 CONTINUE
      TEMP  = TEMP/XPTS
C
C     SET UP CALL TO MATERIAL SUBROUTINE
C
      INFLAG = 1
      IF (SUB.GE.2 .AND. SUB.LE.5) INFLAG = 2
      IF (SUB.GE.6 .AND. SUB.LE.9) INFLAG = 3
      SINTH = 0.0
      COSTH = 1.0
      IF (THETA.EQ.0.0 .OR. INFLAG.NE.2) GO TO 30
      SINTH = SIN(THETA)
      COSTH = COS(THETA)
   30 MATID = IMAT
      CALL HMAT (ELID)
C
C     SUBTRACT  CONDUCTIVITY AT INITIAL TEMPERATURE AND PLACE IN  MATRIX
C
      IF (INFLAG .EQ. 2) GO TO 40
      IF (INFLAG .EQ. 3) GO TO 50
      K(1) = MATOUT(1) - MATO(1)
      GO TO 60
   40 K(1) = MATOUT(1) - MATO(1)
      K(2) = MATOUT(2) - MATO(2)
      K(3) = K(2)
      K(4) = MATOUT(3) - MATO(3)
      GO TO 60
   50 K(1) = MATOUT(1) - MATO(1)
      K(2) = MATOUT(2) - MATO(2)
      K(3) = MATOUT(3) - MATO(3)
      K(4) = K(2)
      K(5) = MATOUT(4) - MATO(4)
      K(6) = MATOUT(5) - MATO(5)
      K(7) = K(3)
      K(8) = K(6)
      K(9) = MATOUT(6) - MATO(6)
   60 CONTINUE
      IP(1) = 1
      IP(2) = 2
      IP(3) = 3
      IF (SUB.NE.3 .AND. SUB.NE.5) GO TO 100
C
C     MOVE  QUADS TO ELEMENT COORDINATES
C
      DO 95 J = 1,2
      L  = 1
      M  = 2
      I1 = 1
      I2 = 2
      I3 = 3
      I4 = 4
      IF (J .EQ. 1) GO TO 65
      L  = 3
      M  = 4
      I1 = 3
      I2 = 4
      I3 = 1
      I4 = 2
   65 CONTINUE
      DO 70 I = 1,3
      DR(I,1) = R(I,I2) - R(I,I1)
      DR(I,3) = R(I,I3) - R(I,I1)
      DR(I,2) = R(I,I4) - R(I,I2)
   70 CONTINUE
      CALL DAXB (DR(1,3),DR(1,2),DR(1,4))
C
      AREA = DSQRT(DR(1,4)**2 + DR(2,4)**2 + DR(3,4)**2)
C
      DO 80 I = 1,3
   80 DR(I,4) = DR(I,4)/AREA
      EL = DR(1,4)*DR(1,1) + DR(2,4)*DR(2,1) + DR(3,4)*DR(3,1)
      DO 81 I = 1,3
   81 DR(I,1) = DR(I,1) - EL*DR(I,4)
      EL = DSQRT(DR(1,1)**2 + DR(2,1)**2 + DR(3,1)**2)
      DO 82 I = 1,3
   82 DR(I,1) = DR(I,1)/EL
C
      CALL DAXB (DR(1,4),DR(1,1),DR(1,2))
      DO 90 I = 1,3
   90 DR(I,4) = R(I,I4) - R(I,I1)
      CALL GMMATD (DR(1,1),2,3,0, DR(1,3),2,3,1, KQ)
      DRT(L,3) = KQ(1)
      DRT(L,4) = KQ(2)
      DRT(M,3) = KQ(3)
      DRT(M,4) = KQ(4)
      DRT(L,1) = 0.0D0
      DRT(L,2) = EL
      DRT(M,1) = 0.0D0
      DRT(M,2) = 0.0D0
   95 CONTINUE
      GO TO 120
  100 IF (SUB.NE.2 .AND .SUB.NE.4) GO TO 120
C
C     MOVE  TRIANGLES TO ELEMENT COORDINATES
C
      DO 110 I = 1,3
      DR(I,1) = R(I,2) - R(I,1)
  110 DR(I,2) = R(I,3) - R(I,1)
C
      EL   = DR(1,1)**2 + DR(2,1)**2 + DR(3,1)**2
      EL   = DSQRT(EL)
      AREA = DADOTB( DR(1,1),DR(1,2))/EL
      CALL DAXB (DR(1,1), DR(1,2), DR(1,3))
      DR(2,3) = DSQRT(DR(1,3)**2 + DR(2,3)**2 + DR(3,3)**2)/EL
      DR(1,3) = AREA
      DR(1,1) = 0.0D0
      DR(1,2) = EL
      DR(2,1) = 0.0D0
      DR(2,2) = 0.0D0
  120 CONTINUE
C
C     LOOP  ON  SUBELEMENTS  (ONE FOR MOST)
C
      NEL = NELS(SUB)
      DO 460 IEL = 1,NEL
C
      GO TO (130,160,160,140,140, 200,220,240,240,330,330,330,
     1       330,330,330), SUB
C
C     RODS,BARS, ETC.
C
  130 C(1) = 1.0D0
      C(2) =-1.0D0
      EL = (R(1,2)-R(1,1))**2 + (R(2,2)-R(2,1))**2 + (R(3,2)-R(3,1))**2
      EL = DSQRT(EL)
      KQ(1) = AF*K(1)/EL
      IP(1) = 1
      IP(2) = 2
      NP = 2
      NQ = 1
      GO TO 300
C
C     RING ELEMENTS, TRIANGLES AND QUADRILATERALS
C
  140 RBAR = 0.0
      DO 150 I = 1,3
      IG = I + IEL - 1
      IF (IG .GT. 4) IG = IG - 4
      RBAR  = RBAR + R(1,IG)
  150 IP(I) = IG
      AF = RBAR/3.0*PI
      IF (SUB .EQ. 5) GO TO 160
      I1 = IP(1)
      I2 = IP(2)
      I3 = IP(3)
      GO TO 180
  160 J  = 1
      I1 = 1
      I2 = 2
      I3 = 3
      IF (IEL.EQ.2 .OR. IEL.EQ.4) I3 = 4
      IP(1) = 1
      IP(2) = 2
      IP(3) = 3
      IF (IEL .EQ. 1) GO TO 165
      IP(3) = 4
      IF (IEL .EQ. 2) GO TO 165
      J     = 3
      IP(1) = 3
      IP(2) = 4
      IP(3) = 1
      IF (IEL .EQ. 3) GO TO 165
      IP(3) = 2
  165 DO 170 I = 1,4
      DR(1,I) = DRT(J,I)
      DR(2,I) = DRT(J+1,I)
  170 CONTINUE
  180 CONTINUE
      AREA = DR(1,I1)*(DR(2,I2) - DR(2,I3))
     1     + DR(1,I2)*(DR(2,I3) - DR(2,I1))
     2     + DR(1,I3)*(DR(2,I1) - DR(2,I2))
C
      C(1) = (DR(2,I2) - DR(2,I3))/AREA
      C(2) = (DR(2,I3) - DR(2,I1))/AREA
      C(3) = (DR(2,I1) - DR(2,I2))/AREA
C
      C(4) = (DR(1,I3) - DR(1,I2))/AREA
      C(5) = (DR(1,I1) - DR(1,I3))/AREA
      C(6) = (DR(1,I2) - DR(1,I1))/AREA
C
      IF (SUB.EQ.3 .OR. SUB.EQ.5) AREA = AREA/2.0D0
      DO 190 I = 1,4
  190 KQ(I) = K(I)*AREA*AF/2.0D0
C
      NP = 3
      NQ = 2
      GO TO 300
C
C     SOLID ELEMENTS
C
  200 DO 210 I = 1,4
  210 IP(I) = I
      GO TO 260
C
C     WEDGE
C
  220 LROW = 4*IEL - 4
      DO 230 I = 1,4
      I1 = LROW + I
  230 IP(I) = SMAP(I1)
      GO TO 260
C
C     HEXA1 AND HEXA2 ELEMENTS
C
  240 LROW = 4*IEL + 8
      DO 250 I = 1,4
      I1 = LROW +I
  250 IP(I) = SMAP(I1)
      I1 = IP(1)
  260 DO 270 I = 1,3
      IG = IP(I+1)
      DO 270 J = 1,3
      DR(J,I) = R(J,IG) - R(J,I1)
  270 CONTINUE
C
C     COMPUTE INVERSE AND BRING ALONG THE DETERMINANT FROM INVERD.
C
      ISING = 0
      CALL INVERD (3, DR(1,1),3,C(1), 0, DETERM,ISING,C(5))
      DO 280 I = 1,3
      IG = 4*I - 4
      C(IG+1) = 0.0D0
      DO 280 J = 2,4
      I1 = IG + J
      C(I1  ) = DR(J-1,I)
      C(IG+1) = C(IG+1) - C(I1)
  280 CONTINUE
      FACT = DETERM/6.0D0
      IF (SUB .EQ. 9)  FACT = FACT/2.0D0
      DO 290 I = 1,9
  290 KQ(I) = K(I)*FACT
      NP = 4
      NQ = 3
C
C     PERFORM  MATRIX MULTPLIES FOR EACH SUBELEMENT
C                               T
C                       DP  =  C  K  C * T1
C
  300 DO 310 I = 1,NP
      IG = IP(I)
      LTEMP = SIL(IG)
      T1(I) = UNI(LTEMP)
      SINDX(I) = SIL(IG)
  310 CONTINUE
      CALL GMMATD (C,NQ,NP,0, T1,NP,1,0, DRTEMP)
      CALL GMMATD (KQ,NQ,NQ,0, DRTEMP,NQ,1,0, DRTEMP(1,3))
      CALL GMMATD (C,NQ,NP,1, DRTEMP(1,3),NQ,1,0, KQ(1))
      DO 320 I = 1,NP
      IG = SINDX(I)
      DELTA(IG)  = DELTA(IG) + KQ(I)
  320 CONTINUE
      GO TO 460
C
C     BOUNDARY HEAT CONVECTION ELEMENTS
C
  330 ITYPE = SUB - 9
      IF (ITYPE .GT. 7) GO TO 10
      GO TO (340,350,370,380,380,350,350), ITYPE
  340 NP = 1
      KQ(1) = AF*K(1)
      GO TO 410
  350 NP = 2
      EL = (R(1,2)-R(1,1))**2 + (R(2,2)-R(2,1))**2 + (R(3,2)-R(3,1))**2
      KQ(1) = AF*K(1)*DSQRT(EL)/3.0D0
      KQ(2) = KQ(1)/2.0D0
      KQ(3) = KQ(2)
      KQ(4) = KQ(1)
      GO TO 410
C
C     RING SURFACE
C
  370 EL    = ((R(1,2)-R(1,1))**2 + (R(3,2)-R(3,1))**2)
      C(1)  = PI*K(1)*DSQRT(EL)/6.0D0
      KQ(1) = C(1)*(3.0D0*R(1,1) + R(1,2))
      KQ(2) = C(1)*(      R(1,1) + R(1,2))
      KQ(3) = KQ(2)
      KQ(4) = C(1)*(      R(1,1) + 3.0D0*R(1,2))
      NP= 2
      GO TO 410
C
C     TRIANGLES  (ALSO FOR SUBELEMENT OF QUAD)
C
  380 DO 390 I = 1,3
      IG = I + IEL - 1
      IF (IG .GT. 4) IG = IG - 4
      IP(I) = IG
  390 CONTINUE
      I1 = IP(1)
      I2 = IP(2)
      I3 = IP(3)
      DO 400 I = 1,3
      DR(I,1) = R(I,I2) - R(I,I1)
  400 DR(I,2) = R(I,I3) - R(I,I1)
      CALL DAXB (DR(I,1),DR(I,2),DR(I,3))
      AREA = DSQRT(DR(1,3)**2 + DR(2,3)**2 + DR(3,3)**2)/12.0D0
      IF (ITYPE .EQ. 5) AREA = AREA/2.0D0
      KQ(1) = AREA*K(1)
      KQ(2) = KQ(1)/2.0D0
      KQ(3) = KQ(2)
      KQ(4) = KQ(2)
      KQ(5) = KQ(1)
      KQ(6) = KQ(2)
      KQ(7) = KQ(2)
      KQ(8) = KQ(2)
      KQ(9) = KQ(1)
      NP    = 3
C
C     PERFORM MATRIX MULTIPLY, FIRST GET TEMPERATURE VECTOR
C
  410 DO 430 I = 1,NP
      IG = IP(I)
      LTEMP  = SIL(IG)
      T1(I)  = UNI(LTEMP)
      IF (SIL(IG+4) .NE. 0) GO TO 420
      T1(I+4) = 0.0D0
      GO TO 430
  420 LTEMP   = SIL(IG+4)
      T1(I+4) = UNI(LTEMP)
  430 CONTINUE
      CALL GMMATD (KQ(1),NP,NP,0, T1(1),NP,1,0, C)
      CALL GMMATD (KQ(1),NP,NP,0, T1(5),NP,1,0, C(5))
      DO 450 I = 1,NP
      IG  = IP(I)
      IPG = SIL(IG)
      DELTA(IPG) = DELTA(IPG) + C(I) - C(I+4)
      IG = IG + 4
      IF (SIL(IG)) 450,450,440
  440 IPG = SIL(IG)
      DELTA(IPG) = DELTA(IPG) + C(I+4) - C(I)
  450 CONTINUE
C
  460 CONTINUE
      GO TO 10
  470 RETURN
C
  480 J = -2
      CALL MESAGE (FILE,J,SUBR)
      RETURN
      END

      SUBROUTINE DS1B (KE,J)
C
C     THIS ROUTINE ADDS THE 6 X 6 DOUBLE PRECISION MATRIX KE TO THE
C     SUBMATRIX OF ORDER NROWSC X JMAX.
C
      INTEGER          CSTM  ,MPT   ,DIT   ,ECPTDS,OUTRW ,EOR   ,
     1                 CLSRW ,FROWIC,IZ(1)
      DOUBLE PRECISION DZ(1) ,KE(36)
      COMMON /ZZZZZZ/  Z(1)
      COMMON /DS1AAA/  NPVT  ,ICSTM ,NCSTM ,IGPCT ,NGPCT ,IPOINT,
     1                 NPOINT,I6X6K ,N6X6K ,CSTM  ,MPT   ,DIT   ,
     2                 ECPTDS,GPCT  ,KGGD  ,INRW  ,OUTRW ,EOR   ,
     3                 NEOR  ,CLSRW ,JMAX  ,FROWIC,LROWIC,NROWSC,
     4                 NLINKS,LINK(10)     ,NOGO
      EQUIVALENCE      (DZ(1),Z(1),IZ(1))
C
C     SEARCH THE GPCT AND FIND AN INDEX M SUCH THAT
C     IABS(GPCT(M)) .LE. J .LT. IABS(GPCT(M+1))
C
      LOW = IGPCT + 1
      LIM = NGPCT + LOW - 2
      IF (LOW .GT. LIM) GO TO 15
      DO 10 I = LOW,LIM
      ISAVE = I
      IF (J .GE. IABS(IZ(I+1))) GO TO 10
      IF (J .GE. IABS(IZ(I  ))) GO TO 20
   10 CONTINUE
      IF (J .GE. IABS(IZ(ISAVE+1))) ISAVE = ISAVE + 1
      GO TO 20
   15 ISAVE = LOW
C
C     ADD KE TO THE SUBMATRIX
C
   20 L1  = FROWIC - 1
      JJ  = IPOINT + ISAVE - IGPCT
      J2  = IZ(JJ) - 1
      I1  = 0
      LIM = NROWSC - 1
   30 IF (I1 .GT. LIM) RETURN
      K1  = I6X6K + I1*JMAX + J2
      J1  = 0
      L   = 6*L1
      K   = K1
   40 J1  = J1 + 1
      IF (J1 .GT. 6) GO TO 50
      K   = K + 1
      L   = L + 1
      DZ(K) = DZ(K) + KE(L)
      GO TO 40
   50 I1  = I1 + 1
      L1  = L1 + 1
      GO TO 30
      END

      SUBROUTINE DDR
C
C*****
C
C     DUMMY DECK FOR MODULE DDR    SEE USERS MANUAL SECTION 5.3
C                                  FOR MODULE PROPERTIES CHECK XMPLBD
C                                  OR USE DIAG 29
C
C*****
C
      INTEGER PARM1,PARM2,PARM3
C     INTEGER OUTFIL
C
      COMMON /BLANK/ PARM1(2),PARM2(2),PARM3(2)
C
C     DATA INFILE/101/, OUTFIL/201/
C
      RETURN
      END

      LOGICAL FUNCTION TAPBIT (FILE)
C
      EXTERNAL  ANDF
      INTEGER   FIST,XFIAT,FIAT,FILE,ANDF,NAM(2)
      COMMON   /XXFIAT/ XFIAT(1)
     1         /XPFIST/ NPFIST
     2         /XFIST / NFIST,LFIST,FIST(1)
     3         /XFIAT / MFIAT,NFIAT,LFIAT,FIAT(1)
      COMMON   /SYSTEM/ IB(45)
      COMMON   /TWO   / ITWO(32)
      DATA      NAM   / 4HTAPB,4HIT   /
C
      TAPBIT = .TRUE.
      DO 10 J = 1,NPFIST
      IF (FIST(2*J-1) .EQ. FILE) GO TO 20
   10 CONTINUE
      NPF1 = NPFIST + 1
      DO 15 J = NPF1,LFIST
      IF (FIST(2*J-1) .EQ. FILE) GO TO 30
   15 CONTINUE
      CALL MESAGE (-21,FILE,NAM)
C
   20 J = -FIST(2*J)
      IF (ANDF(ITWO(32-J),IB(45)) .NE. 0) RETURN
      IF (ANDF(XFIAT(J+1),32768)  .EQ. 0) TAPBIT = .FALSE.
      RETURN
C
   30 J = FIST(2*J)
      IF (ANDF(FIAT(J+1),32768) .EQ. 0) TAPBIT = .FALSE.
      RETURN
      END

      SUBROUTINE COPY
C
C     COPY  INPUT /OUTPUT/ PARAM $
C
C     THIS UTILITY MODULE GENERATES A PHYSICAL COPY OF THE INPUT DATA
C     BLOCK IF THE VALUE OF PARAM IS LESS THAN ZERO (DEFAULT IS -1).
C     THE OUTPUT DATA BLOCK CARRIES THE INPUT DATA BLOCK NAME IN THE
C     HEADER RECORD.
C     IF PARAM IS SET TO ZERO, THE OUTPUT DATA BLOCK WILL HAVE ITS OWN
C     NAME IN THE OUTPUT FILE HEADER RECORD.  (IMPLEMENTED IN JUNE 84)
C
C
      INTEGER         MODNAM(2),SYSBUF,OUTPUT,ITRL(7),IN(15),OUT(15)
      COMMON /SYSTEM/ SYSBUF
      COMMON /ZZZZZZ/ Z(1)
      COMMON /BLANK / IPARAM
      COMMON /XFIST / IFIST(1)
      COMMON /XFIAT / IFIAT(1)
      DATA    INPUT / 101 /, OUTPUT / 201 /, MODNAM / 4HCOPY,4H    /
C
C     RETURN IF IPARAM NOT GREATER THAN ZERO
C
      IF (IPARAM .EQ. 0) IPARAM = -1111
      IF (IPARAM .GE. 0) RETURN
C
C     COMPUTE OPEN CORE AND INITIALIZE GINO BUFFERS
C
      NZWD = KORSZ(Z(1))
      IF (NZWD .LE. 0) CALL MESAGE (-8,0,MODNAM)
      IBUF1 = NZWD  - SYSBUF
      IBUF2 = IBUF1 - SYSBUF
      LCORE = IBUF2 - 1
      IF (LCORE .LE. 0) CALL MESAGE (-8,0,MODNAM)
C
C     OPEN INPUT AND OUTPUT DATA BLOCKS
C
      IN(1)   = INPUT
      OUT(1)  = OUTPUT
      ITRL(1) = 101
      CALL RDTRL (ITRL)
      CALL OPEN  (*1001,INPUT,Z(IBUF1),0)
      CALL OPEN  (*1002,OUTPUT,Z(IBUF2),1)
      CALL CPYFIL (IN,OUT,Z(1),LCORE,ICOUNT)
      CALL CLOSE (OUTPUT,1)
      CALL CLOSE (INPUT,1)
      ITRL(1) = 201
      CALL WRTTRL (ITRL)
      RETURN
C
 1001 CALL MESAGE (-1,INPUT,MODNAM)
 1002 CALL MESAGE (-1,OUTPUT,MODNAM)
      RETURN
      END

      SUBROUTINE CFACTR (A,LL,UL,SCR1,SCR2,SCR3,IOPT)
C
      INTEGER           FA        ,FL       ,FU       ,SR1      ,
     1                  SR2       ,SR3      ,UL       ,SCR1     ,
     2                  SCR2      ,SCR3     ,A        ,
     3                  MCB(7)    ,NAME(2)
      DOUBLE PRECISION  DET       ,MIND
      COMMON   /CDCMPX/ FA(7)     ,FL(7)    ,FU(7)    ,SR1      ,
     1                  SR2       ,SR3      ,DET(2)   ,POWR     ,
     2                  NX        ,MIND     ,IB       ,IBBAR
      COMMON   /SFACT / MFA(7)    ,MFL(7)   ,MFC(7)   ,M1FIL    ,
     1                  M2FIL     ,MXX      ,D(5)     ,M3FIL    ,
     2                  D1(2)     ,ICHOL
      COMMON   /SDCCSP/ JFA(7)    ,JFL(7)   ,JFC(7)   ,J1FIL    ,
     1                  J2FIL     ,JX
      COMMON   /ZZZZZZ/ IZ(1)
      DATA      NAME  / 4HCFAC,4HTR   /
C
C
      NZ = KORSZ(IZ)
      MCB(1) = A
      CALL RDTRL (MCB)
      IF (MCB(4) .NE. 6) GO TO 200
C
C     SYMMETRIC  COMPLEX
C
      DO 10 I = 1,7
      MFA(I) = MCB(I)
      MFL(I) = MCB(I)
      MFC(I) = MCB(I)
   10 CONTINUE
      MFL(1) = LL
      MFC(1) = UL
      MFL(4) = 4
      MFC(4) = 5
      M1FIL  = SCR1
      M2FIL  = SCR2
      MXX    = NZ
      M3FIL  = SCR3
      ICHOL  = 0
      CALL SDCOMP (*900,IZ,IZ,IZ)
      CALL WRTTRL (MFL)
      IOPT  = 2
      GO TO  60
C
C     UNSYMMETRIC  COMPLEX
C
  200 DO 210 I = 1,7
      FA(I) = MCB(I)
      FL(I) = MCB(I)
      FU(I) = MCB(I)
  210 CONTINUE
      FL(1) = LL
      FU(1) = UL
      FL(4) = 4
      FU(4) = 5
      SR1   = SCR1
      SR2   = SCR2
      SR3   = SCR3
      NX    = NZ
C     IB    = 0
C
C     IF IB IS SET TO ZERO HERE, T08021 PRINTS 27 MORE MESSAGES 3027
C     AND 3028 FROM GENVEC WHICH IS CALLED BY CFACTR, WHCIH IS CALLED BY
C     FRD2C, IN FRRD2 MODULE
C
CIBMI 6/93
      IBBAR = 0
      CALL CDCOMP (*900,IZ,IZ,IZ)
      CALL WRTTRL (FU)
      CALL WRTTRL (FL)
      IOPT  = 1
   60 RETURN
C
C     ERRORS
C
  900 CALL MESAGE (-5,A,NAME)
C
      RETURN
      END

      SUBROUTINE OPT2D (IPR,PR)
C-----
C   COPY OPTP1 TO OPTP2 DATA FILE.
C  CHANGE RECORD 3      WORD 1 = IABS (PID).
C                       WORD 4 = PLST
C                       WORD 5 = ALPH
C-----
      REAL PR(1)
      INTEGER ZCOR     ,EOR      ,IPR(1)   ,OPTP1    ,OPTP2    ,IZ(1)
C
      COMMON /BLANK/ SKP1(9),NWDSP,OPTP1,SKP3(2),OPTP2,SKP4(2),NPRW
      COMMON /NAMES / NRD,NRREW,NWRT,NWREW,NEXT
      COMMON /OPTPW2/ ZCOR,Z(1)
      EQUIVALENCE (IZ(1),Z(1))
C
C  . RECORD ZERO - COPY NAME AND 6 PARAMETERS...
C
      CALL FREAD (OPTP1,Z(1),8,NEXT)
      CALL FNAME(OPTP2,Z(1))
      CALL WRITE (OPTP2,Z(1),8,NEXT)
C
C  . RECORD ONE (POINTERS) AND TWO (ELEMENT DATA)...
C
      DO 30 I = 1,2
      N = ZCOR
   10 EOR = NEXT
      CALL READ(*20,*20,OPTP1,Z,ZCOR,0,N)
      EOR = 0
   20 CALL WRITE (OPTP2,Z(1),N,EOR)
      IF (EOR.EQ.0) GO TO 10
   30 CONTINUE
C
C  . RECORD THREE - PROPERTY DATA...
C
      EOR = 0
      DO 40 I = 1,NPRW,NWDSP
      IPR(I) = IABS(IPR(I) )
      PR(I+4) = -1.0
      CALL WRITE (OPTP2,IPR(I),NWDSP,EOR)
   40 CONTINUE
      CALL WRITE (OPTP2,0,0,NEXT)
C
C  . RECORD FOUR - PLIMIT DATA...
C
      CALL FREAD (OPTP1,0,0,NEXT)
      N = ZCOR
   50 EOR = NEXT
      CALL READ(*60,*60,OPTP1,Z,ZCOR,0,N)
      EOR = 0
   60 CALL WRITE (OPTP2,Z(1),N,EOR)
      IF (EOR.EQ.0) GO TO 50
C
      CALL EOF (OPTP2)
      IZ(1) = OPTP1
      CALL RDTRL(IZ(1))
      IZ(1) = OPTP2
      CALL WRTTRL (IZ(1))
      RETURN
      END

        SUBROUTINE DSSKFF ( NN )
      INCLUDE 'DSIOF.COM'
        N = NN
10      IF ( N .EQ. 0 ) GO TO 7000
20      CALL DSFWR1
        IF ( IRETRN .EQ. 0 ) GO TO 20
        N = N - 1
        GO TO 10
7000    RETURN
        END

      SUBROUTINE SUPLT (IZ,IY,X,U,GPLST,PEN,DEFORM)
C
C     TO CREATE A SET OF UNIQUE LINES TO BE PLOTTED.  IN ADDITION, TO
C     AVOID SKIPPING ALL OVER THE PLOT FOR EACH LINE.
C
C     INPUT (SIMULAR TO -GPCT-)
C       NGRID - NUMBER OF INTERNAL GRID POINTS.
C       IY    - 1 THRU NGRID - POINTERS TO FIRST CONNECTION OF THE
C                              INTERNAL GRID MATCHING THIS INDEX.
C                              IF THE GRID HAS NO ENTRIES IZ(I+1) WILL
C                              HAVE THE SAME POINTER VALUE.
C             - NGRID+1      - POINTER TO END-OF-RECORD.
C       IZ    - CONNECTING INTERNAL GRIDS.  POINTER FOR NEXT GRID
C                              DETERMINES LAST ENTRY.  ENTRIES PUSHED
C                              DOWN AND  -1  ADDED AT END AS EACH ENTRY
C                              IS USED.
C
C       NTAB  = TOTAL ENTRY COUNTER IN GPCT
C       ID1   = START OF CURRENT -LINE-
C       ID2   = END   OF CURRENT -LINE-
C       ID3   = START OF LAST -LINE-
C       ID4   = END   OF LAST -LINE-
C
      INTEGER         IZ(1),IY(1),PEN,DEFORM,GPLST(1),NM(5),M(71),
     1                M1(17),M2(17),M3(11),M4(17),M5(9),ERR(4),LM(5),
     2                LIMT(2)
      REAL            U(2,1),X(3,1)
      COMMON /SYSTEM/ SYSBUF,IOUT
      COMMON /BLANK / NGRID,SKP1(19),MERR
      EQUIVALENCE     (M1(1),M( 1)), (M2(1),M(18)), (M3(1),M(35)),
     1                (M4(1),M(46)), (M5(1),M(63))
      DATA    NM    / 17,17,11,17, 9 /,
     1        LM    /  1,18,35,46,63 /,
     2        M1    / 4H(35X, 4H,26H, 4HSUPL, 4HT RE, 4HJECT, 4HED P,
     3                4HLOT., 4H PIV, 4HOT,I, 4H8,26, 4HH IS, 4H ZER,
     4                4HO OR, 4H SAM, 4HE AS, 4H ENT, 4HRY.)/,
     5        M2    / 4H(35X, 4H,54H, 4HSUPL, 4HT RE, 4HJECT, 4HED P,
     6                4HLOT., 4H NEG, 4HATIV, 4HE NU, 4HMBER, 4H ENT,
     7                4HRIES, 4H - N, 4H3,N4, 4H =,2, 4HI10)/,
     8        M3    / 4H(35X, 4H,31H, 4HUNEX, 4HPECT, 4HED E, 4HOF I,
     9                4HN SU, 4HPLT , 4H- PI, 4HVOT,, 4HI10)/,
     O        M4    / 4H(35X, 4H,11H, 4HSUPL, 4HT-EN, 4HTRY,, 4HI10,,
     1                4H22H , 4HFOR , 4HPIVO, 4HT NO, 4HT FO, 4HUND ,
     2                4H(,2I, 4H6,8H, 4H) RA, 4HNGE., 4H)   /,
     3        M5    / 4H(35X, 4H,24H, 4HNO E, 4HLEME, 4HNTS , 4HIN T,
     4                4HHIS , 4HSET., 4H)   /
C
      LINESP = 0
C
C     LOCATE FIRST PIVOT (ID1) WITH ODD NUMBER OF ENTRIES
C
      ID2 = 0
      ID1 = 0
      DO 10 I = 1,NGRID
      LL  = IY(I+1) - IY(I)
      IF (LL .EQ. 0) GO TO 10
C
C     IN CASE AN ODD NO. ENTRIES ISN'T FOUND THE DEFAULT IS FIRST PIVOT
C
      IF (ID2 .EQ. 0) ID2 = I
      IF (MOD(LL,2) .EQ. 0) GO TO 10
      ID1 = I
      I1  = IY(I)
      ID2 = IZ(I1)
      GO TO 20
   10 CONTINUE
C
   20 NTAB = IY(NGRID+1) - IY(1)
C
C     NO ELEMENTS IN THE SET
C
      IF (NTAB .EQ. 0) GO TO 440
C
C     SEE IF ANY ODD ENTRIES FOUND
C
      LIMT(1) = 0
      LIMT(2) = NGRID + 1
      IF (ID1 .NE. 0) GO TO 140
      ID1 = ID2
      I1  = IY(ID1)
      ID2 = IZ(I1)
      GO TO 140
C
C     START OF LOOP AFTER FIRST -LINE-
C
   30 IF (N4) 410,260,40
C
C     LAST END HAS ENTRY TO CONTINUE FROM
C
   40 ID1 = ID4
C
C     INTERNAL SEARCH FOR FIRST GPCT ENTRY ABOVE AND BELOW THE PIVOT
C     VALUE FOR THE PIVOT           *** M I N / M A X ***
C
   50 I1 = IY(ID1)
      IL =-100000
      IH = 100000
      J1 = IY(ID1+1) - 1
C
      DO 80 I = I1,J1
      IF (IZ(I)    ) 100,400,60
   60 IF (IZ(I)-ID1)  70,400,90
   70 IL = IZ(I)
   80 CONTINUE
      GO TO 100
C
   90 IH = IZ(I)
C
C     DETERMINE  WHICH IS CLOSER TO PIVOT
C
  100 I = ID1 - IL
      J = IH  - ID1
      IF (J-I) 130,110,120
C
C     EQUAL DISTANT, GO TO SAME DIRECTION AS BEFORE
C
  110 IF (ID4-ID3) 120,400,130
C
C     ID2 IS LESSOR ID
C
  120 ID2 = IL
      GO TO 140
C
C     ID2 IS GREATER ID
C
  130 ID2 = IH
C
C     OUTPUT THE LINE -
C     NOTE THAT ID4 MAY BE RESET AT 320 SO DONT TAKE SHORTCUTS
C
  140 CONTINUE
      I  = IABS(GPLST(ID1))
      J  = IABS(GPLST(ID2))
      IF (DEFORM .NE. 0) GO TO 160
      X1 = X(2,I)
      Y1 = X(3,I)
      X2 = X(2,J)
      Y2 = X(3,J)
      GO TO 170
  160 X1 = U(1,I)
      Y1 = U(2,I)
      X2 = U(1,J)
      Y2 = U(2,J)
  170 CONTINUE
      CALL LINE (X1,Y1,X2,Y2,PEN,0)
      LINESP = LINESP + 1
C
C     REMOVE ENTRIES FROM CORE, LEFT SHIFT AS NEEDED AND PUT -1 AT THE
C     END OF THE TABLE.  PLACE THE NUMBER OF ENTRIES LEFT IN N3 AND N4.
C     DECREMENT THE TOTAL NUMBER OF ENTRIES BY 2. SET ID3 AND ID4.
C
      IF (NTAB .LE. 2) GO TO 460
      KK = 0
      J1 = I1
      J2 = IY(ID1+1) - 1
      LL = ID2
  180 IPAR = J1
      IL = 0
C
      DO 230 I = J1,J2
      IF (IZ(I)-LL) 210,200,190
  190 IZ(IPAR) = IZ(I)
      GO TO 220
C
C     COMPONENT TO BE ELIMINATED HAS BEEN FOUND
C
  200 IL = 1
      GO TO 230
  210 IF (IZ(I)) 240,400,220
  220 IPAR = IPAR + 1
  230 CONTINUE
C
  240 IZ(IPAR) = -LL
      IF (IL .EQ. 0) GO TO 430
      IF (KK .NE. 0) GO TO 250
      KK = 2
      ID3= ID1
      N3 = IPAR - J1
      LL = ID2
      J1 = IY(LL  )
      J2 = IY(LL+1) - 1
      LL = ID1
      GO TO 180
  250 NTAB= NTAB - 2
      ID4 = ID2
      N4  = IPAR - J1
      GO TO 30
C
C     CASE ID4 HAS NO MORE ENTRIES. CHECK IF ID3 CAN BE PIVOT
C
  260 IF (N3) 410,280,270
C
C     NONZERO - ID3 IS TO BE ID1
C
  270 ID1 = ID3
      GO TO 50
C
C     ID3 AND ID4 ARE NULL.  GO TO CLOSEST END OF TABLE FROM ID4
C
  280 I = NGRID - ID4
      J = 1
      IF (I .GT. ID4) J = -1
      L = (J+2)/2 + 1
      LIM = LIMT(L)
      LEN = ID4
C
      ASSIGN 310 TO IRET1
      KK = ID4
  290 KK = KK + J
      IF (KK .EQ. LIM) GO TO IRET1, (310,420)
      IPAR = 2
      ASSIGN 300 TO IRET
      GO TO 370
C
C     CHECK IF ANY ENTRIES FOUND
C
  300 IF (IPAR .EQ. 0) GO TO 290
C
C     ENTRY FOUND
C
      LEN = KK + J
      ID4 = KK
      N4  = IPAR
      GO TO 320
C
C     THAT END OF TABLE FAILED - TRY OTHER END
C
  310 J   = -J
      LIMT(L) = LEN
      L   = (J+2)/2 + 1
      LIM = LIMT(L)
      KK  = ID4
      ASSIGN 420 TO IRET1
      GO TO 290
C
C     AN ENTRY WAS FOUND - CHECK FOR ODD NUMBER OF ENTRIES FOR PIVOT
C
  320 IF (MOD(IPAR,2) .EQ. 1) GO TO 360
C
C     NOT AN ODD NUMBER OF ENTRIES FOR ID4.  CHECK GPCT ENTRIES
C     FOR ONLY ONE ENTRY.
C
      ASSIGN 340 TO IRET
C
      IH = J2
      IL = J1 - 1
  330 IL = IL + 1
      KK = IZ(IL)
      IF (KK .LE. 0) GO TO 40
      IPAR = 1
      GO TO 370
  340 CONTINUE
      IF (IPAR .EQ.  1) GO TO 360
      IF (IL   .LT. IH) GO TO 330
C
C     PIVOT NOW DETERMINED
C
      GO TO 40
  360 ID1 = KK
      GO TO 50
C
C
C     INTERNAL ROUTINE TO DETERMINE NUMBER OF ENTRIES FOR PIVOT
C
C     INPUT
C        IPAR = 1 -- 0,1 OR MORE THAN 1 ENTRY RETURN
C             = 2 -- ACTUAL NUMBER OF ENTRIES RETURN
C        KK   = ID OF PIVOT
C
C     OUTPUT
C        IPAR = DESIRED NUMBER OF ENTRIES
C        KK   = SAME AS INPUT
C        J1   = POINTER TO 1ST LOCATION
C        J2   = NOT NECESSARILY LAST LOCATION (I.E. IPAR INPUT AS 1)
C
  370 J1 = IY(KK  )
      J2 = IY(KK+1) - 1
      IF (IPAR .EQ. 1) J2 = MIN0(J1+2,J2)
      IPAR = 0
      IF (J2-J1 .LT. 0) GO TO 390
C
      DO 380 I = J1,J2
      IF (IZ(I)) 390,400,380
  380 IPAR = IPAR + 1
  390 GO TO IRET, (300,340)
C
C     ERROR MESSAGES
C
  400 ERR(1) = 1
      ERR(2) = ID1
      K = 1
      GO TO 450
  410 ERR(1) = 2
      ERR(2) = N3
      ERR(3) = N4
      K = 2
      GO TO 450
  420 ERR(1) = 1
      ERR(2) = ID4
      K = 3
      GO TO 450
  430 ERR(1) = 3
      ERR(2) = LL
      ERR(3) = J1
      ERR(4) = J2
      K = 4
      GO TO 450
  440 ERR(1) = 0
      K = 5
C
  450 I = LM(K)
      CALL WRTPRT (MERR,ERR,M(I),NM(K))
      IF (K .EQ. 5) GO TO 530
C
C     CONVERT TABLE TO ORIGINAL VALUES UNLESS THIS IS THE LAST CALL
C
  460 IL = NGRID  + 1
      I  = IY(IL) - 1
      IF (DEFORM .NE. 0) GO TO 530
      DO 480 J = 1,I
  480 IZ(J) = IABS(IZ(J))
C
      DO 520 J1 = 1,NGRID
      IF (IY(J1) .EQ. IY(J1+1)) GO TO 520
      I = IY(J1)
      L = I
      N = IY(J1+1) - 1
      IF (I+1 .GT. N) GO TO 520
C
C     SHUTTLE EXCHANGE
C     (NOTE FROM G.CHAN/UNISYS  10/1990
C     THERE ARE MORE THAN JUST A SHUTTLE SORTING HERE. REPLACING THE
C     SHUTTLE EXCHANGE METHOD BY SORT ROUTINE, WHICH USES A MUCH FASTER
C     TECHNEQUE, DOES NOT WORK HERE)
C
  490 IF (IZ(I) .LE. IZ(I+1)) GO TO 510
      K = IZ(I+1)
      IZ(I+1) = IZ(I)
      IZ(I  ) = K
      J = I
  500 IF (J .EQ. L) GO TO 510
      IF (IZ(J) .GE. IZ(J-1)) GO TO 510
      K = IZ(J)
      IZ(J  ) = IZ(J-1)
      IZ(J-1) = K
      J = J - 1
      GO TO 500
  510 IF (I .GE. N-1) GO TO 520
      I = I + 1
      GO TO 490
C
  520 CONTINUE
C
C     A NONSTANDARD RETURN COULD BE ADDED HERE.  BAD PLOT RESULTS IF
C     THIS ROUTINE FAILS.  THE FRAME WILL BE PRESENT HOWEVER
C
  530 CONTINUE
      RETURN
      END

      SUBROUTINE PIDCK (PFILE,GEOM2,NOPID,Z)
C
C     THIS ROUTINE CHECKS THE UNIQUNESS OF PROPERTY IDS FOR ALL ELEMENTS
C     THAT HAVE PID FIELDS
C
C     IT SHOULD BE CALLED ONLY ONCE BY IFP
C     IT DOES NOT OPEN NOR CLOSE ANY GINO FILE.
C
C     DESIGN REQUIREMENT -
C
C     IF PID IS REFERENCED BY AN ELEMENT, THE PID MUST RESIDE ON THE
C     THIRD FIELD OF THE ELEMENT INPUT CARD.
C     INPUT FILES - GEOM2 AND PROPERTY FILE (EPT).
C
C     THIS VERSION INCLUDES SPECIAL HANDLING OF THE CQUAD4 AND CTRIA3
C     ELEMENTS WHICH USE AND SHARE MORE THAN ONE STANDARD PROPERTY CARD.
C     THE PROPERTY TYPE IDS OF THE PSHELL, PCOMP, PCOMP1 AND PCOMP2
C     MUST NOT BE INTERRUPTED BY ANOTHER PROPERTY TYPE. (I.E. NO OTHER
C     PROPERTY TYPE SHOULD HAVE AN ID PLACED IN BETWEEN 5502 THRU 5802).
C     NOTICE THAT THE PSHELL CARD HAS FIXED LENGTH WHILE THE 3 PCOMPI
C     CARDS HAVE VARIABLE LENGTH.
C
C     WRITTEN BY G.CHAN/UNISYS, SEPT. 1983
C
      LOGICAL         ABORT
      INTEGER         PFILE,    GEOM2,    Z(1),     NAME(2),
     1                FLAG,     X(3),     QUAD4,    PSHELL,
     2                PCOMP(3)
      CHARACTER       UFM*23,   UWM*25,   UIM*29
      COMMON /XMSSG / UFM,      UWM,      UIM
      COMMON /SYSTEM/ IBUF,     NOUT,     ABORT,    SKIP(42),
     1                KDUM(9)
      COMMON /GPTA1 / NELEM,    LAST,     INCR,     NE(1)
      DATA    QUAD4 , PSHELL,   PCOMP                      /
     1         5408 , 5802,     5502,     5602,     5702   /
      DATA    NAME  / 4HPIDC,   4HK       /
C
C     UPDATE /GPTA1/ IF DUMMY ELEMENTS ARE PRESENT
C
      DO 90 I = 1,9
      IF (KDUM(I) .EQ. 0) GO TO 90
      K  = KDUM(I)
      NG = K/10000000
      NC = (K-NG*10000000)/10000
      NP = (K-NG*10000000 - NC*10000)/10
      K  = (51+I)*INCR
      NE(K+ 6) = 2 + NG + NC
      NE(K+ 9) = 2 + NP
      NE(K+10) = NG
 90   CONTINUE
C
C     CREATE A PROPERTY ID TABLE IN Z FROM /GPTA1/ DATA BLOCK FOR THOSE
C     ELEMENTS THAT HAVE PROPERTY CARDS
C     4 WORDS PER ENTRY
C       WORD 1, PROPERTY TYPE CODE  (EPT-ID)
C       WORD 2, LENGTH OF PROPERTY CARD  (EPTWDS)
C       WORD 3, ELEMENT TYPE CODE   (ECT-ID)
C       WORD 4, LENGTH OF ELEMENT CARD (ECTWDS), PLUS POINTER TO GPTA1
C
      II = 0
      DO 100 I = 1,LAST,INCR
      IF (NE(I+6) .EQ. 0) GO TO 100
      Z(II+1) = NE(I+6)
      Z(II+2) =-NE(I+8)
      Z(II+3) = NE(I+3)
      Z(II+4) = NE(I+5)*10000 + I
      II = II + 4
 100  CONTINUE
C
C     ADD 3 MORE PROPERTY CARDS (PCOMP, PCOMP1, PCOMP2) FOR CQUAD4 (64)
C     AND CTRIA3
C     NOTE - THESE THREE ARE OPEN-ENDED, AND WE SET WORD 2 TO -8888
C          - WE GIVE THEM LOCALLY NEW QUAD4 IDS IN THE 3RD WORD, SO THAT
C            ELEMENT CQUAD4 AND ELEMENT CTRIA3 WILL PICK THEM UP VIA
C            THE PSEHLL DATA LATER.
C
      I = (64-1)*INCR + 1
      IF (NE(I+3) .NE. QUAD4) CALL MESAGE (-37,0,NAME)
      DO 105 J = 1,3
      Z(II+1) = PCOMP(J)
      Z(II+2) = -8888
      Z(II+3) = QUAD4 - J
      Z(II+4) = NE(I+5)*10000 + I
      II = II + 4
 105  CONTINUE
C
C     SORT THIS 4-ENTRY Z-TABLE BY THE FIRST WORD.
C     SET WORD 2 TO -9999 IF ELEMENT USES THE SAME PROPERTY CARD AS THE
C     PREVIOUS ELEMENT.
C
      I4 = II/4
      CALL SORT (0,0,4,1,Z,II)
      DO 110 I = 5,II,4
      IF (Z(I) .EQ. Z(I-4)) Z(I+1) = -9999
 110  CONTINUE
C
C     READ FROM PFILE ALL PID INTO REMAINING CORE. REPLACE WORD 2 IN THE
C     Z-TABLE BY PID BEGIN-ENDING POINTERS
C
      JJ = II + 1
      IF (NOPID .EQ. 1) GO TO 210
      CALL REWIND (PFILE)
 120  CALL FWDREC (*360,PFILE)
 130  CALL READ (*190,*190,PFILE,X,3,0,FLAG)
C     2147483647  = 2**31-1
      IF (X(1) .EQ. 2147483647) GO TO 190
      CALL BISLOC (*120,X(1),Z,4,I4,K)
 140  KP1 = K + 1
      IF (Z(KP1) .NE. -9999) GO TO 150
      K = K - 4
      GO TO 140
 150  NWDS = -Z(KP1)
      IF (NWDS .LE. 0) GO TO 120
      KOMP = 0
      IF (NWDS .NE. 8888) GO TO 155
      KOMP = 1
      NWDS = 8
 155  Z(KP1) = (JJ*10000) + (JJ-1)
      JB = JJ
 160  CALL READ (*360,*130,PFILE,Z(JJ),NWDS,0,FLAG)
      IF (KOMP .EQ. 0) GO TO 167
 165  CALL READ (*360,*130,PFILE,J,1,0,FLAG)
      IF (J .NE. -1) GO TO 165
 167  JE = MOD(Z(KP1),10000)
      IF (JE .LT. JB) GO TO 180
      DO 170 J = JB,JE
      IF (Z(JJ) .EQ. Z(J)) GO TO 160
 170  CONTINUE
 180  Z(KP1) = Z(KP1) + 1
      JJ = JJ + 1
      GO TO 160
 190  CALL REWIND (PFILE)
      JJ = JJ - 1
      IF (JJ .LE. II) NOPID = -1
C
C     RESET THE PSHELL POINTERS TO INCLUDE THE PCOMP GROUP IDS.
C     MAKE SURE THIS GROUP ARE ALL TOGETHER, NOT SEPERATED BY OTHER
C     PROPERTY CARD
C     THERE ARE 2 PSHELL CARDS, ONE FROM CQUAD4 AND ONE FROM CTRIA3,
C     MAKE SURE THE FIRST PSHELL POINTER IS USED
C
      CALL BISLOC (*210,PSHELL,Z,4,I4,KP1)
      IF (Z(KP1+1) .EQ. -9999) KP1 = KP1 - 4
      IF (Z(KP1- 4).NE.PCOMP(3) .OR. Z(KP1-8).NE.PCOMP(2) .OR.
     1    Z(KP1-12).NE.PCOMP(1)) GO TO 380
      J = Z(KP1+1)
      IF (J .LE. 0) J = 0
      JB = J/10000
      JE = MOD(J,10000)
      IF (JB .EQ. 0) JB = 9999999
      DO 200 I = 1,3
      CALL BISLOC (*370,PCOMP(I),Z,4,I4,K)
      IF (Z(K+1) .LE. 0) GO TO 200
      J = Z(K+1)/10000
      K = MOD(Z(K+1),10000)
      IF (J .LT. JB) JB = J
      IF (K .GT. JE) JE = K
 200  CONTINUE
      IF (JB .NE. 9999999) Z(KP1+1) = (JB*10000) + JE
C
C     RESET POINTERS FOR THOSE PROPERTY ID COMMON TO MORE THAN ONE TYPE
C     OF ELEMENTS, AND
C     MOVE THE THIRD ENTRY IN THE Z-TABLE TO FIRST, FOR ELEMENT SORT
C
 210  DO 220 I = 1,II,4
      Z(I) = Z(I+2)
      J = I + 1
      IF (Z(J) .GT. 0) GO TO 220
      IF (Z(J) .EQ. -9999) Z(J) = Z(J-4)
 220  CONTINUE
      CALL SORT (0,0,4,1,Z,II)
C
C     READ IN CONNECTING ELEMENTS, ONE BY ONE, FROM GEOM2 FILE, AND
C     CHECK THE EXISTENCE OF THE PROPERTY ID IF IT IS SPECIFIED.
C
      KK = JJ + 1
      CALL REWIND (GEOM2)
 230  CALL FWDREC (*360,GEOM2)
 240  CALL READ (*300,*300,GEOM2,X,3,0,FLAG)
      CALL BISLOC (*230,X(1),Z,4,I4,K)
      NWDS = Z(K+3)/10000
      IF (NWDS .LE. 0) GO TO 230
      J = Z(K+1)
      IF (J .LE. 0) GO TO 270
      JB = J/10000
      JE = MOD(J,10000)
 250  CALL READ (*360,*240,GEOM2,Z(KK),NWDS,0,FLAG)
      JJ1 = Z(KK+1)
      DO 260 J = JB,JE
      IZ = IABS(Z(J))
      IF (JJ1 .NE. IZ) GO TO 260
      Z(J) = -IZ
      GO TO 250
 260  CONTINUE
      CALL MESAGE (30,10,Z(KK))
      ABORT = .TRUE.
      GO TO 250
 270  J = MOD(Z(K+3),10000)
      CALL MESAGE (30,11,NE(J))
      ABORT = .TRUE.
      GO TO 230
 300  CALL REWIND (GEOM2)
      IF (ABORT .OR. NOPID.NE.0) GO TO 350
C
C     PREPARE AN ACTIVE PROPERTY ID LIST FOR SUBROUTINE MATCK
C
      J  = II + 1
      II = 1
      DO 320 I = J,JJ
      IF (Z(I) .GE. 0) GO TO 310
      II = II + 1
      Z(II) = -Z(I)
      GO TO 320
 310  Z(KK) = Z(I)
      KK = KK + 1
 320  CONTINUE
      Z(1) = II
C
C     Z(2,...II) CONTAINS A LIST OF ACTIVE PROPERTY IDS, UN-SORTED,
C     REFERENCED BY ELEMENTS IN GEOM2 FILE.  Z(1) = LENGTH OF THIS LIST
C
      JJ1 = JJ + 1
      KK  = KK - 1
      IF (KK .LT. JJ1) RETURN
      WRITE  (NOUT,330) UIM
 330  FORMAT (A29,', THE FOLLOWING PROPERTY IDS ARE PRESENT BUT NOT ',
     1        'USED -')
      WRITE  (NOUT,340) (Z(J),J=JJ1,KK)
 340  FORMAT (/5X,12I9)
      RETURN
C
C     SET Z(1) TO ZERO IF NO ACTIVE PROPERTY LIST EXISTS.
C
 350  Z(1) = 0
      RETURN
C
 360  J = -2
      GO TO 400
 370  WRITE  (NOUT,375)
 375  FORMAT ('0*** CAN NOT LOCATE PSHELL OR PCOMP DATA IN /GPTA1/')
      GO TO 390
 380  WRITE  (NOUT,385) Z(KP1),PSHELL,Z(KP1-4),PCOMP(3),
     1                  Z(KP1-8),PCOMP(2),Z(KP1-12),PCOMP(1)
 385  FORMAT ('0*** ERROR IN /GPTA1/ PCOMP ARRANGEMENT',(/3X,2I7))
 390  J = -37
 400  CALL MESAGE (J,0,NAME)
      RETURN
      END

      SUBROUTINE CNSTDD
C
C     THIS SUBROUTINE DEFINES COMMONLY USED PHYSICAL CONSTANTS
C
C     THE /CONDAD/ COMMON BLOCK CONTAINS COMMONLY USED PHYSICAL
C     CONSTANTS IN DOUBLE PRECISION FORM.
C
C     THE /CONDAS/ COMMON BLOCK CONTAINS COMMONLY USED PHYSICAL
C     CONSTANTS IN SINGLE PRECISION FORM.
C
C     THE FOLLOWING IS A PARTIAL LIST OF ROUTINES THAT USE CONSTANTS
C     FROM ONE OF THESE COMMON BLOCKS
C              CDETM    ,CEAD1A   ,CONE     ,DETM5    ,DS1A     ,
C              DTRIA    ,FRRD1A   ,GKAM     ,GP1      ,INPUT    ,
C              KTUBE    ,MCONE    ,MFREE    ,MTUBE    ,PLA32    ,
C              PLA42    ,PRESAX   ,QDMEM    ,RAND3    ,RAND8    ,
C              REIG     ,RFORCE   ,ROD      ,SCONE1   ,SDR2C    ,
C              STUBE1   ,TR1A     ,VDRB
C
C     TYPE DECLARATION
C
      DOUBLE PRECISION   DPI      ,D2PI     ,RADDEG   ,DEGRAD   ,
     1                   D4PISQ
C
C
C     COMMON STATEMENTS
C
      COMMON /CONDAS/    PI       ,TWOPI    ,RADEG    ,DEGRA    ,
     1                   S4PISQ
      COMMON /CONDAD/    DPI      ,D2PI     ,RADDEG   ,DEGRAD   ,
     1                   D4PISQ
C
C
C     PI IS THE SINGLE PRECISION VALUE OF PI
C
      PI     =  3.1415 92653 58979 32384 62643 D0
C
C     DPI IS THE DOUBLE PRECISION VALUE OF PI
C
      DPI    =  3.1415 92653 58979 32384 62643 D0
C
C     TWOPI IS THE SINGLE PRECISION VALUE OF 2*PI
C
      TWOPI  =  6.2831 85307 17958 64769 25287 D0
C
C     D2PI IS THE DOUBLE PRECISION VALUE OF 2*PI
C
      D2PI   =  6.2831 85307 17958 64769 25287 D0
C
C     RADEG IS THE SINGLE PRECISION CONVERSION FACTOR FROM RADIANS TO
C     DEGREES
C
      RADEG  = 57.2957 79513 08232 08767 98155 D0
C
C     RADDEG IS THE DOUBLE PRECISION CONVERSION FACTOR FROM RADIANS TO
C     DEGREES
C
      RADDEG = 57.2957 79513 08232 08767 98155 D0
C
C     DEGRA IS THE SINGLE PRECISIONCONVERSION FACTOR FROM DEGREES TO
C     RADIANS
C
      DEGRA  =  0.0174 53292 51994 32957 69237 D0
C
C     DEGRAD IS THE DOUBLE PRECISION CONVERSION FACTOR FROM DEGREES TO
C     RADIANS
C
      DEGRAD =  0.0174 53292 51994 32957 69237 D0
C
C
C     S4PISQ IS THE SINGLE PRECISION VALUE OF 4*PI**2
C
      S4PISQ = 39.4784 17604 35743 44753 37964 D0
C
C     D4PISQ IS THE DOUBLE PRECISION VALUE OF 4*PI**2
C
      D4PISQ = 39.4784 17604 35743 44753 37964 D0
C
      RETURN
C
C
      END

      SUBROUTINE STRP12 (TI)
C
C     PHASE II OF STRESS DATA RECOVERY
C
      LOGICAL         FLAG
      INTEGER         TLOADS
      REAL            TI(6),SDELTA(3)
      DIMENSION       NSIL(6),STR(18),NPH1OU(990),SI(36),STOUT(68),
     1                REALI(4)
      COMMON /ZZZZZZ/ Z(1)
      COMMON /SDR2X4/ DUMMY(35),IVEC,IVECN,LDTEMP,DEFORM,DUM8(8),
     1                TLOADS,MAXSIZ
      COMMON /SDR2X7/ PH1OUT(990),FORVEC(24)
      COMMON /SDR2X8/ TEMP,DELTA,NPOINT,IJ1,IJ2,NPT1,VEC(5),TEM,
     1                Z1 OVR I,Z2 OVR I,STRESS(18)
      EQUIVALENCE     (NSIL(1),PH1OUT(2)),(NPH1OU(1),PH1OUT(1)),
     1                (SI(1),PH1OUT(19)),(LDTEMP,FTEMP),(F1,N1)
C
C     FIRST GET FORCE VECTOR FOR THE PLATE CONSIDERATION
C
C     M ,  M ,  M ,  V ,  V    FOR ALL SIX GRID POINTS
C      X   Y   XY   X   Y
C
C                                NPTS
C     THE 5X1 FORCE VECTOR = SUMMATION  (S )(U )   FOR EACH POINT
C                                I=1       I   I
C
      NPTS = 6
      DO 15 I = 1,24
   15 FORVEC( I) = 0.0
      FORVEC( 1) = PH1OUT(1)
      FORVEC( 7) = PH1OUT(1)
      FORVEC(13) = PH1OUT(1)
      FORVEC(19) = PH1OUT(1)
C
C     DO 155 II = 1,4
C
      II = 0
   17 II = II + 1
      IF (II .GT. 4) GO TO 155
C
C     ZERO OUT LOCAL STRESSES
C
      SIG X  1 = 0.0
      SIG Y  1 = 0.0
      SIG XY 1 = 0.0
      SIG X  2 = 0.0
      SIG Y  2 = 0.0
      SIG XY 2 = 0.0
C
      IF (NSIL(1) .EQ. 0) GO TO 30
C
C     FORM SUMMATION
C
      DO 20 I = 1,6
C
C     POINTER TO DISPLACEMENT VECTOR IN VARIABLE CORE
C
      NPOINT = IVEC + NSIL(I) - 1
C
      II1 = (II-1)*180 + 30*I - 29
      CALL GMMATS (SI(II1),5,6,0, Z(NPOINT),6,1,0, VEC(1))
C
      DO 10 J = 2,6
      IJ = (II-1)*6 + J
   10 FORVEC(IJ) = FORVEC(IJ) + VEC(J-1)
   20 CONTINUE
C
      IF (TLOADS .EQ. 0) GO TO 23
      JST  = (II-1)*3 + 738
      I1   = (II-1)*6
      FLAG = .FALSE.
      F1   = TI(6)
      IF (N1 .EQ. 1) GO TO 22
      FORVEC(I1+2) = FORVEC(I1+2) - TI(2)
      FORVEC(I1+3) = FORVEC(I1+3) - TI(3)
      FORVEC(I1+4) = FORVEC(I1+4) - TI(4)
      IF (TI(5).EQ.0.0 .AND. TI(6).EQ.0.0) FLAG = .TRUE.
      GO TO 23
   22 FORVEC(I1+2) = FORVEC(I1+2) + TI(2)*PH1OUT(JST+1)
      FORVEC(I1+3) = FORVEC(I1+3) + TI(2)*PH1OUT(JST+2)
      FORVEC(I1+4) = FORVEC(I1+4) + TI(2)*PH1OUT(JST+3)
      IF (TI(3).EQ.0.0 .AND. TI(4).EQ.0.0) FLAG = .TRUE.
   23 CONTINUE
C
C     FORCE VECTOR IS NOW COMPLETE
C
      IF (II .EQ. 4) GO TO 24
      I1 = II*2 + 9
      I2 = I1 + 1
      Z1 OVR I = -12.0*PH1OUT(I1)/PH1OUT(7+II)**3
      Z2 OVR I = -12.0*PH1OUT(I2)/PH1OUT(7+II)**3
      GO TO 25
   24 ZI OVR I = -1.5/PH1OUT(17)**2
      Z2 OVR I = -Z1 OVR I
   25 CONTINUE
      II1 = (II-1)*6
C
      K1 = 0
      ASSIGN 26 TO IRETRN
      GO TO 170
C
   26 SIG X  1 = FORVEC(II1+2)*Z1 OVR I - SDELTA(1)
      SIG Y  1 = FORVEC(II1+3)*Z1 OVR I - SDELTA(2)
      SIG XY 1 = FORVEC(II1+4)*Z1 OVR I - SDELTA(3)
C
      K1 = 1
      ASSIGN 27 TO IRETRN
      GO TO 170
C
   27 SIG X  2 = FORVEC(II1+2)*Z2 OVR I - SDELTA(1)
      SIG Y  2 = FORVEC(II1+3)*Z2 OVR I - SDELTA(2)
      SIG XY 2 = FORVEC(II1+4)*Z2 OVR I - SDELTA(3)
C
      GO TO 40
   30 Z1 = 0.0
      Z2 = 0.0
C
   40 CONTINUE
C
C     STRESS OUTPUT VECTOR IS THE FOLLOWING
C
C      1) ELEMENT ID
C      2) Z1 = FIBER DISTANCE 1
C      3) SIG X  1
C      4) SIG Y  1
C      5) SIG XY 1
C      6) ANGLE OF ZERO SHEAR AT Z1
C      7) SIG P1 AT Z1
C      8) SIG P2 AT Z1
C      9) TAU MAX = MAXIMUM SHEAR STRESS AT Z1
C     10) ELEMENT ID
C     11) Z2 = FIBER DISTANCE 2
C     12) SIG X  2
C     13) SIG Y  2
C     14) SIG XY 2
C     15) ANGLE OF ZERO SHEAR AT Z2
C     16) SIG P1 AT Z2
C     17) SIG P2 AT Z2
C     S7) SIG P2 AT Z2
C     18) TAU MAX = MAXIMUM SHEAR STRESS AT Z2
C
      IF (NPH1OU(2) .EQ. 0) GO TO 120
C
C     COMPUTE PRINCIPAL STRESSES
C
      STR( 1) = PH1OUT(1)
      STR( 2) = PH1OUT(II*2+9)
      STR( 3) = SIG X 1
      STR( 4) = SIG Y 1
      STR( 5) = SIG XY 1
      STR(10) = PH1OUT(1)
      STR(11) = PH1OUT(II*2+10)
      STR(12) = SIG X  2
      STR(13) = SIG Y  2
      STR(14) = SIG XY 2
C
      DO 110 I = 3,12,9
      TEMP     = STR(I)-STR(I+1)
      STR(I+6) = SQRT((TEMP/2.0)**2+STR(I+2)**2)
      DELTA    = (STR(I)+STR(I+1))/2.0
      STR(I+4) = DELTA+STR(I+6)
      STR(I+5) = DELTA-STR(I+6)
      DELTA    = 2.0*STR(I+2)
      IF (ABS(DELTA).LT.1.0E-15 .AND. ABS(TEMP).LT.1.0E-15) GO TO 100
      STR(I+3) = ATAN2(DELTA,TEMP)*28.6478898E0
      GO TO 110
  100 STR(I+3) = 0.0
  110 CONTINUE
      GO TO 140
  120 DO 130 I = 2,18
  130 STR( I) = 0.0
  140 STR( 1) = PH1OUT(1)
      STR(10) = PH1OUT(1)
C
C     ADDITION TO ELIMINATE 2ND ELEMENT ID IN OUTPUT
C
      IJK = (II-1)*17
      STOUT(IJK+1) = PH1OUT(1)
      DO 149 I = 2,9
  149 STOUT(IJK+I) = STR(I)
      DO 150 I = 10,17
  150 STOUT (IJK+I) = STR(I+1)
C
      GO TO 17
  155 CONTINUE
      DO 156 I = 1,17
  156 PH1OUT(100+I) = STOUT(I)
      DO 159 J = 1,3
      DO 159 I = 1,16
      J1 = 117 + (J-1)*16 + I
      J2 = (J-1)*17 + I + 18
      PH1OUT(J1) = STOUT(J2)
  159 CONTINUE
      DO 157 I = 1,6
  157 PH1OUT(200+I) = FORVEC(I)
      DO 158 I = 1,5
      PH1OUT(206+I) = FORVEC(I+ 7)
  158 PH1OUT(211+I) = FORVEC(I+13)
      RETURN
C
C     INTERNAL SUBROUTINE
C
  170 IF (TLOADS.EQ.0 .OR. FLAG) GO TO 200
      JST = 738 + (II-1)*3
      REALI(1) = PH1OUT(8)**3/12.0
      REALI(2) = PH1OUT(9)**3/12.0
      REALI(3) = PH1OUT(10)**3/12.0
      CENTHK   = PH1OUT(17)*2.0
      REALI(4) = CENTHK**3/12.0
      IF (N1 .EQ. 1) GO TO 190
      FF = TI(K1+5) - TI(1)
      IF (ABS(PH1OUT(K1+9+2*II)) .LE.1.0E-07) GO TO 200
      SDELTA(1) = (PH1OUT(JST+1)*FF + TI(2)*PH1OUT(K1+9+2*II))/REALI(II)
      SDELTA(2) = (PH1OUT(JST+2)*FF + TI(3)*PH1OUT(K1+9+2*II))/REALI(II)
      SDELTA(3) = (PH1OUT(JST+3)*FF + TI(4)*PH1OUT(K1+9+2*II))/REALI(II)
      GO TO 210
  190 CONTINUE
      IF (ABS(PH1OUT(K1+9+2*II)) .LE. 1.0E-07) GO TO 200
      FF1 = (TI(K1+3) - PH1OUT(K1+9+2*II)*TI(2)-TI(1))/REALI(II)
      FF2 = (TI(K1+3) - PH1OUT(K1+9+2*II)*TI(2)-TI(1))/REALI(II)
      FF3 = (TI(K1+3) - PH1OUT(K1+9+2*II)*TI(2)-TI(1))/REALI(II)
      SDELTA(1) = PH1OUT(JST+1)*FF1
      SDELTA(2) = PH1OUT(JST+2)*FF2
      SDELTA(3) = PH1OUT(JST+3)*FF3
      GO TO 210
  200 SDELTA(1) = 0.0
      SDELTA(2) = 0.0
      SDELTA(3) = 0.0
  210 GO TO IRETRN, (26,27)
      END

      SUBROUTINE SDR2C
C
C     SDR2C PROCESSES OUTPUT REQUESTS FOR SINGLE-POINT FORCES OF
C     CONSTRAINT, LOADS, DISPLACEMENTS, VELOCITIES, ACCELERATIONS AND
C     EIGENVECTORS.
C
      LOGICAL         ANYOUT,AXIC  ,DDRMM ,AXSINE,AXCOSI
      INTEGER         APP   ,SORT2 ,SPCF  ,DISPL ,VEL   ,ACC   ,STRESS,
     1                FORCE ,CSTM  ,CASECC,EQEXIN,SIL   ,BGPDT ,PG    ,
     2                QG    ,UGV   ,PHIG  ,EIGR  ,OPG1  ,OQG1  ,OUGV1 ,
     3                PUGV1 ,OCB   ,SORC  ,DTYPE ,FILE  ,BUF1  ,BUF2  ,
     4                BUF3  ,BUF4  ,BUF5  ,SYMFLG,OUTFL ,STA   ,REI   ,
     5                DS0   ,DS1   ,FRQ   ,TRN   ,BK0   ,DATE  ,SYSBUF,
     6                BRANCH,PLOTS ,QTYPE2,EOL   ,BK1   ,TIME  ,SETNO ,
     7                FSETNO,Z     ,RETX  ,FORMT ,FLAG  ,EOF   ,CEI   ,
     8                PLA   ,OHARMS,BLANKS,HARMS ,XSETNO,XSET0 ,DEST  ,
     9                PBUFF(4)     ,EXTRA ,AXIF  ,EDT   ,PLATIT(12)   ,
     O                BUF(50)
      REAL            ZZ(1) ,BUFR(11)     ,PBUFR(4)
      DIMENSION       DATE(3)
      COMMON /BLANK / APP(2),SORT2
      COMMON /SDR2X1/ IEIGEN,IELDEF,ITLOAD,ISYMFL,ILOADS,IDISPL,ISTR  ,
     1                IELF  ,IACC  ,IVEL  ,ISPCF ,ITTL  ,ILSYM ,IFROUT,
     2                ISLOAD,IDLOAD,ISORC
      COMMON /SDR2X2/ CASECC,CSTM  ,MPT   ,DIT   ,EQEXIN,SIL   ,GPTT  ,
     1                EDT   ,BGPDT ,PG    ,QG    ,UGV   ,EST   ,PHIG  ,
     2                EIGR  ,OPG1  ,OQG1  ,OUGV1 ,OES1  ,OEF1  ,PUGV1 ,
     3                OEIGR ,OPHIG ,PPHIG ,ESTA  ,GPTTA ,HARMS
      COMMON /SDR2X4/ NAM(2),END   ,MSET  ,ICB(7),OCB(7),MCB(7),DTYPE(8)
     1,               ICSTM ,NCSTM ,IVEC  ,IVECN ,TEMP  ,DEFORM,FILE  ,
     2                BUF1  ,BUF2  ,BUF3  ,BUF4  ,BUF5  ,ANY   ,ALL   ,
     3                TLOADS,ELDEF ,SYMFLG,BRANCH,KTYPE ,LOADS ,SPCF  ,
     4                DISPL ,VEL   ,ACC   ,STRESS,FORCE ,KWDEST,KWDEDT,
     5                KWDGPT,KWDCC ,NRIGDS,STA(2),REI(2),DS0(2),DS1(2),
     6                FRQ(2),TRN(2),BK0(2),BK1(2),CEI(2),PLA(22)      ,
     7                NRINGS,NHARMS,AXIC  ,KNSET ,ISOPL ,STRSPT,DDRMM
      COMMON /ZZZZZZ/ Z(1)
      COMMON /CONDAS/ PI    ,TWOPI ,RADDEG,DEGRA ,S4PISQ
      COMMON /NAMES / RD    ,RDREW ,WRT   ,WRTREW,CLSREW
      COMMON /SYSTEM/ KSYSTM(65)
      COMMON /UNPAKX/ QTYPE2,I2    ,J2    ,INCR2
      COMMON /ZNTPKX/ XX(4),IXX    ,EOL   ,EOR
      COMMON /ZBLPKX/ Y(4) ,IY
      EQUIVALENCE     (KSYSTM( 1),SYSBUF) ,(KSYSTM(15),DATE(1)) ,
     1                (KSYSTM(18),TIME  ) ,(KSYSTM(20),PLOTS  ) ,
     2                (KSYSTM(38),AXIF  ) ,(KSYSTM(56),IHEAT  ) ,
     3                (BUF(1),BUFR(1)),(Z(1),ZZ(1)),(PBUFF(1),PBUFR(1))
      DATA    BUF   / 50*0     /
      DATA    BLANKS/ 4H       /
      DATA    XSET0 / 100000000/
      DATA    PLATIT/ 4HLOAD,4H FAC,4HTOR ,9*0/
      DATA    MMREIG/ 4HMMRE   /
C
C     IF THIS IS A DYNAMIC-DATA-RECOVERY-MATRIX-METHOD REIG PROBLEM
C     THEN ALL EIGENVECTORS ARE TO BE OUTPUT FOR THE DDRMM MODULE.
C
      SETNO = 0
      IF (DDRMM .AND. IREQ.EQ.IDISPL) SETNO = -1
C
C     PERFORM GENERAL INITIALIZATION
C
      BUF1  = KORSZ(Z) - SYSBUF + 1
      BUF2  = BUF1 - SYSBUF
      BUF3  = BUF2 - SYSBUF
      BUF4  = BUF3 - SYSBUF
      BUF5  = BUF4 - SYSBUF
      ISEQ  = 1
      M8    =-8
      I2    = 1
      INCR2 = 1
      KPLOT = 0
      EXTRA = 0
      AXSINE = .FALSE.
      AXCOSI = .FALSE.
C
C     READ SECOND RECORD OF EQEXIN OR EQDYN INTO CORE.
C
      FILE = EQEXIN
      CALL GOPEN (EQEXIN,Z(BUF1),0)
      CALL SKPREC (EQEXIN,1)
      CALL READ (*1320,*30,EQEXIN,Z,BUF5,1,NEQEX)
      CALL MESAGE (M8,0,NAM)
   30 CALL CLOSE (EQEXIN,CLSREW)
      ITABL= 1
      KN   = NEQEX/2
      ICC  = NEQEX
      ILIST= NEQEX + 1
C
C     INITIALIZE FOR PROCESSING SPECIFIC REQUEST.
C
   40 IF (ISEQ-2) 50,60,70
C
C     LOAD VECTOR.
C
   50 IF (LOADS.EQ.0 .OR. APP(1).EQ.REI(1) .OR. APP(1).EQ.CEI(1) .OR.
     1    APP(1).EQ.BK1(1)) GO TO 1180
      INFIL = 115
      OUTFL = OPG1
      IREQ  = ILOADS
      GO TO 90
C
C     SINGLE-POINT FORCES OF CONSTRAINT.
C
   60 IF (SPCF .EQ. 0) GO TO 1180
      INFIL = QG
      OUTFL = OQG1
      IREQ  = ISPCF
      GO TO 90
C
C     DISPLACEMENT VECTOR OR EIGENVECTOR
C
   70 IF (DISPL.NE.0 .OR. VEL.NE.0 .OR. ACC.NE.0 .OR. PLOTS.NE.0)
     1    GO TO 80
      GO TO 1180
   80 INFIL = UGV
      OUTFL = OUGV1
      JTJ   = VEL + ACC
      IF (.NOT.(APP(1).EQ.MMREIG .AND. DISPL.EQ.0 .AND. JTJ.NE.0))
     1    GO TO 88
      IF (VEL .EQ. 0) GO TO 84
      IREQ = IVEL
      GO TO 90
   84 IREQ = IACC
      GO TO 90
   88 IREQ = IDISPL
C
C     READ TRAILER ON INPUT FILE. SET PARAMETERS.
C
   90 ICB(1) = INFIL
      CALL RDTRL (ICB)
      IF (ICB(1) .NE. INFIL) GO TO 1200
      NVECTS = ICB(2)
      IF (ICB(5) .GT. 2) GO TO 100
C
C     REAL VECTOR.
C
      KTYPE  = 1
      QTYPE2 = 1
      KTYPE1 = 2
      NWDS   = 8
      KTYPEX = 0
      GO TO 110
C
C     COMPLEX VECTOR.
C
  100 KTYPE  = 2
      QTYPE2 = 3
      KTYPE1 = 3
      NWDS   = 14
      KTYPEX = 1000
C
C     OPEN CASE CONTROL AND SKIP HEADER. THEN BRANCH ON APPROACH.
C
  110 CALL GOPEN (CASECC,Z(BUF1),0)
      PBUFF(2) = 1
      GO TO (190,120,190,150,160,160,190,150,120,190), BRANCH
C
C     EIGENVALUES - READ LIST OF MODE NOS. AND EIGENVALUES INTO CORE.
C
  120 FILE = EIGR
      CALL GOPEN (EIGR,Z(BUF2),0)
      CALL SKPREC (EIGR,1)
      IF (APP(1) .EQ. CEI(1)) PBUFF(2) = 5
      IF (APP(1) .EQ. REI(1)) PBUFF(2) = 4
      I = ILIST
      M = 8 - KTYPE
      ISKIP = 0
      INDEX = 2
      IF (APP(1) .NE. REI(1)) GO TO 130
C
C     CHECK TO SEE IF ALL GENERALIZED MASS VALUES ARE ZERO
C
  125 CALL READ (*1320,*127,EIGR,BUF,M,0,FLAG)
      IF (BUF(6) .EQ. 0.0) GO TO 125
      INDEX = 0
  127 CALL SKPREC (EIGR,-1)
  130 CALL READ (*1320,*140,EIGR,BUF,M,0,FLAG)
      IF (APP(1) .NE. REI(1)) GO TO 135
      IF (INDEX .EQ. 2) GO TO 135
C
C     MATCH CORRECT MODE NOS. AND EIGENVALUES WITH PROPER
C     EIGENVECTORS WHEN USING GIVENS METHOD WITH F1.GT.0.0
C
      IF (INDEX  .EQ.  1) GO TO 135
      IF (BUF(6) .NE. 0.) GO TO 133
      ISKIP = ISKIP + 1
      GO TO 130
  133 INDEX = 1
  135 Z(I  ) = BUF(1) - ISKIP
      Z(I+1) = BUF(3)
      Z(I+2) = BUF(4)
      I = I + KTYPE1
      GO TO 130
  140 CALL CLOSE (EIGR,CLSREW)
      NLIST = I - KTYPE1
      ICC   = I
      GO TO 190
C
C     DIFF. STIFF. PHASE 1 OR BUCKLING PHASE 1 - SKIP 1ST DATA RECORD ON
C     CC.
C
  150 CALL SKPREC (CASECC,1)
      PBUFF(2) = 4
      IF (APP(1) .EQ. BK1(1)) GO TO 120
      PBUFF(2) = 1
      GO TO 190
C
C     FREQUENCY OR TRANSIENT RESPONSE - READ LIST INTO CORE.
C
  160 FILE = PG
      CALL OPEN (*1310,FILE,Z(BUF2),RDREW)
      I  = ILIST
      M  = 3
      IX = 1
      PBUFF(2) = 3
      IF (APP(1) .EQ. FRQ(1)) PBUFF(2) = 2
      IF (APP(1).EQ.FRQ(1) .OR. APP(1).EQ.TRN(1)) IX = 2
  170 CALL READ (*1320,*180,FILE,BUF,M,0,FLAG)
      Z(I  ) = BUF(M)
      Z(I+1) = 0
      I = I + IX
      M = 1
      GO TO 170
  180 CALL CLOSE (FILE,CLSREW)
      NLIST = I - IX
      ICC   = I
C
C     OPEN OUTPUT FILE. WRITE HEADER RECORD.
C
  190 FILE   = OUTFL
      ANYOUT = .FALSE.
      CALL OPEN (*1200,OUTFL,Z(BUF2),WRTREW)
      OCB(1) = OUTFL
      CALL FNAME (OUTFL,BUF)
      DO 200 I = 1,3
  200 BUF(I+2) =  DATE(I)
      BUF(6) = TIME
      BUF(7) = 1
      CALL WRITE (OUTFL,BUF,7,1)
C
C     OPEN INPUT FILE. SKIP HEADER RECORD.
C
      FILE   = INFIL
      CALL OPEN (*1190,INFIL,Z(BUF3),RDREW)
      CALL FWDREC (*1320,INFIL)
C
C     SET PARAMETERS TO KEEP CASE CONTROL AND VECTORS IN SYNCH.
C
      EOF    = 0
      JCOUNT = 0
      KCOUNT = 1
      JLIST  = ILIST
      KFRQ   = 0
      INCORE = 0
      KWDS   = 0
C
C     READ A RECORD IN CASE CONTROL. SET SYMMETRY FLAG.
C
  230 CALL READ (*1160,*240,CASECC,Z(ICC+1),BUF5-ICC,1,NCC)
      CALL MESAGE (M8,0,NAM)
  240 IX     = ICC + ISYMFL
      ITEMP  = ICC + HARMS
C
C     OHARMS WILL BE 1 GREATER THAN THE MAXIMUM OUTPUT HARMONIC
C
      OHARMS = Z(ITEMP)
      IF (OHARMS.LT.0 .AND. AXIF.NE.0) OHARMS = AXIF
      IF (OHARMS .LT. 0) OHARMS = NHARMS
C
C     IF A FLUID PROBLEM CONVERT USER HARMONIC TO INTERNAL HARMONIC MAX.
C
      IF (OHARMS .EQ. 0) GO TO 243
      IF (AXIF   .EQ. 0) GO TO 243
      OHARMS = OHARMS - 1
      OHARMS = 2*OHARMS + 3
  243 SYMFLG = Z(IX)
      IF (SYMFLG .EQ. 0) SORC = Z(ICC+ISORC)
      IF (SORC .EQ. 1) AXSINE = .TRUE.
      IF (SORC .EQ. 2) AXCOSI = .TRUE.
      IFLAG  = 0
      IF (AXIC .AND. AXSINE .AND. AXCOSI .AND. JCOUNT.EQ.2) IFLAG = 1
      IVEC   = ICC + NCC + 1
C
C     DETERMINE IF OUTPUT REQUEST IS PRESENT.
C     IF NOT, TEST FOR RECORD SKIP ON INFIL  THEN GO TO END OF THIS
C     REQUEST.
C     IF SO, SET POINTERS TO SET DEFINING REQUEST.
C
  250 IREQX  = ICC + IREQ
      SETNO  = Z(IREQX  )
      DEST   = Z(IREQX+1)
      FORMT  = IABS(Z(IREQX+2))
      XSETNO = -1
      IF (SETNO) 300,260,280
  260 IF (SYMFLG .NE. 0) GO TO 1000
      IF (APP(1) .NE. FRQ(1)) GO TO 270
      IF (ISEQ  .EQ. 3) GO TO 300
  270 IF (PLOTS .NE. 0) GO TO 300
      CALL FWDREC (*1320,INFIL)
      JCOUNT = JCOUNT + 1
      GO TO 1000
  280 IX     = ICC + ILSYM
      ISETNO = IX + Z(IX) + 1
  290 ISET   = ISETNO + 2
      NSET   = Z(ISETNO+1) + ISET - 1
      IF (Z(ISETNO) .EQ. SETNO) GO TO 295
      ISETNO = NSET + 1
      IF (ISETNO .LT. IVEC) GO TO 290
      SETNO  = -1
      GO TO 300
C
C     IF REQUIRED, LOCATE PRINT/PUNCH SUBSET.
C
  295 IF (SETNO .LT. XSET0) GO TO 300
      XSETNO = DEST/10
      DEST   = DEST - 10*XSETNO
      IF (XSETNO .EQ. 0) GO TO 300
      IXSETN = IX + Z(IX) + 1
  296 IXSET  = IXSETN + 2
      NXSET  = Z(IXSETN+1) + IXSET - 1
      IF (Z(IXSETN) .EQ. XSETNO) GO TO 300
      IXSETN = NXSET + 1
      IF (IXSETN .LT. IVEC) GO TO 296
      XSETNO = -1
C
C     UNPACK VECTOR INTO CORE (UNLESS VECTOR IS ALREADY IN CORE).
C
  300 IF (INCORE .NE. 0) GO TO 400
      IVECN = IVEC + KTYPE*ICB(3) - 1
      IF (IVECN  .GE. BUF5) CALL MESAGE (M8,0,NAM)
      IF (SYMFLG .EQ. 0) GO TO 360
C
C     SYMMETRY SEQUENCE - BUILD VECTOR IN CORE.
C
      IX   = ICC + ILSYM
      LSYM = Z(IX)
C
C     IF SYMFLG IS NEGATIVE THIS IS A REPEAT SUBCASE. BCKREC VECTOR
C     AND READ IT INTO CORE.
C
      IF (SYMFLG.LT.0 .AND. APP(1).EQ.STA(1)) GO TO 358
      IF (SYMFLG .LT. 0) GO TO 230
      DO 310 I = IVEC,IVECN
  310 ZZ(I) = 0.
      DO 320 I = 1,LSYM
  320 CALL BCKREC (INFIL)
      ISYMN = IX + LSYM
      I = IX + 1
  330 COEF = ZZ(I)
      CALL INTPK (*350,INFIL,0,QTYPE2,0)
  340 CALL ZNTPKI
      IX = IVEC + IXX - 1
      ZZ(IX) = ZZ(IX) + COEF*XX(1)
      IF (KTYPE .EQ. 2) ZZ(IX+1) = ZZ(IX+1) + COEF*XX(2)
      IF (EOL .EQ. 0) GO TO 340
  350 I = I + 1
      IF (I .LE. ISYMN) GO TO 330
      GO TO 400
C
C     REPEAT SUBCASE
C
  358 JCOUNT = JCOUNT - 1
      CALL BCKREC (INFIL)
C
C     NOT SYMMETRY - UNPACK VECTOR.
C
  360 J2= ICB(3)
      IF (JCOUNT .GE. NVECTS) GO TO 1170
      CALL UNPACK (*370,INFIL,Z(IVEC))
      GO TO 390
  370 DO 380 I = IVEC,IVECN
  380 ZZ(I)  = 0.
  390 JCOUNT = JCOUNT + 1
C
C     TEST FOR CONTINUATION FROM HERE.
C
  400 IF (SETNO .NE. 0) GO TO 410
      IF (APP(1) .EQ. FRQ(1)) GO TO 1040
C
C     PREPARE TO WRITE ID RECORD ON OUTPUT FILE.
C
  410 GO TO (420,430,420,420,440,560,420,430,430,420), BRANCH
C
C     NORMAL STATICS OR DIFF.STIFF. PHASE O OR 1 OR BUCKLING PHASE 0.
C
  420 BUF(2) = DTYPE(ISEQ)
      IX = ICC + ISLOAD
      BUF(5) = Z(ICC+1)
      BUF(6) = 0
      BUF(7) = 0
      BUF(8) = Z(IX)
      PBUFF(2) = 1
      PBUFF(3) = Z(IX)
      PBUFF(4) = 0
      IF (BRANCH .NE. 10) GO TO 610
      IX = ICC + ITTL + 84
      Z(IX  ) = PLATIT(1)
      Z(IX+1) = PLATIT(2)
      Z(IX+2) = PLATIT(3)
      CALL INT2AL (JCOUNT,Z(IX+3),PLATIT(4))
      GO TO 610
C
C     EIGENVALUES OR BUCKLING PHASE 1.
C
  430 IF (ISEQ .EQ. 2) BUF(2) = KTYPEX + 3
      IF (ISEQ .EQ. 3) BUF(2) = KTYPEX + 7
      BUF(5) = Z(JLIST  )
      BUF(6) = Z(JLIST+1)
      BUF(7) = Z(JLIST+2)
      BUF(8) = 0
C     PBUFF(2) = 2  THIS CARD WAS REMOVED SINCE LEVEL 16. NO LONGER NEED
      PBUFF(3) = BUF(5)
      IF (APP(1) .EQ. BK1(1)) PBUFF(3) = -BUF(5)
      PBUFF(4) = BUF(6)
      IF (APP(1).NE.BK1(1) .AND. APP(1).NE.CEI(1))
     1   PBUFR(4) = SQRT(ABS(BUFR(6)))/TWOPI
      IF (APP(1) .EQ. CEI(1)) PBUFR(4) = ABS(BUFR(7))/TWOPI
      GO TO 610
C
C     FREQUENCY RESPONSE.
C
  440 IX = ICC + IDLOAD
      BUF(8) = Z(IX)
      BUF(6) = 0
      BUF(7) = 0
      PBUFF(2) = 2
      PBUFF(3) = BUF(8)
      IF (ISEQ .EQ. 3) GO TO 520
      BUF(2) = DTYPE(ISEQ) + KTYPEX
      GO TO 441
  520 IF (KCOUNT-2) 530,540,550
  530 BUF(2) = 1001
      GO TO 441
  540 BUF(2) = 1010
      GO TO 441
  550 BUF(2) = 1011
      GO TO 441
  441 CONTINUE
      IF (KFRQ .NE. 0) GO TO 510
C
C     FIRST TIME FOR THIS LOAD VECTOR ONLY - MATCH LIST OF USER
C     REQUESTED FREQS WITH ACTUAL FREQS. MARK FOR OUTPUT EACH ACTUAL
C     FREQ WHICH IS CLOSEST TO USER REQUEST.
C
      KFRQ   = 1
      IX     = ICC + IFROUT
      FSETNO = Z(IX)
      IF (FSETNO .LE. 0) GO TO 460
      IX     = ICC + ILSYM
      ISETNF = IX  + Z(IX) + 1
  450 ISETF  = ISETNF + 2
      NSETF  = Z(ISETNF+1) + ISETF - 1
      IF(Z(ISETNF) .EQ. FSETNO) GO TO 480
      ISETNF = NSETF + 1
      IF (ISETNF .LT. IVEC) GO TO 450
      FSETNO = -1
  460 DO 470 J = ILIST,NLIST,2
  470 Z(J+1) = 1
      GO TO 510
  480 DO 500 I = ISETF,NSETF
      K    = 0
      DIFF = 1.E25
      BUFR(1) = ZZ(I)
      DO 490 J = ILIST,NLIST,2
      IF (Z(J+1) .NE. 0) GO TO 490
      DIFF1 = ABS(ZZ(J)-BUFR(1))
      IF (DIFF1 .GE. DIFF) GO TO 490
      DIFF = DIFF1
      K = J
  490 CONTINUE
      IF (K .NE. 0) Z(K+1) = 1
  500 CONTINUE
C
C     DETERMINE IF CURRENT FREQ IS MARKED FOR OUTPUT.
C
  510 IF (Z(JLIST+1) .EQ. 0) GO TO 1000
      BUF(5)   = Z(JLIST)
      PBUFF(4) = BUF(5)
      GO TO 610
C
C     TRANSIENT RESPONSE.
C
  560 BUF(5) = Z(JLIST)
      IF (KCOUNT - 2) 570,580,590
  570 BUF(2) = 1
      GO TO 600
  580 BUF(2) = 10
      GO TO 600
  590 BUF(2) = 11
  600 IF (IREQ .EQ. ILOADS) BUF(2) = 2
      IF (IREQ .EQ. ISPCF ) BUF(2) = 3
      IX = ICC + IDLOAD
      BUF(8) = Z(IX)
      BUF(6) = 0
      BUF(7) = 0
      PBUFF(2) = 3 + 10*(KCOUNT-1)
      PBUFF(3) = BUF(8)
      PBUFF(4) = BUF(5)
      GO TO 441
C
C     WRITE ID RECORD ON OUTPUT FILE.
C
  610 IF (SETNO.EQ.0 .AND. PLOTS.NE.0) GO TO 880
      BUF(1) = DEST + 10*BRANCH
      BUF(3) = 0
C
C     IF CONICAL SHELL PROBLEM, SET MINOR ID = 1000 FOR USE BY OFP
C
      IF (AXIC) BUF(3) = 1000
      BUF(4) = Z(ICC+1)
      IF (DDRMM) BUF(4) = 9999
      BUF(9) = IABS(Z(IREQX+2))
      IF (BUF(9).EQ.1 .AND. KTYPE.EQ.2) BUF(9) = 2
      FORMT  = BUF(9)
      BUF(10)= NWDS
      CALL WRITE (OUTFL,BUF,50,0)
      IX = ICC + ITTL
      CALL WRITE (OUTFL,Z(IX),96,1)
C
C     BUILD DATA RECORD ON OUTPUT FILE.
C
      IF (SETNO .NE. -1) GO TO 650
C
C     SET .EQ. ALL  -  OUTPUT ALL POINTS DEFINED IN EQEXIN.
C
      KX = 1
      N  = NEQEX - 1
      ASSIGN 640 TO RETX
      GO TO 700
  640 KX = KX + 2
      IF (KX .LE. N) GO TO 700
      GO TO 880
C
C     SET .NE. ALL  -  OUTPUT ONLY POINTS DEFINED IN SET.
C
  650 JHARM = 0
  651 I = ISET
  660 IF (I   .EQ. NSET) GO TO 680
      IF (Z(I+1) .GT. 0) GO TO 680
      N = -Z(I+1)
      BUF(1) = Z(I)
      IBUFSV = BUF(1)
      I = I + 1
      ASSIGN 670 TO RETX
      GO TO 1210
  670 BUF(1) = IBUFSV + 1
      IBUFSV = BUF(1)
      IF (BUF(1) .LE. N) GO TO 1210
      GO TO 690
  680 BUF(1) = Z(I)
      ASSIGN 690 TO RETX
      GO TO 1210
  690 I = I + 1
      IF (I .LE. NSET) GO TO 660
      JHARM = JHARM + 1
      IF (.NOT.AXIC .AND. AXIF.EQ.0) GO TO 880
      IF (JHARM .LE. OHARMS) GO TO 651
      GO TO 880
C
C     PICK UP POINTER TO GRID POINT DATA AND GRID POINT TYPE.
C
  700 BUF(1) = Z(KX)
      IF (IFLAG.EQ.1 .AND. BUF(1).GE.1000000) GO TO RETX, (640,670,690)
      J = Z(KX+1)/10
      BUF(2) = Z(KX+1) - 10*J
      J = IVEC + KTYPE*(J-1)
      IF (BUF(2) .EQ. 1) GO TO 770
C
C     SCALAR OR EXTRA POINT.
C
      BUF(3) = Z(J)
      IF (KTYPE .EQ. 2) GO TO 720
      IF (ISEQ.LE.2 .AND. BUFR(3).EQ.0.0 .AND. SORT2.LT.0)
     1    GO TO RETX, (640,670,690)
      DO 710 K = 4,8
  710 BUF(K) = 0
      GO TO 840
C
C     COMPLEX SCALAR OR EXTRA POINT.
C
  720 BUF(4) = Z(J+1)
      IF (ISEQ.LE.2 .AND. BUFR(3).EQ.0.0 .AND. BUFR(4).EQ.0.0 .AND.
     1    SORT2.LT.0) GO TO RETX, (640,670,690)
      DO 730 K = 5,14
  730 BUF(K) = 0
      IF (FORMT .NE. 3) GO TO 840
      REDNER = SQRT(BUFR(3)**2 + BUFR(4)**2)
      IF (REDNER) 750,740,750
  740 BUFR(4) = 0.0
      GO TO 760
  750 BUFR(4) = ATAN2(BUFR(4),BUFR(3))*RADDEG
      IF (BUFR(4) .LT. -0.00005) BUFR(4) = BUFR(4) + 360.0
  760 BUFR(3) = REDNER
      GO TO 840
C
C     GRID POINT.
C
  770 FLAG = 0
      IF (KTYPE .EQ. 2) GO TO 790
      DO 780 K = 1,6
      BUFR(K+2) = ZZ(J)
      IF (BUFR(K+2).NE.0.0 .OR. SORT2.GE.0) FLAG = 1
  780 J = J + 1
      IF (ISEQ.LE.2 .AND. FLAG.EQ.0) GO TO RETX, (640,670,690)
      GO TO 840
C
C     COMPLEX GRID POINT.
C
  790 DO 830 K = 1,11,2
      BUFR(K+2) = ZZ(J  )
      BUFR(K+3) = ZZ(J+1)
      IF (BUFR(K+2).NE.0. .OR. BUFR(K+3).NE.0. .OR. SORT2.GE.0) FLAG = 1
      IF (FORMT .NE. 3) GO TO 830
      REDNER = SQRT(BUFR(K+2)**2 + BUFR(K+3)**2)
      IF (REDNER) 810,800,810
  800 BUFR(K+3) = 0.0
      GO TO 820
  810 BUFR(K+3) = ATAN2( BUFR(K+3),BUFR(K+2) )*RADDEG
      IF (BUFR(K+3) .LT. -0.00005) BUFR(K+3) = BUFR(K+3) + 360.0
  820 BUFR(K+2) = REDNER
  830 J = J + 2
      IF (ISEQ.LE.2 .AND. FLAG.EQ.0) GO TO RETX, (640,670,690)
C
C     WRITE ENTRY ON OUTPUT FILE.
C
C     IF COMPLEX  TRANSPOSE DATA FOR OFP (REAL TOP, IMAG BOTTOM)
C
  840 IF (NWDS .NE. 14) GO TO 850
      ITEMP   = BUF( 4)
      BUF( 4) = BUF( 5)
      BUF( 5) = BUF( 7)
      BUF( 7) = BUF(11)
      BUF(11) = BUF( 8)
      BUF( 8) = BUF(13)
      BUF(13) = BUF(12)
      BUF(12) = BUF(10)
      BUF(10) = BUF( 6)
      BUF( 6) = BUF( 9)
      BUF( 9) = ITEMP
C
  850 ANYOUT = .TRUE.
C
C     IF CONICAL SHELL DECODE GRID POINT NUMBER IF GREATER THAN 1000000.
C
      IF (.NOT.AXIC) GO TO 870
      IF (BUF(1) .GE. 1000000) GO TO 860
      BUF(2) = BLANKS
      GO TO 870
  860 ITEMP = BUF(1)/1000000
C
C     STOP OUTPUT WHEN PRESENT HARMONIC EXCEEDS OUTPUT HARMONIC SIZE REQ
C
      IF (ITEMP .GT. OHARMS) GO TO 880
      BUF(1) = BUF(1) - ITEMP*1000000
      BUF(2) = ITEMP - 1
      GO TO 876
C
C     IF A FLUID PROBLEM THEN A CHECK IS MADE ON THE HARMONIC ID
C
  870 IF (AXIF) 876,876,861
  861 IF (BUF(1) .LT. 500000) GO TO 876
      ITEMP = BUF(1) - MOD(BUF(1),500000)
      ITEMP = ITEMP/500000
C
C     STOP THE OUTPUT IF THE HARMONIC IS GREATER THAN THE OUTPUT
C     REQUEST FOR HARMONICS
C
      IF (ITEMP .GE. OHARMS) GO TO 880
C
C     DETERMINE DESTINATION FOR ENTRY.
C
  876 ID = BUF(1)
      BUF(1) = 10*ID + DEST
      IF (XSETNO) 878,871,872
  871 BUF(1) = 10*ID
      GO TO 878
  872 IX = IXSET
  873 IF (IX .EQ.  NXSET) GO TO 874
      IF (Z(IX+1) .GT. 0) GO TO 874
      IF (ID.GE.Z(IX) .AND. ID.LE.-Z(IX+1)) GO TO 878
      IX = IX + 2
      GO TO 875
  874 IF (ID .EQ. Z(IX)) GO TO 878
      IX = IX + 1
  875 IF (IX .LE. NXSET) GO TO 873
      GO TO 871
C
C     NOW WRITE ENTRY.
C
  878 CALL WRITE (OUTFL,BUF(1),NWDS,0)
      BUF(1) = ID
      KWDS = KWDS + NWDS
      GO TO RETX, (640,670,690)
C
C     IF PLOTS ARE REQUESTED, READ THE CSTM INTO CORE.
C     IF FIRST VECTOR, OPEN PUGV1 AND WRITE HEADER RECORD.
C
  880 CONTINUE
      EXTRA = 0
      IF (ISEQ.NE.3 .OR. PLOTS.EQ.0 .OR. (KCOUNT.NE.1 .AND.
     1    APP(1).NE.TRN(1))) GO TO 990
      IF (SYMFLG .LT. 0) GO TO 990
      FILE = CSTM
      CALL OPEN (*900,CSTM,Z(BUF5),RDREW)
      CALL FWDREC (*1320,CSTM)
      ICSTM = IVECN + 1
      CALL READ (*1320,*890,CSTM,Z(ICSTM),BUF5-ICSTM,1,NCSTM)
      CALL MESAGE (M8,0,NAM)
  890 CALL CLOSE (CSTM,CLSREW)
      CALL PRETRS (Z(ICSTM),NCSTM)
  900 IF (JCOUNT .NE. 1) GO TO 902
      CALL MAKMCB (MCB,PUGV1,J2,2,QTYPE2)
      FILE = PUGV1
      CALL OPEN (*902,PUGV1,Z(BUF4),WRTREW)
      KPLOT = 1
      CALL FNAME (PUGV1,BUF)
      CALL WRITE (PUGV1,BUF,2,1)
C
C     IF PLOT FILE IS PURGED, NO PLOT FILE CAN BE PREPARED.
C     IF TRANSIENT PROBLEM, REMOVE EXTRA POINTS FROM VECTOR
C     NOW IN CORE THUS CREATING A G-SET VECTOR.
C
  902 EXTRA = 0
      IF (KPLOT .EQ. 0) GO TO 990
      IF (APP(1).NE.TRN(1) .AND. APP(1).NE.FRQ(1) .AND. APP(1).NE.CEI(1)
     1   ) GO TO 910
      DO 903 I = 1,NEQEX,2
      J = Z(I+1)/10
      K = Z(I+1) - 10*J
      IF (K .NE. 3) GO TO 903
      EXTRA = 1
      J = KTYPE*J + IVEC - KTYPE
      Z(J) = 1
      IF (KTYPE .EQ. 2) Z(J+1) = 1
  903 CONTINUE
      IF (EXTRA .EQ. 0) GO TO 910
      J = IVEC
      DO 905 I = IVEC,IVECN
      IF (Z(I) .EQ. 1) GO TO 905
      Z(J) = Z(I)
      J = J + 1
  905 CONTINUE
      IVECN = J - 1
C
C     PASS THE BGPDT. FOR EACH ENTRY, ROTATE THE TRANSLATION COMPONENTS
C     OF UGV TO BASIC (IF REQUIRED). WRITE THESE COMPONENTS ON PUGV1.
C
  910 FILE = BGPDT
      CALL OPEN (*990,BGPDT,Z(BUF5),RDREW)
      CALL FWDREC (*1320,BGPDT)
      K = 0
      I = IVEC
      PBUFF(1) = Z(ICC+1)
      CALL WRITE (PUGV1,PBUFF,4,1)
      L = 3*KTYPE
      CALL BLDPK (QTYPE2,QTYPE2,PUGV1,0,0)
  920 CALL READ (*1320,*980,BGPDT,BUF(7),4,0,FLAG)
      ITEMP = 0
      DO 925 J = 1,L
      LL = I + J - 1
  925 BUFR(J) = ZZ(LL)
      IF (BUF(7)) 950,940,930
C
C     TRANSFORM TO BASIC
C
  930 IF (QTYPE2 .EQ. 1) GO TO 935
      J = BUF(2)
      BUF(2) = BUF(3)
      BUF(3) = BUF(5)
      BUF(5) = BUF(4)
      BUF(4) = J
  935 ITEMP  = 19
      CALL TRANSS (BUFR(7),BUFR(11))
      CALL GMMATS (BUFR(11),3,3,0,BUFR(1),3,1,0,BUF(ITEMP+1))
      IF (QTYPE2 .EQ. 1) GO TO 940
      CALL GMMATS (BUFR(11),3,3,0,BUFR(4),3,1,0,BUF(ITEMP+4))
      J       = BUF(21)
      BUF(21) = BUF(23)
      BUF(23) = BUF(24)
      BUF(24) = BUF(22)
      BUF(22) = J
  940 IY = (I-IVEC+K)/KTYPE
      DO 945 J = 1,L,KTYPE
      IY = IY + 1
      LL = ITEMP + J
      Y(1) = BUFR(LL)
      IF (KTYPE .EQ. 2) Y(2) = BUFR(LL+1)
      CALL ZBLPKI
  945 CONTINUE
      I = I + 6*KTYPE
      GO TO 920
C
C     CHECK FOR FLUID POINTS
C
  950 I = I + KTYPE
      IF (BUF(7) .NE. -2) GO TO 920
      IY = (I-IVEC+K)/KTYPE + 2
      Y(1) = BUFR(1)
      IF (QTYPE2 .EQ. 3) Y(2) = BUFR(2)
      CALL ZBLPKI
      K = K + 5*KTYPE
      GO TO 920
  980 CALL BLDPKN (PUGV1,0,MCB)
      CALL CLOSE (BGPDT,CLSREW)
C
C     CONCLUDE PROCESSING OF THIS VECTOR.
C
  990 IF (SETNO .NE. 0) CALL WRITE (OUTFL,0,0,1)
 1000 GO TO (1010,1020,1170,1020,1040,1110,1170,1020,1020,1020), BRANCH
C
C     NORMAL STATICS.
C
 1010 IF (JCOUNT .LT. NVECTS) GO TO 230
      IF (EOF .EQ. 0) GO TO 230
      GO TO 1170
C
C     EIGENVALUES OR DIFF. STIFF PHASE1 OR BUCKLING PHASE 1.
C
 1020 JLIST = JLIST + KTYPE1
 1030 IF (JCOUNT .GE. NVECTS) GO TO 1170
      IF (EOF .EQ. 0) GO TO 230
      GO TO 250
C
C     FREQUENCY RESPONSE.
C
 1040 IF (ISEQ   .LE. 2) GO TO 1090
      IF (KCOUNT .EQ. 3) GO TO 1080
      N = IVECN - 1
      IF (EXTRA .EQ. 0) GO TO 1045
      CALL BCKREC (INFIL)
      CALL UNPACK (*1041,INFIL,Z(IVEC))
      GO TO 1045
 1041 DO 1042 I = IVEC,N
 1042 ZZ(I) = 0.0
      GO TO 1055
 1045 CONTINUE
      OMEGA = TWOPI*ZZ(JLIST)
      DO 1050 I = IVEC,N,2
      BUFR(1) = -OMEGA*ZZ(I+1)
      ZZ(I+1) =  OMEGA*ZZ(I  )
 1050 ZZ(I  ) =  BUFR(1)
 1055 IF (KCOUNT .EQ. 2) GO TO 1060
      IREQ   = IVEL
      GO TO 1070
 1060 IREQ   = IACC
 1070 KCOUNT = KCOUNT + 1
      INCORE = 1
      GO TO 250
 1080 KCOUNT = 1
      IREQ   = IDISPL
 1090 INCORE = 0
      JLIST  = JLIST + 2
      IF (JLIST.LE.NLIST .AND. JCOUNT.LT.NVECTS) GO TO 250
      KFRQ   = 0
      JLIST  = ILIST
      DO 1100 I = ILIST,NLIST,2
 1100 Z(I+1) = 0
      IF (JCOUNT .LT. NVECTS) GO TO 230
      GO TO 1170
C
C     TRANSIENT RESPONSE.
C
 1110 IF (ISEQ .LE. 2) GO TO 1150
      IF (KCOUNT - 2) 1120,1130,1140
 1120 IREQ   = IVEL
      KCOUNT = 2
      GO TO 250
 1130 IREQ   = IACC
      KCOUNT = 3
      GO TO 250
 1140 IREQ   = IDISPL
      KCOUNT = 1
 1150 JLIST  = JLIST + 2
      IF (JLIST.LE.NLIST .AND. JCOUNT.LT.NVECTS) GO TO 250
      GO TO 1170
C
C     HERE WHEN END-OF-FILE ENCOUNTERED ON CASE CONTROL.
C
 1160 EOF = 1
      GO TO (1170,1030,1170,1030,1170,1170,1170,1030,1030,1030), BRANCH
C
C     CONCLUDE PROCESSING OF CURRENT INPUT FILE.
C
 1170 CALL CLOSE (CASECC,CLSREW)
      CALL CLOSE (INFIL ,CLSREW)
      CALL CLOSE (OUTFL ,CLSREW)
      IF (KPLOT .NE. 0) CALL CLOSE (PUGV1,CLSREW)
      IF (KPLOT .NE. 0) CALL WRTTRL (MCB)
      OCB(2) = KWDS/65536
      OCB(3) = KWDS - 65536*OCB(2)
      IF (.NOT.ANYOUT) GO TO 1180
      CALL WRTTRL (OCB)
C
C     TEST FOR ALL INPUT FILES PROCESSED.
C
 1180 ISEQ = ISEQ + 1
      IF (ISEQ .LE. 3) GO TO 40
      CALL CLOSE (CASECC,CLSREW)
      RETURN
C
C     HERE IF ABNORMAL CONDITION.
C     CLOSE ALL FILES, JUST TO BE SURE
C
 1190 CALL CLOSE (OUTFL ,CLSREW)
 1200 CALL CLOSE (INFIL ,CLSREW)
      CALL CLOSE (CASECC,CLSREW)
      IX = ISEQ + 75
      CALL MESAGE (30,IX,0)
      GO TO 1180
C
C     BINARY SEARCH ROUTINE.
C     =====================
C
 1210 KLO = 1
      KHI = KN
      IF (AXIC) BUF(1) = JHARM*1000000 + BUF(1)
      IF (AXIF) 1220,1220,1213
 1213 BUF(1) = JHARM*500000 + BUF(1)
 1220 K  = (KLO+KHI+1)/2
 1230 KX = 2*K - 1
      IF (BUF(1)-Z(KX)) 1240,700,1250
 1240 KHI = K
      GO TO 1260
 1250 KLO = K
 1260 IF (KHI-KLO-1) 1300,1270,1220
 1270 IF (K .EQ. KLO) GO TO 1280
      K = KLO
      GO TO 1290
 1280 K = KHI
 1290 KLO = KHI
      GO TO 1230
 1300 GO TO RETX, (640,670,690)
C
C     FATAL FILE ERRORS
C
 1310 N = -1
      GO TO 1330
 1320 N = -2
      GO TO 1330
 1330 CALL MESAGE (N,FILE,NAM)
      GO TO 1330
      END

      SUBROUTINE SAXIF1 (IOPT)
C
C     THIS ROUTINE GENERATES MATRICES WHICH RELATE PRESSURE TO VELOCITY
C     IN A FLUID. IOPT DETERMINES THE ELEMENT TYPE
C
C        IOPT     TYPE
C         0      CAXIF2
C         1      CAXIF3
C         2      CAXIF4
C
      INTEGER         NEST(100),SIL
      DIMENSION       A(9)
      COMMON /SDR2X5/ EST(100),NID,SIL(4),SV(95)
      COMMON /SDR2X6/ HM(9),R(4),Z(4),AM(9),COEF,EN,EL,RBAR,ZBAR,
     1                R1N,R2N,RBN1,DR,DZ,I1,I2,I3,IRET,IJ,IK,KJ
      EQUIVALENCE     (EST(1),NEST(1)),(AM(1),A(1))
C
      DO 10 I = 1,44
   10 SV(I) = 0.0
      NID = NEST(1)
      IF (IOPT-1) 20,50,70
C
C     CAXIF2 ELEMENTS
C
   20 IF (NEST(6) .GE. 1) GO TO 30
      COEF = EST(4)*(EST(13)-EST(9))
      IF (COEF .EQ. 0.0) RETURN
      SV(3) = 1.0/COEF
      SV(4) = -SV(3)
      GO TO 40
   30 IF (NEST(6) .GT. 1) GO TO 40
      COEF  = EST(4)*(EST(8)+EST(12))
      IF (COEF .EQ. 0.0) RETURN
      SV(1) = -1.0/COEF
      SV(2) =  SV(1)
   40 CONTINUE
      EN    = FLOAT(NEST(6))
      RBAR  = (EST(8)+EST(12))/2.0
      ZBAR  = (EST(9)+EST(13))/2.0
      DR    = EST(12) - EST(8)
      DZ    = EST(13) - EST(9)
      R1N   = EST( 8)**NEST(6)
      R2N   = EST(12)**NEST(6)
      RBN1  = RBAR**(NEST(6)-1)
      HM(1) = EST(13)/(R1N*DZ)
      HM(2) =-EST( 9)/(R2N*DZ)
      HM(3) =-1.0/(R1N*DZ)
      HM(4) = 1.0/(R2N*DZ)
      EL    = SQRT(DZ**2 +DR**2)
      COEF  = RBN1/(EST(4)*EL)
      AM(1) = EN*DR*COEF
      AM(2) = (EN*DR*ZBAR + RBAR*DZ)*COEF
      AM(3) = EN*EL*COEF
      AM(4) = EN*ZBAR*EL*COEF
      SV(5) = AM(1)*HM(1) + AM(2)*HM(3)
      SV(6) = AM(1)*HM(2) + AM(2)*HM(4)
      SV(7) = AM(3)*HM(1) + AM(4)*HM(3)
      SV(8) = AM(3)*HM(2) + AM(4)*HM(4)
      SIL(1)= NEST(2)
      SIL(2)= NEST(3)
      RETURN
C
C     CAXIF3 ELEMENT
C
   50 N    = NEST(7)
      EN   = FLOAT(N)
      RHO  = EST(5)
      DO 60 I = 1,3
      SIL(I) = NEST(I+1)
      IR   = 4*(I-1) + 9
      R(I) = EST(IR  )
      Z(I) = EST(IR+1)
   60 CONTINUE
      I1   = 1
      I2   = 2
      I3   = 3
      RBAR = (R(I1)+R(I2)+R(I3))/3.0
      ZBAR = (Z(I1)+Z(I2)+Z(I3))/3.0
      IRET = 4
      GO TO 120
C
C     CAXIF4 ELEMENT
C
   70 N    = NEST(8)
      EN   = FLOAT(N)
      RHO  = EST(6)*4.0
      DO 80 I = 1,4
      SIL(I) = NEST(I+1)
      IR   = 4*(I-1) + 10
      R(I) = EST(IR  )
      Z(I) = EST(IR+1)
   80 CONTINUE
      RBAR = (R(1)+R(2)+R(3)+R(4))/4.0
      ZBAR = (Z(1)+Z(2)+Z(3)+Z(4))/4.0
      I1   = 1
      I2   = 2
      I3   = 3
      IRET = 1
      GO TO  120
   90 I3   = 4
      IRET = 2
      GO TO  120
  100 I2   = 3
      IRET = 3
      GO TO  120
  110 I1   = 2
      IRET = 4
C
C     ACTUAL SUBTRIANGLE CALCULATION
C
  120 IF (RHO .EQ. 0.0) RETURN
      A(1) = 0.0
      A(2) =-1.0/RHO
      A(3) = 0.0
      A(5) = A(2)*EN
      A(4) = A(5)/RBAR
      A(6) = A(4)*ZBAR
      A(7) = 0.0
      A(8) = 0.0
      A(9) = A(2)
C
      COEF = (R(I2)-R(I1))*(Z(I3)-Z(I1)) - (R(I3)-R(I1))*(Z(I2)-Z(I1))
      IF (COEF .EQ. 0.0) RETURN
      HM(1) = (R(I2)*Z(I3)-R(I3)*Z(I2))/COEF
      HM(2) = (R(I3)*Z(I1)-R(I1)*Z(I3))/COEF
      HM(3) = (R(I1)*Z(I2)-R(I2)*Z(I1))/COEF
      HM(4) = (Z(I2)-Z(I3))            /COEF
      HM(5) = (Z(I3)-Z(I1))            /COEF
      HM(6) = (Z(I1)-Z(I2))            /COEF
      HM(7) = (R(I3)-R(I2))            /COEF
      HM(8) = (R(I1)-R(I3))            /COEF
      HM(9) = (R(I2)-R(I1))            /COEF
      DO 150 J = 1,3
      JCOL  = I1
      IF (J .EQ. 2) JCOL = I2
      IF (J .EQ. 3) JCOL = I3
      DO 150 I = 1,3
      IJ = (2+IOPT)*(I-1) + JCOL
      DO 140 K = 1,3
      IK = 3*(I-1) + K
      KJ = 3*(K-1) + J
      SV(IJ) = SV(IJ) + A(IK)*HM(KJ)
  140 CONTINUE
  150 CONTINUE
      GO TO (90,100,110,160 ), IRET
C
C     THE CENTROID  CALCULATIONS ARE COMPLETE.
C
  160 NSTA = 3*(IOPT+2)
      NCOL = IOPT + 2
      IF (IOPT .EQ. 2) RHO = EST(6)
      DO 170 I = 1,NCOL
      J = I + 1
      IF (J .GT.NCOL) J = J - NCOL
      EL = SQRT((R(J)-R(I))**2  + (Z(J)-Z(I))**2)*RHO
C
      IK = NSTA + 2*NCOL*(I-1) + I
      IJ = IK + J - I
      SV(IK) = -1.0/EL
      SV(IJ) = -SV(IK)
      COEF   = -EN/((R(I)+R(J))*RHO)
      IK     = IK + NCOL
      IJ     = IJ + NCOL
      SV(IK) = COEF
      SV(IJ) = COEF
  170 CONTINUE
      RETURN
      END

      SUBROUTINE XRGDFM (NEWSOL,OLDSOL,IAPP,IUFILE,IOPEN,ISIZE,ISCR,
     1                   NOGO)
C
C     XRGDFM READS AND PROCESSES RIGID FORMATS
C
C     WRITTEN BY  RPK CORPORATION; DECEMBER, 1983
C
C     INPUT
C       ARGUMENTS
C         IAPP        =1, FOR DMAP APPROACH; =2, DISPLACEMENT APPRAOCH
C                     =3, HEAT APPROACH    ; =4, AERO APPROACH
C         IOPEN       ARRAY FROM OPEN CORE TO CONTAIN THE MODULE
C                     EXECUTION DECISION TABLE
C         ISIZE       NUMBER OF WORDS AVAILABLE IN THE IOPEN ARRAY
C         IUFILE      NAME OF USER'S FILE CONTAINING THE RIGID FORMAT
C         NEWSOL      ARRAY CONTAINING THE SOLUTION NUMBER FOLLOWED
C                     BY ALL SUBSET NUMBERS GIVEN BY THE USER
C         OLDSOL      SOLUTION ON PREVIOUS RUN IF THIS IS A RESTART
C       OTHER
C       /XRGDXX/
C         IRESTR      RESTART FLAG - NON-ZERO IF RUN IS A RESTART
C         NSUBST      NUMBER OF SUBSETS GIVEN BY THE USER
C         RECORD      ARRAY CONTAINING THE CARD IMAGE IN 20A4 FORMAT
C       /SYSTEM/
C         IDATE       ARRAY CONTAINING MONTH AND YEAR OF NASTRAN LEVEL
C         OPTAPE      UNIT USED FOR THE OUTPUT PRINT FILE
C       /TWO/
C         TWO         ARRAY CONTAINING THE VALUES OF THE POWERS OF 2.
C       /MEDMSK/
C         N1          NUMBER OF WORDS USED FOR THE CARD NAME RESTART
C                     TABLE
C         N2          NUMBER OF WORDS USED FOR THE FILE NAME RESTART
C                     TABLE
C         N3          NUMBER OF WORDS USED FOR THE RIGID FORMAT
C                     CHANGE RESTART TABLE
C
C     OUTPUT
C       ARGUMENTS
C         IOPEN       ARRAY CONTAINING THE MODULE EXECUTION DECISION
C                     TABLE
C       OTHER
C         /MEDMSK/
C           MEDMSK    MODULE EXECUTION DECISION MASK - SET IF SOLUTION
C                     CHANGE OCCURRED ON A RESTART
C         /SYSTEM/
C           ITHRML    SET TO NON-ZERO FOR A HEAT APPROACH
C         /PHAS11/
C           IPAS11    ARRAY FOR SUBSTRUCTURE CONTROLS-SET TO ZERO
C         /PHAS25/
C           IPAS25    SAME AS IPAS11
C         /PHAS28/
C           IPAS28    SAME AS IPAS11
C         /PHAS31/
C           IPAS31    SAME AS IPAS11
C         /PHAS37/
C           IPAS37    SAME AS IPAS11
C         /XRGDXX/
C           IDMAP     DMAP SEQUENCE NUMBER
C           IGNORE    FLAG SET TO IGNORE ANY CONTROL CARDS FOR THE
C                     CURRENT DMAP STATEMENT - IS SET WHEN THE DMAP
C                     STATEMENT IS TO BE DELETED BY THE SUBSET
C           IPHASE    PHASE NUMBER ASSOCIATED WITH THE ****PHS-
C                     CONTROL CARD
C           ITYPE     SET TO 'FILE' OR 'CARD' FOR TYPE OF CONTROL CARD
C           LIMIT     LOWER/UPPER LIMITS ASSOCIATED WITH THE VALUES
C                     OF A PARTICULAR CARD TYPE
C           MEMBER    NAME OF USER'S FILE CONTAINING A RIGID FORMAT
C                     THIS IS A 2-WORD ARRAY IN 2A4 FORMAT
C           NUMENT    NUMBER OF WORDS PER ENTRY IN THE MODULE EXECUTION
C                     DECISION TABLE
C
C
C     LOCAL VARIABLES
C       ASTERS        VARIABLE CONTAINING THE VALUE OF 4H****
C       CARD          VARIABLE CONTAINING THE VALUE OF 4HCARD
C       COMENT        VARIABLE CONTAINING THE VALUE OF 4H$$$$
C       DOLACR        VARIABLE CONTAINING THE VALUE OF 4H$*CA
C       DOLAFL        VARIABLE CONTAINING THE VALUE OF 4H$*FI
C       FILE          VARIABLE CONTAINING THE VALUE OF 4HFILE
C       FILTYP        ARRAY CONTAINING ACRONYMS FOR APPROACH
C       IBIT          BIT NUMBER TO SET IN THE MEDMSK
C       IFILL         VALUE TO BE USED TO INITIALIZE THE MODULE
C                     EXECUTION DECISION TABLE; =0, IF RESTART;
C                     =1, OTHERWISE
C       LU            FORTRAN LOGICAL UNIT NUMBER AS RETURN FROM RFOPEN
C                     =0, IF OPEN IS NOT SUCCESSFUL
C       INDEX         INDEX INTO CURRENT ENTRY OF MODULE EXEC.
C                     DECISION TABLE
C       ISOL          SOLUTION NUMBER
C       IWORD         WORD IN MEDMSK TO BE SET FOR RESTART FLAG
C       NEXT          FLAG INDICATING THAT A NEW DMAP STATEMENT IS
C                     TO BE PROCESSED; =0, IF NEW DMAP STATEMENT;
C                     =1, IF PROCESSING THE SAME DMAP STATEMENT
C       NUMSOL        ARRAY CONTAINING THE RESTART BITS ASSOCIATED
C                     WITH A RIGID FORMAT SWITCH DURING RESTART
C       MAXSOL        MAX. SOLUTION NUMBER
C       PHASE         ARRAY CONTAINING 'PHS1', PHS2', AND 'PHS3'
C       RFMT          VARIABLE CONTAINING THE VALUE 4HRFMT
C       SOLNUM        ARRAY CONTAINING THE ALPHA REPRESENTATIONS OF
C                     THE SOLUTION NUMBERS
C
C     FUNCTIONS
C       1. INITIALIZES SUBSTRUCTURE CONTROLS TO ZERO
C       2. CHECKS FOR USER SUPPLIED RIGID FORMAT
C       3. IF STANDARD RIGID FORMAT, VALIDATES SOLUTION NUMBER,
C          SETS MEDMSK IF A RESTART OCCURRED ON A DIFFERENT
C          RIGID FORMAT
C       4. SETS NUMENT=1 AND IFILL=1 IS NO RESTART - OTHERWISE
C          NUMENT=N1+N2+N3 AND IFILL=0
C       5. CALLS RFOPEN TO OPEN THE RIGID FORMAT
C       6. READS A CARD IMAGE FROM THE RIGID FORMAT FILE -
C          THE DATE AND YEAR OF THE RIGID FORMAT IS VALIDATED AGAINST
C          THAT THE LEVEL OF NASTRAN
C          RE-DEFINE NO. OF LINES PER OUTPUT PAGE IF 4TH WORD IS
C          PRESENT, .GT.20 .AND. .LE.99,  NO DATE CHECK IF THE ORD WROD
C          IS ****
C       7. READS A CARD FROM THE RIGID FORMAT FILE AND DOES THE
C          FOLLOWING DEPENDING ON THE TYPE OF CARD READ:
C          - FOR '$$$$' COMMENT CARDS, NEXT IS RESET
C          - FOR '****SBST' CARDS SUBROUTINE XRGSUB IS CALLED
C          - FOR '****CARD' CARDS SUBROUTINE XRGDCF IS CALLED
C          - FOR '****FILE' CARDS SUBROUTINE XRGDCF IS CALLED
C          - FOR '****RFMT' CARDS SUBROUTINE XRGDCF IS CALLED
C          - FOR '****PHS-' CARDS SUBROUTINE XRGSST IS CALLED
C          - OTHERWISE, THE CARD IS A DMAP AND WRITEN TO SCRATCH 315
C          (NOTE- FOR NON RESTARTS, THE ****CARD,****FILE,****RFMT
C          CARDS ARE BYPASSED.  FOR DMAP STATEMENTS THAT ARE
C          DELETED BY SUBSET CONTROLS, NO CONTROL CARDS ARE
C          PROCESSED EXCEPT FOR ****PHS- CARDS UNTIL THE NEXT
C          DMAP STATEMENT IS ENCOUNTERED)
C       8. WHEN A '$*CA' OR A '$*FI' CARD IS READ, PROCESSING OF
C          DMAP STATEMENTS TERMINATES - IF THE JOB IS NOT A RESTART
C          XRGDFM RETURNS.  OTHERWISE, A CHECK IS MADE TO ENSURE
C          THAT THE CARD NAME TABLE IS GIVEN FIRST FOLLOWED BY
C          THE FILE NAME TABLE.  SUBROUTINE XRGDTB IS CALLED TO
C          PROCESS BOTH TABLES.  AFTER THESE TABLES ARE PROCESSED,
C          XRGDFM RETURNS.
C
C     SUBROUTINES CALLED - RFOPEN,READ,WRITE,XRGSUB,XRGDCF,XRGSST,
C                          XRGDTB,MESAGE,RFCLOS
C
C     COMMENTS FROM G.C./UNISYS - ALL THE MACHINE DEPENDENT DSX* SUB-
C     ROUTINES ARE NO LONGER USED. SEE RFOPEN.  10/1990
C
C     CALLING SUBROUTINE - XCSA
C
C     ERROR MESSAGES 8023,504,8025,8026,8024,8037 MAY BE ISSUED
C
      EXTERNAL        ORF
      INTEGER         RECORD, BLANK, ORF, TWO,  ASTERS, SUB(2),
     1                OPTAPE, CARD, FILE, RFMT, COMENT, SUBSET, DOLAFL,
     2                DOLACR, IUFILE(2),  IOPEN(100),   IDATE(3),
     3                FILTYP(4),  SOLNUM(20), NUMSOL(50),OLDNUM,
     4                NEWSOL(12), OLDSOL(12), PHASE(3), OLDIND
      INTEGER         ALTFIL
      DIMENSION       IOUTBF(200)
      COMMON /ALTRXX/ ALTFIL, NEWALT
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /XRGDXX/ IRESTR, NSUBST, IPHASE, ICOL   , NUMBER, ITYPE  ,
     1                ISTATE, IERROR, NUM(2), IND    , NUMENT         ,
     2                RECORD(20)    , ICHAR(80)      , LIMIT(2)       ,
     3                ICOUNT, IDMAP , ISCRX , NAME(2), MEMBER(2)      ,
     4                IGNORE
      COMMON /SYSTEM/ KSYSTM(100)
      COMMON /TWO   / TWO(31)
      COMMON /XMDMSK/ N1,N2,N3,MEDMSK(7)
      COMMON /PHAS11/ IPAS11(8)
      COMMON /PHAS25/ IPAS25(14)
      COMMON /PHAS28/ IPAS28(14)
      COMMON /PHAS31/ IPAS31(2)
      COMMON /PHAS37/ IPAS37(6)
      EQUIVALENCE     (KSYSTM( 2), OPTAPE), (KSYSTM(56), ITHRML) ,
     1                (KSYSTM(42), IDATE(1)),
     2                (KSYSTM(69), ISUBAL), (KSYSTM( 9), NLPP  )
      DATA    FILTYP/ 4HDMAP, 4HDISP, 4HHEAT, 4HAERO    /
      DATA    SOLNUM/ 1H1 ,1H2 ,1H3 ,1H4 ,1H5 ,1H6 ,1H7 ,
     1                1H8 ,1H9 ,2H10,2H11,2H12,2H13,2H14,
     2                2H15,2H16,2H17,2H18,2H19,2H20     /
      DATA    CARD  / 4HCARD /, FILE   / 4HFILE /
      DATA    RFMT  / 4HRFMT /, BLANK  / 4H     /
      DATA    ASTERS/ 4H**** /, COMENT / 4H$$$$ /
      DATA    SUBSET/ 4HSBST /, DOLACR / 4H$*CA /
      DATA    DOLAFL/ 4H$*FI /
      DATA    PHASE / 4HPHS1,   4HPHS2, 4HPHS3  /
      DATA    SUB   / 4HXRGD,   4HFM            /
      DATA    NAS   / 4HNAS  /, MAXSOL / 19     /
C
C     IN THE FOLLOWING TABLE, VALUES 187-209 ARE FOR STATICS,
C     210-213 ARE FOR HEAT, AND 214-217 ARE FOR AERO -
C     THIS PROVIDES FOR 31 DIFFERENT VALUES IN TOTAL (1 WORD)
C
      DATA    NUMSOL/
     1                187, 188, 189, 190, 191, 192, 193, 194,
     2                195, 196, 197, 198, 199, 200, 201, 202,
     3                203, 204, 205,  -1,  -1,  -1,  -1, 210,
     4                 -1, 211,  -1,  -1,  -1,  -1,  -1, 212,
     5                 -1,  -1,  -1,  -1,  -1,  -1, 216, 214,
     6                215, 9*-1 /
C WAS:
C     DATA    NUMSOL/
C    1                187, 188, 189, 190, 191, 192, 193, 194,
C    2                195, 196, 197, 198, 199, 200, 201, 202,
C    3                 -1,  -1,  -1,  -1, 207,  -1, 208,  -1,
C    4                 -1,  -1,  -1,  -1, 209,  -1,  -1,  -1,
C    5                 -1,  -1,  -1,  -1,  -1,  -1, 216, 214,
C    6                215, 9*-1 /
C
      ISCRX = ISCR
      IDMAP = 0
      DO 10 K = 1,8
 10   IPAS11(K) = 0
      DO 20 K = 1,14
      IPAS25(K) = 0
 20   IPAS28(K) = 0
      DO 30 K = 1,2
 30   IPAS31(K) = 0
      DO 40 K = 1,6
 40   IPAS37(K) = 0
      IF (IUFILE(1) .EQ. 0) GO TO 100
      MEMBER(1) = IUFILE(1)
      MEMBER(2) = IUFILE(2)
      GO TO 210
 100  ISOL = NEWSOL(1)
      GO TO (700,120,130,140), IAPP
 120  IF (ISOL.GE.1 .AND. ISOL.LE.MAXSOL) GO TO 200
      GO TO 700
 130  ITHRML = 1
      ISOL = ISOL - 23
      IF (ISOL.EQ.1 .OR. ISOL.EQ.3 .OR. ISOL.EQ.9) GO TO 200
      GO TO 700
 140  ISOL = ISOL - 30
      IF (ISOL.EQ.9 .OR. ISOL.EQ.10 .OR. ISOL.EQ.11) GO TO 200
      GO TO 700
 200  MEMBER(1) = FILTYP(IAPP)
      MEMBER(2) = SOLNUM(ISOL)
 210  CONTINUE
C
      OLDIND = OLDSOL(1)
      IF (OLDIND.EQ.0 .OR. OLDIND.EQ.NEWSOL(1)) GO TO 270
C
C     MAKE SURE CHECKPOINT TAPE FROM OLDER VERSION IS COMPATIBLE WITH
C     NEW CHANGE MADE IN 1991.
C
      IF (OLDIND.NE.21 .AND. OLDIND.NE.23 .AND. OLDIND.NE.29) GO TO 220
      OLDIND = OLDIND + 3
      OLDSOL(1) = OLDIND
      IF (OLDIND .EQ. NEWSOL(1)) GO TO 270
C
 220  OLDNUM = NUMSOL(OLDIND)
      IF (OLDNUM .LE. 0) GO TO 270
      IWORD = ((OLDNUM-1)/31) + 1
      IBIT  = OLDNUM - 31*(IWORD-1) + 1
      MEDMSK(IWORD) = ORF(MEDMSK(IWORD),TWO(IBIT))
      WRITE  (OPTAPE,240) OLDSOL(1),NEWSOL(1),OLDNUM
 240  FORMAT (51H0*** SWITCHED SOLUTION FOR RESTART - OLD SOLUTION =,I4,
     1        16H, NEW SOLUTION =,I4,14H, BIT NUMBER =,I4)
 270  IF (IRESTR .NE. 0) GO TO 280
      NUMENT = 1
      IFILL  = 1
      GO TO 290
 280  NUMENT = N1 + N2 + N3
      IFILL  = 0
 290  CONTINUE
      IDMAP = 0
      DO 300 KB = 1,NUMENT
      IOPEN(KB) = IFILL
 300  CONTINUE
      INDEX = 1 - NUMENT
      NEXT  = 0
      CALL RFOPEN (MEMBER,LU)
      IGNORE = 0
      IF (LU .EQ. 0) GO TO 790
      READ (LU,305,ERR=720,END=730) RECORD
 305  FORMAT (20A4)
C
C     BLANK OUT THE 19TH AND 20TH WORDS AS THEY
C     MAY CONTAIN SEQUENCE INFORMATION
C
      RECORD(19) = BLANK
      RECORD(20) = BLANK
C
C     ALLOW OPTIONS TO CHANGE NLPP LOCALLY, AND NOT TO CHECK RF DATE.
C     (THE NLPP OPTION HERE IS OBSOLETE. CAN BE EASILY DONE VIA NASINFO
C     FILE - 7/90)
C
      IF (RECORD(3) .EQ. ASTERS) GO TO 310
      IF (                           RECORD(2).NE.IDATE(3)) GO TO 770
 310  READ (LU,305,ERR=720,END=730) RECORD
C
C     BLANK OUT THE 19TH AND 20TH WORDS AS THEY
C     MAY CONTAIN SEQUENCE INFORMATION
C
      RECORD(19) = BLANK
      RECORD(20) = BLANK
      IF (RECORD(1) .NE. COMENT) GO TO 315
      IF (NEXT      .EQ. 0     ) GO TO 310
      NEXT = 0
      IF (INDEX .LE. ISIZE) GO TO 310
      GO TO 740
 315  IF (RECORD(1) .EQ. ASTERS) GO TO 330
      IF (RECORD(1).EQ.DOLACR .OR. RECORD(1).EQ.DOLAFL) GO TO 400
      IF (NEXT .EQ. 1) GO TO 325
      IF (NEWALT .EQ. 0) GO TO 317
      CALL XRCARD (IOUTBF, 200, RECORD)
      CALL WRITE (ALTFIL, IOUTBF(2), 2, 0)
  317 CONTINUE
      NEXT   = 1
      IDMAP  = IDMAP + 1
      INDEX  = INDEX + NUMENT
      DO 320 KB = 1,NUMENT
      IOPEN(KB+INDEX-1) = IFILL
 320  CONTINUE
 325  CONTINUE
      CALL WRITE (ISCR,RECORD,18,0)
      IGNORE = 0
      GO TO 310
 330  IF (RECORD(2) .NE. SUBSET) GO TO 340
      IF (NSUBST .EQ. 0) GO TO 310
      CALL XRGSUB (IOPEN(INDEX),NEWSOL(2))
      IF (IERROR .NE. 0) NOGO = 3
      GO TO 310
 340  IF (RECORD(2) .NE. CARD) GO TO 350
      IF (IRESTR.EQ.0 .OR. IGNORE.EQ.1) GO TO 310
      LIMIT(1) = 1
      LIMIT(2) = N1*31
      CALL XRGDCF (IOPEN(INDEX))
      IF (IERROR .NE. 0) NOGO = 3
      GO TO 310
 350  IF (RECORD(2) .NE. FILE) GO TO 360
      IF (IRESTR.EQ.0 .OR. IGNORE.EQ.1) GO TO 310
      LIMIT(1) =  N1*31 + 1
      LIMIT(2) = (N1+N2)*31
      CALL XRGDCF (IOPEN(INDEX))
      IF (IERROR .NE. 0) NOGO = 3
      GO TO 310
 360  IF (RECORD(2) .NE. RFMT) GO TO 365
      IF (IRESTR.EQ.0 .OR. IGNORE.EQ.1) GO TO 310
      LIMIT(1) = (N1+N2)*31 + 1
      LIMIT(2) = (N1+N2+N3)*31
      CALL XRGDCF (IOPEN(INDEX))
      IF (IERROR .NE. 0) NOGO = 3
      GO TO 310
 365  DO 370 K = 1,3
      IF (RECORD(2) .NE. PHASE(K)) GO TO 370
      IPHASE = K
      CALL XRGSST (NEWSOL)
      IF (IERROR .NE. 0) NOGO = 3
      GO TO 310
 370  CONTINUE
      GO TO 750
 400  CALL WRITE (ISCR,0,0,1)
      IF (NEWALT .EQ. 0) GO TO 500
      CALL WRITE (ALTFIL, 0, 0, 1)
      CALL CLOSE (ALTFIL, 1)
  500 CONTINUE
      CALL WRITE (ISCR,IOPEN(1),INDEX+NUMENT-1,1)
      IF (IRESTR. EQ. 0) GO TO 800
      ITYPE = CARD
      IF (RECORD(1) .NE. DOLACR) GO TO 760
      LIMIT(1) = 1
      LIMIT(2) = N1*31
      CALL XRGDTB (LU)
      IF (IERROR .NE. 0) NOGO = 3
      ITYPE = FILE
      IF (RECORD(1) .NE. DOLAFL) GO TO 760
      LIMIT(1) =  N1*31 + 1
      LIMIT(2) = (N1+N2)*31
      CALL XRGDTB (LU)
      IF (IERROR .NE. 0) NOGO = 3
      GO TO 800
C
C     ERRORS
C
 700  WRITE  (OPTAPE,710) UFM,ISOL,FILTYP(IAPP)
 710  FORMAT (A23,' 8023, SOLUTION NUMBER',I4,' IS ILLEGAL FOR APPROACH'
     1,       A4)
 720  WRITE  (OPTAPE,725) UFM,MEMBER
 725  FORMAT (A23,' 8025, READ ERROR ON FILE ',2A4)
      GO TO 790
 730  WRITE  (OPTAPE,735) UFM,MEMBER
 735  FORMAT (A23,' 8025, UNEXPECTED EOF ENCOUNTERED ON FILE ',2A4)
      GO TO 790
 740  CALL MESAGE (-8,0,SUB)
      GO TO 800
 750  WRITE  (OPTAPE,755) UFM,RECORD
 755  FORMAT (A23,' 8026, THE FOLLOWING CARD HAS AN UNIDENTIFIED ',
     1       'FUNCTION AFTER ',6H'****', //20X,20A4)
      NOGO = 3
      GO TO 310
 760  WRITE  (OPTAPE,765) UFM,ITYPE,RECORD
 765  FORMAT (A23,' 8024, EXPECTED A ',3H'$*,A4,1H',' CARD.',
     1        ' INSTEAD THE FOLLOWING CARD IS READ', //20X,20A4)
      GO TO 790
 770  WRITE  (OPTAPE,775) UFM,IDATE(1),IDATE(3),RECORD(1),RECORD(2)
 775  FORMAT (A23,' 8037, NASTRAN IS LEVEL ',2A4,
     1        ' BUT THE RIGID FORMAT DATA BASE IS LEVEL ',2A4)
 790  NOGO = 3
 800  CALL RFCLSE (LU)
      RETURN
      END

      SUBROUTINE PARTN2 (CP,RP,CORE,BUF)
C
C     THIS IS AN INITIALIZATION ROUTINE FOR PARTN1 AND MERGE1.
C     IT CALLS PARTN3 TO BUILD THE BIT STRINGS FROM THE PARTITIONING
C     VECTORS -CP- AND -RP- AND SETS DEFAULT OPTIONS FOR -CP- AND  -RP-
C     BASED ON -SYM-.
C
C
      LOGICAL         CPNULL  ,RPNULL  ,CPHERE  ,RPHERE
      INTEGER         CP      ,RP      ,CORE    ,BUF(4)  ,SUBR(2) ,
     1                CPSIZE  ,RPSIZE  ,CPONES  ,RPONES  ,Z       ,
     2                SYM     ,TYPE    ,FORM    ,SYSBUF  ,OUTPT   ,
     3                CPCOL   ,RPCOL
      CHARACTER       UFM*23  ,UWM*25  ,UIM*29  ,SFM*25  ,SWM*27
      COMMON /XMSSG / UFM     ,UWM     ,UIM     ,SFM     ,SWM
      COMMON /SYSTEM/ SYSBUF  ,OUTPT
      COMMON /PRTMRG/ CPSIZE  ,RPSIZE  ,CPONES  ,RPONES  ,CPNULL  ,
     1                RPNULL  ,CPHERE  ,RPHERE  ,ICP     ,NCP     ,
     2                IRP     ,NRP
      COMMON /ZZZZZZ/ Z(1)
      COMMON /BLANK / SYM     ,TYPE    ,FORM(4) ,CPCOL   ,RPCOL   ,
     1                IREQCL
      DATA    SUBR  / 4HPART  ,4HN2    /
C
C
C              I             I             I                I
C       SYM    I  RP-PURGED  I  CP-PURGED  I NEITHER-PURGED I
C     ---------+-------------+-------------+----------------+--------
C              I             I             I                I
C       .LT.0  I  RP IS SET  I  CP IS SET  I  RP MUST HAVE  I
C              I  = TO CP    I  = TO RP    I  SAME ONES-S   I
C              I             I             I  COUNT AS CP   I
C     ---------+-------------+-------------+----------------+--------
C              I             I             I                I
C       .GE.0  I  RP IS SET  I  CP IS SET  I  USE CP AND RP I
C              I  TO ALL 0   I  TO ALL 0   I                I
C              I             I             I                I
C
C     IN ALL CASES, RESULTANT -CP- AND -RP- DIMENSIONS MUST BE
C     COMPATIBLE TO THOSE OF  -A-
C
C
C     CONVERT COLUMN PARTITIONING VECTOR TO BIT STRING.
C
      ICP = 1
      IREQCL = CPCOL
      CALL PARTN3 (CP,CPSIZE,CPONES,ICP,NCP,CPHERE,BUF,CORE)
      CPCOL = IREQCL
      IF (CPHERE) GO TO 10
      IRP = 1
      GO TO 20
   10 IRP = NCP + 1
C
C     CONVERT ROW PARTITIONING VECTOR TO BIT STRING.
C
   20 IREQCL = RPCOL
      CALL PARTN3 (RP,RPSIZE,RPONES,IRP,NRP,RPHERE,BUF,CORE)
      RPCOL = IREQCL
C
C     BRANCH ON SYMMETRIC OR  NON-SYMMETRIC DMAP VARIABLE SYM
C
      CPNULL = .FALSE.
      RPNULL = .FALSE.
      IF (SYM) 30,140,140
C
C     DMAP USER CLAIMS SYMMETRIC INPUT AND OUTPUT
C
   30 IF (CPHERE) GO TO 70
C
C     -CP- IS PURGED.  CHECK FOR -RP- PURGED (ERROR), AND IF NOT SET
C     -CP- BITS EQUAL TO -RP- BITS
C
      IF (RPHERE) GO TO 60
C
C     BOTH -RP- AND -CP- PURGED AND -A- IS NOT PURGED (ERROR).
C
   40 WRITE  (OUTPT,50) SFM
   50 FORMAT (A25,' 2170, BOTH THE ROW AND COLUMN PARTITIONING VECTORS',
     1       ' ARE PURGED AND ONLY ONE MAY BE.')
      CALL MESAGE (-61,0,SUBR)
C
C     SET CP-ONES = RP-ONES BY SIMPLE EQUIVALENCE OF CORE SPACE
C
   60 ICP = IRP
      NCP = NRP
      CPONES = RPONES
      CPSIZE = RPSIZE
      GO TO 170
C
C     -CP- IS NOT PURGED.  IF -RP- IS PURGED IT IS SET EQUAL TO -CP-.
C
   70 IF (RPHERE) GO TO 80
      IRP = ICP
      NRP = NCP
      RPONES = CPONES
      RPSIZE = CPSIZE
      GO TO 170
C
C     BOTH -RP- AND -CP- ARE PRESENT AND SINCE USER HAS SPECIFIED A
C     SYMMETRIC OUTPUT PARTITION IS DESIRED THE NUMBER OF
C     NON-ZEROS IN-CP- MUST EQUAL THE NUMBER OF NON-ZEROS IN -RP- FOR NO
C     ERROR HERE.
C
   80 IF (CPONES.EQ.RPONES .AND. CPSIZE.EQ.RPSIZE) GO TO 100
      WRITE  (OUTPT,90) SWM,CP,RP
   90 FORMAT (A27,' 2171, SYM FLAG INDICATES TO THE PARTITION OR MERGE',
     1       ' MODULE THAT A SYMMETRIC MATRIX IS TO BE', /5X,
     2       ' OUTPUT.  THE PARTITIONING VECTORS',2I4,' HOWEVER DO NOT',
     3       ' CONTAIN AN IDENTICAL NUMBER OF ZEROS AND NON-ZEROS.')
C
C     CHECK FOR ORDER OF ONES IN ROW AND COLUMN PARTITIONING VECTOR.
C
  100 IF (CPSIZE .NE. RPSIZE) GO TO 170
      J = IRP
      DO 110 I = ICP,NCP
      IF (Z(I) .NE. Z(J)) GO TO 120
      J = J + 1
  110 CONTINUE
      GO TO 170
C
C     ROW AND COLUMN PARTITIONING VECTORS DO NOT HAVE SAME ORDER.
C
  120 WRITE  (OUTPT,130) SWM
  130 FORMAT (A27,' 2172, ROW AND COLUMN PARTITIONING VECTORS DO NOT ',
     1       'HAVE IDENTICAL ORDERING OF ZERO', /5X,' AND NON-ZERO ',
     2       'ELEMENTS, AND SYM FLAG INDICATES THAT A SYMMETRIC ',
     3       'PARTITION OR MERGE IS TO BE PERFORMED.')
      GO TO 170
C
C     DMAP USER DOES NOT REQUIRE SYMMETRY
C
  140 IF (CPHERE) GO TO 160
C
C     -CP- IS PURGED.  THUS -RP- MUST BE PRESENT FOR NO ERROR.
C
      IF (RPHERE) GO TO 150
      GO TO 40
C
C     SET CP-ONES EQUAL TO 0 AND CPSIZE = 0
C
  150 CPNULL = .TRUE.
      CPSIZE = 0
      CPONES = 0
      GO TO 170
C
C     -CP- NOT PURGED.  IF -RP- IS PURGED SET IT NULL.
C
  160 IF (RPHERE) GO TO 170
      RPNULL = .TRUE.
      NRP    = IRP - 1
      RPSIZE = 0
      RPONES = 0
  170 RETURN
      END

      SUBROUTINE KTRBSC (IOPT)
C
C     BASIC BENDING TRIANGLE  ELEMENT ROUTINE
C
C     IOPT = 0   IMPLIES DO COMPLETE BASIC BENDING TRIANGLE.
C                INSERTING THREE (6X6) MATRICES FOR A PIVOT POINT.
C     IOPT = 1   IMPLIES COMPUTE ONLY THE NINE (3X3)MATRICES
C                WHICH FORM THE 9X9 K SUPER U - MATRIX.
C     IOPT = 2   SAME AS IOPT = 1, BUT SAVE H-INVERSE AND S
C
C     CALLS FROM THIS ROUTINE ARE MADE TO -
C
C           MAT    - MATERIAL DATA ROUTINE
C           SMA1B  - INSERTION ROUTINE
C           TRANSD - DOUBLE PRECISION TRANSFORMATION SUPPLIER
C           INVERD - DOUBLE PRECISION INVERSE ROUTINE
C           GMMATD - DOUBLE PRECISION MATRIX MULTIPLY AND TRANSPOSE
C           MESAGE - ERROR MESSAGE WRITER
C
      INTEGER          SUBSCA,SUBSCB
      DOUBLE PRECISION A,E,XSUBB,TEMP,XSUBC,D,YSUBC,XCYC,XCSQ,DETERM,
     1                 YCSQ,XBSQ,G2X2,TITE,TJTE,S,TI,J2X2,AREA,XBAR,
     2                 YBAR,PX2,PY2,PXY2,XBAR3,YBAR2,YBAR3,PROD9,TEMP9,
     3                 G
      DIMENSION        D(9),G2X2(4),J2X2(4),S(18),ECPT(25),G(9),
     1                 TJTE(18),TITE(18),TI(9)
      COMMON /CONDAS/  CONSTS(5)
      COMMON /SMA1IO/  DUM1(10),IFKGG,DUM2(1),IF4GG,DUM3(23)
      COMMON /SMA1CL/  IOPT4,K4GGSW,NPVT,DUMCL(7),LINK(10),IDETCK,
     1                 DODET,NOGO
      COMMON /MATIN /  MATID,INFLAG,ELTEMP,STRESS,SINTH,COSTH
      COMMON /MATOUT/  G11,G12,G13,G22,G23,G33,RHO,ALPHA1,ALPHA2,ALP12,
     1                 T SUB 0, G SUB E, SIGTEN, SIGCOM, SIGSHE,
     2                 G2X211, G2X212, G2X222
      COMMON /SMA1ET/  NECPT(1),NGRID(3),ANGLE,MATID1,EYE,MATID2,T2,FMU,
     1                 Z11,Z22,DUMMY1,X1,Y1,Z1,DUMMY2,X2,Y2,Z2,DUMMY3,
     2                 X3,Y3,Z3,DUMB(76)
      COMMON /SMA1DP/  A(225),PROD9(9),TEMP9(9),XSUBB,XSUBC,YSUBC,E(18),
     1                 TEMP,XBAR,AREA,XCSQ,YBAR2,YCSQ,YBAR,XBSQ,PX2,
     2                 XCYC,PY2,PXY2,XBAR3,YBAR3,DETERM,NSIZED,
     3                 DUMDUM(4),NPIVOT,THETA,NSUBC,ISING,SUBSCA,SUBSCB,
     4                 NBEGIN,DUMMY(30)
      EQUIVALENCE      (CONSTS(4),DEGRA),(D(1),G(1),A(79)),
     1                 (ECPT(1),NECPT(1)),(G2X2(1),A(88)),
     2                 (TJTE(1),A(100)),(TITE(1),S(1),A(82)),
     3                 (J2X2(1),A(92)),(TI(1),A(118))
C
C     ECPT LIST FOR BASIC BENDING TRIANGLE             NAME IN
C                                                      THIS
C     ECPT                                             ROUTINE    TYPE
C     =====================================            ========  =======
C     ECPT( 1) = ELEMENT ID                            NECPT(1)  INTEGER
C     ECPT( 2) = GRID POINT A                          NGRID(1)  INTEGER
C     ECPT( 3) = GRID POINT B                          NGRID(2)  INTEGER
C     ECPT( 4) = GRID POINT C                          NGRID(3)  INTEGER
C     ECPT( 5) = THETA = ANGLE OF MATERIAL             ANGLE     REAL
C     ECPT( 6) = MATERIAL ID 1                         MATID1    INTEGER
C     ECPT( 7) = I = MOMENT OF INERTIA                 EYE       REAL
C     ECPT( 8) = MATERIAL ID 2                         MATID2    INTEGER
C     ECPT( 9) = T2                                    T2        REAL
C     ECPT(10) = NON-STRUCTURAL-MASS                   FMU       REAL
C     ECPT(11) = Z1                                    Z11       REAL
C     ECPT(12) = Z2                                    Z22       REAL
C     ECPT(13) = COORD. SYSTEM ID 1                    NECPT(13) INTEGER
C     ECPT(14) = X1                                    X1        REAL
C     ECPT(15) = Y1                                    Y1        REAL
C     ECPT(16) = Z1                                    Z1        REAL
C     ECPT(17) = COORD. SYSTEM ID 2                    NECPT(17) INTEGER
C     ECPT(18) = X2                                    X2        REAL
C     ECPT(19) = Y2                                    Y2        REAL
C     ECPT(20) = Z2                                    Z2        REAL
C     ECPT(21) = COORD. SYSTEM ID 3                    NECPT(21) INTEGER
C     ECPT(22) = X3                                    X3        REAL
C     ECPT(23) = Y3                                    Y3        REAL
C     ECPT(24) = Z3                                    Z3        REAL
C     ECPT(25) = ELEMENT TEMPERATURE                   ELTEMP    REAL
C
      NTYPE = 0
      IF (IOPT .GT. 0) NTYPE = 1
      IF (NTYPE .EQ. 1) GO TO 455
      ELTEMP = ECPT(25)
C
C     SET UP  I, J, K VECTORS STORING AS FOLLOWS AND ALSO CALCULATE
C     X-SUB-B, X-SUB-C, AND Y-SUB-C.
C
C     E(11), E(14), E(17) WILL BE THE I-VECTOR.
C     E(12), E(15), E(18) WILL BE THE J-VECTOR.
C     E( 1), E( 4), E( 7) WILL BE THE K-VECTOR.
C
C     FIND I-VECTOR = RSUBB - RUBA (NON-NORMALIZED)
C
      E(11) = DBLE(X2) - DBLE(X1)
      E(14) = DBLE(Y2) - DBLE(Y1)
      E(17) = DBLE(Z2) - DBLE(Z1)
C
C     FIND LENGTH = X-SUB-B COOR. IN ELEMENT SYSTEM
C
      XSUBB = DSQRT(E(11)**2 + E(14)**2 + E(17)**2)
      IF (XSUBB .GT. 1.0D-06) GO TO 20
      CALL MESAGE (30,31,ECPT(1))
C
C     SET FLAG FOR FATAL ERROR WHILE ALLOWING ERROR MESSAGES TO
C     ACCUMULATE
C
      NOGO = 1
      RETURN
C
C  20 NORMALIZE I-VECTOR WITH X-SUB-B
C
   20 E(11) = E(11)/XSUBB
      E(14) = E(14)/XSUBB
      E(17) = E(17)/XSUBB
C
C     TAKE RSUBC - RSUBA AND STORE TEMPORARILY IN E(2), E(5), E(8)
C
      E(2) = DBLE(X3) - DBLE(X1)
      E(5) = DBLE(Y3) - DBLE(Y1)
      E(8) = DBLE(Z3) - DBLE(Z1)
C
C     X-SUB-C = I . (RSUBC - RSUBA), THUS
C
      XSUBC = E(11)*E(2) + E(14)*E(5) + E(17)*E(8)
C
C     CROSSING I-VECTOR TO (RSUBC - RSUBA) GIVES THE K-VECTOR
C     (NON-NORMALIZED)
C
      E(1) = E(14)*E( 8) - E( 5)*E(17)
      E(4) = E( 2)*E(17) - E(11)*E( 8)
      E(7) = E(11)*E( 5) - E( 2)*E(14)
C
C     FIND LENGTH = Y-SUB-C COOR. IN ELEMENT SYSTEM
C
      YSUBC = DSQRT(E(1)**2 + E(4)**2 + E(7)**2)
      IF (YSUBC .GT. 1.0D-06) GO TO 25
      CALL MESAGE (30,32,ECPT(1))
C
C     SET FLAG FOR FATAL ERROR WHILE ALLOWING ERROR MESSAGES TO
C     ACCUMULATE
C
      NOGO = 1
      RETURN
C
C     NORMALIZE K-VECTOR WITH Y-SUB-C
C
   25 E(1) = E(1)/YSUBC
      E(4) = E(4)/YSUBC
      E(7) = E(7)/YSUBC
C
C     NOW HAVING I AND K VECTORS GET -- J = K CROSS I
C
      E(12) = E( 4)*E(17) - E(14)*E( 7)
      E(15) = E(11)*E( 7) - E( 1)*E(17)
      E(18) = E( 1)*E(14) - E(11)*E( 4)
C
C     NORMALIZE J-VECTOR FOR COMPUTER EXACTNESS JUST TO MAKE SURE
C
      TEMP = DSQRT(E(12)**2 + E(15)**2 + E(18)**2)
      E(12) = E(12)/TEMP
      E(15) = E(15)/TEMP
      E(18) = E(18)/TEMP
      E( 2) = 0.0D0
      E( 3) = 0.0D0
      E( 5) = 0.0D0
      E( 6) = 0.0D0
      E( 8) = 0.0D0
      E( 9) = 0.0D0
      E(10) = 0.0D0
      E(13) = 0.0D0
      E(16) = 0.0D0
C
C     CONVERT ANGLE FROM DEGREES TO RADIANS STORING IN THETA.
C
      THETA = ANGLE*DEGRA
      SINTH = SIN(THETA)
      COSTH = COS(THETA)
      IF (ABS(SINTH) .LT. 1.0E-06) SINTH = 0.0E0
C
C     SETTING UP G MATRIX
C
  455 INFLAG = 2
      MATID  = MATID1
      CALL MAT (ECPT(1))
C
C     FILL G-MATRIX WITH OUTPUT FROM MAT ROUTINE
C
      G(1) = G11
      G(2) = G12
      G(3) = G13
      G(4) = G12
      G(5) = G22
      G(6) = G23
      G(7) = G13
      G(8) = G23
      G(9) = G33
C
C     COMPUTATION OF D = I.G-MATRIX (EYE IS INPUT FROM THE ECPT)
C
      DO 90 I = 1,9
   90 D(I) = G(I)*DBLE(EYE)
C
      AREA = XSUBB*YSUBC/2.0D0
      XBAR =(XSUBB+XSUBC)/3.0D0
      YBAR = YSUBC/3.0D0
C
      XCSQ = XSUBC**2
      YCSQ = YSUBC**2
      XBSQ = XSUBB**2
      XCYC = XSUBC*YSUBC
      PX2 = (XBSQ+XSUBB*XSUBC+XCSQ)/6.0D0
      PY2 = YCSQ/6.0D0
      PXY2= YSUBC*(XSUBB+2.0D0*XSUBC)/12.0D0
      XBAR3 = 3.0D0*XBAR
      YBAR3 = 3.0D0*YBAR
      YBAR2 = 2.0D0*YBAR
C
C                 X
C     FILL THE  (K ) MATRIX STORING IN  A(1) THRU A(36)
C
      A( 1) = D( 1)
      A( 2) = D( 3)
      A( 3) = D( 2)
      A( 4) = D( 1)*XBAR3
      A( 5) = D( 2)*XBAR + YBAR2*D(3)
      A( 6) = D( 2)*YBAR3
      A( 7) = A( 2)
      A( 8) = D( 9)
      A( 9) = D( 6)
      A(10) = D( 3)*XBAR3
      A(11) = D( 6)*XBAR + YBAR2*D(9)
      A(12) = D( 6)*YBAR3
      A(13) = A( 3)
      A(14) = A( 9)
      A(15) = D( 5)
      A(16) = D( 2)*XBAR3
      A(17) = D( 5)*XBAR + YBAR2*D(6)
      A(18) = D( 5)*YBAR3
      A(19) = A( 4)
      A(20) = A(10)
      A(21) = A(16)
      A(22) = D( 1)*9.0D0*PX2
      A(23) = D( 2)*3.0D0*PX2 + 6.0D0*PXY2*D(3)
      A(24) = D( 2)*9.0D0*PXY2
      A(25) = A( 5)
      A(26) = A(11)
      A(27) = A(17)
      A(28) = A(23)
      A(29) = D( 5)*PX2 + 4.0D0*PXY2*D(6) + 4.0D0*PY2*D(9)
      A(30) = D( 5)*3.0D0*PXY2 + 6.0D0*PY2*D(6)
      A(31) = A( 6)
      A(32) = A(12)
      A(33) = A(18)
      A(34) = A(24)
      A(35) = A(30)
      A(36) = D( 5)*9.0D0*PY2
      TEMP  = 4.0D0*AREA
      DO 70 I = 1,36
   70 A(I)  = A(I)*TEMP
C
C     F1LL  (HBAR) MATRIX STORING AT A(37) THRU A(72)
C
      DO 130 I = 37,72
  130 A(I) = 0.0D0
C
      A(37) = XBSQ
      A(40) = XBSQ*XSUBB
      A(44) = XSUBB
      A(49) =-2.0D0*XSUBB
      A(52) =-3.0D0*XBSQ
      A(55) = XCSQ
      A(56) = XCYC
      A(57) = YCSQ
      A(58) = XCSQ*XSUBC
      A(59) = YCSQ*XSUBC
      A(60) = YCSQ*YSUBC
      A(62) = XSUBC
      A(63) = YSUBC*2.0D0
      A(65) = XCYC *2.0D0
      A(66) = YCSQ *3.0D0
      A(67) =-2.0D0*XSUBC
      A(68) =-YSUBC
      A(70) =-3.0D0*XCSQ
      A(71) =-YCSQ
C
      IF (T2 .EQ. 0.0E0) GO TO 500
C
C     ALL OF THE FOLLOWING OPERATIONS THROUGH STATEMENT LABEL 500
C     ARE NECESSARY IF T2 IS NON-ZERO.
C
C     GET THE G2X2 MATRIX
C
      MATID  = MATID2
      INFLAG = 3
      CALL MAT (ECPT(1))
      IF (G2X211.EQ.0. .AND. G2X212.EQ.0. .AND. G2X222.EQ.0.) GO TO 500
      G2X2(1) = G2X211*T2
      G2X2(2) = G2X212*T2
      G2X2(3) = G2X212*T2
      G2X2(4) = G2X222*T2
C
      DETERM  = G2X2(1)*G2X2(4) - G2X2(3)*G2X2(2)
      J2X2(1) = G2X2(4)/DETERM
      J2X2(2) =-G2X2(2)/DETERM
      J2X2(3) =-G2X2(3)/DETERM
      J2X2(4) = G2X2(1)/DETERM
C
C     (H  ) IS PARTITIONED INTO A LEFT AND RIGHT PORTION AND ONLY THE
C       YQ  RIGHT PORTION IS COMPUTED AND USED AS A  (2X3). THE LEFT
C           2X3 PORTION IS NULL.  THE RIGHT PORTION WILL BE STORED AT
C           A(73) THRU A(78) UNTIL NOT NEEDED ANY FURTHER.
C
      TEMP  =  2.0D0*D(2) + 4.0D0*D(9)
      A(73) = -6.0D0*(J2X2(1)*D(1) + J2X2(2)*D(3))
      A(74) = -J2X2(1)*TEMP - 6.0D0*J2X2(2)*D(6)
      A(75) = -6.0D0*(J2X2(1)*D(6) + J2X2(2)*D(5))
      A(76) = -6.0D0*(J2X2(2)*D(1) + J2X2(4)*D(3))
      A(77) = -J2X2(2)*TEMP - 6.0D0*J2X2(4)*D(6)
      A(78) = -6.0D0*(J2X2(2)*D(6) + J2X2(4)*D(5))
C
C     THE ABOVE 6 ELEMENTS NOW REPRESENT THE (H  ) MATRIX (2X3)
C                                              YQ
C
C     NOW FORMING  PRODUCT (G2X2)(H  ) AND STORING AS AN INTERMEDIATE
C     STEP.                        YQ
C
C
      CALL GMMATD (G2X2(1),2,2,0, A(73),2,3,0, A(79))
C
C                                                               Y
C     WITH LAST PRODUCT  FORM  LOWER RIGHT 3 X 3 PARTITION OF (K )
C
C              Y                   T
C     THUS   (K ) PARTITION = (H  ) (LAST PRODUCT)   STORE AT A(85)
C                               YQ
C
      CALL GMMATD (A(73),2,3,1, A(79),2,3,0, A(85))
C
C                                                     X
C     NOW ADD THE 9 ELEMENTS OF THIS 3X3 PORTION TO (K )
C     PER STEP 5 PAGE -16- MS-17                            Y
C     MULTIPLY IN AREA AT SAME TIME WHICH WAS LEFT OUT OF (K ) ABOVE.
C
      DO 60 I = 1,3
      A(I+21) = A(I+21) + A(I+84)*AREA
      A(I+27) = A(I+27) + A(I+87)*AREA
   60 A(I+33) = A(I+33) + A(I+90)*AREA
C
C     ADD TO 6 OF THE (HBAR) ELEMENTS THE RESULT OF (H  )(H  )
C                                                     UY   YQ
C     THE PRODUCT IS FORMED DIRECTLY IN THE ADDITION PROCESS BELOW.
C     NO (H  ) MATRIX IS ACTUALLY COMPUTED DIRECTLY.
C          UY
C
C     THE FOLLOWING IS THEN PER STEPS 6 AND 7 PAGE -16- MS-17.
C
      DO 75 I = 1,3
      A(I+39) = A(I+39) + XSUBB*A(I+72)
   75 A(I+57) = A(I+57) + XSUBC*A(I+72) + YSUBC*A(I+75)
C
C     THIS ENDS ADDED COMPUTATION FOR CASE OF T2 NOT ZERO
C
  500 CONTINUE
C
C     AT THIS POINT INVERT  (H) WHICH IS STORED AT A(37) THRU A(72)
C     STORE INVERSE BACK IN A(37) THRU A(72)
C     NO NEED TO COMPUTE DETERMINANT SINCE IT IS NOT USED SUBSEQUENTLY.
C
      ISING = -1
      CALL INVERD (6,A(37),6,A(73),0,DETERM,ISING,A(79))
C
C     CHECK TO SEE IF H WAS SINGULAR
C
      IF (ISING .NE. 2) GO TO 440
C
C     ISING = 2 IMPLIES SINGULAR MATRIX THUS ERROR CONDITION.
C
      CALL MESAGE (30,33,ECPT(1))
C
C     SET FLAG FOR FATAL ERROR WHILE ALLOWING ERROR MESSAGES TO
C     ACCUMULATE
C
      NOGO = 1
      RETURN
C
C              Q   -1
C 440 FORM   (K )(H  )  AND STORE AT  A(73) THRU A(108)
C
C                 X                     Q
C     NOTE THAT (K ) AT THIS POINT IS (K )
C
  440 CALL GMMATD (A(1),6,6,0, A(37),6,6,0, A(73))
C
C                    -1 T
C     FORM(K  ) = (H  ) (LAST PRODUCT) STORE AT A(109) THRU A(144)
C            II
C
      CALL GMMATD (A(37),6,6,1, A(73),6,6,0, A(109))
C
C     FILL S-MATRIX EQUIVALENCED TO A(82)  (S IS  6X3)
C
      IF (IOPT.NE.2) GO TO 700
C
C     SAVE H-INVERSE TO BE USED BY TRIANGULAR PLATE ROUTINE.
C
      DO 710 I = 37,72
  710 A(I+108) = A(I)
C
  700 S( 1) = 1.0D0
      S( 2) = 0.0D0
      S( 3) =-XSUBB
      S( 4) = 0.0D0
      S( 5) = 1.0D0
      S( 6) = 0.0D0
      S( 7) = 0.0D0
      S( 8) = 0.0D0
      S( 9) = 1.0D0
      S(10) = 1.0D0
      S(11) = YSUBC
      S(12) =-XSUBC
      S(13) = 0.0D0
      S(14) = 1.0D0
      S(15) = 0.0D0
      S(16) = 0.0D0
      S(17) = 0.0D0
      S(18) = 1.0D0
C
C                   T
C     FORM   K   = K   = -K   S  STORING AT A(46)   (K   IS 6X3)
C             IA    AI     II                         IA
C
      CALL GMMATD (A(109),6,6,0, S(1),6,3,0, A(46))
C
C     THIS PRODUCT IS MULTIPLIED BY SCALER -1 BELOW.
C
C                    T
C          (K  ) = (S )(-K  )
C            AA           IA
C
C     NOTE K    HAS NOT BEEN MULTIPLIED ABOVE BY -1, THUS IGNORE MINUS
C           IA                                                   HERE.
C
      CALL GMMATD (S(1),6,3,1, A(46),6,3,0, A(1))
C
C     NOW MULTIPLY  K   BY SCALER (-1)
C                    IA
C
      DO 190 I = 46,63
  190 A(I) = -A(I)
C
C     AT THIS POINT, STORED BY ROWS ARE
C
C                  K     (6X6) AT A(109) THRU A(144)
C                   II
C
C                  K     (6,3) AT  A(46) THRU A(63)
C                   IA
C
C                  K     (3X3) AT A(1) THRU A(9)
C                   AA
C
C     ARRANGE NINE 3X3 MATRICES OF K SUPER U
C
      DO 600 I = 28,36
  600 A(I) = A(I+18)
       A(10) = A(46)
       A(11) = A(49)
       A(12) = A(52)
       A(13) = A(47)
       A(14) = A(50)
       A(15) = A(53)
       A(16) = A(48)
       A(17) = A(51)
       A(18) = A(54)
       A(19) = A(55)
       A(20) = A(58)
       A(21) = A(61)
       A(22) = A(56)
       A(23) = A(59)
       A(24) = A(62)
       A(25) = A(57)
       A(26) = A(60)
       A(27) = A(63)
       A(37) = A(109)
       A(38) = A(110)
       A(39) = A(111)
       A(40) = A(115)
       A(41) = A(116)
       A(42) = A(117)
       A(43) = A(121)
       A(44) = A(122)
       A(45) = A(123)
       A(46) = A(112)
       A(47) = A(113)
       A(48) = A(114)
       A(49) = A(118)
       A(50) = A(119)
       A(51) = A(120)
       A(52) = A(124)
       A(53) = A(125)
       A(54) = A(126)
       A(64) = A(127)
       A(65) = A(128)
       A(66) = A(129)
       A(67) = A(133)
       A(68) = A(134)
       A(69) = A(135)
       A(70) = A(139)
       A(71) = A(140)
       A(72) = A(141)
       A(73) = A(130)
       A(74) = A(131)
       A(75) = A(132)
       A(76) = A(136)
       A(77) = A(137)
       A(78) = A(138)
       A(79) = A(142)
       A(80) = A(143)
       A(81) = A(144)
      IF (NTYPE .EQ. 1) RETURN
C
      DO 95 I = 1,3
      IF (NGRID(I) .NE. NPVT) GO TO 95
      NPIVOT = I
      GO TO 170
   95 CONTINUE
C
C     ERROR IF FALL THRU ABOVE LOOP
C
      CALL MESAGE (-30,34,ECPT(1))
C
C 170 AT THIS POINT START ASSEMBLY OF 3 6X6 MATRICES FOR I = PIVOT,
C     AND J =1,2,3  IN THE FOLLOWING EQUATION.
C
C                  T         U     T
C        (K  ) = (T  ) (E) (K  ) (E ) (T )
C          IJ      I         IJ         J
C
C
C     FIRST GET THE PRODUCT APPLICABLE TO ALL 3 K  .
C                                                IJ
C                  T
C              = (T  ) (E)    A 6X3 MATRIX.
C                  I
C
C     CHECK TO SEE IF TI-MATRIX IS NEEDED
C     IF THE CSID IS ZERO FOR THE PIVOT POINT SKIP TRANSFORMATION.
C
  170 IF (NECPT(4*NPIVOT+9) .EQ. 0) GO TO 250
C
C     GET  TI AND MULTIPLY WITH E TO FILL TITE (THE COMMON PRODUCT)
C
      CALL TRANSD (NECPT(4*NPIVOT+9),TI)
C
C     TI IS EQUIVALENCED TO A(118) AND IS 3X3.
C
C     FORM TITE (UPPER AND LOWER) OK OK OK
C
      CALL GMMATD (TI(1),3,3,1,  E(1),3,3,0,  TITE(1))
      CALL GMMATD (TI(1),3,3,1, E(10),3,3,0, TITE(10))
C
      GO TO 280
C
C 250 COMING HERE IMPLIES TI NOT USED.
C     JUST SET TITE = E MATRIX
C
  250 DO 260 I = 1,18
  260 TITE(I) = E(I)
C
C                                                 T
C 280 AT THIS POINT COMMON PRODUCT IS COMPLETE =(T  )(E)  STORED IN TITE
C                                                 I
C
C     THE PIVOT I IS NPIVOT
  280 NPT1 = 1
      IF (NPIVOT .EQ. 1 ) NPT1 = 28
C
C     THE ABOVE SETS A POINTER, NPT1, TO POINT TO 18 FREE DOUBLE PREC.
C     CORE LOCATIONS IN THE A-ARRAY FOR STORAGE OF THE FOLLOWING
C     SUB-PRODUCT.
C                     U   T
C                  (K  )(E )(T )
C                    IJ       J
C
C
C     LOOP THRU FOR THE 3 - 6X6 K   ARRAYS.
C                                IJ
      DO 800 J = 1,3
C                          T
C     TAKE SUB PRODUCT = (E )(T )..     STORE IN TJTE MATRIX
C                              J
C
C     NOTE.. THE TRANSPOSE OF THE ABOVE IS BEING FOUND AND USED,
C                          T
C                      = (T  )(E),  AND STORED IN TJTE-MATRIX
C                          J        EQUIVALENCED TO A(100)
C
C
C     CHECK TO SEE IF TRANSFORMATION IS NEEDED.
C     IF NOT SKIP TO 850
C
      IF (NECPT(4*J+9) .EQ. 0) GO TO 850
C
      CALL TRANSD (NECPT(4*J+9),TI)
      CALL GMMATD (TI(1),3,3,1, E(1),3,3,0, TJTE(1))
      CALL GMMATD (TI(1),3,3,1, E(10),3,3,0, TJTE(10))
      GO TO 880
C
C 850 COMING HERE IF TRANSFORMATION NOT USED
C
C 850 SET TJTE = E
  850 DO 860 I = 1,18
  860 TJTE(I) = E(I)
C
C           T       T
C 880   ( (E )(T ) )  IS COMPLETE AND STORED BY ROWS IN TJTE-MATRIX.
C               J
C                     U   T
C     NOW FORM,    (K  )(E )(T ), STORING AT A(NPT1)
C                    IJ       J
C
C     NPT1 =  1  IF PIVOT IS GRID PT. 2 OR 3
C     NPT1 = 28  IF PIVOT IS GRID PT. 1
C                                  U
C     TO COMPUTE ABOVE USE 3X3   K
C                                 (NPIVOT,J)
C     COMPUTE POINTER TO THIS 3X3.
C
  880 NPT2 = 27*NPIVOT + 9*J - 35
C
      CALL GMMATD (A(NPT2),3,3,0, TJTE,6,3,1, A(NPT1))
C
C
C 950 AT THIS POINT,
C                      U    T
C                    (K  )(E )(T )  IS STORED AT A(NPT1), (3X6).
C                      IJ       J
C
C     AND,             T
C                    (T  )(E)      IS STORED AT TITE(1) = A(82)  (6X3)
C                      I
C
C     FORMING FINAL PRODUCT, AND STORING AT A(100) THE 6X6.
C
      CALL GMMATD (TITE(1),6,3,0, A(NPT1),3,6,0, A(100))
C
C     SHIP TO SMA1B
C
      CALL SMA1B (A(100),NECPT(J+1),-1,IFKGG,0.0D0)
      TEMP = G SUB E
      IF (IOPT4) 801,800,801
  801 IF (GSUBE) 802,800,802
  802 CALL SMA1B (A(100),NECPT(J+1),-1,IF4GG,TEMP)
      K4GGSW = 1
C
  800 CONTINUE
C
      RETURN
      END

      SUBROUTINE EMA
C
C     DMAP SEQUENCE
C
C     EMA    GPECT,XEMD,XBLOCK/XGG/C,N,NOK4/C,N,WTMASS $
C
C            WHERE NOK4 .NE. -1 TO BUILD K4GG (USE DAMPING FACTOR),
C                       .EQ. -1 TO IGNORE DAMPING FACTOR
C
C     EMA USES TWO SCRATCH FILES
C
      EXTERNAL        LSHIFT,RSHIFT,ANDF  ,ORF
      LOGICAL         FIRST ,LAST  ,PIEZ
      INTEGER         BUF1  ,BUF2  ,SCRIN ,SCROUT,SCR1  ,SCR2  ,GPECT ,
     1                BUF   ,SYSBUF,RDREW ,WRTREW,RD    ,WRT   ,CLS   ,
     2                CLSREW,Z     ,BUF3  ,XEMD  ,OUTPUT,GPEWDS,GPECTX,
     3                HIGH  ,XBLOCK,SCALAS,XGG   ,ANDF  ,PREC  ,HDR   ,
     4                PPOINT,UNION ,ORF   ,OP    ,RSHIFT,COL   ,OLDCOD,
     5                COL1  ,COLN  ,Q     ,OPENR ,OPENW
      DOUBLE PRECISION       ZD    ,XD    ,D
CWKBI 1/95      
      DOUBLE PRECISION       XDD
      DIMENSION       BUF(100)     ,SCALAS(32)   ,HDR(6),MSG(4),MCB(7),
     1                MA1H(2)      ,ZD(1) ,XD(1) ,XS(2) ,IS(2) ,Y(1)  ,
     2                D(18) ,IHQ(180)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG / UFM   ,UWM   ,UIM   ,SFM
      COMMON /MACHIN/ MACH  ,IHALF ,JHALF
      COMMON /LHPWX / LHPW(5)      ,KSHIFT
      COMMON /BLANK / NOK4  ,WTMASS
      COMMON /SYSTEM/ KSYSTM(100)
      COMMON /NAMES / RD    ,RDREW ,WRT   ,WRTREW,CLSREW,CLS
      COMMON /ZBLPKX/ Q(4)  ,IQ
      COMMON /ZZZZZZ/ Z(1)
      COMMON /MA1XX / BUF   ,BUF1  ,BUF2  ,BUF3  ,COL   ,COLN  ,COL1  ,
     1                GPEWDS,HIGH  ,I     ,ICOL  ,ICOLX ,IDICT ,IELEM ,
     2                IGPX  ,ILIST ,IMAT  ,IMATN ,IPVT  ,IROW  ,IROWP ,
     3                IROWX ,JJ    ,K     ,KELEM ,KK    ,II    ,K4FLAG,
     4                L     ,J     ,LCORE ,LDICT ,LOW   ,L1    ,L2    ,
     5                M     ,MAXII ,MAXIPV,MAXN  ,MAXNPR,JNEXT ,N     ,
     6                NBRCOL,NBRROW,NBRWDS,NCOL  ,NGPS  ,NGRIDS,NHDR  ,
     7                NLIST ,NLOCS ,NMAT  ,NPVT  ,NREAD ,NREC  ,NROW  ,
     8                NROWP ,NSCA  ,NWDS  ,OLDCOD,OP    ,PREC  ,SCRIN ,
     9                SCROUT, UNION,SCALAS
      EQUIVALENCE    (KSYSTM( 1),SYSBUF), (KSYSTM( 2),OUTPUT),
     1               (KSYSTM(78),IPIEZ )
      EQUIVALENCE    (Z(1) ,ZD(1)), (XS(1),XD(1),IS(1)), (Z(1) ,Y(1) ),
     1               (BUF(1),D(1)), (IPVT ,IVPT ), (BUF(1),IHQ(1))
      DATA   LBUF  / 100/, MCB/ 7*0 /, MA1H/ 4HEMA ,2H   /, KONS/ 14 /,
     1       MDICT / 6  /, HDR/ 6*0 /
      DATA   GPECT , XEMD  , XBLOCK / 101, 102, 103 / ,
     1       XGG                    / 201           / ,
     2       SCR1  , SCR2           / 301, 302      /
C
C
C     RE-SET KONS IF HALF WORD IS LARGER THAN THAN 16 BITS
C
      IF (IHALF .GE. 18) KONS = 16
      IF (IHALF .GE. 30) KONS = 24
C
C     ALLOCATE BUFFERS. OPEN GPECT AND ALLOCATE A TABLE OF 4 WORDS
C     PER ELEMENT TYPE. OPEN SCRATCH FILE FOR GPECTX. OPEN XEMD.
C
      MCB(1) = 0
      MCB(2) = 0
      MCB(3) = 0
      MCB(4) = 0
      MCB(5) = 0
      MCB(6) = 0
      MCB(7) = 0
      MAXII  = 2**KONS - 1
      MAXBLK = 0
      KSFT   = KSHIFT
      MASK   = LSHIFT(JHALF,IHALF)
      BUF1   = KORSZ(Z) - SYSBUF
      BUF2   = BUF1 - SYSBUF
      BUF3   = BUF2 - SYSBUF
      LCORE  = BUF1 + SYSBUF - 1
      K4FLAG = 1
      IF (NOK4 .EQ. -1) K4FLAG = 0
C
C     SET LOGICAL VARIABLE TRUE IF THIS IS A PIEZOELECRRIC COUPLED
C     PROBLEM AND STRUCTURAL DAMPING FLAG IS ON
C
      PIEZ = .FALSE.
      IF (IPIEZ.EQ.1 .AND. K4FLAG.NE.0) PIEZ = .TRUE.
      BUF(1) = XBLOCK
      CALL RDTRL (BUF)
      IF (BUF(1) .LT. 0) GO TO 9132
      PREC   = BUF(2)
      BUF(1) = GPECT
      CALL RDTRL (BUF)
      IF (BUF(1) .LT. 0) GO TO 9131
      IDICT = 4*BUF(2) + 1
      NSIL  = BUF(3)
      MAXEL = BUF(4)
      MAXDOF= BUF(5)
      CALL GOPEN (GPECT,Z(BUF1),RDREW)
      L     = (2**(IHALF+IHALF-2)-1)*2 + 1
      MAXIPV= RSHIFT(L,KONS)
      SCRIN = GPECT
      SCROUT= SCR1
      CALL GOPEN (XEMD,Z(BUF3),RDREW)
      CALL OPEN (*9134,SCROUT,Z(BUF2),WRTREW)
      CALL WRITE (SCROUT,BUF,3,1)
C
C     SET SWITCHES FOR MULTIPLICATION BY DAMPING
C     OR WEIGHT MASS FACTOR (OR BOTH)
C
      EPS = ABS(WTMASS-1.0)
      IF (EPS.LT.1.E-6 .AND. K4FLAG.EQ.0) ASSIGN  1370 TO KFACT
      IF (EPS.LT.1.E-6 .AND. K4FLAG.NE.0) ASSIGN 13651 TO KFACT
      IF (EPS.GT.1.E-6 .AND. K4FLAG.EQ.0) ASSIGN 13652 TO KFACT
      IF (EPS.GT.1.E-6 .AND. K4FLAG.NE.0) ASSIGN 13653 TO KFACT
C
C     FILL CORE WITH ELEMENT MATRIX DICTIONARIES. FOR EACH ELEMENT TYPE
C     STORE POINTER TO 1ST DICT AND THE NBR OF DICTS IN TABLE AT TOP OF
C     CORE ALSO STORE LENGTH OF EACH DICTIONARY AND FORMAT CODE.
C
      L = IDICT
      DO 1012 I = 1,IDICT
 1012 Z(I)  = 0
      MAXN  = 0
      LAST  = .TRUE.
 1014 CALL READ (*1026,*9135,XEMD,HDR,3,0,NREAD)
      IELEM = 4*HDR(1) - 3
      LDICT = HDR(2)
      Z(IELEM  ) = L
      Z(IELEM+2) = LDICT
      Z(IELEM+3) = HDR(3)
 1016 IF (L+LDICT .GE. BUF3) GO TO 1024
      JDICT = LDICT
      CALL READ (*9136,*1018,XEMD,Z(L),LDICT,0,NREAD)
      L = L + LDICT
      GO TO 1016
 1018 IF (NREAD .NE. 0) GO TO 9001
      HIGH = Z(L-LDICT)
      Z(IELEM+1) = (L-Z(IELEM))/LDICT
      GO TO 1014
 1024 LAST = .FALSE.
      Z(IELEM+1) = (L-Z(IELEM))/LDICT
      HIGH = Z(L-JDICT)
      IF (Z(IELEM+1) .NE. 0) GO TO 1030
      Z(IELEM) = 0
      GO TO 1030
 1026 LAST = .TRUE.
      CALL CLOSE (XEMD,CLSREW)
C
C     PASS GPECT (OR PARTIALLY COMPLETED GPECTX) ENTRY BY ENTRY.
C     IF ENTRY HAS BEEN COMPLETED, COPY IT OUT.  OTHERWISE, LOCATE
C     DICTIONARY FOR ELEMENT (IF IN CORE) AND ATTACH IT.
C     DETERMINE LENGTH OF LONGEST RECORD IN GPECTX.
C     DETERMINE THE MAXIMUM LENGTH OF ONE COLUMN OF AN ELEMENT MATRIX.
C
 1030 NHDR = 2
      IF (LAST) NHDR = 5
      MAXGPE = 0
      LOW  = Z(IDICT)
      NGPS = 0
C
C     READ AND WRITE HEADER FOR RECORD (SIL, DOF, ETC.)
C
 1032 CALL READ (*1110,*9137,SCRIN,HDR,2,0,NREAD)
      CALL WRITE (SCROUT,HDR,NHDR,0)
      GPEWDS = NHDR
      NGPS   = NGPS + 1
C
C     READ FIRST WORD  OF ENTRY ON GPECT. TEST FOR DICT ALREADY ATTACHED
C
 1035 CALL READ (*9138,*1100,SCRIN,BUF,1,0,NREAD)
      IF (IABS(BUF(1)) .GT. LBUF) GO TO 9002
      IF (BUF(1) .LT. 0) GO TO 1040
C
C     DICTIONARY ALREADY ATTACHED---READ REMAINDER OF ENTRY AND
C     COPY ENTRY TO GPECTX.
C
      CALL READ (*9139,*9140,SCRIN,BUF(2),BUF(1),0,NREAD)
      N = BUF(1) + 1
 1038 CALL WRITE (SCROUT,BUF,N,0)
      GPEWDS = GPEWDS + N
      GO TO 1035
C
C     DICTIONARY NOT ATTACHED---TRY TO LOCATE DICT IN CORE
C
 1040 M = -BUF(1)
      CALL READ (*9141,*9142,SCRIN,BUF(2),M,0,NREAD)
      IF (BUF(2) .LT.  LOW) GO TO 1044
      IF (BUF(2) .GT. HIGH) GO TO 1042
      KELEM = 4*BUF(3) - 3
      IF (Z(KELEM) .EQ. 0) GO TO 1035
      L     = Z(KELEM  )
      N     = Z(KELEM+1)
      LDICT = Z(KELEM+2)
      NLOCS = Z(KELEM+3)
      CALL BISLOC (*1035,BUF(2),Z(L),LDICT,N,K)
      K = K + L - 1
      IF (K4FLAG.NE.0 .AND. Z(K+4).EQ.0) GO TO 1035
      GO TO 1050
 1042 IF (LAST) GO TO 1044
      N = M + 1
      GO TO 1038
 1044 CONTINUE
      GO TO 1035
C
C     DICTIONARY LOCATED---WRITE OUT COMPLETED ENTRY ON GPECTX
C         0             NO. OF WORDS IN ENTRY (NOT INCL THIS WORD)
C       1 - 5           ELEM ID, F, N, C, GE
C         6             LOC OF ELEMENT MATRIX COLUMNS FOR CURRENT PIVOT
C       7 - 6+NGRIDS    SIL-S OF CONNECTED GRID POINTS
C
 1050 NGRIDS = M - 2
      INDX   = K + MDICT - 1
      IF (NLOCS .EQ. 1) GO TO 1056
      IF (NGRIDS .GT. NLOCS) GO TO 9004
      KK = 1
      DO 1053 I = 1,NGRIDS
      IF (KK .EQ. 1) GO TO 10525
C
C     CHECK FOR DUPLICATE SILS - E.G. HBDY ELEMENT WITH AMBIENT PTS
C
10522 IF (BUF(KK+3) .NE. BUF(KK+2)) GO TO 10525
      KK = KK + 1
      GO TO 10522
10525 IF (BUF(KK+3) .NE. HDR(1)) GO TO 10530
C
C     SIL THAT MATCHES THE PIVOT FOUND.  NOW INSURE THAT THIS SIL
C     HAS NOT BEEN ALREADY CONNECTED DUE TO A PREVIOUS ENTRY IN THIS
C     GPECT RECORD.  (CAUSED BY DUPLICATE IDS I.E. CELAS2)
C
C     GINO-LOC WILL NOW BE ZERO IF THAT IS TRUE
C
      INDX = K + MDICT + I - 2
      IF (Z(INDX)) 1054,10530,1054
10530 KK = KK + 1
 1053 CONTINUE
      GO TO 1035
 1054 Z(K+MDICT-1) = Z(INDX)
      IF (Z(K+1) .NE. 2) GO TO 1056
      BUF(4) = BUF(I+3)
      NGRIDS = 1
 1056 IF (LDICT-NLOCS+1 .NE. MDICT) GO TO 9010
      N = MDICT + NGRIDS
      CALL WRITE (SCROUT,N,1,0)
      CALL WRITE (SCROUT,Z(K),MDICT,0)
      MAXBLK = MAX0(Z(INDX)/KSFT,MAXBLK)
C
C     ZERO GINO-LOC AS HAVING BEEN USED NOW.
C
      Z(INDX) = 0
      CALL WRITE (SCROUT,BUF(4),NGRIDS,0)
      MAXN   = MAX0(MAXN,Z(K+2))
      GPEWDS = GPEWDS + N + 1
      GO TO 1035
C
C     HERE ON END-OF-RECORD ON GPECT
C
 1100 CALL WRITE (SCROUT,0,0,1)
      MAXGPE = MAX0(MAXGPE,GPEWDS)
      GO TO 1032
C
C     HERE ON END-OF-FILE ON GPECT---TEST FOR COMPLETION OF GPECTX
C
 1110 CALL CLOSE (SCRIN ,CLSREW)
      CALL CLOSE (SCROUT,CLSREW)
      IF (NGPS .NE. NSIL) GO TO 9024
      IF (LAST) GO TO 1200
C
C     GPECTX NOT COMPLETE---SWITCH FILES AND MAKE ANOTHER PASS
C
      IF (SCRIN .EQ. GPECT) SCRIN = SCR2
      K = SCRIN
      SCRIN  = SCROUT
      SCROUT = K
      CALL GOPEN (SCRIN ,Z(BUF1),RDREW )
      CALL GOPEN (SCROUT,Z(BUF2),WRTREW)
      L = IDICT
      LDICT = Z(IELEM+2)
      NLOCS = Z(IELEM+3)
      DO 1114 I = 1,IDICT
 1114 Z(I) = 0
      LAST = .TRUE.
      Z(IELEM  ) = IDICT
      Z(IELEM+2) = LDICT
      Z(IELEM+3) = NLOCS
      GO TO 1016
C
C     HERE WE GO NOW FOR THE ASSEMBLY PHASE---PREPARE BY ALLOCATING
C     STORAGE FOR ONE ELEMENT MATRIX COLUMN AND ITS ROW POSITIONS
C
 1200 IROWP  = PREC*MAXN + 1
      IGPX   = IROWP + MAXN
      FIRST  = .TRUE.
      GPECTX = SCROUT
      MCB(1) = XGG
      MCB(4) = 6
      MCB(5) = PREC
      MCB(6) = 0
      MCB(7) = 0
      LAST   = .FALSE.
      NREC   = 0
      MAXNPR = MAXN*PREC
      OPENR  = RDREW
      OPENW  = WRTREW
      OLDCOD = 0
      ITAB   = BUF1 - MAXBLK
      NTAB   = BUF1 - 1
      IF (ITAB .LT. IGPX) GO TO 9011
C
C     BEGIN A PASS - OPEN GPECTX
C
 1210 IPVT = IGPX
      JJ   = ITAB - 3
      DO 1212 INDX = ITAB,NTAB
      Z(INDX) = 0
 1212 CONTINUE
      CALL GOPEN (GPECTX,Z(BUF1),OPENR)
C
C     READ A RECORD FROM GPECTX INTO CORE
C
 1220 IF (IVPT+MAXGPE.GE.JJ .OR. IPVT.GT.MAXIPV) GO TO 1304
      CALL READ (*9144,*1222,GPECTX,Z(IVPT),MAXGPE+1,1,NREAD)
      GO TO 9006
 1222 ICOL = IPVT + NREAD
      NREC = NREC + 1
C
C     MAKE A PASS THROUGH EACH ELEMENT CONNECTED TO THE PIVOT---FORM THE
C     UNION OF ALL CODE WORDS AND STORE ELEMENT POINTERS IN LIST AT THE
C     END OF OPEN CORE
C
      PPOINT = LSHIFT(IPVT,KONS)
      II     = IPVT + 5
      UNION  = 0
      Z(IPVT+2) = 0
      Z(IPVT+3) = 0
      Z(IPVT+4) = IPVT
      GO TO 1234
 1231 IF (Z(II) .LT. 0) GO TO 9007
      KK = II - IPVT
      IF (KK .GT. MAXII) GO TO 9008
      IF (JJ .LE. ICOL ) GO TO 1300
      Z(JJ  ) = Z(II+MDICT)
      Z(JJ+1) = ORF(PPOINT,KK)
      Z(JJ+2) = 0
      INDX    = ITAB + Z(JJ)/KSFT - 1
      IF (INDX .GT. NTAB) GO TO 9016
      IF (Z(INDX) .NE. 0) GO TO 1236
      Z(INDX) = ORF(LSHIFT(ITAB-JJ,IHALF),ITAB-JJ)
      GO TO 1237
 1236 JJLAST = ITAB - ANDF(Z(INDX),JHALF)
      Z(JJLAST+2) = JJ
      Z(INDX) = ORF(ANDF(Z(INDX),MASK),ITAB-JJ)
 1237 JJ = JJ - 3
      UNION = ORF(UNION,Z(II+4))
      II = II + Z(II) + 1
 1234 IF (II .LT. ICOL) GO TO 1231
      IF (II .NE. ICOL) GO TO 9022
C
C     FORM THE LIST OF NON-NULL COLUMNS TO BE BUILT FOR THIS PIVOT
C
      IF (UNION .EQ. 0) GO TO 1280
      IF (UNION .EQ. OLDCOD) GO TO 1243
      CALL DECODE (UNION,SCALAS,NSCA)
      OLDCOD = UNION
 1243 Z(IPVT+2) = ICOL
      IF (ICOL+NSCA .GE. JJ) GO TO 1300
      II = ICOL
      DO 1244 L = 1,NSCA
      Z(II) = Z(IPVT) + SCALAS(L)
      II = II + 1
 1244 CONTINUE
      IROW = II
C
C     NOW MAKE A PASS AGAIN THROUGH EACH ELEMENT CONNECTED TO CURRENT
C     PIVOT AND FORM A LIST OF UNIQUE ROW INDICES.
C
      II = IPVT + 5
 1252 L1 = II + MDICT + 1
      L2 = II + Z(II)
      IF (OLDCOD .EQ. Z(II+4)) GO TO 1253
      ICODE = Z(II+4)
      CALL DECODE (ICODE,SCALAS,NSCA)
      OLDCOD = Z(II+4)
 1253 CONTINUE
      KK = IROW
      IF (II .NE. IPVT+5) GO TO 1258
      DO 1256 L = L1,L2
C
C     IGNORE DUPLICATE IDS AS IN SOME CELAS2 ELEMENTS ETC.
C
      IF (L.GT.L1 .AND. Z(L).EQ.Z(L-1)) GO TO 1256
      DO 1254 I = 1,NSCA
      Z(KK) = Z(L) + SCALAS(I)
      KK = KK + 1
      IF (KK .GE. JJ) GO TO 1300
 1254 CONTINUE
 1256 CONTINUE
      NROW   = KK - 1
      NBRWDS = KK - IROW
      GO TO 1269
 1258 J = IROWP
      DO 1264 L = L1,L2
C
C     IGNORE DUPLICATE IDS AS IN SOME CELAS2 ELEMENTS ETC.
C
      IF (L.GT.L1 .AND. Z(L).EQ.Z(L-1)) GO TO 1264
      DO 1262 I = 1,NSCA
      Z(J) = Z(L) + SCALAS(I)
      J = J + 1
 1262 CONTINUE
 1264 CONTINUE
      IF (J .GT. IGPX) GO TO 9023
      M = J - IROWP
      IF (IROW+NBRWDS+M .GE. JJ) GO TO 1300
      CALL MRGE (Z(IROW),NBRWDS,Z(IROWP),M)
      NROW = IROW + NBRWDS - 1
      IF (NROW .GE. JJ) GO TO 1300
 1269 II = L2 + 1
      IF (II .LT. ICOL) GO TO 1252
      Z(IPVT+3) = IROW
C
C     NOW ALLOCATE STORAGE FOR COLUMNS OF XGG ASSOCIATED WITH THIS PIVOT
C
      IMAT   = NROW + 1
      NBRCOL = IROW - ICOL
      NBRROW = IMAT - IROW
      NBRWDS = PREC*NBRCOL*NBRROW
      NMAT   = IMAT + NBRWDS - 1
      IF (NMAT .GE. JJ) GO TO 1300
      DO 1272 I = IMAT,NMAT
      Z(I) = 0
 1272 CONTINUE
      Z(IPVT+4) = IMAT
      II = NMAT + 1
C
C     ADVANCE POINTER AND TRY TO GET ANOTHER PIVOT ALLOCATED
C
 1280 ILIST = JJ + 3
      NPVT  = IPVT
      IF (NREC .EQ. NGPS) GO TO 1310
      IPVT = II
      GO TO 1220
C
C     HERE WHEN STORAGE EXCEEDED DURING PROCESSING OF A PIVOT.
C     IF FIRST PIVOT ON PASS, INSUFFICIENT CORE FOR MODULE.
C     OTHERWISE, BACKSPACE GPECTX AND PREPARE TO PROCESS ALL
C     PIVOTS IN CORE WHICH HAVE BEEN COMPLETELY ALLOCATED.
C
 1300 IF (IPVT .EQ. IGPX) CALL MESAGE (-8,0,MA1H)
      CALL BCKREC (GPECTX)
      NREC = NREC - 1
 1304 OP   = CLS
      IF (IPVT .EQ. IGPX) CALL MESAGE (-8,0,MA1H)
      GO TO 1320
C
C     HERE WHEN LAST PIVOT POINT HAS BEEN READ AND ALLOCATED
C
 1310 LAST = .TRUE.
      OP   = CLSREW
C
C     CLOSE GPECTX. OPEN XBLOCK.
C
 1320 CALL CLOSE (GPECTX,OP)
      NWDS = BUF1 - ILIST
      IF (NWDS .LE. 0) GO TO 1402
      CALL GOPEN (XBLOCK,Z(BUF1),RDREW)
      OLDCOD = 0
C
C     PASS THE LIST OF ELEMENT MATRIX POINTERS. EACH ENTRY POINTS TO THE
C     PIVOT POINT AND ELEMENT DICTIONARY IN CORE AND TO THE POSITION IN
C     THE XBLOCK FILE CONTAINING THE ASSOCIATED ELEMENT MATRIX COLUMNS.
C     WHEN PROCESSING OF ALL ENTRIES IS COMPLETE, COLUMNS OF XGG NOW IN
C     CORE ARE COMPLETE.
C
      DO 1398 INDX = ITAB,NTAB
      IF (Z(INDX) .EQ. 0) GO TO 1398
      JJ = ITAB - RSHIFT(Z(INDX),IHALF)
      IF (JJ .LT. ILIST) GO TO 1398
 1330 CONTINUE
      CALL FILPOS (XBLOCK,Z(JJ))
      IPVT  = RSHIFT(Z(JJ+1),KONS)
      IF (IPVT .GT. NPVT) GO TO 9019
      IELEM = IPVT + ANDF(Z(JJ+1),MAXII)
      ICOL  = Z(IPVT+2)
      IROW  = Z(IPVT+3)
      IMAT  = Z(IPVT+4)
C
C     DECODE CODE WORD FOR ELEMENT. FORM LIST OF ROW INDICES DESCRIBING
C     TERMS IN THE ELEMENT MATRIX COLUMN. THEN CONVERT THESE INDICES TO
C     RELATIVE ADDRESSES IN XGG COLUMN IN CORE (USE LIST OF ROW INDICES
C     FOR XGG COLUMN TO DO THIS).
C
      IF (Z(IELEM+4) .EQ. OLDCOD) GO TO 1341
      ICODE = Z(IELEM+4)
      CALL DECODE (ICODE,SCALAS,NSCA)
      OLDCOD = Z(IELEM+4)
 1341 L1 = IELEM + MDICT + 1
      L2 = IELEM + Z(IELEM)
      K  = IROWP
      DO 1344 L = L1,L2
C
C     IGNORE DUPLICATE IDS AS IN SOME CELAS2 ELEMENTS ETC.
C
      IF (L.GT.L1 .AND. Z(L).EQ.Z(L-1)) GO TO 1344
      DO 1342 I = 1,NSCA
      Z(K) = Z(L) + SCALAS(I)
      K = K + 1
 1342 CONTINUE
 1344 CONTINUE
      NROWP = K - 1
      IF (NROWP.GE. IGPX) GO TO 9012
      NROW = IMAT - 1
      ID   = Z(IROWP)
      CALL BISLOC (*9020,ID,Z(IROW),1,(IMAT-IROW),IROWX)
      IROWX = IROW + IROWX - 1
      DO 1348 K = IROWP,NROWP
      DO 1346 I = IROWX,NROW
      IF (Z(K) .EQ. Z(I)) GO TO 1347
 1346 CONTINUE
      GO TO 9013
 1347 Z(K)  = (I-IROW)*PREC
      IROWX = I + 1
 1348 CONTINUE
      NBRROW = NROWP - IROWP + 1
C
C     PREPARE TO READ EACH COLUMN OF ELEMENT MATRIX
C
      NCOL  = IROW - 1
      ICOLX = ICOL
      NBRWDS= Z(IELEM+3)*PREC
      IF (Z(IELEM+2) .EQ.  2) NBRWDS = PREC
      IF (NBRWDS .GT. MAXNPR) GO TO 9014
      DO 1396 I = 1,NSCA
C
C     READ A COLUMN OF THE ELEMENT MATRIX AND DETERMINE ADDRESS
C     OF FIRST WORD OF ASSOCIATED COLUMN OF XGG IN CORE.
C
      CALL READ (*9145,*9146,XBLOCK,Z,NBRWDS,0,NREAD)
      COL = Z(IPVT) + SCALAS(I)
      DO 1362 K = ICOLX,NCOL
      IF (COL .EQ. Z(K)) GO TO 1364
 1362 CONTINUE
      GO TO 9015
 1364 IMATN = IMAT + (IMAT-IROW)*(K-ICOL)*PREC
      ICOLX = K + 1
      IF (Z(IELEM+2) .NE. 2) GO TO 1365
C
C     ELEMENT MATRIX IS DIAGONAL
C
      NBRROW = 1
      Z(IROWP) = Z(IROWP+I-1)
C
C     IF DAMPING OR WEIGHT MASS FACTOR (OR BOTH) PRESENT, MULTIPLY
C     EACH TERM IN THE ELEMENT MATRIX COLUMN BY THE FACTOR.
C
 1365 GO TO KFACT, (1370,13651,13652,13653)
13651 FACTOR = Y(IELEM+5)
      GO TO 13654
13652 FACTOR = WTMASS
      GO TO 13654
13653 FACTOR = Y(IELEM+5)*WTMASS
13654 CONTINUE
      IF (PREC .EQ. 2) GO TO 1367
      DO 1366 K = 1,NBRWDS
C
C     FOR PIEZOELECTRIC COUPLED PROBLEMS, ANY STRUCTURAL DAMPING COEFF.
C     SHOULD MULTIPLY ONLY THE UNCOUPLED STRUCTURAL TERMS. SO, SKIP
C     EVERY 4TH TERM IN A COLUMN AND SKIP EVERY 4TH COLUMN
C
      IF (PIEZ .AND. (I.EQ.NSCA .OR. MOD(K,4).EQ.0)) Y(K) = 0.
      Y(K) = FACTOR*Y(K)
 1366 CONTINUE
      GO TO 1371
 1367 M = NBRWDS/2
      DO 1368 K = 1,M
      IF (PIEZ .AND. (I.EQ.NSCA.OR.MOD(K,4).EQ.0)) ZD(K) = 0.D0
      ZD(K) = FACTOR*ZD(K)
 1368 CONTINUE
      GO TO 1374
C
C     NOW ADD TERMS OF THE ELEMENT MATRIX INTO XGG
C
 1370 IF (PREC .EQ. 2) GO TO 1374
C
C     DO ARITHMETIC IN SINGLE PRECISION
C
 1371 DO 1372 K = 1,NBRROW
      J = IMATN + Z(IROWP+K-1)
CWKBI 1/95
      YJ   = Y(J)
      Y(J) = Y(J) + Y(K)
CWKBNB 1/95  FOLLOWING CODE WILL CAUSE A TRUE ZERO WHEN SUBTRACTING SAME NO.
      IF ( Y(K) .EQ. 0.0 ) GO TO 13720
      YJ   = YJ / Y(K)
      IF ( YJ .LE. -.999999999998 .AND. YJ .GE. -1.000000000001 )
     &     Y(J) = 0.0
13720 CONTINUE
CWKBNE 1/95
 1372 CONTINUE
      GO TO 1396
C
C     DO ARITHMETIC IN DOUBLE PRECISION
C
 1374 DO 1376 K = 1,NBRROW
      J = IMATN + Z(IROWP+K-1)
      IS(1) = Z(J  )
      IS(2) = Z(J+1)
CWKBI 1/95      
      XDD   = XD(1)
      XD(1) = XD(1) + ZD(K)
CWKBNB 1/95 FOLLOWING CODE WILL CAUSE A TRUE ZERO WHEN SUBTRACTING SAME NO.
C  WITHOUT THIS CODE, A SYMMETRIC MATRIX MIGHT HAVE UNSYMMETRIC TERMS ON      
C  THE HP AND ULTRIX (SEE DEMO D01011A, MATRIX KAA, COLUMN 84 ROW 70)
      IF ( ZD(K) .EQ. 0.0D0 ) GO TO 1375
      XDD   = XDD / ZD(K)
      IF ( XDD .LE. -.999999999998 .AND. XDD .GE. -1.000000000001 )
     &     XD(1) = 0.0D0
1375  CONTINUE
CWKBNE 1/95
      Z(J  )= IS(1)
      Z(J+1)= IS(2)
C
 1376 CONTINUE
      GO TO 1396
C
C     END OF DO LOOPS
C
 1396 CONTINUE
      JJ = Z(JJ+2)
      IF (JJ .GE. ILIST) GO TO 1330
 1398 CONTINUE
C
C     ALL COLUMNS OF XGG IN CORE ARE NOW COMPLETE - SEND THEM
C     OUT TO THE XGG DATA BLOCK VIA THE BLDPK ROUTINE.
C
      CALL CLOSE (XBLOCK,CLSREW)
 1402 CALL GOPEN (XGG,Z(BUF1),OPENW)
      IPVT = IGPX
C
C     PREPARE TO PACK ALL COLUMNS FOR CURRENT PIVOT
C
 1410 COL1 = Z(IPVT)
      COLN = COL1 + Z(IPVT+1) - 1
      ICOL = Z(IPVT+2)
      IROW = Z(IPVT+3)
      IMAT = Z(IPVT+4)
      NCOL = IROW - 1
      NROW = IMAT - 1
      JNEXT  = ICOL
      NXTCOL = Z(JNEXT)
      II = IMAT
      DO 1430 COL = COL1,COLN
C
C     INITIATE PACKING BY CALLING BLDPK. TEST FOR NULL COL.
C
      CALL BLDPK (PREC,PREC,XGG,0,0)
      IF (ICOL .EQ. 0) GO TO 1428
      IF (COL .LT. NXTCOL) GO TO 1428
      JNEXT  = JNEXT + 1
      NXTCOL = Z(JNEXT)
      IF (JNEXT .GT. NCOL) NXTCOL = COLN + 1
      IF (PREC .EQ. 2) GO TO 1426
C
C     NON-NULL COLUMN - SEND THE TERMS OUT VIA ZBLPKI
C
C     SINGLE PRECISION
C
      DO 1424 K = IROW,NROW
      IQ   = Z(K)
      Q(1) = Z(II)
      CALL ZBLPKI
      II = II + 1
 1424 CONTINUE
      GO TO 1428
C
C     DOUBLE PRECISION
C
 1426 DO 1427 K = IROW,NROW
      IQ   = Z(K)
      Q(1) = Z(II  )
      Q(2) = Z(II+1)
      CALL ZBLPKI
      II = II + 2
 1427 CONTINUE
C
C     TERMINATE COLUMN BY CALLING BLDPKN
C
 1428 CALL BLDPKN (XGG,0,MCB)
 1430 CONTINUE
C
C     LOGIC TEST TO MAKE SURE POINTERS ENDED CORRECTLY
C
      NBRWDS = 5
      IF (ICOL .EQ. 0) GO TO 1440
      NBRWDS = (IMAT-IROW)*(IROW-ICOL)*PREC
      IF (II-IMAT.NE.NBRWDS .AND. Z(IPVT+1).NE.1) GO TO 9017
C
C     TEST FOR LAST PIVOT
C
 1440 IF (IPVT .GE. NPVT) GO TO 1450
      IPVT = IMAT + NBRWDS
      GO TO 1410
C
C     CLOSE XGG
C
 1450 CALL CLOSE (XGG,OP)
C
C     TEST FOR LAST PASS
C
      IF (LAST) GO TO 1490
      FIRST = .FALSE.
      OPENR = RD
      OPENW = WRT
      GO TO 1210
C
C     XGG NOW COMPLETE - WRITE ITS TRAILER.
C
 1490 MCB(3) = MCB(2)
      IF (MCB(2) .NE. Z(NPVT)+Z(NPVT+1)-1) GO TO 9018
      CALL WRTTRL (MCB)
      RETURN
C
C     FATAL ERROR MESSAGES
C
 9001 MSG(1) = 1016
      GO TO 9098
 9002 MSG(1) = 1035
      GO TO 9098
 9004 MSG(1) = 1052
      GO TO 9098
 9006 MSG(1) = 1220
      GO TO 9098
 9007 MSG(1) = 1231
      GO TO 9098
 9008 MSG(1) = 1232
      GO TO 9098
 9010 MSG(1) = 1056
      GO TO 9098
 9011 MSG(1) = 1202
      GO TO 9098
 9012 MSG(1) = 1344
      GO TO 9098
 9013 MSG(1) = 1346
      GO TO 9098
 9014 MSG(1) = 1352
      GO TO 9098
 9015 MSG(1) = 1362
      GO TO 9098
 9016 MSG(1) = 1238
      GO TO 9098
 9017 MSG(1) = 1432
      GO TO 9098
 9018 MSG(1) = 1490
      GO TO 9098
 9019 MSG(1) = 1332
      GO TO 9098
 9020 MSG(1) = 1345
      GO TO 9098
 9022 MSG(1) = 1235
      GO TO 9098
 9023 MSG(1) = 1264
      GO TO 9098
 9024 MSG(1) = 1110
      GO TO 9098
 9098 WRITE  (OUTPUT,9099) SFM,MSG(1)
 9099 FORMAT (A25,' 3102, LOGIC ERROR EMA - ',I4)
 9097 CONTINUE
      WRITE  (OUTPUT,9091)
 9091 FORMAT (/,' *** CONTENTS OF /MA1XX/')
      WRITE  (OUTPUT,9092) IHQ
 9092 FORMAT (5X,10I10)
      WRITE  (OUTPUT,9093)
 9093 FORMAT (/,' FIRST 250 WORDS OF OPEN CORE')
      J = 250
      WRITE (OUTPUT,9092) (Z(I),I=1,J)
      CALL MESAGE (-61,0,0)
 9100 CALL FNAME (MSG(3),MSG(1))
      WRITE  (OUTPUT,9101) SFM,(MSG(I),I=1,4)
 9101 FORMAT (A25,' 3001, ATTEMPT TO OPEN DATA SET ',2A4,', FILE (',I4,
     1    ') IN SUBROUTINE EMA (',I4,') WHICH WAS NOT DEFINED IN FIST.')
      GO TO 9097
 9110 CALL FNAME (MSG(3),MSG(1))
      WRITE  (OUTPUT,9111) SFM,(MSG(I),I=1,4)
 9111 FORMAT (A25,' 3002, EOF ENCOUNTERED WHILE READING DATA SET ',2A4,
     1       ', (FILE',I5,') IN SUBROUTINE EMA (',I4,1H))
      GO TO 9097
 9120 CALL FNAME (MSG(3),MSG(1))
      WRITE  (OUTPUT,9121) SFM,(MSG(I),I=1,4)
 9121 FORMAT (A25,' 3003, ATTEMPT TO READ PAST END OF LOGICAL RECORD IN'
     1,     ' DATA SET ',2A4,' (FILE',I5,') IN SUBROUTINE EMA (',I4,1H))
      GO TO 9097
 9131 MSG(3) = GPECT
      MSG(4) = 1002
      GO TO 9100
 9132 MSG(3) = XBLOCK
      MSG(4) = 1001
      GO TO 9100
 9134 MSG(3) = SCROUT
      MSG(4) = 1005
      GO TO 9100
 9135 MSG(3) = XEMD
      MSG(4) = 1014
      GO TO 9120
 9136 MSG(3) = XEMD
      MSG(4) = 1017
      GO TO 9110
 9137 MSG(3) = SCRIN
      MSG(4) = 1032
      GO TO 9120
 9138 MSG(3) = SCRIN
      MSG(4) = 1035
      GO TO 9110
 9139 MSG(3) = SCRIN
      MSG(4) = 1036
      GO TO 9110
 9140 MSG(3) = SCRIN
      MSG(4) = 1036
      GO TO 9120
 9141 MSG(3) = SCRIN
      MSG(4) = 1040
      GO TO 9110
 9142 MSG(3) = SCRIN
      MSG(4) = 1040
      GO TO 9120
 9144 MSG(3) = GPECTX
      MSG(4) = 1221
      GO TO 9110
 9145 MSG(3) = XBLOCK
      MSG(4) = 1360
      GO TO 9110
 9146 MSG(3) = XBLOCK
      MSG(4) = 1360
      GO TO 9120
      END

      SUBROUTINE FLFACE (TYPE,ECT,ELT,GRID)
C
C     LOCATES THE FLUID GRID POINTS DEFINING THE FACE OF A FLUID
C     ELEMENT.  THE FACE MAY BE SPECIFIED IN TWO MANNERS.
C
C     1) FACE NUMBER - ELT(2) LESS THEN ZERO AND FACE = ELT(3)
C     2) STRUCTURAL ELEMENT WHICH COINCIDES WITH FACE -
C                         ELT(2) = ELEMENT ID AND ELT(3)-ELT(6) = GRIDS
C
      LOGICAL         ERROR
      INTEGER         ECT(10)  ,ELT(7)   ,GF(10)   ,TYPE     ,GRID(4)  ,
     1                GS1      ,GS2      ,GS3      ,GS4      ,GF1      ,
     2                GF2      ,GF3      ,GF4      ,GRIDF(4) ,NFACE(4) ,
     3                FACEID   ,HEX1(4,6),HEX2(4,6),TETRA(4,4)         ,
     4                WEDGE(4,5)         ,FACE(4,6,4)
      REAL            MAG      ,R1(3)    ,R2(3)    ,R3(3)    ,KS(3)    ,
     1                KF(3)    ,CS(3)    ,ANGLE(6) ,Z        ,HEIGTH(6)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /FLBPTR/ ERROR    ,ICORE    ,LCORE    ,IBGPDT   ,NBGPDT
      COMMON /ZZZZZZ/ Z(1)
      COMMON /SYSTEM/ SYSBUF   ,NOUT
      EQUIVALENCE     (HEX1(1,1),FACE(1,1,1)),  (HEX2(1,1),FACE(1,1,2)),
     1                (TETRA(1,1),FACE(1,1,3)), (WEDGE(1,1),FACE(1,1,4))
C
C     DATA DEFINING FACES OF THE FLUID ELEMENTS
C
C     NUMBER OF GRID POINTS PER ELEMENT
C
C                   FHEX1     FHEX2     FTETRA    FWEDGE
C
      DATA    GRIDF / 8        ,8        ,4        ,6       /
C
C     NUMBER OF FACES ON EACH ELEMENT
C
      DATA    NFACE / 6        ,6        ,4        ,5       /
C
C     GRID POINTS WHICH DEFINE FACES FOR FHEX1 ELEMENTS
C
      DATA    HEX1  / 1        ,4        ,3        ,2        ,
     1                1        ,2        ,6        ,5        ,
     2                2        ,3        ,7        ,6        ,
     3                3        ,4        ,8        ,7        ,
     4                4        ,1        ,5        ,8        ,
     5                5        ,6        ,7        ,8        /
C
C     GRID POINTS WHICH DEFINE FACES FOR FHEX2 ELEMENTS
C
      DATA    HEX2  / 1        ,4        ,3        ,2        ,
     1                1        ,2        ,6        ,5        ,
     2                2        ,3        ,7        ,6        ,
     3                3        ,4        ,8        ,7        ,
     4                4        ,1        ,5        ,8        ,
     5                5        ,6        ,7        ,8        /
C
C     GRID POINTS WHICH DEFINE FACES FOR FTETRA ELEMENTS
C
      DATA    TETRA / 1        ,3        ,2        ,-1       ,
     1                1        ,2        ,4        ,-1       ,
     2                2        ,3        ,4        ,-1       ,
     3                3        ,1        ,4        ,-1       /
C
C     GRID POINTS WHICH DEFINE FACES FOR FWEDGE ELEMENTS
C
      DATA    WEDGE / 1        ,3        ,2        ,-1       ,
     1                1        ,2        ,5        ,4        ,
     2                2        ,3        ,6        ,5        ,
     3                3        ,1        ,4        ,6        ,
     4                4        ,5        ,6        ,-1       /
C
C
C     DETERMINE HOW THE FACE IS SPECIFIED
C
C     SUBTRACT IFP CARD NUMBER OF ELEMENT JUST BEFORE CFHEX1 FROM TYPE
      INTYPE = TYPE - 332
C
      NF = NFACE(INTYPE)
      IF (ELT(2) .LT. 0) GO TO 200
C
C     THE FACE IS DEFINED BY STRUCTURAL GRIDS
C
C     INITIALIZE POINTERS TO GRID POINT DATA
C
      NGRIDS = 4
      IF (ELT(6) .LT. 0) NGRIDS = 3
      GS1 = IBGPDT + (ELT(3)-1)*4
      GS2 = IBGPDT + (ELT(4)-1)*4
      GS3 = IBGPDT + (ELT(5)-1)*4
      GS4 = -1
      IF (NGRIDS .EQ. 4) GS4 = IBGPDT + (ELT(6)-1)*4
C
      NGRIDF = GRIDF(INTYPE)
      DO 10 I = 1,NGRIDF
   10 GF(I) = IBGPDT + (ECT(I+2)-1)*4
C
C     FIND NORMAL VECTOR TO STRUCTURAL ELEMENT FACE
C
      DO 20 I = 1,3
      R1(I) = Z(GS2+I) - Z(GS1+I)
   20 R2(I) = Z(GS3+I) - Z(GS1+I)
C
      KS(1) = R1(2)*R2(3) - R1(3)*R2(2)
      KS(2) = R1(3)*R2(1) - R1(1)*R2(3)
      KS(3) = R1(1)*R2(2) - R1(2)*R2(1)
C
      MAG = SQRT(KS(1)**2 + KS(2)**2 + KS(3)**2)
      IF (MAG .LT. 1.0E-7) GO TO 8005
      DO 30 I = 1,3
   30 KS(I) = KS(I)/MAG
C
C     FIND AREA OF STRUCTURE FACE AND TOLERANCE USED IN CHECKING
C     SEPERATIOON
C
      AREA = MAG
      IF (GS4 .LT. 0) AREA = MAG/2.0
      TOL = .2*SQRT(AREA)
C
C     FIND CENTROID OF STRUCTURAL FACE
C
      DO 35 I = 1,3
      CS(I) = Z(GS1+I) + Z(GS2+I) + Z(GS3+I)
      IF (NGRIDS .EQ. 4) CS(I) = CS(I) + Z(GS4+I)
   35 CS(I) = CS(I)/FLOAT(NGRIDS)
C
C     PROCESS EACH FACE OF THE FLUID ELEMENT - FIRST GET GRID POINTERS
C     POINTERS
C
      DO 100 IF = 1,NF
      I   = FACE(1,IF,INTYPE)
      GF1 = GF(I)
      I   = FACE(2,IF,INTYPE)
      GF2 = GF(I)
      I   = FACE(3,IF,INTYPE)
      GF3 = GF(I)
      I   = FACE(4,IF,INTYPE)
      GF4 = -1
      IF (I .GT. 0) GF4 = GF(I)
C
C     FIND NORMAL TO FLUID FACE
C
      DO 40 I = 1,3
      R2(I) = Z(GF2+I) - Z(GF1+I)
   40 R3(I) = Z(GF3+I) - Z(GF1+I)
C
      KF(1) = R2(2)*R3(3) - R2(3)*R3(2)
      KF(2) = R2(3)*R3(1) - R2(1)*R3(3)
      KF(3) = R2(1)*R3(2) - R2(2)*R3(1)
C
      MAG = SQRT(KF(1)**2 + KF(2)**2 + KF(3)**2)
      IF (MAG .LT. 1.0E-7) GO TO 8006
      DO 45 I = 1,3
   45 KF(I) = KF(I)/MAG
C
C     DETERMINE ANGLE BETWEEN FACES
C
      ANGLE(IF) = KF(1)*KS(1) + KF(2)*KS(2) + KF(3)*KS(3)
      IF (ABS(ANGLE(IF)) .LE. .866) GO TO 100
C
C     FIND DISTANCE FROM THE CENTROID OF THE STRUCTURE TO THE FLUID
C     FACE.  THE DISTANCE IS MEASURED ALONG THE NORMAL TO THE
C     FLUID FACE
C
      DO 60 I = 1,3
   60 R2(I) = CS(I) - Z(GF1+I)
C
      HEIGTH(IF) = ABS(KF(1)*R2(1) + KF(2)*R2(2) + KF(3)*R2(3))
C
  100 CONTINUE
C
C     CHOSE THE FACE OF THE FLUID WITH THE SMALLEST DISTANCE TO THE
C     STRUCTURAL ELEMENT AND WITH THE ANGLE BETWEEN THE TWO FACES LESS
C     THEN 30 DEGREES
C
      DIST   = 1.0E+10
      FACEID = 0
      DO 110 IF = 1,NF
      IF (ABS(ANGLE(IF)) .LE. .866) GO TO 110
      IF (HEIGTH(IF) .GE. DIST) GO TO 110
      DIST   = HEIGTH(IF)
      FACEID = IF
  110 CONTINUE
      IF (FACEID .EQ. 0) GO TO 8007
C
C     VERIFY THAT THE FACE IS WITHIN PROPER TOLERENCE
C
      IF (DIST .GT. TOL) GO TO 8008
C
C     IF ANGLE WAS COMPUTED NEGATIVE - SWICTH STRUCTURAL GRIDS AROUND
C     IN ELEMENT TABLE RECORD FOR LATER USE
C
      IF (ANGLE(FACEID) .GE. 0.0) GO TO 300
      IF (NGRIDS .EQ. 3) GO TO 120
      I      = ELT(3)
      ELT(3) = ELT(6)
      ELT(6) = I
      I      = ELT(4)
      ELT(4) = ELT(5)
      ELT(5) = I
      GO TO 300
C
  120 I      = ELT(3)
      ELT(3) = ELT(5)
      ELT(5) = I
      GO TO 300
C
C     THE FACE IS DEFINED BY A FACE ID
C
  200 FACEID = ELT(3)
      IF (FACEID.LT.1 .OR. FACEID.GT.NF) GO TO 8009
C
C     USING THE FACE SPECIFIES OR FOUND - RETURN THE PROPER
C     FLUID GRID POINTS
C
  300 DO 310 I = 1,4
      J = FACE(I,FACEID,INTYPE)
      IF (J .GT. 0) GO TO 305
      GRID(I) = -1
      GO TO 310
  305 GRID(I) = ECT(J+2)
  310 CONTINUE
C
      RETURN
C
C     ERROR CONDITIONS
C
C     BAD GEOMETRY FOR STRUCTURAL ELEMENT
C
 8005 WRITE (NOUT,9005) UFM,ELT(2)
      GO TO 9000
C
C     BAD GEOMETRY FOR FLUID ELEMENT
C
 8006 WRITE (NOUT,9006) UFM,IF,ECT(1)
      GO TO 9000
C
C     NO FACE WITHIN 30 DEGREES FO STRUCTURAL ELEMENT FACE
C
 8007 WRITE (NOUT,9007) UFM,ECT(1),ELT(2)
      GO TO 9000
C
C     FLUID ELEMENT IS NOT WITHIN TOLERENCE RANGE OF STRUCTURAL ELEMENT
C
 8008 WRITE (NOUT,9008) UFM,ECT(1),ELT(2)
      GO TO 9000
C
C     ILLEGAL FACE NUMBER
C
 8009 WRITE (NOUT,9009) UFM,FACEID,ECT(1)
C
 9000 ERROR = .TRUE.
      RETURN
C
C     ERROR FORMATS
C
 9005 FORMAT (A23,' 8005. BAD GEOMETRY DEFINED FOR STRUCTURAL ELEMENT',
     1        I9)
 9006 FORMAT (A23,' 8006. BAD GEOMETRY DEFINED FOR FACE',I9,
     1       ' OF FLUID ELEMENT',I9)
 9007 FORMAT (A23,' 8007. NO FACE ON FLUID ELEMENT',I9,
     1       ' IS WITHIN 30 DEGREES OF STRUCTURAL ELEMENT',I9)
 9008 FORMAT (A23,' 8008. THE DISTANCE BETWEEN FLUID ELEMENT',I9,
     1       ' AND STRUCTURAL ELEMENT',I9, /30X,
     2       'IS GREATER THAN THE ALLOWED TOLERANCE.')
 9009 FORMAT (A23,' 8009. FACE',I9,' SPECIFIED FOR FLUID ELEMENT',I9,
     1       ' IS AN ILLEGAL VALUE.')
      END

      SUBROUTINE DUMPER
C
C     THIS SUBROUTINE DUMPS THE OSCAR
C
      EXTERNAL         LSHIFT,RSHIFT,ANDF
      INTEGER          IXTRA(3),CON1,CON2
      INTEGER          RECNO,DMAPNO,OP,OSCAR(1),OS(5),RSHIFT,INAME(2),
     1                 TP,AP,ANDF,VPS,PTYPE,BL,EL,ML,CL,CEITBL
      DIMENSION        RA(4),ROSCAR(1),LOCO(300),AVPS(1),IHD(96)
      DOUBLE PRECISION DPREC,DPREC1
      COMMON /OUTPUT/ ITITLE(96),IHEAD(96)
      COMMON /ZZZZZZ/ CORE(1)
      COMMON /XGPI2 / LMPL,MPLPNT,MPL(1)
      COMMON /XVPS  / VPS(1)
      COMMON /XCEITB/ CEITBL(1)
      COMMON /SYSTEM/ SYSBUF,OP,JUNK5(6),NLPP,JUNK6(2),NLINES
      COMMON / XGPIC/ JUNK22(28),NOSGN
      EQUIVALENCE     (VPS(1),AVPS(1)), (DPREC,RA(1)), (DPREC1,RA(3)),
     1                (OSCAR(1),ROSCAR(1),OS(5)), (CORE(1),OS(1)),
     2                (IOSBOT,OS(3))
      DATA   MASK1,   MASK2,      MASK3,        MASK4,      MASK5     /
     1       32767,   32768, 1073676288,   1073741824,     983040     /
      DATA   CON1,    CON2 /     4HCONS,4HTANT                        /
      DATA   IHD/2*4H    ,4H COS,4HMIC ,4H/ NA,4HSTRA,4HN DM,4HAP C,
     1             4HOMPI,4HLER ,4H- OS,4HCAR ,4HLIST,4HING ,82*4H    /
      DATA   IXTRA/4H(CON,4HTINU,4HED)  /
      DATA   ION, IOFF /  4HON  ,4HOFF  /
C
   10 FORMAT (20X,2A4,5H(I  ),2X,I10)
   20 FORMAT (20X,2A4,5H(R  ),2X,E15.6)
   30 FORMAT (20X,2A4,5H(BCD),5X,2A4)
   40 FORMAT (20X,2A4,5H(RDP),2X,D24.15)
C
C     INITIALIZE LOCO ARRAY - POINTS TO FIRST WORD IN MPL FOR MOD I
C
      J = 1
      I = 1
   50 LOCO(I) = J
      J = J + MPL(J)
      IF (J .GT. LMPL) GO TO 60
      I = I + 1
      GO TO 50
   60 CONTINUE
C
      I = 1
      DO 70 K=1,96
      IHEAD(K) = IHD(K)
   70 CONTINUE
      CALL PAGE
      DO 80 K=1,3
      IHEAD(K+14) = IXTRA(K)
   80 CONTINUE
C
C     PROCESS ENTRY HEADER
C
   90 IF (MI .EQ. 11) GO TO 910
      NWE   = OSCAR(I  )
      RECNO = OSCAR(I+1)
      MI    = RSHIFT(OSCAR(I+2),16)
      MSAVE = LOCO(MI)
      ITYPE = OSCAR(I+2) - LSHIFT(RSHIFT(OSCAR(I+2),16),16)
      IEXFLG= IOFF
      IF (OSCAR(I+5).LT.0) IEXFLG = ION
      DMAPNO = ANDF(NOSGN,OSCAR(I+5))
      NLINES = NLINES + 4
      IF (NLINES .LT. NLPP) GO TO 100
      CALL PAGE
      NLINES = NLINES + 4
  100 CONTINUE
      WRITE  (OP,110)
  110 FORMAT (/1X,18(4H****))
      WRITE  (OP,120) RECNO,ITYPE,IEXFLG,OSCAR(I+3),OSCAR(I+4),DMAPNO
  120 FORMAT (2X,20HOSCAR RECORD NUMBER ,I3,5X,14HMODULE TYPE = ,I2,
     1        5X,16HEXECUTE FLAG -- , A4, /2X,
     2        15HMODULE NAME -  ,2A4,5X,21HDMAP INSTRUCTION NO. ,I3)
      I   = I + 6
      NWE = NWE - 6
      GO TO (130,130,800,540), ITYPE
  130 IO  = 1
      NIP = OSCAR(I)
      NLINES = NLINES + 2
      IF (NLINES .LT. NLPP) GO TO 140
      CALL PAGE
      NLINES = NLINES + 2
  140 CONTINUE
      WRITE  (OP,150) NIP
  150 FORMAT (/10X,29HSUMMARY OF INPUT DATA BLOCKS(,I2,2H ) )
      J = 1
  160 INAME(1) = OSCAR(I+1)
      INAME(2) = OSCAR(I+2)
      NTU = ANDF(OSCAR(I+3),MASK1)
      TP  = RSHIFT(ANDF(OSCAR(I+3),MASK2),15)
      LTU = RSHIFT(ANDF(OSCAR(I+3),MASK3),16)
      AP  = RSHIFT(ANDF(OSCAR(I+3),MASK4),30)
      IF (INAME(1).EQ.0 .AND. IO.EQ.1) GO TO 190
      IF (INAME(1).EQ.0 .AND. IO.EQ.0) GO TO 220
      NLINES = NLINES + 1
      IF (NLINES .LT. NLPP) GO TO 170
      CALL PAGE
      NLINES = NLINES + 1
  170 CONTINUE
      WRITE  (OP,180) INAME(1),INAME(2),AP,LTU,TP,NTU
  180 FORMAT (20X,2A4,3X,I1,1H/,I5,1H/,I1,1H/,I5)
      GO TO 250
  190 NLINES = NLINES + 1
      IF (NLINES .LT. NLPP) GO TO 200
      CALL PAGE
      NLINES = NLINES + 1
  200 CONTINUE
      WRITE  (OP,210) J
  210 FORMAT (20X,24H********INPUT DATA BLOCK,I3,8H IS NULL)
      GO TO 250
  220 NLINES = NLINES + 1
      IF (NLINES .LT. NLPP) GO TO 230
      CALL PAGE
      NLINES = NLINES + 1
  230 CONTINUE
      WRITE  (OP,240) J
  240 FORMAT (20X,25H********OUTPUT DATA BLOCK,I3,8H IS NULL)
  250 I = I + 3
      J = J + 1
      IF (J .LE. NIP) GO TO 160
      IF (ITYPE .EQ. 2 ) IO = 0
C
C     PROCESS OUTPUT DATA BLOCKS
C
      IF (IO .EQ. 0) GO TO 280
      IO  = 0
      I   = I + 1
      NIP = OSCAR(I)
      NLINES = NLINES + 2
      IF (NLINES .LT. NLPP) GO TO 260
      CALL PAGE
      NLINES = NLINES + 2
  260 CONTINUE
      WRITE  (OP,270) NIP
  270 FORMAT (/10X,30HSUMMARY OF OUTPUT DATA BLOCKS(,I2,2H ))
      J = 1
      GO TO 160
C
C     PROCESS PARAMETER SECTION
C
  280 I = I + 2
      NPARM = OSCAR(I)
      IF (NPARM .EQ. 0) GO TO 530
      J = 1
      MPLP = MSAVE + 7
      NLINES = NLINES + 2
      IF (NLINES .LT. NLPP) GO TO 290
      CALL PAGE
      NLINES = NLINES + 2
  290 CONTINUE
      WRITE  (OP,300) NPARM
  300 FORMAT (/10X,22HSUMMARY OF PARAMETERS(,I2,2H ))
  310 IF (OSCAR(I+1)) 440,440,320
C
C     SEARCH MPL FOR TYPE OF VARIABLE
C
  320 INAME(1) = CON1
      INAME(2) = CON2
      KK = IABS(MPL(MPLP))
      NLINES = NLINES + 1
      IF (NLINES .LT. NLPP) GO TO 330
      CALL PAGE
      NLINES = NLINES + 1
  330 CONTINUE
      GO TO (340,360,370,390,400,420), KK
  340 WRITE (OP,10) INAME(1),INAME(2),OSCAR(I+2)
  350 I = I + 2
      IF (MPL(MPLP) .GT. 0 ) MPLP = MPLP+1
      MPLP = MPLP+1
      J = J+1
      IF (J .GT. NPARM) GO TO 530
      GO TO 310
  360 WRITE (OP,20) INAME(1),INAME(2),ROSCAR(I+2)
      GO TO 350
  370 WRITE (OP,30) INAME(1),INAME(2),OSCAR(I+2),OSCAR(I+3)
  380 I = I + 3
      IF (MPL(MPLP) .GT. 0) MPLP = MPLP+2
      MPLP = MPLP + 1
      J = J + 1
      IF (J .GT. NPARM) GO TO 530
      GO TO 310
  390 RA(1) = ROSCAR(I+2)
      RA(2) = ROSCAR(I+3)
      WRITE (OP,40) INAME(1),INAME(2),DPREC
      GO TO 380
  400 WRITE  (OP,410) INAME(1),INAME(2),ROSCAR(I+2),ROSCAR(I+3)
  410 FORMAT (20X,2A4,5H(CSP),2X,2E15.6)
      GO TO 380
  420 RA(1) = ROSCAR(I+2)
      RA(2) = ROSCAR(I+3)
      RA(3) = ROSCAR(I+4)
      RA(4) = ROSCAR(I+5)
      WRITE  (OP,430) INAME(1),INAME(2),DPREC,DPREC1
  430 FORMAT (20X,2A4,5H(CDP),2X,2D24.15)
      I = I + 5
      IF (MPL(MPLP) .GT. 0) MPLP = MPLP+4
      MPLP = MPLP+1
      J = J + 1
      IF (J .GT. NPARM) GO TO 530
      GO TO 310
  440 IVPS = ANDF(NOSGN,OSCAR(I+1))
      INAME(1) = VPS(IVPS-3)
      INAME(2) = VPS(IVPS-2)
      PTYPE = RSHIFT(ANDF(VPS(IVPS-1),MASK5),16)
      NLINES = NLINES + 1
      IF (NLINES .LT. NLPP) GO TO 450
      CALL PAGE
      NLINES = NLINES + 1
  450 CONTINUE
      GO TO (460,470,480,490,500,510), PTYPE
  460 WRITE (OP,10) INAME(1),INAME(2),VPS(IVPS)
      GO TO 520
  470 WRITE (OP,20) INAME(1),INAME(2),AVPS(IVPS)
      GO TO 520
  480 WRITE (OP,30) INAME(1),INAME(2),VPS(IVPS),VPS(IVPS+1)
      GO TO 520
  490 RA(1) = AVPS(IVPS  )
      RA(2) = AVPS(IVPS+1)
      WRITE (OP,40) INAME(1),INAME(2),DPREC
      GO TO 520
  500 WRITE (OP,410) INAME(1),INAME(2),AVPS(IVPS),AVPS(IVPS+1)
      GO TO 520
  510 RA(1) = AVPS(IVPS  )
      RA(2) = AVPS(IVPS+1)
      RA(3) = AVPS(IVPS+2)
      RA(4) = AVPS(IVPS+3)
      WRITE (OP,430) INAME(1),INAME(2),DPREC,DPREC1
  520 I = I + 1
      J = J + 1
      IF (MPL(MPLP) .GT. 0) MPLP = MPLP + PTYPE/3 + 1
      IF (PTYPE .EQ. 6) MPLP = MPLP + 1
      MPLP = MPLP + 1
      IF (J .GT. NPARM) GO TO 530
      GO TO 310
C
C     HAVE COMPLETED FUNCTIONAL MODULE
C
  530 I = I + 2
      IF (ITYPE .EQ. 2) I = I - 1
      GO TO 90
C
C     PROCESS EXECUTIVE MODULES
C
  540 IF (MI - 3) 550,550,600
C
C     PROCESS CHKPNT
C
  550 NDB = OSCAR(I)
      NLINES = NLINES + 2
      IF (NLINES .LT. NLPP) GO TO 560
      CALL PAGE
      NLINES = NLINES + 2
  560 CONTINUE
      WRITE  (OP,570) NDB
  570 FORMAT (/10X,31HDATA BLOCKS TO BE CHECKPOINTED(,I2,2H ))
      IST  = I + 1
      IFIN = IST + 2 * NDB - 1
      NPAGE = (10+NDB)/10+1
      NLINES = NLINES + NPAGE
      IF (NLINES .LT. NLPP) GO TO 580
      CALL PAGE
      NLINES = NLINES + NPAGE
  580 CONTINUE
      IF (NDB .NE. 0) WRITE(OP,590) (OSCAR(K),K=IST,IFIN)
      I = I + 2*NDB+1
  590 FORMAT ((20X,10(2A4,2X)),/)
      GO TO 90
  600 IF (MI - 8) 610,610,670
C
C     PROCESS SAVE
C
  610 NPARM  = OSCAR(I)
      NLINES = NLINES + 2
      IF (NLINES .LT. NLPP) GO TO 620
      CALL PAGE
      NLINES = NLINES + 2
  620 CONTINUE
      WRITE  (OP,630) NPARM
  630 FORMAT (/10X,23HPARAMETERS TO BE SAVED(,I2,2H ))
  640 FORMAT (20X,2A4,2X,I5)
      J = 1
  650 IVPS = OSCAR(I+1)
      INAME(1) = VPS(IVPS-3)
      INAME(2) = VPS(IVPS-2)
      NLINES   = NLINES + 1
      IF (NLINES .LT. NLPP) GO TO 660
      CALL PAGE
      NLINES = NLINES + 1
  660 CONTINUE
      WRITE (OP,640) INAME(1),INAME(2),OSCAR(I+2)
      J = J + 1
      I = I + 2
      IF (J .LE. NPARM) GO TO 650
      I = I + 1
      GO TO 90
  670 NDB = OSCAR(I)
      NWE = NWE - 1
      NLINES = NLINES + 2
      IF (NLINES .LT. NLPP) GO TO 680
      CALL PAGE
      NLINES = NLINES + 2
  680 CONTINUE
      IF (MI .EQ.  9) WRITE (OP,690) NDB
      IF (MI .EQ. 10) WRITE (OP,700) NDB
  690 FORMAT (/10X,25HDATA BLOCKS TO BE PURGED( ,I2,2H ))
  700 FORMAT (/10X,26HDATA BLOCKS TO BE EQUIVED(,I2,2H ))
      IST  = I + 1
      IFIN = IST + 2*NDB - 1
      IF (MI .NE. 10) GO TO 730
      NTU = RSHIFT(OSCAR(IST+2),16)
      LTU = OSCAR(IST+2) - LSHIFT(NTU,16)
      NLINES = NLINES + 1
      IF (NLINES .LT. NLPP) GO TO 710
      CALL PAGE
      NLINES = NLINES + 1
  710 CONTINUE
      WRITE  (OP,720) OSCAR(IST),OSCAR(IST+1),NTU,LTU
  720 FORMAT (20X,19HPRIMARY DATA BLOCK ,2A4,3X,I5,1H/,I5)
      IST  = IST  + 3
      IFIN = IFIN + 1
      NWE  = NWE  - 3
  730 CONTINUE
      NPAGE  = (10+NDB)/10+1
      NLINES = NLINES + NPAGE
      IF (NLINES .LT. NLPP) GO TO 740
      CALL PAGE
      NLINES = NLINES + NPAGE
  740 CONTINUE
      WRITE  (OP,750)(OSCAR(K),K=IST,IFIN)
  750 FORMAT ((20X,10(2A4,2X)),/)
      NWE = NWE - 2*NDB + 2
      IF (MI .EQ. 9) NWE = NWE - 2
      IVPS = OSCAR(IFIN+1)
      NLINES = NLINES + 1
      IF (NLINES .LT. NLPP) GO TO 760
      CALL PAGE
      NLINES = NLINES + 1
  760 CONTINUE
      IF (IVPS .LT. 0) WRITE (OP,770)
  770 FORMAT (20X,35HDEFAULT PARAMETER - ALWAYS NEGATIVE)
      IF (IVPS .LT. 0) GO TO 790
      WRITE  (OP,780) VPS(IVPS-3),VPS(IVPS-2)
  780 FORMAT (20X,21HCONTROL PARAMETER IS ,2A4)
  790 CONTINUE
      I = I + 2*NDB + 2
      IF (MI .EQ. 10 ) I = I + 1
      NWE = NWE - 1
      IF (NWE .GT. 0) GO TO 670
      GO TO 90
C
C     PROCESS CONTROL INSTRUCTIONS
C
  800 IRN = RSHIFT(OSCAR(I),16)
      IF (MI .EQ. 11 .OR. MI .EQ. 12) GO TO 810
      NLINES = NLINES + 2
      IF (NLINES .LT. NLPP) GO TO 810
      CALL PAGE
      NLINES = NLINES + 2
  810 CONTINUE
      IF (MI.NE.11 .AND. MI.NE.12) WRITE (OP,820) IRN
  820 FORMAT (/10X,25HRE-ENTRY RECORD NUMBER = ,I4)
      IF (MI .EQ. 6) GO TO 900
      IW = OSCAR(I) - LSHIFT(IRN,16)
      IF (MI .NE. 7) GO TO 860
C
C     CONDITIONAL INSTRUCTION
C
      NLINES = NLINES + 2
      IF (NLINES .LT. NLPP) GO TO 840
      CALL PAGE
      NLINES = NLINES + 2
  840 CONTINUE
      WRITE  (OP,850) VPS(IW-3),VPS(IW-2)
  850 FORMAT (/10X,21HPARAMETER FOR COND = ,2A4)
      GO TO 900
  860 BL = RSHIFT(CEITBL(IW-1),16)
      EL = CEITBL(IW-1) - LSHIFT(BL,16)
      ML = RSHIFT(CEITBL(IW),16)
      CL = CEITBL(IW  ) - LSHIFT(ML,16)
      NLINES = NLINES + 2
      IF (NLINES .LT. NLPP) GO TO 870
      CALL PAGE
      NLINES = NLINES + 2
  870 CONTINUE
      IF (MI .EQ. 5) WRITE (OP,880) BL,EL,ML,CL,CEITBL(IW+1),
     1    CEITBL(IW+2)
      IF (MI.EQ.11 .OR. MI.EQ.12) WRITE (OP,890) EL,ML,CL
  880 FORMAT (/20X,I5,1H/,I5,5X,I5,1H/,I5,5X,2A4)
  890 FORMAT (/20X,5X,1H/,I5,5X,I5,1H/,I5)
  900 I = I + 1
      GO TO 90
  910 RETURN
      END

      SUBROUTINE PAGE2 (LINES)
C
C     2ND MASTER PAGING ROUTINE FOR NASTRAN
C
C     IABS(LINES) = NO. OF LINES TO BE ADDED FOR OUTPUT
C     IF CURRENT PAGE CAN NOT ACCOMODATE THE INCOMING LINES, A NEW PAGE
C     IS INITIATED WITH PROPER HEADINGS.
C
C     IF LINES IS NEGATIVE, A 6-LINE HEADER IS PRINTED.
C     IF LINES IS POSITIVE, A 3-LINE HEADER IS PRINTED AND FOLLOWED BY
C        3 BLANK LINES.
C
C     ENTRY POINT PAGE3 -
C     A 3-LINE HEADER IS PRINTED, NO BLANK LINES FOLLOWED. LINES CAN BE
C     NEGATIVE OR POSITIVE.
C
C     SIMPLIFIED BY G.CHAN/UNISYS, AND PAGE3 ADDED  12/92
C
      IMPLICIT INTEGER (A-Z)
      INTEGER         TITLEX(18),NAME(2),FCHAR
      CHARACTER       MONTH(12)*3,AHEAD*30,MCHNAM*11,MACHOS*7
      COMMON /CHMACH/ MCHNAM, MACHOS
      COMMON /MACHIN/ MACH(4)
      COMMON /SYSTEM/ IBUF,NOUT,DUM6(6),SYM,ST,PAGE,LINE,TLINE,MAXLIN,
     1                DATE(3),DUM15(15),OFP,DUM8(8),CRDATE(3)
      COMMON /OUTPUT/ TITLE(32),SUBTIT(32),LABEL(32),HEAD1(32),
     1                HEAD2(32),HEAD3(32)
      EQUIVALENCE     (TITLEX(1),TITLE(1))
      DATA    MONTH /'JAN', 'FEB', 'MAR', 'APR', 'MAY', 'JUN', 
     1               'JUL', 'AUG', 'SEP', 'OCT', 'NOV', 'DEC'/
      DATA    NAME  / 4H PAG, 4HE2  /
C
      FLAG  = 2
C
   10 IF (LINES .EQ. 0) GO TO 100
      LL    = IABS(LINES)
      IF (SYM-LINE.LT.LL .OR. OFP.NE.0) GO TO 30
   20 LINE  = LINE + LL
      GO TO 100
C
   30 PAGE  = PAGE  + 1
      TLINE = TLINE + LINE
      LINE  = 0
      IF (TLINE .GT. MAXLIN) GO TO 90
      IN    = DATE(1)
C
C   ASSEMBLE PAGE HEADING
C
      AHEAD = ' '
      NCMNAM = INDEX(MCHNAM,' ') - 1
      IF (NCMNAM .LE. -1) NCMNAM = 11
      NCMOS  = INDEX(MACHOS,' ') - 1
      IF (NCMOS .LE. -1) NCMOS = 7
      FCHAR = (18 - NCMNAM - NCMOS)/2 + 1
      WRITE (AHEAD(FCHAR:FCHAR+1),35) CRDATE(3)
   35 FORMAT (A2)
      FCHAR = FCHAR + 3
      AHEAD(FCHAR:30) = MCHNAM(1:NCMNAM) // ' ' // MACHOS(1:NCMOS) //
     1 ' NASTRAN'
C
      WRITE  (NOUT,40) TITLEX, AHEAD, MONTH(IN),DATE(2),DATE(3),PAGE
   40 FORMAT (1H1,4X,17A4,A2,' /',A30,'/ ',A3,1X,I2,', ',I2, 
     1        ' / PAGE',I6)
      WRITE  (NOUT,50) SUBTIT
   50 FORMAT ( 5X,31A4,A3)
      WRITE  (NOUT,60) LABEL
   60 FORMAT (/5X,31A4,A3)
      LINE  = LINE + 4
      IF (FLAG  .LT. 0) GO TO 20
      IF (LINES .GT. 0) GO TO 70
C
      WRITE (NOUT,60) (HEAD1(I),I=1,32)
      WRITE (NOUT,50) (HEAD2(I),I=1,32)
      WRITE (NOUT,50) (HEAD3(I),I=1,32)
      LINE  = LINE + 4
      GO TO 20
C
   70 WRITE  (NOUT,80)
   80 FORMAT (///)
      LINE  = LINE + 4
      GO TO 20
C
C     MAX LINES EXCEEDED.  BUMP MAXLINES BY 3000 AND CALL MESAGE
C
   90 MAXLIN = MAXLIN + 3000
      CALL MESAGE (-19,TLINE,NAME)
C
  100 OFP  = 0
      RETURN
C
C
      ENTRY PAGE3 (LINES)
C     ===================
C
      FLAG = -3
      GO TO 10
C
      END

      SUBROUTINE ENDSYS (JOBSEG,JOBEND)
C
C     ENDSYS SAVES VARIOUS EXEC TABLES ON A SCRATCH FILE
C
C     LAST REVISED  5/91 BY G.CHAN/UNISYS  FOR SUPERLINK OPERATION
C          IF SPERLK = 0, WE ARE IN NASTRAN MULTI-LINK COMPUTATION
C          IF SPERLK = NON-ZERO, WE ARE IN NASTRAN SUPERLINK
C          SPERLK IS THE 95TH WORD OF /SYSTEM/
C
      EXTERNAL        LSHIFT,RSHIFT,ANDF,ORF,LINK
      LOGICAL         BITPAS
      INTEGER         ANDF,FIST,SAVE,SCRN1,SCRN2,THCRMK,POOL,SPERLK,
     1                NOPREF(2),RSHIFT,BUF,MSGBUF(8),BCDNUM(10),UNITS,
     2                TENS,ORF,UNITAB(75),FCB(75),DATABF,MSG(2),NAME(2),
     3                FILE,FILEX,LNKNUM(15),COMM,XF1AT,PREFAC
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25,FORTXX*7
      COMMON /XMSSG / UFM,UWM,UIM,SFM
      COMMON /MACHIN/ MACH
      COMMON /BLANK / IBLKCM(58),PREFAC(2)
      COMMON /XPFIST/ NPFIST
      COMMON /XFIST / FIST(2)
      COMMON /MSGX  / ITAB1(1)
      COMMON /STIME / ITAB2(2)
      COMMON /STAPID/ ITAB3(1)
      COMMON /XDPL  / ITAB4(3)
      COMMON /XXFIAT/ ITAB5(1)
      COMMON /XFIAT / ITAB6(4)
      COMMON /XVPS  / ITAB7(2)
      COMMON /XCEITB/ ITAB8(2)
      COMMON /GINOX / ITAB9(170)
      COMMON /SYSTEM/ ITAB10(22),LSYSTM,ICFIAT,JTAB10(11),NPRUS,
     1                KTAB10(35),BITPAS,LTAB10(18),LPCH,LDICT,MTAB10(2),
     2                SPERLK,NTAB10(5)
      COMMON /OUTPUT/ ITAB11(1)
      COMMON /NTIME / ITAB13(1)
      COMMON /XLINK / ITAB14(1)
      COMMON /SOFCOM/ ITAB15(1)
      COMMON /BITPOS/ BT(32,2)
      COMMON /OSCENT/ INOSCR(2)
CZZ   COMMON /ZZENDS/ DATABF(1)
      COMMON /ZZZZZZ/ DATABF(1)
      COMMON /SEM   / MASK,THCRMK,IMASK,LINKS(15)
      COMMON /L15 L8/ L15,L8,L13
      COMMON /XSFA1 / DUMMY(1902),COMM(20),XF1AT(1100)
C                           1902 = 401+1501
C
      EQUIVALENCE    (ITAB10( 1),ISYBUF),  (ITAB10(2),NOUT     ),
     1               (ITAB9 ( 2),FILEX ),  (ITAB9(12),UNITAB(1)),
     2               (ITAB9(170),FCB(1))
      DATA MSGBUF(1)/ 4HLINK /
      DATA MSGBUF(3)/ 4H     /
      DATA MSGBUF(5)/ 4H---- /
      DATA MSGBUF(6)/ 4H---- /
      DATA MSGBUF(7)/ 4H---- /
      DATA MSGBUF(8)/ 4H---- /
      DATA SCRN1    , SCRN2  /4HSCRA,4HTCH0/, SAVE/4HSAVE/,
     1     POOL     / 4HPOOL /,
     2     NOPREF   / 4HNOT , 4HPREF/
      DATA MSG      / 4HBEGN, 4HEND /
      DATA BCDNUM   / 1H0, 1H1, 1H2, 1H3, 1H4, 1H5, 1H6, 1H7, 1H8, 1H9 /
      DATA LNKNUM   / 4H 1  , 4H 2  , 4H 3  , 4H 4  , 4H 5  ,
     1                4H 6  , 4H 7  , 4H 8  , 4H 9  , 4H10  ,
     2                4H11  , 4H12  , 4H13  , 4H14  , 4H15  /
      DATA NAME     / 4HENDS,4HYS   /
C
C
C     PUNCH RESTART DICTIONAY
C     LDICT MAY NOT BE A SYSTEM PUNCH FILE, PUNCH THE CARDS OUT FIRST
C     BEFORE THE RESTART DICTIONARY CARDS GET LOST
C
      IF (MACH.GE.5 .OR. LDICT.EQ.LPCH) GO TO 8
      ENDFILE LDICT
      REWIND  LDICT
    5 READ   (LDICT,6,ERR=7,END=7) (DATABF(J),J=1,20)
    6 FORMAT (20A4)
      WRITE  (LPCH,6) (DATABF(J),J=1,20)
      GO TO  5
    7 REWIND LDICT
C
    8 MSGBUF(2) = 0
      J = 0
      DO 10 I = 1,15
      IF (JOBEND .EQ. LINKS(I)) MSGBUF(2) = LNKNUM(I)
      IF (JOBSEG .EQ. LINKS(I)) J = I
   10 CONTINUE
      IF (MSGBUF(2) .NE. 0) GO TO 15
      WRITE  (NOUT,12) SFM,JOBEND
   12 FORMAT (A25,', ILLEGAL LINK NUMBER ',A4,' ENCOUNTERED BY ENDSYS')
      CALL MESAGE (-61,0,0)
   15 MSGBUF(4) = MSG(2)
C
      IF (SPERLK .EQ. 0) GO TO 30
C
C     SIMPLIFIED OPERATION IF SUPERLINK (USED IN UNIX VERSION)
C
      SPERLK = J
      ITAB10(22) = JOBSEG
C     PREFAC(1)  = NOPREF(1)
C     PREFAC(2)  = NOPREF(2)
      CALL CONMSG (MSGBUF   ,4,0)
      CALL CONMSG (MSGBUF(5),4,0)
      DO 20 J = 2,11
   20 ITAB9(J) = 0
      DO 25 J = 87,161
      IF (ITAB9(J) .EQ. 0) GO TO 25
      I = J - 86
      WRITE  (NOUT,23) SFM,I,JOBEND
   23 FORMAT (A25,', LOGICAL UNIT',I5,' WAS NOT CLOSED AT END OF ',A4)
C     ITAB9(J) = 0
      CALL MESAGE (-37,0,0)
   25 CONTINUE
      GO TO 400
C
C     SEARCH FIAT FOR A SAVE FILE -- FILE MUST SATISFY THE FOLLOWING
C     (1) FILE MUST BE SCRATCHX OR TRAILERS=0 OR EXPIRED*
C     (2) IF (1) IS TRUE, NO UNEXPIRED SECONDARY ALLOCATIONS WITH
C     NON-ZERO TRAILERS MAY EXIST. (ALSO FILE MUST NOT BE PURGED)
C     AN EXPIRED FILE HAS AN LTU LESS THAN THE CURRENT OSCAR POSITION.
C
   30 FILE = SAVE
      LMT  = ITAB6(3)*ICFIAT + 3
      NEXT = LSHIFT(INOSCR(2),16)
      IFOUND  = 0
      FIST(2) = NPFIST + 1
      FIST(2*NPFIST+3) = SAVE
C
      K = ANDF(THCRMK,SCRN2)
      DO 50 I = 4,LMT,ICFIAT
      IF (ITAB6(I+1).EQ.SCRN1 .AND. ANDF(THCRMK,ITAB6(I+2)).EQ.K)
     1    GO TO 35
      IF (ITAB6(I+3).NE.0 .OR. ITAB6(I+4).NE.0 .OR. ITAB6(I+5).NE.0)
     1    GO TO 32
      IF (ICFIAT.EQ.11 .AND.  (ITAB6(I+8).NE.0 .OR. ITAB6(I+9).NE.0 .OR.
     1    ITAB6(I+10).NE.0)) GO TO 32
      GO TO 35
   32 LTU = ANDF(ITAB6(I),1073676288)
C                         1073676288 = 2**30 - 2**16 = 3FFF0000 HEX
C                                    = 0 SIGN BIT + LEFT 14 BITS OF 1's
      IF (LTU.GE.NEXT .OR. LTU .EQ. 0) GO TO 50
   35 IUCB = ANDF(ITAB6(I),32767)
C                          32767 = 2**15 - 1 = RIGHT 15 BITS OF 1's
      IF (IUCB .EQ. 32767) GO TO 50
      DO 40 J = 4,LMT,ICFIAT
      IF (ANDF(ITAB6(J),32767) .NE. IUCB) GO TO 40
      IF (I .EQ. J) GO TO 40
      LTU = ANDF(ITAB6(J),1073676288)
      IF (LTU.LT.NEXT .AND. LTU.NE.0) GO TO 40
      IF (ITAB6(J+3).NE.0 .OR. ITAB6(J+4).NE.0 .OR. ITAB6(J+5).NE.0)
     1    GO TO 50
      IF (ICFIAT.EQ.11 .AND. (ITAB6(J+8).NE.0 .OR. ITAB6(J+9).NE.0 .OR.
     1    ITAB6(J+10).NE.0)) GO TO 50
   40 CONTINUE
      IF (IFOUND .EQ. 0) IFOUND = I
C
C     FLUSH FILE IN CASE DATA EXISTS ON FILE
C     THIS WILL FREE UP SECONDARIES ON 360 AND DISK ON CDC AND UNIVAC
C
      IF (ITAB6(I+3).NE.0 .OR. ITAB6(I+4).NE.0 .OR. ITAB6(I+5).NE.0)
     1    GO TO 45
      IF (ICFIAT.EQ.11 .AND. (ITAB6(I+8).NE.0 .OR. ITAB6(I+9).NE.0 .OR.
     1    ITAB6(I+10).NE.0)) GO TO 45
      GO TO 50
   45 FIST(2*NPFIST+4) = I - 1
      CALL OPEN (*360,SAVE,DATABF,1)
      CALL CLOSE (SAVE,1)
   50 CONTINUE
C
      IF (IFOUND .EQ. 0) CALL MESAGE (-39,0,0)
      I = -2
      IF (ITAB11(1)+ITAB11(-I) .EQ. I) ICFIAT = ICFIAT + I
C
C     GOOD NEWS - WE FOUND A FILE FOR SAVE PURPOSES.
C     SAVE POINTER TO FILE IN BLANK COMMON.
C
      I = IFOUND
      IBLKCM(1) = ITAB6(I)
C
C     SAVE UNIT = 2 FOR ALL MACHINES, IBM INCLUDED
C     (IBM USED 51 BEFORE)
C
      IUNITU = 2
C
C     FCB ARREY OF 75 WORDS IS NOT USED BY VAX AND UNIX
C
      REWIND IUNITU
      IF (MACH .LT. 5) WRITE (IUNITU) ITAB6(I),ISYBUF,FCB
      IF (MACH .GE. 5) WRITE (IUNITU) ITAB6(I),ISYBUF
      REWIND IUNITU
      FIST(2*NPFIST+4) = I - 1
C
C     SET PREFAC FLAG SO LINK 1 IS RE-ENTRANT
C
C     PREFAC(1) = NOPREF(1)
C     PREFAC(2) = NOPREF(2)
C
C     SAVE THE NEXT LINK NO. IN THE 22ND WORD OF /SYSTEM/
C
      ITAB10(22) = JOBSEG
C
C     WRITE EXEC TABLES ON THE FILE JUST FOUND.
C
      CALL OPEN  (*360,SAVE,DATABF,1)
      LTAB10(7)  = 0
      CALL WRITE (SAVE,ITAB10,LSYSTM,1)
      CALL WRITE (SAVE,ITAB1,ITAB1(1)*4+2,1)
      CALL WRITE (SAVE,ITAB2,1,1)
      CALL WRITE (SAVE,ITAB3,6,1)
      CALL WRITE (SAVE,ITAB4,ITAB4(3)*3+3,1)
      CALL WRITE (SAVE,ITAB5,NPFIST,1)
      CALL WRITE (SAVE,ITAB6,ITAB6(3)*ICFIAT+3,1)
      CALL WRITE (SAVE,ITAB7,ITAB7(2),1)
      CALL WRITE (SAVE,ITAB8,ITAB8(2),1)
      CALL WRITE (SAVE,ITAB9(12),75,1)
      CALL WRITE (SAVE,ITAB11,224,1)
      CALL WRITE (SAVE,ITAB13,ITAB13(1)+1,1)
      CALL WRITE (SAVE,ITAB14,ITAB14(1)+2,1)
      CALL WRITE (SAVE,ITAB15,27,1)
      CALL WRITE (SAVE,BT,64,1)
      CALL CLOSE (SAVE,1)
C
C     FLUSH ANY QUEUED SYSTEM OUTPUT.
C     LOAD NEXT LINK NO. INTO UNIT 97, AND TERMINATE PRESENT LINK.
C
      KK = ITAB10(2)
      WRITE  (KK,55)
   55 FORMAT (//)
      CALL CONMSG (MSGBUF   ,4,0)
      CALL CONMSG (MSGBUF(5),4,0)
      IF (MACH .EQ. 4) GO TO 67
      IF (ITAB10(7) .LT. 0) ENDFILE 52
C
C     IF IBM NEW LOGIC OF LINK SWITCHING VIA FILE 97 IS NOT AVAILBLE,
C     WE STILL NEED THE NEXT 3 LINES FOR DEAR OLD IBM
C
      IF (MACH .NE. 2) GO TO 60
C     CALL SEARCH (JOBSEG,SYSLB2,NOTUSE)
      CALL SEARCH (JOBSEG)
      GO TO 400
C
   60 I = KHRFN3(MSGBUF(3),JOBSEG,2,1)
      IF (MACH.EQ.9 .OR. MACH.EQ.12) GO TO 61
      OPEN (UNIT=97,ACCESS='SEQUENTIAL',STATUS='NEW',ERR=64)
      GO TO 62
   61 CALL FLUNAM (97,FORTXX)
      OPEN (UNIT=97,ACCESS='SEQUENTIAL',STATUS='NEW',ERR=64,FILE=FORTXX)
   62 WRITE  (97,63) I
   63 FORMAT ('NAST',A2)
      CLOSE (UNIT=97)
      CALL EXIT
CSUN  CALL EXIT (0)
   64 WRITE  (NOUT,65)
   65 FORMAT ('0*** SYSTEM ERROR, CAN NOT OPEN FORTRAN UNIT 97 FOR ',
     1        'LINK SWITCH')
      CALL MESAGE (-37,0,NAME)
C
C     DETERMINE LINK NUMBER FOR 6600
C
   67 I = ANDF(4095,RSHIFT(JOBSEG,36))
      I1 = I/64
      I2 = I - I1*64
      I  = 10*I1 + I2 - 297
      I76= 76
      CALL LINK (I,ITAB10(I76),0)
      GO TO 350
C
C
      ENTRY BGNSYS
C     ============
C
      NPRUS      = 0
      BITPAS     = .TRUE.
      MSGBUF(4)  = MSG(1)
C     PREFAC(1)  = 0
C     PREFAC(2)  = 0
      IF (SPERLK .EQ. 0) GO TO 70
C
C     SIMPLEFIED OPERATION IF SUPERLINK (USED IN UNIX VERSION)
C
      IF (SPERLK.LT.1 .OR. SPERLK.GT.15) GO TO 225
      ITAB10(22) = LINKS(SPERLK)
      MSGBUF(2)  = LNKNUM(SPERLK)
      JOBSXX     = ITAB10(22)
      GO TO 228
C
C     BGNSYS RESTORES THE EXEC TABLES SAVED BY ENDSYS
C     THEN REPOSITIONS THE OSCAR TO THE ENTRY FOR THE MODULE
C     IN THE CURRENT LINK.
C
   70 IUNITU = 2
      IF (MACH .LT. 5) READ (IUNITU) ITAB6(4),ISYBUF,FCB
      IF (MACH .GE. 5) READ (IUNITU) ITAB6(4),ISYBUF
      FIST(2) = NPFIST + 1
      FIST(2*NPFIST+3) = SAVE
      FIST(2*NPFIST+4) = 3
      J = 5000
      CALL OPEN (*360,SAVE,DATABF(J),0)
      CALL READ (*340,*80,SAVE,ITAB10,900,1,FLG)
   80 CALL READ (*340,*90,SAVE,ITAB1,900,1,FLG)
      GO TO 350
   90 CALL READ (*340,*100,SAVE,ITAB2,900,1,FLG)
      GO TO 350
  100 CALL READ (*340,*110,SAVE,ITAB3,900,1,FLG)
      GO TO 350
  110 CALL READ (*340,*120,SAVE,ITAB4,900,1,FLG)
      GO TO 350
  120 CALL READ (*340,*130,SAVE,ITAB5,900,1,FLG)
      GO TO 350
  130 CALL READ (*340,*140,SAVE,ITAB6,900,1,FLG)
      GO TO 350
  140 CALL READ (*340,*150,SAVE,ITAB7,900,1,FLG)
      GO TO 350
  150 CALL READ (*340,*160,SAVE,ITAB8,900,1,FLG)
      GO TO 350
  160 CALL READ (*340,*170,SAVE,ITAB9(12),900,1,FLG)
      GO TO 350
  170 CALL READ (*340,*190,SAVE,ITAB11,900,1,FLG)
      GO TO 350
  190 CALL READ (*340,*210,SAVE,ITAB13,900,1,FLG)
      GO TO 350
  210 CALL READ (*340,*220,SAVE,ITAB14,900,1,FLG)
      GO TO 350
  220 CALL READ (*340,*221,SAVE,ITAB15,900,1,FLG)
      GO TO 350
  221 CALL READ (*340,*222,SAVE,BT,900,1,FLG)
      GO TO 350
  222 CALL CLOSE (SAVE,1)
C
C     RETRIEVE THE CURRENT LINK NO. FROM THE 22ND WORD OF /SYSTEM/
C
      JOBSXX = ITAB10(22)
      DO 224 I = 1,15
      IF (JOBSXX .NE. LINKS(I)) GO TO 224
      MSGBUF(2) = LNKNUM(I)
      GO TO 228
  224 CONTINUE
  225 WRITE  (NOUT,226) SFM,JOBSXX,SPERLK
  226 FORMAT (A25,', ILLEGAL LINK NUMBER ',A4,' ENCOUNTERED BY BGNSYS.',
     1        4X,'SPERLK=',I14)
      CALL MESAGE (-61,0,0)
C
  228 CALL PRESSW (JOBSXX,I)
      CALL CONMSG (MSGBUF,4,0)
      CALL SSWTCH (15,L15)
      CALL SSWTCH ( 8,L 8)
      CALL SSWTCH (13,L13)
      IF (MACH .NE. 3) GO TO 320
C
      IF (ITAB10(7) .GE. 0) GO TO 238
  232 READ (52,234,END=236) I
  234 FORMAT (A1)
      GO TO 232
  236 BACKSPACE 52
  238 CONTINUE
C
C     REPOSITION DRUM FILES OFF LOAD POINT (1108 ONLY)
C
      CALL DEFCOR
      CALL CONTIN
C
C     TAPE-FLAG IS THE 45TH WORD OF /SYSTEM/
C     IF THE 7TH BIT (COUNTING FROM RIGHT TO LEFT) OF TAPE-FLAG IS NOT
C     ON (=1), AND PLT2 HAS NOT BEEN EXTERNALLY ASSIGNED AS A MAGNETIC
C     TAPE, SET PLT2 IS TO DISK. SIMILARILY,
C     IF THE 6TH BIT IS NOT SET, AND PLT1 IS NOT TAPE ASSIGNED, SET PLT1
C     TO DISK
C
      I45   = 45
      ISTAT = ANDF(ITAB10(I45),64)
      JSTAT = ANDF(ITAB10(I45),32)
C
      DO 300 I = 1,75
C
C     CALL FACIL TO DETERMINE IF UNIT IS TAPE
C
      TENS  = I/10
      UNITS = I - 10*TENS
      NBCD  = BCDNUM(UNITS+1)
      IF (TENS .EQ. 0) GO TO 295
      MASKK = 255
      MASKK = LSHIFT(MASKK,27)
      NBCD  = ORF(ANDF(BCDNUM(TENS+1),MASKK),RSHIFT(NBCD,9))
  295 CALL FACIL (NBCD,J)
C
C     DECODE UNITAB ENTRY
C
      NBLOCK = ANDF(RSHIFT(UNITAB(I),12),262143)
      NLR = ANDF(UNITAB(I),4095)
      IF (J.EQ.7 .OR. J.EQ.9) GO TO 298
C
C     POSITION DRUM UNIT NOW OFF LOAD POINT
C
      IF (NBLOCK+NLR .EQ. 1) GO TO 300
      CALL NTRAN (I,10,22)
      NOSECT = NBLOCK*ITAB9(164)
      IF (NLR .EQ. 0) NOSECT = NOSECT - ITAB9(164)
      IF (I.EQ.13 .AND. ISTAT.NE.0) NOSECT = UNITAB(13)
      IF (I.EQ.12 .AND. JSTAT.NE.0) NOSECT = UNITAB(12)
      CALL NTRAN (I,6,NOSECT)
C
C     RESET FCB ENTRY
C     COMMENTS FROM G.CHAN/UNISYS   11/90
C     FCB ARRAY OF 75 WORDS IS USED ONLY BY UNIVAC AND IBM. IT BEGINS
C     AT THE 170TH WORD OF /GINOX/
C
  298 IF (NLR .NE. 0) NBLOCK = NBLOCK + 1
      FCB(I) = NBLOCK
  300 CONTINUE
C
  320 IF (SPERLK .NE. 0) GO TO 330
C
C     DEFINE OPEN CORE FOR VAX AND UNIX
C
      IF (MACH .GE. 5) CALL DEFCOR
C
C     REPOSITION POOL TO OSCAR ENTRY TO BE EXECUTED.
C
  330 BUF  = KORSZ(DATABF) - ITAB10(1)
      FILE = POOL
      CALL OPEN (*360,POOL,DATABF(BUF),2)
      CALL BCKREC (POOL)
      IF (SPERLK .EQ. 0) GO TO 400
      DO 333 J = 1,60
  333 IBLKCM(J)= 0
C     DO 334 J = 1,1902
C 334 DUMMY(J) = 0
C     COMM( 1) = 0
C     COMM( 3) = 0
      COMM( 8) = 0
C     COMM( 9) = 0
C     COMM(12) = 0
C     COMM(15) = 0
C     COMM(18) = 0
      DO 335 J = 1,1100
  335 XF1AT(J) = 0
      GO TO 400
C
  340 CONTINUE
  350 CALL MESAGE (-37,0,NAME)
  360 CALL MESAGE (-1,FILE,NAME)
C
  400 RETURN
      END

      SUBROUTINE IDPLOT (IDX)
C
      COMMON /OUTPUT/ SKPOUT(32,6),ID(32)
      COMMON /PLTDAT/ SKPPLT(2),XYMIN(2),XYMAX(2),AXYMAX(2),EDGE(12)
     1,      SKPA(3),CNTX,CNTY,SKPB(4),PLTYPE
      INTEGER PLTYPE
C
      INTEGER BLANK
      REAL SAVE(2,4)
      DATA BLANK,LINSIZ / 1H ,3 /
C
C     DOES A PLOT ID EXIST AT ALL
C
      IDX = 1
      DO 101 I = 1,20
      IF (ID(I).NE.BLANK)  GO TO 102
  101 CONTINUE
      IDX = 0
      GO TO 200
C
  102 DO 103 I = 1,2
      SAVE(I,1) = XYMIN(I)
      XYMIN(I) = 0.
      SAVE(I,2) = XYMAX(I)
      XYMAX(I) = AXYMAX(I)+EDGE(I)
      SAVE(I,3) = AXYMAX(I)
      AXYMAX(I) = XYMAX(I)
      SAVE(I,4) = EDGE(I)
      EDGE(I) = 0.
  103 CONTINUE
      NLINES = (AXYMAX(2)-7.*CNTY) / FLOAT(2*LINSIZ) + .1
      IF (IABS(PLTYPE).NE.1)  GO TO 122
C
C     FILL TOP HALF OF PLOT WITH X-AXIS LINES ALL THE WAY ACROSS.
C
      CALL AXIS (0,0,0,0,0,-1)
      DO 111 I = 1,NLINES
      Y = XYMAX(2) - FLOAT((I-1)*LINSIZ)
      CALL AXIS (XYMIN(1),Y,XYMAX(1),Y,1,0)
  111 CONTINUE
C
C     PRINT THE PLOT ID 2 TIMES IN THE MIDDLE OF THE PLOT.
C
      CALL PRINT (0,0,0,0,0,-1)
      X = XYMIN(1) + AMAX1(0.,(AXYMAX(1)-80.*CNTX)/2.)
      YY = Y-CNTY
      DO 116 I = 1,2
      Y = YY - CNTY*FLOAT(I-1)
      CALL PRINT (X,Y,1,ID,20,0)
  116 CONTINUE
C
C     FILL BOTTOM HALF OF PLOT WITH X-AXIS LINES ALL THE WAY ACROSS.
C
      CALL AXIS (0,0,0,0,0,-1)
      DO 121 I = 1,NLINES
      Y = XYMIN(2) + FLOAT((I-1)*LINSIZ)
      CALL AXIS (XYMIN(1),Y,XYMAX(1),Y,1,0)
  121 CONTINUE
      CALL AXIS (0,0,0,0,0,1)
      GO TO 125
C
C     NOT A CRT PLOTTER. TYPE THE ID ONCE AT THE BOTTOM OF THE PAPER.
C
  122 CALL PRINT (0,0,0,0,0,-1)
      X = XYMIN(1) + AMAX1(0.,(AXYMAX(1)-80.*CNTX)/2.)
      Y = 0.
      IF (PLTYPE.LT.0)  Y=CNTY/2.
      CALL PRINT (X,Y,1,ID,20,0)
C
C     END OF ID PLOT. PUT BLANKS IN THE PLOT ID.
C
  125 CALL PRINT (0,0,0,0,0,1)
      DO 126 I = 1,20
      ID(I) = BLANK
  126 CONTINUE
      DO 127 I = 1,2
      XYMIN(I) = SAVE(I,1)
      XYMAX(I) = SAVE(I,2)
      AXYMAX(I) = SAVE(I,3)
      EDGE(I) = SAVE(I,4)
  127 CONTINUE
C
  200 RETURN
      END

      SUBROUTINE DPDAA
C*****
C DPDAA PERFORMS A BINARY SEARCH IN EQDYN AND CONVERTS THE GRID NO
C AND COMPONENT CODE TO AN SIL VALUE.
C*****
C
      INTEGER       GPL   ,SIL   ,USET  ,USETD ,GPLD  ,SILD  ,DPOOL
     1             ,DLT   ,FRL   ,TFL   ,TRL   ,PSDL  ,EED   ,SCR1
     2             ,SCR2  ,SCR3  ,SCR4  ,BUF   ,BUF1  ,BUF2  ,BUF3
     3             ,BUF4  ,NGRID ,EQDYN ,EPOINT,SEQEP ,Z     ,LOADS
     5             ,PSD   ,DLOAD ,FREQ1 ,FREQ  ,TIC   ,TSTEP ,TF
     6             ,EIGR  ,EIGB  ,EIGC
C
      DIMENSION BUF(24)   ,EPOINT(2)    ,SEQEP(2)     ,MCB(7)
     1         ,NAM(2)    ,LOADS(32)    ,DLOAD(2)     ,FREQ1(2)
     2         ,FREQ(2)   ,ZZ(1)        ,BUFR(20)     ,NOLIN(21)
     3         ,TIC(2)    ,TSTEP(2)     ,TF(2)        ,PSD(2)
     4         ,MSG(3)    ,EIGR(2)      ,EIGB(2)      ,EIGC(2)
C
      COMMON/DPDCOM/DPOOL ,GPL   ,SIL   ,USET  ,GPLD  ,SILD  ,USETD
     1             ,DLT   ,FRL   ,NLFT  ,TFL   ,TRL   ,PSDL  ,EED
     2             ,SCR1  ,SCR2  ,SCR3  ,SCR4  ,BUF   ,BUF1  ,BUF2
     3             ,BUF3  ,BUF4  ,EPOINT,SEQEP ,L     ,KN    ,NEQDYN
     4             ,LOADS ,DLOAD ,FREQ1 ,FREQ  ,NOLIN ,NOGO
     5             ,MSG   ,TIC   ,TSTEP ,TF    ,PSD   ,EIGR  ,EIGB
     6             ,EIGC  ,MCB   ,NAM   ,EQDYN ,SDT   ,INEQ
C
      COMMON/ZZZZZZ/Z(1)
C
      EQUIVALENCE   (Z(1) ,ZZ(1)),(BUF(1),BUFR(1)),(MSG(2),NGRID)
C
C*****
C IF EQDYN IS NOT IN CORE, READ IT IN AND SET FLAG.
C*****
      IF(INEQ .NE. 0) GO TO 1
      CALL GOPEN(EQDYN,Z(BUF3),0)
      CALL FREAD(EQDYN,Z,NEQDYN+1,1)
      CALL CLOSE(EQDYN,1)
      INEQ= 1
C*****
C PERFORM SEARCH.
C*****
    1 KLO= 1
      KHI= KN
      NGRID= BUF(L)
    2 K= (KLO+KHI+1)/2
    3 IF(NGRID - Z(2*K-1)) 4,11,5
    4 KHI= K
      GO TO 6
    5 KLO= K
    6 IF(KHI-KLO-1) 10,7,2
    7 IF(K.EQ.KLO) GO TO 8
      K= KLO
      GO TO 9
    8 K= KHI
    9 KLO= KHI
      GO TO 3
   10 CALL MESAGE(30,MSG,MSG(2))
      NOGO= 1
   11 BUF(L)= Z(2*K)
      IF(BUF(L+1) .NE. 0) BUF(L)= BUF(L)+BUF(L+1)-1
      RETURN
      END

      SUBROUTINE RODS
C
C     THIS ROUTINE PROCESSES ROD ELEMENT DATA TO PRODUCE STIFFNESS AND
C     MASS MATRICES. IF THE HEAT TRANSFER OPTION IS ON, CONDUCTIVITY AND
C     CAPACITY MATRICES ARE PRODUCED
C
C     THIS ROUTINE CAN COMPUTE BOTH CONVENTIONAL AND CONSISTENT
C     MASS MATRICES
C
C     SINGLE PRECISION VERSION
C
C     THIS VERSION WAS SPECIALLY CODED TO ILLUSTRATE A GENERAL
C     USE OF THE IMPROVED MATRIX GENERATOR.
C
C     THE EST ENTRY FOR THIS ELEMENT CONTAINS
C
C     POSITION     NAME       DESCRIPTION
C     *****        *****      *******************************
C     1             EID       ELEMENT ID NO.
C     2             SIL1      SCALAR INDEX OF POINT A
C     3             SIL2      SCALAR INDEX OF POINT B
C     4             MID       MATERIAL DATA ID
C     5             AFACT     AREA OF CROSS SECTION
C     6             JFACT     TORSIONAL STIFFNESS COEFFICIENT
C     7             CFACT     TORSIONAL STRESS RECOVERY DISTANCE
C     8             MU        NON-STRUCTURAL MASS PER LENGTH
C     9-16          BGPDT     BASIC GRID POINT DATA. COORDINATE SYSTEM
C                             NUMBER AND  X,Y,Z LOCATION FOR 2 POINTS
C     17            TBAR      AVERAGE ELEMENT TEMPERATURE
C
C
      LOGICAL         NOGO
      INTEGER         SIL1     ,SIL2     ,IEST(13)  ,EID     ,GE       ,
     1                DICT(7)  ,ELID     ,ESTID
      REAL            JFACT    ,MU       ,KCON     ,EST(200) ,K        ,
     1                EVECT(3) ,EL       ,KE       ,ME       ,TE       ,
     2                HA(3)    ,HB(3)    ,KHA(3)   ,KHB(3)   ,TA(9)    ,
     3                TB(9)    ,SCALE
      REAL            MASSII(9),MASSJJ(9),MASSIJ(9),MASSJI(9),MIJDUM(9),
     1                MJIDUM(9)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /MATIN / MATID    ,INFLAG   ,ELTEMP   ,DUM(3)
      COMMON /MATOUT/ E        ,G        ,NU       ,RHO      ,ALFA     ,
     1                TSUB0    ,GE
      COMMON /HMTOUT/ KCON
      COMMON /EMGPRM/ IXTRA    ,IZR      ,NZR      ,DUMY(12) ,KMBGG(3) ,
     1                IPREC    ,NOGO     ,HEAT     ,ICMBAR
      COMMON /EMGDIC/ DUM2(2)  ,NLOCS    ,ELID     ,ESTID
      COMMON /ZZZZZZ/ K(1)
C
C     THE VARIABLE K IS OPEN CORE. OPEN SPACE EXISTS FROM Z(IZ) TO Z(NZ)
C     THIS IS INTENDED AS AN EXAMPLE. NORMALLY FOR SMALL ARRAYS
C     LOCAL VARIABLES MAY BE USED.
C
      COMMON /EMGEST/ EID      ,SIL1     ,SIL2     ,MID      ,AFACT    ,
     1                JFACT    ,CFACT    ,MU       ,BGPDT(4,2),TBAR
      COMMON /SYSTEM/ KSYSTM(63)
      EQUIVALENCE     (KSYSTM( 2),IOUTPT),(KSYSTM(56),IHEAT) ,
     1                (EID,EST(1),IEST(1)),(CP,KCON)
C
C     FOR DOUBLE PRECISION THE POINTERS TO OPEN CORE MUST BE MODIFIED.
C
      IZ = (IZR-2)/IPREC + 2
      NZ = NZR/IPREC
      IF (NZ -IZ .LE. 144) GO TO 290
      DICT(1) = ESTID
C
C     SUBTRACT BASIC LOCATIONS TO OBTAIN LENGTH ETC.
C
      DO 10 I = 1,3
   10 EVECT(I) = BGPDT(I+1,2) - BGPDT(I+1,1)
C
      EL = SQRT(EVECT(1)**2 + EVECT(2)**2 + EVECT(3)**2)
      IF (EL .LE. 0.0) GO TO 270
C
C     IF HEAT TRANSFER PROBLEM TRANSFER.  CALL MATERIAL SUBROUTINE
C
      INFLAG = 1
      MATID  = MID
      ELTEMP = TBAR
      IF (IHEAT .EQ. 1) GO TO 240
      CALL MAT (EID)
      KE = (E*AFACT)/EL
      ME = (RHO*AFACT+MU)*EL/2.0
      TE = (G*JFACT)/EL
C
C     PROCESS STIFFNESS HERE
C
      IF (KMBGG(1) .EQ. 0) GO TO 220
      IF (KE.EQ.0.0 .AND. TE.EQ.0.) GO TO 220
C
C     GENERATE   HA  =  (E*TA)/EL   AND  HB = (E*TB)/EL
C
      IF (IEST(9).EQ. 0) GO TO 30
      CALL TRANSS (BGPDT(1,1),TA)
      CALL GMMATS (EVECT,1,3,0, TA,3,3,0, HA)
      DO 20 I = 1,3
   20 HA(I) = HA(I)/EL
      GO TO 50
   30 DO 40 I = 1,3
   40 HA(I) = EVECT(I)/EL
   50 IF (IEST(13).EQ. 0) GO TO 70
      CALL TRANSS (BGPDT(1,2),TB)
      CALL GMMATS (EVECT,1,3,0, TB,3,3,0, HB)
      DO 60 I = 1,3
   60 HB(I) = HB(I)/EL
      GO TO 90
   70 DO 80 I = 1,3
   80 HB(I) = EVECT(I)/EL
C
C     THE GENERAL 12X12  MATRIX FOR THE ROD ELEMENT IS
C                             -                            -
C                            1HA K HA1   0  1HA K HB1       1
C                **   **     1 ------1------1-------1-------1
C                *  K  *   = 1   0   1HA T A1       1HA T HB1
C                **   **     1 ------1------1-------1-------1
C                            1HB K HA       1HB K HB1       1
C                            1 ------1------1-------1-------1
C                            1       1HB T A1       1HB T HB1
C                            1       1      1       1       1
C                             -                            -
C                      EACH BLOCK  ABOVE IS A 3 BY 3 MATRIX
C
C     TEST AND SET COMPONENT CODE    111= 7     111000=56
C
   90 ICODE = 0
      NDOF  = 0
      IF (TE .NE. 0.) GO TO 100
      ICODE = 7
      NDOF  = 6
      GO TO 120
  100 IF (KE .NE. 0.) GO TO 110
      ICODE = 56
      NDOF  = 6
      GO TO 120
  110 ICODE = 63
      NDOF  = 12
  120 NSQ   = NDOF**2
      NG    = NDOF/2
      NPART = NG*NDOF
      IZERO = IZ -1
      IPASS = 1
      DO  130 I = 1,NSQ
      IZPI  = IZ + I - 1
  130 K(IZPI) = 0.0
C
C     EXTENSIONAL STIFFNESS TERMS ARE COMPUTED HERE.
C
      IF (ICODE .EQ. 56) GO TO 200
      SCALE = KE
  140 DO 150 I = 1,3
      KHA(I) = SCALE*HA(I)
  150 KHB(I) = SCALE*HB(I)
C
C     THE MATRIX COLUMNS AND ROWS MUST BE IN THE NUMERICAL ORDER
C     OF TH SIL VALUES. THE POINTERS INTO THE MATRIX ARE VARIABLES.
C
      IF (SIL2-SIL1) 160,270,170
  160 IBBZ = IZERO
      IABZ = IZERO + NG
      IBAZ = IZERO + NPART
      IAAZ = IBAZ  + NG
      GO TO 180
  170 IAAZ = IZERO
      IBAZ = IZERO + NG
      IABZ = IZERO + NPART
      IBBZ = IABZ  + NG
  180 CONTINUE
      DO 190 J = 1,3
      DO 190 I = 1,3
      IJ   = NDOF*(J-1) + I
      IAA  = IJ + IAAZ
      K(IAA) = KHA(I)*HA(J)
      IBA  = IJ + IBAZ
      K(IBA) =-KHB(I)*HA(J)
      IAB  = IJ + IABZ
      K(IAB) =-KHA(I)* HB(J)
      IBB  = IJ + IBBZ
      K(IBB) = KHB(I)* HB(J)
  190 CONTINUE
C
C     THE TORSIONAL STIFFNESS TERMS ARE FORMED USING TE INSTEAD OF KE
C     THEY ARE INSERTED IN THE MATRIX WITH  A CONSTANT OFFSET, 3*12+3.
C
  200 IF (IPASS .EQ. 2) GO TO 210
      IF (NDOF .EQ. 12) IZERO = 38 + IZ
      IPASS = 2
      SCALE = TE
      IF (ICODE .NE. 7) GO TO 140
  210 IPART   = IZ
      DICT(2) = 1
      DICT(3) = NDOF
      DICT(4) = ICODE
      DICT(5) = GE
      CALL EMGOUT (K(IPART),K(IPART),NSQ,1,DICT,1,IPREC)
C
C     THE MASS MATRIX TERMS ARE CALCULATED HERE.
C
  220 IF (KMBGG(2).EQ.0 .OR. ME.EQ.0.0) RETURN
      DICT(3) = 6
      DICT(4) = 7
      DICT(5) = 0
C
C     CHECK TO SEE IF CONVENTIONAL OR CONSISTENT MASS MATRIX IS REQUIRED
C
      IF (ICMBAR .GT. 0) GO TO 400
C
C     CONVENTIONAL MASS MATRIX TERMS ARE COMPUTED HERE
C
      DICT(2) = 2
      LDATA = 6
      IZP5  = IZ + 5
      DO 230 I = IZ,IZP5
  230 K(I)  = ME
      GO TO 600
C
C     CONSISTENT MASS MATRIX TERMS ARE COMPUTED HERE
C
  400 DICT(2) = 1
      LDATA   = 36
      DO 420 I = 1,9
      MASSII(I) = 0.0
      MASSJJ(I) = 0.0
      MASSIJ(I) = 0.0
      MASSJI(I) = 0.0
      MIJDUM(I) = 0.0
      MJIDUM(I) = 0.0
  420 CONTINUE
      ME = 2.0*ME
      DO 440 I = 1,9,4
      MASSII(I) = ME/3.0
      MASSJJ(I) = ME/3.0
      MASSIJ(I) = ME/6.0
      MASSJI(I) = ME/6.0
      MIJDUM(I) = ME/6.0
      MJIDUM(I) = ME/6.0
  440 CONTINUE
      IF (SIL2-SIL1) 480,270,460
  460 ITI = 9
      ITJ = 13
      GO TO 500
  480 ITI = 13
      ITJ = 9
  500 IF (IEST(ITI) .EQ. 0) GO TO 520
      CALL TRANSS (IEST(ITI), TA)
      CALL GMMATS (TA,3,3,1, MASSII,3,3,0, K(IZ))
      CALL GMMATS (K(IZ),3,3,0, TA,3,3,0, MASSII)
      CALL GMMATS (TA,3,3,1, MIJDUM,3,3,0, MASSIJ)
      CALL GMMATS (MJIDUM,3,3,0, TA,3,3,0, MASSJI)
  520 IF (IEST(ITJ) .EQ. 0) GO TO 560
      CALL TRANSS (IEST(ITJ), TA)
      CALL GMMATS (TA,3,3,1, MASSJJ,3,3,0, K(IZ))
      CALL GMMATS (K(IZ),3,3,0, TA,3,3,0, MASSJJ)
      CALL GMMATS (MASSIJ,3,3,0, TA,3,3,0, MIJDUM)
      CALL GMMATS (TA,3,3,1, MASSJI,3,3,0, MJIDUM)
      DO 540 I = 1,9
      MASSIJ(I) = MIJDUM(I)
      MASSJI(I) = MJIDUM(I)
  540 CONTINUE
  560 DO 580 I = 1,3
      KZ = IZ + I - 1
      K(KZ   ) = MASSII(I  )
      K(KZ+ 6) = MASSII(I+3)
      K(KZ+12) = MASSII(I+6)
      K(KZ+ 3) = MASSIJ(I  )
      K(KZ+ 9) = MASSIJ(I+3)
      K(KZ+15) = MASSIJ(I+6)
      K(KZ+18) = MASSJI(I  )
      K(KZ+24) = MASSJI(I+3)
      K(KZ+30) = MASSJI(I+6)
      K(KZ+21) = MASSJJ(I  )
      K(KZ+27) = MASSJJ(I+3)
      K(KZ+33) = MASSJJ(I+6)
  580 CONTINUE
  600 CALL EMGOUT (K(IZ),K(IZ),LDATA,1,DICT,2,IPREC)
      RETURN
C
C     HEAT TRANSFER CALCULATIONS ARE PERFORMED HERE
C
  240 INFLAG  = 1
      DICT(2) = 1
      DICT(3) = 2
      DICT(4) = 1
      DICT(5) = 0
      IF (KMBGG(1) .EQ. 0) GO TO 250
      CALL HMAT (EID)
      K(IZ) = (AFACT*KCON)/EL
      IF (K(IZ) .EQ. 0.0) GO TO 250
      K(IZ+1) = -K(IZ)
      K(IZ+2) = -K(IZ)
      K(IZ+3) =  K(IZ)
      CALL EMGOUT (K(IZ),K(IZ),4,1,DICT,1,IPREC)
  250 INFLAG = 4
      IF (KMBGG(1) .EQ. 0) RETURN
      CALL HMAT (EID)
      K(IZ) = (AFACT*CP)*EL/2.0
      IF (K(IZ) .EQ. 0.0) RETURN
      K(IZ+1) = K(IZ)
      DICT(2) = 2
      CALL EMGOUT (K(IZ),K(IZ),2,1,DICT,3,IPREC)
      RETURN
C
  270 NOGO = .TRUE.
      WRITE  (IOUTPT,280) UFM,EID
  280 FORMAT (A23,' 3118, ROD ELEMENT NO.',I9,
     1        ' HAS ILLEGAL GEOMETRY OR CONNECTIONS.')
      RETURN
  290 NOGO = .TRUE.
      WRITE  (IOUTPT,300) UFM
  300 FORMAT (A23,' 3119, INSUFFICIENT CORE TO PROCESS ROD ELEMENTS')
      RETURN
      END

      SUBROUTINE PSBAR
C*****
C THIS ROUTINE COMPUTES THE TWO 6 X 6 MATRICES K(NPVT,NPVT) AND
C K(NPVT,J) FOR A BAR ELEMENT HAVING END POINTS NUMBERED NPVT AND J.
C*****
C
C                     E C P T  F O R  T H E  B A R
C
C ECPT( 1)  -  IELID          ELEMENT ID. NUMBER
C ECPT( 2)  -  ISILNO(2)      * SCALAR INDEX NOS. OF THE GRID POINTS
C ECPT( 3)  -    ...          *
C ECPT( 4)  -  SMALLV(3)      $ REFERENCE VECTOR
C ECPT( 5)  -    ...          $
C ECPT( 6)  -    ...          $
C ECPT( 7)  -  ICSSV          COOR. SYS. ID FOR SMALLV VECTOR
C ECPT( 8)  -  IPINFL(2)      * PIN FLAGS
C ECPT( 9)  -    ...          *
C ECPT(10)  -  ZA(3)          $ OFFSET VECTOR FOR POINT A
C ECPT(11)  -    ...          $
C ECPT(12)  -    ...          $
C ECPT(13)  -  ZB(3)          * OFFSET VECTOR FOR POINT B
C ECPT(14)  -    ...          *
C ECPT(15)  -    ...          *
C ECPT(16)  -  IMATID         MATERIAL ID.
C ECPT(17)  -  A              CROSS-SECTIONAL AREA
C ECPT(18)  -  I1             $ AREA MOMENTS OF INERTIA
C ECPT(19)  -  I2             $
C ECPT(20)  -  FJ             POLAR MOMENT OF INERTIA
C ECPT(21)  -  NSM            NON-STRUCTURAL MASS
C ECPT(22)  -  FE             FORCE ELEMENT DESCRIPTIONS (FORCE METHOD)
C ECPT(23)  -  C1             * STRESS RECOVERY COEFFICIENTS
C ECPT(24)  -  C2             *
C ECPT(25)  -  D1             *
C ECPT(26)  -  D2             *
C ECPT(27)  -  F1             *
C ECPT(28)  -  F2             *
C ECPT(29)  -  G1             *
C ECPT(30)  -  G2             *
C ECPT(31)  -  K1             $ AREA FACTORS FOR SHEAR
C ECPT(32)  -  K2             $
C ECPT(33)  -  I12            AREA MOMENT OF INERTIA
C ECPT(34)  -  MCSIDA         COOR. SYS. ID. FOR GRID POINT A
C ECPT(35)  -  GPA(3)         * BASIC COORDINATES FOR GRID POINT A
C ECPT(36)  -    ...          *
C ECPT(37)  -    ...          *
C ECPT(38)  -  MCSIDB         COOR. SYS. ID. FOR GRID POINT B
C ECPT(39)  -  GPB(3)         $ BASIC COORDINATES FOR GRID POINT B
C ECPT(40)  -    ...          $
C ECPT(41)  -    ...          $
C ECPT(42)  -  ELTEMP         AVG. ELEMENT TEMPERATURE
C ECPT(43)  -  EPSIN1         PREVIOUS STRAIN VALUE ONCE REMOVED
C ECPT(44)  -  EPSIN2         PREVIOUS STRAIN VALUE
C ECPT(45)  -  ESTAR          PREVIOUSLY COMPUTED MODULUS OF ELASTICITY
C ECPT(46)  -  V1STAR         * ELEMENT FORCES, INITIALLY ZERO
C ECPT(47)  -   V2STAR        *
C ECPT(48)  -   TSTAR         *
C ECPT(49)  -   M1ASTR        *
C ECPT(50)  -   M2ASTR        *
C ECPT(51)  -   UAIN(6)       $ INCREMENTAL DISPLACEMENT VECTOR AT PT. A
C ECPT(52)  -   ...           $
C ECPT(53)  -   ...           $
C ECPT(54)  -   ...           $
C ECPT(55)  -   ...           $
C ECPT(56)  -   ...           $
C ECPT(57)  -   UBIN(6)       * INCREMENTAL DISPLACEMENT VECTOR AT PT. B
C ECPT(58)  -   ...           *
C ECPT(59)  -   ...           *
C ECPT(60)  -   ...           *
C ECPT(61)  -   ...           *
C ECPT(62)  -   ...           *
C
      REAL
     1                   L                  ,LSQ
     2,                  LCUBE              ,I1
     3,                  I2                 ,K1
     4,                  K2                 ,KE
     5,                  KEP                ,I12
     6,                  NSM                ,LR1
     7,                  LR2                ,LB
     8,                  L2B3               ,L2B6
      REAL
     1                   M1ASTR             ,M2ASTR
     2,                  M1A                ,M2A
     3,                  M1B                ,M2B
     4,                  K1A                ,K2A
     5,                  K1B                ,K2B
      LOGICAL
     1                   ABASIC             ,BBASIC
     2,                  BASIC              ,AOFSET
     3,                  BOFSET             ,OFFSET
      DIMENSION
     1                   VECI(3)            ,VECJ(3)
     2,                  VECK(3)            ,ECPT(100)
     3,                  IECPT(100)         ,IPIN(10)
     5,                  TA(18)             ,TB(9)
     6,                  SMALV0(6)          ,U(24)
     7,                  D(9)               ,SA(72)
     8,                  SB(36)             ,FA(6)
     9,                  FB(6)
C
      COMMON   /PLA32E/
     1                   IELID              ,ISILNO(2)
     2,                  SMALLV(3)          ,ICSSV
     3,                  IPINFL(2)          ,ZA(3)
     4,                  ZB(3)              ,IMATID
     5,                  A                  ,I1
     6,                  I2                 ,FJ
     7,                  NSM                ,FE
     8,                  C1                 ,C2
     9,                  D1                 ,D2
     T,                  F1                 ,F2
     1,                  G1                 ,G2
     2,                  K1                 ,K2
     3,                  I12
     4,                  MCSIDA             ,GPA(3)
     5,                  MCSIDB             ,GPB(3)
     6,                  ELTEMP             ,EPSIN1
     7,                  EPSIN2             ,ESTAR
     8,                  V1STAR             ,V2STAR
      COMMON   /PLA32E/
     1                   TSTAR              ,M1ASTR
     2,                  M2ASTR             ,UAIN(6)
     3,                  UBIN(6)
      COMMON   /PLA32S/
     1                   KE(144)            ,KEP(144)
     2,                  DELA(6)            ,DELB(6)
      COMMON   /PLA32C/
     1                   GAMMA              ,GAMMAS
      COMMON   /SOUT/
     1                   ISELID             ,SIG1A
     2,                  SIG2A              ,SIG3A
     3,                  SIG4A              ,SIGAX
     4,                  SIGAMX             ,SIGAMN
     5,                  MSTEN              ,SIG1B
     6,                  SIG2B              ,SIG3B
     7,                  SIG4B              ,SIGBMX
     8,                  SIGBMN             ,MSCOM
     9,                  DUM14(14)
      COMMON   /MATIN/
     1                   MATIDC             ,MATFLG
     2,                  TEMDUM             ,PLAARG
     3,                  DUM2(2)
      COMMON   /MATOUT/
     1                   E SUB 0            ,G SUB 0
     2,                  NU                 ,RHO
     3,                  ALPHA              ,T SUB 0
     4,                  GSUBE              ,SIGMAT
     5,                  SIGMAC             ,SIGMAS
C
      EQUIVALENCE
     1                   (IELID,ECPT(1),IECPT(1))
     2,                  (TA(10),TB(1))
     3,                  (ECPT(71),D(1))
     4,                  (E SUB 0,PLAANS)
     5,                  (SA(37),SB(1))
     6,                  (MSTEN,SMTEN)
     7,                  (MSCOM,SMCOM)
C
C-----------------------------------------------------------------------
C
C SET UP POINTERS TO COOR. SYS. IDS., OFFSET VECTORS, AND PIN FLAGS.
C ICSIDA AND ICSIDB ARE COOR. SYS. IDS.
C
      JCSIDA = 34
      JCSIDB = 38
      JOFSTA = 10
      JOFSTB = 13
      JPINA  =  8
      JPINB  =  9
      ICSIDA = IECPT(34)
      ICSIDB = IECPT(38)
C
C NORMALIZE THE REFERENCE VECTOR WHICH LIES IN THE FIRST PRINCIPAL AXIS
C PLANE  (FMMS - 36 P. 4)
C
      FL = 0.0
      DO 50 I = 1,3
   50 FL = FL + SMALLV(I)**2
      FL = SQRT(FL)
      DO 60 I = 1,3
   60 SMALLV(I) = SMALLV(I) / FL
C
C DETERMINE IF POINT A AND B ARE IN BASIC COORDINATES OR NOT.
C
      ABASIC = .TRUE.
      BBASIC = .TRUE.
      IF (ICSIDA .NE. 0) ABASIC = .FALSE.
      IF (ICSIDB .NE. 0) BBASIC = .FALSE.
C
C COMPUTE THE TRANSFORMATION MATRICES TA AND TB IF NECESSARY
C
      IF (.NOT. ABASIC) CALL TRANSS (ECPT(JCSIDA),TA)
      IF (.NOT. BBASIC) CALL TRANSS (ECPT(JCSIDA),TB)
C
C DETERMINE IF WE HAVE NON-ZERO OFFSET VECTORS.
C
      AOFSET = .TRUE.
      J = JOFSTA - 1
      DO 70 I = 1,3
      J = J + 1
      IF (ECPT(J) .NE. 0.0) GO TO 80
   70 CONTINUE
      AOFSET = .FALSE.
   80 BOFSET = .TRUE.
      J = JOFSTB - 1
      DO 90 I = 1,3
      J = J + 1
      IF (ECPT(J) .NE. 0.0) GO TO 100
   90 CONTINUE
      BOFSET = .FALSE.
C
C FORM THE CENTER AXIS OF THE BEAM WITHOUT OFFSETS.
C
  100 VECI(1) = ECPT(JCSIDA+1) - ECPT(JCSIDB+1)
      VECI(2) = ECPT(JCSIDA+2) - ECPT(JCSIDB+2)
      VECI(3) = ECPT(JCSIDA+3) - ECPT(JCSIDB+3)
C
C TRANSFORM THE OFFSET VECTORS IF NECESSARY
C
      IF ( .NOT. AOFSET  .AND.  .NOT. BOFSET )  GO TO 150
C
C TRANSFORM THE OFFSET VECTOR FOR POINT A IF NECESSARY.
C
      IDELA = 1
      J = JOFSTA - 1
      DO 110 I = 1,3
      J = J + 1
  110 DELA(I) = ECPT(J)
      IF (ABASIC) GO TO 120
      IDELA = 4
      CALL GMMATS (TA,3,3,0, DELA(1),3,1,0, DELA(4) )
C
C TRANSFORM THE OFFSET VECTOR FOR POINT B IF NECESSARY
C
  120 IDELB = 1
      J = JOFSTB - 1
      DO 130 I = 1,3
      J = J + 1
  130 DELB(I) = ECPT(J)
      IF (BBASIC) GO TO 140
      IDELB = 4
      CALL GMMATS (TB,3,3,0, DELB(1),3,1,0, DELB(4) )
C
C SINCE THERE WAS AT LEAST ONE NON-ZERO OFFSET VECTOR RECOMPUTE VECI
C
  140 VECI(1) = VECI(1) + DELA(IDELA  ) - DELB(IDELB  )
      VECI(2) = VECI(2) + DELA(IDELA+1) - DELB(IDELB+1)
      VECI(3) = VECI(3) + DELA(IDELA+2) - DELB(IDELB+2)
C
C COMPUTE THE LENGTH OF THE BIG V (VECI) VECTOR AND NORMALIZE
C
  150 VECI(1) = -VECI(1)
      VECI(2) = -VECI(2)
      VECI(3) = -VECI(3)
      FL = SQRT (VECI(1)**2  +  VECI(2)**2  +  VECI(3)**2)
      DO 160 I = 1,3
  160 VECI(I) = VECI(I) / FL
C
C COMPUTE THE SMALL V SUB 0 VECTOR, SMALV0.  ****CHECK THIS LOGIC****
C
      DO 165 I = 1,3
  165 SMALV0(I) = SMALLV(I)
      ISV = 1
      IF (ICSSV .EQ. 0) GO TO 180
      ISV = 4
      CALL GMMATS (TA,3,3,0, SMALV0(1),3,1,0, SMALV0(4) )
C
C COMPUTE THE K VECTOR, VECK = VECI  X  SMALV0, AND NORMALIZE
C
  180 VECK(1) =  VECI(2) * SMALV0(ISV+2)  -  VECI(3) * SMALV0(ISV+1)
      VECK(2) =  VECI(3) * SMALV0(ISV  )  -  VECI(1) * SMALV0(ISV+2)
      VECK(3) =  VECI(1) * SMALV0(ISV+1)  -  VECI(2) * SMALV0(ISV)
      FLL     =  SQRT ( VECK(1)**2  +  VECK(2)**2  +  VECK(3)**2  )
      VECK(1) =  VECK(1) / FLL
      VECK(2) =  VECK(2) / FLL
      VECK(3) =  VECK(3) / FLL
C
C COMPUTE THE J VECTOR, VECJ = VECK  X  VECI, AND NORMALIZE
C
      VECJ(1) =  VECK(2) * VECI(3)  -  VECK(3) * VECI(2)
      VECJ(2) =  VECK(3) * VECI(1)  -  VECK(1) * VECI(3)
      VECJ(3) =  VECK(1) * VECI(2)  -  VECK(2) * VECI(1)
      FLL     =  SQRT ( VECJ(1)**2  +  VECJ(2)**2  +  VECJ(3)**2 )
      VECJ(1) =  VECJ(1) / FLL
      VECJ(2) =  VECJ(2) / FLL
      VECJ(3) =  VECJ(3) / FLL
C
C SET UP INTERMEDIATE VARIABLES FOR ELEMENT STIFFNESS MATRIX CALCULATION
C
      L = FL
      LSQ = L**2
      LCUBE = LSQ * L
C
C STORE INCREMENTAL DISPLACEMENT VECTORS IN DOUBLE PRECISION LOCATIONS
C
      DO 182 I = 1,6
      U(I)    = UAIN(I)
  182 U(I+12) = UBIN(I)
C*****
C COMPUTE ON FIRST PASS C  * E  * U   AND C  * E  * U  ON SECOND PASS
C                        B    B    B       A    A    A
C*****
      IPASS = 1
      BASIC = BBASIC
      OFFSET = BOFSET
      JOFSET = JOFSTB
      JCSID = 10
      INDEX = 13
C
C IF THERE ARE OFFSETS FOR THIS POINT, CONSTRUCT THE 3 X 3 MATRIX D.
C
  184 IF (.NOT. OFFSET) GO TO 188
      D(1) = 0.0
      D(2) =  ECPT(JOFSET+2)
      D(3) = -ECPT(JOFSET+1)
      D(4) = -D(2)
      D(5) = 0.0
      D(6) =  ECPT(JOFSET)
      D(7) = -D(3)
      D(8) = -D(6)
      D(9) = 0.0
C
C COMPUTE THE 3 VECTOR  D * U , WHERE U  IS THE VECTOR OF THE 3
C                            R         R
C ROTATIONAL DISPLACEMENTS
C
      CALL GMMATS (D,3,3,0, U(INDEX+3),3,1,0, U(INDEX+6))
C
C ADD OFFSET CONTRIBUTION TO THE TRANSLATION COMPONENTS OF THE DISPLACE-
C MENT VECTOR
C
      J = INDEX
      DO 186 I = 1,3
      U(J) = U(J) + U(J+6)
  186 J = J + 1
C
C TRANSFORM TRANSLATIONAL COMPONENTS TO BASIC COORDINATES IF NECESSARY
C
  188 IF (BASIC) GO TO 190
      CALL GMMATS (TA(JCSID),3,3,0, U(INDEX),3,1,0, U(INDEX+3) )
C
C STORE TRANSFORMED VECTOR BACK INTO ITS ORIGINAL D.P. LOCATION
C
      U(INDEX  ) = U(INDEX+3)
      U(INDEX+1) = U(INDEX+4)
      U(INDEX+2) = U(INDEX+5)
  190 IF (IPASS .EQ. 2) GO TO 192
      IPASS = 2
      BASIC  = ABASIC
      OFFSET = AOFSET
      JOFSET = JOFSTA
      JCSID  = 1
      INDEX  = 1
      GO TO 184
C
C FORM THE DIFFERENCE OF THE TRANSLATIONAL COMPONENTS OF THE TRANSFORMED
C DISPLACEMENT VECTORS
C
  192 DO 194 I = 1,3
  194 U(I+12) = U(I+12) - U(I)
C
C FORM DOT PRODUCT
C
      CALL GMMATS (VECI,3,1,1, U(13),3,1,0, D(1) )
C
C CALCULATE THE INCREMENTAL ELEMENT STRAIN
C
      DEPS1 = D(1) / L
C
C PERFORM EXTENSIONAL STRAIN CALCULATIONS
C
      DEPS2  = EPSIN2 - EPSIN1
      EPS1   = EPSIN2 + DEPS1
      EPS2 = EPSIN2 + (DEPS1 + GAMMAS**2 * DEPS2)* (GAMMA + 1.0E0)
     1                /(GAMMAS + 1.0E0)
     2              + GAMMAS * (DEPS1 - GAMMAS*DEPS2) * (GAMMA+1.0E0)**2
     3                /(GAMMAS + 1.0E0)
C
C CALL MAT ROUTINE TO GET SIGMA1 AND SIGMA2 AS FUNCTIONS OF EPS1,EPS2
C
      MATIDC = IMATID
      MATFLG = 1
      CALL MAT (IECPT(1))
      E SUB 0 L = E SUB 0
      G SUB 0 L = G SUB 0
      MATFLG = 6
      PLAARG = EPS1
      CALL MAT (IECPT(1))
      SIGMA1 = PLAANS
      PLAARG = EPS2
      CALL MAT (IECPT(1))
      SIGMA2 = PLAANS
C
C NOTE THAT E1 IS USED IN THIS ROUTINE ONLY TO UPDATE THE EST (ECPT)
C ENTRY
C
      IF (EPS1 .EQ. EPS2) GO TO 200
      E1 = (SIGMA2 - SIGMA1) / (EPS2 - EPS1)
      GO TO 202
  200 E1 = ESTAR
C
C BEGIN ELEMENT STRESS MATRIX CALCULATIONS.
C
  202 E = ESTAR
      G = ESTAR * G SUB 0 L / E SUB 0 L
      EI1  = E * I1
      EI2  = E * I2
      IF (K1 .EQ. 0.0  .OR.  I12 .NE. 0.0) GO TO 210
      GAK1 = G * A * K1
      R1 = (12.0 * EI1 * GAK1) / (GAK1 * LCUBE + 12.0 * L * EI1)
      GO TO 220
  210 R1 =  12.0 * EI1 / LCUBE
  220 IF (K2 .EQ. 0.0  .OR.  I12 .NE. 0.0) GO TO 230
      GAK2 = G * A * K2
      R2 = (12.0 * EI2 * GAK2) / (GAK2 * LCUBE + 12.0 * L * EI2)
      GO TO 240
  230 R2 =  12.0 * EI2 / LCUBE
C
C COMPUTE THE -SMALL- K-S, SK1, SK2, SK3 AND SK4
C
  240 SK1 = 0.25 * R1 * LSQ  +  EI1 / L
      SK2 = 0.25 * R2 * LSQ  +  EI2 / L
      SK3 = 0.25 * R1 * LSQ  -  EI1 / L
      SK4 = 0.25 * R2 * LSQ  -  EI2 / L
C
C COMPUTE THE TERMS THAT WILL BE NEEDED FOR THE 12 X 12 MATRIX KE
C
      AEL = A * E / L
      LR1 = L * R1 / 2.0
      LR2 = L * R2 / 2.0
      GJL = G * FJ / L
C
C CONSTRUCT THE 12 X 12 MATRIX KE
C
      DO 250 I = 1,144
  250 KE(I) = 0.0
      KE(  1) =  AEL
      KE(  7) = -AEL
      KE( 14) =  R1
      KE( 18) =  LR1
      KE( 20) = -R1
      KE( 24) =  LR1
      KE( 27) =  R2
      KE( 29) = -LR2
      KE( 33) = -R2
      KE( 35) = -LR2
      KE( 40) =  GJL
      KE( 46) = -GJL
      KE( 51) = -LR2
      KE( 53) =  SK2
      KE( 57) =  LR2
      KE( 59) =  SK4
      KE( 62) =  LR1
      KE( 66) =  SK1
      KE( 68) = -LR1
      KE( 72) =  SK3
      KE( 73) = -AEL
      KE( 79) =  AEL
      KE( 86) = -R1
      KE( 90) = -LR1
      KE( 92) =  R1
      KE( 96) = -LR1
      KE( 99) = -R2
      KE(101) =  LR2
      KE(105) =  R2
      KE(107) =  LR2
      KE(112) = -GJL
      KE(118) =  GJL
      KE(123) = -LR2
      KE(125) =  SK4
      KE(129) =  LR2
      KE(131) =  SK2
      KE(134) =  LR1
      KE(138) =  SK3
      KE(140) = -LR1
      KE(144) =  SK1
      IF (I12 .EQ. 0.0) GO TO 255
      BETA = 12.0 * E * I12 / LCUBE
      LB   = L * BETA / 2.0
      L2B3 = LSQ * BETA / 3.0
      L2B6 = LSQ * BETA / 6.0
      KE( 15) =  BETA
      KE( 17) = -LB
      KE( 21) = -BETA
      KE( 23) = -LB
      KE( 26) =  BETA
      KE( 30) =  LB
      KE( 32) = -BETA
      KE( 36) =  LB
      KE( 50) = -LB
      KE( 54) = -L2B3
      KE( 56) =  LB
      KE( 60) = -L2B6
      KE( 63) =  LB
      KE( 65) = -L2B3
      KE( 69) = -LB
      KE( 71) = -L2B6
      KE( 87) = -BETA
      KE( 89) =  LB
      KE( 93) =  BETA
      KE( 95) =  LB
      KE( 98) = -BETA
      KE(102) = -LB
      KE(104) =  BETA
      KE(108) = -LB
      KE(122) = -LB
      KE(126) = -L2B6
      KE(128) =  LB
      KE(132) = -L2B3
      KE(135) =  LB
      KE(137) = -L2B6
      KE(141) = -LB
      KE(143) = -L2B3
C
C DETERMINE IF THERE ARE NON-ZERO PIN FLAGS.
C
  255 KA = IECPT(JPINA)
      KB = IECPT(JPINB)
      IF (KA .EQ. 0  .AND.  KB .EQ. 0) GO TO 325
C
C SET UP THE IPIN ARRAY
C
      DO 260 I = 1,5
      IPIN(I  ) = MOD(KA,10)
      IPIN(I+5) = MOD(KB,10) + 6
      IF (IPIN(I+5) .EQ. 6) IPIN(I+5) = 0
      KA = KA / 10
  260 KB = KB / 10
C
C ALTER KE MATRIX DUE TO PIN FLAGS.
C
      DO 320 I = 1,10
      IF (IPIN(I) .EQ. 0) GO TO 320
      II = 13 * IPIN(I)  -  12
      IF (KE(II) .NE. 0.0) GO TO 280
      IL = IPIN(I)
      II = II - IL
      DO 270 J = 1,12
      II = II + 1
      KE(II) = 0.0
      KE(IL) = 0.0
      IL = IL + 12
  270 CONTINUE
      GO TO 320
  280 DO 300 J = 1,12
      JI  = 12 * (J-1) + IPIN(I)
      IJ = 12 * (IPIN(I) - 1) + J
      DO 290 LL = 1,12
      JLL = 12 * (J-1) + LL
      ILL = 12 * (IPIN(I) - 1) + LL
      KEP(JLL) = KE(JLL) - (KE(ILL)/KE(II)) * KE(JI)
  290 CONTINUE
      KEP(IJ) = 0.0
      KEP(JI) = 0.0
  300 CONTINUE
      DO 310 K = 1,144
  310 KE(K) = KEP(K)
  320 CONTINUE
C
C        E
C STORE K   IN KEP(1),...,KEP(36) AND
C        AA
C
C        E
C STORE K   IN KEP(37),...,KEP(72)
C        AB
C
  325 J = 0
      DO 340 I = 1,72,12
      LOW = I
      LIM = LOW + 5
      DO 330 K = LOW,LIM
      J = J + 1
      KEP(J) = KE(K)
  330 KEP(J+36) = KE(K+6)
  340 CONTINUE
C
C                                                        T
C STORE VECI, VECJ, VECK IN KE(1),...,KE(9) FORMING THE A  MATRIX.
C
      KE(1) = VECI(1)
      KE(2) = VECI(2)
      KE(3) = VECI(3)
      KE(4) = VECJ(1)
      KE(5) = VECJ(2)
      KE(6) = VECJ(3)
      KE(7) = VECK(1)
      KE(8) = VECK(2)
      KE(9) = VECK(3)
C
C SET POINTERS SO THAT WE WILL BE WORKING WITH POINT A.
C
      BASIC = ABASIC
      JCSID  = JCSIDA
      OFFSET = AOFSET
      JOFSET = JOFSTA
      IWBEG  = 0
      IKEL   = 1
      IAB = 1
      INDEX = ISILNO(1)
C
C ZERO OUT THE ARRAY WHERE THE 3 X 3 MATRIX AND THE W  AND W  6 X 6
C MATRICES WILL RESIDE.                              A      B
C
      DO 350 I = 28,108
  350 KE(I) = 0.0
C
C SET UP THE -G- MATRIX.  IG POINTS TO THE BEGINNING OF THE G MATRIX.
C G = AT X TI
C
  360 IG = 1
      IF (BASIC) GO TO 370
      CALL TRANSS (ECPT(JCSID),KE(10))
      CALL GMMATS (KE(1),3,3,0, KE(10),3,3,0, KE(19) )
      IG = 19
C
C IF THERE IS A NON-ZERO OFFSET FOR THE POINT, SET UP THE D 3 X3 MATRIX.
C
  370 IF ( .NOT. OFFSET ) GO TO 380
      KE(10) = 0.0
      KE(11) =  ECPT(JOFSET+2)
      KE(12) = -ECPT(JOFSET+1)
      KE(13) = -KE(11)
      KE(14) = 0.0
      KE(15) =  ECPT(JOFSET)
      KE(16) = -KE(12)
      KE(17) = -KE(15)
      KE(18) = 0.0
C
C FORM THE 3 X 3 PRODUCT H = G X D, I.E., KE(28) = KE(IG) X KE(10)
C
      CALL GMMATS (KE(IG),3,3,0, KE(10),3,3,0, KE(28) )
C
C
C FORM THE W  MATRIX OR THE W  MATRIX IN KE(37) OR KE(73) DEPENDING
C           A                B
C UPON WHICH POINT - A OR B - IS UNDER CONSIDERATION.  G WILL BE STORED
C IN THE UPPER LEFT AND LOWER RIGHT CORNERS.  H, IF NON-ZERO, WILL BE
C STORED IN THE UPPER RIGHT CORNER.
C
C
  380 KE(IWBEG+37) = KE(IG  )
      KE(IWBEG+38) = KE(IG+1)
      KE(IWBEG+39) = KE(IG+2)
      KE(IWBEG+43) = KE(IG+3)
      KE(IWBEG+44) = KE(IG+4)
      KE(IWBEG+45) = KE(IG+5)
      KE(IWBEG+49) = KE(IG+6)
      KE(IWBEG+50) = KE(IG+7)
      KE(IWBEG+51) = KE(IG+8)
      KE(IWBEG+58) = KE(IG  )
      KE(IWBEG+59) = KE(IG+1)
      KE(IWBEG+60) = KE(IG+2)
      KE(IWBEG+64) = KE(IG+3)
      KE(IWBEG+65) = KE(IG+4)
      KE(IWBEG+66) = KE(IG+5)
      KE(IWBEG+70) = KE(IG+6)
      KE(IWBEG+71) = KE(IG+7)
      KE(IWBEG+72) = KE(IG+8)
      IF ( .NOT. OFFSET ) GO TO 390
      KE(IWBEG+40) = KE(28)
      KE(IWBEG+41) = KE(29)
      KE(IWBEG+42) = KE(30)
      KE(IWBEG+46) = KE(31)
      KE(IWBEG+47) = KE(32)
      KE(IWBEG+48) = KE(33)
      KE(IWBEG+52) = KE(34)
      KE(IWBEG+53) = KE(35)
      KE(IWBEG+54) = KE(36)
C
C                          E                      E
C FORM THE PRODUCT  S  =  K    X  W   OR  S   = K    X  W  , DEPENDING
C                    A     AA      A       B     AB      B
C UPON WHICH POINT WE ARE WORKING WITH.
C
  390 CALL GMMATS (KEP(IKEL),6,6,0, KE(IWBEG+37),6,6,0, SA(IAB) )
C
C IF THE POINT UNDER CONSIDERATION IS POINT B WE ARE FINISHED.  IF NOT,
C SET UP POINTS AND INDICATORS FOR WORKING WITH POINT B.
C
      IF (IWBEG .EQ. 36) GO TO 500
      BASIC = BBASIC
      JCSID = JCSIDB
      OFFSET = BOFSET
      JOFSET = JOFSTB
      IWBEG  = 36
      IKEL   = 37
      IAB = 37
      INDEX  = ISILNO(2)
      DO 400 I = 28,36
  400 KE(I) = 0.0
      GO TO 360
C
C COMPUTE FORCES AND MOMENTS FROM  S   AND   S   AND DISPLACEMENT
C                                   A         B
C VECTORS
C
  500 CALL GMMATS (SA,6,6,0, UAIN,6,1,0, FA)
      CALL GMMATS (SB,6,6,0, UBIN,6,1,0, FB)
      FX = A * SIGMA1
      V1  = -FA(2) - FB(2) + V1STAR
      V2  = -FA(3) - FB(3) + V2STAR
      T   = -FA(4) - FB(4) + TSTAR
      M2A =  FA(5) + FB(5) + M2ASTR
      M1A = -FA(6) - FB(6) + M1ASTR
      M1B = M1A - V1*L
      M2B = M2A - V2*L
C*****
C COMPUTE ELEMENT STRESSES AT 4 POINTS
C*****
C
C COMPUTE K1A AND K2A
C
      IF (I12 .NE. 0.0) GO TO 530
      IF (I1 .NE. 0.0) GO TO 520
      K1A = 0.0
      GO TO 540
  520 K1A = -M1A / I1
      GO TO 540
  530 K1A = (M2A * I12  -  M1A * I2) / (I1 * I2  -  I12**2)
      K2A = (M1A * I12  -  M2A * I1) / (I1 * I2  -  I12**2)
      GO TO 560
  540 IF (I2 .NE. 0.0) GO TO 550
      K2A = 0.0
      GO TO 560
  550 K2A = -M2A / I2
C
C COMPUTE SIG1A, SIG2A, SIG3A AND SIG4A
C
  560 SIG1A = K1A * C1  +  K2A * C2
      SIG2A = K1A * D1  +  K2A * D2
      SIG3A = K1A * F1  +  K2A * F2
      SIG4A = K1A * G1  +  K2A * G2
C
C COMPUTE K1B AND K2B
C
      IF (I12 .NE. 0.0) GO TO 580
      IF (I1 .NE. 0.0) GO TO 570
      K1B = 0.0
      GO TO 590
  570 K1B = -M1B / I1
      GO TO 590
  580 K1B = (M2B * I12  -  M1B * I2) / (I1 * I2  -  I12**2)
      K2B = (M1B * I12  -  M2B * I1) / (I1 * I2  -  I12**2)
      GO TO 610
  590 IF (I2 .NE. 0.0) GO TO 600
      K2B = 0.0
      GO TO 610
  600 K2B = -M2B / I2
C
C COMPUTE SIG1B, SIG2B, SIG3B AND SIG4B
C
  610 SIG1B = K1B * C1  +  K2B * C2
      SIG2B = K1B * D1  +  K2B * D2
      SIG3B = K1B * F1  +  K2B * F2
      SIG4B = K1B * G1  +  K2B * G2
C
C COMPUTE AXIAL STRESS
C
      SIGAX = 0.0
      IF (A .NE. 0.0) SIGAX = FX / A
C
C COMPUTE MAXIMA AND MINIMA
C
      SIGAMX = SIGAX + AMAX1(SIG1A,SIG2A,SIG3A,SIG4A)
      SIGBMX = SIGAX + AMAX1(SIG1B,SIG2B,SIG3B,SIG4B)
      SIGAMN = SIGAX + AMIN1(SIG1A,SIG2A,SIG3A,SIG4A)
      SIGBMN = SIGAX + AMIN1(SIG1B,SIG2B,SIG3B,SIG4B)
C
C COMPUTE MARGIN OF SAFETY IN TENSION
C
      IF(SIGMAT.LE.0.0)GO TO 620
      IF(AMAX1(SIGAMX,SIGBMX).LE.0.0) GO TO 620
      Q=SIGMAT/AMAX1(SIGAMX,SIGBMX)
      SMTEN=Q-1.0
      GO TO 630
  620 MSTEN=1
C
C      COMPUTE MARGIN OF SAFETY IN COMPRESSION
C
  630 SIGMAC=-ABS(SIGMAC)
      IF(AMIN1(SIGAMN,SIGBMN).GE.0.0) GO TO 640
      W=SIGMAC/AMIN1(SIGAMN,SIGBMN)
      SMCOM=W-1.0
      GO TO 650
  640 MSCOM=1
  650 ISELID = IELID
C
C UPDATE EST (ECPT) ENTRIES
C
      EPSIN1 = EPSIN2
      EPSIN2 = EPS1
      ESTAR  = E1
      V1STAR = V1
      V2STAR = V2
      TSTAR  = T
      M1ASTR = M1A
      M2ASTR = M2A
      RETURN
      END

      SUBROUTINE BPACK (IG,I,J,L)
C
      IMPLICIT INTEGER (A-Z)
C
CDC   NEXT 2 LINES FOR CDC AND UNIVAC ONLY
C     EXTERNAL         ORF,      LSHIFT
C     INTEGER          IG(1)
C
C     NEXT LINE FOR IBM, VAX, AND MACHINES THAT HAVE INTEGER*2
      INTEGER*2        IG(1)
C
      COMMON /BANDB /  NBIT,     DUM3B(3), IPASS,    NW,       DUM1B,
     1                 NBPW
      COMMON /BANDS /  DUM4S(4), II1,      DUM5S(5), MASK
C
C     THIS ROUTINE IS USED ONLY IN BANDIT MODULE
C
C     PACK INTERNAL GRID NO. INTO IG TABLE.  SEE BUNPK FOR UNPACKING
C     TABLE IG IS PACKED COLUMN-WISE.
C     USE APPROP. PORTION OF THIS ROUTINE FOR DIFFERENT TYPE OF MACHINE.
C     IPASS=COUNTER ON NUMBER OF CALLS TO PACK/UNPACK
C
C     NOTE - THIS ROUTINE DOES NOT CHECK NOR ZERO OUT THE PACKING SLOT
C            BEFORE PACKING.
C            L IS ASSUMED TO BE A POSITIVE INTEGER, NBIT BITS OR LESS
C
      IPASS=IPASS+1
      LOC  =J-1
C
C     ********************************************
C     UNIVAC AND CDC MACHINES
C     (IG SHOULD BE IN INTEGER*4 HERE)
C     ********************************************
C
C     N1 =II1*(LOC/NW)+I
C     N2 =MOD(LOC,NW)*NBIT+NBIT
C     LOC=ORF(IG(N1),LSHIFT(L,NBPW-N2))
C     IG(N1)=LOC
C
C     RETURN
C
C     ********************************************
C     IBM AND VAX MACHINES
C     (IG IS SET TO INTEGER*2 IN BPACK AND BUNPK, ELSEWHERE INTEGER*4)
C     INTEGER*2     IG(1)
C     ********************************************
C
      N1=II1*LOC+I
      IG(N1)=L
      RETURN
      END

      SUBROUTINE INCRO (AX,AY,AZ,AX1,AY1,AZ1,AX2,AY2,AZ2,SGR,CGR,SGS,
     1                  CGS,KR,FL,BETA,SDELX,DELY,DELR,DELI)
C
C     CALCULATES THE UNSTEADY PART OF THE INFLUENCE COEFFICIENT MATRIX
C     ELEMENTS USING  SUBROUTINES  KERNEL, IDF1  AND  IDF2
C
      REAL         K10,K20,K1RT1,K1IT1,K2RT2P,K2IT2P,K10T1,K20T2P,KR,M
      COMMON /DLM/ K10,K20,K1RT1,K1IT1,K2RT2P,K2IT2P,K10T1,K20T2P
      COMMON /KDS/ IND
C
C     DKRO = REAL PART OF THE PLANAR KERNEL  *  OUTBOARD POINT
C     DKIO = IMAGINARY PART OF THE PLANAR KERNEL  *  OUTBOARD POINT
C     XKRO = REAL PART OF THE NONPLANAR KERNEL  *  OUTBOARD POINT
C     XKIO = IMAGINARY PART OF THE NONPLANAR KERNEL  *  OUTBOARD POINT
C     DKRI = REAL PART OF THE PLANAR KERNEL  *   INBOARD POINT
C     DKII = IMAGINARY PART OF THE PLANAR KERNEL  *   INBOARD POINT
C     XKRI = REAL PART OF THE NONPLANAR KERNEL  *   INBOARD POINT
C     XKII = IMAGINARY PART OF THE NONPLANAR KERNEL  *   INBOARD POINT
C
      IND   = 1
      M     = SQRT(1.0 - BETA**2)
      BR    = FL/2.
      EPS   = 0.00001
      PI    = 3.14159265
      XDELX = SDELX
      XDELY = DELY
      EE    = 0.5*XDELY
      E2    = EE**2
      DELR  = 0.0
      DELI  = 0.0
      AT1S  = 0.0
      AT2S  = 0.0
      T1    = 0.0
      T2    = 0.0
      COUNT = 0.
      X0    = AX
      Y0    = AY
      Z0    = AZ
   80 CONTINUE
      CALL TKER (X0,Y0,Z0,KR,BR,SGR,CGR,SGS,CGS,T1,T2,M)
      AT1   = ABS(T1)
      AT2   = ABS(T2)
      IF (AT1 .GT. AT1S) AT1S = AT1
      IF (AT2 .GT. AT2S) AT2S = AT2
      IF (COUNT) 130,90,150
   90 DKRC  = K1RT1 - K10T1
      DKIC  = K1IT1
      XKRC  = K2RT2P - K20T2P
      XKIC  = K2IT2P
      AT2   = ABS(T2)
      COUNT = -1.
      X0    = AX1
      Y0    = AY1
      Z0    = AZ1
      GO TO 80
  130 DKRI  = K1RT1 - K10T1
      DKII  = K1IT1
      XKRI  = K2RT2P - K20T2P
      XKII  = K2IT2P
      COUNT = 1.
      X0    = AX2
      Y0    = AY2
      Z0    = AZ2
      GO TO 80
  150 DKRO  = K1RT1 - K10T1
      DKIO  = K1IT1
      XKRO  = K2RT2P - K20T2P
      XKIO  = K2IT2P
      X0    = AX
      Y0    = AY
      Z0    = AZ
      ZERO  = 0.0
      XIIJR = 0.
      XIIJI = 0.
      DIIJR = 0.0
      DIIJI = 0.0
      XMULT = XDELX/(8.0*PI)
      IF (Y0.EQ.ZERO .AND.  Z0.EQ.ZERO) GO TO 220
      IF (Z0.EQ.ZERO .AND. SGS.EQ.ZERO) GO TO 230
      ETA01 = Y0*CGS + Z0*SGS
      ZET01 =-Y0*SGS + Z0*CGS
      AZET0 = ABS(ZET01)
      IF (AZET0 .LE. 0.0001) ZET01 = 0.
      R1SQX = ETA01**2 + ZET01**2
  210 ARE   = (DKRI - 2.*DKRC + DKRO)/(2.0*E2)
      AIM   = (DKII - 2.*DKIC + DKIO)/(2.0*E2)
      BRE   = (DKRO - DKRI)/(2.0*EE)
      BIM   = (DKIO - DKII)/(2.0*EE)
      CRE   =  DKRC
      CIM   =  DKIC
      GO TO 250
  220 ETA01 = 0.0
      ZET01 = 0.0
      R1SQX = 0.0
      GO TO  210
  230 ETA01 = Y0*CGS
      ZET01 = 0.
      R1SQX = ETA01**2
      GO TO  210
  250 CONTINUE
      IF (AT1S .EQ. 0.0) GO TO 255
      CALL IDF1 (EE,E2,ETA01,ZET01,ARE,AIM,BRE,BIM,CRE,CIM,R1SQX,XIIJR,
     1           XIIJI)
      DELR  = XMULT*XIIJR
      DELI  = XMULT*XIIJI
  255 CONTINUE
      IF (AT2S .EQ. 0.0) GO TO 260
      A2R   = (XKRI - 2.0*XKRC + XKRO)/(2.0*E2)
      A2I   = (XKII - 2.0*XKIC + XKIO)/(2.0*E2)
      B2R   = (XKRO - XKRI)/(2.0*EE)
      B2I   = (XKIO - XKII)/(2.0*EE)
      C2R   =  XKRC
      C2I   =  XKIC
      CALL IDF2 (EE,E2,ETA01,ZET01,A2R,A2I,B2R,B2I,C2R,C2I,R1SQX,DIIJR,
     1           DIIJI)
      DELR  = DELR + XMULT*DIIJR
      DELI  = DELI + XMULT*DIIJI
  260 CONTINUE
C
      RETURN
      END

      SUBROUTINE CMTOC
C
C     THIS SUBROUTINE GENERATES A TABLE OF CONTENTS FOR A COMBINE
C     OPERATION. FOR EACH PSEUDO-STRUCTURE IT LISTS THE NAME, NUMBER
C     OF COMPONENTS, AND EACH COMPONENT BASIC SUBSTRUCTURE NAME.
C     THIS DATA IS THEN WRITTEN ON SCRATCH FILE SCTOC.
C
      EXTERNAL        RSHIFT,ANDF
      LOGICAL         PRINT,TOCOPN
      INTEGER         SCTOC,BUF5,COMBO,NAME(2),Z,SCORE,AAA(2),OUTT,
     1                IHED(96),XXX,ANDF,RSHIFT
      COMMON /CMB001/ SCR1,SCR2,SCBDAT,SCSFIL,SCCONN,SCMCON,SCTOC,
     1                GEOM4,CASECC
      COMMON /CMB002/ BUF1,BUF2,BUF3,BUF4,BUF5,SCORE,LCORE,INPT,OUTT
      COMMON /CMB003/ COMBO(7,5),CONSET,IAUTO,TOLER,NPSUB,CONECT,TRAN,
     1                MCON,RESTCT(7,7),ISORT,ORIGIN(7,3),IPRINT,TOCOPN
      COMMON /ZZZZZZ/ Z(1)
      COMMON /OUTPUT/ ITITL(96),IHDR(96)
      COMMON /SYSTEM/ XXX
      DATA    IHED  / 7*4H     ,
     1        4HP S , 4HE U , 4HD O , 4HS T , 4HR U , 4HC T , 4HU R ,
     2        4HE   , 4HT A , 4HB L , 4HE   , 4HO F , 4H  C , 4HO N ,
     3        4HT E , 4HN T , 4HS   , 15*4H         ,
     4        4H PSE, 4HUDO-, 4H    , 4H   N, 4HO. O, 4HF   ,26*2H  ,
     5        4HSTRU, 4HCTUR, 4HE   , 4H COM, 4HPONE, 4HNTS , 4H   -,
     6        4H----, 4H----, 4H- CO, 4HMPON, 4HENT , 4HNAME, 4HS --,
     7        4H----, 4H----, 4H-   , 8*4H     /
      DATA    AAA   / 4HCMTO, 4HC   /
      DATA    NHEQSS/ 4HEQSS/
C
      PRINT = .FALSE.
      IF (ANDF(RSHIFT(IPRINT,1),1) .EQ. 1) PRINT = .TRUE.
      TOCOPN = .TRUE.
      ITOT = 0
      DO 20 I = 1,96
      IHDR(I) = IHED(I)
   20 CONTINUE
      IF (PRINT) CALL PAGE
      CALL OPEN (*60,SCTOC,Z(BUF5),1)
      DO 50 I = 1,NPSUB
      NAME(1) = COMBO(I,1)
      NAME(2) = COMBO(I,2)
      CALL SFETCH (NAME,NHEQSS,1,ITEST)
      CALL SUREAD (Z(SCORE),-1,NWDS,ITEST)
      Z(SCORE  ) = NAME(1)
      Z(SCORE+1) = NAME(2)
      CALL WRITE (SCTOC,Z(SCORE),3,0)
      ITOT = ITOT + 3
      IA   = SCORE
      IB   = SCORE+2
      IF (PRINT) WRITE(OUTT,30) (Z(KDH),KDH=IA,IB)
   30 FORMAT (34X,2A4,6X,I4)
      COMBO(I,5) = Z(SCORE+2)
      NWDS = NWDS - 4
      IA   = SCORE+4
      IB   = IA+NWDS-1
      NT   = (IB - IA + 1)/8
      IF (NT .EQ. 0) NT = 1
      IF (PRINT) CALL PAGE2 (NT)
      IF (PRINT) WRITE (OUTT,40) (Z(KDH),KDH=IA,IB)
      ITOT = ITOT + NWDS
   40 FORMAT (1H+,57X,2X,2A4,2X,2A4,2X,2A4,2X,2A4,/
     1       (58X,2X,2A4,2X,2A4,2X,2A4,2X,2A4))
      CALL WRITE (SCTOC,Z(SCORE+4),NWDS,1)
   50 CONTINUE
      CALL CLOSE (SCTOC,1)
      CALL OPEN (*60,SCTOC,Z(BUF5),0)
C
C     DETERMINE WHETHER TO CLOSE FILE
C
      IF (ITOT .LE. XXX) RETURN
      TOCOPN = .FALSE.
      CALL CLOSE (SCTOC,1)
      RETURN
C
   60 CALL MESAGE (-1,SCTOC,AAA)
      RETURN
      END

      SUBROUTINE SUMM(SUM,ISUM,TERM1,ITERM1,TERM2,ITERM2,N)
C
      DOUBLE PRECISION SUM,TERM1,TERM2,TEMP1,TEMP2
      DOUBLE PRECISION FACTOR
C
      IF (TERM1.EQ.0.0D0) GO TO 30
      IF (TERM2.EQ.0.0D0) GO TO 40
      TEMP1 = TERM1
      TEMP2 = TERM2
      ISAVE = ITERM1
      IF(ITERM1 .EQ. ITERM2) GO TO 50
      MULT = IABS (ITERM1 - ITERM2)
CDVAX TEST TO PREVENT FLOATING PT OVFLOW IF EXPONENT DIFF TOO LARGE
      IF(MULT.GT.37 .AND. ITERM1.GT.ITERM2) GO TO 40
      IF(MULT.GT.37 .AND. ITERM2.GT.ITERM1) GO TO 30
      FACTOR = 10.0D0**MULT
      IF(ITERM1 .GT. ITERM2) GO TO 20
      TEMP1 = TERM1/FACTOR
      ISAVE = ITERM2
      GO TO 50
   20 TEMP2 = TERM2/FACTOR
      GO TO 50
   30 IF(N .NE. 1) GO TO 35
      SUM = TERM2
   31 ISUM = ITERM2
      GO TO 70
   35 SUM = -TERM2
      GO TO 31
   40 SUM = TERM1
      ISUM = ITERM1
      GO TO 70
   50 IF(N .NE. 1) GO TO 60
      SUM = TEMP1+TEMP2
      ISUM = ISAVE
      GO TO 70
   60 SUM = TEMP1-TEMP2
      ISUM = ISAVE
   70 IF (SUM.EQ.0.0D0) ISUM = 0
      RETURN
      END

      SUBROUTINE ORTCK (X,MASS,IBUF,NUM,NDIM,GM,ACCUM,EPS)
C
C     ORTCK WILL GENERATE THE GENERALIZED MASS MATRIX FOR CLOSE ROOTS
C     AND MAKE THE EPSILON TEST TO DETERMINE IF THE VECTORS SHOULD BE
C     ORTHOGONALIZED
C
      DOUBLE PRECISION   ACCUM(1)
      DIMENSION          IBUF(1)   ,X(NDIM,1),GM(NUM,1),IM(7)
C     COMMON   /DESCRP/  LENGTH    ,MAJOR(1)
      COMMON   /ZNTPKX/  Z(4)      ,II       ,IEOL
      COMMON   /NAMES /  RD        ,RDREW    ,WRT      ,WRTREW   ,
     1                   REW       ,NOREW    ,EOFNRW   ,RSP
C
      IDEN  = 0
      IM(1) = MASS
      CALL RDTRL (IM)
      IF (IM(4) .EQ. 8) IDEN = 1
      IF (IDEN  .EQ. 1) GO TO 10
      CALL GOPEN (MASS,IBUF,0)
   10 K = 1
   20 DO 30 I = 1,NUM
      DO 30 J = 1,NUM
   30 GM(I,J) = 0.
      DO 110 I = 1,NDIM
      DO 40 J = 1,NUM
   40 ACCUM(J) = 0.D0
      IF (IDEN .EQ. 1) GO TO 80
      CALL INTPK (*110,MASS,0,RSP,0)
   50 IF (IEOL .EQ. 1)GO TO 90
      CALL ZNTPKI
   60 DO 70 J = 1,NUM
   70 ACCUM(J) = ACCUM(J) + Z(1)*X(II,J)
      GO TO 50
C
C     IDENTITY
C
   80 IEOL = 1
      II   = I
      Z(1) = 1.0
      GO TO 60
   90 DO 100 J = 1,NUM
      DO 100 M = 1,NUM
  100 GM(J,M) = GM(J,M) + ACCUM(J)*X(I,M)
  110 CONTINUE
      IF (IDEN .EQ. 1) GO TO 120
      CALL REWIND (MASS)
      CALL SKPREC (MASS,1)
  120 GM(1,1) = SQRT(GM(1,1))
      DO 130 I = 2,NUM
      GM(I,I) = SQRT(GM(I,I))
      II = I - 1
      DO 130 J = 1,II
  130 GM(I,J) = GM(I,J)/(GM(I,I)*GM(J,J))
      DO 140 I = 1,NUM
      DO 140 J = 1,NDIM
  140 X(J,I) = X(J,I)/GM(I,I)
      J = 0
  150 DO 170 KK = 1,K
      IF (ABS(GM(K+1,KK)) .LT. EPS) GO TO 170
      J = 1
      DO 160 I = 1,NDIM
  160 X(I,K+1) = X(I,K+1) - GM(K+1,KK)*X(I,KK)
  170 CONTINUE
      K = K + 1
      IF (K .GE. NUM) GO TO 180
      IF (J .EQ.   0) GO TO 150
      GO TO 20
  180 IF (IDEN .EQ. 1) GO TO 190
      CALL CLOSE (MASS,REW)
  190 RETURN
      END

      SUBROUTINE FNXT (II,J)
C
C     FETCHES FROM THE RANDOM ACCESS STORAGE DEVICE THE BLOCK OF THE
C     ARRAY NXT CONTAINING THE ENTRY FOR BLOCK I.  IT STORES THE FETCHED
C     BLOCK IN THE ARRAY BUF, STARTING AT LOCATION NXT.  THE OUTPUT J
C     INDICATES THAT BLOCK I HAS THE JTH ENTRY IN THE ARRAY BUF.
C
      LOGICAL         DITUP,NXTUP
      INTEGER         BUF,DIT,DITPBN,DITLBN,DITSIZ,DITNSB,DITBL,
     1                BLKSIZ,DIRSIZ,SUPSIZ,FILSIZ,FILNUM,FILSUP
      DIMENSION       NMSBR(2)
      COMMON /ZZZZZZ/ BUF(1)
      COMMON /SOF   / DIT,DITPBN,DITLBN,DITSIZ,DITNSB,DITBL,IODUM(8),
     1                MDIDUM(4),NXT,NXTPBN,NXTLBN,NXTTSZ,NXTFSZ(10),
     2                NXTCUR,DITUP,MDIUP,NXTUP,NXTRST
      COMMON /SYS   / BLKSIZ,DIRSIZ,SUPSIZ
      COMMON /SOFCOM/ NFILES,FILNAM(10),FILSIZ(10)
      DATA    IRD   , IWRT,INDSBR  / 1,2, 9 /
      DATA    NMSBR / 4HFNXT,4H    /
C
C     FILNUM IS THE NUMBER OF THE DEVICE TO WHICH BLOCK I BELONGS.
C
      CALL CHKOPN (NMSBR(1))
      INDEX = II
      DO 4 L = 1,NFILES
      IF (INDEX .GT. FILSIZ(L)) GO TO 2
      FILNUM = L
      GO TO 10
    2 INDEX = INDEX - FILSIZ(L)
    4 CONTINUE
      GO TO 500
C
C     INDEX IS THE INDEX OF BLOCK I WITHIN FILE FILNUM.
C     FILSUP IS THE NUMBER OF THE SUPERBLOCK WITHIN FILE FILNUM TO WHICH
C     BLOCK I BELONGS, AND SUPSIZ IS THE SIZE OF A SUPERBLOCK.
C
   10 FILSUP = (INDEX-1)/SUPSIZ
      IF (INDEX-1 .EQ. FILSUP*SUPSIZ) GO TO 20
      FILSUP = FILSUP + 1
C
C     COMPUTE THE LOGICAL BLOCK NUMBER, WITHIN THE ARRAY NXT, IN WHICH
C     THE ITH BLOCK HAS AN ENTRY, ALSO COMPUTE THE INDEX OF THIS ENTRY
C     RELATIVE TO THE ARRAY BUF.  STORE THE BLOCK NUMBER IN IBLOCK, AND
C     THE INDEX IN J.
C
   20 IBLOCK = 0
      MAX = FILNUM - 1
      IF (MAX .LT. 1) GO TO 26
      DO 24 I = 1,MAX
      IBLOCK = IBLOCK + NXTFSZ(I)
   24 CONTINUE
   26 IBLOCK = IBLOCK + FILSUP
      J = (INDEX-(FILSUP-1)*SUPSIZ)/2 + 1 + NXT
      IF (IBLOCK .EQ. NXTLBN) RETURN
      IF (IBLOCK .GT. NXTTSZ) GO TO 500
C
C     THE DESIRED NXT BLOCK IS NOT PRESENTLY IN CORE, MUST THEREFORE
C     FETCH IT.
C
      IF (DITPBN .EQ. 0) GO TO 40
C
C     THE IN CORE BLOCK SHARED BY THE DIT AND THE ARRAY NXT IS NOW
C     OCCUPIED BY ONE BLOCK OF THE DIT.
C
      IF (.NOT.DITUP) GO TO 30
C
C     THE DIT BLOCK NOW IN CORE HAS BEEN UPDATED.  MUST THEREFORE WRITE
C     IT OUT BEFORE READING IN THE DESIRED NXT BLOCK.
C
      CALL SOFIO (IWRT,DITPBN,BUF(DIT-2))
      DITUP  = .FALSE.
   30 DITPBN = 0
      DITLBN = 0
      GO TO 50
   40 IF (NXTPBN .EQ. 0) GO TO 50
C
C     THE IN CORE BLOCK SHARED BY THE DIT AND THE ARRAY NXT IS NOW
C     OCCUPIED BY ONE BLOCK OF NXT.
C
      IF (.NOT.NXTUP) GO TO 50
C
C     THE NEXT BLOCK CURRENTLY IN CORE HAS BEEN UPDATED.  MUST THEREFORE
C     WRITE IT OUT BEFORE READING IN A NEW BLOCK.
C
      CALL SOFIO (IWRT,NXTPBN,BUF(NXT-2))
      NXTUP = .FALSE.
C
C     READ THE DESIRED NXT BLOCK INTO CORE.
C
   50 NXTLBN = IBLOCK
      NXTPBN = 0
      IF (MAX .LT. 1) GO TO 70
      DO 60 I = 1,MAX
      NXTPBN = NXTPBN+FILSIZ(I)
   60 CONTINUE
   70 NXTPBN = NXTPBN + (FILSUP-1)*SUPSIZ + 2
      CALL SOFIO (IRD,NXTPBN,BUF(NXT-2))
      RETURN
C
C     ERROR MESSAGES.
C
  500 CALL ERRMKN (INDSBR,1)
      RETURN
      END

      SUBROUTINE ORTHO (U,V,X1,X2,X3,X4,X5,NZ,IBUF1,IBUF2,IBUF3,IBUF4)
C
C     ORTHO WILL ORTHOGONALIZE THE CURRENT ITERANT WITH RESPECT TO
C     THE PREVIOUSLY EXTRACTED EIGENVECTORS
C
      INTEGER          FILEM     ,FILEK    ,FILEB    ,FILELM   ,
     1                 FILEVC    ,SR0FIL   ,SR5FIL   ,REAL     ,
     2                 SUB(2)    ,IBUF1(1) ,IBUF2(1) ,IBUF3(1) ,
     3                 SQR       ,CDP      ,IBUF4(1)
      DOUBLE PRECISION U(1)      ,V(1)     ,X1(1)    ,X2(1)    ,
     1                 X3(1)     ,X4(1)    ,X5(1)    ,PJ(2)    ,
     2                 CONST1(2) ,CONST2(2),ALPHA(2),BETA(2)
      COMMON /CINVPX/  FILEK(7)  ,FILEM(7) ,FILEB(7),FILELM(7) ,
     1                 FILEVC(7),DMPFIL    ,SCRFIL(10)
      COMMON /CINVXX/  DUM(17)   ,REAL     ,XXXX     ,NORTHO
      COMMON /NAMES /  RD        ,RDREW    ,WRT      ,WRTREW   ,
     1                 REW       ,NOREW    ,EOFNRW   ,RSP      ,
     2                 RDP       ,CSP      ,CDP      ,SQR
      EQUIVALENCE      (SR0FIL,SCRFIL(10)) ,(SR5FIL,SCRFIL(5)) ,
     1                 (NCOL,FILEK(2))
      DATA    SUB   /  4HORTH ,4HO   /
C
      NCOL2 = NCOL  + NCOL
      NCOL4 = NCOL2 + NCOL2
      IF (FILEB(1) .EQ. 0) GO TO 5
      CALL CMTIMU (V,X1,0,IBUF4)
      CALL CMTIMU (U,X2,FILEB,IBUF4)
      GO TO 7
    5 DO 6 I = 1,NCOL2
    6 X2(I) = 0.D0
    7 CONTINUE
      CALL CMTIMU (U,X3,0,IBUF4)
      CALL SSWTCH (12,L7)
      CONST1(1) = 1.0D0
      CONST1(2) = 0.
      CONST2(1) =-1.0D0
      CONST2(2) = 0.
      CALL CSUB (X1,X2,X2,CONST1,CONST2)
C
C     REWIND EIGENVALUE AND EIGENVECTOR FILES
C
      IFILE = FILELM(1)
      CALL OPEN (*1000,IFILE,IBUF1,RDREW)
      IFILE = FILEVC(1)
      CALL OPEN (*1000,IFILE,IBUF2,RDREW)
      IFILE = SR0FIL
      CALL OPEN (*1000,IFILE,IBUF3,RDREW)
      DO 100 K = 1,NORTHO
C
C     READ AN EIGENVALUE
C
      IFILE = FILELM(1)
      CALL READ (*1010,*1020,IFILE,PJ(1),4,1,FLAG)
      CONST1(1) = -1.D0
      CONST1(2) = 0.
      CALL CSUB (X3,X2,X5,PJ,CONST1)
C
C     READ THE RIGHT EIGENVECTOR
C
      IFILE = FILEVC(1)
      CALL READ (*1010,*1020,IFILE,X1(1),NCOL4,1,FLAG)
C
C     READ THE LEFT EIGENVECTOR
C
      IFILE = SR0FIL
      CALL READ (*1010,*1020,IFILE,X4(1),NCOL4,1,FLAG)
C
      IF (FILEB(1) .NE. 0) GO TO 40
C
C    COMPUTE ALPHA USING REAL FORMULA
C
      CALL CX TRN Y (X4,X3,CONST1)
      GO TO 55
   40 CALL CX TRN Y (X4(1),X5(1),CONST1(1))
   55 ALPHA(1) = CONST1(1)
      ALPHA(2) = CONST1(2)
      BETA(1)  = ALPHA(1)*PJ(1) - ALPHA(2)*PJ(2)
      BETA(2)  = ALPHA(1)*PJ(2) + ALPHA(2)*PJ(1)
      IF (L7 .EQ. 0) GO TO 1901
      WRITE  (6,500) CONST1,CONST2,ALPHA
  500 FORMAT (4H NUM ,2D12.5,6H DENOM ,2D12.5,6H ALPHA ,2D12.5 )
 1901 CONTINUE
      DO 60 I = 1,NCOL2,2
      U(I  ) = U(I  ) - ALPHA(1)*X1(I) + ALPHA(2)*X1(I+1)
      U(I+1) = U(I+1) - ALPHA(2)*X1(I) - ALPHA(1)*X1(I+1)
      IF (FILEB(1) .EQ. 0) GO TO 60
      V(I  ) = V(I  ) - BETA(1)*X1(I  ) + BETA(2)*X1(I+1)
      V(I+1) = V(I+1) - BETA(1)*X1(I+1) - BETA(2)*X1(I  )
   60 CONTINUE
  100 CONTINUE
      CALL CLOSE (FILELM,NOREW)
      CALL CLOSE (FILEVC,NOREW)
      CALL CLOSE (SR0FIL,NOREW)
      RETURN
C
 1000 NO = -1
      GO TO 1500
 1010 NO = -2
      GO TO 1500
 1020 NO = -3
 1500 CALL MESAGE (NO,IFILE,SUB)
      RETURN
      END

      SUBROUTINE EXIO
C
C     THE MAIN PURPOSE OF THIS MODULE IS TO COPY DATA BETWEEN THE
C     RESIDENT SOF AND AN EXTERNAL TAPE OR DISK FILE.  AS AN EXTRA
C     ADDED ATTRACTION, IT WILL ALSO APPEND AN EXTERNAL SOF (CREATED BY
C     SOME OTHER NASTRAN RUNS) TO THE RESIDENT SOF AND COMPRESS THE
C     RESIDENT SOF.
C
C     OPTIONS ARE -
C
C     (1) DUMP (RESTORE) THE ENTIRE SOF TO (FROM) AN EXTERNAL FILE.
C         INTERNAL FORM ONLY.  THIS IS THE MOST EFFICIENT MEANS TO SAVE
C         OR RECOVER A BACKUP COPY OF THE SOF, EXCEPT FOR SYSTEM UTILITY
C         PROGRAMS.
C
C     (2) COPY SELECTED ITEMS BETWEEN THE SOF AND AN EXTERNAL FILE.
C
C     (3) CHECK THE EXTERNAL FILE AND PRINT OUT A LIST OF ALL SUBSTRUC-
C         TURES AND ITEMS ON IT ALONG WITH THE DATE AND TIME EACH WAS
C         CREATED.
C
C     (4) APPEND AN EXTERNAL SOF TO THE RESIDENT SOF.
C
C     (5) COMPRESS THE RESIDENT SOF. (PLACE ALL ITEMS IN CONTIGUOUS
C         BLOCKS ON THE SOF AND ELIMINATE ALL EMBEDDED FREE BLOCKS)
C
C     FEBRUARY 1974
C
      INTEGER         FORMAT,EXTE,BLANK,HEAD1,HEAD2,DRY,DEVICE,UNAME,
     1                POS,BCDS(2,10),INBCDS(2,5)
      CHARACTER       UFM*23,UWM*25
      COMMON /XMSSG / UFM,UWM
      COMMON /BLANK / DRY,XMACH,DEVICE(2),UNAME(2),FORMAT(2),MODE(2),
     1                POS(2),DATYPE(2),NAMES(10),PDATE,PTIME
      COMMON /SYSTEM/ SYSBUF,NOUT
      COMMON /OUTPUT/ HEAD1(96),HEAD2(96)
      EQUIVALENCE     (INTE,BCDS(1,7)),(EXTE,BCDS(1,8)),
     1                (DEVICE(1),INBCDS(1,1))
      DATA    BLANK / 4H       /
      DATA    BCDS  / 4HSOFI   ,4HN     ,
     1                4HSOFO   ,4HUT    ,
     2                4HREST   ,4HORE   ,
     3                4HCHEC   ,4HK     ,
     4                4HCOMP   ,4HRESS  ,
     5                4HAPPE   ,4HND    ,
     6                4HINTE   ,4HRNAL  ,
     7                4HEXTE   ,4HRNAL  ,
     8                4HREWI   ,4HND    ,
     9                4HNORE   ,4HWIND  /
C
      DO 10 I = 1,96
   10 HEAD2(I) = BLANK
      DO 30 I = 1,5
      DO 20 J = 1,10
      IF (INBCDS(1,I) .NE. BCDS(1,J)) GO TO 20
      INBCDS(2,I) = BCDS(2,J)
      GO TO 30
   20 CONTINUE
   30 CONTINUE
C
      DO 40 I = 1,2
      HEAD2(I   ) = MODE(I)
      HEAD2(I+ 3) = FORMAT(I)
      HEAD2(I+ 6) = DEVICE(I)
      HEAD2(I+ 9) = UNAME(I)
      HEAD2(I+12) = POS(I)
   40 CONTINUE
C
C     INTERNAL FORMAT - GINO I/O IS USED FOR DATA WHICH WILL BE READ OR
C                       WAS WRITTEN ON THE SAME HARDWARE.
C
      IF (FORMAT(1) .EQ. INTE) CALL EXIO1
C
C     EXTERNAL FORMAT - FORTRAN I/O IS USED FOR DATA WHICH WILL BE READ
C                       OR WAS WRITTEN ON A DIFFERENT MACHINE.
C
      IF (FORMAT(1) .EQ. EXTE) CALL EXIO2
C
C     CHECK VALIDITY OF FORMAT TO ASCERTAIN WHETHER EITHER EXIO1 OR
C     EXIO2 WAS CALLED.
C
      IF (FORMAT(1).EQ.INTE .OR. FORMAT(1).EQ.EXTE) RETURN
      WRITE  (NOUT,50) UWM,FORMAT
   50 FORMAT (A25,' 6333, ',2A4,' IS AN INVALID FORMAT PARAMETER FOR ',
     1        'MODULE EXIO.')
      DRY = -2
      RETURN
      END

      SUBROUTINE EMSG(NCHAR,NO,ISYS,IWF,ITEXT)
      INTEGER IMSG(2,4), ITEXT(1)
      COMMON /SYSTEM/SYSBUF(41)
C     ISYS = 1   USER           IWF  =     1   WARNING
C          = 2   SYSTEM             =     2   FATAL
C
      EQUIVALENCE (NCPW,SYSBUF(41)),(NOUT,SYSBUF(2)),(IMACH,SYSBUF(22))
      DATA IMSG /4HUSER,1H ,4HSYST,4HEM  ,4HWARN,4HING ,4HFATA,1HL  /
      NWORD = (NCHAR + NCPW-1)/NCPW
      NLINE = (NCHAR + 9 + 131)/ 132   +2
      CALL PAGE2(-NLINE)
      NO1=IABS(NO)
      K = IWF +2
      WRITE(NOUT,10)(IMSG(I,ISYS),I=1,2),(IMSG(M,K),M=1,2),NO1
   10 FORMAT(1H0,4H*** ,4A4, I4,1H,)
      IF(NCHAR .EQ. 0) RETURN
      GO TO (20,30,20,50,30), IMACH
C
C     7094
C
   20 WRITE (NOUT,25)(ITEXT(I),I=1,NWORD)
   25 FORMAT(10X, 20A6,A2)
      GO TO 60
C
C     360/370
C
   30 WRITE(NOUT,35) (ITEXT(I),I=1,NWORD)
   35 FORMAT(10X, 30A4,A2)
      GO TO 60
C
C     CDC
C
   50 WRITE(NOUT,55) (ITEXT(I),I=1,NWORD)
   55 FORMAT(10X,12A10,A2)
   60 IF (NO .LT. 0) CALL MESAGE(-61,0,0)
      RETURN
      END

      SUBROUTINE SOFOPN (B1,B2,B3)
C
C     READS THE SOF AND SYS COMMON BLOCKS FROM THE DIRECT ACCESS STORAGE
C     DEVICE, AND INITIALIZES THE POINTERS TO THE THREE BUFFERS NEEDED
C     BY THE SOF UTILITY SUBROUTINES
C
      LOGICAL         FIRST,OPNSOF
      INTEGER         B1(1),B2(1),B3(1),BUF,DIT,A,B,CORWDS,GINOBL
      DIMENSION       NAME(2),IPTR(3)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /MACHIN/ MACH
      COMMON /ZZZZZZ/ BUF(1)
      COMMON /SOF   / A(37)
      COMMON /SYS   / B(6)
      COMMON /SOFCOM/ NFILES,FILNAM(10),FILSIZ(10),STATUS,PSSWRD(2),
     1                FIRST,OPNSOF
      COMMON /ITEMDT/ NITEM,ITEM(7,1)
      COMMON /SYSTEM/ NBUFF,NOUT
      COMMON /GINOX / C(161),GINOBL
      DATA    NAME  / 4HSOFO,4HPN  /
      DATA    IRD   / 1 /
C
      IF (OPNSOF) GO TO 1000
C
C     CHECK IF THE OPEN CORE BUFFERS ARE LARGE ENOUGH AND DO NOT OVERLAP
C
      IPTR(1) = CORWDS(BUF,B1) + 2
      IPTR(2) = CORWDS(BUF,B2) + 2
      IPTR(3) = CORWDS(BUF,B3) + 2
      ISIZ    = KORSZ(BUF)
      DO 2 I = 1,3
      IF (ISIZ-IPTR(I) .LT. NBUFF-3) CALL MESAGE (-8,0,NAME)
    2 CONTINUE
      DO 4 I = 1,2
      K = I + 1
      DO 3 J = K,3
      ISIZ = IPTR(I) - IPTR(J)
      IF (ISIZ .LT.     0) ISIZ = -ISIZ
      IF (ISIZ .LT. NBUFF) CALL MESAGE (-8,0,NAME)
    3 CONTINUE
    4 CONTINUE
      A( 1) = IPTR(1)
      A( 7) = IPTR(2)
      A(15) = IPTR(3)
      A(19) = IPTR(1)
C
C     SET SOF BUFFER SIZE FROM /GINOX/
C     ON IBM USE /SYSTEM/ BECAUSE /GINOX/ IS IN SUPER LINK
C
      B(1) = GINOBL
      IF (MACH.EQ.2 .OR. MACH.GE.5) B(1) = NBUFF - 4
CWKBD 3/94      IF (MACH .EQ. 12) B(1) =NBUFF -28
      IF (FIRST) CALL SOFINT (IPTR(1),IPTR(2),NUMB,IBL1)
C
C     READ AND INITIALIZE THE COMMON BLOCKS SYS AND SOF
C
      DIT = IPTR(1)
      CALL SOFIO (IRD,1,BUF(DIT-2))
      DO 20 I = 1,4
      B(I) = BUF(DIT+24+I)
   20 CONTINUE
      B(5) = BUF(DIT+46)
      B(6) = BUF(DIT+47)
      A(1) = IPTR(1)
      A(2) = 0
      A(3) = 0
      A(4) = BUF(DIT+29)
      A(5) = BUF(DIT+30)
      A(6) = BUF(DIT+31)
      A(7) = IPTR(2)
      DO 30 I = 8,14
      A(I) = 0
   30 CONTINUE
      A(15) = IPTR(3)
      A(16) = 0
      A(17) = 0
      A(18) = BUF(DIT+32)
      A(19) = IPTR(1)
      A(20) = 0
      A(21) = 0
      A(22) = BUF(DIT+33)
      DO 35 I = 1,NFILES
      A(22+I) = BUF(DIT+33+I)
   35 CONTINUE
      A(33) = BUF(DIT+44)
      A(34) = 0
      A(35) = 0
      A(36) = 0
      A(37) = BUF(DIT+45)
C
C     INITILIZE COMMON BLOCK ITEMDT
C
      NITEM = BUF(DIT+100)
      K = 100
      DO 38 I = 1,NITEM
      DO 37 J = 1,7
   37 ITEM(J,I) = BUF(DIT+K+J)
   38 K = K + 7
      OPNSOF = .TRUE.
      IF (.NOT. FIRST) RETURN
      FIRST  = .FALSE.
      IF (NUMB .EQ. 0) RETURN
C
C     ADD THE NUMBER NUMB OF BLOCKS TO THE SUPERBLOCK WHOSE SIZE
C     NEEDED TO BE INCREASED
C
      DO 40 I = 1,NUMB
      CALL RETBLK (IBL1+I-1)
   40 CONTINUE
      B(4) = B(4) - NUMB
      RETURN
C
C     ERROR MESSAGE
C
 1000 WRITE  (NOUT,1001) UFM
 1001 FORMAT (A23,' 6222 - ATTEMPT TO CALL SOFOPN MORE THAN ONCE ',
     1       'WITHOUT CALLING SOFCLS.')
      CALL SOFCLS
      CALL MESAGE (-61,0,0)
      RETURN
      END

      INTEGER FUNCTION EJECT (LINES)
      COMMON /SYSTEM/ SKP1(8),MAXLIN,SKP2(2),LINCNT
C
C     LINES = NUNBER OF LINES TO BE PRINTED.
C     RESULT = 1 IF NEW PAGE IS STARTED.
C
      EJECT = 0
      IF (LINCNT+LINES+2 .LE. MAXLIN) GO TO 105
      CALL PAGE1
      EJECT = 1
  105 RETURN
      END

      SUBROUTINE MTRAPR
C
C     THIS ROUTINE COMPUTES THE MASS MATRIX FOR A AXI-SYMMETRIC RING
C     WITH A TRAPEZOIDAL CROSS SECTION
C
C     ECPT FOR THE TRAPEZOIDAL RING
C                                                          TYPE
C     ECPT( 1) ELEMENT IDENTIFICATION                        I
C     ECPT( 2) SCALAR INDEX NO. FOR GRID POINT A             I
C     ECPT( 3) SCALAR INDEX NO. FOR GRID POINT B             I
C     ECPT( 4) SCALAR INDEX NO. FOR GRID POINT C             I
C     ECPT( 5) SCALAR INDEX NO. FOR GRID POINT D             I
C     ECPT( 6) MATERIAL ORIENTATION ANGLE(DEGREES)           R
C     ECPT( 7) MATERIAL IDENTIFICATION                       I
C     ECPT( 8) COOR. SYS. ID. FOR GRID POINT A               I
C     ECPT( 9) X-COOR. OF GRID POINT A (IN BASIC COOR.)      R
C     ECPT(10) Y-COOR. OF GRID POINT A (IN BASIC COOR.)      R
C     ECPT(11) Z-COOR. OF GRID POINT A (IN BASIC COOR.)      R
C     ECPT(12) COOR. SYS. ID. FOR GRID POINT B               I
C     ECPT(13) X-COOR. OF GRID POINT B (IN BASIC COOR.)      R
C     ECPT(14) Y-COOR. OF GRID POINT B (IN BASIC COOR.)      R
C     ECPT(15) Z-COOR. OF GRID POINT B (IN BASIC COOR.)      R
C     ECPT(16) COOR. SYS. ID. FOR GRID POINT C               I
C     ECPT(17) X-COOR. OF GRID POINT C (IN BASIC COOR.)      R
C     ECPT(18) Y-COOR. OF GRID POINT C (IN BASIC COOR.)      R
C     ECPT(19) Z-COOR. OF GRID POINT C (IN BASIC COOR.)      R
C     ECPT(20) COOR. SYS. ID. FOR GRID POINT D               I
C     ECPT(21) X-COOR. OF GRID POINT D (IN BASIC COOR.)      R
C     ECPT(22) Y-COOR. OF GRID POINT D (IN BASIC COOR.)      R
C     ECPT(23) Z-COOR. OF GRID POINT D (IN BASIC COOR.)      R
C     ECPT(24) EL. TEMPERATURE FOR MATERIAL PROPERTIES       R
C
      DOUBLE PRECISION CONSTD,D2PI,D,GAMBQ,R,Z,DELINT,AK,AKI,AKT,AM,
     1                 R1,R2,R3,R4,Z1,Z2,Z3,Z4,ZMIN,DGAMA,RZINTD,
     2                 RMIN,RMAX,RHOD,TWOPI
      DIMENSION        JRZ(2),IECPT(24),AM(64)
      COMMON /SYSTEM/  IBUF,IOUT
      COMMON /CONDAD/  CONSTD(5)
      COMMON /SMA2IO/  DUM1(10),IFMGG,DUM2(25)
      COMMON /SMA2CL/  DUM3(2),NPVT,DUM4(7),LINK(10),NOGO
      COMMON /SMA2ET/  ECPT(24),DUM5(76)
      COMMON /MATIN /  MATIDC,MATFLG,ELTEMP,STRESS,SINTH,COSTH
      COMMON /MATOUT/  E(3),ANU(3),RHO,G(3),ALF(3),TZERO
      COMMON /SMA2DP/  D(64),GAMBQ(64),R(4),Z(4),DELINT(12),AK(64),
     1                 AKI(36),AKT(9),DGAMA,ZMIN,RHOD,TWOPI,IGP(4),
     2                 ICS(4),SP(24),TEMPE
      EQUIVALENCE      (IECPT(1),ECPT(1)),(R(1),R1),(R(2),R2),(R(3),R3),
     1                 (R(4),R4),(Z(1),Z1),(Z(2),Z2),(Z(3),Z3),(Z(4),Z4)
     2,                (AM(1),AK(1)),(CONSTD(2),D2PI)
C
C     STORE ECPT PARAMETERS IN LOCAL VARIABLES
C
      IDEL   = IECPT( 1)
      IGP(1) = IECPT( 2)
      IGP(2) = IECPT( 3)
      IGP(3) = IECPT( 4)
      IGP(4) = IECPT( 5)
      MATID  = IECPT( 7)
      ICS(1) = IECPT( 8)
      ICS(2) = IECPT(12)
      ICS(3) = IECPT(16)
      ICS(4) = IECPT(20)
      R(1)   = ECPT( 9)
      D(1)   = ECPT(10)
      Z(1)   = ECPT(11)
      R(2)   = ECPT(13)
      D(2)   = ECPT(14)
      Z(2)   = ECPT(15)
      R(3)   = ECPT(17)
      D(3)   = ECPT(18)
      Z(3)   = ECPT(19)
      R(4)   = ECPT(21)
      D(4)   = ECPT(22)
      Z(4)   = ECPT(23)
      TEMPE  = ECPT(24)
      DGAMA  = ECPT( 6)
C
C     CHECK INTERNAL GRID POINTS FOR PIVOT POINT
C
      IPP = 0
      DO 100 I = 1,4
      IF (NPVT .EQ. IGP(I)) IPP = I
  100 CONTINUE
      IF (IPP .EQ. 0) CALL MESAGE (-30,34,IDEL)
C
C     TEST THE VALIDITY OF THE GRID POINT COORDINATES
C
      DO 200 I = 1,4
      IF (R(I) .LT. 0.0D0) GO TO 910
      IF (D(I) .NE. 0.0D0) GO TO 910
  200 CONTINUE
C
C     COMPUTE THE ELEMENT COORDINATES
C
      ZMIN = DMIN1(Z1,Z2,Z3,Z4)
      Z1 = Z1 - ZMIN
      Z2 = Z2 - ZMIN
      Z3 = Z3 - ZMIN
      Z4 = Z4 - ZMIN
C
C     FATAL IF RATIO OF RADII IS TO LARGE FOR GUASS QUADRATURE FOR IP=-1
C
      RMIN = DMIN1(R1,R2,R3,R4)
      RMAX = DMAX1(R1,R2,R3,R4)
      IF (RMIN .EQ. 0.D0) GO TO 206
      IF (RMAX/RMIN .GT. 10.D0) GO TO 930
C
  206 CONTINUE
      D(5) = (R1+R4)/2.0D0
      D(6) = (R2+R3)/2.0D0
      IF (D(5) .EQ. 0.0D0) GO TO 210
      IF (DABS((R1-R4)/D(5)) .GT. 0.5D-2) GO TO 210
      R1 = D(5)
      R4 = D(5)
  210 CONTINUE
      IF (D(6) .EQ. 0.0D0) GO TO 220
      IF (DABS((R2-R3)/D(6)) .GT. 0.5D-2) GO TO 220
      R2 = D(6)
      R3 = D(6)
  220 CONTINUE
C
      ICORE = 0
      J = 1
      DO 230 I = 1,4
      IF (R(I) .NE. 0.0D0) GO TO 230
      ICORE = ICORE + 1
      JRZ(J) = I
      J = 2
  230 CONTINUE
      IF (ICORE.NE.0 .AND. ICORE.NE.2) GO TO 910
C
C     FORM THE TRANSFORMATION MATRIX (8X8) FROM FIELD COORDINATES TO
C     GRID POINT DEGREES OF FREEDOM
C
      DO 300 I = 1,64
      GAMBQ(I) = 0.0D0
  300 CONTINUE
      GAMBQ( 1) = 1.0D0
      GAMBQ( 2) = R1
      GAMBQ( 3) = Z1
      GAMBQ( 4) = R1*Z1
      GAMBQ(13) = 1.0D0
      GAMBQ(14) = R1
      GAMBQ(15) = Z1
      GAMBQ(16) = GAMBQ(4)
      GAMBQ(17) = 1.0D0
      GAMBQ(18) = R2
      GAMBQ(19) = Z2
      GAMBQ(20) = R2*Z2
      GAMBQ(29) = 1.0D0
      GAMBQ(30) = R2
      GAMBQ(31) = Z2
      GAMBQ(32) = GAMBQ(20)
      GAMBQ(33) = 1.0D0
      GAMBQ(34) = R3
      GAMBQ(35) = Z3
      GAMBQ(36) = R3*Z3
      GAMBQ(45) = 1.0D0
      GAMBQ(46) = R3
      GAMBQ(47) = Z3
      GAMBQ(48) = GAMBQ(36)
      GAMBQ(49) = 1.0D0
      GAMBQ(50) = R4
      GAMBQ(51) = Z4
      GAMBQ(52) = R4*Z4
      GAMBQ(61) = 1.0D0
      GAMBQ(62) = R4
      GAMBQ(63) = Z4
      GAMBQ(64) = GAMBQ(52)
C
C     NO NEED TO COMPUTE DETERMINANT SINCE IT IS NOT USED SUBSEQUENTLY.
C
      ISING = -1
      CALL INVERD (8,GAMBQ(1),8,D(10),0,D(11),ISING,SP)
      IF (ISING .EQ. 2) GO TO 920
C
C     MODIFY THE TRANSFORMATION MATRIX IF ELEMENT IS A CORE ELEMENT
C
      IF (ICORE .EQ. 0) GO TO 305
      JJ1 = 2*JRZ(1) - 1
      JJ2 = 2*JRZ(2) - 1
C
      DO 303 I = 1,8
      J = 8*(I-1)
      GAMBQ(I    ) = 0.0D0
      GAMBQ(I+ 16) = 0.0D0
      GAMBQ(J+JJ1) = 0.0D0
      GAMBQ(J+JJ2) = 0.0D0
  303 CONTINUE
  305 CONTINUE
C
C     CALCULATE THE INTEGRAL VALUES IN ARRAY DELINT WHERE THE ORDER IS
C     INDICATED BY THE FOLLOWING TABLE
C
C     DELINT(1) - (1,0)
C     DELINT(2) - (1,1)
C     DELINT(3) - (1,2)
C     DELINT(4) - (2,0)
C     DELINT(5) - (2,1)
C     DELINT(6) - (2,2)
C     DELINT(7) - (3,0)
C     DELINT(8) - (3,1)
C     DELINT(9) - (3,2)
C
      I1 = 0
      DO 400 I = 1,3
      IP = I
      DO 350 J = 1,3
      IQ = J - 1
      I1 = I1 + 1
      DELINT(I1) = RZINTD(IP,IQ,R,Z,4)
  350 CONTINUE
  400 CONTINUE
C
C     LOCATE THE MATERIAL PROPERTIES IN THE MAT1 OR MAT3 TABLE
C
      MATIDC = MATID
      MATFLG = 7
      ELTEMP = TEMPE
      CALL MAT (IDEL)
C
C    SET MATERIAL PROPERTIES IN DOUBLE PRECISION VARIABLES
C
      RHOD = RHO
C
C     GENERATE THE CONSISTENT MASS MATRIX IN FIELD COORDINATES
C
      DO 600 I = 1,64
      AM(I) = 0.0D0
  600 CONTINUE
      TWOPI  = D2PI*RHOD
      AM( 1) = TWOPI*DELINT(1)
      AM( 2) = TWOPI*DELINT(4)
      AM( 3) = TWOPI*DELINT(2)
      AM( 4) = TWOPI*DELINT(5)
      AM( 9) = AM( 2)
      AM(10) = TWOPI*DELINT(7)
      AM(11) = TWOPI*DELINT(5)
      AM(12) = TWOPI*DELINT(8)
      AM(17) = AM( 3)
      AM(18) = AM(11)
      AM(19) = TWOPI*DELINT(3)
      AM(20) = TWOPI*DELINT(6)
      AM(25) = AM( 4)
      AM(26) = AM(12)
      AM(27) = AM(20)
      AM(28) = TWOPI*DELINT(9)
      DO 650 I = 1,4
      K = (I-1)*8
      DO 650 J = 1,4
      K = K + 1
      AM(K+36) = AM(K)
  650 CONTINUE
C
C     TRANSFORM THE ELEMENT MASS MATRIX FROM FIELD COORDINATES TO GRID
C     POINT DEGREES OF FREEDOM
C
      CALL GMMATD (GAMBQ,8,8,1, AK,8,8,0, D)
      CALL GMMATD (D,8,8,0, GAMBQ,8,8,0, AK)
C
C     ZERO OUT THE (6X6) MATRIX USED AS INPUT TO THE INSERTION ROUTINE
C
      DO 700 I = 1,36
      AKI(I) = 0.0D0
  700 CONTINUE
C
C     LOCATE THE TRANSFORMATION MATRICES FOR THE FOUR  GRID POINTS
C
      DO 800 I = 1,4
      IF (ICS(I) .EQ. 0) GO TO 800
      K = 9*(I-1) + 1
      CALL TRANSD (ICS(I),D(K))
  800 CONTINUE
C
C     START THE LOOP FOR INSERTION OF THE FOUR  (6X6) MATRICES INTO THE
C     MASTER MASS MATRIX
C
      IR1  = 2*IPP - 1
      IAPP = 9*(IPP-1) + 1
      DO 900 I = 1,4
C
C     PLACE THE APPROIATE (2X2) SUBMATRIX OF THE MASS MATRIX IN A (3X3)
C     MATRIX FOR TRANSFORMATION
C
      IC1    = 2*I - 1
      IRC    = (IR1-1)*8 + IC1
      AKT(1) = AK(IRC)
      AKT(2) = 0.0D0
      AKT(3) = AK(IRC+1)
      AKT(4) = 0.0D0
      AKT(5) = 0.0D0
      AKT(6) = 0.0D0
      AKT(7) = AK(IRC+8)
      AKT(8) = 0.0D0
      AKT(9) = AK(IRC+9)
C
C     TRANSFORM THE (3X3) MASS MATRIX
C
      IF (ICS(IPP) .EQ. 0) GO TO 820
      CALL GMMATD (D(IAPP),3,3,1, AKT(1),3,3,0, D(37))
      DO 810 J = 1,9
      AKT(J) = D(J+36)
  810 CONTINUE
  820 CONTINUE
      IF (ICS(I) .EQ. 0) GO TO 840
      IAI = 9*(I-1) + 1
      CALL GMMATD (AKT(1),3,3,0, D(IAI),3,3,0, D(37))
      DO 830 J = 1,9
      AKT(J) = D(J+36)
  830 CONTINUE
  840 CONTINUE
C
C     PLACE THE TRANSFORMED (3X3) MATRIX INTO A (6X6) MATRIX FOR THE
C     INSERTION ROUTINE
C
      J = 0
      DO 850 J1 = 1,18,6
      DO 850 J2 = 1,3
      J = J  + 1
      K = J1 + J2 - 1
      AKI(K) = AKT(J)
  850 CONTINUE
C
C     CALL THE INSERTION ROUTINE
C
      CALL SMA2B (AKI(1),IGP(I),-1,IFMGG,0.0D0)
  900 CONTINUE
      RETURN
C
C     SET FLAG FOR FATAL ERROR WHILE ALLOWING ERROR MESSAGES TO
C     ACCUMULATE
C
  910 I = 37
      GO TO 950
  920 I = 26
      GO TO 950
  930 I = 218
      GO TO 960
C
C     ERROR TYPE 218 HAD BEEN ISSUED BY KTRAPR ALREADY.
C
  950 CALL MESAGE (30,I,IDEL)
  960 NOGO = 1
      RETURN
C
      END

      SUBROUTINE KTRIQD (NTYPE)
C
C
C     8/18/67         E C P T     L I S T I N G
C
C ECPT  TRMEM   QDMEM   TRPLT   QDPLT   TRIA1   QUAD1   TRIA2   QUAD2
C ***** ******* ******* ******* ******* ******* ******* ******* ********
C   1   EL.ID   EL.ID   EL.ID   EL.ID   EL.ID   EL.ID   EL.ID   EL.ID
C   2   GRID A  GRID A  GRID A  GRID A  GRID A  GRID A  GRID A  GRID A
C   3   GRID B  GRID B  GRID B  GRID B  GRID B  GRID B  GRID B  GRID B
C   4   GRID C  GRID C  GRID C  GRID C  GRID C  GRID C  GRID C  GRID C
C   5   THETA   GRID D  THETA   GRID D  THETA   GRID D  THETA   GRID D
C   6   MATID   THETA   MATID1  THETA   MATID1  THETA   MAT ID  THETA
C   7   T       MAT ID  I       MATID1  T1      MATID1  T       MAT ID
C   8   NS MASS T       MATID2  I       MATID2  T1      NS MASS T
C   9   CSID 1  NS MASS T2      MATID2  I       MATID2  CSID 1  NS MASS
C  10   X1      CSID 1  NS MASS T2      MATID3  I       X1      CSID 1
C  11   Y1      X1      Z1      NS MASS T2      MATID3  Y1      X1
C  12   Z1      Y1      Z2      Z1      NS MASS T2      Z1      Y1
C  13   CSID 2  Z1      CSID 1  Z2      Z1      NS MASS CSID 2  Z1
C  14   X2      CSID 2  X1      CSID 1  Z2      Z1      X2      CSID 2
C  15   Y2      X2      Y1      X1      CSID 1  Z2      Y2      X2
C  16   Z2      Y2      Z1      Y1      X1      CSID 1  Z2      Y2
C  17   CSID 3  Z2      CSID 2  Z1      Y1      X1      CSID 3  Z2
C  18   X3      CSID 3  X2      CSID 2  Z1      Y1      X3      CSID 3
C  19   Y3      X3      Y2      X2      CSID 2  Z1      Y3      X3
C  20   Z3      Y3      Z2      Y2      X2      CSID 2  Z3      Y3
C  21   TEMP    Z3      CSID 3  Z2      Y2      X2      TEMP    Z3
C  22           CSID 4  X3      CSID 3  Z2      Y2              CSID 4
C  23           X4      Y3      X3      CSID 3  Z2              X4
C  24           Y4      Z3      Y3      X3      CSID 3          Y4
C  25           Z4      TEMP    Z3      Y3      X3              Z4
C  26           TEMP            CSID 4  Z3      Y3              TEMP
C  27                           X4      TEMP    Z3
C  28                           Y4              CSID 4
C  29                           Z4              X4
C  30                           TEMP            Y4
C  31                                           Z4
C  32                                           TEMP
C
C
      LOGICAL         HEAT
      INTEGER         SCR4,IECPT(4),BCD(2,4),BGPDT(4)
      DIMENSION       SAVE(32)
      COMMON /BLANK / SKIP(16),VOLUME,SURFAC
      COMMON /MATOUT/ DUM(6),RHO
      COMMON /SMA1HT/ HEAT
      COMMON /SMA1ET/ ECPT(100)
      COMMON /SMA1DP/ DUMMY(600)
      EQUIVALENCE     (SAVE(1),ECPT(50)),(ECPT(1),IECPT(1))
      DATA    BCD   / 4HCTRI,2HA1,4HCTRI,2HA2,4HCQUA,2HD1,4HCQUA,2HD2 /
      DATA    OLD   , KOUNT,NGPT / 0.0,   2*0     /
      DATA    SCR4  , BGPDT/  304, 15, 9, 16, 10  /
C
C     THIS SUBROUTINE INCORPORATES TRIA1, QUAD1, TRIA2, QUAD2
C
C             NTYPE = 1  IMPLIES KTRIA1
C             NTYPE = 2  IMPLIES KTRIA2
C             NTYPE = 3  IMPLIES KQUAD1
C             NTYPE = 4  IMPLIES KQUAD2
C
C     CALLS FROM THIS ROUTINE CAN BE MADE TO
C
C            KTRMEM - TRIANGULAR MEMBRANE ROUTINE
C            KQDMEM - QUADRILATERAL MEMBRANE ROUTINE
C            KTQPLT - TRIANGULAR OR QUADRILATERAL PLATE ROUTINE
C            QDMM1X - HIGHER LEVEL QUADRIALATER MEMBRANE ROUTINE
C
C     ALL INSERTIONS OF 6X6 ELEMENT STIFFNESS MATRICES ARE HANDLED BY
C     THE ABOVE ROUTINES.
C
C
C     THE SAVED ECPT IS EQUIVALENCED TO ECPT(50)
C
C     SAVE THE INCOMING ECPT
C
      DO 10 I = 1,32
   10 SAVE(I) = ECPT(I)
C
C     TRANSFER TO OPERATIONS DESIRED
C
C           KTRIA1 KTRIA2 KQUAD1 KQUAD2
      GO TO (  20,    70,   100,   150), NTYPE
C
C     *** KTRIA1 ***
C
C     SET UP ECPT FOR CALL TO KTRMEM (0), FIRST CHECK T1 FOR ZERO.
C
   20 IF (SAVE(7) .EQ. 0.0) GO TO 40
      DO 30 I = 9,21
   30 ECPT(I) = SAVE(I+6)
C
      CALL KTRMEM (0)
C
C     SET UP ECPT FOR CALL TO TQPLT(3), FIRST CHECK I AND T2 EQUAL ZERO.
C
   40 IF (SAVE(9) .EQ. 0.0) GO TO 200
      DO 50 I = 1,5
   50 ECPT(I) = SAVE(I)
      DO 60 I = 6,25
   60 ECPT(I) = SAVE(I+2)
C
      IF (.NOT.HEAT) CALL KTRPLT
      GO TO 200
C
C     *** KTRIA2 ***
C
   70 IF (SAVE(7) .EQ. 0.0) GO TO 200
C
C     SET UP ECPT FOR CALL TO KTRMEM (0)
C
C     ECPT IS OK AS DELIVERED TO THIS ROUTINE
C
      CALL KTRMEM (0)
C
C     SET UP ECPT FOR CALL TO KTQPLT (3)
C
      DO 80 I = 1,6
   80 ECPT(I) = SAVE(I)
      ECPT(7) = SAVE(7)**3/12.0
      ECPT(8) = SAVE(6)
      ECPT(9) = SAVE(7)
      ECPT(10)= SAVE(8)
      DO 90 I = 13,25
   90 ECPT(I) = SAVE(I-4)
C
      IF (.NOT.HEAT) CALL KTRPLT
      GO TO 200
C
C     *** KQUAD1 ***
C
  100 IF (SAVE(8) .EQ. 0.0) GO TO 120
C
C     SET UP ECPT FOR CALL TO KQDMEM
C
      ECPT(9) = SAVE(13)
      DO 110 I = 10,26
  110 ECPT(I) = SAVE(I+6)
C
      CALL KQDMEM
C
  120 IF (SAVE(10) .EQ. 0.0) GO TO 200
C
C     SET UP ECPT FOR CALL TO KTQPLT (4)
C
      DO 130 I = 1,6
  130 ECPT(I) = SAVE(I)
      DO 140 I = 7,30
  140 ECPT(I) = SAVE(I+2)
C
      IF (.NOT.HEAT) CALL KQDPLT
      GO TO 200
C
C     *** KQUAD2 ***
C
  150 IF (SAVE(8) .EQ. 0.0) GO TO 200
C
C     SET UP ECPT FOR CALL TO KQDMEM
C     (WHICH HAS WEAK STIFFNESS MATRIX FORMULATION)
C     OR
C     SET UP ECPT FOR CALL TO QDMM1D/S (BETTER MEMBRANE FORMALATION)
C     THE PROBLEM HERE IS THAT KTRIQD AND KQDMEM ARE EMGOLD ELEMENTS
C     WHILE QDMM1D/S ARE EMGPRO NEW ELEMENTS.
C     TO SOLVE THIS PROPLEM, WE NEED A S.P./D.P. QDMM1X ELEMENT ROUTINE
C     THAT USES QDMM1D/S FORMULATION WITH EMGOLD/SMA1B TECHNIQUE.
C
C     ECPT IS OK AS DELIVERED TO THIS ROUTINE
C
C     CALL QDMM1X
C     (QDMM1X IS INCOMPLETE AS OF 3/92. GO BACK TO KQDMEM)
C
      CALL KQDMEM
C
C     SET UP ECPT FOR CALL TO KTQPLT (4)
C
      DO 160 I = 1,7
  160 ECPT(I) = SAVE(I)
      ECPT(8) = SAVE(8)**3/12.0
      ECPT(9) = SAVE(7)
      ECPT(10)= SAVE(8)
      ECPT(11)= SAVE(9)
      DO 170 I = 14,30
  170 ECPT(I) = SAVE(I-4)
C
      IF (.NOT. HEAT) CALL KQDPLT
C
C
C     SAVE ELEMENT NAME, ID, THICKNESS, DENSITY, NO. OF GRID POINTS,
C     AND GRID PT DATA IF USER REQUESTED VOLUME AND AREA COMPUTATION
C
  200 IF (HEAT .OR. (VOLUME.LE.0.0 .AND. SURFAC.LE.0.0)) GO TO 220
      IF (SAVE(1) .EQ. OLD) GO TO 210
      OLD  = SAVE(1)
      NGPT = 3
      IF (NTYPE .GE. 3) NGPT = 4
      KOUNT = 0
  210 KOUNT = KOUNT + 1
      IF (KOUNT .LT. NGPT) GO TO 220
      ECPT(2) = SAVE(7)
      ECPT(3) = RHO
      IECPT(4)= NGPT
      I = BGPDT(NTYPE)
      K = NGPT*4
      IF (NTYPE .GE. 3) ECPT(2) = SAVE(8)
      CALL WRITE (SCR4,BCD(1,NTYPE),2,0)
      CALL WRITE (SCR4,ECPT(1),4,0)
      CALL WRITE (SCR4,SAVE(2),NGPT,0)
      CALL WRITE (SCR4,SAVE(I),K,1)
  220 RETURN
      END

      SUBROUTINE DAXB(A,B,C)
      DOUBLE PRECISION A(3), B(3), C(3), D(3)
C*****
C  DOUBLE PRECISION VERSION
C
C  THIS ROUTINE PERFORMS A X B INTO C  (C MAY OVERLAP A OR B IN CORE)
C*****
      D(1) = A(2)*B(3) - A(3)*B(2)
      D(2) = A(3)*B(1) - A(1)*B(3)
      D(3) = A(1)*B(2) - A(2)*B(1)
      C(1) = D(1)
      C(2) = D(2)
      C(3) = D(3)
      RETURN
      END

      SUBROUTINE RE2AL (RE,ALPH)
C
      EXTERNAL        LSHIFT
      INTEGER         ALPH(2)
      COMMON /SYSTEM/ IBUF,NOUT,DUMMY(37),NBPW
C
      CALL FP2A8 (*40,RE,ALPH)
      IF (NBPW-60) 30,10,20
C
C     FOR 60- OR 64- BIT MACHINES, SAVE THE SECOND HALF OF REAL NUMBER
C     IN THE SECOND ALPH WORD. THAT IS -
C     THE FULL REAL NUMBER IS IN ALPH(1), ALL 8 BYTES, OR
C     FIRST 4 BYTES IN ALPH(1), AND LAST 4 BYTES IN ALPH(2)
C
 10   ALPH(2) = LSHIFT(ALPH(1),24)
      GO TO 30
 20   ALPH(2) = LSHIFT(ALPH(1),32)
 30   RETURN
C
 40   WRITE  (NOUT,50)
 50   FORMAT (99X,'(IN FP2A8, CALLED FROM RE2AL)')
      CALL MESAGE (-61,0,0)
      GO TO 30
      END

      SUBROUTINE OUTPAK (II,IOUT,ISN)
C
      EXTERNAL        ORF
      INTEGER         IOUT(1),NUMBER(10),IDIG(4),ORF,OP
      COMMON /SYSTEM/ KSYS(65)
      EQUIVALENCE     (KSYS(2),OP),(KSYS(9),NLPP),(KSYS(12),NLINE),
     1                (KSYS(41),NCPW)
      DATA    NUMBER/ 1H1,1H2,1H3,1H4,1H5,1H6,1H7,1H8,1H9,1H0/
      DATA    NBLANK/ 4H    /
C
      KCODE = 0
      IF (ISN .LT. 0) KCODE = 1
      ISN = IABS(ISN)
      ICODE = 0
      IF (II .GT. 32) ICODE = 1
      IF (ICODE .EQ. 1) GO TO 50
C
C     TRANSLATE ISN TO DIGITS
C
   10 IDIG(1) = ISN/1000
      IDIG(2) = (ISN-IDIG(1)*1000)/100
      IDIG(3) = (ISN-IDIG(1)*1000 - IDIG(2)*100)/10
      IDIG(4) = ISN - IDIG(1)*1000 - IDIG(2)*100 - IDIG(3)*10
      DO 20 I = 1,4
      IF (IDIG(I) .EQ. 0) IDIG(I) = 10
   20 CONTINUE
C
C     FORM WORD AND STORE IN IOUT ARRAY
C
      K = 0
      DO 30 I = 1,4
      J = IDIG(I)
      K = ORF(KLSHFT(KRSHFT(NUMBER(J),NCPW-1),NCPW-I),K)
   30 CONTINUE
      IOUT(II) = K
      GO TO 80
   50 NLINE = NLINE + 1
      IF (NLINE .LE. NLPP) GO TO 60
      CALL PAGE
      NLINE = NLINE + 1
      WRITE (OP,100)
      NLINE = NLINE + 1
   60 WRITE (OP,90) (IOUT(I),I=2,32)
      II = 5
      IF (KCODE .EQ. 1) II = 7
      DO 70 LL = 2,32
      IOUT(LL) = NBLANK
   70 CONTINUE
      GO TO 10
   80 RETURN
C
   90 FORMAT (5X,31A4)
  100 FORMAT (/,1H )
      END

      SUBROUTINE CINVP1
C*******
C     CINVP1 INITIALIZES AND CALLS SUBROUTINE ADD FOR CINVPR
C*******
      DOUBLE PRECISION   ALPHA(2) ,BETA(2)  ,LAMBDA
      INTEGER            SCR1     ,SCR2     ,SCR11     ,SQR
      INTEGER            FILEK    ,FILEM    ,FILEB     ,CDP
      INTEGER            IFILA(7) ,IFILB(7) ,IFILC(7)  ,CSP
      INTEGER            SYSBUF   ,SWITCH
C
      COMMON   /CINVPX/  FILEK(7)  ,FILEM(7) ,FILEB(7) ,DUM(15)  ,
     1                   SCR1      ,SCR2     ,SCR(8)   ,SCR11
      COMMON   /CINVXX/  LAMBDA(2) ,SWITCH
      COMMON   /SADDX /  NOMAT     ,NZ       ,MCBS(67)
      COMMON   /ZZZZZZ/  Z(1)
      COMMON   /NAMES /  DUMM(9)   ,CSP      ,CDP      ,SQR
      COMMON   /SYSTEM/  SYSBUF
C
      EQUIVALENCE        ( MCBS( 1), IFILA(1) )
     1                  ,( MCBS( 8), ITYPAL   )
     1                  ,( MCBS(61), IFILC(1) )
     1                  ,( MCBS(13), IFILB(1) )
     1                  ,( MCBS(20), ITYPBT   )
     1                  ,( MCBS(21), BETA(1)  )
     1                  ,( MCBS( 9), ALPHA(1) )
C*******
C     FORM -(B+LAMBDA*M) ON SCR2
C*******
      NOMAT = 2
      DO 10 I = 1,7
      IFILA(I) = FILEM(I)
   10 IFILB(I) = FILEB(I)
      ALPHA(1) = -LAMBDA(1)
      ALPHA(2) = -LAMBDA(2)
      BETA(1)  = -1.D0
      BETA(2)  = 0.D0
      ITYPAL   = CDP
      ITYPBT   = CDP
      NZ = KORSZ(Z)
      IF (SWITCH .EQ. -204) NZ = NZ - 2*SYSBUF
      IFILC(1) = SCR2
      IF (SWITCH .NE. 0) IFILC(1) = SCR11
      IFILC(2) = FILEK(2)
      IFILC(3) = FILEK(3)
      IFILC(4) = 1
      IFILC(5) = CDP
      CALL SADD (Z,Z)
C*******
C     FORM (LAMBDA**2*M+LAMBDA*B+K) ON SCR1
C*******
      DO 30 I = 1,7
   30 IFILA(I) = FILEK(I)
      IFILB(1) = IFILC(1)
      IFILB(2) = FILEK(2)
      IFILB(3) = FILEK(3)
      IFILB(4) = SQR
      ALPHA(2) = 0.D0
      BETA(1)  = -LAMBDA(1)
      BETA(2)  = -LAMBDA(2)
      IFILB(5) = CDP
      ALPHA(1) = 1.D0
      IFILC(1) = SCR1
      CALL SADD (Z,Z)
      RETURN
      END

      SUBROUTINE FRRD1C (FRL,FRQSET,MDD,BDD,KDD,IFR,ULL,LLL,SCR1,SCR2,
     1                   SCR3,SCR4,IGOOD)
C                                         (A)      (B)        (C)
C     THIS ROUTINE FORMS AND DECOMPOSES   KDD + I*W*BDD - W**2*MDD
C     WHERE  W = OMEGA, CYCLIC FREQ. AND I = SQUARE ROOT MINUS ONE
C
C     THE DECOMPOSITION ROUTINES ARE CALLED ACCORDING TO THE FOLLOWING
C     TABLE AS DETERMINED BY THE MATRIX RESULTING FROM THE ADDITION
C
C     IF MATRIX IS     COMPLEX SYMMETRIC    CALL SDCOMP
C                              UNSYMMETRIC  CALL CDCOMP
C                      REAL    SYMMETRIC    CALL SDCOMP
C                              UNSYMMETRIC  CALL DECOMP
C
      INTEGER          FA,FL,SCR1,SCR2,FRL,FU,FRQ SET,BDD,ULL,LLL,SR1,
     1                 SR2,SCR3,SYSBUF,SCR4,SR3,CHLSKY,NAME(2),
     2                 MCORE(1),ICORE(1)
      DOUBLE PRECISION DET,MINDA,AMCB(2),BMCB(2),CMCB(2),DDR,DDC,MINDD,
     1                 DETT
      CHARACTER        UFM*23
      COMMON /XMSSG /  UFM
      COMMON /SYSTEM/  KSYSTM(63)
      COMMON /CDCMPX/  FA(7),FL(7),FU(7),SR1,SR2,SR3,DET(2),POWR,NX,
     1                 MINDA,IB,IBBAR
      COMMON /DCOMPX/  IA(7),IL(7),IU(7),ISCR1,ISCR2,ISCR3,DETT,IPOW,
     1                 NY,MINDIA,IIB,IIBB,ICBR(3)
      COMMON /SFACT /  MFA(7),MFL(7),MFC(7),M1FIL,M2FIL,MXX,DDR,DDC,
     1                 POWER,M3FIL,MINDD,CHLSKY
      COMMON /SADDX /  NOMAT,LCORE,MCBA(12),MCBB(12),MCBC(12),MCBD(12),
     1                 MCBE(12),MX(7)
      COMMON /ZZZZZZ/  CORE(1)
      EQUIVALENCE      (MCORE(1),CORE(1))
      EQUIVALENCE      (ICORE(1),CORE(1))
      EQUIVALENCE      (AMCB(1),MCBA(9)),(BMCB(1),MCBB(9)),
     1                 (CMCB(1),MCBC(9)),(KSYSTM(2),NOUT)
      EQUIVALENCE      (KSYSTM(1),SYSBUF),(KSYSTM(55),IPREC)
      DATA    NAME  /  4HFRRD,4H1C  /
C
C
      NX = KORSZ(CORE)
      NZ = NX - SYSBUF
C
C     PICK UP CURRENT FREQUENCY
C
      CALL GOPEN  (FRL,CORE(NZ+1),0)
      CALL SKPREC (FRL,FRQSET-1)
      CALL FREAD  (FRL,CORE,IFR,1)
      W  = CORE(IFR)
      CALL CLOSE  (FRL,1)
C
C     ADD MATRICES TOGETHER
C
      MCBA(1) = KDD
      MCBB(1) = BDD
      MCBC(1) = MDD
      CALL RDTRL (MCBA)
      CALL RDTRL (MCBB)
      CALL RDTRL (MCBC)
      IF (MCBA(1).GT.0 .AND. MCBC(1).GT.0) GO TO 20
      WRITE  (NOUT,10) UFM
   10 FORMAT (A23,', EITHER STIFFNESS MATRIX OR MASS MATRIX IS MISSING')
      CALL MESAGE (-37,0,NAME)
C
   20 MCBA(8) = 2
      MCBB(8) = 4
      MCBC(8) = 2
      AMCB(1) = 1.0D0
      AMCB(2) = 0.0D0
      BMCB(1) = 0.0D0
      BMCB(2) = W
      CMCB(1) =-W*W
      CMCB(2) = 0.0D0
      IF (MCBB(1) .GT. 0) GO TO 30
C
C     NO BDD TO BE ADDED
C
      MCBB(1) = 0
      MCBB(8) = 0
      BMCB(2) = 0.0D0
C
   30 MX(1)   = SCR3
      MX(2)   = MCBA(2)
      MX(3)   = MCBA(3)
      MX4A    = 6
      MX4B    = 6
      MX4C    = 6
      IF (MCBA(1) .GT. 0) MX4A = MCBA(4)
      IF (MCBB(1) .GT. 0) MX4B = MCBB(4)
      IF (MCBC(1) .GT. 0) MX4C = MCBC(4)
      MX(4) = MIN0(MX4A,MX4B,MX4C)
      MX(5) = 2 + IPREC
      IF (MCBA(1).GT.0 .AND. MCBA(5).GT.2) GO TO 40
      IF (MCBB(1) .GT. 0) GO TO 40
      IF (MCBC(1).GT.0 .AND. MCBC(5).GT.2) GO TO 40
      MX(5) = IPREC
   40 CONTINUE
      LCORE = NX
      NOMAT = 3
      CALL SADD  (CORE,CORE)
      CALL WRTTRL (MX)
C
C     SET UP TO DECOMPOSE MATRICES
C
      FA(1) = SCR3
      CALL RDTRL (FA)
      IGOOD = 1
      IF (FA(4) .EQ. 6) GO TO 120
      IF (FA(5) .LE. 2) GO TO 150
      FL(1) = LLL
      FU(1) = ULL
      DO 50 I = 2,7
      FL(I) = FA(I)
      FU(I) = FA(I)
   50 CONTINUE
      FL(4) = 4
      FU(4) = 5
      SR1   = SCR1
      SR2   = SCR2
      SR3   = SCR4
      CALL CDCOMP (*100,CORE(1),CORE(1),CORE(1))
      IGOOD = 0
      CALL WRTTRL (FL)
      CALL WRTTRL (FU)
C
C     FORCE RE-EVALUATION OF DECOMP PARAM IF W = 0.0
C
   60 IF (W .NE. 0.0) GO TO 70
      IB    = 0
      IBBAR = 0
   70 RETURN
C
C     MATRIX SINGULR
C
  100 I = 5
      IF (W .NE. 0.0) I = -5
      CALL MESAGE (I,SCR3,NAME)
      GO TO 60
C
C     USE SDCOMP TO PERFORM DECOMPOSITION
C
  120 MFA(1) = SCR3
      MFL(1) = LLL
      MFC(1) = ULL
      DO 130 I = 2,7
      MFA(I) = FA(I)
      MFL(I) = FA(I)
      MFC(I) = FA(I)
  130 CONTINUE
      MFL(4) = 4
      M1FIL  = SCR1
      M2FIL  = SCR2
      M3FIL  = SCR4
      MXX    = KORSZ(MCORE)
      CHLSKY = 0
      CALL SDCOMP (*100,MCORE,MCORE,MCORE)
      IGOOD  = 0
C
C     DIRECTION FOR FRRD1D TO USE  FBS RATHER THAN GFBS
C
      ULL = -IABS(ULL)
C
      CALL WRTTRL (MFL)
      GO TO 60
C
C     USE DECOMP TO PERFORM DECOMPOSITION
C
  150 IA(1) = SCR3
      IL(1) = LLL
      IU(1) = ULL
      DO 160 I = 2,7
      IA(I) = FA(I)
      IL(I) = FA(I)
      IU(I) = FA(I)
  160 CONTINUE
      IL(4) = 4
      IU(4) = 5
      ISCR1 = SCR1
      ISCR2 = SCR2
      ISCR3 = SCR4
      NY    = KORSZ(ICORE)
      CALL DECOMP (*100,ICORE,ICORE,ICORE)
      CALL WRTTRL (IL)
      CALL WRTTRL (IU)
      IGOOD = 0
      RETURN
      END

      SUBROUTINE APD
C
      EXTERNAL        ANDF,ORF
      LOGICAL         LMKAER ,LSKIP,LSET,LSPLIN
      INTEGER         IZ(1),FLAG,SILGP
      INTEGER         EID,PID,CP,CIDBX,ACSID,SILB,SCR1,SCR2,SCR3,SCR4,
     1                SCR5,ECTA,BGPA,GPLA,USETA,SILA,CSTMA,ACPT,BUF10,
     2                BUF11,BUF12
      INTEGER         CAERO2(3),CAERO3(3),CAERO4(3),CAERO5(3)
      INTEGER         PAERO2(3),PAERO3(3),PAERO4(3),PAERO5(3)
      INTEGER         KSPL(3),ANDF,FILE
      INTEGER         SPLIN3(3)
      INTEGER         CAERO1(3),PAERO1(3),AERO(3),SPLIN 1(3),SPLIN 2(3),
     1                SET1(3),SET2(3),MKAER 2(3),MKAER 1(3),FLUTT R(3),
     2                AEFACT(3),FLFACT(3),BUF(7),MSG(7),
     3                BUF1,BUF2,BUF3,BUF4,BUF5,BUF6,BUF7,BUF8,BUF9,
     4                EDT,EQDYN,ECT,BGPDT,SILD,USETD,CSTM,
     5                EQAERO,SPLINE,AEROR,FLIST,GPLD,NAM(2),
     6                AERX(3),SYMXZ,SYMXY,CORWDS,RDREW,CLSREW,
     7                ORF,SYSBUF,WTREW,PSPA,NBCA(3)
      INTEGER         CA2S,CA2E,CA3S,CA3E,CA4S,CA4E,CA5S,CA5E
      INTEGER         PA2S,PA2E,PA3S,PA3E,PA4S,PA4E,PA5S,PA5E
      INTEGER         MSG1(9),MSG2(5),MSG3(6),MSG4(10)
      COMMON /BLANK / NK,NJ,LUSETA,BOV
      COMMON /SYSTEM/ SYSBUF,NOT
      COMMON /APD1C / EID,PID,CP,NSPAN,NCHORD,LSPAN,LCHORD,IGID,
     1                X1,Y1,Z1,X12,X4,Y4,Z4,X43,XOP,X1P,ALZO,MCSTM,
     2                NCST1,NCST2,CIDBX,ACSID,IACS,SILB,NCRD,
     3                SCR1,SCR2,SCR3,SCR4,SCR5,ECTA,BGPA,GPLA,USETA,
     4                SILA,CSTMA,ACPT,BUF10,BUF11,BUF12,NEXT,LEFT,ISILN,
     5                NCAM,NAEF1,NAEF2,NCA1,NCA2,CA2S,CA2E,CA3S,CA3E,
     6                CA4S,CA4E,NPA1,NPA2,PA2S,PA2E,PA3S,PA3E,PA4S,PA4E,
     7                CA5S,CA5E,PA5S,PA5E
      COMMON /TWO   / ITWO(32)
      COMMON /BITPOS/ IBIT(64)
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE     (Z(1), IZ(1))
      EQUIVALENCE     (AERX(1),SYMXZ),(AERX(2),SYMXY),(AERX(3),BREF)
      DATA    RDREW , CLSREW,WTREW /0,1,1 /
      DATA    MSG1  / 4HSETI,4H AND,4H/OR ,4HSPLI,4HNEI ,4HCARD,4HS RE,
     1                4HQUIR,4HED  /
      DATA    MSG2  / 4HNO A,4HERO ,4HCARD,4H FOU,4HND    /
      DATA    MSG3  / 4HNO C,4HAERO,4H  CA,4HARDS,4HFOUN,4HD    /
      DATA    MSG4  / 4HNEIT,4HHER ,4HMKAE,4HRO1 ,4HOR  ,4HMKAE,4HRO2 ,
     1                4HCARD,4HS FO,4HUND /
      DATA    CAERO2/ 4301,43, 0/ , CAERO3 /4401,44, 0 /
      DATA    CAERO4/ 4501,45, 0/ , PAERO2 /4601,46, 0 /
      DATA    PAERO3/ 4701,47, 0/ , PAERO4 /4801,48, 0 /
      DATA    CAERO5/ 5001,50, 0/ , PAERO5 /5101,51, 0 /
      DATA    SPLIN3/ 4901,49, 0/
      DATA    KSPL  / 200 , 2, 0/
      DATA    CAERO1/ 3002,30,16 /, PAERO1 /3102,31,0  /,
     1        AERO  / 3202,32,0  /, SPLIN1 /3302,33,0  /,
     2        SPLIN2/ 3402,34,0  /, SET1   /3502,35,0  /,
     3        SET2  / 3602,36,0  /, MKAER2 /3702,37,0  /,
     4        MKAER1/ 3802,38,0  /, FLUTTR /3902,39,0  /,
     5        AEFACT/ 4002,40,0  /, FLFACT /4102,41,0  /,
     6        NBCA  / 3002,46,0/
      DATA    EDT   , EQDYN,  ECT, BGPDT, SILD, USETD, CSTM, GPLD /
     1        101   , 102,    103, 104,   105,  106,   107,  108  /
      DATA    EQAERO, SPLINE, AEROR, FLIST  /
     1        201   , 206,    207,   209    /
     2
      DATA    MSG   / 7*0 /,  NAM / 4HAPD ,4H    /
C
      LCA  = CAERO1(3)
      NOGO = 0
      BUF1 = KORSZ(IZ) - SYSBUF
      BUF2 = BUF1 - SYSBUF
      BUF3 = BUF2 - SYSBUF
      BUF4 = BUF3 - SYSBUF
      BUF5 = BUF4 - SYSBUF
      BUF6 = BUF5 - SYSBUF
      BUF7 = BUF6 - SYSBUF
      BUF8 = BUF7 - SYSBUF
      BUF9 = BUF8 - SYSBUF
      BUF10= BUF9 - SYSBUF
      BUF11= BUF10- SYSBUF
      BUF12= BUF11- SYSBUF
      SCR1 = 301
      SCR2 = 302
      SCR3 = 303
      SCR4 = 304
      SCR5 = 305
      ECTA = 202
      BGPA = 203
      SILA = 204
      USETA= 205
      ACPT = 208
      CSTMA= 210
      GPLA = 211
      SILGP= 212
      LAST = BUF12 - 1
      IF (LAST .LE. 0) GO TO 995
      NJ   = 0
      NK   = 0
      I17  = IBIT(17)
      I20  = IBIT(20)
      PSPA = ORF(ITWO(I17),ITWO(I20))
C
C     READ AERO CARDS
C
      LEFT = LAST
      FILE = EDT
      CALL PRELOC (*940,Z(BUF1),EDT)
      CALL LOCATE (*800,Z(BUF1),AERO,FLAG)
      CALL READ (*960,*970,EDT,Z(1),6,1,FLAG)
      ACSID= IZ(1)
      IZX  = 2
      VSOUND = Z(IZX)
      IZX  = 3
      BREF = Z(IZX)
      BOV  = 0.0
      IF (VSOUND .NE. 0.0) BOV = BREF/(2.0*VSOUND)
      IZX  = 5
      SYMXZ= IZ(IZX)
      IZX  = 6
      SYMXY= IZ(IZX)
C
C     READ AEFACT CARDS
C
      NAEF2 = 0
      CALL APDR (EDT,Z,LEFT,NAEF1,NAEF2,FLAG,BUF1,AEFACT)
C
C     READ CSTM TABLE
C
      FILE  = CSTM
      NCST2 = NAEF2
      NCST1 = 0
      MCSTM = 0
      BUF(1)= CSTM
      CALL RDTRL(BUF)
      IF (BUF(1) .NE. CSTM) GO TO 100
      CALL GOPEN (CSTM,Z(BUF2),RDREW)
      NCST1 = NCST2 + 1
      CALL READ (*980,*80,CSTM,Z(NCST1),LEFT,0,NCST2)
      GO TO 970
   80 CALL CLOSE (CSTM,CLSREW)
      LEFT  = LEFT  - NCST2
      NCST2 = NCST1 + NCST2 - 1
C
C     FIND LARGEST CID OF CSTM
C
      DO 90 J = NCST1,NCST2,14
      IF (IZ(J) .LT. MCSTM) GO TO 90
      MCSTM = IZ(J)
   90 CONTINUE
C
C     FIND AC TRANS
C
  100 IF (ACSID .EQ. 0) GO TO 120
      IF (NCST1 .EQ. 0) GO TO 880
      DO 110 IACS = NCST1,NCST2,14
      IF (IZ(IACS) .EQ. ACSID) GO TO 120
  110 CONTINUE
      GO TO 880
C
C     WRITE CSTM TO CSTMA
C
  120 CALL GOPEN (CSTMA,Z(BUF2),WTREW)
      IF (MCSTM .NE. 0) CALL WRITE (CSTMA,Z(NCST1),NCST2-NCST1+1,0)
      NCSA = MCSTM
C
C     READ EQDYN INTO CORE
C
      NEXT = NCST2 + 1
      FILE = EQDYN
      CALL GOPEN (EQDYN,Z(BUF3),RDREW)
      CALL SKPREC (EQDYN,1)
      CALL READ (*980,*140,EQDYN,Z(NEXT),LEFT,0,NX)
      GO TO 970
  140 CALL CLOSE (EQDYN,CLSREW)
      BUF(1) = EQDYN
      CALL RDTRL (BUF)
      NEXTRA = BUF(3)
C
C     CIDBX = LARGEST ID
C     NCRD  = NUMBER OF GRID AND SCALAR POINTS
C
      NCRD  = BUF(2) - NEXTRA
      NCRDO = NCRD
      CIDBX = 1000000
C
C     WRITE SECOND RECORD OF EQDYN ONTO SCR1
C
      CALL GOPEN (SCR1,Z(BUF3),WTREW)
      CALL WRITE (SCR1,Z(NEXT),NX,0)
C
C     READ BGPDT
C
      FILE = BGPDT
      CALL GOPEN (BGPDT,Z(BUF4),RDREW)
      CALL READ (*980,*150,BGPDT,Z(NEXT),LEFT,0,NX)
      GO TO 970
  150 CALL CLOSE (BGPDT,CLSREW)
C
C     WRITE BGPDT TO BGPA
C
      CALL GOPEN (BGPA,Z(BUF4),WTREW)
      CALL WRITE (BGPA,Z(NEXT),NX,0)
C
C     READ USETD
C
      FILE = USETD
      CALL GOPEN (USETD,Z(BUF5),RDREW)
      CALL READ (*980,*160,USETD,Z(NEXT),LEFT,0,NX)
      GO TO 970
  160 CALL CLOSE (USETD,CLSREW)
C
C     MASK IN PS AND PA BITS
C
      N2 = NEXT + NX - 1
      DO 170 I = NEXT,N2
  170 IZ(I) = ORF(IZ(I),PSPA)
C
C     WRITE USETD TO USETA
C
      FILE = USETA
      CALL GOPEN (USETA,Z(BUF5),WTREW)
      CALL WRITE (USETA,Z(NEXT),NX,0)
C
C     READ ECT
C
      FILE   = ECT
      BUF(1) = ECT
      CALL GOPEN (ECTA,Z(BUF6),WTREW)
      CALL RDTRL (BUF)
      IF (BUF(1) .NE. ECT) GO TO 210
      CALL GOPEN (ECT,Z(BUF7),RDREW)
  180 CALL READ (*200,*190,ECT,Z(NEXT),LEFT,0,NX)
      GO TO 970
  190 CALL WRITE (ECTA,Z(NEXT),NX,1)
      GO TO 180
  200 CALL CLOSE (ECT,CLSREW)
  210 CALL WRITE (ECTA,NBCA,3,0)
C
C     READ FIRST RECORD OF SILD INTO CORE
C
      FILE = SILD
      CALL GOPEN (SILD,Z(BUF8),RDREW)
      CALL READ (*980,*220,SILD,Z(NEXT),LEFT,0,NX)
      GO TO 970
C
C     WRITE FIRST RECORD OF SILD ONTO SILA
C
  220 BUF(1) = SILD
      CALL RDTRL (BUF)
C
C     SILB  + 6 = NEXT DOF IN PROBLEM
C     ISILN + 6 = NEXT DOF WITHOUT EXTRA POINTS
C
      SILB  = BUF(2) - 5
      ISILN = SILB - NEXTRA
      CALL GOPEN (SILA,Z(BUF7),WTREW)
      CALL WRITE (SILA,Z(NEXT),NX,0)
C
C     READ SECOND RECORD OF SILD INTO CORE
C
      CALL READ (*980,*230,SILD,Z(NEXT),LEFT,0,NX)
      GO TO 970
  230 CALL CLOSE (SILD,CLSREW)
C
C     WRITE SECOND RECORD OF SILD ONTO SCR2
C
      CALL GOPEN (SCR2,Z(BUF8),WTREW)
      CALL WRITE (SCR2,Z(NEXT),NX,0)
C
C     COPY GPLD TO GPLA
C
      FILE = GPLD
      CALL GOPEN (GPLD,Z(BUF9),RDREW)
      CALL READ (*980,*235,GPLD,Z(NEXT),LEFT,0,NX)
      GO TO 970
  235 CALL CLOSE (GPLD,CLSREW)
      CALL GOPEN (GPLA,Z(BUF9),WTREW)
      CALL WRITE (GPLA,Z(NEXT),NX,0)
C
C     READ CAERO CARDS INTO CORE
C
      NCA2 = NCST2
      LCAS = NCA2 + 1
      CALL APDR (EDT,Z,LEFT,NCA1,NCA2,FLAG,BUF1,CAERO1)
      CA2E = NCA2
      CALL APDR (EDT,Z,LEFT,CA2S,CA2E,FLAG,BUF1,CAERO2)
      CA3E = CA2E
      CALL APDR (EDT,Z,LEFT,CA3S,CA3E,FLAG,BUF1,CAERO3)
      CA4E = CA3E
      CALL APDR (EDT,Z,LEFT,CA4S,CA4E,FLAG,BUF1,CAERO4)
      CA5E = CA4E
      CALL APDR (EDT,Z,LEFT,CA5S,CA5E,FLAG,BUF1,CAERO5)
      LCAE = MAX0(NCA2,CA2E,CA3E,CA4E,CA5E)
C
C     READ PAERO CARDS INTO CORE
C
      NPA2 = CA5E
      CALL APDR (EDT,Z,LEFT,NPA1,NPA2,FLAG,BUF1,PAERO1)
      PA2E = NPA2
      CALL APDR (EDT,Z,LEFT,PA2S,PA2E,FLAG,BUF1,PAERO2)
      PA3E = PA2E
      CALL APDR (EDT,Z,LEFT,PA3S,PA3E,FLAG,BUF1,PAERO3)
      PA4E = PA3E
      CALL APDR (EDT,Z,LEFT,PA4S,PA4E,FLAG,BUF1,PAERO4)
      PA5E = PA4E
      CALL APDR (EDT,Z,LEFT,PA5S,PA5E,FLAG,BUF1,PAERO5)
      NEXT = PA5E + 1
      CALL CLOSE (EDT,CLSREW)
      IF (NCA1.EQ.0 .AND. CA2S.EQ.0 .AND. CA3S.EQ.0 .AND. CA4S.EQ.0
     1   .AND. CA5S.EQ.0) GO TO 820
C
C     OPEN ACPT
C
      CALL GOPEN (ACPT,Z(BUF1),WTREW)
C
C     CALL CAERO TYPE
C
      IF (NCA1.NE.0 .OR. CA2S.NE.0) CALL APD12
      IF (CA3S .NE. 0) CALL APD3
      IF (CA4S .NE. 0) CALL APD4
      IF (CA5S .NE. 0) CALL APD5
      LUSETA = LUSETA + 5
      CALL WRITE (CSTMA,0,0,1)
      CALL CLOSE (CSTMA,CLSREW)
      CALL CLOSE (ACPT,CLSREW)
      CALL WRITE (ECTA,0,0,1)
      CALL CLOSE (ECTA,CLSREW)
      CALL WRITE (BGPA,0,0,1)
      CALL CLOSE (BGPA,CLSREW)
      CALL WRITE (GPLA,0,0,1)
      CALL CLOSE (GPLA,CLSREW)
      CALL WRITE (USETA,0,0,1)
      CALL CLOSE (USETA,CLSREW)
      CALL WRITE (SILA,0,0,1)
      CALL WRITE (SCR1,0,0,1)
      CALL CLOSE (SCR1,CLSREW)
      CALL WRITE (SCR2,0,0,1)
      CALL CLOSE (SCR2,CLSREW)
C
C     READ SECOND RECORD OF EQAERO TABLE OFF SCR1
C
      FILE = SCR1
      CALL GOPEN (SCR1,Z(BUF3),RDREW)
      I = NEXT
  411 CONTINUE
      IF (I+2 .GT. NEXT+LEFT) GO TO 970
      CALL READ (*980,*420,SCR1,Z(I),2,0,NX)
      IZ(I+2) = 0
      I = I + 3
      GO TO 411
  420 CALL CLOSE (SCR1,CLSREW)
      NX = I - NEXT
C
C     SORT TABLE ON SILD VALUE
C
      CALL SORT (0,0,3,2,Z(NEXT),NX)
      NY = NEXT + NX - 1
C
C     REPLACE THIRD ENTRIES WITH INTERNAL GRID ID WITH OUT EXTRA
C
      K = 0
      DO 412 I = NEXT,NY,3
      IF (IZ(I+1)-(IZ(I+1)/10)*10 .EQ. 3) GO TO 412
      K = K + 1
      IZ(I+2) = K
  412 CONTINUE
C
C     SORT EQAERO TABLE
C
      CALL SORT (0,0,3,1,Z(NEXT),NX)
C
C     CHECK FOR DUPLICATE EXT ID
C
      N1 = NEXT + 3
      DO 430 I = N1,NY,3
      IF (IZ(I-3) .NE. IZ(I)) GO TO 430
      CALL EMSG (0,2329,1,2,0)
      NOGO = 1
      WRITE  (NOT,421) IZ(I)
  421 FORMAT (10X,26HDUPLICATE EXTERNAL ID NO. ,I8,11H GENERATED.)
  430 CONTINUE
C
C     WRITE FIRST RECORD OF EQAERO TABLE
C
      CALL GOPEN (EQAERO,Z(BUF3),WTREW)
      DO 440 I = NEXT,NY,3
      BUF(1) = IZ(I  )
      BUF(2) = IZ(I+2)
  440 CALL WRITE (EQAERO,BUF,2,0)
      CALL WRITE (EQAERO,0,0,1)
C
C     WRITE SECOND RECORD OF EQAERO TABLE
C
      DO 441 I = NEXT,NY,3
  441 CALL WRITE (EQAERO,IZ(I),2,0)
      CALL WRITE (EQAERO,0,0,1)
      CALL CLOSE (EQAERO,CLSREW)
C
C     PUT ON SPLINE A RECORD OF K POINTS WITH
C     EXTERNAL ID , BGPA POINTERS, AND K COLUMN NUMBER
C
      FILE = USETA
      N1   = NEXT + NX
      CALL GOPEN (USETA,Z(BUF3),RDREW)
      CALL READ (*980,*442,USETA,Z(N1),LEFT-NX,0,N2)
      GO TO 970
  442 CALL CLOSE (USETA,CLSREW)
      CALL GOPEN (SPLINE,Z(BUF3),WTREW)
      CALL WRITE (SPLINE,KSPL,3,0)
      MASK = IBIT(19)
      MASK = ITWO(MASK)
      KO   = 1
      N3   = (NCRDO+NEXTRA)*3 + NEXT
      DO 444 I = NEXT,NY,3
      IF (MOD(IZ(I+1),10) .NE. 1) GO TO 444
      K  = 0
      N4 = IZ(I+1)/10 - 2
      DO 443 J = 1,6
      IF (ANDF(IZ(N1+N4+J),MASK) .NE. 0) K = K + 1
  443 CONTINUE
      IF (K .EQ. 0) GO TO 444
      BUF(1) = IZ(I  )
      BUF(2) = IZ(I+2)
      BUF(3) = KO
      CALL WRITE (SPLINE,BUF,3,0)
      KO = KO + K
  444 CONTINUE
      CALL WRITE (SPLINE,0,0,1)
      CALL CLOSE (SPLINE,2)
C
C     READ SECOND RECORD OF SILA TABLE
C
      CALL GOPEN (SCR2,Z(BUF8),RDREW)
      CALL READ  (*980,*450,SCR2,Z(NEXT),LEFT,0,NX)
      GO TO 970
  450 CALL CLOSE (SCR2,CLSREW)
      CALL WRITE (SILA,Z(NEXT),NX,1)
      CALL CLOSE (SILA,CLSREW)
C
C     BUILD SILGP TABLE
C
      CALL GOPEN (SILGP,Z(BUF8),W TREW)
      NY = NEXT + NX - 1
      K  = 0
      DO 451 I = NEXT,NY,2
      IZ(NEXT+K) = IZ(I)
      K  = K + 1
  451 CONTINUE
      CALL WRITE (SILGP,IZ(NEXT),K,1)
      CALL CLOSE (SILGP,CLSREW)
C
C     WRITE RECORD
C
      CALL GOPEN (AEROR,Z(BUF2),WTREW)
      CALL WRITE (AEROR,AERX,3,1)
C
C     READ IN MKAERO1 CARDS
C
      FILE = EDT
      CALL PRELOC (*940,Z(BUF1),EDT)
      LMKAER = .FALSE.
      CALL LOCATE (*510,Z(BUF1),MKAER1,FLAG)
      CALL READ (*980,*460,EDT,Z(NEXT),LEFT,0,NX)
      GO TO 970
  460 N1 = NEXT
      LMKAER = .TRUE.
  470 N2 = N1 + 7
      DO 490 I = N1,N2
      IF (IZ(I) .EQ. -1) GO TO 500
      BUF(1) = IZ(I)
      N3 = N2 + 1
      N4 = N3 + 7
      DO 480 J = N3,N4
      IF (IZ(J) .EQ. -1) GO TO 490
      BUF(2) = IZ(J)
  480 CALL WRITE (AEROR,BUF,2,0)
  490 CONTINUE
  500 IF (N4-NEXT+1 .GE. NX) GO TO 510
      N1 = N1 + 16
      GO TO 470
C
C     READ IN MKAER2 CARDS
C
  510 CALL LOCATE (*530,Z(BUF1),MKAER2,FLAG)
      CALL READ (*980,*520,EDT,Z(NEXT),LEFT,0,NX)
      GO TO 970
  520 CALL WRITE (AEROR,Z(NEXT),NX,0)
      LMKAER =.TRUE.
  530 CALL WRITE (AEROR,0,0,1)
      CALL CLOSE (AEROR,CLSREW)
      IF (LMKAER) GO TO 540
      GO TO 870
C
C     PROCESS SET1 CARDS
C
  540 CALL OPEN (*940,SPLINE,Z(BUF2),3)
      LSET =.FALSE.
      CALL LOCATE (*610,Z(BUF1),SET1,FLAG)
      LSET =.TRUE.
      CALL READ (*980,*550,EDT,Z(NEXT),LEFT,0,NX)
      GO TO 970
  550 N3 = NEXT + NX
      CALL GOPEN (EQAERO,Z(BUF3),RDREW)
      LEFT = CORWDS(IZ(N3),IZ(LAST))
      FILE = EQAERO
      CALL READ (*980,*560,EQAERO,Z(N3),LEFT,0,N4)
      GO TO 970
  560 N1 = NEXT
      FILE = EDT
      N2 = N1 + NX - 1
      CALL CLOSE (EQAERO,CLSREW)
      LEFT = CORWDS(IZ(NEXT),IZ(LAST))
C
C     CONVERT SET1 TO INTERNAL COOR NO
C
      LSKIP = .TRUE.
      DO 600 I = N1,N2
      IF (IZ(I) .EQ. -1) GO TO 590
      IF (LSKIP) GO TO 580
      KID = IZ(I)
      CALL BISLOC (*930,KID,IZ(N3),2,N4/2,JP)
      K = N3 + JP
      IF (IZ(K) .GT. NCRDO) GO TO 930
      IZ(I) = IZ(K)
      GO TO 600
  580 LSKIP =.FALSE.
      GO TO 600
  930 CALL EMSG (0,2330,1,2,0)
      NOGO = 1
      WRITE  (NOT,931) IZ(N1),IZ(I)
  931 FORMAT (10X,24HSET1 OR SPLIN3 CARD NO. ,I8,28H REFERENCES EXTERNAL
     1 ID NO. ,I8,22H WHICH DOES NOT EXIST.)
      GO TO 600
  590 LSKIP = .TRUE.
  600 CONTINUE
C
C     WRITE OUT SET1 CARD ON SPLINE
C
      CALL WRITE (SPLINE,SET1,3,0)
      CALL WRITE (SPLINE,Z(NEXT),NX,1)
C
C     PROCESS SET2 CARDS
C
  610 CALL LOCATE (*660,Z(BUF1),SET2,FLAG)
      LSET =.TRUE.
      CALL WRITE (SPLINE,SET2,3,0)
  620 CALL READ (*980,*650,EDT,Z(NEXT),8,0,NX)
      CALL WRITE (SPLINE,Z(NEXT),10,0)
      NX = IZ(NEXT+1)
      DO 630 I = LCAS,LCAE,LCA
      IF (IZ(I) .EQ. NX) GO TO 640
  630 CONTINUE
      GO TO 830
  640 CALL WRITE (SPLINE,Z(I),LCA,0)
      GO TO 620
  650 CALL WRITE (SPLINE,0,0,1)
C
C     PROCESS SPLINE1 CARDS
C
  660 LSPLIN =.FALSE.
      CALL LOCATE (*710,Z(BUF1),SPLIN1,FLAG)
      LSPLIN =.TRUE.
      CALL WRITE (SPLINE,SPLIN 1,3,0)
      ASSIGN 670 TO IRET
  670 CALL READ (*980,*700,EDT,Z(NEXT),6,0,NX)
      GO TO 671
C
C     INTERNAL ROUTINE TO ATTACH CAERO DATA TO SPLINE
C
  671 CONTINUE
      CALL WRITE (SPLINE,Z(NEXT),10,0)
      NX = IZ(NEXT+1)
      DO 680 I = LCAS,LCAE,LCA
      IF (IZ(I) .EQ. NX) GO TO 690
  680 CONTINUE
      GO TO 810
  690 CALL WRITE (SPLINE,Z(I),LCA,0)
      IF (IZ(NEXT+2) .GT. IZ(NEXT+3)) GO TO 691
      J1 = IZ(I+4)*IZ(I+3) + IZ(I) - 1
      IF (IZ(NEXT+2).LT.IZ(I) .OR. IZ(NEXT+3).GT.J1) GO TO 691
      GO TO 693
  691 NOGO = 1
      CALL EMSG (0,2331,1,2,0)
      WRITE  (NOT,692) IZ(NEXT),IZ(I)
  692 FORMAT (10X,30HBOX PICKED ON SPLINE CARD NO. ,I8,32HNOT GENERATED
     1BY CAERO CARD NO. ,I8,1H.)
  693 GO TO IRET, (670,720,7651)
  700 CALL WRITE (SPLINE,0,0,1)
C
C     PROCESS SPLINE2 CARDS
C
  710 CALL LOCATE (*760,Z(BUF1),SPLIN2,FLAG)
      LSPLIN =.TRUE.
      CALL WRITE (SPLINE,SPLIN 2,3,0)
      ASSIGN 720 TO IRET
  720 CALL READ (*980,*750,EDT,Z(NEXT),10,0,NX)
      GO TO 671
  750 CALL WRITE (SPLINE,0,0,1)
C
C     PROCESS  SPLINE3 CARDS
C
  760 NSPLIE = NEXT - 1
      CALL APDR (EDT,Z,LEFT,NSPLIS,NSPLIE,FLAG,BUF1,SPLIN3)
      IF (NSPLIS .EQ. 0) GO TO 769
      FILE = EQAERO
      N3   = NSPLIE + 1
      CALL GOPEN (EQAERO,Z(BUF3),RDREW)
      CALL READ (*980,*761,EQAERO,Z(N3),LEFT,0,N4)
      GO TO 970
  761 FILE = EDT
      CALL CLOSE (EQAERO,CLSREW)
      N4   = N4/2
      LSET = .TRUE.
      LEFT = LEFT + FLAG
      LSPLIN = .TRUE.
      ASSIGN 7651 TO IRET
      CALL WRITE (SPLINE,SPLIN3,3,0)
      ISP = NSPLIS
      NLS = 0
C
C     PICK UP NEXT SPLIN3 AND ATTACHED CAERO
C
  765 ISP = ISP + NLS
      IF (ISP .GE. NSPLIE) GO TO 768
      CALL APDOE (IZ(ISP),Z,ISP,NSPLIE,FLAG,NLS)
      NLS = NLS + 1
      NX  = IZ(ISP+1)
      DO 766 I = LCAS,LCAE,LCA
      J   = I
      IF (IZ(I) .EQ. NX) GO TO 767
  766 CONTINUE
      GO TO 810
  767 J1  = IZ(I+3)*IZ(I+4) + NX - 1
      IZ(NEXT) = IZ(ISP)
      IF (IZ(ISP+2) .LT. IZ(ISP+1)) GO TO 691
      IF (IZ(ISP+2) .GT. J1) GO TO 691
C
C     CONVERT TO INTERNAL ID
C
      N2 = NLS - 4
      DO 7652 I = 1,N2,3
      N1 = IZ(ISP+I+3)
      CALL BISLOC (*7653,N1,IZ(N3),2,N4,JP)
      IF (IZ(N3+JP) .GT. NCRDO) GO TO 7653
      IZ(ISP+I+3) = IZ(N3+JP)
 7652 CONTINUE
 7651 CALL WRITE (SPLINE,NLS+LCA,1,0)
      CALL WRITE (SPLINE,IZ(ISP),NLS,0)
      NLS = NLS + 1
      CALL WRITE (SPLINE,IZ(J),LCA,0)
      GO TO 765
 7653 NOGO = 1
      CALL EMSG (0,2330,1,2,0)
      WRITE (NOT,931) IZ(ISP),N1
      GO TO 7651
  768 CALL WRITE (SPLINE,0,0,1)
  769 CALL CLOSE (SPLINE,CLSREW)
C
C     CREATE FLIST TABLE
C
      CALL GOPEN (FLIST,Z(BUF2),WTREW)
      CALL LOCATE (*800,Z(BUF1),AERO,FLAG)
      CALL READ (*980,*770,EDT,Z(NEXT),LEFT,0,NX)
      GO TO 970
  770 CALL WRITE (FLIST,AERO,3,0)
      CALL WRITE (FLIST,Z(NEXT),NX,1)
      CALL LOCATE (*785,Z(BUF1),FLFACT,FLAG)
      CALL READ (*980,*780,EDT,Z(NEXT),LEFT,1,NX)
      GO TO 970
  780 CALL WRITE (FLIST,FLFACT,3,0)
      CALL WRITE (FLIST,Z(NEXT),NX,1)
  785 CALL LOCATE (*900,Z(BUF1),FLUTTR,FLAG)
      CALL READ (*980,*790,EDT,Z(NEXT),LEFT,0,NX)
      GO TO 970
  790 CALL WRITE (FLIST,FLUTT R,3,0)
      CALL WRITE (FLIST,Z(NEXT),NX,1)
  900 CALL CLOSE (FLIST,CLSREW)
      CALL CLOSE (EDT,CLSREW)
      MSG(1) = AEROR
      MSG(2) = 1
      CALL WRTTRL (MSG)
      MSG(1) = EQDYN
      CALL RDTRL (MSG)
      MSG(1) = EQAERO
      MSG(2) = NCRD + NEXTRA
      CALL WRTTRL (MSG)
      MSG(1) = BGPDT
      CALL RDTRL (MSG(1))
      MSG(3) = NCRD - MSG(2)
      MSG(1) = BGPA
      MSG(2) = NCRD
      CALL WRTTRL (MSG)
      MSG(1) = SILA
      MSG(2) = LUSETA
      MSG(3) = NEXTRA
      CALL WRTTRL (MSG)
      MSG(1) = ACPT
      MSG(2) = 1
      CALL WRTTRL (MSG)
      MSG(1) = GPLA
      MSG(2) = NCRD + NEXTRA
      CALL WRTTRL (MSG)
      MSG(1) = CSTM
      CALL RDTRL (MSG)
      IF (MSG(1) .LT.0) MSG(3) = 0
      MSG(1) = CSTMA
      MSG(3) = MSG(3) + MCSTM - NCSA
      CALL WRTTRL (MSG)
      MSG(1) = USETA
      MSG(2) = LUSETA
      MSG(3) = NEXTRA
      MSG(4) = PSPA
      CALL WRTTRL (MSG)
      MSG(1) = EDT
      CALL RDTRL (MSG)
      MSG(1) = FLIST
      CALL WRTTRL (MSG)
      MSG(1) = EDT
      CALL RDTRL (MSG)
      MSG(1) = SPLINE
      MSG(2) = ORF(MSG(2),ITWO(18))
      CALL WRTTRL (MSG)
      MSG(1) = ECT
      CALL RDTRL (MSG)
      N1     = (NBCA(2)-1)/16 + 2
      N2     = NBCA(2) - (N1-2)*16 + 16
      MSG(N1)= ORF(MSG(N1),ITWO(N2))
      MSG(1) = ECTA
      CALL WRTTRL (MSG)
C
C     PUT OUT SILGP TRAILER
C
      MSG(1) = SILGP
      MSG(2) = NCRD
      MSG(3) = LUSETA - NEXTRA
      MSG(4) = 0
      MSG(5) = 0
      MSG(6) = 0
      MSG(7) = 0
      CALL WRTTRL (MSG)
      IF (NOGO .EQ. 1) CALL MESAGE (-37,0,NAM)
      IF (LSET .AND. LSPLIN) RETURN
C
C     ERROR MESSAGES
C
      CALL EMSG (35,-2328,1,2,MSG1)
  800 CALL EMSG (18,-2318,1,3,MSG2)
  810 CALL EMSG (0,-2324,1,2,0)
      WRITE  (NOT,811) NX
  811 FORMAT (10X,19HCAERO  ELEMENT NO. ,I8,
     1        45H REFERENCED ON A SPLINEI CARD DOES NOT EXIST.)
  812 CALL MESAGE (-61,0,NAM)
  820 CALL EMSG (21,-2319,1,2,MSG3)
  830 CALL EMSG (0,-2325,1,2,0)
      WRITE  (NOT,831) NX
  831 FORMAT (10X,19HCAERO  ELEMENT NO. ,I8,
     1        42H REFERENCED ON A SET2 CARD DOES NOT EXIST.)
      GO TO 812
  870 CALL EMSG (38,-2322,1,2,MSG4)
  880 CALL MESAGE (-30,25,ACSID)
  940 IP1 = -1
  950 CALL MESAGE (IP1,FILE,NAM)
  995 IP1 = -8
      GO TO 950
  960 IP1 = -2
      GO TO 950
  970 IP1 = 3
      GO TO 950
  980 GO TO 960
      END

      SUBROUTINE SDR1
C
      EXTERNAL        ANDF
      INTEGER         ANDF,UE,REIG,USET,PG,ULV,UOOV,YS,GO,GM,PS,QR,
     1                UGVX,PGX,QSX,UM,UO,UR,US,IA(7),
     2                UA1,UF1,UN1,UG1,UP,UNE,UFE,UD,UA,UF,UN,UG,DYNA
      COMMON /TWO   / TWO1(32)
      COMMON /BLANK / APPEND,ITYPE(2)
      COMMON /BITPOS/ UM,UO,UR,USG,USB,UL,UA1,UF1,US,UN1,UG1,UE,UP,UNE,
     1                UFE,UD
      COMMON /SYSTEM/ ISYS(54),IPREC,IHEAT
      EQUIVALENCE     (ISYS(25),IRFNO)
      DATA    DYNA  , REIG / 4HDYNA, 4HREIG /
C
      IUM   = 304
      ISCR6 = 306
      IUR   = 0
      IUO   = 304
      IPVECT= 301
      IUS   = 304
      USET  = 101
      PG    = 102
      ULV   = 103
      UOOV  = 104
      YS    = 105
      GO    = 106
      GM    = 107
      PS    = 108
      KSS   = 110
      QR    = 111
      UGVX  = 201
      PGX   = 202
      QSX   = 203
      KFS = 109
      IUA = 302
      IUF = 303
      IUN = 302
      IUG = 306
      ISCR5 = 0
C
C     COPY PG ONTO PGX
C
      CALL SDR1A (PG,PGX)
C
C     SET FLAGS TO CONTROL LOGIC
C
      IA(1) = USET
      CALL RDTRL (IA(1))
      IF (IA(1) .LE. 0) RETURN
      IOMT   = ANDF(IA(5),TWO1(UO))
      NOUE   = ANDF(IA(5),TWO1(UE))
      ISNG   = ANDF(IA(5),TWO1(US))
      IREACT = ANDF(IA(5),TWO1(UR))
      IMULTI = ANDF(IA(5),TWO1(UM))
      ITRAN  = 1
C
C     TEST FOR DYNAMICS OR STATICS
C
      IF (NOUE.NE.0 .OR. ITYPE(1).EQ.DYNA) GO TO 10
C
C     STATICS
C
      UA = UA1
      UF = UF1
      UN = UN1
      UG = UG1
      GO TO 20
C
C     DYNAMICS
C
   10 UG = UP
      UN = UNE
      UF = UFE
      UA = UD
      IF (IHEAT .NE. 0) ITRAN = 0
      IF (IRFNO .EQ. 9) ITRAN = 0
   20 CONTINUE
C
C     IF REAL EIGENVALUE,BUCKLING,OR DYNAMICS PROBLEM UR = 0
C
      IF (ITYPE(1).EQ.DYNA .OR. ITYPE(1).EQ.REIG) GO TO 70
      IF (IREACT) 40,70,40
C
C     REACTIONS
C
   40 CALL SDR1B (IPVECT,ULV,IUR,IUA,UA,UL,UR,USET,0,0)
      ISCR5 = 305
      IF (ISNG) 50,60,50
   50 CONTINUE
      CALL SDR1B (IPVECT,QR,0,ISCR5,UF,UR,UL,USET,0,0)
      IUG = IUA
      GO TO 80
C
C     REACTS BUT NO SINGLES - MAKE QG
C
   60 CALL SDR1B (IPVECT,QR,0,ISCR5,UG,UR,UL,USET,0,0)
      CALL SDR1A (ISCR5,QSX)
      GO TO 80
C
C     NO REACT
C
C
C     NON STATICS APPROACH
C
   70 IUA = ULV
   80 IF (IOMT) 90,100,90
C
C     OMITTED POINTS
C
   90 CALL SSG2B (GO,IUA,UOOV,IUO,0,IPREC,1,ISCR6)
      CALL SDR1B (IPVECT,IUA,IUO,IUF,UF,UA,UO,USET,0,0)
      IUG = IUF
      GO TO 110
C
C     NO OMITTED POINTS
C
  100 ISAV = IUF
      IUF  = IUA
      IUN  = ISAV
  110 IF (ISNG) 120,180,120
C
C     SINGLE POINT CONSTRAINTS
C
C
C     TEST FOR PRESENCE OF YS VECTOR
C
  120 IA(1) = YS
      CALL RDTRL (IA(1))
      IF (IA(1).LT.0 .OR. IA(6).EQ.0) GO TO 130
      CALL SDR1B (IPVECT,IUF,YS,IUN,UN,UF,US,USET,1,IUS)
C
C     IUS CONTAINS EXPANDED YS FROM SPC
C
C
C     IS QS REWUESTED
C
      IA(1) = QSX
      CALL RDTRL (IA(1))
      IF (IA(1) .LE. 0) GO TO 190
C
C     COMPUTE QS
C
      CALL SSG2B (KSS,IUS,PS,IPVECT,0,IPREC,2,ISCR6)
      CALL SSG2B (KFS,IUF,IPVECT,IUS,1,IPREC,1,ISCR6)
      IF (IMULTI.NE.0 .AND. IREACT.NE.0) GO TO 160
      CALL SDR1B (IPVECT,IUS,ISCR5,ISCR6,UG,US,UF,USET,0,0)
      CALL SDR1A (ISCR6,QSX)
      GO TO 190
C
C     NO YS VECTOR
C
  130 CALL SDR1B (IPVECT,IUF,0,IUN,UN,UF,US,USET,0,0)
      IA(1) = QSX
      CALL RDTRL (IA(1))
      IF (IA(1) .LE. 0) GO TO 190
C
C     COMPUTE QS = KFS T*UF
C
      IUF1 = IUF
      IF (ITYPE(1) .NE. DYNA) GO TO 140
C
C     EXPAND  KFS TO  D SET
C
      IF (NOUE .EQ. 0) GO TO 140
      CALL SDR1B (IPVECT,KFS,0,IUS,UF,UF1,UE,USET,0,0)
      KFS = IUS
C
C     IF TRANSIENT STRIP VELOCITY AND ACCERERATION FROM IUF
C
  140 CALL SDR1D (PS,IUF,QSX,ITRAN)
      IF (ITRAN .EQ. 1) GO TO 150
      IUF1 = QSX
  150 CALL SSG2B (KFS,IUF1,PS,IPVECT,1,IPREC,2,ISCR6)
      IF (IMULTI.NE.0 .AND. IREACT.NE.0 .AND. ITYPE(1).NE.DYNA .AND.
     1    ITYPE(1).NE.REIG) GO TO 170
      CALL SDR1B (IUS,IPVECT,ISCR5,ISCR6,UG,US,UF,USET,0,0)
      CALL SDR1A (ISCR6,QSX)
      GO TO 190
  160 CALL SDR1B (IPVECT,IUS,ISCR5,ISCR6,UN,US,UF,USET,0,0)
      CALL SDR1B (IPVECT,ISCR6,0,IUS,UG,UN,UM,USET,0,0)
      CALL SDR1A (IUS,QSX)
      GO TO 190
  170 CALL SDR1B (IUS,IPVECT,ISCR5,IUF,UN,US,UF,USET,0,0)
      CALL SDR1B (IUS,IUF,0,IPVECT,UG,UN,UM,USET,0,0)
      CALL SDR1A (IPVECT,QSX)
      GO TO 190
C
C     NO SINGLE POINT CONSTRAINTS
C
  180 IUG = IUN
      IUN = IUF
C
  190 IF (IMULTI) 210,200,210
C
C     NO MULTI POINT CONSTRAINTS
C
  200 IUG = IUN
      GO TO 220
C
C     MULTI POINT CONSTRAINTS
C
  210 IUG = ISCR6
      CALL SSG2B (GM,IUN,0,IUM,0,IPREC,1,ISCR6)
      CALL SDR1B (IPVECT,IUN,IUM,IUG,UG,UN,UM,USET,0,0)
  220 CALL SDR1A (IUG,UGVX)
      RETURN
      END

      SUBROUTINE INVPWR
C
C     GIVEN A REAL SYMETRIC MATRIX, INVPWR WILL SOLVE FOR ALL OF THE
C     EIGENVALUES AND EIGENVECTORS WITHIN A SPECIFIED RANGE
C
C     DEFINITION OF INPUT AND OUTPUT PARAMETERS
C
C     FILEK(7) =  MATRIX CONTROL BLOCK FOR THE INPUT STIFFNESS MATRIX K
C     FILEM(7) =  MATRIX CONTROL BLOCK FOR THE INPUT MASS MATRIX M
C     FILELM(7)=  MATRIX CONTROL BLOCK FOR THE OUTPUT EIGENVALUES
C     FILEVC(7)=  MATRIX CONTROL BLOCK FOR THE OUTPUT EIGENVECTORS
C     SR1FIL-
C     SR7FIL   =  SCRATCH FILES REQUIRED INTERNALLY
C     LAMMIN   =  MINIMUM VALUE FOR THE EIGENVALUE
C     LAMMAX   =  MAXIMUM VALUE FOR THE EIGENVALUE
C     NOEST    =  NUMBER OF ESTIMATED EIGENVALUES WITHIN THE SPECIFIED
C                 RANGE
C     NDPLUS   =  NUMBER OF DESIRED EIGENVALUES IN THE POSITIVE RANGE
C     NDMNUS   =  NUMBER OF DESIRED EIGENVALUES IN THE NEGATIVE RANGE
C     EPS      =  CONVERGENCE CRITERIA
C
C     FILELM AND FILEVC WILL BE USED AS SR1FIL AND SR2FIL WHILE THE
C     EIGENVALUES AND EIGENVECTORS WILL BE STORED ON THE ACTUAL SR1FIL
C     AND SR2FIL. THE ORDERING OF THE EIGENVALUES AND EIGENVECTORS WILL
C     PUT THEM ON FILELM AND FILEVC IN THE CORRECT SEQUENCE AT THE END
C     OF THE SUBROUTINE
C
C     SR1FIL-FILELM CONTAINS (K-LAMBDA*M)
C     SR2FIL-FILEVC CONTAINS THE LOWER TRIANGLE L
C     SR3FIL        CONTAINS THE UPPER TRIANGLE U
C     SR4FIL        IS USED AS SCRATCH IN DECOMP
C     SR5FIL        IS USED AS SCRATCH IN DECOMP
C     SR6FIL        IS USED AS SCRATCH IN DECOMP
C     SR7FIL        CONTAINS THE VECTORS WHICH ARE USED TO ORTHOGONALIZE
C                   THE CURRENT ITERATE
C
      EXTERNAL          NORM11    ,SUB1     ,MTMSU1   ,XTRNY1   ,
     1                  NORM1     ,SUB      ,MTIMSU   ,XTRNSY
      INTEGER           SYSBUF    ,COMFLG   ,FILEK    ,NAME(2)  ,
     1                  SWITCH    ,DMPFIL   ,IZ(12)   ,STURM    ,
     2                  T1        ,T2       ,TIMED
      INTEGER           WRTREW    ,REW      ,SR1FIL   ,SR2FIL
      REAL              LAMMIN    ,LAMMAX   ,LMIN     ,Z        ,
     1                  ZZ(1)
      DOUBLE PRECISION  LAMBDA    ,LMBDA
      COMMON   /DCOMPX/ DUMXX(35) ,ISYM
      COMMON   /INVPWX/ FILEK(7)  ,FILEM(7) ,FILELM(7),FILEVC(7),
     1                  SR1FIL    ,SR2FIL   ,SR3FIL   ,SR4FIL   ,
     2                  SR5FIL    ,SR6FIL   ,SR7FIL   ,SR8FIL   ,
     3                  DMPFIL    ,LAMMIN   ,LAMMAX   ,NOEST    ,
     4                  NDPLUS    ,NDMNUS   ,EPS      ,NORTHO
      COMMON   /STURMX/ STURM     ,SHFTPT   ,KEEP(2)
      COMMON   /INVPXX/ LAMBDA    ,COMFLG   ,ITER     ,TIMED    ,
     1                  NOPOS     ,RZERO    ,NEG      ,NOCHNG   ,
     2                  IND       ,LMBDA    ,SWITCH   ,NZERO    ,
     3                  NONEG     ,IVECT    ,IREG     ,ISTART
      COMMON   /SYSTEM/ KSYSTM(65)
      COMMON   /NAMES / RD        ,RDREW    ,WRT      ,WRTREW   ,
     1                  REW       ,NOREW    ,EOFNRW
      COMMON   /ZZZZZZ/ Z(1)
      EQUIVALENCE       (ZZ(1),Z(1))
      EQUIVALENCE       (IZ(1),Z(1)), (KSYSTM(1),SYSBUF),
     1                  (KSYSTM(55),IPREC)
      DATA      NAME  / 4HINVP,4HWR  /
C
C     DEFINITION OF INTERNAL PARAMETERS
C
C     NSHIFT =  NUMBER OF SHIFT POINTS
C     ISHIFT =  CURRENT SHIFT REGION
C     NOVECT =  NUMBER OF EIGENVECTORS FOUND IN A GIVEN REGION
C     NOSKIP =  NUMBER OF VECTORS TO SKIP TO REACH THE LAST SHIFT REGION
C     NEG    =  1 = FIND NEGATIVE ROOTS
C               0 = FIND ONLY POSITIVE ROOTS
C              -1 = WE ARE NOW SEARCHING FOR THE NEGATIVE ROOTS
C     LAMBDA =  THE CURRENT SHIFT POINT
C     RZEROP =  THE CURRENT EIGENVALUE MUST BE .LT. LAMBDA + RZEROP
C     RZEROM =  THE CURRENT EIGENVALUE MUST BE .GT. LAMBDA - RZEROM
C     LMBDA  =  THE ORIGINAL VALUE OF LAMBDA IN A GIVEN REGION
C     COMFLG =  0 = INITIAL ENTRY WITH NEW LAMBDA
C               1 = NEW SHIFT POINT WITHIN THE SEARCH REGION
C               2 = NEW SHIFT DUE TO CLOSENESS TO AN EIGENVALUE
C               3 = NUMBER OF DESIRED POSITIVE ROOTS FOUND
C               4 = NUMBER FOUND EXCEEDS 3*NOEST
C     ISING  =  SINGULARITY FLAG  0 = NO SINGULARITY
C                                 1 = SINGULAR MATRIX - CHANGE LAMBDA
C                                     AND TRY ONE MORE TIME
C     ITER   =  TOTAL NUMBER OF ITERATIONS
C     NOCHNG =  NUMBER OF SHIFTS WITHIN ONE REGION
C     TIMED  =  TIME REQUIRED TO FORM AND DECOMPOSE (K-LAMBDA*M)
C     NFIRST =  NUMBER OF VECTORS IN THE FIRST POSITIVE SEARCH REGION
C
      ISYM   = 1
      NSHIFT = (NOEST+5)/6
      MXCHNG = MAX0 (10, NSHIFT)
      NCOL   = FILEK(2)
      NCOL2  = 2*NCOL
      ISHIFT = 1
      NZ     = KORSZ(ZZ(1))
      ICRQ   = NCOL*(1+7*IPREC) + 4*SYSBUF - NZ
      IF (ICRQ .GT. 0) GO TO 220
      NZ     = KORSZ(Z(1))
      IBUF1  = NZ - SYSBUF
      ICRQ   = NCOL2 - IBUF1
      IF (IBUF1 .LE. NCOL2) GO TO 220
      NOPOS  = NORTHO
      NONEG  = 0
      NEG    = 0
      IND    = 0
      ITER   = 0
      NODCMP = 0
      NOSTRT = 0
      NOMOVS = 0
      IF (NORTHO .GT. 0) GO TO 20
      CALL GOPEN (SR1FIL,Z(IBUF1),WRTREW)
      CALL CLOSE (SR1FIL,NOREW)
      CALL GOPEN (SR2FIL,Z(IBUF1),WRTREW)
      CALL CLOSE (SR2FIL,NOREW)
   20 LMIN   = LAMMIN
      IF (LAMMIN .GE. 0.0) GO TO 30
      LMIN   = 0.
      NEG    = 1
      IF (LAMMAX .GT. 0.0) GO TO 30
      LMIN   = LAMMAX
      NEG    =-1
      DELLAM = LAMMIN - LAMMAX
      GO TO 40
C
C     EVALUATE THE VALUE OF LAMBDA IN THE CENTER OF THE CURRENT SEARCH
C     REGION
C
   30 DELLAM = LAMMAX - LMIN
   40 LAMBDA = LMIN + (ISHIFT - 0.5)*DELLAM/NSHIFT
      RZERO  = ABS(0.55*DELLAM/NSHIFT)
      NOSTRT = NOSTRT + 1
   50 COMFLG = 0
      LMBDA  = LAMBDA
C
C     INITIATE CLOCK TIME
C
      CALL KLOCK (ISTART)
      NOCHNG = 0
      SWITCH = 0
      IVECT  = 0
      IREG   = 0
      IND    = IND + 1
      IF (IABS(IND) .EQ. 13) IND = 1
      ISING  = 0
      GO TO 90
   70 ISING  = 0
      SWITCH = 1
   90 IF (NOCHNG .GE. MXCHNG) GO TO 160
      NOCHNG = NOCHNG + 1
      CALL KLOCK (T1)
C
C     CALL IN ADD LINK TO FORM  (K-LAMBDA*M)
C
      CALL INVP1
C
C     CALL IN DECOMP TO DECOMPOSE THIS MATRIX
C
      NODCMP = NODCMP + 1
      SHFTPT = LAMBDA
      CALL INVP2 (*100)
      CALL KLOCK (T2)
      GO TO 110
C
C     SINGULAR MATRIX. INCREMENT LAMBDA AND TRY ONCE MORE
C
  100 IF (ISING .EQ. 1) GO TO 150
      ISING  = 1
      LAMBDA = LAMBDA + .02*RZERO
      GO TO 90
C
C     DETERMINE THE TIME REQUIRED TO FORM AND DECOMPOSE (K-LAMBDA*M)
C
  110 TIMED  = T2 - T1
C
C     CALL IN THE MAIN LINK TO ITERATE FOR EIGENVALUES
C
      IF (IPREC  .EQ. 1) CALL INVP3 (NORM11,SUB1,MTMSU1,XTRNY1)
      IF (IPREC  .EQ. 2) CALL INVP3 (NORM1 ,SUB ,MTIMSU,XTRNSY)
      IF (COMFLG .EQ. 2) GO TO 200
      IF (COMFLG .EQ. 1) GO TO 70
      IF (COMFLG .EQ. 3) GO TO 130
      IF (COMFLG .EQ. 0) GO TO 120
      GO TO 170
  120 ISHIFT = ISHIFT + 1
      IF (ISHIFT .GT. NSHIFT) GO TO 130
      GO TO 40
  130 IF (NEG) 180,180,140
C
C     INITIALIZE PARAMETERS TO SOLVE FOR NEGATIVE EIGENVALUES
C
  140 X      = NSHIFT*(-LAMMIN/LAMMAX)
      IX     = X
      Y      = IX
      IF (X .NE. Y) IX = IX + 1
      NSHIFT = IX
      NEG    =-1
      DELLAM = LAMMIN
      ISHIFT = 1
      GO TO 40
  150 ITERM  = 1
      GO TO 190
  160 ITERM  = 2
      GO TO 190
  170 ITERM  = COMFLG
      GO TO 190
  180 ITERM  = 3
C
C     RE-ORDER EIGENVALUES AND EIGENVECTORS
C
  190 CALL GOPEN (DMPFIL,Z(IBUF1),WRTREW)
      IZ( 1) = 2
      IZ( 2) = NORTHO
      IZ( 3) = NOSTRT
      IZ( 4) = NOMOVS
      IZ( 5) = NODCMP
      IZ( 6) = ITER
      IZ( 7) = 0
      IZ( 8) = ITERM
      IZ( 9) = 0
      IZ(10) = 0
      IZ(11) = 0
      IZ(12) = 0
      CALL WRITE (DMPFIL,IZ,12,1)
      CALL CLOSE (DMPFIL,REW)
      RETURN
  200 NOMOVS = NOMOVS + 1
      GO TO 50
  220 NO     =-8
      IFILE  = ICRQ
      CALL MESAGE (NO,IFILE,NAME)
      RETURN
      END

      SUBROUTINE SBSPL2( NTYPE, TI )
C
C     PHASE TWO STRESS DATA RECOVERY BASIC BENDING TRIANGLE.
C
C     NTYPE = 0  IMPLIES BASIC BENDING TRIANGLE
C     NTYPE = 3 IMPLIES TRI-PLATE IS CALLING
C     NTYPE = 4 IMPLIES QUAD-PLATE IS CALLING
C
      DIMENSION NSIL(1), SI(1)
      REAL    TI(6)    ,SDELTA(3),FRLAST(2)
      INTEGER EJECT    ,ISHED(7) ,TLOADS   ,BSC   ,PLT   ,QD   ,TR
     1,       ISTYP(2)
      LOGICAL FLAG
C
      COMMON   /SYSTEM/  IBFSZ    ,NOUT     ,IDM(9)   ,LINE
      COMMON /ZZZZZZ/ Z(1)
      COMMON /SDR2X4/ DUMMY(35),IVEC,DUM11(11),TLOADS
      COMMON /SDR2X7/ EST(100),STRES(100),FORVEC(25)
      COMMON /SDR2X8/ EYE,I,J,NPOINT,VEC(5),ZOVERI,TEMP,DELTA
     1,            CVEC(5),CFRVEC(12)
      COMMON /SDR2X9/ NCHK,ISUB,ILD,FRTMEI(2),TWOTOP,FNCHK
      COMMON /SDR2DE/ SKP(8),IELTYP
C
      EQUIVALENCE (SI(1),EST(9)),(NSIL(1),EST(2))
      EQUIVALENCE (NELID,EST(1))
      EQUIVALENCE (F1,N1)  ,  (ISHED(6),FRLAST(1) )
     1,           (ISHED(1),LSUB)  ,  (ISHED(2),LLD)
C
      DATA TR,QD,BSC,PLT / 4H  TR, 4H  QD, 4HBSC , 4HPLT  /
      DATA LLD,LSUB,FRLAST / 2*-100, -1.0E30, -1.0E30 /
C
C     ******************************************************************
C  . ZERO OUT FORCE AND PRECISION CHECK VECTOR...
      DO 5 I = 1,6
      FORVEC(I) = 0.0E0
      CFRVEC(I) = 0.0E0
    5 CFRVEC(I+6) = 0.0E0
      FORVEC(1) = EST(1)
C
      NPTS = 3
      IF( NTYPE .EQ. 4 ) NPTS = 4
C
C                          NPTS
C         FORCE VECTOR = SUMMATION (S )(U )
C                          I=1       I   I
C
      DO 20 I = 1,NPTS
C
C     POINTER TO DISPLACEMENT VECTOR IN VARIABLE CORE
C
      NPOINT = IVEC + NSIL(I) - 1
C
      CALL SMMATS (SI(30*I-29),5,6,0,  Z(NPOINT),6,1,0,  VEC,CVEC )
C
      DO 30 J = 1,5
      CFRVEC(J+1) = CFRVEC(J+1) + CVEC(J)
   30 FORVEC(J + 1) = FORVEC(J + 1) + VEC(J)
   20 CONTINUE
      IF( TLOADS .EQ. 0 ) GO TO 55
      FLAG = .FALSE.
      JST = 98
      IF( NTYPE .EQ. 4 ) JST = 128
      F1 = TI(6)
      IF( N1 .EQ. 1 ) GO TO 50
      FORVEC(2) = FORVEC(2) - TI(2)
      FORVEC(3) = FORVEC(3) - TI(3)
      FORVEC(4) = FORVEC(4) - TI(4)
      IF( TI(5).EQ.0.0 .AND. TI(6).EQ.0.0 ) FLAG = .TRUE.
      GO TO 55
   50 FORVEC(2) = FORVEC(2) + TI(2)*EST(JST+1)
      FORVEC(3) = FORVEC(3) + TI(2)*EST(JST+2)
      FORVEC(4) = FORVEC(4) + TI(2)*EST(JST+3)
      IF( TI(3).EQ.0.0 .AND. TI(4).EQ.0.0 ) FLAG = .TRUE.
   55 CONTINUE
C
C     FORCE VECTOR COMPLETE AND CONTAINS M , M , M  , V , V
C                                         X   Y   XY   X   Y
C
C     AND ALSO INCLUDES THE ELEMENT ID AS THE FIRST ENTRY
C     ******************************************************************
C
C     STRESSES AT FIBER DISTANCES Z1 AND Z2 = - M * Z / I
C
      STRES(2) = EST(7)
      STRES(11) = EST(8)
      EYE = EST(6)
      I = 2
      K = 7
      K1 = 0
  200 ZOVERI = - STRES(I) / EYE
      ZOVI = ABS (ZOVERI)
      IF( TLOADS.EQ.0  .OR.  FLAG ) GO TO 207
      J = 98
      IF( NTYPE .EQ. 4 ) J = 128
      IF( N1 .EQ. 1 ) GO TO 205
C
      FF = TI(K1+5) - TI(1)
      SDELTA(1) = (EST(JST+1)*FF + TI(2)*STRES(I))/EYE
      SDELTA(2) = (EST(JST+2)*FF + TI(3)*STRES(I))/EYE
      SDELTA(3) = (EST(JST+3)*FF + TI(4)*STRES(I))/EYE
      GO TO 210
C
  205 FF = (TI(K1+3) - STRES(I)*TI(2) - TI(1)) / EYE
      SDELTA(1) = EST(JST+1)*FF
      SDELTA(2) = EST(JST+2)*FF
      SDELTA(3) = EST(JST+3)*FF
      GO TO 210
C
  207 SDELTA(1) = 0.0
      SDELTA(2) = 0.0
      SDELTA(3) = 0.0
  210 CONTINUE
      STRES(I+1) = FORVEC(2) * ZOVERI - SDELTA(1)
      STRES(I+2) = FORVEC(3) * ZOVERI - SDELTA(2)
      STRES(I+3) = FORVEC(4) * ZOVERI - SDELTA(3)
      CFRVEC(K  ) = CFRVEC(2) * ZOVI
      CFRVEC(K+1) = CFRVEC(3) * ZOVI
      CFRVEC(K+2) = CFRVEC(4) * ZOVI
C
C     PRINCIPAL STRESSES AND ANGLE OF ACTION PHI
      TEMP = STRES(I+1) - STRES(I+2)
      STRES(I+7) = SQRT(  (TEMP/2.0E0)**2  +  STRES(I+3)**2  )
      DELTA = (STRES(I + 1) + STRES(I + 2) ) / 2.0E0
      STRES(I+5) = DELTA + STRES(I+7)
      STRES(I+6) = DELTA - STRES(I+7)
      DELTA = 2.0E0 * STRES(I+3)
      IF( ABS(DELTA) .LT. 1.0E-15 .AND. ABS(TEMP) .LT. 1.0E-15)GO TO 101
      STRES(I+4) = ATAN2( DELTA,TEMP ) * 28.6478898E0
      GO TO 100
  101 STRES(I+4) = 0.0E0
  100 IF( I .EQ. 11 ) GO TO 111
      I = 11
      K1 = 1
      K = 10
      GO TO 200
  111 STRES( 1) = EST(1)
C
C     ABOVE COMPLETES 2 VECTORS EACH WITH...
C
C     ELEM ID, Z, SIGMA X, SIGMA Y, SIGMA XY, PHI, SIG 1, SIG 2, TAU-MAX
C
C     STRESSES AND FORCES COMPLETE
C
C
C     ADDITON TO ELIMINATE 2ND ELEMENT ID IN OUTPUT
C
      DO 5000 I = 10,17
 5000 STRES(I) = STRES(I+1)
C
C  . STRESS CHECK...
C
      IF (NCHK.LE.0) GO TO 350
      CFRVEC(1) = EST(1)
      K = 0
C
C  . FORCES...
      CALL SDRCHK (FORVEC(2),CFRVEC(2),5,K)
C
C  . STRESSES...
      CALL SDRCHK (STRES(3),CFRVEC(7),3,K)
      CALL SDRCHK (STRES(11),CFRVEC(10),3,K)
      IF (K.EQ.0) GO TO 350
C
C  . LIMITS EXCEEDED...
      J = 0
      ISTYP(1) = TR
      IF (IELTYP.EQ.15) ISTYP(1) = QD
      ISTYP(2) = PLT
      IF (IELTYP.EQ.7) ISTYP(2) = BSC
C
      IF (LSUB.EQ.ISUB .AND. FRLAST(1).EQ.FRTMEI(1) .AND.
     1    LLD .EQ.ILD  .AND. FRLAST(2).EQ.FRTMEI(2) ) GO TO 320
C
      LSUB = ISUB
      LLD = ILD
      FRLAST(1) = FRTMEI(1)
      FRLAST(2) = FRTMEI(2)
      J = 2
      CALL PAGE1
  300 CALL SD2RHD (ISHED,J)
      LINE = LINE + 1
      WRITE(NOUT,310)
  310 FORMAT (7X,4HTYPE,5X,3HEID,5X,2HMX,5X,2HMY,4X,3HMXY,5X,2HVX,5X,
     1  2HVY,4X,3HSX1,4X,3HSY1,3X,4HSXY1,4X,3HSX2,4X,3HSY2,3X,4HSXY2)
      GO TO 330
C
  320 IF (EJECT(2).NE.0) GO TO 300
  330 WRITE(NOUT,340) ISTYP,NELID,(CFRVEC(I),I=2,12)
  340 FORMAT (1H0,4X,A4,A3,I7,11F7.1)
C
  350 CONTINUE
      RETURN
      END

      SUBROUTINE FNAME (FILE,NAME)
C*******
C     GIVEN A FILE NO., FNAME WILL RETURN THE BCD DESCRIPTOR
C*******
      INTEGER FIAT,FILE,FIST,NAME(2)
      COMMON /XFIST / FIST(2)
      COMMON /XFIAT / FIAT(1)
      DATA    NBLANK/ 4H    /
      DATA    NON1  , NON2  / 4H (NO,4HNE) /
C*******
C     SEARCH THE FIST FOR THE FILE
C*******
      N = FIST(2)*2 + 2
      DO 10 J=3,N,2
      IF (FILE .EQ. FIST(J)) GO TO 20
   10 CONTINUE
C*******
C     FILE DOES NOT EXIST, RETURN -(NONE)-
C*******
      NAME(1) = NON1
      NAME(2) = NON2
      RETURN
   20 K = FIST(J+1)
      IF (K) 21,21,30
   21 CONTINUE
C*******
C     RETURN BCD DESCRIPTOR
C*******
      NAME(1) = FILE
      NAME(2) = NBLANK
      RETURN
C
   30 IX = FIST(J+1) + 2
      NAME(1) = FIAT(IX  )
      NAME(2) = FIAT(IX+1)
      RETURN
      END

      SUBROUTINE MMA401 ( ZI, ZR )
C
C     MMA401 PERFORMS THE MATRIX OPERATION USING METHOD 40 
C       IN REAL SINGLE PRECISION
C       (+/-)A(T & NT) * B (+/-)C = D
C     
C     MMA401 USES METHOD 40 WHICH IS AS FOLLOWS:
C       1.  THIS IS FOR "A" NON-TRANSPOSED AND TRANSPOSED
C       2.  READ AS MANY COLUMNS OF "B" INTO MEMORY AS POSSIBLE
C           INTO MEMORY IN COMPACT FORM LEAVING SPACE FOR A FULL
C           COLUMN OF "D" FOR EVERY COLUMN "B" READ.  SEE SUBROUTINES
C           MMARM1,2,3,4 FOR FORMAT OF COMPACT FORM.
C       3.  INITIALIZE EACH COLUMN OF "D" WITH THE DATA FROM "C".
C       4.  CALL UNPACK TO READ MATRICES "A" AND "C".
C
      INTEGER           ZI(2)      ,T
      INTEGER           TYPEI      ,TYPEP    ,TYPEU ,SIGNAB, SIGNC
      INTEGER           RD         ,RDREW    ,WRT   ,WRTREW, CLSREW,CLS
      INTEGER           FILEA      ,FILEB ,FILEC , FILED
      REAL              ZR(2)
      INCLUDE           'MMACOM.COM'
      COMMON / NAMES  / RD         ,RDREW    ,WRT   ,WRTREW, CLSREW,CLS
      COMMON / TYPE   / IPRC(2)    ,NWORDS(4),IRC(4)
      COMMON / MPYADX / FILEA(7)   ,FILEB(7) ,FILEC(7)    
     1,                 FILED(7)   ,NZ       ,T     ,SIGNAB,SIGNC ,PREC1 
     2,                 SCRTCH     ,TIME
      COMMON / SYSTEM / KSYSTM(152)
      COMMON / UNPAKX / TYPEU      ,IUROW1   ,IUROWN, INCRU
      COMMON / PACKX  / TYPEI      ,TYPEP    ,IPROW1, IPROWN , INCRP
      EQUIVALENCE       (KSYSTM( 1),SYSBUF)  , (KSYSTM( 2),IWR   ) 
      EQUIVALENCE       (FILEA(2)  ,NAC   )  , (FILEA(3)  ,NAR   )
     1,                 (FILEA(4)  ,NAFORM)  , (FILEA(5)  ,NATYPE)
     2,                 (FILEA(6)  ,NANZWD)  , (FILEA(7)  ,NADENS)
      EQUIVALENCE       (FILEB(2)  ,NBC   )  , (FILEB(3)  ,NBR   )
     1,                 (FILEB(4)  ,NBFORM)  , (FILEB(5)  ,NBTYPE)
     2,                 (FILEB(6)  ,NBNZWD)  , (FILEB(7)  ,NBDENS)
      EQUIVALENCE       (FILEC(2)  ,NCC   )  , (FILEC(3)  ,NCR   )
     1,                 (FILEC(4)  ,NCFORM)  , (FILEC(5)  ,NCTYPE)
     2,                 (FILEC(6)  ,NCNZWD)  , (FILEC(7)  ,NCDENS)
      EQUIVALENCE       (FILED(2)  ,NDC   )  , (FILED(3)  ,NDR   )
     1,                 (FILED(4)  ,NDFORM)  , (FILED(5)  ,NDTYPE)
     2,                 (FILED(6)  ,NDNZWD)  , (FILED(7)  ,NDDENS)
C
C
C   OPEN CORE ALLOCATION AS FOLLOWS:
C     Z( 1        ) = ARRAY FOR ONE COLUMN OF "A" MATRIX
C     Z( IBX      ) = ARRAY FOR MULTIPLE COLUMNS OF "B" MATRIX
C                     (STORED IN COMPACT FORM)
C     Z( IDX      ) = ARRAY FOR MULTIPLE COLUMNS OF "D" MATRIX
C                     (FULL COLUMN SPACE ALLOCATION)
C        THROUGH
C     Z( LASMEM   )
C     Z( IBUF4    ) = BUFFER FOR "D" FILE
C     Z( IBUF3    ) = BUFFER FOR "C" FILE
C     Z( IBUF2    ) = BUFFER FOR "B" FILE 
C     Z( IBUF1    ) = BUFFER FOR "A" FILE
C     Z( NZ       ) = END OF OPEN CORE THAT IS AVAILABLE
C
C
C PROCESS ALL OF THE COLUMNS OF "A" 
C      
      DO 60000 II = 1, NAC
C      print *,' processing column of a, ii=',ii
      IUROW1 = -1
      TYPEU  = NDTYPE  
      CALL UNPACK ( *50000, FILEA, ZR( 1 ) )
      IROWA1 = IUROW1
      IROWAN = IUROWN
      INDXA  = 1 - IROWA1    
      IF ( T .NE. 0 ) GO TO 5000
C      
C "A" NON-TRANSPOSE CASE    ( A*B + C )      
C
C SINGLE PRECISION
1000  CONTINUE
      INDXB  = IBX
      DO 1500 I = 1, NCOLPP
      ICOLB  = IBROW + I
      IF ( ICOLB .NE. IABS( ZI( INDXB ) ) ) GO TO 70001
      INDXBL = ZI( INDXB+1 ) + IBX - 1
      INDXB  = INDXB + 2
      INDXD  = ( IDX + ( I-1 )*NDR ) - 1    
1100  CONTINUE
      IF ( INDXB .GE. INDXBL ) GO TO 1450
      IROWB1 = ZI( INDXB   )
      IROWS  = ZI( INDXB+1 )
      IROWBN = IROWB1 + IROWS - 1
      IF ( II .GT. IROWBN ) GO TO 1410
      IF ( II .LT. IROWB1 ) GO TO 1450
      INDXBV = INDXB + 2 + II - IROWB1
      IF ( ZR( INDXBV ) .EQ. 0.0 ) GO TO 1450
      DO 1400 K = IROWA1, IROWAN
      ZR( INDXD+K ) = ZR( INDXD+K ) + ZR( INDXA+K ) * ZR( INDXBV )
1400  CONTINUE
      GO TO 1450
1410  CONTINUE
      INDXB  = INDXB + 2 + IROWS
      GO TO 1100
1450  INDXB  = INDXBL
1500  CONTINUE
      GO TO 50000
C
C  TRANSPOSE CASE ( A(T) * B + C )
C
5000  CONTINUE      
C SINGLE PRECISION
10000 CONTINUE
      INDXB  = IBX
      DO 15000 I = 1, NCOLPP
      ICOLB  = IBROW + I 
      IF ( ICOLB .NE. IABS( ZI( INDXB ) ) ) GO TO 70001
      INDXBL = ZI( INDXB+1 ) + IBX - 1
      INDXB  = INDXB + 2
      INDXD  = ( IDX + ( I-1 )*NDR ) + II - 1 
11000 CONTINUE
      IF ( INDXB .GE. INDXBL ) GO TO 14500
      IROWB1 = ZI( INDXB )
      IROWS  = ZI( INDXB+1 )
      IROWBN = IROWB1 + IROWS - 1
      IROW1  = MAX0( IROWA1, IROWB1 )
      IROWN  = MIN0( IROWAN, IROWBN )
      IF ( IROWN .LT. IROW1 ) GO TO 14100
      INDXBV = INDXB + 2 - IROWB1 
      DO 14000 K = IROW1, IROWN
      ZR( INDXD ) = ZR( INDXD ) + ZR( INDXA+K ) * ZR( INDXBV+K )
14000 CONTINUE
14100 CONTINUE
      INDXB  = INDXB + 2 + IROWS
      GO TO 11000
14500 CONTINUE
      INDXB  = INDXBL
15000 CONTINUE
      GO TO 50000
C END OF PROCESSING THIS COLUMN OF "A" FOR THIS PASS
50000 CONTINUE
60000 CONTINUE
C  NOW SAVE COLUMNS COMPLETED 
      DO 65000 K = 1, NCOLPP
      INDX = IDX + ( K-1 ) * NDR
      CALL PACK ( ZR( INDX ), FILED, FILED )
65000 CONTINUE
      GO TO 70000
70001 WRITE ( IWR, 90001 ) ICOLB, ZI( INDXB ), IBX, INDXB
90001 FORMAT(' UNEXPECTED COLUMN FOUND IN PROCESSING MATRIX B'
     &,/,' COLUMN EXPECTED:',I6
     &,/,' COLUMN FOUND   :',I6
     &,/,' IBX =',I7,'  INDXB =',I7 )
      CALL MESAGE ( -61, 0, 0 )
70000 RETURN
      END

      REAL FUNCTION AIS (NP,I,L,RR,ZZ)
C
C     THIS ROUTINE CALCULATES THE SINGLE PRECISION  DELTA(IJ) INTEGRALS
C     FOR AXISYMMETRIC SOLIDS IN SDR2. CALCULATIONS DONE IN DOUBLE
C     PRECISION
C
C     INPUT
C     NP  = NUMBER OF POINTS (3 OR 4.  MORE THAN 4 WILL FAIL FSN-5)
C     I,L = THE INTEGRAL DESIRED (I SERIES STARTS WITH -1)
C     R   = RADIUS ARRAY (NP LONG)
C     Z   = Z-CORD ARRAY (NP LONG)
C
C     OUTPUT
C     DKL = DESIRED INTEGRAL
C
      INTEGER          NAM(2)
      DOUBLE PRECISION A,AJ,AR,BETA,DR,DZ,DFACT,DZJ,DL1,DKL,EPS,FACT,
     1                 GKL,ZERO,ONE,TWO,THREE,PR,RA,RB,R(4),RAK,RBK,
     2                 ZA,ZB,Z(4)
      DIMENSION        RR(4),ZZ(4)
      DATA       EPS / .01D0 /
      DATA       ZERO, ONE,TWO,THREE / 0.0D0, 1.0D0, 2.0D0, 3.0D0 /
      DATA       NAM / 4HAIS , 1H    /
C
      DO 5 M = 1,NP
      R(M) = RR(M)
    5 Z(M) = ZZ(M)
      DKL  = ZERO
      L1   = L + 1
      L2   = L + 2
      DL1  = L1
      K    = I + 1
C
C     LOOP ON NUMBER OF POINTS
C
      IF (R(1) .LE. ZERO) GO TO 300
      DO 200 M = 1,NP
      J  = M + 1
      IF (M .EQ. NP) J = 1
      RA = R(M)
      RB = R(J)
      ZA = Z(M)
      ZB = Z(J)
      DR = RB - RA
      DZ = ZB - ZA
C
C     TEST IF RADIUS IS .LE. 0 (DRIVER SHOULD FIND THIS)
C
      IF (RB .LE. ZERO) GO TO 300
      GKL = ZERO
      PR  = RA + RB
      AR  = PR/TWO
C
C     CHECK FOR APPROXIMATION, DR/AVE(R)
C
      IF ( DABS ( DR/AR ) .LT. EPS ) GO TO 70
C
      A = ZA*DR - RA*DZ
      BETA = A/DR
C
C     CHECK FOR BETA .EQ. 0 CASE
C
      IF (DABS(BETA/AR) .GT. EPS) GO TO 10
C
      IF (DZ .EQ. ZERO) GO TO 200
      LK  = L + K + 1
      AR  = LK
      GKL = (DZ/DR)**L1*(RA**LK-RB**LK)/(DL1*AR)
      GO TO 200
C
C     GENERAL CASE
C
   10 RAK = RA**K
      RBK = RB**K
      IF (K) 300,20,30
C
C     GENERAL CASE, K.EQ.0, CONSTANT TERM
C
   20 GKL = DLOG(RA/RB)/DL1
      GO TO 40
C
C     GENERAL CASE, CONSTANT TERM
C
   30 AR  = K*L1
      GKL = (RAK-RBK)/AR
C
C     GENERAL CASE, SUMMATION
C
   40 IF (DZ .EQ. ZERO) GO TO 65
      LFACT = 1
C
C     CALCULATE FACTORIAL (L+1)
C
      DO 50 J = 2,L
   50 LFACT = LFACT*J
      FACTL = LFACT
      JFACT = 1
      AJ    = ONE
      DZJ   = ONE
      LMJF  = LFACT*L1
      DO 60 J = 1,L1
      JFACT = JFACT*J
C
C     CALCULATE (L+1-J) FACTORIAL IN LMJF
C
      LMJF  = LMJF /(L2-J)
      FACT  = FACTL/FLOAT (JFACT*LMJF)
      DFACT = K + J
      DFACT = FACT /DFACT
      AJ    = AJ *A
      RAK   = RAK*RA
      RBK   = RBK*RB
      DZJ   = DZJ*DZ
   60 GKL   = GKL + (DFACT*DZJ*(RAK-RBK))/AJ
C
   65 GKL   = GKL*BETA**L1
      GO TO 200
C
C     APPROXIMATE CODE
C
   70 CONTINUE
      IF (DR .EQ. ZERO) GO TO 200
      DZJ = L1*L2
      RBK = ZB**L1
      J   = K - 1
      GKL =-DR*AR**J*RBK/DL1
C
      IF (DZ .EQ. ZERO) GO TO 200
      GKL = GKL + (((TWO*RA+RB)/THREE)**J*DR*DABS(ZA**L2-RBK*ZB))
     1            /(DZJ*DZ)
C
  200 DKL = DKL + GKL
C
C     ALL DONE
C
  210 AIS = DKL
      RETURN
C
C     ERROR
C
  300 CALL MESAGE (-7,K,NAM)
      GO TO 210
      END

      SUBROUTINE VEC
C
C     THE CALL TO THIS MODULE IS
C                   VEC USET  / V / C,N,X / C,N,X0 / C,N,X1 $
C          OR       VEC USETD / V / C,N,X / C,N,X0 / C,N,X1 $
C
C     ALTERNATE FORM OF THE CALL TO THIS MODULE IS
C                   VEC USET  / V / C,N,X / C,N,X0 / C,N,COMP $
C          OR       VEC USETD / V / C,N,X / C,N,X0 / C,N,COMP $
C
C     ALTERNATE FORM OF THE CALL TO THIS MODULE IS
C                   VEC USET  / V / C,N,X / C,N,COMP / C,N,X1 $
C          OR       VEC USETD / V / C,N,X / C,N,COMP / C,N,X1 $
C
C     ALTERNATE FORM OF THE CALL TO THIS MODULE IS
C                   VEC USET  / V / C,N,BITID / C,N,* / C,N,* / C,N,I $
C          OR       VEC USET  / V / C,N,BITID / C,N,X1 $
C          OR       VEC USETD / V / C,N,BITID / C,N,* / C,N,* / C,N,I $
C          OR       VEC USETD / V / C,N,BITID / C,N,X1 $
C
C     ALTERNATE FORM OF THE CALL TO THIS MODULE IS
C                   VEC USET  / V / C,N,COLUMNS / C,N,LEFT  / C,N,* /
C                                                             C,N,I $
C          OR       VEC USETD / V / C,N,COLUMNS / C,N,LEFT  / C,N,* /
C                                                             C,N,I $
C                   ( V WILL HAVE -I- COLUMNS GENERATED FROM BIT
C                     POSITIONS 1,2,3,...,I OF USET (OR USETD) WHERE
C                     THE 32 RIGHT-MOST BITS ARE CONSIDERED, COUNTING
C                     FROM LEFT TO RIGHT. )
C
C     ALTERNATE FORM OF THE CALL TO THIS MODULE IS
C                   VEC USET  / V / C,N,COLUMNS / C,N,RIGHT / C,N,* /
C                                                             C,N,I $
C          OR       VEC USETD / V / C,N,COLUMNS / C,N,RIGHT / C,N,* /
C                                                             C,N,I $
C                   ( V WILL HAVE -I- COLUMNS GENERATED FROM BIT
C                     POSITIONS 32,31,...,33-I OF USET (OR USETD) WHERE
C                     THE 32 RIGHT-MOST BITS ARE CONSIDERED, COUNTING
C                     FROM LEFT TO RIGHT. )
C
C
C     CORE REQUIREMENTS.. ONE BUFFER PLUS USET (OR USETD).
C     FOR COLUMNS OPTION, ONE GINO BUFFER PLUS 2*USET (OR USETD) REQD.
C
C
      EXTERNAL        ANDF
      LOGICAL         LZ,L0,L1,COLS,FLAG1,FLAG2
      INTEGER         ANDF,MODNAM(2),FI,FO,F,NAM(2),T(7),TWO,
     1                P(2),P1,P2,P3,P4,BN,BLANK,TYIN,TYOU,B(2),C(2),
     2                OFFSET,D(2),LR(2,2)
      CHARACTER       UFM*23,UWM*25
      COMMON /XMSSG / UFM,UWM
      COMMON /BLANK / P1(2),P2(2),P3(2),P4
     1       /ZZZZZZ/ X(1)
     2       /SYSTEM/ LB,NOUT,NERR
     3       /BITPOS/ BN(32,2)
     4       /PACKX / TYIN,TYOU,II,NN,INCR
     5       /TWO   / TWO(32)
      EQUIVALENCE     (NR,T(3))
      DATA    NERMAX, BLANK / 10,1H /
      DATA    B,C,D / 4HBITI,4HD    ,4HCOMP,4H     ,4HCOLU,4HMNS  /
      DATA    LR    / 4HRIGH,4HT    ,4HLEFT,4H     /
      DATA    MODNAM/ 4HVEC ,4H     /
      DATA    FI,FO , NBN   / 101,201, 32          /
C
C
      FLAG1  = .FALSE.
      FLAG2  = .FALSE.
      OFFSET = 0
      NERR   = 0
      LZ     = .FALSE.
      L0     = .FALSE.
      L1     = .FALSE.
      LC     = KORSZ(X) - LB
      IF (LC .LE. 0) CALL MESAGE (-8,LC,MODNAM)
      IB = LC + 1
C
C     CHECK PARAMETER VALUES AND COMPUTE MASKS.
C
      IF (P1(1).NE.D(1) .OR. P1(2).NE.D(2)) GO TO 5
      COLS = .TRUE.
      DO 3 J = 1,2
      IF (P2(1).EQ.LR(1,J) .AND. P2(2).EQ.LR(2,J)) GO TO 4
    3 CONTINUE
      J = 2
    4 J = 2*J - 3
      GO TO 13
    5 CONTINUE
      COLS = .FALSE.
      IF (P1(1).EQ.B(1) .AND. P1(2).EQ.B(2)) GO TO 13
      IF (P1(2) .NE. BLANK) GO TO 11
      DO 10 I = 1,NBN
      IF (P1(1) .EQ. BN(I,2)) GO TO 19
   10 CONTINUE
   11 P(1) = P1(1)
      P(2) = P1(2)
      GO TO 9904
   13 LZ   = .TRUE.
      L0   = .TRUE.
      IF (P4.LT.0 .OR. P4.GT.32) GO TO 9908
      IF (COLS) GO TO 50
      IF (P4 .GT. 0) GO TO 18
      IF (P2(2) .NE. BLANK) GO TO 21
      DO 15 I = 1,NBN
      IF (P2(1) .EQ. BN(I,2)) GO TO 35
   15 CONTINUE
      GO TO 21
   18 MASKX1 = TWO(P4)
      GO TO 50
   19 I = BN(I,1)
      MASKX  = TWO(I)
C
      IF (P2(1).EQ.C(1) .AND. P2(2).EQ.C(2)) GO TO 23
      IF (P2(2) .NE. BLANK) GO TO 21
      DO 20 I = 1,NBN
      IF (P2(1) .EQ. BN(I,2)) GO TO 25
   20 CONTINUE
   21 P(1) = P2(1)
      P(2) = P2(2)
      GO TO 9904
   23 L0   = .TRUE.
      GO TO 26
   25 I    = BN(I,1)
      MASKX0 = TWO(I)
C
   26 CONTINUE
      IF (P3(1).EQ.C(1) .AND. P3(2).EQ.C(2)) GO TO 33
      IF (P3(2) .NE. BLANK) GO TO 31
      DO 30 I = 1,NBN
      IF (P3(1) .EQ. BN(I,2)) GO TO 35
   30 CONTINUE
   31 P(1) = P3(1)
      P(2) = P3(2)
      GO TO 9904
   33 L1   = .TRUE.
      IF (L0) GO TO 9907
      GO TO 50
   35 I    = BN(I,1)
      MASKX1 = TWO(I)
C
C     BLAST READ USET (OR USETD) INTO CORE.
C
   50 CONTINUE
      F = FI
      CALL FNAME (F,NAM)
      CALL GOPEN (F,X(IB),0)
      CALL READ (*9902,*100,F,X,LC,0,NW)
C
C     INSUFFICIENT CORE - IF DESIRED, THIS ROUTINE CAN BE WRITTEN TO
C     RUN IN SMALLER CORE.
C
      LCEX = 0
   70 CALL READ (*9902,*80,F,X,LC,0,NW)
      LCEX = LCEX + LC
      GO TO 70
   80 LCEX = LCEX + NW
      IF (COLS) LCEX = 2*LCEX
      GO TO 9903
  100 CONTINUE
      CALL CLOSE (F,1)
      IF (.NOT.COLS) GO TO 150
      IF (P4 .LE. 0) GO TO 9908
      OFFSET = NW
      K = 1
      L = 1
      IF (J .LT. 0) K = 32
      MASKX1 = TWO(K)
      IF (2*NW .LE. LC) GO TO 150
      LCEX = 2*NW - LC
      GO TO 9903
  150 CONTINUE
C
C     PREPARE OUTPUT FILE.
C
      F = FO
      CALL GOPEN  (F,X(IB),1)
      CALL MAKMCB (T,F,0,2,1)
      TYIN = 1
      TYOU = 1
      II   = 1
      INCR = 1
C
C     CREATE VECTOR IN CORE OCCUPIED BY USET (OR USETD).
C
  170 NR = 0
      NZ = 0
C
      DO 500 I = 1,NW
      IF (LZ) GO TO 220
      IF (ANDF(X(I),MASKX) .EQ. 0) GO TO 400
  220 CONTINUE
      IF (.NOT.L0) GO TO 230
      IF (ANDF(X(I),MASKX1) .EQ. 0) GO TO 370
      GO TO 300
  230 IF (.NOT.L1) GO TO 240
      IF (ANDF(X(I),MASKX0) .EQ. 0) GO TO 300
      GO TO 370
  240 CONTINUE
      IF (ANDF(X(I),MASKX1) .EQ. 0) GO TO 350
      IF (ANDF(X(I),MASKX0) .EQ. 0) GO TO 300
      NERR = NERR + 1
      IF (NERR .GT. NERMAX) GO TO 500
      WRITE  (NOUT,250) UFM,I
  250 FORMAT (A23,' 2120, MODULE VEC - BOTH SUBSET BITS ARE NON-ZERO.',
     1       3X,'I =',I10)
      GO TO 500
  300 NR = NR + 1
      NZ = NZ + 1
      X(NR+OFFSET) = 1.0
      GO TO 500
  350 CONTINUE
      IF (ANDF(X(I),MASKX0) .NE. 0) GO TO 370
      NERR = NERR + 1
      IF (NERR .GT. NERMAX) GO TO 500
      WRITE  (NOUT,360) UFM,I
  360 FORMAT (A23,' 2121, MODULE VEC - BOTH SUBSET BITS ARE ZERO.',3X,
     1       'I =',I10)
      GO TO 500
  370 NR = NR + 1
      X(NR+OFFSET) = 0.0
      GO TO 500
  400 IF (L0) GO TO 450
      IF (ANDF(X(I),MASKX0) .EQ. 0) GO TO 450
      NERR = NERR + 1
      IF (NERR .GT. NERMAX) GO TO 450
      WRITE  (NOUT,410) UFM,I
  410 FORMAT (A23,' 2122, MODULE VEC - SET X BIT IS ZERO BUT SUBSET X0',
     1       ' BIT IS NOT.  I =',I10)
  450 IF (L1) GO TO 500
      IF (ANDF(X(I),MASKX1) .EQ. 0) GO TO 500
      NERR = NERR + 1
      IF (NERR .GT. NERMAX) GO TO 500
      WRITE  (NOUT,460) UFM,I
  460 FORMAT (A23,' 2123, MODULE VEC - SET X BIT IS ZERO BUT SUBSET X1',
     1       ' BIT IS NOT.  I =',I10)
  500 CONTINUE
C
      IF (NERR .LE. 0) GO TO 540
      IF (NERR-NERMAX) 9995,9995,9906
  540 CONTINUE
C
      IF (FLAG1) GO TO 600
      FLAG1 = .TRUE.
      IF (NR .GT. 0) GO TO 600
      WRITE  (NOUT,550) UWM
  550 FORMAT (A25,' 2124, MODULE VEC - NR=0, OUTPUT WILL BE PURGED.')
      GO TO 900
  600 IF (NZ .GT. 0) GO TO 700
      IF (FLAG2) GO TO 700
      FLAG2 = .TRUE.
      WRITE  (NOUT,650) UWM
  650 FORMAT (A25,' 2125, MODULE VEC - NZ=0, ONE OR MORE COLUMNS OF ',
     1       'OUTPUT MATRIX WILL BE NULL.')
      GO TO 750
  700 CONTINUE
C
C     PACK OUT COLUMN OF OUTPUT VECTOR.
C
  750 NN = NR
      CALL PACK (X(OFFSET+1),F,T)
      IF (.NOT.COLS .OR. L.GE.P4) GO TO 800
      L = L + 1
      K = K + J
      MASKX1 = TWO(K)
      GO TO 170
  800 CALL WRTTRL (T)
  900 CALL CLOSE  (F,1)
C
      RETURN
C
C     ERROR PROCESSING.
C
 9902 WRITE  (NOUT,9952) UFM,F,NAM
 9952 FORMAT (A23,' 2141, MODULE VEC - EOF ENCOUNTERED WHILE READING ',
     1       'GINO FILE ',I3,', DATA BLOCK ',2A4)
      GO TO 9995
 9903 WRITE  (NOUT,9953) UFM,LC,LCEX
 9953 FORMAT (A23,' 2142, INSUFFICIENT CORE FOR MODULE VEC.  AVAILABLE',
     1       ' CORE =',I11,' WORDS.', /5X,
     2       'ADDITIONAL CORE NEEDED =',I11,' WORDS.')
      GO TO 9995
 9904 WRITE  (NOUT,9954) UFM,P
 9954 FORMAT (A23,' 2143, MODULE VEC UNABLE TO IDENTIFY SET OR SUBSET ',
     1       'DESCRIPTOR ',2A4)
      GO TO 9995
 9906 WRITE  (NOUT,9956) UFM,NERR,NERMAX
 9956 FORMAT (A23,' 2145,',I8,' FATAL MESSAGES HAVE BEEN GENERATED IN',
     1       ' SUBROUTINE VEC.', /5X,
     2       'ONLY THE FIRST',I4,' HAVE BEEN PRINTED.')
      GO TO 9995
 9907 WRITE  (NOUT,9957) UFM
 9957 FORMAT (A23,' 2146, BOTH OF THE SECOND AND THIRD VEC PARAMETERS ',
     1       'REQUEST COMPLEMENT.')
      GO TO 9995
 9908 WRITE  (NOUT,9958) UFM,P4
 9958 FORMAT (A23,' 2150, ILLEGAL VALUE FOR FOURTH PARAMETER =',I11)
      GO TO 9995
 9995 CALL MESAGE (-61,0,0)
      RETURN
C
      END

      SUBROUTINE ALG02
C
      LOGICAL         DEBUG
      REAL            LOSS,LAMI,LAMIP1,LAMIM1
      DIMENSION       II(21,30),JJ(21,30),IDATA(24),RDATA(6),NAME(2)
      COMMON /UD3PRT/ IPRTC
      COMMON /UDSIGN/ NSIGN
      COMMON /UPAGE / LIMIT,LQ
      COMMON /UD300C/ NSTNS,NSTRMS,NMAX,NFORCE,NBL,NCASE,NSPLIT,NREAD,
     1                NPUNCH,NPAGE,NSET1,NSET2,ISTAG,ICASE,IFAILO,IPASS,
     2                I,IVFAIL,IFFAIL,NMIX,NTRANS,NPLOT,ILOSS,LNCT,ITUB,
     3                IMID,IFAIL,ITER,LOG1,LOG2,LOG3,LOG4,LOG5,LOG6,
     4                IPRINT,NMANY,NSTPLT,NEQN,NSPEC(30),NWORK(30),
     5                NLOSS(30),NDATA(30),NTERP(30),NMACH(30),NL1(30),
     6                NL2(30),NDIMEN(30),IS1(30),IS2(30),IS3(30),
     7                NEVAL(30),NDIFF(4),NDEL(30),NLITER(30),NM(2),
     8                NRAD(2),NCURVE(30),NWHICH(30),NOUT1(30),NOUT2(30),
     9                NOUT3(30),NBLADE(30),DM(11,5,2),WFRAC(11,5,2),
     O                R(21,30),XL(21,30),X(21,30),H(21,30),S(21,30),
     1                VM(21,30),VW(21,30),TBETA(21,30),DIFF(15,4),
     2                FDHUB(15,4),FDMID(15,4),FDTIP(15,4),TERAD(5,2),
     3                DATAC(100),DATA1(100),DATA2(100),DATA3(100),
     4                DATA4(100),DATA5(100),DATA6(100),DATA7(100),
     5                DATA8(100),DATA9(100),FLOW(10),SPEED(30),
     6                SPDFAC(10),BBLOCK(30),BDIST(30),WBLOCK(30),
     7                WWBL(30),XSTN(150),RSTN(150),DELF(30),DELC(100),
     8                DELTA(100),TITLE(18),DRDM2(30),RIM1(30),XIM1(30)
      COMMON /UD300C/ WORK(21),LOSS(21),TANEPS(21),XI(21),VV(21),
     1                DELW(21),LAMI(21),LAMIM1(21),LAMIP1(21),PHI(21),
     2                CR(21),GAMA(21),SPPG(21),CPPG(21),HKEEP(21),
     3                SKEEP(21),VWKEEP(21),DELH(30),DELT(30),VISK,SHAPE,
     4                SCLFAC,EJ,G,TOLNCE,XSCALE,PSCALE,PLOW,RLOW,XMMAX,
     5                RCONST,FM2,HMIN,C1,PI,CONTR,CONMX
      EQUIVALENCE     (H(1,1),II(1,1)),(S(1,1),JJ(1,1))
      DATA    NAME  / 4HALG0, 4H2     /
C
      DEBUG = .FALSE.
      CALL SSWTCH (20,J)
      IF (J .EQ. 1) DEBUG =.TRUE.
      NEVAL(1) = 0
      CALL FREAD (LOG1,TITLE,18,1)
      IF (IPRTC .EQ. 1) WRITE (LOG2,110) TITLE
 110  FORMAT (10X,10HINPUT DATA, /10X,10(1H*), //10X,5HTITLE,34X,2H= ,
     1       18A4)
      LNCT = LNCT + 4
      CALL ALG1 (LNCT)
      CALL FREAD (LOG1,IDATA,21,1)
CWKBD IF (DEBUG) CALL BUG1 ('ALG02   ',111,IDATA,21)
      NSTNS  = IDATA( 1)
      NSTRMS = IDATA( 2)
      NMAX   = IDATA( 3)
      NFORCE = IDATA( 4)
      NBL    = IDATA( 5)
      NCASE  = IDATA( 6)
      NSPLIT = IDATA( 7)
      NSET1  = IDATA( 8)
      NSET2  = IDATA( 9)
      NREAD  = IDATA(10)
      NPUNCH = IDATA(11)
      NPLOT  = IDATA(12)
      NPAGE  = IDATA(13)
      NTRANS = IDATA(14)
      NMIX   = IDATA(15)
      NMANY  = IDATA(16)
      NSTPLT = IDATA(17)
      NEQN   = IDATA(18)
      NLE    = IDATA(19)
      NTE    = IDATA(20)
      NSIGN  = IDATA(21)
      IF (NSTRMS .EQ. 0) NSTRMS = 11
      IF (NMAX   .EQ. 0) NMAX   = 40
      IF (NFORCE .EQ. 0) NFORCE = 10
      IF (NCASE  .EQ. 0) NCASE  = 1
      IF (NPAGE  .EQ. 0) NPAGE  = 60
      LQ    = LOG2
      LIMIT = NPAGE
      CALL ALG03 (LNCT,19)
      IF (IPRTC .EQ. 1) WRITE (LOG2,130) NSTNS,NSTRMS,NMAX,NFORCE,NBL,
     1       NCASE,NSPLIT,NSET1,NSET2,NREAD,NPUNCH,NPLOT,NPAGE,NTRANS,
     2       NMIX,NMANY,NSTPLT,NEQN,NLE,NTE,NSIGN
 130  FORMAT (//10X,'NUMBER OF STATIONS',21X,1H=,I3, /10X,'NUMBER OF ',
     1       'STREAMLINES',18X,1H=,I3, /10X,20HMAX NUMBER OF PASSES,19X,
     2       1H=,I3, /10X,30HMAX NUMBER OF ARBITRARY PASSES,9X,1H=,I3,
     3       /10X,29HBOUNDARY LAYER CALC INDICATOR,10X,1H=,I3, /10X,
     4       24HNUMBER OF RUNNING POINTS,15X,1H=,I3, /10X,
     5       33HSTREAMLINE DISTRIBUTION INDICATOR,6X,1H=,I3, /10X,
     6       34HNUMBER OF LOSS/D-FACTOR CURVE SETS,5X,1H=,I3, /10X,
     7       34HNUMBER OF LOSS/T.E.LOSS CURVE SETS,5X,1H=,I3, /10X,
     8       26HSTREAMLINE INPUT INDICATOR,13X,1H=,I3, /10X,
     9       27HSTREAMLINE OUTPUT INDICATOR,12X,1H=,I3, /10X,
     O       24HPRECISION PLOT INDICATOR,15X,1H=,I3, /10X,
     1       24HMAX NUMBER OF LINES/PAGE,15X,1H=,I3, /10X,
     2       29HWAKE TRANSPORT CALC INDICATOR,10X,1H=,I3, /10X,
     3       32HMAINSTREAM MIXING CALC INDICATOR,7X,1H=,I3, /10X,
     4       33HNO OF STATIONS FROM ANALYTIC SECN,6X,1H=,I3, /10X,
     5       27HLINE-PRINTER PLOT INDICATOR,12X,1H=,I3, /10X,
     6       32HMOMENTUM EQUATION FORM INDICATOR,7X,1H=,I3, /10X,
     7       30HSTATION NUMBER AT LEADING EDGE,9X,1H=,I3, /10X,
     8       31HSTATION NUMBER AT TRAILING EDGE,8X,1H=,I3, /10X,
     9       37HCOMPRESSOR DIR. OF ROTATION INDICATOR,2X,1H=,I3)
      ITUB = NSTRMS - 1
      IMID = NSTRMS/2 + 1
      IF (NMANY .EQ. 0) GO TO 136
      CALL FREAD (LOG1,NWHICH,NMANY,1)
CWKBD IF (DEBUG) CALL BUG1 ('ALG02   ',132,NWHICH,NMANY)
      CALL ALG03 (LNCT,2)
      IF (IPRTC .EQ. 1) WRITE (LOG2,134) (NWHICH(I),I=1,NMANY)
 134  FORMAT (//10X,'GEOMETRY COMES FROM ANALYTIC SECTION FOR STATIONS',
     1       23I3)
 136  CALL ALG03 (LNCT,7)
      CALL FREAD (LOG1,RDATA,6,1)
CWKBD IF (DEBUG) CALL BUG1 ('ALG02   ',136,RDATA,6)
      G      = RDATA(1)
      EJ     = RDATA(2)
      SCLFAC = RDATA(3)
      TOLNCE = RDATA(4)
      VISK   = RDATA(5)
      SHAPE  = RDATA(6)
      IF (G   .EQ.   0.0) G  = 32.174
      IF (EJ  .EQ.   0.0) EJ = 778.16
      IF (SCLFAC .EQ. 0.) SCLFAC = 12.0
      IF (TOLNCE .EQ. 0.) TOLNCE = 0.001
      IF (VISK .EQ.  0.0) VISK  = 0.00018
      IF (SHAPE.EQ.  0.0) SHAPE = 0.7
      IF (IPRTC .EQ. 1) WRITE (LOG2,150) G,EJ,SCLFAC,TOLNCE,VISK,SHAPE
 150  FORMAT (//10X,22HGRAVITATIONAL CONSTANT,17X,1H=,F8.4, /10X,
     1       17HJOULES EQUIVALENT,22X,1H=,F8.3, /10X,
     2       29HLINEAR DIMENSION SCALE FACTOR,10X,1H=,F8.4, /10X,
     3       15HBASIC TOLERANCE,24X,1H=,F8.5, /10X,
     4       19HKINEMATIC VISCOSITY,20X,1H=,F8.5, /10X,
     5       17HB.L. SHAPE FACTOR,22X,1H=,F8.5)
      CALL ALG03 (LNCT,7)
      CALL FREAD (LOG1,RDATA,6,1)
CWKBD IF (DEBUG) CALL BUG1 ('ALG02   ',151,RDATA,6)
      XSCALE = RDATA(1)
      PSCALE = RDATA(2)
      RLOW   = RDATA(3)
      PLOW   = RDATA(4)
      XMMAX  = RDATA(5)
      RCONST = RDATA(6)
      IF (XMMAX .EQ.0.0) XMMAX  = 0.6
      IF (RCONST.EQ.0.0) RCONST = 6.0
      IF (IPRTC .EQ. 1) WRITE (LOG2,160) XSCALE,PSCALE,RLOW,PLOW,XMMAX,
     1       RCONST
 160  FORMAT (//10X,29HPLOTTING SCALE FOR DIMENSIONS,10X,1H=,F7.3, /10X,
     1       28HPLOTTING SCALE FOR PRESSURES,11X,1H=,F7.3, /10X,
     2       22HMINIMUM RADIUS ON PLOT,17X,1H=,F7.3, /10X,
     3       24HMINIMUM PRESSURE ON PLOT,15X,1H=,F7.3, /10X,
     4       40HMAXIMUM M-SQUARED IN RELAXATION FACTOR =,F8.4, /10X,
     5       29HCONSTANT IN RELAXATION FACTOR,10X,1H=,F8.4)
      CALL ALG03 (LNCT,3)
      CALL FREAD (LOG1,RDATA,2,1)
CWKBD IF (DEBUG) CALL BUG1 ('ALG02   ',162,RDATA,2)
      CONTR = RDATA(1)
      CONMX = RDATA(2)
      IF (IPRTC .EQ. 1) WRITE (LOG2,164) CONTR,CONMX
 164  FORMAT (//10X,22HWAKE TRANSFER CONSTANT,17X,1H=,F8.5, /10X,
     1       25HTURBULENT MIXING CONSTANT,14X,1H=,F8.5)
      CALL ALG03 (LNCT,5+NCASE)
      DO 168 K = 1,NCASE
      CALL FREAD (LOG1,FLOW(K),1,0)
 168  CALL FREAD (LOG1,SPDFAC(K),1,1)
CWKBD IF (DEBUG) CALL BUG1 ('ALG02   ',171,FLOW,NCASE)
CWKBD IF (DEBUG) CALL BUG1 ('ALG02   ',172,SPDFAC,NCASE)
      IF (IPRTC .EQ. 1) WRITE(LOG2,180) (K,FLOW(K),SPDFAC(K),K=1,NCASE)
 180  FORMAT (//10X,21HPOINTS TO BE COMPUTED,  //10X,2HNO,6X,8HFLOWRATE,
     1       4X,12HSPEED FACTOR, //,(10X,I2,F13.3,F14.3))
      CALL FREAD (LOG1,L1,1,1)
CWKBD IF (DEBUG) CALL BUG1 ('ALG02   ',180,L1,1)
      DO 185 K = 1,L1
      CALL FREAD (LOG1,XSTN(K),1,0)
 185  CALL FREAD (LOG1,RSTN(K),1,1)
CWKBD IF (DEBUG) CALL BUG1 ('ALG02   ',191,XSTN,L1)
CWKBD IF (DEBUG) CALL BUG1 ('ALG02   ',192,RSTN,L1)
      ISTAG = 0
      IF (RSTN(1) .EQ. 0.0) ISTAG = 1
      NSPEC(1) = L1
      CALL ALG03 (LNCT,7+L1)
      IF (IPRTC .EQ. 1) WRITE (LOG2,200) L1,(XSTN(K),RSTN(K),K=1,L1)
 200  FORMAT (//10X,'ANNULUS / COMPUTING STATION GEOMETRY', //10X,
     1       24HSTATION  1  SPECIFIED BY,I3,7H POINTS, //17X,4HXSTN,8X,
     2       4HRSTN,//,(F22.4,F12.4))
      IS1(1) = 1
      LAST   = L1
      DO 220 I = 2,NSTNS
      CALL FREAD (LOG1,L1,1,1)
CWKBD IF (DEBUG) CALL BUG1 ('ALG02   ',210,L1,1)
      NEXT = LAST + 1
      LAST = LAST + L1
      IF (LAST .GT. 150) GO TO 550
      DO 215 K = NEXT,LAST
      CALL FREAD (LOG1,XSTN(K),1,0)
 215  CALL FREAD (LOG1,RSTN(K),1,1)
CWKBD IF (DEBUG) CALL BUG1 ('ALG02   ',215,XSTN(NEXT),LAST-NEXT+1)
CWKBD IF (DEBUG) CALL BUG1 ('ALG02   ',216,RSTN(NEXT),LAST-NEXT+1)
      IF (RSTN(NEXT) .EQ. 0.0) ISTAG = I
      CALL ALG03 (LNCT,5+L1)
      IS1(I) = NEXT
      NSPEC(I) = L1
 220  IF (IPRTC .EQ. 1) WRITE (LOG2,230) I,L1,(XSTN(K),RSTN(K),
     1       K=NEXT,LAST)
 230  FORMAT (//10X,7HSTATION,I3,14H  SPECIFIED BY,I3,7H POINTS, //17X,
     1       4HXSTN,8X,4HRSTN, //,(F22.4,F12.4))
      SPEED(1)  = 0.0
      CALL FREAD (LOG1,IDATA,4,1)
CWKBD IF (DEBUG) CALL BUG1 ('ALG02   ',233,IDATA,4)
      L1        = IDATA(1)
      NTERP(1)  = IDATA(2)
      NDIMEN(1) = IDATA(3)
      NMACH(1)  = IDATA(4)
      DO 335 K = 1,L1
      CALL FREAD (LOG1,RDATA,4,1)
CWKBD IF (DEBUG) CALL BUG1 ('ALG02   ',234,RDATA,4)
      DATAC(K) = RDATA(1)
      DATA1(K) = RDATA(2)
      DATA2(K) = RDATA(3)
 335  DATA3(K) = RDATA(4)
      CALL ALG03 (LNCT,7+L1)
      IS2(1)   = 1
      NDATA(1) = L1
      LAST = L1
      IF (IPRTC .EQ. 1) WRITE (LOG2,250) L1,NTERP(1),NDIMEN(1),NMACH(1),
     1       (DATAC(K),DATA1(K),DATA2(K),DATA3(K),K=1,L1)
 250  FORMAT (//10X,24HSTATION CALCULATION DATA,   //7X,
     1       18HSTATION  1  NDATA=,I3,7H NTERP=,I2,8H NDIMEN=,I2,
     2       7H NMACH=,I2, //11X,5HDATAC,6X,14HTOTAL PRESSURE,4X,
     3       17HTOTAL TEMPERATURE,4X,11HWHIRL ANGLE, //,
     4       (5X,F12.4,F15.4,F19.3,F18.3))
      DO 252 K = 1,L1
 252  DATA1(K) = DATA1(K)*SCLFAC**2
      LASTD    = 0
      NOUT1(1) = 0
      NOUT2(1) = 0
      DO 320 I = 2,NSTNS
      LOGN = LOG1
      IF (NMANY .EQ. 0) GO TO 258
      DO 254 L1 = 1,NMANY
      IF (NWHICH(L1) .EQ. I) GO TO 256
 254  CONTINUE
      GO TO 258
 256  LOGN = LOG5
 258  CALL FREAD (LOGN,IDATA,16,1)
CWKBD IF (DEBUG .AND. LOGN.EQ.LOG1) CALL BUG1 ('ALG02   ',258,IDATA,16)
      NDATA(I)  = IDATA(1)
      NTERP(I)  = IDATA(2)
      NDIMEN(I) = IDATA(3)
      NMACH(I)  = IDATA(4)
      NWORK(I)  = IDATA(5)
      NLOSS(I)  = IDATA(6)
      NL1(I)    = IDATA(7)
      NL2(I)    = IDATA(8)
      NEVAL(I)  = IDATA(9)
      NCURVE(I) = IDATA(10)
      NLITER(I) = IDATA(11)
      NDEL(I)   = IDATA(12)
      NOUT1(I)  = IDATA(13)
      NOUT2(I)  = IDATA(14)
      NOUT3(I)  = IDATA(15)
      NBLADE(I) = IDATA(16)
      L1 = 3
      IF (NDATA(I) .NE. 0) L1 = L1 + 5 + NDATA(I)
      IF (NDEL(I)  .NE. 0) L1 = L1 + 3 + NDEL(I)
      CALL ALG03 (LNCT,L1)
      IF (IPRTC .EQ. 1) WRITE (LOG2,270) I,NDATA(I),NTERP(I),NDIMEN(I),
     1       NMACH(I),NWORK(I),NLOSS(I),NL1(I),NL2(I),NEVAL(I),NCURVE(I)
     2,      NLITER(I),NDEL(I),NOUT1(I),NOUT2(I),NOUT3(I),NBLADE(I)
 270  FORMAT (//7X,7HSTATION,I3, 8H  NDATA=,I3,7H NTERP=,I2,8H NDIMEN=,
     1       I2,7H NMACH=,I2,7H NWORK=,I2,7H NLOSS=,I2,5H NL1=,I3,
     2       5H NL2=,I3,7H NEVAL=,I2,8H NCURVE=,I2,8H NLITER=,I3,
     3       6H NDEL=,I3, /19X,6HNOUT1=,I2,7H NOUT2=,I2,7H NOUT3=,I2,
     4       8H NBLADE=,I3)
      SPEED(I) = 0.0
      IF (NDATA(I) .EQ. 0) GO TO 320
      NEXT   = LAST + 1
      LAST   = LAST + NDATA(I)
      IS2(I) = NEXT
      IF (LAST .GT. 100) GO TO 550
      CALL FREAD (LOGN,SPEED(I),1,1)
CWKBD IF (DEBUG .AND.LOGN.EQ.LOG1) CALL BUG1 ('ALG02   ',271,SPEED(I),1)
      DO 275 K = NEXT,LAST
      CALL FREAD (LOGN,RDATA,6,1)
CWKBD IF (DEBUG .AND. LOGN.EQ.LOG1) CALL BUG1 ('ALG02   ',272,RDATA,6)
      DATAC(K) = RDATA(1)
      DATA1(K) = RDATA(2)
      DATA2(K) = RDATA(3)
      DATA3(K) = RDATA(4)
      DATA4(K) = RDATA(5)
      DATA5(K) = RDATA(6)
      CALL FREAD (LOGN,RDATA,4,1)
CWKBD IF (DEBUG .AND. LOGN.EQ.LOG1) CALL BUG1 ('ALG02   ',273,RDATA,4)
      DATA6(K) = RDATA(1)
      DATA7(K) = RDATA(2)
      DATA8(K) = RDATA(3)
 275  DATA9(K) = RDATA(4)
      IF (IPRTC .EQ. 1) WRITE (LOG2,290) SPEED(I),(DATAC(K),DATA1(K),
     1       DATA2(K),DATA3(K),DATA4(K),DATA5(K),DATA6(K),DATA7(K),
     2       DATA8(K),DATA9(K),K=NEXT,LAST)
 290  FORMAT (//10X,7HSPEED =,F9.2, //13X,5HDATAC,7X,5HDATA1,7X,5HDATA2,
     1       7X,5HDATA3,7X,5HDATA4,7X,5HDATA5,7X,5HDATA6,7X,5HDATA7,7X,
     2       5HDATA8,7X,5HDATA9, //,
     3       (10X,F9.4,F12.3,F13.6,F11.4,F12.5,F12.5,4F12.4))
      IF (NWORK(I) .NE. 1) GO TO 296
      DO 294 K = NEXT,LAST
 294  DATA1(K) = DATA1(K)*SCLFAC**2
 296  IF (NEVAL(I).GT.0 .AND. NSTRMS.GT.NDATA(I)) LAST = LAST + NSTRMS -
     1    NDATA(I)
      IF (NDEL(I) .EQ. 0) GO TO 320
      NEXT   = LASTD + 1
      LASTD  = LASTD + NDEL(I)
      IS3(I) = NEXT
      IF (LASTD .GT. 100) GO TO 550
      DO 298 K = NEXT,LASTD
      CALL FREAD (LOG1,DELC(K), 1,0)
 298  CALL FREAD (LOG1,DELTA(K),1,1)
CWKBD IF (DEBUG) CALL BUG1 ('ALG02   ',298,DELC(NEXT),LASTD-NEXT+1)
CWKBD IF (DEBUG) CALL BUG1 ('ALG02   ',299,DELTA(NEXT),LASTD-NEXT+1)
      IF (IPRTC .EQ. 1) WRITE(LOG2,310)(DELC(K),DELTA(K),K=NEXT,LASTD)
 310  FORMAT (//13X,4HDELC,8X,5HDELTA, //,(10X,F9.4,F12.4))
 320  CONTINUE
      CALL ALG03 (LNCT,5+NSTNS)
      DO 325 I = 1,NSTNS
      CALL FREAD (LOG1,RDATA,3,1)
CWKBD IF (DEBUG) CALL BUG1 ('ALG02   ',323,RDATA,3)
      WBLOCK(I) = RDATA(1)
      BBLOCK(I) = RDATA(2)
 325  BDIST(I)  = RDATA(3)
      IF (IPRTC .EQ. 1) WRITE (LOG2,340) (I,WBLOCK(I),BBLOCK(I),
     1       BDIST(I),I=1,NSTNS)
 340  FORMAT (//10X,'BLOCKAGE FACTOR SPECIFICATIONS', //10X,'STATION  ',
     1      ' WALL BLOCKAGE   WAKE BLOCKAGE   WAKE DISTRIBUTION FACTOR',
     2       //,(10X,I4,F16.5,F16.5,F19.3))
      IF (NSET1 .EQ. 0) GO TO 380
      DO 370 K = 1,NSET1
      CALL FREAD (LOG1,L1,1,1)
CWKBD IF (DEBUG) CALL BUG1 ('ALG02   ',342,L1,1)
      DO 345 J = 1,L1
      CALL FREAD (LOG1,RDATA,4,1)
CWKBD IF (DEBUG) CALL BUG1 ('ALG02   ',343,RDATA,4)
      DIFF(J,K)  = RDATA(1)
      FDHUB(J,K) = RDATA(2)
      FDMID(J,K) = RDATA(3)
 345  FDTIP(J,K) = RDATA(4)
      CALL ALG03 (LNCT,6+L1)
      IF (IPRTC .EQ. 1) WRITE (LOG2,360) K,L1,(DIFF(J,K),FDHUB(J,K),
     1       FDMID(J,K),FDTIP(J,K),J=1,L1)
 360  FORMAT (//10X,'LOSS PARAMETER / DIFFUSION FACTOR CURVES FOR BLADE'
     1,      ' TYPE',I2,I5,' D-FACTORS GIVEN', //15X,9HDIFFUSION,5X,
     2       'L O S S   P A R A M E T E R S', /16X,7HFACTORS,8X,3HHUB,
     3       9X,3HMID,8X,3HTIP,//,(15X,F8.3,F13.5,F12.5,F11.5))
 370  NDIFF(K) = L1
 380  IF (NSET2 .EQ. 0) GO TO 450
      DO 440 K = 1,NSET2
      CALL FREAD (LOG1,IDATA,2,1)
CWKBD IF (DEBUG) CALL BUG1 ('ALG02   ',385,IDATA,2)
      L1 = IDATA(1)
      L2 = IDATA(2)
      CALL ALG03 (LNCT,7+L1)
      NM(K)   = L1
      NRAD(K) = L2
      CALL FREAD (LOG1,TERAD(1,K),1,1)
CWKBD IF (DEBUG) CALL BUG1 ('ALG02   ',391,TERAD(1,K),1)
      DO 398 J = 1,L1
      CALL FREAD (LOG1,RDATA,2,1)
CWKBD IF (DEBUG) CALL BUG1 ('ALG02   ',398,RDATA,2)
      DM(J,1,K)    = RDATA(1)
 398  WFRAC(J,1,K) = RDATA(2)
      IF (IPRTC .EQ. 1) WRITE (LOG2,410) K,L1,L2,TERAD(1,K),(DM(J,1,K),
     1       WFRAC(J,1,K),J=1,L1)
 410  FORMAT (//10X,'FRACTIONAL LOSS DISTRIBUTION CURVES FOR BLADE ',
     1       'CLASS',I2,I5,' POINTS GIVEN AT',I3,' RADIAL LOCATIONS', //
     2       10X,'FRACTION OF COMPUTING STATION LENGTH AT BLADE EXIT =',
     3       F7.4, //10X,'FRACTION OF MERIDIONAL CHORD',4X,
     4       'LOSS/LOSS AT TRAILING EDGE', //,(15X,F11.4,20X,F11.4))
      IF (L2 .EQ. 1) GO TO 440
      DO 420 L = 2,L2
      CALL ALG03 (LNCT,5+L1)
      CALL FREAD (LOG1,TERAD(L,K),1,1)
CWKBD IF (DEBUG) CALL BUG1 ('ALG02   ',411,TERAD(L,K),1)
      DO 415 J = 1,L1
      CALL FREAD (LOG1,RDATA,2,1)
CWKBD IF (DEBUG) CALL BUG1 ('ALG02   ',412,RDATA,2)
      DM(J,L,K)    = RDATA(1)
 415  WFRAC(J,L,K) = RDATA(2)
 420  IF (IPRTC .EQ. 1) WRITE (LOG2,430) TERAD(L,K),(DM(J,L,K),
     1       WFRAC(J,L,K),J=1,L1)
 430  FORMAT (//10X,'FRACTION OF COMPUTING STATION LENGTH AT BLADE ',
     1       'EXIT =',F7.4, //10X,'FRACTION OF MERIDIONAL CHORD',4X,
     2       'LOSS/LOSSAT TRAILING EDGE', //,(15X,F11.4,20X,F11.4))
 440  CONTINUE
 450  IF (NSPLIT.EQ.0 .AND. NREAD.EQ.0) GO TO 570
      DO 455 J = 1,NSTRMS,6
 455  CALL FREAD (LOG1,DELF(J),6,1)
CWKBD IF (DEBUG) CALL BUG1 ('ALG02   ',455,DELF,NSTRMS)
      L1 = 5
      IF (NSTRMS .GE. 16) L1 = 8
      CALL ALG03 (LNCT,L1)
      IF (IPRTC .EQ. 1) WRITE (LOG2,470)
      L1 = NSTRMS
      IF (NSTRMS .GT. 15) L1 = 15
      IF (IPRTC .EQ. 1) WRITE (LOG2,480) (J,J=1,L1)
 480  FORMAT (//10X,'STREAMLINE',I5,14I7)
 470  FORMAT (//10X,'PROPORTIONS OF TOTAL FLOW BETWEEN HUB AND EACH ',
     1       'STREAMLINE ARE TO BE AS FOLLOWS')
      IF (IPRTC .EQ. 1) WRITE(LOG2,490) (DELF(J),J=1,L1)
 490  FORMAT (10X,4HFLOW,7X,15F7.4)
      IF (NSTRMS .LE. 15) GO TO 500
      L1 = L1 + 1
      IF (IPRTC .EQ. 1) WRITE (LOG2,480) (J,J=L1,NSTRMS)
      IF (IPRTC .EQ. 1) WRITE (LOG2,490) (DELF(J),J=L1,NSTRMS)
 500  IF (NREAD .EQ. 0) GO TO 570
      DO 505 I = 1,NSTNS
      DO 505 J = 1,NSTRMS
      CALL FREAD (LOG1,RDATA,3,0)
CWKBD IF (DEBUG) CALL BUG1 ('ALG02   ',501,RDATA,3)
      R(J,I)  = RDATA(1)
      X(J,I)  = RDATA(2)
      XL(J,I) = RDATA(3)
      CALL FREAD (LOG1,IDATA,2,1)
CWKBD IF (DEBUG) CALL BUG1 ('ALG02   ',502,IDATA,2)
      II(J,I) = IDATA(1)
 505  JJ(J,I) = IDATA(2)
      CALL ALG03 (LNCT,5+NSTRMS)
      IF (IPRTC .EQ. 1) WRITE (LOG2,520)
 520  FORMAT (//10X,'ESTIMATED STREAMLINE COORDINATES')
      DO 530 I = 1,NSTNS
      IF (I .GT. 1) CALL ALG03 (LNCT,3+NSTRMS)
 530  IF (IPRTC .EQ. 1) WRITE (LOG2,540) (I,J,R(J,I),X(J,I),XL(J,I),
     1       II(J,I),JJ(J,I),J=1,NSTRMS)
 540  FORMAT (//10X,'STATION  STREAMLINE   RADIUS  AXIAL COORDINATE  ',
     1       'L -COORDINATE    CHECKS-  I    J', //,
     2       (3X,2I11,F14.4,F12.4,F16.4,I17,I5))
      GO TO 570
 550  WRITE  (LOG2,560)
 560  FORMAT (////10X,'JOB STOPPED - TOO MUCH INPUT DATA')
      CALL MESAGE (-37,0,NAME)
 570  RETURN
      END

      SUBROUTINE INTVEC (VECTOR)
C
      INTEGER         VECTOR,XYZR(4),CHAR,VEC(4),VECWRD
      COMMON /SYSTEM/ SKIP(40), NCPW
      DATA    XYZR  / 1HX,1HY,1HZ,1HR /
      DATA    N     / 1HN/
C
      NSHAPE = 0
      VECWRD = VECTOR
      IF (VECWRD .EQ. 0) GO TO 125
      DO 101 I = 1,4
      VEC(I) = 0
  101 CONTINUE
C
C     SEPARATE THE FOUR CHARACTERS IN -VECWRD- (ANY COMBINATION OF THE
C     CHARACTERS X, Y, Z, AND R.
C
      DO 120 K = 1,4
      CHAR = KLSHFT(VECWRD,(K-1))
      CHAR = KRSHFT(CHAR,(NCPW-1))
      DO 111 I = 1,4
      IF (CHAR .EQ. KRSHFT(XYZR(I),(NCPW-1))) GO TO 115
  111 CONTINUE
      IF(CHAR .EQ. KRSHFT(N,(NCPW-1))) NSHAPE = 1
      GO TO 120
  115 VEC(I) = 1
  120 CONTINUE
C
      VECTOR = VEC(1) + 2*VEC(2) + 4*VEC(3) + 8*VEC(4)
      IF (VECTOR .EQ. 8) VECTOR = 15
      IF (NSHAPE .EQ. 1) VECTOR =-VECTOR
  125 RETURN
      END

      SUBROUTINE HDCHK(XXX,CCC,NNO,II,XI,YI,NGX,ZM,ZMI,
     1           RV,RVI,TGM,TGI,ZI,LZ,XCC)
C
C
C
C     THIS SUBROUTINE SOLVES FOR THE POINTS OF INTERSECTION ON THE
C     LINES OF THE JTH ELEMENT WITH OTHER LINES AND PLANES(RELEVANT)
C
C
      DIMENSION CCC(1),XXX(1)
      DIMENSION RV(1),RVI(1),TGM(1),TGI(1),ZM(1),ZMI(1),
     1          NNO(1),NGX(1),XCC(1),XI(1),YI(1),ZI(1)
      COMMON/HEDG/JS,M,JT,VX,VX1,VX2,VX3,NN
      COMMON/GO3/L0,L1,L00,L01,L2,L3,L4,L5,L6,L7,L8,L9,L10,L11,L12,L13
      JM=1
      EEX=.015
      EXP=.005
      NGX(1)=0
      IF(II.EQ.0)GO TO 190
      IF(NN .EQ. 1) GO TO 5
      IF(VX3 .NE. 0.)GO TO 5
      A=XXX(JT+2)
      B=XXX(JT+1)
      C=XXX(JT+4)
      Z1=XCC(JS)
      Z2=XCC(JS+1)
      IF(A.EQ.0.) GO TO 1
      Y1=-XCC(JS+3)*B-C
      Y2=-XCC(JS+4)*B-C
      X1=XCC(JS+3)
      X2=XCC(JS+4)
      GO TO 50
    1 CONTINUE
      Y1=XCC(JS+3)
      Y2=XCC(JS+4)
      X1=-C
      X2=X1
      GO TO 50
    5 CONTINUE
      A=XCC(JS)
      B=XCC(JS+1)
      C=XCC(JS+2)
      IF(A.EQ.0.)GO TO 20
      Y1=-XCC(JS+3)*XCC(JS+1)-XCC(JS+2)
      Y2=-XCC(JS+4)*XCC(JS+1)-XCC(JS+2)
      X1=XCC(JS+3)
      X2=XCC(JS+4)
      GO TO 30
   20 CONTINUE
      Y1=XCC(JS+3)
      Y2=XCC(JS+4)
      X1=-XCC(JS+2)
      X2=X1
   30 CONTINUE
      IF(NN.NE.1)GO TO 40
      Z1=XXX(1+JT)
      Z2=XXX(2+JT)
      GO TO 50
   40 CONTINUE
      Z1=-(VX+VX1*Y1+VX2*X1)/VX3
      Z2=-(VX+VX1*Y2+VX2*X2)/VX3
   50 CONTINUE
      AL=X2-X1
      BL=Y2-Y1
      CL=Z2-Z1
      EG=AMIN1(Z1,Z2)
      EGX=AMAX1(X1,X2)
      EGX1=AMIN1(X1,X2)
      EGY=AMAX1(Y1,Y2)
      EGY1=AMIN1(Y1,Y2)
C
C
C     THIS CODE DETERMINES THE POINTS OF INTERSECTIONS ON THE LINES OF
C     JTH ELEMENT RESULTING FROM THE INTERSECTION OF THE PLANES WITH
C     THESE LINES.
C
C
      DO 170 JR=1,II
      LG=NNO(L4+JR)
      NNO(L4+JR)=IABS(NNO(JR+L4))
      LE=NNO(L4+JR)
      JE=L13+LZ*(LE-1)
      JU=L12+5*(LE-1)
      NK=XXX(5+JU)
      JV=1
      AC=XXX(1+JU)
      BC=XXX(2+JU)
      CC=XXX(3+JU)
      D=XXX(4+JU)
      IF(EGX.LT.TGM(L5+LE))GO TO 170
      IF(EGX1.GT.TGI(L6+LE))GO TO 170
      IF(EGY.LT.RVI(L8+LE))GO TO 170
      IF(EGY1.GT.RV(L7+LE))GO TO 170
      IF(EG.GT.ZM(L2+LE))GO TO 170
      IF(LG.LT.0)GO TO 80
      IF((AL.EQ.0.).AND.(BL.EQ.0.))GO TO 80
      IF(AL.EQ.0.)GO TO 60
      XP=((BC*BL)/AL)*X1+(CC*CL/AL)*X1-D
      XP=XP-BC*Y1-CC*Z1
      VU=AC+(BC*BL/AL)+(CC*CL/AL)
      IF(VU.EQ.0.)GO TO 80
      XP=XP/VU
      T=(XP-X1)/AL
      YP=T*BL+Y1
      ZP=T*CL+Z1
      GO TO 70
   60 CONTINUE
      YP=(AC*AL/BL)*Y1+(CC*CL/BL)*Y1-D
      YP=YP-CC*Z1-AC*X1
      VU=BC+(AC*AL/BL)+(CC*CL/BL)
      IF(VU.EQ.0.)GO TO 80
      YP=YP/VU
      T=(YP-Y1)/BL
      XP=T*AL+X1
      ZP=T*CL+Z1
   70 CONTINUE
      S=ZP-ZM(L2+LE)
      S1=ZP-ZMI(L3+LE)
      IF((ABS(S).LT.EEX).OR.(ABS(S1).LT.EEX))GO TO 56
      IF(S*S1.GT.0.)GO TO 80
   56 CONTINUE
      S=XP-TGM(L5+LE)
      S1=XP-TGI(L6+LE)
      IF(S*S1.GT.0.)GO TO 80
      S=YP-RV(L7+LE)
      S1=YP-RVI(L8+LE)
      IF(S*S1.GT.0.)GO TO 80
      T=XP
      IF(A.EQ.0.)T=YP
      S=T-XCC(JS+3)
      S1=T-XCC(JS+4)
      IF(S*S1.GE.0.)GO TO 80
      M=M+1
C
C     STORES INTERSECTIONS.
C
      XI(M+1)=XP
      YI(M+1)=YP
      ZI(M+1)=ZP
   80 CONTINUE
C
C     THIS CODE DETERMINES INTERSECTION POINTS OF LINES WITH LINES.
C
      DO 160 JC=1,NK
      B1=CCC(JV+1+JE)
      A1=CCC(JV+JE)
      C1=CCC(JV+2+JE)
      T=A1*B-B1*A
      IF(T.EQ.0.)GO TO 160
      XO=(C1*A-C*A1)/T
      IF((ABS(B).LE.50.).AND.(A.NE.0.))GO TO 90
      YO=-C1-B1*XO
      GO TO 100
   90 CONTINUE
      YO=-C-B*XO
  100 CONTINUE
      T=XO
      IF(A.EQ.0.)T=YO
      S=T-XCC(JS+3)
      S1=T-XCC(JS+4)
      IF(S*S1.GE.0.)GO TO 160
      T=XO
      IF(A1.EQ.0.)T=YO
      S1=T-CCC(JV+4+JE)
      S=T-CCC(JV+3+JE)
      IF((ABS(S).LE.EEX).OR.(ABS(S1).LE.EEX))GO TO 110
      IF(S*S1.GT.0.)GO TO 160
  110 CONTINUE
      IF(CC.EQ.0.)GO TO 160
      ZX=-(AC*XO+BC*YO+D)/CC
      IF(NN.NE.1 .AND. VX3 .NE. 0.)GO TO 130
      TSZ=Z2-Z1
      TSX=X2-X1
      VT=XO-X1
      IF(TSX.NE.0.)GO TO 120
      VT=YO-Y1
      TSX=Y2-Y1
  120 CONTINUE
      ZX1=(TSZ/TSX)*VT+Z1
      GO TO 140
  130 CONTINUE
      ZX1=-(VX+VX1*YO+VX2*XO)/VX3
  140 CONTINUE
      IF(ABS(ZX-ZX1).LE.EXP)GO TO 150
      IF(ZX1.GT.ZX)GO TO 160
  150 CONTINUE
      M=M+1
C
C     STORES INTERSECTIONS.
C
      XI(M+1)=XO
      YI(M+1)=YO
      ZI(M+1)=ZX1
  160 JV=JV+5
  170 CONTINUE
      NGX(1)=M
  190 RETURN
      END

      SUBROUTINE INVERD (NDIM,A,N,B,M,DETERM,ISING,INDEX)
C
C     INVERSE, OR LINEAR EQUATIONS SOLVER
C
C     NDIM IS THE ACTUAL SIZE OF A IN CALLING PROGRAM. E.G. A(NDIM,NDIM)
C     A IS SQUARE MATRIX TO BE INVERTED.
C     N IS SIZE OF UPPER LEFT PORTION BEING INVERTED.
C     B IS COLUMN OF CONSTANTS (OPTIONAL INPUT). SUPPLY SPACE B(NDIM,1)
C     M IS THE NUMBER OF COLUMNS OF CONSTANTS
C     DETERM RETURNS THE VALUE OF DETERMINANT IF NON-SINGULAR
C     ISING RETURNS 2, IF MATRIX A(N,N) IS SINGULAR, 1 OTHERWISE.
C     (IF ISING IS SET TO .LT. 0 UPON INPUT, DETERM IS NO CALCULATED)
C     INVERSE RETURNS  IN A
C     SOLUTION VECTORS RETURN IN B
C     INDEX IS WORKING STORAGE (N,3)
C
      DIMENSION        A(NDIM,1),  B(NDIM,1), INDEX(N,3)
      DOUBLE PRECISION A, B, AMAX, T, SWAP,   DETERM, PIVOT, EPSI
      COMMON /MACHIN/  MACH
      EQUIVALENCE      (IROW,JROW), (ICOLUM,JCOLUM), (AMAX, T, SWAP)
      DATA    EPSI  /  1.0D-36/
C
C     INITIALIZE
C
      IF (MACH  .EQ. 5) EPSI = 1.D-18
      DETERM = 1.0D0
      IF (ISING .LT. 0) DETERM = 0.0D0
      DO 10 J = 1,N
   10 INDEX(J,3) = 0
      DO 130 I = 1,N
C
C     SEARCH FOR PIVOT
C
      AMAX = 0.0D0
      DO 40 J = 1,N
      IF (INDEX(J,3) .EQ. 1) GO TO 40
      DO 30 K = 1,N
      IF (INDEX(K,3) - 1) 20,30,190
   20 IF (DABS(A(J,K)).LE. AMAX) GO TO 30
      IROW = J
      ICOLUM = K
      AMAX = DABS(A(J,K))
   30 CONTINUE
   40 CONTINUE
      INDEX(ICOLUM,3) = INDEX(ICOLUM,3) + 1
      INDEX(I,1) = IROW
      INDEX(I,2) = ICOLUM
C
C     INTERCHANGE ROWS TO PUT PIVOT ELEMENT ON DIAGONAL
C
      IF (IROW .EQ. ICOLUM) GO TO 70
      DETERM = -DETERM
      DO 50 L = 1,N
      SWAP = A(IROW,L)
      A(IROW  ,L) = A(ICOLUM,L)
   50 A(ICOLUM,L) = SWAP
      IF (M .LE. 0) GO TO 70
      DO 60 L = 1,M
      SWAP = B(IROW,L)
      B(IROW  ,L) = B(ICOLUM,L)
   60 B(ICOLUM,L) = SWAP
C
C     DIVIDE PIVOT ROW BY PIVOT ELEMENT
C
   70 PIVOT  = A(ICOLUM,ICOLUM)
C
C     COMMENTS FROM G.CHAN/UNISYS    9/1992
C
C     THE D.P. OF VAX IS LIMITED TO 10**38. NEXT LINE COULD CAUSE
C     FLOATING POINT NUMBER OVERFLOW IN VAX IN SOME HUGE PROBLEM.
C     CHECK FIRST THAT THE CALLER REALLY WANT THE DETERMINANT TERM. IF
C     NOT, ISING SHOULD BE SET TO -1 AND THE DETERM TERM IS BY-PASSED.
C     IF DETERM IS REALLY WANTED, USE REAL*16 HERE FOR VAX, AND TURN IT
C     BACK TO D.P. BEFORE RETURN. RE-COMPILE THIS SUBROUTINE AND RE-LINK
C     NASTRAN EXECUTABLE
C
      DETERM = DETERM*PIVOT
C
      IF (DABS(PIVOT) .LT. EPSI) GO TO 190
      A(ICOLUM,ICOLUM) = 1.0D0
      DO 80 L = 1,N
   80 A(ICOLUM,L) = A(ICOLUM,L)/PIVOT
      IF (M .LE. 0) GO TO 100
      DO 90 L = 1,M
   90 B(ICOLUM,L) = B(ICOLUM,L)/PIVOT
C
C     REDUCE NON PIVOT ROWS
C
  100 DO 130 L1 = 1,N
      IF (L1 .EQ. ICOLUM) GO TO 130
      T = A(L1,ICOLUM)
      A(L1,ICOLUM) = 0.0D0
      IF (DABS(T) .LT. EPSI) GO TO 130
      DO 110 L = 1,N
  110 A(L1,L) = A(L1,L) - A(ICOLUM,L)*T
      IF (M .LE. 0) GO TO 130
      DO 120 L = 1,M
  120 B(L1,L) = B(L1,L) - B(ICOLUM,L)*T
  130 CONTINUE
C
C     INTERCHANGE COLUMNS
C
      DO 150 I = 1,N
      L = N + 1 - I
      IF (INDEX(L,1) .EQ. INDEX(L,2)) GO TO 150
      JROW   = INDEX(L,1)
      JCOLUM = INDEX(L,2)
      DO 140 K = 1,N
      SWAP = A(K,JROW)
      A(K,JROW  ) = A(K,JCOLUM)
      A(K,JCOLUM) = SWAP
  140 CONTINUE
  150 CONTINUE
      DO 170 K = 1,N
      IF (INDEX(K,3) .EQ. 1) GO TO 160
      ISING = 2
      GO TO 180
  160 CONTINUE
  170 CONTINUE
      ISING = 1
  180 RETURN
  190 ISING = 2
      RETURN
      END

      SUBROUTINE DUMERG
C
C     DRIVER FOR DMAP MODULE UMERGE
C
C     UMERGE   USET,PHIA,PHIO/PHIF/C,N,MAJOR/C,N,SUB0/C,N,SUB1 $
C
      INTEGER         USET,PHIA,PHIO,PHIF,SCR1,SUB0,SUB1,IABIT(16),
     1                NAME(2),IB(3)
      COMMON /BLANK / MAJOR(2),SUB0(2),SUB1(2)
      COMMON /BITPOS/ IBIT(32),IABIT
      DATA    NAME  / 4HUMER , 4HGE       /
      DATA    USET  , PHIA,PHIO,PHIF,SCR1 / 101,102,103,201,301/
C
      NOGO = 0
C
C     DECIDE IF CHARACTERS ARE LEGAL BIT NUMBERS
C
      IB(1) = MAJOR(1)
      IB(2) = SUB0(1)
      IB(3) = SUB1(1)
C
      DO 30 J = 1,3
      DO 20 I = 1,32
      IF (IB(J) .NE. IABIT(I)) GO TO 20
      IB(J) = IBIT(I)
      GO TO 30
   20 CONTINUE
C
C     INVALID
C
      CALL MESAGE (59,IB(J),NAME)
      NOGO = 1
   30 CONTINUE
C
      IF (NOGO .EQ. 1) CALL MESAGE (-7,0,NAME)
      CALL SDR1B (SCR1,PHIA,PHIO,PHIF,IB(1),IB(2),IB(3),USET,0,0)
      RETURN
C
      END

      SUBROUTINE XGPIMW (MSGNO,I,J,A)
C
C     XGPIMW IS USED TO WRITE ALL NON-DIAGNOSTIC MESSAGES
C     GENERATED BY THE XGPI MODULE.
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        RSHIFT,ANDF
      DIMENSION       HDG1(18),HDG2(7),HDG3(2),HDG4(22),HDG5(26),
     1                LINE(12),A(6)
      CHARACTER       UFM*23,UWM*25,UIM*29
      COMMON /XMSSG / UFM,UWM,UIM
      COMMON /SYSTEM/ ZSYS(90),LPCH,LDICT
      COMMON /OUTPUT/ PGHDG(1)
      COMMON /XGPIC / ICOLD,ISLSH,IEQUL,NBLANK,NXEQUI,
     1                NDIAG,NSOL,NDMAP,NESTM1,NESTM2,NEXIT,
     2                NBEGIN,NEND,NJUMP,NCOND,NREPT,NTIME,NSAVE,NOUTPT,
     3                NCHKPT,NPURGE,NEQUIV,NCPW,NBPC,NWPC,
     4                MASKHI,MASKLO,ISGNON,NOSGN,IALLON,MASKS(1)
      COMMON /XGPI6 / MEDTP,FNMTP,CNMTP,MEDPNT,LMED,IPLUS,DIAG14,DIAG17
      COMMON /XGPID / ICST,IUNST,IMST,IHAPP,IDSAPP,IDMAPP,
     1                ISAVE,ITPFLG,IAPND,IDUM(5),IEQFLG
      COMMON /XGPI5 / IAPP,START,ALTER(2),SOL,SUBSET,IFLAG,IESTIM,
     1                ICFTOP,ICFPNT,LCTLFL,ICTLFL(1)
      COMMON /MODDMP/ IFLG(6),NAMOPT(26)
      COMMON /RESDIC/ IRDICT, IROPEN
      EQUIVALENCE     (ZSYS( 2),OP    ), (ZSYS( 3),NOGO  ),
     1                (ZSYS( 9),NLPP  ), (ZSYS(12),NLINES),
     2                (ZSYS(77),BKDATA), (ZSYS(26),CPPGCT),
     3                (ZSYS(19),IECHO ), (ZSYS(24),ICFIAT)
      DATA    HDG1  / 17, 4H    ,4H COS,4HMIC ,4H/ NA,4HSTRA,4HN DM,
     1                4HAP C,4HOMPI,4HLER ,4H- SO,4HURCE,4H LIS,
     2                4HTING,4*4H     /
      DATA    HDG2  / 6, 6*4H         /
      DATA    HDG3  / 1, 4H           /
      DATA    HDG4  / 21,
     1                4HINTE,4HRPRE,4HTED ,4HFROM,4H THE,4H OSC,4HAR. ,
     2                4HNEGA,4HTIVE,4H DMA,4HP IN,4HDICA,4HTES ,4HA NO,
     3                4HN EX,4HECUT,4HABLE,4H INS,4HTRUC,4HTION,4H    /
      DATA    HDG5  / 25,
     1                4H* * ,4H*  D,4H M A,4H P  ,4H C R,4H O S,4H S -,
     2                4H R E,4H F E,4H R E,4H N C,4H E  ,4H * *,4H *  ,
     3                7*4H    ,4HMODU,4HLE  ,4H  NA,4HMES  /
      DATA    KDLH   / 0     /
      DATA    ISTAR  / 1H*   /
      DATA    IPAGE  / 0     /
      DATA    IBLNK  / 4H    /
C
C
      DIAGI4 = DIAG14
      IF (DIAG14 .EQ. 10) DIAGI4 = 0
      IF (DIAGI4.NE.0 .OR. DIAG17.NE.0) GO TO 100
      IF (IECHO.EQ.-2 .AND. MSGNO.NE.9) RETURN
      GO TO 110
 100  IF (IECHO.EQ.-2 .AND. (MSGNO.LE.4 .OR. MSGNO.EQ.8) .AND.
     1    MSGNO.NE.9) RETURN
 110  IF (MSGNO.LE.0 .OR. MSGNO.GT.13) GO TO 2240
      GO TO (1860,1960,2000,2020,2040,2060,2080,2100,2160,2080,
     1       1985,1970,2400), MSGNO
C
C     MESSAGE 1 - INITIALIZE PAGE HEADING
C     ===================================
C
 1860 I1 = -I
      IF (I1 .GE. 0) GO TO 1940
      I1 = HDG1(1)
      I2 = I1 + 1
      DO 1870 M = 1,I1
 1870 PGHDG(M+96) = HDG1(M+1)
      DO 1880 M = I2,32
 1880 PGHDG(M+96) = NBLANK
      IF (I .EQ. 1) GO TO 1888
      IF (I .EQ. 2) GO TO 1884
      I1 = HDG5(1)
      DO 1883 M = 1,I1
 1883 PGHDG(M+128) = HDG5(M+1)
      GO TO 1886
 1884 I1 = HDG4(1)
      DO 1885 M = 1,I1
 1885 PGHDG(M+128) = HDG4(M+1)
 1886 I1 = I1 + 32
      GO TO 1940
 1888 I1 = HDG2(1)
      I2 = I1 + 1
      DO 1890 M = 1,I1
 1890 PGHDG(M+128) = HDG2(M+1)
      DO 1900 M = I2,32
 1900 PGHDG(M+128) = NBLANK
      I1 = HDG3(1)
      I2 = I1 + 1
      DO 1920 M = 1,I1
 1920 PGHDG(M+160) = HDG3(M+1)
      DO 1930 M = I2,32
 1930 PGHDG(M+160) = NBLANK
      IF (DIAGI4.EQ.0 .AND. START.EQ.ICST) GO TO 3000
      IPAGE = 1
      CALL PAGE
      GO TO 3000
C
C     BLANK OUT HEADING
C
 1940 I2 = I1 + 1
      DO 1950 M = I2,96
      PGHDG(M+ 96) = NBLANK
 1950 CONTINUE
      NLINES = NLPP
      GO TO 3000
C
C     MESSAGE 2  (XGPI)
C     =================
C
 1960 IF (START .EQ. IUNST) GO TO 1980
      CALL PAGE2 (-6)
      WRITE  (OP,1965)
 1965 FORMAT (1H0,/,'0  + INDICATES DMAP INSTRUCTIONS THAT ARE PROCESS',
     1        'ED ONLY AT DMAP COMPILATION TIME.')
      WRITE  (OP,1967)
 1967 FORMAT ('0  * INDICATES DMAP INSTRUCTIONS THAT ARE FLAGGED FOR ',
     1        'EXECUTION IN THIS MODIFIED RESTART.')
      GO TO 3000
C
C     MESSAGE 12
C     ==========
C
 1970 CALL PAGE2 (-5)
      WRITE  (OP,1975) UIM
 1975 FORMAT (A29,' 4147', /5X,'NOTE THAT ADDITIONAL DMAP INSTRUCTIONS',
     1        ' (NOT INDICATED BY AN * IN THE DMAP SOURCE LISTING)',/5X,
     2        'NEED TO BE FLAGGED FOR EXECUTION IN ORDER TO GENERATE ',
     3        'CERTAIN REQUIRED DATA BLOCKS.', /5X,
     4        'SUCH INSTRUCTIONS AND THE ASSOCIATED DATA BLOCKS ARE ',
     5        'IDENTIFIED BELOW.')
      GO TO 3000
C
 1980 CALL PAGE2 (-6)
      WRITE  (OP,1965)
      WRITE  (OP,1982)
 1982 FORMAT ('0  * INDICATES DMAP INSTRUCTIONS THAT ARE FLAGGED FOR ',
     1        'EXECUTION IN THIS UNMODIFIED RESTART.')
      GO TO 3000
C
C     MESSAGE 11
C     ==========
C
 1985 CALL PAGE2 (-6)
      WRITE  (OP,1988) UIM,I
 1988 FORMAT (A29,' 4148', /5X,'NOTE THAT ADDITIONAL DMAP INSTRUCTIONS',
     1        ' (NOT INDICATED BY AN * IN THE DMAP SOURCE LISTING)',/5X,
     2        'NEED TO BE FLAGGED FOR EXECUTION SINCE THIS UNMODIFIED ',
     3        'RESTART INVOLVES DMAP LOOPING AND', /5X,
     4        'THE REENTRY POINT IS WITHIN A DMAP LOOP.  SUCH INSTRUCT',
     5        'IONS ARE IDENTIFIED BELOW.', /5X,
     6        'THE EXECUTION WILL, HOWEVER, RESUME AT THE LAST REENTRY',
     7        ' POINT (DMAP INSTRUCTION NO.',I5,2H).,/)
      GO TO 3000
C
C     MESSAGE 3  (KYXFLD)
C     ===================
C
 2000 NLINES = NLINES + 2
      IF (NLINES .GE. NLPP) CALL PAGE1
      WRITE  (OP,2010) I,J
 2010 FORMAT ('0TO GENERATE DATA BLOCK ',2A4,' - TURN ON THE EXECUTE ',
     1        'FLAG FOR THE FOLLOWING DMAP INSTRUCTIONS',/)
      GO TO 3000
C
C     MESSAGE 4  (KYXFLD)
C     ===================
C
 2020 NLINES = NLINES + 1
      IF (NLINES .GE. NLPP) CALL PAGE1
      L = ANDF(A(6),MASKHI)
      WRITE  (OP,2030) L,A(4),A(5)
 2030 FORMAT (1X,I4,2X,2A4)
      GO TO 3000
C
C     MESSAGE 5 - WRITE DMAP INSTRUCTION, FIRST LINE   (XSCNDM)
C     =========================================================
C
 2040 IF (DIAGI4 .EQ. 0) GO TO 2050
      IF (KDLH   .EQ. 0) GO TO 2255
 2042 CALL PAGE2 (-2)
      WRITE  (OP,2045) J,(A(M),M=1,I)
 2045 FORMAT (/1X,I7,2X,20A4)
 2050 IF (DIAG17 .NE. 0) WRITE (LPCH,2055) (A(M),M=1,I)
 2055 FORMAT (20A4)
      GO TO 3000
C
C     MESSAGE 6 - WRITE DMAP INSTRUCTION, CONTINUATION LINE   (XSCNDM)
C     ================================================================
C
 2060 IF (DIAGI4 .EQ. 0) GO TO 2070
      NLINES = NLINES + 1
      IF (NLINES .GE. NLPP) CALL PAGE
      WRITE  (OP,2065) (A(M),M=1,I)
 2065 FORMAT (10X,20A4)
 2070 IF (DIAG17 .NE. 0) WRITE (LPCH,2075) (A(M),M=1,I)
 2075 FORMAT (20A4)
      GO TO 3000
C
C     MESSAGE 7   (XLNKHD)
C     MESSAGE 10  (XLNKHD AND XOSGEN)
C     ===============================
C
 2080 CONTINUE
      IF (DIAGI4 .EQ. 0) GO TO 3000
      IWRITE = ISTAR
      IF (MSGNO .EQ. 10) IWRITE = IPLUS
      WRITE  (OP,2090) IPLUS,IWRITE
 2090 FORMAT (A1,2X,A1)
      GO TO 3000
C
C     MESSAGE 8  (KYGPI)
C     ==================
C
 2100 CALL PAGE1
      NLINES = NLINES + 4
      WRITE  (OP,2110)
 2110 FORMAT ('0THE FOLLOWING FILES FROM THE OLD PROBLEM TAPE WERE ',
     1        'USED TO INITIATE RESTART', //4X,
     2        'FILE NAME  REEL NO.  FILE NO.',/)
      DO 2150 M = I,J,3
      IREEL = ANDF(RSHIFT(A(M+2),16),31)
      IFILE = ANDF(A(M+2),MASKHI)
      CALL PAGE2 (-1)
      IF (IFILE .EQ. 0) GO TO 2130
      WRITE  (OP,2120) A(M),A(M+1),IREEL,IFILE
 2120 FORMAT (5X,2A4,2X,I8,2X,I8)
      GO TO 2150
 2130 WRITE  (OP,2140) A(M),A(M+1)
 2140 FORMAT (5X,2A4,2X,8H(PURGED))
 2150 CONTINUE
      GO TO 3000
C
C     MESSAGE 9  (KYGPI)
C     ==================
C
 2160 IF (BKDATA .LT. 0) CALL PAGE2 (-2)
      IF (BKDATA .EQ.-2) GO TO 2171
      IF (IFLG(1).EQ. 1) GO TO 2165
      WRITE  (OP,2161)
 2161 FORMAT (1H0,10X,'**COMPILATION COMPLETE - JOB TERMINATING WITH ',
     1       'NOGO STATUS**')
      GO TO 2175
 2165 IF (BKDATA .GE. 0) GO TO 2175
      WRITE  (OP,2170)
 2170 FORMAT (1H0,10X,'**NO ERRORS FOUND - EXECUTE NASTRAN PROGRAM**')
      GO TO 2175
 2171 WRITE  (OP,2172)
 2172 FORMAT (1H0,9X,'**NO ERRORS FOUND - NASTRAN EXECUTION TERMINATED',
     1        ' BY USER REQUEST**')
      GO TO 3000
C
C     DUMP FIAT IF SENSE SWITCH 2 IS ON
C
 2175 CALL SSWTCH (2,L)
      IF (L .EQ. 0) GO TO 2210
      CALL PAGE1
      NLINES = NLINES + 4
      WRITE  (OP,2180) A(1),A(2),A(3)
 2180 FORMAT (1H ,/5X,22HFIAT AT END OF PREFACE,3I15, /,1H ,/5X,'EQUIV',
     2     '  APPEND    LTU  TAPE  UNIT  FILE NAME',31X,'---TRAILER---')
      L1 = A(3)*ICFIAT - 2
      DO 2200 L = 4,L1,ICFIAT
      IEQUIV = 0
      IAPPND = 0
      ITAPE  = 0
      IF (RSHIFT(ANDF(A(L),IEQFLG),1) .GT. 0) IEQUIV = 1
      IF (ANDF(A(L),IAPND ) .GT. 0) IAPPND = 1
      IF (ANDF(A(L),ITPFLG) .GT. 0) ITAPE  = 1
      LTU = ANDF(RSHIFT(A(L),16),16383)
      IUNIT = ANDF(A(L),16383)
      IA1 = A(L+1)
      IA2 = A(L+2)
      IF (IA1 .NE. 0) GO TO 2185
      IA1 = IBLNK
      IA2 = IBLNK
 2185 M1  = L + 3
      M2  = L + 5
      CALL PAGE2 (-1)
      WRITE (OP,2190) IEQUIV,IAPPND,LTU,ITAPE,IUNIT,IA1,IA2
      IF (ICFIAT .EQ.  8) WRITE (OP,2191) (A(M),M=M1,M2)
      IF (ICFIAT .EQ. 11) WRITE (OP,2192) (A(M),M=M1,M2),(A(M+M2),M=3,5)
 2190 FORMAT (7X,I1,7X,I1,3X,I6,4X,I1,1X,I6,2X,2A4)
 2191 FORMAT (1H+,48X,3I20)
 2192 FORMAT (1H+,48X,6I10)
 2200 CONTINUE
 2210 IF (J .EQ. 0) GO TO 3000
      IF (IROPEN .EQ. 1) GO TO 2215
CWKBD OPEN (UNIT=4, FILE='FORTDIC.ZAP', STATUS='UNKNOWN')
      IROPEN = 1
 2215 WRITE  (IRDICT,2220) I
 2220 FORMAT (9X,'1,   XVPS    ,   FLAGS = 0,   REEL =  1,   FILE =',I7)
      CALL SSWTCH (9,DIAG09)
      IF (DIAG09 .EQ. 1) GO TO 3000
      CALL PAGE1
      NLINES = NLINES + 3
      WRITE  (OP,2230)
 2230 FORMAT (9X,'CONTINUATION OF CHECKPOINT DICTIONARY', /,1H )
      WRITE  (OP,2220) I
      GO TO 3000
 2240 NLINES = 2 + NLINES
      IF (NLINES .GE. NLPP) CALL PAGE1
      WRITE  (OP,2250) MSGNO
 2250 FORMAT (//,' NO MESSAGE AVAILABLE FOR MESSAGE NO. ',I4)
      GO TO 3000
C
C     PROCESS DMAP COMPILER OPTIONS SUMMARY
C
 2255 IF (KDLH .NE. 0) GO TO 3000
      IF (IPAGE.EQ. 0) CALL PAGE
      NLINES   = NLINES + 4
      LINE( 1) = NAMOPT( 1)
      LINE( 2) = NAMOPT( 2)
      LINE( 3) = NAMOPT( 5)
      LINE( 4) = IFLG  ( 2)
      LINE( 5) = NAMOPT( 9)
      LINE( 6) = NAMOPT(10)
      LINE( 7) = NAMOPT(13)
      LINE( 8) = NAMOPT(14)
      LINE( 9) = NAMOPT(17)
      LINE(10) = NAMOPT(18)
      LINE(11) = NAMOPT(21)
      LINE(12) = NAMOPT(22)
      IF (IFLG(1) .LE. 0) LINE(1) = NAMOPT(3)
      IF (IFLG(3) .LE. 0) GO TO 2300
      LINE( 5) = NAMOPT( 7)
      LINE( 6) = NAMOPT( 8)
 2300 IF (IFLG(4) .LE. 0) GO TO 2310
      LINE( 7) = NAMOPT(11)
      LINE( 8) = NAMOPT(12)
 2310 IF (IFLG(5) .LE. 0) GO TO 2330
      LINE( 9) = NAMOPT(15)
      LINE(10) = NAMOPT(16)
 2330 IF (IFLG(6) .LE. 0) GO TO 2345
      LINE(11) = NAMOPT(19)
      LINE(12) = NAMOPT(20)
 2345 WRITE  (OP,2350) (LINE(KKDJ),KKDJ=1,12)
 2350 FORMAT ('0  OPTIONS IN EFFECT ',2A4,A3,1H=,I1,3X,8A4,/3X,17(1H-),
     1        /)
      KDLH = 1
      GO TO 2042
C
C     MESSAGE 13   (XGPI)
C     ===================
C
 2400 NSCR = 315
      L    = 20
      CALL OPEN (*3000,NSCR,A(L),0)
      CALL PAGE1
      CALL PAGE3 (4)
      WRITE  (OP,2410) UIM
 2410 FORMAT (A29,' - DUE TO ERROR(S), POSSIBLY ORIGINATED FROM USER''S'
     1,      ' ALTER PACKAGE, THE UNMODIFIED RIGID FORMAT LISTING', /5X,
     2       'IS PRINTED FOR CROSS REFERENCE',/)
      L = 0
 2420 CALL READ (*2440,*2440,NSCR,A(1),18,0,M)
      IF (A(1) .EQ. IBLNK) GO TO 2430
      CALL PAGE3 (2)
      L = L + 1
      WRITE (OP,2045) L,(A(M),M=1,18)
      GO TO 2420
 2430 NLINES = NLINES + 1
      IF (NLINES .GE. NLPP) CALL PAGE
      WRITE (OP,2065) (A(M),M=1,18)
      GO TO 2420
 2440 CALL CLOSE (NSCR,1)
C
 3000 RETURN
      END

      SUBROUTINE PKTRPL
C  THIR ROUTINE CALCULATES THE STIFFNESS MATRIX FOR TRI-PLATES IN  PLA4
C
C     THIS ROUTINE GENERATES THE FOLLOWING
C
C                             3-6X6 STIFFNESS MATRICES WITH RESPECT
C                             TO ONE PIVOT POINT OF A TRIANGULAR PLATE
C                             ELEMENT.
C
C         REF. FMMS-55  NOVEMBER 1ST, 1967
C
C         CALLS FROM THIS ROUTINE ARE MADE TO
C                             PKTRBS - BASIC BENDING TRIANGLE
C                             TRANSD - SUPPLIES 3X3 TRANSFORMATIONS
C                             INVERD - MATRIX INVERSION ROUTINE
C                             PLA4B  - INSERTION ROUTINE
C                             GMMATD - GENERAL MATRIX MULITPLY AND
C                                      TRANSPOSE ROUTINE
C                             MESAGE - ERROR MESSAGE WRITER
C
C
      INTEGER            SUBSCA        ,SUBSCB        ,SUBSCC
      DOUBLE PRECISION
     1                   R             ,D1            ,HABC
     2                  ,TEMP          ,D2            ,HINV
     3                  ,KSUM          ,IVECT         ,G
     4                  ,V             ,JVECT         ,E
     5                  ,VV            ,KVECT         ,TITE
     6                  ,XSUBB         ,TEMP9         ,TJTE
     7                  ,XSUBC         ,PROD9         ,ARR9
     8                  ,YSUBC         ,U1            ,ARRAY9
     9                  ,T             ,U2            ,TEMP18
     T                  ,A             ,TEMP1         ,PROD12
     1                  ,C1            ,TEMP2         ,HQ
     2                  ,C2            ,L1            ,Y1
     3                  ,X1            ,L2            ,Y2
     4                  ,X2            ,S1            ,DETERM
     5                  ,S2            ,KOUT          ,S ,REQUIV
C     ******************************************************************
C
C     ECPT LISTS AS OF AUGUST 4, 1967
C
C                 DEFINITION
C       ECPT      TRI.PLATE AND BASIC BENDING TRI.
C     ******************************************************************
C     ECPT( 1) = ELEMENT ID         INTEGER
C     ECPT( 2) = GRID PT. A         INTEGER
C     ECPT( 3) = GRID PT. B         INTEGER
C     ECPT( 4) = GRID PT. C         INTEGER
C     ECPT( 5) = THETA              REAL
C     ECPT( 6) = MAT ID 1           INTEGER
C     ECPT( 7) = I  MOM. OF INERT.  REAL
C     ECPT( 8) = MAT ID 2           INTEGER
C     ECPT( 9) = T2                 REAL
C     ECPT(10) = NON-STRUCT. MASS   REAL
C     ECPT(11) = Z1                 REAL
C     ECPT(12) = Z2                 REAL
C     ECPT(13) = COORD. SYS. ID 1   INTEGER
C     ECPT(14) = X1                 REAL
C     ECPT(15) = Y1                 REAL
C     ECPT(16) = Z1                 REAL
C     ECPT(17) = COORD. SYS. ID 2   INTEGER
C     ECPT(18) = X2                 REAL
C     ECPT(19) = Y2                 REAL
C     ECPT(20) = Z2                 REAL
C     ECPT(21) = COORD. SYS. ID 3   INTEGER
C     ECPT(22) = X3                 REAL
C     ECPT(23) = Y3                 REAL
C     ECPT(24) = Z3                 REAL
C     ECPT(25) = ELEMENT TEMP       REAL
C     ******************************************************************
      DIMENSION
     1                   NECPT(100)    ,M(9)          ,REQUIV(8)
     2                  ,HQ(12)        ,PROD12(12)    ,HABC(18)
     3                  ,G(36)         ,TITE(18)      ,TJTE(18)
     4                  ,KOUT(36)      ,TEMP18(18)    ,V1(3)
     5                  ,V2(3)         ,V3(3)         ,R(2,4)
     6                  ,D1(3)         ,D2(3)
C
      COMMON /CONDAS/ CONSTS(5)
      COMMON /MATIN / MATID,INFLAG,ELTEMP,STRESS,SINTH,COSTH
      COMMON /MATOUT/G11,G12,G13,G22,G23,G33,RHO,ALPHA1,ALPHA2,ALP12,
     1                T SUB 0, G SUB E, SIGTEN, SIGCOM, SIGSHE,
     2                G2X211, G2X212, G2X222
      COMMON /PLA42C/ NPVT, DUM1(3)
     1,                  DUMCL(145)         ,NOGO
      COMMON /PLA4ES/ ECPT(100)
      COMMON /PLA42D/
     1                   A(81)         ,S(18)         ,T(9)
     2                  ,TEMP9(9)      ,PROD9(9)      ,ARR9(9)
     3                  ,ARRAY9(9)     ,HINV(36)      ,KSUM(63)
     4                  ,XSUBB         ,XSUBC         ,YSUBC
     5                  ,E(18)         ,TEMP          ,L1
     6                  ,L2            ,S1            ,S2
     7                  ,C1            ,C2            ,X1
     8                  ,X2            ,Y1            ,Y2
     9                  ,TEMP1         ,TEMP2         ,DUMTWO(2) ,DETERM
     T                  ,NPOINT        ,KM            ,SUBSCA
     1                  ,SUBSCB        ,SUBSCC        ,NPIVOT
     2                  ,THETA         ,NSUBC         ,ISING
     3                  ,NPT1          ,V(2)          ,VV(2)
     4                  ,IVECT(3)      ,JVECT(3)      ,KVECT(3)
     5                  ,U1            ,U2            ,SINANG
     6                  ,COSANG
C
      EQUIVALENCE ( CONSTS(4) , DEGRA  )
      EQUIVALENCE
     1                                 (NECPT(1),ECPT(1))
     2                                 ,(PROD12(1),A(13))
     3                                 ,(HABC(1),A(25))
     4                                 ,(TITE(1),A(37))
     5                                 ,(TJTE(1),A(55))
     6                                 ,(KOUT(1),A(1))
     7                                 ,(TEMP18(1),HINV(1))
     8                                 ,(V1(1),ECPT(14))
     9                                 ,(V2(1),ECPT(18))
     T                                 ,(V3(1),ECPT(22))
     1                                 ,(REQUIV(1),R(1,1))
     2                                 ,(D1(1),A(1))
     3                                 ,(D2(1),A(4))
     4                                 ,(HQ(1),A(1))
C
      DATA M/ 1,2,4,   2,3,4,   3,1,4 /
C
C     DETERMINE PIVOT POINT NUMBER
C
      DO 10 I=1,3
      IF( NPVT .NE. NECPT(I+1) ) GO TO 10
      NPIVOT = I
      GO TO 20
   10 CONTINUE
C
C
C     FALL THRU ABOVE LOOP IMPLIES ERROR CONDITION
      CALL MESAGE(-30,34,ECPT(1))
C
   20 THETA = ECPT(5) * DEGRA
      SINANG = SIN( THETA )
      COSANG = COS( THETA )
C     FORMATION OF THE R-MATRIX CONTAINING COORDINATES OF THE
C     SUB TRIANGLES. (2X4) FOR TRIANGULAR PLATE. (COLUMN 4 BLANK)
C     FORMATION ALSO OF THE I,J, AND K VECTORS USED IN THE E-MATRIX.
C
C     ZERO OUT R-MATRIX
      DO 30 I=1,8
   30 REQUIV(I)=0.0D0
C
      DO 40 I=1,3
      D2(I) = DBLE( V2(I) ) - DBLE( V1(I) )
   40 D1(I) = DBLE( V3(I) ) - DBLE( V1(I) )
C
C     X2  GOES IN R(1,2)
      R(1,2) = DSQRT ( D2(1)**2  +  D2(2)**2  +  D2(3)**2 )
      IF (R(1,2).EQ.0.0D0) GO TO 370
      DO 50 I=1,3
   50 IVECT(I) = D2(I) / R(1,2)
C
C     NON-NORMALIZED K-VECTOR
      KVECT(1) = IVECT(2) * D1(3)    -    D1(2) * IVECT(3)
      KVECT(2) = IVECT(3) * D1(1)    -    D1(3) * IVECT(1)
      KVECT(3) = IVECT(1) * D1(2)    -    D1(1) * IVECT(2)
C
C     Y3 GOES INTO R(2,3)
      R(2,3) = DSQRT ( KVECT(1)**2 + KVECT(2)**2 + KVECT(3)**2 )
      IF (R(2,3).EQ.0.0D0) GO TO 370
      DO 60 I=1,3
   60 KVECT(I) = KVECT(I) / R(2,3)
C
C     J-VECTOR = K X I  VECTORS
      JVECT(1) = KVECT(2) * IVECT(3) - IVECT(2) * KVECT(3)
      JVECT(2) = KVECT(3) * IVECT(1) - IVECT(3) * KVECT(1)
      JVECT(3) = KVECT(1) * IVECT(2) - IVECT(1) * KVECT(2)
C     NORMALIZE J VECTOR TO MAKE SURE
      TEMP = DSQRT ( JVECT(1)**2 + JVECT(2)**2 + JVECT(3)**2 )
      IF (TEMP.EQ.0.0D0) GO TO 370
      DO 70 I=1,3
   70 JVECT(I) = JVECT(I) / TEMP
C     X3 GOES INTO R(1,3) = D1 DOT IVECT
      R(1,3) = D1(1) * IVECT(1)  +  D1(2) * IVECT(2) + D1(3) * IVECT(3)
C
C     CENTROID POINT GOES INTO R(1,4) AND R(2,4)
      R(1,4) = (  R(1,2) + R(1,3)  ) / 3.0D0
      R(2,4) = R(2,3) / 3.0D0
C     ******************************************************************
C            THE COORDINATES AND CENTROID OF THE PLATE IN THE ELEMENT
C     SYSTEM ARE STORED IN THE R-MATRIX WHERE THE COLUMN DENOTES THE
C     POINT AND THE ROW DENOTES THE X OR Y COORDINATE FOR ROW 1 OR
C     ROW 2 RESPECTIVELY.
C     ******************************************************************
C
C     SET UP THE M-MATRIX FOR MAPPING TRIANGLES, IN DATA STATEMENT.
C
C     ******************************************************************
C     ZERO OUT THE KSUM MATRIX FOR 63 AND THE GSUM MATRIX FOR 36...
C
      DO 80 I=1,63
   80 KSUM(I) = 0.0D0
      DO 90 I=1,36
   90 G(I) = 0.0D0
C
C
      DO 210 J=1,3
      KM = 3*J - 3
C
      SUBSCA = M(KM+1)
      SUBSCB = M(KM+2)
      SUBSCC = M(KM+3)
C
      DO 100 I=1,2
      V(I) = R(I,SUBSCB) - R(I,SUBSCA)
  100 VV(I)= R(I,SUBSCC) - R(I,SUBSCA)
      XSUBB = DSQRT ( V(1)**2 + V(2)**2 )
      U1 = V(1) / XSUBB
      U2 = V(2) / XSUBB
      XSUBC = U1 * VV(1) + U2 * VV(2)
      YSUBC = U1 * VV(2) - U2 * VV(1)
C
      SINTH = SINANG * U1  -  COSANG * U2
      COSTH = COSANG * U1  +  SINANG * U2
      IF(ABS(SINTH) .LT. 1.0E-06) SINTH = 0.0E0
C
C     AT THIS POINT, XSUBB, XSUBC, YSUBC ARE AT HAND FOR
C     TRIANGLE -J-
C
      CALL PKTRBS(2)
C                         U
C     NOW HAVE AT HAND  K    I,J, =1,2,3.   9-3X3 MATRICES STORED AT
C                        IJ                 A(1) THROUGH A(81).
C
C           -1
C     ALSO H   (6X6) AT A(145) TO A(181) AND S (6X3) AT A(82) TO A(99)
C
C     NOW ADD CERTAIN OF THESE INTO THE SUMMED MATRICES
C
C
C     SET UP OF T-MATRIX
C
      T(1) = 1.0D0
      T(2) = 0.0D0
      T(3) = 0.0D0
      T(4) = 0.0D0
      T(5) = U1
      T(6) = U2
      T(7) = 0.0D0
      T(8) =-U2
      T(9) = U1
C
      DO 120 I=1,3
      CALL GMMATD( T(1),3,3,1,  A(27*I-8),3,3,0,  TEMP9(1) )
      CALL GMMATD( TEMP9(1),3,3,0,  T(1),3,3,0,  PROD9(1) )
C
C     ADD THIS PRODUCT IN NOW.
C     COMPUTE POINTER TO KSUM MATRIX DESIRED.  (ZERO POINTER)
      NPOINT = KM + I
      NPOINT = 9*M(NPOINT) + 18
C
      DO 110 K=1,9
      NSUBC  = NPOINT + K
  110 KSUM(NSUBC) = KSUM(NSUBC) + PROD9(K)
  120 CONTINUE
      DO 150 K=1,2
      NPOINT = KM + K
      IF( M(NPOINT) .NE. NPIVOT ) GO TO 150
      CALL GMMATD( T(1),3,3,1,  A(36*K-35),3,3,0,  TEMP9(1) )
      CALL GMMATD( TEMP9(1),3,3,0,  T(1),3,3,0,  PROD9(1) )
C
C     COMPUTE POINTER TO KSUM MATRIX (ZERO POINTER)
C
      NPOINT = 9 * NPIVOT - 9
      DO 130 I=1,9
      NSUBC = NPOINT + I
  130 KSUM(NSUBC) = KSUM(NSUBC) + PROD9(I)
C
      CALL GMMATD(T(1),3,3,1,  A(18*K-8),3,3,0,  TEMP9(1) )
      CALL GMMATD( TEMP9(1),3,3,0,  T(1),3,3,0,  PROD9(1) )
C
C     COMPUTE ZERO POINTER TO KSUM MATRIX DESIRED
C
      NPOINT = KM + 3 - K
      NPOINT = 9 * M(NPOINT) - 9
      DO 140 I=1,9
      NSUBC = NPOINT + I
  140 KSUM(NSUBC) = KSUM(NSUBC) +  PROD9(I)
  150 CONTINUE
C
C     FORM HQ (2X6)
C
      TEMP1 = XSUBB - XSUBC
      TEMP2 = YSUBC ** 2
      L1 = DSQRT( XSUBC**2 + TEMP2 )
      L2 = DSQRT( TEMP1**2 + TEMP2 )
      S1 = XSUBC / L1
      S2 = TEMP1 / L2
      C1 = YSUBC / L1
      C2 = YSUBC / L2
      X1 = XSUBC / 2.0D0
      Y1 = YSUBC / 2.0D0
      X2 = (XSUBB + XSUBC) / 2.0D0
      Y2 = Y1
      HQ( 1) = -XSUBC * C1
      HQ( 2) = X1 * S1 - Y1 * C1
      HQ( 3) = 2.0D0 * Y1 * S1
      HQ( 4) = -3.0D0 * X1 * X1 * C1
      HQ( 5) = Y1 * (2.0D0 * X1 * S1 - Y1 * C1 )
      HQ( 6) = 3.0D0 * Y1 * Y1 * S1
      HQ( 7) = 2.0D0 * X2 * C2
      HQ( 8) = X2 * S2  + Y2 * C2
      HQ( 9) = 2.0D0 * Y2 * S2
      HQ(10) = 3.0D0 * X2 * X2 * C2
      HQ(11) = Y2 * ( 2.0D0 * X2 * S2 + Y2 * C2 )
      HQ(12) = 3.0D0 * Y2 * Y2 * S2
C
C                      I                    -1
C     COMPUTE (H       I  H     )  = (HQ)(H)    STORE IN PROD12
C               PSI,B  I   PSI,C
C                      I
C
C
      CALL GMMATD( HQ(1),2,6,0, HINV(1),6,6,0,  PROD12(1) )
C
C
C     COMPUTE (H     ) = -(PROD12)(S)
C               PSI,A
C
      CALL GMMATD( PROD12(1),2,6,0, S(1),6,3,0,  HABC(1) )
C
      HABC(1) = -HABC(1)
      HABC(2) = -HABC(2) + S1
      HABC(3) = -HABC(3) + C1
      HABC(4) = -HABC(4)
      HABC(5) = -HABC(5) + S2
      HABC(6) = -HABC(6) - C2
C
C     SPLIT (H     ) AND (H     )    PARTITION
C             PSI,B        PSI,C
C
      HABC( 7) = PROD12( 1)
      HABC( 8) = PROD12( 2)
      HABC( 9) = PROD12( 3)
      HABC(10) = PROD12( 7)
      HABC(11) = PROD12( 8)
      HABC(12) = PROD12( 9)
      HABC(13) = PROD12( 4)
      HABC(14) = PROD12( 5)
      HABC(15) = PROD12( 6)
      HABC(16) = PROD12(10)
      HABC(17) = PROD12(11)
      HABC(18) = PROD12(12)
C
C     MAP  H , H , AND H  INTO THE G-MATRICES.
C           A   B       C
C
C     TRIANGLE NUMBER = J, THE THREE POINTS ARE SUBSCA, SUBSCB, SUBSCC.
C
      DO 200 I=1,3
C
C     POINTER TO H  = 6*I-6
C                 I
C
C
C     TRANSFORM H SUB I
C
      CALL GMMATD( HABC(6*I-5),2,3,0,  T(1),3,3,0,  TEMP9(1) )
C
C
      NPOINT = KM + I
      NPOINT = 9*M(NPOINT) - 9
C
C     J = 1    ROW 1 OF H INTO ROW 1 OF G.
C              ROW 2 OF H INTO ROW 2 OF G.
C     J = 2    ROW 1 OF H INTO ROW 2 OF G.
C              ROW 2 OF H INTO ROW 3 OF G.
C     J = 3    ROW 1 OF H INTO ROW 3 OF G.
C              ROW 2 OF H INTO ROW 1 OF G.
C
      IF( J-2 ) 170,160,190
C
  160 NPOINT = NPOINT + 3
  170 DO 180 K=1,6
      NPOINT = NPOINT + 1
  180 G(NPOINT) = G(NPOINT) + TEMP9(K)
      GO TO 200
  190 G(NPOINT + 7) = G(NPOINT + 7) + TEMP9(1)
      G(NPOINT + 8) = G(NPOINT + 8) + TEMP9(2)
      G(NPOINT + 9) = G(NPOINT + 9) + TEMP9(3)
      G(NPOINT + 1) = G(NPOINT + 1) + TEMP9(4)
      G(NPOINT + 2) = G(NPOINT + 2) + TEMP9(5)
      G(NPOINT + 3) = G(NPOINT + 3) + TEMP9(6)
C
  200 CONTINUE
C
C
C     END OF LOOP FOR BASIC TRIANGLES
C
  210 CONTINUE
C     ******************************************************************
C
C     FILL E-MATRIX
C
      DO 220 I=1,18
  220 E(I) = 0.0D0
      E( 1) = KVECT(1)
      E( 4) = KVECT(2)
      E( 7) = KVECT(3)
      E(11) = IVECT(1)
      E(14) = IVECT(2)
      E(17) = IVECT(3)
      E(12) = JVECT(1)
      E(15) = JVECT(2)
      E(18) = JVECT(3)
C
C              T
C     FORM   T   E      STORE IN TITE-MATRIX (6X3)
C             I
C
      IF( NECPT(4*NPIVOT+9) .EQ. 0 ) GO TO 230
      CALL TRANSD( NECPT(4*NPIVOT+9), T(1) )
      CALL GMMATD( T(1),3,3,1,  E( 1),3,3,0,  TITE( 1) )
      CALL GMMATD( T(1),3,3,1,  E(10),3,3,0,  TITE(10) )
      GO TO 250
  230 DO 240 K=1,18
  240 TITE(K) = E(K)
C
C     SOLVE NOW FOR ....
C
C    E                   T     T                       T
C (K  ) = (K  ) - (TERM ) (K  ) - (K  )(TERM ) + (TERM )(K  )(TERM )
C   IJ      IJ         I    J4      I4      J         I   44      J
C
C                        -1                               I=NPIVOT
C WHERE... (TERM ) = (G )  (G ) ,I=NPIVOT                 J=1,2,3
C               I      4     I
C
C                        -1
C          (TERM ) = (G )  (G ) ,J=1,2,3 AS ABOVE
C               J      4     J
C
C     AND WITH TRANSFORMATIONS....
C
C    G        T      E   T
C (K  ) = (C ) (E)(K  )(E )(C )
C   IJ      I       IJ       J
C
C
C     COMPUTE  (TERM        )  STORE IN PROD9
C                   I=NPIVOT
C
C                   -1
C     FIRST GET (G )
C                 4
C
  250 CONTINUE
C     NO NEED TO COMPUTE DETERMINANT SINCE IT IS NOT USED SUBSEQUENTLY.
      ISING = -1
      CALL INVERD( 3,G(28),3,PROD9,0,DETERM,ISING,TEMP9 )
C
C     CHECK FOR SINGULARITY. ISING=2 IMPLIES SINGULARITY.
      GO TO(270,260),ISING
  260 CALL MESAGE(30,36,ECPT(1))
C
C  SET FLAG FOR FATAL ERROR WHILE ALLOWING ERROR MESSAGES TO ACCUMULATE
C
      NOGO=1
      RETURN
C
  270 CALL GMMATD ( G(28),3,3,0,  G(9*NPIVOT-8),3,3,0,  PROD9(1) )
C
C                       T
C     GET  (TERM        )(K  )  STORE IN TEMP9
C               I=NPIVOT   44
C
      CALL GMMATD( PROD9(1),3,3,1,  KSUM(55),3,3,0,  TEMP9(1) )
C
C
C
C     THE TWO COMMON PRODUCTS ARE NOW AT HAND IN PROD9 AND TEMP9.
C
      DO 360 J=1,3
C
C                   T     T
C     (TERM        ) (K  )    STORE IN ARR9
C          I=NPIVOT    J4
C
      CALL GMMATD( PROD9(1),3,3,1,  KSUM(9*J+19),3,3,1,  ARR9(1) )
C
C     SUBTRACT FROM (K  )
C                     IJ
C
      NBEGIN = 9*J-9
      DO 280 I=1,9
      NPOINT = NBEGIN + I
  280 KSUM(NPOINT) = KSUM(NPOINT) - ARR9(I)
C
C
C      COMPUTE  (TERM )  STORE IN ARR9
C                   J
C
      CALL GMMATD( G(28),3,3,0,  G(9*J-8),3,3,0,  ARR9(1) )
C
C
C     GET  (K  )(TERM )  STORE IN ARRAY9
C            I4      J
C
      CALL GMMATD( KSUM(9*NPIVOT+19),3,3,0,  ARR9(1),3,3,0,  ARRAY9(1))
C
C     SUBTRACT FROM KIJ
C
      DO 290 I=1,9
      NPOINT = NBEGIN + I
  290 KSUM(NPOINT) = KSUM(NPOINT) - ARRAY9(I)
C
C                           T
C     COMPUTE  (TERM        )(K  )(TERM ) = (TEMP9)(ARR9)
C                   I=NPOINT   44      J
C
      CALL GMMATD( TEMP9(1),3,3,0,  ARR9(1),3,3,0,  ARRAY9(1) )
C
C     ADD TO K
C             IJ
C
      DO 300 I=1,9
      NPOINT = NBEGIN + I
  300 KSUM(NPOINT) = KSUM(NPOINT) + ARRAY9(I)
C
C       E
C     K    COMPLETE
C      IJ
C
C     TRANSFORM NOW, AND INSERT.
C
C
C     TRANSFORMATIONS AND INSERTION
C
      IF( NECPT(4*J+9) .EQ. 0) GO TO 310
      CALL TRANSD( NECPT(4*J+9), T(1) )
      CALL GMMATD( T(1),3,3,1,  E( 1),3,3,0,  TJTE( 1) )
      CALL GMMATD( T(1),3,3,1,  E(10),3,3,0,  TJTE(10) )
      GO TO 330
  310 DO 320 K=1,18
  320 TJTE(K) = E(K)
  330 CALL GMMATD( KSUM(NBEGIN+1),3,3,0,  TJTE(1),6,3,1,  TEMP18(1) )
      CALL GMMATD ( TITE(1),6,3,0,  TEMP18(1),3,6,0,  KOUT(1))
      CALL PLA4B(KOUT(1),NECPT(J+1))
C
  360 CONTINUE
      RETURN
  370 CALL MESAGE(30,26,ECPT(1))
C
C  SET FLAG FOR FATAL ERROR WHILE ALLOWING ERROR MESSAGES TO ACCUMULATE
C
      NOGO=1
      RETURN
      END

      SUBROUTINE AMPC1(INPUT,OUTPUT,NCOL,Z,MCB)
C
C     THE PURPOSE OF THIS ROUTINE IS TO COPY NCOL COLUMNS FROM INPUT
C      TO OUTPUT VIA UNPACK AND PACK.
C
C     THE PACK COMMON BLOCKS HAVE BEEN INITIALIZED OUTSIDE THE ROUTINE
C
      INTEGER OUTPUT,MCB(7),Z(1)
C
      COMMON /PACKX/IT1,IT2,II,NN,INCR
C
C-----------------------------------------------------------------------
C
      DO 10 I=1,NCOL
      CALL UNPACK(*20,INPUT,Z)
      CALL PACK(Z,OUTPUT,MCB)
      GO TO 10
C
C     NULL COLUMN
C
   20 CALL BLDPK(IT1,IT2,OUTPUT,0,0)
      CALL BLDPKN(OUTPUT,0,MCB)
   10 CONTINUE
      RETURN
      END

      SUBROUTINE TRANEM (MCSID, NGRID, R, ICOMP, U, RC)
C*****
C     COMPUTES A STRESS TRANSFORMATION MATRIX U FOR TRIANGLES AND QUADS.
C     INPUTS
C        MCSID  ID OF COORDINATE SYSTEM REFERENCED ON MAT1,2 DATA CARD.
C        NGRID  3 FOR TRIANGLES, 4 FOR QUADS.
C        R      ARRAY OF BASIC LOCATIONS OF ELEMENT GRID PTS (3,NGRID).
C     OUTPUTS
C        ICOMP  1 (IF MAT X-AXIS IS USED) OR 2 (IF Y-AXIS IS USED).
C        U      ARRAY (3X3) FOR TRANSFORMATION, STORED BY ROW.
C        RC     BASIC LOCATION COORDINATES OF ELEMENT CENTER.
C     REQUIREMENTS
C        SUBROUTINE PRETRS MUST SET UP FOR TRANSS. SEE P.M. PAGE 3.4-66
C*****
      INTEGER ECPT(4),SUBNAM(2)
C
      REAL RC(3)
      REAL R(9)
      REAL U(9)
      REAL RCENT(4)
C
      EQUIVALENCE  (RCENT(1), ECPT(1))
C
      DATA SUBNAM /4HTRAN,2HEM/
C
C-----------------------------------------------------------------------
C
      IF(NGRID .NE.3 .AND. NGRID.NE.4 )  CALL MESAGE(-61,0,SUBNAM)
C*****
C     FIND THE UNIT NORMAL OF THE ELEMENT
C*****
      I = 3*(NGRID-3)
      VN1 = (R(8)-R(2))*(R(I+9)-R(6))-(R(9)-R(3))*(R(I+8)-R(5))
      VN2 = (R(9)-R(3))*(R(I+7)-R(4))-(R(7)-R(1))*(R(I+9)-R(6))
      VN3 = (R(7)-R(1))*(R(I+8)-R(5))-(R(8)-R(2))*(R(I+7)-R(4))
      TEMP = SQRT(VN1**2+VN2**2+VN3**2)
      IF(TEMP .LE. 0.0) CALL MESAGE(-61,0,SUBNAM)
      VN1 = VN1 / TEMP
      VN2 = VN2 / TEMP
      VN3 = VN3 / TEMP
C*****
C     GET THE UNIT VECTORS OF MCSID AT ELEM CENTER. PUT IN U TEMPORARILY
C*****
      GRDS = NGRID
      DO 20 IC=1,3
      SUM = 0.0
      DO 10 IG=1,NGRID
      K = 3*IG + IC-3
      SUM = SUM +R(K)
   10 CONTINUE
      RCENT(IC+1) = SUM / GRDS
      RC(IC) = RCENT(IC+1)
   20 CONTINUE
      ECPT(1) = MCSID
      CALL TRANSS(ECPT,U)
C*****
C     SELECT FIRST OR SECOND VECTOR TO PROJECT FOR ELEM-MAT X-AXIS
C*****
      VNDOTM=VN1*U(1)+VN2*U(4)+VN3*U(7)
      IF( VNDOTM**2 .GT. 0.4) GO TO 30
      ICOMP = 1
      VM1 = U(1)
      VM2 = U(4)
      VM3 = U(7)
      GO TO 40
   30 CONTINUE
      ICOMP = 2
      VM1 = U(2)
      VM2 = U(5)
      VM3 = U(8)
      VNDOTM = VN1*VM1+VN2*VM2+VN3*VM3
   40 CONTINUE
C*****
C     FIND COSINE AND SINE OF ANGLE
C*****
      VE1 = R(4) - R(1)
      VE2 = R(5) - R(2)
      VE3 = R(6) - R(3)
      C = VE1*(VM1-VNDOTM*VN1)
     *  + VE2*(VM2-VNDOTM*VN2)
     *  + VE3*(VM3-VNDOTM*VN3)
      S = VE1*(VM2*VN3-VM3*VN2)
     *  + VE2*(VM3*VN1-VM1*VN3)
     *  + VE3*(VM1*VN2-VM2*VN1)
      TEMP = SQRT(C*C+S*S)
      IF(TEMP .LE. 0.0) CALL MESAGE(-61,0,SUBNAM)
      C = C/TEMP
      S = S/TEMP
C*****
C     FILL IN THE U MATRIX, ROW STORED.
C*****
      U(1) = C*C
      U(4) = S*S
      U(7) = -C*S
      U(2) = U(4)
      U(5) = U(1)
      U(8) = -U(7)
      U(3) = 2.0*U(8)
      U(6) = -U(3)
      U(9) = U(1)-U(4)
C
      RETURN
C
      END

      SUBROUTINE STRQD2( NPTS, TI )
C
C     ****PHASE II OF STRESS DATA RECOVERY*********
C
C     NPTS = 3 IMPLIES STRIA1 OR STRIA2  (PHASE II)
C     NPTS = 4 IMPLIES SQUAD1 OR SQUAD2  (PHASE II)
C
      LOGICAL FLAG
      LOGICAL STRAIN
C
      REAL    TI(6)    ,SDELTA(3),SSTRSS(3),FRLAST(2)
C
      INTEGER IST(10)
      INTEGER TLOADS   ,EJECT    ,IFRVEC(12),ISHED(7),TR       ,QU
     1,       ONTW(2)  ,ISTYP(2)
C
      DIMENSION NSIL(4), STR(18), NPH1OU(2), SI(36)
C
      COMMON /BLANK / IDUMMY(10), STRAIN
      COMMON   /SYSTEM/  IBFSZ    ,NOUT     ,IDM(9)   ,LINE
      COMMON /ZZZZZZ/ Z(1)
      COMMON /SDR2X4/ DUMMY(35), IVEC, IVECN, LDTEMP, DEFORM,DUM8(8),
     1  TLOADS
      COMMON /SDR2X7/ PH1OUT(200),FORVEC(6)
      COMMON /SDR2X8/ TEMP,DELTA,NPOINT,I,J,NPT1,VEC(5),TEM
     1,            Z1 OVR I, Z2 OVR I,STRESS(3),CHPOUT(30),CVEC(5)
     1,            CFRVEC(12)
      COMMON /SDR2X9/ NCHK,ISUB,ILD,FRTMEI(2),TWOTOP,FNCHK
      COMMON /SDR2DE/ SKP2DE(8),IELTYP
C
      EQUIVALENCE
     1  (NSIL(1),PH1OUT(2))
     2 ,(NPH1OU(1),PH1OUT(1))
     3 ,(SI(1),PH1OUT(9))
     6 ,(STR(1),PH1OUT(101))
     7 ,(LDTEMP,FTEMP)
     8 ,(F1,N1)
     9,  (CFRVEC(1),IFRVEC(1)) ,  (ISHED(6),FRLAST(1))
     *,  (ISHED(1),LSUB) , (ISHED(2),LLD)
      EQUIVALENCE (STR(1), IST(1))
C
      DATA TR,QU,ONTW / 4HTRIA , 4HQUAD , 1H1 , 1H2  / , LLD  / -100 /
      DATA LSUB,FRLAST / -100 , -1.0E30 , -1.0E30   /
      DATA IBLANK /4H    /
C **********************************************************************
C **********************************************************************
C
C     PHASE I OUTPUT FROM THE PLATE IS THE FOLLWOING
C
C     PH1OUT(1)                        ELEMENT ID
C     PH1OUT(2 THRU 5)                 3 SILS AND DUMMY OR 4 SILS
C     PH1OUT(6)                        I
C     PH1OUT(7 THRU 8)                 Z1 AND Z2
C     PH1OUT(9 THRU 30*NPTS+8)         3 OR 4 S SUB I  5X6 ARRAYS
C     PH1OUT(30*NPTS+9 THRU 30*NPTS+11)  S SUB T MATRIX
C
C **********************************************************************
C
C     PHASE I OUTPUT FROM THE MEMBRANE IS THE FOLLOWING
C     NOTE..BEGIN = 30*NPTS+11
C
C     PH1OUT(BEGIN + 1)                ELEMENT ID
C     PH1OUT(BEGIN + 2 THRU BEGIN + 5) 3 SILS AND DUMMY OR 4 SILS
C     PH1OUT(BEGIN + 6)                T SUB 0
C     PH1OUT(BEGIN + 7 THRU BEGIN + 9) S SUB T  3X1 ARRAY
C     PH1OUT(BEGIN + 10 THRU BEGIN + 9*NPTS+9) 3 OR 4 S SUB I 3X3 ARRAYS
C
C **********************************************************************
C **********************************************************************
C
C     THE ABOVE ELEMENTS ARE COMPOSED OF PLATES AND MEMBRANES...
C     SOME MAY ONLY CONTAIN PLATES WHILE OTHERS MAY ONLY CONTAIN
C     MEMBRANES.
C
C     A CHECK FOR A ZERO FIRST SIL IN THE PHASE I OUTPUT, WHICH
C     INDICATES WHETHER ONE OR THE OTHER HAS BEEN OMITTED, IS MADE BELOW
C
C
C
C     FIRST GET FORCE VECTOR FOR THE PLATE CONSIDERATION
C
C     M ,  M ,  M  ,  V ,  V
C      X    Y    XY    X    Y
C
C                                NPTS
C     THE  5X1 FORCE VECTOR = SUMMATION  (S )(U )
C                                I=1       I   I
C
C *********************************************************************
C
C  . ZERO FORVEC AND PRECISION CHECK STORAGE...
C
      DO 5 I = 1,6
      FORVEC(I) = 0.0E0
      CFRVEC(I) = 0.0E0
    5 CFRVEC(I+6) = 0.0E0
      FORVEC(1) = PH1OUT(1)
C
C     ZERO OUT LOCAL STRESSES
C
      SIG X  1 = 0.0E0
      SIG Y  1 = 0.0E0
      SIG XY 1 = 0.0E0
      SIG X  2 = 0.0E0
      SIG Y  2 = 0.0E0
      SIG XY 2 = 0.0E0
C
      IF( NSIL(1) .EQ. 0 ) GO TO 30
C
C     FORM SUMMATION
C
      DO 20 I=1,NPTS
C
C     POINTER TO DISPLACEMENT VECTOR IN VARIABLE CORE
C
      NPOINT = IVEC + NSIL(I) - 1
C
      CALL SMMATS (SI(30*I-29),5,6,0, Z(NPOINT),6,1,0, VEC(1),CVEC(1) )
      DO 10 J=2,6
      CFRVEC(J) = CFRVEC(J) + CVEC(J-1)
   10 FORVEC(J) = FORVEC(J) + VEC(J-1)
C
   20 CONTINUE
      IF (STRAIN) GO TO 220
      IF( TLOADS .EQ. 0 ) GO TO 25
      JST = 30*NPTS+8
      FLAG = .FALSE.
      F1 = TI(6)
      IF( N1 .EQ. 1 ) GO TO 22
      FORVEC(2) = FORVEC(2) - TI(2)
      FORVEC(3) = FORVEC(3) - TI(3)
      FORVEC(4) = FORVEC(4) - TI(4)
      IF( TI(5).EQ.0.0 .AND. TI(6).EQ.0.0 ) FLAG = .TRUE.
      GO TO 25
   22 FORVEC(2) = FORVEC(2) + TI(2)*PH1OUT(JST+1)
      FORVEC(3) = FORVEC(3) + TI(2)*PH1OUT(JST+2)
      FORVEC(4) = FORVEC(4) + TI(2)*PH1OUT(JST+3)
      IF( TI(3).EQ.0.0 .AND. TI(4).EQ.0.0 ) FLAG = .TRUE.
   25 CONTINUE
C
C     FORCE VECTOR IS NOW COMPLETE
C
      Z1 = PH1OUT(7)
      Z2 = PH1OUT(8)
C
      Z1 OVR I = - PH1OUT(7) / PH1OUT(6)
      Z2 OVR I = - PH1OUT(8) / PH1OUT(6)
      Z1I = ABS (Z1OVRI)
      Z2I = ABS (Z2OVRI)
C
      K1 = 0
      ASSIGN 26 TO IRETRN
      GO TO 170
C
   26 SIG X  1 = FORVEC(2) * Z1 OVR I - SDELTA(1)
      SIG Y  1 = FORVEC(3) * Z1 OVR I - SDELTA(2)
      SIG XY 1 = FORVEC(4) * Z1 OVR I - SDELTA(3)
      CFRVEC(7) = CFRVEC(2) * Z1I
      CFRVEC(8) = CFRVEC(3) * Z1I
      CFRVEC(9) = CFRVEC(4) * Z1I
C
      K1 = 1
      ASSIGN 27 TO IRETRN
      GO TO 170
C
   27 SIG X  2 = FORVEC(2) * Z2 OVR I - SDELTA(1)
      SIG Y  2 = FORVEC(3) * Z2 OVR I - SDELTA(2)
      SIG XY 2 = FORVEC(4) * Z2 OVR I - SDELTA(3)
      CFRVEC(10) = CFRVEC(2) * Z2I
      CFRVEC(11) = CFRVEC(3) * Z2I
      CFRVEC(12) = CFRVEC(4) * Z2I
C     *******************************
C
      GO TO 40
   30 Z1 = 0.0E0
      Z2 = 0.0E0
C
C     FIND SIG X, SIG Y, SIG XY, FOR MEMBRANE CONSIDERATION
   40 IF( NPH1OU(30*NPTS+13) .EQ. 0 ) GO TO 90
C
C     ZERO STRESS VECTOR STORAGE
C
      STRESS(1) = 0.0E0
      STRESS(2) = 0.0E0
      STRESS(3) = 0.0E0
      SSTRSS(1) = 0.0E0
      SSTRSS(2) = 0.0E0
      SSTRSS(3) = 0.0E0
C
C                            I=NPTS
C        STRESS VECTOR = (  SUMMATION(S )(U )  ) - (S )(LDTEMP - T )
C                            I=1       I   I         T            0
C
      DO 60 I=1,NPTS
C
C     POINTER TO I-TH SIL IN PH1OUT
      NPOINT = 30*NPTS + 12 + I
C     POINTER TO DISPLACEMENT VECTOR IN VARIABLE CORE
      NPOINT = IVEC + NPH1OU (NPOINT) - 1
C
C     POINTER TO S SUB I 3X3
      NPT1 = 30*NPTS + 12 + 9*I
C
      CALL SMMATS (PH1OUT(NPT1),3,3,0, Z(NPOINT),3,1,0, VEC(1),CVEC(1))
      DO 50 J=1,3
      SSTRSS(J) = SSTRSS(J) + CVEC(J)
   50 STRESS(J) = STRESS(J) + VEC(J)
C
   60 CONTINUE
C
      IF (STRAIN) GO TO 230
      IF(LDTEMP .EQ. (-1) ) GO TO 80
C
C     POINTER TO T SUB 0 = 30*NPTS + 17
C
      TEM = FTEMP - PH1OUT(30*NPTS + 17)
      DO 70 I=1,3
      NPOINT = 30*NPTS + 17 + I
   70 STRESS(I) = STRESS(I) -PH1OUT(NPOINT) *TEM
C
C     ADD MEMBRANE STRESSES TO PLATE STRESSES
C
   80 SIG X  1 = SIG X  1 + STRESS(1)
      SIG Y  1 = SIG Y  1 + STRESS(2)
      SIG XY 1 = SIG XY 1 + STRESS(3)
      SIG X  2 = SIG X  2 + STRESS(1)
      SIG Y  2 = SIG Y  2 + STRESS(2)
      SIG XY 2 = SIG XY 2 + STRESS(3)
      CFRVEC( 7) = CFRVEC( 7) + SSTRSS(1)
      CFRVEC( 8) = CFRVEC( 8) + SSTRSS(2)
      CFRVEC( 9) = CFRVEC( 9) + SSTRSS(3)
      CFRVEC(10) = CFRVEC(10) + SSTRSS(1)
      CFRVEC(11) = CFRVEC(11) + SSTRSS(2)
      CFRVEC(12) = CFRVEC(12) + SSTRSS(3)
C
C     STRESS OUTPUT VECTOR IS THE FOLLOWING
C
C      1) ELEMENT ID
C      2) Z1 = FIBER DISTANCE 1
C      3) SIG X  1
C      4) SIG Y  1
C      5) SIG XY 1
C      6) ANGLE OF ZERO SHEAR AT Z1
C      7) SIG P1 AT Z1
C      8) SIG P2 AT Z1
C      9) TAU MAX = MAXIMUM SHEAR STRESS AT Z1
C
C     10) ELEMENT ID
C     11) Z2 = FIBER DISTANCE 2
C     12) SIG X  2
C     13) SIG Y  2
C     14) SIG XY 2
C     15) ANGLE OF ZERO SHEAR AT Z2
C     16) SIG P1 AT Z2
C     17) SIG P2 AT Z2
C     S7) SIG P2 AT Z2
C     18) TAU MAX = MAXIMUM SHEAR STRESS AT Z2
C
C
   90 IF( NPH1OU(2) .EQ. 0 .AND. NPH1OU(30*NPTS+13) .EQ. 0 ) GO TO 120
C
C     COMPUTE PRINCIPAL STRESSES
C
      STR( 1) = PH1OUT(1)
      STR( 2) = Z1
      STR( 3) = SIG X  1
      STR( 4) = SIG Y  1
      STR( 5) = SIG XY 1
      STR(10) = PH1OUT(1)
      STR(11) = Z2
      STR(12) = SIG X  2
      STR(13) = SIG Y  2
      STR(14) = SIG XY 2
C
      DO 110 I=3,12,9
      TEMP = STR(I) - STR(I+1)
      STR(I+6) = SQRT( (TEMP/2.0E0)**2 + STR(I+2)**2 )
      DELTA = (  STR(I)  +  STR(I+1)  )  /  2.0E0
      STR(I+4) = DELTA + STR(I+6)
      STR(I+5) = DELTA - STR(I+6)
      DELTA = 2.0E0 * STR(I+2)
      IF( ABS(DELTA) .LT. 1.0E-15 .AND. ABS(TEMP) .LT. 1.0E-15)GO TO 100
      STR(I+3) = ATAN2( DELTA,TEMP ) * 28.6478898E0
      GO TO 110
  100 STR(I+3) = 0.0E0
  110 CONTINUE
C
      GO TO 140
  120 DO 130 I=2,18
  130 STR(I) = 0.0E0
  140 STR(1) = PH1OUT(1)
      STR(10) = PH1OUT(1)
C
C
C     ADDITION TO ELIMINATE 2ND ELEMENT ID IN OUTPUT
C
      DO 150 I=10,17
  150 STR(I) = STR(I+1)
      IF (.NOT.STRAIN) GO TO 152
      IST( 2) = IBLANK
      STR( 5) = 2.0*STR(5)
      STR( 9) = 2.0*STR(9)
      IST(10) = IBLANK
      STR(13) = 2.0*STR(13)
      STR(17) = 2.0*STR(17)
  152 CONTINUE
C
C  . STRESS CHECK...
C
      IF (NCHK .LE. 0 ) GO TO 999
      CFRVEC(1) = PH1OUT(1)
      K = 0
C  . FORCES...
      CALL SDRCHK (FORVEC(2),CFRVEC(2),5,K)
C  . STRESSES...
      CALL SDRCHK (STR(3),CFRVEC( 7),3,K)
      CALL SDRCHK (STR(11),CFRVEC(10),3,K)
C
      IF (K.EQ.0) GO TO 999
C
C  . LIMITS EXCEEDED...
      J = 0
      ISTYP(1) = TR
      ISTYP(2) = ONTW(1)
      IF (IELTYP.GT.17) ISTYP(1) = QU
      IF (IABS (IELTYP-17).LT.2) ISTYP(2) = ONTW(2)
C
      IF (LSUB.EQ.ISUB .AND. FRLAST(1).EQ.FRTMEI(1) .AND.
     1    LLD .EQ.ILD  .AND. FRLAST(2).EQ.FRTMEI(2) ) GO TO 156
C
      LSUB = ISUB
      LLD = ILD
      FRLAST(1) = FRTMEI(1)
      FRLAST(2) = FRTMEI(2)
      J = 1
      CALL PAGE1
  154 CALL SD2RHD (ISHED,J)
      LINE = LINE + 1
      WRITE(NOUT,155)
  155 FORMAT (7X,51HTYPE     EID     MX     MY    MXY     VX     VY    ,
     *38HSX1    SY1   SXY1    SX2    SY2   SXY2)
      GO TO 157
C
  156 IF (EJECT(2).NE.0) GO TO 154
C
  157 WRITE(NOUT,158) ISTYP,IFRVEC(1),(CFRVEC(II),II=2,12)
  158 FORMAT (1H0,5X,A4,A2,I7,11F7.1)
C
      GO TO 999
C
C     INTERNAL SUBROUTINE
C
  170 IF( TLOADS.EQ.0 .OR. FLAG ) GO TO 200
      JST = 30*NPTS + 8
      IF( N1 .EQ. 1 ) GO TO 190
      FF = TI(K1+5) - TI(1)
      SDELTA(1) = (PH1OUT(JST+1)*FF + TI(2)*PH1OUT(K1+7)) / PH1OUT(6)
      SDELTA(2) = (PH1OUT(JST+2)*FF + TI(3)*PH1OUT(K1+7)) / PH1OUT(6)
      SDELTA(3) = (PH1OUT(JST+3)*FF + TI(4)*PH1OUT(K1+7)) / PH1OUT(6)
      GO TO 210
  190 FF = (TI(K1+3) - PH1OUT(K1+7)*TI(2) - TI(1))/PH1OUT(6)
      SDELTA(1) = PH1OUT(JST+1)*FF
      SDELTA(2) = PH1OUT(JST+2)*FF
      SDELTA(3) = PH1OUT(JST+3)*FF
      GO TO 210
  200 SDELTA(1) = 0.0
      SDELTA(2) = 0.0
      SDELTA(3) = 0.0
  210 GO TO IRETRN,(26,27)
C
C     SPECIAL CALCULATIONS FOR STRAINS.
C
  220 SIGX2 = FORVEC(2)
      SIGY2 = FORVEC(3)
      SIGXY2= FORVEC(4)
      GO TO 40
C
  230 SIGX1 = STRESS(1)
      SIGY1 = STRESS(2)
      SIGXY1= STRESS(3)
      GO TO 90
  999 RETURN
      END

      SUBROUTINE PLA2
C*****
C THIS ROUTINE IS THE SECOND FUNCTIONAL MODULE UNIQUE TO THE PIECE-WISE
C LINEAR ANALYSIS (PLA) RIGID FORMAT FOR THE DISPLACEMENT APPROACH.
C
C DMAP CALL...
C
C PLA2   DELTAUGV,DELTAPG,DELTAQG/UGV1,PGV1,QG1/V,N,PLACOUNT/ $
C
C CONCERNING DELTAUGV AND UGV1, THE ROUTINE WORKS AS FOLLOWS...
C DELTAUGV IS THE CURRENT INCREMENTAL DISPLACEMENT VECTOR IN THE PLA
C RIGID FORMAT LOOP AND UGV1 IS AN APPENDED FILE OF DISPLACEMENT VECTORS
C IF PLACOUNT .EQ. 1, THAT IS, THIS IS THE FIRST TIME PLA2 HAS BEEN
C CALLED IN THE PLA LOOP, THEN DELTAUGV IS COPIED ONTO UGV1.  IF
C PLACOUNT .GT. 1, THE PREVIOUS, OR LAST, DISPLACEMENT VECTOR IS READ
C INTO CORE FROM THE UGV1 DATA BLOCK, AND THE UGV1 FILE IS CLOSED WITH-
C OUT REWIND, THEN OPENED WITHOUT REWIND TO WRITE.  THE DELTAUGV VECTOR
C IS READ AN ELEMENT AT A TIME USING SUBROUTINE ZNTPKI AND ADDED TO
C THE VECTOR IN CORE.  THEN THE NEW DISPLACEMENT VECTOR IS WRITTEN ONTO
C THE UGV1 FILE.
C
C THEN THE PLA DMAP LOOP COUNTER PLACOUNT IS INCREMENTED.
C
C DELTAPG IS THE CURRENT INCREMENTAL LOAD VECTOR AND PGV1 IS THE
C CORRESPONDING MATRIX OF RUNNING SUM LOAD VECTORS.  PROCESSING IS
C SIMILAR TO THE ABOVE.  NOTE THAT NEITHER DATA BLOCK, LIKE THE TWO
C DISCUSSED ABOVE, CAN BE PURGED.
C
C DELTAQG IS THE CURRENT INCREMENTAL VECTOR OF SINGLE POINT CONSTRAINT
C FORCES AND QG1 IS THE APPENDED FILE OF VECTORS OF SPCF.  THESE TWO
C DATA BLOCKS ARE PROCESSED IDENTICALLY TO DELTAUGV AND UGV1 EXCECT
C THAT NO FATAL ERROR EXISTS IF ONE OR THE OTHER HAS BEEN PURGED.
C*****
C
      INTEGER
     1                   BUFSZ
     2,                  BUFFR1             ,BUFFR2
     3,                  OFILE              ,PLACNT
     4,                  EOR                ,CLSRW
     5,                  CLSNRW             ,OUTRW
     6,                  EOL                ,TYPEA
     7,                  TYPEB              ,OUTNRW
      INTEGER INBLK(15),OUBLK(15)
C
      DIMENSION
     1                   NAME(2)            ,DUMMY(2)
     2,                  MCB(7)
      COMMON /BLANK/PLACNT
      COMMON   /SYSTEM/  BUFSZ
      COMMON   /ZZZZZZ /  Z(1)
      COMMON   /ZNTPKX/
     1                   A(4)               ,INDEX
     2,                  EOL                ,IDUMMY
      COMMON   /PACKX /
     1                   TYPEA              ,TYPEB
     2,                  IPACK              ,JPACK
     3,                  INCPK
      COMMON   /UNPAKX/
     1                   IUNPKB             ,IUNPK
     2,                  JUNPK              ,INCUPK
C
      DATA               NAME /4HPLA2,4H    /
      DATA               INRW,OUTRW,OUTNRW,CLSRW,CLSNRW,EOR/0,1,3,1,2,1/
C
C INITIALIZE
C
      IZMAX = KORSZ (Z)
      BUFFR1 = IZMAX - BUFSZ
      BUFFR2 = BUFFR1 - BUFSZ
      LEFT = BUFFR2 - 1
      ILOOP = 1
      IFILE = 101
      OFILE = 201
C
C OPEN INPUT FILE TO READ AND OUTPUT FILE TO WRITE (IF PLACNT .EQ. 1)
C OR TO READ (IF PLACNT .GT. 1)
C
   10 JFILE = IFILE
      INBLK(1) = IFILE
      OUBLK(1) = OFILE
      DO 15 I = 2,7
   15 MCB(I) = 0
      MCB(1) = OFILE
      IF (PLACNT .EQ. 1) MCB(1) = IFILE
      CALL RDTRL (MCB)
      CALL OPEN(*100,IFILE,Z(BUFFR1),INRW)
      CALL FWDREC(*9020,IFILE)
      IOPT = INRW
      IF (PLACNT .EQ. 1) IOPT = OUTRW
      CALL OPEN(*110,OFILE,Z(BUFFR2),IOPT)
      IF (PLACNT .NE. 1) GO TO 30
C
C THIS IS THE FIRST TIME THROUGH THE PLA LOOP.  COPY THE VECTOR ON THE
C INPUT FILE ONTO THE OUTPUT FILE.
C
      CALL FNAME (OFILE,DUMMY)
      CALL WRITE (OFILE,DUMMY,2,EOR)
      CALL CPYSTR(INBLK,OUBLK,0,0)
      CALL CLOSE (OFILE,CLSRW)
      CALL CLOSE(IFILE,CLSRW)
      GO TO 70
C
C THIS IS NOT THE FIRST PASS
C
   30 JFILE = OFILE
      CALL FWDREC(*9020,OFILE)
      NRECS = PLACNT - 2
      IF (NRECS .LE. 0) GO TO 50
      DO 40 I = 1,NRECS
   40 CALL FWDREC(*9020,OFILE)
   50 MCB(1) = OFILE
      CALL RDTRL (MCB)
      MCB(6) = 0
      MCB(7) = 0
      IF (LEFT .LT. MCB(3)) CALL MESAGE (-8,0,NAME)
      IUNPKB = 1
      IUNPK  = 1
      JUNPK  = MCB(3)
      INCUPK = 1
      CALL UNPACK(*9030,OFILE,Z)
      CALL CLOSE (OFILE,CLSNRW)
      CALL OPEN(*9010,OFILE,Z(BUFFR2),OUTNRW)
C
C READ THE INCREMENTAL VECTOR.  INTPK INITIALIZES AND ZNTPKI RETURNS
C ONE ELEMENT AT A TIME
C
      KTYPE = 1
      CALL INTPK(*9040,IFILE,0,KTYPE,0)
C
C READ AND ADD LOOP.
C
   60 CALL ZNTPKI
      Z(INDEX) = Z(INDEX) + A(1)
      IF (EOL .EQ. 0) GO TO 60
C
C ADDITION HAS BEEN COMPLETED
C
      CALL CLOSE (IFILE,CLSRW)
C
C WRITE VECTOR ON OUTPUT FILE IN PACKED FORMAT.
C
      TYPEA = 1
      TYPEB = 1
      IPACK = 1
      JPACK = MCB(3)
      INCPK = 1
      CALL PACK(Z,OFILE,MCB)
      CALL CLOSE (OFILE,CLSRW)
C
C WRITE TRAILER
C
   70 MCB(1) = OFILE
      CALL WRTTRL (MCB)
   90 ILOOP = ILOOP + 1
      IF (ILOOP .GT. 3) GO TO 200
      IFILE = IFILE + 1
      OFILE = OFILE + 1
      GO TO 10
  100 IF (ILOOP .EQ. 1  .OR.  ILOOP .EQ. 2) CALL MESAGE (-30,127,IFILE)
      GO TO 90
  110 IF (ILOOP .EQ. 1  .OR.  ILOOP .EQ. 2) CALL MESAGE (-30,128,OFILE)
      GO TO 90
C
C INCREMENT THE PLA DMAP LOOP COUNTER
C
  200 PLACNT = PLACNT + 1
      RETURN
C
C FATAL ERRORS
C
 9010 CALL MESAGE (-1,JFILE,NAME)
 9020 CALL MESAGE (-2,JFILE,NAME)
 9030 CALL MESAGE (-30,129,ILOOP+200)
 9040 CALL MESAGE (-30,130,ILOOP+100)
      RETURN
      END

      SUBROUTINE IS2D8D
C
C     2-D, 8 GRID POINT ISOPARAMETRIC STRUCTURAL  ELEMENT STIFFNESS,
C     MASS, CONDUCTIVITY, AND CAPACITANCE ROUTINE
C
C     DOUBLE PRECISION VERSION
C
      LOGICAL         ERROR,    HEAT
      INTEGER         GE,       DICT(13), IND6(36), ISIL(8),  NAM(2)
      INTEGER         SCR4,     BCD(2)
      REAL            KX,       KY,       KXY
      DIMENSION       VEC(3),   VVEC(3),  VECI(3),  VECJ(3),  VECK(3),
     1                XY1(3),   XY2(3),   IZ(1),    ECPT(46), QQ(15),
     2                IWS(2,3)
      DOUBLE PRECISION          G(9),     XI(8),    ETA(8),   TB(9),
     1                B(12),    BT(12),   TEMP(9),  TEMPAR(7),DNX(1),
     2                DNY(1),   DNXI(1),  DNETA(1), SAVE(144),TSAVE(216)
     3,               E1T(6),   TEMP1(9), TEMP2(9), TEMP3(9), PSTMUL(9),
     4                PREMUL(6),DN(8),    XX(16),   DNC(16),  DNL(16),
     5                XJB(4),   XXJB(2,2),PT(3),    H(3),     BIJ,
     6                KIJ,      MIJ,      DETERM,   DUMARG,   DRHO,
     7                DC,       DHH,      TERM,     THICK,    SAVM(36),
     8                Z
      COMMON /BLANK / SKIP(16), VOLUME,   SURFAC
      COMMON /EMGEST/ NECPT(1), NGRID(8), ID1,      TH,       MATID1,
     1                T,        ISYS1,    X1,       Y1,       Z1,
     2                ISYS2,    X2,       Y2,       Z2,       ISYS3,
     3                X3,       Y3,       Z3,       ISYS4,    X4,
     4                Y4,       Z4,       ISYS5,    X5,       Y5,
     5                Z5,       ISYS6,    X6,       Y6,       Z6,
     6                ISYS7,    X7,       Y7,       Z7,       ISYS8,
     7                X8,       Y8,       Z8,       TTEMP,    DUMB(119)
      COMMON /MATIN / MATID,    INFLAG,   ELTEMP,   STRESS,   SINTH,
     1                COSTH
      COMMON/MATOUT / G11,      G12,      G13,      G22,      G23,
     1                G33,      RHO,      ALPHA1,   ALPHA2,   ALPH12,
     2                TREF,     GE,       DUM3(3)
      COMMON /HMTOUT/ KX,       KXY,      KY,       C
      COMMON /EMGDIC/ DUM2(2),  NLOCS,    ELID,     IESTID
      COMMON /ZZZZZZ/ Z(1)
      COMMON /EMGPRM/ IDUM,     JCORE,    NCORE,    DUM12(12),KMBGG(3),
     1                IPREC,    ERROR,    HEAT,     COUP
      EQUIVALENCE     (ECPT(1),NECPT(1)), (Z(1),IZ(1)), (TEMP(1),B(1)),
     1                (DNC(1),DNXI(1))  , (DNC(9),DNETA(1)),
     2                (DNL(1),DNX(1))   , (DNL(9),DNY(1)), (QQ(1),G11),
     3                (TEMPAR(1),BT(1)) , (XY1(1),X1)    , (XY2(1),X2),
     4                (ISIL(1),NGRID(1))
      DATA    XI    / -1.D0, 1.D0, 1.D0,-1.D0, 0.D0, 1.D0, 0.D0,-1.D0/
      DATA    ETA   / -1.D0,-1.D0, 1.D0, 1.D0,-1.D0, 0.D0, 1.D0, 0.D0/
      DATA    IND6  / 1,7,49,13,55,91,19,61,97,127,25,67,103,133,157,31,
     1                73,109,139,163,181,37,79,115,145,169,187,199,43,
     2                85,121,151,175,193,205,211/
      DATA    NAM   , BCD/ 4HIS2D,4H8D  , 4HCIS2,4HD8   /
      DATA    SCR4  / 304 /
C
C     ECPT LIST
C                                      IN
C                                      THIS
C     ECPT       DESCRIPTION           ROUTINE        TYPE
C     ******************************************************************
C     ECPT( 1) = ELEMENT ID            NECPT(1)       INTEGER
C     ECPT( 2) = GRID POINT 1          NGRID(1)       INTEGER
C     ECPT( 3) = GRID POINT 2          NGRID(2)       INTEGER
C     ECPT( 4) = GRID POINT 3          NGRID(3)       INTEGER
C     ECPT( 5) = GRID POINT 4          NGRID(4)       INTEGER
C     ECPT( 6) = GRID POINT 5          NGRID(5)       INTEGER
C     ECPT( 7) = GRID POINT 6          NGRID(6)       INTEGER
C     ECPT( 8) = GRID POINT 7          NGRID(7)       INTEGER
C     ECPT( 9) = GRID POINT 8          NGRID(8)       INTEGER
C     ECPT(10) = NO. OF GAUSS POINTS   ID1            INTEGER
C     ECPT(11) = ANIS. MATERIAL ANGLE  TH             REAL
C     ECPT(12) = MATERIAL ID           MATID1         INTEGER
C     ECPT(13) = THICKNESS             T              REAL
C     ECPT(14) = COORD SYS ID 1        ISYS1          INTEGER
C     ECPT(15) = X1                    X1             REAL
C     ECPT(16) = Y1                    Y1             REAL
C     ECPT(17) = Z1                    Z1             REAL
C     ECPT(18) = COORD SYS ID 2        ISYS2          INTEGER
C     ECPT(19) = X2                    X2             REAL
C     ECPT(20) = Y2                    Y2             REAL
C     ECPT(21) = Z2                    Z2             REAL
C     ECPT(22) = COORD SYS ID 3        ISYS3          INTEGER
C     ECPT(23) = X3                    X3             REAL
C     ECPT(24) = Y3                    Y3             REAL
C     ECPT(25) = Z3                    Z3             REAL
C     ECPT(26) = COORD SYS ID 4        ISYS4          INTEGER
C     ECPT(27) = X4                    X4             REAL
C     ECPT(28) = Y4                    Y4             REAL
C     ECPT(29) = Z4                    Z4             REAL
C     ECPT(30) = COORD SYS ID 5        ISYS5          INTEGER
C     ECPT(31) = X5                    X5             REAL
C     ECPT(32) = Y5                    Y5             REAL
C     ECPT(33) = Z5                    Z5             REAL
C     ECPT(34) = COORD SYS ID 6        ISYS6          INTEGER
C     ECPT(35) = X6                    XL             REAL
C     ECPT(36) = Y6                    Y6             REAL
C     ECPT(37) = Z6                    Z6             REAL
C     ECPT(38) = COORD SYS ID 7        ISYS7          INTEGER
C     ECPT(39) = X7                    X7             REAL
C     ECPT(40) = Y7                    Y7             REAL
C     ECPT(41) = Z7                    Z7             REAL
C     ECPT(42) = COORD SYS ID 8        ISYS8          INTEGER
C     ECPT(43) = X8                    X8             REAL
C     ECPT(44) = Y8                    Y8             REAL
C     ECPT(45) = Z8                    Z8             REAL
C     ECPT(46) = ELEMENT TEMP          TTEMP          REAL
C
      IF (JCORE+576 .GT. NCORE) CALL MESAGE (-8,0,NAM)
      DICT(1) = IESTID
      DICT(2) = 1
      IF (HEAT) GO TO 1
      DICT(3) = 24
      DICT(4) = 7
      NSQ     = 576
      GO TO 2
    1 DICT(3) = 8
      DICT(4) = 1
      NSQ     = 64
C
C     SAVE NGRID IN DUMB
C
    2 DO 3 I = 1,9
    3 DUMB(I) = ECPT(I)
      AREA = 0.0
C
C     SET UP SIL ARRAY SO THAT MATRICES ARE SET UP IN INCREASING SIL
C     ORDER SIL(I)=PARTITION NUMBER OF ITH GRID POINT
C
      I =-8
    5 J = 0
      DO 6 K = 1,8
      IF (ISIL(K) .LT. J) GO TO 6
      J = ISIL(K)
      L = K
    6 CONTINUE
      ISIL(L) = I
      I = I + 1
      IF (I .LT. 0) GO TO 5
      DO 7 I = 1,8
    7 ISIL(I) =-ISIL(I)
C
      DO 10 I = 1,NSQ
   10 Z(JCORE+I) = 0.0D0
C
C     UNIT I VECTOR IS FROM GRID POINT 1 TO GRID POINT 2
C
      DO 20 I = 1,3
      VECI(I) = XY2(I)-XY1(I)
   20 CONTINUE
      VECIL = SQRT(VECI(1)**2 + VECI(2)**2 + VECI(3)**2)
      IF (VECIL .EQ. 0.0) GO TO 40
      VECI(1) = VECI(1)/VECIL
      VECI(2) = VECI(2)/VECIL
      VECI(3) = VECI(3)/VECIL
C
C     K VECTOR IS OBTAINED BY CROSSING I INTO VECTOR FROM GRID PT. 1 TO
C     GRID
C
      VECK(1) = VECI(2)*(Z4-Z1) - VECI(3)*(Y4-Y1)
      VECK(2) = VECI(3)*(X4-X1) - VECI(1)*(Z4-Z1)
      VECK(3) = VECI(1)*(Y4-Y1) - VECI(2)*(X4-X1)
      VECKL   = SQRT(VECK(1)**2 + VECK(2)**2 + VECK(3)**2)
      IF (VECKL .EQ. 0.0) GO TO 40
      VECK(1) = VECK(1)/VECKL
      VECK(2) = VECK(2)/VECKL
      VECK(3) = VECK(3)/VECKL
C
C     J VECTOR IS OBTAINED BY CROSSING K INTO I
C
      VECJ(1) = VECK(2)*VECI(3) - VECK(3)*VECI(2)
      VECJ(2) = VECK(3)*VECI(1) - VECK(1)*VECI(3)
      VECJ(3) = VECK(1)*VECI(2) - VECK(2)*VECI(1)
C
      E1T(1)  = VECI(1)
      E1T(2)  = VECI(2)
      E1T(3)  = VECI(3)
      E1T(4)  = VECJ(1)
      E1T(5)  = VECJ(2)
      E1T(6)  = VECJ(3)
C
C     STORE ELEMENT COORDS FOR GRIDS 1 AND 2
C
      XX(1) = 0.D0
      XX(2) = 0.D0
      XX(3) = VECIL
      XX(4) = 0.D0
C
C     FOR GRIDS 3-8, THE X COORDINATE IS THE DOT PRODUCT OF HTE VECTOR
C     FROM GRID POINT 1 TO THE GRID POINT AND THE I VECTOR. THE Y COORD.
C     IS THE L OF THE I VECTOR CROSSED INTO THE VECTOR FROM GRID 1 TO
C     THE GRID POINT.
C
      DO 30 I = 3,8
      IXX  = 2*I - 1
      ISUB = 4*I + 11
      VEC(1)  = ECPT(ISUB  ) - X1
      VEC(2)  = ECPT(ISUB+1) - Y1
      VEC(3)  = ECPT(ISUB+2) - Z1
      XX(IXX) = VEC(1)*VECI(1) + VEC(2)*VECI(2) + VEC(3)*VECI(3)
      VVEC(1) = VECI(2)*VEC(3) - VECI(3)*VEC(2)
      VVEC(2) = VECI(3)*VEC(1) - VECI(1)*VEC(3)
      VVEC(3) = VECI(1)*VEC(2) - VECI(2)*VEC(1)
      XX(IXX+1) = SQRT(VVEC(1)**2 + VVEC(2)**2 + VVEC(3)**2)
   30 CONTINUE
      GO TO 150
C
C     INAPPROPRIATE GEOMETRY
C
   40 CALL MESAGE (30,31,ECPT(1))
      ERROR = .TRUE.
C
  150 IF (ERROR) RETURN
C
C     SET UP QUADRATURE POINTS AND WEIGHTS
C
      PT(1) =-0.57735027D0
      PT(2) =-PT(1)
      H(1)  = 1.D0
      H(2)  = 1.D0
      IF (ID1 .EQ. 2) GO TO 155
      PT(1) =-0.77459667D0
      PT(2) = 0.D0
      PT(3) =-PT(1)
      H(1)  = 5.D0/9.D0
      H(2)  = 8.D0/9.D0
      H(3)  = H(1)
C
  155 IF (HEAT) GO TO 700
C
C     COMPUTE MATERIAL PROPERTIES
C
      TTH   = TH*3.1415927/180.
      SINTH = SIN(TTH)
      COSTH = COS(TTH)
      ELTEMP= TTEMP
      INFLAG= 2
      MATID = MATID1
      CALL MAT (ECPT(1))
      DO 160 I = 1,3
  160 G(I)  = QQ(I)
      G(4)  = QQ(2)
      G(5)  = QQ(4)
      G(6)  = QQ(5)
      G(7)  = QQ(3)
      G(8)  = QQ(5)
      G(9)  = QQ(6)
      THICK = T
      DRHO  = RHO*T
C
C     ZERO THE SAVE MATRICES TO COLLECT INTEGRATIONS
C
      DO 210 I = 1,36
  210 SAVM(I) = 0.D0
      DO 220 I = 1,144
  220 SAVE(I) = 0.D0
C
C     2 OR 3 QUADRATURE POINTS
C
      DO 300 III = 1,ID1
      DO 300 JJJ = 1,ID1
C
C     COMPUTE DERIVATIVES WITH RESPECT TO XI AND ETA
C     EACH GRID POINT
C
      DO 230 N = 1,4
      IF (KMBGG(2) .NE. 0) DN(N) = .25D0*(1.D0+PT(III)*XI(N))*
     1   (1.D0+PT(JJJ)*ETA(N))*(PT(III)*XI(N)+PT(JJJ)*ETA(N)-1.D0)
      DNXI(N)  = .25D0*XI(N)*(1.D0+PT(JJJ)*ETA(N))*
     1           (2.D0*PT(III)*XI(N)+PT(JJJ)*ETA(N))
      DNETA(N) = .25D0*ETA(N)*(1.D0+PT(III)*XI(N))*
     1           (PT(III)*XI(N)+2.D0*PT(JJJ)*ETA(N))
  230 CONTINUE
C
      DO 231 N = 5,7,2
      IF (KMBGG(2) .NE. 0) DN(N) = .5D0*(1.D0-PT(III)*PT(III))*
     1   (1.D0+PT(JJJ)*ETA(N))
      DNXI(N)  = -PT(III)*(1.D0+PT(JJJ)*ETA(N))
      DNETA(N) = .5D0*(1.D0-PT(III)*PT(III))*ETA(N)
  231 CONTINUE
C
      DO 232 N = 6,8,2
      IF (KMBGG(2) .NE. 0) DN(N) = .5D0*(1.D0+PT(III)*XI(N))*
     1   (1.D0-PT(JJJ)*PT(JJJ))
      DNXI(N)  = .5D0*XI(N)*(1.D0-PT(JJJ)*PT(JJJ))
      DNETA(N) =-PT(JJJ)*(1.D0+PT(III)*XI(N))
  232 CONTINUE
C
C     COMPUTE JACOBEAN
C
C           N1XI   N2XI   N3XI   N4XI   N5XI   N6XI   N7XI   N8XI
C     DNC = N1ETA  N2ETA  N3ETA  N4ETA  N5ETA  N6ETA  N7ETA  N8ETA
C
C          X1  Y1
C          X2  Y2
C          X3  Y3
C     XX = X4  Y4
C          X5  Y5
C          X6  Y6
C          X7  Y7
C          X8  Y8
C
      CALL GMMATD (DNC,2,8,0,XX,8,2,0,XJB)
C
C     XJB IS ROW-STORED-IT MUST BE COLUMN-STORED AND DOUBLY DIMENSIONED
C     FOR INVERSION
C
      K = 0
      DO 240 I = 1,2
      DO 240 J = 1,2
      K = K + 1
  240 XXJB(I,J) = XJB(K)
C
C     COMPUTE INVERSE AND DETERMINANT OF JACOBEAN
C
      CALL INVERD (2,XXJB,2,DUMARG,0,DETERM,ISING,IWS)
      IF (ISING .NE. 2) GO TO 241
      CALL MESAGE (30,143,ECPT(1))
      ERROR =.TRUE.
      RETURN
C
  241 CONTINUE
      DHH  = DETERM*H(III)*H(JJJ)
      AREA = AREA + DHH
C
C     COMPUTE DERIVATIVES WITH RESPECT TO X AND Y
C
      K = 0
      DO 250 I = 1,2
      DO 250 J = 1,2
      K = K + 1
  250 XJB(K) = XXJB(I,J)
      CALL GMMATD (XJB,2,2,0,DNC,2,8,0,DNL)
C
C           N1X N2X N3X N4X N5X N6X N7X N8X
C     DNL = N1Y N2Y N3Y N4Y N5Y N6Y N7Y N8Y
C
C     SET UP THE BT MATRIX
C
      IC = 0
      DO 290 KK = 1,8
      IF (KMBGG(1) .EQ. 0) GO TO 256
C
      DO 255 I = 1,12
  255 BT(I) = 0.D0
      BT(1) = DNX(KK)
      BT(3) = DNY(KK)
      BT(5) = DNY(KK)
      BT(6) = DNX(KK)
C
      CALL GMMATD (TEMPAR(1),2,3,0,G,3,3,0,TEMPAR(7))
C
C     MULTIPLY G MATRIX BY PRESENT RESULTS
C
C     LOOP FOR THE 8 6X6 PARTITIONS CORRESPONDING TO THE PRESENT
C     PIVOT POINT
C
  256 CONTINUE
      DO 290 N = KK,8
      IC = IC + 1
      IF (KMBGG(1) .EQ. 0) GO TO 281
C
C     SET UP THE B MATRIX
C
      DO 260 I = 1,12
  260 B( I) = 0.D0
      B( 1) = DNX(N)
      B( 4) = DNY(N)
      B( 5) = DNY(N)
      B( 6) = DNX(N)
C                                    T
C     PERFORM MULTIPLICATION TO GET B *D*B
C
      CALL GMMATD (TEMPAR(7),2,3,0,B,3,2,0,TEMPAR(1))
C
C     THROW IN JACOBEAN DETERMINANT AND WEIGHT FACTORS
C
      DO 270 I = 1,4
      TEMPAR(I) = TEMPAR(I)*DHH
  270 CONTINUE
C
C     ADD THE RESULTS OF THIS INTEGRATION TO THE PREVIOUS RESULTS
C
      LL = 4*(IC-1)
      DO 280 I = 1,4
      L = LL + I
      SAVE(L) = SAVE(L) + TEMPAR(I)
  280 CONTINUE
  281 CONTINUE
C
      IF (KMBGG(2) .EQ. 0) GO TO 289
C
      MIJ = DN(KK)*DN(N)*DHH
      SAVM(IC) = SAVM(IC) + MIJ
  289 CONTINUE
C
C     LOOP FOR MORE PARTITIONS
C
  290 CONTINUE
C
C     LOOP FOR MORE GAUSS POINTS
C
  300 CONTINUE
      IF (KMBGG(2) .EQ. 0) GO TO 306
      DO 305 I = 1,36
  305 SAVM(I) = SAVM(I)*DRHO
  306 CONTINUE
C
C     CHECK ON NECESSITY OF PRE-MULTIPLYING COORDINATE TRANSFORMATIONS
C
      IF (KMBGG(1) .EQ. 0) GO TO 500
      IC = 0
      DO 385 KK = 1,8
      ISUB = 4*KK + 10
      IF (NECPT(ISUB) .EQ. 0) GO TO 310
C
C     ELEMENT TO GLOBAL
C
      CALL TRANSD (NECPT(ISUB),TB)
      CALL GMMATD (E1T,2,3,0,TB,3,3,0,PREMUL)
      GO TO 350
  310 DO 320 I = 1,6
      PREMUL(I) = E1T(I)
  320 CONTINUE
  350 DO 380 N = KK,8
      IC = IC + 1
      LL = 4*IC - 3
      CALL GMMATD (PREMUL,2,3,1,SAVE(LL),2,2,0,TEMP)
C
C     STORE THE 3 X 2 IN TSAVE
C
      DO 370 I = 1,6
      L = 6*IC + I - 6
  370 TSAVE(L) = TEMP(I)
C
  380 CONTINUE
  385 CONTINUE
C
C     NOW CHECK ON THE NECESSITY FOR POST-MULTIPLYING TRANSFORMATIONS
C
      IC = 0
      DO 490 N = 1,8
      ISUB = 4*N + 10
      IF (NECPT(ISUB) .EQ. 0) GO TO 410
C
C     GLOBAL TO ELEMENT
C
      CALL TRANSD (NECPT(ISUB),TB)
      CALL GMMATD (E1T,2,3,0,TB,3,3,0,PSTMUL)
      GO TO 450
  410 DO 420 I = 1,6
      PSTMUL(I) = E1T(I)
  420 CONTINUE
C
C     POST-MULTIPLY
C
C     IND6 GIVES STARTING POSITIONS OF VERTICAL 3X3 PARTITIONS, SINCE
C     THE NTH COLUMN MULTIPLIES INTO THE NTH POST-MULTIPLIER
C
  450 DO 485 M = 1,N
      IC = IC + 1
      LL = IND6(IC)
      CALL GMMATD (TSAVE(LL),3,2,0,PSTMUL,2,3,0,TEMP)
      DO 486 I =  1,9
  486 TEMP(I) = TEMP(I)*THICK
C
C     PICK UP ROW AND COLUMN PARTITION NUMBERS AND CONVERT TO STARTING
C     POINTS IN OPEN CORE FOR THIS PARTITION  AND ITS TRANSPOSE.
C     TEMP IS PUT INTO ONE PARTITION AND TEMP-TRANSPOSE INTO THE OTHER
C
      NCOL = ISIL(N)
      NROW = ISIL(M)
      CALL INSERT (NCOL,NROW,3,8,JCORE,Z,Z,TEMP,TEMP,IPREC)
C
C     LOOP FOR ANOTHER PARTITION FOR THIS POST-MULTIPLIER
C
  485 CONTINUE
C
C     LOOP FOR ANOTHER POST-MULTIPLIER
C
  490 CONTINUE
C
C     ADD TO DICTIONARY
C
      DICT(5) = GE
      CALL EMGOUT (Z(JCORE),Z(JCORE),NSQ,1,DICT,1,IPREC)
C
  500 IF (KMBGG(2) .EQ. 0) GO TO 1000
C
      IC = 0
      DO 620 KK = 1,8
      DO 620 N = KK,8
      IC = IC + 1
      DO 510 I = 1,9
  510 TEMP(I) = 0.D0
C
C     CHECK ON TEH NECESSITY OF COORDINATE TRANSFORMATIONS.
C     SINCE EACH PARTITION IS A MULTIPLE OF A 3X3 IDENTITY AND SINCE
C     THE TRANSFORAMATION MATRICES ARE ORTHOGONAL, NO EXPLICIT
C     TRANSFORMA-TIONS FROM THE ELEMENT COORDINATE SYSTEM ARE REQUIRED.
C     ALSO, NO TRANSFORAMTION IS REQUIRED IF TRANSFORMATION MATRICES ARE
C     THE SAME FOR THE GRIDS CORRESPONDING TO THE THE ROW AND COLUMN
C
      TERM  = SAVM(IC)
      IF (KK .EQ. N) GO TO 570
      ISUB  = 4*KK + 10
      ISUB1 =4*N + 10
      IF (NECPT(ISUB).EQ.0 .AND. NECPT(ISUB1).EQ.0) GO TO 570
      IF (NECPT(ISUB) .EQ. 0) GO TO 520
      CALL TRANSD (NECPT(ISUB),TEMP1)
      IF (NECPT(ISUB1) .EQ. 0) GO TO 530
  520 CALL TRANSD (NECPT(ISUB1),TEMP2)
      IF (NECPT(ISUB) .EQ. 0) GO TO 550
C
C     MULTIPLY THE TRANSFORMATION MATRICES
C
      CALL GMMATD (TEMP1,3,3,1,TEMP2,3,3,0,TEMP3)
      GO TO 580
  530 TEMP3(1) = TEMP1(1)
      TEMP3(2) = TEMP1(4)
      TEMP3(3) = TEMP1(7)
      TEMP3(4) = TEMP1(2)
      TEMP3(5) = TEMP1(5)
      TEMP3(6) = TEMP1(8)
      TEMP3(7) = TEMP1(3)
      TEMP3(8) = TEMP1(6)
      TEMP3(9) = TEMP1(9)
      GO TO 580
  550 DO 560 I = 1,9
  560 TEMP3(I) = TEMP2(I)
      GO TO 580
  570 TEMP(1) = TERM
      TEMP(5) = TERM
      TEMP(9) = TERM
      GO TO 600
C
  580 DO 590 I = 1,9
  590 TEMP(I) = TERM*TEMP3(I)
C
  600 NROW = ISIL(KK)
      NCOL = ISIL(N)
      CALL INSERT (NCOL,NROW,3,8,JCORE,Z,Z,TEMP,TEMP,IPREC)
  620 CONTINUE
C
      CALL EMGOUT (Z(JCORE),Z(JCORE),NSQ,1,DICT,2,IPREC)
      GO TO 1000
C
C     HEAT FORMULATION
C
C     COMPUTE MATERIAL PROPERTIES
C
  700 SINTH  = 0.
      COSTH  = 0.
      ELTEMP = TTEMP
      INFLAG = 2
      MATID  = MATID1
      CALL HMAT (ECPT(1))
      THICK  = T
      DC     = C*T
C
C     ZERO OUT THE SAVE MATRIX
C
      DO 720 I = 1,36
      SAVM(I) = 0.D0
  720 SAVE(I) = 0.D0
C
      DO 880 III = 1,ID1
      DO 880 JJJ = 1,ID1
C
C     COMPUTE DERIVATIVES WITH RESPECT TO XI AND ETA
C     EACH GRID POINT
C
      DO 730 N = 1,4
      IF (KMBGG(3) .NE. 0) DN(N) = .25D0*(1.D0+PT(III)*XI(N))*
     1   (1.D0+PT(JJJ)*ETA(N))*(PT(III)*XI(N)+PT(JJJ)*ETA(N)-1.D0)
      DNXI(N)  = .25D0*XI(N)*(1.D0+PT(JJJ)*ETA(N))*
     1           (2.D0*PT(III)*XI(N)+PT(JJJ)*ETA(N))
      DNETA(N) = .25D0*ETA(N)*(1.D0+PT(III)*XI(N))*
     1           (PT(III)*XI(N)+2.D0*PT(JJJ)*ETA(N))
  730 CONTINUE
C
      DO 731 N = 5,7,2
      IF (KMBGG(3) .NE. 0) DN(N) = .5D0*(1.D0-PT(III)*PT(III))*
     1   (1.D0+PT(JJJ)*ETA(N))
      DNXI(N)  = -PT(III)*(1.D0+PT(JJJ)*ETA(N))
      DNETA(N) = .5D0*(1.D0-PT(III)*PT(III))*ETA(N)
  731 CONTINUE
C
      DO 732 N = 6,8,2
      IF (KMBGG(3) .NE. 0) DN(N) = .5D0*(1.D0+PT(III)*XI(N))*
     1    (1.D0-PT(JJJ)*PT(JJJ))
      DNXI(N)  = .5D0*XI(N)*(1.D0-PT(JJJ)*PT(JJJ))
      DNETA(N) = -PT(JJJ)*(1.D0+PT(III)*XI(N))
  732 CONTINUE
C
C     COMPUTE JACOBEAN
C
C           N1XI   N2XI   N3XI   N4XI   N5XI   N6XI   N7XI   N8XI
C     DNC = N1ETA  N2ETA  N3ETA  N4ETA  N5ETA  N6ETA  N7ETA  N8ETA
C
C          X1  Y1
C          X2  Y2
C          X3  Y3
C     XX = X4  Y4
C          X5  Y5
C          X6  Y6
C          X7  Y7
C          X8  Y8
C
      CALL GMMATD (DNC,2,8,0,XX,8,2,0,XJB)
C
C     XJB IS ROW-STORED-IT MUST BE COLUMN-STORED AND DOUBLY DIMENSIONED
C     FOR INVERSION
C
      K = 0
      DO 740 I = 1,2
      DO 740 J = 1,2
      K = K + 1
  740 XXJB(I,J) = XJB(K)
C
C     COMPUTE INVERSE AND DETERMINANT OF JACOBEAN
C
      CALL INVERD (2,XXJB,2,DUMARG,0,DETERM,ISING,IWS)
      IF (ISING .NE. 2) GO TO 741
      CALL MESAGE (30,143,ECPT(1))
      ERROR =.TRUE.
      RETURN
C
  741 CONTINUE
      DHH = DETERM*H(III)*H(JJJ)
C
C     COMPUTE DERIVATIVES WITH RESPECT TO X,Y,AND Z
C
      K = 0
      DO 750 I = 1,2
      DO 750 J = 1,2
      K = K + 1
  750 XJB(K) = XXJB(I,J)
      CALL GMMATD (XJB,2,2,0,DNC,2,8,0,DNL)
C
C           N1X N2X N3X N4X N5X N6X N7X N8X
C     DNL = N1Y N2Y N3Y N4Y N5Y N6Y N7Y N8Y
C
C     SET UP THE BT MATRIX
C
      IC = 0
      DO 875 KK = 1,8
      IF (KMBGG(1) .EQ. 0) GO TO 800
      BT(1) = KX *DNX(KK) + KXY*DNY(KK)
      BT(2) = KXY*DNX(KK) + KY*DNY(KK)
C
C     DO NOT TRANSFORM FROM MATERIAL COORD SYSTEM TO BASIC AND GLOBAL
C     SINCE THIS IS A SCALAR PROBLEM
C
  800 DO 870 N = KK,8
      IC = IC + 1
C
C     SET UP THE B MATRIX
C
      IF (KMBGG(1) .EQ. 0) GO TO 810
      B(1) = DNX(N)
      B(2) = DNY(N)
C
C     O.K. NOW PERFORM FINAL MULTIPLICATION
C
      KIJ = BT(1)*B(1) + BT(2)*B(2)
C
C     THROW IN JACOBEAN DETERMINANT AND WEIGHT FACTORS
C
      KIJ = KIJ*DHH
C
C     ADD THE RESULTS OF THIS INTEGRATION TO PREVIOUS RESULTS
C
      SAVE(IC) = SAVE(IC) + KIJ
  810 IF (KMBGG(3) .EQ. 0) GO TO 870
      BIJ = DN(KK)*DN(N)*DHH
      SAVM(IC) = SAVM(IC) + BIJ
C
C     LOOP FOR MORE PARTITIONS
C
  870 CONTINUE
  875 CONTINUE
C
C     LOOP FOR ADDITIONAL GAUSS POINTS
C
  880 CONTINUE
C
      DO 890 I = 1,36
      IF (KMBGG(1) .NE. 0) SAVE(I) = SAVE(I)*THICK
      IF (KMBGG(3) .NE. 0) SAVM(I) = SAVM(I)*DC
  890 CONTINUE
C
C     INSERT INTO OVERALL STIFFNESS MATRIX
C
      IC = 0
      DO 900 I = 1,8
      DO 900 J = I,8
      IC = IC + 1
      NROW = ISIL(I)
      NCOL = ISIL(J)
      IF (KMBGG(1) .NE. 0) CALL INSERT (NCOL,NROW,1,8,JCORE,Z,Z,
     1    SAVE(IC),SAVE(IC),IPREC)
      IF (KMBGG(3) .NE. 0) CALL INSERT (NCOL,NROW,1,8,JCORE+64,Z,Z,
     1    SAVM(IC),SAVM(IC),IPREC)
  900 CONTINUE
C
      IF (KMBGG(1) .NE. 0) CALL EMGOUT (Z(JCORE),Z(JCORE),NSQ,1,DICT,1,
     1    IPREC)
      IF (KMBGG(3) .NE. 0) CALL EMGOUT (Z(JCORE+64),Z(JCORE+64),NSQ,1,
     1    DICT,3,IPREC)
      GO TO 5000
C
C     SAVE ELEMENT NAME, ID, THICKNESS, DENSITY, NO. OF GRID POINTS,
C     GRID POINT DATA, AND AREA IF USER REQUESTED VOLUME AND AREA
C     COMPUTATION
C
 1000 IF (VOLUME.LE.0.0 .AND. SURFAC.LE.0.0) GO TO 5000
      ECPT(2) = ECPT(13)
      ECPT(3) = RHO
      J = 4
      NECPT(J) = 8
      ECPT(46) = AREA
      CALL WRITE (SCR4,BCD,2,0)
      CALL WRITE (SCR4,ECPT(1),4,0)
      CALL WRITE (SCR4,DUMB(2),8,0)
      CALL WRITE (SCR4,ECPT(14),33,1)
 5000 RETURN
      END

      SUBROUTINE GPWG1B (MO,OGPWG,WTMASS,IPOINT)
C
C     DOUBLE PRECISION VERSION, BY G.CHAN/UNISYS  8/86
C
C     THIS ROUTINE WRITES OGPWG--
C         HEADER
C         MO =  36 D.P.WORDS
C         S  =  9  D.P.WORDS
C         MX,XX,YX,ZX,MY,XY,YY,ZY,MZ,XZ,YZ,ZZ  = 12 D.P.WORDS
C         I  =  9  D.P.WORDS
C         I1P, I2P, I3P = 3 D.P.WORDS
C         Q  =  9  D.P.WORDS
C               78 D.P.WORDS (156 S.P.WORDS) TOTAL
C
      DOUBLE PRECISION  S(3,3),MT(3,3),MTR(3,3),MR(3,3),TEMP(3,3),
     1                  DZ(36),DELTA,EPSI
      INTEGER           SYSBUF,MO,OGPWG,NAME(2),Z(150)
      EQUIVALENCE       (DZ(1),Z(1),IZ(1))
C
      COMMON /ZZZZZZ/ IZ(1)
      COMMON /UNPAKX/ IT1,II,JJ,INCR
      COMMON /SYSTEM/ SYSBUF
      COMMON /OUTPUT/ HEAD(1)
C
      DATA    NAME  / 4HGPWG,4H1B   /
C
C     ASSIGN BUFFER
C     OPEN OGPWG, PUT ON OFP HEADER
C
      IBUF = KORSZ(Z)- SYSBUF+1
      CALL GOPEN (MO,Z(IBUF),0)
C
C     UNPACK MO  + MOVE TO PARTITIONS
C
      IT1  = 2
      INCR = 1
      JJ   = 6
      II   = 1
      K    = 1
      DO 30 I=1,6
      CALL UNPACK (*10,MO,DZ(K))
      GO TO 30
   10 DO 20 L=1,6
      M = L+K-1
      DZ(M) =0.0D0
   20 CONTINUE
   30 K = K+6
      CALL CLOSE (MO,1)
      DELTA=1.D0/WTMASS
      DO 40 I=1,36
      DZ(I) = DZ(I)*DELTA
   40 CONTINUE
C
C     OPEN OGPWG FOR OUTPUT
C
      CALL GOPEN (OGPWG,Z(IBUF),1)
      DO 42 I = 104,150
   42 Z(I) = 0
      Z(101) = 1
      Z(102) = 13
      Z(103) = IPOINT
      Z(110) = 78*2
      CALL WRITE (OGPWG,Z(101),50,0)
      CALL WRITE (OGPWG,HEAD,96,1)
C
C     PUT MO  ON OGPWG
C
      CALL WRITE (OGPWG,Z(1),72,0)
C
C     PARTITION MO INTO MT, MTR, AND MR
C     AND CREATE DIAGONAL S MATRIX
C
      MT(1,1) = DZ(1)
      MT(1,2) = DZ(2)
      MT(1,3) = DZ(3)
      MT(2,1) = DZ(7)
      MT(2,2) = DZ(8)
      MT(2,3) = DZ(9)
      MT(3,1) = DZ(13)
      MT(3,2) = DZ(14)
      MT(3,3) = DZ(15)
      MTR(1,1)= DZ(4)
      MTR(2,1)= DZ(5)
      MTR(3,1)= DZ(6)
      MTR(1,2)= DZ(10)
      MTR(2,2)= DZ(11)
      MTR(3,2)= DZ(12)
      MTR(1,3)= DZ(16)
      MTR(2,3)= DZ(17)
      MTR(3,3)= DZ(18)
      MR(1,1) = DZ(22)
      MR(1,2) = DZ(23)
      MR(1,3) = DZ(24)
      MR(2,1) = DZ(28)
      MR(2,2) = DZ(29)
      MR(2,3) = DZ(30)
      MR(3,1) = DZ(34)
      MR(3,2) = DZ(35)
      MR(3,3) = DZ(36)
      S(1,1)  = 1.0D0
      S(1,2)  = 0.0D0
      S(1,3)  = 0.0D0
      S(2,1)  = 0.0D0
      S(2,2)  = 1.0D0
      S(2,3)  = 0.0D0
      S(3,1)  = 0.0D0
      S(3,2)  = 0.0D0
      S(3,3)  = 1.0D0
C
C     COMPUTE  DETERMINATE OF  MT
C
      DELTA = DSQRT(MT(1,1)**2 + MT(2,2)**2 + MT(3,3)**2)
      EPSI  = DSQRT(MT(2,1)**2 + MT(3,1)**2 + MT(3,2)**2)
      IF (EPSI  .EQ. 0.0D0) GO TO 60
      EPSI = EPSI/DELTA
      IF (DELTA .EQ. 0.0D0) GO TO 45
      IF (EPSI .LT. 1.0D-6) GO TO 60
C
C     ROTATE COORDINATES
C
   45 R = EPSI
      CALL MESAGE (42,R,NAME)
      DO 50 I=1,3
      DO 50 J=1,3
      TEMP(I,J)= MT(I,J)
   50 CONTINUE
C
C     COMPUTE EIGENVECTORS OF  MT  BY JACOBY  METHOD
C
      CALL GPWG1C (TEMP,S,DZ(1),IFLAG)
      IF (IFLAG .GT. 0) CALL MESAGE(-7,0,NAME)
C
C     ORDER EIGENVECTORS  SUCH THAT
C
C     TRANSFORM  MT
C
      CALL GMMATD (MT,3,3,0,S,3,3,0,TEMP)
      CALL GMMATD (S,3,3,1,TEMP,3,3,0,MT)
C
C     TRANSFORM  MTR
C
      CALL GMMATD (MTR,3,3,0,S,3,3,0,TEMP)
      CALL GMMATD (S,3,3,1,TEMP,3,3,0,MTR)
C
C     TRANSFORM  MR
C
      CALL GMMATD (MR,3,3,0,S,3,3,0,TEMP)
      CALL GMMATD (S,3,3,1,TEMP,3,3,0,MR)
C
C     OUTPUT S
C
   60 CALL WRITE (OGPWG,S,18,0)
C
C     COMPUTE   MX,XX,YX,ZX
C
      DZ(1) = MT(1,1)
      DZ(2) = 0.0D0
      DZ(3) = 0.0D0
      DZ(4) = 0.0D0
      IF (DZ(1) .EQ. 0.0D0) GO TO 70
      DZ(2) = MTR(1,1)/DZ(1)
      DZ(3) =-MTR(3,1)/DZ(1)
      DZ(4) = MTR(2,1)/DZ(1)
   70 CALL WRITE (OGPWG,DZ(1),8,0)
      DZ(5) = MT(2,2)
      DZ(6) = 0.0D0
      DZ(7) = 0.0D0
      DZ(8) = 0.0D0
      IF (DZ(5) .EQ.0. 0D0) GO TO 80
      DZ(6) = MTR(3,2)/DZ(5)
      DZ(7) = MTR(2,2)/DZ(5)
      DZ(8) =-MTR(1,2)/DZ(5)
   80 CALL WRITE (OGPWG,DZ(5),8,0)
      DZ( 9) = MT(3,3)
      DZ(10) = 0.0D0
      DZ(11) = 0.0D0
      DZ(12) = 0.0D0
      IF (DZ(9) .EQ. 0.0D0) GO TO 90
      DZ(10) =-MTR(2,3)/DZ(9)
      DZ(11) = MTR(1,3)/DZ(9)
      DZ(12) = MTR(3,3)/DZ(9)
   90 CALL WRITE (OGPWG,DZ(9),8,0)
C
C     COMPUTE INERTIAS
C
      TEMP(1,1) = MR(1,1) - DZ(5)*DZ(8)*DZ(8) - DZ(9)*DZ(11)*DZ(11)
      TEMP(2,1) =-MR(1,2) - DZ(9)*DZ(10)*DZ(11)
      TEMP(1,2) = TEMP(2,1)
      TEMP(1,3) =-MR(1,3) - DZ(5)*DZ(6)*DZ(8)
      TEMP(3,1) = TEMP(1,3)
      TEMP(2,2) = MR(2,2) - DZ(9)*DZ(10)*DZ(10) - DZ(1)*DZ(4)*DZ(4)
      TEMP(2,3) =-MR(2,3) - DZ(1)*DZ(3)*DZ(4)
      TEMP(3,2) = TEMP(2,3)
      TEMP(3,3) = MR(3,3) - DZ(1)*DZ(3)*DZ(3) - DZ(5)*DZ(6)*DZ(6)
      CALL WRITE (OGPWG,TEMP,18,0)
      CALL GPWG1C (TEMP,S,DZ(1),IFLAG)
      IF (IFLAG .GT. 0) CALL MESAGE(-7,0,NAME)
C
C     PUT OUT  PRINCIPLE INERTIA-S
C
      CALL WRITE (OGPWG,DZ(1),6,0)
C
C     PUT  OUT  Q
C
      CALL WRITE (OGPWG,S,18,0)
      CALL CLSTAB (OGPWG,1)
      RETURN
      END

      SUBROUTINE INPUT4 (NMAT,UNITX,TAPE,BCDOPT)
C
C     THIS SUBROUTINE IS CALLED ONLY BY INPTT4. IT READS USER-SUPPLIED
C     TAPE (OR DISC FILE), AS GENERATED BY COSMIC or MSC/OUTPUT4 MODULE,
C     AND CREATES THE CORRESPONDING MATRIX DATA BLOCKS.
C
C     INPUTT4 MODULE DOES NOT HANDLE TABLE DATA BLOCKS.
C
C     DUE TO INSUFFICEINT DOCUMENTATION IN MSC USER MANUAL, THIS INPUT4
C     MAY NOT WORK WITH BCD/ASCII DATA AS GENERATED BY MSC/OUTPUT4
C
C     MATRICES CAN BE IN S.P. OR D.P.; DENSE OR SPARSE.
C     NO MATRIX CONVERSION IN THIS ROUTINE
C     i.e. TYPE OF MATRIX OUT = TYPE OF MATRIX IN
C
C     DEFINITION OF DENSE AND SPARSE MATRICES IN THIS SUBROUTINE -
C     DENSE MATRIX IS PROCESSED FROM FIRST TO LAST NONZERO TERMS OF
C     COLUMNS, AND SPARSE MATRIX IS PROCESSED BY STRINGS.
C
C     WRITTEN BY G.CHAN/UNISYS            JUNE  1989
C     LAST REVISION WITH MAJOR CHANGES    MARCH 1993
C
C     NMAT   = NUMBER OF MATRICES (5 MAX) WRITTEN ON USER'S TAPE
C     UNITX  = INPUT TAPE LOGICAL UNIT*, INTEGER, NO DEFAULT
C     TAPE   = TAPE READ CONTROL
C            = 0  NO ADDITIONAL ACTION BEFORE READ
C            =-1  REWIND UNITX  BEFORE READ
C            =-2  REWIND UNITX  AT END
C            =-3  BOTH
C     BCDOPT = 1  INPUT TAPE IN BINARY FORMAT
C            = 2  INPUT TAPE IN ASCII  FORMAT
C                 IF INPUT MATRIX IS IN S.P., I13 IS USED FOR INTEGER,
C                 AND 10E13.6 FOR S.P.REAL DATA
C                 IF INPUT MATRIX IS IN D.P., I16 IS USED FOR INTEGER,
C                 AND 8D16.9 FOR D.P.REAL DATA
C            = 3  SAME AS BCDOPT=2, EXECPT THAT I16 AND 8E16.9 ARE USED
C                 FOR INTEGERS AND S.P.REAL DATA. (BCDOPT=3 IS USED ONLY
C                 IN MACHINES WITH LONG WORDS (60 OR MORE BITS PER WORD)
C           NOTE- MATRIX HEADER RECORD IS NOT AFFECTED BY ABOVE FORMAT
C                 CHANGES. IT IS WRITTEN OUT BY (1X,4I13,5X,2A4)
C     P4     =-4,-2,-1,0,.GE.1, SEE P4 IN INPTT4
C
C     OUTFIL = UP TO 5 OUTPUT GINO DATA BLOCKS (MATRIX ONLY)
C              IF ANY OF THE OUTPUT DB IS PURGED, THE CORRESPONDING
C              MATRIX ON INPUT TAPE WILL BE SKIPPED.
C
C     * LOGICAL UNIT  vs.  GINO FILE NAME
C              ------     ----------------------
C                11        UT1  (CDC ONLY)
C                12        UT2  (CDC ONLY
C                14        INPT (VAX,UNIVAC)
C                15        INP1 (VAX,UNIVAC,IBM)
C                16        INP2      :
C                17        INP3      :
C                 :          :       :
C                23        INP9      :
C                24        INPT (IBM ONLY)
C
C
C     EACH MATRIX WAS WRITTEN AS FOLLOWS (IN BINARY OR ASCII), 4 INTEGER
C     WORDS + FILE NAME
C                1) NO. OF COLUMNS
C                2) NO. OF ROWS
C                3) FORM (NASTRAN  1 TO 8)
C                4) TYPE (NASTRAN  1 TO 4)
C              5,6) FILE NAME (BCD)
C
C     A  RECORD WAS WRITTEN FOR EACH NON-ZERO COLUMN
C        A) DENSE MATRIX:
C                1) COLUMN NO.
C                2) ROW POSITION OF FIRST NON-ZERO ELEMENT
C                3) NO. OF WORDS IN THIS COLUMN, ZEROS INCLUDED, FROM
C                   THE FIRST TO LAST NON-ZERO TERMS.
C                4) DATA VALUES FOR THIS COLUMN (REAL)
C        B) SPARSE MATRIX:
C                1) COLUMN NO.
C                2) ZERO (THIS ZERO IS THE SPARSE MATRIX FLAG)
C                3) NO. OF WORDS IN THIS COLUMN
C                4) DATA OF ONE OR MORE STRINGS.
C
C
C     EXAMPLE 1 - INPUT TAPE INP1 (UNIT 15) CONTAINS 5 MATRICES,
C     =========   WRITTEN BY COSMIC/OUTPUT4, BINARY.
C                 WE WANT TO COPY
C                 FILE 3 TO A,
C                 FILE 4 TO B
C
C     INPUTT4  /,,A,B,/-1/15      $ REWIND, READ & ECHO HEADER RECORD
C
C
C     EXAMPLE 2 - TO COPY THE FIRST 2 FILES OF A UNFORMATTED TAPE INP2
C     =========   (UNIT 16), WRITTEN BY MSC/OUTPUT4, DENSE MATRIX
C
C     INPUTT4  /A,B,,,/-3/16//-4  $
C
C     EXAMPLE 3 - TO COPY THE FIRST 2 FILES OF A FORMATTED ASCII TAPE
C     =========   INPT (UNIT 14), WRITTEN BY COSMIC/OUTPUT4, SPARSE
C                 MATRIX
C
C     INPUTT4  /A,B,,,/-3/-14//1  $
C
C     EXAMPLE 4 - SEE DEMO PROBLEM T00001A TO INPUT VARIOUS DATA BLOCKS
C     =========   (SQUARE, RECTANGULAR, ROW-VECTOR, 'COLUMN' VECOR,
C                 DIAGONAL, IDENTITY, SYMMETRIC) INTO NASTRAN SYSTEM
C                 USING MSC, ASCII FORMAT FILES.
C
C     A NOTE FOR FUTURE IMPROVEMENT, G.CHAN 4/93 -
C     IF INPUT MATRIX IS SYMMETRIC, MAKE AN OPTION TO INPUT ONLY THE
C     LOWER TRIANGULAR PORTION OF THE MATRIX, AND OBTAIN THE UPPER
C     PROTION THRU SYMMETRY.
C
C
      IMPLICIT INTEGER (A-Z)
CWKBR LOGICAL          BO,SP,CP,DP,MS,TAPEUP,TAPBIT,DEBUG
      LOGICAL          BO,SP,CP,DP,MS,DEBUG
      INTEGER          OUTFIL(5),TRL(7),NAME(2),SUBNAM(2),IZ(1),
     1                 SKIP(2),INAME(2,5),ONAME(2,5),TYP(5),T(2,5),TY(4)
      REAL             Z(1),DR(2),D,ZERO(4)
      DOUBLE PRECISION DZ(1),DD
      CHARACTER*11     FMD,UNF,FM
CWKBI
      CHARACTER*80     DSNAMES
      CHARACTER        UFM*23,UWM*25,UIM*29,SFM*25,SWM*27
      COMMON /XMSSG /  UFM,UWM,UIM,SFM,SWM
CWKBI
      COMMON / DSNAME / DSNAMES(80)
      COMMON /MACHIN/  MACH
     1       /PACKX /  TYPIN,TYPOUT,II,JJ,INCR
     2       /SYSTEM/  SYSBUF,NOUT,NOGO,DUM36(36),NBPW
     3       /TYPE  /  PREC(2),NWDS(4)
     4       /ZZZZZZ/  CORE(1)
      COMMON /BLANK /  P1,P2,P3(2),P4
      EQUIVALENCE      (IZ(1),Z(1),DZ(1),CORE(1)), (DR(1),D,DD)
      DATA    OUTFIL/  201,202,203,204,205 /, SKIP/4H(SKI,4HP)  /
      DATA    INAME ,  ONAME ,TYP / 25*4H    /    ,SUBNAM/4HINPT,2HT4  /
      DATA    TY    /  4HRSP ,4HRDP ,4HCSP ,4HCDP /, ZERO/4*0.0 /
      DATA    FMD   ,  UNF / 'FORMATTED  ','UNFORMATTED' /BLNK / 4H    /
      DATA    DEBUG /  .FALSE.    /
CWKBI
      DATA  IFIRST / 0 /
C
      SP    = .FALSE.
      CP    = .FALSE.
      DP    = .FALSE.
      MS    = P4.EQ.-4
      BO    = BCDOPT.NE.1
      LCORE = KORSZ(Z(1))
      BUF1  = LCORE - SYSBUF
      LCOR  = BUF1  - 1
      IF (LCOR .LE. 0) CALL MESAGE (-8,LCORE,SUBNAM)
      IF (UNITX.LT.10 .OR. UNITX.GT.24) GO TO 30
      IF (UNITX .EQ. 13) GO TO 30
      IF (MACH.EQ.4 .AND. UNITX.GE.13) GO TO 30
      IF (MACH.NE.4 .AND. UNITX.LE.13) GO TO 30
C
      FM = UNF
      IF (BO) FM = FMD
CWKBR WRITE  (NOUT,10) UIM,UNITX,INP(UNITX-10),FM
      WRITE  (NOUT,10) UIM,UNITX,DSNAMES(UNITX),FM
C    1,                BCDOPT,P1,P2,P3,P4
CWKBR10 FORMAT (A29,'. INPUTT4 MODULE OPENING FORTRAN TAPE',I4,' (',A4,
   10 FORMAT (A29,'. INPUTT4 MODULE OPENING FORTRAN TAPE',I4,/,' (',
     1       A44,')',/,
     1       ' FOR ',A11,' READ.')
C    2,      /5X,'BCDOPT,P1,P2,P3,P4 =',3I3,1X,2A4,I4)
C
CWKBR IF (MACH .GE. 5) GO TO 50
CWKBI
      CLOSE ( UNIT=UNITX )
CWKBR OPEN (UNIT=UNITX,ACCESS='SEQUENTIAL',STATUS='OLD',FORM=FM,ERR=920)
      OPEN (UNIT=UNITX,ACCESS='SEQUENTIAL',STATUS='OLD',FORM=FM,ERR=920,
CWKBI
     &     FILE=DSNAMES(UNITX) )
      GO TO 50
CWKBD FILE   = INP(UNITX-10)
CWKBD TAPEUP = TAPBIT(FILE)
CWKBD IF (TAPEUP) GO TO 50
CWKBD WRITE  (NOUT,20) UFM,FILE,UNITX
CWKBD 20 FORMAT (A23,'. ',A4,' (TAPE UNIT',I4,') NOT ASSIGNED')
CWKBD GO TO 990
C
   30 WRITE  (NOUT,40) UFM,UNITX
   40 FORMAT (A23,', TAPE UNIT',I4,' SPEC. ERROR')
      GO TO 990
C
   50 IF (TAPE.EQ.-1 .OR. TAPE.EQ.-3) REWIND UNITX
CWKBI	
      IFIRST = 1
C
C     SET UP LOOP TO READ MATRIX FILES
C
      INCR  = 1
      II    = 1
      DO 800 NN = 1,NMAT
C
C     CHECK OUTPUT FILE REQUEST
C
      OUTPUT = OUTFIL(NN)
      TRL(1) = OUTPUT
      CALL RDTRL (TRL)
      IF (TRL(1) .GT. 0) GO TO 200
C
C     IF OUTPUT FILE IS PURGED, PURGE THE CORRESPONDING FILE ON INPUT
C     TAPE. CHECK IF THERE ARE MORE OUTPUT DATA BLOCK REQUESTED ON THE
C     SAME OUTPUT2 DMAP. QUIT IF THERE ARE NONE
C
      I = NN
  100 I = I + 1
      IF (I .GT. 5) GO TO 810
      TRL(1) = OUTFIL(I)
      CALL RDTRL (TRL)
      IF (TRL(1) .LE. 0) GO TO 100
C
C     SKIP PRESENT MATRIX DATA BLOCK ON INPUT TAPE
C
      IMHERE = 120
      IF (BO) GO TO 120
C
C     SKIP BINARY FILES
C
      IMHERE = 105
      READ (UNITX,ERR=960,END=940) NCOL,J1,J2,NTYPE,NAME
      IMHERE = -110
  110 READ (UNITX,ERR=780,END=940) ICOL
      IF (ICOL-NCOL) 110,110,170
C
C     SKIP ASCII FILES
C
  120 IF (.NOT.MS) READ (UNITX,220,ERR=960,END=940) NCOL,J1,J2,NTYPE,
     1             NAME
      IF (MS) READ (UNITX,230,ERR=960,END=940) NCOL,J1,J2,NTYPE,NAME
      IF (MS) GO TO 130
      DP = NTYPE.EQ.2 .OR. NTYPE.EQ.4
      SP = .NOT.DP
      CP = P4.GE.1 .AND. NBPW.GE.60
      IF (.NOT.CP) GO TO 130
      SP = .FALSE.
      DP = .FALSE.
  130 IF (MS) READ (UNITX,440) ICOL,IROW,NW
      IF (SP) READ (UNITX,450) ICOL,IROW,NW
      IF (CP .OR. DP) READ (UNITX,460) ICOL,IROW,NW
      IF (ICOL .GT. NCOL) GO TO 160
      IF (IROW .EQ. 0) NW = NW/65536
C
C     COMPUTE NO. OF RECORDS TO SKIP.
C
C     S.P. DATA ARE WRITTEN IN 10 VALUES PER RECORD (5 FOR MSC RECORD)
C     D.P. DATA, AND DATA FROM LONG WORD MACHINE, ARE IN 8 VALUES PER
C     RECORD (SEE FORMAT 650, 660, 670 AND 680)
C
      IF (MS) NW = (NW+4)/5
      IF (SP) NW = (NW+9)/10
      IF (CP .OR. DP) NW = (NW+7)/8
      DO 150 J = 1,NW
      READ (UNITX,140) K
  140 FORMAT (A1)
  150 CONTINUE
      GO TO 130
C
  160 READ (UNITX,140) J
C
  170 INAME(1,NN) = NAME(1)
      INAME(2,NN) = NAME(2)
      ONAME(1,NN) = SKIP(1)
      ONAME(2,NN) = SKIP(2)
      TYP(NN) = TY(NTYPE)
      T(1,NN) = J1
      T(2,NN) = J2
      GO TO 800
C
C     TRANSFER DATA FROM INPUT TAPE TO OUTPUT FILE
C
  200 IMHERE = 210
      IF (BO) GO TO 210
      IMHERE = 200
      READ (UNITX,ERR=960,END=940) NCOL,NROW,NFORM,NTYPE,NAME
      GO TO 240
  210 IF (.NOT.MS) READ (UNITX,220,ERR=960,END=940) NCOL,NROW,NFORM,
     1             NTYPE,NAME
      IF (MS) READ (UNITX,230,ERR=960,END=940) NCOL,NROW,NFORM,NTYPE,
     1             NAME
  220 FORMAT (1X,4I13,5X,2A4)
  230 FORMAT (4I8,2A4)
C
  240 IF (DEBUG) WRITE (NOUT,220) NCOL,NROW,NFORM,NTYPE,NAME
      IF (.NOT.DEBUG) WRITE (NOUT,245) NN,NAME
  245 FORMAT (5X,'READING DATA BLOCK NO.',I4,' - ',2A4,
     1       ' FROM INPUT TAPE')
C
      IF (MS) NFORM = -NFORM
      IF (BO .AND. NFORM.GT.0) GO TO 900
C
C     THE ABOVE CHECK ON NFORM AND BO MAY BE ALREADY TOO LATE
C
      IF (MS) GO TO 250
      DP = .FALSE.
      IF (NTYPE.EQ.2 .OR. NTYPE.EQ.4) DP = .TRUE.
      SP = .NOT.DP
      CP = P4.GE.1 .AND. NBPW.GE.60
      IF (CP) SP = .FALSE.
      IF (CP) DP = .FALSE.
  250 FLAG = 0
      IF (MS) FLAG = 1
      IF (SP) FLAG = 2
      IF (CP) FLAG = 3
      IF (DP) FLAG = 4
      IF (FLAG .EQ. 0) CALL MESAGE (-37,0,SUBNAM)
      NFORM  = IABS(NFORM)
      JJ     = NROW
      TYPIN  = NTYPE
      IF (MS .AND. (TYPIN.EQ.2 .OR. TYPIN.EQ.4)) TYPIN = TYPIN - 1
      TYPOUT = NTYPE
      NWORDS = NWDS(TYPIN)
      BASE   = NROW*NWORDS
      IF (BASE .GT. LCOR) CALL MESAGE (-8,LCORE,SUBNAM)
      CALL MAKMCB (TRL(1),OUTPUT,NROW,NFORM,TYPOUT)
      INAME(1,NN) = NAME(1)
      INAME(2,NN) = NAME(2)
      CALL FNAME (OUTPUT,NAME)
      CALL OPEN  (*260,OUTPUT,IZ(BUF1),1)
      CALL WRITE (OUTPUT,NAME,2,1)
      ONAME(1,NN) = NAME(1)
      ONAME(2,NN) = NAME(2)
      TYP(NN) = TY(NTYPE)
      T(1,NN) = NCOL
      T(2,NN) = NROW
      GO TO 280
C
  260 WRITE  (NOUT,270) UFM,DSNAMES(UNITX)
  270 FORMAT (A23,'. CANNOT OPEN OUTPUT FILE - ',/,A80)
      GO TO 990
C
C     PROCESS EACH COLUMN (NON-ZERO OR NULL COLUMN ON FILE)
C     PLUS ONE EXTRA COLUMN, NCOL+1, AT THE END
C
  280 IOLD = -1
      II = 1
      JJ = NROW
      NCOL1 = NCOL + 1
      I  = 0
C
  290 I  = I + 1
      IF (DEBUG) WRITE (NOUT,300) I,NCOL1
  300 FORMAT ('   INPUT4/@290   I,NCOL1 =',2I5)
      IF (I .GT. NCOL1) GO TO 760
      DO 310 J = 1,BASE
  310 Z(J) = 0.0
      IMHERE = -400
      IF (BO) GO TO 400
C
C     BINARY (UNFORMATTED) READ
C     -------------------------
C
      IMHERE = -315
      READ (UNITX,ERR=780,END=940) ICOL,IROW,NW,(Z(K+BASE),K=1,NW)
C
      IF (ICOL .GT. NCOL) GO TO 760
      IF (NW+BASE .GT. LCOR) CALL MESAGE (-8,LCORE,SUBNAM)
  320 IF (I .GE. ICOL) GO TO 330
C
C     NULL COLUMN(S) ENCOUNTERED
C
      JJ = 1
      CALL PACK (Z(1),OUTPUT,TRL)
      JJ = NROW
      I  = I + 1
      GO TO 320
C
  330 IF (IROW .EQ. 0) GO TO 360
C
C     DENSE MATRIX FORMAT
C
C     DATA WERE WRITTEN FROM FIRST NON-ZERO TERM TO LAST NON-ZERO TERM
C     INCLUDING POSSIBLE ZERO TERMS.
C     IROW IS THE FIRST NON-ZERO TERM ROW POSITION
C
C     S.P. OR D.P. MATRIX IN, S.P. OR. D.P. MATRIX OUT. THAT INCLUDE
C     REAL AND COMPLEX.
C
      IROWP = (IROW-1)*NWORDS
      DO 340 J = 1,NW
  340 Z(J+IROWP) = Z(J+BASE)
C
C     PACK ONE COLUMN OUT
C
  350 CALL PACK (Z(1),OUTPUT,TRL)
      GO TO 290
C
C     SPARSE INCOMING MATRIX.
C     THIS RECORD CONATINS ONE OR MORE STRINGS.
C
C     DATA ARE WRITTEN IN MULTIPLE STRINGS OF NON-ZERO TERMS. EACH
C     STRING IS PRECEED BY A CONTROL WORD
C       LN   = LENGTH OF STRING, LEFT HALF OF WORD
C       IROW = ROW POSITION,    RIGHT HALF OF WORD
C       LN AND IROW ARE DATA TYPE DEPENDENT
C     AND
C       K    = A RUNNING POINTER, POINTS TO THE CONTROL WORD OF EACH
C              STRING IN ARRAY Z HOLDING LN AND IROW INFORMATION
C
  360 K    = 1
  370 KPB  = K + BASE
      LN   = IZ(KPB)/65536
      IROW = IZ(KPB) - LN*65536
      IROW = (IROW-1)*NWORDS
      LN   = LN*NWORDS
C
C     S.P. OR D.P. MATRIX IN, S.P. OR. D.P. MATRIX OUT. THAT INCLUDE
C     REAL AND COMPLEX
C
      DO 380 J = 1,LN
  380 Z(J+IROW) = Z(J+KPB)
      K  = K + LN + 1
      IF (K-NW) 370,350,350
C
C     ASCII (FORMATTED) READ
C     ----------------------
C
C     THIS ASCII OPTION WORKS WELL WITH INPUT TAPE GENERATED FROM
C     COSMIC/OUTPUT4 MODULE. HOWEVER IT MAY OR MAY NOT WORK WITH INPUT
C     TAPE FROM MSC/OUTPUT4.
C
C     ASSUMPTIONS HERE FOR MSC/OUTPUT4 TAPE ARE -
C     1. INTEGER RECORDS AND FLOATING POINT RECORDS DO NOT MIXED
C     2. ONE OR MORE RECORDS HOLD A MATRIX COLUMN, EACH RECORD IS LESS
C        THAN 80 BYTES LONG.
C        INTEGER IN 3I8, BCD IN 2A4, AND S.P. REAL DATA IN 5E16.9
C
  400 GO TO (410,420,430,430), FLAG
  410 READ (UNITX,440,ERR=780,END=940) ICOL,IROW,NW
      IF (DEBUG) WRITE (NOUT,450) ICOL,IROW,NW
      GO TO 470
  420 READ (UNITX,450,ERR=780,END=940) ICOL,IROW,NW
      GO TO 470
  430 READ (UNITX,460,ERR=780,END=940) ICOL,IROW,NW
  440 FORMAT (3I8)
  450 FORMAT (1X,3I13)
  460 FORMAT (1X,3I16)
C
C     ICOL IS MATRIX COLUMN NUMBER READ IN FROM THE INPUT TAPE.
C          REPEATED ICOL FOR MULTIPLE STRINGS.
C     IROW IS .LT. 0, AND IABS(IROW) IS THE ROW POSITION OF STRING.
C     NW   IS LENGTH OF STRING.
C     I    IS THE CURRENT COLUMN NUMBER OF THE OUTPUT MATRIX.
C
C     POSSIBILITIES AT THIS POINT ARE -
C
C     1. ICOL = IOLD, ADD NEW STRING TO CURRENT COLUMN OF OUTPUT MATRIX.
C     2. ICOL = IOLD+1, PREVIOUS COLUMN JUST FINISHED, PACK IT OUT.
C     3. ICOL.GT.NCOL, OUTPUT MATRIX FINISH. ALL COLUMNS HAVE BEEN READ.
C               READ ONE MORE DUMMY RECORD BEFORE WRAP UP THIS MATRIX
C     4. IN ALL CASES, ZERO OUT Z ARRAY FOR NEW DATA, AND INCREASE
C        COLUMN COUNTER I BY 1
C     5. ICOL .LT. I, LOGIC ERROR
C     6. ICOL .GT. I, PACK NULL COLUMN(S) OUT.
C     7. ICOL .EQ. I, CURRENT INPUT RECORD IS FOR THE I-TH COLUMN.
C
  470 IF (NW*NWORDS .GT. LCOR) CALL MESAGE (-8,LCORE,SUBNAM)
      IF (ICOL .EQ. IOLD  ) GO TO 710
      IF (ICOL .EQ. IOLD+1) CALL PACK (Z(1),OUTPUT,TRL)
      IMHERE = -550
      IF (ICOL .GT. NCOL) GO TO 550
      DO 480 J = 1,BASE
  480 Z(J) = 0.0
C 490 I = I + 1
  490 IF (ICOL - I) 510,600,500
  500 CALL PACK (Z(1),OUTPUT,TRL)
      I = I + 1
      GO TO 490
  510 WRITE  (NOUT,520) SFM,I,ICOL, IOLD,NCOL,IROW,NW, SP,CP,DP,MS,FLAG
  520 FORMAT (A25,'. LOGIC ERROR @470, I,ICOL =',2I6, /5X,
     1       '  IOLD,NCOL,IROW,NW =',4I6,'  SP,CP,DP,MS,FLAG =',4L2,I4)
      CALL MESAGE (-37,0,SUBNAM)
C
  550 READ (UNITX,140,ERR=780,END=940) J
      GO TO 760
C
  600 IF (IROW .LE. 0) GO TO 700
C
C     DENSE MATRIX FORMAT
C
      IROW = IROW - 1
      IMHERE = 605
      GO TO (610,620,630,640), FLAG
  610 READ (UNITX,650,ERR=780,END=940) ( Z(K+IROW),K=1,NW)
      IF (DEBUG) WRITE (NOUT,660) (Z(K+IROW),K=1,NW)
      GO TO 350
  620 READ (UNITX,660,ERR=780,END=940) ( Z(K+IROW),K=1,NW)
      GO TO 350
  630 READ (UNITX,670,ERR=780,END=940) ( Z(K+IROW),K=1,NW)
      GO TO 350
  640 READ (UNITX,680,ERR=780,END=940) (DZ(K+IROW),K=1,NW)
      GO TO 350
  650 FORMAT (    5E16.9)
  660 FORMAT (1X,10E13.6)
  670 FORMAT (1X, 8E16.9)
  680 FORMAT (1X, 8D16.9)
C
C     SPARSE INCOMING MATRIX
C
C     OUTPUT4 WRITES OUT THE ASCII STRING DATA IN FOLLOWING FORMATS -
C     EACH STRING, PRECEEDED BY A 3-INTEGER - ICOL,IROW,NW - CONTROL
C     RECORD, AND CONTINUE INTO ONE OR MORE DATA RECORDS OF 130 OR
C     128 BYTES EACH. (80 BYTES MSC RECORD)
C     NW   = LENGTH OF STRING IN THE FOLLOWING DATA RECORDS, S.P. OR
C            D.P. DEPENDENT.
C     IROW = IABS(IROW) IS ROW POSITION IF FIRST WORD OF STRING
C     ICOL = COLUMN NUMBER OF MATRIX
C
C     NOTICE THAT OUTPUT4 MAY WRITE OUT A MATRIX COLUMN IN MULTI-STRING
C     RECORDS, WITH THE SAME COLUMN VALUE ICOL IN THE EACH 3-INTEGER
C     CONTROL RECORD. IN THIS CASE, MROW IS ALWAYS NEGATIVE.
C     (IF IROW IS ZERO, MATRIX WAS WRITTEN OUT IN DENSE FORMAT)
C
  700 IOLD = ICOL
  710 IROW = IABS(IROW) - 1
      IF (TYPIN .GE. 3) IROW = IROW*2
      IMHERE = 715
      GO TO (720,730,740,750), FLAG
  720 READ (UNITX,650,ERR=780,END=940) ( Z(K+IROW),K=1,NW)
      GO TO 400
  730 READ (UNITX,660,ERR=780,END=940) ( Z(K+IROW),K=1,NW)
      GO TO 400
  740 READ (UNITX,670,ERR=780,END=940) ( Z(K+IROW),K=1,NW)
      GO TO 400
  750 READ (UNITX,680,ERR=780,END=940) (DZ(K+IROW),K=1,NW)
      GO TO 400
C
  760 CALL CLOSE  (OUTPUT,1)
      CALL WRTTRL (TRL)
      IF (DEBUG) WRITE (NOUT,770) UIM,NAME,DSNAMES(UNITX),TRL
  770 FORMAT (A29,' FROM INPUTT4 MODULE. ',2A4,' WAS RECOVERED FROM ',
     1 /, A44,' INPUT TAPE SUCCESSFULLY.', /5X,'TRAIL =',6I6,I9)
      GO TO 800
C
C     BAD DATA ON INPUT TAPE
C
  780 WRITE  (NOUT,790) UFM,DSNAMES(UNITX),UNITX,NN,IMHERE
  790 FORMAT (A23,'. BAD DATA ENCOUNTERED WHILE READING INPUT TAPE ',/,A80
     1,/,     ' FORTRAN UNIT',I4,',  DATA BLOCK',I4, /5X,'IMHERE =',I5)
      NOGO = 1
C
  800 CONTINUE
C
  810 IF (TAPE .LE. -2) REWIND UNITX
      CALL PAGE2 (-8)
CWKBR WRITE  (NOUT,820) UIM,FM,INP(UNITX-10)
      WRITE  (NOUT,820) UIM,FM,DSNAMES(UNITX)
  820 FORMAT (A29,' FROM INPUTT4 MODULE. THE FOLLOWING FILES WERE ',
     1       'SUCCESSFULLY RECOVERED FROM USER ',/5X,A11,' INPUT TAPE ',
CWKBR2       /A80/,' TO NASTRAN GINO FILES')
     2       /,A44,' TO NASTRAN GINO FILES')
      DO 840 J = 1,5
      IF (INAME(1,J) .NE. BLNK) WRITE (NOUT,830) INAME(1,J),INAME(2,J),
     1       ONAME(1,J),ONAME(2,J),TYP(J),T(1,J),T(2,J)
  830 FORMAT (5X,2A4,' ==COPIED TO== ',2A4,4X,'MATRIX TYPE = ',A4,
     1       ',  SIZE (',I6,2H X,I6,1H))
  840 CONTINUE
      GO TO 1000
C
C     ERRORS
C
  900 WRITE  (NOUT,910) UFM,DSNAMES(UNITX),BO,NCOL,NROW,NFORM,NTYPE,
     1        NAME,BCDOPT
  910 FORMAT (A23,'. PARAMETER P3 ERROR. FORTRAN INPUT TAPE ',A4,' WAS',
     1       ' WRITTEN IN BINARY RECORDS, NOT ASCII.', /5X,'BO =',L2,2X,
     2       'NCOL,NROW,NFORM,NTYPE,NAME =',4I8,1X,2A4,'   BCDOPT =',I3)
      GO TO  990
  920 WRITE  (NOUT,930) UFM,UNITX
  930 FORMAT (A23,'. INPUTT4 MODULE CANNOT OPEN FORTRAN INPUT TAPE',I4)
      GO TO  990
  940 WRITE  (NOUT,950) UFM,DSNAMES(UNITX),UNITX,NN,IMHERE
  950 FORMAT (A23,' 3001, EOF ENCOUNTERED WHILE READING INPUT TAPE ',/,A80
     1,/,    ' FORTRAN UNIT',I4,',  DATA BLOCK',I4, /5X,'IMHERE =',I4)
      IF (IMHERE.EQ.210 .OR. IMHERE.EQ.220) WRITE (NOUT,975)
      GO TO 990
  960 WRITE  (NOUT,970) UFM,DSNAMES(UNITX),UNITX,NN,IMHERE
  970 FORMAT (A23,'. BAD DATA IN HEADER RECORD ON INPUT TAPE ',
     1/,A80,/
     2, ' FORTRAN UNIT',I4,',  DATA BLOCK',I4, /5X,'IMHERE =',I5)
      IF (IMHERE.EQ.105 .OR. IMHERE.EQ.120) WRITE (NOUT,975)
  975 FORMAT (1H+,22X,'POSSIBLY TAPE UNIT NOT CORRECTLY ASSIGNED')
      IF (IMHERE .LT. 0) WRITE (NOUT,980)
  980 FORMAT (1H+,22X,'POSSIBLY ERROR IN CONTRL RECORD 3 WORDS')
C
  990 NOGO = 1
C
CWKBR 1000 CLOSE (UNIT=UNITX)
 1000 CONTINUE
      RETURN
      END

      SUBROUTINE SORTDG (STK1,STK2,X1,X2,NDEG)
C
C     SORTDG SORTS STK2 BY DEGREE OF THE NODE AND ADDS IT TO THE END
C     OF STK1 IN ORDER OF LOWEST TO HIGHEST DEGREE.  X1 AND X2 ARE THE
C     NUMBER OF NODES IN STK1 AND STK2 RESPECTIVELY.
C
      INTEGER          X1,       X2,       STK1,     STK2,     TEMP
      DIMENSION        NDEG(1),  STK1(1),  STK2(1)
      COMMON /BANDG /  N,        IDPTH
C
      IND=X2
   10 ITEST=0
      IND=IND-1
      IF (IND.LT.1) GO TO 40
      DO 30 I=1,IND
      J=I+1
      ISTK2=STK2(I)
      JSTK2=STK2(J)
      IF (NDEG(ISTK2).LE.NDEG(JSTK2)) GO TO 30
      ITEST=1
      TEMP=STK2(I)
      STK2(I)=STK2(J)
      STK2(J)=TEMP
   30 CONTINUE
      IF (ITEST.EQ.1) GO TO 10
   40 DO 50 I=1,X2
      X1=X1+1
      STK1(X1)=STK2(I)
   50 CONTINUE
      RETURN
      END

      SUBROUTINE SMCCCS ( CTEMP, ZIL, ILIM, ZOL )
      COMPLEX    CTEMP( ILIM ), ZIL( ILIM ), ZOL
      DO 10 I = 1, ILIM
      CTEMP( I ) = CTEMP( I ) + ZIL( I ) * ZOL
10    CONTINUE
      RETURN
      END
      
      

      SUBROUTINE MRED1A (MODE)
C
C     THIS SUBROUTINE PROCESSES THE BDYC DATA FOR THE FIXED
C     IDENTIFICATION SET (FIXSET) AND THE BOUNDARY IDENTIFICATION SET
C     (BNDSET) FOR THE MRED1 MODULE.
C
C     INPUT DATA
C     GINO - GEOM4    - BDYC DATA
C     MODE            - PROCESSING OPERATION FLAG
C                     = 1, PROCESS FIXED ID SET
C                     = 2, PROCESS BOUNDARY ID SET
C
C     OUTPUT DATA
C     GINO - USETX    - S,R,B DEGREES OF FREEDOM
C
C     PARAMETERS
C     INPUT  - GBUF1  - GINO BUFFER
C              KORLEN - CORE LENGTH
C              BNDSET - BOUNDARY SET IDENTIFICATION NUMBER
C              FIXSET - FIXED SET IDENTIFICATION NUMBER
C              IO     - OUTPUT OPTION FLAG
C              KORUST - STARTING ADDRESS OF USET ARRAY
C              NCSUBS - NUMBER OF CONTRIBUTING SUBSTRUCTURES
C              NAMEBS - BEGINNING ADDRESS OF BASIC SUBSTRUCTURES NAMES
C              KBDYC  - BEGINNING ADDRESS OF BDYC DATA
C              NBDYCC - NUMBER OF BDYC CARDS
C              USETL  - NUMBER OF WORDS IN USET ARRAY
C     OUTPUT - NOUS   - FIXED POINTS FLAG
C                       .GE.  0, FIXED POINTS DEFINED
C                       .EQ. -1, NO FIXED POINTS DEFINED
C              DRY    - MODULE OPERATION FLAG
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        RSHIFT,ANDF
      LOGICAL         PONLY
      DIMENSION       ARRAY(3),BDYC(2),MODNAM(2)
      CHARACTER       UFM*23,UWM*25
      COMMON /XMSSG / UFM,UWM
      COMMON /BLANK / OLDNAM(2),DRY,IDUM1,NOUS,SKIPM,IDUM2(3),GBUF1,
     1                IDUM3(4),KORLEN,IDUM4(2),BNDSET,FIXSET,IDUM5,IO,
     2                IDUM6(6),NCSUBS,NAMEBS,IDUM7(3),KBDYC,NBDYCC,
     3                USETL,KORUST,IDUM14(5),PONLY
      COMMON /ZZZZZZ/ Z(1)
      COMMON /SYSTEM/ IDUM8,IPRNTR,IDUM9(6),NLPP,IDUM10(2),LINE
      COMMON /TWO   / ITWO(32)
      COMMON /BITPOS/ IDUM11(5),UL,UA,UF,IDUM12,UN,IDUM13(11),UI
      DATA    GEOM4 , BDYC  /102,910,9/
      DATA    MODNAM/ 4HMRED,4H1A     /
C
C     TEST PROCESSING MODE FLAG
C
      IF (MODE .EQ. 2) GO TO 10
C
C     TEST FIXED SET ID FLAG AND SET FIXED INDEX
C
      IF (FIXSET.EQ.0 .OR. SKIPM.EQ.-1) GO TO 260
      SETID  = FIXSET
      ISHIFT = 10
      GO TO 20
C
C     SET BOUNDARY INDEX
C
   10 IF (BNDSET .EQ. 0) GO TO 240
      SETID  = BNDSET
      ISHIFT = 1
C
C     ALLOCATE USET ARRAY AND TEST OPEN CORE LENGTH
C
      IF (NOUS .EQ. 1) GO TO 40
   20 KBDYC = KORUST + USETL
      IF (KBDYC .GE. KORLEN) GO TO 200
C
C     TURN UL, UA, UF, UN, AND UI BITS ON IN USET ARRAY
C
      IBITS = ITWO(UL) + ITWO(UA) + ITWO(UF) + ITWO(UN) + ITWO(UI)
      DO 30 I = 1,USETL
   30 Z(KORUST+I-1) = IBITS
C
C     READ BOUNDARY SET (BDYC) BULK DATA FOR REQUESTED FIXED SET
C     ID (FIXSET) OR BOUNDARY SET ID (BNDSET)
C
   40 IFILE = GEOM4
      CALL PRELOC (*170,Z(GBUF1),GEOM4)
      CALL LOCATE (*230,Z(GBUF1),BDYC,IFLAG)
   50 CALL READ (*180,*230,GEOM4,ARRAY,1,0,IFLAG)
      IF (ARRAY(1) .EQ. SETID) GO TO 70
   60 CALL READ (*180,*190,GEOM4,ARRAY,3,0,IFLAG)
      IF (ARRAY(3) .EQ. -1) GO TO 50
      GO TO 60
C
C     SET ID FOUND, STORE AT Z(KBDYC+NWDS)
C
   70 NWDS = 0
   80 CALL READ (*180,*190,GEOM4,Z(KBDYC+NWDS),3,0,IFLAG)
      IF (Z(KBDYC+NWDS+2) .EQ. -1) GO TO 110
C
C     CHECK THAT SUBSTRUCTURE IS A COMPONENT OF STRUCTURE BEING
C     REDUCED
C
      DO 90 I = 1,NCSUBS
      J = 2*(I-1)
      IF ((Z(NAMEBS+J).EQ.Z(KBDYC+NWDS)) .AND. (Z(NAMEBS+J+1).EQ.
     1     Z(KBDYC+NWDS+1))) GO TO 100
   90 CONTINUE
C
C     SUBSTRUCTURE IS NOT A COMPONENT
C
      IF (MODE .EQ. 1) WRITE (IPRNTR,900) UWM,Z(KBDYC+NWDS),
     1                                    Z(KBDYC+NWDS+1)
      IF (MODE .EQ. 2) WRITE (IPRNTR,901) UWM,Z(KBDYC+NWDS),
     1                                    Z(KBDYC+NWDS+1)
      DRY = -2
      GO TO 80
C
C     SAVE BASIC SUBSTRUCTURE INDEX
C
  100 Z(KBDYC+NWDS+3) = I
      NWDS = NWDS + 4
      IF (KBDYC+NWDS .GE. KORLEN) GO TO 200
      GO TO 80
C
C     CHECK FOR DUPLICATE BDYC SUBSTRUCTURE NAMES
C
  110 NWDS = NWDS/4
      IF (NWDS .LE. 1) GO TO 125
      I = NWDS - 1
      DO 120 J = 1,I
      K  = J + 1
      II = 4*(J-1)
      DO 120 L = K,NWDS
      LL = 4*(L-1)
      IF (Z(KBDYC+II  ) .NE. Z(KBDYC+LL  )) GO TO 120
      IF (Z(KBDYC+II+1) .NE. Z(KBDYC+LL+1)) GO TO 120
      WRITE (IPRNTR,902) UFM,OLDNAM,ARRAY(1)
      DRY = -2
  120 CONTINUE
C
C     TEST OUTPUT OPTION
C
  125 CONTINUE
      IF (ANDF(RSHIFT(IO,ISHIFT),1) .EQ. 0) GO TO 150
      IF (NWDS .EQ. 0) GO TO 150
      LINE = NLPP + 1
      DO 140 I = 1,NWDS
      IF (LINE .LE. NLPP) GO TO 130
      CALL PAGE1
      IF (MODE .EQ. 1) WRITE (IPRNTR,903) FIXSET
      IF (MODE .EQ. 2) WRITE (IPRNTR,904) BNDSET
      LINE = LINE + 7
  130 J = 4*(I-1)
      IF (MODE .EQ. 1) WRITE (IPRNTR,905) Z(KBDYC+J),Z(KBDYC+J+1),
     1    Z(KBDYC+J+2)
      IF (MODE .EQ. 2) WRITE (IPRNTR,906) Z(KBDYC+J),Z(KBDYC+J+1),
     1    Z(KBDYC+J+2)
  140 LINE = LINE + 1
C
C     SORT BDYC DATA ON SET ID
C
  150 NBDYCC = NWDS
      IF (NBDYCC .LE. 1) GO TO 270
      NWDS = 4*NBDYCC
      CALL SORT (0,0,4,3,Z(KBDYC),NWDS)
      GO TO 270
C
C     PROCESS SYSTEM FATAL ERRORS
C
  170 IMSG = -1
      GO TO 220
  180 IMSG = -2
      GO TO 210
  190 IMSG = -3
      GO TO 210
  200 IMSG = -8
      IFILE = 0
  210 CALL CLOSE (GEOM4,1)
  220 CALL SOFCLS
      CALL MESAGE (IMSG,IFILE,MODNAM)
      RETURN
C
C     PROCESS MODULE FATAL ERRORS
C
  230 IF (MODE .EQ. 1) WRITE (IPRNTR,907) UWM,FIXSET
      IF (MODE .EQ. 2) WRITE (IPRNTR,908) UWM,BNDSET
      DRY = -1
      GO TO 250
  240 IF (PONLY) GO TO 280
      WRITE (IPRNTR,909) UFM
      DRY = -2
  250 CALL SOFCLS
      CALL CLOSE (GEOM4,1)
      RETURN
C
C     NO FIXED ID SET DATA
C
  260 NOUS = -1
C
C     END OF PROCESSING
C
  270 CALL CLOSE (GEOM4,1)
  280 CONTINUE
C
  900 FORMAT (A25,' 6622, A FIXED SET HAS BEEN SPECIFIED FOR ',2A4,
     1       ', BUT IT IS NOT A COMPONENT OF',/32X,'THE PSEUDOSTRUCTURE'
     2,      ' BEING PROCESSED.  THE FIXED SET WILL BE IGNORED.')
  901 FORMAT (A25,' 6604, A BOUNDARY SET HAS BEEN SPECIFIED FOR ',2A4,
     1       ', BUT IT IS NOT A COMPONENT OF',/32X,'THE PSEUDOSTRUCTURE'
     2,      ' BEING PROCESSED.  THE BOUNDARY SET WILL BE IGNORED.')
  902 FORMAT (A23,' 6623, SUBSTRUCTURE ',2A4,
     1       ' HAS DUPLICATE NAMES IN BDYC DATA SET ',I8,1H.)
  903 FORMAT (1H0,43X,'SUMMARY OF COMBINED FIXED SET NUMBER ',I8, //57X,
     1       'BASIC      FIXED', /54X,'SUBSTRUCTURE  SET ID', /58X,
     2       'NAME      NUMBER',/)
  904 FORMAT (1H0,43X,'SUMMARY OF COMBINED BOUNDARY SET NUMBER ',I8,
     1       //57X,'BASIC      BOUNDARY', /54X,'SUBSTRUCTURE   SET ID',
     2       /58X,'NAME       NUMBER',/)
  905 FORMAT (56X,2A4,3X,I8)
  906 FORMAT (56X,2A4,4X,I8)
  907 FORMAT (A25,' 6621, FIXED SET',I9,' SPECIFIED IN CASE CONTROL ',
     1       'HAS NOT BEEN DEFINED BY BULK DATA.')
  908 FORMAT (A25,' 6606, BOUNDARY SET',I9,' SPECIFIED IN CASE CONTROL',
     1       ' HAS NOT BEEN DEFINED BY BULK DATA.')
  909 FORMAT (A23,' 6603, A BOUNDARY SET MUST BE SPECIFIED FOR A REDUCE'
     1,      ' OPERATION.')
C
      RETURN
      END

      SUBROUTINE NRLSUM
C
C     NRLSUM   OES2,OEF2/NRLSTR,NRLFOR/V,N,NMODES/V,N,NSHOCK(NDIR)/
C              C,Y,DIRECT=123/C,Y,SQRSS=0 $
C
C     NRLSUM COMPUTES NRL SUM STRESSES AND FORCES FOR DDAM. IT IS
C     ASSUMED THAT THE USER HAS REQUESTED STRESSES AND FORCES IN SORT2
C     FORMAT (BUT RESULTS WILL BE SORT1). NRLSUM READS ITEMS FOR AN
C     ELEMENT (FOR ALL SUBCASES) AND COMPUTES THE NRL SUM.  UP TO 3
C     SCRATCH FILES ARE USED TO STORE THE SUMS FOR EACH SHOCK DIRECTION.
C     PRINCIPAL STRESSES WILL BE COMPUTED BASED ON THE SUMS. THE NUMBER
C     OF SUBCASES IS NMODES*NSHOCK WITH THE ORDER 1-NMODES,
C     NMODES+1 - 2*NMODES, ... NSHOCK*NMODES.
C
C     (IF (SQRSS.EQ.1), SQUARE ROOT OF THE SUM OF THE SQUARES IS USED
C     INSTEAD OF NRL SUM
C
      INTEGER         FILE,BUF1,BUF2,BUF3,BUF4,OES2,SYSBUF,ELTYPE,SCR1,
     1                SCR2,SCR3,ELID,OLDTYP,SCR(3),
     2                OEF2,OFIL,IDIR(2),INUM(3),NSUB(3),DIRECT,SQRSS
      DIMENSION       SIG(6),SIGP(3),SMAT(3,3),DCOS(3,3)
      DIMENSION       Z(20),NAM(2),STRESS(146),ISTRES(146),MCB(7)
      COMMON /SYSTEM/ SYSBUF
      COMMON /BLANK / NMODES,NSHOCK,DIRECT,SQRSS
      COMMON /ZZZZZZ/ IZ(1)
      EQUIVALENCE    (Z(1),IZ(1)), (STRESS(1),ISTRES(1))
      EQUIVALENCE    (SIGP(1),SA), (SIGP(2),SB), (SIGP(3),SC)
      EQUIVALENCE    (SIG(1) ,SX), (SIG(2) ,SY), (SIG(3) ,SZ),
     1               (SIG(4),SXY), (SIG(5),SYZ), (SIG(6),SZX)
      DATA    OES2  , NRLSTR,SCR1,SCR2,SCR3 / 101,201,301,302,303/
      DATA    OEF2  , NRLFOR /102,202 /
      DATA    SCR   / 301,302,303     /
      DATA    IDIR  / 4HDIRE,4HCTIO   /
      DATA    INUM  / 4HN 1 ,4HN 2 ,4HN 3 /
      DATA    DTOR  / 0.0174532925E0  /
      DATA    NAM   / 4HNRLS,4HUM     /, I0 / 0 /
C
      LCORE= KORSZ(Z)
      BUF1 = LCORE- SYSBUF + 1
      BUF2 = BUF1 - SYSBUF
      BUF3 = BUF2 - SYSBUF
      BUF4 = BUF3 - SYSBUF
      IF (NSHOCK .EQ. 3) GO TO 20
      IF (NSHOCK .EQ. 2) GO TO 10
      BUF4 = BUF2
      BUF3 = BUF2
      GO TO 20
C
   10 BUF4 = BUF3
C
   20 LCORE = BUF4 - 1
      IF (LCORE .LE. 0) GO TO 1008
      NDIR = NSHOCK
      IF (NDIR  .GT. 1) GO TO 11
      NSUB(1) = DIRECT
      GO TO 14
   11 IF (NDIR   .GT.  2) GO TO 13
      IF (DIRECT .EQ. 23) GO TO 12
      NSUB(1) = 1
      NSUB(2) = 2
      IF (DIRECT .EQ. 13) NSUB(2) = 3
      GO TO 14
   12 NSUB(1) = 2
      NSUB(2) = 3
      GO TO 14
   13 NSUB(1) = 1
      NSUB(2) = 2
      NSUB(3) = 3
   14 CONTINUE
      IFIL = OES2
      OFIL = NRLSTR
C
   15 FILE = IFIL
      OLDTYP = 0
      CALL OPEN (*710,IFIL,Z(BUF1),0)
      CALL FWDREC (*1002,IFIL)
      CALL GOPEN (SCR1,Z(BUF2),1)
      IF (NSHOCK .GT. 1) CALL GOPEN (SCR2,Z(BUF3),1)
      IF (NSHOCK .EQ. 3) CALL GOPEN (SCR3,Z(BUF4),1)
C
   30 CALL READ (*410,*1003,IFIL,STRESS,146,1,IWORDS)
      ELTYPE= ISTRES(3)
      NWDS  = ISTRES(10)
      I5    = ISTRES(5)
      ELID  = ISTRES(5)/10
C
C     REFORMULATE TO SORT 1 FORMAT
C
      ISTRES(2) = 5
      IF (IFIL .EQ. OEF2) ISTRES(2) = 4
      ISTRES(141) = IDIR(1)
      ISTRES(142) = IDIR(2)
C
C     WRITE ONTO SCRATCH ONLY FOR NEW ELEMENT TYPE
C
      IF (ELTYPE .EQ. OLDTYP)  GO TO 45
      DO 35 I = 1,NSHOCK
      ISTRES(4) = I
      ISTRES(5) = I
      ISTRES(8) = I
      ISUB = NSUB(I)
      ISTRES(143) = INUM(ISUB)
      IF (OLDTYP .NE. 0) CALL WRITE (SCR(I),0,0,1)
      CALL WRITE (SCR(I),STRESS,146,1)
   35 CONTINUE
C
      OLDTYP = ELTYPE
C
C     READ STRESS INFO FOR NUMBER OF MODES AND SHOCK DIRECTIONS
C
      IF (NMODES*NWDS .GT. LCORE)  GO TO 1008
   45 DO 400 NS = 1,NSHOCK
      ISCR = 300 + NS
C
      CALL FREAD (IFIL,Z(1),NWDS*NMODES,0)
C
C     GO TO PROPER SECTION FOR EACH ELEMENT TYPE
C
C     FOR FORCES, COMPUTATIONS ARE EASIER. SO LETS NOT HAVE A COMPUTED
C     GO TO
C
      IF (IFIL .EQ. OES2) GO TO 46
C
      IF (ELTYPE.GE.20 .AND. ELTYPE.LE.33) GO TO 400
      IF (ELTYPE.GE.39 .AND. ELTYPE.LE.52) GO TO 400
      IF (ELTYPE.EQ.62 .OR.  ELTYPE.EQ.68 .OR. ELTYPE.EQ.69 .OR.
     1    ELTYPE.EQ.72) GO TO 400
      IF (ELTYPE.GE.65 .AND. ELTYPE.LE.67) GO TO 400
      IF (ELTYPE.EQ. 9 .OR.  ELTYPE.EQ.16 .OR. ELTYPE.EQ.73 .OR.
     1    ELTYPE.EQ.76) GO TO 400
      I3 = 1
      I2 = NWDS
      I1 = 2
      IF (ELTYPE.EQ.35 .OR.  ELTYPE.EQ.70 .OR. ELTYPE.EQ.71) I1 = 3
      GO TO 105
C
   46 CONTINUE
C
      GO TO ( 50, 60, 50, 70, 70, 80, 80, 80, 90, 50,
     1       100,100,100,400, 80, 90, 80, 80, 80,400,
     2       400,400,400,400,400,400,400,400,400,400,
     3       400,400,400,110,120,130,140,150,160,160,
     4       160,160,400,400,400,400,400,400,400,400,
     5       400,400,170,170,170,170,170,170,170,170,
     6       170, 90, 90, 80,220,220,220,400,400,180,
     7       190,400,200,200,200,210,400,400,400,400,
     8       400,400, 80), ELTYPE
C
C     ROD, TUBE, CONROD
C
   50 I1 = 2
      I2 = 4
      I3 = 2
      ASSIGN 55 TO IRET
      GO TO 390
C
C     IGNORE MARGINS OF SAFETY
C
   55 IZ(I0+3) = 1
      IZ(I0+5) = 1
      GO TO 395
C
C     BEAM
C
   60 I1 = 2
      I2 = 5
      I3 = 1
      ASSIGN 65 TO IRET
      GO TO 390
   65 Z(6) = Z(5) + AMAX1(Z(2),Z(3),Z(4))
      Z(7) = Z(5) + AMIN1(Z(2),Z(3),Z(4))
      IZ(I0+8) = 1
      I1 = 9
      I2 = 11
      I3 = 1
      ASSIGN 66 TO IRET
      GO TO 390
   66 Z(12) = Z(5) + AMAX1(Z(9),Z(10),Z(11))
      Z(13) = Z(5) + AMIN1(Z(9),Z(10),Z(11))
      IZ(I0+14) = 1
      GO TO 395
C
C     SHEAR
C
   70 I1 = 2
      I2 = 3
      I3 = 1
      ASSIGN 75 TO IRET
      GO TO 390
   75 IZ(I0+4) = 1
      GO TO 395
C
C     TRBSC, TRPLT, QDPLT, TRIA1, TRIA2, TRIA3, QUAD1, QUAD2, QUAD4
C
   80 I1 = 3
      I2 = 5
      I3 = 1
      J3 = 3
      J4 = 4
      J5 = 5
      J6 = 6
      J7 = 7
      J8 = 8
      J9 = 9
      ASSIGN 85 TO IRET
      GO TO 390
   85 SS = .5*(Z(J3) + Z(J4))
      ST = Z(J3) - Z(J4)
      SQ = SQRT(.25*ST**2 + Z(J5)**2)
      Z(J7) = SS + SQ
      Z(J8) = SS - SQ
      Z(J9) = SQ
      SD = 2.*Z(J5)
      IF (ABS(SD).LT.1.E-15 .AND. ABS(ST).LT.1.E-15) GO TO 87
      Z(J6) = ATAN2(SD,ST)*28.6478898
      GO TO 88
   87 Z(J6) = 0.
   88 IF (J3 .EQ. 11) GO TO 395
      IF (ELTYPE.EQ. 9 .OR. ELTYPE.EQ.16) GO TO 395
C                 TRMEM             QDMEM
      IF (ELTYPE.EQ.62 .OR. ELTYPE.EQ.63) GO TO 395
C                QDMEM1            QDMEM2
      IF (ELTYPE .EQ. 35) GO TO 125
C                  CONEAX
      I1 = 11
      I2 = 13
      I3 = 1
      J3 = 11
      J4 = 12
      J5 = 13
      J6 = 14
      J7 = 15
      J8 = 16
      J9 = 17
      GO TO 390
C
C     TRMEM, QDMEM,  QDMEM1, QDMEM2
C
   90 I1 = 2
      I2 = 4
      I3 = 1
      J3 = 2
      J4 = 3
      J5 = 4
      J6 = 5
      J7 = 6
      J8 = 7
      J9 = 8
      ASSIGN 85 TO IRET
      GO TO 390
C
C     CELAS1,2,3
C
  100 I1 = 2
      I2 = 2
      I3 = 1
  105 ASSIGN 395 TO IRET
      GO TO 390
C
C     BAR - ADD AXIAL STRESS TO EXTENSIONAL STRESSES DUE TO BENDING
C           BEFORE COMPUTING NRL SUMS. THEN ZERO OUT AXIAL STRESS
C           AND MAX AND MIN STRESSES
C
  110 I1 = 2
      I2 = 5
      I3 = 1
      DO 113 J = 1,NMODES
      ISUB = NWDS*(J-1)
      DO 111 I = 2,5
  111 Z(ISUB+I) = Z(ISUB+I)+Z(ISUB+6)
      DO 112 I = 10,13
  112 Z(ISUB+I) = Z(ISUB+I)+Z(ISUB+6)
  113 CONTINUE
      ASSIGN 115 TO IRET
      GO TO 390
  115 Z(6) = 0.
      Z(7) = 0.
      Z(8) = 0.
      IZ(I0+9) = 1
      I1   = 10
      I2   = 13
      I3   = 1
      ASSIGN 116 TO IRET
      GO TO 390
  116 Z(14) = 0.
      Z(15) = 0.
      IZ(I0+16) = 1
      GO TO 395
C
C     CONEAX
C
  120 I1 = 4
      I2 = 6
      I3 = 1
      J3 = 4
      J4 = 5
      J5 = 6
      J6 = 7
      J7 = 8
      J8 = 9
      J9 = 10
      ASSIGN 85 TO IRET
      GO TO 390
  125 IF (J3 .EQ. 12) GO TO 395
      I1 = 12
      I2 = 14
      I3 = 1
      J3 = 12
      J4 = 13
      J5 = 14
      J6 = 15
      J7 = 16
      J8 = 17
      J9 = 18
      GO TO 390
C
C     TRIARG
C
  130 I1 = 2
      I2 = 5
      I3 = 1
      GO TO 105
C
C     TRAPRG
C
  140 I1 = 2
      I2 = 21
      I3 = 1
      GO TO 105
C
C     TORDRG
C
  150 I1 = 2
      I2 = 16
      I3 = 1
      GO TO 105
C
C     TETRA, WEDGE, HEXA1, HEXA2
C
  160 I1 = 2
      I2 = 7
      I3 = 1
      ASSIGN 165 TO IRET
      GO TO 390
  165 Z(8) = SQRT((Z(2)-Z(3))**2 + (Z(3)-Z(4))**2 + (Z(4)-Z(2))**2 +
     1               6.*(Z(5)**2 + Z(6)**2 + Z(7)**2)) / 3.
      Z(9) = -(Z(2)+Z(3)+Z(4)) / 3.
      GO TO 395
C
C     DUM1 - DUM9
C
  170 I1 = 2
      I2 = 10
      I3 = 1
      GO TO 105
C
C     TRIAAX
C
  180 I1 = 3
      I2 = 11
      I3 = 1
      GO TO 105
C
C     TRAPAX
C
  190 I1 = 3
      I2 = 47
      I3 = 1
      GO TO 105
C
C     TRIM6, TRPLT1, TRSHL
C
  200 IEND = 8
      ISKIP= 8
      IF (ELTYPE .NE. 73) GO TO 201
      IEND = 4
      ISKIP= 7
  201 J2 = -5
      IJ = 0
  202 IJ = IJ + 1
      J2 = J2 + ISKIP
      J4 = J2 + 2
      I1 = J2
      I2 = J4
      I3 = 1
      ASSIGN 205 TO IRET
      GO TO 390
  205 SS = .5*(Z(J2)+Z(J2+1))
      ST = Z(J2) - Z(J2+1)
      SQ = SQRT(.25*ST**2 + Z(J4)**2)
      Z(J4+2) = SS + SQ
      Z(J4+3) = SS - SQ
      Z(J4+4) = SQ
      SD = 2.*Z(J4)
      IF (ABS(SD).LT.1.E-15 .AND. ABS(ST).LT.1.E-15) GO TO 206
      Z(J4+1) = ATAN2(SD,ST) * 28.6478898
      GO TO 207
  206 Z(J4+1) = 0.
  207 IF (IJ .LT. IEND) GO TO 202
      GO TO 395
C
C     IS2D8
C
  210 IJ = 0
      J2 = 1
  211 IJ = IJ + 1
      J2 = J2 + 5
      J4 = J2 + 2
      I1 = J2
      I2 = J4
      I3 = 1
      ASSIGN 215 TO IRET
      GO TO 390
  215 IF (IJ .LT. 8) GO TO 211
      GO TO 395
C
C     IHEX1,2,3
C
  220 I1 = 3
      I2 = 4
      I3 = 1
      ASSIGN 221 TO IRET
      GO TO 390
  221 I1 = 11
      IF (ELTYPE. EQ. 67) I1 = 12
C                   IHEX3
      I2 = I1+1
      ASSIGN 222 TO IRET
      GO TO 390
  222 I1 = I1 + 6
      I2 = I1 + 1
      ASSIGN 223 TO IRET
      GO TO 390
C
C     COMPUTE PRINCIPAL STRESSES
C
  223 SIG(1) = Z( 3)
      SIG(2) = Z(11)
      SIG(3) = Z(17)
      SIG(4) = Z( 4)
      SIG(5) = Z(12)
      SIG(6) = Z(18)
      IF (ELTYPE .NE. 67) GO TO 224
C                   IHEX3
      SIG(2) = Z(12)
      SIG(3) = Z(18)
      SIG(5) = Z(13)
      SIG(6) = Z(19)
  224 CONTINUE
C*****
C     SOLVE CUBIC EQUATION FOR PRINCIPAL STRESSES
C*****
C
C     S**3 + P*S**2 + Q*S + R = 0.0
C
C     REF. -- CRC STANDARD MATH TABLES 14TH ED., PP. 392,3
C
      RM = 0.0
      DO 262 I = 1,6
      IF (ABS(SIG(I)) .GT. RM) RM = ABS(SIG(I))
  262 CONTINUE
      IF (RM .LE. 0.0) GO TO 267
      THRESH = 1.0E-5
  264 DO 263 I = 1,6
      IF (ABS(SIG(I)/RM) .LT. THRESH) SIG(I) = 0.0
  263 CONTINUE
      RX = SX/RM
      RY = SY/RM
      RZ = SZ/RM
      RXY= SXY/RM
      RYZ= SYZ/RM
      RZX= SZX/RM
      P  =-RX - RY - RZ
      Q  = RX*RY + RY*RZ + RZ*RX - RXY**2 - RYZ**2 - RZX**2
      R  =-(RX*RY*RZ +2.0*RXY*RYZ*RZX -RX*RYZ**2 -RY*RZX**2 -RZ*RXY**2)
      A  = (3.0*Q - P**2)/3.0
      B  = (2.0*P**3 - 9.0*P*Q + 27.0*R)/27.0
      X  =-A**3/27.0
      IF (X .GT. 0.0) GO TO 270
C
C     CHECK FOR IMAGINARY ROOTS
C
      IF (ABS(X) .GT. RM*1.0E-6) GO TO 265
C
C     CHECK FOR 3 EQUAL ROOTS
C
      IF (ABS(B) .GT. 1.0E-6) GO TO 265
      X  = 0.0
      PHI= 0.0
      GO TO 275
  265 THRESH = 10.0*THRESH
      IF (THRESH .LT. 1.1E-3) GO TO 264
  267 SA = 0.0
      SB = 0.0
      SC = 0.0
      GO TO 280
  270 COSPHI =-(B/2.0)/SQRT(X)
      IF (ABS(COSPHI) .GT. 1.0) GO TO 265
      PHI= ACOS(COSPHI)
      X  = 2.0*SQRT(-A/3.0)
  275 SA = (X*COS(PHI/3.0)-P/3.0)*RM
      SB = (X*COS(PHI/3.0+120.0*DTOR)-P/3.0)*RM
      SC = (X*COS(PHI/3.0+240.0*DTOR)-P/3.0)*RM
      RM = 0.0
      DO 276 I = 1,3
      IF (ABS(SIGP(I)) .GT. RM) RM = ABS(SIGP(I))
  276 CONTINUE
      DO 277 I = 1,3
      IF (ABS(SIGP(I)/RM) .LT. 1.0E-5) SIGP(I) = 0.0
  277 CONTINUE
C*****
C     COMPUTE MEAN STRESS OR PRESSURE
C*****
  280 SN =-(SA+SB+SC)/3.0
C*****
C     COMPUTE OCTAHEDRAL SHEAR STRESS
C*****
      SO = SQRT(((SA+SN)**2 + (SB+SN)**2 + (SC+SN)**2)/3.0)
C*****
C     COMPUTE DIRECTION COSINES OF THE PRINCIPAL PLANES
C*****
      RM = 1.0E-6
      DO 600 I = 1,3
      IF (SIGP(I) .EQ. 0.0) GO TO 580
      SMAT(1,1) = 1.0 - SX/SIGP(I)
      SMAT(2,1) =-SXY/SIGP(I)
      SMAT(3,1) =-SZX/SIGP(I)
      SMAT(1,2) = SMAT(2,1)
      SMAT(2,2) = 1.0 - SY/SIGP(I)
      SMAT(3,2) =-SYZ/SIGP(I)
      SMAT(1,3) = SMAT(3,1)
      SMAT(2,3) = SMAT(3,2)
      SMAT(3,3) = 1.0 - SZ/SIGP(I)
      CALL SAXB (SMAT(1,1),SMAT(1,2),DCOS(1,I))
      RX = SADOTB(DCOS(1,I),DCOS(1,I))
      J  = 1
      CALL SAXB (SMAT(1,2),SMAT(1,3),DCOS(1,I))
      RY = SADOTB(DCOS(1,I),DCOS(1,I))
      IF (RY .GT. RX) J = 2
      CALL SAXB (SMAT(1,3),SMAT(1,1),DCOS(1,I))
      RZ = SADOTB(DCOS(1,I),DCOS(1,I))
      IF (RZ.GT.RY .AND. RZ.GT.RX) J = 3
      P = SMAT(1,J)
      Q = SMAT(2,J)
      R = SMAT(3,J)
      IF (J-2) 450,460,470
  450 J = 2
      GO TO 480
  460 J = 3
      GO TO 480
  470 J = 1
  480 S = SMAT(1,J)
      T = SMAT(2,J)
      V = SMAT(3,J)
      IF (ABS(Q)  .LE. RM) GO TO 500
      RX = V - T*R/Q
      IF (ABS(RX) .LE. RM) GO TO 490
      RZ =-(S - T*P/Q)/RX
      RY =-(P + R*RZ)/Q
  485 X  = 1.0 + RZ*RZ + RY*RY
      DCOS(1,I) = 1.0/SQRT(X)
      DCOS(2,I) = RY*DCOS(1,I)
      DCOS(3,I) = RZ*DCOS(1,I)
      GO TO 600
  490 RX = S - T*P/Q
      IF (ABS(RX) .LE. RM) GO TO 580
      RY =-R/Q
      X  = 1.0 + RY*RY
      DCOS(1,I) = 0.0
      DCOS(3,I) = 1.0/SQRT(X)
      DCOS(2,I) = RY*DCOS(3,I)
      GO TO 600
  500 IF (ABS(R) .LE. RM) GO TO 520
      RZ = -P/R
      IF (ABS(T) .LE. RM) GO TO 510
      RY =-(S - V*P/R)/T
      GO TO 485
  510 IF (ABS(S-V*P/R) .LE. RM) GO TO 580
      DCOS(1,I) = 0.0
      DCOS(2,I) = 1.0
      DCOS(3,I) = 0.0
      GO TO 600
  520 IF (ABS(P) .LE. RM) GO TO 580
      IF (ABS(V) .LE. RM) GO TO 530
      RZ =-T/V
      X  = 1.0 + RZ*RZ
      DCOS(1,I) = 0.0
      DCOS(2,I) = 1.0/SQRT(X)
      DCOS(3,I) = RZ*DCOS(2,I)
      GO TO 600
  530 IF (ABS(T) .LE. RM) GO TO 580
      DCOS(1,I) = 0.0
      DCOS(2,I) = 0.0
      DCOS(3,I) = 1.0
      GO TO 600
  580 DCOS(1,I) = 0.0
      DCOS(2,I) = 0.0
      DCOS(3,I) = 0.0
  600 CONTINUE
      IPTS = 0
      IF (ELTYPE .EQ. 67) IPTS = 1
C                   IHEX3
      Z(5) = SA
      Z(9) = SN
      Z(10)= SO
      Z(IPTS+13) = SB
      Z(IPTS+19) = SC
      DO 610 I = 1,3
      Z(      5+I) = DCOS(1,I)
      Z(IPTS+13+I) = DCOS(2,I)
      Z(IPTS+19+I) = DCOS(3,I)
  610 CONTINUE
      GO TO 395
C
C     PERFORM NRL SUMS
C
  390 DO 393 I = I1,I2,I3
      SUM  = 0.
      RMAX = 0.
      DO 392 J = 1,NMODES
      ISUB = NWDS*(J-1) + I
      SUM  = SUM + Z(ISUB)**2
      IF (ABS(Z(ISUB)) .GT. RMAX) RMAX = ABS(Z(ISUB))
  392 CONTINUE
      IF (SQRSS .EQ. 1) RMAX = 0.
      SUM = SUM  - RMAX**2
      SUM = RMAX + SQRT(SUM)
      Z(I)= SUM
  393 CONTINUE
C
      GO TO IRET, (55,65,66,75,85,115,116,165,205,215,221,222,223,395)
C
C     WRITE NRL SUMS TO APPROPRIATE SCRATCH FILE
C
  395 IZ(1) = I5
      CALL WRITE (ISCR,Z,NWDS,0)
C
  400 CONTINUE
C
C     DONE WITH THIS ELEMENT.  SINCE WE ARE WRITING IN SORT1, EOR IS
C     NEEDED ON SCRATCH FILE ONLY IF ELEMENT TYPE CHANGES.  THIS WILL BE
C     CHECKED ABOVE.  SKIP EOR ON OES2 AND GO BACK.
C
      FILE = IFIL
      CALL FWDREC (*1002,IFIL)
      GO TO 30
C
C     EOF ON OES2.  WRITE EOR ON SCRATCH FILE AND COPY THEM TO OUTPUT
C     DATA BLOCK.
C
  410 CALL CLOSE (IFIL,1)
C
      DO 415 I = 2,7
  415 MCB(I) = 1
      DO 420 I = 1,NSHOCK
      CALL WRITE (SCR(I),0,0,1)
      CALL CLOSE (SCR(I),1)
      MCB(1) = SCR(I)
      CALL WRTTRL (MCB)
  420 CONTINUE
C
      LCORE = BUF2 - 1
      CALL GOPEN (OFIL,Z(BUF1),1)
      DO 700 I = 1,NSHOCK
      CALL GOPEN (SCR(I),Z(BUF2),0)
C
  430 CALL READ (*690,*440,SCR(I),Z,LCORE,0,IWORDS)
      CALL WRITE (OFIL,Z,LCORE,0)
      GO TO 430
C
C     EOR
C
  440 CALL WRITE (OFIL,Z,IWORDS,1)
      GO TO 430
C
C     EOF
C
  690 CALL CLOSE (SCR(I),1)
C
  700 CONTINUE
C
      CALL CLOSE (OFIL,1)
      MCB(1) = OFIL
      CALL WRTTRL (MCB)
C
C     GO BACK FOR FORCES
C
  710 IF (IFIL .EQ. OEF2) RETURN
      IFIL = OEF2
      OFIL = NRLFOR
      GO TO 15
C
 1002 N = -2
      GO TO 1010
 1003 N = -3
      GO TO 1010
 1008 N = -8
      FILE = 0
 1010 CALL MESAGE (N,FILE,NAM)
      RETURN
      END

      SUBROUTINE TA1CPS
C
C     G3 MATRIX CALCULATION WITH NEW FORMULATION
C
C     THIS ROUTINE IS CALLED IN TA1 IF PARAM COMPS IS SET TO -1
C     INDICATING PCOMP, PCOMP1 OR PCOMP2 BULK DATA ENTRIES ARE
C     PRESENT. IT'S PRIMARY FUNCTION IS TO -
C       1. CREATE FILE PCOMPS WHICH WILL CONTAIN THE ECHO OF THE
C          'PCOMPS' ENTRIES ALONG WITH INDIVIDUAL LAYER INTRINISIC
C          PROPERTY MATRICES.
C       2. CALCULATE OVERALL MATERIAL PROPERTIES IN THE FORM OF MAT2
C          ENTRIES AND WRITE TO FILE MPTX.
C       3. GENERATE EQUIVALENT PSHELL PROPERTY ENTRIES AND WRITE TO
C          FILE EPTX.
C
      EXTERNAL        ANDF,ORF
      LOGICAL         OK UAI
      INTEGER         PCOMP(2),PCOMP1(2),PCOMP2(2),COMPS,PCBIT(3),EPTX,
     1                PSHLPR,EPTWDS,PSHBIT,RD,RDREW,WRT,WRTREW,CLSREW,
     2                CLS,IPSHEL(17),PSHNAM(3),PCOMPR,TYPC,TYPC1,TYPC2,
     3                FLAG,EPT,PCOMPS,EOF,ELID,PIDLOC,EOELOC,SYM,SYMMEM,
     4                EOE,SYSBUF,POS,POS1,Z,BUF0,BUF1,BUF2,BUF3,BUF4,
     5                BUF5,FILE,INDEX(6,3),INDEXX(3,3),ANDF,ORF,BLANK
      REAL            GLAY(25),GMEMBR(17),GBENDG(17),GMEMBD(17),
     1                GTRSHR(17),EXX,EYY,EIXX,EIYY,ZX,ZY,RPSHEL(17),
     2                ALFA1,ALFA2,ALFA12,TREF,GSUBE
      REAL            THETA,THETAR,C,C2,C4,S,S2,S4,PI,TWOPI,RADDEG,
     1                DEGRAD,T(9),GT(9),GBR(9),GBAR(3,3),G(25),GD(9),
     2                GDT(9),GDBR(9),GDBAR(3,3),GD2(3,3),U(9),G3I(9),
     3                G3IU(9),G3BR(9),G3BAR(3,3),G1(3,3),G2(3,3),
     4                G3(2,2),G4(3,3),TLAM,ZK,ZK1,ZREF,ZG1,ZG2,ZG4,ZI,
     5                TI,RHO,DETRMN,CONST,ZBARX,ZBARY,TRFLX(2,2),ZBARXT,
     6                ZBARXB,ZBARYT,ZBARYB,ZBAR(2),GTRFLX(2,2),GD4(3,3),
     7                G3INVD(2,2),EX,EY,E(2),FI(2),FII(2),RI(2),DETERM,
     8                DUM(6),DUMMY(3),STIFF(6,6),EI(2),GD1(3,3),EPSI
      DIMENSION       RZ(1),NPCMP(3),NPCMP1(3),NPCMP2(3),NAM(2),NAM1(2),
     1                NAM2(2),MATNAM(3),IPCOMP(7),IMEMBR(17),IBENDG(17),
     2                IMEMBD(17),ITRSHR(17),IMPTX(7),IEPTX(7)
      COMMON /BLANK / LUSET ,NOSIMP,NOSUP ,NOGENL,GENL  ,COMPS
      COMMON /TA1COM/ NSIL  ,ECT   ,EPT   ,BGPDT ,SIL   ,GPTT  ,CSTM  ,
     1                MPT   ,EST   ,GEI   ,GPECT ,ECPT  ,GPCT  ,MPTX  ,
     2                PCOMPS,EPTX  ,SCR1  ,SCR2  ,SCR3  ,SCR4
      COMMON /NAMES / RD    ,RDREW ,WRT   ,WRTREW,CLSREW,CLS
      COMMON /SYSTEM/ SYSBUF,NOUT  ,NOGO  ,DM(20),ICFIAT
      COMMON /MATIN / MATID ,INFLAG,ELTEMP
      COMMON /MATOUT/ RMTOUT(25)
      COMMON /ZZZZZZ/ Z(1)
      COMMON /CONDAS/ PI    ,TWOPI ,RADDEG,DEGRAD
      COMMON /TWO   / TWO(32)
      EQUIVALENCE     (Z(1)     ,RZ(1)    ), (IPSHEL(1),RPSHEL(1)),
     1                (IMEMBR(1),GMEMBR(1)), (IBENDG(1),GBENDG(1)),
     2                (IMEMBD(1),GMEMBD(1)), (ITRSHR(1),GTRSHR(1))
C     DATA    MPT   / 107/
C     DATA    MPTX  / 206/
C     DATA    PCOMPS/ 207/
C     DATA    EPTX  / 208/
      DATA    PCOMP / 5502,55/
      DATA    PCOMP1/ 5602,56/
      DATA    PCOMP2/ 5702,57/
      DATA    NPCMP / 5502,55,280/
      DATA    NPCMP1/ 5602,56,281/
      DATA    NPCMP2/ 5702,57,282/
      DATA    PSHNAM/ 5802,58,283/
      DATA    MATNAM/ 203, 2, 78 /
      DATA    PCBIT / 55, 56, 57 /
      DATA    PSHBIT/ 58 /
      DATA    MT2BIT/ 2  /
      DATA    I1ST  / 1  /
      DATA    SYM   / 1  /
      DATA    MEM   / 2  /
      DATA    SYMMEM/ 3  /
      DATA    EOE   / -1 /
      DATA    NAM   / 4HTA1C, 4HPS   /
      DATA    NAM2  / 4HPCOM, 4HPS   /
      DATA    BLANK / 4HBLNK         /
      DATA    OK UAI/ .TRUE.         /
      DATA    EPSI  / 1.0E-15        /
C
      BUF0 = KORSZ(Z) - SYSBUF - 2
      BUF1 = BUF0 - SYSBUF - 2
      BUF2 = BUF1 - SYSBUF - 2
      BUF3 = BUF2 - SYSBUF - 2
      BUF4 = BUF3 - SYSBUF - 2
      BUF5 = BUF4 - SYSBUF - 2
C
C     PERFORM GENERAL INITILIZATION
C
      MATWDS = 0
      EOF    = 0
      ELID   = 0
      MAT2PR = 0
      PSHLPR = 0
      ICOUNT = 0
      RHO    = 0.0
C
C     OPEN EPTX AND WRITE HEADER RECORD
C
      FILE = EPTX
      CALL OPEN (*1200,EPTX,Z(BUF0),WRTREW)
      CALL FNAME (EPTX,NAM1)
      CALL WRITE (EPTX,NAM1,2,1)
C
C     OPEN MPTX AND WRITE HEADER RECORD
C
      FILE = MPTX
      CALL OPEN (*1200,MPTX,Z(BUF1),WRTREW)
      CALL FNAME (MPTX,NAM1)
      CALL WRITE (MPTX,NAM1,2,1)
C
C     OPEN MPT AND POSITION FILE
C
      FILE = MPT
      CALL OPEN (*1200,MPT,Z(BUF2),RDREW)
      CALL FWDREC (*1200,MPT)
C
C     OPEN PCOMPS AND WRITE HEADER RECORD
C     WRITE TO IPCOMP(1), THE GINO FILE NAME OF PCOMPS
C
      FILE = PCOMPS
      CALL OPEN (*1200,PCOMPS,Z(BUF3),WRTREW)
      CALL WRITE (PCOMPS,NAM2,2,1)
C
      IPCOMP(1) = PCOMPS
      DO 10 LL = 2,7
   10 IPCOMP(LL) = 0
C
C     COPY ALL EPT ENTRIES UP TO PSHELL TYPE TO FILE EPTX
C     IF NONE FOUND, MUST CREATE ONE BEFORE THE LAST RECORD IN FILE
C
C     SET AVAILABLE CORE
C
      N    = BUF5 - 1
      IEPT = I1ST
      FILE = EPT
      CALL OPEN (*1200,EPT,Z(BUF4),RDREW)
      CALL FWDREC (*1200,EPT)
      IREC = 0
   20 CALL FWDREC (*30,EPT)
      IREC = IREC + 1
      GO TO 20
C
   30 CALL REWIND (EPT)
      CALL FWDREC (*1200,EPT)
      IRED = 0
   40 CALL READ (*1200,*50,EPT,Z(IEPT),N,1,EPTWDS)
      CALL MESAGE (-8,0,NAM)
   50 IF (Z(IEPT) .EQ. 4902) GO TO 60
      IRED = IRED + 1
      IF (IRED .EQ. IREC) GO TO 70
      CALL WRITE (EPTX,Z(IEPT),EPTWDS,1)
      EPTWDS = 0
      GO TO 40
C
   60 PSHLPR = 1
   70 CALL BCKREC (EPT)
      CALL SAVPOS (EPT,POS1)
      CALL CLOSE (EPT,CLSREW)
C
C     OPEN EPT
C
      FILE = EPT
      CALL PRELOC (*1200,Z(BUF4),EPT)
C
C     COPY ALL MAT ENTRIES UP TO MAT2 TYPE TO FILE MPTX
C
C     SET AVAILABLE CORE
C
      N = BUF5 - 1
      IMAT = I1ST
   80 CALL READ (*110,*90,MPT,Z(IMAT),N,1,MATWDS)
      CALL MESAGE (-8,0,NAM)
   90 IF (Z(IMAT) .GE. 203) GO TO 100
      CALL WRITE (MPTX,Z(IMAT),MATWDS,1)
      MATWDS = 0
      GO TO 80
  100 CALL BCKREC (MPT)
      CALL SAVPOS (MPT,POS)
      IF (Z(IMAT) .EQ. 203) MAT2PR = 1
      GO TO 120
C
C    SET END OF FILE FLAG
C
  110 EOF = 1
C
C     CLOSE MPT BEFORE CALLING PREMAT
C
  120 CALL CLOSE (MPT,1)
C
C     SET POINTERS AND PERFORM INITILIZATION
C
      IPC1  = 1
      NPC   = 0
      NPC1  = 0
      NPC2  = 0
      TYPC  = 0
      TYPC1 = 0
      TYPC2 = 0
C
C     SET SIZE OF AVAILABLE CORE
C
      N   = BUF5 - 1
      IPC = 1
C
C     LOCATE PCOMP DATA AND READ INTO CORE
C
      CALL LOCATE (*140,Z(BUF4),PCOMP,FLAG)
C
      CALL READ (*1200,*130,EPT,Z(IPC),N,0,NPC)
      CALL MESAGE (-8,0,NAM)
  130 IF (NPC .GT. 0) TYPC = 1
      IPC1 = IPC + NPC
      IF (IPC1 .GE. BUF5) CALL MESAGE (-8,0,NAM)
      N = N - NPC
C
C     LOCATE PCOMP1 DATA AND READ INTO CORE
C
  140 CALL LOCATE (*160,Z(BUF4),PCOMP1,FLAG)
C
      IPC1 = IPC + NPC
      CALL READ (*180,*150,EPT,Z(IPC1),N,0,NPC1)
      CALL MESAGE (-8,0,NAM)
  150 IF (NPC1 .GT. 0) TYPC1 = 1
      IPC2 = IPC1 + NPC1
      IF (IPC2 .GE. BUF5) CALL MESAGE (-8,0,NAM)
      N = N - NPC1
C
C     LOCATE PCOMP2 DATA AND READ INTO CORE
C
  160 CALL LOCATE(*180,Z(BUF4),PCOMP2,FLAG)
C
      IPC2 = IPC1 + NPC1
      CALL READ (*180,*170,EPT,Z(IPC2),N,0,NPC2)
      CALL MESAGE (-8,0,NAM)
  170 IF (NPC2 .GT. 0) TYPC2 = 1
C
C     SET SIZE OF LPCOMP. NUMBER OF WORDS READ INTO CORE
C
  180 LPCOMP = IPC + NPC + NPC1 + NPC2
      IF (LPCOMP .GE. BUF5) CALL MESAGE (-8,0,NAM)
C
C     CLOSE EPT BEFORE PROCESSING PCOMPI
C
      CALL CLOSE (EPT,1)
C
C     READ MATERIAL PROPERTY TABLE INTO CORE
C
      IMAT  = LPCOMP + 1
      N1MAT = BUF5 - IMAT
      CALL PREMAT (Z(IMAT),Z(IMAT),Z(BUF5),N1MAT,N2MAT,MPT,DIT)
      IF (IMAT+N2MAT .GE. BUF5) CALL MESAGE (-8,0,NAM)
      ICORE = IMAT + N2MAT + 1
C
C     SET POINTERS
C
      ITYPE  =-1
      ISTART = 0
      IFINIS = 0
C
C     PROCESS ALL 'PCOMP' ENTRY TYPES SEQUENTIALLY
C
C     PCOMP ENTRIES
C
      IF (TYPC .EQ. 0) GO TO 190
      ITYPE  = 0
      ISTART = IPC
      IFINIS = IPC1 - 1
      NWDPC  = 8
      KPC    = 4
      PCOMPR = 1
      GO TO 220
C
C     PCOMP1 ENTRIES
C
  190 IF (TYPC1 .EQ. 0) GO TO 200
      ITYPE  = 1
      ISTART = IPC1
      IFINIS = IPC2 - 1
      NWDPC  = 8
      KPC    = 1
      PCOMPR = 1
      GO TO 220
C
C     PCOMP2 ENTRIES
C
  200 IF (TYPC2 .EQ. 0) GO TO 210
      ITYPE  = 2
      ISTART = IPC2
      IFINIS = LPCOMP - 1
      NWDPC  = 8
      KPC    = 2
C
C     CHECK IF NO PCOMP DATA HAS BEEN READ INTO CORE
C
  210 IF (TYPC.EQ.0 .AND. TYPC1.EQ.0 .AND. TYPC2.EQ.0) GO TO 1210
C
C     SET INFLAG = 12, SO THAT FOR LAMINA REFERENCING MAT1 OR MAT2
C     PROPERTY ENTRY WILL BE RETURNED IN MAT2 FORMAT. EXECPT FOR
C     THOSE REFERENCING MAT8 PROPERTY, IN WHICH CASE THE ENTRY
C     IS MERELY ECHOED.
C
  220 INFLAG = 12
C
C     SET POINTERS
C
C     WRITE 3-WORD IDENTITY FOR PCOMP DATA
C
C     PCOMP TYPE
C
      IF (ITYPE .NE. 0) GO TO 230
      CALL WRITE (PCOMPS,NPCMP,3,0)
      GO TO 250
C
C     PCOMP1 TYPE
C
  230 IF (ITYPE .NE. 1) GO TO 240
      CALL WRITE (PCOMPS,NPCMP1,3,0)
      GO TO 250
C
C     PCOMP2 TYPE
C
  240 CALL WRITE (PCOMPS,NPCMP2,3,0)
C
C     PROCESS ALL 'PCOMP' ENTRIES
C
  250 LEN    = 0
      NLAY   = 0
      EOELOC = 0
      PIDLOC = 1
      TLAM   = 0.0
      RHO    = 0.0
      ZK     = 0.0
      ZK1    = 0.0
      TREF   = 0.0
      GSUBE  = 0.0
      ALFA1  = 0.0
      ALFA2  = 0.0
      ALFA12 = 0.0
C
      DO 260 II = ISTART,IFINIS
      IF (Z(II) .EQ. -1) GO TO 270
  260 CONTINUE
C
  270 EOELOC = II
      PIDLOC = ISTART
      LEN    = EOELOC - PIDLOC
      NLAY   = (LEN - NWDPC)/KPC
      LAMOPT = Z(PIDLOC+7)
C
C     DETERMINE LAMINATE THICKNESS
C
C     PCOMP DATA
C
      IF (ITYPE .GT. 0) GO TO 290
      DO 280 K = 1,NLAY
      IIK  = (PIDLOC+5) + 4*K
      TLAM = TLAM + RZ(IIK)
  280 CONTINUE
      IF (LAMOPT.EQ.SYM .OR. LAMOPT.EQ.SYMMEM) TLAM = 2.0*TLAM
      GO TO  320
C
C     PCOMP1 DATA
C
  290 IF (ITYPE .GT. 1) GO TO 300
      IIK  = PIDLOC + 6
      TLAM = RZ(IIK)*NLAY
      IF (LAMOPT.EQ.SYM .OR. LAMOPT.EQ.SYMMEM) TLAM = 2.0*TLAM
      GO TO 320
C
C     PCOMP2 DATA
C
  300 DO 310 K = 1,NLAY
      IIK  = (PIDLOC+6) + 2*K
      TLAM = TLAM + RZ(IIK)
  310 CONTINUE
      IF (LAMOPT.EQ.SYM .OR. LAMOPT.EQ.SYMMEM) TLAM = 2.0*TLAM
C
C     WRITE TO PCOMPS
C      1. PID
C      2. NLAY - NUMBER OF LAYERS
C      3. REMAINDER OF PCOMP ENTRY
C
  320 CALL WRITE (PCOMPS,Z(PIDLOC),1,0)
      CALL WRITE (PCOMPS,NLAY,1,0)
C
C     SET LEN TO THE NO. WORDS TO BE WRITTEN TO PCOMPS
C
      LEN = LEN - 1
      CALL WRITE (PCOMPS,Z(PIDLOC+1),LEN,0)
C
C     CALL MAT TO GET LAYER PROPERTIES AND WRITE TO PCOMPS
C     NOTE FOR PCOMP1 AND PCOMP2 ENTRIES THE PROPERTY MATRIX
C     IS ONLY WRITTEN TO PCOMPS ONCE. (ALL LAYER PER ENTRY HAVE
C     THE SAME MID.
C     SIMILARILY FOR PCOMP ENTRY, IF ALL LAYERS REFERENCE THE SAME
C     MID, THEN THE PROPERTY MATRIX IS ONLY WRITTEN ONCE TO PCOMPS.
C
C          ITYPE = 0 PCOMP  ENTRY
C          ITYPE = 1 PCOMP1 ENTRY
C          ITYPE = 2 PCOMP2 ENTRY
C
      MID = 0
C
C     INITIALIZE G1, G2, G3 AND G4 MATRICES
C
      DO 330 LL = 1,3
      DO 330 MM = 1,3
      G1 (LL,MM) = 0.0
      GD1(LL,MM) = 0.0
      G2 (LL,MM) = 0.0
      GD2(LL,MM) = 0.0
      G4 (LL,MM) = 0.0
      GD4(LL,MM) = 0.0
  330 CONTINUE
C
      DO 340 LL = 1,2
      FII(LL)  = 0.0
      FI(LL)   = 0.0
      RI(LL)   = 0.0
      ZBAR(LL) = 0.0
      DO 340 MM = 1,2
      G3(LL,MM) = 0.0
      GTRFLX(LL,MM) = 0.0
      TRFLX(LL,MM)  = 0.0
      G3INVD(LL,MM) = 0.0
  340 CONTINUE
C
C     INTILIZISE ZBAR
C
      ZBARX   = 0.0
      ZBARY   = 0.0
      ZBARXT  = 0.0
      ZBARXB  = 0.0
      ZBARYT  = 0.0
      ZBARYB  = 0.0
      ZX      = 0.0
      ZY      = 0.0
C
      EIXX    = 0.0
      EIYY    = 0.0
C
C     LOOP OVER LAYERS
C
      DO 500 K = 1,NLAY
      IF (ITYPE .EQ. 0) MATID = Z(PIDLOC+4+4*K)
      IF (ITYPE.EQ.1 .OR. ITYPE.EQ.2) MATID = Z(PIDLOC+5)
      IF (K.GE.2 .AND. (ITYPE.EQ.0 .AND. MID.EQ.MATID)) GO TO 410
      IF (K.GE.2 .AND. (ITYPE.EQ.1 .OR.  ITYPE.EQ.2)  ) GO TO 420
C
      MID = MATID
      CALL MAT (ELID)
C
C     CALL LPROPS TO GET LAYER PROPERTY MATRICES
C
      CALL LPROPS (G)
C
C     COPY G(25) TO GLAY(25), FOR WRITING TO PCOMPS
C
      DO 400 KK = 1,25
  400 GLAY(KK) = G(KK)
C
C     NEX 20 LINES ARE NEW FROM 2/90 UAI CODE
C     COPY ALFA1, ALFA2 AND ALFA12 FROM GLAY(14 THRU 16)
C
      IF (.NOT.OK UAI) GO TO 410
      ALFA1  = GLAY(14)
      ALFA2  = GLAY(15)
      ALFA1  = GLAY(16)
C
C     IF PCOMP, COPY TREF AND GE FROM THE MAIN CARD TO MATERIAL
C     PROPERTY DATA. THIS IS DONE FOR THE FIRST LAYER
C
      IF (K     .EQ. 1) GO TO 410
      IF (ITYPE .GE. 1) GO TO 405
      TREF  = RZ(PIDLOC+5)
      GSUBE = RZ(PIDLOC+6)
      GLAY(24) = TREF
      GLAY(25) = GSUBE
      GO TO 410
  405 TREF  = GLAY(24)
      GSUBE = GLAY(25)
C
C     WRITE THE LAYER PROPERTY MATRIX G TO FILE PCOMPS
C
  410 CALL WRITE (PCOMPS,GLAY(1),25,0)
C
C     CALCULATE CONTRIBUTION OF EACH LAYER TO OVERALL PROPERTY
C     MATRICES G1, G2, G4
C
C     BUILD TRANSFORMATION MATRIX T
C
  420 IF (ITYPE .EQ. 0) THETA = RZ(PIDLOC+6+4*K)
      IF (ITYPE .EQ. 1) THETA = RZ(PIDLOC+7+  K)
      IF (ITYPE .EQ. 2) THETA = RZ(PIDLOC+7+2*K)
      C = ABS(THETA)
      IF (C .LT. 0.000002) C = 0.0
      IF (C.GT.89.99998 .AND. C.LT.90.00002) C =  90.0
      IF (C.GT.179.9998 .AND. C.LT.180.0002) C = 180.0
      IF (C.GT.269.9998 .AND. C.LT.270.0002) C = 270.0
      IF (C.GT.359.9998 .AND. C.LT.360.0002) C = 360.0
      IF (THETA .LT. 0.0) C = -C
      THETAR = C*DEGRAD
C
      C  = COS(THETAR)
      IF (ABS(C) .LT. EPSI) C = 0.0
      C2 = C*C
      C4 = C2*C2
      S  = SIN(THETAR)
      IF (ABS(S) .LT. EPSI) S = 0.0
      S2 = S*S
      S4 = S2*S2
C
      T(1) = C2
      T(2) = S2
      T(3) = C*S
      T(4) = S2
      T(5) = C2
      T(6) =-C*S
      T(7) =-2.0*C*S
      T(8) = 2.0*C*S
      T(9) = C2 - S2
C
C     CALCULATE GBAR = TT X G X T
C
C     MULTIPLY G X T AND WRITE TO GT
C
      CALL GMMATS (G(1),3,3,0, T(1),3,3,0, GT(1))
C
C     MULTIPLY TT X GT AND WRITE TO GBR
C
      CALL GMMATS (T(1),3,3,1, GT(1),3,3,0, GBR(1))
C
C     WRITE GBR IN TWO DIMENSIONED ARRAY GBAR
C
      DO 430 LL = 1,3
      DO 430 MM = 1,3
      NN = MM + 3*(LL-1)
      GBAR(LL,MM) = GBR(NN)
  430 CONTINUE
C
C     PROCESSING FOR G3 MATRIX
C
C     CALCULATE GDBAR = TT X GD X T
C
C     DETERMINE GD MATRIX, WHICH IS EQUAL TO G MATRIX WITH POISSONS
C     RATIO=0.0
C        GD(1) ---- YOUNGS MODULUS IN X-DIRN
C        GD(5) ---- YOUNGS MODULUS IN Y-DIRN
C        GD(9) ---- INPLANE SHEAR MODULUS
C
      DO 440 LL = 1,9
  440 GD(LL) = 0.0
      CONST = 1.0 - (G(2)*G(4))/(G(5)*G(1))
      GD(1) = G(1)*CONST
      GD(5) = G(5)*CONST
      GD(9) = G(9)
C
C     MULTIPLY GD X T AND WRITE TO GDT
C
      CALL GMMATS (GD(1),3,3,0, T(1),3,3,0, GDT(1))
C
C     MULTIPLY TT X GDT AND WRITE TO GDBR
      CALL GMMATS (T(1),3,3,1, GDT(1),3,3,0, GDBR(1))
C
C     WRITE GDBR IN TWO DIMENSIONED ARRAY GDBAR
C
      DO 450 LL = 1,3
      DO 450 MM = 1,3
      NN = MM + 3*(LL-1)
      GDBAR(LL,MM) = GDBR(NN)
  450 CONTINUE
C
C     *********************************************************
C     *   NOTE TO APPROXIMATE BEAM BEHAVIOUR THE CROSS AND    *
C     *   COUPLING TERMS IN THE GDBAR MATRIX NEED TO BE       *
C     *   DEGRADED I.E SET TO ZERO.                           *
C     *********************************************************
C
      GDBAR(1,2) = 0.0
      GDBAR(2,1) = 0.0
      GDBAR(1,3) = 0.0
      GDBAR(2,3) = 0.0
      GDBAR(3,1) = 0.0
      GDBAR(3,2) = 0.0
C
C     PERFORM INITIALIZATION
C
      ZREF = -TLAM/2.0
      ZK1  = ZK
      IF (K .EQ. 1) ZK1 = ZREF
      IF (ITYPE .EQ. 0) ZK = ZK1 + RZ(PIDLOC+5+4*K)
      IF (ITYPE .EQ. 1) ZK = ZK1 + RZ(PIDLOC+6    )
      IF (ITYPE .EQ. 2) ZK = ZK1 + RZ(PIDLOC+6+2*K)
      ZG1 = ZK - ZK1
      ZG4 =-(ZK**2 - ZK1**2)*0.5
      ZG2 = (ZK**3 - ZK1**3)*0.33333333
C
C     CALCULATE LAYER CONTRIBUTION TO G1, G2, DG2, AND G4 MATRICES
C
      DO 460 IR = 1,3
      DO 460 IC = 1,3
      G1 (IR,IC) =  G1(IR,IC) +  GBAR(IR,IC)*ZG1
      GD1(IR,IC) = GD1(IR,IC) + GDBAR(IR,IC)*ZG1
      IF (LAMOPT.EQ.MEM .OR. LAMOPT.EQ.SYMMEM) GO TO 460
      G2 (IR,IC) =  G2(IR,IC) +  GBAR(IR,IC)*ZG2
      GD2(IR,IC) =  GD2(IR,IC)+ GDBAR(IR,IC)*ZG2
      IF (LAMOPT .EQ. SYM) GO TO 460
      G4 (IR,IC) =  G4(IR,IC) +  GBAR(IR,IC)*ZG4
      GD4(IR,IC) = GD4(IR,IC) + GDBAR(IR,IC)*ZG4
  460 CONTINUE
C
C     CHECK LAMINATION OPTION AND IF SYMM OR SYMM.MEMB CALCULATE
C     LAYER CONTRIBUTION TO THE MEMBRANE, BENDING AND THE
C     MEMEBRANE-BENDING MATRICES
C
      IF (LAMOPT.NE.SYM .AND. LAMOPT.NE.SYMMEM) GO TO 480
C
      DO 470 IR = 1,3
      DO 470 IC = 1,3
      G1 (IR,IC) =  G1(IR,IC) +  GBAR(IR,IC)*ZG1
      GD1(IR,IC) = GD1(IR,IC) + GDBAR(IR,IC)*ZG1
      IF (LAMOPT .EQ. SYMMEM) GO TO 470
      G2 (IR,IC) =  G2(IR,IC) +  GBAR(IR,IC)*ZG2
      GD2(IR,IC) = GD2(IR,IC) + GDBAR(IR,IC)*ZG2
  470 CONTINUE
C
  480 CONTINUE
C
C     **************************************************************
C     CALCULATION OF ZBARX AND ZBARY
C            NEUTRAL SURFACE LOCATION IN X- AND Y- DIRECTION
C
C           TI  -  THICKNESS OF LAYER K
C           ZI  -  DISTANCE FROM REFERENCE SURFACE TO MID OF LAMINA K
C        EX,EY  -  APPARENT ENGINEERING PROPERTY. I.E YOUNGS MODULUS
C                  IN THE LONGITUDINAL AND TRANSVERSE DIRECTIONS IN
C                  THE MATERIAL COORDINATE SYSTEM.
C     **************************************************************
C
C     INVERT GDBAR TO DETERMINE EX AND EY
C
      ISING = -1
      CALL INVERS (3,GDBAR,3,DUMMY,0,DETERM,ISING,INDEXX)
C
C     THE YOUNGS MODULI EX AND EY IN THE MATERIAL COORD SYSTEM
C
      EX = 1.0/GDBAR(1,1)
      EY = 1.0/GDBAR(2,2)
C
      EXX = EX
      EYY = EY
C
C     WRITE EXX AND EYY TO PCOMPS
C
      CALL WRITE (PCOMPS,EXX,1,0)
      CALL WRITE (PCOMPS,EYY,1,0)
C
      IF (LAMOPT .EQ. SYM) GO TO 490
C
      TI = ZK - ZK1
      ZI = (ZK + ZK1)/2.0
C
      ZBARXT = ZBARXT + EX*TI*ZI
      ZBARXB = ZBARXB + EX*TI
      ZBARYT = ZBARYT + EY*TI*ZI
      ZBARYB = ZBARYB + EY*TI
C
C     CALCULATE CONTRIBUTION TO OVERALL DENSITY RHO
C
  490 IF (G(23) .EQ. 0.) GO TO 500
      RHO = RHO + G(23)*ZG1
C
C     PROCESS NEXT LAYER
C
  500 CONTINUE
C
C     JUMP IF LAMOPT IS MEMBRANE OR SYMM.MEMBRANE
C
      IF (LAMOPT.EQ.MEM .OR. LAMOPT.EQ.SYMMEM) GO TO 520
C
C     WRITE GD1, GD2 AND GD4 MATRICES TO STIFF MATRIX AND INVERT
C     TO DETERMINE THE OVERALL BENDING PROPERTY FOR THE LAMINATE.
C
      DO 510 LL = 1,3
      DO 510 MM = 1,3
      STIFF(LL  ,MM  ) = GD1(LL,MM)
      STIFF(LL  ,MM+3) = GD4(LL,MM)
      STIFF(LL+3,MM  ) = GD4(LL,MM)
      STIFF(LL+3,MM+3) = GD2(LL,MM)
  510 CONTINUE
C
C     INVERT STIFF
C
      ISING = -1
      CALL INVERS (6,STIFF,6,DUM,0,DETERM,ISING,INDEX)
C
      EI(1) = 1.0/STIFF(4,4)
      EI(2) = 1.0/STIFF(5,5)
C
      EIXX = EI(1)
      EIYY = EI(2)
C
C     WRITE EIXX AND EIYY TO PCOMPS
C
  520 CALL WRITE (PCOMPS,EIXX,1,0)
      CALL WRITE (PCOMPS,EIYY,1,0)
C
C     ***************************************************************
C     *   THE MEMBRANE, BENDING, AND MEMEBRANE-BENDING MATRICES     *
C     *   G1, G2, G3, AND G4  ARE GIVEN BY THE FOLLOWING            *
C     ***************************************************************
C
      DO 530 IR = 1,3
      DO 530 IC = 1,3
      G1(IR,IC)  = (1.0/TLAM)*G1(IR,IC)
      IF (LAMOPT.EQ.MEM .OR. LAMOPT.EQ.SYMMEM) GO TO 530
      G2(IR,IC)  = (12.0/TLAM**3)*G2(IR,IC)
      IF (LAMOPT .EQ. SYM) GO TO 530
      G4(IR,IC)  = (1.0/TLAM**2)*G4(IR,IC)
  530 CONTINUE
C
C     CALCULATE LOCATION OF NEUTRAL SURFACE ZBARX AND ZBARY
C     FOR LAMINATE
C
      IF (LAMOPT.EQ.SYM .OR. LAMOPT.EQ.MEM .OR. LAMOPT.EQ.SYMMEM)
     1    GO TO 540
      ZBARX = ZBARXT/ZBARXB
      ZBARY = ZBARYT/ZBARYB
      ZBAR(1) = ZBARX
      ZBAR(2) = ZBARY
C
      ZX = ZBARX
      ZY = ZBARY
C
C     WRITE ZX AND ZY TO PCOMPS
C
  540 CALL WRITE (PCOMPS,ZX,1,0)
      CALL WRITE (PCOMPS,ZY,1,0)
C
C     CALCULATE OVERALL DENSITY RHO
C
      IF (RHO .EQ. 0.) GO TO 550
      IF (LAMOPT.EQ.SYM .OR. LAMOPT.EQ.SYMMEM) RHO = 2.0*RHO
      RHO = RHO/TLAM
C
C     ****************************************************************
C     *   CHECK IF TRANSVERSE FLEXIBILITY MATRIX NEEDS TO CALCULATED *
C     *   OTHERWISE JUMP TO PROCEED AS PER NORMAL.                   *
C     ****************************************************************
C
  550 IF (LAMOPT.EQ.MEM .OR. LAMOPT.EQ.SYMMEM) GO TO 830
      IF (G(10) .EQ. 0.0) GO TO 830
C
C     LOOP OVER ALL THE LAYERS
C
      DO 700 K = 1,NLAY
      IF (ITYPE .EQ. 0) MATID = Z(PIDLOC+4+4*K)
      IF (ITYPE.EQ.1 .OR. ITYPE.EQ.2) MATID = Z(PIDLOC+5)
      IF (K.GE.2 .AND. (ITYPE.EQ.0 .AND. MID.EQ.MATID)) GO TO 560
      IF (K.GE.2 .AND. (ITYPE.EQ.1 .OR.  ITYPE.EQ.2)  ) GO TO 560
C
      MID = MATID
      CALL MAT (ELID)
C
C     CALL LPROPS TO GET LAYER PROPERTY MATRICES
C
      CALL LPROPS (G)
C
C     BUILD TRANSFORMATION MATRIX T
C
  560 IF (ITYPE .EQ. 0) THETA = RZ(PIDLOC+6+4*K)
      IF (ITYPE .EQ. 1) THETA = RZ(PIDLOC+7+  K)
      IF (ITYPE .EQ. 2) THETA = RZ(PIDLOC+7+2*K)
      C = ABS(THETA)
      IF (C .LT. 0.000002) C = 0.0
      IF (C.GT.89.99998 .AND. C.LT.90.00002) C =  90.0
      IF (C.GT.179.9998 .AND. C.LT.180.0002) C = 180.0
      IF (C.GT.269.9998 .AND. C.LT.270.0002) C = 270.0
      IF (C.GT.359.9998 .AND. C.LT.360.0002) C = 360.0
      IF (THETA .LT. 0.0) C = -C
      THETAR = C*DEGRAD
C
      C  = COS(THETAR)
      IF (ABS(C) .LT. EPSI) C = 0.0
      C2 = C*C
      C4 = C2*C2
      S  = SIN(THETAR)
      IF (ABS(S) .LT. EPSI) S = 0.0
      S2 = S*S
      S4 = S2*S2
C
      T(1) = C2
      T(2) = S2
      T(3) = C*S
      T(4) = S2
      T(5) = C2
      T(6) =-C*S
      T(7) =-2.0*C*S
      T(8) = 2.0*C*S
      T(9) = C2 - S2
C
C     PROCESSING FOR G3 MATRIX
C
C     CALCULATE GDBR = TT X GD X T
C
C     DETERMINE GD MATRIX, WHICH IS EQUAL TO G MATRIX WITH POISSONS
C     RATIO=0.0
C        GD(1) ---- YOUNGS MODULUS IN X-DIRN
C        GD(5) ---- YOUNGS MODULUS IN Y-DIRN
C        GD(9) ---- INPLANE SHEAR MODULUS
C
      DO 570 LL = 1,9
  570 GD(LL) = 0.0
      CONST = 1.0 - (G(2)*G(4))/(G(5)*G(1))
      GD(1) = G(1)*CONST
      GD(5) = G(5)*CONST
      GD(9) = G(9)
C
C     MULTIPLY GD X T AND WRITE TO GDT
C
      CALL GMMATS (GD(1),3,3,0, T(1),3,3,0, GDT(1))
C
C     MULTIPLY TT X GDT AND WRITE TO GDBR
C
      CALL GMMATS (T(1),3,3,1, GDT(1),3,3,0, GDBR(1))
C
C     WRITE GBR TO GDBAR
C
      DO 580 LL = 1,3
      DO 580 MM = 1,3
      NN = MM + 3*(LL-1)
      GDBAR(LL,MM) = GDBR(NN)
  580 CONTINUE
C
C     *************************************************************
C     *       NOTE TO APPROXIMATE BEAM BEHAVIOUR THE CROSS AND    *
C     *       COUPLING TERMS IN THE GDBAR MATRIX NEED TO BE       *
C     *       DEGRADED I.E SET TO ZERO.                           *
C     *************************************************************
C
      GDBAR(1,2) = 0.0
      GDBAR(2,1) = 0.0
      GDBAR(1,3) = 0.0
      GDBAR(2,3) = 0.0
      GDBAR(3,1) = 0.0
      GDBAR(3,2) = 0.0
C
C     INVERT GDBAR TO DETERMINE EX AND EY
C
      ISING = -1
      CALL INVERS (3,GDBAR,3,DUMMY,0,DETERM,ISING,INDEXX)
C
C     THE YOUNGS MODULI EX AND EY IN THE MATERIAL COORD SYSTEM ARE
C
      E(1) = 1.0/GDBAR(1,1)
      E(2) = 1.0/GDBAR(2,2)
C
C     PERFORM INTILIZATION
C
      ZREF = -TLAM/2.0
      ZK1  = ZK
      IF (K .EQ. 1) ZK1 = ZREF
      IF (ITYPE .EQ. 0) ZK = ZK1 + RZ(PIDLOC+5+4*K)
      IF (ITYPE .EQ. 1) ZK = ZK1 + RZ(PIDLOC+6    )
      IF (ITYPE .EQ. 2) ZK = ZK1 + RZ(PIDLOC+6+2*K)
C
C     BUILD TRANSFORMATION MATRIX U
C
      U(1) = C
      U(2) = S
      U(3) =-S
      U(4) = C
C
C     CALCULATE G3BAR = UT X G3I X U
C     G3I MATRIX  -  LAYER K TRANSFORMED G3, IN MATERIAL COORD-SYS
C
      DO 590 LL = 1,4
      MM = LL + 9
      G3I(LL) = G(MM)
  590 CONTINUE
C
C     MULTIPLY G3I X U AND WRITE TO G3IU
C
      CALL GMMATS (G3I(1),2,2,0, U(1),2,2,0, G3IU(1))
C
C     MULTIPLY UT X G3IU AND WRITE TO G3BR
C
      CALL GMMATS (U(1),2,2,1, G3IU(1),2,2,0, G3BR(1))
C
C     WRITE G3BR IN TWO DIMENSIONED ARRAY G3BAR
C
      DO 600 LL = 1,2
      DO 600 MM = 1,2
      NN = MM + 2*(LL-1)
      G3BAR(LL,MM) = G3BR(NN)
  600 CONTINUE
C
C     INVERT G3BAR
C
      DETRMN = G3BAR(1,1)*G3BAR(2,2) - G3BAR(1,2)*G3BAR(2,1)
      IF (DETRMN .EQ. 0.0) GO TO 1230
C
      G3INVD(1,1) = G3BAR(2,2)/DETRMN
      G3INVD(1,2) =-G3BAR(1,2)/DETRMN
      G3INVD(2,1) =-G3BAR(2,1)/DETRMN
      G3INVD(2,2) = G3BAR(1,1)/DETRMN
C
C     G3 MATRIX CALC
C
      ZI = (ZK + ZK1)/2.0
      TI =  ZK - ZK1
C
      DO 610 IR = 1,2
      RI(IR) = ((FI(IR)/E(IR)) + (ZBAR(IR)-ZK1)*TI - (TI*TI/3.0))
     1       * (FI(IR)/E(IR))
      RI(IR) = RI(IR) + ZBAR(IR)*TI*TI*((ZBAR(IR)-2.0*ZK1)/3.0
     1       - (TI/4.0))
      RI(IR) = RI(IR) + TI*TI*((ZK1*ZK1)/3.0 + (ZK1*TI)/4.0
     1       + (TI*TI)/20.0)
      RI(IR) = RI(IR)*E(IR)*E(IR)*TI
  610 CONTINUE
C
      DO 620 IR = 1,2
      DO 620 IC = 1,2
      GTRFLX(IR,IC) = GTRFLX(IR,IC) + RI(IR)*G3INVD(IR,IC)
  620 CONTINUE
C
      DO 630 IR = 1,2
      FII(IR) = E(IR)*TI*(ZBAR(IR)-ZI)
      FI(IR)  = FI(IR) + FII(IR)
  630 CONTINUE
C
C     PROCESS NEXT LAYER
C
  700 CONTINUE
C
C
C    FALL HERE IF LAMOPT IS SYMM AND G3 CALCULATION IS REQUIRED
C
C
      IF (LAMOPT .NE. SYM) GO TO  810
      DO 800 KK = 1,NLAY
      K = NLAY + 1 - KK
C
      IF (ITYPE .EQ. 0) MATID = Z(PIDLOC+4+4*K)
      IF (ITYPE.EQ.1 .OR. ITYPE.EQ.2) MATID = Z(PIDLOC+5)
      IF (K.GE.2 .AND. (ITYPE.EQ.0 .AND. MID.EQ.MATID)) GO TO 710
      IF (K.GE.2 .AND. (ITYPE.EQ.1 .OR.  ITYPE.EQ.2)  ) GO TO 710
C
      MID = MATID
      CALL MAT (ELID)
C
C     CALL LPROPS TO GET LAYER PROPERTY MATRICES
C
      CALL LPROPS (G)
C
C     BUILD TRANSFORMATION MATRIX T
C
  710 IF (ITYPE .EQ. 0) THETA = RZ(PIDLOC+6+4*K)
      IF (ITYPE .EQ. 1) THETA = RZ(PIDLOC+7+  K)
      IF (ITYPE .EQ. 2) THETA = RZ(PIDLOC+7+2*K)
      C = ABS(THETA)
      IF (C .LT. 0.000002) C = 0.0
      IF (C.GT.89.99998 .AND. C.LT.90.00002) C =  90.0
      IF (C.GT.179.9998 .AND. C.LT.180.0002) C = 180.0
      IF (C.GT.269.9998 .AND. C.LT.270.0002) C = 270.0
      IF (C.GT.359.9998 .AND. C.LT.360.0002) C = 360.0
      IF (THETA .LT. 0.0) C = -C
      THETAR = C*DEGRAD
C
      C  = COS(THETAR)
      IF (ABS(C) .LT. EPSI) C = 0.0
      C2 = C*C
      C4 = C2*C2
      S  = SIN(THETAR)
      IF (ABS(S) .LT. EPSI) S = 0.0
      S2 = S*S
      S4 = S2*S2
C
      T(1) = C2
      T(2) = S2
      T(3) = C*S
      T(4) = S2
      T(5) = C2
      T(6) =-C*S
      T(7) =-2.0*C*S
      T(8) = 2.0*C*S
      T(9) = C2 - S2
C
C     PROCESSING FOR G3 MATRIX
C
C     CALCULATE GDBR = TT X GD X T
C
C     DETERMINE GD MATRIX, WHICH IS EQUAL TO G MATRIX WITH POISSONS
C     RATIO=0.0
C        GD(1) ---- YOUNGS MODULUS IN X-DIRN
C        GD(5) ---- YOUNGS MODULUS IN Y-DIRN
C        GD(9) ---- INPLANE SHEAR MODULUS
C
      DO 720 LL = 1,9
  720 GD(LL) = 0.0
      CONST = 1.0 - (G(2)*G(4))/(G(5)*G(1))
      GD(1) = G(1)*CONST
      GD(5) = G(5)*CONST
      GD(9) = G(9)
C
C     MULTIPLY GD X T AND WRITE TO GDT
C
      CALL GMMATS (GD(1),3,3,0, T(1),3,3,0, GDT(1))
C
C     MULTIPLY TT X GDT AND WRITE TO GDBR
C
      CALL GMMATS (T(1),3,3,1, GDT(1),3,3,0, GDBR(1))
C
C     WRITE GBR TO GDBAR
C
      DO 730 LL = 1,3
      DO 730 MM = 1,3
      NN = MM + 3*(LL-1)
      GDBAR(LL,MM) = GDBR(NN)
  730 CONTINUE
C
C     *************************************************************
C     *       NOTE TO APPROXIMATE BEAM BEHAVIOUR THE CROSS AND    *
C     *       COUPLING TERMS IN THE GDBAR MATRIX NEED TO BE       *
C     *       DEGRADED I.E SET TO ZERO.                           *
C     *************************************************************
C
      GDBAR(1,2) = 0.0
      GDBAR(2,1) = 0.0
      GDBAR(1,3) = 0.0
      GDBAR(2,3) = 0.0
      GDBAR(3,1) = 0.0
      GDBAR(3,2) = 0.0
C
C     INVERT GDBAR TO DETERMINE EX AND EY
C
      ISING = -1
      CALL INVERS (3,GDBAR,3,DUMMY,0,DETERM,ISING,INDEXX)
C
C     THE YOUNGS MODULI EX AND EY IN THE MATERIAL COORD SYSTEM ARE
C
      E(1) = 1.0/GDBAR(1,1)
      E(2) = 1.0/GDBAR(2,2)
C
C     PERFORM INTILIZATION
C
      ZREF = -TLAM/2.0
      ZK1  = ZK
      IF (ITYPE .EQ. 0) ZK = ZK1 + RZ(PIDLOC+5+4*K)
      IF (ITYPE .EQ. 1) ZK = ZK1 + RZ(PIDLOC+6    )
      IF (ITYPE .EQ. 2) ZK = ZK1 + RZ(PIDLOC+6+2*K)
C
C     BUILD TRANSFORMATION MATRIX U
C
      U(1) = C
      U(2) = S
      U(3) =-S
      U(4) = C
C
C     CALCULATE G3BAR = UT X G3I X U
C     G3I MATRIX  -  LAYER K TRANSFORMED G3, IN MATERIAL COORD-SYS
C
      DO 740 LL = 1,4
      MM = LL + 9
      G3I(LL) = G(MM)
  740 CONTINUE
C
C     MULTIPLY G3I X U AND WRITE TO G3IU
C
      CALL GMMATS (G3I(1),2,2,0, U(1),2,2,0, G3IU(1))
C
C     MULTIPLY UT X G3IU AND WRITE TO G3BR
C
      CALL GMMATS (U(1),2,2,1, G3IU(1),2,2,0, G3BR(1))
C
C     WRITE G3BR IN TWO DIMENSIONED ARRAY G3BAR
C
      DO 750 LL = 1,2
      DO 750 MM = 1,2
      NN = MM + 2*(LL-1)
      G3BAR(LL,MM) = G3BR(NN)
  750 CONTINUE
C
C     INVERT G3BAR
C
      DETRMN = G3BAR(1,1)*G3BAR(2,2) - G3BAR(1,2)*G3BAR(2,1)
      IF (DETRMN .EQ. 0.0) GO TO 1230
C
      G3INVD(1,1) = G3BAR(2,2)/DETRMN
      G3INVD(1,2) =-G3BAR(1,2)/DETRMN
      G3INVD(2,1) =-G3BAR(2,1)/DETRMN
      G3INVD(2,2) = G3BAR(1,1)/DETRMN
C
C     THE CORRESSPONDING LAYER ON THE OTHER SIDE OF SYMMETRY
C
      ZI = (ZK + ZK1)/2.0
      TI =  ZK - ZK1
C
      DO 760 IR = 1,2
      RI(IR) = (FI(IR)/E(IR) +(-ZK1)*TI-TI*TI/3.0 )*FI(IR)/E(IR)
     1       + (ZK1*ZK1/3.0+ZK1*TI/4.0+TI*TI/20.0)*TI*TI
      RI(IR) = RI(IR)*E(IR)*E(IR)*TI
  760 CONTINUE
C
      DO 770 IR = 1,2
      DO 770 IC = 1,2
      GTRFLX(IR,IC) = GTRFLX(IR,IC) + RI(IR)*G3INVD(IR,IC)
  770 CONTINUE
C
      DO 780 IR = 1,2
      FII(IR) = E(IR)*TI*(ZBAR(IR)-ZI)
      FI(IR)  = FI(IR) + FII(IR)
  780 CONTINUE
C
C     PROCESS NEXT LAYER
C
  800 CONTINUE
C
  810 DO 820 IR = 1,2
      DO 820 IC = 1,2
      GTRFLX(IR,IC) = GTRFLX(IR,IC)*TLAM/(EI(IR)**2)
  820 CONTINUE
C
C     INVERT GTRFLX
C
      DETRMN = GTRFLX(1,1)*GTRFLX(2,2) - GTRFLX(1,2)*GTRFLX(2,1)
      IF (DETRMN .EQ. 0.0) GO TO 1230
C
      G3(1,1) = GTRFLX(2,2)/DETRMN
      G3(1,2) =-GTRFLX(1,2)/DETRMN
      G3(2,1) =-GTRFLX(2,1)/DETRMN
      G3(2,2) = GTRFLX(1,1)/DETRMN
C
C     BECAUSE G3(1,2) IS NOT EQUAL TO G3(2,1) IN GENERAL
C     AN AVERAGE VALUE WILL BE USED FOR THE COUPLING TERMS
C
      G3(1,2) = (G3(1,2) + G3(2,1))/ 2.0
      G3(2,1) = G3(1,2)
C
C     *****************************************************
C     WRITE THE NEWLY GENERATED G1, G2, G3, AND G4 MATRICES
C     TO MPTX IN THE FORM OF MAT2 DATA ENTRIES
C     *****************************************************
C
C      NOTE - THE MID FOR THESE MATRICES ARE AS FOLLOWS-
C         1. MID1  -- PID + 100000000
C         2. MID2  -- PID + 200000000
C         3. MID3  -- PID + 300000000
C         4. MID4  -- PID + 400000000
C
C    INITIALIZE G1, G2, G3, AND G4 MATRICES
C
  830 DO 840 JJ = 1,17
      GMEMBR(JJ) = 0.0
      GBENDG(JJ) = 0.0
      GTRSHR(JJ) = 0.0
      GMEMBD(JJ) = 0.0
  840 CONTINUE
C
      IMEMBR(1) = 0
      IBENDG(1) = 0
      ITRSHR(1) = 0
      IMEMBD(1) = 0
C
C     START GENERATING G1 MEMBRANE MATRIX
C
      IMEMBR( 1) = Z(PIDLOC) + 100000000
      GMEMBR( 2) = G1(1,1)
      GMEMBR( 3) = G1(1,2)
      GMEMBR( 4) = G1(1,3)
      GMEMBR( 5) = G1(2,2)
      GMEMBR( 6) = G1(2,3)
      GMEMBR( 7) = G1(3,3)
      GMEMBR( 8) = RHO
C
C     NEXT 5 LINES ARE NEW FROM 2/90 UAI CODE
C
      IF (.NOT.OK UAI) GO TO 845
      GMEMBR( 9) = ALFA1
      GMEMBR(10) = ALFA2
      GMEMBR(11) = ALFA12
      GMEMBR(12) = TREF
      GMEMBR(13) = GSUBE
C
  845 IF (LAMOPT.EQ.MEM .OR. LAMOPT.EQ.SYMMEM) GO TO 850
C
C     START GENERATING G2 BENDING MATRIX
C
      IBENDG( 1) = Z(PIDLOC) + 200000000
      GBENDG( 2) = G2(1,1)
      GBENDG( 3) = G2(1,2)
      GBENDG( 4) = G2(1,3)
      GBENDG( 5) = G2(2,2)
      GBENDG( 6) = G2(2,3)
      GBENDG( 7) = G2(3,3)
C
C     NEXT 3 LINES ARE NEW FROM 2/90 UAI CODE
C
      IF (.NOT.OK UAI) GO TO 847
C     GBENDG( 8) = ??
      GBENDG( 9) = ALFA1
      GBENDG(10) = ALFA2
      GBENDG(11) = ALFA12
C
C     START GENERATING G3 TRANSVERSE SHEAR FLEXIBILITY MATRIX
C
  847 ITRSHR( 1) = Z(PIDLOC) + 300000000
      GTRSHR( 2) = G3(1,1)
      GTRSHR( 3) = G3(1,2)
      GTRSHR( 4) = G3(2,1)
      GTRSHR( 5) = G3(2,2)
C
      IF (LAMOPT .EQ. SYM) GO TO 850
C
C     START GENERATING G4 MEMBRANE-BENDING COUPLING MATRIX
C
      IMEMBD( 1) = Z(PIDLOC) + 400000000
      GMEMBD( 2) = G4(1,1)
      GMEMBD( 3) = G4(1,2)
      GMEMBD( 4) = G4(1,3)
      GMEMBD( 5) = G4(2,2)
      GMEMBD( 6) = G4(2,3)
      GMEMBD( 7) = G4(3,3)
C
  850 CONTINUE
C
C     *******************************************************
C     GENERATE EQUIVALENT PSHELL BULK DATA ENTIES FOR EVERY
C     PCOMPI BULK DATA ENTRY. THIS IS NECESSARY FOR DEMG TO
C     FUNCTION CORRECTLY WHEN LAMINATED COMPOSITE ELEMENTS
C     ARE PRESENT.
C     *******************************************************
C
      IPSHEL( 1) = Z(PIDLOC)
      IPSHEL( 2) = Z(PIDLOC) + 100000000
      RPSHEL( 3) = TLAM
      IPSHEL( 4) = Z(PIDLOC) + 200000000
      RPSHEL( 5) = 1.0
      IPSHEL( 6) = Z(PIDLOC) + 300000000
      RPSHEL( 7) = 1.0
      RPSHEL( 8) = RZ(PIDLOC+2)
      RPSHEL( 9) =-TLAM/2.0
      RPSHEL(10) = TLAM/2.0
      IPSHEL(11) = Z(PIDLOC) + 400000000
      RPSHEL(12) = 0.0
      IPSHEL(13) = 0
      IPSHEL(14) = 0
      RPSHEL(15) = 0.0
      IPSHEL(16) = 0
      RPSHEL(17) = 0.0
C
      ZOFFS = RZ(PIDLOC+1) + TLAM/2.0
      IF (Z(PIDLOC)  .EQ.  BLANK) ZOFFS = 0.0
      IF (LAMOPT.EQ.MEM .OR. LAMOPT.EQ.SYMMEM) ZOFFS = 0
      IF (ABS(ZOFFS) .LE. 1.0E-3) ZOFFS = 0.0
      RPSHEL(14) = ZOFFS
C
      IF (LAMOPT.NE.MEM .AND. LAMOPT.NE.SYMMEM) GO TO 860
      IPSHEL( 4) = 0
      IPSHEL( 6) = 0
      IPSHEL(11) = 0
      RPSHEL(14) = 0.0
  860 IF (LAMOPT .NE. SYM) GO TO 870
      IPSHEL(11) = 0
  870 CONTINUE
C
C     UPDATE COUNTER ICOUNT TO INDICATE MAT2 AND PSHELL DATA IS BEING
C     WRITTEN SECOND TIME
C
      ICOUNT = ICOUNT + 1
C
      IF (ICOUNT .GT. 1) GO TO 900
C
      IF (PSHLPR .NE. 1) GO TO 890
      ICORE = LPCOMP + 1 + N2MAT
      N = BUF5 - ICORE
      CALL OPEN (*1200,EPT,Z(BUF4),RDREW)
      CALL FILPOS (EPT,POS1)
      CALL READ (*900,*880,EPT,Z(ICORE),N,0,EPTWDS)
      CALL MESAGE (-8,0,NAM)
  880 CALL WRITE (EPTX,Z(ICORE),EPTWDS,0)
      GO TO 900
  890 CALL WRITE (EPTX,PSHNAM,3,0)
  900 CALL WRITE (EPTX,IPSHEL(1),17,0)
C
      IF (ICOUNT .GT. 1) GO TO 930
C
      IF (MAT2PR .NE. 1) GO TO 920
      ICORE = LPCOMP + 1 + N2MAT
      N = BUF5 - ICORE
      CALL OPEN (*1200,MPT,Z(BUF2),RDREW)
      CALL FILPOS (MPT,POS)
      CALL READ (*930,*910,MPT,Z(ICORE),N,0,MATWDS)
      CALL MESAGE (-8,0,NAM)
  910 CALL WRITE (MPTX,Z(ICORE),MATWDS,0)
      GO TO 930
  920 CALL WRITE (MPTX,MATNAM,3,0)
  930 CALL WRITE (MPTX,IMEMBR(1),17,0)
      IF (LAMOPT.EQ.MEM .OR. LAMOPT.EQ.SYMMEM) GO TO 940
      CALL WRITE (MPTX,IBENDG(1),17,0)
      CALL WRITE (MPTX,ITRSHR(1),17,0)
      IF (LAMOPT .EQ. SYM) GO TO 940
      CALL WRITE (MPTX,IMEMBD(1),17,0)
  940 CONTINUE
      CALL SSWTCH (40,L40)
      IF (L40 .EQ. 0) GO TO 980
C
C     WRITE THE NEWLY GENERATED PROPERTY MATRICES TO THE OUTPUT FILE
C
      CALL PAGE2 (2)
      WRITE (NOUT,960) IMEMBR(1),(GMEMBR(LL),LL=2,16)
      IF (LAMOPT.EQ.MEM .OR. LAMOPT.EQ.SYMMEM) GO TO 980
      CALL PAGE2 (2)
      WRITE (NOUT,960) IBENDG(1),(GBENDG(LL),LL=2,16)
      IF (GTRSHR(1) .EQ. 0.0) GO TO 950
      CALL PAGE2 (2)
      WRITE (NOUT,960) ITRSHR(1),(GTRSHR(LL),LL=2,16)
  950 IF (LAMOPT .EQ. SYM) GO TO 980
      CALL PAGE2 (2)
      WRITE  (NOUT,960) IMEMBD(1),(GMEMBD(LL),LL=2,16)
  960 FORMAT (/,' MAT2',7X,I9,7(1X,1P,E11.4),/,9X,8(1X,F11.1))
C
C     UPDATE LOCATION OF NEXT PID
C
  980 PIDLOC = EOELOC + 1
      ISTART = PIDLOC
C
C     WRITE END OF ENTRY (EOE) TO PCOMPS BEFORE PROCESSING
C     NEXT PCOMP ENTRY
C
      CALL WRITE (PCOMPS,EOE,1,0)
C
C     CHECK IF ALL 'PCOMP' TYPE ENTRIES HAVE BEEN PROCESSED
C
      IF (ISTART .GE. IFINIS) IF (ITYPE-1) 990,1000,1010
C
C     PROCESS NEXT 'PCOMP' ENTRY
C
      GO TO 250
C
  990 CALL WRITE (PCOMPS,0,0,1)
      IF (TYPC1 .GT. 0) GO TO 190
      IF (TYPC2 .GT. 0) GO TO 200
      GO TO 1020
C
 1000 CALL WRITE (PCOMPS,0,0,1)
      IF (TYPC2 .GT. 0) GO TO 200
      GO TO 1020
C
 1010 CALL WRITE (PCOMPS,0,0,1)
C
C     ALL 'PCOMP' TYPES PROCESSED
C     WRITE EOR ON MPTX AND EPTX
C
 1020 CALL WRITE (MPTX,0,0,1)
      CALL WRITE (EPTX,0,0,1)
C
C     COPY REMAINDER OF EPT TO EPTX
C
      ICORE = 1
      N = BUF5 - 1
      EPTWDS = 0
      IF (PSHLPR .NE. 1) CALL OPEN (*1200,EPT,Z(BUF4),RDREW)
      CALL FILPOS (EPT,POS1)
      IF (PSHLPR .EQ. 1) CALL FWDREC (*1050,EPT)
 1030 CALL READ (*1050,*1040,EPT,Z(ICORE),N,1,EPTWDS)
      CALL MESAGE (-8,0,NAM)
 1040 CALL WRITE (EPTX,Z(ICORE),EPTWDS,1)
      EPTWDS = 0
      GO TO 1030
C
C     READ TRAILER FROM EPT AND WRITE TO EPTX
C
 1050 DO 1060 KK = 1,7
 1060 IEPTX(KK) = 0
      IEPTX( 1) = EPT
C
      CALL RDTRL(IEPTX)
      IEPTX(1) = EPTX
      KT721 = ANDF(PSHBIT,511)
      K1 = (KT721-1)/16 + 2
      K2 = KT721 - (K1-2)*16 + 16
      IEPTX(K1) = ORF(IEPTX(K1),TWO(K2))
      CALL WRTTRL (IEPTX)
C
C     IF EOF ON MPT,THEN ALL MAT2 DATA COPIED TO MPTX
C
      IF (EOF .EQ. 1) GO TO 1090
C
C     OTHERWISE COPY REMAINDER OF MPT TO MPTX
C
      ICORE = 1
      N = BUF5 - 1
      MATWDS = 0
      IF (MAT2PR .NE. 1) CALL OPEN (*1200,MPT,Z(BUF2),RDREW)
      CALL FILPOS (MPT,POS)
      IF (MAT2PR .EQ. 1) CALL FWDREC (*1090,MPT)
 1070 CALL READ (*1090,*1080,MPT,Z(ICORE),N,1,MATWDS)
      CALL MESAGE (-8,0,NAM)
 1080 CALL WRITE (MPTX,Z(ICORE),MATWDS,1)
      MATWDS = 0
      GO TO 1070
C
C     READ TRAILER FROM MPT AND WRITE TO MPTX
C
 1090 DO 1100 KK = 1,7
 1100 IMPTX(KK) = 0
      IMPTX( 1) = MPT
C
      CALL RDTRL(IMPTX)
      IMPTX(1) = MPTX
      KT721 = ANDF(MT2BIT,511)
      K1 = (KT721-1)/16 + 2
      K2 = KT721 - (K1-2)*16 + 16
      IMPTX(K1) = ORF(IMPTX(K1),TWO(K2))
      CALL WRTTRL (IMPTX)
C
C     WRITE TO TRAILER OF PCOMPS
C
C     SET TRAILER BIT POSITION TO ZERO IF ENTRY TYPE DOES NOT EXIST
C
      IF (TYPC  .EQ. 0) PCBIT(1) = 0
      IF (TYPC1 .EQ. 0) PCBIT(2) = 0
      IF (TYPC2 .EQ. 0) PCBIT(3) = 0
C
      DO 1110 LL = 1,3
      KT721 = ANDF(PCBIT(LL),511)
      K1 = (KT721-1)/16 + 2
      K2 = KT721 - (K1-2)*16 + 16
      IPCOMP(K1) = ORF(IPCOMP(K1),TWO(K2))
 1110 CONTINUE
C
C     WHEN ICFIAT IS 11, A 65536 IS LEFT IN IPCOMP(2) ACCIDENTALLY
C     ZERO IT OUT
C
      IF (ICFIAT .EQ. 11) IPCOMP(2) = 0
      CALL WRTTRL (IPCOMP)
C
C     CLOSE ALL FILES
C
      CALL CLOSE (PCOMPS,1)
      CALL CLOSE (EPTX,1)
      CALL CLOSE (MPTX,1)
      CALL CLOSE (MPT,1)
      CALL CLOSE (EPT,1)
C
      RETURN
C
C     FATAL ERROR MESSAGES
C
 1200 CALL MESAGE (-1,FILE,NAM)
      GO TO 1300
 1210 CALL PAGE2 (2)
      WRITE  (NOUT,1220)
 1220 FORMAT ('0*** SYSTEM FATAL ERROR.  PCOMP, PCOMP1 OR PCOMP2',
     1        ' DATA NOT FOUND BY SUBROUTINE TA1CPS.')
      NOGO = 1
      GO TO 1300
 1230 CALL PAGE2 (4)
      WRITE (NOUT,1240) MATID
      NOGO = 1
 1240 FORMAT ('0*** USER FATAL ERROR.  IMPROPER DATA PROVIDED FOR',
     1       ' CALCULATION OF TRANSVERSE SHEAR FLEXIBILITY MATRIX',
     2       /,23X,'FOR LAMINA REFERENCING MID ',I8,'.',
     3       /,23X,'CHECK DATA ON MAT BULK DATA ENTRY.')
 1300 CONTINUE
      RETURN
      END

      SUBROUTINE TRD1C2 (IC,PD,NGROUP,NLFTP,UDV,ILOOP,SCR1,DIT,NLFT,
CRLBR SPR94003 9/94
CRLBR1                   NOUE,MODAL,PNL)
     1                   NOUE,MODAL,PNL,ISKIP)
C
C     THIS ROUTINE STEPS INTEGRATION PROCEDURE
C
C     THIS ROUTINE IS SUITABLE FOR DOUBLE PRECISION OPERATION
C
      LOGICAL         NOPD
      INTEGER         DIT1,PNL1,PNL,PD,UDV,SCR1,DIT,SYSBUF,FILE,IZ(1),
CRLBR SPR94003 9/94
CRLBR1                MCB(7),IPNL(7),SUBNAM(2)
     1                MCB(7),IPNL(7),SUBNAM(2),MOUTPU(7)
      DOUBLE PRECISION Z,H
      DIMENSION       RZ(1)
      COMMON /BLANK / DUMMY(4),NCOL
CRLBR SPR94003 9/94
CRLBR COMMON /SYSTEM/ SYSBUF
      COMMON /SYSTEM/ SYSBUF, NNOUT, ISYSTM(79), ICPFLG
      COMMON /ZZZZZZ/ Z(1)
      COMMON /PACKX / IT1,IT2,II,JJ,INCR
      COMMON /TRDXX / IK(7),IDUM(14),ISCR1,ISCR2,ISCR3,ISCR4,ISCR5,
     1                ISCR6,IOPEN,ISYM,TO,NOPD,ISPNL
      COMMON /UNPAKX/ IT3,III,JJJ,INCR1
      COMMON /TRDD1 / NLFT1,DIT1,NLFTP1,NOUT,ICOUNT,ILOOP1,MODAL1,NZ,
     1                ICORE,IU2,IP4,IPNL,NMODES,NSTEP,PNL1,IST,IU1,
     2                DELTAT
      EQUIVALENCE     (Z(1),RZ(1),IZ(1))
      DATA    SUBNAM/ 4HTRD1,2HC2/
CRLBNB SPR94003 9/94
      DATA  IOUTPU, ISCR9 /203, 309/
CRLBNE
C
C     INITIALIZE
C
      NROW  = IK(3)
      NNROW = 2*NROW
      IT1   = 2
      IT2   = 2
      II    = 1
      JJ    = NROW
      INCR  = 1
      IT3   = 2
      III   = 1
      JJJ   = NROW
      INCR1 = 1
      NZ    = KORSZ(Z)
      IGROUP= NZ - 3*NGROUP + 1
      IBUF1 = IGROUP- SYSBUF
      IBUF2 = IBUF1 - SYSBUF
      IBUF3 = IBUF2 - SYSBUF
      IBUF4 = IBUF3 - SYSBUF
      IBUF5 = IBUF4 - SYSBUF
      IBUF6 = IBUF5 - SYSBUF
      IBUF7 = IBUF6 - SYSBUF
      IBUF8 = IBUF7 - SYSBUF
CRLBNB SPR94003 9/94
      IF (NLFTP .EQ. 0) IBUF8 = IBUF7
      IBUF9 = IBUF8 - SYSBUF
      IBUFA = IBUF9 - SYSBUF
      IF (ICPFLG .EQ. 0) IBUFA = IBUF8
      IF (ICPFLG .NE. 0 .AND. ISKIP .EQ. 1) IBUFA = IBUF9
      NZ = IBUFA - 1
CRLBNE
CRLBD SPR94003 9/94 NZ = IBUF7-1
CRLBD SPR94003 9/94 IF(NLFTP .NE. 0) NZ = IBUF8-1
      IOPEN = 0
CRLBR SPR94003 9/94 ICRQ = 14*NROW + 1 - NZ
      ICRQ = 14*(NROW+1) + 1 - NZ
      IF(ICRQ.GT.0) GO TO 430
CRLBR SPR94003 9/94 IU1=0
      IU1=1
CRLBR SPR94003 9/94 IU2= IU1+NROW
      IU2= IU1+NROW + 1
CRLBR SPR94003 9/94 IU3= IU2+ NROW
      IU3= IU2+ NROW + 1
CRLBR SPR94003 9/94 IP1= IU3+ NROW
      IP1= IU3+ NROW + 1
CRLBR SPR94003 9/94 IP2= IP1+ NROW
      IP2= IP1+ NROW + 1
      IP3   = IP2 + NROW
      IP4   = IP3 + NROW
      NLFT1 = NLFT
      DIT1  = DIT
      NLFTP1= NLFTP
      ILOOP1= ILOOP
      MODAL1= MODAL
      IST   = 0
CRLBR SPR94003 9/94 NZ    = NZ - 14*NROW - 1
      NZ    = NZ - 14*(NROW+1) - 1
      ICORE = 2*(IP4 + NROW)
      NMODES= NROW - NOUE
      PNL1  = PNL
      ASSIGN 60 TO IRET1
      NSTEP = IZ(IGROUP) + 1
      DELTAT= RZ(IGROUP+1)
      NOUT  = IZ(IGROUP+2)
      IF (ILOOP .NE. 1) GO TO 210
C
C     FIRST ENTRY INITIALIZE STUFF
C
      IST  =-1
      FILE = PD
C
C     PUT P0 IN IP2
C
      IPNT = IP2
      NOPD =.TRUE.
      ASSIGN 5 TO IRETN
      CALL OPEN (*310,PD,IZ(IBUF2),0)
      CALL SKPREC (PD,1)
      NOPD = .FALSE.
      GO TO 290
CRLBD SPR94003 9/94     5 FILE = UDV
CRLBD SPR94003 9/94       IAPEND = 0
CRLBR SPR94003 9/94       IF (NCOL .LE. 0) GO TO 8
    5 IF (NCOL .GT. 2) GO TO 325
CRLBD SPR94003 9/94      MCB(1) = UDV
CRLBD SPR94003 9/94      CALL RDTRL (MCB)
CRLBD SPR94003 9/94      IF (MCB(2) .NE. 0) GO TO 330
CRLBR SPR94003 9/94    8 CALL GOPEN (UDV,IZ(IBUF3),1)
      CALL GOPEN (UDV, IZ(IBUF3), 1)
      CALL MAKMCB (MCB,UDV,NROW,2,2)
CRLBNB SPR94003 9/94 
    8 IF (ICPFLG .EQ. 0) GO TO 10
      CALL MAKMCB (MOUTPU, IOUTPU, NROW+1, ISKIP, 2)
      CALL GOPEN (IOUTPU, IZ(IBUF9), 1)
      IF (ISKIP .EQ. 0) CALL GOPEN (ISCR9, IZ(IBUFA), 1)
CRLBNE
   10 IF (NLFTP .EQ. 0) GO TO 20
C
C     CHECK TO SEE IF PNL HAS BEEN PRE-PURGED.
C
      IPNL(1) = PNL1
      CALL RDTRL (IPNL)
      ISPNL = 0
      IF (IPNL(1) .LE. 0) GO TO 20
      ISPNL = 1
      CALL GOPEN (PNL1,IZ(IBUF8),1)
      CALL MAKMCB (IPNL,PNL1,NROW,2,2)
   20 CONTINUE
CRLBR SPR94003 9/94      IF (IAPEND .EQ. 1) GO TO 50
      IF (NCOL .GT. 2) GO TO 50
      FILE = IC
      CALL GOPEN (IC,IZ(IBUF1),0)
      ASSIGN 30 TO IRETN
      IPNT = IU2
      GO TO 290
   30 ASSIGN 40 TO IRETN
      IPNT = IU3
      GO TO 290
   40 CALL CLOSE (IC,1)
      NSTEP  = IZ(IGROUP) + 1
      DELTAT = RZ(IGROUP+1)
      NOUT   = IZ(IGROUP+2)
C
C     FORM  U=1, PO, P-1
C
      CALL FORM12 (Z(IU2+1),Z(IU3+1),Z(IU1+1),Z(IP2+1),Z(IP1+1),DELTAT,
     1             RZ(IBUF1))
C
C     START TIME STEP COUNT
C
   50 CONTINUE
      ICOUNT = 1
CRLBNB SPR94003 9/94   
      MCOL = 1
CRLBNE
C
C     OPEN FBS FILES
C
   60 FILE = ISCR1
      CALL OPEN (*390,ISCR1,IZ(IBUF4),0)
      FILE = ISCR2
      CALL OPEN (*390,ISCR2,IZ(IBUF5),0)
      FILE = ISCR3
CIBMR 5/95      
C     CALL OPEN (*390,ISCR3,IZ(IBUF6),0) 
      IF ( ISYM .EQ. 1 ) CALL OPEN (*390,ISCR3,IZ(IBUF6),0) 
      FILE = ISCR4
      CALL OPEN (*390,ISCR4,IZ(IBUF7),0)
C
C     ZERO P*
C
   70 CALL TMTOGO (ITLEFT)
      IF (ITLEFT .LE. 0) GO TO 170
      DO 80 I = 1,NROW
      K = IP4 + I
      Z(K) = 0.0D0
   80 CONTINUE
      IF (NLFTP .EQ. 0) GO TO 90
C
C     FORM NON-LINEAR LOADS
C
      CALL TRD1D2
      IF (ICOUNT.EQ.1 .OR. ICOUNT.EQ.NSTEP .OR. MOD(ICOUNT+IST,NOUT)
     1   .EQ.0) GO TO 85
      GO TO 90
   85 IF (ISPNL .GT. 0) CALL PACK (Z(IP4+1),PNL,IPNL)
C
C     BRING IN NEXT P
C
   90 IPNT = IP3
      FILE = PD
      ASSIGN 100 TO IRETN
      IF (NOPD) GO TO 310
      GO TO 290
C
C     ADD P-S TO FORM P*
C
  100 DO 110 I = 1,NROW
      K = IP4 + I
      L = IP1 + I
      M = IP2 + I
      J = IP3 + I
      Z(K) = Z(K) + (Z(L) + Z(M) + Z(J))/3.0D0
  110 CONTINUE
      IF (ILOOP.NE.1 .OR. ICOUNT.NE.1) GO TO 115
CRLBR SPR94003 9/94      IF (IAPEND .EQ. 1) GO TO 115
      IF (NCOL .GT. 2) GO TO 113
C
C     OUTPUT INITIAL DISPLACEMENT
C
      CALL PACK (Z(IU2+1),UDV,MCB(1))
C
C     OUTPUT INITIAL VELOCITY
C
      CALL PACK (Z(IU3+1),UDV,MCB(1))
CRLBNB SPR94003 9/94 
  113 IF (ICPFLG .EQ. 0) GO TO 115
      IF (ISKIP .EQ. 0) CALL WRITE (ISCR9, MCOL, 1, 0)
CRLBNE
C
C     SOLVE FOR NEXT SOLUTION
C
  115 CALL STEP2 (Z(IU3+1),Z(IU2+1),Z(IU1+1),Z(IP4+1),IZ(IBUF1))
CRLBNB SPR94003 9/94      
      IF (ICPFLG .EQ. 0) GO TO 118
      JJ = NROW + 1
      Z(IP2) = DELTAT
      IF (ILOOP.NE.1 .AND. ICOUNT.EQ.0) Z(IP2) = DELTA1
      CALL PACK (Z(IP2), IOUTPU, MOUTPU)
      IF (ISKIP .EQ. 1) GO TO 117
      Z(IU2) = MCOL + 0.1
      CALL PACK (Z(IU2), IOUTPU, MOUTPU)
  117 JJ = NROW
  118 CONTINUE
CRLBNE
      IF (ILOOP.EQ.1 .AND. ICOUNT.EQ.1) GO TO 145
      IF (ICOUNT.EQ.NSTEP .OR. MOD(ICOUNT+IST,NOUT).EQ.0) GO TO 130
      IF (ICOUNT .EQ. 1) GO TO 130
C
C     ROTATE P POINTERS
C
  120 J   = IP1
      IP1 = IP2
      IP2 = IP3
      IP3 = J
C
C     ROTATE U POINTERS
C
      J   = IU1
      IU1 = IU2
      IU2 = IU3
      IU3 = J
      ICOUNT = ICOUNT + 1
CRLBNB SPR94003 9/94      
      MCOL = MCOL + 1
CRLBNE
      IF (ICOUNT-NSTEP) 70,160,170
C
C     IT-S OUTPUT TIME -- LUCKY FELLOW
C
  130 CALL PACK (Z(IU2+1),UDV,MCB(1))
C
C     COMPUTE U DOT
C
      H = 1.0D0/(2.0D0*DELTAT)
      DO 140 I = 1,NROW
      K = IP4 + I
      L = IU3 + I
      M = IU1 + I
      Z(K) = (Z(L)-Z(M))*H
  140 CONTINUE
      CALL PACK (Z(IP4+1),UDV,MCB(1))
CRLBNB SPR94003 9/94      
      IF (ICPFLG .EQ. 0) GO TO 145
      IF (ISKIP .EQ. 0) CALL WRITE (ISCR9, MCOL, 1, 0)
CRLBNE
C
C     COMPUTE U DOT DOT
C
  145 H = 1.0D0/(DELTAT*DELTAT)
      DO 150 I = 1,NROW
      K = IP4 + I
      L = IU3 + I
      M = IU1 + I
      J = IU2 + I
      Z(K) = (Z(L)+Z(M)-2.0D0*Z(J))*H
  150 CONTINUE
      CALL PACK (Z(IP4+1),UDV,MCB(1))
      GO TO 120
C
C     END OF 1 GROUP
C
  160 IF (ILOOP .NE. NGROUP) GO TO 200
      GO TO 70
  170 J = 1
  180 CALL CLOSE (UDV,J)
      CALL CLOSE (PD ,J)
CRLBNB SPR94003 9/94
      IF (ICPFLG .EQ. 0) GO TO 188
      IF (J.NE.1 .OR. ISKIP.EQ.1) GO TO 186
      CALL CLOSE (ISCR9, 1)
C
C     COPY THE SINGLE RECORD IN FILE ISCR9 AS THE
C     LAST RECORD IN FILE IOUTPU
C
      CALL GOPEN (ISCR9, IZ(IBUFA), 0)
      FILE = ISCR9
  183 CALL READ (*410, *184, ISCR9, Z(IU2+1), NROW, 0, IFLAG)
      CALL WRITE (IOUTPU, Z(IU2+1), NROW, 0)
      GO TO 183
  184 CALL WRITE (IOUTPU, Z(IU2+1), IFLAG, 1)
      CALL CLOSE (ISCR9, 1)
  186 CALL CLOSE (IOUTPU, J)
      CALL WRTTRL (MOUTPU)
  188 CONTINUE
CRLBNE
      CALL CLOSE (ISCR1,1)
      CALL CLOSE (ISCR2,1)
CIBMR 5/95       
C     CALL CLOSE (ISCR3,1)      
      IF ( ISYM .EQ. 1 ) CALL CLOSE (ISCR3,1)      
      CALL CLOSE (ISCR4,1)
      CALL WRTTRL (MCB)
      IF (NLFTP.EQ.0 .OR. ISPNL.EQ.0) GO TO 190
      CALL CLOSE (PNL,J)
      CALL WRTTRL (IPNL)
  190 RETURN
C
C     MORE GROUPS TO COME SAVE STUFF
C
  200 J = 2
      FILE = SCR1
      CALL OPEN  (*390,SCR1,IZ(IBUF1),1)
      CALL WRITE (SCR1,Z(IU3+1),NNROW,1)
      CALL WRITE (SCR1,Z(IU1+1),NNROW,1)
      CALL WRITE (SCR1,Z(IU2+1),NNROW,1)
CRLBR SPR94003 9/94
CRLBR CALL WRITE (SCR1,Z(IP1+1),NNROW,1)
      CALL WRITE (SCR1,Z(IP2+1),NNROW,1)
      CALL CLOSE (SCR1,1)
      GO TO 180
C
C     CHANGE OF TIME STEP--RESTORE POINTERS ETC
C
  210 IGROUP = IGROUP + (ILOOP-1)*3
      DELTA1 = RZ(IGROUP-2)
      NSTEP  = IZ(IGROUP  )
      DELTAT = RZ(IGROUP+1)
      NOUT   = IZ(IGROUP+2)
      IF (.NOT.NOPD) CALL GOPEN (PD,IZ(IBUF2),2)
      CALL GOPEN (UDV,IZ(IBUF3),3)
      MCB(1) = UDV
      CALL RDTRL (MCB)
CRLBNB SPR94003 9/94  
      IF (ICPFLG .EQ. 0) GO TO 217
      CALL GOPEN (IOUTPU, IZ(IBUF9), 3)
      MOUTPU(1) = IOUTPU
      CALL RDTRL (MOUTPU)
  217 CONTINUE
CRLBNE
      IF (NLFTP .EQ. 0) GO TO 220
      IF (ISPNL .GT. 0) CALL GOPEN (PNL1,IZ(IBUF8),3)
  220 CONTINUE
C
C     RESTORE STUFF SAVED
C
      FILE = SCR1
      CALL OPEN  (*390,SCR1,IZ(IBUF1),0)
      CALL FREAD (SCR1,Z(IU1+1),NNROW,1)
      CALL FREAD (SCR1,Z(IU3+1),NNROW,1)
      CALL FREAD (SCR1,Z(IU2+1),NNROW,1)
      CALL FREAD (SCR1,Z(IP2+1),NNROW,1)
      CALL CLOSE (SCR1,1)
C
C     COMPUTE U DOT
C
CRLBR SPR94003 9/94      H = 1.0D0/DELTA1
  225 H = 1.0D0/DELTA1
      DO 230 I = 1,NROW
      K = IP1 + I
      L = IU2 + I
      M = IU3 + I
      Z(K) = (Z(L)-Z(M))*H
  230 CONTINUE
C
C     COMPUTE U DOT DOT
C
      H = 1.0D0/(DELTA1*DELTA1)
      DO 240 I = 1,NROW
      K = IP4 + I
      L = IU2 + I
      M = IU3 + I
      J = IU1 + I
      Z(K) = (Z(L)-2.0D0*Z(M)+Z(J))*H
  240 CONTINUE
CRLBD SPR94003 9/94   250 CONTINUE
C
C     COMPUTE UI PRIME
C
      H = DELTAT*DELTAT/2.0D0
      DO 260 I = 1,NROW
      K = IU1 + I
      L = IU2 + I
      M = IP1 + I
      J = IP4 + I
      Z(K) = Z(L) - DELTAT*Z(M) + H*Z(J)
  260 CONTINUE
C
C     COMPUTE U DOT PRIME
C
      DO 270 I = 1,NROW
      K = IU3 + I
      L = IP1 + I
      M = IP4 + I
      Z(K) = Z(L) - DELTAT*Z(M)
  270 CONTINUE
C
C     COMPUTE PI PRIME
C
      DO 280 I = 1,NROW
      K = IP1 + I
      Z(K) = 0.0D0
  280 CONTINUE
      CALL FORM22 (Z(IP4+1),Z(IU3+1),Z(IU1+1),Z(IP1+1),RZ(IBUF1))
      ICOUNT = 0
CRLBR SPR94003 9/94      GO TO IRET1, (60,10)
      GO TO IRET1, (60,8)
C
C     INTERNAL ROUTINE TO UNPACK VECTORS
C
  290 CALL UNPACK (*310,FILE,Z(IPNT+1))
CRLBR SPR94003 9/94  300 GO TO IRETN, (5,30,40,100,350,360,370)
  300 GO TO IRETN, (5,30,40,100,340,350,360,370,385,387)
CRLBR SPR94003 9/94  310 DO 320 INL = 1,NROW
  310 DO 320 INL = III, JJJ
      K = IPNT + INL
      Z(K) = 0.0D0
  320 CONTINUE
      GO TO 300
CRLBNB SPR94003 9/94
C     THE FOLLOWING LINES (UNTIL CRPKNE) REPRESENT
C     REPLACEMENTS FOR THE OLD CODE WHICH HAS BEEN
C     DELETED BELOW
C
C     RETRIEVE REQUIRED INFORMATION FROM
C     THE CHECKPOINT RUN
C
  325 MCOL = NCOL
      CALL GOPEN (IOUTPU, IZ(IBUF4), 0)
      MOUTPU(1) = IOUTPU
      CALL RDTRL (MOUTPU)
      JSKIP = 1
      IF (MOUTPU(4) .EQ. 1) GO TO 335
      JSKIP = 2
      CALL SKPREC (IOUTPU, MOUTPU(2))
      FILE = IOUTPU
      NWDS = NCOL - 1
  327 CALL READ (*410, *330, IOUTPU, MCOL, -NWDS, 0, IFLAG)
      GO TO 333
  330 NWDS = NWDS - IFLAG
      GO TO 327
  333 CALL READ (*410, *333, IOUTPU, MCOL, 1, 0, IFLAG)
      CALL REWIND (IOUTPU)
      CALL SKPREC (IOUTPU, 1)
C
  335 CALL SKPREC (IOUTPU, JSKIP*(MCOL-1))
      FILE = IOUTPU
      JJJ = NROW + 1
C
C     GET P SUB I+1
C
      IPNT = IP2 - 1
      ASSIGN 340 TO IRETN
      GO TO 290
  340 ITYPE = 1
      DELTA1 = Z(IP2)
      IF (DELTA1 .EQ. DELTAT) GO TO 345
      ITYPE = 2
      GO TO 350
  345 CALL SKPREC (IOUTPU, -(JSKIP+1))
C
C     GET P SUB I
C
      IPNT = IP1 - 1
      ASSIGN 350 TO IRETN
      GO TO 290
  350 CALL CLOSE (IOUTPU, 1)
C
      FILE = UDV
      CALL GOPEN (UDV, IZ(IBUF3), 0)
      K = 3*(NCOL - 1)
      KK = 5
      KKK = 4
      KKP = 0
      JJJ = NROW
      CALL SKPREC (UDV, K)
C
C     GET U SUB I+1
C
      IPNT = IU2
      ASSIGN 360 TO IRETN
      GO TO 290
C
C     GET U DOT SUB I+1
C
  360 IPNT = IP3
      ASSIGN 370 TO IRETN
      GO TO 290
C
  370 IF (MCOL .EQ. NCOL) GO TO 380
      CALL CLOSE (UDV, 1)
      FILE = IOUTPU
      CALL GOPEN (IOUTPU, IZ(IBUF4), 0)
      K = 2*MCOL - 3
      KK = 0
      KKK = 3
      KKP = 1
      JJJ = NROW + 1
      CALL SKPREC (IOUTPU, K)
C
C     GET U SUB I
C
  380 IPNT = IU1 - KKP
      IF (ITYPE .EQ. 2) IPNT = IU3 - KKP
      CALL SKPREC (FILE, -KK)
      ASSIGN 385 TO IRETN
      GO TO 290
  385 IF (ITYPE .EQ. 1) GO TO 388
      IF (MCOL .EQ. NCOL) GO TO 386
      ITEST = Z(IPNT+1)
      IF (MCOL .EQ. ITEST+1) GO TO 386
      WRITE (NNOUT, 500)
      CALL MESAGE (-61, 0, 0)
  386 CALL SKPREC (FILE, -KKK)
C
C     GET U SUB I-1
C
      IPNT = IU1 - KKP
      ASSIGN 387 TO IRETN
      GO TO 290
  387 IF (MCOL .EQ. NCOL) GO TO 388
      ITEST = Z(IPNT+1)
      IF (MCOL .EQ. ITEST+2) GO TO 388
      WRITE (NNOUT, 600)
      CALL MESAGE (-61, 0, 0)
  388 CALL CLOSE (FILE, 1)
      JJJ = NROW
      CALL GOPEN (UDV, IZ(IBUF3), 1)
      CALL MAKMCB(MCB,UDV,NROW,2,1)
C
C     OUTPUT INITIAL DISPLACEMENT
C
      CALL PACK (Z(IU2 + 1), UDV, MCB(1))
C
C     OUTPUT INITIAL VELOCITY
C
      CALL PACK (Z(IP3 + 1), UDV, MCB(1))
      IF (ITYPE .EQ. 1) GO TO 8
      ASSIGN 8 TO IRET1
      GO TO 225
CRLBNE
CRLBDB SPR94003 9/94
CRLBD C
CRLBD C     RETRIEVE LAST VECTOR
CRLBD C
CRLBD   330 CALL GOPEN (UDV,IZ(IBUF3),0)
CRLBD       K = 3*(NCOL-1)
CRLBD       IAPEND = 1
CRLBD       CALL SKPREC (UDV,K)
CRLBD C
CRLBD C     GET U SUB I+1
CRLBD C
CRLBD       IPNT = IU2
CRLBD       ASSIGN 350 TO IRETN
CRLBD       GO TO 290
CRLBD CP
CRLBD C     GET U SUB I+1 DOT
CRLBD C
CRLBD   350 IPNT = IP1
CRLBD       ASSIGN 360 TO IRETN
CRLBD       GO TO 290
CRLBD C
CRLBD C     GET U SUB I+1 DOT DOT
CRLBD C
CRLBD   360 IPNT = IP4
CRLBD       ASSIGN 370 TO IRETN
CRLBD       GO TO 290
CRLBD   370 CONTINUE
CRLBD       CALL CLOSE (UDV,1)
CRLBD       CALL GOPEN (UDV,IZ(IBUF3),1)
CRLBD       CALL MAKMCB (MCB,UDV,NROW,2,2)
CRLBD C
CRLBD C     OUTPUT INITIAL DISPLACEMENT
CRLBD C
CRLBD       CALL PACK (Z(IU2+1),UDV,MCB(1))
CRLBD C
CRLBD C     OUTPUT INITIAL VELOCITY
CRLBD C
CRLBD       CALL PACK (Z(IP1+1),UDV,MCB(1))
CRLBD C
CRLBD C     FORM P SUB I+1
CRLBD C
CRLBD       DO 380 I = 1,NROW
CRLBD       K = IP2 + I
CRLBD       Z(K) = 0.0D0
CRLBD   380 CONTINUE
CRLBD       CALL FORM22 (Z(IP4+1),Z(IP1+1),Z(IU2+1),Z(IP2+1),RZ(IBUF1))
CRLBD       ASSIGN 10 TO IRET1
CRLBD       GO TO 250
CRLBDE
C
C     ERROR MESAGES
C
  390 IP1 = -1
  400 CALL MESAGE (IP1,FILE,SUBNAM)
      RETURN
CRLBNB SPR94003 9/94
  410 IP1 = -2
      GO TO 400
CRLBNE
C
  430 IP1  = -8
      FILE = ICRQ
      GO TO 400
CRLBNB SPR94003 9/94
  500 FORMAT ('0*** SYSTEM FATAL MESSAGE, LOGIC ERROR 1 IN ',
     *        'SUBROUTINE TRD1C2 WHILE PROCESSING THE RESTART ',
     *        'INFORMATION')
  600 FORMAT ('0*** SYSTEM FATAL MESSAGE, LOGIC ERROR 2 IN ',
     *        'SUBROUTINE TRD1C2 WHILE PROCESSING THE RESTART ',
     *        'INFORMATION')
CRLBNE
      END

      SUBROUTINE MCE1
C
C     MCE1 PARTITIONS RG INTO RM AND RN
C     THEN SOLVES THE MATRIX EQUATION RM * GM = -RN.
C
C
      INTEGER        USET   ,RG    ,GM    ,SCR1  ,SCR2  ,SCR3  ,RM   ,
     1               RN     ,L     ,U
      COMMON /BLANK/ USET   ,RG    ,GM    ,SCR1  ,SCR2  ,SCR3  ,RM   ,
     1               RN     ,L     ,U     ,MCB(7)
C
C     SET INPUT, OUTPUT AND SCRATCH FILES
C
      USET = 101
      RG   = 102
      GM   = 201
      SCR1 = 304
      SCR2 = 305
      SCR3 = 301
      RM   = 302
      RN   = 303
      L    = 306
      U    = 307
C
C     PARTITION RG INTO RM AND RN
C
      CALL MCE1A
C
C     TEST FOR RM DIAGONAL
C
      MCB(1) = RM
      CALL RDTRL (MCB)
      IF (MCB(5).EQ.1 .AND. MCB(6).EQ.1) GO TO 50
      IF (MCB(5).EQ.2 .AND. MCB(6).EQ.2) GO TO 50
C
C     RM IS NOT DIAGONAL, DECOMPOSE RM THEN SOLVE FOR GM
C     BY FORWARD-BACKWARD SUBSTITUTION.
C
      CALL MCE1B
      CALL MCE1C
      RETURN
C
C     RM IS DIAGONAL, COMPUTE GM = -RM(-1) * RN
C
   50 CALL MCE1D
      RETURN
      END

      SUBROUTINE DDR1B (IN1,IN2,IOUT)
C
C     THIS ROUTINE REPLACES DISPLACEMNTS ON IN1 WITH DISPLACEMENTS ON
C     IN2  AND WRITES ON  IOUT
C
      INTEGER SYSBUF, MCB(7)
      COMMON /SYSTEM/ SYSBUF
      COMMON /UNPAKX/ ITC,II,JJ,INCR
      COMMON /ZZZZZZ/ Z(1)
C
C
      NZ = KORSZ(Z) - SYSBUF
      CALL GOPEN (IN1,Z(NZ+1),0)
      NZ = NZ - SYSBUF
      CALL GOPEN (IN2,Z(NZ+1),0)
      NZ = NZ - SYSBUF
      CALL GOPEN (IOUT,Z(NZ+1),1)
      MCB(1) = IN1
      CALL RDTRL (MCB)
      MCB(1) = IOUT
      ND  = MCB(2)/3
      ITC = MCB(5)
      INCR = 1
      MCB(2) = 0
      MCB(6) = 0
      MCB(7) = 0
      DO 40 I = 1,ND
      CALL SKPREC (IN1,1)
      CALL CYCT2B (IN2,IOUT,1,Z,MCB)
      CALL CYCT2B (IN1,IOUT,2,Z,MCB)
   40 CONTINUE
      CALL WRTTRL (MCB)
      CALL CLOSE (IN1,1)
      CALL CLOSE (IN2,1)
      CALL CLOSE (IOUT,1)
      RETURN
      END

      SUBROUTINE QDMM2S
C
C     THIS ROUTINE CALCULATES THE STIFFNESS, MASS AND DAMPING MATRICES
C     FOR THE QDMM2 ELEMENT.
C
C     SINGLE PRECISION VERSION
C
C     THIS ROUTINE USES SUBROUTINE E MAS TQ TO CALCULATE THE LUMPED
C     MASS USING THE SAME METHOD AS WITH THE QDMEM ELEMENT.
C
C     THIS ROUTINE MAY NOT BE CALLED IN A HEAT PROBLEM.
C
C     ELEMENT EST ENTRY CONTENTS
C     + + + + + + + + + + + + + + + + + + + + + + + + + +
C     +   1 = ID                                        +
C     +   2 = SIL-PT-A            (ELEMENT CONNECTS     +
C     +   3 = SIL-PT-B             GRID POINTS A,B,     +
C     +   4 = SIL-PT-C             C,D IN THAT ORDER)   +
C     +   5 = SIL-PT-D                                  +
C     +   6 = MATERIAL-ANGLE                            +
C     +   7 = MATERIAL-ID                               +
C     +   8 = THICKNESS OF ELEMENT                      +
C     +   9 = NON-STRUCTURAL-MASS                       +
C     +  10 = COORD-SYS-ID PT-A OR 0                    +
C     +  11 = XA                                        +
C     +  12 = YA                                        +
C     +  13 = ZA                                        +
C     +  14 = COORD-SYS-ID PT-B OR 0                    +
C     +  15 = XB                                        +
C     +  16 = YB                                        +
C     +  17 = ZB                                        +
C     +  18 = COORD-SYS-ID PT-C OR 0                    +
C     +  19 = XC                                        +
C     +  20 = YC                                        +
C     +  21 = ZC                                        +
C     +  22 = COORD-SYS-ID PT-D OR 0                    +
C     +  23 = XD                                        +
C     +  24 = YD                                        +
C     +  25 = ZD                                        +
C     +  26 = AVERAGE OF CONNECTED GRID TEMPERATURES    +
C     + + + + + + + + + + + + + + + + + + + + + + + + + +
C
      LOGICAL         PLANAR,NOGO,IHEAT
      INTEGER         DICT(11),ELID,ESTID,IPART(4),NEST(7),MAP(4,3)
      REAL            RMAT(3,5),ET(9),K1SUM(9,16),KIJ(1),ISINTH,
     1                KMAT(63),K5SUM(9,5),ICOSTH,GSUBE(9),IT,G(36),
     2                ITEMP9(9),K5MOD(9,5),TMAT(36),JTEMP9(9),IDETRM,
     3                KTEMP9(9),KOUT(144)
      CHARACTER       UFM*23,UWM*25
      COMMON /XMSSG / UFM,UWM
      COMMON /EMGEST/ EST(26)
      COMMON /EMGPRM/ DUMM(15),ISMD(3),IPREC,NOGO,HEAT,ICMBAR
      COMMON /EMGDIC/ DUM(2),NGRIDS,ELID,ESTID
      COMMON /MATIN / MATID,INFLAG,ELTEMP,STRESS,SINTH,COSTH
      COMMON /MATOUT/ G11,G12,G13,G22,G23,G33,RHO,ALPS(3),TSUB0,GE
      COMMON /SYSTEM/ KSYSTM(65)
      COMMON /CONDAS/ PI,TWOPI,RADEG,DEGRA,S4PISQ
      EQUIVALENCE     (KSYSTM(2),IOUTPT),(NEST(1),EST(1)),
     1                (DICT(5),DICT5),(K1SUM(1,1),KIJ(1)),
     2                (KSYSTM(56),IHEAT)
      DATA    MAP   / 1, 2, 3, 4,
     1                2, 3, 4, 1,
     2                5, 5, 5, 5  /
C
C
C     THIS ELEMENT NOT USED IN A HEAT PROBLEM
C
      IF (IHEAT) GO TO 320
C
C     CREATE AN ARRAY POINTING TO THE GRID POINTS ACCORDING TO
C     INCREASING SIL VALUE
C
      DO 2 I = 1,4
      IPART(I) = NEST(I+1)
    2 CONTINUE
      I = -4
    4 J = 0
      DO 6 K = 1,4
      IF (IPART(K) .LT. J) GO TO 6
      J = IPART(K)
      L = K
    6 CONTINUE
      IPART(L) = I
      I = I + 1
      IF (I .LT. 0) GO TO 4
      DO 8 I = 1,4
      IPART(I) = -IPART(I)
    8 CONTINUE
C
C     IF STIFFNESS MATRIX NEEDED
C     SET UP DICT ARRAY AND FOR STIFFNESS MATRIX
C     CALCULATIONS, OTHERWISE SKIP
C
      IF (ISMD(1) .EQ. 0) GO TO 400
C
C      COMPUTE BASIC SIN AND COSINE OF ELEMENT MATERIAL ANGLE.
C
      ANGL   = EST(6)*DEGRA
      ISINTH = SIN(ANGL)
      ICOSTH = COS(ANGL)
C
C     COMPUTE GSUBE MATRIX
C
      INFLAG = 2
      MATID  = NEST(7)
      ELTEMP = EST(26)
      SINTH  = 0.0
      COSTH  = 1.0
      CALL MAT (NEST(1))
      GSUBE(1) = G11
      GSUBE(2) = G12
      GSUBE(3) = G13
      GSUBE(4) = G12
      GSUBE(5) = G22
      GSUBE(6) = G23
      GSUBE(7) = G13
      GSUBE(8) = G23
      GSUBE(9) = G33
C
C     BASIC WHOLE-ELEMENT CALCULATIONS
C
      CALL Q2BCS (EST,PLANAR,RMAT,ET,IERROR)
      IF (IERROR) 10,10,270
C
C     ZERO SUMMATION ARRAYS
C
   10 DO 40 I = 1,9
      DO 20 J = 1,16
      K1SUM(I,J) = 0.0
   20 CONTINUE
      DO 30 J = 1,5
      K5SUM(I,J) = 0.0
   30 CONTINUE
   40 CONTINUE
C
C     SUB-TRIANGLES ARE COMPUTED AND RESULTS SUMMED.
C
      DO 70 I = 1,4
C
C     CALL TRIANGLE CALCULATION ROUTINE TO GET (3X3) SUB-PARTITIONS
C
      IA = MAP(I,1)
      IB = MAP(I,2)
      IC = MAP(I,3)
      IT = EST(8)
C
      CALL Q2TRMS (RMAT(1,IA),RMAT(1,IB),RMAT(1,IC),DUMMY,ISINTH,ICOSTH,
     1             GSUBE,IT,IERROR,1,KMAT,DUMMY,DUMMY,DUMMY)
      IF (IERROR) 50,50,270
C
C     SUM IN KCA,KCB,KCC 3-(3X3)-S STORED FIRST IN KMAT
C
C     ALSO SUM IN KAA,KAB,KBA,KBB = LAST 4-(3X3)-S STORED IN KMAT.
C     THESE GO INTO 4 OF THE 16 POSSIBLE (3X3) SUM MATRICES = ,
C
C     K11,K12,K13,K14,K21,K22,K23,K24,K31,K32,K33,K34,K41,K42,K43,K44
C
C     J1,J2,J3,J4 WILL EACH POINT TO 1 OF THE 16 (3X3)-S.
C
   50 J1 = 5*IA - 4
      J2 = 4*IA - 4 + IB
      J3 = 4*IB - 4 + IA
      J4 = 5*IB - 4
C
      DO 60 K = 1,9
      K5SUM(K,IA) = K5SUM(K,IA) + KMAT(K   )
      K5SUM(K,IB) = K5SUM(K,IB) + KMAT(K+ 9)
      K5SUM(K,IC) = K5SUM(K,IC) + KMAT(K+18)
      K1SUM(K,J1) = K1SUM(K,J1) + KMAT(K+27)
      K1SUM(K,J2) = K1SUM(K,J2) + KMAT(K+36)
      K1SUM(K,J3) = K1SUM(K,J3) + KMAT(K+45)
      K1SUM(K,J4) = K1SUM(K,J4) + KMAT(K+54)
   60 CONTINUE
C
   70 CONTINUE
C
C     FORMATION OF THE FOUR (3X3) G MATRICES.
C                     -1
C     (G ) = -(K5SUM  ) (K  )   NOTE.  IF -PLANAR- THEN MODIFIED
C       I           55    5I           K5SUM MATRICES ARE USED.
C
      IF (PLANAR) GO TO 90
      DO 80 I = 1,5
      DO 80 J = 1,9
      K5MOD(J,I) = K5SUM(J,I)
   80 CONTINUE
      GO TO 110
C
   90 DO 100 I = 1,5
      K5MOD(1,I) = K5SUM(1,I)
      K5MOD(2,I) = K5SUM(2,I)
      K5MOD(3,I) = K5SUM(3,I)
      K5MOD(4,I) = K5SUM(4,I)
      K5MOD(5,I) = K5SUM(5,I)
      K5MOD(6,I) = K5SUM(6,I)
      K5MOD(7,I) = 0.0
      K5MOD(8,I) = 0.0
      K5MOD(9,I) =-0.25
  100 CONTINUE
      K5MOD(9,5) = 1.0
C
C     INVERT K5MOD   AND NEGATE RESULT.
C                 55
C
  110 CONTINUE
C
C     NO NEED TO COMPUTE DETERMINANT SINCE IT IS NOT USED SUBSEQUENTLY.
C
      ISING = -1
      CALL INVERS (3,K5MOD(1,5),3,DUMMY,0,IDETRM,ISING,ITEMP9)
      IF (ISING .EQ. 2) GO TO 290
C
      DO 120 I = 1,9
      K5MOD(I,5) = -K5MOD(I,5)
  120 CONTINUE
C
C     FORM G MATRICES
C
      DO 130 I = 1,4
      CALL GMMATS (K5MOD(1,5),3,3,0, K5MOD(1,I),3,3,0, G(9*I-8))
  130 CONTINUE
C
C     FORMATION OF THE 4 TRANSFORMATION MATRICES EACH (3X3)
C
      DO 170 I = 1,4
      IEST = 4*I + 6
      IF (NEST(IEST)) 140,150,140
C
C     GET TRANSFORMATION MATRIX
C
  140 CALL TRANSS (NEST(IEST),ITEMP9)
      CALL GMMATS (ET,3,3,0, ITEMP9,3,3,0, TMAT(9*I-8))
      GO TO 170
C
  150 K = 9*I - 9
      DO 160 J = 1,9
      K = K + 1
      TMAT(K) = ET(J)
  160 CONTINUE
C
  170 CONTINUE
C
C     FORM STIFFNESS MATRIX BY ROW-PARTIONS.
C
      DO 260 I = 1,4
C                          T
C     IF -PLANAR- FORM (G ) (K  ) FOR USE IN COLUMN-PARTITIONS LOOP.
C                        I    55
C
      IF (.NOT.PLANAR) GO TO 190
      CALL GMMATS (G(9*I-8),3,3,1, K5SUM(1,5),3,3,0, ITEMP9)
C
C     COLUMN-PARTITIONS-LOOP
C
  190 DO 250 J = 1,4
C                                   T
C     FORM (K  ) = (K5SUM  ) + (K  ) (G )
C            IJ          IJ      5I    J
C
      CALL GMMATS (K5SUM(1,I),3,3,1, G(9*J-8),3,3,0, JTEMP9)
      LPART = 4*I - 4 + J
      DO 200 K = 1,9
      K1SUM(K,LPART) = K1SUM(K,LPART) + JTEMP9(K)
  200 CONTINUE
C
C     BALANCE OF TERMS IF -PLANAR-
C
C                T            T
C     ADD IN (G ) (K  ) + (G ) (K  )(G )
C              I    5J      I    55   J
C
      IF (.NOT.PLANAR) GO TO 220
      CALL GMMATS (ITEMP9,3,3,0, G(9*J-8),3,3,0, JTEMP9)
      CALL GMMATS (G(9*I-8),3,3,1, K5SUM(1,J),3,3,0, KTEMP9)
      DO 210 K = 1,9
      K1SUM(K,LPART) = K1SUM(K,LPART) + KTEMP9(K) + JTEMP9(K)
  210 CONTINUE
C
C     TRANSFORM THIS RESULTANT K   (3X3) STORED AT K1SUM(1,LPART)
C                               IJ
C     TO GLOBAL.
C
  220 CALL GMMATS (TMAT(9*I-8),3,3,1, K1SUM(1,LPART),3,3,0, JTEMP9)
      CALL GMMATS (JTEMP9,3,3,0, TMAT(9*J-8),3,3,0, K1SUM(1,LPART))
  250 CONTINUE
  260 CONTINUE
C
C     FOR THE MATRIX ASSEMBLER -EMG- THE 16 (3X3) PARTITIONS IN K1SUM
C     ARE REARRANGED TO STORE THEM BY ROWS TO A TOTAL OF
C     12X12 RATHER THAN 3X3.  BUT FIRST DICT MUST BE
C     SET UP.  THE SILS MUST BE SORTED SO THAT THE 12X12 WILL
C     BE BY INCREASING SIL VALUE
C
      DICT(1) = ESTID
      DICT(2) = 1
      DICT(3) = 12
      DICT(4) = 7
      DICT5   = GE
      IP      = IPREC
C
C     REORDER K1SUM INTO KOUT AS DESCRIBED ABOVE
C
C         ****          ****
C         * K   K   K   K  *
C         *  AA  AB  AC  AD*
C     K = * K   K   K   K  *
C         *  BA  BB  BC  BD*
C         * K   K   K   K  *
C         *  CA  CB  CC  CD*
C         * K   K   K   K  *
C         *  DA  DB  DC  DD*
C         ****          ****
C
C     WHERE SUBSCRIPTS ARE ARRANGED BY INCREASING SIL VALUE
C
      DO 390 I = 1,4
      II = IPART(I)
      DO 380 J = 1,4
      JTT = IPART(J)
      JT = (I-1)*4  + J
      DO 370 K = 1,9
      MODK = MOD(K,3)
      IF (MODK .EQ. 0) MODK = 3
      L = (II-1)*36 + ((K-1)/3)*12 + (JTT-1)*3 + MODK
      KOUT(L) = K1SUM(K,JT)
  370 CONTINUE
  380 CONTINUE
  390 CONTINUE
C
      CALL EMGOUT (KOUT,KOUT,144,1,DICT,1,IP)
C
C     CALCULATE THE MASS MATRIX HERE.  SUBROUTINE
C     E MAS TQ IS USED TO GENERATE A LUMPED
C     MASS MATRIX EXACTLY LIKE A QDMEM ELEMENT
C
  400 IF (ISMD(2) .EQ. 0) RETURN
C
      CALL E MAS TQ (1,K1SUM)
C
      DICT(1) = ESTID
      DICT(2) = 2
      DICT(3) = 12
      DICT(4) = 7
      DICT(5) = 0
C
C     REARRANGE KIJ BY INCREASING SIL VALUE
C
      DO 440 I = 1,4
      II = 1 + (IPART(I)-1)*3
      IJ = (I-1)*3 + 1
      KOUT(IJ  ) = KIJ(II  )
      KOUT(IJ+1) = KIJ(II+1)
  440 KOUT(IJ+2) = KIJ(II+2)
C
      CALL EMGOUT (KOUT,KOUT,12,1,DICT,2,IP)
      RETURN
C
C     ELEMENT ERRORS DETECTED.
C
  270 WRITE  (IOUTPT,280) UFM,NEST(1)
  280 FORMAT (A23,' 3098,  QDMEM2 ELEMENT STIFFNESS ROUTINE DETECTS ',
     1        'ILLEGAL GEOMETRY FOR ELEMENT ID =',I10)
      GO TO 310
  290 WRITE  (IOUTPT,300) UFM,NEST(1)
  300 FORMAT (A23,' 3099.  ELEMENT STIFFNESS COMPUTATION FOR QDMEM2 ',
     1       'ELEMENT ID =',I10, /5X,'IS IMPOSSIBLE DUE TO SINGULARITY',
     2       ' IN CONSTRAINT EQUATION.')
  310 NOGO = .TRUE.
      RETURN
C
  320 WRITE  (IOUTPT,330) UWM,NEST(1)
  330 FORMAT (A25,' 3115, QDMM2 FINDS ELEMENT NUMBER',I10,
     1        ' PRESENT IN A HEAT FORMULATION AND IS IGNORING SAME.')
C
      RETURN
      END

      SUBROUTINE PSTRM
C
C     THIS SUBROUTINE IS THE DRIVER FOR THE  TRI-MEMBRANE CALCULATIONS
C     IN PLA3
C
C     ECPT LIST
C                                                      IN
C                                                      THIS
C       ECPT       DESCRIPTION                         ROUTINE   TYPE
C     ******************************************************************
C       ECPT( 1) = ELEMENT ID                          NECPT(1)  INTEGER
C       ECPT( 2) = GRID POINT A                        NGRID(1)  INTEGER
C       ECPT( 3) = GRID POINT B                        NGRID(2)  INTEGER
C       ECPT( 4) = GRID POINT C                        NGRID(3)  INTEGER
C       ECPT( 5) = THETA = ANGLE OF MATERIAL           ANGLE     REAL
C       ECPT( 6) = MATERIAL ID                         MATID     INTEGER
C       ECPT( 7) = T                                   T         REAL
C       ECPT( 8) = NON-STRUCTURAL MASS                 FMU       REAL
C       ECPT( 9) = COORD. SYSTEM ID 1                  NECPT(9)  INTEGER
C       ECPT(10) = X1                                  X1        REAL
C       ECPT(11) = Y1                                  Y1        REAL
C       ECPT(12) = Z1                                  Z1        REAL
C       ECPT(13) = COORD. SYSTEM ID 2                  NECPT(13) INTEGER
C       ECPT(14) = X2                                  X2        REAL
C       ECPT(15) = Y2                                  Y2        REAL
C       ECPT(16) = Z2                                  Z2        REAL
C       ECPT(17) = COORD. SYSTEM ID 3                  NECPT(17) INTEGER
C       ECPT(18) = X3                                  X3        REAL
C       ECPT(19) = Y3                                  Y3        REAL
C       ECPT(20) = Z3                                  Z3        REAL
C       ECPT(21) = ELEMENT TEMPERATURE                 ELTEMP    REAL
C       ECPT(22) = STRAIN (MINUS ONE)                  EPS0      REAL
C       ECPT(23) = STRAIN (PRESENT)                    EPSS      REAL
C       ECPT(24) = MODULUS OF ELASTICITY               ESTAR     REAL
C       ECPT(25) = STRESS SUB X                        SIGXS     REAL
C       ECPT(26) = STRESS SUB Y                        SIGYS     REAL
C       ECPT(27) = STRESS SUB XY                       SIGXYS    REAL
C       ECPT(28) = DISPLACEMENT VECTOR   A1            UI(1)     REAL
C       ECPT(29) = DISPLACEMENT VECTOR   A2            UI(2)     REAL
C       ECPT(30) = DISPLACEMENT VECTOR   A3            UI(3)     REAL
C       ECPT(31) = DISPLACEMENT VECTOR   B1            UI(4)     REAL
C       ECPT(32) = DISPLACEMENT VECTOR   B2            UI(5)     REAL
C       ECPT(33) = DISPLACEMENT VECTOR   B3            UI(6)     REAL
C       ECPT(34) = DISPLACEMENT VECTOR   C1            UI(7)     REAL
C       ECPT(35) = DISPLACEMENT VECTOR   C2            UI(8)     REAL
C       ECPT(36) = DISPLACEMENT VECTOR   C3            UI(9)     REAL
C
C     ******************************************************************
C
      REAL            NU
      DIMENSION       NECPT(21),NECPTS(21)
      COMMON /PLA32E/ ECPT(21),EPS0,EPSS,ESTAR,SIGXS,SIGYS,SIGXYS,
     1                UI(9),DUMMY(64)
      COMMON /PLA3ES/ ECPTSA(100),PH1OUT(200)
      COMMON /PLA3UV/ IVEC,Z(24)
C
C     SCRATCH BLOCK  325 CELLS
C
      COMMON /PLA32S/ S(3),DUM(297),TAU0,TAU1,TAU2,F,SX,SY,DEPS,
     1                DEPSS,EPS1,EPS2,DUM1,IDUM2,IDUM3(3,3),EXTRA(4)
      COMMON /MATIN / MATID,INFLAG,ELTEMP,PLAARG,SINTH,COSTH
      COMMON /MATOUT/ G11,G12,G13,G22,G23,G33
      COMMON /PLA32C/ GAMMA,GAMMAS,IPASS
      COMMON /PLAGP / GP(9),MIDGP,ELID
      EQUIVALENCE     (NECPT(6),MATID1),(ECPT(1),NECPT(1)),(G11,PLAANS),
     1                (G13,NU),(G11,ESUB0),(NECPTS(1),ECPTSA(1)),
     2                (G12,NIROF)
C
C     SETUP GP MATRIX FOR PLAMAT
C
      ELID  = ECPT(1)
      MIDGP = MATID1
      DO 10 I = 1,9
   10 GP(I) = 0.0
      TAU0  = SQRT(SIGXS**2 - SIGXS*SIGYS + SIGYS**2 + 3.0*SIGXYS**2)
      IF (ESTAR .EQ. 0.) GO TO 50
      IF (IPASS .NE.  1) GO TO 20
      MATID = MATID1
      COSTH = 1.0
      SINTH = 0.0
      INFLAG = 2
C
      CALL MAT (ECPT(1))
C
      GP(1) = G11
      GP(2) = G12
      GP(3) = G13
      GP(4) = G12
      GP(5) = G22
      GP(6) = G23
      GP(7) = G13
      GP(8) = G23
      GP(9) = G33
      GO TO 50
   20 IF (TAU0 .EQ. 0.0) GO TO 50
      MATID = MATID1
      INFLAG = 1
C
      CALL MAT (ECPT(1))
C
      F     =  9.0*(ESUB0-ESTAR)/(4.0*TAU0**2*ESTAR)
      SX    = (2.0*SIGXS-SIGYS)/3.0
      SY    = (2.0*SIGYS-SIGXS)/3.0
      GP(1) = (1.0+SX**2*F) /ESUB0
      GP(2) = (-NU+SX*SY*F) /ESUB0
      GP(3) = (2.0*SIGXYS*SX*F)/ESUB0
      GP(4) = GP(2)
      GP(5) = (1.0+SY**2*F)/ESUB0
      GP(6) = (2.0*SIGXYS*SY*F)/ESUB0
      GP(7) = GP(3)
      GP(8) = GP(6)
      GP(9) = (2.0*(1.0+NU) + 4.0*F*SIGXYS**2)/ESUB0
C
C     NO NEED TO COMPUTE DETERMINANT SINCE IT IS NOT USED SUBSEQUNTLY.
C
      IDUM2 = -1
      CALL INVERS (3,GP,3,0,0,DUM1,IDUM2,IDUM3)
C
C     CHECK SINGULARITY
C
      IF (IDUM2 .EQ. 2) CALL MESAGE (-30,38,ECPT(1))
C
C     CALCULATE PHASE I STRESSES
C
   50 DO 30 I = 1,32
   30 ECPTSA(I) = ECPT(I)
      NECPTS(2) = 1
      NECPTS(3) = 4
      NECPTS(4) = 7
C
      CALL PSTRM1 (0)
C
C     CALCULATE PHASE II STRESSES
C
      IVEC = 1
      DO 60 I = 1,24
   60 Z(I) = UI(I)
      DO 70 I = 1,200
   70 ECPTSA(I) = PH1OUT(I)
      S(1) = SIGXS
      S(2) = SIGYS
      S(3) = SIGXYS
C
      CALL PSTRQ2 (1)
C
C     UPDATE ECPT FOR STRESSES
C
      SIGXS  = S(1)
      SIGYS  = S(2)
      SIGXYS = S(3)
      TAU1   = SQRT(SIGXS**2 - SIGXS*SIGYS + SIGYS**2 + 3.0*SIGXYS**2)
      MATID  = MATID1
      INFLAG = 8
      PLAARG = TAU1
C
      CALL MAT (ECPT(1))
C
C     TEST FOR TAU 1 OUTSIDE THE RANGE OF FUNCTION
C
      IF (NIROF .EQ. 1) GO TO 80
C
C     RETURNS EPS SUB 1 GIVEN TAU1
C
      EPS1 = PLAANS
      DEPS = EPS1 - EPSS
      DEPSS= EPSS - EPS0
      EPS2 = EPS1 + GAMMA * DEPS
      INFLAG = 6
      PLAARG = EPS2
C
      CALL MAT (ECPT(1))
C
C     RETURNS  TAU2 GIVEN EPS2
C
      TAU2  = PLAANS
      ESTAR = 0.0
      IF (EPS2-EPS1 .NE. 0.0) ESTAR = (TAU2-TAU1)/(EPS2-EPS1)
      EPS0  = EPSS
      EPSS  = EPS1
      RETURN
C
   80 ESTAR = 0.0
      RETURN
      END

      SUBROUTINE DLBPT2 (INPUT,W1JK,W2JK)
C
      INTEGER         W1JK,W2JK,SYSBUF,ECORE,TW1JK,TW2JK,NAME(2)
      DIMENSION       A(4),IZ(1)
      COMMON /PACKX / ITI,ITO,II,NN,INCR
      COMMON /AMGP2 / TW1JK(7),TW2JK(7)
      COMMON /AMGMN / MCB(7),NROW,ND,NE,REFC,FMACH,RFK
      COMMON /SYSTEM/ SYSBUF
      COMMON /ZZZZZZ/ NJ1,NK1,NP,NB,NTP,NBZ,NBY,NTZ,NTY,NT0,NTZS,NTYS,
     1                Z(1)
      EQUIVALENCE     (IZ(1),Z(1))
      DATA    NAME  / 4HDLBP,4HT2  /
C
C     GET CORE THEN SET POINTERS TO ACPT TABLE ARRAYS
C
      ECORE = KORSZ(IZ) - 4*SYSBUF
C
C     READ LENGTHS OF ARRAYS
C
      CALL FREAD (INPUT,NJ1,13,0)
C
C     COMPUTE POINTERS TO OPEN CORE
C
      IF (NTP .EQ. 0) CALL FREAD (INPUT,0,0,1)
      IF (NTP .EQ. 0) GO TO 50
      LNS  = IZ(1)
      INC  = 1
      INS  = INC
      INB  = INS + NP
      INAS = INB + NP
      IZIN = INAS
      IYIN = IZIN
      INBEA1 = IYIN   + NP
      INBEA2 = INBEA1 + NB
      INSBEA = INBEA2 + NB
      IZB  = INSBEA + NB
      IYB  = IZB  + NB
      IAVR = IYB  + NB
      IARB = IAVR + NB
      INFL = IARB + NB
      IXLE = INFL + NB
      IXTE = IXLE + NB
      INT121 = IXTE   + NB
      INT122 = INT121 + NB
      IZS = INT122 + NB
      N = 3*NP + 12*NB
C
C     READ FIXED ARRAYS
C
      IF (N .GT. ECORE) GO TO 180
      CALL FREAD (INPUT,IZ,N,0)
C
C     GET LENGTHS OF VARIABLE ARRAYS, PANELS THEN BODIES
C
      LNAS = 0
      IF (NP .EQ. 0) GO TO 20
      DO 10 I = 1,NP
   10 LNAS = LNAS + IZ(INAS+I-1)
   20 LNB  = 0
      LNSB = 0
      LNFL = 0
      LT1  = 0
      LT2  = 0
      DO 30 I = 1,NB
      K    = I - 1
      LNB  = LNB  + IZ(INBEA1+K)
      LNSB = LNSB + IZ(INSBEA+K)
      LNFL = LNFL + IZ(INFL+K)
      LT1  = LT1  + IZ(INT121+K)
   30 LT2  = LT2  + IZ(INT122+K)
C
C     READ VARIABLE  ARRAYS AND SET POINTERS TO CORE
C
      NEXT = N + 1
      N = 2*NB + 5*LNS + 4*NTP + 3*LNB + 4*LNSB + LNAS + 2*LNFL
     *  + LT1  + LT2
      IF (NEXT+N .GE. ECORE) GO TO 180
      CALL READ (*190,*190,INPUT,IZ(NEXT),N,1,NW)
      NEXT = NEXT+ N + 1
      IYS  = IZS + NB + LNS
      ICS  = IYS
      IEE  = ICS + NB + LNS
      ISG  = IEE + LNS
      ICG  = ISG + LNS
      IXIJ = ICG
      IX   = IXIJ+ LNS
      IDELX= IX  + NTP + LNB
C
C     COMPUTE TERMS AND PACK
C
      NN = II + 1
      DO 40 I = 1,NTP
      A(1) = 0.0
      A(2) = 1.0
      CALL PACK (A,W1JK,TW1JK)
      A(1) = -(2.0/REFC)
      A(2) = Z(IDELX+I-1)/(2.0*REFC)
      CALL PACK (A,W2JK,TW2JK)
C
C     BUMP PACK INDEXES
C
      II = II + 2
      IF (I .EQ. NTP) GO TO 40
      NN = NN + 2
   40 CONTINUE
   50 NTZY = NTZ + NTY
      IF (NTZY .EQ. 0) GO TO 70
      NN   = II + 1
      A(1) = 0.0
      A(2) = 0.0
      DO 60 I = 1,NTZY
      CALL PACK (A,W1JK,TW1JK)
      CALL PACK (A,W2JK,TW2JK)
   60 CONTINUE
   70 NTZY = NTZS + NTYS
      IF (NTZY .EQ. 0) GO TO 200
C
C     ANOTHER HARDER SHUFFLE
C
      III = II
      INBEA2 = INBEA2 - 1
      INSBEA = INSBEA - 1
      IFY = II
      IF (NBZ .EQ. 0) GO TO 120
      DO 110 I = 1,NBZ
      IBT = IZ(INBEA2+I)
      NBE = IZ(INSBEA+I)
      IF (IBT .EQ. 2) GO TO 90
      A(1) = 0.0
      A(2) = 1.0
      A(3) = -2.0/REFC
      A(4) = 0.0
      DO 80 J = 1,NBE
      NN = II + 1
      CALL PACK (A,W1JK,TW1JK)
      CALL PACK (A(3),W2JK,TW2JK)
      II  = II + 2
      IFY = II
   80 CONTINUE
      GO TO 110
   90 A(1) = 0.0
      A(4) = 0.0
      DO 100 J = 1,NBE
      NN   = II + 3
      A(2) = 0.0
      A(3) = 1.0
      CALL PACK (A,W1JK,TW1JK)
      A(2) = -2.0/REFC
      A(3) = 0.0
      CALL PACK (A,W2JK,TW2JK)
      II = II + 4
  100 CONTINUE
  110 CONTINUE
  120 IF (NBY .EQ. 0) GO TO 170
      II = IFY
      NBTD = NB - NBY + 1
      DO 160 I = NBTD,NB
      IBT = IZ(INBEA2+I)
      NBE = IZ(INSBEA+I)
      IF (IBT .EQ. 3) GO TO 140
      A(2) = 0.0
      A(3) = 0.0
      DO 130 J = 1,NBE
      NN   = II + 3
      A(1) = 0.0
      A(4) =-1.0
      CALL PACK (A,W1JK,TW1JK)
      A(1) = -2.0/REFC
      A(4) = 0.0
      CALL PACK (A,W2JK,TW2JK)
      II  = II + 4
  130 CONTINUE
      GO TO 160
  140 A(1) = 0.0
      A(2) =-1.0
      A(3) =-2.0/REFC
      A(4) = 0.0
      DO 150 J = 1,NBE
      NN = II + 1
      CALL PACK (A,W1JK,TW1JK)
      CALL PACK (A(3),W2JK,TW2JK)
      II = II + 2
  150 CONTINUE
  160 CONTINUE
  170 II = III + NTZY*2
      NN = II  - 1
      GO TO 200
C
C     ERROR MESSAGES
C
  180 CALL MESAGE (-8,0,NAME)
  190 CALL MESAGE (-7,0,NAME)
  200 RETURN
      END

      SUBROUTINE INT2AL (INT,ALF,CH)
C     ----------
C     THIS ROUTINE CONVERTS AN INTEGER TO ALPHA-NUMERIC WORD. THE
C     NUMBER IS LEFT JUSTIFIED WITH NO BLANKS.
C
C     INPUT/OUTPUT
C
C     INT - INTEGER - INPUT - NOT CHANGED
C     ALF - BCD 2 WORDS - OUTPUT - 2A4 MAY BE USED FOR PRINTING
C     CH  - BCD 9 WORDS - OUTPUT - CH(1) .EQ. NUMBER OF CHARACTERS
C           NEEDED TO CREATE INT. MAY BE PRINTED BY CH(I), I=2,CH(1)
C           IN A1 FORMAT.
C
C     NOTE - ANY INPUT NUMBER OUTSIDE THE RANGE OF -9999999 AND +9999999
C            (I.E. MORE THAN 8 DIGITS) IS SET TO ZERO IN OUTPUT.
C     ----------
C
      INTEGER     INT,    ALF(2),  CH(9),  ZERO,   BLANK
      CHARACTER*8 K8
      DATA        BLANK,  ZERO /   1H ,    1H0 /
C
      IF (INT.LT.-9999999 .OR. INT.GT.+99999999) GO TO 50
      CALL INT2K8 (*50,INT,K8)
      READ (K8,10) ALF
      READ (K8,20) (CH(J),J=2,9)
 10   FORMAT (2A4)
 20   FORMAT (8A1)
      DO 30 J=2,9
      IF (CH(J) .EQ. BLANK) GO TO 40
 30   CONTINUE
      J=10
 40   CH(1)=J-2
      RETURN
C
 50   CH(1) =1
      CH(2) =ZERO
      ALF(1)=ZERO
      ALF(2)=BLANK
      RETURN
      END

      SUBROUTINE GUST1(CASECC,DIT,DLT,FRL,PP,FOL,GUSTL,NFREQ,NLOAD,
     1  XO,V,NOGUST,CASNEW)
C
C     THE PURPOSE OF THI ROUTINE IS TO GERATE PP,GUSTL,FOL.
C
C     THE ROUTINE PROCEEDS AS FOLLOWS
C
C         FIND  GUST CARD(NO-CARDS--SET NOGUST=1 AND RETURN)
C         PUT GUST CARDS IN CORE
C         READ CASECC -- BUILD GUSTL
C           SUPPLU DLOAD =   FROM GUST =
C
C         CALL GUST1A WITH NEW CASECC
C
      INTEGER CASECC,DIT,DLT,FRL,PP,FOL,GUSTL,CASNEW,SYSBUF,NAME(2),
     1 FILE,IGUST(2),LGUST(5)
      REAL  Z(1),RGUST(5)
      COMMON /SYSTEM/SYSBUF
      COMMON /ZZZZZZ/ IZ(1)
      EQUIVALENCE (IZ(1),Z(1)),(RGUST(1),LGUST(1))
      DATA  NAME /4HGUST,1H1 /,IGUST /1005,10 /
      DATA IGST /178/
C
C     INITIALIZE
C
      NZ = KORSZ(IZ)
      IBUF1 = NZ-SYSBUF
      IBUF2 = IBUF1-SYSBUF
      IBUF3 = IBUF2-SYSBUF
      NZ = IBUF3-1
      NOGUST =-1
      NOGO =0
      CALL PRELOC(*1000,IZ(IBUF1),DIT)
      CALL LOCATE(*1000,IZ(IBUF1),IGUST,IDX)
C
C     PUT  GUST CARDS IN CORE
C
      FILE =DIT
      CALL READ(*910,*10,DIT,IZ,NZ,0,NLGUST)
      CALL MESAGE(-8,0,NAME)
   10 CONTINUE
      CALL CLOSE(DIT,1)
      ICC = NLGUST+1
      CALL GOPEN(CASECC,IZ(IBUF1),0)
      CALL GOPEN(CASNEW,IZ(IBUF2),1)
      CALL GOPEN(GUSTL,IZ(IBUF3),1)
      NZ = NZ - NLGUST
C
C     BLAST READ A CASE CONTROL RECORD INTO CORE
C
   20 CONTINUE
      FILE = CASECC
      CALL READ(*100,*30,CASECC,IZ(ICC),NZ,0,LCC)
      CALL MESAGE(-8,0,NAME)
   30 CONTINUE
      IGSID = IZ(ICC+IGST)
      IZ(ICC+12) = IGSID
      CALL ZEROC(RGUST,5)
      IF( IGSID .EQ.  0)  GO TO 90
C
C     FIND GUST ID AMONG GUST CARDS
C
      DO 40 I = 1 ,NLGUST,5
      IF( IZ(I) .EQ. IGSID) GO TO 50
   40 CONTINUE
      CALL MESAGE(31,IGSID,NAME)
      NOGO =1
      GO TO 90
C
C     FOUND GUST CARD
C
   50 CONTINUE
      IZ(ICC+12) = IZ(I+1)
      IGUST(1) =IGSID
      LGUST(2) = IZ(I+1)
      RGUST(3) = Z(I+2)
      RGUST(4) = Z(I+3)
      RGUST(5) = Z(I+4)
      XO =  RGUST(4)
      V  =  RGUST(5)
      NOGUST = 1
C
C     PUT OUT GUSTL /CASNEW
C
   90 CALL WRITE(CASNEW,IZ(ICC),LCC,1)
      CALL WRITE(GUSTL,LGUST,5,1)
      GO TO 20
C
C     END OF FILE ON CASECC
  100 CONTINUE
      IF( NOGO .EQ. 1) CALL MESAGE(-61,0,NAME)
      CALL CLOSE(CASECC,1)
      CALL CLOSE(GUSTL,1)
      CALL CLOSE(CASNEW,1)
C
C     CALL GUST1A FOR LOADS(W)
C
      CALL GUST1A (DLT, FRL, -CASNEW, DIT, PP, 1, NFREQ, NLOAD, FRQSET,
     1             FOL, NOTRD)
      CALL DMPFIL(-PP,IZ,NZ)
 1000 CALL CLOSE(DIT,1)
      RETURN
C
C     FILE  ERRORS
C
  910 IP1 = -2
      CALL MESAGE (IP1, FILE, NAME)
      RETURN
      END

      SUBROUTINE ALGPO (SCR1)
C
      EXTERNAL        ORF
      INTEGER         APRESS,ATEMP,STRML,NAME(2),CORWDS,ITRL(7),TWO(32),
     1                ORF,CASECC,CASECA,GEOM3A,SCR1,LEND(3),SYSBUF,
     2                PGEOM,RD,RDREW,WRT,WRTREW,REW,NOREW,PLOAD2(3),
     3                TEMP(3),TEMPD(3),LREC(5)
      DIMENSION       RREC(5)
      CHARACTER       UFM*23,UWM*25
      COMMON /XMSSG / UFM,UWM
      COMMON /BLANK / APRESS,ATEMP,STRML,PGEOM,IPRTK,IFAIL
      COMMON /SYSTEM/ SYSBUF,NOUT
      COMMON /NAMES / RD,RDREW,WRT,WRTREW,REW,NOREW
      COMMON /TWO   / TWO
      COMMON /ZZZZZZ/ IZ(1)
      EQUIVALENCE     (LREC(1),RREC(1))
      DATA    LEND  / 3*2147483647 /
      DATA    NAME  / 4HALG ,4H    /
      DATA    LABP  / 4HPLOA/      , LABT /4HTEMP/
      DATA    PLOAD2/ 6809,68,199 /, TEMP/5701,57,27/, TEMPD/5641,65,98/
      DATA    CASECC, CASECA,GEOM3A /101,201,202/
C
C     ALG WILL USE OPEN CORE AT IZ
C     ALLOCATE OPEN CORE
C
      NZ    = KORSZ(IZ)
      IBUF1 = NZ - SYSBUF
      IBUF2 = IBUF1 - SYSBUF - 1
      LAST  = IBUF2 - 1
C
C     CHECK FOR SUFFICIENT CORE
C
      IF (LAST .LE. 0) CALL MESAGE (-8,0,NAME)
      LEFT   = CORWDS(IZ(1),IZ(LAST))
      KAPERR = 0
      KATERR = 0
      IFAIL  = 1
C
C     OPEN GEOM3A FOR OUTPUT OF PLOAD2 AND TEMP DATA
C
      CALL GOPEN (GEOM3A,IZ(IBUF1),WRTREW)
C
C     AERODYNAMIC PRESSURE SECTION
C
      IF (APRESS .LT. 0) GO TO 20
      IFILE = SCR1
      CALL OPEN (*901,SCR1,IZ(IBUF2),RDREW)
    8 CALL READ (*11,*10,SCR1,LREC,5,1,NWAR)
   10 IF (LREC(1) .EQ. LABP) GO TO 12
      GO TO 8
C
C     NO PLOAD2 CARDS ON SCR1 FILE
C
   11 KAPERR = 1
      IDP    = 0
      CALL REWIND (SCR1)
      WRITE (NOUT,2001) UWM
      GO TO 20
   12 CONTINUE
C
C     CREATE PLOAD2 RECORD
C
      CALL WRITE (GEOM3A,PLOAD2,3,0)
      IDP = LREC(3)
      GO TO 16
   14 CALL READ (*18,*15,SCR1,LREC,5,1,NWAR)
   15 IF (LREC(1) .NE. LABP) GO TO 18
   16 CALL WRITE (GEOM3A,LREC(3),3,0)
      GO TO 14
   18 CALL WRITE (GEOM3A,IZ,0,1)
      CALL REWIND (SCR1)
C
C     AERODYNAMIC TEMPERATURE SECTION
C
   20 IF (ATEMP .LT. 0) GO TO 35
      IF (APRESS .LT. 0) CALL OPEN (*901,SCR1,IZ(IBUF2),RDREW)
   21 CALL READ (*23,*22,SCR1,LREC,5,1,NWAR)
   22 IF (LREC(1) .EQ. LABT) GO TO 24
      GO TO 21
C
C     NO TEMP CARDS ON SCR1 FILE
C
   23 KATERR = 1
      IDT = 0
      WRITE (NOUT,2002) UWM
      GO TO 35
   24 CONTINUE
C
C     CREATE TEMP RECORD
C
      CALL WRITE (GEOM3A,TEMP,3,0)
      IDT   = LREC(3)
      DTEMP = RREC(5)
      ITPD  = 1
      GO TO 28
   26 CALL READ (*30,*27,SCR1,LREC,5,1,NWAR)
   27 IF (LREC(1) .NE. LABT) GO TO 30
   28 CALL WRITE (GEOM3A,LREC(3),3,0)
      ITPD = ITPD + 1
      IF (ITPD .LE. 3) DTEMP = DTEMP + RREC(5)
      GO TO 26
   30 CALL WRITE (GEOM3A,IZ,0,1)
C
C     CREATE TEMPD RECORD. AVERAGE FIRST THREE TEMPS. ON BLADE ROOT.
C
      CALL WRITE (GEOM3A,TEMPD,3,0)
      CALL WRITE (GEOM3A,IDT,1,0)
      DTEMP = DTEMP/3.0
      CALL WRITE (GEOM3A,DTEMP,1,1)
C
C     CLOSE GEOM3A
C
   35 CALL WRITE (GEOM3A,LEND,3,1)
      CALL CLOSE (GEOM3A,1)
      ITRL(1) = GEOM3A
      ITRL(2) = 0
      ITRL(3) = 0
      ITRL(4) = 0
      ITRL(5) = 0
      ITRL(6) = 0
      ITRL(7) = 0
      IF (APRESS.LT.0 .OR. KAPERR.EQ.1) GO TO 40
      IBIT = 68
      I1 = (IBIT-1)/16 + 2
      I2 = IBIT - (I1-2)*16 + 16
      ITRL(I1) = ORF(ITRL(I1),TWO(I2))
   40 IF (ATEMP.LT.0 .OR. KATERR.EQ.1) GO TO 50
      IBIT = 57
      I1 = (IBIT-1)/16 + 2
      I2 = IBIT - (I1-2)*16 + 16
      ITRL(I1) = ORF(ITRL(I1),TWO(I2))
      IBIT = 65
      I1 = (IBIT-1)/16 + 2
      I2 = IBIT - (I1-2)*16 + 16
      ITRL(I1) = ORF(ITRL(I1),TWO(I2))
   50 CALL WRTTRL (ITRL)
C
C     CLOSE SCR1
C
      IF (APRESS.GE.0 .OR. ATEMP.GE.0) CALL CLOSE (SCR1,1)
      IF (KAPERR .EQ. 1) APRESS = -1
      IF (KATERR .EQ. 1) ATEMP  = -1
C
C     SET IFAIL TO INDICATE ALG MODULE FAILED. CONDITIONAL JUMP BASED
C     ON VALUE OF IFAIL IS PERFORMED AFTER EXITING FROM ALG MODULE.
C
      IF (APRESS.EQ.-1 .AND. ATEMP.EQ.-1) IFAIL = -1
C
C     NEW CASE CONTROL DATA BLOCK
C     OPEN CASECC AND COPY ALL SUBCASES WITH CHANGES MADE TO
C     STATIC AND THERMAL LOAD ID-S
C
      IFILE = CASECC
      CALL OPEN (*901,CASECC,IZ(IBUF1),RDREW)
      CALL FWDREC (*902,CASECC)
      CALL GOPEN (CASECA,IZ(IBUF2),WRTREW)
   60 CALL READ (*70,*65,CASECC,IZ,LEFT,1,NWDS)
   65 IZX = 4
      IZ(IZX) = IDP
      IZX = 7
      IZ(IZX) = IDT
      CALL WRITE (CASECA,IZ,NWDS,1)
      GO TO 60
   70 CALL CLOSE (CASECC,1)
      CALL CLOSE (CASECA,1)
      ITRL(1) = CASECC
      CALL RDTRL (ITRL)
      ITRL(1) = CASECA
      CALL WRTTRL (ITRL)
      GO TO 999
  901 CALL MESAGE (-1,IFILE,NAME)
      GO TO 999
  902 CALL MESAGE (-2,IFILE,NAME)
      GO TO 999
  999 RETURN
C
 2001 FORMAT (A25,' - ALG MODULE - AERODYNAMIC PRESSURES REQUESTED VIA',
     1       ' PARAM APRESS, BUT NOUT3=0 IN AERODYNAMIC INPUT', /41X,
     2       'OR AERODYNAMIC CALCULATION FAILED. REQUEST IGNORED.')
 2002 FORMAT (A25,' - ALG MODULE - AERODYNAMIC TEMPERATURES REQUESTED ',
     1       'VIA PARAM ATEMP, BUT NOUT3=0 IN AERODYNAMIC INPUT' ,/41X,
     2       'OR AERODYNAMIC CALCULATION FAILED. REQUEST IGNORED.')
      END

      SUBROUTINE PLA4B (KE,J)
C*****
C THIS ROUTINE IS THE INSERTION ROUTINE FOR THE PLA4 MODULE.  IT ADDS
C THE 6 X 6 DOUBLE PRECISION MATRIX KE TO THE SUBMATRIX OF ORDER
C 6 X JMAX
C*****
      DOUBLE PRECISION
     1                   DZ(1)              ,KE(36)
C
C
C
      INTEGER
     1                   FROWIC             ,IZ(1)
C
C VARIABLE CORE
C
      COMMON   /ZZZZZZ/
     1                   Z(1)
C
C PLA42 COMMUNICATIONS BLOCK
C
      COMMON   /PLA42C/
     1                   IDUM5(6)
     2,                  IGPCT              ,NGPCT
     3,                  IPOINT             ,NPOINT
     4,                  I6X6K              ,N6X6K
     5,                  IDUM11(12)
     6,                  JMAX               ,FROWIC
     7,                  LROWIC             ,NROWSC
     8,                  IDUM(121)
C
C
C
      EQUIVALENCE
     1                   (DZ(1),Z(1),IZ(1))
C
C SEARCH THE GPCT AND FIND AN INDEX M SUCH THAT
C IABS(GPCT(M)) .LE. J .LT. IABS(GPCT(M+1))
C
      LOW = IGPCT + 1
      LIM = NGPCT + LOW - 2
      IF (LOW .GT. LIM) GO TO 15
      DO 10 I = LOW,LIM
      ISAVE = I
      IF (J .GE. IABS(IZ(I+1)) ) GO TO 10
      IF (J .GE. IABS(IZ(I)) ) GO TO 20
   10 CONTINUE
      IF (J .GE. IABS(IZ(ISAVE+1)) ) ISAVE = ISAVE + 1
      GO TO 20
   15 ISAVE = LOW
C
C ADD KE TO THE SUBMATRIX
C
   20 L1 = FROWIC - 1
      JJ = IPOINT + ISAVE - IGPCT
      J2 = IZ(JJ) - 1
      I1 = 0
      LIM = NROWSC - 1
   30 IF (I1 .GT. LIM) RETURN
      K1 = I6X6K + I1*JMAX + J2
      J1 = 0
      L  = 6*L1
      K  = K1
   40 J1 = J1 + 1
      IF (J1 .GT. 6) GO TO 50
      K  = K + 1
      L  = L + 1
      DZ(K) = DZ(K) + KE(L)
      GO TO 40
   50 I1 = I1 + 1
      L1 = L1 + 1
      GO TO 30
      END

      SUBROUTINE GFSHC(AWY,NUY,HC,IDENT,AC,MROW)
C
C     ROUTINE TO GENERATE CONSTRAINT MATRIX FOR PURELY INCOMPRESSIBLE
C     FORMULATION WHEN NO SPC'S ARE ON FLUID
C
      DOUBLE PRECISION        DZ(1)    ,DTERM    ,VAL
C
      REAL          RZ(1)
C
      INTEGER       Z        ,SYSBUF   ,MCB(7)   ,NAME(2)  ,HC
     1             ,TI1      ,TO1      ,TO2      ,AWY      ,SCR
     2             ,AC
C
C     OPEN CORE
C
      COMMON / ZZZZZZ /        Z(1)
C
C     SYSTEM COMMON
C
      COMMON / SYSTEM /       SYSBUF
C
C     PACK - UNPACK COMMON BLOCKS
C
      COMMON / PACKX /        TI1      ,TO1      ,I1       ,N1
     1                       ,INCR1
      COMMON / UNPAKX /       TO2      ,I2       ,N2       ,INCR2
      COMMON / ZBLPKX /       A(4)     ,IROW
C
      EQUIVALENCE   ( Z(1) , RZ(1) , DZ(1) )
     1             ,( VAL , A(1) )
C
      DATA NAME / 4HGFSH , 4HC    /
C
C
C     ALLOCATE CORE
C
      NZ = KORSZ(Z(1))
      IBUF = NZ - SYSBUF
      NZ = IBUF - 1
      IF(NZ .LT. NUY) GO TO 1008
C
C     FORM A COLUMN VECTOR OF ONES
C
      TI1 = 1
      TO1 = 2
      I1 = 1
      N1 = NUY
      INCR1 = 1
      DO 30 I=1,NUY
   30 RZ(I) = 1.0
      CALL MAKMCB(MCB,IDENT,NUY,2,2)
      CALL GOPEN(IDENT,Z(IBUF),1)
      CALL PACK(RZ(1),IDENT,MCB)
      CALL CLOSE(IDENT,1)
      CALL WRTTRL(MCB)
C
      CALL SSG2B(AWY,IDENT,0,AC,0,2,1,SCR)
C
C     PERFORM MULTIPLY TO GET COMPRESSIBLITY MATRIX
C
C
C     UNPACK ROW OF AC INTO CORE
C
      MCB(1) = AC
      CALL RDTRL(MCB)
      NROW = MCB(3)
      IF(NZ .LT. 2*NROW) GO TO 1008
      TO2 = 2
      I2 = 1
      N2 = NROW
      INCR2 = 1
C
      CALL GOPEN(AC,Z(IBUF),0)
      CALL UNPACK(*40,AC,DZ(1))
      GO TO 60
C
C     AC IS NULL
C
   40 DO 50 I=1,NROW
   50 DZ(I) = 0.0D0
C
   60 CALL CLOSE(AC,1)
C
C     LOCATE LARGEST TERM IN AC
C
      DTERM = -1.0D10
      DO 210 I=1,NROW
      IF(DZ(I) .LE. DTERM) GO TO 210
      MROW = I
      DTERM = DZ(I)
  210 CONTINUE
C
C     GENERATE THE HC MATRIX
C
      CALL MAKMCB(MCB,HC,NROW,1,2)
      CALL GOPEN(HC,Z(IBUF),1)
C
C     GENERATE COLUMNS UP TO MROW
C
      IF(MROW .EQ. 1) GO TO 230
      MR = MROW - 1
      DO 220 IR = 1,MR
      CALL BLDPK(2,2,HC,0,0)
      IROW = IR
      VAL = 1.0D0
      CALL ZBLPKI
      IROW = MROW
      VAL = -DZ(IR) / DTERM
      CALL ZBLPKI
  220 CALL BLDPKN(HC,0,MCB)
C
C     PACK OUT NULL COLUMN FOR MROW
C
  230 CALL BLDPK(2,2,HC,0,0)
      CALL BLDPKN(HC,0,MCB)
C
C     GENERATE REMAINING ROWS
C
      IF(MROW .GE. NROW) GO TO 250
      MR = MROW + 1
      DO 240 IR=MR,NROW
      CALL BLDPK(2,2,HC,0,0)
      IROW = MROW
      VAL = -DZ(IR) / DTERM
      CALL ZBLPKI
      IROW = IR
      VAL = 1.0D0
      CALL ZBLPKI
  240 CALL BLDPKN(HC,0,MCB)
C
  250 CALL CLOSE(HC,1)
      CALL WRTTRL(MCB)
C
      RETURN
C
C     ERRORS
C
 1008 CALL MESAGE(-8,0,NAME)
      RETURN
      END

      SUBROUTINE ALGAP (IFNAME,IFNM)
C
C     THIS ROUTINE IS A MODIFIED VERSION OF SUBROUTINE TABPCH. IT WILL
C     ONLY PUNCH ONE TABLE INTO DTI CHARDS.
C
C     CONTINUATION CARD CHARACTERS ARE - AL.
C
C     SINGLE FIELD CARDS WILL BE MADE UNLESS REAL NUMBERS ARE TO BE MADE
C     ALL REAL NUMBERS ARE ASSUMED TO BE SINGLE PRECISION.
C
C  $MIXED_FORMATS
C
      INTEGER         SYSBUF   ,IZ(10)   ,NAME(2)  ,INT(2)   ,IREAL(2) ,
     1                MCB(7)   ,FILE     ,TABNM(2) ,DTI(2)   ,DTIS(2)  ,
     2                IDATA(20),ENDREC(2),OUT      ,IFORM(20),BLANK    ,
     3                IBCD(2)  ,INTD(2)  ,IBCDD(2) ,PFORM(30),LL(4)    ,
     4                FORM(30,2)         ,FORMS(30,2)
      REAL            RDATA(20)
      CHARACTER       UFM*23   ,UWM*25   ,UIM*29
      COMMON /XMSSG / UFM      ,UWM      ,UIM
      COMMON /SYSTEM/ KSYSTM(100)
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE     (KSYSTM( 1),SYSBUF),(KSYSTM(2),OUT ),
     1                (KSYSTM(91),LPUNCH),(IZ(1)    ,Z(1)),
     2                (IDATA(1),RDATA(1))
      DATA    BLANK / 1H             /
      DATA    DTI   / 4HDTI , 1H     /
      DATA    DTIS  / 4HDTI*, 1H     /
      DATA    ENDREC/ 4HENDR, 4HEC   /
      DATA    FORMS / 4H(2A4, 26*4H    ,4H,1H+ ,4HA2,I,4H5)  ,
     1                4H(A1,, 4HA2,I   ,4H5    ,24*4H        ,4H,1H+  ,
     2                4HA2,I, 4H5)   /
      DATA    IBCD  / 4H,2A4, 1H     /
      DATA    IBCDD / 4H,2A4, 4H,8X  /
      DATA    INT   / 4H,I8 , 1H     /
      DATA    INTD  / 4H,I16, 1H     /
      DATA    IPLUS / 1H+            /
      DATA    IREAL / 4H,E16, 4H.9   /
      DATA    ISTAR / 1H*            /
      DATA    NAME  / 4HALGA, 4HP    /
      DATA    N1    / 2HAL           /
      DATA    LL    / 3, 1, 3, 2     /
C
      NZ   = KORSZ(Z)
      IBUF = NZ - SYSBUF + 1
      NZ   = IBUF - 1
      IF (NZ .LE. 10) CALL MESAGE (-8,0,NAME)
      NREAD = NZ/2  - 2
      NLIST = NREAD + 3
      DO 5 J = 1,2
      DO 5 I = 1,30
      FORM(I,J) = FORMS(I,J)
    5 CONTINUE
C
C     FOR EACH  TABLE DEFINED
C
      MCB(1) = IFNM
      CALL RDTRL(MCB)
      IF (MCB(1) .LE. 0) GO TO 310
C
C     TABLE EXISTS SET IT UP
C
      FILE = IFNM
      CALL OPEN (*320,FILE,IZ(IBUF),0)
      CALL READ (*340,*350,FILE,IZ(1),-2,0,ILEN)
      CALL FNAME (IFNAME,TABNM)
      IRECNO = 0
      ICHR   = N1
      IZ(3)  = 0
C
C     SET UP FIRST RECORD
C
      IZ(1) = TABNM(1)
      IZ(2) = TABNM(2)
      IZ(4) = MCB(2)
      IZ(5) = MCB(3)
      IZ(6) = MCB(4)
      IZ(7) = MCB(5)
      IZ(8) = MCB(6)
      IZ(9) = MCB(7)
      CALL READ (*290,*10,FILE,IZ(10),NREAD,0,ILEN)
      CALL MESAGE (-8,0,NAME)
   10 ILEN = ILEN + 11
   11 IZ(ILEN-1) = ENDREC(1)
      IZ(ILEN  ) = ENDREC(2)
      GO TO 40
C
C     BRING IN NEXT RECORD
C
   20 CALL READ (*290,*30,FILE,IZ(4),NREAD,0,ILEN)
      CALL MESAGE (-8,0,NAME)
   30 IZ(3) = IZ(3) + 1
      IF (ILEN .EQ. 0) GO TO 20
      ILEN = ILEN + 5
      GO TO 11
C
C     BUILD FORMAT VECTOR  1= INTEGER, 2 =BCD, 3=REAL
C
   40 DO 50 K = 1,ILEN
      M = NLIST + K - 1
      J = NUMTYP(IZ(K))
      IZ(M) = LL(J+1)
   50 CONTINUE
C
C     MOVE DATA/FORMAT TO DATA AREA 8 FIELDS AT A TIME--SET D.F. FLAG
C
      ID = 1
      IF = NLIST
      IFRS = 1
C
C     HERE FOR EIGHT MORE WORDS
C
   60 IDF = 0
      IDT = 1
      IFT = 1
      NF  = 1
C
C     HERE  FOR EACH FIELD
C
   70 IDATA(IDT) = IZ(ID)
      IFORM(IFT) = IZ(IF)
      IF (IFORM(IFT) .EQ. 3) IDF = 1
      IF (IFORM(IFT) .NE. 2) GO TO 80
C
C     BCD IS TWO WORDS
C
      IDATA(IDT+1) = IZ(ID+1)
C
C     MAY BE FALSE BCD, CHECK FORMAT OF SECOND WORD ALSO
C     ( SOME REAL NUMBER BIT PATTERNS LOOK LIKE BCD ).
C
      IF (IZ(IF+1) .EQ. 2) GO TO 100
C
C     SECOND WORD IS NOT BCD, ASSUME FIRST WORD IS REAL.
C
      IDF = 1
      IFORM(IFT) = 3
      GO TO 80
  100 IDT = IDT + 2
      IFT = IFT + 1
      ID  = ID  + 2
      IF  = IF  + 2
      GO TO 90
C
C     REAL OR INTEGER
C
   80 IDT = IDT + 1
      IFT = IFT + 1
      ID  = ID  + 1
      IF  = IF  + 1
C
C     BUMP FIELD COUNTER
C
   90 NF = NF + 1
      IF (NF .GT. 8) GO TO 110
      IF (ID .LT. ILEN) GO TO 70
C
C     FILL  WITH BLANKS
C
      IDATA(IDT  ) = BLANK
      IDATA(IDT+1) = BLANK
      IFORM(IFT  ) = 2
      GO TO 100
C
C     PUNCH OUT 8 FIELDS OF DATA
C
  110 IDT = 0
      IF (IDF .NE. 0) GO TO 200
C
C     SINGLE FIELD CARD
C
      NF = 1
  120 M = 2*NF + 2
      IF (IFORM(NF)-2) 130,150,160
C
C     INTEGER
C
  130 FORM(M  ,IFRS) = INT(1)
      FORM(M+1,IFRS) = INT(2)
C
C     GET NEXT ITEM
C
      IDT = IDT + 1
  140 NF  = NF  + 1
      IF (NF .LE. 8) GO TO 120
      GO TO 170
C
C     BCD
C
  150 FORM(M  ,IFRS) = IBCD(1)
      FORM(M+1,IFRS) = IBCD(2)
      IDT = IDT + 2
      GO TO 140
C
C     REAL NOT LEGAL
C
  160 CALL MESAGE (-61,0,NAME)
      RETURN
C
C     PUNCH OUT SINGLE CARD
C
  170 IF (IFRS .NE. 1) GO TO 190
      DO 171 J = 1,30
      PFORM(J) = FORM(J,1)
  171 CONTINUE
      WRITE (LPUNCH,PFORM,ERR=173) DTI,(RDATA(M),M=1,IDT),ICHR,IRECNO
  173 IRECNO = IRECNO + 1
      IFRS = 2
      DO 175 J = 1,30
  175 FORM(J,1) = FORMS(J,1)
  180 IF (ID .GE. ILEN) GO TO 20
      GO TO 60
C
C     CONTINUATION CARD
C
  190 IRCNM1 = IRECNO - 1
      DO 191 J = 1,30
      PFORM(J) = FORM(J,2)
  191 CONTINUE
      WRITE (LPUNCH,PFORM,ERR=193)
     1      IPLUS,ICHR,IRCNM1,(RDATA(M),M=1,IDT),ICHR,IRECNO
  193 IRECNO = IRECNO + 1
      DO 195 J = 1,30
  195 FORM(J,2) = FORMS(J,2)
      GO TO 180
C
C     DOUBLE FIELD CARDS
C
  200 NF = 1
      IS = 1
      IT = 4
      IDT= 0
      M  = 2
  210 M  = M + 2
      IF (IFORM(NF)-2) 211,240,250
C
C     INTEGER
C
  211 FORM(M  ,IFRS) = INTD(1)
      FORM(M+1,IFRS) = INTD(2)
  220 IDT = IDT + 1
  230 NF  = NF  + 1
      IF (M .LE. 8) GO TO 210
      GO TO 260
C
C     BCD
C
  240 FORM(M  ,IFRS) = IBCDD(1)
      FORM(M+1,IFRS) = IBCDD(2)
      IDT = IDT + 2
      GO TO 230
C
C     REAL
C
  250 FORM(M  ,IFRS) = IREAL(1)
      FORM(M+1,IFRS) = IREAL(2)
      GO TO 220
C
C     PUNCH OUT DOUBLE FIELD CARD
C
  260 IF (IFRS .NE. 1) GO TO 280
      DO 261 J = 1,30
      PFORM(J) = FORM(J,1)
  261 CONTINUE
      WRITE (LPUNCH,PFORM,ERR=263) DTIS,(RDATA(M),M=IS,IDT),ICHR,IRECNO
  263 IRECNO = IRECNO + 1
      DO 265 J = 1,30
  265 FORM(J,1) = FORMS(J,1)
      IFRS = 2
  270 IT = 8
      M  = 2
      IS = IDT + 1
      GO TO 210
C
C     CONTINUATION CARD
C
  280 IRCNM1 = IRECNO - 1
      DO 281 J = 1,30
      PFORM(J) = FORM(J,2)
  281 CONTINUE
      WRITE (LPUNCH,PFORM,ERR=283)
     1      ISTAR,ICHR,IRCNM1,(RDATA(M),M=IS,IDT),ICHR,IRECNO
  283 IRECNO = IRECNO + 1
      DO 285 J = 1,30
  285 FORM(J,2) = FORMS(J,2)
      IF (IT .EQ. 4) GO TO 270
      GO TO 180
C
C     CLOSE OFF FILES
C
  290 CALL CLOSE (FILE,1)
      WRITE  (OUT,300) UIM,TABNM,IRECNO
  300 FORMAT (A29,' 4015.', /5X,'TABLE NAMED ',2A4,' PUNCHED ONTO',I9,
     1        ' CARDS.')
  310 CONTINUE
      WRITE  (LPUNCH,311)
  311 FORMAT (1H , /,1H , /,1H )
      RETURN
C
C     ERROR MESAGES
C
  320 IP1 = -1
  330 CALL MESAGE (IP1,FILE,NAME)
      CALL MESAGE (-61,0,NAME)
  340 IP1 =-2
      GO TO 330
  350 IP1 =-3
      GO TO 330
      END

      SUBROUTINE GMMATS (A,IROWA,ICOLA,MTA, B,IROWB,ICOLB,NTB, C)
C*****
C     GMMATS - G E N E R A L  M A T R I X  M U L T I P L Y
C                                 A N D
C                           T R A N S P O S E
C            S I N G L E  P R E C I S I O N  V E R S I O N
C
C     PERFORMS                                     WHEN
C               A            *  B            =  C     MTA=0  NTB= 0
C               A            *  B TRANSPOSE  =  C          0       1
C               A TRANSPOSE  *  B            =  C          1       0
C               A TRANSPOSE  *  B TRANSPOSE  =  C          1       1
C*****
C     A -  IS A MATRIX (ROWA) ROWS BY (COLA) COLUMNS
C     B -  IS A MATRIX (ROWB) ROWS BY (COLB) COLUMNS
C     A,B AND C ARE STORED BY ROWS (EXAMPLE)
C              MATRIX                   STORED
C         A=   1    2              A=   1
C              3    4                   2
C              5    6                   3
C                                       4
C                                       5
C                                       6
C*****
C*****
C
C
C     IF MTA .LT. 0, C IS NOT ZEROED OUT.  HENCE THE ROUTINE, IN THIS
C     CASE, COMPUTES  A * B  +  D  =  C  WHERE THE MATRIX  D  HAS BEEN
C     STORED ROW-WISE AT  C  BY THE CALLING PROGRAM.  IF MTA = -1,  A
C     IS TRANSPOSED.  IF MTA = -2,  A  IS NOT TRANSPOSED.  NTB IS
C     DEFINED AS ABOVE AND IS INDEPENDENT OF MTA.
C
C
      INTEGER   ROWA,COLA,  ROWB,COLB
C
C
C
      DIMENSION   A(1),B(1),C(1),IPARM(2)
C
C
C
      ROWA = IROWA
      COLA = ICOLA
      ROWB = IROWB
      COLB = ICOLB
      NTA = IABS(MTA)
      IF (MTA .EQ. (-2)) NTA = 0
      IF (NTA .EQ. 0  .AND.  NTB .EQ. 0) IF (COLA - ROWB) 80,5,80
      IF (NTA .EQ. 1  .AND.  NTB .EQ. 0) IF (ROWA - ROWB) 80,5,80
      IF (NTA .EQ. 0  .AND.  NTB .EQ. 1) IF (COLA - COLB) 80,5,80
      IF (NTA .EQ. 1  .AND.  NTB .EQ. 1) IF (ROWA - COLB) 80,5,80
    5 IF (NTA .EQ. 1) GO TO 10
      ILIM= ROWA
      KLIM= COLA
      INCI= COLA
      INCKA= 1
      GO TO 20
   10 ILIM= COLA
      KLIM= ROWA
      INCI= 1
      INCKA= COLA
   20 IF(NTB.EQ.1) GO TO 30
      JLIM= COLB
      INCJ= 1
      INCKB= COLB
      GO TO 40
   30 JLIM= ROWB
      INCJ= COLB
      INCKB= 1
   40 IF (MTA .LT. 0) GO TO 47
      LIM = ILIM * JLIM
      DO 45 I = 1,LIM
   45 C(I) = 0.0
   47 IJ = 0
      I = 0
   50 I = I + 1
      IFIX=I*INCI-COLA
      J = 0
   60 J = J + 1
      IJ=IJ+1
      IA=IFIX
      JB=J*INCJ-COLB
      K = 0
   70 K = K + 1
      IA=IA+INCKA
      JB=JB+INCKB
      C(IJ)=C(IJ)+ A(IA) * B(JB)
      IF (K .LT. KLIM) GO TO 70
      IF (J .LT. JLIM) GO TO 60
      IF (I .LT. ILIM) GO TO 50
      RETURN
   80 IPARM(1) = NTA
      IPARM(2) = NTB
      CALL MESAGE (-30,21,IPARM(1))
      RETURN
      END

      SUBROUTINE SBAR2( TI )
C******
C THIS ROUTINE IS THE PHASE II SUBROUTINE OF STRESS DATA RECOVERY FOR
C THE BEAM ELEMENT.
C******
C
      REAL    I1       ,I2       ,L        ,M1A      ,M2A      ,M1B
     1,       M2B      ,I12      ,K1A      ,K2A      ,K1B      ,K2B
     2,       TI(14)    ,FRLAST(2)
      INTEGER TLOADS   ,EJECT    ,ISHED(7)
C
C
      COMMON   /SYSTEM/  IBFSZ    ,NOUT     ,IDM(9)   ,LINE
C
C SDR2 VARIABLE CORE
C
      COMMON   /ZZZZZZ/  ZZ(1)
C
C BLOCK FOR POINTERS, LOADING TEMPERATURE AND ELEMENT DEFORMATION.
C
      COMMON   /SDR2X4/
     1                   XXXXXX(33)         ,ICSTM
     2,                  NCSTM              ,IVEC
     3,                  IVECN              ,LDTEMP
     4,                  ELDEFM             ,DUM8(8),TLOADS
C
C THE FIRST 100 LOCATIONS OF THE SDR2X7 BLOCK ARE RESERVED FOR INPUT
C PARAMETERS, THE SECOND 100 FOR STRESS OUTPUT PARAMETERS, AND FORCE
C OUTPUT PARAMETERS BEGIN AT LOCATION 201.
C
      COMMON   /SDR2X7/
     1                   JELID              ,JSILNO(2)
     2,                  SA(36)             ,SB(36)
     3,                  ST                 ,SDELTA
     4,                  A                  ,FJ
     5,                  I1                 ,I2
     6,                  I12                ,C1
     7,                  C2                 ,D1
     8,                  D2                 ,F1
     9,                  F2                 ,G1
     T,                  G2                 ,T SUB 0
     1,                  SIGMAT             ,SIGMAC
     2,                  L                  ,THERM(6)
C
C     THERM ACTUALLY HAS 30 VALUES
C
      COMMON   /SDR2X7/
     1                   ISELID             ,SIG1A
     2,                  SIG2A              ,SIG3A
     3,                  SIG4A              ,SIGAX
     4,                  SIGAMX             ,SIGAMN
     5,                  MSTEN              ,SIG1B
     6,                  SIG2B              ,SIG3B
     7,                  SIG4B              ,SIGBMX
     8,                  SIGBMN             ,MSCOM
     9,                  YYYYYY(84)
      COMMON   /SDR2X7/
     1                   IFELID             ,M1A
     2,                  M2A                ,M1B
     3,                  M2B                ,V1
     4,                  V2                 ,FX
     5,                  T
C
C SDR2 SCRATCH BLOCK
C
      COMMON   /SDR2X8/
     1                   FA(6)              ,FB(6)
     2,                  IDISP              ,IUA
     3,                  IUB                ,P1
     4,                  K1A                ,K2A
     5,                  K1B                ,K2B
     6,                  Q                  ,W
     7,                  CFA(6)             ,CFB(6)
     8,                  CFRVEC(10)         ,FRVEC(10)
C
C  STRESS/FORCE PRECISION CHECK
C
      COMMON   /SDR2X9/
     1                   NCHK               ,ISUB
     2,                  ILD                ,FRTMEI(2)
     3,                  TWOTOP             ,FNCHK
C
      EQUIVALENCE
     1                   (LDTEMP,TEMPLD)    ,(MSTEN,SMTEN)
     2,                  (MSCOM,SMCOM)      ,(ISHED(6),FRLAST(1))
     3,                  (IEID,CFRVEC(1))
     4,                  (ISHED(1),LSUB)    ,(ISHED(2),LLD)
C
      DATA LLD, LSUB, FRLAST / 2*-100, -1.0E30, -1.0E30 /
C
      IDISP = IVEC - 1
      IUA = IDISP + JSILNO(1)
      CALL SMMATS (SA(1),6,6,0, ZZ(IUA),6,1,0,  FA,CFA )
      IUB = IDISP + JSILNO(2)
      CALL SMMATS (SB(1),6,6,0, ZZ(IUB),6,1,0,  FB,CFB )
      P1  =  FA(1) + FB(1)
      V1  = -FA(2) - FB(2)
      V2  = -FA(3) - FB(3)
      T   = -FA(4) - FB(4)
      M2A =  FA(5) + FB(5)
      M1A = -FA(6) - FB(6)
      FX  = -P1 - SDELTA * ELDEFM
      CFRVEC(2) = CFA(6) + CFB(6)
      CFRVEC(3) = CFA(5) + CFB(5)
      CFRVEC(9) = CFA(4) + CFB(4)
      CFRVEC(7) = CFA(3) + CFB(3)
      CFRVEC(6) = CFA(2) + CFB(2)
      CFRVEC(8) = CFA(1) + CFB(1)
C
C IF LDTEMP = -1, THE LOADING TEMPERATURE IS UNDEFINED
C
      IF( TLOADS .EQ. 0 ) GO TO 10
      TSAVE = TI(2)
      TI(2) = (TI(1) + TI(2))/2.0  -  TSUB0
      CALL GMMATS( THERM,6,5,0,  TI(2),5,1,0,  FA(1) )
      TI(2) = TSAVE
      FX = FX - FA(1)
      V1 = V1 - FA(2)
      V2 = V2 - FA(3)
      T  = T - FA(4)
      M2A = M2A + FA(5)
      M1A = M1A - FA(6)
   10 M1B = M1A - V1*L
      M2B = M2A - V2*L
      CFRVEC(4) = CFRVEC(2) + CFRVEC(6) * L
      CFRVEC(5) = CFRVEC(3) + CFRVEC(7) * L
      FRVEC(2) = M1A
      FRVEC(3) = M2A
      FRVEC(4) = M1B
      FRVEC(5) = M2B
      FRVEC(6) = V1
      FRVEC(7) = V2
      FRVEC(8) = FX
      FRVEC(9) = T
C*****
C COMPUTE ELEMENT STRESSES AT 4 POINTS
C*****
C
C COMPUTE K1A AND K2A
C
      IF (I12 .NE. 0.0) GO TO 30
      IF (I1 .NE. 0.0) GO TO 20
      K1A = 0.0
      GO TO 40
   20 K1A = -M1A / I1
      GO TO 40
   30 K1A = (M2A * I12  -  M1A * I2) / (I1 * I2  -  I12**2)
      K2A = (M1A * I12  -  M2A * I1) / (I1 * I2  -  I12**2)
      GO TO 60
   40 IF (I2 .NE. 0.0) GO TO 50
      K2A = 0.0
      GO TO 60
   50 K2A = -M2A / I2
C
C COMPUTE SIG1A, SIG2A, SIG3A AND SIG4A
C
   60 SIG1A = K1A * C1  +  K2A * C2
      SIG2A = K1A * D1  +  K2A * D2
      SIG3A = K1A * F1  +  K2A * F2
      SIG4A = K1A * G1  +  K2A * G2
C
C COMPUTE K1B AND K2B
C
      IF (I12 .NE. 0.0) GO TO 80
      IF (I1 .NE. 0.0) GO TO 70
      K1B = 0.0
      GO TO 90
   70 K1B = -M1B / I1
      GO TO 90
   80 K1B = (M2B * I12  -  M1B * I2) / (I1 * I2  -  I12**2)
      K2B = (M1B * I12  -  M2B * I1) / (I1 * I2  -  I12**2)
      GO TO 110
   90 IF (I2 .NE. 0.0) GO TO 100
      K2B = 0.0
      GO TO 110
  100 K2B = -M2B / I2
C
C COMPUTE SIG1B, SIG2B, SIG3B AND SIG4B
C
  110 SIG1B = K1B * C1  +  K2B * C2
      SIG2B = K1B * D1  +  K2B * D2
      SIG3B = K1B * F1  +  K2B * F2
      SIG4B = K1B * G1  +  K2B * G2
      IF( TLOADS .EQ. 0 ) GO TO 115
C
C     TEST IF AT LEAST ONE POINT TEMPERATURE IS GIVEN
C
      DO 111 I = 7,14
      IF( TI(I) .NE. 0.0 ) GO TO 112
  111 CONTINUE
      GO TO 115
  112 IF( A .EQ. 0.0 ) GO TO 115
      EALF =-ST / A
      SIG1A = SIG1A + EALF*(TI(7) - TI(3)*C1 - TI(5)*C2 - TI(1))
      SIG2A = SIG2A + EALF*(TI(8) - TI(3)*D1 - TI(5)*D2 - TI(1))
      SIG3A = SIG3A + EALF*(TI(9) - TI(3)*F1 - TI(5)*F2 - TI(1))
      SIG4A = SIG4A + EALF*(TI(10) - TI(3)*G1 - TI(5)*G2 - TI(1))
      SIG1B = SIG1B + EALF*(TI(11) - TI(4)*C1 - TI(6)*C2 - TI(2))
      SIG2B = SIG2B + EALF*(TI(12) - TI(4)*D1 - TI(6)*D2 - TI(2))
      SIG3B = SIG3B + EALF*(TI(13) - TI(4)*F1 - TI(6)*F2 - TI(2))
      SIG4B = SIG4B + EALF*(TI(14) - TI(4)*G1 - TI(6)*G2 - TI(2))
  115 CONTINUE
C
C COMPUTE AXIAL STRESS
C
      CFRVEC(10) = 0.0
      SIGAX = 0.0
      IF (A .NE. 0.0) SIGAX = FX / A
      IF (A.NE.0.0) CFRVEC(10) = CFRVEC(8) / A
      FRVEC(10) = SIGAX
C
C COMPUTE MAXIMA AND MINIMA
C
      SIGAMX = SIGAX + AMAX1(SIG1A,SIG2A,SIG3A,SIG4A)
      SIGBMX = SIGAX + AMAX1(SIG1B,SIG2B,SIG3B,SIG4B)
      SIGAMN = SIGAX + AMIN1(SIG1A,SIG2A,SIG3A,SIG4A)
      SIGBMN = SIGAX + AMIN1(SIG1B,SIG2B,SIG3B,SIG4B)
C
C COMPUTE MARGIN OF SAFETY IN TENSION
C
      IF(SIGMAT.LE.0.0)GO TO 620
      IF(AMAX1(SIGAMX,SIGBMX).LE.0.0) GO TO 620
      Q=SIGMAT/AMAX1(SIGAMX,SIGBMX)
      SMTEN=Q-1.0
      GO TO 630
  620 MSTEN=1
C
C      COMPUTE MARGIN OF SAFETY IN COMPRESSION
C
  630 IF(SIGMAC .LE. 0.0) GO TO 640
      IF(AMIN1(SIGAMN,SIGBMN).GE.0.0) GO TO 640
      W = -SIGMAC/AMIN1(SIGAMN,SIGBMN)
      SMCOM=W-1.0
      GO TO 150
  640 MSCOM=1
  150 ISELID = JELID
      IFELID = JELID
C
C  . STRESS CHECK...
C
      IF (NCHK.LE.0) GO TO 230
      IEID = JELID
      K = 0
      CALL SDRCHK (FRVEC(2),CFRVEC(2),9,K)
C
      IF (K.EQ.0) GO TO 230
C
C  . LIMITS EXCEEDED...
      J = 0
      IF (LSUB.EQ.ISUB .AND. FRLAST(1).EQ.FRTMEI(1) .AND.
     1    LLD .EQ.ILD  .AND. FRLAST(2).EQ.FRTMEI(2) ) GO TO 200
      LSUB = ISUB
      LLD = ILD
      FRLAST(1) = FRTMEI(1)
      FRLAST(2) = FRTMEI(2)
      J = 1
      CALL PAGE1
  180 CALL SD2RHD (ISHED,J)
      LINE = LINE + 1
      WRITE(NOUT,190)
  190 FORMAT(7X,47HTYPE     EID    M1A    M2A    M1B    M2B     V1,5X,
     1 23HV2     FA      T     SA)
      GO TO 210
C
  200 IF (EJECT(2).NE.0) GO TO 180
  210 WRITE(NOUT,220) IEID,(CFRVEC(I),I=2,10)
  220 FORMAT (1H0,7X,3HBAR,I8,9F7.1)
C
  230 CONTINUE
      RETURN
      END

      SUBROUTINE XSOSGN
C
C     THIS SUBROUTINE SCANS THE OSCAR TAPE AND GENERATES THE SOS + MD
C
C     LAST REVISED BY G.CHAN/UNISYS TO REMOVE THE VAX AND NOT-VAX
C     LOGICS, AND TO SYNCHRONIZE THE SCRATH FILE NAMES AS SET FORTH BY
C     THE XSEMX ROUTINES.   2/1990
C
      IMPLICIT INTEGER (A-Z)
C     LOGICAL         DEC
      EXTERNAL        ANDF,ORF,LSHIFT,RSHIFT
      DIMENSION       BLOCK1(93),STR(30),NSOSGN(2),FEQU(1),FNTU(1),
     1                FON(1),FORD(1),MINP(1),MLSN(1),MOUT(1),MSCR(1),
     2                SAL(1),SDBN(1),SNTU(1),SORD(1),BLOCK(100),
     3                NUMBR(10)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG / UFM,UWM,UIM,SFM
      COMMON /SYSTEM/ IBUFSZ,OUTTAP
      COMMON /XFIAT / FIAT(1),FMXLG,FCULG,FILE(1),FDBN(2),FMAT(1)
      COMMON /XFIST / FIST
      COMMON /XDPL  / DPD(1),DMXLG,DCULG,DDBN(2),DFNU(1)
      COMMON /ZZZZZZ/ BUF1(1)
      COMMON /XSFA1 / MD(401),SOS(1501),COMM(20),XF1AT(1),FPUN(1),
     1                FCUM(1),FCUS(1),FKND(1)
      COMMON /ISOSGN/ ENTN5,ENTN6,K,J,STR
      EQUIVALENCE     (DPD(1),DNAF),(FIAT(1),FUNLG),(FILE(1),FEQU(1)),
     1                (FILE(1),FORD(1)),(BLOCK(8),BLOCK1(1))
      EQUIVALENCE     (MD(1),MLGN),(MD(2),MLSN(1)),(MD(3),MINP(1)),
     1                (MD(4),MOUT(1)),(MD(5),MSCR(1)),
     2                (SOS(1),SLGN),(SOS(2),SDBN(1)),
     3                (SOS(4),SAL(1),SNTU(1),SORD(1)),
     4                (COMM(1),ALMSK),(COMM(2),APNDMK),(COMM(3),CURSNO),
     5                (COMM(4),ENTN1),(COMM(5),ENTN2 ),(COMM (6),ENTN3),
     6                (COMM(7),ENTN4),(COMM(8),FLAG  ),(COMM (9),FNX  ),
     7                (COMM(10),LMSK),(COMM(11),LXMSK),(COMM(13),RMSK ),
     8                (COMM(14),RXMSK),(COMM(15),S  ),(COMM(16),SCORNT),
     9                (COMM(17),TAPMSK),(COMM(19),ZAP),
     O                (XF1AT(1),FNTU(1),FON(1))
      DATA    JUMP  / 4HJUMP/, REPT /4HREPT/,  COND/4HCOND/
      DATA    OSCAR / 4HPOOL/, SCRN1,SCRN2 / 4HSCRA,4HTCH0/
      DATA    NSOSGN/ 4HXSOS , 2HGN /
      DATA    NUMBR / 1H1,1H2,1H3,1H4,1H5,1H6,1H7,1H8,1H9,1H0  /
C
      IFLAG = 0
      CALL OPEN (*500,OSCAR,BUF1,2)
      CALL BCKREC (OSCAR)
      CALL READ (*400,*600,OSCAR,BLOCK,7,0,FLAG)
      IF (BLOCK(2) .NE. CURSNO) GO TO 900
      GO TO 103
C
C     READ OSCAR FORMAT HEADER + 1
C
  100 IF (J.GT.1400 .OR. K.GT.390) GO TO 410
      CALL READ (*400,*600,OSCAR,BLOCK,7,0,FLAG)
  103 BLOCK(3) = ANDF(RMSK,BLOCK(3))
      IF (BLOCK(6) .GE. 0) GO TO 108
      IF (BLOCK(3) .LE. 2) GO TO 110
      IF (BLOCK(3) .NE. 3) GO TO 108
      L = RSHIFT(ANDF(LXMSK,BLOCK(7)),16) - BLOCK(2)
      IF (BLOCK(4) .NE. JUMP) GO TO 106
      IF (L .LE. 1) GO TO 107
      DO 104 I = 1,L
      CALL FWDREC (*400,OSCAR)
  104 CONTINUE
      GO TO 100
  106 IF (BLOCK(4).NE.REPT .AND. BLOCK(4).NE.COND) GO TO 108
  107 IF (L .LT. 0) IFLAG = -1
  108 CALL FWDREC (*400,OSCAR)
      GO TO 100
C
C     INPUT FILES
C
  110 MINP(K) = BLOCK(7)
      IF (BLOCK(7) .EQ. 0) GO TO 300
      NWDS= BLOCK(7)*ENTN5
      ASSIGN 150 TO ISW
C
C     FILES READER
C
  130 CALL READ (*400,*600,OSCAR,BLOCK1,NWDS+1,0,FLAG)
      BLKCNT = 0
      DO 145 I = 1,NWDS,ENTN5
      IF (BLOCK1(I) .EQ.  0) GO TO 140
      SOS(J  ) = BLOCK1(I  )
      SOS(J+1) = BLOCK1(I+1)
      SOS(J+2) = BLOCK1(I+2)
      J = J+3
      IF (J .GT. 1500) GO TO 460
      GO TO 145
  140 BLKCNT = BLKCNT + 1
  145 CONTINUE
      GO TO ISW, (150,170)
C
  150 MINP(K) = MINP(K) - BLKCNT
      IF (BLOCK(3) .EQ. 2) GO TO 310
C
C     OUTPUT FILES
C
      MOUT(K) = BLOCK1(NWDS+1)
  155 IF (MOUT(K) .EQ. 0) GO TO 320
      NWDS = MOUT(K)*ENTN6
      ASSIGN 170 TO ISW
      GO TO 130
C
  170 MOUT(K) = MOUT(K) - BLKCNT
  175 CALL FWDREC (*400,OSCAR)
C
C     SCRATCH FILES
C
      MSCR(K) = BLOCK1(NWDS+1)
      IF (MSCR(K) .EQ. 0) GO TO 230
      L = MSCR(K)
      SCRN3  = SCRN2
      LLL = 1
      LL  = 0
      DO 220 I = 1,L
      LL  = LL + 1
      IF (LL .EQ. 10) SCRN3 = KHRFN1(SCRN3,3,NUMBR(LLL),1)
      SOS(J  ) = SCRN1
      SOS(J+1) = KHRFN1(SCRN3,4,NUMBR(LL),1)
      IF (LL .NE. 10) GO TO 200
      LL  = 0
      LLL = LLL + 1
  200 IF (STR(I) .EQ. 0) GO TO 210
      N1= STR(I)
      SOS(N1) = ORF(LMSK,BLOCK(2))
  210 STR(I)  = J + 2
      SOS(J+2)= SCORNT + I
      J = J + 3
      IF (J .GT. 1500) GO TO 460
  220 CONTINUE
C
  230 MLSN(K) = BLOCK(2)
      IF (IFLAG .EQ. 0)  GO TO 240
      MLSN(K) = ORF(S,MLSN(K))
  240 IF (MINP(K)+MOUT(K)+MSCR(K) .EQ. 0) GO TO 100
      K= K + ENTN3
      IF (K .GT. 400) GO TO 460
      GO TO 100
C
C     ZERO INPUT FILES
C
  300 CALL READ (*400,*600,OSCAR,BLOCK(7),1,0,FLAG)
      IF (BLOCK(3) .EQ. 2) GO TO 310
      MOUT(K) = BLOCK(7)
      GO TO 155
C
C     TYPE O FORMAT - NO OUTPUTS
C
  310 MOUT(K) = 0
      GO TO 175
C
C     ZERO OUTPUT FILES
C
  320 CALL READ (*400,*600,OSCAR,BLOCK1(NWDS+1),1,0,FLAG)
      GO TO 175
C
  400 CALL SKPFIL (OSCAR,-1)
  410 CALL CLOSE  (OSCAR, 2)
      SLGN = (J-1)/ENTN2
      MLGN = (K-1)/ENTN3
      RETURN
C
C     SYSTEM FATAL MESSAGES
C
  460 WRITE  (OUTTAP,461) SFM
  461 FORMAT (A25,' 1011, MD OR SOS TABLE OVERFLOW')
      GO TO  1000
  500 WRITE  (OUTTAP,501) SFM
  501 FORMAT (A25,' 1012, POOL COULD NOT BE OPENED')
      GO TO  1000
  600 WRITE  (OUTTAP,601) SFM
  601 FORMAT (A25,' 1013, ILLEGAL EOR ON POOL')
      GO TO  1000
  900 WRITE  (OUTTAP,901) SFM,BLOCK(2),CURSNO
  901 FORMAT (A25,' 1014, POOL FILE MIS-POSITIONED ',2I7)
 1000 CALL MESAGE (-37,0,NSOSGN)
      RETURN
      END

      SUBROUTINE CTHMCK (NT,NUM,NOM,IO,IG,IC,IDEG,IDIS,IW,NEW,ICC,ILD,
     1                   IPP,JUMP,UN,NODESL)
C
C     THIS IS THE EXECUTIVE FOR THE CUTHILL-MCKEE GRID POINT RENUMBERING
C     STRATEGY.
C     91 VERSION, WITH REVERSED NEW SEQUENCE LOGIC
C
C     IN SAN ANTONIO, TEXAS, APRIL 27, 1989, THE DOUGLAS MICHEL NASTRAN
C     ACHIEVEMENT AWARD 1989, AN ANNUAL EVENT SPONSORED BY COSMIC AND
C     NASA, WAS GIVEN TO ELIZABETH H. CUTHILL, JAMES M. McKEE AND GORDON
C     C. EVERSTINE FOR THEIR TEAMWORK THAT CREATED BANDIT, A COMPUTER
C     PROGRAM THAT MINIMIZES THE BANDWIDTHS OF NASTRAN MATRICES. THE
C     WIDOW OF DR. McKEE AND HIS FAMILY RECEIVED THE AWARD FOR HIM.
C     DRS. CUTHILL AND EVERSTINE RECEIVED THEIR AWARDS PERSONALLY.
C
C     THE PRINCIPAL INPUTS ARE THE CONNECTIVITY MATRIX IG AND THE NUMBER
C     OF GRID POINTS (NODES) NN.
C
C     INPUT   - NT,NUM,NOM,IO,IP,IG,NN,MAXGRD,ILD
C     OUTPUT  - NEW,ILD,MM,IH0,IHE,KORIG,KNEW,NCM
C     SCRATCH - IC,IDEG,IDIS,IW,ICC,IPP
C
C     SET FOLLOWING DIMENSIONS IN CALLING PROGRAM -
C     IG(II1,M),IC(L),IDEG(L),IDIS(L),IW(L),NEW(L),ICC(L),ILD(L),IP(M)
C
C     L     = HAS THE DIMENSION OF MAXGRD
C             (NEW) MAXGRD EXCEEDS NUMBER OF GRID POINTS
C     II1   = MAXGRD/(PACKING DENSITY IN INTEGERS/WORD)
C           = ROW DIMENSION OF IG
C     M     = MAX NODAL DEGREE DIVIDED BY INTEGER PACKING FACTOR
C             (NEW) EXCEEDS MAX NODAL DEGREE
C     NT    = MAX NUMBER OF STARTING NODES TO BE CONSIDERED (=80)
C     NUM AND NOM GIVE THE FRACTION OF THE RANGE FROM MIN DEGREE TO MAX
C             DEGREE TO CONSIDER FOR STARTING NODES (NUM=1, NOM=2)
C     IO    = RE-SEQUENCING CRITERION , SET BY BANDIT -
C           = 1, RMS WAVEFRONT
C           = 2, BANDWIDTH
C           = 3, PROFILE. (PROFILE IS BANDWIDTH SUM OF ALL ROWS)
C           = 4, WAVEFRONT (MAX)
C     IG(I,J) CONTAINS THE GRID POINT LABEL FOR THE JTH NODE ADJACENT
C             TO NODE I  (THE CONNECTIVITY MATRIX).
C             THE CONNECTION OF A NODE TO ITSELF IS NOT LISTED.
C     NN    = NUMBER OF GRID POINTS (NODES)
C     MM    = COLUMN DIMENSION OF IG ON INPUT,
C             MAX NODAL DEGREE ON OUTPUT
C     MAXGRD= EFFECTIVE IG ROW DIMENSION (NEGLECTING INTEGER PACKING)
C     NEW(I)= OLD LABEL FOR GRID POINT NOW LABELLED I
C     ILD(I)= NEW LABEL FOR GRID POINT ORIGINALLY LABELLED I
C             ILD AND NEW ARE INVERSES
C     ILD MUST BE INPUT TO CTHMCK TO INDICATE AN INITIAL SEQUENCE.
C             NORMALLY, ON INPUT, SET ILD(I)=I FOR ALL I.
C     JUMP  = 1 IF RESEQUENCING ATTEMPTS RESULT IN NO IMPROVEMENT
C           = 0 OTHERWISE.
C     IH0   = ORIG PROFILE
C     IHE   = NEW PROFILE
C     KORIG = ORIG BANDWIDTH
C     KNEW  = NEW BW
C     NCM   = NUMBER OF COMPONENTS
C     NODESL IS SCRATCH SPACE.
C
C     IN CALLING PROGRAM, TRY  CALL CTHMCKL (80,1,2,2,1,...)
C
C     THE FOLLOWING SUBROUTINES WERE WRITTEN BY E. CUTHILL AND J. MCKEE
C     OF NSRDC -
C     DEGREE,DIAM,IDIST,KOMPNT,MAXBND,MAXDGR,MINDEG,RELABL,CTHMCK
C     CTHMCK WAS MODIFIED BY G.C. EVERSTINE, DTRC, AND
C        PUT INTO NASTRAN BY G.C. CHAN/UNISYS
C
      INTEGER         SUMW
      REAL            IM1,     IM2
      DIMENSION       IG(1),   IC(1),   IDEG(1),  IDIS(1),  IW(1),
     1                NEW(1),  ICC(1),  ILD(1),   IPP(1),   UN(1),
     2                NODESL(1)
      CHARACTER       UFM*23,  UWM*25,  UIM*29
      COMMON /XMSSG / UFM,     UWM,     UIM
      COMMON /BANDA / IBUF1,   NOMPC,   NODEP,    NOPCH,    NORUN,
     1                METHOD,  ICRIT
      COMMON /BANDB / DUM3B(3),NGRID,   DUMB2(2), KDIM
      COMMON /BANDD / KORIG,   KNEW,    IH0,      IHE,      NCM
      COMMON /BANDS / NN,      MM,      IH,       IB,       MAXGRD
      COMMON /BANDW / MAXW0,   RMS0,    MAXW1,    RMS1,     I77,
     1                BRMS0,   BRMS1
      COMMON /SYSTEM/ ISYS,    NOUT,    DUM6Y(6), NLPP
C
C     SET UP SCRATCH SPACE NODESL.
C
      IDEM  = KDIM
      K2    = IDEM + 1
      IAJDIM= 3*IDEM
C
C     DETERMINE THE DEGREE OF EACH NODE, THE NUMBER OF COMPONENTS, NCM,
C     AND THE MAXIMUM DEGREE OF ANY NODE.
C
      CALL DEGREE (IG,IDEG,UN)
      NCM  = KOMPNT(IG,IC,IDEG,IW,ICC,UN)
      MAXD = MAXDGR(0,IC,IDEG)
      MMC  = MAXD
C
C     INITIALIZE NEW ARRAY FROM THE ILD ARRAY.
C     ILD MUST BE INPUT TO CUTHILL.
C
      DO 10 I = 1,NN
      K = ILD(I)
   10 NEW(K) = I
C
C     COMPUTE ORIGINAL BANDWIDTH, PROFILE, WAVEFRONT AND ACTIVE COLUMN
C     IH0 = ORIGINAL PROFILE,  IS = ORIGINAL BW
C
      CALL WAVEY (IG,ILD,NEW,0,IC,IW,IS,MAXW,AVERW,SUMW,RMS,BRMS,UN)
      IH    = SUMW
      MAXW0 = MAXW
      RMS0  = RMS
      BRMS0 = BRMS
      KORIG = IS
      IH0   = IH
      CALL PAGE1
      I = METHOD + 2
      WRITE  (NOUT,20) UIM,ICRIT,I,NOMPC,NODEP,NOPCH
   20 FORMAT (A29,'S FROM RESEQUENCING PROCESSOR - BANDIT     (CRI=',I2,
     1       ',  MTH=',I2,',  MPC=',I2,',  DEP=',I2,',  PCH=',I2,')',/)
      IF (NLPP .LE. 50) GO TO 50
      WRITE  (NOUT,30)
   30 FORMAT (31X,'BEFORE RESEQUENCING - - -')
      WRITE  (NOUT,40) IS,IH,MAXW,AVERW,RMS,BRMS
   40 FORMAT (40X,'BANDWIDTH',I13,     /40X,'PROFILE',I15,
     1       /40X,'MAX WAVEFRONT',I9,  /40X,'AVG WAVEFRONT',F9.3,
     2       /40X,'RMS WAVEFRONT',F9.3,/40X,'RMS BANDWIDTH',F9.3)
C
C     COMPUTE NODAL DEGREE STATISTICS.
C
   50 CALL DIST (IDEG,IPP,MEDIAN,MODD)
      IF (METHOD .EQ. +1) RETURN
C
C     INITIALIZE ILD AND NEW ARRAYS.
C
      JUMP  = 0
      DO 70 I = 1,NN
      NEW(I) = 0
   70 ILD(I) = 0
C
C     GENERATE NUMBERING SCHEME FOR EACH COMPONENT, NC.
C
      DO 310 NC = 1,NCM
C
C     DETERMINE THE RANGE OF DEGREES (MI TO MAD) OF NODES OF INTEREST.
C     MAKE SURE MAD DOES NOT EXCEED MEDIAN
C
      MI  = MINDEG(NC,IC,IDEG)
      MAD = MI
      IF (NOM .EQ. 0) GO TO 80
      MA  = MAXDGR(NC,IC,IDEG)
      MAD = MI + ((MA-MI)*NUM)/NOM
      MAD = MIN0(MAD,MEDIAN-1)
      MAD = MAX0(MAD,MI)
C
C     DETERMINE BANDWIDTH OR SUM CRITERION FOR EACH NODE MEETING
C     SPECIFIED CONDITION.
C
   80 CALL DIAM (NC,MAD,NL,NODESL,IDEM,MAXLEV,IG,IC,IDEG,IDIS,IW,ICC,UN)
      JMAX = MIN0(NT,NL)
      JMAX = MAX0(JMAX,1)
      IM1  = 1.E+8
      IM2  = IM1
C
C     CHECK SEQUENCE FOR EACH STARTING NODE SELECTED, AND
C     COMPUTE NEW BANDWIDTH,PROFILE,WAVEFRONT DATA.
C     IB = BANDWIDTH, IH = PROFILE.
C
      DO 300 J = 1,JMAX
      CALL RELABL (1,NODESL(J),IG,IC,IDEG,IDIS,IW,NEW,ICC,ILD,
     1             NODESL(K2),UN,IAJDIM)
      CALL WAVEY (IG,ILD,NEW,NC,IC,IW,IB,MAXW,AVERW,SUMW,RMS,BRMS,UN)
      IF (NGRID .EQ. -1) RETURN
C
      IH = SUMW
      GO TO (220,230,240,250), IO
  220 CRIT1 = RMS
      CRIT2 = IH
      GO TO 260
  230 CRIT1 = IB
      CRIT2 = IH
      GO TO 260
  240 CRIT1 = IH
      CRIT2 = IB
      GO TO 260
  250 CRIT1 = MAXW
      CRIT2 = RMS
  260 IF (IM1-CRIT1) 300,280,270
  270 IM1 = CRIT1
      IM2 = CRIT2
      IJ  = J
      GO TO 300
  280 IF (IM2 .LE. CRIT2) GO TO 300
      IM2 = CRIT2
      IJ  = J
C
  300 CONTINUE
C
C     RECOMPUTE SEQUENCE FOR STARTING NODE WHICH IS BEST FOR CRITERION
C     SELECTED.
C
      CALL RELABL (1,NODESL(IJ),IG,IC,IDEG,IDIS,IW,NEW,ICC,ILD,
     1             NODESL(K2),UN,IAJDIM)
      IF (NGRID .EQ. -1) RETURN
C
  310 CONTINUE
C
C     DETERMINE NODES OF ZERO DEGREE AND STACK LAST, AND
C     COMPUTE BANDWIDTH, PROFILE AND WAVEFRONT DATA.
C
      CALL STACK (IDEG,NEW,ILD,IW)
      CALL WAVEY (IG,ILD,NEW,0,IC,IW,IB,MAXW,AVERW,SUMW,RMS,BRMS,UN)
      IH = SUMW
C
      IF (NLPP .LE. 50) GO TO 350
      WRITE  (NOUT,320)
  320 FORMAT (/31X,'AFTER RESEQUENCING BY REVERSE CUTHILL-MCKEE (CM)',
     1        ' ALGORITHM - - -')
      WRITE (NOUT,40) IB,IH,MAXW,AVERW,RMS,BRMS
C
C     CHECK CM LABELING AGAINST ORIGINAL LABELING TO SEE IF BETTER.
C     IB = BANDWIDTH,  IH = PROFILE.
C
  350 GO TO (400,410,420,430), IO
  400 IM1   = RMS0
      IM2   = IH0
      CRIT1 = RMS
      CRIT2 = IH
      GO TO 440
  410 IM1   = IS
      IM2   = IH0
      CRIT1 = IB
      CRIT2 = IH
      GO TO 440
  420 IM1   = IH0
      IM2   = IS
      CRIT1 = IH
      CRIT2 = IB
      GO TO 440
  430 IM1   = MAXW0
      IM2   = RMS0
      CRIT1 = MAXW
      CRIT2 = RMS
  440 IF (CRIT1-IM1) 480,450,460
  450 IF (CRIT2 .LT. IM2) GO TO 480
C
C     IF NO IMPROVEMENT RETURN TO ORIGINAL SEQUENCE.
C
  460 IB   = IS
      IH   = IH0
      MAXW = MAXW0
      RMS  = RMS0
      BRMS = BRMS0
      DO 470 I = 1,NN
      ILD(I) = I
  470 NEW(I) = I
      JUMP = 1
C
C     SET FINAL VALUES OF B, P, RMS, W.
C
  480 KNEW = IB
      IHE  = IH
      MAXW1= MAXW
      RMS1 = RMS
      BRMS1= BRMS
      RETURN
      END

      SUBROUTINE XGPI
C
C     THE PURPOSE OF XGPI IS TO INITIALIZE AND CALL THE FOLLOWING
C     SUBROUTINES - XOSGEN AND XFLORD.
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        LSHIFT,RSHIFT,ANDF,ORF,COMPLF
      LOGICAL         LNOGO
      INTEGER         CNM(1),FNM(1),PTDIC(1)
      DIMENSION       ICPDPL(1),ISOL(1),ICF(1),ICCNAM(1),IBUFR(1),
     1                IBF(8),IOSHDR(2),ITYPE(6),ITRL(7),DMPCRD(1),
     2                MED(1),NXGPI(2),NXPTDC(2),OSCAR(1),OS(5)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG / UFM,UWM,UIM,SFM
      COMMON /XOLDPT/ PTDTOP,PTDBOT,LPTDIC,NRLFL,SEQNO
      COMMON /STAPID/ TAPID(6),OTAPID(6)
      COMMON /XGPI5 / ISOL,START,ALTER(2),SOL,SUBSET,IFLAG,IESTIM,
     1                ICFTOP,ICFPNT,LCTLFL,ICTLFL(1)
      COMMON /MODDMP/ IFLG(6)
      COMMON /XGPI6 / MEDTP,FNMTP,CNMTP,MEDPNT,LMED,IPLUS,DIAG14,
     1                DIAG17,DIAG4,DIAG25,IFIRST,IBUFF(20)
      COMMON /XGPI8 / ICPTOP,ICPBOT,LCPDPL
      COMMON /IFPX0 / LBD,LCC,MJMSK(1)
      COMMON /IFPX1 / NCDS,MJCD(1)
      COMMON /TWO   / TWO(32)
      COMMON /XMDMSK/ NMSKCD,NMSKFL,NMSKRF,MEDMSK(7)
      COMMON /SYSTEM/ IBUFSZ,OPTAPE,NOGO,SYS4,MPC,SPC,SYS7,LOAD,SYS9(2),
     1                PAGECT,SYS12(7),IECHO,SYS20,APPRCH,SYS22(2),
     2                ICFIAT,SYS25,CPPGCT,SYS27(42),SSCELL,SYS70(7),
     3                BANDIT,SYS78(4),ICPFLG
      COMMON /L15 L8/ L15,L8
      COMMON /XGPI4 / IRTURN,INSERT,ISEQN,DMPCNT,
     1                IDMPNT,DMPPNT,BCDCNT,LENGTH,ICRDTP,ICHAR,NEWCRD,
     2                MODIDX,LICF,ISAVDW,DMAP(1)
C
C                  ** CONTROL CARD NAMES **
C                  ** DMAP    CARD NAMES **
      COMMON /XGPIC / ICOLD,ISLSH,IEQUL,NBLANK,NXEQUI,
     1                NMED,NSOL,NDMAP,NESTM1,NESTM2,NEXIT,
     2                NBEGIN,NEND,NJUMP,NCOND,NREPT,NTIME,NSAVE,NOUTPT,
     3                NCHKPT,NPURGE,NEQUIV,NCPW,NBPC,NWPC,
     4                MASKHI,MASKLO,ISGNON,NOSGN,IALLON,MASKS(1)
      COMMON /ZZZZZZ/ CORE(1)
      COMMON /XGPI2 / LIBF,MPLPNT,MPL(1)
CWKBR COMMON /XGPI3 / PVT(6)
      COMMON /XGPI3 / PVT(200)
      COMMON /XDPL  / DPL(3)
      COMMON /XVPS  / VPS(4)
      COMMON /XFIST / IFIST(1)
      COMMON /XFIAT / IFIAT(3)
CWKBR COMMON /XCEITB/ CEITBL(2)
      COMMON /XCEITB/ CEITBL(42)
      COMMON /XGPID / ICST,IUNST,IMST,IHAPP,IDSAPP,IDMAPP,
     1                ISAVE,ITAPE,MODFLG,INTGR,LOSGN,
     2                NOFLGS,SETEOR,EOTFLG,IEQFLG,
     3                CPNTRY(7),JMP(7)
      COMMON /XGPIE / NSCR
      EQUIVALENCE     (LOSCAR,OS(1),CORE(1)), (OSPRC,OS(2)),
     1                (OSBOT ,OS(3)), (OSPNT,OS(4)), (OSCAR(1),OS(5)),
     2                (OSCAR(1),MED(1),FNM(1),CNM(1),ICPDPL(1)),
     3                (OSCAR(1),IBUFR(1),DMPCRD(1),PTDIC(1))
      EQUIVALENCE     (DMAP(1),ICF(1)), (NMED,ICCNAM(1)),
     1                (MPL(1),IBF(1)), (DPL(1),NDPFIL),
     2                (DPL(2),MAXDPL), (DPL(3),LSTDPL), (NOGO,LNOGO)
C
C           ** DEFINITION OF PROGRAM VARIABLES **
C     LICF   = NUMBER OF WORDS IN ICF ARRAY
C     WRNGRL = COUNTER FOR NUMBER OF TIMES WRONG REEL WAS MOUNTED.
C     FILCON = FLAG INDICATING FILE IS CONTINUED ON NEXT REEL.
C     IDPFCT = DATA POOL FILE NUMBER OF OSCAR FILE
C     IOSHDR = ARRAY CONTAINING HEADER RECORD FOR XOSCAR FILE IN IDP.
C     PTFCT  = PROBLEM TAPE FILE POSITION
C     EORFLG = END OF RECORD FLAG
C     ICST   = COLD START FLAG
C     IUNST  = UNMODIFIED RESTART
C     IMST   = MODIFIED   RESTART
C
C           ** VARIABLES USED IN GINO CALLS **
C     NPTBUF = NEW PROBLEM TAPE BUFFER AREA
C     IOPBUF = OLD PROBLEM TAPE BUFFER AREA
C     IDPBUF = DATA POOL FILE BUFFER AREA
C     NPTWRD = NUMBER OF WORDS READ FROM NEW PROBLEM TAPE
C     IOPWRD = NUMBER OF WORDS READ FROM OLD PROBLEM TAPE
C     IDPWRD = NUMBER OF WORDS READ FROM DATA POOL FILE
C
C           ** SYMBOLS EQUATED TO CONSTANTS **
C     NPT    = NEW PROBLEM TAPE GINO I.D. NAME (NPTP)
C     IOP    = OLD PROBLEM TAPE GINO I.D. NAME (OPTP)
C     IDP    = DATA POOL FILE GINO I.D. NAME   (POOL)
C     NSCR   = SCRATCH FILE USED FOR RIGID FORMAT. DATA IN NSCR WAS
C              PASSED OVER BY XCSA. IT MUST BE THE LAST SCRATCH FILE
C              IN LINK1, AND NOT TO BE OVER WRITTEN BY XSORT2
C              (CURRENTLY, NSCR = 315)
C
      DATA    JCARD ,JFILE  /  4HCARD,4HFILE /, IDP   /4HPOOL /
      DATA    NPVT  /4HPVT  /, IXTIM /4HXTIM /, NPT   /4HNPTP /,
     1        IOP   /4HOPTP /, IDPWRD/0      /, IOPWRD/0      /,
     2        NDPL  /4HDPL  /, IOSHDR/4HXOSC  , 4HAR          /,
     3        NPTWRD/0      /, FILCON/0      /, NXVPS /4HXVPS /
      DATA    ITYPE /1,1,2,2 , 2,4           /
      DATA    NXCSA /4HXCSA /, NXALTR/4HXALT /, NPARAM/216    /
      DATA    NXPTDC/4HXPTD  , 4HIC  /,NXGPI /  4HXGPI,4H     /
C
C
C     LOAD COMMON AREAS AND PERFORM INITIAL CALCULATIONS
C
      CALL XGPIDD
      CALL XMPLDD
      CALL XLNKDD
C
C     INITIALIZE
C
      NSCR  = 315
      CALL SSWTCH ( 4,DIAG4 )
      CALL SSWTCH (14,DIAG14)
      CALL SSWTCH (17,DIAG17)
      CALL SSWTCH (25,DIAG25)
      IF (DIAG14 .EQ. 1) IFLG(3) = 1
      IF (DIAG17 .EQ. 1) IFLG(4) = 1
      IF (DIAG4  .EQ. 1) IFLG(6) = 1
      IF (DIAG4  .NE. 0) IFLG(5) = ORF(IFLG(5),LSHIFT(1,16))
      IF (DIAG25 .EQ. 1) IFLG(5) = 1
C
C     SET DMAP COMPILER DEFAULT OPTION TO LIST FOR
C     APPROACH DMAP RUNS, RESTART RUNS AND SUBSTRUCTURE RUNS
C     RESET TO NO LIST IF ECHO=NONO (IECHO=-2)
C
      IF (IECHO.NE.-2 .AND. (APPRCH.LT.2 .OR. SSCELL.NE.0)) IFLG(3) = 1
      IF (DIAG14.EQ.0 .AND. IFLG(3).EQ.1) DIAG14 = 2
      IF (IECHO .EQ. -2) DIAG14 = 0
      CALL XGPIMW (1,0,0,0)
C
      CALL XGPIBS
      IF (NOGO .GT. 1) GO TO 2210
C
C     SET UP GINO BUFFER AREAS FOR OLD PROBLEM TAPE,NEW PROBLEM TAPE
C     AND DATA POOL TAPE.
C
      LOSCAR = KORSZ(IBUFR)
      NPTBUF = LOSCAR - IBUFSZ
C
C     OLD PROBLEM TAPE AND NEW PROBLEM TAPE SHARE BUFFER
C
      IOPBUF = NPTBUF
      IDPBUF = NPTBUF - IBUFSZ
      LOSCAR = IDPBUF - 1
C
C     ALLOW MINIMAL SIZE FOR MED ARRAY RESIDING IN OPEN CORE.
C     WE WILL EXPAND MED IF NECESSARY.
C
      MEDTP = LOSCAR
      LMED  = 1
      IF (LOSCAR .LT. 1) GO TO 2080
C
C     OPEN NEW PROBLEM TAPE AS INPUT FILE
C
      CALL OPEN (*1900,NPT,IBUFR(NPTBUF),0)
C
C     NUMBER OF FILE ON NPT + 1
C
      NRLFL = LSHIFT(TAPID(6),16) + 5
C
C     FILE POSITION OF IOP AT ENTRY TO XGPI
C
      PTFCT = LSHIFT(OTAPID(6),16) + 4
C
C     FIND XCSA FILE ON NEW PROBLEM TAPE
C
      NAM1 = NXCSA
      NAM2 = NBLANK
C
C     SKIP HEADER FILE
C
   10 CALL SKPFIL (NPT,1)
      CALL READ (*1950,*1950,NPT,ICF,1,1,NPTWRD)
C
C     CHECK FOR ALTER FILE
C     SET DIAG14 TO 10 IF ALTER CARDS ARE PRESENT. DIAG14 WOULD BE
C     CHANGED TO 11 IF DMAP CONTAINS POTENTIAL FATAL ERROR. IN SUCH
C     CASE, DMAP LISTING WILL BE PRINTED.
C
      IF (ICF(1) .NE. NXALTR) GO TO 15
      NRLFL = NRLFL + 1
      IF (DIAG14 .EQ. 0)                 DIAG14 = 10
C
C     CHECK FOR CHECKPOINT DICTIONARY FILE
C
   15 IF (ICF(1) .EQ. NXPTDC(1)) NRLFL = NRLFL + 1
C
C     CHECK FOR CONTROL FILE
C
      IF (ICF(1) .NE. NXCSA) GO TO 10
C
C     PROBLEM TAPE IS POSITIONED AT EXECUTIVE CONTROL FILE.
C
      ICFPNT = ICFTOP
C
C     READ THE SIX-WORD DATA RECORD
C
      CALL READ (*1950,*20,NPT,ISOL,7,1,NPTWRD)
      GO TO 1950
   20 CALL CLOSE (NPT,1)
      IF (IABS(APPRCH) .EQ. 1) GO TO 620
C
C     FILL MED ARRAY
C
      MEDTP = 1
C
C     SET VALUE FOR NUMBER OF WORDS PER MED ENTRY
C
      MED(MEDTP+1) = 1
      IF (START .NE. ICST) MED(MEDTP+1) = NMSKCD + NMSKFL + NMSKRF
C
      CALL GOPEN (NSCR,IBUFR(NPTBUF),0)
      LLOSCR = LOSCAR - 2
C
C     READ THE MED TABLE
C
      CALL READ (*1960,*30,NSCR,MED(MEDTP+2),LLOSCR,1,LMED)
      GO TO 2090
C
C     SET VALUE FOR NUMBER OF DMAP INSTRUCTIONS
C
   30 MED(MEDTP) = LMED/MED(MEDTP+1)
C
C     CHECK FOR ILLEGAL NUMBER OF WORDS IN MED TABLE RECORD
C
      IF (START.NE.ICST .AND. LMED.NE.MED(MEDTP)*MED(MEDTP+1))
     1    GO TO 1980
C
C     SET THE POINTERS TO THE FILE NAME AND CARD NAME TABLES
C
      FNMTP = MEDTP + LMED + 2
      CNMTP = FNMTP
      IF (START .EQ. ICST) GO TO 600
      LLOSCR = LLOSCR - LMED
C
C     READ THE FILE NAME TABLE
C
      CALL SKPREC (NSCR,1)
      JTYPE = JFILE
      CALL READ (*1970,*40,NSCR,MED(FNMTP+1),LLOSCR,1,LMED)
      GO TO 2090
C
C     SET THE VALUE FOR THE NUMBER OF ENTRIES IN THE FILE NAME TABLE
C
   40 MED(FNMTP) = LMED/3
C
C     CHECK FOR ILLEGAL NUMBER OF WORDS IN FILE NAME TABLE RECORD
C
      IF (LMED .NE. 3*MED(FNMTP)) GO TO 1990
C
C     CHECK FOR ILLEGAL BIT NUMBERS IN FILE NAME TABLE
C
      ISTRBT = 31*NMSKCD + 1
      IENDBT = 31*(NMSKCD+NMSKFL)
      DO 50 J = 3,LMED,3
      IF (MED(FNMTP+J).LT.ISTRBT .OR. MED(FNMTP+J).GT.IENDBT) GO TO 2000
   50 CONTINUE
C
C     RESET THE POINTER FOR THE CARD NAME TABLE
C
      CNMTP  = FNMTP + 3*FNM(FNMTP) + 1
      LLOSCR = LLOSCR - LMED
C
C     READ THE CARD NAME TABLE
C
      CALL SKPREC (NSCR,-2)
      JTYPE = JCARD
      CALL READ (*1970,*60,NSCR,MED(CNMTP+1),LLOSCR,1,LMED)
      GO TO 2090
C
C     SET THE VALUE FOR THE NUMBER OF ENTRIES IN THE CARD NAME TABLE
C
   60 MED(CNMTP) = LMED/3
C
C     CHECK FOR ILLEGAL NUMBER OF WORDS IN CARD NAME TABLE RECORD
C
      IF (LMED .NE. 3*MED(CNMTP)) GO TO 1990
C
C     CHECK FOR ILLEGAL BIT NUMBERS IN CARD NAME TABLE
C
      ISTRBT = 1
      IENDBT = 31*NMSKCD
      DO 70 J = 3,LMED,3
      IF (MED(CNMTP+J).LT.ISTRBT .OR. MED(CNMTP+J).GT.IENDBT) GO TO 2000
   70 CONTINUE
C
C     RESTART - CHECK MEDMSK TABLE
C     IF MEDMSK WORD(S), CORRESPONDING TO RIGID FORMAT SWITCH, IS(ARE)
C     NON-ZERO, SOLUTION HAS BEEN CHANGED.
C     RESET ENTRY SEQUENCE NO. TO INFINITE IF SOLUTION IS CHANGED.
C
      NMASK = MED(MEDTP+1)
      IBEGN = NMSKCD + NMSKFL + 1
      DO 80 I = IBEGN,NMASK
      IF (MEDMSK(I) .EQ. 0) GO TO 80
      SEQNO = MASKLO
      START = IMST
   80 CONTINUE
C
C     SEE IF ANY BULK DATA OR CASE CONTROL CARDS HAVE BEEN MODIFIED.
C
      BGNMSK = 1
      ENDMSK = LBD + LCC
C
C     TURN OFF BIT IN MJMSK ARRAY IF THE CORRESPONDING CARD NAME
C     IS NOT IN THE CARD NAME RESTART TABLE
C
      I1 = CNMTP + 1
      I2 = I1 + 3*CNM(CNMTP) - 3
      DO 110 LX = BGNMSK,ENDMSK
      IF (MJMSK(LX) .EQ. 0) GO TO 110
      L = LX - BGNMSK + 1
      DO 100 L1 = 2,32
      IF (ANDF(MJMSK(LX),TWO(L1)) .EQ. 0) GO TO 100
C
C     IGNORE BIT IF IT CORRESPONDS TO QOUT$ OR BOUT$
C
      IF (LX.EQ.LBD+2 .AND. (L1.EQ.3 .OR. L1.EQ.4)) GO TO 100
      I = 62*(L-1) + 2*(L1-2) + 1
      DO 90 II = I1,I2,3
      IF (MJCD(I).EQ.CNM(II) .AND. MJCD(I+1).EQ.CNM(II+1)) GO TO 100
   90 CONTINUE
      II = COMPLF(TWO(L1))
      MJMSK(LX) = ANDF(MJMSK(LX),II)
  100 CONTINUE
  110 CONTINUE
      IF (START .EQ. IMST) GO TO 130
C
C     DETERMINE TYPE OF RESTART
C
      INDEX = 0
      IEND  = LBD
      DO 120 L = BGNMSK,IEND
      IF (MJMSK(L) .EQ. 0) GO TO 120
      INDEX = 1
      GO TO 130
  120 CONTINUE
  130 L = LBD + 1
      IF (START .EQ. IMST) GO TO 160
      IF (INDEX .EQ.    1) GO TO 150
      IF (MJMSK(L) .EQ. 0) GO TO 140
C
C     CHECK FOR NOLOOP$ AND LOOP$
C                                          2**21
      IF (MJMSK(L).NE.1 .AND. MJMSK(L).NE.TWO(11)) GO TO 150
C
C     CHECK FOR GUST$
C                         2**30
  140 IF (MJMSK(L+1) .LT. TWO(2)) GO TO 170
  150 START = IMST
C
C     TURN ON POUT$ IF QOUT$ IS ON
C                         2**29                                  2**14
  160 IF (ANDF(MJMSK(L+1),TWO(3)) .NE. 0) MJMSK(L)=ORF(MJMSK(L),TWO(18))
C
C     TURN ON AOUT$ IF BOUT$ IS ON
C                         2**28                                  2**22
      IF (ANDF(MJMSK(L+1),TWO(4)) .NE. 0) MJMSK(L)=ORF(MJMSK(L),TWO(10))
C
C     TURN OFF BOUT$ AND QOUT$
C                 2**28    2**29
      II = COMPLF(TWO(4) + TWO(3))
      MJMSK(L+1) = ANDF(MJMSK(L+1),II)
C
C     TURN OFF NOLOOP$ FOR UNMODIFIED RESTARTS
C
  170 IF (START.EQ.IUNST .AND. MJMSK(LBD+1).EQ.1) MJMSK(LBD+1) = 0
  180 CALL PAGE1
      IF (START .NE. IUNST) GO TO 200
      WRITE  (OPTAPE,190) UIM
  190 FORMAT (A29,' 4143, THIS IS AN UNMODIFIED RESTART.')
      BANDIT = -1
      IF (APPRCH .EQ. -1) GO TO 700
      GO TO 600
  200 CALL PAGE2 (-2)
      IF (SEQNO .NE. MASKLO) WRITE (OPTAPE,210) UIM
      IF (SEQNO .EQ. MASKLO) WRITE (OPTAPE,220) UIM
  210 FORMAT (A29,' 4144, THIS IS A MODIFIED RESTART.')
  220 FORMAT (A29,' 4145, THIS IS A MODIFIED RESTART INVOLVING RIGID ',
     1       'FORMAT SWITCH.')
      IBULK = 0
      ICASE = 0
      DO 230 L = 1,LBD
      IF (MJMSK(L) .EQ. 0) GO TO 230
      IBULK = 1
      GO TO 240
  230 CONTINUE
  240 LBD1 = LBD + 1
      LBDLCC = LBD + LCC
      DO 250 L = LBD1,LBDLCC
      IF (MJMSK(L) .EQ. 0) GO TO 250
      ICASE = 1
      GO TO 260
  250 CONTINUE
  260 IF (IBULK.NE.0 .OR. ICASE.NE.0) GO TO 290
      IF (SEQNO .EQ. MASKLO) GO TO 270
      WRITE (OPTAPE,460)
      CALL MESAGE (-61,0,0)
  270 WRITE  (OPTAPE,280) UIM
  280 FORMAT (A29,'. THERE ARE NO CASE CONTROL OR BULK DATA DECK ',
     1       'CHANGES AFFECTING THIS RESTART.')
      GO TO 600
  290 CALL PAGE2 (-4)
      WRITE  (OPTAPE,300) UIM
  300 FORMAT (A29,'. CASE CONTROL AND BULK DATA DECK CHANGES AFFECTING',
     1       ' THIS RESTART ARE INDICATED BELOW.',/)
      DO 500 LLX = 1,2
      IF (LLX .EQ. 1) GO TO 360
      CALL PAGE2 (-3)
      WRITE  (OPTAPE,310) UIM
  310 FORMAT (A29,'. EFFECTIVE BULK DATA DECK CHANGES', /1X,32(1H-))
      IF (IBULK .NE. 0) GO TO 330
      CALL PAGE2 (-3)
      WRITE  (OPTAPE,320)
  320 FORMAT (//,' NONE',/)
      GO TO 500
  330 CALL PAGE2 (-3)
      IF (APPRCH .NE. -1) WRITE (OPTAPE,340)
      IF (APPRCH .EQ. -1) WRITE (OPTAPE,350)
  340 FORMAT (//,' MASK WORD - BIT POSITION - CARD/PARAM NAME - PACKED',
     1       ' BIT POSITION',/)
  350 FORMAT (//,' MASK WORD - BIT POSITION - CARD/PARAM NAME',/)
      LIM1 = 1
      LIM2 = LBD
      GO TO 410
  360 CALL PAGE2 (-3)
      WRITE  (OPTAPE,370) UIM
  370 FORMAT (A29,'. EFFECTIVE CASE CONTROL DECK CHANGES', /1X,35(1H-))
      IF (ICASE .NE. 0) GO TO 380
      CALL PAGE2 (-3)
      WRITE (OPTAPE,320)
      GO TO 500
  380 CALL PAGE2 (-3)
      IF (APPRCH .NE. -1) WRITE (OPTAPE,390)
      IF (APPRCH .EQ. -1) WRITE (OPTAPE,400)
  390 FORMAT (//,' MASK WORD - BIT POSITION ---- FLAG NAME ---- PACKED',
     1       ' BIT POSITION',/)
  400 FORMAT (//,' MASK WORD - BIT POSITION ---- FLAG NAME',/)
      LIM1 = LBD1
      LIM2 = LBDLCC
  410 DO 490 L = LIM1,LIM2
      IF (MJMSK(L) .EQ. 0) GO TO 490
      CALL PAGE2 (-1)
      WRITE  (OPTAPE,420) L
  420 FORMAT (1X,I5)
      DO 480 K = 2,32
      IF (ANDF(MJMSK(L),TWO(K)) .EQ. 0) GO TO 480
C
C     GET CORRESPONDING CARD NAME FROM MAIN CARD TABLE
C
      I  = 62*(L-1) + 2*(K-2) + 1
      KZ = K - 1
      CALL PAGE2 (-1)
      IF (APPRCH .NE. -1) GO TO 430
      WRITE (OPTAPE,440) KZ,MJCD(I),MJCD(I+1)
      GO TO 480
C
C     SEARCH RIGID FORMAT CARD NAME RESTART TABLE FOR A MATCH
C
  430 DO 450 II = I1,I2,3
      IF (MJCD(I).NE.CNM(II) .OR. MJCD(I+1).NE.CNM(II+1)) GO TO 450
C
C     CARD NAME FOUND - SET BIT IN MEDMSK
C
      WRITE  (OPTAPE,440) KZ,MJCD(I),MJCD(I+1),CNM(II+2)
  440 FORMAT (17X,I3,11X,2A4,14X,I3)
      L1 = (CNM(II+2)-1)/31
      LL = L1 + 1
      KK = CNM(II+2) - 31*L1 + 1
      MEDMSK(LL) = ORF(MEDMSK(LL),TWO(KK))
      GO TO 480
  450 CONTINUE
      WRITE  (OPTAPE,460) SFM
  460 FORMAT (A25,' 4146, LOGIC ERROR IN SUBROUTINE XGPI WHILE ',
     1       'PROCESSING DATA CHANGES FOR MODIFIED RESTART.')
      WRITE  (OPTAPE,470) MJCD(I),MJCD(I+1),(CNM(LL),CNM(LL+1),
     1       LL=I1,I2,3)
  470 FORMAT (/10X,2A4, //,10(4X,2A4))
      CALL MESAGE (-61,0,0)
  480 CONTINUE
  490 CONTINUE
  500 CONTINUE
      IF (APPRCH .EQ. -1) GO TO 700
C
C     MOVE MED AND FILE NAME TABLES TO BOTTOM OF OPEN CORE.
C
  600 CALL CLOSE (NSCR,1)
      LMED = CNMTP - MEDTP
      DO 610 I = 1,LMED
      LL = MEDTP + LMED - I
      M  = LOSCAR - I + 1
  610 MED(M) = MED(LL)
      MEDTP  = LOSCAR - LMED + 1
      FNMTP  = MEDTP + MED(MEDTP)*MED(MEDTP+1) + 2
      LOSCAR = MEDTP - 1
C
C     DETERMINE TYPE OF RESTART IF IT IS A RESTART OF A DMAP RUN
C
  620 IF (APPRCH .NE.  -1) GO TO 700
      IF (MJMSK(LBD+1) .EQ. 0) GO TO 630
C
C     CHECK FOR NOLOOP$ AND LOOP$
C                                                  2**21
      IF (MJMSK(LBD+1).NE.1 .AND. MJMSK(LBD+1).NE.TWO(11)) GO TO 650
      MJMSK(LBD+1) = 0
C
C     CHECK FOR GUST$
C                           2**30
  630 IF (MJMSK(LBD+2) .GE. TWO(2)) GO TO 650
      DO 640 L = 1,LBD
      IF (MJMSK(L) .NE. 0) GO TO 650
  640 CONTINUE
      GO TO 180
  650 START = IMST
      SEQNO = LSHIFT(1,16)
      GO TO 180
C
C     CONTROL FILE LOADED, LOAD PVT TABLE
C     BUMP NUMBER OF FILES IF OLD PROBLEM TAPE HAD ALTERS
C
  700 PTFCT = PTFCT + ALTER(2)
      ITRL(1) = NPARAM
      CALL RDTRL (ITRL(1))
      IF (ITRL(2) .LE. 0) GO TO 760
      CALL OPEN (*1900,NPARAM,IBUFR(NPTBUF),0)
      CALL READ (*760,*710,NPARAM,PVT(6),2,1,NPTWRD)
  710 IF (PVT(6) .NE. NPVT) GO TO 1950
      I = 3
C
C      LOAD PVT VALUES INTO PVT TABLES
C
  720 CALL READ (*740,*730,NPARAM,PVT(I),PVT(1)-I+1,0,NPTWRD)
      GO TO 2020
  730 I = I + NPTWRD
      GO TO 720
  740 PVT(2) = I - 1
      CALL CLOSE (NPARAM,1)
C
C     ELIMINATE TRAILER SO FILE WILL BE DELETED
C
      DO 750 I = 2,7
  750 ITRL(I) = 0
      CALL WRTTRL (ITRL(1))
  760 CONTINUE
      IF (START .EQ. ICST) GO TO 1000
      IF (APPRCH.EQ.-1 .AND. START.EQ.IMST) GO TO 1000
C
C     INITIALIZE VPS TABLE FOR RESTART
C     GET FIRST ENTRY IN CHECKPOINT DICTIONARY
C
      PTDTOP = 1
      ASSIGN 770 TO IRTURN
      GO TO 1090
  770 I = PTDTOP
      IF (PTDIC(PTDTOP) .NE. NXVPS) GO TO 1000
C
C     FIRST ENTRY IN CHECKPOINT DICTIONARY IS XVPS - GET FILE OFF OF OLD
C     PROBLEM TAPE, OPTP
C
      CALL OPEN (*1910,IOP,IBUFR(IOPBUF),2)
C
C     CHECK TO SEE IF OLD RESTART TAPE HAS PVT  J = 0 WITHOUT PVT
C
      J = ANDF(MASKHI,PTDIC(PTDTOP+2)) - (ANDF(MASKHI,PTFCT)+1)
      PTFCT = PTFCT + J
      CALL SKPFIL (IOP,J)
      CALL READ (*2060,*780,IOP,VPS(3),2,1,IOPWRD)
  780 IF (VPS(3).NE.NXVPS .OR. VPS(4).NE.NBLANK) GO TO 2060
      J = VPS(1)
      CALL READ (*2060,*790,IOP,VPS,J,1,IOPWRD)
  790 CALL SKPFIL (IOP,1)
      CALL CLOSE  (IOP,2)
      PTFCT  = PTFCT + 1
      VPS(1) = J
C
C     FOR RESTART COMPARE PVT VALUES WITH VPS VALUES. IF NOT EQUAL SET
C     MODFLG INVPS ENTRY.
C
      IF (PVT(2) .LE. 2) GO TO 850
      I = 3
  800 J = 3
  810 IF (PVT(2) .LT. J) GO TO 840
      IF (PVT(J).EQ.VPS(I) .AND. PVT(J+1).EQ.VPS(I+1)) GO TO 820
      JJ = ANDF(PVT(J+2),NOSGN)
      J  = J + ITYPE(JJ) + 3
      GO TO 810
C
C     FOUND VARIABLE IN PVT TABLE
C
  820 L = ANDF(VPS(I+2),MASKHI)
      PVT(J+2) = ORF(PVT(J+2),ISGNON)
      DO 830 LL = 1,L
      II = I + LL + 2
      JJ = J + LL + 2
      VPS(I+2) = ORF(VPS(I+2),MODFLG)
      VPS(II ) = PVT(JJ)
  830 CONTINUE
  840 I = I + ANDF(VPS(I+2),MASKHI) + 3
      IF (I .LT. VPS(2)) GO TO 800
  850 I = LBD + LCC + 1
      IPARPT = MJMSK(I)
      IPARW1 = (IPARPT-1)/31 + 1
      IPARW2 = LBD
      IPARBT = MOD(IPARPT-1,31) + 2
      IDELET = 0
      DO 860 J1 = IPARW1,IPARW2
      IF (MJMSK(J1) .NE. 0) GO TO 870
  860 CONTINUE
      IDELET = 1
      GO TO 1000
  870 DO 920 J1 = IPARW1,IPARW2
      IF (MJMSK(J1) .EQ. 0) GO TO 910
      DO 900 I1 = IPARBT,32
      IF (ANDF(MJMSK(J1),TWO(I1)) .EQ. 0) GO TO 900
      NAMPT = 2*(31*(J1-1)+I1-1) - 1
      I2 = 3
  880 IF (MJCD(NAMPT).NE.VPS(I2) .OR. MJCD(NAMPT+1).NE.VPS(I2+1))
     1    GO TO 890
      IF (ANDF(VPS(I2+2),TWO(2)) .NE. 0) GO TO 900
      VPS(I2  ) = NBLANK
      VPS(I2+1) = NBLANK
      GO TO 900
  890 I2 = I2 + ANDF(VPS(I2+2),MASKHI) + 3
      IF (I2 .LT. VPS(2)) GO TO 880
  900 CONTINUE
  910 IPARBT = 2
  920 CONTINUE
C
C     DMAP SEQUENCE COMPILATION - PHASE 1
C     ***********************************
C
C     GENERATE OSCAR
C     POSITION NEW PROBLEM TAPE AT ALTER FILE IF IT EXISTS
C
 1000 IF (ALTER(1) .EQ. 0) GO TO 1030
      NAM1 = NXALTR
      NAM2 = NBLANK
      CALL OPEN (*1900,NPT,IBUFR(NPTBUF),0)
 1010 CALL SKPFIL (NPT,1)
      CALL READ (*1950,*1020,NPT,ICF,2,1,NPTWRD)
 1020 IF (ICF(1) .NE. NXALTR) GO TO 1010
C
C     ALTER FILE FOUND - INITIALIZE ALTER CELLS
C
      CALL READ (*1950,*1950,NPT,ALTER,2,1,NPTWRD)
 1030 CALL OPEN (*2010,NSCR,IBUFR(IDPBUF),0)
      CALL XGPIMW (1,1,0,0)
      CALL XOSGEN
      IF (START .EQ. ICST) GO TO 1050
      DO 1040 I = 1,NMASK
      MEDMSK(I) = 0
 1040 CONTINUE
 1050 IF (ALTER(1) .EQ. 0) GO TO 1060
      CALL CLOSE (NPT,2)
 1060 CONTINUE
      IF (PVT(2) .LE. 2) GO TO 1080
      J = 5
 1070 IF (PVT(2) .LT. J) GO TO 1080
      IF (PVT(J) .GE. 0) CALL XGPIDG (-54,0,PVT(J-2),PVT(J-1))
      JJ = ANDF(PVT(J),NOSGN)
      J  = J + ITYPE(JJ) + 3
      GO TO 1070
 1080 IF (NOGO .EQ. 2) GO TO 2210
      CALL CLOSE (NSCR,1)
      IF (START .NE. ICST) CALL XGPIMW (2,0,0,0)
      CALL XGPIMW (1,0,0,0)
C
C     ALLOW MINIMAL SIZE FOR PTDIC ARRAY IN OPEN CORE.
C     WE WILL EXPAND IF THIS IS RESTART.
C
      PTDTOP = OSCAR(OSBOT) + OSBOT
      PTDBOT = PTDTOP
      LPTDIC = 3
      ASSIGN 1130 TO IRTURN
C
 1090 IF (START .EQ. ICST) GO TO 1130
C
C     RESTART - LOAD OLD PROBLEM TAPE DICTIONARY INTO OPEN CORE.
C
      CALL OPEN (*1900,NPT,IBUFR(NPTBUF),0)
C
C     FIND XPTDIC ON NEW PROBLEM TAPE
C
      NAM1 = NXPTDC(1)
      NAM2 = NXPTDC(2)
 1100 CALL SKPFIL (NPT,1)
      CALL READ (*1950,*1110,NPT,PTDIC(PTDTOP),2,1,NPTWRD)
 1110 IF (PTDIC(PTDTOP) .EQ.     NXCSA) GO TO 1950
      IF (PTDIC(PTDTOP) .NE. NXPTDC(1)) GO TO 1100
C
C     FOUND XPTDIC
C
      LPTDIC = LOSCAR - PTDTOP
      CALL READ (*1950,*1120,NPT,PTDIC(PTDTOP),LPTDIC,1,NPTWRD)
      GO TO 2030
 1120 PTDBOT = PTDTOP + NPTWRD - 3
      CALL CLOSE (NPT,1)
      GO TO IRTURN, (770,1130)
C
C     IF BOTH DIAGS 14 AND 20 ARE ON, TERMINATE JOB
C
 1130 IF (DIAG14 .NE. 1) GO TO 1200
      CALL SSWTCH (20,I)
      IF (I .EQ. 0) GO TO 1200
      WRITE  (OPTAPE,1140)
 1140 FORMAT (//' *** JOB TERMINATED BY DIAG 20',//)
      CALL PEXIT
C
C     DMAP SEQUENCE COMPILATION - PHASE 2
C     ***********************************
C
C     COMPUTE NTU AND LTU FOR DATA SETS IN OSCAR
C
 1200 IF (NOGO.NE.0 .AND. START.NE.ICST .AND. PTDTOP.EQ.PTDBOT)
     1    GO TO 2210
      CALL XFLORD
      IF (DIAG14 .EQ. 11) GO TO 2120
      IF (NOGO.NE.0 .OR. LNOGO) GO TO 2210
      IF (DIAG4 .NE. 0) CALL DUMPER
C
C     PURGE ALL FILES IN FIAT TABLE THAT HAVE NOT BEEN GENERATED BY
C     IFP SUBROUTINE
C
      I = IFIAT(1)*ICFIAT - 2
      DO 1230 K = 4,I,ICFIAT
      IF (IFIAT(K+1) .EQ. 0) GO TO 1210
      IF (IFIAT(K+3).NE.0 .OR. IFIAT(K+4).NE.0 .OR. IFIAT(K+5).NE.0)
     1    GO TO 1230
      IF (ICFIAT.EQ.11  .AND. (IFIAT(K+8).NE.0 .OR. IFIAT(K+9).NE.0 .OR.
     1    IFIAT(K+10).NE.0)) GO TO 1230
C
C     FILE NOT GENERATED - PURGE IT.
C
      K1 = IFIAT(3)*ICFIAT + 4
      IFIAT(3)  = IFIAT(3) + 1
      IFIAT(K1) = ORF( ANDF(IFIAT(K),MASKLO),MASKHI)
      IFIAT(K ) = ANDF(IFIAT(K),ORF(MASKHI,LOSGN))
      IFIAT(K1+1) = IFIAT(K+1)
      IFIAT(K1+2) = IFIAT(K+2)
C
C     MAKE SURE NO RESIDUE LEFT IN FIAT TABLE
C
 1210 J1 = K + 1
      J2 = K + ICFIAT - 1
      DO 1220 J = J1,J2
 1220 IFIAT(J) = 0
C
 1230 CONTINUE
C
C     WRITE OSCAR ON DATA POOL FILE.
C
C     PUT OSCAR NAME IN DPL AND ASSIGN FILE NO.
C
      LSTDPL = LSTDPL + 1
      I = LSTDPL*3 + 1
      DPL(I  ) = IOSHDR(1)
      DPL(I+1) = IOSHDR(2)
      DPL(I+2) = NDPFIL
      NDPFIL   = 1 + NDPFIL
C
C     WRITE OSCAR HEADER RECORD
C     POSITION FILE
C
      IF (NDPFIL .EQ. 2) GO TO 1240
      CALL OPEN (*1940,IDP,IBUFR(IDPBUF),0)
      CALL SKPFIL (IDP,NDPFIL-2)
      CALL CLOSE  (IDP,2)
 1240 IDPFCT = NDPFIL - 1
      CALL OPEN (*1940,IDP,IBUFR(IDPBUF),3)
      CALL WRITE (IDP,IOSHDR,2,1)
C
C     IF CHECKPOINT AND RESTART FLAGS ARE ON INSERT CHECKPOINT ENTRY IN
C     OSCAR TO SAVE FILES LISTED IN ICPDPL TABLE
C
      IF (START .EQ. ICST) GO TO 1290
      IF (ICPBOT.GE.ICPTOP .AND. ICPFLG.NE.0) GO TO 1250
      CPNTRY(6) = 1
      CALL WRITE (IDP,CPNTRY,6,1)
      GO TO 1270
C
C     CHECKPOINT ALL FILES LISTED IN ICPDPL
C
 1250 CPNTRY(7) = (ICPBOT - ICPTOP + 3)/3
      CPNTRY(1) = 7 + CPNTRY(7)*2
C
C     FOR UNMODIFIED RESTART - DMAP SEQUENCE NO. OF THIS INITIAL
C     CHECKPOINT MUST = REENTRY POINT - 1
C
      IF (START .EQ. IUNST)
     1    CPNTRY(6) = ORF(ISGNON,RSHIFT(ANDF(SEQNO,MASKLO),16)-1)
      CALL WRITE (IDP,CPNTRY,7,0)
      DO 1260 I = ICPTOP,ICPBOT,3
 1260 CALL WRITE (IDP,ICPDPL(I),2,0)
      CALL WRITE (IDP,0,0,1)
C
C     FOR RESTART - INSERT JUMP IN OSCAR TO POSITION OSCAR AT CORRECT
C     REENTRY POINT
C     FOR MODIFIED RESTART - START AT FIRST EXECUTABLE MODULE
C
 1270 IF (START .EQ. IMST) JMP(6) = 1
C
C     SEE IF RE-ENTRY POINT IS WITHIN BOUNDS UNLESS SOLUTION CHANGED.
C
      IF (ANDF(SEQNO,MASKLO) .EQ. MASKLO) GO TO 1280
      I = ANDF(SEQNO,MASKHI)
      IF (I.GT.OSCAR(OSBOT+1) .OR. I.EQ.0) GO TO 2110
      JMP(7) = LSHIFT(I,16)
 1280 CALL WRITE (IDP,JMP,7,1)
 1290 OSPNT = 1
C
C     WRITE NEXT OSCAR ENTRY ON DATA POOL TAPE
C
 1300 CALL WRITE (IDP,OSCAR(OSPNT),OSCAR(OSPNT),1)
      IF (OSCAR(OSPNT+3) .EQ. IXTIM) GO TO 1330
      I = ANDF(OSCAR(OSPNT+2),MASKHI)
      IF (I.GT.2 .OR. OSCAR(OSPNT+5).GE.0) GO TO 1340
C
C     MAKE SURE SYSTEM HAS ENOUGH FILES AVAILABLE TO HANDLE MODULE
C     REQUIREMENTS.
C     COUNT NUMBER OF I/P AND O/P FILES NEEDED
C
      J1 = 2
      IF (I .EQ. 2) J1 = 1
      K = 0
      L = OSPNT + 6
      DO 1320 J = 1,J1
      L2 = OSCAR(L)*3 - 2 + L
      L1 = L + 1
      IF (OSCAR(L1-1) .EQ. 0) GO TO 1320
      DO 1310 L = L1,L2,3
      IF (OSCAR(L) .NE. 0) K = K + 1
 1310 CONTINUE
 1320 L = L2 + 3
C
C     ADD ON NUMBER OF SCRATCH FILES NEEDED
C
      K = K + OSCAR(L)
      IF (IFIAT(1) .LT. K) GO TO 2070
      GO TO 1340
C
C     OSCAR ENTRY IS XTIME, COMPUTE ROUGH TIME ESTIMATES FOR MODULES IN
C     TIME SEGMENT, AND
C     WRITE XTIME HEADER AND TIME ESTIMATES ONTO DATA POOL
C     (THIS SECTION TEMPORARILY OMITTED)
C
 1330 GO TO 1340
C
C     INCREMENT OSPNT AND CHECK FOR END OF OSCAR
C
 1340 OSPNT = OSPNT + OSCAR(OSPNT)
      IF (OSPNT-OSBOT) 1300,1300,1350
 1350 CALL EOF (IDP)
      IF (START .EQ. ICST) GO TO 1800
C
C
C     *** RESTART ***
C
      IF (ICPBOT .LT. ICPTOP) GO TO 1800
C
C     LIST ICPDPL CONTENTS
C
      CALL XGPIMW (8,ICPTOP,ICPBOT,ICPDPL)
C
C     ELIMINATE PURGED FILES FROM ICPDPL
C
      I1 = ICPTOP
      DO 1400 I = I1,ICPBOT,3
      IF (ANDF(ICPDPL(I+2),MASKHI) .NE. 0) GO TO 1410
 1400 ICPTOP = ICPTOP + 3
 1410 IF (ICPBOT .LT. ICPTOP) GO TO 1800
      CALL CLOSE (IDP,2)
      IB1S   = IDPBUF
      IDPBUF = ICPBOT + 3
      IOPBUF = IDPBUF + IBUFSZ
      CALL GOPEN (IDP,IBUFR(IDPBUF),3)
C
C     TRANSFER CHECKPOINT INFO FROM OLD PROBLEM TAPE TO DATA POOL TAPE
C
      K = LSTDPL*3 + 4
      CALL OPEN (*1910,IOP,IBUFR(IOPBUF),2)
      DO 1580 I = ICPTOP,ICPBOT,3
      DPL(K+2) = 0
      IF (ANDF(ICPDPL(I+2),NOFLGS) .GT. PTFCT) GO TO 1420
C
C     FILE IS EQUIVALENCED TO PREVIOUS ENTRY IN DPL
C
      NDPFIL = NDPFIL - 1
      DPL(K+2) = DPL(K-1)
      GO TO 1570
C
C     MAKE SURE CORRECT REEL IS MOUNTED FOR OLD PROBLEM TAPE
C
 1420 IF (ANDF(ANDF(NOFLGS,MASKLO),ICPDPL(I+2)) .EQ. ANDF(MASKLO,PTFCT))
     1   GO TO 1480
C
C     ** NEW REEL NEEDED **
C     MOUNT REEL SPECIFIED BY ICPDPL ENTRY
C
      OTAPID(6) = RSHIFT(ANDF(NOFLGS,ICPDPL(I+2)),16)
      WRNGRL = 0
C
C     SEND OPERATOR MESSAGE
C
 1430 CALL XEOT (IOP,RSHIFT(PTFCT,16),OTAPID(6),IBUFR(IOPBUF))
      CALL OPEN (*1910,IOP,IBUFR(IOPBUF),0)
      CALL READ (*2050,*1440,IOP,IBF,LIBF,0,IOPWRD)
C
C     SEE THAT CORRECT REEL HAS BEEN MOUNTED.
C
 1440 DO 1450 II = 1,6
      IF (OTAPID(II) .NE. IBF(II)) GO TO 1460
 1450 CONTINUE
      GO TO 1470
 1460 WRNGRL = WRNGRL + 1
      IF (WRNGRL .LT. 2) GO TO 1430
      GO TO 2100
C
C     CORRECT REEL MOUNTED - CARRY ON
C
 1470 CALL SKPFIL (IOP,1)
      PTFCT = LSHIFT(OTAPID(6),16) + 1
      IF (FILCON) 1560,1480,1560
C
C     WRITE FILE ON DATA POOL
C
 1480 CALL SKPFIL (IOP,ANDF(MASKHI,ICPDPL(I+2))-(ANDF(MASKHI,PTFCT)+1))
C
C     CHECK FOR CORRECT FILE
C
C     5 OR 8 WORDS (DEPEND ON ICFIAT VALUE OF 8 OR 11) WRITTEN TO IOP
C     BY XCHK OF PREVIOUS CHECKPOINT RUN.
C     IF ICFIAT=11, READ 5 WORDS HERE FIRST, AND CHECK IF THERE ARE 3
C     MORE WORDS BEHIND.  I.E. OPTP MAY BE WRITTEN WITH A 5-WORD RECORD
C     IF ICFIAT= 8, READ 5 WORDS
C
      IF (ICFIAT .EQ. 11) GO TO 1490
      CALL READ (*2050,*2050,IOP,IBF,5,1,IOPWRD)
      IBF(8) = 0
      GO TO 1510
 1490 IBF(8) = -999
      CALL READ (*2050,*2050,IOP,IBF(1),5,0,IOPWRD)
      CALL READ (*2050,*1510,IOP,IBF(6),3,1,IOPWRD)
C
 1510 DO 1520 II = I,ICPBOT,3
      IF (IBF(1).EQ.ICPDPL(II) .AND. IBF(2).EQ.ICPDPL(II+1)) GO TO 1530
 1520 CONTINUE
      GO TO 2050
C
C     A 5-WORD RECORD READ, EXPANDED (THE TRAILERS) TO 8 WORDS
C
 1530 IF (IBF(8) .NE. -999) GO TO 1540
      IBF(8) = ANDF(IBF(5),65535)
      IBF(7) = RSHIFT(IBF(5),16)
      IBF(6) = ANDF(IBF(4),65535)
      IBF(5) = RSHIFT(IBF(4),16)
      IBF(4) = ANDF(IBF(3),65535)
      IBF(3) = RSHIFT(IBF(3),16)
C
C     COPY FILE TO POOL
C
 1540 CALL WRITE (IDP,IBF,ICFIAT-3,1)
 1560 CALL CPYFIL (IOP,IDP,IBF,LIBF,IOPWRD)
      DPL(K+2) = DPL(K+2) + IOPWRD/1000 + 1
C
C     FILE ALL ON DATA POOL TAPE
C
      CALL EOF (IDP)
      FILCON = 0
C
C     MAKE DPL ENTRY FOR ICPDPL ENTRY
C
      DPL(K+2) = ORF(ORF(LSHIFT(DPL(K+2),16),NDPFIL),
     1           ANDF(ICPDPL(I+2),IEQFLG))
 1570 DPL(K  ) = ICPDPL(I  )
      DPL(K+1) = ICPDPL(I+1)
      IF (L8 .NE. 0) CALL CONMSG (DPL(K),2,0)
      K = K + 3
      NDPFIL = NDPFIL + 1
      LSTDPL = 1 + LSTDPL
      IF (LSTDPL .GT. MAXDPL) GO TO 2040
      PTFCT = ANDF(NOFLGS,ICPDPL(I+2))
 1580 CONTINUE
C
C     FILES ALL COPIED OVER FROM OLD PROBLEM TAPE TO DATA POOL TAPE.
C
      CALL CLOSE (IOP,1)
C
C     SEE IF XVPS IS ON POOL TAPE
C
      K = LSTDPL*3 + 1
      L = NDPFIL
      IF (DPL(K) .NE. NXVPS) GO TO 1590
C
C     VPS FILE IS LAST ENTRY IN DPL - DELETE ENTRY
C
      LSTDPL = LSTDPL - 1
      NDPFIL = NDPFIL - 1
      J = K
      GO TO 1620
C
C     VPS FILE IS NOT LAST ENTRY IN DPL - SEARCH DPL FOR IT
C
 1590 DO 1600 J = 4,K,3
      IF (DPL(J) .EQ. NXVPS) GO TO 1610
 1600 CONTINUE
C
C     NO RESTART VPS TABLE
C
      GO TO 1800
C
C     XVPS FOUND - ZERO NAME WHEN NOT LAST ENTRY IN DPL
C
 1610 DPL(J  ) = 0
      DPL(J+1) = 0
C
C     XVPS FILE FOUND IN DPL - POSITION POOL TAPE AND INITIALIZE
C     VPS TABLE WITH CHECKPOINT VALUES
C
 1620 CALL CLOSE (IDP,3)
      CALL OPEN (*1940,IDP,IBUFR(IDPBUF),2)
      CALL SKPFIL (IDP,ANDF(DPL(J+2),MASKHI)-L-1)
      NAM1 = NXVPS
      NAM2 = NBLANK
      CALL SKPFIL (IDP,1)
      CALL READ (*1930,*1630,IDP,IBF,LIBF,1,IDPWRD)
 1630 IF (IBF(1) .NE. NXVPS) GO TO 1930
      CALL READ (*1930,*1640,IDP,IBF,LIBF,1,IDPWRD)
C
C     COMPARE RESTART PARAMETER NAMES WITH VPS NAMES
C
 1640 K = 3
 1650 J = 3
      IF (ANDF(VPS(K+2),MODFLG) .EQ. MODFLG) GO TO 1730
 1660 IF (IBF(2) .LT. J) GO TO 1730
      IF (IBF(J).EQ.VPS(K) .AND. IBF(J+1).EQ.VPS(K+1)) GO TO 1670
      J = J + IBF(J+2) + 3
      GO TO 1660
C
C     PARAMETER NAMES MATCH AND MODFLG NOT ON - INITIALIZE VPS WITH
C     RESTART VALUE.
C
 1670 L = IBF(J+2)
      IF (IDELET .EQ. 1) GO TO 1710
      IPARBT = MOD(IPARPT-1,31) + 2
      DO 1700 JJJ = IPARW1,IPARW2
      IF (MJMSK(JJJ) .EQ. 0) GO TO 1690
      DO 1680 III = IPARBT,32
      IF (ANDF(MJMSK(JJJ),TWO(III)) .EQ. 0) GO TO 1680
      NAMPT = 2*(31*(JJJ-1) + III - 1) - 1
      IF (MJCD(NAMPT).EQ.VPS(K) .AND. MJCD(NAMPT+1).EQ.VPS(K+1))
     1    GO TO 1730
 1680 CONTINUE
 1690 IPARBT = 2
 1700 CONTINUE
 1710 DO 1720 M = 1,L
      J1 = M + 2 + J
      K1 = M + 2 + K
 1720 VPS(K1) = IBF(J1)
C
C     CLEAR FLAGS AND TYPE CODE IN VPS ENTRY AND GET NEXT ENTRY.
C
 1730 VPS(K+2) = ANDF(VPS(K+2),MASKHI)
      K = K + VPS(K+2) + 3
      IF (K .LT. VPS(2)) GO TO 1650
C
C     FOR UNMODIFIED RESTART LOAD CEITBL FROM LAST CHECKPOINT
C
      CALL READ (*1930,*1740,IDP,IBF,LIBF,1,IDPWRD)
 1740 IF (START .EQ. IMST) GO TO 1770
      K1 = CEITBL(2)
      J1 = IBF(2)
C
C     FOR RESTART INITIALIZE REPT LOOP COUNTS WITH CHECKPOINT INFO
C
      DO 1760 J = 3,J1,4
      DO 1750 K = 3,K1,4
      IF (CEITBL(K+2).EQ.IBF(J+2) .AND. CEITBL(K+3).EQ.IBF(J+3) .AND.
     1    IBF(J+2).NE.0) CEITBL(K+1) = IBF(J+1)
 1750 CONTINUE
 1760 CONTINUE
C
C     FOR BOTH MOD AND UNMOD RESTART - LOAD VARIOUS CELLS IN /SYSTEM/
C     WITH LAST CHECKPOINT INFO
C
 1770 CALL READ (*1790,*1780,IDP,IBF,LIBF,1,IDPWRD)
 1780 MPC  = IBF(5)
      SPC  = IBF(6)
      LOAD = IBF(8)
 1790 CONTINUE
      CALL CLOSE (IDP,1)
      IDPBUF = IB1S
C
C
C     POSITION DATA POOL TAPE AT FIRST OSCAR ENTRY
C
 1800 CALL CLOSE (IDP,1)
C
C     *** FIRST, PRODUCE DMAP XREF IF REQUESTED
C
      CALL OPEN (*1940,IDP,IBUFR(IDPBUF),2)
      CALL SKPFIL (IDP,IDPFCT-1)
      CALL FWDREC (*1920,IDP)
      IF (ANDF(IFLG(5),1) .NE. 0) CALL OSCXRF (IDPFCT-1,IDPBUF-1)
      CALL CLOSE (IDP,2)
C
C     WRITE VPS TABLE ON NEW PROBLEM TAPE IF CHECKPOINT FLAG ES SET
C     CLEAR FLAGS IN VPS
C
      K = 3
 1810 VPS(K+2) = ANDF(VPS(K+2),MASKHI)
      K = K + VPS(K+2) + 3
      IF (K .LT. VPS(2)) GO TO 1810
      IF (ICPFLG .EQ. 0) GO TO 1820
C
C     POSITION TAPE FOR WRITING XVPS
C
      CALL OPEN (*1900,NPT,IBUFR(NPTBUF),0)
      CALL SKPFIL (NPT,ANDF(NRLFL,MASKHI)-1)
      CALL CLOSE (NPT,2)
      CALL OPEN (*1900,NPT,IBUFR(NPTBUF),3)
      IBF(1) = NXVPS
      IBF(2) = NBLANK
      CALL WRITE (NPT,IBF,2,1)
      CALL WRITE (NPT,VPS,VPS(2),1)
C
C     WRITE CEITBL TABLE ON NEW PROBLEM TAPE
C
      CALL WRITE (NPT,CEITBL,CEITBL(2),1)
      CALL EOF (NPT)
      CALL CLOSE (NPT,2)
C
C     INITIALIZE CHECKPOINT PARAMETERS FOR XCHK AND XCEI ROUTINES
C
      PTDIC(PTDTOP  ) = NXVPS
      PTDIC(PTDTOP+1) = NBLANK
      PTDIC(PTDTOP+2) = NRLFL
      NRLFL = NRLFL + 1
      SEQNO = 1
C
C     WRITE NEW DICTIONARY ON XPTD
C
      CALL OPEN  (*1900,NXPTDC,IBUFR(NPTBUF),1)
      CALL WRITE (NXPTDC,NXPTDC,2,1)
      CALL WRITE (NXPTDC,NRLFL, 2,1)
      CALL WRITE (NXPTDC,PTDIC(PTDTOP),3,1)
      CALL CLOSE (NXPTDC,1)
C
C     PUNCH DICTIONARY ENTRY FOR XVPS TABLE
C
      NFILE = ANDF(MASKHI,PTDIC(PTDTOP+2))
 1820 CONTINUE
      IF (NOGO.NE.0 .OR. LNOGO) GO TO 2210
      CALL XGPIMW (9,NFILE,ICPFLG,IFIAT)
      CPPGCT = PAGECT
      IF (IFLG(1) .EQ. 0) CALL PEXIT
C
C     TERMINATE RUN IF ANY OF THE DIAG (17, 25, 28, OR 30) AND DIAG 20
C     ARE REQUESTED SIMULTANEOUSLY
C
      CALL SSWTCH (20,J)
      IF (J .EQ. 0) RETURN
      CALL SSWTCH (28,I)
      CALL SSWTCH (30,J)
      IF (DIAG17+DIAG25+I+J .EQ. 0) RETURN
      WRITE  (OPTAPE,1830)
 1830 FORMAT (10X,'JOB TERMINATED BY DIAG 20')
      CALL PEXIT
C
C     E R R O R    M E S S A G E S
C
C     UNEXPECTED END OF TAPE ON NEW PROBLEM TAPE
C
 1900 CALL XGPIDG (28,0,0,0)
      GO TO 2200
C
C     UNEXPECTED END OF TAPE ON OLD PROBLEM TAPE
C
 1910 CALL XGPIDG (29,0,0,0)
      GO TO 2200
C
C     CANNOT FIND FILE ON DATA POOL TAPE
C
 1920 NAM1 = IOSHDR(1)
      NAM2 = IOSHDR(2)
 1930 CALL XGPIDG (24,NAM1,NAM2,0)
      GO TO 2200
C
C     UNEXPECTED END OF TAPE ON DATA POOL TAPE
C
 1940 CALL XGPIDG (30,0,0,0)
      GO TO 2200
C
C     CONTROL FILE INCOMPLETE OR MISSING ON NEW PROBLEM TAPE.
C
 1950 CALL XGPIDG (31,NAM1,NAM2,0)
      GO TO 2200
C
C     MED TABLE RECORD MISSING ON SCRATCH FILE
C
 1960 CALL XGPIDG (69,NXGPI(1),NXGPI(2),0)
      GO TO 2200
C
C     CARD OR FILE NAME TABLE RECORD MISSING ON SCRATCH FILE
C
 1970 CALL XGPIDG (70,NXGPI(1),NXGPI(2),JTYPE)
      GO TO 2200
C
C     ILLEGAL NUMBER OF WORDS IN MED TABLE RECORD
C
 1980 CALL XGPIDG (71,LMED,0,0)
      GO TO 2200
C
C     ILLEGAL NUMBER OF WORDS IN CARD OR FILE NAME TABLE RECORD
C
 1990 CALL XGPIDG (72,LMED,JTYPE,0)
      GO TO 2200
C
C     ILLEGAL BIT NUMBERS IN CARD OR FILE NAME TABLE
C
 2000 CALL XGPIDG (73,JTYPE,0,0)
      GO TO 2200
C
C     SCRATCH FILE CONTAINING DMAP DATA COULD NOT BE OPENED
C
 2010 CALL XGPIDG (33,NXGPI(1),NXGPI(2),0)
      GO TO 2200
C
C     PVT TABLE OVERFLOW
C
 2020 CALL XGPIDG (14,NPVT,NBLANK,0)
      GO TO 2210
C
C     XPTDIC OVERFLOWED
C
 2030 CALL XGPIDG (14,NXPTDC(1),NXPTDC(2),0)
      GO TO 2200
C
C     DPL TABLE OVERFLOW
C
 2040 CALL XGPIDG (14,NDPL,NBLANK,0)
      GO TO 2210
C
C     CANNOT FIND FILE ON OLD PROBLEM TAPE
C
 2050 CALL XGPIDG (36,ICPDPL(I),ICPDPL(I+1),0)
      GO TO 2210
 2060 CALL XGPIDG (36,PTDIC(I),PTDIC(I+1),0)
      GO TO 2210
C
C     NOT ENOUGH FILES AVAILABLE FOR MODULE REQUIREMENTS.
C
 2070 CALL XGPIDG (-37,OSPNT,K,IFIAT(1))
      GO TO 1340
C
C     NOT ENOUGH CORE FOR GPI TABLES
C
 2080 CALL XGPIDG (38,-LOSCAR,0,0)
      GO TO 2200
C
C     MED TABLE OVERFLOW
C
 2090 CALL XGPIDG (14,NMED,NBLANK,0)
      GO TO 2200
C
C     INCORRECT OLD PROBLEM TAPE MOUNTED
C
 2100 CALL XGPIDG (35,0,0,0)
      GO TO 2210
C
C     REENTRY POINT NOT WITHIN BOUNDS
C
 2110 CALL XGPIDG (46,0,0,0)
      GO TO 2210
C
C     USER DMAP ALTER CONTAINS ERROR, DIAG 14 FLAG IS NOT REQUESTED, AND
C     ECHO IS NOT 'NONO', PRINT RIGID FORMAT BEFORE QUITTING
C
 2120 IF (IECHO .NE. -2) CALL XGPIMW (13,0,0,CORE)
      GO TO 2210
C
C     TERMINATE JOB IF NOGO = 1
C
 2200 NOGO = 2
 2210 WRITE  (OPTAPE,2220)
 2220 FORMAT (//5X,'*** JOB TERMINATED DUE TO ABOVE ERRORS')
      CALL MESAGE (-37,0,NXGPI)
      RETURN
      END

      SUBROUTINE GFSSPC(NUY,PVEC)
C
C     ROUTINE TO CALCULATE A PARTITIONING VECTOR TO REMOVE FIRST
C     ROW AND COLUMN OF FLUID STIFFNESS MATRIX IF NO SPC'S ARE ON
C     THE FLUID
C
      INTEGER       MCB(7)   ,PVEC     ,Z        ,SYSBUF   ,NAME(2)
C
C     OPEN CORE
C
      COMMON / ZZZZZZ /        Z(1)
C
C     SYSTEM COMMON
C
      COMMON / SYSTEM /       SYSBUF
C
C     PACK - UNPACK COMMON BLOCKS
C
      COMMON / ZBLPKX /       A(4)     ,IROW
C
      DATA NAME / 4HGFSS , 4HPC   /
C
C     ALLOCATE CORE
C
      NZ = KORSZ(Z(1))
      IBUF = NZ - SYSBUF
      NZ = IBUF - 1
      IF(NZ .LT. 0) GO TO 1008
C
      NUY1 = NUY - 1
      CALL MAKMCB(MCB,PVEC,NUY,2,1)
      CALL GOPEN(PVEC,Z(IBUF),1)
      CALL BLDPK(1,1,PVEC,0,0)
      A(1) = 1.0
      IROW = 1
      CALL ZBLPKI
      CALL BLDPKN(PVEC,0,MCB)
      CALL CLOSE(PVEC,1)
      CALL WRTTRL(MCB)
      RETURN
C
C     ERRORS
C
 1008 CALL MESAGE(-8,0,NAME)
      RETURN
      END

      SUBROUTINE OUTPT4
C
C     COPY MATRIX DATA BLOCKS ONTO A FORTRAN TAPE, BINARY OR ASCII
C     FORMATS, IN DENSE MATRIX FORM (FROM FIRST TO LAST NON-ZERO TERMS
C     OF COLUMNS), OR IN SPARSE FORM (BY STRINGS)
C
C     A LOGICAL OUTPUT RECORD, WHICH CAN BE ONE OR MORE PHYSICAL RECORES
C     BEGINS WITH 3 INTEGER WORD THEN AN ARRAY OF DATA
C
C     FIRST  INTEGER WORD = LOGICAL RECORD NUMBER, OR COLUMN NUMBER
C     SECOND INTEGER WORD = ROW POSITION OF 1ST NONZERO TERM IN COLUMN
C                         = 0, SPARSE MATRIX (BINARY ONLY)
C                       .LT.0, SPARSE MATRIX ROW POSITION (ASCII ONLY)
C     THIRD  INTEGER WORD = NW, LENGTH OF ARRAY DATA THAT FOLLOW
C                           NW IS BASED ON S.P. WORD COUNT (BINARY ONLY)
C                           NW IS DATA PRECISION TYPE DEPENDENT (ASCII)
C
C     OUTPUT4 DOES NOT HANDLE TABLE DATA BLOCK, EXECPT 6 SPECIAL TABLES
C     KELM, MELM, BELM, KDICT, MDICT, AND BDICT.
C
C
C     OUTPUT4   IN1,IN2,IN3,IN4,IN5 // V,N,P1 / V,N,P2 / V,N,P3  $
C
C     PARAMETERS P1, P2 AND P3 ARE INTEGERS
C
C     P1 = 0, NO ACTION TAKEN BEFORE WRITE (DEFAULT)
C        =-1, REWIND TAPE BEFORE WRITE
C        =-2, AT END, WRITE E-O-F MARK AND REWIND TAPE
C        =-3, BOTH -1 AND -2
C        =-9, NOT AVAILABLE
C
C     P2 = N, FORTRAN OUTPUT UNIT N (N = 11,...,24)
C        =-N, MATRIX WILL BE WRITTEN OUT IN SPARSE FORMAT ONTO UNIT N.
C
C     P3 = 1, FILE OUTPUT IN FORTRAN BINARY FORMAT (UNFORMATTED)
C        = 2, FILE OUTPUT IN BCD FORMAT (ASCII, FORMATTED)
C          .  NO MIXED INTEGERS AND REAL NUMBERS IN A FORMATTED RECORD.
C             THE RECORD LENGTH IS LESS THAN 132 BYTES.
C          .  IF INPUT MATRIX TO BE COPIED OUT IS IN S.P., INTEGERS ARE
C             WRITTEN OUT IN I13, AND S.P.REAL DATA IN 10E13.6.
C          .  IF INPUT MATRIX TO BE COPIED OUT IS IN D.P., INTEGERS ARE
C             WRITTEN OUT IN I16, AND D.P.REAL DATA IN 8D16.9.
C        = 3, FORMATS I16 AHD 8E16.9 ARE USED TO COPY INTEGERS AND S.P.
C             REAL DATA OUT TO OUTPUT TAPE. P3=3 IS USED ONLY FOR
C             MACHINE WITH LONG WORDS (60 OR MORE BITS PER WORD)
C
C     THESE OUTPUT FORMATS CAN BE CHANGED EASILY BY ALTERING FORMATS
C     40, 50, 60 AND 370. MAKE SURE AN OUTPUT LINE DOES NOT EXCEED 132
C     COLUMNS. OTHERWISE, IT WOULD BE FOLDED IN PRINTOUT OR SCREEN
C     LISTING.
C
C     WRITTEN BY G.CHAN/UNISYS  3/93
C
      LOGICAL          SPARSE,BO,SP,DP,CP
      INTEGER          P1,P2,P3,BUF1,D,ZERO,TRL(8),NAME(2),NONE(2),
     1                 IX(3),BLOCK(20),INP(13),SUB(2),TAB1(6),TAB2(6)
      REAL             XNS(1)
      DOUBLE PRECISION DX(1),DXNS(1)
      CHARACTER*6      DNS,SPA,DS
      CHARACTER*11     FMD,UNF,FM
      CHARACTER        UFM*23,UWM*25,UIM*29
CWKBI
      CHARACTER*80    DSNAMES
CWKBI
      COMMON / DSNAME / DSNAMES(80)
      COMMON /XMSSG /  UFM,UWM,UIM
      COMMON /BLANK /  P1,P2,P3
      COMMON /SYSTEM/  IBUFF,NOUT,DUM1(6),NLPP,DUM2(2),LINE,DUM3(2),
     1                 D(3),DUM22(22),NBPW
      COMMON /MACHIN/  MACH
      COMMON /UNPAKX/  ITU,II,JJ,INCR
      COMMON /TYPE  /  PRC(2),NWD(4)
      COMMON /ZZZZZZ/  X(1)
      EQUIVALENCE      (X(1),XNS(1))
      EQUIVALENCE      (X(1),IX(1),DX(1)),(XNS(1),DXNS(1)),(NM1,NAME(1))
      DATA    INP   /  4HUT1 ,4HUT2 ,4HUT3 ,4HINPT,4HINP1,4HINP2,4HINP3,
     1                 4HINP4,4HINP5,4HINP6,4HINP7,4HINP8,4HINP9/
      DATA    TAB1  /  4HKELM,4HMELM,4HBELM,4HKDIC,4HMDIC,4HBDIC/,
     1        TAB2  /  4HHKEL,4HHMEL,4HHBEL,4HHKDI,4HHMDI,4HHBDI/
      DATA    DNS   ,  SPA  / 'DENSE ', 'SPARSE' /  RZERO,ZERO  / 0.,0 /
      DATA    FMD   ,  UNF  / 'FORMATTED  ','UNFORMATTED' /
      DATA    NONE  ,  SUB  / 4H (NO,4HNE) ,4HOUTP,4HT4   /
CWKBI
      DATA    IFIRST / 0 /
C
      SPARSE = P2.LT.0
      P2   = IABS(P2)
      IF (P2.LE.10 .OR. P2.GT.24) GO TO 500
      BO   = P3.NE.1
      II   = 1
      INCR = 1
      LCOR = KORSZ(X(1))
      BUF1 = LCOR - IBUFF
C
      FM = UNF
      IF (BO) FM = FMD
CWKBNB
      IF ( BO .OR. IFIRST .NE. 0 ) GO TO 1
      CLOSE ( UNIT=P2 )
      OPEN (UNIT=P2,STATUS='NEW',ACCESS='SEQUENTIAL',FORM=FM,ERR=500
     1      ,FILE=DSNAMES(P2) )
1     CONTINUE
      IFIRST = 1
CWBKNE
      IF (P1.EQ.-1 .OR. P1.EQ.-3) REWIND P2
C
      DO 400 IPT = 1,5
      NDICT = 0
      INPUT = 100 + IPT
      TRL(1)= INPUT
      CALL RDTRL (TRL(1))
      IF (TRL(1) .LE. 0) GO TO 400
      CALL FNAME (INPUT,NAME)
      IF (NM1.EQ.NONE(1) .AND. NAME(2).EQ.NONE(2)) GO TO 400
      IF (TRL(7).EQ.0 .AND. TRL(8).EQ.0) GO TO 250
      IF (TRL(4).LT.1 .OR.  TRL(4).GT.8) GO TO 250
      NC   = TRL(2)
      NR   = TRL(3)
      ITU  = TRL(5)
      IF (NC.EQ.0 .OR. NR.EQ.0 .OR. (ITU.LT.1 .OR. ITU.GT.4)) GO TO 250
      NWDS = NWD(ITU)
      IF (NR*NWDS .GE. BUF1) CALL MESAGE (-8,LCOR,SUB)
      DP   = ITU.EQ.2 .OR. ITU.EQ.4
      SP   = .NOT.DP
      CP   = SP .AND. P3.EQ.3 .AND. NBPW.GE.60
      IF (CP) SP = .FALSE.
      IF (BO .AND. SPARSE .AND. NC.GT.2000) WRITE (NOUT,10) UWM
   10 FORMAT (A25,' FROM OUTPUT4 MODULE. ON ASCII TAPE AND SPARSE ',
     1       'MATRIX OUTPUT, EACH STRING OF DATA IS WRITTEN OUT TO THE',
     2   /5X,'OUTPUT TAPE AS A FORTRAN FORMATTED REDORD. FATAL ERROR',
     3       ' COULD OCCUR WHEN NO. OF RECORDS EXCEED SYSTEM I/O LIMIT')
C
C     OPEN INPUT DATA BLOCK TO READ WITH REWIND
C
      CALL OPEN (*520,INPUT,X(BUF1),0)
      CALL FWDREC (*520,INPUT)
C
      BLOCK(1) = INPUT
C
C     WRITE TRAILER RECORD ON OUTPUT TAPE.
C     SET FORM (TRL(4)) TO NEGATIVE IF ASCII RECORDS IS REQUESTED
C
      K = -TRL(4)
      IF (.NOT.BO) WRITE (P2   ) NC,NR,TRL(4),ITU,NAME
      IF (     BO) WRITE (P2,20) NC,NR,K     ,ITU,NAME
   20 FORMAT (1X,4I13,5X,2A4)
C
      IF (SPARSE) GO TO 100
C
C     DENSE MATRIX OUTPUT -
C     WRITE THE MATRIX COLUMNS FROM FIRST TO LAST NON-ZERO TERMS
C
   30 DO 80 K = 1,NC
      II = 0
      CALL UNPACK (*40,INPUT,X)
      JJ = (JJ-II+1)*NWDS
      IF (BO) GO TO 40
C
      WRITE (P2) K,II,JJ,(X(L),L=1,JJ)
      GO TO 80
C
   40 M = JJ/2
      IF (SP) WRITE (P2,50) K,II,JJ,( X(L),L=1,JJ)
      IF (CP) WRITE (P2,60) K,II,JJ,( X(L),L=1,JJ)
      IF (DP) WRITE (P2,70) K,II,JJ,(DX(L),L=1,M )
   50 FORMAT (1X,3I13,/,(1X,10E13.6))
   60 FORMAT (1X,3I16,/,(1X, 8E16.9))
   70 FORMAT (1X,3I16,/,(1X, 8D16.9))
C
   80 CONTINUE
C
      GO TO 210
C
C     SPARSE MATRIX OUPUT -
C     WRITE A RECORD FOR EACH MATRIX COLUMN, IN PACKED STRINGS DATA
C     IF MATRIX IS NOT WRITTEN IN STRINGS, SEND THE MATRIX TO THE DENSE
C     MATRIX METHOD
C
  100 CALL RECTYP (INPUT,K)
      IF (K .NE. 0) GO TO 110
      CALL REWIND (INPUT)
      CALL FWDREC (*520,INPUT)
      GO TO 30
C
C     BLOCK(2) = STRING TYPE, 1,2,3 OR 4
C     BLOCK(4) = FIRST ROW POSITION ON A MATRIX COLUMN
C     BLOCK(5) = POINTER TO STRING IN XNS ARRAY
C     BLOCK(6) = NO. OF TERMS IN STRING
C
  110 NWORDS   = NWD(ITU)
      NWORD1   = NWORDS - 1
      DO 200 K = 1,NC
      BLOCK(8) = -1
      NW = 0
  120 CALL GETSTR (*150,BLOCK)
      IF (BO) GO TO 160
      LN = BLOCK(6)*NWORDS
      J1 = BLOCK(5)*NWORDS - NWORD1
      J2 = J1 + LN - 1
C
      NW = NW + 1
      IX(NW) = BLOCK(4) + 65536*BLOCK(6)
      L  = 1
      DO 130 J = J1,J2
      X(L+NW) = XNS(J)
  130 L  = L + 1
      NW = NW + LN
      IF (NW .GE. BUF1) CALL MESAGE (-8,LCOR,SUB)
  140 CALL ENDGET (BLOCK)
      GO TO 120
  150 IF (NW .GT. 0) WRITE (P2) K,ZERO,NW,(X(J),J=1,NW)
      GO TO 200
C
C     NOTE - FOR THE BCD OUTPUT RECORD, THE 2ND INTEGER WORD, ZERO
C     BEFORE, IS REPLACED BY THE NEGATIVE OF THE ROW POSITION (IN A
C     MATRIX COLUMN).
C     DOUBLE THE POINTER TO THE STRING IN XNS ARRAY, J1, IF DATA TYPE IS
C     COMPLEX, BUT NOT THE LENGTH LN.
C
  160 LN = BLOCK(6)
      J1 = BLOCK(5)
      IF (BLOCK(2) .GE. 3) J1 = J1*2
      J2 = J1 + LN - 1
      MROW = -BLOCK(4)
C
C                   ZERO REPLACED   EXACT LENGTH OF XNS, OR DXNS
C                               /   /
      IF (SP) WRITE (P2,50) K,MROW,LN,( XNS(J),J=J1,J2)
      IF (CP) WRITE (P2,60) K,MROW,LN,( XNS(J),J=J1,J2)
      IF (DP) WRITE (P2,70) K,MROW,LN,(DXNS(J),J=J1,J2)
      GO TO 140
C
  200 CONTINUE
C
C     WRITE AN EXTRA NCOL+1 COLUMN RECORD OUT TO P2, AND AT LEAST ONE
C     VALUE OF ZERO
C
  210 M  = 1
      K  = NC + 1
      IF (BO) GO TO 220
      WRITE (P2) K,M,M,RZERO
      GO TO 230
  220 IF (SP) WRITE (P2,50) K,M,M,RZERO
      IF (CP .OR. DP) WRITE (P2,60) K,M,M,RZERO
  230 DS = DNS
      IF (SPARSE) DS = SPA
      WRITE  (NOUT,240) UIM,NAME,P2,INP(P2-10),FM,DS,(TRL(L),L=2,7)
  240 FORMAT (A29,' FROM OUTPUT4 MODULE. DATA BLOCK ',2A4,' WAS WRITTEN'
     1,       ' OUT TO FORTRAN TAPE',I3,' (',A4,')', /5X,'IN ',A11,
     2        ' RECORDS. ',A6,' MATRIX FORM.  TRAILER =',5I6,I9)
      GO TO 280
C
C     INPUT FILE IS A TABLE DATA BLOCK
C     ONLY 6 SPECIAL TABLES ARE ALLOWED
C
  250 DO 260 I = 1,6
      IF (NM1.EQ.TAB1(I) .OR. NM1.EQ.TAB2(I)) GO TO 290
  260 CONTINUE
      IF (BO) WRITE (P2,270) UWM,INPUT,NAME,(TRL(J),J=2,7)
      WRITE  (NOUT,270) UWM,INPUT,NAME,(TRL(J),J=2,7)
  270 FORMAT (A25,'. INPUT DATA BLOCK',I5,2H, ,2A4,', IS A TABLE OR A ',
     1       'NULL MATRIX. OUTPUT4 MODULE HANDLES ONLY MATRICES', /5X,
     2       'TRAILER =',6I6)
  280 CALL CLOSE (INPUT,1)
      GO TO 400
C
C     KELM, MELM AND BELM (AND HKELM, HMELM AND HBELM) TALBES
C
  290 IF (SPARSE) WRITE (NOUT,300) UWM,NAME,P2,P3
  300 FORMAT (A25,'. PARAMETER P2 FOR SPARSE MATRIX IS MEANINGLESS FOR',
     1       ' THE ',2A8,' INPUT FILE.   P2,P3 =',2I4,/)
      CALL OPEN (*520,INPUT,X(BUF1),0)
      CALL FWDREC (*520,INPUT)
      K = -TRL(4)
      IF (.NOT.BO) WRITE (P2   ) NC,NR,TRL(4),ITU,NAME
      IF (     BO) WRITE (P2,20) NC,NR,K     ,ITU,NAME
      J = 1
      K = 0
      IF (I .GE. 4) GO TO 310
      DP = TRL(2).EQ.2
      SP = .NOT.DP
      CP = SP .AND. P3.EQ.3 .AND. NBPW.GE.60
      IF (CP) SP = .FALSE.
  310 K = K + 1
      CALL READ (*380,*320,INPUT,X,BUF1-1,1,M)
      CALL MESAGE (-8,0,SUB)
  320 IF (I .GE. 4) GO TO 350
      IF (BO) GO TO 330
      WRITE (P2) K,J,M,(X(L),L=1,M)
      GO TO 310
C
  330 IF (DP) GO TO 340
      IF (SP) WRITE (P2,50) K,J,M,( X(L),L=1,M)
      IF (CP) WRITE (P2,60) K,J,M,( X(L),L=1,M)
      GO TO 310
  340 M = M/2
      WRITE (P2,70) K,J,M,(DX(L),L=1,M)
      GO TO 310
C
C     KDICT, MDICT AND BDICT (AND HKDICT, HMDICT AND HBDICT) TABLES.
C     INTEGERIZE THE DAMPING CONSTANT (BY 10**8) BEFORE OUTPUT THE ARRAY
C
  350 NDICT = IX(3) + 5
      DO 360 I = 8,M,NDICT
      IX(I) = IFIX(X(I)*100000000.)
  360 CONTINUE
      IF (.NOT.BO) WRITE (P2) K,J,M,(IX(L),L=1,M)
      IF (BO .AND. .NOT.CP) WRITE (P2,370) K,J,M,(IX(L),L=1,M)
      IF (BO .AND.      CP) WRITE (P2,375) K,J,M,(IX(L),L=1,M)
  370 FORMAT (1X,3I13,/,(1X,10I13))
  375 FORMAT (1X,3I13,/,(1X, 8I16))
      GO TO 310
C
  380 IF (.NOT.BO) WRITE (P2) K,J,J,ZERO
      IF (BO .AND. .NOT.CP) WRITE (P2,370) K,J,J,ZERO
      IF (BO .AND.      CP) WRITE (P2,375) K,J,J,ZERO
      IF (NDICT .NE. 0) WRITE  (NOUT,390) UIM,NAME,INP(P2-10)
  390 FORMAT (A29,'. THE DAMPING CONSTANT TERMS FROM ',2A4,' WERE ',
     1       'MULTIPLIED BY 10**8, AND INTEGERIZED', /5X,
     2       'BEFORE WRITING OUT TO ',A4,' OUTPUT FILE')
      GO TO 280
C
  400 CONTINUE
C
      IF (P1.NE.-2 .AND. P1.NE.-3) GO TO 600
      ENDFILE P2
      REWIND  P2
      CLOSE (UNIT=P2)
      GO TO 600
C
C     ERRORS
C
  500 WRITE  (NOUT,510) UFM,P2
  510 FORMAT (A23,'. CANNOT OPEN OUTPUT FORTRAN FILE. UNIT =',I4)
      GO TO  540
  520 WRITE  (NOUT,530) UWM,INPUT
  530 FORMAT (A25,'. OUTPT4 CANNOT OPEN INPUT DATA BLOCK',I5)
C
  540 CALL MESAGE (-37,0,SUB)
  600 RETURN
      END

      SUBROUTINE SCE1
C
C     MODULE 2.6 SCE PARTITIONS KNN,MNN,BNN,AND K4NN
C
C     TO ELIMINATE THE EFFECTS OF SINGLE POINT CONSTRAINTS IF US IS NOT
C     NULL
C
      INTEGER        US,USET,BNN,BFF,UN,UF,PVECT
      COMMON /PATX / N(2),N3,NN(3)
      DATA    UN,UF, US /
     1        27,26, 31 /
      DATA    USET , KNN,MNN,BNN,K4NN,KFF,KFS,KSS,MFF,BFF,K4FF,PVECT /
     1        101  , 102,103,104,105 ,201,202,203,204,205,206 ,301   /
C
      CALL UPART (USET,PVECT,UN,UF,US)
      CALL MPART (KNN,KFF,0,KFS,KSS)
      CALL MPART (MNN,MFF,0,0,0)
      CALL MPART (BNN,BFF,0,0,0)
      CALL MPART (K4NN,K4FF,0,0,0)
      RETURN
      END

      SUBROUTINE NSINFO (JUMP)
C
C     THIS ROUTINE READS AND PROCESSES DATA IN THE NASINFO FILE
C
C     JUMP = 2, NSINFO IS CALLED BY NASCAR TO OPEN NASINFO FILE AND
C               PROCESS THE SYSTEM PRESET PARAMETERS IN THE 2ND SECTION
C               OF THE FILE, AND THE BCD WORDS (USED ONLY BY NUMTYP
C               SUBROUTINE) IN THE 3RD SECTION
C     JUMP = 3, NSINFO IS CALLED BY TTLPGE TO PROCESS THE INSTALLATION-
C               CENTER-TO-USER MESSAGES STORED IN THE 4TH SECTION OF
C               THE NASINFO FILE
C     JUMP = 4, NSINFO IS CALLED BY XCSA TO ECHO DIAG 48 MESSAGE STORED
C               IN THE 5TH SECITON OF THE NASINFO FILE.
C
C     SINCE DIAG48 MAY NOT BE CALLED, NASINFO FILE IS CLOSED BY XCSA
C
C     WRITTEN BY G.CHAN/UNISYS    6/1990
C
      IMPLICIT INTEGER (A-Z)
CWKBR 8/94 SUN INTEGER         NAME(2),NTAB(5),CARDX(4),CARD(20),DIAG48(4)                 
      INTEGER         NAME(2),CARDX(4),CARD(20),DIAG48(4)           
      REAL            TIME
CWKBR CHARACTER*167   IFILE
      CHARACTER*144   IFILE
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG / UFM,UWM,UIM,SFM
      COMMON /MACHIN/ MACH
      COMMON /SYSTEM/ SYS(100)
      COMMON /NTIME / NT,TIME(16)
      COMMON /OUTPUT/ DUM(64),PGHDG3(32)
      COMMON /NUMTPX/ NBCD,BCD(1)
      COMMON /BLANK / IBLNK(60)
      EQUIVALENCE     (CARDX(1),CARD(1))
      EQUIVALENCE     (SYS(1),SYSBUF), (SYS( 2),NOUT), (SYS( 9),NLPP  ),
     1                (SYS(14),MXLNS), (SYS(19),EHCO), (SYS(31),HICORE),
     2                (SYS(35),LPRUS), (SYS(37),LU  ), (SYS(36),NPRUS ),
     3                (SYS(20),PLTOP), (SYS(92),DICT), (SYS(76),NOSBE ),
     4                (SYS(77),BNDIT), (SYS(91),LPCH)
      DATA    TTPG     / 0            /
CWKBR 8/94 SUN DATA    EQU   , R  ,  S  ,  BNK      ,   EQUALS   , NAME         /
CWKBR 8/94 SUN1        1H=   , 1HR,  1HS,  4H       ,   4H====   , 4HNSIN,2HFO  /
      DATA    EQU   , S  ,  BNK      ,   EQUALS   , NAME         /
     1        1H=   , 1HS,  4H       ,   4H====   , 4HNSIN,2HFO  /
      
      DATA    RELSE , TPG,  POP,  TIM,  MXL,   BSZ      , S3S   ,SKP3  /
     1        4HELEA, 3HTPG,3HPOP,3HTIM,3HMXL, 3HBSZ    , 3HS3S ,0     /
      DATA    LPP   , HIC,  BND,  ECH,  NOS,   PRU,  NPR,  PCH,  END   /
     1        3HLPP , 3HHIC,3HBND,3HECH,3HNOS, 3HPRU,3HNPR,3HPCH,3HEND /
      DATA    S88   , S89,  S90,  S92,  S94,   S96,  S97,  S98,  S99   /
     1        3HS88 , 3HS89,3HS90,3HS92,3HS94, 3HS96,3HS97,3HS98,3HS99 /
      DATA    DIAG48                         , DD   ,DIC  ,COD  ,KEY   /
     1        4H D I, 4H A G, 4H   4, 2H 8   , 3H$. ,3HDIC,3HCOD,3HKEY /
C
      GO TO (550,200,350,400), JUMP
C
C     JUMP = 2
C     ========
C
C     OPEN NASINFO FILE, AND SET LU, THE 37TH WORD OF /SYSTEM/
C
C     CURRENTLY 'NASINFO' IS USED FOR ALL MACHINES OF TYPE 5 AND HIGHER
C
 200  LU  = 99
      CALL NASOPN (*280, LU, IFILE)
C
C     SEARCH FOR FIRST EQUAL-LINE
C
 210  READ (LU,220,ERR=275,END=275) CARDX
 220  FORMAT (20A4)
      IF (CARD(1).NE.EQUALS .AND. CARD(2).NE.EQUALS) GO TO 210
C
C     READ AND PROCESS THE 2ND SECTION OF NASINFO FILE
C
 230  READ (LU,235,END=500) SYMBOL,EQ,VALUE
 235  FORMAT (A4,A1,I7)
      IF (SYMBOL .EQ. BNK) GO TO 230
      IF (EQ     .NE. EQU) GO TO 520
      IF (SYMBOL .EQ. TIM) GO TO 250
      IF (SYMBOL .EQ. END) GO TO 290
      IF (VALUE  .EQ. -99) GO TO 230
      IF (SYMBOL .EQ. S3S) GO TO 240
      IF (SYMBOL .EQ. BSZ) SYSBUF  = VALUE
      IF (SYMBOL .EQ. LPP) NLPP    = VALUE
      IF (SYMBOL .EQ. HIC) HICORE  = VALUE
      IF (SYMBOL .EQ. MXL) MXLNS   = VALUE
      IF (SYMBOL .EQ. TPG) TTPG    = VALUE
      IF (SYMBOL .EQ. ECH) ECHO    = VALUE
      IF (SYMBOL .EQ. PCH) LPCH    = VALUE
      IF (SYMBOL .EQ. DIC) DICT    = VALUE
      IF (SYMBOL .EQ. BND) BNDIT   = VALUE
      IF (SYMBOL .EQ. POP) PLTOP   = VALUE
      IF (SYMBOL .EQ. PRU) LPRUS   = VALUE
      IF (SYMBOL .EQ. NPR) NPRUS   = VALUE
      IF (SYMBOL .EQ. NOS) NOSBE   = VALUE
      IF (SYMBOL .EQ. COD) CODE    = VALUE
      IF (SYMBOL .EQ. KEY) KEY     = VALUE
      SYMB1 = KHRFN1(BNK,1,SYMBOL,1)
      IF (SYMB1  .NE.   S) GO TO 230
      IF (SYMBOL .EQ. S88) SYS(88) = VALUE
      IF (SYMBOL .EQ. S89) SYS(89) = VALUE
      IF (SYMBOL .EQ. S90) SYS(90) = VALUE
      IF (SYMBOL .EQ. S92) SYS(92) = VALUE
      IF (SYMBOL .EQ. S94) SYS(94) = VALUE
      IF (SYMBOL .EQ. S96) SYS(96) = VALUE
      IF (SYMBOL .EQ. S97) SYS(97) = VALUE
      IF (SYMBOL .EQ. S98) SYS(98) = VALUE
      IF (SYMBOL .EQ. S99) SYS(99) = VALUE
      GO TO 230
C
C     SKIP JUMP 3 PRINTOUT
C
 240  SKP3 = 1
      GO TO 230
C
C     READ IN 16 GINO TIME CONSTANTS (NT=16)
C
 250  IF (VALUE .NE. NT) GO TO 270
      READ (LU,260,END=500) TIME
 260  FORMAT (12X,8F7.2, /12X,8F7.2)
      GO TO 230
 270  READ (LU,235,END=500) SYMBOL
      READ (LU,235,END=500) SYMBOL
      GO TO 230
C
C     NASINFO DOES NOT EXIST (or IS WRITE-PROTECTED), SET LU TO ZERO
C
 275  CLOSE (UNIT=LU)
      CALL MESAGE (2,0,NAME)
 280  WRITE (NOUT, 285) IFILE
 285  FORMAT ('0*** USER WARNING MESSAGE, UNABLE TO OPEN ',
     *        'THE FOLLOWING NASINFO FILE -- '//
CWKBR*        1X, A167/)
     *        1X, A44/)
      LU = 0
      GO TO 550
C
C     READ PASS THE 2ND EQUAL-LINE. CONTINUE INTO 3RD SECTION
C
 290  READ (LU,220,END=500) CARDX
      IF (CARD(1).NE.EQUALS .AND. CARD(2).NE.EQUALS) GO TO 290
C
C
C     THIS 3RD SECTION CONTAINS BCD WORDS WHICH ARE REALLY REAL NUMBERS.
C     (THE BINARY REPRESENTATIONS OF SOME REAL NUMBERS AND THEIR
C     CORRESPONDING BCD WORDS ARE EXACTLY THE SAME. SUBROUTINE NUMTYP
C     MAY IDENTIFY THEM AS TYPE BCD. ANY WORD ON THE BCD LIST WILL BE
C     REVERTED BACK TO AS TYPE REAL. THE LIST IS MACHINE DEPENDENT)
C
C     SKIP FIRST 5 COMMENT LINES
C
      READ (LU,220,END=500)
      READ (LU,220)
      READ (LU,220)
      READ (LU,220)
      READ (LU,220)
C
 300  READ (LU,305,END=500) MACHX,NBCD
 305  FORMAT (I2,I3)
      IF (MACHX .EQ. MACH) GO TO 320
      IF (NBCD .EQ. 0) GO TO 300
      DO 310 I = 1,NBCD,19
      READ (LU,325)
 310  CONTINUE
      GO TO 300
 320  IF (NBCD .EQ. 0) GO TO 340
      JB = 1
      DO 330 I = 1,NBCD,19
      JE = JB + 18
      READ (LU,325) (BCD(J),J=JB,JE)
 325  FORMAT (5X,19(A4,1X))
 330  CONTINUE
C
C     READ PASS THE 3RD EQUAL-LINE, THEN RETURN
C
 340  READ (LU,220,END=500) CARDX
      IF (CARD(1).NE.EQUALS .AND. CARD(2).NE.EQUALS) GO TO 340
      IF (TTPG .NE. 0) JUMP = TTPG
      GO TO 550
C
C     JUMP = 3
C     ========
C
C     READ AND ECHO OUT INSTALLATION-CENTER-TO-USER MESSAGES, SAVED IN
C     THE 4TH SECTION OF NASINFO FILE
C     TERMINATE MESSAGES BY THE LAST EQUAL-LINE.
C
C     IN THIS MESSAGE SECTION ONLY, SKIP INPUT LINE IF A '$.  ' SYMBOL
C     IS IN FIRST 4 COLUMNS.
C
 350  IF (LU.EQ.0 .OR. SKP3.EQ.1) GO TO 550
      CALL PAGE1
 360  READ (LU,220,END=500) CARD
      IF (CARD(1) .EQ.     DD) GO TO 360
      IF (CARD(1) .NE. EQUALS) GO TO 380
      IF (CARD(2) .EQ. EQUALS) GO TO 550
      CALL PAGE1
      WRITE  (NOUT,370)
 370  FORMAT (//)
      GO TO 360
 380  WRITE  (NOUT,390) CARD
 390  FORMAT (25X,20A4)
      GO TO 360
C
C     JUMP = 4
C     ========
C
C     PROCESS DIAG48 MESSAGE, SAVED IN THE 5TH SECTION OF NASINFO FILE
C
 400  CALL SSWTCH (20,L20)
      IF (LU .EQ. 0) GO TO 480
      DO 410 I = 10,20
 410  PGHDG3(I) = BNK
      PGHDG3(6) = DIAG48(1)
      PGHDG3(7) = DIAG48(2)
      PGHDG3(8) = DIAG48(3)
      PGHDG3(9) = DIAG48(4)
      LINE  = NLPP + 1
      COUNT = 0
C
C     READ AND PRINT RELEASE NEWS
C     PRINT LAST TWO YEARS OF NEWS ONLY, IF DIAG 20 IS ON
C     (MECHANISM - GEAR TO THE 'nn RELEASE' LINE AND '========' LINES)
C
      ONE = 1
      IF (L20 .EQ. 1) ONE = 0
 420  READ (LU,220,END=540) CARD
      IF (CARD(1).EQ.EQUALS .AND. CARD(2).EQ.EQUALS) GO TO 470
      IF (ONE .EQ. -1) GO TO 440
      IF (CARD(2).NE.RELSE  .OR.  CARD(4).NE.   BNK) GO TO 440
      COUNT = COUNT + ONE
      IF (COUNT .LE. 2) GO TO 440
 430  READ (LU,220,END=540) CARDX
      IF (CARD(1).NE.EQUALS .OR. CARD(2).NE.EQUALS) GO TO 430
      GO TO 470
 440  IF (LINE .LT. NLPP) GO TO 460
      CALL PAGE1
      IF (LINE .EQ. NLPP) GO TO 450
      LINE = 3
      GO TO 460
 450  WRITE (NOUT,370)
      LINE = 5
 460  LINE = LINE + 1
      WRITE (NOUT,390) CARD
      GO TO 420
C
C     READ AND PRINT THE REST OF SECTION 5
C
 470  IF (ONE .EQ. -1) GO TO 540
      ONE  = -1
      LINE = NLPP + 1
      GO TO 420
C
 480  WRITE  (NOUT,490) UIM
 490  FORMAT (A29,', DIAG48 MESSAGES ARE NOT AVAILABLE DUE TO ABSENCE ',
     1       'OF THE NASINFO FILE')
      GO TO 540
C
C     ERROR
C
 500  WRITE  (NOUT,510) SFM
 510  FORMAT (A25,' 3002, EOF ENCOUNTERED WHILE READING NASINFO FILE')
      STOP 'JOB TERMINATED IN SUBROUTINE NSINFO'
 520  WRITE  (NOUT,530) SYMBOL,EQ,VALUE
 530  FORMAT ('0*** ERROR IN NASINFO FILE - LINE - ',A4,A1,I7)
      GO TO 230
C
 540  IF (L20 .EQ. 0) GO TO 550
      CLOSE (UNIT=LU)
      CALL PEXIT
 550  RETURN
      END

      SUBROUTINE KSOLID (ITYPE)
C
C     IOPT = 1 IMPLIES WEDGE - 3 TETRAHEDRONS
C     IOPT = 2 IMPLIES HEXA(6-SIDED-SOLID) 5  TETRAHEDRONS
C     IOPT = 3 IMPLIES HEXA(6-SIDED-SOLID) 10 TETRAHEDRONS
C
C     ECPT        TETRA          WEDGE          HEXA
C     ------------------------------------------------
C     ECPT( 1) =  EL ID          EL ID          EL ID
C     ECPT( 2) =  MAT-ID         MAT-ID         MAT-ID
C     ECPT( 3) =  GRID-1         GRID-1         GRID-1
C     ECPT( 4) =  GRID-2         GRID-2         GRID-2
C     ECPT( 5) =  GRID-3         GRID-3         GRID-3
C     ECPT( 6) =  GRID-4         GRID-4         GRID-4
C     ECPT( 7) =  CSID-1         GRID-5         GRID-5
C     ECPT( 8) =  X1             GRID-6         GRID-6
C     ECPT( 9) =  Y1             CSID-1         GRID-7
C     ECPT(10) =  Z1             X1             GRID-8
C     ECPT(11) =  CSID-2         Y1             CSID-1
C     ECPT(12) =  X2             Z1             X1
C     ECPT(13) =  Y2             CSID-2         Y1
C     ECPT(14) =  Z2             X2             Z1
C     ECPT(15) =  CSID-3         Y2             CSID-2
C     ECPT(16) =  X3             Z2             X2
C     ECPT(17) =  Y3             CSID-3         Y2
C     ECPT(18) =  Z3             X3             Z2
C     ECPT(19) =  CSID-4         Y3             CSID-3
C     ECPT(20) =  X4             Z3             X3
C     ECPT(21) =  Y4             CSID-4         Y3
C     ECPT(22) =  Z4             X4             Z3
C     ECPT(23) =  EL-TEM         Y4             CSID-4
C     ECPT(24)                   Z4             X4
C     ECPT(25)                   CSID-5         Y4
C     ECPT(26)                   X5             Z4
C     ECPT(27)                   Y5             CSID-5
C     ECPT(28)                   Z5             X5
C     ECPT(29)                   CSID-6         Y5
C     ECPT(30)                   X6             Z5
C     ECPT(31)                   Y6             CSID-6
C     ECPT(32)                   Z6             X6
C     ECPT(33)                   ELTEMP         Y6
C     ECPT(34)                                  Z6
C     ECPT(35)                                  CSID-7
C     ECPT(36)                                  X7
C     ECPT(37)                                  Y7
C     ECPT(38)
C     ECPT(39)                                  CSID-8
C     ECPT(40)                                  X8
C     ECPT(41)                                  Y8
C     ECPT(42)                                  Z8
C     ECPT(43)                                  EL-TEMP
C
C     MAP FOR WEDGE  M(I,J)  I = TETRAHEDRON, J = GRID POINT
C
      LOGICAL         NOGO
      INTEGER         NECPT(52),OUT,M(22,4)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /SYSTEM/ SYSBUF,OUT,NOGO
      COMMON /SMA1ET/ ECPT(100)
      COMMON /SMA1CL/ IOPT4,K4GGSW,NPVT,ISKP(19),NOGOO
      COMMON /SMA1DP/ R12(3),R13(3),R(3),RXR(3),R24(3)
      EQUIVALENCE     (NECPT(1),ECPT(1))
      DATA    M( 1,1),M( 1,2),M( 1,3),M( 1,4) / 1   ,2   ,3   ,4 /
      DATA    M( 2,1),M( 2,2),M( 2,3),M( 2,4) / 1   ,2   ,3   ,5 /
      DATA    M( 3,1),M( 3,2),M( 3,3),M( 3,4) / 1   ,2   ,3   ,6 /
      DATA    M( 4,1),M( 4,2),M( 4,3),M( 4,4) / 1   ,4   ,5   ,6 /
      DATA    M( 5,1),M( 5,2),M( 5,3),M( 5,4) / 2   ,4   ,5   ,6 /
      DATA    M( 6,1),M( 6,2),M( 6,3),M( 6,4) / 3   ,4   ,5   ,6 /
      DATA    M( 7,1),M( 7,2),M( 7,3),M( 7,4) / 2   ,1   ,4   ,6 /
      DATA    M( 8,1),M( 8,2),M( 8,3),M( 8,4) / 2   ,3   ,4   ,6 /
      DATA    M( 9,1),M( 9,2),M( 9,3),M( 9,4) / 1   ,3   ,4   ,5 /
      DATA    M(10,1),M(10,2),M(10,3),M(10,4) / 2   ,3   ,4   ,5 /
      DATA    M(11,1),M(11,2),M(11,3),M(11,4) / 3   ,1   ,5   ,6 /
      DATA    M(12,1),M(12,2),M(12,3),M(12,4) / 2   ,1   ,5   ,6 /
C
C     MAP FOR HEXA-SOLID (5 OR 10 TETRAHEDRONS)
C
      DATA    M(13,1),M(13,2),M(13,3),M(13,4) / 1   ,2   ,3   ,6 /
      DATA    M(14,1),M(14,2),M(14,3),M(14,4) / 1   ,3   ,4   ,8 /
      DATA    M(15,1),M(15,2),M(15,3),M(15,4) / 1   ,3   ,8   ,6 /
      DATA    M(16,1),M(16,2),M(16,3),M(16,4) / 1   ,5   ,6   ,8 /
      DATA    M(17,1),M(17,2),M(17,3),M(17,4) / 3   ,6   ,7   ,8 /
      DATA    M(18,1),M(18,2),M(18,3),M(18,4) / 2   ,3   ,4   ,7 /
      DATA    M(19,1),M(19,2),M(19,3),M(19,4) / 1   ,2   ,4   ,5 /
      DATA    M(20,1),M(20,2),M(20,3),M(20,4) / 2   ,4   ,5   ,7 /
      DATA    M(21,1),M(21,2),M(21,3),M(21,4) / 2   ,5   ,6   ,7 /
      DATA    M(22,1),M(22,2),M(22,3),M(22,4) / 4   ,5   ,7   ,8 /
      DATA    IDELEM / 0 /
C
C     BRANCH ON ELEMENT TYPE
C
      IGFLAG = 0
      GO TO (1000,2000,3000), ITYPE
C
C     COME HERE FOR WEDGE COMPUTATIONS.
C     KTETRA IS CALLED 3 TIMES BASED ON WEDGE MAPPING MATRIX.
C
 1000 ITET   = 1
      NTET   = 12
      ITEMP  = 33
      NGRIDS = 6
      IOPT   = 0
C
C     BASE CROSS PRODUCT
C
      IF (NECPT(1) .EQ. IDELEM) GO TO 1951
      IDELEM = NECPT(1)
      IGFLAG = 1
      R12(1) = ECPT(14) - ECPT(10)
      R12(2) = ECPT(15) - ECPT(11)
      R12(3) = ECPT(16) - ECPT(12)
      R13(1) = ECPT(18) - ECPT(10)
      R13(2) = ECPT(19) - ECPT(11)
      R13(3) = ECPT(20) - ECPT(12)
      CALL SAXB (R12,R13,RXR)
C
C     IN THE ABOVE, THE WEDGE IS NUMBERED 1,2,3 COUNTERCLOCKWISE AT THE
C     BASE AND 4,5,6 COUNTER CLOCKWISE AT THE TOP. (LOOKING DOWN ON WED)
C
      R12(1) = ECPT(26) - ECPT(22)
      R12(2) = ECPT(27) - ECPT(23)
      R12(3) = ECPT(28) - ECPT(24)
      R13(1) = ECPT(30) - ECPT(22)
      R13(2) = ECPT(31) - ECPT(23)
      R13(3) = ECPT(32) - ECPT(24)
      CALL SAXB (R12,R13,R)
C
      IF (SADOTB(R,RXR)) 1800,1800,1950
C
C     ERROR CONDITION - BAD GEOMETRY
C
 1800 WRITE  (OUT,1900) UFM,NECPT(1)
 1900 FORMAT (A23,' 4001, ELEMENT',I10,' HAS BAD GEOMETRY.')
      NOGOO = 1
      RETURN
C
C     PLANER CHECKS FOR WEDGE
C
 1950 CALL KPLTST (ECPT(10),ECPT(14),ECPT(26),ECPT(22))
      CALL KPLTST (ECPT(10),ECPT(22),ECPT(30),ECPT(18))
      CALL KPLTST (ECPT(14),ECPT(18),ECPT(30),ECPT(26))
 1951 IF (NOGOO .EQ. 1) RETURN
      GO TO 6000
C
C     COME HERE FOR 5-TETRAHEDRON 6-SIDED SOLID
C
 2000 ITET   = 13
      NTET   = 17
      ITEMP  = 43
      NGRIDS = 8
      IOPT   = 0
      GO TO 3500
C
C     COME HERE FOR 10-TETRAHEDRON 6-SIDED SOLID
C
 3000 ITET   = 13
      NTET   = 22
      ITEMP  = 43
      NGRIDS = 8
      IOPT   = 1
C
C     CHECK GEOMETRY OF 6-SIDED SOLID AT THIS POINT
C
 3500 IF (NECPT(1) .EQ. IDELEM) GO TO 2951
      IDELEM = NECPT(1)
      IGFLAG = 1
      R13(1) = ECPT(20) - ECPT(12)
      R13(2) = ECPT(21) - ECPT(13)
      R13(3) = ECPT(22) - ECPT(14)
      R24(1) = ECPT(24) - ECPT(16)
      R24(2) = ECPT(25) - ECPT(17)
      R24(3) = ECPT(26) - ECPT(18)
      CALL SAXB (R13,R24,RXR)
C
      R12(1) = ECPT(36) - ECPT(28)
      R12(2) = ECPT(37) - ECPT(29)
      R12(3) = ECPT(38) - ECPT(30)
      R13(1) = ECPT(40) - ECPT(32)
      R13(2) = ECPT(41) - ECPT(33)
      R13(3) = ECPT(42) - ECPT(34)
      CALL SAXB (R12,R13,R)
C
      IF (SADOTB(RXR,R)) 1800,1800,2950
C
C     PLANER CHECKS FOR HEXA-5 OR HEXA-10
C
 2950 CALL KPLTST (ECPT(12),ECPT(16),ECPT(20),ECPT(24))
      CALL KPLTST (ECPT(12),ECPT(16),ECPT(32),ECPT(28))
      CALL KPLTST (ECPT(16),ECPT(20),ECPT(36),ECPT(32))
      CALL KPLTST (ECPT(20),ECPT(24),ECPT(40),ECPT(36))
      CALL KPLTST (ECPT(24),ECPT(12),ECPT(28),ECPT(40))
      CALL KPLTST (ECPT(28),ECPT(32),ECPT(36),ECPT(40))
 2951 IF (NOGOO .EQ. 1) RETURN
      GO TO 6000
C
C     AT THIS POINT ALL CHECKS HAVE BEEN MADE. NOW FORM THE ECPT FOR
C     EACH TETRAHEDRON AND CALL KTETRA(IOPT). IOPT = 1 IMPLIES TO COMPUT
C     HALF STIFFNESS. IOPT = 0 IMPLIES COMPUTE FULL STIFFNESS.
C
 6000 DO 6010 J = 1,50
      ECPT(J+50) = ECPT(J)
 6010 CONTINUE
C
C     FILL MAT ID AND EL TEMP
C
      NECPT( 2) = NECPT(52)
      NECPT(23) = NECPT(ITEMP+50)
      JTYPE     = ITYPE
      DO 8000 I = ITET,NTET
      IF (I .EQ. NTET) JTYPE = -ITYPE
      IF (ITYPE .EQ. 1) IOPT = I + 10
C
C     FILL IN GRID SIL-S AND COORDINATE SETS
C
      DO 7030 J = 1,4
      KPOINT = M(I,J)
      NECPT(J+2) = NECPT(KPOINT+52)
      KPOINT = 4*KPOINT + NGRIDS - 3
      JPOINT = 4*J + 2
      NECPT(JPOINT+1) = NECPT(KPOINT+52)
      NECPT(JPOINT+2) = NECPT(KPOINT+53)
      NECPT(JPOINT+3) = NECPT(KPOINT+54)
      NECPT(JPOINT+4) = NECPT(KPOINT+55)
 7030 CONTINUE
C
C     BUMP IOPT IF GEOMETRY TESTS ARE TO BE MADE
C
      IF (IGFLAG .EQ. 1) IOPT = IOPT + 100
      CALL KTETRA (IOPT,JTYPE)
 8000 CONTINUE
C
C     ALL THROUGH
C
      RETURN
      END

        SUBROUTINE DSRDNB
      INCLUDE 'DSIOF.COM'
      INCLUDE 'XNSTRN.COM'
        CALL DBMMGR( 5 )
        NBLOCK = FCB( 4, IFILEX )
        INDCLR = INDBAS + 5
        INDCBP = INDCLR
        LCW    = IBASE( INDBAS+4 )
        IBLK   = IBASE( INDBAS+3 )
        IF ( IBLK .EQ. NBLOCK ) GO TO 10
        CALL DSMSG ( 102 )
10      RETURN
        END

      SUBROUTINE MRED2I (KODE,NUF,N2)
C
C     THIS SUBROUTINE COMPUTES THE GS MATRIX FOR THE MRED2 MODULE.
C
      INTEGER          DRY,GBUF1,OTFILE,Z,TYPIN,TYPOUT,TYPINU,
     1                 QSMROW,QSMCOL,GS,QSM,DBLKOR,SGLKOR,QSMTYP
      DOUBLE PRECISION DZ
      DIMENSION        MODNAM(2),ITRLR1(7),RZ(1),DZ(1)
      CHARACTER        UFM*23
      COMMON /XMSSG /  UFM
      COMMON /BLANK /  IDUM1,DRY,IDUM2,GBUF1,IDUM3(5),INFILE(12),
     1                 OTFILE(6),ISCR(10),KORLEN,KORBGN,IDUM6(14),
     2                 NMODES,MODLEN
      COMMON /ZZZZZZ/  Z(1)
      COMMON /SYSTEM/  IDUM4,IPRNTR
      COMMON /CONDAS/  IDUM5(4),FORPI2
      COMMON /PACKX /  TYPIN,TYPOUT,IROW,NROW,INCR
      COMMON /UNPAKX/  TYPINU,IROWU,NROWU,INCRU
      EQUIVALENCE      (LAMAMR,INFILE(2)),(QSM,INFILE(12)),
     1                 (GS,ISCR(7)),(RZ(1),Z(1)),(DZ(1),Z(1))
      DATA    MODNAM/  4HMRED,4H2I  /, IDIAG / 3 /
C
C     TEST OPERATION MODE
C
      IF (DRY .EQ. -2) RETURN
C
C     FORM GS MATRIX
C
C                 **     **
C                 *       *        T
C        **  **   * .   0 * **   **
C        *    *   *  .    * *     *                 2
C        * GS * =-*  1/K  * * QSM *    WHERE K = M W
C        *    *   *    .  * *     *               I I
C        **  **   * 0   . * **   **
C                 *       *
C                 **     **
C
      ITRLR1(1) = QSM
      CALL RDTRL (ITRLR1)
      IF (ITRLR1(1) .LT. 0) GO TO 100
      QSMROW = ITRLR1(2)
      QSMCOL = ITRLR1(3)
C
C                        2
C     FORM K = 1.0 / (M W )
C                      I I
C
      IF (KORBGN+7+QSMROW .GE. KORLEN) GO TO 80
      IFILE = LAMAMR
      CALL GOPEN (LAMAMR,Z(GBUF1),0)
      CALL FWDREC (*70,LAMAMR)
      NMODES = 0
   10 CALL READ (*60,*15,LAMAMR,Z(KORBGN),7,0,NWDSRD)
      RZ(KORBGN+7+NMODES) = 1.0/(FORPI2*RZ(KORBGN+5)*(RZ(KORBGN+4)**2))
      NMODES = NMODES + 1
      IF (KORBGN+7+NMODES .GE. KORLEN) GO TO 80
      GO TO 10
   15 CALL CLOSE (LAMAMR,1)
      IF (NMODES .NE. QSMROW) GO TO 110
      MODLEN = NMODES
C
C     READ QSM INTO CORE
C
      KORE   = KORBGN
      KORBGN = KORBGN + 7 + ITRLR1(2)
      IF (KORBGN+QSMROW*(QSMCOL+1) .GE. KORLEN) GO TO 80
      TYPINU = ITRLR1(5)
      IROWU  = 1
      NROWU  = ITRLR1(3)
      INCRU  = 1
      QSMTYP = ITRLR1(5)
      DBLKOR = KORBGN/2 + 1
      SGLKOR = 2*DBLKOR - 1
      CALL GOPEN (QSM,Z(GBUF1),0)
      IF (QSMTYP .EQ. 2) GO TO 26
      LOCQSM = SGLKOR
      DO 25 I = 1,QSMROW
      CALL UNPACK (*20,QSM,RZ(SGLKOR))
      GO TO 25
   20 DO 22 J = 1,QSMCOL
   22 RZ(SGLKOR+J-1) = 0.0E0
   25 SGLKOR = SGLKOR + ITRLR1(3)
      KORBGN = SGLKOR
      GO TO 30
   26 LOCQSM = DBLKOR
      DO 29 I = 1,QSMROW
      CALL UNPACK (*27,QSM,DZ(DBLKOR))
      GO TO 29
   27 DO 28 J = 1,QSMCOL
   28 DZ(DBLKOR+J-1) = 0.0D0
   29 DBLKOR = DBLKOR + ITRLR1(3)
      KORBGN = DBLKOR
   30 CALL CLOSE (QSM,1)
C
C     FORM GS MATRIX
C
      TYPIN  = ITRLR1(5)
      TYPOUT = ITRLR1(5)
      IROW   = 1
      NROW   = QSMROW
      INCR   = 1
      CALL MAKMCB (ITRLR1,GS,QSMROW,IDIAG,TYPIN)
      DBLKOR = KORBGN/2 + 1
      SGLKOR = 2*DBLKOR - 1
      CALL GOPEN (GS,Z(GBUF1),1)
      DO 35 I = 1,QSMCOL
      DO 34 J = 1,QSMROW
      K = 3*(J-1)
      IF (QSMTYP .EQ. 2) GO TO 32
      RZ(SGLKOR+J-1) = RZ(KORE+7+J-1)*RZ(LOCQSM+K)
      GO TO 34
   32 CONTINUE
      DZ(DBLKOR+J-1) = RZ(KORE+7+J-1)*DZ(LOCQSM+K)
   34 CONTINUE
   35 CALL PACK (DZ(DBLKOR),GS,ITRLR1)
      KORBGN = KORE
      CALL CLOSE (GS,1)
      CALL WRTTRL (ITRLR1)
      RETURN
C
C     PROCESS SYSTEM FATAL ERRORS
C
   60 IMSG = -2
      GO TO 90
   70 IMSG = -3
      GO TO 90
   80 IMSG = -8
      IFILE = 0
   90 CALL SOFCLS
      CALL MESAGE (IMSG,IFILE,MODNAM)
      RETURN
C
C     PROCESS MODULE FATAL ERRORS
C
  100 WRITE (IPRNTR,900) UFM
      GO TO 120
  110 WRITE (IPRNTR,901) UFM,QSMROW,QSMCOL,NMODES
  120 DRY = -2
      RETURN
C
  900 FORMAT (A23,' 6638, IN MODULE MREDUCE WITH USERMODE=2, THE ',
     1       'CONSTRAINT FORCES MATRIX (QSM) CANNOT BE PURGED.')
  901 FORMAT (A23,' 6634, IN MODULE MREDUCE WITH USERMODE=2, THE ',
     1       'CONSTRAINT FORCES MATRIX (',I3,3H X ,I3,1H), /30X,
     2       'IS INCOMPATABLE WITH THE NUMBER OF MODES (',I3,2H).)
C
      END

      SUBROUTINE MTRPLT
C
COMMENT.  ALL WRITE STATEMENTS WHICH HAVE BEEN COMMENTED OUT, HAVE BEEN
C         LEFT IN THE PROGRAMMING FOR ANY FUTURE DEBUGGING USE.
C
C
C     THIS ROUTINE GENERATES THE FOLLOWING
C
C                             3-6X6 STIFFNESS MATRICES WITH RESPECT
C                             TO ONE PIVOT POINT OF A TRIANGULAR PLATE
C                             ELEMENT.
C
C         REF. FMMS-66  JUNE 23, 1969
C
C         CALLS FROM THIS ROUTINE ARE MADE TO
C                             MTRBSC - BASIC BENDING TRI. ROUTINE.
C                             TRANSD - SUPPLIES 3X3 TRANSFORMATIONS
C                             INVERD - MATRIX INVERSION ROUTINE
C                             SMA2B  - INSERTION ROUTINE
C                             GMMATD - GENERAL MATRIX MULITPLY AND
C                                      TRANSPOSE ROUTINE
C                             MESAGE - ERROR MESSAGE WRITER
C
C
      INTEGER            SUBSCA        ,SUBSCB        ,SUBSCC
      DOUBLE PRECISION
     1                   R(2,4)        ,D1(3)         ,HABC(18)
     2                  ,TEMP          ,D2(3)         ,HINV
     3                  ,MSUM(63)      ,IVECT         ,G(36)
     4                  ,V             ,JVECT         ,E
     5                  ,VV            ,KVECT         ,TITE(9)
     6                  ,XSUBB         ,TEMP9         ,TJTE(36)
     7                  ,XSUBC         ,PROD9         ,ARR9
     8                  ,YSUBC         ,U1            ,ARRAY9
     9                  ,T             ,U2            ,TEMP36(36)
     T                  ,A             ,TEMP1         ,PROD12(12)
     1                  ,C1            ,TEMP2         ,HQ(12)
     2                  ,C2            ,L1            ,Y1
     3                  ,X1            ,L2            ,Y2
     4                  ,X2            ,S1            ,DETERM
     5                  ,S2            ,MOUT(36)      ,S ,REQUIV(8)
     6                  ,EM3           ,M6X6
C
C     ******************************************************************
C
C     ECPT LISTS AS OF AUGUST 4, 1967
C
C                 DEFINITION
C       ECPT      TRI.PLATE AND BASIC BENDING TRI.
C     ******************************************************************
C     ECPT( 1) = ELEMENT ID         INTEGER
C     ECPT( 2) = GRID PT. A         INTEGER
C     ECPT( 3) = GRID PT. B         INTEGER
C     ECPT( 4) = GRID PT. C         INTEGER
C     ECPT( 5) = THETA              REAL
C     ECPT( 6) = MAT ID 1           INTEGER
C     ECPT( 7) = I  MOM. OF INERT.  REAL
C     ECPT( 8) = MAT ID 2           INTEGER
C     ECPT( 9) = T2                 REAL
C     ECPT(10) = NON-STRUCT. MASS   REAL
C     ECPT(11) = Z1                 REAL
C     ECPT(12) = Z2                 REAL
C     ECPT(13) = COORD. SYS. ID 1   INTEGER
C     ECPT(14) = X1                 REAL
C     ECPT(15) = Y1                 REAL
C     ECPT(16) = Z1                 REAL
C     ECPT(17) = COORD. SYS. ID 2   INTEGER
C     ECPT(18) = X2                 REAL
C     ECPT(19) = Y2                 REAL
C     ECPT(20) = Z2                 REAL
C     ECPT(21) = COORD. SYS. ID 3   INTEGER
C     ECPT(22) = X3                 REAL
C     ECPT(23) = Y3                 REAL
C     ECPT(24) = Z3                 REAL
C     ECPT(25) = ELEMENT TEMP       REAL
C     ******************************************************************
      DIMENSION
     1                   NECPT(100)    ,M(9)          ,V1(3)
     2                  ,V2(3)         ,V3(3)
C
      COMMON /CONDAS/ CONSTS(5)
      COMMON /MATIN / MATID,INFLAG,ELTEMP,STRESS,SINTH,COSTH
      COMMON /MATOUT/G11,G12,G13,G22,G23,G33,RHO,ALPHA1,ALPHA2,ALP12,
     1                T SUB 0, G SUB E, SIGTEN, SIGCOM, SIGSHE,
     2                G2X211, G2X212, G2X222, SPACE(2)
      COMMON /SMA2IO/ DUM1(10),IFMGG,DUM2(25)
      COMMON /SMA2CL/ DUM3(2), NPVT
     2,                  DUMCL(7)
     3,                  LINK(10)           ,NOGO
      COMMON /SMA2ET/ ECPT(100)
      COMMON /SMA2DP/
     1                   A(81)         ,S(18)         ,HINV(36)
     2                  ,TEMP9(9)      ,PROD9(9)      ,ARR9(9)
     3                  ,ARRAY9(9)     ,T(9)          ,M6X6(36),DUMX(54)
     4                  ,XSUBB         ,XSUBC         ,YSUBC
     5                  ,E(9)          ,TEMP          ,L1
     6                  ,L2            ,S1            ,S2
     7                  ,C1            ,C2            ,X1
     8                  ,X2            ,Y1            ,Y2
     9                  ,TEMP1         ,TEMP2         ,DUMTWO(20),DETERM
     T                  ,NPOINT        ,KM            ,SUBSCA
     1                  ,SUBSCB        ,SUBSCC        ,NPIVOT
     2                  ,THETA         ,NSUBC         ,ISING
     3                  ,NPT1          ,V(2)          ,VV(2)
     4                  ,IVECT(3)      ,JVECT(3)      ,KVECT(3)
     5                  ,U1            ,U2            ,SINANG
     6                  ,COSANG
C
      EQUIVALENCE ( CONSTS(4) , DEGRA  )
      EQUIVALENCE
     1                                 (NECPT(1),ECPT(1))
     2                                 ,(PROD12(1),A(13))
     3                                 ,(HABC(1),A(25))
     4                                 ,(TITE(1),A(37))
     5                                 ,(TJTE(1),A(46))
     6                                 ,(MOUT(1),A(1))
     7                                 ,(TEMP36(1),HINV(1))
     8                                 ,(V1(1),ECPT(14))
     9                                 ,(V2(1),ECPT(18))
     T                                 ,(V3(1),ECPT(22))
     1                                 ,(REQUIV(1),R(1,1))
     2                                 ,(D1(1),A(1))
     3                                 ,(D2(1),A(4))
     4                                 ,(HQ(1),A(1))
C
      DATA M/ 1,2,4,   2,3,4,   3,1,4 /
C
      ELTEMP = ECPT(25)
C     DETERMINE PIVOT POINT NUMBER
C
      DO 10 I=1,3
      IF( NPVT .NE. NECPT(I+1) ) GO TO 10
      NPIVOT = I
      GO TO 20
   10 CONTINUE
C
C
C     FALL THRU ABOVE LOOP IMPLIES ERROR CONDITION
      CALL MESAGE(-30,34,ECPT(1))
C
   20 THETA = ECPT(5) * DEGRA
      SINANG = SIN( THETA )
      COSANG = COS( THETA )
C     FORMATION OF THE R-MATRIX CONTAINING COORDINATES OF THE
C     SUB TRIANGLES. (2X4) FOR TRIANGULAR PLATE. (COLUMN 4 BLANK)
C     FORMATION ALSO OF THE I,J, AND K VECTORS USED IN THE E-MATRIX.
C
C     ZERO OUT R-MATRIX
      DO 30 I=1,8
   30 REQUIV(I)=0.0D0
C
      DO 40 I=1,3
      D2(I) = DBLE( V2(I) ) - DBLE( V1(I) )
   40 D1(I) = DBLE( V3(I) ) - DBLE( V1(I) )
C
C     X2  GOES IN R(1,2)
      R(1,2) = DSQRT ( D2(1)**2  +  D2(2)**2  +  D2(3)**2 )
      IF (R(1,2).EQ.0.0D0) GO TO 400
      DO 50 I=1,3
   50 IVECT(I) = D2(I) / R(1,2)
C
C     NON-NORMALIZED K-VECTOR
      KVECT(1) = IVECT(2) * D1(3)    -    D1(2) * IVECT(3)
      KVECT(2) = IVECT(3) * D1(1)    -    D1(3) * IVECT(1)
      KVECT(3) = IVECT(1) * D1(2)    -    D1(1) * IVECT(2)
C
C     Y3 GOES INTO R(2,3)
      R(2,3) = DSQRT ( KVECT(1)**2 + KVECT(2)**2 + KVECT(3)**2 )
      IF (R(2,3).EQ.0.0D0) GO TO 400
      DO 60 I=1,3
   60 KVECT(I) = KVECT(I) / R(2,3)
C
C     J-VECTOR = K X I  VECTORS
      JVECT(1) = KVECT(2) * IVECT(3) - IVECT(2) * KVECT(3)
      JVECT(2) = KVECT(3) * IVECT(1) - IVECT(3) * KVECT(1)
      JVECT(3) = KVECT(1) * IVECT(2) - IVECT(1) * KVECT(2)
C     NORMALIZE J VECTOR TO MAKE SURE
      TEMP = DSQRT ( JVECT(1)**2 + JVECT(2)**2 + JVECT(3)**2 )
      IF (TEMP.EQ.0.0D0) GO TO 400
      DO 70 I=1,3
   70 JVECT(I) = JVECT(I) / TEMP
C     X3 GOES INTO R(1,3) = D1 DOT IVECT
      R(1,3) = D1(1) * IVECT(1)  +  D1(2) * IVECT(2) + D1(3) * IVECT(3)
C
C     CENTROID POINT GOES INTO R(1,4) AND R(2,4)
      R(1,4) = (  R(1,2) + R(1,3)  ) / 3.0D0
      R(2,4) = R(2,3) / 3.0D0
C
C
C     ******************************************************************
C            THE COORDINATES AND CENTROID OF THE PLATE IN THE ELEMENT
C     SYSTEM ARE STORED IN THE R-MATRIX WHERE THE COLUMN DENOTES THE
C     POINT AND THE ROW DENOTES THE X OR Y COORDINATE FOR ROW 1 OR
C     ROW 2 RESPECTIVELY.
C     ******************************************************************
C
C     SET UP THE M-MATRIX FOR MAPPING TRIANGLES, IN DATA STATEMENT.
C
C     ******************************************************************
C
COMMENCE CALCULATIONS FOR ALL THREE SUBTRIANGLES
C  INITIALIZE TO ZERO..
C          MSUM MATRIX 7 (3X3) = 63 LONG,
C          G    MATRIX 4 (3X3) = 36 LONG.
C
      DO 80 I=1,63
   80 MSUM(I) = 0.0D0
      DO 90 I=1,36
   90 G(I) = 0.0D0
C
CHOOSE APPROPRIATE COORDINATE POINTS FOR EACH SUBTRIANGLE J = 1,2,3
C
      DO 210 J=1,3
      KM = 3*J - 3
C
      SUBSCA = M(KM+1)
      SUBSCB = M(KM+2)
      SUBSCC = M(KM+3)
C
      DO 100 I=1,2
      V(I) = R(I,SUBSCB) - R(I,SUBSCA)
  100 VV(I)= R(I,SUBSCC) - R(I,SUBSCA)
      XSUBB = DSQRT ( V(1)**2 + V(2)**2 )
      U1 = V(1) / XSUBB
      U2 = V(2) / XSUBB
      XSUBC = U1 * VV(1) + U2 * VV(2)
      YSUBC = U1 * VV(2) - U2 * VV(1)
C
      SINTH = SINANG * U1  -  COSANG * U2
      COSTH = COSANG * U1  +  SINANG * U2
      IF(ABS(SINTH) .LT. 1.0E-06) SINTH = 0.0E0
C
C
C     AT THIS POINT, XSUBB, XSUBC, YSUBC ARE AT HAND FOR
C     TRIANGLE -J-
C
      CALL MTRBSC
C                         U
C     NOW HAVE AT HAND  M    I,J, =1,2,3.   9-3X3 MATRICES STORED AT
C                        IJ                 A(1) THROUGH A(81).
C
C           -1
C     ALSO H   (6X6) AT A(100) TO A(135) AND S (6X3) AT A(82) TO A(99)
C
C
C NOTE..SUB-MATRICES FOR THE PIVOT POINT AND THE CENTROID POINT
C          ARE TRANSFORMED TO ELEMENT COORDINATES AND SUMMED WITH
C          THEIR CORRESPONDING SUB-MATRIX OF THE TRIANGULAR PLATE
C
C                                     ***           ***
C                   ***               * MSUM(28...36) *
C  M     I = 1,2,3    * ARE STORED IN * MSUM(37...45) *
C   I3   3 = CENTROID *               * MSUM(46...54) *
C                   ***               * MSUM(54...63) *
C                                     ***           ***
C             WHERE I DENOTES A POINT ON THE SUB-TRIANGLE, AND
C                     REFERENCES GRID POINTS 1, 2, OR 3
C                     ON THE TRIANGULAR PLATE
C
C                                     ***           ***
C                   ***               * MSUM( 1... 9) *
C  M     I = PIVOT PT * ARE STORED IN * MSUM(10...18) *
C   IJ   J = 1,2      *               * MSUM(19...27) *
C                   ***               ***           ***
C             WHERE I DENOTES A POINT ON THE SUB-TRIANGLE AND
C                     REFERENCES POINTS 1, 2, 3, OR 4
C                     ON THE TRIANGULAR PLATE
C
C
C
C     SET UP OF T-MATRIX
C
      T(1) = 1.0D0
      T(2) = 0.0D0
      T(3) = 0.0D0
      T(4) = 0.0D0
      T(5) = U1
      T(6) = U2
      T(7) = 0.0D0
      T(8) =-U2
      T(9) = U1
C
C
      DO 120 I=1,3
      CALL GMMATD( T(1),3,3,1,  A(27*I-8),3,3,0,  TEMP9(1) )
      CALL GMMATD( TEMP9(1),3,3,0,  T(1),3,3,0,  PROD9(1) )
C
C     ADD THIS PRODUCT IN NOW.
C     COMPUTE POINTER TO MSUM MATRIX DESIRED.  (ZERO POINTER)
      NPOINT = KM + I
      NPOINT = 9*M(NPOINT) + 18
C
      DO 110 K=1,9
      NSUBC  = NPOINT + K
  110 MSUM(NSUBC) = MSUM(NSUBC) + PROD9(K)
  120 CONTINUE
C
C
      DO 150 K=1,2
      NPOINT = KM + K
      IF( M(NPOINT) .NE. NPIVOT ) GO TO 150
      CALL GMMATD( T(1),3,3,1,  A(36*K-35),3,3,0,  TEMP9(1) )
      CALL GMMATD( TEMP9(1),3,3,0,  T(1),3,3,0,  PROD9(1) )
C
C     COMPUTE POINTER TO MSUM MATRIX (ZERO POINTER)
C
      NPOINT = 9 * NPIVOT - 9
      DO 130 I=1,9
      NSUBC = NPOINT + I
  130 MSUM(NSUBC) = MSUM(NSUBC) + PROD9(I)
C
      CALL GMMATD(T(1),3,3,1,  A(18*K-8),3,3,0,  TEMP9(1) )
      CALL GMMATD( TEMP9(1),3,3,0,  T(1),3,3,0,  PROD9(1) )
C
C     COMPUTE ZERO POINTER TO MSUM MATRIX DESIRED
C
      NPOINT = KM + 3 - K
      NPOINT = 9 * M(NPOINT) - 9
      DO 140 I=1,9
      NSUBC = NPOINT + I
  140 MSUM(NSUBC) = MSUM(NSUBC) +  PROD9(I)
  150 CONTINUE
C
C
C NOTE..THE CENTROID POINT IS A DUMMY POINT SO IT MUST BE REMOVED.
C          THIS IS DONE BY TRANSFERRING THE DISPLACEMENTS IN THE
C          MIDDLE TO BE A DIRECT FUNCTION OF THE OTHER DISPLACEMENTS.
C       THE TRANSFERENCE IS DONE THROUGH THE CREATION OF 3 (2X3)
C          HABC MATRICES, EACH CORRESPONDING TO A POINT OF THE
C          SUB-TRIANGLE.  EACH HABC MATRIX IS SUMMED WITH ITS
C          CORRESPONDENT IN THE G MATRIX 4 (3X3) ONE FOR EACH GRID POINT
C                                                AND THE CENTROID  POINT
C
C
C     FORM HQ (2X6)
C
      TEMP1 = XSUBB - XSUBC
      TEMP2 = YSUBC ** 2
      L1 = DSQRT( XSUBC**2 + TEMP2 )
      L2 = DSQRT( TEMP1**2 + TEMP2 )
      S1 = XSUBC / L1
      S2 = TEMP1 / L2
      C1 = YSUBC / L1
      C2 = YSUBC / L2
      X1 = XSUBC / 2.0D0
      Y1 = YSUBC / 2.0D0
      X2 = (XSUBB + XSUBC) / 2.0D0
      Y2 = Y1
      HQ( 1) = -XSUBC * C1
      HQ( 2) = X1 * S1 - Y1 * C1
      HQ( 3) = YSUBC * S1
      HQ( 4) = -3.0D0 * X1 * X1 * C1
      HQ( 5) = Y1 * (XSUBC * S1 - Y1 * C1 )
      HQ( 6) = 3.0D0 * Y1 * Y1 * S1
      HQ( 7) = 2.0D0 * X2 * C2
      HQ( 8) = X2 * S2  + Y2 * C2
      HQ( 9) = YSUBC * S2
      HQ(10) = 3.0D0 * X2 * X2 * C2
      HQ(11) = Y2 * ( 2.0D0 * X2 * S2 + Y2 * C2 )
      HQ(12) = 3.0D0 * Y2 * Y2 * S2
C
C
C
C                      I                    -1
C     COMPUTE (H       I  H     )  = (HQ)(H)    STORE IN PROD12
C               PSI,B  I   PSI,C
C                      I
C
C
      CALL GMMATD( HQ(1),2,6,0, HINV(1),6,6,0,  PROD12(1) )
C
C
C     COMPUTE (H     ) = -(PROD12)(S)
C               PSI,A
C
      CALL GMMATD( PROD12(1),2,6,0, S(1),6,3,0,  HABC(1) )
C
      HABC(1) = -HABC(1)
      HABC(2) = -HABC(2) + S1
      HABC(3) = -HABC(3) + C1
      HABC(4) = -HABC(4)
      HABC(5) = -HABC(5) + S2
      HABC(6) = -HABC(6) - C2
C
C     SPLIT (H     ) AND (H     )    PARTITION
C             PSI,B        PSI,C
C
      HABC( 7) = PROD12( 1)
      HABC( 8) = PROD12( 2)
      HABC( 9) = PROD12( 3)
      HABC(10) = PROD12( 7)
      HABC(11) = PROD12( 8)
      HABC(12) = PROD12( 9)
      HABC(13) = PROD12( 4)
      HABC(14) = PROD12( 5)
      HABC(15) = PROD12( 6)
      HABC(16) = PROD12(10)
      HABC(17) = PROD12(11)
      HABC(18) = PROD12(12)
C
C
C     MAP  H , H , AND H  INTO THE G-MATRICES.
C           A   B       C
C
C     TRIANGLE NUMBER = J, THE THREE POINTS ARE SUBSCA, SUBSCB, SUBSCC.
C
      DO 200 I=1,3
C
C     POINTER TO H  = 6*I-6
C                 I
C
C
C     TRANSFORM H SUB I
C
      CALL GMMATD( HABC(6*I-5),2,3,0,  T(1),3,3,0,  TEMP9(1) )
C
C
      NPOINT = KM + I
      NPOINT = 9*M(NPOINT) - 9
C
C     J = 1    ROW 1 OF H INTO ROW 1 OF G.
C              ROW 2 OF H INTO ROW 2 OF G.
C     J = 2    ROW 1 OF H INTO ROW 2 OF G.
C              ROW 2 OF H INTO ROW 3 OF G.
C     J = 3    ROW 1 OF H INTO ROW 3 OF G.
C              ROW 2 OF H INTO ROW 1 OF G.
C
      IF( J-2 ) 170,160,190
C
  160 NPOINT = NPOINT + 3
  170 DO 180 K=1,6
      NPOINT = NPOINT + 1
  180 G(NPOINT) = G(NPOINT) + TEMP9(K)
      GO TO 200
  190 G(NPOINT + 7) = G(NPOINT + 7) + TEMP9(1)
      G(NPOINT + 8) = G(NPOINT + 8) + TEMP9(2)
      G(NPOINT + 9) = G(NPOINT + 9) + TEMP9(3)
      G(NPOINT + 1) = G(NPOINT + 1) + TEMP9(4)
      G(NPOINT + 2) = G(NPOINT + 2) + TEMP9(5)
      G(NPOINT + 3) = G(NPOINT + 3) + TEMP9(6)
C
  200 CONTINUE
C
C
C     END OF LOOP FOR BASIC TRIANGLES
C
C
  210 CONTINUE
C
C     ******************************************************************
C
CALCULATE MASS MATRIX PARTITIONS FOR WHOLE PLATE , ACCOUNTING FOR
C DISPLACEMENT OF CENTER.  EXPAND PARTITIONS TO (6X6) AND
C TRANSFORM TO GLOBAL COORDINATES
C
C
C
      DO 215 I = 1,36
  215 TJTE(I) = 0.0D0
      EM3 = DBLE(ECPT(10)) / 6.0D0 * R(1,2) * R(2,3)
C
C     FILL E-MATRIX
C
      DO 220 I=1,9
  220 E(I) = 0.0D0
      DO 225 I = 1,3
        NPOINT = 3 * I - 2
        E(NPOINT    ) = IVECT(I)
        E(NPOINT + 1) = JVECT(I)
  225   E(NPOINT + 2) = KVECT(I)
C
C
C              T
C     FORM   T   E      STORE IN TITE-MATRIX (6X3)
C             I
C
      IF( NECPT(4*NPIVOT+9) .EQ. 0 ) GO TO 230
      CALL TRANSD( NECPT(4*NPIVOT+9), T(1) )
      CALL GMMATD( T(1),3,3,1,  E( 1),3,3,0,  TITE( 1) )
C
      GO TO 250
C
  230 DO 240 K=1,9
  240 TITE(K) = E(K)
C
C
C     SOLVE NOW FOR ....
C
C    E                   T     T                       T
C (M  ) = (M  ) - (TERM ) (M  ) - (M  )(TERM ) + (TERM )(M  )(TERM )
C   IJ      IJ         I    J4      I4      J         I   44      J
C
C                        -1                               I=NPIVOT
C WHERE... (TERM ) = (G )  (G ) ,I=NPIVOT                 J=1,2,3
C               I      4     I
C
C                        -1
C          (TERM ) = (G )  (G ) ,J=1,2,3 AS ABOVE
C               J      4     J
C
C     AND WITH TRANSFORMATIONS....
C
C    G        T      E   T
C (M  ) = (C ) (E)(M  )(E )(C )
C   IJ      I       IJ       J
C
C
C     COMPUTE  (TERM        )  STORE IN PROD9
C                   I=NPIVOT
C
C                   -1
C     FIRST GET (G )
C                 4
C
  250 CONTINUE
C     NO NEED TO COMPUTE DETERMINANT SINCE IT IS NOT USES SUBSEQUENTLY.
      ISING = -1
      CALL INVERD( 3,G(28),3,PROD9,0,DETERM,ISING,TEMP9 )
C
C     CHECK FOR SINGULARITY. ISING=2 IMPLIES SINGULARITY.
      GO TO(270,260),ISING
  260 CALL MESAGE(30,36,ECPT(1))
C
C  SET FLAG FOR FATAL ERROR WHILE ALLOWING ERROR MESSAGES TO ACCUMULATE
C
      NOGO=1
      RETURN
C
  270 CALL GMMATD ( G(28),3,3,0,  G(9*NPIVOT-8),3,3,0,  PROD9(1) )
C
C                       T
C     GET  (TERM        )(M  )  STORE IN TEMP9
C               I=NPIVOT   44
C
      CALL GMMATD( PROD9(1),3,3,1,  MSUM(55),3,3,0,  TEMP9(1) )
C
C
C
C     THE TWO COMMON PRODUCTS ARE NOW AT HAND IN PROD9 AND TEMP9.
C
      DO 390 J=1,3
C
C                   T     T
C     (TERM        ) (M  )    STORE IN ARR9
C          I=NPIVOT    J4
C
      CALL GMMATD( PROD9(1),3,3,1,  MSUM(9*J+19),3,3,1,  ARR9(1) )
C
C     SUBTRACT FROM (M  )
C                     IJ
C
      NBEGIN = 9*J-9
      DO 275 I = 1,36
  275 M6X6(I) = 0.0D0
      DO 280 I=1,9
      NPOINT = NBEGIN + I
  280 MSUM(NPOINT) = MSUM(NPOINT) - ARR9(I)
C
C
C      COMPUTE  (TERM )  STORE IN ARR9
C                   J
C
      CALL GMMATD( G(28),3,3,0,  G(9*J-8),3,3,0,  ARR9(1) )
C
C
C     GET  (M  )(TERM )  STORE IN ARRAY9
C            I4      J
C
      CALL GMMATD( MSUM(9*NPIVOT+19),3,3,0,  ARR9(1),3,3,0,  ARRAY9(1))
C
C     SUBTRACT FROM MIJ
C
      DO 290 I=1,9
      NPOINT = NBEGIN + I
  290 MSUM(NPOINT) = MSUM(NPOINT) - ARRAY9(I)
C
C                           T
C     COMPUTE  (TERM        )(M  )(TERM ) = (TEMP9)(ARR9)
C                   I=NPOINT   44      J
C
      CALL GMMATD( TEMP9(1),3,3,0,  ARR9(1),3,3,0,  ARRAY9(1) )
C
C     ADD TO M
C             IJ
C
      DO 300 I=1,9
      NPOINT = NBEGIN + I
  300 MSUM(NPOINT) = MSUM(NPOINT) + ARRAY9(I)
C
C
C       E
C     M    COMPLETE
C      IJ
C
C     TRANSFORM NOW, AND INSERT.
C
C
C     TRANSFORMATIONS AND INSERTION
C
      IF( NECPT(4*J+9) .EQ. 0) GO TO 330
      CALL TRANSD( NECPT(4*J+9), T(1) )
        CALL GMMATD( E(1),3,3,1,T(1),3,3,0,TJTE(1) )
        DO 310 I = 1,3
        NPOINT = I + 21
        TJTE(NPOINT     ) = TJTE(I)
        TJTE(NPOINT +  6) = TJTE(I + 3)
  310   TJTE(NPOINT + 12) = TJTE(I + 6)
        DO 320 I = 1,3
        NPOINT = I + 21
        TJTE(I     ) = TJTE(NPOINT)
        TJTE(I +  6) = TJTE(NPOINT +  6)
        TJTE(I + 12) = TJTE(NPOINT + 12)
  320   TJTE(I +  3) = 0.0D0
C
        GO TO 350
C
  330 DO 340 I = 1,3
        NPOINT = 6*I - 5
        NPT    = NPOINT + 21
        TJTE(NPOINT    ) = E(I)
        TJTE(NPOINT + 1) = E(I + 3)
        TJTE(NPOINT + 2) = E(I + 6)
        TJTE(NPT       ) = E(I)
        TJTE(NPT    + 1) = E(I + 3)
  340   TJTE(NPT    + 2) = E(I + 6)
C
C
C  EXPAND THE MSUM MATRIX (3X3) TO M6X6 MATRIX (6X6)
  350 IF(NPIVOT .NE. J) GO TO 370
        M6X6(1) = EM3
        M6X6(8) = EM3
  370 DO 380 I = 1,3
        NPOINT = NBEGIN + I
        M6X6(I + 14) = MSUM(NPOINT)
        M6X6(I + 20) = MSUM(NPOINT + 3)
  380   M6X6(I + 26) = MSUM(NPOINT + 6)
C
C
      CALL GMMATD(M6X6(1),6,6,0,TJTE(1),6,6,0,TEMP36(1))
      CALL GMMATD(TITE(1),3,3,0,TEMP36(1) ,3,6,0,MOUT( 1))
      CALL GMMATD(TITE(1),3,3,0,TEMP36(19),3,6,0,MOUT(19))
C
C
      CALL SMA2B(MOUT(1),NECPT(J+1),-1,IFMGG,0.0D0)
C
  390 CONTINUE
      RETURN
C
C
  400 CALL MESAGE(30,26,ECPT(1))
C
C  SET FLAG FOR FATAL ERROR WHILE ALLOWING ERROR MESSAGES TO ACCUMULATE
C
      NOGO=1
      RETURN
      END

      SUBROUTINE FVRS2A (FILE,KK1,KK2,NORO,BUFFER)
C
C     GENERATE COLUMN REORDERING MATRIX. THIS MATRIX WILL REORDER
C     COLUMNS OF A MATRIX BY POST-MULTIPLYING THE MATRIX WHOSE
C     COLUMNS ARE TO BE REORDERED BY THE REORDERING MATRIX.
C
C     THE MATRIX WILL BE A REAL SINGLE-PRECISION SQUARE MATRIX.
C
      INTEGER FILE,ROW,TRL(7),BUFFER(1),TYPIN,TYPOUT
C
      COMMON /PACKX/ TYPIN,TYPOUT,II,NN,INCR
C
      NORO = -1
      IF(KK1.EQ.1 .OR. KK2.EQ.1) RETURN
C
      NORO = 1
C
      TYPIN  = 1
      TYPOUT = 1
      INCR   = 1
C
      TRL(1) = FILE
      TRL(2) = 0
      TRL(3) = KK1*KK2
      TRL(4) = 1
      TRL(5) = TYPOUT
      TRL(6) = 0
      TRL(7) = 0
C
      CALL GOPEN(FILE,BUFFER,1)
C
      VALUE = 1.0
C
      DO 20 K1 = 1,KK1
      ROW = K1
      DO 10 K2 = 1,KK2
C
      II = ROW
      NN = ROW
      CALL PACK(VALUE,FILE,TRL)
C
      ROW = ROW + KK1
C
   10 CONTINUE
   20 CONTINUE
C
      CALL CLOSE(FILE,1)
      CALL WRTTRL(TRL)
C
      RETURN
      END

      SUBROUTINE STEP2 (U2,U1,U0,P,IBUF)
C
C     STEP2 WILL INTEGRATE FORWARD ONE TIME STEP
C
C     THIS ROUTINE IS SUITABLE FOR DOUBLE PRECISION OPERATION
C
      INTEGER          FILE(7) ,SQR     ,RDP     ,DUM     ,IBUF(1)
      DOUBLE PRECISION U2(1)   ,U1(1)   ,U0(1)   ,P(1)
      COMMON /TRDXX /  DUM(21) ,ISCR1   ,ISCR2   ,ISCR3   ,ISCR4   ,
     1                 ISCR5   ,ISCR6   ,IOPEN   ,ISYM
      COMMON /NAMES /  DUMM(8) ,RDP     ,DUMN(2) ,SQR
      COMMON /INFBSX/  IFIL(7) ,IFILU(7)
C
      FILE(1) = ISCR1
      FILE(2) = DUM(2)
      FILE(4) = SQR
C
C     TELL MATVC2/INVFBS FILES ARE OPEN
C
      IOPEN = 1
C
C     FORM R.H.S. OF THE INTEGRATION EQUATION
C
      CALL MATVC2 (U1(1),P(1),FILE,IBUF)
      FILE(1) = ISCR4
      CALL MATVC2 (U0(1),P(1),FILE,IBUF)
C
C     CALL INVFBS/FBSINT TO DO THE FORWARD/BACKWARD PASS
C
      IFIL(1)  = ISCR2
      IFILU(1) = ISCR3
      CALL RDTRL (IFIL)
      CALL RDTRL (IFILU)
      IFIL(5) = RDP
      IFIL(3) = DUM(3)
      IF (ISYM .EQ. 1) IOPEN = - 20
      IF (ISYM .EQ. 1) CALL INVFBS (P(1),U2(1),IBUF)
      IF (ISYM .EQ. 0) CALL FBSINT (P(1),U2(1))
      IOPEN = 0
      RETURN
      END

      SUBROUTINE RCOVE
C
C     THIS SUBROUTINE PRINTS THE ENERGIES ON THE MODAL COORDINATES
C     IN A SUBSTRUCTURE THAT WAS MODAL REDUCED.  IT WILL ALSO PRINT
C     THE ENERGIES ON THOSE MODES EXCLUDED FROM THE REDUCTION
C     PROCESSING.
C
      EXTERNAL        ANDF
      LOGICAL         MREDU      ,CREDU      ,NOEXCL
      INTEGER         DRY        ,FSS        ,RSS        ,UA        ,
     1                RFNO       ,Z(3)       ,RC         ,BUF(1)    ,
     2                FILE       ,SOF1       ,SOF2       ,SOF3      ,
     4                BUF1       ,BUF2       ,BUF3       ,SYSBUF    ,
     5                NAME(2)    ,SCR3       ,SCR4       ,SCR6      ,
     7                SCR7       ,EQSS       ,RSP        ,GRID      ,
     8                SOLN       ,TRIGID(2)  ,TIMODE(2)  ,TEMODE(2) ,
     9                TYPE(2)    ,CASESS     ,CASECC(2)  ,MCB(7)    ,
     O                CMASK      ,ENERGY     ,BUF4       ,BLANK     ,
     A                HIGHER(2)  ,ANDF       ,NAMES(2)
      REAL            KENG       ,PENG
      CHARACTER       UFM*23     ,UWM*25
      COMMON /XMSSG / UFM        ,UWM
      COMMON /BLANK / DRY        ,LOOP       ,STEP       ,FSS(2)    ,
     1                RFNO       ,NEIGV      ,LUI        ,UINMS(2,5),
     2                NOSORT     ,UTHRES     ,PTHRES     ,QTHRES
      COMMON /RCOVCR/ ICORE      ,LCORE      ,BUF1       ,BUF2      ,
     1                BUF3       ,BUF4       ,SOF1       ,SOF2      ,
     2                SOF3
      COMMON /RCOVCM/ MRECVR     ,UA         ,PA         ,QA        ,
     1                IOPT       ,RSS(2)     ,ENERGY     ,UIMPRO    ,
     2                RANGE(2)   ,IREQ       ,LREQ       ,LBASIC
      COMMON /ZZZZZZ/ RZ(1)
      COMMON /SYSTEM/ SYSBUF     ,NOUT       ,DUM1(6)    ,NLPP      ,
     1                DUM2(2)    ,NLINES
      COMMON /UNPAKX/ ITINU      ,IRU        ,NRU        ,INCRU
      COMMON /OUTPUT/ ITITLE(96)
      COMMON /NAMES / RD         ,RDREW      ,WRT        ,WRTREW    ,
     1                REW        ,NOREW      ,EOFNRW     ,RSP       ,
     2                RDP        ,CSP        ,CDP        ,SQUARE    ,
     3                RECT       ,DIAG
      EQUIVALENCE     (BUF(1)    ,RZ(1))
      EQUIVALENCE     (RZ(1)     ,Z(1))
      DATA    CASECC/ 4HCASE,4HCC   /
      DATA    EQSS  , LAMS, SOLN    / 4HEQSS,4HLAMS,4HSOLN /
      DATA    CASESS, SCR3, SCR4, SCR6, SCR7           /
     1        101   , 303,  304,  306,  307            /
      DATA    TRIGID/ 4HINER,4HTIAL /
      DATA    TIMODE/ 4HIN-M,4HODE  /
      DATA    TEMODE/ 4HEX-M,4HODE  /
      DATA    IB    / 1             /
      DATA    MMASK / 201326592     /
      DATA    CMASK / 67108864      /
      DATA    BLANK / 4H            /
      DATA    NAME  / 4HRCOV,4HE    /
C
C     IF THIS IS A STATICS SOLUTION NO ENERGY CALCULATIONS CAN BE MADE
C
      IF (RFNO .LE. 2) RETURN
C
C     INITIALIZE
C
      SOF1 = KORSZ(Z) - SYSBUF + 1
      SOF2 = SOF1 - SYSBUF - 1
      SOF3 = SOF2 - SYSBUF
      BUF1 = SOF3 - SYSBUF
      BUF2 = BUF1 - SYSBUF
      BUF3 = BUF2 - SYSBUF
      BUF4 = BUF3 - SYSBUF
      LCORE= BUF4 - 1
      IF (LCORE .LE. 0) GO TO 9008
C
C     GET THE NAME OF THE HIGHER LEVEL SUBSTRUCTURE.  IF NONE EXISTS
C     THEN RETURN.
C
      CALL SOFOPN (Z(SOF1),Z(SOF2),Z(SOF3))
      NAMES(1) = RSS(1)
      NAMES(2) = RSS(2)
      CALL FNDNXL (RSS,HIGHER)
      RC = 4
      IF (HIGHER(1) .EQ. BLANK) GO TO 6000
      IF (HIGHER(1).EQ.RSS(1) .AND. HIGHER(2).EQ.RSS(2)) GO TO 1000
C
C     CHECK IF THE HIGHER LEVEL SUBSTRUCTURE WAS MODAL REDUCED.
C     IF NOT THEN WE HAVE NOTHING TO DO
C
      NAMES(1) = HIGHER(1)
      NAMES(2) = HIGHER(2)
      RC = 4
      CALL FDSUB (HIGHER,IDIT)
      IF (IDIT .LT. 0) GO TO 6000
      CALL FMDI (IDIT,IMDI)
      MREDU = .FALSE.
      CREDU = .FALSE.
      IF (ANDF(BUF(IMDI+IB),MMASK) .NE. 0) MREDU = .TRUE.
      IF (ANDF(BUF(IMDI+IB),CMASK) .NE. 0) CREDU = .TRUE.
      IF (.NOT.MREDU) GO TO 1000
C
C     READ THE MODAL GROUP OF THE EQSS TO DETERMINE IF THERE ARE ANY
C     RIGID BODY DOF PRESENT.  ALSO GET THE SIL NUMBER OF THE FIRST
C     MODAL CORDINATE.
C
      ITEM = EQSS
      CALL SFETCH (HIGHER,EQSS,1,RC)
      IF (RC .NE. 1) GO TO 6000
      CALL SUREAD (Z(1),3,N,RC)
      IF (RC .NE. 1) GO TO 6100
      N = Z(3)
      CALL SJUMP (N)
      IF (N .LT. 0) GO TO 6200
C
      NRIGID = 0
   10 CALL SUREAD (Z(1),3,N,RC)
      IF (RC .NE. 1) GO TO 6100
      IF (NRIGID .EQ. 0) IP = Z(2)
      IF (Z(1) .GE. 100) GO TO 20
      NRIGID = NRIGID + 1
      GO TO 10
C
   20 IF (2*IP .GT. SOF3) GO TO 9008
      N = 1
      CALL SJUMP (N)
      IF (N .LT. 0) GO TO 6200
C
      CALL SUREAD (Z(1),2*IP,N,RC)
      IF (RC .NE. 1) GO TO 6100
      I = 2*(IP-1) + 1
      ISIL = Z(I)
C
C     CALCULATE THE ENERGIES ON THE EXCLUDED MODES
C
      NOEXCL = .TRUE.
      NROWE  = 0
      IF (CREDU .OR. RFNO.LT.3 .OR. RFNO.GT.8) GO TO 100
      NOEXCL = .FALSE.
      CALL RCOVEM (NOEXCL,NROWE)
C
C     CALCULATE THE ENERGIES ON THE INCLUDED MODE AND THE TOTAL
C     ENERGIES ON EACH VECTOR
C
  100 CALL RCOVIM (HIGHER)
      IF (IOPT .LT. 0) GO TO 9200
      MCB(1) = SCR6
      CALL RDTRL(MCB)
      NCOL  = MCB(2)
      NROWI = MCB(3)
      NMODEI= NROWI - ISIL + 1
C
C     READ THE MODE DATA FROM LAMS AND SAVE THE MODE NUMBER AND
C     THE FREQUENCY FOR EACH MODE.
C
      NAMES(1) = RSS(1)
      NAMES(2) = RSS(2)
      ITEM = LAMS
      CALL SFETCH (RSS,LAMS,1,RC)
      IF (RC .NE. 1) GO TO 6000
      N = 1
      CALL SJUMP (N)
      IF (N .LT. 0) GO TO 6200
      IMODE = 1
      IF (NRIGID .EQ. 0) GO TO 210
      N = 3*NRIGID
      IMODE = IMODE + N
      DO 200 I = 1,N,3
      Z(I  ) = 0
      Z(I+1) = 0
  200 Z(I+2) = (I-1)/3 + 1
  210 NMODE = 3*(NMODEI-1+NROWE)
      IF (NMODE .GT. LCORE) GO TO 9008
C
      DO 300 I = IMODE,NMODE,3
      CALL SUREAD (Z(I),7,N,RC)
      IF (RC .NE. 1) GO TO 6100
      Z(I+1) = Z(I+4)
      Z(I+2) = 0
  300 CONTINUE
C
C     READ THE LAST GROUP OF LAMS AND GENERATE GRID NUMBERS FOR THE
C     INCLUDED MODES.
C
      N = 1
      CALL SJUMP (N)
      IF (N .LT. 0) GO TO 6200
      IINC = 100
      DO 400 I = IMODE,NMODE,3
      CALL SUREAD (ICODE,1,N,RC)
      IF (RC .NE. 1) GO TO 6100
      IF (ICODE .GT. 1) GO TO 400
      IINC = IINC + 1
      Z(I+2) = IINC
  400 CONTINUE
C
C     POSITION THE SOLN ITEM TO THE FREQUENCY OR TIME DATA
C
      ITEM = SOLN
      CALL SFETCH (RSS,SOLN,1,RC)
      IF (RC .NE. 1) GO TO 6000
      N = 1
      CALL SJUMP (N)
      IF (N .LT. 0) GO TO 6200
C
C     ALLOCATE INCORE ARRAYS FOR THE ENERGY VECTORS
C
      IVEC1 = NMODE + 1
      IVEC2 = IVEC1 + NMODEI
      IVEC3 = IVEC2 + NMODEI
      IVEC4 = IVEC3 + NROWE
      ISETS = IVEC4 + NROWE
      IF (ISETS .GT. LCORE) GO TO 9008
C
C     READ CASESS AND GET THE TITLE AND ANY SET INFORMATION
C
      FILE = CASESS
      CALL GOPEN (CASESS,Z(BUF1),RDREW)
  450 CALL FREAD (CASESS,Z(IVEC1),2,1)
      IF (Z(IVEC1).NE.CASECC(1) .OR. Z(IVEC1+1).NE.CASECC(2)) GO TO 450
C
      CALL FREAD (CASESS,0,-38,0)
      CALL FREAD (CASESS,ITITLE(1),96,0)
C
      IF (ENERGY .LE. 0) GO TO 485
      CALL FREAD (CASESS,0,-31,0)
      CALL FREAD (CASESS,LCC,1,0)
      LSKIP = 167 - LCC
      CALL FREAD (CASESS,0,LSKIP,0)
      CALL READ (*9002,*480,CASESS,LSEQ,1,0,I)
      IF (LSEQ .GT. 0) CALL FREAD (CASESS,0,LSEQ,0)
C
  460 CALL READ (*9002,*480,CASESS,ISET,1,0,I)
      CALL FREAD (CASESS,LSET,1,0)
      IF (ISET .EQ. ENERGY) GO TO 470
      CALL FREAD (CASESS,0,-LSET,0)
      GO TO 460
  470 IF (ISETS+LSET .GT. LCORE) GO TO 9008
      CALL FREAD (CASESS,Z(ISETS),LSET,0)
      GO TO 485
C
  480 WRITE (NOUT,63650) UWM,ENERGY
      ENERGY = -1
C
  485 CALL CLOSE (CASESS,REW)
C
C     LOOP OVER EACH COLUMN AND PRINT THE KINETIC AND POTENTIAL
C     ENERGIES FOR EACH MODAL COORDINATE IF REQUESTED
C
      NEXT = 1
      CALL GOPEN (SCR6,Z(BUF1),RDREW)
      CALL GOPEN (SCR7,Z(BUF2),RDREW)
      IF (NOEXCL) GO TO 490
      CALL GOPEN (SCR3,Z(BUF3),RDREW)
      CALL GOPEN (SCR4,Z(BUF4),RDREW)
C
  490 ITINU = RSP
      INCRU = 1
C
      DO 800 ICOL = 1,NCOL
C
C     SET FLAGS FOR NULL COLUMNS
C
      IKFLAG = 0
      IPFLAG = 0
C
C     GET THE FREQUENCY OR TIME FOR THIS VECTOR
C
      IF (RFNO .GT. 3) GO TO 500
C
C     NORMAL MODES SOLUTION
C
      CALL SUREAD (Z(IVEC1),7,N,RC)
      IF (RC .NE. 1) GO TO 6100
      STEP = RZ(IVEC1+4)
      GO TO 505
C
C     DYNAMICS SOLUTION
C
  500 CALL SUREAD (STEP,1,N,RC)
      IF (RC .NE. 1) GO TO 6100
C
C     SEE IF THIS COLUMN IS REQUESTED
C
  505 IF (ENERGY .LE. 0) GO TO 510
      CALL SETFND (*790,Z(ISETS),LSET,ICOL,NEXT)
C
  510 IF (STEP.LT.RANGE(1) .OR. STEP.GT.RANGE(2)) GO TO 790
C
C     UNPACK THE KINETIC AND POTENTIAL ENERGIES ON INCLUDED MODES
C
      IRU = ISIL
      NRU = NROWI
      CALL UNPACK (*520,SCR6,RZ(IVEC1))
      GO TO 540
  520 DO 530 I = 1,NMODEI
  530 RZ(IVEC1+I-1) = 0.0
      RZ(IVEC1+NMODEI-1) = 1.0
      IKFLAG = 1
C
  540 CALL UNPACK (*550,SCR7,RZ(IVEC2))
      GO TO 570
  550 DO 560 I = 1,NMODEI
  560 RZ(IVEC2+I-1) = 0.0
      RZ(IVEC2+NMODEI-1) = 1.0
      IPFLAG = 1
C
C     UNPACK THE KINETIC AND POTENTIAL ENERGIES ON EXLUDED MODES
C
  570 IF (NOEXCL) GO TO 580
      IRU = 1
      NRU = NROWE
      CALL UNPACK (*580,SCR3,RZ(IVEC3))
      GO TO 600
  580 DO 590 I = 1,NROWE
  590 RZ(IVEC3+I-1) = 0.0
C
  600 IF (NOEXCL) GO TO 610
      CALL UNPACK (*610,SCR4,RZ(IVEC4))
      GO TO 630
  610 DO 620 I = 1,NROWE
  620 RZ(IVEC4+I-1) = 0.0
C
C     INITILIZE FOR THE OUTPUT
C
  630 NLINES = NLPP
C
C     GET TOTAL ENERGIES
C
      TKENG = RZ(IVEC1+NMODEI-1)
      TPENG = RZ(IVEC2+NMODEI-1)
      PERKT = 1.0
      PERPT = 1.0
C
C     LOOP OVER EACH MODAL COORDINATE
C
      IINC = 0
      IEXC = 0
C
      DO 700 I = 1,NMODE,3
C
      MODE = Z(I)
      FREQ = RZ(I+1)
      GRID = Z(I+2)
C
C     GET ENERGIES FORM THE PROPER VECTOR
C
      IF (NOEXCL) GO TO 650
      IF (GRID .EQ. 0) GO TO 660
 650  KENG = RZ(IVEC1+IINC)
      PENG = RZ(IVEC2+IINC)
      IINC = IINC + 1
      TYPE(1) = TIMODE(1)
      TYPE(2) = TIMODE(2)
C
      IF (MODE .NE. 0) GO TO 670
      TYPE(1) = TRIGID(1)
      TYPE(2) = TRIGID(2)
      GO TO 670
C
  660 KENG = RZ(IVEC3+IEXC)
      PENG = RZ(IVEC4+IEXC)
      IEXC = IEXC + 1
      TYPE(1) = TEMODE(1)
      TYPE(2) = TEMODE(2)
C
C     CALCULATE THE ENERGY PERCENTAGES
C
  670 PERK = KENG/TKENG
      IF (PERK .GE. 100.0) PERK = 99.9999
      PERP = PENG/TPENG
      IF (PERP .GE. 100.0) PERP = 99.9999
      IF (GRID .NE. 0) GO TO 680
      PERKT = PERKT + PERK
      PERPT = PERPT + PERP
C
C     PRINT A LINE OF OUTPUT
C
  680 NLINES = NLINES + 1
      IF (NLINES .LE. NLPP) GO TO 690
      CALL PAGE1
      WRITE (NOUT,5000) RSS
      IF (RFNO .EQ. 9) WRITE (NOUT,5010) STEP
      IF (RFNO .NE. 9) WRITE (NOUT,5020) STEP
      WRITE (NOUT,5100)
      NLINES = 0
C
  690 WRITE (NOUT,5200) GRID,TYPE,MODE,FREQ,KENG,PERK,PENG,PERP
C
  700 CONTINUE
C
C     PRINT THE TOTAL KINETIC AND POTENTIAL ENERGIES FOR THIS COLUMN
C
      IF (PERKT .GE. 100.0) PERKT = 99.9999
      IF (PERPT .GE. 100.0) PERPT = 99.9999
      IF (IKFLAG .EQ. 0) GO TO 710
      TKENG = 0.0
      PERKT = 0.0
  710 IF (IPFLAG .EQ. 0) GO TO 720
      TPENG = 0.0
      PERPT = 0.0
  720 WRITE (NOUT,5300) TKENG,PERKT,TPENG,PERPT
      GO TO 800
C
C     THIS VECTOR IS NOT TO BE PRINTED SO SKIP IT
C
  790 CALL FWDREC (*9002,SCR6)
      CALL FWDREC (*9002,SCR7)
      IF (NOEXCL) GO TO 800
      CALL FWDREC (*9002,SCR3)
      CALL FWDREC (*9002,SCR4)
C
  800 CONTINUE
C
C     CLOSE FILES
C
      CALL CLOSE (SCR6,REW)
      CALL CLOSE (SCR7,REW)
      IF (NOEXCL) GO TO 1000
      CALL CLOSE (SCR3,REW)
      CALL CLOSE (SCR4,REW)
C
C     NORMAL RETURN
C
 1000 CALL SOFCLS
      RETURN
C
C     ERRORS
C
 6000 CALL SMSG (RC-2,ITEM,NAMES)
      GO TO 9200
 6100 CALL SMSG (RC+4,ITEM,NAMES)
      GO TO 9200
 6200 CALL SMSG (7,ITEM,NAMES)
      GO TO 9200
 9002 N = 2
      GO TO 9100
 9008 N = 8
 9100 CALL MESAGE (N,FILE,NAME)
 9200 CALL SOFCLS
      WRITE (NOUT,63710) UWM,RSS
      RETURN
C
C     FORMAT STATEMENTS
C
 5000 FORMAT (//39X,43HMODAL COORDINATE ENERGIES FOR SUBSTRUCTURE ,2A4)
 5010 FORMAT (//12X,7HTIME = ,1P,E13.6)
 5020 FORMAT (//12X,12HFREQUENCY = ,1P,E13.6)
 5100 FORMAT (//12X,4HGRID,6X,4HTYPE,6X,4HMODE,7X,9HFREQUENCY,10X,
     1        7HKINETIC,8X,8HKE/TOTAL,6X,9HPOTENTIAL,7X,8HPE/TOTAL ,/)
 5200 FORMAT (1H ,8X,I8,5X,2A4,2X,I5,5X,1P,E13.6,2(5X,1P,E13.6,5X,
     1        0P,F7.4))
 5300 FORMAT (1H ,55X,2(4X,14H--------------,4X,8H--------), /12X,
     1        28HTOTAL ENERGY FOR THIS VECTOR,15X,2(5X,1P,E13.6,5X,
     2        0P,F7.4))
63710 FORMAT (A25,' 6371, MODAL REDUCTION ENERGY CALCULATIONS FOR ',
     1       'SUBSTRUCTURE ',2A4,' ABORTED.')
63650 FORMAT (A25,' 6365, REQUESTED OUTPUT SET ID',I6,' IS NOT ',
     1       'DECLARED IN CASE CONTROL. ALL OUTPUT WILL BE PRODUCED')
      END

      SUBROUTINE FIND (MODE,BUF1,BUF4,SETID,X)
C
      INTEGER         AWRD(2),BUF1,BUF4,BUFSIZ,ERR(3),FOR,FSCALE,FVP,
     1                GPSET,ORIGIN,ORG,PARM,PRJECT,PRNT,REGION,SET,
     2                SETD,SETID(1),TRA,WORD,X(1),HSET,ORIG,POIN,REGI,
     3                SCAL,VANT,MSG1(20),MSG3(21),MSG6(20),NAME(2)
      REAL            IMSEP,MAX,MAXDEF,MIN,MM17P5
      DOUBLE PRECISION DWRD
      CHARACTER       UFM*23,UWM*25
      COMMON /XMSSG / UFM,UWM
      COMMON /SYSTEM/ BUFSIZ, NOUT
      COMMON /BLANK / NGP,SKP11,NSETS,PRNT,SKP12,NGPSET,SKP13(4),
     1                PARM,GPSET,SKP2(8),MERR,SETD
      COMMON /XXPARM/ PLTBUF,PLTTER(5),NOPENS,PAPSIZ(2),PENPAP(27),
     1                SCALE,OBJMOD,FSCALE,MAXDEF,DEFMAX,AXIS(6),VIEW(9),
     2                FVP,SKPVP1(4),D0,SKPVP2(2),PRJECT,S0S,FOR,ORG,
     3                NORG,ORIGIN(11),EDGE(11,4),XY(11,3)
      COMMON /PLTDAT/ SKPPLT(2),REG(4),AXYMAX(14),SKPA(3),CNTCHR(2)
      COMMON /RSTXXX/ CSTM(3,3),MIN(3),MAX(3),D(3),AVER(3)
      EQUIVALENCE     (WORD,AWRD(1),IWRD,FWRD,DWRD)
      DATA    NAME  / 4H  FI, 4HND  /
      DATA    MM17P5, RDIST,  SQRT3 / .688975, 29., 1.732051/,
     1        ORIG  / 4HORIG/, REGI / 4HREGI/, SCAL / 4HSCAL/,
     2        HSET  / 3HSET /, VANT / 4HVANT/, POIN / 4HPOIN/
      DATA    NMSG1 , MSG1  / 20,
     1                4H(34X, 4H,45H, 4HAN A, 4HTTEM, 4HPT H, 4HAS B,
     2                4HEEN , 4HMADE, 4H TO , 4HDEFI, 4HNE M, 4HORE ,
     3                4HTHAN, 4H ,I2, 4H,17H, 4H DIS, 4HTINC, 4HT OR,
     4                4HIGIN, 4HS)     /
      DATA    NMSG3 , MSG3  / 21,
     1                4H(25X, 4H,27H, 4HAN U, 4HNREC, 4HOGNI, 4HZABL,
     2                4HE RE, 4HQUES, 4HT (,, 4H2A4,, 4H37H), 4H HAS,
     3                4H BEE, 4HN SP, 4HECIF, 4HIED , 4HON A, 4H -FI,
     4                4HND- , 4HCARD, 4H)   /
      DATA    NMSG6 , MSG6  / 20,
     1                4H(33X, 4H,71H, 4HMAXI, 4HMUM , 4HDEFO, 4HRMAT,
     2                4HION , 4HCARD, 4H NEE, 4HDED , 4H- 5 , 4HPER ,
     3                4HCENT, 4H OF , 4HMAXI, 4HMUM , 4HDIME, 4HNSIO,
     4                4HN US, 4HED.)  /
C
      CALL RDMODX (PARM,MODE,WORD)
      SET    = SETD
      REGION = 0
      REG(1) = 0.
      REG(2) = 0.
      REG(3) = 1.
      REG(4) = 1.
      RATIO  = 0.
      NOGO   = 0
      IF (MODE .LT. 0) GO TO 480
C
C     INTERPRET THE REQUESTS ON THE -FIND- CARD.
C
   10 IF (MODE .LE. 0) CALL RDMODE (*10,*20,*480,MODE,WORD)
   20 CALL RDWORD (MODE,WORD)
C
C     IS AN ORIGIN TO BE FOUND
C
   30 IF (WORD .NE. ORIG) GO TO 90
      IF (MODE .NE.    0) GO TO 10
      ASSIGN 40 TO TRA
      GO TO 400
   40 IF (ORG .EQ. 0) GO TO 70
      DO 50 J = 1,ORG
      IF (ORIGIN(J) .EQ. IWRD) GO TO 80
   50 CONTINUE
      IF (ORG  .LT. NORG) GO TO 70
      IF (PRNT .LT.    0) GO TO 60
      ERR(1) = 1
      ERR(2) = NORG
      CALL WRTPRT (MERR,ERR,MSG1,NMSG1)
   60 ORG = NORG
      I   = ORG + 1
      EDGE(I,1) = 0.0
      EDGE(I,2) = 0.0
      EDGE(I,3) = 1.0
      EDGE(I,4) = 1.0
   70 ORG = ORG + 1
      ORIGIN(ORG) = IWRD
      J   = ORG
   80 FOR = J
      GO TO 10
C
C     IS A REGION SPECIFIED
C
   90 IF (WORD .NE. REGI) GO TO 200
      IF (MODE .NE.    0) GO TO 10
      REGION = 1
      ASSIGN 110 TO TRA
      J = 0
  100 J = J + 1
      GO TO 440
  110 REG(J) = AMIN1(1.,ABS(FWRD))
      IF (J-4) 100,10,10
C
C     IS THE SCALE TO BE FOUND
C
  200 IF (WORD .NE. SCAL) GO TO 220
      FSCALE = 1
      IF (MODE .NE. 0) GO TO 10
      ASSIGN 210 TO TRA
      GO TO 440
  210 RATIO = FWRD
      GO TO 10
C
C     IS THERE A SET ON THE FIND CARD
C
  220 IF (WORD .NE. HSET) GO TO 300
      IF (MODE .NE.    0) GO TO 10
      ASSIGN 230 TO TRA
      GO TO 400
  230 DO 240 J = 1,NSETS
      IF (IWRD .EQ. SETID(J)) GO TO 260
  240 CONTINUE
      WRITE  (NOUT,250) UWM,IWRD
  250 FORMAT (A25,' 700, SET',I9,' REQUESTED ON FIND CARD HAS NOT BEEN',
     1       ' DEFINED. DEFAULT SET',I9,' USED')
      NOGO = 1
      GO TO 10
  260 SET  = J
      GO TO 10
C
C     IS THE VANTAGE POINT TO BE FOUND
C
  300 IF (WORD .NE. VANT) GO TO 320
      IF (MODE .EQ. 0) CALL RDMODE (*10,*310,*480,MODE,WORD)
  310 CALL RDWORD (MODE,WORD)
      IF (WORD .NE. POIN) GO TO 30
      FVP = 1
      GO TO 10
C
C     UNRECOGNIZABLE OPTION ON THE FIND CARD
C
  320 IF (PRNT .LT. 0) GO TO 10
      ERR(1) = 2
      ERR(2) = AWRD(1)
      ERR(3) = AWRD(2)
      CALL WRTPRT (MERR,ERR,MSG3,NMSG3)
      GO TO 10
C
C     READ AN INTEGER FROM THE FIND CARD
C
  400 CALL RDMODE (*410,*10,*480,MODE,WORD)
  410 IF (MODE .EQ. -1) GO TO 430
      IF (MODE .EQ. -4) GO TO 420
      IWRD = FWRD
      GO TO 430
  420 IWRD = DWRD
  430 GO TO TRA, (40,230)
C
C     READ A REAL NUMBER FROM THE FIND CARD
C
  440 CALL RDMODE (*450,*10,*480,MODE,WORD)
  450 IF (MODE .EQ. -4) GO TO 460
      IF (MODE .NE. -1) GO TO 470
      FWRD = IWRD
      GO TO 470
  460 FWRD = DWRD
  470 GO TO TRA, (110,210)
C
C     END OF THE FIND CARD
C
  480 IF (ORG .GT. 0) GO TO 485
C
C     ALLOW NO ORIGIN REQUEST ON FIRST FIND CARD
C     ORIGIN ID IS ZERO
C
      ORG = 1
      ORIGIN(1) = 0
      REGION = 1
  485 IF (FOR    .EQ. 0) GO TO 500
      IF (REGION .EQ. 0) GO TO 490
      EDGE(FOR,1) = REG(1)
      EDGE(FOR,2) = REG(2)
      EDGE(FOR,3) = REG(3)
      EDGE(FOR,4) = REG(4)
      GO TO 500
  490 REG(1) = EDGE(FOR,1)
      REG(2) = EDGE(FOR,2)
      REG(3) = EDGE(FOR,3)
      REG(4) = EDGE(FOR,4)
  500 REG(1) = REG(1)*AXYMAX(1)
      IF (REG(2) .NE. 0.) GO TO 510
      REG(2) = 4.*CNTCHR(2)
      GO TO 520
  510 REG(2) = REG(2)*AXYMAX(2)
  520 REG(3) = REG(3)*AXYMAX(1) - CNTCHR(1)*8.
      REG(4) = REG(4)*AXYMAX(2) - CNTCHR(2)
C
C     CALCULATE THE ROTATION MATRIX + ROTATE THE CO-ORDINATES OF THE SET
C
      CALL GOPEN (GPSET,X(BUF4),0)
      I = 1
      CALL FWDREC (*810,GPSET)
      IF (SET .EQ. 1) GO TO 540
      DO 530 I = 2,SET
      CALL FWDREC (*810,GPSET)
  530 CONTINUE
C
C     READ NGPSET
C
  540 CALL FREAD (GPSET,NGPSET,1,0)
C
C     CHECK CORE
C
      ICRQ = 3*NGPSET + NGP - BUF4 - BUFSIZ - 1
      IF (ICRQ .GT. 0) GO TO 800
      CALL FREAD (GPSET,X,NGP,0)
      CALL CLOSE (GPSET,1)
      CALL FNDSET (X,X(NGP+1),BUF1,0)
      DO 550 I = 1,3
      MIN(I) = +1.E+20
  550 MAX(I) = -1.E+20
      CALL PROCES (X(NGP+1))
      IF (MAXDEF.NE.0.0 .OR. PRNT.GE.0) GO TO 560
C
C     DEFORMED PLOTS AND MAXDEF WAS NOT SPECIFIED
C
      ERR(1) = 0
      CALL WRTPRT (MERR,ERR,MSG6,NMSG6)
      MAXDEF = AMAX1(D(2),D(3))
      IF (MAXDEF .LE. 0.0) MAXDEF = 1.0
      MAXDEF = 0.05*MAXDEF
  560 CONTINUE
      GO TO (600,570,700), PRJECT
C
C     PERSPECTIVE PROJECTION (FIND VANTAGE POINT IF REQUESTED)
C
  570 DO 580 I = 1,3
      MIN(I) = +1.E+20
  580 MAX(I) = -1.E+20
      CALL PERPEC (X(NGP+1),0)
      FVP = 0
C
C     ORTHOGRAPHIC OR PERSPECTIVE PROJECTION
C
C     FIND SCALE FACTOR (IF REQUESTED).
C
  600 IF (FSCALE .EQ. 0) GO TO 630
      A = D(2) + 2.*MAXDEF*SQRT3
      IF (A .EQ. 0.0) GO TO 610
      A = (REG(3)-REG(1))/A
  610 B = D(3) + 2.*MAXDEF*SQRT3
      IF (B .EQ. 0.0) GO TO 620
      B = (REG(4)-REG(2))/B
  620 SCALE = AMIN1(A,B)
      IF (SCALE .LE. 0.) SCALE = AMAX1(A,B)
      IF (SCALE .LE. 0.) SCALE = 1.
      IF (RATIO .NE. 0.) SCALE = RATIO*SCALE
C
C     FIND ORIGIN -FOR- IF REQUESTED
C
  630 IF (FOR .EQ. 0) GO TO 830
      XY(FOR,1) = AVER(2)*SCALE - (REG(1)+REG(3))/2.
      XY(FOR,3) = AVER(3)*SCALE - (REG(2)+REG(4))/2.
      GO TO 830
C
C     STEREO PROJECTION
C
C     FIND SCALE FACTORS (IF REQUESTED).
C
  700 IF (FSCALE .EQ. 0) GO TO 710
      DIAM = SQRT(D(1)**2 + D(2)**2 + D(3)**2)
      A = SQRT3*MAXDEF
      IF (D(2)+A.GE.DIAM .OR. D(3)+A.GE.DIAM) DIAM = DIAM + MAXDEF
      IF (DIAM .EQ. 0.0) DIAM = 1.E-5
      OBJMOD = 10./DIAM
      SCALE  = AMIN1(REG(3)-REG(1),REG(4)-REG(2))/MM17P5
      IF (RATIO .NE. 0.) SCALE=RATIO*SCALE
C
C     FIND VANTAGE POINT (IF REQUESTED)
C
  710 CALL PERPEC (X(NGP+1),0)
      FVP = 0
C
C     FIND ORIGIN -FOR- IF REQUESTED
C
      IF (FOR .EQ. 0) GO TO 830
      IMSEP     = S0S*(RDIST-D0)/(2.*RDIST)
      XY(FOR,1) = SCALE*(AVER(2)*OBJMOD-IMSEP) - (REG(1)+REG(3))/2.
      XY(FOR,2) = SCALE*(AVER(2)*OBJMOD+IMSEP) - (REG(1)+REG(3))/2.
      XY(FOR,3) = SCALE*(AVER(3)*OBJMOD)       - (REG(2)+REG(4))/2.
      GO TO 830
C
  800 CALL MESAGE (-8,ICRQ,NAME)
C
  810 WRITE  (NOUT,820) UFM,SETID(SET)
  820 FORMAT (A23,' 703, SET',I9,' REQUESTED ON FIND CARD NOT IN ',
     1       'GPSETS FILE.')
      NOGO = 1
      CALL CLOSE (GPSET,1)
      GO TO 840
C
  830 FSCALE = 0
      FOR    = 0
  840 IF (NOGO .NE. 0) CALL MESAGE (-37,0,NAME)
      RETURN
      END

      SUBROUTINE MPLPRT
C
C     PRINTS MPL TABLE FOR DOCUMENTATION PURPOSES
C     AND CHECKS VALIDITY OF MANY ITEMS.
C
      DOUBLE PRECISION XX
      REAL            X(2,1)
      INTEGER         KP(6),FLAG,FLAGB,FLAGS,TOT,FLGTOT,ADD(2),
     1                T1,T2,T3,H1,H2,H3,H1X(32),H2X(32),H3X(32)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25,SWM*27
      COMMON /XMSSG / UFM,UWM,UIM,SFM,SWM
      COMMON /SYSTEM/ NB,NO,JUNK1(6),NLPP,JUNK2(2),LINE
      COMMON /XFIST / NFIST
      COMMON /XPFIST/ NPFIST
      COMMON /OUTPUT/ T1(32),T2(32),T3(32),H1(32),H2(32),H3(32)
      COMMON /XGPI2 / LMPL,MPLPNT,MPL(1)
      COMMON /XGPI2X/ XX(1)
C
      EQUIVALENCE    (XX(1),X(1,1))
C
      DATA KP    / 1,1,2,2,2,4 / ,  ADD   /4HADD ,4H    /
      DATA FLAGB / 1H  /  ,  FLAGS /4H ***/
      DATA H1X/4H    ,4H    ,4H    ,4H    ,4H    ,4H    ,4H    ,4H
     2        ,4H   M,4H O D,4H U L,4H E  ,4H P R,4H O P,4H E R,4H T I
     3        ,4H E S,4H   L,4H I S,4H T  ,4H    ,4H    ,4H    ,4H
     4        ,4H    ,4H    ,4H    ,4H    ,4H    ,4H    ,4H    ,4H    /
      DATA H2X/4H    ,4H    ,4H    ,4H    ,4H    ,4H    ,4H    ,4H
     2        ,4H    ,4H    ,4H    ,4H    ,4H    ,4H   -,4H - -,4H - -
     3        ,4H - -,4H P A,4H R A,4H M E,4H T E,4H R S,4H - -,4H - -
     4        ,4H - -,4H - -,4H    ,4H    ,4H    ,4H    ,4H    ,4H    /
      DATA H3X/4H  MP,4HLID ,4HNWDS,4H  WD,4H1  M,4HOD-N,4HAME ,4HTYP
     2        ,4H IN ,4H OUT,4H  SC,4HR  T,4HOT  ,4H   I,4HD TY,4HP
     3        ,4HP   ,4H   D,4HEFAU,4HLT (,4HIF A,4HNY) ,4H    ,4H   W
     4        ,4H1-W2,4H FLG,4H    ,4H    ,4H    ,4H    ,4H    ,4H    /
C
   21 FORMAT (7H0      ,3I5,2X ,2A4 ,I3,4I5  ,10X,A3)
   22 FORMAT (7H0      ,3I5,2X ,2A4 ,I3,4I5
     1       ,10X,50H----- N O   P A R A M E T E R S   E X I S T -----
     2       ,10X,A3)
   23 FORMAT (7H0      ,3I5,2X,8H (NONE) )
   24 FORMAT (7H0      ,3I5,2X,2A4,I3    )
   31 FORMAT (59X,I2,5H. INT,I5,7X,16H-- NO DEFAULT --,6X ,I2          )
   32 FORMAT (59X,I2,5H. RSP,I5,7X,16H-- NO DEFAULT --,6X ,I2          )
   33 FORMAT (59X,I2,5H. BCD,I5,7X,16H-- NO DEFAULT --,6X ,I2,1H-,I2   )
   34 FORMAT (59X,I2,5H. RDP,I5,7X,16H-- NO DEFAULT --,6X ,I2,1H-,I2,A4)
   35 FORMAT (59X,I2,5H. CSP,I5,7X,16H-- NO DEFAULT --,6X ,I2,1H-,I2,A4)
   36 FORMAT (59X,I2,5H. CDP,I5,7X,16H-- NO DEFAULT --,6X ,I2,1H-,I2,A4)
   41 FORMAT (59X,I2,5H. INT,I5, I15,14X                  ,I2          )
   42 FORMAT (59X,I2,5H. RSP,I5, 1P,E20.4,9X              ,I2          )
   43 FORMAT (59X,I2,5H. BCD,I5, 11X,2A4,10X              ,I2,1H-,I2   )
   44 FORMAT (59X,I2,5H. RDP,I5, 1P,D20.4,9X              ,I2,1H-,I2,A4)
   45 FORMAT (59X,I2,5H. CSP,I5, 3H  (,1P,E11.4,1H, ,1P,E11.4,3H   ,
     1                                                     I2,1H-,I2,A4)
   46 FORMAT (59X,I2,5H. CDP,I5, 3H  (,1P,D11.4,1H, ,1P,D11.4,3H)  ,
     1                                                     I2,1H-,I2,A4)
   47 FORMAT (10X,'NOTE - THE ABOVE PARAMETER DEFAULTS WILL BE CHANGED',
     1 ' TO ALL ZEROS BY THE ADD MODULE.  HOWEVER, IF ALL 4 PARAMETERS',
     2 ' ARE NOT', /10X,'SPECIFIED, THEY WILL BE CHANGED TO 2*(1.,0.),',
     3 ' 2*(0.D0,0.D0), OR 2*(0.,0.), 2*(1.D0,0.D0) DEPENDING ON ',
     4 'MATRICES INVOLVED')
C
C     INITIALIZATION
C
      CALL PAGE
      MPLID = 0
      NPAD  = 0
      I2    = 0
      DO 80 I = 1,32
      H1(I) = H1X(I)
      H2(I) = H2X(I)
      H3(I) = H3X(I)
   80 CONTINUE
      CALL PAGE
C
C     PROCESS NEXT ENTRY
C
  100 CONTINUE
      IF (I2-LMPL) 110,900,9901
  110 I0 = I2
      I1 = I2 + 1
      I2 = I0 + MPL(I1)
      MPLID = MPLID + 1
C
C     TEST FOR MODULE TYPE
C
      IF (MPL(I1)-1) 9904,120,112
  112 IF (MPL(I1+1) .EQ. 0) GO TO 120
      IF (MPL(I0+4) .LT. 3) GO TO 130
C
C     EXECUTIVE MODULE
C
      CALL PAGE2 (-2)
      L1 = I0 + 2
      L2 = L1 + 2
      WRITE (NO,24) MPLID,MPL(I1),I1,(MPL(L),L=L1,L2)
      GO TO 100
C
C     PAD SPACE
C
  120 CALL PAGE2 (-2)
      WRITE (NO,23) MPLID,MPL(I1),I1
      NPAD = NPAD + 1
      GO TO 100
C
C     FUNCTIONAL MODULE
C
  130 IF (MPL(I1) .GT. 7) GO TO 140
C
C     NO PARAMETERS EXIST FOR THIS FUNCTIONAL MODULE
C
      CALL PAGE2 (-2)
      L1  = I0 + 5
      L2  = L1 + 2
      TOT = 0
      DO 137 L = L1,L2
  137 TOT = TOT + MPL(L)
      FLGTOT = FLAGB
      IF (TOT .GT. NFIST-NPFIST) FLGTOT = FLAGS
      L1  = I0 + 2
      WRITE (NO,22) MPLID,MPL(I1),I1,(MPL(L),L=L1,L2),TOT,FLGTOT
      GO TO 100
C
C     PARAMETERS EXIST FOR THIS FUNCTIONAL MODULE
C
  140 CONTINUE
C
C     DETERMINE THE NUMBER OF PARAMETERS FOR FUNCTIONAL MODULE
C
      NP = 0
      I  = I0 + 8
  150 CONTINUE
      IF ((I-1)-(I2)) 151,160,9903
  151 IP = IABS(MPL(I))
      IF (IP .GT. 6) GO TO 9902
      IF (MPL(I)) 152,9902,154
  152 NP = NP + 1
      I  = I  + 1
      GO TO 150
  154 NP = NP + 1
      I  = I + 1 + KP(IP)
      GO TO 150
  160 IF (NP .LE. 0) GO TO 9903
C
      CALL PAGE2 (-2-NP)
      L1 = I0 + 5
      L2 = L1 + 2
      TOT= 0
      DO 167 L = L1,L2
  167 TOT = TOT + MPL(L)
      FLGTOT = FLAGB
      IF (TOT .GT. NFIST-NPFIST) FLGTOT = FLAGS
      L1 = I0 + 2
      WRITE (NO,21) MPLID,MPL(I1),I1,(MPL(L),L=L1,L2),TOT,FLGTOT
C
C     PRINT PARAMETERS
C
      NP = 0
      I  = I0 + 8
      J2 = 0
  170 CONTINUE
      NP = NP + 1
      J1 = J2 + 1
      IF ((I-1)-(I2)) 175,200,9903
  175 IP = IABS(MPL(I))
      IF (IP .GT. 6) GO TO 9902
      IF (MPL(I)) 180,9902,190
C
C     PARAMETER HAS NO DEFAULT VALUE
C
  180 CONTINUE
      J2 = J1
      GO TO (181,182,183,184,185,186), IP
C
C     INTEGER
C
  181 WRITE (NO,31) NP,I,J1
      GO TO 188
C
C     REAL SINGLE-PRECISION
C
  182 WRITE (NO,32) NP,I,J1
      GO TO 188
C
C     ALPHANUMERIC (BCD)
C
  183 J2 = J2 + 1
      WRITE (NO,33) NP,I,J1,J2
      GO TO 188
C
C     REAL DOUBLE-PRECISION
C
  184 J2 = J2 + 1
      FLAG = FLAGB
      IF (MOD(J1,2) .EQ. 0) FLAG = FLAGS
      WRITE (NO,34) NP,I,J1,J2,FLAG
      GO TO 188
C
C     COMPLEX SINGLE-PRECISION
C
  185 J2   = J2 + 1
      FLAG = FLAGB
      IF (MOD(J1,2) .EQ. 0) FLAG = FLAGS
      WRITE (NO,35) NP,I,J1,J2,FLAG
      GO TO 188
C
C     COMPLEX DOUBLE-PRECISION
C
  186 J2   = J2 + 3
      FLAG = FLAGB
      IF (MOD(J1,2) .EQ. 0) FLAG = FLAGS
      WRITE (NO,36) NP,I,J1,J2,FLAG
      GO TO 188
  188 CONTINUE
      I = I + 1
      GO TO 170
C
C     PARAMETER HAS A DEFAULT VALUE
C
  190 CONTINUE
      GO TO (191,192,193,194,195,196), IP
C
C     INTEGER
C
  191 J2 = J1
      WRITE (NO,41) NP,I,MPL(I+1),J1
      I = I + 2
      GO TO 198
C
C     REAL SINGLE-PRECISION
C
  192 J2 = J1
      M  = MPL(I+1)
      WRITE (NO,42) NP,I,X(1,M),J1
      I  = I + 2
      GO TO 198
C
C     ALPHANUMERIC (BCD)
C
  193 J2 = J1 + 1
      WRITE (NO,43) NP,I,MPL(I+1),MPL(I+2),J1,J2
      I = I + 3
      GO TO 198
C
C     REAL DOUBLE-PRECISION
C
  194 J2 = J1 + 1
      M  = MPL(I+1)
      FLAG = FLAGB
      IF (MOD(J1,2) .EQ. 0) FLAG = FLAGS
      WRITE (NO,44) NP,I,XX(M),J1,J2,FLAG
      I = I + 3
      GO TO 198
C
C     COMPLEX SINGLE-PRECISION
C
  195 J2 = J1 + 1
      M  = MPL(I+1)
      FLAG = FLAGB
      IF (MOD(J1,2) .EQ. 0) FLAG = FLAGS
      WRITE (NO,45) NP,I,X(1,M),X(2,M),J1,J2,FLAG
      I  = I + 3
      GO TO 198
C
C     COMPLEX DOUBLE-PRECISION
C
  196 J2 = J1 + 3
      M1 = MPL(I+1)
      M2 = MPL(I+3)
      FLAG = FLAGB
      IF (MOD(J1,2) .EQ. 0) FLAG = FLAGS
      WRITE (NO,46) NP,I,XX(M1),XX(M2),J1,J2,FLAG
      I = I + 5
      GO TO 198
  198 CONTINUE
      GO TO 170
C
  200 CONTINUE
      IF (MPL(L1).NE.ADD(1) .OR. MPL(L1+1).NE.ADD(2)) GO TO 100
      CALL PAGE2 (-2)
      WRITE (NO,47)
      GO TO 100
C
C     TERMINATION
C
  900 CONTINUE
      CALL PAGE2 (-4)
      WRITE  (NO,901)
  901 FORMAT ('0*** END OF MPL PRINTOUT')
      WRITE  (NO,902) MPLID,NPAD
  902 FORMAT ('0*** THE MPL CONTAINS ',I3,' ENTRYS.  OF THESE, ',I3,
     1       ' ARE PAD ENTRYS.')
C
      RETURN
C
C     ERROR MESSAGES
C
 9901 WRITE  (NO,9951) SWM,I2,LMPL
 9951 FORMAT (A27,' 65, POINTER I2 =',I10,' DOES NOT AGREE WITH LMPL =',
     1        I11)
      GO TO 9995
C
 9902 WRITE  (NO,9952) SWM
 9952 FORMAT (A27,' 66, ILLEGAL PARAMETER TYPE CODE.')
      GO TO 9995
C
 9903 WRITE  (NO,9953) SWM
 9953 FORMAT (A27,' 67, ERROR IN PARAMETER SEQUENCE.')
      GO TO 9995
C
 9904 WRITE  (NO,9954) SWM
 9954 FORMAT (A27,' 68, ILLEGAL WORD COUNT.')
C
C
 9995 CALL PAGE2 (4)
      WRITE  (NO,9996)
 9996 FORMAT (5X,'MPL TABLE LISTING CANCELLED.')
C
      RETURN
      END

      SUBROUTINE INITL2 (OFFSET,DELTT)
C
C     INITL2 WILL COMPUTE THE STARTING VALUES FOR THE INTEGRATION
C     ROUTINE
C
C     THIS ROUTINE IS SUITABLE FOR DOUBLE PRECISION OPERATION
C
      INTEGER          OFFSET   ,RSP      ,FILEM    ,FILEB    ,
     1                 FILEK    ,SQR      ,FILE     ,IFILA(7) ,
     2                 IFILB(7) ,IFILC(7) ,NAME(2)  ,RDP
      DOUBLE PRECISION DET      ,MINDIA   ,ALPHA(2) ,BETA(2)
      COMMON /SADDX /  NOMAT    ,NZ       ,MCBS(67)
      COMMON /NAMES /  RD       ,RDREW    ,WRT      ,WRTREW   ,
     1                 REW      ,NOREW    ,EOFNRW   ,RSP      ,
     2                 RDP      ,CSP      ,CDP      ,SQR
      COMMON /SFACT /  IFA(7)   ,IFL(7)   ,IFU(7)   ,ISC1     ,
     1                 ISC2     ,NXX      ,ID(5)    ,ISC3     ,
     2                 ID1(2)   ,ICHL
      COMMON /DCOMPX/  IA(7)    ,IL(7)    ,IU(7)    ,ISCR10   ,
     1                 ISCR20   ,ISCR30   ,DET      ,POWER    ,
     2                 NX       ,MINDIA
      COMMON /TRDXX /  FILEK(7) ,FILEM(7) ,FILEB(7) ,
     1                 ISCR1    ,ISCR2    ,ISCR3    ,ISCR4    ,
     2                 ISCR5    ,ISCR6    ,IOPEN    ,ISYM
      COMMON /ZZZZZZ/  Z(1)
      EQUIVALENCE      (MCBS(1),IFILA(1)) ,(MCBS(8),ITYPAL)   ,
     1                 (MCBS(9),ALPHA(1)) ,(MCBS(13),IFILB(1)),
     2                 (MCBS(20),ITYPBT)  ,(MCBS(21),BETA(1)) ,
     3                 (MCBS(61),IFILC(1))
      DATA    NAME  /  4HINIT,4HL2  /
C
      NOMAT   = 2
      IPREC   = RDP
      ALPHA(2)= 0.0D0
      BETA(2) = 0.0D0
      NX      = KORSZ(Z) - OFFSET
      NZ      = NX
C
C     FORM AND DECOMPOSE THE LEFT HAND MATRIX
C
      ITYPAL   = RDP
      ITYPBT   = RDP
      ALPHA(1) = 1.0D0/DELTT**2
      BETA(1)  = 0.5D0/DELTT
      IFILC(4) = 6
      DO 10 I = 1,7
      IFILA(I) = FILEM(I)
   10 IFILB(I) = FILEB(I)
      IFILC(2) = FILEK(2)
      IFILC(1) = ISCR2
      IF (FILEK(1) .LE. 0) IFILC(1) = ISCR1
      IFILC(3) = FILEK(2)
      IF (IFILA(1).NE.0 .AND. IFILA(4).NE.6) IFILC(4) = SQR
      IF (IFILB(1).NE.0 .AND. IFILB(4).NE.6) IFILC(4) = SQR
      IFILC(5) = IPREC
      IF (FILEM(1).LE.0 .AND. FILEB(1).LE.0) GO TO 60
      CALL SADD (Z,Z)
      IF (FILEK(1) .LE. 0) GO TO 21
   11 DO 20 I = 1,7
      IFILA(I) = IFILC(I)
   20 IFILB(I) = FILEK(I)
      IF (IFILB(4) .NE. 6) IFILC(4) = SQR
      IFILC(1) = ISCR1
      ALPHA(1) = 1.0D0
      BETA(1)  = 1.0D0/3.0D0
      CALL SADD (Z,Z)
   21 CONTINUE
      CALL WRTTRL (IFILC)
      IF (IFILC(4) .NE. 6) GO TO 31
C
C     SET UP FOR SYMMETRIC DECOMPOSITION
C
      DO 32  I = 1,7
      IFA(I) = IFILC(I)
   32 CONTINUE
      IFL(1) = ISCR2
      IFU(1) = ISCR3
      ISC1   = ISCR4
      ISC2   = ISCR5
      ISC3   = ISCR6
      IFL(5) = IPREC
      ICHL   = 0
      NXX    = NX
      FILE   = IFA(1)
      CALL SDCOMP (*1030,Z,Z,Z)
      CALL WRTTRL (IFL)
      ISYM   = 0
      GO TO 33
C
C     SET UP FOR UNSYMMETRIC DECOMPOSITION
C
   31 CONTINUE
      ISYM = 1
      DO 30 I = 1,7
   30 IA(I)  = IFILC(I)
      IL(1)  = ISCR2
      IU(1)  = ISCR3
      ISCR10 = ISCR4
      ISCR20 = ISCR5
      ISCR30 = ISCR6
      IL(5)  = IPREC
      FILE   = IA(1)
      CALL DECOMP (*1030,Z(1),Z(1),Z(1))
      CALL WRTTRL (IL)
      CALL WRTTRL (IU)
C
C     FORM FIRST RIGHT HAND MATRIX
C
   33 CONTINUE
      DO 40 I = 1,7
   40 IFILA(I) = FILEM(I)
      ALPHA(1) = 2.0D0/DELTT**2
      BETA(1)  = -1.0D0/3.0D0
      IFILC(1) = ISCR1
      CALL SADD (Z,Z)
C
C     FORM SECOND RIGHT HAND MATRIX
C
      ALPHA(1) = -1.0D0/DELTT**2
      IFILC(1) = ISCR5
      CALL SADD (Z,Z)
      DO 50 I = 1,7
      IFILA(I) = IFILC(I)
   50 IFILB(I) = FILEB(I)
      ALPHA(1) = 1.0D0
      BETA(1)  = 0.5D0/DELTT
      IFILC(1) = ISCR4
      CALL SADD (Z,Z)
      RETURN
C
C     ERRORS
C
 1030 IP1 = -5
 1031 CALL MESAGE (IP1,FILE,NAME(1))
C
C     NO BDD OR MDD
C
   60 IF (FILEK(1) .LE. 0) GO TO 70
      IFILC(1) =0
      GO TO 11
C
C     ILLEGAL INPUT.   NO MATRICES
C
   70 IP1 = -7
      GO TO 1031
      END

      SUBROUTINE FNDPAR (NP2,INDEX)
C
C     FNDPAR FINDS THE INDEX INTO THE  VPS FOR PARAMETER NUMBER NP
C     IN THE CURRENT OSCAR (THIS PARAMETER MUST BE VARIABLE)
C
      EXTERNAL        ANDF
      INTEGER         OSCAR,NAME(2),ANDF
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /OSCENT/ OSCAR(7)
      COMMON /SYSTEM/ SYSBUF,NOUT
      COMMON /SEM   / MASK,MASK2,MASK3
      DATA    NAME  / 4HFNDP,4HAR  /
C
      NIP  = OSCAR(7)
      ITYPE= ANDF(OSCAR(3),7)
      I    = 8 + 3*NIP
      IF (ITYPE .EQ. 2) GO TO 100
      NOP  = OSCAR(I)
      I    = I + 3*NOP + 1
  100 CONTINUE
      I    = I + 1
      NP1  = OSCAR(I)
      NP   = IABS(NP2)
      IF (NP .LE. NP1) GO TO 120
      IF (NP2 .LE.  0) GO TO 200
      WRITE  (NOUT,110) UFM,NP
  110 FORMAT (A23,' 3123, PARAMETER NUMBER',I6,' NOT IN DMAP CALL.')
      CALL MESAGE (-61,0,NAME)
  120 CONTINUE
      NP1 = NP - 1
      K   = I + 1
      IF (NP1 .EQ. 0) GO TO 170
      DO 130 I = 1,NP1
      M   = OSCAR(K)
      IF (M) 140,150,150
C
C     VARTABLE
C
  140 K = K + 1
      GO TO 130
C
C     CONSTANT
C
  150 K = K + 1 + M
  130 CONTINUE
C
C     K POINTS  TO WANTED OSCAR WORD
C
  170 IF (OSCAR(K) .LT. 0) GO TO 190
      IF (NP2 .LE. 0) GO TO 200
      WRITE  (NOUT,180) UFM,NP
  180 FORMAT (A23,' 3124, PARAMETER NUMBER',I6,' IS NOT A VARIABLE.')
      CALL MESAGE (-61,0,NAME)
  190 INDEX = ANDF(OSCAR(K),MASK3)
      RETURN
C
C     PARAMETER SPORT NOT SUPPLIES
C
  200 INDEX = -1
      RETURN
      END

      SUBROUTINE MRED2C (KODE)
C
C     THIS SUBROUTINE PROCESSES THE OLDMODES OPTION FLAG FOR THE MRED2
C     MODULE.
C
C     INPUT DATA
C     GINO - LAMAMR   - EIGENVALUE TABLE  FOR SUBSTRUCTURE BEING REDUCED
C            PHISS    - EIGENVCTOR MATRIX FOR SUBSTRUCTURE BEING REDUCED
C     SOF  - LAMS     - EIGENVALUE  TABLE FOR ORIGINAL SUBSTRUCTURE
C            PHIS     - EIGENVCTOR  TABLE FOR ORIGINAL SUBSTRUCTURE
C
C     OUTPUT DATA
C     GINO - LAMAMR   - EIGENVALUE TABLE  FOR SUBSTRUCTURE BEING REDUCED
C            PHISS    - EIGENVCTOR MATRIX FOR SUBSTRUCTURE BEING REDUCED
C     SOF  - LAMS     - EIGENVALUE TABLE  FOR ORIGINAL SUBSTRUCTURE
C            PHIS     - EIGENVCTOR MATRIX FOR ORIGINAL SUBSTRUCTURE
C
C     PARAMETERS
C     INPUT  - GBUF   - GINO BUFFER
C              INFILE - INPUT FILE NUMBERS
C              ISCR   - SCRATCH FILE NUMBERS
C              KORBGN - BEGINNING ADDRESS OF OPEN CORE
C              OLDNAM - NAME OF SUBSTRUCTURE BEING REDUCED
C              MODES  - OLDMODES OPTION FLAG
C              LAMAAP - BEGINNING ADDRESS OF LAMS RECORD TO BE APPENDED
C              NFOUND - NUMBER OF MODAL POINTS USED
C              MODLEN - LENGTH OF MODE USE ARRAY
C     OTHERS - LAMAMR - LAMAMR INPUT FILE NUMBER
C              PHIS   - PHIS INPUT FILE NUMBER
C              LAMS   - LAMS INPUT FILE NUMBER
C              PHISS  - PHISS INPUT FILE NUMBER
C
      LOGICAL         MODES
      INTEGER         DRY,GBUF1,OLDNAM,Z,PHIS,PHISS,RGDFMT
      DIMENSION       MODNAM(2),ITMLST(2)
      COMMON /BLANK / IDUM1,DRY,IDUM7,GBUF1,IDUM2(5),INFILE(12),
     1                IDUM3(6),ISCR(10),KORLEN,KORBGN,OLDNAM(2),
     2                IDUM5(9),MODES,IDUM6,LAMAAP,NFOUND,MODLEN
      COMMON /ZZZZZZ/ Z(1)
      COMMON /SYSTEM/ IDUM4,IPRNTR
      EQUIVALENCE     (LAMAMR,INFILE(2)),(PHIS,INFILE(3)),
     1                (LAMS,ISCR(5)),(PHISS,ISCR(6))
      DATA    MODNAM/ 4HMRED,4H2C  /
      DATA    ITMLST/ 4HPHIS,4HLAMS/
      DATA    RGDFMT/ 3 /
C
C     TEST OPERATION FLAG
C
      IF (DRY .EQ. -2) GO TO 200
      IF (KODE .GT. 1) GO TO 20
C
C     TEST OLDMODES OPTION FLAG
C
      IF (MODES) GO TO 10
C
C     STORE GINO PHIS AS PHIS ON SOF
C
      IFILE = PHIS
      CALL MTRXO (PHIS,OLDNAM,ITMLST(1),0,ITEST)
      ITEM  = ITMLST(1)
      IF (ITEST .NE. 3) GO TO 120
      GO TO 200
C
C     READ SOF PHIS ONTO GINO PHIS SCRATCH FILE
C
   10 CALL MTRXI (PHISS,OLDNAM,ITMLST(1),0,ITEST)
      ITEM = ITMLST(1)
      IF (ITEST .NE. 1) GO TO 120
C
C     READ SOF LAMS ONTO GINO LAMAMR SCRATCH FILE
C
      CALL SFETCH (OLDNAM,ITMLST(2),1,ITEST)
      ITEM = ITMLST(2)
      IF (ITEST .GT. 1) GO TO 120
      CALL GOPEN  (LAMS,Z(GBUF1),1)
      CALL SUREAD (Z(KORBGN),-1,NWDSRD,ITEST)
      CALL WRITE  (LAMS,Z(KORBGN),NWDSRD,1)
      CALL SUREAD (Z(KORBGN),-1,NWDSRD,ITEST)
      CALL WRITE  (LAMS,Z(KORBGN),NWDSRD,1)
      CALL CLOSE  (LAMS,1)
C
C     SWITCH FILE NUMBERS
C
      PHIS   = PHISS
      LAMAMR = LAMS
      GO TO 200
C
C     STORE LAMAMR (TABLE) AS LAMS ON SOF
C
   20 IF (MODES) GO TO 70
      ITEM = ITMLST(2)
      CALL DELETE (OLDNAM,ITEM,ITEST)
      IF (ITEST.EQ.2 .OR. ITEST.GT.3) GO TO 120
      IFILE = LAMAMR
      CALL GOPEN (LAMAMR,Z(GBUF1),0)
      CALL FWDREC (*100,LAMAMR)
      ITEST = 3
      CALL SFETCH (OLDNAM,ITMLST(2),2,ITEST)
      IF (ITEST .NE. 3) GO TO 120
      DO 30 I = 1,2
   30 Z(KORBGN+I-1) = OLDNAM(I)
      Z(KORBGN+2  ) = RGDFMT
      Z(KORBGN+3  ) = MODLEN
      CALL SUWRT (Z(KORBGN),4,2)
      LAMWDS = MODLEN - 1
      IF (LAMWDS .LT. 1) GO TO 55
      DO 50 I = 1,LAMWDS
      CALL READ  (*90,*100,LAMAMR,Z(KORBGN),7,0,NWDS)
   50 CALL SUWRT (Z(KORBGN),7,1)
   55 CALL READ  (*90,*100,LAMAMR,Z(KORBGN),7,0,NWDS)
      CALL CLOSE (LAMAMR,1)
      CALL SUWRT (Z(KORBGN),7,2)
      IF (KODE .EQ. 3) GO TO 60
      CALL SUWRT (Z(LAMAAP),MODLEN,2)
      CALL SUWRT (Z(LAMAAP),0,3)
      GO TO 70
   60 DO 65 I = 1,MODLEN
   65 Z(KORBGN+I-1) = 1
      CALL SUWRT (Z(KORBGN),MODLEN,2)
      CALL SUWRT (Z(KORBGN),0,3)
   70 CONTINUE
      GO TO 200
C
C     PROCESS SYSTEM FATAL ERRORS
C
   90 IMSG = -2
      GO TO 110
  100 IMSG = -3
  110 CALL SOFCLS
      CALL MESAGE (IMSG,IFILE,MODNAM)
      GO TO 200
C
C     PROCESS MODULE FATAL ERRORS
C
  120 GO TO (130,135,140,150,160,180), ITEST
  130 IMSG = -9
      GO TO 190
  135 ISMG = -11
      GO TO 190
  140 IMSG = -1
      GO TO 170
  150 IMSG = -2
      GO TO 170
  160 IMSG = -3
  170 CALL SMSG (IMSG,ITEM,OLDNAM)
      GO TO 200
  180 IMSG = -10
  190 DRY  = -2
      CALL SMSG1 (IMSG,ITEM,OLDNAM,MODNAM)
  200 RETURN
      END

      SUBROUTINE TERMSS (NNODE,GPTH,EPNORM,EGPDT,IORDER,MMN,BTERMS)
C
C     SINGLE PRECISION ROUTINE TO CALCULATE B-MATRIX TERMS
C     FOR ELEMENTS  QUAD4, QUAD8 AND TRIA6.
C
C     THE INPUT FLAG LETS THE SUBROUTINE SWITCH BETWEEN QUAD4,
C     QUAD8 AND TRIA6 VERSIONS
C
C     ELEMENT TYPE FLAG (LTYPFL) = 1  FOR QUAD4,
C                                = 2  FOR TRIA6 (NOT AVAILABLE),
C                                = 3  FOR QUAD8 (NOT AVAILABLE).
C
C     THE OUTPUT CONSISTS OF THE DETERMINANT OF THE JACOBIAN
C     (DETJ), SHAPE FUNCTIONS AND THEIR DERIVATIVES. THE OUTPUT
C     PARAMETER, BADJAC, IS AN INTERNAL LOGICAL FLAG TO THE CALLING
C     ROUTINE INDICATING THAT THE JACOBIAN IS NOT CORRECT.
C     PART OF THE INPUT IS PASSED TO THIS SUBROUTINE THROUGH THE
C     INTERNAL COMMON BLOCK  /COMJAC/.
C
      LOGICAL          BADJAC
      INTEGER          MMN(1),LTYPFL,IORDER(1),INDEX(3,3)
      REAL             EGPDT(4,1),EPNORM(4,1)
      REAL             XI,ETA,ZETA,DETJ,SHP(8),JACOB(3,3),DSHPX(8),
     1                 DSHPE(8),DSHP(16),TSHP(8),TDSHP(16),BTERMS(1),
     2                 DUM,TEMP,EPS,TIE(9),TJ(3,3),VN(3),CJAC,GPTH(1),
     3                 TH,GRIDC(3,8)
      COMMON /COMJAC/  XI,ETA,ZETA,DETJ,BADJAC,LTYPFL
      COMMON /CJACOB/  CJAC(19)
      EQUIVALENCE      (DSHPX(1),DSHP(1)), (DSHPE(1),DSHP(9) )
      EQUIVALENCE      (VN(1)   ,CJAC(8)), (TIE(1)  ,CJAC(11))
      EQUIVALENCE      (TH      ,CJAC(1))
C
      EPS = 1.0E-15
      BADJAC = .FALSE.
C
      GO TO (10,30,20), LTYPFL
C
C     QUAD4 VERSION
C
   10 NGP = 4
      CALL Q4SHPS (XI,ETA,SHP,DSHP)
      GO TO 40
C
C     QUAD8 VERSION
C
   20 NGP = 8
      GO TO 40
C
C     TRIA6 VERSION
C
   30 NGP = 6
C
   40 DO 50 I = 1,NGP
      TSHP (I  ) = SHP(I)
      TDSHP(I  ) = DSHP(I)
   50 TDSHP(I+8) = DSHP(I+NGP)
      DO 60 I = 1,NGP
      IO = IORDER(I)
      SHP (I  ) = TSHP(IO)
      DSHP(I  ) = TDSHP(IO)
   60 DSHP(I+8) = TDSHP(IO+8)
C
      TH = 0.0
      DO 70 I = 1,NNODE
      TH = TH + GPTH(I)*SHP(I)
      DO 70 J = 1,3
      J1 = J + 1
      GRIDC(J,I) = EGPDT(J1,I) + ZETA*GPTH(I)*EPNORM(J1,I)*0.5
   70 CONTINUE
C
      DO 80 I = 1,2
      II = (I-1)*8
      DO 80 J = 1,3
      TJ(I,J) = 0.0
      DO 80 K = 1,NNODE
      TJ(I,J) = TJ(I,J) + DSHP(K+II)*GRIDC(J,K)
   80 CONTINUE
C
      DO 90 I = 1,3
      TJ(3,I) = 0.0
      DO 90 J = 1,NNODE
   90 TJ(3,I) = TJ(3,I) + 0.5*GPTH(J)*SHP(J)*EPNORM(I+1,J)
C
      DO 100 I = 1,3
      DO 100 J = 1,3
      IF (ABS(TJ(I,J)) .LT. EPS) TJ(I,J) = 0.0
  100 CONTINUE
C
C     SET UP THE TRANSFORMATION FROM THIS INTEGRATION POINT C.S.
C     TO THE ELEMENT C.S.  TIE
C
      VN(1) = TJ(1,2)*TJ(2,3) - TJ(2,2)*TJ(1,3)
      VN(2) = TJ(2,1)*TJ(1,3) - TJ(1,1)*TJ(2,3)
      VN(3) = TJ(1,1)*TJ(2,2) - TJ(2,1)*TJ(1,2)
C
      TEMP = SQRT(VN(1)*VN(1) + VN(2)*VN(2) + VN(3)*VN(3))
C
      TIE(7) = VN(1)/TEMP
      TIE(8) = VN(2)/TEMP
      TIE(9) = VN(3)/TEMP
C
      TEMP = SQRT(TIE(8)*TIE(8) + TIE(9)*TIE(9))
C
      TIE(1) = TIE(9)/TEMP
      TIE(2) = 0.0
      TIE(3) =-TIE(7)/TEMP
C
      TIE(4) = TIE(8)*TIE(3)
      TIE(5) = TEMP
      TIE(6) =-TIE(1)*TIE(8)
C
      CALL INVERS (3,TJ,3,DUM,0,DETJ,ISING,INDEX)
C
C
C     NOTE - THE INVERSE OF JACOBIAN HAS BEEN STORED IN TJ
C            UPON RETURN FROM INVERS.
C
      IF (ISING.EQ.1 .AND. DETJ.GT.0.0) GO TO 110
      BADJAC = .TRUE.
      GO TO 150
C
  110 CONTINUE
C
      DO 120 I = 1,3
      II = (I-1)*3
      DO 120 J = 1,3
      JACOB(I,J) = 0.0
      DO 120 K = 1,3
      IK = II + K
  120 JACOB(I,J) = JACOB(I,J) + TIE(IK)*TJ(K,J)
C
C     MULTIPLY THE INVERSE OF THE JACOBIAN BY THE TRANSPOSE
C     OF THE ARRAY CONTAINING DERIVATIVES OF THE SHAPE FUNCTIONS
C     TO GET THE TERMS USED IN THE ASSEMBLY OF THE B MATRIX.
C     NOTE THAT THE LAST ROW CONTAINS THE SHAPE FUNCTION VALUES.
C
      NODE3 = NNODE*3
      DO 130 I = 1,NNODE
  130 BTERMS(NODE3+I) = SHP(I)*JACOB(3,3)
C
      DO 140 I = 1,3
      II = (I-1)*NNODE
      DO 140 J = 1,NNODE
      IJ = II + J
      BTERMS(IJ) = 0.0
      DO 140 K = 1,2
      IK = (K-1)*8
  140 BTERMS(IJ) = BTERMS(IJ) + JACOB(I,K)*DSHP(IK+J)
  150 RETURN
      END

      SUBROUTINE ALG13 (IBL,YS,YP,XS,XP,YSEMI,XSEMI,LOG1,LOG2,N,IPRINT,
     1                BETA1,BETA2,P,Q,YZERO,T,YONE,XDEL,YDEL,Z,AXIALC,
     2                LNCT,IFCORD,SQ,SB,ISECN,XSEMJ,YSEMJ,ISTAK,XHERE,
     3                X,SS,NSTNS,R,DX,Y,DY,SS1,BX,SIGMA,CCORD,ISPLIT,
     4                YZEROS,TS,YONES,ZSPMXT,PERSPJ,INAST,IRLE,IRTE,
     5                THARR)
C
      REAL            IX,IY,IXY,IPX,IPY,IXD,IYD,IXN,IYN,IXYN
      DIMENSION       CCORD(1),NAME(2),XXM(81),SNADUM(10),THARR(21,10)
      DIMENSION       YS(21,80),YP(21,80),XS(21,80),XP(21,80),
     1                YSEMI(21,31),XSEMI(21,31),S(80),PHI(11),
     2                THICK2(80),XM(81),YM(80),AM(80),XSEMJ(21,31),
     3                YSEMJ(21,31),XHERE(100),X(100),SS(100),R(10,21),
     4                DX(100),DY(100),SS1(80,4),Y(100),SIGMA(100)
      DIMENSION       XSPLTM(45),YSPLTM(45),SSPLTM(45),XSPLTS(45),
     1                YSPLTS(45),XSPLTP(45),YSPLTP(45),THICK(45)
      COMMON /UDSTR2/ NBLDES,STAG(21),CHORDD(21)
      DATA    NAME  / 4HALG1, 4H3    /
C
      F1(A) = A*EXP(1.0-A*SQ)*SQ
      F2(A) = (SQ-1.0)*A*EXP(1.0+A*(1.0-SQ))
      F3(A,B,C,D) = B/A**3*EXP(A*XD)*(A*XD-2.0) + C*(XD+SQ) + D
      F4(A,B) = ABS(A-B)/(A-B)
      F5(A,B,C) = B/A**2*EXP(A*XD)*(A*XD-1.0) + C
      F6(XAB) = SQRT(RDIUS**2-(XAB-X1)**2) + Y1
      F7(XAB) =-SQRT(RDIUS**2-(XAB-X1)**2) + Y1
      F8(XAB) =-1./SQRT(RDIUS**2-(XAB-X1)**2)*(XAB-X1)
C
10    FORMAT (1H1)
      A    = 0.
      D    = 0.
      BTA1 = BETA1
      BTA2 = BETA2
      BETA3= 0.0
      PI   = 3.1415926535
      C1   = 180.0/PI
      IF (IPRINT .GE. 2) GO TO 40
      WRITE  (LOG2,20) IBL,P,Q,BETA1,BETA2,YZERO,T,YONE,Z,AXIALC
20    FORMAT (1H1,44X,43HSTREAMSURFACE GEOMETRY ON STREAMLINE NUMBER,I3,
     1 /45X,46(1H*), //20X,1HP,1
     25X,1H=,F7.4,6X,72H(D2YDX2 OF MEANLINE AT LEADING EDGE AS A FRACTIO
     3N OF ITS MAXIMUM VALUE.), /20X,1HQ,15X,1H=,F7.4,6X,73H(D2YDX2 OF M
     4EANLINE AT TRAILING EDGE AS A FRACTION OF ITS MAXIMUM VALUE.), /20
     5X,5HBETA1,11X,1H=,F7.3,6X,20H(BLADE INLET ANGLE.), /20X,5HBETA2,11
     6X,1H=,F7.3,6X,21H(BLADE OUTLET ANGLE.), /20X,5HYZERO,11X,1H=,F8.5,
     75X,51H(BLADE LEADING EDGE RADIUS AS A FRACTION OF CHORD.), /20X,1H
     8T,15X,1H=,F8.5,5X,49H(BLADE MAXIMUM THICKNESS AS A FRACTION OF CHO
     9RD.), /20X,4HYONE,12X,1H=,F8.5,5X,60H(BLADE TRAILING EDGE HALF-THI
     OCKNESS AS A FRACTION OF CHORD.), /20X,1HZ,15X,1H=,F7.4,6X,59H(LOCA
     1TION OF MAXIMUM THICKNESS AS A FRACTION OF MEAN LINE.), /20X,4HCOR
     2D,12X,1H=,F7.4,6X,39H(CHORD OR MERIDIONAL CHORD OF SECTION.))
      IF (ISECN.EQ.1 .OR. ISECN.EQ.3) WRITE (LOG2,30) SQ,SB
30    FORMAT (20X,1HS,15X,1H=,F7.4,6X,53H(INFLECTION POINT AS A FRACTION
     1 OF MERIDIONAL CHORD.), /20X,5HBETA3,11X,1H=,F7.3,6X,36H(CHANGE IN
     2 ANGLE FROM LEADING EDGE.))
   40 IF (IPRINT .EQ. 3) GO TO 55
      LNCT = LNCT + 2
      IF (LNCT .LE. 60)GO TO 45
      LNCT = 3
      WRITE  (LOG2,10)
45    WRITE  (LOG2,50) IBL,P,Q,BETA1,BETA2,YZERO,T,YONE,Z,AXIALC
50    FORMAT (2X, /5X,4HLINE,I3,4H  P=,F7.4,4H  Q=,F7.4,8H  BETA1=,F7.3,
     18H  BETA2=,F7.3,8H  YZERO=,F7.5,6H  T/C=,F7.5,7H  YONE=,F7.5,4H  Z
     2=,F7.4,6H  AXC=,F7.3)
55    IF (ISECN .EQ. 1) GO TO 60
      IF (ISECN .EQ. 3) GO TO 130
      IF (ISECN .EQ. 2) GO TO 150
      H  = 1.0/(1.0+SQRT((1.0-Q)/(1.0-P)))
      HH = H*H
      OA = 4.0*(TAN(BETA1/C1)-TAN(BETA2/C1))/(P/(1.0-P)*HH+H-1.0/3.0)
      OA48 = OA/48.0
      XK2  =-HH/(8.0*(1.0-P))*OA
      B    = HH*H/12.0*OA+TAN(BETA1/C1)
      C    =-HH*HH*OA48
      XMLC = SQRT(1.0+(OA48*(1.0-H)**4+XK2+B+C)**2)
      GO TO 160
60    NQ = 1
      SB = BETA1+SB
      G1 = 1.0/SQ
      R1 = F1(G1)
      G2 = G1+5.0
      R2 = F1(G2)
      S2 = F4(R2,P)
70    G3 = G2+(P-R2)*(G2-G1)/(R2-R1)
      R3 = F1(G3)
      S3 = F4(R3,P)
      IF (ABS(R3-P) .LE. 0.0001) GO TO 90
      IF (NQ .GT. 50) GO TO 1290
      NQ = NQ + 1
      IF (ABS(S2-S3) .LE. 0.0001) GO TO 80
      G1 = G3
      R1 = R3
      GO TO 70
80    G2 = G3
      R2 = R3
      S2 = S3
      GO TO 70
90    A1 = G3
      NQ = 1
      G1 = 1.0/(SQ-1.0)
      R1 = F2(G1)
      G2 = G1-5.0
      R2 = F2(G2)
      S2 = F4(R2,Q)
100   G3 = G2+(Q-R2)*(G2-G1)/(R2-R1)
      R3 = F2(G3)
      S3 = F4(R3,Q)
      IF (ABS(R3-Q) .LE. 0.0001) GO TO 120
      IF (NQ .GT. 50) GO TO 1290
      NQ = NQ + 1
      IF (ABS(S2-S3) .LE. 0.0001) GO TO 110
      G1 = G3
      R1 = R3
      GO TO 100
110   G2 = G3
      R2 = R3
      S2 = S3
      GO TO 100
120   A2 = G3
      B1 = A1**2*(TAN(BETA1/C1)-TAN(SB/C1))/
     1     (1.0-(A1*SQ+1.0)*EXP(-A1*SQ))
      CC1= TAN(SB/C1)+B1/A1**2
      E1 = (A1*SQ+2.0)*B1/A1**3*EXP(-A1*SQ)
      B2 = A2**2*(TAN(BETA2/C1)-TAN(SB/C1))/
     1     (1.0+(A2*(1.0-SQ)-1.0)*EXP(A2*(1.0-SQ)))
      CC2= TAN(SB/C1)+B2/A2**2
      D2 = 2.*(B2/A2**3-B1/A1**3)+SQ*(CC1-CC2) + E1
      XD = 1.0-SQ
      R2 = F3(A2,B2,CC2,D2)
      XMLC = SQRT(1.0+R2**2)
      GO TO 160
130   I1 = 1
      BETA3 = BETA1+SB
      S0 = 0.
      X0 = 0.
      Y0 = 0.
      Y21= 0.0
      I2 = FLOAT(N)*SQ
      IF (I2 .LE. 1) SQ = 0.0
      IF (I2 .LE. 1) BETA3 = BETA1
      IF (I2 .LE. 1) GO TO 140
      XRNGE = SQ
      FACT  = SQ
      CALL ALG18 (BETA1,BETA3,I1,I2,FACT,X0,Y0,S0,XRNGE,Y11,X11,Y21,
     1            RDIUS1,S,C1)
      I1 = I2
      X0 = SQ
      Y0 = Y21
      S0 = S(I1)
140   I2 = N
      FACT  = 1.-SQ
      XRNGE = FACT
      CALL ALG18 (BETA3,BETA2,I1,I2,FACT,X0,Y0,S0,XRNGE,Y12,X12,Y22,
     1            RDIUS2,S,C1)
      XMLC = SQRT(1.0+Y22**2)
      GO TO 160
150   CALL ALG18 (BETA1,BETA2,1,N,1.0,0.0,0.0,0.0,1.0,Y1,X1,Y2,RDIUS,
     1            S,C1)
      XMLC  = SQRT(1.+Y2**2)
      CHORD = XMLC/(1.-2.*YZERO*(1.-XMLC))
      FCSLMN= 1.0 - CHORD*2.*YZERO
      GO TO 170
160   CHORD = XMLC/(1.0-YZERO+XMLC*(YZERO+ABS(YONE*SIN(BETA2/C1))))
      FCSLMN= 1.0 - CHORD*(YZERO+ABS(YONE*SIN(BETA2/C1)))
170   IF (IFCORD .EQ. 1) AXIALC = AXIALC/CHORD
      YZERO = YZERO*CHORD/FCSLMN
      YONE  = YONE*CHORD/FCSLMN
      T   = T*CHORD/FCSLMN
      S(1)= 0.0
      XX  = 0.0
      XN  = N
      IF (ISECN .EQ. 2) GO TO 240
      AT = (YZERO-T/2.0)/(2.0*Z**3)
      CT = (T/2.0-YZERO)*3.0/(2.0*Z)
      DT = YZERO
      ET = (YONE-T/2.0)/(1.0-Z)**3 - 1.5*(YZERO-T/2.0)/(Z**2*(1.0-Z))
      FT = 1.5*(YZERO-T/2.0)/Z**2
      HT = T/2.0
      IF (ISECN .EQ. 3) GO TO 240
      DELX = 1.0/(10.0*(XN-1.0))
      ASSIGN 190 TO ISEC1
      ASSIGN 290 TO ISEC2
      IF (ISECN .EQ. 0) GO TO 180
      ASSIGN 200 TO ISEC1
      ASSIGN 300 TO ISEC2
180   DO 230 J  = 2,N
      DO 220 JJ = 1,11
      GO TO ISEC1, (190,200)
190   PHI(JJ) = SQRT(1.0+(OA/12.0*(XX-H)**3+XK2*2.0*XX+B)**2)
      GO TO 220
200   XD = XX - SQ
      IF (XD .GT. 0.0) GO TO 210
      PHI(JJ) = SQRT(1.0+(F5(A1,B1,CC1))**2)
      GO TO 220
210   PHI(JJ) = SQRT(1.+(F5(A2,B2,CC2))**2)
220   XX = XX + DELX
      XX = XX - DELX
230   S(J) = S(J-1)+ (PHI(1)+ PHI(11)+ 4.0*(PHI(2)+PHI(4)+PHI(6)+PHI(8)+
     1       PHI(10))+2.0*(PHI(3)+PHI(5)+PHI(7)+PHI(9)))/(30.0*(XN-1.0))
240   DELX = 1.0/(XN-1.0)
      IF (ISECN .NE. 2) GO TO 250
      T2 = T/2.
      TPRIM2 = T2 - YZERO
      C2 = 2.*C1
      AFORM = (TPRIM2+RDIUS*(1.-COS((BETA1-BETA2)/C2)))/XMLC*2.
      PHIS  = ACOS((1.-AFORM**2)/(1.+AFORM**2))
      RS    = YZERO + XMLC/2./SIN(PHIS)
      YSS   = RDIUS - RS + T2
      BFORM = (RDIUS*(1.-COS((BETA1-BETA2)/C2))-TPRIM2)/XMLC*2.
      PHIP  = ACOS((1.-BFORM**2)/(1.+BFORM**2))
      PHI2  = ABS((BETA1-BETA2)/C1)
250   XM(1) = 0.0
      IF (ISECN .NE. 3) GO TO 260
      YMM = 0.0
      XMM = 0.0
      I2  = SQ*FLOAT(N)
      I3  = I2
      IF (I2 .LE.  1) I2 = N + 1
      DELX= SQ/FLOAT(I2-1)
      IF (I3 .NE. I2) I3 = 1
      DELXX = (1.-SQ)/FLOAT(N-I3)
      IF (I2 .EQ. N+1) DELX = DELXX
260   DO 380 J = 1,N
      SN = S(J)/S(N)
      IF (ISECN .EQ. 2) GO TO 340
      IF (SN    .GT. Z) GO TO 270
      THICK2(J) = (AT*SN**2+CT)*SN + DT
      GO TO 280
270   SN = SN - Z
      THICK2(J) = (ET*SN+FT)*SN**2 + HT
280   IF (ISECN .EQ. 3) GO TO 320
      GO TO ISEC2, (290,300)
290   YM(J)  = OA48*(XM(J)-H)**4+XK2*XM(J)**2 + B*XM(J) + C
      YPRIME = OA/12.0*(XM(J)-H)**3 + XK2*2.0*XM(J) + B
      GO TO 370
300   XD = XM(J) - SQ
      IF (XD .GT. 0.0) GO TO 310
      YM(J)  = F3(A1,B1,CC1,E1)
      YPRIME = F5(A1,B1,CC1)
      GO TO 370
310   YM(J)  = F3(A2,B2,CC2,D2)
      YPRIME = F5(A2,B2,CC2)
      GO TO 370
320   IF (XM(J)-SQ.GT.0.0 .OR. XM(J).EQ.0.0 .AND. SQ.EQ.0.0) GO TO 330
      IF (BETA1 .EQ. BETA3) GO TO 360
      BTA1  = BETA1
      BTA2  = BETA3
      RDIUS = RDIUS1
      Y1 = Y11
      X1 = X11
      GO TO 350
330   IF (BETA2 .EQ. BETA3) GO TO 360
      RDIUS = RDIUS2
      X1 = X12
      Y1 = Y12
      BTA1 = BETA3
      BTA2 = BETA2
      GO TO 350
340   PHIX = (SN-0.5)*PHI2
      THICK2(J) = YSS*COS(PHIX) + SQRT(RS**2-YSS**2*SIN(PHIX)**2) -RDIUS
350   YM(J)  = F6(XM(J))
      YPRIME = F8(XM(J))
      IF (BTA1-BTA2 .LT. 0.0) YPRIME = -YPRIME
      IF (BTA1-BTA2 .LT. 0.0) YM(J) = F7(XM(J))
      IF (ISECN .EQ. 2) GO TO 370
      IF (J .EQ. I3) DELX = DELXX
      GO TO 370
360   YPRIME = TAN(BETA3/C1)
      IF (J .NE. 1) XMM = XM(J-1)/FCSLMN - YZERO
      IF (J .NE. 1) YMM = YM(J-1)/FCSLMN
      YM(J) = YPRIME*(XM(J)-XMM) + YMM
      IF (J .EQ. I3) DELX = DELXX
370   XM(J+1) = XM(J) + DELX
      FYPR = 1.0/SQRT(1.0+YPRIME**2)
      XS(IBL,J) = (XM(J)-THICK2(J)*YPRIME*FYPR+YZERO)*FCSLMN
      YS(IBL,J) = (YM(J)+THICK2(J)*FYPR)*FCSLMN
      XP(IBL,J) = (XM(J)+THICK2(J)*YPRIME*FYPR+YZERO)*FCSLMN
      YP(IBL,J) = (YM(J)-THICK2(J)*FYPR)*FCSLMN
      AM(J)  = ATAN(YPRIME)*C1
      XXM(J) = XM(J)
      IF(J .EQ. N) STAGER = ATAN(YM(N)/XM(N))*C1
      IF(J .EQ. N) STAG(IBL) = STAGER
      XM(J) = (XM(J)+YZERO)*FCSLMN
      YM(J) = YM(J)*FCSLMN
      THICK2(J) = THICK2(J)*FCSLMN
380   S(J) = S(J)*FCSLMN
      IF (ISPLIT .EQ. 0) GO TO 530
      XSPLTM(1) = 1. - PERSPJ
      K1 = 25
      XSPLTM(K1) = 1.
      K11 = K1 - 1
      DELXX = PERSPJ/FLOAT(K11)
      DO 390 J = 2,K11
390   XSPLTM(J) = XSPLTM(J-1) + DELXX
      CALL ALG15 (XM,YM,N,XSPLTM,YSPLTM,K1,1)
      YLE = YSPLTM(1)
      CALL ALG15 (XM,S,N,XSPLTM,SSPLTM,K1,1)
      CALL ALG15 (XM,AM,N,XSPLTM,SS1(1,3),K1,1)
      SSPLS = SSPLTM(1)
      DO 400 J = 1,K1
400   SSPLTM(J) = SSPLTM(J) - SSPLS
      GO TO (410,420), ISPLIT
410   XNORMS = SQRT((XSPLTM(K1)-XSPLTM(1))**2+(YSPLTM(K1)-YSPLTM(1))**2)
      CHORDS = XNORMS/(1.-YZEROS+XNORMS*(YZEROS+ABS(YONES*SIN(BETA2/
     1         C1))))
      FCSLMS = (PERSPJ-CHORDS*(YZEROS+ABS(YONES*SIN(BETA2/C1))))/PERSPJ
      YZEROS = YZEROS*CHORDS/FCSLMS
      YONES  = YONES *CHORDS/FCSLMS
      TS  = TS*CHORDS/FCSLMS
      AT  = (YZEROS-TS/2.)/(2.*ZSPMXT**3)
      CT  = (TS/2.-YZEROS)*3./(2.*ZSPMXT)
      DT  = YZEROS
      ET  = (YONES-TS/2.)/(1.-ZSPMXT)**3-1.5*(YZEROS-TS/2.)/
     1      (ZSPMXT**2*(1.-ZSPMXT))
      FT  = 1.5*(YZEROS-TS/2.)/ZSPMXT**2
      HT  = TS/2.
      GO TO 450
420   YZS = YZEROS
      TS1 = TS
      BETA1 = SS1(1,3)
      Y1  =-COS(BETA1/C1)/(SIN(BETA1/C1)-SIN(BETA2/C1))
      X1  = SIN(BETA1/C1)/(SIN(BETA1/C1)-SIN(BETA2/C1))
      RDIUS = ABS(1./(SIN(BETA1/C1)-SIN(BETA2/C1)))
      Y2  = TAN((BETA1+BETA2)/(2.*C1))
      XMLCS  = SQRT(1.+Y2**2)
      CHORDS = XMLCS/(1.0-2.*YZEROS*(1.0-XMLCS))
      FCSLMS = 1.0-CHORDS*2.*YZEROS
      YZEROS = YZEROS*CHORDS/FCSLMS
      TS  = TS*CHORDS/FCSLMS
      SS1(1,1) = 0.
      DELX  = 1./(XN-1.)
      T2    = TS/2.
      TPRIM2= T2-YZEROS
      C2    = 2.*C1
      AFORM = (TPRIM2+RDIUS*(1.-COS((BETA1-BETA2)/C2)))/XMLCS*2.
      PHIS  = ACOS((1.-AFORM**2)/(1.+AFORM**2))
      RS    = YZEROS + XMLCS/2./SIN(PHIS)
      YSS   = RDIUS - RS + T2
      BFORM = (RDIUS*(1.-COS((BETA1-BETA2)/C2))-TPRIM2)/XMLCS*2.
      PHIP  = ACOS((1.-BFORM**2)/(1.+BFORM**2))
      RP    = XMLCS/2./SIN(PHIP)-YZEROS
      YPP   = RDIUS - RP - T2
      XX = 0.
      DO 430 J = 2,N
      XX = XX + DELX
      PHI1 = ATAN(-1./SQRT(RDIUS**2-(XX-X1)**2)*(XX-X1))
      IF (BETA1 .LT. 0.) PHI1 = -PHI1
      PHI2 = ABS(BETA1/C1-PHI1)
430   SS1(J,1) = RDIUS*PHI2
      DO 440 J = 1,N
      SS1(J,1) = SS1(J,1)/SS1(N,1)
      PHIX = (SS1(J,1)-.5)*PHI2
440   SS1(J,2) =(YSS*COS(PHIX)+SQRT(RS**2-YSS**2*SIN(PHIX)**2)-RDIUS)/T2
      CALL ALG14 (XSPLTM,YSPLTM,K1,XSPLTM,XDUM,SS1(1,3),K1,1)
      XNORMS = SQRT(PERSPJ**2+(YSPLTM(K1)-YSPLTM(1))**2)
      CHORDS = XNORMS/(1.-2.*YZS*(1.-XNORMS))
      FCSLMS = (PERSPJ-CHORDS*2.*YZS)/PERSPJ
      TS     = TS1*CHORDS/FCSLMS
      YZEROS = YZS*CHORDS/FCSLMS
450   DO 500 J = 1,K1
      SN = SSPLTM(J)/SSPLTM(K1)
      IF (ISPLIT  .GT. 1) GO TO 480
      IF (SN .GT. ZSPMXT) GO TO 460
      THICK(J) = (AT*SN**2+CT)*SN + DT
      GO TO 470
460   SN = SN - ZSPMXT
      THICK(J) = (ET*SN+FT)*SN**2 + HT
470   FYPR   = 1./SQRT(1.+TAN(SS1(J,3)/C1)**2)
      YPRIME = TAN(SS1(J,3)/C1)
      GO TO 490
480   CALL ALG15 (SS1,SS1(1,2),N,SN,THICK(J),1,1)
      THICK(J) = THICK(J)*TS/2.
      FYPR   = 1.0/SQRT(1.0+SS1(J,3)**2)
      YPRIME = SS1(J,3)
490   XSPLTP(J) = (XSPLTM(J)-(1.-PERSPJ)+THICK(J)*YPRIME*FYPR+YZEROS)*
     1             FCSLMS+(1.-PERSPJ)
      XSPLTS(J) = (XSPLTM(J)-(1.-PERSPJ)-THICK(J)*YPRIME*FYPR+YZEROS)*
     1             FCSLMS+(1.-PERSPJ)
      YSPLTP(J) = (YSPLTM(J)-YLE-THICK(J)*FYPR)*FCSLMS+YLE
      YSPLTS(J) = (YSPLTM(J)-YLE+THICK(J)*FYPR)*FCSLMS+YLE
      XSPLTM(J) = (XSPLTM(J)-(1.-PERSPJ)+YZEROS)*FCSLMS+(1.-PERSPJ)
      YSPLTM(J) = (YSPLTM(J)-YLE)*FCSLMS+YLE
      THICK(J)  = THICK(J)*FCSLMS
500   SSPLTM(J) = SSPLTM(J)*FCSLMS
      IF (ISPLIT .GT. 1) SS1(1,3) = ATAN(SS1(1,3))*C1
      YZEROS = YZEROS*FCSLMS
      AREAS  = PI/2.*YZEROS**2
      AREA2  = AREAS
      YINT   =-4./(3.*PI)*YZEROS*AREAS*SIN(SS1(1,3)/C1)
      XINT   = YZEROS*(1.-COS(SS1(1,3)/C1)*4./(3.*PI))*AREAS
      DO 510 J = 2,K1
      DELA  = (THICK(J)+THICK(J-1))*(SSPLTM(J)-SSPLTM(J-1))
      AREAS = AREAS + DELA
      XINT  = XINT + DELA*(XSPLTM(J)+XSPLTM(J-1))/2.
510   YINT  = YINT + DELA*(YSPLTM(J)+YSPLTM(J-1))/2.
      IF (ISPLIT .LT. 2) GO TO 520
      XINT  = XINT + AREA2*(XSPLTM(K1)+4.*YZEROS/(3.*PI)*COS(BETA2/C1))
      YINT  = YINT + AREA2*(YSPLTM(K1)+4.*YZEROS/(3.*PI)*SIN(BETA2/C1))
      AREAS = AREAS + AREA2
520   XBARS = XINT/AREAS
      YBARS = YINT/AREAS
530   CONTINUE
      YZERO = YZERO*FCSLMN
      IF (INAST .EQ. 0) GO TO 550
      NASNUM = IRTE - IRLE + 1
      CALL ALG15 (X,SS,100,XHERE(IRLE),SNADUM(IRLE),NASNUM,1)
      SNDUM1 = SNADUM(IRLE)
      SNDUM2 = SNADUM(IRTE)
      DO 540 J = IRLE,IRTE
      SNADUM(J) = (SNADUM(J)-SNDUM1)/(SNDUM2-SNDUM1)
      CALL ALG15 (XXM,THICK2,N,SNADUM(J),THARR(IBL,J),1,1)
540   THARR(IBL,J) = THARR(IBL,J)*2.*AXIALC
550   CONTINUE
      AREA = PI/2.0*YZERO**2
      XINT = YZERO*(1.0-COS(BETA1/C1)*4.0/(3.0*PI))*AREA
      YINT =-4.0/(3.0*PI)*YZERO*AREA*SIN(BETA1/C1)
      DO 560 J = 2,N
      DELA = (THICK2(J)+THICK2(J-1))*(S(J)-S(J-1))
      AREA = AREA + DELA
      XINT = XINT + DELA*(XM(J)+XM(J-1))/2.0
560   YINT = YINT + DELA*(YM(J)+YM(J-1))/2.0
      IF (ISECN .NE. 2) GO TO 570
      AREA2= PI/2.*YZERO**2
      XINT = XINT + AREA2*(XM(N)+4.*YZERO/(3.*PI)*COS(BETA2/C1))
      YINT = YINT + AREA2*(YM(N)+4.*YZERO/(3.*PI)*SIN(BETA2/C1))
      AREA = AREA + AREA2
570   XBAR = XINT/AREA
      YBAR = YINT/AREA
      XBARB= XBAR
      YBARB= YBAR
      YBAR = YBAR + YDEL/AXIALC
      XBAR = XBAR + XDEL/AXIALC
      AX   = 1./99.
      DX(1)= 0.
      DO 580 IK = 2,100
580   DX(IK) = DX(IK-1) + AX
      YMM = 0.0
      XMM = 0.0
      DO 660 IK = 1,100
      XAB = DX(IK)
      IF (ISECN .EQ. 0) GO TO 590
      IF (ISECN .EQ. 1) GO TO 600
      IF (ISECN .EQ. 2) GO TO 640
      IF (ISECN .EQ. 3) GO TO 620
590   Y(IK) = (OA48*(XAB-H)**4+XAB**2*XK2+B*XAB+C)*FCSLMN
      SS1(IK,1) = OA/12.*(XAB-H)**3+XK2*2.*XAB+B
      GO TO 660
600   XD = XAB - SQ
      IF (XD .GT. 0.) GO TO 610
      Y(IK) = F3(A1,B1,CC1,E1)*FCSLMN
      SS1(IK,1) = F5(A1,B1,CC1)
      GO TO 660
610   Y(IK) = F3(A2,B2,CC2,D2)*FCSLMN
      SS1(IK,1) = F5(A2,B2,CC2)
      GO TO 660
620   IF (XAB-SQ.GT.0.0 .OR. XAB.EQ.0.0 .AND. SQ.EQ.0.0) GO TO 630
      IF (BETA1 .EQ. BETA3) GO TO 650
      RDIUS = RDIUS1
      X1 = X11
      Y1 = Y11
      BTA1 = BETA1
      BTA2 = BETA3
      GO TO 640
630   IF (BETA2 .EQ. BETA3) GO TO 650
      RDIUS = RDIUS2
      X1 = X12
      Y1 = Y12
      BTA1 = BETA3
      BTA2 = BETA2
640   Y(IK) = F6(XAB)*FCSLMN
      SS1(IK,1) = F8(XAB)
      IF (BTA1-BTA2 .LT. 0.0) SS1(IK,1) = -SS1(IK,1)
      IF (BTA1-BTA2 .LT. 0.0) Y(IK) = F7(XAB)*FCSLMN
      GO TO 660
650   SS1(IK,1) = TAN(BETA3/C1)
      IF (IK .NE. 1) YMM = Y(IK-1)/FCSLMN
      IF (IK .NE. 1) XMM = DX(IK-1)
      Y(IK) = (SS1(IK,1)*(XAB-XMM)+YMM)*FCSLMN
660   SIGMA(IK) = DX(IK)*FCSLMN + YZERO
      CALL ALG15 (SIGMA,Y,100,DX,DY,100,1)
      CALL ALG15 (SIGMA,SS1(1,1),100,DX,Y,100,1)
      CALL ALG15 (DX,DY,100,XBAR,XAB,1,1)
      CALL ALG15 (DX,Y,100,XBAR,XBC,1,1)
      XBAR = XBARB
      YBAR = YBARB
      IX   = 0.0
      IY   = 0.0
      IXY  = 0.0
      DO 670 J = 2,N
      DELA = (THICK2(J)+THICK2(J-1))*(S(J)-S(J-1))
      IXD  = (THICK2(J)+THICK2(J-1))**3*(S(J)-S(J-1))/12.0
      IYD  = (THICK2(J)+THICK2(J-1))*(S(J)-S(J-1))**3/12.0
      COSANG = COS((AM(J)+AM(J-1))/C1)
      IXN  = (IXD+IYD+(IXD-IYD)*COSANG)/2.0
      IYN  = (IXD+IYD-(IXD-IYD)*COSANG)/2.0
      IXYN = 0.0
      IF (AM(J)+AM(J-1) .NE. 0.0) IXYN = ((IXN-IYN)*COSANG-IXD+IYD)/
     1   (2.0*SIN((AM(J)+AM(J-1))/C1))
      IX  = IX + IXN + DELA*((YM(J)+YM(J-1))/2.0-YBAR)**2
      IY  = IY + IYN + DELA*((XM(J)+XM(J-1))/2.0-XBAR)**2
670   IXY = IXY+ IXYN+ DELA*(YBAR-(YM(J)+YM(J-1))/2.0)*(XBAR-(XM(J)+
     1      XM(J-1))/2.0)
      ANG = ATAN(2.0*IXY/(IY-IX))
      IPX = (IX+IY)/2.0+(IX-IY)/2.0*COS(ANG)-IXY*SIN(ANG)
      IPY = (IX+IY)/2.0-(IX-IY)/2.0*COS(ANG)+IXY*SIN(ANG)
      ANG = ANG/2.0*C1
      XML = XM(N)
      YML = YM(N)
      CAMBER = BETA1 - BETA2
      IF (IPRINT .GE. 2) GO TO 790
      LNCT = 47
      IF (ISECN.EQ.1 .OR. ISECN.EQ.3) LNCT = 49
      WRITE (LOG2,680) CHORD,STAGER,CAMBER,AREA,XBAR,YBAR,IX,IY,IXY,ANG,
     1                 IPX,ANG,IPY,ANG
680   FORMAT ( /16X,100HNORMALISED RESULTS - ALL THE FOLLOWING REFER TO
     1ABLADE HAVING A MERIDIONAL CHORD PROJECTION OF UNITY, /16X,100(1H*
     2),//20X,11HBLADE CHORD,4X,1H=,F7.4, //20X,16HSTAGGER ANGLE  =,F7.3
     3, //20X,16HCAMBER ANGLE   =,F7.3, //20X,16HSECTION AREA   =,F7.5,
     4//20X,45HLOCATION OF CENTROID RELATIVE TO LEADING EDGE, //30X,6HXB
     5AR =,F8.5, /30X,6HYBAR =,F8.5, //20X,37HSECOND MOMENTS OF AREA ABO
     6UT CENTROID, //30X,6HIX   =,F8.5, /30X,6HIY   =,F8.5, /30X,6HIXY  
     7=,F8.5, //20X,58HANGLE OF INCLINATION OF (ONE) PRINCIPAL AXIS TO  
     8X  AXIS =,F7.3, //20X,47HPRINCIPAL SECOND MOMENTS OF AREA ABOUT CE
     9NTROID, //30X,6HIPX  =,F7.5,6X,3H(AT,F7.3,15H WITH  X  AXIS), /30X
     $,6HIPY  =,F7.5,6X,3H(AT,F7.3,15H WITH  Y  AXIS), //)
690   FORMAT (27X,5HPOINT,8X,24HM E A N L I N E  D A T A,13X,23HSURFACE
     1COORDINATE DATA, /27X,6HNUMBER,5X,1HX,7X,1HY,5X,15HANGLE THICKNESS
     2,9X,2HX1,6X,2HY1,6X,2HX2,6X,2HY2, //)
      WRITE (LOG2,690)
      DO 710 J = 1,N
      IF (LNCT .NE. 60) GO TO 700
      WRITE (LOG2,10)
      WRITE (LOG2,690)
      LNCT = 4
700   LNCT = LNCT + 1
      TM   = THICK2(J)*2.0
710   WRITE (LOG2,720) J,XM(J),YM(J),AM(J),TM,XS(IBL,J),YS(IBL,J),
     1                 XP(IBL,J),YP(IBL,J)
720   FORMAT (27X,I3,F13.5,F8.5,F7.3,F8.5,F16.5,3F8.5)
      IF (ISPLIT .EQ. 0) GO TO 760
      IF (LNCT  .LE. 40) GO TO 730
      WRITE (LOG2,10)
      LNCT = 1
730   WRITE  (LOG2,740)
740   FORMAT (//10X,20HSPLITTER COORDINATES, /10X,21(1H*), //2X)
      WRITE (LOG2,690)
      LNCT = LNCT + 11
      N  = K1
      DO 750 J = 1,N
      TM = THICK(J)*2.
      XS(IBL,J) = XSPLTS(J)
      XP(IBL,J) = XSPLTP(J)
      YP(IBL,J) = YSPLTP(J)
      YS(IBL,J) = YSPLTS(J)
      WRITE (LOG2,720) J,XSPLTM(J),YSPLTM(J),SS1(J,3),TM,XS(IBL,J),
     1                 YS(IBL,J),XP(IBL,J),YP(IBL,J)
      LNCT = LNCT + 1
      IF (LNCT .LE. 60) GO TO 750
      WRITE (LOG2,10)
      WRITE (LOG2,690)
      LNCT = 4
750   CONTINUE
760   CONTINUE
      DO 770 J = 1,N
      XM(J) = XS(IBL,J)
      YM(J) = YS(IBL,J)
      AM(J) = XP(IBL,J)
770   THICK2(J) = YP(IBL,J)
      WRITE  (LOG2,780) IBL
780   FORMAT (1H1,45X,33HNORMALISED PLOT OF SECTION NUMBER,I3, /2X)
      CALL ALG16 (N,LOG2,XM,YM,AM,THICK2)
790   A2  = AXIALC**2
      A4  = A2**2
      IX  = IX*A4
      IY  = IY*A4
      IXY = IXY*A4
      IPX = IPX*A4
      IPY = IPY*A4
      IF (ISTAK .GT. 1) GO TO 800
      XBAR= ISTAK
      IF (ISTAK .EQ. 0) YBAR = 0.
      IF (ISTAK .EQ. 1) YBAR = YML
800   RLE = YZERO*AXIALC
      IF (ISPLIT .NE. 0) GO TO 810
      CHORD = CHORD*AXIALC
      CCORD(IBL) = CHORD
      AREA = AREA*A2
      XC  = RLE - XBAR*AXIALC - XDEL
      YC  =-YBAR*AXIALC - YDEL
      XTC = (XML-XBAR)*AXIALC - XDEL
      YTC = (YML-YBAR)*AXIALC - YDEL
      GO TO 860
810   RLE = YZEROS*AXIALC
      CHORD = CHORDS*AXIALC
      AREAS = AREAS*AXIALC**2
      XC  = (XSPLTM(1)-XBAR)*AXIALC - XDEL
      YC  = (YSPLTM(1)-YBAR)*AXIALC - YDEL
      XTC = (XSPLTM(K1)-XBAR)*AXIALC - XDEL
      YTC = (YSPLTM(K1)-YBAR)*AXIALC - YDEL
      XBARS = (XBARS-XBAR)*AXIALC - XDEL
      YBARS = (YBARS-YBAR)*AXIALC - YDEL
      IF (IPRINT .GE. 2) GO TO 940
      GO TO (820,840), ISPLIT
820   WRITE  (LOG2,830) CHORD,RLE,XC,YC,XBARS,YBARS,AREAS
830   FORMAT (1H1,31X,69HDIMENSIONAL RESULTS - ALL RESULTS REFER TO A BL
     1ADE OF SPECIFIED CHORD, /32X,69(1H*), //20X,11HBLADE CHORD,4X,1H=,
     21P,E12.5,//20X,10HEND RADIUS,5X,1H=,1P,E12.5,8X,14HCENTERED AT X=,
     31P,E12.5,3H Y=,1P,E13.5, //20X,26HLOCATION OF CENTROID AT X=,
     41P,E12.5,7H AND Y=,1P,E12.5, //20X,16HSECTION AREA   =,1P,E12.5,
     5 //2X)
      GO TO 900
840   WRITE  (LOG2,850) CHORD,RLE,XC,YC,XTC,YTC,XBARS,YBARS,AREAS
850   FORMAT (1H1,31X,69HDIMENSIONAL RESULTS - ALL RESULTS REFER TO A BL
     1ADE OF SPECIFIED CHORD, /32X,69(1H*), //20X,11HBLADE CHORD,4X,1H=,
     21P,E12.5,//20X,10HEND RADIUS,5X,1H=,1P,E12.5,8X,14HCENTERED AT X=,
     31P,E12.5,3H Y=,1P,E13.5, /64X,6HAND X=,1P,E12.5,3H Y=,1P,E13.5,
     4 /20X,26HLOCATION OF CENTROID AT X=,1P,E12.5,7H AND Y=,1P,E12.5,
     5 //20X,16HSECTION AREA   =,1P,E12.5, //2X)
      GO TO 900
860   CONTINUE
      IF (IPRINT .GE. 2) GO TO 940
      IF (ISECN  .EQ. 2) GO TO 880
      WRITE  (LOG2,870) CHORD,RLE,XC,YC,AREA,IX,IY,IXY,IPX,ANG,IPY,ANG
870   FORMAT (1H1,31X,69HDIMENSIONAL RESULTS - ALL RESULTS REFER TO A BL
     1ADE OF SPECIFIED CHORD, /32X,69(1H*),//20X,11HBLADE CHORD,4X,1H=,
     31P,E12.5,//20X,10HL.E.RADIUS,5X,1H=,1P,E12.5,8X,14HCENTERED AT X=,
     41P,E13.5,3H Y=,1P,E13.5, //20X,16HSECTION AREA   =,1P,E12.5,//20X,
     537HSECOND MOMENTS OF AREA ABOUT CENTROID, //30X,6HIX   =,1P,E12.5,
     6 /30X,6HIY   =,1P,E12.5, /30X,6HIXY  =,1P,E12.5, //20X,47HPRINCIPA
     7L SECOND MOMENTS OF AREA ABOUT CENTROID, //30X,6HIPX  =,1P,E12.5,
     85H  (AT,0P,F7.3,15H WITH  X  AXIS), /30X,6HIPY  =,1P,E12.5,
     95H  (AT,0P,F7.3,15H WITH  Y  AXIS), //)
      GO TO 910
880   CONTINUE
      WRITE (LOG2,890) CHORD,RLE,XC,YC,XTC,YTC,AREA,IX,IY,IXY,IPX,ANG,
     1                 IPY,ANG
890   FORMAT (1H1,31X,69HDIMENSIONAL RESULTS - ALL RESULTS REFER TO A BL
     1ADE OF SPECIFIED CHORD, /32X,69(1H*),//20X,11HBLADE CHORD,4X,1H=,
     21P,E12.5, //20X,9HEND RADII,6X,1H=,1P,E12.5,8X,14HCENTERED AT X=,
     31P,E13.5,3H Y=,1P,E13.5, /64X,6HAND X=,1P,E13.5,3H Y=,1P,E13.5,
     4 /20X,16HSECTION AREA   =,1P,E12.5, //20X,37HSECOND MOMENTS OF ARE
     5A ABOUT CENTROID, //30X,6HIX   =,1P,E12.5, /30X,6HIY   =,1P,E12.5,
     6 /30X,6HIXY  =,1P,E12.5, //20X,47HPRINCIPAL SECOND MOMENTS OF AREA
     7 ABOUT CENTROID, //30X,6HIPX  =,1P,E12.5,5H  (AT,0P,F7.3,
     815H WITH  X  AXIS), /30X,6HIPY  =,1P,E12.5,5H  (AT,0P,F7.3,
     915H WITH  Y  AXIS), //)
900   CONTINUE
910   WRITE (LOG2,920)
      WRITE (LOG2,930)
920   FORMAT(4X,2HPT,5X,7HSURFACE,10(1H-),3HONE,8X,7HSURFACE,10(1H-),3HT
     1WO,10X,2HPT,5X,7HSURFACE,10(1H-),3HONE,8X,7HSURFACE,10(1H-),3HTWO)
930   FORMAT (4X,2HNO,8X,1HX,13X,1HY,13X,1HX,13X,1HY,12X,2HNO,8X,1HX,13X
     1,1HY,13X,1HX,13X,1HY, //)
      LNCT = 24
940   DO 970 J = 1,N
      XS(IBL,J) = (XS(IBL,J) - XBAR)*AXIALC - XDEL
      YS(IBL,J) = (YS(IBL,J) - YBAR)*AXIALC - YDEL
      XP(IBL,J) = (XP(IBL,J) - XBAR)*AXIALC - XDEL
      YP(IBL,J) = (YP(IBL,J) - YBAR)*AXIALC - YDEL
      IF (IPRINT  .GE. 2) GO TO 970
      IF ((J/2)*2 .NE. J) GO TO 970
      IF (LNCT   .NE. 60) GO TO 950
      LNCT = 4
      WRITE (LOG2,10)
      WRITE (LOG2,920)
      WRITE (LOG2,930)
950   LNCT = LNCT + 1
      JM1  = J - 1
      WRITE (LOG2,960) JM1,XS(IBL,JM1),YS(IBL,JM1),XP(IBL,JM1),
     1                 YP(IBL,JM1),J,XS(IBL,J),YS(IBL,J),XP(IBL,J),
     2                 YP(IBL,J)
960   FORMAT (3X,I3,4(2X,1P,E12.5),6X,I3,4(2X,1P,E12.5))
970   CONTINUE
      CHORDD(IBL) = CHORD
      IF (ISPLIT .GT. 1) ISECN = ISPLIT
      IF (IPRINT .GE. 2) GO TO 1000
      IF (LNCT  .GT. 24) WRITE (LOG2,980)
980   FORMAT (1H1)
      IF (LNCT .GT. 24) LNCT = 2
      LNCT = LNCT + 5
      IF (ISECN .EQ. 2) GO TO 1030
      WRITE  (LOG2,990)
990   FORMAT (//48X,37HPOINTS DESCRIBING LEADING EDGE RADIUS, //48X,
     1        9HPOINT NO.,6X,1HX,13X,1HY, /2X)
1000  EPS = BETA1 + 180.0
      IF (ISECN .EQ. 2) GO TO 1030
      DO 1020 J = 1,31
      XSEMI(IBL,J) = XC - RLE*SIN(EPS/C1)
      YSEMI(IBL,J) = YC + RLE*COS(EPS/C1)
      EPS = EPS - 6.0
      IF (IPRINT .GE. 2) GO TO 1020
      WRITE (LOG2,1010) J,XSEMI(IBL,J),YSEMI(IBL,J)
      LNCT = LNCT + 1
1010  FORMAT (48X,I5,1P,E17.5,1P,E14.5)
1020  CONTINUE
      GO TO 1090
1030  PHISS = PHIS - ABS((BETA1-BETA2)/C2)
      PHIPP = ABS((BETA1-BETA2))/C2 - PHIP
      EPS   = BETA1 + 180.0
      EPS2  = BETA2 + 90.
      DELEP = (180.-(PHISS+PHIPP)*C1)/28.
      DO 1060 J = 1,31
      IF (J .NE. 1) GO TO 1040
      XSEMI(IBL,J) = XP(IBL,1)
      YSEMI(IBL,J) = YP(IBL,1)
      XSEMJ(IBL,J) = XS(IBL,N)
      YSEMJ(IBL,J) = YS(IBL,N)
      EPS  = EPS  - PHIPP*C1
      EPS2 = EPS2 - PHISS*C1
      GO TO 1060
1040  IF (J .NE. 31) GO TO 1050
      XSEMI(IBL,J) = XS(IBL,1)
      YSEMI(IBL,J) = YS(IBL,1)
      YSEMJ(IBL,J) = YP(IBL,N)
      XSEMJ(IBL,J) = XP(IBL,N)
      GO TO 1060
1050  XSEMI(IBL,J) = XC  - RLE*SIN(EPS/C1)
      YSEMI(IBL,J) = YC  + RLE*COS(EPS/C1)
      XSEMJ(IBL,J) = XTC + RLE*COS(EPS2/C1)
      YSEMJ(IBL,J) = YTC + RLE*SIN(EPS2/C1)
      EPS  = EPS  - DELEP
      EPS2 = EPS2 - DELEP
1060  CONTINUE
      IF (IPRINT .GE. 2) GO TO 1090
      WRITE  (LOG2,1070)
1070  FORMAT (//39X,44HPOINTS DESCRIBING LEADING AND TRAILING EDGES,
     1 /25X,12HLEADING EDGE,22X,13HTRAILING EDGE, /2X,9HPOINT NO.,4X,8X,
     2 1HX,14X,1HY,12X,8X,1HX,14X,1HY, /2X)
      WRITE (LOG2,1080) (J,XSEMI(IBL,J),YSEMI(IBL,J),XSEMJ(IBL,J),
     1                   YSEMJ(IBL,J),J=1,31)
      LNCT = LNCT + 31
1080  FORMAT (6X,I2,7X,1P,E17.5,1P,E14.5,2X,1P,E17.5,1P,E14.5)
1090  SSURF = AXIALC
      SS2   =  BX - AXIALC*XBAR  - XDEL
      SBAR  = SS2 + AXIALC*XBARB + XDEL
      DO 1100 IK = 1,100
1100  SS(IK) = SS(IK) - SBAR
      CALL ALG15 (SS,X,100,0.0,SBAR,1,1)
      CALL ALG15 (XHERE,R(1,IBL),NSTNS,SBAR,RXBAR,1,0)
      XBARC = XBAR
      YBARC = YBAR
      XBAR  = XBARB + XDEL/AXIALC
      YBAR  = YBARB + YDEL/AXIALC
      SS1(1,1) = SS(1)
      S23 = AXIALC/99.
      SS(1) = SS(1) + SS2
      DO 1110 IK = 2,100
      SS1(IK,1) = SS(IK)
1110  SS(IK) = SS(IK-1) + S23
      SIGMAO = (XAB-YBAR)/RXBAR*AXIALC
      DO 1120 IK = 2,100
      IF (XBAR .EQ. DX(IK)) GO TO 1140
      IF (XBAR.GT.DX(IK-1) .AND. XBAR.LT.DX(IK)) GO TO 1150
1120  CONTINUE
      WRITE  (LOG2,1130)
1130  FORMAT (1H1,23H XBAR CANNOT BE LOCATED)
1140  SIGMA(IK) = SIGMAO
      KL = IK + 1
      GO TO 1160
1150  KL = IK
      SIGMA(IK-1) = SIGMAO
1160  SSDUM = SS(KL-1)
      SS(KL-1) = 0.
      YP1 = XBC
      RX1 = RXBAR
      DO 1170 IK = KL,100
      XSURF = SS2 + DX(IK)*SSURF + SS1(1,1)
      CALL ALG15 (SS1(1,1),X,100,XSURF,XDUM,1,1)
      CALL ALG15 (XHERE,R(1,IBL),NSTNS,XDUM,RX2,1,0)
      SIGMA(IK) = SIGMA(IK-1) + (Y(IK)/RX2+YP1/RX1)/2.*(SS(IK)-SS(IK-1))
      YP1 = Y(IK)
1170  RX1 = RX2
      SS(KL-1) = SSDUM
      SSDUM  = SS(KL)
      SIGDUM = SIGMA(KL)
      SIGMA(KL) = SIGMAO
      SS(KL) = 0.
      RX1 = RXBAR
      YP1 = XBC
      KM  = KL - 1
      DO 1180 IK = 1,KM
      KJ  = KL - IK
      XSURF = SS2 + DX(KJ)*SSURF + SS1(1,1)
      CALL ALG15 (SS1(1,1),X,100,XSURF,XDUM,1,1)
      CALL ALG15 (XHERE,R(1,IBL),NSTNS,XDUM,RX2,1,0)
      SIGMA(KJ) = SIGMA(KJ+1)-(Y(KJ)/RX2+YP1/RX1)/2.*(SS(KJ+1)-SS(KJ))
      YP1 = Y(KJ)
1180  RX1 = RX2
      SIGMA(KL) = SIGDUM
      SS(KL) = SSDUM
      DO 1190 IK = 1,100
1190  SS(IK) = SS1(IK,1)
      XBAR = XBARC
      YBAR = YBARC
      DO 1200 IK = 1,N
      SS1(IK,1) = SS2 + ((XS(IBL,IK)+XDEL)/AXIALC+XBAR)*SSURF+SS(1)
1200  SS1(IK,2) = SS2 + ((XP(IBL,IK)+XDEL)/AXIALC+XBAR)*SSURF+SS(1)
      DO 1210 IK =1,31
1210  SS1(IK,3) = SS2 + ((XSEMI(IBL,IK)+XDEL)/AXIALC+XBAR)*SSURF+SS(1)
      IF (ISECN .NE. 2) GO TO 1230
      DO 1220 IK = 1,31
1220  SS1(IK,4) = SS2 + ((XSEMJ(IBL,IK)+XDEL)/AXIALC+XBAR)*SSURF+SS(1)
      CALL ALG15 (SS,X,100,SS1(1,4),SS1(1,4),31,1)
1230  CALL ALG15 (SS,X,100,SS1(1,1),SS1(1,1),N,1)
      CALL ALG15 (SS,X,100,SS1(1,2),SS1(1,2),N,1)
      CALL ALG15 (SS,X,100,SS1(1,3),SS1(1,3),31,1)
      IF (ISTAK .GT. 1) GO TO 1250
      IF (ISTAK .EQ. 1) SIGMAO = SIGMA(100)
      IF (ISTAK .EQ. 0) SIGMAO = SIGMA(1)
      DO 1240 IK = 1,100
1240  SIGMA(IK) = SIGMA(IK) - SIGMAO
1250  DO 1260 IK = 1,100
      DX(IK) = (DX(IK)-XBAR)*AXIALC - XDEL
1260  DY(IK) = (DY(IK)-YBAR)*AXIALC - YDEL
      DO 1280 MK = 1,4
      IF (ISECN.NE.2 .AND. MK.EQ.4) GO TO 1280
      IF (MK.EQ.4 .OR. MK.EQ.3) NNN = 31
      IF (MK.EQ.1 .OR. MK.EQ.2) NNN = N
      DO 1270 IK = 1,NNN
      IF (MK .EQ. 1) YP1 = YS(IBL,IK)
      IF (MK .EQ. 2) YP1 = YP(IBL,IK)
      IF (MK .EQ. 3) YP1 = YSEMI(IBL,IK)
      IF (MK .EQ. 4) YP1 = YSEMJ(IBL,IK)
      IF (MK .EQ. 1) RX1 = XS(IBL,IK)
      IF (MK .EQ. 2) RX1 = XP(IBL,IK)
      IF (MK .EQ. 3) RX1 = XSEMI(IBL,IK)
      IF (MK .EQ. 4) RX1 = XSEMJ(IBL,IK)
      CALL ALG15 (DX,DY,100,RX1,RXBAR,1,1)
      DELLY = YP1 - RXBAR
      CALL ALG15 (XHERE,R(1,IBL),NSTNS,SS1(IK,MK),RAB,1,0)
      DELSIG = DELLY/RAB
      CALL ALG15 (DX,SIGMA,100,RX1,XAB,1,1)
1270  SS1(IK,MK) = XAB + DELSIG
1280  CONTINUE
      RETURN
C
1290  WRITE  (LOG2,1300)
1300  FORMAT (1H1,10X,54HITERATIVE SOLUTION FOR CONSTANT FAILS - CASE AB
     1ANDONED)
      CALL MESAGE (-37,0,NAME)
      END

      DOUBLE PRECISION FUNCTION DKI(I,J,K,L,M,N,IP,IQ,R,Z)
      DOUBLE PRECISION AI, R, Z, RD, ABS1, AMKL, AKKL, AMMN, AKMN, ARR
      DOUBLE PRECISION DKINT, DK89, DK100, DK211
      DOUBLE PRECISION XX, AMM
      DIMENSION  R(1) , Z(1)
      IF (R(I) .EQ. R(J)) GO TO 20
      RD = R(J)
      IF (R(J) .EQ. 0.0D0) RD = R(I)
      ABS1 =  DABS( (R(I) - R(J)) / RD )
      IF (ABS1 .LE. 0.1D-3) GO TO 20
      AMKL = (R(L)*Z(K)-R(K)*Z(L)) / (R(L)-R(K))
      AKKL = (Z(L)-Z(K)) / (R(L)-R(K))
      AMMN = (R(N)*Z(M)-R(M)*Z(N)) / (R(N)-R(M))
      AKMN = (Z(N)-Z(M)) / (R(N)-R(M))
      IF (AKMN .NE. AKKL .OR. AMMN .NE. AMKL) GO TO 30
   20 AI = 0.0D0
      GO TO  510
   30 CONTINUE
      ISS = IABS(IP)
      IRR = IABS(IQ)
      IF (IQ + 1) 100,300,50
   50 CONTINUE
      MM = IP
      NN = IQ + 1
      AI =DKINT(I,J,AMMN,AKMN,MM,NN,R,Z) -DKINT(I,J,AMKL,AKKL,MM,NN,R,Z)
      GO TO  510
  100 CONTINUE
      IF (IP .LT. 0) GO TO 200
      MM = IP
      NN = IRR - 1
      AI =DK89(I,AMKL,AKKL,MM,NN,R)  -  DK89(I,AMMN,AKMN,MM,NN,R)
     1   -DK89(J,AMKL,AKKL,MM,NN,R)  +  DK89(J,AMMN,AKMN,MM,NN,R)
      ARR = IRR
      AI = (1.0D0 / (1.0D0 - ARR)) * AI
      GO TO  510
  200 CONTINUE
      MM = ISS
      NN = IRR - 1
      AI =DK100(I,AMKL,AKKL,MM,NN,R) -DK100(I,AMMN,AKMN,MM,NN,R)
     1   -DK100(J,AMKL,AKKL,MM,NN,R) +DK100(J,AMMN,AKMN,MM,NN,R)
      ARR = IRR
      AI = (1.0D0 / (1.0D0 - ARR)) * AI
      GO TO  510
  300 CONTINUE
      IF (IP + 1) 400,500,301
  301 CONTINUE
      MM = IP + 1
      AMM=MM
      XX=R(I)**MM/AMM
      AI=   (
     *  +XX*DLOG(DABS(AMKL+AKKL*R(I)))-AKKL/AMM*DK89(I,AMKL,AKKL,MM,1,R)
     *  -XX*DLOG(DABS(AMMN+AKMN*R(I)))+AKMN/AMM*DK89(I,AMMN,AKMN,MM,1,R)
     *      )
      XX=R(J)**MM/AMM
      AI=   (
     *  -XX*DLOG(DABS(AMKL+AKKL*R(J)))+AKKL/AMM*DK89(J,AMKL,AKKL,MM,1,R)
     *  +XX*DLOG(DABS(AMMN+AKMN*R(J)))-AKMN/AMM*DK89(J,AMMN,AKMN,MM,1,R)
     *      ) + AI
      GO TO  510
  400 CONTINUE
      MM = ISS - 1
      AMM=MM
      XX=AMM*R(I)**MM
      AI=   (
     * -DLOG(DABS(AMKL+AKKL*R(I)))/XX+AKKL/AMM*DK100(I,AMKL,AKKL,MM,1,R)
     * +DLOG(DABS(AMMN+AKMN*R(I)))/XX-AKMN/AMM*DK100(I,AMMN,AKMN,MM,1,R)
     *      )
      XX=AMM*R(J)**M
      AI=   (
     * +DLOG(DABS(AMKL+AKKL*R(J)))/XX-AKKL/AMM*DK100(J,AMKL,AKKL,MM,1,R)
     * -DLOG(DABS(AMMN+AKMN*R(J)))/XX+AKMN/AMM*DK100(J,AMMN,AKMN,MM,1,R)
     *      ) + AI
      GO TO  510
  500 CONTINUE
      AI = DK211(I,AMKL,AKKL,R) - DK211(I,AMMN,AKMN,R)
     1   - DK211(J,AMKL,AKKL,R) + DK211(J,AMMN,AKMN,R)
  510 CONTINUE
      DKI = AI
      RETURN
      END

      SUBROUTINE FLBSET
C
C     CONSTRUCTS THE HYDROELASTIC USET VECTOR AND WRITES THE CONECT
C     FILE FOR USE IN CORE ALLOCATION DURING MATRIX ASSEMBLY
C
      EXTERNAL      COMPLF   ,RSHIFT   ,ANDF     ,ORF
C
      LOGICAL       ERROR
C
      INTEGER       GEOM2    ,ECT      ,BGPDT    ,SIL      ,MPT
     1             ,GEOM3    ,CSTM     ,USET     ,EQEXIN   ,USETF
     2             ,USETS    ,AF       ,DKGG     ,FBELM    ,FRELM
     3             ,CONECT   ,AFMAT    ,AFDICT   ,KGMAT    ,KGDICT
     4             ,Z        ,GROUP(3) ,TWO      ,UX       ,UY
     5             ,UFR      ,UZ       ,UAB      ,UI       ,UA
     6             ,MCB(7)   ,NAME(2)  ,FILE     ,TOTAL    ,NAM(2)
C
      INTEGER       ANDF     ,ORF      ,COMPLF   ,RSHIFT
C
C     MACHINE AND HALF WORD
C
      COMMON / MACHIN /       MACH     ,IHALF    ,JHALF
C
C     GINO FILES
C
      COMMON / FLBFIL /       GEOM2    ,ECT      ,BGPDT    ,SIL
     1                       ,MPT      ,GEOM3    ,CSTM     ,USET
     2                       ,EQEXIN   ,USETF    ,USETS    ,AF
     3                       ,DKGG     ,FBELM    ,FRELM    ,CONECT
     4                       ,AFMAT    ,AFDICT   ,KGMAT    ,KGDICT
C
C     CORE POINTERS
C
      COMMON / FLBPTR /       ERROR    ,ICORE    ,LCORE    ,IBGPDT
     1                       ,NBGPDT   ,ISIL     ,NSIL     ,IGRAV
     2                       ,NGRAV    ,IGRID    ,NGRID    ,IBUF1
     3                       ,IBUF2    ,IBUF3    ,IBUF4    ,IBUF5
C
C     OPEN CORE
C
      COMMON / ZZZZZZ /       Z(1)
C
C     POWERS OF TWO
C
      COMMON /TWO    /        TWO(32)
C
C     USET PIT POSITIONS
C
      COMMON /BITPOS /        BIT1(6)  ,UA       ,BIT2(16) ,UX
     1                       ,UY       ,UFR      ,UZ       ,UAB
     2                       ,UI
C
      DATA    NAME   /        4HFLBS,4HET   /
      DATA    NAM    /        4HCONE,4HCT   /
      DATA    MCB    /        7*0           /
C
C***********************************************************************
C
C     READ SIL INTO CORE
C
      FILE = SIL
      ISIL = ICORE
      NZ   = IGRID - ISIL - 1
      CALL GOPEN (SIL,Z(IBUF1),0)
      CALL READ (*1002,*10,SIL,Z(ISIL),NZ,0,NSIL)
      GO TO 1008
   10 CALL CLOSE (SIL,1)
C
C     WRITE OUT CONECT FILE
C
C     FILE 1 - FOR USE IN ASSEMBLING AF MATRIX, CONTAINS SILS WHICH
C              CONNECT FLUID POINTS TO STRUCTURE POINTS ALONG THE
C              BOUNDARY AND SILS WHICH CONNECT FLUID POINTS ALONG THE
C              FREE SURFACE
C     FILE 2 - FOR USE IN ASSEMBLING THE DKGG MATRIX, CONTAINS SILS
C              WHICH CONNECT STRUCTURE POINTS ALONG THE BOUNDARY AND
C              SILS WHICH CONNECT FLUID POINTS ALONG THE FREE SURFACE
C
C     EACH FILE IS COMPOSED OF A 3 WORD RECORD FOR EACH SIL
C
C              WORD      DESCRIPTION
C
C               1        SIL NUMBER
C               2        MAXIMUN GRID POINTS CONNECTED
C               3        MAXIMUM SILS CONNECTED
C
      FILE = CONECT
      CALL OPEN (*1001,CONECT,Z(IBUF1),1)
C
C     FILE 1
C
      CALL WRITE (CONECT,NAM,2,1)
      DO 20 I = 1,NGRID
      J = IGRID + I - 1
      IF (Z(J) .LE. 0) GO TO 20
      NFR = Z(J) / 1000000
      NFL = Z(J) - NFR*1000000
      GROUP(1) = Z(ISIL+I-1)
      GROUP(2) = NFR+NFL
      GROUP(3) = NFR + 3*NFL
      CALL WRITE (CONECT,GROUP,3,1)
   20 CONTINUE
      CALL EOF (CONECT)
C
C     FILE 2
C
      CALL WRITE (CONECT,NAM,2,1)
      DO 60 I = 1,NGRID
      J = IGRID + I - 1
      IF (Z(J) .GE. 0 .AND. Z(J) .LT. 1000000) GO TO 60
      IF (Z(J) .GT. 0) GO TO 30
      NGROUP = 3
      NNGRID = IABS(Z(J))
      NNSIL  = NNGRID*3
      GO TO 40
   30 NGROUP = 1
      NNGRID = Z(J) / 1000000
      NNSIL  = NNGRID
   40 JSIL   = Z(ISIL+I-1)
      DO 50 J = 1,NGROUP
      GROUP(1) = JSIL
      GROUP(2) = NNGRID
      GROUP(3) = NNSIL
      CALL WRITE (CONECT,GROUP,3,1)
   50 JSIL = JSIL + 1
   60 CONTINUE
C
      CALL CLOSE (CONECT,1)
      MCB(1) = CONECT
      MCB(2) = NGRID
      CALL WRTTRL (MCB)
C
C     READ USET TABLE INTO CORE
C
      FILE  = USET
      IUSET = ISIL  + NSIL  + 1
      NZ    = IGRID - IUSET - 1
      CALL GOPEN (USET,Z(IBUF1),0)
      CALL READ  (*1002,*70,USET,Z(IUSET),NZ,0,NUSET)
      GO TO 1008
   70 CALL CLOSE (USET,1)
C
C     CONSTRUCT A LIST OF FREE SURFACE GRID POINTS BY PASSING THROUGH
C     THE GRID POINT CONNECTIVITY TABLE.
C
      ICORE = IUSET + NUSET
      IFREE = ICORE
      DO 80 I = 1,NGRID
      IF (Z(IGRID+I-1) .LT. 1000000) GO TO 80
      Z(ICORE) = I
      ICORE = ICORE + 1
      IF (ICORE .GE. IGRID) GO TO 1008
   80 CONTINUE
      NFREE = ICORE - IFREE
C
C     PASS THROUGH SIL AND PROCESS EACH GRID POINT TO SET THE
C     APPROPRIATE BIT POSITIONS IN THE NEW USET
C
C     *** NOTE.
C     THE UW BIT IS NO LONGER USED.  INSTEAD THE UA BIT WILL REFLECT
C     THE SOLUTION SET  (UAB + UFR)
C
      Z(ISIL+NSIL) = NUSET + 1
      NSTR  = 0
      TOTAL = 0
      MASKA = COMPLF(TWO(UA))
      JUSET = IUSET
      DO 110 IGRD = 1,NSIL
      K = IBGPDT + 4*(IGRD-1)
      ICSTM = Z(K)
      IF (ICSTM .EQ. -1) GO TO 82
      IF (Z(ISIL+IGRD) .EQ. Z(ISIL+IGRD-1)+1) GO TO 100
C
C     STURCTURE POINT - SET UX AND UZ. ALSO SET UAB IF UA IS SET
C
      NNSIL = 6
      GO TO 84
   82 NNSIL = 1
   84 NSTR  = NSTR + NNSIL
      DO 90 J = 1,NNSIL
      Z(JUSET) = ORF(Z(JUSET),TWO(UX))
      Z(JUSET) = ORF(Z(JUSET),TWO(UZ))
      IF (ANDF(Z(JUSET),TWO(UA)) .EQ. 0) GO TO 85
      Z(JUSET) = ORF(Z(JUSET),TWO(UAB))
   85 CONTINUE
      TOTAL = ORF(TOTAL,Z(JUSET))
   90 JUSET = JUSET + 1
      GO TO 110
C
C     FLUID POINT - SET Y BIT.
C
  100 Z(JUSET) = ORF(Z(JUSET),TWO(UY))
      CALL BISLOC (*102,IGRD,Z(IFREE),1,NFREE,JLOC)
C
C     FREE SURFACE FLUID POINT - SET UFR, UA AND UZ BITS
C
      Z(JUSET) = ORF(Z(JUSET),TWO(UFR))
      Z(JUSET) = ORF(Z(JUSET),TWO(UA))
      Z(JUSET) = ORF(Z(JUSET),TWO(UZ))
      GO TO 106
C
C     INTERIOR FLUID POINT - SET UI BIT AND TURN OF UA BIT
C
  102 Z(JUSET) = ORF(Z(JUSET),TWO(UI))
      Z(JUSET) = ANDF(Z(JUSET),MASKA)
C
  106 CONTINUE
      TOTAL = ORF(TOTAL,Z(JUSET))
      JUSET = JUSET + 1
  110 CONTINUE
C
C     WRITE OUT NEW USETF VECTOR
C
      CALL GOPEN (USETF,Z(IBUF1),1)
      CALL WRITE (USETF,Z(IUSET),NUSET,1)
      CALL CLOSE (USETF,1)
      MCB(1) = USETF
      MCB(2) = 0
      MCB(3) = NUSET
      MCB(4) = RSHIFT(TOTAL,IHALF)
      MCB(5) = ANDF(TOTAL,JHALF)
      CALL WRTTRL (MCB)
C
C     WRITE OUT NEW USETS VECTOR
C
      CALL GOPEN (USETS,Z(IBUF1),1)
      LUSET = IUSET + NUSET - 1
      DO 120 I = IUSET,LUSET
      IF (ANDF(Z(I),TWO(UX)) .EQ. 0) GO TO 120
      CALL WRITE (USETS,Z(I),1,0)
  120 CONTINUE
      CALL CLOSE (USETS,1)
      MASK   = COMPLF(ORF(TWO(UY),TWO(UFR)))
      TOTAL  = ANDF(TOTAL,MASK)
      MCB(1) = USETS
      MCB(3) = NSTR
      MCB(4) = RSHIFT(TOTAL,IHALF)
      MCB(5) = ANDF(TOTAL,JHALF)
      CALL WRTTRL (MCB)
C
C     PRINT NEW USET VECTOR IF USER REQUESTS
C
      ICORE = IUSET + NUSET
      CALL FLBPRT (IUSET,ICORE,IBUF1)
C
C     USET PROCESSING COMPLETED
C
      ICORE = IUSET
      RETURN
C
C     ERROR CONDITIONS
C
 1001 N = -1
      GO TO 1100
 1002 N = -2
      GO TO 1100
 1008 N = -8
 1100 CALL MESAGE (N,FILE,NAME)
      RETURN
      END

      SUBROUTINE PERMUT(IA,ID,N,ISW)
      DIMENSION IA(1),IB(32),IC(32),ID(10)
      DO 10 I=1,N
      IC(I)=IA(I)
   10 IB(I)=I
      N1=N-1
      DO 20 I=1,N1
      I1=I+1
      DO 30 J=I1,N
      IF(IC(J)-IC(I))40,30,30
   40 IS1=IB(J)
      IB(J)=IB(I)
      IB(I)=IS1
      IS1 = IC(J)
      IC(J)=IC(I)
      IC(I) = IS1
   30 CONTINUE
   20 CONTINUE
      DO 50 I = 1,N
      IF(IC(I)-ISW)50,60,60
   50 CONTINUE
      K=1
      GO TO 71
   60 DO 70 J=I,N
      K=J-I+1
   70 ID(K)=IB(J)
      IF(K .EQ. N) GO TO 90
      K=K+1
   71 DO 80 J=K,N
      L=J-K+1
   80 ID(J)=IB(L)
   90 RETURN
      END

      SUBROUTINE TABLE V (*,IN,LL,TRL,NAME,P4,IBUF,Z5)
C
C     TABLE-V IS CALLED ONLY BY INPUT5 TO GENERATE A GINO TABLE
C     DATA BLOCK IN 'OUT' FROM AN INPUT FILE 'IN' - A REVERSE PROCESS
C     OF TABLE-5.
C     THE INPUT FILE WAS FORTRAN WRITTEN, FORMATTED OR UNFORMATTED
C
C     IN     = INPUT FILE, INTEGERS
C     LL     = (200+LL) IS THE OUTPUT FILE, INTEGER
C     TRL    = AN ARRAY OF 7 WORDS FOR TRAILER
C     NAME   = ORIGINAL FILE NAME FROM INPUT FILE, 2 BCD WORDS, PLUS 1
C     P4     = 0, INPUT FILE WAS WRITTEN UNFORMATTED, BINARY, INTEGER
C            = 1, INPUT FILE WAS WRITTEN FORMATTED, ASCII, INTEGER
C     IBUF   = OPEN CORE AND GINO BUFFER POINTER, INTEGER
C
      LOGICAL          DEBUG
      INTEGER          SYSBUF,P4,Z,TRL(7),OUT,NAME(3),NAMEX(2),SUB(2),
     1                 END,TBLE,FUF,FU(2)
      REAL             RZ(1),Z4(2)
      DOUBLE PRECISION DZ
      CHARACTER*1      Z1,I1,R1,B1,D1,F1
      CHARACTER*5      Z5(1),Z5L,END5
      CHARACTER*10     Z10
      CHARACTER*15     Z15
      COMMON /SYSTEM/  SYSBUF,NOUT
      COMMON /ZZZZZZ/  Z(1)
      EQUIVALENCE      (Z1,Z5L), (Z(1),RZ(1)), (DZ,Z4(1))
      DATA    I1,R1,   B1,D1,F1  / 'I', 'R', '/', 'D', 'X'    /
      DATA    FU,      END,END5  / 2H  ,2HUN, 4H*END, ' *END' /
      DATA    SUB,     TBLE      / 4HTABL,4HEV  ,     4HTBLE  /
      DATA    DEBUG              / .FALSE.                    /
C
      IF (DEBUG) WRITE (NOUT,10)
 10   FORMAT (///,' *** IN TABLE-V, DEBUG ***')
      KORE  = IBUF-1
      KORE9 = (KORE/9)*9
      OUT   = 200+LL
      LL    = LL+1
      KOUNT = 0
C
C     OPEN GINO OUTPUT FILE AND WRITE A FILE HEADER
C
      CALL OPEN (*180,OUT,Z(IBUF),1)
      CALL FNAME (OUT,NAMEX)
      CALL WRITE (OUT,NAMEX,2,1)
      IF (DEBUG) WRITE (NOUT,20) NAMEX
 20   FORMAT (/5X,'GENERATING...',2A4,/)
      NAME(3) = TBLE
      IF (P4 .EQ. 1) GO TO 40
C
C     UNFORMATED READ
C
 30   READ (IN,ERR=150,END=130) LN,(Z(J),J=1,LN)
      IF (LN .GT. KORE) GO TO 170
      IF (LN.EQ.1 .AND. Z(1).EQ.END) GO TO 130
      CALL WRITE  (OUT,Z(1),LN,1)
      KOUNT = KOUNT+1
      GO TO 30
C
C     FORMATTED READ
C
 40   READ  (IN,50,ERR=150,END=130) LN,(Z5(J),J=1,LN)
 50   FORMAT (I10,24A5,/,(26A5))
      IF (LN .GT. KORE) GO TO 170
      IF (LN.EQ.1 .AND. Z5(1).EQ.END5) GO TO 130
      IF (LN .LE. -1) GO TO 130
      LB = (LN*5)/4+1
      K  = 0
      L  = 1
 60   IF (L .GT. LN) GO TO 120
      K  = K+1
      Z5L= Z5(L)
      IF (Z1 .EQ. I1) GO TO 90
      IF (Z1 .EQ. R1) GO TO 100
      IF (Z1 .EQ. B1) GO TO 70
      IF (Z1 .EQ. F1) GO TO 80
      IF (Z1 .EQ. D1) GO TO 110
      WRITE  (NOUT,65) Z5L
 65   FORMAT (/,' SYSTEM ERROR/TABLEV @65  Z5L=',A5)
      GO TO 150
C
C     BCD
C
 70   READ (Z5L,75) Z(LB+K)
 75   FORMAT (1X,A4)
C
C     FILLER
C
 80   L = L+1
      GO TO 60
C
C     INTEGER
C
 85   FORMAT (3A5)
 90   WRITE  (Z10,85) Z5(L),Z5(L+1)
      READ   (Z10,95) Z(LB+K)
 95   FORMAT (1X,I9)
      L = L+2
      GO TO 60
C
C     REAL, SINGLE PRECISION
C
 100  WRITE  (Z15, 85) Z5(L),Z5(L+1),Z5(L+2)
      READ   (Z15,105) RZ(LB+K)
 105  FORMAT (1X,E14.7)
      L = L+3
      GO TO 60
C
C     REAL, DOUBLE PRECISION
C
 110  WRITE (Z15, 85) Z5(L),Z5(L+1),Z5(L+2)
      READ  (Z15,115) DZ
 115  FORMAT (1X,D14.7)
      RZ(LB+K  ) = Z4(1)
      RZ(LB+K+1) = Z4(2)
      K = K+1
      L = L+3
      GO TO 60
C
 120  IF (K .LE. 0) GO TO 40
      CALL WRITE (OUT,Z(LB+1),K,1)
      KOUNT = KOUNT+1
      GO TO 40
C
C     ALL DONE.
C     CLOSE OUTPUT GINO FILE AND WRITE TRAILER
C
 130  CALL CLOSE (OUT,1)
      IF (DEBUG) WRITE (NOUT,135) TRL(2),KOUNT
 135  FORMAT (/,' DEBUG ECHO - OLD AND NEW COLUMN COUNTS =',2I5)
      TRL(1) = OUT
      TRL(2) = KOUNT
      CALL WRTTRL (TRL)
      FUF = FU(1)
      IF (P4 .EQ. 0) FUF = FU(2)
      WRITE  (NOUT,140) FUF,NAMEX
 140  FORMAT (/5X,'DATA TRANSFERED SUCCESSFULLY FROM ',A2,'FORMATTED ',
     1       'TAPE TO GINO OUTPUT FILE ',2A4)
      GO TO 200
C
C     ERROR
C
 150  CALL CLOSE (OUT,1)
      WRITE  (NOUT,160) NAMEX
 160  FORMAT (//5X,'ERROR IN READING INPUT TAPE IN TABLEV. NO ',2A4,
     1         /5X,'FILE GENERATED')
      GO TO 200
 170  CALL MESAGE (8,0,SUB)
      GO TO 200
 180  CALL MESAGE (1,OUT,SUB)
C
 200  RETURN 1
      END

      SUBROUTINE SMA3
C
C     THIS ROUTINE, FOR EACH GENERAL ELEMENT, READS THE GENERAL ELEMENT
C     INPUT FILE, GEI, CALLS SMA3A OR SMA3B, DEPENDING UPON WHETHER OR
C     NOT THE ORDERS OF THE K OR Z AND S MATRICES WILL ALLOW THE IN CORE
C     MATRIX ROUTINES (CALLED BY SMA3A) TO BE USED, AND THEN CALLS THE
C     MATRIX ADD ROUTINE TO ADD THE KGGX MATRIX TO THE GENERAL ELEMENT
C     MATRIX.
C
      LOGICAL          EVEN,ONLYGE
      INTEGER          IQ(1),EOR,OUTRW,CLSRW,CLSNRW
      DOUBLE PRECISION DQ(1)
      DIMENSION        IBUFF3(3),NAME(2),MCBID(7),BLOCK(11),IBLOCK(11)
      COMMON /BLANK /  LUSET,NGENEL,NOECPT
      COMMON /SYSTEM/  KSYSTM(65)
      COMMON /ZZZZZZ/  Q(1)
      COMMON /GENELY/  IFGEI,IFKGGX,IFOUT,IFA,IFB,IFC,IFD,IFE,IFF,INRW,
     1                 OUTRW,CLSRW,CLSNRW,EOR,NEOR,MCBA(7),MCBB(7),
     2                 MCBC(7),MCBD(7),MCBE(7),MCBF(7),MCBKGG(7),
     3                 IUI,IUD,IZI,IS,IZIS,ISTZIS,IBUFF3,LEFT
      EQUIVALENCE      (KSYSTM(1),ISYS),(KSYSTM(55),IPREC),
     1                 (IQ(1),DQ(1),Q(1)),(IBUFF3(2),M),(IBUFF3(3),N),
     2                 (MCBID(1),MCBC(1)),(BLOCK(1),IBLOCK(1))
      DATA    NAME  /  4HSMA3,4H    /
C
C     GENERAL INITIALIZATION
C
      IFGEI  = 101
      IFKGGX = 102
      IF201  = 201
      IF301  = 301
      IF302  = 302
      IF303  = 303
      IF304  = 304
      IF305  = 305
      IF306  = 306
      IFOUT  = IF201
      IFA    = IF301
      IFB    = IF302
      IFC    = IF303
      IFD    = IF304
      IFE    = IF305
      IFF    = IF306
      IFG    = 307
      INRW   = 0
      OUTRW  = 1
      CLSRW  = 1
      CLSNRW = 2
      EOR    = 1
      NEOR  = 0
C
C     DETERMINE THE SIZE OF VARIABLE CORE AVAILABLE AND SET IUI TO THE
C     ZEROTH LOCATION OF VARIABLE CORE.
C
      IQMAX = KORSZ (Q)
      IUI   = 0
C
C     OPEN THE GENERAL ELEMENT INPUT FILE AND SKIP OVER THE HEADER
C     RECORD.
C
      IGGEI = IQMAX - ISYS + 1
      CALL GOPEN (IFGEI,Q(IGGEI),0)
      IGA   = IGGEI - ISYS
C
C     DETERMINE IF THE NUMBER OF GENERAL ELEMENTS IS EVEN OR ODD.
C
      EVEN = .TRUE.
      IF ((NGENEL/2)*2 .NE. NGENEL) EVEN = .FALSE.
      IPASS = 0
C
C     COMPUTE LENGTH OF OPEN CORE
C
      LEFT = IGA - 1
      NZ   = LEFT
C
C     READ THE TRAILER FOR KGGX TO SEE IF IT EXISTS.
C
      ONLYGE = .FALSE.
      MCBKGG(1) = IFKGGX
      CALL RDTRL (MCBKGG(1))
      IF (MCBKGG(1) .LT. 0) GO TO 12
      IFB = MCBKGG(1)
      DO 10 I = 1,7
      MCBB(I) = MCBKGG(I)
   10 MCBKGG(I) = 0
      GO TO 14
   12 ONLYGE = .TRUE.
C
C     INITIALIZATION PRIOR TO LOOP
C
   14 IF (ONLYGE) GO TO 21
      IFOUT = IF201
      IF (EVEN) IFOUT = IF302
      GO TO 30
   21 IFA = IFOUT
      IF (EVEN) IFA = IF302
C
C     BEGIN MAIN LOOP OF THE PROGRAM
C
   30 IPASS = IPASS + 1
C
C     READ THE ELEMENT ID, THE LENGTH OF THE UI SET, M, AND THE LENGTH
C     OF THE UD SET, N
C
      CALL READ (*200,*210,IFGEI,IBUFF3(1),3,NEOR,IDUMMY)
      NEEDED = 2*(M+N+M**2 + N**2 + 2*M*N)
      ITEMP1 = 2*(M+N+ M**2) + 3*M
      IF (ITEMP1 .GT. NEEDED) NEEDED = ITEMP1
C
C     DETERMINE IF THERE IS ENOUGH CORE STORAGE AVAILABLE TO USE THE IN
C     CORE MATRIX ROUTINES.
C
      IF (NEEDED .GT. LEFT) GO TO 140
C
C
C     **********  IN CORE VERSION  ****************
C
C     USE THE IN CORE MATRIX ROUTINES.  CALL SMA3A.
C
      CALL MAKMCB (MCBA,IFA,0,6,IPREC)
C
C     OPEN THE FILE ON WHICH THE CURRENT GENERAL ELEMENT WILL BE OUTPUT.
C
      CALL GOPEN (IFA,Q(IGA),1)
      CALL SMA3A (MCBA)
C
C     STORE THE CORRECT NUMBER OF ROWS IN THE 3RD WORD OF THE MATRIX
C     CONTROL BLOCK AND CLOSE THE FILE WITH REWIND.
C
      MCBA(3) = MCBA(2)
      CALL WRTTRL (MCBA)
      CALL CLOSE (IFA,CLSRW)
C
C     SUMATION
C
C     JUMP TO 100 ONLY IF THIS IS THE FIRST PASS AND KGGX DOES NOT EXIST
C
   60 IF (IPASS.EQ.1 .AND. ONLYGE) GO TO 100
      CALL MAKMCB (MCBKGG,IFOUT,0,6,IPREC)
      IBLOCK(1) = 1
      BLOCK (2) = 1.0
      BLOCK (3) = 0.0
      BLOCK (4) = 0.0
      BLOCK (5) = 0.0
      BLOCK (6) = 0.0
      IBLOCK(7) = 1
      BLOCK (8) = 1.0
      BLOCK (9) = 0.0
      BLOCK(10) = 0.0
      BLOCK(11) = 0.0
C
C     CLOSE GEI WITH NO REWIND SO SUBROUTINE ADD CAN HAVE THE BUFFER
C
      CALL CLOSE (IFGEI,2)
C
C     CALL SSG2C TO PERFORM SUMMATION - OUTPUT ON IFOUT
C
      CALL SSG2C (IFA,IFB,IFOUT,0,BLOCK)
      IF (IPASS .EQ. NGENEL) GO TO 160
      CALL RDTRL (MCBKGG)
C
C     RESTORE GEI AFTER SUMATION
C
      CALL GOPEN (IFGEI,Q(IGGEI),2)
      IF (IPASS  .GT. 1) GO TO 130
  100 IF (NGENEL .EQ. 1) GO TO 160
      IFA   = IF301
      IFB   = IF302
      IFOUT = IF201
      IF (.NOT.EVEN) GO TO 130
      IFB   = IF201
      IFOUT = IF302
C
C     SWITCH FILES IFB AND IFOUT FOR NEXT GENEL PROCESSING
C
  130 DO 135 I = 1,7
      II = MCBKGG(I)
      MCBKGG(I) = MCBB(I)
  135 MCBB(I) = II
      II = IFOUT
      IFOUT = IFB
      IFB = II
C
C     RETURN TO BEGIN LOOP
C
      GO TO 30
C
C     ***********  OUT OF CORE VERSION  *************
C
C     IFOUT MUST CONTAIN THE RESULTS OF THE LAST GENEL PROCESSED
C     SWITCH FILES IFB AND IFOUT FOR OUT OF CORE VERSION
C
  140 IF (IPASS.EQ.1 .AND. ONLYGE .AND. .NOT.EVEN) GO TO 142
      DO 141 I = 1,7
      II = MCBKGG(I)
      MCBKGG(I) = MCBB(I)
  141 MCBB(I) = II
      II = IFOUT
      IFOUT = IFB
      IFB = II
C
C     THE IN CORE MATRIX ROUTINES CANNOT BE USED.SUBROUTINE SMA3B BUILDS
C     THE ZE IF Z IS INPUT OR THE ZINYS IF K IS INPUT AND IF PRESENT THE
C     SE MATRICES. IF THE SE MATRIX IS PRESENT ISE IS POSITIVE.
C     NOTE - SE(T) IS ON THE SE FILE.
C
  142 CALL SMA3B (ISE,IZK)
      IF (IZK .EQ. 2) GO TO 145
C
C     FACTOR DECOMPOSES THE ZE MATRIX INTO ITS UPPER AND LOWER
C     TRIANGULAR FACTORS.  TWO SCRATCH FILES ARE NEEDED.
C
      CALL FACTOR (IFA,IFE,IFF,IFD,IFC,IFG)
C
C     CONVERT IFB INTO THE IDENTITY MATRIX.  (MCBID HAS BEEN SET UP BY
C     SMA3B)
C
      CALL WRTTRL (MCBID)
C
C     COMPUTE Z INVERSE
C
      CALL SSG3A (IFA,IFE,IFC,IFD,0,0,-1,0)
  145 CONTINUE
C
C     GO TO 150 IF NO SE MATRIX IS PRESENT.
C
      IF (ISE .LT. 0) GO TO 150
C
C               T        T  -1
C     COMPUTE -S XK OR -S XZ  AND STORE ON IFF
C               E  E     E  E
C
      CALL SSG2B (IFB,IFD,0,IFF,0,IPREC,1,IFC)
C
C     TRANSPOSE THE SE FILE ONTO IFA.  HENCE IFA CONTAINS THE -SE MATRIX
C
      CALL TRANP1 (IFB,IFA,1,IFC,0,0,0,0,0,0,0)
C
C                       -1
C     COMPUTE K X-S OR Z  X-S AND STORE ON IFE
C              E   E    E    E
C
      CALL SSG2B (IFD,IFA,0,IFE,0,IPREC,1,IFC)
C
C              T          T  -1
C     COMPUTE S XK XS OR S XZ  XS AND STORE ON IFC
C              E  E  E    E  E   E
C
      CALL SSG2B (IFB,IFE,0,IFC,0,IPREC,1,IFA)
C
C     SMA3C BUILDS THE FINAL MATRIX OF G (LUSET) SIZE.
C
      MCBA(1) = IFA
  150 CALL SMA3C (ISE,MCBA)
C
C     RETURN FILES IFB AND IFOUT TO ORIGIONAL FILES AFTER OUT OF CORE
C
      IF (IPASS.EQ.1 .AND. ONLYGE .AND. .NOT.EVEN) GO TO 60
      DO 155 I = 1,7
      II = MCBKGG(I)
      MCBKGG(I) = MCBB(I)
  155 MCBB(I) = II
      II = IFOUT
      IFOUT = IFB
      IFB = II
C
C     RETURN TO SUMATION
C
      GO TO 60
C
C     WRAP-UP
C
  160 CALL CLOSE (IFGEI, CLSRW)
      IF (IFOUT .NE. IF201) CALL MESAGE (-30,28,5)
      RETURN
C
C     FATAL ERROR MESSAGES
C
  200 CALL MESAGE (-2,IFGEI,NAME)
  210 CALL MESAGE (-3,IFGEI,NAME)
      RETURN
      END

      SUBROUTINE WRTPRT (FILE,LIST,FORMAT,N)
C
      INTEGER FILE,LIST(1),FORMAT(N)
C
      CALL WRITE (FILE,LIST,LIST(1)+1,0)
      CALL WRITE (FILE,N,1,0)
      CALL WRITE (FILE,FORMAT,N,0)
      RETURN
      END

        SUBROUTINE BLDPKI ( A, I, FILE, BLOCK )
      INTEGER BLOCK(15), A(4), FILE
      INCLUDE 'DSIOF.COM'
      INCLUDE 'XNSTRN.COM'
      NAME   = FILE
      BLOCK( 15 ) = I
      ITYPIN = BLOCK( 13 )
      NWORDS = NWRDEL( ITYPIN )
      IF ( BLOCK( 2 ) .GE. 3 ) GO TO 5
      INCCNT = 1
      GO TO 8
5     INCCNT = 2
8     CONTINUE
      DO 10 K = 1, NWORDS
      IF ( A( K ) .NE. 0 ) GO TO 20
10    CONTINUE
      GO TO 7000
20    IF ( BLOCK( 4 ) .EQ. 0 ) GO TO 35
      NEXROW = BLOCK( 4 ) + BLOCK( 7 )
      ICROW  = BLOCK( 15 )
      IF ( ICROW .GE. NEXROW ) GO TO 30
      CALL DSMSG1( BLOCK )
      CALL DSMSG( 119 )
30    IF ( ICROW .EQ. NEXROW ) GO TO 40
      CALL ENDPUT( BLOCK )
      CALL PUTSTR( BLOCK )
      BLOCK( 7 ) = 0
35    ICROW = BLOCK( 15 )
      BLOCK( 4 ) = ICROW
40    INDEX  = ( BLOCK( 5 ) - 1  ) * BLOCK( 14 ) + 1
      IF ( ITYPIN .NE. BLOCK( 2 ) ) GO TO 100
CDIR$ NOVECTOR
      DO 70 KK = 1, NWORDS
      IBASE( INDEX + KK - 1 ) = A( KK )
70    CONTINUE
CDIR$ VECTOR
      GO TO 200
100   CALL DSUPKC ( ITYPIN, BLOCK( 2 ), A, IBASE( INDEX ) )
200   CONTINUE
      BLOCK( 5 ) = BLOCK( 5 ) + INCCNT
      BLOCK( 7 ) = BLOCK( 7 ) + 1
      BLOCK(10 ) = BLOCK(10 ) + BLOCK( 11 )
      IF ( BLOCK( 6 ) .GT. BLOCK( 7 ) ) GO TO 7000
      CALL ENDPUT( BLOCK )
      CALL PUTSTR( BLOCK )
      BLOCK( 4 ) = 0
      BLOCK( 7 ) = 0
7000  RETURN
        END

      SUBROUTINE SEEMAT
C
C     SUBROUTINE SEEMAT IS THE DMAP DRIVER FOR UTILITY MODULE SEEMAT
C     WHOSE DMAP CALL FOLLOWS
C
C     SEEMAT    A,B,C,D,E//C,N,PRINT(PLOT)/V,N,PFILE/C,N,FSIZE/
C                          C,N,MODIDA/C,N,MODELA/C,N,PAPERX/C,N,PAPERY
C
C     INPUT DATA BLOCKS  - A,B,C,D,E ARE MATRICES, ANY OF WHICH MAY BE
C                          PURGED.
C
C     OUTPUT DATA BLOCKS - NONE
C
C     PARAMETERS
C       1. BCD, -PRINT- MEANS USE SYSTEM PRINTER (DEFAULT).
C               -PLOT- MEANS USE SPECIFIED PLOTTER.
C       2. INTEGER, PLOT COUNTER (INPUT + OUTPUT).
C       3. INTEGER, FRAME SIZE = NUMBER OF CHARACTERS TO BE TYPED
C                   IN AN ASSUMED SQUARE FRAME (DEFAULT=100).
C       4. BCD, MODEL ID (DEFAULT=M).
C       5. INTEGER, MODEL NUMBER (DEFAULT=1).
C       6. REAL, X DIMENSION OF PLOT FRAME (DEFAULT=0.0).
C       7. REAL, Y DIMENSION OF PLOT FRAME (DEFAULT=0.0).
C      NOTE - PARAMETERS 2-7 ARE USED ONLY IF PARAMETER 1 = -PLOT-.
C
      EXTERNAL        ANDF,ORF
      LOGICAL         TABLE,SQ,PLOTIT,PRNTIT,TAPBIT,NOBITS
      INTEGER         NAME(5),GOBAC,BLANK,XSTAR,XDOLR,XDDDD,SEEMT(2),
     1                A,B,C,IT(7),SYSBUF,EOL,EOR,IRO(10),IX(1),LBL(2),
     2                ANDF,ORF,KPP(2),PLUS,BCOR,SYMBL(2),MODID(2),
     3                TTL1(9),TTL2(4),TTL3(4),TTL4(3),LIN(25),
     4                PP,PFILE,FSIZE,PLTTER,PLTYPE,PLOTER,PLTBUF,TWO
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25,SWM*27,SIM*31
      COMMON /XMSSG / UFM,UWM,UIM,SFM,SWM,SIM
      COMMON /SYSTEM/ SYSBUF,NOUT,JAZZ1(6),NLINES,JAZZ2(2),LNCT,
     1                JAZZ3(26),NBPC,NBPW,NCPW
      COMMON /BLANK / PP(2),PFILE,FSIZE,MODIDA(2),MODELA,PAPERX,PAPERY
      COMMON /ZZZZZZ/ X(1)
      COMMON /ZNTPKX/ Z(4),IZ,EOL,EOR
      COMMON /PLTDAT/ MODEL,PLTTER,REGION(4),AXMAX,AYMAX,EDGE(12),
     1                SKPA(9),PLTYPE,PLOTER
      COMMON /XXPARM/ PLTBUF,KAMRAN,NBLFM,SKPARM(4),PAPSIZ(2)
      COMMON /TWO   / TWO(32)
      EQUIVALENCE     (X(1),IX(1)),(IRO(1),ICOL1),(IRO(2),IBLCU1),
     1                (IRO(3),IBLCU2),(IRO(4),JBLCU1),(IRO(5),JBLCU2),
     2                (IRO(6),A,IPIJ1),(IRO(7),B,IPIJ2),(IRO(8),C),
     3                (IT(1),NAM ),(IT(2),NCOLS),(IT(3),NROWS),
     4                (IT(5),ITYP)
      DATA    NAME  , SEEMT /101,102,103,104,105,4HSEEM,4HAT   /
      DATA    BLANK , NCC,XSTAR,XDOLR,XDDDD/1H ,100,1H*,1H$,1HD/
      DATA    KPP   / 4HPLOT,4H    /
      DATA    PLUS  / 4H+   /
      DATA    TTL1  / 4HSEEM,4HAT D,4HISPL,4HAY O,4HF MA,4HTRIX,
     1                4H DAT,4HA BL,4HOCK /
      DATA    TTL2  / 4HNO. ,4HCOLU,4HMNS ,4H=   /
      DATA    TTL3  / 4HNO. ,4H  RO,4HWS  ,4H=   /
      DATA    TTL4  / 4H(TRA,4HNSPO,4HSED)/
C
      NCC    = 100
      PLOTIT =.FALSE.
      PRNTIT =.TRUE.
      NLNXX  = NLINES
      IF (PP(1).NE.KPP(1) .OR. PP(2).NE.KPP(2)) GO TO 20
      PLOTIT =.TRUE.
      PRNTIT =.FALSE.
      TABLE  =.FALSE.
      NCC    = FSIZE
      FNCC   = NCC
      NLNXX  = NCC
   20 LCOR   = KORSZ(X) - SYSBUF
C
      NCC1   = NCC/4
      NCC5   = NCC - 5
      LBLK   = (NCC*NLNXX-1)/32 + 3
      IF (PRNTIT) GO TO 90
C
C     INITIALIZE PLOTTER
C
      MODID(1) = MODIDA(1)
      MODID(2) = MODELA
      CALL FNDPLT (PLTTER,MODEL,MODID)
      PAPSIZ(1) = PAPERX
      PAPSIZ(2) = PAPERY
      KAMRAN = 3
      NBLKFM = 0
      CALL PLTSET
      LCOR = LCOR - PLTBUF
      KCOR = LCOR + SYSBUF + 1
      IF (LCOR .LE. 0) CALL MESAGE (-8,SQ,SEEMT)
      BCOR = LCOR - NCC1
      IF (TAPBIT(PLOTER)) GO TO 70
      WRITE  (NOUT,65) UWM,PLOTER
   65 FORMAT (A25,' 1704, PLOT FILE -',A4,'- NOT SET UP')
      GO TO 9999
   70 IF (IABS(PLTYPE).NE.1) TABLE = .TRUE.
      REGION(3) = AMIN1(AXMAX,AYMAX)
      REGION(4) = REGION(3)
      AXMAX = REGION(3)
      AYMAX = REGION(4)
      CALL MAPSET (0,0,1.01*FNCC,1.01*FNCC,0,0,AXMAX,AYMAX,2)
      CALL MAP (0.005*FNCC,0.005*FNCC,BLLX,BLLY)
      CALL MAP (1.005*FNCC,0.005*FNCC,BLRX,BLRY)
      CALL MAP (1.005*FNCC,1.005*FNCC,BURX,BURY)
      CALL MAP (0.005*FNCC,1.005*FNCC,BULX,BULY)
      GO TO 90
   85 CALL MESAGE (-1,PLOTER,SEEMT)
   90 CONTINUE
C
      DO 9998 III = 1,5
C
      NAM = NAME(III)
      CALL RDTRL (IT)
      IF (NAM .LE. 0) GO TO 9998
      CALL GOPEN (NAM,X(LCOR+1),0)
      CALL FNAME (NAM,LBL)
      SQ = .TRUE.
      IF (NCOLS .NE. NROWS) SQ = .FALSE.
      NBLKS = 0
      NCOL1 = 0
      IJMAX = MAX0(NCOLS,NROWS)
      NROWS1= NROWS + 1
      IF (PRNTIT) GO TO 95
      IF (TABLE ) GO TO 92
      PFILE = PFILE + 1
      CALL SOPEN (*85,PLOTER,X(KCOR),PLTBUF)
      CALL STPLOT (PFILE)
      CALL MAP   (0.23*FNCC,0.50*FNCC,XXXX,YYYY)
      CALL PRINT (XXXX,YYYY,1,TTL1,9,-1)
      CALL PRINT (XXXX,YYYY,1,TTL1,9, 0)
      CALL MAP   (0.60*FNCC,0.50*FNCC,XXXX,YYYY)
      CALL PRINT (XXXX,YYYY,1,LBL,2,0)
      CALL MAP   (0.75*FNCC,0.50*FNCC,XXXX,YYYY)
      CALL PRINT (XXXX,YYYY,1,TTL4,3,0)
      CALL MAP   (0.40*FNCC,0.40*FNCC,XXXX,YYYY)
      CALL PRINT (XXXX,YYYY,1,TTL3,4,0)
      CALL MAP   (0.40*FNCC,0.30*FNCC,XXXX,YYYY)
      CALL PRINT (XXXX,YYYY,1,TTL2,4,0)
      CALL MAP   (0.55*FNCC,0.40*FNCC,XXXX,YYYY)
      CALL TYPINT (XXXX,YYYY,1,NROWS,0, 0)
      CALL MAP   (0.55*FNCC,0.30*FNCC,XXXX,YYYY)
      CALL TYPINT (XXXX,YYYY,1,NCOLS,0, 0)
      CALL LINE (BLLX,BLLY,BULX,BULY,1,-1)
      CALL LINE (BLLX,BLLY,BULX,BULY,1, 0)
      CALL LINE (BULX,BULY,BURX,BURY,1, 0)
      CALL LINE (BURX,BURY,BLRX,BLRY,1, 0)
      CALL LINE (BLRX,BLRY,BLLX,BLLY,1, 0)
      CALL STPLOT (-1)
   92 CALL PAGE1
      LNCT = LNCT + 5
      WRITE  (NOUT,93) LBL(1),LBL(2),NCOLS,NROWS
   93 FORMAT (//5X,'SEEMAT PLOT FOR TRANSPOSE OF', /22X,'MATRIX DATA ',
     1       'BLOCK ',2A4,11X,'PLOT FILE ','    R','     C', /10X,
     2       'SIZE =',I6,' ROWS BY',I6,' COLUMNS')
      IF (TABLE) GO TO 95
      WRITE  (NOUT,94) PFILE
   94 FORMAT (1H0,62X,I5,2X,12HHEADER FRAME)
   95 CONTINUE
C
C
C     LOOP ON COLUMNS OF MATRIX
C
      NCOL = 1
  100 CONTINUE
      CALL INTPK (*2100,NAM,0,ITYP,0)
C
C     IF COLUMN IS NULL, RETURN FROM INTPK IS TO STATEMENT 2100
C     ITY IS TYPE OF ELEMENT STORED IN Z, NOT USED IN THIS PROGRAM
C     BLOCK IS DUMMY ENTRY NOT USED BY INTPK
C
C     LOOP ON ROWS OF MATRIX
C
      NROW = 1
  200 CONTINUE
      IF (EOL .NE. 0) GO TO 2100
C
C     READ ELEMENT OF MATRIX INTO /ZNTPKX/
C
      CALL ZNTPKI
C
C     COMPUTE BLOCK ID IN WHICH ELEMENT BELONGS
C
C     LOOK AT CURRENT BLOCK FIRST
C
      IF (NBLKS .LE. 0) GO TO 1045
      IF (NCOL.LE.JBLCU1 .OR. NCOL.GT.JBLCU2 .OR. IZ.LE.IBLCU1 .OR.
     1    IZ.GT.IBLCU2) GO TO 1020
      NBLK = NBLCUR
      GO TO 1050
C
C     SEARCH ALL BLOCKS TO FIND OLD ONE IN WHICH ELEMENT LIES
C
 1020 DO 1040 I2 = 1,NBLKS
      IP  = LBLK*(I2-1) + 1
      IP1 = IP + 2
      IBLCU1 = IX(IP)
      IBLCU2 = IBLCU1 + NCC
      JBLCU1 = IX(IP+1)
      JBLCU2 = JBLCU1 + NLNXX
      IF (NCOL.LE.JBLCU1 .OR. NCOL.GT.JBLCU2 .OR. IZ.LE.IBLCU1 .OR.
     1    IZ.GT.IBLCU2) GO TO 1040
      NBLK = I2
      GO TO 1050
 1040 CONTINUE
 1045 NBLK = -1
 1050 IF (NBLK .GT. 0) GO TO 1100
C
C     SET UP NEW BLOCK IF THERE IS ROOM FOR IT IN CORE
C
      NBLKS1 = NBLKS + 1
      IF (LBLK*NBLKS1 .LE. LCOR) GO TO 1070
      WRITE  (NOUT,1060) SWM,NBLKS1
 1060 FORMAT (A27,' 1701, AVAILABLE CORE EXCEEDED BY',I10,' LINE IMAGE',
     1       ' BLOCKS.')
      NBLKS  = -1
      GO TO 9960
C
C     SET BLOCK POINTERS AND BLANK OUT LINE IMAGE
C
 1070 IP  = LBLK*NBLKS + 1
      IP1 = IP + 2
      IP2 = IP + LBLK - 1
      DO 1071 I = IP1,IP2
 1071 IX(I) = 0
      DO 1074 IJM = 1,IJMAX
      IF (IJM*NCC .LT. IZ) GO TO 1074
      IX(IP) = NCC*(IJM-1)
      GO TO 1075
 1074 CONTINUE
      KERROR = 1074
      GO TO 9950
 1075 DO 1079 IJM = 1,IJMAX
      IF (IJM*NLNXX .LT. NCOL) GO TO 1079
      IX(IP+1) = NLNXX*(IJM-1)
      GO TO 1080
 1079 CONTINUE
      KERROR = 1079
      GO TO 9950
 1080 IBLCU1 = IX(IP)
      IBLCU2 = IBLCU1 + NCC
      JBLCU1 = IX(IP+1)
      JBLCU2 = JBLCU1 + NLNXX
      NBLKS  = NBLKS1
      NBLCUR = NBLKS
      IF (NBLKS .LE. 0) GO TO 9997
C
C     INSERT BIT INTO PACKED LINE IMAGE BLOCK
C
 1100 A = NCC*(NCOL-IX(IP+1)-1) + (IZ-IX(IP))
      B = (A-1)/32
      C = IP1 + B
      B = A - 32*B
      IX(C) = ORF(IX(C),TWO(B))
C
C     END OF LOOP ON ROWS
C
      NROW = NROW + 1
      IF (NROW .LE. NROWS1) GO TO 200
      KERROR = 2000
      GO TO 9950
 2100 IF (NCOL-NCOL1 .LT. NLNXX) GO TO 3000
C
C     OUTPUT GROUP OF LINE IMAGE BLOCKS
C
      ASSIGN 2200 TO GOBAC
      GO TO 9500
 2200 NBLKS = 0
      NCOL1 = NCOL1 + NLNXX
C
C     END OF LOOP ON COLUMNS
C
 3000 NCOL = NCOL + 1
      IF (NCOL .LE. NCOLS) GO TO 100
C
C     OUTPUT RESIDUAL LINE IMAGE BLOCKS
C
      ASSIGN 3050 TO GOBAC
      GO TO 9500
 3050 NBLKS = 0
      GO TO 9997
C
C     OUTPUT GROUP OF LINE IMAGE BLOCKS
C
 9500 CONTINUE
      IF (NBLKS .LE. 0) GO TO 9699
      DO 9650 I = 1,NBLKS
      IP = LBLK*(I-1) + 1
      IF (PRNTIT) CALL PAGE1
      I1 = IX(IP)
      J100 = I1 + NCC
      DO 9510 IJ = 1,10
 9510 IRO(IJ) = I1 + 10*IJ
      IF (PRNTIT) WRITE (NOUT,9520) (IRO(IJ),IJ=1,10)
 9520 FORMAT (13H0TRANSPOSE OF,9X,8HCOLUMN..,10I10)
      IF (PRNTIT) WRITE (NOUT,9530) LBL(1),LBL(2)
 9530 FORMAT (8H MATRIX ,2A4,7X,3HROW,4X,10(9X,1H.),
     1        /23X,3H...,4X,100(1H.)/24X,1H.)
      ICOL1 = IX(IP+1)
      I100  = ICOL1 + NLNXX
      IP1   = IP - NCC1 + 1
      IF (PRNTIT) GO TO 9535
      PFILE = PFILE + 1
      CALL SOPEN (*85,PLOTER,X(KCOR),PLTBUF)
      CALL STPLOT (PFILE)
      CALL TIPE (XXXX,YYYY,1,PLUS,1,-1)
      IPAK  = (NCC+99)/100
      IJA   = 5*IPAK
      IJB   = NCC - IJA
      FNCCY = 1.005*FNCC
      DO 9531 IJ = IJA,IJB,IJA
      FIJ = FLOAT(IJ)
      CALL MAP (FIJ,FNCCY,XXXX,YYYY)
 9531 CALL TIPE (XXXX,YYYY,1,PLUS,1,0)
      FNCCX = 1.005*FNCC
      DO 9532 IJ = IJA,IJB,IJA
      FIJ = FNCC - FLOAT(IJ)
      CALL MAP (FNCCX,FIJ,XXXX,YYYY)
 9532 CALL TIPE (XXXX,YYYY,1,PLUS,1,0)
      FNCCY = 0.005*FNCC
      DO 9533 IJ = IJA,IJB,IJA
      FIJ = FNCC - FLOAT(IJ)
      CALL MAP (FIJ,FNCCY,XXXX,YYYY)
 9533 CALL TIPE (XXXX,YYYY,1,PLUS,1,0)
      FNCCX = 0.005*FNCC
      DO 9534 IJ = IJA,IJB,IJA
      FIJ = FLOAT(IJ)
      CALL MAP (FNCCX,FIJ,XXXX,YYYY)
 9534 CALL TIPE (XXXX,YYYY,1,PLUS,1,0)
 9535 DO 9600 IJ = 1,NLNXX
      IP1   = IP1 + NCC1
      IPIJ1 = IP1 + 1
      IPIJ2 = IP1 + NCC1
      IB    = NCC*(IJ-1)
      IW    = IB/32
      IB    = IB - 32*IW
      IW    = IW + IP + 2
      NOBITS= .TRUE.
      IF (PLOTIT) GO TO 9570
      DO 9536 JJ = 1,NCC1
 9536 LIN(JJ) = BLANK
      DO 9540 JJ = 1,NCC
      IB = IB + 1
      IF (IB .LE. 32) GO TO 9537
      IB = 1
      IW = IW + 1
 9537 IF (ANDF(IX(IW),TWO(IB)).EQ.0) GO TO 9540
      NOBITS = .FALSE.
      B   = (JJ-1)/4 + 1
      C   = JJ - 4*(B-1)
      IXX = XSTAR
      IF (IX(IP+1)+IJ.EQ.NCOLS .OR. IX(IP)+JJ.EQ.NROWS) IXX = XDOLR
      IF (SQ .AND. IX(IP+1)+IJ.EQ.IX(IP)+JJ) IXX = XDDDD
      LIN(B) = KHRFN1(LIN(B),C,IXX,1)
 9540 CONTINUE
      IF (NOBITS) GO TO 9560
      IF (MOD(IJ,5) .EQ. 0) GO TO 9550
      WRITE  (NOUT,9545) (LIN(JJ),JJ=1,NCC1)
 9545 FORMAT (28X,2H. ,25A4)
      GO TO 9600
 9550 ICOL1 = ICOL1 + 5
      WRITE  (NOUT,9555) ICOL1,(LIN(JJ),JJ=1,NCC1)
 9555 FORMAT (16X,I10,4H .. ,25A4)
      GO TO 9600
 9560 IF (MOD(IJ,5) .EQ. 0) GO TO 9565
      WRITE (NOUT,9545)
      GO TO 9600
 9565 ICOL1 = ICOL1 + 5
      WRITE (NOUT,9555) ICOL1
      GO TO 9600
 9570 FIJ = 101.0 - FLOAT(IJ)
      DO 9580 JJ = 1,NCC
      IB = IB + 1
      IF (IB .LE. 32) GO TO 9577
      IB = 1
      IW = IW + 1
 9577 IF (ANDF(IX(IW),TWO(IB)) .EQ. 0) GO TO 9580
      NOBITS = .FALSE.
      FJJ = FLOAT(JJ)
      CALL MAP (FJJ,FIJ,XXXX,YYYY)
      IF (SQ .AND. IX(IP+1)+IJ.EQ.IX(IP)+JJ) GO TO 9579
      IF (IX(IP+1)+IJ.EQ.NCOLS .OR. IX(IP)+JJ.EQ.NROWS) GO TO 9578
      CALL TIPE (XXXX,YYYY,1,XSTAR,1,0)
      GO TO 9580
 9578 CALL TIPE (XXXX,YYYY,1,XDOLR,1,0)
      GO TO 9580
 9579 CALL TIPE (XXXX,YYYY,1,XDDDD,1,0)
 9580 CONTINUE
 9600 CONTINUE
      IF (PRNTIT) WRITE (NOUT,9640)
 9640 FORMAT (1H0,29X,100(1H.)/30X,10(9X,1H.))
      IF (PRNTIT) GO TO 9650
      CALL STPLOT (-1)
      LNCT = LNCT + 1
      IF (LNCT .GT. NLINES) CALL PAGE1
      WRITE  (NOUT,9645) PFILE,I100,J100
 9645 FORMAT (1H ,62X,I5,2I6)
 9650 CONTINUE
C
 9699 GO TO GOBAC, (2200,3050)
C
 9950 WRITE  (NOUT,9952) SWM,KERROR
 9952 FORMAT (A27,' 1705, LOGIC ERROR AT STATEMENT',I5,
     1       ' IN SUBROUTINE SEEMAT.')
 9960 WRITE  (NOUT,9962) SIM,LBL
 9962 FORMAT (A31,' 1702, UTILITY MODULE SEEMAT WILL ABANDON ',
     1       'PROCESSING DATA BLOCK ',2A4 )
 9997 CALL CLOSE (NAM,1)
      IF (PRNTIT) GO TO 9998
      IF (TABLE ) GO TO 9998
      PFILE = PFILE + 1
      CALL SOPEN (*85,PLOTER,X(KCOR),PLTBUF)
      CALL STPLOT (PFILE)
      CALL LINE (BLLX,BLLY,BURX,BURY,1,-1)
      CALL LINE (BLLX,BLLY,BURX,BURY,1, 0)
      CALL LINE (BULX,BULY,BURX,BURY,1, 0)
      CALL LINE (BULX,BULY,BLRX,BLRY,1, 0)
      CALL LINE (BLRX,BLRY,BLLX,BLLY,1, 0)
      CALL LINE (BLLX,BLLY,BULX,BULY,1, 0)
      CALL LINE (BURX,BURY,BLRX,BLRY,1, 0)
      SYMBL(1) = 3
      SYMBL(2) = 6
      CALL MAP (0.505*FNCC,0.505*FNCC,XXXX,YYYY)
      CALL SYMBOL (XXXX,YYYY,SYMBL,-1)
      CALL SYMBOL (XXXX,YYYY,SYMBL, 0)
      CALL STPLOT (-1)
      LNCT = LNCT + 1
      WRITE  (NOUT,9996) PFILE
 9996 FORMAT (63X,I5,2X,13HTRAILER FRAME)
 9998 CONTINUE
 9999 RETURN
C
      END

      SUBROUTINE PKTRBS (IOPT)
C
C     BASIC BENDING TRIANGLE ELEMENT ROUTINE
C
C     THIS ROUTINE DOES SUB-CALCULATIONS FOR TRI OR QUAD PLATES IN PLA4
C
C     CALLS FROM THIS ROUTINE ARE MADE TO
C          MAT    - MATERIAL DATA ROUTINE
C
C     PLAMAT - ROTATES AND RETURNS GP MATRIX
C          TRANSD - DOUBLE PRECISION TRANSFORMATION SUPPLIER
C          INVERD - DOUBLE PRECISION INVERSE ROUTINE
C          GMMATD - DOUBLE PRECISION MATRIX MULTIPLY AND TRANSPOSE
C          MESAGE - ERROR MESSAGE WRITER
C
C     IOPT = 1   IMPLIES COMPUTE ONLY THE NINE (3X3)MATRICES
C                WHICH FORM THE 9X9 K SUPER U - MATRIX.
C     IOPT = 2   SAME AS IOPT = 1,BUT SAVE H-INVERSE AND S
C
C     ECPT LIST FOR BASIC BENDING TRIANGLE          NAME IN
C                                                   THIS
C     ECPT                                          ROUTINE   TYPE
C     ------------------------------------        -------------------
C     ECPT( 1) = ELEMENT ID                         NECPT(1)  INTEGER
C     ECPT( 2) = GRID POINT A                       NGRID(1)  INTEGER
C     ECPT( 3) = GRID POINT B                       NGRID(2)  INTEGER
C     ECPT( 4) = GRID POINT C                       NGRID(3)  INTEGER
C     ECPT( 5) = THETA = ANGLE OF MATERIAL          ANGLE     REAL
C     ECPT( 6) = MATERIAL ID 1                      MATID1    INTEGER
C     ECPT( 7) = I = MOMENT OF INERTIA              EYE       REAL
C     ECPT( 8) = MATERIAL ID 2                      MATID2    INTEGER
C     ECPT( 9) = T2                                 T2        REAL
C     ECPT(10) = NON-STRUCTURAL-MASS                FMU       REAL
C     ECPT(11) = Z1                                 Z11       REAL
C     ECPT(12) = Z2                                 Z22       REAL
C     ECPT(13) = COORD. SYSTEM ID 1                 NECPT(13) INTEGER
C     ECPT(14) = X1                                 X1        REAL
C     ECPT(15) = Y1                                 Y1        REAL
C     ECPT(16) = Z1                                 Z1        REAL
C     ECPT(17) = COORD. SYSTEM ID 2                 NECPT(17) INTEGER
C     ECPT(18) = X2                                 X2        REAL
C     ECPT(19) = Y2                                 Y2        REAL
C     ECPT(20) = Z2                                 Z2        REAL
C     ECPT(21) = COORD. SYSTEM ID 3                 NECPT(21) INTEGER
C     ECPT(22) = X3                                 X3        REAL
C     ECPT(23) = Y3                                 Y3        REAL
C     ECPT(24) = Z3                                 Z3        REAL
C     ECPT(25) = ELEMENT TEMPERATURE                ELTEMP    REAL
C
      INTEGER          SUBSCA,SUBSCB
      DOUBLE PRECISION A,E,XSUBB,TEMP,XSUBC,D,YSUBC,XCYC,XCSQ,DETERM,
     1                 YCSQ,XBSQ,G2X2,TITE,TJTE,S,TI,J2X2,AREA,G,XBAR,
     2                 YBAR,PX2,PY2,PXY2,XBAR3,YBAR2,YBAR3,PROD9,TEMP9
      DIMENSION        D(9),G2X2(4),J2X2(4),S(18),ECPT(1),G(9),TJTE(18),
     1                 TITE(18),TI(9)
      COMMON /PLA42C/  NPVT,DUM1(148),NOGO
      COMMON /MATIN /  MATID,INFLAG,ELTEMP,STRESS,SINTH,COSTH
      COMMON /MATOUT/  G11,G12,G13,G22,G23,G33,RHO,ALPHA1,ALPHA2,ALP12,
     1                 T SUB 0, G SUB E, SIGTEN, SIGCOM, SIGSHE,
     2                 G2X211, G2X212, G2X222
C
C     ECPT BLOCK
      COMMON /PLA4ES/  NECPT(1),NGRID(3),ANGLE,MATID1,EYE,MATID2,T2,FMU,
     1                 Z11,Z22,DUMMY1,X1,Y1,Z1,DUMMY2,X2,Y2,Z2,DUMMY3,
     2                 X3,Y3,Z3,DUMB(76)
      COMMON /PLA42D/  A(225),PROD9(9),TEMP9(9),XSUBB,XSUBC,YSUBC,E(18),
     1                 TEMP,XBAR,AREA,XCSQ,YBAR2,YCSQ,YBAR,XBSQ,PX2,
     2                 XCYC,PY2,PXY2,XBAR3,YBAR3,DETERM,NSIZED,
     3                 DUMDUM(4),NPIVOT,THETA,NSUBC,ISING,SUBSCA,SUBSCB,
     4                 NBEGIN,DUMMY(30)
      EQUIVALENCE      (D(1),G(1),A(79)),(ECPT(1),NECPT(1)),
     1                 (G2X2(1),A(88)),(TJTE(1),A(100)),
     2                 (TITE(1),S(1),A(82)),(J2X2(1),A(92)),
     3                 (TI(1),A(118))
C
C
      MATID  = MATID1
      INFLAG = -1
C
      CALL PLAMAT
C
C     FILL G-MATRIX WITH OUTPUT FROM MAT ROUTINE
C
      G(1) = G11
      G(2) = G12
      G(3) = G13
      G(4) = G12
      G(5) = G22
      G(6) = G23
      G(7) = G13
      G(8) = G23
      G(9) = G33
C
C     COMPUTATION OF D = I.G-MATRIX (EYE IS INPUT FROM THE ECPT)
C
      DO 90 I = 1,9
   90 D(I) = G(I)*DBLE(EYE)
C
      AREA = XSUBB*YSUBC/2.0D0
      XBAR =(XSUBB + XSUBC)/3.0D0
      YBAR = YSUBC/3.0D0
C
      XCSQ  = XSUBC**2
      YCSQ  = YSUBC**2
      XBSQ  = XSUBB**2
      XCYC  = XSUBC*YSUBC
      PX2   = (XBSQ + XSUBB*XSUBC + XCSQ)/6.0D0
      PY2   = YCSQ/6.0D0
      PXY2  = YSUBC*(XSUBB + 2.0D0*XSUBC)/12.0D0
      XBAR3 = 3.0D0*XBAR
      YBAR3 = 3.0D0*YBAR
      YBAR2 = 2.0D0*YBAR
C
C                 X
C     FILL THE  (K ) MATRIX STORING IN  A(1) THRU A(36)
C
      A( 1) = D( 1)
      A( 2) = D( 3)
      A( 3) = D( 2)
      A( 4) = D( 1)*XBAR3
      A( 5) = D( 2)*XBAR + YBAR2*D(3)
      A( 6) = D( 2)*YBAR3
      A( 7) = A( 2)
      A( 8) = D( 9)
      A( 9) = D( 6)
      A(10) = D( 3)*XBAR3
      A(11) = D( 6)*XBAR + YBAR2*D(9)
      A(12) = D( 6)*YBAR3
      A(13) = A( 3)
      A(14) = A( 9)
      A(15) = D( 5)
      A(16) = D( 2)*XBAR3
      A(17) = D( 5)*XBAR + YBAR2*D(6)
      A(18) = D( 5)*YBAR3
      A(19) = A( 4)
      A(20) = A(10)
      A(21) = A(16)
      A(22) = D( 1)*9.0D0*PX2
      A(23) = D( 2)*3.0D0*PX2 + 6.0D0*PXY2*D(3)
      A(24) = D( 2)*9.0D0*PXY2
      A(25) = A( 5)
      A(26) = A(11)
      A(27) = A(17)
      A(28) = A(23)
      A(29) = D( 5)*PX2 + 4.0D0*PXY2*D(6) + 4.0D0*PY2*D(9)
      A(30) = D( 5)*3.0D0*PXY2 + 6.0D0*PY2*D(6)
      A(31) = A( 6)
      A(32) = A(12)
      A(33) = A(18)
      A(34) = A(24)
      A(35) = A(30)
      A(36) = D( 5)*9.0D0*PY2
      TEMP  = 4.0D0*AREA
      DO 70 I = 1,36
   70 A(I)  = A(I)*TEMP
C
C     F1LL  (HBAR) MATRIX STORING AT A(37) THRU A(72)
C
      DO 130 I = 37,72
  130 A(I) = 0.0D0
C
      A(37) = XBSQ
      A(40) = XBSQ*XSUBB
      A(44) = XSUBB
      A(49) =-2.0D0*XSUBB
      A(52) =-3.0D0*XBSQ
      A(55) = XCSQ
      A(56) = XCYC
      A(57) = YCSQ
      A(58) = XCSQ*XSUBC
      A(59) = YCSQ*XSUBC
      A(60) = YCSQ*YSUBC
      A(62) = XSUBC
      A(63) = YSUBC*2.0D0
      A(65) = XCYC *2.0D0
      A(66) = YCSQ *3.0D0
      A(67) =-2.0D0*XSUBC
      A(68) =-YSUBC
      A(70) =-3.0D0*XCSQ
      A(71) =-YCSQ
C
      IF (T2 .EQ. 0.0E0) GO TO 500
C
C     ALL OF THE FOLLOWING OPERATIONS THROUGH STATEMENT LABEL 500
C     ARE NECESSARY IF T2 IS NON-ZERO.
C
C     GET THE G2X2 MATRIX
C
      MATID  = MATID2
      INFLAG = 3
      CALL MAT (ECPT(1))
      IF (G2X211.EQ.0.0 .AND. G2X212.EQ.0.0 .AND. G2X222.EQ.0.0)
     1    GO TO 500
      G2X2(1) = G2X211*T2
      G2X2(2) = G2X212*T2
      G2X2(3) = G2X212*T2
      G2X2(4) = G2X222*T2
C
      DETERM  = G2X2(1)*G2X2(4) - G2X2(3)*G2X2(2)
      J2X2(1) = G2X2(4)/DETERM
      J2X2(2) =-G2X2(2)/DETERM
      J2X2(3) =-G2X2(3)/DETERM
      J2X2(4) = G2X2(1)/DETERM
C
C     (H  ) IS PARTITIONED INTO A LEFT AND RIGHT PORTION AND ONLY THE
C       YQ  RIGHT PORTION IS COMPUTED AND USED AS A  (2X3). THE LEFT
C           2X3 PORTION IS NULL.  THE RIGHT PORTION WILL BE STORED AT
C           A(73)...A(78) UNTIL NOT NEEDED ANY FURTHER.
C
      TEMP  =  2.0D0*D(2) + 4.0D0*D(9)
      A(73) = -6.0D0*(J2X2(1)*D(1) + J2X2(2)*D(3))
      A(74) = -J2X2(1)*TEMP + 6.0D0*J2X2(2)*D(6)
      A(75) = -6.0D0*(J2X2(1)*D(6) + J2X2(2)*D(5))
      A(76) = -6.0D0*(J2X2(2)*D(1) + J2X2(4)*D(3))
      A(77) = -J2X2(2)*TEMP + 6.0D0*J2X2(4)*D(6)
      A(78) = -6.0D0*(J2X2(2)*D(6) + J2X2(4)*D(5))
C
C     THE ABOVE 6 ELEMENTS NOW REPRESENT THE (H  ) MATRIX (2X3)
C                                              YQ
C
C     NOW FORMING  PRODUCT (G2X2)(H  ) AND STORING AS AN INTERMEDIATE
C     STEP.                        YQ
C
      CALL GMMATD (G2X2(1),2,2,0, A(73),2,3,0, A(79))
C
C                                                               Y
C     WITH LAST PRODUCT  FORM  LOWER RIGHT 3 X 3 PARTITION OF (K )
C
C              Y                   T
C     THUS   (K ) PARTITION = (H  ) (LAST PRODUCT)   STORE AT A(85)
C                               YQ
C
      CALL GMMATD (A(73),2,3,1, A(79),2,3,0, A(85))
C
C                                                     X
C     NOW ADD THE 9 ELEMENTS OF THIS 3X3 PORTION TO (K )
C     PER STEP 5 PAGE -16- MS-17                            Y
C     MULTIPLY IN AREA AT SAME TIME WHICH WAS LEFT OUT OF (K ) ABOVE.
C
      DO 60 I = 1,3
      A(I+21) = A(I+21) + A(I+84)*AREA
      A(I+27) = A(I+27) + A(I+87)*AREA
   60 A(I+33) = A(I+33) + A(I+90)*AREA
C
C     ADD TO 6 OF THE (HBAR) ELEMENTS THE RESULT OF (H  )(H  )
C                                                    UY   YQ
C     THE PRODUCT IS FORMED DIRECTLY IN THE ADDITION PROCESS BELOW.
C     NO (H  ) MATRIX IS ACTUALLY COMPUTED DIRECTLY.
C          UY
C
C     THE FOLLOWING IS THEN PER STEPS 6 AND 7 PAGE -16- MS-17.
C
      DO 75 I = 1,3
      A(I+39) = A(I+39) + XSUBB*A(I+72)
   75 A(I+57) = A(I+57) + XSUBC*A(I+72) + YSUBC*A(I+75)
C
C     THIS ENDS ADDED COMPUTATION FOR CASE OF T2 NOT ZERO
C
  500 CONTINUE
C
C     AT THIS POINT INVERT  (H) WHICH IS STORED AT A(37) THRU A(72)
C     STORE INVERSE BACK IN A(37) THRU A(72)
C     NO NEED TO COMPUTE DETERMINANT SINCE IT IS NOT USED SUBSEQUENTLY.
C
      ISING = -1
      CALL INVERD (6,A(37),6,A(73),0,DETERM,ISING,A(79))
C
C     CHECK TO SEE IF H WAS SINGULAR
C
      IF (ISING .NE. 2) GO TO 440
C
C     ISING = 2 IMPLIES SINGULAR MATRIX THUS ERROR CONDITION.
C
      CALL MESAGE (30,33,ECPT(1))
C
C     SET FLAG FOR FATAL ERROR WHILE ALLOWING ERROR MESSAGES TO
C     ACCUMULATE
C
      NOGO = 1
      RETURN
C
C              Q   -1
C 440 FORM   (K )(H  )  AND STORE AT  A(73) THRU A(108)
C
C                 X                     Q
C     NOTE THAT (K ) AT THIS POINT IS (K )
C
  440 CALL GMMATD (A(1),6,6,0, A(37),6,6,0, A(73))
C
C                    -1 T
C     FORM(K  ) = (H  ) (LAST PRODUCT) STORE AT A(109) THRU A(144)
C            II
C
      CALL GMMATD (A(37),6,6,1, A(73),6,6,0, A(109))
C
C     FILL S-MATRIX EQUIVALENCED TO A(82)  (S IS 6X3)
C
      IF (IOPT .NE. 2) GO TO 700
C
C     SAVE H-INVERSE TO BE USED BY TRIANGULAR PLATE ROUTINE.
C
      DO 710 I = 37,72
  710 A(I+108) = A(I)
C
  700 S( 1) = 1.0D0
      S( 2) = 0.0D0
      S( 3) =-XSUBB
      S( 4) = 0.0D0
      S( 5) = 1.0D0
      S( 6) = 0.0D0
      S( 7) = 0.0D0
      S( 8) = 0.0D0
      S( 9) = 1.0D0
      S(10) = 1.0D0
      S(11) = YSUBC
      S(12) =-XSUBC
      S(13) = 0.0D0
      S(14) = 1.0D0
      S(15) = 0.0D0
      S(16) = 0.0D0
      S(17) = 0.0D0
      S(18) = 1.0D0
C
C                     T
C     FORM   K   = K   = -K   S  STORING AT A(46)   (K   IS 6X3)
C             IA    AI     II                         IA
C
       CALL GMMATD (A(109),6,6,0, S(1),6,3,0, A(46))
C
C     THIS PRODUCT IS MULTIPLIED BY SCALER -1 BELOW.
C
C                    T
C          (K  ) = (S )(-K  )
C            AA           IA
C
C     NOTE K    HAS NOT BEEN MULTIPLIED ABOVE BY -1, THUS IGNORE MINUS
C           IA                                                   HERE.
C
      CALL GMMATD (S(1),6,3,1, A(46),6,3,0, A(1))
C
C     NOW MULTIPLY  K   BY SCALER (-1)
C                    IA
C
      DO 190 I = 46,63
  190 A(I) = -A(I)
C
C     AT THIS POINT, STORED BY ROWS ARE
C
C        K     (6X6) AT A(109) THRU A(144)
C         II
C
C        K     (6,3) AT  A(46) THRU A(63)
C         IA
C
C        K     (3X3) AT A(1) THRU A(9)
C         AA
C
C     ARRANGE NINE 3X3 MATRICES OF K SUPER U
C
      A( I) = A(I+18)
      A(10) = A( 46)
      A(11) = A( 49)
      A(12) = A( 52)
      A(13) = A( 47)
      A(14) = A( 50)
      A(15) = A( 53)
      A(16) = A( 48)
      A(17) = A( 51)
      A(18) = A( 54)
      A(19) = A( 55)
      A(20) = A( 58)
      A(21) = A( 61)
      A(22) = A( 56)
      A(23) = A( 59)
      A(24) = A( 62)
      A(25) = A( 57)
      A(26) = A( 60)
      A(27) = A( 63)
      A(37) = A(109)
      A(38) = A(110)
      A(39) = A(111)
      A(40) = A(115)
      A(41) = A(116)
      A(42) = A(117)
      A(43) = A(121)
      A(44) = A(122)
      A(45) = A(123)
      A(46) = A(112)
      A(47) = A(113)
      A(48) = A(114)
      A(49) = A(118)
      A(50) = A(119)
      A(51) = A(120)
      A(52) = A(124)
      A(53) = A(125)
      A(54) = A(126)
      A(64) = A(127)
      A(65) = A(128)
      A(66) = A(129)
      A(67) = A(133)
      A(68) = A(134)
      A(69) = A(135)
      A(70) = A(139)
      A(71) = A(140)
      A(72) = A(141)
      A(73) = A(130)
      A(74) = A(131)
      A(75) = A(132)
      A(76) = A(136)
      A(77) = A(137)
      A(78) = A(138)
      A(79) = A(142)
      A(80) = A(143)
      A(81) = A(144)
      RETURN
      END

      SUBROUTINE T3BGBS (NG,NB,GMAT,BMAT,KMAT)
C
C     WITH ENTRY T3BGBD (NG,NB,GMAD,BMAD,KMAD)
C
C     ROUTINE FOR EFFICIENT TRIPLE-MULTPLICATION OF [B] AND [G] MATRICES
C     TO EVALUATE THE CONTRIBUTION TO THE ELEMENT STIFFNESS MATRIX FROM
C     THE CURRENT INTEGRATION POINT
C
C
C     INPUT :
C           NG          - NUMBER OF ROWS AND COLUMNS OF GMAT
C           NB          - NUMBER OF COLUMNS OF BMAT
C           GMAT/GMAD   - [G], FORCE-STRAIN RELATIONSHIP
C           BMAT/BMAD   - [B], STRAIN-DISPLACEMENT RELATIONSHIP
C     OUTPUT:
C           KMAT/KMAD   - CONTRIBUTION TO THE ELEMENT STIFFNESS MATRIX
C                         FROM THE CURRENT INTEGRATION POINT
C
C     ALGORITHM:
C           MATRICES ARE MULTIPLIED IN FULL WHEN MEMBRANE-BENDING
C           COUPLING IN PRESENT, OTHERWISE PARTIAL MULTIPLICATION
C           IS PERFORMED.
C           IN EACH TRIPLE MULTIPLY, THE RESULT IS ADDED TO KMAT.
C
C
      LOGICAL          MEMBRN,BENDNG,SHRFLX,MBCOUP,NORPTH
      REAL             GMAT(9,1),BMAT(1),KMAT(1),G1(3,3),GBMAT(162)
      DOUBLE PRECISION GMAD(9,1),BMAD(1),KMAD(1),G2(3,3),GBMAD(162)
      COMMON /TERMS /  MEMBRN,BENDNG,SHRFLX,MBCOUP,NORPTH
      EQUIVALENCE      (G1(1,1),G2(1,1)),(GBMAT(1),GBMAD(1))
C
C
C     SINGLE PRECISION
C
      ND3 = NB*3
      ND6 = NB*6
C
C     IF [G] IS FULLY POPULATED, PERFORM STRAIGHT MULTIPLICATION AND
C     RETURN.
C
      IF (.NOT.MBCOUP) GO TO 10
      CALL GMMATS (GMAT,NG,NG,0,  BMAT,NG,NB,0,  GBMAT)
      CALL GMMATS (BMAT,NG,NB,-1, GBMAT,NG,NB,0, KMAT )
      GO TO 60
C
C     MULTIPLY MEMBRANE TERMS WHEN PRESENT
C
   10 IF (.NOT.MEMBRN) GO TO 30
      DO 20 I = 1,3
      DO 20 J = 1,3
      G1(I,J) = GMAT(I,J)
   20 CONTINUE
      CALL GMMATS (G1,3,3,0, BMAT(1),3,NB,0, GBMAT)
      CALL GMMATS (BMAT(1),3,NB,-1, GBMAT,3,NB,0, KMAT)
C
C     MULTIPLY BENDING TERMS WHEN PRESENT
C
   30 IF (.NOT.BENDNG) GO TO 60
      DO 40 I = 1,3
      II = I + 3
      DO 40 J = 1,3
      JJ = J + 3
      G1(I,J) = GMAT(II,JJ)
   40 CONTINUE
      CALL GMMATS (G1,3,3,0, BMAT(ND3+1),3,NB,0, GBMAT)
      CALL GMMATS (BMAT(ND3+1),3,NB,-1, GBMAT,3,NB,0, KMAT)
C
      DO 50 I = 1,3
      II = I + 6
      DO 50 J = 1,3
      JJ = J + 6
      G1(I,J) = GMAT(II,JJ)
   50 CONTINUE
      CALL GMMATS (G1,3,3,0, BMAT(ND6+1),3,NB,0, GBMAT)
      CALL GMMATS (BMAT(ND6+1),3,NB,-1, GBMAT,3,NB,0, KMAT)
   60 RETURN
C
C
      ENTRY T3BGBD (NG,NB,GMAD,BMAD,KMAD)
C     ===================================
C
C     DOUBLE PRECISION
C
      ND3 = NB*3
      ND6 = NB*6
C
C     IF [G] IS FULLY POPULATED, PERFORM STRAIGHT MULTIPLICATION AND
C     RETURN.
C
      IF (.NOT.MBCOUP) GO TO 100
      CALL GMMATD (GMAD,NG,NG,0,  BMAD,NG,NB,0,  GBMAD)
      CALL GMMATD (BMAD,NG,NB,-1, GBMAD,NG,NB,0, KMAD )
      GO TO 150
C
C     MULTIPLY MEMBRANE TERMS WHEN PRESENT
C
  100 IF (.NOT.MEMBRN) GO TO 120
      DO 110 I = 1,3
      DO 110 J = 1,3
      G2(I,J) = GMAD(I,J)
  110 CONTINUE
      CALL GMMATD (G2,3,3,0, BMAD(1),3,NB,0, GBMAD)
      CALL GMMATD (BMAD(1),3,NB,-1, GBMAD,3,NB,0, KMAD)
C
C     MULTIPLY BENDING TERMS WHEN PRESENT
C
  120 IF (.NOT.BENDNG) GO TO 150
      DO 130 I = 1,3
      II = I + 3
      DO 130 J = 1,3
      JJ = J + 3
      G2(I,J) = GMAD(II,JJ)
  130 CONTINUE
      CALL GMMATD (G2,3,3,0, BMAD(ND3+1),3,NB,0, GBMAD)
      CALL GMMATD (BMAD(ND3+1),3,NB,-1, GBMAD,3,NB,0, KMAD)
C
      DO 140 I = 1,3
      II = I + 6
      DO 140 J = 1,3
      JJ = J + 6
      G2(I,J) = GMAD(II,JJ)
  140 CONTINUE
      CALL GMMATD (G2,3,3,0, BMAD(ND6+1),3,NB,0, GBMAD)
      CALL GMMATD (BMAD(ND6+1),3,NB,-1, GBMAD,3,NB,0, KMAD)
C
  150 RETURN
C
      END

      SUBROUTINE KTETRA (IOPT,JTYPE)
C
C     ELEMENT STIFFNESS MATRIX GENERATOR FOR THE TETRAHEDRON SOLID
C     ELEMENT
C
C     LOOKING DOWN ON THIS ELEMENT, GRIDS 1,2,3 ARE THE BASE AND MUST BE
C     LABELED COUNTERCLOCKWISE. GRID 4 MUST BE ABOVE THE PLANE FORMED BY
C     GRIDS 1,2,3 AND CLOSEST TO THIS OBSERVER.
C
C     ECPT FOR THE TETRAHEDRON SOLID ELEMENT
C     --------------------------------------
C     ECPT( 1) = ELEMENT  ID
C     ECPT( 2) = MATERIAL ID (MAT1 MATERIAL TYPE)
C     ECPT( 3) = SIL GRID POINT 1
C     ECPT( 4) = SIL GRID POINT 2
C     ECPT( 5) = SIL GRID POINT 3
C     ECPT( 6) = SIL GRID POINT 4
C     ECPT( 7) = COORD SYS ID GRID PT 1
C     ECPT( 8) = X1
C     ECPT( 9) = Y1
C     ECPT(10) = Z1
C     ECPT(11) = COORD SYS ID GRID PT 2
C     ECPT(12) = X2
C     ECPT(13) = Y2
C     ECPT(14) = Z2
C     ECPT(15) = COORD SYS ID GRID PT 3
C     ECPT(16) = X3
C     ECPT(17) = Y3
C     ECPT(18) = Z3
C     ECPT(19) = COORD SYS ID GRID PT 4
C     ECPT(20) = X4
C     ECPT(21) = Y4
C     ECPT(22) = Z4
C     ECPT(23) = ELEMENT TEMPERATURE
C
C     JTYPE = 1 FOR WEDGE, = 2 FOR HEXA1, = 3 FOR HEXA2, AND = 0 TETRA
C     IF JTYPE IS NEGATIVE, THIS IS LAST CALL FROM KSOLID
C
C
      LOGICAL         NOGO    ,HEAT      ,HYDRO
      INTEGER         OUT     ,NECPT(4)  ,DIREC    ,EL(2,4)  ,SCR4
      REAL            NU      ,MATBUF
      DOUBLE PRECISION C      ,G         ,H        ,TEMP     ,HDETER  ,
     1                TEMP1   ,T         ,CT       ,KIJ      ,GCT
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /BLANK / SKIP(16) ,VOLUME   ,SURFAC
      COMMON /SMA1ET/ ECPT(100)
      COMMON /SMA1DP/ C(72)    ,G(36)    ,H(16)    ,TEMP(12) ,T(9)    ,
     1                CT(18)   ,GCT(18)  ,KIJ(36)  ,HDETER   ,TEMP1   ,
     2                NGPT     ,DIREC    ,KOUNT    ,TVOL
      COMMON /SMA1HT/ HEAT
      COMMON /HYDROE/ HYDRO
      COMMON /MATIN / MATID    ,INFLAG   ,ELTEMP
      COMMON /MATOUT/ E        ,GG       ,NU       ,RHO      ,ALPHA   ,
     1                TSUB0    ,GSUBE    ,SIGT     ,SIGC     ,SIGS
      COMMON /HMTOUT/ MATBUF(7)
      COMMON /SMA1CL/ IOPT4    ,K4GGSW   ,NPVT     ,ISKP(17) ,NOGOO
      COMMON /SMA1IO/ DUM1(10) ,IFKGG    ,DUM2(1)  ,IF4GG    ,DUM3(23)
      COMMON /SYSTEM/ SYSBUF   ,OUT      ,NOGO
      EQUIVALENCE     (NECPT(1),ECPT(1))
      DATA    IDFLAG/ 0 /,    SCR4    /   304 /
      DATA    EL    / 4HCWED, 4HGE  , 4HCHEX, 4HA1  , 4HCHEX, 4HA2  ,
     1                4HCTET, 4HRA    /
C
C     FILL THE 4 X 4 H MATRIX.
C
      IF (NECPT(1) .EQ. IDFLAG) GO TO 100
      IDFLAG = NECPT(1)
      DIREC  = 0
      KOUNT  = 0
      TVOL   = 0.0
      NGPT   = 99
      IF (VOLUME.LE.0.0 .AND. SURFAC.LE.0.0) GO TO 100
      NGPT   = 8
      IF (IABS(JTYPE) .EQ. 1) NGPT = 6
      IF (JTYPE .EQ. 0) NGPT  = 4
  100 IF (JTYPE .LE. 0) KOUNT = KOUNT + 1
C
C     RETURN IF SUB-TETRA DOES NOT CONTRIBUTE TO PIVOT STIFFNESS AND NO
C     GEOMETRY TESTS ARE BEING MADE ON IT.
C
      IF (IOPT .GE. 100) GO TO 140
      DO 131 I = 3,6
      IF (NPVT .EQ. NECPT(I)) GO TO 140
  131 CONTINUE
      IF (KOUNT.EQ.NGPT .AND. JTYPE.NE.0) GO TO 910
      RETURN
C
  140 H( 1) = 1.0D0
      H( 2) = ECPT( 8)
      H( 3) = ECPT( 9)
      H( 4) = ECPT(10)
      H( 5) = 1.0D0
      H( 6) = ECPT(12)
      H( 7) = ECPT(13)
      H( 8) = ECPT(14)
      H( 9) = 1.0D0
      H(10) = ECPT(16)
      H(11) = ECPT(17)
      H(12) = ECPT(18)
      H(13) = 1.0D0
      H(14) = ECPT(20)
      H(15) = ECPT(21)
      H(16) = ECPT(22)
C
C     INVERT H AND GET THE DETERMINANT
C
      ISING = 0
      CALL INVERD (4,H(1),4,DUM,0,HDETER,ISING,TEMP(1))
C
C     IF THE DETERMINANT IS .LE. 0 THE TETRAHEDRON HAS BAD OR REVERSE
C     GEOMETRY WHICH IS AN ERROR CONDITION.
C
      IF (ISING .EQ.  2) GO TO 149
      IF (IOPT .LT. 100) GO TO 200
      IOPT = IOPT - 100
      IF (DIREC .NE.  0) GO TO 148
      DIREC = 1
      IF (HDETER .LT.0.0D0) DIREC = -1
      GO TO 200
  148 IF (DIREC.EQ. 1 .AND. HDETER.GT.0.0D0) GO TO 200
      IF (DIREC.EQ.-1 .AND. HDETER.LT.0.0D0) GO TO 200
  149 WRITE  (OUT,150) UFM,NECPT(1)
  150 FORMAT (A23,' 4004, MODULE SMA1 DETECTS BAD OR REVERSE GEOMETRY ',
     1       'FOR ELEMENT ID',I10)
      NOGOO = 1
      RETURN
C
C     SKIP SUB-TETRAHEDRON IF IT DOES NOT CONTRIBUTE TO PIVOT STIFFNESS
C
  200 DO 201 I = 3,6
      IF (NPVT .EQ. NECPT(I)) GO TO 209
  201 CONTINUE
      IF (KOUNT.EQ.NGPT .AND. JTYPE.NE.0) GO TO 910
      RETURN
C
C     AT THIS POINT BRANCH ON HEAT OR STRUCTURE PROBLEM.
C
  209 HDETER = DABS(HDETER)
      IF (HEAT ) GO TO 1010
      IF (HYDRO) GO TO 1060
C
C     GET THE MATERIAL DATA AND FILL THE 6X6 G MATERIAL STRESS-STRAIN
C     MATRIX.
C
      INFLAG = 1
      MATID  = NECPT(2)
      ELTEMP = ECPT(23)
      CALL MAT (NECPT(1))
      DO 210 I = 1,36
  210 G(I)  = 0.0D0
      TEMP1 = (1.0+NU)*(1.0-2.0*NU)
      IF (DABS(TEMP1) .GT. 1.0D-6) GO TO 240
      WRITE  (OUT,230) UFM,MATID,ECPT(1)
  230 FORMAT (A23,' 4005, AN ILLEGAL VALUE OF -NU- HAS BEEN SPECIFIED ',
     1       'UNDER MATERIAL ID',I10,' FOR ELEMENT ID',I10)
      NOGOO = 1
      RETURN
C
  240 G( 1) = E*(1.0-NU)/TEMP1
      G( 8) = G(1)
      G(15) = G(1)
      G( 2) = E*NU/TEMP1
      G( 3) = G(2)
      G( 7) = G(2)
      G( 9) = G(2)
      G(13) = G(2)
      G(14) = G(2)
      G(22) = GG
      G(29) = GG
      G(36) = GG
C
C     FILL 4 C-MATRICES. (6X3) EACH.
C
      DO 400 I = 1,72
  400 C(I) = 0.0D0
      DO 500 I = 1,4
      J = 18*I - 18
      C(J+ 1) = H(I+ 4)
      C(J+ 5) = H(I+ 8)
      C(J+ 9) = H(I+12)
      C(J+11) = H(I+12)
      C(J+12) = H(I+ 8)
      C(J+13) = H(I+12)
      C(J+15) = H(I+ 4)
      C(J+16) = H(I+ 8)
      C(J+17) = H(I+ 4)
  500 CONTINUE
C
C     DIVIDE DETERMINANT BY 6.0, AND BY AN ADDITIONAL 2.0 IF A SUB-TETRA
C     FOR THE HEXA-10 ELEMENT.
C     FOR WEDGES, 1ST 6 CONFIGURATUONS ARE MULTIPLIED BY 2.
C     ALL CONFIGURATIONS ARE DIVIDED BY 6.
C
      IF (IOPT) 602,601,602
  601 HDETER = HDETER/6.0D0
      GO TO 610
  602 IF (IOPT.GE.11 .AND. IOPT.LE.22) GO TO 603
      HDETER = HDETER/12.0D0
      GO TO 610
C
C     WEDGES
C
  603 HDETER = HDETER/36.0D0
      IF (IOPT .LE. 16) HDETER = HDETER*2.0D0
  610 DO 700 I = 1,36
  700 KIJ(I) = 0.0D0
C
C     DETERMINE THE PIVOT POINT
C
      DO 720 I = 2,5
      KA = 4*I - 1
      NPOINT = 18*I - 35
      IF (NECPT(I+1) .NE. NPVT) GO TO 720
      GO TO 740
  720 CONTINUE
      CALL MESAGE (-30,34,ECPT(1))
C
C     PICK UP PIVOT TRANSFORMATION IF CSID IS NON-ZERO.
C
  740 IF (NECPT(KA)) 750,760,750
  750 CALL TRANSD (NECPT(KA),T)
      CALL GMMATD (T(1),3,3,1, C(NPOINT),6,3,1, CT(1))
      GO TO 778
C
C                     T  T
C     AT THIS POINT  T  C  IS STORED AS A 3X6 IN THE CT ARRAY.
C                     I  I
C
C                                                T T
C     NOW MULTIPLY ON THE RIGHT BY G   TO FORM  T C G   (3X6)
C                                   E            I I E
C
  760 CALL GMMATD (C(NPOINT),6,3,1, G(1),6,6,0, GCT(1))
      GO TO 781
  778 CALL GMMATD (CT(1),3,6,0, G(1),6,6,0, GCT(1))
  781 DO 790 I = 1,18
      GCT(I) = GCT(I)*HDETER
  790 CONTINUE
C
C     LOOP THROUGH THE 4 POINTS INSERTING THE STIFFNESS MATRIX FOR
C     EACH WITH RESPECT TO THE PIVOT POINT.
C
      DO 900 I = 1,4
      IF (NECPT(4*I+3)) 810,820,810
  810 CALL TRANSD (NECPT(4*I+3),T)
      CALL GMMATD (C(18*I-17),6,3,0, T(1),3,3,0, CT(1))
      CALL GMMATD (GCT(1),3,6,0, CT(1),6,3,0, T(1))
      GO TO 830
C
C     NO TRANSFORMATION
C
  820 CALL GMMATD (GCT(1),3,6,0, C(18*I-17),6,3,0, T(1))
C
C     INSERT 3X3 KIJ INTO 6X6 KIJ AND CALL SMA1B FOR INSERTION.
C
  830 KIJ( 1) = T(1)
      KIJ( 2) = T(2)
      KIJ( 3) = T(3)
      KIJ( 7) = T(4)
      KIJ( 8) = T(5)
      KIJ( 9) = T(6)
      KIJ(13) = T(7)
      KIJ(14) = T(8)
      KIJ(15) = T(9)
C
      CALL SMA1B (KIJ(1),NECPT(I+2),-1,IFKGG,0.0D0)
      TEMP1 = GSUBE
      IF (IOPT4) 840,900,840
  840 IF (GSUBE) 850,900,850
  850 CALL SMA1B (KIJ(1),NECPT(I+2),-1,IF4GG,TEMP1)
C
  900 CONTINUE
C
C     IF USER REQUESTED VOLUME AND SURFACE CALCULATIONS, WE NEED TO SAVE
C     IN SCR4 THE FOLLOWING
C     WORDS 1,2 = ELEM. BCD NAME
C             3 = ELEM. ID
C             4 = VOLUME
C             5 = MASS
C             6 = NO. OF GRID POINTS, NGPT
C           7 THRU 6+NGPT = GRID POINTS
C           7+NGPT THRU 7+5*NGPT = BGPDT DATA
C
      TVOL = TVOL + HDETER/4.0D+0
      IF (KOUNT .LT. NGPT) GO TO 950
  910 IF (JTYPE .GT. 0) GO TO 950
      ECPT(2) = TVOL*VOLUME
      IF (JTYPE.EQ.0 .AND. SURFAC.GT.0.0) GO TO 920
      J = IABS(JTYPE)
      ECPT(3) = TVOL
      IF (RHO .GT. 0.0) ECPT(3) = TVOL*RHO
      NECPT(4) = NGPT
      CALL WRITE (SCR4,EL(1,J),2,0)
      CALL WRITE (SCR4,ECPT(1),4,0)
      IF (SURFAC .LE. 0.0) GO TO 950
      J = NGPT*5
      CALL WRITE (SCR4,ECPT(53),J,1)
      GO TO 950
  920 CALL WRITE (SCR4,EL(1,4),2,0)
      CALL WRITE (SCR4,ECPT(1),2,0)
      IF (RHO .GT. 0.0) TVOL = TVOL*RHO
      ECPT (1) = TVOL
      NECPT(2) = NGPT
      CALL WRITE (SCR4,ECPT(1),22,1)
C
  950 RETURN
C
C     HEAT PROBLEM LOGIC FOR 1 PIVOT ROW OF 1 TETRAHEDRON.
C
C     OBTAIN G  MATERIAL MATRIX FROM HMAT ROUTINE
C             E
C
 1010 MATID  = NECPT(2)
      INFLAG = 3
      ELTEMP = ECPT(23)
      CALL HMAT (NECPT)
      G( 1)  = 0.0D0
      G( 2)  = 0.0D0
      G( 3)  = 0.0D0
      G( 4)  = 0.0D0
      G( 5)  = 0.0D0
      G( 6)  = MATBUF(1)
      G( 7)  = MATBUF(2)
      G( 8)  = MATBUF(3)
      G( 9)  = 0.0D0
      G(10)  = MATBUF(2)
      G(11)  = MATBUF(4)
      G(12)  = MATBUF(5)
      G(13)  = 0.0D0
      G(14)  = MATBUF(3)
      G(15)  = MATBUF(5)
      G(16)  = MATBUF(6)
C
C     OBTAIN THE FOUR CONDUCTIVITY VALUES NEEDED FOR PIVOT ROW BEING
C     INSERTED.
C
 1020 CONTINUE
      CALL GMMATD (G(1),4,4,0, H(1),4,4,0, C(5))
      IHCOL   = I - 2
      TEMP(1) = H(IHCOL  )
      TEMP(2) = H(IHCOL+4)
      TEMP(3) = H(IHCOL+8)
      TEMP(4) = H(IHCOL+12)
      CALL GMMATD (TEMP(1),1,4,0, C(5),4,4,0, C(1))
C
C     DIVIDE CONDUCTIVITY BY 2.0 IF THIS IS A SUB-TETRA OF A HEXA2
C     ELEMENT.
C
      IF (IOPT) 1045,1040,1045
 1040 HDETER = HDETER/6.0D0
      GO TO 1046
 1045 IF (IOPT.GE.11 .AND. IOPT.LE.22) GO TO 1048
      HDETER = HDETER/12.0D0
      GO TO 1046
C
C     WEDGES
C
 1048 HDETER = HDETER/36.0D0
      IF (IOPT .LE. 16) HDETER = HDETER*2.0D0
 1046 DO 1047 I = 1,4
      C(I) = C(I)*HDETER
 1047 CONTINUE
C
C     INSERT THE PIVOT ROW.
C
      DO 1050 I = 1,4
      CALL SMA1B (C(I),NECPT(I+2),NPVT,IFKGG,0.0D0)
 1050 CONTINUE
      RETURN
C
C     HYDROELASTIC PROBLEM, OBTAIN DENSITY AND RETURN
C
 1060 MATID  = NECPT(2)
      INFLAG = 11
      CALL MAT (NECPT(1))
      DO 1070 IDLH = 1,16
 1070 G(IDLH) = 0.0D0
      G(6)  = 1.0D0/DBLE(RHO)
      G(11) = G(6)
      G(16) = G(6)
      GO TO 1020
      END

      SUBROUTINE CURV3
C*****
C  THIS OVERLAY WILL FORM OES1G (IF REQUESTED BY DMAP PARAMETER = 0)
C
C  OES1G OUTPUTS FOR CURRENT SUBCASE WILL BE GROUPED ON THE BASIS OF
C  THE MCSID. THUS THERE WILL BE A PASS FOR EACH -MCSID- HAVING A NON-
C  ZERO COUNT IN TABLE(IMCSID-NMCSID).
C
C  TO CONSERVE CORE FOR SSPLIN UTILITY, THE SIGMAS FOR EACH -MCSID- PASS
C  WILL BE WRITTEN TO SCR4 AS ENTRIES ARE SELECTED FROM SCR2. DEPENDENT
C  POINTS, EXTERNAL-IDS, AND INDEPENDENT POINTS WILL BE PLACED IN CORE
C  AND THEN REDUCED DURING THE PROJECTION SURFACE DETERMINATION PHASE.
C
C     OPEN CORE MAP DURING -CURV3- EXECUTION.
C     =======================================
C
C     FROM-------+------------+
C     CURV1      I  Z(IELTYP) I  MASTER LIST OF ELEMENT TYPES  ON
C     EXECUTION  I    THRU    I  ESTX(SCR1)
C                I  Z(NELTYP) I
C                +------------+
C                I  Z(IMCSID) I  MASTER LIST OF MCSIDS ELEMENTS IN
C                I    THRU    I  PROBLEM REFERENCE, WITH COUNTS OF
C                I  Z(NMCSID) I  OES1M ELEMENTS FOR CURRENT SUBCASE.
C                +------------+
C                I  Z(ICSTM)  I  CSTM FOR EACH -MCSID- IN ABOVE LIST.
C                I    THRU    I  14 WORD ENTRIES. (USER MAY NOT HAVE
C                I  Z(NCSTM)  I  SUPPLIED ALL, BUT MAY BE OK.)
C     FROM-------+------------+
C     AND DURING I  Z(IINDEP) I  INDEPENDENT POINT COORDINATES FOR ONE
C     CURV3      I    THRU    I  -MCSID- OF CURRENT SUBCASE.
C     EXECUTION  I  Z(NINDEP) I  TWO OR THREE WORD ENTRIES POSSIBLE.
C                +------------+
C                I  Z(IDEP)   I  DEPENDENT POINT COORDINATES FOR ONE
C                I    THRU    I  -MCSID- OF CURRENT SUBCASE.
C                I  Z(NDEP)   I  TWO OR FOUR WORD ENTRIES POSSIBLE.
C                +------------+
C                I  Z(IGMAT)  I  G MATRIX FROM SSPLIN UTILITY
C                I    THRU    I  (N-DEPENDENT-PTS BY N-INDEPENDENT-PTS)
C                I  Z(NGMAT)  I
C                +------------+
C                I  Z(ISIGMA) I  OES1M SIGMAS FOR ONE -MCSID- OF CURRENT
C                I    THRU    I  SUBCASE.  6X1 ENTRIES.
C                I  Z(NSIGMA) I
C                +------------+
C                I     .      I  AVAILABLE CORE.
C                I     .      I  (SSPLIN UTILITY USES Z(ISIGMA) THRU
C                I     .      I  Z(LCORE) FOR WORKING SPACE.)
C                I     .      I
C                I  Z(JCORE)  I
C                +------------+
C                I  Z(IBUF4)  I  GINO-BUFFER
C                I            I
C                +------------+
C                I  Z(IBUF3)  I  GINO-BUFFER
C                I            I
C                +------------+
C                I  Z(IBUF2)  I  GINO-BUFFER
C                I            I
C                +------------+
C                I  Z(IBUF1)  I  GINO-BUFFER
C                I            I
C                I  Z(LCORE)  I
C                +------------+
C
C  INPUTS - SCR2 CONTAINING ACTUAL ELEMENT ENTRIES USED TO FORM
C                OES1M FOR CURRENT OES1 SUBCASE. MAY BE MORE THAN
C                ONE -MCSID-. HAS THE SIX SIGMAS OF EACH ELEMENT
C                APPENDED TO EACH ELEMENT.
C
C                       -ELEMENT-ENTRY-
C
C                        MCSID = MATERIAL COORDINATE SYSTEM ID
C                        SIGMA1-X
C                        SIGMA1-Y
C                        SIGMA1-XY
C                        SIGMA2-X
C                        SIGMA2-Y
C                        SIGMA2-XY
C                        XC  *
C                        YC   * MEAN CENTER OF INDEPENDENT POINT
C                        ZC  *
C                        NPTS = NUMBER OF CONNECTED DEPENDENT GRIDS
C                        EXTERNAL GRID IDS (1 FOR EACH POINT)
C                        X,Y,Z  COMPONENTS OF EACH DEPENDENT GRID
C
C           SCR3 CONTAINING OFP TYPE -ID- RECORD TO USE AS A MODEL
C                FOR OES1G -ID- RECORD.
C
C
C           TABLE(IMCSID) THRU Z(NMCSID) CONTAINS PAIRS OF MCSID-S AND
C                COUNTS. (ONE PAIR FOR EACH UNIQUE MCSID OF CURRENT
C                SUBCASE.)
C
C
C           TABLE  Z(ICSTM) TO Z(NCSTM) CONTAINING TRANSFORMATIONS
C
C*****
      REAL               Z(1)     ,RBUF(100)
C
      INTEGER            MCB(7)
C
      INTEGER            CSTMS    ,SCR1     ,SCR2     ,SCR3
      INTEGER            SCR4     ,OES1M    ,OES1G    ,OES1     ,SCR5
      INTEGER            CSTM     ,EST      ,SIL      ,GPL
      INTEGER            ELTYPE   ,SUBCAS   ,FILE     ,ESTWDS
      INTEGER            EWORDS   ,OWORDS   ,DEPTS    ,CSTYPE
      INTEGER            DEVICE   ,OLDID    ,BUF      ,SBUF
      INTEGER            RD       ,RDREW    ,WRT      ,WRTREW
      INTEGER            CLS      ,CLSREW   ,EOR      ,SYSBUF
C
      LOGICAL            ANY      ,EOFOS1   ,FIRST    ,ANYOUT
      LOGICAL            FOES1G   ,STRAIN   ,ANY1M    ,ANY1G
C
      COMMON/BLANK /     IP1      ,IP2
C
      COMMON/SYSTEM/     SYSBUF   ,IOUTPT
C
      COMMON/NAMES /     RD       ,RDREW    ,WRT      ,WRTREW
     1                  ,CLSREW   ,CLS
C
      COMMON/ZZZZZZ/     IZ(1)
C
      COMMON/CURVC1/     LSBUF    ,SBUF(10)
C
      COMMON/CURVC2/     LBUF     ,BUF(100)
C
      COMMON/CURVC3/     VEC(3)   ,VMAX(3)  ,VMIN(3)  ,IDREC(146)
C
      COMMON/CURVTB/     IMID     ,NMID     ,LMID     ,NMIDS
     A                  ,IELTYP   ,NELTYP   ,JELTYP   ,ICSTM
     B                  ,NCSTM    ,CSTMS    ,LCSTM    ,IESTX
     C                  ,NESTX    ,IMCSID   ,NMCSID   ,LMCSID
     D                  ,MCSIDS   ,JMCSID   ,KMCSID   ,ISIL
     E                  ,NSIL     ,LSIL     ,JSIL     ,IOES1M
     F                  ,NOES1M   ,LOES1M   ,IDEP     ,NDEP
     G                  ,IINDEP   ,NINDEP   ,JINDEP   ,ISIGMA
     H                  ,NSIGMA   ,IGMAT    ,NGMAT    ,IEXT
     I                  ,NEXT     ,LEXT     ,SCR1     ,SCR2
     J                  ,SCR3     ,SCR4     ,OES1M    ,OES1G
     K                  ,OES1     ,MPT      ,CSTM     ,EST
     L                  ,SIL      ,GPL      ,JCORE    ,LCORE
     M                  ,IBUF1    ,IBUF2    ,IBUF3    ,IBUF4
     N                  ,I        ,J        ,K        ,L
     O                  ,K1       ,K2       ,IXYZ1    ,IXYZ2
     P                  ,LX1      ,LX2      ,ELTYPE   ,MCSID
     Q                  ,IDSCR1   ,IDOES1   ,NPTS     ,NPTS4
     R                  ,IWORDS   ,NWORDS   ,SUBCAS   ,KOUNT
     S                  ,ISIG1    ,ISIG2    ,LOC      ,FILE
      COMMON/CURVTB/     IMSG     ,NELEMS   ,IMATID   ,ICOMP
     1                  ,ESTWDS   ,EWORDS   ,JP       ,OWORDS
     2                  ,MATID    ,DEPTS    ,INDPTS   ,ICTYPE
     3                  ,IVMAT    ,ITRAN    ,CSTYPE   ,ISING
     4                  ,DEVICE   ,OLDID    ,ANY      ,EOFOS1
     5                  ,FIRST    ,ANYOUT   ,FOES1G   ,STRAIN
     6                  ,LOGERR   ,ANY1M    ,ANY1G    ,SCR5
C
      EQUIVALENCE        (Z(1),IZ(1)), (BUF(1),RBUF(1))
      EQUIVALENCE        (NOEOR,RDREW), (EOR,CLS)
C
      DATA MCB/ 7*1 /
C
C  BRING OES1G -ID- RECORD INTO CORE AND MODIFY AS NECESSARY.
C
      FILE = SCR3
      LOC = 50
      CALL OPEN(*9001,SCR3,IZ(IBUF1),RDREW)
      CALL READ(*9002,*9003,SCR3,IDREC(1),146,NOEOR,NWORDS)
      CALL CLOSE( SCR3, CLSREW )
C
C
C
C
C  OVERALL LOOP IS ON ENTRIES OF TABLE(IMCSID-NMCSID)
C
      JMCSID = IMCSID
C
  100 MCSID = IZ(JMCSID)
      INDPTS = IZ(JMCSID+1)
      LOC = 100
      IF( INDPTS ) 9000,980,110
C
C  COLLECT DATA REQUIRED FROM SCR2.
C
  110 FILE = SCR2
C
C  CORE ALLOCATION FOR XC, YC, ZC OF EACH INDEPENDENT POINT.
C
      IINDEP = NCSTM + 1
      NINDEP = NCSTM + 3*INDPTS
C
C  CORE ALLOCATION FOR EXT-ID,X,Y,Z OF EACH UNIQUE DEPENDENT POINT.
C  (THE QUANTITY OF DEPENDENT POINTS IS NOT YET KNOWN.)
C
      IDEP = NINDEP + 1
      NDEP = NINDEP
      LOC = 110
      ICRQ = NDEP - JCORE
      IF( NDEP .GT. JCORE ) GO TO 9008
C
      CALL OPEN(*9001,SCR2,IZ(IBUF1),RDREW)
      FILE = SCR3
      CALL OPEN(*9001,SCR3,IZ(IBUF2),WRTREW)
C
      JINDEP = IINDEP
      FILE = SCR2
C
C  FIND -INDPTS- NUMBER OF INDEPENDENT ELEMENT POINTS ENTRIES
C  FOR CURRENT -MCSID- PASS. (LOGIC ERROR IF CAN NOT FIND THIS MANY)
C
      DO 400 I = 1,INDPTS
C
C  READ ELEMENT INDEPENDENT PORTION OF ENTRY
C
  150 LOC = 150
      CALL READ(*9002,*9003,SCR2,BUF(1),11,NOEOR,NWORDS)
      NPTS = BUF(11)
      NPTS4 = 4*NPTS
C
C  CHECK MCSID OF ENTRY TO BE SAME AS ONE OF THIS PASS.
C
      IF( BUF(1) .EQ. MCSID ) GO TO 170
C
C  NO IT IS NOT THUS SKIP BALANCE OF ENTRY.
C
      LOC = 170
      CALL READ(*9002,*9003,SCR2,0,-NPTS4,NOEOR,NWORDS)
      GO TO 150
C
C  YES, THIS ENTRY IS OF CURRENT PASS MCSID. ADD POINT DATA TO CORE.
C  FIRST OUTPUT SIGMAS TO SCR3
C
  170 CALL WRITE( SCR3, BUF(2), 6, NOEOR )
      Z(JINDEP  ) = RBUF(8)
      Z(JINDEP+1) = RBUF(9)
      Z(JINDEP+2) = RBUF(10)
      JINDEP = JINDEP + 3
C
C  INDEPENDENT POINTS NOT YET IN CORE ARE ADDED.
C
      CALL READ(*9002,*9003,SCR2,BUF(1),NPTS4,NOEOR,NWORDS)
      K = NPTS
      DO 300 J = 1,NPTS
C
C  CHECK IF EXTERNAL ID IS IN TABLE YET.
C
      IF( NDEP .LT. IDEP ) GO TO 220
      DO 200 L = IDEP,NDEP,4
      IF( BUF(J) .EQ. IZ(L) ) GO TO 290
  200 CONTINUE
C
C  NOT YET IN THUS ADD IT TO TABLE
C
  220 ICRQ = NDEP + 4 - JCORE
      IF( NDEP+4 .GT. JCORE ) GO TO 9008
      IZ(NDEP+1) = BUF(J)
      Z(NDEP+2) = RBUF(K+1)
      Z(NDEP+3) = RBUF(K+2)
      Z(NDEP+4) = RBUF(K+3)
      NDEP = NDEP + 4
C
  290 K = K + 3
C
  300 CONTINUE
C
  400 CONTINUE
C*****
C  ALL DATA FOR CURRENT MCSID HAS BEEN COLLECTED FROM SCR2.
C*****
      CALL CLOSE( SCR2, CLSREW )
      CALL CLOSE( SCR3, CLSREW )
C
C  DEPENDENT COORDINATES ARE SORTED ON EXTERNAL-ID.
C
      CALL SORT( 0, 0, 4, 1, Z(IDEP), NDEP-IDEP+1 )
C*****
C  CONVERSION OF INDEPENDENT AND DEPENDENT POINTS TO LOCAL
C  MATERIAL COORDINATE SYSTEM. FIRST GET CSTM DATA TO USE.
C*****
      LOC = 400
      CALL BISLOC(*9000,MCSID,IZ(ICSTM),14,CSTMS,JP)
      IVMAT = ICSTM + JP + 1
      ITRAN = IVMAT + 3
      ICTYPE = IZ(IVMAT-1)
C
C  FOR EACH POINT
C                               T
C                   (R     )=( T ) ( R     - V     )
C                     LOCAL           BASIC   MCSID
C
C                    (3X1)   (3X3)   (3X1)   (3X1)
C
      DO 480 I = IINDEP,NINDEP,3
      VEC(1) = Z(I  ) - Z(IVMAT  )
      VEC(2) = Z(I+1) - Z(IVMAT+1)
      VEC(3) = Z(I+2) - Z(IVMAT+2)
      CALL GMMATS( Z(ITRAN),3,3,1, VEC(1),3,1,0, Z(I) )
  480 CONTINUE
C
      DO 490 I = IDEP,NDEP,4
      VEC(1) = Z(I+1) - Z(IVMAT  )
      VEC(2) = Z(I+2) - Z(IVMAT+1)
      VEC(3) = Z(I+3) - Z(IVMAT+2)
      CALL GMMATS( Z(ITRAN),3,3,1, VEC(1),3,1,0, Z(I+1) )
  490 CONTINUE
C*****
C  CONVERSION OF INDEPENDENT POINT LOCAL COORDINATES TO MAPPING
C  COORDINATES. (IF MCSID IS A RECTANGULAR SYSTEM THEN NO CHANGE.)
C*****
      LOC = 490
      IF( ICTYPE.LT.1 .OR. ICTYPE.GT.3 ) GO TO 9000
      GO TO ( 589,510,530 ),ICTYPE
C
C  CYLINDRICAL COORDINATES
C
  510 AVGL = 0.0
      DO 520 I = IINDEP,NINDEP,3
      VEC(1) = SQRT( Z(I)**2 + Z(I+1)**2 )
      AVGL = AVGL + VEC(1)
      IF( VEC(1) .LE. 0.0 ) GO TO 515
      Z(I+1) = ATAN2( Z(I+1), Z(I) )
      GO TO 517
  515 Z(I+1) = 0.0
  517 Z(I) = VEC(1)
  520 CONTINUE
      AVGL = AVGL / FLOAT(INDPTS)
      GO TO 589
C
C  SPHERICAL COORDINATES
C
  530 AVGL = 0.0
      DO 580 I = IINDEP,NINDEP,3
      XSQYSQ = Z(I)**2 + Z(I+1)**2
      FL = SQRT( XSQYSQ )
      VEC(1) = SQRT( XSQYSQ + Z(I+2)**2 )
      AVGL = AVGL + VEC(1)
      IF( VEC(1) .GT. 0.0 ) GO TO 540
      VEC(2) = 0.0
      GO TO 550
  540 VEC(2) = ATAN2( FL, Z(I+2) )
  550 IF( FL .GT. 0.0 ) GO TO 560
      VEC(3) = 0.0
      GO TO 570
  560 VEC(3) = ATAN2( Z(I+1), Z(I) )
  570 Z(I  ) = VEC(1)
      Z(I+1) = VEC(2)
      Z(I+2) = VEC(3)
  580 CONTINUE
      AVGL = AVGL / FLOAT(INDPTS)
C*****
C  CONVERSION OF DEPENDENT POINT LOCAL COORDINATES TO MAPPING
C  COORDINATES.
C  (IF MCSID IS RECTANGULAR SYSTEM THEN NO CHANGE.)
C*****
  589 GO TO(609,590,600), ICTYPE
C
C  CYLINDRICAL COORDINATES
C
  590 DO 594 I = IDEP,NDEP,4
      VEC(1) = SQRT( Z(I+1)**2 + Z(I+2)**2 )
      IF( VEC(1) .LE. 0.0 ) GO TO 592
      Z(I+2) = ATAN2( Z(I+2), Z(I+1) )
      GO TO 593
  592 Z(I+2) = 0.0
  593 Z(I+1) = VEC(1)
  594 CONTINUE
      GO TO 609
C
C  SPHERICAL COORDINATES
C
  600 DO 607 I = IDEP,NDEP,4
      XSQYSQ = Z(I+1)**2 + Z(I+2)**2
      FL = SQRT( XSQYSQ )
      VEC(1) = SQRT( XSQYSQ + Z(I+3)**2 )
      IF( VEC(1) .GT. 0.0 ) GO TO 602
      VEC(2) = 0.0
      GO TO 604
  602 VEC(2) = ATAN2( FL, Z(I+3) )
  604 IF( FL .GT. 0.0 ) GO TO 605
      VEC(3) = 0.0
      GO TO 606
  605 VEC(3) = ATAN2( Z(I+2), Z(I+1) )
  606 Z(I+1) = VEC(1)
      Z(I+2) = VEC(2)
      Z(I+3) = VEC(3)
  607 CONTINUE
C
C  SET MAXIMUM AND MIMIMUM X,Y,Z VALUES.
C
  609 DO 610 I = 1,3
      VMAX(I) = Z(IINDEP+I-1)
      VMIN(I) = Z(IINDEP+I-1)
  610 CONTINUE
C
      DO 650 I = IINDEP,NINDEP,3
      DO 640 J = 1,3
      VMAX(J) = AMAX1( Z(I+J-1), VMAX(J) )
      VMIN(J) = AMIN1( Z(I+J-1), VMIN(J) )
  640 CONTINUE
  650 CONTINUE
C
C  SET THE X,Y,Z RANGES
C
      DO 670 I = 1,3
      VMAX(I) = VMAX(I) - VMIN(I)
      VEC(I) = VMAX(I)
  670 CONTINUE
C
      IF( ICTYPE .EQ. 1 ) GO TO 680
      VMAX(2) = AVGL * VMAX(2)
      IF( ICTYPE .EQ. 2 ) GO TO 680
      VMAX(3) = AVGL * VMAX(3)
C
C  DIRECTION YIELDING MINIMUM RANGE DETERMINES PROJECTION
C
  680 IF( VMAX(1) .LT. VMAX(2) ) GO TO 700
      IF( VMAX(2) .LT. VMAX(3) ) GO TO 690
  685 K1 = 1
      K2 = 2
      KCTYPE = 3
      GO TO 710
  690 K1 = 1
      K2 = 3
      KCTYPE = 2
      GO TO 710
  700 IF( VMAX(3) .LT. VMAX(1) ) GO TO 685
      K1 = 2
      K2 = 3
      KCTYPE = 1
C
  710 XRANGE = VEC(K1)
      YRANGE = VEC(K2)
      IF( XRANGE ) 712,711,712
  711 XRANGE = 1.0
  712 IF( YRANGE ) 714,713,714
  713 YRANGE = 1.0
C
C  COORDINATES -K1- AND -K2- WILL BE KEPT.
C
C  TABLE OF INDEPENDENT AND DEPENDENT POINTS ARE REDUCED TO
C  TABLES OF X,Y PAIRS. FIRST TO GAIN SOME CORE, EXTERNAL
C  IDS- ARE WRITTEN TO SCR4.
C
  714 FILE = SCR4
      LOC = 714
      CALL OPEN(*9001,SCR4,IZ(IBUF1),WRTREW)
      DO 720 I = IDEP,NDEP,4
      CALL WRITE( SCR4, IZ(I), 1, NOEOR )
  720 CONTINUE
      CALL CLOSE( SCR4, CLSREW )
C
C  REDUCE INDEPENDENT POINTS TO XY PAIRS, SCALE BY X AND Y RANGES
C  RESPECTIVELY, AND COMPRESS IN CORE.
C
      J = IINDEP
      DO 740 I = IINDEP,NINDEP,3
      Z(J  ) = Z(I+K1-1) / XRANGE
      Z(J+1) = Z(I+K2-1) / YRANGE
      J = J + 2
  740 CONTINUE
      NINDEP = J - 1
C
C  REDUCE DEPENDENT POINTS LIST. (J IS STILL GOOD)
C
      DO 770 I=IDEP,NDEP,4
      Z(J  ) = Z(I+K1) / XRANGE
      Z(J+1) = Z(I+K2) / YRANGE
      J = J + 2
  770 CONTINUE
      IDEP = NINDEP + 1
      NDEP = J - 1
      DEPTS = (NDEP - IDEP + 1) / 2
C*****
C  INDEPENDENT AND DEPENDENT POINT COORDINATE LISTS ARE NOW
C  COMPLETE.  CALL FOR INTERPOLATION.
C*****
      CALL CURVIT( Z(IINDEP), INDPTS, Z(IDEP), DEPTS, SCR5,
     1        Z(NDEP+1), IZ(NDEP+1), LCORE-NDEP-1, IP2, 15.0, MCSID,
     2        XRANGE, YRANGE )
C
C  BRING -OES1M- SIGMAS INTO CORE FOR CURRENT -MCSID- PASS.
C
      ISIGMA = IINDEP + 1
      NSIGMA = IINDEP + 6*INDPTS
      JSIGMA = ISIGMA - 7
      ICRQ = NSIGMA - IBUF3
      IF( NSIGMA .GE. IBUF3 ) GO TO 9008
      FILE = SCR3
      LOC = 800
      CALL OPEN(*9001,SCR3,IZ(IBUF1),RDREW)
      CALL READ(*9002,*810,SCR3,IZ(ISIGMA),IBUF3-ISIGMA,NOEOR,NWORDS)
      LOC = 810
      GO TO 9000
C
  810 IF( NWORDS .NE. 6*INDPTS ) GO TO 9000
      CALL CLOSE( SCR3, CLSREW )
C
C    (SIGMAS                ) = (G)(SIGMAS                        )
C           DEPENDENT POINTS              OES1M INDEPENDENT POINTS
C
C  SINCE THE ORDER OF THE ROWS IN THE G MATRIX ARE IN SORTED EXTERNAL
C  GRID ORDER EACH OUTPUT LINE OF OES1G WILL BE HANDLED ON ITS
C  OWN. THIS ELIMINATES NECESSITY OF HOLDING ANOTHER SIGMA ARRAY
C  IN CORE.
C
      FILE = OES1G
      LOC = 815
      CALL OPEN(*9001,OES1G,IZ(IBUF1),WRT)
C
C  OUTPUT ID RECORD. PREVIOUSLY PREPARED.
C
      IDREC(3) = IDREC(3) + 2000
      CALL WRITE( OES1G, IDREC(1), 146, EOR )
      MCB(1) = OES1G
      CALL WRTTRL( MCB(1) )
      ANY1G = .TRUE.
C
C  OPEN SCR5 CONTAINING ROWS OF THE G-MATRIX.
C
      FILE = SCR5
      CALL OPEN(*9001,SCR5,IZ(IBUF3),RDREW)
      CALL FWDREC(*9002,SCR5)
C
C  OPEN SCR4 CONTAINING LIST OF EXTERNAL IDS )
C
      FILE = SCR4
      CALL OPEN(*9001,SCR4,IZ(IBUF2),RDREW)
C
C  COMPUTE AND OUTPUT SIGMAS FOR THE DEPENDENT POINTS
C
      BUF(2) = MCSID
      DO 900 I=1,DEPTS
C
C  READ THE EXTERNAL ID
C
      FILE = SCR4
      CALL READ(*9002,*9003,SCR4,BUF(1),1,NOEOR,NWORDS)
      FILE = SCR5
C
C  INITIALIZE SIGMAS(DEPENDENT POINT) TO ZERO
C
      DO 820 J = 3,8
      RBUF(J) = 0.0
  820 CONTINUE
C
      K = 0
      LOC = 825
C
C  READ ACTIVE INDEX AND G-VALUE FROM SCRATCH 5
C
  825 CALL READ(*9002,*840,SCR5,RBUF(11),2,NOEOR,NWORDS)
      K = K + 10
      IDX = JSIGMA + 6*BUF(11)
      DO 830 J = 1,6
      RBUF(J+2) = RBUF(J+2) + RBUF(12)*Z(IDX+J)
  830 CONTINUE
      GO TO 825
C
C  IF THERE WERE ANY G-VALUES THEN NOW COMPLETE THE OUTPUT LINE.
C
  840 IF( K .LE. 0 ) GO TO 900
C
      BUF(10) = K + KCTYPE
C
      RBUF(11) = RBUF(6)
      RBUF(12) = RBUF(7)
      RBUF(13) = RBUF(8)
C
C  COMPUTE INVARIANTS FOR EACH LINE
C
      CALL CURVPS( RBUF( 3), RBUF( 6) )
      CALL CURVPS( RBUF(11), RBUF(14) )
      IF( .NOT. STRAIN ) GO TO 881
      RBUF(5) = 2.0 * RBUF(5)
      RBUF(9) = 2.0 * RBUF(9)
      RBUF(13) = 2.0 * RBUF(13)
      RBUF(17) = 2.0 * RBUF(17)
C
C  APPEND DEVICE CODE TO EXTERNAL ID AND OUTPUT LINE
C
  881 BUF(1) = 10*BUF(1) + DEVICE
      CALL WRITE( OES1G, BUF(1), 17, NOEOR )
  900 CONTINUE
C
      CALL WRITE( OES1G, 0, 0, EOR )
      IF(EOFOS1 .AND. JMCSID+2 .GT. NMCSID) CALL CLOSE(OES1G,CLSREW)
      CALL CLOSE( OES1G, CLS )
      CALL CLOSE( SCR4, CLSREW )
      CALL CLOSE( SCR5, CLSREW )
C*****
C  ALL INDEPENDENT POINTS OUTPUT TO OES1G FOR 1 ACTIVE MCSID OF
C  CURRENT SUBCASE. GO TO NEXT MCSID.
C*****
  980 JMCSID = JMCSID + 2
      IF( JMCSID .LE. NMCSID ) GO TO 100
C*****
C  ALL THROUGH FORMING OES1G FOR CURRENT SUBCASE.
C*****
 5000 RETURN
C*****
C  ERROR CONDITION ENCOUNTERED
C*****
 9000 IMSG = -LOGERR
      GO TO 5000
 9001 IMSG = -1
      GO TO 5000
 9002 IMSG = -2
      GO TO 5000
 9003 IMSG = -3
      GO TO 5000
 9008 IMSG = -8
      LCORE = ICRQ
      GO TO 5000
      END

      SUBROUTINE MPYQ (Z      )
C
C     MPYQ IS CALLED ONCE PER EXECUTION OF MPYAD. IT PERFORMS GENERAL
C     INITIALIZATION FOR EACH OF THE ENTRY POINTS
C     I.E.  SETTING UP MPYAD GO-TO-BRANCHES, ARITH AND BPICK FOR METHOD
C           1, AND ARITH2, APICK2 AND BPICK2 FOR METHOD 2
C
C     ENTRY POINTS -
C           MPY1V   (PERFORMS THE INNER LOOP FOR MPYAD, METHOD 1,
C                    TRANSPOSE AND NON-TRANSPOSE. IT IS CALLED ONCE FOR
C                    EACH COLUMNN OF THE A MATRIX)
C           MPY2NV  (PERFORMS THE INNER LOOP FOR THE NON-TRANSPOSE CASE
C                    OF METHOD 2. IT IS CALLED ONCE FOR EACH COUMN OF
C                    THE B MATRIX)
C           MPY2TV  (SAME AS MPY2NV, EXECPT IT IS FOR THE TRANSPOSE
C                    CASE)
C           MPY3T   (PERFORMS THE INNER LOOP FOR THE TRANSPOSE CASE OF
C                    METHOD 3. IT IS CALLED ONCE FOR EACH COLUMN OF THE
C                    B MATRIX)
C     (WHERE V STANDS FOR VAX VERSION, AND T IS THE TRANSPOSE FLAG)
C
C     THE MPYi ROUTINES PERFORM THE MATRIX MULTIPLICATION AND ADDITION
C     FOR THE MPYAD INNER LOOPS
C
C           (+/-)A * B (+/-)C = D   OR (+/-)A(T) * B (+/-)C = D
C
C
C     LAST REVISED BY G.CHAN/UNISYS  1/91
C     (1) MPY3T WAS PREVIOUSLY A .MDS SUBROUTINE. IT IS NOW AN ENTRY
C         POINT IN THIS MPYQ ROUTINE
C         (MPY3T IS AN ENTRY POINT IN MPYQ, IN IBM AND CDC VERSIONS)
C     (2) TO IMPROVE MPYAD INNER LOOP LOGIC FOR THE COMMON CASES
C
C
      IMPLICIT INTEGER (A-Z)
      REAL             A(4)    ,B(4)    ,D(4)    ,Z(1)    ,AA(4) ,AAA  ,
     1                 BSR     ,AAS(1)  ,DDS(1)  ,BBB     ,BSI   ,BBS
      DOUBLE PRECISION AD(2)   ,BD(2)   ,DD(2)   ,ZD(1)   ,ADD(2),BDR  ,
     1                 BDI     ,AAD(1)  ,DDD(1)  ,BBD(1)
      DIMENSION        ZZ(1)
      COMMON /MPYADX/  FILEA(7),FILEB(7),FILEC(7),FILED(7),NZ    ,T    ,
     1                 SIGNAB  ,SIGNC   ,PREC1   ,SCRTCH  ,TIME
     2       /SYSTEM/  KSYSTM(65)
     3       /TYPE  /  PRC(2)  ,NWDS(4) ,RC(4)
     4       /NAMES /  RD      ,RDREW   ,WRT     ,WRTREW  ,CLSREW,CLS
     5       /ZBLPKX/  D       ,DROW
     6       /ZNTPKX/  A       ,I       ,EOL     ,EOR
     7       /PACKX /  TYPED   ,TYPD1   ,ONE1    ,PP1     ,INCR1
     8       /UNPAKX/  TYPEBD  ,ONE2    ,PP2     ,INCR2
      COMMON /MPYADZ/  RCB     ,RCD     ,LL      ,LLL     ,JB    ,NBX  ,
     1                 NDX     ,JMAX1X  ,ACOL    ,ACOL1   ,ACOLN ,ACORE,
     2                 APOINT  ,BCOL    ,CROW    ,FIRSTL  ,NA    ,NB   ,
     3                 ND      ,NWDA    ,NWDB    ,NWDD    ,PREC  ,JMAX ,
     4                 INCRA   ,BLOCK(20)
      COMMON /MPYQT4/  RCA     ,PRCA    ,ALL4    ,JUMP4   ,PREC4
      COMMON /ZZZZZZ/  BBS(17000)
      EQUIVALENCE      (KSYSTM( 1),SYSBUF)  ,(KSYSTM( 2),MOUT )  ,
     1                 (KSYSTM(58),IPASS )
      EQUIVALENCE      (A(1)    ,AD(1)   )  ,(B(1)      ,BD(1))  ,
     1                 (D(1)    ,DD(1)   )  ,(FILEA(2),M      )  ,
     2                 (FILEA(3),N       )  ,(FILEA(5),TYPEA  )  ,
     3                 (FILEB(2),Q       )  ,(FILEB(3),R      )  ,
     4                 (FILEB(5),TYPEB   )  ,(FILEC(5),TYPEC  )  ,
     5                 (FILED(5),TYPD    )  ,(NZZ     ,BUF1   )  ,
     6                 (ACOLN   ,AROWN   )  ,(AA(1)   ,ADD(1) )  ,
     7                 (ACOL1   ,AROW1   )  ,(ACOL    ,AROW   )  ,
     8                 (BBS(1)  ,BBD(1)  )
      EQUIVALENCE      (BLOCK(2),TYPE    )  ,(BLOCK(3),FORM   )  ,
     1                 (BLOCK(4),ROW, J3 )  ,(BLOCK(5),POINT  )  ,
     2                 (BLOCK(6),NBRSTR  )  ,(BLOCK(8),FLAG   )
      EQUIVALENCE      (BLOCK(5),JB31    )  ,(BLOCK(6),NTERM3 )  ,
     1                 (BLOCK(7),JB3N    )  ,(BLOCK(8),B3FLAG )
C     DATA    MASK6F / X'00FFFFFF'  /
      DATA    MASK6F / 16777215 /
C
C     MASK6F= '00FFFFFF'X (OR X'00FFFFFF') = 16777215
C     RCB   = 1 IF B IS REAL,2 IF B IS COMPLEX
C     NWDB  = NUMBER OF WORDS PER ELEMENT OF B
C     NBX   = NUMBER OF ELEMENTS PER COLUMN OF B
C     NB    = NUMBER OF WORDS PER COLUMN OF B
C     NDX   = NUMBER OF ELEMENTS PER COLUMN OF C AND D
C     ND    = NUMBER OF WORDS PER COLUMN OF C AND D
C     NZZ   = BUF1 = POINTER TO FIRST GINO BUFFER
C     BUF2  = POINTER TO SECOND GINO BUFFER
C     BUF3  = POINTER TO THIRD GINO BUFFER
C     JJ    = MAX. NO. OF COLUMNS OF B AND D THAT MAY BE HELD IN CORE
C     MPASS1= NUMBER OF PASSES REQUIRED FOR METHOD ONE
C     JZB   = POINTER TO FIRST ELEMENT OF B FOR SP REFERENCE
C     JZDB  = POINTER TO FIRST ELEMENT OF B FOR DP REFERENCE
C     JB    = POINTER TO FIRST ELEMENT OF B FOR PRECISION OF PROBLEM
C     NWDA  = NUMBER OF WORDS PER ELEMENT OF A
C     NWDD  = NUMBER OF WORDS PER ELEMENT OF D
C     ACORE = POINTER TO FIRST WORD FOR STORAGE OF PACKED COLUMNS
C             OF A MATRIX FOR METHOD TWO
C*****
      RCA  = RC(TYPEA)
      MODB = MOD(TYPEB,2)
      MODA = MOD(TYPEA,2)
      PRCA = PRC(TYPEA)
      FA3  = FILEA(3)
C
C     IF DIAG 43 IS ON, SKIP ALL (1991) SPEED IMPROVEMENT LOGIC
C     (THIS IS ONLY TEMPORARY)
C
      ALL  = 0
      IF (TYPEA.EQ.TYPEB .AND. TYPEA.EQ.TYPED) ALL = TYPEA
      ALL4 = ALL
      IF (ALL4 .EQ. 0) ALL4 = 5
      IF (TYPED.GE.3 .AND. TYPEA.LE.2 .AND. TYPEB.LE.2) ALL4 = 6
      CALL SSWTCH (43,J)
      IF (J .EQ. 1) ALL = 0
      JUMP4 = TYPEB + (TYPEA-1)*4
      PREC4 = PREC1 - 1
C
C     RCA, PRCA, ALL4 AND JUMP4 ARE USED IN MPY4T
C
      GO TO (20,40,100,300), TYPED
C
C     REAL SINGLE PRECISION
C
   20 ASSIGN 840 TO ARITH
      ASSIGN 750 TO BPICK
      IF (T .NE. 0)  GO TO 30
C
      ASSIGN 1210 TO ARITH2
      ASSIGN 1010 TO BPICK2
      ASSIGN 1100 TO APICK2
      GO TO 600
C
   30 ASSIGN 1600 TO ARITH2
      ASSIGN 1400 TO BPICK2
      ASSIGN 1500 TO APICK2
      GO TO 600
C
C     REAL DOUBLE PRECISION
C
   40 ASSIGN 850 TO ARITH
      ASSIGN 770 TO BPICK
      IF (MODB .EQ. 1) ASSIGN 790 TO BPICK
      IF (T .NE. 0) GO TO 60
C
      ASSIGN 1220 TO ARITH2
      ASSIGN 1030 TO BPICK2
      IF (MODB .EQ. 1) ASSIGN 1050 TO BPICK2
      ASSIGN 1120 TO APICK2
   50 IF (MODA .EQ. 1) ASSIGN 1140 TO APICK2
      GO TO 600
C
   60 ASSIGN 1610 TO ARITH2
      ASSIGN 1420 TO BPICK2
      IF (MODB .EQ. 1) ASSIGN 1440 TO BPICK2
      ASSIGN 1520 TO APICK2
   70 IF (MODA .EQ. 1) ASSIGN 1540 TO APICK2
      GO TO 600
C
C     COMPLEX SINGLE PRECISION
C
  100 ASSIGN 860 TO ARITH
      GO TO (110,110,120,130), TYPEB
  110 ASSIGN 750 TO BPICK
      GO TO 140
  120 ASSIGN 760 TO BPICK
      GO TO 140
  130 ASSIGN 810 TO BPICK
  140 IF (T .NE. 0)  GO TO 220
C
      ASSIGN 1230 TO ARITH2
      GO TO (150,150,160,170), TYPEB
  150 ASSIGN 1010 TO BPICK2
      GO TO 180
  160 ASSIGN 1020 TO BPICK2
      GO TO 180
  170 ASSIGN 1070 TO BPICK2
  180 GO TO (190,190,200,210), TYPEA
  190 ASSIGN 1100 TO APICK2
      GO TO 600
  200 ASSIGN 1110 TO APICK2
      GO TO 600
  210 ASSIGN 1160 TO APICK2
      GO TO 600
  220 ASSIGN 1620 TO ARITH2
C
      GO TO (230,230,240,250), TYPEB
  230 ASSIGN 1400 TO BPICK2
      GO TO 260
  240 ASSIGN 1410 TO BPICK2
      GO TO 260
  250 ASSIGN 1460 TO BPICK2
  260 GO TO (270,270,280,290), TYPEA
  270 ASSIGN 1500 TO APICK2
      GO TO 600
  280 ASSIGN 1510 TO APICK2
      GO TO 600
  290 ASSIGN 1560 TO APICK2
      GO TO 600
C
C     COMPLEX DOUBLE PRECISION
C
  300 ASSIGN 870 TO ARITH
      GO TO (310,320,330,340), TYPEB
  310 ASSIGN 790 TO BPICK
      GO TO 350
  320 ASSIGN 770 TO BPICK
      GO TO 350
  330 ASSIGN 800 TO BPICK
      GO TO 350
  340 ASSIGN 780 TO BPICK
  350 IF (T .NE. 0) GO TO 440
C
      ASSIGN 1240 TO ARITH2
      GO TO (360,370,380,390), TYPEB
  360 ASSIGN 1050 TO BPICK2
      GO TO 400
  370 ASSIGN 1030 TO BPICK2
      GO TO 400
  380 ASSIGN 1060 TO BPICK2
      GO TO 400
  390 ASSIGN 1040 TO BPICK2
  400 GO TO (50,410,420,430), TYPEA
  410 ASSIGN 1120 TO APICK2
      GO TO 600
  420 ASSIGN 1150 TO APICK2
      GO TO 600
  430 ASSIGN 1130 TO APICK2
      GO TO 600
C
  440 ASSIGN 1630 TO ARITH2
      GO TO (450,460,470,480), TYPEB
  450 ASSIGN 1440 TO BPICK2
      GO TO 490
  460 ASSIGN 1420 TO BPICK2
      GO TO 490
  470 ASSIGN 1450 TO BPICK2
      GO TO 490
  480 ASSIGN 1430 TO BPICK2
  490 GO TO (70,500,510,520), TYPEA
  500 ASSIGN 1520 TO APICK2
      GO TO 600
  510 ASSIGN 1550 TO APICK2
      GO TO 600
  520 ASSIGN 1530 TO APICK2
C
C     MPYQ INITIALIZATION DONE
C
  600 RETURN
C
C
      ENTRY MPY1V (ZZ      ,Z      ,ZD      )
C     =====================
C
C     METHOD 1  (TRANSPOSE AND NON-TRANSPOSE)
C
  700 B (2) = 0.
      BD(2) = 0.D0
  710 CALL ZNTPKI
      I1 = I - 1
      IF (T) 730,720,730
  720 K1 = LL
      K2 = I1*RCD + 1
      GO TO 740
  730 K1 = I1*RCB + JB
      K2 = LLL
  740 K3 = K2 + JMAX1X
      IF (ALL .NE. 0) GO TO (900,920,940,960), ALL
      DO 880 K = K2,K3,NDX
      J  = K1
      GO TO BPICK, (750,760,770,780,790,800,810)
  750 IF (Z(J) .EQ. 0.0) GO TO 880
      B(1) = Z(J)
      GO TO 830
  760 IF (Z(J).EQ.0.0 .AND. Z(J+1).EQ.0.0) GO TO 880
      B(1) = Z(J  )
      B(2) = Z(J+1)
      GO TO 830
  770 IF (ZD(J) .EQ. 0.D0) GO TO 880
      BD(1) = ZD(J)
      GO TO 830
  780 IF (ZD(J).EQ.0.D0 .AND. ZD(J+1).EQ.0.D0) GO TO 880
      BD(1) = ZD(J  )
      BD(2) = ZD(J+1)
      GO TO 830
  790 IF (Z(J) .EQ. 0.0) GO TO 880
      BD(1) = Z(J)
      GO TO 830
  800 IF (Z(J).EQ.0.0 .AND. Z(J+1).EQ.0.0) GO TO 880
      BD(1) = Z(J  )
      BD(2) = Z(J+1)
      GO TO 830
  810 IF (ZD(J).EQ.0.D0 .AND. ZD(J+1).EQ.0.D0) GO TO 880
      B(1) = ZD(J  )
      B(2) = ZD(J+1)
C
  830 GO TO ARITH, (840,850,860,870)
  840 Z(K) = Z(K) + A(1)*B(1)
      GO TO 880
  850 ZD(K) = ZD(K) + AD(1)*BD(1)
      GO TO 880
  860 Z(K  ) = Z(K  ) + A(1)*B(1) - A(2)*B(2)
      Z(K+1) = Z(K+1) + A(1)*B(2) + A(2)*B(1)
      GO TO 880
  870 ZD(K  ) = ZD(K  ) + AD(1)*BD(1) - AD(2)*BD(2)
      ZD(K+1) = ZD(K+1) + AD(1)*BD(2) + AD(2)*BD(1)
  880 K1 = K1 + NBX
      IF (EOL) 980,710,980
C
C     COMMON CASES (TYPEA=TYPEB=TYPED=PREC)
C
C     PREC=1, ARITH(840) AND BPICK(750)
C     PREC=2, ARITH(850) AND BPICK(770)
C     PREC=3, ARITH(860) AND BPICK(760)
C     PREC=4, ARITH(870) AND BPICK(780)
C
  900 DO 910 K = K2,K3,NDX
      Z(K) = Z(K) + A(1)*Z(K1)
  910 K1 = K1 + NBX
      IF (EOL) 980,710,980
  920 DO 930 K = K2,K3,NDX
      ZD(K) = ZD(K) + AD(1)*ZD(K1)
  930 K1 = K1 + NBX
      IF (EOL) 980,710,980
  940 DO 950 K = K2,K3,NDX
      Z(K  ) = Z(K  ) + A(1)*Z(K1  ) - A(2)*Z(K1+1)
      Z(K+1) = Z(K+1) + A(1)*Z(K1+1) + A(2)*Z(K1  )
  950 K1 = K1 + NBX
      IF (EOL) 980,710,980
  960 DO 970 K = K2,K3,NDX
      ZD(K  ) = ZD(K  ) + AD(1)*ZD(K1  ) - AD(2)*ZD(K1+1)
      ZD(K+1) = ZD(K+1) + AD(1)*ZD(K1+1) + AD(2)*ZD(K1  )
  970 K1 = K1 + NBX
      IF (EOL) 980,710,980
  980 RETURN
C
C
      ENTRY MPY2NV (ZZ      ,Z      ,ZD      )
C     ======================
C
C     METHOD 2 NON-TRANSPOSE CASE
C
      B(2)  = 0.
      BD(2) = 0.D0
      AA(2) = 0.
      ADD(2)= 0.D0
      L     = FIRSTL
      ACOL  = ACOL1
 1000 CALL ZNTPKI
      IF (I.LT.ACOL1 .OR. I.GT.ACOLN .OR. I.LT.ACOL) GO TO 1290
      L     = L - 2*(I-ACOL)
      ACOL  = I
      APOINT= ZZ(L)
      IF (APOINT .EQ. 0) GO TO 1280
      NBR   = ZZ(L-1)
      IF (ALL .NE. 0) GO TO (1260,1265,1270,1275), ALL
      GO TO BPICK2, (1010,1020,1030,1040,1050,1060,1070)
 1010 B(1)  = A(1)
      GO TO 1090
 1020 B(1)  = A(1)
      B(2)  = A(2)
      GO TO 1090
 1030 BD(1) = AD(1)
      GO TO 1090
 1040 BD(1) = AD(1)
      BD(2) = AD(2)
      GO TO 1090
 1050 BD(1) = A(1)
      GO TO 1090
 1060 BD(1) = A(1)
      BD(2) = A(2)
      GO TO 1090
 1070 B(1)  = AD(1)
      B(2)  = AD(2)
C
 1090 NBRSTR = ZZ( APOINT+1 )
      INIT   = ZZ( APOINT )
      APOINT = APOINT + 2
      J      = APOINT
      IF ( PRCA .EQ. 2 ) J = J/2 + 1
      APOINT = APOINT+ NBRSTR*NWDA
      IROW   = INIT*RCD - RCD + 1
      NROW   = IROW + NBRSTR*RCD - 1
      DO 1250 K = IROW,NROW,RCD
      GO TO APICK2, (1100,1110,1120,1130,1140,1150,1160)
 1100 AA(1) = Z(J)
      GO TO 1200
 1110 AA(1) = Z(J  )
      AA(2) = Z(J+1)
      GO TO 1200
 1120 ADD(1)= ZD(J)
      GO TO 1200
 1130 ADD(1)= ZD(J  )
      ADD(2)= ZD(J+1)
      GO TO 1200
 1140 ADD(1)= Z(J)
      GO TO 1200
 1150 ADD(1)= Z(J  )
      ADD(2)= Z(J+1)
      GO TO 1200
 1160 AA(1) = ZD(J  )
      AA(2) = ZD(J+1)
C
 1200 GO TO ARITH2, (1210,1220,1230,1240)
 1210 Z(K)  = Z(K) + AA(1)*B(1)
      GO TO 1250
 1220 ZD(K) = ZD(K) + ADD(1)*BD(1)
      GO TO 1250
 1230 Z(K  )= Z(K  ) + AA(1)*B(1) - AA(2)*B(2)
      Z(K+1)= Z(K+1) + AA(1)*B(2) + AA(2)*B(1)
      GO TO 1250
 1240 ZD(K  ) = ZD(K  ) + ADD(1)*BD(1) - ADD(2)*BD(2)
      ZD(K+1) = ZD(K+1) + ADD(1)*BD(2) + ADD(2)*BD(1)
 1250 J = J + RCA
      NBR  = NBR - 1
      IF (NBR) 1280,1280,1090
C
C     COMMON CASES (TYPEA=TYPEB=TYPED=PREC)
C
C     PREC=1, ARITH2(1210), APICK2(1100) AND BPICK2(1010)
C     PREC=2, ARITH2(1220), APICK2(1120) AND BPICK2(1030)
C     PREC=3, ARITH2(1230), APICK2(1110) AND BPICK2(1020)
C     PREC=4, ARITH2(1620), APICK2(1510) AND BPICK2(1410)
C
 1260 NBRSTR = ZZ( APOINT+1 )
      INIT   = ZZ( APOINT )
      APOINT = APOINT + 2
      J      = APOINT
      IF ( PRCA .EQ. 2 ) J = J/2 + 1
      APOINT = APOINT+ NBRSTR*NWDA
      IROW  = INIT*RCD - RCD + 1
      NROW  = IROW + NBRSTR*RCD - 1
      DO 1262 K = IROW,NROW,RCD
      Z(K)  = Z(K) + Z(J)*A(1)
 1262 J     = J + RCA
      NBR   = NBR - 1
      IF (NBR) 1280,1280,1260
C
 1265 NBRSTR = ZZ( APOINT+1 )
      INIT   = ZZ( APOINT )
      APOINT = APOINT + 2
      J      = APOINT
      IF ( PRCA .EQ. 2 ) J = J/2 + 1
      APOINT = APOINT+ NBRSTR*NWDA
      IROW  = INIT*RCD - RCD + 1
      NROW  = IROW + NBRSTR*RCD - 1
      DO 1267 K = IROW,NROW,RCD
      ZD(K) = ZD(K) + ZD(J)*AD(1)
 1267 J     = J + RCA
      NBR   = NBR - 1
      IF (NBR) 1280,1280,1265
C
 1270 NBRSTR = ZZ( APOINT+1 )
      INIT   = ZZ( APOINT )
      APOINT = APOINT + 2
      J      = APOINT
      IF ( PRCA .EQ. 2 ) J = J/2 + 1
      APOINT = APOINT+ NBRSTR*NWDA
      IROW  = INIT*RCD - RCD + 1
      NROW  = IROW + NBRSTR*RCD - 1
      DO 1272 K = IROW,NROW,RCD
      Z(K  )  = Z(K  ) + Z(J)*A(1) - Z(J+1)*A(2)
      Z(K+1)  = Z(K+1) + Z(J)*A(2) + Z(J+1)*A(1)
 1272 J     = J + RCA
      NBR   = NBR - 1
      IF (NBR) 1280,1280,1270
C
 1275 NBRSTR = ZZ( APOINT+1 )
      INIT   = ZZ( APOINT )
      APOINT = APOINT + 2
      J      = APOINT
      IF ( PRCA .EQ. 2 ) J = J/2 + 1
      APOINT = APOINT+ NBRSTR*NWDA
      IROW  = INIT*RCD - RCD + 1
      NROW  = IROW + NBRSTR*RCD - 1
      DO 1277 K = IROW,NROW,RCD
      ZD(K  ) = ZD(K  ) + ZD(J)*AD(1) - ZD(J+1)*AD(2)
      ZD(K+1) = ZD(K+1) + ZD(J)*AD(2) + ZD(J+1)*AD(1)
 1277 J     = J + RCA
      NBR   = NBR - 1
      IF (NBR) 1280,1280,1275
C
 1280 L = L - 2
      ACOL = ACOL + 1
 1290 IF (EOL .EQ. 0) GO TO 1000
      RETURN
C
C
      ENTRY MPY2TV (ZZ      ,Z      ,ZD      )
C     ======================
C
C     METHOD 2 - TRANSPOSE CASE
C
C     COMMENTS FROM G.CHAN/UNISYS      1/91
C     OBSERVE THAT THERE IS NO DO-LOOP IN THIS MPY2TV LOGIC. IT IS
C     THEREFORE CONCLUDED THAT THE TRANSPOSE CASE WOULD TAKE MUCH MORE
C     TIME THAN THE NON-TRANSPOSE CASE
C
      B(2)  = 0.
      BD(2) = 0.D0
      AA(2) = 0.
      ADD(2)= 0.D0
      DD(1) = 0.D0
      DD(2) = 0.D0
      L     = FIRSTL
      APOINT= ZZ(L)
      AROW  = AROW1
      IF (CROW .EQ. MASK6F) GO TO 1350
      GO TO 1330
 1300 APOINT = ZZ(L)
      IF (CROW-AROW) 1320,1340,1350
 1310 DROW = CROW
      CALL ZBLPKI
 1320 IF (EOL .NE. 0) GO TO 1350
 1330 CALL ZNTPKI
      CROW  = I
 1340 DD(1) = AD(1)
      DD(2) = AD(2)
      IF (CROW-AROW) 1310,1360,1350
 1350 DD(1) = 0.D0
      DD(2) = 0.D0
      IF (APOINT .EQ. 0) GO TO 1690
 1360 DROW  = AROW
      IF (APOINT .EQ. 0) GO TO 1680
      NBRSTR= ZZ(L-1)
 1370 NBR   = ZZ( APOINT+1 )
      NBR1  = NBR
      INIT  = ZZ( APOINT )
      APOINT = APOINT + 2
      J = APOINT
      IF ( PRCA .GT. 1 ) J = J/2 + 1
      APOINT = APOINT + NBR*NWDA
      K     = (INIT-1)*RCB + 1
 1380 IF (ALL .NE. 0) GO TO (1640,1645,1650,1655), ALL
      GO TO BPICK2, (1400,1410,1420,1430,1440,1450,1460)
 1400 B(1)  = Z(K)
      GO TO 1470
 1410 B(1)  = Z(K  )
      B(2)  = Z(K+1)
      GO TO 1470
 1420 BD(1) = ZD(K)
      GO TO 1470
 1430 BD(1) = ZD(K  )
      BD(2) = ZD(K+1)
      GO TO 1470
 1440 BD(1) = Z(K)
      GO TO 1470
 1450 BD(1) = Z(K  )
      BD(2) = Z(K+1)
      GO TO 1470
 1460 B(1)  = ZD(K  )
      B(2)  = ZD(K+1)
C
 1470 GO TO APICK2, (1500,1510,1520,1530,1540,1550,1560)
 1500 AA(1) = Z(J)
      GO TO 1570
 1510 AA(1) = Z(J  )
      AA(2) = Z(J+1)
      GO TO 1570
 1520 ADD(1)= ZD(J)
      GO TO 1570
 1530 ADD(1)= ZD(J  )
      ADD(2)= ZD(J+1)
      GO TO 1570
 1540 ADD(1)= Z(J)
      GO TO 1570
 1550 ADD(1)= Z(J  )
      ADD(2)= Z(J+1)
      GO TO 1570
 1560 AA(1) = Z(J  )
      AA(2) = Z(J+2)
C
 1570 GO TO ARITH2, (1600,1610,1620,1630)
 1600 D(1)  = D(1) + AA(1)*B(1)
      GO TO 1660
 1610 DD(1) = DD(1) + ADD(1)*BD(1)
      GO TO 1660
 1620 D(1)  = D(1) + AA(1)*B(1) - AA(2)*B(2)
      D(2)  = D(2) + AA(1)*B(2) + AA(2)*B(1)
      GO TO 1660
 1630 DD(1) = DD(1) + ADD(1)*BD(1) - ADD(2)*BD(2)
      DD(2) = DD(2) + ADD(1)*BD(2) + ADD(2)*BD(1)
      GO TO 1660
C
C     COMMON CASES (TYPEA=TYPEB=TYPED=PREC)
C
C     PREC=1, ARITH2(1600), APICK2(1500) AND BPICK2(1400)
C     PREC=2, ARITH2(1610), APICK2(1520) AND BPICK2(1420)
C     PREC=3, ARITH2(1620), APICK2(1510) AND BPICK2(1410)
C     PREC=4, ARITH2(1630), APICK2(1530) AND BPICK2(1430)
C
 1640 D(1) = D(1) + Z(J)*Z(K)
      J = J + RCA
      K = K + RCB
      NBR = NBR - 1
      IF (NBR) 1670,1670,1640
C
 1645 DD(1) = DD(1) + ZD(J)*ZD(K)
      J = J + RCA
      K = K + RCB
      NBR = NBR - 1
      IF (NBR) 1670,1670,1645
C
 1650 D(1) = D(1) + Z(J)*Z(K  ) - Z(J+1)*Z(K+1)
      D(2) = D(2) + Z(J)*Z(K+1) + Z(J+1)*Z(K  )
      J = J + RCA
      K = K + RCB
      NBR = NBR - 1
      IF (NBR) 1670,1670,1650
C
 1655 DD(1) = DD(1) + ZD(J)*ZD(K  ) - ZD(J+1)*ZD(K+1)
      DD(2) = DD(2) + ZD(J)*ZD(K+1) + ZD(J+1)*ZD(K  )
      J = J + RCA
      K = K + RCB
      NBR = NBR - 1
      IF (NBR) 1670,1670,1655
C
 1660 J = J + RCA
      K = K + RCB
      NBR = NBR - 1
      IF (NBR .GT. 0) GO TO 1380
 1670 NBRSTR = NBRSTR - 1
      IF (NBRSTR .GT. 0) GO TO 1370
 1680 CALL ZBLPKI
 1690 L = L - 2
      AROW = AROW + 1
      IF (AROW .LE. AROWN) GO TO 1300
      RETURN
C
C
      ENTRY MPY3T (*,AAS      ,AAD      ,DDS      ,DDD      )
C     ===============================
C
C     METHOD 3 (TRANSPOSE ONLY)
C
      B3FLAG = -1
      CALL GETSTR (*2400,BLOCK)
CIBMNB 6/93
      IF ( BLOCK( 2 ) .EQ. TYPEB ) GO TO 1699
      TYPEB = BLOCK( 2 )
      RCB   = RC( TYPEB )
      ALL   = 0
 1699 CONTINUE
CIBMNE 6/93
      IF (ALL .NE. 0) GO TO (1760,1920,2060,2270), ALL
      GO TO (1700,1800,2000,2100), TYPED
C
C     PERFORM ARITHMETIC IN REAL SINGLE PRECISION
C
 1700 JB3N = JB31 + NTERM3 - 1
      DO 1740 JB3 = JB31,JB3N
      K = J3
      BBB = BBS(JB3)
      IF (BLOCK(2) .EQ. 2) BBB = BBD(JB3)
      IF (TYPEA    .NE. 2) GO TO 1720
      DO 1710 I = AROW1,AROWN
      AAA = AAD(K)
      DDS(I) = DDS(I) + AAA*BBB
 1710 K  = K + NA
      GO TO 1740
 1720 DO 1730 I = AROW1,AROWN
      DDS(I) = DDS(I) + AAS(K)*BBB
 1730 K  = K + NA
 1740 J3 = J3 + 1
      CALL ENDGET (BLOCK)
      CALL GETSTR (*2500,BLOCK)
      GO TO 1700
C
C     COMMON CASE (TYPEA=TYPEB=TYPED=PREC=1)
C
 1760 JB3N = JB31 + NTERM3 - 1
      DO 1780 JB3 = JB31,JB3N
      K  = J3
      DO 1770 I = AROW1,AROWN
      DDS(I) = DDS(I) + AAS(K)*BBS(JB3)
 1770 K  = K  + NA
 1780 J3 = J3 + 1
      CALL ENDGET (BLOCK)
      CALL GETSTR (*2500,BLOCK)
      GO TO 1760
C
C     PERFORM ARITHMETIC IN REAL DOUBLE PRECISION
C
 1800 K1 = 2*(PRCA-1) + PRC(TYPEB)
 1810 JB3N = JB31 + NTERM3 - 1
      DO 1900 JB3 = JB31,JB3N
      K = J3
      GO TO (1820,1840,1860,1880), K1
 1820 DO 1830 I = AROW1,AROWN
      DDD(I) = DDD(I) + AAS(K)*BBS(JB3)
 1830 K = K + FA3
      GO TO 1900
 1840 DO 1850 I = AROW1,AROWN
      DDD(I) = DDD(I) + AAS(K)*BBD(JB3)
 1850 K = K + FA3
      GO TO 1900
 1860 DO 1870 I = AROW1,AROWN
      DDD(I) = DDD(I) + AAD(K)*BBS(JB3)
 1870 K = K + FA3
      GO TO 1900
 1880 DO 1890 I = AROW1,AROWN
      DDD(I) = DDD(I) + AAD(K)*BBD(JB3)
 1890 K = K + FA3
 1900 J3 = J3 + 1
      CALL ENDGET (BLOCK)
      CALL GETSTR (*2500,BLOCK)
      GO TO 1810
C
C     COMMON CASE (TYPEA=TYPEB=TYPED=PREC=2)
C
 1920 JB3N = JB31 + NTERM3 - 1
      DO 1940 JB3 = JB31,JB3N
      K = J3
      DO 1930 I = AROW1,AROWN
      DDD(I) = DDD(I) + AAD(K)*BBD(JB3)
 1930 K = K  + FA3
 1940 J3 = J3 + 1
      CALL ENDGET (BLOCK)
      CALL GETSTR (*2500,BLOCK)
      GO TO 1920
C
C     PERFORM ARITHMETIC IN COMPLEX SINGLE PRECISION
C
 2000 BSI  = 0.
      I1   = 2*AROW1 - 1
      IN   = 2*AROWN - 1
 2010 IF (RCA .EQ. 2) J3 = 2*J3 - 1
      JB3N = JB31 + RCB*NTERM3 - RCB
      DO 2050 JB3 = JB31,JB3N,RCB
      BSR = BBS(JB3)
      IF (RCB .EQ. 2) BSI = BBS(JB3+1)
      K = J3
      IF (RCA .EQ. 2) GO TO 2030
      DO 2020 I = I1,IN,2
      DDS(I  ) = DDS(I  ) + AAS(K)*BSR
      DDS(I+1) = DDS(I+1) + AAS(K)*BSI
 2020 K = K + NA
      GO TO 2050
 2030 DO 2040 I = I1,IN,2
      DDS(I  ) = DDS(I  ) + AAS(K)*BSR - AAS(K+1)*BSI
      DDS(I+1) = DDS(I+1) + AAS(K)*BSI + AAS(K+1)*BSR
 2040 K = K + NA
 2050 J3 = J3 + RCA
      CALL ENDGET (BLOCK)
      CALL GETSTR (*2500,BLOCK)
      GO TO 2010
C
C     COMMON CASE (TYPEA=TYPEB=TYPED=PREC=3)
C
 2060 I1 = 2*AROW1 - 1
      IN = 2*AROWN - 1
 2070 J3 = 2*J3 - 1
      JB3N = JB31 + RCB*NTERM3 - RCB
      DO 2090 JB3 = JB31,JB3N,RCB
      K = J3
      DO 2080 I = I1,IN,2
      DDS(I  ) = DDS(I  ) + AAS(K)*BBS(JB3  ) - AAS(K+1)*BBS(JB3+1)
      DDS(I+1) = DDS(I+1) + AAS(K)*BBS(JB3+1) + AAS(K+1)*BBS(JB3  )
 2080 K = K + NA
 2090 J3 = J3 + RCA
      CALL ENDGET (BLOCK)
      CALL GETSTR (*2500,BLOCK)
      GO TO 2070
C
C     PERFORM ARITHMETIC IN COMPLEX DOUBLE PRECISION
C
 2100 BDI = 0.
      INCA= RCA*FA3
      I1  = 2*AROW1 - 1
      IN  = 2*AROWN - 1
 2110 IF (RCA .EQ. 2) J3 = 2*J3 - 1
      JB3N = JB31 + RCB*NTERM3 - RCB
      DO 2260 JB3 = JB31,JB3N,RCB
      K = J3
      GO TO (2120,2130,2140,2150), TYPEB
 2120 BDR = BBS(JB3)
      GO TO 2160
 2130 BDR = BBD(JB3)
      GO TO 2160
 2140 BDR = BBS(JB3  )
      BDI = BBS(JB3+1)
      GO TO 2160
 2150 BDR = BBD(JB3  )
      BDI = BBD(JB3+1)
 2160 GO TO (2170,2190,2210,2230), TYPEA
 2170 DO 2180 I = I1,IN,2
      DDD(I  ) = DDD(I  ) + AAS(K)*BDR
      DDD(I+1) = DDD(I+1) + AAS(K)*BDI
 2180 K = K + INCA
      GO TO 2250
 2190 DO 2200 I = I1,IN,2
      DDD(I  ) = DDD(I  ) + AAD(K)*BDR
      DDD(I+1) = DDD(I+1) + AAD(K)*BDI
 2200 K = K + INCA
      GO TO 2250
 2210 DO 2220 I = I1,IN,2
      DDD(I  ) = DDD(I  ) + AAS(K)*BDR - AAS(K+1)*BDI
      DDD(I+1) = DDD(I+1) + AAS(K)*BDI + AAS(K+1)*BDR
 2220 K = K + INCA
      GO TO 2250
 2230 DO 2240 I = I1,IN,2
      DDD(I  ) = DDD(I  ) + AAD(K)*BDR - AAD(K+1)*BDI
      DDD(I+1) = DDD(I+1) + AAD(K)*BDI + AAD(K+1)*BDR
 2240 K = K + INCA
 2250 J3  = J3 + RCA
 2260 CONTINUE
      CALL ENDGET (BLOCK)
      CALL GETSTR (*2500,BLOCK)
      GO TO 2110
C
C     COMMON CASE (TYPEA=TYPEB=TYPED=PREC=4)
C
 2270 INCA= RCA*FA3
      I1  = 2*AROW1 - 1
      IN  = 2*AROWN - 1
 2280 J3 = 2*J3 - 1
      JB3N = JB31 + RCB*NTERM3 - RCB
      DO 2300 JB3 = JB31,JB3N,RCB
      K = J3
      DO 2290 I = I1,IN,2
      DDD(I  ) = DDD(I  ) + AAD(K)*BBD(JB3  ) - AAD(K+1)*BBD(JB3+1)
      DDD(I+1) = DDD(I+1) + AAD(K)*BBD(JB3+1) + AAD(K+1)*BBD(JB3  )
 2290 K = K + INCA
 2300 J3  = J3 + RCA
      CALL ENDGET (BLOCK)
      CALL GETSTR (*2500,BLOCK)
      GO TO 2280
C
 2400 RETURN 1
 2500 RETURN
      END

      SUBROUTINE OUTPT
C
C*****
C
C     DUMMY DECK FOR MODULE OUTPUT    SEE USERS MANUAL SECTION 5.3
C                                     FOR MODULE PROPERTIES CHECK XMPLBD
C                                     OR USE DIAG 29
C
C*****
C
      INTEGER PARM
C
      COMMON /BLANK/ PARM
C
C     DATA INFILE /101/
C
      RETURN
      END

       SUBROUTINE BREAD (IG,INV,II3,NORIG,KG)
C
C      THIS ROUTINE IS USED ONLY IN BANDIT MODULE
C      IT READS THE CONNECTING ELEMENTS AND GENEL ELEM. FROM GEOM2 FILE
C      AND PREPROCESS THE MPC CARDS AND THE RIGID ELEMENTS FROM GEOM4
C
C      REVISED BY G.CHAN/UNISYS
C      12/89, TO INCLUDE NEW RIGID ELEMENTS CRROD, CRBAR, CRTRPLT,
C      CRBE1, CREB2, CRBE3 AND CRSPLINE
C      03/92, TO INCLUDE DUMMY ELEMENTS, CDUM1,...,CDUM9
C
      IMPLICIT INTEGER (A-Z)
      LOGICAL          DEBUG
      DIMENSION        SUB(2),   XXX(3),   IZ(3),    KG(7),    IG(1),
     1                 NORIG(1), INV(II3,1)
      CHARACTER        UFM*23,   UWM*25
      COMMON /XMSSG /  UFM,      UWM
      COMMON /BANDA /  IBUF1,    NOMPC
      COMMON /BANDB /  NBITIN,   KORE,     IFL,      NGRID,    IPNW(2),
     1                 KDIM
      COMMON /BANDD /  DUM6(6),  NEL,      NEQ,      NEQR
      COMMON /BANDS /  NN(10)
      COMMON /GEOMX /  GEOM1,    GEOM2,    GEOM4,    SCR1
      COMMON /NAMES /  RD,       RDREW,    WRT,      WRTREW,   REW
      COMMON /SYSTEM/  IBUF,     NOUT,     DUM43(43),KDUM(9)
      COMMON /GPTA1 /  NE,       LAST,     INCR,     KE(1)
      COMMON /ZZZZZZ/  Z(1)
      DATA             CRIGDR,   CRIGD1,   CRIGD2,   CRIGD3,   GENEL  /
     1                 8210,     5310,     5410,     8310,     4301   /
      DATA             CHBDY,    PLOTEL,   CRROD,    CRBAR,    CRTRPT /
     1                 4208,     5201,     6510,     6610,     6710   /
      DATA             CRBE1,    CRBE2,    CRBE3,    CRSPLN,   MSET   /
     1                 6810,     6910,     7010,     7110,     4HMSET /
      DATA             SUB,                MPC,      MAXMPC,   DEBUG  /
     1                 4HBREA,   4HD   ,   4901,     150,      .FALSE./
C
C
C     CHECK THE PRESENCE OF GEOM2 FILE
C
      KG(1) = GEOM2
      CALL RDTRL (KG(1))
      J = KG(2) + KG(3) + KG(4) + KG(5) + KG(6) + KG(7)
      IF (KG(1).LT.0 .OR. J.EQ.0) GO TO 370
      DO 10 I = 1,7
 10   KG(I) = 0
C
C     UPDATE /GPTA1/ IF DUMMY ELEMENTS ARE PRESENT
C
      DO 15 I = 1,9
      IF (KDUM(I) .EQ. 0) GO TO 15
      K = KDUM(I)/10000000
      L = (KDUM(I)-K*10000000)/10000
      J = (I+51)*INCR
      KE(J+ 6) = 2 + K + L
      KE(J+10) = K
 15   CONTINUE
C
C     CHECK THE PRESENCE OF MPC CARDS AND RIGID ELEMENTS.  SAVE THEIR
C     GRID DATA IN SCR1 FILE FOR TIGER AND UPDATE NEQ AND NEQR COUNTERS
C
      IF (NOMPC .EQ. 0) GO TO 200
      Z(1) = GEOM4
      CALL RDTRL (Z(1))
      J = 0
      DO 20 I = 2,7
 20   J = J + Z(I)
      IF (Z(1).LT.0 .OR. J.EQ.0) GO TO 200
C
      IBUF2 = IBUF1 - IBUF
      CALL OPEN (*290,SCR1,Z(IBUF2),WRTREW)
      IFILE  = GEOM4
      CALL PRELOC (*190,Z(IBUF1),GEOM4)
C
      IF (NOMPC .EQ. 1) GO TO 40
C
      XXX(1) = MPC
      XXX(2) = XXX(1)/100
      CALL LOCATE (*40,Z(IBUF1),XXX,J)
 25   J = 1
      CALL READ (*300,*40,GEOM4,IZ,1,0,M)
 30   J = J + 1
      CALL READ (*300,*40,GEOM4,KG(J),3,0,M)
      IF (KG(J) .NE. -1) IF (J+3-MAXMPC) 30,30,320
      J = J - 1
      KG(1) = J - 1
      CALL WRITE (SCR1,KG,J,1)
      NEQ = NEQ + 1
      GO TO 25
C
C     LOCATE ANY CRIGDR AND CRROD ELEMENTS, AND SAVE THE GRID DATA IN
C     SCR1. (DEPENDENT GRID FIRST, AND ONE INDEPENDENT GRID LAST)
C
C     FOR ALL RIGID ELEMENTS, THE FIRST WORD OF KG ARRAY CONTAINS
C     (NO. OF DEPENDENT + INDEP. GRIDS)*1000 + (NO. OF INDEP. GRIDS)
C     THE DATA IN SCR1 WILL BE PROCESSED BY TIGER
C
 40   IF (NOMPC .EQ. 3) GO TO 180
      XXX(1) = CRIGDR
 50   XXX(2) = XXX(1)/100
      CALL LOCATE (*60,Z(IBUF1),XXX,J)
 55   CALL READ (*300,*60,GEOM4,IZ,1,0,M)
      CALL READ (*300,*60,GEOM4,KG(3),3,0,M)
      KG(1) = 2*1000 + 1
      KG(2) = KG(4)
      CALL WRITE (SCR1,KG,3,1)
      NEQR  = NEQR + 1
      GO TO 55
C
 60   IF (XXX(1) .EQ. CRROD) GO TO 70
      XXX(1) = CRROD
      GO TO 50
C
C     LOCATE ANY CRIGD1, CRIGD2  AND CRBE2  ELEMENTS, AND SAVE GRID
C     DATA IN SCR1. PUT THE ONE INDEPENDENT GRID LAST
C
 70   XXX(1) = CRIGD1
 75   XXX(2) = XXX(1)/100
      CALL LOCATE (*90,Z(IBUF1),XXX,J)
 80   J = 1
      CALL READ (*300,*90,GEOM4,IZ,2,0,M)
      IZ2 = IZ(2)
 85   J = J + 1
      CALL READ (*300,*90,GEOM4,KG(J),1,0,M)
      CALL READ (*300,*90,GEOM4,   0,-6,0,M)
      IF (KG(J) .NE. -1) IF (J-MAXMPC) 85,85,320
      KG(J) = IZ2
      KG(1) = (J-1)*1000 + 1
      CALL WRITE (SCR1,KG,J,1)
      NEQR  = NEQR + 1
      GO TO 80
 90   IF (XXX(1) .EQ. CRBE2) GO TO 110
C
C     LOCATE ANY CRIGD2 ELEMENT
C
      IF (XXX(1) .EQ. CRIGD2) GO TO 100
      XXX(1) = CRIGD2
      GO TO 75
C
C     LOCATE ANY CRBE2 ELEMENT
C
 100  XXX(1) = CRBE2
      GO TO 75
C
C     LOCATE ANY CRIGD3, CRBE1, CRBAR AND CRTRPLT ELEMENTS, AND SAVE
C     GRID DATA IN SCR1 FILE. PUT THE INDEPENDENT GRID LAST
C
 110  XXX(1) = CRBAR
      ASSIGN 115 TO IRTN
      GO TO 130
 115  XXX(1) = CRTRPT
      ASSIGN 120 TO IRTN
      GO TO 130
 120  XXX(1) = CRBE1
      ASSIGN 125 TO IRTN
      GO TO 130
 125  XXX(1) = CRIGD3
      ASSIGN 150 TO IRTN
 130  XXX(2) = XXX(1)/100
      CALL LOCATE (*145,Z(IBUF1),XXX,J)
 133  J = 2
      K = 1
      CALL READ (*300,*145,GEOM4,IZ,1,0,M)
 135  CALL READ (*300,*145,GEOM4,IZ(K),1,0,M)
      IF (IZ(K) .EQ. MSET) GO TO 137
      CALL READ (*300,*145,GEOM4,0,-6,0,M)
      K = K + 1
      IF (K .GT. 999) GO TO 340
      GO TO 135
 137  CALL READ (*300,*145,GEOM4,KG(J),1,0,M)
      CALL READ (*300,*145,GEOM4,0,-6,0,M)
      IF (KG(J) .EQ. -1) GO TO 140
      J = J + 1
      IF (J .GT. MAXMPC) GO TO 320
      GO TO 137
 140  K = K - 1
      DO 142 I = 1,K
      KG(J) = IZ(I)
 142  J = J + 1
      J = J - 1
      KG(1) = (J-1)*1000 + K
      CALL WRITE (SCR1,KG,J,1)
      NEQR = NEQR + 1
      GO TO 133
C
C     LOCATE ANY CRSPLINE ELEMENTS, AND SAVE GRID DATA IN SCR1 FILE.
C     PUT THE INDEPENDENT GRIDS LAST
 145  GO TO IRTN, (115,120,125,150)
C
C     LOCATE ANY CRBE3 ELEMENTS, AND SAVE GRID DATA IN SCR1 FILE. PUT
C     THE INDEPENDENT GRID LAST
C
 150  XXX(1) = CRBE3
      XXX(2) = XXX(1)/100
      CALL LOCATE (*165,Z(IBUF1),XXX,J)
 151  CALL READ (*300,*165,GEOM4,IZ,3,0,M)
      IZ2 = IZ(2)
      J = 2
      CALL READ (*300,*165,GEOM4,0,-2,0,M)
 153  CALL READ (*300,*165,GEOM4,KG(J),1,0,M)
      K = -KG(J)
      IF (K .GT. 0) GO TO (155,157,160) K
      J = J + 1
      IF (J-MAXMPC) 153,153,320
 155  CALL READ (*300,*165,GEOM4,I,1,0,M)
      IF (I .EQ. -2) GO TO 157
      CALL READ (*300,*165,GEOM4,0,-1,0,M)
      GO TO 153
 157  CALL READ (*300,*165,GEOM4,KG(J),1,0,M)
      IF (KG(J) .LT. 0) GO TO 160
      CALL READ (*300,*165,GEOM4,0,-1,0,M)
      J = J + 1
      GO TO 157
 160  KG(J) = IZ2
      KG(1) = (J-1)*1000 + 1
      CALL WRITE (SCR1,KG,J,1)
      NEQR = NEQR + 1
      GO TO 151
C
C     LOCATE ANY CRSPLINE ELEMENTS, AND SAVE GRID DATA IN SCR1 FILE.
C     PUT THE INDEPENDENT GRIDS LAST
C
 165  XXX(1) = CRSPLN
      XXX(2) = XXX(1)/100
      CALL LOCATE (*180,Z(IBUF1),XXX,J)
 167  CALL READ (*300,*180,GEOM4,IZ,3,0,M)
      K = 1
      IZ(K) = IZ(3)
      J = 1
 170  J = J + 1
 173  CALL READ (*300,*175,GEOM4,KG(J),2,0,M)
      IF (KG(J) .EQ. -1) GO TO 175
      IF (J+2 .GT. MAXMPC) GO TO 320
      IF (KG(J+1) .NE.  0) GO TO 170
      K = K + 1
      IF (K .GT. 999) GO TO 340
      IZ(K) = KG(J)
      GO TO 173
 175  DO 177 I = 1,K
      KG(J) = IZ(I)
 177  J = J + 1
      J = J - 1
      KG(1) = (J-1)*1000 + K
      CALL WRITE (SCR1,KG,J,1)
      NEQR = NEQR + 1
      GO TO 167
C
 180  DO 185 K = 1,MAXMPC
 185  KG(K) = 0
 190  CALL CLOSE (GEOM4,REW)
      CALL CLOSE (SCR1,REW)
C
C     PROCESS ELEMENT CARDS AND FILL UP CONNECTION TABLE IG
C
 200  IFILE = GEOM2
      CALL PRELOC (*300,Z(IBUF1),GEOM2)
      IELEM = 1 - INCR
 205  IELEM = IELEM + INCR
      IF (IELEM .GT. LAST) GO TO 250
      IF (KE(IELEM+3) .EQ. CHBDY ) GO TO 205
      IF (KE(IELEM+3) .EQ. PLOTEL) GO TO 205
      SCALAR = KE(IELEM+10)
      IF (SCALAR .EQ. -1) GO TO 205
      CALL LOCATE (*205,Z(IBUF1),KE(IELEM+3),J)
      NWDS  = KE(IELEM+ 5)
      NGPTS = KE(IELEM+ 9)
      NGPT1 = KE(IELEM+12)
      NCON  = NGPTS
 210  CALL READ (*300,*205,GEOM2,KG(1),NWDS,0,M)
      IF (SCALAR .EQ. 0) GO TO 220
      IF (KG(5).EQ.0 .OR. KG(6).EQ.0) GO TO 210
C     THE ABOVE CONDITIONS HOLD TRUE FOR CDAMPI, CELASI, AND CMASSI
C     WHERE I = 1,2
 220  NEL = NEL + 1
      CALL SCAT (KG(NGPT1),NCON,INV,II3,NORIG)
      IF (NGRID .EQ. -1) GO TO 270
      IF (NCON  .LE.  1) GO TO 240
      NGPT2 = NGPT1 + NCON - 1
      K = NGPT2 - 1
      DO 230 I = NGPT1,K
      L = I + 1
      DO 230 J = L,NGPT2
 230  CALL SETIG (KG(I),KG(J),IG,NORIG)
 240  IF (IELEM-LAST) 210,210,255
C
C     SPECIAL TREATMENT FOR GENERAL ELEM.
C     (LIMITED TO KDIM*4 GRID POINTS PER GENEL)
C
 250  XXX(1) = GENEL
      XXX(2) = XXX(1)/100
      CALL LOCATE (*270,Z(IBUF1),XXX,J)
      KDIM4  = KDIM*4
 255  NTOT   = 0
      CALL READ (*300,*270,GEOM2,K,1,0,M)
      K    = 0
      KGPV = 0
      GO TO 263
 260  IF (KG(NCON) .EQ. KGPV) GO TO 265
      KGPV = KG(NCON)
 263  NTOT = NTOT + 1
      IF (NTOT .LT. KDIM4) NCON = NTOT
 265  CALL READ (*300,*270,GEOM2,KG(NCON),2,0,M)
      IF (KG(NCON) .NE. -1) IF (KG(NCON+1)) 260,  265,  260
C                                           GRD  SCALAR GRD
C                                           PT.   PT.   PT.
      K = K + 1
      XXX(K) = KG(NCON+1)
      IF (K .LT. 2) GO TO 265
      NCON = NCON - 1
      M    = XXX(1)
      NWDS = 1 + (M*M-M)/2 + M
      CALL READ (*300,*270,GEOM2,K,-NWDS,0,M)
      CALL READ (*300,*270,GEOM2,K,   1,0,M)
      NGPT1 = 1
      IF (K .EQ. 0) GO TO 220
      NWDS  = M*XXX(2)
      CALL READ (*300,*270,GEOM2,K,-NWDS,0,M)
      GO TO 220
 270  CALL CLOSE (GEOM2,REW)
      IF (NTOT .GT. KDIM4) GO TO 330
      IF (.NOT.DEBUG) RETURN
C
      M = NN(1)
      WRITE  (NOUT,280) NN
      WRITE  (NOUT,285) ((INV(I,J),J=1,2),I=1,M)
 280  FORMAT (//21H /BANDS/ FROM BREAD =,10I8)
 285  FORMAT (/12H TABLE INV =,(/10X,2I8))
      RETURN
C
 290  IFILE = SCR1
 300  CALL MESAGE (-1,IFILE,SUB)
 320  WRITE  (NOUT,325) UWM,IZ(1),MAXMPC
 325  FORMAT (A25,', MPC SET (OR CRIGID ID)',I9,
     1        ' IS TOO LONG,  ONLY THE FIRST',I4, /5X,
     2        ' GRID POINTS ARE USED IN THE BANDIT COMPUTATION')
      GO TO 180
 330  WRITE  (NOUT,335) UFM,NTOT
 335  FORMAT (A23,', GENEL ELEMENT HAS TOO MANY GRID POINTS,',I7)
      J = NTOT/400 + 1
      IF (J .LE. 9) WRITE (NOUT,336) J
 336  FORMAT (5X,'USER NEEDS TO ADD A ''NASTRAN BANDTDIM=',I1,
     1       ''' CARD AND RERUN JOB')
      GO TO 350
 340  WRITE  (NOUT,345)
 345  FORMAT ('0*** MORE THAN 1000 INDEPENDENT GRID POINTS USED IN A ',
     1        'RIGID ELEMENT')
 350  CALL MESAGE (-61,0,0)
C
 370  NGRID = 0
      RETURN
      END

      SUBROUTINE AMPF (SKJ,GKH,AJJL,QHJL,PLAN,IMAX,SCR1,SCR2,SCR3,SCR4,
     1                 SCR5,SCR6,SCR7,SCR8,SCR9,SCR10)
C
C     THE PURPOSE OF THIS ROUTINE IS TO SOLVE FOR QHJL
C
C     THE STEPS ARE AS FOLLOWS
C
C       I.  FOR EACH M-K PAIR
C
C           A. FIND SKJ FROM SKJ LIST
C                                      T
C           B.  COMPUTE  S(K) =  SKJ(K) *GKH
C
C           C.  FOR EACH GROUP
C                                                  G
C               1. BREAK  S(K) INTO GROUPS  =  S(K)
C
C               2. SOLVE FOR  RJH
C                                                        -1     G
C                      D.L. AND D.L. WITH BODIES RGH= AJJ  *S(K)
C                                                        T      G
C                      OTHERS                    RGH= AJJ  *S(K)
C
C               3. MERGE RESULTS
C
C                  1    G11
C                  1 RJH  1
C                  1------1  =   RJH(K)
C                  1    G21
C                  1 RJH  1
C                  1      1
C
C
C           D.  APPEND  RJH ONTO GROWING  QHJL
C                1       1       1
C                1RJH(K1)1RJH(K2)1  =  QHJL
C                1       1       1
C                1       1       1
C
      INTEGER         SKJ,GKH,AJJL,QHJL,PLAN,MCB(7),SYSBUF,NAME(2),
     1                AJJCOL,SCR1,SCR2,SCR3,SCR4,SCR5,SCR6,SCR7,SCR8,
     2                SCR9,SCR10,RJH
      COMMON /AMPCOM/ NCOLJ,NSUB,XM,XK,AJJCOL,QHHCOL,NGP,NGPD(2,30),
     1                MCBQHH(7),MCBQJH(7),NOH,IDJH
      COMMON /SYSTEM/ SYSBUF,NOUT,SKP(52),IPREC
      COMMON /ZZZZZZ/ Z(1)
      COMMON /CDCMPX/ DUM32(32),IB
      COMMON /UNPAKX/ ITC,II,JJ,INCR
      COMMON /PACKX / ITC1,ITC2,II1,JJ1,INCR1
      DATA    NAME  / 4HAMPF,1H /
C
C     INITIALIZE
C
      IBUF1 = KORSZ(Z) - SYSBUF + 1
      IBUF2 = IBUF1 - SYSBUF
      IOP   = 0
      ITL   = 0
      DO 9000 ILOOP = 1,IMAX
      CALL KLOCK (ITS)
      CALL GOPEN (PLAN,Z(IBUF1),IOP)
      IOP = 2
      CALL FREAD (PLAN,XM,4,1)
      CALL CLOSE (PLAN,2)
C
C     FIND  SKJ(K) IN SKJL
C
      CALL GOPEN (SKJ,Z(IBUF1),0)
      CALL GOPEN (SCR1,Z(IBUF2),1)
      K = AJJCOL - 1
      CALL SKPREC (SKJ,K)
      MCB(1) = SKJ
      CALL RDTRL (MCB)
      CALL MAKMCB (MCB,SCR1,MCB(3),MCB(4),MCB(5))
      INCR = 1
      ITC  = MCB(5)
      CALL CYCT2B (SKJ,SCR1,NCOLJ,Z,MCB)
      CALL CLOSE  (SKJ,1)
      CALL CLOSE  (SCR1,1)
      CALL WRTTRL (MCB)
C                     T
C     MULTIPLY  SKJ(K) *GKH  ONTO SCR2
C
      CALL SSG2B (SCR1,GKH,0,SCR2,1,IPREC,1,SCR3)
C
C     POSITION AJJL
C
      CALL GOPEN (AJJL,Z(IBUF1),0)
      K = AJJCOL - 1
      CALL SKPREC (AJJL,K)
      CALL CLOSE  (AJJL,2)
C
C     SET UP TO LOOP ON CONSTANT THEORY
C
      NGPS = 1
      NTH  = NGPD(1,NGPS)
      NCOLTH = 0
  135 NCLOLD = NCOLTH + 1
  140 IF (NGPS .GT. NGP) GO TO 150
      IF (NGPD(1,NGPS) .NE. NTH) GO TO 150
      NCOLTH = NCOLTH + NGPD(2,NGPS)
      NGPS   = NGPS + 1
      GO TO 140
  150 CONTINUE
      IONCE = 0
      IF (NCLOLD.EQ.1 .AND. NGPS.GT.NGP) IONCE = 1
C                                 G
C     COPY AJJL(K) TO SCR1 (AJJ(K) )
C
      CALL GOPEN (AJJL,Z(IBUF1),2)
      CALL GOPEN (SCR1,Z(IBUF2),1)
      MCB(1) = AJJL
      CALL RDTRL (MCB)
      CALL MAKMCB (MCB,SCR1,NCOLTH,MCB(4),MCB(5))
      II   = NCLOLD
      JJ   = NCOLTH
      II1  = 1
      JJ1  = NCOLTH - NCLOLD + 1
      ITC  = MCB(5)
      ITC1 = ITC
      ITC2 = ITC
      INCR = 1
      INCR1= 1
      CALL AMPC1 (AJJL,SCR1,NCOLTH,Z,MCB)
      CALL CLOSE (AJJL,2)
      CALL CLOSE (SCR1,1)
      CALL WRTTRL (MCB)
C                                   G
C     COPY SKJ(K)  ONTO SCR3 (SKJ(K) )
C
      CALL GOPEN (SCR2,Z(IBUF1),0)
      CALL GOPEN (SCR3,Z(IBUF2),1)
      MCB(1) = SCR2
      CALL RDTRL (MCB)
      CALL MAKMCB (MCB,SCR3,NCOLTH,MCB(4),MCB(5))
      ITC  = MCB(5)
      ITC1 = ITC
      ITC2 = ITC
      CALL AMPC1 (SCR2,SCR3,NOH,Z,MCB)
      CALL CLOSE (SCR2,1)
      CALL CLOSE (SCR3,1)
      CALL WRTTRL (MCB)
      RJH = SCR10
      IF (IONCE .NE. 0) RJH = SCR9
C
C     BRANCH ON THEORY
C
      GO TO (1000,2000,3000,4000,5000), NTH
C
C     DOUBLET LATTICE--D.L. WITH SLENDER BODIES
C
 1000 CONTINUE
 2000 CONTINUE
C                     G
C     DECOMPOSE AJJ(K)
C
      IB = 0
      CALL CFACTR (SCR1,SCR4,SCR5,SCR6,SCR7,SCR8,IOPT)
      CALL CFBSOR (SCR4,SCR5,SCR3,RJH,IOPT)
      GO TO 1020
C
C     OTHER THEORIES
C
 3000 CONTINUE
 4000 CONTINUE
 5000 CONTINUE
      CALL SSG2B (SCR1,SCR3,0,RJH,1,IPREC,1,SCR4)
C
C     COPY ACCUMULATIVELY ONTO RJH(K)
C
 1020 IF (IONCE .NE. 0) GO TO 8000
      CALL AMPC2 (RJH,SCR9,SCR1)
      IF (NGPS .GT. NGP) GO TO 8000
      GO TO 135
C
C     ALL GROUPS /THEORIES COMPLETE
C
 8000 CONTINUE
C
C     COPY ONTO  QHJL
C
      CALL GOPEN (SCR9,Z(IBUF1),0)
      CALL GOPEN (QHJL,Z(IBUF2),3)
      MCB(1) = QHJL
      CALL RDTRL (MCB(1))
      ITC  = MCB(5)
      INCR = 1
      CALL CYCT2B (SCR9,QHJL,NOH,Z,MCB)
      CALL CLOSE  (QHJL,2)
      CALL CLOSE  (SCR9,1)
      CALL WRTTRL (MCB)
C
C     END LOOP ON M-K PAIRS
C
      IF (ILOOP .EQ. IMAX) GO TO 9000
C
C     CHECK TIME
C
      CALL KLOCK (ITF)
      CALL TMTOGO (ITMTO)
      ITL= MAX0(ITF-ITS,1,ITL)
      IF (1.1*ITL .GE. ITMTO) GO TO 9010
 9000 CONTINUE
      RETURN
C
C     INSUFFICIENT TIME TO COMPLETE
C
 9010 CALL MESAGE (45,IMAX-ILOOP,NAME)
      RETURN
      END

      SUBROUTINE XGPIDG (NCODE,IX,JX,K)
C
C     THE PURPOSE OF XGPIDG IS TO WRITE DIAGNOSTIC MESSAGES FOR EXGPI
C
C     ICODE  = A SIGNED INTEGER WHICH INDICATES DIAGNOSTIC MESSAGE TO
C              OUTPUT.
C     NODMAP = DMAP CARD NUMBER.
C
      EXTERNAL        LSHIFT,RSHIFT,ANDF
      INTEGER         IX(1),JX(1),DMPCNT,DMPPNT,BCDCNT,DMAP,OSPRC,OSBOT,
     1                OSPNT,OSCAR(1),OTAPID,OP,RSHIFT,ANDF,CPPGCT
      DIMENSION       MED(1),IBF(6),MPL(1),OS(5)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25,SWM*27
      COMMON /XMSSG / UFM,UWM,UIM,SFM,SWM
      COMMON /STAPID/ TAPID(6),OTAPID(6)
      COMMON /SYSTEM/ ZSYS(90),LPCH
C                  ** CONTROL CARD NAMES **
C                  ** DMAP CARD NAMES **
      COMMON /XGPIC / ICOLD,ISLSH,IEQUL,NBLANK,NXEQUI,
     1                NDIAG,NSOL,NDMAP,NESTM1,NESTM2,NEXIT,
     2                NBEGIN,NEND,NJUMP,NCOND,NREPT,NTIME,NSAVE,
     3                NOUTPT,NCHKPT,NPURGE,NEQUIV,
     4                NCPW,NBPC,NWPC,
     5                MASKHI,MASKLO,ISGNON,NOSGN,IALLON,MASKS(1)
      COMMON /ZZZZZZ/ CORE(1)
      COMMON /XGPI2 / LMPL,MPLPNT,MPL
      COMMON /XGPI4 / IRTURN,INSERT,ISEQN,DMPCNT,
     1                IDMPNT,DMPPNT,BCDCNT,LENGTH,ICRDTP,ICHAR,NEWCRD,
     2                MODIDX,LDMAP,ISAVDW,DMAP(1)
      COMMON /MODDMP/ IFLG(6),NAMOPT(26)
      EQUIVALENCE     (CORE(1),OS(1),LOSCAR),(OSPRC,OS(2)),(OSBOT,OS(3))
     1,               (OSPNT,OS(4)),(OSCAR(1),MED(1),OS(5))
      EQUIVALENCE     (ZSYS(1),BUFSZ),(ZSYS(2),OP),(ZSYS(3),NOGO),
     1                (ZSYS(9),NLPP),(ZSYS(12),NLINES),(ZSYS(26),CPPGCT)
     2,               (ZSYS(77),ISYS77)
      EQUIVALENCE     (MPL(1),IBF(1))
      DATA    NLABL1/ 4HLABE/, NLABL2/4HL   /
C
C     SET NOGO FLAG IF NCODE IS POSITIVE
C
      IF (NCODE .GT. 0 .AND. NOGO .LT. 1) NOGO = 1
      I      = IX(1)
      J      = JX(1)
      KDHCOD = 0
      ICODE  = IABS(NCODE)
C
C     BRANCH ON ICODE AND WRITE ERROR MESSAGE.
C
      IF (ICODE.EQ.0 .OR. ICODE.GT.73) GO TO 1830
      NLINES = NLINES + 3
      IF (NLINES .GE. NLPP) CALL PAGE
      GO TO ( 220, 250, 280, 310, 340, 370, 400, 430, 460, 490,
     1        520, 550, 580, 610, 650, 680, 710, 740, 770, 800,
     2        830, 860, 890, 920, 950, 980,1010,1040,1070,1100,
     3       1130,1160,1190,1220,1250,1280,1310,1340,1370,1400,
     4       1430,1460,1490,1520,1550,1580,1610,1640,1670,1710,
     5       1740,1770,1800,1822,3310,3340,3370,3400,3430,3470,
     6       3500,3600,3700,1830,1830,1830,1830,1830,3800,3900,
     7       4000,4100,4200), ICODE
C
C     STANDARD ERROR MESSAGES
C
   10 NODMAP = ANDF(OSCAR(I+5),NOSGN)
      ASSIGN 30 TO LX
   20 IF (NCODE) 130,1830,150
   30 NME1= OSCAR(I+3)
      IF (NCODE .LT. 0) GO TO 60
      WRITE  (OP,50) NME1,OSCAR(I+4),NODMAP
   50 FORMAT (30X,'ERROR IN DMAP INSTRUCTION ',2A4,3X,
     1       'INSTRUCTION NO.',I4)
      GO TO 80
   60 WRITE  (OP,70) NME1,OSCAR(I+4),NODMAP
   70 FORMAT (30X,'POSSIBLE ERROR IN DMAP INSTRUCTION ',2A4,3X,
     1       'INSTRUCTION NO.',I4)
   80 GO TO L, ( 290, 380, 410, 470, 500, 530, 660, 690, 810, 840,
     1           960, 990, 720, 750,1320,1470,1500,1530,1560, 230,
     2           870, 900, 260,1170,1620,1650, 320,1140,1200,1230,
     3           930,1290,1380,1440,1680,1720,3502,3602,3702)
C
   90 ASSIGN 80 TO LX
      IF (NCODE) 170,1830,190
C
  100 ASSIGN 110 TO LX
      GO TO 190
  110 WRITE  (OP,120)
  120 FORMAT (30X,'UNEXPECTED END OF TAPE.')
      GO TO L, (1050,1080,1110)
C
  130 IF (KDHCOD .EQ. 1) GO TO 142
      WRITE  (OP,140) UWM,ICODE
  140 FORMAT (A25,I5,1H,)
      GO TO  210
  142 WRITE  (OP,144) ICODE
  144 FORMAT (/,' *** USER POTENTIALLY FATAL MESSAGE',I4,1H,)
      IF (IFLG(2) .LT. 2) NOGO = 1
      GO TO  210
  150 WRITE  (OP,160) UFM,ICODE
  160 FORMAT (A23,I4,1H,)
      GO TO  210
  170 WRITE  (OP,180) SWM,ICODE
  180 FORMAT (A27,I4,1H,)
      GO TO  210
  190 WRITE  (OP,200) SFM,ICODE
  200 FORMAT (A25,I4,1H,)
C
  210 GO TO LX, ( 350, 440, 560, 590, 620, 780,1020,1260,1350,1410,
     1           1590,1750,1780,1810,1824,  30,  80, 110,3312,3342,
     2           3372,3402,3432,3472,3802,3902,4002,4102,4202)
C
C     ERROR MESSAGE  1   (XIOFL)
C
  220 ASSIGN 230 TO L
      GO TO  10
  230 WRITE  (OP,240)
  240 FORMAT (5X,'ASSUMED FIRST INPUT DATA BLOCK IS NULL')
      GO TO  1850
C
C     ERROR MESSAGE  2   (XOSGEN)
C
  250 ASSIGN 260 TO L
      GO TO  10
  260 WRITE  (OP,270) J,K
  270 FORMAT (5X,'PARAMETER NAMED ',2A4,' IS DUPLICATED')
      GO TO  1850
C
C     ERROR MESSAGE  3   (XPARAM)
C
  280 ASSIGN 290 TO L
      GO TO  10
  290 WRITE  (OP,300) J
  300 FORMAT (5X,'FORMAT ERROR IN PARAMETER NO.',I3)
      GO TO  1850
C
C     ERROR MESSAGE  4   (XPARAM)
C
  310 ASSIGN 320 TO L
      GO TO  90
  320 WRITE  (OP,330) OSCAR(I+3),OSCAR(I+4),J
  330 FORMAT (5X,'MPL PARAMETER ERROR,MODULE NAME = ',2A4,3X,
     1       'PARAMETER NO.',I3)
      GO TO  1850
C
C     ERROR MESSAGE  5   (XPARAM)
C
  340 ASSIGN 350 TO LX
      GO TO  20
  350 WRITE  (OP,360) J,K
  360 FORMAT (30X,'PARAMETER INPUT DATA ERROR, ILLEGAL TYPE FOR ',
     1       'PARAMETER NAMED ',2A4,1H.)
      GO TO 1850
C
C     ERROR MESSAGE  6   (XPARAM)
C
  370 ASSIGN 380 TO L
      GO TO  10
  380 WRITE  (OP,390) J
  390 FORMAT (5X,'ILLEGAL TYPE FOR PARAMETER NO.',I3)
      GO TO  1850
C
C     ERROR MESSAGE  7   (XPARAM)
C
  400 ASSIGN 410 TO L
      GO TO  10
  410 WRITE  (OP,420) J
  420 FORMAT (5X,'PARAMETER NO.',I3,' NEEDS PARAMETER NAME')
      GO TO  1850
C
C     ERROR MESSAGE  8   (XPARAM)
C
  430 ASSIGN 440 TO LX
      GO TO 20
  440 WRITE  (OP,450) J,K
  450 FORMAT (30X,'BULK DATA PARAM CARD ERROR - MUST NOT DEFINE ',
     1       'PARAMETER NAMED ',2A4,1H.)
      GO TO 1850
C
C     ERROR MESSAGE  9   (XPARAM)
C
  460 ASSIGN 470 TO L
      GO TO  10
  470 WRITE  (OP,480) J
  480 FORMAT (5X,'VALUE NEEDED FOR PARAMETER NO.',I3)
      GO TO  1850
C
C     ERROR MESSAGE 10   (XOSGEN)
C
  490 ASSIGN 500 TO L
      KDHCOD = 1
      GO TO  10
  500 WRITE  (OP,510)
  510 FORMAT (5X,'DEFAULT OPTION FOR INPUT DATA BLOCKS - MAKE SURE ',
     1       'MISSING BLOCKS ARE NOT REQUIRED.')
      GO TO 1850
C
C     ERROR MESSAGE 11   (XOSGEN)
C
  520 ASSIGN 530 TO L
      KDHCOD = 1
      GO TO  10
  530 WRITE  (OP,540)
  540 FORMAT (5X,'DEFAULT OPTION FOR OUTPUT DATA BLOCKS - MAKE SURE ',
     1       'MISSING BLOCKS ARE NOT REQUIRED.')
      GO TO 1850
C
C     ERROR MESSAGE 12   (XOSGEN)
C
  550 ASSIGN 560 TO LX
      GO TO  20
  560 WRITE  (OP,570) J
  570 FORMAT (30X,'ERROR IN DMAP INSTRUCTION NO.',I4,
     1       ', ILLEGAL CHARACTER IN DMAP INSTRUCTION NAME.')
      GO TO  1850
C
C     ERROR MESSAGE 13   (XOSGEN)
C
  580 ASSIGN 590 TO LX
      GO TO  20
  590 WRITE  (OP,50) DMAP(J),DMAP(J+1),K
      WRITE  (OP,600)
  600 FORMAT (30X,'DMAP INSTRUCTION NOT IN MODULE LIBRARY.')
      GO TO  1850
C
C     ERROR MESSAGE 14   (XOSGEN,XPARAM,XFLORD,XGPI,XSCNDM)
C
  610 ASSIGN 620 TO LX
      GO TO  190
  620 WRITE  (OP,630) I,J
  630 FORMAT (5X,'ARRAY NAMED ',2A4,' OVERFLOWED')
      IF (K .EQ. 0) GO TO 1850
      WRITE  (OP,640) K
  640 FORMAT (50X,'AT DMAP INSTRUCTION NO. ',I4,1H.)
      GO TO  1850
C
C     ERROR MESSAGE 15   (XPARAM)
C
  650 ASSIGN 660 TO L
      GO TO  10
  660 WRITE  (OP,670) J,K
  670 FORMAT (5X,'INCONSISTENT TYPE USED FOR PARAMETER NAMED ',2A4)
      GO TO  1850
C
C     ERROR MESSAGE 16   (XOSGEN)
C
  680 ASSIGN 690 TO L
      GO TO  10
  690 WRITE  (OP,700)
  700 FORMAT (5X,'ILLEGAL FORMAT')
      GO TO  1850
C
C     ERROR MESSAGE 17   (XOSGEN)
C
  710 ASSIGN 720 TO L
      GO TO  10
  720 WRITE  (OP,730)
  730 FORMAT (5X,'ILLEGAL TIME SEGMENT NAME - NO TIME ESTIMATES MADE',
     1       ' FOR THIS TIME SEGMENT (WARNING ONLY)')
      GO TO  1850
C
C     ERROR MESSAGE 18   (XPARAM)
C
  740 ASSIGN 750 TO L
      GO TO  10
  750 WRITE  (OP,760)
  760 FORMAT (5X,'TOO MANY PARAMETERS IN DMAP PARAMETER LIST')
      GO TO  1850
C
C     ERROR MESSAGE 19   (XOSGEN)
C
  770 ASSIGN 780 TO LX
      GO TO  20
  780 WRITE  (OP,50) NLABL1,NLABL2,I
      WRITE  (OP,790) DMAP(J),DMAP(J+1)
  790 FORMAT (30X,'LABEL NAMED ',2A4,' IS MULTIPLY DEFINED.')
      GO TO  1850
C
C     ERROR MESSAGE 20   (XOSGEN)
C
  800 ASSIGN 810 TO L
      GO TO  10
  810 WRITE  (OP,820) J
  820 FORMAT (5X,'ILLEGAL CHARACTERS IN PARAMETER NO.',I3)
      GO TO  1850
C
C     ERROR MESSAGE 21   (XOSGEN)
C
  830 ASSIGN 840 TO L
      GO TO  10
  840 WRITE  (OP,850) J,K
  850 FORMAT (5X,'PARAMETER NAMED ',2A4,' IS NOT IN PRECEDING DMAP ',
     1        'INSTRUCTION PARAMETER LIST')
      GO TO  1850
C
C     ERROR MESSAGE 22   (XFLORD)
C
  860 ASSIGN 870 TO L
      KDHCOD = 1
      GO TO  10
  870 WRITE  (OP,880) J,K
  880 FORMAT (5X,'DATA BLOCK NAMED ',2A4,' APPEARS AS INPUT BEFORE ',
     1       'BEING DEFINED')
      GO TO  1850
C
C     ERROR MESSAGE 23   (XFLORD)
C
  890 ASSIGN 900 TO L
      GO TO  10
  900 WRITE  (OP,910) J,K
  910 FORMAT (5X,'DATA BLOCK NAMED ',2A4,' IS NOT REFERENCED IN ',
     1       'SUBSEQUENT FUNCTIONAL MODULE')
      GO TO  1850
C
C     ERROR MESSAGE 24   (XGPI)
C
  920 ASSIGN 930 TO L
      GO TO  90
  930 WRITE  (OP,940) I,J
  940 FORMAT (5X,'CANNOT FIND DATA BLOCK NAMED ',2A4,' ON DATA POOL ',
     1       'TABLE ')
      GO TO  1850
C
C     ERROR MESSAGE 25   (XOSGEN)
C
  950 ASSIGN 960 TO L
      GO TO  10
  960 WRITE  (OP,970) J,K
  970 FORMAT (5X,'PARAMETER NAMED ',2A4,' NOT DEFINED')
      GO TO  1850
C
C     ERROR MESSAGE 26   (XOSGEN)
C
  980 ASSIGN 990 TO L
      GO TO  10
  990 WRITE  (OP,1000) J,K
 1000 FORMAT (5X,'LABEL NAMED ',2A4,' NOT DEFINED')
      GO TO  1850
C
C     ERROR MESSAGE 27   (XOSGEN)
C
 1010 ASSIGN 1020 TO LX
      GO TO  20
 1020 WRITE  (OP,1030) J,K
 1030 FORMAT (5X,'LABEL NAMED ',2A4,' NOT REFERENCED')
      GO TO  1850
C
C     ERROR MESSAGE 28   (XGPI)
C
 1040 ASSIGN 1050 TO L
      GO TO  100
 1050 WRITE  (OP,1060)
 1060 FORMAT (61X,'ON NEW PROBLEM TAPE.')
      GO TO  1850
C
C     ERROR MESSAGE 29   (XGPI)
C
 1070 ASSIGN 1080 TO L
      GO TO  100
 1080 WRITE  (OP,1090)
 1090 FORMAT (61X,'ON OLD PROBLEM TAPE.')
      GO TO  1850
C
C     ERROR MESSAGE 30   (XGPI)
C
 1100 ASSIGN 1110 TO L
      GO TO  100
 1110 WRITE  (OP,1120)
 1120 FORMAT (61X,'ON DATA POOL FILE.')
      GO TO  1850
C
C     ERROR MESSAGE 31   (XGPI)
C
 1130 ASSIGN 1140 TO L
      GO TO  90
 1140 WRITE  (OP,1150) I,J
 1150 FORMAT (5X,'CONTROL FILE ',2A4,' INCOMPLETE OR MISSING ON NEW ',
     1       'PROBLEM TAPE')
      GO TO  1850
C
C     ERROR MESSAGE 32   (XFLORD)
C
 1160 ASSIGN 1170 TO L
      GO TO  10
 1170 WRITE  (OP,1180) J,K
 1180 FORMAT (5X,'DATA BLOCK NAMED ',2A4,' MUST BE DEFINED PRIOR TO ',
     1       'THIS INSTRUCTION')
      GO TO  1850
C
C     ERROR MESSAGE 33   (XGPI)
C
 1190 ASSIGN 1200 TO L
      GO TO  90
 1200 WRITE  (OP,1210) I,J
 1210 FORMAT (5X,'SCRATCH FILE CONTAINING DMAP DATA COULD NOT BE ',
     1       'OPENED IN SUBROUTINE ',2A4)
      GO TO 1850
C
C     ERROR MESSAGE 34   (XSCNDM)
C
 1220 ASSIGN 1230 TO L
      GO TO  90
 1230 WRITE  (OP,1240) J
 1240 FORMAT (5X,'CANNOT TRANSLATE DMAP INSTRUCTION NO.',I3)
      GO TO  1850
C
C     ERROR MESSAGE 35   (XGPI)
C
 1250 ASSIGN 1260 TO LX
      GO TO  20
 1260 M = LSHIFT(IBF(5),7)
      IYEAR = RSHIFT(ANDF(M,MASKHI),7)
      M = RSHIFT(M,6)
      IDAY  = RSHIFT(ANDF(M,MASKHI),9)
      M = RSHIFT(M,5)
      IMNTH = RSHIFT(ANDF(M,MASKHI),10)
      N = LSHIFT(OTAPID(5),7)
      JYEAR = RSHIFT(ANDF(N,MASKHI),7)
      N = RSHIFT(N,6)
      JDAY  = RSHIFT(ANDF(N,MASKHI),9)
      N = RSHIFT(N,5)
      JMNTH = RSHIFT(ANDF(N,MASKHI),10)
      WRITE  (OP,1270) (IBF(I),M=1,4),IMNTH,IDAY,IYEAR,IBF(6),
     1                 (OTAPID(J),N=1,4),JMNTH,JDAY,JYEAR,OTAPID(6)
 1270 FORMAT (30X,'INCORRECT OLD PROBLEM TAPE MOUNTED -', /5X,
     1       'ID OF TAPE MOUNTED= ',2A4,1H,,2A4,1H,,I3,1H/,I2,1H/,I2,
     1       'REEL=',I2, /5X,
     2       'ID OF TAPE DESIRED= ',2A4,1H,,2A4,1H,,I3,1H/,I2,1H/,I2,
     3       'REEL=',I2)
      GO TO 1850
C
C     ERROR MESSAGE 36   (XGPI)
C
 1280 ASSIGN 1290 TO L
      GO TO  90
 1290 WRITE  (OP,1300) I,J
 1300 FORMAT (5X,'CANNOT FIND DATA BLOCK NAMED ',2A4,' ON OLD PROBLEM',
     1       ' TAPE')
      GO TO 1850
C
C     ERROR MESSAGE 37   (XGPI)
C
 1310 IF (ISYS77 .LE. -1) GO TO 1850
      ASSIGN 1320 TO L
      GO TO  10
 1320 WRITE  (OP,1330) J,K
 1330 FORMAT (5X,'WARNING ONLY - MAY NOT BE ENOUGH FILES AVAILABLE FOR',
     1       'MODULE REQUIREMENTS', /5X,
     1       'FILES NEEDED =',I4,5X,'FILES AVAILABLE =',I4)
      GO TO 1850
C
C     ERROR MESSAGE 38   (XGPI)
C
 1340 ASSIGN 1350 TO LX
      GO TO  190
 1350 WRITE  (OP,1360)
 1360 FORMAT (5X,'NOT ENOUGH CORE FOR GPI TABLES.')
      WRITE  (OP,1361) I
 1361 FORMAT (5X,'ADDITIONAL CORE NEEDED =',I8,' WORDS.')
      GO TO  1850
C
C     ERROR MESSAGE 39   (XOSGEN)
C
 1370 ASSIGN 1380 TO L
      GO TO  90
 1380 WRITE  (OP,1390)
 1390 FORMAT (5X,'RIGID FORMAT DMAP SEQUENCE DOES NOT CORRESPOND TO ',
     1       'MED TABLE')
      GO TO 1850
C
C     ERROR MESSAGE 40   (XSCNDM)
C
 1400 ASSIGN 1410 TO LX
      GO TO  20
 1410 WRITE  (OP,1420)
 1420 FORMAT (5X,'ERROR IN ALTER DECK - CANNOT FIND END OF DMAP ',
     1       'INSTRUCTION')
      GO TO 1850
C
C     ERROR MESSAGE 41   (XFLDEF)
C
 1430 ASSIGN 1440 TO L
      GO TO  90
 1440 WRITE  (OP,1450) I,J
 1450 FORMAT (5X,'TABLES INCORRECT FOR REGENERATING DATA BLOCK ',2A4)
      GO TO 1850
C
C     ERROR MESSAGE 42   (XPARAM)
C
 1460 ASSIGN 1470 TO L
      GO TO  10
 1470 WRITE  (OP,1480) J,K
 1480 FORMAT (5X,'PARAMETER NAMED ',2A4,' ALREADY HAD VALUE ASSIGNED ',
     1        'PREVIOUSLY')
      GO TO 1850
C
C     ERROR MESSAGE 43   (XOSGEN)
C
 1490 ASSIGN 1500 TO L
      GO TO  10
 1500 WRITE  (OP,1510)
 1510 FORMAT (5X,'ILLEGAL TYPE FOR CONSTANT VALUE')
      GO TO  1850
C
C     ERROR MESSAGE 44   (XSCNDM)
C
 1520 ASSIGN 1530 TO L
      GO TO  10
 1530 WRITE  (OP,1540)
 1540 FORMAT (5X,'UNABLE TO FIND END DMAP INSTRUCTION')
      GO TO  1850
C
C     ERROR MESSAGE 45   (XFLORD)
C
 1550 ASSIGN 1560 TO L
      KDHCOD = 1
      GO TO  10
 1560 WRITE  (OP,1570) J,K
 1570 FORMAT (5X,'DATA BLOCK NAMED ',2A4,' ALREADY APPEARED AS OUTPUT')
      GO TO 1850
C
C     ERROR MESSAGE 46   (XGPI)
C
 1580 ASSIGN 1590 TO LX
      GO TO  20
 1590 WRITE  (OP,1600)
 1600 FORMAT (5X,'INCORRECT REENTRY POINT')
      GO TO  1850
C
C     ERROR MESSAGE 47   (XFLORD)
C
 1610 ASSIGN 1620 TO L
      GO TO  10
 1620 WRITE  (OP,1630)
 1630 FORMAT (5X,'THIS INSTRUCTION CANNOT BE FIRST INSTRUCTION OF LOOP')
      GO TO 1850
C
C     ERROR MESSAGE 48   (XOSGEN)
C
 1640 ASSIGN 1650 TO L
      GO TO  10
 1650 WRITE  (OP,1660) J,K
 1660 FORMAT (5X,'DATA SET ',2A4,' IS ALWAYS REGENERATED, THEREFORE IT',
     1       'WILL NOT BE CHECKPOINTED')
      GO TO  1850
C
C     ERROR MESSAGE 49   (XGPIBS,XOSGEN)
C
 1670 ASSIGN 1680 TO L
      GO TO  90
 1680 WRITE  (OP,1690)
 1690 FORMAT (5X,'MPL TABLE (MODULE PROPERTIES LIST) IS INCORRECT')
      IF (I .EQ. 0) GO TO 1850
      NLINES = NLINES + 1
      WRITE  (OP,1700) I,J,K
 1700 FORMAT (5X,'DECIMAL LOCATION RELATIVE TO MPL(1) = ',I10,
     1        ',MODULE NAME = ',2A4 )
      GO TO 1850
C
C     ERROR MESSAGE 50   (XGPI)
C
 1710 ASSIGN 1720 TO L
      GO TO  90
 1720 WRITE  (OP,1730)
 1730 FORMAT (5X,'CANNOT FIND JUMP OSCAR ENTRY NEEDED FOR THIS RESTART')
      GO TO  1850
C
C     ERROR MESSAGE 51   (XGPIBS)
C
 1740 ASSIGN 1750 TO LX
      GO TO  190
 1750 WRITE  (OP,1760)
 1760 FORMAT (5X,'NOT ENOUGH OPEN CORE FOR XGPIBS ROUTINE')
      WRITE  (OP,1361) I
      GO TO  1850
C
C     ERROR MESSAGE 52   (XGPIBS)
C
 1770 ASSIGN 1780 TO LX
      GO TO  190
 1780 WRITE  (OP,1790)
 1790 FORMAT (5X,'NAMED COMMON /XLINK/ IS TOO SMALL')
      GO TO  1850
C
C     ERROR MESSAGE 53   (XGPIBS)
C
 1800 ASSIGN 1810 TO LX
      GO TO  150
 1810 WRITE  (OP,1820)
 1820 FORMAT (5X,'INCORRECT FORMAT IN ABOVE CARD')
      GO TO  1850
C
C     ERROR MESSAGE 54   (XGPI)
C
 1822 ASSIGN 1824 TO LX
      GO TO  130
 1824 WRITE  (OP,1826) J,K
 1826 FORMAT (5X,'PARAMETER NAMED ',2A4,' NOT REFERENCED')
      GO TO  1850
C
C     ERROR MESSAGE 55   (XOSGEN)
C
 3310 ASSIGN 3312 TO LX
      GO TO  150
 3312 WRITE  (OP,3314)
 3314 FORMAT (5X,'PRECHK NAME LIST EXCEEDS MAXIMUM LIMIT (50)')
      GO TO  1850
C
C     ERROR MESSAGE 56   (XOSGEN)
C
 3340 ASSIGN 3342 TO LX
      GO TO  130
 3342 WRITE  (OP,3344)
 3344 FORMAT (5X,'ILLEGAL OPTION ON XDMAP CARD - IGNORED')
      GO TO  1850
C
C     ERROR MESSAGE 57   (XOSGEN)
C
 3370 ASSIGN 3372 TO LX
      GO TO  150
 3372 WRITE  (OP,3374)
 3374 FORMAT (5X,'VARIABLE REPT PARAMETER MUST BE AN INTEGER')
      GO TO  1850
C
C     ERROR MESSAGE 58   (XOSGEN)
C
 3400 ASSIGN 3402 TO LX
      GO TO  150
 3402 WRITE  (OP,3404)
 3404 FORMAT (5X,'VARIABLE REPT PARAMETER MUST BE DEFINED PRIOR TO ',
     1       'INSTRUCTION')
      GO TO 1850
C
C     ERROR MESSAGE 59   (OSCXRF)
C
 3430 ASSIGN 3432 TO LX
      KDHCOD = 1
      GO TO  130
 3432 WRITE  (OP,3434)
 3434 FORMAT (5X,'POOL FILE ERROR - DMAP CROSS-REF TERMINATED.')
      GO TO  1850
C
C     ERROR MESSAGE 60   (OSCXRF)
C
 3470 ASSIGN 3472 TO LX
      KDHCOD = 1
      GO TO  130
 3472 WRITE  (OP,3474)
 3474 FORMAT (5X,'INSUFFICIENT OPEN CORE FOR DMAP CROSS-REF - ',
     1       'TERMINATED.')
      WRITE  (OP,1361) I
      GO TO  1850
C
C     ERROR MESSAGE 61   (XOSGEN)
C
 3500 ASSIGN 3502 TO L
      GO TO  10
 3502 WRITE  (OP,3504)
 3504 FORMAT (5X,'SAVE INSTRUCTION OUT OF SEQUENCE')
      GO TO  1850
C
C     ERROR MESSAGE 62   (XIPFL)
C
 3600 ASSIGN 3602 TO L
      GO TO  10
 3602 WRITE  (OP,3604)
 3604 FORMAT (5X,'INCORRECT NUMBER OF INPUT DATA BLOCKS ENCOUNTERED')
      GO TO  1850
C
C     ERROR MESSAGE 63   (XIPFL)
C
 3700 ASSIGN 3702 TO L
      GO TO  10
 3702 WRITE  (OP,3704)
 3704 FORMAT (5X,'INCORRECT NUMBER OF OUTPUT DATA BLOCKS ENCOUNTERED')
      GO TO  1850
C
C     ERROR MESSAGE 69   (XGPI)
C
 3800 ASSIGN 3802 TO LX
      GO TO  190
 3802 WRITE  (OP,3804) I, J
 3804 FORMAT (5X,'SUBROUTINE ',2A4,' FINDS RIGID FORMAT OR MED TABLE ',
     1       'RECORD MISSING ON SCRATCH FILE', /5X,
     2       'MOST LIKELY DUE TO INSUFFECIENT CORE')
C
C   * NOTE - DATA ON SCRATCH FILE MAY BE DESTROYED BY XSORT2 *
      GO TO  1850
C
C     ERROR MESSAGE 70   (XGPI)
C
 3900 ASSIGN 3902 TO LX
      GO TO  190
 3902 WRITE  (OP,3904) I,J,K
 3904 FORMAT (5X,'SUBROUTINE ',2A4,' FINDS ',A4,' NAME TABLE RECORD ',
     1       'MISSING ON SCRATCH FILE')
      GO TO  1850
C
C     ERROR MESSAGE 71   (XGPI)
C
 4000 ASSIGN 4002 TO LX
      GO TO  190
 4002 WRITE  (OP,4004) I
 4004 FORMAT (5X,'ILLEGAL NUMBER OF WORDS (',I8,') IN MED TABLE RECORD',
     1       ' ON SCRATCH FILE')
      GO TO  1850
C
C     ERROR MESSAGE 72   (XGPI)
C
 4100 ASSIGN 4102 TO LX
      GO TO  190
 4102 WRITE  (OP,4104) I,J
 4104 FORMAT (5X,'ILLEGAL NUMBER OF WORDS (',I8,') IN ',A4,
     1       ' NAME TABLE RECORD ON SCRATCH FILE')
      GO TO  1850
C
C     ERROR MESSAGE 73   (XGPI)
C
 4200 ASSIGN 4202 TO LX
      GO TO  190
 4202 WRITE  (OP,4204) I
 4204 FORMAT (5X,'ONE OR MORE ILLEGAL BIT NUMBERS SPECIFIED IN ',A4,
     1       ' NAME TABLE')
      GO TO 1850
C
 1830 WRITE  (OP,1840) ICODE
 1840 FORMAT (//5X,'NO MESSAGE AVAILABLE FOR ERROR CODE =',I4)
C
 1850 RETURN
C
      END

      SUBROUTINE QDMM1S
C
C     THIS SUBROUTINE COMPUTES THE STIFFNESS AND MASS MATRIX FOR THE
C     FIRST QUADRILATERAL MEMBRANE ELEMENT.
C
C     SINGLE PRECISION VERSION
C
C     ECPT LIST
C                                                   IN THIS
C        ECPT       DESCRIPTION                     ROUTINE    TYPE
C     ========   ================================   ========  =======
C     ECPT( 1) = ELEMENT ID                         NECPT(1)  INTEGER
C     ECPT( 2)   GRID POINT A                       NGRID(1)  INTEGER
C     ECPT( 3)   GRID POINT B                       NGRID(2)  INTEGER
C     ECPT( 4)   GRID POINT C                       NGRID(3)  INTEGER
C     ECPT( 5)   GRID POINT D                       NGRID(4)  INTEGER
C     ECPT( 6) = THETA = ANGLE OF MATERIAL          ANGLE     REAL
C     ECPT( 7)   MATERIAL ID                        MATID     INTEGER
C     ECPT( 8) = THICKNESS                          T         REAL
C     ECPT( 9) = NON-STRUCTURAL MASS                FMU       REAL
C     ECPT(10)   COORD. SYSTEM ID 1                 NECPT(10) INTEGER
C     ECPT(11) = X1                                 X1        REAL
C     ECPT(12) = Y1                                 Y1        REAL
C     ECPT(13) = Z1                                 Z1        REAL
C     ECPT(14)   COORD. SYSTEM ID 2                 NECPT(14) INTEGER
C     ECPT(15) = X2                                 X2        REAL
C     ECPT(16) = Y2                                 Y2        REAL
C     ECPT(17) = Z2                                 Z2        REAL
C     ECPT(18)   COORD. SYSTEM ID 3                 NECPT(18) INTEGER
C     ECPT(19) = X3                                 X3        REAL
C     ECPT(20) = Y3                                 Y3        REAL
C     ECPT(21) = Z3                                 Z3        REAL
C     ECPT(22)   COORD. SYSTEM ID 4                 NECPT(22) INTEGER
C     ECPT(23) = X4                                 X4        REAL
C     ECPT(24) = Y4                                 Y4        REAL
C     ECPT(25)   Z4                                 Z4        REAL
C     ECPT(26) = ELEMENT TEMPERATURE                ELTEMP    REAL
C
      LOGICAL         NOGO,     HEAT,     PLANAR
      INTEGER         OUTPT,    DICT(9),  MAP(2,4), ELID,     ESTID
      REAL            KIJ,      LA,       LB,       LC,       LD,
     1                LBD1,     LCD1,     LCD2,     LDD2,     MGG(4),
     2                MAGI,     MAGJ,     MAGK,     ETA01(2), ECPT(26),
     3                TEMPAR(144)
      CHARACTER       UFM*23,   UWM*25,   UIM*29
      COMMON /XMSSG / UFM,      UWM,      UIM
      COMMON /SYSTEM/ KSYSTM,   OUTPT
      COMMON /CONDAS/ CONSTS(4),DEGRA
      COMMON /EMGEST/ NECPT(1), NGRID(4), ANGLE,    MATID1,   THICK,
     1                FMU,      DUMMY1,   X1,       Y1,       Z1,
     2                          DUMMY2,   X2,       Y2,       Z2,
     3                          DUMMY3,   X3,       Y3,       Z3,
     4                          DUMMY4,   X4,       Y4,       Z4,
     5                DUM(75)
      COMMON /EMGPRM/ DUM2(16), MASS,     DUM3,     IPREC,    NOGO,
     1                HEAT
      COMMON /MATIN / MATID,    INFLAG,   ELTEMP,   STRESS,   SINTH,
     1                COSTH
      COMMON /MATOUT/ G11,      G12,      G13,      G22,      G23,
     1                G33,      RHO,      ALPHA1,   ALPHA2,   ALP12,
     2                TSUB0,    GSUBE,    SIGTEN,   SIGCOM,   SIGSHE,
     3                G2X211,   G2X212,   G2X222
      COMMON /SMA1DP/ TIE(9,4), KIJ(3,3), B(144),   E(9),     ETJ(9,4)
      COMMON /SMA2DP/ U(64),    C(6),     AQ(24),   BQ(24),   CQ(30),
     1                TI(9),    BTXK(96)
      COMMON /EMGDIC/ DMMM(2),  NLOCS,    ELID,     ESTID
      EQUIVALENCE     (DICT5,DICT(5)),    (ECPT(1),NECPT(1)),
     1                (U(1),TEMPAR(1))
C
      O(D,V,F,H,P,Q,Y4A,X12,Y34,Y3A,X23,X14,ETA,TEA) = (D+(V*TEA) +
     1 (F*ETA) + (H*TEA*ETA) + (P*TEA*TEA) + (Q*ETA*ETA))/
     2 ((-Y4A*X12) + (-Y34*X12*ETA) + ((-Y4A*X23) + (Y3A*X14))*TEA)
C
      ETA = 1.0
      TEA = 1.0
      IF (HEAT) GO TO 450
      ETA01(1) = 0.211324865
      ETA01(2) = 0.788675135
C
C     COMPUTE DIFFERENCES OF COORDINATES OF ACTUAL GRID POINTS
C
      X21 = X2 - X1
      Y21 = Y2 - Y1
      Z21 = Z2 - Z1
      X31 = X3 - X1
      Y31 = Y3 - Y1
      Z31 = Z3 - Z1
      X41 = X4 - X1
      Y41 = Y4 - Y1
      Z41 = Z4 - Z1
      X42 = X4 - X2
      Y42 = Y4 - Y2
      Z42 = Z4 - Z2
C
C     COMPUTE ELEMENTS OF THE E MATRIX
C
      PK1 = Y31*Z42 - Z31*Y42
      PK2 = Z31*X42 - X31*Z42
      PK3 = X31*Y42 - Y31*X42
      MAGK= SQRT(PK1**2 + PK2**2 + PK3**2)
      IF (MAGK .LE. 1.0E-6) GO TO 410
      PK1 = PK1/MAGK
      PK2 = PK2/MAGK
      PK3 = PK3/MAGK
C
C     HH IS THE MEASURE OF NON-PLANARITY OF THE ELEMENT
C
      HH  = X21*PK1 + Y21*PK2 + Z21*PK3
      PI1 = X21 - HH*PK1
      PI2 = Y21 - HH*PK2
      PI3 = Z21 - HH*PK3
      MAGI= SQRT(PI1**2 + PI2**2 + PI3**2)
      IF (MAGI .LE. 1.0E-6) GO TO 420
      PI1 = PI1/MAGI
      PI2 = PI2/MAGI
      PI3 = PI3/MAGI
      HH  =-HH/2.0
C
C     THIS SIGN CHANGE MADE BECAUSE SIGN OF H AS DEFINED ON
C     PAGE 4.87-105 OF PROGRAMMERS MANUAL IS WRONG
C
      TEMP  = SQRT(X31**2 + Y31**2 + Z31**2)
      YSUB4 = SQRT(X42**2 + Y42**2 + Z42**2)
      H1    = (2.0*HH)/(TEMP + YSUB4)
      PLANAR= .TRUE.
      IF (H1 .GT. 1.0E-6) PLANAR = .FALSE.
      IF (H1 .GE. 1.0E-2) WRITE (OUTPT,28) UIM,H1,NECPT(1)
   28 FORMAT (A29,' 3061, THE MEASURE OF NON-PLANARITY IS ',E13.5,
     1       ' FOR ELEMENT NUMBER',I9)
      PJ1 = PK2*PI3 - PK3*PI2
      PJ2 = PK3*PI1 - PK1*PI3
      PJ3 = PK1*PI2 - PK2*PI1
      MAGJ= SQRT(PJ1**2 + PJ2**2 + PJ3**2)
      IF (MAGJ .LE. 1.0E-6) GO TO 430
      PJ1 = PJ1/MAGJ
      PJ2 = PJ2/MAGJ
      PJ3 = PJ3/MAGJ
C
C  *  SET UP E MATRIX (3X3) FOR QUAD-MEMBRANE PROJECTION ONTO MEAN PLANE
C     E IS TRANSPOSE OF E MATRIX IN THEORETICAL MANUAL
C
C     E(1),E(4),E(7) IS I-VECTOR
C     E(2),E(5),E(8) IS J-VECTOR
C     E(3),E(6),E(9) IS K-VECTOR
C
      E(1) = PI1
      E(2) = PJ1
      E(3) = PK1
      E(4) = PI2
      E(5) = PJ2
      E(6) = PK2
      E(7) = PI3
      E(8) = PJ3
      E(9) = PK3
C
C     COMPUTE DIFFERENCES OF COORDINATES OF GRID POINTS IN THE MEAN PLAN
C
      X12 =-(X21*E(1) + Y21*E(4) + Z21*E(7))
      X13 =-(X31*E(1) + Y31*E(4) + Z31*E(7))
      X24 =-(X42*E(1) + Y42*E(4) + Z42*E(7))
      X14 = X12 + X24
      Y3A = X31*E(2) + Y31*E(5) + Z31*E(8)
      Y4A = X42*E(2) + Y42*E(5) + Z42*E(8)
      X34 = X14 - X13
      Y34 = Y3A - Y4A
      X23 = X13 - X12
      IF (Y3A.LE.0. .OR. Y4A.LE.0.) GO TO 430
      TEMP  = X12 + X23*(Y4A/Y3A)
      YSUB4 = (Y3A/Y4A)*X14
C
C                                              0
C     CHECK FOR INTERNAL ANGLE GREATER THAN 180
C
      IF (X13.GE.YSUB4 .OR. X14.LE.TEMP) GO TO 430
C
C     GET MASS MATRIX DIAGONALS
C
      IF( MASS .EQ. 0) GO TO 60
      INFLAG = 4
      MATID  = MATID1
      CALL MAT (ECPT(1))
C
C     GET TRIANGULAR AREA TIMES TWO
C
      AT1 = -X12*Y4A
      AT2 = -X12*Y3A
      AT3 = -X23*Y4A + X24*Y3A
      AT4 = -X13*Y4A + X14*Y3A
C
      FACT   = (FMU + G11*THICK)/12.0
      MGG(1) = (AT4 + AT1 + AT2)*FACT
      MGG(2) = (AT1 + AT2 + AT3)*FACT
      MGG(3) = (AT2 + AT3 + AT4)*FACT
      MGG(4) = (AT3 + AT4 + AT1)*FACT
C
C     COMPUTE LENGTHS OF SIDES OF ELEMENT IN THE MEAN PLANE
C
   60 LA = ABS(X12)
      LB = SQRT(X23**2 + Y3A**2)
      LC = SQRT(X34**2 + Y34**2)
      LD = SQRT(X14**2 + Y4A**2)
      IF (LA.EQ.0. .OR. LB.EQ.0. .OR. LC.EQ.0. .OR. LD.EQ.0.) GO TO 430
C
C     COMPUTE THE CHARACTERISTIC ANGLES OF ELEMENT IN THE MEAN PLANE
C
      IF (PLANAR) GO TO 75
      CTH1  =-X14/LD
      STH1  = Y4A/LD
      CTH2  = X23/LB
      STH2  = Y3A/LB
      CTH31 = X34/LC
      STH31 =-Y34/LC
      CTH41 = CTH1
      STH41 = STH1
      CTH32 = STH2
      STH32 = CTH2
      CTH42 = STH31
      STH42 = CTH31
      DLT1  = CTH31*CTH32 - STH31*STH32
      DLT2  = CTH42*CTH41 + STH41*STH42
      LDD2  = LD*DLT2
      LBD1  = LB*DLT1
      LCD1  = LC*DLT1
      LCD2  = LC*DLT2
C
C     SET UP THE (12X8)  TRANSFORMATION MATRIX B BETWEEN THE MEAN PLANE
C                        AND ACTUAL GRID POINTS
C
      DO70 I = 2,92
      B(I) = 0.0
   70 CONTINUE
C
      B( 1) = 1.0
      B(10) = 1.0
      B(17) =-HH/LA
      B(18) =-HH/(LD*STH1) + ((HH*CTH1)/(LA*STH1))
      B(19) = HH/LA
      B(20) = (HH*CTH2)/(LA*STH2)
      B(23) = (HH*CTH42)/LDD2
      B(24) = (HH*STH42)/LDD2
      B(27) = 1.0
      B(36) = 1.
      B(41) =-B(17)
      B(42) = (-HH*CTH1)/(LA*STH1)
      B(43) = B(17)
      B(44) = ((-HH*CTH2)/(LA*STH2)) + (HH/(LB*STH2))
      B(45) = (-HH*STH31)/LBD1
      B(46) = (-HH*CTH31)/LBD1
      B(53) = 1.
      B(62) = 1.
      B(68) =-HH/(LB*STH2)
      B(69) = HH*((STH31/LBD1) + (CTH32/LCD1))
      B(70) = HH*((CTH31/LBD1) + (STH32/LCD1))
      B(71) = (-HH*STH41)/LCD2
      B(72) = (HH*CTH41)/LCD2
      B(79) = 1.0
      B(88) = 1.0
      B(90) = HH/(LD*STH1)
      B(93) = (-HH*CTH32)/LCD1
      B(94) = (-HH*STH32)/LCD1
      B(95) = HH*((-CTH42/LDD2) + (STH41/LCD2))
      B(96) = HH*((-STH42/LDD2) - (CTH41/LCD2))
C
   75 THETA = ANGLE*DEGRA
      SINTH = SIN(THETA)
      COSTH = COS(THETA)
      IF (ABS(SINTH).LT.1.0E-06) SINTH = 0.0E0
      ELTEMP = ECPT(26)
      INFLAG = 2
      MATID  = MATID1
C
C                                                     T
C     COMPUTE TRANSFORMED MATRIX OF STIFFNESSES  C = P  * G * P
C
      CALL MAT (ECPT(1))
C
C     STORE INTO G MATRIX
C
      C(1) = G11
      C(2) = G12
      C(3) = G22
      C(4) = G13
      C(5) = G23
      C(6) = 0.
      FACT = G33*THICK/(X24*Y3A - X13*Y4A)*2.
C
C     COMPUTE COEFFICIENTS OF THE GENERAL INTEGRAL
C
C                                            2         2
C     D + E*ETA + F*ZETA + H*ETA*ZETA + P*ETA  + Q*ZETA
C     --------------------------------------------------
C     Y *X   +Y  *X  *ZETA + (Y *X   - Y *X  ) * ETA
C      4  21   34  21          4  32    3  41
C
      AQ( 1) =-Y4A
      AQ( 3) =-X24
      AQ( 5) =-X24
      AQ( 6) =-Y4A
      AQ( 7) = Y4A
      AQ( 9) = X14
      AQ(11) = X14
      AQ(12) = Y4A
      AQ(13) = 0.0
      AQ(15) = 0.0
      AQ(17) = 0.0
      AQ(18) = 0.0
      AQ(19) = 0.0
      AQ(21) =-X12
      AQ(23) =-X12
      AQ(24) = 0.0
C
      BQ( 1) = Y3A
      BQ( 3) = X23
      BQ( 5) = X23
      BQ( 6) = Y3A
      BQ( 7) =-Y4A
      BQ( 9) =-X14
      BQ(11) =-X14
      BQ(12) =-Y4A
      BQ(13) = Y4A
      BQ(15) = X14
      BQ(17) = X14
      BQ(18) = Y4A
      BQ(19) =-Y3A
      BQ(21) =-X23
      BQ(23) =-X23
      BQ(24) =-Y3A
C
      CQ( 1) =-Y34
      CQ( 3) = X34
      CQ( 5) = X34
      CQ( 6) =-Y34
      CQ( 7) = Y34
      CQ( 9) =-X34
      CQ(11) =-X34
      CQ(12) = Y34
      CQ(13) = 0.0
      CQ(15) =-X12
      CQ(17) =-X12
      CQ(18) = 0.0
      CQ(19) = 0.0
      CQ(21) = X12
      CQ(23) = X12
      CQ(24) = 0.0
C
      NN = 0
      DO 120 I = 1,4
      DO 110 K = 1,2
      DO 100 J = 1,4
      DO  90 L = 1,2
      NN  = NN + 1
      IM1 = I  - 1
      JM1 = J  - 1
      KM1 = K  - 1
      LM1 = L  - 1
      K1  = 6*IM1 + 4*KM1 + 1
      K2  = 6*IM1 + 3*KM1 + 3
      L1  = 6*JM1 + 4*LM1 + 1
      L2  = 6*JM1 + 3*LM1 + 3
      KL  = K + L - 1
      K3  = K + 3
      L3  = L + 3
      D = C(KL)*AQ(K1)*AQ(L1)+C(K3)*AQ(K1)*AQ(L2)+C(L3)*AQ(K2)*AQ(L1)
C
      V = C(KL)*((AQ(K1)*BQ(L1))+(BQ(K1)*AQ(L1)))+C(K3)*((AQ(K1)*BQ(L2))
     1  + (BQ(K1)*AQ(L2)))+C(L3)*((AQ(K2)*BQ(L1))+(BQ(K2)*AQ(L1)))
C
      F = C(KL)*((AQ(K1)*CQ(L1))+(CQ(K1)*AQ(L1)))+C(K3)*((AQ(K1)*CQ(L2))
     1  + (CQ(K1)*AQ(L2)))+C(L3)*((AQ(K2)*CQ(L1))+(CQ(K2)*AQ(L1)))
C
      H = C(KL)*((BQ(K1)*CQ(L1))+(CQ(K1)*BQ(L1)))+C(K3)*((BQ(K1)*CQ(L2))
     1  + (CQ(K1)*BQ(L2)))+C(L3)*((BQ(K2)*CQ(L1))+(CQ(K2)*BQ(L1)))
C
      P = C(KL)*BQ(K1)*BQ(L1)+C(K3)*BQ(K1)*BQ(L2)+C(L3)*BQ(K2)*BQ(L1)
C
      Q = C(KL)*CQ(K1)*CQ(L1)+C(K3)*CQ(K1)*CQ(L2)+C(L3)*CQ(K2)*CQ(L1)
C
C     USE GAUSSIAN INTEGRATION TO FIND THE PARTITIONS OF
C     THE STIFFNESS MATRIX FOR THE MEAN PLANE ELEMENT
C
      U(NN) = 0.0
      DO 80 IA01 = 1,2
      DO 80 JA01 = 1,2
      U(NN) = U(NN) +
     1    O(D,V,F,H,P,Q,Y4A,X12,Y34,Y3A,X23,X14,ETA01(IA01),ETA01(JA01))
   80 CONTINUE
      U(NN) = U(NN)/4.0*THICK
C
C     ADD SHEAR TERMS HERE
      U(NN) = U(NN) + FACT*(AQ(K2)+0.5*(BQ(K2)+CQ(K2)))
     1                    *(AQ(L2)+0.5*(BQ(L2)+CQ(L2)))
   90 CONTINUE
  100 CONTINUE
  110 CONTINUE
  120 CONTINUE
C
C     TRANSFORM FROM MEAN PLANE TO ACTUAL GRID POINTS
C
C                   T
C      K = B * K * B
C
C     EXPAND MATRIX TO INCLUDE Z COORDINATES
C     IF NON-PLANAR,
C
      IF (PLANAR) GO TO 130
      CALL GMMATS (B(1),12,8,0, U(1),8,8,0, BTXK(1))
      CALL GMMATS (BTXK(1),12,8,0, B(1),12,8,1, TEMPAR(1))
      GO TO 200
C
C  *  IF PLANAR, TEMPAR(12X12) .EQ. U(8X8)
C
  130 IJ1 =-12
      I2  = 144
      DO 140 I = 1,64
  140 TEMPAR(I2+I) = U(I)
      DO 190 I = 1,12
      IJ1 = IJ1 + 12
      IF (MOD(I,3) .NE. 0) GO TO 160
      DO 150 J = 1,12
      IJ = IJ1 + J
  150 TEMPAR(IJ) = 0.0
      GO TO 190
  160 DO 180 J = 1,12
      IJ = IJ1 + J
      IF (MOD(J,3) .NE. 0) GO TO 170
      TEMPAR(IJ) = 0.0
      GO TO 180
  170 I2 = I2 + 1
      TEMPAR(IJ) = TEMPAR(I2)
  180 CONTINUE
  190 CONTINUE
C
C                T            T
C  *  GENERATE (T  * E) AND (E  * T )
C                I                 J
C
  200 DO 230 I = 1,4
      KA = 4*I + 6
      IF (NECPT(KA) .EQ. 0) GO TO 210
      CALL TRANSS (NECPT(KA),TI)
      CALL GMMATS (TI,3,3,1, E,3,3,0, TIE(1,I))
      CALL GMMATS (E,3,3,1, TI,3,3,0, ETJ(1,I))
      GO TO 230
  210 DO 220 II = 1,9
      TIE(II,I) = E(II)
  220 CONTINUE
      ETJ(1,I) = E(1)
      ETJ(2,I) = E(4)
      ETJ(3,I) = E(7)
      ETJ(4,I) = E(2)
      ETJ(5,I) = E(5)
      ETJ(6,I) = E(8)
      ETJ(7,I) = E(3)
      ETJ(8,I) = E(6)
      ETJ(9,I) = E(9)
  230 CONTINUE
C                                      T              T
C     COMPUTE STIFFNESS MATRIX  K   = T  * E * S   * E  * T
C                                IJ    I        IJ         J
C
C     EXTRACT 3 BY 3 PARTITIONS, TRANSFORM TO GLOBAL, AND INSERT BY
C     ORDER OF SILS INTO A 12 BY 12 MATRIX
C
      DO 260 I = 1,4
      J = NGRID(I)
      DO 240 K = 2,5
      IF (NECPT(K) .EQ. J) GO TO 250
  240 CONTINUE
      CALL MESAGE (-30,34,ECPT(1))
  250 MAP(1,I) = J
  260 MAP(2,I) = I
      CALL SORT (0,0,2,1,MAP(1,1),8)
C
C     REPLACE SILS WITH INDICES
C     RESORT FOR ORIGINAL ORDER - WORD 1 WILL CONTAIN NEW LOCATION
C
      DO 270 I = 1,4
  270 MAP(1,I) = I
      CALL SORT (0,0,2,2,MAP(1,1),8)
C
C     MOVE AND TRANSFORM HERE
C     ROW LOOP
C
      DO 300 I = 1,4
      IOR = 36*(I-1)
      INR = 36*(MAP(1,I) - 1)
C
C     COLUMN LOOP
C
      DO 300 J = 1,4
      IOCL = IOR + 3*(J-1)
      INCL = INR + 3*(MAP(1,J) - 1)
C
C     INNER LOOPS
C
      DO 280 K = 1,3
      KL = IOCL + 12*(K-1)
      DO 280 L = 1,3
      KIJ(L,K) = TEMPAR(KL+L)
  280 CONTINUE
C
C     TRANSFORM 3 BY 3
C
      CALL GMMATS (KIJ,3,3,0, ETJ(1,J),3,3,0, E)
      CALL GMMATS (TIE(1,I),3,3,0, E,3,3,0, KIJ)
C
C     INSERT
C
      DO 290 K = 1,3
      KL = INCL + 12*(K-1)
      DO 290 L = 1,3
      B(KL+L) = KIJ(L,K)
  290 CONTINUE
  300 CONTINUE
C
C     INSERT WHOLE 12 BY 12 USING EMGOUT
C
      DICT(1) = ESTID
      DICT(2) = 1
      DICT(3) = 12
      DICT(4) = 7
      DICT5   = GSUBE
      LDATA   = 144
      IEOE    = 1
      IFILE   = 1
      CALL EMGOUT (B,B,LDATA,IEOE,DICT,IFILE,IPREC)
C
C     DO MASS IF NECESSARY
C
      IF (MASS .EQ. 0) RETURN
      DO 350 I = 1,4
      KL = 3*(MAP(1,I) - 1)
      DO 350 J = 1,3
      B(KL+J) = MGG(I)
  350 CONTINUE
      DICT(2) = 2
      DICT(5) = 0
      LDATA   = 12
      IFILE   = 2
      CALL EMGOUT (B,B,LDATA,IEOE,DICT,IFILE,IPREC)
      RETURN
C
C     ERROR EXITS
C
  410 J = 32
      GO TO 440
  420 J = 31
      GO TO 440
  430 J = 26
  440 CALL MESAGE (30,J,ECPT(1))
      NOGO = .TRUE.
      RETURN
C
  450 WRITE  (OUTPT,460) UWM,NECPT(1)
  460 FORMAT (A25,' 3115, QDMM1S FINDS ELEMENT NO.',I9,' PRESENT IN A',
     1       ' HEAT FORMULATION AND IS IGNORING SAME.')
      RETURN
      END

      SUBROUTINE SSOLD2 (ITYPE,FTEMP)
C
C     PHASE TWO STRESS DATA RECOVERY FOR THE SOLID ELEMENTS
C
C     ITYPE = 1,2,3,OR4 CORRESPONDING TO THE TETRA,WEDGE,HEXA1,ORHEXA2
C             ELEMENTS
C
C     PHIOUT CONTAINS THE FOLLOWING WHERE N IS THE NUMBER OF CORNERS
C
C             ELEMENT ID
C             N SILS
C             T SUB 0
C             6 THERMAL STRESS COEFFICIENTS
C             N VOLUME RATIO COEFFICIENTS
C             N 6 BY 3 MATRICES RELATING STRESS TO DISPLACEMENTS
C
C  $MIXED_FORMATS
C
      INTEGER         NPHI(1),EJECT,ISHD(7),TYP(8),ISTYP(2)
      REAL            FTEMP(8),FRLAST(2)
      COMMON /SYSTEM/ IBFSZ,NOUT,IDM(9),LINE
      COMMON /ZZZZZZ/ Z(1)
      COMMON /SDR2X4/ DUMMY(35),IVEC,IVECN,LDTEMP,DEFORM
      COMMON /SDR2X7/ PHIOUT(100),STRES(100),FORVEC(25)
      COMMON /SDR2X8/ TEMP(6),FACTOR,NPTS,NPOINT,KS,KBETA,SIGMA(9),
     1                CTMP(6),CSIG(7)
      COMMON /SDR2X9/ NCHK,ISUB,ILD,FRTMEI(2),TWOTOP,FNCHK
      EQUIVALENCE     (NPHI(1),PHIOUT(1)),(ISHD(1),LSUB),
     1                (ISHD(2),LLD),(ISHD(6),FRLAST(1))
      DATA    TYP   / 4HTETR,1HA, 4HWEDG,1HE, 4HHEXA,1H1, 4HHEXA,1H2  /
      DATA    LLD   , LSUB,FRLAST / 2*-1, -1.0E30, -1.0E30  /
C
      GO TO (100,110,120,120), ITYPE
  100 NPTS = 4
      GO TO 130
  110 NPTS = 6
      GO TO 130
  120 NPTS = 8
C
C
  130 DO 140 I = 1,9
      CSIG(I)  = 0.0
  140 SIGMA(I) = 0.0
C
C     LOOP ON GRID POINTS, DISPLACEMENT EFFECTS
C
      DO 1000 N = 1,NPTS
      NPOINT = IVEC + NPHI(N+1) - 1
      KS =  18*N + 2*NPTS - 9
      CALL SMMATS (PHIOUT(KS),6,3,0, Z(NPOINT),3,1,0, TEMP,CTMP)
      DO 200 I = 1,6
      CSIG (I+1) =  CSIG(I+1) + CTMP(I)
  200 SIGMA(I+1) = SIGMA(I+1) + TEMP(I)
C
C     TEMPERATURE EFFECTS
C
      IF (LDTEMP .EQ. -1) GO TO 1000
      KBETA  = NPTS + N + 8
      FACTOR = (FTEMP(N) - PHIOUT(NPTS+2))*PHIOUT(KBETA)
C
      DO 300 I = 1,6
      KBETA = NPTS + I + 2
  300 SIGMA(I+1) = SIGMA(I+1) - PHIOUT(KBETA)*FACTOR
 1000 CONTINUE
      SIGMA(1) = PHIOUT(1)
      DO 1100 I = 1,7
 1100 STRES(I) = SIGMA(I)
C
C     OCTAHEDRAL STRESS AND HYDROSTATIC PRESSURE
C
      STRES(8) = SQRT(SIGMA(2)*(SIGMA(2) - SIGMA(3) - SIGMA(4))*2.0 +
     1           2.0*SIGMA(3)*(SIGMA(3) - SIGMA(4)) + 2.0* SIGMA(4)**2 +
     2           6.0*(SIGMA(5)**2 + SIGMA(6)**2 + SIGMA(7)**2))/3.0
      STRES(9) = -(SIGMA(2) + SIGMA(3) + SIGMA(4))/3.0
      IF (NCHK .LE. 0) GO TO 450
C
C   . CHECK PRECISION
C
      CSIG(1) = PHIOUT(1)
      K = 0
C
C   . STRESSES
C
      CALL SDRCHK (SIGMA(2),CSIG(2),6,K)
      IF (K .EQ. 0) GO TO 450
C
C   . LIMITS EXCEEDED
C
      J = 2*ITYPE
      ISTYP(1) = TYP(J-1)
      ISTYP(2) = TYP(J  )
      J = 0
C
      IF (LSUB.EQ.ISUB .AND. FRLAST(1).EQ.FRTMEI(1) .AND.
     1    LLD .EQ.ILD  .AND. FRLAST(2).EQ.FRTMEI(2)) GO TO 420
      LSUB = ISUB
      LLD  = ILD
      FRLAST(1) = FRTMEI(1)
      FRLAST(2) = FRTMEI(2)
      J = 2
      CALL PAGE1
  400 CALL SD2RHD (ISHD,J)
      LINE = LINE + 1
      WRITE  (NOUT,410)
  410 FORMAT (7X,4HTYPE,5X,3HEID,5X,2HSX,5X,2HSY,5X,2HSZ,4X,3HTYZ,4X,
     1        3HTXZ,4X,3HTXY)
      GO TO 430
  420 IF (EJECT(2) .NE. 0) GO TO 400
  430 WRITE  (NOUT,440,ERR=450) ISTYP,CSIG
  440 FORMAT (1H0,6X,A4,A1,I7,6F7.1)
C
  450 CONTINUE
      RETURN
      END

      SUBROUTINE ALGAR
C
      REAL LOSS,LAMI,LAMIP1,LAMIM1
C
      DIMENSION XX1(21),XX2(21),XX3(21),XX4(21),VMOLD(21),VMLOLD(21)
      DIMENSION DELTAR(59,30),PASS(59)
C
      COMMON /UD3PRT/ IPRTC
      COMMON /CONTRL/ NANAL,NAERO,NARBIT,LOQ1,LOQ2,LOQ3,LOQ4,LOQ5,LOQ6
      COMMON /UD300C/ NSTNS,NSTRMS,NMAX,NFORCE,NBL,NCASE,NSPLIT,NREAD,
     1NPUNCH,NPAGE,NSET1,NSET2,ISTAG,ICASE,IFAILO,IPASS,I,IVFAIL,IFFAIL,
     2NMIX,NTRANS,NPLOT,ILOSS,LNCT,ITUB,IMID,IFAIL,ITER,LOG1,LOG2,LOG3,
     3LOG4,LOG5,LOG6,IPRINT,NMANY,NSTPLT,NEQN,NSPEC(30),NWORK(30),
     4NLOSS(30),NDATA(30),NTERP(30),NMACH(30),NL1(30),NL2(30),NDIMEN(30)
     5,IS1(30),IS2(30),IS3(30),NEVAL(30),NDIFF(4),NDEL(30),NLITER(30),
     6NM(2),NRAD(2),NCURVE(30),NWHICH(30),NOUT1(30),NOUT2(30),NOUT3(30),
     7NBLADE(30),DM(11,5,2),WFRAC(11,5,2),R(21,30),XL(21,30),X(21,30),
     8H(21,30),S(21,30),VM(21,30),VW(21,30),TBETA(21,30),DIFF(15,4),
     9FDHUB(15,4),FDMID(15,4),FDTIP(15,4),TERAD(5,2),DATAC(100),
     1DATA1(100),DATA2(100),DATA3(100),DATA4(100),DATA5(100),DATA6(100),
     2DATA7(100),DATA8(100),DATA9(100),FLOW(10),SPEED(30),SPDFAC(10),
     3BBLOCK(30),BDIST(30),WBLOCK(30),WWBL(30),XSTN(150),RSTN(150),
     4DELF(30),DELC(100),DELTA(100),TITLE(18),DRDM2(30),RIM1(30),
     5XIM1(30),WORK(21),LOSS(21),TANEPS(21),XI(21),VV(21),DELW(21),
     6LAMI(21),LAMIM1(21),LAMIP1(21),PHI(21),CR(21),GAMA(21),SPPG(21),
     7CPPG(21),HKEEP(21),SKEEP(21),VWKEEP(21),DELH(30),DELT(30),VISK,
     8SHAPE,SCLFAC,EJ,G,TOLNCE,XSCALE,PSCALE,PLOW,RLOW,XMMAX,RCONST,
     9FM2,HMIN,C1,PI,CONTR,CONMX
C
      IF = 0
      LOG1=LOQ1
      LOG2=LOQ2
      LOG3=LOQ3
      LOG5=LOQ5
      LOG6=LOQ6
      IF (IPRTC .EQ. 1) WRITE(LOG2,1)
1     FORMAT(1HT)
      PI=3.141592653589
      C1=180.0/PI
      HMIN=50.0
      VMIN = 25.0
      IF (IPRTC .EQ. 1) WRITE(LOG2,50)
50    FORMAT(1H1,37X, 53HPROGRAM ALG - COMPRESSOR DESIGN - AERODYNAMIC S
     1ECTION,/,38X,53(1H*))
      LNCT=2
      CALL ALG02
      ICASE=1
  100 IF (IPRTC .EQ. 1) WRITE(LOG2,104) ICASE
104   FORMAT(1H1,9X,20HOUTPUT FOR POINT NO.,I2,/,10X,22(1H*))
      LNCT=2
      DO 106 I=1,30
      DO 106 J=1,59
106   DELTAR(J,I)=0.0
      IF((ICASE.EQ.1.AND.NREAD.EQ.1).OR.(ICASE.GT.1.AND.IFAILK.EQ.0))GO
     1TO 254
      IF(NSPLIT.EQ.1)GO TO 170
      L1=NSPEC(1)
      XX1(1)=0.0
      DO 110 K=2,L1
110   XX1(K)=XX1(K-1)+SQRT((RSTN(K)-RSTN(K-1))**2+(XSTN(K)-XSTN(K-1))**2
     1)
      X1=1.0/XX1(L1)
      DO 120 K=2,L1
120   XX1(K)=XX1(K)*X1
      DO 130 K=1,11
130   XX2(K)=FLOAT(K-1)*0.1
      CALL ALG01(XX1,XSTN,L1,XX2,XX3,X1,11,0,0)
      CALL ALG01(XX1,RSTN,L1,XX2,XX4,X1,11,0,0)
      DO 136 K=2,11
      XX1(K)=XX1(K-1)+SQRT((XX3(K)-XX3(K-1))**2+(XX4(K)-XX4(K-1))**2)
136   XX3(K-1)=(XX1(K)+XX1(K-1))*0.5
      L2=IS1(2)
      XX2(1)=ATAN2(RSTN(L2)-RSTN(1),XSTN(L2)-XSTN(1))
      L2=L2+NSPEC(2)-1
      XX2(2)=ATAN2(RSTN(L2)-RSTN(L1),XSTN(L2)-XSTN(L1))
      XI(1)=0.0
      XI(2)=XX1(11)
      CALL ALG01(XI,XX2,2,XX3,PHI,X1,10,1,0)
      CALL ALG01(RSTN,XSTN,L1,XX3,X1,GAMA,10,0,1)
      XX3(1)=0.0
      DO 140 K=2,11
140   XX3(K)=XX3(K-1)+COS(PHI(K-1)+ATAN(GAMA(K-1)))*(XX4(K)+XX4(K-1))*(X
     1X1(K)-XX1(K-1))
      X1=1.0/XX3(11)
      X2=1.0/XX1(11)
      DO 150 K=2,11
      XX1(K)=XX1(K)*X2
150   XX3(K)=XX3(K)*X1
      X1=1.0/FLOAT(ITUB)
      DO 160 K=1,NSTRMS
160   XX2(K)=FLOAT(K-1)*X1
      CALL ALG01(XX1,XX3,11,XX2,DELF,X1,NSTRMS,1,0)
170   DO 250 I=1,NSTNS
      L1=IS1(I)
      L2=NSPEC(I)
      XX1(1)=0.0
      VV(1)=0.0
      DO 180 K=2,L2
      L3=L1+K-1
180   VV(K)=VV(K-1)+SQRT((RSTN(L3)-RSTN(L3-1))**2+(XSTN(L3)-XSTN(L3-1))*
     1*2)
      X1=1.0/VV(L2)
      DO 190 K=2,L2
190   XX1(K)=VV(K)*X1
      DO 200 K=1,11
200   XX2(K)=FLOAT(K-1)*0.1
      CALL ALG01(XX1,XSTN(L1),L2,XX2,XX3,X1,11,0,0)
      CALL ALG01(XX1,RSTN(L1),L2,XX2,XX4,X1,11,0,0)
      DO 230 K=2,11
      XX1(K)=XX1(K-1)+SQRT((XX3(K)-XX3(K-1))**2+(XX4(K)-XX4(K-1))**2)
      GAMA(K-1)=(XX4(K)+XX4(K-1))*0.5
230   XX3(K-1)=(XX1(K)+XX1(K-1))*0.5
      IF(I.EQ.1.OR.I.EQ.NSTNS)GO TO 234
      L3=IS1(I+1)
      L4=IS1(I-1)
      L5=L1
      XX2(1)=(ATAN2(RSTN(L3)-RSTN(L5),XSTN(L3)-XSTN(L5))+ATAN2(RSTN(L5)-
     1RSTN(L4),XSTN(L5)-XSTN(L4)))*0.5
      L3=L3+NSPEC(I+1)-1
      L4=L4+NSPEC(I-1)-1
      L5=L5+L2-1
      XX2(2)=(ATAN2(RSTN(L3)-RSTN(L5),XSTN(L3)-XSTN(L5))+ATAN2(RSTN(L5)-
     1RSTN(L4),XSTN(L5)-XSTN(L4)))*0.5
      GO TO 238
234   IF(I.EQ.NSTNS)GO TO 236
      L3=IS1(2)
      XX2(1)=ATAN2(RSTN(L3)-RSTN(1),XSTN(L3)-XSTN(1))
      L4=NSPEC(1)
      L3=L3+NSPEC(2)-1
      XX2(2)=ATAN2(RSTN(L3)-RSTN(L4),XSTN(L3)-XSTN(L4))
      GO TO 238
236   L4=IS1(I-1)
      XX2(1)=ATAN2(RSTN(L1)-RSTN(L4),XSTN(L1)-XSTN(L4))
      L4=L4+NSPEC(I-1)-1
      L3=L1+L2-1
      XX2(2)=ATAN2(RSTN(L3)-RSTN(L4),XSTN(L3)-XSTN(L4))
238   XI(1)=0.0
      XI(2)=XX1(11)
      CALL ALG01(XI,XX2,2,XX3,PHI,X1,10,1,0)
      CALL ALG01(RSTN(L1),XSTN(L1),L2,GAMA,X1,GAMA,10,0,1)
      XX3(1)=0.0
      DO 240 K=2,11
240   XX3(K)=XX3(K-1)+COS(PHI(K-1)+ATAN(GAMA(K-1)))*(XX4(K)+XX4(K-1))*(X
     1X1(K)-XX1(K-1))
      X1=1.0/XX3(11)
      DO 244 K=2,11
244   XX3(K)=XX3(K)*X1
      CALL ALG01(XX3,XX1,11,DELF,XL(1,I),X1,NSTRMS,1,0)
      X1=VV(L2)/XX1(11)
      DO 246 J=2,NSTRMS
246   XL(J,I)=XL(J,I)*X1
      CALL ALG01(VV,XSTN(L1),L2,XL(1,I),X(1,I),X1,NSTRMS,0,0)
250   CALL ALG01(VV,RSTN(L1),L2,XL(1,I),R(1,I),X1,NSTRMS,0,0)
254   IF(ICASE.GT.1)GO TO 270
      X1=(X(IMID,2)-X(IMID,1))**2+(R(IMID,2)-R(IMID,1))**2
      DRDM2(1)=((R(NSTRMS,1)-R(1,1))**2+(X(NSTRMS,1)-X(1,1))**2)/X1
      L1=NSTNS-1
      DO 260 I=2,L1
      X2=(X(IMID,I+1)-X(IMID,I))**2+(R(IMID,I+1)-R(IMID,I))**2
      X3=X2
      IF(X1.LT.X3)X3=X1
      DRDM2(I)=((R(NSTRMS,I)-R(1,I))**2+(X(NSTRMS,I)-X(1,I))**2)/X3
260   X1=X2
      DRDM2(NSTNS)=((R(NSTRMS,NSTNS)-R(1,NSTNS))**2+(X(NSTRMS,NSTNS)-X(1
     1,NSTNS))**2)/X2
270   DO 280 I=1,NSTNS
280   WWBL(I)=WBLOCK(I)
      IPASS=1
290   I=1
      IF((IPASS.GT.1.OR.ICASE.GT.1).AND.NDATA(1).EQ.1)GO TO 400
      L1=NDIMEN(1)+1
      GO TO(300,320,340,360),L1
300   DO 310 J=1,NSTRMS
310   XX1(J)=R(J,1)
      GO TO 380
320   DO 330 J=1,NSTRMS
330   XX1(J)=R(J,1)/R(NSTRMS,1)
      GO TO 380
340   DO 350 J=1,NSTRMS
350   XX1(J)=XL(J,1)
      GO TO 380
360   DO 370 J=1,NSTRMS
370   XX1(J)=XL(J,1)/XL(NSTRMS,1)
380   L1=NTERP(1)
      L2=NDATA(1)
      CALL ALG01(DATAC,DATA1,L2,XX1,S    ,X1,NSTRMS,L1,0)
      CALL ALG01(DATAC,DATA2,L2,XX1,H    ,X1,NSTRMS,L1,0)
      CALL ALG01(DATAC,DATA3,L2,XX1,TBETA,X1,NSTRMS,L1,0)
      DO 390 J=1,NSTRMS
      H(J,1)=ALG6(S(J,1),H(J,1))
      S(J,1)=ALG3(S(J,1),H(J,1))
390   TBETA(J,1)=TAN(TBETA(J,1)/C1)
400   IF(IPASS.GT.1.OR.ICASE.GT.1)GO TO 420
      X1=FLOW(1)/(ALG5(H,S)*PI*(R(NSTRMS,1)+R(1,1))*XL(NSTRMS,1))*SCLFAC
     1**2
      DO 410 J=1,NSTRMS
410   VM(J,1)=X1
      IF(ISTAG.EQ.1)VM(1,1)=0.0
420   IFAILO=0
      IFFAIL=0
      IVFAIL=0
      DO 430 J=1,NSTRMS
430   VMOLD(J)=VM(J,1)
      GO TO 500
440   IF(IPASS.GT.1)GO TO 460
      DO 450 J=1,NSTRMS
450   VM(J,I)=VM(J,I-1)
      IF(I-1.EQ.ISTAG)VM(1,I)=VM(2,I)
      IF(I.EQ.ISTAG)VM(1,I)=0.0
460   ILOSS=1
      DO 464 J=1,NSTRMS
464   VMOLD(J)=VM(J,I)
470   DO 474 J=1,NSTRMS
      VWKEEP(J)=VW(J,I-1)
      SKEEP(J)=S(J,I-1)
474   HKEEP(J)=H(J,I-1)
      X1=H(IMID,I-1)-(VM(IMID,I-1)**2+VW(IMID,I-1)**2)/(2.0*G*EJ)
      IF(X1.LT.HMIN)X1=HMIN
      PSMID=ALG4(X1,S(IMID,I-1))
      IF(NMIX.EQ.1)CALL ALG04(H(1,I-1),S(1,I-1),VW(1,I-1),R(1,I-1),R(1,
     1I),X(1,I-1),X(1,I),VM(1,I-1),CONMX,SCLFAC,G,EJ,HMIN,VMIN,PSMID,NST
     2RMS,LOG2,LNCT,IF)
      IF(IF.EQ.0)GO TO 478
      IFAILO=I-1
      GO TO 640
478   IF(NWORK(I).EQ.0)GO TO 480
      CALL ALG05
      IF(NTRANS.EQ.1.AND.IPASS.GT.1)CALL ALG06(R(1,I-1),R(1,I),X(1,I-1)
     1,X(1,I),H(1,I),S(1,I),VM(1,I),TBETA(1,I-1),TBETA(1,I),LOSS,CONTR,S
     2CLFAC,SPEED(I),SPDFAC(ICASE),G,EJ,HMIN,NSTRMS,PI)
      ITER=0
      CALL ALG07
      GO TO 500
480   DO 490 J=1,NSTRMS
      H(J,I)=H(J,I-1)
      S(J,I)=S(J,I-1)
      VW(J,I)=0.0
      IF(I.GT.ISTAG.OR.J.NE.1)VW(J,I)=VW(J,I-1)*RIM1(J)/R(J,I)
490   CONTINUE
500   DO 510 J=1,NSTRMS
510   VMLOLD(J)=VM(J,I)
      IF(NEQN.GE.2)GO TO 514
      CALL ALG08
      GO TO 516
  514 CALL ALG26
516   IF(NEVAL(I).LE.0)GO TO 590
      IPRINT=0
      CALL ALG09
      IF(IFAILO.NE.0.AND.IPASS.GT.NFORCE)GO TO 550
      DO 520 J=1,NSTRMS
      IF(ABS(VM(J,I)/VMLOLD(J)-1.0).GT.TOLNCE/5.0)GO TO 530
520   CONTINUE
      GO TO 590
530   IF(ILOSS.GE.NLITER(I))GO TO 550
      ILOSS=ILOSS+1
      DO 540 J=1,NSTRMS
540   VMLOLD(J)=VM(J,I)
      GO TO 470
550   IF(IPASS.LE.NFORCE)GO TO 590
      IF(LNCT+1.LE.NPAGE)GO TO 570
      IF (IPRTC .EQ. 1) WRITE(LOG2,560)
560   FORMAT(1H1)
      LNCT=1
570   LNCT=LNCT+1
      X1=VM(1,I)/VMLOLD(1)
      X2=VM(IMID,I)/VMLOLD(IMID)
      X3=VM(NSTRMS,I)/VMLOLD(NSTRMS)
      IF (IPRTC .EQ. 1) WRITE(LOG2,580) IPASS,I,X1,X2,X3
580   FORMAT(5X,4HPASS,I3,9H  STATION,I3,66H  VM PROFILE NOT CONVERGED W
     1ITH LOSS RECALC   VM NEW/VM PREV  HUB=,F9.6,6H  MID=,F9.6,7H  CASE
     2=,F9.6)
590   IF(NBL.EQ.1.AND.(IFAILO.EQ.0.OR.IPASS.LE.NFORCE))CALL ALG10
      DO 600 J=1,NSTRMS
      XIM1(J)=X(J,I)
      RIM1(J)=R(J,I)
      IF(I.EQ.ISTAG.AND.J.EQ.1)GO TO 600
      IF(ABS(VM(J,I)/VMOLD(J)-1.0).GT.TOLNCE)IVFAIL=IVFAIL+1
      IF(ABS(DELW(J)-DELF(J)).GT.TOLNCE)IFFAIL=IFFAIL+1
600   CONTINUE
      IF(NMAX.EQ.1.OR.(IPASS.EQ.1.AND.NREAD.EQ.1))GO TO 624
      X1=FM2
      IF(X1.LT.1.0-XMMAX)X1=1.0-XMMAX
      X2=1.0
      IF(I.EQ.1.OR.NWORK(I).GE.5)X2=1.0+TBETA(IMID,I)**2
      X1=1.0/(1.0+X1*DRDM2(I)/(RCONST*X2))
      L3=NSTRMS-2
      CALL ALG01(DELW,XL(1,I),NSTRMS,DELF(2),XX1(2),X1,L3,1,0)
      XX=XL(IMID,I)
      DO 610 J=2,ITUB
610   XL(J,I)=XL(J,I)+X1*(XX1(J)-XL(J,I))
      L1=IPASS
      IF(L1.LE.59)GO TO 618
      L1=59
      DO 616 K=1,58
616   DELTAR(K,I)=DELTAR(K+1,I)
618   DELTAR(L1,I)=XL(IMID,I)-XX
      L1=IS1(I)
      L2=NSPEC(I)
      XX1(1)=0.0
      DO 620 K=2,L2
      KK=L1-1+K
620   XX1(K)=XX1(K-1)+SQRT((XSTN(KK)-XSTN(KK-1))**2+(RSTN(KK)-RSTN(KK-1)
     1)**2)
      CALL ALG01(XX1,RSTN(L1),L2,XL(2,I),R(2,I),X1,L3,0,0)
      CALL ALG01(XX1,XSTN(L1),L2,XL(2,I),X(2,I),X1,L3,0,0)
624   IF(IPASS.GT.NFORCE.AND.IFAILO.NE.0)GO TO 640
      IF(I.EQ.NSTNS)GO TO 630
      I=I+1
      GO TO 440
630   IF(IPASS.GE.NMAX)GO TO 640
      IF(IFAILO.NE.0)GO TO 635
      IF(IVFAIL.EQ.0.AND.IFFAIL.EQ.0)GO TO 640
635   IPASS=IPASS+1
      GO TO 290
640   CALL ALG11
      L1=NSTNS
      IF(IFAILO.NE.0)L1=IFAILO
      IPRINT=1
      DO 650 I=2,L1
      IF(NEVAL(I).NE.0)CALL ALG09
650   CONTINUE
      IF(NPLOT.NE.0)CALL ALG12
      IF(IFAILO.NE.0)GO TO 750
      IF(NPUNCH.EQ.0)GO TO 680
      WRITE(LOG3,660)(DELF(J),J=1,NSTRMS)
660   FORMAT(6F12.8)
      WRITE(LOG3,670)((R(J,I),X(J,I),XL(J,I),I,J,J=1,NSTRMS),I=1,NSTNS)
670   FORMAT(3F12.8,2I3)
680   DO 700 I=1,NSTNS
      IF(NOUT1(I).EQ.0)GO TO 700
      WRITE(LOG3,690)(R(J,I),J,I,J=1,NSTRMS)
690   FORMAT(F12.8,60X,2I4)
700   CONTINUE
      L1=LOG3
      IF(NARBIT.NE.0)L1=LOG6
      DO 740 I=1,NSTNS
      IF(NOUT2(I).EQ.0)GO TO 740
      L2=IS1(I)
      L3=L2+NSPEC(I)-1
      WRITE(L1,710)NSPEC(I),(XSTN(K),RSTN(K),K=L2,L3)
710   FORMAT(I3,/,(2F12.7))
      XN=SPEED(I)
      IF(I.EQ.NSTNS)GO TO 714
      IF(SPEED(I).NE.SPEED(I+1).AND.NWORK(I+1).NE.0)XN=SPEED(I+1)
714   XN=XN*SPDFAC(ICASE)*PI/(30.0*SCLFAC)
      DO 720 J=1,NSTRMS
720   XX1(J)=ATAN((VW(J,I)-XN*R(J,I))/VM(J,I))*C1
      WRITE(L1,730)(R(J,I),XX1(J),J,I,J=1,NSTRMS)
730   FORMAT(2F12.8,48X,2I4)
740   CONTINUE
750   IF(NSTPLT.EQ.0)GO TO 759
      L1=IPASS
      IF(L1.GT.59)L1=59
      DO 754 K=1,L1
754   PASS(K)=FLOAT(K)
      DO 758 K=1,NSTNS
      IF (IPRTC .EQ. 1) WRITE(LOG2,756) K
756   FORMAT(1H1,53X,19HDELTA L FOR STATION,I3,/,2X)
758   CALL ALG25(L1,IPASS,LOG2,PASS,DELTAR(1,K))
759   IF(ICASE.GE.NCASE)GO TO 760
      ICASE=ICASE+1
      IFAILK=IFAILO
      GO TO 100
  760 IF (IPRTC .EQ. 1) WRITE(LOG2,770)
770   FORMAT(1HS)
      RETURN
      END

      SUBROUTINE XSFADD
C
CXSFABD
C
C     REVISED  8/89 BY G.C./UNISYS
C          1.  THE ORDER OF COMM AND XFIAT IN /XSFA1/ ARE REVERSED IN
C              THIS ROUTINE AND IN THE FOLLOWING 7 SUBROUTINES -
C              XCLEAN, XDPH, XPOLCK, XPUNP, XPURGE, XSFA AND XSOSGN.
C              ANY INCREASE IN SIZE OF XFIAT CAN THEREFORE BE MADE
C              EASILY THROUGH OUT THESE GROUP OF ROUTINES BY JUST
C              CHANGING THE XFIAT DIMENSION HERE.
C          2.  IN THIS GROUP OF ROUTINES, THE ARRAY XFIAT IN /XSFA1/ IS
C              RENAMED TO XFIAT, NOT TO BE CONFUSED WITH THE XFIAT ARRAY
C              IN /XFIAT/
C          3.  ENTN1 MUST EQUAL ICFIAT, THE 24TH WORD OF /SYSTEM/
C              HOWEVER, XSFA AND XPURGE ROUTINES INITIALIZE ENTN1 AGAIN
C              TO ICFIAT, JUST TO BE SURE.
C          4.  THE DIMENSION OF XFIAT SHOULD BE 800 WHEN ENTN1 = 8, OR
C              1100 WHEN ENTN1 IS 11
C
      INTEGER         ALMSK,APNDMK,COMM,CURSNO,ENTN1,ENTN2,ENTN3,
     1                ENTN4,FLAG,FNX,RMSK,RXMSK,S,SCORNT,SOS,TAPMSK,
     2                THCRMK,XFIAT,ZAP
CWKBR COMMON /XSFA1 / MF(401),SOS(1501),COMM(20),XFIAT(1100)
      COMMON /XSFA1 / MF(401),SOS(1501),COMM(20),XFIAT(1320)
      EQUIVALENCE            (COMM (1),ALMSK ),(COMM (2),APNDMK),
     1     (COMM (3),CURSNO),(COMM (4),ENTN1 ),(COMM (5),ENTN2 ),
     2     (COMM (6),ENTN3 ),(COMM (7),ENTN4 ),(COMM (8),FLAG  ),
     3     (COMM (9),FNX   ),(COMM(10),LMSK  ),(COMM(11),LXMSK ),
     4     (COMM(12),MACSFT),(COMM(13),RMSK  ),(COMM(14),RXMSK ),
     5     (COMM(15),S     ),(COMM(16),SCORNT),(COMM(17),TAPMSK),
     6     (COMM(18),THCRMK),(COMM(19),ZAP   )
      ENTN1 = 11
      ENTN2 = 3
      ENTN3 = 4
      ENTN4 = 3
      FLAG  = 0
      DO 10 I = 1, 1320
   10 XFIAT(I) = 0
      TAPMSK = 32768
C            TAPMSK = O 000000100000  = Z 00008000
      APNDMK = 1073741824
C            APNDMK = O 010000000000  = Z 40000000
      RMSK   = 32767
C            RMSK   = O 000000077777  = Z 00007FFF
      RXMSK  = 65535
C            RXMSK  = O 000000177777  = Z 0000FFFF
      LMSK   = 1073676288
C            LMSK   = O 007777600000  = Z 3FFF0000
      LXMSK  = 2147418112
C            LXMSK  = O 017777600000  = Z 7FFF0000
      SCORNT = 1073708992
C            SCORNT = O 007777677700  = Z 3FFF7FC0
      ZAP    = 32767
C            ZAP    = O 000000077777  = Z 00007FFF
      END

      SUBROUTINE DSHEAR
C
C     THIS COMPUTES THE THE TWO 6X6 DIFFERENTIAL STIFFNESS MATRICES
C     K(NPVT,NPVT) AND K(NPVT,J) WHERE J = 3,4,1,2 IF NPVT = 1,2,3,4
C     RESPECTIVELY.
C
C     ECPT FOR BOTH PANELS
C
C     ECPT( 1)  -  IELID          ELEMENT ID. NO.
C     ECPT( 2)  -  ISILNO(4)      SCALAR INDEX NUMBERS
C     ECPT( 3)  -   ...                   ...
C     ECPT( 4)  -   ...                   ...
C     ECPT( 5)  -   ...                   ...
C     ECPT( 6)  -  MATID          MATERIAL ID.
C     ECPT( 7)  -  T              THICKNESS
C     ECPT( 8)  -  FMU            NON-STRUCTURAL MASS
C     ECPT( 9)  -  ICSID1         COOR. SYS. ID. FOR GRID POINT 1
C     ECPT(10)  -  GP1(3)         BASIC COORDINATES FOR GRID POINT 1
C     ECPT(11)  -   ...                      ...
C     ECPT(12)  -   ...                      ...
C     ECPT(13)  -  ICSID2         COOR. SYS. ID. FOR GRID POINT 2
C     ECPT(14)  -  GP2(3)         BASIC COORDINATES FOR GRID POINT 2
C     ECPT(15)  -   ...                      ...
C     ECPT(16)  -   ...                      ...
C     ECPT(17)  -  ICSID3         COOR. SYS. ID. FOR GRID POINT 3
C     ECPT(18)  -  GP3(3)         BASIC COORDINATES FOR GRID POINT 3
C     ECPT(19)  -   ...                      ...
C     ECPT(20)  -   ...                      ...
C     ECPT(21)  -  ICSID4         COOR. SYS. ID. FOR GRID POINT 4
C     ECPT(22)  -  GP4(3)         BASIC COORDINATES FOR GRID POINT 4
C     ECPT(23)  -   ...                      ...
C     ECPT(24)  -   ...                      ...
C     ECPT(25)  -  TEMPEL         ELEMENT TEMPERATURE
C     ECPT(26)  -  DEFORM         ELEMENT DEFORMATION (NOT USED)
C     ECPT(27)  -  AVGLTP         AVG.ELEM LOADING TEMPERATURE, NOT USED
C     ECPT(28)  -  U1(3)          TRANSLATION DISPLACEMENTS AT PT. 1
C     ECPT(29)  -  ...                         ...
C     ECPT(30)  -  ...                         ...
C     ECPT(31)  -  U2(3)          TRANSLATION DISPLACEMENTS AT PT. 2
C     ECPT(32)  -  ...                         ...
C     ECPT(33)  -  ...                         ...
C     ECPT(34)  -  U3(3)          TRANSLATION DISPLACEMENTS AT PT. 3
C     ECPT(35)  -  ...                         ...
C     ECPT(36)  -  ...                         ...
C     ECPT(37)  -  U4(3)          TRANSLATION DISPLACEMENTS AT PT. 4
C     ECPT(38)  -  ...                         ...
C     ECPT(39)  -  ...                         ...
C
      REAL             NUSP
      DOUBLE PRECISION KE(36),TI(9),VLEFT(6),VD1,VD2,VKN,VK,V12,V41,
     1                 VP12,VI,VJ,AVEC,SMALLU,SMALLV,P,X1,X2,X3,X4,
     2                 Y1,Y2,Y3,Y4,VKL,PA,V12DK,CEP1,CEP2,EP,TEMP
      DOUBLE PRECISION YP,XP,SA,XQ,B,XL,A,A2,A3,A4,A5,B2,B3,B4,B5,C,C2,
     1                 C3,C4,C5,D,D2,D3,D4,D5,TERM1,TERM2,TERM3,TERM4,
     2                 TERM5,XL13,XL24
      DOUBLE PRECISION VP12L,VJL,Z,TERM,F,E,G,NU,T,C23,NUC
      DOUBLE PRECISION UI(3),DPTERM,SUM,F13,F24,FXX,JJ(3),J3X3(9),
     1                 K3X3(9)
      DIMENSION        VD1(3),VD2(3),VKN(3),VK(3),V12(3),V41(3),VP12(3),
     1                 VI(3),VJ(3),AVEC(4),SMALLU(4),SMALLV(4),P(4),
     2                 IECPT(100),ECPT(100),IZ(1)
      COMMON /ZZZZZZ/  ZZ(1)
      COMMON /DS1AAA/  NPVT,ICSTM,NCSTM,DUMCL(32),NOGO
      COMMON /DS1AET/  IELID,ISILNO(4),MATID,TSP,FMU,ICSID1,GP1(3),
     1                 ICSID2,GP2(3),ICSID3,GP3(3),ICSID4,GP4(3),TEMPEL,
     2                 DEFORM,AVGLTP,U1(3),U2(3),U3(3),U4(4)
      COMMON /DS1ADP/  KE,TI,VLEFT,VD1,VD2,VKN,VK,V12,V41,VP12,VI,VJ,
     1                 AVEC,SMALLU,SMALLV,P,X1,X2,X3,X4,Y1,Y2,Y3,Y4,
     2                 VKL,PA,V12DK,CEP1,CEP2,EP,TEMP
      COMMON /DS1ADP/  YP,XP,SA,XQ,B,XL,A,A2,A3,A4,A5,B2,B3,B4,B5,C,C2,
     1                 C3,C4,C5,D,D2,D3,D4,D5,TERM1,TERM2,TERM3,TERM4,
     2                 TERM5,XL13,XL24
      COMMON /DS1ADP/  VP12L,VJL,Z,TERM,F,E,G,NU,T,C23,NUC
      COMMON /DS1ADP/  UI,DPTERM,SUM,F13,F24,FXX,JJ,J3X3,K3X3
      COMMON /MATIN /  MATIDC,MATFLG,ELTEMP,STRESS,SINTH,COSTH
      COMMON /MATOUT/  ESP,GSP,NUSP,RHO,ALPHA,TSUBO,GSUBE,SIGT,SIGC,SIGS
      EQUIVALENCE      (IZ(1),ZZ(1)),(IELID,IECPT(1),ECPT(1))
     1
C
C     CALL MAT TO GET MATERIAL PROPERTIES.
C
      MATIDC = MATID
      MATFLG = 1
      ELTEMP = TEMPEL
      CALL MAT (IECPT(1))
C
C     STORE ECPT AND MPT VARIABLES IN DOUBLE PRECISION LOCATIONS
C
      E    = ESP
      G    = GSP
      NU   = NUSP
      T    = TSP
      C23  = 2.0D0/3.0D0
      NUC  = 1.0D0/(1.0D0+NU)
C
C     COMPUTE DIAGONAL VECTORS.
C
      DO 10 I = 1,3
      VD1(I) = GP3(I) - GP1(I)
   10 VD2(I) = GP4(I) - GP2(I)
C
C     COMPUTE THE NORMAL VECTOR VKN, NORMALIZE, AND COMPUTE THE
C     PROJECTED AREA, PA
C
      VKN(1) = VD1(2)*VD2(3) - VD1(3)*VD2(2)
      VKN(2) = VD1(3)*VD2(1) - VD1(1)*VD2(3)
      VKN(3) = VD1(1)*VD2(2) - VD1(2)*VD2(1)
      VKL    = DSQRT(VKN(1)**2 + VKN(2)**2 + VKN(3)**2)
      IF (VKL .EQ. 0.0D0) GO TO 1010
      VK(1)  = VKN(1)/VKL
      VK(2)  = VKN(2)/VKL
      VK(3)  = VKN(3)/VKL
      PA     = .5D0*VKL
C
C     COMPUTE  SIDES -12- AND -41-
C
      DO 12 I = 1,3
      V12(I) = GP2(I) - GP1(I)
   12 V41(I) = GP1(I) - GP4(I)
C
C     COMPUTE DOT PRODUCT, V12DK, OF V12 AND VK, THE VECTORS VP12,VI,VJ
C
      V12DK   = V12(1)*VK(1) + V12(2)*VK(2) + V12(3)*VK(3)
      VP12(1) = V12(1) - V12DK*VK(1)
      VP12(2) = V12(2) - V12DK*VK(2)
      VP12(3) = V12(3) - V12DK*VK(3)
      VP12L   = DSQRT(VP12(1)**2 + VP12(2)**2 + VP12(3)**2)
      IF (VP12L .EQ. 0.0D0) GO TO 1020
      VI(1)   = VP12(1)/VP12L
      VI(2)   = VP12(2)/VP12L
      VI(3)   = VP12(3)/VP12L
      VJ(1)   = VK(2)*VI(3) - VK(3)*VI(2)
      VJ(2)   = VK(3)*VI(1) - VK(1)*VI(3)
      VJ(3)   = VK(1)*VI(2) - VK(2)*VI(1)
C
C     NORMALIZE J FOR GOOD MEASURE
C
      VJL   = DSQRT(VJ(1)**2 + VJ(2)**2 + VJ(3)**2)
      IF (VJL .EQ. 0.0D0) GO TO 1030
      VJ(1) = VJ(1)/VJL
      VJ(2) = VJ(2)/VJL
      VJ(3) = VJ(3)/VJL
      X1    = 0.0D0
      Y1    = 0.0D0
      X2    = VP12L
      Y2    = 0.0D0
      X3    = VI(1)*VD1(1) + VI(2)*VD1(2) + VI(3)*VD1(3)
      Y3    = VJ(1)*VD1(1) + VJ(2)*VD1(2) + VJ(3)*VD1(3)
      X4    =-VI(1)*V41(1) - VI(2)*V41(2) - VI(3)*V41(3)
      Y4    =-VJ(1)*V41(1) - VJ(2)*V41(2) - VJ(3)*V41(3)
C
C     CHECK TO SEE IF INTERIOR ANGLES ARE LESS THAN 180 DEGREES.
C     IF NOT, CALL FATAL ERROR MESSAGE.
C
      IF (Y3 .LE.    0.0D0) GO TO 1040
      IF (X3 .LE. Y3*X4/Y4) GO TO 1050
      IF (Y4 .LE.    0.0D0) GO TO 1060
      IF (X4 .GE. X2-(X2-X3)*Y4/Y3) GO TO 1070
C
C     TEST FOR PARALLEL EFFECTS.
C
      CEP1 = DABS((Y3-Y4)/(X3-X4))
      TEMP = X3 - X2
      CEP2 = DABS((Y4*TEMP-Y3*X4)/(X4*TEMP+Y4*Y3))
      EP   = 1.0D-1
      IF (CEP1 .LT. EP) GO TO 15
      IF (CEP2 .LT. EP) GO TO 30
      GO TO 50
   15 IF (CEP2 .LT. EP) GO TO 40
C
C     AT THIS POINT THE LINE CONNECTING POINTS 3 AND 4 IS -PARALLEL- TO
C     THE LINE CONNECTING POINTS 1 AND 2.
C
      TEMP = Y3*X4 - Y4*(X3-X2)
      YP   = X2*Y3*Y4/TEMP
      P(1) = YP - Y1
      P(2) = YP - Y2
      P(3) = YP - Y3
      P(4) = YP - Y4
      XP   = X2*Y3*X4/TEMP
      SA   = (X2 - XP)/YP
      C    = (X1 - XP)/YP
      Z    = ((P(1)*P(2)*PA)/(P(3)*P(4)*2.0D0*G*T))*
     1       (1.0D0 + C23*NUC*(SA**2 + SA*C + C**2))
      GO TO 60
C
C     AT THIS POINT THE LINE CONNECTING POINTS 1 AND 4 IS -PARALLEL- TO
C     THE LINE CONNECTING POINTS 2 AND 3.
C
   30 D    = -.5D0*(X4/Y4 + (X3-X2)/Y3)
      XQ   = X4 - Y4*(X3-X4)/(Y3-Y4)
      TEMP = 1.0D0/DSQRT(1.0D0 + D**2)
      P(1) = (XQ - X1 - D*Y1)*TEMP
      P(2) = (XQ - X2 - D*Y2)*TEMP
      P(3) = (XQ - X3 - D*Y3)*TEMP
      P(4) = (XQ - X4 - D*Y4)*TEMP
      TEMP =  XQ - X4
      B    = (TEMP*D + Y4)/(TEMP - Y4*D)
      Z    = ((P(1)*P(2)*PA)/(P(3)*P(4)*2.0D0*G*T))*
     1       (1.0D0 + C23*NUC*(B**2 + B*D + D**2))
      GO TO 60
C
C     IN THIS CASE THE PANEL APPROXIMATES A PARALLELOGRAM.
C
   40 DO 45 I = 1,4
   45 P(I) = 1.0D0
      D = -.5D0*(X4/Y4 + (X3-X2)/Y3 + (Y3-Y4)/(X3-X4))
      Z = PA/(2.0D0*G*T)*(1.0D0 + 2.0D0*D**2*NUC)
      GO TO 60
C
C     IN THIS CASE NO PARALLEL EFFECTS EXIST.
C
   50 XQ    = X4 - (X3-X4)/(Y3-Y4)*Y4
      TEMP  = Y3*X4 - Y4*(X3-X2)
      XP    = X2*Y3*X4/TEMP
      YP    = X2*Y3*Y4/TEMP
      XL    = DSQRT((XQ-XP)**2 + YP**2)
      D     = (XQ-XP)/YP
      TEMP  = YP/XL
      P(1)  = TEMP*(XQ - X1 - D*Y1)
      P(2)  = TEMP*(XQ - X2 - D*Y2)
      P(3)  = TEMP*(XQ - X3 - D*Y3)
      P(4)  = TEMP*(XQ - X4 - D*Y4)
      C     = XL/P(1) - D
      B     = XL/P(4) - C
      A     = XL/P(2) - D
      A2    = A**2
      B2    = B**2
      C2    = C**2
      D2    = D**2
      A3    = A2*A
      B3    = B2*B
      C3    = C2*C
      D3    = D2*D
      A4    = A3*A
      B4    = B3*B
      C4    = C3*C
      D4    = D3*D
      A5    = A4*A
      B5    = B4*B
      C5    = C4*C
      D5    = D4*D
      TEMP  = .5D0*P(1)*P(2)*P(3)*P(4)/XL**2
      TERM  = A + B + C23*(A3+B3) + .2D0*(A5+B5)
      TERM1 = C + D + C23*(C3+D3) + .2D0*(C5+D5)
      TERM2 = B + C + C23*(B3+C3) + .2D0*(B5+C5)
      TERM3 = D + A + C23*(D3+A3) + .2D0*(D5+A5)
      TERM  = TERM *DLOG(DABS(A+B))
      TERM1 = TERM1*DLOG(DABS(C+D))
      TERM2 = TERM2*DLOG(DABS(B+C))
      TERM3 = TERM3*DLOG(DABS(D+A))
      TERM4 = .1D0*((A2-C2)*(B3-D3) + (B2-D2)*(A3-C3))
      TERM5 = .2D0*((A -C )*(B4-D4) + (B -D )*(A4-C4))
      F     = TEMP*(TERM + TERM1 - TERM2 - TERM3 + TERM4 - TERM5)
      Z     = P(1)*P(2)/(P(3)*P(4)*2.0D0*G*T)*(PA+4.0D0*NUC*(F-C23*PA))
   60 XL13  = DSQRT(X3**2 + Y3**2)
      XL24  = DSQRT((X4-X2)**2 + Y4**2)
      SMALLU(1) = X3/XL13
      SMALLU(2) = (X4-X2)/XL24
      SMALLU(3) = SMALLU(1)
      SMALLU(4) = SMALLU(2)
      SMALLV(1) = Y3/XL13
      SMALLV(2) = Y4/XL24
      SMALLV(3) = SMALLV(1)
      SMALLV(4) = SMALLV(2)
      TEMP      = X4*Y3 - X3*Y4
      AVEC(1)   =-.5D0*X2*Y4*XL13/TEMP
      AVEC(2)   = .5D0*X2*Y3*XL24/(TEMP-X2*(Y3-Y4))
      AVEC(3)   =-AVEC(1)
      AVEC(4)   =-AVEC(2)
C
C     COMPUTE THE SUM GIVEN ON P. 16 OF FMMS-39
C
      SUM = 0.0D0
      DO 80 I = 1,4
      IVLBEG   = 1
      VLEFT(1) = SMALLU(I)*VI(1) + SMALLV(I)*VJ(1)
      VLEFT(2) = SMALLU(I)*VI(2) + SMALLV(I)*VJ(2)
      VLEFT(3) = SMALLU(I)*VI(3) + SMALLV(I)*VJ(3)
      IF (IECPT(4*I+5) .EQ. 0) GO TO 70
      CALL TRANSD (IECPT(4*I+5),TI)
      IVLBEG = 4
      CALL GMMATD (VLEFT(1),3,1,1, TI,3,3,0, VLEFT(4))
   70 K = 24 + 3*I
      UI(1) = ECPT(K+1)
      UI(2) = ECPT(K+2)
      UI(3) = ECPT(K+3)
      CALL GMMATD (VLEFT(IVLBEG),3,1,1, UI,3,1,0, DPTERM)
   80 SUM = SUM + AVEC(I)*DPTERM
      F13 =-AVEC(1)*SUM/(2.0D0*Z)
      F24 = AVEC(2)*F13/AVEC(1)
C
C     SEARCH LIST OF SIL NOS. IN THE ECPT FOR THE PIVOT POINT.
C
      DO 90 I = 1,4
      II = I
      IF (NPVT .EQ. IECPT(I+1)) GO TO 100
   90 CONTINUE
      CALL MESAGE (-30,34,IECPT(1))
  100 IF (II.EQ.2 .OR. II.EQ.4) GO TO 110
      FXX = F13/XL13
      I   = 1
      GO TO 120
  110 FXX = F24/XL24
      I   = 2
  120 JJ(1) = -VI(1)*SMALLV(I) + VJ(1)*SMALLU(I)
      JJ(2) = -VI(2)*SMALLV(I) + VJ(2)*SMALLU(I)
      JJ(3) = -VI(3)*SMALLV(I) + VJ(3)*SMALLU(I)
C
C                     T            T
C     COMPUTE  JJ X JJ  AND VK X VK
C
      CALL GMMATD (JJ,3,1,0, JJ,3,1,1, J3X3)
      CALL GMMATD (VK,3,1,0, VK,3,1,1, K3X3)
C
C     SUM THE TWO IN J3X3
C
      DO 130 J = 1,9
  130 J3X3(J) = J3X3(J) + K3X3(J)
      GO TO (140,150,160,170), II
  140 KK = 3
      GO TO 180
  150 KK = 4
      GO TO 180
  160 KK = 1
      GO TO 180
  170 KK = 2
C
C     ZERO OUT KE
C
  180 DO 190 I = 1,36
  190 KE(I) = 0.0D0
C
C                 D
C     SET UP THE K   MATRIX
C                 II
C
      MPOINT = 1
      IF (IECPT(4*II+5) .EQ. 0) GO TO 200
      CALL TRANSD (ECPT(4*II+5),TI)
      MPOINT = 10
      CALL GMMATD (TI,3,3,1, J3X3(1),3,3,0, K3X3(1))
      CALL GMMATD (K3X3(1),3,3,0, TI,3,3,0, J3X3(1))
  200 K = 1
      J = II
  210 KE( 1) = FXX*J3X3(K  )
      KE( 2) = FXX*J3X3(K+1)
      KE( 3) = FXX*J3X3(K+2)
      KE( 7) = FXX*J3X3(K+3)
      KE( 8) = FXX*J3X3(K+4)
      KE( 9) = FXX*J3X3(K+5)
      KE(13) = FXX*J3X3(K+6)
      KE(14) = FXX*J3X3(K+7)
      KE(15) = FXX*J3X3(K+8)
      CALL DS1B (KE,IECPT(J+1))
      IF (J .EQ. KK) RETURN
C
C                 D
C     SET UP THE K   MATRIX
C                 IJ
C
      J = KK
      IF (IECPT(4*J+5) .EQ. 0) GO TO 220
      CALL TRANSD (ECPT(4*J+5),TI)
      NPOINT = 10
      IF (MPOINT .EQ. 10) NPOINT = 1
      CALL GMMATD (J3X3(MPOINT),3,3,0, TI,3,3,0, J3X3(NPOINT))
      K = NPOINT
      GO TO 230
  220 K = MPOINT
  230 FXX = -FXX
      GO TO 210
C
C     ERROR RETURNS
C
 1010 CONTINUE
 1020 CONTINUE
 1030 CALL MESAGE (30,26,IECPT(1))
C
C     SET FLAG FOR FATAL ERROR WHILE ALLOWING ERROR MESSAGES TO
C     ACCUMULATE
C
      NOGO = 1
      RETURN
C
 1040 IECPT(2) = 2
      GO TO 2000
 1050 IECPT(2) = 4
      GO TO 2000
 1060 IECPT(2) = 1
      GO TO 2000
 1070 IECPT(2) = 3
 2000 CALL MESAGE (30,27,IECPT(1))
C
C     SET FLAG FOR FATAL ERROR WHILE ALLOWING ERROR MESSAGES TO
C     ACCUMULATE
C
      NOGO = 1
      RETURN
      END

      SUBROUTINE PKTQ1(NTYPE)
C  THIS ROUTINE CALCULATES PHASE I OUTPUT FOR PLA4
C  FOR COMBINATION ELEMENTS
C
C**************** PHASE I  STRESS DATA RECOVERY ************************
C *********************************************************-************
C
C     9/12/67         E C P T     L I S T I N G
C                    ***************************
C ECPT  TRMEM   QDMEM   TRPLT   QDPLT   TRIA1   QUAD1   TRIA2   QUAD2
C **********************************************************************
C   1   EL.ID   EL.ID   EL.ID   EL.ID   EL.ID   EL.ID   EL.ID   EL.ID
C   2   GRID A  GRID A  GRID A  GRID A  GRID A  GRID A  GRID A  GRID A
C   3   GRID B  GRID B  GRID B  GRID B  GRID B  GRID B  GRID B  GRID B
C   4   GRID C  GRID C  GRID C  GRID C  GRID C  GRID C  GRID C  GRID C
C   5   THETA   GRID D  THETA   GRID D  THETA   GRID D  THETA   GRID D
C   6   MATID   THETA   MATID1  THETA   MATID1  THETA   MAT ID  THETA
C   7   T       MAT ID  I       MATID1  T1      MATID1  T       MAT ID
C   8   NS MASS T       MATID2  I       MATID2  T1      NS MASS T
C   9   CSID 1  NS MASS T2      MATID2  I       MATID2  CSID 1  NS MASS
C  10   X1      CSID 1  NS MASS T2      MATID3  I       X1      CSID 1
C  11   Y1      X1      Z1      NS MASS T2      MATID3  Y1      X1
C  12   Z1      Y1      Z2      Z1      NS MASS T2      Z1      Y1
C  13   CSID 2  Z1      CSID 1  Z2      Z1      NS MASS CSID 2  Z1
C  14   X2      CSID 2  X1      CSID 1  Z2      Z1      X2      CSID 2
C  15   Y2      X2      Y1      X1      CSID 1  Z2      Y2      X2
C  16   Z2      Y2      Z1      Y1      X1      CSID 1  Z2      Y2
C  17   CSID 3  Z2      CSID 2  Z1      Y1      X1      CSID 3  Z2
C  18   X3      CSID 3  X2      CSID 2  Z1      Y1      X3      CSID 3
C  19   Y3      X3      Y2      X2      CSID 2  Z1      Y3      X3
C  20   Z3      Y3      Z2      Y2      X2      CSID 2  Z3      Y3
C  21   TEMP    Z3      CSID 3  Z2      Y2      X2      TEMP    Z3
C  22           CSID 4  X3      CSID 3  Z2      Y2              CSID 4
C  23           X4      Y3      X3      CSID 3  Z2              X4
C  24           Y4      Z3      Y3      X3      CSID 3          Y4
C  25           Z4      TEMP    Z3      Y3      X3              Z4
C  26           TEMP            CSID 4  Z3      Y3              TEMP
C  27                           X4      TEMP    Z3
C  28                           Y4              CSID 4
C  29                           Z4              X4
C  30                           TEMP            Y4
C  31                                           Z4
C  32                                           TEMP
C **********************************************************************
C
      DIMENSION SAVE(32)
C
      COMMON /PLA4ES/ ECPT(100), PH1OUT(173) ,DUMMY(27)
C
C
C     THIS SUBROUTINE INCORPORATES TRIA1, QUAD1, TRIA2, QUAD2
C
C              NTYPE = 1  IMPLIES STRIA1
C              NTYPE = 2  IMPLIES STRIA2
C              NTYPE = 3  IMPLIES SQUAD1
C              NTYPE = 4  IMPLIES SQUAD2
C
C     SAVE THE INCOMING ECPT
C
      DO 10 I=1,32
   10 SAVE(I) = ECPT(I)
C
C     TRANSFER TO OPERATIONS DESIRED
C
C              STRIA1    STRIA2    SQUAD1    SQUAD2
      GO TO(20,100,150,230),NTYPE
C
C     **************
C     *** STRIA1 ***
C     **************
C
C     SET UP ECPT FOR PKTRM1, FIRST CHECK T1 FOR ZERO
   20 IF( SAVE(7) .EQ. 0.0E0 ) GO TO 50
      DO 30 I=9,21
   30 ECPT(I) = SAVE(I + 6)
C
      CALL PKTRM1 (0)
C
C     MOVE OUTPUT FROM PKTRM1 TO NEAR BOTTOM OF PH1OUT
C     WORDS (1 THRU 36) DOWN TO (99 THRU 134)
C
C
      DO 40 I=1,36
   40 PH1OUT(I + 98) = PH1OUT(I)
      RETURN
   50 PH1OUT( 99) = ECPT(1)
      PH1OUT(100) = 0.0E0
      RETURN
C
C
C     **************
C     *** STRIA2 ***
C     **************
  100 IF( SAVE(7) .EQ. 0.0E0 ) GO TO 140
C     SET UP CALL TO PKTRM1
C
C      ECPT IS OK AS DELIVERED TO THIS ROUTINE
C
      CALL PKTRM1(0)
C
C     MOVE OUTPUT FROM PKTRM1 TO NEAR BOTTOM OF PH1OUT
C     WORDS (1 THRU 36) DOWN TO (99 THRU 134)
C
      DO 110 I=1,36
  110 PH1OUT(I + 98) = PH1OUT(I)
      RETURN
C
  140 PH1OUT( 99) = ECPT(1)
      PH1OUT(100) = 0.0E0
      RETURN
C
C     **************
C     *** SQUAD1 ***
C     **************
C
  150 IF(SAVE(8).EQ.0.0E0)GO TO 180
C
C     SET UP CALL TO PKQDM1
C
      ECPT(9) = SAVE(13)
      DO 160 I=10,26
  160 ECPT(I) = SAVE(I+6)
C
      CALL PKQDM1
C
C     MOVE OUTPUT DOWN TO NEAR BOTTOM OF PH1OUT
C     WORDS (1 THRU 45) DOWN TO (129 THRU 173)
C
      DO 170 I=1,45
  170 PH1OUT(I + 128) = PH1OUT(I)
C
      RETURN
  180 PH1OUT(129) = ECPT(1)
      PH1OUT(130) = 0.0E0
      RETURN
C
C
C     **************
C     *** SQUAD2 ***
C     **************
C
  230 IF( SAVE(8) .EQ. 0.0E0 ) GO TO 270
C
C     SET UP CALL TO PKQDM1
C
C      ECPT IS OK AS DELIVERED TO THIS ROUTINE
C
      CALL PKQDM1
C
C     MOVE OUTPUT DOWN TO NEAR BOTTOM OF PH1OUT
C     WORDS (1 THRU 45) DOWN TO (129 THRU 173)
C
      DO 240 I=1,45
  240 PH1OUT(I + 128) = PH1OUT(I)
      RETURN
C
  270 PH1OUT(129) = ECPT(1)
      PH1OUT(130) = 0.0E0
      RETURN
      END

      SUBROUTINE BDAT06
C
C     THIS SUBROUTINE PROCESSES THE GTRAN BULK DATA
C
      EXTERNAL        RSHIFT,ANDF
      LOGICAL         PRINT,TDAT
CWKBI 8/94 ALPHA-VMS
      INTEGER         GEOM4, SCR1
      INTEGER         SCR2,BUF3,SCBDAT,BUF2,BUF1,GTRAN(2),FLAG,ID(5),
     1                COMBO,SCORE,Z,AAA(2),OUTT,BUF4,ANDF,RSHIFT,IHD(96)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /ZZZZZZ/ Z(1)
      COMMON /CMB001/ SCR1,SCR2,SCBDAT,SCSFIL,SCCONN,SCMCON,
     1                SCTOC,GEOM4,CASECC
      COMMON /CMB002/ BUF1,BUF2,BUF3,BUF4,BUF5,SCORE,LCORE,INPT,OUTT
      COMMON /CMB003/ COMBO(7,5),CONSET,IAUTO,TOLER,NPSUB,CONECT,TRAN,
     1                MCON,RESTCT(7,7),ISORT,ORIGIN(7,3),IPRINT
      COMMON /CMB004/ TDAT(6)
      COMMON /CMBFND/ INAM(2),IERR
      COMMON /OUTPUT/ ITITL(96),IHEAD(96)
      COMMON /BLANK / STEP,IDRY
      DATA   GTRAN  / 1510,15 / , AAA/ 4HBDAT,4H06   /
      DATA   IHD  / 11*4H    ,4H  SU,4HMMAR,4HY OF,4H PRO,4HCESS,4HED G,
     1       4HTRAN,4H BUL,4HK DA,4HTA  ,19*4H    ,4H PSE,4HUDO-,4H    ,
     2       4H    ,4H COM,4HPONE,4HNT  ,4H    ,4H   T,4HRANS,2*4H     ,
     3       4HGRID,4H    ,4HREFE,4HRENC,4HE   ,14*4H    ,4H  ST,4HRUCT,
     4       4HURE ,4HNO. ,4H   S,4HTRUC,4HTURE,4H NO.,4H    ,4H  SE   ,
     5       4HT ID,2*4H    ,4H ID ,4H    ,4HTRAN,4HS  I,4HD   ,7*2H   /
C
      IFILE = SCR1
      KK    = 0
      PRINT = .FALSE.
      IF (ANDF(RSHIFT(IPRINT,5),1) .EQ. 1) PRINT = .TRUE.
      DO 10 I = 1,96
      IHEAD(I) = IHD(I)
   10 CONTINUE
      CALL OPEN (*100,SCR2,Z(BUF3),1)
      IFILE = SCBDAT
      CALL LOCATE (*80,Z(BUF1),GTRAN,FLAG)
      IF (PRINT) CALL PAGE
      IFILE = GEOM4
   20 CALL READ (*110,*60,GEOM4,ID,1,0,N)
      DO 30 I = 1,NPSUB
      IF (ID(1) .EQ. COMBO(I,3)) GO TO 40
   30 CONTINUE
      CALL READ (*110,*120,GEOM4,ID,-4,0,N)
      GO TO 20
   40 TDAT(6) = .TRUE.
      KK = KK + 1
      CALL READ (*110,*120,GEOM4,ID(2),4,0,N)
      CALL FINDER (ID(2),IS,IC)
      IF (IERR .NE. 1) GO TO 50
      WRITE (OUTT,210) UFM,ID(2),ID(3)
      IDRY = -2
   50 CONTINUE
      IF (PRINT) CALL PAGE2 (1)
      IF (PRINT) WRITE (OUTT,200) IS,IC,ID(1),ID(4),ID(5)
      ID(3) = ID(1)
      ID(1) = IS
      ID(2) = IC
      ID(4) = IC*1000000 + ID(4)
      Z(BUF4+KK) = ID(5)
      CALL WRITE (SCR2,ID,5,0)
      GO TO 20
   60 CALL WRITE (SCR2,ID,0,1)
      CALL CLOSE (SCR2,1)
      IF (.NOT.TDAT(6)) GO TO 80
      IFILE = SCR2
      CALL OPEN (*100,SCR2,Z(BUF3),2)
      CALL READ (*110,*70,SCR2,Z(SCORE),LCORE,0,NN)
      GO TO 130
   70 CALL SORT (0,0,5,1,Z(SCORE),NN)
      CALL WRITE (SCBDAT,Z(SCORE),NN,1)
   80 CALL EOF (SCBDAT)
      Z(BUF4) = KK
      CALL CLOSE (SCR2,1)
      IF (PRINT) CALL PAGE2 (3)
      IF (PRINT) WRITE (OUTT,220)
      RETURN
C
  100 IMSG = -1
      GO TO 140
  110 IMSG = -2
      GO TO 140
  120 IMSG = -3
      GO TO 140
  130 IMSG = -8
  140 CALL MESAGE (IMSG,IFILE,AAA)
      RETURN
C
  200 FORMAT (36X,I1,14X,I5,8X,I8,4X,I8,4X,I8)
  210 FORMAT (A23,' 6530, THE BASIC SUBSTRUCTURE ',2A4, /30X,
     1       'REFERED TO BY A GTRAN BULK DATA CARD WHICH CANNOT BE ',
     2       'FOUNDD IN THE PROBLEM TABLE OF CONTENTS.')
  220 FORMAT (/5X,'NOTE - THE PSEUDOSTRUCTURE AND COMPONENT NUMBERS RE',
     1       'FER TO THEIR POSITIONS IN THE PROBLEM TABLE OF CONTENTS.')
      END

      SUBROUTINE RCOVLS (LASTSS)
C
C     THIS ROUTINE CREATES THE SOLN ITEM FOR A LOWER LEVEL SUBSTRUCTURE,
C     LASTSS, BY EDITING THAT OF THE SOLUTION SUBSTRUCTURE FSS.
C
      INTEGER         DRY        ,STEP       ,FSS        ,RFNO       ,
     1                UINMS      ,UA         ,LASTSS(2)  ,EQSS       ,
     2                RC         ,SOLN       ,SRD        ,SWRT       ,
     3                IZ(3)      ,EOI        ,EOG        ,NAME(2)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /BLANK / DRY        ,LOOP       ,STEP       ,FSS(2)     ,
     1                RFNO       ,NEIGV      ,LUI        ,UINMS(2,5) ,
     2                NOSORT     ,UTHRES     ,PTHRES     ,QTHRES
      COMMON /RCOVCR/ ICORE      ,LCORE      ,BUF1       ,BUF2       ,
     1                BUF3       ,BUF4       ,SOF1       ,SOF2       ,
     2                SOF3
      COMMON /RCOVCM/ MRECVR     ,UA         ,PA         ,QA         ,
     1                IOPT       ,RSS(2)     ,ENERGY     ,UIMPRO     ,
     2                RANGE(2)   ,IREQ       ,LREQ       ,LBASIC
      COMMON /SYSTEM/ SYSBUF     ,NOUT
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE     (Z(1),IZ(1))
      DATA    NAME  / 4HRCOV, 4HLS  /
      DATA    EQSS  , SOLN  / 4HEQSS,4HSOLN /
      DATA    SRD   , SWRT  / 1,2   /
      DATA    EOG   , EOI   / 2,3   /
C
C     CREATE SOLN ITEM FOR THE RECOVERED SUBSTRUCTURE
C
      IF (RFNO .EQ. 3) GO TO 490
C
C     OBTAIN LIST OF CONTRIBUTING BASIC SUBSTRUCTURES FROM EQSS.
C     STORE IN OPEN CORE AT ICORE.
C
      CALL SFETCH (LASTSS,EQSS,SRD,RC)
      CALL SUREAD (Z(ICORE),4,NWDS,RC)
      NSS = IZ(ICORE+2)
      IF (LCORE .LE. ICORE+2*NSS-1) GO TO 9008
      CALL SUREAD (Z(ICORE),2*NSS,NWDS,RC)
C
C     CONSTRUCT SOLN GROUP 0 IN OPEN CORE AT IG0.  TWO SLOTS FOR THE
C     NUMBER OF LOADS ON EACH SUBSTRUCTURE.  FIRST IS FOR OLD FSS
C     SOLN, SECOND FOR NEW ONE.
C
      IG0 = ICORE + 2*NSS
      CALL SFETCH (FSS,SOLN,SRD,RC)
      IF (RC .EQ. 1) GO TO 462
      CALL SMSG (RC-2,SOLN,FSS)
      GO TO 498
  462 CALL SUREAD (Z(IG0),5,NWDS,RC)
      ISOL = IZ(IG0+2)
      IF (ISOL .NE. RFNO) GO TO 6369
      NS = IZ(IG0+3)
      NC = IZ(IG0+4)
      IF (IG0+4+4*NS .GT. LCORE) GO TO 9008
      DO 465 I = 1,NS
      CALL SUREAD (Z(IG0+1+4*I),3,NWDS,RC)
      IZ(IG0+4*I+4) = -65535
      DO 463 J = 1,NSS
      IF (IZ(IG0+4*I+1) .NE. IZ(ICORE+2*J-2)) GO TO 463
      IF (IZ(IG0+4*I+2) .NE. IZ(ICORE+2*J-1)) GO TO 463
      IZ(IG0+4*I+4) = IZ(IG0+4*I+3)
      GO TO 465
  463 CONTINUE
  465 CONTINUE
      IF (RFNO.EQ.8 .OR. RFNO.EQ.9) GO TO 600
      I = 1
      CALL SJUMP (I)
C
C     STATICS SOLUTION ITEM
C
C     READ ALL GROUPS OF THE OLD FSS SOLN INTO OPEN CORE AT IGS.
C     AS EACH ONE IS READ, ELIMINATE LOAD VECTORS WHICH DO NOT
C     APPLY TO THE NEW SOLN BY SETTING THEIR LOAD VECTOR
C     NUMBERS TO -65535.
C     UPDATE THE NUMBER OF LOAD VECTORS WHICH DO APPLY.
C
      IGS = IG0 + 4*NS + 5
      JGS = IGS
      DO 478 I = 1,NC
      CALL SUREAD (Z(JGS),1,NWDS,RC)
      N = IABS(IZ(JGS))
      IF (JGS+N*2 .GT. LCORE) GO TO 9008
      CALL SUREAD (Z(JGS+1),-1,NWDS,RC)
      NL = 0
      IF (N .EQ. 0) GO TO 477
      DO 475 J = 1,N
      LVN = IZ(JGS+2*J-1)
C
C     FIND SUBSTRUCTURE WHERE LVN IS APPLIED FOR FSS SOLN ITEM.
C
      L1 = 0
      L2 = 0
      DO 470 K = 1,NS
      IF (LVN .GT. L2+IZ(IG0+4*K+3)) GO TO 468
      IF (IZ(IG0+4*K+4) .LT. 0) GO TO 471
      LVN = LVN - L1
      NL  = NL + 1
      GO TO 472
  468 IF (IZ(IG0+4*K+4) .LT. 0) L1 = L1 + IZ(IG0+4*K+3)
      L2 = L2 + IZ(IG0+4*K+3)
  470 CONTINUE
  471 LVN = -65535
  472 IZ(JGS+2*J-1) = LVN
  475 CONTINUE
      IF (IZ(JGS) .LT. 0) NL = -NL
      IZ(JGS) = NL
  477 JGS = JGS + 2*N + 1
  478 CONTINUE
C
C     WRITE THE NEW SOLN FOR THE RECOVERED SUBSTRUCTURE ON THE SOF.
C     IN CASE USER FORGOT TO EDIT OUT THIS SOLN FROM A PREVIOUS
C     RUN, DELETE IT TO AVOID LOSING OR SCREWING UP THE RECOVERED
C     DISPLACEMENTS.
C
      CALL DELETE (LASTSS,SOLN,RC)
      IZ(IG0+3) = NSS
      RC = 3
      CALL SFETCH (LASTSS,SOLN,SWRT,RC)
      CALL SUWRT (Z(IG0),5,1)
      DO 480 I = 1,NS
      IF (IZ(IG0+4*I+4) .LT. 0) GO TO 480
      CALL SUWRT (Z(IG0+4*I+1),2,1)
      CALL SUWRT (Z(IG0+4*I+4),1,1)
  480 CONTINUE
      CALL SUWRT (0,0,EOG)
      JGS = IGS
      DO 488 I = 1,NC
      K  = 0
      NL = IZ(JGS)
      JGS= JGS + 1
      CALL SUWRT (NL,1,1)
      IF (NL .EQ. 0) GO TO 485
      NL = IABS(NL)
  482 IF (IZ(JGS) .EQ. -65535) GO TO 484
      CALL SUWRT (IZ(JGS),2,1)
      K = K + 1
  484 JGS = JGS + 2
      IF (K .LT. NL) GO TO 482
  485 IF (IZ(JGS) .NE. -65535) GO TO 486
      JGS = JGS + 2
      GO TO 485
  486 CALL SUWRT (0,0,EOG)
  488 CONTINUE
      CALL SUWRT (0,0,EOI)
      GO TO 498
C
C     MODAL SOLUTION ITEM
C
C     FOR MODAL COPY THE SOLN UNCHANGED.  IN CASE THE USER FORGOT
C     TO EDIT OUT THIS SOLN FROM A PREVIOUS RUN, DELETE IT TO AVOID
C     LOSING OR SCREWING UP THE RECOVERED DISPLACEMENTS.
C
  490 CALL DELETE (LASTSS,SOLN,RC)
      CALL SFETCH (FSS,SOLN,SRD,RC)
      CALL SUREAD (IZ(ICORE),-1,NWDS,RC)
      ISOL = IZ(ICORE+2)
      IF (ISOL .NE. RFNO) GO TO 6369
      IF (IZ(ICORE+3) .GT. 0) GO TO 492
      RC = 3
      CALL SFETCH (LASTSS,SOLN,SWRT,RC)
      CALL SUWRT (Z(ICORE),4,EOG)
      CALL SUWRT (0,0,EOI)
      GO TO 498
  492 IF (LCORE .LT. ICORE+7*IZ(ICORE+3)+3) GO TO 9008
      CALL SUREAD (IZ(ICORE+4),-1,NWDS,RC)
      RC = 3
      CALL SFETCH (LASTSS,SOLN,SWRT,RC)
      CALL SUWRT (Z(ICORE),4,EOG)
      CALL SUWRT (Z(ICORE+4),7*IZ(ICORE+3),EOG)
      CALL SUWRT (0,0,EOI)
      GO TO 498
C
C     DYNAMIC SOLUTION ITEM
C
C     READ IN STATIC LOAD SETS
C
  600 INCR = 1
      IF (RFNO .EQ. 8) INCR = 2
      IGS = IG0 + 4*NS + 5
      CALL SUREAD (Z(IGS),1,NWDS,RC)
      NSL = IZ(IGS)
      LSL = NSL*INCR
      NSLL= 0
      IF (NSL .EQ. 0) GO TO 660
      IF (IGS+NSL .GT. LCORE) GO TO 9008
      CALL SUREAD (Z(IGS+1),NSL,NWDS,RC)
C
C     FLAG THOSE STATIC LOAD IDS THAT ARE NOT IN THE LOWER LEVEL
C     SUBSTRUCTURE AND RENUMBER THOSE THAT ARE LEFT
C
      DO 650 J = 1,NSL
      LVN = IZ(IGS+J)
      L1  = 0
      L2  = 0
      DO 620 K = 1,NS
      IF (LVN .GT. L2+IZ(IG0+4*K+3)) GO TO 610
      IF (IZ(IG0+4*K+4) .LT. 0) GO TO 630
      LVN  = LVN - L1
      NSLL = NSLL + 1
      GO TO 640
  610 IF (IZ(IG0+4*K+4) .LT. 0) L1 = L1 + IZ(IG0+4*K+3)
      L2 = L2 + IZ(IG0+4*K+3)
  620 CONTINUE
  630 LVN = -65535
  640 IZ(IGS+J) = LVN
  650 CONTINUE
C
C     COPY THE FREQUENCY OR TIME STEP RECORD INTO CORE
C
  660 I = 1
      CALL SJUMP (I)
      ISTEP = IGS + NSL + 1
      IF (ISTEP+NC .GT. LCORE) GO TO 9008
      CALL SUREAD (IZ(ISTEP),-1,NWDS,RC)
C
C     COPY IN ALL LOAD FACTOR DATA
C
      IF (NSLL .EQ. 0) GO TO 675
      JGS = ISTEP + NC
      DO 670 I = 1,NC
      IF (JGS+LSL .GT. LCORE) GO TO 9008
      CALL SUREAD (Z(JGS),-1,NWDS,RC)
  670 JGS = JGS + LSL
C
C     WRITE THE NEW SOLN ITEM FOR THE RECOVERED SUBSTRUCTURE.  IN CASE
C     THE USER FORGOT TO EDIT OUT THIS SOLN FROM A PREVIOUS RUN,
C     DELETE IT TO AVOID LOSING OR SCREWING UP THE RECOVERED
C     DISPLACEMENTS
C
  675 CALL DELETE (LASTSS,SOLN,RC)
      RC = 3
      CALL SFETCH (LASTSS,SOLN,SWRT,RC)
      IZ(IG0+3) = NSS
      CALL SUWRT (Z(IG0),5,1)
      DO 680 I = 1,NS
      IF (IZ(IG0+4*I+4) .LT. 0) GO TO 680
      CALL SUWRT (Z(IG0+4*I+1),2,1)
      CALL SUWRT (Z(IG0+4*I+4),1,1)
  680 CONTINUE
      CALL SUWRT (NSLL,1,1)
      IF (NSLL .EQ. 0) GO TO 700
      DO 690 I = 1,NSL
      IF (Z(IGS+I) .LT. 0) GO TO 690
      CALL SUWRT (Z(IGS+I),1,1)
  690 CONTINUE
  700 CALL SUWRT (0,0,EOG)
C
C     COPY THE TIME OR FREQUENCY STEP INFO TO SOF.
C
      CALL SUWRT (Z(ISTEP),NC,EOG)
C
C     COPY LOAD FACTORS FOR EACH STEP TO SOF EDITING OUT THOSE
C     THAT NO LONGER PARTICIAPTE
C
      IF (NSLL .EQ. 0) GO TO 730
      KGS = ISTEP + NC
      DO 720 I = 1,NC
      K = 1
      DO 710 J = 1,NSL
      IF (Z(IGS+J) .LT. 0) GO TO 710
      CALL SUWRT (Z(KGS+K-1),INCR,1)
      K = K + INCR
  710 CONTINUE
      CALL SUWRT (0,0,EOG)
      KGS = KGS + LSL
  720 CONTINUE
C
  730 CALL SUWRT (0,0,EOI)
      GO TO 498
C
C     NORMAL RETURN
C
  498 RETURN
C
C     ERROR PROCESSING
C
 6369 WRITE (NOUT,63690) UFM,ISOL,RFNO
      GO TO 9100
 9008 N = 8
      CALL MESAGE (N,0,NAME)
 9100 IOPT = -1
      CALL SOFCLS
      RETURN
C
63690 FORMAT (A23,' 6369.  SOLN ITEM HAS INCORRECT RIGID FORMAT NUMBER',
     1       /31X,'SOLUTION RIGID FORMAT WAS',I5,
     2       ' AND CURRENT NASTRAN EXECUTION RIGID FORMAT IS',I5)
      END

      SUBROUTINE KFLUD4
C
C     THIS ROUTINE IS USED FOR THE 4-SIDED FLUID ELEMENT. IT REARRANGES
C     THE DATA AND  CALLS THE KFLUD3 ROUTINE FOR EACH SUBELEMENT.
C
C     THE ECPT DATA FOR THE ELEMENT AND ITS SUBELEMENTS ARE
C
C        FIELD      SYMBOL(FLUID4)      SYMBOL(FLUID3)
C           1            ID                  ID
C           2            SIL1                SIL1
C           3            SIL2                SIL2
C           4            SIL3                SIL3
C           5            SIL4                RHO
C           6            RHO                 BULK
C           7            BULK                N
C           8            N                   CSF
C           9            CSF                 R1
C          10            R1                  Z1
C          11            Z1                  -
C          12            -                   CSF
C          13            CSF                 R2
C          14            R2                  Z2
C          15            Z2                  -
C          16            -                   CSF
C          17            CSF                 R3
C          18            R3                  Z3
C          19            Z3                  -
C          20            -
C          21            CSF
C          22            R4
C          23            Z4
C          24            -
C          25            -
C
      LOGICAL         NOGO
      INTEGER         OUT,NECPT(100)
      REAL            KI
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /SYSTEM/ SYSBUF,OUT,NOGO,SKIP(34),IAXIF
      COMMON /SMA1DP/ R(3),Z(3),NNEG,NJ,NPTJ,KI
      COMMON /SMA1CL/ IOPT1,K1GGSW,NPVT
      COMMON /SMA1ET/ ECPT(100)
      EQUIVALENCE     (ECPT(1),NECPT(1))
C
      IF (NECPT(6).LE. 0.0) RETURN
C
C     TEST FOR INTERIOR ANGLES GREATER THAN 180 DEGREES
C
      NNEG = 0
      IP   = 0
      DO 30 I = 1,4
      DO 20 J = 1,3
      NJ   = I + J - 1
      IF (NJ .GT. 4) NJ = NJ - 4
      NPTJ = 4*(NJ-1) + 10
      R(J) = ECPT(NPTJ  )
   20 Z(J) = ECPT(NPTJ+1)
      IF (NPVT .EQ. NECPT(I+1)) IP = IP + 1
      KI   = (R(2)-R(1))*(Z(3)-Z(1)) - (R(3)-R(1))*(Z(2)-Z(1))
      IF (KI) 25,2000,30
   25 NNEG = NNEG + 1
   30 CONTINUE
      IF (NNEG.EQ.1 .OR. NNEG.EQ.3) GO TO 2000
      IF (IP .NE. 1) GO TO 2000
      ECPT(6) = ECPT(6)*2.0
      DO 50 I = 1,24
   50 ECPT(I+50) = ECPT(I)
      DO 60 I = 5,24
   60 ECPT(I) = ECPT(I+1)
      IRET = 1
      GO TO 100
   70 ECPT( 4) = ECPT(55)
      ECPT(17) = ECPT(72)
      ECPT(18) = ECPT(73)
      IRET = 2
      GO TO 100
   80 ECPT(13) = ECPT(68)
      ECPT(14) = ECPT(69)
      ECPT( 3) = ECPT(54)
      IRET = 3
      GO TO 100
   90 ECPT( 9) = ECPT(64)
      ECPT(10) = ECPT(65)
      ECPT( 2) = ECPT(53)
      IRET = 4
C
  100 IF (NECPT(2).NE.NPVT .AND. NECPT(3).NE.NPVT .AND.
     1    NECPT(4).NE.NPVT)  GO TO 110
      CALL KFLUD3
  110 GO TO (70,80,90,120), IRET
  120 RETURN
C
 2000 CONTINUE
      NJ = NECPT(1)
      IF (IAXIF .EQ. 0) GO TO 2001
      NJ = NJ/1000
 2001 CONTINUE
      WRITE  (OUT,3000) UFM,NJ
 3000 FORMAT (A23,' 5002, INTERIOR ANGLE GREATER THAN OR EQUAL TO 180 ',
     1        'DEGREES FOR ELEMENT',I12)
      NOGO = .TRUE.
      RETURN
      END

      SUBROUTINE PRTINT
C
      INTEGER TRLR
      INTEGER OPT, PRT
C
C     OPT = 0 IF MATRIX BY COLUMNS...1 IF BY ROWS.
C
      REAL NAME(2)
C
      COMMON /BLANK/ OPT, PRT
      COMMON /XXMPRT/ TRLR(7)
      COMMON /ZZZZZZ/ X(1)
C
      IF (PRT.LT.0)  GO TO 100
      TRLR(1) = 101
      CALL RDTRL (TRLR)
      IF (TRLR(1).LE.0)  GO TO 100
      CALL FNAME (TRLR,NAME)
      CALL INTPRT (X,OPT,1,NAME)
  100 RETURN
      END

      SUBROUTINE MPYL (A,B,NCOLA,NROWA,NCOLB,C)
C
C     SINCE CDC FORTRAN 5 IMPOSES NO LONGER EXACT NO. OF DUMMY ARGUMENT
C     LIST FOR SUBROUTINE AND ENTRY POINTS, THIS ROUTINE IS NOW MACHINE
C     INDEPENDENT.
C
      DIMENSION A(NCOLA,NROWA),B(NCOLB,NCOLA),C(NCOLB,NROWA)
      DIMENSION D(NROWA,NCOLA),X(3),Y(3),VECT(3)
C
C     SIMPLE MATRIX MULTIPLICATION
C
      DO 10 N= 1,NCOLB
      DO 10 L= 1,NROWA
      C(N,L) = 0.0
      DO 10 M= 1,NCOLA
   10 C(N,L) = C(N,L)+B(N,M)*A(M,L)
      RETURN
C
      ENTRY NORM (X,Y)
C     ================
C
C     NORMALIZE X VECTOR
C
      Y(1) = X(1)*X(1)+X(2)*X(2)+X(3)*X(3)
      IF (Y(1) .EQ. 0.0)  GO TO 15
      W    = 1./SQRT(Y(1))
      X(1) = X(1)*W
      X(2) = X(2)*W
      X(3) = X(3)*W
   15 RETURN
C
      ENTRY CROSS (X,Y,VECT)
C     ======================
C
C     CROSS PRODUCT
C
      VECT(1) = X(2)*Y(3)-X(3)*Y(2)
      VECT(2) = Y(1)*X(3)-X(1)*Y(3)
      VECT(3) = X(1)*Y(2)-Y(1)*X(2)
      RETURN
C
      ENTRY MPYLT (D,B,NCOLA,NROWA,NCOLB,C)
C     =====================================
C
C     TRANSPOSE MULTIPLY
C
      DO 20 N= 1,NCOLB
      DO 20 L= 1,NROWA
      C(N,L) = 0.0
      DO 20 M= 1,NCOLA
   20 C(N,L) = C(N,L)+D(L,M)*B(N,M)
      RETURN
      END

      SUBROUTINE DTRANP
C
C     DRIVER OF MATRIX TRANSPOSE MODULE
C
C     TRNSP    IA/IAT/C,N,IXX  $
C
C     THE DIAGONALS OF THE LOWER OR UPPER TRIANGULAR MATRICES ARE
C     REPLACED BY UNITY (1.0) IF IXX IS ONE. (DEFAULT IS ZERO)
C
      CHARACTER       UFM*23,UWM*25
      COMMON /XMSSG / UFM,UWM
      COMMON /BLANK / IXX
      COMMON /SYSTEM/ IBUF,NOUT
      COMMON /ZZZZZZ/ CORE(1)
      COMMON /TRNSPX/ IA(7),IAT(7),LCORE,NSCR,ISCR(8)
      DATA    IN1   , IN2  /101, 201 /
C
      IA(1) = IN1
      CALL RDTRL (IA(1))
      IF (IA(1) .GT. 0) GO TO 20
      WRITE  (NOUT,10) UWM
   10 FORMAT (A25,' FROM TRNSP, MISSING INPUT DATA BLOCK FOR MATRIX ',
     1       'TRANSPOSE')
      GO TO 60
   20 IAT(1) = IN2
      IAT(2) = IA(3)
      IAT(3) = IA(2)
      IAT(4) = IA(4)
      IAT(5) = IA(5)
      IAT(6) = 0
      IAT(7) = 0
      LCORE  = KORSZ(CORE)
      NSCR = 8
      DO 30 I = 1,NSCR
   30 ISCR(I) = 300 + I
      IF (IXX .EQ. 1) IXX = -123457890
      CALL TRNSP (CORE(1))
      CALL WRTTRL (IAT(1))
C
   60 RETURN
      END

      SUBROUTINE ECTLOC(*,ECT,BUF,IELEM)
C*****
C ECTLOC IS A SPECIAL PURPOSE VERSION OF SUBROUTINE LOCATE.  ITS
C PURPOSE IS TO PASS THE ECT FILE SEQUENTIALLY POSITIONING EACH LOGICAL
C RECORD AFTER THE 3-WORD HEADER AND PROVIDING A POINTER TO THE
C APPROPRIATE ENTRY IN THE ELEM TABLE IN /GPTA1/. PLOTEL
C ELEMENTS ARE IGNORED.
C     NOTE---THE ECT FILE MUST BE OPEN ON EACH CALL.
C
C  ARGUMENTS
C
C     ECT   ---INPUT ---EINO FILE NAME OF THE ECT
C     BUF   ---IN/OUT---ADDRESS OF A 3-WORD ARRAY INTO WHICH
C                       THE FIRST 3 WORDS OF THE RECORD ARE READ
C     IELEM ---OUTPUT---POINTER TO 1ST WORD OF ENTRY IN ELEM
C                       TABLE IN /GPTA1/
C
C NON-STANDARD RETURN---GIVEN WHEN EOF HIT. ECT IS CLOSED BEFORE RETURN.
C*****
      INTEGER ECT , BUF(3), ELEM, PLOTEL
C
      COMMON/ GPTA1 / NELEM, LAST, INCR, ELEM(1)
C
      DATA PLOTEL/ 4HPLOT /
C
C READ A 3-WORD RECORD HEADER. IF NOT 3 WORDS, TRY NEXT RECORD
C
   10 CONTINUE
      CALL READ(*90,*10,ECT,BUF,3,0,NREAD)
C
C SEARCH FOR MATCH OF FIRST WORD OF RECORD WITH ECT-ID WORD IN /GPTA1/
C IF FOUND AND NOT PLOTEL, RETURN POINTER.
C
      DO 20 I=1,LAST,INCR
      IF( BUF(1) .EQ. ELEM(I+3) ) GO TO 30
   20 CONTINUE
   25 CALL FWDREC(*90,ECT)
      GO TO 10
   30 IF( ELEM(I).EQ.PLOTEL ) GO TO 25
      IELEM = I
      RETURN
C
C EOF ENCOUNTERED--CLOSE FILE AND RETURN.
C
   90 CALL CLOSE( ECT, 1 )
      IELEM = 0
      RETURN 1
      END

      SUBROUTINE MTRXO (FILE,NAME,ITEM,DUMBUF,ITEST)
C
C     COPIES MATRIX ITEM OF SUBSTRUCTURE NAME FROM THE NASTRAN FILE
C     TO THE SOF
C     ITEST VALUES RETURNED ARE
C        1 - ITEM ALREADY EXISTS ON THE SOF
C        2 - THE ITEM WAS PESUDO WRITTEN
C        3 - NORMAL RETURN
C        4 - NAME DOES NOT EXIST
C        5 - ITEM IS NOT ONE OF THE ALLOWABLE MATIX ITEMS
C        6 - NASTRAN FILE HAS BEEN PURGED
C
      EXTERNAL        LSHIFT,ORF,ANDF
      LOGICAL         MDIUP
      INTEGER         NMSBR(2),BUF(1),FILE,TRAIL(7),OLDBUF,NAME(2),
     1                BLKSIZ,FIRST,ORF,ANDF
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /MACHIN/ MACH,IHALF,JHALF
      COMMON /SOF   / DITDUM(6),IO,IOPBN,IOLBN,IOMODE,IOPTR,IOSIND,
     1                IOITCD,IOBLK,SOFDUM(20),MDIUP
      COMMON /SYSTEM/ NBUF,NOUT
      COMMON /SYS   / BLKSIZ
      COMMON /ZZZZZZ/ NSTRN
      EQUIVALENCE     (BUF(1),NSTRN)
      DATA    NMSBR / 4HMTRX, 4HO   /
      DATA    IWRT  / 2 /
      DATA    IFETCH/ -2/
      DATA    IDLE  / 0 /
C
C     CHECK IF ITEM IS ONE OF THE FOLLOWING ALLOWABLE NAMES.
C     KMTX, MMTX, PVEC, POVE, UPRT, HORG, UVEC, QVEC, PAPP, POAP, LMTX
C
      CALL CHKOPN (NMSBR(1))
      ITM = ITTYPE(ITEM)
      IF (ITM  .NE. 1) GO TO 1030
      IF (FILE .GT. 0) GO TO 20
C
C     THE MATRIX ITEM IS TO BE PESUDO WRITTEN
C
      ITEST = 2
      CALL SFETCH (NAME(1),ITEM,IFETCH,ITEST)
      GO TO 100
C
C     CHECK IF NASTRAN FILE HAS BEEN PURGED
C
   20 TRAIL(1) = FILE
      CALL RDTRL (TRAIL)
      IF (TRAIL(1) .LE. 0) GO TO 1020
C
C     OPEN ITEM TO WRITE AND FETCH FIRST BLOCK FOR SOF
C
      ITEST = 3
      CALL SFETCH (NAME(1),ITEM,IFETCH,ITEST)
      IF (ITEST .NE. 3) GO TO 100
C
C     OPEN NASTRAN FILE
C     MAKE SURE BUFFER IS  DOUBLE WORD ALIGNED.
C
      IDISP = LOCFX(BUF(IO-2)) - LOCFX(NSTRN)
      IF (ANDF(IDISP,1) .NE. 0) IO = IO + 1
      IOPT = 0
      CALL OPEN (*1020,FILE,BUF(IO-2),IOPT)
C
C     ADJUST SOF BUFFER TO COINCIDE WITH GINO BUFFER
C
      OLDBUF = IO
C
CIBMD 6/93 IF (MACH .GT. 2) GO TO 50
CIBMD 6/93 IF (BUF(IO-2) .EQ. FILE) GO TO 50
CIBMD 6/93 IO = IO + 1
CIBMD 6/93 IF (BUF(IO-2) .NE. FILE) GO TO 1000
C
C     BEGIN COPYING DATA TO SOF
C
C     FIRST CHECK IF CALL TO OPEN OBTAINED ONLY BLOCK IN FILE
C
   50 FIRST = 1
      CALL RDBLK (*70,FILE,FIRST,LEFT)
      FIRST = 0
C
C     WRITE OUT BLOCK IN BUFFER TO SOF AND OBTAIN A FREE SOF BLOCK
C
   60 CALL SOFIO (IWRT,IOPBN,BUF(IO-2))
      CALL GETBLK (IOPBN,J)
      IF (J .EQ. -1) GO TO 120
      IOPBN = J
      IOLBN = IOLBN + 1
C
C     OBTAIN A NEW BLOCK FROM THE GINO FILE
C
      CALL RDBLK (*70,FILE,FIRST,LEFT)
      GO TO 60
C
C     THE LAST BUFFER OF THE GINO FILE HAS BEEN FOUND - DETERMINE
C     IF SUFFICIENT SPACE IN BUFFER REMAINS FOR TRAILER
C
   70 CONTINUE
      IF (LEFT .GE. 6) GO TO 80
C
C     INSUFFICIENT SPACE - OBTAIN NEW SOF BLOCK
C     SET BLOCK NUMBER OF CURRENT BLOCK TO ZERO TO INDICATE TRAILER
C     IS STORED IN NEXT BLOCK
C
      BUF(IO+1) = 0
      CALL SOFIO (IWRT,IOPBN,BUF(IO-2))
      CALL GETBLK (IOPBN,J)
      IF (J .EQ. -1) GO TO 120
      IOPBN = J
      IOLBN = IOLBN + 1
C
C     STORE TRAILER IN LAST SIX WORDS OF BLOCK
C     SET BLOCK NUMBER NEGATIVE TO INDICATE LAST BLOCK AND
C     WRITE OUT FINAL BLOCK TO SOF
C
   80 DO 90 I = 2,7
   90 BUF(IO+BLKSIZ-7+I) = TRAIL(I)
      BUF(IO+1) = -IOLBN
      CALL SOFIO (IWRT,IOPBN,BUF(IO-2))
C
C     CLOSE FILE AND UPDATE MDI
C
      CALL CLOSE (FILE,1)
      CALL FMDI (IOSIND,IMDI)
      BUF(IMDI+IOITCD) = ORF(ANDF(IOBLK,JHALF),LSHIFT(IOLBN,IHALF))
      MDIUP = .TRUE.
C
C     RETURN
C
      ITEST  = 3
      IO     = OLDBUF
      IOMODE = IDLE
  100 RETURN
C
C     THERE ARE NO MORE FREE BLOCKS ON THE SOF.
C     RETURN THE BLOCKS THAT HAVE BEEN USED SO FAR BY THE ITEM BEING
C     WRITTEN, CLOSE THE SOF AND ISSUE A FATAL MESSAGE
C
  120 CALL RETBLK (IOBLK)
      CALL SOFCLS
      GO TO 1010
C
C     ERROR RETURNS
C
C
C     BUFFER ALIGNMENT ERROR
C
CIBMD 6/93 1000 CALL SOFCLS
CIBMD 6/93      CALL MESAGE (-8,0,NMSBR)
CIBMD 6/93      GO TO 100
C
C     NO MORE FREE BLOCKS ON THE SOF
C
 1010 WRITE  (NOUT,1011) UFM
 1011 FORMAT (A23,' 6223, THERE ARE NO MORE FREE BLOCKS AVAILABLE ON ',
     1       'THE SOF.')
      CALL MESAGE (-37,0,NMSBR)
C
C     GINO FILE PURGED
C
 1020 ITEST = 6
      GO TO 100
C
C     INVALID ITEM NAME
C
 1030 ITEST = 5
      GO TO 100
C
      END

      SUBROUTINE OFPPUN (IBUF,BUF,NWDS,IOPT,IDD,PNCHED)
C
C     MAIN OFP PUNCH ROUTINE FOR PUNCHING OF DATA LINES ONLY
C
C  $MIXED_FORMATS
C
      LOGICAL         TEMPER,PNCHED
      INTEGER         IBUF(NWDS),VECTOR,ID(50),OF(56)
      REAL            BUF(NWDS),RID(50)
      COMMON /SYSTEM/ SYSBUF,L,DUM53(53),ITHERM,DUM34(34),LPCH
      COMMON /OUTPUT/ HD(96)
C     COMMON /ZZOFPX/ L1,L2,L3,L4,L5,ID(50)
      COMMON /ZZZZZZ/ CORE(1)
      COMMON /BLANK / ICARD
      COMMON /OFPCOM/ TEMPER, M
      COMMON /GPTA1 / NELM,LAST,INCR,IE(25,1)
      EQUIVALENCE     (RID(1),ID(1),OF(6)), (L1,OF(1),CORE(1)),
     1                (L2,OF(2)), (L3,OF(3)), (L4,OF(4)), (L5,OF(5))
      DATA    VECTOR, IDTEMP / 1, 0 /
C
C
      IF (.NOT. PNCHED) GO TO 700
   20 IF (NWDS .LT.  0) GO TO 1710
C
C     FIRST CARD OUT
C
      ICARD = ICARD + 1
      IF (IOPT .EQ. VECTOR) GO TO 200
C
C     GENERAL 1-ST CARD (FIRST WORD OF BUF ASSUMED INTEGER)
C
      N = MIN0(4,NWDS)
      IF (IDD) 30,90,40
   30 IF (IDD .EQ. -1) GO TO 90
   40 GO TO (50,60,70,80), N
   50 WRITE (LPCH,440,ERR=180) BUF(1),ICARD
      GO TO 180
   60 WRITE (LPCH,450,ERR=180) BUF(1),BUF(2),ICARD
      GO TO 180
   70 WRITE (LPCH,460,ERR=180) BUF(1),BUF(2),BUF(3),ICARD
      GO TO 180
   80 WRITE (LPCH,470,ERR=180) BUF(1),BUF(2),BUF(3),BUF(4),ICARD
      GO TO 180
   90 GO TO (100,110,120,130), N
  100 WRITE (LPCH,400) IBUF(1),ICARD
      GO TO 180
  110 WRITE (LPCH,410,ERR=180) IBUF(1),BUF(2),ICARD
      GO TO 180
  120 WRITE (LPCH,420,ERR=180) IBUF(1),BUF(2),BUF(3),ICARD
      GO TO 180
C
C     CHECK FOR THERMAL FORCES FOR ISOPARAMETRICS
C
  130 IF (ITHERM.EQ.0 .OR. M.NE.4) GO TO 150
      IF (ID(3).LT.65 .OR. ID(3).GT.67) GO TO 150
      WRITE  (LPCH,140) IBUF(1),BUF(2),IBUF(3),BUF(4),ICARD
  140 FORMAT (I10,8X,A4,14X,I10,8X,1P,E18.6,I8)
      GO TO 180
C
C     CHECK FOR INTEGER IN SECOND ARGUMENT ALSO.
C
  150 IF (M .EQ. 19) GO TO 170
      IF (NUMTYP(BUF(2)) .LE. 1) GO TO 160
      WRITE (LPCH,430,ERR=180) IBUF(1),BUF(2),BUF(3),BUF(4),ICARD
      GO TO 180
  160 WRITE (LPCH,500,ERR=180) IBUF(1),IBUF(2),BUF(3),BUF(4),ICARD
      GO TO 180
  170 WRITE (LPCH,510) IBUF(1),IBUF(2),BUF(3),BUF(4),ICARD
      GO TO 180
  180 NWORD = 4
      GO TO 230
C
C     VECTOR 1-ST CARD (FIRST WORD INTEGER, SECOND WORD BCD)
C
  200 IF (TEMPER) GO TO 280
      IF (IDD.NE.0 .AND. IDD.NE.-1) GO TO 210
      WRITE (LPCH,520,ERR=220) IBUF(1),BUF(2),BUF(3),BUF(4),BUF(5),ICARD
      GO TO 220
  210 WRITE (LPCH,530,ERR=220)  BUF(1),BUF(2),BUF(3),BUF(4),BUF(5),ICARD
  220 NWORD = 5
C
C     CONTINUATION CARDS IF ANY.
C
  230 IF (NWORD .GE. NWDS) GO TO 1710
      ICARD = ICARD + 1
      NWORD = NWORD + 3
      IF (NWORD .LE. NWDS) GO TO 250
      NWORD = NWORD - 1
      IF (NWORD .EQ. NWDS) GO TO 240
      NWORD = NWORD - 1
C
C     1 WORD OUT
C
      WRITE (LPCH,610,ERR=1710) BUF(NWORD),ICARD
      GO TO 1710
C
C     2 WORDS OUT
C
  240 WRITE (LPCH,600,ERR=1710) BUF(NWORD-1),BUF(NWORD),ICARD
      GO TO 1710
C
C     3 WORDS OUT
C
  250 IF (IBUF(NWORD-1) .EQ. VECTOR) GO TO 260
      IF (IBUF(NWORD  ) .EQ. VECTOR) GO TO 270
      WRITE (LPCH,590,ERR=230) BUF(NWORD-2),BUF(NWORD-1),BUF(NWORD),
     1                         ICARD
      GO TO 230
  260 WRITE (LPCH,620) BUF(NWORD-2),BUF(NWORD),ICARD
      GO TO 230
  270 WRITE (LPCH,600) BUF(NWORD-2),BUF(NWORD-1),ICARD
      GO TO 230
C
C     SPECIAL PUNCH ONLY WHEN TEMPER FLAG IS ON IN A -HEAT- FORMULATION.
C
  280 IC1 = IBUF(1)
      IF (IDD.EQ.0 .OR. IDD.EQ.-1) GO TO 290
      IDTEMP = IDTEMP + 1
      IC1 = IDD
  290 CONTINUE
      WRITE  (LPCH,300) IDTEMP,IC1,BUF(3),ICARD
  300 FORMAT (8HTEMP*    ,I16,I16,1P,E16.6,16X,I8)
      GO TO 1710
C
  400 FORMAT (I10,62X,I8)
  410 FORMAT (I10,8X,1P,E18.6,36X,I8)
  420 FORMAT (I10,8X,2(1P,E18.6),18X,I8)
  430 FORMAT (I10,8X,3(1P,E18.6),I8)
  440 FORMAT (1P,E18.6,54X,I8)
  450 FORMAT (2(1P,E18.6),36X,I8)
  460 FORMAT (3(1P,E18.6),18X,I8)
  470 FORMAT (4(1P,E18.6),I8)
  500 FORMAT (I10,8X,I10,8X,2(1P,E18.6),I8)
  510 FORMAT (I10,8X,I10,8X,2A4,28X,I8)
  520 FORMAT (I10,7X,A1,3(1P,E18.6),I8)
  530 FORMAT (1P,E16.6,1X,A1,3(1P,E18.6),I8)
  590 FORMAT (6H-CONT-,12X,3(1P,E18.6),I8)
  600 FORMAT (6H-CONT-,12X,2(1P,E18.6),18X,I8)
  610 FORMAT (6H-CONT-,12X,1P,E18.6,36X,I8)
  620 FORMAT (6H-CONT-,12X,1P,E18.6,18X,1P,E18.6,I8)
C
C
C     PUNCH HEADING CARDS
C
C
C     TITLE,SUBTITLE,AND LABEL
C
  700 DO 740 I = 1,3
      ICARD = ICARD + 1
      GO TO (710,720,730), I
  710 WRITE (LPCH,750) (HD(J),J= 1,15),ICARD
      GO TO 740
  720 WRITE (LPCH,760) (HD(J),J=33,47),ICARD
      GO TO 740
  730 WRITE (LPCH,770) (HD(J),J=65,79),ICARD
  740 CONTINUE
C
  750 FORMAT (10H$TITLE   =,15A4,2X,I8)
  760 FORMAT (10H$SUBTITLE=,15A4,2X,I8)
  770 FORMAT (10H$LABEL   =,15A4,2X,I8)
C
      KTYPE = ID(2)/1000
      M = ID(2) - (KTYPE)*1000
      IF (M.LT.1 .OR. M.GT.19) GO TO 1200
      ICARD = ICARD + 1
      GO TO (780,790,800 ,810,900,1170,910,1170,1170,920,
     1       930,940,1170,950,960,970 ,980,990 ,1000), M
  780 WRITE (LPCH,1010) ICARD
      GO TO 1200
  790 WRITE (LPCH,1020) ICARD
      GO TO 1200
  800 WRITE (LPCH,1030) ICARD
      GO TO 1200
  810 WRITE (LPCH,1040) ICARD
      GO TO 1200
C
C     PUNCH ELEMENT STRESS OR GRID POINT STRESS HEADING LINE
C
  900 IF (L2 .NE. 378) WRITE(LPCH,1050) ICARD
      IF (L2 .EQ. 378) WRITE(LPCH,1060) ICARD
      GO TO 1200
  910 WRITE (LPCH,1070) ICARD
      GO TO 1200
  920 WRITE (LPCH,1080) ICARD
      GO TO 1200
  930 WRITE (LPCH,1090) ICARD
      GO TO 1200
  940 WRITE (LPCH,1100) ICARD
      GO TO 1200
  950 WRITE (LPCH,1110) ICARD
      GO TO 1200
  960 WRITE (LPCH,1120) ICARD
      GO TO 1200
  970 WRITE (LPCH,1130) ICARD
      GO TO 1200
  980 WRITE (LPCH,1140) ICARD
      GO TO 1200
  990 WRITE (LPCH,1150) ICARD
      GO TO 1200
 1000 WRITE (LPCH,1160) ICARD
      GO TO 1200
C
 1010 FORMAT (14H$DISPLACEMENTS,58X,I8)
 1020 FORMAT (7H$OLOADS,65X,I8)
 1030 FORMAT (5H$SPCF,67X,I8)
 1040 FORMAT (15H$ELEMENT FORCES,57X,I8)
 1050 FORMAT (17H$ELEMENT STRESSES,55X,I8)
 1060 FORMAT (24H$STRESSES AT GRID POINTS,48X,I8)
 1070 FORMAT (12H$EIGENVECTOR,60X,I8)
 1080 FORMAT (9H$VELOCITY,63X,I8)
 1090 FORMAT (13H$ACCELERATION,59X,I8)
 1100 FORMAT (18H$NON-LINEAR-FORCES,54X,I8)
 1110 FORMAT (27H$EIGENVECTOR (SOLUTION SET),45X,I8)
 1120 FORMAT (29H$DISPLACEMENTS (SOLUTION SET),43X,I8)
 1130 FORMAT (24H$VELOCITY (SOLUTION SET),48X,I8)
 1140 FORMAT (28H$ACCELERATION (SOLUTION SET),43X,I8)
 1150 FORMAT (23HELEMENT STRAIN ENERGIES ,49X,I8)
 1160 FORMAT (24HGRID POINT FORCE BALANCE ,48X,I8)
 1170 ICARD = ICARD - 1
C
C     REAL, REAL/IMAGINARY, MAGNITUDE/PHASE
C
 1200 ICARD = ICARD + 1
      IF (KTYPE.LT.1 .OR. KTYPE.EQ.2) GO TO 1210
      IF (ID(9).EQ. 3) GO TO 1230
      GO TO 1220
 1210 WRITE (LPCH,1240) ICARD
      GO TO 1300
 1220 WRITE (LPCH,1250) ICARD
      GO TO 1300
C
 1230 WRITE  (LPCH,1260) ICARD
 1240 FORMAT (12H$REAL OUTPUT,60X,I8)
 1250 FORMAT (22H$REAL-IMAGINARY OUTPUT, 50X,I8)
 1260 FORMAT (23H$MAGNITUDE-PHASE OUTPUT,49X,I8)
C
C     SUBCASE NUMBER FOR SORT1 OUTPUT, OR
C     SUBCASE NUMBER FOR SORT2, FREQUENCY AND TRANSIENT RESPONSE ONLY
C
 1300 IF (KTYPE .LE. 1) GO TO 1310
      IAPP = ID(1)/10
      IF (IAPP.NE.5 .AND. IAPP.NE.6) GO TO 1400
 1310 ICARD = ICARD + 1
      WRITE  (LPCH,1320) ID(4),ICARD
 1320 FORMAT (13H$SUBCASE ID =,I12,47X,I8)
C
C     IF ELEMENT STRESS OR FORCE PUNCH ELEMENT TYPE NUMBER
C
 1400 IF (M.NE.4 .AND. M.NE.5) GO TO 1500
      ICARD = ICARD + 1
      ID3   = ID(3)
      IF (L2 .NE. 378) WRITE (LPCH,1410) ID3,IE(1,ID3),IE(2,ID3),ICARD
      IF (L2 .EQ. 378) WRITE (LPCH,1420) ICARD
 1410 FORMAT (15H$ELEMENT TYPE =,I12,3X,1H(,2A4,1H),32X,I8)
 1420 FORMAT (38H$PUNCHED IN MATERIAL COORDINATE SYSTEM,34X,I8)
C
C     PUNCH EIGENVALUE, FREQUENCY, POINT OR ELEMENT ID, OR TIME
C
 1500 IAPP = ID(1)/10
      IF (IAPP.LT.1 .OR. IAPP.GT.10) GO TO 1700
      GO TO (1590,1510,1590,1590,1550,1570,1590,1510,1510,1590), IAPP
C
C     PUNCH EIGENVALUE
C
 1510 ICARD = ICARD + 1
      IF (KTYPE .EQ. 1) GO TO 1530
      WRITE  (LPCH,1520,ERR=1700) RID(6),ID(5),ICARD
 1520 FORMAT (13H$EIGENVALUE =,E15.7,2X,6HMODE =,I6,30X,I8)
      GO TO 1700
 1530 WRITE  (LPCH,1540,ERR=1700) RID(6),RID(7),ID(5),ICARD
 1540 FORMAT (15H$EIGENVALUE = (,E15.7,1H,,E15.7,8H) MODE =,I6,12X,I8)
      GO TO 1700
C
C     FREQUENCY OR TIME, POINT OR ELEMENT ID
C
 1550 IF (KTYPE .GT. 1) GO TO 1590
      ICARD = ICARD + 1
      WRITE  (LPCH,1560,ERR=1700) RID(5),ICARD
 1560 FORMAT (12H$FREQUENCY =,E16.7,44X,I8)
      GO TO 1700
 1570 IF (KTYPE .GT. 1) GO TO 1590
      ICARD = ICARD + 1
      WRITE  (LPCH,1580,ERR=1700) RID(5),ICARD
 1580 FORMAT (7H$TIME =,E16.7,49X,I8)
      GO TO 1700
 1590 IF (KTYPE .LE. 1) GO TO 1700
      ICARD = ICARD + 1
      IF (M.EQ.4 .OR. M.EQ.5) GO TO 1610
      WRITE  (LPCH,1600) ID(5),ICARD
 1600 FORMAT (11H$POINT ID =,I12,49X,I8)
      GO TO 1700
 1610 WRITE  (LPCH,1620) ID(5),ICARD
 1620 FORMAT (13H$ELEMENT ID =,I10,49X,I8)
C
C     CARD HEADING COMPLETE
C
 1700 PNCHED = .TRUE.
      IF (.NOT.TEMPER) GO TO 20
      IDTEMP = IDTEMP + 1
      IF (IDD .GT. 0) IDTEMP = 0
      GO TO 20
C
 1710 RETURN
      END

      SUBROUTINE FRD2I (FL,NFREQ,NCORE,QHHL,SCR2,SCR1,SCR3,SCR4,NROW)
C
      INTEGER         QHHL,SCR1,SCR2,SCR3,SCR4,TRL(7),OUT
      DIMENSION       FL(1),MCB(7),NAME(2)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /BLANK / BOV,Q,RM
      COMMON /CONDAS/ PI,TWOPI
      COMMON /SYSTEM/ ISYS,OUT,DUM(52),IPREC
      COMMON /UNPAKX/ IOUT,INN,NNN,INCR1
      COMMON /PACKX / ITI,ITO,II,NN,INCR
      COMMON /TYPE  / P(2),IWC(4)
      DATA    NAME  / 4HFRD2,4HI   /
      DATA    NHFRDI/ 4HFRDI/
C
      IBUF1 = NCORE - ISYS
      IBUF2 = IBUF1 - ISYS
      NROW  = 0
      INCR  = 1
      INCR1 = 1
      II    = 1
      INN   = 1
      MCB(1)= QHHL
      CALL RDTRL (MCB)
      IF (MCB(1) .LT. 0) GO TO 1000
      NROW  = MCB(3)
      NI    =(MCB(2)/MCB(3))*2
      NNN   = NROW
      NN    = NROW*NROW
      ITI   = 3
      ITO   = ITI
      IOUT  = ITI
      NWC   = IWC(ITI)
      ISCR  = SCR1
      NLOOP = 1
      INDX  = 0
      XM    = RM
      IF (RM .GE. 0.0) GO TO 5
      ISCR  = SCR2
      NLOOP = NFREQ
      INDX  = 1
    5 CALL MAKMCB (TRL,ISCR,NN,MCB(4),ITO)
C
C     MAKE INDEPENDENT FREQ LIST
C
      IPD   = 1
      NL    = 2*NFREQ
      N     = NFREQ + 1
      ICORE = IBUF1
      IPI   = IPD + NL
      DO 10 I = 1,NFREQ
      FL(NL) = FL(N-I)*TWOPI*BOV
      FL(NL-1) = 0.0
      NL = NL -2
   10 CONTINUE
C
C     MAKE INDEPENDENT FREQ LIST
C
      CALL OPEN  (*1000,QHHL,FL(IBUF2),0)
      CALL GOPEN (ISCR,FL(IBUF1),1)
      CALL READ  (*999,*999,QHHL,FL(IPI),-3,0,FLAG)
      CALL READ  (*999,*999,QHHL,N,1,0,FLAG)
      N = N + N
      IF (RM.GE.0.0 .OR. N.EQ.NI) GO TO 15
      WRITE  (OUT, 2000) UFM,N,NI
 2000 FORMAT (A23,', THE NUMBER OF (M,K) PAIRS SPECIFIED ON MKAEROX ',
     1       'CARDS (', I5, ') IS NOT EQUAL ', /5X,
     2       'TO THE NUMBER OF FREQUENCIES SPECIFIED (', I5, '),')
      CALL MESAGE (-37,0,NAME)
  15  NI = MIN0(NI,N)
      CALL READ (*999,*999,QHHL,FL(IPI),NI,1,FLAG)
      IF (RM .LT. 0.0) CALL CLOSE (QHHL, 1)
C
      DO 200 KKK = 1, NLOOP
      IF (RM .GE. 0.0) GO TO 20
      XM = FL(2*KKK)
      CALL GOPEN (QHHL,FL(IBUF2),0)
   20 CONTINUE
C
C     FOR RM.GE.0.0, FIND M CLOSEST TO XM
C     FOR RM.LT.0.0, FIND K CLOSEST TO XM
C
      ICP = IPI + NI
      RMI = 1.E20
      RMS = 0.0
      DO 30 I = 1,NI,2
      RMX = ABS(FL(IPI+I+INDX-1)-XM)
      RMI = AMIN1(RMI,RMX)
      IF (RMX .GT. RMI) GO TO 30
      RMS = FL(IPI+I+INDX-1)
   30 CONTINUE
      RMI = RMS
C
C     FOR RM.GE.0.0, SELECT ALL K'S ASSOCIATED WITH RMI
C     FOR RM.LT.0.0, SELECT THE K EQUAL TO RMI
C
      K = 0
      DO 100 I = 1,NI,2
      IF (FL(IPI+I+INDX-1) .EQ. RMI) GO TO 120
C
C     SKIP MATRIX
C
      CALL SKPREC (QHHL,NROW)
      GO TO 100
C
C     MAKE MATRIX INTO COLUMN
C
  120 FL(IPI+K+1) = FL(IPI+I)
      K  = K + 2
      JI = ICP
      N  = NROW*NWC
      DO 130 J = 1,NROW
      CALL UNPACK (*131,QHHL,FL(JI))
      GO TO 135
  131 CALL ZEROC (FL(JI),N)
  135 JI = JI + N
  130 CONTINUE
C
C     DIVIDE IMAG PART OF QHHL BY FREQUENCY
C
      JJ = ICP + 1
      KK = JI  - 1
      DO 132 J = JJ,KK,2
      FL(J) = FL(J)/FL(IPI+I)
  132 CONTINUE
      IF (RM .LT. 0.0) FL(IPI+I) = -10000.0
      CALL PACK (FL(ICP),ISCR,TRL)
      IF (RM .LT. 0.0) GO TO 150
  100 CONTINUE
  150 CALL CLOSE (QHHL,1)
      CALL CLOSE (ISCR,1)
  200 CONTINUE
C
      CALL WRTTRL (TRL)
      CALL BUG (NHFRDI,200,K ,1)
      CALL BUG (NHFRDI,200,NFREQ,1)
      CALL BUG (NHFRDI,200,FL(1),ICP)
      IF (RM .LT. 0.0) RETURN
C
C     SETUP TO CALL MINTRP
C
      NI   = K/2
      NOGO = 0
      NC   = NCORE - ICP
      CALL DMPFIL (-SCR1,FL(ICP),NC)
      IM   = 0
      IK   = 1
      CALL MINTRP (NI,FL(IPI),NFREQ,FL(IPD),-1,IM,IK,0.0,SCR1,SCR2,SCR3,
     1             SCR4,FL(ICP),NC,NOGO,IPREC)
      IF (NOGO .EQ. 1) GO TO 998
      CALL DMPFIL (-SCR2,FL(ICP),NC)
      RETURN
C
  998 WRITE  (OUT,9980) UFM
 9980 FORMAT (A23,' 2271, INTERPOLATION MATRIX IS SINGULAR')
      GO TO 9999
  999 CALL MESAGE (-3,QHHL,NAME)
 9999 CALL MESAGE (-61,0,NAME)
 1000 CALL CLOSE (QHHL,1)
      RETURN
      END

      SUBROUTINE CINVP2 (*)
C
C     CINVP2 INITIALIZES AND CALLS CDCOMP FOR CINVPR
C
      INTEGER            FILEA     ,FILEL    ,FILEU    ,SCR1     ,
     1                   SCR2      ,SCR3     ,SCR4     ,SCR5     ,
     2                   SCR6      ,SCR7     ,SCR8     ,SWITCH   ,
     3                   SR1FIL    ,SR2FIL   ,SR3FIL   ,SYSBUF   ,
     5                   DUMM      ,CDP      ,SCR9
      DOUBLE PRECISION   DET       ,MINDIA
      COMMON   /CDCMPX/  FILEA(7)  ,FILEL(7) ,FILEU(7), SR1FIL   ,
     1                   SR2FIL    ,SR3FIL   ,DET(2)   ,POWER    ,
     2                   NZ        ,MINDIA   ,IB
      COMMON   /CINVXX/  DUM(4)    ,SWITCH
      COMMON   /CINVPX/  DUMM(36)  ,SCR1     ,SCR2     ,SCR3     ,
     1                   SCR4      ,SCR5     ,SCR6     ,SCR7     ,
     2                   SCR8      ,SCR9
      COMMON   /ZZZZZZ/  Z(1)
      COMMON   /NAMES /  IJ(10)    ,CDP
      COMMON / SYSTEM /  SYSBUF
C
      IOFF     = FILEU(7)
      FILEA(1) = SCR1
      IF (SWITCH .EQ. 0) GO TO 10
      FILEL(1) = SCR8
      FILEU(1) = SCR9
      IF (SWITCH .LT. 0) FILEA(1) = -FILEA(1)
      IF (SWITCH .EQ. -204) GO TO 20
      SWITCH   = 1
      GO TO 20
   10 FILEL(1) = SCR3
      FILEU(1) = SCR4
   20 SR1FIL   = SCR5
      SR2FIL   = SCR6
      SR3FIL   = SCR7
      FILEA(2) = DUMM(3)
      FILEA(3) = DUMM(3)
      FILEA(4) = DUMM(4)
      FILEA(5) = CDP
      FILEA(6) = 0
      FILEA(7) = 0
      FILEL(5) = CDP
      NZ       = KORSZ(Z)
      IF (SWITCH .EQ. -204) NZ = NZ - 2*SYSBUF
      IB       = 0
      CALL CDCOMP (*30,Z,Z,Z)
      IF (SWITCH  .NE. 0) FILEU(7) = IOFF
      RETURN
C
   30 RETURN 1
      END

      SUBROUTINE EXLVL (NOS,MD,NAME,Z,NWDS)
C
C     EXLVL ADDS A SUBSTRUCTURE TO THE RESIDENT SOF FOR THE SOFIN
C     OPERATION.  IT USES THE DIT AND MDI DATA WRITTEN ON THE EXTERNAL
C     FILE BY SOFOUT TO RESTORE THE HL, CS, AND LL POINTERS IN THE MDI.
C
      EXTERNAL LSHIFT   ,RSHIFT   ,ANDF     ,ORF
      LOGICAL  MDIUP
      INTEGER  MD(4,1)  ,NAME(2)  ,BUF      ,ANDF     ,RSHIFT    ,
     1         PS       ,CS       ,HL       ,TP       ,Z(2)      ,
     2         SUBR(2)  ,ORF
      COMMON  /ZZZZZZ/   BUF(1)
      COMMON  /SYSTEM/   SYSBUF   ,NOUT     ,X1(6)    ,NLPP      ,
     1                   X2(2)    ,LINE
      COMMON  /SOF   /   X3(34)   ,MDIUP
      DATA     SUBR  /   4HEXLV   ,4HL      /
C
C
C     ADD THE NEW SUBSTRUCTURE TO THE RESIDENT DIT.
C
      CALL FDSUB (NAME,I)
      IF (I .NE. -1) GO TO 6104
      CALL CRSUB (NAME,I)
      IF (NOS .LE. 0) GO TO 200
      Z(1) = NAME(1)
      Z(2) = NAME(2)
      NSS  = 1
      ISS  = 1
C
C     DECODE THE OLD MDI ENTRY
C
    5 DO 10 I = 1,NOS
      IF (MD(1,I).NE.Z(2*ISS-1) .OR. MD(2,I).NE.Z(2*ISS)) GO TO 10
      PS = ANDF(MD(3,I),1023)
      TP = ANDF(RSHIFT(MD(3,I),20),1023)
      LL = RSHIFT(MD(4,I),20)
      CS = ANDF(RSHIFT(MD(4,I),10),1023)
      HL = ANDF(MD(4,I),1023)
      IOLD = I
      GO TO 15
   10 CONTINUE
C
C     SET NEW MDI POINTERS FOR HL, CS, AND LL IF THE SUBSTRUCTURES OF
C     THE ORIGINATING SOF WHICH ARE INDICATED THEREBY EXIST.
C
C
C     HIGHER LEVEL (HL)
C
   15 M = 0
      IF (HL .EQ. 0) GO TO 30
      CALL FDSUB (MD(1,HL),I)
      IF (I .GT. 0) GO TO 20
      CALL CRSUB (MD(1,HL),I)
      NSS = NSS + 1
      IF (2*NSS .GT. NWDS) GO TO 9008
      Z(2*NSS-1) = MD(1,HL)
      Z(2*NSS  ) = MD(2,HL)
   20 M  = I
      HL = I
C
C     COMBINED SUBSTRUCTURE (CS)
C
   30 IF (CS .EQ. 0) GO TO 60
      CALL FDSUB (MD(1,CS),J)
      IF (J .GT. 0) GO TO 50
      CALL CRSUB (MD(1,CS),J)
      NSS = NSS + 1
      IF (2*NSS .GT. NWDS) GO TO 9008
      Z(2*NSS-1) = MD(1,CS)
      Z(2*NSS  ) = MD(2,CS)
   50 M  = ORF(M,LSHIFT(J,10))
      CS = J
C
C     LOWER LEVEL (LL)
C
   60 IF (LL .EQ. 0) GO TO 90
      CALL FDSUB (MD(1,LL),J)
      IF (J .GT. 0) GO TO 80
      CALL CRSUB (MD(1,LL),J)
      NSS = NSS + 1
      IF (2*NSS .GT. NWDS) GO TO 9008
      Z(2*NSS-1) = MD(1,LL)
      Z(2*NSS  ) = MD(2,LL)
   80 M  = ORF(M,LSHIFT(J,20))
      LL = J
C
C     UPDATE THE MDI
C
   90 CALL FDSUB (Z(2*ISS-1),J)
      CALL FMDI (J,I)
      BUF(I+1) = LSHIFT(TP,20)
      BUF(I+2) = M
      MDIUP    =.TRUE.
C
C     WRITE USER MESSAGES
C
      NL = 2
      IF (LL .NE. 0) NL = NL + 1
      IF (CS .NE. 0) NL = NL + 1
      IF (HL .NE. 0) NL = NL + 1
      IF (PS .NE. 0) NL = NL + 3
      IF (LINE+NL .GT. NLPP) CALL PAGE
      LINE = LINE + NL
      WRITE (NOUT,63470) Z(2*ISS-1),Z(2*ISS)
      IF (HL .EQ. 0) GO TO 100
      CALL FDIT (HL,I)
      WRITE (NOUT,63471) BUF(I),BUF(I+1)
  100 IF (CS .EQ. 0) GO TO 130
      CALL FDIT (CS,I)
      WRITE (NOUT,63472) BUF(I),BUF(I+1)
  130 IF (LL .EQ. 0) GO TO 160
      CALL FDIT (LL,I)
      WRITE (NOUT,63473) BUF(I),BUF(I+1)
  160 IF (PS .EQ. 0) GO TO 170
      WRITE (NOUT,63590) Z(2*ISS-1),Z(2*ISS)
  170 ISS = ISS + 1
      IF (ISS-NSS) 5,5,210
C
C     SUBSTRUCTURE ADDED TO SOF SUCCESSFULLY
C
  200 WRITE (NOUT,63470) NAME
  210 RETURN
C
C     SUBSTRUCTURE NAME WAS DUPLICATED
C
 6104 CALL SMSG (4,0,NAME)
      RETURN
C
C     INSUFFICIENT CORE
C
 9008 CALL MESAGE (-8,0,SUBR)
      RETURN
C
C     MESSAGE TEXT
C
63470 FORMAT (49H0*** USER INFORMATION MESSAGE 6347, SUBSTRUCTURE ,
     1        2A4,18H ADDED TO THE SOF.)
63471 FORMAT (5X, 25HHIGHER LEVEL SUBSTRUCTURE,2X,2A4)
63472 FORMAT (5X, 25HCOMBINED SUBSTRUCTURE    ,6(2X,2A4))
63473 FORMAT (5X, 25HLOWER LEVEL SUBSTRUCTURE ,7(2X,2A4))
63590 FORMAT (49H0*** USER INFORMATION MESSAGE 6359, SUBSTRUCTURE ,
     1        2A4,41H WAS ORIGINALLY A SECONDARY SUBSTRUCTURE./36X,
     2        42HON THIS SOF, IT IS A PRIMARY SUBSTRUCTURE.)
      END

        SUBROUTINE SKPFIL ( FILE, N )
      INCLUDE 'DSIOF.COM'
        INTEGER FILE
        IF ( N .EQ. 0 ) GO TO 7777
        NAME = FILE
        CALL DSGEFL
        IRWORD = N
        IF ( N .GT. 0 ) GO TO 20
        IF ( ( INDCLR-INDBAS ) .NE. 5 ) GO TO 10
        IF ( NBLOCK .EQ. 1 ) GO TO 7000
10      CALL DSSKFB( N )
        GO TO 7000
20      IF ( IPRVOP .NE. 0 ) CALL DSMSG( 4 )
        CALL DSSKFF( N )
7000    CALL DSSDCB
7777    RETURN
        END

      SUBROUTINE IHEXS (TYPE)
C
C     SINGLE PRECISION VERSION
C
C     THIS ROUTINE PROCESSES IHEX1, IHEX2, AND IHEX3 ELEMENT DATA TO
C     PRODUCE STIFFNESS AND MASS MATRICES.  IF THE HEAT TRANSFER OPTION
C     IS ON, CONDUCTIVITY AND CAPACITY MATRICES ARE PRODUCED.  IF THE
C     DISPLACEMENT VECTOR POINTER IS NON-ZERO, THE DIFFERENTIAL
C     STIFFNESS MATRIX ONLY IS PRODUCED.
C
C           TYPE = 1    IHEX1
C           TYPE = 2    IHEX2
C           TYPE = 3    IHEX3
C
C           THE EST ENTRIES ARE
C
C     NAME  ----------INDEX----------   DESCRIPTION
C            IHEX1    IHEX2    IHEX3
C
C     EID        1        1        1    ELEMENT ID NO.
C     SIL      2-9     2-21     2-33    SCALAR INDEX LIST
C     MID       10       22       34    MATERIAL ID NO.
C     CID       11       23       35    MATERIAL COORD. SYSTEM ID NO.
C     NIP       12       24       36    NO. INTEGRATION POINTS PER EDGE
C     MAXAR     13       25       37    MAX ASPECT RATIO
C     ALFA      14       26       38    MAX ANGLE FOR NORMALS
C     BETA      15       27       39    MAX ANGLE FOR MIDSIDE POINTS
C     BGPDT  16-47   28-107   40-167    BASIC GRID POINT DATA
C     GPT    48-55  108-127  168-199    GRID POINT TEMPERATURES
C
C     - INSTALLATION NOTE --
C     GPTLD IS SUPPOSED TO CONTAIN GRID POINT TEMPERATURE LOADS FOR
C     COMPUTING DIFFERENTIAL STIFFNESS.  FOR INSTALLATION, GPTLD MUST
C     BE LOADED WITH DATA BY EMG.  IF GPTLD(1)=-1, NO TEMP LOAD IS
C     ASSUMED.
C
      LOGICAL          ANIS       ,RECT       ,TDEP       ,DIAG       ,
     1                 MTDEP      ,HEAT1      ,NOGO       ,NOCSTM
      INTEGER          HEAT       ,EID        ,SIL(1)     ,SCR4       ,
     1                 TYPE       ,JZ(1)      ,CID        ,IEST(1)    ,
     2                 BCORD      ,BGPDT      ,GPT        ,NC(8)      ,
     3                 EDGE       ,FACE       ,IB(46)     ,ELNO(3)    ,
     4                 EXCD(3)    ,TWINS(9)   ,RVRS(5)    ,IWORK(1)   ,
     5                 BACK       ,OTPT       ,UGV        ,CDAMP      ,
     6                 DICT(40)
      REAL             NU         ,KHEAT      ,MAXAR      ,DMAXAR(3)  ,
     1                 DALFA(3)   ,DBETA(2)   ,EVEC(3,12) ,WORK(66)   ,
     2                 VN(3,2)    ,GPTLD(32)  ,BCD2(3)    ,JACOB(3,3)
      DIMENSION        Z(1)       ,S(4)       ,H(4)       ,GAUSS(8)   ,
     1                 PART(3,3)  ,TF(3,3)    ,TK(3,3)    ,SIG(6)     ,
     2                 STR(18)    ,C(3,3)     ,GMAT(36)   ,DALPHA(6)  ,
     3                 STORE(45)
      CHARACTER        UFM*23
      COMMON /XMSSG /  UFM
      COMMON /MATIN/   MID        ,INFLAG     ,TEMP
      COMMON /MATOUT/  E          ,G          ,NU         ,RHO        ,
     1                 TALPHA     ,TREF       ,CDAMP      ,SPACE(18)  ,
     3                 MTDEP
      COMMON /MATISO/  BUFM6(46)
C     OMMON  /MATISO/  G11,G12,G13,...,G46,G56,G66,RHO,AXX,AYY,AZZ,AXY,
C                      AYZ,AZX,TREF,GE,IER
      COMMON /BLANK /  SKIP16(16) ,VOLUME     ,SURFAC
      COMMON /HMTOUT/  KHEAT(6)   ,CP
C     COMMON /EMG***/  ...,UGV,...
C
C     - INSTALLATION NOTE --
C     UGV POINTS TO BEGINNING OF SINGLE PRECISION GLOBAL DISPLACEMENT
C     VECTOR IN OPEN CORE ARRAY RZ.
C
      COMMON /EMGPRM/  IEXT       ,IZS        ,NZS         ,DUM(12)   ,
     1                 KGG1       ,MGG1       ,BGG1        ,IPREC     ,
     2                 NOGO       ,HEAT1
C
C     RZ IS OPEN CORE.  USE ONLY RZ(IZS) TO RZ(NZS).
C
      COMMON /ZZZZZZ/  RZ(1)
      COMMON /EMGEST/  EST(200)
      COMMON /SYSTEM/  SYSBUF     ,OTPT       ,SYS1(7)    ,MTEMP
      COMMON /EMGDIC/  SPAC(2)    ,NGRIDS     ,SPAC1      ,IESTID
      EQUIVALENCE      (Z(1),JZ(1),RZ(1))     ,(EID,EST(1),IEST(1))   ,
     1                 (SIL(1),EST(2))        ,(WORK(1),IWORK(1))     ,
     2                 (SIG(1),SX)            ,(SIG(2),SY)            ,
     3                 (SIG(3),SZ)            ,(SIG(4),SXY)           ,
     4                 (SIG(5),SYZ)           ,(SIG(6),SZX)           ,
     5                 (DSTLD,IDSTLD)
      EQUIVALENCE      (WORK(1),EVEC(1,1))    ,(WORK(37),VN(1,1))     ,
     1                 (WORK(43),NC(1))
      EQUIVALENCE      (WORK(1),JACOB(1,1))   ,(WORK(19),H(1))        ,
     1                 (WORK(27),S(1))        ,(WORK(35),PART(1,1))   ,
     2                 (WORK(53),SIG(1))      ,(WORK(1),C(1,1))
      EQUIVALENCE      (WORK(1),TF(1,1))      ,(WORK(35),TK(1,1))
      EQUIVALENCE      (IB(1),BUFM6(1))
      DATA    SCR4  /  304 /
      DATA    BCD1  ,  BCD2/ 4HCIHE, 4HX1  , 4HX2  , 4HX3   /
      DATA    DMAXAR,  DALFA,DBETA / 5.0   ,10.0   ,15.0    ,
     1                               45.0  ,45.0   ,45.0    ,
     2                                      45.0   ,45.0    /
      DATA    DTOR  ,  GAUSS  /0.01745329251994,
     1                         0.57735026918962,
     2                         0.55555555555555,
     3                         0.77459666924148,
     4                         0.88888888888889,
     5                         0.34785484513745,
     6                         0.86113631159405,
     7                         0.65214515486254,
     8                         0.33998104358485/
      DATA    IHEX,ELNO       /4HIHEX,4H ELE,4HMENT,4H NO./
      DATA    BAR,BALFA,BBETA /4H  AR,4HALFA,4HBETA/
      DATA    EXCD            /4H EXC,4HEEDE,4HD.  /
      DATA    RVRS            /4HREVE,4HRSED,4H NUM,4HBERI,4HNG. /
      DATA    TWINS           /4HCOOR,4HDINA,4HTES ,4HOF T,4HWO P,
     1                         4HOINT,4HS AR,4HE SA,4HME. /
      DATA    NERR1,NERR2     /3301, 3302 /
C
C     IZ AND NZ ARE OPEN CORE POINTERS
C
      IZ = IZS
      NZ = NZS
C
C     THIS ROUTINE OPERATES IN DOUBLE PRECISION.
C     EMGOUT WILL PRODUCE THE REQUIRED MATRIX IN THE REQUESTED PRECISION
C
C     ALLOCATE LARGE ARRAYS IN OPEN CORE
C
      NGP  = 12*TYPE - 4
      HEAT = 0
      KGG  = 0
      MGG  = 0
      IF (HEAT1) HEAT = 1
      IF (KGG1 .NE. 0) KGG = 1
      IF (MGG1 .NE. 0) MGG = 1
      NGRIDS = NGP
      UGV  = 0
      NGG  = 3*NGP
      DICT(1) = IESTID
      DICT(2) = 1
      IF (.NOT.HEAT1) GO TO 5
      DICT(3) = NGP
      DICT(4) = 1
      GO TO 30
    5 DICT(3) = NGG
      DICT(4) = 7
      IF (KGG .LE. 0) GO TO 10
      IK = IZ + 3*NGG
      NK = IK - 1 + (NGG+1)*NGG/2
      GO TO 20
   10 IK = IZ
      NK = IK + 3*NGG - 1
      IM = NK + 1
      NM = (NGP+1)*NGP/2 + NK
      GO TO 40
   20 NM = NK
      IF (MGG .LE. 0) GO TO 40
      IM = NK + 1
      NM = NK + (NGP+1)*NGP/2
      GO TO 40
   30 IK = IZ + 17
      NK = IK - 1 + NGP**2
      IM = NK + 1
      NM = IM - 1 + NGP**2
      NGG= NGP
   40 IN = NM + 1
      IG = IN + NGP
      IX = IG + 3*NGP
      ND = NM + 9*NGP
      IF (UGV .EQ. 0) GO TO 50
      ID = ND + 1
      ND = ID + NGG - 1
   50 IF (ND .LE. NZ) GO TO 100
      WRITE (OTPT,7100) UFM,NERR1,IHEX,TYPE,ELNO,EID
      NOGO = .TRUE.
C
C     ***** OPEN CORE MAP *****
C
C     DOUBLE PRECISION Z(1)
C     COMMON /EMGZZZ/  Z
C
C     NGG = ORDER OF ELEMENT MATRIX
C
C     INDEX      STIFFNESS             MASS                HEAT
C                AND MASS              ONLY              TRANSFER
C
C     IZ    NGG BY 3 PARTITION  NGG BY 3 PARTITION  FOUR WORD COORDINATE
C           OF MATRIX           OF MATRIX           VECTOR.  INPUT TO
C                                                   TRANSD
C
C     IZ+2                                          TRANSFORMED THERMAL
C                                                   CONDUCTANCE MATRIX
C
C     IT                                            MATERIAL TRANSFOR-
C                                                   MATION MATRIX
C
C     IK    SYMMETRIC HALF OF   SAME AS IZ          FULL CONDUCTANCE
C           STIFFNESS
C
C     IM    SYMMETRIC HALF OF   SYMMETRIC HALF OF   FULL CAPACITANCE
C           MASS                MASS
C
C     IN    --------------------SHAPE FUNCTIONS-------------------------
C
C     IG    --------------------D(SHAPE)/D(GREEK)-----------------------
C
C     IX    --------------------D(SHAPE)/D(BASIC XYZ)-------------------
C
C     ID    DISPLACEMENT
C           VECTOR IN BASIC
C           COORDINATES
C
C     CHECK GEOMETRY.  THE FOLLOWING CHECKS ARE MADE
C           1.  ASPECT RATIO
C           2.  ANGLES BETWEEN NORMALS OF SUB-TRIANGLES ON EACH FACE
C           3.  ANGLES BETWEEN VECTORS BETWEEN POINTS ALONG EACH EDGE
C           4.  REVERSE SEQUENCING
C           5.  DUPLICATE COORDINATE VALUES
C
C     FETCH EPT DATA, COMPUTE EST POINTERS
C
  100 MID  = 10 + 12*(TYPE-1)
      CID  = IEST(MID+1)
      NIP  = IEST(MID+2)
      MAXAR= EST(MID+3)
      ALFA = EST(MID+4)
      BETA = EST(MID+5)
      BGPDT= MID + 6
      GPT  = BGPDT + NGP*4
      MID  = IEST(MID)
      IF (NIP.LT.2 .OR. NIP.GT.4) NIP = TYPE/2 + 2
      IF (MAXAR .LE. 0.0) MAXAR = DMAXAR(TYPE)
      IF (ALFA  .LT. 0.0) ALFA  = DALFA(TYPE)
      IF (BETA.LT.0.0 .AND. TYPE.NE.1) BETA = DBETA(TYPE-1)
      ALFA = COS(DTOR*ALFA)
      BETA = COS(DTOR*BETA)
      IF (UGV .EQ. 0) GO TO 105
C
C     TRANSFORM DISPLACEMENT VECTOR TO BASIC COORDINATES
C     MULTIPLY BY 1/4 TO AVOID MULTIPLYING STRAIN-DISPLACEMENT
C     RELATIONS BY 1/2 UNDER THE INTEGRAL.  DITTO FOR LOADING TEMP-S.
C
      DSTLD = GPTLD(1)
      DO 104 I = 1,NGP
      M = BGPDT + 4*I - 4
      J = UGV + SIL(I) - 1
      K = ID + 3*I - 3
      IF (IEST(M) .EQ. 0) GO TO 102
      CALL TRANSS (EST(M),TK)
      DO 101 L = 1,3
  101 Z(IZ+L-1) = RZ(J+L-1)*0.25
      CALL GMMATS (TK,3,3,0,Z(IZ),3,1,0,Z(N))
      GPTLD(I) = 0.25*GPTLD(I)
      GO TO 104
  102 DO 103 L = 1,3
  103 Z(N+L-1) = RZ(J+L-1)*0.25
      GPTLD(I) = 0.25*GPTLD(I)
  104 CONTINUE
C
C     REARRANGE BGPDT
C
  105 DO 110 I = 1,NGP
  110 JZ(IZS+I) = IEST(BGPDT+I*4-4)
      BCORD = GPT - 3
      DO 120 I = 2,NGP
      DO 120 J = 1,3
      K = BGPDT + 4*(NGP-I) + 4 - J
      BCORD = BCORD - 1
      EST(BCORD) = EST(K)
  120 CONTINUE
      DO 130 I = 2,NGP
  130 IEST(BGPDT+I-1) = JZ(IZS+I)
C
C     IF COMPUTING DIFFERENTIAL STIFFNESS, SKIP CHECKS
C
      IF (UGV .GT. 0) GO TO 500
C
C     FIND 8 POINTERS TO CORNER COORDINATES IN EST
C
C     EDGE        CORNERS
C       1         1     2
C       2         2     3
C       3         3     4
C       4         4     1
C       5         1     5
C       6         2     6
C       7         3     7
C       8         4     8
C       9         5     6
C      10         6     7
C      11         7     8
C      12         8     5
C
      NC(1) = BCORD
      J = 3*TYPE
      GO TO (140,150,160), TYPE
  140 NC(5) = BCORD + 12
      GO TO 170
  150 NC(5) = BCORD + 36
      GO TO 170
  160 NC(5) = BCORD + 60
  170 DO 180 I = 2,4
      NC(I  ) = NC(I-1) + J
  180 NC(I+4) = NC(I+3) + J
C
C     COMPUTE 12 EDGE VECTORS, FIND SMALLEST AND LARGEST MAGNITUDES
C
      I = 0
      J = 1
      SMAG = 1.0E+20
      BMAG = 0.0
      DO 250 EDGE = 1,12
      GO TO (190,190,190,200,210,190,190,190,220,190,190,200), EDGE
  190 I = I + 1
      J = J + 1
      L = NC(I) - 1
      M = NC(J) - 1
      GO TO 230
  200 L = M
      M = NC(J-3) - 1
      GO TO 230
  210 I = 0
      J = 4
      GO TO 190
  220 I = 4
      J = 5
      GO TO 190
  230 TMAG = 0.0
      DO 240 K = 1,3
      EVEC(K,EDGE) = EST(M+K) - EST(L+K)
  240 TMAG = TMAG + EVEC(K,EDGE)**2
      IF (TMAG .LT. SMAG) SMAG = TMAG
      IF (TMAG .GT. BMAG) BMAG = TMAG
  250 CONTINUE
C
C     CHECK ASPECT RATIO
C
      IF (SMAG .GT. 0.0) GO TO 260
      SMAG = 1.0E-10
  260 IF (BMAG/SMAG .LE. MAXAR**2) GO TO 265
      WRITE (OTPT,7200) UFM,NERR2,IHEX,TYPE,ELNO,EID,BAR,EXCD
      NOGO = .TRUE.
C
C     CHECK ANGLES BETWEEN FACE NORMALS
C
C     FACE              CORNERS
C       1         1     4     3     2
C       2         1     2     6     5
C       3         2     3     7     6
C       4         3     4     8     7
C       5         4     1     5     8
C       6         5     6     7     8
C
  265 DO 350 FACE = 1,6
      GO TO (270,280,290,290,300,310), FACE
  270 I = 1
      J = 4
      K = 3
      L = 2
      GO TO 320
  280 I = 1
      J = 6
      K = 9
      L = 5
      GO TO 320
  290 I = I + 1
      J = J + 1
      K = K + 1
      L = L + 1
      GO TO 320
  300 I = 4
      J = 5
      K = 12
      L = 8
      GO TO 320
  310 I = 12
      J = 9
      K = 10
      L = 11
  320 DO 340 N = 1,2
      VN(1,1) = EVEC(2,I)*EVEC(3,J) - EVEC(3,I)*EVEC(2,J)
      VN(2,1) = EVEC(3,I)*EVEC(1,J) - EVEC(1,I)*EVEC(3,J)
      VN(3,1) = EVEC(1,I)*EVEC(2,J) - EVEC(2,I)*EVEC(1,J)
      VN(1,2) = EVEC(2,K)*EVEC(3,L) - EVEC(3,K)*EVEC(2,L)
      VN(2,2) = EVEC(3,K)*EVEC(1,L) - EVEC(1,K)*EVEC(3,L)
      VN(3,2) = EVEC(1,K)*EVEC(2,L) - EVEC(2,K)*EVEC(1,L)
      SMAG = 0.0
      BMAG = 0.0
      TMAG = 0.0
      DO 330 M = 1,3
      SMAG = SMAG + VN(M,1)**2
      BMAG = BMAG + VN(M,2)**2
  330 TMAG = VN(M,1)*VN(M,2) + TMAG
      SMAG = SQRT(SMAG*BMAG)
      IF (SMAG .EQ. 0.0) GO TO 335
C
C     EPSILON INTRODUCED TO OVERCOME ROUNDOUT ERROR
C
      IF (TMAG/SMAG .GE. 0.99*ALFA) GO TO 335
      WRITE (OTPT,7200) UFM,NERR2,IHEX,TYPE,ELNO,EID,BALFA,EXCD
      NOGO = .TRUE.
  335 M = I
      I = L
      L = K
      K = J
      J = M
  340 CONTINUE
  350 CONTINUE
C
C     CHECK MID-EDGE POINTS
C
      IF (TYPE .EQ. 1) GO TO 455
      M = 1
      DO 450 EDGE = 1,12
      GO TO (370,370,370,370,380,390,390,390,400,370,370,370), EDGE
  370 I = NC(M)
      J = I + 3
      K = J + 3
      L = K + 3
      M = M + 1
      IF (EDGE.NE.4 .AND. EDGE.NE.12) GO TO 410
      IF (TYPE .EQ. 2) K = NC(M-4)
      IF (TYPE .EQ. 3) L = NC(M-4)
      GO TO 410
  380 M = 0
  390 M = M + 1
      I = NC(M)
      J = I + 12*TYPE - 3*(M-1)*(TYPE-1)
      K = J + 12
      K = K + 3*(M-1)*(3-TYPE)
      L = NC(M+4)
      GO TO 410
  400 M = 5
      GO TO 370
  410 SMAG = 0.0
      BMAG = 0.0
      TMAG = 0.0
      DO 420 N = 1,3
      VN(N,1) = EST(J+N-1) - EST(I+N-1)
      VN(N,2) = EST(K+N-1) - EST(J+N-1)
      TMAG = TMAG + VN(N,1)*VN(N,2)
      SMAG = SMAG + VN(N,1)**2
  420 BMAG = BMAG + VN(N,2)**2
      SMAG = SQRT(SMAG*BMAG)
      IF (SMAG .EQ. 0.0) GO TO 430
      IF (TMAG/SMAG .GE. BETA) GO TO 430
      GO TO 445
  430 IF (TYPE .EQ. 2) GO TO 450
      TMAG = 0.0
      SMAG = 0.0
      DO 440 N = 1,3
      VN(N,1) = EST(L+N-1) - EST(K+N-1)
      TMAG = TMAG + VN(N,1)*VN(N,2)
  440 SMAG = SMAG + VN(N,1)**2
      SMAG = SQRT(SMAG*BMAG)
      IF (SMAG .EQ. 0.0) GO TO 450
      IF (TMAG/SMAG .GE. BETA) GO TO 450
  445 WRITE (OTPT,7200) UFM,NERR2,IHEX,TYPE,ELNO,EID,BBETA,EXCD
      NOGO = .TRUE.
  450 CONTINUE
C
C     CHECK FOR LEFT-HANDED ELEMENT COORDINATE SYSTEM
C
C     VOL = EVEC(5)*(EVEC(1) X -EVEC(4))
C
  455 VN(1,1) = EVEC(2,4)*EVEC(3,1) - EVEC(3,4)*EVEC(2,1)
      VN(2,1) = EVEC(3,4)*EVEC(1,1) - EVEC(1,4)*EVEC(3,1)
      VN(3,1) = EVEC(1,4)*EVEC(2,1) - EVEC(2,4)*EVEC(1,1)
      TMAG    = 0.0
      DO 460 I = 1,3
  460 TMAG = TMAG + EVEC(I,5)*VN(I,1)
      IF (TMAG .GT. 0.0) GO TO 470
      WRITE (OTPT,7200) UFM,NERR2,IHEX,TYPE,ELNO,EID,RVRS
      NOGO = .TRUE.
C
C     CHECK FOR DUPLICATE COORDINATE VALUES
C
  470 L = NGP - 1
      DO 490 I = 1,L
      M = BCORD + 3*(I-1)
      K = I + 1
      DO 480 J = K,NGP
      N = BCORD + 3*(J-1)
      IF (EST(M  ) .NE. EST(N  )) GO TO 480
      IF (EST(M+1) .NE. EST(N+1)) GO TO 480
      IF (EST(M+2) .NE. EST(N+2)) GO TO 480
      WRITE (OTPT,7200) UFM,NERR2,IHEX,TYPE,ELNO,EID,TWINS
      NOGO = .TRUE.
  480 CONTINUE
  490 CONTINUE
C
C     IF NOGO FLAG ON, DON T COMPUTE ELEMENT MATRICES
C
      IF (NOGO) RETURN
C
C     INITIALIZE FOR NUMERICAL INTEGRATION
C
C     ABSCISSAE AND WEIGHT COEFFICIENTS FOR GAUSSIAN QUADRATURE
C
  500 I = NIP - 1
      GO TO (510,520,530), I
  510 H(1) = 1.0
      S(1) = GAUSS(1)
      H(2) = 1.0
      S(2) =-GAUSS(1)
      GO TO 540
  520 H(1) = GAUSS(2)
      S(1) = GAUSS(3)
      H(2) = GAUSS(4)
      S(2) = 0.0
      H(3) = GAUSS(2)
      S(3) =-GAUSS(3)
      GO TO 540
  530 H(1) = GAUSS(5)
      S(1) = GAUSS(6)
      H(2) = GAUSS(7)
      S(2) = GAUSS(8)
      H(3) = GAUSS(7)
      S(3) =-GAUSS(8)
      H(4) = GAUSS(5)
      S(4) =-GAUSS(6)
C
C     GENERATE TABLE OF EQUIVALENTS IN SIL ARRAY SO MATRIX WILL BE
C     ORDERED ACCORDING TO INCREASING SIL NUMBERS
C
  540 I = -NGP
  545 J =  0
      DO 560 K = 1,NGP
      IF (SIL(K) .LT. J) GO TO 560
      J = SIL(K)
      L = K
  560 CONTINUE
      SIL(L) = I
      I = I + 1
      IF (I .LT. 0) GO TO 545
      DO 570 I = 1,NGP
  570 SIL(I) = -SIL(I)
C
C     NOW SIL(I) = PARTITION NUMBER OF ELEMENT GRID POINT I
C
C     ZERO OUT OPEN CORE FOR MATRIX SUMMATION
C
      DO 580 I = IK,NM
  580 Z(I) = 0.0
C
C     BRANCH ON HEAT TRANSFER FLAG
C
      IF (HEAT .EQ. 1) GO TO 3000
C
C     FETCH MATERIAL PROPERTIES
C
C     =============================================================
C     THIS SECTION OF CODE MUST BE UPDATED WHEN GENERAL ANISOTROPIC
C     MATERIAL IS ADDED.
C
C     TEST FOR ANISOTROPIC MATERIAL
C
      INFLAG = 10
      ANIS   =.FALSE.
C
C     TEST FOR RECTANGULAR COORDINATE SYSTEM IN WHICH THE ANISOTROPIC
C     MATERIAL IS DEFINED
C
      RECT = .TRUE.
C     ===============================================================
C
C     CHECK FOR TEMPERATURE DEPENDENCE
C
      TDEP = .TRUE.
      DO 610 I = 2,NGP
      IF (EST(GPT) .NE. EST(GPT+I-1)) GO TO 630
  610 CONTINUE
      TDEP = .FALSE.
  630 TEMP = EST(GPT)
      CALL MAT (EID)
      IF (.NOT.MTDEP) TDEP = .FALSE.
      IF (IB(46) .EQ. 6) ANIS = .TRUE.
      IF (KGG .LE. 0) GO TO 1000
C
C     IF ISOTROPIC, TEMPERATURE INDEPENDENT MATERIAL, COMPUTE CONSTANTS
C
      IF (ANIS .OR. TDEP) GO TO 1000
      IF (IB(46) .NE.  0) GO TO 640
      WRITE (OTPT,7300) UFM,MID,EID
      NOGO = .TRUE.
      RETURN
C
C     SET UP FOR EASY MULTIPLICATION IF MATERIALS ARE ON MAT1
C
  640 E1 = BUFM6(1)
      E2 = BUFM6(2)
      E3 = BUFM6(22)
C
C     ============================================================
C     CODE TO TRANSFORM GENERAL ANISOTROPIC MATERIAL PROPERTIES TO
C     BASIC COORDINATE SYSTEM MUST BE ADDED HERE.
C     ============================================================
C
C     ALL SET TO BEGIN INTEGRATION LOOPS.  DO IT.
C
 1000 TVOL = 0.0
      DO 2000 I = 1,NIP
      DO 2000 J = 1,NIP
      DO 2000 K = 1,NIP
C
C     GENERATE SHAPE FUNCTIONS AND JACOBIAN MATRIX INVERSE
C
      CALL IHEXSS (TYPE,Z(IN),Z(IG),JACOB,DETJ,EID,S(I),S(J),S(K),
     1             EST(BCORD))
      IF (DETJ .NE. 0.0) GO TO 1010
C
C     BAD ELEMENT IF FALL HERE.  JACOBIAN MATRIX WAS SINGULAR.
C
      NOGO = .TRUE.
      RETURN
C
 1010 SFACT = H(I)*H(J)*H(K)*DETJ
      TVOL  = TVOL + SFACT
      IF (KGG .LE. 0) GO TO 1015
C
C     STIFFNESS
C
C     COMPUTE STRAIN-DISPLACEMENT RELATIONS
C
C     MUST REVERSE CALLING ORDER SINCE MATRICES ARE STORED BY COLUMNS
C
      CALL GMMATS (Z(IG),NGP,3,0,JACOB,3,3,0,Z(IX))
C
C     IF MATERIAL IS TEMPERATURE DEPENDENT, MUST COMPUTE TEMPERATURE
C     AT THIS INTEGRATION POINT AND FETCH MATERIAL PROPERTIES AGAIN
C
 1015 IF (.NOT. TDEP) GO TO 1030
      TEMP = 0.0
      DO 1020 L = 1,NGP
 1020 TEMP = TEMP + Z(IN+L-1)*EST(GPT+L-1)
      CALL MAT (EID)
      IF (KGG .LE. 0) GO TO 1100
      IF (ANIS) GO TO 1040
      IF (IB(46) .NE. 0) GO TO 1025
      WRITE (OTPT,7300) UFM,MID,EID
      NOGO = .TRUE.
      RETURN
C
 1025 E1 = BUFM6(1)
      E2 = BUFM6(2)
      E3 = BUFM6(22)
      GO TO 1100
 1030 IF (KGG .LE. 0) GO TO 1100
C
C     IF MATERIAL IS ANISOTROPIC AND NOT DEFINED IN RECTANGULAR COOR-
C     DINATE SYSTEM, MUST TRANSFORM TO BASIC COORDINATE SYSTEM AT THIS
C     INTEGRATION POINT
C     IN THIS VERSION, ANISOTROPIC MATERIAL SYSTEMS MUST BE RECTANGULAR.
C     THEREFORE, NO FURTHER TRANSFORMATIONS ARE NECESSARY
C
C
C     ================================================================
C     THIS CODE MUST BE COMPLETED WHEN GENERAL ANISOTROPIC MATERIAL IS
C     ADDED
C
      IF (.NOT.ANIS) GO TO 1100
 1040 CONTINUE
C
C     INSERT GLOBAL TO BASIC TRANSFORMATION OPERATIONS HERE FOR
C     ANISOTROPIC MATERIAL MATRIX
C     =============+==================================================
C
      DO 1041 IJK = 1,36
 1041 GMAT(IJK) = BUFM6(IJK)
      IF (RECT) GO TO 1100
C
C     MATERIAL HAS BEEN EVALUATED FOR THIS INTEGRATION POINT WHEN
C     FALL HERE.
C
 1100 IF (UGV .EQ. 0) GO TO 1170
C
C     COMPUTE STRESSES FOR DIFFERENTIAL STIFFNESS MATRIX
C
C     THERMAL EFFECTS
C
      IF (IDSTLD .EQ. -1) GO TO 1120
      TEMP = 0.0
      DO 1110 L = 1,NGP
 1110 TEMP = TEMP + Z(IN+L-1)*GPTLD(L)
      TEMP = TEMP - TREF
      IF (ANIS) GO TO 1115
      SIG(1) =-TALPHA*(E1+2.0*E2)*TEMP
      SIG(2) = SIG(1)
      SIG(3) = SIG(1)
      SIG(4) = 0.0
      SIG(5) = 0.0
      SIG(6) = 0.0
      GO TO 1140
C     ===========================================================
 1115 CONTINUE
C
C     ADD THERMAL STRESS COMPUTATIONS FOR ANISOTROPIC MATERIAL
C
C     STORE ALPHA IN DOUBLE PRECISION
C
      DO 1116 IJK = 1,6
 1116 DALPHA(IJK) = BUFM6(IJK+37)
C
      CALL GMMATS (GMAT,6,6,0, DALPHA,6,1,0,SIG)
      DO 1117 IJK = 1,6
 1117 SIG(IJK) = -SIG(IJK)*TEMP
      GO TO 1140
C     ===========================================================
 1120 DO 1130 L = 1,6
 1130 SIG(L) = 0.0
C
C     DISPLACEMENT EFFECTS, COMPUTE STRESS MATRIX AND MULTIPLY BY DISPL.
C
 1140 STR(12) = 0.0
      STR(13) = 0.0
      STR(17) = 0.0
      DO 1160 L = 1,NGP
      II = IX + 3*L - 4
      IF (ANIS) GO TO 1145
      STR( 1) = E1*Z(II+1)
      STR( 2) = E2*Z(II+2)
      STR( 3) = E2*Z(II+3)
      STR( 4) = E2*Z(II+1)
      STR( 5) = E1*Z(II+2)
      STR( 6) = E2*Z(II+3)
      STR( 7) = E2*Z(II+1)
      STR( 8) = E2*Z(II+2)
      STR( 9) = E1*Z(II+3)
      STR(10) = E3*Z(II+2)
      STR(11) = E3*Z(II+1)
      STR(14) = E3*Z(II+3)
      STR(15) = E3*Z(II+2)
      STR(16) = E3*Z(II+3)
      STR(18) = E3*Z(II+1)
      GO TO 1150
C     =========================================================
C
 1145 CONTINUE
C
C     ADD STRESS MATRIX COMPUTATION FOR ANISOTROPIC MATERIAL
C
      DO 1146 IJK = 1,18
 1146 STORE(IJK) = 0.
      STORE( 1) = Z(II+1)
      STORE( 5) = Z(II+2)
      STORE( 9) = Z(II+3)
      STORE(10) = Z(II+2)
      STORE(11) = Z(II+1)
      STORE(14) = Z(II+3)
      STORE(15) = Z(II+2)
      STORE(16) = Z(II+3)
      STORE(18) = Z(II+1)
C
      CALL GMMATS (GMAT,6,6,0,STORE(1),6,3,0,STR)
C
C     ============================================================
C
 1150 CALL GMMATS (STR,6,3,-2,Z(ID+3*L-3),3,1,0,SIG)
 1160 CONTINUE
      STR(1) = SX
      SX = SX + SY
      SY = SY + SZ
      SZ = SZ + STR(1)
C
C     NOW BEGIN LOOPS OVER GRID POINTS ALONG ROWS AND COLUMNS
C
 1170 DO 1400 N = 1,NGP
      DO 1400 M = N,NGP
C
C     COMPUTE PARTITION FOR POINTWISE ROW M AND COLUMN N
C
      IF (KGG .LE. 0) GO TO 1300
      IF (.NOT.ANIS ) GO TO 1200
C
C     =================================================================
C     MUST ADD CODE TO COMPUTE THE CONTRIBUTION TO THE STIFFNESS MATRIX
C     FOR ANISOTROPIC MATERIAL HERE
C     =================================================================
C
 1200 IF (SIL(M) .GE. SIL(N)) GO TO 1210
C
C     MUST COMPUTE TRANSPOSE OF THIS PARTITION FOR SUMMATION IN ELEMENT
C     MATRIX
C
      MZ = IX + (N-1)*3
      NZ = IX + (M-1)*3
      GO TO 1220
 1210 MZ = IX + (M-1)*3
      NZ = IX + (N-1)*3
 1220 IF (UGV .EQ. 0) GO TO 1222
C
C     DIFFERENTIAL STIFFNESS
C
      DO 1221 L = 1,3
      DO 1221 INC = 1,3
 1221 C(L,INC) = Z(MZ+INC-1)*Z(NZ+L-1)
      PART(1,1) = SX*C(2,2) + SYZ*(C(2,3)+C(3,2)) + SZ*C(3,3)
      PART(2,2) = SY*C(3,3) + SZX*(C(3,1)+C(1,3)) + SX*C(1,1)
      PART(3,3) = SZ*C(1,1) + SXY*(C(1,2)+C(2,1)) + SY*C(2,2)
      PART(2,1) =-SX*C(2,1) + SXY*C(3,3) -SYZ*C(1,3) - SZX*C(2,3)
      PART(3,1) =-SZ*C(3,1) - SXY*C(3,2) -SYZ*C(2,1) + SZX*C(2,2)
      PART(1,2) =-SX*C(1,2) + SXY*C(3,3) -SYZ*C(3,1) - SZX*C(3,2)
      PART(3,2) =-SY*C(3,2) - SXY*C(3,1) +SYZ*C(1,1) - SZX*C(1,2)
      PART(1,3) =-SZ*C(1,3) - SXY*C(2,3) -SYZ*C(1,2) + SZX*C(2,2)
      PART(2,3) =-SY*C(2,3) - SXY*C(1,3) +SYZ*C(1,1) - SZX*C(2,1)
      GO TO 1228
C
C     ELASTIC STIFFNESS
C
 1222 IF (.NOT.ANIS) GO TO 1226
C
C     STORE CI MATRIX
C
      DO 1223 IJK = 1,18
 1223 STORE(IJK) = 0.
      STORE( 1) = Z(MZ  )
      STORE( 4) = Z(MZ+1)
      STORE( 6) = Z(MZ+2)
      STORE( 8) = Z(MZ+1)
      STORE(10) = Z(MZ  )
      STORE(11) = Z(MZ+2)
      STORE(15) = Z(MZ+2)
      STORE(17) = Z(MZ+1)
      STORE(18) = Z(MZ  )
C
      CALL GMMATS (STORE(1),3,6,0,GMAT(1),6,6,0,STORE(19))
C
C     STORE CJ
C
      DO 1224 IJK = 1,18
 1224 STORE(IJK) = 0.
      STORE( 1) = Z(NZ  )
      STORE( 5) = Z(NZ+1)
      STORE( 9) = Z(NZ+2)
      STORE(10) = Z(NZ+1)
      STORE(11) = Z(NZ  )
      STORE(14) = Z(NZ+2)
      STORE(15) = Z(NZ+1)
      STORE(16) = Z(NZ+2)
      STORE(18) = Z(NZ  )
C
      CALL GMMATS (STORE(19),3,6,0,STORE(1),6,3,0,STORE(37))
      IJKL = 0
      DO 1225 IJK = 1,3
      DO 1225 IJL = 1,3
      IJKL = IJKL + 1
      PART(IJK,IJL) = STORE(IJKL+36)
 1225 CONTINUE
      GO TO 1228
 1226 PART(1,1) = E1*Z(NZ)*Z(MZ) + E3*(Z(NZ+1)*Z(MZ+1) +Z(NZ+2)*Z(MZ+2))
      PART(2,2) = E1*Z(NZ+1)*Z(MZ+1) + E3*(Z(NZ)*Z(MZ) +Z(NZ+2)*Z(MZ+2))
      PART(3,3) = E1*Z(NZ+2)*Z(MZ+2) + E3*(Z(NZ)*Z(MZ) +Z(NZ+1)*Z(MZ+1))
      PART(2,1) = E2*Z(NZ  )*Z(MZ+1) + E3*Z(NZ+1)*Z(MZ  )
      PART(3,1) = E2*Z(NZ  )*Z(MZ+2) + E3*Z(NZ+2)*Z(MZ  )
      PART(1,2) = E2*Z(NZ+1)*Z(MZ  ) + E3*Z(NZ  )*Z(MZ+1)
      PART(3,2) = E2*Z(NZ+1)*Z(MZ+2) + E3*Z(NZ+2)*Z(MZ+1)
      PART(1,3) = E2*Z(NZ+2)*Z(MZ  ) + E3*Z(NZ  )*Z(MZ+2)
      PART(2,3) = E2*Z(NZ+2)*Z(MZ+1) + E3*Z(NZ+1)*Z(MZ+2)
C
C     ADD STIFFNESS PARTITION TO ELEMENT MATRIX
C
C     COMPUTE INDEX INTO OPEN CORE WHERE PART(1,1) IS TO BE ADDED.
C
 1228 IF (SIL(M)-SIL(N)) 1230,1240,1250
 1230 MZ = SIL(N)
      NZ = SIL(M)
      DIAG = .FALSE.
      GO TO 1260
 1240 MZ = SIL(M)
      NZ = SIL(N)
      DIAG = .TRUE.
      GO TO 1260
 1250 MZ = SIL(M)
      NZ = SIL(N)
      DIAG = .FALSE.
C
C     COLUMN NUMBER
C
 1260 L = (NZ-1)*3 + 1
C
C     INCREMENT BETWEEN COLUMNS
C
      INC = NGG - L
C
C     FIRST WORD OF COLUMN
C
      L = IK + ((L-1)*L)/2 + (INC+1)*(L-1)
C
C     WORD IN COLUMN FOR THIS ROW
C
      L = L + 3*(MZ-NZ)
C
C     ADD PARTITION
C
      DO 1280 NZ = 1,3
      DO 1270 MZ = 1,3
      IF (DIAG .AND. MZ.LT.NZ) GO TO 1270
      Z(L+MZ-1) = Z(L+MZ-1) + PART(MZ,NZ)*SFACT
 1270 CONTINUE
      L = L + INC
      INC = INC - 1
 1280 CONTINUE
 1300 IF (MGG .LE. 0) GO TO 1400
C
C     MASS
C
C     COMPUTE TERM FOR MASS MATRIX
C
      RHO = BUFM6(37)
      MZ  = SIL(M)
      NZ  = SIL(N)
      IF (MZ .GE. NZ) GO TO 1310
      MZ  = SIL(N)
      NZ  = SIL(M)
C
C     COMPUTE INDEX INTO OPEN CORE FOR THIS MASS TERM
C
 1310 L = (NZ*(NZ+1))/2 + (NZ-1)*(NGP-NZ) + MZ - NZ + IM - 1
C
C     COMPUTE AND ADD MASS TERM TO ELEMENT MATRIX
C
      Z(L) = Z(L) + RHO*SFACT*Z(IN+M-1)*Z(IN+N-1)
 1400 CONTINUE
 2000 CONTINUE
C
C     END OF INTEGRATION LOOPS
C
      ICODE = 7
C
C     LOOK FOR NON-BASIC COORDINATE SYSTEM
C
      NOCSTM = .FALSE.
      DO 2003 I = 1,NGP
      IF (IEST(BGPDT+I-1) .NE. 0) GO TO 2005
 2003 CONTINUE
      NOCSTM = .TRUE.
      GO TO 2065
C
C     RESTORE GRID POINT DATA TO ORIGINAL FORM FOR DOING TRANSFORM
C     TO GLOBAL COORDINATES
C
C     FIRST, TRANSFER IT TO OPEN CORE AT IN
C
 2005 K = (IN-1)*2 + 1
      J = NGP*4
      DO 2010 I = 1,J
 2010 RZ(K+I-1) = EST(BGPDT+I-1)
C
C     NOW MOVE IT BACK AND REARRANGE IT
C
      DO 2020 I = 1,NGP
      IEST(BGPDT+4*I-4) = JZ(K+I-1)
      DO 2020 J = 1,3
      EST(BGPDT+4*I-4+J) = RZ(K+NGP+3*I+J-4)
 2020 CONTINUE
C
C     FETCH GLOBAL TO BASIC TRANSFORMATION MATRICES
C
      DO 2025 I = 1,NGP
      J = IN + (I-1)*9
      CALL TRANSS (EST(BGPDT+4*I-4),Z(J))
 2025 CONTINUE
      IF (KGG .LE. 0) GO TO 2110
C
C     TRANSFORM STIFFNESS TO GLOBAL COORDINATES
C
      I = 0
 2026 I = I + 1
      ICP = SIL(I)
C
C     COLUMN INDICES
C
      K   = (ICP-1)*3 + 1
      INC = NGG - K + 1
      L   = IK + ((K-1)*K)/2 + INC*(K-1)
      M   = L + INC
      N   = M + INC - 1
C
C     TRANSFORMATION MATRIX INDEX
C
      IGCS = IEST(BGPDT+4*I-4)
      NZ = IN + (I-1)*9
      IF (IGCS .EQ. 0) GO TO 2028
C
C     TERMS ON DIAGONAL PARTITION
C
      ASSIGN 2028 TO BACK
      GO TO 6000
C
C     OFF-DIAGONAL PARTITIONS
C
 2028 L = L + 3
      M = M + 2
      N = N + 1
      IRP = ICP + 1
      IF (IRP .GT. NGP) GO TO 2060
      MZ = NZ
      DO 2050 J = IRP,NGP
      DO 2029 K = 1,NGP
      IF (J .EQ. SIL(K)) GO TO 2031
 2029 CONTINUE
 2031 IF (IGCS .NE. 0) GO TO 2032
      IF (IEST(BGPDT+4*K-4) .EQ. 0) GO TO 2045
 2032 NZ = IN + (K-1)*9
      DO 2030 K = 1,3
      TK(K,1) = 0.0
      TK(K,2) = 0.0
      TK(K,3) = 0.0
      DO 2030 II = 1,3
      TK(K,1) = TK(K,1) + Z(L+II-1)*Z(NZ+3*II+K-4)
      TK(K,2) = TK(K,2) + Z(M+II-1)*Z(NZ+3*II+K-4)
      TK(K,3) = TK(K,3) + Z(N+II-1)*Z(NZ+3*II+K-4)
 2030 CONTINUE
      DO 2040 K = 1,3
      Z(L+K-1) = 0.0
      Z(M+K-1) = 0.0
      Z(N+K-1) = 0.0
      DO 2040 II = 1,3
      Z(L+K-1) = Z(L+K-1) + TK(K,II)*Z(MZ+3*II-3)
      Z(M+K-1) = Z(M+K-1) + TK(K,II)*Z(MZ+3*II-2)
      Z(N+K-1) = Z(N+K-1) + TK(K,II)*Z(MZ+3*II-1)
 2040 CONTINUE
 2045 L = L + 3
      M = M + 3
      N = N + 3
 2050 CONTINUE
 2060 IF (I .LT. NGP) GO TO 2026
C
C     BUILD STIFFNESS PARTITIONS AND PASS TO EMGOUT
C
 2065 IDON = 0
      DO 2100 I = 1,NGP
      IF (I .EQ. NGP) IDON = 1
      DO 2090 J = 1,3
C
C     COLUMN NUMBER
C
      K = (I-1)*3 + J
C
C     NUMBER OF TERMS TO FETCH TO COMPLETE THIS COLUMN IN PARTITION
C
      L = K - 1
      IF (L .EQ. 0) GO TO 2075
C
C     FETCH TERMS AND LOAD INTO J-TH COLUMN OF PARTITION
C
      N   = IK + L
      INC = NGG - 1
      DO 2070 M = 1,L
      Z(IZ+NGG*J-NGG+M-1) = Z(N)
      N   = N + INC
      INC = INC - 1
 2070 CONTINUE
C
C     FILL OUT PARTITION WITH COLUMNS OF STIFFNESS MATRIX
C
C     COMPUTE INDEX IN OPEN CORE OF FIRST TERM OF COLUMN K
C
 2075 N = IK + ((K-1)*K)/2 + (NGG-K+1)*(K-1)
C
C     INSERT THIS COLUMN IN PARTITION
C
      DO 2080 M = K,NGG
      Z(IZ+NGG*J-NGG+M-1) = Z(N)
      N = N + 1
 2080 CONTINUE
 2090 CONTINUE
      DICT(5) = IB(45)
      CALL EMGOUT (Z(IZ),Z(IZ),3*NGG,IDON,DICT,1,1)
 2100 CONTINUE
C
C     EXPAND AND TRANSFORM MASS MATRIX AND PASS TO EMGOUT
C
      IF (MGG .LE. 0) GO TO 2400
 2110 IDON = 0
      DO 2140 I = 1,NGP
      IF (I .EQ. NGP) IDON = 1
      DO 2130 J = 1,NGP
C
C     COMPUTE INDEX INTO OPEN CORE FOR MASS TERM
C
      K = I
      L = J
      IF (I .LE. J) GO TO 2115
      K = J
      L = I
 2115 N = ((K-1)*K)/2 + (K-1)*(NGP-K+1) + L - K + IM
C
C     MULTIPLY GLOBAL TO BASIC TRANSFORMATIONS
C
      M = IZ - NGG+3*J - 4
      IF (I.EQ.J .OR. NOCSTM) GO TO 2116
      IF (IEST(BGPDT+4*I-4) .NE. 0) GO TO 2118
      IF (IEST(BGPDT+4*J-4) .NE. 0) GO TO 2118
 2116 Z(M+NGG  +1) = Z(N)
      Z(M+NGG  +2) = 0.0
      Z(M+NGG  +3) = 0.0
      Z(M+NGG*2+1) = 0.0
      Z(M+NGG*2+2) = Z(N)
      Z(M+NGG*2+3) = 0.0
      Z(M+NGG*3+1) = 0.0
      Z(M+NGG*3+2) = 0.0
      Z(M+NGG*3+3) = Z(N)
      GO TO 2130
 2118 DO 2119 K = 1,NGP
      IF (I .EQ. SIL(K)) MZ = IN + 9*(K-1)
      IF (J .EQ. SIL(K)) NZ = IN + 9*(K-1)
 2119 CONTINUE
      CALL GMMATS (Z(MZ),3,3,1,Z(NZ),3,3,0,TF)
C
C     MULTIPLY BY MASS SCALAR FOR THIS 3 BY 3 PARTITION AND STORE
C     IN NGG BY 3 PARTITION
C
      DO 2120 K = 1,3
      DO 2120 L = 1,3
      Z(M+NGG*L+K) = TF(K,L)*Z(N)
 2120 CONTINUE
 2130 CONTINUE
      DICT(5) = 0
      CALL EMGOUT (Z(IZ),Z(IZ),3*NGG,IDON,DICT,2,1)
 2140 CONTINUE
C
C     SAVE ELEMENT BCD NAME, ID, VOLUME, MASS, NO. OF GRID POINTS, AND
C     GRID POINT DATA IN SCR4 IF USER REQUESTED VOLUME/AREA PRINTOUT
C     (NOTE - MAKE SURE THE GRID POINT DATA, BGPDT, IS IN ISTS ORIGIANL
C      FORM)
C
 2400 IF (VOLUME.LE.0.0 .AND. SURFAC.LE.0.0) GO TO 5000
      IL = IZ*2
      RZ(IL+1) = BCD1
      RZ(IL+2) = BCD2(TYPE)
      JZ(IL+3) = EID
      RZ(IL+4) = TVOL*VOLUME
      RZ(IL+5) = TVOL
      IF (RHO .GT. 0.0) RZ(IL+5) = TVOL*RHO
      JZ(IL+6) = NGP
      K = IL + 6
      DO 2410 I = 1,NGP
      K = K + 1
 2410 RZ(K) = EST(1+I)
      IF (SURFAC .LE. 0.0) GO TO 2460
      IF (.NOT.NOCSTM) GO TO 2440
      L = BGPDT + NGP
      DO 2430 I = 1,NGP
      K = K + 1
      JZ(K) = IEST(BGPDT+I-1)
      DO 2420 J = 1,3
      K = K + 1
      RZ(K) = EST(L)
 2420 L = L + 1
 2430 CONTINUE
      GO TO 2460
 2440 J = NGP*4
      DO 2450 I = 1,J
      K = K + 1
 2450 RZ(K) = EST(BGPDT+I-1)
 2460 L = K - IL
      CALL WRITE (SCR4,RZ(IL+1),L,1)
      GO TO 5000
C
C     HEAT TRANSFER SECTION
C
 3000 INFLAG = 3
      CALL HMAT (EID)
      ANIS = .FALSE.
      IF (KGG .LE. 0) GO TO 3100
C
C     CHECK FOR ANISOTROPY
C
      IF (KHEAT(1).NE.KHEAT(4) .OR. KHEAT(1).NE.KHEAT(6)) GO TO 3010
      IF (KHEAT(2).NE.0.0 .OR. KHEAT(3).NE.0.0 .OR. KHEAT(5).NE.0.0)
     1    GO TO 3010
      GO TO 3100
 3010 ANIS = .TRUE.
      IT = IZ + 8
C
C     CHECK FOR RECTANGULAR COORDINATE SYSTEM FOR MATERIAL
C
      RECT = .TRUE.
      IF (CID .EQ. 0) GO TO 3100
      JZ(IZS) = CID
      DO 3030 I = 1,3
 3030 RZ(IZS+I) = EST(BCORD+I-1)
      CALL TRANSS (RZ(IZS),Z(IT))
      DO 3040 I = 1,3
 3040 RZ(IZS+I) = -RZ(IZS+I)
      CALL TRANSS (RZ(IZS),Z(IN))
      DO 3050 I = 1,9
      IF (Z(IT+I-1) .NE. Z(IN+I-1)) RECT = .FALSE.
 3050 CONTINUE
C
C     IF NOT DEFINED IN A RECTANGULAR SYSTEM, MUST TRANSFORM INSIDE
C     INTEGRATION LOOPS
C
      IF (.NOT.RECT) GO TO 3100
C
C     TRANSFORM MATERIAL MATRIX TO BASIC SYSTEM
C
      DO 3060 I = 1,6
 3060 Z(IZ+I+1) = KHEAT(I)
      L  = IZ + 2
      M  = L + 3
      N  = M + 2
      NZ = IT
      ASSIGN 3100 TO BACK
      GO TO 6000
C
C     ANISOTROPIC CONDUCTIVITY MATERIAL MATRIX NOW STORED AT RZ(IZ+2)
C     TO RZ(IZ+7)
C
C     ALL SET FOR DOING INTEGRATION.  DO IT.
C
 3100 I = 0
 3101 I = I + 1
      J = 0
 3102 J = J + 1
      K = 0
 3103 K = K + 1
C
C     GENERATE SHAPE FUNCTIONS AND JACOBIAN MATRIX INVERSE
C
      CALL IHEXSS (TYPE,Z(IN),Z(IG),JACOB,DETJ,EID,S(I),S(J),S(K),
     1             EST(BCORD))
      IF (DETJ .NE. 0.0) GO TO 3110
C
C     FALL HERE IF JACOBIAN MATRIX WAS SINGULAR
C
      NOGO = .TRUE.
      RETURN
C
 3110 SFACT = H(I)*H(J)*H(K)*DETJ
      IF (KGG .LE. 0) GO TO 3120
C
C     COMPUTE DERIVATIVES OF SHAPE FUNCTION W.R.T. BASIC SYSTEM.
C
C     MUST REVERSE CALLING ORDER SINCE MATRICES ARE STORED BY COLUMNS
C
      CALL GMMATS (Z(IG),NGP,3,0,JACOB,3,3,0,Z(IX))
C
C     IF MATERIAL IS ANISOTROPIC AND NOT DEFINED IN A RECTANGULAR
C     CORDINATE SYSTEM, MUST TRANSFORM TO BASIC SYSTEM AT THIS
C     INTEGRATION POINT
C
 3120 IF (.NOT.ANIS) GO TO 3160
      IF (RECT) GO TO 3160
C
C     COMPUTE BASIC COORDINATES VECTOR AT THIS POINT
C
      DO 3130 L = 1,3
 3130 RZ(IZS+L) = 0.0
      DO 3140 L = 1,NGP
      DO 3140 M = 1,3
      RZ(IZS+M) = RZ(IZS+M) + Z(IN+L-1)*EST(BCORD + 3*L+M-4)
 3140 CONTINUE
C
C     FETCH TRANSFORMATION AND CONDUCTIVITY MATRICES AND PERFORM
C     TRANSFORMATION OPERATIONS
C
      CALL TRANSS (RZ(IZS),Z(IT))
      DO 3150 L = 1,6
 3150 Z(IZ+L+1) = KHEAT(L)
      NZ = IT
      L  = IZ + 2
      M  = L + 3
      N  = M + 2
      ASSIGN 3160 TO BACK
      GO TO 6000
C
C     MATERIAL HAS BEEN EVALUATED FOR THIS INTEGRATION POINT WHEN
C     FALL HERE
C
C     NOW BEGIN LOOPS OVER GRID POINTS ALONG ROWS AND COLUMNS
C
 3160 DO 3220 N = 1,NGP
      DO 3220 M = N,NGP
C
C     COMPUTE 1 BY 1 PARTITION FOR ROW M AND COLUMN N
C
      IF (KGG .LE. 0) GO TO 3210
C
C     CONDUCTIVITY
C
      IF (ANIS) GO TO 3180
C
C     ISOTROPIC CASE
C
      PRT1 = 0.0
      DO 3170 L = 1,3
 3170 PRT1 = PRT1 + Z(IX+3*M+L-4)*Z(IX+3*N+L-4)
      PRT1 = SFACT*KHEAT(1)*PRT1
      GO TO 3190
C
C     ANISOTROPIC CASE
C
 3180 L  = IX + 3*(M-1)
      E1 = Z(L)*Z(IZ+2) + Z(L+1)*Z(IZ+3) + Z(L+2)*Z(IZ+4)
      E2 = Z(L)*Z(IZ+3) + Z(L+1)*Z(IZ+5) + Z(L+2)*Z(IZ+6)
      E3 = Z(L)*Z(IZ+4) + Z(L+1)*Z(IZ+6) + Z(L+2)*Z(IZ+7)
      L  = IX + 3*(N-1)
      PRT1 = SFACT*(Z(L)*E1 + Z(L+1)*E2 + Z(L+2)*E3)
C
C     COMPUTE INDEX INTO OPEN CORE FOR THIS TERM
C
 3190 L  = SIL(M)
      MZ = SIL(N)
      IF (L .LE. MZ) GO TO 3200
      L  = MZ
      MZ = SIL(M)
 3200 L  = (L-1)*NGG + MZ + IK - 1
C
C     ADD TERM TO MATRIX
C
      Z(L) = Z(L) + PRT1
C
C     CAPACITANCE
C
 3210 IF (MGG .LE. 0) GO TO 3220
C
C     COMPUTE INDEX INTO OPEN CORE FOR THIS TERM
C
      L  = SIL(M)
      MZ = SIL(N)
      IF (L .LE. MZ) GO TO 3215
      L  = MZ
      MZ = SIL(M)
 3215 L  = (L-1)*NGG + MZ + IM - 1
C
C     COMPUTE AND ADD TERM
C
      Z(L) = Z(L) + SFACT*CP*Z(IN+M-1)*Z(IN+N-1)
 3220 CONTINUE
      IF (K .LT. NIP) GO TO 3103
      IF (J .LT. NIP) GO TO 3102
      IF (I .LT. NIP) GO TO 3101
C
C     END OF HEAT TRANSFER INTEGRATION LOOPS
C
      ICODE = 1
C
C     FILL IN THE UPPER TRIANGLES OF THE MATRICES
C
      IF (KGG .LE. 0) GO TO 4010
      MZ = IK
      GO TO 4020
 4010 IF (MGG .LE. 0) GO TO 4040
      MZ = IM
 4020 L  = NGG - 1
      DO 4030 I = 1,L
      J  = I + 1
      DO 4030 K = J,NGG
      M  = (I-1)*NGG + K + MZ - 1
      N  = (K-1)*NGG + I + MZ - 1
      Z(N) = Z(M)
 4030 CONTINUE
      IF (MZ .EQ. IK) GO TO 4010
C
C     PASS MATRICES TO EMGOUT
C
 4040 K = NGG**2
      DICT(5) = 0
      IF (KGG .GT. 0) CALL EMGOUT (Z(IK),Z(IK),K,1,DICT,1,1)
      IF (MGG .GT. 0) CALL EMGOUT (Z(IM),Z(IM),K,1,DICT,3,1)
C
C     ALL DONE, NO ERRORS
C
 5000 RETURN
C
C
C     INTERNAL SUBROUTINE
C
C     TRANSFORM COORDINATE SYSTEM OF SYMMETRIC HALF OF A 3 BY 3 MATRIX
C
 6000 TK(1,1) = Z(NZ  )*Z(L  )  + Z(NZ+3)*Z(L+1)  + Z(NZ+6)*Z(L+2)
      TK(2,1) = Z(NZ+1)*Z(L  )  + Z(NZ+4)*Z(L+1)  + Z(NZ+7)*Z(L+2)
      TK(3,1) = Z(NZ+2)*Z(L  )  + Z(NZ+5)*Z(L+1)  + Z(NZ+8)*Z(L+2)
      TK(1,2) = Z(NZ  )*Z(L+1)  + Z(NZ+3)*Z(M  )  + Z(NZ+6)*Z(M+1)
      TK(2,2) = Z(NZ+1)*Z(L+1)  + Z(NZ+4)*Z(M  )  + Z(NZ+7)*Z(M+1)
      TK(3,2) = Z(NZ+2)*Z(L+1)  + Z(NZ+5)*Z(M  )  + Z(NZ+8)*Z(M+1)
      TK(1,3) = Z(NZ  )*Z(L+2)  + Z(NZ+3)*Z(M+1)  + Z(NZ+6)*Z(N  )
      TK(2,3) = Z(NZ+1)*Z(L+2)  + Z(NZ+4)*Z(M+1)  + Z(NZ+7)*Z(N  )
      TK(3,3) = Z(NZ+2)*Z(L+2)  + Z(NZ+5)*Z(M+1)  + Z(NZ+8)*Z(N  )
      Z(L  )  = Z(NZ  )*TK(1,1) + Z(NZ+3)*TK(1,2) + Z(NZ+6)*TK(1,3)
      Z(L+1)  = Z(NZ  )*TK(2,1) + Z(NZ+3)*TK(2,2) + Z(NZ+6)*TK(2,3)
      Z(L+2)  = Z(NZ  )*TK(3,1) + Z(NZ+3)*TK(3,2) + Z(NZ+6)*TK(3,3)
      Z(M  )  = Z(NZ+1)*TK(2,1) + Z(NZ+4)*TK(2,2) + Z(NZ+7)*TK(2,3)
      Z(M+1)  = Z(NZ+1)*TK(3,1) + Z(NZ+4)*TK(3,2) + Z(NZ+7)*TK(3,3)
      Z(N  )  = Z(NZ+2)*TK(3,1) + Z(NZ+5)*TK(3,2) + Z(NZ+8)*TK(3,3)
      GO TO BACK, (2028,3100,3160)
C
 7100 FORMAT (A23,I5,2H, ,A4,I1,3A4,I9,' INSUFFICIENT CORE TO COMPUTE',
     1       ' ELEMENT MATRIX')
 7200 FORMAT (A23,I5,2H, ,A4,I1,3A4,I9,3X,18HILLEGAL GEOMETRY, ,9A4)
 7300 FORMAT (A23,' 4005. AN ILLEGAL VALUE OF -NU- HAS BEEN SPECIFIED ',
     1       'UNDER MATERIAL ID =',I10,17H FOR ELEMENT ID =,I10)
C
      END

      SUBROUTINE A8 2 INT (*,A,N,B,INT)
C
      CHARACTER*8     C
      REAL            A(2)
      COMMON /XREADX/ NOUT
C
C     THESE ROUTINES PERFORM IN THE OPPOSITE DIRECTION AS THOSE OF THE
C     INT2A8 GROUP OF ROUTINES
C     THIS ROUTINE IS MACHINE INDEPENDENT
C
C     ENTRY POINTS   A8 2 INT  (BCD-INTEGER VERSION)
C                    K8 2 INT  (CHARACTER-INTEGER VERSION)
C                    A8 2 FP   (BCD-REAL VERSION)
C                    K8 2 FP   (CHARACTER-REAL VERSION)
C
      NT = +1
      GO TO 20
C
      ENTRY K8 2 INT (*,C,N,B,INT)
C     ****************************
C
      NT = +1
      GO TO 30
C
      ENTRY A8 2 FP (*,A,N,B,INT)
C     ***************************
C
      NT = -1
C
 20   IF (N .GT. 8) GO TO 50
      INT = NT
      CALL NA12IF (*80,A,N,B,INT)
      RETURN
C
      ENTRY K8 2 FP (*,C,N,B,INT)
C     ***************************
C
      NT = -1
C
 30   IF (N .GT. 8) GO TO 50
      INT = NT
      CALL NK12IF (*80,C,N,B,INT)
      RETURN
C
 50   WRITE  (NOUT,60) N,NT
 60   FORMAT ('  N.GT.8/A82INT',I5,7X,'NT=',I2)
 80   RETURN 1
      END

      SUBROUTINE INT 2 A8 (*,X,A8)
C
      INTEGER         JX,       POWER,    A8(2)
      REAL            RX,       X(1)
      CHARACTER*1     A(10),    IP,       IM,       IB,       PT,
     1                ALP(10)
      CHARACTER*8     K8(1),    TEMP,     ZERO,     ZEROX
      CHARACTER*10    ALP10,    TEMP10
      COMMON /MACHIN/ MACH
      COMMON /SYSTEM/ DUMMY(38),NBPC,     NBPW,     NCPW
      EQUIVALENCE     (TEMP,TEMP10,A(1)), (JX,RX),  (ALP10,ALP(1))
      DATA IP,  IM,  IB,  PT,  TEMP, ZERO, ZEROX, NN, LL, ALP10        /
     1     '+', '-', ' ', '.', 'T',  '0',  '0.0', 0,  0,  '1234567890' /
C
C     THESE ROUTINES ENCODE AN INTEGER OR F.P. NUMBER IN X, TO AN 8-BYTE
C     BCD WORD IN A8, OR AN 8-CHARACTER WORD IN K8, LEFT ADJUSTED.
C     WITH MAXIMUM NUMBERS OF DIGITS SQUEEZED INTO THE 8-BYTE FORMAT.
C
C     ENTRY POINT    INT 2 A8  (INTEGER-BCD VERSION)
C                    INT 2 K8  (INTEGER-CHARACTER VERSION)
C                    FP  2 A8  (REAL-BCD VERSION)
C                    FP  2 K8  (REAL-CHARACTER VERSION)
C
C     WRITTEN BY G.CHAN/UNISYS IN AUG. 1985
C     PARTICULARLY FOR XREAD ROUTINE, IN SUPPORT OF ITS NEW FREE-FIELD
C     INPUT FORMAT.
C     THIS ROUTINE IS MACHINE INDEPENDENT
C
      NT = +1
      GO TO 100
C
      ENTRY INT2K8 (*,X,K8)
C     =====================
C
      NT = -1
      GO TO 100
C
      ENTRY FP2A8 (*,X,A8)
C     ====================
C
      NT = +2
      GO TO 100
C
      ENTRY FP 2 K8 (*,X,K8)
C     ======================
C
      NT = -2
C
 100  INT = IABS(NT)
      DO 110 J = 1,8
 110  A(J) = IP
      A( 9) = IB
      A(10) = IB
      IF (INT .NE. 1) GO TO 200
C
C     INTEGER
C
      LU = 8
      N  = 0
      RX = X(1)
      IX = IABS(JX)
      XLL = FLOAT(IX) + .01
      ABSX = ABS(XLL)
      NN = 0
      IF (JX.GE.0 .AND. IX.LT.10**8) GO TO 140
      IF (JX.LT.0 .AND. IX.LT.10**7) GO TO 140
      RETURN 1
 140  IF (JX) 210,150,220
C
 150  TEMP = ZERO
      GO TO 310
 160  TEMP = ZEROX
      GO TO 310
C
C     F.P. NUMBER
C
 200  ABSX = ABS(X(1))
      IF (ABSX .LT. 1.E-20) GO TO 160
      ABSX = ABSX*(1.0+1.E-20)
      LU = 7
      LL =-3
      N  = 0
      IF (X(1) .GT. 0.) GO TO 220
      LU = LU - 1
      LL = LL + 1
 210  N  = 1
      A(1) = IM
 220  N1 = N
      IF (INT .EQ. 1) GO TO 240
      XLL = ALOG10(ABSX)
      IF (XLL .LT. 0.) XLL = XLL - .99998
      IF (XLL .GT. 0.) XLL = XLL + .00002
      POWER = IFIX(XLL)
      NP1 = POWER + 1
      IP1 = IABS(NP1)
      XLU = 10.**LU
      XLL = 10.**LL
      IF (ABSX.LT.XLL .OR. ABSX.GT.XLU) GO TO 400
C
C     F.P. NUMBER IS SQUEEZED INTO AN EIGHT DIGIT F FORMAT, IF
C     X IS BETWWEN 10**-3 AND 10**7 AND X IS POSITUVE, OR
C          BETWWEN 10**-2 AND 10**6 AND X IS NEGATIVE,
C
 230  IF (IP1 .GE. 10) LU = LU - 1
      IF (NP1 .EQ. -1) LU = LU + 1
      NN = LU - NP1
      IF (INT.EQ.2 .AND. NN.GT.7) NN = 7
      IX = IFIX(ABSX*10.**NN)
 240  LU = LU - 1
      IF (LU.LT.0 .AND. INT.EQ.3) GO TO 420
      IF (LU.LT.0 .AND.   N.EQ.7) GO TO 260
      POWER = 10**LU
      IF (POWER .EQ. 0) POWER = 1
      J  = IX/POWER
      IF (J .GE. 10) GO TO 240
      IX = MOD(IX,POWER)
      IF (LU-NN+1) 280,250,270
 250  IF (INT .EQ. 3) GO TO 420
 260  N  = N + 1
      A(N) = PT
      IF (N .GE. 8) GO TO 290
 270  IF (J.EQ.0 .AND. N.LE.N1) GO TO (240,280,280), INT
 280  IF (J .EQ. 0) J = 10
      N  = N + 1
      A(N) = ALP(J)
      IF (LU.EQ.0 .AND. INT.EQ.1) GO TO 350
      IF (N .LT. 8) GO TO 240
 290  DO 300 J = 1,8
      IF (A(N) .EQ. PT) GO TO 310
      IF (A(N) .NE. ALP(10)) GO TO 310
      A(N) = IB
 300  N  = N - 1
C
 310  IF (NT) 320,440,330
 320  K8(1) = TEMP
      GO TO 440
 330  IF (MACH .NE. 4) CALL KHRBC2 (TEMP,A8(1))
CWKBD IF (MACH .EQ. 4) A8(1) = ISWAP(TEMP10)
C     IF (NCPW .GE. 8) A8(2) = LSHIFT(A8(1),4*NBPC)
      GO TO 440
C
 350  N = N + 1
      IF (N .GT. 8) GO TO 310
      DO 360 J = N,8
 360  A(J) = IB
      GO TO 310
C
C     F.P. NUMBER IN .XXXXX+X, .XXXX-XX, -.XXXX-X, OR -.XXX+XX FORMS
C     FOR MAXIMUM NOS. OF DIGITS POSSIBLE IN AN A8 WROD.
C
 400  INT = 3
      N   = N + 1
      A(N)= PT
      LU  = LU - 2
      GO TO 230
C
 420  N = N + 1
      IF (NP1 .GE. 0) A(N) = IP
      IF (NP1 .LT. 0) A(N) = IM
      IF (IP1 .GE. 10) GO TO 430
      A(N+1) = ALP(IP1)
      GO TO 310
 430  J = IP1/10
      A(N+1) = ALP(J)
      J = MOD(IP1,10)
      IF (J .EQ. 0) J = 10
      A(N+2) = ALP(J)
      GO TO 310
C
 440  RETURN
      END

      SUBROUTINE SROD1
C*****
C THIS ROUTINE IS PHASE I OF STRESS DATA RECOVERY FOR THE ROD.
C*****
C
C
C
      DIMENSION          IECPT(13)
C
C
C
C
C INPUT AND OUTPUT BLOCK
C
      COMMON   /SDR2X5/
     A                   ECPT(17)           ,DUMMY1(83),
     1                   IELID              ,ISILNO(2)
     2,                  SAT(3)             ,SBT(3)
     3,                  SAR(3)             ,SBR(3)
     4,                  ST                 ,SDELTA
     5,                  AREA               ,FJOVRC
     6,                  T SUBC 0           ,SIGMAT
     7,                  SIGMAC             ,SIGMAS
     8,                  SIGVEC(77)         ,FORVEC(25)
C
C SCRATCH BLOCK
C
      COMMON   /SDR2X6/
     1                   XN(6)              ,TI(9)
     2,                  XL                 ,EOVERL
     3,                  IBASE
C
C INPUT AND OUTPUT BLOCKS FOR SUBROUTINE MAT
C
      COMMON   /MATIN/
     1                   MATIDC             ,MATFLG
     2,                  ELTEMP             ,STRESS
     3,                  SINTH              ,COSTH
C
C
C
      COMMON   /MATOUT/
     1                   E                  ,G
     2,                  NU                 ,RHO
     3,                  ALPHA              ,T SUB 0
     4,                  GSUBE              ,SIGT
     5,                  SIGC               ,SIGS
C
C
C
      EQUIVALENCE        (IECPT(1),ECPT(1))
C
C CALL MAT TO GET MATERIAL PROPERTIES
C
      MATIDC = IECPT(4)
      MATFLG = 1
      ELTEMP = ECPT(17)
      CALL MAT (IECPT(1))
C
C SET UP VECTOR ALONG THE ROD, COMPUTE LENGTH AND NORMALIZE
C
      XN(1) = ECPT(10) - ECPT(14)
      XN(2) = ECPT(11) - ECPT(15)
      XN(3) = ECPT(12) - ECPT(16)
      XL =  XN(1)**2  +  XN(2)**2  +  XN(3)**2
      XL =  SQRT(XL)
      XN(1) = XN(1) / XL
      XN(2) = XN(2) / XL
      XN(3) = XN(3) / XL
      EOVERL = E / XL
      GCOVRL = G * ECPT(6) / XL
      IBASE = 0
C
C TRANSFORM XN VECTOR IF POINT A IS NOT IN BASIC COORDINATES.
C
      IF (IECPT(9) .EQ. 0) GO TO 10
      IBASE = 3
      CALL TRANSS (IECPT(9),TI)
      CALL GMMATS (XN(1),3,1,1, TI(1),3,3,0, XN(4) )
   10 SAT(1) = XN(IBASE +1) * EOVERL
      SAT(2) = XN(IBASE +2) * EOVERL
      SAT(3) = XN(IBASE +3) * EOVERL
      SAR(1) = XN(IBASE +1) * GCOVRL
      SAR(2) = XN(IBASE +2) * GCOVRL
      SAR(3) = XN(IBASE +3) * GCOVRL
C
C TRANSFORM XN VECTOR IF POINT B IS NOT IN BASIC COORDINATES.
C
      IBASE = 0
      IF (IECPT(13) .EQ. 0) GO TO 20
      IBASE = 3
      CALL TRANSS (IECPT(13),TI)
      CALL GMMATS (XN(1),3,1,1, TI(1),3,3,0, XN(4) )
   20 SBT(1) = - XN(IBASE+1) * EOVERL
      SBT(2) = - XN(IBASE+2) * EOVERL
      SBT(3) = - XN(IBASE+3) * EOVERL
      SBR(1) = - XN(IBASE+1) * GCOVRL
      SBR(2) = - XN(IBASE+2) * GCOVRL
      SBR(3) = - XN(IBASE+3) * GCOVRL
C
C FILL REMAINDER OF OUTPUT BLOCK
C
      ST     = - ALPHA * E
      SDELTA = - EOVERL
      AREA   =   ECPT(5)
      IF(ECPT(6)) 30,40,30
   30 FJOVRC = ECPT(7) / ECPT(6)
      GO TO 50
   40 FJOVRC = 0.0
   50 TSUBC0 = TSUB0
      SIGMAT = SIGT
      SIGMAC = SIGC
      SIGMAS = SIGS
      IELID = IECPT(1)
      ISILNO(1) = IECPT(2)
      ISILNO(2) = IECPT(3)
      RETURN
      END

      SUBROUTINE SKPFRM (BFRAMS)
C
      INTEGER         BFRAMS,BFRMS,PLOTER,CAMERA,A(10),ADV10(3),CON10
      REAL            SAVE(2,4),XYMAX(2)
      COMMON /PLTDAT/ MODEL,PLOTER,REG(2,2),AXYMAX(2),EDGE(2),CAMERA,
     1                SKPPLT(9),PXYMAX(7),ORIGIN(2)
      DATA    ADV10 , CON10 / 1,2,3, 3 /
C
      DO 101 I = 1,2
      SAVE(I,1) = REG(I,1)
      REG(I,1)  = 0.
      SAVE(I,2) = REG(I,2)
      REG(I,2)  = AXYMAX(I)+2.*EDGE(I)
      SAVE(I,3) = ORIGIN(I)
      ORIGIN(I) = 0.
      SAVE(I,4) = EDGE(I)
      EDGE(I)   = 0.
  101 CONTINUE
      XYMAX(1) = AMAX1(REG(1,2),REG(2,2))
      XYMAX(2) = AMIN1(REG(1,2),REG(2,2))
      REG(1,2) = XYMAX(1)
      REG(2,2) = XYMAX(2)
      BFRMS    = MIN0(MAX0(BFRAMS,1),5)
C
C     PLOTTER 1, 2
C
      A(1) = CON10
      A(2) = ADV10(CAMERA)
      DO 141 I = 3,6
      A(I) = 0
  141 CONTINUE
      DO 142 I = 1,BFRMS
      CALL WPLT10 (A,0)
  142 CONTINUE
      GO TO 300
C
  300 DO 301 I = 1,2
      REG(I,1) = SAVE(I,1)
      REG(I,2) = SAVE(I,2)
      ORIGIN(I)= SAVE(I,3)
      EDGE(I)  = SAVE(I,4)
  301 CONTINUE
C
      RETURN
      END

      SUBROUTINE JACOBS (ELID,SHP,DSHP,GPTH,BGPDT,GPNORM,JACOB)
C
C     THIS SUBROUTINE CALCULATES JACOBIAN AT EACH GIVEN INTEGRATION
C     POINT FOR QUAD4 POTVIN TYPE ELEMENTS.
C
C     SINGLE PRECISION VERSION
C
      LOGICAL         BADJ
      INTEGER         INDEX(3,3),ELID,NOGO,NOUT
      REAL            BGPDT(4,1),GPNORM(4,1)
      REAL            SHP(1),DSHP(1),GPTH(1),PSITRN(9),JACOB(3,3),
     1                TGRID(3,8),SK(3),TK(3),ENK(3),V1(3),V2(3),V3(3),
     2                VAL,HZTA,THICK ,DETJ,DUM(3),EPS
      COMMON /Q4DT  / DETJ,HZTA,PSITRN,NNODE,BADJ,N1
      COMMON /SYSTEM/ IBUF,NOUT,NOGO
C
      EQUIVALENCE     (PSITRN(1),V1(1))
      EQUIVALENCE     (PSITRN(4),V2(1))
      EQUIVALENCE     (PSITRN(7),V3(1))
C
      DATA   EPS    / 1.0E-15 /
C
C     INITIALIZE BADJ LOGICAL
C
      BADJ=.FALSE.
C
C     COMPUTE THE JACOBIAN AT THIS GAUSS POINT,
C     ITS INVERSE AND ITS DETERMINANT.
C
      DO 150 I=1,NNODE
      THICK=GPTH(I)
      TGRID(1,I)=BGPDT(2,I)+HZTA*THICK*GPNORM(2,I)
      TGRID(2,I)=BGPDT(3,I)+HZTA*THICK*GPNORM(3,I)
  150 TGRID(3,I)=BGPDT(4,I)+HZTA*THICK*GPNORM(4,I)
      DO 200 I=1,2
      IPOINT=N1*(I-1)
      DO 200 J=1,3
      JACOB(I,J)=0.0
      DO 200 K=1,NNODE
      JACOB(I,J)=JACOB(I,J)+DSHP(K+IPOINT)*TGRID(J,K)
  200 CONTINUE
      DO 250 J=1,3
      JACOB(3,J)=0.0
      DO 250 K=1,NNODE
      JTEMP=J+1
      JACOB(3,J)=JACOB(3,J)+0.5*GPTH(K)*GPNORM(JTEMP,K)*SHP(K)
  250 CONTINUE
C
C     SAVE THE S,T, AND N VECTORS FOR CALCULATING PSI LATER.
C
      DO 300 I=1,3
      IF (ABS(JACOB(1,I)) .LE. EPS) JACOB(1,I)=0.0
      SK(I)=JACOB(1,I)
      IF (ABS(JACOB(2,I)) .LE. EPS) JACOB(2,I)=0.0
      TK(I)=JACOB(2,I)
      IF (ABS(JACOB(3,I)) .LE. EPS) JACOB(3,I)=0.0
      ENK(I)=JACOB(3,I)
  300 CONTINUE
C
C     THE INVERSE OF THE JACOBIAN WILL BE STORED IN
C     JACOB AFTER THE SUBROUTINE INVERS HAS EXECUTED.
C
      CALL INVERS (3,JACOB,3,DUM,0,DETJ,ISING,INDEX)
      IF (ISING.EQ.1 .AND. DETJ.GT.0.0) GO TO 350
      WRITE (NOUT,550) ELID
      NOGO=1
      BADJ=.TRUE.
      GO TO 500
  350 CALL SAXB (SK,TK,V3)
      VAL=SQRT(V3(1)*V3(1)+V3(2)*V3(2)+V3(3)*V3(3))
      V3(1)=V3(1)/VAL
      V3(2)=V3(2)/VAL
      V3(3)=V3(3)/VAL
C
C     CROSS ELEMENT Y DIRECTION WITH UNIT VECTOR V3 IN ORDER
C     TO BE CONSISTENT WITH THE ELEMENT COORDINATE SYSTEM.
C
C     NOTE - THIS IS IMPORTANT FOR THE DIRECTIONAL REDUCED
C            INTEGRATION CASES.
C
C
C
      V2(1)=0.0
      V2(2)=1.0
      V2(3)=0.0
C
      CALL SAXB (V2,V3,V1)
      VAL=SQRT(V1(1)*V1(1)+V1(2)*V1(2)+V1(3)*V1(3))
      V1(1)=V1(1)/VAL
      V1(2)=V1(2)/VAL
      V1(3)=V1(3)/VAL
      CALL SAXB (V3,V1,V2)
C
C     REMEMBER THAT V1(1) IS EQUIVALENCED TO PSITRN(1), AND SO ON.
C
C     ELIMINATE SMALL NUMBERS
C
      DO 400 I = 1,3
      IF (ABS(V1(I)) .LE. EPS) V1(I)=0.0
      IF (ABS(V2(I)) .LE. EPS) V2(I)=0.0
      IF (ABS(V3(I)) .LE. EPS) V3(I)=0.0
  400 CONTINUE
C
  500 CONTINUE
      RETURN
C
  550 FORMAT ('0*** USER FATAL ERROR, ELEMENT ID =',I10,
     1        '  HAS BAD OR REVERSE GEOMETRY')
      END

      SUBROUTINE HEAD (DTYP,PLTP,MTYP,IDAT)
C
      INTEGER         IDAT(17),MAXDEF(3),DTYP,PLTP,UNDEF(4),PTYP(2,5),
     1                SUBC(2),MTYPF(2,3),PHAS(3),FPLTIT,PLTITL
      REAL            NT1(5),NT2(4),NT3(3),CSCALE,X,X0
      COMMON /OUTPUT/ TITLE(32,3)
      COMMON /PLTDAT/ SKPPLT(2),XYMIN(2),XYMAX(2),AXYMAX(13),CSCALE,
     1                SKPA(3),CNTX,CNTY
      COMMON /XXPARM/ ISKP(215),FPLTIT,PLTITL(17)
C
      DATA    UNDEF / 4HUNDE, 4HFORM, 4HED S, 4HHAPE /
C ... NUMBER CHAR+2 FOR STATIC - CMODAL ... NOTE, 1 BLANK AT START...
     1,       NT1   / 8., 7., 8., 7., 8.  /
C ... NUMBER CHAR+1 FOR DEFO - ACCEL ...
     2,       NT2   , PTYP / 7., 9., 7., 7.
     A,               4HDEFO,2HR.  , 4HVELO,4HCITY, 4HACCE,2HL.
     B,               4HSTRE,2HSS  , 4HSTRA,2HIN  /
     3,       SUBC  / 4HSUBC,4HASE  /
C ... NUMBER CHAR+1 FOR FREQ, EIGENV., TIME  ... IDENTIFY BY MTYP ...
     4,       NT3   / 6., 8., 5. /
     C,       MTYPF / 4HFREQ,4H.   , 4HEIGE,4HNV. , 4HTIME,1H    /
C ... NUMBER OF SPACES BETWEEN IDENTIFIERS ...
     5,       DELX  / 3.0 /
     6,       MAXDEF/ 4HMAX-,4HDEF.,2H =   /
     7,       PHAS  / 4H PHA,4HSE  ,1H     /
C
      XYMIN(1) = 0.0
      XYMIN(2) = 0.0
      XYMAX(1) = AXYMAX(1)
      XYMAX(2) = AXYMAX(2)
      CALL PRINT (0,0,0,0,0,-1)
      IF (MTYP .LT. 0) GO TO 30
C
C     LEFT-MOST CHARACTER MAY NOT BE COMPETELY DRAWN IF FRACTION OF
C     CSCALE IS IS LESS THAN 0.5. SO MOVE OVER A SMALL SPACE OF X0
C
      J  = IFIX(CSCALE)
      X0 = CSCALE - FLOAT(J)
      IF (X0 .GT. 0.5) X0 = 0.0
C
C     PRINT THE TITLE, SUBTITLE AND LABEL
C
      CALL PRINT (X0,3.0*CNTY,1,TITLE(1,1),17,0)
      CALL PRINT (X0,2.0*CNTY,1,TITLE(1,2),16,0)
      CALL PRINT (X0,CNTY,1,TITLE(1,3),17,0)
C
      X = 25. - 5.*(CSCALE-1.)
      IF (DTYP .EQ. 0) GO TO 10
      X = 40.
      IF (IDAT(1) .LE. 8) GO TO 10
      X = 45.
      IF (IDAT(1) .GE. 12) X = 52.
      IF (IDAT(1) .GE. 15) X = 59.
   10 CONTINUE
      IF (FPLTIT .NE. 0) CALL PRINT (X*CNTX,0.,1,PLTITL,17,0)
C
C     BOTTOM LINE IDENTIFIES PLOT
C
      IF (DTYP .NE. 0) GO TO 20
C
C     UNDEFORMED SHAPE
C
      CALL PRINT (CNTX+X0,0.,1,UNDEF,4,0)
      GO TO 40
C
C     DEFORMED SHAPE
C
   20 CALL PRINT (CNTX+X0,0.,1,IDAT(3),2,0)
      X = NT1(DTYP)
      CALL PRINT (X*CNTX+X0,0.,1,PTYP(1,PLTP),2,0)
      X = X + NT2(PLTP)
      CALL PRINT (X*CNTX+X0,0.,1,SUBC,2,0)
      X = X + 8.
      N = -1
      CALL TYPINT (X*CNTX+X0,0.,1,IDAT(7),N,0)
      X = X + FLOAT(N) + DELX
C
C     LOAD I  OR  MODE I
C
      CALL PRINT (X*CNTX+X0,0.,1,IDAT(9),1,0)
      X = X + 5.
      N = -1
      CALL TYPINT (X*CNTX+X0,0.,1,IDAT(8),N,0)
C
C     FREQUENCY, EIGENVALUE, OR TIME
C
      IF (IDAT(1) .LE. 8) GO TO 40
      X = FLOAT(IFIX(X+DELX+0.1) + N)
      CALL PRINT (X*CNTX+X0,0.,1,MTYPF(1,MTYP),2,0)
      X = X + NT3(MTYP)
      CALL TYPFLT (X*CNTX+X0,0.,1,IDAT(10),-8,0)
C
C     MAGNITUDE  OR  PHASE LAG
C
      IF (IDAT(1) .LE. 12) GO TO 40
      X = X + 7.0 + DELX
      IF (IDAT(14) .NE. PHAS(1)) GO TO 25
      IDAT(15) = PHAS(2)
      IDAT(16) = PHAS(3)
   25 CALL PRINT (X*CNTX+X0,0.,1,IDAT(14),3,0)
C
      IF (IDAT(1) .LE. 15) GO TO 40
      X = X + 7.0
      CALL TYPFLT (X*CNTX+X0,0.,1,IDAT(17),-6,0)
      GO TO 40
C
C     PRINT THE MAXIMUM DEFORMATION AT THE TOP
C
   30 CALL PRINT (20.*CNTX,XYMAX(2),1,MAXDEF,3,0)
      CALL TYPFLT (31.*CNTX,XYMAX(2),1,IDAT(1),-10,0)
C
C
   40 CALL PRINT (0,0,0,0,0,1)
      RETURN
      END

      SUBROUTINE EMGOLD
C
C     THIS IS A DRIVING ROUTINE OF THE -EMG- MODULE WHICH ALLOWS PIVOT-
C     POINT-LOGIC ELEMENT SUBROUTINES TO BE USED IN CONJUNCTION WITH THE
C     NON-PIVOT-POINT PROCESS.
C
      LOGICAL          ERROR,LAST,HEAT,KHEAT,LHEAT,HYDRO
      INTEGER          OUTPT,SIL,POSVEC,ELTYPE,ELID,ELEM,DICT,ESTWDS,
     1                 ESTID,ESTBUF,FILTYP,PRECIS,MDICT(15),KDICT(15),
     2                 BDICT(15),FLAGS,QP
      DOUBLE PRECISION DUMMY
      CHARACTER        UFM*23,UWM*25,UIM*29,SFM*25,SWM*27,SIM*31
      COMMON /XMSSG /  UFM,UWM,UIM,SFM,SWM,SIM
      COMMON /MACHIN/  MACH,DUM2(2),LQRO
      COMMON /SYSTEM/  KSYSTM(65)
      COMMON /GPTA1 /  NELEMS,NLAST,INCR,ELEM(1)
      COMMON /EMGDIC/  ELTYPE,LDICT,NLOCS,ELID,ESTID
      COMMON /EMGEST/  ESTBUF(100)
      COMMON /SMA1ET/  KECPT(100)
      COMMON /SMA2ET/  MECPT(100)
      COMMON /SMA1IO/  SMAIO(36)
      COMMON /SMA1BK/  S1DUM(10)
      COMMON /SMA2BK/  S2DUM(10)
      COMMON /SMA1DP/  KWORK(700)
      COMMON /SMA2DP/  MWORK(700)
      COMMON /SMA1CL/  IOPT4,K4GGSW,KNPVT,SKIP19(19),KNOGO,KSAFE(200)
      COMMON /SMA2CL/  IOPTB,BGGIND,MNPVT,SKIP17(17),MNOGO,SKIP2(2),
     1                 MSAFE(200)
      COMMON /EMG1BX/  NSILS,POSVEC(10),IBLOC,NBLOC,IROWS,DICT(15),
     1                 FILTYP,SIL(10),LAST
      COMMON /EMGPRM/  SKIPXX(15),FLAGS(3),PRECIS,ERROR,HEAT,ICMBAR,
     1                 LCSTM,LMAT,LHMAT,KFLAGS(3),L38
      COMMON /HYDROE/  HYDRO
      COMMON /SMA1HT/  KHEAT
      COMMON /SMA2HT/  LHEAT
      COMMON /IEMGOD/  DUMMY,LTYPES
      EQUIVALENCE      (KSYSTM(2),OUTPT), (KSYSTM(40),NBPW),
     1                 (SMAIO(11),IFKGG), (SMAIO(13),IF4GG)
C
      KTEMP = KNOGO
      MTEMP = MNOGO
      QP    = MOD(LQRO/100,10)
      JLTYPE= 2*(ELTYPE-1) + PRECIS
      KHEAT = HEAT
      LHEAT = HEAT
      IZERO = INCR*(ELTYPE - 1)
      IF (ELTYPE .EQ. LTYPES) GO TO 20
      CALL PAGE2 (3)
      INDEX = IZERO
      IF (.NOT.HEAT) GO TO 3
      IF (ELTYPE.EQ.62 .OR. ELTYPE.EQ.63) INDEX = 15*INCR
    3 IF (L38 .EQ. 1) WRITE (OUTPT,4) SIM,ELEM(INDEX+1),ELEM(INDEX+2)
    4 FORMAT (A31,' 3107',/5X,'EMGOLD CALLED BY EMGPRO TO PROCESS ',2A4,
     1       ' ELEMENTS.')
      LTYPES = ELTYPE
      GO TO 20
    5 WRITE  (OUTPT,10) SWM,ELID,ELEM(IZERO+1),ELEM(IZERO+2)
   10 FORMAT (A27,' 3121, EMGOLD HAS RECEIVED A CALL FOR ELEMENT ID',I9,
     1       ' (ELEMENT TYPE ',2A4,2H)., /5X,'ELEMENT IGNORED AS THIS ',
     2       'ELEMENT TYPE IS NOT HANDLED BY EMGOLD.')
      GO TO 1220
C
   20 NSILS = ELEM(IZERO+10)
      ISIL  = ELEM(IZERO+13)
      IF (ELEM(IZERO+9) .NE. 0) ISIL = ISIL - 1
      ESTWDS = ELEM(IZERO+12)
      I1 = ISIL
      I2 = ISIL + NSILS - 1
      L  = NSILS
C
C     MOVE SILS TO SEPARATE ARRAY
C
C     SORT ARRAY OF SILS
C
C     POSITION VECTOR
C
      DO 80 I = I1,I2
      IF (ESTBUF(I) .EQ. 0) GO TO 72
      K = 1
      DO 70 J = I1,I2
      IF (ESTBUF(J) - ESTBUF(I)) 60,50,70
   50 IF (J .GE. I) GO TO 70
   60 IF (ESTBUF(J) .NE. 0) K = K + 1
   70 CONTINUE
      GO TO 74
   72 K = L
      L = L - 1
   74 POSVEC(K) = I - I1 + 1
   80 SIL(K) = ESTBUF(I)
C
C     ELIMINATE DUP SILS THAT MAY OCCUR,E.G. CHBDY WITH AMB.PTS.
C
      K = 1
      ICOUNT = 1
      DO 85 I = 2,NSILS
   82 K = K + 1
      IF (K .LE. NSILS) GO TO 84
      SIL(I) = 0
      POSVEC(I) = 0
      GO TO 85
   84 IF (SIL(K) .EQ. SIL(K-1)) GO TO 82
      SIL(I) = SIL(K)
      IF (SIL(K) .NE. 0) ICOUNT = ICOUNT + 1
      POSVEC(I) = POSVEC(K)
   85 CONTINUE
      NSILS = ICOUNT
C
C     SETUP VALUES AND DICTIONARY IN /EMG1BX/ FOR EMG1B USE
C
      DICT(1) = ESTID
      DICT(2) = 1
C
C     PSUEDO SMA1-SMA2 FILE NUMBERS
C
      IFKGG = 201
      IF4GG = 202
C
C     DICT(4) WILL BE RESET TO EITHER 1 OR 63 BY EMG1B
C     BASED ON INCOMING DATA TO EMG1B
C
      DO 90 I = 5,15
      DICT(I) = 0
   90 CONTINUE
C
C     CALL ELEMENT FOR EACH PIVOT ROW
C
      LAST  = .FALSE.
      KNOGO = 0
      MNOGO = 0
      DO 1210 I = 1,NSILS
      IF (I .EQ. NSILS) LAST = .TRUE.
C
C     STIFFNESS MATRIX
C
      IF (FLAGS(1) .EQ. 0) GO TO 550
C
C     RESTORE K-DICTIONARY IF NECESSARY
C
      IF (I .EQ. 1) GO TO 110
      DO 100 L = 1,15
      DICT(L) = KDICT(L)
  100 CONTINUE
  110 CONTINUE
      FILTYP = 1
C
C     IOPT4 IS TURNED ON SO THAT DAMPING CONSTANTS ARE SENT TO EMG1B
C     IN ALL AVAILABLE CASES BY ELEMENT ROUTINES.  MATRIX DATA WILL BE
C     IGNORED BY EMG1B ON EMG1B CALLS SENDING DAMPING CONSTANTS.
C     DAMPING CONSTANTS WILL BE PLACED IN 5TH WORD OF ELEMENT DICTIONARY
C     ENTRY.
C
      IOPT4  = 1
      K4GGSW = 0
      KNPVT  = SIL(I)
C
C     FULL 6X6 MATRIX FORCED FOR STIFFNESS WITH OLD ELEMENT ROUTINES
C
      DICT(2) = 1
      IF (SIL(I) .NE. 0) GO TO 115
      CALL EMG1B (DUMMY,0,1,1,0)
      GO TO 520
  115 CONTINUE
      DO 120 L = 1,ESTWDS
      KECPT(L) = ESTBUF(L)
  120 CONTINUE
      HYDRO = .FALSE.
      IF (ELTYPE.GE.76 .AND. ELTYPE.LE.79) HYDRO = .TRUE.
C
C     CALL THE PROPER ELEMENT STIFFNESS ROUTINE
C
      LOCAL = JLTYPE - 100
      IF (LOCAL) 130,130,140
C
C     PAIRED -GO TO- ENTRIES PER ELEMENT SINGLE/DOUBLE PRECISION
C
C             1 CROD      2 C.....    3 CTUBE     4 CSHEAR    5 CTWIST
  130 GO TO (  5,    5,    5,    5,    5,    5,    5,    5,    5,    5
C
C             6 CTRIA1    7 CTRBSC    8 CTRPLT    9 CTRMEM   10 CONROD
     1,      190,  190,    5,    5,  210,  210,    5,    5,    5,    5
C
C            11 ELAS1    12 ELAS2    13 ELAS3    14 ELAS4    15 CQDPLT
     2,        5,    5,    5,    5,    5,    5,    5,    5,  280,  280
C
C            16 CQDMEM   17 CTRIA2   18 CQUAD2   19 CQUAD1   20 CDAMP1
     3,      290,  290,  300,  300,  310,  310,  320,  320,    5,    5
C
C            21 CDAMP2   22 CDAMP3   23 CDAMP4   24 CVISC    25 CMASS1
     4,        5,    5,    5,    5,    5,    5,    5,    5,    5,    5
C
C            26 CMASS2   27 CMASS3   28 CMASS4   29 CONM1    30 CONM2
     5,        5,    5,    5,    5,    5,    5,    5,    5,    5,    5
C
C            31 PLOTEL   32 C.....   33 C.....   34 CBAR     35 CCONEAX
     6,      520,  520,    5,    5,    5,    5,    5,    5,  340,  345
C
C            36 CTRIARG  37 CTRAPRG  38 CTORDRG  39 CTETRA   40 CWEDGE
     7,      350,  350,  370,  370,    5,    5,  400,  400,  410,  410
C
C            41 CHEXA1   42 CHEXA2   43 CFLUID2  44 CFLUID3  45 CFLUID4
     8,      420,  420,  430,  430,  440,  440,  450,  450,  460,  460
C
C            46 CFLMASS  47 CAXIF2   48 CAXIF3   49 CAXIF4   50 CSLOT3
     9,      520,  520,  440,  440,  450,  450,  460,  460,  470,  470
C
     *      ), JLTYPE
C
C            51 CSLOT4   52 CHBDY    53 CDUM1    54 CDUM2    55 CDUM3
  140 GO TO (480,  480,    5,    5,    5,    5,    5,    5,    5,    5
C
C            56 CDUM4    57 CDUM5    58 CDUM6    59 CDUM7    60 CDUM8
     B,        5,    5,    5,    5,    5,    5,    5,    5,    5,    5
C
C            61 CDUM9    62 CQDMEM1  63 CQDMEM2  64 CQDMEM3  65 CIHEX1
     C,        5,    5,  292,  292,  295,  294,    5,    5,    5,    5
C
C            66 CIHEX2   67 CIHEX3   68 CQUADTS  69 CTRIATS  70 CTRIAAX
     D,        5,    5,    5,    5,    5,    5,    5,    5,    5,    5
C
C            71 CTRAPAX  72 CAERO1   73 CTRIM6   74 CTRPLT1  75 CTRSHL
     E,        5,    5,    5,    5,    5,    5,    5,    5,    5,    5
C
C            76 CFHEX1   77 CFHEX2   78 CFTETRA  79 CFWEDGE  80 CIS2D8
     F,      420,  420,  430,  430,  400,  400,  410,  410,    5,    5
C
C            81 CELBOW   82 FTUBE    83 CTRIA3   84 CPSE2    85 CPSE3
     G,      390,  390,    5,    5,    5,    5,    5,    5,    5,    5
C
C            86 CPSE4
     H,        5,    5
C
     *      ), LOCAL
C
C
C     IN -HEAT- FORMULATIONS SOME ELEMENTS ARE IGNORED (OPTION(1)=HEAT)
C     IN STRUCTURE PROBLEMS SOME ELEMENTS ARE IGNORED (OPTION(1)=STRUCT)
C
  190 CALL KTRIQD (1)
      GO TO 520
  210 CALL KTRPLT
      GO TO 520
  280 CALL KQDPLT
      GO TO 520
  290 CALL KQDMEM
      GO TO 520
C
C     REPLACE ELEMENT TYPE CQDMEM1 BY ELEMENT TYPE CQDMEM
C     IN -HEAT- FORMULATION
C
  292 IF (HEAT) GO TO 290
      GO TO 5
C
C     REPLACE ELEMENT TYPE CQDMEM2 BY ELEMENT TYPE CQDMEM
C     IN -HEAT- FORMULATION
C
  294 IF (HEAT) GO TO 290
      GO TO 5
C
C     REPLACE ELEMENT TYPE CQDMEM2 BY ELEMENT TYPE CQDMEM
C     IN -HEAT- FORMULATION
C
  295 IF (HEAT) GO TO 290
      GO TO 5
  300 CALL KTRIQD (2)
      GO TO 520
  310 CALL KTRIQD (4)
      GO TO 520
  320 CALL KTRIQD (3)
      GO TO 520
  340 CALL KCONES
      GO TO 520
  343 CALL KCONE2
      GO TO 520
  345 IF (MACH .EQ.  3) GO TO 340
      IF (NBPW .GE. 60) GO TO 343
      IF (QP .EQ. 0) CALL KCONED
      IF (QP .NE. 0) CALL KCONEQ
      GO TO 520
  350 IF (HEAT) GO TO 360
      IF (KNOGO .EQ. 2) GO TO 1210
      CALL KTRIRG
      IF (KNOGO .EQ. 2) GO TO 1210
      GO TO 520
  360 CALL HRING (3)
      GO TO 520
  370 IF (HEAT) GO TO 380
      CALL KTRAPR
      GO TO 520
  390 CALL KELBOW
      GO TO 520
  380 CALL HRING (4)
      GO TO 520
  400 CALL KTETRA (0,0)
      GO TO 520
  410 CALL KSOLID (1)
      GO TO 520
  420 CALL KSOLID (2)
      GO TO 520
  430 CALL KSOLID (3)
      GO TO 520
  440 CALL KFLUD2
      GO TO 520
  450 CALL KFLUD3
      GO TO 520
  460 CALL KFLUD4
      GO TO 520
  470 CALL KSLOT (0)
      GO TO 520
  480 CALL KSLOT (1)
      GO TO 520
C
C     OUTPUT THE PIVOT ROW PARTITION NOW COMPLETED BY -EMG1B-
C
  520 CALL EMG1B (0.0D0,-1111111,0,0,0.0D0)
C
C     SAVE K-DICTIONARY
C
      DO 530 L = 1,15
      KDICT(L) = DICT(L)
  530 CONTINUE
C
C     MASS MATRIX M
C
  550 IF (FLAGS(2) .EQ. 0) GO TO 1090
      IF (HEAT) GO TO 1090
C
C     RESTORE M-DICTIONARY IF NECESSARY
C
      IF (I .EQ. 1) GO TO 570
      DO 560 L = 1,15
      DICT(L) = MDICT(L)
  560 CONTINUE
  570 CONTINUE
      FILTYP = 2
      IOPTB  = 0
      BGGIND =-1
      MNPVT  = SIL(I)
      DICT(2)= 1
      IF (SIL(I) .NE. 0)  GO TO 575
      CALL EMG1B (DUMMY,0,1,2,0)
      GO TO 1060
  575 CONTINUE
      DO 580 L = 1,ESTWDS
      MECPT(L) = ESTBUF(L)
  580 CONTINUE
C
C     CALL THE PROPER ELEMENT MASS ROUTINE.
C
  590 LOCAL = JLTYPE - 100
      IF (LOCAL) 600,600,610
C
C     PAIRED -GO TO- ENTRIES PER ELEMENT SINGLE/DOUBLE PRECISION
C
C             1 CROD      2 C.....    3 CTUBE     4 CSHEAR    5 CTWIST
  600 GO TO (  5,    5,    5,    5,    5,    5,    5,    5,    5,    5
C
C             6 CTRIA1    7 CTRBSC    8 CTRPLT    9 CTRMEM   10 CONROD
     1,      670,  670,    5,    5,  710,  710,    5,    5,    5,    5
C
C            11 ELAS1    12 ELAS2    13 ELAS3    14 ELAS4    15 CQDPLT
     2,        5,    5,    5,    5,    5,    5,    5,    5,  740,  740
C
C            16 CQDMEM   17 CTRIA2   18 CQUAD2   19 CQUAD1   20 CDAMP1
     3,      760,  760,  770,  770,  790,  790,  810,  810,    5,    5
C
C            21 CDAMP2   22 CDAMP3   23 CDAMP4   24 CVISC    25 CMASS1
     4,        5,    5,    5,    5,    5,    5,    5,    5,    5,    5
C
C            26 CMASS2   27 CMASS3   28 CMASS4   29 CONM1    30 CONM2
     5,        5,    5,    5,    5,    5,    5,    5,    5,    5,    5
C
C            31 PLOTEL   32 C.....   33 C.....   34 CBAR     35 CCONEAX
     6,     1060, 1060,    5,    5,    5,    5,    5,    5,  910,  910
C
C            36 CTRIARG  37 CTRAPRG  38 CTORDRG  39 CTETRA   40 CWEDGE
     7,      930,  930,  940,  940,    5,    5,  960,  960,  970,  970
C
C            41 CHEXA1   42 CHEXA2   43 CFLUID2  44 CFLUID3  45 CFLUID4
     8,      980,  980,  990,  990, 1000, 1000, 1010, 1010, 1020, 1020
C
C            46 CFLMASS  47 CAXIF2   48 CAXIF3   49 CAXIF4   50 CSLOT3
     9,     1030, 1030, 1000, 1000, 1010, 1010, 1020, 1020, 1040, 1040
C
     *     ), JLTYPE
C
C
C            51 CSLOT4   52 CHBDY    53 CDUM1    54 CDUM2    55 CDUM3
  610 GO TO (1050,1050,    5,    5,    5,    5,    5,    5,    5,    5
C
C            56 CDUM4    57 CDUM5    58 CDUM6    59 CDUM7    60 CDUM8
     B,        5,    5,    5,    5,    5,    5,    5,    5,    5,    5
C
C            61 CDUM9    62 CQDMEM1  63 CQDMEM2  64 CQDMEM3  65 CIHEX1
     C,        5,    5,    5,    5,    5,    5,    5,    5,    5,    5
C
C            66 CIHEX2   67 CIHEX3   68 CQUADTS  69 CTRIATS  70 CTRIAAX
     D,        5,    5,    5,    5,    5,    5,    5,    5,    5,    5
C
C            71 CTRAPAX  72 CAERO1   73 CTRIM6   74 CTRPLT1  75 CTRSHL
     E,        5,    5,    5,    5,    5,    5,    5,    5,    5,    5
C
C            76 CFHEX1   77 CFHEX2   78 CFTETRA  79 CFWEDGE  80 CIS2D8
     F,     1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060,    5,    5
C
C            81 CELBOW   82 FTUBE    83 CTRIA3   84 CPSE2    85 CPSE3
     G,      950,  950,    5,    5,    5,    5,    5,    5,    5,    5
C
C            86 CPSE4
     H,        5,    5
C
     *      ), LOCAL
C
C
C     CONVENTIONAL MASS MATRIX GENERATION ROUTINE CALLED WHEN
C     ICMBAR .LT. 0
C     OTHERWISE CONSISTENT MASS MATRIX GENERATION ROUTINE CALLED
C
  670 IF (ICMBAR .LT. 0) GO TO 680
      CALL MTRIQD (1)
      GO TO 1060
  680 CALL MASSTQ (5)
      GO TO 1060
C
  710 IF (ICMBAR .LT. 0) GO TO 720
      CALL MTRPLT
      GO TO 1060
  720 CALL MASSTQ (3)
      GO TO 1060
C
  740 IF (ICMBAR .LT. 0) GO TO 750
      CALL MQDPLT
      GO TO 1060
  750 CALL MASSTQ (7)
      GO TO 1060
  760 CALL MASSTQ (1)
      GO TO 1060
C
  770 IF (ICMBAR .LT. 0) GO TO 780
      CALL MTRIQD (2)
      GO TO 1060
  780 CALL MASSTQ (4)
      GO TO 1060
C
  790 IF (ICMBAR .LT. 0) GO TO 800
      CALL MTRIQD (4)
      GO TO 1060
  800 CALL MASSTQ (1)
      GO TO 1060
C
  810 IF (ICMBAR .LT. 0) GO TO 820
      CALL MTRIQD (3)
      GO TO 1060
  820 CALL MASSTQ (2)
      GO TO 1060
  910 CALL MCONE
      GO TO 1060
  930 IF (MNOGO .EQ. 2) GO TO 1210
      IF (HEAT) GO TO 935
      CALL MTRIRG
      IF (MNOGO .EQ. 2) GO TO 1210
      GO TO 1060
  935 CALL MRING (3)
      GO TO 1060
  940 IF (HEAT) GO TO 945
      CALL MTRAPR
      GO TO 1060
  945 CALL MRING (4)
      GO TO 1060
  950 CALL MELBOW
      GO TO 1060
  960 CALL MSOLID (1)
      GO TO 1060
  970 CALL MSOLID (2)
      GO TO 1060
  980 CALL MSOLID (3)
      GO TO 1060
  990 CALL MSOLID (4)
      GO TO 1060
 1000 CALL MFLUD2
      GO TO 1060
 1010 CALL MFLUD3
      GO TO 1060
 1020 CALL MFLUD4
      GO TO 1060
 1030 CALL MFREE
      GO TO 1060
 1040 CALL MSLOT (0)
      GO TO 1060
 1050 CALL MSLOT (1)
      GO TO 1060
C
C     OUTPUT THE PIVOT ROW PARTITION NOW COMPLETED BY -EMG1B-
C
 1060 CALL EMG1B (0.0D0,-1111111,0,0,0.0D0)
      IF (HEAT) GO TO 1185
C
C     SAVE M-DICTIONARY
C
      DO 1070 L = 1,15
      MDICT(L) = DICT(L)
 1070 CONTINUE
C
C     DAMPING MATRIX B
C
 1090 IF (FLAGS(3) .EQ. 0) GO TO 1210
      IF (.NOT.HEAT) GO TO 1210
C
C     RESTORE B-DICTIONARY IF NECESSARY
C
      IF (I .EQ. 1) GO TO 1110
      DO 1100 L = 1,15
      DICT(L) = BDICT(L)
 1100 CONTINUE
 1110 FILTYP = 3
      IOPTB  =-1
      BGGIND =-1
      MNPVT  = SIL(I)
      DICT(2)= 1
      IF (SIL(I) .NE. 0) GO TO 1115
      CALL EMG1B (DUMMY,0,1,3,0)
      GO TO 1180
 1115 DO 1120 L = 1,ESTWDS
      MECPT(L) = ESTBUF(L)
 1120 CONTINUE
      GO TO 590
C
C     OUTPUT THE PIVOT ROW PARTITION NOW COMPLETED BY -EMG1B-
C
 1180 CALL EMG1B (0.0D0,-1111111,0,0,0.0D0)
C
C     SAVE DICTIONARY
C
 1185 DO 1190 L = 1,15
      BDICT(L) = DICT(L)
 1190 CONTINUE
C
 1210 CONTINUE
      IF (KNOGO .EQ. 0) KNOGO = KTEMP
      IF (MNOGO .EQ. 0) MNOGO = MTEMP
C
 1220 RETURN
      END

      SUBROUTINE AMGB2 (INPUT,D1JK,D2JK)
C
C     DRIVER FOR COMPRESSOR BLADE THEORY
C     COMPUTATIONS ARE FOR D1JK AND D2JK MATRICES
C     FOR COMPRESSOR BLADES K-SET = J-SET = NLINES*NSTNS
C     D1JK = F(INVERSE)TRANSPOSE
C     NOTE - AMP MODULE TAKES D1JK(TRANSPOSE) SO OUTPUT
C            F(INVERSE)TRANSPOSE TO GET EFFECT OF F(INVERSE) IN AMP.
C
C     D2JK = NULL
C
      LOGICAL         TSONIC,DEBUG
      INTEGER         D1JK,D2JK,TD1JK,TD2JK,ECORE,SYSBUF,NAME(2),SLN
      REAL            MINMAC,MAXMAC,MACH
      DIMENSION       IZ(1)
      COMMON /AMGP2 / TD1JK(7),TD2JK(7)
      COMMON /AMGMN / MCB(7),NROW,DUM(2),REFC,SIGMA,RFREQ
      COMMON /CONDAS/ PI,TWOPI,RADEG,DEGRA,S4PISQ
      COMMON /PACKX / ITI,ITO,II,NN,INCR
      COMMON /SYSTEM/ SYSBUF,IOUT
      COMMON /ZZZZZZ/ WORK(1)
      COMMON /BLANK / NK,NJ
      COMMON /BAMG2L/ IREF,MINMAC,MAXMAC,NLINES,NSTNS,REFSTG,REFCRD,
     1                REFMAC,REFDEN,REFVEL,REFFLO,SLN,NSTNSX,STAGER,
     2                CHORD,RADIUS,BSPACE,MACH,DEN,VEL,FLOWA,AMACH,
     3                REDF,BLSPC,AMACHR,TSONIC,XSIGN
      COMMON /AMGBUG/ DEBUG
      EQUIVALENCE     (WORK(1),IZ(1))
      DATA    NAME  / 4HAMGB,4H2   /
C
C     READ PARAMETERS IREF,MINMAC,MAXMAC,NLINES AND NSTNS
C
      CALL FREAD (INPUT,IREF,5,0)
      IF (DEBUG) CALL BUG1 ('ACPT-REF  ',5,IREF,5)
C
C     READ REST OF ACPT RECORD INTO OPEN CORE AND LOCATE REFERENCE
C     PARAMETERS REFSTG,REFCRD,REFMAC,REFDEN,REFVEL AND REFFLO
C
      ECORE = KORSZ(IZ) - 3*SYSBUF
      CALL READ (*10,*10,INPUT,IZ,ECORE,1,NWAR)
      GO TO 120
   10 NDATA = 3*NSTNS + 10
      IF (DEBUG) CALL BUG1 ('ACPT-REST ',10,IZ,NWAR)
      IRSLN = 0
      NLINE = 0
      DO 20 I = 1,NWAR,NDATA
      IF (IREF .EQ. IZ(I)) IRSLN = I
      NLINE = NLINE + 1
   20 CONTINUE
C
C     DETERMINE DIRECTION OF BLADE ROTATION VIA Y-COORDINATES AT TIP
C     STREAMLINE. USE COORDINATES OF FIRST 2 NODES ON STREAMLINE.
C
      IPTR  = NDATA*(NLINES-1)
      XSIGN = 1.0
      IF (WORK(IPTR+15) .LT. WORK(IPTR+12)) XSIGN = -1.0
C
      IF (DEBUG) CALL BUG1 ('RADII     ',20,RADII,NLINES)
C
C     DID IREF MATCH AN SLN OR IS THE DEFAULT TO BE TAKEN (BLADE TIP)
C
      IF (IRSLN .EQ. 0) IRSLN = (NLINES-1)*NDATA + 1
      REFSTG = WORK(IRSLN+2)
      REFCRD = WORK(IRSLN+3)
      REFMAC = WORK(IRSLN+6)
      REFDEN = WORK(IRSLN+7)
      REFVEL = WORK(IRSLN+8)
      REFFLO = WORK(IRSLN+9)
C
C     REPOSITION ACPT TO BEGINNING OF COMPRESSOR BLADE DATA
C
      CALL BCKREC (INPUT)
      CALL FREAD (INPUT,0,-6,0)
C
      IF (DEBUG) CALL BUG1 ('BAMG2L    ',22,IREF,27)
C
C     COMPUTE POINTERS AND SEE IF THERE IS ENOUGH CORE
C
      NSNS = NSTNS*NSTNS
      IP1  = 1
      IP2  = IP1 + NSNS
      NEXT = IP2 + 3*NSTNS
      IF (NEXT .GT. ECORE) GO TO 120
C
C     COMPUTE F(INVERSE) FOR EACH STREAMLINE
C
      NN = II + NSTNS - 1
      DO 100 NLINE = 1,NLINES
      CALL AMGB2A (INPUT,WORK(IP1),WORK(IP2),WORK(IP2))
C
C     OUTPUT D1JK (=F(INVERSE)TRANSPOSE) FOR THIS STREAMLINE.
C     NOTE - AMP MODULE TAKES D1JK(TRANSPOSE) SO OUTPUT
C            F(INVERSE)TRANSPOSE TO GET EFFECT OF F(INVERSE) IN AMP.
C
      IP3 = IP2 + NSTNS - 1
      DO 50 I = 1,NSTNS
      K   = I
      DO 30 J = IP2,IP3
      WORK(J) = WORK(K)
   30 K   = K + NSTNS
      CALL PACK (WORK(IP2),D1JK,TD1JK)
      IF (DEBUG) CALL BUG1 ('D1JK      ',31,WORK(IP2),NSTNS)
   50 CONTINUE
      II  = II +NSTNS
      IF (NLINE .EQ. NLINES) GO TO 100
      NN  = NN + NSTNS
  100 CONTINUE
C
C     OUTPUT D2JK = NULL
C
      DO 110 ICOL = 1,NK
      CALL BLDPK (ITI,ITO,D2JK,0,0)
  110 CALL BLDPKN (D2JK,0,TD2JK)
      RETURN
C
C     ERROR MESSAGES
C
C     NOT ENOUGH CORE
C
  120 CALL MESAGE (-8,0,NAME)
      RETURN
      END

      SUBROUTINE SUBP (I,L,LS,J,SGR,CGR,YREC,ZREC,SUM,XIC,DELX,EE,XLAM,
     1                 SG,CG,YS,ZS)
C
C     COMPUTES ELEMENTS OF THE SUBMATRICES  DPP, DPZ  AND  DPY
C     USING  SUBROUTINES  SNPDF,  INCRO  AND SUBI
C
      REAL           KR,M
      COMPLEX        DPUR,DPUL,DPLR,DPLL,DP,SUM
      DIMENSION      XIC(1),DELX(1),EE(1),XLAM(1),SG(1),CG(1),YS(1),
     1               ZS(1)
      COMMON /AMGMN/ MCB(7),NROW,ND,NE,REFC,FMACH,KR
      COMMON /DLCOM/ DUM(3),F
C
      EPS  = 0.00001
      M    = FMACH
      BETA = SQRT(1.0-M*M)
      FL   = REFC
      FLND = FLOAT(ND)
      FLNE = FLOAT(NE)
      SGS  = SG(LS)
      CGS  = CG(LS)
      DPUR = (0.0,0.0)
      DPUL = (0.0,0.0)
      DPLR = (0.0,0.0)
      DPLL = (0.0,0.0)
      DIJ  = 0.0
      DELR = 0.0
      DELI = 0.0
      DIJI = 0.0
      DELRI= 0.0
      DELII= 0.0
C
C     UPPER RIGHT SENDING POINT
C
      IGO  = 1
      TL   = XLAM(J)
      SQTL = SQRT(1.0+TL**2)
      SL   = TL/SQTL
      CL   = 1.0/SQTL
      X    = XIC(I) + F*DELX(I)
      X0   = X - XIC(J)
      Y0   = YREC - YS(LS)
      Z0   = ZREC - ZS(LS)
      ES   = EE(LS)
      DXS  = DELX(J)
      AX   = X0
      AY   = Y0
      AZ   = Z0
      CV   = DXS
C
   30 NOBI = 1
      CALL SNPDF (SL,CL,TL,SGS,CGS,SGR,CGR,X0,Y0,Z0,ES,DIJ,BETA,CV)
      IF (KR .LE. EPS) GO TO  40
      SDELX= DXS
      DELY = 2.0*ES
      AX1  = AX + ES*TL
      AY1  = AY + ES*CGS
      AZ1  = AZ + ES*SGS
      AX2  = AX - ES*TL
      AY2  = AY - ES*CGS
      AZ2  = AZ - ES*SGS
      CALL INCRO (AX,AY,AZ,AX1,AY1,AZ1,AX2,AY2,AZ2,SGR,CGR,SGS,CGS,
     1            KR,FL,BETA,SDELX,DELY,DELR,DELI)
   40 CONTINUE
      DP = CMPLX(((DIJ+DIJI)-(DELR +DELRI)),(-DELI-DELII))
      GO TO (140,150,170,180), IGO
  140 CONTINUE
      DPUR = DP
C
C     TEST FOR ABS(YS(LS)) .LE..001 TAKEN OUT
C
      IF (ND .EQ. 0) GO TO 160
C
C     UPPER LEFT  SENDING POINT
C
      IGO  = 2
      SGS  =-SGS
      TL   =-TL
      SL   =-SL
      Y0   = YREC + YS(LS)
      AY   = Y0
      GO TO  30
  150 CONTINUE
      DPUL = DP
  160 CONTINUE
      IF (NE .EQ. 0) GO TO 190
C
C     LOWER RIGHT SENDING POINT
C
      IGO  = 3
      TL   = XLAM(J)
      SL   = TL/(SQRT(1.0+TL*TL))
      Y0   = YREC - YS(LS)
      Z0   = ZREC + ZS(LS)
      AY   = Y0
      AZ   = Z0
      SGS  =-SG(LS)
      GO TO  30
  170 CONTINUE
      DPLR = DP
      IF (ND .EQ. 0) GO TO 190
C
C     LOWER LEFT  SENDING POINT
C
      IGO  = 4
      SGS  = SG(LS)
      TL   =-XLAM(J)
      SL   = TL/(SQRT(1.0+TL*TL))
      Y0   = YREC + YS(LS)
      AY   = Y0
      GO TO  30
  180 CONTINUE
      DPLL = DP
  190 CONTINUE
      SUM  = DPUR + FLND*DPUL + FLNE*DPLR + FLND*FLNE*DPLL
      RETURN
      END

      SUBROUTINE GETBLK (IOLD,INEW)
C
C     FINDS A FREE BLOCK INEW.  IF IOLD IS NOT ZERO IOLD POINTER WILL
C     BE SET TO INEW.
C
      EXTERNAL        LSHIFT,RSHIFT,ANDF,ORF
      LOGICAL         DITUP,NXTUP,NXTRST
      INTEGER         BUF,DIT,DITPBN,DITLBN,DITSIZ,DITNSB,DITBL,ORF,
     1                BLKSIZ,DIRSIZ,SUPSIZ,FILSIZ,AVBLKS,ANDF,RSHIFT,
     2                FILNUM,TPFREE,BTFREE,FILIND,FILSUP,NMSBR(2)
      COMMON /MACHIN/ MACH,IHALF,JHALF
      COMMON /ZZZZZZ/ BUF(1)
      COMMON /SOF   / DIT,DITPBN,DITLBN,DITSIZ,DITNSB,DITBL,
     1                IODUM(8),MDIDUM(4),
     2                NXT,NXTPBN,NXTLBN,NXTTSZ,NXTFSZ(10),NXTCUR,
     3                DITUP,MDIUP,NXTUP,NXTRST
      COMMON /SYS   / BLKSIZ,DIRSIZ,SUPSIZ,AVBLKS
      COMMON /SOFCOM/ NFILES,FILNAM(10),FILSIZ(10)
      COMMON /SYSTEM/ NBUFF
      DATA   IRD    , IWRT / 1, 2    /
      DATA   INDSBR / 11   /,  NMSBR / 4HGETB,4HLK  /
C
C     CHECK IF THE SUPERBLOCK NXTCUR HAS A FREE BLOCK.
C
      CALL CHKOPN (NMSBR(1))
      LMASK = LSHIFT(JHALF,IHALF)
    5 IF (NXTCUR .EQ. NXTLBN) GO TO 40
C
C     THE SUPERBLOCK NXTCUR IS NOT IN CORE.
C
      IF (NXTLBN .EQ. 0) GO TO 10
C
C     THE IN CORE BUFFER SHARED BY THE DIT AND THE ARRAY NXT IS NOW
C     OCCUPIED BY A BLOCK OF NXT.
C
      IF (.NOT.NXTUP) GO TO 20
C
C     THE BLOCK OF THE ARRAY NXT WHICH IS NOW IN CORE HAS BEEN UPDATED,
C     MUST THEREFORE WRITE IT OUT BEFORE READING IN A NEW BLOCK.
C
      CALL SOFIO (IWRT,NXTPBN,BUF(NXT-2))
      NXTUP = .FALSE.
      GO TO 20
   10 IF (DITPBN .EQ. 0) GO TO 20
C
C     THE IN CORE BUFFER SHARED BY THE DIT AND THE ARRAY NXT IS NOW
C     OCCUPIED BY A BLOCK OF DIT.
C
      IF (.NOT.DITUP) GO TO 15
C
C     THE DIT BLOCK WHICH IS NOW IN CORE HAS BEEN UPDATED, MUST
C     THEREFORE WRITE IT OUT BEFORE READING IN A NEW BLOCK.
C
      CALL SOFIO (IWRT,DITPBN,BUF(DIT-2))
      DITUP  = .FALSE.
   15 DITPBN = 0
      DITLBN = 0
C
C     READ INTO CORE THE DESIRED BLOCK OF THE ARRAY NXT.
C
   20 NXTLBN = NXTCUR
      NXTPBN = 0
      LEFT   = NXTLBN
      DO 25 I = 1,NFILES
      IF (LEFT .GT. NXTFSZ(I)) GO TO 23
      FILNUM = I
      GO TO 30
   23 NXTPBN = NXTPBN + FILSIZ(I)
      LEFT   = LEFT - NXTFSZ(I)
   25 CONTINUE
      GO TO 510
   30 NXTPBN = NXTPBN + (LEFT-1)*SUPSIZ + 2
      CALL SOFIO (IRD,NXTPBN,BUF(NXT-2))
C
C     CHECK THE FREE LIST OF SUPERBLOCK NXTCUR.
C
   40 TPFREE = RSHIFT(BUF(NXT+1),IHALF)
      IF (TPFREE .GT. 0) GO TO 180
C
C     THE SUPERBLOCK NXTCUR DOES NOT HAVE ANY FREE BLOCKS.
C
      IF (NXTCUR .EQ. NXTTSZ) GO TO 50
      NXTCUR = NXTCUR + 1
      GO TO 5
C
C     NXTCUR IS THE LAST SUPERBLOCK.
C
   50 IF (NXTRST) GO TO 60
      NXTCUR = 1
      NXTRST = .TRUE.
      GO TO 5
C
C     MUST START A BRAND NEW SUPERBLOCK.
C
   60 NXTRST = .FALSE.
      IF (NXTUP) CALL SOFIO (IWRT,NXTPBN,BUF(NXT-2))
      NXTUP  = .FALSE.
   70 NXTCUR = NXTCUR + 1
      LEFT   = NXTCUR
      DO 80 I = 1,NFILES
      IF (LEFT .GT. NXTFSZ(I)) GO TO 75
      FILNUM = I
      GO TO 85
   75 LEFT   = LEFT-NXTFSZ(I)
   80 CONTINUE
      NXTCUR = NXTCUR - 1
      GO TO 500
   85 LAST   = NBUFF - 4
      DO 86 I = 1,LAST
      BUF(NXT+I) = 0
   86 CONTINUE
      IF (LEFT .EQ. 1) GO TO 110
C
C     NXTCUR IS NOT THE FIRST SUPERBLOCK ON FILE FILNUM.
C
      NXTPBN = NXTPBN + SUPSIZ
      IF (LEFT .NE. NXTFSZ(FILNUM)) GO TO 120
C
C     NXTCUR IS THE LAST BLOCK ON FILE FILNUM.
C
      LSTSIZ = MOD(FILSIZ(FILNUM)-2,SUPSIZ) + 1
      IF (LSTSIZ .GT. 1) GO TO 90
C
C     THE SIZE OF THE LAST BLOCK ON FILE FILNUM IS EQUAL TO 1.
C     THERE ARE THEREFORE NO FREE BLOCKS AVAILABLE ON SUPERBLOCK NXTCUR.
C     SET TPFREE AND BTFREE OF NXTCUR EQUAL TO ZERO.
C
      BUF(NXT+1) = 0
      AVBLKS = AVBLKS - 1
      CALL SOFIO (IWRT,NXTPBN,BUF(NXT-2))
      GO TO 70
C
C     THE SIZE OF SUPERBLOCK NXTCUR IS LARGER THAN 1.
C
   90 IF (LSTSIZ .GT. 2) GO TO 100
C
C     THE SIZE OF SUPERBLOCK NXTCUR IS EQUAL TO 2.  THERE IS THEREFORE
C     ONLY ONE FREE BLOCK IN NXTCUR.  SET TPFREE AND BTFREE TO ZERO.
C
      BUF(NXT+1) = 0
      GO TO 170
C
C     THE SIZE OF SUPERBLOCK NXTCUR IS LARGER THAN 2.
C
  100 BTFREE = NXTPBN + LSTSIZ - 1
      GO TO 130
C
C     NXTCUR IS THE FIRST SUPERBLOCK ON FILE FILNUM.
C
  110 LSTSIZ = MOD(FILSIZ(FILNUM-1)-2,SUPSIZ) + 1
      NXTPBN = NXTPBN + LSTSIZ + 1
      AVBLKS = AVBLKS - 1
      IF (FILSIZ(FILNUM) .GE. SUPSIZ+1) GO TO 120
      BTFREE = NXTPBN + FILSIZ(FILNUM) - 2
      GO TO 130
  120 BTFREE = NXTPBN + SUPSIZ - 1
C
C     INITIALIZE THE NEW SUPERBLOCK.
C
  130 TPFREE = NXTPBN + 2
C
C     PUT THE VALUES OF BTFREE AND TPFREE IN THE FIRST WORD OF THE ARRAY
C     NXT BELONGING TO SUPERBLOCK NXTCUR.
C
      BUF(NXT+1) = BTFREE
      BUF(NXT+1) = ORF(BUF(NXT+1),LSHIFT(TPFREE,IHALF))
      IF (MOD(BTFREE,2) .EQ. 1) GO TO 140
C
C     BTFREE IS AN EVEN INTEGER.
C
      MAX = (BTFREE-NXTPBN+2)/2
      BUF(NXT+MAX+1) = 0
      GO TO 150
C
C     BTFREE IS AN ODD INTEGER.
C
  140 MAX = (BTFREE-NXTPBN+1)/2
      BUF(NXT+MAX+1) = LSHIFT(BTFREE,IHALF)
C
C     SET UP THE THREAD THROUGH THE BLOCKS OF SUPERBLOCK NXTCUR.
C
  150 IF (MAX.LT.3) GO TO 170
      DO 160 I = 3,MAX
      BUF(NXT+I) = 2*I + NXTPBN - 2
      BUF(NXT+I) = ORF(BUF(NXT+I),LSHIFT(2*I+NXTPBN-3,IHALF))
  160 CONTINUE
C
C     SETUP VARIABLES RELATED TO THE SUPERBLOCK NXTCUR.
C
  170 BUF(NXT+2) = 0
      INEW   = NXTPBN + 1
      AVBLKS = AVBLKS - 2
      NXTLBN = NXTCUR
      NXTTSZ = NXTCUR
      GO TO 230
C
C     SUPERBLOCK NXTCUR DOES HAVE A FREE BLOCK.
C
  180 INEW   = TPFREE
      AVBLKS = AVBLKS - 1
C
C     COMPUTE THE INDEX OF TPFREE ENTRY IN THE BLOCK OF ARRAY NXT
C     BELONGING TO SUPERBLOCK NXTCUR.
C
      FILIND = TPFREE
      DO 185 I = 1,NFILES
      IF (FILIND .LE. FILSIZ(I)) GO TO 187
      FILIND = FILIND - FILSIZ(I)
  185 CONTINUE
  187 FILSUP = (FILIND-1)/SUPSIZ
      IF (FILIND-1 .EQ. FILSUP*SUPSIZ) GO TO 190
      FILSUP = FILSUP + 1
  190 INDEX  = (FILIND-(FILSUP-1)*SUPSIZ)/2 + 1
      IF (MOD(TPFREE,2) .EQ. 1) GO TO 200
C
C     TPFREE IS AN EVEN INTEGER.  THE ENTRY FOR TPFREE IS THEREFORE
C     IN BITS (IHALF+1) TO (2*IHALF-1) OF THE WORD.  SAVE TPFREE ENTRY
C     IN NXTBLK AND THEN SET IT TO ZERO.
C
      NXTBLK = RSHIFT(BUF(NXT+INDEX),IHALF)
      BUF(NXT+INDEX) = ANDF(BUF(NXT+INDEX),JHALF)
      GO TO 210
C
C     TPFREE IS AN ODD INTEGER.  THE ENTRY FOR TPFREE IS THEREFORE
C     IN BITS 0 TO IHALF OF THE WORD.  SAVE TPFREE ENTRY IN NXTBLK
C     AND THEN SET IT TO ZERO.
C
  200 NXTBLK = ANDF(BUF(NXT+INDEX),JHALF)
      BUF(NXT+INDEX) = ANDF(BUF(NXT+INDEX),LMASK)
  210 BTFREE = ANDF(BUF(NXT+1),JHALF)
      IF (TPFREE .EQ. BTFREE) GO TO 220
C
C     SET TPFREE TO NXTBLK.
C
      BUF(NXT+1) = ORF(ANDF(BUF(NXT+1),JHALF),LSHIFT(NXTBLK,IHALF))
      GO TO 230
C
C     SET TPFREE AND BTFREE TO ZERO.
C
  220 BUF(NXT+1) = 0
  230 IF (IOLD .EQ. 0) GO TO 250
C
C     WANT TO SET IOLD POINTER TO INEW.
C
      NXTUP =.TRUE.
      CALL FNXT (IOLD,IND)
      IF (MOD(IOLD,2) .EQ. 1) GO TO 240
C
C     IOLD IS AN EVEN INTEGER
C
      BUF(IND) = ORF(ANDF(BUF(IND),JHALF),LSHIFT(INEW,IHALF))
      GO TO 250
C
C     IOLD IS AN ODD INTEGER
C
  240 BUF(IND) = ORF(ANDF(BUF(IND),LMASK),INEW)
  250 NXTUP = .TRUE.
      RETURN
C
C     ERROR MESSAGES.
C
  500 INEW = -1
      RETURN
  510 CALL ERRMKN (INDSBR,4)
      RETURN
      END

      SUBROUTINE CDTFBS (DX,DY,IOBUF,FILEU,NROW)
C
C     CDTFBS IS A SPECIAL VERSION OF GFBS USED BY COMPLEX DETERMINATE
C     METHOD
C
C     DEFINITION OF INPUT PARAMETERS
C
C     FILEU = MATRIX CONTROL BLOCK FOR THE UPPER TRIANGLE U
C     DX    = THE LOAD VECTOR B
C     DY    = THE SOLUTION VECTOR X
C     IOBUF = THE INPUT BUFFER
C
      INTEGER          FILEU(7)  ,TYPEAR   ,CDP      ,PARM(4)  ,
     1                 IOBUF(1)
      DOUBLE PRECISION DX(1)     ,DY(1)    ,DTEMP
      COMMON /NAMES /  RD        ,RDREW    ,WRT      ,WRTREW   ,
     1                 REW       ,NOREW    ,EOFNRW   ,RSP      ,
     2                 RDP       ,CSP      ,CDP      ,SQR      ,
     3                 RECT      ,DIAG     ,LOWTRI   ,UPRTRI   ,
     4                 SYM       ,ROW      ,IDENTY
      COMMON /UNPAKX/  ITYPEX    ,IUNPAK   ,JUNPAK   ,INCRX
      DATA    PARM(3), PARM(4)   /4HDETF,4HBS  /
C
      INCRX  = 1
      ITYPEX = CDP
      TYPEAR = CDP
C
C     BEGIN BACKWARD PASS
C
      IOFF = FILEU(7) - 1
      PARM(2) = FILEU(1)
      CALL OPEN (*80,FILEU,IOBUF,RD)
      DO 70 I = 1,NROW
      IUNPAK = 0
      J  = NROW - I + 1
      JJ = J + J
      CALL BCKREC (FILEU)
      CALL UNPACK (*90,FILEU,DY)
      CALL BCKREC (FILEU)
      ISING = 0
      K = (JUNPAK-IUNPAK+1)*2
      JU = JUNPAK + JUNPAK
      GO TO 30
   10 ISING = 1
C
C     DIVIDE BY THE DIAGONAL
C
      DTEMP    = (DX(JJ)*DY(K-1)-DX(JJ-1)*DY(K))/(DY(K)**2+DY(K-1)**2)
      DX(JJ-1) = (DX(JJ-1)*DY(K-1)+DX(JJ)*DY(K))/(DY(K)**2+DY(K-1)**2)
      DX(JJ  ) = DTEMP
   20 K  = K  - 2
      JU = JU - 2
      JUNPAK = JUNPAK - 1
      IF (K .EQ. 0) GO TO 60
      IF (DY(K).EQ.0.D0 .AND. DY(K-1).EQ.0.D0) GO TO 20
   30 IF (JUNPAK-J) 50,10,40
   40 JK = (J-IOFF)*2
      DX(JK-1) = DX(JK-1) - DX(JU-1)*DY(K-1) + DX(JU  )*DY(K)
      DX(JK  ) = DX(JK  ) - DX(JU  )*DY(K-1) - DX(JU-1)*DY(K)
      GO TO 20
   50 CONTINUE
      DX(JU-1) = DX(JU-1) - DX(JJ-1)*DY(K-1) + DX(JJ  )*DY(K)
      DX(JU  ) = DX(JU  ) - DX(JJ  )*DY(K-1) - DX(JJ-1)*DY(K)
      GO TO 20
   60 IF (ISING .EQ. 0) GO TO 90
   70 CONTINUE
      CALL CLOSE (FILEU,REW)
      RETURN
C
   80 PARM(1) = -1
      GO TO 100
   90 PARM(1) = -5
  100 CALL MESAGE (PARM(1),PARM(2),PARM(3))
      RETURN
      END

      SUBROUTINE SAVPOS ( FILE, IPOS )
      INCLUDE 'DSIOF.COM'
      COMMON / DDIOSV / IFLPOS( 2,80 )
      INTEGER          FILE
      NAME = FILE
      CALL DSGEFL
      IPOS = IFLPOS( 1,IFILEX )*MULQ2 + IFLPOS( 2, IFILEX )
      IF (IPRVOP .EQ. 0)
     &        IPOS = FCB(3,IFILEX)*MULQ2 + FCB(4,IFILEX)
      RETURN
        END

      INTEGER FUNCTION SOFSIZ (DUM)
C*****
C     RETURNS THE REMAINING NUMBER OF AVAILABLE WORDS ON THE SOF.
C*****
      INTEGER      BLKSIZ,AVBLKS
      DIMENSION    NMSBR(2)
      COMMON /SYS/ BLKSIZ,DIRSIZ,SUPSIZ,AVBLKS
      DATA  NMSBR/ 4HSOFS,4HIZ  /
C*****
      CALL CHKOPN (NMSBR(1))
      SOFSIZ = BLKSIZ*AVBLKS
      RETURN
      END

      SUBROUTINE FBSI4 (BLOCK, Y, MEM, DMEM, IBUFF)
C
C     FBSI4 EXECUTES THE FORWARD/BACKWARD PASS FOR FBSI IN CDP
C
      INTEGER          BLOCK(8), DBL, BUF(2), SUBNAM, BEGN, END
      INTEGER          IBUFF(2), DBU, DBB, DBC
      INTEGER          RD, RDREW, WRT, WRTREW, REW, MEM(2)
      DOUBLE PRECISION L, DMEM(2)
      DOUBLE COMPLEX   Y(1), YJK, SUM, ZERO, LJJ
      CHARACTER        UFM*23, UWM*25, UIM*29, SFM*25
      COMMON /NAMES /  RD, RDREW, WRT, WRTREW, REW
      COMMON /XMSSG /  UFM, UWM, UIM, SFM
      COMMON /ZZZZZZ/  L(2)
      COMMON /SYSTEM/  SYSBUF, NOUT
      COMMON /FBSX  /  DBL(7), DBU(7), DBB(7), DBC(7)
      COMMON /FBSM  /  NVEC  , NVECSZ, NWDS  , LASIND, IPOS(7)
      DATA             ZERO / (0.0D+0, 0.0D+0 )    /
      DATA    SUBNAM, BEGN, END / 4HFBS4, 4HBEGN, 4HEND /
C
      NCOL   = DBL(2)
      BUF(1) = SUBNAM
      BUF(2) = BEGN
      IOPEN  = 0
      CALL CONMSG (BUF,2,0)
      LAST   = NVEC * NVECSZ
      NIDLT  = 1
      LCOL   = IPOS( 1 )
      DO 1000 J = 1,LCOL
C      PRINT *,' FORWARD, PROCESSING COLUMN J=',J
      J1 = J - 1
C
C CHECK IF THIS ROW VALUE IS ZERO FOR ALL RIGHT HAND VECTORS
C
      DO 10 K = J,LAST,NVECSZ
      IF (Y(K) .NE. ZERO) GO TO 100
10    CONTINUE
C
C ALL VALUES FOR THIS ROW ARE ZERO, SKIP TO NEXT ROW OF RIGHT HAND VECTORS
C
      IF ( NIDLT .GE. LASIND ) GO TO 1005
      KCOL   = MEM( NIDLT )
      IF ( KCOL .NE. J ) GO TO 7001
40    NROWS  = MEM( NIDLT+1 )
      NIDLT  = NIDLT + NROWS*NWDS + 4
      IF ( NIDLT .GE. LASIND ) GO TO 1005
      KCOL = MEM( NIDLT )
      IF ( KCOL .NE. J ) GO TO 1000
      GO TO 40
C
C     GET 1ST STRING FOR COLUMN AND SAVE DIAGONAL ELEMENT
C
100   CONTINUE
      KCOL   = MEM( NIDLT )
      IF ( KCOL .NE. J ) GO TO 7001
      NROWS  = MEM( NIDLT + 1 )    
      IROW   = MEM( NIDLT + NROWS*NWDS + 2 )
      INDXI  = ( NIDLT + 3 ) / 2
      INDXL  = INDXI + NROWS*2 - 1
      LJJ   = 1.0D+0 / DCMPLX( DMEM( INDXI ), DMEM( INDXI+1 ) )
      IF (NROWS .EQ. 1) GO TO 600
      INDXI = INDXI + 2
      IROW  = IROW + 1
C
C     PROCESS CURRENT STRING IN TRIANGULAR FACTOR AGAINST EACH
C     LOAD VECTOR IN CORE -- Y(I,K) = Y(I,K) + L(I,J)*Y(J,K)
C
300   DO 500 K   = 1, LAST, NVECSZ
      YJK        = Y( J1+K )
      IF ( YJK .EQ. ZERO ) GO TO 500
      IYROW      = IROW + K - 1
      DO 400 IJ  = INDXI, INDXL, 2
      Y( IYROW ) = Y( IYROW ) + DCMPLX( DMEM(IJ), DMEM(IJ+1) ) * YJK
400   IYROW      = IYROW + 1
500   CONTINUE
C
C     GET NEXT STRING IN TRIANGULAR FACTOR
C
600   CONTINUE
      NIDLT  = NIDLT + 4 + NROWS*NWDS
      IF ( NIDLT .GE. LASIND ) GO TO 800
      KCOL   = MEM( NIDLT )
      IF ( KCOL .NE. J ) GO TO 800
      NROWS  = MEM( NIDLT + 1 )
      IROW   = MEM( NIDLT + NROWS*NWDS + 2 )
      INDXI  = ( NIDLT + 3 ) / 2
      INDXL  = INDXI + NROWS*2 - 1
      GO TO 300
C
C     END-OF-COLUMN ON TRIANGULAR FACTOR -- DIVIDE BY DIAGONAL
C
800   DO 900 K = J,LAST,NVECSZ
      Y(K) = Y(K)*LJJ
900   CONTINUE
C
1000  CONTINUE
1005  CONTINUE
      IF ( LCOL .EQ. NCOL ) GO TO 2005
      IFCOL = LCOL + 1
      CALL GOPEN  ( DBL, IBUFF, RDREW ) 
C
C POSITION FILE TO APPROPRIATE COLUMN TO BE READ 
C
      CALL DSSPOS ( DBL, IPOS(2), IPOS(3), IPOS(4) )
      DO 2000 J = IFCOL, NCOL
      J1 = J - 1
C
C CHECK IF THIS ROW VALUE IS ZERO FOR ALL RIGHT HAND VECTORS
C
      DO 1010 K = J,LAST,NVECSZ
      IF (Y(K) .NE. ZERO) GO TO 1100
1010  CONTINUE
C
C ALL VALUES FOR THIS ROW ARE ZERO, SKIP TO NEXT ROW OF RIGHT HAND VECTORS
C
      CALL SKPREC ( DBL, 1 )
      GO TO 2000
C
C     GET 1ST STRING FOR COLUMN AND SAVE DIAGONAL ELEMENT
C
1100  CONTINUE
      BLOCK(8) = -1
      CALL GETSTR ( *7002, BLOCK )
      IF (BLOCK(4) .NE. J) GO TO 7002
      IROW  = BLOCK(4)  
      INDXI = BLOCK(5)
      NROWS = BLOCK(6)
      INDXL = INDXI + NROWS*2 - 1  
1200  CONTINUE
      LJJ   = 1.0D+0 / DCMPLX( L( INDXI ), L( INDXI+1 ) )
      IF (NROWS .EQ. 1) GO TO 1600
      INDXI = INDXI + 2
      IROW  = IROW + 1
C
C     PROCESS CURRENT STRING IN TRIANGULAR FACTOR AGAINST EACH
C     LOAD VECTOR IN CORE -- Y(I,K) = Y(I,K) + L(I,J)*Y(J,K)
C
1300  DO 1500 K   = 1, LAST, NVECSZ
      YJK        = Y( J1+K )
      IF ( YJK .EQ. ZERO ) GO TO 1500
      IYROW      = IROW + K - 1
      DO 1400 IJ  = INDXI, INDXL, 2
      Y( IYROW ) = Y( IYROW ) + DCMPLX( L(IJ), L(IJ+1) ) * YJK
1400  IYROW      = IYROW + 1
1500  CONTINUE
C
C     GET NEXT STRING IN TRIANGULAR FACTOR
C
1600  CONTINUE
      CALL ENDGET ( BLOCK )
      CALL GETSTR ( *1800, BLOCK )
      IROW  = BLOCK(4)  
      INDXI = BLOCK(5)
      NROWS = BLOCK(6)
      INDXL = INDXI + NROWS*2 - 1  
      GO TO 1300
C
C     END-OF-COLUMN ON TRIANGULAR FACTOR -- DIVIDE BY DIAGONAL
C
1800  DO 1900 K = J,LAST,NVECSZ
      Y(K) = Y(K)*LJJ
1900  CONTINUE
2000  CONTINUE
2005  CONTINUE
      IF ( NCOL  .EQ. 1 ) GO TO 7000    
      J = NCOL - 1   
      IF ( LCOL .EQ. NCOL ) GO TO 3000
C
C     INITIALIZE FOR BACKWARD PASS BY SKIPPING THE NTH COLUMN
C
      CALL BCKREC (BLOCK)
C
C     GET A STRING IN CURRENT COLUMN. IF THIS STRING INCLUDES DIAGONAL,
C     ADJUST STRING TO SKIP IT.
C
2200  J1 = J - 1
      BLOCK(8) = -1
2300  CALL GETSTB (*2900,BLOCK)
      IROW  = BLOCK( 4 )
      NROWS = BLOCK( 6 )
      IF (IROW-NROWS .EQ. J1) NROWS = NROWS - 1
      IF (NROWS .EQ. 0) GO TO 2800
      INDXI = BLOCK( 5 )
C
C     PROCESS CURRENT STRING IN TRIANGULAR FACTOR AGAINST EACH
C     LOAD VECTOR IN CORE -- Y(J,K) = Y(J,K) + L(J,I)*Y(I,K)
C
      DO 2700 K = 1,LAST,NVECSZ
      JI  = INDXI + 2
      IK  = IROW  + K
      SUM = (0.0D+0, 0.0D+0)
      DO 2600 II = 1,NROWS
      JI = JI - 2
      IK = IK - 1
      SUM = SUM + DCMPLX( L(JI),L(JI+1) ) * Y(IK)
2600  CONTINUE
      Y(J1+K) = Y(J1+K) + SUM
2700  CONTINUE
C
C     TERMINATE CURRENT STRING AND GET NEXT STRING
C
2800  CONTINUE
      CALL ENDGTB (BLOCK)
      GO TO 2300
C
C     END-OF-COLUMN -- TEST FOR COMPLETION
C
2900  IF (J .EQ. 1) GO TO 7000
      J = J - 1
      IF ( J .EQ. LCOL ) GO TO 3010
      GO TO 2200
C
3000  CONTINUE
C
C     INITIALIZE FOR BACKWARD PASS BY SKIPPING THE NTH COLUMN
C
3005  CONTINUE
      NIDLT = NIDLT - 1          
      NROWS = MEM( NIDLT )
      NIDLT = NIDLT - NROWS*NWDS - 3
      KCOL  = MEM( NIDLT )
      IF ( KCOL .EQ. NCOL ) GO TO 3005
      NIDLT = NIDLT + NROWS*NWDS + 4
3010  CONTINUE
C
C     GET A STRING IN CURRENT COLUMN. IF THIS STRING INCLUDES DIAGONAL,
C     ADJUST STRING TO SKIP IT.
C
3200  J1 = J - 1
C      print *,' processing column in backward step, j=',j
3250  NIDLT = NIDLT - 1
      IF ( NIDLT .LE. 1 ) GO TO 3900
      NROWS = MEM( NIDLT )
      IROW  = MEM( NIDLT-1 )
      NIDLT = NIDLT - NROWS*NWDS - 3
      KCOL  = MEM( NIDLT )
3260  CONTINUE     
      IF ( KCOL .NE. J ) GO TO 3900
      INDXI = NIDLT/2  + NROWS*2 
      IROW  = IROW + NROWS - 1
      IF ( (IROW-NROWS) .EQ. J1 ) NROWS = NROWS - 1   
C
C     PROCESS CURRENT STRING IN TRIANGULAR FACTOR AGAINST EACH
C     LOAD VECTOR IN CORE -- Y(J,K) = Y(J,K) + L(J,I)*Y(I,K)
C
      DO 3700 K = 1,LAST,NVECSZ
      JI  = INDXI + 2
      IK  = IROW  + K
      SUM = 0.0D+0
      DO 3600 II = 1,NROWS
      JI = JI - 2
      IK = IK - 1
      SUM = SUM + DCMPLX( DMEM(JI),DMEM(JI+1) ) * Y(IK)
3600  CONTINUE
      Y(J1+K) = Y(J1+K) + SUM
3700  CONTINUE
C
C     TERMINATE CURRENT STRING AND GET NEXT STRING
C
      GO TO 3250
C
C     END-OF-COLUMN -- TEST FOR COMPLETION
C
3900  IF (J .EQ. 1) GO TO 7000
      J  = J - 1
      J1 = J - 1
      GO TO 3260
C
7000  BUF(2) = END
      CALL CONMSG (BUF,2,0)
      CALL CLOSE ( DBL, REW )
      RETURN
C
C     FATAL ERROR MESSAGE
C
7001  CONTINUE
7002  CONTINUE
      WRITE  (NOUT,9001) SFM,SUBNAM
9001  FORMAT (A25,' 2149, SUBROUTINE ',A4,/5X,'FIRST ELEMENT OF A COLU',
     1      'MN OF LOWER TRIANGULAR MATRIX IS NOT THE DIAGONAL ELEMENT')
      CALL MESAGE (-61,0,0)
      RETURN
      END

      SUBROUTINE DESVEL
C
C     DESVAL COMPUTES DESIGN VELOCITY AND ACCELERATION SPECTRA FOR
C     DDAM. THE ASSUMUED FORM FOR VELOCITY IS
C
C                            VELB + W
C        VEL = VELI * VELA * --------
C                            VELC + W
C
C     WHERE VELI IS VEL1,VEL2,OR VEL3 FOR TH 1,2,3, DIRECTIONS
C         W IS THE EFFECTIVE WEIGHT = MATRIX EFFW/1000.
C         VEL,VELA ARE IN LENGTH/SECOND
C     MATRIX SSDV WILL BE OUTPUT
C     DESIGN ACCELERATIONS HAVE THE SAME FORM AS VELOCITY EXCEPT FOR
C     ONE CASE WHERE
C         ACC = ACCI*ACCA*(ACCB+W)*(ACCC+W)/(ACCD+W)**2
C
C     WHERE ACC IS IN G-S AND W IS AS ABOVE
C     IF ACCD IA ZERO, ACC HAS THE SAME FORM AS VEL
C     MATRICES ACC AND VEL*OMEGA/G WILL BE OUTPUT FOR COMPARISON
C     PURPOSES
C     IN ADDITION, DATA BLOCK MINAC WILL CONTAIN THE MINIMUM
C     OF ACCE*GG VS. VEL*OMEGA FOR USE IN COMPUTING STATIC LOADS
C *** ALL VELOCITY PARAMETERS MUST BE PUT ON PARAM BULK DATA CARDS,
C                             ----
C     I.E.,VEL1,VEL2,VEL3,VELA,VELB,VELC. ACCELERATION PARAMETERS ARE
C     DEFAULTED TO ZERO AND NEED NOT BE ON PARAM CARDS IF NOT WANTED.
C
C     DESVEL   EFFW,OMEGA / SSDV,ACC,VWG,MINAC,MINOW2 / C,Y,GG=386.4/
C              C,Y,VEL1/C,Y,VEL2/C,Y,VEL3/C,Y,VELA/C,Y,VELB/C,Y,VELC/
C              C,Y,ACC1=0./C,Y,ACC2=0./C,Y,ACC3=0./C,Y,ACCA=0./
C              C,Y,ACCB=0./C,Y,ACCC=0./C,Y,ACCD=0.
C
      LOGICAL         ZERO
      INTEGER         BUF1,BUF2,BUF3,EFFW,OMEGA,SSDV,ACC,VWG,SYSBUF,
     1                BUF4,MCB4(7),BUF5,MCB5(7)
      DIMENSION       NAM(2),MCB1(7),MCB2(7),MCB3(7),IZ(1)
      CHARACTER       UFM*23,UWM*25,UIM*29
      COMMON /XMSSG / UFM,UWM,UIM
      COMMON /UNPAKX/ JOUT,III,NNN,JNCR
      COMMON /PACKX / IIN,IOUT,II,NN,INCR
      COMMON /SYSTEM/ SYSBUF,IPRINT
      COMMON /BLANK / GG,VEL1,VEL2,VEL3,VELA,VELB,VELC,ACC1,ACC2,ACC3,
     1                ACCA,ACCB,ACCC,ACCD
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE     (Z(1),IZ(1))
      DATA    EFFW  , OMEGA,SSDV,ACC,VWG,MINAC,MINOW2 /
     1        101   , 102  ,201 ,202,203,204  ,205    /
      DATA    NAM   / 4HDESV,4HEL  /
C
      ZERO  = .FALSE.
      LCORE = KORSZ(Z)
      BUF1  = LCORE - SYSBUF + 1
      BUF2  = BUF1 - SYSBUF
      BUF3  = BUF2 - SYSBUF
      BUF4  = BUF3 - SYSBUF
      BUF5  = BUF4 - SYSBUF
      LCORE = BUF5 - 1
      IF (LCORE .LE. 0) CALL MESAGE (-8,0,NAM)
C
      JOUT = 1
      IIN  = 1
      IOUT = 1
      INCR = 1
      JNCR = 1
      II   = 1
      III  = 1
C
C     UNPACK AND STORE EFFW AND OMEGA
C
      MCB1(1) = EFFW
      CALL RDTRL (MCB1)
      NCOL = MCB1(2)
      NROW = MCB1(3)
      NNN  = NROW
      NN   = NNN
      NTOT = NCOL*NROW
      NALL = NTOT+NNN
C
      IF (LCORE .LT. (NCOL+6)*NNN) CALL MESAGE (-8,0,NAM)
      CALL GOPEN (EFFW,Z(BUF1),0)
      DO 20 I = 1,NCOL
      JJ = (I-1)*NNN
      CALL UNPACK (*10,EFFW,Z(JJ+1))
      GO TO 20
   10 DO 15 J = 1,NNN
   15 Z(JJ+J) = 0.
C
   20 CONTINUE
      CALL CLOSE (EFFW,1)
      CALL GOPEN (OMEGA,Z(BUF1),0)
      CALL UNPACK (*30,OMEGA,Z(NTOT+1))
      GO TO 50
   30 DO 40 I = 1,NNN
   40 Z(NTOT+I) = 0.
C
   50 CALL CLOSE (OMEGA,1)
      NMODES = NROW
      NDIR   = NCOL
C
      CALL GOPEN (SSDV,Z(BUF1),1)
      CALL GOPEN (ACC,Z(BUF2),1)
      CALL GOPEN (VWG,Z(BUF3),1)
      CALL GOPEN (MINAC,Z(BUF4),1)
      CALL GOPEN (MINOW2,Z(BUF5),1)
C
      MCB1(1) = SSDV
      MCB1(2) = 0
      MCB1(3) = NROW
      MCB1(4) = 2
      MCB1(5) = 1
      MCB1(6) = 0
      MCB1(7) = 0
      MCB2(1) = ACC
      MCB2(2) = 0
      MCB2(3) = NROW
      MCB2(4) = 2
      MCB2(5) = 1
      MCB2(6) = 0
      MCB2(7) = 0
      MCB3(1) = VWG
      MCB3(2) = 0
      MCB3(3) = NROW
      MCB3(4) = 2
      MCB3(5) = 1
      MCB3(6) = 0
      MCB3(7) = 0
      MCB4(1) = MINAC
      MCB4(2) = 0
      MCB4(3) = NROW
      MCB4(4) = 2
      MCB4(5) = 1
      MCB4(6) = 0
      MCB4(7) = 0
      MCB5(1) = MINOW2
      MCB5(2) = 0
      MCB5(3) = NROW
      MCB5(4) = 2
      MCB5(5) = 1
      MCB5(6) = 0
      MCB5(7) = 0
C
      DO 130 I = 1,NDIR
      IPT = (I-1)*NNN
      DO 120 J = 1,NMODES
C
C     EFFECTIVE WEIGHT FOR JTH MODE IN ITH DIRECTION (IN 1000-S)
C
      EFWT = Z(IPT+J)/1000.
      GO TO (60,70,80), I
   60 VELI = VEL1
      ACCI = ACC1
      GO TO 90
   70 VELI = VEL2
      ACCI = ACC2
      GO TO 90
   80 VELI = VEL3
      ACCI = ACC3
C
   90 VEL = VELI*VELA*(VELB+EFWT)/(VELC+EFWT)
      IF (ACCD .NE. 0.) GO TO 100
      ACCE = ACCI*ACCA*(ACCB+EFWT)/(ACCC+EFWT)
      GO TO 110
C
  100 ACCE = ACCI*ACCA*(ACCB+EFWT)*(ACCC+EFWT)/(ACCD+EFWT)**2
C
  110 OMEG = Z(NTOT+J)
      VWOG = VEL*OMEG/GG
C
C     VELOCITIES FOR ITH DIRECTION ARE IN Z(NALL+1)-Z(NALL+NNN)
C     ACCELERATIONS ARE IN NEXT NNN LOCATIONS, VWOG IN 3RD NNN
C     MAXIMUM OF VEL*OMEG OR ACCE*GG IS IN 4TH NNN
C
      Z(NALL      +J) = VEL
      Z(NALL+ NNN +J) = ACCE
      Z(NALL+2*NNN+J) = VWOG
      Z(NALL+3*NNN+J) = GG*AMIN1(ACCE,VWOG)
      IF (ABS(OMEG) .LT. 0.01) GO TO 125
      Z(NALL+4*NNN+J) = Z(NALL+3*NNN+J)/OMEG**2
      GO TO 120
C
C     IN DDAM, THERE SHOULD BE NO RIGID BODY MODES.ZERO THE RESPONSE.
C
  125 Z(NALL+4*NNN+J) = 0.
      ZERO = .TRUE.
C
C     GET ANOTHER MODE FOR THIS DIRECTION
C
  120 CONTINUE
C
C     PACK RESULTS FOR THIS DIRECTION
C
      CALL PACK (Z(NALL      +1),SSDV,MCB1)
      CALL PACK (Z(NALL+NNN  +1),ACC,MCB2)
      CALL PACK (Z(NALL+2*NNN+1),VWG,MCB3)
      CALL PACK (Z(NALL+3*NNN+1),MINAC,MCB4)
      CALL PACK (Z(NALL+4*NNN+1),MINOW2,MCB5)
C
C     GET ANOTHER DIRECTION
C
  130 CONTINUE
C
C     DONE
C
      CALL CLOSE  (SSDV,1)
      CALL CLOSE  (ACC,1)
      CALL CLOSE  (VWG,1)
      CALL CLOSE  (MINAC,1)
      CALL CLOSE  (MINOW2,1)
      CALL WRTTRL (MCB1)
      CALL WRTTRL (MCB2)
      CALL WRTTRL (MCB3)
      CALL WRTTRL (MCB4)
      CALL WRTTRL (MCB5)
C
      IF (.NOT.ZERO) RETURN
      WRITE  (IPRINT,135) UIM
  135 FORMAT (A29,', CIRCULAR FREQUENCY LESS THAN .01 IS ENCOUNTERED ',
     1       'IN DDAM.', /5X,'MAXIMUM RESPONSE FOR THAT MODE IS SET TO',
     2       ' ZERO. DDAM SHOULD HAVE NO RIGID BODY MODES.')
      RETURN
      END

      SUBROUTINE BITPAT (ICODE,IBITS)
C
C     THE PURPOSE OF THIS ROUTINE IS TO TRANSFORM THE DOF WORD INTO ITS
C     NASTRAN DIGITAL REPRESENTATION.
C
      EXTERNAL        ORF
      INTEGER         LIST(32),IBITS(2),ORF,INT(9)
      COMMON /SYSTEM/ JUNK(38),NBPC,NBPW
      DATA    IBLANK/ 4H    /
      DATA    INT   / 1H1,1H2,1H3,1H4,1H5,1H6,1H7,1H8,1H9 /
C
      IBITS(1) = IBLANK
      IBITS(2) = IBLANK
C
      CALL DECODE (ICODE,LIST,N)
      IF (N .EQ. 0) RETURN
C
      J = 1
      NBITS = -NBPC
      DO 20 I = 1,N
      NBITS = NBITS + NBPC
      IA = LIST(I)  + 1
      K  = NBPW - NBITS
      IBITS(J) = KLSHFT(KRSHFT(IBITS(J),K/NBPC),K/NBPC)
      IBITS(J) = ORF(IBITS(J),KRSHFT(INT(IA),NBITS/NBPC))
      IF (I .NE. 4) GO TO 20
      J = 2
      NBITS = -NBPC
   20 CONTINUE
      RETURN
      END

      SUBROUTINE CMRD2F (KODE)
C
C     THIS SUBROUTINE CALCULATES THE FINAL STRUCTURAL MATRICES FOR THE
C     CMRED2 MODULE.
C
C     INPUT  DATA
C     GINO - KBB    - STIFFNESS PARTITION MATRIX
C            KIB    - KIB STIFFNESS PATTITION MATRIX
C            HIE    - HIE PARTITION MATRIX
C            KII    - KII PARTITION MATRIX
C            HGH    - HORG PARTITION MATRIX
C            MAA    - MASS INPUT MATRIX
C            BAA    - DAMPING INPUT MATRIX
C            K4AA   - STIFFNESS INPUT MATRIX
C            PAA    - LOADS INPUT MATRIX
C     SOF  - GIMS   - G TRANSFORMATION MATRIX
C
C     OUTPUT DATA
C     GINO - KHH    - STIFFNESS MATRIX
C            MHH    - MASS MATRIX
C            BHH    - DAMPING MATRIX
C            K4HH   - K4HH MATRIX
C            PHH    - LOADS MATRIX
C     SOF  - KMTX   - STIFFNESS MATRIX
C            MMTX   - MASS MATRIX
C            PVEC   - LOADS MATRIX
C            PAPP   - APPENDED LOADS MATRIX
C            BMTX   - DAMPING MATRIX
C            K4MX   - K4MX STIFFNESS MATRIX
C
C     PARAMETERS
C     INPUT- POPT   - LOADS OPTION FLAG
C            GBUF   - GINO BUFFERS
C            INFILE - INPUT FILE NUMBERS
C            OTFILE - OUTPUT FILE NUMBERS
C            ISCR   - SCRATCH FILE NUMBERS
C            KORLEN - LENGTH OF OPEN CORE
C            KORBGN - BEGINNING ADDRESS OF OPEN CORE
C            OLDNAM - NAME OF SUBSTRUCTURE BEING REDUCED
C     OTHERS-PAA    - LOADS INPUT FILE NUMBER
C            KHH    - STIFFNESS OUTPUT FILE NUMBER
C            POVE   - LOADS OUTPUT FILE NUMBER
C            UPRT   - PARTITION VECTOR FILE NUMBER
C            ZEROMB - ZERO PARTITION FILE NUMBER
C            KBB    - KBB INPUT FILE NUMBER
C            ZEROBM - ZERO PARTITION MATRIX
C            KIB    - KIB INPUT FILE NUMBER
C            KII    - KII INPUT FILE NUMBER
C            KBARBB - KBARBB FILE NU BER
C            GIB    - GIB INPUT FILE NUMBER
C            KMM    - KMM FILE NUMBER
C            HGH    - HORG INPUT FILE NUMBER
C
      LOGICAL         SYMTRY,MODES,PONLY
      INTEGER         DRY,POPT,GBUF1,SBUF1,SBUF2,SBUF3,OTFILE,OLDNAM,Z,
     1                T,SIGNAB,SIGNC,PREC,SCR,TYPIN,TYPOUT,UN,UB,UI,
     2                FUSET,PREC3,PAA,HIM,POVE,UPRT,GIB,GIBBAR,HGHBAR,
     3                HGH,USETMR,CMRED2,PAPP,BLANKS,DBLKOR,HIMBAR,EQST
      DOUBLE PRECISION DZ
      DIMENSION       MODNAM(2),ITRLR1(7),ITRLR2(7),ITRLR3(7),ISUB(4),
     1                ITMLST(12),ITMNAM(2),RZ(1),DZ(1)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /BLANK / IDUM1,DRY,POPT,GBUF1,IDUM2(2),SBUF1,SBUF2,SBUF3,
     1                INFILE(11),OTFILE(6),ISCR(11),KORLEN,KORBGN,
     2                OLDNAM(2),NEWNAM(2),SYMTRY,IDUM6(4),MODES,
     3                IDUM7(4),PONLY,LSTZWD
      COMMON /ZZZZZZ/ Z(1)
      COMMON /MPYADX/ ITRLRA(7),ITRLRB(7),ITRLRC(7),ITRLRD(7),NZ,T,
     1                SIGNAB,SIGNC,PREC,SCR
      COMMON /PACKX / TYPIN,TYPOUT,IROW,NROW,INCR
      COMMON /BITPOS/ IDUM4(9),UN,IDUM5(10),UB,UI
      COMMON /PATX  / LCORE,NSUB(3),FUSET
      COMMON /SYSTEM/ IDUM3,IPRNTR
      COMMON /MPY3TL/ JTRLRA(7),JTRLRB(7),JTRLRE(7),JTRLRC(7),JSCR(3),
     1                LKORE,ICODE,PREC3
      EQUIVALENCE     (EQST,INFILE(5)),(USETMR,INFILE(6)),
     1                (PAA,INFILE(11)),(KHH,OTFILE(1)),(POVE,OTFILE(6)),
     2                (KBB,ISCR(1)),(KIB,ISCR(2)),(KII,ISCR(4)),
     3                (HIM,ISCR(10)),(UPRT,ISCR(1)),(HIMBAR,ISCR(8)),
     4                (KBARBB,ISCR(5)),(KMM,ISCR(6)),(GIB,ISCR(3)),
     5                (GIBBAR,ISCR(11)),(HGHBAR,ISCR(9)),(HGH,ISCR(8)),
     6                (RPRTN,ISCR(1)),(RZ(1),Z(1)),(DZ(1),Z(1))
      DATA    MODNAM/ 4HCMRD,4H2F  /, PAPP  / 4HPAPP/, BLANKS/ 4H    /
      DATA    CMRED2/ 26    /
      DATA    ITMLST/ 4HKMTX,4HHORG,4HHLFT,4HMMTX,4HBMTX,4HK4MX,4HPVEC,
     1                4HPAPP,4HPOVE,4HGIMS,4HPOAP,4HUPRT/
C
C     SELECT OPERATION MODE
C
      IF (DRY .EQ. -2) RETURN
      IF (PONLY .OR. DRY.EQ.0) GO TO 90
C
C     SET UP NEW SUBSTRUCTURE
C
      IF (MODES) GO TO 1
      NUMB = 1
      CALL SETLVL (NEWNAM,NUMB,OLDNAM,ITEST,CMRED2)
      IF (ITEST .EQ. 8) GO TO 290
C
C     CHECK FOR STIFFNESS MATRIX GENERATION
C
    1 ITRLR1(1) = KHH
      CALL RDTRL (ITRLR1)
      IF (ITRLR1(1) .LT. 0) GO TO 90
C
C     FORM PRELIMINARY STIFFNESS CALCULATION
C
C                                           T
C        **      **   **   **   **        ** **   **
C        *        *   *     *   *          * *     *
C        * KBARBB * = * KBB * + * GIB(BAR) * * KIB *
C        *        *   *     *   *          * *     *
C        **      **   **   **   **        ** **   **
C
      ITRLR1(1) = KBB
      CALL RDTRL (ITRLR1)
      IF (SYMTRY) GO TO 2
      ITRLR2(1) = GIBBAR
      CALL RDTRL (ITRLR2)
      GO TO 4
    2 ITEM  = ITMLST(10)
      CALL SOFTRL (OLDNAM,ITEM,ITRLR2)
      ITEST = ITRLR2(1)
      ITMNAM(1) = OLDNAM(1)
      ITMNAM(2) = OLDNAM(2)
      IF (ITEST .NE. 1) GO TO 200
      CALL MTRXI (GIB,OLDNAM,ITEM,0,ITEST)
      IF (ITEST .NE. 1) GO TO 200
      ITRLR2(1) = GIB
    4 ITRLR3(1) = KIB
      CALL RDTRL (ITRLR3)
      DO 10 I = 1,7
      ITRLRA(I) = ITRLR2(I)
      ITRLRB(I) = ITRLR3(I)
   10 ITRLRC(I) = ITRLR1(I)
      IFORM = 1
      IPRC  = 1
      ITYP  = 0
      IF (ITRLRA(5).EQ.2 .OR. ITRLRA(5).EQ.4) IPRC = 2
      IF (ITRLRB(5).EQ.2 .OR. ITRLRB(5).EQ.4) IPRC = 2
      IF (ITRLRC(5).EQ.2 .OR. ITRLRC(5).EQ.4) IPRC = 2
      IF (ITRLRA(5) .GE. 3) ITYP = 2
      IF (ITRLRB(5) .GE. 3) ITYP = 2
      IF (ITRLRC(5) .GE. 3) ITYP = 2
      ITYPE  = IPRC + ITYP
      CALL MAKMCB (ITRLRD,KBARBB,ITRLR1(3),IFORM,ITYPE)
      T      = 1
      SIGNAB = 1
      SIGNC  = 1
      PREC   = 0
      SCR    = ISCR(7)
      SCR    = ISCR(1)
      CALL SOFCLS
      DBLKOR = KORBGN/2 + 1
      NZ     = LSTZWD - (2*DBLKOR - 1)
      CALL MPYAD (DZ(DBLKOR),DZ(DBLKOR),DZ(DBLKOR))
      CALL WRTTRL (ITRLRD)
      KBAROW = ITRLRD(3)
      KCOL   = ITRLRD(2)
C
C     FORM PRELIMINARY STIFFNESS CALCULATION
C
C                              T
C        **   **   **        ** **   ** **   **
C        *     *   *          * *     * *     *
C        * KMM * = * HIM(BAR) * * KII * * HIM *
C        *     *   *          * *     * *     *
C        **   **   **        ** **   ** **   **
C
      ITRLR1(1) = KII
      ITRLR2(1) = HIM
      CALL RDTRL (ITRLR1)
      CALL RDTRL (ITRLR2)
      DO 20 I = 1,7
      ITRLRA(I) = ITRLR1(I)
      ITRLRB(I) = ITRLR2(I)
   20 ITRLRC(I) = 0
      IFORM = 2
      IPRC  = 1
      ITYP  = 0
      IF (ITRLRA(5).EQ.2 .OR. ITRLRA(5).EQ.4) IPRC = 2
      IF (ITRLRB(5).EQ.2 .OR. ITRLRB(5).EQ.4) IPRC = 2
      IF (ITRLRA(5) .GE. 3) ITYP = 2
      IF (ITRLRB(5) .GE. 3) ITYP = 2
      ITYPE = IPRC + ITYP
      CALL MAKMCB (ITRLRD,ISCR(2),ITRLR2(3),IFORM,ITYPE)
      PREC  = 0
      T     = 0
      SIGNAB= 1
      SIGNC = 1
      SCR   = ISCR(1)
      CALL MPYAD (DZ(DBLKOR),DZ(DBLKOR),DZ(DBLKOR))
      CALL WRTTRL (ITRLRD)
      ITRLR1(1) = HIM
      IF (.NOT.SYMTRY) ITRLR1(1) = HIMBAR
      CALL RDTRL (ITRLR1)
      DO 30 I = 1,7
      ITRLRA(I) = ITRLR1(I)
   30 ITRLRB(I) = ITRLRD(I)
      IFORM = 1
      IPRC  = 1
      ITYP  = 0
      IF (ITRLRA(5).EQ.2 .OR. ITRLRA(5).EQ.4) IPRC = 2
      IF (ITRLRB(5).EQ.2 .OR. ITRLRB(5).EQ.4) IPRC = 2
      IF (ITRLRA(5) .GE. 3) ITYP = 2
      IF (ITRLRB(5) .GE. 3) ITYP = 2
      ITYPE = IPRC + ITYP
      CALL MAKMCB (ITRLRD,KMM,ITRLR1(2),IFORM,ITYPE)
      T    = 1
      PREC = 0
      CALL MPYAD (DZ(DBLKOR),DZ(DBLKOR),DZ(DBLKOR))
      CALL WRTTRL (ITRLRD)
      KMMROW = ITRLRD(3)
      KMMCOL = ITRLRD(2)
C
C     GENERATE MERGE PARTITION VECTOR
C
      NROW = KCOL + KMMCOL
      DO 80 I = 1,NROW
      RZ(KORBGN+I-1) = 0.0
      IF (I .GT. KCOL) RZ(KORBGN+I-1) = 1.0
   80 CONTINUE
      TYPIN  = 1
      TYPOUT = 1
      IROW   = 1
      INCR   = 1
      IFORM  = 7
      CALL MAKMCB (ITRLR1,RPRTN,NROW,IFORM,TYPIN)
      CALL GOPEN (RPRTN,Z(GBUF1),1)
      CALL PACK (RZ(KORBGN),RPRTN,ITRLR1)
      CALL CLOSE (RPRTN,1)
      CALL WRTTRL (ITRLR1)
C
C     FORM STIFFNESS MATRIX
C
C                  **            **
C                  *        .     *
C        **   **   * KBARBB .  0  *
C        *     *   *        .     *
C        * KHH * = *..............*
C        *     *   *        .     *
C        **   **   *   0    . KMM *
C                  *        .     *
C                  **            **
C
      ISUB(1) = KCOL
      ISUB(2) = KMMCOL
      ISUB(3) = KBAROW
      ISUB(4) = KMMROW
      ITYPE   = 1
      CALL GMMERG (KHH,KBARBB,0,0,KMM,RPRTN,RPRTN,ISUB,ITYPE,Z(KORBGN),
     1             KORLEN)
C
C     STORE KHH AS KMTX ON SOF
C
      CALL SOFOPN (Z(SBUF1),Z(SBUF2),Z(SBUF3))
      CALL MTRXO (KHH,NEWNAM,ITMLST(1),0,ITEST)
      ITEM      = ITMLST(1)
      ITMNAM(1) = NEWNAM(1)
      ITMNAM(2) = NEWNAM(2)
      IF (ITEST .NE. 3) GO TO 200
C
C     LOCATE HGH MATRIX
C       KODE .EQ. 0, BOTH HORG, HLFT ON SOF
C       KODE .EQ. 1, HORG CALCULATED, HLFT ON SOF
C       KODE .EQ. 2, HORG ON SOF, HLFT CALCULATED
C       KODE .EQ. 3, BOTH HORG, HLFT CALCULATED
C
   90 ITEM      = ITMLST(2)
      ITMNAM(1) = OLDNAM(1)
      ITMNAM(2) = OLDNAM(2)
      CALL MTRXI (HGH,OLDNAM,ITEM,0,ITEST)
      IF (ITEST .NE. 1) GO TO 200
      IF (KODE.GT.1 .OR. SYMTRY) GO TO 100
      ITEM = ITMLST(3)
      CALL MTRXI (HGHBAR,OLDNAM,ITEM,0,ITEST)
      IF (ITEST .NE. 1) GO TO 200
  100 SIGNAB = 1
      SIGNC  = 1
      SCR    = ISCR(1)
      DBLKOR = KORBGN/2 + 1
      NZ     = LSTZWD - (2*DBLKOR - 1)
      ITMNAM(1) = NEWNAM(1)
      ITMNAM(2) = NEWNAM(2)
C
C     GENERATE MATRICES REQUESTED
C        I .EQ. 2, GENERATE MHH MATRIX
C        I .EQ. 3, GENERATE BHH MATRIX
C        I .EQ. 4, GENERATE K4HH MATRIX
C        I .EQ. 5, GENERATE PHH MATRIX
C
      DO 180 I = 2,5
      ITRLR1(1) = INFILE(I+6)
      CALL RDTRL (ITRLR1)
      IF (ITRLR1(1) .LT. 0) GO TO 180
      CALL SOFCLS
C
C     CALCULATE MATRIX REQUIRED
C
C                                     T
C        **          **   **        ** **          ** **   **
C        *            *   *          * *            * *     *
C        * (M,B,K4)HH * = * HGH(BAR) * * (M,B,K4)AA * * HGH *
C        *            *   *          * *            * *     *
C        **          **   **        ** **          ** **   **
C
C                              T
C        **   **   **        ** **   **
C        *     *   *          * *     *
C        * PHH * = * HGH(BAR) * * PAA *
C        *     *   *          * *     *
C        **   **   **        ** **   **
C
      ITRLR2(1) = HGH
      CALL RDTRL (ITRLR2)
      IF (I .EQ. 5) GO TO 112
      DO 110 J = 1,7
      ITRLRA(J) = ITRLR1(J)
      ITRLRB(J) = ITRLR2(J)
  110 ITRLRC(J) = 0
      IFORM = 2
      IF (ITRLR1(3) .EQ. ITRLR2(2)) IFORM = 1
      IPRC  = 1
      ITYP  = 0
      IF (ITRLR1(5).EQ.2 .OR. ITRLR1(5).EQ.4) IPRC = 2
      IF (ITRLR2(5).EQ.2 .OR. ITRLR2(5).EQ.4) IPRC = 2
      IF (ITRLR1(5) .GE. 3) ITYP = 2
      IF (ITRLR2(5) .GE. 3) ITYP = 2
      ITYPE = IPRC + ITYP
      CALL MAKMCB (ITRLRD,ISCR(2),ITRLR1(3),IFORM,ITYPE)
      PREC  = 0
      T     = 0
      SIGNAB= 1
      SIGNC = 1
      SCR   = ISCR(1)
      CALL MPYAD (DZ(DBLKOR),DZ(DBLKOR),DZ(DBLKOR))
      CALL WRTTRL (ITRLRD)
      ITEM = ITMLST(I+2)
      GO TO 116
  112 DO 114 J = 1,7
  114 ITRLRD(J) = ITRLR1(J)
      ITEM = ITMLST(7)
      IF (POPT .EQ. PAPP) ITEM = ITMLST(8)
  116 ITRLR2(1) = HGH
      IF (.NOT. SYMTRY) ITRLR2(1) = HGHBAR
      CALL RDTRL (ITRLR2)
      DO 120 J = 1,7
      ITRLRA(J) = ITRLR2(J)
  120 ITRLRB(J) = ITRLRD(J)
      IFORM = 1
      IPRC  = 1
      ITYP  = 0
      IF (ITRLRD(5).EQ.2 .OR. ITRLRD(5).EQ.4) IPRC = 2
      IF (ITRLR2(5).EQ.2 .OR. ITRLR2(5).EQ.4) IPRC = 2
      IF (ITRLRD(5) .GE. 3) ITYP = 2
      IF (ITRLR2(5) .GE. 3) ITYP = 2
      ITYPE = IPRC + ITYP
      CALL MAKMCB (ITRLRD,OTFILE(I),ITRLR2(2),IFORM,ITYPE)
      T    = 1
      PREC = 0
      CALL MPYAD (DZ(DBLKOR),DZ(DBLKOR),DZ(DBLKOR))
      CALL WRTTRL (ITRLRD)
C
C     STORE MATRIX ON SOF
C        I .EQ. 2, STORE MHH AS MMTX
C        I .EQ. 3, STORE BHH AS BMTX
C        I .EQ. 4, STORE K4HH AS K4MX
C        I .EQ. 5, STORE PHH AS PVEC OR PAPP
C
      CALL SOFOPN (Z(SBUF1),Z(SBUF2),Z(SBUF3))
      CALL MTRXO (OTFILE(I),NEWNAM,ITEM,0,ITEST)
      IF (ITEST .NE. 3) GO TO 200
  180 CONTINUE
C
C     TEST FOR LOAD PROCESSING
C
      IF (POPT .EQ. BLANKS) GO TO 190
      ITMNAM(1) = OLDNAM(1)
      ITMNAM(2) = OLDNAM(2)
      IF (.NOT.PONLY) GO TO 184
      ITRLR1(1) = EQST
      CALL RDTRL (ITRLR1)
      NSUB(1) = ITRLR1(6)
      NSUB(2) = ITRLR1(7)
      ITEM = ITMLST(12)
      CALL MTRXI (UPRT,OLDNAM,ITEM,0,ITEST)
      IF (ITEST .NE. 1) GO TO 200
      GO TO 188
C
C     PARTITION PAA VECTOR
C
  184 LCORE = KORLEN
      FUSET = USETMR
      CALL CALCV (UPRT,UN,UI,UB,Z(KORBGN))
  188 CALL GMPRTN (PAA,POVE,0,0,0,0,UPRT,NSUB(1),NSUB(2),Z(KORBGN),
     1             KORLEN)
C
C     SAVE POVE AS POVE OR POAP ON SOF
C
      IF (MODES) GO TO 190
      ITEM = ITMLST(9)
      IF (POPT .EQ. PAPP) ITEM = ITMLST(11)
      CALL MTRXO (POVE,OLDNAM,ITEM,0,ITEST)
      IF (ITEST .NE. 3) GO TO 200
  190 CONTINUE
      RETURN
C
C     PROCESS MODULE ERRORS
C
  200 GO TO (210,210,210,220,230,250), ITEST
  210 WRITE (IPRNTR,900) UFM,MODNAM,ITEM,ITMNAM
      DRY = -2
      RETURN
C
  220 IMSG = -2
      GO TO 240
  230 IMSG = -3
  240 CALL SMSG (IMSG,ITEM,ITMNAM)
      RETURN
C
  250 WRITE (IPRNTR,901) UFM,MODNAM,ITEM,ITMNAM
      DRY = -2
      RETURN
C
  290 WRITE (IPRNTR,902) UFM
      DRY = -2
      RETURN
C
  900 FORMAT (A23,' 6211, MODULE ',2A4,' - ITEM ',A4,
     1       ' OF SUBSTRUCTURE ',2A4,' HAS ALREADY BEEN WRITTEN.')
  901 FORMAT (A23,' 6632, MODULE ',2A4,' - NASTRAN MATRIX FILE FOR I/O',
     1       ' OF SOF ITEM ',A4,', SUBSTRUCTURE ',2A4,', IS PURGED.')
  902 FORMAT (A23,' 6518, ONE OF THE COMPONENT SUBSTRUCTURES HAS BEEN ',
     1       'USED IN A PREVIOUS COMBINE OR REDUCE.')
C
      END

      SUBROUTINE ERRMKN (N,IERR)
C
C     SENDS ERROR MESSAGES.  N IS THE INDEX OF THE SUBROUTINE CALLING
C     ERROR, AND IERR IS AN ERROR CODE.
C
      DIMENSION       ISUBR(26)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG / UFM,UWM,UIM,SFM
      COMMON /SYSTEM/ NBUFF,NOUT
      DATA    ISUBR / 4HCRSU,4HB   ,4HDSTR,4HOY  ,4HFDIT,4H    ,
     1                4HFMDI,4H    ,4HFNXT,4H    ,4HGETB,4HLK  ,
     2                4HRETB,4HLK  ,4HSETE,4HQ   ,4HSJUM,4HP   ,
     3                4HSURE,4HAD  ,4HRENA,4HME  ,4HEXO2,4H    ,
     4                4HEXIO,4H1   /
C
      WRITE (NOUT,1000) SFM,ISUBR(N),ISUBR(N+1)
      CALL SOFCLS
      GO TO (10,20,30,40,50,60,70,80,90,100), IERR
   10 WRITE (NOUT,1010)
      GO TO 900
   20 WRITE (NOUT,1020)
      GO TO 900
   30 WRITE (NOUT,1030)
      GO TO 900
   40 WRITE (NOUT,1040)
      GO TO 900
   50 WRITE (NOUT,1050)
      GO TO 900
   60 WRITE (NOUT,1060)
      GO TO 900
   70 WRITE (NOUT,1070)
      GO TO 900
   80 WRITE (NOUT,1080)
      GO TO 900
   90 WRITE (NOUT,1090)
      GO TO 900
  100 WRITE (NOUT,1100)
      GO TO 900
  900 CALL MESAGE (-61,0,0)
      RETURN
C
 1000 FORMAT (A25,' 6224, SOF UTILITY SUBROUTINE ',2A4)
 1010 FORMAT (5X,'I IS TOO LARGE OR NXTTSZ HAS NOT BEEN PROPERLY ',
     1        'UPDATED')
 1020 FORMAT (5X,'ILLEGAL BLOCK NUMBER')
 1030 FORMAT (5X,'ERROR IN SETTING UP THE LIST IMORE')
 1040 FORMAT (5X,'NXTCUR IS TOO LARGE')
 1050 FORMAT (5X,'ERROR IN UPDATING DIT')
 1060 FORMAT (5X,'ERROR IN UPDATING MDI')
 1070 FORMAT (5X,'ERROR IN LINKING BLOCKS OF DIT')
 1080 FORMAT (5X,'LINK THROUGH COMBINED SUBSTRUCTURES IS NOT CIRCULAR')
 1090 FORMAT (5X,'ERROR IN LINKING SOF BLOCKS')
 1100 FORMAT (5X,'INTERNAL ARRAY DIMENSION EXCEEDED')
      END

      SUBROUTINE PLOAD
C
      INTEGER         NAME(2),GRIDP,PONT
      DIMENSION       GRIDP(5),IGPCO(4,4),GPCO1(3),GPCO2(3),GPCO3(3),
     1                PONT(4),IORD(4),VECT(3),VECT1(3),VECT2(3),
     2                PLOADS(3,4),GPCO4(3),VECT3(3)
      COMMON /LOADX / LCORE,SLT,BGPDT,OLD,CSTM,NN(11),NOBLD
      COMMON /SYSTEM/ KSYS(87),KSYS88
      COMMON /ZZZZZZ/ CORE(1)
      EQUIVALENCE     (PMAG,GRIDP(1)),
     1                (IGPCO(2,1),GPCO1(1)),(IGPCO(2,2),GPCO2(1)),
     2                (IGPCO(2,3),GPCO3(1)),(IGPCO(2,4),GPCO4(1))
      DATA    NAME  / 4HPLOA,4HD   /, PI / 3.141592654 /
C
C
      DO 10 I = 1,3
   10 PLOADS(I,4) = 0.0
      CALL READ (*150,*150,SLT,GRIDP(1),5,0,FLAG)
      PONT(1) = GRIDP(2)
      PONT(2) = GRIDP(3)
      PONT(3) = GRIDP(4)
      PONT(4) = GRIDP(5)
      N1 = 4
      IF (GRIDP(5) .EQ. 0) N1 = 3
      CALL PERMUT (PONT(1),IORD(1),N1,OLD)
      DO 20 I = 1,N1
      L = IORD(I)
   20 CALL FNDPNT (IGPCO(1,L),PONT(L))
      IF (N1 .EQ. 4) GO TO 160
C
C     THREE  POINTS
C
      DO 30 I = 1,3
      VECT3(I) = GPCO1(I) - GPCO2(I)
      VECT2(I) = GPCO3(I) - GPCO1(I)
   30 VECT1(I) = GPCO2(I) - GPCO3(I)
      CALL CROSS (VECT3(1),VECT1(1),VECT(1))
C
      DO 40 I = 1,3
      DO 40 J = 1,3
   40 PLOADS(J,I) = -VECT(J)
C
      IF (KSYS88 .EQ. 1) GO TO 50
C
C     KSYS88 = 0, PRESSURE LOAD IS DISTRIBUTED EVENLY (ONE-THIRD) TO
C     EACH OF THE 3 GRID POINTS. TRIANGULAR GEOMETRY IS NOT CONSIDERED.
C
      PMAG    = PMAG/6
      VECT(1) = PMAG
      VECT(2) = PMAG
      VECT(3) = PMAG
      GO TO 80
C
C     IMPLEMENTED BY G.CHAN/UNISYS   3/1990
C     KSYS88 = 1, PRESSURE LOAD IS DISTRIBUTED PROPORTIONALLY TO THE
C     THREE ANGLE SIZES.
C     E.G. A 45-90-45 DEGREE TRIANGLE ELEMENT WILL HAVE TWICE THE LOAD
C     AT THE 90 DEGREE ANGLE TO THAT OF THE 45 DEGREE ANGLE.
C     RECTANGULAR ELEMENT (4 POINTS) IS NOT AFFECTED
C
C     GET AREA(2X), SIDES (VI) AND ANGLES (AI) OF THE TRIANGLE
C
   50 CONTINUE
      AREA = SQRT(VECT (1)**2 + VECT (2)**2 + VECT (3)**2)
      V1   = SQRT(VECT1(1)**2 + VECT1(2)**2 + VECT1(3)**2)
      V2   = SQRT(VECT2(1)**2 + VECT2(2)**2 + VECT2(3)**2)
      V3   = SQRT(VECT3(1)**2 + VECT3(2)**2 + VECT3(3)**2)
C
C     CHOOSE AN ANGLE, WHICH IS NOT THE LARGEST, TO START COMPUTING
C     THE THREE ANGLES
C
      IF (V2.GT.V1 .AND. V2.GT.V3) GO TO 60
      SIN2 = AREA/(V3*V1)
      SIN1 = V1*SIN2/V2
      SIN3 = V3*SIN2/V2
      A2   = ASIN(SIN2)
      IF (SIN1 .GE. 0.0) A1 = ASIN(SIN1)
      IF (SIN3 .GE. 0.0) A3 = ASIN(SIN3)
      IF (V1 .GT. V3) A1 = PI - A2 - A3
      IF (V3 .GT. V1) A3 = PI - A2 - A1
      GO TO 70
C
   60 SIN3 = AREA/(V2*V1)
      SIN2 = V2*SIN3/V3
      SIN1 = V1*SIN3/V3
      A3   = ASIN(SIN3)
      IF (SIN2 .GE. 0.0) A2 = ASIN(SIN2)
      IF (SIN1 .GE. 0.0) A1 = ASIN(SIN1)
      IF (V1 .GT. V2) A1 = PI - A3 - A2
      IF (V2 .GT. V1) A2 = PI - A3 - A1
   70 PMAG    = 0.5*PMAG/PI
      VECT(1) = PMAG*A1
      VECT(2) = PMAG*A2
      VECT(3) = PMAG*A3
C
C     TRANSFORM TO GLOBAL AND ADD CONTRIBUTIONS
C
   80 DO 130 I = 1,N1
      DO 90  J = 1,3
      IF (N1 .EQ. 4) PLOADS(J,I) = -PLOADS(J,I)*PMAG
      IF (N1 .EQ. 3) PLOADS(J,I) = -PLOADS(J,I)*VECT(I)
   90 CONTINUE
      IF (IGPCO(1,I) .NE. 0) CALL BASGLB (PLOADS(1,I),PLOADS(1,I),
     1                                    IGPCO(2,I),IGPCO(1,I))
      CALL FNDSIL (PONT(I))
      DO 120 J = 1,3
      IN = PONT(I) + J - 1
      CORE(IN) = PLOADS(J,I) + CORE(IN)
  120 CONTINUE
  130 CONTINUE
  140 RETURN
C
  150 CALL MESAGE (-1,SLT,NAME)
      GO TO 140
C
C     FOUR  POINTS
C
C
C     TRIANGLE  1,2,3
C
  160 DO 170 I = 1,3
      VECT1(I) = GPCO1(I) - GPCO2(I)
  170 VECT2(I) = GPCO3(I) - GPCO2(I)
      CALL CROSS (VECT1(1),VECT2(1),VECT(1))
      DO 180 I = 1,3
      DO 180 J = 1,3
  180 PLOADS(J,I) = VECT(J)
C
C     TRIANGLE  2,3,4
C
      DO 190 I  =1,3
      VECT1(I) = GPCO2(I) - GPCO3(I)
  190 VECT2(I) = GPCO4(I) - GPCO3(I)
      CALL CROSS (VECT1(1),VECT2(1),VECT(1))
      DO 200 I = 2,4
      DO 200 J = 1,3
  200 PLOADS(J,I) = PLOADS(J,I) + VECT(J)
C
C     TRIANGLE  3,1,4
C
      DO 210 I = 1,3
      VECT1(I) = GPCO4(I) - GPCO1(I)
  210 VECT2(I) = GPCO3(I) - GPCO1(I)
      CALL CROSS (VECT1(1),VECT2(1),VECT(1))
      DO 230 I = 1,4
      IF (I .EQ. 2) GO TO 230
      DO 220 J = 1,3
  220 PLOADS(J,I) = PLOADS(J,I)+VECT(J)
  230 CONTINUE
C
C     TRIANGLE (4,1,2)
C
      DO 240 I = 1,3
      VECT1(I) = GPCO4(I) - GPCO1(I)
  240 VECT2(I) = GPCO2(I) - GPCO1(I)
      CALL CROSS (VECT1(1),VECT2(1),VECT(1))
      DO 260 I = 1,4
      IF (I .EQ. 3) GO TO 260
      DO 250 J = 1,3
  250 PLOADS(J,I) = PLOADS(J,I) + VECT(J)
  260 CONTINUE
      PMAG = PMAG/12.0
      GO TO 80
      END

      SUBROUTINE MRED1C
C
C     THIS SUBROUTINE CONVERTS THE EQSS DATA AND BGSS DATA TO CORRESPOND
C     TO THE BOUNDARY DEGREES OF FREEDOM (UB) FOR THE MRED1 MODULE
C
C     INPUT DATA
C     SOF - BGSS - BASIC GRID POINT IDENTIFICATION TABLE
C
C     OUTPUT DATA
C     GINO - EQST - TEMPORARY EQSS DATA FILE
C
C     PARAMETERS
C     INPUT - GBUF1  - GINO BUFFER
C             KORLEN - LENGTH OF OPEN CORE
C             NEWNAM - NAME OF NEW SUBSTRUCTURE
C             RGRID  - FREEBODY MODE IDENTIFICATION NUMBERS (SET IN
C                      MRED1)
C                      RGRID(1) .EQ. GRID POINT IDENTIFICATION NUMBER
C                      RGRID(2) .EQ. NUMBER OF CONTRIBUTING SUBSTRUCTURE
C             NCSUBS - NUMBER OF CONTRIBUTING SUBSTRUCTURES
C             NAMEBS - BEGINNING ADDRESS OF BASIC SUBSTRUCTURE NAMES
C             EQSIND - BEGINNING ADDRESS OF EQSS GROUP ADDRESSES
C             NSLBGN - BEGINNING ADDRESS OF SIL DATA
C             NSIL   - NUMBER OF SIL GROUPS
C             LOCUST - BEGINNING ADDRESS OF USET ARRAY
C
      EXTERNAL        ANDF,ORF
      LOGICAL         BOUNDS
      INTEGER         OLDNAM,DRY,GBUF1,EQSIND,RGRID,Z,SILDOF,UB,ESTDTA,
     1                SILIND,ESTWRT,BITPAT,EQST,EQSTRL,ANDF,ORF
      DIMENSION       BITPAT(32),MODNAM(2),EQSTRL(7)
      COMMON /BLANK / OLDNAM(2),DRY,IDUM1(6),GBUF1,IDUM2(4),KORLEN,
     1                NEWNAM(2),IDUM3(4),RGRID(2),IDUM4(4),NCSUBS,
     2                NAMEBS,EQSIND,NSLBGN,NSIL,IDUM6(3),LOCUST,
     3                IDUM7(4),BOUNDS
      COMMON /ZZZZZZ/ Z(1)
      COMMON /TWO   / ITWO(32)
      COMMON /BITPOS/ IDUM5(20),UB
      DATA    EQST  , NHBGSS,MODNAM / 203,4HBGSS,4HMRED,4H1C  /
C
C     IF OLDBOUNDS OPTION, GET EQST TRAILER
C
      IF (DRY .EQ. -2) RETURN
      EQSTRL(1) = EQST
      IF (.NOT. BOUNDS) GO TO 5
      CALL RDTRL (EQSTRL)
C
C     GET SIL DOF AND DECODE
C
    5 NEWIPS = 0
      DO 30 I = 1,NSIL
      SILDOF = NSLBGN + ((2*I) - 1)
      ICODE  = Z(SILDOF)
      CALL DECODE (ICODE,BITPAT,NWDSD)
C
C     TEST FOR DOF REMAINING IN BOUNDARY SET
C
      NDOF = 0
      KOMPNT = 0
      DO 10 J = 1,NWDSD
      K = LOCUST + (Z(SILDOF-1)-1) + (J-1)
      IF (ANDF(Z(K),ITWO(UB)) .EQ. 0) GO TO 10
      K = 32 - BITPAT(J)
      KOMPNT = ORF(KOMPNT,ITWO(K))
      NDOF = NDOF + 1
   10 CONTINUE
C
C     SAVE NEW SIL DATA
C
      IF (NDOF .EQ. 0) GO TO 20
      NEWIPS = NEWIPS + 1
      Z(SILDOF-1) = (8*NEWIPS) + NDOF
      Z(SILDOF) = KOMPNT
      GO TO 30
C
C     SIL DATA NOT NEEDED
C
   20 Z(SILDOF-1) = -1
   30 CONTINUE
C
C     WRITE EQSS GROUP 0 DATA ONTO TEMPORARY EQST TABLE
C
      CALL GOPEN (EQST,Z(GBUF1),1)
      CALL WRITE (EQST,NEWNAM,2,0)
      CALL WRITE (EQST,NCSUBS,1,0)
      CALL WRITE (EQST,NEWIPS,1,0)
      NWDS = EQSIND - NAMEBS
      CALL WRITE (EQST,Z(NAMEBS),NWDS,1)
      EQSTRL(2) = NWDS + 4
C
C     WRITE REMAINING EQSS GROUP DATA ONTO TEMPORARY EQST TABLE
C
      EQSTRL(3) = NCSUBS
      DO 60 I = 1,NCSUBS
      J = 2*(I-1)
      ESTDTA = Z(EQSIND+J)
      NWDS = Z(EQSIND+J+1)
C
C     TEST SUBSTRUCTURE COMPONENTS
C
      IF (NWDS .LE. 0) GO TO 60
      DO 50 J = 1,NWDS,3
      SILIND = NSLBGN + (2*(Z(ESTDTA+J) - 1))
      IF (RGRID(1) .LE. 0) GO TO 40
      IF (I .NE. RGRID(2)) GO TO 40
      IF (RGRID(1) .NE. Z(ESTDTA+J-1)) GO TO 40
      RGRID(1) = Z(ESTDTA+J)
   40 IF (Z(SILIND) .EQ. -1) GO TO 50
C
C     REPLACE IP, SIL NUMBERS AND WRITE DATA
C
      ESTWRT = ESTDTA + J
      Z(ESTWRT  ) = Z(SILIND)/8
      Z(ESTWRT+1) = Z(SILIND+1)
      CALL WRITE (EQST,Z(ESTWRT-1),3,0)
   50 CONTINUE
   60 CALL WRITE (EQST,0,0,1)
C
C     REDUCE SIL ENTRIES AND STORE NEW SIL DATA AT Z(2*NSIL)
C
      NDOF   = 1
      LOINDX = 0
      NEWSIL = NSLBGN + (2*NSIL)
      IF ((NEWSIL+(2*NSIL)) .GE. KORLEN) GO TO 130
      DO 70 I = 1,NSIL
      J = 2*(I-1)
      IF (Z(NSLBGN+J) .EQ. -1) GO TO 70
      Z(NEWSIL+LOINDX  ) = NDOF
      Z(NEWSIL+LOINDX+1) = Z(NSLBGN+J+1)
      NDOF = NDOF + ANDF(Z(NSLBGN+J),7)
      LOINDX = LOINDX + 2
   70 CONTINUE
C
C     WRITE SIL DATA ONTO TEMPORARY EQST TABLE
C
      KORBGN = NAMEBS
      IF (LOINDX .LE. 0) CALL WRITE (EQST,0,0,1)
      IF (LOINDX .GT. 0) CALL WRITE (EQST,Z(NEWSIL),LOINDX,1)
      EQSTRL(4) = LOINDX
C
C     READ AND WRITE BGSS GROUP 0 DATA
C
      CALL SFETCH (OLDNAM,NHBGSS,1,ITEST)
      IF (ITEST .EQ. 3) GO TO 90
      IF (ITEST .EQ. 4) GO TO 100
      IF (ITEST .EQ. 5) GO TO 110
      CALL SUREAD (Z(KORBGN),-1,NWDSRD,ITEST)
      Z(KORBGN  ) = OLDNAM(1)
      Z(KORBGN+1) = OLDNAM(2)
      NBGSS = Z(KORBGN+2)
      Z(KORBGN+2) = LOINDX/2
      CALL WRITE (EQST,Z(KORBGN),3,1)
C
C     ELIMINATE BGSS DATA NOT REQUIRED
C
      I = 0
      EQSTRL(5) = 0
      DO 80 J = 1,NBGSS
      CALL SUREAD (Z(KORBGN),4,NWDSRD,ITEST)
      IF (I .GT. (2*NSIL)) GO TO 80
      IF (Z(NSLBGN+I) .EQ. -1) GO TO 80
      CALL WRITE (EQST,Z(KORBGN),4,0)
      EQSTRL(5) = EQSTRL(5) + 4
   80 I = I + 2
      CALL WRITE  (EQST,0,0,1)
      CALL WRTTRL (EQSTRL)
C
C     CLOSE EQST FILE
C
      CALL CLOSE (EQST,1)
      RETURN
C
C     PROCESS MODULE FATAL ERRORS
C
   90 IMSG = -1
      GO TO 120
  100 IMSG = -2
      GO TO 120
  110 IMSG = -3
  120 CALL SMSG (IMSG,NHBGSS,OLDNAM)
      RETURN
C
C     PROCESS SYSTEM FATAL ERRORS
C
  130 IMSG = -8
      IFILE = 0
      CALL SOFCLS
      CALL MESAGE (IMSG,IFILE,MODNAM)
C
      RETURN
      END

      SUBROUTINE PLBAR1 (IDO,LCORE)
C
C     THIS SUBROUTINE SETS UP THE DATA NEEDED TO CALL PLOAD1
C     TO GET THE APPLIED CONCENTRATED, UNIFORMLY OR LINEARLY DISTRIBUTED
C     LOADS, ON A BAR ELEMENT FROM A PLOAD1 CARD
C     AND INSERTS THE VECTOR INO PV
C
      INTEGER         BAR,NAM(2),OLDID,EST,IZ(1),ISLT(7)
      DIMENSION       TA(9),TB(9),PA(6),PB(6),PG(42)
      COMMON /SYSTEM/ IBUFF,NOUT
      COMMON /SSGA1X/ PV(1)
      COMMON /LOADX / LC,SLT,D1(5),EST,D2(11),ILID
      COMMON /MATIN / MATID,INFLAG,TEMP
      EQUIVALENCE     (PG(1),IZ(1))
      DATA    NAM   / 4HPLBA,4HR1  /, N,OLDID,ISLT / 9*0 /
      DATA    IECT  , IEPT,IBG,NWDS,BAR / 1,16,34,42,34  /
C
C     INITIALIZE AND OPEN EST
C
      IF (N .NE. 0) GO TO 30
      CALL GOPEN (EST,IZ(LCORE),0)
   10 CALL READ (*110,*20,EST,I,1,0,FLAG)
   20 IF (I .EQ. BAR) GO TO 30
      CALL FWDREC (*110,EST)
      GO TO 10
C
C     READ SLT THEN FIND BAR ELEMENT
C
   30 CALL READ (*100,*100,SLT,ISLT,7,0,FLAG)
      IF (ISLT(1) .EQ. OLDID) GO TO 60
   40 CALL READ (*110,*110,EST,IZ(IECT),NWDS,0,FLAG)
      OLDID = IZ(IECT)
      IF (IZ(IECT)-ISLT(1)) 40,50,110
C
C     CONVERT COORD. SYSTEMS
C
   50 IF (IZ(IECT+6) .NE. 0) CALL GLBBAS (PG(IECT+ 3),PG(IECT+ 3),
     1                                    PG(IBG + 1),IZ(IECT+ 6))
      IF (IZ(IBG   ) .NE. 0) CALL GLBBAS (PG(IECT+ 9),PG(IECT+ 9),
     1                                    PG(IBG + 1),IZ(IBG    ))
      IF (IZ(IBG +4) .NE. 0) CALL GLBBAS (PG(IECT+12),PG(IECT+12),
     1                                    PG(IBG + 5),IZ(IBG + 4))
      CALL GBTRAN (IZ(IBG  ),IZ(IBG+1),TA)
      CALL GBTRAN (IZ(IBG+4),IZ(IBG+5),TB)
C
C     DATA READY
C
      INFLAG = 1
      TEMP   = PG(IBG+8)
      MATID  = IZ(IEPT)
      CALL MAT (OLDID)
   60 CALL PLOAD1 (1,ISLT,PG(IECT+3),PG(IECT+9),PG(IECT+12),PG(IBG+1),
     1             PG(IBG+5),PA,PB,TA,TB,ISLT,IZ(IECT))
C
C     INSERT INTO PV
C
      IPG = IZ(IECT+1) - 1
      DO 70 I = 1,6
   70 PV(IPG+I) = PV(IPG+I) + PA(I)
      IPG = IZ(IECT+2) - 1
      DO 80 I = 1,6
   80 PV(IPG+I) = PV(IPG+I) + PB(I)
      N = N + 1
      IF (N .NE. IDO) GO TO 150
      N = 0
      OLDID = 0
      CALL CLOSE (EST,1)
      GO TO 150
C
C     ERROR
C
  100 CALL MESAGE (-1,SLT,NAM)
  110 WRITE  (NOUT,120) ISLT(1),ILID
  120 FORMAT ('0*** USER FATAL MESSAGE 2286, CBAR ELEMENT',I9,
     1        ' REFERENCED ON PLOAD1',I9,' NOT FOUND')
      CALL MESAGE (-61,0,NAM)
C
  150 RETURN
      END

      SUBROUTINE MBCTR (ICTR,IL1,IR1,NCN,NC1,NWN,NW1,PAREA)
C
C     CONTROL1 SURFACE
C
C     CONVEX ONLY:
C     MUST COMPILE WITH O1 OR LOWER OPTIMIZATION OPTION. IF O2 IS USED,
C     THE COMPILER WOULD GO INTO INFINITE LOOP.
C
      LOGICAL        CNTRL2,CNTRL1,CRANK1,CRANK2,ASYM
      DIMENSION      NCN(1),NC1(1),NWN(1),NW1(1),PAREA(50,50,3),
     1               X(5),Y(5),TANG(5),COTANG(5)
      COMMON /MBOXA/ XX(12),YY(12),TG(10),ANG(10),COTG(10)
      COMMON /MBOXC/ NJJ ,CRANK1,CRANK2,CNTRL1,CNTRL2,NBOX,NPTS0,NPTS1,
     1               NPTS2,ASYM,GC,CR,MACH,BETA,EK,EKBAR,EKM,BOXL,BOXW,
     2               BOXA ,NCB,NSB,NSBD,NTOTE,KC,KC1,KC2,KCT,KC1T,KC2T
C
      IF (ICTR .EQ. 2) GO TO 1000
      X(1) = XX( 7)
      X(2) = XX( 8)
      X(3) = XX( 9)
      X(4) = XX(11)
      Y(1) = YY( 7)
      Y(2) = YY( 8)
      Y(3) = YY( 9)
      Y(4) = YY(11)
      TANG(1) = TG(6)
      TANG(2) = TG(7)
      TANG(3) = TG(8)
      COTANG(1) = COTG(6)
      COTANG(2) = COTG(7)
      COTANG(3) = COTG(8)
      GO TO 2000
C
C     CONTROL2 SURFACE
C
 1000 X(1) = XX(11)
      X(2) = XX( 9)
      X(3) = XX(10)
      X(4) = XX(12)
      Y(1) = YY(11)
      Y(2) = YY( 9)
      Y(3) = YY(10)
      Y(4) = YY(12)
      TANG(1) = TG( 8)
      TANG(2) = TG(10)
      TANG(3) = TG( 9)
      COTANG(1) = COTG( 8)
      COTANG(2) = COTG(10)
      COTANG(3) = COTG( 9)
C
 2000 X(5) = XX(5)
      Y(5) = YY(5)
      TANG(4) = TG(4)
      TANG(5) = TG(5)
      COTANG(4) = COTG(4)
      COTANG(5) = COTG(5)
C
      IL1 = AMIN1(Y(2),Y(1))/BOXW + 1.5
      IR1 = AMAX1(Y(3),Y(4))/BOXW + 1.4999
      DO 6000 I = IL1,IR1
      YR  = (FLOAT(I)-0.5)*BOXW
      YL  = YR-BOXW
C
      XLL = (YL-Y(2))*TANG(1) + X(2)
      XRL = (YR-Y(2))*TANG(1) + X(2)
      XLH = (YL-Y(2))*TANG(2) + X(2)
      XRH = (YR-Y(2))*TANG(2) + X(2)
      XLR = (YL-Y(3))*TANG(3) + X(3)
      XRR = (YR-Y(3))*TANG(3) + X(3)
C
      IF (CRANK2 .AND. Y(5).LE.Y(1)) GO TO 4515
C
      XLT = (YL-Y(1))*TANG(4) + X(1)
      XRT = (YR-Y(1))*TANG(4) + X(1)
      GO TO 4520
C
 4515 XLT = (YL-Y(1))*TANG(5) + X(1)
      XRT = (YR-Y(1))*TANG(5) + X(1)
C
 4520 IF (YL.LE.Y(2) .AND. YR.GE.Y(2)) GO TO 4525
C
      IF (YR .LT. Y(2)) GO TO 4550
      JT = (XLH-AMOD(XLH,BOXL)+BOXL)/BOXL + 0.01
      GO TO 4600
C
 4525 JT = (X(2)-AMOD(X(2),BOXL)+BOXL)/BOXL + 0.01
      GO TO 4600
C
 4550 JT = (XRL-AMOD(XRL,BOXL)+BOXL)/BOXL + 0.01
C
 4600 IF (YL.LT.Y(4) .AND. YR.GE.Y(4).AND.XRT.GE.XLT) GO TO 4625
      IF (YL .GE. Y(4)) GO TO 4650
C
      JB = (AMAX1(XLT,XRT)-AMOD(AMAX1(XLT,XRT),BOXL)+BOXL)/BOXL + 0.01
      GO TO 4700
 4625 JB = (X(4)-AMOD(X(4),BOXL)+BOXL)/BOXL + 0.01
      GO TO 4700
C
 4650 JB = (XLR-AMOD(XLR,BOXL)+BOXL)/BOXL + 0.01
C
 4700 DO 5400 J = JT,JB
C
      XB = FLOAT(J)*BOXL
      XT = XB - BOXL
C
      YTL = (XT-X(2))*COTANG(1) + Y(2)
      YBL = (XB-X(2))*COTANG(1) + Y(2)
      YTH = (XT-X(2))*COTANG(2) + Y(2)
      YBH = (XB-X(2))*COTANG(2) + Y(2)
      YTR = (XT-X(3))*COTANG(3) + Y(3)
      YBR = (XB-X(3))*COTANG(3) + Y(3)
C
      IF (CRANK2 .AND. Y(5).LE.Y(1)) GO TO 4706
C
      YTT = (XT-X(1))*COTANG(4) + Y(1)
      YBT = (XB-X(1))*COTANG(4) + Y(1)
      GO TO 4708
C
 4706 YTT = (XT-X(1))*COTANG(5) + Y(1)
      YBT = (XB-X(1))*COTANG(5) + Y(1)
C
C     FULL BOXES
C
 4708 IF (YL.GE.YTL .AND. XT.GE.XRH .AND. YR.LT.YBR .AND.
     1    XB.LT.XRT .AND. XB.LT.XLT) GO TO 4900
C
C     DOUBLE CORNER BOXES
C
      IF (YL.LE.Y(2) .AND. YR.GE.Y(2) .AND. XT.LT.X(2) .AND.
     1    XB.GE.X(2) .AND. YL.LE.Y(1) .AND. YR.GE.Y(1) .AND.
     2    XT.LT.X(1) .AND. XB.GE.X(1)) GO TO 4820
C
      IF (YL.LT.Y(3) .AND. YR.GE.Y(3) .AND. XT.LT.X(3) .AND.
     1    XB.GE.X(3) .AND. YL.LT.Y(4) .AND. YR.GE.Y(4) .AND.
     2    XT.LT.X(4) .AND. XB.GE.X(4)) GO TO 4840
C
C     SINGLE CORNER BOXES
C
      IF (YL.LE.Y(2) .AND. YR.GE.Y(2) .AND. XT.LT.X(2) .AND.
     1    XB.GE.X(2)) GO TO 4710
      IF (YL.LE.Y(1) .AND. YR.GE.Y(1) .AND. XT.LT.X(1) .AND.
     1    XB.GE.X(1)) GO TO 4730
      IF (YL.LT.Y(3) .AND. YR.GE.Y(3) .AND. XT.LT.X(3) .AND.
     1    XB.GE.X(3)) GO TO 4750
      IF (YL.LT.Y(4) .AND. YR.GE.Y(4) .AND. XT.LT.X(4) .AND.
     1    XB.GE.X(4)) GO TO 4770
C
C     HINGE + T. E. BOXES
C
      IF (XT.LT.XRH .AND. (XB.GE.XLT .OR. XB.GE.XRT)) GO TO 4788
C
C     SIDE BOXES
C
      IF (XB.GE.XLH .AND. XT.LT.XRH .AND. YL.GE.YTL .AND. (XB.LT.X(3)
     1   .OR. YR.LT.Y(3))) GO TO 4745
      IF (YL.LE.YTL .AND. YR.GE.YBL .AND. XB.GE.X(2) .AND. XT.LT.X(1))
     1    GO TO 4740
      IF (YL.LT.YTR .AND. YR.GE.YBR .AND. XB.GE.X(3) .AND. XT.LT.X(4)
     1   .AND. YR.GE.Y(4)) GO TO 4765
      GO TO 4747
C
C     FWD LH CORNER
C
 4710 IF (YL.LE.YBL .AND. YR.GE.YBL .AND. XT.LT.XRH .AND. XB.GE.XRH)
     1   PA = .5*((Y(2)-YBL)*(XB-X(2))+(2.*XB-X(2)-XRH)*(YR-Y(2)))/BOXA
      IF (XT.LT.XLL .AND. XB.GE.XLL .AND. XT.LT.XRH .AND. XB.GE.XRH)
     1   PA = .5*((2.*XB-XLL-X(2))*(Y(2)-YL)+(2.*XB-XRH-X(2))*(YR-Y(2)))
     2        /BOXA
      IF (XT.LT.XLL .AND. XB.GE.XLL .AND. YL.LT.YBH .AND. YR.GE.YBH)
     1   PA = .5*((2.*XB-X(2)-XLL)*(Y(2)-YL)+(YBH-Y(2))*(XB-X(2)))/BOXA
      IF (YL.LE.YBL .AND. YR.GE.YBL .AND. YL.LT.YBH .AND. YR.GE.YBH)
     1   PA = 0.5*(XB-X(2))*(YBH-YBL)/BOXA
      IF (I-1) 4799,5000,4799
C
 4720 IF (YL.LE.YTL .AND. YR.GE.YTL .AND. YL.LT.YTH .AND. YR.GE.YTH .AND
     1.   XT.LT.XLL .AND. XB.GE.XLL .AND. XT.LT.XRH .AND. XB.GE.XRH)
     2    PA = 1.0 - 0.5*((XLL-XT)*(YTL-YL)+(YR-YTH)*(XRH-XT))/BOXA
      IF (YL.LE.YBL .AND. YR.GE.YBL .AND. YL.LE.YTL .AND. YR.GE.YTL .AND
     1.   YL.LT.YTH .AND. YR.GE.YTH .AND. XT.LT.XRH .AND. XB.GE.XRH)
     2    PA = 1.0 - 0.5*((YTL+YBL-2.0*YL)*BOXL+(YR-YTH)*(XRH-XT))/BOXA
      IF (YL.LT.YBH .AND. YR.GE.YBH .AND. XT.LT.XLL .AND. XB.GE.XLL .AND
     1.   YL.LE.YTL .AND. YR.GE.YTL .AND. YL.LT.YTH .AND. YR.GE.YTH)
     2    PA = 1.0 - 0.5*((YTL-YL)*(XLL-XT)+(2.0*YR-YTH-YBH)*BOXL)/BOXA
      IF (YL.LE.YTL .AND. YR.GE.YTL .AND. YL.LT.YTH .AND. YR.GE.YTH .AND
     1.   YL.LE.YBL .AND. YR.GE.YBL .AND. YL.LT.YBH .AND. YR.GE.YBH)
     2    PA = 0.5*(YTH+YBH-YTL-YBL)/BOXW
      IF (YL.LE.YTL .AND. YR.GE.YTL .AND. YL.LE.YBL .AND. YR.GE.YBL .AND
     1.   YL.LT.YBT .AND. YR.GE.YBT .AND. XT.LT.XRT .AND. XB.GE.XRT)
     2    PA = 0.5*((2.0*YR-YTL-YBL)*BOXL-(YR-YBT)*(XB-XRT))/BOXA
      IF (YL.LT.YTL .AND. YR.GE.YTL .AND. XT.LT.XLL .AND. XB.GE.XLL .AND
     1.   XT.LT.XLT .AND. XB.GE.XLT .AND. YL.LT.YBT .AND. YR.GE.YBT)
     2    PA = 1.0 - 0.5*((YTL-YL)*(XLL-XT)+(XB-XLT)*(YBT-YL))/BOXA
      IF (XT.LT.XLL .AND. XB.GE.XLL .AND. XT.LT.XRL .AND. XB.GE.XRL .AND
     1.   YL.LT.YBT .AND. YR.GE.YBT .AND. XT.LT.XLT .AND. XB.GE.XLT)
     2    PA = 0.5*((2.0*XB-XLL-XRL)*BOXW-(XB-XLT)*(YBT-YL))/BOXA
      IF (YL.LT.YTL .AND. YR.GE.YTL .AND. XT.LT.XLL .AND. XB.GE.XLL .AND
     1.   XT.LT.XLT .AND. XB.GE.XLT .AND. XT.LT.XRT .AND. XB.GE.XRT)
     2    PA = 0.5*((XLT+XRT-2.0*XB)*BOXW-(YTL-YL)*(XLL-XT))/BOXA
      IF (XT.LT.XLL .AND. XB.GE.XLL .AND. XT.LT.XLT .AND. XB.GE.XLT .AND
     1.   XT.LT.XRL .AND. XB.GE.XRL .AND. XT.LT.XRT .AND. XB.GE.XRT)
     2    PA = 0.5*(XLT+XRT-XLL-XRL)/BOXL
      IF (I-1) 4799,5000,4799
C
C     AFT LH CORNER
C
 4730 IF (X(1) .GE. X(4)) GO TO 4735
      IF (YL.LT.YBT .AND. YR.GE.YBT .AND. YL.LE.YTL .AND. YR.GE.YTL)
     1   PA = .5*((2.*YR-YTL-Y(1))*(X(1)-XT)+(2.*YR-Y(1)-YBT)*(XB-X(1)))
     2        /BOXA
 4735 IF (YL.LE.YTL .AND. YR.GE.YTL .AND. XT.LT.XRT .AND. XB.GE.XRT)
     1   PA = .5*((Y(1)-YTL)*(X(1)-XT)+(X(1)+XRT-2.*XT)*(YR-Y(1)))/BOXA
      IF (YL.LT.YTT .AND. YR.GE.YTT .AND. YL.LE.YTL .AND. YR.GE.YTL .AND
     1.   YTT.GE.YTL) PA = 0.5*(YTT-YTL)*(X(1)-XT)/BOXA
      IF (XT.LT.XRL .AND. XB.GE.XRL .AND. XT.LT.XRT .AND. XB.GE.XRT)
     1   PA = 0.5*(XRT-XRL)*(YR-Y(1))/BOXA
      IF (YL.LT.YBT .AND. YR.GE.YBT .AND. XT.LT.XRL .AND. XB.GE.XRL)
     1   PA = .5*((X(1)-XRL)*(YR-Y(1))+(2.*YR-Y(1)-YBT)*(XB-X(1)))/BOXA
      IF (I-1) 4799,5000,4799
C
C     LH EDGE
C
 4740 IF (I .EQ. 1) GO TO 4800
C
      IF (XT.LT.XLL .AND. XB.GE.XLL .AND. XT.LT.XRL .AND. XB.GE.XRL)
     1   PA = 0.5*(2.0*XB-XLL-XRL)/BOXL
      IF (YL.LE.YBL .AND. YR.GE.YBL .AND. XT.LT.XRL .AND. XB.GE.XRL)
     1   PA = 0.5*(YR-YBL)*(XB-XRL)/BOXA
      IF (YL.LE.YTL .AND. YR.GE.YTL .AND. YL.LE.YBL .AND. YR.GE.YBL)
     1   PA = 0.5*(2.0*YR-YTL-YBL)/BOXW
      IF (YL.LE.YTL .AND. YR.GE.YTL .AND. XT.LT.XLL .AND. XB.GE.XLL)
     1   PA = 1.0 - 0.5*(XLL-XT)*(YTL-YL)/BOXA
      GO TO 4720
C
C     HINGE LINE
C
 4745 IF (YL.LT.YTH .AND. YR.GE.YTH .AND. XT.LT.XRH .AND. XB.GE.XRH)
     1   PA = 1.0 - 0.5*(YR-YTH)*(XRH-XT)/BOXA
      IF (XT.LT.XLH .AND. XB.GE.XLH .AND. XT.LT.XRH .AND. XB.GE.XRH)
     1   PA = 0.5*(2.0*XB-XLH-XRH)/BOXL
      IF (YL.LT.YBH .AND. YR.GE.YBH .AND. XT.LT.XLH .AND. XB.GE.XLH)
     1   PA = 0.5*(XB-XLH)*(YBH-YL)/BOXA
      IF (YL.LT.YTH .AND. YR.GE.YTH .AND. YL.LT.YBH .AND. YR.GE.YBH)
     1   PA = 0.5*(YTH+YBH-2.0*YL)/BOXW
      GO TO 4760
C
C     TRAILING EDGE
C
 4747 IF (YL.LT.YTT .AND. YR.GE.YTT .AND. XT.LT.XRT .AND. XB.GE.XRT)
     1   PA = 0.5*(YR-YTT)*(XRT-XT)/BOXA
      IF (XT.LT.XLT .AND. XB.GE.XLT .AND. XT.LT.XRT .AND. XB.GE.XRT)
     1   PA = 0.5*(XLT+XRT-2.0*XT)/BOXL
      IF (XT.LT.XLT .AND. XB.GE.XLT .AND. YL.LT.YBT .AND. YR.GE.YBT)
     1   PA = 1.0 - 0.5*(XB-XLT)*(YBT-YL)/BOXA
      IF (YL.LT.YTT .AND. YR.GE.YTT .AND. YL.LT.YBT .AND. YR.GE.YBT)
     1   PA = 0.5*(2.0*YR-YTT-YBT)/BOXW
      IF (YL.LT.YBT .AND. YR.GE.YBT .AND. XT.LT.XRT .AND. XB.GE.XRT)
     1   PA = 1.0 - 0.5*(YR-YBT)*(XB-XRT)/BOXA
      IF (XT.LT.XLT .AND. XB.GE.XLT .AND. YL.LT.YTT .AND. YR.GE.YTT)
     1   PA = 0.5*(XLT-XT)*(YTT-YL)/BOXA
      GO TO 4799
C
C     FWD RH CORNER
C
 4750 IF (YR.GE.YBR .AND. YL.LT.YBR .AND. XT.LT.XLH .AND. XB.GE.XLH)
     1   PA = 0.5*((X(3)-XLH)*(Y(3)-YL)+(Y(3)+YBR-2.0*YL)*(XB-X(3)))
     2        /BOXA
      IF (XT.LT.XLH .AND. XB.GE.XLH .AND. XT.LT.XLR .AND. XB.GE.XLR)
     1   PA = 0.5*(XLR-XLH)*(Y(3)-YL)/BOXA
      IF (YR.GE.YTH .AND. YL.LT.YTH .AND. XT.LT.XLR .AND. XB.GE.XLR)
     1   PA = .5*((YTH+Y(3)-2.*YL)*(X(3)-XT)+(Y(3)-YL)*(XLR-X(3)))/BOXA
      IF (YR.GE.YTH .AND. YL.LT.YTH .AND. YR.GE.YBR .AND. YL.LT.YBR)
     1   PA = 0.5*((YTH+Y(3)-2.0*YL)*(X(3)-XT)+(Y(3)+YBR-2.0*YL)*
     2        (XB-X(3)))/BOXA
      GO TO 4799
C
 4760 IF (YR.GE.YBR .AND. YL.LT.YBR .AND. XT.LT.XRR .AND. XB.GE.XRR .AND
     1.   XT.LT.XRH .AND. XB.GE.XRH .AND. YL.LT.YTH .AND. YR.GE.YTH)
     2    PA = 1.0 - 0.5*((YR-YTH)*(XRH-XT)+(XB-XRR)*(YR-YBR))/BOXA
      IF (YR.GE.YBR .AND. YL.LT.YBR .AND. XT.LT.XRR .AND. XB.GE.XRR .AND
     1.   XT.LT.XRH .AND. XB.GE.XRH .AND. XT.LT.XLH .AND. XB.GE.XLH)
     2    PA = 0.5*((2.0*XB-XLH-XRH)*BOXW-(YR-YBR)*(XB-XRR))/BOXA
      IF (YL.LT.YTH .AND. YR.GE.YTH .AND. XT.LT.XRH .AND. XB.GE.XRH .AND
     1.   XT.LT.XRR .AND. XB.GE.XRR .AND. XT.LT.XLR .AND. XB.GE.XLR)
     2    PA = 0.5*((XLR+XRR-2.0*XT)*BOXW-(YR-YTH)*(XRH-XT))/BOXA
      IF (XT.LT.XLH .AND. XB.GE.XLH .AND. XT.LT.XLR .AND. XB.GE.XLR .AND
     1.   XT.LT.XRH .AND. XB.GE.XRH .AND. XT.LT.XRR .AND. XB.GE.XRR)
     2    PA = 0.5*(XLR+XRR-XLH-XRH)/BOXL
      GO TO 4799
C
C     RH EDGE
C
 4765 IF (XT.LT.XRR .AND. XB.GE.XRR .AND. XT.LT.XLR .AND. XB.GE.XLR)
     1   PA = 0.5*(XLR+XRR-2.0*XT)/BOXL
      IF (YR.GE.YTR .AND. YL.LT.YTR .AND. XT.LT.XLR .AND. XB.GE.XLR)
     1   PA = 0.5*(YTR-YL)*(XLR-XT)/BOXA
      IF (YR.GE.YTR .AND. YL.LT.YTR .AND. YR.GE.YBR .AND. YL.LT.YBR)
     1   PA = 0.5*(YTR+YBR-2.0*YL)/BOXW
      IF (YR.GE.YBR .AND. YL.LT.YBR .AND. XT.LT.XRR .AND. XB.GE.XRR)
     1   PA = 1.0 - 0.5*(XB-XRR)*(YR-YBR)/BOXA
      GO TO 4780
C
C     AFT RH CORNER
C
 4770 IF (X(4) .GE. X(1)) GO TO 4775
      IF (YR.GE.YTR .AND. YL.LT.YTR .AND. YL.LT.YBT .AND. YR.GE.YBT)
     1   PA = 0.5*((YTR+Y(4)-2.0*YL)*(X(4)-XT)+(Y(4)+YBT-2.0*YL)*
     2   (XB-X(4)))/BOXA
 4775 IF (YR.GE.YTR .AND. YL.LT.YTR .AND. XT.LT.XLT .AND. XB.GE.XLT)
     1   PA = .5*((XLT-X(4))*(Y(4)-YL)+(YTR+Y(4)-2.*YL)*(X(4)-XT))/BOXA
      IF (YL.LT.YTT .AND. YR.GE.YTT .AND. YR.GE.YTR .AND. YL.LT.YTR)
     1   PA = 0.5*(YTR-YTT)*(X(4)-XT)/BOXA
      IF (XT.LT.XLT .AND. XB.GE.XLT .AND. XT.LT.XRR .AND. XB.GE.XRR)
     1   PA = 0.5*((XLT+X(4)-2.0*XT)*(Y(4)-YL)+(X(4)+XRR-2.0*XT)*
     2   (YR-Y(4)))/BOXA
      IF (YL.LT.YTT .AND. YR.GE.YTT .AND. XT.LT.XRR .AND. XB.GE.XRR)
     1   PA = .5*((Y(4)-YTT)*(X(4)-XT)+(X(4)+XRR-2.*XT)*(YR-Y(4)))/BOXA
      GO TO 4799
C
 4780 IF (XT.LT.XLT .AND. XB.GE.XLT .AND. YR.GE.YBR .AND. YL.LT.YBR .AND
     1.   YL.LT.YBT .AND. YR.GE.YBT .AND. XT.LT.XRR .AND. XB.GE.XRR)
     2    PA = 1.0 - 0.5*((XB-XLT)*(YBT-YL)+(YR-YBR)*(XB-XRR))/BOXA
      IF (YL.LT.YTT .AND. YR.GE.YTT .AND. YL.LT.YBT .AND. YR.GE.YBT .AND
     1.   YR.GE.YBR .AND. YL.LT.YBR .AND. XT.LT.XRR .AND. XB.GE.XRR)
     2    PA = 0.5*((2.0*YR-YTT-YBT)*BOXL-(YR-YBR)*(XB-XRR))/BOXA
      IF (YR.GE.YTR .AND. YL.LT.YTR .AND. YR.GE.YBR .AND. YL.LT.YBR .AND
     1.   XT.LT.XLT .AND. XB.GE.XLT .AND. YL.LT.YBT .AND. YR.GE.YBT)
     2    PA = 0.5*((YTR+YBR-2.0*YL)*BOXL-(XB-XLT)*(YBT-YL))/BOXA
      IF (YL.LT.YTT .AND. YR.GE.YTT .AND. YR.GE.YTR .AND. YL.LT.YTR .AND
     1.   YL.LT.YBT .AND. YR.GE.YBT .AND. YR.GE.YBR .AND. YL.LT.YBR)
     2    PA = 0.5*(YTR-YTT+YBR-YBT)/BOXW
      GO TO 4799
C
 4788 IF (XB.GE.XLT .AND. YR.GE.YBT .AND. YL.LT.YTH)
     1    PA = 1.0 - 0.5*((YR-YTH)*(XRH-XT)+(XB-XLT)*(YBT-YL))/BOXA
      IF (XB.GE.XRT .AND. YL.LT.YBT .AND. YL.LT.YTH)
     1    PA = 1.0 - 0.5*((YR-YTH)*(XRH-XT)+(XB-XRT)*(YR-YBT))/BOXA
      IF (XT.LT.XLH .AND. XB.GE.XLT .AND. XB.GE.XRT)
     1    PA = 0.5*(XRT-XRH+XLT-XLH)/BOXL
      IF (XT.LT.XLH .AND. YL.LT.YBT .AND. XB.GE.XRT)
     1    PA = 1.0 - 0.5*((XLH+XRH-2.0*XT)*BOXW+(XB-XRT)*(YR-YBT))/BOXA
      IF (YL.LT.YTH .AND. XB.GE.XLT .AND. XB.GE.XRT)
     1    PA = 1.0 - 0.5*((2.0*XB-XLT-XRT)*BOXW+(XRH-XT)*(YR-YTH))/BOXA
      IF (XT.LT.XLH .AND. YR.GE.YBT .AND. XB.GE.XLT)
     1    PA = 1.0 - 0.5*((XLH+XRH-2.0*XT)*BOXW+(XB-XLT)*(YBT-YL))/BOXA
C
 4799 PAREA(J,I,2) = PA
      PAREA(J,I,1) = PAREA(J,I,1) - PA
      GO TO 5400
C
 4800 YL1  = 0.0
      XLL1 = (YL1-Y(2))*TANG(1) + X(2)
C
      IF (XT.LT.XLL1 .AND. XB.GE.XLL1 .AND. XT.LT.XRL .AND. XB.GE.XRL)
     1   PA = 0.5*(2.0*XB-XLL1-XRL)*(YR-YL1)/BOXA
      IF (YL1.LE.YBL .AND. YR.GE.YBL .AND. XT.LT.XRL .AND. XB.GE.XRL)
     1   PA = 0.5*(XB-XRL)*(YR-YBL)/BOXA
      IF (YL1.LE.YTL .AND. YR.GE.YTL .AND. XT.LT.XLL .AND. XB.GE.XLL)
     1   PA = 1.0 - 0.5*(YTL-YL1)*(XLL1-XT)/BOXA
      IF (YL1.LE.YTL .AND. YR.GE.YTL .AND. YL1.LE.YBL .AND. YR.GE.YBL)
     1   PA = 0.5*(2.0*YR-YTL-YBL)/BOXW
      GO TO 4720
C
C     LH CORNERS
C
 4820 IF (YL.LE.YTH .AND. YR.GE.YTH .AND. YL.LE.YBT .AND. YR.GE.YBT)
     1    PA = 0.5*((2.0*YR-YTH-Y(2))*(X(2)-XT)+(2.0*YR-Y(2)-Y(1))*
     2         (X(1)-X(2))+(2.0*YR-Y(1)-YBT)*(XB-X(1)))/BOXA
      IF (XT.LT.XRH .AND. XB.GE.XRH .AND. YL.LE.YBT .AND. YR.GE.YBT)
     1    PA = 0.5*((X(2)-XRH)*(YR-Y(2))+(2.0*YR-Y(2)-Y(1))*(X(1)-X(2))
     2         +(2.0*YR-Y(1)-YBT)*(XB-X(1)))/BOXA
      IF (YL.LE.YTH .AND. YR.GE.YTH .AND. XT.LT.XRT .AND. XB.GE.XRT)
     1    PA = 0.5*((2.0*YR-YTH-Y(2))*(X(2)-XT)+(2.0*YR-Y(2)-Y(1))*
     2         (X(1)-X(2))+(XRT-X(1))*(YR-Y(1)))/BOXA
      IF (XT.LT.XRH .AND. XB.GE.XRH .AND. XT.LT.XRT .AND. XB.GE.XRT)
     1    PA = 0.5*((X(2)-XRH)*(YR-Y(2))+(2.0*YR-Y(2)-Y(1))*(X(1)-X(2))
     2         +(XRT-X(1))*(YR-Y(1)))/BOXA
      IF (I-1) 4799,5000,4799
C
C     RH CORNERS
C
 4840 IF (YL.LT.YTH .AND. YR.GE.YTH .AND. YL.LT.YBT .AND. YR.GE.YBT)
     1   PA = 0.5*((YTH+Y(3)-2.0*YL)*(X(3)-XT)+(Y(3)+Y(4)-2.0*YL)*(X(4)
     2        -X(3))+(Y(4)+YBT-2.0*YL)*(XB-X(4)))/BOXA
      IF (XT.LT.XLH .AND. XB.GE.XLH .AND. YL.LT.YBT .AND. YR.GE.YBT)
     1   PA = 0.5*((X(3)-XLH)*(Y(3)-YL)+(Y(3)+Y(4)-2.0*YL)*(X(4)-X(3))
     2        +(Y(4)+YBT-2.0*YL)*(XB-X(4)))/BOXA
      IF (YL.LT.YTH .AND. YR.GE.YTH .AND. XT.LT.XLT .AND. XB.GE.XLT)
     1   PA = 0.5*((YTH+Y(3)-2.0*YL)*(X(3)-XT)+(Y(3)+Y(4)-2.0*YL)*(X(4)
     2        -X(3))+(XLT-X(4))*(Y(4)-YL))/BOXA
      IF (XT.LT.XLH .AND. XB.GE.XLH .AND. XT.LT.XLT .AND. XB.GE.XLT)
     1   PA = 0.5*((X(3)-XLH)*(Y(3)-YL)+(Y(3)+Y(4)-2.0*YL)*(X(4)-X(3))
     2        +(XLT-X(4))*(Y(4)-YL))/BOXA
      GO TO 4799
C
 4900 PAREA(J,I,2) = 1.0
      PAREA(J,I,1) = 0.0
      GO TO 5400
C
 5000 PAREA(J,I,2) = 2.0*PA
      PAREA(J,I,1) = PAREA(J,I,1) - PAREA(J,I,2)
C
 5400 CONTINUE
C
      YC = YR - BOXW/2.0
      XF = (YL-Y(2))*TANG(2) + X(2)
C
      IF (YC .LT. Y(2)) GO TO 5600
      IF (YC .LT. Y(3)) GO TO 5800
      IF (YC .GE. Y(4)) GO TO 6000
      XF2 = (YR-Y(3))*TANG(3) + X(3)
      NC1(I) = XF2/BOXL + 1.0
      IF (YC .LT. Y(1)) GO TO 5900
 5500 NCN(I) =  NWN(I)
      GO TO 6000
 5600 IF (YC .LT. Y(1)) GO TO 6000
      XF1 = (YR-Y(2))*TANG(1) + X(2)
      NC1(I) = XF1/BOXL + 1.0
 5700 NC1(I) = MAX0(NC1(I),NW1(I))
      IF (YC .LT. Y(4)) GO TO 5500
      XF2 = (YR-Y(3))*TANG(3) + X(3)
      NCN(I) = XF2/BOXL + 1.0
      GO TO 6000
 5800 NC1(I) = XF/BOXL + 1.0
      IF (YC .GE. Y(1)) GO TO 5700
 5900 XF1 = (YR-Y(2))*TANG(1) + X(2)
      NCN(I) = XF1/BOXL + 1.0
 6000 CONTINUE
C
      RETURN
      END

      SUBROUTINE GRAVL3 (NVECT,GVECT,SR1,IHARM)
C
C     BUILD GRAVITY LOADS FOR AXISYMMETRIC SHELL
C
C     DEFINITION OF VARIABLES
C
C     NVECT    NUMBER OF GRAVITY LOADS
C     GVECT    ARRAY OF G VECTORS
C     SR1      FILE TO PUT ACCELERATION VECTOR ON
C     IHARM    SINE OR COSINE SET FLAG -- 1 = SINE SET
C     LUSET    LENGTH OF G SET
C     MCB      MATRIX CONTROL BLOCK FOR SR1
C     M        NUMBER OF RINGS
C     N        NUMBER OF HARMONICS
C     IL       POINTER IN GVECT ARRAY
C
      EXTERNAL        RSHIFT,ANDF
      INTEGER         ANDF,RSHIFT,SYSBUF,MCB(7),SR1
      DIMENSION       GVECT(1)
      DIMENSION       ISYSTM(175)
      COMMON /MACHIN/ MACH,IHALF,JHALF
      COMMON /BLANK / LUSET
      COMMON /SYSTEM/ SYSBUF,IX(25),MN
      COMMON /ZZZZZZ/ Z(1)
      COMMON /ZBLPKX/ B(4),II
      EQUIVALENCE (SYSBUF, ISYSTM(1))
C
C     INITIALIZE STUFF
C
      IBUF = KORSZ(Z) - SYSBUF + 1
      CALL GOPEN (SR1,Z(IBUF),1)
      CALL MAKMCB (MCB,SR1,LUSET,2,1)
      IL    = 1
      N = MN
      M = ISYSTM(161)
C
C     BUILD NVECT GRAVITY VECTORS
C
      DO 140 ILOOP = 1,NVECT
      CALL BLDPK (1,1,MCB(1),0,0)
C
C     COMPUTE VALUES
C
      SINTH = 0.0
      SINPH = 0.0
      COSPH = 1.0
      G = SQRT(GVECT(IL)*GVECT(IL)+GVECT(IL+1)*GVECT(IL+1)+GVECT(IL+2)*
     1    GVECT(IL+2))
      COSTH = GVECT(IL+2)/G
      IF (GVECT(IL).EQ.0.0 .AND. GVECT(IL+1).EQ.0.0) GO TO 30
      GXY   = SQRT(GVECT(IL)*GVECT(IL)+ GVECT(IL+1)*GVECT(IL+1))
      SINTH = GXY/G
      SINPH = GVECT(IL+1)/GXY
      COSPH = GVECT(IL  )/GXY
   30 CONTINUE
      GO TO (40,50), IHARM
C
C     SINE SET
C
   40 B(1) = G*SINTH*SINPH
      II = LUSET - M*(N-1)*6 + 1
      DO 41 I = 1,M
      CALL ZBLPKI
      II = II +1
      CALL ZBLPKI
      II = II +5
   41 CONTINUE
      GO TO 110
C
C     COSINE SET
C
   50 B(1)=  G*COSTH
      II  = LUSET - M*N*6 + 3
C
C     LOAD ZERO HARMONIC
C
      DO 51 I = 1,M
      CALL ZBLPKI
      II = II + 6
   51 CONTINUE
C
C     LOAD 2-D HARMONIC
C
      II = II - 2
      B(1) = G*SINTH*COSPH
      DO 52 I = 1,M
      CALL ZBLPKI
      II = II +1
      B(1) = -B(1)
      CALL ZBLPKI
      B(1) = -B(1)
      II = II +5
   52 CONTINUE
C
C     END OF COLUMN
C
  110 CALL BLDPKN (MCB(1),0,MCB(1))
      IL = IL + 3
  140 CONTINUE
      CALL CLOSE (MCB(1),1)
      CALL WRTTRL (MCB)
      RETURN
C
      END

      SUBROUTINE RAND1(FILE,MID,TYPE,ID,COMP,Q)
C
C     PUTS ID RECORD ON RANDOM OUTPUT FILES
C
      INTEGER FILE,TYPE,COMP,IDR(50)
      INTEGER Q(2)
      INTEGER MID1(2,7)
      COMMON /OUTPUT/ HEAD(1)
      DATA MID1/2001,4HDISP,
     1          2010,4HVELO,
     2          2011,4HACCE,
     3          2002,4HLOAD,
     4          2003,4HSPCF,
     5          2004,4HELFO,
     6          2005,4HSTRE/
      DATA IDR /50*0/
      IDR(1)= 50
      IDR(3) = MID
      DO 10 I = 1,7
      IF(TYPE .EQ. MID1(2,I)) GO TO 20
   10 CONTINUE
   20 ITYPE = MID1(1,I)
      IDR(2) = ITYPE
      IDR(5) = ID*10
      IDR(6) = COMP
      IDR(8) = Q(1)
      IDR(9) = Q(2)
      IDR(10) = 2
      CALL WRITE(FILE,IDR(1),50,0)
      CALL WRITE(FILE,HEAD(1),96,1)
      RETURN
      END

      SUBROUTINE EDTL (NEDT,ILIST,PG)
C
C     THIS SUBROUTINE COMPUTES THE ELEMENT TEMPERATURE AND ENFORCED
C     DEFORMATION LOADS
C
      IMPLICIT INTEGER (A-Z)
      LOGICAL         EORFLG,ENDID,BUFFLG,RECORD
      INTEGER         PG(7),PCOMP(2),PCOMP1(2),PCOMP2(2),ILIST(1),
     1                IPARM(2),TLIST(1080)
      REAL            CORE,TI
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25,SWM*27
      COMMON /XMSSG / UFM,UWM,UIM,SFM,SWM
      COMMON /BLANK / NROWSP,IPARAM,COMPS
      COMMON /SYSTEM/ KSYSTM(64)
      COMMON /PACKX / ITYA,ITYB,II,JJ,INCUR
      COMMON /ZZZZZZ/ CORE(1)
      COMMON /XCSTM / TGB(3,3)
      COMMON /TRANX / IDUM1(14)
      COMMON /FPT   / TO,NSIL,NGPTT,NSTART,LCORE
      COMMON /LOADX / LCARE,N(3),CSTM,SIL,NNN,ECPT,MPT,GPTT,EDT,IMPT,
     1                IGPTT,IEC,NN(3),DIT,ICM
      COMMON /TRIMEX/ MECPT(200)
      COMMON /SGTMPD/ TI(33)
      COMMON /MATIN / MATID,INFLAG,TEMP,STRESS,SINTH,COSTH
      COMMON /MATOUT/ E1,G,NU,RHO,ALPHA,TO1,GE,SIGMAT,SIGMAC,SIGMAS,
     1                SPACE(10)
      COMMON /GPTA1 / NELEMS,LAST,INCR,NE(1)
      COMMON /SSGETT/ ELTYPE,OLDEL,EORFLG,ENDID,BUFFLG,ITEMP,IDEFT,
     1                IDEFM,RECORD
      COMMON /SSGWRK/ DUM(300)
      COMMON /COMPST/ IPCMP,NPCMP,IPCMP1,NPCMP1,IPCMP2,NPCMP2
      EQUIVALENCE     (KSYSTM( 1),SYSBUF),(KSYSTM( 2),OUTPT ),
     1                (KSYSTM(55),IPREC ),(KSYSTM(56),ITHRML),
     2                (TI(7)     ,ICHECK),(TI(6)     ,IFLAG )
      DATA    IPARM , IPGTT/ 4HEDTL,4H    ,4HGPTT   /
      DATA    CROD  , CTUBE, CONROD, CBAR, PCOMPS   /
     1        1     , 3    , 10    , 34  , 112      /
      DATA    PCOMP ,        PCOMP1,       PCOMP2   /
     1        5502  , 55,    5602, 56,     5702, 57 /
C
      IGPTT = IPGTT
C
C     CHECK IF HEAT FORMULATION
C
      IF (ITHRML .NE. 0) RETURN
C
      ITEMP = 0
      IDEFT = NEDT
      GO TO 10
C
C
      ENTRY TEMPL (NTEMP,ILIST,PG)
C     ============================
C
      IF (ITHRML .NE. 0) RETURN
      IDEFT = 0
      ITEMP = NTEMP
C
C     START SEARCH POINTERS AT ZERO
C
   10 ITYA  = 1
      CALL DELSET
      ITYB  = 1
      IPR   = IPREC
      IF (IPR .NE. 1) IPR = 0
      II    = 1
      JJ    = NROWSP
      INCUR = 1
      NNN   = 0
      NOGPTT= 0
      IDUM1(1) = 0
      ICM   = 1
      NOEDT = 0
      CALL DELSET
      LPCOMP = 0
C
C     SET CORE SIZE AND BUFFERS
C
      LCORE= KORSZ(CORE) - NROWSP
      BUF1 = LCORE - SYSBUF - 2
      BUF2 = BUF1  - SYSBUF - 2
      BUF3 = BUF2  - SYSBUF - 2
      BUF4 = BUF3  - SYSBUF - 2
      BUF5 = BUF4  - SYSBUF - 2
C
C     OPEN FILES--
C
C     READ FILE PCOMPS INTO CORE ONLY IF PARAM COMPS = -1,
C     INDICATING THE PRESENCE OF LAMINATED COMPOSITE ELEMENTS
C
      IF (COMPS .NE. -1) GO TO 25
C
      IPM = PCOMPS
      CALL PRELOC (*750,CORE(BUF2),PCOMPS)
C
      IPCMP  = NROWSP + 1
      IPCMP1 = IPCMP
      NPCMP  = 0
      NPCMP1 = 0
      NPCMP2 = 0
C
      LCORE = BUF5 - NROWSP - 1
C
C     LOCATE PCOMP DATA AND READ INTO CORE
C
      CALL LOCATE (*14,CORE(BUF2),PCOMP,FLAG)
C
      CALL READ (*860,*12,PCOMPS,CORE(IPCMP),LCORE,0,NPCMP)
      GO TO 820
   12 IPCMP1 = IPCMP + NPCMP
      LCORE  = LCORE - NPCMP
      IF (IPCMP1 .GE. LCORE) GO TO 820
C
C     LOCATE PCOMP1 DATA AND READ INTO CORE
C
   14 CALL LOCATE (*18,CORE(BUF2),PCOMP1,FLAG)
C
      IPCMP1 = IPCMP + NPCMP
      CALL READ (*20,*16,PCOMPS,CORE(IPCMP1),LCORE,0,NPCMP1)
      GO TO 820
   16 IPCMP2 = IPCMP1 + NPCMP1
      LCORE  = LCORE  - NPCMP1
      IF (IPCMP2 .GE. LCORE) GO TO 820
C
C     LOCATE PCOMP2 DATA AND READ INTO CORE
C
   18 CALL LOCATE (*20,CORE(BUF2),PCOMP2,FLAG)
C
      IPCMP2 = IPCMP1 + NPCMP1
      CALL READ (*20,*20,PCOMPS,CORE(IPCMP2),LCORE,0,NPCMP2)
      GO TO 820
C
   20 LPCOMP = NPCMP + NPCMP1 + NPCMP2
C
      LCORE = LCORE - NPCMP2
      IF (LCORE .LE. 0) GO TO 820
C
      CALL CLOSE (PCOMPS,1)
C
C
   25 CALL GOPEN (ECPT,CORE(BUF2),0)
      IF (ITEMP) 30,40,30
   30 IPM = GPTT
      CALL OPEN (*750,GPTT,CORE(BUF3),0)
C
C     BRING IN MAT ETC
C
      CALL READ (*860,*810,GPTT,TLIST(1),  -2,0,NTLIST)
      CALL READ (*860,*40 ,GPTT,TLIST(1),1080,1,NTLIST)
      WRITE  (OUTPT,35) UFM
   35 FORMAT (A23,' 4013, PROBLEM LIMITATION OF 360 TEMPERATURE SETS ',
     1       ' HAS BEEN EXCEEDED.')
      N1 = -37
      GO TO 760
   40 IF (IDEFT .NE. 0) CALL GOPEN (EDT,CORE(BUF4),0)
      NLOOP = IDEFT + ITEMP
      IF (IDEFT .NE. 0) LDEFM = 0
C
C     INITIALIZE MATERIAL ROUTINE
C
      IMAT  = NROWSP + LPCOMP
      LCORE = BUF5   - IMAT
      CALL PREMAT (CORE(IMAT+1),CORE(IMAT+1),CORE(BUF5),LCORE,NMAT,
     1             MPT,DIT)
      NSTART = IMAT  + NMAT
      LCORE  = LCORE - NSTART
      IF (LCORE .LE. 0) GO TO 820
      IF (IDEFT .NE. 0) LDEFM = 0
C
      DO 720 ILLOP = 1,NLOOP
C
      IDEFM = ILIST(ILLOP)
      IF (ITEMP) 75,75,70
   70 CALL REWIND (GPTT)
C
   75 IF (NNN .EQ. 1) GO TO 95
C
C     BRING SIL INTO CORE
C
      IF (LCORE .LT. 0) GO TO 820
      CALL GOPEN (SIL,CORE(BUF5),0)
      IPM = SIL
      CALL READ (*860,*80,SIL,CORE(NSTART+1),LCORE,1,NSIL)
      GO TO 820
   80 CALL CLOSE (SIL,1)
      LCORE  = LCORE  - NSIL
      NSTART = NSTART + NSIL
C
C     READ CSTM INTO OPEN CORE AND MAKE INITIAL CALLS TO PRETRD/PRETRS
C
      IF (LCORE .LT. 0) GO TO 820
      CALL OPEN (*90,CSTM,CORE(BUF5),0)
      ICM = 0
      CALL SKPREC (CSTM,1)
      IPM = CSTM
      CALL READ (*860,*85,CSTM,CORE(NSTART+1),LCORE,1,NCSTM)
      GO TO 820
   85 CONTINUE
C
C     FOR THOSE SUBROUTINES WHICH USE BASGLB INSTEAD OF TRANSS/TRANSD,
C     WE NEED TO REPOSITION THE CSTM FILE AND LEAVE THE GINO BUFFER
C     AVAILABLE FOR LATER CALLS TO READ BY SUBROUTINE BASGLB.
C
      CALL REWIND (CSTM)
      CALL SKPREC (CSTM,1)
C
      CALL PRETRD (CORE(NSTART+1),NCSTM)
      CALL PRETRS (CORE(NSTART+1),NCSTM)
C
      LCORE  = LCORE  - NCSTM
      NSTART = NSTART + NCSTM
      IF (LCORE .LE. 0) GO TO 820
C
   90 NNN = 1
   95 IF (ITEMP) 150, 150, 99
C
   99 DO 100 I = 1,NTLIST,3
      IF (IDEFM .EQ. TLIST(I)) GO TO 110
  100 CONTINUE
C
C     THERMAL LOAD NOT FOUND IN GPTT
C
      IPARM(2) = IPARM(1)
      IPARM(1) = IGPTT
      CALL MESAGE (-32,IDEFM,IPARM(1))
  110 TO = TLIST(I+1)
      IF (TLIST(I+2) .EQ. 0) GO TO 140
      I = TLIST(I+2)
      DO 120 J = 1,I
      CALL FWDREC (*800,GPTT)
  120 CONTINUE
C
C     READ SETID AND VERIFY CORRECT RECORD.  FAILSAFE
C
      CALL READ (*121,*121,GPTT,IDDD,1,0,DUMMY)
      IF (IDDD .EQ. IDEFM) GO TO 125
  121 WRITE  (OUTPT,122) IDEFM
  122 FORMAT (98H0*** SYSTEM FATAL ERROR 4014, ROUTINE EDTL DETECTS BAD
     1DATA ON TEMPERATURE DATA BLOCK FOR SET ID =,I9)
      N1 = -61
      GO TO 760
  125 RECORD = .TRUE.
      GO TO 150
C
C     THE GPTT (ELEMENT TEMPERATURE TABLE) IS NOW POSITIONED TO THE
C     TEMPERATURE DATA FOR THE SET REQUESTED.  SUBROUTINE SSGETD WILL
C     READ THE DATA.
C
  140 CONTINUE
      RECORD = .FALSE.
C
  150 CONTINUE
      CALL CLOSE (CSTM,1)
      CALL OPEN (*151,CSTM,CORE(BUF5),0)
      CALL SKPREC (CSTM,1)
      ICM = 0
  151 DO 160 I = 1,NROWSP
  160 CORE(I) =  0.0
C
C     INITIALIZE /SSGETT/ VARIABLES
C
      OLDEL  = 0
      EORFLG = .FALSE.
      ENDID  = .TRUE.
      BUFFLG = .FALSE.
C
C     ELEMENT CALL PROCESSING
C
C
C     READ THE ELEMENT TYPE
C
  170 CALL READ (*710,*830,ECPT,ELTYPE,1,0,FLAG)
      IF (ELTYPE.GE.1 .AND. ELTYPE.LE.NELEMS) GO TO 174
      CALL MESAGE (-7,0,NAME)
  172 WRITE  (OUTPT,173) SWM,ELTYPE
  173 FORMAT (A27,' 4015, ELEMENT THERMAL AND DEFORMATION LOADING NOT ',
     1       'COMPUTED FOR ILLEGAL ELEMENT TYPE',I9, /34X,
     2       'IN MODULE SSG1.')
      GO TO 610
  174 IDX    = (ELTYPE-1)*INCR
      JLTYPE = 2*ELTYPE - IPR
      NWORDS = NE(IDX+12)
C
C     READ AN ENTRY FOR ONE ELEMENT FROM ECPT
C
  175 CALL READ (*840,*170,ECPT,MECPT(1),NWORDS,0,FLAG)
      IF (ITEMP .NE. 0) GO TO 176
C
C     ELEMENT DEFORMATION LOAD
C
      IF (IDEFM .NE. LDEFM) CALL FEDTST (IDEFM)
      LDEFM = IDEFM
      IF (ELTYPE .EQ. CROD  ) GO TO 180
      IF (ELTYPE .EQ. CTUBE ) GO TO 200
      IF (ELTYPE .EQ. CONROD) GO TO 190
      IF (ELTYPE .EQ. CBAR  ) GO TO 210
      GO TO 610
C
C     THERMAL LOAD
C
  176 CONTINUE
C
C     BRANCH TO THE DESIRED ELEMENT TYPE
C
      LOCAL = JLTYPE - 100
      IF (LOCAL) 177,177,178
C
C
C     PAIRED -GO TO- ENTRIES PER ELEMENT SINGLE/DOUBLE PRECISION
C
C             1 CROD      2 CBEAM     3 CTUBE     4 CSHEAR    5 CTWIST
  177 GO TO( 180,  180,  172,  172,  200,  200,  360,  360,  610,  610
C
C             6 CTRIA1    7 CTRBSC    8 CTRPLT    9 CTRMEM   10 CONROD
     1,      270,  270,  240,  240,  250,  250,  220,  220,  190,  190
C
C            11 ELAS1    12 ELAS2    13 ELAS3    14 ELAS4    15 CQDPLT
     2,      610,  610,  610,  610,  610,  610,  610,  610,  260,  260
C
C            16 CQDMEM   17 CTRIA2   18 CQUAD2   19 CQUAD1   20 CDAMP1
     3,      230,  230,  280,  280,  300,  300,  290,  290,  610,  610
C
C            21 CDAMP2   22 CDAMP3   23 CDAMP4   24 CVISC    25 CMASS1
     4,      610,  610,  610,  610,  610,  610,  610,  610,  610,  610
C
C            26 CMASS2   27 CMASS3   28 CMASS4   29 CONM1    30 CONM2
     5,      610,  610,  610,  610,  610,  610,  610,  610,  610,  610
C
C            31 PLOTEL   32 CREACT   33 CQUAD3   34 CBAR     35 CCONE
     6,      610,  610,  172,  172,  172,  172,  210,  210,  350,  350
C
C            36 CTRIARG  37 CTRAPRG  38 CTORDRG  39 CTETRA   40 CWEDGE
     7,      320,  320,  330,  330,  340,  340,  390,  390,  400,  400
C
C            41 CHEXA1   42 CHEXA2   43 CFLUID2  44 CFLUID3  45 CFLUID4
     8,      410,  410,  420,  420,  610,  610,  610,  610,  610,  610
C
C            46 CFLMASS  47 CAXIF2   48 CAXIF3   49 CAXIF4   50 CSLOT3
     9,      610,  610,  610,  610,  610,  610,  610,  610,  610,  610
C
     *), JLTYPE
C
C            51 CSLOT4   52 CHBDY    53 CDUM1    54 CDUM2    55 CDUM3
  178 GO TO( 610,  610,  610,  610,  553,  553,  554,  554,  555,  555
C
C            56 CDUM4    57 CDUM5    58 CDUM6    59 CDUM7    60 CDUM8
     B,      556,  556,  557,  557,  558,  558,  559,  559,  560,  560
C
C            61 CDUM9    62 CQDMEM1  63 CQDMEM2  64 CQUAD4   65 CIHEX1
     C,      561,  561,  562,  562,  563,  563,  564,  564,  425,  425
C
C            66 CIHEX2   67 CIHEX3   68 CQUADTS  69 CTRIATS  70 CTRIAAX
     D,      425,  425,  425,  425,  172,  172,  172,  172,  428,  428
C
C             71 CTRAPAX  72 CAERO1   73 CTRIM6   74 CTRPLT1  75 CTRSHL
     E,       429,  429,  172,  172,  430,  430,  431,  431,  432,  432
C
C             76 CFHEX1   77 CFHEX2   78 CFTETRA  79 CFWEDGE  80 CIS2D8
     F,       172,  172,  172,  172,  172,  172,  172,  172,  433,  433
C
C             81 CELBOW   82 FTUBE    83 TRIA3
     G,       172,  172,  610,  610,  566,  566
C
     *), LOCAL
C
C     ROD
C
  180 CALL ROD
      GO TO 175
C
C     CONROD
C
  190 GO TO 180
C
C     TUBE
C
  200 GO TO 180
C
C     BAR
C
  210 CALL BAR (CORE(1),IDEFM,ITEMP,IDEFT)
      GO TO 175
C
C     TRMEM
C
  220 CALL SSGETD (MECPT(1),TI(1),0)
      CALL TRIMEM (0,TI,CORE(1))
      GO TO 175
C
C     QDMEM
C
  230 CALL SSGETD (MECPT(1),TI(1),0)
      CALL QDMEM  (TI,CORE(1))
      GO TO 175
C
C     TRBSC
C
  240 CALL SSGETD (MECPT(1),TI(1),0)
      CALL TRBSC  (0,TI)
      GO TO 175
C
C     TRPLT
C
  250 CALL SSGETD (MECPT(1),TI(1),0)
      CALL TRPLT  (TI)
      GO TO 175
C
C     QDPLT
C
  260 CALL SSGETD (MECPT(1),TI(1),0)
      CALL QDPLT  (TI)
      GO TO 175
C
C     TRIA1
C
  270 KK = 1
      GO TO 301
C
C     TRIA2
C
  280 KK = 2
      GO TO 301
C
C     QUAD1
C
  290 KK = 3
      GO TO 301
C
C     QUAD2
C
  300 KK = 4
  301 CALL SSGETD (MECPT(1),TI(1),0)
      CALL TRIQD  (KK,TI(1))
      GO TO 175
C
C     TRIARG
C
  320 CALL SSGETD (MECPT(1),TI(1),3)
      CALL TTRIRG (TI(2),CORE(1))
      GO TO 175
C
C     TRAPRG
C
  330 CALL SSGETD (MECPT(1),TI(1),4)
      CALL TTRAPR (TI(2),CORE(1))
      GO TO 175
C
C     TORDRG
C
  340 CALL SSGETD (MECPT(1),TI(1),2)
      CALL TTORDR (TI(2),CORE(1) )
      GO TO 175
C
C     CONE
C
  350 CALL SSGETD (MECPT(1),TI(1),2)
      CALL CONE   (TI(2),CORE(1))
      GO TO 175
C
C     SHEAR PANEL
C
  360 CALL TSHEAR
      GO TO 175
C
C     TETRA
C
  390 CALL SSGETD (MECPT(1),TI(1),4)
      CALL TETRA  (TI(2),CORE(1),0)
      GO TO 175
C
C     WEDGE
C
  400 IIJJ = 1
      NPTS = 6
      GO TO 421
C
C     HEXA1
C
  410 IIJJ = 2
      NPTS = 8
      GO TO 421
C
C     HEXA2
C
  420 IIJJ = 3
      NPTS = 8
  421 CALL SSGETD (MECPT(1),TI(1),NPTS)
      CALL SOLID  (TI(2),CORE(1),IIJJ)
      GO TO 175
C
C     IHEX1, IHEX2, IHEX3
C
  425 NPTS=12*(ELTYPE-64)-4
      CALL SSGETD (MECPT(1),TI(1),NPTS)
      CALL IHEX   (TI(1),CORE(1),ELTYPE-64)
      GO TO 175
C
C     TRIAAX
C
  428 CALL SSGETD (MECPT,TI,3)
      CALL TRTTEM (TI(2),CORE)
      GO TO 175
C
C     TRAPAX
C
  429 CALL SSGETD (MECPT,TI,4)
      CALL TPZTEM (TI(2),CORE)
      GO TO 175
C
C     TRIM6
C
  430 CALL SSGETD (MECPT(1),TI,6)
      CALL TLODM6 (TI(1))
      GO TO 175
C
C     TRPLT1
C
  431 CALL SSGETD (MECPT(1),TI,0)
      CALL TLODT1 (TI(1),TI(1))
      GO TO 175
C
C     TRSHL
C
  432 CALL SSGETD (MECPT(1),TI(1),0)
      CALL TLODSL (TI(1),TI(1))
      GO TO 175
C
C     IS2D8
C
  433 CALL SSGETD (MECPT(1),TI(1),8)
      CALL TIS2D8 (TI(2),CORE)
      GO TO 175
C
C     DUMMY ELEMENTS
C
  553 CALL DUM1 (CORE(1))
      GO TO 175
  554 CALL DUM2 (CORE(1))
      GO TO 175
  555 CALL DUM3 (CORE(1))
      GO TO 175
  556 CALL DUM4 (CORE(1))
      GO TO 175
  557 CALL DUM5 (CORE(1))
      GO TO 175
  558 CALL DUM6 (CORE(1))
      GO TO 175
  559 CALL DUM7 (CORE(1))
      GO TO 175
  560 CALL DUM8 (CORE(1))
      GO TO 175
  561 CALL DUM9 (CORE(1))
      GO TO 175
C
C     QDMEM1
C
  562 CALL SSGETD (MECPT(1),TI(1),0)
      CALL QDMM1  (TI,CORE(1))
      GO TO 175
C
C     QDMEM2
C
  563 CALL SSGETD (MECPT(1),TI(1),0)
      CALL QDMM2  (TI,CORE(1))
      GO TO 175
C
C     QUAD4
C
  564 DO 565 ITI = 1,7
  565 TI(ITI) = 0.0
      CALL SSGETD (MECPT(1),TI,4)
      IF (IPR .NE. 0) CALL TLQD4S
      IF (IPR .EQ. 0) CALL TLQD4D
      GO TO 175
C
C     TRIA3
C
  566 DO 567 ITI = 1,7
  567 TI(ITI) = 0.0
      CALL SSGETD (MECPT(1),TI,3)
      IF (IPR .NE. 0) CALL TLTR3S
      IF (IPR .EQ. 0) CALL TLTR3D
      GO TO 175
C
C     NO LOAD, SKIP THE ECPT ENTRY ONLY
C
  610 CALL FWDREC (*840,ECPT)
      GO TO 170
C
C     PACK THE LOAD VECTOR FROM CORE TO OUTPUT DATA BLOCK -PG-
C
  710 CALL PACK (CORE,PG(1),PG)
      CALL REWIND (ECPT)
      CALL FWDREC (*840,ECPT)
      IF (IDEFT .NE. 0 .AND. IDEFM .NE. 0) CALL FEDTED (IDEFM)
C
  720 CONTINUE
C
      IF (NOEDT  .EQ. 0) CALL CLOSE (EDT ,1)
      IF (NOGPTT .EQ. 0) CALL CLOSE (GPTT,1)
      IF (ICM    .EQ. 0) CALL CLOSE (CSTM,1)
      CALL CLOSE (ECPT,1)
      RETURN
C
  750 N1 = -1
  760 CALL MESAGE (N1,IPM,IPARM)
  800 IPM = GPTT
      GO TO 860
  810 N1 = -3
      GO TO 760
  820 N1 = -8
      GO TO 760
  830 IPM = ECPT
      GO TO 810
  840 IPM = ECPT
  860 N1 = -2
      GO TO 760
      END

      SUBROUTINE RAND2 (FILE,ILIST,LOAD,IF,LEN,LLIST)
C
C     READS FILE UNTIL IT FINDS DATA RECORD IN LIST - RETURNS LOAD,
C     IF, AND LEN
C
      INTEGER         FILE,IDR(10),NAME(2),ILIST(2),MID(2,10),ITEMP(5),
     1                IDATA(50),IFMT(2,84),IFMTT(11),DATA1(100),DATA(1),
     2                ITB(180),ITB1(137),ITB2(145),FILEX
      CHARACTER       UFM*23,UWM*25
      COMMON /XMSSG / UFM,UWM
      COMMON /SYSTEM/ IBUF,NOUT
      EQUIVALENCE     (ITB1(1),ITB(1)), (ITB2(1),ITB(138))
      DATA    IFMTT / 1,11,41,55,61,99,121,155,181,199,237/
      DATA    IOLDLD/ 0 /
      DATA    IFMT  /
     1        1, 1,    -1,-1,     1, 1,     1, 1,     1, 1,     6, 2,
     7        6, 2,     6, 2,     0, 3,     1, 1,     4, 4,     4, 4,
     3        4, 4,     4, 0,     6, 2,     0, 3,     6, 2,     6, 2,
     9        6, 2,    -1,-1,    -1,-1,    -1,-1,    -1,-1,    -1,-1,
     5       -1,-1,    -1,-1,    -1,-1,    -1,-1,    -1,-1,    -1,-1,
     1       -1,-1,    -1,-1,    -1,-1,     7, 5,    -1,-1,    -1,-1,
     7       -1,-1,    -1,-1,     0, 8,     0, 8,     0, 8,     0, 8,
     3       -1,-1,    -1,-1,    -1,-1,    -1,-1,     0, 9,     0,10,
     9        0,11,     0, 6,     0, 8,    -1,-1,    -1,-1,    -1,-1,
     5       -1,-1,    -1,-1,    -1,-1,    -1,-1,    -1,-1,    -1,-1,
     1       -1,-1,     0, 3,     0, 3,     7, 2,    -1,-1,    -1,-1,
     7       -1,-1,    -1,-1,    -1,-1,    -1,-1,    -1,-1,    -1,-1,
     3       -1,-1,    -1,-1,    -1,-1,    -1,-1,    -1,-1,    -1,-1,
     9       -1,-1,    -1,-1,    -1,-1,    -1,-1,     7, 2,    -1,-1/
C
C     IFMT TABLE (ELEM ID IN GPTABD ORDER) HAS 2 WORDS PER ENTRY
C        WORD1  FORCE  FORMAT POINTER INTO IFMTT TABLE
C        WORD2  STRESS FORMAT POINTER INTO IFMTT TABLE
C
C     IFMTT TABLE  HAS ONE ENTRY PER FORMAT TYPE
C        THE ENTRY IS THE BEGINNING OF THE FORMAT IN THE ITB TABLE
C
      DATA ITB1/
     1   6,   3,   5,   4,   6,
     1   0,   1,   1,   2,   2,
     2  16,   3,   4,  12,   5,  13,   6,  14,   7,   8,  16,   9,  17,
     *  10,  18,
     2   0,   1,   2,   2,   3,   3,   4,   4,   5,   6,   6,   7,   7,
     *   8,   8,
     3   8,   3,   6,   4,   7,   5,   8,
     3   0,   1,   1,   2,   2,   3,   3,
     4   4,   3,   4,
     4   0,   1,   1,
     5  20,   3,   4,   5,   6,   7,  12,  13,  14,  15,  16,   8,   9,
     *  10,  11,  17,  18,  19,  20,
     5   0,   1,   2,   3,   4,   5,   1,   2,   3,   4,   5,   6,   7,
     *   8,   9,   6,   7,   8,   9,
     6  12,   3,   4,   5,   6,   7,   8,   9,  10,  11,  12,
     6   0,   1,   2,   3,   4,   5,   1,   2,   3,   4,   5,
     7  18,   3,   4,   5,   6,   7,   8,   9,  10,  11,  12,  13,  14,
     *  15,  16,  17,  18/
      DATA ITB2/
     7   0,   1,   2,   3,   4,   5,   6,   7,   8,   1,   2,   3,   4,
     *   5,   6,   7,   8,
     8  14,   3,   4,   5,   6,   7,   8,   9,  10,  11,  12,  13,  14,
     8   0,   1,   2,   3,   4,   5,   6,   1,   2,   3,   4,   5,   6,
     9  10,   3,   4,   5,   6,   7,   8,   9,  10,
     9   0,   1,   2,   3,   4,   1,   2,   3,   4,
     O  20,   3,   4,   5,   6,   7,   8,   9,  10,  11,  12,  13,  14,
     *  15,  16,  17,  18,  19,  20,
     O   0,   1,   2,   3,   4,   5,   6,   7,   8,   9,   1,   2,   3,
     *   4,   5,   6,   7,   8,   9,
     A  24,   3,   4,   5,   6,   7,   8,   9,  10,  11,  12,  13,  14,
     *  15,  16,  17,  18,  19,  20,  21,  22,  23,  24,
     A   0,   1,   2,   3,   4,   5,   6,   7,   8,   9,  10,  11,   1,
     *   2,   3,   4,   5,   6,   7,   8,   9,  10,  11/
      DATA NAME/ 4HRAND,4H2   /
      DATA MID / 3001  ,4HDISP,
     1           3010  ,4HVELO,
     2           3011  ,4HACCE,
     3           3002  ,4HLOAD,
     4           3003  ,4HSPCF,
     5           3004  ,4HELFO,
     6           3005  ,4HSTRE,
     7           3015  ,4HDISP,
     8           3016  ,4HVELO,
     9           3017  ,4HACCE/
C
      FILEX = FILE
C
C     POSITION TO + READ ID RECORD
C
    5 CALL FWDREC (*950,FILE)
      CALL READ (*950,*920,FILE,IDR,10,1,I)
      IDR(5) = IDR(5)/10
C
C     IDR(5) = 10*ELEM.ID + DEV.CODE
C     IDR(2) = GINO FILE 3004, 3005 ETC.
C     CONVERT MAJOR ID TO MNEMONIC
C
      DO 10 I = 1,10
      IF (IDR(2) .EQ. MID(1,I)) GO TO 20
   10 CONTINUE
C
C     ILLEGAL FORMAT
C
      GO TO 970
C
C     CHECK FOR  MID
C
   20 IF (ILIST(1) .NE. MID(2,I)) GO TO 5
      IELEM = I
C
C     LOOK FOR ID IN LIST
C
      DO 30 I = 1,LLIST,5
      IF (IDR(5)-ILIST(I+1)) 5,50,30
   30 CONTINUE
      GO TO 5
C
C     ID IS IN  LIST
C
   50 I = I - 1
      IF (I .EQ. 0) GO TO 100
C
C     FLIP LIST ORDER
C
      M  = 0
      LL = I
C
C     SAVE CURRENT STUFF AT END OF LIST
C
   54 DO 51 J = 1,5
      L = I + J
      ITEMP(J) = ILIST(L)
   51 CONTINUE
C
C     PUSH DOWN LIST
C
      DO 52 J = 1,LL
      K = I - J + 1
      ILIST(K+5) = ILIST(K)
   52 CONTINUE
C
C     RESTORE CURRENT STUFF IN FRONT OF LIST, IN FLIPPED ORDER
C
      DO 53 J = 1,5
      K = M + J
      ILIST(K) = ITEMP(J)
   53 CONTINUE
C
C     AGAIN
C
      IF (ILIST(I+7) .NE. ITEMP(2)) GO TO 100
      M = M + 5
      I = I + 5
      GO TO 54
C
C     FOUND IT
C
C     IDR( 3) = ELEMENT TYPE
C     IDR( 4) = SUBCASE NO.
C     IDR( 9) = FORMAT CODE, 1=REAL, 2=REAL/IMAG, 3=MAG/PHASE
C     IDR(10) = NO. OF WORDS PER ENTRY
C     IELEM   = 6 OR 7 FOR ELFORCE (OEFC2) OR STRESS (OESC2)
C
  100 LOAD = IDR(4)
      IF   = 0
      IF (IDR(9) .EQ. 3) IF = 1
      LEN1 = IDR(10)
      LEN  = LEN1
      IELTP= IDR(3)
      IF (IELEM.LT.6 .OR. IELEM.GT.7) GO TO 150
C
C     EXECUTE THIS PORTION FOR STRESSES AND FORCES
C
C     FIND FORMAT TYPE
C
      IF (IFMT(1,IELTP) .EQ. -1) GO TO 930
C
C     PICK UP FORMAT POINTER
C
      IFMTP = IFMT(IELEM-5,IELTP)
      IF (IFMTP  .EQ. 0) GO TO 970
      J = IFMTT(IFMTP)
C
C     SAVE EXTERNAL DATA LENGTH
C
      LEN  = ITB(J)
C
C     SAVE MAP OF ITB
C
      DO 130 I = 1,LEN1
      K = J + I - 1
      IDATA(I) = ITB(K)
  130 CONTINUE
C
C     CONVERT POINTERS TO NEW DATA VALUES
C
      IF (IOLDLD .EQ.    0) GO TO 131
      IF (IOLDLD .NE. LOAD) GO TO 150
  131 IOLDLD = LOAD
      DO 140 I = 1,LLIST,5
      IF (ILIST(I).NE.MID(2,IELEM) .OR. ILIST(I+1).NE.ILIST(2))
     1    GO TO 150
      K = ILIST(I+2)
      IF (K .LE. LEN1) GO TO 141
C
C     POINTER OUT OF RANGE
C
      CALL MESAGE (52,ILIST(I),ILIST(I+1))
      K = LEN1
  141 K = J + K - 1 + LEN1
      ILIST(I+2) = ITB(K)
  140 CONTINUE
  150 ICHK  = 1234321
      LENX  = LEN
C
C     FILE AND LEN WERE SAVED LOCALLY IN FILEX AND LENX, SO THAT THEY
C     CAN BE USED IN RAND2A
C
      RETURN
C
C
      ENTRY RAND2A (DATA)
C     ===================
C
C     WILL OBTAIN DATA AND REFORMAT IF NECESSARY
C
C     READ DATA
C
      IF (ICHK .NE. 1234321) CALL MESAGE (-37,0,NAME)
      CALL READ (*910,*920,FILEX,DATA(1),LEN1,0,IFLAG)
      IF (IELEM .LT. 6) RETURN
C
C     APPLY DATA MAP  I.E. REARRANGE DATA ACCORDING TO DATA MAP
C
      DO 170 I = 1,LENX
      DATA1(I) = 0
  170 CONTINUE
      DATA1(1) = DATA(1)
      DO 180 I = 2,LEN1
      J = IDATA(I)
      DATA1(J) = DATA(I)
  180 CONTINUE
CWKBR 9/93 DO 190 I = 1,LEN
      DO 190 I = 1,LENX
      DATA(I)  = DATA1(I)
  190 CONTINUE
      RETURN
C
C     FILE ERRORS
C
  910 IP1 = -2
  911 CALL MESAGE (IP1,FILEX,NAME)
  920 IP1 = -3
      GO TO 911
  930 WRITE  (NOUT,940) UWM,IELTP
  940 FORMAT (A25,' 2185, CURRENTLY RAND2 ROUTINE DOES NOT PROCESS ',
     1        'ELEMENT TYPE',I5)
      GO TO 5
C 950 LOAD = 0
  950 CALL REWIND (FILEX)
CWKBI 9/93
      WRITE(NOUT,9901)
9901  FORMAT(' THE FOLLOWING I/O ERROR OCCURRED MOST LIKELY BECAUSE'
     &,/,' THERE WAS A PLOT REQUEST FOR A POINT THAT DOES NOT EXIST.')
      CALL MESAGE (-2,FILE,NAME)
      GO TO 150
  970 IP1 = -7
      GO TO 911
      END

      SUBROUTINE TMTOGO (TOGO)
C
C     TO COMPUTE THE TIME (IN SECONDS) REMAINING
C
      INTEGER TBEGIN, TPROB,TNOW,TOGO
      COMMON /SYSTEM/ XSYS(17),TMBEGN
      COMMON /STIME / TPROB
C
C     GET PRESENT TIME
C
      CALL KLOCK (TNOW)
C
C     COMPUTE TIME TO GO
C
      TBEGIN = TMBEGN
      TOGO = TPROB - (TNOW - TBEGIN)
      RETURN
      END

      SUBROUTINE GOPEN (FILE,BUFFER,OPTION)
C
      INTEGER FILE,OPTION,ERR,OUTREW,OUTNOR
      REAL    BUFFER(1),SUBNAM(2),HEADER(2)
      DATA    SUBNAM / 4H GOP,4HEN  /
      DATA    OUTREW,INPNOR,OUTNOR  / 1,2,3 /
C
      CALL OPEN (*200,FILE,BUFFER,OPTION)
      IF (OPTION.EQ.INPNOR .OR. OPTION.EQ.OUTNOR) GO TO 150
      IF (OPTION.EQ.OUTREW)  GO TO 110
      CALL READ (*201,*202,FILE,HEADER,2,1,ERR)
      GO TO 150
  110 CALL FNAME (FILE,HEADER)
      CALL WRITE (FILE,HEADER,2,1)
  150 RETURN
C
  200 ERR = -1
      GO TO 210
  201 ERR = -2
      GO TO 210
  202 ERR = -3
  210 CALL MESAGE (ERR,FILE,SUBNAM)
C
      RETURN
      END

      SUBROUTINE IFT
C
C     INVERSE FOURIER TRANSFORM MODULE (IFT)
C
C     DMAP CALLING SEQ.
C
C     IFT   UHVF,CASECC,TRL,FOL/UHVT,TOL/C,Y,IFTM
C
      INTEGER SYSBUF,      IZ(1),UHVF,UHVT,CASECC,TRL,TOL,FOL,NAME(2),
     1  MCB(7),FILE,MCB1(7)
      COMMON /SYSTEM/SYSBUF,NOUT
      COMMON /PACKX/IT1,IT2,II,JJ,INCR
      COMMON /UNPAKX/IT3,II1,JJ1,INCR1
      COMMON /CONDAS/ PHI,TWOPI
      COMMON  /ZZZZZZ/ Z(1)
      COMMON /BLANK/ IFTM
      EQUIVALENCE (Z(1),IZ(1))
      DATA UHVF,CASECC,TRL,FOL,UHVT,TOL/101,102,103,104,201,202/
      DATA NAME /4HIFT , 1H  /
C
C     VARIABLE CORE
C
C        CONTENT         LENGTH         POINTER
C        -------         ------         -------
C     FOL                NFREQ          IFREQ
C     TSTEP              NGROUP*3       ITSTP
C     UHVF               NMODES*NFREQ*2 IUHVF
C     CK                 NBIG           ICK
C     SK                 NBIG           ISK
C     UDOT               NMODES*NFREW*2 IUDOT
C     UHVT               NMODES         IUVT
C
C
C
C     PUT FOL INTO CORE
C
      NZ = KORSZ(IZ)
      IBUF1 = NZ-SYSBUF+1
      IBUF2 = IBUF1-SYSBUF
      NZ = NZ-2*SYSBUF
      FILE = FOL
      CALL OPEN(*900,FOL,IZ(IBUF1),0)
      CALL FREAD(FOL ,IZ,-2,0)
      CALL READ(*910,*10,FOL,IZ,NZ,0,NFREQ)
      CALL MESAGE(-8,0,NAME)
   10 CALL CLOSE(FOL ,1)
      IFREQ = 1
      NZ = NZ-NFREQ
      ITSTP=NFREQ+1
C
C     DEFINE BASIC SIZES
C
      MCB(1) = UHVF
      CALL RDTRL(MCB)
      NLOAD = MCB(2)/NFREQ
      NMODES = MCB(3)
      MCB(1) = UHVT
      MCB(2) = 0
      MCB(5) = 1
      MCB(6) = 0
      MCB(7) = 0
      K = NFREQ + 2*(NMODES*NFREQ*2) + NMODES
      IF(K .GT. NZ) CALL  MESAGE(-8,0,NAME)
C
C     DETERMINE IF EQUAL FREQ - CONVERT TO W'S
C
      DELW = Z(IFREQ+1)-Z(IFREQ)
      EPSI = DELW*1.E-6
      J = NFREQ-1
      IEQUAL = 1
      DO 20 I=1,J
      M = IFREQ+I-1
      IF( ABS(Z(M+1)-Z(M)-DELW) .GE. EPSI) IEQUAL = 0
      Z(M) = Z(M)*TWOPI
   20 CONTINUE
      Z(IFREQ+NFREQ-1) = Z(IFREQ+NFREQ-1)*TWOPI
      DELW = DELW*TWOPI
C
C     FIRST FREQUENCY MUST BE MULTIPLE OF DELW
C
      NBIG = ABS(Z(IFREQ)/DELW)+.1
      IF(ABS(FLOAT(NBIG)*DELW-ABS(Z(IFREQ))) .GT. EPSI) IEQUAL = 0
      LLL = NBIG -1
C
C     FIND TSTEP IN TRL
C
      CALL GOPEN(CASECC,IZ(IBUF1),0)
      CALL FREAD(CASECC,0,-37,0)
      CALL FREAD(CASECC,J,1,0)
      CALL CLOSE(CASECC,1)
      FILE = TRL
      CALL OPEN(*900,TRL,IZ(IBUF1),0)
      CALL FREAD(TRL,MCB1,3,1)
      M = MCB1(3)
      CALL SKPREC(TRL,M)
   25 CONTINUE
      CALL FREAD(TRL,M,1,0)
      IF(M .EQ. J) GO TO 30
      CALL FREAD(TRL,0,0,1)
      GO TO 25
C
C     FOUND TSTEP
C
   30 CALL READ(*910,*40,TRL,IZ(ITSTP),NZ,0,NGROUP)
      CALL MESAGE(-8,0,NAME)
   40 NZ = NZ-NGROUP
      IUHVF = ITSTP+NGROUP
      CALL CLOSE(TRL,1)
      NGROUP = NGROUP/3
      IF(NGROUP .NE. 1) IEQUAL = 0
      IF( IEQUAL .EQ. 0 ) GO TO 50
C
C     FORCE WAT TO BE INTEGER MULTIPLE OF TWOPI/N
C
      FBIG = TWOPI/(DELW*Z(ITSTP+1))
      NBIG = FBIG+.9
      Z(ITSTP+1) = TWOPI/(FLOAT(NBIG)*DELW)
   50 CONTINUE
C
C     BUILD / WRITE TOL
C
      FILE = TOL
      CALL OPEN(*900,TOL,IZ(IBUF1),1)
      CALL FNAME(TOL,MCB1)
      CALL WRITE(TOL,MCB1,2,0)
      DELT = Z(ITSTP+1)
      T = 0.0
      N = 0
      M = ITSTP
      DO 60 I=1,NGROUP
      NSTEP = IZ(M)
      IF(I .EQ. 1) NSTEP = NSTEP +1
      M = M+3
      DO 70 J=1,NSTEP
      CALL WRITE(TOL,T,1,0)
      N = N+1
      IF(J .EQ. NSTEP  .AND. I .NE. NGROUP) DELT = Z(M+1)
      T = T+DELT
   70 CONTINUE
   60 CONTINUE
      CALL WRITE(TOL,0,0,1)
      CALL CLOSE(TOL,1)
      MCB1(1) = TOL
      MCB1(2) = NGROUP
      MCB1(3) = N
      MCB1(4) = 0
      MCB1(5) = 0
      MCB1(6) = 0
      MCB1(7) = 0
      CALL WRTTRL(MCB1)
C
C     BUILD TABLE OF CK, SK
C
      ICK = IUHVF + 2*NMODES*NFREQ
      ISK = ICK
      IUDOT = ISK
      IF( IEQUAL .EQ. 0 ) GO TO 100
      ISK = ICK + NBIG
      IUDOT = ISK + NBIG
      M = ICK
      M1 = ISK
      M2 = ISK
      J = IUDOT
      RP = COS(TWOPI/FLOAT(NBIG))
      CP = SIN(TWOPI/FLOAT(NBIG))
      I = M
      N = M1+1
      L = M2
      KK = J
      Z(I) = 1.0
      Z(L) = 0.0
   65 IF(M1-I-2) 61,62,63
   62 CMNR = -1.
      CMNC = 0.
      GO TO 64
   63 CMNR = RP*Z(I) -CP*Z(L)
      CMNC = CP*Z(I) +RP*Z(L)
   64 I = I+1
      L = L+1
      M1 = M1-1
      KK = KK-1
      Z(I) = CMNR
      Z(L) = CMNC
      Z(M1) = CMNR
      Z(KK) = -CMNC
      GO TO 65
   61 CONTINUE
C     GET READY FOR OUTPUTS
C
  100 CALL GOPEN(UHVF,IZ(IBUF1),0)
      CALL GOPEN(UHVT,IZ(IBUF2),1)
      IT1 = 1
      IT2 = 1
      II = 1
      JJ=NMODES
      INCR = 1
      IT3 = 3
      II1 = 1
      JJ1 = NMODES
      INCR1 = 1
      IUVT = IUDOT
      IF(IFTM .EQ. 2) IUVT = IUVT+2*NFREQ*NMODES
      ASSIGN 235 TO IHOP
C
C     BEGIN LOOP ON LOADS
C
      DO 200 I=1,NLOAD
C
C     PUT UHVF INTO CORE
C
      DO 110 J=1,NFREQ
      M = IUHVF+(J-1)*NMODES*2
      CALL UNPACK(*120,UHVF,Z(M))
      GO TO 110
  120 CALL ZEROC(Z(M),2*NMODES)
  110 CONTINUE
      IF(IFTM .NE. 2) GO TO 150
      ASSIGN 236 TO IHOP
C
C     COMPUTE SPLINE FIT FOR U DOT
C
C
C     COMPUTE A'S
C
      IAP = IUVT + NMODES
      M =NFREQ + IAP - 1
      Z(M) = 0.0
      L = NFREQ-2
      IF(L .LE. 0) GO TO 126
      DO 125 J=1,L
      M = IAP + NFREQ -J-1
      N = IFREQ + NFREQ-J-1
      Z(M) = (Z(N) - Z(N-1))/(2.*(Z(N+1)-Z(N-1))-(Z(N+1)-Z(N))*Z(M+1))
  125 CONTINUE
  126 CONTINUE
C
C     COMPUTE U DOT DOT
C
      DO 122 M1=1,NMODES
      M = IUDOT +(NFREQ-1)*NMODES*2 +(M1-1)*2
      Z(M) = 0.0
      Z(M+1) = 0.0
C
C     BEGIN BACKWARD PASS
C
      M2= IUHVF +(NFREQ-1)*NMODES*2 +(M1-1)*2
      IF(L .LE. 0) GO TO 122
      DO 130 J=1,L
      N2 = M
      M = M-NMODES*2
      N = IFREQ + NFREQ -J-1
      M2 = M2-NMODES*2
      KK = IAP + NFREQ-J
      LL = M2+2*NMODES
      RP = Z(N+1) - Z(N)
      CP = Z(N) -Z(N-1)
      N1 = M2-2*NMODES
      Z(M) = (6. *((Z(LL)-Z(M2))/RP-(Z(M2)-Z(N1))/CP)-RP*Z(KK)*Z(N2))
     U   /CP
      Z(M+1) = (6.*((Z(LL+1)-Z(M2+1))/RP-(Z(M2+1)-Z(N1+1))/CP)-RP*Z(KK)*
     1  Z(N2+1))/CP
  130 CONTINUE
  122 CONTINUE
C
C     BEGIN FORWARD PASS
C
      DO 135 M1=1,NMODES
      M = IUDOT +(M1-1)*2
      M2 = IUHVF +(M1-1)*2
      N1 = M2+2*NMODES
      LL = M+2*NMODES
      RP = Z(IFREQ+1) -Z(IFREQ)
      Z(M) =(6.*(Z(N1)-Z(M2))/RP-RP*Z(IAP+1)*Z(LL))/(6.*Z(IFREQ)+(RP)*
     1  (2.-Z(IAP+1)) )
      Z(M+1) = 0.0
      DO 138 J=2,NFREQ
      KK = IAP+J-1
      M2 = M
      M = M+2*NMODES
      Z(M) = Z(KK)*(Z(LL) - Z(M2))
      Z(M+1) = Z(KK)*(Z(LL+1)-Z(M2+1))
      LL = LL + 2*NMODES
  138 CONTINUE
  135 CONTINUE
  150 CONTINUE
      T = 0.0
      N = 0
      M = ITSTP
      DELT = Z(ITSTP+1)
C
C     BEGIN LOOP ON TIMES
C
      DO 160 L=1,NGROUP
      NSTEP = IZ(M)
      IF(L .EQ. 1) NSTEP = NSTEP+1
      M = M+3
      DO 170 J=1,NSTEP
      TT = T
      CALL ZEROC(Z(IUVT),NMODES)
C
C     BEGIN LOOP ON FREQUENCIES
C
      LX = LLL
      DO 180 LL=1,NFREQ
      LX = LX+1
      WN = Z(IFREQ+LL-1)
      IF(LL .EQ. 1) GO TO 191
      WNM1 = Z(IFREQ+LL-2)
  191 IF(LL .EQ. NFREQ) GO TO 192
      WNP1 = Z(IFREQ+LL)
  192 CONTINUE
      IF(IEQUAL .EQ. 0) GO TO 190
      KK = MOD(LX*N,NBIG)
      CK = Z(ICK+KK)
      SK = Z(ISK+KK)
      GO TO 195
  190 CK = COS(WN*TT)
      SK = SIN(WN*TT)
  195 CONTINUE
C
C     COMPUTE CMN, DMN
C
      IF(IFTM .NE. 0) GO TO 220
C
C     IFTM  =0
C
      CMNC = 0.0
      IF(LL .EQ. 1) GO TO 196
      IF(LL .EQ. NFREQ) GO TO 197
      CMNR = (WNP1-WNM1)*.5
      GO TO 230
  196 CONTINUE
      CMNR = WNP1-WN
      IF(WN .EQ. 0.0) CMNR = CMNR*.5
      GO TO 230
  197 CMNR = WN -WNM1
      GO TO 230
C
C     IFTM = 1
C
  220 CONTINUE
      IF(LL .EQ. 1) GO TO 221
      IF(LL.GT. 2 .AND. IEQUAL .NE. 0 .AND. LL .NE. NFREQ) GO TO 223
      R1 = WN-WNM1
      CALL IFTE2(-TT*R1,RP,CP)
      CMNR = R1*.5*RP
      CMNC = R1*.5*CP
      GO TO 222
  221 CMNR = 0.
      CMNC = 0.
  222 CONTINUE
      IF(LL .EQ. NFREQ) GO TO 223
      R2 = WNP1-WN
      CALL IFTE2(TT*R2,RP,CP)
      CMNR = CMNR+R2*.5*RP
      CMNC = CMNC+R2*.5*CP
  223 IF(IFTM .EQ. 2) GO TO 229
      DMNR = 0.0
      DMNC = 0.0
      GO TO 230
  229 CONTINUE
C
C     IFTM = 2
C
      IM2 = IUDOT -2 +(LL-1)*NMODES*2
      IF(LL .EQ. 1) GO TO 224
      IF(LL .GT. 2 .AND.  IEQUAL .NE. 0 .AND. LL .NE. NFREQ) GO TO 230
      CALL IFTG(-TT*R1,RP,CP)
      R1 = -R1*R1*R1/24.
      DMNR = R1*RP
      DMNC = R1*CP
      GO TO 228
  224 CONTINUE
      DMNR = 0.0
      DMNC = 0.0
  228 CONTINUE
      IF(LL .EQ. NFREQ) GO TO 230
      CALL IFTG(TT*R2,RP,CP)
      R2 = -R2*R2*R2/24.
      DMNR = DMNR+R2*RP
      DMNC = DMNC+R2*CP
  230 CONTINUE
      IM1 = IUHVF-2 +(LL-1)*NMODES*2
C
C     BEGIN LOOP ON MODES
C
      DO 240 KK=1,NMODES
      IM = IM1+2*KK
      RP = CMNR*Z(IM)-CMNC*Z(IM+1)
      CP = CMNC*Z(IM)+CMNR* Z(IM+1)
      GO TO IHOP,(235,236)
  236 CONTINUE
      IM = IM2+2*KK
      RP = RP+DMNR*Z(IM)-DMNC*Z(IM+1)
      CP = CP+DMNC*Z(IM)+DMNR*Z(IM+1)
  235 CONTINUE
      Z(IUVT+KK-1) = Z(IUVT+KK-1) + RP*CK-CP*SK
C
C     END LOOP ON MODES
C
  240 CONTINUE
C
C     END LOOP ON FREQUENCIES
C
  180 CONTINUE
      DO 181 KK=1,NMODES
      Z(IUVT+KK-1) = Z(IUVT+KK-1)/PHI
  181 CONTINUE
      CALL PACK(Z(IUVT),UHVT,MCB)
      DO 182 KK =1,2
      CALL BLDPK(1,1,UHVT,0,0)
      CALL BLDPKN(UHVT,0,MCB)
  182 CONTINUE
      IF(J .EQ. NSTEP) DELT = Z(M+1)
      T = T + DELT
      N = N+1
  170 CONTINUE
C
C     END LOOP ON TIME
C
  160 CONTINUE
C
C     END LOOP ON LOADS
C
  200 CONTINUE
      CALL CLOSE(UHVF,1)
      CALL CLOSE(UHVT,1)
      CALL WRTTRL(MCB)
      RETURN
C
C     ERROR MESSAGES
C
  900 N1=-1
  901 CALL MESAGE(N1,FILE,NAME)
      CALL PEXIT
  910 N1=-2
      GO TO 901
      END

      SUBROUTINE TTRIRG( TI, PG )
C
C
C*****
C THIS ROUTINECOMPUTES THE THERMAL LOAD FOR A TRIANGULAR CROSS
C SECTION RING
C*****
C
C
C                        ECPT FOR THE TRIANGULAR RING
C
C
C                                                      TYPE
C ECPT( 1) ELEMENT IDENTIFICATION                        I
C ECPT( 2) SCALAR INDEX NO. FOR GRID POINT A             I
C ECPT( 3) SCALAR INDEX NO. FOR GRID POINT B             I
C ECPT( 4) SCALAR INDEX NO. FOR GRID POINT C             I
C ECPT( 5) MATERIAL ORIENTATION ANGLE(DEGREES)           R
C ECPT( 6) MATERIAL IDENTIFICATION                       I
C ECPT( 7) COOR. SYS. ID. FOR GRID POINT A               I
C ECPT( 8) X-COOR. OF GRID POINT A (IN BASIC COOR.)      R
C ECPT( 9) Y-COOR. OF GRID POINT A (IN BASIC COOR.)      R
C ECPT(10) Z-COOR. OF GRID POINT A (IN BASIC COOR.)      R
C ECPT(11) COOR. SYS. ID. FOR GRID POINT B               I
C ECPT(12) X-COOR. OF GRID POINT B (IN BASIC COOR.)      R
C ECPT(13) Y-COOR. OF GRID POINT B (IN BASIC COOR.)      R
C ECPT(14) Z-COOR. OF GRID POINT B (IN BASIC COOR.)      R
C ECPT(15) COOR. SYS. ID. FOR GRID POINT C               I
C ECPT(16) X-COOR. OF GRID POINT C (IN BASIC COOR.)      R
C ECPT(17) Y-COOR. OF GRID POINT C (IN BASIC COOR.)      R
C ECPT(18) Z-COOR. OF GRID POINT C (IN BASIC COOR.)      R
C ECPT(19) EL. TEMPERATURE FOR MATERIAL PROPERTIES       R
C
C
      DIMENSION          TI(3),    PG(1)
      DIMENSION          IECPT(19)
      DIMENSION
     1                   D(18) ,   GAMBQ(36),     R(3) ,    Z(3)
     2,                  TEO(16),  EE(16),   DELINT(8),  GAMQS(54)
     3,                  DZERO(24),     GAMBL(81),     ALFB(4)
     8,                  IGP(3),  ICS(3) , SP(18)
      DIMENSION          TL(9)
C
      COMMON /CONDAS/ CONSTS(5)
      COMMON   /TRIMEX/
     1                   ECPT(19)
      COMMON   /MATIN/
     1                   MATIDC             ,MATFLG
     2,                  ELTEMP             ,STRESS
     3,                  SINTH              ,COSTH
      COMMON   /MATOUT/
     1                   E(3)               ,ANU(3)
     2,                  RHO                ,G(3)
     3,                  ALF(3)             ,TZERO
C
      EQUIVALENCE ( CONSTS(2) , TWOPI  )
      EQUIVALENCE ( CONSTS(4) , DEGRA  )
      EQUIVALENCE        (IECPT(1) , ECPT(1))
      EQUIVALENCE   (R(1),R1),     (R(2),R2),     (R(3),R3)
     1,             (Z(1),Z1),     (Z(2),Z2),     (Z(3),Z3)
      EQUIVALENCE        (GAMBL( 1),    EE(1))
      EQUIVALENCE        (GAMBL(17),    TEO(1))
      EQUIVALENCE        (GAMBL(33),    DZERO(1))
      EQUIVALENCE        (GAMBL(57),    ALFB(1))
      EQUIVALENCE        (GAMBL(61),    DELINT(1))
      EQUIVALENCE        (GAMBL(37),    SP(1))
      EQUIVALENCE        (GAMBL( 1),    GAMBQ(1))
      EQUIVALENCE        (GAMBL( 1),    GAMQS(1))
C
C ----------------------------------------------------------------------
C
C STORE ECPT PARAMETERS IN LOCAL VARIABLES
C
      IDEL  = IECPT(1)
      IGP(1)= IECPT(2)
      IGP(2)= IECPT(3)
      IGP(3)= IECPT(4)
      MATID = IECPT(6)
      ICS(1)= IECPT(7)
      ICS(2)= IECPT(11)
      ICS(3)= IECPT(15)
      R(1)  = ECPT(8)
      D(1)  = ECPT(9)
      Z(1)  = ECPT(10)
      R(2)  = ECPT(12)
      D(2)  = ECPT(13)
      Z(2)  = ECPT(14)
      R(3)  = ECPT(16)
      D(3)  = ECPT(17)
      Z(3)  = ECPT(18)
      TEMPE = ECPT(19)
      DGAMA = ECPT(5)
C
C
C TEST THE VALIDITY OF THE GRID POINT COORDINATES
C
      DO 200 I = 1,3
      IF (R(I) .LT. 0.0E0) CALL MESAGE (-30, 37, IDEL)
      IF (D(I) .NE. 0.0E0) CALL MESAGE (-30, 37, IDEL)
  200 CONTINUE
C
C
C COMPUTE THE ELEMENT COORDINATES
C
      ZMIN = AMIN1(Z1, Z2, Z3)
      Z1 = Z1 - ZMIN
      Z2 = Z2 - ZMIN
      Z3 = Z3 - ZMIN
C
C CALCULATE THE INTEGRAL VALUES IN ARRAY DELINT WHERE THE ORDER IS
C INDICATED BY THE FOLLOWING TABLE
C
C              DELINT( 1) - (-1,0)
C              DELINT( 2) - (-1,1)
C              DELINT( 3) - (-1,2)
C              DELINT( 4) - ( 0,0)
C              DELINT( 5) - ( 0,1)
C              DELINT( 6) - ( 1,0)
C              DELINT( 7) - ( 0,2)
C              DELINT( 8) - ( 1,2)
C
C
C TEST FOR RELATIVE SMALL AREA OF INTEGRATION
C AND IF AREA IS SMALL THEN APPROXIMATE INTEGRALS
C
      DR = AMAX1 (  ABS(R1-R2) ,  ABS(R2-R3) ,  ABS(R3-R1) )
      RH = AMIN1 ( R1 , R2 , R3 ) / 10.0E0
      DZ = AMAX1 (  ABS(Z1-Z2) ,  ABS(Z2-Z3) ,  ABS(Z3-Z1) )
      ZH = AMIN1 ( Z1 , Z2 , Z3 ) / 10.0E0
      RA = (R1 + R2 + R3) / 3.0E0
      ZA = (Z1 + Z2 + Z3) / 3.0E0
      AREA =(R1*(Z2-Z3) + R2*(Z3-Z1) + R3*(Z1-Z2)) / 2.0E0
      KODE = 0
      IF ( ABS( (R2-R1)/R2 ) .LT. 1.0E-5) KODE = 1
      IF ( DR .LE. RH  .OR.  DZ .LE. ZH ) KODE = -1
C
C
  310 CONTINUE
      I1 = 0
      DO 400 I = 1,3
      IP = I - 2
      DO 350 J = 1,3
      IQ = J - 1
      IF (IP.EQ.1 .AND. IQ.EQ.1) GO TO 350
      I1 = I1 + 1
      IF (KODE) 320,330,340
  320 DELINT(I1) =((RA) ** IP)*((ZA) ** IQ) * AREA
      GO TO 350
  330 DELINT(I1) =    AI (1,3,1,2,1,3,IP,IQ,R,Z)
     1            +   AI (3,2,1,2,3,2,IP,IQ,R,Z)
      GO TO 350
  340 CONTINUE
      DELINT(I1) =    AI (1,3,3,2,1,3,IP,IQ,R,Z)
  350 CONTINUE
  400 CONTINUE
      D(1)      = DELINT(6)
      DELINT(6) = DELINT(7)
      DELINT(7) = D(1)
C
C
C TEST FOR EXCESSIVE ROUND-OFF ERROR IN INTEGRAL CALCULATIONS
C AND IF IT EXIST APPROXIMATE INTEGRALS
C
      IF (KODE .LT. 0) GO TO 500
      DO 450 I = 1,8
      IF (DELINT(I) .LT. 0.0E0) GO TO 475
  450 CONTINUE
      IF (DELINT(8) .LE. DELINT(7)) GO TO 475
      IF (DELINT(3) .GE. DELINT(8)) GO TO 475
      IF (DELINT(3) .GT. DELINT(7)) GO TO 475
      GO TO 500
  475 CONTINUE
      KODE = -1
      GO TO 310
  500 CONTINUE
C
C
C
C LOCATE THE MATERIAL PROPERTIES IN THE MAT1 OR MAT3 TABLE
C
      MATIDC = MATID
      MATFLG = 7
      ELTEMP = TEMPE
      CALL  MAT (IDEL)
C
C
C SET MATERIAL PROPERTIES IN LOCAL VARIABLES
C
      ER = E(1)
      ET = E(2)
      EZ = E(3)
      VRT = ANU(1)
      VTZ = ANU(2)
      VZR = ANU(3)
      GRZ = G(3)
      TZ = TZERO
      VTR = VRT * ET / ER
      VZT = VTZ * EZ / ET
      VRZ = VZR * ER / EZ
      DEL = 1.0E0 - VRT*VTR - VTZ*VZT - VZR*VRZ - VRT*VTZ*VZR
     1       - VRZ*VTR*VZT
C
C
C GENERATE ELASTIC CONSTANTS MATRIX (4X4)
C
      EE(1) = ER * (1.0E0 - VTZ*VZT) / DEL
      EE(2) = ER * (VTR + VZR*VTZ) / DEL
      EE(3) = ER * (VZR + VTR*VZT) / DEL
      EE(4) = 0.0E0
      EE(5) = EE(2)
      EE(6) = ET * (1.0E0 - VRZ*VZR) / DEL
      EE(7) = ET * (VZT + VRT*VZR) / DEL
      EE(8) = 0.0E0
      EE(9) = EE(3)
      EE(10)= EE(7)
      EE(11)= EZ * (1.0E0 - VRT*VTR) / DEL
      EE(12)= 0.0E0
      EE(13)= 0.0E0
      EE(14)= 0.0E0
      EE(15)= 0.0E0
      EE(16)= GRZ
C
C
C FORM TRANSFORMATION MATRIX (4X4) FROM MATERIAL AXIS TO ELEMENT
C GEOMETRIC AXIS
C
      DGAMR = DGAMA * DEGRA
      COSG =  COS(DGAMR)
      SING =  SIN(DGAMR)
      TEO( 1) = COSG ** 2
      TEO( 2) = 0.0E0
      TEO( 3) = SING ** 2
      TEO( 4) = SING * COSG
      TEO( 5) = 0.0E0
      TEO( 6) = 1.0E0
      TEO( 7) = 0.0E0
      TEO( 8) = 0.0E0
      TEO( 9) = TEO(3)
      TEO(10) = 0.0E0
      TEO(11) = TEO(1)
      TEO(12) = -TEO(4)
      TEO(13) = -2.0E0 * TEO(4)
      TEO(14) = 0.0E0
      TEO(15) = -TEO(13)
      TEO(16) = TEO(1) - TEO(3)
C
C
C TRANSFORM THE ELASTIC CONSTANTS MATRIX FROM MATERIAL
C TO ELEMENT GEOMETRIC AXIS
C
      CALL GMMATS (TEO , 4, 4, 1, EE , 4, 4, 0, D )
      CALL GMMATS (D   , 4, 4, 0, TEO, 4, 4, 0, EE)
C
C
C
C FORM THE D-CURL MATRIX
C
      DO 600 I = 1,24
      DZERO(I) = 0.0E0
  600 CONTINUE
      DZERO( 2) = DELINT(6) * TWOPI
      DZERO( 7) = DELINT(4) * TWOPI
      DZERO( 8) = DZERO(2)
      DZERO( 9) = DELINT(5) * TWOPI
      DZERO(18) = DZERO(2)
      DZERO(21) = DZERO(2)
      DZERO(23) = DZERO(2)
C
C
C COMPUTE THE THERMAL STRAIN VECTOR
C
      D(1) = ( TI(1) + TI(2) + TI(3) )  / 3.0E0
      D(1) = D(1) - TZ
      DO 650 I = 1,3
      ALFB(I) = ALF(I) * D(1)
  650 CONTINUE
      ALFB(4) = 0.0E0
C
C
C COMPUTE THE THERMAL LOAD IN FIELD COORDINATES
C
      CALL GMMATS (EE(1), 4, 4, 0, ALFB(1), 4, 1, 0, TL(1) )
      CALL GMMATS (DZERO(1), 4, 6, 1, TL(1), 4, 1, 0, D(1) )
C
C
C FORM THE TRANSFORMATION MATRIX (6X6) FROM FIELD COORDINATES TO GRID
C POINT DEGREES OF FREEDOM
C
      DO 680 I = 1,36
      GAMBQ(I) = 0.0E0
  680 CONTINUE
      GAMBQ( 1) = 1.0E0
      GAMBQ( 2) = R1
      GAMBQ( 3) = Z1
      GAMBQ(10) = 1.0E0
      GAMBQ(11) = R1
      GAMBQ(12) = Z1
      GAMBQ(13) = 1.0E0
      GAMBQ(14) = R2
      GAMBQ(15) = Z2
      GAMBQ(22) = 1.0E0
      GAMBQ(23) = R2
      GAMBQ(24) = Z2
      GAMBQ(25) = 1.0E0
      GAMBQ(26) = R3
      GAMBQ(27) = Z3
      GAMBQ(34) = 1.0E0
      GAMBQ(35) = R3
      GAMBQ(36) = Z3
C
C
C     NO NEED TO COMPUTE DETERMINANT SINCE IT IS NOT USED SUBSEQUENTLY.
      ISING = -1
      CALL INVERS (6, GAMBQ(1),6 , D(10), 0, D(11) , ISING , SP)
C
      IF (ISING .EQ. 2) CALL MESAGE(-30,26,IDEL)
C
C
C
C TRANSFORM THE THERMAL LOAD TO GRID POINT DEGREES OF FREEDOM
C
      CALL GMMATS (GAMBQ(1), 6, 6, 1, D(1), 6, 1, 0, TL(1) )
C
C
C GENERATE THE TRANSFORMATION MATRIX FROM TWO TO THREE DEGREES OF
C FREEDOM PER POINT
C
      DO 700 I = 1,54
      GAMQS( I) = 0.0E0
  700 CONTINUE
      GAMQS( 1) = 1.0E0
      GAMQS(12) = 1.0E0
      GAMQS(22) = 1.0E0
      GAMQS(33) = 1.0E0
      GAMQS(43) = 1.0E0
      GAMQS(54) = 1.0E0
C
C
C TRANSFORM THE THERMAL LOAD FROM TWO TO THREE DEGREES OF FREEDOM
C
      CALL GMMATS (GAMQS(1), 6, 9, 1, TL(1), 6, 1, 0, D(10) )
C
C
C LOCATE THE TRANSFORMATION MATRICES FOR THE THREE GRID POINTS
C
      DO 750 I = 1,81
      GAMBL(I) = 0.0E0
  750 CONTINUE
      DO 800 I = 1,3
      CALL GBTRAN(ICS(I),ECPT(4*I+7),D(1))
      K = 30* (I-1) + 1
      DO 800 J = 1,3
      KK = K + 9 * (J-1)
      JJ = 3 * (J-1) + 1
      GAMBL(KK  ) = D(JJ  )
      GAMBL(KK+1) = D(JJ+1)
      GAMBL(KK+2) = D(JJ+2)
  800 CONTINUE
C
C
C TRANSFORM THE THERMAL LOAD FROM BASIC TO LOCAL COORDINATES
C
      CALL GMMATS (GAMBL(1), 9, 9, 1, D(10),9, 1, 0, TL(1) )
C
C
C ADD THE ELEMENT THERMAL LOAD TO THE STRUCTURE THERMAL LOAD
C
      K = 0
      DO 900 I = 1,3
      L = IGP(I) - 1
      DO 900 J = 1,3
      K = K + 1
      L = L + 1
      PG(L) = PG(L) + TL(K)
  900 CONTINUE
C
C
C
      RETURN
      END

      SUBROUTINE SUREAD (IA,ND,NOUT,ITEST)
C
C     READS DATA FROM THE SOF INTO THE ARRAY IA.  ND IS AN INPUT
C     PARAMETER INDICATING THE NUMBER OF WORDS DESIRED.  ND=-1 MEANS
C     READ UNTIL END OF GROUP. NOUT IS AN OUTPUT PARAMETER INDICATING
C     THE NUMBER OF WORD THAT HAVE BEEN READ.  ITEST IS AN OUTPUT
C     PARAMETER WHERE ITEST=3 MEANS END OF ITEM ENCOUNTERED, ITEST=2
C     MEANS END OF GROUP ENCOUNTERED, AND ITEST=1 OTHERWISE.
C
      EXTERNAL        ANDF,RSHIFT
      INTEGER         ANDF,RSHIFT,BUF,BLKSIZ,DIRSIZ,IA(1),NMSBR(2)
      COMMON /MACHIN/ MACH,IHALF,JHALF
      COMMON /ZZZZZZ/ BUF(1)
      COMMON /SOF   / DITDUM(6),IO,IOPBN,IOLBN,IOMODE,IOPTR,IOSIND,
     1                IOITCD,IOBLK
      COMMON /SYS   / BLKSIZ,DIRSIZ
      DATA    IDLE  , IRD / 0,1    /
      DATA    IEOG  , IEOI/ 4H$EOG ,4H$EOI       /
      DATA    INDSBR/ 19  /, NMSBR /4HSURE,4HAD  /
C
      CALL CHKOPN (NMSBR(1))
      ICOUNT = 0
      IF (IOMODE .EQ. IRD) GO TO 20
      ITEST = 4
      NOUT  = 0
      RETURN
C
   10 ICOUNT = ICOUNT + 1
      IA(ICOUNT) = BUF(IOPTR)
      IOPTR = IOPTR + 1
      IF (ICOUNT .EQ. ND) GO TO 35
   20 IF (IOPTR .GT. BLKSIZ+IO) GO TO 80
C
C     READ SOF INTO ARRAY IA, BUT WATCH FOR END OF GROUP AND END OF ITEM
C
   30 IF (BUF(IOPTR) .EQ. IEOI) GO TO 50
      IF (BUF(IOPTR).EQ.IEOG .AND. ND.NE.-2) GO TO 40
      GO TO 10
C
C     READ THE REQUIRED NUMBER OF WORDS.
C
   35 ITEST = 1
      GO TO 70
C
C    REACHED END OF GROUP.
C
   40 ITEST = 2
      GO TO 60
C
C    REACHED END OF ITEM.
C
   50 ITEST  = 3
      IOMODE = IDLE
   60 IOPTR  = IOPTR + 1
   70 NOUT   = ICOUNT
      RETURN
C
C     REACHED END OF BLOCK.  REPLACE THE BLOCK CURRENTLY IN CORE BY ITS
C     LINK BLOCK.
C
   80 CALL FNXT (IOPBN,INXT)
      IF (MOD(IOPBN,2) .EQ. 1) GO TO 90
      NEXT = ANDF(RSHIFT(BUF(INXT),IHALF),JHALF)
      GO TO 100
   90 NEXT = ANDF(BUF(INXT),JHALF)
  100 IF (NEXT .EQ. 0) GO TO 510
      IOPBN = NEXT
      IOLBN = IOLBN + 1
      CALL SOFIO (IRD,IOPBN,BUF(IO-2))
      IOPTR = IO + 1
      GO TO 30
C
C     ERROR MESSAGES.
C
  510 CALL ERRMKN (INDSBR,9)
      RETURN
      END

      SUBROUTINE DSIODD
      INCLUDE 'GINOX.COM'
      INCLUDE 'DSIOF.COM'
      LGINOX = 5*NUMFCB + NUMSOF + 2
      LHALF  = 16
      LENDSP = 0
      LENWPB = 0
      MASKH1 = 'FFFF0000'X
      MASKH2 = '0000FFFF'X
      MASKE1 = 'FF000000'X
      MASKE2 = '00FF0000'X
      MASKE3 = '0000FF00'X
      MASKE4 = '000000FF'X
      MCBMAS = '40000000'X
      MAXDSN = NUMFCB
      MASKQ1 = MASKE1
      MASKQ2 = MASKE2
      MASKQ3 = MASKE3
      MASKQ4 = MASKE4
      MULQ1  = 2**24
      MULQ2  = 2**16
      MULQ3  = 2**8
      IDSX   = '00EE0000'X
      IDSP   = '000E0000'X
      IDSC   = '000C0000'X
      IDSRH  = '11000000'X
      IDSRT  = '77000000'X
      IDSSB  = '22000000'X
      IDSSE  = '7F000000'X
      IDSCH  = '3B000000'X
      IDSCT  = '3F000000'X
      IDSSH  = '4B000000'X
      IDSST  = '4F000000'X
      IDSSD  = 'DD000000'X
      IDSEB  = 'EB000000'X
      IDSEF  = 'EF000000'X
      NWRDEL( 1 ) = 1
      NWRDEL( 2 ) = 2
      NWRDEL( 3 ) = 2
      NWRDEL( 4 ) = 4
      RETURN
      END

      SUBROUTINE TIMEEQ (B,BBAR,C,CBAR,R,IENTRY,NCOL,TIM)
C
C     TIMEEQ SOLVES THE TIME AND CORE FUNCTIONS FOR DECOMP AND CDCOMP
C
      INTEGER         SYSBUF
      REAL            MB(1),MC(1),K1,K2,K3,K4,K5
      COMMON /NTIME / LNTIME, TCONS(15)
     1       /SYSTEM/ KSYSTM(65)
C
      EQUIVALENCE     (KSYSTM( 1),SYSBUF),(KSYSTM(40),NBPW),
     1                (KSYSTM(55),IPREC ),(TCONS (1) ,AAIO),
     2                (TCONS ( 2),AAPAK ),(TCONS (8),MB(1)),
     3                (TCONS (12),MC(1) )
C
C
      IRET  = 0
      IENTR = IENTRY
    1 AMB   = MB(IPREC)
      AMC   = MC(IPREC)
      IF (NBPW .LT. 60) GO TO 2
      AMB   = 3.0*AMB
      AMC   = 3.0*AMC
    2 AIO   = AAIO
      APAK  = AAPAK
      IF (IENTR .EQ. 1) GO TO 10
      AMB   = 5.*AMB
      AMC   = 5.*AMC
      AIO   = AIO+AIO
      APAK  = 1.1*APAK
   10 IF (IRET .EQ. 1) GO TO 20
      TIM = FLOAT(NCOL)*(AMB*BBAR*R+AMC*(BBAR*C+BBAR*CBAR+B*CBAR+
     1      2.0*C*CBAR)+AIO*BBAR*(B+BBAR-R-1.0))*1.E-06
      RETURN
C
C
      ENTRY TFIN (AB,ABBAR,AC,ACBAR,AR,JENTRY,ANCOL,TIMEX)
C     ====================================================
C
      IRET  = 1
      IENTR = JENTRY
      GO TO 1
   20 TIMEX = 0.
      K1    = ANCOL - AB - ABBAR - ABBAR
      IF (K1 .LE. 0.) GO TO 30
      TIMEX = K1*(AMB*ABBAR*AR+AIO*ABBAR*(AB+ABBAR-AR)+APAK*(AB+ABBAR*
     1        2.))
   30 K2  = AB + ABBAR
      K3  = K2
      IF (ANCOL .GE. AB+ABBAR+ABBAR) GO TO 35
      K2  = ANCOL - ABBAR
      K3  = AB + ABBAR
      IF (ANCOL .LT. AB+ABBAR) K3 = ANCOL
   35 TIMEX = TIMEX+.5*K2*(ABBAR*K2*AMB+(K3-AR)*(AIO-AMB)*ABBAR+
     1        2.*APAK*ABBAR+APAK*K2)
      IF (ANCOL .LT. AB+ABBAR+ABBAR) GO TO 40
      K4 = AB + ABBAR - AR
      K5 = AB + 1.5*ABBAR
      IF (AB .GT. AR) K4 = ABBAR
      GO TO 50
   40 K4 = ANCOL - AR
      K5 = ANCOL
      IF (ANCOL-AR .GT. ABBAR) K4 = ABBAR
   50 TIMEX = TIMEX+ABBAR**3/3.*AMB+K4**3*.5*AIO+APAK*ABBAR*K5
      TIMEX = (TIMEX+(ANCOL-ABBAR)*(AMC*(ABBAR*AC+AB*ACBAR+ABBAR*ACBAR+
     1        AC*ACBAR)+APAK*(AC+ACBAR)))*1.E-06
      RETURN
C
C
      ENTRY RCORE (IB,IBBAR,IC,ICBAR,INCOL,KENTRY,NX,IR)
C     ==================================================
C     ENTRY FOR THE CORE FUNCTION
C
      IR = (NX-((IB+IBBAR+1) +2*KENTRY*MIN0(INCOL,IB+IBBAR+IBBAR)+
     1     2*KENTRY*IC*(IBBAR+2)+2*ICBAR*KENTRY*(MIN0(IB+IBBAR,INCOL)+1)
     2     +2*KENTRY*IC*ICBAR +IC+ICBAR*KENTRY+ICBAR)-6*SYSBUF)/
     3     (2*KENTRY*IBBAR)
      RETURN
      END

      SUBROUTINE SHLSTS (ELID,PID,TLAM,EPSUMI,EPSCMI)
C
C     TO PERFORM LAYER STRAIN, STRESS AND FORCE CALCULATIONS FOR THE
C     2-D SHELL ELEMENTS.
C     ONLY THE ELEMENT CENTER VALUES ARE CONSIDERED
C
C     INPUT :
C           ELID   - ELEMENT ID
C           PID    - COMPOSITE PROPERTY ID
C           TLAM   - AVERAGE ELEMENT THICKNESS
C           EPSUMI - UNCORRECTED STRAINS IN MATERIAL COORD. SYSTEM
C           EPSCMI - CORRECTED STRAINS IN MATERIAL COORD. SYSTEM
C          /CONDAS/- TRIGONOMETRIC CONSTATNTS
C          /OUTREQ/- OUTPUT REQUEST LOGICAL FLAGS
C
C     OUTPUT:
C           OUTPUT DATA ARE WRITTEN DIRECTLY TO EACH APPROPRIATE OUTPUT
C           FILE - OEF1L, OES1L/OES1AL
C
C
C     LAYER STRESS/STRAIN OUTPUT BLOCK FOR EACH CTRIA3 ELEMENT
C
C         1.    10*ELEMENT ID + DEVICE CODE
C         2.    NLAYER - NUMBER OF OUTPUT LAYERS
C         3.    TYPE OF FAILURE THEORY SELECTED
C
C         4.    LAYER ID
C        5-7.   LAYER STRESSES/STRAINS
C         8.    LAYER FAILURE INDEX, FI
C         9.    IFLAG1 = 1 IF FI.GE.0.999
C                      = 0 OTHERWISE
C       10-11.  INTERLAMINAR SHEAR STRESSES/STRAINS
C        12.    SHEAR BONDING INDEX, FB
C        13.    IFLAG2 = 1 IF FB.GE.0.999
C                      = 0 OTHERWISE
C         :
C         :     REPEAT 4-13 NLAYER TIMES FOR EACH LAYER
C
C       LAST-1. MAXIMUM FAILURE INDEX OF LAMINATE, FIMAX
C        LAST.  IFLAG3 = 1 IF FIMAX.GE.0.999
C                      = 0 OTHERWISE
C
C
C     FORCE OUTPUT BLOCK
C
C         1.    10*ELEMENT ID + DEVICE CODE
C        2-9.   FORCE RESULTANTS:
C                 MEMBRANE        BENDING     TRANSVERSE
C               -- FORCES --    - MOMENTS -  SHEAR FROCES
C               FX,  FY, FXY,   MX, MY, MXY,    VX, VY
C
C
      LOGICAL         STRESS,STRAIN,FORCE,STSREQ,STNREQ,FORREQ,STRCUR,
     1                GRIDS,VONMS,LAYER,GRIDSS,VONMSS,LAYERS,
     2                TRNFLX,NONMEM,SYMLAY,PCMP,PCMP1,PCMP2
      INTEGER         ELID,ELEMID,OES1L,OES1AL,OEF1L,PCOMP,PCOMP1,
     1                PCOMP2,PID,PIDLOC,SYM,SYMMEM,SOUTI,HALF,FTHR,
     2                STRINF,SDEST,EDEST,FDEST,IZ(1)
      REAL            STRSLR(3),TRNSRR(2),EPSLR(3),ERNSRR(2),FINDXR,
     1                FBONDR,FIMAXR,Z
      REAL            TLAM,EPSUMI(6,1),EPSCMI(6,1),PI,TWOPI,RADDEG,
     1                DEGRAD,GG(9),ULTSTN(6),TRANS(9),STRESL(3),
     2                EPSLCM(3),EPSLUM(3),EPSLCF(3),EPSLUF(3),TRNAR(2),
     3                ERNAR(2),TRNSHR(2),ERNSHR(2),FINDEX,FPMAX,FBOND,
     4                FBMAX,FIMAX,FB(2),SB,V(2),EI(2),ZBAR(2),
     5                ZK,ZK1,ZSUBI,ZREF,THETA,C,C2,S,S2,TI
      COMMON /CONDAS/ PI,TWOPI,RADDEG,DEGRAD
      COMMON /OUTREQ/ STSREQ,STNREQ,FORREQ,STRCUR,GRIDS,VONMS,LAYER
     1,               GRIDSS,VONMSS,LAYERS
      COMMON /SDR2DE/ KSDRDE(200)
      COMMON /SDR2X2/ DUM1(30),OES1L,OEF1L
      COMMON /SDR2X7/ DUM2(100),STRES(69),DUM3(31),FORSUL(37),
     1                DUM4(163),STRIN(69)
      COMMON /SDR2C1/ IPCMP,NPCMP,IPCMP1,NPCMP1,IPCMP2,NPCMP2
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE     (Z(1) ,IZ(1)     ),(SDEST,KSDRDE( 26)),
     1                (FDEST,KSDRDE(33)),(EDEST,KSDRDE(148)),
     2                (OES1L,OES1AL    )
      DATA    SYMMEM, MEM, SYM, PCOMP, PCOMP1, PCOMP2, STRINF /
     1        3     , 2  , 1  , 0    , 1     , 2     , 5      /
C
C     INITIALIZE
C
      ZREF  =-TLAM/2.0
      FINDEX= 0.0
      FBOND = 0.0
      FPMAX = 0.0
      FBMAX = 0.0
      FIMAX = 0.0
C
      DO 10 LL = 1,2
      ERNAR(LL) = 0.0
      TRNAR(LL) = 0.0
      ERNSHR(LL)= 0.0
      TRNSHR(LL)= 0.0
   10 CONTINUE
C
      FORCE  = FORREQ .AND. LAYER
      STRESS = STSREQ .AND. LAYER
      STRAIN = STNREQ .AND. LAYERS
C
      ITYPE  = -1
      LPCOMP = IPCMP + NPCMP + NPCMP1 + NPCMP2
      PCMP   = NPCMP  .GT. 0
      PCMP1  = NPCMP1 .GT. 0
      PCMP2  = NPCMP2 .GT. 0
C
      IF (.NOT.FORCE) GO TO 20
C
C     WRITE FORCE RESULTANTS TO OEF1L IF REQUESTED
C
      ELEMID = 10*ELID + FDEST
      CALL WRITE (OEF1L,ELEMID,1,0)
      CALL WRITE (OEF1L,FORSUL(3),8,0)
C
C     FORCE REQUEST HAS BEEN PROCESSED. IF NO MORE REQUESTS WE ARE DONE.
C     IF NOT, PREPARE FOR OTHER REQUESTS.
C     ISSUE ERROR IF PCOMPI DATA HAS NOT BEEN READ INTO CORE.
C
   20 IF (.NOT.(STRESS .OR. STRAIN)) GO TO 650
C
C     START WRITING STRESS/STRAIN OUTPUT TO OES1L/OES1AL
C     (NOTE - OES1L AND OES1AL ARE SAME FILE IN COSMIC/NASTRAN)
C
C     1.  10*ELEMENT ID + DEVICE CODE
C
      IF (LPCOMP .EQ. IPCMP) GO TO 600
      ELEMID = 10*ELID + SDEST
      IF (STRAIN) ELEMID = 10*ELID + EDEST
      CALL WRITE (OES1L,ELEMID,1,0)
C
C     DETERMINE  IF INTERLAMINAR SHEAR STRESS CALCULATIONS ARE REQUIRED
C     BY CHECKING THE TRANSVERSE SHEAR STRESS RESULTANTS QX AND QY
C
      V(1) = FORSUL( 9)
      V(2) = FORSUL(10)
      TRNFLX = V(1).NE.0.0 .OR. V(2).NE.0.0
C
C     LOCATE PID BY PERFORMING A SEQUENTIAL SEARCH OF THE PCOMPI DATA
C     BLOCK WHICH IS IN CORE.
C
C     SEARCH FOR PID IN PCOMP DATA
C
      IF (.NOT.PCMP) GO TO 40
      IP = IPCMP
      IF (IZ(IP) .EQ. PID) GO TO 110
      IPC11 = IPCMP1 - 1
      DO 30 IP = IPCMP,IPC11
      IF (IZ(IP).EQ.-1 .AND. IP.LT.IPC11) IF (IZ(IP+1)-PID) 30,100,30
   30 CONTINUE
C
C     SEARCH FOR PID IN PCOMP1 DATA
C
   40 IF (.NOT.PCMP1) GO TO 60
      IP = IPCMP1
      IF (IZ(IP) .EQ. PID) GO TO 140
      IPC21 = IPCMP2 - 1
      DO 50 IP = IPCMP1,IPC21
      IF (IZ(IP).EQ.-1 .AND. IP.LT.IPC21) IF (IZ(IP+1)-PID) 50,130,50
   50 CONTINUE
C
C     SEARCH FOR PID IN PCOMP2 DATA
C
   60 IF (.NOT.PCMP2) GO TO 600
      IP = IPCMP2
      IF (IZ(IP) .EQ. PID) GO TO 160
      LPC11 = LPCOMP - 1
      DO 70 IP = IPCMP2,LPC11
      IF (IZ(IP).EQ.-1 .AND. IP.LT.LPC11) IF (IZ(IP+1)-PID) 70,150,70
   70 CONTINUE
C
C     PID WAS NOT LOCATED; ISSUE ERROR
C
      GO TO 600
C
C     PID WAS LOCATED; DETERMINE TYPE
C
C     FOR PCOMP BULK DATA DETERMINE HOW MANY LAYERS HAVE THE STRESS/
C     STRAIN OUTPUT REQUEST (SOUTI).
C     FOR PCOMP1 OR PCOMP2 BULK DATA ENTRIES LAYER STRESSES/STRAINS ARE
C     OUTPUT FOR ALL LAYERS.
C
  100 IP = IP + 1
  110 ITYPE  = PCOMP
      PIDLOC = IP
      NLAY   = IZ(PIDLOC+1)
      NLAYER = NLAY
      NSTRQT = 0
      DO 120 K = 1,NLAY
      IF (IZ(PIDLOC+8+4*K) .EQ. 1) NSTRQT = NSTRQT + 1
  120 CONTINUE
      NLAYER = NSTRQT
      IPOINT = PIDLOC + 8 + 4*NLAY
      ICONTR = IPOINT +    27*NLAY
      GO TO 200
C
  130 IP = IP + 1
  140 ITYPE  = PCOMP1
      PIDLOC = IP
      NLAY   = IZ(PIDLOC+1)
      NLAYER = NLAY
      IPOINT = PIDLOC +  8 +   NLAY
      ICONTR = IPOINT + 25 + 2*NLAY
      GO TO 200
C
  150 IP = IP + 1
  160 ITYPE  = PCOMP2
      PIDLOC = IP
      NLAY   = IZ(PIDLOC+1)
      NLAYER = NLAY
      IPOINT = PIDLOC +  8 + 2*NLAY
      ICONTR = IPOINT + 25 + 2*NLAY
C
C     DETERMINE GENERAL COMPOSITE PROPERTY VALUES
C
C     LAMOPT - LAMINATION GENERATION OPTION
C            = ALL    = 0 (ALL PLYS SPECIFIED, DEFAULT)
C            = SYM    = 1 (SYMMETRIC)
C            = MEM    = 2 (MEMBRANE ONLY)
C            = SYMMEM = 3 (SYMMETRIC-MEMBRANE)
C
C     FTHR   - FAILURE THEORY
C            = 1    HILL
C            = 2    HOFFMAN
C            = 3    TSAI-WU
C            = 4    MAX-STRESS
C            = 5    MAX-STRAIN
C
C     SB     - SHEAR BONDING STRENGTH
C
  200 LAMOPT = IZ(PIDLOC+8)
      FTHR   = IZ(PIDLOC+5)
      SB     =  Z(PIDLOC+4)
      EI(1)  =  Z(ICONTR+1)
      EI(2)  =  Z(ICONTR+2)
      ZBAR(1)=  Z(ICONTR+3)
      ZBAR(2)=  Z(ICONTR+4)
C
      NONMEM = LAMOPT.NE.MEM .AND. LAMOPT.NE.SYMMEM
      SYMLAY = LAMOPT.EQ.SYM .OR.  LAMOPT.EQ.SYMMEM
      IF (SYMLAY) NLAYER = 2*NLAYER
      IF (NLAYER .EQ. 0) GO TO 650
C
C     CONTINUE TO WRITE LAYER-INDEPENDENT DATA TO OES1L/OES1AL
C
C     2.  NLAYER - NUMBER OF LAYERS FOR LAMINATE
C     3.  TYPE OF FAILURE THEORY SELECTED
C
      CALL WRITE (OES1L,NLAYER,1,0)
      CALL WRITE (OES1L,FTHR,1,0)
C
C     START THE LOOP OVER LAYERS
C
      ZK = ZREF
      HALF = 1
      IF (SYMLAY) HALF = 2
C
      DO 450 IHALF = 1,HALF
      DO 440 KK = 1,NLAY
      K = KK
      IF (IHALF .EQ. 2) K = NLAY + 1 - KK
C
C     OBTAIN LAYER K INFORMATION
C     - THE BOUNDARIES
C     - THE DISTANCE FROM THE REFERENCE SURFACE TO THE MIDDLE OF LAYER
C     - LAYER THICKNESS
C     - STRESS OUTPUT REQUEST (SOUTI) FOR PCOMP BULK DATA
C       (NOT SUPPORTED FOR PCOMP1 OR PCOMP2 BULK DATA)
C
      ZK1 = ZK
      IF (ITYPE .EQ. PCOMP ) ZK = ZK1 + Z(PIDLOC + 6 + 4*K)
      IF (ITYPE .EQ. PCOMP1) ZK = ZK1 + Z(PIDLOC + 7      )
      IF (ITYPE .EQ. PCOMP2) ZK = ZK1 + Z(PIDLOC + 7 + 2*K)
      ZSUBI = (ZK+ZK1)/2.0
      TI = ZK - ZK1
      SOUTI = 1
      IF (ITYPE .EQ. PCOMP) SOUTI = IZ(PIDLOC+8+4*K)
C
C     LAYER MATERIAL PROPERTIES
C
      DO 210 IGI = 1,9
      GG(IGI) = Z(IPOINT+IGI)
  210 CONTINUE
C
C     LAYER ULTIMATE STRENGTHS
C
      DO 220 IR = 1,6
      ULTSTN(IR) = Z(IPOINT+16+IR)
  220 CONTINUE
C
C     LAYER ORIENTATION
C
      IF (ITYPE .EQ. PCOMP ) THETA = Z(PIDLOC + 7 + 4*K)
      IF (ITYPE .EQ. PCOMP1) THETA = Z(PIDLOC + 8 +   K)
      IF (ITYPE .EQ. PCOMP2) THETA = Z(PIDLOC + 8 + 2*K)
      THETA = THETA*DEGRAD
C
C     BUILD THE STRAIN TENSOR TRANSFORMATION TO TRANSFORM
C     LAYER STRAINS FROM MATERIAL TO FIBER DIRECTION.
C
      C   = COS(THETA)
      C2  = C*C
      S   = SIN(THETA)
      S2  = S*S
C
      TRANS(1)  = C2
      TRANS(2)  = S2
      TRANS(3)  = C*S
      TRANS(4)  = S2
      TRANS(5)  = C2
      TRANS(6)  =-C*S
      TRANS(7)  =-2.0*C*S
      TRANS(8)  = 2.0*C*S
      TRANS(9)  = C2 - S2
C
C     CALCULATE THE CORRECTED AND UNCORRECTED STRAIN VECTORS AT ZSUBI
C     IN THE MATERIAL COORD. SYSTEM, THENTRANSFORM STRAINS FROM MATERIAL
C     TO FIBER COORD. SYSTEM AND CALCULATE THE LAYER STRESS VECTOR IN
C     THE FIBER COORD. SYSTEM
C
      DO 300 IR = 1,3
      EPSLCM(IR) = EPSCMI(IR,1) - ZSUBI*EPSCMI(IR+3,1)
      EPSLUM(IR) = EPSUMI(IR,1) - ZSUBI*EPSUMI(IR+3,1)
  300 CONTINUE
C
      CALL GMMATS (TRANS(1),3,3,0, EPSLCM(1),3,1,0, EPSLCF(1))
      CALL GMMATS (TRANS(1),3,3,0, EPSLUM(1),3,1,0, EPSLUF(1))
      CALL GMMATS (GG(1),3,3,0,    EPSLCF,3,1,0,    STRESL(1))
C
      IF (FTHR .LE. 0) GO TO 310
C
C     COMPUTE FAILURE INDEX FOR THIS LAYER AND THE MAXIMUM FAILURE INDEX
C
      IF (FTHR .EQ. STRINF) CALL FAILRS (FTHR,ULTSTN,EPSLUF,FINDEX)
      IF (FTHR .NE. STRINF) CALL FAILRS (FTHR,ULTSTN,STRESL,FINDEX)
      IF (ABS(FINDEX) .GE. ABS(FPMAX)) FPMAX = FINDEX
C
  310 IF (.NOT.TRNFLX .OR. .NOT.NONMEM) GO TO 350
C
C     CALCULATE INTERLAMINAR SHEAR STRESSES AND STRAINS
C
      IF (ITYPE .EQ. PCOMP ) ICONTR = IPOINT + 25
      IF (ITYPE .EQ. PCOMP1) ICONTR = IPOINT + 23 + 2*K
      IF (ITYPE .EQ. PCOMP2) ICONTR = IPOINT + 23 + 2*K
      DO 320 IR = 1,2
      ERNAR(IR) = ERNAR(IR) + TI*(ZBAR(IR)-ZSUBI)
      TRNAR(IR) = TRNAR(IR) + TI*(ZBAR(IR)-ZSUBI)*Z(ICONTR+IR)
  320 CONTINUE
C
      DO 330 IR = 1,2
      TRNSHR(IR) = V(IR)*TRNAR(IR)/EI(IR)
      ERNSHR(IR) = V(IR)*ERNAR(IR)/EI(IR)
  330 CONTINUE
C
      IF (SB .LE. 0.0) GO TO 350
C
C     CALCULATE SHEAR BONDING FAILURE INDEX, FB, AND THE MAX SHEAR
C     BONDING INDEX, FBMAX.
C
      DO 340 IR = 1,2
      FB(IR) = ABS(TRNSHR(IR))/SB
  340 CONTINUE
C
      FBOND = FB(1)
      IF (FB(2) .GT. FB(1)) FBOND = FB(2)
      IF (FBOND .GE. FBMAX) FBMAX = FBOND
C
  350 IF (SOUTI .EQ. 0) GO TO 430
C
C     CONTINUE TO WRITE LAYER-DEPENDENT DATA TO OES1L AND OES1AL
C
C       4.   LAYER ID, LYRID
C     5,6,7. LAYER STRESSES/STRAINS
C       8.   LAYER FAILURE INDEX, FINDXR
C       9.   IFLAG1 (=1 IF FINDXR.GE.0.999, DEFAULT=0)
C     10,11. INTERLAMINAR SHEAR STRESSES/STRAINS
C      12.   SHEAR BONDING FAILURE INDEX, FBONDR
C      13.   IFLAG2 (=1 IF FBONDR.GE.0.999, DEFAULT=0)
C       :    REPEAT 4-13 FOR NUMBER OF LAYER WITH LAYER STRESS/STRAIN
C       :    REQUEST
C
C
      LYRID = K
      IF (IHALF .EQ. 2) LYRID = NLAY + KK
C
      FINDXR = FINDEX
      IFLAG1 = 0
      IF (ABS(FINDEX) .GE. 0.999) IFLAG1 = 1
C
      FBONDR = FBOND
      IFLAG2 = 0
      IF (ABS(FBOND ) .GE. 0.999) IFLAG2 = 1
C
      IF (.NOT.STRESS) GO TO 410
      DO 400 ISTR = 1,3
      STRSLR(ISTR) = STRESL(ISTR)
  400 CONTINUE
      TRNSRR(1) = TRNSHR(1)
      TRNSRR(2) = TRNSHR(2)
      CALL WRITE (OES1L,LYRID,1,0)
      CALL WRITE (OES1L,STRSLR(1),3,0)
      CALL WRITE (OES1L,FINDXR,1,0)
      CALL WRITE (OES1L,IFLAG1,1,0)
      CALL WRITE (OES1L,TRNSRR(1),2,0)
      CALL WRITE (OES1L,FBONDR,1,0)
      CALL WRITE (OES1L,IFLAG2,1,0)
C
  410 IF (.NOT.STRAIN) GO TO 430
      DO 420 ISTR = 1,3
      EPSLR(ISTR)  = EPSLUF(ISTR)
  420 CONTINUE
      ERNSRR(1) = ERNSHR(1)
      ERNSRR(2) = ERNSHR(2)
      CALL WRITE (OES1AL,LYRID,1,0)
      CALL WRITE (OES1AL,EPSLR(1),3,0)
      CALL WRITE (OES1AL,FINDXR,1,0)
      CALL WRITE (OES1AL,IFLAG1,1,0)
      CALL WRITE (OES1AL,ERNSRR(1),2,0)
      CALL WRITE (OES1AL,FBONDR,1,0)
      CALL WRITE (OES1AL,IFLAG2,1,0)
C
C     UPDATE IPOINT FOR PCOMP BULK DATA ENTRY
C
  430 IF (ITYPE .NE. PCOMP) GO TO 440
      IF (IHALF.EQ.1 .AND. K.NE.NLAY) IPOINT = IPOINT + 27
      IF (IHALF .EQ. 2) IPOINT = IPOINT - 27
  440 CONTINUE
  450 CONTINUE
C
C     END OF LOOP OVER LAYERS
C
      IF (FTHR .LE. 0) GO TO 500
C
C     DETERMINE THE MAXIMUM FAILURE INDEX
C
      FIMAX = FPMAX
      IF (FBMAX .GT. ABS(FPMAX)) FIMAX = FBMAX
C
C     CONTINUE TO OUTPUT THE MAXIMUM FAILURE INDEX TO OES1L/OES1AL
C
C     LAST-1.  MAXIMUM FAILURE INDEX OF LIMIATE, FIMAXR
C      LAST.   IFLAG3 (=1 IF FIMAXR.GE.0.999, DEFAULT=0)
C
  500 FIMAXR = FIMAX
      IFLAG3 = 0
      IF (ABS(FIMAX) .GE. 0.999) IFLAG3 = 1
C
      CALL WRITE (OES1L,FIMAXR,1,0)
      CALL WRITE (OES1L,IFLAG3,1,0)
      GO TO 650
C
C
C     ERROR MESSAGE
C
C     NO PCOMP, PCOMP1, PCOMP2 FOUND
C
  600 CALL MESAGE (-30,223,ELID)
C
  650 RETURN
      END

      SUBROUTINE APD2 (IOPT,CAO1,CAO2,NCORE,ID)
C
      INTEGER         PA2S,PA2E,CA2S,CA2E,IZ(1),NAM(2),IAX(1),CAO1(1),
     1                CAO2(1),PC,PPC,BET,TYPE(3),
     2                CP,ACSID,EID,EIDB,CID(5),CIDBX,AUSET(6,2),SILB,
     3                UK,USA,NECTA(6),KEY(5),SILDX(2),ACSIX(4),BACK,
     4                SCR1,SCR2,SCR3,SCR4,SCR5,ECTA,BGPA,GPLA,USETA,
     5                SILA,CSTMA,ACPT,BUF10,BUF11,BUF12,ACSIB,PID
      REAL            RB1(3),ACPL(3,3),VX1(3),VX2(3)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /BLANK / NK,NJ,LUSETA
      COMMON /SYSTEM/ SYSBUF,NOT
      COMMON /APD1C / EID,PID,CP,NSPAN,NCHORD,LSPAN,LCHORD,IGID,
     1                X1,Y1,Z1,X12,X4,Y4,Z4,X43,XOP,X1P,ALZO,MCSTM,
     2                NCST1,NCST2,CIDBX,ACSID,IACS,SILB,NCRD,
     3                SCR1,SCR2,SCR3,SCR4,SCR5,ECTA,BGPA,GPLA,USETA,
     4                SILA,CSTMA,ACPT,BUF10,BUF11,BUF12,NEXT,LEFT,ISILN,
     5                NCAM,NAEF1,NAEF2,
     6                NCA1,NCA2,CA2S,CA2E,CA3S,CA3E,CA4S,CA4E,
     7                NPA1,NPA2,PA2S,PA2E,PA3S,PA3E,PA4S,PA4E
      COMMON /APD1D / ICPL(14),YP4,S1,C1,XP2,XP3,XP4,RA1(3)
      COMMON /APD12C/ KEY,AUSET,USA,UK,NCAM2,NASB
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE     (Z(1),IZ(1)),(ICPL(3),RB1(1)),(ICPL(6),ACPL(1,1)),
     1                (NECTA(1),EIDB),(NECTA(2),CID(1)),(KEY(2),NP),
     2                (KEY(3),NSTRIP),(KEY(4),NTP),(EID,IAX(1)),
     3                (SILDX(1),ICID),(ACSIX(1),ACSIB),(ACSIX(2),VX2(1))
      DATA    TYPE  / 1HZ,2HZY,1HY /
      DATA    NAM   / 4HAPD2,4H    /
      DATA    PIO180/ .0174532925  /
C
      IBC   = 0
      NB    = 0
      IF (IOPT .EQ. 1) GO TO 200
C
C     PROCESS CAERO2 WITHOUT CAERO1 ATTACHED
C
      NP    = 0
      NSTRIP= 0
      NTP   = 0
      NAS   = 0
      IPC   = 1
      IDS   = CAO2(1)
   10 IF (CAO2(IPC) .LT. 0) GO TO 191
   11 PC    = CAO2(IPC+1) - 1
      IF (IBC .NE. NB) GO TO 31
C
C     LOOP OVER ALL CAERO2 WITH CURRENT ID TO SET UP POINTERS
C
      NB    = 0
      IBC   = 0
      NBZ   = 0
      NBY   = 0
      NTZ   = 0
      NTY   = 0
      NTZS  = 0
      NTYS  = 0
      NBEA1 = 0
      NSBEA = 0
      NFL   = 0
      NT121 = 0
      NT122 = 0
      K     = IPC
   12 IF (CAO2(K) .NE. IDS) GO TO 19
      NB    = NB + 1
      L     = CAO2(K+1) - 1
      DO 13 M = 1,7
   13 IAX(M) = IZ(L+M)
      ASSIGN 14 TO IRET
      GO TO 29
   14 CONTINUE
      GO TO (15,15,16), BET
   15 NBZ   = NBZ  + 1
      NTZ   = NTZ  + NINT
      NTZS  = NTZS + NSB
      IF (BET .EQ. 1) GO TO 17
   16 NBY   = NBY  + 1
      NTY   = NTY  + NINT
      NTYS  = NTYS + NSB
   17 CONTINUE
      NBEA1 = NBEA1 + NINT
      NSBEA = NSBEA + NSB
      NT121 = NT121 + NTH1
      NT122 = NT122 + NTH2
      NFL   = NFL + KT1
      K     = K + 2
      IF (K .GT. NCAM2*2) GO TO 19
      GO TO 12
   19 IDS   = CAO2(K)
      NTO   = NTP + NTZ + NTY
      NAS   = NASB
C
C     NOW SET UP POINTERS TO BUILD ACPT IN CORE
C
      I = NCORE
      IZ(I   ) = 2
      IZ(I+ 1) = NTP
      IZ(I+ 2) = NTP*2
      IZ(I+ 3) = NP
      IZ(I+ 4) = NB
      IZ(I+ 5) = NTP
      IZ(I+ 6) = NBZ
      IZ(I+ 7) = NBY
      IZ(I+ 8) = NTZ
      IZ(I+ 9) = NTY
      IZ(I+10) = NTO
      IZ(I+11) = NTZS
      IZ(I+12) = NTYS
      IZ(I+13) = NSTRIP
      INC    = I + 14
      INB    = INC  + NP
      INAS   = INB  + NP
      INBEA1 = INAS + NP
      INBEA2 = INBEA1 + NB
      INSBEA = INBEA2 + NB
      IZB    = INSBEA + NB
      IYB    = IZB  + NB
      IAVR   = IYB  + NB
      IARB   = IAVR + NB
      INFL   = IARB + NB
      IXLE   = INFL + NB
      IXTE   = IXLE + NB
      INT121 = IXTE + NB
      INT122 = INT121 + NB
      IZS    = INT122 + NB
      IYS    = IZS + NB + NSTRIP
      IEE    = IYS + NB + NSTRIP
      ISG    = IEE + NSTRIP
      ICG    = ISG + NSTRIP
      IX     = ICG + NSTRIP
      IDELX  = IX  + NTP   + NBEA1
      IXIC   = IDELX + NTP + NBEA1
      IXLAM  = IXIC  + NTP
      IAO    = IXLAM + NTP
      IXIS1  = IAO   + NSBEA
      IXIS2  = IXIS1 + NSBEA
      IAOP   = IXIS2 + NSBEA
      IRIA   = IAOP  + NSBEA
      INASB  = IRIA  + NBEA1
      IFLA1  = INASB + NAS
      IFLA2  = IFLA1 + NFL
      ITH1A  = IFLA2 + NFL
      ITH2A  = ITH1A + NT121
      NWR    = ITH2A + NT122 - NCORE
      NA     = ITH2A + NT122 - 1
      I      = NA + NP*6 +1
      IF (I .GT. LEFT) CALL MESAGE (-8,0,NAM)
C
C     IF PANELS EXIST INSERT DATA FROM SCRATCH FILES
C
      IF(NP.EQ.0) GO TO 31
      NASS = NA
      CALL WRITE (SCR3,0,0,1)
      CALL WRITE (SCR4,0,0,1)
      CALL WRITE (SCR5,0,0,1)
      CALL CLOSE (SCR3,1)
      CALL CLOSE (SCR4,1)
      CALL CLOSE (SCR5,1)
      CALL GOPEN (SCR3,Z(BUF10),0)
      CALL GOPEN (SCR4,Z(BUF11),0)
      CALL GOPEN (SCR5,Z(BUF12),0)
      DO 21 I = 1,NP
      CALL FREAD (SCR5,IZ(INC),1,0)
      CALL FREAD (SCR5,IZ(INB),1,0)
      CALL FREAD (SCR5,K,1,0)
      DO 22 J = 1,6
   22 IZ(NA+J) = IZ(K+J)
      INC = INC + 1
      INB = INB + 1
   21 NA  = NA  + 6
      DO 23 I = 1,NSTRIP
      CALL FREAD (SCR3,IZ(IYS),1,0)
      CALL FREAD (SCR3,IZ(IZS),1,0)
      CALL FREAD (SCR3,IZ(IEE),1,0)
      CALL FREAD (SCR3,IZ(ISG),1,0)
      CALL FREAD (SCR3,IZ(ICG),1,0)
      IYS = IYS + 1
      IZS = IZS + 1
      IEE = IEE + 1
      ISG = ISG + 1
   23 ICG = ICG + 1
      DO 24 I = 1,NTP
      CALL FREAD (SCR4,IZ(IXIC),1,0)
      CALL FREAD (SCR4,IZ(IDELX),1,0)
      CALL FREAD (SCR4,IZ(IXLAM),1,0)
      Z(IX) = Z(IXIC) + .5*Z(IDELX)
      IXIC  = IXIC  + 1
      IDELX = IDELX + 1
      IXLAM = IXLAM + 1
   24 IX    = IX    + 1
      CALL CLOSE (SCR3,1)
      CALL CLOSE (SCR4,1)
      CALL CLOSE (SCR5,1)
C
C     FILL IN ASSOCIATED BODIES
C
      NA  = NASS
      DO 26 I = 1,NP
      L   = 0
      DO 25 J = 1,6
      IF (IZ(NA+J) .EQ. 0) GO TO 25
      L   = L + 1
      IBT = IPC
      DO 27 K = 1,NB
      M   = CAO2(IBT+1)
      IF (IZ(M) .NE. IZ(NA+J)) GO TO 28
      IZ(INASB) = K
      INASB = INASB +1
      GO TO 25
   28 IBT = IBT + 2
   27 CONTINUE
      GO TO 880
   25 CONTINUE
      IZ(INAS) = L
      INAS = INAS + 1
      NA   = NA + 6
   26 CONTINUE
   31 CONTINUE
      IBC  = IBC + 1
C
C     MOVE TO COMMON
C
      DO 20 J = 1,16
   20 IAX(J) = IZ(J+PC)
      IZ(PC+2) = ACSID
      ACSIB = ACSID
      X4    = X1
      Y4    = Y1 + 1.0
      Z4    = Z1
      X43   = X12
      IGID  =-IGID
      CALL APDCS
      IGID  =-IGID
C
C     MOVE AERO CORD SYS TO ICPL
C
      IF (ACSID .EQ. 0) GO TO 35
      DO 34 I = 1,14
      ICPL(I) = IZ(IACS+I-1)
   34 CONTINUE
   35 CONTINUE
      ASSIGN 85 TO IRET
      GO TO 29
C
C     FIND PAERO2 CARD
C
   29 CONTINUE
      IF (PA2S .EQ. 0) GO TO 990
      DO 30 J = PA2S,PA2E,15
      IF (PID .EQ. IZ(J)) GO TO 40
   30 CONTINUE
      GO TO 990
   40 PPC = J
C
C     GET BODY TYPE AND NUMBER OF ELEMENTS
C
      NSB  = NSPAN
      NINT = NCHORD
      BET  = IZ(PPC+1)
      DO 50 J = 1,3
      IF (BET .EQ. TYPE(J)) GO TO 60
   50 CONTINUE
   60 BET  = J
      LTH1 = IZ(PPC+7)
      LTH2 = IZ(PPC+8)
      NTH1 = 0
      NTH2 = 0
      KT1  = 0
      IF (LSPAN .EQ. 0) GO TO 70
      CALL APDOE (LSPAN,IZ,NAEF1,NAEF2,ISPAN,JSPAN)
      IF (ISPAN .EQ. 0) GO TO 950
      NSB  = JSPAN - 1
   70 IF (LCHORD .EQ. 0) GO TO 79
      CALL APDOE (LCHORD,IZ,NAEF1,NAEF2,ICHORD,JCHORD)
      IF (ICHORD .EQ. 0) GO TO 960
      NINT = JCHORD - 1
   79 IF (NINT .EQ. 0) GO TO 80
      KT1  = KT1 + 1
      IF (IZ(PPC+ 9) .EQ. 0) GO TO 920
      IF (IZ(PPC+11) .EQ. 0) GO TO 75
      KT1  = KT1 + 1
      IF (IZ(PPC+13) .EQ. 0) GO TO 75
      KT1  = KT1 + 1
   75 IF (LTH1 .EQ. 0) GO TO 940
      CALL APDOE (LTH1,IZ,NAEF1,NAEF2,ITH1,NTH1)
      IF (ITH1 .EQ. 0) GO TO 940
      IF (LTH2 .EQ. 0) GO TO 80
      CALL APDOE (LTH2,IZ,NAEF1,NAEF2,ITH2,NTH2)
      IF (ITH2 .EQ. 0) GO TO 930
   80 IF (NSB .LT. 2) GO TO 970
      GO TO IRET, (14,85)
C
C     PUT IN TERMS FOR SOME BODY ARRAYS
C
   85 IZ(INBEA1) = NINT
      IF(IBC.GT.1 .AND. BET.LT.IZ(INBEA2-1)) GO TO 870
      IZ(INBEA2) = BET
      IZ(INSBEA) = NSB
      Z(IZB)  = RA1(3)
      Z(IYB)  = RA1(2)
      Z(IZS)  = RA1(3)
      Z(IYS)  = RA1(2)
      Z(IAVR) = Z(PPC+3)
      Z(IARB) = Z(PPC+4)
      IZ(INFL)= KT1
      IZ(INT121) = NTH1
      IZ(INT122) = NTH2
      INBEA1  = INBEA1 + 1
      INBEA2  = INBEA2 + 1
      INSBEA  = INSBEA+1
      IZB  = IZB + 1
      IYB  = IYB + 1
      IZS  = IZS + 1
      IYS  = IYS + 1
      IAVR = IAVR+ 1
      IARB = IARB+ 1
      INFL = INFL+ 1
      INT121 = INT121 + 1
      INT122 = INT122 + 1
C
C     ADD SOME MISC ARRAYS
C
      IF (NTH1 .EQ. 0) GO TO 89
      DO 86 I = 1,NTH1
      Z(ITH1A) = Z(ITH1+I)*PIO180
   86 ITH1A = ITH1A + 1
      IF (NTH2 .EQ. 0) GO TO 88
      DO 87 I = 1,NTH2
      Z(ITH2A) = Z(ITH2+I)*PIO180
   87 ITH2A = ITH2A + 1
   88 K = PPC + 9
      IF (IZ(K).NE.1 .AND. IZ(K+1).NE.NINT .AND. NTH2.EQ.0) GO TO 910
      DO 81 I = 1,KT1
      IZ(IFLA1) = IZ(K)
      IZ(IFLA2) = IZ(K+1)
      K = K + 2
      IF (IZ(IFLA1) .GT. IZ(IFLA2)) GO TO 910
      IF (IZ(IFLA2) .GT. NINT) GO TO 910
      IF (I .EQ. 1) GO TO 82
      IF (IZ(IFLA1) .LE. IZ(IFLA2-1)) GO TO 910
   82 IFLA1 = IFLA1 + 1
      IFLA2 = IFLA2 + 1
   81 CONTINUE
   89 LRSB = IZ(PPC+5)
      LRIB = IZ(PPC+6)
      IF (LRSB .EQ. 0) GO TO 91
      CALL APDOE (LRSB,IZ,NAEF1,NAEF2,IRSB,NRSB)
      IF (IRSB .EQ.     0) GO TO 900
      IF (NRSB .NE. NSB+1) GO TO 900
   91 IF (LRIB .EQ.     0) GO TO 92
      CALL APDOE (LRIB,IZ,NAEF1,NAEF2,IRIB,NRIB)
      IF (IRIB .EQ.      0) GO TO 890
      IF (NRIB .NE. NINT+1) GO TO 890
   92 CONTINUE
      WIDTH = Z(PPC+3)
C
C     GENERATE ELEMENTS
C
      EIDB   = EID - 1
      CIDBX  = CIDBX + 1
      VX1(2) = RA1(2)
      VX1(3) = RA1(3)
C
C     PUT IN PROPER MASKS FOR USET
C
      IF (BET .EQ. 1) GO TO 90
      AUSET(2,2) = UK
      AUSET(6,2) = UK
      IF (BET .EQ. 2) GO TO 90
      AUSET(3,2) = USA
      AUSET(5,2) = USA
   90 CONTINUE
C
C     BUMP NJ AND NK
C
      NJA = NSB + NINT
      NKA = NSB*2
      NJ  = NJ + NJA
      NK  = NK + NKA
      IZ(NCORE+1) = IZ(NCORE+1) + NJA
      IZ(NCORE+2) = IZ(NCORE+2) + NKA
      IF (BET .NE. 2) GO TO 94
      NJ  = NJ + NJA
      NK  = NK + NKA
      IZ(NCORE+1) = IZ(NCORE+1) + NJA
      IZ(NCORE+2) = IZ(NCORE+2) + NKA
   94 I = 1
   95 EIDB = EIDB + 1
      CID(1) = CIDBX
      CIDBX  = CIDBX + 1
      CID(2) = CIDBX
      CID(5) = EIDB
C
C     GRID POINTS IN AERO SYSTEM
C
      IF (I .NE. 1) GO TO 110
      ASSIGN 110 TO BACK
      ICID = CID(1)
      IF (LSPAN .EQ. 0) VX1(1) = RA1(1) + (X12/NSB)*(I-1)
      IF (LSPAN .NE. 0) VX1(1) = RA1(1) + Z(ISPAN+I)*X12
      OLDX = VX1(1)
      Z(IXLE)  = OLDX
      Z(IXIS1) = OLDX
      IXIS1 = IXIS1 + 1
      KK = 1
      GO TO 130
  110 ASSIGN 120 TO BACK
      ICID = CID(2)
      IF (LSPAN .EQ. 0) VX1(1) = RA1(1) + (X12/NSB)*I
      IF (LSPAN .NE. 0) VX1(1) = RA1(1) + Z(ISPAN+I+1)*X12
      Z(IXTE ) = VX1(1)
      Z(IXIS2) = VX1(1)
      IXIS2 = IXIS2 + 1
      IF (I .NE. 1) Z(IXIS1) = OLDX
      IF (I .NE. 1) IXIS1 = IXIS1 + 1
      KK = 1
      GO TO 130
  120 ASSIGN 160 TO BACK
C
C     A0 AND AOP
C
      Z(IAO ) = WIDTH
      Z(IAOP) = 0.0
      IF (LRSB .EQ. 0) GO TO 125
      Z(IAO ) = (Z(IRSB+I  ) + Z(IRSB+I+1))*.5
      Z(IAOP) = (Z(IRSB+I+1) - Z(IRSB+I))/(VX1(1)-OLDX)
  125 IAO  = IAO  + 1
      IAOP = IAOP + 1
      TEMP = (VX1(1)+OLDX)/2.0
      OLDX = VX1(1)
      VX1(1) = TEMP
      ICID = CID(5)
      KK   = 2
C
C     CONVERT TO BASIC
C
  130 IF (ACSID .EQ. 0) GO TO 140
      CALL GMMATS (ACPL,3,3,0,VX1,3,1,0,VX2)
      DO 135 K = 1,3
  135 VX2(K) = VX2(K) + RB1(K)
      GO TO 150
  140 DO 145 K = 1,3
  145 VX2(K) = VX1(K)
C
C     PUT OUT BGPDT GPL USET
C
  150 CALL WRITE (BGPA,ACSIX,4,0)
      CALL WRITE (GPLA,ICID,1,0)
      CALL WRITE (USETA,AUSET(1,KK),6,0)
C
C     BUMP POINTERS
C     PUT OUT SIL EQEXIN SILGA
C
      NCRD   = NCRD + 1
      SILB   = SILB + 6
      ISILN  = ISILN+ 6
      LUSETA = SILB
      SILDX(2) = 10*SILB + 1
      CALL WRITE (SILA,SILB,1,0)
      CALL WRITE (SCR2,ISILN,1,0)
      CALL WRITE (SCR2,SILB,1,0)
      CALL WRITE (SCR1,ICID,2,0)
      GO TO BACK, (110,120,160)
C
C     PUT OUT ECT
C
  160 CID(1) = NCRD - 3
      IF (I .EQ. 1) CID(1) = CID(1) + 1
      CID(2) = NCRD - 1
      CID(3) = CID(1)
      CID(4) = CID(2)
      CID(5) = NCRD
      CALL WRITE (ECTA,NECTA,6,0)
      I  = I + 1
      IF (I .LE. NSB) GO TO 95
C
C     INTEFERENCE CALCULATIONS AND ARRAYS
C
      IF (NINT .EQ. 0) GO TO 170
      P1 = 1.0/NINT
      DO 165 J = 1,NINT
      Z(IRIA) = WIDTH
      IF (LRIB .NE. 0) Z(IRIA) = .5*(Z(IRIB+J)+Z(IRIB+J+1))
      IRIA = IRIA + 1
      D1   = P1*(J-1)
      D2   = P1*J
      IF (LCHORD .NE. 0) D1 = Z(ICHORD+J  )
      IF (LCHORD .NE. 0) D2 = Z(ICHORD+J+1)
      Z(IDELX) = X12*(D2-D1)
      Z(IX) = RA1(1) + X12*(D1+D2)/2.0
      IF (J .EQ.    1) Z(IXLE) = RA1(1) + D1*X12
      IF (J .EQ. NINT) Z(IXTE) = RA1(1) + D2*X12
      IDELX = IDELX + 1
      IX = IX + 1
  165 CONTINUE
  170 CONTINUE
      IXLE = IXLE + 1
      IXTE = IXTE + 1
      IZ(PC+ 4) = NSB
      IZ(PC+ 5) = 1
      IZ(PC+ 8) = 2
      IZ(PC+16) = BET
      IF (BET .EQ. 1) GO TO 190
      AUSET(2,2) = USA
      AUSET(6,2) = USA
      AUSET(3,2) = UK
      AUSET(5,2) = UK
  190 IF (IBC .EQ. NB) CALL WRITE (ACPT,IZ(NCORE),NWR,1)
  191 IF (IOPT .EQ. 1) GO TO 230
      IPC = IPC + 2
      IF (IPC .LT. NCAM2*2) GO TO 10
      GO TO 1000
C
C     CAERO2 WITH CAERO1 ATTACHED
C
  200 IPC = 1
      IDS = ID
  210 IF (CAO2(IPC) .EQ. ID) GO TO 11
  220 IPC = IPC + 2
      IF (IPC .LT. NCAM2*2) GO TO 210
      GO TO 1000
  230 CAO2(IPC) = -CAO2(IPC)
      GO TO 220
 1000 RETURN
C
C     ERROR MESSAGES
C
  912 CALL MESAGE (-61,0,NAM)
  870 WRITE  (NOT,8777) UFM,EID
 8777 FORMAT (A23,' 2273, CAERO2',I9,' NOT INPUT IN Z, ZY, Y SEQUENCE.')
      GO TO 912
  880 WRITE  (NOT,8888) UFM,IZ(NA+J),CAO2(IBT)
 8888 FORMAT (A23,' 2274, ASSOCIATED BODY',I9,' WAS NOT FOUND WITH ',
     1       'CAERO2 GROUP',I9,1H.)
      GO TO 912
  890 J = LRIB
      GO TO 941
  900 J = LRSB
      GO TO 941
  910 WRITE  (NOT,9111) UFM,EID
 9111 FORMAT (A23,' 2275, CAERO2',I9,' HAS INCONSISTENT USE FOR THI OR',
     1       ' THN, OR LTH2 IS REQUIRED.')
      GO TO 912
  920 WRITE  (NOT,9222) UFM,EID
 9222 FORMAT (A23,' 2276, THI1 AND THN1 REQUIRED FOR CAERO2',I9,1H.)
      GO TO 912
  930 J = LTH2
      GO TO 941
  940 J = LTH1
  941 WRITE  (NOT,9999) UFM,J,EID
 9999 FORMAT (A23,' 2429, WRONG NUMBER OF WORDS OR CARD NOT FOUND FOR',
     1       ' CARD ID',I9, /28X,'ASSOCIATED WITH CAERO2 ID',I9)
      GO TO 912
  950 CALL EMSG (0,2326,1,2,0)
      WRITE  (NOT,951) EID,LSPAN
  951 FORMAT (10X,'CAERO2 ELEMENT NO.',I9,' REFERENCES AEFACT CARD NO.',
     1        I9,' WHICH DOES NOT EXIST.')
      GO TO 912
  960 CALL EMSG (0,2327,1,2,0)
      WRITE (NOT,951) EID,LCHORD
      GO TO 912
  970 WRITE  (NOT,971) UFM,EID
  971 FORMAT (A23,' 2277, CAERO2 BODY',I9,' DOES NOT HAVE ENOUGH ',
     1       'SLENDER ELEMENTS.')
      GO TO 912
  990 CALL EMSG (0,2323,1,2,0)
      WRITE  (NOT,991) PID,EID
  991 FORMAT (10X,'PAERO2 CARD NO.',I9,' REFERENCED BY CAERO2 CARD NO.',
     1        I9,' BUT DOES NOT EXIST.')
      GO TO 912
      END

      SUBROUTINE SMCOUT ( ZI, ZR, ZD, ZRS, ZRD )
C
C SMCOUT DOES THE FINAL DIVISION OF THE TERMS OF THE PIVOTAL COLUMN
C AND WRITES THE COLUMN DATA TO THE LOWER TRIANGULAR MATRIX.
C
C THE FOLLOWING CALCULATIONS ARE DONE IN SUBROUTINE SMC2-RS,RD,CS,CD
C 
C      do 100 k = 1,n
C         do 10  i = k,n
C         temp = 0.
C         do 5  l = 1,k-1
C            temp = temp + a(i,l)*a(k,l) / a(l,l)
C    5       continue
C         a(i,k) = a(i,k) - temp
C   10    continue
C
C            THE FOLLOWING LAST COMPUTATION TAKES PLACE IN THIS SUBROUTINE.
C            THE RESULTS OF THE DIVISION ARE WRITTEN TO THE OUTPUT FILE BUT
C            THE RESULTS OF THE ABOVE (WITHOUT THE DIVISION BELOW) IS
C            MAINTAINED IN MEMORY FOR REMAINING COLUMN COMPUTATIONS.
C
C         do 11 j = k+1,n
C           a(k,j) = a(j,k) / a( k,k )
C   11      continue
C  100 continue
C
C  THE FINAL COMPUTATIONS ARE WRITTEN TO THE LLL MATRIX USING PUTSTR/ENDPUT.
C
      INTEGER          ZI(10)
      REAL             ZR(10), MINDS, ZRS(10)
      DOUBLE PRECISION ZD(10), DAKK2, DAKKR, DAKKI, DAKK, XND(10)
      DOUBLE PRECISION DR    , ZRD(10)
      INCLUDE  'SMCOMX.COM'
      CHARACTER         UFM*23,UWM*25,UIM*29,SFM*25
      COMMON / XMSSG  / UFM  , UWM  , UIM  , SFM
      COMMON / ZZZZZZ / XNS(10)
      EQUIVALENCE      ( XNS, XND )
      EQUIVALENCE      ( MINDS, MINDD ), (DSR, DDR ), (DSC, DDC )
      DATA               RZERO / 1.0E-10  / 
C      PRINT *,' SMCOUT-ENTER,KCOL=',KCOL
      KDIR  = ( KCOL-1 ) * 4 + 1
      KMIDX = ZI( KDIR )
      KRIDX = KMIDX + 4
      KM2   = ZI( KMIDX+1 )
      KRIDN = KRIDX + KM2   
      NROWS = 0
      DO 10 I = 1, KM2, 2
      NROWS  = NROWS + ZI( KRIDX + I ) 
10    CONTINUE
      KVIDX = KRIDX + KM2  
      GO TO (1000, 2000, 3000, 4000 ), KTYPE
C
C DO DIVISION IN REAL SINGLE PRECISION AND COMPUTE THE  DETERMINANT DDS.
C CHECK FOR THE SMALLEST VALUE OF ANY DIAGONAL ELEMENT ("MINDS")
C
1000  CONTINUE
      AKK          =  ZR( KVIDX )     
CWKBI  7/95 SPR95005
      IF ( AKK .EQ. 0.0 ) GO TO 7002
1010  IF ( ABS( DSR ) .LT. 10. ) GO TO 1020
      DSR = DSR / 10.
      POWER = POWER + 1
      GO TO 1010
1020  IF ( ABS( DSR ) .GT. 0.1 ) GO TO 1030
      DSR = DSR * 10.
      POWER = POWER - 1
      GO TO 1020
1030  DSR    = DSR * AKK
      MINDS  = AMIN1 ( ABS(AKK), MINDS )
      IF ( CHLSKY .EQ. 0 ) GO TO 1040
      IF ( AKK .LE. 0 ) GO TO 7001
      AKK = SQRT( AKK )
1040  IF ( AKK .LT. 0. ) STURM = STURM + 1
CWKBD  7/95 SPR95005
C      IF ( AKK .EQ. 0. ) GO TO 7002
1050  ZRS( 1 ) = AKK
CWKBR 7/95 SPR95005
C      AKK      = 1. / AKK
      AKK      = -1. / AKK
      DO 1150 I = 2, NROWS
CWKBR 7/95 SPR95005
C      ZRS( I ) = -1.0 * ZR( KVIDX + I - 1 ) * AKK 
      ZRS( I ) =  ZR( KVIDX + I - 1 ) * AKK 
1150  CONTINUE
      GO TO 5000
C
C DO DIVISION IN REAL DOUBLE PRECISION AND COMPUTE THE  DETERMINANT DDR.
C CHECK FOR THE SMALLEST VALUE OF ANY DIAGONAL ELEMENT ("MINDD")
C
2000  CONTINUE
      KVIDX = ( KVIDX/2 ) + 1            
      DAKK  =  ZD( KVIDX )  
CWKBI  7/95 SPR95005
      IF ( DAKK .EQ. 0.D0 ) GO TO 7002
2010  IF ( DABS( DDR ) .LT. 10.D0 ) GO TO 2020
      DDR = DDR / 10.D0
      POWER = POWER + 1
      GO TO 2010
2020  IF ( DABS( DDR ) .GT. 0.1 ) GO TO 2030
      DDR   = DDR * 10.D0
      POWER = POWER - 1
      GO TO 2020
2030  DDR   = DDR * DAKK
      MINDD = DMIN1 ( DABS(DAKK), MINDD )
      IF ( CHLSKY .EQ. 0 ) GO TO 2040
      IF ( DAKK .LE. 0 ) GO TO 7001
      DAKK = DSQRT( DAKK )
2040  IF ( DAKK .LT. 0.D0 ) STURM = STURM + 1
CWKBD 7/95 SPR95005
C      IF ( DAKK .EQ. 0.D0 ) GO TO 7002
2050  ZRD( 1 ) = DAKK
CWKBR 7/95 SPR95005
C      DAKK        = 1.D0 / DAKK   
      DAKK        = -1.D0 / DAKK   
      DO 2150 I = 2, NROWS
CWKBR 7/95 SPR95005
C      ZRD( I ) = -1.0D0 * ZD( KVIDX + I - 1 ) * DAKK  
      ZRD( I ) = ZD( KVIDX + I - 1 ) * DAKK  
2150  CONTINUE
      GO TO 5000
C
C DO DIVISION IN COMPLEX SINGLE PRECISION AND COMPUTE THE DETERMINANT 
C DSR AND DSC.
C CHECK FOR THE SMALLEST VALUE OF ANY DIAGONAL ELEMENT ("MINDS")
C
3000  CONTINUE
C   (A+Bi) / (C+Di) = (AC + DB + ( CB-AD )i ) / (C**2 + D**2)
      AKKR  = ZR( KVIDX   )
      AKKI  = ZR( KVIDX+1 )
      AKK2  = AKKR*AKKR + AKKI*AKKI
CWKBI  7/95 SPR95005      
      IF ( AKK2 .EQ. 0. ) GO TO 7002     
3010  IF ( ABS( DSR**2 + DSC**2 ) .LT. 10. ) GO TO 3020
      DSR   = DSR / 10.
      DSC   = DSC / 10.
      POWER = POWER + 1
      GO TO 3010
3020  IF ( ABS( DSR**2 + DSC**2 ) .GT. 0.1 ) GO TO 3030
      DSR   = DSR * 10.
      DSC   = DSC * 10.
      POWER = POWER - 1
      GO TO 3020
3030  RS    = DSR*AKKR - DSC*AKKI
      DSC   = DSR*AKKI + DSC*AKKR
      DSR   = RS
      MINDS = AMIN1 ( ABS(AKK2), MINDS )
      IF ( CHLSKY .EQ. 0 ) GO TO 3040
      IF ( AKK2 .LE. 0 ) GO TO 7001
      AKK2 = SQRT( AKK2 )
3040  IF ( AKKR .LT. 0. ) STURM = STURM + 1
CWKBD  7/95 SPR95005
C      IF ( AKK2 .EQ. 0. ) GO TO 7002     
3050  ZRS( 1 ) = AKKR
      ZRS( 2 ) = AKKI
      NROWM   = NROWS * 2 - 1
CWKBR 7/95 SPR95005
C      AKK2    = 1. / AKK2   
      AKK2    = -1. / AKK2   
      KVIDX   = KVIDX + 1
      DO 3150 I = 2, NROWM, 2
CWKBDB 7/95 SPR95005
C      ZRS( I+1 ) =  -1.0 * ( ZR( KVIDX+I-1   ) * AKKR  +
C     &                         ZR( KVIDX+I   ) * AKKI  ) * AKK2
C      ZRS( I+2 ) =  -1.0 * ( ZR( KVIDX+I     ) * AKKR  -
C     &                         ZR( KVIDX+I-1 ) * AKKI  ) * AKK2
CWKBDE 7/95 SPR95005
CWKBIB 7/95 SPR95005
      ZRS( I+1 ) =  ( ZR( KVIDX+I-1 ) * AKKR  +
     &                ZR( KVIDX+I   ) * AKKI  ) * AKK2
      ZRS( I+2 ) =  ( ZR( KVIDX+I   ) * AKKR  -
     &                ZR( KVIDX+I-1 ) * AKKI  ) * AKK2
CWKBIE 7/95 SPR95005
3150  CONTINUE
      GO TO 5000
C
C DO DIVISION IN COMPLEX DOUBLE PRECISION AND COMPUTE THE DETERMINANT 
C DDR AND DDC.
C CHECK FOR THE SMALLEST VALUE OF ANY DIAGONAL ELEMENT ("MINDD")
C
4000  CONTINUE
      KVIDX = ( KVIDX/2 ) + 1            
      DAKKR = ZD( KVIDX   )
      DAKKI = ZD( KVIDX+1 )
      DAKK2 = DAKKR*DAKKR + DAKKI*DAKKI
CWKBI  7/95 SPR95005      
      IF ( DAKK2 .EQ. 0. ) GO TO 7002 
4010  IF ( DABS( DDR**2 + DDC**2 ) .LT. 10.D0 ) GO TO 4020
      DDR   = DDR / 10.
      DDC   = DDC / 10.
      POWER = POWER + 1
      GO TO 4010
4020  IF ( DABS( DDR**2 + DDC**2 ) .GT. 0.1D0 ) GO TO 4030
      DDR   = DDR * 10.
      DDC   = DDC * 10.
      POWER = POWER - 1
      GO TO 4020
4030  DR    = DDR*DAKKR - DDC*DAKKI
      DDC   = DDR*DAKKI + DDC*DAKKR
      DDR   = DR
      MINDD = DMIN1 ( DABS(DAKK2), MINDD )
      IF ( CHLSKY .EQ. 0 ) GO TO 4040
      IF ( DAKK2 .LE. 0 ) GO TO 7001
      DAKK2 = DSQRT( DAKK2 )
4040  IF ( DAKKR .LT. 0. ) STURM = STURM + 1
CWKBD  7/95 SPR95005
C      IF ( DAKK2 .EQ. 0. ) GO TO 7002 
4050  ZRD( 1 ) = DAKKR
      ZRD( 2 ) = DAKKI
      NROWM1  = NROWS * 2 - 1
CWKBR 7/95 SPR95005
C      DAKK2   = 1.D0 / (DAKK2 )   
      DAKK2   = -1.D0 / (DAKK2 )   
      KVIDX   = KVIDX + 1
      DO 4150 I = 2, NROWM1, 2
CWKBDB 7/95 SPR95005
C      ZRD( I+1 ) = -1.0D0 * ( ZD( KVIDX+I-1 ) * DAKKR  +
C     &                          ZD( KVIDX+I ) * DAKKI  ) * DAKK2
C      ZRD( I+2 ) = -1.0D0 * ( ZD( KVIDX+I )   * DAKKR  -
C     &                        ZD( KVIDX+I-1 ) * DAKKI  ) * DAKK2
CWKBDE 7/95 SPR95005
CWKBIB 7/95 SPR95005
      ZRD( I+1 ) = ( ZD( KVIDX+I-1 ) * DAKKR  +
     &               ZD( KVIDX+I   ) * DAKKI  ) * DAKK2
      ZRD( I+2 ) = ( ZD( KVIDX+I   ) * DAKKR  -
     &               ZD( KVIDX+I-1 ) * DAKKI  ) * DAKK2
CWKBIE 7/95 SPR95005
4150  CONTINUE
      GO TO 5000
C
C NOW WRITE THE COLUMN OUT TO THE OUTPUT MATRIX
C
5000  CONTINUE
      ITWRDS      = 0
      MOBLK( 8 )  = -1
      MOBLK( 12 ) = KCOL
      KROW  = ZI( KRIDX )
      KROWS = ZI( KRIDX+ 1)
      IF ( KTYPE .LE. 2 ) NWDS = 1
      IF ( KTYPE .GT. 2 ) NWDS = 2
      IOL = 1
5050  CALL PUTSTR ( MOBLK )
      MOBLK( 4 ) = KROW
      MOBLK( 7 ) = MIN0 ( KROWS, MOBLK(6) )
      JSTR = MOBLK( 5 )
      NSTR = JSTR + (MOBLK( 7 ) - 1 ) * NWDS 
      IF ( KTYPE .GE. 3 ) NSTR = NSTR + 1
      IF ( KPREC .EQ. 2 ) GO TO 5200
C 
C MOVE REAL SINGLE AND SINGLE COMPLEX VALUES INTO BUFFER
C
5100  DO 5150 JJ = JSTR, NSTR
      XNS( JJ ) = ZRS( IOL  )
      IOL = IOL + 1
5150  CONTINUE
      ITWRDS = NSTR - JSTR + 1
      GO TO 5500
C
C MOVE REAL DOUBLE AND DOUBLE COMPLEX VALUES INTO BUFFER
C
5200  DO 5250 JJ = JSTR, NSTR
      XND( JJ ) = ZRD( IOL )
C      PRINT *,' SMCOUT,ROW,NUM,TERM=',MOBLK(4),MOBLK(7),XND(JJ)
      IOL = IOL + 1
5250  CONTINUE
      ITWRDS = ( NSTR-JSTR+1 ) * 2
5500  CONTINUE
C
C CHECK TO SEE IF ALL CONSECUTIVE ROWS CAN BE STORED IN THE BUFFER
C I.E., ARE THERE ENOUGH WORDS IN THE AVAILABLE STRING
C
      IF ( MOBLK( 7 ) .EQ. KROWS ) GO TO 5600
      ISTORE = MOBLK( 7 )
      KROWS  = KROWS - ISTORE
      KROW   = KROW  + ISTORE
      CALL ENDPUT ( MOBLK )
      GO TO 5050
C
C ALL OF THE CURRENT CONSECUTIVE ROWS WERE STORED IN THE BUFFER.
C GO AND GET THE NEXT SET OF CONSECUTIVE ROWS, IF ANY EXIST.
C
5600  KRIDX = KRIDX + 2
      IF ( KRIDX .GE. KRIDN ) GO TO 7000
      CALL ENDPUT ( MOBLK )
      KROW  = ZI( KRIDX )
      KROWS = ZI( KRIDX+1 )
      GO TO 5050
C
C ALL ROWS OF THIS COLUMN HAVE BEEN STORED, CLOSE OUT THE COLUMN
C
7000  MOBLK( 8 ) = 1
      CALL ENDPUT ( MOBLK )
      GO TO 7777
7001  WRITE ( NOUT, 9001 ) UFM, KCOL
9001  FORMAT(A23,' 3181, ATTEMPT TO PERFORM CHOLESKY DECOMPOSITION'
     &,' ON A NEGATIVE DEFINITE MATRIX IN SUBROUTINE SMCOMP.'
     &,/,' NEGATIVE DIAGONAL TERM FOUND ON COLUMN ',I6)
      IERROR = 4
      CALL MESAGE ( -61, 0, 0 )
7002  WRITE ( NOUT, 9002 ) UWM, KCOL, RZERO
9002  FORMAT(A25,' 2396, SMCOMP COMPUTED A ZERO ON THE DIAGONAL '
     &,'DURING DECOMPOSITION OF ROW NUMBER ',I6,'.',/
     &,' USE OF DIAG 22 OUTPUT SHOULD PERMIT YOU TO CORRELATE THE'
     &,' ROW WITH A MODEL D.O.F.',/,' A VALUE OF ',E13.6
     &,' WILL BE USED IN PLACE OF THE ZERO, HOWEVER',/
     &,' THE ACCURACY OF THE DECOMPOSITION MAY BE IN DOUBT.')
      AKK   = RZERO
      DAKK  = RZERO
      AKKR  = RZERO
      AKKI  = RZERO
      DAKKR = RZERO
      DAKKI = RZERO
      AKK2  = AKKR*AKKR   + AKKI*AKKI
      DAKK2 = DAKKR*DAKKR + DAKKI*DAKKI
CWKBIB 7/95 SPR95005
      GO TO ( 7010, 7020, 7030, 7040 ), KTYPE
7010  CONTINUE
      ZR( KVIDX ) = AKK    
      GO TO 1010
7020  CONTINUE
      ZD( KVIDX ) = DAKK   
      GO TO 2010
7030  CONTINUE
      ZR( KVIDX   ) = AKKR
      ZR( KVIDX+1 ) = AKKI
      GO TO 3010
7040  CONTINUE
      ZD( KVIDX   ) = DAKKR   
      ZD( KVIDX+1 ) = DAKKI   
      GO TO 4010
CWKBIE 7/95 SPR95005
CWKBD  7/95 SPR95005
C      GO TO ( 1050, 2050, 3050, 4050 ), KTYPE
7777  LLL( 6 ) = MAX0( LLL(6), ITWRDS )
      LLL( 7 ) = LLL( 7 ) + ITWRDS
      RETURN
      END

      DOUBLE PRECISION FUNCTION DK89(I,A,B,M,N,X)
      DOUBLE PRECISION F89, A, B, X, CAPX, AMF, AN1, AN2, S, SF, AMMSF
      DOUBLE PRECISION AMN1F, ANM1F
      DIMENSION X(1)
      F89 = 0.0D0
      CAPX = A + B * X(I)
      NFAC = M
      ASSIGN 5 TO IRET
      GO TO 1000
    5 AMF = KFAC
      N1 = M + 1
      N2 = N1 - N
      AN1 = N1
      AN2 = N2
      IS = 0
      S = 0.0D0
      SF = 1.0D0
      AMMSF = AMF
      GO TO 50
   10 IS = IS + 1
      S = IS
      SF = SF * S
      AMMSF = AMMSF / (AN1 - S)
   50 CONTINUE
      N3 = N2 - IS
      IF (N3 .EQ. 0) GO TO 100
      F89 = F89 + AMF *((-A)** IS) * (CAPX ** N3) / (AMMSF * SF *
     1            (AN2 - S))
      GO TO 200
  100 CONTINUE
      NFAC = N2
      ASSIGN 110 TO IRET
      GO TO 1000
  110 AMN1F = KFAC
      NFAC = N-1
      ASSIGN 120 TO IRET
      GO TO 1000
  120 ANM1F = KFAC
      F89 = F89 + AMF *((-A)** N2) *DLOG(DABS(CAPX)) / (AMN1F * ANM1F)
  200 IF (IS .LT. M) GO TO 10
      IF( B .EQ. 0.0D0 ) GO TO 300
      F89 = F89 / (B ** N1)
      DK89 = F89
      RETURN
  300 DK89 = 0.0D0
      RETURN
 1000 KFAC = 1
      IF(NFAC.LT.2) GO TO 1020
      DO 1010 LFAC=2,NFAC
      KFAC=KFAC*LFAC
 1010 CONTINUE
 1020 GO TO IRET,(5,110,120)
      END

      LOGICAL FUNCTION IFPDCO (IC)
C
C     DECODE D.O.F. INTO LL SPACE.
C     RETURN WITH IFPDCO=.TRUE. IF ERROR ENCOUNTERED
C     FOR EXAMPLE - GIVEN IC=124, THEN
C                   LL(1)=1,   LL(2)=2,  LL(4)=4, LL(3)=LL(5)=LL(6)=0
C                   GC(1)=124, GC(2)=12, GC(3)=1, GC(4)=GC(5),GC(6)=0
C                   IFPDCO=.FALSE.
C
      INTEGER DG,GC
      COMMON /IFPDTA/ DUM(521),GC(7),LL(6)
      COMMON /SYSTEM/ IDUMMY(55),ITHRML
C
      GC(1) = IC
      DO 110 LC=1,6
  110 LL(LC) = 0
      IF (IC) 120,116,112
  112 DO 114 LC=1,6
      GC(LC+1) = GC(LC)/10
      DG = GC(LC)-10*GC(LC+1)
      IF (ITHRML.NE.1 .AND. DG.GT.6) GO TO 120
      IF (ITHRML.EQ.1 .AND. DG.GT.1) GO TO 120
      IF (DG .EQ. 0) GO TO 118
      IF (LL(DG) .NE. 0) GO TO 120
  114 LL(DG) = DG
      IF (GC(7) .NE. 0) GO TO 120
  116 IFPDCO = .FALSE.
      RETURN
  118 IF (GC(LC) .EQ. 0) GO TO 116
  120 IFPDCO = .TRUE.
      RETURN
      END

      SUBROUTINE SHAPE (*,GPLST,X,U,PEN,DEFORM,IOPT,IPTL,LIPLT,OPCOR)
C
C     IOPT CONTROLS THIS ROUTINE
C     IOPT .LT. 0
C       THE LINEL ARRAY WAS NOT CREATED.  UNIQUE LINES ARE NOT DRAWN.
C     IOPT .GE. 0
C       THE LIPLT ARRAY HAS CONNECTION DATA TO MAKE UNIQUE LINES. SUPLT
C       WILL CREATE THE LINES.  IPTR IS ONE OF THE PARAMETERS.
C
C     REVISED 10/1990 BY G.CHAN/UNISYS, TO INCLUDE BAR, TRIA3 AND QUAE4
C     OFFSET (PEDGE = 3)
C
      INTEGER         GPLST(1),PEN,DEFORM,LIPLT(1),ETYP,ECT,NAME(2),GP,
     1                ELID,OPCOR,TE,BR,T3,Q4,OFFSET,PEDGE
      REAL            X(3,1),U(2,1),OFF(6)
      COMMON /BLANK / NGP,SKP1(9),SKP2(2),ECT,SKP21(7),MERR
      COMMON /DRWDAT/ SKP15(15),PEDGE
      DATA    TE,BR , T3,Q4  / 2HTE, 2HBR, 2HT3, 2HQ4 /
      DATA    NAME  / 4HSHAP,1HE/
C
      CALL LINE (0,0,0,0,0,-1)
      IF (IOPT .GE. 0) GO TO 120
   10 CALL READ (*140,*130,ECT,ETYP,1,0,I)
      OFFSET = 0
      IF (ETYP .EQ. BR) OFFSET = 6
      IF (ETYP.EQ.T3 .OR. ETYP.EQ.Q4) OFFSET = 1
      CALL FREAD (ECT,I,1,0)
      NGPEL = IABS(I)
      IF (ETYP.NE.TE .AND. NGPEL.LT.5) GO TO 30
C
C     NOT A SIMPLE ELEMENT
C
   20 LGPEL = NGPEL
      LTYP  = ETYP
      CALL LINEL (LIPLT,LTYP,OPCOR,LGPEL,X,PEN,DEFORM,GPLST)
      L = IABS(LTYP)
      IF (L-1) 10,115,70
C
   30 L = NGPEL + 1
      IF (NGPEL.LE.2 .OR. I.LT.0) L = NGPEL
      LTYP = 10000
      M = 1
   40 CALL FREAD (ECT,ELID,1,0)
      IF (ELID .LE. 0) GO TO 10
      CALL FREAD (ECT,LID,1,0)
      CALL FREAD (ECT,LIPLT,NGPEL,0)
      IF (L .NE. NGPEL) LIPLT(L) = LIPLT(1)
C
      IF (OFFSET .NE. 0) CALL FREAD (ECT,OFF,OFFSET,0)
      IF (OFFSET.EQ.0 .OR. DEFORM.NE.0) GO TO 70
C
C     IF THIS IS A BAR, TRIA3 OR QUAD4 ELEMENTS READ IN THE OFFSET
C     NO SCALE FACTOR APPLIES TO OFFSET HERE
C
      IF (OFFSET .NE. 6) GO TO 50
C
C     BAR OFFSET
C
      OFF(1) = 0.707*SQRT(OFF(1)**2 + OFF(2)**2 + OFF(3)**2)
      OFF(2) = 0.707*SQRT(OFF(4)**2 + OFF(5)**2 + OFF(6)**2)
      OFF(3) = OFF(1)
      GO TO 70
C
C     TRIA3 AND QUAD4 OFFSET
C
   50 OFF(1) = 0.707*OFF(1)
      DO 60 I = 2,5
   60 OFF(I) = OFF(1)
C
C     WRITE THE LINES.  0 FOR SIL MEANS NO LINES DRAWN
C
   70 J = 0
      DO 110 I = 1,L
      IF (J .EQ. 0) GO TO 80
      X1 = X2
      Y1 = Y2
   80 GP = LIPLT(I)
      IF (GP .EQ. 0) GO TO 110
      GP = IABS(GPLST(GP))
      IF (DEFORM .NE. 0) GO TO 90
      X2 = X(2,GP)
      Y2 = X(3,GP)
      IF (OFFSET .EQ. 0) GO TO 100
C
C     IF OFFSET IS PRESENT, ADD ARBITRARY AN OFFSET LENGTH TO X2 AND Y2.
C     SINCE THE OFFSET LENGTH IS SO TINY, ITS TRUE DIRECTION IS NOT OF
C     VITAL CONCERNS. THE IDEA HERE IS THAT BIG OFFSET WILL SHOW IN THE
C     PLOT IF ORIGINAL DATA CONTAINS ERRONEOUS AND BIG OFFSET VALUE(S).
C
C     IF OFFSET IS ADDED IN SAME DIRECTION AS THE PLOTTED LINE, ROTATE
C     THE OFFSET LENGTH BY 90 DEGREE
C
      X2 = X2 + OFF(I)
      XY = XY + OFF(I)
      IF (ABS((X2-X1)-(Y2-Y1)) .LT. 0.01) X2 = X2 - 2.*OFF(I)
      GO TO 100
   90 X2 = U(1,GP)
      Y2 = U(2,GP)
  100 IF (J.EQ.0 .OR. J.EQ.GP) GO TO 110
      CALL LINE (X1,Y1,X2,Y2,PEN,0)
  110 J = GP
C
  115 IF (L-LTYP) 40,10,20
C
C
  120 IF (PEDGE .EQ. 3) GO TO 130
      CALL SUPLT (LIPLT(1),LIPLT(IPTL+1),X,U,GPLST,PEN,DEFORM)
  130 CALL LINE (0,0,0,0,0,1)
      IF (IOPT .LT. 0) CALL BCKREC (ECT)
      GO TO 150
C
C     ILLEGAL EOF
C
  140 CALL MESAGE (-2,ECT,NAME)
  150 IF (PEDGE .EQ. 3) RETURN 1
      RETURN
      END

      SUBROUTINE SMCHLP
C      
C SMCHLP WRITES THE CONTENTS OF THE KEY PARAMETERS IN THE SYMMETRIC
C DECOMPOSITION COMMON BLOCKS
C
      INCLUDE 'SMCOMX.COM'
      WRITE ( NOUT, 9001 ) 
     &    NCOL   , IERROR  , IVWRDS , MAXNAC 
     &,   NSPILL , MAXINLOP, IDBASE , IDBMAX 
     &,   IBUF1  , IBUF2   , OPNSCR , IOLOOP
     &,   LASCOL , KROW    , KROWS  , KROWN
     &,   KRIDX  , KRIDXN  , JRIDXN , JROW    
     &,   JROWS  , JROWN   , JRIDX  , JVIDX  
     &,   IROW1  , IROWN   , KFRCOL , KLSCOL
     &,   KLSROW , IOL     , IIL    , KTYPE 
     &,   ISKIP  , INDEXV  , KCOL   , MAXNCOL
     &,   MEMFRE , MEMCOL1 , MEMLCK , MEMLAS
     &,   MEMCOLN, ISPILL  , NBANDW , NVTERM
9001  FORMAT(//
     &,  ' NCOL   =',I9,' IERROR  =',I9,' IVWRDS =',I9,' MAXNAC =',I9
     &,/,' NSPILL =',I9,' MAXINLOP=',I9,' IDBASE =',I9,' IDBMAX =',I9
     &,/,' IBUF1  =',I9,' IBUF2   =',I9,' OPNSCR =',L9,' IOLOOP =',I9
     &,/,' LASCOL =',I9,' KROW    =',I9,' KROWS  =',I9,' KROWN  =',I9
     &,/,' KRIDX  =',I9,' KRIDXN  =',I9,' JRIDXN =',I9,' JROW   =',I9
     &,/,' JROWS  =',I9,' JROWN   =',I9,' JRIDX  =',I9,' JVIDX  =',I9
     &,/,' IROW1  =',I9,' IROWN   =',I9,' KFRCOL =',I9,' KLSCOL =',I9
     &,/,' KLSROW =',I9,' IOL     =',I9,' IIL    =',I9,' KTYPE  =',I9
     &,/,' ISKIP  =',I9,' INDEXV  =',I9,' KCOL   =',I9,' MAXNCOL=',I9
     &,/,' MEMFRE =',I9,' MEMCOL1 =',I9,' MEMLCK =',I9,' MEMLAS =',I9
     &,/,' MEMCOLN=',I9,' ISPILL  =',I9,' NBANDW =',I9,' NVTERM =',I9  
     & )
      WRITE ( NOUT, 9002 ) ISYSBF, ISPREC
9002  FORMAT(
     & /,' ISYSBF =',I9,' ISPREC   =',I9 )
      WRITE ( NOUT, 9003 ) MBLK, MOBLK
9003  FORMAT(/,' MBLK (INPUT MATRIX STRING BLOCK)=',/,3(5I10,/)
     &      ,/,' MOBLK (OUTPUT MATRIX STRING BLOCK)=',/,3(5I10,/))
      WRITE ( NOUT, 9004 ) LCORE, POWER, MINDD, CHLSKY, ISCR1
9004  FORMAT(
     & /,' LCORE  =',I9,' POWER   =',I9,' MINDD   =',E16.8
     &,/,' CHLSKY =',I9,' ISCR1   =',I9 )
      WRITE ( NOUT, 9005 ) MCB, LLL
9005  FORMAT('  INPUT MATRIX MCB=',/,7I8,
     & /,    ' OUTPUT MATRIX MCB=',/,7I8 )
      RETURN
      END

        SUBROUTINE ENDGTB ( BLOCK )
      INCLUDE 'DSIOF.COM'
      INCLUDE 'XNSTRN.COM'
        INTEGER BLOCK( 15 )
        NAME = BLOCK( 1)
        CALL DSGEFL
        ID = IAND( IBASE( INDCBP ), MASKQ1 )
        IF ( ID .NE. IDSST ) CALL DSMSG ( 117 )
        LEN = IAND ( IBASE( INDCBP ), MASKH2 ) * BLOCK( 11 )
        INDCBP = INDCBP - LEN - 2
        CALL DSSDCB
        RETURN
        END

      SUBROUTINE GIVENS
C
C     DRIVER FOR GIVENS-HOUSEHOLDER METHOD
C
      INTEGER          SYSBUF   ,EIGR(4)  ,ICORE(1) ,OPTION   ,FILE    ,
     1                 NAME(4)  ,END      ,PHIA     ,T        ,IX(7)   ,
     2                 SCR1     ,SCR2     ,SCR3     ,SCR4     ,SCR5    ,
     3                 SCR6     ,SCR7
      REAL             LFREQ    ,MB(1)
      DOUBLE PRECISION DCORE(1) ,DLMDAS   ,DALPHA(2),DBETA(2)
      CHARACTER        UFM*23   ,UWM*25   ,UIM*29   ,SFM*25
      COMMON /XMSSG /  UFM      ,UWM      ,UIM      ,SFM
      COMMON /SADDX /  NOMAT    ,LLCORE   ,MCBA(7)  ,ITYPA    ,ALPHA(4),
     1                 MCBB(7)  ,ITYPB    ,BETA(4)  ,MCBCDE(36),MCBX(7)
      COMMON /MGIVXX/  DLMDAS
      COMMON /BLANK /  IPROB(2) ,NUMMOD   ,ICASE    ,XLMDAS
     1       /GIVN  /  DUM(100) ,N        ,LFREQ    ,ORDER    ,D1      ,
     2                 HFREQ    ,D2       ,NV       ,D3       ,D4      ,
     3                 NFR
     4       /NTIME /  LNTIME   ,TCONS(15)
     5       /REGEAN/  IM(7)    ,IK(7)    ,IEV(7)   ,SCR1     ,SCR2    ,
     6                 SCR3     ,SCR4     ,SCR5     ,LCORE    ,RMAX    ,
     7                 RMIN     ,MZ       ,NEV      ,EPSI     ,RMINR   ,
     8                 NE       ,NIT      ,NEVM     ,SCR6     ,SCR7    ,
     9                 NFOUND   ,LAMDA    ,IBUCK    ,NSYM
     O       /REIGKR/  OPTION
     1       /SYSTEM/  SYSBUF   ,NOUT     ,NOGO     ,KSYS(51) ,JPREC
     2       /ZZZZZZ/  CORE(1)
      COMMON /CONDAS/  PI       ,TWOPI    ,RADEG    ,DEGRA    ,FPS
      COMMON /PACKX /  ITP1     ,ITP2     ,IIP      ,JJP      ,INCRP
      COMMON /UNPAKX/  ITU      ,IIU      ,JJU      ,INCRU
      EQUIVALENCE      (BETA(1),DBETA(1)) ,(ALPHA(1),DALPHA(1)),
     1                 (SLMDAS  ,DLMDAS ) ,(TCONS(8),MB(1)   ),
     2                 (CORE(1),DCORE(1)) ,(ICORE(1),CORE(1) ),
     3                 (TCONS(4),APC    ) ,(TCONS(5),APU     )
      DATA     NAME /  4HGIVE   ,4HNS     ,4HBEGI   ,4HNS    /,
     1         MGIV /  4HMGIV   /         ,END   /   4HENDS  /,
     2         ICR1 ,  ICR2     /301, 302 /
C
C
      CALL CONMSG (NAME,4,0)
      I   = 0
      KAA = ICORE(  1)
      MAA = ICORE(I+2)
      PHIA= ICORE(I+3)
      DO 50 I = 1,4
   50 EIGR(I) = ICORE(I+3)
      NNV = NV
      NZ  = KORSZ(CORE(1))
      IBUF1 = NZ - 3 - SYSBUF
      IBUF2 = IBUF1  - SYSBUF
      IX(1) = KAA
      CALL RDTRL (IX)
      IF (IX(1) .GT. 0) GO TO 70
      WRITE  (NOUT,60) SFM,IX,KAA,MAA,PHIA
   60 FORMAT (A25,' FROM GIVENS.  FILE ERROR,  TRAIL =',5I5,2I8, /5X,
     1       'KAA,MAA,PHIA = ',3I5)
      CALL ERRTRC ('GIVENS  ',60)
   70 AN = IX(2)
C
C     CHECK THE CORE SIZE REQUIREMENT FOR WILVEC/VALVEC BEFORE GOING
C     BLINDLY INTO EIGENVALUE COMPUTATION AND EVENTUALLY STOP DUE TO
C     INSUFFICIENT CORE IN THOSE ROUTINES.
C     PRESENTLY CDC IS USING D.P. IN GIVENS COMPUTATION.  IF CDC VERSION
C     IS MODIFIED TO USE S.P., 19 IN THE FOLLOWING FORMULA SHOULD CHANGE
C     TO 10. (COMMENT FROM G.CHAN/UNISYS)
C
      N   = (9*JPREC+1)*IX(2) + 2*SYSBUF - NZ
      IF (N .GT. 0) GO TO 120
      AZ  = NZ - (3*JPREC+1)*IX(2) - 2*SYSBUF
      AZ  = AZ/JPREC
      AM  = SQRT(2.0*AZ)
      AK  = AN - AM
      AN2 = AN**2
      AMB = MB(JPREC)
      AV  = NV
      ANV = AN*AV
      AV2 = AV**2
      T1  = AMB*AN*(3.0*(AN2+ANV) + AV2)
      T23 = APU*(10.0*AN2 + 5.0*ANV)
      T2  = APC*( 5.0*AN2 + 3.0*ANV + AV2) + T23
      T3  = 0
      IF (AM .LT. AN) T3 = T23+.5*(APC+APU)*AK*(AN2-AK*(AN+.5+AK/3.)+AN)
      T   = (T1+T2+T3)*1.0E-6
      N   = AN
      M   = AM
      WRITE  (NOUT,100) UIM,T,N,M
  100 FORMAT (A29,' 2016, GIVENS TIME ESTIMATE IS ',I8,' SECONDS.',
     1       /36X,'PROBLEM SIZE IS',I8,', SPILL WILL OCCUR FOR THIS ',
     2       'CORE AT A PROBLEM SIZE OF',I8,2H .)
      IF (T.GT.2000 .OR. N.GT.1000) WRITE (NOUT,110) UIM
  110 FORMAT (A29,', FEER METHOD WOULD BE MORE EFFICIENT FOR PROBLEM ',
     1       'OF THIS SIZE',/)
      CALL TMTOGO (I)
      IF (I .GE. T) GO TO 200
      IP1  =-50
      FILE = T
      GO TO 180
  120 WRITE  (NOUT,150) UIM,IX(2),IX(2),N
  150 FORMAT (A29,' 3008, INSUFFICIENT CORE FOR GIVENS METHOD.', /5X,
     1       'MATRIX SIZE IS',I5,3H BY,I5,'.  ADDITIONAL CORE OF',I7,
     2       ' WORDS IS NEEDED.', /5X,'OR SWITCH TO INVPWR OR FEER ',
     3       'METHOD.')
      CALL MESAGE (-37,0,NAME)
  180 CALL MESAGE (IP1,FILE,NAME)
C
C     CHOLESKI DECOMPOSE  MAA
C
  200 IF (OPTION .NE. MGIV) GO TO 250
      NOMAT   = 2
      MCBA(1) = KAA
      MCBB(1) = MAA
      CALL RDTRL (MCBA)
      CALL RDTRL (MCBB)
      MCBX(1) = ICR1
      MCBX(2) = MCBA(2)
      MCBX(3) = MCBA(3)
      MCBX(4) = MCBA(4)
      MCBX(5) = JPREC
      MCBX(6) = 0
      MCBX(7) = 0
      DALPHA(1) = 0.0D0
      DALPHA(2) = 0.0D0
      DBETA(1)  = 0.0D0
      DBETA(2)  = 0.0D0
      IF (JPREC .EQ. 2) GO TO 210
      SLMDAS = XLMDAS
      ALPHA(1) = 1.0
      BETA(1)  = SLMDAS
      ITYPA = 1
      ITYPB = 1
      GO TO 220
  210 DLMDAS = XLMDAS
      DALPHA(1) = 1.0D0
      DBETA(1)  = DLMDAS
      ITYPA = 2
      ITYPB = 2
  220 LLCORE = NZ
      CALL SADD (CORE,CORE)
      CALL WRTTRL (MCBX)
      IFILE1 = ICR1
      IFILE2 = MAA
      GO TO 260
  250 IFILE1 = MAA
      IFILE2 = KAA
  260 CALL FACTOR (IFILE1,SCR3,-SCR4,SCR5,SCR6,SCR7)
C
C     C  IS ON SCR3
C
C     CHANGE SIGNS OF THE OFF-DIAGONAL TERMS OF C AS SDCOMP HAS THEM
C     REVERSED.
C
      IP1   = -5
      FILE  = SCR3
      IX(1) = SCR3
      CALL RDTRL (IX)
      IX(5) = JPREC
      ITP1  = IX(5)
      ITP2  = ITP1
      ITU   = ITP1
      INCRP = 1
      INCRU = 1
      NCOL  = IX(2)
      IX(1) = SCR7
      IX(2) = 0
      IX(6) = 0
      IX(7) = 0
      CALL GOPEN (SCR3,CORE(IBUF1+1),0)
      CALL GOPEN (SCR7,CORE(IBUF2+1),1)
      DO 400 L = 1,NCOL
      IIU = 1
      JJU = NCOL
      CALL UNPACK (*180,SCR3,CORE)
      IF (ITU .EQ. 2) GO TO 320
      DO 300 K = 1,NCOL
      CORE(K) = -CORE(K)
  300 CONTINUE
      CORE(L) = -CORE(L)
      GO TO 350
  320 DO 340 K = 1,NCOL
      DCORE(K) = -DCORE(K)
  340 CONTINUE
      DCORE(L) = -DCORE(L)
  350 IIP = IIU
      JJP = JJU
      CALL PACK (CORE,SCR7,IX)
  400 CONTINUE
      CALL CLOSE (SCR3,1)
      CALL CLOSE (SCR7,1)
      CALL WRTTRL (IX)
C
C     C IS NOW ON SCR7
C
C     INVERT  C
C
      CALL INVERT (SCR7,SCR5,SCR6)
C
C     C INVERSE IS ON SCR5
C
C
C     GET C INVERSE TRANSPOSE ON SCR6
C
C     CALL TRANP1 (SCR5,SCR6,4,SCR4,SCR3,SCR7,ICR1,0,0,0,0)
C     GINO UNITS    308, 305,   304, 303, 204, 301
C                   ARE THESE UNITS AVAILABEL?    , 306, 307, 309
C                                                  SCR1,SCR2, EMPTY
C
C     TRANP1 SHOULD BE 60 PERCENT FASTER BY ADDING 3 MORE SCRATCH FILES
C
      CALL TRANP1 (SCR5,SCR6,7,SCR4,SCR3,SCR7,ICR1,SCR1,SCR2, 309,0)
C
C     COMPUTE  J
C
      CALL SSG2B (IFILE2,SCR6,0,SCR5,0,JPREC,1,SCR4)
      CALL SSG2B (SCR6  ,SCR5,0,SCR4,1,JPREC,1,SCR3)
C
C     J IS ON SCR4
C
C     EXTRACT EIGENVALUES
C
      CALL VALVEC
C
C     TRANSFORM
C
      CALL SSG2B (SCR6,SCR5,0,SCR4,0,JPREC,1,SCR7)
C
C     MERGE MODES AND FREE BODY MODES
C
      CALL READ6 (ICR2,SCR4,NFR,PHIA)
      ICORE(1)= NNV
      NAME(3) = END
      CALL CONMSG (NAME,3,0)
      RETURN
      END

      SUBROUTINE GP1
C
C     GP1  BUILDS THE FOLLOWING DATA BLOCKS--
C       1. GRID POINT LIST (GPL)
C       2. EXTERNAL INTERNAL GRID POINT EQUIVALENCE TABLE (EQEXIN)
C       3. GRID POINT DEFINITION TABLE (GPDT)
C       4. COORDINATE SYSTEM TRANSFORMATION MATRICES (CSTM)
C       5. BASIC GRID POINT DEFINITION TABLE (BGPDT)
C       6. SCALAR INDEX LIST (SIL)
C
C     THE FOLLOWING CARDS ARE READ BY GP1--
C       1. GRID
C       2. CELASI, CDAMPI, CMASSI  (I=1,2,3,4)
C       3. SPOINT
C       4. SEQGP   (SEQEP IS PROCESSED IN DPD1)
C       5. CORDIJ  (I=1,2,  J=R,S,C)
C
C     IMPORTANT
C     =========
C     REVISED  7/89 BY G.CHAN/UNISYS, TO ALLOW GRID, SCALAR AND EXTRA
C     POINT EXTERNAL ID UP TO 8 DIGITS FOR ALL 32-BIT MACHINES
C     PREVIOUSLY, ID OF 2000000 IS THE UPPER LIMIT FOR IBM AND VAX
C
C     REVISED  8/89 BY G.CHAN/UNISYS, AS PART OF THE EFFORT TO ALLOW A
C     NASTRAN JOB TO EXCEED 65535 LIMIT.
C     NORMALLY, IF GRID POINTS OR SCALAR POINTS DO NOT HAVE VERY LARGE
C     EXTERNAL ID NUMBERS, THEIR ID NOS. ARE MULTIPLIED BY 1000, SO THAT
C     999 ADDITIONAL POINTS CAN SQUEEZE IN VIA SEQGP CARDS. (NOTE - A
C     7- OR 8-DIGIT ID NO., TIMES 1000, EXCEEDS A 32-BIT WORD COMPUTER
C     HARDWARE LIMIT). THIS MULTIPLY FACTOR IS NOW ADJUSTABLE, 1000,100,
C     OR 10, SO THAT ADDITIONAL DIGITS CAN BE USED FOR THE EXTERNAL GRID
C     OR SCALAR POINTS IN CASE THERE ARE LIMITTED SEQGP CARDS PRESENT.
C     THIS VARIABLE MULTIPLIER (10,100, OR 1000) IS ALSO RECORDED IN THE
C     3RD WORD OF THE HEADER RECORD OF THE GPL DATA BLOCK FOR LATER USE.
C     THE ACTUAL FACTOR OF THE MULTIPLIER IS ALSO MACHINE DEPENDENT.
C     UNIVAC, A 36-BIT MACHINE, CAN HAVE A MULTIPLIER OF 100 OR 1000.
C     OTHER 60- OR 64- BIT MACHINES, THE MULTIPLIER REMAINS AT 1000
C     IF THE MULTIPLIER IS 1000, THE SEQGP AND SEQEP CARDS, AS BEFORE,
C     CAN HAVE 4 SEQID LEVELS, SUCH AS XXX.X.X.X
C     IF THE MULTIPLIER IS 100, SEQGP AND SEQEP CARDS ARE LIMITED TO
C     3 SEQID LEVELS, XXX.X.X
C     FINALLY, IF MULTIPLIER IS 10, SEQGP AND SEQEP ARE LIMITED TO XXX.X
C
C     SPECIAL CONSIDERATION FOR THE AXISYM. AND HYDROELAS. PROBLEMS - 10
C     IS USED FOR THE MULTIPLIER, AND THEREFOR A ONE SEQID LEVEL IS
C     AVAILABLE. PREVIOUSLY, SEQGP CARDS WERE NOT USED IN AXISYM. AND
C     HYDROELAS. PROBLEMS, AND NO USER WARNING MESSAGE PRINTED
C
C     NO ADJUSTABLE MULTIPLY FACTOR FOR SUBRSTRUCTURING (MULT=1000,
C     SEE ALSO SGEN)
C
C     THE 65535 LIMITATION INVOLVES ONLY A SAMLL CHANGE IN STA 973
C
      EXTERNAL        RSHIFT
      INTEGER         RD,WRT,CLS,FILE,ELEM,AXIC,Z,SYSBUF,BUF1,BUF2,
     1                BUF3,GEOMP,GPL,EQEXIN,GPDT,CSTM,BGPDT,SIL,SCR1,
     2                SCR2,WRTREW,RDREW,A,SPOINT,FLAG,GRID,CLSREW,
     3                SEQGP,GPFL,CORD,CORDIJ,GP1AH,GEOM1,GEOM2,PTR,
     4                SOLV,SOLVP,SCALPT,TYPE,OFFSET,RSHIFT
      REAL            LENGTH
      DIMENSION       A(34),AA(34),AB(3),AC(3),AI(3),AJ(3),AK(3),AX(3),
     1                AR(3),SPOINT(2),GRID(2),SEQGP(2),CORDIJ(12),
     2                CORD(6),GP1AH(2),SCALPT(2),ZZ(1),MCB(7)
      CHARACTER*29    LVL1,LVL2
      CHARACTER       UFM*23,UWM*25,UIM*29
      COMMON /XMSSG / UFM,UWM,UIM
      COMMON /BLANK / LUSET,NOGPDT,NOCSTM
      COMMON /CONDAS/ PI,TWOPI,RADEG,DEGRA,S4PISQ
      COMMON /ZZZZZZ/ Z(1)
      COMMON /SYSTEM/ KSYSTM(100)
      COMMON /SETUP / NFILE(6),PTR
      COMMON /GPTA1 / NELEM,LASTX,INCRX,ELEM(1)
      COMMON /NAMES / RD,RDREW,WRT,WRTREW,CLSREW,CLS
      EQUIVALENCE     (KSYSTM( 1),SYSBUF), (KSYSTM( 2),IOUT ),
     1                (KSYSTM(24),ICFIAT), (KSYSTM(27),AXIC ),
     2                (KSYSTM(38),IAXIF ), (KSYSTM(40),NBPW ),
     3                (KSYSTM(56),ITHERM), (KSYSTM(69),ISUBS)
      EQUIVALENCE     (Z( 1),ZZ(1)), (A( 1),AA(1)), (A( 4),AB(1)),
     1                (A( 7),AC(1)), (A(10),AI(1)), (A(13),AJ(1)),
     2                (A(16),AK(1)), (A(19),AX(1)), (A(22),AR(1)),
     3                (NOCSTM,IFL ), (GEOMP,GEOM1), (MCB(2),KN  )
      EQUIVALENCE     (IGPDT,ICSDT)
      DATA    GEOM1 / 101/, GEOM2 / 102/,
     1        GPL   / 201/, EQEXIN/ 202/, GPDT  / 203/,
     2        CSTM  / 204/, BGPDT / 205/, SIL   / 206/,
     3        SCR1  / 301/, SCR2  / 302/
      DATA    GP1AH / 4HGP1 , 4H    /,
     1        CORD  / 6,6,6,13,13,13/,
     2        GRID  / 4501,45  /,
     3        SEQGP / 5301,53  /,
     4        CORDIJ/ 1701,17,1801,18,1901,19,2001,20,2101,21,2201,22/,
     5        SCALPT/ 5551,49  /
      DATA    MCB   / 7*0      /,
     1        LARGE / 100000000/,
     2        LVL1  / '3  I.E.  XXX.X.X.X TO XXX.X.X' /,
     3        LVL2  / '2  I.E.  XXX.X.X.X TO XXX.X  ' /
C
C     PERFORM GENERAL INITIALIZATION
C
      CALL DELSET
      NZ     = KORSZ(Z)
      BUF1   = NZ - SYSBUF - 2
      BUF2   = BUF1 - SYSBUF
      BUF3   = BUF2 - SYSBUF
      NOGO   = 0
      NOCSTM = 0
      NOGPDT =-1
      NOGMP1 = 1
      MAXA1  = 0
      MULT   = 1000
      AXI    = 0
      IF (AXIC.NE.0 .OR. IAXIF.NE.0) AXI = 1
      IF (AXI   .NE. 0) MULT = 10
      IF (ISUBS .NE. 0) MULT = 1000
      IMAX = LARGE
      IF (NBPW .EQ. 32) IMAX =  2147483
      IF (NBPW .EQ. 36) IMAX = 34359738
C         2147483=2**31/1000   34359738=2**35/1000
C
C     READ SCALAR ELEMENT CONNECTION CARDS (IF PRESENT).
C     EXTRACT SCALAR POINTS AND WRITE THEM ON SCR2.
C
      FILE = SCR2
      CALL OPEN (*1170,SCR2,Z(BUF2),WRTREW)
      NOSCLR= 0
      M8    =-8
      A(11) =-1
      DO 30 K = 12,16
   30 A(K) = 0
      CALL PRELOC (*80,Z(BUF1),GEOM2)
      I = 1
      DO 60 I = 1,LASTX,INCRX
      KK = ELEM(I+10)
      IF (KK .EQ. 0) GO TO 60
      CALL LOCATE (*60,Z(BUF1),ELEM(I+3),FLAG)
      NN = ELEM(I+5)
   40 CALL READ (*1180,*60,GEOM2,A,NN,0,FLAG)
      DO 50 K = 3,4
      IF (A(K).EQ.0 .OR. (KK.EQ.1 .AND. A(K+2).NE.0)) GO TO 50
      A(10)  = A(K)
      NOSCLR = 1
      CALL WRITE (SCR2,A(10),1,0)
   50 CONTINUE
      GO TO 40
   60 CONTINUE
C
C     COPY SCALAR POINTS DEFINED ON SPOINT CARDS (IF PRESENT) ONTO SCR2.
C
      CALL LOCATE (*80,Z(BUF1),SCALPT,FLAG)
      NOSCLR = 1
      CALL READ   (*1180,*70,GEOM2,Z,BUF2-1,1,N)
      CALL MESAGE (M8,0,GP1AH)
   70 CALL WRITE  (SCR2,Z,N,0)
C
C     CLOSE FILES. IF SCALAR POINTS PRESENT, SORT LIST.
C     THEN DISCARD DUPLICATES AND WRITE UNIQUE LIST ON SCR2.
C
   80 CALL WRITE (SCR2,0,0,1)
      CALL CLOSE (SCR2,CLSREW)
      CALL CLOSE (GEOM2,CLSREW)
      IF (NOSCLR .EQ. 0) GO TO 110
      NFILE(1) = GPDT
      NFILE(2) = BGPDT
      NFILE(3) = SIL
      CALL OPEN  (*1170,SCR2,Z(BUF1),RDREW)
      CALL SORTI (SCR2,0,1,1,Z,BUF1-1)
      CALL CLOSE (SCR2,CLSREW)
      FILE = NFILE(6)
      CALL OPEN (*1170,FILE,Z(BUF1),RDREW)
      CALL OPEN (*1170,SCR2,Z(BUF2),WRTREW)
      LAST = -1
   90 CALL READ (*1180,*100,FILE,A(10),1,0,FLAG)
      IF (A(10) .EQ. LAST) GO TO 90
      CALL WRITE (SCR2,A(10),1,0)
      LAST = A(10)
      GO TO 90
  100 CALL WRITE (SCR2,0,0,1)
      CALL CLOSE (SCR2,CLSREW)
      CALL CLOSE (FILE,CLSREW)
      CALL OPEN  (*1170,SCR2,Z(BUF3),RDREW)
C
C     READ GRID ENTRIES (IF PRESENT).
C     MERGE GRID AND SCALAR NOS.
C     CREATING LIST IN CORE OF EXTERNAL NO., MULT * EXTERNAL NO.
C     WRITE 7-WORD GRID AND SCALAR ENTRIES ON SCR1.
C
  110 A(1)  = LARGE
      A(10) = LARGE
      FILE  = SCR1
      IF (MAXA1 .EQ. 0) CALL OPEN (*1170,SCR1,Z(BUF2),WRTREW)
      I = -1
      NOGRID = 0
      IF (MAXA1 .EQ. 0) CALL PRELOC (*190,Z(BUF1),GEOM1)
      CALL LOCATE (*200,Z(BUF1),GRID,FLAG)
      NOGRID = 1
      CALL READ  (*1180,*1200,GEOM1,A,8,0,FLAG)
      CALL WRITE (SCR1,A,7,0)
  120 IF (NOSCLR .EQ. 0) GO TO 140
      CALL READ  (*1180,*1200,SCR2,A(10),1,0,FLAG)
      CALL WRITE (SCR1,A(10),7,0)
  130 IF (NOGRID .EQ. 0) GO TO 160
      IF (NOSCLR .EQ. 0) GO TO 140
      IF (A(1) -  A(10)) 140,1250,160
C
C     GRID NO. .LT. SCALAR NO.
C
  140 I = I + 2
      Z(I) = A(1)
C
C     GRID POINT EXTERNAL ID * MULT IS LIMITED TO COMPUTER MAXIMUM
C     INTEGER SIZE
C
      IF (A(1).LE.IMAX .OR. AXI.NE.0) GO TO 142
      IF (A(1) .GT. MAXA1) MAXA1 = A(1)
      GO TO 146
  142 Z(I+1) = MULT*A(1)
  146 CALL READ  (*1180,*150,GEOM1,A,8,0,FLAG)
      CALL WRITE (SCR1,A,7,0)
      GO TO 130
  150 NOGRID = 0
      A(1) = LARGE
      IF (NOSCLR .EQ. 0) GO TO 180
C
C     SCALAR NO. .LT. GRID NO.
C
  160 I = I + 2
      Z(I) = A(10)
C
C     SCALAR POINT EXTERNAL ID * MULT IS LIMITED TO COMPUTER MAXIMUM
C     INTEGER SIZE
C
      IF (A(10).LE.IMAX .OR. AXI.NE.0) GO TO 162
      IF (A(10) .GT. MAXA1) MAXA1 = A(10)
      GO TO 166
  162 Z(I+1) = MULT*A(10)
  166 CALL READ  (*1180,*170,SCR2,A(10),1,0,FLAG)
      CALL WRITE (SCR1,A(10),7,0)
      GO TO 130
  170 NOSCLR = 0
      A(10)  = LARGE
      IF (NOGRID .EQ. 0) GO TO 180
      GO TO 140
C
C     LIST COMPLETE ONLY IF MAXA1 .LE. ZERO
C
C     IF MAXA1 IS .GT. ZERO, SOME LARGE GRID OR SCALAR POINTS HAD BEEN
C     LEFT OUT IN LIST. MAXA1 IS THE LARGEST GRID OR SCALAR POINT
C     EXTERNAL ID.  RESET MULT AND REPEAT COMPILING LIST
C
  180 IF (MAXA1 .LE. 0) GO TO 185
      IF (ISUBS .NE. 0) GO TO 183
      CALL REWIND (SCR1)
      CALL REWIND (GEOM1)
      IF (NOSCLR .NE. 0) CALL REWIND (SCR2)
      MULT = 100
      IF (MAXA1 .GT. IMAX*10) MULT = 10
      IMAX  = (IMAX/MULT)*1000
      MAXA1 = -1
CWKBR CALL PAGE (-3)
      CALL PAGE2(-3)
      IF (MULT .EQ. 100) WRITE (IOUT,182) UWM,LVL1
      IF (MULT .EQ.  10) WRITE (IOUT,182) UWM,LVL2
  182 FORMAT (A25,' 2140A, DUE TO THE PRESENCE OF ONE OR MORE GRID OR ',
     1       'SCALAR POINTS WITH VERY LARGE EXTERNAL ID''S, THE SEQGP' ,
     2       /5X,'AND SEQEP CARDS, IF USED, ARE FORCED TO REDUCE FROM ',
     3       'ALLOWABLE 4 SEQID LEVELS TO ',A29,/)
      GO TO 110
C
  183 WRITE  (IOUT,184) UFM
  184 FORMAT (A23,' 2140B, EXTERNAL GRID OR SCALAR POINT ID TOO BIG')
      CALL MESAGE (-61,0,0)
C
  185 N    = I
      NEQEX= N
      N1   = N + 1
      N2   = N + 2
      IGPDT= N2
      ILIST= N2
      KN   = N1/2
      CALL CLOSE (SCR1,CLSREW)
      CALL CLOSE (SCR2,CLSREW)
      GO TO 210
C
C     NO GRID CARDS PRESENT-- TEST FOR ANY SCALAR PTS.
C
  190 NOGMP1 = 0
  200 IF (NOSCLR .EQ. 0) GO TO 980
      GO TO 120
C
C     READ THE SEQGP TABLE (IF PRESENT)
C     FOR EACH ENTRY, FIND MATCH IN THE SORTED EXTERNAL GRID POINTS
C     AND REPLACE SEQUENCE NO. WITH SEQGP NO.
C
  210 NOSEQ  = 0
      NOGPDT = 1
      IF (NOGMP1 .EQ. 0) GO TO 260
      ASSIGN 230 TO NDX
      SPOINT(2) = 0
      IERR = 1
      ASSIGN 220 TO NERR
      CALL LOCATE (*250,Z(BUF1),SEQGP,FLAG)
      NOSEQ = 1
      IFAIL = 0
 2010 CALL READ (*1180,*2020,GEOMP,Z(N2),BUF1-1,1,FLAG)
      IFAIL = IFAIL + 1
      GO TO 2010
 2020 IF (IFAIL .EQ. 0) GO TO 2060
      NWDS = (IFAIL-1)*(BUF1-1) + FLAG
      WRITE  (IOUT,2040) UFM,NWDS
 2040 FORMAT (A23,' 3135, UNABLE TO PROCESS SEQGP DATA IN SUBROUTINE ',
     1       'GP1 DUE TO INSUFFICIENT CORE.', //5X,
     2       'ADDITIONAL CORE REQUIRED =',I10,7H  WORDS)
      CALL MESAGE (-61,0,0)
C
C     CHECK FOR MULTIPLE REFERENCES TO GRID (OR SCALAR) POINT ID NOS.
C     AND SEQUENCE ID NOS. ON SEQGP CARDS
C
 2060 K  = N2
      KK = N2 + FLAG - 1
      JJ = KK - 2
 2080 DO 2285 I = K,JJ,2
      IF (Z(I).LT.0 .OR. I.GE.KK) GO TO 2275
      II = I + 2
      IFAIL = 0
      DO 2270 J = II,KK,2
      IF (Z(I) .NE. Z(J)) GO TO 2270
      IF (IFAIL .NE.   0) GO TO 2260
      IFAIL = 1
      NOGO  = 1
      IF (K .NE. N2) GO TO 2110
      WRITE  (IOUT,2100) UFM,Z(I)
 2100 FORMAT (A23,' 3136, MULTIPLE REFERENCES TO GRID (OR SCALAR) POINT'
     1,      ' ID NO.',I9,'  ON SEQGP CARDS.')
      GO TO 2260
 2110 IDSEQ1 = Z(I)/1000
      IRMNDR = Z(I) - 1000*IDSEQ1
      IF (IRMNDR.NE.0 .AND. MULT.GE.10) GO TO 2140
      IF (AXI .NE. 0) GO TO 2130
      WRITE  (IOUT,2120) UFM,IDSEQ1
 2120 FORMAT (A23,' 3137, MULTIPLE REFERENCES TO SEQUENCE ID NO.',I6,6X,
     1       ' ON SEQGP CARDS.')
      GO TO 2260
 2130 IF (AXI .EQ. 1) WRITE (IOUT,2135) UFM
 2135 FORMAT (A23,' 3137A, SEQGP CARDS WITH MORE THAN ONE SEQID LEVEL ',
     1       'ARE ILLEGAL FOR AXISYSM. OR HYDROELAS. PROBLEM')
      AXI  = 2
      NOGO = 1
      GO TO 2260
 2140 IDSEQ2 = IRMNDR/100
      IRMNDR = IRMNDR - 100*IDSEQ2
      IF (IRMNDR.NE.0 .AND. MULT.GE.100) GO TO 2180
      WRITE  (IOUT,2160) UFM,IDSEQ1,IDSEQ2
 2160 FORMAT (A23,' 3137, MULTIPLE REFERENCES TO SEQUENCE ID NO.',I6,
     1        1H.,I1,5X,'ON SEQGP CARDS.')
      GO TO 2260
 2180 IDSEQ3 = IRMNDR/10
      IRMNDR = IRMNDR - 10*IDSEQ3
      IF (IRMNDR .NE. 0) GO TO 2220
      WRITE  (IOUT,2200) UFM,IDSEQ1,IDSEQ2,IDSEQ3
 2200 FORMAT (A23,' 3137, MULTIPLE REFERENCES TO SEQUENCE ID NO.',I6,
     1       1H.,I1,1H.,I1,4X,'ON SEQGP CARDS.')
      GO TO 2260
 2220 WRITE  (IOUT,2240) UFM,IDSEQ1,IDSEQ2,IDSEQ3,IRMNDR
 2240 FORMAT (A23,' 3137, MULTIPLE REFERENCES TO SEQUENCE ID NO.',I6,
     1        1H.,I1,1H.,I1,1H.,I1,'  ON SEQGP CARDS.')
 2260 Z(J) = -Z(J)
 2270 CONTINUE
C
 2275 IF (JJ.LT.KK .OR. MULT.EQ.1000) GO TO 2285
      L = Z(I)
      IF (MULT   .LE.   10) GO TO 2280
      IF (MOD(L,10) .NE. 0) GO TO 2276
      Z(I) = L/10
      GO TO 2285
 2276 IF (MAXA1 .EQ. 0) GO TO 2285
      MAXA1 = 0
      NOGO  = 1
      WRITE  (IOUT,2277) UFM
 2277 FORMAT (A23,' 2140B, ILLEGAL DATA IN SEQGP CARD, POSSIBLY CAUSED',
     1       ' BY LARGE GRID OR SCALAR POINTS')
      GO TO 2285
 2280 IF (MULT .EQ. 1) GO TO 2282
      IF (MOD(L,100) .NE. 0) GO TO 2276
      Z(I) = L/100
      GO TO 2285
 2282 IF (AXI .EQ. 0) CALL MESAGE (-37,0,NAM)
      IF (MOD(L,1000) .EQ. 0) GO TO 2285
      IF (AXI .EQ. 1) WRITE (IOUT,2135) UFM
      AXI  = 2
      NOGO = 1
 2285 CONTINUE
C
      IF (K .NE. N2) GO TO 2290
      JJ = KK
      K  = K + 1
      GO TO 2080
C
 2290 DO 2300 I = N2,KK,2
      IF (Z(I) .LT. 0) Z(I) = -Z(I)
 2300 CONTINUE
      IF (NOGO .EQ. 1) GO TO 2400
C
C     CHECK TO SEE IF ANY SEQUENCE ID NO. ON SEQGP CARDS IS THE SAME
C     AS A GRID (OR SCALAR) POINT ID NO. THAT HAS NOT BEEN RESEQUENCED
C
      DO 2390 I = K,KK,2
      IF (Z(I) .LT. 0) GO TO 2390
      IDSEQ1 = Z(I)/MULT
      IRMNDR = Z(I) - MULT*IDSEQ1
      IF (IRMNDR .NE. 0) GO TO 2390
      DO 2320 J = N2,KK,2
      IF (IDSEQ1 .EQ. Z(J)) GO TO 2390
 2320 CONTINUE
      DO 2340 J = 1,N1,2
      IF (IDSEQ1 .EQ. Z(J)) GO TO 2360
 2340 CONTINUE
      GO TO 2390
 2360 NOGO = 1
      WRITE  (IOUT,2380) UFM,IDSEQ1
 2380 FORMAT (A23,' 3138, SEQUENCE ID NO.',I6,' ON SEQGP CARDS IS THE ',
     1       'SAME AS A', /5X,'GRID (OR SCALAR) POINT ID NO. THAT HAS ',
     2       'NOT BEEN RESEQUENCED.')
 2390 CONTINUE
 2400 CONTINUE
      I = -1
  220 I = I + 2
      IF (I .GT. FLAG) GO TO 240
      A(1) = Z(N2+I-1)
      A(2) = Z(N2+I  )
      GO TO 1060
  230 Z(2*K) = A(2)
      GO TO 220
C
C     SORT THE CORE TABLE BY INTERNAL GRID PT NO
C     THUS FORMING THE GPL (EXTERNAL GRID PT NOS IN SORT BY INTERNAL NO)
C
  240 IF (NOGO .NE. 0) GO TO 1165
      CALL SORTI (0,0,2,2,Z,N1)
C
C     CLOSE GEOM1. WRITE THE GPL. FIRST RECORD IS A SINGE ENTRIED LIST
C     OF EXTERNAL GRID NOS. IN INTERNAL SORT. SECOND RECORD IS A DOUBLE
C     ENTRIED LIST OF EXTERAL GRID NO., SEQUENCE NO. (SORT IS INTERNAL).
C     ADD THE MULTIPLIER, MULT, TO THE 3RD WORD OF GPL HEADER RECORD
C
  250 IF (NOGMP1 .NE. 0) CALL CLOSE (GEOM1,CLSREW)
  260 CALL FNAME (GPL,A)
      FILE = GPL
      CALL OPEN (*1170,GPL,Z(BUF1),WRTREW)
      A(3) = MULT
      CALL WRITE (GPL,A,3,1)
      DO 270 I = 1,N,2
  270 CALL WRITE (GPL,Z(I),1,0)
      CALL WRITE (GPL,0,0,1)
      CALL WRITE (GPL,Z,N1,1)
      CALL CLOSE (GPL,CLSREW)
      MCB(1) = GPL
      CALL WRTTRL (MCB)
C
C     FORM INTERNAL INDEX FOR EACH EXTERNAL GRID PT. NO.
C
      I = 2
      Z(I) = 1
      IF (N .EQ. 1) GO TO 310
      DO 290 I = 3,N,2
  290 Z(I+1) = Z(I-1) + 1
C
C     TEST TO SEE IF EXTERNAL GRID PT NOS ARE STILL IN EXTERNAL SORT
C     I.E., IF NO SEQGP TABLE, THEN SORT IS MAINTAINED
C     OTHERWISE, SORT ON EXTERNAL GRID NO.
C
      IF (NOSEQ .NE. 0) CALL SORTI (0,0,2,1,Z,N1)
C
C     DETERMINE IF THE GPDT CAN BE HELD IN CORE
C     NWDS= TOTAL NO OF WORDS IN THE GPDT
C     M= MAX NO OF ENTRIES CORE CAN HOLD WITH ONE BUFFER OPEN
C     IF NWDS/7.LE.M,CORE WILL HOLD THE GPDT
C     OTHERWISE THE FILE SORT ROUTINE WILL BE USED
C
  310 NWDS = 7*KN
      M    = (BUF1-N1)/7
      GPFL = 0
      IF (KN .GT. M) GPFL = 7
      FILE = SCR1
C
C     READ THE GRID AND SPOINT TABLES FROM SCR1
C     REPLACE THE EXTERNAL GRID PT NO WITH THE INTERNAL INDEX
C     IF CORE WILL HOLD THE GPDT, USE THE INTERNAL INDEX AS A POINTER
C     OTHERWISE, WRITE THE UNSORTED GPDT ON SCR2
C
      CALL OPEN (*1170,SCR1,Z(BUF1),RDREW)
      FILE = SCR2
      IF (GPFL .NE. 0) CALL OPEN (*1170,SCR2,Z(BUF2),WRTREW)
      FILE = SCR1
      ASSIGN 340 TO NDX
      IERR = 2
      ASSIGN 330 TO NERR
  330 CALL READ (*1180,*370,SCR1,A,7,0,FLAG)
      GO TO 1060
  340 IF (GPFL .NE. 0) GO TO 360
      J = N1 + 7*(A(1)-1)
      DO 350 K = 1,7
      I = J+K
  350 Z(I) = A(K)
      GO TO 330
  360 CALL WRITE (SCR2,A,7,0)
      GO TO 330
  370 IF (NOGO .NE. 0) GO TO 1165
      CALL CLOSE (SCR1,CLSREW)
C
C     OPEN OUTPUT FILE FOR GPDT AND WRITE HEADER DATA
C     IF GPDT IS IN CORE, WRITE IT OUT
C
      FILE = GPDT
      CALL FNAME (GPDT,A)
      CALL OPEN  (*1170,GPDT,Z(BUF1),WRTREW)
      CALL WRITE (GPDT,A,2,1)
      IF (GPFL .NE. 0) GO TO 390
      CALL WRITE (GPDT,Z(IGPDT),NWDS,1)
      GO TO 400
C
C     IF GPDT NOT IN CORE, CALL SORT
C
  390 NFILE(1) = SCR1
      NFILE(2) = CSTM
      NFILE(3) = BGPDT
      CALL CLOSE (SCR2,CLSREW)
      FILE = SCR2
      CALL OPEN  (*1170,SCR2,Z(BUF2),RDREW)
      CALL SORTI (SCR2,GPDT,7,1,Z(IGPDT),BUF2-IGPDT)
      CALL CLOSE (SCR2,CLSREW)
  400 CALL CLOSE (GPDT,CLSREW)
      MCB(1) = GPDT
      CALL WRTTRL (MCB)
C
C     READ THE CORDIJ TABLES INTO CORE (IF PRESENT)
C
      IFL = -1
      M   = ICSDT
      NOLIST = 0
      IF (NOGMP1 .EQ. 0) GO TO 810
      NDX   = BUF1 - 15
      NCORE = BUF1 - 15
      DO 420 I = ICSDT,BUF1
  420 Z(I) = 0
      FILE = GEOMP
      CALL PRELOC (*1170,Z(BUF1),GEOMP)
      DO 440 I = 1,6
      IJ = I + I - 1
      CALL LOCATE (*440,Z(BUF1),CORDIJ(IJ),FLAG)
      IFL = 1
  430 CALL READ (*1180,*440,GEOMP,Z(M),CORD(I),0,FLAG)
      M = M + 16
      IF (M .GT. NCORE) CALL MESAGE (-8,0,GP1AH)
      GO TO 430
  440 CONTINUE
      CALL CLOSE (GEOMP,CLSREW)
      M = M - 16
      NCSDT = M
C
C     TEST FOR PRESENCE OF ANY CORDIJ TABLES
C
      IF (IFL .EQ. -1) GO TO 810
C
C     REPLACE EXTERNAL GRID PT NO IN CORD1J ENTRIES (IF ANY)
C     WITH CORRESPONDING INTERNAL INDEX
C     SAVE A TABLE OF GRID PTS REFERENCED ON CORD1J ENTRIES
C
      JJ   = ICSDT
      ILIST= NCSDT + 16
      II   = ILIST - 1
      NCORE= BUF1  - 3
      IERR = 3
  470 IF (Z(JJ+2).NE.1) GO TO 510
      NOLIST = 1
      ASSIGN 480 TO NDX
      ASSIGN 485 TO NERR
      A(1) = Z(JJ+3)
      SPOINT(2) =  Z(JJ+1)
      GO TO 1060
  480 Z(JJ+3) = A(1)
      Z(II+1) = A(1)
  485 ASSIGN 490 TO NDX
      ASSIGN 495 TO NERR
      A(1) = Z(JJ+4)
      GO TO 1060
  490 Z(JJ+4) = A(1)
      Z(II+2) = A(1)
  495 ASSIGN 500 TO NDX
      ASSIGN 505 TO NERR
      A(1) = Z(JJ+5)
      GO TO 1060
  500 Z(JJ+5) = A(1)
      Z(II+3) = A(1)
  505 II = II+3
      IF (II .GT. NCORE) CALL MESAGE (-8,0,GP1AH)
  510 JJ = JJ + 16
      IF (JJ .LE. NCSDT) GO TO 470
      IF (NOGO .NE.   0) GO TO 1165
C
C     IF ANY CORD1J ENTRIES, PASS THE GPDT AND CREATE A TABLE OF THE
C     REFERENCED GRID PTS. THIS TABLE IS CALLED CSGP
C
      IF (NOLIST .EQ. 0) GO TO 550
      NLIST = II
      ICSGP = NLIST + 1
      CALL SORTI (0,0,1,1,Z(ILIST),ICSGP-ILIST)
      Z(ICSGP) = 0
      JJ = ILIST
      DO 530 KK = ILIST,NLIST
      IF (Z(KK+1) .EQ. Z(KK)) GO TO 530
      Z(JJ) = Z(KK)
      JJ = JJ + 1
  530 CONTINUE
      NLIST = JJ - 1
      ICSGP = JJ
      FILE  = GPDT
      CALL OPEN   (*1170,GPDT,Z(BUF1),RDREW)
      CALL FWDREC (*1180,GPDT)
      NCORE = BUF1 - 5
      I = ILIST
  540 CALL READ (*1180,*1200,GPDT,Z(JJ),7,0,FLAG)
      IF (Z(JJ) .NE. Z(I)) GO TO 540
      JJ = JJ + 5
      IF (JJ .GT. NCORE) CALL MESAGE (-8,0,GP1AH)
      I  = I + 1
      IF (I .LE. NLIST) GO TO 540
      NCSGP = JJ - 5
      CALL CLOSE (GPDT,CLSREW)
C
C     LOOP THRU THE CSDT SOLVING AS MANY COORDINATE SYSTEMS AS POSSIBLE
C     ON EACH PASS.
C
  550 NN = (NCSDT-ICSDT)/16 + 1
      SOLV  = 0
      SOLVP = 0
  560 II = ICSDT
  570 IF (Z(II+2)-2) 580,620,690
C
C     *****  TYPE = 1 *****
C     CHECK TO SEE IF EACH OF THE 3 REFERENCE GRID PTS IS IN BASIC SYS
C     IF SO,CALCULATE THE TRANSFORMATION TO BASIC AND SET COORD SYSTEM
C     AS SOLVED, IF NOT CONTINUE TO NEXT COORDINATE SYSTEM
C
  580 I = 0
  590 K = II + I
      J = ICSGP - 1
  600 IF (Z(J+1) .EQ. Z(K+3)) GO TO 610
      J = J + 5
      IF (J .LT. NCSGP) GO TO 600
      GO TO 1220
  610 IF (Z(J+2).NE.0) GO TO 700
      K = I*3
      AA(K+1) = ZZ(J+3)
      AA(K+2) = ZZ(J+4)
      AA(K+3) = ZZ(J+5)
      I = I+1
      IF (I .LE. 2) GO TO 590
      GO TO 1020
C
C     ***** TYPE = 2 *****
C     CHECK THE DEFINING LOCAL COORDINATE SYSTEM
C     IF BASIC, SOLVE AS IN TYPE=1
C     IF NOT BASIC, FIND THE REFERENCED COORD SYSTEM AND TEST IF THAT
C     SYSTEM IS SOLVED. IF YES, CALCULATE THE TRANSFORMATION TO BASIC
C     IF NO, CONTINUE THRU THE CSDT
C
  620 IF (Z(II+3) .NE. 0) GO TO 640
      DO 630 I = 1,9
      K = II + I
  630 AA(I) = ZZ(K+3)
      GO TO 1020
  640 I = ICSDT
  650 IF (Z(I) .EQ. Z(II+3)) GO TO 660
      I = I + 16
      IF (I .LE. NCSDT) GO TO 650
      GO TO 1230
  660 IF (Z(I+2).NE.3 .OR. Z(I+3).NE.0) GO TO 700
      K = 0
      ASSIGN 680 TO NDX
  670 L = K + II
      AX(1) = ZZ(L+4)
      AX(2) = ZZ(L+5)
      AX(3) = ZZ(L+6)
      IF (Z(I+1)-2) 990,1000,1010
  680 AA(K+1) = AR(1)
      AA(K+2) = AR(2)
      AA(K+3) = AR(3)
      K = K + 3
      IF (K .LE. 6) GO TO 670
      GO TO 1020
C
C     ***** TYPE = 3 *****
C     CHECK THE DEFINING LOCAL COORDINATE SYSTEM
C     IF BASIC, CONTINUE THRU CSDT
C     IF NOT BASIC, ERROR CONDITION
C
  690 IF (Z(II+3) .NE. 0) GO TO 1190
C
C     TEST FOR COMPLETION OF PASS THRU CSDT
C
  700 II = II + 16
      IF (II .LE. NCSDT) GO TO 570
C
C     LOOP THRU THE CSGP (IFPRESENT) AND TRANSFORM ALL
C     POSSIBLE GRID PTS TO BASIC
C
      IF (NOLIST .EQ. 0) GO TO 770
      JJ = ICSGP
  720 IF (Z(JJ+1) .EQ. 0) GO TO 760
      I = ICSDT
  730 IF (Z(JJ+1) .EQ. Z(I)) GO TO 740
      I = I + 16
      IF (I .LE. NCSDT) GO TO 730
      IERR = 6
      SPOINT(1) = Z(JJ  )
      SPOINT(2) = Z(JJ+1)
      GO TO 1190
  740 IF (Z(I+2).NE.3 .OR. Z(I+3).NE.0) GO TO 760
      AX(1) = ZZ(JJ+2)
      AX(2) = ZZ(JJ+3)
      AX(3) = ZZ(JJ+4)
      ASSIGN 750 TO NDX
      IF (Z(I+1)-2) 990,1000,1010
  750 ZZ(JJ+2) = AR(1)
      ZZ(JJ+3) = AR(2)
      ZZ(JJ+4) = AR(3)
      ZZ(JJ+1) = 0
  760 JJ = JJ + 5
      IF (JJ .LE. NCSGP) GO TO 720
C
C     TEST TO SEE IF ALL COORDINATE SYSTEMS SOLVED
C     IF NOT, TEST TO SEE IF ANY NEW SOLUTIONS ON LAST PASS
C     IF NONE, INCONSISTANT DEFINITION OF COORDINATE SYSTEMS
C     OTHERWISE LOOP BACK THRU THE CSDT
C
  770 IF (SOLV .EQ.    NN) GO TO 780
      IF (SOLV .EQ. SOLVP) GO TO 1240
      SOLVP = SOLV
      GO TO 560
C
C     WRITE THE CSTM
C
  780 CALL FNAME (CSTM,A)
      FILE = CSTM
      CALL OPEN  (*1170,CSTM,Z(BUF1),WRTREW)
      CALL WRITE (CSTM,A,2,1)
      DO 800 II = ICSDT,NCSDT,16
      CALL WRITE (CSTM,Z(II),2,0)
      CALL WRITE (CSTM,Z(II+4),12,0)
  800 CONTINUE
      CALL CLOSE (CSTM,CLSREW)
      NOCSTM = NN
      MCB(3) = NN
      MCB(1) = CSTM
      CALL WRTTRL (MCB)
C
C     OPEN EQEXIN AND WRITE HEADER RECORD.
C     THEN WRITE FIRST RECORD (PAIRS OF EXTERNAL GRID NO., INTERNAL NO.
C     IN EXTERNAL SORT).
C
  810 FILE = EQEXIN
      CALL OPEN  (*1170,EQEXIN,Z(BUF1),WRTREW)
      CALL FNAME (EQEXIN,A)
      CALL WRITE (EQEXIN,A,2,1)
      CALL WRITE (EQEXIN,Z,N1,1)
      CALL CLOSE (EQEXIN,CLS)
C
C     A LIST OF DEGREES OF FREEDOM FOR EACH GRID OR SCALAR POINT IS
C     FORMED BEGINNING AT Z(ILIST) BY READING GEOM2 AND USING THE
C     CONNECTION INFORMATION IN CONJUNCTION WITH THE ELEM TABLE IN
C     /GPTA1/.
C
      FILE   = GEOM2
      ILIST0 = ILIST - 1
      NLIST  = ILIST + (NEQEX+1)/2
      IF (NLIST .GE. BUF3) CALL MESAGE (-8,0,GP1AH)
      DO 8102 I = ILIST,NLIST
      Z(I) = 0
 8102 CONTINUE
      JERR = 0
      CALL OPEN   (*8130,GEOM2,Z(BUF1),RDREW)
 8103 CALL FWDREC (*1180,GEOM2)
 8104 CALL ECTLOC (*8130,GEOM2,A,I)
C
C     ELEMENT TYPE LOCATED--PREPARE TO PROCESS EACH ELEMENT
C
      IF (ELEM(I+9) .EQ. 0) GO TO 8103
      J1 = ELEM(I+12)
      NREAD = J1 + ELEM(I+9) - 1
      NSKIP =-(ELEM(I+5 ) - NREAD)
      MAXDOF=  ELEM(I+24)
      ITYPE =  ELEM(I+2 )
C
C     READ CONNECTION DATA FOR ELEMENT AND LOCATE EXT. GRID NBR IN
C     EQEXIN UPDATE DOF LIST FOR EACH GRID NBR
C
 8110 CALL READ (*1180,*8104,GEOM2,A,NREAD,0,M)
      DO 8128 I = J1,NREAD
      IF (A(I) .EQ. 0) GO TO 8128
      CALL BISLOC (*8122,A(I),Z,2,KN,K)
      J = ILIST0 + Z(K+1)
      IF (ITYPE.GE.76 .AND. ITYPE.LE.79) GO TO 8115
C
C     STRUCTURE ELEMENT AND OTHERS
C
      IF (Z(J) .LT. 0) GO TO 8124
      Z(J) = MAX0(Z(J),MAXDOF)
      GO TO 8128
C
C     FLUID ELEMENT (CFHEX1,CFHEX2,CFWEDGE,CFTETRA)
C
 8115 IF (Z(J) .GT. 0) GO TO 8124
C
      Z(J) = -1
      GO TO 8128
 8122 WRITE  (IOUT,8123) UFM,A(1),A(I)
 8123 FORMAT (A23,' 2007, ELEMENT',I8,' REFERENCES UNDEFINED GRID ',
     1       'POINT',I8)
      JERR = JERR + 1
      GO TO 8128
 8124 WRITE  (IOUT,8125) UFM,A(I)
 8125 FORMAT (A23,' 8011, GRID POINT',I8,' HAS BOTH STRUCTURE AND ',
     1       'FLUID ELEMENTS CONNECTED')
      JERR = JERR + 1
 8128 CONTINUE
      CALL READ (*1180,*8104,GEOM2,A,NSKIP,0,M)
      GO TO 8110
C
C     END-OF-FILE ON GEOM2---IF FATAL ERRORS, TERMINATE
C
 8130 CONTINUE
      IF (JERR .NE. 0) CALL MESAGE (-61,A,Z)
C
C     OPEN BGPDT AND SIL. WRITE HEADER RECORDS. OPEN GPDT. SKIP HEADER.
C
      OFFSET = RSHIFT(KN,5)
      CALL FNAME (BGPDT,A)
      CALL FNAME (SIL,A(3))
      FILE = BGPDT
      CALL OPEN (*1170,BGPDT,Z(BUF1),WRTREW)
      FILE = SIL
      CALL OPEN (*1170,SIL,Z(BUF2),WRTREW)
      FILE = GPDT
      CALL OPEN   (*1170,GPDT,Z(BUF3),RDREW)
      CALL FWDREC (*1180,GPDT)
      CALL WRITE  (BGPDT,A,2,1)
      CALL WRITE  (SIL,A(3),2,1)
      LUSET = 1
C
C     READ AN ENTRY FROM THE GPDT.
C     TEST FOR DEFINING COORDINATE SYSTEM.
C
  820 CALL READ (*1180,*970,GPDT,A,7,0,FLAG)
      IF (A(2)) 910,880,830
C
C     COORDINATE SYSTEM NOT BASIC--
C     USE CSDT IN CORE TO TRANSFORM TO BASIC.
C
  830 IF (NOCSTM .EQ. -1) GO TO 850
      I = ICSDT
  840 IF (Z(I).EQ.A(2)) GO TO 860
      I = I + 16
      IF (I .LE. NCSDT) GO TO 840
  850 IERR = 6
      SPOINT(1) = A(1)
      SPOINT(2) = A(2)
      GO TO 1190
  860 AX(1) = AA(3)
      AX(2) = AA(4)
      AX(3) = AA(5)
      ASSIGN 870 TO NDX
      IF (Z(I+1)-2) 990,1000,1010
  870 AA(3) = AR(1)
      AA(4) = AR(2)
      AA(5) = AR(3)
C
C     GRID POINT NOW BASIC--
C     STORE DISPLACEMENT SYSTEM COORD. SYSTEM ID AND SET TYPE.
C     MAKE SURE DISPLACEMENT COORD. SYSTEM IS DEFINED.
C
  880 A(2) = A(6)
      TYPE = 1
      KHR  = ILIST0 + A(1)
      INCR = Z(KHR)
C
C     IF INCR NEGATIVE - SPECIAL HYDROELASTIC GRID POINT WITH SINGLE
C     DEGREE OF FREEDOM
C
      IF (INCR .LT. 0) GO TO 905
      IF (INCR .EQ. 0) INCR = 6
C
C     ///////////////////////////////
C
C     TEMP PATCH
C
      INCR = MAX0(INCR,6)
C
C     ///////////////////////////////
C
      IF (A(2).EQ.0 .AND. ITHERM.EQ.0) GO TO 920
C
C     IF A(2) WHICH EQUALS A(6) IS EQUAL TO -1 THEN A FLUID GRID POINT
C     AS CREATED BY IFP4 IS AT HAND AND HAS ONLY 1 DEGREE OF FREEDOM
C     ..... IF -HEAT- PROBLEM THEN ALL GRIDS HAVE 1 DEGREE OF FREEDOM.
C
      IF (A(2).EQ.(-1) .OR. ITHERM.GT.0) GO TO 905
      IF (NOCSTM .EQ. -1) GO TO 900
      DO 890 IJK = ICSDT,NCSDT,16
      IF (A(2) .EQ. Z(IJK)) GO TO 920
  890 CONTINUE
  900 NOGO = 1
      CALL MESAGE (30,104,A(2))
      GO TO 920
C
C     SCALAR POINT-- SET TYPE.
C
  905 A(2) = 0
      A(6) = 0
  910 TYPE = 2
      INCR = 1
C
C     WRITE ENTRY ON BGPDT AND SIL.
C
  920 CALL WRITE (BGPDT,A(2),4,0)
      CALL WRITE (SIL, LUSET,1,0)
C
C     REPLACE INTERNAL NO. IN EQEXIN WITH CODED SIL NO.
C     THEN INCREMENT SIL NO.
C
      NCODE = 10*LUSET + TYPE
      IF (NOSEQ .NE. 0) GO TO 925
      K = 2*A(1)
      IF (Z(K) - A(1)) 950,960,950
  925 NCODE = -NCODE
      LMT1  = MAX0(2*(A(1)-OFFSET),2)
      DO 930 K = LMT1,N1,2
      IF (Z(K) .EQ. A(1)) GO TO 960
  930 CONTINUE
      DO 940 K = 2,LMT1,2
      IF (Z(K) .EQ. A(1)) GO TO 960
  940 CONTINUE
  950 CALL MESAGE (-30,2,A)
  960 Z(K)  = NCODE
      LUSET = LUSET + INCR
      GO TO 820
C
C     CLOSE BGPDT AND SIL. WRITE TRAILERS.
C
  970 CALL CLOSE (BGPDT,CLSREW)
      CALL CLOSE (SIL,CLSREW)
      CALL CLOSE (GPDT,CLSREW)
      LUSET = LUSET - 1
C    2147483647   = 2**31-1
      IF (LUSET .LE. 2147483647) GO TO 974
      WRITE (IOUT,972) UFM,LUSET
  972 FORMAT (A23,' 3175, TOTAL NUMBER OF DEGREES OF FREEDOM IN THE ',
     1       'PROBLEM (',I11,' ) EXCEEDS 2,147,483,647 (I.E., '
     2       '2**31 - 1)')
  973 FORMAT (A29,' 3175, PROBLEM SIZE,',I8,' DOF''S, EXCEEDS THE OLD ',
     1       'LIMIT OF 65535.', /5X,'GOOD NEWS, JOB WILL CONTINUE')
      CALL MESAGE (-61,0,0)
  974 MCB(1) = BGPDT
      MCB(3) = 0
      CALL WRTTRL (MCB)
      MCB(1) = SIL
      MCB(3) = LUSET
      CALL WRTTRL (MCB)
C
C     IF GRID NOS. ARE RESEQUENCED, SWITCH SIGN ON CODED SIL NO.
C     WRITE SECOND RECORD OF EQEXIN. CLOSE FILE AND WRITE TRAILER.
C
      IF (NOSEQ .EQ. 0) GO TO 978
      DO 976 K = 2,N1,2
      Z(K) = -Z(K)
  976 CONTINUE
  978 FILE = EQEXIN
      CALL OPEN  (*1170,EQEXIN,Z(BUF1),WRT)
      CALL WRITE (EQEXIN,Z,N1,1)
      CALL CLOSE (EQEXIN,CLSREW)
      MCB(1) = EQEXIN
      MCB(3) = 0
      CALL WRTTRL (MCB)
      CALL SSWTCH (36,K)
      IF (K    .EQ. 1) CALL DIAG36 (Z,BUF1,GPL,SIL,EQEXIN)
      IF (NOGO .NE. 0) CALL MESAGE (-61,0,0)
      RETURN
C
C     ABNORMAL EXIT FROM GP1
C
  980 CALL CLOSE (SCR1,CLSREW)
      CALL CLOSE (GEOM1,CLSREW)
      NOCSTM = -1
      RETURN
C
C     ===============================================================
C
C     INTERNAL SUBROUTINE TO TRANSFORM A RECTANGULAR GRID PT TO BASIC
C     I POINTS TO THE CSDT ENTRY WHERE THE TRANSFORMATION IS DEFINED
C     THE GRID PT TO BE TRANSFORMED IS STORED AT AX(1,2,3)
C     THE TRANSFORMED GRID PT WILL BE STORED AT AR(1,2,3)
C
  990 AR(1) = ZZ(I+ 7)*AX(1) + ZZ(I+ 8)*AX(2) + ZZ(I+ 9)*AX(3) + ZZ(I+4)
      AR(2) = ZZ(I+10)*AX(1) + ZZ(I+11)*AX(2) + ZZ(I+12)*AX(3) + ZZ(I+5)
      AR(3) = ZZ(I+13)*AX(1) + ZZ(I+14)*AX(2) + ZZ(I+15)*AX(3) + ZZ(I+6)
      GO TO NDX, (680,750,870)
C
C     INTERNAL SUBROUTINE TO TRANSFORM A CYLINDRICAL GRID PT TO BASIC
C     R,THETA,Z IS STORED AX(1,2,3)
C
 1000 R     = AX(1)
      AX(2) = DEGRA*AX(2)
      AX(1) = R*COS(AX(2))
      AX(2) = R*SIN(AX(2))
      GO TO 990
C
C
C     INTERNAL SUBROUTINE TO TRANSFORM A SPHERICAL GRID PT TO BASIC
C     RHO,THETA,PHI IS STORED AT AX(1,2,3)
C
 1010 AX(2) = DEGRA*AX(2)
      AX(3) = DEGRA*AX(3)
      RSTH  = AX(1)*SIN(AX(2))
      RCTH  = AX(1)*COS(AX(2))
      AX(1) = RSTH *COS(AX(3))
      AX(2) = RSTH *SIN(AX(3))
      AX(3) = RCTH
      GO TO 990
C
C
C     INTERNAL SUBROUTINE TO CALCULATE THE 3X3 TRANSFORMATION MATRIX
C     AND 3X1 TRANSLATION VECTOR GIVEN THREE POINTS IN THE BASIC SYSTEM
C     THE RESULTS ARE STORED BACK IN THE CSDT
C
C     STORE R0 = A IN THE CSDT
C
 1020 ZZ(II+4) = AA(1)
      ZZ(II+5) = AA(2)
      ZZ(II+6) = AA(3)
C
C     FORM B - A
C
      DO 1030 I = 1,3
 1030 AK(I) = AB(I) - AA(I)
C
C     FORM K = (B - A)/LENGTH(B - A)
C     FORM C - A
C
      LENGTH = SQRT(AK(1)**2 + AK(2)**2 + AK(3)**2)
      DO 1040 I = 1,3
      AK(I) = AK(I)/LENGTH
 1040 AC(I) = AC(I) - AA(I)
C
C     FORM K X (C - A)
C
      AJ(1) = AK(2)*AC(3) - AK(3)*AC(2)
      AJ(2) = AK(3)*AC(1) - AK(1)*AC(3)
      AJ(3) = AK(1)*AC(2) - AK(2)*AC(1)
C
C     FORM J = (K X (C-A))/LENGTH(K X (C-A))
C
      LENGTH =  SQRT(AJ(1)**2 + AJ(2)**2 + AJ(3)**2)
      DO 1050 I = 1,3
 1050 AJ(I) = AJ(I)/LENGTH
C
C     FORM I = J X K
C
      AI(1) = AJ(2)*AK(3) - AJ(3)*AK(2)
      AI(2) = AJ(3)*AK(1) - AJ(1)*AK(3)
      AI(3) = AJ(1)*AK(2) - AJ(2)*AK(1)
C
C     STORE 3X3 ROTATION MATRIX = ((IX,JX,KX),(IY,JY,KY),(IZ,JZ,KZ))
C     IN THE CSDT
C
      ZZ(II+ 7) = AI(1)
      ZZ(II+ 8) = AJ(1)
      ZZ(II+ 9) = AK(1)
      ZZ(II+10) = AI(2)
      ZZ(II+11) = AJ(2)
      ZZ(II+12) = AK(2)
      ZZ(II+13) = AI(3)
      ZZ(II+14) = AJ(3)
      ZZ(II+15) = AK(3)
C
C     SET WD 3 OF CSDT = 3 AND WD 4 = 0 TO INDICATE  SOLVED SYSTEM
C     INCREMENT SOLVED SYSTEM COUNT
C
      Z(II+2) = 3
      Z(II+3) = 0
      SOLV = SOLV + 1
      GO TO 700
C
C
C     INTERNAL SUBROUTINE TO PERFORM BINARY SEARCH ON FIRST ENTRY
C     OF A DOUBLE ENTRIED TABLE STORED AT Z(1) THRU Z(N+1)
C
 1060 KLO = 1
      KHI = KN
 1070 K = (KLO+KHI+1)/2
 1080 IF (A(1)-Z(2*K-1)) 1090,1150,1100
 1090 KHI = K
      GO TO 1110
 1100 KLO = K
 1110 IF (KHI-KLO-1) 1160,1120,1070
 1120 IF (K.EQ.KLO) GO TO 1130
      K = KLO
      GO TO 1140
 1130 K = KHI
 1140 KLO = KHI
      GO TO 1080
 1150 A(1) = Z(2*K)
      GO TO NDX,  (230,340,480,490,500)
 1160 CALL MESAGE (30,IERR,A(1))
      NOGO = 1
      GO TO NERR, (220,330,485,495,505)
 1165 CALL MESAGE (-61,0,0)
C
C
C     FATAL ERROR MESAGES
C
 1170 NDX = -1
      GO TO 1210
 1180 NDX = -2
      GO TO 1210
 1190 CALL MESAGE (-30,IERR,SPOINT)
 1200 NDX = -3
      GO TO 1210
 1210 CALL MESAGE (NDX,FILE,GP1AH)
 1220 SPOINT(1) = Z(K+3)
      SPOINT(2) = Z(II )
      IERR = 3
      GO TO 1190
 1230 SPOINT(1) = Z(II  )
      SPOINT(2) = Z(II+3)
      IERR = 4
      GO TO 1190
 1240 SPOINT(1) = 0
      SPOINT(2) = 0
      IERR = 5
      GO TO 1190
 1250 SPOINT(1) = A(1)
      SPOINT(2) = 0
      IERR = 12
      GO TO 1190
      END

      SUBROUTINE INPTT5
C
C     DRIVER OF INPUTT5 MODULE
C     THIS MODULE HANDLES BOTH TABLE AND MATRIX DATA BLOCKS     5/88
C
C     THIS IS A COMPANION MODULE TO OUTPUT5
C
C     ==== TABLE  ====
C     CALLS TABLE-V ROUTINE TO COPY FROM A FORTRAN UNIT (FORMATTED OR
C     BINARY TAPE) TABLE DATA TO NASTRAN GINO TABLE DATA BLOCKS
C
C     ==== MATRIX ====
C     COPIES FROM A FORTRAN UNIT (BINARY OR FORMATTED TAPE) OF BANDED
C     MATRICES ONTO NASTRAN GINO MATRIX DATA BLOCKS, IN GINO PACKED
C     FORMAT
C
C     UNFORMATTED RECORDS CAN ONLY BE USED BY THE SAME COMPUTER SYSTEM,
C     WHILE FORMATTED RECORDS CAN BE USED ACROSS COMPUTER BOUNDARY
C     (E.G. WRITTEN BY CDC MACHINE AND READ BY IBM), AND ASLO, IT CAN
C     BE EDITED BY SYSTEM EDITOR, OR PRINTED OUT BY SYSTEM PRINT COMMAND
C
C     ******************************************************************
C     *                                                                *
C     *                       - IMPORTANT -                            *
C     *                                                                *
C     *  IF USER ASSEMBLES HIS OWN MATRIX IN INPUTT5 FORMAT, AND USES  *
C     *  INPUTT5 MODULE TO READ IT INTO NASTRAN, BE SURE THAT THE      *
C     *  DENSITY TERM (DENS) OF THE MATRIX TRAILER IS SET TO NON-ZERO  *
C     *  (NEED NOT BE EXACT) AND THE PRECISION TERM (TYPE) IS 1,2,3,   *
C     *  OR 4. OTHERWISE, HIS MATRIX WILL BE TREATED AS TABLE AND      *
C     *  EVERYTHING GOES HAYWIRE.                                      *
C     *                                                                *
C     ******************************************************************
C
C     CALL TO THIS MODULE IS
C
C     INPUTT5  /O1,O2,O3,O4,O5/C,N,P1/C,N,P2/C,N,P3/C,N,P4 $
C
C              P1=+N, SKIP FORWARD N MATRIX DATA BLOCKS OR TABLES BEFORE
C                     COPYING (EXCEPT THE FIRST HEADER RECORD. EACH
C                     MATRIX DATA BLOCK OR TABLE, PRECEEDED BY A HEADER
C                     RECORD, IS A COMPLETE MATRIX OR TABLE, MADE UP OF
C                     MANY PHYSICAL RECORDS.
C                     SKIP TO THE END OF TAPE IF P1 EXCEEDS THE NO. OF
C                     DATA BLOCKS AVAILABLE ON THE OUTPUT TAPE
C                     NO REWIND BEFORE SKIPPING)
C              P1= 0, NO ACTION TAKEN BEFORE COPYING. (DEFAULT)
C                     HOWEVER, IF TAPE IS POSITIONED AT THE BEGINNING,
C                     THE TAPE ID RECORD IS SKIPPED FIRST.
C              P1=-1, INPUT TAPE IS REWOUND, AND TAPEID CHECKED. IF
C                     OUTPUT GINO FILES ARE PRESENT, DATA FROM TAPE ARE
C                     THEN COPIED TO GINO FILES - IN PACKED MATRIX FORM
C                     IF MATRIX DATA, OR TABLE FORM IF TABLE DATA.
C              P1=-3, TAPE IS REWOUND AND READ. THE NAMES OF ALL DATA
C                     BLOCKS ON FORTRAN TAPE ARE PRINTED. AT END, TAPE
C                     IS REWOUND AND POSITIONED AFTER TAPE HEADER RECORD
C                     (NOTE - SERVICE UP TO 15 FILE NAMES ON ONE INPUT
C                     TAPE. AND THE 'AT END' TREATMENT IS NOT THE SAME
C                     AS IN OUTPUT5)
C              P1=-4  THRU -8 ARE NOT USED
C              P1=-9, REWIND TAPE
C
C              P2  IS THE FORTRAN UNIT NO. ON WHICH THE DATA BLOCKS WILL
C                     WRITTEN.  DEFAULT IS 16 (INP2 FOR UNIVAC,IBM,VAX),
C                     OR 12 (UT2 FOR CDC)
C
C              P3  IS TAPE ID IF GIVEN BY USER. DEFAULT IS XXXXXXXX
C
C              P4=0, OUTPUT TAPE IS FORTRAN WRITTEN, UNFORMATTED RECORDS
C              P4=1, OUTPUT TAPE IS FORTRAN WRITTED, FORMATTED
C                    BCD IN 2A4, INTEGER IN I8, S.P. REAL IN 10E13.6,
C                    AND D.P. IN 5D26.17.
C              P4=2, SAME AS P4=1, EXECPT FORMAT 5E26.17 IS USED FOR
C                    S.P. REAL DATA. (THIS OPTION IS USED ONLY IN
C                    MACHINES WITH 60 OR MORE BITS PER WORD)
C
C
C     CONTENTS OF INPUT TAPE, AS WRITTEN BY OUTPUT5
C                                                       (P4=0)   (P4=1)
C     RECORD  WORD        CONTENTS                      BINARY   FORMAT
C     ------  ----  --------------------------------   -------  -------
C        0            TAPE HEADER RECORD -
C              1,2    TAPEID                             2*BCD      2A4
C              3,4    MACHINE                            2*BCD      2A4
C              5-7    DATE                               3*INT      3I8
C               8     BUFFSIZE                             INT       I8
C               9     0 (BINARY), OR 1 OR 2 (FORMATTED)    INT       I8
C       1/2@          FIRST MATRIX HEADER RECORD -
C               1     ZERO                                 INT       I8
C              2,3    1,1                                2*INT      2I8
C               1     DUMMY (D.P.)                        F.P.   D26.17
C              2-7    MATRIX TRAILER                     6*INT      6I8
C                     (COL,ROW,FORM,TYPE,MAX,DENS)
C              8-9    MATRIX DMAP NAME                   2*BCD      2A4
C       3/4     1     1 (FIRST COLUMN ID)                  INT       I8
C               2     LOC. OF FIRST NON-ZERO ELEMENT, L1   INT       I8
C               3     LOC. OF LAST  NON-ZERO ELEMENT, L2   INT       I8
C              1-W    FIRST MATRIX COLUMN DATA            F.P.     (**)
C                     (W=L2-L1+1)
C       5/6     1     2 (SECOND COLUMN ID)                 INT       I8
C              2-3    LOC. OF FIRST AND LAST NON-ZERO    2*INT      2I8
C                     ELEMENTS
C              1-W    SECOND MATRIX COLUMN DATA           F.P.     (**)
C       7/8    1-3    THIRD MATRIX COLUMN, SAME FORMAT   3*INT      3I8
C              1-W    AS RECORD 1                         F.P.     (**)
C        :      :       :
C       M/M+1  1-3    LAST MATRIX COLUMN, SAME FORMAT    3*INT      3I8
C                     AS RECORD 1                         F.P.     (**)
C     M+2/M+3  1-3    SECOND MATRIX HEADER RECORD        3*INT      3I8
C               1     DUMMY                               F.P.     (**)
C              2-7    MATRIX TRAILER                     6*INT      6I8
C              8,9    MATRIX DMAP NAME                   2*BCD      2A4
C     M+4-N     :     FIRST THRU LAST COLUMNS OF MATRIX  3*INT      3I8
C                                                        +F.P.    +(**)
C        :      :     REPEAT FOR 3RD,4TH,5TH MATRICES
C        :      :     (UP TO 5 MATRIX DATA BLOCKS PER ONE OUTPUT TAPE)
C
C       EOF    1-3    -1,1,1                              3*INT     3I8
C               1     ZEROS (D.P.)                         F.P.  D26.17
C
C     @  RECORDS 1/2 (3/4, 5/6, ETC) ARE TWO RECORDS IN THE FORMATTED
C        TAPE, AND ARE PHYSICALLY ONE RECORD IN THE BINARY TAPE (AND
C        THE WORD COUNT SHOULD BE ADDED)
C     ** IS (10E13.6) FOR S.P.REAL OR (5D26.17) FOR D.P.DATA
C        (5E26.17) FOR LONG WORD MACHINE
C
C                                                               - NOTE -
C                                                  BCD AND INTEGERS IN 8
C                                                     S.P. REAL IN  13.7
C                                                     D.P. DATA IN 26.17
C                                             LONG WORD MACHINE IN 26.17
C
C     NO SYSTEM END-OF-FILE MARK WRITTEN BETWEEN MATRICES
C     EXCEPT FOR THE TAPE HEADER RECORD, AND THE MATRIX HEADERS, THE
C     ENTIRE FORMATTED INPUT TAPE CAN BE READ BY A STANDARD FORMAT
C     (3I8,/,(10E13.6)), (3I8,/,(5D26.17)), OR (3I8,/,(5E26.17))
C
C     ALSO, USER MAY OR MAY NOT CALL OUTPUT5 WITH P1=-9 TO WRITE AN
C     'OUPUT5 E-O-F' MARK ON TAPE. THIS CAUSED PROBLEM BEFORE.
C
C     THE PROCEDURE TO READ AND/OR WRITE THE TAPE IS COMMONLY USED
C     AMONG INPUTT5, OUTPUT5, AND DUMOD5. ANY PROCEDURE CHANGE SHOULD
C     BE MADE TO ALL THREE SUBROUTINES.
C
C     WRITTEN BY G.CHAN/UNISYS   1987
C     MAJOR REVISED 12/1992 BY G.C.
C
      IMPLICIT INTEGER (A-Z)
      LOGICAL          OPN,P40,P40S,P40D,P41,P41S,P41D,P41C,DEBUG
      INTEGER          NAME(2),TAPEID(2),MAC(2),SUBNAM(2),DT(3),
     1                 IZ(7),FN(3,15),BK
      REAL             RZ,X
      DOUBLE PRECISION DZ(7),DX
      CHARACTER*8      BINARY,FORMTD,BF
CWKBI
      CHARACTER*5      Z5(1)
      CHARACTER        UFM*23,UWM*25,UIM*29,SFM*25
CWKBNB
      CHARACTER*80     DSNAMES
      COMMON /DSNAME/  DSNAMES(80)
CWKBNE
      COMMON /XMSSG /  UFM,UWM,UIM,SFM
      COMMON /BLANK /  P1,P2,P3(2),P4
      COMMON /INPUT5/  MCB(1),COL,ROW,FORM,TYPE,MAX,DENS
      COMMON /MACHIN/  MACH
      COMMON /SYSTEM/  IBUF,NOUT,NOGO,DUM36(36),NBPW
      COMMON /ZZZZZZ/  RZ(1)
      COMMON /PACKX /  TYPIN,TYPOUT,II,JJ,INCR
CWKBR EQUIVALENCE      (RZ(1),IZ(1),DZ(1))
      EQUIVALENCE      (RZ(1),IZ(1),DZ(1),Z5)
      DATA    BINARY,  FORMTD,       SUBNAM,         FN,BK    /
     1       'BINARY','FORMATTD',    4HINPT, 2HT5,   46*2H    /
      DATA    MTRX,    TBLE,SKIP   / 4HMTRX, 4HTBLE, 4HSKIP   /
      DATA    DEBUG /  .FALSE.     /
C
C     IF MACHINE IS CDC OR UNIVAC, CALL CDCOPN OR UNVOPN TO OPEN OUTPUT
C     FILE, A SEQUENTIAL FORMATTED TAPE. NO CONTROL WORDS ARE TO BE
C     ADDED TO EACH SEQUENTIAL RECORD. RECORD LENGTH IS 132 CHARACTERS,
C     AN ANSI STANDARD.
C
      BF = BINARY
      IF (P4 .GE. 1) BF = FORMTD
      CALL PAGE1
      WRITE  (NOUT,10) UIM,BF,P1
   10 FORMAT (A29,', MODULE INPUTT5 CALLED BY USER DMAP ALTER, ON ',A8,
     1        ' INPUT FILE,',/5X,'WITH THE FOLLOWING REQUEST.  (P1=',
     2        I2,1H))
      IF (P1 .EQ. -9) WRITE (NOUT,20)
      IF (P1 .EQ. -3) WRITE (NOUT,30)
      IF (P1 .EQ. -1) WRITE (NOUT,40)
      IF (P1 .EQ.  0) WRITE (NOUT,50)
      IF (P1 .GT.  0) WRITE (NOUT,60) P1
   20 FORMAT (5X,'REWIND TAPE ONLY')
   30 FORMAT (5X,'REWIND AND READ TAPE. PRINT ALL DATA BLOCK NAMES ON ',
     1       'TAPE. AT END, TAPE IS REWOUND', /5X,'AND POSITIONED ',
     2       'PASS TAPE HEADER RECORD')
   40 FORMAT (5X,'REWIND, POSITION PAST TAPE HEADER RECORD, THEN READ ',
     1       'TAPE. AT END, NO REWIND')
   50 FORMAT (5X,'READ TAPE STARTING AT CURRENT POSITION, OR POSITION ',
     1       'PAST THE TAPE HEADER RECORD (FIRST USE OF TAPE).', /5X,
     2       ' NO REWIND AT BEGINNING AND AT END')
   60 FORMAT (5X,'SKIP FORWARD',I4,' DATA BLOCKS (NOT COUNTING TAPE ',
     1       'HEADER RECORD) BEFORE READING, AT END NO REWIND')
C
      BUF1 = KORSZ(RZ(1)) - IBUF - 1
      IF (BUF1 .LE. 0) CALL MESAGE (-8,0,SUBNAM)
      INPUT= P2
      OPN  = .FALSE.
      LL   = 0
      P41  =.FALSE.
      IF (P4 .GE.  1) P41 =.TRUE.
      P40  =.NOT.P41
      P40S =.FALSE.
      P41S =.FALSE.
      P40D = P40
      P41D = P41
      P41C = P4.EQ.2 .AND. NBPW.GE.60
      IF (P41C) P40D = .FALSE.
      IF (P41C) P41D = .FALSE.
      COL12= 0
      P1N  = P1
      IF (P1 .LT.  0) P1N = 0
CWKBNB
      CLOSE( UNIT=INPUT )
      IF ( P4 .NE. 0  ) GO TO 62
      OPEN ( UNIT=INPUT, FILE=DSNAMES(INPUT), FORM='UNFORMATTED'
     1      ,STATUS='UNKNOWN' )
      GO TO 65
62    CONTINUE
      OPEN ( UNIT=INPUT, FILE=DSNAMES(INPUT), STATUS='UNKNOWN')
65    CONTINUE
CWKBNE
      IF (P1 .NE. -9) GO TO 70
      REWIND INPUT
      GO TO 1000
C
   70 DO 80 I = 1,15
   80 FN(3,I) = BK
      IF (P1.GE.-1 .OR. P1.EQ.-3 .OR. P1.EQ.-9) GO TO 200
C
      WRITE  (NOUT,90) UFM,P1
   90 FORMAT (A23,', MODULE INPUTT5 - ILLEGAL VALUE FOR FIRST PARAMETER'
     1,      ' = ',I8, /5X,'ONLY -9, -3 AND GREATER THAN -1 ALLOWED')
  100 ERR = -37
  120 CALL MESAGE (ERR,OUTPUT,SUBNAM)
      RETURN
C
  200 IF (P1 .EQ. 0) GO TO 500
C
C     CHECK TAPE ID
C
      REWIND INPUT
      ERR = -1
      IF (P40) READ (INPUT,    END=420) TAPEID,MAC,DT,I,K
      IF (P41) READ (INPUT,210,END=420) TAPEID,MAC,DT,I,K
  210 FORMAT (4A4,5I8)
      IF (TAPEID(1).EQ.P3(1) .AND. TAPEID(2).EQ.P3(2)) GO TO 230
      WRITE  (NOUT,220) TAPEID,P3,MAC,DT
  220 FORMAT ('0*** WRONG TAPE MOUNTED - TAPEID =',2A4,', NOT ',2A4,
     1        /5X,'MACHINE=',2A4,' DATE WRITTEN-',I4,1H/,I2,1H/,I2)
      IF (P1 .EQ. -1) GO TO 100
  230 IF (K  .EQ. P4) GO TO 250
      WRITE  (NOUT,240) UWM,P4
  240 FORMAT (A25,', MODULE INPUTT5 4TH PARAMETER SPECIFIED WRONG TAPE',
     1       ' FORMAT.   P4=',I5, /5X,
     2       'INPUTT5 WILL RESET P4 AND TRY TO READ THE TAPE AGAIN.',/)
      P4  = K
      P40 =.NOT.P40
      P41 =.NOT.P41
  250 CALL PAGE2 (4)
      WRITE  (NOUT,260) TAPEID,MAC,DT,I
  260 FORMAT (/5X,'MODULE INPUTT5 IS NOW PROCESSING TAPE ',2A4,
     1       ' WHICH WAS WRITTEN BY ',2A4,'MACHINE', /5X,
     2       'ON',I4,1H/,I2,1H/,I2,4X,'SYSTEM BUFFSIZE=',I8)
      IF (P40) WRITE (NOUT,270)
      IF (P41) WRITE (NOUT,280)
  270 FORMAT (5X,'TAPE IN BINARY RECORDS',/)
  280 FORMAT (5X,'TAPE IN FORMATTED RECORDS',/)
      LL = 0
      IF (P1.GT.0 .OR. P1.EQ.-3) GO TO 300
      IF (P1 .EQ. -1) GO TO 510
      IMHERE = 290
      WRITE  (NOUT,290) SFM,IMHERE,P1
  290 FORMAT (A25,' @',I5,I10)
      GO TO 100
C
C     TO SKIP P1 MATRIX DATA BLOCKS OR TABLES ON INPUT TAPE (P1 = +N)
C     OR PRINT CONTENTS OF INPUT TAPE (P1 = -3)
C
  300 IF (P40 ) READ (INPUT,    ERR=390,END=420) NC,JB,JE
      IF (P41S) READ (INPUT,520,ERR=390,END=420) NC,JB,JE,( X,J=JB,JE)
      IF (P41C) READ (INPUT,525,ERR=390,END=420) NC,JB,JE,( X,J=JB,JE)
      IF (P41D) READ (INPUT,530,ERR=390,END=420) NC,JB,JE,(DX,J=JB,JE)
      IF (DEBUG .AND. (NC.LE.15 .OR. NC.GE.COL12))
     1    WRITE (NOUT,540) NC,JB,JE,LL
      IF (NC) 360,340,300
C
  310 IF (P40) READ (INPUT,    ERR=390,END=420) L
      IF (P41) READ (INPUT,320,ERR=390,END=420) L,(TABEL,J=1,L)
  320 FORMAT (I10,24A, /,(26A5))
      IF (DEBUG) WRITE (NOUT,330) L,LL
  330 FORMAT (30X,'L AND LL=',2I6)
      IMHERE = 330
      IF (L) 360,340,310
  340 IF (P1.NE.-3 .AND. LL.GE.P1) GO TO 360
      IMHERE = 340
      LL = LL + 1
      BACKSPACE INPUT
      IF (P41) BACKSPACE INPUT
      IF (LL .GT. 15) GO TO 370
      IF (P40) READ (INPUT    ) I,I,I,DX,J,J,J,J,K,K,FN(1,LL),FN(2,LL)
      IF (P41) READ (INPUT,560) I,I,I,DX,J,J,J,J,K,K,FN(1,LL),FN(2,LL)
      IF (P1.NE.-3 .OR. LL.LE.P1) FN(3,LL) = SKIP
      IF (K.GT.0 .AND. J.GE.1 .AND. J.LE.4) GO TO 350
C
C     FILE IS A TABLE
C
      IF (LL .GT. P1) FN(3,LL) = TBLE
      IMHERE = 345
      GO TO 310
C
C     FILE IS A MATRIX
C
  350 IF (LL .GT. P1) FN(3,LL) = MTRX
      IF (P40) GO TO 300
      P41S = .FALSE.
      P41D = .FALSE.
      P41C =  P4.EQ.2 .AND. NBPW.GE.60
      IF (P41C) GO TO 300
      IF (J.EQ.1 .OR. J.EQ.3) P41S = .TRUE.
      P41D = .NOT.P41S
      GO TO 300
C
  360 IF (P1 .EQ. -3) GO TO 900
      IF (P41) BACKSPACE INPUT
      BACKSPACE INPUT
      GO TO 510
C
  370 WRITE  (NOUT,380) UIM
  380 FORMAT (A29,', INPUTT5, WITH P1= -3, CAN ONLY PRINT UP TO 15 ',
     1       ' FILE NAMES ON ONE INPUT TAPE.', /5X,'TAPE IS POSITIONED',
     2       ' AFTER THE 15TH FILE')
      LL = LL - 1
      GO TO 920
C
  390 WRITE  (NOUT,400) UFM,P3,LL,NC,IMHERE
  400 FORMAT (A23,', TAPE ERROR DURING READ/INPUTT5  ',2A4, /5X,
     1       'LL,NC =',2I5,'   IMHERE =',I5)
      IMHERE = 405
      IF (P41 .AND. MACH.EQ.2) WRITE (NOUT,410) IMHERE
  410 FORMAT (/5X,'IBM USER - CHECK FILE ASSIGNMENT FOR DCB PARAMETER ',
     1       'OF 132 BYTES',I15)
      GO TO  100
  420 IF (P1 .EQ. -3) GO TO 440
      WRITE  (NOUT,430) UFM,P3,IMHERE,LL,NC
  430 FORMAT (A23,', EOF ENCOUNTERED ON INPUT TAPE ',2A4,5X,
     1        'IMHERE,LL,NC =',3I5)
      IF (P1 .NE. -3) NOGO = 1
      GO TO  900
  440 WRITE  (NOUT,450) UWM,P3
  450 FORMAT (A25,', EOF ENCOUNTERED ON INPUT TAPE ',2A4,'. TAPE DOES ',
     1       'NOT CONTAIN AN ''OUTPUT5 E-O-F'' MARK')
      IF (DEBUG) WRITE (NOUT,460) IMHERE,LL,NC
  460 FORMAT (5X,'IMHERE,LL,NC =',3I5)
      GO TO  900
C
C     P1 = 0,
C     MUST SKIP TAPE HEADER RECORD IF CURRENT TAPE POSITION IS AT THE
C     VERY BEGINNING
C
  500 LL = 0
      IMHERE = 500
      IF (P40) READ (INPUT,    ERR=770,END=420) TAPEID
      IF (P41) READ (INPUT,210,ERR=770,END=420) TAPEID
      IF (TAPEID(1).NE.P3(1) .OR. TAPEID(2).NE.P3(2)) BACKSPACE INPUT
C
C     COPY MATRIX TO TAPE
C
      IMHERE = 510
  510 IF (P40S) READ(INPUT,    ERR=770,END=910) NC,JB,JE,(RZ(J),J=JB,JE)
      IF (P40D) READ(INPUT,    ERR=770,END=910) NC,JB,JE,(DZ(J),J=JB,JE)
      IF (P41S) READ(INPUT,520,ERR=770,END=910) NC,JB,JE,(RZ(J),J=JB,JE)
      IF (P41C) READ(INPUT,525,ERR=770,END=910) NC,JB,JE,(RZ(J),J=JB,JE)
      IF (P41D) READ(INPUT,530,ERR=770,END=910) NC,JB,JE,(DZ(J),J=JB,JE)
  520 FORMAT (3I8,/,(10E13.6))
  525 FORMAT (3I8,/,(5E26.17))
  530 FORMAT (3I8,/,(5D26.17))
      IF (DEBUG .AND. (NC.LE.15 .OR. NC.GE.COL12))
     1    WRITE (NOUT,540) NC,JB,JE,LL,IMHERE
  540 FORMAT (30X,'NC,JB,JE,LL=',5I6,'=IMHERE')
      IF (NC) 800,           550,         700
C             EOF, MATRIX-HEADER, COLUMN-DATA
C
C     MATRIX OR TABLE HEADER
C
  550 IF (OPN) GO TO 810
      LL = LL + 1
      IF (LL .GT. 15) GO TO 370
      BACKSPACE INPUT
      IF (P41) BACKSPACE INPUT
      J = -1
      IF (P40) READ (INPUT,    ERR=570) K,J,J,DX,COL,ROW,FORM,TYPE,
     1                                  MAX,DENS,FN(1,LL),FN(2,LL)
      IF (P41) READ (INPUT,560,ERR=570) K,J,J,DX,COL,ROW,FORM,TYPE,
     1                                  MAX,DENS,FN(1,LL),FN(2,LL)
  560 FORMAT (3I8,/,D26.17,6I8,2A4)
      COL12 = COL - 12
      IF (COL12 .LT. 0) COL12 = 0
      IF (.NOT.DEBUG) GO TO 590
  570 WRITE  (NOUT,580) COL,ROW,FORM,TYPE,MAX,DENS,DX,FN(1,LL),FN(2,LL)
  580 FORMAT (' COL,ROW,FORM,TYPE,MAX,DENS,DX,FILE=',6I6,D12.3,3X,2A4)
      IF (J .EQ. -1) CALL MESAGE (-37,0,SUBNAM)
C
  590 IF (K.EQ.0 .AND. (DENS.EQ.0 .OR. TYPE.LE.0 .OR. TYPE.GT.4))
CWKBR1    CALL TABLE V (*510,INPUT,LL,MCB,FN(1,LL),P4,BUF1,RZ)
     1    CALL TABLE V (*510,INPUT,LL,MCB,FN(1,LL),P4,BUF1,Z5)
C
      FN(3,LL) = MTRX
      P40S = .FALSE.
      P40D = .FALSE.
      P41S = .FALSE.
      P41D = .FALSE.
      P41C =  P4.EQ.2 .AND. NBPW.GE.60
      IF (P41C) GO TO 610
      IF (P41 ) GO TO 600
      IF (TYPE.EQ.1 .OR. TYPE.EQ.3) P40S = .TRUE.
      P40D = .NOT.P40S
      GO TO 610
  600 IF (TYPE.EQ.1 .OR. TYPE.EQ.3) P41S = .TRUE.
      P41D = .NOT.P41S
  610 IF (DEBUG) WRITE (NOUT,620) P40,P40S,P40D,P41,P41S,P41D,P41C
  620 FORMAT ('0  P40,P40S,P40D,P41,P41S,P41D,P41C = ',7L4)
      TYPIN  = TYPE
      TYPOUT = TYPE
      JTYP   = TYPE
      IF (TYPE .EQ. 3) JTYP = 2
      II   = 1
      JJ   = ROW
      INCR = 1
      NWDS = ROW*JTYP
      IF (NWDS .GT. BUF1) CALL MESAGE (-8,0,SUBNAM)
C
C     OPEN GINO FILE FOR OUTPUT
C
      IMHERE = 640
      IF (P1 .EQ. -3) GO TO 640
      ROWX   = ROW
      FORMX  = FORM
      OUTPUT = 200 + LL - P1N
      MCB(1) = OUTPUT
      CALL RDTRL (MCB(1))
      IF (MCB(1) .LE. 0) GO TO 750
      ERR  = -1
      CALL OPEN  (*120,OUTPUT,RZ(BUF1),1)
      CALL FNAME (OUTPUT,NAME)
      CALL WRITE (OUTPUT,NAME,2,1)
      OPN  = .TRUE.
      COL  = 0
      ROW  = ROWX
      FORM = FORMX
      TYPE = TYPOUT
      MAX  = 0
      DENS = 0
      NCK  = 0
      GO TO 510
C
  640 WRITE (NOUT,290) SFM,IMHERE,P1
      CALL MESAGE (-37,0,SUBNAM)
C
C     RECOVER INPUT MATRIX, AND WRITE IT OUT BY COLUMN
C
  700 IMHERE = 700
      IF (P1 .EQ. -3) GO TO 510
      NCK = NCK + 1
      IF (NC .NE. NCK) GO TO 390
      IF (JB .LE. 1) GO TO 720
      JB  = (JB-1)*JTYP
      DO 710 J = 1,JB
  710 RZ(J) = 0.0
  720 IF (JE .GE. NWDS) GO TO 740
      JE  = (JE*JTYP) + 1
      DO 730 J = JE,NWDS
  730 RZ(J) = 0.0
  740 CALL PACK (RZ,OUTPUT,MCB)
      GO TO 510
C
C     OUTPUT FILE PURGED, SKIP FORWARD FOR NEXT MATRIX ON TAPE
C
  750 IF (P40 ) READ (INPUT    ,ERR=390,END=420) NC,JB,JE
      IF (P41S) READ (INPUT,520,ERR=390,END=420) NC,JB,JE,( X,J=JB,JB)
      IF (P41C) READ (INPUT,525,ERR=390,END=420) NC,JB,JE,( X,J=JB,JB)
      IF (P41D) READ (INPUT,530,ERR=390,END=420) NC,JB,JE,(DX,J=JB,JB)
      IF (NC .GT. 0) GO TO 750
      CALL PAGE2 (2)
      WRITE  (NOUT,760) UWM,FN(1,LL),FN(2,LL)
  760 FORMAT (A25,', OUTPUT FILE PURGED.  ',2A4,' FROM INPUT TAPE NOT ',
     1       'COPIED')
C     LL = LL + 1
      GO TO 550
C
  770 IMHERE = -IMHERE
      WRITE  (NOUT,400) UFM,P3,LL,NC,IMHERE
      WRITE  (NOUT,780) P40,P41,P40S,P40D,P41S,P41D,P41C
  780 FORMAT ('  P40,P41,P40S,P40D,P41S,P41D,P41C =',7L2)
      IMHERE = 770
      IF (P41 .AND. MACH.EQ.2) WRITE (NOUT,410) IMHERE
      GO TO 750
C
C     END OF MATRIX ENCOUNTERED. CLOSE GINO DATA BLOCK WITH REWIND.
C
  800 IF (.NOT.OPN) GO TO 840
  810 CALL CLOSE (OUTPUT,1)
      OPN = .FALSE.
      IF (FORM.GE.1 .AND. FORM.LE.6) GO TO 820
      FORM = 1
      IF (COL .NE. ROW) FORM = 2
  820 CALL WRTTRL (MCB)
      CALL FNAME (OUTPUT,NAME)
      CALL PAGE2 (10)
      WRITE  (NOUT,830) FN(1,LL),FN(2,LL),INPUT,NAME,(MCB(J),J=1,7)
  830 FORMAT (/5X,'MATRIX DATA BLOCK ',2A4,' WAS SUCESSFULLY RECOVERED',
     1       ' FROM FORTRAN UNIT',I4,' TO ',2A4, /8X,'GINO UNIT =',I8,
     2       /6X,'NO. OF COLS =',I8, /6X,'NO. OF ROWS =',I8,  /13X,
     3       'FORM =',I8, /13X,'TYPE =',I8, /3X,'NON-ZERO WORDS =',I8,
     4       /10X,'DENSITY =',I8)
  840 IMHERE = 840
      IF (LL .GE.  5+P1N) GO TO 860
      IF (NC) 850,550,390
  850 IF (P1 .EQ. -3) GO TO 1000
      GO TO 900
  860 BACKSPACE INPUT
      IF (P41) BACKSPACE INPUT
      GO TO 920
C
C     IF NC = -2, THIS IS AN ELEM/GRID ID RECORD WRITTEN BY DUMOD5
C
  900 IF (NC .EQ. -2) GO TO 510
  910 NC = -3
      IF (OPN) GO TO 800
      IF (FN(3,LL) .EQ. BK) LL = LL - 1
      IF (LL .LE. 0) GO TO 970
C
C     PRINT LIST OF DATA BLOCKS ON FORTRAN TAPE (P1=-3).
C
  920 CALL PAGE2 (LL+9)
      WRITE  (NOUT,930)
      IF (P1 .NE. -3) WRITE (NOUT,940) INPUT
      IF (P1 .EQ. -3) WRITE (NOUT,950) INPUT
      WRITE  (NOUT,960) MAC,BF,(J,FN(1,J),FN(2,J),FN(3,J),J=1,LL)
  930 FORMAT (/5X,'SUMMARY FROM INPUTT5 MODLUE -')
  940 FORMAT (/34X,'FILES RECOVERED FROM FORTRAN UNIT',I5)
  950 FORMAT (/34X,'FILE CONTENTS ON FORTRAN UNIT',I5)
  960 FORMAT (28X,'(WRITTEN BY ',2A4,' MACHINE ',A8,' RECORDS)', //37X,
     1       'FILE',8X,'NAME',8X,'TYPE', /33X,9(4H----), /,
     2       (37X,I3,7X,2A4,6X,A4))
      IF (NOGO .EQ. 1) GO TO 100
C
      IF (P1  .NE. -3) GO TO 1000
      REWIND INPUT
      IF (P40) READ (INPUT)
      IF (P41) READ (INPUT,210)
      GO TO 1000
C
  970 IF (P1 .EQ. -3) WRITE (NOUT,980) UIM,INPUT
  980 FORMAT (A29,' FROM INPUTT5 MODULE, INPUT TAPE (FORTRAN UNIT',I5,
     1       ') CONTAINS NO DATA BLOCK')
C
 1000 IF (MACH .EQ. 3) CALL UNVCLS (P2)
      IF (MACH .EQ. 4) CALL CDCCLS (P2)
      RETURN
      END

      SUBROUTINE FVRS1D (BASE,BASE1,INDEX,NFX)
C
      COMPLEX BASE(3,NFX),BASE1(3,NFX)
C
      DIMENSION INDEX(NFX)
C
      DO 100 I=1,NFX
      LOC =INDEX(I)
      DO 10 L=1,3
  10  BASE1(L,I)=BASE(L,LOC)
 100  CONTINUE
C
C-----RETURN BASE1 TO BASE
C
      DO 200 I=1,NFX
      DO 110 L=1,3
 110  BASE(L,I)=BASE1(L,I)
 200  CONTINUE
      RETURN
      END

      SUBROUTINE DSCHK
C
C     MODULE TO PERFORM DIFFERENTIAL STIFFNESS CONVERGENCE TESTS
C
C     DSCHK    PGI,PGIP1,UGIP1//EPSIO,DSEPSI,NT,TOUT,TIN,DONE,SHIFT,
C                               COUNT,BETA
C
C     EPSIO    ACCEPTABLE RATIO OF ENERGY ERROR TO TOTAL ERROR(R) INPUT
C     DSEPSI   EPSI(SUB I -1)   (REAL)                            IN/OUT
C     NT       TOTAL NUMBER OF ITERATIONS ALLOWED                 INPUT
C     TOUT     START TIME FOR OUTER LOOP                          INPUT
C     TIN      START TIME FOR INNER LOOP                          INPUT
C     DONE     EXIT FLAG FOR SKIP TO SDR2                         OUTPUT
C     SHIFT    EXIT FLAG FOR SHIFT                                IN/OUT
C     COUNT    CURRENT STEP NUMBER                                IN/OUT
C     BETA     SHIFT DECISION FACTOR (REAL)                       INPUT
C
C     EXIT FLAG VALUES (IEXIT)                                    LOCAL
C          0   NOT SET
C          1   CONVERGED
C          2   DIVERGED
C          3   INSUFFICIENT TIME
C          4   ITERATION LIMIT
C          5   ZERO EPSIO
C          6   ZERO EPSI
C
      INTEGER         PGI,PGIP1,UGIP1,TOUT,TIN,DONE,SHIFT,COUNT,IZ(1),
     1                SYSBUF,SCR1,SCR2,SCR3,FILE,TNOW,TI,TO,TLEFT,BETA
      CHARACTER       UFM*23,UWM*25,UIM*29
      COMMON /XMSSG / UFM,UWM,UIM
      COMMON /SYSTEM/ SYSBUF,NOUT,KSYSTM(52),IPREC
      COMMON /UNPAKX/ ITA,II,JJ,INCR
      COMMON /BLANK / EPSIO,DSEPSI,NT,TOUT,TIN,DONE,SHIFT,COUNT,BETA
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE     (COUNT,NI), (Z(1),IZ(1))
      DATA    PGI   , PGIP1,UGIP1,SCR1,SCR2,SCR3 /
     1        101   , 102,  103,  301, 302, 303  /
C
C     INITIALIZE
C
      IBUF1 = KORSZ(IZ) - SYSBUF + 1
      IEXIT = 0
      IFRST = SHIFT
      SHIFT = 1
      NF    = 1
      CALL KLOCK (TNOW)
      TI    = TNOW - TIN
      CALL TMTOGO (TLEFT)
      TO    = TNOW - TLEFT
C
C     COMPUTE DSEPSI(I)
C
      CALL SSG2B (UGIP1,PGI  ,0   ,SCR1,1,IPREC,1,SCR3)
      CALL SSG2B (UGIP1,PGIP1,SCR1,SCR2,1,IPREC,2,SCR3)
C
      II   = 1
      JJ   = 1
      INCR = 1
      ITA  = 1
      FILE = SCR2
      ASSIGN 10 TO IRETN
      GO TO 300
C
C     GET DENOMINATOR
C
   10 EPSI = VALUE
      FILE = SCR1
      ASSIGN 20 TO IRETN
      GO TO 300
   20 IF (VALUE .EQ. 0.0) GO TO 40
      EPSI  = ABS(EPSI/VALUE)
      COUNT = COUNT + 1
      IF (IFRST .EQ.  -1) GO TO 30
      IF (EPSI  .EQ. 0.0) GO TO 210
      XLAMA = ABS(DSEPSI/EPSI)
      IF (XLAMA .LE. 1.0) GO TO 60
   30 DSEPSI = EPSI
      IF (EPSI .GT. EPSIO) GO TO 50
C
C     CONVERGED
C
   40 IEXIT = 1
      DONE  =-1
      GO TO 220
C
C     MAKE FIRST TEST
C
   50 IF (IFRST .EQ. -1) GO TO 80
C
C     NOT FIRST TIME
C
      IF (EPSIO .LE. 0.0) GO TO 200
      NF  = ALOG(EPSI/EPSIO)/ALOG(XLAMA)
      CALL KLOCK (TNOW)
      CALL TMTOGO (TLEFT)
      TI  = TNOW - TIN
      TO  = TNOW - TOUT
      GO TO 70
C
C     DIVERGED
C
   60 IEXIT = 2
      DONE  =-1
      DSEPSI = EPSI
      GO TO 220
C
C     CONVERGENT
C
   70 IF (NF .GT. NT-NI) GO TO 90
      IF (TI*NF .GT. TO+BETA*TI) GO TO 100
   80 IF (TLEFT .GE. 3*TI) GO TO 120
C
C     INSUFFICIENT TIME
C
      IEXIT = 3
      DONE  =-1
      GO TO 220
   90 IF (NT-NI-BETA) 80,100,100
C
C     SET SHIFT FLAG
C
  100 SHIFT =-1
      IF (TLEFT .LT. TO+BETA*TI) GO TO 80
C
C     WRAP UP FOR SHIFT
C
      DONE  = NF
      IEXIT = 0
      GO TO 220
C
C     USER LIMIT ITERATION NUMBER EXPIRED
C
  110 CONTINUE
      IEXIT = 4
      DONE  =-1
      GO TO 220
C
C     WRAP UP FOR NO SHIFT
C
  120 CONTINUE
      IF (NI .GE. NT) GO TO 110
      SHIFT = 1
      DONE  = NF
      GO TO 220
C
C     PARAMETER ERROR, EPSIO HAS NO VALUE
C
  200 IEXIT = 5
      GO TO 220
C
C     AFTER SSG2B, EPSI IS ZERO DUE TO THE FIRST VAULE FROM SCR2 IS ZERO
C     WHILE VALUE FROM SCR1 IS NOT ZERO
C
  210 IEXIT = 6
C
C     EXIT FROM MODULE
C
  220 CALL PAGE2 (-9)
      WRITE  (NOUT,230) UIM,IEXIT,COUNT,DONE,SHIFT,DSEPSI
  230 FORMAT (A29,' 7019, MODULE DSCHK IS EXITING FOR REASON',I4, /5X,
     1       'ON ITERATION NUMBER',I7,1H.,
     2       /5X,'PARAMETER VALUES ARE AS FOLLOWS',/10X,'DONE   =',I10,
     3       /10X,'SHIFT  =',I10, /10X,'DSEPSI =',1P,E14.7)
      IF (IEXIT .GE. 5) WRITE (NOUT,240) EPSIO,EPSI
  240 FORMAT ( 10X,'EPSIO  =',1P,E10.3, /10X,'EPSI   =',1P,E10.3)
      RETURN
C
C     INTERNAL ROUTINE TO OBTAIN VALUE FROM MATRIX
C
  300 CALL GOPEN (FILE,IZ(IBUF1),0)
      CALL UNPACK (*310,FILE,VALUE)
      GO TO 320
  310 VALUE = 0.0
  320 CALL CLOSE (FILE,1)
      GO TO IRETN, (10,20)
      END

C*DECK,DMPALT
      SUBROUTINE DMPALT (ISIZE, IOPEN      , IPTAPE)
C******************************************************************
C                              NOTICE                             *
C                              ------                             *
C                                                                 *
C     THIS PROGRAM BELONGS TO RPK CORPORATION.  IT IS CONSIDERED  *
C  A TRADE SECRET AND IS NOT TO BE DIVULGED OR USED BY PARTIES    *
C  WHO HAVE NOT RECEIVED WRITTEN AUTHORIZATION FROM RPK.          *
C******************************************************************
C
      INTEGER   ALTFIL, OLDALT, XALTER(2)
C
      DIMENSION IALTER(2), IOPEN(1), ISUBR(2), ICARD(18)
C
      COMMON /ALTRXX/ ALTFIL, NEWALT, NOGO
      COMMON /SYSTEM/ ISYSBF, NOUT
      COMMON /XRGDXX/ IDUM(115), NMDMAP
C
      DATA OLDALT /0/
      DATA ISUBR  /4HDMPA, 4HLT  /
      DATA XALTER /4HXALT, 4HER  /
C
      IPOINT = 1
      CALL WRITE (IPTAPE, XALTER, 2, 1)
      IF (NEWALT .EQ. 0) GO TO 200
      N2DMAP = 2*NMDMAP
      CALL SKPFIL (ALTFIL, 1)
      CALL READ (*2000, *100, ALTFIL, IOPEN, ISIZE, 1, IEND)
      IREQD = N2DMAP - ISIZE
      CALL MESAGE (-8, IREQD, ISUBR)
  100 IF (IEND .NE. N2DMAP) GO TO 2100
      IPOINT = IPOINT + IEND
      CALL REWIND (ALTFIL)
C
  200 CALL READ (*3000, *300, ALTFIL, IOPEN(IPOINT), 19, 1, IFLAG)
      NWORDS = 19
      LOGIC = 200
      GO TO 2200
C
  300 IF (IFLAG .NE. 2) GO TO 400
      LOGIC = 300
      ASSIGN 320 TO JGOTO
      GO TO 1200
C
C     PROCESS ALTER CARDS HERE
C
  320 IALTER(1) = IOPEN(IPOINT  )
      IALTER(2) = IOPEN(IPOINT+1)
      IF (IALTER(2).EQ.0 .OR. IALTER(2).GE.IALTER(1)) GO TO 1000
      ITEMP = IALTER(2)
      IALTER(2) = IALTER(1)
      IALTER(1) = ITEMP
      GO TO 1000
C
  400 IF (IFLAG .NE. 4) GO TO 500
      NWORDS = 4
      LOGIC = 400
      IF (NEWALT .EQ. 0) GO TO 2200
      LOGIC = 410
      ASSIGN 420 TO JGOTO
      GO TO 1200
C
C     PROCESS INSERT CARDS HERE
C
  420 IDMAP1 = IOPEN(IPOINT  )
      IDMAP2 = IOPEN(IPOINT+1)
      IOCCUR = IOPEN(IPOINT+2)
      IOFFST = IOPEN(IPOINT+3)
      ASSIGN 470 TO IGOTO
      GO TO 1500
  470 IALTER(1) = INUMBR
      IALTER(2) = 0
      GO TO 1000
C
  500 IF (IFLAG .NE. 5) GO TO 600
      NWORDS = 5
      LOGIC = 500
      IF (NEWALT .EQ. 0) GO TO 2200
      LOGIC = 510
      ASSIGN 520 TO JGOTO
      GO TO 1200
C
C     PROCESS DELETE CARDS WITH ONE FIELD HERE
C
  520 IDMAP1 = IOPEN(IPOINT  )
      IDMAP2 = IOPEN(IPOINT+1)
      IOCCUR = IOPEN(IPOINT+2)
      IOFFST = IOPEN(IPOINT+3)
      ICHECK = IOPEN(IPOINT+4)
      LOGIC = 520
      IF (ICHECK .NE. 0) GO TO 2300
      ASSIGN 570 TO IGOTO
      GO TO 1500
  570 IALTER(1) = INUMBR
      IALTER(2) = INUMBR
      GO TO 1000
C
  600 IF (IFLAG .NE. 9) GO TO 700
      NWORDS = 9
      LOGIC = 600
      IF (NEWALT .EQ. 0) GO TO 2200
      LOGIC = 610
      ASSIGN 620 TO JGOTO
      GO TO 1200
C
C     PROCESS DELETE CARDS WITH TWO FIELDS HERE
C
  620 IDMAP1 = IOPEN(IPOINT  )
      IDMAP2 = IOPEN(IPOINT+1)
      IOCCUR = IOPEN(IPOINT+2)
      IOFFST = IOPEN(IPOINT+3)
      ICHECK = IOPEN(IPOINT+4)
      LOGIC = 620
      IF (ICHECK .NE. 1) GO TO 2300
      ASSIGN 670 TO IGOTO
      GO TO 1500
  670 IALTER(1) = INUMBR
      IDMAP1 = IOPEN(IPOINT+5)
      IDMAP2 = IOPEN(IPOINT+6)
      IOCCUR = IOPEN(IPOINT+7)
      IOFFST = IOPEN(IPOINT+8)
      ASSIGN 690 TO IGOTO
      GO TO 1500
  690 IALTER(2) = INUMBR
      IF (IALTER(2).EQ.0 .OR. IALTER(2).GE.IALTER(1)) GO TO 1000
      ITEMP = IALTER(2)
      IALTER(2) = IALTER(1)
      IALTER(1) = ITEMP
      GO TO 1000
C
C     PROCESS DMAP STATEMENTS HERE
C
  700 NWORDS = IFLAG
      LOGIC = 700
      IF (IFLAG .NE. 18) GO TO 2200
      CALL WRITE (IPTAPE, IOPEN(IPOINT), 18, 1)
      GO TO 200
C
C     WRITE ALTER CONTROL DATA ON THE NEW PROBLEM TAPE
C
 1000 IF (IALTER(1) .EQ. 0) GO TO 200
      IF (IALTER(1) .GT. OLDALT) GO TO 1100
 1050 NOGO = 1
      WRITE (NOUT, 3300) ICARD
      GO TO 200
 1100 IF (IALTER(2).NE.0 .AND. IALTER(1).GT.IALTER(2)) GO TO 1050
      CALL WRITE (IPTAPE, IALTER, 2, 1)
      OLDALT = IALTER(1)
      IF (IALTER(2) .NE. 0) OLDALT = IALTER(2)
      GO TO 200
C
C     INTERNAL SUBROUTINE TO READ IN AN ALTER CONTROL CARD IMAGE
C
 1200 CALL READ (*2000, *1230, ALTFIL, ICARD, 19, 1, IFLAG)
      NWORDS = 19
      GO TO 2200
 1230 GO TO JGOTO, (320, 420, 520, 620)
C
C     INTERNAL SUBROUTINE TO FIND THE DMAP STATEMENT NUMBER
C     FOR A DMAP STATEMENT WITH A GIVEN OCCURENCE FLAG AND
C     AN OFFSET FLAG
C
 1500 ICOUNT = 0
      DO 1600 J = 1, IEND, 2
      IF (IDMAP1.NE.IOPEN(J) .OR. IDMAP2.NE.IOPEN(J+1)) GO TO 1600
      ICOUNT = ICOUNT + 1
      IF (ICOUNT .LT. IOCCUR) GO TO 1600
      INUMBR = (J+1)/2 + IOFFST
      IF (INUMBR.GE.1 .AND. INUMBR.LE.NMDMAP) GO TO 1700
      NOGO = 1
      INUMBR = 0
      WRITE (NOUT, 3500) ICARD
      GO TO 1700
 1600 CONTINUE
      NOGO = 1
      INUMBR = 0
      IF (ICOUNT .GT. 0) WRITE (NOUT, 3600) ICARD
      IF (ICOUNT .EQ. 0) WRITE (NOUT, 3700) ICARD
 1700 GO TO IGOTO, (470, 570, 670, 690)
C
C     ERROR MESSAGES
C
 2000 CALL MESAGE (-2, ALTFIL, ISUBR)
 2100 WRITE (NOUT, 4100) IEND, N2DMAP
      GO TO 2900
 2200 WRITE (NOUT, 4200) NWORDS, LOGIC
      GO TO 2900
 2300 WRITE (NOUT, 4300) LOGIC
      GO TO 2900
 2900 CALL MESAGE (-61, 0, 0)
C
 3000 RETURN
C***********************************************************************
 3300 FORMAT ('0*** USER FATAL MESSAGE, THE DATA ON THE ',
     *        'FOLLOWING ALTER CONTROL CARD IS NOT IN PROPER ',
     *        'SEQUENCE OR ORDER --'//
     *        5X, 18A4)
 3500 FORMAT ('0*** USER FATAL MESSAGE, ILLEGAL OFFSET FLAG ',
     *         'SPECIFIED ON THE FOLLOWING ALTER CONTROL CARD --'//
     *        5X, 18A4)
 3600 FORMAT ('0*** USER FATAL MESSAGE, ILLEGAL OCCURENCE FLAG ',
     *         'SPECIFIED ON THE FOLLOWING ALTER CONTROL CARD --'//
     *        5X, 18A4)
 3700 FORMAT ('0*** USER FATAL MESSAGE, NON-EXISTENT NOMINAL ',
     *        'DMAP STATEMENT SPECIFIED ON THE FOLLOWING ',
     *        'ALTER CONTROL CARD --'//
     *        5X, 18A4)
 4100 FORMAT ('0*** SYSTEM FATAL MESSAGE, ILLEGAL NUMBER OF ',
     *        'WORDS (', I5, ') ENCOUNTERED IN THE SECOND ',
     *        'FILE OF THE ALTER SCRATCH FILE.'/
     *        '     EXPECTED NUMBER OF WORDS = ', I5)
 4200 FORMAT ('0*** SYSTEM FATAL MESSAGE, ILLEGAL NUMBER OF ',
     *        'WORDS (', I5, ') ENCOUNTERED WHILE READING ',
     *        'A RECORD IN THE FIRST FILE OF THE ALTER SCRATCH ',
     *        'FILE.'/
     *        '     LOGIC ERROR NO. = ', I5)
 4300 FORMAT ('0*** SYSTEM FATAL MESSAGE, ILLEGAL CONTROL WORD ',
     *        'WHILE PROCESSING THE FOLLOWING ALTER CONTROL CARD'//
     *        5X, 18A4)
C***********************************************************************
C                              NOTICE                             *
C                              ------                             *
C                                                                 *
C     THIS PROGRAM BELONGS TO RPK CORPORATION.  IT IS CONSIDERED  *
C  A TRADE SECRET AND IS NOT TO BE DIVULGED OR USED BY PARTIES    *
C  WHO HAVE NOT RECEIVED WRITTEN AUTHORIZATION FROM RPK.          *
C******************************************************************
      END

      SUBROUTINE ESTMAG (HEST,ESTFLD,MPT,DIT,GEOM1,IANY,KCOUNT)
C
C     CREATE SCRATCH FILE ESTFLD WHICH WILL BE USED TO COMPUTE TOTAL
C     MAGNETIC FIELD. READ EST AND CREATE SIMILAR RECORDS CONTAINING
C     ELTYPE,EID,NUMBER OF SILS,SILS,3 X 3 MATERIALS MATRIX, AND 3 X 3
C     TRANSFORMATION MATRIX TO BRING HM BACK TO BASIC COORD. SYSTEM
C     FROM ELEMENT SYSTEM,OUTPUT COORD. SYSTEM ID, AND BASIC COORDS.
C     OF STRESS POINT(USUALLY AVERAGE OF GRID COORDS.)
C
      INTEGER         HEST,ESTFLD,SYSBUF,ELTYPE,POINTR(6,20),MCB(7),
     1                BUF1,BUF2,IZ(1),NAM(2),ESTWDS,FRSTGD,OTPE,DIT,
     2                BFIELD(2),OLDEID,BUF3,FILE,GEOM1
      DIMENSION       DN(8),XM(32),COORD(3),KOUNT(2),NAME(2),V12(3),
     1                V13(3),XI(3),XJ(3),XK(3),ECPT(200),IECPT(200),
     2                E(9),G(9)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /GPTA1 / NELEMS,LAST,INCR,NE(1)
      COMMON /SYSTEM/ SYSBUF,OTPE
      COMMON /ZZZZZZ/ Z(1)
      COMMON /HMATDD/ IIHMAT,NNHMAT,MPTFIL,IDITFL
      COMMON /MATIN / MATID,INFLAG,ELTEMP,STRESS,SINTH,COSTH
      COMMON /HMTOUT/ XMAT(6)
      EQUIVALENCE     (Z(1),IZ(1)),(ECPT(1),IECPT(1))
      DATA    NAM   / 4HESTM,4HAG  /
      DATA    BFIELD/ 3101,31      /
      DATA    DN    / 4*-.25, 4*.5 /
C
C     ITYPE ITH MID ISYS1 ITEMP DIM
C
      DATA POINTR/   1,   0,  4,   9,   17,   1,
     1               3,   0,  4,   8,   16,   1,
     2               6,   5,  6,  15,   27,   2,
     3               9,   5,  6,   9,   21,   2,
     4              10,   0,  4,   9,   17,   1,
     5              16,   6,  7,  10,   26,   2,
     6              17,   5,  6,   9,   21,   2,
     7              18,   6,  7,  10,   26,   2,
     8              19,   6,  7,  16,   32,   2,
     9              34,   0, 16,  34,   42,   1,
     1              36,   5,  6,   7,   19,   2,
     2              37,   6,  7,   8,   24,   2,
     3              39,   0,  2,   7,   23,   3,
     3              40,   0,  2,   9,   33,   3,
     4              41,   0,  2,  11,   43,   3,
     5              42,   0,  2,  11,   43,   3,
     6              65,   0, 10,  16,   48,   3,
     6              66,   0, 22,  28,  108,   3,
     7              67,   0, 34,  40,  168,   3,
     8              80,  11, 12,  14,   46,   2     /
C
      LCORE = KORSZ(Z)
      BUF1  = LCORE - SYSBUF + 1
      BUF2  = BUF1  - SYSBUF
      BUF3  = BUF2  - SYSBUF - 1
      LCORE = BUF3  - 1
      IF (LCORE .LE. 0) GO TO 1008
C
C     COUNT NUMBER OF TERMS IN A COLUMN OF HCCEN
C
      KCOUNT = 0
C
C     SET UP MATERIALS
C
      IIHMAT = 0
      NNHMAT = LCORE
      MPTFIL = MPT
      IDITFL = DIT
      CALL PREHMA (Z)
      NEXTZ  = NNHMAT + 1
C
      CALL GOPEN (HEST,Z(BUF1),0)
      CALL GOPEN (ESTFLD,Z(BUF2),1)
C
C     READ IN ANY BFIELD CARDS
C
      IANY   = 0
      IALL   = 1
      IFIELD = 0
      IDEFID = 0
      NFIELD = 0
      FILE   = GEOM1
      CALL PRELOC (*1001,Z(BUF3),GEOM1)
      CALL LOCATE (*3,Z(BUF3),BFIELD,IDEX)
      IANY   = 1
      CALL READ (*1002,*1,GEOM1,Z(NEXTZ+1),LCORE-NEXTZ,0,IWORDS)
      GO TO 1008
    1 NFIELD = IWORDS/2
      IF (NFIELD.NE.1 .OR. IZ(NEXTZ+2).NE.-1) GO TO 2
      IFIELD = IZ(NEXTZ+1)
      IDEFID = IFIELD
      GO TO 3
C
C     BFIELD ARE NOT THE SAME FOR EVERY ELEMENT
C
    2 IALL = 0
    3 CALL CLOSE (GEOM1,1)
C
C     CHECK FOR ALL SO THAT CSTM WONT BE OPENED
C
      IF (NFIELD .EQ. 0) GO TO 8
      DO 4 I = 1,IWORDS,2
      IF (IZ(NEXTZ+I) .NE. 0) GO TO 5
    4 CONTINUE
      IANY = 0
      IALL = 1
      IFIELD = 0
    5 CONTINUE
C
C     CHECK FOR A DEFAULT ID
C
      DO 6 I = 2,IWORDS,2
      IF (IZ(NEXTZ+I) .EQ. -1) GO TO 7
    6 CONTINUE
      GO TO 8
    7 IDEFID = IZ(NEXTZ+I-1)
    8 CONTINUE
      FILE = HEST
C
   10 CALL READ (*120,*1003,HEST,ELTYPE,1,0,IFLAG)
      CALL WRITE (ESTFLD,ELTYPE,1,0)
      OLDEID = 0
      ICOUNT = 0
      IDX    = (ELTYPE-1)*INCR
      ESTWDS = NE(IDX+12)
      NGRIDS = NE(IDX+10)
      FRSTGD = 2
      IF (ELTYPE.GE.39 .AND. ELTYPE.LE.42) FRSTGD = 3
      NAME(1) = NE(IDX+1)
      NAME(2) = NE(IDX+2)
C
C     PICK UP MATERIAL ID, START OF BGPDT DATA, AND DIMENSIONALITY OF
C     ELEMENT
C
      DO 20 I = 1,20
      JEL = I
      IF (ELTYPE-POINTR(1,I)) 500,30,20
   20 CONTINUE
      GO TO 500
C
   30 ITH   = POINTR(2,JEL)
      MID   = POINTR(3,JEL)
      ISYS1 = POINTR(4,JEL)
      ISYS2 = ISYS1 + 4
      ISYS3 = ISYS2 + 4
C
C     FOR IS2D8, USE 4TH POINT FOR GEOMETRY SINCE THAT IS WHAT WE USE
C     FOR IS2D8 ELSEWHERE
C
      IF (ELTYPE .EQ. 80) ISYS3 = ISYS3 + 4
      ITEMP = POINTR(5,JEL)
      IDIM  = POINTR(6,JEL)
C
   40 CALL READ (*1002,*110,HEST,ECPT,ESTWDS,0,IFLAG)
      IF (ELTYPE .LT. 65) KCOUNT = KCOUNT + 3
      IF (ELTYPE .EQ. 65) KCOUNT = KCOUNT + 27
      IF (ELTYPE.EQ.66 .OR. ELTYPE.EQ.67) KCOUNT = KCOUNT + 63
      IF (ELTYPE .EQ. 80) KCOUNT = KCOUNT + 27
C
C     FIND BFIELD FOR THIS ELEMENT
C
      IF (IALL .EQ. 1) GO TO 47
      DO 45 I = 2,IWORDS,2
      IF (IECPT(1) .EQ. IZ(NEXTZ+I)) GO TO 46
   45 CONTINUE
      IFIELD = IDEFID
      GO TO 47
   46 IFIELD = IZ(NEXTZ+I-1)
   47 CONTINUE
C
C     WRITE EID, SILS
C
      CALL WRITE (ESTFLD,IECPT(1),1,0)
      CALL WRITE (ESTFLD,NGRIDS,1,0)
      CALL WRITE (ESTFLD,IECPT(FRSTGD),NGRIDS,0)
C
C     FETCH MATERIALS
C
      MATID = IECPT(MID)
      SINTH = 0.
      COSTH = 0.
C***
C    ASSUME HERE THAT FOR ISOPARAMETRICS WE HAVE TEMPERATURE-INDEPENDENT
C    MATERIALS IN THIS MAGNETICS PROBLEM
C***
      ELTEMP = ECPT(ITEMP)
      INFLAG = 3
      CALL HMAT (IECPT(1))
      G(1) = XMAT(1)
      G(2) = XMAT(2)
      G(3) = XMAT(3)
      G(4) = XMAT(2)
      G(5) = XMAT(4)
      G(6) = XMAT(5)
      G(7) = XMAT(3)
      G(8) = XMAT(5)
      G(9) = XMAT(6)
C
C     NOW CREATE TRANSFORMATION MATRIX FROM LOACL COORDS TO BASIC
C     DETERMINE DIMENSIONALITY OF ELEMENT
C
      GO TO (50,70,90), IDIM
C
C     ONE-DIMENSIONAL-DETERMINE THE LOCAL X-AXIS(IN BASIC COORDS)
C
   50 DO 55 I = 1,3
   55 V12(I) = ECPT(ISYS2+I) - ECPT(ISYS1+I)
      XLEN   = SQRT(V12(1)**2 + V12(2)**2 + V12(3)**2)
      DO 60 I = 1,3
   60 V12(I) = V12(I)/XLEN
C
      DO 65 I = 1,9
   65 E(I) = 0.
      E(1) = V12(1)
      E(4) = V12(2)
      E(7) = V12(3)
      GO TO 100
C
C     TWO-DIMENSIONAL  WE WILL USE ONLY GRIDS 1,2,3 ASSUMING A PLANAR
C     OR NEARLY PLANAR ELEMENT FOR QUADS
C
   70 DO 75 I = 1,3
      V12(I) = ECPT(ISYS2+I) - ECPT(ISYS1+I)
      V13(I) = ECPT(ISYS3+I) - ECPT(ISYS1+I)
   75 CONTINUE
      XLEN  = SQRT(V12(1)**2 + V12(2)**2 + V12(3)**2)
      DO 78 I = 1,3
   78 XI(I) = V12(I)/XLEN
C
      XK(1) = XI(2)*V13(3) - XI(3)*V13(2)
      XK(2) = XI(3)*V13(1) - XI(1)*V13(3)
      XK(3) = XI(1)*V13(2) - XI(2)*V13(1)
      XLEN  = SQRT(XK(1)**2 + XK(2)**2 + XK(3)**2)
      DO 80 I = 1,3
   80 XK(I) = XK(I)/XLEN
C
      XJ(1) = XK(2)*XI(3) - XK(3)*XI(2)
      XJ(2) = XK(3)*XI(1) - XK(1)*XI(3)
      XJ(3) = XK(1)*XI(2) - XK(2)*XI(1)
      XLEN  = SQRT(XJ(1)**2 + XJ(2)**2 + XJ(3)**2)
      DO 85 I = 1,3
   85 XJ(I) = XJ(I)/XLEN
C
      DO 86 I = 1,3
      E(3*I-2) = XI(I)
      E(3*I-1) = XJ(I)
      E(3*I  ) = XK(I)
   86 CONTINUE
C
C     CHECK ON MATERIALS AS IN EMRING
C
      ANGLE = ECPT(ITH)*0.017453293
      IF (XMAT(3).EQ.0. .AND. XMAT(5).EQ.0.) GO TO 87
      GO TO 100
   87 IF (ABS(ANGLE) .LE. .0001) GO TO 100
      DO 88 I = 1,9
   88 G(I) = 0.
      S    = SIN(ANGLE)
      C    = COS(ANGLE)
      CSQ  = C*C
      SSQ  = S*S
      CS   = C*S
      X2   = 2.*CS*XMAT(2)
      G(1) = CSQ*XMAT(1) - X2 + SSQ*XMAT(4)
      G(2) = CS*(XMAT(1) - XMAT(4)) + (CSQ-SSQ)*XMAT(2)
      G(5) = SSQ*XMAT(1) + X2 + CSQ*XMAT(4)
      G(4) = G(2)
      G(9) = XMAT(6)
C
      IF (ELTYPE.NE.36 .AND. ELTYPE.NE.37) GO TO 100
C
C     SINCE MAT5 INFO FOR TRAPRG,TRIARG MUST BE GIVEN IN X-Y TERMS,
C     RE-ORDER THE 3 X 3 , INTERCHANGING Y AND Z
C
      TEMP = G(5)
      G(5) = G(9)
      G(9) = TEMP
      TEMP = G(2)
      G(2) = G(3)
      G(3) = TEMP
      G(4) = G(2)
      G(7) = G(3)
      GO TO 100
C
C     THREE-DIMENSIONAL-NO ELEMENT COORDINATE SYSTEM-EVERYTHING IS
C     OUTPUT IN BASIC- SO E IS IDENTITY
C
   90 DO 95 I = 1,9
   95 E(I) = 0.
      E(1) = 1.
      E(5) = 1.
      E(9) = 1.
C
  100 CALL WRITE (ESTFLD,G,9,0)
      CALL WRITE (ESTFLD,E,9,0)
      IF (ELTYPE.GE.65 .AND. ELTYPE.LE.67) GO TO 104
C
C     COMPUTE THE AVERAGE COORDINATES OF THE GRID POINTS OF THE ELEMENT
C     FOR USE IN NON-RECTANGULAR COORDIANTE SYSTEMS. THIS POINT IS NOT
C     NECESSARILY THE CENTROID,BUT ANY POINT WILL DO FOR CONSTANT STRAIN
C     ELEMENTS AND THIS IS CONVENIENT
C
      IF (ELTYPE .NE. 80) GO TO 1013
C
C     FOR IS2D8 USE SHAPE FUNCTION
C
      DO 1012 I = 1,3
      COORD(I) = 0.
      DO 1012 J = 1,8
      JSUB = ISYS1 + 4*(J-1)
      COORD(I) = COORD(I) + DN(J)*ECPT(JSUB+I)
 1012 CONTINUE
      GO TO 108
 1013 CONTINUE
      DO 102 I = 1,3
      COORD(I) = 0.
      DO 102 J = 1,NGRIDS
      JSUB = ISYS1 + 4*(J-1)
      COORD(I) = COORD(I) + ECPT(JSUB+I)
  102 CONTINUE
      DO 103 I = 1,3
  103 COORD(I) = COORD(I)/FLOAT(NGRIDS)
      GO TO 108
C
C     ISOPARAMETRICS-PICK UP COORDS. OF APPLICABLE POINT. FOR THE LAST
C     POINT, GO TO THE PREVIOUS METHOD
C
  104 IF (IECPT(1) .EQ. OLDEID) GO TO 105
      OLDEID = IECPT(1)
  105 ICOUNT = ICOUNT + 1
      IF (ELTYPE.EQ.65 .AND. ICOUNT.LT. 9) GO TO 106
      IF (ELTYPE.GT.65 .AND. ICOUNT.LT.21) GO TO 106
C
C     CENTROIDAL POINT-COMPUTE COORDS BASED ON XI=ETA=ZETA=0
C
      ICOUNT = 0
      OLDEID = 0
      IF (ELTYPE .NE. 65) GO TO 1051
      DO 1050 I = 1,8
 1050 XM(I) = .125
      GO TO 1057
 1051 IF (ELTYPE .NE. 66) GO TO 1054
      DO 1052 I = 1,20
 1052 XM(I) = .25
      DO 1053 I = 1,7,2
      XM(I) =-.25
 1053 XM(I+12) =-.25
      GO TO 1057
 1054 CON1 =  9./64.
      CON2 =-19./64.
      DO 1055 I = 1,32
 1055 XM(I) = CON1
      DO 1056 I = 1,10,3
      XM(I) = CON2
 1056 XM(I+20) = CON2
C
 1057 DO 1058 I = 1,3
      COORD(I) = 0.
      DO 1058 J = 1,NGRIDS
      JSUB = ISYS1 + 4*(J-1)
      COORD(I) = COORD(I) + ECPT(JSUB+I)*XM(J)
 1058 CONTINUE
      GO TO 109
  106 IF (ELTYPE.EQ.67 .AND. ICOUNT.LT.21) GO TO 1071
      JSUB = ISYS1 + 4*(ICOUNT-1)
      DO 107 I = 1,3
  107 COORD(I) = ECPT(JSUB+I)
      IF (ICOUNT .GT. 1) GO TO 109
      GO TO 108
C
C     FOR IHEX3, MUST GET PROPER COORDINATES IF NOT THE LAST POINT
C
 1071 IF (ICOUNT.GE.9 .AND. ICOUNT.LE.12) GO TO 1072
      IF ((ICOUNT/2)*2 .EQ. ICOUNT) GO TO 1073
C
C     CORNERS
C
      IF (ICOUNT.EQ.1 .OR. ICOUNT.EQ.13) JCOUNT =-1
      IADD = 0
      IF (ICOUNT .GE. 13) IADD = 8
      JCOUNT = JCOUNT + 1
      NUM = 1
      KOUNT(1) = ICOUNT + JCOUNT + IADD
      GO TO 1075
C
C     MIDSIDES
C
 1072 KADD = 4
      JCO  = 3
      GO TO 1074
 1073 KADD = 1
      IF (ICOUNT.EQ.2 .OR. ICOUNT.EQ.14) JCO = -1
 1074 IADD = 0
      IF (ICOUNT .GE. 14) IADD = 8
      JCO  = JCO + 1
      NUM  = 2
      KOUNT(1) = ICOUNT + JCO + IADD
      KOUNT(2) = KOUNT(1) + KADD
 1075 DO 1077 I = 1,3
      COORD(I) = 0.
      DO 1076 J = 1,NUM
      JSUB = ISYS1 + 4*(KOUNT(J)-1)
 1076 COORD(I) = COORD(I) + ECPT(JSUB+I)
 1077 CONTINUE
      DO 1078 I = 1,3
 1078 COORD(I) = COORD(I)/FLOAT(NUM)
      IF (ICOUNT .GT. 1) GO TO 109
C
C     WRITE OUT CID AND COORDINATES
C
  108 CALL WRITE (ESTFLD,IFIELD,1,0)
  109 CALL WRITE (ESTFLD,COORD,3,0)
C
C     FOR ISOPARAMETRICS, GET COORDS OF NEXT POINT, OTHERWISE,
C     GO BACK FOR ANOTHER ELEMENT OF THIS TYPE
C
      IF (OLDEID .EQ. 0) GO TO 40
      GO TO 105
C
C
C     GET ANOTHER ELEMENT TYPE
C
  110 CALL WRITE (ESTFLD,0,0,1)
      GO TO 10
C
C     DONE
C
  120 CALL CLOSE (ESTFLD,1)
      CALL CLOSE (HEST,1)
      MCB(1) = HEST
      CALL RDTRL (MCB)
      MCB(1) = ESTFLD
      CALL WRTTRL (MCB)
      RETURN
C
C     FATAL ERRORS
C
  500 WRITE  (OTPE,501) UFM,NAME
  501 FORMAT (A23,', ELEMENT TYPE ',2A4,' NOT ALLOWED IN ESTMAG')
      CALL MESAGE (-61,0,0)
C
 1001 N = -1
      GO TO 1010
 1002 N = -2
      GO TO 1010
 1003 N = -3
      GO TO 1010
 1008 N = -8
      FILE = 0
 1010 CALL MESAGE (N,FILE,NAM)
      RETURN
      END

      SUBROUTINE APD12
C
      EXTERNAL        ORF
      LOGICAL         LS,LC,DLB
      INTEGER         AUSET(6,2),ORF,PSPA,UK,USA,IZ(1),NAM(2),
     1                EID,PID,CP,CIDBX,ACSID,SILB,SCR1,SCR2,SCR3,SCR4,
     2                SCR5,ECTA,BGPA,GPLA,USETA,SILA,CSTMA,ACPT,BUF10,
     3                BUF11,BUF12,IAX(20),
     4                CA2S,CA2E,CA3S,CA3E,CA4S,CA4E,
     5                PA2S,PA2E,PA3S,PA3E,PA4S,PA4E
      COMMON /SYSTEM/ SYSBUF,IUT
      COMMON /APD1C / EID,PID,CP,NSPAN,NCHORD,LSPAN,LCHORD,IGID,
     1                X1,Y1,Z1,X12,X4,Y4,Z4,X43,XOP,X1P,ALZO,MCSTM,
     2                NCST1,NCST2,CIDBX,ACSID,IACS,SILB,NCRD,SCR1,
     3                SCR2,SCR3,SCR4,SCR5,ECTA,BGPA,GPLA,USETA,SILA,
     4                CSTMA,ACPT,BUF10,BUF11,BUF12,NEXT,LEFT,ISILN,
     5                NCAM,NAEF1,NAEF2,NCA1,NCA2,CA2S,CA2E,CA3S,CA3E,
     6                CA4S,CA4E,NPA1,NPA2,PA2S,PA2E,PA3S,PA3E,PA4S,PA4E
      COMMON /APD12C/ KEY(5),AUSET,USA,UK,NCAM2,NASB,IPPC
      COMMON /BITPOS/ IBIT(64)
      COMMON /TWO   / ITWO(32)
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE    (Z(1),IZ(1)),(EID,IAX(1))
      DATA    NAM   /4HAPD1,4H2   /
C
      I17 = IBIT(17)
      I18 = IBIT(18)
      I19 = IBIT(19)
      I20 = IBIT(20)
      PSPA= ORF(ITWO(I17),ITWO(I20))
      USA = ORF(PSPA,ITWO(I18))
      UK  = ORF(ITWO(I19),ITWO(I20))
      DO 10 J = 1,2
      DO 10 I = 1,6
   10 AUSET(I,J) = USA
      AUSET(3,2) = UK
      AUSET(5,2) = UK
      NCAM = ((NCA2-NCA1)+1)/16
      IF (NCA1 .EQ. 0) NCAM = 0
      NCAM2 = ((CA2E-CA2S)+1)/16
      IF (CA2S .EQ. 0) NCAM2 = 0
      LCA = 16
C
C     CREATE IGID SEQUENCE ARRAY
C
      NIGID1 = NEXT
      IGID2  = NEXT
      NIGID  = NEXT
      NX = NCA1
      J  = NIGID1
      IF (NCAM .EQ. 0) GO TO 15
      DO 240 I = 1,NCAM
      IZ(J) = IZ(NX+7)
      J = J + 1
      IZ(J) = NX
      NX = NX + LCA
  240 J = J + 1
C
C     SORT IGID ARRAY ON IGID
C
      CALL SORT (0,0,2,1,IZ(NIGID1),2*NCAM)
   15 IF (NCAM2 .EQ. 0) GO TO 30
      NX = CA2S
      NIGID2 = J
      DO 20 I = 1,NCAM2
      IZ(J) = IZ(NX+7)
      J = J + 1
      IZ(J) = NX
      NX = NX + LCA
   20 J = J + 1
      CALL SORT (0,0,2,1,IZ(NIGID2),2*NCAM2)
      IGID2 = NIGID2
   30 NEXTC = J
      IF (NCAM .EQ. 0) GO TO 500
      NIGID = NIGID1
C
C     OUTTER LOOP PROCESSES CAERO1 CARDS
C
      DO 410 I = 1,NCAM
C
C     SET APD1 INPUT COMMON BLOCK
C
      NC = IZ(NIGID+1) - 1
C
C     MOVE CAERO TO COMMON
C
      DO 250 J = 1,16
      N1 = J + NC
  250 IAX(J) = IZ(N1)
      MCSTM  = MCSTM + 1
      IZ(NC+2) = MCSTM
C
C     FIND PAERO1 CARD
C
      IF (NPA1 .EQ. 0) GO TO 890
      DO 260 J = NPA1,NPA2,8
      IPPC = J
      IF (PID .EQ. IZ(J)) GO TO 270
  260 CONTINUE
      GO TO 890
  270 XOP  = .25
      X1P  = .75
      ALZO = 0.0
C
C     FIND AEFACT ARRAYS IF PRESENT
C
      JSPAN  = NSPAN
      JCHORD = NCHORD
      IF (LSPAN .EQ. 0) GO TO 280
      CALL APDOE (LSPAN,IZ,NAEF1,NAEF2,ISPAN,JSPAN)
      IF (ISPAN .EQ. 0) GO TO 850
      ISPAN = ISPAN + 1
      JSPAN = JSPAN - 1
  280 IF (LCHORD .EQ. 0) GO TO 350
      CALL APDOE (LCHORD,IZ,NAEF1,NAEF2,ICHORD,JCHORD)
      IF (ICHORD .EQ. 0) GO TO 860
      ICHORD = ICHORD + 1
      JCHORD = JCHORD - 1
  350 CONTINUE
C
C     CHECK IF FIRST OR LAST ENTRY IN IGID SET
C
      LS = .FALSE.
      IF (I .EQ. 1) GO TO 370
      IF (IZ(NIGID) .EQ. IZ(NIGID-2)) GO TO 380
  370 LS = .TRUE.
  380 LC = .FALSE.
      DLB= .FALSE.
      IF (I .EQ. NCAM) GO TO 390
      IF (IZ(NIGID) .EQ. IZ(NIGID+2)) GO TO 400
  390 LC = .TRUE.
C
C     CHECK FOR CAERO2 ELEMENT
C
      IF (NCAM2 .EQ. 0) GO TO 400
      IF (NIGID2 .GT. NEXTC) GO TO 50
   40 IF (IZ(NIGID2) .GT. IZ(NIGID)) GO TO 50
      IF (IZ(NIGID) .EQ. IZ(NIGID2)) DLB = .TRUE.
      IF (DLB) GO TO 50
      NIGID2 = NIGID2 + 2
      IF (NIGID2 .GT. NEXTC) GO TO 50
      GO TO 40
   50 CONTINUE
      IF (DLB) LC = .FALSE.
C
C     CALL APD1 TO MANUFACTURE BOXES
C
  400 CALL APD1 (Z(ISPAN),JSPAN,Z(ICHORD),JCHORD,LS,LC)
      NCHORD = JCHORD
      NSPAN  = JSPAN
      IZ(NC+4) = NSPAN
      IZ(NC+5) = NCHORD
      IZ(NC+8) = 1
      IF (.NOT.DLB) GO TO 410
C
C     PROCESS CAERO2 WITH CAERO1
C
      CALL APD2 (1,IZ(NEXT),IZ(IGID2 ),NEXTC,IZ(NIGID))
  410 NIGID = NIGID + 2
C
C     PROCESS CAERO2 CARDS NOT PROCESSED YET
C
  500 IF (NCAM2 .EQ. 0) GO TO 1000
      CALL APD2 (0,IZ(NEXT),IZ(IGID2 ),NEXTC,IZ(NIGID))
 1000 RETURN
C
C     ERROR MESSAGES
C
  812 CALL MESAGE (-61,0,NAM)
  850 CALL EMSG (0,2326,1,2,0)
      WRITE  (IUT,851) EID,LSPAN
  851 FORMAT (10X,19HCAERO1 ELEMENT NO. ,I8,28H REFERENCES AEFACT CARD N
     1O. ,I8,22H WHICH DOES NOT EXIST.)
      GO TO 812
  860 CALL EMSG (0,2327,1,2,0)
      WRITE (IUT,851) EID,LCHORD
      GO TO 812
  890 CALL EMSG (0,2323,1,2,0)
      WRITE  (IUT,891) PID,EID
  891 FORMAT (10X,16HPAERO1 CARD NO. , I8,31H REFERENCED BY CAERO1 CARD
     1NO. ,I8,20H BUT DOES NOT EXIST.)
      GO TO 812
      END

      SUBROUTINE IFP5
C
C     ACOUSTIC CAVITY PREFACE ROUTINE
C
C     THIS PREFACE MODULE OPERATES ON ACOUSTIC-CAVITY-ANALYSIS DATA
C     CARDS WHICH AT THIS POINT ARE IN THE FORM OF IFP-OUTPUT IMAGES ON
C     THE AXIC DATA BLOCK.
C
C     THE FOLLOWING LIST GIVES THE CARD IMAGES IFP5 WILL LOOK FOR ON THE
C     AXIC OR GEOM2 DATA BLOCKS,  THE CARD IMAGES IFP5 WILL GENERATE OR
C     MODIFY, AND THE DATA BLOCKS ONTO WHICH THE GENERATED OR MODIFIED
C     CARD IMAGES WILL BE PLACED.
C
C      IFP5 INPUT         IFP5 OUTPUT        DATA BLOCK
C      CARD IMAGE         CARD IMAGE         EFFECTED
C     ------------       -----------        ----------
C      AXSLOT/AXIC        -NONE-             -NONE-
C      CAXIF2/GEOM2       PLOTEL             GEOM2
C      CAXIF3/GEOM2       PLOTEL             GEOM2
C      CSLOT3/GEOM2       PLOTEL             GEOM2
C      CSLOT4/GEOM2       PLOTEL             GEOM2
C      CAXIF4/GEOM2       PLOTEL             GEOM2
C      GRIDF/AXIC         GRID               GEOM1
C      GRIDS/AXIC         GRID               GEOM1
C      SLBDY/AXIC         CELAS2             GEOM2
C
C     SOME OF THE ABOVE OUTPUT DATA CARDS ARE A FUNCTION OF MORE THAN
C     ONE INPUT DATA CARDS
C
      LOGICAL         G1EOF    ,G2EOF    ,PLOTEL   ,ANY
      INTEGER         SYSBUF   ,OUTPUT   ,RD       ,RDREW    ,CLS      ,
     1                BUF(24)  ,Z        ,WRT      ,WRTREW   ,CLSREW   ,
     2                CORE     ,SUBR(2)  ,FLAG     ,
     3                CAXIF(6) ,CSLOT(4) ,GRID(2)  ,CELAS2(2),PLOTLS(2),
     4                CARD(10) ,EOR      ,GRIDS(2) ,GRIDF(2) ,SLBDY(2) ,
     5                WORDS    ,BUF1     ,BUF2     ,BUF3     ,BUF4     ,
     6                FILE     ,GEOM1    ,GEOM2    ,SCRT1    ,SCRT2    ,
     7                AXSLOT(2),MSG1(2)  ,MSG2(2)  ,AXIC     ,ENTRYS
      REAL            RZ(4)    ,RBUF(24) ,RR(3)    ,ZZ(3)    ,WW(3)    ,
     1                L1       ,L2       ,L3       ,L1L2     ,KF       ,
     2                LE       ,LC       ,RCARD(10)
      COMMON /CONDAS/ CONSTS(5)
      COMMON /SYSTEM/ KSYSTM(65)
      COMMON /NAMES / RD,RDREW ,WRT      ,WRTREW   ,CLSREW   ,CLS
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE     (CONSTS(2),TWOPI)  ,(KSYSTM(1),SYSBUF),
     1                (KSYSTM(2),OUTPUT) ,(Z(1),RZ(1)),
     2                (BUF(1),RBUF(1))   ,(CARD(1),RCARD(1))
      DATA    AXSLOT/ 1115,   11 /
      DATA    SLBDY / 1415,   14 /
      DATA    CAXIF / 2108,   21
     1              , 2208,   22
     2              , 2308,   23 /
      DATA    CELAS2/  701,    7 /
      DATA    CSLOT / 4408,   44
     1              , 4508,   45 /
      DATA    GRID  / 4501,   45 /
      DATA    GRIDS / 1315,   13 /
      DATA    GRIDF / 1215,   12 /
      DATA    PLOTLS/ 5201,   52 /
      DATA    SUBR  / 4HIFP5, 4H    /
      DATA    EOR   , NOEOR / 1, 0  /
C
C     NOTE...  SCRATCH2 IN IFP5 AS IN IFP4 IS EQUIVALENCED TO THE
C     -FORCE- DATA BLOCK.
C
      DATA AXIC, GEOM1, GEOM2, SCRT1, SCRT2 / 215, 201, 208, 301, 213 /
      DATA MSG1/ 4HIFP5, 4HBEGN/, MSG2 /4HIFP5, 4HEND /
C
C     DEFINE CORE AND BUFFER POINTERS
C
      CALL CONMSG (MSG1,2,0)
      CORE = KORSZ(Z)
      BUF1 = CORE - SYSBUF - 2
      BUF2 = BUF1 - SYSBUF - 2
      BUF3 = BUF2 - SYSBUF - 2
      BUF4 = BUF3 - SYSBUF - 2
      CORE = BUF4 - 1
      ICRQ = 100  - CORE
      IF (CORE .LT. 100) GO TO 980
      PLOTEL = .FALSE.
C
C     OPEN AXIC DATA BLOCK. (IF NAME IS NOT IN FIST RETURN - NO MESSAGE)
C
      CALL PRELOC (*910,Z(BUF1),AXIC)
C
C     PICK UP THE AXSLOT CARD AND SAVE THE VALUES ON IT.
C     RHOD, BD, N, WD, MD (FATAL ERROR IF NOT PRESSENT)
C
      CALL LOCATE (*10,Z(BUF1),AXSLOT,FLAG)
      CALL READ (*920,*30,AXIC,Z(1),6,EOR,WORDS)
   10 CALL IFP5A (1)
      WRITE  (OUTPUT,20)
   20 FORMAT (' AXSLOT DATA CARD IS NOT PRESENT OR IS INCORRECT.')
C
C     SET VALUES FOR CONTINUING DATA CHECK
C
      RHOD = 0.0
      BD   = 0.0
      N    = 0
      WD   = 1.0
      MD   = 0
      GO TO 40
   30 IF (WORDS .NE. 5) GO TO 10
      RHOD = RZ(1)
      BD   = RZ(2)
      J    = 3
      N    = Z(J)
      WD   = RZ(4)
      MD   = Z(J+2)
C
C     READ GRIDS DATA CARDS INTO CORE FROM AXIC DATA BLOCK.
C
   40 IGRIDS = 1
      NGRIDS = IGRIDS - 1
      CALL LOCATE (*70,Z(BUF1),GRIDS,FLAG)
      CALL READ (*920,*60,AXIC,Z(IGRIDS),CORE,EOR,WORDS)
      CALL IFP5A (2)
      WRITE  (OUTPUT,50)
   50 FORMAT (49H INSUFFICIENT CORE TO HOLD ALL GRIDS CARD IMAGES.)
      WRITE  (OUTPUT,431) CORE
      GO TO 70
   60 NGRIDS = NGRIDS + WORDS
C
C     READ GRIDF DATA CARDS INTO CORE FROM AXIC DATA BLOCK.
C
   70 IGRIDF = NGRIDS + 1
      NGRIDF = IGRIDF - 1
      CALL LOCATE (*100,Z(BUF1),GRIDF,FLAG)
      CALL READ (*920,*90,AXIC,Z(IGRIDF),CORE-NGRIDS,EOR,WORDS)
      CALL IFP5A (3)
      WRITE  (OUTPUT,80)
   80 FORMAT (49H INSUFFICIENT CORE TO HOLD ALL GRIDF CARD IMAGES.)
      ICRQ = CORE - NGRIDS
      WRITE (OUTPUT,431) ICRQ
      GO TO 100
   90 NGRIDF = NGRIDF + WORDS
C
C     INSERT DEFAULT SLOT WIDTH INTO ANY GRIDS IMAGE HAVING NONE
C     SPECIFIED BY THE USER.
C
  100 IF (NGRIDS .LT. IGRIDS) GO TO 170
      DO 110 I = IGRIDS,NGRIDS,5
      IF (Z(I+3) .EQ. 1) RZ(I+3) = WD
  110 CONTINUE
C
C     CREATE A GRIDF CARD FOR EACH GRIDS DATA CARD THAT HAS A NON-ZERO
C     IDF
C
      DO 140 I = IGRIDS,NGRIDS,5
      IF (Z(I+4)) 140,140,130
  130 NGRIDF = NGRIDF + 3
      IF (NGRIDF .GT. CORE) GO TO 150
      Z(NGRIDF-2) = Z(I+4)
      Z(NGRIDF-1) = Z(I+1)
      Z(NGRIDF  ) = Z(I+2)
  140 CONTINUE
      GO TO 170
  150 CALL IFP5A (4)
      WRITE  (OUTPUT,160)
  160 FORMAT (' INSUFFICIENT CORE TO HOLD ALL GRIDF CARD IMAGES BEING ',
     1       'CREATED INTERNALLY DUE TO GRIDS CARDS SPECIFYING AN IDF.')
      ICRQ = NGRIDF - CORE
      WRITE (OUTPUT,431) ICRQ
      NGRIDF = NGRIDF - 3
C
C     SORT THE GRIDF CARDS ON THEIR ID.
C
  170 IF (NGRIDF .GT. IGRIDF)
     1    CALL SORT (0,0,3,1,Z(IGRIDF),NGRIDF-IGRIDF+1)
C
C     OPEN GEOM1 AND SCRATCH1, COPY HEADER REC FROM GEOM1 TO SCRATCH1.
C
      CALL IFP4C (GEOM1,SCRT1,Z(BUF2),Z(BUF3),G1EOF)
C
C     COPY ALL DATA FROM GEOM1 TO SCRATCH1 UP TO FIRST GRID CARD.
C
      CALL IFP4B (GEOM1,SCRT1,ANY,Z(NGRIDF+1),CORE-NGRIDF,GRID,G1EOF)
      FILE = GEOM1
C
C     CREATE GRID CARDS FROM GRIDS AND GRIDF CARDS.
C     MERGE THESE INTO EXISTING GRID CARDS CHECKING FOR DUPLICATE ID-S.
C
      IGF  = IGRIDF
      IDGF = 0
      IGS  = IGRIDS
      IDGS = 0
      IF (IGF .LT. NGRIDF) IDGF = Z(IGF)
      IF (IGS .LT. NGRIDS) IDGS = Z(IGS)
      CARD(2) = 0
      CARD(6) =-1
      CARD(7) = 0
      CARD(8) = 0
C
C     READ A GRID CARD INTO BUF.
C
      IF (.NOT.ANY) GO TO 190
  180 CALL READ (*940,*190,GEOM1,BUF,8,NOEOR,WORDS)
      IDG = BUF(1)
      GO TO 200
  190 IDG = 0
C
C     DETERMINE WHETHER GRID, GRIDF, OR GRIDS CARD IS TO OUTPUT NEXT.
C
  200 IF (  IDG    ) 210,210,250
  210 IF (  IDGF   ) 220,220,230
  220 IF (  IDGS   ) 390,390,370
  230 IF (  IDGS   ) 360,360,240
  240 IF (IDGF-IDGS) 360,330,370
  250 IF (  IDGF   ) 260,260,280
  260 IF (  IDGS   ) 350,350,270
  270 IF (IDG -IDGS) 350,330,370
  280 IF (IDG -IDGF) 310,330,290
  290 IF (  IDGS   ) 360,360,300
  300 IF (IDGF-IDGS) 360,330,370
  310 IF (  IDGS   ) 360,360,320
  320 IF (IDG -IDGS) 350,330,370
C
C     ERROR - DUPLICATE ID-S ENCOUNTERED
C
  330 CALL IFP5A (10)
      WRITE  (OUTPUT,340) IDG,IDGS,IDGF
  340 FORMAT (' ONE OF THE FOLLOWING NON-ZERO IDENTIFICATION NUMBERS ',
     1        'APPEARS ON SOME COMBINATION', /,' OF GRID, GRIDS, OR ',
     2        'GRIDF BULK DATA CARDS.',3(6H   ID=,I12))
      IF (IDG .EQ. IDGF) GO TO 350
      IF (IDG .EQ. IDGS) GO TO 350
      GO TO 370
C
C     OUTPUT GRID CARD AND READ ANOTHER
C
  350 CALL WRITE (SCRT1,BUF,8,NOEOR)
      GO TO 180
C
C     OUTPUT A GRID FROM GRIDF CARD.
C
  360 CARD(1)  = IDGF
      RCARD(3) = RZ(IGF+1)
      RCARD(4) = RZ(IGF+2)
      RCARD(5) = 0.0
      IGF = IGF + 3
      IF (IGF .GT. NGRIDF) IDGF = 0
      IF (IDGF .NE. 0) IDGF = Z(IGF)
      GO TO 380
C
C     OUTPUT A GRID FROM GRIDS CARD.
C
  370 CARD(1)  = IDGS
      RCARD(3) = RZ(IGS+1)
      RCARD(4) = RZ(IGS+2)
      RCARD(5) = RZ(IGS+3)
      IGS = IGS + 5
      IF (IGS .GT. NGRIDS) IDGS = 0
      IF (IDGS .NE. 0) IDGS = Z(IGS)
  380 CALL WRITE (SCRT1,CARD,8,NOEOR)
      GO TO 200
C
C     ALL GRID CARDS HAVE BEEN OUPTUT, WRITE EOR.
C
  390 CALL WRITE (SCRT1,0,0,EOR)
C
C     COPY BALANCE OF GEOM1 TO SCRT1, WRAP UP AND COPY BACK.
C
      CALL IFP4B (GEOM1,SCRT1,ANY,Z(IGRIDF),CORE-IGRIDF,-1,G1EOF)
C
C     SLBDY CARD IMAGES ARE NOW PROCESSED AND A BOUNDARY TABLE IS FORMED
C     IN CORE.  EACH ENTRY IN THE TABLE CONTAINS,
C
C              IDS , IDS   , IDS   , RHO, M
C                 I     I-1     I+1
C
C     IDS    = -1 IF IDS  IS THE FIRST ID ON SLBDY CARD.
C        I-1            I
C
C     IDS    = -1 IF IDS  IS THE LAST ID ON SLBDY CARD.
C        I+1            I
C
      ISLBDY = NGRIDS + 1
      NSLBDY = ISLBDY - 1
      CALL LOCATE (*440,Z(BUF1),SLBDY,FLAG)
  400 CALL READ (*920,*440,AXIC,BUF,2,NOEOR,WORDS)
      RHO = RBUF(1)
      M   = BUF(2)
      IDSL1 = -1
      CALL READ (*920,*930,AXIC,IDS,1,NOEOR,WORDS)
  410 CALL READ (*920,*930,AXIC,IDSP1,1,NOEOR,WORDS)
C
C     PLACE 5 WORD ENTRY INTO CORE
C
      NSLBDY = NSLBDY + 5
      IF (NSLBDY .GT. CORE) GO TO 420
      Z(NSLBDY-4) = IDS
      Z(NSLBDY-3) = IDSL1
      Z(NSLBDY-2) = IDSP1
      RZ(NSLBDY-1) = RHO
      Z(NSLBDY   ) = M
      IDSL1 = IDS
      IDS   = IDSP1
      IF (IDSP1+1) 410,400,410
C
C     OUT OF CORE
C
  420 CALL IFP5A (5)
      WRITE  (OUTPUT,430)
  430 FORMAT (' INSUFFICIENT CORE TO CONSTRUCT ENTIRE BOUNDARY TABLE ',
     1        'FOR SLBDY CARDS PRESENT.')
      ICRQ = NSLBDY - CORE
      WRITE  (OUTPUT,431) ICRQ
  431 FORMAT (5X,24HADDITIONAL CORE NEEDED =,I8,7H WORDS.)
      NSLBDY = NSLBDY - 5
C
C     SKIP BALANCE OF SLBDY DATA.
C
      CALL READ (*920,*440,AXIC,BUF,1,EOR,WORDS)
C
C     SORT BOUNDARY TABLE ON IDS . (FIRST WORD OF EACH ENTRY)
C                               I
C
  440 IF (NSLBDY .GT. ISLBDY)
     1    CALL SORT (0,0,5,1,Z(ISLBDY),NSLBDY-ISLBDY+1)
C/////
C     CALL BUG (10H BOUNDRY      ,440,Z(ISLBDY),NSLBDY-ISLBDY+1)
C
C     OPEN GEOM2, OPEN SCRATCH2, COPY HEADER REC FROM GEOM2 TO SCRATCH2.
C
      FILE = GEOM2
      CALL IFP4C (GEOM2,SCRT2,Z(BUF2),Z(BUF3),G2EOF)
C
C     OPEN SCRATCH1, FOR TEMPORARY OUTPUT OF PLOTEL IMAGES CREATED FROM
C     CAXIF2, CAXIF3, CAXIF4, CSLOT3, AND CSLOT4 CARDS.
C
      FILE = SCRT1
      CALL OPEN (*960,SCRT1,Z(BUF4),WRTREW)
C
C     CREATE PLOTEL IMAGES FROM CAXIF2, CAXIF3, AND CAXIF4 AT THIS TIME
C
      FILE = GEOM2
      DO 490 I = 1,3
      IBASE = (I-1)*1000000
      IF (I .EQ. 3) IBASE = 4000000
      K  = 2*I - 1
      K4 = I + 5
C
C     CHECK TRAILER TO SEE IF CAXIF(I+1) EXISTS
C
      CALL IFP4F (CAXIF(K+1),GEOM2,ANY)
      IF (.NOT.ANY) GO TO 490
C
C     COPY ALL DATA FROM GEOM2 TO SCRATCH2 UP TO FIRST CAXIF(I+1) IMAGE.
C
      CALL IFP4B(GEOM2,SCRT2,ANY,Z(NSLBDY+1),CORE-NSLBDY,CAXIF(K),G2EOF)
      IF (.NOT.ANY) GO TO 1610
C
C     COPY EACH IMAGE TO SCRATCH2 AND CREATE PLOTELS AT SAME TIME.
C
  460 CALL READ (*940,*480,GEOM2,BUF,K4,NOEOR,WORDS)
      CALL WRITE (SCRT2,BUF,K4,NOEOR)
      NLINES = I + 1
      IF (I .EQ. 1) NLINES = 1
      DO 470 J = 1,NLINES
      CARD(1) = BUF(1) + IBASE + J*1000000
      CARD(2) = BUF(J+1)
      JJ = J + 1
      IF (JJ.GT.NLINES .AND. NLINES.NE.1) JJ = 1
      CARD(3) = BUF(JJ+1)
      CALL WRITE (SCRT1,CARD,3,NOEOR)
  470 CONTINUE
      PLOTEL = .TRUE.
      GO TO 460
C
C     END OF RECORD HIT ON GEOM2.  COMPLETE RECORD ON SCRATCH2
C
  480 CALL WRITE (SCRT2,0,0,EOR)
  490 CONTINUE
C
C     COPY ALL DATA FROM GEOM2 TO SCRATCH2 UP TO FIRST CELAS2 CARD
C     IMAGE.
C
      CALL IFP4B (GEOM2,SCRT2,ANY,Z(NSLBDY+1),CORE-NSLBDY,CELAS2,G2EOF)
C
C     COPY ANY CELAS2 DATA CARDS, MAKE SURE ALL ID ARE LESS THAN
C     10000001.
C
      IF (.NOT.ANY) GO TO 540
  510 CALL READ (*940,*540,GEOM2,BUF,8,NOEOR,WORDS)
      IF (BUF(1) .LT. 10000001) GO TO 530
      CALL IFP5A (6)
      WRITE  (OUTPUT,520) BUF(1)
  520 FORMAT (' CELAS2 DATA CARD HAS ID =',I14,
     1  ', WHICH IS GREATER THAN 10000000,', /,' AND 10000000 IS THE ',
     2  'LIMIT FOR CELAS2 ID WITH ACOUSTIC ANALYSIS DATA CARDS PRESENT')
  530 CALL WRITE (SCRT2,BUF,8,NOEOR)
      GO TO 510
C
C     OUTPUT THREE CELAS2 IMAGES FOR EACH ENTRY IN THE BOUNDARY TABLE.
C
  540 IF (NSLBDY .LT. ISLBDY) GO TO 800
      ENTRYS = (NGRIDS-IGRIDS+1)/5
C/////
C     CALL BUG(10H BOUNDRY      ,540,Z(ISLBDY),NSLBDY-ISLBDY+1)
C     CALL BUG(10H GRIDS        ,540,Z(IGRIDS),NGRIDS-IGRIDS+1)
      IDE = 10000000
      DO 790 I = ISLBDY,NSLBDY,5
C
C     FIND  R, Z, W FOR IDS , IDS   , IDS    RESPECTIVELY.
C                          I     I-1     I+1
C
      K   = 0
      IS1 = I
      IS3 = I + 2
      DO 600 J = IS1,IS3
      K = K + 1
      IF (Z(J)  ) 570,580,550
  550 IF (ENTRYS) 580,580,560
  560 KID = Z(J)
      CALL BISLOC (*580,KID,Z(IGRIDS),5,ENTRYS,JPOINT)
      NTEMP = IGRIDS + JPOINT
C
C     NTEMP NOW POINTS TO THE SECOND WORD OF THE GRIDS ENTRY HAVING
C     THE ID SPECIFIED BY Z(J).  (1ST,2ND,OR 3RD ID IN SLBDY ENTRY)
C
C
C     NO CELAS2 CARDS ARE GENERATED IF GRIDS FOR IDS  HAS NO IDF.
C                                                   I
C
      IF (K .EQ. 1) IDF = Z(NTEMP+3)
      IF (K.EQ.1 .AND. IDF.LE.0) GO TO 790
      RR(K) = RZ(NTEMP  )
      ZZ(K) = RZ(NTEMP+1)
      WW(K) = RZ(NTEMP+2)
      GO TO 600
C
C     IDS = -1
C
  570 RR(K) = RR(1)
      ZZ(K) = ZZ(1)
      WW(K) = WW(1)
      GO TO 600
C
C     IDS COULD NOT BE FOUND IN GRIDS ENTRYS.
C
  580 CALL IFP5A (7)
      WRITE  (OUTPUT,590) Z(J)
  590 FORMAT (11H SLBDY ID =,I12,
     1        ' DOES NOT APPEAR ON ANY GRIDS DATA CARD.')
      RR(K) = 0.0
      ZZ(K) = 0.0
      WW(K) = 0.0
  600 CONTINUE
C
C     COMPUTE GEOMETRY AND OTHER DATA.
C
      L1 = SQRT((ZZ(3)-ZZ(1))**2 + (RR(3)-RR(1))**2)
      L2 = SQRT((ZZ(2)-ZZ(1))**2 + (RR(2)-RR(1))**2)
      L3 = SQRT((ZZ(3)-ZZ(2))**2 + (RR(3)-RR(2))**2)/2.0
C
      L1L2 = (L1 + L2)*4.0
      IF (L1L2) 610,610,630
C
C     ERROR, ZERO OR NEGATIVE LENGTH
C
  610 CALL IFP5A (8)
      WRITE  (OUTPUT,620) Z(I),Z(I+1),Z(I+2)
  620 FORMAT (' ONE OR MORE OF THE FOLLOWING ID-S NOT EQUAL TO -1 HAVE',
     1       ' INCORRECT OR NO GEOMETRY DATA',/3(10X,4HID = ,I10))
      GO TO 790
C
C     COMPUTE W-BAR AND R-BAR
C
  630 WBAR = (L1*WW(3) + L2*WW(2))/L1L2 + 0.75*WW(1)
      RBAR = (L1*RR(3) + L2*RR(2))/L1L2 + 0.75*RR(1)
C
      IF (WBAR  ) 640,610,640
  640 IF (RBAR  ) 650,610,650
  650 IF (Z(I+4)) 660,740,660
C
C     COMPUTE BETA,LC
C
  660 BETA = (TWOPI*RBAR)/(FLOAT(Z(I+4))*WBAR)
      IF (BETA - 1.0) 610,610,670
  670 BL1 = BETA - 1.0
      BP1 = BETA + 1.0
      LC  = WBAR/TWOPI
      LC  = LC*((BETA+1.0/BETA)*ALOG(BP1/BL1) +
     1          2.0*ALOG(BP1*BL1/(4.0*BETA)))
      TERM = 0.01*WBAR
      LE  = AMAX1(LC,TERM)
      IF (LE) 680,610,680
  680 IF (RZ(I+3)) 710,690,710
  690 CALL IFP5A (9)
      WRITE  (OUTPUT,700) Z(I)
  700 FORMAT (' RHO AS SPECIFIED ON SLBDY OR AXSLOT CARD IS 0.0 FOR ID',
     1        ' =',I12)
      GO TO 790
C
C     FIND F  = M, IF N=0 OR N=M/2  OTHERWISE F  = M/2
C           I                                  I
C
  710 IF (N.EQ.0 .OR. 2*N.EQ.Z(I+4)) GO TO 720
      FI = FLOAT(Z(I+4))/2.0
      GO TO 730
  720 FI = Z(I+4)
  730 KF = (WBAR*L3*FI)/(RZ(I+3)*LE)
      GO TO 750
C
C     M = 0, THUS K  = 0.0
C                  F
C
  740 KF = 0.0
C
C                           N WBAR
C                      SIN( ------ )
C                           2 RBAR
C     COMPUTE  ALPHA = --------------
C                           N WBAR
C                         ( ------ )
C                           2 RBAR
C
  750 TERM = (FLOAT(N)*WBAR)/(2.0*RBAR)
      IF (TERM) 760,770,760
  760 ALPHA = SIN(TERM)/TERM
      GO TO 780
  770 ALPHA = 1.0
C
C  OUTPUT THE 3 CELAS2 CARDS
C
  780 BUF( 1) = IDE + 1
      RBUF(2) = KF*(1.0 - ALPHA)
      BUF( 3) = Z(I)
      BUF( 4) = 0
      BUF( 5) = 1
      BUF( 6) = 0
      BUF( 7) = 0
      BUF( 8) = 0
      BUF( 9) = IDE + 2
      RBUF(10)= KF*ALPHA
      BUF(11) = Z(I)
      BUF(12) = IDF
      BUF(13) = 1
      BUF(14) = 1
      BUF(15) = 0
      BUF(16) = 0
      BUF(17) = IDE + 3
      RBUF(18)= KF*ALPHA*(ALPHA - 1.0)
      BUF(19) = IDF
      BUF(20) = 0
      BUF(21) = 1
      BUF(22) = 0
      BUF(23) = 0
      BUF(24) = 0
      CALL WRITE (SCRT2,BUF,24,NOEOR)
      IDE = IDE + 3
  790 CONTINUE
C
C     COMPLETE THE CELAS2 RECORD.
C
  800 CALL WRITE (SCRT2,0,0,EOR)
C
C     CREATE PLOTEL IMAGES FROM CSLOT3, AND CSLOT4 AT THIS TIME IF ANY
C
      DO 840 I = 1,2
      IBASE = 3000000*I + 5000000
      K  = 2*I - 1
      K6 = I + 7
C
C     CHECK TRAILER BIT TO SEE IF CSLOT(I+2) EXISTS.
C
      CALL IFP4F (CSLOT(K+1),GEOM2,ANY)
      IF (.NOT.ANY) GO TO 840
C
C     COPY ALL DATA FROM GEOM2 TO SCRATCH2 UP TO FIRST CSLOT(I+2) IMAGE.
C
      CALL IFP4B (GEOM2,SCRT2,ANY,Z(IGRIDS),CORE-IGRIDS,CSLOT(K),G2EOF)
      IF (.NOT.ANY) GO TO 1610
C
C     COPY EACH IMAGE TO SCRATCH2 AND CREATE PLOTELS AT SAME TIME.
C
  810 CALL READ (*940,*830,GEOM2,BUF,K6,NOEOR,WORDS)
      CALL WRITE (SCRT2,BUF,K6,NOEOR)
      NLINES = I + 2
      DO 820 J = 1,NLINES
      CARD(1) = BUF(1) + IBASE + J*1000000
      CARD(2) = BUF(J+1)
      JJ = J + 1
      IF (JJ .GT. NLINES) JJ = 1
      CARD(3) = BUF(JJ+1)
      CALL WRITE (SCRT1,CARD,3,NOEOR)
  820 CONTINUE
      PLOTEL = .TRUE.
      GO TO 810
C
C     END OF RECORD ON GEOM2.  COMPLETE RECORD ON SCRATCH2.
C
  830 CALL WRITE (SCRT2,0,0,EOR)
  840 CONTINUE
C
C     APPEND PLOTELS ON SCRATCH1 TO ANY PLOTELS ON GEOM2.
C     MAKE SURE ALL PLOTEL ID-S ARE .LE. 1000000
C     /// ID CHECK NOT IN YET.
C     POSITION TO PLOTELS ON GEOM2 IF ANY ARE ON SCRATCH1
C
      IF (.NOT. PLOTEL) GO TO 900
      CALL IFP4B (GEOM2,SCRT2,ANY,Z(IGRIDS),CORE-IGRIDS,PLOTLS,G2EOF)
      IF (.NOT.ANY) GO TO 870
C
C     BLAST COPY PLOTELS FROM GEOM2 TO SCRATCH2
C
  850 CALL READ (*940,*860,GEOM2,Z(IGRIDS),CORE-IGRIDS,NOEOR,WORDS)
      CALL WRITE (SCRT2,Z(IGRIDS),CORE-IGRIDS,NOEOR)
      GO TO 850
  860 CALL WRITE (SCRT2,Z(IGRIDS),WORDS,NOEOR)
C
C     CLOSE AND OPEN SCRATCH1 CONTAINING GENERATED PLOTEL IMAGES.
C
  870 FILE = SCRT1
      CALL CLOSE (SCRT1,CLSREW)
      CALL OPEN (*960,SCRT1,Z(BUF4),RDREW)
C
C     BLAST COPY PLOTELS FROM SCRATCH1 TO SCRATCH2.
C
  880 CALL READ (*890,*890,SCRT1,Z(IGRIDS),CORE-IGRIDS,NOEOR,WORDS)
      CALL WRITE (SCRT2,Z(IGRIDS),CORE-IGRIDS,NOEOR)
      GO TO 880
  890 CALL WRITE (SCRT2,Z(IGRIDS),WORDS,EOR)
  900 CALL CLOSE (SCRT1,CLSREW)
C
C     ALL PROCESSING OF GEOM2 IS COMPLETE SO COPY BALANCE OF GEOM2 TO
C     SCRATCH2, WRAP UP, AND COPY BACK.
C
      CALL IFP4B (GEOM2,SCRT2,ANY,Z(IGRIDS),CORE-IGRIDS,-1,G2EOF)
C
C     ALL PROCESSING COMPLETE.
C
  910 CALL CLOSE (AXIC,CLSREW)
      CALL CONMSG (MSG2,2,0)
      RETURN
C
C     END OF FILE ON AXIC.
C
  920 FILE = AXIC
      GO TO 940
C
C     END OF RECORD ON AXIC
C
  930 FILE = AXIC
      IER  = -3
      GO TO 2000
C
C     END OF FILE OR END OF RECORD ON -FILE-.
C
  940 IER = -2
      GO TO 2000
C
C     FILE NOT IN FIST
C
  960 IER = -1
      GO TO 2000
C
C     INSUFFICIENT CORE
C
  980 IER = -8
      FILE = ICRQ
      GO TO 2000
C
C     BISLOC EXIT
C
 1610 IER = -37
C
 2000 CALL MESAGE (IER,FILE,SUBR)
      RETURN
      END

      SUBROUTINE GFSTRN(A,AT,I,SCR1)
C
C     MATRIX TRANSPOSE ROUTINE
C
C     MORE EFFICIENT THEN TRANSPOSE FOR SPARSE MATRICES
C
C
C     TRANSPOSE IS SOLVED BY THE FOLLOWING EQUATION
C
C                                    T
C                  --    --   --   --  --   --
C                  I      I   I     I  I     I
C                  I  AT  I = I  A  I  I  I  I
C                  I      I   I     I  I     I
C                  --    --   --   --  --   --
C
C     WHERE I IS AN IDENITY MATRIX
C
C
      INTEGER       A        ,AT       ,I        ,SCR1     ,MCB(7)
     1             ,Z        ,SYSBUF   ,NAME(2)
C
C     SYSTEM PARAMETERS
C
      COMMON /SYSTEM /        SYSBUF
C
C     PACK COMMON
C
      COMMON / ZBLPKX /       VAL(4)   ,IROW
C
C     OPEN CORE
C
      COMMON / ZZZZZZ /        Z(1)
C
      DATA NAME / 4HGFST , 4HRN   /
C
C***********************************************************************
C
      NZ = KORSZ(Z)
      IBUF = NZ - SYSBUF
      IF(IBUF .LT. 0) CALL MESAGE(-8,0,NAME)
C
C     GET MATRIX TRAILER
C
      MCB(1) = A
      CALL RDTRL(MCB)
      IF(MCB(1) .LT. 0) RETURN
      IR = MCB(3)
C
C     GENERATE A SQUARE IDENITY MATRIX   IR BY IR
C
      VAL(1) = 1.0
      CALL MAKMCB(MCB,I,IR,2,2)
      CALL GOPEN(I,Z(IBUF),1)
C
      DO 10 IROW=1,IR
      CALL BLDPK(1,2,I,0,0)
      CALL ZBLPKI
      CALL BLDPKN(I,0,MCB)
   10 CONTINUE
      CALL CLOSE(I,1)
      CALL WRTTRL(MCB)
C
C     PERFORM MULTIPLY
C
      CALL SSG2B(A,I,0,AT,1,2,1,SCR1)
C
      RETURN
      END

      SUBROUTINE SDR3A (OFPFIL)
C
C     SORT-2  MODULE
C
      INTEGER         INAME(2),TRAIL(7),ID(146),IDTEMP(146),VECTOR(50),
     1                SCRTCH(8),OFILE(6),IFILE(6),BUFF(10),OFPFIL(6),Z,
     2                WORDS,EOF,CORE,BUFF9,BUFF10,GROUP,OUFILE,FILE,RECS
     3,               RECPT,EOR,OUTRWD,RWD,FULL,OVRLAP,V IN BK,W PER BK,
     4                V PER BK,TOTAL1,TOTAL2,AHEAD,ENTRYS(85)
      CHARACTER       UFM*23,UWM*25
      COMMON /XMSSG / UFM,UWM
      COMMON /SYSTEM/ IBUFSZ, L
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE     (NWDS,ID(10))
C
C     IF THE NUMBER OF SCRATCH FILES CHANGE, ONE SHOULD SET NSCRAT EQUAL
C     TO THE NEW NUMBER AND INCREASE THE DATA BELOW
C
C     NFILES BELOW EQUALS THE NUMBER OF INPUT FILES AND ALSO EQUALS
C     THE NUMBER OF OUTPUT FILES.  IF NFILES CHANGES, CHANGE THE DATA
C     BELOW TO CONFORM...
C     ALSO CHANGE DIMENSIONS OF BUFF,IFILE,OFILE,SCRTCH, AS REQUIRED...
C
      DATA    IFILE / 101,102,103,104,105,106 /
      DATA    OFILE / 201,202,203,204,205,206 /
      DATA    SCRTCH/ 301,302,303,304,305,306,307,308 /
      DATA    TRAIL / 0,1,2,3,4,5,6 /
      DATA    EOR   , NOEOR,RWD,INPRWD,OUTRWD / 1,0,1,0,1 /
C
      NFILES = 6
      NSCRAT = 8
      DO 4 I = 1,6
    4 OFPFIL(I) = 0
      DO 5 I = 1,146
      IDTEMP(I) = 0
    5 CONTINUE
C
C     BUFFERS AND OPEN CORE
C
      CORE = KORSZ(Z)
C
      BUFF(1) = CORE - IBUFSZ + 1
      DO 10 I = 2,10
      BUFF(I) = BUFF(I-1) - IBUFSZ
   10 CONTINUE
      BUFF9  = BUFF( 9)
      BUFF10 = BUFF(10)
      CORE   = BUFF(10) - 1
      IF (CORE .LT. 1) GO TO 700
C
C     OPEN SCRATCH FILES FOR OUTPUT
C
      IERROR = 0
      DO 30 I = 1,NSCRAT
      IBUFF = BUFF(I)
      CALL OPEN (*20,SCRTCH(I),Z(IBUFF),OUTRWD)
      GO TO 30
   20 IERROR = 1
      WRITE  (L,21) UWM,I
   21 FORMAT (A25,' 985, SDR3 FINDS SCRATCH',I1,' PURGED.')
   30 CONTINUE
C
C     EXECUTE FOR NFILES FILES
C
      DO 460 FILE = 1,NFILES
      EOF = 0
      INFILE = IFILE(FILE)
      OUFILE = OFILE(FILE)
C
      CALL OPEN (*460,INFILE,Z(BUFF9),INPRWD)
      CALL OPEN (*480,OUFILE,Z(BUFF10),OUTRWD)
      CALL FWDREC (*520,INFILE)
C
C     HEADER RECORD FOR OUFILE
C
      CALL FNAME (OUFILE,INAME(1))
      CALL WRITE (OUFILE,INAME(1),2,EOR)
C
C     WRITE SOME JUNK IN TRAILER FOR NOW
C
      TRAIL(1) = OUFILE
      CALL WRTTRL (TRAIL(1))
      NO FRQ = 0
C
C     PROCEED WITH TRANSPOSE OF DATA = SORT-2
C
C     GROUP WILL BE THE NUMBER OF THE FIRST REC IN THE PRESENT GROUP OF
C     DATA BLOCKS BEING OPERATED ON, LESS 1
C
      NRECS = 1
C
   50 ASSIGN 120 TO IRETRN
C
   60 CALL READ (*80,*620,INFILE,ID(1),146,EOR,IAMT)
      IF (ID(1)/10 .EQ. 1) NOFRQ = 1
      IDATA = 1
C
   70 ICORE = CORE
      RECS  = 0
      GROUP = NRECS
C
C     READ FIRST DATA BLOCK INTO CORE
C
      CALL READ (*530,*90,INFILE,Z(1),ICORE,NOEOR,IAMT)
C
C     INSUFFICIENT CORE,  IF FALL HERE, TO DO SORT II ON THIS FILE..
C
      GO TO 670
   80 CALL CLOSE (INFILE,RWD)
      CALL CLOSE (OUFILE,RWD)
      GO TO 460
C
   90 IF (IAMT .EQ. 0) GO TO 441
      ENTRYS(1) = IAMT/NWDS
C
C     SET UP IN-CORE ENTRY BLOCKS
C     SPOT FOR TRANSPOSE HEADING DATA IS AT Z(ICORE-ENTRYS(1)+1)
C
      IHD2  = ICORE + 1
      ICORE = ICORE - ENTRYS(1)
      IHEAD = ICORE
      IF (ICORE .LT. IAMT) GO TO 680
C
C     NOTATION - W PER BK = WORDS PER ENTRY BLOCK
C                V PER BK = VECTORS PER ENTRY BLOCK
C                V IN  BK = VECTORS NOW IN ENTRY BLOCKS
C
      W PER BK = ICORE/ENTRYS(1)
      V PER BK = W PER BK/NWDS
      W PER BK = V PER BK*NWDS
      IF (V PER BK .LT. 1) GO TO 690
C
C     DISTRIBUTE FIRST DATA BLOCK TO INCORE ENTRY BLOCKS (BOTTOM TO TOP)
C
      NENTRY = ENTRYS(1)
      TOTAL1 = W PER BK*ENTRYS(1) + 1
      TOTAL2 = NWDS*ENTRYS(1) + 1
      DO 110 I = 1,NENTRY
      N1  = TOTAL1 - W PER BK*I
      N2  = TOTAL2 - NWDS    *I
      IHD = IHD2 - I
      Z(IHD) = Z(N2)
      Z(N1 ) = ID(5)
C
C     SAVE TRANSPOSE HEADING
C
      DO 100 J = 2,NWDS
      N1 = N1 + 1
      N2 = N2 + 1
      Z(N1) = Z(N2)
  100 CONTINUE
  110 CONTINUE
C
      V IN BK = 1
      GO TO IRETRN, (120,150)
C
  120 NTYPES = 1
  130 CALL READ (*159,*630,INFILE,IDTEMP(1),146,EOR,IAMT)
      IF ((ID(2).EQ.IDTEMP(2) .AND. ID(3).EQ.IDTEMP(3) .AND.
     1     ID(5).NE.IDTEMP(5)) .OR. (ID(5).NE.IDTEMP(5)) .OR.
     2    (ID(4).NE.IDTEMP(4))) GO TO 160
C
      NTYPES = NTYPES + 1
      NWORDS = IDTEMP(10)
C
C     WILL READ DATA AND COUNT ENTRYS
C
      IF (NTYPES .GT. 30) GO TO 472
      ENTRYS(NTYPES) = 0
  140 CALL READ (*540,*130,INFILE,IDTEMP(1),NWORDS,NOEOR,IAMT)
      ENTRYS(NTYPES) = ENTRYS(NTYPES) + 1
      GO TO 140
C
  150 AHEAD = 2*NTYPES - 2
      IF (NDATA .EQ. 1) GO TO 260
      GO TO 170
C
C     AT THIS POINT IT IS KNOWN HOW MANY TYPES ARE IN THE PRESENT GROUP
C     OF DATA BLOCKS AND ALSO HOW MANY ENTRYS IN EACH TYPE
C
  159 IF (NTYPES .EQ. 1) EOF = 1
  160 ITYPE = 1
      NDATA = 1
      IDATA = 1
C
C     POSITION TO READ 2-ND ID OF TYPE(ITYPE) IF NOT JUST READ
C
      IF (NTYPES .EQ. 1) GO TO 200
      CALL REWIND (INFILE)
      AHEAD = GROUP + 2*NTYPES
  170 DO 180 I = 1,AHEAD
      CALL FWDREC (*550,INFILE)
  180 CONTINUE
C
  190 CALL READ (*260,*640,INFILE,IDTEMP(1),146,EOR,IAMT)
C
C     CHECK FOR BREAK POINT
C
  200 IF (NOFRQ .EQ. 1) GO TO 201
      IF (ID(4) .NE. IDTEMP(4)) GO TO 270
  201 CONTINUE
      IF (EOF .EQ. 1) GO TO 270
      IF (ITYPE .EQ. 1) NDATA = NDATA + 1
      IDATA  = IDATA + 1
      NENTRY = ENTRYS(ITYPE)
C
C     CHECK TO SEE IF THERE IS ENOUGH ROOM IN EACH OF THE INCORE
C     ENTRY BLOCKS FOR ANOTHER VECTOR
C     IF NOT DO SCRATCH FILE  OPERATIONS
C
      IF (V IN BK .LT. V PER BK) GO TO 220
C
C     NOT ENOUGH ROOM THUS DUMP CORE ENTRY BLOCKS ONTO SCRATCH FILES
C
      IF (IERROR .EQ. 1) GO TO 451
      NPOINT = 1
      NFILE  = NSCRAT
      DO 210 I = 1,NENTRY
      NFILE  = NFILE + 1
      IF (NFILE .GT. NSCRAT) NFILE = 1
      CALL WRITE (SCRTCH(NFILE),Z(NPOINT),W PER BK,EOR)
      NPOINT = NPOINT + W PER BK
  210 CONTINUE
      RECS = RECS + NENTRY
C
C     IN CORE ENTRY BLOCKS ARE NOW EMPTY
C
      V IN BK = 0
C
C     DISTRIBUTE DATA TO INCORE ENTRY BLOCKS
C
  220 NPOINT = V IN BK*NWDS + 1
      DO 230 I = 1,NENTRY
      IEOR = I/NENTRY
      CALL READ (*560,*650,INFILE,Z(NPOINT),NWDS,IEOR,IAMT)
      Z(NPOINT) = IDTEMP(5)
      NPOINT = NPOINT + W PER BK
  230 CONTINUE
      V IN BK = V IN BK + 1
C
      IF (NTYPES .EQ. 1) GO TO 190
      IF (ITYPE  .EQ. 1) GO TO 240
      IF (IDATA .EQ. NDATA) GO TO 270
C
C     NOW POSITION AHEAD TO READ NEXT ID FOR TYPE(ITYPE)
C
  240 AHEAD = 2*NTYPES - 2
      DO 250 I = 1,AHEAD
      CALL FWDREC (*570,INFILE)
  250 CONTINUE
      GO TO 190
C
C     ONE DATA TYPE IN THIS GROUP IS COMPLETE
C
C     OUTPUT IS IN CORE, AND ON SCRATCH FILES IF RECS IS NOT 0
C
C     NOW DUMP SCRATCHES AND (OR JUST) CORE ONTO FINAL OUTPUT TAPE
C
C     ID WILL BE WRITTEN BEFORE EACH ENTRY INSERTING INTO IT THE NEW
C     HEADER VALUE REPLACING FREQUENCY OR TIME ETC
C
  260 EOF = 1
  270 IF (RECS .EQ. 0) GO TO 290
C
      LAYERS = RECS/NENTRY
C
C     CLOSE SCRATCH FILES AND OPEN AS INPUT FILES
C
      DO 280 I = 1,NSCRAT
      CALL CLOSE (SCRTCH(I),RWD)
      IBUFF = BUFF(I)
      CALL OPEN (*500,SCRTCH(I),Z(IBUFF),INPRWD)
  280 CONTINUE
C
C     COMPUTE OVERLAPS PER LAYER
C
      OVRLAP = (NENTRY-1)/NSCRAT
C
C     COMPUTE HOW MANY TAPES HAVE ALL THE OVERLAPS
C
      FULL = NENTRY - OVRLAP*NSCRAT
C
C
C     WRITE FINAL FILE THEN
C
  290 NFILE = 0
      ID(2) = ID(2) + 2000
      DO 400 I = 1,NENTRY
      NFILE = NFILE + 1
      IF (NFILE .GT. NSCRAT) NFILE = 1
C
      NPOINT = IHEAD + I
      ID(5)  = Z(NPOINT)
      CALL WRITE (OUFILE,ID(1),146,EOR)
C
C     ANYTHING ON SCRATCH FILES IS NOW WRITTEN
C
      IF (RECS .EQ. 0) GO TO 390
C
      DO 380 J = 1,LAYERS
C
C     FORWARD REC IF NECESSARY
C
      IF (J .GT. 1) GO TO 320
C
C     AHEAD TO FIRST PART IF NECESSARY
C
      IF (LAYERS .EQ. 1) GO TO 350
      AHEAD = (I-1)/NSCRAT
C
      IF (AHEAD) 300,350,300
  300 DO 310 K = 1,AHEAD
      CALL FWDREC (*590,SCRTCH(NFILE))
  310 CONTINUE
      GO TO 350
C
  320 RECPT = OVRLAP
      IF (NFILE .GT. FULL) RECPT = RECPT - 1
      IF (RECPT) 350,350,330
  330 DO 340 K = 1,RECPT
      CALL FWDREC (*600,SCRTCH(NFILE))
  340 CONTINUE
C
C     COPY RECORD FROM SCRTCH TO OUTFILE
C
  350 DO 370 K = 1,VPERBK
      IEOR = K/V PER BK
      CALL READ (*610,*660,SCRTCH(NFILE),VECTOR(1),NWDS,IEOR,IAMT)
      CALL WRITE (OUFILE,VECTOR(1),NWDS,NOEOR)
  370 CONTINUE
  380 CONTINUE
      IF (LAYERS .GT. 1) CALL REWIND (SCRTCH(NFILE))
C
C     COPY INCORE VECTORS TO OUTFILE
C
  390 WORDS  = V IN BK*NWDS
      NPOINT = W PER BK*I - W PER BK + 1
      CALL WRITE (OUFILE,Z(NPOINT),WORDS,EOR)
  400 CONTINUE
      IF (RECS .EQ. 0) GO TO 420
C
C     CLOSE SCRTCH FILES AND OPEN AS OUTPUT FILES
C
      DO 410 I = 1,NSCRAT
      CALL CLOSE (SCRTCH(I),RWD)
      IBUFF = BUFF(I)
      CALL OPEN (*490,SCRTCH(I),Z(IBUFF),OUTRWD)
  410 CONTINUE
C
  420 IF (ITYPE .EQ. NTYPES) GO TO 440
C
      ITYPE = ITYPE + 1
      CALL REWIND (INFILE)
      AHEAD = GROUP + ITYPE*2 - 2
      DO 430 I = 1,AHEAD
      CALL FWDREC (*580,INFILE)
  430 CONTINUE
      ASSIGN 150 TO IRETRN
      EOF = 0
      GO TO 60
C
C     THIS GROUP IS ABSOLUTELY COMPLETE AND WE ARE AT BREAK POINT
C
  440 IF (EOF .EQ. 1) GO TO 80
      NRECS = NRECS + 2*NDATA*NTYPES
      IF (NTYPES .GT. 1) GO TO 50
  441 CONTINUE
      DO 450 I = 1,146
  450 ID(I) = IDTEMP(I)
      GO TO 70
C
C
C     ERROR CONDITIONS FOR THIS DATA BLOCK
C
C     FORMAT OF INPUT DATA BLOCK MAY BE INCORRECT (N=TRACEBACK CODE)
C
  490 N = 23
      GO TO 452
  500 N = 3
      GO TO 452
  520 N = 4
      GO TO 452
  530 N = 5
      GO TO 452
  540 N = 6
      GO TO 452
  550 N = 7
      GO TO 452
  560 N = 8
      GO TO 452
  570 N = 9
      GO TO 452
  580 N = 10
      GO TO 452
  590 N = 11
      GO TO 452
  600 N = 12
      GO TO 452
  610 N = 13
      GO TO 452
  620 N = 14
      GO TO 452
  630 N = 15
      GO TO 452
  640 N = 16
      GO TO 452
  650 N = 17
      GO TO 452
  660 N = 18
      GO TO 452
  452 OFPFIL(FILE) = N
      WRITE  (L,453) UWM,FILE
  453 FORMAT (A25,' 982, FORMAT OF SDR3 INPUT DATA BLOCK ',I3,
     1        ' DOES NOT PERMIT SUCCESSFUL SORT-2 PROCESSING.')
      GO TO 80
  472 WRITE  (L,475) UFM,NTYPES
  475 FORMAT (A23,' 3129, SDR3 CAN ONLY PROCESS 30 ELEMENT TYPES, ',
     1        'PROBLEM HAS',I5)
      CALL MESAGE (-61,0,0)
C
C     CORRESPONDING OUTPUT FILE IS PURGED.
C
  480 OFPFIL(FILE) = 2
      WRITE  (L,481) UWM,FILE
  481 FORMAT (A25,' 984,  SDR3 FINDS OUTPUT DATA-BLOCK',I4,' PURGED.')
      GO TO 80
C
C     ATTEMPT TO USE SCRATCH FILES 1 OR MORE OF WHICH ARE PURGED.
C
  451 OFPFIL(FILE) = 1
      GO TO 80
C
C     INSUFFICIENT CORE
C
  670 N = 19
      GO TO 701
  680 N = 20
      GO TO 701
  690 N = 21
      GO TO 701
  701 WRITE  (L,702) UWM,FILE
  702 FORMAT (A25,' 983, SDR3 HAS INSUFFICIENT CORE TO PERFORM SORT-2',
     1       ' ON INPUT DATA BLOCK',I4, /5X,
     2       'OR DATA-BLOCK IS NOT IN CORRECT FORMAT.')
      OFPFIL(FILE) = N
      GO TO 80
C
  460 CONTINUE
C
C     CLOSE SCRATCH FILES
C
      DO 470 I = 1,NSCRAT
      CALL CLOSE (SCRTCH(I),RWD)
  470 CONTINUE
C
      GO TO 801
  700 DO 704 I = 1,5
  704 OFPFIL(I) = 22
      WRITE  (L,703) UWM
  703 FORMAT (A25,' 986, INSUFFICIENT CORE FOR SDR3.')
  801 RETURN
      END

      SUBROUTINE ALG14 (XDATA,YDATA,NDATA,XIN,YOUT,YPRIME,NXY,NWOT)
C
C     THIS SPLINE ROUTINE DETERMINES Y AND/OR YPRIME  LINEAR EXTRAPOLATI
C     XDATA AND XIN MUST BE IN ASCENDING ORDER  E1 AND E2 ARE D2YDX2 LAS
C     D2YDX2 LAST-BUT-ONE AT ENDS OF SPECIFIED REGION OF BEAM
C
      REAL M
C
      DIMENSION A(65), B(65), D(65), M(65), XDATA(2), YDATA(2), XIN(1),
     1YOUT(1), YPRIME(1)
C
      IF (NDATA-2) 240,10,70
10    IF (NWOT-1) 20,40,20
20    DO 30 I=1,NXY
30    YOUT(I)=((YDATA(2)-YDATA(1))/(XDATA(2)-XDATA(1)))*(XIN(I)-XDATA(1)
     1)+YDATA(1)
40    IF (NWOT) 240,240,50
50    DO 60 I=1,NXY
60    YPRIME(I)=(YDATA(2)-YDATA(1))/(XDATA(2)-XDATA(1))
      GO TO 240
70    CONTINUE
      E1=1.0
      E2=1.0
      A(1)=1.0
      B(1)=-E1
      D(1)=0.0
      N=NDATA-1
      DO 80 I=2,N
      A(I)=(XDATA(I+1)-XDATA(I-1))/3.0-(XDATA(I)-XDATA(I-1))*B(I-1)/(6.0
     1*A(I-1))
      B(I)=(XDATA(I+1)-XDATA(I))/6.0
80    D(I)=(YDATA(I+1)-YDATA(I))/(XDATA(I+1)-XDATA(I))-(YDATA(I)-YDATA(I
     1-1))/(XDATA(I)-XDATA(I-1))-(XDATA(I)-XDATA(I-1))*D(I-1)/6.0/A(I-1)
      A(NDATA)=-E2
      B(NDATA)=1.0
      D(NDATA)=0.0
      M(NDATA)=A(NDATA)*D(N)/(A(NDATA)*B(N)-A(N)*B(NDATA))
      DO 90 II=2,NDATA
      I=NDATA+1-II
90    M(I)=(D(I)-B(I)*M(I+1))/A(I)
      J=1
      I=1
100   IF (XIN(I)-XDATA(1)) 190,190,110
110   IF (XIN(I)-XDATA(J+1)) 140,140,120
120   IF (J+1-NDATA) 130,140,140
130   J=J+1
      GO TO 110
140   IF (XIN(I)-XDATA(NDATA)) 150,220,220
150   DX=XDATA(J+1)-XDATA(J)
      IF (NWOT-1) 160,170,160
160   YOUT(I)=M(J)/(6.0*DX)*(XDATA(J+1)-XIN(I))**3+M(J+1)/(6.0*DX)*(XIN(
     1I)-XDATA(J))**3+(XDATA(J+1)-XIN(I))*(YDATA(J)/DX-M(J)/6.0*DX)+(XIN
     2(I)-XDATA(J))*(YDATA(J+1)/DX-M(J+1)/6.0*DX)
      IF (NWOT) 170,180,170
170   YPRIME(I)=(-M(J)*(XDATA(J+1)-XIN(I))**2/2.0+M(J+1)*(XIN(I)-XDATA(J
     1))**2/2.0+YDATA(J+1)-YDATA(J))/DX-(M(J+1)-M(J))/6.0*DX
180   I=I+1
      IF (I-NXY) 100,100,240
190   YDASH=(YDATA(2)-YDATA(1))/(XDATA(2)-XDATA(1))-(M(1)/3.0+M(2)/6.0)*
     1(XDATA(2)-XDATA(1))
      IF (NWOT-1) 200,210,200
200   YOUT(I)=YDATA(1)-YDASH*(XDATA(1)-XIN(I))
      IF (NWOT) 210,180,210
210   YPRIME(I)=YDASH
      GO TO 180
220   YDASH=(YDATA(NDATA)-YDATA(N))/(XDATA(NDATA)-XDATA(N))+(M(NDATA)/3.
     10+M(N)/6.0)*(XDATA(NDATA)-XDATA(N))
      IF (NWOT-1) 230,210,230
230   YOUT(I)=YDATA(NDATA)+YDASH*(XIN(I)-XDATA(NDATA))
      IF (NWOT) 210,180,210
240   RETURN
      END

      SUBROUTINE COMBIN (PG,ILIST,NLIST)
C
      INTEGER         SYSBUF,PG,NAME(2),HCFLDS,HCFLD,HCCENS,HCCEN,OTPE,
     1                REMFLS,REMFL,MCB(7)
      DIMENSION       ARY(1),ILIST(1),ALPHA(360),LOADN(360),LOADNN(360),
     1                IARY(1),ALPHA1(360),LODC1(7),HEAD(2)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /LOADX / LC,N(13),LODC,MASS
      COMMON /BLANK / NROWSP
      COMMON /SYSTEM/ SYSBUF,OTPE,DUM52(52),IPREC
      COMMON /ZZZZZZ/ CORE(1)
      COMMON /LOADS / NLOAD,IPTR
      COMMON /ZNTPKX/ A(4),LL,IEOL,IEOR
      COMMON /PACKX / ITA,ITB,II,JJ,INCUR
      EQUIVALENCE     (CORE(1),IARY(1),ARY(1))
C
C     ALSO COMBINE HCFLD AND REMFL IN MAGNETOSTATIC PROBLEMS
C
      DATA    HCFLDS, HCFLD /304,202/
      DATA    REMFLS, REMFL /305,203/
      DATA    HCCENS, HCCEN /307,204/
      DATA    NAME  / 4HCOMB,4HIN   /
C
C
      ITA = 1
      ITB = IPREC
      II  = 1
C
C     PERFORM CHECKS IN E AND M PROBLEM
C     IN E AND M PROBLEM, REMFLS AND HCFLDS MUST HAVE THE SAME NUMBER
C     OF COLUMNS AS PG
C
      MCB(1) = REMFLS
      CALL RDTRL (MCB)
      NPERMS = 0
      IF (MCB(1) .LE. 0) GO TO 1
      NPERMS = MCB(2)
    1 MCB(1) = HCFLDS
      CALL RDTRL (MCB)
      NHC = 0
      IF (MCB(1) .LE. 0) GO TO 2
      NHC = MCB(2)
    2 IF (NHC .NE. NPERMS) GO TO 300
      IF (NHC .EQ. 0) GO TO 5
      MCB(1) = PG
      CALL RDTRL (MCB)
      IF (NHC .NE. MCB(2)) GO TO 300
    5 CONTINUE
      MCB(1) = HCCENS
      CALL RDTRL (MCB)
      NS = 0
      IF (MCB(1) .LE. 0) GO TO 6
      NS = MCB(2)
    6 IF (NS .NE. NHC) GO TO 300
      JJ    = NROWSP
      INCUR = 1
      LCORE = LC
      IBUF1 = LCORE
      LCORE = LCORE - SYSBUF
      CALL OPEN (*200,LODC,CORE(LCORE+1),1)
      CALL FNAME (LODC,HEAD)
      CALL WRITE (LODC,HEAD,2,1)
      LCORE = LCORE - SYSBUF
      CALL OPEN (*190,PG,CORE(LCORE+1),0)
      CALL MAKMCB (LODC1,LODC,NROWSP,2,IPREC)
      NLJ = IPTR
      NL1 = 0
      DO 160 I = 1,NLOAD
      DO 10  J = 1,NROWSP
   10 CORE(J) = 0.0
      NLJ = NLJ + NL1*2 + 1
      NL1 = IARY(NLJ)
      DO 20 K = 1,NL1
      KK  = NLJ + (K-1)*2 + 1
      LOADN(K) = IARY(KK)
      IF (LOADN(K) .LT. 0) GO TO 150
   20 ALPHA(K) = ARY(KK+1)
      KK = 1
      KL = 0
      DO 60 K = 1,NLIST
      IF (ILIST(K)) 30,60,30
   30 KL = KL + 1
      DO 40 J = 1,NL1
      IF (LOADN(J)-ILIST(K)) 40,50,40
   40 CONTINUE
      GO TO 60
   50 LOADNN(KK) = KL
      ALPHA1(KK) = ALPHA(J)
      KK = KK + 1
   60 CONTINUE
      KK = 1
      DO 140 J = 1,NL1
      INULL = 0
      IF (J .NE. 1) GO TO 70
      CALL SKPREC (PG,1)
   70 CALL INTPK (*120,PG,0,1,0)
   80 IF (LOADNN(J)-KK) 90,100,90
   90 IF (INULL .EQ. 1) GO TO 91
      IF (IEOR  .EQ. 0) CALL SKPREC (PG,1)
   91 CONTINUE
      KK = KK + 1
      INULL = 0
      GO TO 70
  100 IF (INULL .EQ. 1) GO TO 130
      IF (IEOL) 130,110,130
  110 CALL ZNTPKI
      CORE(LL) = CORE(LL) + A(1)*ALPHA1(J)
      GO TO 100
  120 INULL = 1
      GO TO 80
  130 KK = KK + 1
  140 CONTINUE
  150 CALL PACK (CORE,LODC1(1),LODC1)
      CALL REWIND (PG)
  160 CONTINUE
      CALL WRTTRL (LODC1(1))
      CALL CLOSE  (LODC1(1),1)
      CALL CLOSE  (PG,1)
      IF (PG .EQ. HCFLDS) GO TO 170
      IF (PG .EQ. REMFLS) GO TO 180
      IF (PG .EQ. HCCENS) RETURN
C
C     DO MAGNETOSTATIC FIELDS FOR USE IN EMFLD
C
      LODC1(1) = HCFLDS
      CALL RDTRL (LODC1)
C
C     IF HCFLD IS PURGED, SO MUST REMFLS
C
      IF (LODC1(2) .LE. 0) RETURN
      PG   = HCFLDS
      LODC = HCFLD
      NROWSP = 3*NROWSP
      GO TO 5
C
C     DO REMFLS
C
  170 LODC1(1) = REMFLS
      CALL RDTRL (LODC1)
      IF (LODC1(2) .LE. 0) RETURN
      PG   = REMFLS
      LODC = REMFL
      NROWSP = LODC1(3)
      GO TO 5
C
C     HCCENS
C
  180 LODC1(1) = HCCENS
      CALL RDTRL (LODC1)
      IF (LODC1(2).LE.0) RETURN
      PG   = HCCENS
      LODC = HCCEN
      NROWSP = LODC1(3)
      GO TO 5
  190 IP1 = PG
  195 CALL MESAGE (-1,IP1,NAME)
  200 IF (LODC .EQ. HCFLD) RETURN
      IP1 = LODC
      GO TO 195
  300 WRITE  (OTPE,350) UFM
  350 FORMAT (A23,', IN AN E AND M PROBLEM, SCRATCH DATA BLOCKS HCFLDS',
     1       ' AND REMFLS HAVE DIFFERENT NUMBERS OF COLUMNS.', /10X,
     2       ' THIS MAY RESULT FROM SPCFLD AND REMFLU CARDS HAVING THE',
     3       ' SAME LOAD SET ID')
      CALL MESAGE (-61,0,0)
      RETURN
      END

      SUBROUTINE EMPCOR(MT1X,MT2X,PT,PC,FRSROW,MIDROW,LASROW,NX,A,Z)
C
C     EMPTY CORE OF A TRIANGULAR MATRIX
C
      INTEGER PT,PC,FRSROW,ROW,MCB(7)
      REAL A(1),Z(1)
C
C
C     MT1      FIRST PART OF THE MATRIX (UP TO ROW -MIDROW-).
C     MT2      REST OF THE MATRIX.
C     PT       PRECISION OF THE MATRIX ON TAPE.
C     PC       ......... .. ... ...... IN CORE.
C     FRSROW   FIRST ROW IN CORE.
C     LAST     LAST  ... .. CORE.
C     N        SIZE OF THE COMPLETE MATRIX.
C     A        LOCATION OF THE COMPLETE MATRIX.
C
      COMMON /PACKX/IT1,IT2,II,JJ,INCR
      DATA  MCB /7*0/
      MT1 = MT1X
      MT2 = MT2X
      N   = NX
      MT  = MT1
      IF(FRSROW .GT. MIDROW .AND. MT2 .NE. 0) MT = MT2
      NA  =1
      INCR = 1
      IT1 = PC
      IT2 = PT
      JJ  = N
      DO 105 ROW =  FRSROW,LASROW
      II = ROW
      CALL PACK(A(NA),MT,MCB)
      IF( ROW .EQ. N) GO TO 110
      NA = NA + PC* (N-ROW+1)
      IF( ROW .NE. MIDROW .OR. MT2 .EQ. 0) GO TO 105
      CALL CLOSE(MT,1)
      MT = MT2
      CALL GOPEN(MT,Z,1)
  105 CONTINUE
      GO TO 115
C
C     END OF CORE DUMP
C
  110 CALL CLOSE(MT,1)
  115 RETURN
      END

      SUBROUTINE OPTPR2
C
C     THIS ROUTINE IS THE DRIVER FOR PROPERTY OPTIMIZATION, PHASE 2.
C
C     CALLING SEQUENCE
C
C     OPTPR2  OPTP1,OES1,EST1 / OPTP2,EST2 / V,N,PRINT / V,N,TSTART /
C                                            V,N,COUNT / V,N,CARDNO $
C     WHERE   PRINT  = INPUT/OUTPUT - INTEGER, CALL OFP IF 1, SKIP OFP
C                      IF -1
C             TSTART = INPUT - INTEGER, END TIME AT OPTPR1.
C             COUNT  = INPUT/OUTPUT - INTEGER, ITERATION LOOP COUNTER.
C             CARDNO = INPUT/OUTPUT - INTEGER, PUNCHED CARD COUNT
C
C     LOGICAL         DEBUG
      INTEGER         PRINT,COUNT,YCOR,PARM(8),B1,NAME(2),CREW,FILE,
     1                SYSBUF,OUTTAP,IY(1),NONE(2),OPTP1,OES1,EST1,OPTP2,
     2                PTRRY,EST2,B2,PTPTY,PTELY,PTPRY,PTPLY,TG,TL,
     3                TSTART,ZCOR
      REAL            Y(1)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /BLANK / PRINT,TSTART,COUNT,NCARD,SKP,YCOR,B1,NELOP,NWDSE,
     1                NWDSP,OPTP1,OES1,EST1,OPTP2,EST2,
     2                NELW,NPRW,NKLW,NTOTL,CONV
      COMMON /OPTPW2/ ZCOR,Z(200)
      COMMON /ZZZZZZ/ CORE(1)
      COMMON /NAMES / NRD,NRREW,NWRT,NWREW,CREW
      COMMON /SYSTEM/ SYSBUF,OUTTAP
      COMMON /GPTA1 / NTYPES,LAST,INCR,NE(1)
      EQUIVALENCE     (Y(1),IY(1),PARM(8)), (CORE(1),MAX,PARM(1)),
     1                (PARM(4),IPRN ), (PARM(7),IPRNT)
      DATA    NAME  / 4H OPT,4HPR2  /,   NONE / 4H (NO,4HNE)   /
      DATA    PTPTY , PTELY,PTPRY,PTPLY,PTRRY / 5*0 /
C     DATA    DEBUG / .FALSE /
C
      OPTP1 = 101
      OES1  = 102
      EST1  = 103
      OPTP2 = 201
      EST2  = 202
      ZCOR  = 200
      NWDSE = 5
      NWDSP = 6
C
C     LOAD /GPTA1/ ON 1108
C
      CALL DELSET
C
C     STEP 1.  INITIALIZE AND READ POPT DATA
C
      B1  = KORSZ(CORE(1)) - SYSBUF + 1
      B2  = B1 - SYSBUF
      YCOR= B2 -1
      IF (B2 .LE. 6) GO TO 10
      COUNT = COUNT + 1
      CONV  = 0.0
      FILE  = OPTP1
      CALL OPEN  (*105,FILE,PARM(B1),NRREW)
      CALL FREAD (OPTP1,PARM(1),2,0)
      CALL FREAD (OPTP1,PARM(1),6,1)
C
C     PARM NOW CONTAINS
C
C       1 = MAX  - MAX NUMBER OF ITERATIONS (I)
C       2 = EPS  - CONVERGENCE TEST (R)
C       3 = GAMA - ITERATION FACTOR (R)
C       4 = IPRN - PRINT CONTROL (I)
C     5,6 = KPUN - PUNCH CONTROL (BCD, YES OR NO)
C
C     NEW PROPERTIES ARE CALCULATED BY,
C     PNEW = (PLST*ALPH) / (ALPH + (1-ALPH)GAMA)
C
C     STEP 2. CHECK TIME TO GO
C
      IF (COUNT .GT. MAX) GO TO 105
      CALL TMTOGO (TG)
      IF (TG .GT. 0) GO TO 5
      CALL MESAGE (45,COUNT,NAME)
      COUNT = 0
      GO TO 110
    5 CALL KLOCK (TL)
      TL = (TL-TSTART)/COUNT
      IF (TG .LE. TL) COUNT = MAX
      IPRNT = 0
C
C     STEP 3. READ OPTP1 INTO CORE
C
C     RECORD 1 - POINTERS
C
      YCOR = YCOR - 7
      IF (YCOR .LT. NTYPES) GO TO 10
C
C     POINTERS TO OPTIMIZING POINTERS
C
      CALL FREAD (OPTP1,Y(1),NTYPES,0)
C
C     NUMBER OF ELEMENT TYPES THAT MAY BE OPTIMIZED
C
      CALL FREAD (OPTP1,NELOP,1,0)
C
C     ELEMENT AND PROPERTY POINTERS OF (2,NELOP+1) LENGTH
C
      YCOR = YCOR - NTYPES
      I    = 2*(NELOP+1)
      PTPTY= NTYPES + 1
      IF (YCOR .LT. I) GO TO 10
      CALL FREAD (OPTP1,Y(PTPTY),I,1)
C
C     RECORD 2 - ELEMENT DATA
C
      YCOR  = YCOR  - I
      PTELY = PTPTY + I
      IF (YCOR .LT. NWDSE+NWDSP) GO TO 10
      CALL READ (*10,*30,OPTP1,Y(PTELY),YCOR,1,NELW)
C
C     INSUFFICIENT CORE - PRINT START OF EACH SECTION
C
C
   10 CALL PAGE2 (-3)
      I = NTYPES + 1
      WRITE  (OUTTAP,20) UFM,NAME,B1,I,PTPTY,PTELY,PTPRY
   20 FORMAT (A23,' 2289, ',2A4,'INSUFFICIENT CORE (',I10,2H ), /9X,I9,
     1       ' = MATERIAL',I9,' = POINTERS',I9,' = ELEMENTS',I9,
     2       ' = PROPERTIES')
      CALL CLOSE (FILE,CREW)
      GO TO 100
C
C     RECORD 3 - PROPERTY DATA
C
   30 IF (NELW .LT. NWDSE) GO TO 50
      PTPRY = PTELY + NELW
      YCOR  = YCOR  - NELW
      IF (YCOR .LT. NWDSP) GO TO 10
      CALL READ (*10,*40,OPTP1,Y(PTPRY),YCOR,1,NPRW)
      GO TO 10
C
C     RECORD 4 - PLIMIT DATA
C
   40 IF (NPRW .LT. NWDSP) GO TO 50
      PTPLY = PTPRY + NPRW
      YCOR  = YCOR  - NPRW
      IF (YCOR .LT. 0) GO TO 10
      CALL READ (*10,*70,OPTP1,Y(PTPLY),YCOR,1,NKLW)
      GO TO 10
C
C     INSUFFICIENT DATA
C
   50 CALL CLOSE (FILE,CREW)
      CALL PAGE2 (-2)
      WRITE  (OUTTAP,60) UFM,NAME
   60 FORMAT (A23,' 2302, SUBROUTINE ',2A4,' HAS NO PROPERTY OR ',
     1        'ELEMENT DATA.')
      GO TO 100
C
C     CLOSE OPTP1 FILE.
C     ALLOCATE AN ARRAY WITH STARTING POINTER PTRRY, OF LENGTH EQUALS TO
C     THE NO. OF PROPERTY CARDS (TO BE USED IN OPT2A, 2B, AND 2C)
C     SET VARIABLE NTOTL TO THE TOTAL LENGTH OF WORDS USED IN OPEN CORE
C     RE-ESTABLISH OPEN CORE UPPER LIMIT, YCOR
C
   70 CALL CLOSE (FILE,CREW)
      PTRRY = PTPLY + NKLW
      NTOTL = PTRRY + NPRW/NWDSP + 1
      IY(NTOTL-1) = -1234567
      IF (NTOTL .GT. YCOR) GO TO 10
      YCOR = B2 - 1
      DO 80 J = NTOTL,YCOR
   80 IY(J) = 0
C
C     READ STRESS DATA, SET ALPH
C
      FILE = OES1
      CALL GOPEN (FILE,PARM(B1),NRREW)
      CALL OPT2A (IY(PTPTY),Y(PTELY),IY(PTELY),Y(PTPRY),IY(PTPRY),
     1            Y(PTRRY))
      IF (IY(NTOTL-1) .NE. -1234567) GO TO 120
      CALL CLOSE (FILE,CREW)
      IF (COUNT .GT. MAX) GO TO 105
C
C     SET NEW PROPERTY, CHECK FOR CONVERGENCE
C
      CALL OPT2B (IY(PTPRY),Y(PTPRY),Y(PTPLY),Y(PTRRY))
C
C     CREATE EST2, PUNCH PROPERTIES IF CONVERGED
C
      PRINT = -1
      IF (COUNT.GE.MAX .OR. COUNT.LE.1 .OR. CONV.EQ. 2.) PRINT = 1
      IF (IPRN .LT.0  .AND. MOD(COUNT,IABS(IPRN)).EQ. 0) PRINT = 1
      IF (COUNT.GT.MAX .OR. COUNT.LT.0) GO TO 90
      IF (COUNT.EQ.1 .OR. COUNT.GE.MAX .OR. MOD(COUNT,IABS(IPRN)).EQ.0
     1   .OR. CONV.EQ.2.) IPRNT = 1
      FILE = EST1
      CALL OPEN  (*95,FILE,PARM(B1),NRREW)
      CALL FREAD (FILE,NONE(1),2,1)
      FILE = EST2
      CALL GOPEN (FILE,PARM(B2),NWREW)
      CALL OPT2C (Y(PTPTY),IY(PTELY),IY(PTPRY),Y(PTPRY),Y(PTRRY))
      CALL CLOSE (FILE,CREW)
      CALL CLOSE (EST1,CREW)
C
C     COPY OPTPR1 TO OPTPR2 - CHANGE RECORD 3
C
   90 IF (COUNT .GT. MAX) GO TO 105
      CALL OPEN (*95,OPTP1,PARM(B1),NRREW)
      FILE = OPTP2
      CALL OPEN  (*95,FILE,PARM(B2),NWREW)
      CALL OPT2D (IY(PTPRY),Y(PTPRY))
      CALL CLOSE (FILE,CREW)
      CALL CLOSE (OPTP1,CREW)
      GO TO 110
C
C     FILE NOT PRESENT
C
   95 CALL MESAGE (-1 ,FILE,NAME)
  100 CALL MESAGE (-61,B2,NAME)
  105 COUNT = -1
      CALL CLOSE (OPTP1,1)
  110 IF (CONV .EQ. 2.0) COUNT = MAX
      IF (COUNT .LE.  0) PRINT = 1
      IF (COUNT .EQ.  0) COUNT =-1
      RETURN
C
  120 WRITE  (OUTTAP,125) NTOTL,PTRRY
  125 FORMAT (32H0*** RR DIMENSION ERROR/OPTPR2  ,2I7)
      GO TO 100
      END

      SUBROUTINE LINEL (IZ,NWDS,OPCOR,OPT,X,PEN,DEFORM,GPLST)
C
C     CALL TO LINEL IS AS FOLLOWS -
C
C     (1)
C     OPT = ZERO (INPUT) - TO CREATE COMPLETE LINE CONNECTION TABLE OF
C     **********           ELEMENTS OF ALL TYPES, TO BE USED BY SUPLT
C                          SUBROUTINE
C        INPUT-
C           OPCOR (INPUT) = NUMBER OF WORDS OF OPEN CORE FOR -IZ-
C        OUTPUT-
C           IZ   = LIST OF GRID POINT ELEMENET CONNECTIONS AND POINTERS
C                  TO EACH GRID POINT, FROM IZ(1) THRU IZ(NWDS). DATA
C                  COMPOSED OF   1. GPCT,  AND 2. NGP WORDS OF CONTROL
C                  POINTERS
C           NWDS = NO. OF WORDS IN IZ PRIOR TO POINTER ARRAY.
C                  I.E. 1 LESS THAN LOCATION OF POINTERS,
C                = 0 IF ARRAY NOT CREATED
C           OPT  = NWDS
C
C     (2)
C     OPT = NONZERO (INPUT) - LOAD INTO CORE THE GRID POINT CNNECTION
C     *************           LIST OF ALL ELEMENTS OF THE SAME TYPE
C
C        INPUT-
C           NWDS  = ETYP, 2 BCD WORDS (CALLING ROUTINE HAS ALREADY READ
C                   THIS WORD FROM DATA BLOCK ELSET)
C           OPT   = MO. OF GRID POINT CONNECTIONS PER ELEMENT, NGPEL
C                   (CALLING ROUTINE HAS ALREADY READ THIS WORD)
C           OPCOR = OPEN CORE AVAILABLE W.R.T. IZ(1)
C           GPLST = A SUBSET LIST OF GRID POINTS PERTAINING TO THOSE
C                   POINTS USED ONLY IN THIS PLOT
C        OUTPUT-
C           IZ    = GRID POINT CONNECTION LIST FOR ALL ELEMENTS OF THIS
C                   TYPE, OR AS MANY ELEMS OF THIS TYPE AS CORE ALLOWS.
C           NWDS  = TOTAL LENGTH OF TABLE IZ
C           OPT   = NUMBER OF CONNECTIONS PER ELEMENT
C           (IF INSUFF. CORE TO READ ALL THE ELEMENTS, BOTH NWDS AND OPT
C           ARE SET TO NEGATIVE UPON RETURN. FURTHER CALLS MUST BE MADE
C           TO COMPLETE THIS ELEMENT
C           IF ILLEGAL ELEMENT IS ENCOUNTERED, NWDS AND OPT ARE SET TO
C           ZERO, AND ELSET IS SPACED OVER THE ELEMENT)
C
C           (NOTE THAT  'DO 100 I=1,NWDS,OPT'  MAY THEN BE USED
C           BUT IT IS MORE EFFICIENT TO USE  'DO 100 I=1,NWDS' AND CHECK
C           ZERO AS THE COMMAND TO LIFT THE PEN)
C
C     EACH ELEMENT TYPE HAS THE FOLLOWING DATA IN ELSET FILE
C           ELTYP = BCD SYMBOL (1 WORD)
C           NGPEL = NUM. GRID POINTS.
C                   IF NEGATIVE OR .GT. 4 NOT A CLOSED LOOP
C           ELID  = ELEMENT ID
C           G     = NGPEL GRIDS.
C           LOOP THRU ELID AND G UNTIL ELID = 0 (I.E. NO MORE ELEMS OF
C                                              THIS TYPE)
C     (3)
C     ELEMENT OFFSET PLOT (UNDEFORMED PLOT ONLY, PEDGE=3),
C     *******************
C     IF ELEMENTS WITH OFFSET ARE PRESENT, CALL OFSPLT TO PLOT THEM OUT
C     AND DO NOT INCLUDE THEM IN THE IZ TABLE
C     IF OFFSET COMMAND IS REQUESTED BY USER VIA THE PLOT CARD
C     (PEDGE = 3), SKIP COMPLETELY THE GENERATION OF THE IZ TABLE
C
C     OFFSET n OPTION (ON PLOT CONNAND CARD IN CASE CONTROL SECTION) -
C       n .LT. 0, SKIP OFFSET VALUES ON GENERAL PLOTS. (PEDGE.NE.3)
C       n =    0, OFFSET VALUES INCLUDED IN ALL GENERAL PLOTS (PEDGE=3)
C       n .GT. 0, PLOT ONLY THOSE ELEMENTS HAVING OFFSET DATA, OFFSET
C                 DATA ARE MAGNIFIED n TIMES. (PEDGE=3)
C     SUBROUTINE PLOT SETS THE PEDGE FLAG, AND PLTSET SETS THE OFFSCL.
C
      INTEGER         ELID,ELSET,ETYP,G,IZ(1),M1(16),NAME(2),GPLST(1),
     1                NG(121),OPCOR,OPT,TYPE,NGTYP(2,13),LDX(9),OFFSCL,
     2                OFFSET,DEFORM,PEN,PEDGE
      REAL            X(3,1)
      COMMON /BLANK / NGP,SKP1(9),SKP2(2),ELSET,SKP3(7),MERR
      COMMON /SYSTEM/ SKP4,IOUT
      COMMON /PLTSCR/ NNN,G(3)
      COMMON /DRWDAT/ SKP5(15),PEDGE
      COMMON /XXPARM/ SKP6(235),OFFSCL
      DATA    NAME  / 4HLINE, 1HL  /,  NM1,M1 / 16,
     1                4H(33X, 4H,13H, 4HELEM, 4HENT , 4HTYPE, 4H ,A5,
     2                4H,4HW, 4HITH,, 4HI8,2, 4H4H G, 4HRIDS, 4H SKI,
     3                4HPPED, 4H IN , 4HLINE, 4HL.)   /
C
C     SPECIAL ELEMENT CONNECTION PATTERNS
C
      DATA LDX  / 2HD1,2HD2,2HD3,2HD4,2HD5,2HD6,2HD7,2HD8,2HD9      /
      DATA KTET / 2HTE /, KWEG / 2HWG /, KHX1 / 2HH1 /, KHX2 / 2HH2 /,
     1     KIX1 / 2HXL /, KIX2 / 2HXQ /, KIX3 / 2HXC /, KAE  / 2HAE /,
     2     KTM6 / 2HT6 /,KTRPLT/ 2HP6 /,KTRSHL/ 2HSL /, KFH1 / 2HFA /,
     3     KFH2 / 2HFB /, KFWD / 2HFW /, KFTE / 2HFT /, K2D8 / 2HD8 /,
     4     KHB  / 2HHB /, KBAR / 2HBR /, KT3  / 2HT3 /, KQ4  / 2HQ4 /
C
C     NGTYP(1,TYPE) = LOCATION WORD 1 IN -NG-, +N = POINTER TO G
C                                              -N = THRU POINTER TO G
C     BE SURE TO KEEP PEN DOWN                  0 = LIFT PEN
C     AS MUCH AS POSSIBLE.
C     NGTYP(2,TYPE) = NUMBER OF ENTRIES/ELEMENT MINUS 1 IN TABLE IZ
C
      DATA NGTYP/ 0,0,  3,9,  10,14,  22,19,  37,30,  56,43,  79,6,
     1           83,7, 86,9,  95,10, 102, 8, 108, 2, 110, 7/
      DATA  NG  /
C    1 - LINE,TRIANGLE,QUAD
     1   1,-5,
C    2 - TETRA (WORD 3)
     2   1,-4,1,3,0,2,4,
C    3 - WEDGE (WORD 10)
     3   1,-3,1,4,-6,4,0,5,2,0,3,6,
C    4 - HEXA  (WORD 22)
     4   1,-4,1,5,-8,5,0,6,2,0,3,7,0,8,4,
C    5 - IHEXA2 (WORD 37)
     5   1,-8,1,9,13,-20,13,0,15,10,3,0,5,11,17,0,19,12,7,
C    6 - IHEXA3 (WORD 56)
     6   1,-12,1,13,17,21,-32,21,0,24,18,14,4,0,7,15,19,27,0,30,20,16,10
C    7 - AREO (WORD 79)
     7,  1,-4,1,0,
C    8 - TRIM6, TRPLT1, AND TRSHL (WORD 83)
     8   1,-6,1,
C    9 - IS2D8 (WORD 86)
     9   1,5,2,6,3,7,4,8,1,
C   1O - POINT (WORD 95)
     O   2,-6,7,2,0,1,8,
C   11 - LINE (WORD 102)
     1   3,-6,3,0,7,8,
C   12 - REV OR ELIP CYL. (WORD 108)
     2   1,2,
C   13 - AREA3 (WORD 110)
     3   1,-3,1,0,4,5,
C   14 - AREA4 (WORD 116)
     4   1,-4,1,0,5,6
     * /
C
      K    = 1
      IF (OPT .EQ. 0) GO TO 20
      ETYP = NWDS
      I    = OPT
      GO TO 30
C
   20 IF (OPT .NE. 0) GO TO 170
      CALL READ (*420,*190,ELSET,ETYP,1,0,I)
      CALL FREAD (ELSET,I,1,0)
C
   30 NGPEL  = IABS(I)
      NGPELX = NGPEL
      OFFSET = 0
      IF (ETYP .EQ. KBAR) OFFSET = 6
      IF (ETYP.EQ.KT3 .OR. ETYP.EQ.KQ4) OFFSET = 1
C
      TYPE  = 1
      IF (ETYP.EQ.KTET .OR. ETYP.EQ.KFTE) TYPE = 2
      IF (ETYP.EQ.KWEG .OR. ETYP.EQ.KFWD) TYPE = 3
      IF (ETYP.EQ.KHX1 .OR. ETYP.EQ.KHX2 .OR. ETYP.EQ.KFH1 .OR.
     1    ETYP.EQ.KFH2 .OR. ETYP.EQ.KIX1) TYPE = 4
      IF (ETYP .EQ. KIX2) TYPE = 5
      IF (ETYP .EQ. KIX3) TYPE = 6
      IF (ETYP .EQ.  KAE) TYPE = 7
      IF (ETYP.EQ.KTM6 .OR. ETYP.EQ.KTRPLT .OR. ETYP.EQ.KTRSHL) TYPE = 8
      IF (ETYP .EQ. K2D8) TYPE = 9
      IF (ETYP .EQ. KHB ) TYPE = 10
C                   CHBDY TYPE = 10,11,12,13,14
C
      IF (TYPE .NE. 1) GO TO 40
C
C     SIMPLE ELEMENT
C
      IF (NGPEL.GT.2 .AND. I.GT.0) NGPELX = NGPEL + 1
      IF (NGPEL .GT. 4) GO TO 131
      L1 = 1
      M  = NGPELX
      GO TO 50
C
C     COMPLEX ELEMENT
C
   40 L1 = NGTYP(1,TYPE)
      M  = NGTYP(2,TYPE)
   50 IF (NGPELX .GT. NNN) GO TO 140
C
C     READ THE ELEMENT DATA
C
   55 CALL FREAD (ELSET,ELID,1,0)
      IF (ELID .LE. 0) GO TO 20
      CALL FREAD (ELSET,LID,1,0)
      CALL FREAD (ELSET,G,NGPEL,0)
      IF (NGPEL .NE. NGPELX) G(NGPELX) = G(1)
C
C     CALL OFSPLT TO PROCESS OFFSET PLOT
C
      IF (OFFSET .NE. 0)
     1   CALL OFSPLT (*55,ETYP,ELID,G,OFFSET,X,DEFORM,GPLST)
      IF (TYPE.LT.10 .OR. TYPE.GT.14) GO TO 57
C
C     SPECIAL HANDLING FOR CHBDY
C
      TYPE = 9 + G(NGPEL)
      L1 = NGTYP(1,TYPE)
      M  = NGTYP(2,TYPE)
C
   57 L = L1
C
      IF (OPT .NE. 0) GO TO 70
C
C     CREATING CONNECTION ARRAY FOR SUPLT
C
      LL = 0
      I1 = 0
   60 I2 = NG(L)
      IF (I1 .EQ. 0) GO TO 66
      IF (I2) 62,64,65
C
C     THRU RANGE
C
   62 I2 =-I2
      I2 = MIN0(I2,M)
      J  = I1 + 1
      I1 = G(I1)
      IF (2*(I2-J+1)+K .GT. OPCOR) GO TO 390
      DO 63 I = J,I2
      IZ(K  ) = MIN0(G(I),I1)
      IZ(K+1) = MAX0(G(I),I1)
      K  = K  + 2
      LL = LL + 1
   63 I1 = G(I)
      IF (LL .EQ. M-1) LL = LL - 1
      GO TO 66
C
   64 I1 = 0
      L  = L + 1
      GO TO 60
C
   65 IF (K+1 .GT. OPCOR) GO TO 180
      IZ(K  ) = MIN0(G(I2),G(I1))
      IZ(K+1) = MAX0(G(I2),G(I1))
      K  = K  + 2
   66 LL = LL + 1
      I1 = I2
      IF (LL .GE. M) GO TO 55
      L  = L + 1
      GO TO 60
C
C     ON CONVERSION REMOVE ABOVE CODE
C
C     LOAD ELEMENT INTO CORE
C
   70 N = K + M
C
C     THIS TEST PROTECTS THE CORE FOR THE FIRST ELEMENT READ
C
      IF (N+1 .GT. OPCOR) GO TO 140
      I1 = 0
      I2 = NG(L)
      GO TO 125
   80 IF (I1 .EQ. 0) GO TO 90
      IF (I2) 110,100,90
C
   90 IZ(K) = G(I2)
      GO TO 120
  100 IZ(K) = I2
      GO TO 120
  110 I2 =-I2
C
C     NEXT LINE FOR ELEMENTS WITH MORE THAN ONE THRU POINTER
C
      IF (N .NE. K+M) I1 = I1 + 1
      DO 115 I = I1,I2
      IZ(K) = G(I)
  115 K = K + 1
      K = K - 1
  120 K = K + 1
      IF (K .GE. N) GO TO 130
  125 I1 = I2
      L  = L + 1
      I2 = NG(L)
      GO TO 80
C
C     STORE ZERO AT THE END OF EACH ELEMENT
C
  130 IZ(K) = 0
      K = K + 1
      IF (K+M+1 .GT. OPCOR) GO TO 180
      GO TO 55
C
C     CHECK FOR PDUM ELEMENTS BEFORE REJECTING
C
  131 DO 132 II = 1,9
      IF (ETYP .EQ. LDX(II)) CALL PDUMI (*20,*180,*140,II,M,OPCOR,NGPEL,
     1                                   K,ELSET,OPT)
  132 CONTINUE
C
C     ILLEGAL ELEMENT, NO CORE FOR 1 ELEMENT
C
  140 G(1) = 2
      G(2) = ETYP
      G(3) = NGPEL
      CALL WRTPRT (MERR,G,M1,NM1)
C
C     READ TO THE END OF THIS ELEMENT
C
  150 CALL FREAD (ELSET,ELID,1,0)
      IF (ELID .LE. 0) GO TO 160
      J = 1 + NGPEL + OFFSET
      CALL FREAD (ELSET,0,-J,0)
      GO TO 150
  160 CONTINUE
C
C     NOTE THAT BOTH OPT AND NWDS=0 FOR ILLEGAL ELEMENTS
C
      IF (OPT .NE. 0) GO TO 390
      GO TO 20
C
C     END OF OPT.NE.0
C
  170 NWDS = K - 1
      OPT  = M + 2
      GO TO 410
C
C     INSUFFICIENT CORE FOR ALL ELEMENTS
C
  180 IF (OPT .EQ. 0) GO TO 390
      NWDS = 1 - K
      OPT  = -(M+2)
      GO TO 410
C
C     SORT
C
  190 IF (PEDGE .EQ. 3) GO TO 400
      IF (OPT   .NE. 0) GO TO 170
      IF (K     .LE. 1) GO TO 400
      CALL SORT (0,0,2,1,IZ,K-1)
C
C     NWDS IS SET TO NO. OF WORDS PRIOR TO ELIMINATING DUPLICATES
C
      NWDS = K - 1
      IF (NWDS .LE. 2) GO TO 310
      ASSIGN 310 TO IRET
C
C     ELIMINATE DUPLICATE ENTRIES FROM LIST SORTED ON FIRST ENTRY
C
  200 CONTINUE
      I = 1
      L = 1
      LL= IZ(L)
C
C
      DO 300 J = 3,NWDS,2
      IF (IZ(J) .EQ. LL) GO TO 220
C
C     NEW PIVOT
C
      L  = I + 2
      LL = IZ(J)
      GO TO 230
  220 IF (IZ(J+1)-IZ(I+1)) 240,300,230
C
C     UNIQUE ENTRY FOR PIVOT FOUND
C
  230 IZ(I+2) = LL
      IZ(I+3) = IZ(J+1)
      GO TO 290
C
C     SECOND COLUMN OUT-OF-SORT
C     LOAD ENTRY SORTED.  CHECK PREVIOUS ENTRIES
C     L = LOWER LIMIT OF COLUMN 1 FOR MERGING
C     K SET TO FIRST ENTRY OF NEXT NEW ENTRY IN LIST INITIALLY
C
  240 K = I
  250 IF (K .LE. L) GO TO 270
      IF (IZ(J+1)-IZ(K-1)) 260,300,270
  260 K = K - 2
      GO TO 250
C
C     LOAD ENTRY INTO LOCATION
C
  270 N = IZ(J+1)
      M = I + 2
  280 IZ(M+1) = IZ(M-1)
      M = M - 2
      IF (M .GT. K) GO TO 280
      IZ(K+1) = N
      IZ(I+2) = LL
C
C     INCREMENT FOR ENTRY LOADED
C
  290 I = I + 2
  300 CONTINUE
C
C     NWDS RESET TO NO. WORDS AFTER ELIMINATING DUPLICATE ENTRIES
C
      NWDS = I + 1
      GO TO IRET, (310,330)
C
C
C     K IS SET TO THE NEXT PART OF CORE WHICH WILL BE FILLED WITH THE
C     HIGHER ENTRY IN THE FIRST POSITION
C
  310 K = NWDS + 1
      IF (2*NWDS .GT. OPCOR) GO TO 400
      DO 320 I = 1,NWDS,2
      IZ(K  ) = IZ(I+1)
      IZ(K+1) = IZ(I  )
      K = K + 2
  320 CONTINUE
      NWDS = K - 1
      CALL SORT (0,0,2,1,IZ,NWDS)
      ASSIGN 330 TO IRET
      GO TO 200
C
  330 CONTINUE
      IF (NWDS+NGP+1 .GT. OPCOR) GO TO 400
      K = 1
      J = 1
      L = 1
      M = 1 + NWDS
      I = 0
      IZ(M) = 1
C
C     CREATE A GPCT --- M = POINTER FOR POINTER ARRAY
C                       L = SIL NUMBER
C                       J = POINTER TO NEXT GPCT ENTRY
C
  340 IF (IZ(K) .EQ. L) GO TO 360
C
C     NEW PIVOT
C
  350 M = M + 1
      IZ(M) = IZ(M-1) + I
      L = L + 1
      I = 0
      IF (L .GT.  NGP) GO TO 370
      IF (K .GT. NWDS) GO TO 350
      GO TO 340
C
C     CONNECTED POINT
C
  360 IZ(J) = IZ(K+1)
      K = K + 2
      J = J + 1
      I = I + 1
      GO TO 340
C
C     EFFICIENCY PLOT POSSIBLE
C
  370 CONTINUE
      OPT = NWDS
      GO TO 410
C
  390 OPT  = 0
  400 NWDS = 0
  410 RETURN
C
  420 CALL MESAGE (-2,ELSET,NAME)
      GO TO 410
      END

      SUBROUTINE SDCMQ (*,KEY,V1,V,DV1,DV,IC,Z)
C
C     THIS SUBROUTINE CREATES A SCRATCH FILE OF QUEUED SINGULARITY
C     MESSAGES.  EACH MESSAGE IS A GINO RECORD DUE TO POSSIBLE CLOSE
C     WITHOUT REWIND.
C     THE -KEY- IS AS FOLLOWS,
C      1  - NULL COLUMN       - INPUT MATRIX
C      2  - ZERO DIAGONAL     - DECOMPOSED MATRIX.
C      3  - NEGATIVE DIAGONAL - DECOMPOSED MATRIX
C      4  - SINGULARITY TOLERANCE FAILURE - DECOMPOSED MATRIX.
C      5  - UNEXPECTED NULL COLUMN OR END OF COLUMN - ABORT IMMIDIATELY.
C      6  - NONCONSERVATIVE COLUMN  D/A.GT.1.001
C      7  - ZERO DIAGONAL     - INPUT MATRIX.
C     OTHER ARGUMENTS ARE
C      $  - NONSTANDARD RETURN IF DECOMPOSITION IS TO BE ABORTED.
C      Z  - OPEN CORE.  BUFFER LOCATIONS RELATIVE TO Z(1).
C      V  - RSP VALUE OF ENTRY IN ERROR (DV IS DOUBLE PRECISION).
C      V1 - INPUT VALUE OF DIAGONAL (DV1 IS DOUBLE PRECISION VERSION).
C      IC - COLUMN NUMBER IN ERROR.
C    THE ARGUMENTS ARE NOT CHANGED.
C    /SDCQ/ CONTAINS CONSTANT DATA.
C      FILCUR - CURRENT FILE USING BUFFER FOR SCRATCH FILE.  NEGATIVE IF
C               NONE, ZERO IF FILSCR IS TO REMAIN OPEN
C      STSCR  - GINO FILE STATUS FOR REOPENING FILCUR (1=READ,2=WRITE)
C      FILSCR - SCRATCH FILE NAME.
C      BUF    - BUFFER LOCATION RELATIVE TO Z(1).
C      NERR(2)- COUNT OF NUMBER OF ERROR CALLS ( (1)=ES, (2)=PD CHECK)
C      DIAGCK - EXIT FLAG FOR KEY=4 -- 0=NONFATAL, +N = MAX.-MESSAGES
C               WITHOUT ABORTING, -N = IMMEDIATE ABORT
C      IPREC  - 1=RSP, USE V. 2=RDP, USE DV.
C      PDEFCK - EXIT FLAG FOR KEY=3.  0 = NONFATAL IF -V, FATAL AT END
C               OF DECOMP FOR V=0.  +N = MAX-MESSAGES WITHOUT ABORTING.
C               -N = IMMEDIATE ABORT
C      NOGLEV - NOGO CODE.
C             = 0, NO FATAL ERRORS,
C             = 1, ABORT AT END OF DECOMP,
C             = 2, ABORT AT END OF PREPASS
C             = 3, ABORT,NONSTD RET.
C             = 4, INTERNAL ERRORS.  ABORT AT MAJOR CHECK-POINTS.
C-----
      LOGICAL          OPNSCR,FIRST
      INTEGER          BUF,DIAGCK,FILCUR,FILERR,FILSCR,IV(3),NAME(2),
     1                 PARM,PDEFCK,STSCR,Z(1)
      DOUBLE PRECISION DV,DV1
      CHARACTER        UFM*23,UWM*25,UIM*29,SFM*25,SWM*27
      COMMON /XMSSG /  UFM,UWM,UIM,SFM,SWM
      COMMON /SDCQ  /  NERR(2),NOGLEV,BUF,FILSCR,FILCUR,STSCR,PDEFCK,
     1                 DIAGCK,DIAGET,IPREC,PARM(4),OPNSCR,FIRST
      COMMON /SFACT /  SKPSF(32),ICHLY
      COMMON /NAMES /  KRD2,KRR0,KWT3,KWR1, SKPN,KCL2
      COMMON /SYSTEM/  ISB,IOUT
      EQUIVALENCE      (RV1,IV(2)),(RV,IV(3))
      DATA    NAME  /  4HSDCM,2HQ  /
C
      IF (FILCUR .GT. 0) CALL CLOSE (FILCUR,KCL2)
      FILERR = FILSCR
      IF (OPNSCR) GO TO 10
      IF (.NOT.FIRST) CALL OPEN (*200,FILSCR,Z(BUF),KWT3)
      IF (FIRST) CALL OPEN (*200,FILSCR,Z(BUF),KWR1)
      FIRST  = .FALSE.
      OPNSCR = .TRUE.
C
   10 IV(1) = IC*10 + KEY
      IF (IPREC .EQ. 1) GO TO 14
      RV  = DV
      RV1 = DV1
      GO TO 17
   14 RV  = V
      RV1 = V1
   17 CONTINUE
      CALL WRITE (FILSCR,IV,3,1)
C
C     CONVERT FILES TO ORIGINAL STATUS
C
      IF (FILCUR .EQ. 0) GO TO 20
      CALL CLOSE (FILSCR,KCL2)
      OPNSCR = .FALSE.
      IF (FILCUR .LE. 0) GO TO 20
      FILERR = FILCUR
C
C     READ MODE ON CURRENT FILE
C
      IF (STSCR .EQ. 1) I = KRD2
C
C     WRITE MODE ON CURRENT FILE
C
      IF (STSCR .EQ. 2) I = KWT3
      CALL OPEN (*200,FILCUR,Z(BUF),I)
C
C     DETERMINE ABORT FLAG
C
   20 CONTINUE
      GO TO (65,30,40,50,60,50,50), KEY
C
C     ZERO DIAGONAL - DECOMPOSED MATRIX
C
   30 NOGLEV = MAX0(NOGLEV,1)
      IF (IPREC .EQ. 1)  V = 1.0
      IF (IPREC .EQ. 2) DV = 1.D0
      GO TO 70
C
C     NEGATIVE DIAGONAL
C
   40 CONTINUE
      IF (ICHLY  .NE. 1) GO TO 45
      IF (IPREC  .EQ. 1)  V =-V
      IF (IPREC  .EQ. 2) DV =-DV
   45 IF (PDEFCK .EQ. 0) GO TO 70
      NOGLEV = MAX0(NOGLEV,1)
      GO TO 70
C
C     ES SINGULARITY CHECK, DIAG-IN=0.0, NON-CONSERVATIVE MATRIX
C
   50 CONTINUE
      NERR(1) = NERR(1) + 1
      IF (DIAGCK .EQ. 0) GO TO 100
      NOGLEV = MAX0(NOGLEV,1)
      IF (NERR(1) .GE. DIAGCK) NOGLEV = 3
      GO TO 100
C
C     UNEXPECTED NULL COLUMN
C
   60 NOGLEV = 3
      GO TO 70
C
   65 NOGLEV  = 2
   70 NERR(2) = NERR(2) + 1
      IF (NERR(2).GT.IABS(PDEFCK) .AND. PDEFCK.NE.0)  NOGLEV = 3
C
  100 CONTINUE
      IF (NOGLEV .EQ. 3) RETURN 1
      RETURN
C
C     UNABLE TO USE FILES - WRITE GINO NUMBER. ABORT AT MAJOR DECOMP
C     CHCK
C
  200 CALL PAGE2 (2)
      WRITE  (IOUT,210) SWM,FILERR,NAME,IC,KEY
  210 FORMAT (A27,' 2379, FILE',I8,' COULD NOT BE OPENED IN',A4,A1,
     1       '. COLUMN',I8,' SINGULAR, REASON',I3)
      PARM(1) = -37
      PARM(2) = FILSCR
      PARM(3) = NAME(1)
      PARM(4) = NAME(2)
      NOGLEV  = 4
      GO TO 100
      END

      SUBROUTINE CRDRD2 (*,*,MU,INDCOM,N23)
C
C     WRITE THE RIGID ROD ELEMENT ON THE RG FILE
C
C     EXTERNAL          ORF    ,LSHIFT
C     INTEGER           ORF
      INTEGER           GEOMP  ,BGPDT  ,CSTM   ,RGT    ,SCR1   ,
     1                  BUF(20),MASK16 ,GPOINT ,Z(1)   ,MCODE(2)
      REAL              RZ(1)
      DOUBLE PRECISION  INDTFM(9),DEPTFM(9),RODCOS(3),IDRCOS(3),
     1                  DDRCOS(3),
     2                  DZ(1)  ,XD     ,YD     ,ZD     ,RLNGTH ,CDEP
      COMMON /ZZZZZZ/   Z
      COMMON /GP4FIL/   GEOMP  ,BGPDT  ,CSTM   ,RGT    ,SCR1
      COMMON /GP4PRM/   BUF    ,BUF1   ,BUF2   ,BUF3   ,BUF4   ,KNKL1  ,
     1                  MASK16 ,NOGO   ,GPOINT ,KN
      EQUIVALENCE       (Z(1)  ,DZ(1)) ,(Z(1)  ,RZ(1))
      DATA              MASK15 /32767/
C
C     INDTFM = INDEPENDENT GRID POINT TRANSFORMATION MATRIX
C     DEPTFM = DEPENDENT GRID POINT TRANSFORMATION MATRIX
C     RODCOS = BASIC COSINES OF ROD ELEMENT
C     IDRCOS = DIRECTION COSINES OF INDEPENDENT GRID POINT
C     DDRCOS = DIRECTION COSINES OF DEPENDENT GRID POINT
C
C     OBTAIN TRANSFORMATION MATRIX
C
      IF (Z(KNKL1+3) .EQ. 0) GO TO 50
      DO 10 I = 1,4
      BUF(I) = Z(KNKL1+2+I)
   10 CONTINUE
      CALL TRANSD (BUF,INDTFM)
   50 IF (Z(KNKL1+10) .EQ. 0) GO TO 70
      DO 60 I = 1,4
      BUF(I) = Z(KNKL1+9+I)
   60 CONTINUE
      CALL TRANSD (BUF,DEPTFM)
C
C     COMPUTE THE LENGTH OF THE RIGID ROD ELEMENT
C
   70 XD = RZ(KNKL1+11) - RZ(KNKL1+4)
      YD = RZ(KNKL1+12) - RZ(KNKL1+5)
      ZD = RZ(KNKL1+13) - RZ(KNKL1+6)
C
C     CHECK TO SEE IF LENGTH OF ROD IS ZERO
C
      IF (XD.EQ.0.0D0 .AND. YD.EQ.0.0D0 .AND. ZD.EQ.0.0D0) RETURN 1
      RLNGTH = DSQRT(XD*XD + YD*YD + ZD*ZD)
C
C     COMPUTE THE BASIC DIRECTION COSINES OF THE RIGID ROD ELEMENT
C
      RODCOS (1) = XD/RLNGTH
      RODCOS (2) = YD/RLNGTH
      RODCOS (3) = ZD/RLNGTH
C
C     OBTAIN THE DIRECTION COSINES ASSOCIATED WITH
C     THE INDEPENDENT GRID POINT
C
      IF (Z(KNKL1+3) .NE. 0) GO TO 100
      DO 80 I = 1,3
      IDRCOS(I) = RODCOS(I)
   80 CONTINUE
      GO TO 200
  100 CALL GMMATD (RODCOS,1,3,0,INDTFM,3,3,0,IDRCOS)
C
C     OBTAIN THE DIRECTION COSINES ASSOCIATED WITH
C     THE DEPENDENT GRID POINT
C
  200 IF (Z(KNKL1+10) .NE. 0) GO TO 300
      DO 250 I = 1,3
      DDRCOS(I) = RODCOS(I)
  250 CONTINUE
      GO TO 400
  300 CALL GMMATD (RODCOS,1,3,0,DEPTFM,3,3,0,DDRCOS)
C
C     DETERMINE THE DEPENDENT SIL AND THE CORRESPONDING COEFFICIENT
C
  400 DO 500 I = 1,3
      IF (INDCOM .NE. I) GO TO 500
      IDEP = Z(KNKL1+6+I)
      CDEP = RODCOS(I)
      GO TO 600
  500 CONTINUE
C
C     CHECK TO SEE IF RIGID ROD IS PROPERLY DEFINED
C
  600 IF (DABS(CDEP) .LT. 0.001D0) RETURN 2
      MCODE(2) = IDEP
      IF (IDEP .GT. MASK15) N23 = 3
      DO 700 I = 1, 3
      MCODE(1) = Z(KNKL1+I-1)
      IF (MCODE(1) .GT. MASK15) N23 = 3
      COEFF = -IDRCOS(I)/CDEP
      CALL WRITE (RGT,MCODE,2,0)
      CALL WRITE (RGT,COEFF,1,0)
      MCODE(1) = Z(KNKL1+6+I)
      IF (MCODE(1) .GT. MASK15) N23 = 3
      COEFF = DDRCOS(I)/CDEP
      CALL WRITE (RGT,MCODE,2,0)
      CALL WRITE (RGT,COEFF,1,0)
  700 CONTINUE
      Z(MU) = IDEP
      MU = MU - 1
      RETURN
      END

      SUBROUTINE MRED2E
C
C     THIS SUBROUTINE CALCULATES THE MODAL TRANSFORMATION MATRIX FOR THE
C     MRED2 MODULE.
C
C     INPUT DATA
C     GINO   - LAMAMR - EIGENVALUE TABLE FOR SUBSTRUCTURE BEING REDUCED
C              PHISS  - EIGENVECTOR MATRIX FOR SUBSTRUCTURE BEING REDUCE
C     SOF    - GIMS   - G TRANSFORMATION MATRIX FOR ORIGINAL SUBSTRUCTUR
C
C     OUTPUT DATA
C     GINO   - HIM    - HIM MATRIX PARTITION
C
C     PARAMETERS
C     INPUT  - GBUF   - GINO BUFFERS
C              INFILE - INPUT FILE NUMBERS
C              OTFILE - OUTPUT FILE NUMBERS
C              ISCR   - SCRATCH FILE NUMBERS
C              KORLEN - LENGTH OF OPEN CORE
C              KORBGN - BEGINNING ADDRESS OF OPEN CORE
C              OLDNAM - NAME OF SUBSTRUCTURE BEING REDUCED
C              NMAX   - MAXIMUM NUMBER OF FREQUENCIES TO BE USED
C     OUTPUT - MODUSE - BEGINNING ADDRESS OF MODE USE DESCRIPTION ARRAY
C              MODLEN - LENGTH OF MODE USE ARRAY
C              NFOUND - NUMBER OF MODAL POINTS FOUND
C     OTHERS - HIMPRT - HIM PARTITION VECTOR
C              PPRTN  - PHISS MATRIX PARTITION VECTOR
C              PHIAM  - PHIAM MATRIX PARTITION
C              PHIBM  - PHIBM MATRIX PARTITION
C              PHIIM  - PHIIM MATRIX PARTITION
C              IPARTN - BEGINNING ADDRESS OF PHISS PARTITION VECTOR
C              LAMAMR - LAMAMR INPUT FILE NUMBER
C              PHISS  - PHISS INPUT FILE NUMBER
C              PPRTN  - PARTITION VECTOR FILE NUMBER
C              HIMPRT - HIM PARTITION VECTOR FILE NUMBER
C              GIB    - GIB INPUT FILE NUMBER
C              PHIAM  - PHIAM PARTITION MATRIX FILE NUMBER
C              PHIBM  - PHIBM PARTITION MATRIX FILE NUMBER
C              PHIIM  - PHIIM PARTITION MATRIX FILE NUMBER
C              HIM    - HIM INPUT FILE NUMBER
C              HIMSCR - HIM SCRATCH INPUT FILE NUMBER
C
      LOGICAL          FREBDY
      INTEGER          DRY,GBUF1,GBUF2,GBUF3,SBUF1,SBUF2,SBUF3,OTFILE,
     1                 OLDNAM,Z,TYPIN,TYPEP,FUSET,UN,UB,UI
      INTEGER          T,SIGNAB,SIGNC,PREC,SCR,RULE,TYPEU,PHISS
      INTEGER          PPRTN,GIB,PHIAM,PHIBM,PHIIM,HIM,HIMSCR,HIMPRT,
     1                 USETMR,HIMTYP,FBMODS,DBLKOR,SGLKOR,DICORE
      DOUBLE PRECISION DZ,DHIMSM,DHIMAG
      DIMENSION        MODNAM(2),RZ(1),ITRLR(7),DZ(1)
      CHARACTER        UFM*23
      COMMON /XMSSG /  UFM
      COMMON /BLANK /  IDUM1,DRY,IDUM6,GBUF1,GBUF2,GBUF3,SBUF1,SBUF2,
     1                 SBUF3,INFILE(12),OTFILE(6),ISCR(10),KORLEN,
     2                 KORBGN,OLDNAM(2),IDUM4(2),FREBDY,RANGE(2),NMAX,
     3                 IDUM5(5),MODUSE,NFOUND,MODLEN,IDUM2,LSTZWD
      COMMON /ZZZZZZ/  Z(1)
      COMMON /PACKX /  TYPIN,TYPEP,IROWP,NROWP,INCRP
      COMMON /PATX  /  LCORE,NSUB(3),FUSET
      COMMON /MPYADX/  ITRLRA(7),ITRLRB(7),ITRLRC(7),ITRLRD(7),NZ,T,
     1                 SIGNAB,SIGNC,PREC,SCR
      COMMON /BITPOS/  IDUM3(9),UN,IDUM7(10),UB,UI
      COMMON /PARMEG/  IA(7),IA11(7),IA21(7),IA12(7),IA22(7),LCR,RULE
      COMMON /UNPAKX/  TYPEU,IROWU,NROWU,INCRU
      COMMON /SYSTEM/  IDUM8,IPRNTR
      EQUIVALENCE      (LAMAMR,INFILE(2)),(PHISS,INFILE(3)),
     1                 (USETMR,INFILE(5))
      EQUIVALENCE      (GIB,ISCR(8)),(PPRTN,ISCR(5)),
     1                 (HIM,ISCR(8)),
     2                 (HIMPRT,ISCR(9)),(PHIBM,ISCR(9))
      EQUIVALENCE      (RZ(1),Z(1)),(DZ(1),Z(1))
      DATA    MODNAM/  4HMRED,4H2E  /
      DATA    EPSLON,  ISCR4,FBMODS /1.0E-03,304,6/
      DATA    ITEM  /  4HGIMS       /
C
C     READ LAMAMR FILE
C
      IF (DRY .EQ. -2) GO TO 300
      KORE  = KORBGN
      IFILE = LAMAMR
      CALL GOPEN (LAMAMR,Z(GBUF1),0)
      CALL FWDREC (*170,LAMAMR)
      ITER = 0
    2 CALL READ (*160,*4,LAMAMR,Z(KORBGN),7,0,NWDS)
C
C     REJECT MODES WITH NO ASSOCIATED VECTORS
C
      IF (RZ(KORBGN+5) .LE. 0.0) GO TO 2
      KORBGN = KORBGN + 7
      IF (KORBGN .GE. KORLEN) GO TO 180
      ITER = ITER + 1
      GO TO 2
    4 CALL CLOSE (LAMAMR,1)
C
C     ZERO OUT PARTITIONING VECTOR AND SET UP MODE USE DESCRIPTION
C     RECORD
C
      MODEXT  = KORBGN
      ITRLR(1)= PHISS
      CALL RDTRL (ITRLR)
      ITPHIS  = ITRLR(2)
      NROWS   = ITRLR(3)
      IF ((3*ITPHIS)+MODEXT .GE. KORLEN) GO TO 180
      LAMLEN  = 7*ITPHIS
      NNMAX   = MIN0(NMAX,ITPHIS)
      MODUSE  = MODEXT + ITPHIS
      IPARTN  = MODEXT + 2*ITPHIS
      MODLEN  = ITPHIS
      DO 10 I = 1,ITPHIS
      Z(MODEXT+I-1) = 0
      Z(MODUSE+I-1) = 3
   10 RZ(IPARTN+I-1) = 0.0
C
C     SELECT DESIRED MODES
C
      KORBGN = MODEXT + 3*ITPHIS
      IF (KORBGN .GE. KORLEN) GO TO 180
      NFOUND = 0
      DO 20 I = 1,ITPHIS
      J = 4 + 7*(I-1)
      IF (RZ(KORE+J).LE.RANGE(1) .OR. RZ(KORE+J).GE.RANGE(2)) GO TO 20
C
C     REMOVE MODES WITH NEGATIVE EIGENVALUES
C
      IF (RZ(KORE+J-2) .LT. 0.0) GO TO 20
      Z(MODEXT+NFOUND) = I
      NFOUND = NFOUND + 1
      Z(MODUSE +I-1) = 1
      RZ(IPARTN+I-1) = 1.0
   20 CONTINUE
C
C     PACK OUT PARTITIONING VECTOR
C
      TYPIN = 1
      TYPEP = 1
      IROWP = 1
      NROWP = ITRLR(2)
      INCRP = 1
      IFORM = 2
      CALL MAKMCB (ITRLR,PPRTN,NROWP,IFORM,TYPIN)
      CALL GOPEN (PPRTN,Z(GBUF1),1)
      CALL PACK (RZ(IPARTN),PPRTN,ITRLR)
      CALL CLOSE (PPRTN,1)
      CALL WRTTRL (ITRLR)
C
C     PARTITION PHISS MATRIX
C
C        **     **   **         **
C        *       *   *   .       *
C        * PHISS * = * 0 . PHIAM *
C        *       *   *   .       *
C        **     **   **         **
C
      NSUB(1) = ITPHIS - NFOUND
      NSUB(2) = NFOUND
      NSUB(3) = 0
      LCORE   = KORLEN - KORBGN
      ICORE   = LCORE
C
C     TEST FOR ALL MODES
C
      IF (NSUB(1) .EQ. 0) GO TO 32
      PHIAM = ISCR(8)
      CALL GMPRTN (PHISS,0,0,PHIAM,0,PPRTN,0,NSUB(1),NSUB(2),Z(KORBGN),
     1             ICORE)
C
C     PARTITION PHIAM MATRIX
C
C                    **     **
C                    *       *
C        **     **   * PHIBM *
C        *       *   *       *
C        * PHIAM * = *.......*
C        *       *   *       *
C        **     **   * PHIIM *
C                    *       *
C                    **     **
C
      GO TO 34
   32 PHIAM = PHISS
   34 CONTINUE
C
C     CALCULATE THE VECTOR MAGNITUDE
C
      IF (KORBGN+NROWS .GE. KORLEN) GO TO 180
      CALL GOPEN (PHIAM,Z(GBUF1),0)
      TYPEU = 1
      IROWU = 1
      NROWU = NROWS
      INCRU = 1
      DO 40 I = 1,NFOUND
      L     = IPARTN + I - 1
      RZ(L) = 0.0
      CALL UNPACK (*40,PHIAM,RZ(KORBGN))
      DO 38 J = 1,NROWS
      K     = KORBGN + J - 1
      RZ(L) = RZ(L) + RZ(K)**2
   38 CONTINUE
   40 CONTINUE
      CALL CLOSE (PHIAM,1)
      FUSET = USETMR
      CALL CALCV (PPRTN,UN,UI,UB,Z(KORBGN))
C
C     TEST FOR NULL B SET
C
      ITRLR(1) = PPRTN
      CALL RDTRL (ITRLR)
      IF (ITRLR(6) .GT. 0) GO TO 44
      PHIIM   = PHIAM
      IA11(1) = PHIAM
      CALL RDTRL (IA11)
      DO 42 I = 1,7
   42 IA21(I) = 0
      GO TO 55
   44 CONTINUE
      PHIIM = ISCR(7)
      CALL GMPRTN (PHIAM,PHIIM,PHIBM,0,0,0,PPRTN,NSUB(1),NSUB(2),
     1             Z(KORBGN),ICORE)
      JHIM = 0
C
C     COMPUTE MODAL TRANSFORMATION MATRIX
C
C        **   **   **     **   **   ** **     **
C        *     *   *       *   *     * *       *
C        * HIM * = * PHIIM * - * GIB * * PHIBM *
C        *     *   *       *   *     * *       *
C        **   **   **     **   **   ** **     **
C
      CALL MTRXI (GIB,OLDNAM,ITEM,0,ITEST)
      IF (ITEST .NE. 1) GO TO 200
      CALL SOFTRL (OLDNAM,ITEM,ITRLR)
      ITEST = ITRLR(1)
      IF (ITEST .NE. 1) GO TO 200
      DO 50 I = 1, 7
      ITRLRA(I) = ITRLR(I)
      ITRLRB(I) = IA21(I)
   50 ITRLRC(I) = IA11(I)
      ITRLRA(1) = GIB
      HIMSCR = ISCR(4)
      IFORM  = 2
      IPRC   = 1
      ITYP   = 0
      IF (ITRLRA(5).EQ.2 .OR. ITRLRA(5).EQ.4) IPRC = 2
      IF (ITRLRB(5).EQ.2 .OR. ITRLRB(5).EQ.4) IPRC = 2
      IF (ITRLRC(5).EQ.2 .OR. ITRLRC(5).EQ.4) IPRC = 2
      IF (ITRLRA(5) .GE. 3) ITYP = 2
      IF (ITRLRB(5) .GE. 3) ITYP = 2
      IF (ITRLRC(5) .GE. 3) ITYP = 2
      ITYPE  = IPRC + ITYP
      CALL MAKMCB (ITRLRD,HIMSCR,ITRLR(3),IFORM,ITYPE)
      CALL SOFCLS
      T      = 0
      SIGNAB = -1
      SIGNC  = 1
      PREC   = 0
      SCR    = ISCR(6)
      DBLKOR = KORBGN/2 + 1
      NZ     = LSTZWD - ((2*DBLKOR)-1)
      CALL MPYAD (DZ(DBLKOR),DZ(DBLKOR),DZ(DBLKOR))
      CALL WRTTRL (ITRLRD)
      CALL SOFOPN (Z(SBUF1),Z(SBUF2),Z(SBUF3))
      I      = ITRLRD(2)
      II     = ITRLRD(3)
      IFORM  = ITRLRD(4)
      HIMTYP = ITRLRD(5)
      GO TO 60
C
C     PHIBM IS NULL, HIM = PHIIM
C
   55 HIMSCR = PHIIM
      I      = IA11(2)
      II     = IA11(3)
      IFORM  = IA11(4)
      HIMTYP = IA11(5)
      JHIM   = 1
C
C     TEST SELECTED MODES
C
   60 NCORE  = I
      IF (KORBGN+NCORE .GE. KORLEN) GO TO 180
      TYPIN  = HIMTYP
      TYPEP  = HIMTYP
      IROWP  = 1
      NROWP  = II
      INCRP  = 1
      IROWU  = 1
      CALL GOPEN (HIMSCR,Z(GBUF1),0)
      CALL MAKMCB (ITRLR,HIM,II,IFORM,HIMTYP)
      CALL GOPEN (HIM,Z(GBUF3),1)
      NFOUND = 0
      ITER   = I
      DBLKOR = KORBGN/2 + 1
      SGLKOR = 2*DBLKOR - 1
      IF (HIMTYP .EQ. 1) DICORE = (SGLKOR+II)/2 + 1
      IF (HIMTYP .EQ. 2) DICORE = DBLKOR + II
      ICORE  = 2*DICORE - 1
C
C     UNPACK HIM COLUMN
C
      DO 140 I = 1,ITER
C
C     LIMIT VECTORS TO NMAX
C
      IF (NFOUND .LT. NNMAX) GO TO 65
      J      = Z(MODEXT+I-1) + MODUSE - 1
      Z(J)   = 3
      GO TO 140
   65 TYPEU  = HIMTYP
      INCRU  = 1
      NROWU  = II
      IHIM   = NROWU
      CALL UNPACK (*90,HIMSCR,DZ(DBLKOR))
C
C     SAVE LARGEST HIM COLUMN VALUE AND CALCULATE MAGNITUDE OF HIM,
C     COLUMN
C
      IF (HIMTYP .EQ. 2) GO TO 74
      ITYPE  = 0
      HIMSUM = 0.0
      HIMMAG = 0.0
      DO 72 J = 1,IHIM
      IF (ABS(RZ(SGLKOR+J-1)) .GE. ABS(HIMMAG)) HIMMAG = RZ(SGLKOR+J-1)
   72 HIMSUM = HIMSUM + (RZ(SGLKOR+J-1)**2)
      GO TO 78
   74 ITYPE  = 2
      DHIMSM = 0.0D0
      DHIMAG = 0.0D0
      DO 76 J = 1,IHIM
      IF (DABS(DZ(DBLKOR+J-1)) .GE. DABS(DHIMAG))
     1    DHIMAG = DZ(DBLKOR+J-1)
   76 DHIMSM = DHIMSM + DZ(DBLKOR+J-1)**2
      HIMSUM = DHIMSM
   78 IF (JHIM .EQ. 1) GO TO 95
      PHIMSM = RZ(IPARTN+I-1)
      IF (PHIMSM .LE. 0.0) GO TO 90
      PMSM   = PHIMSM*EPSLON*EPSLON
      IF (HIMSUM .GE. PMSM) GO TO 95
C
C     REJECT MODE
C
   90 J = Z(MODEXT+I-1)
      Z(MODUSE+J-1) = 2
      GO TO 140
C
C     USE MODE
C
   95 NFOUND = NFOUND + 1
C
C     SCALE HIM COLUMN
C
      IF (HIMTYP .EQ. 2) GO TO 104
      DO 102 J = 1,IHIM
  102 RZ(SGLKOR+J-1) = RZ(SGLKOR+J-1)/HIMMAG
      GO TO 130
  104 DO 106 J = 1,IHIM
  106 DZ(DBLKOR+J-1) = DZ(DBLKOR+J-1)/DHIMAG
C
C     PACK HIM COLUMN
C
  130 NROWP = NROWU
      CALL PACK(DZ (DBLKOR),HIM,ITRLR)
  140 CONTINUE
      CALL CLOSE (HIM,1)
      IF (JHIM .EQ. 0) CALL CLOSE (PHIIM,1)
      CALL CLOSE (HIMSCR,1)
      CALL WRTTRL (ITRLR)
      KORBGN = KORE
      IF (JHIM .EQ. 1) HIMSCR = ISCR4
C
C     TEST NUMBER OF MODAL POINTS
C
      MODAL = ITRLR(2)
      IF (FREBDY) MODAL = MODAL + FBMODS
      IF (MODAL .LE. ITRLR(3)) GO TO 300
      WRITE  (IPRNTR,145) UFM,OLDNAM,MODAL,ITRLR(3)
  145 FORMAT (A23,' 6633, FOR SUBSTRUCTURE ',2A4,' THE TOTAL NUMBER OF',
     1        ' MODAL COORDINATES (',I8,1H), /30X,
     2        'IS LARGER THAN THE NUMBER OF INTERNAL DOF (',I8,2H).)
      DRY = -2
      GO TO 300
C
C     PROCESS SYSTEM FATAL ERRORS
C
  160 IMSG = -2
      GO TO 190
  170 IMSG = -3
      GO TO 190
  180 IMSG = -8
      IFILE = 0
  190 CALL SOFCLS
      CALL MESAGE (IMSG,IFILE,MODNAM)
      GO TO 300
C
C     PROCESS MODULE FATAL ERRORS
C
  200 GO TO (210,210,220,230,240,260), ITEST
  210 IMSG = -11
      GO TO 270
  220 IMSG = -1
      GO TO 250
  230 IMSG = -2
      GO TO 250
  240 IMSG = -3
  250 CALL SMSG (IMSG,ITEM,OLDNAM)
      GO TO 300
  260 IMSG = -10
  270 CALL SMSG1 (IMSG,ITEM,OLDNAM,MODNAM)
      DRY = -2
  300 RETURN
      END

      SUBROUTINE GP3
C
C     GP3 IS THE MAIN CONTROL PROGRAM FOR MODULE GP3.
C     IF PLOAD2 CARDS ARE PRESENT, GP3C IS EXECUTED TO BUILD PLOAD DATA
C     ON SCRATCH FILE 2 (SCR2). GP3A IS EXECUTED TO BUILD THE STATIC
C     LOADS TABLE (SLT). GP3B IS EXECUTED TO BUILD THE GRID POINT
C     TEMPERATURE TABLE (GPTT).
C     GP3D IS EXECUTED TO BUILD THE ELEMENT TEMPERATURE TABLE (ETT) FROM
C     THE GPTT AND ANY TEMPP1,TEMPP2,TEMPP3, AND TEMPRB DATA PRESENT.
C
      INTEGER         BUF1   ,BUF2  ,BUF  ,SYSBUF,PLOAD2,TWO   ,SLT   ,
     1                GPTT  ,GEOM3  ,BUF3 ,STATUS,SPERLK
      COMMON /BLANK / NOGRAV ,NOLOAD,NOTEMP
      COMMON /GP3COM/ GEOM3 ,EQEXIN,GEOM2 ,SLT   ,GPTT  ,SCR1  ,SCR2  ,
     1                BUF1  ,BUF2  ,BUF(50)      ,CARDID(60)   ,IDNO(30)
     2,               CARDDT(60)   ,MASK(60)     ,STATUS(60)   ,NTYPES,
     3                IPLOAD,IGRAV ,PLOAD2(2)    ,LOAD(2)      ,NOPLD2,
     4                TEMP(2)      ,TEMPD(2)     ,TEMPP1(2)    ,
     5                TEMPP2(2)    ,TEMPP3(2)    ,TEMPRB(2)    ,BUF3  ,
     6                PLOAD3(2)    ,IPLD3
      COMMON /SYSTEM/ SYSBUF,SY(93),SPERLK
      COMMON /ZZZZZZ/ Z(1)
      COMMON /TWO   / TWO(32)
C
C     TURN PARAMETERS ON. INITIALIZE BUFFER POINTERS.
C     READ TRAILER ON GEOM3. IF PURGED, EXIT.
C
      CALL DELSET
C
      IF (SPERLK .EQ. 0) GO TO 20
      DO 10 I = 1,60,2
      STATUS(I  ) =-1
   10 STATUS(I+1) = 0
   20 NOLOAD = -1
      NOGRAV = -1
      NOTEMP = -1
      BUF1   = KORSZ(Z) - SYSBUF - 2
      BUF2   = BUF1 - SYSBUF
      BUF3   = BUF2 - SYSBUF - 2
      BUF(1) = GEOM3
      CALL RDTRL (BUF)
      IF (BUF(1) .NE. GEOM3) RETURN
C
C     IF THE SLT IS PURGED, BYPASS THE SLT PHASE OF GP3.
C     OTHERWISE, IF PLOAD2 CARDS PRESENT, EXECUTE GP3C.
C     EXECUTE GP3A TO COMPLETE SLT PHASE.
C
      BUF(7) = SLT
      CALL RDTRL (BUF(7))
      IF (BUF(7) .NE. SLT) GO TO 30
      CALL GP3C
      CALL GP3A
C
C     IF THE GPTT IS NOT PURGED, EXECUTE GP3B TO BUILD IT.
C
   30 BUF(7) = GPTT
      CALL RDTRL (BUF(7))
      IF (BUF(7) .NE. GPTT) RETURN
C
C     GP3B WILL FORM A GPTT ON SCR1 AND THEN GP3D WILL READ SCR1 AND
C     THE TEMPP1,TEMPP2,TEMPP3, AND TEMPRB DATA FROM GEOM3 TO FORM THE
C     ETT (ELEMENT TEMPERATURE TABLE) ON THE OUTPUT FILE GPTT.
C
      CALL GP3B
      CALL GP3D
      RETURN
      END

      SUBROUTINE CF2FBS (TPOSE,XOUT,IOBUF)
C*******
C     CF2FBS PERFORMS THE DOUBLE-PRECISION FORWARD AND BACKWARD SWEEPS
C     FOR THE COMPLEX FEER METHOD. THESE SWEEPS CONSTITUTE THE
C     OPERATIONAL INVERSE (MATRIX INVERSION).
C*******
C     DEFINITION OF INPUT AND OUTPUT PARAMETERS
C*******
C     TPOSE    = .FALSE. --- PERFORM OPERATION L * U
C              = .TRUE.  --- PERFORM OPERATION U-TRANSPOSE * L-TRANSPOSE
C     XOUT     = INPUT VECTOR GETS TRANSFORMED TO OUTPUT VECTOR
C     IOBUF    = INPUT  GINO BUFFER
C*******
      DOUBLE PRECISION  DTEMP    ,XOUT(1)  ,DA       ,UNIDUM
      INTEGER           NAME(2)  ,IOBUF(1) ,EOL      ,CDP
      LOGICAL           TPOSE(1) ,SYMMET   ,QPR
      COMMON  /FEERAA/  AADUM(117),MCBLT(7),MCBUT(7)
      COMMON  /FEERXC/  XCD01(4) ,SYMMET   ,XCD02(9) ,NSWP
     2                 ,XCD03(6) ,QPR
      COMMON  /ZNTPKX/  DA(2)    ,II       ,EOL
      COMMON  /NAMES /  RD       ,RDREW    ,WRT      ,WRTREW
     2                 ,REW      ,NOREW    ,EOFNRW   ,RSP
     3                 ,RDP      ,CSP      ,CDP
      COMMON  /SYSTEM/  KSYSTM   ,NOUT
      EQUIVALENCE       (AADUM(42),ISCR6)
      DATA   NAME       /4HCF2F,4HBS  /
C
      IF (QPR) WRITE (NOUT,8887) TPOSE(1),SYMMET,NSWP,ISCR6
 8887 FORMAT(1H0,12HENTER CF2FBS,8X,11HTRANSPOSE =,L2,L9,2I10)
               JUNK = 0
      IF (TPOSE(1) .AND. .NOT.SYMMET) GO TO 399
C*******
C     BELOW FOR OPERATION L * U
C     (LOGIC COPIED FROM SUBROUTINE CINFBS)
C*******
C     BEGIN FORWARD PASS USING THE LOWER TRIANGLE
C*******
      CALL GOPEN (MCBLT(1),IOBUF(1),RDREW)
      J = 1
  100 CALL INTPK(*200,MCBLT(1),0,CDP,0)
  110 IF (EOL) 3010,120,3010
  120 CALL ZNTPKI
               IF (QPR) WRITE (NOUT,8882) DA,II,EOL,J
 8882          FORMAT(1H ,4HDA =,2D16.8,4X,4HII =,I6,
     2                4X,5HEOL =,I2,4X,3HJ =,I4)
      IF (J-II) 184,130,110
C*******
C     PERFORM THE REQUIRED ROW INTERCHANGE
C*******
  130 IN1 = ( J + IFIX(SNGL(DA(1))) )*2 - 1
               IF (QPR) WRITE (NOUT,8883) IN1,EOL
 8883          FORMAT(1H ,3X,5HIN1 =,I6,4X,5HEOL =,I2)
      IN2 = IN1+1
      J2 = 2*J
      UNIDUM = XOUT(J2)
      XOUT(J2) = XOUT(IN2)
      XOUT(IN2) = UNIDUM
      J2 = J2-1
      UNIDUM = XOUT(J2)
      XOUT(J2) = XOUT(IN1)
      XOUT(IN1) = UNIDUM
  160 IF (EOL) 200,170,200
  170 CALL ZNTPKI
               IF (QPR) WRITE (NOUT,8882) DA,II,EOL,J
  184 II2 = 2*II
      II1 = II2-1
      J2 = 2*J
      J1 = J2-1
      XOUT(II1) = XOUT(II1) - DA(1)*XOUT(J1) + DA(2)*XOUT(J2)
      XOUT(II2) = XOUT(II2) - DA(2)*XOUT(J1) - DA(1)*XOUT(J2)
      GO TO 160
  200 J = J+1
      IF (J.LT.NSWP) GO TO 100
      CALL CLOSE (MCBLT(1),REW)
C*******
C     BEGIN BACKWARD PASS USING THE UPPER TRIANGLE
C*******
      IOFF = MCBUT(7)-1
               IF (QPR) WRITE (NOUT,8866) IOFF,MCBLT,MCBUT
 8866          FORMAT(1H ,15(1X,I7))
      CALL GOPEN (MCBUT(1),IOBUF(1),RDREW)
      J = NSWP
 210  CALL INTPK(*3020,MCBUT(1),0,CDP,0)
      IF (EOL) 3020,230,3020
  230 CALL ZNTPKI
               IF (QPR) WRITE (NOUT,8882) DA,II,EOL,J
      I = NSWP - II + 1
      IF (I.NE.J) GO TO 275
C*******
C     DIVIDE BY THE DIAGONAL
C*******
      I2 = 2*I
      I1 = I2-1
      UNIDUM = 1.D0/(DA(1)**2+DA(2)**2)
      DTEMP = (DA(1)*XOUT(I1)+DA(2)*XOUT(I2))*UNIDUM
      XOUT(I2) = (DA(1)*XOUT(I2)-DA(2)*XOUT(I1))*UNIDUM
      XOUT(I1) = DTEMP
               IF (QPR) WRITE (NOUT,8884)
 8884          FORMAT(1H ,6X,8HDIAGONAL)
C*******
C     SUBTRACT OFF REMAINING TERMS
C*******
  255 IF (I.GT.J) GO TO 230
      IF (EOL) 300,270,300
  270 CALL ZNTPKI
               IF (QPR) WRITE (NOUT,8882) DA,II,EOL,J
      I = NSWP - II + 1
  275 IN1 = I
      IN2 = J
      IF (I.LT.J) GO TO 279
      K = IN1
      IN1 = IN2-IOFF
               JUNK = 1
      IF (IN1.LE.0) GO TO 3020
      IN2 = K
  279 IN1 = 2*IN1
      IN2 = 2*IN2
      II1 = IN1-1
      II2 = IN2-1
            IF (QPR) WRITE (NOUT,8820) I,J,II1,II2
 8820       FORMAT(1H ,3HI =,I6,6X,3HJ =,I6,6X,5HII1 =,I6,6X,5HII2 =,I6)
      XOUT(II1) = XOUT(II1) - DA(1)*XOUT(II2) + DA(2)*XOUT(IN2)
      XOUT(IN1) = XOUT(IN1) - DA(2)*XOUT(II2) - DA(1)*XOUT(IN2)
      GO TO 255
  300 J = J-1
      IF (J.GT.0) GO TO 210
      CALL CLOSE (MCBUT(1),REW)
      GO TO 4000
C*******
C     BELOW FOR OPERATION U-TRANSPOSE * L-TRANSPOSE
C     (LOGIC COPIED FROM SUBROUTINE CDIFBS)
C*******
C     BEGIN THE FORWARD PASS USING THE UPPER TRIANGLE
C*******
  399 IOFF = MCBUT(7)-1
               IF (QPR) WRITE (NOUT,2216) IOFF
 2216          FORMAT(1H ,30X,6HIOFF =,I10)
      MCSAVE = MCBUT(1)
      MCBUT(1) = ISCR6
      CALL GOPEN (MCBUT(1),IOBUF(1),RDREW)
      DO 500  I = 1,NSWP
               IF (QPR) WRITE (NOUT,2218) I
 2218          FORMAT(1H ,12HLOOP INDEX =,I6)
      J = I+I
      CALL INTPK(*500,MCBUT(1),0,CDP,0)
  410 CALL ZNTPKI
               IF (QPR) WRITE (NOUT,2224) II,EOL,DA
 2224          FORMAT(1H ,4HII =,I14,6X,5HEOL =,I2,
     2                8X,4HDA =,2D16.8)
      IF (II-I) 430,420,440
C*******
C     DIVIDE BY THE DIAGONAL
C*******
  420 I1 = J-1
      UNIDUM = 1.D0/(DA(1)**2+DA(2)**2)
      DTEMP = (XOUT(I1)*DA(1) + XOUT(J)*DA(2))*UNIDUM
      XOUT(J) = (XOUT(J)*DA(1) - XOUT(I1)*DA(2))*UNIDUM
      XOUT(I1) = DTEMP
               IF (QPR) WRITE (NOUT,8884)
      GO TO 490
C*******
C     SUBTRACT OFF NORMAL TERM
C*******
  430 I2 = II+II
      I1 = I2-1
      J1 = J-1
      XOUT(J1) = XOUT(J1) - XOUT(I1)*DA(1) + XOUT(I2)*DA(2)
      XOUT(J) = XOUT(J) - XOUT(I1)*DA(2) - XOUT(I2)*DA(1)
      GO TO 490
C*******
C     SUBTRACT OFF ACTIVE COLUMN TERMS
C*******
  440 K = (I-IOFF)*2
               JUNK = 1
      IN1 = K
      IF (IN1.LE.0) GO TO 3020
      I2 = II+II
      I1 = I2-1
      J1 = K-1
      XOUT(I1) = XOUT(I1) - XOUT(J1)*DA(1) + XOUT(K)*DA(2)
      XOUT(I2) = XOUT(I2) - XOUT(K)*DA(1) - XOUT(J1)*DA(2)
  490 IF (EOL) 500,410,500
  500 CONTINUE
      CALL CLOSE (MCBUT(1),REW)
      MCBUT(1) = MCSAVE
C*******
C     BEGIN BACKWARD PASS USING THE LOWER TRIANGLE
C*******
      CALL GOPEN (MCBLT(1),IOBUF(1),RDREW)
      CALL SKPREC (MCBLT(1),NSWP)
      DO 600  I = 1,NSWP
               IF (QPR) WRITE (NOUT,2218) I
      CALL BCKREC (MCBLT(1))
      INTCHN = 0
      CALL INTPK(*600,MCBLT(1),0,CDP,0)
      J = (NSWP-I+1)*2
  520 CALL ZNTPKI
               IF (QPR) WRITE (NOUT,2224) II,EOL,DA
      IF (II.NE.NSWP-I+1) GO TO 550
      IF (II.LT.J/2) GO TO 3010
C*******
C     PERFORM THE INTERCHANGE
C*******
      INTCHN = IFIX(SNGL(DA(1)))*2
               IF (QPR) WRITE (NOUT,2226) INTCHN
 2226          FORMAT(1H ,4X,11HINTERCHANGE,I6)
      GO TO 590
  530 IN1 = J+INTCHN
               IF (QPR) WRITE (NOUT,2232) J,INTCHN,IN1
 2232          FORMAT(1H ,15X,3I6)
      DTEMP = XOUT(J)
      XOUT(J) = XOUT(IN1)
      XOUT(IN1) = DTEMP
      J1 = J-1
      I1 = IN1-1
      DTEMP = XOUT(J1)
      XOUT(J1) = XOUT(I1)
      XOUT(I1) = DTEMP
      GO TO 600
  550 J1 = J-1
      I2 = II+II
      I1 = I2-1
      XOUT(J1) = XOUT(J1) - XOUT(I1)*DA(1) + XOUT(I2)*DA(2)
      XOUT(J) = XOUT(J) - XOUT(I1)*DA(2) - XOUT(I2)*DA(1)
  590 IF (EOL) 595,520,595
  595 IF (INTCHN) 600,600,530
  600 CALL BCKREC (MCBLT(1))
      CALL CLOSE (MCBLT(1),REW)
      GO TO 4000
 3010 J = MCBLT(1)
      GO TO 3040
 3020 J = MCBUT(1)
 3040 CALL MESAGE (-5,J,NAME)
 4000 CONTINUE
               IF (QPR.AND.JUNK.EQ.0) WRITE (NOUT,5516)
 5516          FORMAT(1H0,30X,13HIOFF NOT USED,/1H )
               IF (QPR.AND.JUNK.NE.0) WRITE (NOUT,5518)
 5518          FORMAT(1H0,30X,13HIOFF WAS USED,/1H )
      RETURN
      END

      SUBROUTINE CDIFBS(DZ,BUF)
C
C     SUBROUTINE TO DO THE FBS PASS TO FIND THE LEFT EIGENVECTOR FOR
C     THE TRANSPOSED MATRIX
C
      INTEGER            UPRTRI    ,EOL      ,NAME(2)
      DOUBLE PRECISION   DTEMP     ,DZ(1)    ,DA
      DIMENSION          BUF(1)
C     COMMON   /DESCRP/  LENGTH    ,MAJOR
      COMMON   /ZNTPKX/  DA(2)     ,II       ,EOL
      COMMON   /NAMES/   RD        ,RDREW    ,WRT      ,WRTREW   ,
     1                   REW       ,NOREW    ,EOFNRW   ,RSP      ,
     2                   RDP       ,CSP      ,CDP
      COMMON   /CDCMPX/  IDUMM(20) ,IOF
      COMMON   /CINVPX/  IDUM(36)  ,SCRFIL(11)
      EQUIVALENCE        (SCRFIL(6),UPRTRI)  ,(SCRFIL(8),LOWTRI) ,
     1                   (IDUM(2),NROW)
      DATA      NAME  /  4HCDIF,4HBS  /
C
      CALL SSWTCH (12,IDIAG)
C
C     BEGIN THE FORWARD PASS USING THE UPPER TRIANGLE
C
      IOFF = IOF - 1
      CALL GOPEN (UPRTRI,BUF,RDREW)
      NROW2 = NROW + NROW
      DO 100 I = 1,NROW
      J = I + I
      CALL INTPK (*100,UPRTRI,0,CDP,0)
   10 CALL ZNTPKI
      IF (II-I) 30,20,40
C
C     DIVIDE BY THE DIAGONAL
C
   20 DTEMP = (DZ(J-1)*DA(1)+DZ(J  )*DA(2))/(DA(1)**2 + DA(2)**2)
      DZ(J) = (DZ(J  )*DA(1)-DZ(J-1)*DA(2))/(DA(1)**2 + DA(2)**2)
      DZ(J-1) = DTEMP
      GO TO 90
C
C     SUBTRACT OFF NORMAL TERM
C
   30 DZ(J-1) = DZ(J-1) - DZ(2*II-1)*DA(1) + DZ(2*II)*DA(2)
      DZ(J  ) = DZ(J  ) - DZ(2*II-1)*DA(2) - DZ(2*II)*DA(1)
      GO TO 90
C
C     SUBTRACT OFF ACTIVE COLUMN TERMS
C
   40 K = (I-IOFF)*2
      DZ(2*II-1) = DZ(2*II-1) - DZ(K-1)*DA(1) + DZ(K  )*DA(2)
      DZ(2*II  ) = DZ(2*II  ) - DZ(K  )*DA(1) - DZ(K-1)*DA(2)
   90 IF (EOL) 100,10,100
  100 CONTINUE
      CALL CLOSE (UPRTRI,REW)
C
C     BEGIN BACKWARD PASS USING THE LOWER TRIANGLE
C
      CALL GOPEN (LOWTRI,BUF,RDREW)
      CALL SKPREC (LOWTRI,NROW)
      DO 200 I = 1,NROW
      CALL BCKREC (LOWTRI)
      INTCHN = 0
      CALL INTPK (*200,LOWTRI,0,CDP,0)
      J = (NROW-I+1)*2
  120 CALL ZNTPKI
      IF (II .NE. NROW-I+1) GO TO 150
      IF (II .LT. J/2) GO TO 1010
C
C     PERFORM THE INTERCHANGE
C
      INTCHN = IFIX(SNGL(DA(1)))*2
      IF (IDIAG .NE. 0) WRITE (6,131) I,INTCHN
  131 FORMAT (5H I = ,I5,10HINTCHNG =  ,I5)
      GO TO 190
  130 IN1   = J + INTCHN
      DTEMP = DZ(J)
      DZ(J) = DZ(IN1)
      DZ(IN1) = DTEMP
      DTEMP   = DZ(J-1)
      DZ(J-1  ) = DZ(IN1-1)
      DZ(IN1-1) = DTEMP
      GO TO 200
  150 CONTINUE
      DZ(J-1) = DZ(J-1) - DZ(2*II-1)*DA(1) + DZ(2*II)*DA(2)
      DZ(J  ) = DZ(J  ) - DZ(2*II-1)*DA(2) - DZ(2*II)*DA(1)
  190 IF (EOL) 195,120,195
  195 IF (INTCHN) 200,200,130
  200 CALL BCKREC (LOWTRI)
      CALL CLOSE (LOWTRI,REW)
      RETURN
C
 1010 CALL MESAGE (-7,LOWTRI,NAME)
      RETURN
      END

      SUBROUTINE PAKCOL(TERMS,NTERMS)
C
C     PACKS OUT A COLUMN OF AF OR DKGG MATRIX - DATA IS IN THE
C     FOLLOWING SAMPLE FORMATS.
C
C                  ---------------------
C                  I  NEGATIVE ROWSIL  I
C                  I-------------------I
C                  I  1 MATRIX TERM    I
C                  I-------------------I
C                  I  POSITIVE ROWSIL  I
C                  I-------------------I
C                  I                   I
C                  I  3 MATRIX TERMS   I
C                  I                   I
C                  ---------------------
C
C     MATRIX TERMS ARE IN DOUBLE PRECISION
C
C
      DOUBLE PRECISION        VAL      ,TVAL
C
      INTEGER       TERMS(1) ,A        ,TEMP(7)
C
C     PACK COMMON BLOCK
C
      COMMON / ZBLPKX /       A(4)     ,IROW
C
      EQUIVALENCE  ( VAL , A(1) )
      EQUIVALENCE  ( TVAL , A(3) )
C
C***********************************************************************
C
C     SORT THE MATRIX ENTRIES BY ABSOULUTE SIL VALUES
C
      ILOC = 1
   10 ISIL = TERMS(ILOC)
      JLOC = ILOC
      JSIL = ISIL
   20 JLOC = JLOC + 3
      IF(JSIL .GT. 0) JLOC = JLOC + 4
      IF(JLOC .GE. NTERMS) GO TO 60
      JSIL = TERMS(JLOC)
      IF(IABS(JSIL) .GE. IABS(ISIL)) GO TO 20
C
      NT = 3
      IF(JSIL .GT. 0) NT = 7
      DO 30 I=1,NT
   30 TEMP(I) = TERMS(JLOC+I-1)
C
      KLOC = JLOC - 1
      DO 40 I=ILOC,KLOC
      J = KLOC - I + ILOC
   40 TERMS(J+NT) = TERMS(J)
C
      DO 50 I=1,NT
   50 TERMS(ILOC+I-1) = TEMP(I)
      ISIL = JSIL
      GO TO 20
C
   60 ILOC = ILOC + 3
      IF(ISIL .GT. 0) ILOC = ILOC + 4
      IF(ILOC .LT. NTERMS) GO TO 10
C
C     PACK OUT TERMS - ADDING ANY IDENTICAL SIL
C
      ILOC = 1
   70 IROW = IABS(TERMS(ILOC))
      NT = 2
      IF(TERMS(ILOC) .GT. 0) NT = 6
C
      DO 100 I=1,NT,2
      A(1) = TERMS(ILOC+I)
      A(2) = TERMS(ILOC+I+1)
      JLOC = ILOC
   80 J = JLOC
      JLOC = J + 3
      IF(TERMS(J) .GT. 0) JLOC = J + 7
      IF(JLOC .GE. NTERMS) GO TO 90
      IF(TERMS(JLOC) .NE. TERMS(ILOC)) GO TO 90
C
C     DUPLICATE SILS - ADD THEM
C
      A(3) = TERMS(JLOC+I)
      A(4) = TERMS(JLOC+I+1)
      VAL = VAL + TVAL
      J = JLOC
      GO TO 80
C
C     PACK OUT TERM
C
   90 CONTINUE
      CALL ZBLPKI
  100 IROW = IROW + 1
C
      ILOC = JLOC
      IF(ILOC .LT. NTERMS) GO TO 70
C
      RETURN
      END

      SUBROUTINE TIMTS2
C
C     TIMTS2 TIME TESTS CPU TIMES FOR VARIOUS TYPES OF LOOPS
C
C
      INTEGER         SYSBUF, OUTPUT, BUF1, BUF2, END, END2, END4,
     1                P, OPT1, OPT2, TYPE, NAME(4), TIG(16), MED(16),
     2                LOS(16), ISUBR(2)
      REAL            B(1), C(1), D(1)
      DOUBLE PRECISION ADND, AD(1), BD(1), CD(1), DD(1)
      COMPLEX         AC(1), BC(1), CC(1), DC(1), ADNC
      COMMON /BLANK / N, M, TYPE, OPT1, OPT2
      COMMON /SYSTEM/ KSYSTM(65)
      COMMON /ZZZZZZ/ A(1)
      EQUIVALENCE     (KSYSTM(1),SYSBUF), (KSYSTM(2),OUTPUT),
     1                (A(1),AC(1),AD(1), B(1),BC(1),BD(1),
     2                 C(1),CC(1),CD(1), D(1),DC(1),DD(1))
      DATA    TIG   / 1H ,4HTIGH, 4HT( R,4HSP ) ,
     1                1H ,4HTIGH, 4HT( R,4HDP ) ,
     2                1H ,4HTIGH, 4HT( C,4HSP ) ,
     3                1H ,4HTIGH, 4HT( C,4HDP ) /
      DATA    MED   / 1H ,4HMEDI, 4HUM(R,4HSP ) ,
     1                1H ,4HMEDI, 4HUM(R,4HDP ) ,
     2                1H ,4HMEDI, 4HUM(C,4HSP ) ,
     3                1H ,4HMEDI, 4HUM(C,4HDP ) /
      DATA    LOS   / 1H ,4HLOOS, 4HE (R,4HSP ) ,
     1                1H ,4HLOOS, 4HE (R,4HDP ) ,
     2                1H ,4HLOOS, 4HE (C,4HSP ) ,
     3                1H ,4HLOOS, 4HE (C,4HDP ) /
      DATA    ISUBR / 4HTIMT, 4HS2  /, M8/-8/
C
C     INITIALIZE
C
      CALL PAGE1
      WRITE  (OUTPUT,11) N,M,TYPE,OPT1
   11 FORMAT (1H  , 20X, 25HNASTRAN TIME TEST D   N =, I4, 5H, M =, I4 ,
     1        8H, TYPE =,I4, 8H, OPT1 =,I4)
      BUF1 = KORSZ(A) - SYSBUF
      BUF2 = BUF1 - SYSBUF
      END = N*M
      IF (END .GE. BUF1-1) CALL MESAGE (M8,0,ISUBR)
C
C     CPU TIME TESTS
C
      P = 4*(TYPE-1) + 1
      ASQ  = M + N
      ADNO = 1/(ASQ*ASQ)
      ADND = ADNO
      ADNC = CMPLX(ADNO,ADNO)
      END2 = END/2
      END4 = END/4
      GO TO (105,106,107,108), TYPE
C
C     REAL CPU TIME TESTS
C
  105 CONTINUE
C
      IF (M.GT.END .OR. N.GT.END) CALL MESAGE (M8,0,ISUBR)
      DO 111 I = 1,END
  111 A(I) = ADNO
      CALL CPUTIM (T1,T1,1)
      DO 100 I = 1,N
      DO 110 J = 1,M
      D(J) = A(J)*B(J) + C(J)
  110 CONTINUE
  100 CONTINUE
      CALL CPUTIM (T2,T2,1)
      IRET = 1
      NAME(1) = TIG(P  )
      NAME(2) = TIG(P+1)
      NAME(3) = TIG(P+2)
      NAME(4) = TIG(P+3)
      GO TO 500
  501 CONTINUE
C
      DO 211 I = 1,END
  211 A(I) = ADNO
      CALL CPUTIM (T1,T1,1)
      DO 200 I = 1,N
      DO 210 J = 1,M
      D(J) = A(I)*B(J) + C(J)
  210 CONTINUE
  200 CONTINUE
      CALL CPUTIM (T2,T2,1)
      IRET = 2
      NAME(1) = MED(P  )
      NAME(2) = MED(P+1)
      NAME(3) = MED(P+2)
      NAME(4) = MED(P+3)
      GO TO 500
  502 CONTINUE
C
      DO 311 I = 1,END
  311 A(I) = ADNO
      CALL CPUTIM (T1,T1,1)
      DO 300 I = 1,N
      DO 310 J = 1,M
      L = I + J - 1
      D(J) = A(I)*B(L) + C(J)
  310 CONTINUE
  300 CONTINUE
      CALL CPUTIM (T2,T2,1)
      IRET = 3
      NAME(1) = LOS(P  )
      NAME(2) = LOS(P+1)
      NAME(3) = LOS(P+2)
      NAME(4) = LOS(P+3)
      GO TO 500
C
C     DOUBLE PRECISION TESTS
C
  106 CONTINUE
C
      IF (M.GT.END2 .OR. N.GT.END2) CALL MESAGE (M8,0,ISUBR)
      DO 131 I = 1,END2
  131 AD(I) = ADND
      CALL CPUTIM (T1,T1,1)
      DO 120 I = 1,N
      DO 130 J = 1,M
      DD(J) = AD(J)*BD(J) + CD(J)
  130 CONTINUE
  120 CONTINUE
      CALL CPUTIM (T2,T2,1)
      IRET = 4
      NAME(1) = TIG(P  )
      NAME(2) = TIG(P+1)
      NAME(3) = TIG(P+2)
      NAME(4) = TIG(P+3)
      GO TO 500
  504 CONTINUE
C
      DO 231 I = 1,END2
  231 AD(I) = ADND
      CALL CPUTIM (T1,T1,1)
      DO 220 I = 1,N
      DO 230 J = 1,M
      DD(J) = AD(I)*BD(J) + CD(J)
  230 CONTINUE
  220 CONTINUE
      CALL CPUTIM (T2,T2,1)
      IRET = 5
      NAME(1) = MED(P  )
      NAME(2) = MED(P+1)
      NAME(3) = MED(P+2)
      NAME(4) = MED(P+3)
      GO TO 500
  505 CONTINUE
C
      DO 331 I = 1,END2
  331 AD(I) = ADND
      CALL CPUTIM (T1,T1,1)
      DO 320 I = 1,N
      DO 330 J = 1,M
      L = I + J - 1
      DD(J) = AD(I)*BD(L) + CD(J)
  330 CONTINUE
  320 CONTINUE
      CALL CPUTIM (T2,T2,1)
      IRET = 6
      NAME(1) = LOS(P  )
      NAME(2) = LOS(P+1)
      NAME(3) = LOS(P+2)
      NAME(4) = LOS(P+3)
      GO TO 500
C
C     COMPLEX SINGLE PRECISION TESTS
C
  107 CONTINUE
C
      IF (M.GT.END2 .OR. N.GT.END2) CALL MESAGE (M8,0,ISUBR)
      DO 421 I = 1,END2
  421 AC(I) = ADNC
      CALL CPUTIM (T1,T1,1)
      DO 410 I = 1,N
      DO 420 J = 1,M
      DC(J) = AC(J)*BC(J) + CC(J)
  420 CONTINUE
  410 CONTINUE
      CALL CPUTIM (T2,T2,1)
      IRET = 7
      NAME(1) = TIG(P  )
      NAME(2) = TIG(P+1)
      NAME(3) = TIG(P+2)
      NAME(4) = TIG(P+3)
      GO TO 500
  507 CONTINUE
C
      DO 441 I = 1,END2
  441 AC(I) = ADNC
      CALL CPUTIM (T1,T1,1)
      DO 430 I = 1,N
      DO 440 J = 1,M
      DC(J) = AC(I)*BC(J) + CC(J)
  440 CONTINUE
  430 CONTINUE
      CALL CPUTIM (T2,T2,1)
      IRET = 8
      NAME(1) = MED(P  )
      NAME(2) = MED(P+1)
      NAME(3) = MED(P+2)
      NAME(4) = MED(P+3)
      GO TO 500
  508 CONTINUE
C
      DO 461 I = 1,END2
  461 AC(I) = ADNC
      CALL CPUTIM (T1,T1,1)
      DO 450 I = 1,N
      DO 460 J = 1,M
      L = I + J - 1
      DC(J) = AC(I)*BC(L) + CC(J)
  460 CONTINUE
  450 CONTINUE
      CALL CPUTIM (T2,T2,1)
      IRET = 9
      NAME(1) = LOS(P  )
      NAME(2) = LOS(P+1)
      NAME(3) = LOS(P+2)
      NAME(4) = LOS(P+3)
      GO TO 500
C
C     DOUBLE PRECISION COMPLEX TESTS
C
  108 CONTINUE
C
      IF (M.GT.END4 .OR. N.GT.END4) CALL MESAGE (M8,0,ISUBR)
      DO 171 I = 1,END2
  171 AD(I) = ADND
      CALL CPUTIM (T1,T1,1)
      DO 160 I = 1,N
      DO 170 J = 1,M
C
C     D(J) AND D(J+1) CALCULATIONS WERE REVERSED
C     IN ORDER TO COUNTERACT THE ITERATIVE BUILD UP
C
      DD(J+1) = AD(J)*BD(J  ) - AD(J+1)*BD(J+1) + CD(J  )
      DD(J  ) = AD(J)*BD(J+1) + AD(J+1)*BD(J  ) + CD(J+1)
  170 CONTINUE
  160 CONTINUE
      CALL CPUTIM (T2,T2,1)
      IRET = 10
      NAME(1) = TIG(P  )
      NAME(2) = TIG(P+1)
      NAME(3) = TIG(P+2)
      NAME(4) = TIG(P+3)
      GO TO 500
  510 CONTINUE
C
      DO 271 I = 1,END2
  271 AD(I) = ADND
      CALL CPUTIM (T1,T1,1)
      DO 260 I = 1,N
      DO 270 J = 1,M
      DD(J  ) = AD(I)*BD(J  ) - AD(I+1)*BD(J+1) + CD(J  )
      DD(J+1) = AD(I)*BD(J+1) + AD(I+1)*BD(J  ) + CD(J+1)
  270 CONTINUE
  260 CONTINUE
      CALL CPUTIM (T2,T2,1)
      IRET = 11
      NAME(1) = MED(P  )
      NAME(2) = MED(P+1)
      NAME(3) = MED(P+2)
      NAME(4) = MED(P+3)
      GO TO 500
  511 CONTINUE
C
      DO 371 I = 1,END2
  371 AD(I) = ADND
      CALL CPUTIM (T1,T1,1)
      DO 360 I = 1,N
      DO 370 J = 1,M
      L = I + J - 1
      DD(J  ) = AD(I)*BD(L  ) - AD(I+1)*BD(L+1) + CD(J  )
      DD(J+1) = AD(I)*BD(L+1) + AD(I+1)*BD(L  ) + CD(J+1)
  370 CONTINUE
  360 CONTINUE
      CALL CPUTIM (T2,T2,1)
      IRET = 12
      NAME(1) = LOS(P  )
      NAME(2) = LOS(P+1)
      NAME(3) = LOS(P+2)
      NAME(4) = LOS(P+3)
      GO TO 500
  600 CONTINUE
      RETURN
C
C
C     INTERNAL ROUTINE TO WRITE OUTPUT ONTO THE OUTPUT FILE
C
  500 TIME = T2 - T1
      ITOT = M*N
      TPEROP = 1.0E6*TIME/ITOT
      IF (IRET.EQ.2 .OR. IRET.EQ.5 .OR. IRET.EQ.8 .OR. IRET.EQ.11)
     1    WRITE (OUTPUT,998) NAME,ITOT,TIME,TPEROP
C
      IF (IRET.NE.2 .AND. IRET.NE.5 .AND. IRET.NE.8 .AND. IRET.NE.11)
     1    WRITE (OUTPUT,999) NAME,ITOT,TIME,TPEROP
C
  998 FORMAT (1H0, 4A4, ' CPU TIME FOR ', I9,
     1        ' OPERATIONS = ', E12.5, ' SECONDS'/
     2        1X , 16X, ' CPU TIME FOR ', '      ONE',
     3        ' OPERATION  = ', E12.5, ' MICROSECONDS')
C
  999 FORMAT (1H0, 4A4, ' CPU TIME FOR ', I9,
     1        ' OPERATIONS = ', E12.5, ' SECONDS'/
     2        1X , 16X, ' CPU TIME FOR ', '      ONE',
     3        ' OPERATION  = ', E12.5, ' MICROSECONDS',
     4        '  ---  DATA FOR USE IN COMMON /NTIME/')
C
      GO TO (501,502,600,504,505,600,507,508,600,510,511,600), IRET
      END

      SUBROUTINE HDSKET (X,Y,Z,NP,NC)
C
C     THIS SUBROUTINE SETS UP PEN MOTION INDICATORS.
C
      INTEGER         XCC,X1SKT,Y1SKT,Z1SKT,X21,Y21,Z21,XE,YE,XU,YU,
     1                XI,YI,ZI,DI,W,IZ(1)
      DIMENSION       X(1),Y(1),Z(1)
      COMMON /HDPTRS/ XDUM,XCC,XASOLV,YASOLV,ZASOLV,X1SKT,Y1SKT,Z1SKT,
     1                ZCOEF1,ZCOEF,ICOUNT,IRCT,X21,Y21,Z21,IIA,XE,YE,
     2                XU,YU,XI,YI,ZI,DI,IBEG,IEND,ICT,ICCT,W
      COMMON /ZZZZZZ/ RZ(1)
      COMMON /HDSC  / SCX,YAW,ROL,PIT,LZ,VP,JJJ,ICORE
      EQUIVALENCE     (IZ(1),RZ(1))
C
      L   = NP
      LI  = NP
      IF (L .LE. 2) GO TO 50
      LX  = 1
      NPX = NP
    1 NPX = NPX-1
      I   = LX
      DO 8 M = I,NPX
      RX = 0
      A  = X(M+1) - X(M)
      B  = Y(M+1) - Y(M)
      C  = Z(M+1) - Z(M)
      IF (A .NE. 0.) GO TO 8
      IF (B .NE. 0.) GO TO 8
      IF (C .NE. 0.) GO TO 8
      IX = M
      IX1SKT = NPX
      DO 4 MX = IX,IX1SKT
      X(MX) = X(MX+1)
      Y(MX) = Y(MX+1)
      Z(MX) = Z(MX+1)
    4 CONTINUE
      RX = 1
      LX = M
      IF (LX .EQ. NPX) GO TO 10
      GO TO 1
    8 CONTINUE
   10 CONTINUE
      IF (RX .EQ. 1.) NPX = NPX - 1
      NP = NPX + 1
      LI = NP
      IF (NP .LE. 2) GO TO 50
      IX = 0
      M1 = 0
      M  = 1
      IS = NP - 1
   20 CONTINUE
      M  = M  + IX
      M1 = M1 + IX + 1
      IF (M-1 .EQ. LI) GO TO 70
C
C     SEARCH FOR MATCHING COORDINATES.
C
      DO 40 J = M,IS
      T = X(J+1) - X(M)
      U = Z(J+1) - Z(M)
      V = Y(J+1) - Y(M)
      IF (T .NE. 0.) GO TO 40
      IF (V .NE. 0.) GO TO 40
      IF (U .NE. 0.) GO TO 40
      NP = NP + 1
C
C     MATCH FOUND.....STORE COORDINATES AND SET SWITCH TO LIFT PEN
C     AND/OR END SET.
C
      IX = J + 2 - M
      IX1SKT = J - IS + 1
      DO 30 IK = 1,IX
      RZ(X1SKT+M1-2+IK) = X(M-1+IK)
      RZ(Y1SKT+M1-2+IK) = Y(M-1+IK)
      RZ(Z1SKT+M1-2+IK) = Z(M-1+IK)
   30 CONTINUE
      RZ(Z1SKT-1+M1+IX) = -ISIGN(1,IX1SKT)*9999.
      GO TO 20
   40 CONTINUE
   50 CONTINUE
      DO 60 J = 1,LI
      RZ(X1SKT-1+J) = X(J)
      RZ(Y1SKT-1+J) = Y(J)
      RZ(Z1SKT-1+J) = Z(J)
   60 CONTINUE
      NP = NP + 1
      RZ(Z1SKT-1+NP) = -9999.
   70 CONTINUE
      CALL HDLIN (RZ(X1SKT),RZ(Y1SKT),RZ(Z1SKT),NP,NC,
     1     RZ(XCC),IZ(ICOUNT),IZ(IRCT),RZ(X21),RZ(Y21),RZ(Z21),
     2     IZ(IIA),RZ(XE),RZ(YE),RZ(XU),RZ(YU),RZ(XI),RZ(YI),RZ(ZI),
     3     RZ(DI),IZ(IBEG),IZ(IEND),IZ(ICT),IZ(ICCT),
     4     IZ(W),IZ(W),RZ(W),RZ(W),IZ(W),IZ(W),IZ(W),RZ(W),RZ(W),RZ(W),
     5     RZ(W),RZ(W),RZ(W),RZ(W),IZ(W),IZ(W),RZ(W),RZ(W),RZ(W),RZ(W),
     6     IZ(W),IZ(W))
      NP = L
C
C     RESET VALUE FOR MAXIMUM NUMBER OF EDGES IF ARGUMENT IS COMPLETED.
C
      IF (VP .GT. 0.) LZ = LZ/5
      RETURN
      END

      SUBROUTINE DELTKL (DEL,R,Z,KODE)
C
C     EVAULATE -
C        DELT(K,L) = SURFACE-INTEGRAL((R**K)*(Z**L)) DR*DZ
C        WHERE  DR*DZ IS EITHER A TRIANGLE OR A TRAPEZOID.
C
C     USAGE -
C        CALL  DELTKL (DEL,R,Z,KODE)
C        WHERE  DEL   =  DOUBLE PRECISION ARRAY OF 15 LOCATIONS.
C                        CONTAINING THE RESULTS.
C        WHERE  R     =  DOUBLE PRECISION ARRAY OF  4 LOCATIONS.
C                        CONTAINING THE R-COORDINATES OF THE ELEMENT
C        WHERE  Z     =  DOUBLE PRECISION ARRAY OF  4 LOCATIONS.
C                        CONTAINING THE Z-COORDINATES OF THE ELEMENT
C               KODE  =  0  FOR TRIANGULAR  ELEMENT
C               KODE  =  1  FOR TRAPEZOIDAL ELEMENT
C
C     PROCEDURE -
C        INFORMATION IS COMPUTED AND STORED AS FOLLOWS.
C
C           COMPUTED  FOR        ELEMENT         STORED
C        TRIANGLE   TRAPEZOID    DELT(K,L)      DEL(LOC)
C        ================================================
C           X          X              0,0            1
C           X          X              1,0            2
C           X          X              0,1            3
C           X          X             -1,0            4
C           X          X             -1,1            5
C           X          X             -1,2            6
C                      X              1,1            7
C                      X              1,2            8
C                      X              2,1            9
C                      X              2,0           10
C                      X              0,2           11
C                      X              3,0           12
C                      X              3,1           13
C                      X              3,2           14
C                      X              2,2           15
C
      INTEGER          GOBACK,KODE,N,I,M,L
      DOUBLE PRECISION DEL(15),R(4),Z(4),RM,RI,ZM,ZI,LN,A,B,SI,SM,
     1                 R1,R2,R3,R4,R5,AB,A2,B2,A3,B3,AAB,ABB,R6,R7
C
C     ZERO ARRAY (ONLY THAT PORTION USING)
C
      N = 15
      DO 2 L = 1,N
    2 DEL(L) = 0.0D+0
C
C     HERE FOR LINE 1-2
C
      I = 1
      M = 2
      ASSIGN  23 TO GO BACK
      GO TO 50
C
C     HERE FOR LINE 2-3
C
   23 CONTINUE
      I = 2
      M = 3
      ASSIGN 34 TO GO BACK
      GO TO 50
C
C     HERE FOR LINE 31 (TRIANGLE),  LINE 3-4 (TRAP)
C
   34 CONTINUE
      I = 3
      IF (KODE .GT. 0) GO TO 35
      M = 1
      ASSIGN 90 TO GO BACK
      GO TO 50
   35 M = 4
      ASSIGN 41 TO GO BACK
      GO TO 50
   41 I = 4
      M = 1
      ASSIGN 90 TO GO BACK
C
C     BEGIN LOCAL SUBROUTINE (DEL-KL-I,M)
C
   50 RM = R(M)
      RI = R(I)
      R1 = RM - RI
      IF (DABS(R1) .LT. 1.0D-07) GO TO 80
C
C     THIS LINE IS NOT PARALLEL TO Z-AXIS
C
      ZM = Z(M)
      ZI = Z(I)
      IF (ZI.EQ.0.0D+0 .AND. ZM.EQ.0.0D+0) GO TO 80
C
C     SPECIAL CASE, ZM = ZI = 0   THUS ALL  A,B = 0  AND
C     ALL DEL TERMS  = 0 .   THUS SKIP AND SAVE CPU.
C
      A   = (RM*ZI - RI*ZM)/R1
      B   = (ZM - ZI)/R1
      LN  = DLOG(RM/RI)
      SI  = RI * RI
      SM  = RM * RM
      R2  = SM - SI
      SI  = SI * RI
      SM  = SM * RM
      R3  = SM - SI
      SI  = SI * RI
      SM  = SM * RM
      R4  = SM - SI
      SI  = SI * RI
      SM  = SM * RM
      R5  = SM - SI
      A2  = A  * A
      A3  = A  * A2
      B2  = B  * B
      B3  = B  * B2
      AB  = A  * B
      AAB = A  * AB
      ABB = B  * AB
      DEL( 1) = A*R1 + B*R2/2.0D+0 + DEL(1)
      DEL( 2) = A*R2/  2.0D+0 + B*R3 /3.0D+0 + DEL(2)
      DEL( 3) = A2*R1/ 2.0D+0 + AB*R2/2.0D+0 + B2*R3/6.0D+0 + DEL(3)
      DEL( 4) = A*LN + B*R1   + DEL(4)
      DEL( 5) = A2*LN/ 2.0D+0 + AB*R1  + B2*R2 /4.0D+0 + DEL(5)
      DEL( 6) = A3*LN/ 3.0D+0 + AAB*R1 + ABB*R2/2.0D+0 + B3*R3/9.0D+0
     1        + DEL(6)
      DEL( 7) = A2*R2/ 4.0D+0 + AB*R3/3.0D+0  + B2*R4 /8.0D+0 + DEL(7)
      DEL( 8) = A3*R2/ 6.0D+0 + AAB*R3/3.0D+0 + ABB*R4/4.0D+0
     1        + B3*R5/15.0D+0 + DEL(8)
      DEL( 9) = A2*R3/ 6.0D+0 + AB*R4/4.0D+0 + B2*R5/10.0D+0 + DEL(9)
      DEL(10) = A *R3/ 3.0D+0 + B*R4 /4.0D+0 + DEL(10)
      DEL(12) = A *R4/ 4.0D+0 + B*R5 /5.0D+0 + DEL(12)
      IF (KODE .LT. 1) GO TO 80
      SI      = SI*RI
      SM      = SM*RM
      R6      = SM - SI
      R7      = (SM*RM - SI*RI)
      DEL(11) = A3*R1/ 3.0D+0 + AAB*R2/2.0D+0 + ABB*R3/3.0D+0
     1        + B3*R4/12.0D+0 + DEL(11)
      DEL(13) = A2*R4/ 8.0D+0 + AB*R5 /5.0D+0 + B2*R6/12.0D+0 + DEL(13)
      DEL(14) = A3*R4/12.0D+0 + AAB*R5/5.0D+0 + ABB*R6/6.0D+0
     1        + B3*R7/21.0D+0 + DEL(14)
      DEL(15) = A3*R3/ 9.0D+0 + AAB*R4/4.0D+0 + ABB*R5/5.0D+0
     1        + B3*R6/18.0D+0 + DEL(15)
   80 GO TO GO BACK, (23,34,41,90)
C
C     THE ABSOLUTE VALUE IS CHOSEN SO THAT NODES INPUT MAY BE ORDERED
C     CW OR CCW.   RESULTS ARE SAME FOR A GIVEN ELEMENT.
C
   90 DO 95 L = 1,N
   95 DEL(L) = DABS(DEL(L))
      RETURN
      END

      SUBROUTINE NASCAR
C
C     NASCAR READS THE NASTRAN CARD (IF PRESENT) AND CALLS TTLPGE.
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        RSHIFT,ORF,COMPLF
      INTEGER         HDG(14),NSTRN(2),BDT(7),FILES(2),
     1                MODCOM(9),KEYWDS(2,17),BUF(75)
      REAL            S1,RTOLEL
      CHARACTER       UFM*23,UWM*25,S2*16
      COMMON /XMSSG / UFM,UWM
      COMMON /MACHIN/ MACH
      COMMON /SYSTEM/ SYSTEM(100)
      COMMON /BLANK / FLAG,CARD(20)
      COMMON /OUTPUT/ PGHDG(96)
      COMMON /XFIST / NFIST,LFIST,FIST(2)
      COMMON /XPFIST/ NPFIST
      COMMON /LHPWX / LHPW(4),MXFL
      EQUIVALENCE     (SYSTEM( 1),SYSBUF),
     1                (SYSTEM( 2),OUTTAP),
     2                (SYSTEM( 3),NOGO  ),
     3                (SYSTEM( 4),INTAP ),
     4                (SYSTEM( 7),LOGFL ),
     5                (SYSTEM(20),PLTFLG),
     6                (SYSTEM(29),MAXFIL),
     7                (SYSTEM(30),MAXOPN),
     8                (SYSTEM(34),IDRUM ),
     O                (SYSTEM(57),MODCOM(1)),
     A                (SYSTEM(70),ITOLEL,RTOLEL),
     B                (SYSTEM(77),BANDIT)
C
      DATA NSTRN  /4HNAST,  4HRAN /
      DATA FILES  /4HFILE,  1HS   /, BLANK / 1H  /
      DATA LKEYWD /   17 /
      DATA KEYWDS /4HBUFF,  4HSIZE,
     2             4HCONF,  4HIG  ,
     3             4HMAXF,  4HILES,
     4             4HMAXO,  4HPEN ,
     5             4HSYST,  4HEM  ,
     6             4HKON3,  4H60  ,
     7             4HNLIN,  4HES  ,
     8             4HTITL,  4HEOPT,
     9             4HMODC,  4HOM  ,
     O             4HHICO,  4HRE  ,
     1             4HDRUM,  4H    ,
     2             4HTRAC,  4HKS  ,
     3             4HSTST,  4H    ,
     4             4HBAND,  4HIT  ,
     5             4HBULK,  4HDATA,
     6             4HPLOT,  4HOPT ,
     7             4HLOGF,  4HL   /
      DATA HDG    /4HN A ,4HS T ,4HR A ,4HN  S,4H Y S,4H T E,4H M  ,
     1             4HP A ,4HR A ,4HM E ,4HT E ,4HR  E,4H C H,4H O  /
      DATA BDT    /4HTCRI,4HTMTH,4HTMPC,4HTDEP,4HTPCH,4HTRUN,4HTDIM/
      DATA TOPT   /  -9  /
C     DATA ADD    /4H@ASG,4H,T  ,4HLOG-,4HFILE,4H.,F ,4H .  /
      DATA S1,S2  /4HWORD, ' OF /SYSTEM/ IS '/
C
C
C     CONMSG (BCD7,1,1)
      MASK1 = COMPLF(0)
      MASK2 = RSHIFT(MASK1,1)
C
C     CALL NSINFO TO OPEN NAINFO FILE AND PICK UP ANY PRESET SYSTEM
C     PARAMETERS FROM THE SECOND SECTION OF THAT FILE
C
      J = 2
      CALL NSINFO (J)
      IF (J .NE. 2) TOPT = J
C
C     READ FIRST CARD IN DATA STREAM AND CALL XRCARD TO CONVERT IT.
C     IF INPUT CARD IS BLANK, READ NEXT CARD
C
   10 CALL XREAD (*3500,CARD)
      IF (CARD(1).EQ.BLANK .AND. CARD(2).EQ.BLANK .AND. CARD(3).EQ.BLANK
     1   .AND. CARD(5).EQ.BLANK .AND. CARD(7).EQ.BLANK) GO TO 10
      CALL XRCARD (BUF,75,CARD)
      FLAG = 1
      IF (BUF(1)) 4000,15,20
   15 IF (NOGO .EQ. 0) GO TO 10
      NOGO = 0
      GO TO 4000
C
C     IF CARD IS NASTRAN PARAMETER CARD, ECHO IT.
C
   20 IF (BUF(2).NE.NSTRN(1) .OR. BUF(3).NE.NSTRN(2)) GO TO 4000
      DO 25 I = 1,14
   25 PGHDG(I+2) = HDG(I)
      IF (SYSTEM(11) .LE. 0) CALL PAGE1
      WRITE  (OUTTAP,30) (CARD(I),I=1,20)
   30 FORMAT (5X,20A4)
C
C     RETURN IF NO KEYWORD ON NASTRAN CARD
C
      IF (BUF(4) .EQ. MASK2) GO TO 4000
      FLAG = 0
C
C     IDENTIFY KEYWORDS AND BRANCH TO APPROPRIATE CODE.
C
      J  = 4
   35 JN = 2*BUF(1) + 1
      J1 = 1
      GO TO 50
   40 IF (BUF(J1)) 85,45,50
   45 CALL XREAD  (*3500,CARD)
      CALL XRCARD (BUF,75,CARD)
      WRITE (OUTTAP,30) CARD
      IF (BUF(1) .EQ. 0) GO TO 45
      J = 2
      GO TO 35
   50 IF (BUF(J1) .EQ. MASK2) GO TO 4000
      DO 55 I = 1,LKEYWD
      IF (BUF(J).EQ.KEYWDS(1,I) .AND. BUF(J+1).EQ.KEYWDS(2,I)) GO TO 110
   55 CONTINUE
      IF (BUF(J) .EQ. KEYWDS(1,14)) GO TO 100
      IF (BUF(J) .EQ. FILES(1)) GO TO 3000
      IF (BUF(J) .NE. BLANK) GO TO 60
      J = J + 2
      IF (BUF(J+2) .EQ. MASK2) GO TO 4000
      IF (BUF(J) .EQ. 0) GO TO 45
      IF (J .LT. JN) GO TO 50
      J1 = JN + 1
      IF (BUF(J1) .EQ. MASK2) GO TO 4000
      JN = 2*BUF(J1) + 1
      J  = J1 + 1
      GO TO 50
C
C     PRINT MESSAGE FOR UNIDENTIFIED KEYWORD.
C
   60 CONTINUE
      WRITE  (OUTTAP,65) UFM,BUF(J),BUF(J+1)
   65 FORMAT (A23,' 17, UNIDENTIFIED NASTRAN CARD KEYWORD ',2A4,
     1        '.  ACCEPTABLE KEYWORDS FOLLOW ---', /1H0 )
      DO 70 I = 1,LKEYWD
      WRITE (OUTTAP,75) KEYWDS(1,I),KEYWDS(2,I)
   70 CONTINUE
   75 FORMAT (5X,2A4)
      WRITE  (OUTTAP,80) (BDT(I),I=1,7)
   80 FORMAT (7(5X,4HBAND,A4),
     1        /5X,'FILES (MUST BE LAST IN INPUT LIST)')
      NOGO = 1
      GO TO 4000
C
C     PRINT MESSAGE FOR BAD FORMAT.
C
   85 WRITE  (OUTTAP,90) UFM
   90 FORMAT (A23,' 43, INCORRECT FORMAT FOR NASTRAN CARD.')
      NOGO = 1
      GO TO 4000
C
C     . CHECK FOR LEGAL REAL NUMBER...
C
   95 CONTINUE
      IF (BUF(J1-2) .NE. -2) GO TO 85
      IF (BUF(J1-2) .EQ. -2) GO TO 120
      IF (I .EQ. 11) GO TO 1100
C
C     . BANDIT KEYWORDS.
C
  100 I = 1400
      K = BUF(J+1)
C
C     KEYWORD FOUND.
C
  110 CONTINUE
      J1 = JN + 1
      PARAM = BUF(J1+1)
      J1 = J1 + 2
      IF (BUF(J1) .NE. MASK2) JN = 2*BUF(J1) + J1
      J  = J1 + 1
      IF (BUF(J1-2) .NE. -1) GO TO 95
  120 CONTINUE
      IF (I .EQ. 1400) GO TO 1400
      GO TO ( 150, 200, 300, 400, 500, 600, 700, 800, 900,1000,
     1       1100,1200,1300,1450,1500,1600,1700),  I
C
C     BUFFSIZE
C
  150 CONTINUE
      SYSBUF = PARAM
      GO TO 40
C
C     IGNORE THE CONFIG PARAMETER
C
  200 CONTINUE
      GO TO 40
C
C     MAXFILES UPPER LIMIT
C
  300 CONTINUE
      M = MXFL
      IF (PARAM .LE. M) GO TO 320
      WRITE  (OUTTAP,310) M
  310 FORMAT (' *** MAXFILES IS RESET TO THE LIMIT OF 74')
      PARAM = M
  320 MAXFIL = PARAM
      GO TO 40
C
C     MAXOPEN
C
  400 CONTINUE
      IF (PARAM .LE. MAXFIL) GO TO 420
      IF (PARAM .GT.   MXFL) GO TO 430
      WRITE  (OUTTAP,410) PARAM
  410 FORMAT (' *** MAXOPEN EXCEEDS MAXFILES. MAXFILES IS AUTOMATICALLY'
     1,       ' EXPANDED TO',I4)
      MAXFIL = PARAM
  420 MAXOPN = PARAM
      GO TO 40
C
  430 M = MXFL
      WRITE  (OUTTAP,440) M,M
  440 FORMAT (' *** MAXOPEN EXCEEDS MAXFILES LIMIT OF ',I3,'.  BOTH ',
     1        'MAXOPEN AND MAXFILES ARE RESET ONLY TO ',I3,' EACH')
      MAXFIL = M
      MAXOPN = M
      GO TO 40
C
C     SYSTEM
C
  500 CONTINUE
      IF (PARAM .LE.  0) GO TO 85
      IF (PARAM .NE. 24) GO TO 510
      WRITE (OUTTAP,505)
  505 FORMAT ('0*** FATAL, USER SHOULD NOT CHANGE THE 24TH WORD OF ',
     1       '/SYSTEM/')
      NOGO = 1
      GO TO 40
C
  510 IF (BUF(J1)) 530,40,520
  520 J1 = JN + 1
      J  = J1 + 1
      IF (BUF(J1) .EQ. MASK2) GO TO 85
      JN = J1 + 2*BUF(J1)
      GO TO 510
  530 IF (BUF(J1).EQ.-2 .AND. PARAM.NE.70) GO TO 85
C
C     IGNORE THE CONFIG PARAMETER
C
      IF (PARAM .NE. 28) SYSTEM(PARAM) = BUF(J)
C
C     SYSTEM WORD ECHO
C
      IF (PARAM .GE. 10) GO TO 531
      IF (PARAM .EQ.  1) WRITE (OUTTAP,541) S1,PARAM,S2
      IF (PARAM .EQ.  2) WRITE (OUTTAP,542) S1,PARAM,S2
      IF (PARAM .EQ.  3) WRITE (OUTTAP,543) S1,PARAM,S2
      IF (PARAM .EQ.  4) WRITE (OUTTAP,544) S1,PARAM,S2
      IF (PARAM .EQ.  7) WRITE (OUTTAP,547) S1,PARAM,S2
      IF (PARAM.EQ.7 .AND. MACH.EQ.3) WRITE (OUTTAP,548)
      IF (PARAM .EQ.  9) WRITE (OUTTAP,549) S1,PARAM,S2
      GO TO 590
  531 K = PARAM/10
      IF (K .LE. 9) GO TO (532,532,533,534,534,536,536,536,536), K
      WRITE (OUTTAP,540) S1,PARAM,S2
      GO TO 590
  532 IF (PARAM .EQ. 20) WRITE (OUTTAP,550) S1,PARAM,S2
      IF (PARAM .EQ. 28) WRITE (OUTTAP,558) S1,PARAM,S2
      IF (PARAM .EQ. 29) WRITE (OUTTAP,559) S1,PARAM,S2
      GO TO 590
  533 IF (PARAM .EQ. 30) WRITE (OUTTAP,560) S1,PARAM,S2
      IF (PARAM .EQ. 31) WRITE (OUTTAP,561) S1,PARAM,S2
      IF (PARAM.EQ.34 .AND. MACH.NE.4) WRITE (OUTTAP,564) S1,PARAM,S2
      IF (PARAM.EQ.34 .AND. MACH.EQ.4) WRITE (OUTTAP,565) S1,PARAM,S2
      GO TO 590
  534 IF (PARAM .EQ. 42) WRITE (OUTTAP,572) S1,PARAM,S2
      IF (PARAM .EQ. 45) WRITE (OUTTAP,575) S1,PARAM,S2
      IF (PARAM .EQ. 57) WRITE (OUTTAP,577) S1,PARAM,S2
      IF (PARAM .EQ. 58) WRITE (OUTTAP,578) S1,PARAM,S2
      IF (PARAM .EQ. 59) WRITE (OUTTAP,579) S1,PARAM,S2
      GO TO 590
  536 IF (PARAM.GE.60 .AND. PARAM.LE.65) WRITE (OUTTAP,577) S1,PARAM,S2
      IF (PARAM .EQ. 70) WRITE (OUTTAP,580) S1,PARAM,S2
      IF (PARAM .EQ. 77) WRITE (OUTTAP,587) S1,PARAM,S2
      GO TO 590
  540 FORMAT (5X,A4,I3,A16,'NOT AVAILABLE. INPUT IGNORED')
  541 FORMAT (5X,A4,I3,A16,'GINO BUFFER SIZE')
  542 FORMAT (5X,A4,I3,A16,'OUTPUT UNIT')
  543 FORMAT (5X,A4,I3,A16,'NOGO FLAG')
  544 FORMAT (5X,A4,I3,A16,'INPUT UNIT')
  547 FORMAT (5X,A4,I3,A16,'NO. OF CONSOLE LOG MESSAGES')
  548 FORMAT (1H+,31X,'. (95 MAX.)')
  549 FORMAT (5X,A4,I3,A16,'NO. OF LINES PER PAGE. MINIMUM 10')
  550 FORMAT (5X,A4,I3,A16,'PLOT OPTION')
  558 FORMAT (5X,A4,I3,A16,'MACHINE CONFIGURATION (IGNORED)')
  559 FORMAT (5X,A4,I3,A16,'MAX FILES')
  560 FORMAT (5X,A4,I3,A16,'MAX FILES OPEN')
  561 FORMAT (5X,A4,I3,A16,'HI-CORE')
  564 FORMAT (5X,A4,I3,A16,'DRUM FLAG')
  565 FORMAT (5X,A4,I3,A16,'NOS/NOS-BE FLAG')
  572 FORMAT (5X,A4,I3,A16,'SYSTEM RELEASE DATE')
  575 FORMAT (5X,A4,I3,A16,'TAPE BIT')
  577 FORMAT (5X,A4,I3,A16,'DATA EXTRACTED FROM ADUM CARDS')
  578 FORMAT (5X,A4,I3,A16,'MPYAD METHOD SELECTION')
  579 FORMAT (5X,A4,I3,A16,'PLOT TAPE TRACK SPEC')
  580 FORMAT (5X,A4,I3,A16,'SMA1 SINGULAR TOLERANCE')
  587 FORMAT (5X,A4,I3,A16,'BANDIT/BULKDATA FLAG')
C
C     SET BOTTOM LIMIT OF 10 TO NUMBER OF LINES PER PAGE
C     AND FOR UNIVAC ONLY, LIMIT THE CONSOLE LOG MESSAGES TO 95 MAXIMUM
C
  590 IF (PARAM.EQ.9 .AND. SYSTEM(9).LT.10) SYSTEM(9) = 10
      IF (MACH .EQ.3 .AND. PARAM.EQ.7 .AND. SYSTEM(7).GT.95)
     1    SYSTEM(7) = 95
      J1 = J1 + 2
      J  = J1 + 1
      IF (BUF(J1) .EQ. MASK2) GO TO 4000
      JN = J1 + 2*BUF(J1)
      GO TO 40
C
C     KON360/HICORE
C
  600 CONTINUE
      SYSTEM(31) = PARAM
      GO TO 40
C
C     NLINES - BOTTOM-LIMITED TO 10
C
  700 CONTINUE
      SYSTEM(9) = PARAM
      IF (SYSTEM(9) .LT. 10) SYSTEM(9) = 10
      GO TO 40
C
C     TITLEOPT
C
  800 CONTINUE
      TOPT = PARAM
      IF (MACH.EQ.3 .AND. TOPT.LE.-2) LOGFL = 3
      GO TO 40
C
C     MODCOM COMMUNICATION AREA
C
  900 CONTINUE
      IF (PARAM .LE. 0) GO TO 85
  910 IF (BUF(J1)) 930,40,920
  920 J1 = JN + 1
      J  = J1 + 1
      IF (BUF(J1) .EQ. MASK2) GO TO 85
      JN = J1 + 2*BUF(J1)
      GO TO 910
  930 MODCOM(PARAM) = BUF(J)
      J1 = J1 + 2
      J  = J1 + 1
      IF (BUF(J1) .EQ. MASK2) GO TO 4000
      JN = J1 + 2*BUF(J1)
      GO TO 40
C
C     HICORE = LENGTH OF CORE ON UNIVAC, VAX, AND UNIX
C
 1000 CONTINUE
      SYSTEM(31) = PARAM
      GO TO 40
C
C     UNIVAC - DRUM ALLOCATION, 1 BY POSITIONS, 2 BY TRACKS
C              DEFAULT IS 1,  150 POSITIONS  (GOOD FOR LARGE JOB)
C              IF DRUM IS 2, 1280 TRKS. IS ASSIGNED (SUITABLE FOR
C                 SMALLER JOB)
C
C     CDC - IDRUM (34TH WORD OF /SYSTEM/) IS LENGTH OF FET + DUMMY INDEX
C
 1100 IDRUM = PARAM
      GO TO 40
C
C     PLOT TAPE TRACK SIZE    TRACK=7 IMPLIES 7 TRACK
C                             TRACK=9 IMPLIES 9 TRACK
C
 1200 IF (PARAM.NE.7 .AND. PARAM.NE.9) GO TO 1250
      IF (PARAM .EQ. 7) SYSTEM(59) = 1
      IF (PARAM .EQ. 9) SYSTEM(59) = 2
      GO TO 40
 1250 WRITE (OUTTAP,1480) UWM,PARAM,KEYWDS(1,12),KEYWDS(2,12)
      NOGO = 1
      GO TO 40
C
C     . ELEMENT SINGULARITY TOLERANCE (A REAL S.P. NUMBER)...
C
 1300 ITOLEL = PARAM
      IF (BUF(J1-2).EQ.-1) RTOLEL = ITOLEL
      GO TO 40
C
C     BANDIT (77TH WORD OF SYSTEM)
C     BANDIT KEYWORDS (DEFAULT VALUES IN BRACKETS, SET BY BGRID ROUTINE)
C        BANDTCRI = (1),2,3,4     CRITERION
C        BANDTMTH = 1,2,(3)       METHOD
C        BANDTMPC = (0),1,2       MPC EQUS. AND RIGID ELEMENTS
C        BANDTDEP = (0),1         DEPENDANT GRID
C        BANDTPCH = (0),1         PUNCH SEQGP CARDS
C        BANDTRUN = (0),1         RUN/SEQGP
C        BANDTDIM = (0),1,2,...,9 SCRATCH ARRAY DIMENSION
C        BANDIT   = -1,(0)        BANDIT SKIP FLAG
C     WHERE,
C        CRITERION = 1, USE RMS WAVEFRONT TO DETERMINE BEST RESULT,
C                  = 2, BANDWIDTH,  =3, PROFILE, OR  =4, MAX WAVEFRONT
C        METHOD    = 1, CM METHOD IS USED,   3, GPS, OR     2, BOTH
C        MPC       = 0, MPC'S AND RIGID ELEM ARE NOT CONSIDERED
C                  = 1, MPC'S AND RIGID ELEM ARE USED IN RESEQUENCING
C                  = 2, ONLY RIGID ELEMENTS ARE USED IN RESEQUENCING
C        DEPEND    = 0, DEPENDANT GRID IS OMITTED IN RESEQUENCING
C                       IF MPC IS NON-ZERO
C                  = 1, DEPENDANT GRIDS ARE INCLUDED
C        PUNCH     = 0, NO SEQGP CARDS PUNCHED
C                  = 1, PUNCH OUT BANDIT GENERATED SEQGP CARDS AND
C                       TERMINATE NASTRAN JOB
C        RUN/SEQGP = 0, BANDIT WOULD QUIT IF THERE IS ONE OR MORE SEQGP
C                       CARD IN THE INPUT DECK
C                  = 1, TO FORCE BANDIT TO BE EXECUTED EVEN IF SEQGP
C                       CARDS ARE PRESENT
C        DIM       = 1,2,...,N, TO SET THE SCRATCH AREA, USED ONLY IN
C                       GPS METHOD, TO N*100. (N IS 9 OR LESS)
C                  = 0, DIMENSION IS SET TO 150
C        BANDIT    =-1, BANDIT COMPUTATION IS SKIPPED UNCONDITIONALLY
C                  = 0, BANDIT WOULD BE EXECUTED IF BULK DATA CONTAINS
C                       NO INPUT ERROR
C
 1400 CONTINUE
      IF (BANDIT .LT. 0) GO TO 40
      IF (K.EQ.BDT(7) .AND. PARAM.GE.100) PARAM = PARAM/100
      IF (PARAM.LT.0 .OR. PARAM.GT.9) GO TO 1470
      DO 1420 I = 1,7
      IF (K .NE. BDT(I)) GO TO 1420
      K = PARAM*10**(I-1)
      GO TO 1430
 1420 CONTINUE
      GO TO 60
 1430 BANDIT = BANDIT + K
      GO TO 40
 1450 IF (PARAM .LT. 0) BANDIT = -1
      IF (PARAM .LE. 0) GO TO 40
      K = KEYWDS(2,14)
 1470 WRITE  (OUTTAP,1480) UWM,PARAM,KEYWDS(1,14),K
 1480 FORMAT (A25,' 65, ILLEGAL VALUE OF ',I7,' IN NASTRAN ',2A4,
     1       ' CARD')
      GO TO 40
C
C     BULK DATA CHECK ONLY
C     TO TERMINATE JOB AFTER BULK DATA CHECK, AND SKIP OVER BANDIT
C     (OPTION TO PRINTOUT TIME CONSTANTS IN /NTIME/, IF BULKDATA=-3)
C
 1500 CONTINUE
      IF (PARAM  .NE.  0) BANDIT = -2
      IF (BANDIT .EQ. -2) MAXFIL = 23
      IF (PARAM  .EQ. -3) BANDIT = -3
      GO TO 40
C
C     PLOT OPTIONS -
C
C     PLTFLG   BULKDATA    PLOT COMMANDS       ACTION TAKEN
C     -----  ------- --   -------------  -------------------------------
C      0      NO ERROR    NO ERROR       EXECUTES ALL LINKS, NO PLOTS
C             NO ERROR       ERROR       STOPS AFTER LNK1 DATA CHECK
C                ERROR  ERR OR NO ERR    STOPS AFTER LINK1 CHECK
C      1      NO ERROR    NO ERROR       GO, ALL LINKS AND PLOTS
C             NO ERROR       ERROR       STOP AFTER LINK1 DATA CHECK
C                ERROR    NO ERROR       STOP AFTER LINK1 DATA CHECK
C                ERROR       ERROR       STOP AFTER LINK1 DATA CHECK
C      2      NO ERROR    NO ERROR       STOP AFTER UNDEFORM PLOT/LINK2
C             NO ERROR       ERROR       STOP AFTER LINK1 DATA CHECK
C                ERROR    NO ERROR       STOP AFTER UNDEFORM PLOT/LINK2
C                ERROR       ERROR       STOP AFTER LINK1 DATA CHECK
C      3      (ERROR OR   (ERROR OR      (ATTEMPT TO PLOT UNDEFORM MODEL
C             NO ERROR)   NO ERROR)      THEN STOP/LINK2)
C      4      NO ERROR    NO ERROR       GO, ALL LINKS AND PLOTS
C             NO ERROR       ERROR       STOP AFTER UNDEFORM PLOT/LINK2
C                ERROR    NO ERROR       STOP AFTER UNDEFORM PLOT/LINK2
C                ERROR       ERROR       STOP AFTER LINK1 DATA CHECK
C      5      NO ERROR    NO ERROR       GO, ALL LINKS AND PLOTS
C             NO ERROR       ERROR       GO, ALL LINKS BUT NO PLOTS
C                ERROR    NO ERROR       STOP AFTER UNDEFORM PLOT/LINK2
C                ERROR       ERROR       STOP AFTER LINK1 DATA CHECK
C     PLTFLG 0 OR 1 IS SET BY THE PRESENCE OF THE PLOT TAPE.
C     PLTFLG WILL BE RESET TO POSITIVE IN IFP1
C     CUT MAXFIL TO HALF AND SKIP BANDIT IF PLOT OPTION IS 2 OR 3
C
 1600 CONTINUE
      IF (PARAM.LT.2 .OR. PARAM.GT.5) GO TO 1650
      IF (PARAM .GE. 2) PLTFLG = -PARAM
      IF (PLTFLG.NE.-2 .AND. PLTFLG.NE.-3) GO TO 40
      MAXFIL = 24
      BANDIT = -1
      GO TO 40
 1650 WRITE (OUTTAP,1480) UWM,PARAM,KEYWDS(1,16),KEYWDS(2,16)
      GO TO 40
C
C     LOGFL = LOGFILE MESSAGE CONTROL ON UNIVAC 1100
C
 1700 CONTINUE
      LOGFL = PARAM
      GO TO 40
C
C     FILES
C
 3000 IF (BUF(J+2) .NE. MASK1) GO TO 85
      IF (J+4 .GE. JN) GO TO 85
      IF (BUF(J+4).EQ.BLANK .AND. BUF(J+6).EQ.MASK1) GO TO 3010
      J = J + 4
      KHR = 0
      GO TO 3020
 3010 J = J + 8
      KHR = 7
 3020 IF (BUF(J).EQ.MASK1 .OR. KHR.EQ.1) GO TO 3090
      DO 3030 II = 1,NPFIST
      IF (BUF(J) .EQ. FIST(2*II-1)) GO TO 3060
 3030 CONTINUE
      DO 3040 I = 1,LKEYWD
      IF (BUF(J).EQ.KEYWDS(1,I) .AND. BUF(J+1).EQ.KEYWDS(2,I)) GO TO 110
 3040 CONTINUE
      IF (BUF(J) .NE. BLANK) WRITE (OUTTAP,3050) UWM,BUF(J)
 3050 FORMAT (A25,' 64, ',A4,' IS NOT DEFINED AS A NASTRAN FILE AND ',
     1       'WILL BE IGNORED.')
      GO TO 3070
 3060 IXX = 2**(II-1)
      SYSTEM(45) = ORF(SYSTEM(45),IXX)
 3070 J = J + 2
      KHR = KHR + 1
      IF (J .LT. JN) GO TO 3020
      J1 = JN + 1
      IF (BUF(J1) .EQ. MASK2) GO TO 4000
      IF (BUF(J1) .NE. 0) GO TO 85
 3080 CALL XREAD  (*3500,CARD)
      CALL XRCARD (BUF,75,CARD)
      WRITE (OUTTAP,30) (CARD(I),I=1,20)
      IF (BUF(1) .EQ. 0) GO TO 3080
      J  = 2
      J1 = 1
      JN = 2*BUF(1) + 1
      GO TO 3020
 3090 J = J + 2
      GO TO 40
C
C
C     END-OF-FILE ENCOUNTERED ON INPUT FILE
C
 3500 WRITE  (OUTTAP,3600) UFM,INTAP
 3600 FORMAT (A23,' 74, EOF ENCOUNTERED ON UNIT ',I4,
     1        ' WHILE READING THE INPUT DATA IN SUBROUTINE NASCAR')
      CALL MESAGE (-61,0,0)
C
C
C     GENERATE TITLE PAGE
C
 4000 DO 4100 I = 1,14
 4100 PGHDG(I+2) = BLANK
      CALL TTLPGE (TOPT)
C
      RETURN
      END

      SUBROUTINE TRBSCS
C
C     THIS SUBROUTINE CALCULATES THE STIFFNESS AND MASS MATRICES FOR
C     THE BASIC BENDING TRIANGLE.  THE MASS MATRIX MAY BE CALCULATED
C     EITHER BY THE CONVENTIONAL OR THE CONSISTENT MASS METHODS (USING
C     EMASTQ OR INCLUDED CODE) ACCORDING TO THE PARAMETER ICMBAR.
C     THIS ELEMENT MAY NOT BE USED IN A HEAT PROBLEM.
C
C     SINGLE PRECISION VERSION
C
C     ECPT FOR THIS ELEMENT
C
C     INDEX  NAME      TYPE      DESCRIPTION
C     ----- ---------  ----   --------------------
C      1    IELID        I     ELEMENT ID
C      2    NGRID(1)     I     FIRST GRID POINT
C      3    NGRID(2)     I     SECOND GRID POINT
C      4    NGRID(3)     I     THIRD GRID POINT
C      5    ANGLE        R     ANGLE OF MATERIAL
C      6    MATID1       I     MATERIAL ID 1
C      7    EYE          R     MOMENT OF INERTIA
C      8    MATID2       I     MATERIAL ID 2
C      9    T2           R     T2
C     10    FMU          R     NON-STRUCTURAL MASS
C     11    Z11          R     Z1
C     12    Z22          R     Z2
C     13    NECPT(13)    I     COORD  SYSTEM ID 1
C     14    X1           R
C     15    Y1           R     COORDINATES
C     16    Z1           R
C     17    NECPT(17)    I     COORD SYSTEM ID 2
C     18    X2           R
C     19    Y2           R     COORDINATES
C     20    Z2           R
C     21    NECPT(21)    I     COORD SYSTEM ID 3
C     22    X3           R
C     23    Y3           R     COORDINATES
C     24    Z3           R
C     25    ELTEMP       R     ELEMENT TEMPERATURE
C
      LOGICAL         IHEAT,NOGO
      INTEGER         ELID,ESTID,DICT(9),IPART(3),NECPT(25)
      REAL            ECPT(25),KK,KOUT,M(324),MOUT(324)
      COMMON /EMGPRM/ IXTR,JCORE,NCORE,DM(12),ISMB(3),IPREC,NOGO,HEAT,
     1                ICMBAR
      COMMON /EMGDIC/ QQ,LDICT,NGRIDS,ELID,ESTID
      COMMON /EMGEST/ IELID,NGRID(3)
      COMMON /EMGTRX/ A(225),PROD(9),TEMP9(9),XSUBB,SXUBC,YSUBC,BFACT,
     1                E(18),KOUT(324),KK(324),KSAV(81)
      COMMON /SYSTEM/ KSYSTM(60)
      EQUIVALENCE     (KSYSTM(2),IOUTPT),(KSYSTM(56),IHEAT),
     1                (ECPT(1),NECPT(1),IELID),(DICT5,DICT(5)),
     2                (KK(1),MOUT(1)),(KOUT(1),M(1))
      DATA    IPART / 1,2,3/
C
      IP = IPREC
C
C     IF THIS IS A HEAT PROBLEM THIS SHOULD NOT CALL US, SO RETURN
C
      IF (IHEAT) RETURN
C
C     CREATE AN ARRAY POINTING TO THE GRID POINTS IN INCREASING  SIL
C     ORDER
C
  100 DO 120 I = 1,2
      IP1 = I + 1
      II  = IPART(I)
      DO 110 J = IP1,3
      JJ  = IPART(J)
      IF (NGRID(II) .LE. NGRID(JJ)) GO TO 110
      IPART(I) = JJ
      IPART(J) = II
      II = JJ
      GO TO 100
  110 CONTINUE
  120 CONTINUE
C
C     IF STIFFNESS MATRIX IS DESIRED CALL ETRBKS, OTHERWISE ONLY MASS
C     MATRIX IS DESIRED
C
      IF (ISMB(1) .EQ. 0) GO TO 200
C
      CALL ETRBKS (0)
      IF (NOGO) RETURN
      DICT5 = BFACT
C
C     RE ORDER THE MATRIX BY INCREASING SIL VALUE.    NOTE THAT
C
C     KK  = KK(1 TO  9)     KK   = KK(10 TO 18)     KK   = KK(19 TO  27)
C       AA                    AB                      AC
C
C     KK  = KK(28 TO  36)  KK   = KK(37 TO  45)   KK   =  KK(46 TO  54)
C       BA                   BB                     BC
C
C     KK  = KK(55 TO  63)  KK   = KK(64 TO  72)   KK  =  KK(73 TO  81)
C       CA                   CB                     CC
C
C     AND
C
C     KOUT  = KOUT(1 - 36) KOUT  = KOUT( 4 - 6)   KOUT  = KOUT( 7 -  9)
C         I I    (10 - 12)     I I     (13 - 15)      I I     (16 - 18)
C          1 1   (19 - 21)      1 2    (22- 24)        1 3    (25 - 27)
C
C     ETC
C
C
      DO 170 I = 1,3
      II = IPART(I)
      DO 160 J = 1,3
      JJ = IPART(J)
      DO 150 K = 1,3
      DO 140 L = 1,3
      IK   = (II-1)*27 + (JJ-1)*9 + (K-1)*3 + L
      IOUT = (I -1)*27 + (J -1)*3 + (K-1)*9 + L
  140 KOUT(IOUT) = KK(IK)
  150 CONTINUE
  160 CONTINUE
  170 CONTINUE
C
C     NOW OUTPUT THE MATRIX
C
      DICT(1) = ESTID
      DICT(2) = 1
      DICT(3) = 9
      DICT(4) = 4 + 8 + 16
C
      CALL EMGOUT (KOUT,KOUT,81,1,DICT,1,IP)
C
C     NOW CALCULATE THE MASS MATRIX IF NEEDED
C
  200 IF (ISMB(2) .EQ. 0) RETURN
C
C     WHICH MASS METHOD TO BE USED (CONVENTIONAL OR CONSISTENT)
C
      IF (ICMBAR .GE. 0) GO TO 300
C
      CALL EMASTQ (3,M)
C
C     REORDER THE DIAGONAL MASS MATRIX
C
      DO 240 I = 1,3
      II = (I-1)*3 + 1
      IJ = IPART(I)
      JJ = (IJ-1)*3 + 1
      DO 220 J = 1,3
      IOUT = II + J - 1
      IK   = JJ + J - 1
  220 MOUT(IOUT) = M(IK)
  240 CONTINUE
C
C     NOW OUTPUT THE MATRIX
C
      DICT(1) = ESTID
      DICT(2) = 2
      DICT(3) = 9
      DICT(4) = 7
C
      CALL EMGOUT (MOUT,MOUT,9,1,DICT,2,IP)
C
      RETURN
C
C     THE COUPLED MASS MATRIX CALCULATIONS ARE MADE HERE VIA ETRBMS
C
300   CALL ETRBMS
      IF (NOGO) RETURN
C
C     INSERT THE MATRICES INTO THE OUTPUT MATRIX IN INCREASING SIL ORDER
C
      DO 550 I = 1,3
      II = IPART(I)
      DO 550 J = 1,3
      JJ = IPART(J)
      DO 550 K = 1,3
      DO 550 L = 1,3
      IA   = (II-1)*36 + (JJ-II)*9 + (K-1)*3 + L
      IOUT = (I -1)*27 + (J - 1)*3 + (K-1)*9 + L
550   MOUT(IOUT) = M(IA)
C
C     NOW OUTPUT THE MASS MATRIX
C
      DICT(1) = ESTID
      DICT(2) = 1
      DICT(3) = 9
      DICT(4) = 4 + 8 + 16
C
      CALL EMGOUT (MOUT,MOUT,81,1,DICT,2,IP)
      RETURN
C
      END

      SUBROUTINE M TIMS U (Y,X,BUF)
C
C     M TIMS U  FORMS THE  PRODUCT  X = M*Y
C
      INTEGER            DIAG      ,EOL       ,FILEM    ,FILEK
      DOUBLE PRECISION   X(1)      ,Y(1)      ,DA
      DIMENSION          BUF(1)
      COMMON   /INVPWX/  FILEK(7)  ,FILEM(7)
      COMMON   /NAMES /  RD        ,RDREW    ,WRT      ,WRTREW   ,
     1                   REW       ,NOREW    ,EOFNRW   ,RSP      ,
     2                   RDP       ,CSP      ,CDP      ,SQR      ,
     3                   RECT      ,DIAG     ,LOWTRI   ,UPRTRI   ,
     4                   SYM       ,ROW      ,IDENTY
      COMMON   /INVPXX/  DUMM(13)  ,NZERO
      COMMON   /ZNTPKX/  A(4)      ,II       ,EOL
C     COMMON   /DESCRP/  LENGTH    ,MAJOR(1)
      EQUIVALENCE        (A(1),DA)
C
C
      NCOL = FILEK(2)
      DO 10 I = 1,NCOL
   10 X(I) = 0.D0
C
C     MASS MATRIX IS NOT DIAGONAL
C
      NZERO = 0
      DO 40 I = 1,NCOL
      IF (Y(I) .EQ. 0.D0) GO TO 30
      CALL INTPK (*40,FILEM(1),0,RDP,0)
      NZERO = NZERO + 1
   20 CALL ZNTPKI
      X(II) = DA*Y(I) + X(II)
      IF (EOL) 40,20,40
   30 CALL SKPREC (FILEM,1)
      NZERO = NZERO + 1
   40 CONTINUE
      GO TO 90
   90 CALL REWIND (FILEM(1))
      CALL SKPREC (FILEM,1)
      NZERO = NCOL - NZERO
      RETURN
      END

      SUBROUTINE TYPE10 (X,Y,XYD,CHR,NN,OPT)
C                                                	
C     (X,Y) = STARTING OR ENDING POINT OF THE LINE TO BE TYPED (ALWAYS
C             LEFT-TO-RIGHT OR TOP-TO-BOTTOM)
C     XYD   = (+/-)1 IF X = STARTING OR ENDING POINT OF THE LINE
C           = (+/-)2 IF Y = STARTING OR ENDING POINT OF THE LINE
C     CHR   = CHARACTERS TO BE TYPED
C     NN    = NUMBER OF CHARACTERS
C     OPT   = -1 TO INITIATE  THE TYPING MODE
C           = +1 TO TERMINATE THE TYPING MODE
C           =  0 TO TYPE A LINE
C
      INTEGER         XYD,CHR(1),OPT,OPTX,A(6),TYPE,D,PLTYPE
      REAL            XY(2,2),CSCALE
      COMMON /PLTDAT/ SKPPLT(2),XYMIN(2),XYMAX(15),CSCALE,SKPA(3),
     1                CNTCHR(6),PLTYPE
      DATA    A(6)  , TYPE,LSTCHR / 0, 4, 48 /
C
      IF (PLTYPE .LT. 0) GO TO 175
      OPTX = -1
      IF (OPT) 200,100,150
  100 A(5) = IFIX(CSCALE+.44)
      XY(1,1) = X
      XY(2,1) = Y
      XY(1,2) = X
      XY(2,2) = Y
      N = 1
      IF (N .LE. 0) N = 1
C
C     SCREEN OUT TRAILING BLANKS
C
      DO 102 J = 1,NN
      IF (IABS(CHR(J)) .NE. 48) N = J
  102 CONTINUE
      IF (N.EQ.1 .AND. IABS(CHR(1)).EQ.48) RETURN
      D = MAX0(IABS(XYD),1)
      S = CNTCHR(D)
      IF (XYD.EQ.-1 .OR. XYD.EQ.2) S = -S
C
C     TYPE THE LINE
C
      DO 125 J = 1,N
      XY(D,2) = XY(D,1) + S*FLOAT(J-1)
      DO 105 I = 1,2
      IF (XY(I,2)+.1.LT.XYMIN(I) .OR. XY(I,2)-.1.GT.XYMAX(I)) GO TO 125
      A(I+2) = XY(I,2) + .1
  105 CONTINUE
C
C     MAKE SURE EACH CHARACTER IS A VALID CHARACTER (UNLESS NN.LE.0)
C
      K = J
      IF (XYD .LT. 0) K = N - J + 1
      A(2) = IABS(CHR(K))
      IF (NN  .LE. 0) GO TO 120
      IF (A(2).EQ.0 .OR. A(2).GT.LSTCHR) GO TO 125
      IF (A(2) .EQ. 0) GO TO 125
C
C     TYPE THE CHARACTER
C
  120 A(1) = TYPE
      IF (OPTX .EQ. 0) GO TO 121
      A(1) = TYPE + 10
      OPTX = 0
  121 CALL WPLT10 (A,0)
  125 CONTINUE
      GO TO 200
C
C     TERMINATE THE TYPING MODE
C
  150 CALL WPLT10 (A,1)
      OPTX = -1
      GO TO 200
C
C     DRAW THE LINE OF CHARACTERS
C
  175 CALL DRWCHR (X,Y,XYD,CHR,NN,OPT)
C
  200 RETURN
      END

      SUBROUTINE BDAT03
C
C     THIS SUBROUTINE PROCESSES TRANS BULK DATA, GENERATES THE
C     TRANSFORMATION MATRIX, AND WRITES TO SCBDAT.
C
      EXTERNAL        RSHIFT,ANDF
      LOGICAL         TDAT
      INTEGER         BUF1,TRANS(2),GEOM4,COMBO,AAA(2),OUTT,BUF2,BUF4,
     1                ANDF,RSHIFT,IHD(10),Z
      DIMENSION       TEMP(9),XAX(3),YAX(3),ZAX(3),V2(3),OUT(9)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /CMB001/ SCR1,SCR2,SCBDAT,SCSFIL,SCCONN,SCMCON,SCTOC,
     1                GEOM4,CASECC
      COMMON /ZZZZZZ/ Z(1)
      COMMON /CMB002/ BUF1,BUF2,BUF3,BUF4,BUF5,SCORE,LCORE,INTP,OUTT
      COMMON /CMB003/ COMBO(7,5),CONSET,IAUTO,TOLER,NPSUB,CONECT,TRAN,
     1                MCON,RESTCT(7,7),ISORT,ORIGIN(7,3),IPRINT
      COMMON /OUTPUT/ ITITL(96),IHEAD(96)
      COMMON /SYSTEM/ XXX,IOT,JUNK(6),NLPP,JUNK1(2),LINE,JUNK2(2),
     1                IDAT(3)
      COMMON /CMB004/ TDAT(6)
      COMMON /BLANK / STEP,IDRY
      DATA    IHD   / 4H  SU , 4HMMAR , 4HY OF , 4H PRO  , 4HCESS    ,
     1                4HED T , 4HRANS , 4H BUL , 4HK DA  , 4HTA      /
      DATA    TRANS / 310,3 /,    AAA / 4HBDAT,4H03   /  ,
     1        IBLNK / 4H    /
C
      NGTRN = Z(BUF4)
      INUM  = 1
      IERR  = 0
      DO 10 I = 1,7
      DO 10 J = 1,3
      ORIGIN(I,J) = 0.0
   10 CONTINUE
      DO 20 I = 1,96
      IHEAD(I) = IBLNK
   20 CONTINUE
      J = 1
      DO 30 I = 76,85
      IHEAD(I) = IHD(J)
   30 J = J + 1
      CALL LOCATE (*220,Z(BUF1),TRANS(1),FLAG)
      IFILE = GEOM4
   40 CALL READ (*300,*130,GEOM4,ID,1,0,N)
      DO 50 I = 1,NPSUB
      IT = 1
      IF (ID .EQ. COMBO(I,3)) GO TO 80
   50 CONTINUE
      IF (NGTRN .EQ. 0) GO TO 70
      DO 60 I = 1,NGTRN
      IT = 2
      IF (ID .EQ. Z(BUF4+I)) GO TO 80
   60 CONTINUE
   70 CONTINUE
      CALL READ (*300,*310,GEOM4,TEMP,-9,0,NNN)
      GO TO 40
   80 TDAT(3) = .TRUE.
      IF (IT .EQ. 1) COMBO(I,3) = -COMBO(I,3)
      IF (IT .EQ. 2)  Z(BUF4+I) = -Z(BUF4+I)
      CALL READ (*300,*310,GEOM4,TEMP,9,0,NNN)
      IF (IT .NE. 1) GO TO 100
      DO 90 LL = 1,3
      ORIGIN(I,LL) = TEMP(LL)
   90 CONTINUE
  100 CONTINUE
C
C     DEFINE Z-AXIS
C
      ZAX(1) = TEMP(4) - TEMP(1)
      ZAX(2) = TEMP(5) - TEMP(2)
      ZAX(3) = TEMP(6) - TEMP(3)
C
C     DEFINE Y-AXIS
C
      V2(1)  = TEMP(7) - TEMP(1)
      V2(2)  = TEMP(8) - TEMP(2)
      V2(3)  = TEMP(9) - TEMP(3)
      YAX(1) = ZAX(2)*V2(3) - ZAX(3)*V2(2)
      YAX(2) = ZAX(3)*V2(1) - ZAX(1)*V2(3)
      YAX(3) = ZAX(1)*V2(2) - ZAX(2)*V2(1)
C
C     DEFINE X-AXIS
C
      XAX(1) = YAX(2)*ZAX(3) - ZAX(2)*YAX(3)
      XAX(2) = YAX(3)*ZAX(1) - ZAX(3)*YAX(1)
      XAX(3) = YAX(1)*ZAX(2) - ZAX(1)*YAX(2)
C
C     CHANGE TO UNIT VECTORS
C
      ZMAG = SQRT(ZAX(1)**2 + ZAX(2)**2 + ZAX(3)**2)
      YMAG = SQRT(YAX(1)**2 + YAX(2)**2 + YAX(3)**2)
      XMAG = SQRT(XAX(1)**2 + XAX(2)**2 + XAX(3)**2)
      DO 110 I = 1,3
      ZAX(I) = ZAX(I)/ZMAG
      YAX(I) = YAX(I)/YMAG
      XAX(I) = XAX(I)/XMAG
  110 CONTINUE
      CALL WRITE (SCBDAT,ID,1,0)
      CALL WRITE (SCBDAT, 1,1,0)
      CALL WRITE (SCBDAT,TEMP(1),3,0)
      OUT(1) = XAX(1)
      OUT(2) = YAX(1)
      OUT(3) = ZAX(1)
      OUT(4) = XAX(2)
      OUT(5) = YAX(2)
      OUT(6) = ZAX(2)
      OUT(7) = XAX(3)
      OUT(8) = YAX(3)
      OUT(9) = ZAX(3)
      CALL WRITE (SCBDAT,OUT,9,0)
      IF (ANDF(RSHIFT(IPRINT,6),1) .NE. 1) GO TO 120
      INUM = INUM + 1
      IF (MOD(INUM,2) .EQ. 0) CALL PAGE
      WRITE (OUTT,430) ID
      WRITE (OUTT,440) (TEMP(I),I=1,3)
      WRITE (OUTT,420) ( OUT(I),I=1,9)
  120 CONTINUE
      GO TO 40
  130 CONTINUE
C
C     PROCESS REPEATED GTRAN IDS
C
      IF (NGTRN .LT. 2) GO TO 160
      NGTRN1 = NGTRN - 1
      DO 150 I = 1,NGTRN1
      IF (Z(BUF4+I) .GE. 0) GO TO 150
      KK = I + 1
      DO 140 J = KK,NGTRN
      IF (IABS(Z(BUF4+I)) .EQ. Z(BUF4+J)) Z(BUF4+J) = -Z(BUF4+J)
  140 CONTINUE
  150 CONTINUE
  160 NPM1 = NPSUB - 1
      DO 190 I = 1,NPM1
      IF (COMBO(I,3) .GE. 0) GO TO 190
      KK = I + 1
      DO 180 J = KK,NPSUB
      IF (IABS(COMBO(I,3)) .NE. COMBO(J,3)) GO TO 180
      COMBO(J,3) = -COMBO(J,3)
      DO 170 JDH = 1,3
      ORIGIN(J,JDH) = ORIGIN(I,JDH)
  170 CONTINUE
  180 CONTINUE
  190 CONTINUE
C
C     TEST TO SEE THAT ALL TRANS HAVE BEEN FOUND
C
      DO 200 I = 1,NPSUB
      IF (COMBO(I,3) .LE. 0) GO TO 200
      IERR = 1
      WRITE (OUTT,400) UFM,COMBO(I,3)
  200 CONTINUE
      IF (NGTRN .EQ. 0) GO TO 220
      DO 210 I = 1,NGTRN
      IF (Z(BUF4+I) .LE. 0) GO TO 210
      IERR = 1
      WRITE (OUTT,410) UFM,Z(BUF4+I)
  210 CONTINUE
  220 CALL EOF (SCBDAT)
      CALL WRITE (SCBDAT,ID,1,1)
      CALL CLOSE (SCBDAT,1)
      DO 230 I = 1,NPSUB
      COMBO(I,3) = IABS(COMBO(I,3))
  230 CONTINUE
      IF (IERR .EQ. 1) IDRY = -2
      RETURN
C
  300 IMSG = -2
      GO TO 320
  310 IMSG = -3
  320 CALL MESAGE (IMSG,IFILE,AAA)
      RETURN
C
  400 FORMAT (A23,' 6511, THE REQUESTED TRANS SET ID',I9,
     1       ' HAS NOT BEEN DEFINED BY BULK DATA.')
  410 FORMAT (A23,' 6513, THE TRANS SET ID',I9,' REQUESTED BY A GTRAN ',
     1       'BULK DATA CARD HAS NOT BEEN DEFINED.')
  420 FORMAT (43X,5H*****,42X,5H*****, /3(43X,1H*,50X,1H*, /43X,1H*,1X,
     1       3E15.6,4X,1H*,/),43X,1H*,50X,1H*, /43X,5H*****,42X,5H*****)
  430 FORMAT (//48X,34HTRANS SET IDENTIFICATION NUMBER = ,I8)
  440 FORMAT ( /50X,37HCOORDINATES OF ORIGIN IN BASIC SYSTEM ,
     1         /45X,3E15.6, //58X,21HTRANSFORMATION MATRIX/)
      END

      SUBROUTINE XFLSZD (FILE,IBLOCK,FILNAM)
C
C     XFLSZD (EXECUTIVE FILE SIZE DETERMINATOR) ACCUMULATES THE
C     NUMBER OF BLOCKS USED FOR A FILE (FILE LT 0) IN THE FIAT OR
C     FOR A FILE (FILE GT 0) IN THE DATA POOL FILE.
C     IF FILE GT 0 IT IS THE INDEX OF THE FILE ON THE DATA POOL FILE
C     IF FILE = 0 THE NUMBER OF WORDS PER BLOCK IS RETURNED IN IBLOCK
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL         RSHIFT,ANDF
      COMMON / MACHIN/ MACH
      COMMON / XFIAT / FIAT(1)
      COMMON / XFIST / NFIST,LFIST,IFIST(1)
      COMMON / XDPL  / POOL(1)
      COMMON / SYSTEM/ KYSTEM
C
      DATA     MASK  / 32767 /
C
      IF (FILE) 10,150,100
C
C     FILE IS IN THE FIAT
C
C     COMMENTS FROM G.CHAN/UNIVAC 8/90
C     VAX AND VAX-DERIVED MACHINES DO NOT SAVE ANY INFORMATION OF BLOCKS
C     USED IN FIAT 7TH AND 8TH WORDS. THEREFORE, IBLOCK IS ALWAYS ZERO.
C
   10 CONTINUE
C
      LIM = 2*LFIST
      DO 30 I = 1,LIM,2
      IF (FILNAM .NE. IFIST(I)) GO TO 30
      IF (IFIST(I+1)  .LE.   0) GO TO 50
      INDX   = IFIST(I+1)
      IBLOCK = RSHIFT(FIAT(INDX+7),16) + ANDF(MASK,FIAT(INDX+8)) +
     1         RSHIFT(FIAT(INDX+8),16)
C            = BLOCK COUNT ON PRIMARY, SECONDARY AND TERTIARY FILES ??
C
      GO TO 200
   30 CONTINUE
   50 IBLOCK = 0
      GO TO 200
C
C     FILE IS ON THE DATA POOL FILE
C
  100 INDX   = FILE*3 + 3
      IBLOCK = RSHIFT(POOL(INDX),16)
      GO TO 200
C
C     USER WANTS THE NUMBER OF WORDS PER BLOCK
C
  150 CONTINUE
      IF (MACH.EQ.2 .OR. MACH.GE.5) IBLOCK = KYSTEM - 4
  200 RETURN
      END

      SUBROUTINE TOTAPE (CALLER,Z)
C
C     THIS ROUTINE IS CALLED ONLY BY DPLTST (CALLER=1), DPLOT (CALLER=2)
C     AND/OR OFP (CALLER=3) TO COPY NUMBERS OF GINO INPUT FILES TO A
C     SAVE FILE, INP9, FOR NEXT INTERACTIVE NASTRAN RUN (INTRA.LT.0)
C     THE SAVE FILE CAN BE A TAPE OR DISC.
C
C     WRITTEN BY G.CHAN/SPERRY     NOV. 1985
C
C     FILE STRUCTURE IN SAVE TAPE
C
C     RECORD NO.   CONTENT
C     ----------   -----------------------------------------------
C        1           6-WORDS (3 CALLER ID WORDS AND 3 DATE WORDS)
C                   96-WORD HEADING
C                  100-SYSTEM WORDS
C        2         MARK
C        3         CALLER ID, NO. OF FILES, NO. OF PARAMETERS
C        4         7-WORD TRAILER OF FIRST GINO INPUT FILE
C      5 TO N      FIRST GINO INPUT FILE (IF FILE IS NOT PURGED)
C       N+1        MARK
C       N+2        7-WORD TRAILER OF SECOND GINO INPUT FILE
C    N+2 TO M      SECOND GINO INPUT FILE (IF FILE IS NOT PURGED)
C       M+1        MARK
C    M+2 TO ..R    REPEAT FOR ADDITION FILES, TRAILER, AND MARK
C       R+1        PARAMETERS IN /BLANK/ OF CURRENT CALLER
C       R+2        MARK
C       R+3        NASTRAN EOF MARK
C    R+4 TO LAST   REPEAT 3 TO R+3 AS MANY TIMES AS NEEDED FROM THE
C                  SAME OR A DIFFERENT CALLER AT DIFFERENT TIME
C     LAST+1       SYSTEM EOF MARK
C
C     THE INTERACTIVE FLAG, INTRA, IN /SYSTEM/ WAS SET BY XCSA TO
C         1 FOR PLOT ONLY,
C         2 FOR OUTPUT PRINT ONLY
C      OR 3 FOR BOTH
C
      IMPLICIT INTEGER (A-Z)
      LOGICAL         DISC,     TAPBIT
      DIMENSION       Z(3),     TAB(3,3), MARK(3),  SUB(2),   FN(2),
     1                DATE(3),  WHO(2)
      CHARACTER       UFM*23,   UWM*25,   UIM*29
      COMMON /XMSSG / UFM,      UWM,      UIM
      COMMON /BLANK / PARAM(1)
      COMMON /SYSTEM/ KSYSTM(100)
      COMMON /OUTPUT/ HEAD(96)
      COMMON /NAMES / RD,       RDREW,    WRT,      WRTREW,   REW,
     1                NOREW
      EQUIVALENCE     (KSYSTM( 1),IBUF), (KSYSTM(15),DATE(1)),
     1                (KSYSTM( 2),NOUT), (KSYSTM(86),INTRA  ),
     2                (TAB(2,3) ,BLANK)
      DATA    TAB   / 4HPLTS,   4HET  ,   2,
     1                4HPLOT,   4H    ,   5,
     2                4HOFP ,   4H    ,   3/
      DATA    FILE,   NFILE,    MARK  /   4HINP9,23,  2*65536,11111  /
      DATA    SUB /   4HTOTA,   4HPE  /
C
      IF (INTRA.GE.0 .OR. CALLER.LT.1 .OR. CALLER.GT.3) RETURN
      IF (CALLER.LE.2 .AND. INTRA.EQ.-2) RETURN
      IF (CALLER.EQ.3 .AND. INTRA.EQ.-1) RETURN
      WHO(1) = TAB(1,CALLER)
      WHO(2) = TAB(2,CALLER)
      NPARAM = TAB(3,CALLER)
      KORE   = KORSZ(Z(1))
      IBUF1  = KORE  - IBUF
      IBUF2  = IBUF1 - IBUF
      KORE   = IBUF2 - 1
      FN(1)  = FILE
      FN(2)  = BLANK
      DISC   = .TRUE.
      IF (TAPBIT(FN(1))) DISC = .FALSE.
      IF (.NOT.DISC .OR. INTRA.GT.0) GO TO 30
C
      CALL OPEN (*120,FILE,Z(IBUF2),RDREW)
 10   CALL READ (*20,*20,FILE,Z(1),2,0,M)
      CALL SKPFIL (FILE,1)
      GO TO 10
 20   CALL CLOSE (FILE,NOREW)
 30   CALL OPEN (*120,FILE,Z(IBUF2),WRT)
      IF (INTRA .LT. 0) GO TO 40
      DO 35 I = 1,2
      IF (INTRA.NE.I .AND. INTRA.NE.3) GO TO 35
      FILE = TAB(3,I+1)
      CALL WRITE (FILE,TAB(1,CALLER),3,0)
      CALL WRITE (FILE,  DATE(1),  3,0)
      CALL WRITE (FILE,  HEAD(1), 96,0)
      CALL WRITE (FILE,KSYSTM(1),100,1)
      CALL WRITE (FILE,  MARK(1),  3,1)
 35   CONTINUE
      INTRA = -INTRA
      FILE  = TAB(3,CALLER)
 40   Z(1)  = CALLER
      Z(2)  = NFILE
      Z(3)  = NPARAM
      CALL WRITE (FILE,Z(1),3,1)
      WRITE  (NOUT,50) UIM,WHO,FILE
 50   FORMAT (A29,', THE FOLLOWING FILES WERE COPIED FROM DMAP ',A4,A2,
     1        4H TO ,A4,5H FILE,/)
      DO 110 I = 1,NFILE
      INFIL = 100 + I
      CALL OPEN (*100,INFIL,Z(IBUF1),RDREW)
      Z(1)  = INFIL
      CALL RDTRL (Z(1))
      CALL WRITE (FILE,Z(1),7,1)
      IF (Z(1) .LE. 0) GO TO 80
 60   CALL READ (*80,*70,INFIL,Z(1),KORE,1,M)
      CALL MESAGE (-8,0,SUB)
 70   CALL WRITE (FILE,Z(1),M,1)
      GO TO 60
 80   CALL CLOSE (INFIL,REW)
      CALL FNAME (INFIL,FN)
      WRITE  (NOUT,90) FN
 90   FORMAT (5X,2A4)
 100  CALL WRITE (FILE,MARK(1),3,1)
 110  CONTINUE
      CALL WRITE (FILE,PARAM(1),NPARAM,1)
      CALL WRITE (FILE,MARK(1),3,1)
      IF (.NOT.DISC) CALL CLOSE (FILE,NOREW)
      IF (     DISC) CALL CLOSE (FILE,  REW)
      RETURN
C
 120  CALL MESAGE (-1,FILE,SUB)
      RETURN
      END

      SUBROUTINE READ2 (MAA,PHIA,SCR1,NORM,IA,USET,MI,LAMA,IPOUT,SCR2,
     1                  EPSI,SCR3)
C
C     COMPUTE MODAL MASS AND NORMALIZES VECTORS ACCORDING TO POINT,
C     MASS, OR MAX.  ALSO LOOKS FOR LARGE OFF DIAGONAL TERM
C
      INTEGER         POINT,SYSBUF,PHIA,SCR1,IX(7),IPHIA(7),SCR2,
     1                IHEAD(50),SCR3,STURM,NAM(2)
      REAL            LFREQ,CORE(13)
      DOUBLE PRECISION DCORE(1),DXMAX
      DIMENSION       IM(7),IHEAD1(10)
      COMMON /CONDAS/ CONSTS(5)
      COMMON /ZZZZZZ/ ICORE(1)
      COMMON /SYSTEM/ SYSBUF
      COMMON /PACKX / ITA1,ITB1,II1,JJ1,INCUR1
      COMMON /UNPAKX/ ITB,II,JJ,INCUR
      COMMON /OUTPUT/ HEAD(1)
      COMMON /STURMX/ STURM,SHFTPT,KEEP,PTSHFT,NR
      COMMON /GIVN  / GIVENS,TITLE1(100),LFREQ,TITLE2(4),NNV
      EQUIVALENCE     (CONSTS(2),TPHI), (IX(2),NCOL), (IX(3),NROW),
     1                (CORE(1),ICORE(1),DCORE(1)), (DXMAX,XMAX)
      DATA    IHEAD1/ 21,9,8*0  /
      DATA    IHEAD / 21,6,7*0,7,40*0/
      DATA    MASS,   POINT     / 4HMASS,4HPOIN/
      DATA    MAX   / 4HMAX     /
      DATA    NAM   / 4HREAD,1H2/
C
C     READ2  SHOULD NORMALIZE  PHIA  ACCORDING TO NORM +METHOD
C
      LCORE = KORSZ(CORE)
C
C     DECIDE IF MI WANTED
C
      IMI   = 0
      IX(1) = MI
      CALL RDTRL (IX)
      IF (IX(1) .GT. 0) GO TO 10
      EPSI = 0.0
      IMI  = -1
      IF (NORM .EQ. MASS) NORM = MAX
   10 IX(1) = PHIA
      CALL RDTRL (IX)
      CALL MAKMCB (IPHIA,PHIA,IX(3),IX(4),IX(5))
C
C     SET UP TO HANDLE IDENTITY MATRIX
C
      IDEN  = 0
      IM(1) = MAA
      CALL RDTRL (IM)
      IF (IM(4) .EQ. 8) IDEN = 1
C
C     FIND TYPE OF NORMALIZATION
C
      IF (NORM .EQ. MASS) GO TO 310
      IPONT = 1
      IF (NORM  .EQ. POINT) GO TO 30
      IF (IA.LT.1 .OR. IA.GT.NROW) GO TO 20
C
C     TYPE IS  MAX
C
   20 IPONT = 0
C
C     POINT
C
   30 ASSIGN 40 TO ICOPY
      GO TO 420
C
   40 CONTINUE
C
C     PROCESS PHIA - NORMALIZE - COPY TO PHIA
C
      LCORE = LCORE - SYSBUF
      CALL GOPEN (SCR1,CORE(LCORE+1),0)
      LCORE = LCORE - SYSBUF
      CALL GOPEN (PHIA,CORE(LCORE+1),1)
      ITB   = IX(5)
      JJ    = NROW
      II    = 1
      INCUR = 1
      ITA1  = ITB
      ITB1  = ITB
      INCUR1= 1
      DO 130 I = 1,NCOL
      CALL UNPACK (*100,SCR1,CORE(3))
      II1 = II
      JJ1 = JJ
      JJJ = 1
      IF (ITB .EQ. 2) GO TO 66
      DO 60 J = 1,NROW
      IF (ABS(CORE(J+2)) .GT. ABS(CORE(JJJ+2))) JJJ = J
   60 CONTINUE
      JJJ = JJJ + 2
      IF (IPONT .NE. 1) GO TO 62
      JJJ = IA + 2
      IF (ABS(CORE(JJJ)) .LE. 1.0E-15) GO TO 90
   62 XMAX = CORE(JJJ)
      DO 64 J = 1,NROW
      CORE(J+2) = CORE(J+2)/XMAX
   64 CONTINUE
      GO TO 90
   66 DO 68 J = 1,NROW
      IF (DABS(DCORE(J+1)) .GT. DABS(DCORE(JJJ+1))) JJJ = J
   68 CONTINUE
      JJJ = JJJ + 1
      IF (IPONT .NE. 1) GO TO 70
      JJJ = IA + 1
      IF (DABS(DCORE(JJJ)) .LE. 1.0D-15) GO TO 90
   70 DXMAX = DCORE(JJJ)
      DO 72 J = 1,NROW
      DCORE(J+1) = DCORE(J+1)/DXMAX
   72 CONTINUE
   90 CALL PACK (CORE(3),PHIA,IPHIA)
      GO TO 130
  100 II1 = 1
      JJ1 = 1
      CALL PACK (CORE,PHIA,IPHIA)
  130 CONTINUE
      CALL CLOSE (PHIA,1)
      CALL CLOSE (SCR1,1)
C
C     COMPUTE MODAL MASS
C
  140 IF (IMI  .LT. 0) GO TO 170
      IF (IDEN .EQ. 0) GO TO 160
      ASSIGN 150 TO ICOPY
      GO TO 420
  150 CALL SSG2B (PHIA,SCR1,0,MI,1,ITB,1,SCR3)
      GO TO 170
C
  160 CALL SSG2B (MAA,PHIA,0,SCR2,0,ITB,1,SCR3)
      CALL SSG2B (PHIA,SCR2,0,MI,1,ITB,1,SCR3)
C
C     COMPUTE GENERALIZED STIFFNESS
C
C
C     COMPUTE FREQUENCY ETC
C
  170 ITB  = 1
      II   = 1
      JJ   = NCOL
      INCUR= 1
      IMSG = 0
      CALL GOPEN (LAMA,CORE(LCORE+1),0)
      CALL READ (*500,*172,LAMA,CORE(1),LCORE,1,NLAMA)
      GO TO 520
C
C     NLAMA IS THE NUMBER OF EIGENVALUES FOUND   NCOL IS TH NUMBER OF
C     VECTORS
C
C
C     BRING IN THE ORDER FOUND
C
  172 KK = NLAMA + 2*NCOL + 8
C
C     KK IS THE POINTER TO THE ORDER FOUND
C     L1 AND  L2 ARE COUNTERS FOR MISSING LOW FREQ. BELOW SHIFT POINTS
C     STURM AND KEEP WERE SAVED IN SDCOMP, SHFTPT AND PTSHFT IN FEER
C     AND INVPWR (REAL SYMMETRIC EIGENVALUE PROBLEM ONLY)
C
      CALL READ (*500,*171,LAMA,ICORE(KK+1),LCORE,1,IFLAG)
      GO TO 520
  171 CALL CLOSE (LAMA,1)
      CALL GOPEN (LAMA,CORE(LCORE+1),1)
      CALL WRITE (LAMA,IHEAD(1),50,0)
      CALL WRITE (LAMA,HEAD(1),96,1)
      LCORE = LCORE + SYSBUF
      CORE(NLAMA+6) = 0.0
      CORE(NLAMA+7) = 0.0
      IF (IMI .LT. 0) GO TO 180
      CALL GOPEN (MI,CORE(LCORE+1),0)
      L1 = STURM
      L2 = KEEP
      SHFTPT = SHFTPT + 1.E-10
      PTSHFT = PTSHFT + 1.E-10
  180 DO 210 I = 1,NLAMA
      ICORE(NLAMA+1) = I
      L = KK + I
      ICORE(NLAMA+2) = ICORE(L)
      CORE(NLAMA+3)  = CORE(I)
      CORE(NLAMA+4)  = SQRT(ABS(CORE(I)))
      CORE(NLAMA+5)  = CORE(NLAMA+4)/TPHI
      IF (CORE(I).GT.1.E-10 .AND. CORE(I).LE.SHFTPT) L1 = L1 - 1
      IF (CORE(I).GT.1.E-10 .AND. CORE(I).LE.PTSHFT) L2 = L2 - 1
      IF (IMI .LT.  0) GO TO 200
      IF (I .GT. NCOL) GO TO 195
      L = NLAMA + I + 7
      K = L - 1 + I
      CALL UNPACK (*195,MI,CORE(L))
      CORE(NLAMA+6) = CORE(K)
      CORE(NLAMA+7) = CORE(K)*CORE(NLAMA+3)
      CORE(L) = CORE(K)
C
C     ZERO OUT GENERALIZED MASS AND GENERALIZED STIFFNESS FOR THE RIGID
C     BODY MODE OF ZERO FREQUENCY
C
C     (G.C.  3/92
C     NEXT 4 NEW LINES CAUSED DEMO T03121A TO DIE. MORE STUDY IS NEEDED)
C
C     IF (CORE(I) .GE. 0.0) GO TO 200
C     CORE(NLAMA+3) = 0.0
C     CORE(NLAMA+4) = 0.0
C     CORE(NLAMA+5) = 0.0
      GO TO 200
C
C     NO MORE VECTORS
C     REPLACE STURM BY SMALLER OF L1 OR L2, IF NOT ALL LOWER MODES FOUND
C     SET STRUM TO   -1 IF THERE IS NOT ENOUGH INFORMATION,
C     SET STRUM TO -999 IF DIAG 37 IS REQUESTED (NOT TO PRINT MESSAGE).
C
  195 CORE(NLAMA+6) = 0.0
      CORE(NLAMA+7) = 0.0
  200 CALL WRITE (LAMA,CORE(NLAMA+1),7,0)
  210 CONTINUE
      IF (L1 .LT.  0) L1 = 0
      IF (L2 .LT.  0) L2 = 0
      IF (L1 .GT. L2) L1 = L2
      IF (STURM.NE.-1 .AND. L1.GE.0) STURM = L1
      IF (STURM.GT.NR .AND. NR.GT.0) STURM = STURM - NR
      IF (KEEP.LE.0 .AND. PTSHFT.GT.0.) STURM = -1
      CALL SSWTCH (37,J)
      IF (J .EQ. 1) STURM = -999
      CALL CLOSE (LAMA,1)
      IF (IMI .LT. 0) GO TO 220
      CALL CLOSE (MI,1)
  220 IMSG  = 0
      XMAX  = 0.
      XMAX1 = 0.
      ISTOR = 0
      JSTOR = 0
C
C     EPSI = 0 IMPLIES TO NOT CHECK MODAL MASS TERMS
C
      IF (EPSI .EQ. 0.0) GO TO 270
      CALL GOPEN (MI,CORE(LCORE+1),0)
      DO 260 I = 1,NCOL
      M    = NLAMA + I + 7
      MCOL = M + NCOL
      CALL UNPACK (*540,MI,CORE(MCOL))
      IF (CORE(M) .EQ. 0) GO TO 260
      DO 250 J = 1,NCOL
      IF (I .EQ. J) GO TO 260
      K  = MCOL  + J - 1
      MM = NLAMA + J + 7
      IF (CORE(MM) .EQ. 0.0) GO TO 250
      GM = ABS(CORE(K))/SQRT(ABS(CORE(M)*CORE(MM)))
      IF (GM .GT. XMAX1) GO TO 240
  230 CONTINUE
      IF (GM .LE. EPSI) GO TO 250
      IMSG = IMSG + 1
      XMAX = AMAX1(XMAX,GM)
      GO TO 250
  240 XMAX1 = GM
      ISTOR = I
      JSTOR = J
      GO TO 230
  250 CONTINUE
  260 CONTINUE
C
      CALL CLOSE (MI,1)
      IF (IMSG   .NE.  0) CALL MESAGE (34,XMAX,EPSI)
  270 IF (GIVENS .EQ. .0) GO TO 275
      IF (NNV    .NE.  0) GO TO 275
      IF (LFREQ  .GT. .0) GO TO 600
  275 CALL GOPEN (IPOUT,CORE(LCORE+1),0)
      CALL READ (*510,*280,IPOUT,CORE(1),LCORE,1,IFLAG)
      GO TO 520
  280 CALL CLOSE (IPOUT,1)
      CALL GOPEN (IPOUT,CORE(LCORE+1),1)
      IHEAD1(3) = ICORE(1)
      CALL WRITE (IPOUT,IHEAD1,10,0)
      I0 = 0
      CORE (I0+ 9) = XMAX1
      ICORE(I0+10) = ISTOR
      ICORE(I0+11) = JSTOR
      ICORE(I0+12) = IMSG
      ICORE(I0+13) = STURM
      CALL WRITE (IPOUT,CORE(2),40,0)
      CALL WRITE (IPOUT,HEAD,96,1)
      IF (ICORE(1) .NE. 1) GO TO 290
      IFLAG = IFLAG - 12
      IHEAD1( 3) = 3
      IHEAD1(10) = 6
      CALL WRITE (IPOUT,IHEAD1,50,0)
      CALL WRITE (IPOUT,HEAD,96,1)
      IF (IFLAG .EQ. 0) GO TO 290
      CALL WRITE (IPOUT,CORE(13),IFLAG,0)
  290 CALL CLOSE (IPOUT,1)
      IX(1) = IPOUT
      CALL WRTTRL (IX)
      RETURN
C
C     COMPUTE UNNORMALIZED MODAL MASS
C
  310 ASSIGN 320 TO ICOPY
      GO TO 420
  320 IF (IDEN .EQ. 0) GO TO 330
C
C     MASS MATRIX IS IDENTITY
C
      CALL SSG2B (PHIA,SCR1,0,MI,1,IPHIA(5),1,SCR3)
      GO TO 340
C
  330 CALL SSG2B (MAA,PHIA,0,SCR2,0,IPHIA(5),1,SCR3)
      CALL SSG2B (PHIA,SCR2,0,MI,1,IPHIA(5),1,SCR3)
C
C     BRING IN DIAGONALS
C
  340 LCORE = LCORE - SYSBUF
      CALL GOPEN (MI,CORE(LCORE+1),0)
      ITB = IPHIA(5)
      II  = 1
      JJ  = NCOL
      IF (ITB .NE. 2) GO TO 356
      DO 350 J = 1,NCOL
      CALL UNPACK (*348,MI,DCORE(NCOL+1))
      K = NCOL + J
      DCORE(J) = 1.0D0/DSQRT(DABS(DCORE(K)))
      GO TO 350
  348 DCORE(J) = 0.0D0
  350 CONTINUE
      GO TO 362
  356 DO 360 J = 1,NCOL
      CALL UNPACK (*358,MI,CORE(NCOL+1))
      K = NCOL + J
      CORE(J) = 1.0/SQRT(ABS(CORE(K)))
      GO TO 360
  358 CORE(J) = 0.0
  360 CONTINUE
  362 CALL CLOSE (MI,1)
C
C     DIVIDE EACH TERM BY SQRT (MI)
C
      CALL GOPEN (SCR1,CORE(LCORE+1),0)
      LCORE = LCORE - SYSBUF
      CALL GOPEN (PHIA,CORE(LCORE+1),1)
      II = 1
      JJ = NROW
      INCUR = 1
      ITA1  = ITB
      ITB1  = ITB
      NCOL2 = ITB*NCOL
      NROW2 = ITB*NROW
      II1   = 1
      JJ1   = NROW
      INCUR1= 1
      DO 410 I = 1,NCOL
      CALL UNPACK (*390,SCR1,CORE(NCOL2+1))
      IF (ITB .NE. 2) GO TO 368
      DO 366 J = 1,NROW
      K = NCOL + J
  366 DCORE(K) = DCORE(K)*DCORE(I)
      GO TO 380
  368 DO 370 J = 1,NROW
      K = NCOL+J
  370 CORE(K) = CORE(K)*CORE(I)
  380 CALL PACK (CORE(NCOL2+1),PHIA,IPHIA)
      GO TO 410
  390 DO 400 J = 1,NROW2
      K = NCOL2 + J
  400 CORE(K) = 0.0
      GO TO 380
  410 CONTINUE
      CALL CLOSE (PHIA,1)
      CALL CLOSE (SCR1,1)
      GO TO 140
C
C     COPY ROUTINE - PHIA TO SCR1
C
  420 LCORE = LCORE - SYSBUF
      CALL GOPEN (PHIA,CORE(LCORE+1),0)
      LCORE = LCORE - SYSBUF
      CALL GOPEN (SCR1,CORE(LCORE+1),1)
      DCORE(1) = 0.0D+0
      ITB   = IX(5)
      ITA1  = ITB
      ITB1  = ITB
      INCUR = 1
      INCUR1= 1
      DO 440 JJJ = 1,NCOL
      II = 0
      CALL UNPACK (*435,PHIA,CORE(3))
      II1 = II
      JJ1 = JJ
      CALL PACK (CORE(3),SCR1,IPHIA)
      GO TO 440
  435 II1 = 1
      JJ1 = 1
      CALL PACK (CORE,SCR1,IPHIA)
  440 CONTINUE
      CALL CLOSE (PHIA,1)
      CALL CLOSE (SCR1,1)
      LCORE = LCORE + 2*SYSBUF
      GO TO ICOPY, (40,320,150)
  490 CALL MESAGE (-2,IP1,NAM)
  500 IP1 = LAMA
      GO TO 490
  510 IP1 = IPOUT
      GO TO 490
  520 CALL MESAGE (-8,0,NAM)
  530 CALL MESAGE (-3,LAMA,NAM)
  540 CALL MESAGE (-5,MI,NAM)
C
C
      ENTRY READ5 (IPOUT)
C     ===================
C
C     PUT OUT EIGENVALUE SUMMARY IN CASE NO EIGENVALUES FOUND
C
      LCORE = KORSZ(CORE) - SYSBUF
      ISTOR = 0
      JSTOR = 0
      IMSG  = 0
      XMAX1 = 0.
      IX(2) = 1
      DO 560 I = 3,7
      IX(I) = 0
  560 CONTINUE
      GO TO 275
C
C     REARRANGE THE EIGENVALUE TABLE, IF NECESSARY, FOR GIVENS METHOD
C
  600 CALL GOPEN (LAMA,CORE(LCORE+1),0)
      CALL SKPREC (LAMA,1)
      NWORDS = 7*NLAMA
      CALL READ (*500,*530,LAMA,CORE(1),NWORDS,1,NWRDS)
      REFREQ = CORE(3)
      DO 640 I = 2,NLAMA
      J = 7*(I-1) + 3
      IF (CORE(J) .GE. REFREQ) GO TO 640
      REFREQ = CORE(J)
      GO TO 660
  640 CONTINUE
      GO TO 740
  660 CALL BCKREC (LAMA)
      CALL CLOSE (LAMA,2)
      CALL GOPEN (LAMA,CORE(LCORE+1),3)
      DO 700 I = 1,NLAMA
      IF (CORE(3) .EQ. REFREQ) GO TO 720
      T2 = CORE(2)
      T3 = CORE(3)
      T4 = CORE(4)
      T5 = CORE(5)
      T6 = CORE(6)
      T7 = CORE(7)
      DO 680 J = 2,NLAMA
      K = 7*(J-2)
      CORE(K+2) = CORE(K+ 9)
      CORE(K+3) = CORE(K+10)
      CORE(K+4) = CORE(K+11)
      CORE(K+5) = CORE(K+12)
      CORE(K+6) = CORE(K+13)
      CORE(K+7) = CORE(K+14)
  680 CONTINUE
      K = 7*(NLAMA-1)
      CORE(K+2) = T2
      CORE(K+3) = T3
      CORE(K+4) = T4
      CORE(K+5) = T5
      CORE(K+6) = T6
      CORE(K+7) = T7
  700 CONTINUE
  720 CALL WRITE (LAMA,CORE(1),NWORDS,1)
  740 CALL CLOSE (LAMA,1)
      GO TO 275
      END

      SUBROUTINE FORMG2(IG,JR,JD,IR,ID)
C
C     FORMGG FORMS THE GG MATRIX FOR EACH RIGID ELEMENT DEGREE OF
C     FREEDOM.  IG IS THE START OF THE ROW STORED GG MATRIX - 1
C     JR IS THE START OF THE TA MATRIX - 1.
C     JD IS THE START OF THE TB MATRIX - 1.
C     IR IS THE START OF THE BGPDT INFORMATION FOR REFERENCE POINT
C     ID IS THE START OF THE BGPDT INFORMATION FOR DEPENDENT POINT
C
      DOUBLE PRECISION XD,YD,ZD,ZZ(1)
      DIMENSION ZR(1)
      INTEGER Z
      COMMON/ZZZZZZ/Z(1)
      EQUIVALENCE (ZZ(1),ZR(1))
      EQUIVALENCE (ZZ(1),Z(1))
C
C     CALCULATE THE X,Y,AND Z DIRECTED DISTANCES WITH RESPECT TO THE
C     REFERENCE GRID POINT
C
      XD = ZR(ID+1) - ZR(IR+1)
      YD = ZR(ID+2) - ZR(IR+2)
      ZD = ZR(ID+3) - ZR(IR+3)
C
C     IF NO TRANSFORMATION IS NECESSARY, GO TO 30
C
      IF (Z(IR).EQ.0.AND.Z(ID).EQ.0) GO TO 30
C
C     IF ONLY DEPENDENT GRID POINT HAS A TRANSFORMATION, GO TO 20
C
      IF (Z(IR).EQ.0) GO TO 20
C
C     IF BOTH HAVE TRANSFORMATIONS, GO TO 10
C
C
      IF (Z(ID).NE.0) GO TO 10
C
C     ONLY REFERENCE GRID POINT HAS A TRANSFORMATION
C
      ZZ(IG+ 1) = ZZ(JR+1)
      ZZ(IG+ 2) = ZZ(JR+2)
      ZZ(IG+ 3) = ZZ(JR+3)
      ZZ(IG+ 4) =ZD * ZZ(JR+4) - YD * ZZ(JR+7)
      ZZ(IG+ 5) =ZD * ZZ(JR+5) - YD * ZZ(JR+8)
      ZZ(IG+ 6) =ZD * ZZ(JR+6) - YD * ZZ(JR+9)
      ZZ(IG+ 7) = ZZ(JR+4)
      ZZ(IG+ 8) = ZZ(JR+5)
      ZZ(IG+ 9) = ZZ(JR+6)
      ZZ(IG+10) =XD * ZZ(JR+7) - ZD * ZZ(JR+1)
      ZZ(IG+11) =XD * ZZ(JR+8) - ZD * ZZ(JR+2)
      ZZ(IG+12) =XD * ZZ(JR+9) - ZD * ZZ(JR+3)
      ZZ(IG+13) = ZZ(JR+7)
      ZZ(IG+14) = ZZ(JR+8)
      ZZ(IG+15) = ZZ(JR+9)
      ZZ(IG+16) =YD * ZZ(JR+1) - XD * ZZ(JR+4)
      ZZ(IG+17) =YD * ZZ(JR+2) - XD * ZZ(JR+5)
      ZZ(IG+18) =YD * ZZ(JR+3) - XD * ZZ(JR+6)
      ZZ(IG+19) = 0.0
      ZZ(IG+20) = 0.0
      ZZ(IG+21) = 0.0
      ZZ(IG+22) = ZZ(IG+ 1)
      ZZ(IG+23) = ZZ(IG+ 2)
      ZZ(IG+24) = ZZ(IG+ 3)
      ZZ(IG+25) = 0.0
      ZZ(IG+26) = 0.0
      ZZ(IG+27) = 0.0
      ZZ(IG+28) = ZZ(IG+ 7)
      ZZ(IG+29) = ZZ(IG+ 8)
      ZZ(IG+30) = ZZ(IG+ 9)
      ZZ(IG+31) = 0.0
      ZZ(IG+32) = 0.0
      ZZ(IG+33) = 0.0
      ZZ(IG+34) = ZZ(IG+13)
      ZZ(IG+35) = ZZ(IG+14)
      ZZ(IG+36) = ZZ(IG+15)
      RETURN
   10 CONTINUE
C
C     BOTH HAVE TRANSFORMATIONS
C
      ZZ(IG+ 1) = ZZ(JD+1)*ZZ(JR+1) + ZZ(JD+4)*ZZ(JR+4) +
     1 ZZ(JD+7)*ZZ(JR+7)
      ZZ(IG+ 2) = ZZ(JD+1)*ZZ(JR+2) + ZZ(JD+4)*ZZ(JR+5) +
     2 ZZ(JD+7)*ZZ(JR+8)
      ZZ(IG+ 3) = ZZ(JD+1)*ZZ(JR+3) + ZZ(JD+4)*ZZ(JR+6) +
     3 ZZ(JD+7)*ZZ(JR+9)
      ZZ(IG+ 4) = ZZ(JD+1)*ZD*ZZ(JR+4)-ZZ(JD+1)*YD*ZZ(JR+7) +
     1 ZZ(JD+4)*XD*ZZ(JR+7) - ZZ(JD+4)*ZD*ZZ(JR+1) +
     1 ZZ(JD+7)*YD*ZZ(JR+1) - ZZ(JD+7)*XD*ZZ(JR+4)
      ZZ(IG+ 5) = ZZ(JD+1)*ZD*ZZ(JR+5)-ZZ(JD+1)*YD*ZZ(JR+8) +
     2 ZZ(JD+4)*XD*ZZ(JR+8) - ZZ(JD+4)*ZD*ZZ(JR+2) +
     2 ZZ(JD+7)*YD*ZZ(JR+2) - ZZ(JD+7)*XD*ZZ(JR+5)
      ZZ(IG+ 6) = ZZ(JD+1)*ZD*ZZ(JR+6)-ZZ(JD+1)*YD*ZZ(JR+9) +
     3 ZZ(JD+4)*XD*ZZ(JR+9) - ZZ(JD+4)*ZD*ZZ(JR+3) +
     3 ZZ(JD+7)*YD*ZZ(JR+3) - ZZ(JD+7)*XD*ZZ(JR+6)
      ZZ(IG+ 7) = ZZ(JD+2)*ZZ(JR+1) + ZZ(JD+5)*ZZ(JR+4) +
     4 ZZ(JD+8)*ZZ(JR+7)
      ZZ(IG+ 8) = ZZ(JD+2)*ZZ(JR+2) + ZZ(JD+5)*ZZ(JR+5) +
     5 ZZ(JD+8)*ZZ(JR+8)
      ZZ(IG+ 9) = ZZ(JD+2)*ZZ(JR+3) + ZZ(JD+5)*ZZ(JR+6) +
     6 ZZ(JD+8)*ZZ(JR+9)
      ZZ(IG+10) = ZZ(JD+2)*ZD*ZZ(JR+4)-ZZ(JD+2)*YD*ZZ(JR+7) +
     4 ZZ(JD+5)*XD*ZZ(JR+7) - ZZ(JD+5)*ZD*ZZ(JR+1) +
     4 ZZ(JD+8)*YD*ZZ(JR+1) - ZZ(JD+8)*XD*ZZ(JR+4)
      ZZ(IG+11) = ZZ(JD+2)*ZD*ZZ(JR+5)-ZZ(JD+2)*YD*ZZ(JR+8) +
     5 ZZ(JD+5)*XD*ZZ(JR+8) - ZZ(JD+5)*ZD*ZZ(JR+2) +
     5 ZZ(JD+8)*YD*ZZ(JR+2) - ZZ(JD+8)*XD*ZZ(JR+5)
      ZZ(IG+12) = ZZ(JD+2)*ZD*ZZ(JR+6)-ZZ(JD+2)*YD*ZZ(JR+9) +
     6 ZZ(JD+5)*XD*ZZ(JR+9) - ZZ(JD+5)*ZD*ZZ(JR+3) +
     6 ZZ(JD+8)*YD*ZZ(JR+3) - ZZ(JD+8)*XD*ZZ(JR+6)
      ZZ(IG+13) = ZZ(JD+3)*ZZ(JR+1) + ZZ(JD+6)*ZZ(JR+4) +
     7 ZZ(JD+9)*ZZ(JR+7)
      ZZ(IG+14) = ZZ(JD+3)*ZZ(JR+2) + ZZ(JD+6)*ZZ(JR+5) +
     8 ZZ(JD+9)*ZZ(JR+8)
      ZZ(IG+15) = ZZ(JD+3)*ZZ(JR+3) + ZZ(JD+6)*ZZ(JR+6) +
     9 ZZ(JD+9)*ZZ(JR+9)
      ZZ(IG+16) = ZZ(JD+3)*ZD*ZZ(JR+4)-ZZ(JD+3)*YD*ZZ(JR+7) +
     7 ZZ(JD+6)*XD*ZZ(JR+7) - ZZ(JD+6)*ZD*ZZ(JR+1) +
     7 ZZ(JD+9)*YD*ZZ(JR+1) - ZZ(JD+9)*XD*ZZ(JR+4)
      ZZ(IG+17) = ZZ(JD+3)*ZD*ZZ(JR+5)-ZZ(JD+3)*YD*ZZ(JR+8) +
     8 ZZ(JD+6)*XD*ZZ(JR+8) - ZZ(JD+6)*ZD*ZZ(JR+2) +
     8 ZZ(JD+9)*YD*ZZ(JR+2) - ZZ(JD+9)*XD*ZZ(JR+5)
      ZZ(IG+18) = ZZ(JD+3)*ZD*ZZ(JR+6)-ZZ(JD+3)*YD*ZZ(JR+9) +
     9 ZZ(JD+6)*XD*ZZ(JR+9) - ZZ(JD+6)*ZD*ZZ(JR+3) +
     9 ZZ(JD+9)*YD*ZZ(JR+3) - ZZ(JD+9)*XD*ZZ(JR+6)
      ZZ(IG+19) = 0.0
      ZZ(IG+20) = 0.0
      ZZ(IG+21) = 0.0
      ZZ(IG+22) = ZZ(IG+ 1)
      ZZ(IG+23) = ZZ(IG+ 2)
      ZZ(IG+24) = ZZ(IG+ 3)
      ZZ(IG+25) = 0.0
      ZZ(IG+26) = 0.0
      ZZ(IG+27) = 0.0
      ZZ(IG+28) = ZZ(IG+ 7)
      ZZ(IG+29) = ZZ(IG+ 8)
      ZZ(IG+30) = ZZ(IG+ 9)
      ZZ(IG+31) = 0.0
      ZZ(IG+32) = 0.0
      ZZ(IG+33) = 0.0
      ZZ(IG+34) = ZZ(IG+13)
      ZZ(IG+35) = ZZ(IG+14)
      ZZ(IG+36) = ZZ(IG+15)
      RETURN
   20 CONTINUE
C
C     DEPENDENT GRID POINT HAS TRANSFORMATION
C
      ZZ(IG+ 1) = ZZ(JD+1)
      ZZ(IG+ 2) = ZZ(JD+4)
      ZZ(IG+ 3) = ZZ(JD+7)
      ZZ(IG+ 4) = ZZ(JD+7)*YD - ZZ(JD+4)*ZD
      ZZ(IG+ 5) = ZZ(JD+1)*ZD - ZZ(JD+7)*XD
      ZZ(IG+ 6) = ZZ(JD+4)*XD - ZZ(JD+1)*YD
      ZZ(IG+ 7) = ZZ(JD+2)
      ZZ(IG+ 8) = ZZ(JD+5)
      ZZ(IG+ 9) = ZZ(JD+8)
      ZZ(IG+10) = ZZ(JD+8)*YD - ZZ(JD+5)*ZD
      ZZ(IG+11) = ZZ(JD+2)*ZD - ZZ(JD+8)*XD
      ZZ(IG+12) = ZZ(JD+5)*XD - ZZ(JD+2)*YD
      ZZ(IG+13) = ZZ(JD+3)
      ZZ(IG+14) = ZZ(JD+6)
      ZZ(IG+15) = ZZ(JD+9)
      ZZ(IG+16) = ZZ(JD+9)*YD - ZZ(JD+6)*ZD
      ZZ(IG+17) = ZZ(JD+3)*ZD - ZZ(JD+9)*XD
      ZZ(IG+18) = ZZ(JD+6)*XD - ZZ(JD+3)*YD
      ZZ(IG+19) = 0.0
      ZZ(IG+20) = 0.0
      ZZ(IG+21) = 0.0
      ZZ(IG+22) = ZZ(IG+ 1)
      ZZ(IG+23) = ZZ(IG+ 2)
      ZZ(IG+24) = ZZ(IG+ 3)
      ZZ(IG+25) = 0.0
      ZZ(IG+26) = 0.0
      ZZ(IG+27) = 0.0
      ZZ(IG+28) = ZZ(IG+ 7)
      ZZ(IG+29) = ZZ(IG+ 8)
      ZZ(IG+30) = ZZ(IG+ 9)
      ZZ(IG+31) = 0.0
      ZZ(IG+32) = 0.0
      ZZ(IG+33) = 0.0
      ZZ(IG+34) = ZZ(IG+13)
      ZZ(IG+35) = ZZ(IG+14)
      ZZ(IG+36) = ZZ(IG+15)
      RETURN
   30 CONTINUE
C
C     NO TRANSFORMATIONS
C
      DO 40 I = 1,36
      ZZ(IG+I) = 0.0
   40 CONTINUE
      ZZ(IG+ 1) = 1.0
      ZZ(IG+ 8) = 1.0
      ZZ(IG+15) = 1.0
      ZZ(IG+22) = 1.0
      ZZ(IG+29) = 1.0
      ZZ(IG+36) = 1.0
      ZZ(IG+ 5) =  ZD
      ZZ(IG+ 6) = -YD
      ZZ(IG+10) = -ZD
      ZZ(IG+12) =  XD
      ZZ(IG+16) =  YD
      ZZ(IG+17) = -XD
      RETURN
      END

      SUBROUTINE DUMX
C
C     DELETE ANY OF THE FOLLOW ENTRY POINT IF A SUBROUTINE OF THE SAME
C     NAME ALREADY EXISTS
C
      INTEGER         II(9),KK(9)
      CHARACTER       UFM*23,UWM*25
      COMMON /XMSSG / UFM,UWM
      COMMON /SYSTEM/ IBUF,NOUT
      DATA    II    / 9*0/,   JJ /4H DUM/,     KK /
     1        1H1,1H2,1H3,1H4,1H5,1H6,1H7,1H8,1H9 /
C
      GO TO 30
C
C
      ENTRY DUM9 ( ICORE )
C     ==========
C
      J = 9
      GO TO 10
C
C
      ENTRY DUM8 ( ICORE )
C     ==========
C
      J = 8
      GO TO 10
C
C
      ENTRY DUM7 ( ICORE )
C     ==========
C
      J = 7
      GO TO 10
C
C
      ENTRY DUM6 ( ICORE )
C     ==========
C
      J = 6
      GO TO 10
C
C
      ENTRY DUM5 ( ICORE )
C     ==========
C
      J = 5
      GO TO 10
C
C
      ENTRY DUM4 ( ICORE )
C     ==========
C
      J = 4
      GO TO 10
C
C
      ENTRY DUM3 ( ICORE )
C     ==========
C
      J = 3
      GO TO 10
C
C
      ENTRY DUM2 ( ICORE )
C     ==========
C
      J = 2
      GO TO 10
C
C
      ENTRY DUM1 ( ICORE )
C     ==========
C
      J = 1
C     GO TO 10
C
   10 IF (II(J) .NE. 0) GO TO 30
      II(J)  = 1
      WRITE  (NOUT,20) UWM,JJ,KK(J)
   20 FORMAT (A25,' 2182, SUBROUTINE ',2A4,' IS DUMMY.  ONLY ONE OF ',
     1       'THESE MESSAGES WILL APPEAR PER OVERLAY OF THIS DECK.')
   30 RETURN
      END

      INTEGER FUNCTION FILCOR(MT1X,MT2X,   PC,FRSROW,MIDROW,NX,A,NZA,Z)
C
C     FILL CORE WITH A TRIANGULAR MATRIX
C
      REAL A(1),Z(1)
      INTEGER PC,FRSROW
C
      COMMON /UNPAKX/IT1,II,JJ,INCR1
C
C     MT1      FIRST PART OF THE MATRIX (UP TO ROW -MIDROW-).
C     MT2      REST OF THE MATRIX
C     PC       PRECISION OF THE MATRIX IN CORE
C     NX       COLUMN SIZE OF THE MATRIX
C     A        STORAGE FOR THE MATRIX
C     Z        BUFFER FOR GINO
C     FRSROW   FIRST ROW OF THE MATRIX TO BE READ
C     ANSWER   LAST ROW READ
C
      MT1 = MT1X
      MT2 = MT2X
      N   = NX
      MT = MT1
      LASROW = FRSROW-1
      IT1 = PC
      INCR1 =1
      JJ = N
      IF( LASROW .GE. MIDROW .AND. MT2 .NE. 0) MT = MT2
      NN = NZA/PC
      NA = 0
C
C     READ IN EACH ROW
C
  105 IF (NA + N -LASROW .GT. NN) GO TO 115
      LASROW  = LASROW +1
      I = PC*NA +1
      II = LASROW
      CALL UNPACK(*106,MT,A(I))
      GO TO 107
  106 K  = I +LASROW*PC-1
      DO 108 J = I,K
  108 A(J) =0.0
  107 IF (LASROW .EQ. N) GO TO 110
      NA = NA + (N-LASROW +1)
      IF( LASROW .NE. MIDROW .OR. MT2 .EQ. 0) GO TO 105
      CALL CLOSE(MT,1)
      MT = MT2
      CALL GOPEN(MT,Z,0)
      GO TO 105
C
C     END OF ROUTINE
C
  110 CALL CLOSE(MT,1)
  115 FILCOR = LASROW
      RETURN
      END

      SUBROUTINE XGPIBS
C
C     PURPOSE OF THIS ROUTINE IS TO INITIALIZE MACHINE DEPENDENT
C     CONSTANTS FOR XGPI AND ASSOCIATED ROUTINES AND TO INITIALIZE
C     THE MODULE LINK TABLE.
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        LSHIFT,RSHIFT,ANDF,ORF,COMPLF
      DIMENSION       OPBUFF(1),PGHDG(113),HDG1(32),HDG2(32),LNKEDT(15),
     1                ENDDTA(2),OPNCOR(1),UTILTY(1),NWPTYP(6),LL(15),
     2                NONE(2),LNKSPC(1),INBUFF(20),MODNAM(2),OS(2)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25,SWM*27
      COMMON /XMSSG / UFM,UWM,UIM,SFM,SWM
      COMMON /MACHIN/ IJHALF(4),MCHNAM
      COMMON /SYSTEM/ XSYS(90),LPCH
      COMMON /ZZZZZZ/ CORE(1)
      COMMON /XGPI2 / LMPL,MPLPNT,MPL(1)
      COMMON /XGPI2X/ IXX(1)
      COMMON /XLINK / LXLINK,MAXLNK,MLINK(1)
      COMMON /XLKSPC/ LLINK,LINK(1)
      COMMON /OUTPUT/ PGHDG
      COMMON /LHPWX / LHPW(2),NWPIC
      COMMON /XGPIC / A(22),NCPW,NBPC,NWPC,MASKHI,MASKLO,ISGNON,NOSGN,
     1                IALLON,MASKS(1)
      COMMON /XGPID / B(7),ITAPE,IAPPND,INTGR,LOSGN,NOFLGS,SETEOR,
     1                EOTFLG,IEQFLG,CPNTRY(7),JMP(7)
      COMMON /XGPI6 / D(5),IPLUS
      EQUIVALENCE     (XSYS( 2) ,OPTAP )  ,(XSYS(9) ,NLPP ) ,
     1                (XSYS(12) ,NLINES)  ,(XSYS(4) ,INTAP) ,
     2                (OPNCOR(1),LNKSPC(1),OPBUFF(1),OS(2)  ,UTILTY(1))
     3,               (CORE(1)  ,OS(1)    ,LOPNCR)
      DATA    MODNAM/ 4HCHKP,4HNT  /
      DATA    DELETE/ 4HDELE       /,  XNONE /4HNONE/
      DATA    ENDDTA/ 4HENDD,4HATA /,  DOLSGN/4H$   /
C
C             NWPTYP = NUMBER OF WORDS PER PARAMETER TYPE CODE
C                        INT,   REAL,   BCD,   D.P.,   CMPLX,  D.P.CMPLX
      DATA    NWPTYP/      1,      1,     2,      2,       2,     4   /
      DATA    NBLANK/ 4H    /, NONE/4H(NON,4HE)  /
      DATA    LNKEDT/ 4H  1 ,4H  2 ,4H  3 ,4H  4 ,4H  5 ,4H  6 ,4H  7 ,
     1        4H  8 , 4H  9 ,4H 10 ,4H 11 ,4H 12 ,4H 13 ,4H 14 ,4H 15 /
      DATA    HDG1  / 4HMODU,4HLE -,4H DMA,4HP NA,4HME -,4H MOD,4HULE ,
     1        4HENTR, 4HY - ,4HLINK,4HS MO,4HDULE,4H RES,4HIDES,4H IN ,
     2        4HON  , 16*4H        /
      DATA    HDG2  / 4HINDE,4HX   ,4H OF ,4HMODU,4HLE  ,4H POI,4HNT N,
     1        4HAME , 24*4H        /
C
C     INITIALIZE MACHINE DEPENDENT CONSTANTS FOR XGPI
C     SEE SUBROUTINE XGPIDD FOR DESCRIPTION OF CONSTANTS.
C
C     INITIALIZE  /XGPIC/
C
C     NCPW   = NUMBER OF CHARACTERS PER WORD
C     NBPC   = NUMBER OF BITS PER CHARACTER
C     NWPC   = NUMBER OF WORDS PER CARD = NWPIC
C                 7094         360        1108             6600
C    MASKLO = 017777600000, 7FFF0000, 017777600000, 00000000017777600000
C    ISGNON = 400000000000, 80000000, 400000000000, 40000000000000000000
C    NOSGN  = 377777777777, 7FFFFFFF, 377777777777, 37777777777777777777
C    IALLON = 777777777777, FFFFFFFF, 777777777777, 77777777777777777777
C
C    MASKHI = MASK FOR LOW ORDER 16 BITS AND SIGN BIT = 32767,
C             INITIALIZED IN XGPIDD
C
      NCPW   = XSYS(41)
      NBPC   = XSYS(39)
      NWPC   = NWPIC
      MASKLO = LSHIFT(MASKHI,16)
      ISGNON = LSHIFT(1,XSYS(40)-1)
      NOSGN  = COMPLF(ISGNON)
      IALLON = COMPLF(0)
C
C     GENERATE MASKS ARRAY
C     MASK IS IN 4 PARTS - MASK DESCRIPTION WILL BE GIVEN IN TERMS OF
C                          IBM 360
C     PART 1 - FFOOOOOO,OOFFOOOO,OOOOFFOO,OOOOOOFF
C     PART 2 - COMPLEMENT OF PART 1
C     PART 3 - FFFFFFFF,OOFFFFFF,OOOOFFFF,OOOOOOFF
C     PART 4 - COMPLEMENT OF PART 3
C
      MHIBYT = LSHIFT(IALLON,NBPC*(NCPW-1))
      DO 10 J = 1,NCPW
      MASKS(J) = RSHIFT(MHIBYT,NBPC*(J-1))
      J2 = J + NCPW
      MASKS(J2) = COMPLF(MASKS(J))
      J3 = 2*NCPW + J
      MASKS(J3) = RSHIFT(IALLON,NBPC*(J-1))
      J4 = 3*NCPW + J
      MASKS(J4) = COMPLF(MASKS(J3))
   10 CONTINUE
C
C     INITIALIZE  /XGPID/
C
C                 7094         360        1108             6600
C    ITAPE  = 000000100000, 00008000, 000000100000, 00000000000000100000
C    IAPPND = 010000000000, 40000000, 010000000000, 00000000010000000000
C    INTGR  = 400000000001, 80000001, 400000000001, 40000000000000000001
C    LOSGN  = 000000100000, 00008000, 000000100000, 00000000000000100000
C    NOFLGS = 000377777777, 03FFFFFF, 000377777777, 00000000000377777777
C    SETEOR = 004000000000, 20000000, 004000000000, 00000000004000000000
C    EOTFLG = 010000000000, 40000000, 010000000000, 00000000010000000000
C    IEQFLG = 400000000000, 80000000, 400000000000, 40000000000000000000
C    CPNTRY(3) = CHKPNT MODULE INDEX/TYPE CODE
C    NTRY(6)= 400000000001, 80000001, 400000000001, 40000000000000000001
C    JMP(3) = JUMP MODULE INDEX/TYPE CODE
C
      ITAPE  = LSHIFT(1,15)
      IAPPND = LSHIFT(1,30)
      INTGR  = ORF(ISGNON,1)
      LOSGN  = LSHIFT(1,15)
      NOFLGS = RSHIFT(IALLON,XSYS(40)-26)
      SETEOR = LSHIFT(1,29)
      EOTFLG = LSHIFT(1,30)
      IEQFLG = ISGNON
C
C     PRINT MPL CONTENTS IF DIAG 31 IS ON
C
      ASSIGN 40 TO IRTN
      CALL SSWTCH (31,L)
      IF (L .NE. 0) CALL MPLPRT
C
C     GET CHKPNT MODULE INDEX
C
   20 MODIDX = 1
      MPLPNT = 1
   30 IF (MPL(MPLPNT+1).EQ.MODNAM(1) .AND. MPL(MPLPNT+2).EQ.MODNAM(2))
     1    GO TO IRTN, (40,50)
      MODIDX = MODIDX + 1
      MPLPNT = MPLPNT + MPL(MPLPNT)
      IF (MPLPNT.GT.LMPL .OR. MPL(MPLPNT).LT.1) GO TO 1240
      GO TO 30
   40 CPNTRY(3) = LSHIFT(MODIDX,16) + 4
C
C     GET JUMP MODULE INDEX
C
      ASSIGN 50 TO IRTN
      MODNAM(1) = JMP(4)
      MODNAM(2) = JMP(5)
      GO TO 20
   50 JMP(3)    = LSHIFT(MODIDX,16) + 3
      CPNTRY(6) = ORF(ISGNON,1)
      JMP(6)    = CPNTRY(6)
C
C     COMPUTE LENGTH OF OPENCORE (SUBTRACT OFF SOME FOR UTILITY BUFFERS)
C
      LOPNCR = KORSZ(OPNCOR) - XSYS(1) - 1
      UTLTOP = LOPNCR + 1
      UTLBOT = UTLTOP + XSYS(1) - 1
C
C     INITIALIZE  /XGPI2/ (I.E. MPL TABLE)
C
C     LOAD FLOATING POINT NUMBERS INTO MPL FROM ARRAY IN /XGPI2X/
C
      MPLPNT = 1
   60 IF (MPL(MPLPNT) .LT. 4) GO TO 150
      IF (MPL(MPLPNT+3).LT.1 .OR. MPL(MPLPNT+3).GT.2) GO TO 150
C
C     MPL ENTRY HAS MODULE TYPE CODE 1 OR 2 - PROCESS PARAMETER SECTION.
C
      I = MPLPNT + 7
C
C     CHECK FOR END OF MPL ENTRY
C
   70 IF (I .GE. MPLPNT+MPL(MPLPNT)) GO TO 150
C
C     CHECK VALIDITY OF PARAMETER TYPE CODE
C
      J = IABS(MPL(I))
      IF (J.LT.1 .OR. J.GT.6) GO TO 1230
      L = 1
C
C     SEE IF PARAMETER VALUE FOLLOWS TYPE CODE.
C
      IF (MPL(I) .LT. 0) GO TO 100
C
C     GET LENGTH OF PARAMETER VALUE TO BE LOADED.
C
      L = NWPTYP(J)
C
C     A VALUE FOLLOWS IF TYPE CODE IS INTEGER OR BCD - OTHERWISE AN
C     INDEX INTO A TABLE CONTAINING THE VALUE FOLLOWS THE TYPE CODE.
C
      IF (J.EQ.1 .OR. J.EQ.3) GO TO 90
C
C     GET INDEX INTO VALUE TABLE - NOTE INDEX MUST BE CONVERTED FROM
C     DOUBLE PRECISION INDEX TO ONE DIMENSIONAL INDEX.
C
      M  = MPL(I+1)*2 - 1
      DO 80 K = 1,L
      N  = K + M - 1
      K1 = I + K
   80 MPL(K1) = IXX(N)
   90 I  = I + 1
C
C     INCREMENT TO NEXT PARAMETER TYPE CODE.
C
  100 I  = I + L
      GO TO 70
C
C     GET NEXT MPL ENTRY
C
  150 IF (MPL(MPLPNT)+MPLPNT .GT. LMPL) GO TO 160
      MPLPNT = MPLPNT + MPL(MPLPNT)
      IF (MPL(MPLPNT) .LT. 1) GO TO 1240
      GO TO 60
  160 CONTINUE
C
C     INITIALIZE /XLINK/
C
C     MAXLNK = MAXIMUM NUMBER OF LINKS THAT CAN BE HANDLED. IF MAXLNK IS
C              INCREASED THEN LNKEDT TABLE MUST BE INCREASED.
C              (MAXLNK WAS SET IN SEMDBD ROUTINE)
C
C     MOVE LINK TABLE INTO OPEN CORE
C
      LNKTOP = 1
      LNKBOT = LLINK + LNKTOP - 5
      DO 200 J = 1,LLINK
  200 LNKSPC(J) = LINK(J)
C
C     UPDATE LNKSPC TABLE IF SENSE SWITCH 29 IS ON
C
      CALL SSWTCH (29,L)
      IF (L .EQ. 0) GO TO 600
      ASSIGN 280 TO IRTN
C
C     PROCESS INPUT CARD (NOTE-DO NOT USE VARIABLES I,J OR M)
C
  210 CALL PAGE1
      NLINES = NLINES + 2
      WRITE  (OPTAP,220)
  220 FORMAT (42H0LINK SPECIFICATION TABLE UPDATE DECK ECHO )
  230 NLINES = NLINES + 1
      IF (NLINES .GE. NLPP) GO TO 210
      CALL XREAD (*240,INBUFF)
      GO TO 260
  240 CALL PAGE2 (2)
      WRITE  (OPTAP,250) UFM
  250 FORMAT (A23,' 220, MISSING ENDDATA CARD.')
      GO TO 1250
  260 CONTINUE
      WRITE  (OPTAP,270) INBUFF
  270 FORMAT (5X,20A4)
C
C     CHECK FOR COMMENT CARD
C
      IF (KHRFN1(0,1,INBUFF(1),1) .EQ. KHRFN1(0,1,DOLSGN,1)) GO TO 230
C
C     CONVERT CARD IMAGE
C
      CALL XRCARD (UTILTY(UTLTOP),UTLBOT-UTLTOP+1,INBUFF)
      IF (UTILTY(UTLTOP) .EQ. 0) GO TO 230
C
C     CHECK FOR ENDDATA CARD
C
      IF (UTILTY(UTLTOP+1).EQ.ENDDTA(1) .AND.
     1    UTILTY(UTLTOP+2).EQ.ENDDTA(2)) GO TO 380
      GO TO IRTN, (280,330)
C
C     CHECK FORMAT OF CARD
C
  280 IF (UTILTY(UTLTOP) .LT. 2) GO TO 1220
C
C     SEE IF MODULE NAME IS IN LNKSPC TABLE
C
      DO 290 I = LNKTOP,LNKBOT,5
      IF (LNKSPC(I  ).EQ.UTILTY(UTLTOP+1) .AND.
     1    LNKSPC(I+1).EQ.UTILTY(UTLTOP+2)) GO TO 300
  290 CONTINUE
C
C     MODULE IS NOT IN LNKSPC - MAKE NEW ENTRY
C
      LNKBOT = LNKBOT + 5
      IF (LNKBOT .GT. LOPNCR) GO TO 1200
      I = LNKBOT
C
C     TRANSFER MODULE NAME AND ENTRY POINT TO LNKSPC
C
  300 LNKSPC(I  ) = UTILTY(UTLTOP+1)
      LNKSPC(I+1) = UTILTY(UTLTOP+2)
      LNKSPC(I+2) = UTILTY(UTLTOP+3)
      LNKSPC(I+3) = UTILTY(UTLTOP+4)
C
C     CHECK FOR DELETE OR NONE
C
      IF (UTILTY(UTLTOP  ) .EQ.      2) GO TO 320
      IF (UTILTY(UTLTOP+5) .EQ. DELETE) GO TO 310
      IF (UTILTY(UTLTOP+5) .NE.  XNONE) GO TO 1220
C
C     MODULE HAS NO ENTRY POINT
C
      LNKSPC(I+2) = NONE(1)
      LNKSPC(I+3) = NONE(2)
      M = 0
      J = 7
      IF (UTILTY(UTLTOP+7) .NE. -1) J = 9
      GO TO 330
C
C     MODULE IS TO BE DELETED
C
  310 LNKSPC(I) = 0
      GO TO 370
C
C     GENERATE A LINK FLAG WORD
C
  320 M = 0
      J = 5
C
C     CHECK MODE WORD
C
  330 K = UTLTOP + J
      IF (UTILTY(K)) 340,350,360
C
C     INTEGER FOUND
C
  340 IF (UTILTY(K) .NE. -1) GO TO 1220
      M = ORF(M,LSHIFT(1,UTILTY(K+1)-1))
      J = J + 2
      GO TO 330
C
C     CONTINUE MODE FOUND
C
  350 J = 1
      ASSIGN 330 TO IRTN
      GO TO 230
C
C     END OF INSTRUCTION FOUND
C
C     TRANSFER GENERATED LINK WORD TO LNKSPC ENTRY
C
  360 IF (UTILTY(K) .NE. NOSGN) GO TO 1220
      J = I + 4
      LNKSPC(J) = M
C
C     PROCESS NEXT INPUT CARD
C
  370 ASSIGN 280 TO IRTN
      GO TO 230
C
C     PUNCH OUT LNKSPC TABLE IF SENSE SWITCH 28 IS ON.
C
  380 CALL SSWTCH (28,L)
      IF (L .EQ. 0) GO TO 600
C
C     ELIMINATE DELETED LNKSPC ENTRIES
C
  390 DO 400 I = LNKTOP,LNKBOT,5
      IF (LNKSPC(I) .EQ. 0) GO TO 410
  400 CONTINUE
      GO TO 430
  410 K = I + 4
      N = LNKBOT - 1
      DO 420 M = I,K
      N = N + 1
      LNKSPC(M) = LNKSPC(N)
  420 CONTINUE
      LNKBOT = LNKBOT - 5
      GO TO 390
  430 CALL PAGE2 (2)
      WRITE  (OPTAP,440)
  440 FORMAT (98H0***USER REQUESTS LINK SPECIFICATION TABLE BE PUNCHED O
     1UT FOR USE IN RECOMPILING SUBROUTINE XLNKDD )
      WRITE  (LPCH,450)
  450 FORMAT (70(1H*),/38HLINK SPEC. TABLE FOR SUBROUTINE XLNKDD )
      J  = LNKBOT - LNKTOP + 5
      N  = J/90
      WRITE  (LPCH,460) J
  460 FORMAT (6X,16HDIMENSION LINK (,I4,1H))
      K  = 90
      IF (N .EQ. 0) GO TO 490
      DO 480 I = 1,N
      I10= I/10
      I1 = I - 10*I10
      WRITE  (LPCH,470) I10,I1,K
  470 FORMAT (5X,2H1,,9X,4HLINK,2I1,1H(,I4,1H))
  480 CONTINUE
  490 K  = MOD(J,90)
      I  = N + 1
      I10= I/10
      I1 = I - 10*I10
      IF (K .GT. 0) WRITE (LPCH,470) I10,I1,K
      WRITE  (LPCH,500) J
  500 FORMAT (6X,28HCOMMON/XLKSPC/ LLINK, KLINK(,I4,1H),/,
     1        6X,34HEQUIVALENCE (LINK(   1),LINK01(1)) )
      IF (K .GT. 0) N = N + 1
      IF (N .LT. 2) GO TO 530
      DO 520 I = 2,N
      I10= I/10
      I1 = I - 10*I10
      K  = 90*(I-1) + 1
      WRITE  (LPCH,510) K,I10,I1
  510 FORMAT (5X,2H1,,11X,6H(LINK( ,I4,6H),LINK ,2I1,4H(1)))
  520 CONTINUE
  530 CONTINUE
      J  = LNKTOP - 1
      M  = 0
  540 J  = J + 1
      M  = M + 1
      M10= M/10
      M1 = M - 10*M10
      K  = MIN0(J+89,LNKBOT+4)
      WRITE  (LPCH,550) M10,M1,(LNKSPC(I),I=J,K)
  550 FORMAT (6X,9HDATA LINK,2I1,1H/, /,
     1        5X,4H1 4H,A4,3H,4H,A4,4H, 4H,A4,3H,4H,A4,1H,,I6,/,
     2       (5X,4H1,4H,A4,3H,4H,A4,4H, 4H,A4,3H,4H,A4,1H,,I6))
      WRITE  (LPCH,560)
  560 FORMAT (5X,2H1/)
      J = K
      IF (J .LT. LNKBOT+4) GO TO 540
      J = LNKBOT - LNKTOP + 5
      WRITE  (LPCH,570) J
  570 FORMAT (6X,8HLLINK = ,I4)
C
C     INITIALIZE PAGE HEADING
C
  600 DO 610 I = 1,32
      PGHDG(I+ 96) = HDG1(I)
      PGHDG(I+128) = HDG2(I)
  610 PGHDG(I+160) = NBLANK
      PGHDG(  113) = MCHNAM
      NLINES = NLPP
C
C     INITIALIZE O/P BUFFER PARAMETERS - O/P BUFFERS ARE IN OPEN CORE
C
      OPBTOP = LNKBOT + 5
      NXTLIN = OPBTOP - 20
C
C     GET FIRST/NEXT MPL ENTRY
C
      MPLPNT = 1
      MODIDX = 1
C
C     CHECK FOR DECLARATIVE OR NULL ENTRY
C
  620 IF (MPL(MPLPNT+3).GT.4 .OR. MPL(MPLPNT+3).LT.1) GO TO 630
      GO TO 700
  630 IF (MPL(MPLPNT) .LT. 1) GO TO 800
      MPLPNT = MPLPNT + MPL(MPLPNT)
      MODIDX = MODIDX + 1
      IF (MPLPNT .LT. LMPL) GO TO 620
      GO TO 800
C
C     PREPARE TO GENERATE NEXT LINE OF OUTPUT
C
  700 NXTLIN = NXTLIN + 20
      I  = NXTLIN + 19
      IF (I .GT. LOPNCR) GO TO 1240
      DO 710 J = NXTLIN,I
  710 OPBUFF(J) = NBLANK
C
C     MODULE INDEX INTO WORD 1 OF O/P ENTRY
C
      OPBUFF(NXTLIN) = MODIDX
C
C     DMAP NAME TO WORDS 2,3 OF O/P ENTRY
C
      OPBUFF(NXTLIN+1) = MPL(MPLPNT+1)
      OPBUFF(NXTLIN+2) = MPL(MPLPNT+2)
C
C     GET ENTRY POINT NAME AND ENTER IN WORDS 4,5 OF O/P ENTRY
C
      OPBUFF(NXTLIN+3) = NONE(1)
      OPBUFF(NXTLIN+4) = NONE(2)
      DO 720 I = LNKTOP,LNKBOT,5
      IF (LNKSPC(I).EQ.MPL(MPLPNT+1) .AND. LNKSPC(I+1).EQ.MPL(MPLPNT+2))
     1    GO TO 730
  720 CONTINUE
      GO TO 630
  730 OPBUFF(NXTLIN+3) = LNKSPC(I+2)
      OPBUFF(NXTLIN+4) = LNKSPC(I+3)
C
C     EXAMINE LINK FLAG
C
      L = LNKSPC(I+4)
      DO 740 J = 1,MAXLNK
      IF (ANDF(L,LSHIFT(1,J-1)) .EQ. 0) GO TO 740
C
C     MODULE IS IN LINK J - SET BIT J IN MAIN LINK TABLE AND O/P BUFFER
C     MAKE SURE LINK TABLE IS LONG ENOUGH.
C
      IF (LXLINK .LT. MODIDX) GO TO 1210
      MLINK(MODIDX) = ORF(MLINK(MODIDX),LSHIFT(1,J-1))
      K = NXTLIN + J + 4
      OPBUFF(K) = LNKEDT(J)
  740 CONTINUE
      GO TO 630
C
C     SEE IF O/P BUFFER IS TO BE PRINTED (I.E. SENSE SWITCH 31 IS ON)
C
  800 CALL SSWTCH (31,L)
      IF (L .NE. 0) GO TO 810
C
C     PRINT O/P BUFFER IF LINK DRIVER PUNCHED O/P  REQUESTED(I.E. SENSE
C     SWITCH 30 IS ON)
C
      CALL SSWTCH (30,L)
      IF (L .EQ. 0) RETURN
  810 DO 830 I = OPBTOP,NXTLIN,20
      NLINES = NLINES + 1
      IF (NLINES .GE. NLPP) CALL PAGE
      J = I + 19
      WRITE  (OPTAP,820) (OPBUFF(K),K=I,J)
  820 FORMAT (5X,I6,3X,2A4,4X,2A4,7X,15A4)
  830 CONTINUE
C
C     SEE IF ANY DRIVERS SHOULD BE PUNCHED  (I.E. SENSE SWITCH 30 ON)
C
      CALL SSWTCH (30,L)
      IF (L .EQ. 0) RETURN
      CALL PAGE1
      NLINES = NLINES + 2
      WRITE  (OPTAP,910)
  910 FORMAT ('0USER REQUESTS PUNCHED OUTPUT FOR THE FOLLOWING LINK ',
     1        'DRIVER SUBROUTINES')
      WRITE  (LPCH,920)
  920 FORMAT (70(1H*), /,' INSERT FOLLOWING FORTRAN CODE IN RESPECTIVE',
     1       ' LINK DRIVER ROUTINES')
      DO 1170 J = 1,MAXLNK
      CALL SSWTCH (J,L)
      IF (L .EQ. 0) GO TO 1170
      J10= J/10
      J1 = J - 10*J10
      WRITE  (LPCH,930) J10,J1,J
  930 FORMAT (70(1H*), /6X,15HSUBROUTINE XSEM,2I1, /6X,12HDATA THISLK,
     1        /,I2,1H/)
      WRITE  (LPCH,940) J10,J1
  940 FORMAT (6X,21HDATA SUBNAM/4HXSEM,4H,2I1,3H  /)
      NLINES = NLINES + 2
      IF (NLINES .GE. NLPP) CALL PAGE
      WRITE  (OPTAP,950) J10,J1
  950 FORMAT (9H0    XSEM,2I1)
C
C     USER REQUESTS PUNCHED O/P FOR LINK J
C     SEARCH LINK TABLE FOR MODULES RESIDING IN LINK J
C
      FRSTIN = 0
      L      = 0
      LASTIN = 0
      NXTGRP = 1000
      DO  1100 I = 1,LXLINK
      LL(L+1) = 940
      IF (ANDF(MLINK(I),LSHIFT(1,J-1)) .NE. 0) LL(L+1) = 2000 + I
      IF (I - LASTIN) 980,990,960
  960 IF (FRSTIN.LE.0 .AND. LL(L+1).EQ.940) GO TO 1100
      FRSTIN = I
      LASTIN = MIN0(I+180,LXLINK)
      LSTGRP = NXTGRP
      NXTGRP = NXTGRP - 5
  970 FORMAT (I5,8H GO TO (  )
  980 L = L + 1
      IF (LL(L) .NE. 940) GO TO 1000
C
C     ONLY TWO CONSECUTIVE BRANCHES TO 940 IN COMPUTED  -GO TO -
C
      IF (LAST+2 .GE. I) GO TO 1010
      LASTIN = LAST
      L      = MAX0(0,L-1+LASTIN-I)
  990 LL(15) = LL(L+1)
      IF (L) 1050,1050,1020
 1000 LAST = I
 1010 IF (L .LT. 13) GO TO 1100
 1020 IF (FRSTIN .EQ. LL(1)-2000) WRITE (LPCH,970) NXTGRP
      LK = MIN0(L,10)
      WRITE  (LPCH,1030) (LL(K),K=1,LK)
 1030 FORMAT (5X,1H1,10(I5,1H,))
      L  = L - LK
      DO 1040 K = 1,L
 1040 LL(K) = LL(K+10)
      IF (I .LT. LASTIN) GO TO 1100
 1050 LAST = NXTGRP + 15
      IF (I .EQ. LXLINK) LAST = 970
      IF (FRSTIN .EQ. LASTIN) GO TO 1070
      FRSTIN = FRSTIN - 1
      WRITE  (LPCH,1060) LL(15),LSTGRP,LASTIN,LAST,FRSTIN,NXTGRP
 1060 FORMAT (5X, 1H1, I5, 4H ),I ,/,
     1        I5, 14H IF (MODX .GT. ,I3, 8H) GO TO ,I5, /,
     1        6X, 10HI = MODX - , I3, /,
     1        6X, 17HIF (I ) 940, 940, ,I5)
      GO TO 1090
 1070 WRITE  (LPCH,1080) LSTGRP,FRSTIN,LL(15),LAST
 1080 FORMAT (I5,12H IF (MODX - ,I3,7H ) 940,,I5,1H,,I5)
 1090 NXTGRP = LAST
      FRSTIN = -1
 1100 CONTINUE
C
C     PUNCH OUT GO TO AND IF STATEMENTS FOR LAST GROUP OF MODULES IN
C     LINK J.
C
      IF (FRSTIN .NE. 0) GO TO 1120
C
C     CANNOT FIND ANY MODULES IN THIS LINK
C
      NLINES = NLINES + 2
      WRITE  (OPTAP,1110) J
 1110 FORMAT (1H0,10X,29HTHERE ARE NO MODULES IN LINK  ,I3)
      GO TO 1170
 1120 IF (LAST .NE. 970) WRITE (LPCH,1130) NXTGRP
 1130 FORMAT (I5,34H IF (MODX - LXLINK ) 940, 940, 970 )
C
C     SEARCH O/P BUFFER FOR MODULES RESIDING IN LINK J
C
      DO 1160 I = OPBTOP,NXTLIN,20
      K = I + 4 + J
      IF (OPBUFF(K) .EQ. NBLANK) GO TO 1160
C
C     THIS MODULE IS IN LINK J - PUNCH OUT CALL AND GO TO STATEMENT
C
      N = 2000 + OPBUFF(I)
      WRITE  (LPCH,1150) N,OPBUFF(I+3),OPBUFF(I+4)
 1150 FORMAT (I5,1X,5HCALL ,2A4,/6X,8HGO TO 10)
 1160 CONTINUE
 1170 CONTINUE
      J = LLINK/8
      IF (J .GT. LXLINK) CALL PAGE2 (-3)
      IF (J .GT. LXLINK) WRITE (OPTAP,1180) SWM,J,LXLINK
 1180 FORMAT (A27,' 54, THE NUMBER OF MODULES SPECIFIED IN THE LINK ',
     1       'SPECIFICATION TABLE,',I5, /20X,'EXCEEDS THE ALLOWABLE ',
     2       'NUMBER SPECIFIED BY SEMDBD,',I5,1H.)
      CALL PEXIT
C
C     ERROR MESSAGES -
C
C     NOT ENOUGH OPEN CORE
C
 1200 CALL XGPIDG (51,LNKBOT-LOPNCR,0,0)
      GO TO 1250
C
C     NAMED COMMON /XLINK/ IS TOO SMALL
C
 1210 CALL XGPIDG (52,0,0,0)
      RETURN
C
C     INCORRECT FORMAT IN ABOVE CARD.
C
 1220 CALL XGPIDG (53,0,0,0)
      ASSIGN 280 TO IRTN
      GO TO 230
C
C     ERROR IN PARAMETER SECTION OF MPL TABLE
C
 1230 CALL XGPIDG (49,MPLPNT,MPL(MPLPNT+1),MPL(MPLPNT+2))
      GO TO 150
C
C     FATAL ERROR IN MPL TABLE
C
 1240 CALL XGPIDG (49,MPLPNT,MPL(MPLPNT+1),MPL(MPLPNT+2))
      GO TO 1250
C
C     FATAL ERROR EXIT
C
 1250 XSYS(3) = 3
      RETURN
      END

      SUBROUTINE INPTT4
C
C     THIS INPTT4 UTILITY MODULE WILL READ USER-SUPPLIED TAPE (OR DISC
C     FILE), AS GENERATED FROM OUTPUT4 OR FROM MSC/OUTPUTi MODULES (i=1,
C
C     THIS MODULE HANDLES ONLY MATRICES, AND NOT TABLES
C
C     COSMIC/OUTPUT4 AND MSC/OUTPUT4 ARE IDENTICAL (BINARY ONLY)
C     COSMIC/INPUTT4 AND MSC/INPUTT4 ARE SIMILAR, EXECPT COSMIC/INPUTT4
C     CAN ALSO PROCESS MSC/OUTPUT1 AND MSC/OUTPUT2 TAPES.
C
C     INPUTT4   /O1,O2,O3,O4,O5/V,N,P1/V,N,P2/V,N,P3/V,N,P4 $
C
C        Oi     = OUTPUT GINO DATA BLOCKS
C
C        P1     = TAPE READ POSITION CONTROL
C               . SEE P1 OF INPUTT1 MODULE IF P4=-1
C               . SEE P1 OF INPUTT2 MODULE IF P4=-2
C               . SEE P1 OF INPUTT4 MODULE IF P4=-4
C               . IF P4=0,   P1= 0 NO ACTION
C                            P1=-1 REWIND P2 BEFORE READ
C                            P1=-2 WRITE E-O-F MARK AND REWIND P2 AT END
C                            P1=-3 BOTH
C        P2     =+N, INPUT TAPE LOGICAL UNIT, INTEGER, NO DEFAULT
C                    INPUT TAPE IS IN BINARY (UNFORMATTED).
C               =-N, INPUT TAPE LOGICAL UNIT +N, INPUT MATRICES WERE
C                    WRITTEN IN BCD RECORDS (i.e. ASCII, FORMATTED)
C        P3     = TAPE LABEL, DEFAULT='XXXXXXXX'
C        P4     = OUTPUT TAPE MODULE, INTEGER (DEFAULT P4=0)
C               =-4, TAPE WAS ORIGINALLY WRITTEN BY MSC/OUTPUT4 MODULE*
C                    UNFORMATTED (BINARY) TAPE, OR FORMATTED (BCD) TAPE.
C                    FORMATS FOR BCD TAPE ARE -
C                    3I8 FOR INTEGERS, 2A4 FOR BCD, AND 5E16.9 FOR REAL.
C               =-2, TAPE WAS ORIGINALLY WRITTEN BY MSC/OUTPUT2 MODULE*
C               =-1, TAPE WAS ORIGINALLY WRITTEN BY MSC/OUTPUT1 MODULE*
C               = 0, TAPE WAS ORIGINALLY WRITTEN BY OUTPUT4 MODULE
C                 .  IN BINARY RECORDS (P2=+N), UNFORMATTED.
C                 .  IN ASCII FORMATTED RECORDS (P2=-N), FORMATS FOR
C                    INTEGERS AND REAL DATA ARE MATRIX TYPE DEPENDENT.
C                    I13 AND 10E13.6 FOR S.P.MATRIX DATA, AND
C                    I16 AND  8D16.9 FOR D.P.MATRIX DATA.
C                    I16 AND  8E16.9 FOR S.P.MATRIX DATA, AND LONG WORD
C             .GE.1, IN ASCII FORMATTED RECORDS (P2=-N), I16 IS USED FOR
C                    INTEGERS, AND 8E16.9 FOR ALL REAL S.P. OR D.P.DATA
C
C        * REQUIRE SYNCHRONIZED GINO BUFFER SIZE IN COSMIC NASTRAN AND
C          MSC/NASTRAN
C
C     PARAMETERS EQUIVALENCE FOR COSMIC/INPUTT4 AND MSC/INPUTT4
C
C          COSMIC/INPUTT4        MSC/INPUTT4
C          --------------        ------------------------------
C               P1               NMAT (NO OF MATRICES ON TAPE)
C               P2               P2
C               P3               P1
C               P4               BCDOPT
C
C
C     NOTE - MIXED OUTPUT FILES FROM MSC/OUTPUT1, OUTPUT2 AND OUTPUT4
C            ON ONE TAPE ARE NOT ALLOWED IN THIS INPUTT4 MODULE
C
C     EXAMPLE 1 - INPUT TAPE INP1 (UNIT 15) CONTAINS 5 MATRICES,
C     =========   WRITTEN BY OUTPUT4, BINARY.
C                 WE WANT TO COPY
C                 FILE 3 TO A,
C                 FILE 4 TO B
C
C     1.  INPUTT4  /,,A,B,/-1/15   $ REWIND, READ & ECHO HEADER RECORD
C
C
C     EXAMPLE 2 - TO COPY THE FIRST 2 FILES OF A FORMATTED TAPE INP2
C     =========   (UNIT 16), WRITTEN BY OUTPUT4
C
C     2.  INPUTT4  /A,B,,,/-1/-16  $
C
C
C     EXAMPLE 3 - TO LIST THE FILES ON INP3 (TAPE CODE 3), THEN REWIND,
C     =========   AND COPY FILES 2 AND 3 ON INPUT TAPE ORIGINALLY
C                 WRITTEN BY MSC/OUTPUT1. TAPE CONTAINS A HEADER RECORD
C                 (FILE 0), AND TAPE ID "MYFILE"
C
C     3.  INPUTT4  /A,B,,,/-3/3/*MYFILE*/-1  $
C
C     ACTUALLY, INPTT4 MODULE CALLS INPUT2 TO PROCESS ANY TAPE THAT WAS
C     GENERATED BY MSC/OUTPUT2. SIMILARILY, INPUT1 IS CALLED FOR TAPE
C     FROM MSC/OUTPUT1
C
C     THE FIRT PARAMETER NMAT IN MSC/INPUTT4 IS NOT USED HERE
C
      INTEGER         P1,P2,P3,P4,BCDOPT,Y(1),Z(1)
      COMMON /BLANK / P1,P2,P3(2),P4
      COMMON /SYSTEM/ IBUFF,NOUT
      COMMON /ZZZZZZ/ X(1)
      EQUIVALENCE     (Y(1),X(1))
      EQUIVALENCE     (Z(1),X(1))
C
      IF (P4 .GE. 0) GO TO 40
      NMAT = IABS(P4)
      GO TO (10,20,30,40,30), NMAT
C
   10 CALL INPUT1
      GO TO 50
C
   20 CALL INPUT2
      GO TO 50
C
   30 WRITE  (NOUT,35) P4
   35 FORMAT ('  ERROR IN INPTT4.  P4 =',I3,' NOT AVAILABLE')
      CALL MESAGE (-61,0,0)
C
   40 NMAT  = 5
      IUNIT = IABS(P2)
      ITAPE = P1
      BCDOPT= 1
      IF (P2 .LT. 0) BCDOPT = 2
      IF (P4 .GT. 0) BCDOPT = 3
C
C     BCDOPT = 1, BINARAY INPUT TAPE
C            = 2, ASCII INPUT TAPE, WITH S.P./D.P. STANDARD FORMATS
C            = 3, ASCII INPUT TAPE, WITH LARGE FILED S.P./D.P. FORMATS
C
      CALL INPUT4 (NMAT,IUNIT,ITAPE,BCDOPT)
   50 RETURN
      END

      SUBROUTINE PSTRQ2 (NTYPE)
C THIS ROUTINE CALCULATES PHASE II OUTPUT FOR PLA3
C
C     NTYPE = 1 TRI-MEMBRANE
C     NTYPE = 2 QUAD-MEMBRANE
C
C     PH1OUT CONTAINS THE FOLLOWING
C     *** NTYPE = 1 ***
C     ELEMENT ID
C     3 SILS
C     5 DUMMY-S
C     3 S ARRAYS EACH 3X3
C
C     *** NTYPE = 2 ***
C     ELEMENT ID
C     4 SILS
C     4 DUMMY-S
C     4 S ARRAYS EACH 3X3
C
      DIMENSION NSIL(4), SI(36)
C
      COMMON /PLA3UV/ IVEC, Z(24)
      COMMON /PLA3ES/ PH1OUT(300)
      COMMON /PLA32S/ STRESS(3),VEC(3),TEMP,DELTA,NSIZE,NPOINT,
     1   DUM(315)
      COMMON /SOUT/  STRES(9)
C
      EQUIVALENCE
     1            (NSIL(1),PH1OUT(2))
     2,           (SI(1),PH1OUT(10))
C
C
C                        I=NSIZE
C     STRESS VECTOR = (SUMMATION  (S ) (U ))
C                        I=1        I    I
C
      NSIZE = NTYPE + 2
      DO 20 I = 1,NSIZE
C     POINTER TO DISPLACEMENT VECTOR
      NPOINT = IVEC + NSIL(I) -1
C
      CALL GMMATS( SI(9*I-8),3,3,0,  Z(NPOINT),3,1,0, VEC(1))
C
      DO 30 J=1,3
   30 STRESS(J) = STRESS(J) + VEC(J)
   20 CONTINUE
C
      STRES(1) = PH1OUT(1)
      STRES(2) = STRESS(1)
      STRES(3) = STRESS(2)
      STRES(4) = STRESS(3)
C
C     ******************************************************************
C
C     PRINCIPAL STRESSES AND ANGLE OF ACTION PHI
      TEMP = STRES(2) - STRES(3)
      STRES(8) = SQRT( (TEMP/2.0E0)**2 + STRES(4)**2 )
      DELTA = (STRES(2) + STRES(3))/2.0E0
      STRES(6) = DELTA + STRES(8)
      STRES(7) = DELTA - STRES(8)
      DELTA = 2.0E0 * STRES(4)
      IF( ABS(DELTA) .LT. 1.0E-15 .AND. ABS(TEMP) .LT. 1.0E-15)GO TO 101
      STRES(5) = ATAN2( DELTA,TEMP ) * 28.6478898 E00
      RETURN
  101 STRES(5) = 0.0E0
      RETURN
      END

      SUBROUTINE TRPLMS (GMAT,DMAT,BMAT,BMAT1,BMAT2,MATTYP,JCOR,WTK)
C
C     ROUTINE TO PERFORM THE TRIPLE MULTIPLY AT EACH INTEGRATION
C     POINT FOR THE QUAD4 ELEMENT.
C     DIFFERENT PATHS ARE TAKEN BASED ON THE FOLLOWING CRITERIA -
C      1- ELEMENT BEING A MEMBRANE ONLY, OR BENDING ONLY, OR BOTH
C         MEMBRANE AND BENDING ELEMENT.
C      2- THE MATERIAL PROPERTIES BEING ISOTROPIC OR NOT.
C      3- THE MACHINE THIS CODE IS RUNNING ON. (TENTATIVE)
C
      REAL    WTK,AKGG,GMAT(10,10),DMAT(7,7)
      REAL    BMAT(240),BMAT1(1),BMAT2(1)
      REAL    DBM(240),DMAT1(3,3),DMAT2(4,4)
C
      LOGICAL MEMBRN,BENDNG,SHRFLX,MBCOUP,NORPTH
C
      COMMON /TERMS / MEMBRN,BENDNG,SHRFLX,MBCOUP,NORPTH
      COMMON /ZZZZZZ/ AKGG(1)
      COMMON /TRPLM / NDOF,IBOT,IPTX1,IPTX2,IPTY1,IPTY2
C
C*****
C     INITIALIZE
C*****
      ND1 = NDOF
      ND2 = ND1 * 2
      ND3 = ND1 * 3
      ND4 = ND1 * 4
      ND5 = ND1 * 5
      ND6 = ND1 * 6
      ND7 = ND1 * 7
      ND8 = ND1 * 8
      ND9 = ND1 * 9
      NDA = ND1 * 10
      IF (.NOT.NORPTH) GO TO 500
C*****
C ALL MIDS ARE THE SAME AND THERE IS NO COUPLING.
C IF THE MATERIAL IS ISOTROPIC, PERFORM THE 1ST MUTIPLY EXPLICITLY.
C IF NOT, USE GMMATS. IN EITHER CASE, THE 2ND MULTIPLY USES GMMATS.
C*****
      DO 100 I=1,ND1
      BMAT(I+ND2) = BMAT2(I+IBOT     )
      BMAT(I+ND3) = BMAT1(I+IPTY1    )
      BMAT(I+ND4) = BMAT1(I+IPTY2    )
      BMAT(I+ND5) = BMAT1(I+IPTX1+ND1)
  100 BMAT(I+ND6) = BMAT1(I+IPTX2+ND1)
C
      IF (MATTYP .NE. 1) GO TO 300
      DO 200 I=1,ND1
      DBM (I    ) = DMAT(1,1)*BMAT(I    ) + DMAT(1,2)*BMAT(I+ND1)
      DBM (I+ND1) = DMAT(2,1)*BMAT(I    ) + DMAT(2,2)*BMAT(I+ND1)
      DBM (I+ND2) = DMAT(3,3)*BMAT(I+ND2)
      DBM (I+ND3) = DMAT(4,4)*BMAT(I+ND3) + DMAT(4,5)*BMAT(I+ND4)
      DBM (I+ND4) = DMAT(5,4)*BMAT(I+ND3) + DMAT(5,5)*BMAT(I+ND4)
      DBM (I+ND5) = DMAT(6,6)*BMAT(I+ND5) + DMAT(6,7)*BMAT(I+ND6)
  200 DBM (I+ND6) = DMAT(7,6)*BMAT(I+ND5) + DMAT(7,7)*BMAT(I+ND6)
      GO TO 400
C
  300 CALL GMMATS (DMAT,7,7,0,BMAT,7,ND1,0,DBM)
C
  400 DO 420 I=1,ND7
  420 BMAT(I) = BMAT(I)*WTK
      CALL GMMATS (BMAT,7,ND1,-1,DBM,7,ND1,0,AKGG(JCOR))
      RETURN
C*****
C     MIDS ARE NOT THE SAME. CHECK FOR MEMBRANE ONLY AND BENDING ONLY
C     CASES AND BRANCH APPROPRIATELY. IF BOTH ARE THERE, CONTINUE.
C*****
  500 IF (.NOT.BENDNG) GO TO 800
      IF (.NOT.MEMBRN) GO TO 1200
      DO 600 I=1,ND1
      BMAT(I+ND2) = BMAT2(I+IBOT     )
      BMAT(I+ND5) = BMAT2(I+IBOT+ND1 )
      BMAT(I+ND6) = BMAT1(I+IPTY1    )
      BMAT(I+ND7) = BMAT1(I+IPTY2    )
      BMAT(I+ND8) = BMAT1(I+IPTX1+ND1)
  600 BMAT(I+ND9) = BMAT1(I+IPTX2+ND1)
      CALL GMMATS (GMAT,10,10,0,BMAT,10,ND1,0,DBM)
C
      DO 750 I=1,NDA
  750 BMAT(I) = BMAT(I)*WTK
      CALL GMMATS (BMAT,10,ND1,-1,DBM,10,ND1,0,AKGG(JCOR))
      RETURN
C*****
C     MEMBRANE ONLY ELEMENT. ONLY THE FIRST 3X3 OF GMAT AND THE FIRST
C     3 ROWS OF BMAT ARE MULTIPLIED.
C*****
  800 DO 900 I=1,ND1
  900 BMAT(I+ND2) = BMAT2(I+IBOT)
C
      IF (MATTYP .NE. 1) GO TO 950
      DO 920 I=1,ND1
      DBM (I    ) = GMAT(1,1)*BMAT(I    ) + GMAT(1,2)*BMAT(I+ND1)
      DBM (I+ND1) = GMAT(2,1)*BMAT(I    ) + GMAT(2,2)*BMAT(I+ND1)
  920 DBM (I+ND2) = GMAT(3,3)*BMAT(I+ND2)
      GO TO 1050
C
  950 DO 1000 I=1,3
      DO 1000 J=1,3
 1000 DMAT1(I,J) = GMAT(I,J)
      CALL GMMATS (DMAT1,3,3,0,BMAT(1),3,ND1,0,DBM(1))
C
 1050 DO 1100 I=1,ND3
 1100 BMAT(I) = BMAT(I)*WTK
      CALL GMMATS (BMAT,3,ND1,-1,DBM,3,ND1,0,AKGG(JCOR))
      RETURN
C*****
C     BENDING ONLY ELEMENT. THE FIRST 3 ROWS AND COLUMNS OF GMAT AND
C     THE FIRST 3 ROWS OF BMAT WILL BE EXCLUDED FROM MULTIPLICATIONS.
C*****
 1200 DO 1300 I=1,ND1
      BMAT(I+ND6) = BMAT1(I+IPTY1    )
      BMAT(I+ND7) = BMAT1(I+IPTY2    )
      BMAT(I+ND8) = BMAT1(I+IPTX1+ND1)
 1300 BMAT(I+ND9) = BMAT1(I+IPTX2+ND1)
C
      DO 1400 I=1,3
      DO 1400 J=1,3
 1400 DMAT1(I,J) = GMAT(I+3,J+3)
      DO 1500 I=1,4
      DO 1500 J=1,4
 1500 DMAT2(I,J) = GMAT(I+6,J+6)
C
      CALL GMMATS (DMAT1,3,3,0,BMAT(ND3+1),3,ND1,0,DBM(1    ))
      CALL GMMATS (DMAT2,4,4,0,BMAT(ND6+1),4,ND1,0,DBM(ND3+1))
C
      DO 1600 I=ND3+1,NDA
 1600 BMAT(I) = BMAT(I)*WTK
      CALL GMMATS (BMAT(ND3+1),7,ND1,-1,DBM,7,ND1,0,AKGG(JCOR))
      RETURN
C
      END

      SUBROUTINE RCOVB
C
C     RCOVB PERFORMS THE BACK-SUBSTITUTIONS TO OBTAIN THE G-SET
C     DISPLACEMENTS OF A SUBSTRUCTURE WHOSE LEVEL IS LOWER THAN OR
C     EQUAL TO THAT OF THE FINAL SOLUTION STRUCTURE (FSS).
C     FOR EACH SUBSTRUCTURE WHOSE DISPLACEMENTS ARE RECOVERED,
C     AN SOLN ITEM IS CREATED BY EDITING THE SOLN ITEM OF THE FSS.
C
      EXTERNAL         ANDF
      LOGICAL          MODAL
      INTEGER          MCBTRL(7)  ,DRY        ,STEP       ,FSS       ,
     1                 RFNO       ,UINMS      ,SCHK       ,UA        ,
     2                 SSNM1      ,SYSBUF     ,RSP        ,RDP       ,
     3                 RECT       ,UPPER      ,LOWER      ,SYM       ,
     4                 HMCB       ,UBMCB      ,UAOMCB     ,UAMCB     ,
     5                 TFLAG      ,SIGNAB     ,SIGNC      ,SCRM      ,
     6                 UGV        ,UI(5)      ,SCR2       ,SCR3      ,
     7                 SCR5       ,NAME(2)    ,BLANK      ,UVEC      ,
     8                 POVE       ,HORG       ,SCR1       ,GMASK     ,
     9                 PAO        ,UB         ,IZ(1)      ,SOFSIZ    ,
     O                 SOF1       ,SOF2       ,SOF3       ,BUF1      ,
     1                 BUF2       ,RC         ,SSNM(2)    ,EQSS      ,
     2                 BUF(1)     ,ANDF       ,UIMPRO     ,ENERGY    ,
     3                 RMASK      ,FILE       ,RD         ,RDREW     ,
     4                 WRT        ,WRTREW     ,REW        ,EOFNRW    ,
     5                 BUF3       ,BUF4
C     INTEGER          SCR6       ,SCR7       ,SRD        ,SWRT
      DOUBLE PRECISION DZ(1)
      CHARACTER        UFM*23     ,UWM*25     ,UIM*29     ,SFM*25    ,
     1                 SWM*27
      COMMON /XMSSG /  UFM        ,UWM        ,UIM        ,SFM       ,
     1                 SWM
      COMMON /BLANK /  DRY        ,LOOP       ,STEP       ,FSS(2)    ,
     1                 RFNO       ,NEIGV      ,LUI        ,UINMS(2,5),
     2                 NOSORT     ,UTHRES     ,PTHRES     ,QTHRES
      COMMON /RCOVCR/  ICORE      ,LCORE      ,BUF1       ,BUF2      ,
     1                 BUF3       ,BUF4       ,SOF1       ,SOF2      ,
     2                 SOF3
      COMMON /RCOVCM/  MRECVR     ,UA         ,PA         ,QA        ,
     1                 IOPT       ,SSNM1(2)   ,ENERGY     ,UIMPRO    ,
     2                 RANGE(2)   ,IREQ       ,LREQ       ,LBASIC
      COMMON /SYSTEM/  SYSBUF     ,NOUT
      COMMON /NAMES /  RD         ,RDREW      ,WRT        ,WRTREW    ,
     1                 REW        ,NOREW      ,EOFNRW     ,RSP       ,
     2                 RDP        ,CSP        ,CDP        ,SQUARE    ,
     3                 RECT       ,DIAG       ,UPPER      ,LOWER     ,
     4                 SYM
      COMMON /MPYADX/  HMCB(7)    ,UBMCB(7)   ,UAOMCB(7)  ,UAMCB(7)  ,
     1                 MPYZ       ,TFLAG      ,SIGNAB     ,SIGNC     ,
     2                 MPREC      ,SCRM
      COMMON /ZZZZZZ/  Z(1)
      EQUIVALENCE      (BUF(1)    ,Z(1))
      EQUIVALENCE      (Z(1)      ,IZ(1)      ,DZ(1))
      DATA    NAME  /  4HRCOV,4HB          /
      DATA    UGV   ,  SCR1,SCR2,SCR3,SCR5 /
     1        106   ,  301, 302, 303, 305  /
      DATA    UI    /  204, 205, 206, 207, 208 /
      DATA    UVEC  ,  POVE,HORG,EQSS / 4HUVEC,4HPOVE,4HHORG,4HEQSS /
      DATA    IB    ,  SCHK / 1,  3   /
      DATA    SCR6  ,  SCR7,SRD,SWRT  / 306,307, 1,2 /
      DATA    RMASK /  469762048  /
      DATA    GMASK /  268435456  /
      DATA    MMASK /  134217728  /
      DATA    BLANK /  4H         /
C
C     INITIALIZE
C
      LCOREZ= KORSZ(Z) - LREQ
      SOF1  = LCOREZ - SYSBUF + 1
      SOF2  = SOF1 - SYSBUF - 1
      SOF3  = SOF2 - SYSBUF
      BUF1  = SOF3 - SYSBUF
      BUF2  = BUF1 - SYSBUF
      BUF3  = BUF2 - SYSBUF
      BUF4  = BUF3 - SYSBUF
      LCORE = BUF4 - 1
      IF (LCORE .LE. 0) GO TO 9008
      CALL SOFOPN (Z(SOF1),Z(SOF2),Z(SOF3))
      UA    = 0
      PAO   = 0
      TFLAG = 0
      SIGNAB= 1
      SIGNC = 1
      MPREC = 0
      SCRM  = SCR5
C
C     FIND OUT HOW MANY UI FILES THERE ARE AND WHICH ONES
C
      DO 10 I = 1,5
      IZ(1) = UI(I)
      CALL RDTRL (IZ)
      IF (IZ(1) .LT. 0) UINMS(1,I) = 0
   10 CONTINUE
C
C     IF UINMS(1,I) = 0         THEN  FILE UI(I) IS PURGED
C     IF UINMS(1,I) = BLANK     THEN  FILE UI(I) IS AVAILABLE AND NOT
C                                     IN USE
C     IF UINMS(1,I) = OTHER     THEN  FILE UI(I) CONTAINS UGV FOR
C                                     SUBSTRUCTURE -OTHER-
C
      SSNM(1) = SSNM1(1)
      SSNM(2) = SSNM1(2)
C
C     IF SSNM IS THE FINAL SOLUTION STRUCTURE (FSS), NO RECOVERY IS
C     NECESSARY.
C
      IF (SSNM(1).NE.FSS(1) .OR. SSNM(2).NE.FSS(2)) GO TO 190
      UA = UGV
      GO TO 508
C
C     SEARCH THE SOF FOR A DISPLACEMENT MATRIX OF SSNM OR A HIGHER
C     LEVEL SUBSTRUCTURE FROM WHICH THE REQUESTED DISPLACEMENTS CAN BE
C     RECOVERED
C
  190 JLVL = 1
  200 CALL SOFTRL (SSNM,UVEC,MCBTRL)
      RC  = MCBTRL(1)
      IF (RC .EQ. 1) GO TO 270
      IF (RC.EQ.2 .AND. DRY.LT.0) GO TO 270
      IF (RC .EQ. 3) GO TO 210
      IF (RC .EQ. 5) CALL SMSG (3,UVEC,SSNM)
      IF (RC .EQ. 4) GO TO 500
      WRITE (NOUT,63070) UWM,SSNM1,SSNM
      GO TO 9200
C
C     NO UVEC AT THIS LEVEL.  SAVE SSNM IN A STACK AT TOP OF OPEN CORE
C     AND SEARCH FOR UVEC OF THE NEXT HIGHER LEVEL
C
  210 LASTSS = 2*JLVL - 1
      IZ(LASTSS  ) = SSNM(1)
      IZ(LASTSS+1) = SSNM(2)
      JLVL = JLVL + 1
      CALL FNDNXL (Z(LASTSS),SSNM)
      IF (SSNM(1) .NE. BLANK) GO TO 230
      WRITE (NOUT,63060) UWM,IZ(LASTSS),IZ(LASTSS+1)
      GO TO 9200
  230 IF (SSNM(1).NE.IZ(LASTSS) .OR. SSNM(2).NE.IZ(LASTSS+1)) GO TO 240
      WRITE (NOUT,63080) UWM,SSNM1,SSNM
      GO TO 9200
C
C     IF SSNM IS NOT THE FSS, LOOK FOR UVEC ON THE SOF.  IF DRY RUN,
C     EXIT.  IF IT IS THE FSS, SET UA=UGV.  IF UGV IS NOT PURGED GO TO
C     BEGIN BACK-SUBSTITUTION.  OTHERWISE, GIVE IT THE SAME TREATMENT
C     AS IF IT WERE NOT THE FSS.
C
  240 IF (SSNM(1).NE.FSS(1) .OR. SSNM(2).NE.FSS(2)) GO TO 200
      IF (DRY .LT. 0) GO TO 500
      UA = UGV
      MCBTRL(1) = UA
      CALL RDTRL (MCBTRL)
      IF (MCBTRL(1) .GT. 0) GO TO 340
      GO TO 200
C
C     FOUND A UVEC ON SOF FOR THIS LEVEL.  SEE IF IT HAS ALREADY BEEN
C     PUT ON A UI FILE.  (IF DRY RUN, EXIT)
C
  270 IF (DRY.LT.0 .OR. JLVL.EQ.1) GO TO 500
      DO 280 I = 1,5
      UA = UI(I)
      IF (SSNM(1).EQ.UINMS(1,I) .AND. SSNM(2).EQ.UINMS(2,I)) GO TO 340
  280 CONTINUE
C
C     DATA BLANK /4H    /
C
C     IT DOES NOT RESIDE ON ANY UI FILE.  FIND A UI FILE TO USE.
C
      J = 0
      DO 290 I = 1,5
      IF (UINMS(1,I) .EQ. 0) GO TO 290
      J = J + 1
      IF (UINMS(1,I) .EQ. BLANK) GO TO 310
  290 CONTINUE
      GO TO 297
C
C     ALL UI FILES SEEM TO BE IN USE.  DO ANY REALLY EXIST
C
  297 IF (J .EQ. 0) GO TO 320
C
C     AT LEAST ONE EXISTS.  RE-USE THE ONE WITH OLDEST DATA
C
      I = LUI + 1
      IF (I .GT. 5) I = 1
      J = I
  300 IF (UINMS(1,I) .NE. 0) GO TO 310
C
C     NO FILE THERE.  TRY NEXT ONE.
C
      I = I + 1
      IF (I .GT. 5) I = 1
      IF (I .EQ. J) GO TO 320
      GO TO 300
C
C     FOUND A UI FILE TO USE
C
  310 LUI = I
      UA  = UI(I)
      UINMS(1,I) = SSNM(1)
      UINMS(2,I) = SSNM(2)
      GO TO 330
C
C     ALL UI FILES ARE PURGED.  USE SCR1 INSTEAD
C
  320 UA = SCR1
C
C     COPY UVEC FROM SOF TO UA
C
  330 CALL MTRXI (UA,SSNM,UVEC,0,RC)
C
C     TOP OF BACK-SUBSTITUTION LOOP
C
  340 UB = UA
      UAOMCB(1) = 0
      ICORE = LASTSS  + 2
      IDPCOR= ICORE/2 + 1
C
C     CHECK IF THE EQSS ITEM IS THERE FOR THIS SUBSTRUCTURE
C
      CALL SFETCH (Z(LASTSS),EQSS,SCHK,RC)
      IF (RC .NE. 1) GO TO 6317
C
C     COMPUTE TIME TO RECOVER THIS LEVEL AND CHECK TIME-TO-GO
C
C     (A DETAILED TIME CHECK SHOULD BE CODED LATER.  FOR THE PRESENT,
C     JUST CHECK TO SEE IF TIME HAS RUN OUT NOW.)
C
      CALL TMTOGO (I)
      IF (I .LE. 0) GO TO 6309
C
C     CHECK REMAINING SPACE ON SOF.  FIRST CALCULATE HOW MUCH SPACE
C     THE RECOVERED DISPLACEMENT MATRIX WILL TAKE (ASSUMING IT IS FULL).
C
      MCBTRL(1) = UB
      CALL RDTRL (MCBTRL)
      I = MCBTRL(2)
C
C     NO. OF COLUMNS IN DISPLACEMENT MATRIX IN I
C
      CALL SOFTRL (Z(LASTSS),HORG,MCBTRL)
      RC = MCBTRL(1)
      ITEM = HORG
      IF (RC .GT. 1) GO TO 6317
      NROW = MCBTRL(3)
      J = I*NROW
C
C     NOW CHECK SPACE
C
      IF (SOFSIZ(I) .LT. J) GO TO 6310
C
C     CREATE THE SOLUTION ITEM FOR THE RECOVERED SUBSTRUCTURE.
C
      CALL RCOVLS (Z(LASTSS))
      IF (IOPT .LT. 0) GO TO 9000
C
C     FIND A UI FILE FOR DISPLACEMENTS
C
      J = 0
      DO 420 I = 1,5
      IF (UINMS(1,I) .EQ. 0) GO TO 420
      J = J + 1
      IF (UINMS(1,I) .EQ. BLANK) GO TO 440
  420 CONTINUE
C
C     NO UNUSED UI FILES ARE AVAILABLE.  IF TWO OR MORE UI FILES ARE
C     NOT PURGED, USE THE ONE WITH OLDEST DATA.  OTHERWISE, USE SCR2.
C     MAKE SURE WE DON T ASSIGN THE SAME FILE AS THE HIGHER
C     LEVEL DISPLACEMENTS ARE ON (UB)
C
      IF (J .LT. 2) GO TO 450
      I = LUI + 1
      IF (I .GT. 5) I = 1
      J = I
  430 IF (UINMS(1,I).NE.0 .AND. UI(I).NE.UB) GO TO 440
      I = I + 1
      IF (I .GT. 5) I = 1
      IF (I .EQ. J) GO TO 450
      GO TO 430
C
C     FOUND A UI FILE
C
  440 LUI = I
      UA  = UI(I)
      UINMS(1,I) = IZ(LASTSS  )
      UINMS(2,I) = IZ(LASTSS+1)
      GO TO 455
  450 UA = SCR2
C
C     IF THE RECOVERED SUBSTRUCTURE WAS NOT REDUCED GENERATE THE
C     DISPLACEMENTS DIRECTLY.
C     IF THE SUBSTRUCTURE WAS REDUCED AND THE UIMPROVED FLAG IS SET
C     AND THIS IS A NON-STATICS RUN GENERATE THE IMPROVED DISPLACEMENTS.
C     IF THE SUBSTRUCTURE WAS IN A GUYAN REDUCTION AND THIS IS A
C     STATICS RUN GENERATE THE LOADS ON THE OMMITED POINTS.
C
C     INCLUDE THE CHECK ON THE POVE ITEM ALSO TO BE COMPATABLE WITH
C     PREVIOUS SOFS WITH NO TYPE BITS
C
  455 CALL SOFTRL (Z(LASTSS),POVE,MCBTRL)
      IPOVE = MCBTRL(1)
      CALL FDSUB (SSNM,IDIT)
      RC = 4
      IF (IDIT .LT. 0) GO TO 6317
      CALL FMDI (IDIT,IMDI)
      MODAL = .FALSE.
      IF (ANDF(BUF(IMDI+IB),MMASK) .NE. 0) MODAL = .TRUE.
      IF (ANDF(BUF(IMDI+IB),RMASK).NE.0 .AND. UIMPRO.NE.0 .AND.
     1    RFNO.GT.2) GO TO 470
      IF (ANDF(BUF(IMDI+IB),GMASK).NE.0 .AND. RFNO.LE.2) GO TO 480
      IF (ANDF(BUF(IMDI+IB),RMASK).EQ.0 .AND. IPOVE.EQ.1 .AND.
     1    RFNO.LE.2) GO TO 480
      GO TO 490
C
C     IF THE USER REQUESTED AN IMPROVED VECTOR AND THIS IS A NONSTATICS
C     RUN THEN GENERATE IT.
C
  470 CALL RCOVUI (UB,Z(LASTSS),MODAL)
      IF (IOPT .LT. 0) GO TO 9000
      GO TO 495
C
C     GENERATE THE LOADS ON THE OMITED POINTS FOR REDUCED SUBSTRUCTURES
C     IF THIS IS A STATICS RUN
C
  480 CALL RCOVUO (0,UAOMCB(1),Z(LASTSS))
      IF (IOPT .LT. 0) GO TO 9000
C
C     MULIPLY AND ADD TO GET DISPLACEMENTS OF LOWER-LIVEL SUBSTRUCTURE.
C
C     COPY H OR G TRANSFORMATION MATRIX TO SCR3
C
      CALL SOFOPN (Z(SOF1),Z(SOF2),Z(SOF3))
  490 ITEM = HORG
      CALL MTRXI (SCR3,Z(LASTSS),HORG,0,RC)
      IF (RC .NE. 1) GO TO 6317
C
C     SETUP FOR MPYAD
C
      CALL SOFCLS
      HMCB(1) = SCR3
      UBMCB(1)= UB
      CALL RDTRL (HMCB)
      CALL RDTRL (UBMCB)
      IF (UAOMCB(1) .NE. 0) CALL RDTRL (UAOMCB)
      CALL MAKMCB (UAMCB,UA,HMCB(3),RECT,UBMCB(5))
      MPYZ = LCOREZ - ICORE - 7
      CALL MPYAD (DZ(IDPCOR),DZ(IDPCOR),DZ(IDPCOR))
      CALL WRTTRL (UAMCB)
C
C     COPY RECOVERED DISPLACEMENTS TO SOF
C
  495 CALL SOFOPN (Z(SOF1),Z(SOF2),Z(SOF3))
      CALL MTRXO (UA,Z(LASTSS),UVEC,0,RC)
C
C     END OF BACK-SUBSTITUTION LOOP
C     CLOSE AND REOPEN THE SOF TO GET ANY CONTROL BLOCKS WRITTEN TO
C     FILE
C
      CALL SOFCLS
      CALL SOFOPN (Z(SOF1),Z(SOF2),Z(SOF3))
      SSNM(1) = IZ(LASTSS)
      SSNM(2) = IZ(LASTSS+1)
      LASTSS  = LASTSS - 2
      JLVL    = JLVL - 1
      WRITE (NOUT,63120) UIM,JLVL,SSNM
      IF (JLVL .GT. 1) GO TO 340
C
C     NORMAL COMPLETION OF MODULE EXECUTION
C
  508 CONTINUE
  500 DO 510 I = 1,5
      IF (UINMS(1,I) .EQ. 0) UINMS(1,I) = BLANK
  510 CONTINUE
      CALL SOFCLS
      RETURN
C
C     ERROR PROCESSING
C
 6309 WRITE (NOUT,63090) SFM,IZ(LASTSS),IZ(LASTSS+1),SSNM,SSNM1
      N = -37
      GO TO 9100
 6310 WRITE (NOUT,63100) SWM,IZ(LASTSS),IZ(LASTSS+1),SSNM,SSNM1
      GO TO 9200
 6317 IF (RC .EQ. 2) RC = 3
      CALL SMSG (RC-2,ITEM,Z(LASTSS))
 9000 WRITE (NOUT,63170) SWM,SSNM1
      GO TO 9200
 9008 N = 8
 9100 CALL SOFCLS
      CALL MESAGE (N,FILE,NAME)
 9200 IOPT = -1
      GO TO 500
C
C     FORMAT STATEMENTS
C
63060 FORMAT (A25,' 6306, ATTEMPT TO RECOVER DISPLACEMENTS FOR NON-',
     1       'EXISTANT SUBSTRUCTURE ',2A4)
63070 FORMAT (A25,' 6307, WHILE ATTEMPTING TO RECOVER DISPLACEMENTS ',
     1       'FOR SUBSTRUCTURE ',2A4,1H,, /32X,'THE DISPLACEMENTS FOR ',
     2       'SUBSTRUCTURE ',2A4,' WERE FOUND TO EXIST IN DRY RUN ',
     3       'FORM ONLY.')
63080 FORMAT (A25,' 6308, NO SOLUTION AVAILABLE FROM WHICH DISPLACE',
     1       'MENTS FOR SUBSTRUCTURE ',2A4, /32X,'CAN BE RECOVERED.  ',
     2       'HIGHEST LEVEL SUBSTRUCTURE FOUND WAS ',2A4)
63090 FORMAT (A25,' 6309, INSUFFICIENT TIME REMAINING TO RECOVER DIS',
     1       'PLACEMENTS OF SUBSTRUCTURE ',2A4, /32X,'FROM THOSE OF ',
     2       'SUBSTRUCTURE ',2A4,'.  (PROCESSING USER RECOVER REQUEST',
     3       /32X,'FOR SUBSTRUCTURE ',2A4,1H))
63100 FORMAT (A27,' 6310, INSUFFICIENT SPACE ON SOF TO RECOVER DIS',
     1       'PLACEMENTS OF SUBSTRUCTURE ',2A4, /32X,' FROM THOSE OF ',
     2       'SUBSTRUCTURE ',2A4,' WHILE PROCESSING USER RECOVER ',
     3       'REQUEST', /32X,'FOR SUBSTRUCTURE ',2A4)
63120 FORMAT (A29,' 6312, LEVEL',I4,' DISPLACEMENTS FOR SUBSTRUCTURE ',
     1       2A4, /36X,'HAVE BEEN RECOVERED AND SAVED ON THE SOF.')
63170 FORMAT (A25,' 6317, RECOVER OF DISPLACEMENTS FOR SUBSTRUCTURE ',
     1       2A4,' ABORTED.')
      END

      SUBROUTINE RCOVSL (NAME,ITEM,IN,AMAT,SCR2,SCR3,OUT,Z,IZ,LCORE,
     1                   FIRST,RFNO)
C
C     RCOVSL CALCULATES THE STATIC LOAD VECTORS FOR THE SUBSTRUCTURING
C     PHASE 2 AND PHASE 3 OPERATIONS FROM THE SUBSTRUCTURE SOLN ITEM
C
      LOGICAL         FIRST
      INTEGER         NAME(2),AMAT,SCR2,SCR3,OUT,PMX,FMX,CMX,SLMX,T,
     1                SIGNPF,SIGNC,PREC,SCR,RD,RDREW,WRT,WRTREW,REW,
     2                OTYPP,SYSBUF,SOLN,SRD,SUBR(2),BUF1,FSS(2),IBUF(3),
     3                IZ(1),RC,RFNO,TYPE
      REAL            Z(1)
      COMMON /MPYADX/ PMX(7),FMX(7),CMX(7),SLMX(7),MCORE,T,SIGNPF,SIGNC,
     1                PREC,SCR
      COMMON /NAMES / RD,RDREW,WRT,WRTREW,REW,NOREW
      COMMON /PACKX / ITYPP,OTYPP,IROWP,NROWP,INCP
      COMMON /SYSTEM/ SYSBUF,NOUT
      DATA    SOLN  / 4HSOLN /, SRD   / 1 /
      DATA    SUBR  / 4HRCOV ,  4HSL  /
C
C     INITIALIZE
C
      BUF1  = LCORE - SYSBUF + 1
      ITYPP = 1
      IROWP = 1
      INCP  = 1
      MCORE = LCORE
      T     = 0
      SIGNPF= 1
      PREC  = 0
C
C     READ LOAD MATRIX FROM SOF ONTO GINO FILE
C
      PMX(1) = IN
      CALL RDTRL (PMX)
      IF (PMX(1) .GT. 0) GO TO 5
      ITM = ITEM
      CALL MTRXI (SCR2,NAME,ITEM,Z(BUF1),RC)
      IF (RC .EQ. 3) GO TO 600
      IF (RC .NE. 1) GO TO 1000
      PMX(1) = SCR2
      CALL RDTRL (PMX)
    5 NROWP = PMX(2)
      TYPE  = PMX(5)
      IF (RFNO .EQ. 8 .AND. TYPE .LE. 2) TYPE = TYPE + 2
      OTYPP = TYPE
      IF (FIRST) GO TO 500
C
C     PROCESS INITIAL SOLN DATA
C
      ITM = SOLN
      CALL SFETCH (NAME,SOLN,SRD,RC)
      IF (RC .NE. 1) GO TO 1000
      CALL SUREAD (FSS,2,N,RC)
      IF (RC .NE. 1) GO TO 1100
      CALL SUREAD (IBUF,3,N,RC)
      IF (RC .NE. 1) GO TO 1100
      IF (RFNO .EQ. 3) GO TO 600
      NB  = IBUF(2)
      NST = IBUF(3)
C
C     INTILIZE SCR1 FILE
C
      CALL MAKMCB (FMX,AMAT,NROWP,2,TYPE)
      CALL GOPEN (AMAT,Z(BUF1),WRTREW)
C
C     PACK FACTOR MATRIX FOR R. F. 1,2
C
      IF (RFNO.EQ.8 .OR. RFNO.EQ.9) GO TO 100
      DO 40 I = 1,NST
      DO 10 J = 1,NROWP
      Z(J) = 0.0
   10 CONTINUE
      N = 1
      CALL SJUMP (N)
      IF (N .LT. 0) GO TO 1200
      CALL SUREAD (NL,1,N,RC)
      IF (RC .NE. 1) GO TO 1100
      IF (NL .LT. 0) GO TO 40
      IF (NL .EQ. 0) GO TO 30
      IF (NROWP+2*NL .GE. BUF1) CALL MESAGE (-8,0,SUBR)
      CALL SUREAD (Z(NROWP+1),2*NL,N,RC)
      IF (RC .NE. 1) GO TO 1100
      NROW = NROWP - 1
      DO 20 J = 1,NL
      NROW = NROW + 2
      NR   = IZ(NROW)
      Z(NR)= Z(NROW+1)
   20 CONTINUE
   30 CALL PACK (Z(1),AMAT,FMX)
   40 CONTINUE
      CALL CLOSE (AMAT,REW)
      CALL WRTTRL(FMX)
      GO TO 500
C
C     PACK FACTOR MATRIX FOR R. F. 8,9
C
  100 CALL SUREAD (IZ(1),3*NB,N,RC)
      IF (RC .NE. 1) GO TO 1100
      CALL SUREAD (NL,1,N,RC)
      IF (RC .NE. 1) GO TO 1100
      IF (NL .LE. 0) GO TO 600
      IF (NL .GE. BUF1) CALL MESAGE (-8,0,SUBR)
      CALL SUREAD (IZ(1),NL,N,RC)
      IF (RC .NE. 1) GO TO 1100
      N  = 1
      CALL SJUMP (N)
      IF (N .LT. 0) GO TO 1200
      IP = 1
      IF (RFNO .EQ. 8) IP = 2
      IF (RFNO .EQ. 8) ITYPP = 3
      IFACT = NL + 1
      NFACT = NL + NL*IP
      ICOL  = NFACT + 1
      NCOL  = NFACT + IP*NROWP
      IF (NCOL .GE. BUF1) CALL MESAGE (-8,0,SUBR)
C
      DO 230 I = 1,NST
      DO 210 J = ICOL,NCOL
      Z(J) = 0.0
  210 CONTINUE
      N = 1
      CALL SJUMP (N)
      IF (N .LT. 0) GO TO 1200
      CALL SUREAD (Z(IFACT),NL*IP,N,RC)
      IF (RC .NE. 1) GO TO 1100
      NROW = IFACT - IP
      NRS  = ICOL  - IP
      DO 220 J = 1,NL
      NROW = NROW + IP
      NR   = NRS  + IZ(J)*IP
      Z(NR)= Z(NROW)
      IF (IP .EQ. 2) Z(NR+1) = Z(NROW+1)
  220 CONTINUE
      CALL PACK (Z(ICOL),AMAT,FMX)
  230 CONTINUE
      CALL CLOSE (AMAT,REW)
      CALL WRTTRL (FMX)
C
C     OUT = LOADS*FACTORS
C
  500 FMX(1) = AMAT
      CALL RDTRL (FMX)
      CMX(1) = 0
      CALL MAKMCB (SLMX,OUT,PMX(3),2,TYPE)
      SCR = SCR3
      CALL MPYAD (Z,Z,Z)
      CALL WRTTRL (SLMX)
      GO TO 700
C
C     NO SCALAR LOADS
C
  600 OUT = 0
      CALL CLOSE (AMAT,REW)
  700 RETURN
C
C     ERRORS
C
 1000 CALL SMSG (RC-2,ITM,NAME)
      GO TO 600
 1100 CALL SMSG (RC+4,ITM,NAME)
      GO TO 600
 1200 CALL SMSG (7,ITM,NAME)
      GO TO 600
      END

      SUBROUTINE DETM5
C
C     WRITES EIGENVALUE SUMMARY FOR DETERMINANT METHOD
C
      DOUBLE PRECISION PSAVE(1),DET(1), PS(1)
      INTEGER IPDET(8),SYSBUF
      DIMENSION CORE(5)
C
      COMMON /CONDAS/ CONSTS(5)
      COMMON /DETMX/ P(32),N2EV,IPSAV,IPS,IDET,IPDETA,PREC,NSTART,
     1  NDCMP,IC,NSMOVE,ITERM,IS,ND,IADD,SML1,IPDETX(4),IPDET1(4),
     2 IFAIL,K,FACT1,IFFND,NFAIL
      COMMON /REGEAN/ IM(26),LCORE,RMAX,RMIN,MZ, NEV, EPSI, RMINR, NE,
     1  NIT, NEVM, SCR6, IPOUT, NFOUND, LAMA
      COMMON /ZZZZZZ/ PSAVE
      COMMON /SYSTEM/SYSBUF
C
      EQUIVALENCE  (PSAVE(1),PS(1),DET(1),IPDET(1),CORE(1))
      EQUIVALENCE ( CONSTS(2) , TPHI   )
C
C ----------------------------------------------------------------------
C
      NZ = KORSZ(PSAVE) -LCORE-SYSBUF
      CALL GOPEN(IPOUT,IPDET(NZ+1),1)
      IPDET(1) = 1
      IPDET(2) = NFOUND
      IF(MZ .GT. 0) IPDET(2) = IPDET(2) +MZ
      IPDET(3) = NSTART
      IPDET(4) = IC
      IPDET(5) = NSMOVE
      IPDET(6) = NDCMP
      IPDET(7) = NFAIL
      IPDET(8) = ITERM
      DO 10 I=9,12
   10 IPDET(I) = 0
      CALL WRITE(IPOUT,IPDET(1),12,0)
      IF(NDCMP .EQ. 0) GO TO 61
      N2EV2 = IADD+ND
      DO 60 I=1,N2EV2
      NND = I+IDET
      NNP = I+IPS
      NNI = I+IPDETA
C
C     PUT UUT STRRTING POINT SUMMARY
C
      IPDET(1) = I
      CORE(2) = PSAVE(NNP)
      CORE(3) = SQRT(ABS(CORE(2)))
      CORE(4) = CORE(3)/TPHI
      CORE(5) = PSAVE(NND)
      IPDET(6) = IPDET(NNI)
C
C     SCALE DETERMINANTE FOR PRETTY PRINT
C
      IF(CORE(5) .EQ. 0.0) GO TO 50
   20 IF(ABS(CORE(5)) .GE. 10.0) GO TO 40
   30 IF(ABS(CORE(5)) .GE. 1.0) GO TO 50
      CORE(5) = CORE(5)*10.0
      IPDET(6) = IPDET(6)-1
      GO TO 30
   40 CORE(5) = CORE(5)*0.1
      IPDET(6) = IPDET(6)+1
      GO TO 20
   50 CALL WRITE(IPOUT,CORE(1),6,0)
   60 CONTINUE
   61 CONTINUE
      CALL WRITE(IPOUT,CORE(1),0,1)
      CALL CLOSE(IPOUT,1)
      RETURN
      END

      SUBROUTINE HDSTAT(MT,NIT,IXR,X21,Y21,Z21,IIA,IV,A,B,C,
     1            IK,XA,YA,ZA,CCC,XXX,LZ)
C
C
C     THIS SUBROUTINE TAKES THE PTS OF INTERSECTION DETERMINED BY
C     SUBROUTINE SOLVE AND PICKS THE COORDINATES WITH THE MAX AND
C     MIN X COORDINATES PROVIDED THEY LIE ON THE INTERIOR/BOUNDARY
C     OF BOTH ELEMENTS.
C
C
      INTEGER       XCC
      DIMENSION     XXX(1),CCC(1),X21(1),Y21(1),Z21(1),
     1              IIA(1),IV(1),XA(1),YA(1),ZA(1)
      COMMON/HDPTRS/XDUM,XCC
      COMMON/ZZZZZZ/RZ(1)
      COMMON/GO3/L0,L1,L00,L01,L2,L3,L4,L5,L6,L7,L8,L9,L10,L11,L12,L13
C
      EXX=.015
      NX=0
      IF(MT.EQ.0)GO TO 160
      DO 50 JX=1,MT
      EI=0
   10 EI=EI+.1
      IF(EI .GE. 1.) GO TO 160
      D=EI*XA(JX)-YA(JX)
      DO 40 JO=1,2
      M=IV(JO)
      JC=L13+(M-1)*LZ
      JXC=L12+(M-1)*5
      NK=XXX(5+JXC)
      I=0
      IB=NK*5
C
C
C     DETERMINE IF THE PROJECTION OF THE POINT OF INTERSECTION
C     BELONGS TO THE INTERIOR OF BOTH PLANES.
C
C
      DO 30 J=1,IB,5
      EXX=.015
      NSUB=J+1+JC
      IF(ABS(CCC(NSUB)).GE.100.)EXX=ALOG10(ABS(CCC(NSUB)))
      VE=XA(JX)
      IF(CCC(J+JC).EQ.0.)VE=YA(JX)
      S=VE-CCC(J+3+JC)
      S1=VE-CCC(J+4+JC)
      T=CCC(J+JC)*YA(JX)+CCC(J+1+JC)*XA(JX)+CCC(J+2+JC)
      IF((ABS(T).LT.EXX).AND.(S*S1.LE.0.))GO TO 40
      T=-CCC(J+2+JC)+CCC(J+JC)*D
      R=EI*CCC(J+JC)+CCC(J+1+JC)
      IF(R.EQ.0.)GO TO 30
      T=T/R
      IF(T.LT.XA(JX))GO TO 30
      IF(CCC(J+JC).NE.0.)GO TO 20
      T=EI*T-D
   20 CONTINUE
      IF((T.EQ.CCC(J+3+JC)).OR.(T.EQ.CCC(J+4+JC)))GO TO 10
      S=T-CCC(J+3+JC)
      S1=T-CCC(J+4+JC)
      IF(S*S1.GT.0.)GO TO 30
      I=I+1
   30 CONTINUE
      IF(MOD(I,2).EQ.0)GO TO 50
   40 CONTINUE
      NX=NX+1
      XA(NX)=XA(JX)
      YA(NX)=YA(JX)
      ZA(NX)=ZA(JX)
   50 CONTINUE
      IF(NX.EQ.0)GO TO 160
C
C
C
C     THIS CODE FINDS THE MAX/MIN X-COORDINATES(Y-COORDINATES) AND
C     STORES THEM. FUTHERMORE BOTH THE EQUATION OF LINE AND POINTS(2)
C     ARE TREATED LIKE ADDITIONAL EDGES. IN THIS WAY, THE ALGORITHM NEED
C     NOT BE DISTURBED. ESSENTIALLY,THEN,THIS TRICK IS TRANSPARENT TO
C     THE REST OF THE PROGRAM.
C
C
      AMAXX=-(10**6)
      AMINX=-AMAXX
      AMAXY=AMAXX
      AMINY=AMINX
      IS=5+(IK-1)*5+L12
      IS=XXX(IS)
      DO 110 JI=1,NX
      IF(A.EQ.0.)GO TO 80
      IF(XA(JI).GE.AMINX)GO TO 60
      AMINX=XA(JI)
      YI=YA(JI)
      ZI=ZA(JI)
   60 IF(XA(JI).LE.AMAXX)GO TO 70
      AMAXX=XA(JI)
      YII=YA(JI)
      ZII=ZA(JI)
   70 CONTINUE
      GO TO 110
   80 CONTINUE
      IF(YA(JI).GE.AMINY)GO TO 90
      AMINY=YA(JI)
      XI=XA(JI)
      ZI=ZA(JI)
   90 CONTINUE
      IF(YA(JI).LE.AMAXY)GO TO 100
      XII=XA(JI)
      AMAXY=YA(JI)
      ZII=ZA(JI)
  100 CONTINUE
  110 CONTINUE
      NIT=NIT+1
      K=5*(NIT-1+IS)+1
      RZ(XCC+K-1)=A
      RZ(XCC+K  )=B
      RZ(XCC+K+1)=C
      IF (A.EQ.0.) GO TO 120
      RZ(XCC+K+2)=AMINX
      RZ(XCC+K+3)=AMAXX
      AMIN=AMINX
      AMAX=AMAXX
      YE=YII
      ZE=ZII
      GO TO 130
  120 CONTINUE
      RZ(XCC+K+2)=AMINY
      RZ(XCC+K+3)=AMAXY
      AMIN=XI
      AMAX=XII
      YI=AMINY
      YE=AMAXY
      ZE=ZII
  130 CONTINUE
      IG=IXR+NIT*3
      X21(IG-2)=AMIN
      Y21(IG-2)=YI
      Z21(IG-2)=ZI
      DO 140 JK=1,2
      IE=IG-JK+1
      X21(IE)=AMAX
      Y21(IE)=YE
      Z21(IE)=ZE
  140 CONTINUE
      DO 150 JK=1,2
      IIA(IG-JK)=0
  150 CONTINUE
      IIA(IG)=1
      TX=(AMAX-AMIN)**2
      TY=(YE-YI)**2
      DX=(TX+TY)**.5
      IF(DX.LT..001)NIT=NIT-1
  160 RETURN
      END

      SUBROUTINE PLTMRG
C
C     MODULE PLTMRG WRITES GINO DATA BLOCKS WHICH ARE USED AS INPUT TO
C     THE PLOT MODULE FOR PLOTTING A SUBSTRUCTURE.
C
C     APRIL 1974
C
      LOGICAL IDENT
      INTEGER BUF      ,SYSBUF   ,Z(3)     ,CASESS   ,PCDB    ,
     1        PLTP     ,GPS      ,ELS      ,BGP      ,CASEP   ,
     2        EQEX     ,SCR1     ,SRD      ,PLTS     ,FILE    ,
     3        EQSS     ,SUBR(2)  ,CASECC(2),BUF1     ,ELID    ,
     4        BUF2     ,BUF3     ,BUF4     ,BUF5     ,RC      ,
     5        BAR      ,QUAD4    ,TRIA3    ,OFFSET
      REAL    RZ
      COMMON /BLANK /   NAME(2)  ,NGPTOT   ,LSIL     ,NPSET   ,
     1                  NM(2)    ,BUF(7)
      COMMON /SYSTEM/   SYSBUF
      COMMON /NAMES /   RD       ,RDREW    ,WRT      ,WRTREW  ,
     1                  REW      ,NOREW
      COMMON /ZZZZZZ/   RZ(1)
      EQUIVALENCE       (Z(1),RZ(1))
      DATA    PLTS  ,   EQSS     ,SUBR               ,CASECC          /
     1        4HPLTS,   4HEQSS   ,4HPLTM   ,4HRG     ,4HCASE   ,4HCC  /
      DATA    CASESS,   PCDB     ,PLTP     ,GPS      ,ELS      /
     1        101   ,   102      ,201      ,202      ,203      /,
     2        BGP   ,   CASEP    ,EQEX     ,SCR1     ,SRD      /
     3        204   ,   205      ,206      ,301      ,1        /,
     4        BAR   ,   QUAD4    ,TRIA3                        /
     5        2HBR  ,   2HQ4     ,2HT3                         /
C
C     INITIALIZE
C
      NCORE = KORSZ(Z)
      BUF1  = NCORE- SYSBUF + 1
      BUF2  = BUF1 - SYSBUF
      BUF3  = BUF2 - SYSBUF
      BUF4  = BUF3 - SYSBUF
      BUF5  = BUF4 - SYSBUF
      NCORE = BUF5 - 1
      NGPTOT= 0
      LSIL  = 0
      NPSET =-1
      IF (NCORE .LE. 0) GO TO 9008
      CALL SOFOPN (Z(BUF3),Z(BUF4),Z(BUF5))
C
C     STRIP SUBSTRUCTURE RECORDS FROM CASESS AND WRITE CASEP (CASECC)
C
      FILE = CASESS
      CALL OPEN (*9001,CASESS,Z(BUF1),RDREW)
      FILE = CASEP
      CALL OPEN  (*9001,CASEP,Z(BUF2),WRTREW)
      CALL FNAME (CASEP,BUF)
      CALL WRITE (CASEP,BUF,2,1)
      FILE = CASESS
   10 CALL READ (*9002,*9003,CASESS,Z,2,1,NWDS)
      IF (Z(1).NE.CASECC(1) .OR. Z(2).NE.CASECC(2)) GO TO 10
   20 CALL READ (*40,*30,CASESS,Z,NCORE,1,NWDS)
      GO TO 9008
   30 CALL WRITE (CASEP,Z,NWDS,1)
      GO TO 20
   40 CALL CLSTAB (CASEP,REW)
      CALL CLOSE  (CASESS,REW)
C
C     BASIC GRID POINT DATA
C
      NM(1) = NAME(1)
      NM(2) = NAME(2)
      ITEM  = PLTS
      CALL SFETCH (NAME,PLTS,SRD,RC)
      IF (RC .NE. 1) GO TO 6100
C
C     READ SUBSTRUCTURE NAMES AND TRANSFORMATION DATA INTO OPEN CORE.
C
      CALL SUREAD (Z,3,NWDS,RC)
      IF (RC .NE. 1) GO TO 6106
      NSS = Z(3)
      IF (14*NSS .GT. NCORE) GO TO 9008
      CALL SUREAD (Z,14*NSS,NWDS,RC)
      IF (RC .NE. 1) GO TO 6106
      ICORE = 14*NSS + 1
C
C     READ THE BASIC GRID POINT DATA FROM THE PLTS ITEM OF EACH BASIC
C     SUBSTRUCTURE COMPRISING THE PSEUDOSTRUCTURE TO BE PLOTTED.
C     TRANSFORM THE COORDINATES TO THE BASIC COORDINATE SYSTEM OF THE
C     PSEUDOSTRUCTURE AND WRITE THEM ON BGP (BGPDT).
C
      FILE = BGP
      CALL OPEN (*9001,BGP,Z(BUF1),WRTREW)
      CALL FNAME (BGP,BUF)
      CALL WRITE (BGP,BUF,2,1)
      J = 1
  120 NM(1) = Z(J  )
      NM(2) = Z(J+1)
      NGP = 0
      CALL SFETCH (NM,PLTS,SRD,RC)
      IF (RC .EQ. 1) GO TO 130
      CALL SMSG (RC-2,PLTS,NM)
      GO TO 170
  130 I = 1
      CALL SJUMP (I)
      IDENT = .FALSE.
      DO 140 I = 1,3
      IF (Z(J+I+1) .NE. 0) GO TO 150
      IF (Z(J+I+5) .NE. 0) GO TO 150
      IF (Z(J+I+9) .NE. 0) GO TO 150
      IF (ABS(RZ(J+4*I+1)-1.0) .GT. 1.0E-4) GO TO 150
  140 CONTINUE
      IDENT = .TRUE.
  150 CALL SUREAD (BUF,4,NWDS,RC)
      IF (RC .EQ. 2) GO TO 170
      NGP = NGP + 1
      IF (IDENT .OR. BUF(1).LT.0) GO TO 160
      BUF(5) = Z(J+2)
      BUF(6) = Z(J+3)
      BUF(7) = Z(J+4)
      CALL GMMATS (Z(J+5),3,3,-2,BUF(2),3,1,0,BUF(5))
      CALL WRITE (BGP,BUF,1,0)
      CALL WRITE (BGP,BUF(5),3,0)
      GO TO 150
  160 CALL WRITE (BGP,BUF,4,0)
      GO TO 150
  170 NGPTOT = NGPTOT+NGP
      Z(J+2) = NGP
      J = J + 14
      IF (J .LT. ICORE) GO TO 120
      CALL WRITE (BGP,0,0,1)
      CALL CLOSE (BGP,REW)
      BUF(1) = BGP
      BUF(2) = NGPTOT
      DO 180 I = 3,7
  180 BUF(I) = 0
      CALL WRTTRL (BUF)
C
C     ALLOCATE 5 WORDS PER COMPONENT BASIC SUBSTRUCTURE AT THE TOP OF
C     OPEN CORE.  THIS ARRAY IS HEREINAFTER REFERRED TO AS *SDATA*
C
C     SAVE THE BASIC SUBSTRUCTURE NAMES AND THE NUMBER OF STRUCTURAL
C     GRID POINTS IN EACH IN SDATA.  DO NOT SAVE SUBSTRUCTURES FOR
C     WHICH NO PLTS ITEM WAS FOUND.
C
      J = 1
      DO 190 I = 1,NSS
      IF (Z(14*I-11) .EQ. 0) GO TO 190
      Z(J  ) = Z(14*I-13)
      Z(J+1) = Z(14*I-12)
      Z(J+2) = Z(14*I-11)
      J = J + 5
  190 CONTINUE
      IF (J .LE. 1) GO TO 9200
      NSS = J/5
      ISX = NSS*5
      ICORE = J
      LCORE = NCORE - J + 1
C
C     COMPUTE EQEX (EQEXIN)
C
C
C     READ THE EQEXIN DATA FROM THE PLTS ITEM OF EACH BASIC SUBSTRUCTURE
C     USE THREE WORDS IN OPEN CORE FOR EACH GRID POINT   (1) EXTERNAL
C     ID, (2) INTERNAL ID, (3) SUBSTRUCTURE SEQUENCE NUMBER IN SDATA.
C     INCREMENT THE INTERNAL IDS BY THE NUMBER OF GRID POINTS ON THE
C     PRECEDING SUBSTRUCTURES.
C
      K   = ICORE
      NGP = 0
      DO 210 I = 1,NSS
      NM(1) = Z(5*I-4)
      NM(2) = Z(5*I-3)
      CALL SFETCH (NM,PLTS,SRD,RC)
      N = 2
      CALL SJUMP (N)
      RC = 3
      IF (N .LT. 0) GO TO 6106
      N = Z(5*I-2)
      DO 200 J = 1,N
      CALL SUREAD (Z(K),2,NWDS,RC)
      IF (RC .NE. 1) GO TO 6106
      Z(K+1) = Z(K+1) + NGP
      Z(K+2) = I
      K = K + 3
      IF (K+2 .GT. NCORE) GO TO 9008
  200 CONTINUE
      NGP = NGP + N
  210 CONTINUE
C
C     SORT ON EXTERNAL IDS AND WRITE RECORD 1 OF EQEX.
C
      CALL SORT (0,0,3,1,Z(ICORE),3*NGP)
      FILE = EQEX
      CALL OPEN (*9001,EQEX,Z(BUF1),WRTREW)
      CALL FNAME (EQEX,BUF)
      CALL WRITE (EQEX,BUF,2,1)
      DO 220 I = 1,NGP
  220 CALL WRITE (EQEX,Z(ICORE+3*I-3),2,0)
      CALL WRITE (EQEX,0,0,1)
C
C     SAVE THE TABLE IN OPEN CORE ON SCR1 TO USE IN COMPUTING RECORD 2
C     OF EQEX
C
      FILE = SCR1
      CALL OPEN  (*9001,SCR1,Z(BUF2),WRTREW)
      CALL WRITE (SCR1,Z(ICORE),3*NGP,1)
      CALL CLOSE (SCR1,REW)
      CALL OPEN  (*9001,SCR1,Z(BUF2),RDREW)
C
C     READ GROUP 0 OF THE EQSS ITEM OF THE SUBSTRUCTURE TO BE PLOTTED
C     INTO OPEN CORE AT ICORE.  READ THE EXTERNAL AND INTERNAL IDS FOR
C     EACH CONTRIBUTING BASIC SUBSTRUCTURE INTO OPEN CORE FOLLOWING
C     GROUP 0.  SAVE THE CORE POINTERS FOR EACH GROUP IN SDATA.
C
      NM(1) = NAME(1)
      NM(2) = NAME(2)
      ITEM  = EQSS
      CALL SFETCH (NAME,EQSS,SRD,RC)
      IF (RC .NE. 1) GO TO 6100
      CALL SUREAD (Z(ICORE),LCORE,NWDS,RC)
      IF (RC .NE. 2) GO TO 9008
      K   = ICORE + NWDS
      N   = Z(ICORE+2)
      ISS = 1
      DO 250 I = 1,N
      IF (ISS .GT. ISX) GO TO 240
      IF (Z(ICORE+2*I+2).NE.Z(ISS) .OR. Z(ICORE+2*I+3).NE.Z(ISS+1))
     1    GO TO 240
      Z(ISS+3) = K
  230 IF (K+2 .GT. NCORE) GO TO 9008
      CALL SUREAD (Z(K),3,NWDS,RC)
      K = K + 2
      IF (RC .EQ. 1) GO TO 230
      Z(ISS+4) = (K-Z(ISS+3))/2
      ISS = ISS + 5
      GO TO 250
  240 J = 1
      CALL SJUMP (J)
  250 CONTINUE
C
C     READ SIL NUMBERS INTO OPEN CORE.
C
      KSIL = K - 1
      N = Z(ICORE+3)
      IF (KSIL+N+1 .GT. NCORE) GO TO 9008
      DO 260 I = 1,N
      CALL SUREAD (Z(KSIL+I),2,NWDS,RC)
      IF (RC .NE. 1) GO TO 6106
  260 CONTINUE
      LSIL = Z(KSIL+N)
C
C     READ THE TABLE OF EXTERNAL ID (GP), INTERNAL ID (IP), AND SUB-
C     STRUCTURE NUMBER (SSN) FROM SCR1 ONE ENTRY AT A TIME.  LOCATE
C     THE GP IN THE EQSS DATA INDICATED BY SSN AND LOOK UP THE SIL
C     NUMBER.  WRITE GP AND SIL ON EQEX.  IF GP NOT FOUND, THEN SIL=-1.
C
  270 CALL READ (*9002,*290,SCR1,BUF,3,0,N)
      I  = BUF(3)
      J  = Z(5*I-1)
      I5 = 5*I
      CALL BISLOC (*280,BUF(1),Z(J),2,Z(I5),K)
      I = Z(J+K) + KSIL
      BUF(2) = 10*Z(I) + 1
      CALL WRITE (EQEX,BUF,2,0)
      GO TO 270
  280 BUF(2) = -1
      CALL WRITE (EQEX,BUF,2,0)
      GO TO 270
  290 CALL WRITE (EQEX,0,0,1)
      CALL CLOSE (EQEX,REW)
      CALL CLOSE (SCR1,REW)
      BUF(1) = EQEX
      BUF(2) = NGPTOT
      DO 300 I = 3,7
  300 BUF(I) = 0
      CALL WRTTRL (BUF)
C
C     INTERPRET PLOT SETS AND GENERATE PLTP (PLTPAR)
C
C
C     AT PRESENT, ONLY ONE PLOT SET (DEFINED IN PHASE 1) IS ALLOWED.
C
C     PHASE 2 PLOT SET DEFINITIONS ARE IGNORED.
C
C     COPY PCDB TO PLTP
C
      FILE = PCDB
      CALL OPEN (*9001,PCDB,Z(BUF1),RDREW)
      CALL FWDREC (*9002,PCDB)
      FILE = PLTP
      CALL OPEN  (*9001,PLTP,Z(BUF2),WRTREW)
      CALL FNAME (PLTP,BUF)
      CALL WRITE (PLTP,BUF,2,1)
  310 CALL READ  (*330,*320,PCDB,Z(ICORE),LCORE,1,NWDS)
      GO TO 9008
  320 CALL WRITE (PLTP,Z(ICORE),NWDS,1)
      GO TO 310
  330 CALL CLOSE (PCDB,REW)
      CALL CLOSE (PLTP,REW)
      BUF(1) = PCDB
      CALL RDTRL (BUF)
      BUF(1) = PLTP
      CALL WRTTRL (BUF)
      DO 340 I = 1,NSS
      Z(5*I-1) = 0
      Z(5*I  ) = 1
  340 CONTINUE
      NPSET = 1
C
C     GPSETS
C
C
C     LOCATE THE GPSETS DATA OF THE PLTS ITEM OF EACH BASIC SUBSTRUCTURE
C     AND READ THE NUMBER OF GRID POINTS IN THE ELEMENT SET.  STORE THIS
C     AS THE FOURTH ENTRY IN SDATA
C
      N = 3
      NGPSET = 0
      ITEM   = PLTS
      DO 1010 I = 1,NSS
      NM(1) = Z(5*I-4)
      NM(2) = Z(5*I-3)
      CALL SFETCH (NM,PLTS,SRD,RC)
      CALL SJUMP (N)
      RC = 3
      IF (N .LT. 0) GO TO 6106
      CALL SUREAD (Z(5*I-1),1,NWDS,RC)
      IF (RC .NE. 1) GO TO 6106
      NGPSET = NGPSET + Z(5*I-1)
 1010 CONTINUE
C
C     WRITE RECORDS 0 AND 1 OF GPS AND FIRST WORD OF RECORD 2.
C
      FILE = GPS
      CALL OPEN  (*9001,GPS,Z(BUF1),WRTREW)
      CALL FNAME (GPS,BUF)
      CALL WRITE (GPS,BUF,2,1)
      CALL WRITE (GPS,1,1,1)
      CALL WRITE (GPS,NGPSET,1,0)
C
C     READ GPSETS DATA FROM THE PLTS ITEM OF EACH BASIC SUBSTRUCTURE.
C     INCREMENT THE ABSOLUTE VALUE OF THE POINTERS IN IT BY THE NUMBER
C     OF GRID POINTS IN THE ELEMENT SETS OF THE PRECEDING BASIC
C     SUBSTRUCTURES.  WRITE THE RESULT ON GPS (GPSETS).
C
      N = 3
      NGPSET = 0
      DO 1050 I = 1,NSS
      CALL SFETCH (Z(5*I-4),PLTS,SRD,RC)
      CALL SJUMP (N)
      CALL SUREAD (Z(ICORE),LCORE,NWDS,RC)
      IF (RC .NE. 2) GO TO 9008
      NWDS = NWDS - 1
      DO 1040 J = 1,NWDS
      IF (Z(ICORE+J)) 1020,1040,1030
 1020 Z(ICORE+J) = Z(ICORE+J) - NGPSET
      GO TO 1040
 1030 Z(ICORE+J) = Z(ICORE+J) + NGPSET
 1040 CONTINUE
      CALL WRITE (GPS,Z(ICORE+1),NWDS,0)
      NGPSET = NGPSET + Z(5*I-1)
 1050 CONTINUE
      CALL CLSTAB (GPS,REW)
C
C     ELSETS
C
C
C     READ THE ELSETS DATA FROM THE PLTS ITEM OF EACH BASIC SUBSTRUCTURE
C     INCREMENT ALL NON-ZERO GRID POINT CONNECTION INDICES BY THE NUMBER
C     OF STRUCTURAL GRID POINTS OF THE PRECEDING SUBSTRUCTURES.  WRITE
C     THE RESULT ON ELS (ELSETS).
C
C     NOTE   THE ELEMENT TYPES WILL BE SCRAMBLED.  LIKE ELEMENT TYPES
C            FROM THE CONTRIBUTING BASIC SUBSTRUCTURES WILL NOT BE
C            GROUPED TOGETHER.
C
C     NOTE   THE BAR HAS ADDITIONALLY 6 OFFSET DATA VALUES. QUAD4 AND
C            TRIA3 HAS 1 OFFSET DATA EACH
C
      FILE = ELS
      CALL OPEN  (*9001,ELS,Z(BUF1),WRTREW)
      CALL FNAME (ELS,BUF)
      CALL WRITE (ELS,BUF,2,1)
      NGP = 0
C
C     LOOP OVER BASIC SUBSTRUCTURES
C
      DO 2050 I = 1,NSS
      NM(1) = Z(5*I-4)
      NM(2) = Z(5*I-3)
      CALL SFETCH (NM,PLTS,SRD,RC)
      N  = 4
      CALL SJUMP (N)
      RC = 3
      IF (N .LT. 0) GO TO 6106
C
C     LOOP OVER ELEMENT TYPES
C
 2010 CALL SUREAD (BUF,2,N,RC)
      IF (RC .EQ. 2) GO TO 2040
      IF (RC .NE. 1) GO TO 6106
      CALL WRITE (ELS,BUF,2,0)
      NGPEL  = BUF(2)
      OFFSET = 0
      IF (BUF(1) .EQ. BAR) OFFSET = 6
      IF (BUF(1).EQ.QUAD4 .OR. BUF(1).EQ.TRIA3) OFFSET = 1
C
C     LOOP OVER ELEMENTS
C
 2020 CALL SUREAD (ELID,1,N,RC)
      IF (RC .NE. 1) GO TO 6106
      CALL WRITE (ELS,ELID,1,0)
      IF (ELID .LE. 0) GO TO 2010
      CALL SUREAD (INDX,1,N,RC)
      CALL WRITE (ELS,INDX,1,0)
      CALL SUREAD (Z(ICORE),NGPEL+OFFSET,N,RC)
      IF (RC .NE. 1) GO TO 6106
C
C     LOOP OVER CONNECTIONS
C
      K = ICORE
      DO 2030 J = 1,NGPEL
      IF (Z(K) .NE. 0) Z(K) = Z(K) + NGP
 2030 K = K + 1
      CALL WRITE (ELS,Z(ICORE),NGPEL+OFFSET,0)
      GO TO 2020
 2040 NGP = NGP + Z(5*I-2)
 2050 CONTINUE
C
      CALL WRITE  (ELS,0,0,1)
      CALL CLSTAB (ELS,REW)
C
C     NORMAL MODULE COMPLETION
C
      CALL SOFCLS
      RETURN
C
C     ABNORMAL MODULE COMPLETION
C
 6100 IF (RC .EQ. 2) RC = 3
      CALL SMSG (RC-2,ITEM,NM)
      GO TO 9200
 6106 CALL SMSG (RC+4,ITEM,NM)
      GO TO 9200
 9001 N = 1
      GO TO 9100
 9002 N = 2
      GO TO 9100
 9003 N = 3
      GO TO 9100
 9008 N = 8
 9100 CALL MESAGE (N,FILE,SUBR)
      CALL CLOSE  (FILE,REW)
 9200 CALL SOFCLS
      NPSET = -1
      RETURN
      END

      SUBROUTINE TRIMEM(NTYPE,TBAR,PG)
C
C     ******** PHASE I OF STRESS DATA RECOVERY *************************
C     ******** TRIANGULAR MEMBRANE ELEMENT *****************************
C
C     CALLS FROM THIS ROUTINE ARE MADE TO. . .
C
C     MAT    - MATERIAL DATA ROUTINE
C     MESAGE - ERROR MESSAGE WRITER
C
C     IF NTYPE = 0  COMPLETE MEMBRANE COMPUTATION IS PERFORMED
C
C     IF NTYPE = 1 RETURN 3 TRANSFORMED 3X3 MATRICES ONLY
C
C
C
      DIMENSION PG(1),ECPT(21)
C
      COMMON /CONDAS/ CONSTS(5)
      COMMON /TRIMEX/
     1                   NECPT(1)           ,NGRID(3)
     2                  ,ANGLE              ,MATID1
     3                  ,T                  ,FMU
     4                  ,DUMMY1             ,X1
     5                  ,Y1                 ,Z1
     6                  ,DUMMY2             ,X2
     7                  ,Y2                 ,Z2
     8                  ,DUMMY3             ,X3
     9                  ,Y3                 ,Z3
      COMMON /SSGWRK/ ETEMPX(6), C(18), E(18), G(9), TEMPAR(9)
      COMMON /MATIN / MATID,INFLAG,ELTEMP,STRESS,SINTH,COSTH
      COMMON /MATOUT/ G11,G12,G13,G22,G23,G33,RHO,ALPHAS(3),
     1                T SUB 0, G SUB E, SIGTEN, SIGCOM, SIGSHE,
     2                G2X211, G2X212, G2X222
C
      EQUIVALENCE ( CONSTS(4) , DEGRA  )
      EQUIVALENCE (ECPT(1),NECPT(1))
C     ECPT LIST
C                                                      IN
C                                                      THIS
C       ECPT       DESCRIPTION                         ROUTINE   TYPE
C     ******************************************************************
C       ECPT( 1) = ELEMENT ID                          NECPT(1)  INTEGER
C       ECPT( 2) = GRID POINT A                        NGRID(1)  INTEGER
C       ECPT( 3) = GRID POINT B                        NGRID(2)  INTEGER
C       ECPT( 4) = GRID POINT C                        NGRID(3)  INTEGER
C       ECPT( 5) = THETA = ANGLE OF MATERIAL           ANGLE     REAL
C       ECPT( 6) = MATERIAL ID                         MATID     INTEGER
C       ECPT( 7) = T                                   T         REAL
C       ECPT( 8) = NON-STRUCTURAL MASS                 FMU       REAL
C       ECPT( 9) = COORD. SYSTEM ID 1                  NECPT(9)  INTEGER
C       ECPT(10) = X1                                  X1        REAL
C       ECPT(11) = Y1                                  Y1        REAL
C       ECPT(12) = Z1                                  Z1        REAL
C       ECPT(13) = COORD. SYSTEM ID 2                  NECPT(13) INTEGER
C       ECPT(14) = X2                                  X2        REAL
C       ECPT(15) = Y2                                  Y2        REAL
C       ECPT(16) = Z2                                  Z2        REAL
C       ECPT(17) = COORD. SYSTEM ID 3                  NECPT(17) INTEGER
C       ECPT(18) = X3                                  X3        REAL
C       ECPT(19) = Y3                                  Y3        REAL
C       ECPT(20) = Z3                                  Z3        REAL
C       ECPT(21) = ELEMENT TEMPERATURE                 ELTEMP    REAL
C
C     ******************************************************************
      ELTEMP = ECPT(21)
C
C     SET UP THE E MATRIX WHICH IS (3X2) FOR THE TRI-MEMBRANE
C
C     E(1), E(3), E(5) WILL BE THE I-VECTOR
C     E(2), E(4), E(6) WILL BE THE J-VECTOR
C     E(7), E(8), E(9) WILL BE THE K-VECTOR NOT USED IN E FOR MEMBRANE
C
C     FIRST FIND I-VECTOR = RSUBB - RSUBA  (NON-NORMALIZED)
      E(1) = X2 - X1
      E(3) = Y2 - Y1
      E(5) = Z2 - Z1
C
C     NOW FIND LENGTH = X-SUB-B   COORD. IN ELEMENT SYSTEM
      XSUBB =  SQRT( E(1)**2 + E(3)**2 + E(5)**2 )
      IF(XSUBB .GT. 1.0E-06) GO TO 10
      CALL MESAGE(-30,31,ECPT(1))
C
C  20 NOW NORMALIZE I-VECTOR WITH X-SUB-B
   10 E(1) = E(1) / XSUBB
      E(3) = E(3) / XSUBB
      E(5) = E(5) / XSUBB
C
C     HERE WE NOW TAKE RSUBC - RSUBA AND STORE TEMPORARILY IN
C     E(2), E(4), E(6) WHICH IS WHERE THE J-VECTOR WILL FIT LATER
C
      E(2) = X3 - X1
      E(4) = Y3 - Y1
      E(6) = Z3 - Z1
C
C     X-SUB-C  =  I . (RSUBC - RSUBA) ,  THUS
      XSUBC = E(1) * E(2) + E(3) * E(4) + E(5) * E(6)
C
C     AND CROSSING THE I-VECTOR TO (RSUBC-RSUBA) GIVES THE K-VECTOR
C     (NON-NORMALIZED)
C
      E(7) = E(3) * E(6)  -  E(5) * E(4)
      E(8) = E(5) * E(2)  -  E(1) * E(6)
      E(9) = E(1) * E(4)  -  E(3) * E(2)
C
C
C     THE LENGTH OF THE K-VECTOR IS NOW FOUND AND EQUALS Y-SUB-C
C     COORD. IN ELEMENT SYSTEM
      YSUBC =  SQRT( E(7)**2 + E(8)**2 + E(9)**2 )
      IF(YSUBC .GT. 1.0E-06) GO TO 20
      CALL MESAGE(-30,32,ECPT(1))
C
C  25 NOW NORMALIZE K-VECTOR WITH YSUBC JUST FOUND
C
   20 E(7) = E(7) / YSUBC
      E(8) = E(8) / YSUBC
      E(9) = E(9) / YSUBC
C
C     NOW HAVING I AND K VECTORS.GET J = I CROSS K AND
C     STORE IN THE SPOT FOR J
C
      E(2) = E(5) * E(8) - E(3) * E(9)
      E(4) = E(1) * E(9) - E(5) * E(7)
      E(6) = E(3) * E(7) - E(1) * E(8)
C
C     AND JUST FOR COMPUTER EXACTNESS NORMALIZE J-VECTOR TO MAKE SURE.
      TEMP =  SQRT( E(2)**2 + E(4)**2 + E(6)**2 )
      E(2) = E(2)/TEMP
      E(4) = E(4)/TEMP
      E(6) = E(6)/TEMP
C
C     VOLUME OF ELEMENT, THETA, MU, LAMDA, AND DELTA
      VOL = XSUBB*YSUBC*T/2.0
C
      REELMU = 1.0D0 / XSUBB
      FLAMDA = 1.0D0 / YSUBC
      DELTA  = XSUBC / XSUBB - 1.0E0
C
C     ******************************************************************
C
C     NOW FORM THE  C MATRIX   (3X6) PARTITIONED AS FOLLOWS HERE.
C                 CSUBA = (3X2) STORED IN C(1) . . .C(6)  BY ROWS
C                 CSUBB = (3X2) STORED IN C(7) . . .C(12) BY ROWS
C                 CSUBC = (3X2) STORED IN C(13). . .C(18) BY ROWS
C
      C(1)  = -REELMU
      C(2)  =  0.0E0
      C(3)  =  0.0E0
      C(4)  =  FLAMDA * DELTA
      C(5)  =  C(4)
      C(6)  = -REELMU
      C(7)  =  REELMU
      C(8)  =  0.0E0
      C(9)  =  0.0E0
      C(10) = -FLAMDA * REELMU * XSUBC
      C(11) =  C(10)
      C(12) =  REELMU
      C(13) =  0.0E0
      C(14) =  0.0E0
      C(15) =  0.0E0
      C(16) =  FLAMDA
      C(17) =  FLAMDA
      C(18) =  0.0E0
C
      IF( NTYPE .EQ. 1 ) GO TO 30
      THETA = ANGLE * DEGRA
      SINTH = SIN( THETA )
      COSTH = COS( THETA )
   30 IF(ABS(SINTH) .LT. 1.0E-06) SINTH = 0.0E0
      ELTEMP = ECPT(21)
      MATID = MATID1
      INFLAG = 2
      CALL MAT( ECPT(1) )
C
C     FILL G-MATRIX WITH OUTPUT FROM MAT ROUTINE
C
      G(1) = G11
      G(2) = G12
      G(3) = G13
      G(4) = G12
      G(5) = G22
      G(6) = G23
      G(7) = G13
      G(8) = G23
      G(9) = G33
C
C     ******************************************************************
C
C     G, E, AND C MATRICES ARE COMPLETE
C
C
C
      TEMP = (TBAR-TSUB0)*VOL
      DO 40 I=1,3
   40 TEMPAR(I) = ALPHAS(I)*TEMP
      CALL MPYL(G(1),TEMPAR(1),3,3,1,TEMPAR(7))
      DO 70 I=1,3
      K = 6*I-5
      CALL MPYLT(C(K),TEMPAR(7),3,2,1,TEMPAR(1))
      CALL MPYL(E,TEMPAR(1),2,3,1,TEMPAR(4))
      K = 4*I+5
      IF(NECPT(K) .EQ. 0) GO TO 50
      CALL BASGLB(TEMPAR(4),TEMPAR(4),NECPT(K+1),NECPT(K))
   50 DO 60 K=1,3
      L = NECPT(I+1)+K-1
   60 PG(L) = PG(L)+TEMPAR(K+3)
   70 CONTINUE
C
C     THIS CONCLUDES PHASE 1 FOR TRIANGULAR MEMBRANE OR SUB CALCULATION
C     TO ANOTHER ROUTINE...
      RETURN
      END

      SUBROUTINE TABPT
C
C     MODULE DRIVER TO PRINT TABLES
C
      DIMENSION      IN(5),ITRL(7)
      COMMON /BLANK/ OP(2),IRC,IWD
      DATA    IN   / 101,102,103,104,105 /, BLANK / 4H     /
C
      DO 10 I = 1,5
      ITRL(1) = IN(I)
      CALL RDTRL (ITRL(1))
      IF (ITRL(1) .GT. 0) CALL TABPRT (IN(I))
   10 CONTINUE
      OP(1) = BLANK
      OP(2) = BLANK
      IRC = 0
      IWD = 0
      RETURN
      END

      SUBROUTINE DBMDFC
C********************************************************************
C     DBMDFC - DUMPS THE FREE CHAIN
C********************************************************************
      INCLUDE  'DSIOF.COM'
      INCLUDE  'ZZZZZZ.COM'
      COMMON / SYSTEM / ISYSBF, IWR
      WRITE ( IWR, 906 )
      WRITE ( IWR, 907 )
      NEXT = IDBFRE
      ITOTAL = 0
      ITOTBK = 0
      ICNT = 0
      IF ( NEXT .EQ. 0 ) GO TO 40
30    ICNT = ICNT + 1
      IF ( NEXT .EQ. 0 ) GO TO 50
      IVAL = NEXT
      IVALP= MEM(NEXT)
      IVALN= MEM(NEXT+1)
      IF ( MEM(NEXT  ) .EQ. 0 ) IVALP = 0
      IF ( MEM(NEXT+1) .EQ. 0 ) IVALN = 0
      ITOTAL = ITOTAL + MEM(NEXT+2)
      ITOTBK = ITOTBK + 1
      WRITE ( IWR, 908 ) ICNT,IVALP,IVAL,IVALN,MEM(NEXT+2)
      NEXT = MEM( NEXT+1 )
      GO TO 30
40    CONTINUE
      WRITE( IWR, 909 )
      GO TO 60
50    CONTINUE
      WRITE( IWR, 910 ) ITOTAL, ITOTBK
60    CONTINUE
700   RETURN
906   FORMAT(///,31X,' DUMP OF FREE CHAIN',/
     &,13X,' ( BLOCK ADDRESSES IN WORDS,  BLOCK LENGTHS IN WORDS )',/)
907   FORMAT(10X,
     &'  BLOCK NO    PREV. BLOCK    BLOCK ADDRESS NEXT BLOCK    LENGTH')
908   FORMAT( I17,I20,I13,I13,I10)
909   FORMAT(//' *************** NO FREE SPACE REMAINS **************')
910   FORMAT(///,' TOTAL FREE SPACE IN WORDS            =',I10
     &,/,        ' NUMBER OF BLOCKS IN FREE SPACE CHAIN =',I10)
      END

      SUBROUTINE GP3A
C
C     GP3A BUILDS THE STATIC LOADS TABLE (SLT).
C     FORCE, FORCE1, FORCE2, MOMENT, MOMNT1, MOMNT2, GRAV, PLOAD, SLOAD
C     AND LOAD CARDS ARE READ. EXTERNAL GRID NOS. ARE CONVERTED TO
C     INTERNAL INDICES. EACH LOAD SET ID (EXCEPT ON LOAD CARD) IS
C     WRITTEN IN THE HEADER RECORD OF THE SLT. THE SLT THEN COMPRISES
C     ONE LOGICAL RECORD PER LOAD SET. THE LAST RECORD OF THE SLT
C     CONTAINS THE LOAD CARDS. RFORCE CARD ADDED IN AUGUST, 1968.
C     PLOAD3 CARD ADDED ON HALLOWEEN 1972
C
      LOGICAL         PIEZ
      INTEGER         GEOM3 ,EQEXIN,SLT   ,GPTT  ,BUF1  ,BUF2  ,BUF   ,
     1                Z     ,RD    ,RDREW ,WRT   ,WRTREW,CLSREW,CARDID,
     2                CARDDT,STATUS,FILE  ,GPOINT,SCR1  ,SCR2  ,FIRST ,
     3                SETID ,FLAG  ,NAM(2),KSYSTM(80)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /SYSTEM/ ISB   ,IPTR  ,IDM(6),NLPP  ,IDUM(2),LINES
      COMMON /BLANK / NOGRAV,NOLOAD,NOTEMP
      COMMON /GP3COM/ GEOM3 ,EQEXIN,GEOM2 ,SLT   ,GPTT  ,SCR1  ,SCR2  ,
     1                BUF1  ,BUF2  ,BUF(50)      ,CARDID(60)   ,IDNO(30)
     2               ,CARDDT(60)   ,MASK(60)     ,STATUS(60)   ,NTYPES,
     3                IPLOAD,IGRAV ,PLOAD2(2)    ,LOAD(2)      ,NOPLD2,
     4                TEMP(2)      ,TEMPD(2)     ,TEMPP1(2)    ,
     5                TEMPP2(2)    ,TEMPP3(2)    ,TEMPRB(2)    ,BUF3  ,
     6                PLOAD3(2)    ,IPLD3
      COMMON /NAMES / RD    ,RDREW ,WRT   ,WRTREW,CLSREW
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE     (KSYSTM(1),ISB)
      DATA    NAM   / 4HGP3A,4H    / ,IRFRC / 9  /
C
C     READ EQEXIN INTO CORE. INITIALIZE BINARY SEARCH ROUTINE.
C
      FILE = EQEXIN
      CALL OPEN   (*570,EQEXIN,Z(BUF1),RDREW)
      CALL FWDREC (*580,EQEXIN)
      CALL READ   (*580,*20,EQEXIN,Z,BUF2,1,NEQX)
      CALL MESAGE (-8,0,NAM)
   20 CALL CLOSE  (EQEXIN,CLSREW)
      KN   = NEQX/2
      NOGO = 0
C
C     INITIALIZE POINTERS AND OPEN SCR1 AND GEOM3.
C
      ISET  = BUF2 - 2
      KSET  = ISET
      ILIST = NEQX + 1
      KLIST = ILIST
      KTABL = 1
      FIRST = 1
      FILE  = SCR1
      CALL OPEN (*570,SCR1,Z(BUF2),WRTREW)
C
C     IF PLOAD2 CARDS PRESENT, INITIALIZE TO READ PLOAD DATA FROM SCR2
C     INSTEAD OF GEOM3.
C
      IF (NOPLD2 .EQ. 0) GO TO 40
      FILE = SCR2
      CALL OPEN (*570,SCR2,Z(BUF1),RDREW)
      GO TO 60
   40 FIRST = 0
   50 FILE  = GEOM3
      CALL OPEN   (*570,GEOM3,Z(BUF1),RDREW)
      CALL FWDREC (*580,GEOM3)
C
C     READ 3-WORD RECORD ID. IF ID BELONGS TO LOAD SET, TURN NOLOAD FLAG
C     OFF.
C     SET 1ST WORD IN STATUS ENTRY TO CURRENT POINTER IN LIST TABLE.
C     SET PARAMETERS FOR CONVERSION OF GRID NOS. TO INTERNAL INDICES.
C
   60 CALL READ (*170,*60,FILE,BUF,3,0,FLAG)
      DO 70 I = 1,NTYPES,2
      IF (BUF(1).EQ.CARDID(I) .AND. BUF(2).EQ.CARDID(I+1)) GO TO 90
   70 CONTINUE
   80 CALL FWDREC (*170,FILE)
      GO TO 60
   90 NOLOAD = 1
      IF (FIRST .EQ. 1) GO TO 100
C
C     IF I POINTS TO PLOAD RECORD AND PLOAD2 CARDS ARE PRESENT, THEN
C     PLOAD DATA IS ALREADY PROCESSED. IN THIS CASE, SKIP PLOAD RECORD.
C     IF I POINTS TO PLOAD3 RECORD ON GEOM3, SKIP RECORD.
C
      IF (I.EQ.IPLOAD .AND. NOPLD2.NE.0 .AND. NOPLD2.NE.2) GO TO 80
      IF (I .EQ. IPLD3) GO TO 80
  100 CONTINUE
      STATUS(I) = KLIST - ILIST + 1
      NWDS  = CARDDT(I)
      NWDS1 = NWDS - 1
      JX  = CARDDT(I+1)
      JJ1 = JX + 1
      JJN = JX + MASK(JX)
      ID  = 0
C
C     READ A LOAD CARD. IF SET ID IS DIFFERENT FROM LAST READ (OR 1ST
C     ONE) STORE SET ID IN POINTER LIST AND IN SET LIST. STORE POINTER
C     IN POINTER LIST. IF NOT FIRST CARD OF TYPE, STORE WORD COUNT IN
C     POINTER LIST.
C
  110 CALL READ (*580,*160,FILE,BUF,NWDS,0,FLAG)
      IF (BUF(1) .EQ. ID) GO TO 120
      Z(KLIST  ) = BUF(1)
      Z(KLIST+1) = KTABL
      IF (ID .NE. 0) Z(KLIST-1) = N
      ID = BUF(1)
      N  = 0
      KLIST   = KLIST + 3
      Z(KSET) = BUF(1)
      KSET    = KSET - 1
C
C     CONVERT EXTERNAL GRID NOS. ON CARD TO INTERNAL NOS. INCREMENT
C     WORD COUNT. WRITE LOAD CARD (WITHOUT SET ID) ON SCR1.
C
  120 IF (JX .EQ. 0) GO TO 150
      JJ = JJ1
      JSTOP = 0
  130 IF (JSTOP .EQ. 0) GO TO 135
      JX = JX + 1
      GO TO 136
  135 JX = MASK(JJ)
      IF (JX .GT. 0) GO TO 136
      JX = -JX
      JSTOP = 1
  136 GPOINT = BUF(JX)
      PIEZ = .FALSE.
      IF (GPOINT.LT.0 .AND.  KSYSTM(78).EQ.1) PIEZ = .TRUE.
      IF (PIEZ) GPOINT = -GPOINT
      IF (GPOINT.EQ.-1 .AND. (CARDID(I).EQ.3209 .OR. CARDID(I).EQ.3409))
     1    GO TO 140
      IF (GPOINT .NE. 0) GO TO 450
  140 IF (PIEZ) GPOINT = -GPOINT
      BUF(JX) = GPOINT
      JJ = JJ + 1
      IF (JJ .LE. JJN) GO TO 130
C
C     CHECK FOR PLOAD4 CARD
C
  150 IF (I .NE. 49) GO TO 152
C
C     CHECK FOR THRU OPTION ON PLOAD4 CARD
C
      IF (BUF(7) .EQ. 0) GO TO 153
C
  152 CALL WRITE (SCR1,BUF(2),NWDS1,0)
      GO TO 158
C
C     PROCESS PLOAD4 DATA FOR ALL ELEMENT IDS IMPLIED BY THE THRU OPTION
C
  153 III = BUF(2)
      JJJ = BUF(8)
      BUF(7) =-1
      BUF(8) = 0
      DO 155 KKK = III,JJJ
      BUF(2) = KKK
      CALL WRITE (SCR1,BUF(2),NWDS1,0)
      N = N + NWDS1
      KTABL = KTABL + NWDS1
  155 CONTINUE
      GO TO 110
C
  158 N = N + NWDS1
      KTABL = KTABL + NWDS1
      GO TO 110
C
C     HERE WHEN ALL CARDS OF CURRENT CARD TYPE HAVE BEEN READ.
C     STORE WORD COUNT FOR LAST SET IN POINTER LIST. STORE POINTER
C     TO LAST ENTRY FOR CARD TYPE IN 2ND WORD OF STATUS ENTRY.
C     LOOP BACK TO READ NEXT CARD TYPE.
C
  160 Z(KLIST-1) = N
      STATUS(I+1) = KLIST - ILIST - 2
      GO TO 60
  170 IF (FIRST .EQ. 0) GO TO 175
      FIRST = 0
      CALL CLOSE (SCR2,CLSREW)
      GO TO 50
C
C     HERE WHEN END-OF-FILE ON GEOM3 ENCOUNTERED. IF ERROR CONDITION
C     NOTED, CALL PEXIT. IF NO LOAD CARDS FOUND, CLOSE FILES AND RETURN.
C
  175 IF (NOGO .NE. 0) CALL MESAGE (-61,0,0)
      IF (NOLOAD .NE. -1) GO TO 180
      CALL CLOSE (GEOM3,CLSREW)
      CALL CLOSE (SCR1,CLSREW)
      RETURN
C
C     IF GRAVITY LOADS WERE READ, TURN NOGRAV FLAG OFF.
C     CLOSE FILES AND MOVE POINTER LIST TO BEGINNING OF CORE.
C
  180 IF (STATUS(IGRAV).GT.0 .OR. STATUS(IRFRC).GT.0) NOGRAV = +1
      CALL WRITE (SCR1,0,0,1)
      CALL CLOSE (GEOM3,CLSREW)
      CALL CLOSE (SCR1, CLSREW)
      N = KLIST - ILIST
      DO 190 I = 1,N
      K = ILIST + I
  190 Z(I)  = Z(K-1)
      ILIST = 1
      NLIST = N - 2
C
C     CHECK UNIQUENESS OF LOAD SETS WITTH RESPECT TO GRAVITY LOAD SETS
C
      IF (STATUS(IGRAV) .LT. 0) GO TO 200
      K1 = STATUS(IGRAV  )
      K2 = STATUS(IGRAV+1)
      DO 194 I = ILIST,NLIST,3
      IF (I.GE.K1 .AND. I.LE.K2) GO TO 194
      SETID = Z(I)
      DO 193 K = K1,K2,3
      IF (Z(K) .NE. SETID) GO TO 193
      NOGO = 1
      CALL MESAGE (30,134,SETID)
  193 CONTINUE
  194 CONTINUE
C
C     SORT THE SET LIST AND DISCARD DUPLICATE SET NOS.
C
  200 N = ISET - KSET
      KSET = KSET + 1
      CALL SORT (0,0,1,1,Z(KSET),N)
      Z(ISET+1) = 0
      K = NLIST + 3
      DO 210 I = KSET,ISET
      IF (Z(I) .EQ. Z(I+1)) GO TO 210
      Z(K) = Z(I)
      K = K + 1
  210 CONTINUE
      ISET  = NLIST + 3
      NSET  = K - 1
      ITABL = NSET
C
C     OPEN SCRATCH FILE AND SLT FILE.
C     WRITE SET LIST IN HEADER RECORD OF THE SLT.
C
      CALL OPEN (*570,SCR1,Z(BUF1),RDREW)
      FILE = SLT
      CALL OPEN (*570,SLT,Z(BUF2),WRTREW)
      CALL FNAME (SLT,BUF)
      CALL WRITE (SLT,BUF,2,0)
      N = NSET - ISET + 1
      CALL WRITE (SLT,Z(ISET),N,1)
C
C     IF ALL LOAD CARDS WILL FIT IN CORE, READ THEM IN.
C
      NWDS  = KTABL - 1
      NCORE = ITABL + KTABL
      IF (NCORE .GE. BUF2) GO TO 370
      FILE  = SCR1
      CALL READ (*580,*590,SCR1,Z(ITABL+1),NWDS,1,FLAG)
      CALL CLOSE (SCR1,CLSREW)
C
C     FOR EACH LOAD SET IN THE SET LIST, LOOP THRU THE STATUS TABLE.
C     FOR EACH CARD TYPE PRESENT IN THE STATUS TABLE, PICK UP POINTERS
C     TO THE POINTER LIST. SEARCH THE POINTER LIST FOR A SET ID MATCH.
C     IF FOUND, PICK UP POINTERS TO THE DATA IN CORE. SORT THE DATA ON
C     INTERNAL INDEX (EXCEPT GRAV AND PLOAD CARDS).
C     THEN, WRITE CARD TYPE ID, NO. OF CARDS IN THE SET, AND THE DATA
C     ON THE CARDS. THUS, THE SLT IS COMPRISED OF ONE LOGICAL RECORD PER
C     SET DATA WITHIN EACH RECORD IS GROUPED BY CARD TYPE, AND, WITHIN
C     THE GROUP, IS SORTED BY INTERNAL INDEX (WHERE DEFINED).
C
      DO 280 K = ISET,NSET
      SETID = Z(K)
      II = 1
      DO 270 I = 1,NTYPES,2
      IF (STATUS(I) .LT. 0) GO TO 270
      JJ1 = STATUS(I  )
      JJN = STATUS(I+1)
      DO 250 JJ = JJ1,JJN,3
      IF (Z(JJ) .EQ. SETID) GO TO 260
  250 CONTINUE
      GO TO 270
C
  260 CONTINUE
      JX   = ITABL + Z(JJ+1)
      NWDS = Z(JJ+2)
      N    = CARDDT(I) - 1
      NKEY = 1
      IF (IDNO(II) .EQ. 20) NKEY = 5
      IF (IDNO(II) .EQ. 21) GO TO 265
      IF (IDNO(II).GE.22 .AND. IDNO(II).LE.24) GO TO 265
      IF (I.EQ.IPLOAD .OR. I.EQ.IPLD3 .OR. I.EQ.IGRAV) GO TO 265
      CALL SORT (0,0,N,NKEY,Z(JX),NWDS)
  265 BUF(1) = IDNO(II)
      BUF(2) = NWDS/N
      CALL WRITE (SLT,BUF,2,0)
      CALL WRITE (SLT,Z(JX),NWDS,0)
  270 II = II + 1
  280 CALL WRITE (SLT,0,0,1)
C
C     IF COMBINATION LOADS ARE PRESENT, SET IDS ARE CHECKED TO ASSURE
C     THAT THEY ARE UNIQUE WITH RESPECT TO LOAD CARDS.  THE SET IDS
C     SPECIFIED ON THE LOAD CARD ARE THEN CHECKED AGAINST THOSE IN THE
C     SET LIST TO VERIFY THAT ALL ARE AVAILABLE AND AGAINST EACH OTHER
C     TO ENSURE THAT NO DUPLICATE SPECIFICATIONS EXIST.  THE COMBINATION
C     LOADS ARE WRITTEN AS THE LAST LOGICAL RECORD OF THE SLT.
C
  290 FILE = GEOM3
      CALL PRELOC (*570,Z(BUF1),GEOM3)
      CALL LOCATE (*360,Z(BUF1),LOAD,FLAG)
  300 CALL READ   (*580,*350,GEOM3,BUF,2,0,FLAG)
      CALL WRITE  (SLT,BUF,2,0)
      DO 320 I = ISET,NSET
      IF (BUF(1) .EQ. Z(I)) GO TO 330
  320 CONTINUE
      GO TO 340
  330 NOGO = 1
      CALL MESAGE (30,106,BUF)
  340 LSET = NSET + 1
      MSET = NSET
      IDCMLD = BUF(1)
  341 CALL READ (*580,*350,GEOM3,BUF,2,0,FLAG)
      CALL WRITE (SLT,BUF,2,0)
      IF (BUF(1) .EQ. -1) GO TO 300
      DO 342 I = ISET,NSET
      IF (BUF(2) .EQ. Z(I)) GO TO 343
  342 CONTINUE
      NOGO = 1
      WRITE  (IPTR,3178) UFM,BUF(2),IDCMLD
 3178 FORMAT (A23,' 3178, LOAD SET',I9,' NOT FOUND.  REQUIRED FOR ',
     1        'DEFINITION OF COMBINATION LOAD',I9)
      LINES = LINES + 2
      IF (LINES .GE. NLPP) CALL PAGE
      GO TO 341
  343 IF (MSET .EQ. NSET) GO TO 345
      DO 344 I = LSET,MSET
      IF (BUF(2) .EQ. Z(I)) GO TO 346
  344 CONTINUE
  345 MSET = MSET + 1
      Z(MSET) = BUF(2)
      GO TO 341
  346 NOGO = 1
      WRITE  (IPTR,3179) UFM,BUF(2),IDCMLD
 3179 FORMAT (A23,' 3179, DUPLICATE LOAD SET',I9,' FOUND IN DEFINITION',
     1       ' OF COMBINATION LOAD',I9)
      LINES = LINES + 2
      IF (LINES .GE. NLPP) CALL PAGE
      GO TO 341
  350 CALL WRITE (SLT,0,0,1)
  360 CALL CLOSE (GEOM3,CLSREW)
      CALL CLOSE (SLT,CLSREW)
      BUF(1) = SLT
      BUF(2) = NSET - ISET + 1
      DO 361 I = 3,7
  361 BUF(I) = 0
      CALL WRTTRL (BUF)
      IF (NOGO .NE. 0) CALL MESAGE (-61,0,0)
      RETURN
C
C     HERE IF CORE WILL NOT HOLD ALL LOAD CARDS.
C     CODE IS SIMILAR TO THAT ABOVE EXCEPT THAT POINTER LIST NOW POINTS
C     TO THE DATA ON THE SCRATCH FILE INSTEAD OF IN CORE. THEREFORE, THE
C     SCRATCH FILE WILL HAVE TO BE PASSED ONCE FOR EACH SET IN THE SET
C     LIST.
C
  370 FILE  = SCR1
      DO 430 K = ISET,NSET
      SETID = Z(K)
      II    = 1
      NREAD = 0
      DO 420 I = 1,NTYPES,2
      IF (STATUS(I) .LT. 0) GO TO 420
      JJ1 = STATUS(I  )
      JJN = STATUS(I+1)
      DO 380 JJ = JJ1,JJN,3
      IF (Z(JJ) .EQ. SETID) GO TO 390
  380 CONTINUE
      GO TO 420
  390 NSKIP = Z(JJ+1) - NREAD - 1
      NWDS  = Z(JJ+2)
      N = CARDDT(I) - 1
      IF (NSKIP) 440,410,400
  400 CALL READ (*580,*590,SCR1,0,-NSKIP,0,FLAG)
  410 CALL READ (*580,*590,SCR1,Z(ITABL+1),NWDS,0,FLAG)
      NREAD = Z(JJ+1) + NWDS - 1
      NKEY  = 1
      IF (IDNO(II) .EQ. 20) NKEY = 5
      IF (IDNO(II) .EQ. 21) GO TO 415
      IF (IDNO(II).GE.22 .AND. IDNO(II).LE.24) GO TO 415
      IF (I.EQ.IPLOAD .OR. I.EQ.IPLD3 .OR. I.EQ.IGRAV) GO TO 415
      CALL SORT (0,0,N,NKEY,Z(ITABL+1),NWDS)
  415 BUF(1) = IDNO(II)
      BUF(2) = NWDS/N
      CALL WRITE (SLT,BUF,2,0)
      CALL WRITE (SLT,Z(ITABL+1),NWDS,0)
  420 II = II + 1
      CALL WRITE (SLT,0,0,1)
  430 CALL REWIND (SCR1)
      CALL CLOSE (SCR1,CLSREW)
      GO TO 290
  440 CALL MESAGE (-61,0,0)
C
C     BINARY SEARCH ROUTINE
C
  450 KLO = 1
      KHI = KN
  460 K = (KLO+KHI+1)/2
  470 IF (GPOINT-Z(2*K-1)) 480,540,490
  480 KHI = K
      GO TO 500
  490 KLO = K
  500 IF (KHI-KLO-1) 550,510,460
  510 IF (K .EQ. KLO) GO TO 520
      K = KLO
      GO TO 530
  520 K = KHI
  530 KLO = KHI
      GO TO 470
  540 GPOINT = Z(2*K)
      GO TO 140
  550 BUF(2) = GPOINT
      NOGO   = 1
      CALL MESAGE (30,8,BUF)
      GO TO 140
C
C     FATAL FILE ERRORS
C
  560 CALL MESAGE (N,FILE,NAM)
  570 N = -1
      GO TO 560
  580 N = -2
      GO TO 560
  590 N = -3
      GO TO 560
      END

      SUBROUTINE KELBOW
C
C     THIS ROUTINE COMPUTES THE TWO 6 X 6 MATRICES K(NPVT,NPVT) AND
C     K(NPVT,J) FOR A CURVED BAR ELEMENT HAVING END POINTS NUMBERED
C     NPVT AND J
C
C                   ECPT FOR THE ELBOW
C
C     ECPT( 1)  -  IELID         ELEMENT ID. NUMBER
C     ECPT( 2)  -  ISILNO(2)     * SCALAR INDEX NOS. OF THE GRID POINTS
C     ECPT( 3)  -    ...         *
C     ECPT( 4)  -  SMALLV(3)     $ REFERENCE VECTOR
C     ECPT( 5)  -    ...         $
C     ECPT( 6)  -    ...         $
C     ECPT( 7)  -  ICSSV         COOR. SYS. ID FOR SMALLV VECTOR
C     ECPT( 8)  -  IMATID        MATERIAL ID.
C     ECPT( 9)  -  A             CROSS-SECTIONAL AREA
C     ECPT(10)  -  I1            $ AREA MOMENTS OF INERTIA
C     ECPT(11)  -  I2            $
C     ECPT(12)  -  FJ            TORSIONAL CONSTANT
C     ECPT(13)  -  NSM           NON-STRUCTURAL MASS
C     ECPT(14)  -  FE            FORCE ELEM. DESCRIPTIONS, FORCE METHOD
C     ECPT(15)  -  R1            *STRESS RECOVERY COEFFICIENTS
C     ECPT(16)  -  T1            *  RI = RADIAL  LOCATION
C     ECPT(17)  -  R2            *  TI = ANGULAR LOCATION
C     ECPT(18)  -  T2            *       OF STRESS RECOVERY POINTS
C     ECPT(19)  -  R3            *
C     ECPT(20)  -  T3            *
C     ECPT(21)  -  R4            *
C     ECPT(22)  -  T4            *
C     ECPT(23)  -  K1            $  AREA FACTOR FOR SHEAR
C     ECPT(24)  -  K2            $
C     ECPT(25)  -  C             STRESS INTENSIFICATION FACTOR
C     ECPT(26)  -  KX            *  FLEXIBILITY CORRECTION FACTORS
C     ECPT(27)  -  KY            *
C     ECPT(28)  -  KZ            *
C     ECPT(29)  -  R             RADIUS OF CURVATURE
C     ECPT(30)  -  BETAR         ANGLE FROM GA TO GB
C     ECPT(31)  -  MCSIDA        COORD. SYS. ID. FOR GRID POINT A
C     ECPT(32)  -  GPA(3)        *  BASIC COORD. FOR GRID POINT A
C     ECPT(33)  -   ...          *
C     ECPT(34)  -   ...          *
C     ECPT(35)  -  MCSIDB        COORD. SYS. ID. FOR GRID POINT B
C     ECPT(36)  -  GPB(3)        *  BASIC COORD. FOR GRID POINT B
C     ECPT(37)  -   ...          *
C     ECPT(38)  -   ...          *
C     ECPT(39)  -  ELTEMP        AVG. ELEMENT TEMPERATURE
C
C     COMMENTS FROM G.CHAN/UNISYS   7/91
C     ABOUT K1 AND K2, THE AREA FACTORS FOR SHEAR
C
C     THE K1,K2 FOR BAR ARE 0. TO 1.0, AND ARE USED IN K1*G*A AND K2*G*A
C         THE K1,K2 ARE THEREFORE CORRECTION FACTORS FOR STIFFNESS
C     THE K1,K2 ARE USED IN ELBOW IN K1/G*A AND K2/G*A. AND THEREFORE
C         THE K1,K2 ARE COORECTION FACTORS FOR FLEXIBILITY. THE K1,K2
C         IN ELBOW ARE EQUIVALENT TO 1./K1 AND 1./K2 IN BAR ELEMENT.
C         THE PROPER VALUE FOR K1 AND K2 SHOULD BE INFINITY TO 1.0
C
C     IN 1992 COSMIC/NASTRAN, THE USE OF K1 AND K2 IN ELBOW AND BAR
C     ELMENTS ARE SYMCHRONIZED, WITH PROPER VALUES FROM 0. TO 1.0
C     THE K1 AND K2 ARE CHANGED TO 1./K1 AND 1./K2 IN ELBOW ELEMENT
C     SHEAR COMPUTATION. THAT IS, CORRECTION FACTORS FOR STIFFNESS IS
C     USED.
C
C     REFERENCE -  R.J. ROARK: FORMULAS FOR STRESS AND STRAIN,
C     SECTION 35, 'BEAMS FOR RELATIVELY GREAT DEPTH',
C     FOR BEAMS OF SAMLL SPAN/DEPTH RATIO
C
C     K = 1/F = 5/6 FOR RECTANGULAR SECTION
C             = 0.9 FOR SOLID CIRCULAR
C             = 0.5 FOR THIN-WALLED HOOLOW CIRCULAR SECTION
C             = 1.0 CAN BE USED FOR I-BEAM
C
C
C
      LOGICAL          HEAT,ABASIC,BBASIC,BASIC
      REAL             K1,K2,I1,I2,NSM,KX,KY,KZ
      DOUBLE PRECISION TA(18),TB(9),SMALV0(6),DELA,DELB,KE,KEP,VECI,
     1                 VECJ,VECK,FL,FLL,DF(6,6),DETERM,H(6,6),DP(16),
     2                 S(12,12),DAMPC,KEE(12,12)
      DIMENSION        VECI(3),VECJ(3),VECK(3),ECPT(100),IECPT(100),
     1                 IZ(1),IWORK(6,3),F(6,6)
      COMMON /SMA1IO/  IFCSTM,IFMPT,IFDIT,IDUM1,IFECPT,IGECPT,IFGPCT,
     1                 IGGPCT,IFGEI,IGGEI,IFKGG,IGKGG,IF4GG,IG4GG,
     2                 IFGPST,IGGPST,INRW,OUTRW,CLSNRW,CLSRW,NEOR,
     3                 EOR,MCBKGG(7),MCB4GG(7)
      COMMON /ZZZZZZ/  Z(1)
      COMMON /SMA1BK/  ICSTM,NCSTM,IGPCT,NGPCT,IPOINT,NPOINT,I6X6K,
     1                 N6X6K,I6X64,N6X64
      COMMON /SMA1CL/  IOPT4,K4GGSW,NPVT,LEFT,FROWIC,LROWIC,NROWSC,
     1                 TNROWS,JMAX,NLINKS,LINK(10),IDETCK,DODET,NOGO
      COMMON /SMA1HT/  HEAT
      COMMON /SMA1ET/  IELID,ISILNO(2),SMALLV(3),ICSSV,IMATID,A,I1,I2,
     1                 FJ,NSM,FE,C1,C2,D1,D2,F1,F2,G1,G2,K1,K2,C,KX,KY,
     2                 KZ,R,BETAR,MCSIDA,GPA(3),MCSIDB,GPB(3),TEMPEL
      COMMON /SMA1DP/  KE(144),KEP(144),DELA(6),DELB(6)
      COMMON /MATIN /  MATIDC,MATFLG,ELTEMP,STRESS,SINTH,COSTH
      COMMON /MATOUT/  E,G,NU,RHO,ALPHA,TSUBO,GSUBE,SIGT,SIGC,SIGS
      COMMON /HMTOUT/  FK
      COMMON /SYSTEM/  SYSBUF,NOUT
      EQUIVALENCE      (IELID,ECPT(1),IECPT(1)),(IZ(1),Z(1)),
     1                 (TA(10),TB(1)),(ECPT(71),DP(1)),
     2                 (KEE(1,1),KE(1),S(1,1))
      DATA    DCR   /  .017453292 /
C
      SID(X) = SIN(X*DCR)
      COD(X) = COS(X*DCR)
      DTR(X) = X*DCR
C
C     DETERMINE WHICH POINT IS THE PIVOT POINT.
C
      X    = 1.
      IPVT = 1
      IF (ISILNO(1) .EQ. NPVT) GO TO 20
      IPVT = 2
      IF (ISILNO(2) .NE. NPVT) CALL MESAGE (-30,34,IECPT(1))
C
C     SET UP POINTERS TO COORD. SYSTEM IDS
C
   20 JCSIDA = 31
      JCSIDB = 35
      ICSIDA = IECPT(31)
      ICSIDB = IECPT(35)
C
C     DEFINE LOCATION OF END A, END B IN TERMS OF DP(1) THRU DP(6)
C
      DP(1) = ECPT(JCSIDA+1)
      DP(2) = ECPT(JCSIDA+2)
      DP(3) = ECPT(JCSIDA+3)
      DP(4) = ECPT(JCSIDB+1)
      DP(5) = ECPT(JCSIDB+2)
      DP(6) = ECPT(JCSIDB+3)
C
C     DEFINE COMPONENTS OF VECTOR FROM END A TO CENTER OF CURVATURE,C
C
      DP(7) = ECPT(4)
      DP(8) = ECPT(5)
      DP(9) = ECPT(6)
      FLD   = DSQRT(DP(7)**2 + DP(8)**2 + DP(9)**2)
      IF (FLD .LE. 0.000) GO TO 1010
      DP(7) = DP(7)/FLD
      DP(8) = DP(8)/FLD
      DP(9) = DP(9)/FLD
C
C     DETERMINE IF POINT A AND B ARE IN BASIC COORDINATES
C
      ABASIC =.TRUE.
      BBASIC =.TRUE.
      IF (ICSIDA .NE. 0) ABASIC =.FALSE.
      IF (ICSIDB .NE. 0) BBASIC =.FALSE.
C
C     COMPUTE THE TRANSFORMATION MATRICES TA AND TB IF NECESSARY
C
      IF (ABASIC) GO TO 30
      CALL TRANSD (ECPT(JCSIDA),TA)
      CALL GMMATD (TA,3,3,0, DP(7),3,1,0, VECJ)
      CALL GMMATD (TA,3,3,0, DP(1),3,1,0, DP(14))
      DP(1) = DP(14)
      DP(2) = DP(15)
      DP(3) = DP(16)
      GO TO 35
   30 CONTINUE
      VECJ(1) = DP(7)
      VECJ(2) = DP(8)
      VECJ(3) = DP(9)
   35 IF (BBASIC) GO TO 40
      CALL TRANSD (ECPT(JCSIDB),TB)
      CALL GMMATD (TB,3,3,0, DP(4),3,1,0, DP(14))
      DP(4) = DP(14)
      DP(5) = DP(15)
      DP(6) = DP(16)
   40 CONTINUE
C
C     CALCULATE TRUE LENGTH OF ELBOW
C
      FL = DBLE(R*DTR(BETAR))
      IF (FL .EQ. 0.0D0) GO TO 1010
C
C     NOW THAT LENGTH HAS BEEN COMPUTED, BRANCH IF THIS IS A -HEAT-
C     FORMULATION.
C
      IF (HEAT) GO TO 2000
C
C     CONSTRUCT VECTOR FROM A TO B
C
      SMALV0(1) = DP(4) - DP(1)
      SMALV0(2) = DP(5) - DP(2)
      SMALV0(3) = DP(6) - DP(3)
      FLL = DSQRT(SMALV0(1)**2 + SMALV0(2)**2 + SMALV0(3)**2)
      IF (FLL .EQ. 0.0D0) GO TO 1010
      SMALV0(1) = SMALV0(1)/FLL
      SMALV0(2) = SMALV0(2)/FLL
      SMALV0(3) = SMALV0(3)/FLL
C
C     COMPUTE THE K VECTOR VECK = SMALV0 X VECJ
C
      VECK(1) = SMALV0(2)*VECJ(3) - SMALV0(3)*VECJ(2)
      VECK(2) = SMALV0(3)*VECJ(1) - SMALV0(1)*VECJ(3)
      VECK(3) = SMALV0(1)*VECJ(2) - SMALV0(2)*VECJ(1)
      FLL = DSQRT(VECK(1)**2 + VECK(2)**2 + VECK(3)**2)
      IF (FLL .EQ. 0.0D0) GOTO 1010
      VECK(1) = VECK(1)/FLL
      VECK(2) = VECK(2)/FLL
      VECK(3) = VECK(3)/FLL
C
C     COMPUTE THE I VECTOR  VECI = VECJ X VECK
C
      VECI(1) = VECJ(2)*VECK(3) - VECJ(3)*VECK(2)
      VECI(2) = VECJ(3)*VECK(1) - VECJ(1)*VECK(3)
      VECI(3) = VECJ(1)*VECK(2) - VECJ(2)*VECK(1)
      FLL = DSQRT(VECI(1)**2 + VECI(2)**2 + VECI(3)**2)
      IF (FLL .EQ. 0.0D0) GO TO 1010
      VECI(1) = VECI(1)/FLL
      VECI(2) = VECI(2)/FLL
      VECI(3) = VECI(3)/FLL
C
C     SEARCH THE MATERIAL PROPERTIES TABLE FOR E,G AND THE DAMPING
C     CONSTANT.
C
      MATIDC = IMATID
      MATFLG = 1
      ELTEMP = TEMPEL
      CALL MAT (IECPT(1))
      DAMPC = G SUB E
C
C     SET UP INTERMEDIATE VARIABLES FOR ELEMENT STIFFNESS MATRIX
C     CALCULATION
C
      IF (KX .LT. 1.0E-8) KX = 1.0
      IF (KY .LT. 1.0E-8) KY = 1.0
      IF (KZ .LT. 1.0E-8) KZ = 1.0
      FI1 = I1/KZ
      FI2 = I2/KY
      FJK = FJ/KX
C
C     AREA FACTORS FOR SHEAR ARE FROM NEAR ZERO TO ONE
C
      IF (K1 .LT. 1.0E-8) K1 = 1.0
      IF (K2 .LT. 1.0E-8) K2 = 1.0
      IF (K1 .GT. 1.0) K1 = 1.0/K1
      IF (K2 .GT. 1.0) K2 = 1.0/K2
C
C     THE FOLLOWING CODE WAS TAKEN FROM SAP4 BENDKS ROUTINE
C     FOR A CURVED PIPE ELEMENT
C
C     COMPUTE SECTION PROPERTY CONSTANTS
C
      T   = DTR(BETAR)
      RA  = R/(A*E)
      RV1 = R/(2.*K1*G*A)
      RV2 = K1/K2*RV1
      RT  = R/(G*FJK*2.)
      RB0 = R/(E*FI2*2.)
      RB1 = R/(E*FI1)
      R2  = R**2
C
C     COMPUTE COMMON TRIGONOMETRIC CONSTANTS
C
      ST  = SID(BETAR)
      CT  = COD(BETAR)
      S2T = SID(2.0*BETAR)
      C2T = COD(2.0*BETAR)
C
C     FORM THE NODE FLEXIBILITY MATRIX AT NODE J REFERENCED TO THE
C     LOCAL (X,Y,Z) COORDINATE SYSTEM AT NODE I.
C
C     X - DIRECTION...  IN-PLANE TANGENT TO THE BEND AT NODE I AND
C                       DIRECTED TOWARD NODE J
C     Y - DIRECTION...  IN-PLANE AND DIRECTED RADIALLY INWARD TO THE
C                       CENTER OF CURVATURE
C     Z - DIRECTION...  OUT OF PLANE AND ORTHOGONAL TO X AND Y
C
      DO 50 I = 1,6
      DO 50 K = I,6
      F(I,K)  = 0.0
   50 CONTINUE
C
C     A X I A L
C
      F(1,1) = F(1,1) + 0.25*RA*(2.0*T+S2T)
      F(2,2) = F(2,2) + 0.25*RA*(2.0*T-S2T)
C
C     N O T E   (COEFFICIENT CHANGE)
C
      F(1,2) = F(1,2) + 0.50*RA*ST**2
C
C     S H E A R
C
      F(1,1) = F(1,1) + 0.5*RV1*(2.0*T-S2T)
      F(2,2) = F(2,2) + 0.5*RV1*(2.0*T+S2T)
      F(3,3) = F(3,3) + 2.0*RV2* T
C
C     N O T E   (SIGN CHANGE)
C
      F(1,2) = F(1,2) - RV1*ST**2
C
C     T O R S I O N
C
      F(3,3) = F(3,3) + 0.5*RT*R2*(6.0*T+S2T-8.0*ST)
      F(4,4) = F(4,4) + 0.5*RT*   (2.0*T+S2T)
      F(5,5) = F(5,5) + 0.5*RT*   (2.0*T-S2T)
      F(3,4) = F(3,4) +     RT*R *(ST-T*CT)
      F(3,5) = F(3,5) +     RT*R *(2.0-2.0*CT-T*ST)
      F(4,5) = F(4,5) + 0.5*RT*   (1.0-C2T)
C
C     B E N D I N G
C
      F(1,1) = F(1,1) + 0.25*RB1*R2*(2.0*T*(2.0+C2T)-3.0*S2T)
      F(2,2) = F(2,2) + 0.25*RB1*R2*(2.0*T*(2.0-C2T)+3.0*S2T-8.0*ST)
      F(3,3) = F(3,3) + 0.50*RB0*R2*(2.0*T-S2T)
      F(4,4) = F(4,4) + 0.50*RB0*   (2.0*T-S2T)
      F(5,5) = F(5,5) + 0.50*RB0*   (2.0*T+S2T)
      F(6,6) = F(6,6) +      RB1*T
      F(1,2) = F(1,2) + 0.25*RB1*R2*(1.0+3.0*C2T+2.0*T*S2T-4.0*CT)
      F(1,6) = F(1,6) -      RB1*R *(ST-T*CT)
      F(2,6) = F(2,6) +      RB1*R *(T*ST+CT-1.0)
      F(3,4) = F(3,4) +      RB0*R *(ST-T*CT)
      F(3,5) = F(3,5) -      RB0*R *T*ST
      F(4,5) = F(4,5) - 0.50*RB0*   (1.0-C2T)
C
C
C     FORM SYMMETRICAL UPPER PART OF FLEX MATRIX
C
      DO 65 I = 1,6
      DO 65 K = I,6
      DF(K,I) = DBLE(F(I,K))
      DF(I,K) = DF(K,I)
   65 CONTINUE
C
C     WRITE (6,4005) DF
C
C     INVERT FLEX TO FORM STIFFNESS
C
      CALL INVERD (6,DF,6,DUM,0,DETERM,ISING,IWORK)
      IF (ISING .EQ. 2) WRITE (6,4002) F
      IF (ISING .EQ. 2) CALL MESAGE (-30,38,ECPT(1))
 4002 FORMAT (1X,34HELBOW STIFFNESS MATRIX IS SINGULAR, /,(5X,6E13.5))
C
C
C     SET UP THE FORCE TRANSFORMATION RELATING REACTIONS AT NODE I
C     ACTING ON THE MEMBER END DUE TO UNIT LOADS APPLIED TO THE MEMBER
C     END AT NODE J.
C
      DO 100 I = 1,6
      DO 100 K = 1,6
      H(I,K) = 0.0D0
  100 CONTINUE
C
      DO 105 K = 1,6
      H(K,K) =-1.0D0
  105 CONTINUE
C
      H(4,3) =-DBLE(R*(1.0-CT))
      H(5,3) = DBLE(R*ST)
      H(6,1) =-H(4,3)
      H(6,2) =-H(5,3)
C
C     FORM THE UPPER TRIANGULAR PORTION OF THE LOCAL ELEMENT STIFFNESS
C     MATRIX FOR THE BEND
C
      DO 110 K = 1,6
      DO 110 I = K,6
      S(K+6,I+6) = DF(K,I)
  110 CONTINUE
C
      DO 130 IR = 1,6
      DO 130 IC = 1,6
      S(IR,IC+6) = 0.0D0
      DO 120 IN = 1,6
      S(IR,IC+6) = S(IR,IC+6) + H(IR,IN)*DF(IN,IC)
  120 CONTINUE
  130 CONTINUE
C
      DO 150 IR = 1,6
      DO 150 IC = IR,6
      S(IR,IC)  = 0.0D0
      DO 140 IN = 1,6
      S(IR,IC) = S(IR,IC) + S(IR,IN+6)*H(IC,IN)
  140 CONTINUE
  150 CONTINUE
C
C     REFLECT FOR SYMMETRY
C
      DO 165 I = 1,12
      DO 165 K = I,12
      S(K,I)   = S(I,K)
  165 CONTINUE
C
      J = 0
      IF (IPVT .EQ. 2) GO TO 327
      ILOW = 1
      ILIM = 72
      GO TO 329
  327 ILOW = 73
      ILIM = 144
  329 DO 340 I = ILOW,ILIM,12
      LOW = I
      LIM = LOW + 5
      DO 330 K = LOW,LIM
      J = J + 1
      KEP(J) = KE(K)
  330 KEP(J+36) = KE(K+6)
  340 CONTINUE
C
C                                                            T
C     STORE VECI, VECJ, VECK IN KE(1),...,KE(9) FORMING THE A  MATRIX.
C
      KE(1) = VECI(1)
      KE(2) = VECI(2)
      KE(3) = VECI(3)
      KE(4) = VECJ(1)
      KE(5) = VECJ(2)
      KE(6) = VECJ(3)
      KE(7) = VECK(1)
      KE(8) = VECK(2)
      KE(9) = VECK(3)
C
C     ZERO OUT THE ARRAY WHERE THE 3 X 3 MATRIX H AND THE W  AND W
C     6 X 6  MATRICES WILL RESIDE.                         A      B
C
      DO 350 I = 28,108
  350 KE(I) = 0.0D0
      IPASS = 1
      IWBEG = 0
C
C     SET UP POINTERS
C
      IF (IPVT-1) 365,360,365
  360 BASIC  = ABASIC
      JCSID  = JCSIDA
      IKEL   = 1
      INDEX  = ISILNO(1)
      GO TO 368
  365 BASIC  = BBASIC
      JCSID  = JCSIDB
      IKEL   = 37
      INDEX  = ISILNO(2)
C
C     SET UP THE -G- MATRIX.  IG POINTS TO THE BEGINNING OF THE G
C     MATRIX. G = AT X TI
C
  368 IG = 1
      IF (BASIC) GO TO 380
      CALL TRANSD (ECPT(JCSID),KE(10))
      CALL GMMATD (KE(1),3,3,0, KE(10),3,3,0, KE(19))
      IG = 19
C
C     FORM THE W  MATRIX OR THE W  MATRIX IN KE(37) OR KE(73) DEPENDING
C               A                B
C     UPON WHICH POINT - A OR B - IS UNDER CONSIDERATION.  G WILL BE
C     STORED IN THE UPPER LEFT AND LOWER RIGHT CORNERS.  H, IF NON-ZERO,
C     WILL BE STORED IN THE UPPER RIGHT CORNER.
C
  380 KE(IWBEG+37) = KE(IG  )
      KE(IWBEG+38) = KE(IG+1)
      KE(IWBEG+39) = KE(IG+2)
      KE(IWBEG+43) = KE(IG+3)
      KE(IWBEG+44) = KE(IG+4)
      KE(IWBEG+45) = KE(IG+5)
      KE(IWBEG+49) = KE(IG+6)
      KE(IWBEG+50) = KE(IG+7)
      KE(IWBEG+51) = KE(IG+8)
      KE(IWBEG+58) = KE(IG  )
      KE(IWBEG+59) = KE(IG+1)
      KE(IWBEG+60) = KE(IG+2)
      KE(IWBEG+64) = KE(IG+3)
      KE(IWBEG+65) = KE(IG+4)
      KE(IWBEG+66) = KE(IG+5)
      KE(IWBEG+70) = KE(IG+6)
      KE(IWBEG+71) = KE(IG+7)
      KE(IWBEG+72) = KE(IG+8)
C
C                       T      E
C     FORM THE PRODUCT W   X  K   AND STORE IN KEP(73)
C                       NPVT
C
      CALL GMMATD (KE(37),6,6,1, KEP(IKEL),6,6,0, KEP(73))
C
C     COMPUTE THE FINAL ANSWER AND STORE IN KEP(109)
C
      CALL GMMATD (KEP(73),6,6,0, KE(IWBEG+37),6,6,0, KEP(109))
C
C     INSERT THIS 6 X 6
C
      CALL SMA1B (KEP(109),INDEX,-1,IFKGG,0.0D0)
      IF (IOPT4.EQ.0 .OR. GSUBE.EQ.0.0) GO TO 400
      K4GGSW = 1
      CALL SMA1B (KEP(109),INDEX,-1,IF4GG,DAMPC)
C
C     IF IPASS = 2, WE ARE DONE.  OTHERWISE COMPUTE THE OFF-DIAGONAL
C     6 X 6.
C
  400 IF (IPASS .EQ. 2) GO TO 500
      IWBEG = 36
      IPASS = 2
      DO 410 I = 28,36
  410 KE(I) = 0.0D0
      IF (IPVT-1) 360,365,360
  500 RETURN
C
 1010 CALL MESAGE (30,26,IECPT(1))
C
C     SET FLAG FOR FATAL ERROR WHILE ALLOWING ERROR MESSAGES TO
C     ACCUMULATE
C
      NOGO = 1
      RETURN
C
C
C     HEAT FORMULATION CONTINUES HERE.  GET MATERIAL PROPERTY -K- FROM
C     HMAT
C
 2000 MATFLG = 1
      MATIDC = IECPT( 8)
      ELTEMP = ECPT(39)
      CALL HMAT (IELID)
C
      FL = DBLE(FK)*DBLE(ECPT(9))/(DP(9)*DP(10)*DBLE(DCR))
      IF (NPVT .EQ. IECPT(3)) FL = -FL
      DO 2020 I = 1,2
      CALL SMA1B (FL,IECPT(I+1),NPVT,IFKGG,0.0D0)
      FL = -FL
 2020 CONTINUE
      RETURN
      END

      SUBROUTINE COMB2
C
C     COMB2 PERFORMS THE TRANSFORMATION AND ADDITION OF STIFFNESS, MASS,
C     OR LOAD MATRICES FOR THE PHASE 2 SUBSTRUCTURE COMBINE OPERATION
C
C     NOVEMBER 1973
C
C
      LOGICAL           ADDFLG
      INTEGER           TFLAG      ,SIGNAB     ,SIGNC      ,PREC      ,
     1        SCR1     ,SCR2       ,SCR3       ,SCR4       ,SCR5      ,
     2        RULE     ,TYPIN      ,TYPOUT     ,ACOMB      ,AMCB(7,7) ,
     3        HMCB(6,7),SOF1       ,SOF2       ,SOF3       ,DRY       ,
     4        BUF1     ,RDSOF      ,RC         ,USE        ,HORG      ,
     5        PVEC     ,RFILES     ,IZ(1)      ,RECT       ,RSP       ,
     6        NAME(2)  ,RSOFAR     ,KMP(5)     ,TYPE       ,KMPITM(5) ,
     7        BLANK    ,SYSBUF     ,CPV(7)     ,RPV(7)     ,SCR6      ,
     8        XXXX     ,SCR7       ,PORA       ,PAPP
      DOUBLE PRECISION  DBZ(1)
      DIMENSION         MCBTRL(7)
      CHARACTER         UFM*23     ,UWM*25     ,UIM*29     ,SFM*25
      COMMON /XMSSG /   UFM        ,UWM        ,UIM        ,SFM
      COMMON /BLANK /   DRY        ,TYPE(2)    ,PORA(2)    ,NAMESS(2,7),
     1                  ACOMB      ,USE(14)    ,RFILES(3)  ,KK        ,
     2                  KN         ,JN
      COMMON /SYSTEM/   SYSBUF     ,NOUT
      COMMON /NAMES /   RD         ,RDREW      ,WRT        ,WRTREW    ,
     1                  REW        ,NOREW      ,EOFNRW     ,RSP       ,
     2                  RDP        ,CSP        ,CDP        ,SQUARE    ,
     3                  RECT
      COMMON /PACKX /   TYPIN      ,TYPOUT     ,IROW       ,NROW      ,
     1                  INCR
      COMMON /PARMEG/   MCBP(7)    ,MCBP11(7)  ,MCBP21(7)  ,MCBP12(7) ,
     1                  MCBP22(7)  ,MRGZ       ,RULE
      COMMON /MPY3TL/   MCBA2(7)   ,MCBB2(7)   ,MCBC2(7)   ,MCBD2(7)  ,
     1                  SCR5       ,SCR6       ,SCR7       ,LKORE     ,
     2                  ICODE      ,IPREC      ,DUMMY(13)
      COMMON /MPYADX/   MCBA(7)    ,MCBB(7)    ,MCBC(7)    ,MCBD(7)   ,
     1                  LCORE      ,TFLAG      ,SIGNAB     ,SIGNC     ,
     2                  PREC       ,MSCR       ,DUMM
      COMMON /ZZZZZZ/   Z(1)
      EQUIVALENCE      (DBZ(1),Z(1),IZ(1)),(PVEC,KMPITM(3))
      DATA   NAME   /  4HCOMB,4H2   /
      DATA   HORG   /  4HHORG       /
      DATA   BLANK  /  4H           /
      DATA   XXXX   /  4HXXXX       /
      DATA   PAPP   /  4HPAPP       /
      DATA   KMP    /  4HK   , 4HM   , 4HP   , 4HB   , 4HK4   /
      DATA   KMPITM /  4HKMTX, 4HMMTX, 4HPVEC, 4HBMTX, 4HK4MX /
C
C     INITIALIZE
C
      DO 5 I = 1,14
      IF (NAMESS(I,1).EQ.XXXX .OR. NAMESS(I,1).EQ.0) NAMESS(I,1) = BLANK
    5 CONTINUE
      ACOMB = 201
      SCR1  = 301
      SCR2  = 302
      SCR3  = 303
      SCR4  = 304
      SCR5  = 305
      SCR6  = 306
      SCR7  = 307
      SIGNAB= 1
      SIGNC = 1
      PREC  = 0
      MSCR  = SCR5
      ICODE = 0
      RULE  = 0
      RDSOF = 1
      NOGO  = 0
      RFILES(1) = ACOMB
      NSIZE = 0
      MCBP21(1) = 0
      MCBP22(1) = 0
      RSOFAR = 0
      KN = 1
      JN =-1
      DO 10 I = 1,5
      IF (TYPE(1) .EQ. KMP(I)) GO TO 20
   10 CONTINUE
      WRITE (NOUT,6302) SFM,TYPE
      IF (DRY .LT. 0) RETURN
C
      DRY  =-2
      ITEM = 0
      GO TO 30
   20 ITEM = KMPITM(I)
      IF (ITEM .EQ. PVEC) ITEM = PORA(1)
      IF (DRY .LT. 0) RETURN
C
   30 LCORE = KORSZ(Z) - 1
      LKORE = LCORE
      BUF1  = LCORE - SYSBUF + 1
      SOF1  = BUF1  - SYSBUF
      SOF2  = SOF1  - SYSBUF - 1
      SOF3  = SOF2  - SYSBUF
      IF (SOF3 .GT. 0) GO TO 40
      CALL MESAGE (8,0,NAME)
      DRY =-2
      RETURN
C
   40 CALL SOFOPN (Z(SOF1),Z(SOF2),Z(SOF3))
C
C     GRAB THE MATRIX CONTROL BLOCKS
C
      NMAT = 0
      DO 170 I = 1,7
      IF (NAMESS(1,I) .EQ. BLANK) GO TO 170
      AMCB(1,I) = 100 + I
      CALL RDTRL (AMCB(1,I))
      IF (AMCB(1,I) .GT. 0) GO TO 135
C
C     NO GINO FILE.  CHECK SOF
C
      CALL SOFTRL (NAMESS(1,I),ITEM,AMCB(1,I))
      RC = AMCB(1,I)
      GO TO (130,110,115,120,120), RC
  110 NOGO = 1
      WRITE (NOUT,6301) SFM,NAMESS(1,I),NAMESS(2,I),ITEM
      GO TO 170
  115 IF (TYPE(1) .EQ. KMP(3)) GO TO 170
  120 NOGO = 1
      CALL SMSG (RC-2,ITEM,NAMESS(1,I))
      GO TO 170
C
C     MATRIX FOUND ON SOF
C
  130 CONTINUE
      AMCB(1,I) = 0
C
C     GRAB THE MCB OF THE TRANSFORMATION MATRIX
C
  135 CALL SOFTRL (NAMESS(1,I),HORG,MCBTRL)
      RC = MCBTRL(1)
      GO TO (160,140,150,155,155), RC
  140 NOGO = 1
      CALL SMSG (1,HORG,NAMESS(1,I))
      GO TO 170
  150 NOGO = 1
      WRITE (NOUT,6303) SFM,NAMESS(1,I),NAMESS(2,I)
      GO TO 170
  155 NOGO = 1
      CALL SMSG (RC-2,HORG,NAMESS(1,I))
      GO TO 170
  160 DO 161 IT = 1,6
  161 HMCB(IT,I) = MCBTRL(IT+1)
      NMAT = NMAT + 1
      USE(2*NMAT-1) = I
      DEN = FLOAT(AMCB(7,I))/10000.
      USE(2*NMAT) = AMCB(2,I)*AMCB(3,I)*DEN
C
C     CHECK COMPATIBILITY OF DIMENSIONS
C
      IF (NSIZE .EQ. 0) NSIZE = HMCB(1,I)
      IF (HMCB(1,I).EQ.NSIZE .AND. HMCB(2,I).EQ.AMCB(2,I) .AND.
     1    HMCB(2,I).EQ.AMCB(3,I)) GO TO 170
      IF (ITEM.EQ.PVEC .OR. ITEM.EQ.PAPP .AND. HMCB(1,I).EQ.NSIZE .AND.
     1    HMCB(2,I).EQ.AMCB(3,I)) GO TO 170
      NOGO = 1
      WRITE (NOUT,6304) SFM,I,NAMESS(1,I),NAMESS(2,I)
  170 CONTINUE
      IF (NOGO .EQ. 0) GO TO 175
C
  174 DRY =-2
      WRITE  (NOUT,177) AMCB,HMCB
  177 FORMAT ('0*** COMB2 MATRIX TRAILER DUMP',
     1        //7(4X,7I10/), /7(11X,6I10/))
      GO TO 9999
C
  175 IF (NMAT .EQ. 0) GO TO 9999
C
C     DETERMINE PRECISION FOR FINAL MATRIX
C
      IPRC = 1
      ITYP = 0
      DO 176 I = 1,NMAT
      IF (AMCB(5,I).EQ.2 .OR. AMCB(5,I).EQ.4) IPRC = 2
      IF (AMCB(5,I) .GE. 3) ITYP = 2
  176 CONTINUE
      IPREC = ITYP + IPRC
C
      IF (ITEM.EQ.PVEC .OR. ITEM.EQ.PAPP) GO TO 300
C                                               ******
C                                                         *
C     PROCESS STIFFNESS, MASS OR DAMPING MATRICES         *
C                                                         *
C                                               ******
C
C     IF NMAT IS ODD, PUT FIRST RESULT ON ACOMB.  IF EVEN, PUT IT ON
C     SCR4.  FINAL RESULT WILL THEN BE ON ACOMB.
C
      CALL SORT (0,0,2,2,USE,2*NMAT)
      IRF = 1
      IF ((NMAT/2)*2 .EQ. NMAT) IRF = 2
      IFORM = 6
      RFILES(2) = SCR4
      ADDFLG =.FALSE.
C
      DO 230 KK = 1,NMAT
      J  = 2*KK - 1
      JN = JN + 2
      INUSE = USE(JN)
C
C     MOVE TRANSFORMATION MATRIX TO SCR2
C
      CALL MTRXI (SCR2,NAMESS(1,INUSE),HORG,Z(BUF1),RC)
C
C     IF INPUT MATRIX IS ON SOF, MOVE IT TO SCR1
C
      MCBB2(1) = 100 + INUSE
      IF (AMCB(1,INUSE) .GT. 0) GO TO 180
      MCBB2(1) = SCR1
      CALL MTRXI (SCR1,NAMESS(1,INUSE),ITEM,Z(BUF1),RC)
C
C     PERFORM TRIPLE MULTIPLY  H(T)*INPUT*H
C
  180 CALL SOFCLS
      MCBA2(1) = SCR2
      MCBC2(1) = 0
      IF (ADDFLG) MCBC2(1) = RFILES(3-IRF)
      ADDFLG = .TRUE.
      DO 190 J = 2,7
      MCBA2(J) = HMCB(J-1,INUSE)
      MCBB2(J) = AMCB(J,INUSE)
  190 CONTINUE
      IF (MCBB2(4) .LE. 2) IFORM = MCBB2(4)
      CALL MAKMCB (MCBD2,RFILES(IRF),HMCB(1,INUSE),IFORM,IPREC)
C
      CALL MPY3DR (Z)
C
      CALL WRTTRL (MCBD2)
      DO 220 J = 2,7
  220 MCBC2(J) = MCBD2(J)
      IRF = 3 - IRF
      CALL SOFOPN (Z(SOF1),Z(SOF2),Z(SOF3))
  230 CONTINUE
      GO TO 9999
C                                          ******
C                                                    *
C     PROCESS LOAD MATRICES                          *
C                                                    *
C****                                           ******
  300 MCBC(1) = 0
      MCBA(1) = SCR2
      TFLAG   = 1
      MRGZ    = LCORE
      PREC    = 0
C
C     SELECT FIRST RESULT FILE SO THAT FINAL RESULT WILL WIND UP ON
C     ACOMB
C
      RFILES(2) = SCR3
      RFILES(3) = SCR4
      IRF = 1
      IF (NMAT.EQ.2 .OR. NMAT.EQ.5) IRF = 2
      IF (NMAT.EQ.3 .OR. NMAT.EQ.6) IRF = 3
      IF (NMAT .EQ. 1) MCBP(1) = ACOMB
C
C     CREATE COLUMN PARTITIONING VECTOR FOR ALL MERGES
C     (VECTOR IS ALWAYS NULL)
C
      CALL MAKMCB (CPV,SCR6,NSIZE,RECT,RSP)
      TYPIN  = RSP
      TYPOUT = RSP
      IROW = 1
      NROW = 1
      INCR = 1
      CALL GOPEN (SCR6,Z(BUF1),WRTREW)
      CALL PACK  (0,SCR6,CPV)
      CALL CLOSE (SCR6,REW)
      ADDFLG =.TRUE.
C
      DO 400 KK = 1,NMAT
      INUSE = USE(2*KK-1)
C
C     COPY TRANSFORMATION MATRIX TO SCR2
C
      CALL MTRXI (SCR2,NAMESS(1,INUSE),HORG,Z(BUF1),RC)
C
C     IF LOAD MATRIX IS ON SOF, COPY IT TO SCR1
C
      MCBB(1) = 100 + INUSE
      IF (AMCB(1,INUSE) .GT. 0) GO TO 330
      MCBB(1) = SCR1
      CALL MTRXI (SCR1,NAMESS(1,INUSE),ITEM,Z(BUF1),RC)
C
C     MULTIPLY (HT * A) AND STORE RESULT ON RFILES(IRF)
C     (ACOMB,SCR3, OR SCR4)
C
  330 CALL SOFCLS
      DO 340 J = 2,7
      MCBA(J) = HMCB(J-1,INUSE)
      MCBB(J) = AMCB(J,INUSE)
  340 CONTINUE
      IF (MCBB(6).EQ.0 .OR. MCBA(3).EQ.MCBB(3)) GO TO 350
      I = KK
      NOGO = 1
      WRITE (NOUT,6304) SFM,I,NAMESS(1,I),NAMESS(2,I)
      GO TO 174
  350 CALL MAKMCB (MCBD,RFILES(IRF),HMCB(1,INUSE),RECT,IPREC)
C
      CALL MPYAD (Z,Z,Z)
C
      IF (ADDFLG) GO TO 390
C
C     COMPUTE ROW PARTITIONING VECTOR TO MERGE RESULT OF THIS MULTIPLY
C     WITH ALL PREVIOUS RESULTS
C
      K = AMCB(2,INUSE)
      CALL MAKMCB (RPV,SCR5,RSOFAR+K,RECT,RSP)
      IF (K .GT. LCORE) GO TO 9008
      DO 360 J = 1,K
  360 Z(J)  = 1.0E0
      TYPIN = RSP
      TYPOUT= RSP
      IROW  = RSOFAR + 1
      NROW  = RSOFAR + K
      INCR  = 1
      CALL GOPEN (SCR5,Z(BUF1),WRTREW)
      CALL PACK  (Z,SCR5,RPV)
      CALL CLOSE (SCR5,REW)
C
C     MERGE MATRICES   STORE RESULT ON NEXT AVAILABLE RFILE
C
      J = MOD(IRF,3) + 1
      CALL MAKMCB (MCBP,RFILES(J),NSIZE,RECT,IPREC)
      MCBP(2) = RPV(3)
      J = MOD(J,3) + 1
      MCBP11(1) = RFILES(J)
      MCBP12(1) = RFILES(IRF)
      DO 380 J = 2,7
      MCBP11(J) = MCBP(J)
      MCBP12(J) = MCBD(J)
  380 CONTINUE
C
      CALL MERGE (RPV,CPV,Z)
C
      IRF = MOD(IRF,3) + 1
      GO TO 395
  390 DO 391 J = 2,7
  391 MCBP(J) = MCBD(J)
  395 RSOFAR = RSOFAR + AMCB(2,INUSE)
      ADDFLG =.FALSE.
      IRF = MOD(IRF,3) + 1
      CALL SOFOPN (Z(SOF1),Z(SOF2),Z(SOF3))
  400 CONTINUE
      CALL WRTTRL (MCBP)
      GO TO 9999
C
C     DIAGNOSTICS
C
 6301 FORMAT (A25,' 6301, DATA MISSING IN GO MODE FOR SUBSTRUCTURE ',
     1        2A4,' ITEM ',A4)
 6302 FORMAT (A25,' 6302, ',2A4,' IS ILLEGAL MATRIX TYPE FOR MODULE ',
     1        'COMB2')
 6303 FORMAT (A25,' 6303, H OR G TRANSFORMATION MATRIX FOR SUBSTRUCTURE'
     1,       1X,2A4,' CANNOT BE FOUND ON SOF')
 6304 FORMAT (A25,' 6304, MODULE COMB2 INPUT MATRIX NUMBER ',I2,
     1        ' FOR SUBSTRUCTURE ,2A4,28H HAS INCOMPATIBLE DIMENSIONS')
 9008 CALL MESAGE (8,0,NAME)
C
C     NORMAL COMPLETION
C
 9999 CALL SOFCLS
      RETURN
      END

      SUBROUTINE CSUB (X,Y,Z,A,B)
C*******
C     CSUB WILL FORM Z = A*X - B*Y WHERE A AND B ARE SCALAR
C     MULTIPLIERS FOR THE COMPLEX VECTORS X AND Y
C*******
      DOUBLE PRECISION   X(2)      ,Y(2)     ,A(2)     ,B(2)
     1                  ,Z(1)      ,DUM
      COMMON   /CINVPX/  AAA       ,NCOL
      NCOL2 = NCOL+NCOL
      DO 10 I = 1,NCOL2,2
      DUM  = X(I)*A(1) - X(I+1)*A(2) - Y(I)*B(1) + Y(I+1)*B(2)
      Z(I+1) = X(I)*A(2) + X(I+1)*A(1) - Y(I+1)*B(1) - Y(I)*B(2)
   10 Z(I) = DUM
      RETURN
      END

      SUBROUTINE STACK (IDEG,NEW,ILD,IW)
C
C     THIS ROUTINE IS USED ONLY IN BANDIT MODULE
C
C     STACK POINTS OF ZERO DEGREE AT END OF THE NUMBERING.
C     IW IS SCRATCH STORAGE.
C
      DIMENSION       IDEG(1),  NEW(1),   ILD(1),   IW(1)
      COMMON /BANDS / NN
      COMMON /BANDD / DUM(5),   KT
C
      KT  = 0
      NN1 = NN - 1
C
C     LIST POINTS OF ZERO DEGREE AND INCREMENT COUNTER KT.
C
      DO 10 I = 1,NN
      IF (IDEG(I) .GT. 0) GO TO 10
      KT = KT + 1
      IW(KT) = ILD(I)
   10 CONTINUE
      IF (KT .LE. 0) GO TO 80
C
C     SORT LIST OF RENUMBERED NUMBERS TO BE STACKED.
C
      IF (KT .LE. 1) GO TO 40
      KT1 = KT-1
      DO 30 I = 1,KT1
      K = KT - I
      KFLAG = 0
      DO 20 J = 1,K
      J1 = J + 1
      IF (IW(J) .LE. IW(J1))  GO TO 20
      KFLAG = 1
      L = IW(J)
      IW(J ) = IW(J1)
      IW(J1) = L
   20 CONTINUE
      IF (KFLAG .EQ. 0) GO TO 40
   30 CONTINUE
   40 CONTINUE
C
C     STACK POINTS OF ZERO DEGREE AT END OF NEW.
C
      DO 70 L = 1,KT
      I = IW(L) - L + 1
      K = NEW(I)
      IF (I .GE. NN) GO TO 60
      DO 50 J = I,NN1
   50 NEW(J) = NEW(J+1)
   60 NEW(NN) = K
   70 CONTINUE
C
C     CORRECT ILD, THE INVERSE OF NEW.
C
   80 DO 90 I = 1,NN
      K = NEW(I)
   90 ILD(K) = I
      RETURN
      END

      SUBROUTINE DDR2
C
C     DYNAMIC DATA RECOVERY--PART 2 --MODE ACCELERATION
C
C     DMAP SEQUENCE
C
C     INPUTS = 9
C
C     USETD,VUD,PD,K2DD,B2DD,MDD,FRL,LLL,DM
C
C     OUTPUTS = 3
C
C     UAV,UEV,PAF
C
C     SCRATCHES = 6
C
C     PARAMETERS 1 BCD, 3INTEGERS
C
      INTEGER         USETD,PD,B2DD,FRL,DM,UAV,PAF,
     1                SCR2,SCR3,SCR4,SCR5,SCR6,SCR7,
     2                TYPE,REACT,TRAN,USET,VUD,PAD,UEV,PL
      COMMON /BLANK / TYPE(2),NOUE,REACT,FRQSET
      COMMON /BITPOS/ UM,UO,UR,USG,USB,UL,UA,UF,US,UN,UG,UE,UP,UNE,UFE,
     1                UD
      COMMON /PATX  / LC,N,NO,N4,USET
      COMMON /ZZZZZZ/ CORE(1)
      DATA    USETD , VUD, PD, K2DD,B2DD,MDD,FRL,LLL,DM  /
     1        101   , 102,103,  104, 105,106,107,108,109 /
      DATA    UAV   , UEV, PAF, TRAN   /
     1        201   , 202, 203, 4HTRAN /
      DATA    SCR2  , SCR3,SCR4,SCR5,SCR6,SCR7,PAD /
     1        302   , 303 , 304, 305, 306, 301,302 /
C
C
      LC   = KORSZ(CORE)
      VUD  = 102
      SCR7 = 301
      USET = USETD
      PL   = SCR6
      ISOL = SCR7
      IF (NOUE .GE. 0) GO TO 10
      PAD  = PAF
   10 CONTINUE
      IF (TYPE(1) .NE. TRAN) SCR7 = UAV
      IF (TYPE(1).NE.TRAN .AND. REACT.LT.0 .AND. NOUE.GE.0) SCR7 = VUD
C
C     MODE ACCELERATION
C
C     FORM PAD
C
C
      CALL DDR1A (PD,K2DD,B2DD,MDD,VUD,PAD,FRL,FRQSET,SCR3,SCR4,SCR5,
     1            SCR6,TYPE(1),SCR7)
C
C     DISP ON SCR7 IN TRANSIENT
C
      IF (NOUE .LT. 0) GO TO 50
      CALL CALCV (SCR3,UD,UA,UE,CORE(1))
      CALL SSG2A (VUD,SCR4,UEV,SCR3)
C
C     UA IS ON SCR4
C
      VUD = SCR4
C
C     BREAK UP PAD
C
      CALL SSG2A (PAD,PAF,SCR5,SCR3)
   50 IF (REACT .GE. 0) GO TO 90
C
C     UR NULL
C
      IF (TYPE(1) .NE. TRAN) SCR7 = ISOL
      IF (TYPE(1).NE.TRAN .AND. NOUE.LT.0) SCR7 = UAV
      CALL SSG3A (0,LLL,PAF,SCR7,SCR3,SCR6,-1,0)
   60 IF (TYPE(1) .NE. TRAN) GO TO 80
C
C     MERGE RECALCULATED SOLUTIONS AND ACCEL AND VELOCITY
C
      ISOL = UAV
      IF (NOUE .LT. 0) GO TO 70
      ISOL = SCR5
   70 CALL DDR1B (VUD,SCR7,ISOL)
C
C     BUILD UP TO DSIZE  ADDING IN UEV
C
   80 IF (NOUE .LT. 0) GO TO 30
      CALL SDR1B (SCR4,ISOL,UEV,UAV,UD,UA,UE,USETD,0,0)
   30 RETURN
C
C     FREE BODY PROBLEM
C
   90 CALL CALCV (SCR3,UA,UL,UR,CORE(1))
C
C     PARTITION PAF AND UA
C
      CALL SSG2A (PAF,PL,SCR5,SCR3)
      IVEC = VUD
      IF (TYPE(1) .EQ. TRAN) IVEC = SCR7
      CALL SSG2A (IVEC,SCR2,SCR5,SCR3)
C
C     UR IS  ON SCR5
C
      CALL SSG3A (0,LLL,PL,SCR3,SCR2,SCR6,-1,0)
      CALL SSG2B (DM,SCR5,SCR3,SCR4,0,2,1,SCR6)
      CALL SDR1B (SCR3,SCR4,SCR5,SCR7,UA,UL,UR,USETD,0,0)
      GO TO 60
      END

      SUBROUTINE FDVECT (DELTA,PK)
C
      INTEGER          SYSBUF,ICORE(1),MCB(7)
C    1,                NAME(2)
      DOUBLE PRECISION DCORE(1),DMAX,PK
      COMMON /SYSTEM/  KSYSTM(65)
      COMMON /ZZZZZZ/  CORE(1)
      COMMON /REGEAN/  IA(14),IVECT(7),IB(5),LC1,IB1(9),LOADS,LX,ICOUNT,
     1                 LAMA,IBUCK,NSYM
      COMMON /PACKX /  IT1P,IT2P,IIP,JJP,INCRP
      EQUIVALENCE      (ICORE(1),CORE(1),DCORE(1)),
     1                 (KSYSTM(1),SYSBUF),(KSYSTM(55),IPREC)
C     DATA    NAME  /  4HFDVE,4HCT  /
C
      NPROB = IA(3)
      KPREC = IA(5)
      IF (KPREC.NE.1 .AND. KPREC.NE.2) KPREC = IPREC
      NPRO2 = NPROB
      ICNT  = IVECT(2)
      IM1   = 1
      LCORE = (KORSZ(CORE)/2)*2 - LC1 - SYSBUF
      X     = NPROB
      Y     = ICOUNT
      MCB(1)= IB(5)
      CALL RDTRL (MCB(1))
C
      CALL DETFBS (NPRO2+1,ICORE(LCORE+1),MCB,NPROB,ICOUNT)
C
C     COPY FX ONTO IVECT + NORMALIZE
C
      IPM1 = IVECT(1)
      IF (ICNT .EQ. 0) GO TO 40
      CALL GOPEN (IVECT(1),ICORE(LCORE+1),0)
      CALL SKPREC (IVECT(1),ICNT)
      CALL CLOSE (IVECT(1),2)
      IM1 = 3
   40 CALL GOPEN (IVECT,ICORE(LCORE+1),IM1)
      LCORE = LCORE - SYSBUF
      IF (KPREC .EQ. 2) GO TO 71
      XMAX = 0.0
      DO 60  I = 1, NPROB
   60 XMAX = AMAX1(XMAX,ABS(CORE(I)))
      DO 70 I = 1,NPROB
   70 CORE(I) = CORE(I)/XMAX
      GO TO 73
   71 DMAX = 0.0D0
      DO 69 I = 1,NPROB
      IF (DABS(DCORE(I)) .GT. DMAX) DMAX = DABS(DCORE(I))
   69 CONTINUE
      DO 72 I = 1,NPROB
   72 DCORE(I) = DCORE(I)/DMAX
   73 CONTINUE
      IT1P = KPREC
      IT2P = IPREC
      IIP  = 1
      JJP  = NPROB
      INCRP = 1
      CALL PACK (CORE,IVECT,IVECT)
      CALL CLOSE (IVECT(1),1)
      IPM1 = LAMA
      CALL GOPEN (LAMA,ICORE(LCORE+1),3)
      DCORE(1) = PK
      CALL WRITE (LAMA,CORE,IPREC,1)
      CALL CLOSE (LAMA,2)
      RETURN
      END

      SUBROUTINE MPYADO (ZZ      ,Z      ,ZD      )
C
C     MPYAD PERFORMS THE MATRIX OPERATION
C       (+/-)A    * B (+/-)C = D   OR
C       (+/-)A(T) * B (+/-)C = D
C
C     LAST REVISED  1/92 BY G.CHAN/UNISYS
C     . NEW METHOD 4T WAS ADDED WHICH IS FASTER THAN METHOD 2T UNDER
C       CERTAIN CONDITIONS.
C     . NEW ROUTINE FOR DIAGONAL, IDENTITY, AND ROW VECTOR MATRICES
C     . USER CAN REVERT TO ORIGINAL MPYAD ALL METHODS, BY DIAG 41
C
C
C     LEGEND:
C
C     +---+ + +  IS A MATRIX       +-            \    AN ELEMENT OF
C     |   | | |  BY COLUMNS        |  IS A        \   A, B, OR C IN
C     |   | | |  IN MULTIPLE       |  COLUMN       \     AND
C     |   | | |  PASSES            |             OR   /  AN ELEMENT
C     +---+ + +                    +-                /   OF D OUT
C
C     +-------+  IS A MATRIX
C     |       |  BY ROWS           => OR   INDICATES MATRICES C AND D
C     +-------+  IN MULTIPLE       <=      ARE USING SAME CORE SPACE
C     +-------+  PASSES
C     +-------+
C
C     UPPER CASE LETTER INDICATES UNPACKED MATRIX OR COLUMN
C     LOWER CASE LETTER INDICATES MATRIX OR COLUMN IN STRINGS FORM
C
C
C     METHOD 1NT AND 1T       METHOD 2NT               METHOD 2T
C                                        B                        +-
C         +----+ + +                    /                         |
C         |    | | |                   /                          |B
C     a   | B  | | |          + + +---+ +-                        |
C      \  |    | | |          | | |   | |            +----------+ +-
C       \ +----+ + +          | | | a | |C           |    a     |
C         +----+              | | |   | |            +----------+
C         |    |              + + +---+ +- +-        +----------+ \
C         | D  | <= C                      |         +----------+  \
C         |    |                        => |D                     \ C
C         |    |                           |                       \
C         +----+                           +-                       D
C
C      METHOD 3T     +-                  METHOD 4T     +-
C                    |                                 |
C                    |b                                |b(BANDED)
C                    |                                 |
C                    +-                                +-
C         + + +----+ +-    +-              +---------+ +-
C         | | |    | |     |               |         | |
C         | | | A  | |D  + |C              |    a    | |C
C         | | |    | |     |               |         | |
C         + + +----+ +-    +-              +---------+ +-  +-
C                        ADD ON            +---------+     |
C                        LAST              +---------+     |D(FULL)
C                        PASS                           => |
C                                                          +-
C
      LOGICAL         LAST  ,NULL
      EXTERNAL        ANDF  ,ORF   ,LSHIFT
CWKBI 9/93
      INTEGER PRNTYP(4), NAMEA(2), NAMEB(2), NAMEC(2), NAMED(2), PRCA
      INTEGER         ZZ(6) ,P     ,Q     ,R     ,T     ,OP    ,OPA   ,
     1                OPB   ,OPC   ,OPBC  ,OP2   ,ONE1  ,ONE2  ,P1    ,
     2                PP1   ,PP2   ,PRC   ,PREC  ,PREC1 ,BCD   ,RCB   ,
     3                RCD   ,RC    ,RD    ,RDREW ,WRT   ,WRTREW,CLS   ,
     4                CLSREW,ANDF  ,ORF   ,EOL   ,EOR   ,ACOL  ,ACOL1 ,
     5                ACOLN ,ACORE ,APOINT,POINT ,BCOL  ,BUF1  ,BUF2  ,
     6                BUF3  ,BUF4  ,BUFI  ,BLK   ,BLOCK ,ROW   ,ROWA  ,
     7                AROW  ,AROW1 ,AROWN ,CROW  ,DROW  ,TYPE  ,TYPEA ,
     8                TYPEB ,TYPEC ,TYPED ,TYPEBD,TYPD  ,TYPD1 ,FILE  ,
     9                FILEA ,FILEB ,FILEC ,FILED ,CFILE ,DFILE ,EFILE ,
     O                SCRTCH,SIGNAB,SIGNC ,FIRSTL,SYSBUF,FORM  ,FLAG  ,
     1                DENSC
      DOUBLE PRECISION       AD(2) ,BD(2) ,DD(2) ,ZD(1) ,XND
      DIMENSION       B(4)  ,Z(1)  ,MPY(3),BCD(2),ZERO(4)      ,XNS(1),
     1                NAME(2)      ,BLK(15)      ,METHOD(6)
CNVXNB
      COMMON /LOGOUT/ LOUT
CNVXNE
      COMMON /MACHIN/ MACH  ,IHALF ,JHALF
     1       /MPYQT4/ QT(2) ,LL4   ,JMP(2)
      COMMON /MPYADX/ FILEA(7)     ,FILEB(7)     ,FILEC(7)     ,
     1                FILED(7)     ,NZ    ,T     ,SIGNAB,SIGNC ,PREC1 ,
     2                SCRTCH,TIME
     3       /SYSTEM/ KSYSTM(152)
     4       /TYPE  / PRC(2),NWDS(4)      ,RC(4)
     5       /NAMES / RD    ,RDREW ,WRT   ,WRTREW,CLSREW,CLS
     6       /ZBLPKX/ D(4)  ,DROW
     7       /ZNTPKX/ A(4)  ,IP    ,EOL   ,EOR
     8       /PACKX / TYPED ,TYPD1 ,ONE1  ,PP1   ,INCR1
     9       /UNPAKX/ TYPEBD,ONE2  ,PP2   ,INCR2
      COMMON /NTIME / NITEMS,TMIO  ,TMBPAK,TMIPAK,TMPAK ,TMUPAK,TMGSTR,
     1                TMPSTR,TMT(4),TML(4)
     2       /MPYADZ/ RCB   ,RCD   ,LL    ,LLL   ,JB    ,NBX   ,NDX   ,
     3                JMAX1X,ACOL  ,ACOL1 ,ACOLN ,ACORE ,APOINT,BCOL  ,
     4                CROW  ,FIRSTL,NA    ,NB    ,ND    ,NWDA  ,NWDB  ,
     5                NWDD  ,PREC  ,JMAX  ,INCRA ,BLOCK(20)
     6       /ZZZZZZ/ XND(8500)
      EQUIVALENCE     (KSYSTM( 1),SYSBUF) , (KSYSTM( 2),MOUT ) ,
     1                (KSYSTM(58),KSYS58) , (KSYSTM(40),NBPW )
CWKBI 10/93
     2               ,(KSYSTM(55),IPREC )
      EQUIVALENCE     (A(1)    ,AD(1)   ) , (B(1)    ,BD(1)  ) ,
     1                (D(1)    ,DD(1)   ) , (FILEA(2),M      ) ,
     2                (FILEA(3),N,ROWA  ) , (FILEA(5),TYPEA  ) ,
     3                (FILEB(2),Q       ) , (FILEB(3),R      ) ,
     4                (FILEB(5),TYPEB   ) , (FILEC(5),TYPEC  ) ,
     6                (FILED(5),TYPD    ) , (NZZ     ,BUF1   ) ,
     7                (ACOLN   ,AROWN   ) , (FILEC(7),DENSC  )
      EQUIVALENCE     (BLOCK(2),TYPE    ) , (BLOCK(3),FORM   ) ,
     1                (BLOCK(4),ROW     ) , (BLOCK(5),POINT  ) ,
     2                (BLOCK(6),NBRSTR  ) ,
     3                (BLOCK(8),FLAG    ) , (XND(1)  ,XNS(1) ) ,
     4                (ACOL1   ,AROW1   ) , (ACOL    ,AROW   ) ,
     5                (MPY(1)  ,NAME(1) )
C
      DATA    NAME  / 4HMPYA, 4HD   /, JBEGN /  4HBEGN/, JEND  / 3HEND/
     1        TIME1 / 0. /  , TIME2 /  0.    /, ZERO  /  4*0   /,
     2        METHOD/ 4H1 NT, 4H1 T ,  4H2 NT,  4H2 T  , 4H3 T , 3H4 T/
CWKBI 9/93
      DATA PRNTYP / 2HRS, 2HRD, 2HCS, 2HCD /
CNVXNB
      IF (TYPEA .EQ. 0) TYPEA = IPREC
      IF (TYPEB .EQ. 0) TYPEB = IPREC
      IF (TYPEC .EQ. 0) TYPEC = IPREC
CNVXNE
CWKBNB 7/94 SPR94008
      ITYPEA = TYPEA
      ITYPEB = TYPEB
      ITYPEC = TYPEC
CWKBNE 7/94 SPR94008
C
C     CHECK TO SEE IF THE INPUT MATRICES ARE CONFORMABLE
C
      CALL SSWTCH (19,L19)
      CALL SSWTCH (41,L41)
      NOGO = 0
      FILE = 0
      NOAB = 0
      IF (FILEA(6).EQ.0 .OR. FILEB(6).EQ.0) NOAB = 1
      IROWB = FILEA(2)
      IROWC = FILEA(3)
      IF (T .NE. 0) T = 1
      IF (T .EQ. 0) GO TO 30
      IROWB = FILEA(3)
      IROWC = FILEA(2)
   30 IF (NOAB .EQ. 1) GO TO 50
      IF (FILEB(3) .NE. IROWB) NOGO = 1
      IF (FILEC(1) .LE. 0) GO TO 40
      IF (FILEC(2).NE.FILEB(2) .OR. FILEC(3).NE.IROWC) NOGO = 1
   40 IF (NOGO .EQ. 1) GO TO 560
C
C     PERFORM GENERAL INITIALIZATION
C
   50 MPY(3) = JBEGN
      IF (FILED(1) .GT. 0) CALL CONMSG (MPY,3,0)
      NOUT  = LOUT
C
C  -- USE SINGLE PRECISION ON MACHINES WITH 60 OR 64 BITS PER WORD
C
      IF (NBPW .GE. 60) PREC1 = 1
      OPB   = RDREW
      OPC   = RDREW
      OP2   = WRTREW
      OP    = CLS
      CFILE = FILEC(1)
      IF (CFILE .EQ. 0) TYPEC = 1
      B(2)  = 0.
      B(3)  = 0.
      B(4)  = 0.
      TYPD1 = TYPD
      ONE1  = 1
      ONE2  = 1
      P     = N
      IF (T .NE. 0) P = M
      PP1   = P
      INCR1 = 1
      IF (CFILE.EQ.0  .OR. FILEC(6).EQ.0) CFILE = 0
      IF (FILEB(6).EQ.0 .AND. CFILE.EQ.0) PP1   = 1
      INCR2    = 1
      FILED(2) = 0
      FILED(6) = 0
      FILED(7) = 0
      MPASS3   = 0
      TIME3    = 1.0E+10
      PREC     = PREC1
      IF (PREC .NE. 2) PREC = 1
      IF (PREC1.EQ.0 .AND. (PRC(TYPEA).EQ.2 .OR. PRC(TYPEB).EQ.2 .OR.
     1    PRC(TYPEC).EQ.2)) PREC = 2
C
C     ELIMINATE METHOD THREE FROM SELECTION FOR THIS BAD CASE
C     (I.E. TRANSPOSE AND MIXED MATRIX PRECISION)
C
      IT = T
      IF (IT.NE.0 .AND. PREC.EQ.1 .AND. PRC(TYPEB).EQ.2) IT = 0
      IF (IT.NE.T .AND. L19.NE.0) WRITE (NOUT,60) TYPEA,TYPEB,TYPEC
   60 FORMAT ('0METHOD 3T IS ELIMINATED FROM SELECTION/MPYAD@60',/1X,
     1        'MATRIX TYPES A,B,C =',3I3)
C
C     COMPUTE TYPE AND PRECISION OF D MATRIX
C     RCD    = 1 FOR REAL,   2 FOR COMPLEX
C     PREC   = 1 FOR SINGLE, 2 FOR DOUBLE
C     TYPED  = 1 FOR RSP, 2 FOR RDP, 3 FOR CSP, AND 4 FOR CDP
C     PRC(1) = 1 FOR S.P.   PRC(2) = 2 FOR D.P.
C
      RCD = 0
      IF (PREC .EQ. 2) GO TO 70
      IF (ANDF(TYPEA,1) .EQ. 0) TYPEA = TYPEA - 1
      IF (ANDF(TYPEB,1) .EQ. 0) TYPEB = TYPEB - 1
      IF (ANDF(TYPEC,1) .EQ. 0) TYPEC = TYPEC - 1
   70 IF (TYPEA.GT.2 .OR. TYPEB.GT.2 .OR. TYPEC.GT.2) RCD = 2
      TYPED = RCD + PREC
      IF (RCD .EQ. 0) RCD = 1
C
C     RCA/B/D   = 1 IF A/B/D IS REAL, = 2 IF A/B/D IS COMPLEX
C     NWDA/B/D  = NUMBER OF WORDS PER ELEMENT OF A/B/D
C     NBX/DX    = NUMBER OF ELEMENTS PER COLUMN OF B/C ORD
C     NB/D      = NUMBER OF WORDS PER COLUMN OF B/C OR D
C     NZZ       = BUF1 = POINTER TO FIRST GINO BUFFER
C     BUF2/3    = POINTER TO SECOND AND THIRD GINO BUFFERS
C     JJ        = MAX. NO. OF COLNS OF B AND D THAT MAY BE HELD IN CORE
C     MPASS1/2/3 = NUMBER OF PASSES REQUIRED FOR METHOD ONE/TWO/THREE
C     JZB/JZDB  = POINTER TO FIRST ELEMENT OF B FOR SP/DP REFERENCE
C     JB        = POINTER TO FIRST ELEMENT OF B FOR PRECISION OF PROBLEM
C     ACORE     = POINTER TO FIRST WORD FOR STORAGE OF PACKED COLUMNS
C                 OF A MATRIX FOR METHOD TWO
C     KSYS58    = SYSTEM(58), METHOD REQUESTED BY USER IF IT IS NON-ZERO
C
C
C     TURN TRANSPOSE FLAG OFF IF INPUT MATRIX A IS SYMMETRIC, AND SURELY
C     THAT COLUMNS EQUEL ROWS, AND DIAG 41 IS OFF.
C
C     IF INPUT A OR B IS DIAGONAL, ROW VECTOR, OR IDENTITY MATRICES,
C     MATRICES ARE NOT IN MIXED PRECISTION TYPES, AND DIAG 41 FLAG IS
C     OFF AND SYSTEM(94) IS NOT 1, BRANCH OFF TO SPECIAL SUBROUTINE
C     MPY-D-R-I
C
      K = FILEA(4)
      IF (K.EQ.6 .AND. M.EQ.N .AND. L41.EQ.0) T = 0
C        SYMMETRIC    COLN=ROW     DIAG41 OFF
      IF (L41.EQ.1 .OR. MOD(KSYSTM(94),10).EQ.1) GO TO 80
      J = FILEB(4)
      IF (K.NE.3 .AND. K.NE.7 .AND. K.NE.8 .AND.
     1    J.NE.3 .AND. J.NE.7 .AND. J.NE.8) GO TO 80
C         DIAGONAL     ROW VCTR     IDENTITY
C
      IF (TYPEA.NE.TYPEB .OR. TYPEA.NE.TYPD) GO TO 80
      K = MAX0(M,N,Q,R)
      J = K*2 + 1
      K = K + 1
      CALL MPYDRI (Z,Z,Z(K),Z(K),Z(J),Z(J))
      GO TO 380
C
   80 RCB   = RC(TYPEB)
      NBX   = R*RCB
      NWDB  = NWDS(TYPEB)
      NWDB1 = NWDB + 1
      NB    = R*NWDB
      NDX   = P*RCD
      ND    = P*NWDS(TYPED)
      NZZ   = IABS(NZ) - SYSBUF + 1
      BUF2  = BUF1 - SYSBUF
      BUF3  = BUF2 - SYSBUF
      BUF4  = BUF3 - SYSBUF
      JJ    = (NZZ-1)/(NB+ND)
      ICRQ  = NB + ND - NZZ + 1
      IF (ICRQ .GT. 0) GO TO 530
      MPASS1= (Q-1)/JJ + 1
      JZB   = JJ*ND  + 1
      JZDB  = JJ*NDX + 1
      JB    = JZB
      IF (PRC(TYPEB) .EQ. 2) JB = JZDB
      NWDA  = NWDS(TYPEA)
      PRCA  = PRC(TYPEA)
      NA    = NWDA*N
      NWDA1 = NWDA + 1
      NWDD  = NWDS(TYPED)
      ACORE = ND + 1
      IF (T .NE. 0) ACORE = NB + 1
      ACORE = ((ACORE+1)/2)*2 + 1
      IF (SIGNAB.EQ.0 .AND. PREC.EQ.1 .AND. (PRC(TYPEA).EQ.2 .OR.
     1    PRC(TYPEB).EQ.2)) TYPED = RCD + 1
      IF (NOAB.EQ.1   .OR. SIGNAB.EQ. 0) GO TO 1100
      IF (SIGNAB.EQ.1 .OR. SIGNAB.EQ.-1) GO TO 100
      WRITE  (MOUT,90)
   90 FORMAT ('0*** USER FATAL MESSAGE 2398, MPYAD REQUIRES SIGN OF ',
     1        'A*B TO BE -1, 0, OR +1')
      GO TO 540
  100 CALL MPYQ (Z)
C
C     CALCULATE ESTIMATED EXECUTION TIMES AND SELECT METHOD.
C
      NCORE = BUF3 - ACORE
      ICRQ  = -NCORE
      IF (ICRQ .GT. 0) GO TO 530
      CORE  = FLOAT(NCORE/NWDA)
      FN    = FILEA(2)
      FM    = FILEA(3)
      FP    = FILEB(2)
      RHOA  = AMIN1(1.E-4*FLOAT(FILEA(7)),1.0)
      RHOB  = AMIN1(1.E-4*FLOAT(FILEB(7)),1.0)
      RHOC  = AMIN1(1.E-4*FLOAT(FILEC(7)),1.0)
      RHOD  = AMAX1(RHOA,RHOB)
      ARITH = FM*FN*(TMT(TYPED) + (1.0-RHOA)*TML(TYPED))
      ATERM = (FM*RHOA+5.0)*FN*TMIPAK
      BTERM = FLOAT(R)*FP*0.5*(1.0+RHOB)*TMUPAK
      DTERM = FM*FP*0.5*(1.0+RHOD)*TMPAK
      CTERM = 0
      IF (CFILE .NE. 0) CTERM = FM*FP*0.5*(1.0+RHOC)*TMUPAK
      TIME1 = (FM*FN*FP*RHOA*TMT(TYPED) + FLOAT(MPASS1)*ATERM + BTERM
     1      +  DTERM + CTERM)*1.0E-6
C
      MPASS2= (2.0-RHOA)*FM*FN*RHOA/CORE + 1.0
      FR    = MPASS2
      IF (T .NE. 0) GO TO 110
      TIME2 = (FP*RHOA*RHOB*ARITH + ATERM
     1      + (FR+1.0)/2.0*(FN*RHOB+10.0)*FP*TMIPAK + FR*DTERM
     2      + (FR-1.0)*0.5*FM*FP*(1.0+RHOD)*TMUPAK
     3      + CTERM)*1.0E-6
      GO TO 120
C
  110 FNT   = FN*FM*RHOB
      P1    = AMIN1((FNT/FLOAT(FILEB(6))+FP)/2.0,FNT,FP)
      FP1   = P1
      CTERM2= 0.
      IF (CFILE .NE. 0) CTERM2 = (FN*RHOC+5.0)*FP*TMIPAK
      BTERM = FM*FP*0.5*(1.0+RHOB)*TMUPAK
      DTERM2= (FN*RHOD+5.0)*FP
      TIME2 = (FP1*RHOA*ARITH + (FM*RHOA+5.0)*FN*TMIPAK + FR*BTERM
     1      + (FR+1.0)/2.0*DTERM2*TMBPAK + (FR-1.0)/2.0*DTERM2*TMIPAK
     2      + CTERM2)*1.0E-6
C
      BUFI  = BUF4
      IF (FILEC(1) .EQ. 0) BUFI = BUF3
      NBRROW= MIN0((BUFI-ORF(ND+1,1))/NA,M)
      MPASS3= (M-1)/NBRROW + 1
      FR    = MPASS3
      TIME3 = (FM*FN*FP*RHOB*TMT(TYPED) + FM*FN*0.5*(1.0+RHOA)*TMUPAK
     1      + FR*FP*(FN*RHOB+5.0 )*TMIPAK
     2      + (FR+1.0)/4.0*FN*FP*(1.0+RHOD)*TMPAK
     3      + (FR-1.0)/4.0*FN*FP*(1.0+RHOD)*TMUPAK + CTERM2)*1.E-6
  120 CALL TMTOGO (ITIMGO)
      IF (CORE .LE. 0.0) TIME2 = AMAX1(TIME1,TIME3) + 1.0
      TIME  = AMIN1(TIME1,TIME2,TIME3)
      ITIME = TIME + 1
      IF (ITIMGO.LE.ITIME .AND. FILED(1).GT.0) GO TO 550
C
C     PRINT TIMING MESSAGE AND IF OUTPUT FILE IS PURGED RETURN
C
      IELEMS = FN*FM*RHOA + 0.5
      JELEMS = FLOAT(R)*FP*RHOB
CWKBNB 9/93
      IF(L19.EQ.0) GO TO 137
      CALL FNAME ( FILEA, NAMEA )
      CALL FNAME ( FILEB, NAMEB )
      CALL FNAME ( FILEC, NAMEC )
      CALL FNAME ( FILED, NAMED )
      WRITE( NOUT,136, IOSTAT=IERR )
CWKBR 7/94/SPR 94008 *         NAMEA, N, M, IELEMS, RHOA, PRNTYP( TYPEA )
CKWBR 7/94 SPR 94008 *,        NAMEB, R, Q, JELEMS, RHOB, PRNTYP( TYPEB )
     *         NAMEA, N, M, IELEMS, RHOA, PRNTYP( ITYPEA )
     *,        NAMEB, R, Q, JELEMS, RHOB, PRNTYP( ITYPEB )
  136 FORMAT(
     & '  /-----------------------------------------------------------/'
     &,/
     &,'  /     MATRIX      ROWS   COLS     TERMS  DENS    TYPE       /'
     &,/
     &,'  /-----------------------------------------------------------/'
     &,/
     &,'  /  A- ',2A4,I8,I7,I10,F7.4, 5X, A2
     &,/
     &,'  /  B- ',2A4,I8,I7,I10,F7.4, 5X, A2 )
      IELEMS = FN*FM*RHOC + .5
      IF (CFILE .EQ. 0) GO TO 11140
      WRITE( NOUT,11136, IOSTAT=IERR )
     *        NAMEC, FILEC(3), FILEC(2), IELEMS, RHOC, PRNTYP(ITYPEC)
11136 FORMAT(
     &   '  /  C- ',2A4,I8,I7,I10, F7.4, 5X, A2 )
11140 WRITE( NOUT, 11137 ) NAMED, PRNTYP(TYPED)
11137 FORMAT('  /  D- ',2A4,8X, 7X, 10X, 7X,   5X, A2 )
      WRITE( NOUT, 11138 ) SIGNAB, SIGNC, T, CORE, MPASS1,MPASS2,
     &                     MPASS3, TIME1, TIME2, TIME3
11138 FORMAT('  /  SIGNAB =',I4,'  SIGNC =',I4,'  TIME EST=',I9
     &,      ' MEMORY =',F8.0
     &,/,    '  /  MPASS1 =',I4, '  MPASS2=',I4, '  MPASS3=',I4
     &,/,    '  /  TIME1  =',E9.2,' TIME2=',E9.2,' TIME3=',E9.2,/
     &,'  /-----------------------------------------------------------/'
     &)
  137 CONTINUE
CWKBNE 9/93
C
  180 IF (FILED(1) .LT. 0) GO TO 1600
C
      J = KSYS58
      IF (J.LT.0 .OR. J.GT.3 .OR. (J.EQ.3 .AND. IT.EQ.0)) J = 0
      IF (J  .NE. 0) GO TO (200,600,1300), J
      IF (IT .NE. 0) GO TO 190
CWKBNB 2/95 NCL93004
      IF ( MPASS1 .LT. MPASS2 ) GO TO 200
      IF ( MPASS2 .LT. MPASS1 ) GO TO 600
CWKBNE 2/95 NCL93004
      IF (TIME1 .LT. TIME2) GO TO 200
      GO TO 600
CWKBD 2/95 NCL93004 190 IF (TIME1.LT.TIME2 .AND. TIME1.LT.TIME3) GO TO 200
CWKBNB 2/95 NCL93004
  190 CONTINUE
      IF ( MPASS1 .LT. MPASS2 .AND. 
     &   ( TIME1 .LT. TIME3 .OR. MPASS1 .LT. MPASS3 ) ) GO TO 200
      IF ( MPASS2 .LT. MPASS1 .AND. 
     &   ( TIME2 .LT. TIME3 .OR. MPASS2 .LT. MPASS3 ) ) GO TO 200
      IF ( TIME1 .LT. TIME2 .AND. TIME1 .LT. TIME3 ) GO TO 200
      IF (TIME2 .LT. TIME3) GO TO 600
CWKBNE 2/95 NCL93004
      GO TO 1300
C
C               *********************
C               *                   *
C               *    METHOD  ONE    *
C               *    MPY1NT $ 1T    *
C               *                   *
C               *********************
C
C     BUILD MATRIX PRODUCT JMAX COLUMNS PER PASS OF A MATRIX
C     WHERE JMAX=JJ EXCEPT ON FINAL PASS
C
  200 JCOL = 1
  230 WRITE  (NOUT,240) METHOD(T+1),MPASS1,TIME1
  240 FORMAT ('    METHOD TO BE USED:',A4,', NBR PASSES =',I4,
     1        ',  EST. TIME =',F9.1)
  250 JMAX  = MIN0(JCOL+JJ-1,Q)
      IF (JMAX .EQ. Q) OP = CLSREW
      JMAX1 = JMAX  - JCOL
      JMAX  = JMAX1 + 1
      JMAX1X= JMAX1*NDX
      IF (FILEB(6) .EQ. 0) GO TO 270
C
C     READ AND UNPACK JMAX COLUMNS OF THE B MATRIX
C
      FILE = FILEB(1)
      JZ   = JZB
      TYPEBD = TYPEB*SIGNAB
      NBD  = NB
      OPBC = OPB
      PP2  = R
      ASSIGN 270 TO MM
      GO TO 400
C
C     READ AND UNPACK JMAX COLUMNS OF THE C MATRIX
C
  270 FILE = FILEC(1)
      JZ   = 1
      TYPEBD = TYPED*SIGNC
      NBD  = ND
      OPBC = OPC
      PP2  = P
      ASSIGN 280 TO MM
      GO TO 400
C
C     OPEN AND POSITION A MATRIX TO FIRST COLUMN
C
  280 IF (FILEB(6) .EQ. 0) GO TO 340
      FILE = FILEA(1)
      CALL OPEN (*500,FILEA,Z(NZZ),RDREW)
  290 CALL FWDREC (*510,FILEA)
C
C     SET POINTERS
C     L   = COLUMN NUMBER
C     LL  = POINTER TO LTH ROW OF B MATRIX
C     LLL = POINTER TO LTH ROW OF D MATRIX
C
      L   = 1
      LL  = JB
      LLL = 1
C
C     CALL INTPK TO INITIATE READING THE LTH COLUMN OF THE A MATRIX
C     IF COLUMN IS NULL, BYPASS ARITHMETIC
C
  310 CALL INTPK (*320,FILEA,0,TYPED,0)
C
C     FORM EITHER  A(I,L)*B(L,J) + D(I,J)
C              OR  A(L,I)*B(I,J) + D(L,J)
C           WHERE  J RUNS ACROSS COLUMNS OF B AND D NOW IN CORE
C
      CALL MPY1V (ZZ,Z,ZD)
C
C     POSITION POINTERS FOR NEXT COLUMN OF A
C
  320 LL  = LL + RCB
      LLL = LLL+ RCD
      L   = L  + 1
      IF (L .LE. M) GO TO 310
C
C     CLOSE AND REWIND FILE CONTAINING A MATRIX
C
      CALL CLOSE (FILEA,CLSREW)
C
C     OPEN FILE CONTAINING D MATRIX TO WRITE
C
  340 FILE = FILED(1)
      CALL OPEN (*500,FILED,Z(NZZ),OP2)
C
C     IF FIRST COLUMNS OF D, WRITE HEADER
C
      IF (OP2 .EQ. WRT) GO TO 360
      CALL FNAME (FILED,BCD)
      CALL WRITE (FILED,BCD,2,1)
C
C     PACK AND WRITE JMAX COLUMNS OF THE D MATRIX
C
  360 JZ = 1
      DO 370 J = 1,JMAX
      CALL PACK (Z(JZ),FILED,FILED)
  370 JZ = JZ + ND
C
C     TEST FOR END OF MULTIPLICATION
C     CLOSE FILE CONTAINING D MATRIX
C
      CALL CLOSE (FILED,OP)
C
C     SET OP FLAGS FOR OPEN CALLS FOR NEXT PASS
C
      OPB = RD
      OPC = RD
      OP2 = WRT
C
      JCOL = JCOL + JJ
      IF (JCOL .LE. Q) GO TO 250
  380 MPY(3) = JEND
      CALL CONMSG (MPY,3,0)
      GO TO 1600
C
C     INTERNAL SUBROUTINE TO READ JMAX COLUMNS OF THE B OR C MATRICES
C     ELEMENTS ARE SET TO ZERO IF COLUMN IS NULL OR MATRIX ABSENT
C
C     OPEN AND POSITION FILE IF MATRIX IS PRESENT
C
  400 IF (FILE) 410,420,410
  410 CALL OPEN (*500,FILE,Z(NZZ),OPBC)
      IF (JCOL .NE. 1) GO TO 420
      CALL FWDREC (*510,FILE)
C
C     LOOP THROUGH JMAX COLUMNS OF MATRIX
C
  420 DO 470 J = 1,JMAX
C
C     UNPACK THE JTH COLUMN IF MATRIX IS PRESENT
C
      IF (FILE) 440,450,440
  440 CALL UNPACK (*450,FILE,Z(JZ))
      GO TO 470
C
C     ZERO COLUMN
C
  450 K2 = JZ + NBD - 1
      DO 460 K = JZ,K2
  460 Z(K) = 0.
C
C     POSITION POINTERS TO NEXT COLUMN OF MATRIX
C
  470 JZ = JZ + NBD
C
C     CLOSE FILE IF MATRIX IS PRESENT
C
      IF (FILE) 480,490,480
  480 CALL CLOSE (FILE,OP)
C
C     RETURN
C
  490 GO TO MM, (270,280)
C
C
C     ERROR CONDITIONS
C
  500 MM = -1
      GO TO 520
  510 MM = -2
  520 CALL MESAGE (MM,FILE,NAME)
      GO TO 1600
C
  530 MM = -8
      FILE = ICRQ
      GO TO 520
  540 MM = -37
      GO TO 520
  550 MM = -50
      FILE = ITIME
      GO TO 520
  560 CALL FNAME (FILEA,ZZ(1))
      CALL FNAME (FILEB,ZZ(3))
      CALL FNAME (FILEC,ZZ(5))
      IF (FILEC(2).NE.FILEB(2) .OR. FILEC(3).NE.IROWC) NOGO = 1
      WRITE (MOUT,570) ZZ(1),ZZ(2),FILEA(2),FILEA(3),ZZ(3),ZZ(4),
     1                 FILEB(2),FILEB(3),ZZ(5),ZZ(6),FILEC(2),IROWC
  570 FORMAT (3(4X,2A4,2I7))
      MM = -55
      GO TO 520
C
C
C               *********************
C               *                   *
C               *    METHOD  TWO    *
C               *    MPY2NT $ 2T    *
C               *    AND   MPY4T    *
C               *                   *
C               *********************
C
  600 CONTINUE
C
C     INITIALIZE FOR METHODS 2NT, 2T AND 4T.
C     METHOD 4T DOES NOT HANDLE COMPLEX MATRIX-D FROM REAL MATRICES A
C     AND B (LL4 = 6).
C
      MT4   = 0
      MT2   = T
      IF (MOD(KSYSTM(94),100)/10 .EQ. 1) GO TO 620
      IF (T.EQ.0 .OR. L41.EQ.1 .OR. LL4.EQ.6) GO TO 620
      IF (MPASS2.LE.2 .OR. CFILE.EQ.0 .OR. DENSC.LT.700) GO TO 620
      MT2   = 0
      MT4   = 2
      ACORE = NB + ND + 1
      ACORE = ((ACORE+1)/2)*2 + 1
      JZB   = ND + 1
      JB    = ND/PREC1 + 1
  620 DFILE = FILED(1)
      EFILE = SCRTCH
      BLOCK(1) = FILEA(1)
      CFILE = FILEC(1)
      OPA   = RDREW
      TYPEC = TYPED*SIGNC
      FIRSTL= BUF3 - 1
  640 WRITE (NOUT,240) METHOD(T+3+MT4),MPASS2,TIME2
C
C     BEGIN PASS
C
C     OPEN DFILE TO WRITE.
C     READ AS MANY COLUMNS (OR ROWS) OF A AS CAN BE HELD
C     IN CORE IN PACKED FORM ON THIS PASS.
C
      ACOL1 = 1
  650 FILE = DFILE
      CALL OPEN  (*500,DFILE,Z(BUF3),WRTREW)
      CALL FNAME (FILED(1),BCD)
      CALL WRITE (DFILE,BCD,2,1)
      FILED(2) = 0
      FILED(6) = 0
      FILED(7) = 0
      FILE = FILEA(1)
      CALL GOPEN (FILEA,Z(BUF2),OPA)
      APOINT = ACORE
      L    = FIRSTL
      ACOL = ACOL1
CWKBR 9/94   660 IF ( (APOINT+NA+2) .GE. L-2) GO TO 530   
C ABOVE CHECK WAS OVER-ZEALOUS IN CHECKING FOR AVAILABLE MEMORY
C BECAUSE OF THE CHECK TWO LINES AFTER STATEMENT 670
  660 IF ( (APOINT+2) .GE. L-2) GO TO 750   
      ZZ(L  ) = 0
      ZZ(L-1) = 0
      BLOCK(8)=-1
      CALL GETSTR (*730,BLOCK)
      INCRA = 1
      IF (PRC(TYPE).EQ.2 .AND. PRC(TYPEA).EQ.1) INCRA = 2
      ZZ(L) = APOINT
  670 KR1 = APOINT + 2
      KRN = KR1 + NBRSTR*NWDA - 1
      IF (KRN .GE. L-2) GO TO 740
C
C     MOVE STRING FROM BUFFER TO CORE AND COMPLETE STRING DEFINITION
C     WORDS
C
      IF (PRC(TYPE).NE.2 .OR. PRC(TYPEA).NE.1) GO TO 690
C
C  -- THIS CODE NECESSARY FOR UNIVAC DOUBLE PRECISION TO SINGLE PRC.
C
      INC   = 1
      INCRA = 1
      IF (TYPE .EQ. 4) INC = 2
      KRN = KR1 + NBRSTR*INC - 1
      DO 680 II = KR1,KRN
      Z(II) = XND(POINT)
      POINT = POINT + INCRA
  680 CONTINUE
      GO TO 710
  690 IF (PRC(TYPE) .EQ. 2) POINT = POINT*2 - 1
      DO 700 II = KR1,KRN
      Z(II) = XNS(POINT)
      POINT = POINT + INCRA
  700 CONTINUE
  710 ZZ(APOINT  ) = ROW
      ZZ(APOINT+1) = NBRSTR
      ZZ(L-1) = ZZ(L-1) + 1
      APOINT  = KRN + 1
C
C     GET NEXT STRING DEFINITION
C
      CALL ENDGET (BLOCK)
      CALL GETSTR (*730,BLOCK)
      GO TO 670
C
C     END-OF-COLUMN -
C     SAVE LAST NON-ZERO TERM POSTION FOR MTHOD 4T, THEN
C     TEST FOR ALL COLUMNS
C
C     SINCE GINO IS MDS, MAKE SURE THAT THE LAST VALUES IN NBRSTR AND
C     ROW HERE ARE STILL VALID. OTHERWISE THEY MUST BE SAVED FIRST (AT
C     710) AND USED ON NEXT LINE.
C
  730 IF (MT4 .EQ. 2) ZZ(L-1) = ORF(ZZ(L-1),LSHIFT(ROW+NBRSTR-1,IHALF))
C                                    NBR + LAST NON-ZERO TERM COLUMN NO.
C
      L = L - 2
      ACOL = ACOL + 1
      IF (ACOL .LE. M) GO TO 660
C
C     ALL COLUMNS OF A ARE IN - THIS IS THE LAST PASS
C
      ACOLN = M
      CALL CLOSE (FILEA(1),CLSREW)
      GO TO 760
C
C     ALL COLUMNS OF A WILL NOT FIT ON THIS PASS.
C
  740 CALL BCKREC (FILEA(1))
  750 CALL CLOSE  (FILEA(1),CLS)
      ACOLN = ACOL - 1
C
C     IF CFILE IS PRESENT, OPEN IT.
C     IF THIS IS THE FIRST PASS, SKIP HEADER RECORD.
C     OPEN BFILE AND SKIP HEADER RECORD.
C     INITIALIZE COLUMN (OR ORW) COUNTER, BCOL, TO 1, AND BRANCH ON T.
C
  760 IF (CFILE .EQ. 0) GO TO 770
      FILE = CFILE
      CALL OPEN (*500,CFILE,Z(BUF1),RDREW)
      CALL FWDREC (*510,CFILE)
  770 FILE = FILEB(1)
      CALL OPEN (*500,FILEB(1),Z(BUF2),RDREW)
      CALL FWDREC (*510,FILEB(1))
      BCOL = 1
  780 IF (MT2 .EQ. 1) GO TO 900
C
C     UNPACK A COLUMN OF C.
C
      IF (CFILE .EQ. 0) GO TO 810
      TYPEBD = TYPEC
      IF (MT4 .NE. 0) ONE2 = 1
      PP2    = P
      CALL UNPACK (*810,CFILE,Z)
      GO TO 830
  810 DO 820 II = 1,ND
      Z(II) = 0.
  820 CONTINUE
  830 IF (MT4 .NE. 0) GO TO 850
C
C     NON-TRANSPOSE CASE, METHOD 2NT
C     ==============================
C
C     INITIATE INTERPRETATION OF A COLUMN OF B.
C
C     ITYPSG = TYPED*SIGNAB
      ITYPSG = TYPEB*SIGNAB
      CALL INTPK (*860,FILEB(1),0,ITYPSG,0)
C
C     FOR EACH NON-ZERO ELEMENT B(I) IN THE CURRENT COLMN OF B SUCH
C     THAT FOR I.GE.ACOL1 .AND I.LE.ACOLN, FORM ALL PRODUCTS OF
C     D(K,I) = A(K,I)*B(I) + C(K,I)
C
      CALL MPY2NV (ZZ,Z,ZD)
      GO TO 860
C
C     TRNASPOSE CASE, METHOD 4T
C     =========================
C
C     UNPACK A BANDED COLUMN OF MATRIX B, RANGING FROM ONE2 THRU PP2.
C     FOR THE RANGE  MAX0(ONE2,ACOL1) THRU MIN0(PP2,ACOLN), FORM ALL
C     PRODUCTS
C     D(I,K) = A(I,J)*B(J,K) + C(I,K)
C
  850 TYPEBD = TYPEB*SIGNAB
      ONE2   = 0
      CALL UNPACK (*860,FILEB,Z(JZB))
C
C     WE HAVE HERE -
C     ACLO1, ACOLN = COLUMNS OF MATRIX A IN CORE
C     BCOL = CURRENTLY WE ARE WORKING ON THE BCOL COLUMN OF MATRIX B,
C            WHICH IS ALSO THE WORKING COLUMNS OF MATRIX D AND MATRIX C
C     Z(JZB) THRU Z(ACORE-1) CONTAIN THE BCOL COLUMN OF MATRIX B
C
      CALL MPY4T (Z,Z,Z)
C
C     PACK CURRENT COLUMN ONTO DFILE FOR BOTH 2NT AND 4T METHOD, AND
C     GO TO TEST FOR END OF PASS.
C
  860 CALL PACK (Z,DFILE,FILED)
      GO TO 980
C
C     TRANSPOSE CASE, METHOD 2T
C     =========================
C
C     INITIATE BUILDING OF A PACKED COLUMN OF D.
C     UNPACK A COLUMN OF B IN CORE. IF NULL, COPY COLUMN FROM C TO D.
C     INITIATE INTERPRETATION OF A COLUMN OF C.
C
  900 CALL BLDPK (TYPED,TYPD,DFILE,0,0)
      TYPEBD = TYPEB*SIGNAB
      PP2  = R
      CALL UNPACK (*910,FILEB(1),Z)
      EOL  = 1
      CROW = 16777215
C            16777215 = 2**24 - 1
C
      IF (CFILE .EQ. 0) GO TO 960
      CALL INTPK (*960,CFILE,0,TYPEC,0)
      CROW = 0
      GO TO 960
  910 IF (CFILE .EQ. 0) GO TO 970
      CALL INTPK (*970,CFILE,0,TYPEC,0)
  920 CALL ZNTPKI
      CROW = IP
  930 DO 940 II = 1,NWDD
      D(II) = A(II)
  940 CONTINUE
      DROW = CROW
      CALL ZBLPKI
  950 IF (EOL .EQ. 0) GO TO 920
      GO TO 970
C
C     FOR ALL NON-NULL ROWS OF A IN CORE, FORM A(I,J)*B(J) + C(I)
C
  960 CALL MPY2TV (ZZ,Z,ZD)
      IF (AROWN.EQ.M .OR. CROW.EQ.16777215) GO TO 970
      IF (CROW .GT. AROWN) GO TO 930
      GO TO 950
C
C     TERMINATE CURRENT COLUMN OF D.
C
  970 CALL BLDPKN (DFILE,0,FILED)
C
C     BOTH TRANSPOSE (2T AND 4T) AND NON-TRANSPOSE (2NT) CASES
C
C     TEST FOR COMPLETION OF PASS. IF COMPLETE, TEST ALL PASSES.
C
  980 BCOL = BCOL + 1
      IF (BCOL .LE. Q) GO TO 780
      CALL CLOSE (FILEB,CLSREW)
      IF (CFILE .NE. 0) CALL CLOSE (CFILE,CLSREW)
      CALL CLOSE (DFILE,CLSREW)
      IF (ACOLN .EQ. M) GO TO 1010
C
C     NOT LAST PASS - SWITCH C AND D FILES AND CONTINUE
C
      OPA   = RD
      TYPEC = TYPED
      IF (ACOL1 .EQ. 1) GO TO 990
      K     = CFILE
      CFILE = DFILE
      DFILE = K
      GO TO 1000
  990 CFILE = DFILE
      DFILE = EFILE
 1000 ACOL1 = ACOLN + 1
      GO TO 650
C
C     LAST PASS -
C     MAKE SURE D MATRIX IS ON PROPER FILE.
C     IF NOT, SWITCH FIST AND FIAT UNIT NBRS IN /XFIAT/
C
 1010 IF (DFILE .NE. FILED(1)) CALL FILSWI (DFILE,FILED)
      GO TO 380
C
C     A MATRIX OR B MATRIX IS NULL - COPY C MATRIX TO D MATRIX
C
 1100 TIME = 0.0
      IF (FILED(1) .LT. 0) GO TO 1600
      IF (Q .LE. 0) Q = FILEC(2)
      FILED(2) = 0
      FILED(6) = 0
      FILED(7) = 0
      WRITE  (NOUT,1140)
 1140 FORMAT ('             MPYAD - NULL MATRIX PRODUCT')
      CALL GOPEN (FILED,Z(BUF1),WRTREW)
      IF (CFILE .EQ. 0) GO TO 1150
      IF (TYPEC .EQ. SIGNC*TYPD) GO TO 1170
      GO TO 1200
C
C     PACK NULL COLUMNS BECAUSE C MATRIX IS NULL
C
 1150 PP1 = 1
      DO 1160 ACOL = 1,Q
      CALL PACK (ZERO,FILED,FILED)
 1160 CONTINUE
      GO TO 1190
C
C     USE CPYSTR TO COPY C TO D
C
 1170 BLOCK(1) = CFILE
      BLK(1)   = FILED(1)
      CALL GOPEN (CFILE,Z(BUF2),RDREW)
      DO 1180 II = 1,Q
      CALL CPYSTR (BLOCK,BLK,0,0)
 1180 CONTINUE
      CALL CLOSE (CFILE,CLSREW)
      FILED(2) = Q
      FILED(5) = FILEC(5)
      FILED(6) = FILEC(6)
      FILED(7) = FILEC(7)
 1190 IF (FILEC(1) .GT. 0) FILED(4) = FILEC(4)
      CALL CLOSE (FILED,CLSREW)
      GO TO 380
C
C     USE INTPK/BLDPK TO COPY C TO D BECAUSE TYPES CONFLICT
C
 1200 CALL GOPEN (CFILE,Z(BUF2),RDREW)
      DO 1230 II = 1,Q
      CALL BLDPK (TYPD,TYPD,FILED,BLOCK,1)
      ITYPSG = SIGNC*TYPD
      CALL INTPK (*1220,FILEC,0,ITYPSG,0)
 1210 CALL ZNTPKI
      CALL BLDPKI (A,IP,FILED,BLOCK)
      IF (EOL .EQ. 0) GO TO 1210
 1220 CALL BLDPKN (FILED,BLOCK,FILED)
 1230 CONTINUE
      CALL CLOSE (CFILE,CLSREW)
      GO TO 1190
C
C
C               *********************
C               *                   *
C               *    METHOD THREE   *
C               *       MPY3T       *
C               *                   *
C               *********************
C
C     TRANSPOSE CASE ONLY, METHOD 3T
C     ==============================
C
 1300 CONTINUE
      WRITE (NOUT,240) METHOD(5),MPASS3,TIME3
      BLOCK(1) = FILEB(1)
      ACORE = ORF(ND+1,1)
      CFILE = SCRTCH
      DFILE = FILED(1)
      IF (MOD(MPASS3,2) .NE. 0) GO TO 1340
      CFILE = FILED(1)
      DFILE = SCRTCH
 1340 AROW1 = 1
      LAST  = .FALSE.
      OPA   = RDREW
C
C     BEGIN PASS BY FILLING CORE WITH UNPACKED COLUMNS OF A
C
 1350 AROWN = MIN0(AROW1+NBRROW-1,M)
      IF (AROWN .EQ. M) LAST = .TRUE.
      CALL GOPEN (FILEA,Z(BUF1),OPA)
      TYPEBD = TYPEA*SIGNAB
      PP2    = N
      APOINT = ACORE
      DO 1390 AROW = AROW1,AROWN
      CALL UNPACK (*1360,FILEA,Z(APOINT))
      GO TO 1380
 1360 K2 = APOINT + NA - 1
      DO 1370 II = APOINT,K2
      Z(II) = 0.
 1370 CONTINUE
 1380 APOINT = APOINT + NA
 1390 CONTINUE
      II = CLS
      IF (LAST) II = CLSREW
      CALL CLOSE (FILEA,II)
      INCRA = (AROWN-AROW1)*NA
C
C     PREPARE TO PASS B MATRIX AND C MATRIX FROM LAST PASS
C
      IF (AROW1 .NE. 1) CALL GOPEN (CFILE,Z(BUF2),RDREW)
      CALL GOPEN (DFILE,Z(BUF3),WRTREW)
      CALL GOPEN (FILEB,Z(BUF1),RDREW )
      IF (LAST .AND. FILEC(1).NE.0) CALL GOPEN (FILEC,Z(BUF4),RDREW)
      FILED(2) = 0
      FILED(6) = 0
      FILED(7) = 0
      TYPEBD   = TYPED
      PP2 = AROWN
      K2  = AROWN*NWDD
C
      DO 1530 BCOL = 1,Q
      IF (AROW1 .NE. 1) GO TO 1420
C
C     FIRST PASS OR NULL COLUMN ON CFILE - SET COLUMN OF D TO ZERO
C
 1400 DO 1410 II = 1,K2
 1410 Z(II) = 0.
      NULL  = .TRUE.
      IF (LAST) GO TO 1430
      GO TO 1500
C
C     INTERMEDIATE PASS OR LAST PASS - UNPACK COLUMN FROM PREVIOUS PASS
C
 1420 CALL UNPACK (*1400,CFILE,Z)
      NULL = .FALSE.
      IF (.NOT.LAST) GO TO 1500
C
C     LAST PASS - ADD COLUMN FROM C MATRIX (IF PRESENT)
C
 1430 IF (FILEC(1) .EQ. 0) GO TO 1500
      ITYPSG = TYPED*SIGNC
      CALL INTPK (*1500,FILEC,0,ITYPSG,0)
      NULL = .FALSE.
 1440 CALL ZNTPKI
      GO TO (1450,1460,1470,1480), TYPED
 1450 Z(IP) = Z(IP) + A(1)
      GO TO 1490
 1460 ZD(IP) = ZD(IP) + AD(1)
      GO TO 1490
 1470 Z(2*IP-1) = Z(2*IP-1) + A(1)
      Z(2*IP  ) = Z(2*IP  ) + A(2)
      GO TO 1490
 1480 ZD(2*IP-1) = ZD(2*IP-1) + AD(1)
      ZD(2*IP  ) = ZD(2*IP  ) + AD(2)
 1490 IF (EOL .EQ. 0) GO TO 1440
C
C     FOR EACH NON-ZERO TERM B(J) IN THE CURRENT COLUMN OF B FORM
C     D(I,K) = D(I,K) + A(I,J)*B(J,K)
C
 1500 CALL MPY3T (*1510,Z(ACORE),Z(ACORE),Z(1),Z(1))
      GO TO 1520
C
C     PACK NULL COLUMN
C
 1510 IF (.NOT.NULL) GO TO 1520
      PP1 = 1
      CALL PACK (ZERO,DFILE,FILED)
      GO TO 1530
C
C     PACK NON-NULL COLUMN
C
 1520 PP1 = AROWN
      CALL PACK (Z,DFILE,FILED)
C
C     TEST FOR END OF CURRENT PASS
C
 1530 CONTINUE
C
      IF (AROW1 .NE. 1) CALL CLOSE (CFILE,CLSREW)
      CALL CLOSE (DFILE,CLSREW)
      CALL CLOSE (FILEB,CLSREW)
      IF (LAST) GO TO 1540
C
C     NOT LAST PASS - SWITCH FILES AND CONTINUE
C
      II    = CFILE
      CFILE = DFILE
      DFILE = II
      AROW1 = AROWN + 1
      OPA   = RD
      GO TO 1350
C
C     LAST PASS - SIGNAL END AND RETURN
C
 1540 IF (FILEC(1) .NE. 0) CALL CLOSE (FILEC,CLSREW)
      GO TO 380
C
 1600 RETURN
      END

      SUBROUTINE DDAMAT
C
C     DDAMAT  A,B/C/C,Y,GG=1.  $
C
C     DDAMAT  TAKES THE OUTER PRODUCT OF MATRICES A AND B, AND MULTIPLES
C     BY GG TO GET C, I.E.  CIJ=GG*(AIJ*BIJ).  ALSO, IF B HAS ONLY ONE
C     COLUMN, AND NUMBER OF COLUMNS OF A .GT. 1, THEN USE THAT COLUMN
C     ON EACH COLUMN OF A.
C
      INTEGER          A,B,C,BUF1,BUF2,BUF3
      DOUBLE PRECISION DZ(1), DGG, GGDZ
      DIMENSION        NAM(2),MCB(7)
      COMMON /UNPAKX/  JOUT,III,NNN,JNCR
      COMMON /PACKX /  IIN,IOUT,II,NN,INCR
      COMMON /SYSTEM/  IBUF(80)
      COMMON /BLANK /  GG
      COMMON /ZZZZZZ/  Z(1)
      EQUIVALENCE      (IPREC,IBUF(55)),(Z(1),DZ(1))
      DATA    A,B,C /  101,102,201  /
      DATA    NAM   /  4HDDAM,4HAT  /
C
C     SET PACK AND UNPACK PARAMETER
C
      JOUT = IPREC
      IIN  = IPREC
      IOUT = IPREC
      INCR = 1
      JNCR = 1
      II   = 1
      III  = 1
C
C     SET OPEN CORE
C
      LCORE = KORSZ(Z)
      BUF1  = LCORE - IBUF(1) + 1
      BUF2  = BUF1 - IBUF(1)
      BUF3  = BUF2 - IBUF(1)
      LCORE = BUF3 - 1
      IF (LCORE .LE. 0) GO TO 1008
C
      MCB(1) = A
      CALL RDTRL (MCB)
      NCOLA  = MCB(2)
      NROWA  = MCB(3)
      MCB(1) = B
      CALL RDTRL (MCB)
      NCOLB  = MCB(2)
      NROWB  = MCB(3)
      IF (NROWA .NE. NROWB) GO TO 1007
      IF (LCORE .LT. 2*NROWA*IPREC) GO TO 1008
C
C     NO. OF COLUMNS OF A AND B MUST BE EQUAL OR
C     NO. OF COLUMNS OF B MUST BE 1
C
      IF (NCOLA .EQ. NCOLB) GO TO 5
      IF (NCOLB .EQ.     1) GO TO 5
      GO TO 1007
C
    5 NN  = NROWA
      NNN = NROWA
      MCB(1) = C
      MCB(2) = 0
      MCB(3) = NROWA
      MCB(6) = 0
      MCB(7) = 0
      IF (IPREC .EQ. 2) DGG = GG
C
      CALL GOPEN (A,Z(BUF1),0)
      CALL GOPEN (B,Z(BUF2),0)
      CALL GOPEN (C,Z(BUF3),1)
C
C     UNPACK A COLUMN OF A AND B, COMPUTE PRODUCTS, AND PACK TO C.
C     IF I.GT.1 AND B=1, USE THE ONE COLUMN OF B OVER AGAIN.
C
      DO 70 I = 1,NCOLA
C
      INULL = 0
      GO TO (10,40), IPREC
   10 GGZ = GG
      CALL UNPACK (*11,A,Z(1))
      GO TO 12
   11 INULL = 1
   12 IF (I.GT.1 .AND. NCOLB.EQ.1) GO TO 20
      CALL UNPACK (*15,B,Z(NROWA+1))
      GO TO 20
   15 INULL = 1
      DO 16 J = 1,NROWA
   16 Z(NROWA+J) = 0.
   20 IF (INULL .EQ. 1) GGZ = 0.
      DO 30 J = 1,NROWA
      Z(J) = GGZ*Z(J)*Z(NROWA+J)
   30 CONTINUE
      CALL PACK (Z(1),C,MCB)
      GO TO 70
   40 GGDZ = DGG
      CALL UNPACK (*41,A,DZ(1))
      GO TO 42
   41 INULL = 1
   42 IF (I.GT.1 .AND. NCOLB.EQ.1) GO TO 50
      CALL UNPACK (*45,B,DZ(NROWA+1))
      GO TO 50
   45 INULL = 1
      DO 46 J = 1,NROWA
   46 DZ(NROWA+J) = 0.D0
   50 IF (INULL .EQ. 1) GGDZ = 0.D0
      DO 60 J = 1,NROWA
      ISUB  = NROWA + J
      DZ(J) = GGDZ*DZ(J)*DZ(ISUB)
   60 CONTINUE
      CALL PACK (DZ(1),C,MCB)
C
C     DO ANOTHER COLUMN
C
   70 CONTINUE
C
      CALL WRTTRL (MCB)
      CALL CLOSE (A,1)
      CALL CLOSE (B,1)
      CALL CLOSE (C,1)
      RETURN
C
C     FATAL ERROR MESSAGE
C
 1007 K = -7
      GO TO 1010
 1008 K = -8
 1010 CALL MESAGE (K,0,NAM)
      RETURN
      END

      SUBROUTINE RSORT (NWDS,KEYWX,L,NX)
C
C     RSORT SORTS REAL NUMBERS IN L(NWDS,NCOL)
C           WHERE NCOL = IABS(NX)/NWDS
C
C     IF KEYWX .LT. 0 SORT BY ABSOLUTE VALUE
C     IF NX    .LT. 0 SORT IN DECREASING SEQUENCE
C
C     COMMENTS FROM G.C./UNISYS
C     THIS ROUTINE IS INEFFICIENT FOR LARGE ARRAY OF L
C
      LOGICAL MAG,BCK
      REAL    L(1),TEMP(50)
      INTEGER NAM(2)
      COMMON /SYSTEM/ IBUF,NOUT
      DATA    NAM   / 4HRSOR, 4HT    /
C
      IF (NWDS .LE. 50) GO TO 30
      WRITE  (NOUT,20)
   20 FORMAT (' *** ARRAY TEMP OF 50 EXCEEDED')
      CALL MESAGE (-37,0,NAM)
C
   30 MAG = .FALSE.
      BCK = .FALSE.
      IF (KEYWX .LT. 0) MAG = .TRUE.
      IF (NX    .LT. 0) BCK = .TRUE.
      KEYWD= IABS(KEYWX)
      NNN  = IABS(NX)
      III  = NWDS+KEYWD
      IA   = NWDS-KEYWD
      IF (NNN-NWDS-NWDS .LT. 0) GO TO 150
      DO 140 I = III,NNN,NWDS
      JJ = I-NWDS
      IF (BCK) GO TO 40
      IF (MAG) IF (ABS(L(I))-ABS(L(JJ))) 50,140,140
      IF (L(I)-L(JJ)) 50,140,140
   40 IF (MAG) IF (ABS(L(JJ))-ABS(L(I))) 50,140,140
      IF (L(JJ)-L(I)) 50,140,140
   50 JJ = JJ-NWDS
      IF (JJ .LE. 0) GO TO 70
      IF (BCK) GO TO 60
      IF (MAG) IF (ABS(L(I))-ABS(L(JJ))) 50,80,80
      IF (L(I) - L(JJ)) 50,80,80
   60 IF (MAG) IF (ABS(L(JJ))-ABS(L(I))) 50,80,80
      IF (L(JJ)-L(I)) 50,80,80
   70 JJ = NWDS
      GO TO 90
   80 JJ = JJ+IA+NWDS
   90 II = I-KEYWD
      DO 100 J = 1,NWDS
      II = II+1
  100 TEMP(J) = L(II)
  110 IIA = II-NWDS
      L(II) = L(IIA)
      II = II-1
      IF (II-JJ) 120,120,110
  120 II = II-NWDS
      DO 130 J = 1,NWDS
      II = II+1
  130 L(II) = TEMP(J)
  140 CONTINUE
C
  150 RETURN
      END

      SUBROUTINE FA1
C
C     FA1 IS THE DRIVER FOR PART ONE OF FLUTTER ANALYSIS
C
      INTEGER         SYSBUF,OUT,BUFF,BUFF1,NS(2),FLOOP,TSTART,
     1                KHH,BHH,MHH,QHHL,CASECC,FLIST,FSAVE,KXHH,MXHH,
     2                BXHH,SCR1,REC0(8),FLUT(10),IMETH(2),FMETHD,SMETH,
     3                TRL(10),AERO(2),FLFACT(2),FLUTER(2),
     4                SR,SM,SK,PR,PM,PK,SL,IBLOCK(12),METHOD(4)
      REAL            BLOCK(12),REC(8),KFREQ,RHO
      DIMENSION       DLT(3),Z(1)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /SYSTEM/ SYSBUF,OUT
      COMMON /BLANK / FLOOP,TSTART,ICEAD
      COMMON /OUTPUT/ HDG(96)
      COMMON /PACKX / ITI,ITO,IJ,NN,INCR1
      COMMON /ZZZZZZ/ IZ(1)
      COMMON /UNPAKX/ IOUT,II,JJ,INCR
      EQUIVALENCE     (REC0(1),REC(1))
      EQUIVALENCE     (BLOCK(1),IBLOCK(1))
      EQUIVALENCE     (IZ(1),Z(1))
      DATA  KHH /101/,   BHH /102/,  MHH /103/, QHHL /104/, CASECC /105/
     1,   FLIST /106/, FSAVE /201/, KXHH /202/, BXHH /203/,   MXHH /204/
      DATA  SCR1/301/,    NS /4HFA1 ,4H    /
      DATA  IMETH   /  4HS   ,4HL   /
      DATA  NMD /4  /, METHOD/4HK   ,4HKE  ,4HPK  ,4HINV /
      DATA  TRL     /  90,1006,7*0,6 /
      DATA  AERO    /  3202,32 /,   FLFACT /4102,41/,   FLUTER /3902,39/
C
      DO 5 I = 1,12
    5 IBLOCK(I) = 0
      NCORE = KORSZ(IZ)
      BUFF  = NCORE - SYSBUF - 1
      BUFF1 = BUFF  - SYSBUF
      IF (FLOOP .NE. 0) GO TO 200
C
C     FIRST TIME THROUGH FIND FMETHOD ON CASECC
C
      IFILE = CASECC
      CALL GOPEN (CASECC,IZ(BUFF+1),0)
      CALL READ (*530,*10,CASECC,IZ,BUFF,1,NWR)
   10 LCC = NWR
      CALL CLOSE (CASECC,1)
C
C     GET DATA FOR REC0 OF FSAVE
C
      CALL FNAME (FSAVE,REC0)
      IFILE = FLIST
      CALL PRELOC (*480,IZ(BUFF+1),FLIST)
      CALL LOCATE (*470,IZ(BUFF+1),AERO,IDUM)
      CALL READ (*530,*530,FLIST,REC0(4),4,1,NWR)
      REC(6) = REC(6)*0.5
      CALL LOCATE (*15,IZ(BUFF+1),FLFACT,IDUM)
      CALL READ (*530,*20,FLIST,IZ(LCC+1),BUFF,1,NWR)
      GO TO 400
   15 NWR = 0
   20 LFL = NWR + LCC
      CALL LOCATE (*450,IZ(BUFF+1),FLUTER,IDUM)
   30 CALL READ (*530,*450,FLIST,FLUT,10,0,NWR)
      I165 = 165
      IF (FLUT(1) .NE. IZ(I165)) GO TO 30
      CALL CLOSE (FLIST,1)
      REC0(8) = FLUT(9)
      IEP = FLUT(10)
      DO 40 I = 1,NMD
      IF (FLUT(2) .EQ. METHOD(I)) GO TO 50
   40 CONTINUE
      GO TO 490
   50 REC0(3) = I
      FMETHD = I
      GO TO (60,60,61,490), I
   60 REC0(4) = 0
      IF (FLUT(7) .EQ. IMETH(1)) REC0(4) = 1
      IF (FLUT(7) .EQ. IMETH(2)) REC0(4) = 2
      IF (REC0(4) .EQ. 0) GO TO 430
      SMETH = REC0(4)
      GO TO 65
C
C     PK METHOD HAS LINEAR SPLINE ONLY
C
   61 REC0(4) = 2
      SMETH = 2
   65 CONTINUE
C
C     BUILD RECORDS 0,1,2,3 OF SAVE
C
      IFILE = FSAVE
      CALL OPEN (*480,FSAVE,IZ(BUFF+1),1)
      CALL WRITE (FSAVE,REC0,8,1)
      BREF = REC(6)
      RREF = REC(7)
      NEIW = REC0(8)
C
C     BUILD M,K,RHO LIST FOR FLUTTER LOOP
C
      SR = 0
      SM = 0
      SK = 0
      I  = LCC
      IF (I .EQ. LFL) GO TO 410
   70 I  = I + 1
      IF (IZ(I) .EQ. FLUT(4)) SR = I
      IF (IZ(I) .EQ. FLUT(5)) SM = I
      IF (IZ(I) .EQ. FLUT(6)) SK = I
   80 I = I + 1
      IF (I .GE. LFL) GO TO 90
      IF (IZ(I) .EQ. -1) GO TO 70
      GO TO 80
   90 IF (SR.EQ.0 .OR. SM.EQ.0 .OR. SK.EQ.0) GO TO 410
      NRHO = 0
      PR = SR
   95 PR = PR + 1
      IF (IZ(PR) .EQ. -1) GO TO 97
      NRHO = NRHO + 1
      GO TO 95
   97 NLOOPS = 0
      IF (FMETHD .NE. 3) GO TO 105
C
C     J.PETKAS/LOCKHEED      3/91
C     19 LINES OF OLD CODE FOR BUILDING ELEMENTS OF FSAVE FOR PK METHOD
C     WERE IN ERROR, AND ARE NOW REPLACED BY NEXT 29 NEW LINES
C
      PM = SM
  101 PM = PM + 1
      IF (IZ(PM) .EQ. -1) GO TO 130
      DLT(1) = Z(PM)
C
C     CENTER LOOP ON RHO
C
      PR = SR
  102 PR = PR + 1
      IF (IZ(PR) .EQ. -1) GO TO 101
      DLT(3) = Z(PR)
C
C     INNER LOOP ON VELOCITY
C
      PK = SK
  103 PK = PK + 1
      IF (IZ(PK) .EQ. -1) GO TO 102
      DLT(2) = Z(PK)
      NLOOPS = NLOOPS + 1
      CALL WRITE (FSAVE,DLT,3,0)
      GO TO 103
C
C     ALGORITHM FOR BUILDING ELEMENTS OF FSAVE FOR K AND KE METHODS
C
  105 CONTINUE
C
C     OUTER LOOP ON MACH NUMBER
C
      PM = SM
  107 PM = PM + 1
      IF (IZ(PM) .EQ. -1) GO TO 130
      DLT(1) = Z(PM)
C
C     CENTER LOOP ON KFREQ
C
      PK = SK
  110 PK = PK + 1
      IF (IZ(PK) .EQ. -1) GO TO 107
      DLT(2) = Z(PK)
C
C     INNER LOOP ON RHO
C
      PR = SR
  120 PR = PR + 1
      IF (IZ(PR) .EQ. -1) GO TO 110
      DLT(3) = Z(PR)
      NLOOPS = NLOOPS + 1
      CALL WRITE (FSAVE,DLT,3,0)
      GO TO 120
  130 CALL WRITE (FSAVE,0,0,1)
C
C     PICK UP M AND K FROM QHHL
C
      IFILE = QHHL
      CALL OPEN (*480,QHHL,IZ(BUFF1+1),0)
      CALL READ (*530,*140,QHHL,IZ(LCC+1),BUFF1,1,NWR)
      GO TO 400
  140 LFL = NWR + LCC
      SL  = LCC + 5
      CALL CLOSE (QHHL,1)
      REC0(1) = QHHL
      CALL RDTRL (REC0)
      NP  = MIN0(IZ(SL-1),REC0(2)/REC0(3))
      LFL = MIN0(LFL,2*NP+SL-1)
      NP  = LFL - SL + 1
      CALL WRITE (FSAVE,IZ(SL),NP,1)
      NP  = NP/2
C
C     WRITE CASECC RECORD AND TRAILER
C
      CALL WRITE (FSAVE,IZ(1),LCC,1)
      CALL CLOSE (FSAVE,1)
      REC0(1) = FSAVE
      REC0(2) = FLOOP
      REC0(3) = NLOOPS
      REC0(4) = NP
      REC0(5) = LCC
      REC0(6) = 0
      REC0(7) = NRHO
      CALL WRTTRL (REC0)
      GO TO 210
  200 IFILE = FSAVE
      CALL OPEN (*480,FSAVE,IZ(BUFF+1),0)
      CALL READ (*530,*530,FSAVE,IZ(1),8,1,NWR)
      CALL CLOSE (FSAVE,1)
      IZX   = 0
      FMETHD= IZ(IZX+3)
      SMETH = IZ(IZX+4)
      BREF  =  Z(IZX+6)
      RREF  =  Z(IZX+7)
      NEIW  = IZ(IZX+8)
  210 REC0(1) = FSAVE
      CALL RDTRL (REC0)
C
C     START OF LOOPING BUMP LOOP COUNTER SET TIME AND GO
C
      FLOOP = FLOOP + 1
      NLOOPS= REC0(3)
      CALL KLOCK (TSTART)
      GO TO (220,230,240,490), FMETHD
C
C     K METHOD BUILD PROPER QHH ON SCR1
C
  220 CALL FA1K (SMETH,KFREQ,RHO,SCR1,0)
      GO TO 300
C
C     KE METHOD DO INCORE EIGNVALUE EXTRACTION
C
  230 REC0(1) = BHH
      CALL RDTRL (REC0)
      IF (REC0(1).GT.0 .AND. REC0(7).GT.0) GO TO 510
      REC0(1) = KHH
      CALL RDTRL (REC0)
      ICO = REC0(2)*REC0(2)*4 + 4
  235 CALL FA1K (SMETH,KFREQ,RHO,SCR1,ICO)
      CALL FA1KE (SCR1,KFREQ,BREF,RHO,RREF,FLOOP,NLOOPS)
      IF (FLOOP .GE. NLOOPS) GO TO 350
      FLOOP = FLOOP + 1
      GO TO 235
C
C     PK METHOD  LINEAR INTERPOLATION  AND INCORE LOOP FOR
C     EIGENVALUE CONVERGENCE
C
  240 CALL FA1PKI (FSAVE,QHHL)
      CALL FA1PKE (KHH,BHH,MHH,BXHH,FSAVE,NLOOPS,BREF,RREF,NEIW,IEP)
      IF (FLOOP .GE. NLOOPS) GO TO 250
      FLOOP = FLOOP  + 1
      GO TO 240
C
C     PHID  - KXHH   CLAMAD - BXHH
C
  250 IBUF = BUFF1 - SYSBUF
      TRL(1) = SCR1
      CALL RDTRL (TRL)
      IF (TRL(2) .EQ. 0) GO TO 350
      CALL OPEN (*350,SCR1,Z(IBUF),0)
      CALL READ (*290,*255,SCR1,REC,6,1,NWR)
  255 CALL READ (*290,*260,SCR1,Z,IBUF,1,NWR)
  260 NN = NWR/2
      CALL GOPEN (KXHH,Z(BUFF),1)
      CALL GOPEN (BXHH,Z(BUFF1),1)
      CALL WRITE (BXHH,TRL(1),50,0)
      CALL WRITE (BXHH,HDG,96,1)
      TRL(1) = KXHH
      TRL(2) = 0
      TRL(3) = NN
      TRL(4) = 2
      TRL(5) = 3
      ITI = 3
      ITO = 3
      IJ  = 1
      INCR1 = 1
  265 CALL WRITE (BXHH,REC,6,0)
      CALL PACK  (Z,KXHH,TRL)
      CALL READ  (*280,*270,SCR1,REC,6,1,NWR)
  270 CALL READ  (*280,*265,SCR1,Z,IBUF,1,NWR)
  280 CALL WRITE (BXHH,0,0,1)
      CALL CLOSE (BXHH,1)
      CALL CLOSE (KXHH,1)
      CALL WRTTRL (TRL)
      TRL(1) = BXHH
      TRL(2) = 1006
      TRL(7) = 0
      CALL WRTTRL (TRL)
  290 CALL CLOSE (SCR1,1)
      GO TO 350
C
C     COPY KHH TO KXHH
C
  300 CALL GOPEN (KHH,IZ(BUFF+1),0)
      CALL GOPEN (KXHH,IZ(BUFF1+1),1)
      REC0(1) = KHH
      CALL RDTRL (REC0)
      REC0(1) = KXHH
      IOUT = REC0(5)
      INCR = 1
      I = REC0(2)
      REC0(2) = 0
      REC0(6) = 0
      REC0(7) = 0
      CALL CYCT2B (KHH,KXHH,I,Z,REC0)
      CALL CLOSE  (KHH,1)
      CALL CLOSE  (KXHH,1)
      CALL WRTTRL (REC0)
C
C     BUILD BXHH = (K/B)BHH
C
      REC0(1) = BHH
      CALL RDTRL (REC0)
      IF (REC0(1) .LE. 0) GO TO 310
      IBLOCK(2) = 1
      BLOCK(3) = KFREQ/BREF
      CALL SSG2C (BHH,0,BXHH,0,BLOCK(2))
  310 CONTINUE
C
C                2  2
C     MXHH  =  (K /B ) MHH  + (RHO*RREF/2.0) QHH
C
      IBLOCK(2) = 1
      BLOCK (3) = (KFREQ*KFREQ)/(BREF*BREF)
      IBLOCK(8) = 1
      BLOCK (9) = RHO*RREF/2.0
      CALL SSG2C (MHH,SCR1,MXHH,0,BLOCK(2))
C
C     THE END
C
  350 CONTINUE
      REC0(1) = FSAVE
      CALL RDTRL (REC0)
      REC0(2) = FLOOP
      CALL WRTTRL (REC0)
      IF (FLOOP .EQ. NLOOPS) FLOOP = -1
      ICEAD = 1
      IF (FMETHD .EQ. 2) ICEAD = -1
      IF (FMETHD .EQ. 3) ICEAD = -1
      GO TO 600
C
C     ERROR MESSAGES
C
  400 CALL MESAGE (-8,0,NS)
  410 WRITE  (OUT,420) UFM,FLUT(4),FLUT(5),FLUT(6)
  420 FORMAT (A23,', ONE OR MORE OF THE FOLLOWING FLFACT SETS WERE NOT',
     1       ' FOUND - ',3I9)
      GO TO 540
  430 WRITE  (OUT,440) UFM,FLUT(7)
  440 FORMAT (A23,' 2267, INTERPOLATION METHOD ',A4,' UNKNOWN')
      GO TO 540
  450 I165 = 165
      WRITE  (OUT,460) UFM,IZ(I165)
  460 FORMAT (A23,' 2268, FMETHOD SET',I9,' NOT FOUND')
      GO TO 540
  470 CALL MESAGE (-7,0,NS)
  480 CALL MESAGE (-1,IFILE,NS)
  490 WRITE  (OUT,500) UFM,FLUT(2)
  500 FORMAT (A23,' 2269, FLUTTER METHOD ',A4,' NOT IMPLEMENTED')
      GO TO 540
  510 WRITE  (OUT,520) UFM,FLUT(2)
  520 FORMAT (A23,', FLUTTER METHOD ',A4,' NOT IMPLEMENTED WITH B ',
     1       'MATRIX')
      GO TO 540
  530 CALL MESAGE (-3,IFILE,NS)
  540 CALL MESAGE (-61,0,NS)
C
  600 RETURN
      END

      SUBROUTINE MMARC2 ( ZI, ZD )
C  MMARC2 - This routine will store a matrix column in memory in compact
C           form and in real double precision.  The input matrix is 
C           assumed to be stored as either real single or double precision.
C           The column is stored in memory according to the following scheme:
C
C
C  1st word = row position of first element in following string 
C  2nd word = number of terms in string (ntms)
C  3rd word           }
C     |               }
C     |               } = actual
C     |               }   matrix
C     |               }   string
C     |               }   data
C     |               }
C     |               }
C  3+(ntms*prec)      } (where prec=1 for s.p.;  =2 for d.p. )
C
C  The above data repeats for all strings within a column 
C
C  Argument list :
C     ZI  - Memory for storage of data (integer)
C     ZD  - Same location as ZI but real double reference 
C
      INTEGER          ZI(1)
      INTEGER          IBLK(15) 
      REAL             RXL(1)       
      DOUBLE PRECISION ZD(1), DXL     
      INCLUDE          'MMACOM.COM'          
      COMMON  /ZZZZZZ/ DXL(1)
      EQUIVALENCE      ( DXL,RXL )
      MEM      = 1
      DO 10 I  = 1,15
 10   IBLK(I)  = 0
      IBLK(1)  = IRFILE
      IBLK(8)  = -1     
      LASIND   = MEM - 1        
      ZI( MEM ) = 0
  100 CALL GETSTR ( *7000, IBLK )
      ITYPE    = IBLK( 2 )
      JROW     = IBLK( 4 )      
      INDEX    = IBLK( 5 )
      NTMS     = IBLK( 6 )
      ZI(MEM)  = JROW
      ZI(MEM+1)= NTMS
      GO TO ( 110, 120 ), ITYPE
  110 CONTINUE
      MINDEX   = MEM/2 + 1
      DO 115 II = 1,NTMS
      ZD( MINDEX+II ) = SIGN*RXL( INDEX+II-1 )
  115 CONTINUE
      GO TO 180
  120 CONTINUE
      MINDEX     = MEM/2+1
      DO 125 II  = 1,NTMS
      ZD( MINDEX+II ) = SIGN*DXL( INDEX+II-1 )
  125 CONTINUE
  180 CONTINUE
      MEM        = MEM + 2 + NTMS*2  
      CALL ENDGET ( IBLK )
      GO TO 100
 7000 CONTINUE  
      LASIND     = MEM - 1        
      RETURN        
      END

      SUBROUTINE SDCIN (BLOCK,AC,N,VECS,VECD)
C
C     SDCIN USES GETSTR/ENDGET TO READ A ROW OF A MATRIX AND ADD THE
C     TERMS OF THE ROW INTO A VECTOR
C
C     BLOCK = A 15-WORD ARRAY IN WHICH BLOCK (1) = GINO NAME
C     AC    = A VECTOR OF N COLUMN POSITIONS (COL NBRS MAY BE .LT. 0)
C     N     = NUMBER OF WORDS IN AC AND NUMBER OF TERMS IN VECS
C     VECS  = A VECTOR OF N TERMS. THE POS OF EACH TERM IS DEFINED BY
C     THE NUMBER STORED IN THE CORRESPONDING POSITION IN AC
C     VECD  = SAME VECTOR AS VECS
C
      INTEGER          AC(1)    ,PRC     ,WORDS    ,RLCMPX   ,TYPE   ,
     1                 RC       ,PREC    ,BLOCK(15)
      REAL             VECS(1)  ,XNS(1)
      DOUBLE PRECISION XND      ,VECD(1)
      COMMON /TYPE  /  PRC(2)   ,WORDS(4) ,RLCMPX(4)
      COMMON /SYSTEM/  SYSBUF   ,NOUT
      COMMON /ZZZZZZ/  XND(1)
      EQUIVALENCE      (XND(1),XNS(1))
C
C     PERFORM GENERAL INITIALIZATION
C
      TYPE = BLOCK(2)
      PREC = PRC(TYPE)
      RC   = RLCMPX(TYPE)
      I    = 1
C
C     LOCATE POSITION IN VECTOR CORRESPONDING TO STRING
C
   10 IF (I .GT. N) GO TO 92
      DO 11 J = I,N
      IF (IABS(AC(J)) .EQ. BLOCK(4)) GO TO 12
   11 CONTINUE
      GO TO 90
   12 I = J + BLOCK(6)
      NN = BLOCK(4) + BLOCK(6) - 1
      IF (IABS(AC(I-1)) .NE. NN) GO TO 91
C
C     ADD TERMS FROM STRING INTO VECTOR
C
      II = RC*(J-1)
      JSTR = BLOCK(5)
      NSTR = JSTR + RC*BLOCK(6) - 1
      IF (PREC .EQ. 2) GO TO 24
C
      DO 22 JJ = JSTR,NSTR
      II = II + 1
      VECS(II) = VECS(II) + XNS(JJ)
   22 CONTINUE
      GO TO 30
C
   24 DO 26 JJ = JSTR,NSTR
      II = II + 1
      VECD(II) = VECD(II) + XND(JJ)
   26 CONTINUE
C
C     CLOSE CURRENT STRING AND GET NEXT STRING
C
   30 CALL ENDGET (BLOCK)
      CALL GETSTR (*99,BLOCK)
      GO TO 10
C
C     LOGIC ERRORS
C
   90 KERR = 1
      GO TO 97
   91 KERR = 2
      GO TO 97
   92 KERR = 3
      GO TO 97
   97 WRITE  (NOUT,98) KERR
   98 FORMAT (22H0*** SDCIN FATAL ERROR ,I2)
      CALL MESAGE (-61,0,0)
   99 RETURN
      END

      SUBROUTINE ALG
C
C     THIS IS THE DRIVER SUBROUTINE FOR THE ALG MODULE
C
      INTEGER         APRESS,ATEMP,STRML,PGEOM,NAME(2),SYSBUF,
     1                TITLE1(18),WD(2),ALGDB
      CHARACTER       UFM*23,UWM*25,UIM*29
      COMMON /XMSSG / UFM,UWM,UIM
      COMMON /BLANK / APRESS,ATEMP,STRML,PGEOM,IPRTK,IFAIL,SIGN,ZORIGN,
     1                FXCOOR,FYCOOR,FZCOOR
      COMMON /SYSTEM/ SYSBUF,NOUT
      COMMON /ALGINO/ ISCR3,ALGDB
      COMMON /UDSTR2/ NBLDES,STAG(21),CHORDD(21)
      COMMON /UD3PRT/ IPRTC,ISTRML,IPGEOM
      COMMON /ZZZZZZ/ IZ(1)
      COMMON /CONTRL/ NANAL,NAERO,NARBIT,LOG1,LOG2,LOG3,LOG4,LOG5,LOG6
      DATA    NAME  / 4HALG ,4H    /
      DATA    WD    / 2HNO  ,2HAN  /
      DATA    ISCR1 , ISCR2 / 301,302 /
C
      ISCR3  = 303
      ISCR4  = 304
      ISTRML = STRML
      IPGEOM = PGEOM
      IF (IPGEOM .EQ. 3) IPGEOM = 1
      IPRTC = IPRTK
      NZ    = KORSZ(IZ)
      IBUF1 = NZ - SYSBUF + 1
      IBUF2 = IBUF1 - SYSBUF
      IBUF3 = IBUF2 - SYSBUF
      IF (3*SYSBUF .GT. NZ) CALL MESAGE (-8,0,NAME)
      CALL ALGPR (IERR)
      IF (IERR .LT. 0) GO TO 400
      ALGDB = ISCR1
      IF (IERR .EQ. 1) ALGDB = ISCR2
      LOG1  = ALGDB
      LOG2  = NOUT
      LOG3  = 7
      LOG4  = ALGDB
      LOG5  = ISCR4
      LOG6  = 9
      CALL GOPEN (LOG1,IZ(IBUF1),0)
      CALL FREAD (LOG1,TITLE1,18,1)
      CALL FREAD (LOG1,NANAL,1,0)
      CALL FREAD (LOG1,NAERO,1,1)
      NARBIT = 0
      IF (IPRTC .EQ. 1) WRITE (LOG2,20) TITLE1,NANAL,WD(NAERO+1)
      IF (IPRTC .EQ. 0) WRITE (LOG2,40) UIM
   20 FORMAT (1H1,/40X,48HALG MODULE - COMPRESSOR DESIGN - CONTROL SECTI
     1ON , /40X,48(1H*), //10X,8HTITLE = ,18A4, /10X,39HNUMBER OF ANALYT
     2IC MEALINE BLADEROWS = ,I3, /10X,14HTHERE WILL BE ,A2,33H ENTRY TO
     3 THE AERODYNAMIC SECTION )
   40 FORMAT (A29,' - MODULE ALG ENTERED.')
C
      IF (NANAL .EQ. 0) GO TO 200
      IFILE = LOG5
      CALL OPEN (*500,LOG5,IZ(IBUF2),1)
      CALL ALGAN
      CALL CLOSE (LOG5,1)
  200 IF (NAERO .EQ. 0) GO TO 300
      IFILE = LOG5
      CALL OPEN (*500,LOG5,IZ(IBUF2),0)
      IFILE = ISCR3
      CALL OPEN (*500,ISCR3,IZ(IBUF3),1)
      CALL ALGAR
      CALL CLOSE (ISCR3,1)
      CALL CLOSE (LOG5,1)
  300 CALL CLOSE (LOG1,1)
      CALL ALGPO (ISCR3)
  400 GO TO 600
  500 CALL MESAGE(-1,IFILE,NAME)
C
  600 RETURN
      END

      SUBROUTINE CONM2D
C
C THIS SUBROUTINE COMPUTES THE CONCENTRATED MASS ELEMENTS MASS MATRIX
C FOR THE M2 TYPE ELEMENT
C   DOUBLE PRECISION VERSION
C
C ECPTNO  NAME       TYPE  DESCRIPTION
C ******  ****       ****  ***********
C
C   1     IELID      I     ELEMENT ID
C   2     IGP        I     GRID POINT NUMBER
C   3     ICIDT2     I     COORDINATE SYSTEM ID FOR T2
C   4     MASS       R     LUMPED MASS
C   5     OFFSET(1)  R
C   6     OFFSET(2)  R     X,Y, AND Z COORDINATES OF THE
C   7     OFFSET(3)  R     OFFSET
C   8     MMI(1,1)   R
C   9     MMI(2,1)   R     MASS MOMENTS OF INERTIA
C  10     MMI(2,2)   R
C  11     MMI(3,1)   R
C  12     MMI(3,2)   R
C  13     MMI(3,3)   R
C  14     ICIDT1     I     COORDINATE SYSTEM ID FOR T1
C  15     X          R
C  16     Y          R
C  17     Z          R
C
      INTEGER DICT(11), ELID, ESTID, IECPT(14)
      DOUBLE PRECISION MM(36),TT(36),T(36),MB,XOF,YOF,ZOF,INER(6)
C
      COMMON /SYSTEM/ SS,IOUTPT,KSYSTM(56)
C
      COMMON /EMGEST/ ECPT(100)
C
      COMMON /EMGDIC/ DMM(2),NLOCS,ELID,ESTID
C
      COMMON /EMGPRM/ DUM(15),ISMB(3),IPREC,NOGO
C
      EQUIVALENCE (ECPT(1),IECPT(1),IELID)
      EQUIVALENCE (DICT(5),DICT5)
C
C     INITIALIZE
C
      IF (ISMB(2) .EQ. 0) RETURN
      DICT(1) = ESTID
      DICT(2) = 1
      DICT(3) = 6
      DICT(4) = 63
      DICT(5) = 0
      IP = IPREC
C
C  MOVE VARIABLES TO DOUBLE PRECISION LOCATIONS
C
      MB = ECPT(4)
      DO 50 I= 1,6
  50  INER(I)= ECPT(I+7)
C
C COMPUTE NON-TRANSFORMED MASS MATRIX.  INITIALIZE TO ZERO
C THEN FILL IN NON-ZERO TERMS
C
      DO 100 I=1,36
  100 MM(I) = 0.
C
      ICIDT2 = IECPT(3)
      IF (ICIDT2 .GE. 0) GO TO 120
      ICIDT2 = 0
      DO 110 I = 1,3
  110 ECPT (I+4) = ECPT(I+4) - ECPT(I+14)
C
  120 XOF = ECPT(5)
      YOF = ECPT(6)
      ZOF = ECPT(7)
      MM(1) = MB
      MM(5) = MB*ZOF
      MM(6) = -MB*YOF
      MM(8) = MB
      MM(10) = -MM(5)
      MM(12) = MB*XOF
      MM(15) = MB
      MM(16) = -MM(6)
      MM(17) = -MM(12)
      MM(20) = MM(10)
      MM(21) = MM(16)
      X2 = XOF**2
      Y2 = YOF**2
      Z2 = ZOF**2
      MM(22) = INER(1) + (Y2 + Z2)*MB
      MM(23) = -INER(2) + MM(6)*XOF
      MM(24) =  -INER(4)+MM(10)*XOF
      MM(25) = MM(5)
      MM(27) = MM(17)
      MM(28) = MM(23)
      MM(29) = INER(3) + (X2 + Z2)*MB
      MM(30) = -INER(5) + MM(6)*ZOF
      MM(31) = MM(6)
      MM(32) = MM(12)
      MM(34) = MM(24)
      MM(35) = MM(30)
      MM(36) = INER(6) + (X2 + Y2)*MB
C
      ICIDT1 = IECPT(14)
C
C PERFORM TRANSFORMATIONS.  IF CSIDS 1 AND 2 ARE EQUAL,
C T1 = T2 SO MASS MATRIX IS COMPLETE
C
      IF (ICIDT2 .EQ. ICIDT1) GO TO 240
C                            T
C NOT EQUAL SO COMPUTE T = (T )(T )
C                            1   2
C GET T1 AND T2 IF NEEDED
      IT = 18
      IF (ICIDT1 .EQ. 0) GO TO 130
C
      CALL TRANSD (ECPT(14),T(1))
      GO TO 140
C ONLY T2 NEEDED SO T = T2
  130 IT = 9
  140 IF (ICIDT2 .EQ. 0) GO TO 150
      ITEMP = IECPT(14)
      IECPT(14) = ICIDT2
      CALL TRANSD (ECPT(14),T(10))
      IECPT(14) = ITEMP
C
      IF(ICIDT1 .EQ. 0) GO TO 210
      CALL GMMATD (T(1),3,3,2, T(10),3,3,0, T(19))
      GO TO 210
C
C HERE T2 IS IDENTITY AND T1 IS AT T(1) SO
C T = T1 (TRANSPOSE).  SO INSERT INTO T
  150 DO 170 I = 1,3
      DO 170 J = 1,3
      IJ = 3*(I-1) + J
      JI = I + 3*(J-1) + 18
170   T(JI) = T(IJ)
C
C T = (T ) (T ) IS COMPLETE. INSERT IT IN THE 6X6 TRANSFORMATION MATRIX.
C       1    2
C
  210 DO 220 I = 1,36
  220 TT(I) = 0.
C
      DO 230 I = 1,3
      IJ = I + IT
      TT(I) = T(IJ)
      TT(I + 6) = T(IJ + 3)
      TT(I + 12) = T(IJ + 6)
      TT(I + 21) = T(IJ)
      TT(I + 27) = T(IJ + 3)
  230 TT(I + 33) = T(IJ + 6)
C           T
C FORM T*M*T  AND STORE IN MM
C
      CALL GMMATD (TT(1),6,6,0, MM(1),6,6,0, T(1))
      CALL GMMATD (T(1),6,6,0, TT(1),6,6,1, MM(1))
C
  240 CALL EMGOUT (MM,MM,36,1,DICT,2,IP)
      RETURN
      END

      SUBROUTINE GPSTGN
C
C     THIS MODULE GENERATES THE GRID POINT SINGULARITY TABLE
C     BY EXAMINING THE SUBMATRICES ALONG THE LEADING DIAGONAL
C     OF THE INPUT STIFFNESS MATRIX
C
C     MODULE DMAP SEQUENCE
C
C     GPSTGEN  KGG,SIL/GPST $
C
      DIMENSION        K(3)  , MCB(7),ISUBNM(2)
C
      INTEGER          SIL   , GPST
C
      DOUBLE PRECISION B
CWKBI 8/94 SPR93026
      REAL             BS(18)
C
      COMMON /GPSTGX/  GPST  , IGPST , ISIL  , NSING , IBUF2
      COMMON /GPSTGY/  B(18)
CWKBI 8/94 SPR93026   COMMON /SYSTEM/  ISYSBF
      COMMON /SYSTEM/ ISYSBF , NOUT  , DUM(52),IPREC
      COMMON /UNPAKX/  ITYPOT, II    , JJ    , INCR
      COMMON /ZZZZZZ/  IZ(1)
CWKBI 8/94 SPR93026
      EQUIVALENCE      ( BS, B )
C
      DATA KGG, SIL /101   , 102   /
      DATA ISUBNM   /4HGPST, 4HGN  /
C
      GPST  = 201
      IGPST = 0
      NSING = 0
CWKBR 8/94 SPR93026      ITYPOT= 2
      ITYPOT= IPREC
      INCR  = 1
      K(1)  = 1
      K(2)  = 1
      IBUF1 = KORSZ (IZ) - ISYSBF - 2
      IBUF2 = IBUF1 - ISYSBF
      IFILE = SIL
      CALL OPEN (*120,SIL,IZ(IBUF1),0)
      CALL SKPREC (SIL,1)
      MCB(1) = SIL
      CALL RDTRL (MCB)
      LUSET = MCB(3)
      ICORE = LUSET + 1 - IBUF1
      IF (ICORE.GE.0) GO TO 160
      CALL READ (*140,*10,SIL,IZ,IBUF1,0,NPTS)
      GO TO 160
   10 CALL CLOSE (SIL,1)
      LOGIC = 110
      IF (NPTS.NE.MCB(2)) GO TO 150
      IZ(NPTS+1) = LUSET + 1
C
      IFILE = KGG
      CALL OPEN (*120,KGG,IZ(IBUF1),0)
      CALL SKPREC (KGG,1)
      MCB(1) = KGG
      CALL RDTRL (MCB)
      LOGIC = 120
      IF (MCB(2).NE.LUSET .OR. MCB(3).NE.LUSET) GO TO 150
C
      DO 100 I = 1, NPTS
      ITYP = 1
      ISIL = IZ(I)
      ISILNX = IZ(I+1)
      IF (ISILNX-ISIL.EQ.1) ITYP = 2
      ILOOP = 1
      IST   = 1
      II = ISIL
   20 JJ = II + 2*(2 - ITYP)
      DO 60 J = II, JJ
CWKBD 8/94 SPR93026      CALL UNPACK (*30,KGG,B(IST))
CWKBNB 8/94 SPR93026
      IF ( IPREC .EQ. 1 ) CALL UNPACK (*30,KGG,BS(IST))
      IF ( IPREC .EQ. 2 ) CALL UNPACK (*30,KGG,B(IST))
CWKBNE 8/94 SPR93026
      GO TO 50
   30 ISTX = IST + 2
CWKBI 8/94 SPR93026
      IF ( IPREC .EQ. 1 ) GO TO 45
      DO 40 III = IST, ISTX
      B(III) = 0.0D0
   40 CONTINUE
CWKBNB 8/94 SPR93026
      GO TO 50
   45 DO 48 III = IST, ISTX
      BS(III) = 0.0
   48 CONTINUE
   50 IST = IST + 3
   60 CONTINUE
      IF (ITYP .EQ.2) GO TO 70
      IF (ILOOP.EQ.2) GO TO 90
      ILOOP = 2
      II = II + 3
      GO TO 20
CWKBD 8/94 SPR93026   70 IF (B(1).GT.0.0D0) GO TO 100     
CWKBNB 8/94 SPR93026
   70 CONTINUE
      IF (IPREC. EQ. 2 .AND. B(1) .GT.0.0D0) GO TO 100     
      IF (IPREC .EQ. 1 .AND. BS(1).GT.0.0  ) GO TO 100     
CWKBNE 8/94 SPR93026
      K(3) = ISIL
      IF (IGPST.EQ.1) GO TO 80
      IGPST = 1
      CALL GOPEN (GPST,IZ(IBUF2),1)
   80 NSING = NSING + 1
      CALL WRITE (GPST,K,3,0)
      GO TO 100
CWKBD 8/94 SPR93026   90 CALL GPSTG
CWKBNB 8/94 SPR93026
   90 IF ( IPREC .EQ. 1 ) CALL GPSTGS
      IF ( IPREC .EQ. 2 ) CALL GPSTG
CWKBNE 8/94 SPR93026
  100 CONTINUE
      IF (IGPST.EQ.0) GO TO 110
      CALL WRITE (GPST,0,0,1)
      CALL CLOSE (GPST,1)
      CALL MAKMCB (MCB,GPST,NPTS,LUSET,0)
      MCB(2) = NSING
      CALL WRTTRL (MCB)
  110 CALL CLOSE (KGG,1)
      GO TO 170
C
C     ERROR MESSAGES
C
  120 N = -1
  130 CALL MESAGE (N,IFILE,ISUBNM)
  140 N = -2
      GO TO 130
  150 N = -7
      GO TO 130
  160 N = -8
      IFILE = ICORE
      GO TO 130
C
  170 RETURN
      END

      SUBROUTINE SHSTTS (TAB,UAB,VAB)
C
C     TO CREATE STRESS TENSOR TRANSFORMATION MATRICES FROM AN ORTHOGONAL
C     TRANSFORMATION FOR SHELL ELEMENTS.
C
C     INPUT :
C           TAB    - ORTHOGONAL INPLANE ROTATION TRANSFORMATION
C     OUTPUT:
C           UAB    - TENSOR TRANSFORMATION FOR NORMAL AND INPLANE SHEAR
C                    COMPONENTS
C           VAB    - TENSOR TRANSFORMATION FOR OUT-OF-PLANE SHEAR
C
C     USAGE:
C           THE INPUT IS ASSUMED TO BE ROW-LOADED.
C           OUTPUTS ARE CREATED ROW-LOADED.
C           DEFINING:
C           [S]      AS A 2-D STRESS VECTOR;
C           [E]      AS A 2-D STRAIN VECTOR;
C           [Q]      AS A 2-D SHEAR FORCE VECTOR;
C           [G]      AS A 2-D STRESS/FORCE-STRAIN RELATION; AND
C           [ALPHA]  AS A VECTOR OF THERMAL EXPANSION COEFFICIENTS,
C
C           THEN THE FOLLOWING RELATIONSHIPS ARE TRUE:
C
C                       T                        T
C           [S]  = [UAB] [S]         [G]  = [UAB] [G] [UAB]
C              A            B           A            B
C
C                       T
C           [Q]  = [VAB] [Q]
C              A            B
C
C           IF [TBA] IS INPUT, THE OUTPUT WILL BE:
C
C                -1                      -1       T
C           [UAB]  = [UBA],   AND   [VAB]  = [VAB] = [VBA]
C
C           WHICH MAY BE USED IN THE FOLLOWING:
C
C           [E]  = [UBA] [E]         [ALPHA]  = [UBA] [ALPHA]
C              A            B               A                B
C
C           [Q]  = [VBA][Q]
C              A           B
C
C
      REAL     TAB(9),UAB(9),VAB(4)
C
      UAB(1) = TAB(1)*TAB(1)
      UAB(2) = TAB(4)*TAB(4)
      UAB(3) = TAB(1)*TAB(4)
      UAB(4) = TAB(2)*TAB(2)
      UAB(5) = TAB(5)*TAB(5)
      UAB(6) = TAB(2)*TAB(5)
      UAB(7) = TAB(1)*TAB(2)*2.0
      UAB(8) = TAB(4)*TAB(5)*2.0
      UAB(9) = TAB(1)*TAB(5) + TAB(2)*TAB(4)
C
      VAB(1) = TAB(5)*TAB(9)
      VAB(2) = TAB(2)*TAB(9)
      VAB(3) = TAB(4)*TAB(9)
      VAB(4) = TAB(1)*TAB(9)
C
      RETURN
      END

      SUBROUTINE MCE1D
C
C     MCE1D SOLVES FOR GM IN THE MATRIX EQUATION RM*GM = -RN
C     WHERE RM IS A DIAGONAL MATRIX.
C
      INTEGER         SYSBUF,EOL    ,EOR   ,TYPE  ,RDP   ,BCD  ,RM   ,
     1                RN    ,GM
      REAL            Z(1)  ,A(1)   ,B(1)
      DOUBLE PRECISION ZD   ,AD     ,BD
      DIMENSION       BCD(2),MCB1(7),MCB2(7)
      COMMON /BLANK / USET  ,RG     ,GM    ,SCR1  ,SCR2  ,SCR3  ,RM  ,
     1                RN    ,L      ,U     ,MCB(7)
      COMMON /ZNTPKX/ AD (2),I      ,EOL   ,EOR
      COMMON /ZBLPKX/ BD (2),J
      COMMON /ZZZZZZ/ ZD (1)
      COMMON /SYSTEM/ SYSBUF,SKP(53),IPR
      EQUIVALENCE     (MCB(2),NCOL) ,(AD(1),A(1)) ,(MCB(5),TYPE) ,
     1                (ZD(1) ,Z(1)) ,(BD(1),B(1)) ,(MCB1(2),NCOL1)
      DATA    BCD   , RDP   /4HMCE1 ,4HD   ,  2   /
C
C     OPEN RM MATRIX,SKIP HEADER RECORD AND READ MATRIX CONTROL BLOCK
C
      NZ = KORSZ(Z)
      N  = NZ - SYSBUF
      CALL GOPEN (RM,Z(N+1),0)
      MCB(1) = RM
      CALL RDTRL (MCB)
C
C     FORM -RM
C
      NCOL = MCB(2)
      DO 22 K = 1,NCOL
      CALL INTPK (*83,RM,0,RDP,0)
      CALL ZNTPKI
      IF (I .NE. K) GO TO 84
   22 ZD(K) = -AD(1)
      CALL CLOSE (RM,1)
C
C     OPEN RN MATRIX,SKIP HEADER RECORD AND READ MATRIX CONTROL BLOCK
C
      CALL GOPEN (RN,Z(N+1),0)
      MCB1(1) = RN
      CALL RDTRL (MCB1)
C
C     SET UP MATRIX CONTROL BLOCK BLOCK FOR GM
C
      CALL MAKMCB (MCB2,GM,MCB1(3),MCB1(4),IPR)
C
C     OPEN OUTPUT FILE FOR GM AND WRITE HEADER RECORD
C
      N1 = N - SYSBUF
      CALL GOPEN (GM,Z(N1+1),1)
C
C     FORM GM = -RM(-1)*RN
C
      NCOL1 = MCB1(2)
      DO 62 K = 1,NCOL1
      CALL BLDPK (RDP,IPR,GM,0,0)
      CALL INTPK (*62,RN,0,RDP,0)
   61 CALL ZNTPKI
      J = I
      BD(1) = AD(1)/ZD(J)
      CALL ZBLPKI
      IF (EOL) 62,61,62
   62 CALL BLDPKN (GM,0,MCB2)
C
C     CLOSE GM AND RM FILES AND WRITE TRAILER FOR GM
C
      CALL CLOSE (GM,1)
      CALL CLOSE (RN,1)
      CALL WRTTRL (MCB2)
      RETURN
C
C     CALL MESSAGE WRITER IF FATAL ERROR DETECTED
C
   83 L = -5
      GO TO 86
   84 L = -16
   86 CALL MESAGE (L,RM,BCD)
      RETURN
      END

      SUBROUTINE AMGB1B (Q)        
C        
C     SUBSONIC RAO (CASCADES)        
C        
      INTEGER         SLN        
      REAL            M,KAPPA,MU,MUS,LAMDA,LAMDM,NU,        
     1                X(20),DISP(20,10),W(8)        
      COMPLEX         Q(NSTNS,NSTNS),LOADS(21),STT(20),SUM,        
     1                AN(401),AB(401),FK(401),CN(401),CB(401),PD(401),  
     2                SO(100),S1(100),P(50),A(20,30),        
     3                FF,ST,STP,FG,FS,FO,SLOPE        
      CHARACTER       UFM*23        
      COMMON /XMSSG / UFM        
      COMMON /BAMG1L/ IREF,MINMAC,MAXMAC,NLINES,NSTNS,REFSTG,REFCRD,    
     1                REFMAC,REFDEN,REFVEL,REFFLO,SLN,NSTNSX,STAG,      
     2                CHORD,RADIUS,BSPACE,MACH,DEN,VEL,FLOWA,AMACH,     
     3                REDF,BLSPC,AMACHR,TSONIC        
      COMMON /AMGMN / MCB(7),NROW,DUM(2),REFC,SIGMA,RFREQ        
      COMMON /SYSTEM/ IBUF,IOUT        
      DATA    W     / 1.48283,.89414,.83521,.66721,        
     1                 .64172,.55519,.54026,.48547 /        
C        
C     THEORY DEPENDENT RESTRICTION OF NO MORE THAN 10 COMPUTING        
C     STATIONS PER STREAMLINE IS REFLECTED IN CODING.        
C        
      IF (NSTNS .GT. 10) GO TO 1000        
      M     = AMACH        
      OMEGA = REDF        
      SS    = 2*BLSPC        
      DELTM =-SIGMA        
      XLAM  = STAG        
      NM    = NSTNS        
      N     = 20        
      PI    = 3.141593        
      PI2   = PI*2        
      CON   = 1.0E-5        
      NNN   = 100        
      KKK   = 2*NNN + 1        
      DELTM = DELTM/360        
      XL    = XLAM*PI/180        
      B     = 1.0/N        
      B2    = 2*B        
      D     = SS*SIN(XL)        
      HH    = SS*COS(XL)        
      BETA  = SQRT(1. - M**2)        
      H     = HH*BETA        
      ZER   = 0.0        
      S     = SQRT(H**2 + D**2)        
      LAMDM = ATAN(D/H)        
      CL    = COS(LAMDM)        
      SL    = SIN(LAMDM)        
      NU    = OMEGA/BETA**2        
      KAPPA = M*NU        
      LAMDA = M*KAPPA        
      DELTA = DELTM + LAMDA*D/PI2        
      MU    = KAPPA*S/PI2        
      MUS   = MU**2        
      FF    = (0.0,1.0)        
      FG    = CMPLX(ZER,NU*S)        
      L     = 1        
      CC    = DELTA**2 - MUS        
      IF (CC .EQ. 0.0) GO TO 200        
      IF (CC .LT. 0.0) FK(L) = SQRT(-CC)*FF        
      IF (CC .GT. 0.0) FK(L) = SQRT(CC)        
      AN(L) = FK(L)*CL + FF*DELTA*SL        
      AB(L) = FK(L)*CL - FF*DELTA*SL        
      PD(L) = FK(L)*(PI2*AB(L) + FG)        
      CK    = PI2*B/S        
      CN(L) = CEXP(-AN(L)*CK)        
      CB(L) = CEXP(-AB(L)*CK)        
      DO 20 I = 1,NNN        
      L     = L + 1        
      CC    = (DELTA+I)**2 - MUS        
      IF (CC .EQ. 0.0) GO TO 200        
      IF (CC .LT. 0.0) FK(L) = SQRT(-CC)*FF        
      IF (CC .GT. 0.0) FK(L) = SQRT(CC)        
      AN(L) = FK(L)*CL + (DELTA+I)*FF*SL        
      AB(L) = FK(L)*CL - (DELTA+I)*FF*SL        
      PD(L) = FK(L)*(PI2*AB(L)+FG)        
      CN(L) = CEXP(-AN(L)*CK)        
      CB(L) = CEXP(-AB(L)*CK)        
      L     = L + 1        
      CC    = (DELTA-I)**2 - MUS        
      IF (CC .EQ. 0.0) GO TO 200        
      IF (CC .GT. 0.0) FK(L) = SQRT(CC)        
      IF (CC .LT. 0.0) FK(L) = SQRT(-CC)*FF        
      AN(L) = FK(L)*CL+(DELTA-I)*FF*SL        
      AB(L) = FK(L)*CL-(DELTA-I)*FF*SL        
      PD(L) = FK(L)*(PI2*AB(L)+FG)        
      CN(L) = CEXP(-AN(L)*CK)        
      CB(L) = CEXP(-AB(L)*CK)        
   20 CONTINUE        
      STP   = 0.0        
      L     = 1        
      ST    = ((1-CN(L))/AN(L) + (1-CB(L))/AB(L))/FK(L)        
      DO 25 I = 2,KKK,2        
      L     = I        
      ST    = ((1-CN(L))/AN(L) + (1-CB(L))/AB(L))/FK(L) + ST        
      L     = L + 1        
      ST    = ((1-CN(L))/AN(L) + (1-CB(L))/AB(L))/FK(L) + ST        
      IF (CABS(ST-STP) .LT. CON) GO TO 30        
      STP   = ST        
   25 CONTINUE        
   30 CONTINUE        
      SO(1) =-ST*S/(2*PI2*B2)        
      DO 40 J = 2,N        
      JK    = 2*(J-1)        
      L     = 1        
      STP   = 0.0        
      ST    = CN(L)**JK/FK(L)        
      DO 32 I = 2,KKK,2        
      L     = L + 1        
      ST    = CN(L)**JK/FK(L) + ST        
      L     = L + 1        
      ST    = CN(L)**JK/FK(L) + ST        
      IF (CABS(ST-STP) .LT. CON) GO TO 35        
   32 STP   = ST        
   35 SO(J) =-0.5*ST        
   40 CONTINUE        
      N1    = N + 1        
      N2    = 3*N - 1        
      DO 50 J = N1,N2        
      JK    = J - N        
      STP   = 0.0        
      L     = 1        
      ST    = CB(L)**JK/FK(L)        
      DO 42 I = 2,KKK,2        
      L     = L + 1        
      ST    = CB(L)**JK/FK(L) + ST        
      L     = L + 1        
      ST    = CB(L)**JK/FK(L) + ST        
      IF (CABS(ST-STP) .LT. CON) GO TO 45        
   42 STP   = ST        
   45 SO(J) =-0.5*ST        
   50 CONTINUE        
      DO 55 J = 1,N        
      JK    = (J-1)*2 + 1        
      L     = 1        
      STP   = 0.0        
      ST    = AN(L)*CN(L)**JK/FK(L)        
      DO 52 I = 2,KKK,2        
      L     = L + 1        
      ST    = AN(L)*CN(L)**JK/FK(L) + ST        
      L     = L + 1        
      ST    = AN(L)*CN(L)**JK/FK(L) + ST        
      IF (CABS(ST-STP) .LT. CON) GO TO 54        
      STP   = ST        
   52 CONTINUE        
   54 S1(J) =-PI/S*ST        
   55 CONTINUE        
      N1    = N + 1        
      N2    = 2*N        
      DO 60 J = N1,N2        
      JK    = (J-N1)*2 + 1        
      L     = 1        
      STP   = 0.0        
      ST    = AB(L)*CB(L)**JK/FK(L)        
      DO 57 I = 2,KKK,2        
      L     = L + 1        
      ST    = AB(L)*CB(L)**JK/FK(L) + ST        
      L     = L + 1        
      ST    = AB(L)*CB(L)**JK/FK(L) + ST        
      IF (CABS(ST-STP) .LT. CON) GO TO 59        
      STP   = ST        
   57 CONTINUE        
   59 S1(J) = PI/S*ST        
   60 CONTINUE        
      DO 64 J = 1,N        
      JK    = (J-1)*2 + 1        
      L     = 1        
      STP   = 0.0        
      ST    = CB(L)**JK/PD(L)        
      DO 61 I = 2,KKK,2        
      L     = L + 1        
      ST    = CB(L)**JK/PD(L) + ST        
      L     = L + 1        
      ST    = CB(L)**JK/PD(L) + ST        
      IF (CABS(ST-STP) .LT. CON) GO TO 62        
      STP   = ST        
   61 CONTINUE        
   62 P(J)  =-S/2*ST        
   64 CONTINUE        
      FG    = CMPLX(ZER,-NU*B)        
      FG    = 1/(CEXP(FG) + CMPLX(ZER,NU*B2))        
      FS    = CMPLX(ZER,NU)        
      CJ    = (NU*BETA)**2        
      L     = 0        
      CT    = 2*KAPPA**2*B        
      DO 70 J = 1,N        
      DO 70 I = 1,N        
      L     = L + 1        
      NK    = I - J + 1        
      NK1   = I - J        
      NK2   = NK1 + 1        
      IF (I .EQ. J) NK1 = N + 1        
      IF (I .EQ. J) NK2 = 1        
      IF (J .LE. I) GO TO 65        
      NK1   = N + J - I + 1        
      NK2   = NK1 - 1        
      NK    = N + 2*(J-I)        
   65 A(I,J)= S1(NK1) - S1(NK2) + CT*SO(NK)        
      IF (J .NE. N) GO TO 70        
      NK    = N + 2*(J-I) + 1        
      NK2   = J - I + 1        
      A(I,J)= A(I,J) - FG*(S1(NK1) + SO(NK)*FS + CJ*P(NK2))        
   70 CONTINUE        
      X(1)  =-1.0 + B        
      DO 81 I = 2,N        
   81 X(I)  = X(I-1) + B2        
      N1    = N + NM        
      N1N   = N - 1        
      N1M   = NM- 1        
      N11   = N + 1        
      N22   = N + 2        
      FO    = FF*OMEGA        
      DO 75 I = 1,N        
      DISP(I,1) =-1.0        
      DISP(I,2) =-1.0 - X(I)        
      STT(I)= CEXP(-FF*LAMDA*X(I))*PI2/BETA        
      A(I,N11) = STT(I)*FO*DISP(I,1)        
   75 A(I,N22) = STT(I)*(FO*DISP(I,2)-1.)        
      DO 83 JJ = 3,NM        
      NF    = N + JJ        
      CON2  = PI*(JJ-2)/2        
      DO 83 I = 1,N        
      CON   = CON2*DISP(I,2)        
      DISP(I,JJ) =SIN(CON)        
   83 A(I,NF) = STT(I)*(FO*DISP(I,JJ) - CON2*COS(CON))        
CWKBR SPR93019 10/93      CALL GAUSS (A,N,N1)        
      CALL GAUSS2 (A,N,N1)  
      DO 95 J = 1,NM        
      NF    = N + J        
      DO 84 I = 1,N        
   84 LOADS(I) = A(I,NF)        
C        
      SLOPE  = LOADS(2)/3./B        
      A(1,NF)= 2.*CEXP(LAMDA*FF*X(1))*(FF*NU*LOADS(1) + SLOPE)        
C        
      SLOPE  = (LOADS(N) - LOADS(N1N))/B2        
      A(N,NF)= 2.*CEXP(LAMDA*FF*X(N))*(FF*NU*LOADS(N) + SLOPE)        
C        
      DO 85 I = 2,N1N        
      SLOPE  = (LOADS(I+1) - LOADS(I-1))/4./B        
   85 A(I,NF)= 2.*CEXP(LAMDA*FF*X(I))*(FF*NU*LOADS(I) + SLOPE)        
   95 CONTINUE        
      DO 86 I = 1,N        
      A(I,1) = SQRT((1-X(I))/(1+X(I)))        
      DO 87 J = 2,N1M        
   87 A(I,J) =-DISP(I,J+1)        
      DO 86 J = NM,N        
      CON2   =-PI*(J-1)*DISP(I,2)/2        
   86 A(I,J) = SIN(CON2)        
CWKBR SPR93019 10/93      CALL GAUSS (A,N,N1)        
      CALL GAUSS2 (A,N,N1)
      A(1,1) = PI        
      CON    = 1.        
      DO 88 J = 1,N1N        
      A(1,J+1) = CON*4/J/PI        
   88 CON    = 1. - CON        
      A(2,1) = PI/2        
      CON    = 0.        
      DO 89 J = 1,N1N        
      A(2,J+1) = A(1,J+1) - CON*4/J/PI        
   89 CON    = 1. - CON        
      DO 90 I = 3,NM        
      DO 90 J = 2,N        
      CON    = 0.        
      IF ((I-1) .EQ. J) CON = 1.        
   90 A(I,J) = CON        
      DO 91 J = 3,NM        
   91 A(J,1) = W(J-2)        
      DO 160 J = 1,NM        
      DO 160 K = 1,NM        
      NF    = N + K        
      SUM   = (0.,0.)        
      DO150 I = 1,N        
  150 SUM   = SUM + A(J,I)*A(I,NF)        
  160 Q(J,K)= SUM        
  200 RETURN        
C        
 1000 WRITE  (IOUT,3001) UFM,SLN,NSTNS        
 3001 FORMAT (A23,' - AMG MODULE - NUMBER OF COMPUTING STATIONS ON ',   
     1        'STREAMLINE',I8,4H IS ,I3,1H., /39X,'SUBSONIC CASCADE ',  
     2        'ROUTINE AMGB1B ALLOWS ONLY A MAXIMUM OF 10.')        
      CALL MESAGE (-61,0,0)        
      RETURN        
      END        

      SUBROUTINE AF (F,N,A,B,C,C1,C2,C3,T1,T3,T5,JUMP)
C
C     THIS AREA INTEGRATION ROUTINE IS USED IN TRIM6, TRPLT1 AND TRSHL
C     IT COMPUTES THE F FUNCTION, AND CONSTANTS C1, C2, C3
C
C     FAC ARE THE FACTORIALS 1 THRU 36
C     B   IS  DISTANCE OF GRID POINT 1
C     A   IS  DISTANCE OF GRID POINT 3
C     C   IS  DISTANCE OF GRID POINT 5
C     T1  IS  ASSOCIATIVE VARIABLE AT GRID POINT 1
C     T3  IS  ASSOCIATIVE VARIABLE AT GRID POINT 3
C     T5  IS  ASSOCIATIVE VARIABLE AT GRID POINT 5
C     N   IS  DIMENSION OF AREA FUNCTION F
C
C
C
      REAL             F(N,N)
      DOUBLE PRECISION FAC(20), TEMP
      DATA FAC / 1.D0,1.D0, 2.D0,6.D0, 2.4D1,  1.2D2, 7.2D2, 5.04D3,
     1           4.032D4,       3.6288D5,     3.6288D6,     3.99168D7,
     2           4.790016D8,    6.227021D9,   8.7178291D10, 1.307674D12,
     3           2.092279D13,   3.556874D14,  6.402374D15,  1.216451D17/
C
      IF (JUMP .GT. 0) GO TO 30
      IF (N .GT. 18) STOP 'IN AF'
      DO 10 I=1,N
      DO 10 J=1,N
 10   F(I,J)=0.0
      DO 20 I=1,N
      I1=I
      DO 15 J=1,I
      TEMP = DBLE(C**J) * FAC(I1) / FAC(I+2)
      TEMP = DBLE(A**I1-(-B)**I1) * TEMP * FAC(J)
      F(I1,J) = SNGL(TEMP)
      I1=I1-1
 15   CONTINUE
 20   CONTINUE
      IF (JUMP .LT. 0) RETURN
C
 30   AB=A-B
      IF (A .EQ. B .AND. A .NE. 0.0) AB=A+B
      IF (AB .EQ. 0.0) CALL MESAGE (-37,0,0)
      C1=(T1*A-T3*B)/AB
      C2=(T3-T1)/AB
      C3=(T5-C1)/C
      RETURN
      END

      SUBROUTINE DDRMMS (BUF,ELTYPE,BUF4,BUF6)
C
      EXTERNAL ANDF
      INTEGER  ANDF   ,BUF4  ,BUF6  ,DIT   ,ELM(4),ELT   ,BUFA(100)    ,
     1         EST    ,IELID ,IELTMP,INT1  ,Z     ,FILE  ,ELTYPE,MATFLG,
     2         MATID  ,MPT   ,MTD(4),N     ,NELT  ,NWORDS,N1MAT ,N2MAT ,
     3         TMP(4),WRD(4)
      REAL     BUF(16),ELTEMP,STRESS,SINTH ,COTH  ,E     ,G     ,NU    ,
     1         RHO    ,ALPHA ,T0    ,GSUBE ,SIGT  ,SIGC  ,SIGS  ,FINT1 ,
     2         TEMP   ,CPRIM
      COMMON /MATIN /  MATID ,MATFLG,ELTEMP,STRESS,SINTH ,COTH
      COMMON /MATOUT/  E,G   ,NU,RHO,ALPHA ,T0    ,GSUBE ,SIGT   ,SIGC ,
     1                 SIGS
      COMMON /ZZZZZZ/  Z(1)
      COMMON /SYSTEM/  ISYS(61)
      EQUIVALENCE     (INT1,FINT1) ,(IELTMP,ELTEMP)
      DATA    INT1/1/ ,EST/109/ ,MPT/110/ ,DIT/111/ ,ELM/1,3,10,34  / ,
     1        MTD   / 4,4,4,16/ ,TMP/ 17,16,17,42 / ,WRD/17,16,17,42/
C
C
      DO 210 I = 1,4
      IF (ELM(I) .EQ. ELTYPE) GO TO 215
  210 CONTINUE
      GO TO 230
  215 NELT = I
      CALL OPEN (*240,EST,Z(BUF4),0)
  220 CALL FWDREC (*250,EST)
      CALL FREAD (EST,ELT,1,0)
      IF (ELT .NE. ELTYPE) GO TO 220
      NWORDS = WRD(NELT)
      CALL FREAD (EST,BUFA,NWORDS,0)
      CALL CLOSE (EST,1)
      N1MAT  = BUF4 - BUF6
      CALL PREMAT (Z(BUF6),Z(BUF6),Z(BUF4),N1MAT,N2MAT,MPT,DIT)
      MATFLG = 1
      ITEMP  = TMP(NELT)
      IMATID = MTD(NELT)
      IELTMP = BUFA(ITEMP)
      MATID  = BUFA(IMATID)
      IELID  = BUFA(1)
      CALL MAT (IELID)
  230 CONTINUE
      IF (ELTYPE) 200,200,10
   10 IF (ELTYPE .GT. 100) GO TO 200
C              ROD       BEAM      TUBE      SHEAR     TWIST
      GO TO (  21       ,1        ,21       ,1        ,1
C              TRIA1     TRBSC     TRPLT     TRMEM     CONROD
     1        ,20       ,20       ,20       ,40       ,21
C              ELAS1     ELAS2     ELAS3     ELAS4     QDPLT
     2        ,1        ,1        ,1        ,1        ,20
C              QDMEM     TRIA2     QUAD2     QUAD1     DAMP1
     3        ,40       ,20       ,20       ,20       ,1
C              DAMP2     DAMP3     DAMP4     VISC      MASS1
     4        ,1        ,1        ,1        ,1        ,1
C              MASS2     MASS3     MASS4     CONM1     CONM2
     5        ,1        ,1        ,1        ,1        ,1
C              PLOTEL    REACT     QUAD3     BAR       CONE
     6        ,1        ,1        ,1        ,22       ,1
C              TRIARG    TRAPRG    TORDRG    TETRA     WEDGE
     7        ,1        ,1        ,1        ,150      ,150
C              HEXA1     HEXA2     FLUID2    FLUID3    FLUID4
     8        ,150      ,150      ,1        ,1        ,1
C              FLMASS    AXIF2     AXIF3     AXIF4     SLOT3
     9        ,1        ,1        ,1        ,1        ,1
C              SLOT4     HBDY      DUM1      DUM2      DUM3
     A        ,1        ,1        ,1        ,1        ,1
C              DUM4      DUM5      DUM6      DUM7      DUM8
     B        ,1        ,1        ,1        ,1        ,1
C              DUM9      QDMEM1    QDMEM2    QUAD4     IHEX1
     C        ,1        ,40       ,40       ,20       ,1
C              IHEX2     IHEX3     QUADTS    TRIATS    TRIAAX
     D        ,1        ,1        ,1        ,1        ,1
C              TRAPAX    AERO1     TRIM6     TRPLT1    TRSHL
     E        ,1        ,1        ,1        ,1        ,1
C              FHEX1     FHEX2     FTETRA    FWEDGE    IS2D8
     F        ,1        ,1        ,1        ,1        ,40
C              ELBOW     FTUBE     TRIA3     -----     -----
     G        ,22       ,1        ,20       ,1        ,1
C              -----     -----     -----     -----     -----
     H        ,1        ,1        ,1        ,1        ,1
C              -----     -----     -----     -----     -----
     I        ,1        ,1        ,1        ,1        ,1
C              -----     -----     -----     -----     -----
     J        ,1        ,1        ,1        ,1        ,1    ), ELTYPE
C
C     ROD  CONROD  TUBE
C
   21 BUF(3) = FINT1
      BUF(5) = FINT1
C
C     M. S. IN TENSION OR COMPRESSION
C
      IF (BUF(2) .GE. 0.0) GO TO 300
      IF (SIGC   .EQ. 0.0) GO TO 301
      BUF(3) = (-ABS(SIGC)/BUF(2))-1.0
      GO TO 301
  300 IF (SIGT.LE.0.0 .OR. BUF(2).EQ.0.0) GO TO 301
      BUF(3) = SIGT/BUF(2)-1.0
C
C     M. S. IN TORSION
C
  301 IF (BUF(4).EQ.0.0 .OR. SIGS.LE.0.0) GO TO 200
      BUF(3) = SIGS/ABS(BUF(4))-1.0
      GO TO 200
C
C     BAR  ELBOW
C
   22 BUF( 7) = BUF(6) + AMAX1(BUF(2),BUF(3),BUF(4),BUF(5))
      BUF( 8) = BUF(6) + AMIN1(BUF(2),BUF(3),BUF(4),BUF(5))
      BUF( 9) = FINT1
      BUF(14) = BUF(6) + AMAX1(BUF(10),BUF(11),BUF(12),BUF(13))
      BUF(15) = BUF(6) + AMIN1(BUF(10),BUF(11),BUF(12),BUF(13))
      BUF(16) = FINT1
C
C     M. S. IN TENSION
C
      IF (SIGT .LE. 0.0) GO TO 302
      TEMP = BUF(7)
      IF (BUF(7) .LT. BUF(14)) TEMP = BUF(14)
      IF (TEMP   .LE. 0.0) GO TO 302
      BUF(9) = SIGT/TEMP-1.0
C
C     M. S. IN COMPRESSION
C
  302 IF (SIGC .EQ. 0.0) GO TO 200
      TEMP = BUF(8)
      IF (BUF(8) .GT. BUF(15)) TEMP = BUF(15)
      IF (TEMP   .GE. 0.0) GO TO 200
      CPRIM   =-ABS(SIGC)
      BUF(16) = CPRIM/TEMP - 1.0
      GO TO 200
C
C     TRIA1  TRIA2  TRIA3  QUAD1  QUAD2  QUAD4  TRBSC  TRPLT  QDPLT
C
   20 I = 2
      ASSIGN 30 TO IRETRN
      GO TO 100
   30 I = 10
      ASSIGN 200 TO IRETRN
      GO TO 100
C
C     TRMEM  QDMEM  QDMEM1  QDMEM2  IS2D8
C
   40 I = 1
      ASSIGN 200 TO IRETRN
      GO TO 100
C
C     PRINCIPAL STRESS EQUATIONS FOR 2-DIMENSIONAL ELEMENTS
C
  100 TEMP     = BUF(I+1) - BUF(I+2)
      BUF(I+7) = SQRT((TEMP/2.0)**2 + BUF(I+3)**2)
      DELTA    = (BUF(I+1) + BUF(I+2)) / 2.0
      BUF(I+5) = DELTA + BUF(I+7)
      BUF(I+6) = DELTA - BUF(I+7)
C
      IF (ANDF(ISYS(61),1)) 120,120,110
  110 BUF(I+7) = SQRT(BUF(I+1)**2 + BUF(I+2)**2 - BUF(I+1)*BUF(I+2)
     1         +  3.0*BUF(I+3)**2)
C
  120 DELTA = 2.0*BUF(I+3)
      IF (ABS(DELTA).LT.1.0E-15 .AND. ABS(TEMP).LT.1.0E-15) GO TO 121
      BUF(I+4) = ATAN2(DELTA,TEMP)*28.6478898
      GO TO IRETRN, (30,200)
C
  121 BUF(I+4) = 0.0
      GO TO IRETRN, (30,200)
C
C     TETRA  WEDGE  HEXA1  HEXA2
C
  150 BUF(8) = SQRT(BUF(2)*(BUF(2)-BUF(3)-BUF(4))*2.0
     1       +  2.0*BUF(3)*(BUF(3)-BUF(4)) + 2.0*BUF(4)**2
     2       +  6.0*(BUF(5)**2 + BUF(6)**2 + BUF(7)**2)) / 3.0
      GO TO 200
C
    1 CONTINUE
  200 RETURN
C
C     ERROR PROCESSING FOR DDRMMS
C
  240 N = -1
      FILE = EST
      GO TO 260
  250 N = -2
      FILE = EST
  260 CALL MESAGE (N,FILE,NAM)
      RETURN
      END

      SUBROUTINE KPLTST (G1,G2,G3,G4)
C
C     THIS ROUTINE WILL VERIFY THAT THE 4 GRID POINTS IN 3 SPACE LIE IN
C     AN APPROXIMATE PLANE. IF NOT THE NOGO FLAG IS SET TRUE AND A
C     MESSAGE IS WRITEN.
C
      LOGICAL         NOGO
      INTEGER         OUT
      REAL            G1(3),G2(3),G3(3),G4(3)
      CHARACTER       UFM*23,UWM*25
      COMMON /XMSSG / UFM,UWM
      COMMON /SYSTEM/ SYSBUF,OUT,NOGO
      COMMON /SMA1ET/ ID
      COMMON /SMA1DP/ R13(3),R24(3),RXR(3),R(3)
C
      R13(1) = G3(1) - G1(1)
      R13(2) = G3(2) - G1(2)
      R13(3) = G3(3) - G1(3)
      R24(1) = G4(1) - G2(1)
      R24(2) = G4(2) - G2(2)
      R24(3) = G4(3) - G2(3)
      CALL SAXB (R13,R24,RXR)
C
C     NORMALIZE
C
      DL     = SQRT(RXR(1)**2 + RXR(2)**2 + RXR(3)**2)
      IF (DL) 20,20,10
   10 RXR(1) = RXR(1)/DL
      RXR(2) = RXR(2)/DL
      RXR(3) = RXR(3)/DL
      R1L    = SQRT(R13(1)**2 + R13(2)**2 + R13(3)**2)
      R2L    = SQRT(R24(1)**2 + R24(2)**2 + R24(3)**2)
      DL     = AMIN1(R1L,R2L)
      R(1)   = G2(1) - G1(1)
      R(2)   = G2(2) - G1(2)
      R(3)   = G2(3) - G1(3)
      DH     = SADOTB(R,RXR)
      IF (DL) 20,20,15
   15 IF (ABS(DH/DL) .LE. 0.10) RETURN
C
C     NOT PLANER
C
   20 CALL PAGE2 (-2)
      WRITE  (OUT,30) UWM,ID
   30 FORMAT (A25,' 4000, ONE SIDE OF ELEMENT',I10,
     1       ' CONNECTING FOUR POINTS IS NOT APPROXIMATELY PLANER.')
      RETURN
      END

      SUBROUTINE MPY3DR (Z)
C
C     SECONDARY DRIVER IF MPY3DR IS CALLED BY MPY3
C     PRIMARY   DRIVER IF CALLED BY OTHERS (COMB2 AND MRED2 GROUP)
C
C     SETS UP OPEN CORE AND DETERMINES SOLUTION METHOD.
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL         ANDF,ORF,COMPLF,LSHIFT
      LOGICAL          E
      INTEGER          Z(1),MPY(3),MCB(7,3),NAME(2)
      REAL             RHOA,RHOB,RHOE,TCOL,TIMCON,TIMEM,TIMEM1,TIMEM2,
     1                 TIMEM3
      DOUBLE PRECISION DD,NN,MM,PP,XX
      CHARACTER        UFM*23,UWM*25,UIM*29
CWKBI 4/94
      COMMON /LOGOUT/  LOUT
      COMMON /XMSSG /  UFM,UWM,UIM
      COMMON /MPY3TL/  FILEA(7),FILEB(7),FILEE(7),FILEC(7),SCR1,SCR2,
     1                 SCR3,LKORE,CODE,PREC,LCORE,SCR(7),BUF1,BUF2,
     2                 BUF3,BUF4,E
      COMMON /MPY3CP/  ITRL,ICORE,N,NCB,M,NK,D,MAXA,DUMCP(34)
      COMMON /NTIME /  TIMCON(16)
      COMMON /SYSTEM/  SYSBUF,NOUT,DUM1(22),DIAG,DUM2(32),METH
      COMMON /MPYADX/  MFILEA(7),MFILEB(7),MFILEE(7),MFILEC(7),MCORE,
     1                 MT,SIGNAB,SIGNC,MPREC,MSCR,TIMEM
      EQUIVALENCE      (AC,FILEA(2)), (AR,FILEA(3)),
     1                 (BC,FILEB(2)), (BR,FILEB(3)),
     2                 (BF,FILEB(4)), (EC,FILEE(2)),
     3                 (ER,FILEE(3)), (EF,FILEE(4))
      EQUIVALENCE      (MCB(1,1),FILEA(1))
      DATA    NAME  /  4HMPY3,4HDR          /
      DATA    MPY   /  4HMPY3,4H    ,4H     /
      DATA    JBEGN ,  JEND  /4HBEGN,4HEND  /
C
C     RETURN IF EITHER A OR B IS PURGED
C
      IF (FILEA(1) .LT. 0) RETURN
      IF (FILEB(1) .LT. 0) RETURN
C
C     TEST FOR MATRIX COMPATABILITY.
C
      MPY(3) = JBEGN
      CALL CONMSG (MPY,3,0)
C
      SCR(1) = SCR3
      IF (CODE .NE. 0) GO TO 5
      IF (BF.EQ.2  .OR.  BF.EQ.  7) GO TO 901
    5 IF (AR.NE.BR .AND. CODE.EQ.1) GO TO 902
      IF (AR.NE.BC .AND. CODE.NE.1) GO TO 903
      IF (FILEE(1) .LE. 0) GO TO 15
      E = .TRUE.
      IF (CODE .NE. 0) GO TO 10
      IF (EF.EQ.2 .OR. EF.EQ.7) GO TO 905
   10 IF (EC.NE.BC .AND. CODE.EQ.1) GO TO 909
      IF (EC.NE.AC .AND. CODE.NE.1) GO TO 904
      IF (ER.NE.AC .AND. CODE.EQ.1) GO TO 910
      IF (ER.NE.BR .AND. CODE.EQ.2) GO TO 906
      GO TO 30
C
   15 E = .FALSE.
      DO 20 I = 1,7
   20 FILEE(I) = 0
C
C     CORE ALLOCATION.
C
   30 BUF1 = LKORE - SYSBUF
      BUF2 = BUF1  - SYSBUF
      BUF3 = BUF2  - SYSBUF
      BUF4 = BUF3  - SYSBUF
      LCORE= BUF4  - 1
      IF (LCORE .LT. 0) GO TO 2008
C
C     IF REQUESTED CALCULATE THE OUTPUT PRECISION
C
      IF (PREC.GE.1 .AND. PREC.LE.4) GO TO 46
      IPRC = 1
      ITYP = 0
      DO 45 I = 1,3
      IF (MCB(5,I).EQ.2 .OR. MCB(5,I).EQ.4) IPRC = 2
      IF (MCB(5,I) .GE. 3) ITYP = 2
   45 CONTINUE
      PREC = ITYP + IPRC
      IF (PREC .LE. 2) FILEC(5) = PREC
   46 CONTINUE
C
C     DETERMINE NK, THE NUMBER OF COLUMNS OF B MATRIX ABLE TO BE HELD
C     IN CORE.
C
      N   = FILEB(3)
      NCB = FILEB(2)
      M   = FILEA(2)
      D   = FILEA(7) + 1
      MAXA= FILEA(6)/FILEA(5)
C
C     (NCB SHOULD BE USED IN THE ABOVE EQUATION INSTEAD OF N. SEE
C     MPY3IC)
C
      DD = D
      NN = NCB
      MM = M
      PP = 1 + PREC
      XX = DD*PP*NN*MM/10000.D0
      IXX= XX + 0.5D0
      NK = (LCORE - 2*NCB - IXX - PREC*M - PREC - (2+PREC)*MAXA)/
     1     (2+PREC*N)
C
C     SET UP CONSTANTS IN MPYADX COMMON
C
      MSCR  = SCR2
      MCORE = LKORE
      MPREC = 0
      SIGNAB= 1
      SIGNC = 1
C
C     CALCULATE PROPERTIES OF THE MATRICES
C
      RHOA  = (FILEA(7)+1)/10000.
      RHOB  = (FILEB(7)+1)/10000.
      RHOE  = (FILEE(7)+1)/10000.
      AELMS = AR*AC*RHOA
      BELMS = BR*BC*RHOB
      EELMS = ER*EC*RHOE
C
C     CALCULATE MPY3 TIME ESTIMATE - REMEMBER NO COMPLEX FOR MPY3
C
      CALL SSWTCH (19,L19)
      TIMEM3 = 1.0E+10
      IF (PREC .GE. 3) GO TO 100
      IF (CODE .EQ. 1) GO TO 100
      TIMEM3 = (RHOA + 2./FLOAT(M))*FLOAT(M)*FLOAT(N)*
     1         (FLOAT(M) + FLOAT(N))*TIMCON(8+PREC) +
     2         (FLOAT(N)**2 + FLOAT(M)**2 + RHOA*FLOAT(M)*
     3         FLOAT(N)*(2. + FLOAT(M)))*TIMCON(5)
      TIMEM3 = TIMEM3/1.0E6
CWKBR 4/94 IF (L19 .NE. 0) WRITE (NOUT,50) FILEA(1),AR,AC,AELMS,RHOA,
      IF (L19 .NE. 0) WRITE (LOUT,50) FILEA(1),AR,AC,AELMS,RHOA,
     1                                FILEB(1),BR,BC,BELMS,RHOB,
     2                                FILEE(1),ER,EC,EELMS,RHOE,
     3                                CODE,LCORE,NK,TIMEM3
   50 FORMAT (50H0(A MAT  ROWS  COLS   TERMS    DENS) (B MAT  ROWS ,
     1        50H COLS   TERMS    DENS) (E MAT  ROWS  COLS   TERMS ,
     2        32H   DENS) C  CORE    NK      TIME /
     3        3(I6,I7,I6,I9,F7.4,1X),I2,I6,I6,F10.1 )
C
      IF (NK.GE.3 .OR. CODE.EQ.2) GO TO 70
      DO 60 I = 1,7
      MFILEA(I) = FILEA(I)
   60 MFILEE(I) = FILEE(I)
      CALL MAKMCB (MFILEB,SCR1,BR,2,PREC)
      MFILEB(2) = AC
      TCOL = FLOAT(BELMS)*FLOAT(AELMS)/FLOAT(AR)/FLOAT(AC)
      MFILEB(6) = TCOL + 1.0
      MFILEB(7) = TCOL/BR*1.0E+4
      MFILEC(1) = -1
      MFILEC(5) = PREC
      MT = 1
      CALL MPYAD (Z(1),Z(1),Z(1))
      TIMEM3 = TIMEM3 + TIMEM
C
CWKBR 4/94 70 WRITE  (NOUT,80) UIM,TIMEM3
   70 WRITE  (LOUT,80) UIM,TIMEM3
   80 FORMAT (A29,' 6525, TRIPLE MULTIPLY TIME ESTIMATE FOR MPY3 = ',
     1        F10.1,' SECONDS.')
C
C     CALCULATE MPYAD TIME ESTIMATE FOR (AT*B)*A + E
C
  100 TIMEM1 = 1.0E+10
      IF (CODE .EQ. 2) GO TO 200
      DO 110 I = 1,7
      MFILEA(I) = FILEA(I)
      MFILEB(I) = FILEB(I)
      IF (CODE .EQ. 1) MFILEE(I) = FILEE(I)
      IF (CODE .NE. 1) MFILEE(I) = 0
  110 CONTINUE
      CALL MAKMCB (MFILEC,-1,AC,2,PREC)
      MT = 1
      CALL MPYAD (Z(1),Z(1),Z(1))
      TIMEM1 = TIMEM
      IF (CODE .EQ. 1) GO TO 130
C
      DO 120 I = 1,7
      MFILEB(I) = MFILEA(I)
      MFILEA(I) = MFILEC(I)
  120 MFILEE(I) = FILEE(I)
      MFILEA(1) = SCR1
      MFILEA(2) = BC
      TCOL = FLOAT(BELMS)*FLOAT(AELMS)/FLOAT(AR)/FLOAT(BC)
      MFILEA(6) = TCOL + 1.0
      MFILEA(7) = TCOL/AC*1.0E+4
      MT = 0
      CALL MPYAD (Z(1),Z(1),Z(1))
      TIMEM1 = TIMEM1 + TIMEM
C
CWKBR 4/94  130 WRITE  (NOUT,140) UIM,TIMEM1
  130 WRITE  (LOUT,140) UIM,TIMEM1
  140 FORMAT (A29,' 6525, TRIPLE MULTIPLY TIME ESTIMATE FOR MPYAD - ',
     1       '(AT*B)*A + E = ',F10.1,' SECONDS.')
C
C     CALCULATE MPYAD TIME ESTIMATE FOR AT*(B*A) + E
C
  200 TIMEM2 = 1.0E+10
      IF (CODE .EQ. 1) GO TO 290
      DO 210 I = 1,7
      MFILEA(I) = FILEB(I)
      MFILEB(I) = FILEA(I)
      IF (CODE .EQ. 2) MFILEE(I) = FILEE(I)
      IF (CODE .NE. 2) MFILEE(I) = 0
  210 CONTINUE
      CALL MAKMCB (MFILEC,-1,BR,2,PREC)
      MT = 0
      CALL MPYAD (Z(1),Z(1),Z(1))
      TIMEM2 = TIMEM
      IF (CODE .EQ. 2) GO TO 230
C
      DO 220 I = 1,7
      MFILEA(I) = MFILEB(I)
      MFILEB(I) = MFILEC(I)
  220 MFILEE(I) = FILEE(I)
      MFILEB(1) = SCR1
      MFILEB(2) = AC
      TCOL = FLOAT(BELMS)*FLOAT(AELMS)/FLOAT(AR)/FLOAT(AC)
      MFILEB(6) = TCOL + 1.0
      MFILEB(7) = TCOL/BR*1.0E+4
      MT = 1
      CALL MPYAD (Z(1),Z(1),Z(1))
      TIMEM2 = TIMEM2 + TIMEM
C
CWKBR 4/94 230 WRITE  (NOUT,240) UIM,TIMEM2
  230 WRITE  (LOUT,240) UIM,TIMEM2
  240 FORMAT (A29,' 6525, TRIPLE MULTIPLY TIME ESTIMATE FOR MPYAD - ',
     1        'AT*(B*A) + E = ',F10.1,' SECONDS.')
C
C     CHOOSE METHOD BASED ON THE BEST TIME ESTIMATE OR USER REQUEST
C
  290 CALL TMTOGO (TTG)
      IF (FLOAT(TTG) .LE. 1.2*AMIN1(TIMEM3,TIMEM1,TIMEM2)) GO TO 908
      DIAG  = ANDF(DIAG,COMPLF(LSHIFT(1,18)))
      KMETH = METH
      JMETH = METH
      METH  = 0
      IF (JMETH.LT.1 .OR. JMETH.GT.3) JMETH = 0
      IF (JMETH.EQ.1 .AND. CODE.EQ.2) JMETH = 0
      IF (JMETH.EQ.2 .AND. CODE.EQ.1) JMETH = 0
      IF (JMETH.EQ.3 .AND. CODE.EQ.1) JMETH = 0
      IF (JMETH .NE. 0) GO TO (400,500,300), JMETH
      FILEC(4) = FILEB(4)
C
      IF (TIMEM3.LT.TIMEM1 .AND. TIMEM3.LT.TIMEM2) GO TO 300
      IF (TIMEM1 .LT. TIMEM2) GO TO 400
      GO TO 500
C
C     PERFORM MULTIPLY WITH MPY3
C
  300 IF (NK .LT. 3) GO TO 310
      ICORE = 0
      CALL MPY3IC (Z(1),Z(1),Z(1))
      GO TO 9999
C
C     OUT OF CORE PROCESSING FOR MPY3
C
  310 ICORE = 1
CWKBR 4/94      WRITE  (NOUT,320) UIM
      WRITE  (LOUT,320) UIM
  320 FORMAT (A29,' 6526,  THE CENTER MATRIX IS TOO LARGE FOR', /5X,
     1       'IN-CORE PROCESSING.  OUT-OF-CORE PROCESSING WILL BE ',
     2       'PERFORMED.')
C
      NK = (LCORE - 4*NCB - PREC*M - (2+PREC)*MAXA)/(2+PREC*N)
      CALL MPY3OC (Z(1),Z(1),Z(1))
      FILEC(4) = FILEB(4)
      GO TO 9999
C
C     PERFORM MULTIPLY WITH MPYAD DOING (AT * B) FIRST
C
  400 DO 410 I = 1,7
      MFILEA(I) = FILEA(I)
      MFILEB(I) = FILEB(I)
      IF (CODE .EQ. 1) MFILEE(I) = FILEE(I)
      IF (CODE .NE. 1) MFILEE(I) = 0
  410 CONTINUE
      CALL MAKMCB (MFILEC,SCR1,AC,2,PREC)
      IF (CODE .EQ. 1) MFILEC(1) = FILEC(1)
      MT = 1
      CALL MPYAD (Z(1),Z(1),Z(1))
      IF (CODE .EQ. 1) GO TO 425
      CALL WRTTRL (MFILEC)
C
      DO 420 I = 1,7
      MFILEB(I) = MFILEA(I)
      MFILEA(I) = MFILEC(I)
  420 MFILEE(I) = FILEE(I)
      CALL MAKMCB (MFILEC,FILEC(1),AC,FILEB(4),PREC)
      MT = 0
      CALL MPYAD (Z(1),Z(1),Z(1))
  425 DO 430 I = 1,7
  430 FILEC(I) = MFILEC(I)
      GO TO 9999
C
C     PERFORM MULTIPLY WITH MPYAD DOING (B*A) FIRST
C
  500 DO 510 I = 1,7
      MFILEA(I) = FILEB(I)
      MFILEB(I) = FILEA(I)
      IF (CODE .EQ. 2) MFILEE(I) = FILEE(I)
      IF (CODE .NE. 2) MFILEE(I) = 0
  510 CONTINUE
      CALL MAKMCB (MFILEC,SCR1,BR,2,PREC)
      IF (CODE .EQ. 2) MFILEC(1) = FILEC(1)
      MT = 0
      CALL MPYAD (Z(1),Z(1),Z(1))
      IF (CODE .EQ. 2) GO TO 525
      CALL WRTTRL (MFILEC)
C
      DO 520 I = 1,7
      MFILEA(I) = MFILEB(I)
      MFILEB(I) = MFILEC(I)
  520 MFILEE(I) = FILEE(I)
      CALL MAKMCB (MFILEC,FILEC(1),AC,FILEB(4),PREC)
      MT = 1
      CALL MPYAD (Z(1),Z(1),Z(1))
  525 DO 530 I = 1,7
  530 FILEC(I) = MFILEC(I)
      GO TO 9999
C
C    ERROR MESSAGES.
C
  901 WRITE (NOUT,9001) UFM
      GO TO 1001
  902 WRITE (NOUT,9002) UFM
      GO TO 1001
  903 WRITE (NOUT,9003) UFM
      GO TO 1001
  904 WRITE (NOUT,9004) UFM
      GO TO 1001
  905 WRITE (NOUT,9005) UFM
      GO TO 1001
  906 WRITE (NOUT,9006) UFM
      GO TO 1001
  908 WRITE (NOUT,9008) UFM
      GO TO 1001
  909 WRITE (NOUT,9009) UFM
      GO TO 1001
  910 WRITE (NOUT,9010) UFM
 1001 CALL MESAGE (-37,0,NAME)
 2008 CALL MESAGE ( -8,0,NAME)
 9001 FORMAT (A23,'6551, MATRIX B IN MPY3 IS NOT SQUARE FOR A(T)BA + E',
     1       ' PROBLEM.')
 9002 FORMAT (A23,' 6552, NO. OF ROWS OF MATRIX A IN MPY3 IS UNEQUAL TO'
     1,      /5X,'NO. OF ROWS OF MATRIX B FOR A(T)B + E PROBLEM.')
 9003 FORMAT (A23,' 6553, NO. OF ROWS OF MATRIX A IN MPY3 IS UNEQUAL TO'
     1       /5X,'NO. OF COLUMNS OF MATRIX B FOR A(T)BA + E PROBLEM.')
 9004 FORMAT (A23,' 6554, NO. OF COLUMNS OF MATRIX E IN MPY3 IS UNEQUAL'
     1,      /5X,'TO NO. OF COLUMNS OF MATRIX A FOR A(T)BA +E PROBLEM.')
 9005 FORMAT (A23,' 6555, MATRIX E IN MPY3 IS NOT SQUARE FOR A(T)BA + ',
     1       'E PROBLEM.')
 9006 FORMAT (A23,' 6556, NO. OF ROWS OF MATRIX E IN MPY3 IS UNEQUAL TO'
     1,      /5X,'NO. OF ROWS OF MATRIX B FOR BA + E PROBLEM.')
 9008 FORMAT (A23,' 6558, INSUFFICIENT TIME REMAINING FOR MPY3 ',
     1       'EXECUTION.')
 9009 FORMAT (A23,' 6524, NO. OF COLUMNS OF MATRIX E IN MPY3 IS UNEQUAL'
     1,      ' TO',/5X,'NO. OF COLUMNS OF MATRIX B FOR A(T)B + E ',
     2       'PROBLEM.')
 9010 FORMAT (A23,' 6559, NO. OF ROWS OF MATRIX E IN MPY3 IS UNEQUAL TO'
     1,      /5X,'NO. OF COLUMNS OF MATRIX A FOR A(T)B + E PROBLEM.')
C
C     RETURN
C
 9999 DIAG = ORF(DIAG,LSHIFT(L19,18))
      METH = KMETH
      MPY(3) = JEND
      CALL CONMSG (MPY,3,0)
      RETURN
      END

      SUBROUTINE DRKAPM (ARG,INDX,RESLT)
C
C     THIS SUBROUTINE COMPUTES THE DERVIATIVE OF KAPPA MINUS
C
      COMPLEX         AI,ARG,RESLT,BSYCON,C1,C2,C2TEST,AT2,AT3,ALP0,
     1                ALP,ALN
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /SYSTEM/ SYSBUF,IBBOUT
      COMMON /BLK1  / SCRK,SPS,SNS,DSTR,AI,PI,DEL,SIGMA,BETA,RES
      COMMON /BLK2  / BSYCON
C
      PI2  = 2.0*PI
      A1   = PI2/(SPS-SNS)
      A2   =-A1
      GAM0 = SPS*DEL - SIGMA
      B1   = GAM0/(SPS-SNS)
      C1   = CEXP(-AI*ARG/2.0*(SPS-SNS))
      C2Q  = GAM0/DSTR - SCRK
      C3Q  = GAM0/DSTR + SCRK
      S1   = SPS/(DSTR**2)
      S2   = SNS/DSTR
      NN   = 0
      CSEC = C2Q*C3Q
      IF (CSEC .LT. 0.0) NN = 1
      T1   = GAM0*S1
      T2   = S2*SQRT(ABS(CSEC))
      IF (C2Q.LT.0.0 .AND. C3Q.LT.0.0) T2 =-T2
      IF (NN .EQ. 0) ALP0 = T1 + T2
      IF (NN .EQ. 1) ALP0 = CMPLX(T1,T2)
      RINDX = INDX
      IF (INDX .EQ. 0) GO TO 10
      C2   = C1*B1/ALP0*CSIN(PI/A1*(ARG-B1))/(A1*RINDX+B1-ARG)*
     1       (1.0+(ALP0-B1)/(B1-ARG))/(SIN(PI*B1/A1))*BSYCON
      GO TO 20
   10 CONTINUE
      C2   = C1*B1/ALP0*CSIN(PI/A1*(ARG-B1))/((B1-ALP0)*SIN(PI*B1/A1))*
     1       BSYCON
   20 CONTINUE
      C2TEST = 0.0
      DO 30 I = 1,200
      R    = I
      IF (INDX.LT.0 .AND. ABS(RINDX).EQ.R) GO TO 30
      IF (INDX.GT.0 .AND. RINDX.EQ.R) GO TO 30
      GAMP = PI2*R + GAM0
      GAMN =-PI2*R + GAM0
      C2P  = GAMP/DSTR - SCRK
      C2Q  = GAMP/DSTR + SCRK
      C2N  = GAMN/DSTR - SCRK
      C3Q  = GAMN/DSTR + SCRK
      NN   = 0
      CSEC = C2P*C2Q
      IF (CSEC .LT. 0.0) NN = 1
      T1   = GAMP*S1
      T2   = S2*SQRT(ABS(CSEC))
      IF (C2P.LT.0.0 .AND. C2Q.LT.0.0) T2 =-T2
      IF (NN .EQ. 0) ALP = T1 + T2
      IF (NN .EQ. 1) ALP = CMPLX(T1,T2)
      NN   = 0
      CSEC = C2N*C3Q
      IF (CSEC .LT. 0.0) NN = 1
      T1   = GAMN*S1
      T2   = S2*SQRT(ABS(CSEC))
      IF (C2N.LT.0.0 .AND. C3Q.LT.0.0) T2 =-T2
      IF (NN .EQ. 0) ALN = T1 + T2
      IF (NN .EQ. 1) ALN = CMPLX(T1,T2)
      AT2  = (ALP-A1*R-B1)/(A1*R+B1-ARG)
      AT3  = (ALN-A2*R-B1)/(A2*R+B1-ARG)
      C2   = C2*(1.0+AT2)*(1.0+AT3)
      IF (CABS((C2-C2TEST)/C2) .LT. 0.0009) GO TO 40
      C2TEST = C2
   30 CONTINUE
      GO TO 50
   40 CONTINUE
      RESLT = C2
      RETURN
C
   50 CONTINUE
      WRITE  (IBBOUT,60) UFM
   60 FORMAT (A23,' - AMG MODULE -SUBROUTINE DRKAPM')
      CALL MESAGE (-61,0,0)
      RETURN
      END

      SUBROUTINE ELELBL (GPLST,X,U,DEFORM,BUF1)
C
      LOGICAL         SOLID
      INTEGER         BLANK    ,BUF1     ,BR       ,Q4       ,T3      ,
     1                CHR      ,CREW     ,DEFORM   ,HB       ,TWOD    ,
     2                ECT      ,ELID     ,ELIDP(2) ,ELSETS   ,ELTYPE  ,
     3                GPTS     ,GPLST(1) ,LBL(10)  ,LBLP(8)  ,RDREW   ,
     4                PID      ,PLABEL   ,PLTFLG   ,PSET     ,OFFSET
      REAL            INFNTY   ,LEN      ,MA       ,MAXLEN   ,MB      ,
     1                MINSLP   ,X(3,1)   ,U(2,1)
      COMMON /BLANK / SKP(3),PLTFLG,SKP1(6),SKP2(2),ELSETS,CASECC(5),ECT
      COMMON /SYSTEM/ KSYSTM(40),NCPW
      COMMON /NAMES / NOREW,RDREW,SKPN(2),CREW
      COMMON /GPTA1 / NTYPS,LAST,INCR,NE(1)
      COMMON /CHAR94/ CHR(60)
      COMMON /PLTDAT/ SKPPLT(20),SKPA(3),CNTCHR(2)
      COMMON /DRWDAT/ PSET,PLABEL
      COMMON /PLTSCR/ NCOR,XY(2,8),GPTS(4)
C
      DATA   BLANK  , INFNTY,SLPMAX   / 1H ,1.E3,5. /, PID / 4      /,
     1       ITETRA / 2HTE   /, IECT  / 4HECT   / , HB     / 2HHB   /,
     2       BR     / 2HBR   /, Q4    / 2HQ4    /,  T3     / 2HT3   /
C
      NP = 0
      CALL TIPE (0,0,0,0,0,-1)
      CNTX = CNTCHR(1)
      CNTY = CNTCHR(1) + (CNTCHR(2) - CNTCHR(1))/2.
C
C   . CHECK IF PROPERTY ID IS TO BE TYPED NEXT TO ELEMENT ID
C
      IF (PLABEL .NE. PID) GO TO 40
      IF (PLTFLG .LT.   0) GO TO 10
      CALL PRELOC (*10,GPLST(BUF1),ECT)
      CALL FNAME  (ECT,GPTS(1))
      IF (GPTS(1) .EQ. IECT) GO TO 20
      CALL CLOSE (ECT,CREW)
   10 PLABEL = PID - 1
      GO TO 40
   20 CALL DELSET
      LPID = 0
C
C   . READ THE ELEMENT TYPE + NUMBER OF GRID POINTS / ELEMENT OF THIS
C     TYPE.
C
   30 IF (LPID .GT. 0) CALL FWDREC(*40,ECT)
   40 CALL READ (*200,*200,ELSETS,ELTYPE,1,0,I)
      CALL FREAD (ELSETS,NGPEL,1,0)
      TWOD = 0
      IF (NGPEL .GT. 2) TWOD = 1
      NGPEL = IABS (NGPEL)
      SOLID =.FALSE.
      IF ((ELTYPE.EQ.ITETRA .OR. NGPEL.GT.4) .AND. ELTYPE.NE.HB)
     1     SOLID = .TRUE.
C-----
C   . REJECT ELEMENTS WITH 0 OR MORE THAN --NCOR-16-- GRID POINTS
C
      IF (NGPEL.GT.1 .AND. NGPEL.LT.NCOR-13) GO TO 60
   50 CALL FREAD (ELSETS,ELID,1,0)
      IF (ELID .LE. 0) GO TO 40
      CALL FREAD (ELSETS,0,-1,0)
      CALL FREAD (ELSETS,0,-NGPEL,0)
      GO TO 50
   60 CONTINUE
C-----
      IF (PLABEL .NE. PID) GO TO 90
      J = 16
      DO 70 I = 1,NTYPS
      IF (NE(J) .EQ. ELTYPE) GO TO 80
   70 J = J + INCR
      GO TO 90
   80 LPID = J - 12
      IF (NE(LPID+2) .LE. 0) GO TO 90
      NPID = NE(LPID+2)
      CALL LOCATE (*90,GPLST(BUF1),NE(LPID),GPTS(1))
      GO TO 100
   90 LPID = 0
C
  100 NGPEL1 = NGPEL + 1
      OFFSET = 0
      IF (ELTYPE .EQ. BR) OFFSET = 6
      IF (ELTYPE.EQ.Q4 .OR. ELTYPE.EQ.T3) OFFSET = 1
C
C     READ AN ELEMENT ID + ITS GRID POINTS.
C
  102 CALL FREAD (ELSETS,ELID,1,0)
      IF (ELTYPE .EQ. HB) NGPEL = 8
      IF (ELID   .LE.  0) GO TO 30
      CALL FREAD (ELSETS,0,-1,0)
      CALL FREAD (ELSETS,GPTS(1),NGPEL,0)
      IF (OFFSET .GT. 0) CALL FREAD (ELSETS,0,-OFFSET,0)
      IF (ELTYPE .NE. HB) GO TO 1028
      DO 1023 I = 2,4
      IF (GPTS(I)) 1023,1025,1023
 1023 CONTINUE
      I = 5
 1025 NGPEL = I - 1
 1028 CONTINUE
      K = ELID
      NL = 0
      DO 103 I = 1,8
      J = ELID/10**(8-I)
      IF (J.EQ.0 .AND. NL.EQ.0) GO TO 103
      NL = NL + 1
      LBL(NL) = CHR(J+1)
      ELID = ELID - J*10**(8-I)
  103 CONTINUE
      LBL(NL+1) = KHRFN1(BLANK,1,ELTYPE,1)
      LBL(NL+2) = KHRFN1(BLANK,1,ELTYPE,2)
      NL = NL + 2
C
C   . DECODE PROPERTY ID
C
      IF (LPID .LE. 0) GO TO 105
 1040 CALL READ (*1041,*1041,ECT,ELIDP,2,0,I)
      CALL FREAD (ECT,0,-(NPID-2),0)
      IF (ELIDP(1) .EQ. K) GO TO 1042
      GO TO 1040
 1041 LPID = -1
      GO TO 105
C
C   . ELEMENT PROPERTY FOUND
C
 1042 K  = 10000000
      NP = 0
      DO 1043 I = 1,8
      J = ELIDP(2)/K
      IF (J.EQ.0 .AND. NP.EQ.0) GO TO 1043
      NP = NP + 1
      LBLP(NP) = CHR(J+1)
      ELIDP(2) = ELIDP(2) - J*K
 1043 K = K/10
C
  105 CONTINUE
C
C   . SET UP THE COORDINATES OF THE GRID POINTS
C
      DO 108 I = 1,NGPEL
      J = GPTS(I)
      J = IABS(GPLST(J))
      IF (DEFORM .NE. 0) GO TO 106
      XX = X(2,J)
      YY = X(3,J)
      GO TO 107
  106 XX = U(1,J)
      YY = U(2,J)
  107 IF (SOLID) GO TO 1071
      XY(1,I) = XX
      XY(2,I) = YY
      J = NGPEL + I
      XY(1,J) = XX
      XY(2,J) = YY
      GO TO 108
 1071 IF (I .GT. 2) GO TO 1072
      XY(1,I) = XX
      XY(2,I) = YY
      IF (I .NE. 1) GO TO 1072
      XY(1,3) = 0.0
      XY(2,3) = 0.0
 1072 XY(1,3) = XX + XY(1,3)
      XY(2,3) = YY + XY(2,3)
  108 CONTINUE
C
      IF (SOLID) GO TO 160
      IF (TWOD  .NE. 0) GO TO 110
      IF (NGPEL .EQ. 2) GO TO 125
      K = 3
      GO TO 120
C
C     FIND THE BASE OF THIS POLYGON = LONGEST SIDE (IF MORE THAN ONE
C     LONGEST SIDE, CHOOSE FROM THEM THE SIDE OF SMALLEST SLOPE).
C
  110 MAXLEN = 0.
      DO 116 I = 1,NGPEL
      XX = XY(1,I+1) - XY(1,I)
      YY = XY(2,I+1) - XY(2,I)
      LEN = XX**2 + YY**2
      IF (XX .NE. 0.) GO TO 111
      SLP = INFNTY
      GO TO 112
  111 SLP = ABS(YY/XX)
  112 IF (MAXLEN-LEN) 113,114,116
  113 MAXLEN = LEN
      GO TO 115
  114 IF (SLP .GE. MINSLP) GO TO 116
  115 K = I
      MINSLP = SLP
  116 CONTINUE
C
      IF (K .EQ. 1) GO TO 122
  120 DO 121 I = 1,NGPEL1
      XY(1,I) = XY(1,K)
      XY(2,I) = XY(2,K)
      K = K + 1
  121 CONTINUE
  122 IF (NGPEL .EQ. 6) GO TO 140
      IF (NGPEL-3) 125,140,150
C
C     LINE ELEMENT.
C
  125 XX = XY(1,2) - XY(1,1)
      IF (XX .EQ. 0.) GO TO 126
      YY = XY(2,2) - XY(2,1)
      SLP= YY/XX
      GO TO 127
  126 SLP= INFNTY
  127 XC = (XY(1,1) + XY(1,2))/2.
      YC = (XY(2,1) + XY(2,2))/2.
C
      IF (ABS(SLP)-1.) 128,128,129
  128 YC = YC + CNTY
      GO TO 175
  129 IF (ABS(SLP)-SLPMAX) 130,131,131
  130 XC = XC - SIGN(CNTX,SLP)
      GO TO 175
  131 XC = XC + CNTX
      GO TO 175
C
C     TRIANGULAR ELEMENT.  POINTS 1+2 ARE THE BASE - POINT 3 THE APEX.
C
  140 XC = (XY(1,1) + XY(1,2) + XY(1,3))/3.
      YC = (XY(2,1) + XY(2,2) + XY(2,3))/3.
      GO TO 175
C
C     QUADRILATERAL ELEMENT.
C
  150 XX = (XY(1,3)+XY(1,4)) - (XY(1,1)+XY(1,2))
      IF (XX .NE. 0.) GO TO 151
      MA = INFNTY
      GO TO 152
  151 YY = (XY(2,3)+XY(2,4)) - (XY(2,1)+XY(2,2))
      MA = YY/XX
      BA = (XY(2,1)+XY(2,2))/2. - MA*(XY(1,1)+XY(1,2))/2.
  152 XX = (XY(1,2)+XY(1,3)) - (XY(1,1)+XY(1,4))
      IF (XX .NE. 0.) GO TO 153
      MB = INFNTY
      GO TO 155
  153 YY = (XY(2,2)+XY(2,3)) - (XY(2,1)+XY(2,4))
      MB = YY/XX
      BB = (XY(2,1)+XY(2,4))/2. - MB*(XY(1,1)+XY(1,4))/2.
C
  155 IF (ABS(MA) .GE. INFNTY) GO TO 156
      IF (ABS(MB) .GE. INFNTY) GO TO 157
      IF (MB .EQ. MA) GO TO 158
      XC = (BA-BB)/(MB-MA)
      YC = MA*XC + BA
      GO TO 175
  156 XC = (XY(1,1) + XY(1,2))/2.
      YC = MB*XC + BB
      GO TO 175
  157 XC = (XY(1,1) + XY(1,4))/2.
      YC = MA*XC + BA
      GO TO 175
  158 XC = (XY(1,3) + XY(1,4) + XY(1,2)+XY(1,1))/4.0
      YC = (XY(2,3) + XY(2,4) + XY(2,2)+XY(2,1))/4.0
      GO TO 175
C
C   . ELEMENTS WITH MORE THAN FOUR GRIDS
C
  160 XC = XY(1,3)/FLOAT(NGPEL)
      YC = XY(2,3)/FLOAT(NGPEL)
      GO TO 175
C
C     SETUP THE STRAIGHT LINE EQUATION OF THE LINE ON WHICH THE ELEMENT
C     LABEL IS TO BE TYPED - Y=MX+B.
C
  175 XX = XY(1,2) - XY(1,1)
      IF (XX .EQ. 0.) GO TO 176
      YY = XY(2,2) - XY(2,1)
      SLP= YY/XX
      B  = YC - XC*SLP
      GO TO 180
  176 SLP= INFNTY
C
C     TYPE THE ELEMENT LABEL (NL CHARACTERS)
C
  180 ZZ = NL/2
      IF (NL/2 .EQ. (NL+1)/2) ZZ = ZZ - .5
      ABSSLP = ABS(SLP)
      CC = CNTX
      IF (ABSSLP .GE. SLPMAX) CC = CNTY
      K = MAX0(NL,NP)
C
      DO 191 I = 1,K
      XX = CC*(ZZ - FLOAT(I-1))
      IF (ABSSLP .GT. 1.) GO TO 181
      XX = XC - XX
      YY = SLP*XX + B
      GO TO 190
  181 IF (ABSSLP .GE. SLPMAX) GO TO 182
      YY = SIGN(1.,SLP)
      GO TO 183
  182 YY = -1.
  183 YY = YC - YY*XX
      IF (ABSSLP .GE. INFNTY) GO TO 184
      XX = (YY-B)/SLP
      GO TO 190
  184 XX = XC
C
C
C     OFFSET THE HB LABEL AND PROPERTY ID IF ANY WHEN TIPE LABEL
C
  190 IF (ELTYPE .NE. HB) GO TO 1905
      JTJ = 2
      IF (ABSSLP .LT. SLPMAX) YY = YY - JTJ*CC
      IF (ABSSLP .GE. SLPMAX) XX = XX + JTJ*CC
 1905 IF (NL .GE. I) CALL TIPE (XX,YY,1,LBL(I),1,0)
      IF (LPID .LE. 0) GO TO 191
      IF (NP   .LT. I) GO TO 191
      IF (ABSSLP .LT. SLPMAX) YY = YY - 2.*CC
      IF (ABSSLP .GE. SLPMAX) XX = XX + 2.*CC
      CALL TIPE (XX,YY,1,LBLP(I),1,0)
  191 CONTINUE
      GO TO 102
C
  200 CALL TIPE (0,0,0,0,0,1)
      IF (PLABEL .EQ. PID) CALL CLOSE (ECT,CREW)
      RETURN
      END

        SUBROUTINE DSWRNB
      INCLUDE 'DSIOF.COM'
      INCLUDE 'XNSTRN.COM'
        IBASE( INDBAS+4 ) = INDCLR - INDBAS + 1
        CALL DBMMGR( 4 )
        NBLOCK  = FCB( 4, IFILEX )
        INDCLR  = INDBAS + 5
        IBASE( INDBAS+3 ) = NBLOCK
        INDCBP  = INDCLR
        RETURN
        END

      SUBROUTINE ALG30 (A,B)
C
      DIMENSION A(9,9),B(9),INDEX(9)
C
      N=9
      DO 100 J=1,N
100   INDEX(J)=0
110   AMAX=-1.0
      DO 120 J=1,N
      IF(INDEX(J).NE.0)GO TO 120
      DO 115 L=1,N
      IF(INDEX(L).NE.0)GO TO 115
      PV=ABS(A(J,L))
      IF(PV.LE.AMAX)GO TO 115
      IR=J
      IC=L
      AMAX=PV
115   CONTINUE
120   CONTINUE
      IF(AMAX.LE.0.0)RETURN
      INDEX(IC)=IR
      IF(IC.EQ.IR)GO TO 150
      DO 140 L=1,N
      PV=A(IR,L)
      A(IR,L)=A(IC,L)
      A(IC,L)=PV
      IF(L.GT.1)GO TO 140
      PV=B(IR)
      B(IR)=B(IC)
      B(IC)=PV
140   CONTINUE
150   PV=1.0/A(IC,IC)
      A(IC,IC)=1.0
      DO 160 L=1,N
      A(IC,L)=A(IC,L)*PV
      IF(L.GT.1)GO TO 160
      B(IC)=B(IC)*PV
160   CONTINUE
      DO 180 L1=1,N
      IF(L1.EQ.IC)GO TO 180
      PV=A(L1,IC)
      A(L1,IC)=0.0
      DO 170 L=1,N
170   A(L1,L)=A(L1,L)-A(IC,L)*PV
      B(L1)=B(L1)-B(IC)*PV
180   CONTINUE
      GO TO 110
      END

      SUBROUTINE PSTA(DELTAY,BI,CA,ALPH,THI,AJJL)
      DIMENSION A(3,3),AI(6),AJ(6),H(3,3),EK(6),G(3,3),GI(3,3),Q(3,3)
      DIMENSION DELTAY(1),BI(1),CA(1),ALPH(1),THI(13)
      DIMENSION P(3,6),QI(3,3)
      COMPLEX PC(3)
      COMMON /PACKX/ ITI,IT0,II,NN,INCR
      COMMON /AMGMN/ MCB(7),NROW,ND,NE,REFC,EMACH,RFK
      COMMON /PSTONC/ NJJ,NMACH,NTHRY,NTHICK,NALPHA,NXIS,NTAUS,NSTRIP,
     *                SECLAM
      COMMON / CONDAS / PI,TWOPI,RADG,DEGRA
      DATA A /9*0.0/ , H /9*0.0/
      BREF = REFC * .5
      RFC = RFK/BREF
      II = NROW +1
      NN = NROW
C
C     BUILD AJJL FOR EACH STRIP
C
      DO 200 I=1,NSTRIP
      B = BI(I)
      CONST = 8.0 * DELTAY(I) * (RFC * B)**2
      A(1,1) = -1.0
      A(2,1) = -.5 * B
      A(2,2) = B
      A(3,3) = B
      H(1,1) = -1.0
      H(1,2) = A(2,1)
      H(2,2) = B
      H(3,3) = B
      ALPHA = ALPH(1)
      IF(NALPHA.NE.1 ) ALPHA = ALPH(I)
      ALPHA = ALPHA * DEGRA
      ALPHA2 = ALPHA*ALPHA
      N = 2
      IF(CA(I) .NE. 0.0 ) N = 3
      IF( NTHICK .EQ. 0 ) GO TO 20
      DO 10 J=1,6
      AI(J) = THI(J)
      AJ(J) = 0.0
      IF(N .EQ. 3 ) AJ(J) = THI(J+6)
   10 CONTINUE
      ZETAH = 1.0
      IF( NXIS .EQ. 1 ) ZETAH = THI(13)
      IF( NXIS.GT.1) ZETAH = THI(I+12)
      GO TO 70
   20 IF( NTAUS .NE. 1 ) GO TO 30
      TAU = THI(1)
      TAUH = THI(2)
      TAUT = THI(3)
      IF( N .EQ. 2 ) TAUT = 0.
      T = TAUH-TAUT
      ZETAM = THI(4)
      ZETAH = THI(5)
      GO TO 50
   30 K = (I-1) * 3+1
      TAU = THI(K)
      TAUH = THI(K+1)
      TAUT = THI(K+2)
      IF( N .EQ. 2 ) TAUT = 0.
      T = TAUH - TAUT
      K = (I-1)*2+1 + 3*NSTRIP
      ZETAM = THI(K)
      ZETAH = THI(K+1)
      DO 40 J=1,6
   40 AJ(J) = 0.
   50 IF(N .EQ. 2 ) ZETAH = 1.0
      IF( N .EQ. 2 ) GO TO 60
      AJ(1) = -.5 * T
      AJ(2) = -.25*T*(1.0+ZETAH)
      AJ(3) = -(1./6.)*T*(1.+ZETAH+ZETAH*ZETAH)
      AJ(4) = .25*T*T/ (1.-ZETAH)
      AJ(5) = .125*T*T*(1.0+ZETAH) / (1.-ZETAH)
      AJ(6) = (1./12.)*T*T*(1.+ZETAH+ZETAH*ZETAH) / (1.-ZETAH)
   60 TS = TAU-TAUH*(TAU-TAUH)
      AI(1) = TAUH*.5 + AJ(1)
      AI(2) = -(TAU/3.)*ZETAH + (TAUH/6.) * (2.*ZETAH+ZETAM) + AJ(2)
      AI(3) = -(TAU/12.)*ZETAH *(3.*ZETAH+2.*ZETAM) + (TAUH/12.) *
     *          (3. *ZETAH*ZETAH + 2.*ZETAH*ZETAM+ZETAM*ZETAM) + AJ(3)
      AI(4) = (TAU*TAU/(3. *ZETAM)) + (1./3.)*TS*(ZETAH-ZETAM) + AJ(4)
      AI(5) = (TAU*TAU/12.) + (1./12.)*TS*(3.*ZETAH + ZETAM) /
     *         (ZETAH-ZETAM) + AJ(5)
      AI(6) = (TAU*TAU/30.) * ZETAM + (1./30.)*TS*(6.*ZETAH*ZETAH +
     *         3.*ZETAH*ZETAM + ZETAM*ZETAM) / (ZETAH-ZETAM) + AJ(6)
   70 EMS = EMACH*EMACH
      SECS = SECLAM*SECLAM
      IF( NTHRY .NE. 0 ) GO TO 80
      CBAR1 = 1.
      CBAR2 = (1.4+1.)/4.
      GO TO 90
   80 CBAR1 = EMACH / SQRT(EMS-SECS)
      CBAR2 = (EMS*EMS*(1.4+1.)- 4.*SECS*(EMS-SECS)) /(4.*(EMS-SECS)**2)
   90 CBAR3 = (1.4+1.) / 12.
      EK(1) = (1./EMACH ) *(CBAR1+2.*CBAR2*EMACH*AI(1)
     *       + 3.*CBAR3*EMS*(AI(4)+ALPHA2))
      EK(2) = (1./EMACH) * (CBAR1+4.*CBAR2*EMACH * AI(2)
     *       + 3.*CBAR3*EMS*(2.*AI(5)+ALPHA2))
      EK(3) = (4./(3.*EMACH)) * (CBAR1+6.*CBAR2*EMACH*AI(3)
     *       + 3.*CBAR3*EMS*(3.*AI(6)+ALPHA2))
      IF( N .EQ. 3 ) GO TO 100
      EK(4) = (1./EMACH) * (CBAR1*(1.-ZETAH) + 2.*CBAR2*EMACH*AJ(1)
     *       +3.*CBAR3*EMS*AJ(4) + ALPHA2*(1.-ZETAH))
      EK(5) = (1./EMACH) * (CBAR1*(1.-ZETAH*ZETAH) + 4.*CBAR2*EMACH*
     *       AJ(2) + 3.*CBAR3*EMS*(2.*AJ(5)+ALPHA2*(1.-ZETAH*ZETAH)))
      EK(6) = (4./(3.*EMACH))*(CBAR1*(1.-ZETAH**3) + 6.*CBAR2*EMACH*
     *       AJ(3) + 3.*CBAR3*EMS*(3.*AJ(6)+ ALPHA2*(1.-ZETAH**3)))
      E1K = 1.0/(RFC *B)
      E1KS = E1K*E1K
      G(1,1) = 0.
      G(1,2) = -EK(1) * E1KS
      G(2,1) = 0.
      G(2,2) = -EK(2) * E1KS
      GI(1,1) = -EK(1) * E1K
      GI(1,2) = -EK(2) * E1K
      GI(2,1) = GI(1,2)
      GI(2,2) = -EK(3) * E1K
      IF( N .EQ. 3 ) GO TO 100
      G(1,3) = -EK(4) * E1KS
      G(2,3) = -EK(5) * E1KS
      G(3,1) = 0.
      G(3,2) =-(EK(5)-2.*EK(4)*ZETAH) * E1KS
      G(3,3) = G(3,2)
      GI(1,3) = -(EK(5)-2.*EK(4)*ZETAH) * E1K
      GI(2,3) = -(EK(6)-2.*EK(5)*ZETAH) * E1K
      GI(3,1) = GI(1,3)
      GI(3,2) = -(EK(6) -2.*EK(5)*ZETAH) * E1K
      GI(3,3) = -(EK(6)-4.*EK(5)*ZETAH+4.*EK(4)*ZETAH*ZETAH) * E1K
C
C     MATRICES BUILT TIME TO MULTIPLY
C
  100 DO 110 K=1,N
      DO 110 L=1,N
      Q(K,L) = 0.
      QI(K,L) = 0.
      DO 110 M1=1,N
      Q(K,L) = Q(K,L) + A(K,M1) * G(M1,L)
      QI(K,L) = QI(K,L) + A(K,M1) * GI(M1,L)
  110 CONTINUE
      N2 = 2*N
      DO 130 K=1,N
      DO 130 L=1,N2,2
      IT = L/2+1
      P(K,L) = 0.
      P(K,L+1) = 0.
      DO 120 M1=1,N
      P(K,L) = P(K,L) + Q(K,M1) * H(M1,IT)
      P(K,L+1) = P(K,L+1) + QI(K,M1)*H(M1,IT)
  120 CONTINUE
      P(K,L) = P(K,L) * CONST
      P(K,L+1) = P(K,L+1) * CONST
  130 CONTINUE
C
C     PACK OUT
C
      NN = NN+N
      DO 150 J=1,N2,2
      DO 140 K=1,N
      PC(K) = CMPLX(P(K,J),P(K,J+1))
  140 CONTINUE
      CALL PACK(PC,AJJL,MCB)
  150 CONTINUE
      II = II+N
  200 CONTINUE
      RETURN
      END

      SUBROUTINE DBMDIA
C********************************************************************
C     DBMDIA - DUMPS THE IN MEMORY DATA BASE DIRECTORY
C********************************************************************
      INCLUDE  'DSIOF.COM'
      INCLUDE  'ZZZZZZ.COM'
      COMMON / SYSTEM / ISYSBF, IWR
      INTEGER           SCRATCH(2)
      DATA              SCRATCH / 4HSCRA , 4HTCHX /
      IBLKSZ = ISYSBF - 4
      ITOTI  = 0
      ITOTX  = 0
      WRITE ( IWR, 903 )
      DO 20 I = 1, 80
      IF ( I .EQ. 7 ) GO TO 20
      IF ( FCB( 9,I ) .EQ. 0 .AND. FCB( 5,I ) .EQ. 0 ) GO TO 20
      INDEX = FCB( 10, I )
      IINTB = 0
      IEXTB = 0
      IF ( FCB( 9,I ) .NE. 0 ) IINTB = MEM( INDEX+3 )
      ITOTI = ITOTI + IINTB
      IF ( FCB( 5,I ) .NE. 0 ) IEXTB = FCB(6,I) - FCB( 5,I) + 1
      IF ( IEXTB .GE. FCB( 7, IFILEX ) ) GO TO 20
      ITOTX = ITOTX + IEXTB
      IF ( FCB( 13,I ) .NE. 0 ) GO TO 15
      FCB( 13,I ) = SCRATCH(1)
      FCB( 14,I ) = SCRATCH(2)
15    CONTINUE
      WRITE ( IWR, 904 ) I, FCB( 13,I ), FCB( 14,I ), FCB( 4,I )
     &,                  IINTB, IEXTB
20    CONTINUE
      WRITE ( IWR, 905 ) ITOTI, ITOTX
C      WRITE ( IWR, 906 ) MAXBLK, MAXDSK, MAXALC, IBLKSZ
700   RETURN
903   FORMAT(///,27X,' MEMORY DATA BASE DIRECTORY',//,
     &'    UNIT    NAME   CURRENT  IN-MEM'
     &,'   DISK ',/,
     &'                    BLOCK   BLOCKS'
     &,'  BLOCKS ',/)
904   FORMAT(I7,3X,2A4,2X,I6,2X,I6,2X,I6 )
905   FORMAT(/,' CURRENT IN-MEMORY BLOCKS =',I16
     &      ,/,' CURRENT DISK BLOCKS      =',I16 )
906   FORMAT(/,' MAXIMUM IN-MEMORY BLOCKS USED                   =',I16
     &      ,/,' MAXIMUM DISK BLOCKS WRITTEN                     =',I16
     &      ,/,' BLOCKS INITIALLY ALLOCATED FOR THE IN-MEMORY DB =',I16
     &      ,/,' BLOCK SIZE                                      =',I16)
      END

      SUBROUTINE ROMBSK (B,PRECIS,ITDONE,FINTG,K,X)
C
C     THIS SUBROUTINE IS USED TO INTEGRATE A FUNCTION FROM X=0. TO X=B
C
C     SINGLE PRECISION VERSION
C
C     B      = UPPER LIMIT
C     NOSIG  = NUMBER OF CORRECT SIGNIFICANT DIGITS DESIRED
C              (NOT MORE THAN 7) = 5
C     PRECIS = 0.0  UPON RETURN, PRECIS = ACTUAL NUMBER
C              OF SIGNIFICANT DIGITS ATTAINED
C     NUM    = MAXIMUM NUMBER OF HALVINGS OF B-A TO BE MADE
C              (NOT MORE THAN 99) = 15
C
C     UPON RETURN FROM ROMBSK, THE VALUE OF THE INTEGRAL WILL BE FOUND
C     IN FINTG.
C
C     IT IS CUSTOMARY TO MEASURE THE PRECISION OF LARGE NUMBERS IN
C     TERMS OF NUMBER OF SIGNIFICANT DIGITS AND THE ACCURACY OF SMALL
C     NUMBERS IN TERMS OF NUMBER OF SIGNIFICANT DECIMALS.  TO CONFORM
C     TO THIS PRACTICE, THE SUBROUTINE TERMINATES WHEN EITHER OF THESE
C     CONDITIONS IS MET.
C
C
      DIMENSION  X(6),FAAAA(20),FAAAB(20)
C
      FAAAC =.00001
      IAAAA = 1
      FAAAD = B
      X(1)  = 0.
      ASSIGN 100 TO IRET
      GO TO (1000,2000,3000), K
  100 CONTINUE
      FAAAE = F
      X(1)  = B
      ASSIGN 200 TO IRET
      GO TO (1000,2000,3000), K
  200 CONTINUE
      FAAAE = FAAAE + F
      FAAAA(1) = 0.5*FAAAD*FAAAE
 9988 FAAAD = 0.5*FAAAD
      IAAAC = 2**(IAAAA-1)
      FAAAE = 0.0
      IAAAD = 0
 9986 IAAAD = IAAAD + 1
      FAAAF = IAAAD
      X(1)  = (2.0*FAAAF-1.0)*FAAAD
      ASSIGN 300 TO IRET
      GO TO (1000,2000,3000), K
  300 CONTINUE
      FAAAE = FAAAE + F
      IF (IAAAD .LT. IAAAC) GO TO 9986
      FAAAB(1) = 0.5*FAAAA(1) + FAAAD*FAAAE
      IAAAA = IAAAA + 1
      DO 9985 IAAAD = 2,IAAAA
      FAAAG = 4.0**(IAAAD-1)
      FAAAH = FAAAG - 1.0
      IAAAF = IAAAD - 1
 9985 FAAAB(IAAAD) = (FAAAG*FAAAB(IAAAF)-FAAAA(IAAAF))/FAAAH
      IAAAC = 2*IAAAC + 1
      DIFF  = FAAAB(IAAAA) - FAAAA(IAAAA-1)
      IF (ABS(DIFF)-ABS(FAAAC*FAAAB(IAAAA))) 9979,9981,9981
 9981 DO 9980 IAAAD = 1,IAAAA
 9980 FAAAA(IAAAD) = FAAAB(IAAAD)
      IF (IAAAA.LT.15) GO TO 9988
 9979 PRECIS = DIFF
      ITDONE = IAAAA - 1
      FINTG  = FAAAB(IAAAA)
      RETURN
C
C     THIS CODE REPLACES D4K
C
 1000 CONTINUE
      IF (X(1).EQ. 0.) GO TO 1010
      DEN = X(3) - X(2)*X(5) + X(2)*X(5)*COS(X(1)) + X(2)*X(4)*SIN(X(1))
      F   = X(1)**(X(6)-1.)*SIN(X(1))**2/DEN
      GO TO 1020
 1010 F = 0.
 1020 GO TO IRET, (100,200,300)
C
C     THIS CODE REPLACES D5K
C
 2000 CONTINUE
      IF (X(1) .EQ. 0.) GOTO 2010
      DEN = X(3) - X(2)*X(5) + X(2)*X(5)*COS(X(1))+ X(2)*X(4)*SIN(X(1))
      F   = X(1)**(X(6)-1.)*2.*SIN(X(1))*COS(X(1))/DEN
      GO TO 2020
 2010 F = 0.
 2020 GO TO IRET, (100,200,300)
C
C     THIS CODE REPLACES D6K
C
 3000 CONTINUE
      DEN = X(3) - X(2)*X(5) +X(2)*X(5)*COS(X(1))+ X(2)*X(4)*SIN(X(1))
      IF (X(6) .EQ. 1.0) CONST = 1.0
      IF (X(6) .NE. 1.0) CONST = X(1)**(X(6)-1.0)
      IF (DEN .EQ. 0.) GO TO 3010
      F = CONST*COS(X(1))**2/DEN
      GO TO 3020
 3010 F = 0.
 3020 GO TO IRET, (100,200,300)
      END

      SUBROUTINE SUBBB
C
      COMPLEX         SBKDE1,SBKDE2,F4,F4S,AM4,F5S,F6S,AM4TST,SUM3,SUM4,
     1                AM5TT,AM6,SUMSV1,SUMSV2,SVKL1,SVKL2,F5,F5T,AM5,
     2                AM5T,AI,A,B,BSYCON,ALP,F1,AM1,ALN,BLKAPM,BKDEL3,
     3                F1S,C1,C2P,C2N,C2,AMTEST,FT2,BLAM1,FT3,AM2,SUM1,
     4                SUM2,F2,BLAM2,FT2T,C1T,FT3T,F2P,AM2P,SUM1T,SUM2T,
     5                GUSAMP,C1P,C1N,BKDEL1,BKDEL2,BLKAP1,ARG,ARG2,
     6                FT3TST,BC,BC2,BC3,BC4,BC5,CA1,CA2,CA3,CA4,CLIFT,
     7                CMOMT,PRES1,PRES2,PRES3,PRES4,QRES4,CEXP4C,FQA,
     8                FQB,T1,T2,T3,T4,CEXP2A,CEXP2B,CEXP2C,CEXP4A,
     9                CEXP4B,FQ7,C1A,C3A,C4A,CONST,CEXP3,CEXP4,CEXP3A,
     O                CEXP3B,CEXP3C
      DIMENSION       PRES1(21),PRES2(21),PRES3(21),PRES4(21),QRES4(21),
     1                SBKDE1(201),SBKDE2(201),SUMSV1(201),SUMSV2(201),
     2                SVKL1(201),SVKL2(201),XLSV1(21),XLSV2(21),
     3                XLSV3(21),XLSV4(21)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /SYSTEM/ SYSBUF,IBBOUT
      COMMON /BLK1  / SCRK,SPS,SNS,DSTR,AI,PI,DEL,SIGMA,BETA,RES
      COMMON /BLK2  / BSYCON
      COMMON /BLK3  / SBKDE1,SBKDE2,F4,F4S,AM4,F5S,F6S,AM4TST,SUM3,SUM4,
     1                AM5TT,AM6,SUMSV1,SUMSV2,SVKL1,SVKL2,F5,F5T,AM5,
     2                AM5T,A,B,ALP,F1,AM1,ALN,BLKAPM,BKDEL3,F1S,C1,C2P,
     3                C2N,C2,AMTEST,FT2,BLAM1,FT3,AM2,SUM1,SUM2,F2,
     4                BLAM2,FT2T,C1T,FT3T,F2P,AM2P,SUM1T,SUM2T,C1P,C1N,
     5                BKDEL1,BKDEL2,BLKAP1,ARG,ARG2,FT3TST,BC,BC2,BC3,
     6                BC4,BC5,CA1,CA2,CA3,CA4,CLIFT,CMOMT,PRES1,PRES2,
     7                PRES3,PRES4,QRES4,FQA,FQB,FQ7
      COMMON /BLK4  / I,R,Y,A1,B1,C4,C5,GL,I6,I7,JL,NL,RI,RT,R5,SN,SP,
     1                XL,Y1,AMU,GAM,IDX,INX,NL2,RL1,RL2,RQ1,RQ2,XL1,
     2                ALP1,ALP2,GAMN,GAMP,INER,IOUT,REDF,STAG,STEP,
     3                AMACH,BETNN,BETNP,BKAP1,XLSV1,XLSV2,XLSV3,XLSV4,
     4                ALPAMP,AMOAXS,GUSAMP,DISAMP,PITAXS,PITCOR
C
      S1    = 2.0 + SNS - SPS
      T1    = CEXP(-AI*SIGMA)
      T2    = CEXP(+AI*SIGMA)
      TEMP  = S1/RL2
      C1A   = AI*GL
      CONST = B*AI*(DEL-AMU)*BLAM2/BKAP1
      CEXP3 = CEXP(C1A*SPS )
      CEXP4 = CEXP(C1A*TEMP)
      XL    = SPS
      DO 456 JL = 1,NL2
      PRES3(JL) = (FT2T*CEXP3+FT3T+CONST*XL)*T1
      CEXP3 = CEXP3*CEXP4
      XL    = XL + TEMP
  456 CONTINUE
      FT3TST = 0.0
      FT2  = 0.0
      FT3  = 0.0
      FT2T = 0.0
      FT3T = 0.0
      FQA  = BKDEL1/(BC*BETA)*(A*AI*BKDEL2/BKDEL1-B*BLKAP1)*
     1       CEXP(-AI*(DEL*SPS-SIGMA)/2.0)
      DO 60 I = 1,50
      RT  = 0.0
      R   = I - 1
      RI  = (-1.0)**(I-1)
CWKBR ALP = SQRT((R*PI/SNS)**2+SCRK**2)
      ALP = SQRT((R*PI/SNS)**2+SCRK**2)
      ALN = -ALP
      CALL AKAPM (ALP,BKDEL3)
      T3  = ALP - DEL
      SVKL1(I) = BKDEL3
      IF (I .EQ. 1) RT = 1.0
      SUM1  = (ALP-AMU)/(T3)*(RI-CEXP(AI*(T3)*SPS)*T2)/
     1        (BETA*(1.0+RT))*RI/(SNS*ALP)*BKDEL1/BKDEL3*(A*AI*BKDEL2/
     2        BKDEL1*(T3)/(T3+GL)-B*BLKAP1-B/(T3))
      SUM1T = (ALP-AMU)/(T3)*(1.0-CEXP(AI*(T3)*SPS)*T2*RI)/
     1        (BETA*(1.0+RT))*RI/(SNS*ALP)*BKDEL1/BKDEL3*(A*AI*BKDEL2/
     2        BKDEL1*(T3)/(T3+GL)-B*BLKAP1-B/(T3))
      SUMSV1(I) = (ALP-AMU)/(T3)*(1.0-CCOS((T3)*SPS+SIGMA+R*PI))/
     1        (BETA*(1.0+RT)*SNS*ALP)*BKDEL1/BKDEL3*CEXP(-2.0*AI*(ALP-
     2        DEL))*(A*BKDEL2/BKDEL1*(T3)/(T3+GL)+B*AI*BLKAP1+B*AI/(T3))
      FT2   = SUM1*AI/(T3)*(CEXP(-2.0*AI*(T3))-CEXP(-AI*(SPS-SNS)*(T3)))
     1        + FT2
      FT3   = SUM1*(2.0*AI*CEXP(-2.0*AI*(T3))/(T3)-AI*(SPS-SNS)/
     1        (T3)*CEXP(-AI*(T3)*(SPS-SNS))+CEXP(-2.0*AI*(T3))/
     2        ((T3)**2)-CEXP(-AI*(T3)*(SPS-SNS))/((T3)**2)) + FT3
      FT2T  = SUM1T*T1*CEXP(-AI*(T3)*SPS)*AI/(T3)*(CEXP(-AI*(T3)*(S1))-
     1        1.0) + FT2T
      FT3T  = SUM1T*T1*CEXP(-AI*(T3)*SPS)*((S1)*AI/(T3)*CEXP(-AI*(T3)*
     1        (S1)) + 1.0/((T3)**2)*(CEXP(-AI*(T3)*(S1))-1.0)) + FT3T
      CALL AKAPM (ALN,BKDEL3)
      T4    = ALN - DEL
      SVKL2(I) = BKDEL3
      SUM2  = (ALN-AMU)/(T4)*(RI-CEXP(AI*(T4)*SPS)*T2)/(BETA*(1.0+RT))*
     1        RI/(SNS*ALN)*BKDEL1/BKDEL3*(A*AI*BKDEL2/BKDEL1*(T4)/
     2        (T4+GL)-B*BLKAP1-B/(T4))
      SUM2T = (ALN-AMU)/(T4)*(1.0-CEXP(AI*(T4)*SPS)*T2*RI)/(BETA*(1.0+
     1        RT))*RI/(SNS*ALN)*BKDEL1/BKDEL3*(A*AI*BKDEL2/BKDEL1*(T4)/
     2        (T4+GL)-B*BLKAP1-B/(T4))
      SUMSV2(I) = (ALN-AMU)/(T4)*(1.0-CCOS((T4)*SPS+SIGMA+R*PI))/
     1        (BETA*(1.0+RT)*SNS*ALN)*BKDEL1/BKDEL3*CEXP(-2.0*AI*(T4))*
     2        (A*BKDEL2/BKDEL1*(T4)/(T4+GL)+B*AI*BLKAP1+B*AI/(T4))
      FT2   = FT2+SUM2*AI/(T4)*(CEXP(-2.0*AI*(T4))-CEXP(-AI*(SPS-SNS)*
     1        (T4)))
      FT2T  = SUM2T*T1*CEXP(-AI*(T4)*SPS)*AI/(T4)*(CEXP(-AI*(T4)*(S1))-
     1        1.0) + FT2T
      FT3   = FT3+SUM2*(2.0*AI*CEXP(-2.0*AI*(T4))/(T4)-AI*(SPS-SNS)/
     1        (T4)*CEXP(-AI*(T4)*(SPS-SNS))+CEXP(-2.0*AI*(T4))/
     2        ((T4)**2)-CEXP(-AI*(T4)*(SPS-SNS))/((T4)**2))
      FT3T  = FT3T+SUM2T*T1*CEXP(-AI*(T4)*SPS)*((S1)*AI/(T4)*
     1        CEXP(-AI*(T4)*(S1))+1./((T4)**2)*(CEXP(-AI*(T4)*(S1))-1.))
      I7    = I
      AA    = SPS - SNS
      TEMP  = S1/RL2
      TEMP2 = R*PI/SNS
      CONST = 4.0/PI*FQA
      TEMP3 = R + RT
      C3A   = -AI*T3
      C4A   = -AI*T4
      C1A   = AI*DEL
      CEXP3A = CEXP(C3A*AA)
      CEXP3B = CEXP(C3A*SPS)
      CEXP3C = CEXP(C3A*TEMP)
      CEXP4A = CEXP(C4A*AA)
      CEXP4B = CEXP(C4A*SPS)
      CEXP4C = CEXP(C4A*TEMP)
      CEXP2A = CEXP(C1A*AA)
      CEXP2B = CEXP(C1A*SPS)
      CEXP2C = CEXP(C1A*TEMP)
      XL1    = AA
      DO 457 JL = 1,NL2
      PRES2(JL) = SUM1*CEXP3A+SUM2*CEXP4A + PRES2(JL)
      PRES2(JL) = PRES2(JL) + CONST*CEXP2A*RI/TEMP3*SIN(TEMP2*(XL1-SPS))
      XL2 = XL1 + SNS
      PRES3(JL) = (SUM1T*CEXP3B+SUM2T*CEXP4B)*T1 + PRES3(JL)
      PRES3(JL) = PRES3(JL)+CONST*CEXP2B/TEMP3*SIN(TEMP2*(XL2-SPS))*T1
      XL1 = XL1 + TEMP
      CEXP3A = CEXP3A*CEXP3C
      CEXP4A = CEXP4A*CEXP4C
      CEXP2A = CEXP2A*CEXP2C
      CEXP3B = CEXP3B*CEXP3C
      CEXP4B = CEXP4B*CEXP4C
      CEXP2B = CEXP2B*CEXP2C
  457 CONTINUE
      IF (CABS((FT3-FT3TST)/FT3) .LT. 0.0006) GO TO 65
      FT3TST = FT3
   60 CONTINUE
      GO TO 9994
   65 CONTINUE
      FT3TST = FT3
      F2     = F2  + FT2
      AM2    = AM2 + FT3
      F2P    = F2P + FT2T
      AM2P   = AM2P+ FT3T
      AA     = SPS - SNS
      AA1    = SPS + SNS
      AA2    = SPS + 2.0*SNS
      TEMP   = S1/RL2
      XL     = AA
      C1A    = AI*DEL
      CEXP3  = CEXP(C1A*AA)
      CEXP3C = CEXP(C1A*TEMP)
      CEXP4  = CEXP(C1A*SPS)
      CONST  = 2.0*FQA
      CEXP2A = T1*CONST
      DO 4571 JL = 1,NL2
      STEP = 0.0
      IF (XL .GE. AA1) STEP = 1.0
      PRES2(JL) = PRES2(JL) + CONST*CEXP3*((XL-SPS)/SNS-2.0*STEP)
      XL2  = XL + SNS
      STEP = 0.0
      IF (XL2 .GE. AA2) STEP = 1.0
      PRES3(JL) = PRES3(JL) - CEXP2A*CEXP4*(1.0-(XL2-SPS)/SNS+2.0*STEP)
      CEXP3 = CEXP3*CEXP3C
      CEXP4 = CEXP4*CEXP3C
      XL  = XL + TEMP
 4571 CONTINUE
      GAM = SPS*DEL - SIGMA
      C1P = (GAM/DSTR) - SCRK
      C2P = (GAM/DSTR) + SCRK
      ALP = GAM*SPS/(DSTR**2) - SNS/DSTR*CSQRT(C1P)*CSQRT(C2P)
      T3  = ALP - DEL
      F4  = CEXP(AI*(ALP*SPS-GAM))*(ALP*SPS-GAM)/((ALP*DSTR**2-GAM*SPS)*
     1      (T3))
      CALL AKAPM (ALP,BKDEL3)
      SBKDE1(1) = BKDEL3
      SBKDE2(1) = 0.0
      CALL AKAPPA (DEL,BKAP1)
      CARG = DEL - GL
      CALL AKAPPA (CARG,CKAP1)
      F4  = F4*BKDEL3/(BKDEL1*BKAP1)*(A*(BKDEL1/BKDEL2*(T3)/(T3+GL)*
     1      (DEL-GL-AMU)*CEXP(2.0*AI*GL)*BKAP1/CKAP1)+B*AI*(1.0-2.0*AI*
     2      (DEL-AMU)-(DEL-AMU)*RES)-B*AI*(DEL-AMU)*(BLKAP1-1.0/(T3)))
      F5S = B*AI/(BKDEL1*BKAP1)*(1.0-2.0*AI*(DEL-AMU) - (DEL-AMU)*RES -
     1      (DEL-AMU)*BLKAP1)
      F6S = A/(BKDEL1*BKAP1)*(BKDEL1/BKDEL2*(DEL-GL-AMU)*CEXP(2.0*AI*GL)
     1      *BKAP1/CKAP1)
      F4S = F4
      FQ7 = BC*(F6S+F5S)
      TEMP  = (SPS-SNS)/RL1
      TEMP2 = 2.0 - SPS
      CONST = -T1*F4S
      C1A   = -AI*T3
      CEXP3A = CEXP(C1A*SNS)
      CEXP3B = CEXP(C1A*TEMP)
      DO 458 JL = 1,NL
      PRES4(JL) = CONST*CEXP3A
      CEXP3A = CEXP3A*CEXP3B
  458 CONTINUE
      C1  = CEXP(-AI*(T3)*SPS)
      C2  = CEXP(-AI*(T3)*SNS)
      F4  = F4*AI*T1/(T3)*(C1-C2)
      AM4 = F4S*T1*(AI*SPS*C1/(T3)-AI*SNS*C2/(T3)+(C1-C2)/
     1      ((T3)**2))+F4S*AI*(2.0-SPS)*T1/(T3)*(C1-C2)
      CALL SUBC
      RETURN
C
 9994 WRITE  (IBBOUT,3015) UFM
 3015 FORMAT (A23,' - AMG MODULE -SUBROUTINE SUBC.  AM4 LOOP DID NOT ',
     1       'CONVERGE.')
      CALL MESAGE (-61,0,0)
      RETURN
      END

        SUBROUTINE PACK ( A, FILE, MCB )
      INCLUDE 'DSIOF.COM'
      INCLUDE 'PAKBLK.COM'
      INCLUDE 'XNSTRN.COM'
        COMMON / PACKX  / ITYPIN, ITYPOT, IROBGN, LASROW, INCR
        COMMON / DDIOSV / IFLPOS( 2,80 )
        INTEGER           FILE,   MCB(7)
        INTEGER           A(4)
        NAME       = FILE
        IBLKC( 1 ) = NAME
        IBLKC( 2 ) = ITYPOT
        IBLKC( 3 ) = 0
        IBLKC( 4 ) = 0
        IBLKC( 7 ) = 0
        IBLKC( 8 ) = -1
        IBLKC( 9 ) = ITYPIN
        IBLKC(10 ) = 0
        IF ( ITYPIN .LE. 0 .OR. ITYPIN .GT. 4 ) GO TO 10
        IF ( ITYPOT .LE. 0 .OR. ITYPOT .GT. 4 ) GO TO 10
        GO TO 20
10      CALL DSMSG1( IBLKC )
        CALL DSMSG( 118 )
20      NWDIN      = NWRDEL( ITYPIN )
        IBLKC( 12) = MCB( 2 ) + 1
        CALL DSGEFL
        IFLPOS( 1,IFILEX ) = FCB( 3, IFILEX )
        IFLPOS( 2,IFILEX ) = FCB( 4, IFILEX )
        CALL PUTSTR( IBLKC )
        IEOR       = 0
        INDEXA     = 0
        IROW       = IROBGN
        INDEXB     = ( IBLKC( 5 ) - 1 ) * IBLKC( 14 ) + 1
CDIR$ NOVECTOR
100     DO 110 K = 1, NWDIN
        IF ( A( INDEXA+K ) .NE. 0 ) GO TO 120
110     CONTINUE
CDIR$ VECTOR
        LASIND = (LASROW-IROW+1)*INCR*NWDIN
        KLIM   = LASIND + INCR
        KLAST  = KLIM
        INCRR = INCR*NWDIN
        DO 116 KK = 1, NWDIN
        INDEA1 = INDEXA - 1 + KK
        DO 115 K  = 1, LASIND, INCRR
        IF ( A(INDEA1 + K) .EQ. 0 ) GO TO 115
        IF ( K .LT. KLAST ) KLAST = K
        GO TO 116
115     CONTINUE
116     CONTINUE
        NCNT = (( KLAST-1 ) / INCRR) - 1
        IF ( KLAST .EQ. KLIM ) NCNT = LASROW - IROW
        IROW = IROW + NCNT
        INDEXA= INDEXA + NCNT*(NWDIN*INCR)
        IEOR       = 1
        GO TO 150
120     IF ( IBLKC( 7 ) .EQ. 0 ) GO TO 130
        IF ( IEOR .EQ. 0 ) GO TO 140
        CALL ENDPUT( IBLKC )
        CALL PUTSTR( IBLKC )
        IBLKC( 7 ) = 0
        INDEXB     = ( IBLKC( 5 ) - 1 ) * IBLKC( 14 ) + 1
130     IBLKC( 4 ) = IROW
140     IF ( ITYPIN .NE. ITYPOT ) GO TO 1400
CDIR$ NOVECTOR
        DO 141 K = 1, NWDIN
        IBASE( INDEXB + K - 1 ) = A( INDEXA + K )
141     CONTINUE
CDIR$ VECTOR
        GO TO 1401
1400    CALL DSUPKC( ITYPIN, ITYPOT, A( INDEXA+1 ), IBASE( INDEXB ))
1401    CONTINUE
        IEOR       = 0
        INDEXB     = INDEXB + IBLKC( 11 )
        IBLKC( 7 ) = IBLKC( 7 ) + 1
        IBLKC(10 ) = IBLKC( 10 ) + IBLKC( 11 )
        IF ( IBLKC( 7 ) .LT. IBLKC( 6 ) ) GO TO 150
        CALL ENDPUT( IBLKC )
        CALL PUTSTR( IBLKC )
        IBLKC( 7 ) = 0
        INDEXB = ( IBLKC( 5 ) - 1 ) * IBLKC( 14 ) + 1
150     INDEXA = INDEXA + ( INCR*NWDIN )
        IROW   = IROW + 1
        IF ( IROW .LE. LASROW ) GO TO 100
        CALL DSBPNK( IBLKC, MCB )
        RETURN
        END

      SUBROUTINE INPTT2
C
C     READ DATA BLOCK(S) FROM A FORTRAN UNIT.
C
C     CALL TO THIS MODULE IS
C
C     INPUTT2   /O1,O2,O3,O4,O5/V,N,P1/V,N,P2/V,N,P3/V,N,P4/V,N,P5/
C                               V,N,P6 $
C
C     PARAMETERS P1, P2, P4, AND P5 ARE INTEGER INPUT. P3 AND P6 ARE BCD
C
C            P1 =+N, SKIP FORWARD N DATA BLOCKS BEFORE READ
C               = 0, NO ACTION TAKEN BEFORE READ (DEFAULT)
C               =-1, BEFORE READ, FORTRAN TAPE IS REWOUND AND TAPE
C                    HEADER RECORD (RECORD NUMBER ZERO) IS CHECKED
C               =-3, THE NAMES OF ALL DATA BLOCKS ON FORTRAN TAPE
C                    ARE PRINTED AND READ OCCURS AT BEGINNING OF TAPE
C               =-5, SEARCH FORTRAN TAPE FOR FIRST VERSION OF DATA
C                    BLOCKS REQUESTED.
C                    IF ANY ARE NOT FOUND, A FATAL TERMINATION OCCURS.
C               =-6, SEARCH FORTRAN TAPE FOR FINAL VERSION OF DATA
C                    BLOCKS REQUESTED.
C                    IF ANY ARE NOT FOUND, A FATAL TERMINATION OCCURS.
C               =-7, SEARCH FORTRAN TAPE FOR FIRST VERSION OF DATA
C                    BLOCKS REQUESTED.
C                    IF ANY ARE NOT FOUND, A WARNING OCCURS.
C               =-8, SEARCH FORTRAN TAPE FOR FINAL VERSION OF DATA
C                    BLOCKS REQUESTED.
C                    IF ANY ARE NOT FOUND, A WARNING OCCURS.
C
C            P2 =    THE FORTRAN UNIT FROM WHICH THE DATA BLOCK(S)
C                    WILL BE READ. (DEFAULT P2 = 11, OR 14)
C
C            P3 =    TAPE ID CODE FOR FORTRAN TAPE, AN ALPHANUMERIC
C                    VARIABLE WHOSE VALUE MUST MATCH A CORRESPONDING
C                    VALUE ON THE FORTRAN TAPE.
C                    THIS CHECK IS DEPENDENT ON THE VALUE OF P1 AS
C                    FOLLOWS..
C
C                    *P1*             *TAPE ID CHECKED*
C                     +N                     NO
C                      0                     NO
C                     -1                    YES
C                     -3                    YES (WARNING CHECK)
C                     -5                    YES
C                     -6                    YES
C                     -7                    YES
C                     -8                    YES
C                    THE MPL DEFAULT VALUE FOR P3 IS XXXXXXXX .
C
C            P4 =    NOT USED IN INPUTT2.
C                    (USED ONLY IN OUTPUT2 FOR MAXIMUM RECORD SIZE)
C
C            P5 = 0, NON-SPARSE MATRIX IF INPUT IS A MATRIX DATA BLOCK
C               = NON-0, SPARSE MATRIX IF INPUT IS A MATRIX DATA BLOCK
C                    (P4 IS IGNORED IF INPUT IS A TALBE DATA BLOCK.
C                     P4 IS EQUIVALENT TO P5 IN OUTPUT2 MODULE)
C
C            P6 = BLANK, (DEFAULT)
C               = 'MSC', THE INPUT TAPE WAS WRITTEN IN MSC/OUTPUT2
C                     COMPATIBEL RECORD FORMAT.
C
C     OUTPT2 DOES NOT AUTOMATICALLY OUTPUT THE MATRIX IN STRING OR
C     SPARSE FORM. UNLESS P5 IS REQUESTED.
C     SIMILARILY, INPUT2 DOES NOT AUTOMATICALLY PROCESS MATRIX IN SPARSE
C     MATRIX FORM, UNLESS P5 IS REQUESTED).
C
C     REVISED  11/90 BY G.CHAN/UNISYS
C              (1) TO ACCEPT MSC/OUTPUT2 DATA (CALLED FROM INPTT4, 11/90
C                  OR INPTT2, 2/93)
C              (2) TO ACCEPT SPARSE MATRIX COMING FORM COSMIC/OUTPT2
C                  (SEE P5 PARAMETER IN INPTT2 AND P5 IN OUTPT2)
C
      IMPLICIT INTEGER (A-Z)
      LOGICAL          SPARSE,DP
      INTEGER          TRL(8),NAME(2),SUBNAM(2),TYPIN,MCB(7),DX(3),
     1                 NAMEX(2),IDHDR(7),IDHDRX(7),P3X(2),NT(5,3),
     2                 TAPCOD(2),NONE(2),BCDBIN(4),BLK(20)
      REAL             CORE(1)
      DOUBLE PRECISION DCORE(1)
      CHARACTER        UFM*23,UWM*25,UIM*29,SFM*25
CWKBNB
      CHARACTER*80     DSNAMES
      COMMON /DSNAME/ DSNAMES(80)
CWKBNE
      COMMON /XMSSG /  UFM,UWM,UIM,SFM
      COMMON /BLANK /  P1,P2,P3(2),P4,P5,P6(2)
     1       /SYSTEM/  KSYSTM(65)
     2       /PACKX /  TYPIN,TYPOUT,IROW,NROW,INCR
     3       /TYPE  /  PREC(2),NWDS(4)
     4       /ZZZZZZ/  X(1)
      EQUIVALENCE      (CORE(1),X(1))
      EQUIVALENCE      (KSYSTM(1),NB    ), (KSYSTM( 2),NOUT ),
     1                 (KSYSTM(9),NLPP  ), (KSYSTM(12),LINE ),
     2                 (BLK( 1)  ,BNAME ), (BLK( 2)   ,BTYP ),
     3                 (BLK( 3)  ,BFORM ), (BLK( 4)   ,BROW ),
     4                 (BLK( 5)  ,BPOINT), (BLK( 6)   ,BRAV ),
     5                 (BLK( 7)  ,BWRT  ), (BLK( 8)   ,BFLAG),
     6                 (BLK(12)  ,BCOL  ), (DCORE(1),CORE(1))
CWKBI
      DATA    IFIRST / 0 /
      DATA    SUBNAM/  4HINPT, 4HT2  /  ,   NONE / 4H (NO,4HNE)       /
      DATA    ZERO  ,  MONE,MTWO,MTRE,MFOR /0,-1,-2,-3,-4  /, I3 / 3  /
     1        MFIV  ,  MSIX,METE /-5,-6,-8 /,    IPT2,IPT4 / 1H2, 1H4 /
      DATA    IDHDR /  4HNAST,4HRAN ,4HFORT,4H TAP,4HE ID,4H COD,3HE -/
      DATA    BCDBIN/  4HBCD ,4H    ,4HBINA,4HRY    /, MSC / 4HMSC    /
C
C
      IPTX  = IPT2
      NTRL  = 8
      IF (P4 .EQ. 0) GO TO 20
      IF (P5 .NE. 0) GO TO 20
      WRITE  (NOUT,10) UWM
   10 FORMAT (A25,'. THE 4TH PARAMETER IN INPUTT2 MODULE IS NO LONGER ',
     1       'USED.', /5X,'SPARSE MATRIX FLAG IS NOW THE 5TH PARAMETER',
     2       ', A MOVE TO SYNCHRONIZE THE PARAMETERS USED IN OUTPUT2')
      P5 = P4
   20 SPARSE = .FALSE.
      IF (P5 .NE. 0) SPARSE = .TRUE.
      IF (P6(1) .NE. MSC) GO TO 100
      GO TO 50
C
C
      ENTRY INPUT2
C     ============
C
C     INPUT2 IS CALLED TO HANDLE MSC/OUTPUT2 DATA.
C     IT IS CALLED FROM INPTT2 WITH P6 PARAMETER = 'MSC', OR
C     FROM INPTT4
C
      IPTX  = IPT4
   50 WRITE  (NOUT,60) UIM,IPTX
   60 FORMAT (A29,' FROM INPUTT',A1,'. USER INPUT TAPE IN MSC/OUTPUT2',
     1       ' COMPATIBLE RECORDS')
      IPTX  = IPT4
      NTRL  = 7
      IRECF = 0
      SPARSE= .FALSE.
      IF (P3(1).EQ.BCDBIN(1) .AND. P3(2).EQ.BCDBIN(2)) GO TO 1580
      IF (P3(1).EQ.BCDBIN(3) .AND. P3(2).EQ.BCDBIN(4)) GO TO 1580
C
  100 LCOR = KORSZ(X) - NB
      IF (LCOR .LE. 0) CALL MESAGE (-8,LCOR,SUBNAM)
CWKBNB
      IF ( IFIRST .NE. 0) GO TO 61
      CLOSE ( UNIT=P2 )
      OPEN ( UNIT=P2, FILE=DSNAMES(P2), FORM='UNFORMATTED',
     1       STATUS='UNKNOWN' )
      IFIRST = 1
61    CONTINUE
CWKBNE
      OUBUF = LCOR + 1
      TAPCOD(1) = P3(1)
      TAPCOD(2) = P3(2)
      IN = P2
      IF (P1.LT.METE .OR. P1.EQ.MTWO .OR. P1.EQ.MFOR) GO TO 1420
C
      IF (P1 .LT. MFOR) GO TO 700
      IF (P1 .EQ. MTRE) GO TO 500
      IF (P1 .LE. ZERO) GO TO 130
C
      I = 1
  110 READ (IN) KEY
      KEYX = 2
      IF (KEY .NE. KEYX) GO TO 1530
      READ (IN) NAMEX
      READ (IN) KEY
      IMHERE = 115
      IF (KEY .GE. 0) GO TO 1560
      ASSIGN 120 TO RET
      NSKIP = 1
      GO TO 1300
C
  120 I = I + 1
      IF (I .LE. P1) GO TO 110
      GO TO 160
C
C     OPEN FORTRAN TAPE TO READ TAPE-LABEL WITHOUT REWIND.
C
  130 IF (P1 .NE. MONE) GO TO 160
      REWIND IN
      READ (IN) KEY
      KEYX = 3
      IF (KEY .NE. KEYX) GO TO 1530
      READ (IN) DX
      READ (IN) KEY
      KEYX = 7
      IF (KEY .NE. KEYX) GO TO 1530
      READ (IN) IDHDRX
      DO 140 KF = 1,7
      IF (IDHDRX(KF) .NE. IDHDR(KF)) GO TO 1460
  140 CONTINUE
      READ (IN) KEY
      KEYX = 2
      IF (KEY .NE. KEYX) GO TO 1530
      READ (IN) P3X
      READ (IN) KEY
      IMHERE = 145
      IF (KEY .GE. 0) GO TO 1560
      IF (P3X(1).NE.P3(1) .OR. P3X(2).NE.P3(2)) GO TO 1440
      ASSIGN 150 TO RET
      NSKIP = 1
      GO TO 1300
  150 CONTINUE
C
  160 DO 430 I = 1,5
C
      OUTPUT = 200 + I
      TRL(1) = OUTPUT
      CALL RDTRL (TRL)
      IF (TRL(1) .LE. 0) GO TO 430
      CALL FNAME (OUTPUT,NAME)
      IF (NAME(1).EQ.NONE(1) .AND. NAME(2).EQ.NONE(2)) GO TO 430
C
C     READ FILE NAME HEADER RECORD.
C
      READ (IN) KEY
      IF (KEY .EQ. 0) GO TO 440
      KEYX = 2
      IF (KEY .NE. KEYX) GO TO 1530
      READ (IN) NAMEX
      READ (IN) KEY
      IMHERE = 163
      IF (KEY .GE. 0) GO TO 1560
C
C     READ TRAILER RECORD.
C
      READ (IN) KEY
      KEYX = NTRL
      IF (KEY .NE. KEYX) GO TO 1530
      READ (IN) (TRL(L),L=1,NTRL)
      IF (IPTX .EQ. IPT2) IRECF = TRL(8)
      READ (IN) KEY
      IMHERE = 165
      IF (KEY .GE. 0) GO TO 1560
C
C     OPEN OUTPUT DATA BLOCK TO WRITE WITH REWIND.
C
      CALL OPEN (*1400,OUTPUT,X(OUBUF),1)
C
C     COPY CONTENTS OF FORTRAN TAPE ONTO OUTPUT DATA BLOCK.
C
C     TRL(8) = 0, DATA BLOCK IS A TALBE
C            = 1, DATA BLOCK IS A MATRIX, WRITTEN IN STRING FORMAT
C            = 2, DATA BLOCK IS A VECTOR (1ST RECORD IS REGULAR, 2ND
C                 RECORD IS A STRING)
C
      INDEX = 0
      READ (IN) KEY
      IF (IPTX .EQ. IPT2) GO TO 180
      BNAME = OUTPUT
      KEYX  = 1
      IF (KEY .NE. KEYX) GO TO 1530
      READ (IN) KREC
      IMHERE = 170
      IF (KREC .NE. 0) GO TO 1560
C
      READ (IN) KEY
  180 KEYX  = 2
      IF (KEY .LT. KEYX) GO TO 1530
      IF (KEY .GT. LCOR) GO TO 1510
      READ (IN) (X(L),L=1,KEY)
      CALL WRITE (OUTPUT,NAME,2,0)
      IF (KEY .EQ. KEYX) GO TO 200
      CALL WRITE (OUTPUT,X(I3),KEY-2,0)
C
  200 IF (IPTX .EQ. IPT2) GO TO 220
      READ (IN) KEY
      IMHERE = 205
      IF (KEY .GE. 0) GO TO 1560
      BTYP  = TRL(5)
      BFORM = 0
      BCOL  = 0
      NWD   = NWDS(BTYP)
      DP    = BTYP.EQ.2 .OR. BTYP.EQ.4
      CALL WRITE (OUTPUT,X,0,1)
  210 READ (IN) KEY
      KEYX = 1
      IF (KEY .NE. KEYX) GO TO 1530
      READ (IN) KREC
      IF (KREC .NE. 0) GO TO 350
C
C     TABLE DATA BLOCK(S)
C
  220 READ (IN) KEY
      IF (KEY) 240, 400, 230
C              EOR, EOF, KEY
C
  230 IF (KEY .GT. LCOR) GO TO 1510
      READ (IN) (X(L),L=1,KEY)
      CALL WRITE (OUTPUT,X,KEY,0)
      GO TO 220
  240 CALL WRITE (OUTPUT,X,0,1)
      IF (IPTX  .EQ. IPT4) GO TO 210
      IF (IRECF .EQ.    0) GO TO 200
      IF (IRECF.EQ.1 .OR. INDEX.GT.0) GO TO 250
      INDEX = 1
      GO TO 220
C
C     READ STRING FORMATTED MATRIX
C
  250 IF (IRECF.EQ.2 .AND. INDEX.EQ.2) GO TO 260
      INDEX = 2
      CALL MAKMCB (MCB(1),OUTPUT,TRL(3),TRL(4),TRL(5))
      IROW  = 1
      NROW  = TRL(3)
      TYPIN = TRL(5)
      TYPOUT= TRL(5)
      NWDSX = NWDS(TYPOUT)
      NCOL  = TRL(2)
C
C     CHECK FOR NULL MATRIX
C
      IF (NROW.EQ.0 .OR. NCOL.EQ.0) GO TO 400
      IF (IRECF .EQ. 2) NCOL = 1
      INCR  = 1
      NWDSX = NROW*NWDSX
  260 KEYX  = NWDSX
C
C     NWDSX IS NUMBER OF WORDS NEEDED PER COLUMN
C
      IF (SPARSE) GO TO 300
      DO 270 L = 1,NCOL
      READ (IN) KEY
      IF (KEY .NE. KEYX) GO TO 1530
      IF (KEY .GT. LCOR) GO TO 1510
      READ (IN) (X(K),K=1,NWDSX)
      CALL PACK (X,OUTPUT,MCB)
      READ (IN) KEY
      IMHERE = 265
      IF (KEY .GT. 0) GO TO 1560
  270 CONTINUE
  280 IF (IRECF .EQ. 2) GO TO 200
      KEYX = 0
      READ (IN) KEY
      IMHERE = 285
      IF (KEY .NE. KEYX) GO TO 1530
      GO TO 400
C
C     SPARSE MATRIX INPUT (P5 = NON-ZERO)
C     (NOT CALLING FROM INPTT4 (IPTX=IPT2)
C
  300 DO 340 L = 1,NCOL
      DO 310 K = 1,NWDSX
  310 X(K) = 0.0
  320 READ (IN) KEY,BASE
      IF (KEY .LT. 0) GO TO 330
      READ (IN) (X(K+BASE),K=1,KEY)
      GO TO 320
  330 CALL PACK (X,OUTPUT,MCB)
  340 CONTINUE
      GO TO 280
C
C     MATRIX DATA BLOCK - MSC/STRING RECORD. (IPTX=IPT4)
C
C
  350 BFLAG = -1
      BCOL  = BCOL + 1
  360 READ (IN) KEY
      CALL PUTSTR (BLK)
      IMHERE = 360
      IF (KEY)  390,1560, 370
C       NULL or EOR, ERR, KEY
C
  370 BWRT = KEY/NWD
      IMHERE = 370
      IF (BWRT .GT. BRAV) GO TO 1560
C
C     COMMENTS FROM G.C./UNISYS   3/93
C     UNLESS MSC/PUTSTR IS DIFFERENT FROM COSMIC/PUTSTR, THE FOLLOWING
C     3 LINES, ORIGINATED FROM MSC SOURCE CODE, DO NOT WORK FOR D.P.
C     DATA ON VAX, AND POSSIBLY SILICON-GRAHPICS. THEY ARE REPLACED BY
C     NEXT 17 LINES BELOW.
C     (I TRIED  SETTING L1=(BPOINT-1)*NWD+1, AND STILL DID NOT WORK.)
C     THE PROBLEM HERE IS D.P. DATA MAY FALL SHORT ON DOUBLE WORD
C     BOUNADRY, AND THEREFORE BECOME GARBAGE, WHICH MAY CAUSE FATAL
C     ERROR IN PRINTING.
C
C     L1 = BPOINT
C     L2 = L1 - 1 + KEY
C     READ (IN) BROW,(CORE(L),L=L1,L2)
C
      L1 = BPOINT*NWD
      L2 = L1 - 1 + KEY
      IF (DP) GO TO 380
C     L  = 375
C     WRITE  (NOUT,375) L,L1,L2,KEY,BROW,BTYP,BPOINT
C 375 FORMAT (' /@',I3,'  L1,L2,KEY,BROW,BTYP,BPOINT =',4I7,4I4)
      READ   (IN) BROW,(CORE(L),L=L1,L2)
C     WRITE  (NOUT,376,ERR=388) (CORE(L),L=L1,L2)
C 376 FORMAT (10X,' CORE =',/,(1X,11E11.3))
      GO TO 385
  380 L1 = L1/2
      L2 = L2/2
C     L  = 382
C     WRITE  (NOUT,375) L,L1,L2,KEY,BROW,BTYP,BPOINT
      READ   (IN) BROW,(DCORE(L),L=L1,L2)
C     WRITE  (NOUT,382,ERR=388) (DCORE(L),L=L1,L2)
C 382 FORMAT (10X,'DCORE =',/,(1X,11D11.3))
  385 CALL ENDPUT (BLK)
      GO TO 360
  390 BFLAG = +1
      BWRT  =  0
      CALL ENDPUT (BLK)
      GO TO 210
C
C     CLOSE OUTPUT DATA BLOCK WITH REWIND AND EOF.
C
  400 CALL CLOSE (OUTPUT,1)
C
C     WRITE TRAILER.
C
      TRL(1) = OUTPUT
      CALL WRTTRL (TRL)
      CALL PAGE2 (-3)
      WRITE  (NOUT,410) UIM,NAME,IN,NAMEX
  410 FORMAT (A29,' 4105, DATA BLOCK ',2A4,' RETRIEVED FROM FORTRAN ',
     1        'TAPE ',I2, /5X,'ORIGINAL NAME OF DATA BLOCK WAS ',2A4)
      IF (SPARSE .AND. NTRL.EQ.8 .AND. TRL(8).NE.0)
     1    WRITE (NOUT,420) TRL(2),TRL(3)
  420 FORMAT (1H+,55X,'(A SPARSE MATRIX',I6,2H X,I6,')')
C
  430 CONTINUE
C
C     CLOSE FORTRAN TAPE WITHOUT REWIND.
C
  440 CONTINUE
      RETURN
C
C     OBTAIN LIST OF DATA BLOCKS ON FORTRAN TAPE.
C
  500 REWIND IN
      READ (IN) KEY
      KEYX = 3
      IF (KEY .NE. KEYX) GO TO 1530
      READ (IN) DX
      READ (IN) KEY
      KEYX = 7
      IF (KEY .NE. KEYX) GO TO 1530
      READ (IN) IDHDRX
      DO 510 KF = 1,7
      IF (IDHDRX(KF) .NE. IDHDR(KF)) GO TO 1460
  510 CONTINUE
      READ (IN) KEY
      KEYX = 2
      IF (KEY .NE. KEYX) GO TO 1530
      READ (IN) P3X
      READ (IN) KEY
      IMHERE = 515
      IF (KEY .GE. 0) GO TO 1560
      IF (P3X(1).NE.P3(1) .OR. P3X(2).NE.P3(2)) GO TO 1480
  520 ASSIGN 530 TO RET
      NSKIP = 1
      GO TO 1300
  530 KF   = 0
  540 CALL PAGE1
      LINE = LINE + 8
      WRITE  (NOUT,550) IN
  550 FORMAT (//50X,'FILE CONTENTS ON FORTRAN UNIT ',I2, /51X,32(1H-),
     1        //54X,4HFILE,18X,4HNAME,//)
  560 READ (IN) KEY
      IF (KEY .EQ. 0) GO TO 590
C     KEYX = 2
C     IF (KEY .NE. KEYX) GO TO 9918
      READ (IN) NAMEX
C     READ (IN) KEY
C     IF (KEY .GE. 0) GO TO 9919
      ASSIGN 570 TO RET
      NSKIP = 1
      GO TO 1300
  570 KF   = KF + 1
      LINE = LINE + 1
      WRITE  (NOUT,580) KF,NAMEX
  580 FORMAT (53X,I5,18X,2A4)
      IF (LINE - NLPP) 560,540,540
  590 REWIND IN
      ASSIGN 600 TO RET
      NSKIP = 1
      GO TO 1300
  600 CONTINUE
      GO TO 160
C
C     SEARCH MODE
C
C     EXAMINE OUTPUT REQUESTS AND FILL NAME TABLE.
C
  700 NNT = 0
      DO 720 I = 1,5
      OUTPUT = 200 + I
      TRL(1) = OUTPUT
      CALL RDTRL (TRL)
      IF (TRL(1) .LE. 0) GO TO 710
      CALL FNAME (OUTPUT,NAME)
      IF (NAME(1).EQ.NONE(1) .AND. NAME(2).EQ.NONE(2)) GO TO 710
      NT(I,1) = 0
      NT(I,2) = NAME(1)
      NT(I,3) = NAME(2)
      NNT = NNT + 1
      GO TO 720
  710 NT(I,1) = -1
C     IF (IPTX .NE. IPT2) GO TO 3050
      NT(I,2) = NONE(1)
      NT(I,3) = NONE(2)
  720 CONTINUE
C
      IF (NNT .GT. 0) GO TO 800
      CALL PAGE2 (-2)
      WRITE  (NOUT,730) UWM,IPTX
  730 FORMAT (A25,' 4137, ALL OUTPUT DATA BLOCKS FOR INPUTT',A1,
     1        ' ARE PURGED.')
C     CLOSE (UNIT=IN)
      RETURN
C
C     CHECK TAPE ID LABEL.
C
  800 REWIND IN
      READ (IN) KEY
      KEYX = 3
      IF (KEY .NE. KEYX) GO TO 1530
      READ (IN) DX
      READ (IN) KEY
      KEYX = 7
      IF (KEY .NE. KEYX) GO TO 1530
      READ (IN) IDHDRX
      DO 810 KF = 1,7
      IF (IDHDRX(KF) .NE. IDHDR(KF)) GO TO 1460
  810 CONTINUE
      READ (IN) KEY
      KEYX = 2
      IF (KEY .NE. KEYX) GO TO 1530
      READ (IN) P3X
      READ (IN) KEY
      IMHERE = 815
      IF (KEY .GE. 0) GO TO 1560
      IF (P3X(1).NE.P3(1) .OR. P3X(2).NE.P3(2)) GO TO 1440
      ASSIGN 820 TO RET
      NSKIP = 1
      GO TO 1300
  820 CONTINUE
C
C     BEGIN SEARCH OF TAPE.
C
      KF = 0
  830 READ (IN) KEY
      IF (KEY .EQ. 0) GO TO 1140
C     KEYX = 2
C     IF (KEY .NE. KEYX) GO TO 9918
      READ (IN) NAMEX
      READ (IN) KEY
      IMHERE = 835
      IF (KEY .GE. 0) GO TO 1560
      KF = KF + 1
C
      DO 1100 I = 1,5
      NAME(1) = NT(I,2)
      NAME(2) = NT(I,3)
      IF (NT(I,1) .LT. 0) GO TO 1100
      IF (NAME(1).NE.NAMEX(1) .OR. NAME(2).NE.NAMEX(2)) GO TO 1100
      NT(I,1) = NT(I,1) + 1
      IF (NT(I,1).EQ.1 .OR. P1.EQ.MSIX .OR. P1.EQ.METE) GO TO 850
      CALL PAGE2 (-3)
      WRITE  (NOUT,840) UWM,NAME,KF,IN
  840 FORMAT (A25,' 4138, DATA BLOCK ,',2A4,' (DATA BLOCK COUNT =',I6,
     1       ')  HAS PREVIOUSLY BEEN RETRIEVED FROM ', /36X,
     2       'FORTRAN TAPE ',I2,' AND WILL BE IGNORED.')
      GO TO 1110
  850 READ (IN) KEY
      KEYX = NTRL
      IF (KEY .NE. KEYX) GO TO 1530
      READ (IN) (TRL(L),L=1,NTRL)
      IF (IPTX .EQ. IPT2) IRECF = TRL(8)
      READ (IN) KEY
      IMHERE = 855
      IF (KEY .GE. 0) GO TO 1560
C
      OUTPUT = 200 + I
      CALL OPEN (*1400,OUTPUT,X(OUBUF),1)
C
      INDEX = 0
C     IF (IPTX .EQ. IPT4) GO TO 890        ! FROM MSC/INPTT4
      READ (IN) KEY
      IF (IPTX .EQ. IPT2) GO TO 860
      KEYX = 1
      IF (KEY .EQ. KEYX) GO TO 1530
      READ (IN) KREC
      IMHERE = 857
      IF (KREC .LT. 0) GO TO 1560
      READ (IN) KEY
  860 KEYX = 2
      IF (KEY .LT. KEYX) GO TO 1530
      IF (KEY .GT. LCOR) GO TO 1510
      READ (IN) (X(L),L=1,KEY)
      CALL WRITE (OUTPUT,NAME,2,0)
      IF (KEY .EQ. KEYX) GO TO 870
      CALL WRITE (OUTPUT,X(I3),KEY-2,0)
C
  870 IF (IPTX .EQ. IPT2) GO TO 890
      READ (IN) KEY
      IMHERE = 875
      IF (KEY .GT. 0) GO TO 1560
      BTYP  = TRL(5)
      BFORM = 0
      BCOL  = 0
      NWD   = NWDS(BTYP)
      DP    = BTYP.EQ.2 .OR. BTYP.EQ.4
      CALL WRITE (OUTPUT,0,0,1)
  880 READ (IN) KEY
      KEYX = 1
      IF (KEY .NE. KEYX) GO TO 1530
      READ (IN) KREC
      IF (KREC .NE. 0) GO TO 1010
C
C     TABLE DATA BLOCK(S)
C
  890 READ (IN) KEY
      IF (KEY) 910,1060,900
C              EOR, EOF, KEY
C
  900 IF (KEY .GT. LCOR) GO TO 1510
      READ (IN) (X(L),L=1,KEY)
      CALL WRITE (OUTPUT,X,KEY,0)
      GO TO 890
  910 CALL WRITE (OUTPUT,X,0,1)
C     IF (IPTX .EQ. IPT4) GO TO 890
      IF (IPTX .EQ. IPT4) GO TO 880
      IF (IRECF .EQ. 0) GO TO 870
      IF (IRECF .EQ. 1) GO TO 920
      IF (INDEX .GT. 0) GO TO 920
      INDEX = 1
      GO TO 870
C
C     READ STRING FORMATTED MATRIX
C
  920 IF (IRECF.EQ.2 .AND. INDEX.EQ.2) GO TO 930
      INDEX = 2
      CALL MAKMCB (MCB(1),OUTPUT,TRL(3),TRL(4),TRL(5))
      IROW  = 1
      NROW  = TRL(3)
      TYPIN = TRL(5)
      TYPOUT= TRL(5)
      NWDSX = NWDS(TYPOUT)
      NCOL  = TRL(2)
C
C     CHECK FOR NULL MATRIX
C
      IF (NROW.EQ.0 .OR. NCOL.EQ.0) GO TO 1060
      IF (IRECF .EQ. 2) NCOL = 1
      INCR  = 1
      NWDSX = NROW*NWDSX
  930 KEYX  = NWDSX
C
C     NWDSX IS NUMBER OF WORDS NEEDED PER COLUMN
C
      IF (SPARSE) GO TO 960
      DO 940 L = 1,NCOL
      READ (IN) KEY
      IF (KEY .NE. KEYX) GO TO 1530
      IF (KEY .GT. LCOR) GO TO 1510
      READ (IN) (X(K),K=1,NWDSX)
      CALL PACK (X,OUTPUT,MCB)
      READ (IN) KEY
      IMHERE = 935
      IF (KEY .GT. 0) GO TO 1560
  940 CONTINUE
  950 IF (IRECF .EQ. 2) GO TO 870
      KEYX = 0
      READ (IN) KEY
      IF (KEY .NE. KEYX) GO TO 1530
      GO TO 1060
C
C     SPARSE MATRIX INPUT (P4 = NON-ZERO)
C     (NOT CALLING FROM INPTT4 (IPTX=IPT2)
C
  960 DO 1000 L = 1,NCOL
      DO 970 K  = 1,NWDSX
  970 X(K) = 0.0
  980 READ (IN) KEY,BASE
      IF (KEY .LT. 0) GO TO 990
      READ (IN) (X(K+BASE),K=1,KEY)
      GO TO 980
  990 CALL PACK (X,OUTPUT,MCB)
 1000 CONTINUE
      GO TO 950
C
C     MATRIX DATA BLOCK, IPTX = IPT4.  MSC/STRING RECORD
C
C
 1010 BFLAG = -1
      BCOL  = BCOL + 1
 1020 READ (IN) KEY
      CALL PUTSTR (BLK)
      IMHERE = 1025
      IF (KEY)  1050,1560,1030
C       NULL or EOR,  ERR, KEY
C
 1030 BWRT = KEY/NWD
      IMHERE = 1030
      IF (BWRT .GT. BRAV) GO TO 1560
C
C     L1 = BPOINT
C     L2 = L1 - 1 + KEY
C     READ (IN) BROW,(CORE(L),L=L1,L2)
C
      L1 = BPOINT*NWD
      L2 = L1 - 1 + KEY
      IF (DP) GO TO 1035
      READ (IN) BROW,(CORE(L),L=L1,L2)
      GO TO 1040
 1035 L1 = L1/2
      L2 = L2/2
      READ (IN) BROW,(DCORE(L),L=L1,L2)
 1040 CALL ENDPUT (BLK)
      GO TO 1020
 1050 BFLAG = +1
      BWRT  =  0
      CALL ENDPUT (BLK)
      GO TO 880
C
C     CLOSE OUTPUT DATA BLOCK WITH REWIND AND EOF
C
 1060 CALL CLOSE (OUTPUT,1)
C
C     WRITE TRAILER
C
      TRL(1) = OUTPUT
      CALL WRTTRL (TRL)
      CALL PAGE2 (-2)
      WRITE  (NOUT,1070) UIM,NAME,IN,KF
 1070 FORMAT (A29,' 4139, DATA BLOCK ',2A4,' RETRIEVED FROM FORTRAN ',
     1       'TAPE ',I2,' (DATA BLOCK COUNT =',I6,1H))
      IF (NT(I,1) .GT. 1) GO TO 1080
      NNT = NNT - 1
      GO TO 1130
 1080 WRITE  (NOUT,1090) UWM
 1090 FORMAT (A25,' 4140, SECONDARY VERSION OF DATA BLOCK HAS REPLACED',
     1       ' EARLIER ONE.')
      CALL PAGE2 (-2)
      GO TO 1130
 1100 CONTINUE
C
 1110 ASSIGN 1120 TO RET
      NSKIP = 1
      GO TO 1300
 1120 CONTINUE
 1130 IF (NNT.GT.0 .OR. P1.EQ.MSIX .OR. P1.EQ.METE) GO TO 830
      GO TO 1200
C
 1140 IF (NNT .LE. 0) GO TO 1200
      CALL PAGE2 (-7)
      IF (P1.EQ.MFIV .OR. P1.EQ.MSIX) GO TO 1160
      WRITE  (NOUT,1150) UWM
 1150 FORMAT (A25,' 4141, ONE OR MORE DATA BLOCKS NOT FOUND ON FORTRAN',
     1       ' TAPE.')
      GO TO 1170
 1160 WRITE (NOUT,1500) UFM
 1170 DO 1190 I = 1,5
      IF (NT(I,1) .NE. 0) GO TO 1190
      WRITE  (NOUT,1180) NT(I,2),NT(I,3)
 1180 FORMAT (20X,21HNAME OF DATA BLOCK = ,2A4)
 1190 IF (IPTX .EQ. IPT4) GO TO 1200
      IF (P1.EQ.MFIV .OR. P1.EQ.MSIX) GO TO 1600
C
 1200 ASSIGN 1210 TO RET
      NSKIP = -1
      GO TO 1300
 1210 CONTINUE
      RETURN
C
C     SIMULATION OF SKPFIL (IN,NSKIP)
C
 1300 IF (NSKIP) 1320,1310,1330
 1310 GO TO RET, (120,150,530,570,600,820,1120,1210)
 1320 REWIND IN
C
C     NSKIP = COMPLEMENT OF NSKIP.
C
 1330 DO 1370 NS = 1,NSKIP
 1340 READ (IN) KEY
      IF (KEY) 1340,1360,1350
C               EOR, EOF, KEY
C
 1350 IF (KEY .GT. LCOR) GO TO 1510
      READ (IN) (X(L),L=1,KEY)
      GO TO 1340
 1360 CONTINUE
 1370 CONTINUE
      GO TO 1310
C
C     ERRORS
C
 1400 WRITE  (NOUT,1410) UFM,IPTX,OUTPUT
 1410 FORMAT (A23,' 4108, SUBROUTINE INPTT',A1,' UNABLE TO OPEN OUTPUT',
     1        ' DATA BLOCK',I6)
      GO TO  1600
 1420 WRITE  (NOUT,1430) UFM,IPTX,P1
 1430 FORMAT (A23,' 4113, MODULE INPUTT',A1,' - ILLEGAL VALUE FOR ',
     1       'FIRST PARAMETER =',I20)
      GO TO  1600
 1440 WRITE  (NOUT,1450) UFM,P3X,IPTX,P3
 1450 FORMAT (A23,' 4136, USER TAPE ID CODE -',2A4,'- DOES NOT MATCH ',
     1       'THIRD INPUTT',A1,' DMAP PARAMETER -',2A4,2H-.)
      LINE = LINE + 1
      GO TO  1600
 1460 WRITE  (NOUT,1470) UFM,IPTX,IDHDRX
 1470 FORMAT (A23,' 4134, MODULE INPUTT',A1,' - ILLEGAL TAPE CODE ',
     1        'HEADER = ',7A4)
      GO TO  1600
 1480 WRITE  (NOUT,1490) UWM,P3X,IPTX,P3
 1490 FORMAT (A25,' 4135, USER TAPE ID CODE -',2A4,'- DOES NOT MATCH ',
     1        'THIRD INPUTT',A1,' DMAP PARAMETER -',2A4,2H-.)
      GO TO  520
 1500 FORMAT (A23,' 4142, ONE OR MORE DATA BLOCKS NOT FOUND ON USER ',
     1       'TAPE')
 1510 WRITE  (NOUT,1520) UFM,LCOR,KEY
 1520 FORMAT (A23,' 2187, INSUFFICIENT WORKING CORE TO HOLD FORTRAN ',
     1       'LOGICAL RECORD.', /5X,'LENGTH OF WORKING CORE =',I11,
     2       ',  LENGTH OF FORTRAN LOGICAL RECORD =',I11,1H.)
      LINE = LINE + 1
      GO TO  1600
 1530 WRITE  (NOUT,1540) SFM,KEY,KEYX
 1540 FORMAT (A25,' 2190, ILLEGAL VALUE FOR KEY =',I10,
     1       ',   EXPECTED VALUE =',I11,1H.)
      IF (KEY.EQ.2 .AND. KEYX.EQ.3) WRITE (NOUT,1550)
 1550 FORMAT (5X,'POSSIBLY DUE TO IMPROPER TAPE GENERATION PROCEDURE')
      GO TO  1600
 1560 WRITE  (NOUT,1570) SFM,KEY,IMHERE
 1570 FORMAT (A25,' 2190, ILLEGAL VALUE FOR KEY =',I10,'.  IMHERE =',I4)
      GO TO  1600
 1580 WRITE  (NOUT,1590) UFM,P3
 1590 FORMAT (A23,', ILLEGAL TAPE LABEL NAME -',2A4,'-  POSSIBLY ',
     1       'THE 4TH PARAMETER OF INPTT4 IS IN ERROR')
      GO TO  1600
C
 1600 LINE = LINE + 2
      CALL MESAGE (-61,LCOR,SUBNAM)
      RETURN
C
      END

      SUBROUTINE FDIT (I,K)
C
C     FETCHES FROM THE RANDOM ACCESS STORAGE DEVICE THE BLOCK OF THE
C     DIT CONTAINING THE ITH SUBSTRUCTURE NAME, AND STORES IT IN THE
C     ARRAY BUF STARTING AT LOCATION (DIT+1) AND EXTENDING TO LOCATION
C     (DIT+BLKSIZ).  THE OUTPUT K INDICATES THAT THE SUBSTRUCTURE HAS
C     THE KTH ENTRY IN BUF.
C
      EXTERNAL        RSHIFT,ANDF
      LOGICAL         DITUP,NXTUP,NEWBLK
      INTEGER         BUF,DIT,DITPBN,DITLBN,DITSIZ,DITNSB,DITBL,
     1                BLKSIZ,DIRSIZ,ANDF,RSHIFT,NMSBR(2)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /ZZZZZZ/ BUF(1)
      COMMON /SOF   / DIT,DITPBN,DITLBN,DITSIZ,DITNSB,DITBL,
     1                IODUM(8),MDIDUM(4),
     2                NXT,NXTPBN,NXTLBN,NXTTSZ,NXTFSZ(10),NXTCUR,
     3                DITUP,MDIUP,NXTUP,NXTRST
      COMMON /SYS   / BLKSIZ,DIRSIZ
      COMMON /SYSTEM/ NBUFF,NOUT
      COMMON /MACHIN/ MACH,IHALF,JHALF
      DATA    IRD   , IWRT  / 1,2   /
      DATA    IEMPTY/ 4H    /
      DATA    INDSBR/ 5     /, NMSBR /4HFDIT,4H    /
C
      CALL CHKOPN (NMSBR(1))
C
C     NDIR IS THE NUMBER OF SUBSTRUCTURE NAMES IN ONE BLOCK OF THE DIT
C
      NDIR = BLKSIZ/2
C
C     COMPUTE THE LOGICAL BLOCK NUMBER, AND THE WORD NUMBER WITHIN
C     BUF IN WHICH THE ITH SUBSTRUCTURE NAME IS STORED.  STORE THE BLOCK
C     NUMBER IN IBLOCK, AND THE WORD NUMBER IN K.
C
      IBLOCK = I/NDIR
      IF (I .EQ. IBLOCK*NDIR) GO TO 10
      IBLOCK = IBLOCK + 1
   10 K = 2*(I-(IBLOCK-1)*NDIR) - 1 + DIT
      IF (DITLBN .EQ. IBLOCK) RETURN
C
C     THE DESIRED DIT BLOCK IS NOT PRESENTLY IN CORE, MUST THEREFORE
C     FETCH IT.
C
      NEWBLK = .FALSE.
C
C     FIND THE PHYSICAL BLOCK NUMBER OF THE BLOCK ON WHICH THE LOGICAL
C     BLOCK IBLOCK IS STORED.
C
      J = DITBL
      ICOUNT = 1
   30 IF (ICOUNT .EQ. IBLOCK) GO TO 40
      ICOUNT = ICOUNT + 1
      CALL FNXT (J,INXT)
      IF (MOD(J,2) .EQ. 1) GO TO 33
      IBL = RSHIFT(BUF(INXT),IHALF)
      GO TO 36
   33 IBL = ANDF(BUF(INXT),JHALF)
   36 IF (IBL .EQ. 0) GO TO 70
      J = IBL
      GO TO 30
   40 IF (DITPBN .EQ. 0) GO TO 43
C
C     THE IN CORE BLOCK SHARED BY THE DIT AND THE ARRAY NXT IS NOW
C     OCCUPIED BY THE DIT.  WRITE IT OUT IF IT HAS BEEN UPDATED.
C
      IF (.NOT.DITUP) GO TO 50
      CALL SOFIO (IWRT,DITPBN,BUF(DIT-2))
      GO TO 50
   43 IF (NXTPBN .EQ. 0) GO TO 50
C
C     THE IN CORE BLOCK SHARED BY THE DIT AND THE ARRAY NXT IS NOW
C     OCCUPIED BY NXT.  WRITE OUT NXT IF IT HAS BEEN UPDATED.
C
      IF (.NOT.NXTUP) GO TO 46
      CALL SOFIO (IWRT,NXTPBN,BUF(NXT-2))
      NXTUP  = .FALSE.
   46 NXTPBN = 0
      NXTLBN = 0
C
C     READ THE DESIRED DIT BLOCK INTO CORE.
C
   50 DITPBN = J
      DITLBN = IBLOCK
      IF (NEWBLK) GO TO 60
      CALL SOFIO (IRD,J,BUF(DIT-2))
      RETURN
C
   60 ISTART = DIT + 1
      IEND   = DIT + BLKSIZ
      DO 65 LL = ISTART,IEND
      BUF(LL) = IEMPTY
   65 CONTINUE
      RETURN
C
C     WE NEED A FREE BLOCK FOR THE DIT.
C
   70 CALL GETBLK (J,IBL)
      IF (IBL .EQ. -1) GO TO 80
      NEWBLK = .TRUE.
      J = IBL
      IF (ICOUNT .EQ. IBLOCK) GO TO 40
C
C     ERROR MESSAGES.
C
      CALL ERRMKN (INDSBR,7)
   80 WRITE  (NOUT,85) UFM
   85 FORMAT (A23,' 6223, SUBROUTINE FDIT - THERE ARE NO MORE FREE ',
     1       'BLOCKS AVAILABLE ON THE SOF')
      CALL SOFCLS
      CALL MESAGE (-61,0,0)
      RETURN
      END

      SUBROUTINE ASCM05 (NAME,IPHASE,ISOL,NOGO)
C
C     SOLVE COMMAND DMAP DATA
C
      INTEGER         COMND(6,1),SUBNAM(2),RDMAP(18,28),RDMAP1(18,9),
     1                RDMAP2(18,9),RDMAP3(18,9),RDMAP4(18,1),OCT(3,5),
     2                OCT1(3,5),PTBS(7,20),PTBS1(7,18),PTBS2(7,2)
      COMMON /PHAS25/ IPAS25(14)
      COMMON /ASDBD / IRDM,NRDM,IXTRA,NXTRA,IOCT,NOCT,IPTBS,NPTBS,
     1                IPH,NPH,IDAT(673)
      EQUIVALENCE     (RDMAP1(1,1),RDMAP(1, 1)),(OCT1(1,1),OCT(1,1)),
     1                (RDMAP2(1,1),RDMAP(1,10)),(PTBS1(1,1),PTBS(1,1)),
     2                (RDMAP3(1,1),RDMAP(1,19)),(PTBS 2(1,1),PTBS(1,19))
     3,               (RDMAP4(1,1),RDMAP(1,28))
      DATA COMND   /
     1                4HSOLV    , 28    ,  0    ,  5    , 20    , 14  /
      DATA SLASH   /  1H/       /
      DATA RDMAP 1 /
     1 4HALTE,4HR   ,4H  (G,4HP1) ,4H$   ,13*4H    ,
     2 4HPARA,4HM   ,4H  //,4H*NOP,4H*/AL,4HWAYS,4H=-1 ,4H$   ,4H    ,
     * 4H    ,8*4H    ,
     3 4HSGEN,4H    ,4H  CA,4HSECC,4H,GEO,4HM3,G,4HEOM4,4H,DYN,4HAMIC,
     * 4HS/CA,4HSESS,4H,CAS,4HEI,G,4HPL,E,4HQEXI,4HN,GP,4HDT, ,4H    ,
     4 4H    ,4H    ,4H  BG,4HPDT,,4HSIL,,4HGE3S,4H,GE4,4HS,DY,4HNS/S,
     * 4H,N,D,4HRY!*,4HNAME,4HSOLS,4H*/S,,4HN,LU,4HSET/,4H    ,4H    ,
     5 4H    ,4H    ,4H  S,,4HN,NO,4HGPDT,4H $  ,12*4H    ,
     6 4HPURG,4HE   ,4H  CS,4HTM $,14*4H    ,
     7 4HEQUI,4HV   ,4H  GE,4H3S,G,4HEOM3,4H/ALW,4HAYS/,4HGE4S,4H,GEO,
     * 4HM4/A,4HLWAY,4HS/CA,4HSEI,,4HCASE,4HCC/A,4HLWAY,4HS/  ,4H    ,
     8 4H    ,4H    ,4H  DY,4HNS,D,4HYNAM,4HICS/,4HALWA,4HYS $,4H    ,
     * 4H    ,8*4H    ,
     9 4HCOND,4H    ,4H  LB,4HSTP,,4HDRY ,4H$   ,12*4H     /
      DATA RDMAP 2 /
     O 4HALTE,4HR   ,4H  (P,4HLOT),4H $  ,13*4H    ,
     1 4HALTE,4HR   ,4H  (C,4HOND),4H $  ,13*4H    ,
     2 4HCOND,4H    ,4H  LB,4HSOL,,4HNOSI,4HMP $,12*4H    ,
     3 4HALTE,4HR   ,4H  (O,4HPTP),4H $  ,13*4H    ,
     4 4HCOND,4H    ,4H  LB,4HSOL,,4HNOMG,4HG $ ,12*4H    ,
     5 4HALTE,4HR   ,4H  (S,4HMA3),4H $  ,13*4H    ,
     6 4HLABE,4HL   ,4H  LB,4HSOL ,4H$   ,13*4H    ,
     7 4HSOFI,4H    ,4H  /K,4HNOS,,4HMNOS,4H,,,/,4HDRY/,4H*NAM,4HESOL,
     * 4HS*!*,4HKMTX,4H*!*M,4HMTX*,4H $  , 4*4H    ,
     8 4HEQUI,4HV   ,4H  KN,4HOS,K,4HGG/N,4HOSIM,4HP $ ,4H    ,4H    ,
     * 4H    ,8*4H      /
      DATA RDMAP 3 /
     9 4HEQUI,4HV   ,4H  MN,4HOS,M,4HGG/N,4HOSIM,4HP $ ,4H    ,4H    ,
     * 4H    ,8*4H    ,
     O 4HCOND,4H    ,4H  LB,4HSTP,,4HNOSI,4HMP $,12*4H    ,
     1 4HADD ,4H    ,4H  KG,4HGX,K,4HNOS/,4HKGG/,4H(1.0,4H,0.0,4H)/(1,
     * 4H.0,0,4H.0) ,4H$   ,6*4H    ,
     2 4HADD ,4H    ,4H  MG,4HG,MN,4HOS/M,4HGGX/,4H(1.0,4H,0.0,4H)/(1,
     * 4H.0,0,4H.0) ,4H$   ,6*4H    ,
     3 4HEQUI,4HV   ,4H  MG,4HGX,M,4HGG/A,4HLWAY,4HS $ ,4H    ,4H    ,
     * 4H    ,8*4H    ,
     4 4HLABE,4HL   ,4H  LB,4HSTP ,4H$   ,13*4H    ,
     5 4HCHKP,4HNT  ,4H  MG,4HG $ ,14*4H    ,
     6 4HALTE,4HR   ,4H  (G,4HP4) ,4H$   ,13*4H    ,
     7 4HCOND,4H    ,4H  LB,4HSEND,4H,DRY,4H $  ,12*4H     /
      DATA RDMAP 4 /
     8 4HALTE,4HR   ,4H  (S,4HDR2),4H $  ,13*4H            /
      DATA OCT 1   /
     1                   18    ,         0    ,         1  ,
     2                   19    ,         0    ,         2  ,
     3                   21    ,         0    ,         1  ,
     4                   22    ,         0    ,         2  ,
     5                   23    ,         0    ,         2  /
      DATA PTBS 1  /
     1          1  , 11  , 11  ,  5  ,     1  ,         0  ,  0  ,
     2          4  , 43  , 45  ,  8  ,4HNAME  ,         0  ,  0  ,
     3          9  , 13  , 13  ,  3  ,4HSTEP  ,         0  ,  0  ,
     4         10  , 11  , 11  ,  6  ,     2  ,         0  ,  0  ,
     5         11  , 11  , 11  ,  6  ,     6  ,         0  ,  0  ,
     6         12  , 50  , 50  ,  0  ,4HSOL   ,         0  ,  0  ,
     7         13  , 11  , 11  ,  6  ,     7  ,         0  ,  0  ,
     8         14  , 50  , 50  ,  0  ,4HMSKP  ,         0  ,  0  ,
     9         15  , 11  , 11  ,  6  ,     3  ,         0  ,  0  ,
     O         17  , 12  , 13  ,  3  ,4HNANO  ,         1  , -1  ,
     1         17  , 17  , 18  ,  3  ,4HNANO  ,         2  , -1  ,
     2         17  , 28  , 30  ,  8  ,4HNAME  ,         0  ,  0  ,
     3         18  , 11  , 12  ,  3  ,4HNANO  ,         0  ,  0  ,
     4         19  , 11  , 12  ,  3  ,4HNANO  ,         0  ,  0  ,
     5         20  , 13  , 13  ,  3  ,4HSTEP  ,         0  ,  0  ,
     6         21  , 16  , 17  ,  3  ,4HNANO  ,         0  ,  0  ,
     7         22  , 15  , 16  ,  3  ,4HNANO  ,         0  ,  0  ,
     8         24  , 13  , 13  ,  3  ,4HSTEP  ,         0  ,  0  /
      DATA PTBS 2  /
     1         26  , 11  , 11  ,  5  ,     4  ,         0  ,  0  ,
     2         28  , 11  , 11  ,  6  ,     5  ,         0  ,  0  /
      DATA SUBNAM  / 4HASCM,2H05  /
C
C     RESTORE TO ORIGINAL DATA BY REPLACEING ! BY / IN RDMAP ARRAY
C     (SEE ASCM01 FOR EXPLANATION))
C
      RDMAP(11, 4) = KHRFN1(RDMAP(11, 4),3,SLASH,1)
      RDMAP(10,17) = KHRFN1(RDMAP(10,17),3,SLASH,1)
      RDMAP(12,17) = KHRFN1(RDMAP(12,17),2,SLASH,1)
C
C     VALIDATE COMMAND AND SET POINTERS
C
      IF (NAME .NE. COMND(1,1)) GO TO 1000
      ICOMND = 1
      IRDM   = 1
      NRDM   = COMND(2,ICOMND)
      IXTRA  = IRDM  + 18*NRDM
      NXTRA  = COMND(3,ICOMND)
      IOCT   = IXTRA + NXTRA
      NOCT   = COMND(4,ICOMND)
      IPTBS  = IOCT  + 3*NOCT
      NPTBS  = COMND(5,ICOMND)
      IPH    = IPTBS + 7*NPTBS
      NPH    = COMND(6,ICOMND)
C
C     MOVE RDMAP DATA
C
      K = 0
      IF (NRDM .EQ. 0) GO TO 35
      DO 30 J = 1,NRDM
      DO 30 I = 1,18
      K = K + 1
   30 IDAT(K) = RDMAP(I,J)
   35 CONTINUE
C
C     MOVE OCT DATA
C
      IF (NOCT .EQ. 0) GO TO 55
      DO 50 J = 1,NOCT
      DO 50 I = 1,3
      K = K + 1
   50 IDAT(K) = OCT(I,J)
   55 CONTINUE
C
C     MOVE PTBS DATA
C
      IF (NPTBS .EQ. 0) GO TO 65
      DO 60 J = 1,NPTBS
      DO 60 I = 1,7
      K = K + 1
   60 IDAT(K) = PTBS(I,J)
   65 CONTINUE
C
C     MOVE PHASE 2 DATA
C
      IF (IPHASE.NE.2 .OR. NPH.EQ.0) GO TO 100
      DO 70 I = 1,4
      K = K + 1
   70 IDAT(K) = IPAS25(I)
      DO 80 I = 9,14
      K = K + 1
   80 IDAT(K) = IPAS25(I)
      DO 90 I = 5,8
      K = K + 1
   90 IDAT(K) = IPAS25(I)
      GO TO 200
  100 CONTINUE
C
  200 RETURN
C
C     INPUT ERROR
C
 1000 CALL MESAGE (7,0,SUBNAM)
      NOGO = 1
      RETURN
C
      END

      SUBROUTINE FORM2(UDDIP1,UDIPRM,UIPRM,PIPRM,IBUF)
C*******
C     FORM2 GENERATES THE VECTORS NECESSARY TO CHANGE THE TIME STEP
C
C     THIS ROUTINE IS SUITABLE FOR SINGLE PRECISION OPERATION
C*******
      DIMENSION UDDIP1(1),UDIPRM(1),UIPRM(1),PIPRM(1),IBUF(1)
C
      COMMON   /TRDXX /  IFILK(7)  ,IFILM(7) ,IFILB(7)
C*******
C     FORM UDOT(I+1), UDDOT(I+1), UDOT-(I), AND U-(I)
C*******
      CALL MATVEC(UDDIP1(1),PIPRM(1),IFILM(1),IBUF)
      CALL MATVEC(UDIPRM(1),PIPRM(1),IFILB(1),IBUF)
      CALL MATVEC(UIPRM(1),PIPRM(1),IFILK(1),IBUF)
      RETURN
      END

      SUBROUTINE SDHTF2(IEQEX,NEQEX)
C*****
C     THIS ROUTINE CALCULATES TEMPERATURE GRADIENTS AND HEAT FLOWS
C     FOR ALL ELEMENTS IN A HEAT TRANSFER PROBLEM.
C      DATA IS OUTPUT FOR ELEMENT FORCE REQUEST ONLY.
C******
      INTEGER  IGRAD(3), IQOUT(3), FTUBE
      REAL    ESTA(202)
      DIMENSION IZ(1),IPT(21)
      COMMON /ZZZZZZ/  ZZ(1)
      COMMON  /SDR2X4/  DUMMY(35),IVEC
      COMMON/SDR2X7/IDE,ISIL(32),NQ,NSIL,NAME(2),RK(9),CE(96),
     1              DUM(58),IDO,NAMO(2),TGRAD(3),QOUT(3)
      COMMON/SDR2X8/TVEC(32)
      EQUIVALENCE  (TGRAD(1),IGRAD(1)) ,(QOUT(1),IQOUT(1))
      EQUIVALENCE  (ZZ(1),IZ(1)), (ESTA(1),IDE)
      DATA IHEX/4HIHEX/,IONE,ITWO,ITHR/4H1   ,4H2   ,4H3   /
      DATA IHEX1,IHEX2,IHEX3/4HHEX1,4HHEX2,4HHEX3/
      DATA FTUBE/4HFTUB/
      DATA IOLD/0/
      DATA IPT/4H   1,4H  E1,4H   4,4H  E2,4H   7,4H  E3,4H  10,
     1         4H  E4,4H  E5,4H  E6,4H  E7,4H  E8,4H  21,4H  E9,
     2         4H  24,4H E10,4H  27,4H E11,4H  30,4H E12,4H   0/
C
      IF (NAME(1) .EQ. FTUBE) GO TO 70
      DO 10 I=1,3
      IGRAD(I)= 1
   10 IQOUT(I)= 1
      IDO= IDE
      NAMO(1)= NAME(1)
      NAMO(2)= NAME(2)
C
C FOR ISOPARAMETRIC SOLIDS, GET SIL NUMBER AND CONVERT TO EXTERNAL.
C STORE IT IN NAMO(2)
C
      IF(NAMO(1).NE.IHEX) GO TO 29
      IF(IOLD.EQ.IDE) GO TO 11
      IOLD=IDE
      ISTRPT=0
   11 IF(NAMO(2).EQ.IONE) NAMO(1)=IHEX1
      IF(NAMO(2).EQ.ITWO) NAMO(1)=IHEX2
      IF(NAMO(2).EQ.ITHR) NAMO(1)=IHEX3
      ISTRPT=ISTRPT+1
      IF(ISTRPT.EQ.NSIL+1.OR.ISTRPT.EQ.21) IOLD=0
      IF(NAMO(1).EQ.IHEX3) GO TO 12
      IF(NAMO(1).EQ.IHEX1.AND.ISTRPT.EQ.9) GO TO 15
      IF(NAMO(1).EQ.IHEX2.AND.ISTRPT.EQ.21) GO TO 15
      GO TO 13
   12 NAMO(2)=IPT(ISTRPT)
      GO TO 29
   13 ISUB1=IEQEX+1
      ISUB2=IEQEX+NEQEX-1
      DO 14 JJJ=ISUB1,ISUB2,2
      NS=IZ(JJJ)/10
      IF(NS.NE.ISIL(ISTRPT)) GO TO 14
      NAMO(2)=IZ(JJJ-1)
      GO TO 29
   14 CONTINUE
      CALL MESAGE(-30,164,IZ(JJJ))
   15 NAMO(2)=0
   29 CONTINUE
      IF(NQ .LE. 0) GO TO 60
      DO 30 I=1,NSIL
      TVEC(I)= 0.0
      IP= ISIL(I)
      IF( IP .EQ. 0) GO TO 30
      ITEMP = IVEC + IP -1
      TVEC(I) = ZZ(ITEMP)
   30 CONTINUE
C***
      CALL GMMATS( CE(1),NQ,NSIL,0, TVEC(1),NSIL,1,0, TGRAD(1) )
C
      CALL GMMATS( RK(1),NQ,NQ,0, TGRAD(1),NQ,1,0, QOUT(1) )
C
      DO 40 I=1,NQ
   40 QOUT(I) =-QOUT(I)
      RETURN
   60 TGRAD(1) = 0.0
      QOUT(1) = 0.0
      GO TO 80
C
   70 IDO=IDE
      ITEMP=IVEC + ISIL(1) - 1
      TVEC(1)=ZZ(ITEMP)
      ESTA(202)=TVEC(1)*ESTA(4)
C
   80 RETURN
      END

      SUBROUTINE SNPDF (SL,CL,TL,SGS,CGS,SGR,CGR,X0,Y0,Z0,EE,DIJ,BETA,
     1                  CV)
C
C     SNPDF CALCULATES THE STEADY PART OF THE INFLUENCE COEFFICIENT
C     MATRIX ELEMENTS
C
      TEST1 = 0.9999
      TEST2 = 0.0001*EE
C
C     ***  TEST1 AND TEST2  SERVE AS A MEASURE OF  'NEARNESS'  WITH
C     RESPECT TO THE BOUND-  AND TRAILING VORTICES RESPECTIVELY - SEE
C     TESTS BELOW
C     NOTE THAT THE MACH NUMBER EFFECT IS ACCOUNTED FOR BY STRETCHING
C     THE  X-COORDINATES AND THE  SWEEP ANGLE OF THE BOUND VORTEX LINE
C
      TLB   = TL/BETA
      SQTLB = SQRT(1.0+TLB**2)
      SLB   = TLB/SQTLB
      CLB   = 1.0/SQTLB
      CAVE  = CV
      CLSGS = CLB*SGS
      CLCGS = CLB*CGS
      EX    = EE*TLB
      EY    = EE*CGS
      EZ    = EE*SGS
      X0B   = X0/BETA
      RIX   = X0B+ EX
      RIY   = Y0 + EY
      RIZ   = Z0 + EZ
      RIMAG = SQRT(RIX**2 + RIY**2 + RIZ**2)
      ROX   = X0B- EX
      ROY   = Y0 - EY
      ROZ   = Z0 - EZ
      ROMAG = SQRT(ROX**2 + ROY**2 + ROZ**2)
      CAB   = (RIX*SLB+ RIY*CLCGS + RIZ*CLSGS)/RIMAG
      CBB   = (ROX*SLB+ ROY*CLCGS + ROZ*CLSGS)/ROMAG
      CBI   =-RIX/RIMAG
      CAO   = ROX/ROMAG
      RICAB = RIMAG*CAB
      DBX   = RIX - RICAB*SLB
      DBY   = RIY - RICAB*CLCGS
      DBZ   = RIZ - RICAB*CLSGS
      DB2   = DBX**2 + DBY**2 + DBZ**2
      DI2   = RIY**2 + RIZ**2
      DO2   = ROY**2 + ROZ**2
      ACAB  = ABS(CAB)
      ACBB  = ABS(CBB)
C
C     ***  THE FOLLOWING IS A TEST TO SEE IF THE RECEIVING POINT LIES ON
C     OR NEAR THE BOUND VORTEX  --  IF SO, THE CONTRIBUTION OF THE BOUND
C     VORTEX IS SET TO ZERO
C
      IF (ACAB .GT. TEST1) GO TO 30
      IF (ACBB .GT. TEST1) GO TO 30
      CACB = (CAB-CBB)/DB2
      GO TO  60
   30 IF (CAB*CBB) 40,50,50
   40 CACB = 0.
      GO TO 60
   50 CACB = 0.5*ABS((1./RIMAG**2)-(1./ROMAG**2))
   60 CONTINUE
      VBY = CACB*(DBX*CLSGS - DBZ*SLB)
      VBZ = CACB*(DBY*SLB - DBX*CLCGS)
C
C     ***  TEST TO SEE IF THE RECEIVING POINT LIES ON OR NEAR THE
C     INBOARD TRAILING VORTEX  --  IF SO, THE CONTRIBUTION OF THE
C     INBOARD TRAILING VORTEX IS SET TO ZERO
C
      IF (DI2 .GT. TEST2) GO TO 62
      VIY  = 0.0
      VIZ  = 0.0
      GO TO  64
   62 CONTINUE
      ONECBI = (1.0-CBI)/DI2
      VIY =  ONECBI*RIZ
      VIZ = -ONECBI*RIY
   64 CONTINUE
C
C     ***  TEST TO SEE IF THE RECEIVING POINT LIES ON OR NEAR THE
C     OUTBOARD TRAILING VORTEX  --  IF SO, THE CONTRIBUTION OF THE
C     OUTBOARD TRAILING VORTEX IS SET TO ZERO
C
      IF (DO2 .GT. TEST2) GO TO 66
      VOY  = 0.0
      VOZ  = 0.0
      GO TO  68
   66 CONTINUE
      CAOONE = (1.0+CAO)/DO2
      VOY = -CAOONE*ROZ
      VOZ =  CAOONE*ROY
   68 CONTINUE
      VY  = VBY + VIY + VOY
      VZ  = VBZ + VIZ + VOZ
      WW  = VY*SGR - VZ*CGR
      DIJ = WW*CAVE/25.132741
      RETURN
      END

      SUBROUTINE SHCTSS (IERR,ELID,PID,MID,TLAM,TMEAN,TGRAD,THETAE,
     1                   FTHERM,EPSLNT,ICORE,CORE)
C
C     SINGLE PRECISION ROUTINE TO EVALUATE THERMAL STRAINS FOR COMPOSITE
C     SHELL ELEMENTS.
C
C     INPUT :
C           ELID   - ELEMENT ID
C           PID    - PROPERTY ID
C           MID    - ARRAY OF LAMINATE MATERIAL ID'S
C           TLAM   - LAMINATE THICKNESS
C           TMEAN  - ELEMENT MEAN TEMPERATURE
C           TGRAD  - THERMAL GRADIENT
C           THETAE - ANGLE FROM ELEMENT X-AXIS TO MATERIAL X-AXIS
C           FTHERM - ARRAY OF THERMAL FORCES CONTAINING THE USER-
C                    DEFINED THERMAL MOMENTS, IF SUPPLIED
C           IPCMPI AND NPCMPI ARE THE STARTING POINT AND THE NUMBER
C           OF WORDS OF PCOMPI DATA IN CORE, AS INPUT BY /SDR2C1/.
C     OUTPUT:
C           EPSLNT - ARRAY OF THERMAL STRAINS FOR THE LAMINATE
C
C
      LOGICAL          NONMEM,PCMP,PCMP1,PCMP2
      INTEGER          ELID,PID,MID(4),ICORE(1),PCOMP,PCOMP1,PCOMP2,
     1                 PIDLOC,SYM,SYMMEM,INDX(6,3)
      REAL             CORE(1)
      REAL             TLAM,TMEAN,TGRAD,THETAE,FTHERM(6),EPSLNT(6),
     1                 MINRT,ABBD(6,6),STIFF(36),GLAY(9),GLAYT(9),
     2                 GBAR(9),GPROP(25),ALPHAL(3),ALPHAE(3),GALPHA(3),
     3                 THETA,TRANSL(9),TSUBO,DELTA,DELTAT,ZK,ZK1,ZREF,
     4                 ZSUBI,C,C2,S,S2,PI,TWOPI,RADDEG,DEGRAD,DETERM,
     5                 DUM(6)
      COMMON /CONDAS/  PI,TWOPI,RADDEG,DEGRAD
      COMMON /MATIN /  MATID,INFLAG,ELTEMP
      COMMON /SDR2C1/  IPCMP,NPCMP,IPCMP1,NPCMP1,IPCMP2,NPCMP2
C
C
      DATA    PCOMP ,  PCOMP1,PCOMP2 / 0,1,2 /
      DATA    SYM   ,  MEM   ,SYMMEM / 1,2,3 /
C
C     INITIALIZE
C
      IERR = 0
      DO 20 LL = 1,6
      DO 10 MM = 1,6
      ABBD(LL,MM) = 0.0
   10 CONTINUE
   20 CONTINUE
C
      MINRT = TLAM*TLAM*TLAM/12.0
      ZREF  =-TLAM/2.0
C
      INFLAG = 12
      ELTEMP = TMEAN
C
      ITYPE = -1
      LPCOMP= IPCMP + NPCMP + NPCMP1 + NPCMP2
      PCMP  = NPCMP  .GT. 0
      PCMP1 = NPCMP1 .GT. 0
      PCMP2 = NPCMP2 .GT. 0
C
C     ISSUE ERROR IF PCOMPI DATA HAS NOT BEEN READ INTO CORE
C
      IF (LPCOMP .EQ. IPCMP) GO TO 600
C
C     LOCATE PID BY PERFORMING A SEQUENTIAL SEARCH OF THE PCOMPI DATA
C     BLOCK WHICH IS IN CORE.
C
C     SEARCH FOR PID IN PCOMP DATA
C
      IF (.NOT.PCMP) GO TO 110
      IP = IPCMP
      IF (ICORE(IP) .EQ. PID) GO TO 210
      IPC11 = IPCMP1 - 1
      DO 100 IP = IPCMP,IPC11
      IF (ICORE(IP).NE.-1 .OR. IP.GE.IPC11) GO TO 100
      IF (ICORE(IP+1) .EQ. PID) GO TO 200
  100 CONTINUE
C
C     SEARCH FOR PID IN PCOMP1 DATA
C
  110 IF (.NOT.PCMP1) GO TO 130
      IP = IPCMP1
      IF (ICORE(IP) .EQ. PID) GO TO 230
      IPC21 = IPCMP2 - 1
      DO 120 IP = IPCMP1,IPC21
      IF (ICORE(IP).NE.-1 .OR. IP.GE.IPC21) GO TO 120
      IF (ICORE(IP+1) .EQ. PID) GO TO 220
  120 CONTINUE
C
C     SEARCH FOR PID IN PCOMP2 DATA
C
  130 IF (.NOT.PCMP2) GO TO 150
      IP = IPCMP2
      IF (ICORE(IP) .EQ. PID) GO TO 250
      LPC11 = LPCOMP - 1
      DO 140 IP = IPCMP2,LPC11
      IF (ICORE(IP).NE.-1 .OR. IP.GE.LPC11) GO TO 140
      IF (ICORE(IP+1) .EQ. PID) GO TO 240
  140 CONTINUE
C
C     PID WAS NOT LOCATED; ISSUE ERROR
C
  150 GO TO 600
C
C     PID WAS LOCATED; DETERMINE TYPE
C
  200 IP     = IP + 1
  210 ITYPE  = PCOMP
      PIDLOC = IP
      NLAY   = ICORE(PIDLOC+1)
      IPOINT = PIDLOC + 8 + 4*NLAY
      GO TO 300
C
  220 IP     = IP + 1
  230 ITYPE  = PCOMP1
      PIDLOC = IP
      NLAY   = ICORE(PIDLOC+1)
      IPOINT = PIDLOC + 8 + NLAY
      GO TO 300
C
  240 IP     = IP + 1
  250 ITYPE  = PCOMP2
      PIDLOC = IP
      NLAY   = ICORE(PIDLOC+1)
      IPOINT = PIDLOC + 8 + 2*NLAY
C
  300 TSUBO  = CORE(IPOINT+24)
      DELTA  = TMEAN - TSUBO
      LAMOPT = ICORE(PIDLOC+8)
      NONMEM = LAMOPT.NE.MEM .AND. LAMOPT.NE.SYMMEM
C
C     LAMOPT - LAMINATION GENERATION OPTION
C            = ALL     (ALL PLYS, DEFAULT)
C            = SYM     (SYMMETRIC)
C            = MEM     (MEMBRANE ONLY)
C            = SYMMEM  (SYMMETRIC-MEMBRANE)
C
C     CONSTRUCT THE LAMINATE FORCE-STRAIN MATRIX
C
C     EXTENSIONAL
C
      MATID = MID(1)
      CALL MAT (ELID)
      CALL LPROPS (GPROP)
C
      DO 320 LL = 1,3
      II = 3*(LL-1)
      DO 310 MM = 1,3
      ABBD(LL,MM) = GPROP(MM+II)*TLAM
  310 CONTINUE
  320 CONTINUE
C
C     BENDING
C
      IF (.NOT.NONMEM) GO TO 400
C
      MATID = MID(2)
      CALL MAT (ELID)
      CALL LPROPS (GPROP)
C
      DO 340 LL = 1,3
      II = 3*(LL-1)
      DO 330 MM = 1,3
      ABBD(LL+3,MM+3) = GPROP(MM+II)*MINRT
  330 CONTINUE
  340 CONTINUE
C
C     MEMBRANE-BENDING
C
      IF (LAMOPT .EQ. SYM) GO TO 400
C
      MATID = MID(4)
      CALL MAT (ELID)
      CALL LPROPS (GPROP)
C
      DO 360 LL = 1,3
      II = 3*(LL-1)
      DO 350 MM = 1,3
      ABBD(LL,MM+3) = GPROP(MM+II)*TLAM*TLAM
      ABBD(LL+3,MM) = GPROP(MM+II)*TLAM*TLAM
  350 CONTINUE
  360 CONTINUE
C
C
C     BEGIN THE LOOP OVER LAYERS
C
  400 ZK = ZREF
      DO 500 K = 1,NLAY
C
C     SET THE LAYER-DEPENDENT VARIABLES
C
      ZK1 = ZK
      IF (ITYPE .NE. PCOMP) GO TO 410
      ZK = ZK1 + CORE(PIDLOC+6+4*K)
      THETA = CORE(PIDLOC   +7+4*K)
      GO TO 430
C
  410 IF (ITYPE .NE. PCOMP1) GO TO 420
      ZK = ZK1 + CORE(PIDLOC+8  )
      THETA = CORE(PIDLOC   +8+K)
      GO TO 430
C
  420 IF (ITYPE .NE. PCOMP2) GO TO 430
      ZK = ZK1 + CORE(PIDLOC+7+2*K)
      THETA = CORE(PIDLOC   +8+2*K)
C
C     LAYER MATERIAL PROPERTIES
C
  430 DO 440 IR = 1,9
      GLAY(IR) = CORE(IPOINT+IR)
  440 CONTINUE
C
      DO 450 IR = 1,3
      ALPHAL(IR) = CORE(IPOINT+13+IR)
  450 CONTINUE
C
      TI = ZK - ZK1
      ZSUBI = (ZK+ZK1)/2.0
      DELTAT = DELTA + ZSUBI*TGRAD
C
C     TRANSFORM THE LAYER MATERIAL PROPERTIES FROM THE FIBER SYSTEM TO
C     THE ELEMENT SYSTEM
C
      THETA = THETA*DEGRAD + THETAE
      C   = COS(THETA)
      C2  = C*C
      S   = SIN(THETA)
      S2  = S*S
C
      TRANSL(1)  = C2
      TRANSL(2)  = S2
      TRANSL(3)  = C*S
      TRANSL(4)  = S2
      TRANSL(5)  = C2
      TRANSL(6)  =-C*S
      TRANSL(7)  =-2.0*C*S
      TRANSL(8)  = 2.0*C*S
      TRANSL(9)  = C2 - S2
C
C                _            T
C     CALCULATE [G] = [TRANSL] [GLAY][TRANSL]
C
      CALL GMMATS (GLAY(1),3,3,0,  TRANSL(1),3,3,0, GLAYT(1))
      CALL GMMATS (TRANSL(1),3,3,1, GLAYT(1),3,3,0, GBAR(1))
C
C     CALCULATE [ALPHAE] = [TRANSL]X[ALPHA]
C     MODIFY [TRANSL] FOR TRANSFORMATIONS OF ALPHAS
C
      TRANSL(3) = -TRANSL(3)
      TRANSL(6) = -TRANSL(6)
      TRANSL(7) = -TRANSL(7)
      TRANSL(8) = -TRANSL(8)
C
      CALL GMMATS (TRANSL(1),3,3,0, ALPHAL(1),3,1,0, ALPHAE(1))
C
C
C     CALCULATE THERMAL FORCES AND MOMENTS
C
      CALL GMMATS (GBAR(1),3,3,0, ALPHAE(1),3,1,0, GALPHA(1))
C
      DO 460 IR = 1,3
      FTHERM(IR) = FTHERM(IR  ) + GALPHA(IR)*DELTAT*(ZK-ZK1)
      IF (NONMEM)  FTHERM(IR+3) = FTHERM(IR+3) - GALPHA(IR)*
     1                            DELTAT*(ZK*ZK-ZK1*ZK1)/2.0
  460 CONTINUE
C
C     CALCULATE CONTRIBUTION FROM SYMMETRIC LAYERS
C
      IF (LAMOPT.NE.SYM .AND. LAMOPT.NE.SYMMEM) GO TO 480
      DELTAT = DELTA - ZSUBI*TGRAD
C
      DO 470 IR = 1,3
      FTHERM(IR) = FTHERM(IR  ) + GALPHA(IR)*DELTAT*(ZK-ZK1)
      IF (NONMEM)  FTHERM(IR+3) = FTHERM(IR+3) - GALPHA(IR)*
     1                            DELTAT*(ZK1*ZK1-ZK*ZK)/2.0
  470 CONTINUE
  480 IF (ITYPE .EQ. PCOMP) IPOINT = IPOINT + 27
C
  500 CONTINUE
C
C
C     END OF LOOP OVER THE LAYERS
C
C     COMPUTE THERMAL STRAIN VECTOR
C
C                      -1
C     {EPSLNT} = [ABBD]  {FTHERM}
C
      ISING = -1
      CALL INVERS (6,ABBD,6,DUM,0,DETERM,ISING,INDX)
C
      DO 520 LL = 1,6
      NN = 6*(LL-1)
      DO 510 MM = 1,6
      STIFF(NN+MM) = ABBD(LL,MM)
  510 CONTINUE
  520 CONTINUE
C
      CALL GMMATS (STIFF(1),6,6,0, FTHERM(1),6,1,0, EPSLNT(1))
      GO TO 700
C
  600 IERR = 1
  700 RETURN
      END

      SUBROUTINE SMSG (NO,P1,P2)
C
C     MESSAGE WRITER FOR SUBSTRUCTURE DIAGNOSTICS, 61XX SERIES
C
      INTEGER         P1,P2(2),P3(2),POS(2),NEG(2),PNG(2)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /SYSTEM/ SYSBUF,K
      DATA    POS   , NEG/4HWARN,4HING ,4HFATA,4HL   /
      DATA    NMSG  / 8  /, NMSG1 / 11 /
C
      L = IABS(NO)
      MSGNO  = L + 6100
      IF (L.LT.1 .OR. L.GT.NMSG) GO TO 99
      IF (NO) 30,30,40
   30 PNG(1) = NEG(1)
      PNG(2) = NEG(2)
      GO TO 50
   40 PNG(1) = POS(1)
      PNG(2) = POS(2)
      GO TO 50
C
C
      ENTRY SMSG1 (NO,P1,P2,P3)
C     ========================
C
      L = IABS(NO)
      IF (L.LE.NMSG .OR. L.GT.NMSG1) GO TO 99
C
   50 GO TO (1,2,3,4,5,6,7,8,9,10,11,12), L
    1 WRITE (K,201) PNG,MSGNO
      WRITE (K,101) P1,P2
      GO TO 100
    2 WRITE (K,201) PNG,MSGNO
      WRITE (K,102) P1,P2
      GO TO 100
    3 WRITE (K,201) PNG,MSGNO
      WRITE (K,103) P1,P2
      GO TO 100
    4 WRITE (K,201) PNG,MSGNO
      WRITE (K,104) P2
      GO TO 100
    5 WRITE (K,201) PNG,MSGNO
      WRITE (K,105) P2
      GO TO 100
    6 WRITE (K,200) PNG,MSGNO
      WRITE (K,106) P1,P2
      GO TO 100
    7 WRITE (K,200) PNG,MSGNO
      WRITE (K,107) P1,P2
      GO TO 100
    8 WRITE (K,200) PNG,MSGNO
      WRITE (K,108) P1,P2
      GO TO 100
    9 WRITE (K,109) P3,P1,P2
      GO TO 100
   10 WRITE (K,110) P3,P1,P2
      GO TO 100
   11 WRITE (K,111) P3,P1,P2
      GO TO 100
   12 WRITE (K,112)
      GO TO 100
   99 WRITE (K,120) NO,P1,P2
  100 IF (NO .GT. 0) RETURN
      IF (L .LE. NMSG) CALL SOFCLS
      WRITE (K,130)
      CALL ERRTRC ('SMSG    ',130)
      RETURN
C
  101 FORMAT (' REQUESTED SOF ITEM DOES NOT EXIST.  ITEM ',A4,
     1        ', SUBSTRUCTURE ',2A4)
  102 FORMAT (' REQUESTED SUBSTRUCTURE DOES NOT EXIST.  ITEM ',A4,
     1        ', SUBSTRUCTURE ',2A4)
  103 FORMAT (' REQUESTED SOF ITEM HAS INVALID NAME.  ITEM ',A4,
     1        ', SUBSTRUCTURE ',2A4)
  104 FORMAT (' ATTEMPT TO CREATE DUPLICATE SUBSTRUCTURE NAME ',2A4)
  105 FORMAT (' ATTEMPT TO RE-USE SUBSTRUCTURE ',2A4,' IN A REDUCE ',
     1       ' OR COMBINE OPERATION.  USE EQUIV SUBSTRUCTURE COMMAND')
  106 FORMAT (' UNEXPECTED END OF GROUP ENCOUNTERED WHILE READING ITEM '
     1,       A4,', SUBSTRUCTURE ',2A4)
  107 FORMAT (' UNEXPECTED END OF ITEM ENCOUNTERED WHILE READING ITEM ',
     1        A4,', SUBSTRUCTURE ',2A4)
  108 FORMAT (' INSUFFICIENT SPACE ON SOF FOR ITEM ',A4,', SUBSTRUCTURE'
     1,       1X,2A4)
  109 FORMAT (A23,' 6211, MODULE ',2A4,' - ITEM ',A4,
     1       ' OF SUBSTRUCTURE ',2A4,' HAS ALREADY BEEN WRITTEN.')
  110 FORMAT (A23,' 6632, MODULE ',2A4,' - NASTRAN MATRIX FILE FOR I/O',
     1       ' OF SOF ITEM ',A4,', SUBSTRUCTURE ',2A4,', IS PURGED.')
  111 FORMAT (A23,' 6215, MODULE ',2A4,' - ITEM ',A4,
     1       ' OF SUBSTRUCTURE ',2A4,' PSEUDO-EXISTS ONLY.')
  112 FORMAT (' ')
  120 FORMAT (' NO MESSAGE FOR MESSAGE NO.',I5,' PARAMETERS = ',2I10,
     1        10X,2A10)
  130 FORMAT (//,' FATAL ERROR')
  200 FORMAT (' *** SYSTEM ',2A4,' MESSAGE',I5)
  201 FORMAT (' *** USER ',2A4,' MESSAGE',I5)
      END

      SUBROUTINE KSLOT (ITYPE)
C
C     THIS ROUTINE CALCULATES THE STIFFNESS MATRIX TERMS FOR THE
C     CSLOT3 AND CSLOT4 TWO DIMENSIONAL LAPLACE ELEMENTS
C
C     IOPT-  CSLOT3 = 0,  CSLOT4 = 1
C
C     THE ECPT DATA FOR THESE ELEMENTS ARE
C
C     FIELD   CSLOT3                CSLOT4
C       1       ID                  ID
C       2       SIL1                SIL1
C       3       SIL2                SIL2
C       4       SIL3                SIL3
C       5       RHO                 SIL4
C       6       BULK                RHO
C       7       M                   BULK
C       8       N                   M
C       9       CID1                N
C       10      R1                  CID1
C      11       Z1                  R1
C      12       W1                  Z1
C      13       CID2                W1
C      14       R2                  CID2
C      15       Z2                  R2
C      16       W2                  Z2
C      17       CID3                W2
C      18       R3                  CID3
C      19       Z3                  R3
C      20       W3                  Z3
C      21       TEMP                W3
C      22                           CID4
C      23                           R4
C      24                           Z4
C      25                           W4
C      26                           TEMP
C
      LOGICAL           NOGO
      INTEGER           NECPT(100) ,OUT
      DOUBLE PRECISION  COEF       ,FIR        ,FIZ        ,
     1                  R          ,Z          ,RKI        ,
     2                  A2         ,KIJ
      CHARACTER         UFM*23
      COMMON  /XMSSG /  UFM
      COMMON  /SYSTEM/  SYSBUF     ,OUT        ,NOGO
      COMMON  /SMA1CL/  IOPT4      ,K4GGSW     ,NPVT
      COMMON  /SMA1ET/  ECPT(100)
      COMMON  /SMA1IO/  DUM1(10)   ,IFILE
      COMMON  /SMA1DP/  COEF       ,FIR(3)     ,FIZ(3)      ,
     1                  R(3)       ,Z(3)       ,RKI         ,
     2                  A2         ,KIJ        ,NNEG        ,
     3                  IP         ,NPTJ       ,IRET        ,
     4                  LRI        ,LRJ        ,LRK         ,
     5                  IPVT
      EQUIVALENCE       (ECPT(1),NECPT(1))
C
      IF (ITYPE .GT. 0) GO TO 50
      IF (ECPT(5).EQ.0.0 .OR. NECPT(7).EQ.0) RETURN
      K = -1
   10 K = K + 1
      IF (2*NECPT(8)-K*NECPT(7)) 30,20,10
   20 NECPT(7) = NECPT(7)*2
   30 ECPT(7)  = FLOAT(NECPT(7))/2.0
      DO 40 I = 1,20
   40 ECPT(I+50) =  ECPT(I)
      IRET = 4
      GO TO 170
C
C     THE CSLOT4 ELEMENT IS CHECKED FOR VALIDITY AND THE DATA ARE
C     REARRANGED TO CONFORM TO THE CSLOT3 FORMAT
C
   50 IF (ECPT(6).EQ.0.0 .OR. NECPT(8).EQ.0) RETURN
      K = -1
   60 K = K + 1
      IF (2*NECPT(9)-K*NECPT(8)) 80,70,60
   70 NECPT(8) = NECPT(8)*2
   80 ECPT(8)  = FLOAT(NECPT(8))/2.0
C
      NNEG = 0
      IP   = 0
      DO 110 I = 1,4
      IF (NPVT .EQ. NECPT(I+1)) IP = IP + 1
      DO 90 J = 1,3
      NJ   = I + J - 1
      IF (NJ .GT.4) NJ = NJ - 4
      NPTJ = 4*(NJ-1) + 11
      R(J) = ECPT(NPTJ  )
   90 Z(J) = ECPT(NPTJ+1)
      COEF = (R(2)-R(1))*(Z(3)-Z(1)) - (R(3)-R(1))*(Z(2)-Z(1))
      IF (COEF) 100,220,110
  100 NNEG = NNEG + 1
  110 CONTINUE
      IF (NNEG.EQ.1 .OR. NNEG.EQ.3) GO TO 220
      IF (IP .NE. 1) GO TO 220
C
      DO 120 I = 1,4
  120 ECPT(I+50) = ECPT(I)
      DO 130 I = 7,21
  130 ECPT(I+49) = ECPT(I)
      ECPT(55) = ECPT(6)*2.0
      IRET = 1
      GO TO 170
  140 ECPT(54) = ECPT( 5)
      ECPT(68) = ECPT(23)
      ECPT(69) = ECPT(24)
      ECPT(70) = ECPT(25)
      IRET = 2
      GO TO 170
  150 ECPT(53) = ECPT( 4)
      ECPT(64) = ECPT(19)
      ECPT(65) = ECPT(20)
      ECPT(66) = ECPT(21)
      IRET = 3
      GO TO 170
  160 ECPT(52) = ECPT( 3)
      ECPT(60) = ECPT(15)
      ECPT(61) = ECPT(16)
      ECPT(62) = ECPT(17)
      IRET = 4
C
C     EACH CSLOT3 ELEMENT OR SUBELEMENT IS FORMULATED AS FOLLOWS
C
  170 IF (NECPT(52).NE.NPVT .AND. NECPT(53).NE.NPVT .AND.
     1    NECPT(54).NE.NPVT) GO TO 200
      COEF = 0.0
      A2   = 0.0
      DO 180 I = 1,3
      J    = I + 1
      IF (J .GT. 3) J = J - 3
      K    = J + 1
      IF (K .GT. 3) K = K - 3
      LRI  = 4*I + 56
      LRJ  = 4*J + 56
      LRK  = 4*K + 56
      COEF = COEF + ECPT(LRI+2)
      FIR(I) = ECPT(LRK  ) - ECPT(LRJ  )
      FIZ(I) = ECPT(LRJ+1) - ECPT(LRK+1)
      A2   = A2 + ECPT(LRI)*FIZ(I)
      IF (NECPT(I+51) .EQ. NPVT) IPVT = I
  180 CONTINUE
      IF (A2.EQ. 0.0D0) GO TO 220
      COEF = COEF*ECPT(57)/(6.0D0*ECPT(55)*DABS(A2))
      I    = NPVT
      DO 190 J = 1,3
      K    = NECPT(J+51)
      KIJ  = COEF*(FIR(IPVT)*FIR(J) + FIZ(IPVT)*FIZ(J))
      CALL SMA1B( KIJ,K,I,IFILE,0.0D0)
  190 CONTINUE
  200 GO TO (140,150,160,210), IRET
  210 RETURN
C
  220 WRITE  (OUT,230) UFM,NECPT(1)
  230 FORMAT (A23,' 2160, BAD GEOMETRY OR ZERO COEFFICIENT FOR SLOT ',
     1       'ELEMENT NUMBER',I18)
      NOGO =.TRUE.
      RETURN
      END

      SUBROUTINE CONMSG (MESAGE, NWORDS, IDUMMY)
C
      INTEGER FCHAR
      REAL INCTIM, MODTIM
      CHARACTER   CTIME*8,AHEAD*41,MCHNAM*11,MACHOS*7
C
      character (len=12) real_clock(3), time
      integer values(8)
      character(4) cvalues(8)
      equivalence(values,cvalues)
      DIMENSION MESAGE(1)
      DIMENSION ICRDAT(3)
      DIMENSION IDATE(3), ITIME(3)
C
      COMMON /CHMACH/ MCHNAM, MACHOS
      COMMON /LOGOUT/ LOUT
      COMMON /SYSTEM/ ISYSTM(175)
C
      EQUIVALENCE (ISYSTM( 15), IDATE(1)),
     *            (ISYSTM( 18), CPUSTR),
     *            (ISYSTM( 42), ICRDAT),
     *            (ISYSTM( 75), CPUTIM),
     *            (ISYSTM(151), NLLOG ),
     *            (ISYSTM(152), LOGLIN),
     *            (ISYSTM(159), LOGPAG),
     *            (ISYSTM(160), OLDCPU)
C
      DATA IDSMS,IWRTT,IAUDT,IMPYA /4HDSMS, 4HWRTT, 4HAUDT, 4HMPYA/
      DATA MODTIM /0.0/
      DATA IDASH /4H----/
C
C   ASSEMBLE PAGE HEADING
C
      AHEAD = ' '
      NCMNAM = INDEX(MCHNAM,' ') - 1
      IF (NCMNAM .LE. -1) NCMNAM = 11
      NCMOS  = INDEX(MACHOS,' ') - 1
      IF (NCMOS .LE. -1) NCMOS = 7
      FCHAR = (18 - NCMNAM - NCMOS) + 1
      AHEAD(FCHAR:FCHAR+6)='LOG OF '
      FCHAR = FCHAR + 7
      WRITE (AHEAD(FCHAR:FCHAR+1),15) ICRDAT(3)
   15 FORMAT (A2)
      FCHAR = FCHAR + 3
      AHEAD(FCHAR:41) = MCHNAM(1:NCMNAM) // ' ' // MACHOS(1:NCMOS) //
     1 ' NASTRAN JOB'
C
      IMODTM = 0
      IF (IDUMMY.EQ.111111 .OR. IDUMMY.EQ.222222)
     *    IMODTM = IDUMMY/111111
      IF (LOGLIN.LT.NLLOG.AND.LOGLIN.GT.0) GO TO 300
      IF (LOGLIN.EQ.0) WRITE (LOUT, 2000) IDATE, AHEAD
      IF (LOGLIN.EQ.0) WRITE (LOUT, 2055)
      IF (MESAGE(1).EQ.IDSMS.AND.NWORDS.EQ.1) RETURN
      IF (MESAGE(1).EQ.IWRTT.AND.NWORDS.EQ.1) RETURN
      IF (MESAGE(1).EQ.IAUDT.AND.NWORDS.EQ.1) RETURN
      IF (MESAGE(1).EQ.IMPYA.AND.NWORDS.EQ.1) RETURN
  300 CALL NASTIM (ITIME(1), ITIME(2), ITIME(3), CPUTMM)
      WRITE (CTIME,2056) ITIME
      call date_and_time(real_clock(1), time, Real_clock(3),
     1                  values)
C
 2056 FORMAT (2( I2,':'),I2)
      IF (CTIME(4:4) .EQ. ' ') CTIME(4:4) = '0'
      IF (CTIME(7:7) .EQ. ' ') CTIME(7:7) = '0'
      CPUTMM = CPUTMM + OLDCPU - CPUSTR
      INCTIM = CPUTMM - CPUTIM
      IF (CPUTIM.EQ.0.0) INCTIM = 0.0
      IF (IMODTM.EQ.1) MODTIM = 0.0
      IF (IMODTM.EQ.2) MODTIM = CPUTMM - MODTIM
      MWORDS = MIN0 (NWORDS, 15)
      IF (IMODTM.NE.2) WRITE (LOUT,2100) time(1:2),time(3:4),time(5:10),
     *                        CPUTMM, INCTIM,(MESAGE(I), I = 1, MWORDS)
      IF (IMODTM.EQ.2) WRITE (LOUT,2110) time(1:2),time(3:4),time(5:10),
     *               CPUTMM, INCTIM, MODTIM, (MESAGE(I), I = 1, MWORDS)
      call flush(4)
C
      LOGLIN = LOGLIN + 1
      CPUTIM = CPUTMM
      IF (IMODTM.EQ.1) MODTIM = CPUTMM
      RETURN
C
 2000 FORMAT (1H1,  77(1H*)/
     *        1X , 1H*,  75X, 1H*/
     *        1X , 1H*, 7X, 'DATE ', 2(I2, '/'), I2,
     *                   7X, A41, 7X, 1H*/
     *        1X , 1H*,  75X, 1H*/
     *        1X ,  77(1H*)/)
 2055 FORMAT (1X, 2X, 'WALL', 15X,
     *                'TOTAL', 7X,
     *                'INCREMENTAL', 6X,
     *                'MODULE', 14X,
     *                'MODULE/'/
     *        1X, 2X, 'CLOCK', 15X,
     *                'CPU', 12X,
     *                'CPU', 12X,
     *                'CPU', 13X,
     *                'SUBROUTINE'/
     *        1X, 2X, 'TIME', 14X,
     *                'SECONDS', 8X,
     *                'SECONDS', 8X,
     *                'SECONDS', 13X,
     *                'STATUS'//
     *        1X,  78(1H-)/)
 2100 FORMAT (1X, a2,':',a2,':',a6,
     *                 4X, F10.3,  5X, F10.3, 15X,
     *                             5X, A4, 2X, 2A4, 2X, 12A4)
 2110 FORMAT (1X, a2,':',a2,':',a6,
     *                 4X, F10.3,  5X, F10.3,  5X, F10.3,
     *                             5X, A4, 2X, 2A4, 2X, 12A4)
      END

      SUBROUTINE XYTRAN
C
      IMPLICIT INTEGER (A-Z)
      LOGICAL         VGP,RANDOM,OUTOPN,PRINT,PLOT,PAPLOT,OOMPP,OOMCP,
     1                PUNCH
      INTEGER         WORD(58),NAMEV(11),FILES(11),SUBCAS(200),
     1                NAME(2),MAJID(11),ROUTIN(2),HEADSV(96),
     2                XYCARD(20),OPENF(5),INDB(5)
      REAL            TEMP,TEMP1,RBUF(100),RZ(1),VALUE(60)
      CHARACTER       UFM*23,UWM*25
      COMMON /XMSSG / UFM,UWM
      COMMON /BLANK / BLKCOM,IDUM1,IPSET,IPSET2,NFRAME,NCARD
      COMMON /SYSTEM/ SYSBUF,L,NOGO,NIN,KSYSTM(81),INTR
      COMMON /OUTPUT/ IHEAD(96)
      COMMON /ZZZZZZ/ Z(1)
      COMMON /XYWORK/ FILE,TCURVE(32),NTOPS,PRINT,IFILE,XAXIS(32),
     1                NBOTS,PLOT,VECTOR,YAXIS(32),VECID(5),PUNCH,
     2                MAJOR,YTAXIS(32),SUBC(5),CENTER,RANDOM,YBAXIS(32),
     3                IDIN(153),BUF(100),IVALUE(60),IAT,IDOUT(300),
     4                OUTOPN,STEPS,NAT,PAPLOT,KNT
      EQUIVALENCE     (Z(1),RZ(1)),(BUF(1),RBUF(1)),(IVALUE(1),VALUE(1))
C
      DATA    STOP  / 4HSTOP /, GO    / 4HGO   /, VDUM  / 4HVDUM /,
     1        XY    / 4HXY   /, FRAM  / 4HFRAM /, CLEA  / 4HCLEA /,
     2        TCUR  / 4HTCUR /, XAXI  / 4HXTIT /, YAXI  / 4HYTIT /,
     3        YTAX  / 4HYTTI /, YBAX  / 4HYBTI /, BLANK / 4H     /,
     4        PSET  / 4HPSET /
C
      DATA    EOR   / 1  /, NOEOR /0  /, OUTRWD/1/, INPRWD/0/, REWD/1/
      DATA    XYCDB / 101/, OUTFIL/201/, INDB  / 102,103,104,105,106 /
      DATA    NWORDS/ 58 /, ROUTIN/4HXYTR, 4HAN  /, RAND  / 4HRAND   /
      DATA    VG    / 4HVG  /, I3 / 3 /
C
      DATA    WORD  /
     1        4HXMIN, 4HXMAX, 4HYMIN, 4HYMAX, 4HYTMI, 4HYTMA, 4HYBMI,
     8        4HYBMA, 4HXINT, 4HYINT, 4HYTIN, 4HYBIN, 4HXAXI, 4HYAXI,
     5        4HXTAX, 4HXBAX, 4HXDIV, 4HYDIV, 4HYTDI, 4HYBDI, 4HXVAL,
     2        4HYVAL, 4HYTVA, 4HYBVA, 4HUPPE, 4HLOWE, 4HLEFT, 4HRIGH,
     9        4HTLEF, 4HTRIG, 4HBLEF, 4HBRIG, 4HALLE, 4HTALL, 4HBALL,
     6        4HXLOG, 4HYLOG, 4HYTLO, 4HYBLO, 4HCURV, 4HDENS, 4H....,
     3        4H...., 4H...., 4HSKIP, 4HCAME, 4HPLOT, 4HXPAP, 4HYPAP,
     O        4HPENS, 4HXGRI, 4HYGRI, 4HXTGR, 4HYTGR, 4HXBGR, 4HYBGR,
     7        4HCSCA, 4HCOLO/
C
C     DATA FOR THE 11 VECTOR TYPES POSSIBLE
C
C                                                         BASIC
C              VECTOR-NAME         RESIDENT-FILE       MAJOR - ID
C          ******************     ***************   ****************
      DATA NAMEV( 1) / 4HDISP /,  FILES( 1) / 3 /,  MAJID( 1) /  1 /
      DATA NAMEV( 2) / 4HVELO /,  FILES( 2) / 3 /,  MAJID( 2) / 10 /
      DATA NAMEV( 3) / 4HACCE /,  FILES( 3) / 3 /,  MAJID( 3) / 11 /
      DATA NAMEV( 4) / 4HSPCF /,  FILES( 4) / 2 /,  MAJID( 4) /  3 /
      DATA NAMEV( 5) / 4HLOAD /,  FILES( 5) / 1 /,  MAJID( 5) /  2 /
      DATA NAMEV( 6) / 4HSTRE /,  FILES( 6) / 4 /,  MAJID( 6) /  5 /
      DATA NAMEV( 7) / 4HFORC /,  FILES( 7) / 5 /,  MAJID( 7) /  4 /
      DATA NAMEV( 8) / 4HSDIS /,  FILES( 8) / 1 /,  MAJID( 8) / 15 /
      DATA NAMEV( 9) / 4HSVEL /,  FILES( 9) / 1 /,  MAJID( 9) / 16 /
      DATA NAMEV(10) / 4HSACC /,  FILES(10) / 1 /,  MAJID(10) / 17 /
      DATA NAMEV(11) / 4HNONL /,  FILES(11) / 2 /,  MAJID(11) / 12 /
      DATA NAMEVG    / 4H VG  /
C
C     - IDOUT DATA RECORD DISCRIPTION -
C
C     WORD    TYPE   DISCRIPTION
C     ==================================================================
C       1     I/R    SUBCASE ID OR IF RANDOM THE MEAN RESPONSE
C       2      I     FRAME NUMBER
C       3      I     CURVE NUMBER
C       4      I     POINT-ID OR ELEMENT-ID
C       5      I     COMPONENT NUMBER
C       6      I     VECTOR NUMBER  1 THRU 11
C
C       7      I     1 -- CURVE USES TOP HALF OF FRAME
C                    0 -- CURVE USES FULL FRAME
C                   -1 -- CURVE USES LOWER HALF OF FRAME
C
C       8      I     0 -- AXIS,TICS,LABELS,VALUES, ETC. HAVE BEEN DRAWN
C                         AND THIS CURVE IS TO BE SCALED AND PLOTTED
C                         IDENTICALLY AS LAST EXCEPT FOR CURVE SYMBOLS.
C                    1 -- AXIS, TICS, LABELS, SCALEING, ETC. ARE TO BE
C                         PERFORMED OR COMPUTED AND IF IDOUT(7)=0 OR 1
C                         A SKIP TO NEW FRAME IS TO BE MADE.
C
C       9      I     NUMBER OF BLANK FRAMES BETWEEN FRAMES (FRAME-SKIP)
C      10      R     MINIMUM X-INCREMENT
C      11      R     XMIN  *
C      12      R     XMAX   *   DEFINES ACTUAL LIMITS OF DATA OF THIS
C      13      R     YMIN   *   UPPER, LOWER, OR FULL FRAME CURVE.
C      14      R     YMAX  *
C      15      R     ACTUAL VALUE OF FIRST TIC                 *
C      16      R     ACTUAL INCREMENT TO SUCCESSIVE TICS        *
C      17      I     ACTUAL MAXIMUM VALUE OF FRAME               *  X-
C      18      I     MAXIMUM NUMBER OF DIGITS IN ANY PRINT-VALUE  * DIRE
C      19      I     + OR - POWER FOR PRINT VALUES                * TICS
C      20      I     TOTAL NUMBER OF TICS TO PRINT THIS EDGE     *
C      21      I     VALUE PRINT SKIP  0,1,2,3---               *
C      22      I     SPARE                                     *
C      23      R     *
C      24      R      *
C      25      I       *
C      26      I        *  SAME AS  15 THRU 22
C      27      I        *  BUT FOR  Y-DIRECTION TICS
C      28      I       *
C      29      I      *
C      30      I     *
C      31      I     TOP EDGE TICS   **   EACH OF 31 THRU 34 MAY BE
C      32      I     BOTTOM EDGE TICS **  LESS THAN 0 -- TICS W/O VALUES
C      33      I     LEFT EDGE TICS   **  EQUAL TO  0 -- NO TICS HERE
C      34      I     RIGHT EDGE TICS **   GREATER   0 -- TICS W VALUES
C
C      35      I     0 -- X-DIRECTION IS LINEAR
C                    GREATER THAN 0 - NUMBR OF CYCLES AND X-DIREC IS LOG
C      36      I     0 -- Y-DIRECTION IS LINEAR
C                    GREATER THAN 0 - NUMBR OF CYCLES AND Y-DIREC IS LOG
C      37      I     0 -- NO X-AXIS
C                    1 -- DRAW X-AXIS
C
C      38      R     X-AXIS  Y-INTERCEPT
C
C      39      I     0 -- NO Y-AXIS
C                    1 -- DRAW Y-AXIS
C
C      40      R     Y-AXIS  X-INTERCEPT
C
C      41      I     LESS THAN 0 ----- PLOT SYMBOL FOR EACH CURVE POINT.
C                                      SELECT SYMBOL CORRESPONDING TO
C                                      CURVE NUMBER IN IDOUT(3)
C                    EQUAL TO  0 ----- CONNECT POINTS BY LINES WHERE
C                                      POINTS ARE CONTINUOUS I.E.(NO
C                                      INTEGER 1 PAIRS)
C                    GREATER THAN 0 -- DO BOTH OF ABOVE
C
C      42
C       .
C       .
C      50
C      51     BCD    TITLE(32)
C       .     BCD    SUBTITLE(32)
C       .     BCD    LABEL(32)
C       .     BCD    CURVE TITLE(32)
C       .     BCD    X-AXIS TITLE(32)
C     242     BCD    Y-AXIS TITLE(32)
C     243      I     XGRID LINES   0=NO   1=YES
C     244      I     YGRID LINES   0=NO   1=YES
C     245      I     TYPE OF PLOT  1=RESPONSE, 2=PSDF, 3=AUTO
C     246      I     STEPS
C       .
C       .
C     281      I     PAPLOT FRAME NUMBER
C     282      R     CSCALE (REAL NUMBER)
C     283      I     PENSIZE OR DENSITY
C     284      I     PLOTTER (LSHIFT 16) AND MODEL NUMBER.
C     285      R     INCHES PAPER X-DIRECTION
C     286      R     INCHES PAPER Y-DIRECTION
C     287      I     CAMERA FOR SC4020 LESS THAN 0=35MM, 0=F80,
C                                        GREATER 0=BOTH
C     288      I     PRINT FLAG  **
C     289      I     PLOT  FLAG  ** 0=NO, +=YES (PLOT- 2=BOTH, -1=PAPLT)
C     290      I     PUNCH FLAG  **
C     291      R     X-MIN OF ALL DATA
C     292      R     X-MAX OF ALL DATA
C     293      R     Y-MIN WITHIN X-LIMITS OF FRAME
C     294      R     X-VALUE AT THIS Y-MIN
C     295      R     Y-MAX WITHIN X-LIMITS OF FRAME
C     296      R     X-VALUE AT THIS Y-MAX
C     297      R     Y-MIN FOR ALL DATA
C     298      R     X-VALUE AT THIS Y-MIN
C     299      R     Y-MAX FOR ALL DATA
C     300      R     X-VALUE AT THIS Y-MAX
C     ==================================================================
C
C     SAVE OUTPUT HEADING
C
      DO 10 I = 1,96
   10 HEADSV(I) = IHEAD(I)
C
C     ALLOCATE CORE AND OPEN DATA BLOCKS
C
      OOMPP = .FALSE.
      VGP   = .FALSE.
      OOMCP = .FALSE.
      RANDOM= .FALSE.
      IFLE  = XYCDB
      CORE  = KORSZ(Z) - 1
      DO 20 I = 1,32
      TCURVE(I) = BLANK
      XAXIS(I)  = BLANK
      YAXIS(I)  = BLANK
      YTAXIS(I) = BLANK
      YBAXIS(I) = BLANK
   20 CONTINUE
      DO 30 I = 1,5
   30 SUBC(I) = 1
      NSUBS  = 0
      CORE   = CORE - SYSBUF
      IF (CORE .LT. 0) GO TO 825
      INTRWD = INPRWD
      IF (INTR .LE. 0) GO TO 35
      INTRWD = OUTRWD
      XYCDB  = 301
   35 CALL OPEN (*835,XYCDB,Z(CORE+1),INTRWD)
      IF (INTR .LE. 0) GO TO 65
      CARD = 1
      WRITE (L,900)
   40 DO 42 IJ = 1,20
   42 XYCARD(IJ) = BLANK
      CALL XREAD (*43,XYCARD)
      IF (XYCARD(1) .EQ. STOP) GO TO 1500
      IF (XYCARD(1) .EQ.   GO) CARD = -1
      CALL IFP1XY (CARD,XYCARD)
      IF (XYCARD(1) .EQ. GO) GO TO 50
      CARD = 0
      IF (NOGO .EQ. 0) GO TO 45
      NOGO = 0
   43 WRITE (L,902)
   45 WRITE (L,910) XYCARD
      GO TO 40
   50 CALL CLOSE (XYCDB,REWD)
      IF (INTR .GT. 10) L = 1
      CALL OPEN (*835,XYCDB,Z(CORE+1),INPRWD)
   65 IF (INTR .LE. 0) CALL FWDREC (*80,XYCDB)
      OUTOPN = .FALSE.
      IF (BLKCOM .EQ. RAND) RANDOM = .TRUE.
      IF (BLKCOM .EQ.   VG) VGP = .TRUE.
      IF (BLKCOM .EQ.   VG) NAMEV(5) = NAMEVG
C
      CORE = CORE - SYSBUF
      DO 70 I = 1,5
      OPENF(I) = -1
      IF (CORE .LT. 0) GO TO 235
C
      CALL OPEN (*70,INDB(I),Z(CORE),INPRWD)
      OPENF(I) = 0
      VECID(I) = 0
      CORE = CORE - SYSBUF
   70 CONTINUE
C
      CORE = CORE + SYSBUF - 1
C
C     NOTE - OUTPUT DATA BLOCKS WILL BE OPENED WHEN AND IF REQUIRED
C
C
C
C     READ FIRST BCD WORD FROM -XYCDB- THEN GO INITIALIZE DATA
C
      BCD = CLEA
      GO TO 800
   80 IER = 2
      GO TO 237
   90 IER = 3
      GO TO 237
C
C     BRANCH ON BCD WORD
C
  100 IF (BCD .EQ. XY  ) GO TO 230
      IF (BCD .EQ. TCUR) GO TO 180
      IF (BCD .EQ. XAXI) GO TO 190
      IF (BCD .EQ. YAXI) GO TO 200
      IF (BCD .EQ. YTAX) GO TO 210
      IF (BCD .EQ. YBAX) GO TO 220
C
C     SET SINGLE VALUE FLAGS. READ IN VALUE
C
      IF (BCD .EQ. CLEA) GO TO 150
      IF (BCD .EQ. VDUM) GO TO 820
      CALL READ (*80,*90,XYCDB,IVAL,1,NOEOR,FLAG)
      DO 110 I = 1,NWORDS
      IF (BCD .EQ. WORD(I)) GO TO 130
  110 CONTINUE
C
C     WORD NOT RECOGNIZED
C
      CALL PAGE2 (2)
      WRITE (L,120) UWM,BCD
      GO TO 140
C
C     KEY WORD FOUND
C
  130 IF (BCD .NE. WORD(58)) GO TO 135
      IVALUE(I) = IVAL
      CALL READ (*80,*90,XYCDB,IVAL,1,NOEOR,FLAG)
      IVALUE(I+1) = IVAL
      GO TO 140
  135 IVALUE(I) = IVAL
C
C     READ NEXT BCD WORD
C
  140 CALL READ (*80,*240,XYCDB,BCD,1,NOEOR,FLAG)
      GO TO 100
C
C     CLEAR ALL VALUES SET AND RESTORE DEFAULTS
C
  150 DO 160 I = 1,12
  160 IVALUE(I) = 1
      DO 170 I = 13,NWORDS
      IF (I .NE. 47) IVALUE(I) = 0
  170 CONTINUE
      DO 171 I = 25,32
  171 IVALUE(I) = 1
C
C     DEFAULT CAMERA TO BOTH
C
      IVALUE(46) = 3
      GO TO 140
C
C     SET TITLES
C
  180 CALL READ (*80,*90,XYCDB,TCURVE(1),32,NOEOR,FLAG)
      GO TO 140
  190 CALL READ (*80,*90,XYCDB,XAXIS(1),32,NOEOR,FLAG)
      GO TO 140
  200 CALL READ (*80,*90,XYCDB,YAXIS(1),32,NOEOR,FLAG)
      GO TO 140
  210 CALL READ (*80,*90,XYCDB,YTAXIS(1),32,NOEOR,FLAG)
      GO TO 140
  220 CALL READ (*80,*90,XYCDB,YBAXIS(1),32,NOEOR,FLAG)
      GO TO 140
C
C     XY-COMMAND OPERATIONS HIT
C
  230 CALL READ (*80,*90,XYCDB,BUF(1),7,NOEOR,FLAG)
      IF (BUF(6) .NE. 0) PAPLOT = .TRUE.
      IF (BUF(6) .NE. 0) OOMPP  = .TRUE.
      IF (BUF(2) .NE. 0) OOMCP  = .TRUE.
      IF (BUF(1) .NE. 0) PRINT  = .TRUE.
      IF (BUF(2) .NE. 0) PLOT   = .TRUE.
      KASKNT = 0
      IF (OUTOPN) GO TO 280
      IF (.NOT.PLOT .AND. .NOT.PAPLOT) GO TO 280
C
C     OPEN OUTPUT PLOT DATA BLOCK
C
      CORE = CORE - SYSBUF
      IF (CORE .GT. 0) GO TO 260
  235 IER = 8
      IFLE = -CORE
  237 CALL MESAGE (IER,IFLE,ROUTIN)
C
C     CLOSE ANY OPEN FILES AND RETURN
C
  240 CALL CLOSE (XYCDB,REWD)
      DO 250 I = 1,5
      CALL CLOSE (INDB(I),REWD)
  250 CONTINUE
      IF (.NOT.OUTOPN) RETURN
C
C     NO CAMERA PLOTS SO DONT WRITE TRAILER
C
      IF (.NOT. OOMCP) GO TO 255
      BUF(1) = OUTFIL
      BUF(2) = 9999999
      CALL WRTTRL (BUF(1))
  255 CALL CLOSE  (OUTFIL,REWD)
      GO TO 830
C
  260 CALL OPEN  (*270,OUTFIL,Z(CORE+1),OUTRWD)
      CALL FNAME (OUTFIL,NAME(1))
      CALL WRITE (OUTFIL,NAME(1),2,EOR)
      OUTOPN = .TRUE.
      GO TO 280
C
C     ERROR,  PLOTS REQUESTED AND OUTFIL PURGED.  DO ALL ELSE.
C
  270 CALL PAGE2 (2)
      WRITE (L,290) UWM,OUTFIL
      PLOT = .FALSE.
C
  280 IF (BUF(3) .NE. 0) PUNCH = .TRUE.
      TYPE   = BUF(4)
      VECTOR = BUF(5)
      NSUBS  = BUF(7)
      KNT    = 0
      IF (NSUBS .GT. 0) CALL READ (*80,*90,XYCDB,SUBCAS(1),NSUBS,NOEOR,
     1                             FLAG)
      IF (NSUBS .GT. 0) CALL SORT (0,0,1,1,SUBCAS(1),NSUBS)
      IF (RANDOM .AND. TYPE.NE.2 .AND. TYPE.NE.3) GO TO 380
      IF ((.NOT.RANDOM) .AND. (TYPE.EQ.2    .OR.  TYPE.EQ.3) ) GO TO 380
      IF ((.NOT.RANDOM) .AND. IPSET.EQ.PSET .AND. VECTOR.GT.7) GO TO 380
      IF ((.NOT.RANDOM) .AND. IPSET.NE.PSET .AND. VECTOR.LE.7) GO TO 380
C
C     INITIALIZE DATA BLOCK POINTERS FOR THIS VECTOR
C
      FILE = FILES(VECTOR)
C
C     CHECK FOR RANDOM
C
      IF (RANDOM .AND. TYPE.EQ.3) FILE = 2
      IF (RANDOM .AND. TYPE.EQ.2) FILE = 1
      IFILE = INDB(FILE)
      IF (OPENF(FILE)) 360,400,400
C
C     EOR HIT ON IFILE.  SHOULD NOT HAVE HAPPENED
C
  330 IER = 3
      GO TO 355
C
C     EOF HIT ON IFILE.  SHOULD NOT HAVE HAPPENED
C
  350 IER = 2
  355 CALL MESAGE (IER,IFILE,ROUTIN)
      OPENF(FILE) = -1
C
C     FILE IFILE IS NOT SATISFACTORY
C
  360 CALL FNAME (IFILE,BUF(1))
      CALL PAGE2 (3)
      WRITE (L,370) UWM,BUF(1),BUF(2),NAMEV(VECTOR)
C
C     SKIP OVER ANY AND ALL FRAME DATA FOR THIS CARD.
C
  380 CALL READ (*80,*240,XYCDB,BCD,1,NOEOR,FLAG)
      IF (BCD .NE. FRAM) GO TO 800
  390 CALL READ (*80,*90,XYCDB,BUF(1),3,NOEOR,FLAG)
      IF (BUF(1) .NE.-1) GO TO 390
      GO TO 380
C
C     CHECK TO SEE IF THIS FILES SUBCASE IS TO BE OUTPUT
C
  400 CONTINUE
      IF (OPENF(FILE)) 360,401,402
  401 CONTINUE
      CALL FWDREC (*350,IFILE)
      CALL READ (*350,*330,IFILE,IDIN(1),20,EOR,FLAG)
      CALL READ (*350,*403,IFILE,IDIN(1),-CORE,EOR,FLAG)
      GO TO 235
  403 CALL BCKREC (IFILE)
      CALL BCKREC (IFILE)
      SIZE  = FLAG/IDIN(10)
      KTYPE = (IDIN(2)/1000)*1000
      OPENF(FILE) = 1
  402 CONTINUE
      KASKNT = KASKNT + 1
      IF (NSUBS .EQ. 0) GO TO 415
      SUBC(FILE) = SUBCAS(KASKNT)
      GO TO 420
  415 SUBC(FILE) = 0
C
C     NOW READY TO PROCEED WITH DATA SELECTION
C
  420 CALL READ (*80,*240,XYCDB,BCD,1,NOEOR,FLAG)
      IF (BCD .NE. FRAM) GO TO 800
C
C     READ IN THE ID-COMP-COMP SETS AND SORT ON ID-S.
C
      KNT  = 0
      ITRY = 0
      IAT  = 0
  430 CALL READ (*80,*90,XYCDB,Z(IAT+1),3,NOEOR,FLAG)
      IF (Z(IAT+1) .EQ. -1) GO TO 440
      IAT  = IAT + 3
      GO TO 430
C
C     SORT ON ID-S
C
  440 CALL SORT (0,0,3,1,Z(1),IAT)
  450 ICORE = CORE - IAT
C
C     COMPUTE FINAL REGIONS
C
      NSLOTS= IAT/3
      NAT   = IAT
      IF (Z(I3).GT.0 .AND. .NOT.RANDOM) NSLOTS = NSLOTS + NSLOTS
  554 STEPS = SIZE
      IF (.NOT.VGP) GO TO 559
      ITEMP = 0
      NUQ   = 0
      DO 555 I = 1,NAT,3
      IF (Z(I) .EQ. ITEMP) GO TO 555
      NUQ   = NUQ + 1
      ITEMP = Z(I)
  555 CONTINUE
      STEPS = STEPS*NUQ
C
C     SET CORE TO 1
C
      J = IAT + 1
      N = J + MIN0(ICORE,(NSLOTS+1)*STEPS)
      DO 556 I = J,N
  556 Z(I) = 1
  559 CONTINUE
      IF (STEPS*(NSLOTS+1) .LE. ICORE) GO TO 580
      CALL PAGE2 (4)
      WRITE (L,570) UWM,Z(IAT-2),Z(IAT-1),Z(IAT)
      ICRQ = STEPS*(NSLOTS+1) - ICORE
      WRITE (L,571) ICRQ
      NSLOTS = NSLOTS - 1
      IF (Z(I3).GT.0 .AND. .NOT.RANDOM) NSLOTS = NSLOTS - 1
      NAT = NAT - 3
      IF (NSLOTS .GT. 0) GO TO 554
      GO TO 420
  580 NTOPS = NSLOTS/2
      NBOTS = NTOPS
      IF (Z(I3).GT.0 .AND. .NOT.RANDOM) GO TO 590
      NTOPS = NSLOTS
      NBOTS = 0
  590 CONTINUE
      CENTER = IAT + NTOPS*STEPS
C
C     GET CURVE DATA
C
      MAJOR = KTYPE + MAJID(VECTOR)
      I2    = 0
      IFCRV =-1
      ISTSV = 0
      IDTOT = NAT/3
C
C     I1 = 1-ST ROW OF NEXT ID
C     I2 = LAST ROW OF NEXT ID
C
  630 I1   = I2 + 1
      NBEG = 3*I1 - 3
      IF (NBEG .GE. NAT) GO TO 780
      IDZ = NBEG + 1
      ID  = Z(IDZ)
      I2  = I1
  640 IF (I2.GE.IDTOT .OR. RANDOM) GO TO 650
      IF (Z(3*I2+1) .NE. ID) GO TO 650
      I2  = I2 + 1
      GO TO 640
C
C     FIND THIS ID ON IFILE
C
  650 CALL XYFIND (*350,*330,*660,MAJID(1),IDZ)
      KNT = -1
      IF (ITRY.EQ.0 .AND. SUBC(FILE).EQ.-1) GO TO 661
C
C     THIS IS THE WAY OUT FOR ALL SUBCASE REQUEST
C
      IF (ITRY.NE.0 .AND. SUBC(FILE).EQ.-1) GO TO 415
      KTYPE = (IDIN(2)/1000)*1000
      IF (KTYPE.EQ.2000 .OR. KTYPE.EQ.3000) GO TO 690
      CALL PAGE2 (2)
      WRITE (L,310) UWM
      GO TO 360
C
C     ID NOT FOUND. PRINT MESSAGE AND SHRINK LIST.
C
C
C     SUBCASE REQUEST EITHER SUBCASE NOT FOUND OR POINT NOT FOUND
C
  660 IF (KNT .EQ. -1) IDZ = -1
      IF (IDZ .NE. -1) GO TO 784
      CALL PAGE2 (3)
      WRITE (L,530) UWM,ID,NAMEV(VECTOR),IFILE
      WRITE (L,635) SUBC(FILE)
      KNT = 0
      IF (NAT/3.LE.I2 .AND. I1.EQ.1) GO TO 784
      GO TO 666
C
C     NSUBS = 0 AND POINT NOT FOUND START FRAME OVER
C
  661 CALL PAGE2 (3)
      WRITE (L,530) UWM,ID,NAMEV(VECTOR),IFILE
      CALL REWIND (IFILE)
      SUBC(FILE) = 0
      KNT = 0
      IF (NAT/3 .GT. I2) GO TO 666
      IF (I1    .EQ.  1) GO TO 415
  666 CONTINUE
      I13 = 3*I1 - 3
      I23 = 3*I2 + 1
      IF (I23 .GE. NAT) GO TO 680
      DO 670 I = I23,NAT
      I13 = I13 + 1
  670 Z(I13) = Z(I)
  680 IDTOT = IDTOT - (I2-I1) - 1
      I2  = I1 - 1
      NAT = I13
      IF (IDZ.EQ.-1 .AND. I1.NE.1 .AND. .NOT.VGP) GO TO 630
      IAT = NAT
      GO TO 450
C
C     ID FOUND. READ DATA AND DISTRIBUTE INTO SLOTS.
C
  690 NWDS  = IDIN(10)
      ISTEP = 0
      IFCRV = IFCRV + 1
      IF (VGP) ISTEP = ISTSV
  700 CALL READ (*350,*630,IFILE,BUF(1),NWDS,NOEOR,FLAG)
      ISTEP = ISTEP + 1
      IF (ISTEP .GT. STEPS) GO TO 700
      ITEMP = IAT + ISTEP
      ISTSV = ISTEP
      IF (.NOT.VGP) GO TO 709
      IF (IFCRV .EQ. 0) GO TO 709
C
C     SORT X AND MOVE Y TO PROPER SLOTS
C
      IF (RBUF(1) .GE. RZ(ITEMP-1)) GO TO 709
      N = ISTEP - 1
      DO 706 I = 1,N
      IF (RBUF(1) .LT. RZ(IAT+I)) GO TO 707
  706 CONTINUE
      GO TO 709
  707 ISTEP = I
      J  = ISTEP
      ITEMP = IAT + ISTEP
      N  = NSLOTS + 1
      JJ = ISTSV  - 1
      DO 708 I = 1,N
      ITEM  = IAT + (I-1)*STEPS + J
      TEMP1 = RZ(ITEM)
      Z(ITEM) = 1
      DO 708 IJ = J,JJ
      ITEM = IAT + (I-1)*STEPS + IJ + 1
      TEMP = RZ(ITEM)
      RZ(ITEM) = TEMP1
      TEMP1 = TEMP
  708 CONTINUE
  709 RZ(ITEMP) = RBUF(1)
C
C     DISTRIBUTE DATA
C
      DO 770 I = I1,I2
      PLACE = I*STEPS + ISTEP
C
C     TOP CURVE
C
      COMP = Z(3*I-1)
C
C     SET MEAN RESPONSE IF RANDOM
C
      IF (RANDOM) Z(3*I) = IDIN(8)
C
C     SET NUMBER OF ZERO CROSSINGS IF RANDOM
C
      IF (RANDOM) BUF(I+20) = IDIN(9)
      IF (COMP .EQ. 1000) GO TO 745
      IF (COMP .EQ.    0) GO TO 770
      IF (RANDOM) COMP = 2
      IF (COMP .LE. NWDS) GO TO 740
      Z(3*I-1) = 0
      CALL PAGE2 (2)
      WRITE (L,730) UWM,COMP,ID
      GO TO 750
C
  740 ITEMP = IAT + PLACE
      Z(ITEMP) = BUF(COMP)
      GO TO 750
  745 ITEMP = IAT + PLACE
      Z(ITEMP) = 1
C
C     BOTTOM CURVE IF DOUBLE FRAME
C
  750 IF (RANDOM) GO TO 770
      COMP = Z(3*I)
      IF (COMP .EQ. 1000) GO TO 765
      IF (COMP .EQ.    0) GO TO 770
      IF (COMP .LE. NWDS) GO TO 760
      Z(3*I) = 0
      CALL PAGE2 (2)
      WRITE (L,730) UWM,COMP,ID
      GO TO 770
C
  760 ITEMP = CENTER + PLACE
      Z(ITEMP) = BUF(COMP)
      GO TO 770
  765 ITEMP = CENTER + PLACE
      Z(ITEMP) = 1
  770 CONTINUE
      ISTEP = ISTSV
      GO TO 700
C
C     ALL DATA IS NOW IN SLOTS. INTEGER 1-S REMAIN IN VACANT SLOTS.
C
  780 IF (NSUBS .NE. 0) GO TO 783
      SUBC(FILE) = IDIN(4)
  783 CONTINUE
      CALL XYDUMP (OUTFIL,TYPE)
      KNT = 1
      IF (NSUBS .NE. 0) GO TO 784
      SUBC(FILE) = 0
      ITRY = ITRY + 1
      GO TO 450
  784 CONTINUE
      IF (KASKNT .LT. NSUBS) GO TO 785
      KASKNT = 0
      GO TO 402
  785 KASKNT = KASKNT + 1
      SUBC(FILE) = SUBCAS(KASKNT)
      DO 786 I = 1,5
  786 VECID(I) = 0
      GO TO 450
C
C     INITIALIZE PARAMETERS
C
  800 PLOT  = .FALSE.
      PUNCH = .FALSE.
      PRINT = .FALSE.
      PAPLOT= .FALSE.
      DO 805 I = 1,5
  805 VECID(I) = 0
      GO TO 100
C
C     VALUE DUMP
C
  820 CONTINUE
      GO TO 140
C
C     INTERACTIVE STOP INITIATED HERE.
C
 1500 NOGO = 1
      RETURN
C
C     INSUFFICIENT CORE
C
  825 CALL MESAGE (8,-CORE,ROUTIN)
C
C     CALL THE PRINTER-PLOTTER IF ANY REQUESTS FOR PRINTER-PLOTTER
C
  830 IF (OOMPP) CALL XYPRPL
C
C     RESTORE OUTPUT HEADING AND RETURN
C
  835 DO 840 I = 1,96
  840 IHEAD(I) = HEADSV(I)
      RETURN
C
C
  120 FORMAT (A25,' 975, XYTRAN DOES NOT RECOGNIZE ',A4,
     1       ' AND IS IGNORING')
  290 FORMAT (A25,' 976, OUTPUT DATA BLOCK',I4,' IS PURGED.',
     1       '  XYTRAN WILL PROCESS ALL REQUESTS OTHER THAN PLOT')
  310 FORMAT (A25,' 977, FOLLOWING NAMED DATA-BLOCK IS NOT IN SORT-II',
     1       ' FORMAT')
  370 FORMAT (A25,' 978', /5X,'XYTRAN MODULE FINDS DATA-BLOCK(',2A4,
     1       ') PURGED, NULL, OR INADEQUATE, AND IS IGNORING XY-OUTPUT',
     2       ' REQUEST FOR -',A4,'- CURVES')
  530 FORMAT (A25,' 979, AN XY-OUTPUT REQUEST FOR POINT OR ELEMENT ID',
     1       I10, /5X,1H-,A4,'- CURVE IS BEING PASSED OVER.  THE ID ',
     2       'COULD NOT BE FOUND IN DATA BLOCK',I10)
  570 FORMAT (A25,' 980, INSUFFICIENT CORE TO HANDLE ALL DATA FOR ALL ',
     1       'CURVES OF THIS FRAME', /5X,' ID =',I10,2(' COMPONENT =',
     2       I4,5X),' DELETED FROM OUTPUT')
  571 FORMAT (5X,'ADDITIONAL CORE NEEDED =',I9,' WORDS.')
  635 FORMAT (5X,'SUBCASE',I10 )
  730 FORMAT (A25,' 981, COMPONENT =',I10,' FOR ID =',I10,
     1       ' IS TOO LARGE. THIS COMPONENTS CURVE NOT OUTPUT')
C
  900 FORMAT ('  ENTER XYPLOT DEFINITION OR GO TO PLOT OR STOP TO EXIT')
  902 FORMAT ('  BAD CARD TRY AGAIN')
  910 FORMAT (20A4)
      END

      SUBROUTINE STRAX2 (SORC,TI)
C
C     THIS ROUTINE IS PHASE II OF STRESS DATA FOR THE TRIANGULAR
C     CROSS SECTION RING
C
C     OUTPUTS FROM PHASE I ARE THE FOLLOWING -
C     IDEL IGP(3) TZ SEL(54) TS(4) AK(81) PHI(14)
C     AKUPH(27) AKPH2(9) SELP1(18) SELP2(27) SELP3(9)
C
C     ANY GROUP OF STATEMENTS PREFACED BY AN IF STATEMENT CONTAINING
C     ...KSYS78 OR LSYS78 ...  INDICATES CODING NECESSARY FOR THIS
C     ELEMENT*S PIEZOELECTRIC CAPABILITY
C
C     KSYS78 = 0   ELASTIC, NON-PIEZOELECTRIC MATERIAL
C     KSYS78 = 1   ELECTRICAL-ELASTIC COUPLED, PIEZOELETRIC MATERIAL
C     KSYS78 = 2   ELASTIC ONLY, PIEZOELECTRIC MATERIAL
C     LSYS78 = .TRUE. IF KSYS78 = 0, OR 2
C
      LOGICAL         ZERO,ZERON,LSYS78
      INTEGER         SORC,IBLOCK(22,14),ISTRES(100),IFORCE(25),ELEMID,
     1                ICLOCK(22,14)
      REAL            NPHI
      DIMENSION       TI(3),DUM3(225),STRES(100),FORCE(25),AKUPH(27),
     1                AKPH2(9),SELP1(18),SELP2(27),SELP3(9),D3(3),D6(6),
     2                D9(9),DISPP(3),ECHRG(3),EFLUX(3)
C
C     SDR2 VARIABLE CORE
C
      COMMON /ZZZZZZ/ ZZ(1)
C
C     SDR2 BLOCK FOR POINTERS AND LOADING  TEMPERATURES
C
      COMMON /SDR2X4/ DUM1(33),ICSTM,NCSTM,IVEC,IVECN,TEMPLD,ELDEFM,
     1                DUM4(12),KTYPE
C
C     SCRATCH BLOCK
C
      COMMON /SDR2X8/ DISP(9),EFORC(9),ESTRES(9),HARM,N,SINPHI,CONPHI,
     1                NPHI,NANGLE,ELEMID,UNU(123),NELHAR
C
C     SDR2 INPUT AND OUTPUT BLOCK
C
      COMMON /SDR2X7/ IDEL,IGP(3),TZ,SEL(54),TS(6),AK(81),PHI(14),
     1                DUM2(90),BLOCK(22,14),CLOCK(22,14)
C
      COMMON /SDR2DE/ DUM5(33), IPART
      COMMON /CONDAS/ CONSTS(5)
      COMMON /SYSTEM/ KSYSTM(77),KSYS78
      EQUIVALENCE     (IBLOCK(1,1),BLOCK(1,1)),(ICLOCK(1,1),CLOCK(1,1)),
     1                (DUM3(1),IDEL),(LDTEMP,TEMPLD),
     2                (DUM3(109),STRES(9),ISTRES(9),EFLUX(1)),
     3                (DUM3(201),FORCE(1),IFORCE(1)),
     4                (DUM2(1),SELP1(1)),(DUM2(19),AKPH2(1)),
     5                (DUM2(28),AKUPH(1)),(DUM2(55),SELP2(1)),
     6                (DUM2(82),SELP3(1)),(CONSTS(4),DEGRAD),
     7                (UNU(1),D3(1)),(UNU(4),D6(1)),(UNU(10),D9(1))
      DATA    ZERON / .FALSE. /
      DATA    IOSORC/ 0       /
C
      LSYS78 = .FALSE.
      IF (KSYS78.EQ.0 .OR. KSYS78.EQ.2) LSYS78 = .TRUE.
C
      ELEMID = IDEL/1000
      NELHAR = IDEL - ELEMID*1000
C
C     SET BLOCK = 0 IF HARMONIC = 0
C
      N = NELHAR - 1
      IF (N .NE. 0) GO TO 21
      IF (N.EQ.0 .AND. ZERON .AND. IOSORC .NE. SORC) GO TO 14
      ZERON  = .TRUE.
      IOSORC = SORC
      DO 15 I = 2,22
      DO 15 J = 1,14
      IF (KTYPE.NE.2 .OR. IPART.NE.2) BLOCK(I,J) = 0.0
      CLOCK(I,J) = 0.0
   15 CONTINUE
C
C     SET ANGLES CONTROL FOR SUMMATION
C
      ZERO = .FALSE.
      J = 0
      DO 16 I = 1,14
      IF (PHI(I)) 17,18,17
   18 IF (ZERO) GO TO 16
      ZERO = .TRUE.
   17 J = J + 1
      BLOCK(1,J) = PHI(I)
      CLOCK(1,J) = PHI(I)
   16 CONTINUE
      J = J + 1
      IF (J .GT. 14) GO TO 21
      IBLOCK(1,J) = 1
      ICLOCK(1,J) = 1
      GO TO 21
   14 ZERON = .FALSE.
   21 HARM  = N
C
C     INITIALIZE LOCAT VARIABLES
C
      NDOF  = 3
      NUMPT = 3
      N     = NDOF*NUMPT
      NSP   = 1
      NCOMP = 6
      NS    = NSP*NCOMP
C
C     FIND GRID POINTS DISPLACEMENTS
C
      K = 0
      DO 100 I = 1,NUMPT
      ILOC = IVEC + IGP(I) - 2
C
      IF (LSYS78) GO TO 90
      ILOCP = ILOC + 4
      DISPP(I) = ZZ(ILOCP)
   90 CONTINUE
      DO 100 J = 1,NDOF
      ILOC = ILOC + 1
      K    = K + 1
      DISP(K) = ZZ(ILOC)
  100 CONTINUE
C
C     COMPUTE THE GRID POINT FORCES
C
      CALL GMMATS (AK(1),N,N,0, DISP(1),N,1,0, EFORC(1))
C
      DO 109 I = 1,3
  109 ECHRG(I) = 0.0
C
      IF (LSYS78) GO TO 125
      CALL GMMATS (AKUPH(1),N,NUMPT,0, DISPP(1),NUMPT,1,0, D9(1))
      DO 110 I = 1,9
  110 EFORC(I) = EFORC(I) + D9(I)
C
      CALL GMMATS (AKUPH(1),N,NUMPT,1, DISP(1),N,1,0, D3(1))
      CALL GMMATS (AKPH2(1),NUMPT,NUMPT,0, DISPP(1),NUMPT,1,0, ECHRG(1))
      DO 120 I = 1,3
  120 ECHRG(I) = ECHRG(I) + D3(I)
C
C     COMPUTE THE STRESSES
C
  125 CALL GMMATS (SEL(1),NS,N,0, DISP(1),N,1,0, ESTRES(1))
C
      DO 129 I = 1,3
  129 EFLUX(I) = 0.0
C
      IF (LSYS78) GO TO 145
      CALL GMMATS (SELP1(1),NS,NUMPT,0, DISPP(1),NUMPT,1,0, D6(1))
      DO 130 I = 1,6
  130 ESTRES(I) = ESTRES(I) + D6(I)
C
      CALL GMMATS (SELP2(1),NUMPT,N,0, DISP(1),N,1,0, EFLUX(1))
      CALL GMMATS (SELP3(1),NUMPT,NUMPT,0, DISPP(1),NUMPT,1,0, D3(1))
C
      DO 140 I = 1,3
  140 EFLUX(I) = EFLUX(I) + D3(I)
C
C     COMPUTE THERMAL STRESS IF IT IS EXISTS
C
  145 IF (LDTEMP .EQ. -1) GO TO 300
      DT = TZ
      IF (HARM .GT. 0.0) DT = 0.0
      DT = (TI(1)+TI(2)+TI(3))/3.0 - DT
      DO 200 I = 1,NS
      ESTRES(I) = ESTRES(I) - DT*TS(I)
  200 CONTINUE
C
C     BRANCH TO INSERT HARMONIC STRESSES AND FORCES INTO BLOCK OR CLOCK
C
C     KTYPE = 1 - REAL OUTPUT, STORED IN BLOCK, NOTHING IN CLOCK
C     KTYPE = 2 - COMPLEX OUTPUT
C     IPART = 1 - IMAGINARY PART OF COMPLEX OUTPUT, STORED IN BLOCK
C     IPART = 2 - REAL PART OF COMPLEX OUTPUT, STORED IN CLOCK
C
  300 IF (KTYPE.EQ.2 .AND. IPART.EQ.2) GO TO 505
C
C     INSERT HARMONIC STRESSES AND FORCES INTO BLOCK
C
      DO 380 I = 1,14
      IF (IBLOCK(1,I) .EQ. 1) GO TO 390
      IF (HARM .NE. 0.0) GO TO 330
      DO 310 IWA = 1,6
      BLOCK(IWA+1,I) = ESTRES(IWA)
      BLOCK(IWA+7,I) = EFORC (IWA)
  310 CONTINUE
      BLOCK(14,I) = EFORC(7)
      BLOCK(15,I) = EFORC(8)
      BLOCK(16,I) = EFORC(9)
C
      IF (LSYS78) GO TO 320
      BLOCK(17,I) = EFLUX(1)
      BLOCK(18,I) = EFLUX(2)
      BLOCK(19,I) = EFLUX(3)
      BLOCK(20,I) = ECHRG(1)
      BLOCK(21,I) = ECHRG(2)
      BLOCK(22,I) = ECHRG(3)
  320 CONTINUE
      GO TO 380
  330 CONTINUE
      NPHI   = HARM*BLOCK(1,I)*DEGRAD
      SINPHI = SIN(NPHI)
      CONPHI = COS(NPHI)
C
      GO TO (360,340), SORC
C
  340 BLOCK( 2,I) = BLOCK( 2,I) + CONPHI*ESTRES(1)
      BLOCK( 3,I) = BLOCK( 3,I) + CONPHI*ESTRES(2)
      BLOCK( 4,I) = BLOCK( 4,I) + CONPHI*ESTRES(3)
      BLOCK( 5,I) = BLOCK( 5,I) + CONPHI*ESTRES(4)
      BLOCK( 6,I) = BLOCK( 6,I) + SINPHI*ESTRES(5)
      BLOCK( 7,I) = BLOCK( 7,I) + SINPHI*ESTRES(6)
      BLOCK( 8,I) = BLOCK( 8,I) + CONPHI*EFORC(1)
      BLOCK( 9,I) = BLOCK( 9,I) + SINPHI*EFORC(2)
      BLOCK(10,I) = BLOCK(10,I) + CONPHI*EFORC(3)
      BLOCK(11,I) = BLOCK(11,I) + CONPHI*EFORC(4)
      BLOCK(12,I) = BLOCK(12,I) + SINPHI*EFORC(5)
      BLOCK(13,I) = BLOCK(13,I) + CONPHI*EFORC(6)
      BLOCK(14,I) = BLOCK(14,I) + CONPHI*EFORC(7)
      BLOCK(15,I) = BLOCK(15,I) + SINPHI*EFORC(8)
      BLOCK(16,I) = BLOCK(16,I) + CONPHI*EFORC(9)
      IF (LSYS78) GO TO 350
      BLOCK(17,I) = BLOCK(17,I) + CONPHI*EFLUX(1)
      BLOCK(18,I) = BLOCK(18,I) + CONPHI*EFLUX(2)
      BLOCK(19,I) = BLOCK(19,I) + SINPHI*EFLUX(3)
      BLOCK(20,I) = BLOCK(20,I) + CONPHI*ECHRG(1)
      BLOCK(21,I) = BLOCK(21,I) + CONPHI*ECHRG(2)
      BLOCK(22,I) = BLOCK(22,I) + CONPHI*ECHRG(3)
  350 CONTINUE
      GO TO 380
  360 BLOCK( 2,I) = BLOCK( 2,I) + SINPHI*ESTRES(1)
      BLOCK( 3,I) = BLOCK( 3,I) + SINPHI*ESTRES(2)
      BLOCK( 4,I) = BLOCK( 4,I) + SINPHI*ESTRES(3)
      BLOCK( 5,I) = BLOCK( 5,I) + SINPHI*ESTRES(4)
      BLOCK( 6,I) = BLOCK( 6,I) - CONPHI*ESTRES(5)
      BLOCK( 7,I) = BLOCK( 7,I) - CONPHI*ESTRES(6)
      BLOCK( 8,I) = BLOCK( 8,I) + SINPHI*EFORC(1)
      BLOCK( 9,I) = BLOCK( 9,I) - CONPHI*EFORC(2)
      BLOCK(10,I) = BLOCK(10,I) + SINPHI*EFORC(3)
      BLOCK(11,I) = BLOCK(11,I) + SINPHI*EFORC(4)
      BLOCK(12,I) = BLOCK(12,I) - CONPHI*EFORC(5)
      BLOCK(13,I) = BLOCK(13,I) + SINPHI*EFORC(6)
      BLOCK(14,I) = BLOCK(14,I) + SINPHI*EFORC(7)
      BLOCK(15,I) = BLOCK(15,I) - CONPHI*EFORC(8)
      BLOCK(16,I) = BLOCK(16,I) - SINPHI*EFORC(9)
      IF (LSYS78) GO TO 370
      BLOCK(17,I) = BLOCK(17,I) + SINPHI*EFLUX(1)
      BLOCK(18,I) = BLOCK(18,I) + SINPHI*EFLUX(2)
      BLOCK(19,I) = BLOCK(19,I) - CONPHI*EFLUX(3)
      BLOCK(20,I) = BLOCK(20,I) + SINPHI*ECHRG(1)
      BLOCK(21,I) = BLOCK(21,I) + SINPHI*ECHRG(2)
      BLOCK(22,I) = BLOCK(22,I) + SINPHI*ECHRG(3)
  370 CONTINUE
  380 CONTINUE
C
C     COPY STRESSES AND FORCES INTO OUTPUT BLOCKS
C     FLUXES ARE EQUIVALENCED INTO STRES(J)
C     CHARGES ARE WRITTEN INTO FORCE(J)
C
  390 J = 2
      ISTRES (1) = ELEMID
      ISTRES (2) = NELHAR
      DO 400 I = 1,NCOMP
      J = J + 1
      STRES(J) = ESTRES(I)
  400 CONTINUE
      K = 0
      J = 2
      IFORCE(1) = ELEMID
      IFORCE(2) = NELHAR
      DO 500 I  = 1,NUMPT
      DO 500 KK = 1,NDOF
      J = J + 1
      K = K + 1
      FORCE(J) = EFORC(K)
C
      IF (K.NE.3 .AND. K.NE.6 .AND. K.NE.9) GO TO 500
      J  = J + 1
      K3 = K/3
      FORCE(J) = ECHRG(K3)
  500 CONTINUE
C
      IF (KTYPE.EQ.1 .OR. (KTYPE.EQ.2 .AND. IPART.EQ.1)) GO TO 1000
C
C     INSERT HARMONIC STRESSES AND FORCES INTO CLOCK
C
  505 DO 580 I = 1,14
      IF (ICLOCK(1,I) .EQ. 1) GO TO 600
      IF (HARM .NE. 0.0) GO TO 530
      DO 510 IWA = 1,6
      CLOCK(IWA+1,I) = ESTRES(IWA)
      CLOCK(IWA+7,I) = EFORC (IWA)
  510 CONTINUE
      CLOCK(14,I) = EFORC(7)
      CLOCK(15,I) = EFORC(8)
      CLOCK(16,I) = EFORC(9)
C
      IF (LSYS78) GO TO 520
      CLOCK(17,I) = EFLUX(1)
      CLOCK(18,I) = EFLUX(2)
      CLOCK(19,I) = EFLUX(3)
      CLOCK(20,I) = ECHRG(1)
      CLOCK(21,I) = ECHRG(2)
      CLOCK(22,I) = ECHRG(3)
  520 CONTINUE
      GO TO 580
  530 CONTINUE
      NPHI   = HARM*CLOCK(1,I)*DEGRAD
      SINPHI = SIN(NPHI)
      CONPHI = COS(NPHI)
C
      GO TO (560,540), SORC
C
  540 CLOCK( 2,I) = CLOCK( 2,I) + CONPHI*ESTRES(1)
      CLOCK( 3,I) = CLOCK( 3,I) + CONPHI*ESTRES(2)
      CLOCK( 4,I) = CLOCK( 4,I) + CONPHI*ESTRES(3)
      CLOCK( 5,I) = CLOCK( 5,I) + CONPHI*ESTRES(4)
      CLOCK( 6,I) = CLOCK( 6,I) + SINPHI*ESTRES(5)
      CLOCK( 7,I) = CLOCK( 7,I) + SINPHI*ESTRES(6)
      CLOCK( 8,I) = CLOCK( 8,I) + CONPHI*EFORC(1)
      CLOCK( 9,I) = CLOCK( 9,I) + SINPHI*EFORC(2)
      CLOCK(10,I) = CLOCK(10,I) + CONPHI*EFORC(3)
      CLOCK(11,I) = CLOCK(11,I) + CONPHI*EFORC(4)
      CLOCK(12,I) = CLOCK(12,I) + SINPHI*EFORC(5)
      CLOCK(13,I) = CLOCK(13,I) + CONPHI*EFORC(6)
      CLOCK(14,I) = CLOCK(14,I) + CONPHI*EFORC(7)
      CLOCK(15,I) = CLOCK(15,I) + SINPHI*EFORC(8)
      CLOCK(16,I) = CLOCK(16,I) + CONPHI*EFORC(9)
C
      IF (LSYS78) GO TO 550
      CLOCK(17,I) = CLOCK(17,I) + CONPHI*EFLUX(1)
      CLOCK(18,I) = CLOCK(18,I) + CONPHI*EFLUX(2)
      CLOCK(19,I) = CLOCK(19,I) + SINPHI*EFLUX(3)
      CLOCK(20,I) = CLOCK(20,I) + CONPHI*ECHRG(1)
      CLOCK(21,I) = CLOCK(21,I) + CONPHI*ECHRG(2)
      CLOCK(22,I) = CLOCK(22,I) + CONPHI*ECHRG(3)
  550 CONTINUE
      GO TO 580
C
  560 CLOCK( 2,I) = CLOCK( 2,I) + SINPHI*ESTRES(1)
      CLOCK( 3,I) = CLOCK( 3,I) + SINPHI*ESTRES(2)
      CLOCK( 4,I) = CLOCK( 4,I) + SINPHI*ESTRES(3)
      CLOCK( 5,I) = CLOCK( 5,I) + SINPHI*ESTRES(4)
      CLOCK( 6,I) = CLOCK( 6,I) - CONPHI*ESTRES(5)
      CLOCK( 7,I) = CLOCK( 7,I) - CONPHI*ESTRES(6)
      CLOCK( 8,I) = CLOCK( 8,I) + SINPHI*EFORC(1)
      CLOCK( 9,I) = CLOCK( 9,I) - CONPHI*EFORC(2)
      CLOCK(10,I) = CLOCK(10,I) + SINPHI*EFORC(3)
      CLOCK(11,I) = CLOCK(11,I) + SINPHI*EFORC(4)
      CLOCK(12,I) = CLOCK(12,I) - CONPHI*EFORC(5)
      CLOCK(13,I) = CLOCK(13,I) + SINPHI*EFORC(6)
      CLOCK(14,I) = CLOCK(14,I) + SINPHI*EFORC(7)
      CLOCK(15,I) = CLOCK(15,I) - CONPHI*EFORC(8)
      CLOCK(16,I) = CLOCK(16,I) + SINPHI*EFORC(9)
      IF (LSYS78) GO TO 570
      CLOCK(17,I) = CLOCK(17,I) + SINPHI*EFLUX(1)
      CLOCK(18,I) = CLOCK(18,I) + SINPHI*EFLUX(2)
      CLOCK(19,I) = CLOCK(19,I) - CONPHI*EFLUX(3)
      CLOCK(20,I) = CLOCK(20,I) + SINPHI*ECHRG(1)
      CLOCK(21,I) = CLOCK(21,I) + SINPHI*ECHRG(2)
      CLOCK(22,I) = CLOCK(22,I) + SINPHI*ECHRG(3)
  570 CONTINUE
  580 CONTINUE
C
C     COPY STRESSES AND FORCES INTO OUTPUT BLOCKS
C     FLUXES ARE EQUIVALENCED INTO STRES(J)
C     CHARGES ARE WRITTEN INTO FORCE(J)
C
  600 J = 2
      ISTRES (1) = ELEMID
      ISTRES (2) = NELHAR
      DO 700 I = 1,NCOMP
      J = J + 1
      STRES(J) = ESTRES(I)
  700 CONTINUE
      K = 0
      J = 2
      IFORCE(1) = ELEMID
      IFORCE(2) = NELHAR
      DO 800 I  = 1,NUMPT
      DO 800 KK = 1,NDOF
      J = J + 1
      K = K + 1
      FORCE(J) = EFORC(K)
C
      IF (K.NE.3 .AND. K.NE.6 .AND. K.NE.9) GO TO 800
      J  = J + 1
      K3 = K/3
      FORCE(J) = ECHRG(K3)
  800 CONTINUE
C
 1000 RETURN
      END

      SUBROUTINE DFBS
C
C     FBS   L,U,B/X/V,Y,ISYM=0/V,Y,KSIGN=1/V,Y,IPREC=0/V,Y,ITYPE=0 $
C
C     ISYM  =  1  USE FBS
C           = -1  USE GFBS
C           =  0  CHOOSE WHICH BASED ON SUPPLIED INPUT
C     KSIGN =  1, SOLVE LUX= B
C             -1,       LUX=-B
C     IPREC = REQUESTED PRECISION - DEFAULT BASED ON INPUT OR SYSTEM(55)
C     ITYPE = REQUESTED TYPE OF X - DEFAULT IS LOGICAL CHOICE ON INPUT
C
C     REVISED  12/91 BY G.CHAN/UNISYS
C     FATAL ERROR IN FBS (NOT GFBS) IF INPUT MATRIX IS NOT A LOWER
C     TRIANGULAR FACTOR
C
      INTEGER         L,U,B,X,SBNM(2),DOSI(3),REFUS(3),OUTPT,SCR
      DIMENSION       ZZ(1)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25,SWM*27
      COMMON /XMSSG / UFM,UWM,UIM,SFM,SWM
      COMMON /BLANK / ISYM, KSIGN, IPREC, ITYPE
      COMMON /SYSTEM/ KSYSTM(65)
      COMMON /FBSX  / IL(7),IU(7),IB(7),IX(7),INX,IP1,IS1,ISCR
      COMMON /GFBSX / JL(7),JU(7),JB(7),JX(7),JNX,JP1,JS1
CZZ   COMMON /ZZDFB1/ Z(1)
      COMMON /ZZZZZZ/ Z(20000)
CZZ   COMMON /ZZDFB2/ ZZ(1)
      EQUIVALENCE     (ZZ(1),Z(1))
      EQUIVALENCE     (KSYSTM(55),KPREC),(KSYSTM(2),OUTPT)
      DATA    L, U, B, X, SCR   / 101,102,103,201,301 /
      DATA    SBNM  / 4HDFBS,1H /
      DATA    DOSI  / 4HSING, 4HDOUB, 4HMLTP/,  REFUS / 2*3H   ,3HREF/
C
C
      JU(1) = U
      CALL RDTRL (JU)
   10 IF (ISYM) 150,20,30
   20 ISYM  = -1
      IF (JU(1) .LT. 0) ISYM = 1
      GO TO 10
C
C     SET UP CALL TO FBS
C
   30 NOGO  = 0
      IL(1) = L
      CALL RDTRL (IL)
      IF (IL(1) .GT. 0) GO TO 40
      CALL MESAGE (30,198,L)
      NOGO  = 1
   40 CONTINUE
      IF (IL(4) .NE. 4) GO TO 100
      N     = IL(2)
      IB(1) = B
      CALL RDTRL (IB)
      IF (NOGO .EQ. 0) GO TO 50
      CALL MESAGE (-30,199,SBNM)
   50 CONTINUE
      INX   = KORSZ(Z)
      IPREC1= MAX0(IL(5),IB(5),IU(5))
      IF (IPREC1 .GT. 2) IPREC1 = IPREC1 - 2
      IF (IPREC1.LT.1 .OR. IPREC1.GT.2) IPREC1 = KPREC
      IF (IPREC.EQ.IPREC1 .OR. IPREC.EQ.0) GO TO 70
      IF (IPREC.LT.1 .OR. IPREC.GT.2) IPREC = 3
      WRITE  (OUTPT,60) SWM,DOSI(IPREC),REFUS(IPREC),SBNM,DOSI(IPREC1)
   60 FORMAT (A27,' 2163, REQUESTED ',A4,'LE PRECISION ',A3,' USED BY ',
     1        2A4,2H. ,A4,'LE PRECISION IS LOGICAL CHOICE')
      IF (IPREC .NE. 3) IPREC1 = IPREC
   70 IPREC = IPREC1
      IP1   = IPREC1
      IS1   = KSIGN
      LTYPE = IPREC1
      IF (IL(5).EQ.3 .OR. IL(5).EQ.4 .OR. IU(5).EQ.3 .OR. IU(5).EQ.4 .OR
CWKBR spr 93014  1   .IL(5).EQ.3 .OR. IL(5).EQ.4)  LTYPE = IPREC1 + 2
     1   .IB(5).EQ.3 .OR. IB(5).EQ.4)  LTYPE = IPREC1 + 2
      IF (ITYPE.EQ.0 .OR. ITYPE.EQ.LTYPE) GO TO 90
      JJ    = 1
      IF (ITYPE.LT.1 .OR. ITYPE.GT.4) JJ = 3
      WRITE  (OUTPT,80) SWM,ITYPE,REFUS(JJ),SBNM,LTYPE
   80 FORMAT (A27,' 2164, REQUESTED TYPE ',I4,2H, ,A3,' USED BY ',2A4,
     1       '. TYPE ',I4,' IS LOGICAL CHOICE.')
      IF (JJ .NE. 3) LTYPE = ITYPE
   90 ITYPE = LTYPE
      IX(5) = ITYPE
      IX(1) = X
      ISCR  = SCR
      CALL FBS (Z,Z)
      IX(3) = N
      IX(4) = 2
      IF (IX(3) .EQ. IX(2)) IX(4) = 1
      CALL WRTTRL (IX)
      GO TO 200
C
  100 CALL FNAME (IL(1),IL(2))
      WRITE  (OUTPT,110) IL(2),IL(3),IL(4)
  110 FORMAT ('0*** INPUT MATRIX ',2A4,' TO FBS MODULE IS NOT A LOWER ',
     1        'TRIANGULAR FACTOR.  FORM =',I4)
      CALL ERRTRC ('DFBS    ',110)
      GO TO 200
C
C     SET UP CALL TO GFBS
C
  150 JL(1) = L
      CALL RDTRL (JL)
      N     = JL(2)
      JB(1) = B
      CALL RDTRL (JB)
      JNX   = KORSZ(ZZ)
      IPREC1= MAX0(JL(5),JB(5),JU(5))
      IF (IPREC1 .GT. 2) IPREC1 = IPREC1 - 2
      IF (IPREC1.LT.1 .OR. IPREC1.GT.2) IPREC1 = KPREC
      IF (IPREC.EQ.IPREC1 .OR. IPREC.EQ.0) GO TO 160
      IF (IPREC.LT.1 .OR. IPREC.GT.2) IPREC = 3
      WRITE (OUTPT,60) SWM,DOSI(IPREC),REFUS(IPREC),SBNM,DOSI(IPREC1)
      IF (IPREC .NE. 3) IPREC1 = IPREC
  160 IPREC = IPREC1
      JP1   = IPREC1
      JS1   = KSIGN
      JX(1) = X
      LTYPE = IPREC1
      IF (JL(5).EQ.3 .OR. JL(5).EQ.4 .OR. JU(5).EQ.3 .OR. JU(5).EQ.4 .OR
     1   .JL(5).EQ.3 .OR. JL(5).EQ.4) LTYPE = IPREC1 + 2
      IF (ITYPE.EQ.0 .OR. ITYPE.EQ.LTYPE) GO TO 170
      JJ    = 1
      IF (ITYPE.LT.1 .OR. ITYPE.GT.4) JJ = 3
      WRITE (OUTPT,80) SWM,ITYPE,REFUS(JJ),SBNM,LTYPE
      IF (JJ .NE. 3) LTYPE = ITYPE
  170 ITYPE = LTYPE
      JX(5) = ITYPE
      CALL GFBS (ZZ,ZZ)
      JX(3) = N
      JX(4) = 2
      IF (JX(3) .EQ. JX(2)) JX(4) =  1
      CALL WRTTRL (JX)
C
  200 RETURN
      END

      SUBROUTINE IFP1XY (CARD,XYCARD)
C
C     THIS ROUTINE PROCESSES THE XRCARD IMAGES OF THE XY-PLOT CONTROL
C     CARDS AND CREATES THE -XYCDB- FILE WHICH IS OPENED AND CLOSED BY
C     THE CALLING ROUTINE.
C
C     THE ARGUMENT -CARD- IS = 1 ON THE FIRST CALL TO THIS ROUTINE
C                            = 0 ON OTHER CALLS WHEN AN IMAGE IS SENT
C                            =-1 ON LAST CALL AND NO IMAGE IS SENT
C
C     TWO RECORDS WILL BE FORMED BY THIS ROUTINE.
C     THE FIRST RECORD HAS XY-PLOT, XY-PRINT, AND XY-PUNCH DATA AND IS
C     USED BY THE XYTRAN MODULE.
C     THE SECOND RECORD IS A SORTED NX6 MATRIX STORED BY ROWS. EACH ROW
C     CONTAINS THE FOLLOWING.
C
C          1 - SUBCASE ID OR 0 INDICATING ALL.
C          2 - VECTOR CODE NUMBER E.G. DISP,STRESS,SPCF, ETC.
C          3 - POINT OR ELEMENT ID NUMBER.
C          4 - COMPONENT NUMBER.
C          5 - TYPE OF PLOT (1=RESP,2=AUTO,3=PSDF)
C          6 - DESTINATION CODE 1-7 (BIT1=PRINT,BIT2=PLOT,BIT3=PUNCH).
C              CODE 8 ADDED - BIT 4 PAPERPLOT
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        LSHIFT,RSHIFT,ANDF,ORF,COMPLF
      LOGICAL         CONTIN,SLASH,PAIRS,OFBCD,TAPBIT,XYCM,BIT64
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      DIMENSION       BUF(10),MODID(2),XYCARD(1),KWORD(3),RWORD(14),
     1                IWORD(26),BWORD(16),ICSE(400),INCARD(20),
     2                BUFF(150),SUBCAS(200),Z(1),COREY(771)
      COMMON /MACHIN/ MACH,IHALF
      COMMON /SYSTEM/ KSYSTM(21),ILINK,SKP63(63),INTR
      COMMON /IFP1A / DUM3(3),NWPC,DUMMY(11),A377
      COMMON /XIFP1 / BLANK,BIT64
C     COMMON /ZZIFP1/ ICSE(400),INCARD(20),BUFF(150),SUBCAS(200),Z(1)
      COMMON /ZZZZZZ/ COREX(1)
      COMMON /IFPX0 / LBD,LCC,BITS(1)
      EQUIVALENCE     (KSYSTM( 1),SYSBUF    ), (KSYSTM( 2),L      ),
     1                (KSYSTM( 3),NOGO      ), (KSYSTM( 9),NLPP   ),
     2                (KSYSTM(12),LINE      ), (KSYSTM(21),IRESRT ),
     3                (ICSE(1)   ,COREX(1   ), COREY(1)           ),
     4                (INCARD(1) ,COREY(401)), (BUFF(1),COREY(421)),
     5                (SUBCAS(1) ,COREY(571)), (Z(1)   ,COREY(771))
      DATA    NRWORD/ 14 /,  NIWORD / 26    /, NBWORD  / 16 /
      DATA    ILNK  / 4HNS01        /
      DATA    KWORD / 4HFILM, 4HPAPE, 4HBOTH/
      DATA    RWORD / 4HXMIN, 4HXMAX, 4HYMIN, 4HYMAX, 4HYTMI, 4HYTMA,
     1                4HYBMI, 4HYBMA, 4HYINT, 4HXINT, 4HYTIN, 4HYBIN,
     2                4HXPAP, 4HYPAP/
      DATA    IWORD / 4HXDIV, 4HYDIV, 4HYTDI, 4HYBDI, 4HXVAL, 4HYVAL,
     1                4HYTVA, 4HYBVA, 4HUPPE, 4HLOWE, 4HLEFT, 4HRIGH,
     2                4HTLEF, 4HTRIG, 4HBLEF, 4HBRIG, 4HALLE, 4HTALL,
     3                4HBALL, 4HCURV, 4HDENS, 4HCAME, 4HPENS, 4HSKIP,
     4                4HCSCA, 4HCOLO/
      DATA    BWORD / 4HXAXI, 4HYAXI, 4HXTAX, 4HXBAX, 4HXLOG, 4HYLOG,
     1                4HYTLO, 4HYBLO, 4HXGRI, 4HYGRI, 4HXTGR, 4HXBGR,
     2                4HPLOT, 4HYTGR, 4HYBGR, 4HLONG/
      DATA    CLEA  / 4HCLEA /,   YES   / 4HYES  /,   NO    / 4HNO   /,
     1        T1    / 4HT1   /,   R1    / 4HR1   /,   T1RM  / 4HT1RM /,
     2        T2    / 4HT2   /,   R2    / 4HR2   /,   T2RM  / 4HT2RM /,
     3        T3    / 4HT3   /,   R3    / 4HR3   /,   T3RM  / 4HT3RM /,
     4        T1IP  / 4HT1IP /,   R1RM  / 4HR1RM /,   R1IP  / 4HR1IP /,
     5        T2IP  / 4HT2IP /,   R2RM  / 4HR2RM /,   R2IP  / 4HR2IP /,
     6        T3IP  / 4HT3IP /,   R3RM  / 4HR3RM /,   R3IP  / 4HR3IP /,
     7        XYPL  / 4HXYPL /,   XYPU  / 4HXYPU /,   XYPR  / 4HXYPR /,
     8        SLAS  / 4H/    /,   THRU  / 4HTHRU /,   FRAM  / 4HFRAM /,
     9        XY    / 4HXY   /,   AUTO  / 4HAUTO /,   RESP  / 4HRESP /
      DATA    PSDF  / 4HPSDF /,   VDUM  / 4HVDUM /,   DISP  / 4HDISP /,
     1        VELO  / 4HVELO /,   SVEL  / 4HSVEL /,   ELST  / 4HELST /,
     2        ACCE  / 4HACCE /,   SPCF  / 4HSPCF /,   SACC  / 4HSACC /,
     3        OLOA  / 4HOLOA /,   LOAD  / 4HLOAD /,   STRE  / 4HSTRE /,
     4        NONL  / 4HNONL /,   SUBC  / 4HSUBC /,   FORC  / 4HFORC /,
     5        SDIS  / 4HSDIS /,   ELFO  / 4HELFO /,   XTIT  / 4HXTIT /,
     6        YTIT  / 4HYTIT /,   YTTI  / 4HYTTI /,   TCUR  / 4HTCUR /,
     7        YBTI  / 4HYBTI /,   XYPE  / 4HXYPE /,   VECT  / 4HVECT /,
     8        PLT1  / 4HPLT1 /,   PLT2  / 4HPLT2 /,   EOR   /  1     /,
     9        XYPA  / 4HXYPA /,   XYCM  / .FALSE./,   NOEOR /  0     /
      DATA    IDEN  / 4HDENS /,   IEQUAL/ 4H=    /,   OPAREN/ 4H(    /,
     1        FILE  / 4HXYCD /,   VG    / 2HVG   /,   IMODEL/ 4HMODE /,
     2        REAL  / -2     /,   INTE  / -1     /,   CONT  / 0      /,
     3        G     / 1HG    /,   F     / 1HF    /
C
      BITWRD = LBD + 1
      N = 1
      IF (INTR.LE.1 .AND. ILINK.EQ.ILNK) GO TO 5
      INCARD(1) = XYCARD(1)
      CALL XRCARD (BUFF,149,XYCARD)
      BUFF(150) = RSHIFT(COMPLF(0),1)
      A377 = BUFF(150)
      FILE = 301
    5 CONTINUE
      IF (CARD) 710,20,10
C
C     FIRST CALL AND FIRST CARD IMAGE.
C
   10 IAT    = 0
      CARD   = 0
      PLOTS  = 0
      PLOTER = 0
      SDRBIT = 0
      VDRBIT = 0
      BINPLT = 0
      CONTIN = .FALSE.
      A777   = COMPLF(0)
      ICORE  = KORSZ(Z) - 2*SYSBUF - NWPC - 1
C
C     RETURNING WITH ANOTHER CARD IMAGE
C
   20 IF (BUFF(N) .EQ. A377) RETURN
C
      IF (.NOT.CONTIN) GO TO 30
      CONTIN = .FALSE.
      GO TO ICONT, (370,410,430,460,520,540,570,680,640)
C
C     BEGIN PROCESSING NON-CONTINUATION CARD (MUST BEGIN WITH BCD FIELD)
C
   30 IWRD = INCARD(1)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWRD,0)
      IF (IWRD.EQ.XTIT .OR. IWRD.EQ.YTIT .OR. IWRD.EQ.YTTI .OR.
     1    IWRD.EQ.YBTI .OR. IWRD.EQ.TCUR) GO TO 70
      IF (BUFF(N) .EQ. 0) RETURN
C
      IF (BUFF(N) .LT. 0) GO TO 730
      BCD = BUFF(N+1)
      IF (BIT64) CALL MVBITS (BLANK,0,32,BCD,0)
      DO 40 I = 1,NRWORD
      IF (BCD .EQ. RWORD(I)) GO TO 120
   40 CONTINUE
C
      DO 50 I = 1,NIWORD
      IF (BCD .EQ. IWORD(I)) GO TO 80
   50 CONTINUE
C
      DO 60 I = 1,NBWORD
      IF (BCD .EQ. BWORD(I)) GO TO 130
   60 CONTINUE
C
      IF (BCD.EQ.CLEA .OR. BCD.EQ.VDUM) GO TO 110
      IF (BCD.EQ.XYPE .OR. BCD.EQ.XYPL .OR. BCD.EQ.XYPR .OR.
     1    BCD.EQ.XYPU .OR. BCD.EQ.XYPA) GO TO 140
      GO TO 750
C
C     TITLE CARD
C
   70 CALL WRITE (FILE,INCARD(1),1,NOEOR)
      CALL WRITE (FILE,BUFF(1),32,NOEOR )
      RETURN
C
C     VERB FOLLOWED BY AN INTEGER VALUE
C     ON CAMERA CARD BCD ALSO ACCEPTED
C
   80 N = N + 2*BUFF(N) + 1
      IF (I.EQ.22 .AND. BUFF(N).NE.INTE) GO TO 81
      IF (BUFF(N) .NE. INTE) GO TO 770
      IF (I .EQ. 26) GO TO 95
      IF (BUFF(N+1).GE.0 .AND. I.LE.8) GO TO 90
      IF (I .LE. 8) GO TO 770
      IF (BUFF(N+1).EQ.0 .OR. I.GT.19) GO TO 90
      BUFF(N+1) = BUFF(N+1)/IABS(BUFF(N+1))
   90 BUF(1) = BCD
      BUF(2) = BUFF(N+1)
  100 CALL WRITE (FILE,BUF(1),2,NOEOR)
      RETURN
C
   95 BUF(1) = BCD
      BUF(2) = BUFF(N+1)
      BUF(3) = BUFF(N+3)
      CALL WRITE (FILE,BUF(1),3,NOEOR)
      RETURN
C
  110 CALL WRITE (FILE,BCD,1,NOEOR)
      RETURN
C
   81 IWRD = BUFF(N-2)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWRD,0)
      DO 85 I = 1,3
      IF (IWRD .NE. KWORD(I)) GO TO 85
      BUFF(N+1) = I
      GO TO 90
   85 CONTINUE
      GO TO 770
C
C     VERB FOLLOWED BY A REAL VALUE
C
  120 N = N + 2*BUFF(N) + 1
      IF (BUFF(N) .NE. REAL) GO TO 770
      GO TO 90
C
C     VERB FOLLOWED BY BCD YES OR NO, UNLESS BCD = PLOT...
C
  130 IF (I .EQ. 13) GO TO 138
      N = N + 2*BUFF(N) - 2
      J = N
C
C     SEARCH FOR EQUAL SIGN
C
  132 IWRD = BUFF(N)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWRD,0)
      IF (IWRD .EQ. IEQUAL) GO TO 133
      N = N - 2
      IF (N .GT. 0) GO TO 132
      N = J
  133 CONTINUE
      I = -1
  134 IWRD = BUFF(N+1)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWRD,0)
      IF (IWRD .EQ. YES) I = 1
      IF (IWRD .EQ. NO ) I = 0
      IF (I .LT. 0) GO TO 135
      BUF(1) = BCD
      BUF(2) = I
      GO TO 100
  135 IF (I .LT. -3) GO TO 136
      I = I - 1
      N = N + 1
      GO TO 134
  136 N = J
      GO TO 750
C
C     PLOTTER SPECIFICATION CARD LOGIC
C
  138 IF (BUFF(N+3) .EQ. A777) N = N + 2
      N    = N + 2
      NMOD = N + 3
      IWRD = BUFF(NMOD)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWRD,0)
      IF (IWRD .EQ. IMODEL) NMOD = NMOD + 2
      IF (IWRD .EQ.   IDEN) GO TO 147
      MODID(1) = 0
      MODID(2) = 0
      IF (BUFF(NMOD) .EQ. A377) GO TO 147
      IF (BUFF(NMOD) .EQ.   -1) MODID(1) = BUFF(NMOD+1)
      IF (BUFF(NMOD) .NE.   -1) MODID(1) = BUFF(NMOD  )
      NMOD = NMOD + 2
      IF (BUFF(NMOD) .EQ.    1) NMOD = NMOD + 1
      IWRD = BUFF(NMOD)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWRD,0)
      IF (IWRD       .EQ. IDEN) GO TO 147
      IF (BUFF(NMOD) .EQ. A377) GO TO 147
      IF (BUFF(NMOD) .EQ.   -1) MODID(2) = BUFF(NMOD+1)
      IF (BUFF(NMOD) .NE.   -1) MODID(2) = BUFF(NMOD  )
  147 CALL FNDPLT (PLOTER,MODEL,MODID(1))
      BUF(1) = BCD
      BUF(2) = ORF(LSHIFT(PLOTER,IHALF),MODEL+100)
      BINPLT = BINPLT + 1
      GO TO 100
C
C     PRINT, PLOT, OR PUNCH COMMAND CARD
C
  140 XTYPE = 0
      TYPE  = 0
      XVECT = 0
      VECTOR= 0
      PRINT = 0
      PLOT  = 0
      PUNCH = 0
      PAPLOT= 0
      SLASH = .FALSE.
      N1    = 2
      N2    = 2*BUFF(N) + N
C
C     PROCESS ALL WORDS
C
      DO 360 I = N1,N2,2
      BCD = BUFF(I)
      IF (BCD .EQ. A777) GO TO 350
      IF (BIT64) CALL MVBITS (BLANK,0,32,BCD,0)
      IF (BCD .EQ. XYPL) GO TO 150
      IF (BCD .EQ. XYPR) GO TO 160
      IF (BCD .EQ. XYPU) GO TO 170
      IF (BCD .EQ. XYPE) GO TO 359
      IF (BCD .EQ. XYPA) GO TO 175
      IF (BCD .EQ. RESP) GO TO 180
      IF (BCD .EQ. AUTO) GO TO 190
      IF (BCD .EQ. PSDF) GO TO 200
      IF (BCD .EQ. SUBC) GO TO 220
      IF (BCD .EQ. DISP) GO TO 230
      IF (BCD .EQ. VECT) GO TO 230
      IF (BCD .EQ. VELO) GO TO 240
      IF (BCD .EQ. ACCE) GO TO 250
      IF (BCD .EQ. SPCF) GO TO 260
      IF (BCD .EQ. LOAD) GO TO 270
      IF (BCD .EQ. STRE) GO TO 280
      IF (BCD .EQ. FORC) GO TO 290
      IF (BCD .EQ. SDIS) GO TO 300
      IF (BCD .EQ. SVEL) GO TO 310
      IF (BCD .EQ. SACC) GO TO 320
      IF (BCD .EQ. NONL) GO TO 330
      IF (BCD .EQ. ELFO) GO TO 290
      IF (BCD .EQ. ELST) GO TO 280
      IF (BCD .EQ. OLOA) GO TO 270
      IF (BCD .EQ. VG  ) GO TO 270
      N = I - 1
      GO TO 750
  150 PLOT  = 2
      PLOTS = 1
      IF (PLOTER .NE. 0) GO TO 359
      PLOTER = 1
      MODEL  =-1
      BUF(1) = BWORD(13)
      BUF(2) = ORF(LSHIFT(PLOTER,IHALF),MODEL+100)
      BINPLT = BINPLT + 1
      CALL WRITE (FILE,BUF(1),2,NOEOR)
      GO TO 359
  160 PRINT = 1
      GO TO 359
  170 PUNCH = 4
      GO TO 359
  175 PAPLOT = 1
      GO TO 359
  180 TYPE = 1
      GO TO 210
  190 TYPE = 3
      GO TO 210
  200 TYPE = 2
      GO TO 210
  210 IF (XTYPE .NE. 0) GO TO 790
      XTYPE = 1
  220 GO TO 360
  230 VECTOR = 1
      GO TO 291
  240 VECTOR = 2
      GO TO 291
  250 VECTOR = 3
      GO TO 291
  260 VECTOR = 4
      GO TO 291
  270 VECTOR = 5
      GO TO 291
  280 VECTOR = 6
      GO TO 291
  290 VECTOR = 7
  291 SDRBIT = 16
      GO TO 340
  300 VECTOR = 8
      GO TO 331
  310 VECTOR = 9
      GO TO 331
  320 VECTOR = 10
      GO TO 331
  330 VECTOR = 11
  331 VDRBIT = 2
      GO TO 340
  340 IF (XVECT .NE. 0) GO TO 790
      XVECT = 1
      GO TO 360
C
C     DELIMETER HIT OF SOME KIND. IGNORE IF NOT LAST WORD OF BCD GROUP.
C
  350 IF (I .NE. N2-1) GO TO 360
      IWRD = BUFF(I+1)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWRD,0)
      IF (IWRD .EQ. SLAS) SLASH = .TRUE.
      IF (.NOT.SLASH) GO TO 810
      GO TO 360
  359 XYCM = .TRUE.
  360 CONTINUE
C
C     WRITE PLOT CONTROL INFORMATION
C
      BUF(1) = XY
      BUF(2) = PRINT
      BUF(3) = PLOT
      BUF(4) = PUNCH
      IF (PAPLOT .EQ. 1) PLOT = 2
      DESTIN = PRINT + PLOT + PUNCH
      IF (TYPE .EQ. 0) TYPE = 1
      BUF(5) = TYPE
      IF (VECTOR .EQ. 0) GO TO 1030
      BUF(6) = VECTOR
      BUF(7) = PAPLOT
      CALL WRITE (FILE,BUF(1),7,NOEOR)
C
C     ALL WORDS PROCESSED. IF SLASH HAS NOT BEEN HIT, START READING
C     SUBCASE NUMBERS.
C
      NSUBS = 0
      N = N2 + 1
      IF (SLASH) GO TO 490
C
C     FORM LIST OF SUBCASES, MAXIMUM OF 200 FOR THIS COMMAND CARD.
C
  370 IF (BUFF(N) .NE. CONT) GO TO 380
      ASSIGN 370 TO ICONT
      GO TO 700
C
  380 SUBCAS(1) = 0
      IF (BUFF(N) .NE. INTE) GO TO 830
C
C     SUBCASES ARE NOT APPLICABLE IN AUTO AND PSDF
C
      IF (TYPE .NE. 1) GO TO 850
C
  390 NSUBS = NSUBS + 1
      IF (NSUBS   .GT. 200) GO TO 890
      IF (BUFF(N+1) .LE. 0) GO TO 910
      SUBCAS(NSUBS) = BUFF(N+1)
  400 N = N + 2
  410 IF (BUFF(N) .EQ. A377) GO TO 1080
      IF (BUFF(N) .NE. CONT) GO TO 420
      ASSIGN 410 TO ICONT
      GO TO 700
C
  420 IF (BUFF(N) .NE. INTE) GO TO 430
      IF (SUBCAS(NSUBS)-BUFF(N+1)) 390,400,910
  430 IF (BUFF(N) .NE. CONT) GO TO 440
      ASSIGN 430 TO ICONT
      GO TO 700
C
  440 IF (BUFF(N) .LT. 0) GO TO 830
      IWRD = BUFF(N+2)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWRD,0)
      IF (IWRD .NE. SLAS) GO TO 450
      SLASH = .TRUE.
      N = N + 3
      GO TO 490
C
  450 IF (IWRD .NE. THRU) GO TO 830
      N = N + 3
  460 IF (BUFF(N) .NE. CONT) GO TO 470
      ASSIGN 460 TO ICONT
      GO TO 700
C
  470 IF (BUFF(N  ) .NE.         INTE ) GO TO 830
      IF (BUFF(N+1) .LT. SUBCAS(NSUBS)) GO TO 910
      IF (BUFF(N+1) .EQ. SUBCAS(NSUBS)) GO TO 400
  480 NSUBS = NSUBS + 1
      IF (NSUBS .GT. 200) GO TO 890
      SUBCAS(NSUBS) = SUBCAS(NSUBS-1) + 1
      IF (SUBCAS(NSUBS) .LT. BUFF(N+1)) GO TO 480
      GO TO 400
C
C     SLASH HIT. BEGIN PROCESSING FRAME DATA. FIRST WRITE SUBCASE
C     NUMBERS.
C
  490 CALL WRITE (FILE,NSUBS,1,NOEOR)
      IF (NSUBS .NE. 0) CALL WRITE (FILE,SUBCAS(1),NSUBS,NOEOR)
      IF (NSUBS .EQ. 0) SUBCAS(1) = 0
      IF (NSUBS .EQ. 0) NSUBS = 1
  500 SLASH  = .FALSE.
      CALL WRITE (FILE,FRAM,1,NOEOR)
      PAIRS  = .FALSE.
      NCURVE = 0
  520 IF (BUFF(N) .NE. CONT) GO TO 530
      ASSIGN 520 TO ICONT
      GO TO 700
C
  530 IF (BUFF(N) .NE. INTE) GO TO 830
      BUF(1) = BUFF(N+1)
      BUF(2) = 0
      BUF(3) = 0
      IDCOM  = 0
      NCURVE = NCURVE + 1
      IF (BUF(1) .LE. 0) GO TO 930
C
C     GET COMPONENT. POSITIVE INTEGER.
C     MAY BE T1,T2,T3,R1,R2,R3 ETC. IF THE VECTOR IS NOT STRESS OR FORCE
C
      N = N + 2
  540 IF (BUFF(N) .NE. CONT) GO TO 550
      ASSIGN 540 TO ICONT
      GO TO 700
C
  550 IWRD = BUFF(N+2)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWRD,0)
      IF (BUFF(N).GT.0 .AND. IWRD.EQ.OPAREN) GO TO 560
      GO TO 830
C
  560 OFBCD = .FALSE.
      IF (BUFF(N) .GT. 1) GO TO 590
C
C     FALL HERE AND A POSITIVE INTEGER COMPONENT IS EXPECTED.
C
      N = N + 3
  570 IF (BUFF(N) .NE. CONT) GO TO 580
      ASSIGN 570 TO ICONT
      GO TO 700
C
  580 IF (BUFF(N  ) .NE. INTE) GO TO 830
      IF (BUFF(N+1) .LE.    0) GO TO 950
      OFBCD  =.FALSE.
      COMPON = BUFF(N+1)
      N = N + 2
      GO TO 620
C
C     FALL HERE AND A BCD COMPONENT IS EXPECTED. T1,T2,T3,R1,R2,R3
C
  590 N1  = N + 3
  600 N   = N + 2*BUFF(N) + 1
  610 BCD = BUFF(N1)
      IF (BIT64) CALL MVBITS (BLANK,0,32,BCD,0)
      IF (BCD .EQ. BLANK) GO TO 615
      IF (VECTOR .EQ.6 .OR. VECTOR.EQ.7) GO TO 970
 615  OFBCD  = .TRUE.
      COMPON = 3
      IF (BCD.EQ.T1 .OR. BCD.EQ.T1RM) GO TO 620
      IF (BCD .EQ. G) GO TO 620
      COMPON = 4
      IF (BCD.EQ.T2 .OR. BCD.EQ.T2RM) GO TO 620
      IF (BCD .EQ. F) GO TO 620
      COMPON = 5
      IF (BCD.EQ.T3 .OR. BCD.EQ.T3RM) GO TO 620
      COMPON = 6
      IF (BCD.EQ.R1 .OR. BCD.EQ.R1RM) GO TO 620
      COMPON = 7
      IF (BCD.EQ.R2 .OR. BCD.EQ.R2RM) GO TO 620
      COMPON = 8
      IF (BCD.EQ.R3 .OR. BCD.EQ.R3RM) GO TO 620
      COMPON = 9
      IF (BCD .EQ. T1IP) GO TO 620
      COMPON = 10
      IF (BCD .EQ. T2IP) GO TO 620
      COMPON = 11
      IF (BCD .EQ. T3IP) GO TO 620
      COMPON = 12
      IF (BCD .EQ. R1IP) GO TO 620
      COMPON = 13
      IF (BCD .EQ. R2IP) GO TO 620
      COMPON = 14
      IF (BCD .EQ. R3IP) GO TO 620
      COMPON = 1000
      IF (BCD .EQ. BLANK) GO TO 620
      GO TO 990
C
  620 IDCOM = IDCOM + 1
      BUF(IDCOM+1) = COMPON
C
C     CHECK RANGE OF COMPONENT
C
      IF (COMPON .EQ. 1000) GO TO 631
      IF ((TYPE.EQ.2 .OR. TYPE.EQ.3) .AND. (COMPON.LT.3 .OR.COMPON.GT.8)
     1   .AND. (VECTOR.NE.6 .AND. VECTOR.NE.7)) GO TO 1130
      IF ((COMPON.LT.3 .OR. COMPON.GT.14) .AND.
     1   (VECTOR.NE.6 .AND. VECTOR.NE.7)) GO TO 1150
      IF (NOGO .NE. 0) GO TO 631
C
C     ADD THIS COMPONENT-ID TO XY-MASTER SET IN OPEN CORE.
C
      DO 630 I = 1,NSUBS
      IF (IAT+6 .GT. ICORE) GO TO 1090
      Z(IAT+1) = SUBCAS(I)
      Z(IAT+2) = VECTOR
      Z(IAT+3) = BUF(1)
      Z(IAT+4) = COMPON
      Z(IAT+5) = TYPE
      Z(IAT+6) = DESTIN
  630 IAT = IAT + 6
C
C     PROCEED TO NEXT COMPONENT OR ID OF THIS FRAME
C
  631 IF (NCURVE.EQ.1 .AND. IDCOM.EQ.2) PAIRS = .TRUE.
      IF (PAIRS .AND. (TYPE.EQ.2 .OR. TYPE.EQ.3)) GO TO 1110
      IF (.NOT.PAIRS .AND. IDCOM.EQ.2) GO TO 1050
      IF (IDCOM .GT. 2) GO TO 1050
      IF (.NOT.OFBCD  ) GO TO 640
      IF (N1 .GE.  N-2) GO TO 640
      N1   = N1 + 2
      IWRD = BUFF(N1+1)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWRD,0)
      IF (IWRD .NE. SLAS) GO TO 610
      SLASH = .TRUE.
      GO TO 670
C
C     IS NEXT FIELD AN INTEGER FOLLOWED BY AN OPAREN
C
  640 IF (BUFF(N) .NE. CONT) GO TO 650
      ASSIGN 640 TO ICONT
      GO TO 700
C
  650 IF (BUFF(N  ) .NE. INTE) GO TO 660
      IF (BUFF(N+2) .EQ. A377) GO TO 580
      IWRD = BUFF(N+4)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWRD,0)
      IF (IWRD .EQ. OPAREN) GO TO 670
      GO TO 580
  660 IF (BUFF(N) .EQ. A377) GO TO 670
      IWRD = BUFF(N+2)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWRD,0)
      IF (BUFF(N).LE.0 .OR. IWRD.EQ.SLAS) GO TO 670
      N1 = N + 1
      GO TO 600
  670 IF (PAIRS .AND. IDCOM.EQ.1) GO TO 1050
      CALL WRITE (FILE,BUF(1),3,NOEOR)
      IF (.NOT.SLASH .AND. BUFF(N).EQ.INTE) GO TO 520
      BUF(1) = -1
      BUF(2) = -1
      BUF(3) = -1
      CALL WRITE (FILE,BUF(1),3,NOEOR)
      IF (BUFF(N) .EQ. A377) RETURN
C
  680 IF (BUFF(N) .NE. CONT) GO TO 690
      ASSIGN 680 TO ICONT
      GO TO 700
  690 IF (SLASH) GO TO 500
      IWRD = BUFF(N+2)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWRD,0)
      IF (IWRD .NE. SLAS) GO TO 830
      N = N + 2*BUFF(N) + 1
      GO TO 500
C
C     RETURN FOR A CONTINUATION CARD
C
  700 CONTIN = .TRUE.
      RETURN
C
C     NO MORE CARDS AVAILABLE. RAP IT UP IF NO ERROR. WRITE XY-SET
C     RECORD
C
  710 IF (CONTIN) GO TO 1010
      CALL WRITE (FILE,Z(1),0,EOR)
      IF (IAT .EQ. 0) GO TO 720
      J = 7
      DO 715 I = 1,6
      J = J - 1
      CALL SORT (0,0,6,-J,Z(1),IAT)
  715 CONTINUE
  720 CALL WRITE (FILE,Z(1),IAT,EOR)
C
C     SET CARD = 0 IF NO PLOTS
C     SET CARD = 1 IF PLOTS
C
      CARD = PLOTS
C
C     SET RESTART BITS FOR VDR AND SDR
C
      IF (IRESRT .LT. 0) BITS(BITWRD) = ORF(BITS(BITWRD),VDRBIT+SDRBIT)
C
C     CHECK FOR COMMAND OP CARD
C
      IF (.NOT.XYCM) GO TO 1170
C
C     CHECK PLOT TAPE BITS
C
      IF (PLOTS .EQ. 0) RETURN
C
C     CHECK FOR TAPE SETUPS
C
      IF (BINPLT.NE.0 .AND. .NOT.TAPBIT(PLT1) .AND. .NOT.TAPBIT(PLT2))
     1   CALL IFP1D (-618)
      RETURN
C
C     FATAL ERROR CONDITIONS
C
  730 J = 675
      WRITE  (L,740) UFM,J
  740 FORMAT (A23,I4,', ABOVE CARD DOES NOT BEGIN WITH A NON-NUMERIC ',
     1        'WORD.')
      GO TO 2000
  750 J = 676
      WRITE  (L,760) UFM,J,BUFF(N+1),BUFF(N+2)
  760 FORMAT (A23,I4,1H,,2A4,' IS NOT RECOGNIZED AS AN XYPLOT COMMAND ',
     1        'CARD OR PARAMETER.')
      GO TO 2000
  770 J = 677
      WRITE  (L,780) UFM,J
  780 FORMAT (A23,I4,', ILLEGAL VALUE SPECIFIED.')
      GO TO 2000
  790 J = 678
      WRITE  (L,800) UFM,J,BUFF(I),BUFF(I+1)
  800 FORMAT (A23,I4,1H,,2A4,' CONTRADICTS PREVIOUS DEFINITION.')
      GO TO 2000
  810 J = 679
      WRITE  (L,820) UFM,J,BUFF(I+1)
  820 FORMAT (A23,I4,1H,,A4,' DELIMITER ILLEGALLY USED.')
      GO TO 2000
  830 IF (BUFF(N) .EQ. REAL) GO TO 850
      IF (BUFF(N) .EQ. INTE) GO TO 870
      J = 680
      WRITE  (L,840) UFM,J,BUFF(N+1),BUFF(N+2)
  840 FORMAT (A23,I4,1H,,2A4,' IS ILLEGAL IN STATEMENT.')
      GO TO 2000
  850 J = 681
      WRITE  (L,860) UFM,J,BUFF(N+1)
  860 FORMAT (A23,I4,1H,,E16.8,' IS ILLEGAL IN STATEMENT.')
      GO TO 2000
  870 J = 682
      WRITE  (L,880) UFM,J,BUFF(N+1)
  880 FORMAT (A23,I4,1H,,I10,' IS ILLEGAL IN STATEMENT.')
      GO TO 2000
  890 J = 683
      WRITE  (L,900) UFM,J
  900 FORMAT (A23,I4,', TOO MANY SUBCASES. MAXIMUM = 200 ON ANY ONE XY',
     1       '-OUTPUT COMMAND CARD.')
      GO TO 2000
  910 J = 684
      WRITE  (L,920) UFM,J
  920 FORMAT (A23,I4,', SUBCASE-ID IS LESS THAN 1 OR IS NOT IN ',
     1        'ASCENDING ORDER.')
      GO TO 2000
  930 J = 685
      WRITE  (L,940) UFM,J,BUF(1)
  940 FORMAT (A23,I4,1H,,I12,' = POINT OR ELEMENT ID IS ILLEGAL (LESS ',
     1        'THAN 1).')
      GO TO 2000
  950 J = 686
      WRITE  (L,960) UFM,J
  960 FORMAT (A23,I4,', NEGATIVE OR ZERO COMPONENTS ARE ILLEGAL.')
      GO TO 2000
  970 J = 687
      WRITE  (L,980) UFM,J
  980 FORMAT (A23,I4,', ALPHA-COMPONENTS ARE NOT PERMITTED FOR STRESS ',
     1        'OR FORCE XY-OUTPUT REQUESTS.')
      GO TO 2000
  990 J = 688
      WRITE  (L,1000) UFM,J,BCD
 1000 FORMAT (A23,I4,1H,,A4,' COMPONENT NAME NOT RECOGNIZED.')
      GO TO 2000
 1010 J = 689
      WRITE  (L,1020) UFM,J
 1020 FORMAT (A23,I4,', LAST CARD ENDED WITH A DELIMITER BUT NO ',
     1       'CONTINUATION CARD WAS PRESENT.')
      GO TO 2000
 1030 J = 690
      WRITE  (L,1040) UFM,J
 1040 FORMAT (A23,I4,', TYPE OF CURVE WAS NOT SPECIFIED. (E.G. ',
     1        'DISPLACEMENT, STRESS, ETC.).')
      GO TO 2000
 1050 J = 691
      WRITE  (L,1060) UFM,J
 1060 FORMAT (A23,I4,', MORE THAN 2 OR UNEQUAL NUMBER OF COMPONENTS ',
     1        'FOR ID-S WITHIN A SINGLE FRAME.')
      GO TO 2000
 1070 FORMAT (A23,I4,', XY-OUTPUT COMMAND IS INCOMPLETE.')
 1080 J = 692
      WRITE  (L,1070) UFM,J
      GO TO 2000
 1090 J = 693
      WRITE  (L,1100) UFM,J
 1100 FORMAT (A23,I4,', INSUFFICIENT CORE FOR SET TABLE.')
      ICRQ = (NSUBS-I+1) * 6
      WRITE  (L,1101) ICRQ
 1101 FORMAT (5X,8HAT LEAST,I8,19H MORE WORDS NEEDED.)
      GO TO 2000
 1110 J = 694
      WRITE  (L,1120) UFM,J
 1120 FORMAT (A23,I4,', AUTO OR PSDF REQUESTS MAY NOT USE SPLIT FRAME',
     1       ', THUS ONLY ONE COMPONENT PER ID IS PERMITTED.')
      GO TO 2000
 1130 J = 695
      WRITE  (L,1140) UFM,J,COMPON
 1140 FORMAT (A23,I4,', COMPONENT VALUE =',I8,', IS ILLEGAL FOR AUTO ',
     1        'OR PSDF VECTOR REQUESTS.')
      GO TO 2000
 1150 J = 696
      WRITE  (L,1160) UFM,J,COMPON
 1160 FORMAT (A23,I4,', COMPONENT VALUE =',I8,', IS ILLEGAL FOR VECTOR',
     1       ' TYPE SPECIFIED.')
      GO TO 2000
 1170 J = 697
      WRITE  (L,1180) UFM,J
 1180 FORMAT (A23,I4,', XYPLOT, XYPRINT, XYPUNCH, XYPEAK, OR XYPAPLOT',
     1    /5X,' COMMAND CARD NOT FOUND IN XY PLOTTER OUT PUT PACKAGE.')
      GO TO 2000
 2000 NOGO = 1
      LINE = LINE + 2
      IF (LINE .GE. NLPP) CALL PAGE
      RETURN
      END

      SUBROUTINE APDCS
      INTEGER CP,ACSID,CSTMA,IZ(1)
      REAL           RCP1(3),RCP4(3),RB1(3),RB4(3),RX1(3),RX4(3)
     1,              RA2(3),RA3(3),RA4(3),RB2(3),RB3(3),VX1(3),VX2(3)
     2,   VX3(3),ACPL(3,3),V1(3),V2(3)
      COMMON /APD1C/ EID,PID,CP,NSPAN,NCHORD,LSPAN,LCHORD,IGID
     1,              X1,Y1,Z1,X12,X4,Y4,Z4,X43,XOP,X1P,ALZO,MCSTM
     2,              NCST1,NCST2,CIDBX,ACSID,IACS,SILB,NCRD
     3,              SCR1,SCR2,SCR3,SCR4,SCR5,ECTA,BGPA,GPLA,USETA,SILA
     4,              CSTMA,ACPT,BUF10,BUF11,BUF12,NEXT,LEFT,ISILN
      COMMON /APD1D/ ICPL(14),YP4,SG,CG,XP2,XP3,XP4,RA1(3)
      COMMON /ZZZZZZ/  Z(1)
      EQUIVALENCE (Z(1),IZ(1))
      EQUIVALENCE (ICPL(3),RB1(1)),(ICPL(6),ACPL(1,1))
     1, (V1(1),RCP1(1)),(V2(1),RCP4(1))
      DATA DEGR/.017453293/
      ICPL(2) = 1
C CREATE PANEL COORDINATE SYSTEM
C FIND CP TRANSFORMATION AND CONVERT POINT 1 AND 4 TO BASIC
      IF(CP.EQ.0) GO TO 120
      IF(NCST1.EQ.0) GO TO 470
      DO 40 ICP=NCST1,NCST2,14
      IF(IZ(ICP).EQ.CP) GO TO 50
   40 CONTINUE
      GO TO 470
   50 IF(IZ(ICP+1)-2) 60,70,80
C CP RECTANGULAR
   60 RCP1(1)=X1
      RCP1(2)=Y1
      RCP1(3)=Z1
      RCP4(1)=X4
      RCP4(2)=Y4
      RCP4(3)=Z4
      GO TO 90
C CP CYLINDRICAL
   70 RCP1(1)=X1*COS(Y1*DEGR)
      RCP1(2)=X1*SIN(Y1*DEGR)
      RCP1(3)=Z1
      RCP4(1)=X4*COS(Y4*DEGR)
      RCP4(2) = X4*SIN(Y4*DEGR)
      RCP4(3)=Z4
      GO TO 90
C CP SPHERICAL
   80 RCP1(1)=X1*SIN(Y1*DEGR)*COS(Z1*DEGR)
      RCP1(2)=X1*SIN(Y1*DEGR)*SIN(Z1*DEGR)
      RCP1(3)=X1*COS(Y1*DEGR)
      RCP4(1)=X4*SIN(Y4*DEGR)*COS(Z4*DEGR)
      RCP4(2)=X4*SIN(Y4*DEGR)*SIN(Z4*DEGR)
      RCP4(3)=X4*COS(Y4*DEGR)
C CONVERT TO BASIC
   90 CALL GMMATS(Z(ICP+5),3,3,0,RCP1,3,1,0,RB1)
      CALL GMMATS(Z(ICP+5),3,3,0,RCP4,3,1,0,RB4)
      J=ICP+1
      DO 100 I=1,3
      K=J+I
  100 RB1(I)=RB1(I)+Z(K)
      DO 110 I=1,3
      K=J+I
  110 RB4(I)=RB4(I)+Z(K)
      GO TO 130
C COORDS ARE IN BASIC
  120 RB1(1)=X1
      RB1(2)=Y1
      RB1(3)=Z1
      RB4(1)=X4
      RB4(2)=Y4
      RB4(3)=Z4
C FIND R1 THRU IN R4 AERO CS
  130 IF(ACSID.EQ.0) GO TO 150
      J=IACS+1
      DO 140 I=1,3
      K=J+I
      RX1(I)=RB1(I)-Z(K)
  140 RX4(I)=RB4(I)-Z(K)
      CALL GMMATS(Z(IACS+5),3,3,1,RX1,3,1,0,RA1)
      CALL GMMATS (Z(IACS+5),3,3,1,RX4,3,1,0,RA4)
      GO TO 170
  150 DO 160 I=1,3
      RA1(I)=RB1(I)
  160 RA4(I)=RB4(I)
C
C     STOP IF BODY
C
      IF(IGID.LT.0) GO TO 1000
C CALCULATE R2 AND R3 IN AC CS
  170 DO 180 I=2,3
      RA2(I)=RA1(I)
  180 RA3(I)=RA4(I)
      RA2(1)=RA1(1)+X12
      RA3(1)=RA4(1)+X43
      EE=SQRT((RA4(3)-RA1(3))**2 + (RA4(2)-RA1(2))**2)
      SG=(RA4(3)-RA1(3))/EE
      CG=(RA4(2)-RA1(2))/EE
C LOCATE POINTS 2,3,4 IN PANEL CORDINATE SYSTEM
      XP2=X12
      XP4=RA4(1)-RA1(1)
      XP3=RA3(1)-RA1(1)
      YP4=EE
C TRANSFORM R2 AND R3 INTO BASIC
      IF(ACSID.EQ.0) GO TO 200
      CALL GMMATS(Z(IACS+5),3,3,0,RA2,3,1,0,RB2)
      CALL GMMATS(Z(IACS+5),3,3,0,RA3,3,1,0,RB3)
      J=IACS+1
      DO 190 I=1,3
      K=J+I
      RB2(I) = RB2(I) + Z(K)
  190 RB3(I) = RB3(I) + Z(K)
      GO TO 220
  200 DO 210 I=1,3
      RB2(I)=RA2(I)
  210 RB3(I)=RA3(I)
C FIND PANEL COORDINATE SYSTEM
  220 DO 230 I=1,3
      VX1(I)=RB2(I)-RB1(I)
      VX2(I)=RB4(I)-RB1(I)
      VX3(I) = RB3(I) - RB1(I)
  230 IF ( X12. EQ. 0.0 ) VX1(I) = VX3(I)
      CALL SAXB(VX1,VX2,V1)
      SX1=SADOTB(V1,V1)
      CALL SAXB(VX1,VX3,V2)
      SX2=SADOTB(V2,V2)
      IF(SX1.LT.SX2) GO TO 250
      SX1=1.0/SQRT(SX1)
      DO 240 I=1,3
  240 VX3(I)=V1(I)*SX1
      GO TO 270
  250 SX2=1.0/SQRT(SX2)
      DO 260 I=1,3
  260 VX3(I)=V2(I)*SX2
  270 IF(ACSID .NE. 0) GO TO 275
      VX1(1) = 1.0
      VX1(2) = 0.0
      VX1(3) = 0.0
      GO TO 285
  275 J=IACS+5
      DO 280 I=1,3
      K=J+3*(I-1)
  280 VX1(I)=Z(K)
  285 CONTINUE
      CALL SAXB(VX3,VX1,VX2)
      DO 290 I=1,3
      ACPL(1,I)=VX1(I)
      ACPL(2,I)=VX2(I)
  290 ACPL(3,I)=VX3(I)
C WRITE TRANSFORMATION ON CSTMA
      ICPL(1)=MCSTM
      CALL WRITE(CSTMA,ICPL(1),14,0)
 1000 RETURN
  470 CALL MESAGE(-30,25,CP)
      GO TO 1000
      END

      SUBROUTINE TRLGB (USETD,AP,GMD,GOD,PHIDH,AS,AD,AH,IFLAG1,SCR1,
     1                  SCR2,SCR3,SCR4)
C
C     THE PURPOSE OF THIS ROUTINE IS TO REDUCE THE SCALE FACTOR MATRIX
C     AP TO  A TRANS FORMATION MATRIX  AS, AD, AH
C
C     INPUTS (5)
C         USETD
C         AP     SCALE MATRIX --P SIZE
C         GMD    M- SET TRASNFORMATION MATRIX
C         GOD    0- SET TRASNFORMATION MATRIX
C         PHIDH  H- SET TRASNFORMATION MATRIX
C
C     OUTPUTS(3)
C         AS     SCALE MATRIX --S SET
C         AD     SCALE MATRIX --D SET
C         AH     SCALE MATRIX --H SET
C
C     NOTE  IFLAG1 WILL BE SET  TO -1  IF  AP = AD (N0 M,S,O)
C
C
      EXTERNAL        ANDF
      INTEGER         USETD,AP,GMD,GOD,PHIDH,AS,AD,AH,MCB(7),SCR1,
     1                USET1,ANBAR,AM,AN,AF,ADBAR,AO,ANDF,MULTI,SINGLE,
     2                OMIT,SIGN,TRNSP,PREC,SCR2,SCR3,SCR4,UM,US,UO
      COMMON /BITPOS/ UM,UO,UR,USG,USB,UL,UA,UF,US,UN,UG,UE,UP,UNE,UFE,
     1                UD
      COMMON /ZZZZZZ/ IZ(1)
      COMMON /SYSTEM/ ISKIP(54),IPREC
      COMMON /PATX  / NZ,N1,N2,N3,USET1
      COMMON /TWO   / TWO1(32)
C
C
      ANBAR = SCR2
      AM    = SCR3
      AN    = SCR4
      AF    = SCR2
      ADBAR = SCR3
      AO    = SCR4
C
C     SET FLAGS FOR PRESCENCE OF SETS
C
      MCB(1) = USETD
      CALL RDTRL (MCB)
      USET1  = USETD
      MULTI  = ANDF(MCB(5),TWO1(UM))
      SINGLE = ANDF(MCB(5),TWO1(US))
      OMIT   = ANDF(MCB(5),TWO1(UO))
      MODAL  = 0
      MCB(1) = PHIDH
      CALL RDTRL (MCB)
      IF (MCB(1) .LE. 0) MODAL = 1
      NZ     = KORSZ(IZ)
      SIGN   = 1
      TRNSP  = 1
      PREC   = IPREC
C
C     REMOVE EACH CONSTRAINT
C
      IF (MULTI .EQ. 0) GO TO 10
      IF (SINGLE.EQ.0 .AND. OMIT.EQ.0) AN = AD
      CALL CALCV (SCR1,UP,UNE,UM,IZ)
      CALL SSG2A (AP,ANBAR,AM,SCR1)
      CALL SSG2B (GMD,AM,ANBAR,AN,TRNSP,PREC,SIGN,SCR1)
      GO TO 20
C
C     NO MULTI-POINT CONSTRAINTS
C
   10 AN = AP
C
C     REMOVE SINGLES
C
   20 IF (SINGLE .EQ. 0) GO TO 30
      IF (OMIT  .EQ.  0) AF = AD
      CALL CALCV (SCR1,UNE,UFE,US,IZ)
      CALL SSG2A (AN,AF,AS,SCR1)
      GO TO 40
C
C     NO SINGLES
C
   30 AF = AN
   40 IF (OMIT .EQ. 0) GO TO 50
C
C     REMOVE OMITS
C
      CALL CALCV (SCR1,UFE,UD,UO,IZ)
      IF (AF .EQ. AO) AO = SCR2
      CALL SSG2A (AF,ADBAR,AO,SCR1)
      CALL SSG2B (GOD,AO,ADBAR,AD,TRNSP,PREC,SIGN,SCR1)
      GO TO 60
C
C     NO OMITS
C
   50 AD = AF
C
C     REMOVE TO H SET
C
   60 IF (MODAL .NE. 0) GO TO 70
      CALL SSG2B (PHIDH,AD,0,AH,TRNSP,PREC,SIGN,SCR1)
   70 IFLAG1 = MULTI + SINGLE + OMIT
      IF (IFLAG1 .EQ. 0) IFLAG1 = -1
      RETURN
      END

      SUBROUTINE CPYFIL (INFILE,OUFILE,AREA,N,COUNT)
C
C     CPYFIL COPIES RECORDS FROM INFILE TO OUFILE UNTIL AN END-OF-FILE
C     ON INFILE IS ENCOUNTERED. AN END-OF-FILE IS NOT WRITTEN ON OUFILE.
C     RECTYPE IS CALLED PRIOR TO COPYING EACH RECORD. STRING RECORDS ARE
C     COPIED USING CPYSTR. NORMAL RECORDS ARE COPIED USING READ/WRITE.
C     UPON EXIT, INFILE IS POSITIONED IMMEDIATELY AFTER THE END-OF-FILE
C     AND OUFILE IS POSITIONED AFTER THE LAST RECORD WRITTEN.
C
C     THIS ROUTINE DOES NOT OPEN NOR CLOSE ANY FILE, NOR WRITE ANY
C     MATRIX TRAILER
C
      INTEGER        AREA(2),INBLK(15),OUBLK(15),OUFILE,TYPE,EOR,COUNT
      COMMON /BLANK/ IPARAM
C
C     INITIALIZE STRING COMMUNICATION BLOCKS AND DETERMINE RECORD TYPE
C
      INBLK(1) = INFILE
      OUBLK(1) = OUFILE
      COUNT    = 0
   10 CALL RECTYP (INFILE,TYPE)
      IF (TYPE .NE. 0) GO TO 50
C
C     COPY NORMAL RECORD
C
   20 EOR  = 1
      CALL READ (*60,*30,INFILE,AREA,N,0,NWDS)
      EOR  = 0
      NWDS = N
   30 IF (COUNT.NE.0 .OR. IPARAM.NE.-1111) GO TO 40
      CALL FNAME (INFILE,AREA(NWDS+1))
      IF (AREA(NWDS+1).EQ.AREA(1) .AND. AREA(NWDS+2).EQ.AREA(2))
     1   CALL FNAME (OUFILE,AREA)
   40 CALL WRITE (OUFILE,AREA,NWDS,EOR)
      COUNT = COUNT + NWDS
      IF (EOR) 10,20,10
C
C     COPY STRING RECORDS
C
   50 CALL CPYSTR (INBLK,OUBLK,0,0)
      COUNT = COUNT + OUBLK(13)
      GO TO 10
C
C     RETURN WHEN END-OF-FILE IS ENCOUNTERED
C
   60 RETURN
      END

      SUBROUTINE DETM1(*)
C
C     RMAX = APPROXIMATE MAGNITUDE OF LARGEST EIGENVALUE OF INTEREST
C
C     RMIN = LOWEST  NON-ZERO  EIGENVALUE
C
C     MZ = NUMBER OF ZERO EIGENVALUES
C
C     NEV = NUMBER OF NON-ZERO EIGENVALUES IN RANGE OF INTEREST
C
C     EPSI = CONVERGENCE CRITERION
C
C     RMINR = LOWEST EIGENVALUE OF INTEREST
C
C     NE   =  NUMBER OF PERMISSIBLE CHANGES OF EPSI
C
C     NIT = INTERATIONS TO AN EIGENVALUE
C
C     NEVM = MAXIMUM NUMBER OF EIGENVALUES DESIRED
C
C     IS  = STARTING SET COUNTER
C
C     IC  = COUNTER FOR CHANGE OF CONVERGENCE CRITERIA
C
C     NFOUND  = THE NUMBER OF EIGENVALUES FOUND TO DATA
C     NSTART = NUMBER OF TIMES THROUGH THE STARTING VALUES
C
C
C      IM = MASS MATRIX CONTROL BLOCK
C
C      IK = K MATRIX CONTROL BLOCK
C
C        A = M +P*K
C
C     IEV = EIGENVECTOR CONTROL BLOCK
C
      DOUBLE PRECISION P,DETX,PS1,DET1,PSAVE(1),DET(1),PS(1),FACT
      DOUBLE PRECISION F1, F2, X, Y, RATIO
C
      INTEGER PREC,U2,SCR1,SCR2,SCR3,SCR4,SCR5,SCR6,SCR7,NAME(2)
C
      DIMENSION IPDET(1)
C
      COMMON /DETMX/P(4),DETX(4),PS1(4),DET1(4),N2EV,IPSAV,IPS,IDET,
     1IPDETA,PREC,NSTART,U2,IC,L1,L2,IS,ND,IADD,SML1,IPDETX(4),IPDET1(4)
     2  ,IFAIL,K,FACT1,IFFND,NFAIL,NPOLE,ISNG
      COMMON  /REGEAN/ IM(7),IK(7),IEV(7),SCR1,SCR2,SCR3,SCR4,SCR5,LCORE
     1 , RMAX,RMIN,MZ,NEV,EPSI,RMINR,NE,NIT,NEVM,SCR6,SCR7
     2  ,NFOUND,LAMA
      COMMON /ZZZZZZ/PSAVE
C
      EQUIVALENCE  (PSAVE(1),PS(1),DET(1),IPDET(1))
C
      DATA NAME/4HDETM,4H1   /
C
C ----------------------------------------------------------------------
C
      IC = 0
C
C     CALCULATE THE NUMBER OF STARTING POINTS TO BE USED
C
      N2EV = 2*NEV
      NN = N2EV
      SRRMIN = SQRT (RMIN)
      SRRMAX = SQRT (RMAX)
      FACT = (SRRMAX - SRRMIN)/N2EV
      F1 = SRRMIN
      I = 0
  120 I = I + 1
      F2 = F1 + FACT
      X = DLOG10 (F2/F1)
      IF (X.LT.1.0D0) GO TO 140
      IX = X
      Y = IX
      IF (X.NE.Y) IX = IX + 1
      N2EV = N2EV + IX - 1
      F1 = F2
  140 IF (I.LT.NN) GO TO 120
C
C     CHECK AVAILABILITY OF CORE
C
      LC = 2*(KORSZ(PSAVE)/2)
      IPSAV = LC/2-NEVM
      IPS = IPSAV -N2EV-1
      IDET = IPS-N2EV-1
      IPDETA = 2*IDET -N2EV-2
      IF(IPDETA .LE. 0) GO TO 80
      LCORE = LC-IPDETA+1
C
C     COMPUTE THE STARTING POINTS
C
      NN = IPS + 1
      PS(NN) = RMIN
      F1 = SRRMIN
      I = 0
  160 F2 = F1 + FACT
      RATIO = F2/F1
      X = DLOG10 (RATIO)
      IF (X.LT.1.0D0) GO TO 200
      IX = X
      Y = IX
      IF (X.NE.Y) IX = IX + 1
      RATIO = RATIO**(1.0D0/IX)
      N = 0
  180 N = N + 1
      I = I + 1
      NN = NN + 1
      PS(NN) = PS(NN-1)*RATIO*RATIO
      IF (N.LT.IX) GO TO 180
      GO TO 220
  200 I = I + 1
      NN = NN + 1
      PS(NN) = F2**2
  220 F1 = F2
      IF (I.LT.N2EV) GO TO 160
      IS=1
      ND=3
      IADD=0
      ISNG = 0
      RMAX = 1.05*RMAX
      FACT1 = EPSI*SQRT(RMAX)
C
C     CALCULATE DETERMINANTE OF FIRST 3 STARTING VALUES
C
      ENTRY DETM2
      IF(NSTART .NE. 0) GO TO 40
      DO 30 N = 1, ND
      NN = N+IADD
      NNP = NN+IPS
      NND = NN+IDET
      NNI = NN+IPDETA
      CALL EADD(-PS(NNP),PREC)
      CALL DETDET(DET(NND),IPDET(NNI),PS(NNP),SML1,0.0D0,1)
   30 CONTINUE
      IF(ND.EQ.3.AND.ISNG.EQ.3)RETURN 1
      IF(IS .EQ. 1) IADD=2
      ND = 1
C
C     CALCULATE THE INITAL GUESS
C
C
C     PERMUT VALUES TO ORDER BY DETERMINANT
C
   40 DO 50 N=1,3
      NS = N-1+IS
      NND = NS+IDET
      NNI = NS+IPDETA
      NNP = NS+IPS
      DET1(N) = DET(NND)
      IPDET1(N) = IPDET(NNI)
      PS1(N) = PS(NNP)
   50 CONTINUE
      RETURN
   80 CALL MESAGE (-8, 0, NAME)
      RETURN
      END

       program chkfil
       character*80 card
       read(5,901) card
901    format(a80)
       inptp = index( card, 'NPTP' )
       iplt2 = index( card, 'PLT'  )
       iexit = 0
       if ( inptp .ne. 0 ) iexit = 1
       if ( iplt2 .ne. 0 ) iexit = iexit + 10
       if ( iexit .eq. 0 ) go to 700
       if ( iexit .eq. 1 ) open ( 77, file='nogood1', status='unknown' )
       if ( iexit .eq. 10) open ( 77, file='nogood2', status='unknown' )
       if ( iexit .eq. 11) open ( 77, file='nogood3', status='unknown' )
       write ( 77, * ) ' iexit=',iexit
       close ( 77 )
700    call exit( iexit )
       end

      SUBROUTINE OPTPX (DTYP)
C
C     PROCESS PLIMIT CARDS INTO ELEMENT SECTIONS THAT MAY BE READ BY
C     OPTP1D
C     MPT ASSUMED PREPOSITIONED TO PLIMIT CARDS.
C
      INTEGER         COUNT,YCOR,B1P1,NPOW,EPT,NAME(2),SYSBUF,OUTTAP,
     1                DTYP(1),ETP(21),ANY,ALL,STOR(21),BLANK,EJECT,
     2                SCRTH1,ENTRY,X(7),IY(1)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /BLANK / SKP1(2),COUNT,SKP2(2),YCOR,B1P1,NPOW,SKP3(4),NKLW,
     1                MPT,EPT,SKP5(4),SCRTH1,NELTYP,ENTRY(21)
      COMMON /OPTPW1/ KCOR,K(10)
      COMMON /ZZZZZZ/ CORE(1)
      COMMON /NAMES / NRD,NOEOR,NWRT,NWEOR
      COMMON /SYSTEM/ SYSBUF,OUTTAP
      COMMON /GPTA1 / NTYPES,LAST,INCR,NE(1)
      EQUIVALENCE     (STOR(1),K(10)),(CORE(1),X(1)),(X(7),IY(1))
      DATA    ETP   / 21*0 /,  ALL / 4HALL /,  BLANK / 1H  /,
     1        NAME  / 4H OPT,  4HPX        /
C
      MAXW  = 0
      IALL  = 0
      ANY   = 0
      NOCOR = 0
      NOGO  = 0
      NX    = 1
      ASSIGN 10 TO IRET
C
C     MAKE PRELIMINARY PASS
C
   10 IMHERE = 10
      CALL READ (*310,*110,MPT,K,9,0,NWDS)
      IF (K(1) .EQ. ALL) GO TO 30
      DO 20 I = 1,NTYPES
      IF (DTYP(I) .EQ. 0) GO TO 20
      IDX = INCR*(I-1) + 1
      IF (NE(IDX  ) .NE. K(1)) GO TO 20
      IF (NE(IDX+1) .EQ. K(2)) GO TO 40
   20 CONTINUE
      GO TO 50
C
C     ALL SPECIFIED
C
   30 IALL = IALL + 1
      GO TO 10
C
C     LEGAL ELEMENT TYPE
C
   40 I = DTYP(I)
      ETP(I) = ETP(I) + 1
      ANY = ANY + 1
      GO TO 10
C
C     ILLEGAL ELEMENT TYPE
C
   50 NOGO = NOGO + 1
      IF (NOGO .GT. 1) GO TO  70
      CALL PAGE2 (-4)
      WRITE  (OUTTAP,60) UFM
   60 FORMAT (A23,' 2290, THE FOLLOWING ILLEGAL ELEMENT TYPES FOUND ON',
     1       ' PLIMIT CARD')
   70 STOR(NX  ) = K(1)
      STOR(NX+1) = K(2)
      NX = NX + 2
      IF (NX .LT. 20) GO TO 10
   80 I = EJECT(2)
      IF (I .EQ. 0) GO TO 90
      CALL PAGE2 (-2)
      WRITE  (OUTTAP,60) UFM
   90 WRITE  (OUTTAP,100) STOR
  100 FORMAT (1H0,9X,10(2A4,1X))
      NX = 1
      GO TO IRET, (10,130)
C
C     LAST PLIMIT
C
  110 IF (NX .LE. 1) GO TO 130
      ASSIGN 130 TO IRET
      DO 120 I = NX,20
  120 STOR(I) = BLANK
      GO TO 80
C
C     CONTINUE PROCESSING LEGAL CARDS UNLESS ANY = 0
C
  130 IF (ANY.EQ.0 .AND. IALL.EQ.0) GO TO 300
      CALL BCKREC (MPT)
      IMHERE = 130
      CALL READ (*310,*320,MPT,STOR(1),3,NOEOR,NWDS)
C
      LOC1 = 1
C
C     START OF OUTPUT LOOP
C
      DO 290 N = 1,NTYPES
      IDE = DTYP(N)
      IF (IDE .LE. 0) GO TO 290
      IDX = ENTRY(IDE)
      IDX = INCR*(IDX-1)
      NEN = 0
      NDE = ETP(IDE)
      IF (NDE .LE. 0) GO TO 160
      NWDS = 0
C
      IMHERE = 140
      DO 150 M = 1,NDE
  140 CALL READ (*310,*320,MPT,STOR(1),9,NOEOR,NWDS)
      IF (STOR(1) .NE. NE(IDX+1)) GO TO 140
      IF (STOR(2) .NE. NE(IDX+2)) GO TO 140
      CALL OPTPX1 (*260,STOR,NOGO,NEN,LOC1)
  150 CONTINUE
      CALL BCKREC (MPT)
      IMHERE = 150
      CALL READ (*310,*320,MPT,STOR(1),3,NOEOR,NWDS)
C
C     CHECK IF ALL SPECIFIED
C
  160 IF (IALL .LE. 0) GO TO 190
      IMHERE = 170
      DO 180 M = 1,IALL
  170 CALL READ (*310,*320,MPT,STOR(1),9,NOEOR,NWDS)
      IF (STOR(1) .NE. ALL) GO TO 170
      CALL OPTPX1 (*260,STOR,NOGO,NEN,LOC1)
  180 CONTINUE
      CALL BCKREC (MPT)
      IMHERE = 180
      CALL READ (*310,*320,MPT,STOR(1),3,NOEOR,NWDS)
C
C     CONTINUE PROCESSING LEGAL CARDS - SORT ON SECOND WORD
C
  190 IF (NEN .EQ. 0) GO TO 290
      CALL SORT (0,0,4,2,IY(LOC1),NEN)
C
C     CHECK SECOND WORD
C
      I1  = IY(LOC1  )
      I2  = IY(LOC1+1)
      I3  = IY(LOC1+2)
      I4  = IY(LOC1+3)
      LOC2= LOC1 + NEN
      L   = LOC2
      IF (L+4 .GT. YCOR) NWDS = 1
      NX = NEN - 3
      IF (NX .LT. 5) GO TO 250
      DO 240 M = 5,NX,4
      J  = LOC1 + M - 1
      J1 = IY(J  )
      J2 = IY(J+1)
C
      IF (I1 .GE. J1) GO TO 220
      IF (I2 .GE. J1) GO TO 220
C
C     CHECK FOR EXPANDING THE THRU
C
      IF (I2 .NE.    J1-1) GO TO 200
      IF (I3 .NE. IY(J+2)) GO TO 200
      IF (I4 .NE. IY(J+3)) GO TO 200
      I2 = J2
      IF (M .NE. NX) GO TO 240
      IY(NX) = I1
      GO TO 250
C
C     OUTPUT PLIMIT DATA IN SETS OF 4
C
  200 IF (NOGO.GT.0 .OR. NWDS.GT.0) GO TO 210
      IY(L  ) = I1
      IY(L+1) = I2
      IY(L+2) = I3
      IY(L+3) = I4
  210 L = L + 4
      IF (L+3 .GT. YCOR) NWDS = NWDS + 4
      I1 = J1
      I2 = J2
      I3 = IY(J+2)
      I4 = IY(J+3)
      GO TO 240
C
C     OVERLAPPING RANGE ERROR CONDITION
C
  220 CALL PAGE2 (-2)
      WRITE  (OUTTAP,230) UFM,I1,I2,J1,J2
  230 FORMAT (A23,' 2291, PLIMIT RANGE INCORRECT FOR',I8,' THRU',I8,
     1       ' AND',I8,' THRU',I8,'.')
      I1 = J1
      I2 = J2
      NOGO = NOGO + 1
  240 CONTINUE
C
C     AFTER ELEMENTS THAT MAY BE OPTIMIZED, FLUSH BUFFER.
C
  250 IF (L+3 .GT. YCOR) GO TO 260
      IY(L  ) = IY(NX  )
      IY(L+1) = IY(NX+1)
      IY(L+2) = IY(NX+2)
      IY(L+3) = IY(NX+3)
      L = L + 3
      GO TO 280
C
C     INSUFFICIENT CORE FOR ELEMENTS OF THIS TYPE
C
  260 CALL PAGE2 (-2)
      NOCOR = 1
      NWDS  = NWDS + 3
      WRITE  (OUTTAP,270) UFM,NE(IDX+1),NE(IDX+2),NWDS
  270 FORMAT (A23,' 2292, INSUFFICIENT CORE FOR PLIMIT DATA, ELEMENT ',
     1       2A4,I5,' WORDS SKIPPED.')
      NOGO = NOGO + 1
C
C     WRITE ONTO SCRATCH FILE
C
  280 IF (NOGO .GT. 0) GO TO 290
      MAXW = MAX0(L,MAXW)
      STOR(1) = IDE
      STOR(2) = (L-LOC2+1)/4
      CALL WRITE (SCRTH1,STOR(1),2,NOEOR)
C
C     AFTER ELEMENT TYPE, NUMBER WORDS - WRITE DATA
C
      CALL WRITE (SCRTH1,IY(LOC2),L-LOC2+1,NWEOR)
C
  290 CONTINUE
C
C     END OF OUTPUT LOOP
C
      CALL EOF (SCRTH1)
  300 IF (NOGO  .EQ. 0) NKLW  = MAXW
      IF (NOGO  .GT. 0) COUNT = -1
      IF (NOCOR .NE. 0) NKLW  = -64
      RETURN
C
C     ILLEGAL EOF (310), EOR (320)
C
  310 J = -2
      NWDS = -222
      GO TO 330
  320 J = -3
  330 WRITE  (OUTTAP,340) IMHERE,NWDS
  340 FORMAT ('  ERROR IN OPTPX.  IMHERE=',I4,',  NWDS=',I6)
      CALL MESAGE (J,MPT,NAME)
      GO TO 300
      END

      SUBROUTINE CMIWRT (ICODE,NAME1,NAME2,LOC,NW,A,IZ)
C
C     THIS SUBROUTINE WRITES FORMATTED SOF ITEMS.
C     ICODE = 1 FOR EQSS    ICODE = 2 FOR BGSS    ICODE = 3 FOR CSTM
C     ICODE = 4 FOR PLTS    ICODE = 5 FOR LODS    ICODE = 7 FOR LOAP
C     NAME1 IS PSEUDOSTRUCTURE NAME, NAME2 IS COMPONENT NAME
C
      EXTERNAL        ANDF
      INTEGER         OUTT,ANDF
      DIMENSION       NAME1(2),NAME2(2),A(1),IZ(1),IBITS(32),IPL(6),
     1                IH1(96),IH2(96),IH3(96),IH4(96),IH5(96),IH6(96)
      COMMON /SYSTEM/ XXX,OUTT,JUNK1(6),NLPP,JUNK2(2),NLINE
      COMMON /OUTPUT/ ITITL(96),IHEAD(96)
      DATA IH1 / 9*4H    ,4H EQS,4HS IT,4HEM F,4HOR S,4HUBST,4HRUCT,
     1           4HURE ,2*4H    ,4H COM,4HPONE,4HNT  ,11*4H    ,4HGRID,
     2           4H POI,4HNT  ,4H INT,4HERNA,4HL   ,4H  CO,4HMPON,
     3           4HENT ,2*4H    ,4H GRI,4HD PO,4HINT ,4H  IN,4HTERN,
     4           4HAL  ,4H   C,4HOMPO,4HNENT,2*4H    ,4H  GR,4HID P,
     5           4HOINT,4H   I,4HNTER,4HNAL ,4H    ,4HCOMP,4HONEN,
     6           4HT   ,4H    ,4HID  ,4H    ,4H POI,4HNT I,4HD   ,
     7           4H    ,4H DOF,4*4H    ,4H ID ,4H    ,4H  PO,4HINT ,
     8           4HID  ,4H    ,4H  DO,4HF   ,3*4H    ,4H  ID,4H    ,
     9           4H   P,4HOINT,4H ID ,4H    ,4H   D,4HOF  ,4H     /
      DATA IH2 / 11*4H    ,4HBGSS,4H ITE,4HM FO,4HR SU,4HBSTR,4HUCTU,
     1           4HRE  ,21*4H    ,4HINTE,4HRNAL,4H    ,4H CST,4HM ID,
     2           4*4H    ,4H  C ,4HO O ,4HR D ,4HI N ,4HA T ,4HE S ,
     3           17*4H    ,4HPOIN,4HT ID,4H    ,4H   N,4HO.  ,3*4H    ,
     4           4HX1  ,3*4H    ,4HX2  ,3*4H    ,4HX3  ,8*4H     /
      DATA IH3 / 12*4H    ,4HCSTM,4H ITE,4HM FO,4HR SU,4HBSTR,
     1           4HUCTU,4HRE  ,13*4H    ,2*4H    ,4H CST,4HM   ,4HTYPE,
     2           2*4H    ,4HC O ,4HO R ,4HD I ,4HN A ,4HT E ,4HS   ,
     3           4HO F ,4H  O ,4HR I ,4HG I ,4HN   ,3*4H    ,4H   T,
     4           4H R A,4H N S,4H F O,4H R M,4H A T,4H I O,4H N  ,
     5           5*4H    ,4H  ID,5*4H    ,4HX1  ,3*4H    ,4HX2  ,
     6           3*4H    ,4HX3  ,6*4H    ,4H   M,4H A T,4H R I,4H X  ,
     7           5*4H      /
      DATA IH4 / 12*4H    ,4HPLTS,4H ITE,4HM FO,4HR SU,4HBSTR,
     1           4HUCTU,4HRE  ,13*4H    ,2*4H    ,4HCOMP,4HONEN,4HT   ,
     2           4H    ,4H C O,4H O R,4H D I,4H N A,4H T E,4H S  ,
     3           4H O F,4H   O,4HR I ,4HG I ,4HN   ,3*4H    ,4H   T,
     4           4H R A,4H N S,4H F O,4H R M,4H A T,4H I O,4H N  ,
     5           6*4H    ,4H  NA,4HME  ,3*4H    ,4H X1 ,3*4H    ,
     6           4H X2 ,3*4H    ,4H X3 ,6*4H    ,4H   M,4H A T,4H R I,
     7           4H X  ,6*4H      /
      DATA IH5 / 12*4H    ,4HLODS,4H ITE,4HM FO,4HR SU,4HBSTR,
     1           4HUCTU,4HRE  ,18*4H    ,4H COM,4HPONE,4HNT  ,4H  NU,
     2           4HMBER,4H OF ,21*4H    ,5*4H    ,4H   N,4HAME ,
     3           4H    ,4H  LO,4HAD S,4HETS ,4H  L ,4HO A ,4HD   ,
     4           4HS E ,4HT   ,4HI D ,4HE N ,4HT I ,4HF I ,4HC A ,
     5           4HT I ,4HO N ,4H  N ,4HU M ,4HB E ,4HR S ,5*4H      /
      DATA IH6 / 9*4H         ,4HEQSS,4H ITE,4HM - ,4HSCAL,4HAR I,
     1           4HNDEX,4H LIS,4HT FO,4HR SU,4HBSTR,4HUCTU,4HRE  ,
     2           11*4H        ,4H INT,4HERNA,4HL   ,4H INT,4HERNA,
     3           4HL   ,4H  CO,4HMPON,4HENT ,2*4H         ,4H  IN,
     4           4HTERN,4HAL  ,4H  IN,4HTERN,4HAL  ,4H   C,4HOMPO,
     5           4HNENT,2*4H         ,4H   I,4HNTER,4HNAL ,4H   I,
     6           4HNTER,4HNAL ,4H    ,4HCOMP,4HONEN,4HT   ,4H POI,
     7           4HNT I,4HD   ,4H  SI,4HL ID,2*4H         ,4H DOF,
     8           3*4H         ,4H  PO,4HINT ,4HID  ,4H   S,4HIL I,
     9           4HD   ,4H    ,4H  DO,4HF   ,2*4H         ,4H   P,
     A           4HOINT,4H ID ,4H    ,4HSIL ,4HID  ,4H    ,4H   D,
     B           4HOF  ,4H     /
      DATA LOAP/ 4HLOAP/
C
      IST  = LOC
      IFIN = LOC + NW - 1
      GO TO (1,2,3,4,5,6,5,8), ICODE
C
C     EQSS ITEM
C
    1 DO 100 I = 1,96
  100 IHEAD(I) = IH1(I)
C
C     INSERT NAMES INTO HEADING
C
      IHEAD(17) = NAME1(1)
      IHEAD(18) = NAME1(2)
      IHEAD(22) = NAME2(1)
      IHEAD(23) = NAME2(2)
      CALL PAGE
      IF (NW .NE. 0) GO TO 140
      WRITE (OUTT,1009)
      GO TO 700
C
  140 DO 101 I = IST,IFIN,9
      NLINE = NLINE + 1
      IF (NLINE .LE. NLPP) GO TO 150
      CALL PAGE
      NLINE = NLINE + 1
  150 CONTINUE
      ICOMP = ANDF(IZ(I+2),63)
      CALL BITPAT (ICOMP,IBITS(1))
      I2 = 3
      IF (I+5 .GT. IFIN) GO TO 151
      ICOMP = ANDF(IZ(I+5),63)
      CALL BITPAT (ICOMP,IBITS(4))
      I2 = 6
      IF (I+8 .GT. IFIN) GO TO 151
      ICOMP = ANDF(IZ(I+8),63)
      CALL BITPAT (ICOMP,IBITS(7))
      I2 = 9
  151 CONTINUE
      WRITE (OUTT,1000) (IZ(I+J-1),IZ(I+J),IBITS(J),IBITS(J+1),J=1,I2,3)
  101 CONTINUE
      GO TO 700
C
C     EQSS - SCALER INDEX LIST
C
    8 DO 600 I = 1,96
  600 IHEAD(I) = IH6(I)
      IHEAD(22) = NAME1(1)
      IHEAD(23) = NAME1(2)
      CALL PAGE
C
      IP = 0
      DO 603 I = IST,IFIN,6
      NLINE = NLINE + 1
      IF (NLINE .LE. NLPP) GO TO 601
      CALL PAGE
      NLINE = NLINE + 1
  601 CONTINUE
      KCODE = IZ(I+1)
      CALL BITPAT (KCODE,IBITS(1))
      I2 = 2
      IPL(1) = IP + 1
      IF (I+3 .GT. IFIN) GO TO 602
      KCODE = IZ(I+3)
      CALL BITPAT (KCODE,IBITS(3))
      I2 = 4
      IPL(3) = IP + 2
      IF (I+5 .GT. IFIN) GO TO 602
      KCODE = IZ(I+5)
      CALL BITPAT (KCODE,IBITS(5))
      I2 = 6
      IPL(5) = IP + 3
  602 CONTINUE
      WRITE (OUTT,1000) (IPL(J),IZ(I+J-1),IBITS(J),IBITS(J+1),J=1,I2,2)
      IP = IP + 3
  603 CONTINUE
      GO TO 700
C
C     BGSS ITEM
C
    2 DO 200 I = 1,96
  200 IHEAD(I)  = IH2(I)
      IHEAD(20) = NAME1(1)
      IHEAD(21) = NAME1(2)
      CALL PAGE
      J = 0
      DO 201 I = IST,IFIN,4
      J = J + 1
      NLINE = NLINE + 1
      IF (NLINE .LE. NLPP) GO TO 250
      CALL PAGE
      NLINE = NLINE + 1
  250 CONTINUE
      WRITE (OUTT,1001) J,IZ(I),A(I+1),A(I+2),A(I+3)
  201 CONTINUE
      GO TO 700
C
C     CSTM ITEM
C
    3 DO 300 I = 1,96
  300 IHEAD(I)  = IH3(I)
      IHEAD(20) = NAME1(1)
      IHEAD(21) = NAME1(2)
      CALL PAGE
      DO 301 I = IST,IFIN,14
      NLINE = NLINE + 4
      IF (NLINE .LE. NLPP) GO TO 350
      CALL PAGE
      NLINE = NLINE + 4
  350 CONTINUE
      I1 = I + 2
      I2 = I + 13
      WRITE (OUTT,1002) IZ(I),IZ(I+1),(A(KK),KK= I1,I2)
  301 CONTINUE
      GO TO 700
C
    4 DO 400 I = 1,96
C
C     PLTS ITEM
C
  400 IHEAD(I)  = IH4(I)
      IHEAD(20) = NAME1(1)
      IHEAD(21) = NAME1(2)
      CALL PAGE
      DO 401 I = IST,IFIN,14
      NLINE = NLINE + 4
      IF (NLINE .LE. NLPP) GO TO 450
      CALL PAGE
      NLINE = NLINE + 4
  450 CONTINUE
      I1 = I + 2
      I2 = I + 13
      WRITE (OUTT,1004) IZ(I),IZ(I+1),(A(J),J=I1,I2)
  401 CONTINUE
      GO TO 700
C
C     LODS AND LOAP ITEMS
C
    5 DO 500 I = 1,96
  500 IHEAD(I)  = IH5(I)
      IHEAD(20) = NAME1(1)
      IHEAD(21) = NAME1(2)
      IF (ICODE .EQ. 7) IHEAD(13) = LOAP
      CALL PAGE
    6 IF (NW.EQ.0 .OR. NW.EQ.1) GO TO 520
      NL = NW/5 + 3
      NLINE = NLINE + NL
      IF (NLINE .LE. NLPP) GO TO 550
      CALL PAGE
      NLINE = NLINE + NL
  550 CONTINUE
      IST1 = IST + 1
      WRITE (OUTT,1006) NAME2(1),NAME2(2),IZ(IST),(IZ(J),J=IST1,IFIN)
      GO TO 700
C
  520 NLINE = NLINE + 2
      IF (NLINE .LE. NLPP) GO TO 560
      CALL PAGE
      NLINE = NLINE + 2
  560 CONTINUE
      WRITE (OUTT,1008) NAME2(1),NAME2(2)
  700 RETURN
C
 1000 FORMAT (6X,I8,4X,I8,6X,A4,A2,2(13X,I8,4X,I8,6X,A4,A2))
 1001 FORMAT (33X,I8,4X,I8,3X,3(3X,E13.6))
 1002 FORMAT (/10X,I8,3X,I4,3X,3(3X,E13.6),4X,3(3X,E13.6),
     1        /80X,3(3X,E13.6), /80X,3(3X,E13.6))
 1004 FORMAT (/14X,2A4,3X,3(3X,E13.6),4X,3(3X,E13.6)
     1        /77X,3(3X,E13.6), /77X,3(3X,E13.6))
 1006 FORMAT (/26X,2A4,3X,I8,5X,6(2X,I8)/(50X,2X,I8,2X,I8,2X,I8,2X,I8,
     1        2X,I8,2X,I8,/))
 1008 FORMAT (/26X,2A4,17X,32HNO LOAD SETS FOR THIS COMPONENT. )
 1009 FORMAT (/30X,64HALL DEGREES OF FREEDOM FOR THIS COMPONENT HAVE BEE
     1N REDUCED OUT. )
      END

      SUBROUTINE SMCDMP1 (  ZI, ZR, ZD )
      INTEGER          ZI(10)
      REAL             ZR(10)
      DOUBLE PRECISION ZD(10)
      INCLUDE   'SMCOMX.COM'
      DO 1000 ICOL = 1, NCOL
      IND = ( ICOL-1 ) * 4 + 1
      INDEXR = ZI( IND )
      IF ( ZI( INDEXR ) .EQ. 0 ) GO TO 700
      ICOLUM  = ZI( INDEXR   )
      LENROWS = ZI( INDEXR+1 )
      NWORDS  = ZI( INDEXR+2 )
      LENVALS = ZI( INDEXR+3 )
      WRITE( NOUT,901) ICOLUM
901   FORMAT(/,' -----------------------------COLUMN NUMBER   =',I10)
      WRITE ( NOUT, 900 )  ZI(IND), ZI(IND+1), ZI(IND+2), ZI(IND+3)
     &,                    LENROWS, LENVALS, NWORDS
900   FORMAT(20X,' COLUMN DIRECTORY: INDEX                    =',I10
     &,/    ,20X,' FIRST COLUMN DATA NEEDED FOR THIS PIVOT    =',I10
     &,/    ,20X,' LAST PIVOT COLUMN TO USE THIS COLUMN       =',I10
     &,/    ,20X,' SAVPOS                                     =',2X,Z8
     &,/    ,20X,' NUMBER OF WORDS DEFINING ROW NUMBERS       =',I10
     &,/    ,20X,' NUMBER OF NON-ZERO TERMS IN THIS COLUMN    =',I10
     &,/    ,20X,' TOTAL NUMBER OF WORDS ALLOCATED FOR COLUMN =',I10
     & )
      INDEXR = INDEXR + 4
      INDEXV = INDEXR+LENROWS
      INDEXVD= INDEXV / 2 + 1
      IEND   = INDEXV
50    IROW   = ZI( INDEXR )
      NTERMS = ZI( INDEXR+1 )
      WRITE( NOUT,905) IROW, NTERMS, KTYPE
905   FORMAT(' ROW, TERMS, TYPE=',3I10)
      GO TO ( 100, 200, 300, 400 ), KTYPE
100   WRITE( NOUT,906) (ZR(INDEXV+K-1),K=1,NTERMS)
906   FORMAT( 5E16.8 )
      INDEXV = INDEXV + NTERMS
      INDEXR = INDEXR + 2
      GO TO 500
200   WRITE( NOUT,907) (ZD(INDEXVD+K-1),K=1,NTERMS)
907   FORMAT( 5D16.8 )
      INDEXV = INDEXV  + 2*NTERMS
      INDEXVD= INDEXVD + NTERMS
      INDEXR = INDEXR + 2
      GO TO 500
300   WRITE( NOUT,906) (ZR(INDEXV+K-1),K=1,2*NTERMS)
      INDEXV = INDEXV + 2*NTERMS
      INDEXR = INDEXR + 2
      GO TO 500
400   WRITE( NOUT,907) (ZD(INDEXVD+K-1),K=1,2*NTERMS)
      INDEXV = INDEXV  + 4*NTERMS
      INDEXVD= INDEXVD + 2*NTERMS
      INDEXR = INDEXR + 2
      GO TO 500
500   IF ( INDEXR .GE. IEND ) GO TO 1000   
      GO TO 50
700   WRITE( NOUT,908) 
908   FORMAT( ' COLUMN HAS BEEN PUT TO SPILL FILE')
1000  CONTINUE
7777  RETURN
      END

      SUBROUTINE MBGAW(BOXL,DPHI,WS,PAW,PAF1,PAF2,Q,Q1,Q2,M,KC,KC1,KC2)
C
C     MAIN PLANE BOXES
C     (NEW MSC METHOD USED)
C
      COMPLEX WS,DPHI,Q(1),Q1(1),Q2(1)
      WS  =  (-0.5 * AMIN0(M,2) * BOXL ) * DPHI
      IF( PAW .LT. 0.005 ) GO TO 120
      Q(KC) = PAW * WS
  120 IF( PAF1 .LT. 0.005 ) GO TO 140
      Q1(KC1) = PAF1 * WS
  140 IF( PAF2 .LT. 0.005 ) GO TO 300
      Q2(KC2) = PAF2 * WS
  300 CONTINUE
      RETURN
      END

      SUBROUTINE GIGTKA(MULTI,SINGLE,OMIT)
C
      LOGICAL MULTI,SINGLE,OMIT
      INTEGER CORE,USET1,GM,GO,GKA,GKG,GKNB,GKM,SCR1,GKAB,GKF,
     *        GKS,GKO,USETA,GKN
      INTEGER  UM,UO,UR,USG,USB,UL,UA,UF,US,UN,UG
C
      COMMON /PATX/  LC,N,NO,NY,USET1,IBC
      COMMON /BITPOS/ UM,UO,UR,USG,USB,UL,UA,UF,US,UN,UG
      COMMON /ZZZZZZ/ CORE(1)
      COMMON/GICOM/ SPLINE,USETA,CSTM,BGPT,SILA,EQAERO,GM,GO,GKA,
     *              KSIZE,GSIZE,SCR1,GKG,GKNB,GKM,GKAB
C
C-----------------------------------------------------------------------
C
      LC = KORSZ(CORE)
      GKF = GKNB
      GKS = GKM
      GKO = GKS
      USET1 = USETA
C
C     REDUCE TO N SET IF MULTI POINT CONSTRAINTS
C
      GKN = GKG
      IF(.NOT.MULTI) GO TO 20
      IF(.NOT.SINGLE.AND..NOT.OMIT) GKN = GKA
      CALL CALCV(SCR1,UG,UN,UM,CORE)
      CALL SSG2A(GKG,GKNB,GKM,SCR1)
      CALL SSG2B(GM,GKM,GKNB,GKN,1,1,1,SCR1)
C
C     PARTITION INTO F SET IF SINGLE POINT CONSTRAINTS
C
   20 IF(.NOT.SINGLE) GO TO 30
      IF(.NOT.OMIT) GKF = GKA
      CALL CALCV(SCR1,UN,UF,US,CORE)
      CALL SSG2A(GKN,GKF,  0,SCR1)
      GO TO 40
C
C     REDUCE TO A SET IF OMITS
C
   30 GKF = GKN
   40 IF(.NOT.OMIT) GO TO 50
      CALL CALCV(SCR1,UF,UA,UO,CORE)
      CALL SSG2A(GKF,GKAB,GKO,SCR1)
      CALL SSG2B(GO,GKO,GKAB,GKA,1,1,1,SCR1)
   50 RETURN
      END

      SUBROUTINE HESS2(NROW,IDEN,IPV)
C
C     HESS2  WILL GENERATE  AN IDENTITY MATRIX AND A PARTIIONING VECTOR
C
      INTEGER MCB(7) , IZ(1)
      INTEGER SYSBUF
C
      COMMON /PACKX/IT1,IT2,II,JJ,INCR
      COMMON /SYSTEM/ KSYSTM(65)
      COMMON /ZZZZZZ/Z(1)
C
      EQUIVALENCE ( KSYSTM( 1) , SYSBUF )
      EQUIVALENCE ( Z(1),IZ(1) )
C
C ----------------------------------------------------------------------
C
      CALL MAKMCB( MCB, IDEN, NROW, 8, 1 )
      NZ = KORSZ(Z)
      IBUF1 = NZ- SYSBUF
      CALL GOPEN(IDEN,IZ(IBUF1),1)
      IT1=1
      IT2=1
      INCR=1
      Z(1)=-1.0
      DO 10 I=1,NROW
      II = I
      JJ=I
      CALL PACK(Z,IDEN,MCB)
   10 CONTINUE
      CALL CLOSE(IDEN,1)
      CALL WRTTRL(MCB)
C
C     BUILD PARTITIONING VECTOR
C
      CALL MAKMCB( MCB, IPV, 2*NROW, 2, 1 )
      CALL GOPEN(IPV,IZ(IBUF1),1)
      DO 20 I=1,NROW
      Z(I)=1.0
   20 CONTINUE
      II = NROW+1
      JJ= 2*NROW
      CALL PACK(Z,IPV,MCB)
      CALL WRTTRL(MCB)
      CALL CLOSE(IPV,1)
      RETURN
      END

      FUNCTION KOMPNT (IG,IC,IDEG,IW,ICC,JG)
C
C     THIS ROUTINE IS USED ONLY IN BANDIT MODULE
C
C     THIS FUNCTION HAS AS ITS VALUE THE NUMBER OF COMPONENTS STORED
C     IN THE CONNECTION ARRAY IG.
C     ALSO, IC AND ICC ARE SET UP.
C     IC(I) =COMPONENT INDEX FOR NODE I
C     ICC(I)=THE STARTING POSITION TO BE USED FOR LABELS IN COMPONENT I
C     THUS, ICC(I+1)-ICC(I)= THE NUMBER OF NODES IN COMPONENT I
C
C     INTEGER          BUNPK
      DIMENSION        IG(1),    IC(1),    IDEG(1),  IW(1),    ICC(1),
     1                 JG(1)
      COMMON /BANDS /  NN,       MM
C
      DO 100 I=1,NN
      ICC(I)=0
      IC(I)=0
  100 CONTINUE
      NC=0
      ICC(1)=1
  105 DO 110 I=1,NN
      IF (IC(I)) 110,120,110
  110 KOMPNT=NC
      GO TO 210
  120 NC=NC+1
      KI=0
      KO=1
      IW(1)=I
      IC(I)=NC
      IF (NC-1) 130,125,125
  125 IS=ICC(NC)+1
      ICC(NC+1)=IS
  130 KI=KI+1
      II=IW(KI)
      N =IDEG(II)
      IF (N) 140,105,140
  140 CALL BUNPAK(IG,II,N,JG)
      DO 200 I=1,N
      IA=JG(I)
      IF (IC(IA)) 200,150,200
  150 IC(IA)=NC
      KO=KO+1
      IW(KO)=IA
      IS=ICC(NC+1)+1
      ICC(NC+1)=IS
  200 CONTINUE
      IF (KO-KI) 105,105,130
  210 RETURN
      END

      SUBROUTINE PSQAD2
C  THIS SUBROUTINE IS THE DRIVER FOR THE QUAD2 CALCULATIONS IN
C  PLA3
C
C     ECPT FOR QUAD2
C
C  1  EL.ID
C  2  GRID A
C  3  GRID B
C  4  GRID C
C  5  GRID D
C  6  THETA
C  7  MAT ID
C  8  T
C  9  MS MASS
C 10  CSID 1
C 11  X1
C 12  Y1
C 13  Z1
C 14  CSID 2
C 15  X2
C 16  Y2
C 17  Z2
C 18  CSID 3
C 19  X3
C 20  Y3
C 21  Z3
C 22  CSID 4
C 23  X4
C 24  Y4
C 25  Z4
C 26  TEMP
C 27  EPS0
C 28  EPSS
C 29  ESTAR
C 30  SIGXS
C 31  SIGYS
C 32  SIGXXS
C 33  MXS
C 34  MYS
C 35  MXYS
C 36  VXS
C 37  VYS
C 38  U(A) (6X1)
C 44  U(B) (6X1)
C 50  U(C) (6X1)
C 56  U(D) (6X1)
C
C     ******************************************************************
      REAL NU
C
      DIMENSION NECPT(26), NECPTS(26)
C
      COMMON /PLA32E/ ECPT(26),EPS0,EPSS,ESTAR,SIGXS,SIGYS,SIGXYS,
     1     FORVEC(5), UI(24),  DUMMY(39)
      COMMON /PLA3ES/ ECPTSA(100),PH1OUT(200)
      COMMON /PLA3UV/  IVEC, Z(24)
C
C SCRATCH BLOCK  325 CELLS
C
      COMMON /PLA32S/S(3),DUM(297),TAU0 ,TAU1 ,TAU2 ,F,SX,SY,DEPS,DEPSS,
     1                EPS1,EPS2, DUM1,IDUM2,IDUM3(3,3)
     2,              EXTRA(4)
      COMMON /MATIN/ MATID,INFLAG,ELTEMP,PLAARG,SINTH,COSTH
      COMMON /MATOUT/ G11,G12,G13,G22,G23,G33
      COMMON /PLA32C/ GAMMA, GAMMAS, IPASS
      COMMON /PLAGP/  GP(9), MIDGP   , ELID
C
      EQUIVALENCE (NECPT(7),MATID1) , (ECPT(1),NECPT(1)) , (G11,PLAANS),
     1            (G13,NU)   , (G11,ESUB0)
     2,  (NECPTS(1),ECPTSA(1))
     3,   (G12,NIROF)
C
C SETUP GP MATRIX FOR PLAMAT
C
      ELID = ECPT(1)
      MIDGP = MATID1
      DO 10 I=1,9
   10 GP(I)=0.0
      TAU0  = SQRT(SIGXS**2 - SIGXS*SIGYS + SIGYS**2 + 3.0*SIGXYS**2)
      IF(ESTAR .EQ. 0.0) GO TO 50
      IF(IPASS .NE. 1  ) GO TO 20
      MATID = MATID1
      COSTH = 1.0
      SINTH = 0.0E0
      INFLAG= 2
C
      CALL MAT(ECPT(1))
C
      GP(1) = G11
      GP(2) = G12
      GP(3) = G13
      GP(4) = G12
      GP(5) = G22
      GP(6) = G23
      GP(7) = G13
      GP(8) = G23
      GP(9) = G33
      GO TO 50
   20 IF(TAU0  .EQ. 0.0) GO TO 50
      MATID = MATID1
      INFLAG = 1
C
      CALL MAT(ECPT(1))
C
      F =   9.0*(ESUB0 - ESTAR) / (4.0 * TAU0**2 * ESTAR)
      SX = (2.0*SIGXS - SIGYS)/ 3.0
      SY = (2.0*SIGYS - SIGXS)/ 3.0
      GP(1) = (1.0+SX**2*F) / ESUB0
      GP(2) = (-NU+SX*SY*F) / ESUB0
      GP(3) = (2.0*SIGXYS*SX*F) / ESUB0
      GP(4) = GP(2)
      GP(5) = (1.0+SY**2*F) / ESUB0
      GP(6) = (2.0*SIGXYS*SY*F) / ESUB0
      GP(7) = GP(3)
      GP(8) = GP(6)
      GP(9) = (2.0*(1.0+NU) + 4.0*F*SIGXYS**2) / ESUB0
C
C     NO NEED TO COMPUTE DETERMINANT SINCE IT IS NOT USED SUBSEQUENTLY.
      IDUM2 = -1
      CALL INVERS(3,GP,3,0,0,DUM1,IDUM2,IDUM3)
C
C CHECK SINGULARITY
C
      IF( IDUM2 .EQ. 2) CALL MESAGE(-30,38,ECPT(1))
C
C CALCULATE PHASE I STRESSES
C
   50 DO 30 I = 1,32
   30 ECPTSA(I) = ECPT(I)
      NECPTS(2) = 1
      NECPTS(3) = 7
      NECPTS(4) = 13
      NECPTS(5) = 19
C
      CALL PSTQ1(4)
C
C
C CALCULATE PHASE II STRESSES
C
      IVEC = 1
      DO 60 I = 1,24
   60 Z(I) = UI(I)
      DO 70 I = 1,200
   70 ECPTSA(I) = PH1OUT(I)
      S(1) = SIGXS
      S(2) = SIGYS
      S(3) = SIGXYS
      I201 = 201
      ECPTSA(I201) = ECPT(1)
      DO 75 I=1,5
   75 ECPTSA(I+201) = FORVEC(I)
C
      CALL PSTQ2(4)
C
C
C  UPDATE ECPT FOR STRESSES
C
      SIGXS = S(1)
      SIGYS = S(2)
      SIGXYS = S(3)
C
C     NEW FORCES ARE IN  /PLA3ES/ AT LOCATIONS 202-206
C
      DO 76 I=1,5
   76 FORVEC(I)   = ECPTSA(I+201)
      TAU1  = SQRT(SIGXS**2 - SIGXS*SIGYS + SIGYS**2 + 3.0*SIGXYS**2)
      MATID= MATID1
      INFLAG = 8
      PLAARG = TAU1
C
      CALL MAT(ECPT(1))
C
C
C TEST FOR TAU 1 OUTSIDE THE RANGE OF FUNCTION
C
      IF ( NIROF . EQ. 1 ) GO TO 80
C
C RETURNS EPS SUB 1 GIVEN TAU1
C
      EPS1 = PLAANS
      DEPS = EPS1 - EPSS
      DEPSS= EPSS - EPS0
      EPS2 = EPS1 + GAMMA * DEPS
      INFLAG=6
      PLAARG = EPS2
C
      CALL MAT(ECPT(1))
C
C RETURNS  TAU2 GIVEN EPS2
C
      TAU2  = PLAANS
      ESTAR = 0.0
      IF( (EPS2 - EPS1) .NE. 0.0) ESTAR = (TAU2 - TAU1) / (EPS2-EPS1)
      EPS0  = EPSS
      EPSS  = EPS1
      RETURN
C
   80 ESTAR = 0.0
      RETURN
      END

      SUBROUTINE KTRPLS
C
C     STIFFNESS SUBROUTINE FOR HIGHER ORDER PLATE ELEMENT CTRPLT1
C
C     ECPT ENTRIES
C
C     ECPT( 1) = ELEMENT ID                               INTEGER
C     ECPT( 2) = SCALAR INDEX NUMBER FOR GRID POINT 1     INTEGER
C     ECPT( 3) = SCALAR INDEX NUMBER FOR GRID POINT 2     INTEGER
C     ECPT( 4) = SCALAR INDEX NUMBER FOR GRID POINT 3     INTEGER
C     ECPT( 5) = SCALAR INDEX NUMBER FOR GRID POINT 4     INTEGER
C     ECPT( 6) = SCALAR INDEX NUMBER FOR GRID POINT 5     INTEGER
C     ECPT( 7) = SCALAR INDEX NUMBER FOR GRID POINT 6     INTEGER
C     ECPT( 8) = THETA                                    REAL
C     ECPT( 9) = MATERIAL ID 1                            INTEGER
C     ECPT(10) = THICKNESS T1 AT GRID POINT G1
C     ECPT(11) = THICKNESS T3 AT GRID POINT G3
C     ECPT(12) = THICKNESS T5 AT GRID POINT G5
C     ECPT(13) = MATERIAL ID 2                            INTEGER
C     ECPT(14) = THICKNESS TSHR1 FOR TRANSVERSE SHEAR AT GRID
C     ECPT(15) = THICKNESS TSHR3 FOR TRANSVERSE SHEAR AT GRID
C     ECPT(16) = THICKNESS TSHR5 FOR TRANSVERSE SHEAR AT GRID
C     ECPT(17) = NON-STRUCTURAL MASS                      REAL
C     ECPT(18) = DISTANCE Z11 FOR STRESS CALCULATION AT GRID 1
C     ECPT(19) = DISTANCE Z21 FOR STRESS CALCULATION AT GRID 1
C     ECPT(20) = DISTANCE Z13 FOR STRESS CALCULATION AT GRID 3
C     ECPT(21) = DISTANCE Z23 FOR STRESS CALCULATION AT GRID 3
C     ECPT(22) = DISTANCE Z15 FOR STRESS CALCULATION AT GRID 5
C     ECPT(23) = DISTANCE Z25 FOR STRESS CALCULATION AT GRID 5
C
C     X1,Y1,Z1 FOR ALL SIX POINTS ARE IN NASTRAN BASIC SYSTEM
C
C     ECPT(24) = COORDINATE SYSTEM ID FOR GRID A          INTEGER
C     ECPT(25) = COORDINATE X1                            REAL
C     ECPT(26) = COORDINATE Y1                            REAL
C     ECPT(27) = COORDINATE Z1                            REAL
C     ECPT(28) = COORDINATE SYSTEM ID FOR GRID B          INTEGER
C     ECPT(29) = COORDINATE X1                            REAL
C     ECPT(30) = COORDINATE Y1                            REAL
C     ECPT(31) = COORDINATE Z1                            REAL
C     ECPT(32) = COORDINATE SYSTEM ID FOR GRID C          INTEGER
C     ECPT(33) = COORDINATE X1                            REAL
C     ECPT(34) = COORDINATE Y1                            REAL
C     ECPT(35) = COORDINATE Z1                            REAL
C     ECPT(36) = COORDINATE SYSTEM ID FOR GRID D          INTEGER
C     ECPT(37) = COORDINATE X1                            REAL
C     ECPT(38) = COORDINATE Y1                            REAL
C     ECPT(39) = COORDINATE Z1                            REAL
C     ECPT(40) = COORDINATE SYSTEM ID FOR GRID E          INTEGER
C     ECPT(41) = COORDINATE X1                            REAL
C     ECPT(42) = COORDINATE Y1                            REAL
C     ECPT(43) = COORDINATE Z1                            REAL
C     ECPT(44) = COORDINATE SYSTEM ID FOR GRID F          INTEGER
C     ECPT(45) = COORDINATE X1                            REAL
C     ECPT(46) = COORDINATE Y1                            REAL
C     ECPT(47) = COORDINATE Z1                            REAL
C     ECPT(48) = ELEMENT TEMPERATURE                      REAL
C
      LOGICAL         IMASS,NOTS,NOGO,UNIBEN
      INTEGER         NAME(2),INDEX(20,3),XPOWER(20),YPOWER(20),ICS(6),
     1                NL(6),IEST(42),XTHK(10),YTHK(10),SAVE(6),SMALL(6),
     2                DICT(11),FLAGS,ELTYPE,ELID,ESTID,PRECIS,SIL1,SIL2
      REAL            NSM,IVECT(3),JVECT(3),KVECT(3),F(14,14),
     1                XC(6),YC(6),ZC(6),CC(10),KSUP(36),KSUPT(36),
     2                E(18),CMT(1296),QQQ(20,20),QQQINV(360),MTR3(400),
     3                KTR3(400),CSUB(3,3),CSUBT(6,3),TS6(40),TS1(60),
     4                TS6S(40),TS2(60),TS7(60),TRAND(9),BALOTR(36),
     5                KSUB(6,6),KSUBT(6,6)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /BLANK / NOK,NOM
      COMMON /SMA1DP/ CM1(18,18)
      COMMON /EMGEST/ EST(100)
      COMMON /EMGDIC/ ELTYPE,LDICT,NLOCS,ELID,ESTID
      COMMON /EMGPRM/ ICORE,JCORE,NCORE,DUM(12),FLAGS(3),PRECIS
      COMMON /SMA1IO/ X,Y,Z,DISTA,DISTB,DISTC,A1,A2,A3,AA1,AA2,AA3
      COMMON /SYSTEM/ KSYSTM(65)
      COMMON /MATIN / MATID,MATFLG,ELTEMP,PLA34,SINTH,COSTH
      COMMON /MATOUT/ EM(6),RHOY,ALF(3),TREF,GSUBE,SIGTY,SIGCY,SIGSY,
     1                RJ11,RJ12,RJ22
      EQUIVALENCE     (KSYSTM(2),IOUTPT),(KSUB(1,1),KSUP(1)),
     1                (KSUBT(1,1),KSUPT(1)),(C1,CC(1)),(C2,CC(2)),
     2                (C3,CC(3)),(C4,CC(4)),(C5,CC(5)),(C6,CC(6)),
     3                (C7,CC(7)),(C8,CC(8)),(C9,CC(9)),(C10,CC(10)),
     4                (THK1,TMEM1),(THK2,TMEM3),(THK3,TMEM5),
     5                (A,DISTA),(B,DISTB),(C,DISTC),(IEST(1),EST(1)),
     6                (CMT(1),KTR3(1),MTR3(1),QQQ(1,1)),
     7                (CM1(1,1),TS6(1)),(CM1(5,3),TS1(1)),
     8                (CM1(11,6),TS6S(1)),(CM1(15,8),TS2(1)),
     9                (CM1(3,12),TS7(1))
      DATA    XPOWER/ 0,1,0,2,1,0,3,2,1,0,4,3,2,1,0,5,3,2,1,0/
      DATA    YPOWER/ 0,0,1,0,1,2,0,1,2,3,0,1,2,3,4,0,2,3,4,5/
      DATA    XTHK  / 0,1,0,2,1,0,3,2,1,0 /
      DATA    YTHK  / 0,0,1,0,1,2,0,1,2,3 /
      DATA    DEGRA / 0.0174532925/
      DATA    BLANK , NAME / 4H    , 4HTRPL, 4HT1    /
C
C     COMPONENT CODE,ICODE,IS  111111  AND HAS A VALUE OF 63
C
      ICODE   = 63
      NDOF    = 36
      IPREC   = PRECIS
      NLOCS   = 6
      DICT(1) = ESTID
      DICT(2) = 1
      DICT(3) = NDOF
      DICT(4) = ICODE
      DICT(5) = GSUBE
      NOTS    = .FALSE.
      IMASS   = .FALSE.
      IF (NOM .GT. 0) IMASS = .TRUE.
      IPASS  = 1
      IDELE  = IEST(1)
      DO 109 I = 1,6
      NL(I)  = IEST(I+1)
  109 CONTINUE
      THETAM = EST(8)
      MATID1 = IEST(9)
      TMEM1  = (EST(10)*12.0)**0.333333333333
      TMEM3  = (EST(11)*12.0)**0.333333333333
      TMEM5  = (EST(12)*12.0)**0.333333333333
      MATID2 = IEST(13)
      TSHR1  = EST(14)
      TSHR3  = EST(15)
      TSHR5  = EST(16)
      NSM    = EST(17)
      J      = 0
      DO 120 I = 24,44,4
      J      = J + 1
      ICS(J) = IEST(I)
      XC(J)  = EST(I+1)
      YC(J)  = EST(I+2)
      ZC(J)  = EST(I+3)
  120 CONTINUE
C
C     IF TMEM3 OR TMEM5 EQUAL TO ZERO OR BLANK,THEY WILL BE SET EQUAL TO
C     SO ALSO FOR TEMP3 AND TEMP5
C
      IF (TMEM3.EQ.0.0 .OR. TMEM3.EQ.BLANK) TMEM3 = TMEM1
      IF (TMEM5.EQ.0.0 .OR. TMEM5.EQ.BLANK) TMEM5 = TMEM1
      IF (TSHR3.EQ.0.0 .OR. TSHR3.EQ.BLANK) TSHR3 = TSHR1
      IF (TSHR5.EQ.0.0 .OR. TSHR5.EQ.BLANK) TSHR5 = TSHR1
      IF (TSHR1 .EQ. 0.0) NOTS = .TRUE.
      ELTEMP = EST(48)
      THETA1 = THETAM*DEGRA
      SINTH  = SIN(THETA1)
      COSTH  = COS(THETA1)
      IF (ABS(SINTH) .LE. 1.0E-06) SINTH = 0.0
C
C     EVALUATE MATERIAL PROPERTIES
C
      MATFLG = 2
      MATID  = MATID1
      CALL MAT (IDELE)
C
      MATID  = MATID2
      MATFLG = 3
      J11 = 0.0
      J12 = 0.0
      J22 = 0.0
      IF (NOTS) GO TO 146
      CALL MAT (IDELE)
  146 CONTINUE
      D11 = EM(1)
      D12 = EM(2)
      D13 = EM(3)
      D22 = EM(4)
      D23 = EM(5)
      D33 = EM(6)
C
C     CALCULATIONS FOR THE TRIANGLE
C
      CALL TRIF (XC,YC,ZC,IVECT,JVECT,KVECT,A,B,C,IEST(1),NAME)
C
C     FILL E-MATRIX
C
      DO 177 I = 1,18
  177 E(I)  = 0.0
      E( 1) = KVECT(1)
      E( 4) = KVECT(2)
      E( 7) = KVECT(3)
      E(11) = IVECT(1)
      E(14) = IVECT(2)
      E(17) = IVECT(3)
      E(12) = JVECT(1)
      E(15) = JVECT(2)
      E(18) = JVECT(3)
C
      D334  = D33*4.0
      D132  = D13*2.0
      D232  = D23*2.0
      CALL AF (F,14,A,B,C,A1,A2,A3,THK1,THK2,THK3,1)
      A1SQ  = A1*A1
      A2SQ  = A2*A2
      A3SQ  = A3*A3
      C1  = A1SQ*A1
      C2  = 3.0*A1SQ*A2
      C3  = 3.0*A1SQ*A3
      C4  = 3.0*A1*A2SQ
      C5  = 6.0*A1*A2*A3
      C6  = 3.0*A3SQ*A1
      C7  = A2SQ*A2
      C8  = 3.0*A2SQ*A3
      C9  = 3.0*A2*A3SQ
      C10 = A3*A3SQ
      CALL AF (F,14,A,B,C,AA1,AA2,AA3,TSHR1,TSHR3,TSHR5,1)
      UNIBEN = .FALSE.
      IF (ABS(A2).LE.1.0E-06 .AND. ABS(A3).LE.1.0E-06) UNIBEN = .TRUE.
C
C     COMPUTE THE AREA INTEGRATION FUNCTION F
C
      CALL AF (F,14,A,B,C,0,0,0,0,0,0,-1)
C
C     CALCULATIONS FOR QMATRIX (QQQ) AND ITS INVERSE
C
      DO 110 I = 1,20
      DO 110 J = 1,20
  110 QQQ(I,J) = 0.0
      DO 115 I = 1,6
      I1 = (I-1)*3 + 1
      I2 = (I-1)*3 + 2
      I3 = (I-1)*3 + 3
      QQQ(I1, 1) = 1.0
      QQQ(I1, 2) = XC(I)
      QQQ(I1, 3) = YC(I)
      QQQ(I1, 4) = XC(I)*XC(I)
      QQQ(I1, 5) = XC(I)*YC(I)
      QQQ(I1, 6) = YC(I)*YC(I)
      QQQ(I1, 7) = QQQ(I1, 4)*XC(I)
      QQQ(I1, 8) = QQQ(I1, 4)*YC(I)
      QQQ(I1, 9) = QQQ(I1, 5)*YC(I)
      QQQ(I1,10) = QQQ(I1, 6)*YC(I)
      QQQ(I1,11) = QQQ(I1, 7)*XC(I)
      QQQ(I1,12) = QQQ(I1, 7)*YC(I)
      QQQ(I1,13) = QQQ(I1, 8)*YC(I)
      QQQ(I1,14) = QQQ(I1, 9)*YC(I)
      QQQ(I1,15) = QQQ(I1,10)*YC(I)
      QQQ(I1,16) = QQQ(I1,11)*XC(I)
      QQQ(I1,17) = QQQ(I1,12)*YC(I)
      QQQ(I1,18) = QQQ(I1,13)*YC(I)
      QQQ(I1,19) = QQQ(I1,14)*YC(I)
      QQQ(I1,20) = QQQ(I1,15)*YC(I)
      QQQ(I2, 3) = 1.0
      QQQ(I2, 5) = XC(I)
      QQQ(I2, 6) = YC(I)*2.0
      QQQ(I2, 8) = QQQ(I1, 4)
      QQQ(I2, 9) = QQQ(I1, 5)*2.0
      QQQ(I2,10) = QQQ(I1, 6)*3.0
      QQQ(I2,12) = QQQ(I1, 7)
      QQQ(I2,13) = QQQ(I1, 8)*2.0
      QQQ(I2,14) = QQQ(I1, 9)*3.0
      QQQ(I2,15) = QQQ(I1,10)*4.0
      QQQ(I2,17) = QQQ(I1,12)*2.0
      QQQ(I2,18) = QQQ(I1,13)*3.0
      QQQ(I2,19) = QQQ(I1,14)*4.0
      QQQ(I2,20) = QQQ(I1,15)*5.0
      QQQ(I3, 2) =-1.0
      QQQ(I3, 4) =-2.0*XC(I)
      QQQ(I3, 5) =-YC(I)
      QQQ(I3, 7) =-QQQ(I1, 4)*3.0
      QQQ(I3, 8) =-QQQ(I1, 5)*2.0
      QQQ(I3, 9) =-QQQ(I1, 6)
      QQQ(I3,11) =-QQQ(I1, 7)*4.0
      QQQ(I3,12) =-QQQ(I1, 8)*3.0
      QQQ(I3,13) =-QQQ(I1, 9)*2.0
      QQQ(I3,14) =-QQQ(I1,10)
      QQQ(I3,16) =-QQQ(I1,11)*5.0
      QQQ(I3,17) =-QQQ(I1,13)*3.0
      QQQ(I3,18) =-QQQ(I1,14)*2.0
      QQQ(I3,19) =-QQQ(I1,15)
C
C     IF NO TRANSVERSE SHEAR GO TO 113
C
      IF (NOTS) GO TO 1137
      X  = XC(I)
      Y  = YC(I)
      CALL TSPL3S (TS6)
      DO 113 JJ = 1,20
      QQQ(I2,JJ) = QQQ(I2,JJ) - TS6(20+JJ)
      QQQ(I3,JJ) = QQQ(I3,JJ) + TS6(   JJ)
  113 CONTINUE
 1137 CONTINUE
  115 CONTINUE
      QQQ(19,16) = 5.0*A**4*C
      QQQ(19,17) = 3.0*A**2*C**3 - 2.0*A**4*C
      QQQ(19,18) =-2.0*A*C**4 + 3.0*A**3*C**2
      QQQ(19,19) = C**5 - 4.0*A**2*C**3
      QQQ(19,20) = 5.0*A*C**4
      QQQ(20,16) = 5.0*B**4*C
      QQQ(20,17) = 3.0*B**2*C**3 - 2.0*B**4*C
      QQQ(20,18) = 2.0*B*C**4 - 3.0*B**3*C**2
      QQQ(20,19) = C**5 - 4.0*B**2*C**3
      QQQ(20,20) =-5.0*B*C**4
C
C     FOURTH ARGUMENT IS A DUMMY LOCATION FOR INVERSE AND HENCE TS1(1)
C     IS U
C
C     NO NEED TO COMPUTE DETERMINANT SINCE IT IS NOT USED SUBSEQUENTLY.
C
      ISING = -1
      CALL INVERS (20,QQQ,20,TS6(1),0,DETERM,ISING,INDEX)
C
C     ISING EQUAL TO 2 IMPLIES THAT QQQ IS SINGULAR
C
      IF (ISING .EQ. 2) GO TO 904
C
C     FIRST 18 COLUMNS OF QQQ INVERSE IS THE QQQINV FOR USE IN STIFFNESS
C     MATRIX CALCULATIONS
C
      DO 152 I = 1,20
      DO 152 J = 1,18
      IJ = (I-1)*18 + J
      QQQINV(IJ) = QQQ(I,J)
  152 CONTINUE
C
C     START EXECUTION FOR STIFFNESS MATRIX CALCULATION
C
C     CM IS STIFFNESS MATRIX IN ELEMENT COORDINATES
C
  211 CONTINUE
      DO 212 I = 1,400
      KTR3(I) = 0.0
  212 CONTINUE
      DO 220 I = 1,20
      MX   = XPOWER(I)
      RMX  = MX
      NX   = YPOWER(I)
      RNX  = NX
      RMNX = RMX*RNX
      RMX1 = RMX*(RMX-1.0)
      RNX1 = RNX*(RNX-1.0)
      DO 218 J = I,20
      IJ   = (I-1)*20 + J
      JI   = (J-1)*20 + I
      MY   = XPOWER(J)
      RMY  = MY
      NY   = YPOWER(J)
      RNY  = NY
      RMNY = RMY*RNY
      RMY1 = RMY*(RMY-1.0)
      RNY1 = RNY*(RNY-1.0)
      MX0  = MX + MY
      MX1  = MX + MY - 1
      MX2  = MX + MY - 2
      MX3  = MX + MY - 3
      NX0  = NX + NY
      NX1  = NX + NY - 1
      NX2  = NX + NY - 2
      NX3  = NX + NY - 3
      MY1  = MX + MY + 1
      NY1  = NX + NY + 1
      IF (IPASS .EQ. 1) GO TO 214
      MX01 = MX0  + 1
      NX01 = NX0  + 1
      MX011= MX01 + 1
      NX011= NX01 + 1
      RHO  = RHOY*1.0
      MTR3(IJ) = RHO*(A1*F(MX01,NX01) + A2*F(MX011,NX01) +
     1           A3*F(MX01,NX011)) + NSM*F(MX01,NX01)
      MTR3(JI) = MTR3(IJ)
      GO TO 216
  214 CONTINUE
      ST   = 0.0
      DO 215 K = 1,10
      MX3X = MX3 + XTHK(K)
      NY1Y = NY1 + YTHK(K)
      MY1X = MY1 + XTHK(K)
      NX3Y = NX3 + YTHK(K)
      MX1X = MX1 + XTHK(K)
      NX1Y = NX1 + YTHK(K)
      MX2X = MX2 + XTHK(K)
      NX0Y = NX0 + YTHK(K)
      MX0X = MX0 + XTHK(K)
      NX2Y = NX2 + YTHK(K)
      S11  = 0.0
      S22  = 0.0
      S33  = 0.0
      S13  = 0.0
      S23  = 0.0
      IF (MX3X .GT. 0) S11 = D11*RMX1*RMY1*CC(K)*F(MX3X,NY1Y)
      IF (NX3Y .GT. 0) S22 = D22*RNX1*RNY1*CC(K)*F(MY1X,NX3Y)
      IF (MX1X.GT.0 .AND. NX1Y.GT.0) S33 = (D334*RMNX*RMNY+
     1    D12*(RMX1*RNY1+RMY1*RNX1))*CC(K)*F(MX1X,NX1Y)
      IF (MX2X.GT.0 .AND. NX0Y.GT.0) S13 = D132*(RMX1*RMNY+
     1    RMNX*RMY1)*CC(K)*F(MX2X,NX0Y)
      IF (MX0X.GT.0 .AND. NX2Y.GT.0) S23 = D232*(RMNX*RNY1+
     1    RNX1*RMNY)*CC(K)*F(MX0X,NX2Y)
      ST = ST + S11 + S22 + S33 + S13 + S23
      IF (UNIBEN) GO TO 2150
  215 CONTINUE
 2150 CONTINUE
      KTR3(IJ) = ST/12.0
      KTR3(JI) = KTR3(IJ)
  216 CONTINUE
  218 CONTINUE
  220 CONTINUE
      IF (IPASS .EQ. 2) GO TO 230
C
C     IF NO TRANSVERSE SHEAR GO TO 230
C
C     IF TSHR EQUAL TO ZERO OR MATID3 EQUAL TO ZERO , SKIP THESE
C     CALCULATIONS
C
      IF (NOTS) GO TO 230
      CALL TSPL1S (TS1,TS2,TS6,TS6S,TS7,KTR3,CMT(761))
C
  230 CONTINUE
C
C     (QQQINV) TRANSPOSE (KTR3)  (QQQINV)
C
      CALL GMMATS (QQQINV,20,18,+1,KTR3,20,20,0,CMT(761))
      CALL GMMATS (CMT(761),18,20,0,QQQINV,20,18,0,CM1)
C
  290 DO 300 I = 1,1296
      CMT(I) = 0.0
  300 CONTINUE
      IF (IPASS .LE. 2) GO TO 305
C
C     LUMPED MASS MATRIX
C
      CALL AF (F,14,A,B,C,T1,T2,T3,EST(10),EST(11),EST(12),1)
      AREA  = F(1,1)
      VOL   = T1*F(1,1) + T2*F(2,1) + T3*F(1,2)
      AMASS = (RHOY*VOL+NSM*AREA)/6.
      DO 303 I = 1,1296,37
      CMT(I) = AMASS
  303 CONTINUE
      IPASS = 2
      GO TO 400
C
C     LOCATE THE TRANSFORMATION MATRICES FROM BASIC TO LOCAL (THAT IS
C     COORDINATE AT ANY GRID POINT IN WHICH DISPLACEMENT AND STRESSES
C     ARE REQUESTED  - NOT NEEDED IF FIELD 7 IN GRID CARD IS ZERO)
C
C     TRANSFORM STIFFNESS MATRIX FROM ELEMENT COORDINATES TO BASIC
C     COORDINATES
C
C     TRANSFORM STIFFNESS MATRIX FROM BASIC COORDINAYES TO GLOBAL (DISP)
C     COORDINATES
C
C     INSERT THE 6X6 SUBMATRIX  INTO KGG MATRIX
C
  305 DO 310 I = 1,6
      SAVE(I) = NL(I)
  310 CONTINUE
      DO 314 I = 1,6
      SMALL(I) = I
      ISMALL = NL(I)
      DO 313 J = 1,6
      IF (ISMALL .LE.NL(J)) GO TO 312
      SMALL(I) = J
      ISMALL = NL(J)
  312 CONTINUE
  313 CONTINUE
      ISM = SMALL(I)
      NL(ISM) = 1000000
  314 CONTINUE
      DO 316 I = 1,6
      NL(I) = SAVE(I)
  316 CONTINUE
      DO 390 I  = 1,6
      DO 385 J  = I,6
      DO 320 II = 1,36
      BALOTR(II) = 0.0
      KSUP(II) = 0.0
  320 CONTINUE
      DO 324 K = 1,3
      SIL1 = SMALL(I)
      K1 = (SIL1-1)*3 + K
      DO 323 L = 1,3
      SIL2 = SMALL(J)
      L1 = (SIL2-1)*3 + L
      CSUB(K,L) = CM1(K1,L1)
  323 CONTINUE
  324 CONTINUE
      CALL GMMATS (E,6,3,0,CSUB,3,3,0,CSUBT)
      CALL GMMATS (CSUBT,6,3,0,E,6,3,+1,KSUPT)
      DO 325 K = 1,6
      DO 325 L = 1,6
      K1 = (K-1)*6 + L
      L1 = (L-1)*6 + K
      KSUP(L1) = KSUPT(K1)
  325 CONTINUE
C
C     TRANSFORM THE KSUP(36) FROM BASIC TO DISPLACEMENT COORDINATES
C
      IF (NL(SIL1).EQ.0 .OR. ICS(SIL1).EQ.0) GO TO 340
      JJ = 4*I + 20
      CALL TRANSS (IEST(JJ),TRAND)
      DO 327 JJ = 1,3
      L = 6*(JJ-1) + 1
      M = 3*(JJ-1) + 1
      BALOTR(L   ) = TRAND(M  )
      BALOTR(L+1 ) = TRAND(M+1)
      BALOTR(L+2 ) = TRAND(M+2)
      BALOTR(L+21) = TRAND(M  )
      BALOTR(L+22) = TRAND(M+1)
      BALOTR(L+23) = TRAND(M+2)
  327 CONTINUE
      CALL GMMATS (BALOTR(1),6,6,1,KSUP(1),6,6,0,KSUPT)
      DO 330 K = 1,36
      KSUP(K) = KSUPT(K)
  330 CONTINUE
  340 CONTINUE
      IF (NL(SIL2).EQ.0 .OR. ICS(SIL2).EQ.0) GO TO 375
      IF (J .EQ. I) GO TO 365
      CALL TRANSS (IEST(4*J+20),TRAND)
      DO 360 JJ = 1,3
      L = 6*(JJ-1) + 1
      M = 3*(JJ-1) + 1
      BALOTR(L   ) = TRAND(M  )
      BALOTR(L+1 ) = TRAND(M+1)
      BALOTR(L+2 ) = TRAND(M+2)
      BALOTR(L+21) = TRAND(M  )
      BALOTR(L+22) = TRAND(M+1)
      BALOTR(L+23) = TRAND(M+2)
  360 CONTINUE
  365 CONTINUE
      CALL GMMATS (KSUP(1),6,6,0,BALOTR( 1 ),6,6,0,KSUPT)
      DO 370 K = 1,36
      KSUP(K) = KSUPT(K)
  370 CONTINUE
  375 CONTINUE
      DO 380 II = 1,6
      DO 380 JJ = 1,6
      I1   = (I-1)*6 + II
      J1   = (J-1)*6 + JJ
      I1J1 = (I1-1)*36 + J1
      J1I1 = (J1-1)*36 + I1
      CMT(I1J1) = KSUB(JJ,II)
      CMT(J1I1) = KSUB(JJ,II)
  380 CONTINUE
  385 CONTINUE
  390 CONTINUE
C
C     CALL INSERTION ROUTINE
C
  400 CALL EMGOUT (CMT(1),CMT(1),1296,1,DICT,IPASS,IPREC)
      IF (.NOT.IMASS .OR. IPASS.GE.2) RETURN
C
C     GO TO 290 TO COMPUTE LUMPED MASS MATRIX
C     GO TO 211 TO COMPUTE CONSIST. MASS MATRIX (THIS PATH MAY NOT WORK)
C
      IPASS = 3
      CALL SSWTCH (46,J)
      IF (J .EQ. 1) IPASS = 2
      GO TO (999,211,290), IPASS
C
C     ERRORS
C
  904 CONTINUE
      NOGO = .TRUE.
      WRITE  (IOUTPT,2411) UFM,IEST(1)
 2411 FORMAT (A23,' 2411, MATRIX RELATING GENERALIZED PARAMETERS AND ',
     1       'GRID POINT DISPLACEMENTS IS SINGULAR.', //26X,
     2       'CHECK COORDINATES OF ELEMENT  TRPLT1 WITH ID',I9,1H.)
  999 CONTINUE
      RETURN
      END

      SUBROUTINE RCOVQV
C
C     THIS SUBROUTINE CALCULATES THE REACTION FORCES FOR THE REQUESTED
C     SUBSTRUCTURE
C
      LOGICAL         REQF       ,REIGEN
      INTEGER         FSS        ,RFNO       ,UA         ,RSS       ,
     1                RC         ,TFLAG      ,SIGNAB     ,SIGNC     ,
     2                PREC       ,SCRM       ,NAME(2)    ,SCR1      ,
     3                SCR2       ,SCR4       ,SCR5       ,SCR6      ,
     4                SCR7       ,SCR8       ,MGG        ,KGG       ,
     5                BGG        ,BUF1       ,BUF2       ,BUF3      ,
     6                BUF4       ,SOF1       ,SOF2       ,SOF3      ,
     7                BMTX       ,QVEC       ,MMTX       ,KMTX      ,
     8                SYSBUF     ,PA         ,QA
C    9,               UVEC       ,SRD
      CHARACTER       UFM*23     ,UWM*25     ,UIM*29     ,SFM*25     ,
     1                SWM*27
      COMMON /XMSSG / UFM        ,UWM        ,UIM        ,SFM        ,
     1                SWM
      COMMON /BLANK / DRY        ,LOOP       ,STEP       ,FSS(2)     ,
     1                RFNO       ,NEIGV      ,LUI        ,UINMS(2,5) ,
     2                NOSORT     ,UTHRES     ,PTHRES     ,QTHRES
      COMMON /RCOVCR/ ICORE      ,LCORE      ,BUF1       ,BUF2       ,
     1                BUF3       ,BUF4       ,SOF1       ,SOF2       ,
     2                SOF3
      COMMON /RCOVCM/ MRECVR     ,UA         ,PA         ,QA         ,
     1                IOPT       ,RSS(2)     ,ENERGY     ,UIMPRO     ,
     2                RANGE(2)   ,IREQ       ,LREQ       ,LBASIC
      COMMON /SYSTEM/ SYSBUF     ,NOUT
      COMMON /MPYADX/ MCBA(7)    ,MCBB(7)    ,MCBC(7)    ,MCBD(7)    ,
     1                MPYZ       ,TFLAG      ,SIGNAB     ,SIGNC      ,
     2                PREC       ,SCRM
      COMMON /ZZZZZZ/ Z(1)
      DATA    QVEC  , KMTX,   MMTX,   BMTX,   K4MX                   /
     1        4HQVEC, 4HKMTX, 4HMMTX, 4HBMTX, 4HK4MX                 /
C     DATA    UVEC  , SRD   / 4HUVEC, 1                              /
      DATA    KGG   , MGG,    BGG,   K4GG,           NAME            /
     1        103   , 104,    109,    110,         4HRCOV,   4HQV    /
      DATA    SCR1  , SCR2,   SCR4,   SCR5,   SCR6,   SCR7,   SCR8   /
     1        301   , 302,    304,    305,    306,    307,    308    /
C
C
C     CHECK TO SEE IF QVEC HAS ALREADY BEEN CALCULATED
C
      CALL MTRXI (SCR4,RSS,QVEC,0,RC)
      IF (RC .NE. 1) GO TO 10
      QA = SCR4
      RETURN
C
C     INITILIZE FOR QVEC CALCULATIONS
C
   10 PREC  = 0
      TFLAG = 0
      SCRM  = SCR5
      SIGNAB= 1
      MPYZ  = KORSZ(Z(1)) - LREQ
      REQF  = .FALSE.
      IF (FSS(1).EQ.RSS(1) .AND. FSS(2).EQ.RSS(2)) REQF = .TRUE.
      REIGEN = .FALSE.
      MALCOM = 0
      IF (UA .NE. SCR1) GO TO 30
      SCR2 = 301
      SCR1 = 302
C
C     CHECK THE DISPLACEMENT MATRIX
C
   30 MCBB(1) = UA
      CALL RDTRL (MCBB)
      IF (MCBB(1) .LE. 0) GO TO 9200
C
C     BRANCH ON RIGID FORMAT
C
      IF (RFNO .GT. 9) GO TO 9007
      GO TO (100,100,200,9007,9007,9007,9007,400,400), RFNO
C
C     STATIC SOUTION
C
C     Q = KU - P
C
C     SET UP LOAD VECTOR FOR SUBSTRACTION
C
  100 SIGNC = -1
      MCBC(1) = PA
      IF (PA .GT. 0) CALL RDTRL (MCBC)
      GO TO 500
C
C     NORMAL MODES
C
C     CHECK IF THE EIGEN VECTORS ARE COMPLEX
C
  200 IF (MCBB(5) .GE. 3) GO TO 300
C
C     REAL NORMAL MODES
C
C      Q = KU + MA   WHERE A = -(2*PI*FREQ)**2 * U
C
      REIGEN = .TRUE.
C
C     MALCOM TAGG OF MDC, IN MSFC, RECOMMANDED THAT FOR RIGID FORMAT 3
C     THE SPC REACTION FORCE SHOULD NOT CONTAIN THE MASS TERM.  JULY/86
C     I.E.    Q = KU ONLY   (DROP THE MA TERM)
C     THUS,   GO TO 250 THEN TO 500
C
C     MARCH 1989 - MALCOM RECOMMENDATION REMOVED. IT CAUSES IMBALANCED
C     SPC FORCES
C
C     MALCOM = 1
      IF (MALCOM .EQ. 1) GO TO 250
C
C     CALCULATE THE ACCLERATION VECTOR FOR REAL NORMAL MODES
C
      IN = UA
      CALL RCOVVA (IN,0,0,0,0,SCR8,RSS,Z(1),Z(1),Z(1))
      IF (IN .LE. 0) GO TO 9200
C
C
C     INDICATE A POSITIVE SIGN ON THE M * A MULTIPLY
C
  250 SIGNAB  = 1
      MCBC(1) = 0
      IF (MALCOM .EQ. 1) GO TO 500
      GO TO 420
C
C     COMPLEX NORMAL MODES
C
C     Q = KU + BV + MA
C
C     CALCULATE THE COMPLEX VELOCITIES AND ACCLERATION VECTORS FOR
C     THE EIGENVECTORS
C
  300 IN = UA
C
C     SEE MALCOM TAGG RECOMMENDATION, 25 LINES ABOVE
C
      CALL SOFCLS
      IF (MALCOM .EQ. 1) GO TO 445
C
      CALL RCOVVA (IN,0,0,SCR6,SCR7,SCR8,RSS,Z(1),Z(1),Z(1))
      IF (IN .LE. 0) GO TO 9200
C
C     INDICATE ZERO LOAD VECTOR FOR NORMAL MODES
C
      MCBC(1) = 0
      GO TO 420
C
C     DYNAMIC ANALYSIS
C
C     Q = KU + BV + MA - P
C
C
C     SPLIT DISPLACEMENT, VELOCITIES AND ACCELERATIONS ONTO SEPERATE
C     FILES
C
  400 IN = UA
      CALL RCOVVA (IN,1,0,SCR6,SCR7,SCR8,RSS,Z(1),Z(1),Z(1))
      IF (IN .LE. 0) GO TO 9200
C
C     SETUP TO SUBTRACT LOAD VECTOR
C
      SIGNC = -1
      MCBC(1) = PA
      IF (PA .GT. 0) CALL RDTRL (MCBC)
C
C     COMMON PROCESSING FOR DYNAMICS AND NORMAL MODES
C
C
C     MULTIPLY AND ADD    SCR1 = MA - P
C
  420 CONTINUE
      IF (.NOT.REQF) GO TO 430
      MCBA(1) = MGG
      CALL RDTRL (MCBA)
      IF (MCBA(1) .GT. 0) GO TO 440
  430 CALL MTRXI (SCR4,RSS,MMTX,0,RC)
      IF (RC .NE. 1) GO TO 460
      MCBA(1) = SCR4
      CALL RDTRL (MCBA)
  440 MCBB(1) = SCR8
      CALL RDTRL (MCBB)
      CALL MAKMCB (MCBD,SCR1,MCBB(3),MCBB(4),MCBB(5))
      CALL SOFCLS
C
      CALL MPYAD (Z(1),Z(1),Z(1))
C
  445 DO 450 I = 1,7
  450 MCBC(I) = MCBD(I)
      SIGNC = 1
      CALL SOFOPN (Z(SOF1),Z(SOF2),Z(SOF3))
C
C     MULTIPLY AND ADD   SCR8 = K4V + MCBC
C
  460 IF (REIGEN .OR. RFNO.EQ.9) GO TO 464
      IF (.NOT.REQF) GO TO 461
      MCBA(1) = K4GG
      CALL RDTRL (MCBA)
      IF (MCBA(1) .GT. 0) GO TO 462
  461 CALL MTRXI (SCR4,RSS,K4MX,0,RC)
      IF (RC .NE. 1) GO TO 464
      MCBA(1) = SCR4
      CALL RDTRL (MCBA)
  462 MCBB(1) = SCR7
      CALL RDTRL (MCBB)
      CALL MAKMCB (MCBD,SCR8,MCBB(3),MCBB(4),MCBB(5))
      SIGNAB = 1
      CALL SOFCLS
C
      CALL MPYAD (Z(1),Z(1),Z(1))
C
      DO 463 I = 1,7
  463 MCBC(I) = MCBD(I)
      SIGNC = 1
      CALL SOFOPN (Z(SOF1),Z(SOF2),Z(SOF3))
  464 CONTINUE
      IF (REIGEN) GO TO 500
C
C     MULTIPLY AND ADD   SCR1 = BV + MCBC
C
      IF (.NOT.REQF) GO TO 470
      MCBA(1) = BGG
      CALL RDTRL (MCBA)
      IF (MCBA(1) .GT. 0) GO TO 480
  470 CALL MTRXI (SCR4,RSS,BMTX,0,RC)
      IF (RC .NE. 1) GO TO 500
      MCBA(1) = SCR4
      CALL RDTRL (MCBA)
  480 MCBB(1) = SCR7
      CALL RDTRL (MCBB)
      CALL MAKMCB (MCBD,SCR1,MCBB(3),MCBB(4),MCBB(5))
      SIGNAB = 1
      CALL SOFCLS
C
      CALL MPYAD (Z(1),Z(1),Z(1))
C
      DO 490 I = 1,7
  490 MCBC(I) = MCBD(I)
      SIGNC = 1
      CALL SOFOPN (Z(SOF1),Z(SOF2),Z(SOF3))
C
C     COMMON PROCESSING FOR ALL RIGID FORMATS
C
C
C     MULTIPLY AND ADD  Q = KU + MCBC
C
  500 IF (.NOT.REQF) GO TO 520
      MCBA(1) = KGG
      CALL RDTRL (MCBA)
      IF (MCBA(1) .GT. 0) GO TO 540
  520 ITEM = KMTX
      FILE = SCR7
      CALL MTRXI (SCR7,RSS,KMTX,0,RC)
      IF (RC .NE. 1) GO TO 6000
      MCBA(1) = SCR7
      CALL RDTRL (MCBA)
  540 MCBB(1) = SCR6
      IF (REIGEN .OR. RFNO.LE.2) MCBB(1) = UA
      CALL RDTRL (MCBB)
      CALL MAKMCB (MCBD,SCR4,MCBB(3),MCBB(4),MCBB(5))
      SIGNAB = 1
      CALL SOFCLS
C
      CALL MPYAD (Z(1),Z(1),Z(1))
C
      CALL WRTTRL (MCBD)
      CALL SOFOPN (Z(SOF1),Z(SOF2),Z(SOF3))
C
C     COPY REACTIONS TO SOF
C
      CALL MTRXO (SCR4,RSS,QVEC,0,RC)
      QA = SCR4
C
      RETURN
C
C     ERRORS
C
 6000 IF (RC .EQ. 6) GO TO 9100
      CALL SMSG (RC-2,ITEM,RSS)
      GO TO 9200
 9007 N = 7
 9100 CALL MESAGE (N,0,NAME)
 9200 QA = 0
      WRITE  (NOUT,6318) SWM
 6318 FORMAT (A27,' 6318, OUTPUT REQUEST FOR REACTIONS FORCES IGNORED.')
      RETURN
C
      END

      SUBROUTINE XREAD (*,BUFX)
C
C     THIS ROUTINE MAKES FREE-FIELD INPUT PACKAGE (HANDLED BY FFREAD)
C     COMPLETELY MACHINE INDEPENDENT.
C
C     IF THE XSORT FLAG IN /XECHOX/ IS TURNED ON (XSORT=1), THIS ROUTINE
C     WILL ALSO PREPARES THE NECESSARY GROUND WORK SO THAT THE INPUT
C     CARDS CAN BE SORTED EFFICIENTLY IN XSORT2 ROUTINE. ALL FIELDS IN
C     THE INPUT CARDS ARE ALSO LEFT-ADJUSTED FOR PRINTING.
C
C     WRITTEN BY G.CHAN/UNISYS.   OCT. 1987
C     LAST REVISED, 1/1990, IMPROVED EFFICIENCY BY REDUCING CHARACTER
C     OPERATIONS (VERY IMPORTANT FOR CDC MACHINE)
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL         RSHIFT,COMPLF
      LOGICAL          DOUBLE,BCD2,BCD3,ALPHA,NUMRIC
      INTEGER          BUFX(20),SUB(2)
      INTEGER          CARD1(80),KHR1(43),BLANK1,DOLLR1,SLASH1,STAR1,
     1                 PLUS1,MINUS1,ZERO1,POINT1,E1,D1,J1
      CHARACTER*1      KARD1(80),KHRK(43),BLANKK,EQU1
      CHARACTER*8      CARD8(10),CARD81,BLANK8,SLASH8,END8(3),NAME8(15)
      CHARACTER*23     UFM*23,KHR43*43,CARD80*80
      COMMON /XMSSG /  UFM
      COMMON /XECHOX/  DUMMY,ECHOU,OSOP(2),XSORT,WASFF,DUM,F3LONG,LARGE
      COMMON /XSORTX/  IBUF(4),TABLE(255)
      COMMON /SYSTEM/  BUFSZ,NOUT,NOGO
      COMMON /MACHIN/  MACH
      EQUIVALENCE      (KARD1(1),CARD8(1), CARD80 ,CARD81  ) ,
     1                 (BLANK1,KHR1( 1)) , (KHR43 ,KHRK( 1)) ,
     2                 (ZERO1 ,KHR1( 2)) , (D1    ,KHR1(15)) ,
     3                 (E1    ,KHR1(16)) , (SLASH1,KHR1(38)) ,
     4                 (DOLLR1,KHR1(39)) , (STAR1 ,KHR1(40)) ,
     5                 (PLUS1 ,KHR1(41)) , (MINUS1,KHR1(42)) ,
     6                 (POINT1,KHR1(43))
      DATA    BLANK8 , SLASH8 ,  BLANK4  , EQUAL4 , SUB            /
     1        '    ' , '/   ' ,  4H      , 4H==== , 4HXREA,4HD     /
      DATA    NNAME /  15 /   ,  NAME8                             /
     1        'SPC1 ', 'SPCS ', 'TICS '  , 'MPCS ','MPCAX', 'RELES',
     2        'GTRAN','FLUTTER','BDYC '  , 'SPCSD','SPCS1','RANDPS',
     3       'DAREAS','DELAYS', 'DPHASES'                          /
      DATA    END8  /  'ENDDATA ','ENDATA ','END DATA'/, DERR / -1 /
C
      DATA    KHR43 /' 0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ/$*+-.' /
C                      2 4 6 8 1 2 4 6 8 2 2 4 6 8 3 2 4 6 8 4 2
C                              0         0         0         0
      DATA    N7, N1, N2,      N3,                       N4, N5,N6 /
     1        44,  1,  2,      11,                       37, 41,43 /
      DATA    PLUS1 , BLANKK, EQU1 / 0, ' ', '=' /
C
      IF (PLUS1 .EQ. 0) CALL K2B (KHR43,KHR1,43)
C
C     CALL FFREAD TO READ INPUT CARD
C     IF INPUT IS A COMMENT CARD, SET IBUF(1)=-1, AND RETURN
C     IF INPUT IS IN FREE-FIELD, ALL 10 BULKDATA FIELDS ARE ALREADY
C     LEFT-ADJUSTED, AND WASFF IS SET TO +1 BY FFREAD
C     IF INPUT IS IN FIXED-FIELD, ALL 10 BULKDATA FIELDS MAY NOT BE IN
C     LEFT-ADJUSTED FORMAT, AND WASFF IS SET TO -1 BY FFREAD
C
      CALL FFREAD (*850,CARD8)
      CALL K2B (CARD80,CARD1,80)
      IF (CARD1(1) .EQ. DOLLR1) GO TO 770
      IE = 0
      IF (XSORT.EQ.0 .OR. WASFF.EQ.1) GO TO 40
C
C     LEFT-ADJUSTED THE BULKDATA FIELDS, FIRST 9 FIELDS
C     (FIRST 4 AND A HALF FIELDS IF DOUBLE FIELD CARDS)
C
      IB = 1
      L  = 8
      IF (CARD1(1).EQ.PLUS1 .OR. CARD1(1).EQ.STAR1) IB = 9
      IF (CARD1(1) .EQ. STAR1) L = 16
      DO 30 I = IB,72,L
      IF (CARD1(I) .NE. BLANK1) GO TO 30
      K  = I
      JE = I + L - 1
      DO 10 J = I,JE
      IF (CARD1(J) .EQ. BLANK1) GO TO 10
      CARD1(K) = CARD1(J)
      KARD1(K) = KARD1(J)
      K  = K + 1
   10 CONTINUE
      IF (K .EQ. I) GO TO 30
      DO 20 J = K,JE
      KARD1(J) = BLANKK
   20 CARD1(J) = BLANK1
   30 CONTINUE
C
C     CHECK COMMENT CARD WITH DOLLAR SIGN NOT IN COLUMN 1. CONVERT
C     CHARACTER STRING TO BCD STRING, AND RETURN TO CALLER IF IT IS
C     NOT CALLED BY XSORT.
C
   40 IE = IE + 1
      IF (CARD1(IE) .EQ. BLANK1) GO TO 40
      IF (CARD1(IE) .EQ. DOLLR1) GO TO 760
      CALL KHRBCD (CARD80,BUFX)
      IF (XSORT .EQ. 0) GO TO 780
C
C
C     IF THIS ROUTINE IS CALLED BY XSORT, PASS THE FIRST 3 FIELDS TO
C     IBUF ARRAY IN /XSORTX/, IN INTEGER FORMS
C
C     FIRST BULKDATA FIELD IS ALPHA-NUMERIC, COMPOSED OF TWO 4-CHARACTER
C     WORDS. CHECK WHETHER OR NOT THIS IS A CONTINUATION OR COMMENT CARD
C     IF IT IS NOT, WE CHANGE ALL 8 CHARACTER BYTES INTO THEIR NUMERIC
C     CODE VALUES GIVEN BY TABLE /KHR43/ AND STORE THE VALUE IN IBUF(1)
C     AND IBUF(2)
C
C     WE SET IBUF(1) AND (2)    IF INPUT CARD IS
C     ----------------------    -------------------
C                -1             A COMMENT CARD
C                -2             A CONTINUATION CARD
C                -3             A DELETE CARD (RANGE IN IBUF(3) AND (4))
C                -3, -4         A DIRTY DELETE CARD
C                -5             A BLANK CARD
C                -9             A ENDDATA CARD
C     AND IBUF(2) AND IBUF(3) ARE NOT SET, EXECPT -3 CASE
C
C     IF FIELD 2 AND/OR FIELD 3 ARE IN CHARACTERS, WE PUT THE FIRST 6
C     BYTES (OUT OF POSSIBLE 8 CHARACTER-BYTES) INTO IBUF(3) AND/OR
C     IBUFF(4) RESPECTIVELY, IN INTERNAL NUMERIC CODE QUITE SIMILAR TO
C     RADIX-50
C     IF FIELD 2 HAS MORE THAN 7 CHARACTERS, IBUF(4) IS USED TO RECEIVE
C     THE LAST 2 CHARACTERS OF FIELD 2
C
C     IF FIELD 2 AND/OR FIELD 3 ARE NUMERIC DATA (0-9,+,-,.,E), THEIR
C     ACTUAL INTEGER VALUES ARE STORED IBUF(3) AND/OR IBUF(4).
C     IF THEY ARE F.P. NUMBERS, THEIR EXPONENT VALUES (X100000) ARE
C     CHANGED INTO INTEGERS, AND THEN STORED IN IBUF(3) AND/OR IBUF(4)
C
C     NOTE - XREAD WILL HANDLE BOTH SINGLE- AND DOUBLE-FIELD BULKDATA
C     INPUT IN FIELDS 2 AND 3, AND MOVED THEM ACCORDINGLY INTO IBUF(3)
C     AND IBUF(4)
C
C
C     PRESET TABLE IF THIS IS VERY FIRST CALL TO XREAD ROUTINE
C     TABLE SETTING IS MOVED UP BY ONE IF MACHINE IS CDC (TO AVOID
C     BLANK CHARACTER WHICH IS ZERO FROM ICHAR FUNCTION)
C
      FROMY = 0
      IF (XSORT .NE. 1) GO TO 80
      XSORT = 2
      CDC   = 0
      IF (MACH .EQ. 4) CDC = 1
      DO 60 I = 1,255
   60 TABLE(I) = N7
      DO 70 I = 1,N6
      J = ICHAR(KHRK(I)) + CDC
   70 TABLE(J) = I
      F3LONG = 0
      LARGE  = RSHIFT(COMPLF(0),1)/20
C
C     CHECK BLANK, ENDDATA, AND CONTINUATION CARDS
C
   80 ER = 0
      J1 = CARD1(1)
      J  = TABLE(ICHAR(KARD1(1))+CDC)
      IF (J .GE. N7) GO TO 810
      IF (CARD81.EQ.BLANK8 .AND. CARD8(2).EQ. BLANK8)  GO TO 90
      IF (CARD81.EQ.END8(1) .OR. CARD81.EQ.END8(2) .OR.
     1    CARD81.EQ.END8(3)) GO TO 100
      IF (J1.NE.PLUS1 .AND. J1.NE.STAR1) GO TO 120
      IBUF(1) = -2
      GO TO 110
   90 IBUF(1) = -5
      GO TO 110
  100 IBUF(1) = -9
  110 IBUF(2) = IBUF(1)
      GO TO 800
C
C     CHECK ASTERISK IN FIELD 1 (BUT NOT IN COLUMN1 1) AND SET DOUBLE-
C     FIELD FLAG. MERGE EVERY TWO SINGLE FIELDS TO ENSURE CONTINUITY OF
C     DOUBLE FIELD DATA (FIXED FIELD CARDS ONLY)
C
  120 DOUBLE = .FALSE.
      IF (WASFF .EQ. 1) GO TO 180
      IE = 8
      DO 130 J = 2,8
      IF (CARD1(IE) .EQ. STAR1) GO TO 140
  130 IE = IE - 1
      GO TO 180
  140 DOUBLE = .TRUE.
      IB = 0
      DO 170 I = 8,71,16
      K = I
      DO 150 J = 1,16
      L = I + J
      IF (CARD1(L) .EQ. BLANK1) GO TO 150
      K = K + 1
      IF (K .EQ. L) GO TO 150
      IB = 1
      CARD1(K) = CARD1(L)
      KARD1(K) = KARD1(L)
  150 CONTINUE
      IF (K .EQ. L) GO TO 170
      K = K + 1
      DO 160 J = K,L
      KARD1(J) = BLANKK
  160 CARD1(J) = BLANK1
  170 CONTINUE
      IF (IE .LE. 0) CALL MESAGE (-37,0,SUB)
      IF (IB .EQ. 1) CALL KHRBCD (CARD80,BUFX)
      CARD1(IE) = BLANK1
      KARD1(IE) = BLANKK
C
C     CHECK DELETE CARD
C     SET IBUF(1)=IBUF(2)=-3 IF IT IS PRESENT, AND SET THE DELETE RANGE
C     IN IBUF(3) AND IBUF(4)
C     SET IBUF(1)=-3 AND IBUF(2)=-4 IF TRASH FOUND AFTER SLASH IN
C     FIELD 1
C     NOTE - IF FIELD 3 IS BLANK, IBUF(4) IS -3
C
  180 IF (J1 .NE. SLASH1) GO TO 200
      DO 190 L = 1,4
  190 IBUF(L) = -3
      IF (CARD81 .NE. SLASH8) IBUF(2) = -4
      L = 2
      GO TO 300
C
C     TURN BCD2 AND BCD3 FLAGS ON IF THE 2ND AND 3RD INPUT FIELDS ARE
C     NOT NUMERIC RESPECTIVELY
C     IF 2ND FIELD HAS MORE THAN 6 CHARACTERS, REPLACE 3RD FIELD BY THE
C     7TH AND 8TH CHARACTERS OF THE 2ND FIELD
C     (FOR DMI AND DTI CARDS, MERGE 7TH AND 8TH CHARACTERS INTO 3RD
C     FIELD AND TREAT THE ORIG. 3RD FIELD AS A NEW BCD WORD)
C     IF 3RD FIELD HAS MORE THAN 6 CHARACTERS, SET F3LONG FLAG TO 1, AND
C     USER INFORMATION MESSAGE 217A WILL BE PRINTED BY XSORT
C     FIELDS 2 AND 3 SHOULD NOT START WITH A /, $, *
C     IF FIELD2 IS A BCD WORD, FIELD3 PROCESSING ACTUALLY BEGINS IN
C     CARD8(4)
C
  200 BCD2 = .FALSE.
      IF (DERR .EQ. +1) DERR = 0
      J = TABLE(ICHAR(KARD1(9))+CDC)
      IF (J .GE. N7) GO TO 810
      NUMRIC = (J.GE.N2 .AND. J.LE.N3) .OR. J.GE.N5
      IF (NUMRIC) GO TO 210
      BCD2 = .TRUE.
      IF (CARD1(15) .EQ. BLANK1) GO TO 210
C
C     SINCE THE NAME IN THE 2ND FIELD OF DMI, DTI, DMIG, DMIAX CARDS
C     ARE NOT UNIQUELY DEFINED FOR SORTING, SPECIAL CODES HERE TO MOVE
C     THE LAST PART OF A LONG NAME (7 OR 8 LETTER NAME) INTO THE 3RD
C     FIELD, AND TREAT THE NEW 3RD FIELD AS BCD WORD. THUS THE ORIGINAL
C     3RD FIELD (THE COLUMN NUMBER, RIGHT ADJUSTED WITH LEADING ZEROS)
C     IS LIMITED TO 4 DIGITS OR LESS.  IF THE NAME IN THE 2ND FIELD IS
C     SHORT (6 LETTERS OR LESS), MERGING OF THE 3RD FIELD IS NOT NEEDED.
C
      IF (CARD1(1).NE.D1       .OR.  CARD1(3).NE.KHR1(20) .OR.
     1   (CARD1(2).NE.KHR1(24) .AND. CARD1(2).NE.KHR1(31))) GO TO 208
      BCD3 = .TRUE.
      K = 24
      IF (DOUBLE) K = 32
      IF (CARD1(K-3) .EQ. BLANK1) GO TO 204
      IF (ECHOU .EQ. 1) GO TO 202
      IF (DERR .EQ. -1) CALL PAGE
      CALL PAGE2 (-2)
      IF (DOUBLE) CARD1(8) = STAR1
      WRITE  (NOUT,201) CARD8
  201 FORMAT (30X,10A8)
      IF (DOUBLE) CARD1(8) = BLANK1
  202 CALL PAGE2 (-2)
      WRITE  (NOUT,203) UFM
  203 FORMAT (A23,', THE 3RD INPUT FIELD OF THE ABOVE CARD IS LIMITED ',
     1       'TO 4 OR LESS DIGITS, WHEN A NAME OF 7 OR MORE', /5X,
     2       'LETTERS IS USED IN THE 2ND FIELD',/)
      DERR = +1
      NOGO =  1
  204 DO 205 J = 1,4
      IF (CARD1(K-4) .NE. BLANK1) GO TO 206
      KARD1(K-4) = KARD1(K-5)
      KARD1(K-5) = KARD1(K-6)
      KARD1(K-6) = KARD1(K-7)
  205 KARD1(K-7) = BLANKK
  206 DO 207 J = 1,6
      KARD1(K) = KARD1(K-2)
  207 K = K-1
      KARD1(K  ) = KARD1(16)
      KARD1(K-1) = KARD1(15)
      KARD1( 15) = BLANKK
      GO TO 215
C
  208 KARD1(17) = KARD1(15)
      KARD1(18) = KARD1(16)
      DO 209 K = 19,24
  209 KARD1(K) = BLANKK
C
  210 BCD3 = .FALSE.
      K = 17
      IF (DOUBLE) K = 25
      J = TABLE(ICHAR(KARD1(K))+CDC)
      ALPHA = J.EQ.N1 .OR. (J.GT.N3 .AND. J.LT.N5)
      IF (ALPHA) BCD3 = .TRUE.
      IF (BCD3 ) GO TO 215
C
C     THE FIRST 3 FIELDS OF THE DMIG OR DMIAX CARDS (NOT THE 1ST HEADER
C     CARD), ARE NOT UNIQUE. MERGE THE 4TH FIELD (1 DIGIT INTEGER) INTO
C     THE 3RD FIELD (INTEGER, 8 DIGITS OR LESS) TO INCLUDE THE COMPONENT
C     FIELD FOR SORTING
C
      IF (CARD1(1).NE.D1 .OR. CARD1(2).NE.KHR1(24) .OR.
     1    CARD1(3).NE.KHR1(20)  .OR. (CARD1(4).NE.KHR1(18) .AND.
     2    CARD1(4).NE.KHR1(12))) GO TO 215
      IF (CARD1(1) .EQ. KHR1(2)) GO TO 215
      K = 24
      IF (DOUBLE) K = 32
      IF (CARD1(K) .NE. BLANK1) GO TO 215
      DO 211 J = 1,7
      K = K - 1
      IF (CARD1(K) .NE. BLANK1) GO TO 212
  211 CONTINUE
  212 KARD1(K+1) = KARD1(25)
      IF (DOUBLE) KARD1(K+1) = KARD1(41)
C
C
C     CHANGE ALL CHARACTERS IN FIRST 3 FIELDS TO INTEGER INTEGER CODES
C     ACCORDING TO THE TABLE ARRANGEMENT IN /KHR43/
C     MAKE SURE THE INTERNAL CODE IS NOT IN NASTRAN INTEGER RANGE (1 TO
C     8 DIGITS), AND WITHIN MACHINE INTEGER WORD LIMIT
C     IN 2ND AND 3RD FIELDS, INTERCHANGE ALPHABETS AND NUMERIC DIGITS
C     SEQUENCE TO AVOID SYSTEM INTEGER OVERFLOW
C
C     -------------- REMEMBER, FROM HERE DOWN,
C                    CARD1 (1-BYTE ) HOLD ONE CHARACTER, AND
C                    IBUFX (4-BYTES) HOLD AN  INTEGER -----------------
C     WE ALSO HAVE   CARD8 (8-BYTES) HOLDING 8 CHARACTERS,
C              AND   BUFX  (4-BYTES) HOLDING 4 BCD-CHARACTERS
C
C
C     MAP OF THE FIRST 3 BULKDATA FIELDS -
C     (INPUT)
C
C           WORD1 WORD2 WORD3 WORD4 WORD5 WORD6 WORD7 WORD8 WORD9 WORD10
C     BYTE: 1         8 9        16 17       24 25       32 33       40
C          +-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+
C     SF:  !<-FIELD 1->!<-FIELD 2->!<-FIELD 3->!
C     DF:  !<-FIELD 1->!<------ FIELD 2 ------>!<------ FIELD 3 ------>!
C
C
C     MAP OF IBUF -           WORD1 WORD2 WORD3 WORD4
C     (OUTPUT)         BYTE:  1         8 9  12 13 16
C                            +-----+-----+-----+-----+
C     FOR CORE SORT          !<-FIELD 1->!<--->!<--->!
C     PERFORMED IN                        FIELD FIELD
C     XSORT2                                 2     3
C
  215 NUMRIC = .FALSE.
      L    = 0
      IOO  = 100
      WORD = 0
  220 WORD = WORD + 1
      GO TO 260
  230 IOO  = N4
      IF (.NOT.BCD2) GO TO 280
      WORD = 3
      GO TO 260
  240 WORD = 5
      IF (DOUBLE) WORD = 7
      IF (.NOT.BCD2 .OR. KARD1(15).EQ.BLANKK) GO TO 250
      WORD = 4
      IOO  = 100
      BCD3 = .TRUE.
  250 IF (.NOT.BCD3) GO TO 280
      IF (WORD.NE.4 .AND. KARD1(WORD*4+3).NE.BLANKK .AND. DERR.NE.+1)
     1    F3LONG = 1
  260 IE  = WORD*4
      IB  = IE - 3
      J   = TABLE(ICHAR(KARD1(IB))+CDC)
      IF (J .GE. N7) GO TO 810
      IF (MOD(WORD,2).EQ.0 .AND. .NOT.NUMRIC) GO TO 262
      NUMRIC = (J.GE.N2 .AND. J.LE.N3) .OR. J.GE.N5
      IF (NUMRIC) GO TO 280
  262 IF (IOO .EQ. 100) GO TO 265
      IE = IE + 2
      K  = J
      IF (K .GT. N3) J = K - N3
      IF (K .LE. N3) J = K + 25
  265 SUM = J
      IB  = IB + 1
      DO 270 I = IB,IE
      J   = TABLE(ICHAR(KARD1(I))+CDC)
  270 SUM = SUM*IOO + J
      IF (IOO .EQ. 100) SUM = SUM + 200000000
      IBUF(L+1) = SUM
  280 L = L + 1
      GO TO (220,230,240,290), L
C
C     CHECK INTEGERS ON 2ND AND 3RD FIELDS
C
  290 IF (BCD2 .AND. BCD3) GO TO 500
      L  = 2
      IF (BCD2) L = 3
  300 L  = L + 1
      IF (L-4) 310,320,500
  310 IB = 9
      GO TO 330
  320 IB = 17
      IF (DOUBLE) IB = 25
  330 IE = IB + 7
      IF (DOUBLE) IE = IB + 15
      J1 = CARD1(IB)
      IF (J1.EQ.PLUS1 .OR. J1.EQ.MINUS1 .OR. J1.EQ.POINT1 .OR.
     1    J1.EQ.ZERO1) GO  TO 340
      J  = TABLE(ICHAR(KARD1(IB))+CDC)
      IF (J.GE.N2 .AND. J.LE.N3) GO TO 350
C
C     IT IS CHARACTER FIELDS, NOTHING ELSE NEEDS TO BE DONE
C
      GO TO 300
C
C     IT IS NUMERIC
C
  340 IB  = IB + 1
  350 SUM = 0
      FP  = 0
      SIGX= 1
      SIGN= 1
      IF (J1 .EQ. MINUS1) SIGN =-1
      IF (J1 .EQ. POINT1) FP   = 1
      DO 380 I = IB,IE
      IF (KARD1(I) .EQ. BLANKK) GO TO 390
      J   = TABLE(ICHAR(KARD1(I))+CDC) - N2
      IF (J.LT.0 .OR. J.GT.9) GO TO 360
      IF (FP.LE.0 .AND. IABS(SUM).LT.LARGE) SUM = SUM*10 + SIGN*J
      GO TO 380
C
C     A NON-NUMERIC SYMBOL FOUND IN NUMERIC STRING
C     ONLY 'E', 'D', '+', '-', OR '.' ARE ACCEPTABLE HERE
C
  360 J1  = CARD1(I)
      IF (J1 .EQ. POINT1) GO TO 370
      IF (FP.EQ.0 .OR. IBUF(3).EQ.-3) GO TO 420
      IF (J1.NE.E1 .AND. J1.NE.D1 .AND. J1.NE.PLUS1 .AND.
     1    J1.NE.MINUS1) GO TO 420
      IF (J1 .EQ. MINUS1) SIGX = -1
      FP  =-1
      SUM = 0
      GO TO 380
  370 FP  = 1
C
  380 CONTINUE
C
C     BEEF UP NUMERIC DATA BY 2,000,000,000 SO THAT THEY WILL BE
C     SORTED BEHIND ALL ALPHABETIC DATA, AND MOVE THE NUMERIC DATA, IN
C     INTEGER FORM (F.P. MAY NOT BE EXACT) INTO IBUF(3) OR IBUF(4)
C
  390 IF (FP) 410,400,400
  400 IBUF(L) = SUM + SIGN*2000000000
      GO TO 300
  410 IBUF(L) = SIGN*2000000000
      IF (SIGX.GT.0 .AND. SUM.LT.9)
     1    IBUF(L) = SIGN * (10**(SIGX*SUM) + 2000000000)
      IF (SIGX.GT.0 .AND. SUM.GE.9) IBUF(L)= 2147000000*SIGN
      GO TO 300
C
C     ERROR IN NUMERIC FIELD
C
  420 IF (IB.EQ.10 .OR. IB.EQ.18) IB = IB - 1
      K = 1
      IF (ECHOU.EQ.0 .AND. ER.NE.-9) K = 2
      CALL PAGE2 (-K)
      IF (ECHOU.EQ.0 .AND. ER.NE.-9) WRITE (NOUT,430) CARD80
  430 FORMAT (1H ,29X,A80)
      K = 2
      IF (.NOT.DOUBLE) GO TO 440
      K = 4
      IF (L .NE. 4) WORD = WORD + 1
  440 IF (L .EQ. 4) WORD = WORD + 2
      WRITE  (NOUT,450) (BLANK4,I=1,WORD),(EQUAL4,I=1,K)
  450 FORMAT (7X,'*** ERROR -',24A4)
      NOGO = 1
      ER   =-9
      GO TO 500
C
C     BOTH FIELDS 2 AND 3 (OF BULK DATA CARD) DONE.
C
C
C     FOR MOST BULK DATA CARDS, EXCEPT THE ONES IN NAME8, THE FIRST
C     3 FIELDS, IN INTERNAL CODES AND SAVED IN THE IBUF 4-WORD ARRAY,
C     ARE SUFFICIENT FOR ALPHA-NUMERIC SORT (BY XSORT2)
C
C     THOSE SPECIAL ONES IN NAME8 ADDITIONAL FIELDS FOR SORTING
C
  500 DO 510 TYPE = 1,NNAME
      IF (CARD81 .EQ. NAME8(TYPE)) GO TO
     1   (520,   520,   520,   520,   600,   520,    520,   520,
     2    520,   560,   570,   580,   560,   560,    560),  TYPE
C
C    1   SPC1   SPCS   TICS   MPCS  MPCAX  RELES   GTRAN  FLUTTER
C    2   BDYC  SPCSD   SPCS1 RANDPS DELAYS DAREAS  DPHASES
C
  510 CONTINUE
      GO TO 700
C
C     SPC1,SPCS,TICS,MPCS,RELES,GTRAN,FLUTTER,BDYC CARDS -
C     ADD 4TH INTEGER FIELD TO IBUF ARRAY
C
  520 IBUF(2) = IBUF(3)
      IBUF(3) = IBUF(4)
  530 SUM = 0
      DO 540 I = 25,32
      J1  = CARD1(I)
      IF (J1 .EQ. BLANK1) GO TO 550
      J   = TABLE(ICHAR(KARD1(I))+CDC) - N2
      IF (J.GE.0 .AND. J.LE.9) SUM = SUM*10 + J
  540 CONTINUE
  550 IBUF(4) = SUM
      IF (TYPE .EQ. 12) GO TO 590
      GO TO 700
C
C     DAREAS,DELAYS,DPHASES,SPCSD CARDS -
C     ADD ONE TO IBUF(1), THUS CREATE DARF,DELB,DPHB,OR SPCT IN
C     IBUF(1), THEN ADD 4TH INTEGER FIELD INTO IBUF ARRAY
C
  560 IBUF(1) = IBUF(1) + 1
      GO TO 520
C
C     SPCS1 CARD -
C     ADD TWO TO IBUF(1), THUS CREATE SPCU IN IBUF(1), THEN ADD
C     4TH INTEGER FIELD INTO IBUF ARRAY
C
  570 IBUF(1) = IBUF(1) + 2
      GO TO 520
C
C     RANDPS -
C     MERGE FIELDS 3 AND 4 IF SUBCASE NUMBERS ARE NOT TOO BIG
C
  580 IF (IBUF(4).GE.10000 .OR. BUFX(8).NE.BLANK4) GO TO 700
      IOOOO = IBUF(4)*10000
      GO TO 530
  590 IBUF(4) = IBUF(4) + IOOOO
      GO TO 700
C
C     MPCAX -
C     MOVE THE 6TH FIELD INTO IBUF(4)
C
  600 J = 41
      DO 610 I = 25,32
      CARD1(I) = CARD1(J)
      KARD1(I) = KARD1(J)
  610 J = J+1
      GO TO 530
C
C     CHECK NUMERIC ERROR IN 4TH TO 9TH FIELDS IF NO ERROR IN FIRST
C     3 FIELDS (NEW BULK DATA CARDS ONLY)
C
  700 IF (FROMY.EQ.1 .OR. ER.EQ.-9) GO TO 800
      WORD = 5
      IF (DOUBLE) WORD = 7
  710 WORD = WORD + 2
      IF (DOUBLE) WORD = WORD + 2
      IF (WORD .GE. 19) GO TO 800
      IB = WORD*4 - 3
      J  = TABLE(ICHAR(KARD1(IB))+CDC)
      IF (J .GE. N7) GO TO 710
      ALPHA = J.EQ.N1 .OR. (J.GT.N3 .AND. J.LT.N5)
      IF (ALPHA) GO TO 710
      IE = IB + 7
      IF (DOUBLE) IE = IB + 15
      L  = IB + 1
      DO 740 I = L,IE
      J1 = CARD1(I)
      IF (J1 .EQ. BLANK1) GO TO 710
      J  = TABLE(ICHAR(KARD1(I))+CDC)
      NUMRIC = (J.GE.N2 .AND. J.LE.N3) .OR. (J.GE.N5 .AND. J.LE.N6)
      IF (NUMRIC .OR. J.EQ.15 .OR. J.EQ.16) GO TO 740
C                           D            E
      K = 1
      IF (ECHOU.EQ.0 .AND. ER.NE.-9) K = 2
      CALL PAGE2 (-K)
      IF (ECHOU.EQ.0 .AND. ER.NE.-9) WRITE (NOUT,430) CARD80
      WORD = WORD + 2
      K = 2
      IF (.NOT. DOUBLE) GO TO 730
      K = 4
  730 WRITE (NOUT,450) (BLANK4,J=1,WORD),(EQUAL4,J=1,K)
      NOGO = 1
      GO TO 800
  740 CONTINUE
      GO TO 800
C
  760 IF (XSORT .EQ. 0) KARD1(IE) = KHRK( 1)
  770 IF (XSORT .EQ. 0) KARD1( 1) = KHRK(39)
      IBUF(1) = -1
      CALL KHRBCD (CARD80,BUFX)
      GO TO 800
C
  780 IBUF(1) = 0
C
  800 RETURN
C
  810 IF (XSORT .EQ. 2) GO TO 830
      WRITE  (NOUT,820) XSORT
  820 FORMAT (//,' *** TABLE IN XREAD HAS NOT BEEN INITIALIZED.',
     1        /5X,'XSORT=',I4)
      CALL MESAGE (-37,0,SUB)
  830 WRITE  (NOUT,840) CARD8
  840 FORMAT (/,' *** ILLEGAL CHARACTER ENCOUNTERED IN INPUT CARD',
     1       /4X,1H',10A8,1H' )
      NOGO = 1
  850 RETURN 1
C
C
      ENTRY YREAD (*,BUFX)
C     ====================
C
C     YREAD IS CALLED ONLY BY XSORT TO RE-PROCESS CARD IMAGES FROM
C     THE OPTP FILE
C
      CALL BCDKH8 (BUFX,CARD80)
      CALL K2B (CARD80,CARD1,80)
      FROMY = 1
      GO TO 80
C
C
      ENTRY RMVEQ (BUFX)
C     ==================
C
C     RMVEQ, CALLED ONLY BY XCSA, REMOVES AN EQUAL SIGN FROM TEXT.
C     THUS, 1 EQUAL SIGN BEFORE COLUMN 36 IS ALLOWED ON ONE EXECUTIVE
C     CONTROL LINE
C
C     AT THIS POINT, THE DATA IN KARD1 IS STILL GOOD
C
      DO 900 I = 1,36
      IF (KARD1(I) .EQ. EQU1) GO TO 910
  900 CONTINUE
      GO TO 920
  910 KARD1(I) = BLANKK
      CALL KHRBCD (CARD80,BUFX)
  920 RETURN
      END

      SUBROUTINE CNORM(X,DIV,Y)
C
C     CNORM WILL NORMALIZE X TO THE MAXIMUM ELEMENT EQUAL TO A MODULUS
C     OF ONE AND STORE THE DIVISOR IN MAX (X MAY BE COMPLEX)
C
      DOUBLE PRECISION X(1),DIV(2),MAX,TEMP,Y(1),SIGN,COSANG,XO,D,R,RI
      COMMON /SYSTEM/  IBUF,NOUT
      COMMON /CINVPX/  FILEK(7)
      COMMON /CINVXX/  DUM(30),IND1,ITER
      EQUIVALENCE      (NCOL,FILEK(2))
C
      NCOL2 = NCOL + NCOL
      MAX   = 0.D0
      SIGN  = 1.0D0
      IND   = 0
      DO 20 I = 1,NCOL2,2
      IF (X(I)**2+X(I+1)**2 .LE. MAX) GO TO 20
      MAX = X(I)**2 + X(I+1)**2
      IND = I
   20 CONTINUE
      IF (IND  .EQ.   0) GO TO 80
      IF (ITER .EQ.   1) GO TO 60
      IF (IND .EQ. IND1) GO TO 50
      CALL SSWTCH (12,IDIAG)
      IF (IDIAG .EQ.  0) GO TO 40
      WRITE  (6,30) IND,IND1
   30 FORMAT (10H CHANGE     ,2I5)
   40 CONTINUE
   50 CONTINUE
      D  = X(IND)**2 + X(IND+1)**2
      R  = (X(IND1)*X(IND) + X(IND1+1)*X(IND+1))/D
      RI = (X(IND1+1)*X(IND) - X(IND1)*X(IND+1))/D
      COSANG = XO*R/DSQRT(R**2 + RI**2)
      IF (DABS(COSANG+1.D0) .LE. 0.1D0) SIGN = -1.0D0
   60 I  = IND
      DIV(1) = X(I  )*SIGN
      DIV(2) = X(I+1)*SIGN
      IND1 = IND
      MAX  = 1.0D0/MAX
      DO 70 I = 1,NCOL2,2
      TEMP   = (X(I)*DIV(1)+X(I+1)*DIV(2))*MAX
      X(I+1) = (X(I+1)*DIV(1)-X(I)*DIV(2))*MAX
   70 X(I) = TEMP
      XO = X(IND)
      RETURN
C
   80 WRITE  (NOUT,90)
   90 FORMAT (//5X,37HCONOR  RECEIVED A VECTOR OF ALL ZEROS)
      CALL MESAGE (-37,0,0)
      RETURN
      END

      SUBROUTINE TRNSP (CORE)
C
C     OUT-OF-CORE MATRIX TRANSPOSE USING 1 TO 8 SCRATCH FILES - NASTRAN
C     ORIGINAL ROUTINE.
C
C     (SEE TRANSP FOR IN-CORE MATRIX TRANSPOSE FOR UPPER TRIAG. MATRIX,
C      AND TRNSPS FOR OUT-OF-CORE MATRIX TRANSPOSE WITH 1 SCRATCH FILE,
C      A NASTRAN NEW ROUTINE)
C
C     REVERT TO NASTRAN ORIGINAL TRNSP IF DIAG 41 IS ON, OR 94TH WORD OF
C     /SYSTEM/ IS 1000. OTHERWISE SEND THE TRANSPOSE JOB TO THE NEW
C     TRNSPS ROUTINE, EXECPT LOWER AND UPPER TRIANGULAR MATRICES
C
      INTEGER         SCRTH,OTPE,SYSBUF,TRB1
      DIMENSION       CORE(1),TRB1(7,8),A(2),IPARM(2),NAME(2),ZERO(4)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25,SWM*27
      COMMON /XMSSG / UFM,UWM,UIM,SFM,SWM
      COMMON /TRNSPX/ NAMEA ,NCOLA ,NROWA ,IFORMA,ITYPA ,IA(2),
     1                NAMEAT,NCOLAT,NROWAT,IFORAT,ITYPAT,IAT(2),
     2                LCARE,NSCRH,SCRTH(8)
      COMMON /MACHIN/ MACH
      COMMON /SYSTEM/ SYSBUF,OTPE,SKIP(91),KSYS94
      COMMON /PACKX / IOTYP,IOTYPA,II,JJ,INCR
      COMMON /UNPAKX/ IOTYP1,IS1,NROW1,INCR1
      DATA    IPARM / 4HTRAN,4HPOSE/, ZERO / 4*0.0   /
      DATA    NAME  / 4HTRNS,4HP   /
C
      IF (NSCRH .NE. 8) CALL CONMSG (IPARM,2,0)
      IAT(1) = 0
      IAT(2) = 0
      INCR1  = 1
      II     = 1
      IF (ITYPAT .EQ. 0) ITYPAT = ITYPA
      IOTYP  = MIN0(ITYPAT,ITYPA)
      IOTYPA = IOTYP
      IOTYP1 = IOTYP
      IF (IFORMA.EQ.4 .OR. IFORMA.EQ.5) GO TO 50
C               LOWER            UPPER TRIANG. MATRICES
C
      J = MOD(KSYS94,10000)/1000
      IF (J .EQ. 1) GO TO 50
      CALL SSWTCH (41,J)
      IF (J .EQ. 1) GO TO 50
C
C     NASTRAN MAINTENANCE WORK IS DONE ON VAX
C
      IF (MACH.NE.5 .OR. IFORMA.LT.3 .OR. IFORMA.EQ.6) GO TO 40
C               VAX      NOT SQUARE, RECTANG., AND SYMM.
      CALL FNAME (NAMEA,A)
      WRITE  (4,30) A,IFORMA
   30 FORMAT (40X,'MATRIX ',2A4,', FORM =',I2,' ===>TRNSPS')
   40 NCOLAT = 0
      NSCRTH = 1
      CALL TRNSPS (CORE,CORE)
      GO TO 500
C
   50 IPARM1 = NAMEA
      NSCRTH = NSCRH
      IM1    = 1
      NCALAT = NCOLAT
      NCOLAT = 0
      IJ1    = 0
      LAST   = 1
      NTYPE  = IOTYPA
      IF (NTYPE .EQ. 3) NTYPE = 2
      LCORE  = LCARE
      IBUF1  = LCORE - SYSBUF
      IBUF   = IBUF1 - SYSBUF
      LCORE  = IBUF  - 1
      IF (LCORE) 440,440,70
C
C     COMMENT FROM G.CHAN/UNISYS    1/91
C     ABOUT THE SQUARE OR RECTANGULAR MATRIX TRANSPOSE BY THE VAX -
C     DATA, 1.0**-10 OR SMALLER, ON THE TRANSPOSED MATRIX MAY DIFFER
C     FROM THE ORIGINAL VALUES. CAN NOT EXPLAIN WHY.
C     THE NORMAL DATA, 1.0**+5 OR LARGER, ARE ALL OK.
C     (NO CHECK ON THE OTHER MACHINES)
C
   70 NROWO  = MIN0(NROWAT,NCOLA)
      NBRUT  = LCORE/(NROWO*NTYPE)
      IF (NBRUT .EQ. 0) GO TO 440
      NREM   = NBRUT
      IF (NBRUT .GT. NCALAT) GO TO 380
      K = AMAX1(FLOAT(NROWAT)*SQRT(FLOAT(NTYPE)/FLOAT(LCORE)),1.0)
   80 NROW2 = NBRUT*K
      NROW  = MIN0(NSCRTH*NROW2,NCALAT)
      KM    = (NCALAT+NROW-1)/NROW
      ICOL  = NBRUT*NTYPE
      IF (LCORE .LT. NROW*NTYPE+(NSCRTH-1)*SYSBUF) GO TO 440
C
C     THERE ARE NROW2 ROWS IN EACH SUBMATRIX
C     WE GENERATE NROW ROWS PER PASS OF FULL MATRIX
C     THERE WILL BE KM SUCH PASSES
C
      IOLOOP = 1
   90 IF (IJ1) 210,100,210
  100 IF (IOLOOP .EQ. KM) GO TO 390
      NROW1 = NROW*IOLOOP
  110 IS1   = NROW1 - NROW + 1
      IF (IOLOOP .NE. 1) GO TO 120
      IPARM1= NAMEA
      CALL OPEN (*410,NAMEA,CORE(IBUF1),0)
  120 CALL FWDREC (*420,NAMEA)
      NL = NROW*NTYPE
C
C     OPEN SCRATCHES
C
      J = IBUF
      DO 140 I = 1,NSCRTH
      IPARM1 = SCRTH(I)
      CALL OPEN (*410,SCRTH(I),CORE(J),1)
      J = J - SYSBUF
      DO 130 III = 1,7
  130 TRB1(III,I) = 0
  140 CONTINUE
      DO 200 ILOOP = 1,NROWO
      CALL UNPACK (*180,NAMEA,CORE)
  150 IK = 1
      JJ = NROW2
      INCR = 1
      DO 160 I = 1,NSCRTH
      CALL PACK (CORE(IK),SCRTH(I),TRB1(1,I))
      IK = IK + NROW2*NTYPE
  160 CONTINUE
C
C     END LOOP ON BUILDING 1 COL OF SUB MATRICES
C
      GO TO 200
C
  180 DO 190 I = 1,NL
  190 CORE(I) = 0.0
      GO TO 150
  200 CONTINUE
      CALL REWIND (NAMEA)
C
C     END LOOP ON BUILDING NSCRATH SUB MATRICES
C
      DO 201 I = 1,NSCRTH
      CALL CLOSE (SCRTH(I),1)
  201 CONTINUE
  210 DO 350 J = 1,NSCRTH
      IF (IJ1) 230,220,230
  220 IF (IOLOOP.NE.KM .OR. J.NE.NSCRTH) GO TO 230
      LAST = 0
  230 DO 340 M = 1,K
      IPARM1 = SCRTH(J)
      CALL OPEN (*410,SCRTH(J),CORE(IBUF),0)
      IF (LAST.EQ.1 .OR. NCALAT-NCOLAT.GE.NREM) GO TO 240
      NBRUT = NCALAT - NCOLAT
      ICOL  = NBRUT*NTYPE
      IS1   = (M-1)*NREM + 1
      NROW1 = IS1 + NBRUT
      GO TO 270
  240 IF (IJ1) 250,260,250
  250 CALL FWDREC (*420,SCRTH(J))
  260 IS1   = (M-1)*NBRUT + 1
      NROW1 = NBRUT*M
  270 L = 1
      DO 310 I = 1,NROWO
      CALL UNPACK (*280,SCRTH(J),CORE(L))
      GO TO 300
  280 DO 290 NL = 1,ICOL
      M2 = NL + L - 1
  290 CORE(M2) = 0.0
  300 L = L + ICOL
  310 CONTINUE
      CALL CLOSE (SCRTH(J),1)
      IPARM1 = NAMEAT
      CALL OPEN (*410,NAMEAT,CORE(IBUF),IM1)
      IF (IM1 .EQ. 3) GO TO 320
      CALL FNAME (NAMEAT,A(1))
      CALL WRITE (NAMEAT,A(1),2,1)
      IM1  = 3
  320 INCR = NBRUT
      JJ = NROWO
      DO 330 L = 1,NBRUT
      M2 = NTYPE*(L-1) + 1
      CALL PACK (CORE(M2),NAMEAT,NAMEAT)
  330 CONTINUE
      CALL CLOSE (NAMEAT,2)
C
C     END LOOP ON SUBMATRIX
C
      IF (NCOLAT .GE. NCALAT) GO TO 350
  340 CONTINUE
C
C     END LOOP ON EACH SCRATCH
C
  350 CONTINUE
C
C     END LOOP ON EACH PASS THROUGH LARGE MATRIX
C
      IOLOOP = IOLOOP + 1
      IF (IOLOOP .LE. KM) GO TO 90
      IPARM1 = NAMEAT
      CALL OPEN  (*410,NAMEAT,CORE(IBUF),3)
      CALL CLOSE (NAMEAT,1)
      CALL CLOSE (NAMEA, 1)
      GO TO 500
C
C     ONE PASS ONLY
C
  380 NSCRTH  = 1
      SCRTH(1)= NAMEA
      NBRUT   = NCALAT
      K   = 1
      IJ1 = 1
      IOTYP = ITYPA
      GO TO 80
  390 IOVER = NCALAT - (KM-1)*NROW
      NBRUT = MIN0(NBRUT,IOVER)
      ICOL  = NBRUT*NTYPE
      NROW  = IOVER
      NROW2 = MIN0(NBRUT*K,NROW)
      K     = (NROW2+NBRUT-1)/NBRUT
      NSCRTH= MIN0((IOVER+K*NBRUT-1)/(K*NBRUT),NSCRTH)
      IF (NSCRTH .EQ. 0) NSCRTH =  1
      NROW1 = NCALAT
      GO TO 110
C
C     ERROR MESSAGES
C
  410 N1 = -1
      GO TO 450
  420 N1 = -2
      GO TO 450
  440 N1 = -8
  450 CALL MESAGE (N1,IPARM1,NAME)
C
C     ONE FINAL CHECK BEFORE RETURN
C
  500 IF (IFORMA.EQ.3 .OR. IFORMA.EQ.7) GO TO 520
      IF (NCOLAT.EQ.NROWA .AND. NROWAT.EQ.NCOLA) GO TO 520
      CALL FNAME (NAMEA,A)
      WRITE (OTPE,510) SWM,A,IFORMA,NCOLA,NROWA,IFORAT,NCOLAT,NROWAT
  510 FORMAT (A27,' FORM TRNSP. TRANSPOSED MATRIX APPEARS IN ERROR',
     1    /5X,'ORIGINAL ',2A4, ' - FORM =',I3,',  (',I6,' X',I6,')',
     2    /5X,'TRNASPOSED MATRIX - FORM =',I3,',  (',I6,' X',I6,')')
  520 IF (NSCRH .NE. 8) CALL CONMSG (IPARM,2,0)
      RETURN
      END

      SUBROUTINE TABLE5 (*,IN,OUT,TRL,IBUF,WRT,LFN,FN)
C
C     THIS ROUTINE IS CALLED ONLY BY OUTPT5 TO COPY A TABLE FILE IN 'IN'
C     TO AN OUPUT FILE 'OUT', BY FORTRAN WRITE, FORMATTED OR UNFORMATTED
C
C     IN,OUT = INPUT AND OUTPUT FILE, INTEGERS
C     TRL    = TRAILER OF INPUT FILE, INTEGERS
C     P4     = 0, OUTPUT FILE IS TO BE WRITTEN UNFORMATTED, BINARY, INT.
C            = 1, OUTPUT FILE IS TO BE WRITTEN FORMATTED, INTEGER
C     TI     = ARRAY TO OVERRIDE DATA TYPE OUTPUT. INTEGERS
C              SEE RULES BELOW.
C     Z,IBUF = OPEN CORE AND GINO BUFFER POINTER, INTEGER
C     WRT,LFN= ARE COMMUNICATION FLAGS BETWEEN TABLE5 AND OUTPT5
C     FN     = ARRAY FOR INPUT FILE NAME
C
C     THE FOLLOWING CONVENTIONS ARE USED FOR FORMATTED TAPE -
C
C       A   '/'+A4  FORMAT FOR BCD WORD               ( 5 BYTES)
C       AN  'I'+I9  FORMAT FOR INTEGER                (10 BYTES)
C       A 'R'+E14.7 FORMAT FOR S.P. REAL NUMBER.      (15 BYTES)
C       A 'D'+D14.7 FORMAT FOR D.P. REAL NUMBER.      (15 BYTES)
C       A 'X'+4 BLANKS IS A FILLER, AT END OF A LINE  ( 5 BYTES)
C
C       EACH RECORD IS PRECEEDED BY L5 (IN I10 FORMAT) WHERE L5 IS THE
C       TOTAL NO. OF CHARACTERS OF THIS CURRENT RECORD DIVIDED BY 5.
C
C       EACH RECORD IS WRITTEN IN MULTIPLE LINES OF 130 CHARACTERS EACH.
C       (131 CHARACTERS TO BE EXACTLY - 130 PLUS A BLANK)
C
C       ONE OR TWO FILLERS MAY ATTACH TO THE END OF A LINE TO MAKE UP
C       130 CHARACTERS. THAT IS, INTEGER AND S.P.REAL NUMBER AT THE END
C       OF A LINE WILL NOT BE SPLITTED BETWEEN TWO LINES
C
C       IF A ZERO IS PRECEEDED BY A F.P. REAL NUMBER, IT WILL BE WRITTEN
C       OUT AS A REAL ZERO (0.0), INTEGER ZERO (0) OTHERWISE.
C
C       DUE TO THE FACTS THAT FLOATING POINT ZEROS ARE ALWAYS TREATED AS
C       INTEGERS, DOUBLE PRECISION CAN NOT BE DETECTED, AND OCCATIONALLY
C       AUTOMATIC DATA TYPE CHECKING MAY ERR, THE USER CAN OVERRIDE THE
C       OUTPUT DATA FORMAT BY DEFINING TI ARRAYS WITH THE FOLLOWING
C       RULES -
C
C          EACH TI PARAMETER MUST HOLD 9 DIGITS, FROM LEFT TO RIGHT.
C               ZEROS-FILLED IF NECCESSARY.
C               TOTALLY THERE ARE 10 TI PARAMETERS. THEREFORE, THERE ARE
C               UP TO 90 CONTINUOUS DIGITS CAN BE USED.
C               (DEFAULT IS 90 ZEROS)
C          EACH DIGIT HOLDS VALUE FROM 0 THROUGH 9, VALUE
C               0 MEANS DATA TYPE WILL BE SET AUTOMATICALLY BY TABLE5
C               1 MEANS DATA TYPE IS INTEGER
C               2 MEANS DATA TYPE IS REAL, SINGLE PRECISION
C               3 MEANS DATA TYPE IS BCD WORD (4 BYTES PER WORD)
C               4 MEANS DATA TYPE IS REAL, DOUGLE PRECISION
C             5-9 HAS SPECIAL MEANING. IT MEANS THERE ARE (5-9) VALUES
C                 OF DATA TYPE DEFINED BY THE NEXT VALUE FOLLOWING.
C          EACH DIGIT IN TI, EXCEPT 5 THRU 9, DEFINES THE CORRESPODING
C               DATA TYPE IN THE TABLE BLOCK DATA, STARTING FROM THE
C               FIRST DATA WORD AND CONTINUE TO THE LAST.
C          IF TI(1) IS NEGATIVE, INTERMEDIATE STEPS IN FORMAT GENERATION
C               ARE PRINTED OUT.
C     E.G.
C     TABLE- 3  4  3.4  5.0E-3  TESTING  .6D+7  9  G  3.2  8  0.  0  4
C            12 13  14  15  28  61   88   14   44 .7D+7
C     TI   - TI(1) =-112233413, TI(2) = 212516140  OR
C            TI(1) = 604000025, TI(2) = 060400000 (7TH AND 24 WORDS ARE
C                                            D.P. AND 12TH WORD IS REAL)
C     NOTE - 2 BCD WORDS IN 'TESTING',
C            ALL OTHERS ARE 1 COMPUTER WORD PER DATA ENTRY
C            TI(2), THE LAST TI USED HERE, MUST FILL UP WITH ZEROS TO
C               MAKE UP A 9-DIGIT WORD.
C
C     TO READ THE OUTPUT FILE, USE TABLE-V SUBROUTINE AS REFERENCE
C
C     NOTE - THE FORMATTED OUTPUT FILE CAN BE VIEWED AND/OR EDITTED BY
C            THE SYSTEM EDITOR
C
C     WRITTEN BY G.CHAN/UNISYS,  1989
C
C  $MIXED_FORMATS
C
      IMPLICIT INTEGER (A-Z)
      LOGICAL          DEBUG,TION,DP
      INTEGER          TRL(7),NAME(2),SUB(2),FN(3,1)
      REAL             TEMP(2),RZ(1)
      DOUBLE PRECISION DTEMP
      CHARACTER*10     FMT(30),FMTI,FMTR,FMTD,FMTB,FMTX,LPREN,RPREN,
     1                 LPRI10
      CHARACTER        UFM*23,UWM*25,UIM*29
      COMMON /XMSSG /  UFM,UWM,UIM
      COMMON /SYSTEM/  SYSBUF,NOUT
      COMMON /BLANK /  DUMMY(4),P4,TI(1)
      COMMON /ZZZZZZ/  Z(1)
CWKBI 7/94
      COMMON /MACHIN/  MACH
      EQUIVALENCE      (Z(1),RZ(1)) ,  (DTEMP,TEMP(1))
      DATA    SUB   /  4HTABL,4HE5  /, DEBUG   /   .FALSE.      /
      DATA    FMTI,    FMTR         / '1HI,I9,' ,  '1HR,E14.7,' /
      DATA    FMTB,    FMTD         / '1H/,A4,' ,  '1HD,D14.7,' /
      DATA    FMTX,    LPRI10       / '1HX,4X,' ,  '(I10,'      /
      DATA    LPREN,   RPREN, DEL   / '(', '1X)',   4H),.)      /
      DATA    END,     TBLE         /  4H*END,      4HTBLE      /
C
      DEBUG = .FALSE.
      IF (TI(1) .LT. 0) DEBUG =.TRUE.
      TI(1) = IABS(TI(1))
      TION  = .FALSE.
      DO 10 L = 1,10
      IF (TI(L) .NE. 0) TION=.TRUE.
   10 CONTINUE
      IF (DEBUG) CALL PAGE1
      IF (DEBUG) WRITE (NOUT,20)
   20 FORMAT (///5X,'*** IN TABLE5/OUTPUT5 ***')
      KORE  = IBUF - 2
C
C     OPEN INPUT FILE, AND READ FILE NAME IN THE FILE HEADER RECORD
C     WRITE ONE HEADER RECORD, IN OUTPT5 MATRIX HEADER FORMAT, TO
C     OUTPUT TAPE
C
      CALL OPEN (*810,IN,Z(IBUF),0)
      CALL READ (*820,*830,IN,NAME,2,1,KK)
      IF (DEBUG) WRITE (NOUT,30) NAME
   30 FORMAT (/5X,'PROCESSING...',2A4,/)
      I = 0
      J = 1
      TRL(7) = 0
      IF (P4 .EQ. 0) WRITE (OUT   ) I,J,J,DTEMP,(TRL(K),K=2,7),NAME
      IF (P4 .EQ. 1) WRITE (OUT,40) I,J,J,DTEMP,(TRL(K),K=2,7),NAME
   40 FORMAT (3I8,/,D26.17,6I8,2A4)
C
   50 IF (P4 .EQ. 1) GO TO 100
C
C     UNFORMATED WRITE
C
      J = 2
   60 CALL READ  (*700,*70,IN,Z(J),KORE,1,KK)
      J = 0
      GO TO 840
   70 IF (J .EQ. 1) GO TO 80
      J = 1
      Z(1) = KK
   80 CALL WRITE (OUT,Z(1),KK,1)
      GO TO 60
C
C     FORMATTED WRITE
C
  100 J = 2
      CALL READ (*700,*110,IN,Z(J),KORE,1,KK)
      J = 0
      GO TO 840
C
C     SET UP USER DIRECTED TI TABLE IN Z(KK2) THRU Z(KK3)
C
  110 IF (DEBUG) WRITE (NOUT,120) (TI(J),J=1,10)
  120 FORMAT (//5X,'TI PARAMETERS =',/4X,10(1X,I9))
      KK1 = KK  + 2
      KK2 = KK1 + KK
      KK3 = KK2 + KK
      J   = KORE - KK3 - 9
      IF (J .LT. 0) GO TO 840
      DO 140 K = KK1,KK3
  140 Z(K) = 0
      IF (.NOT.TION) GO TO 260
      K  = KK1 - 9
      LL = 0
      L  = -1
  150 IF (L .GE. 0) GO TO 170
      L  = 8
      LL = LL + 1
      K  = K  + 9
      IF (K.GE.KK2 .OR. LL.GT.10) GO TO 200
      TIL= TI(LL)
      IF (TIL .GT. 0) GO TO 170
      L  = -1
      GO TO 150
  170 TIL10 = TIL/10
      Z(K+L)= TIL - TIL10*10
      TIL   = TIL10
      L  = L - 1
      GO TO 150
C
  200 K  = KK2 - 1
      IF (DEBUG) WRITE (NOUT,210) (Z(J),J=KK1,K)
  210 FORMAT (//5X,'DIGITIZED TI PARAMTERS =',/,(3X,25I3))
      I  = KK2
      DO 240 J = KK1,K
      JZ = Z(J)
      IF (JZ .LE. 4) GO TO 230
      JI = JZ + I - 1
      JJ = Z(J+1)
      IF (JJ .GT. 4) GO TO 860
      DO 220 L = I,JI
  220 Z(L) = JJ
      I  = JI + 1
      Z(J+1) = -1
      GO TO 240
  230 IF (JZ .EQ. -1) GO TO 240
      Z(I) = JZ
      I  = I + 1
  240 CONTINUE
      I  = KK3 - 1
      IF (DEBUG) WRITE (NOUT,250) (Z(J),J=KK2,I)
  250 FORMAT (//,5X,'DECODED TI PARAMETERS =',/,(3X,25I3))
C
C     COUNT HOW MANY 5-BYTE WORDS TO BE GENERATED, FILLERS INCLUDED
C
  260 KK2 = KK2 - 1
      K   = KK1
      PJJ = 1
      L5  = 10
C
      IF (DEBUG) CALL PAGE1
      DO 400 I = 1,KK
      K   = K + 1
      PJJ = JJ
      IF (TION) GO TO 290
  280 JJ  = NUMTYP(Z(I+1)) + 1
      GO TO 300
  290 JJ  = Z(KK2+I) + 1
      IF (JJ .EQ. 1) GO TO 280
  300 GO TO (310,320,340,380,340), JJ
C              0,  I,  R,  B,  D
C
C     ZERO
C
  310 JJ  = 3
      IF (PJJ.EQ.3 .OR. PJJ.EQ.5) GO TO 340
      JJ  = 2
C
C     INTEGER
C
  320 IF (MOD(L5,130) .LE. 120) GO TO 330
      Z(K)= 6
      K   = K  + 1
      L5  = L5 + 5
  330 Z(K)= JJ
      L5  = L5 + 10
      GO TO 400
C
C     REAL, S.P. OR D.P.
C
  340 J   = MOD(L5,130)
      IF (J-120) 370,350,360
  350 L5  = L5 + 5
      Z(K)= 6
      K   = K  + 1
  360 L5  = L5 + 5
      Z(K)= 6
      K   = K + 1
  370 Z(K)= JJ
      L5  = L5 + 15
      GO TO 400
C
C     BCD
C
  380 Z(K)= JJ
      L5  = L5 + 5
C
  400 CONTINUE
C
C     NOW WE FORM THE FORMAT
C
      DP  = .FALSE.
      KK  = K
      Z(1) = (L5-10)/5
      FMT(1) = LPRI10
C
      L5  = 10
      L   = 1
      I   = 1
      IB  = 1
      K   = KK1
  500 IF (L5 .LT. 130) GO TO 540
      L   = L + 1
      FMT(L) = RPREN
      IF (.NOT.DEBUG) GO TO 520
      CALL PAGE2 (-5)
      WRITE  (NOUT,510) (FMT(J),J=1,L)
  510 FORMAT (/,' DYNAMICALLY GENERATED FORMAT =',/,(1X,7A10))
CWKBD 7/94   520 WRITE  (OUT,FMT,ERR=530) (RZ(J),J=IB,I) 
CWKBNB 7/94
  520 IF ( MACH .NE. 5 .AND. MACH .NE. 2 ) GO TO 525
      WRITE  (OUT,FMT,ERR=530) (RZ(J),J=IB,I) 
      GO TO 530
  525 ISAVE = NOUT
      NOUT  = OUT
      CALL FORWRT ( FMT, RZ(IB), I-IB+1)
      NOUT  = ISAVE
CWKBNE 7/94
  530 IB  = I + 1
      L5  = 0
      L   = 1
      FMT(1) = LPREN
C
  540 K   = K + 1
      IF (K .GT. KK) GO TO 650
      I   = I + 1
      L   = L + 1
      J   = Z(K)
      GO TO (600,600,610,620,630,640), J
C              0,  I,  R,  B,  D, FL
  600 FMT(L) = FMTI
      L5  = L5 + 10
      GO TO 500
C
C     S.P. REAL NUMBERS
C
  610 FMT(L) = FMTR
      L5  = L5 + 15
      GO TO 500
C
  620 FMT(L) = FMTB
      L5  = L5 + 5
      GO TO 500
C
C     D.P. NUMBERS
C
  630 FMT(L) = FMTD
      L5     = L5 + 15
      TEMP(1)= RZ(L  )
      TEMP(2)= RZ(L+1)
      Z(L  ) = SNGL(DTEMP)
      Z(L+1) = DEL
      DP     =.TRUE.
      GO TO 500
C
C     FILLER
C
  640 FMT(L) = FMTX
      L5 = L5 + 5
      I  = I  - 1
      GO TO 500
C
  650 L  = L + 1
      FMT(L) = RPREN
      IF (.NOT.DEBUG) GO TO 660
      CALL PAGE2 (-5)
      WRITE (NOUT,510) (FMT(J),J=1,L)
C
C     REMOVED SECOND HALVES OF ALL D.P. NUMBERS IF THEY ARE PRESENT
C     THEN WRITE THE ARRAY OUT WITH THE GENERATED FORMAT
C
  660 IF (.NOT.DP) GO TO 680
      K   = IB - 1
      DO 670 J = IB,I
      IF (Z(J) .EQ. DEL) GO TO 670
      K   = K + 1
      Z(K)= Z(J)
  670 CONTINUE
      I   = K
CWKBD 7/94  680 WRITE (OUT,FMT,ERR=690) (RZ(J),J=IB,I) 
CWKBNB 7/94
  680 IF ( MACH .NE. 2 .AND. MACH .NE. 5 ) GO TO 685
      WRITE (OUT,FMT,ERR=690) (RZ(J),J=IB,I) 
      GO TO 690
  685 ISAVE = NOUT
      NOUT  = OUT
      CALL FORWRT ( FMT, RZ(IB), I-IB+1) 
      NOUT  = ISAVE
CWKBNE 7/94
C
C     RETURN TO PROCESS ANOTHER RECORD ON INPUT FILE
C
  690 DEBUG = .FALSE.
      GO TO 50
C
C     ALL DONE. SET WRT FLAG, UPDATE LFN AND FN, AND CLOSE INPUT FILE
C     AND ECHO USER MESSAGES
C
  700 WRT = 1
      IF (LFN .LT. 0) LFN = 0
      LFN = LFN + 1
      FN(1,LFN) = NAME(1)
      FN(2,LFN) = NAME(2)
      FN(3,LFN) = TBLE
      CALL CLOSE (IN,1)
      IF (P4 .EQ. 1) GO TO 730
      CALL PAGE2 (-7)
      WRITE  (OUT) I,END
      WRITE  (NOUT,710) UIM,NAME
  710 FORMAT (A29,' FROM OUTPUT5 MODULE, SUCCESSFUL TABLE-DATA ',
     1       'TRANSFERED FROM INPUT FILE ',2A4,' TO OUTPUT TAPE', //5X,
     2        'A HEADER RECORD WAS FIRST WRITTEN, THEN FOLLOWED BY')
      WRITE  (NOUT,720)
  720 FORMAT (5X,'FORTRAN UNFORMATTED (BINARY) WRITE')
      GO TO 950
  730 I  = 1
      WRITE  (OUT,740) I,END
  740 FORMAT (1X,I9,1X,A4)
      CALL PAGE2 (-13)
      WRITE  (NOUT,710) UIM,NAME
      WRITE  (NOUT,750)
  750 FORMAT (5X,'FORTRAN FORMATTED WRITE, 130 CHARACTERS PER LINE -',
     1      /10X,'(''/'',A4 FOR BCD WORD       ( 5 BYTES)',
     2      /11X,'''I'',I9 FOR INTEGER        (10 BYTES)',
     3      /11X,'''R'',E14.7 FOR S.P. REAL   (15 BYTES)',
     4      /11X,'''D'',D14.7 FOR D.P. NUMBER (15 BYTES)',
     5      /11X,'''X    '', FOR FILLER       ( 5 BYTES)')
      GO TO 950
C
C     ERROR
C
  810 J = 1
      GO TO 850
  820 J = 2
      GO TO 850
  830 J = 3
      GO TO 850
  840 IN= J
      J = 8
  850 CALL MESAGE (J,IN,SUB)
      GO TO 880
  860 WRITE  (NOUT,870) UWM,JI,JJ
  870 FORMAT (A25,', OUTPTT5 MODULE PARAMETER ERROR.  WRONG INDEX ',
     1       'VALUES',2I3)
  880 CALL FNAME (IN,NAME)
      WRITE  (NOUT,890) NAME
  890 FORMAT (/5X,'TABLE DATA BLOCK ',2A4,' WAS NOT COPIED TO OUTPUT',
     1        ' TAPE')
  900 CALL FWDREC (*950,IN)
      GO TO 900
C
  950 RETURN 1
      END

      SUBROUTINE MBAMG (INPUT,AJJL,SKJ)
C
C     DRIVER FOR MACH BOX THEORY
C
      LOGICAL         CNTRL2,CNTRL1,CRANK1,CRANK2,ASYM
      INTEGER         SYSBUF,AJJL,SKJ,NAME(2),IZ(1),BUF1,SCR2
      REAL            MACH
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /MBOXA / X(12),Y(12),TANG(10),ANG(10),COTANG(10)
      COMMON /MBOXC / NJJ ,CRANK1,CRANK2,CNTRL1,CNTRL2,NBOX,
     1                NPTS0,NPTS1,NPTS2,ASYM,GC,CR,MACH,BETA,EK,EKBAR,
     2                EKM,BOXL,BOXW,BOXA ,NCB,NSB,NSBD,NTOTE,KC,KC1,KC2,
     3                KCT,KC1T,KC2T
      COMMON /SYSTEM/ SYSBUF,NOUT
      COMMON /AMGMN / MCB(7),NROW,ND,NE,REFC,FMACH,RFK,TSKJ(7),ISK,NSK
      COMMON /PACKX / ITI,IT0,II,NN,INCR
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE     (Z(1),IZ(1))
      DATA    NAME  / 4HMBAM,4HG    /
      DATA    NHCORE, NHCAPF,NHCONT /4HCORE,4HCAPF,4HCONT/
      DATA    SCR2  / 302 /
C
C     SCR2 CONTAINS THE INTERPOLATED POINTS
C
C     2 * KCT FOR NPTS0 POINTS
C     2 * KC1T FOR NPTS1 POINTS
C     2 * KC2T FOR NPTS2 POINTS
C
C
C     OPEN CORE POINTERS FIXED DIMENSIONS
C
      NW1   = 1
      NWN   = 51
      NC21  = 101
      NC2N  = 151
      NC1   = 201
      NCN   = 251
      ND1   = 301
      NDN   = 351
      NXK   = 401
      NYK   = 601
      NXK1  = 801
      NYK1  = 926
      NXK2  = 1051
      NYK2  = 1176
      NXWTE = 1301
      NYWTE = 1351
      NKTE  = 1401
      NKTE1 = 1451
      NKTE2 = 1501
      NPAREA=1551
      ICORR = 9051
C
C     INITITALIZE  PUT HEADER DATA IN MBOXC
C
      ICORE = KORSZ(IZ) - 4*SYSBUF
      BUF1  = ICORE - SYSBUF
      CALL FREAD (INPUT,NJJ,9,0)
      ASYM = .FALSE.
      IF( ND .EQ. -1 ) ASYM = .TRUE.
      MACH = FMACH
      BETA = SQRT((MACH*MACH)-1.0)
      CALL FREAD (INPUT,Z,24,0)
C
C     MOVE X AND Y TO MBOXA
C
      L = 0
      DO 10 I = 1,23,2
      L = L + 1
      X(L)  = Z(I)
      Y(L)  = Z(I+1)
   10 CONTINUE
      CALL MBGEOD
      EK    = (2.0*CR/REFC)*RFK
      CMAX  =  AMAX1(X(4),X(5),X(6))
      BOXL  =  CMAX/(FLOAT(NBOX) + 0.50)
      BOXW  =  BOXL/BETA
      NSB   =  Y(3)/BOXW + 0.5
      NSB   =  MIN0(NSB,50)
      BOXW  =  Y(3)/(FLOAT(NSB) - 0.50)
      BOXL  =  BOXW*BETA
      NCB   =  CMAX/BOXL + 0.999
C
C     CALL MBREG TO GENERATE BOXES
C
      ICRQ = ICORR - BUF1
      IF (ICORR .GT. BUF1) GO TO 996
   20 CALL MBREG (IREG,Z(NW1),Z(NWN),Z(NC21),Z(NC2N),Z(NC1),Z(NCN),
     1            Z(ND1),Z(NDN),Z(NXK),Z(NYK),Z(NXK1),Z(NYK1),Z(NXK2),
     2            Z(NYK2),Z(NXWTE),Z(NYWTE),Z(NKTE),Z(NKTE1),Z(NKTE2),
     3            Z(NPAREA))
      IF (IREG .NE. 2) GO TO 30
      IF (NBOX .LT. 2) GO TO 999
      NBOX = NBOX - 1
      GO TO 20
   30 CALL MBPLOT (Z(NW1),Z(ND1),Z(NWN),Z(NC21),Z(NC2N),Z(NC1),
     1             Z(NCN),Z(NDN))
C
C     CALL MBMODE TO GENERATE MODE LIKE DATA
C
      CALL GOPEN (SCR2,Z(BUF1),1)
      CALL MBMODE (INPUT,SCR2,ICORR,BUF1,Z,NPTS0,KCT,Z(NXK),Z(NYK),IS,
     1             CR)
      IF (IS .EQ. 2) GO TO 997
      IF (CNTRL1) CALL MBMODE (INPUT,SCR2,ICORR,BUF1,Z,NPTS1,KC1T,
     1                         Z(NXK1),Z(NYK1),IS,CR)
      IF (IS .EQ. 2) GO TO 997
      IF (CNTRL2) CALL MBMODE (INPUT,SCR2,ICORR,BUF1,Z,NPTS2,KC2T,
     1                         Z(NXK2),Z(NYK2),IS,CR)
      IF (IS .EQ. 2) GO TO 997
      CALL CLOSE (SCR2,1)
      EKBAR = (EK*BOXL*MACH*MACH)/(BETA*BETA)
      EKM   = EKBAR/MACH
      CALL FREAD (INPUT,0,0,1)
      CALL BUG (NHCORE,80,Z,NYK1-1)
      CALL BUG (NHCORE,80,Z(NYK1),NPAREA-NYK1)
      CALL DMPFIL (SCR2 ,Z(ICORR),BUF1-ICORR)
C
C     MORE DIMENSIONS
C
      IF (MOD(ICORR,2) .EQ. 0) ICORR = ICORR + 1
      NCAP  = ICORR
      NCAPH = NCB*(NCB+1)/2
C
C     COMPLEX PHIS
C
      ICORR = NCAP + NCAPH*2
      ICRQ  = ICORR - BUF1
      IF (ICORR .GT. BUF1) GO TO 996
      CALL MBCAP (NCAPH,Z(NCAP))
      ICORR = NCAP + NCAPH*2
      CALL BUG (NHCAPF,80,Z(NCAP),NCAPH*2)
C
C     PUT OUT SKJ
C
      ITI = 1
      IT0 = 3
      II  = ISK
      NSK = NSK + 1
      NN  = NSK
      RM  = 1.0
      DO 100 I = 1,NJJ
      CALL PACK (RM,SKJ,TSKJ)
      II  = II + 1
      IF (I .EQ. NJJ) GO TO 100
      NN  = NN + 1
  100 CONTINUE
      ISK = II
      NSK = NN
C
C     SET UP FOR COLUMN OF AJJL
C
      ITI = 3
      IT0 = 3
      II  = NROW + 1
      NN  = NROW + NJJ
C
C     GET AJJL MATRIX TERMS
C     MORE DIMENSIONS
C
      NPHIT = ICORR
      NDSS  = NPHIT + (3*NSBD)*2
      NQ    = NDSS  + (NCB*NSBD)*2
      NQ1   = NQ + KCT*2
      NQ2   = NQ1 + KC1T*2
      NA    = NQ2 + KC2T*2
      ICORR = NA + NJJ*2
      CALL BUG (NHXECT,100,X,54)
      CALL BUG (NHCONT,100,NJJ,30)
      ICRQ  = ICORR - BUF1
      IF (ICORR .GT. BUF1) GO TO 996
      CALL MBDPDH (AJJL,Z(NXK),Z(NYK),Z(NXK1),Z(NYK1),Z(NXK2),Z(NYK2),
     1             Z(NXWTE),Z(NYWTE),Z(NPAREA),Z(NCAP),Z(NPHIT),Z(NDSS),
     2             Z(NQ),Z(NQ1),Z(NQ2),Z(NDN),Z(ND1),Z(NW1),Z(NWN),
     3             Z(NKTE),Z(NKTE1),Z(NKTE2),Z(NC1),NCB,NSBD,SCR2,
     4             Z(BUF1),Z(NA))
      NROW = NROW + NJJ
 1000 RETURN
C
C     ERROR MESSAGES
C
  997 WRITE  (NOUT,9971) UFM
 9971 FORMAT (A23,' 2424, MACH BOX CONTROL POINTS IMPROPER SINGULAR ',
     1       'MATRIX RESULTED')
      GO TO 998
  999 WRITE  (NOUT,9991) UFM
 9991 FORMAT (A23,' 2425, MACH BOX GENERATION OF BOXES FAILED')
  998 CALL MESAGE (-37,0,NAME)
  996 CALL MESAGE (-8,ICRQ,NAME)
      GO TO 1000
      END

      SUBROUTINE ALG09
C
      REAL LOSS,LAMI,LAMIP1,LAMIM1
C
      DIMENSION XX1(21),XX2(21),XX3(21),XX4(21),XX5(21),XX6(21),SOL(21),
     1WPARA(21),WD(21),DIF(21),WS(21),PM1(21),XINC(21),BETA1(21),TALPH1(
     221),ANG(21),HIGHM(21),WT(21),XMR(21)
C
      COMMON /UD3PRT/ IPRTC
      COMMON /UD300C/ NSTNS,NSTRMS,NMAX,NFORCE,NBL,NCASE,NSPLIT,NREAD,
     1NPUNCH,NPAGE,NSET1,NSET2,ISTAG,ICASE,IFAILO,IPASS,I,IVFAIL,IFFAIL,
     2NMIX,NTRANS,NPLOT,ILOSS,LNCT,ITUB,IMID,IFAIL,ITER,LOG1,LOG2,LOG3,
     3LOG4,LOG5,LOG6,IPRINT,NMANY,NSTPLT,NEQN,NSPEC(30),NWORK(30),
     4NLOSS(30),NDATA(30),NTERP(30),NMACH(30),NL1(30),NL2(30),NDIMEN(30)
     5,IS1(30),IS2(30),IS3(30),NEVAL(30),NDIFF(4),NDEL(30),NLITER(30),
     6NM(2),NRAD(2),NCURVE(30),NWHICH(30),NOUT1(30),NOUT2(30),NOUT3(30),
     7NBLADE(30),DM(11,5,2),WFRAC(11,5,2),R(21,30),XL(21,30),X(21,30),
     8H(21,30),S(21,30),VM(21,30),VW(21,30),TBETA(21,30),DIFF(15,4),
     9FDHUB(15,4),FDMID(15,4),FDTIP(15,4),TERAD(5,2),DATAC(100),
     1DATA1(100),DATA2(100),DATA3(100),DATA4(100),DATA5(100),DATA6(100),
     2DATA7(100),DATA8(100),DATA9(100),FLOW(10),SPEED(30),SPDFAC(10),
     3BBLOCK(30),BDIST(30),WBLOCK(30),WWBL(30),XSTN(150),RSTN(150),
     4DELF(30),DELC(100),DELTA(100),TITLE(18),DRDM2(30),RIM1(30),
     5XIM1(30),WORK(21),LOSS(21),TANEPS(21),XI(21),VV(21),DELW(21),
     6LAMI(21),LAMIM1(21),LAMIP1(21),PHI(21),CR(21),GAMA(21),SPPG(21),
     7CPPG(21),HKEEP(21),SKEEP(21),VWKEEP(21),DELH(30),DELT(30),VISK,
     8SHAPE,SCLFAC,EJ,G,TOLNCE,XSCALE,PSCALE,PLOW,RLOW,XMMAX,RCONST,
     9FM2,HMIN,C1,PI,CONTR,CONMX
C
      WMAX=0.7
      L1=I+NL1(I)
      XN=SPEED(I)*SPDFAC(ICASE)*PI/(30.0*SCLFAC)
      IF(IPRINT.EQ.0)GO TO 116
      L2=ABS(FLOAT(NEVAL(I)))
      CALL ALG03(LNCT,7+NSTRMS)
      LNCT=LNCT-3
      IF(NEVAL(I).GT.0.AND.IPRTC.EQ.1) WRITE(LOG2,100) L1,I,L2
      IF(NEVAL(I).LT.0.AND.IPRTC.EQ.1) WRITE(LOG2,110) L1,I,L2
100   FORMAT(2X,/,8X,57HLOSS COEFFICIENT DETERMINATION FOR BLADE BETWEEN
     1 STATIONS,I3,4H AND,I3,47H - AS INCORPORATED IN ABOVE RESULTS  BLA
     1DE TYPE,I2,/,8X,116(1H*),/,2X)
110   FORMAT(2X,/,8X,57HLOSS COEFFICIENT DETERMINATION FOR BLADE BETWEEN
     1 STATIONS,I3,4H AND,I3,47H - FOR PURPOSES OF COMPARISON ONLY   BLA
     2DE TYPE,I2,/,8X,116(1H*),/,2X)
116   L2=NDIMEN(I)+1
      GO TO(120,140,160,180),L2
120   DO 130 J=1,NSTRMS
      XX2(J)=R(J,L1)
130   XX6(J)=R(J,I)
      GO TO 200
140   DO 150 J=1,NSTRMS
      XX2(J)=R(J,L1)/R(NSTRMS,L1)
150   XX6(J)=R(J,I)/R(NSTRMS,I)
      GO TO 200
160   DO 170 J=1,NSTRMS
      XX2(J)=XL(J,L1)
170   XX6(J)=XL(J,I)
      GO TO 200
180   DO 190 J=1,NSTRMS
      XX2(J)=XL(J,L1)/XL(NSTRMS,L1)
190   XX6(J)=XL(J,I)/XL(NSTRMS,I)
200   L2=IS2(I)
      CALL ALG01(DATAC(L2),DATA5(L2),NDATA(I),XX6,SOL,X1,NSTRMS,NTERP(I
     1),0)
      Q=1.0
      IF(SPEED(I).LT.0.0)GO TO 208
      IF(SPEED(I).GT.0.0)GO TO 206
      IF(I.LT.3)GO TO 208
      II=I-1
204   IF(SPEED(II).NE.0.0)GO TO 205
      IF(II.EQ.2)GO TO 208
      II=II-1
      GO TO 204
205   IF(SPEED(II).LT.0.0)Q=-1.0
      GO TO 208
206   Q=-1.0
208   DO 210 J=1,NSTRMS
      TALPH1(J)=(VW(J,L1)-XN*R(J,L1))/VM(J,L1)
210   DIF(J)=1.0-VM(J,I)/VM(J,L1)*SQRT((1.0+TBETA(J,I)**2)/(1.0+TALPH1(J
     1)**2))+(VM(J,L1)*TALPH1(J)-VM(J,I)*TBETA(J,I))/(2.0*SOL(J)*VM(J,L1
     2)*SQRT(1.0+TALPH1(J)**2))*Q
      L2=ABS(FLOAT(NEVAL(I)))
      L3=NDIFF(L2)
      CALL ALG01(DIFF(1,L2),FDHUB(1,L2),L3,DIF,XX3,X1,NSTRMS,0,0)
      CALL ALG01(DIFF(1,L2),FDMID(1,L2),L3,DIF,XX4,X1,NSTRMS,0,0)
      CALL ALG01(DIFF(1,L2),FDTIP(1,L2),L3,DIF,XX5,X1,NSTRMS,0,0)
      XX1(1)=0.1
      XX1(2)=0.5
      XX1(3)=0.9
      DO 220 J=1,NSTRMS
      XX1(4)=XX3(J)
      XX1(5)=XX4(J)
      XX1(6)=XX5(J)
      X1=(R(J,I)-R(1,I))/(R(NSTRMS,I)-R(1,I))
220   CALL ALG01(XX1,XX1(4),3,X1,WPARA(J),X1,1,0,0)
      DO 230 J=1,NSTRMS
      XMR(J)=0.0
      HIGHM(J)=0.0
      ANG(J)=0.0
      WS(J)=0.0
      XINC(J)=0.0
      BETA1(J)=0.0
      WD(J)=WPARA(J)*2.0*SOL(J)*SQRT(1.0+TBETA(J,I)**2)
230   WT(J)=WD(J)
      IF(NDEL(I).EQ.0)GO TO 384
      L2=IS3(I)
      CALL ALG01(DELC(L2),DELTA(L2),NDEL(I),XX2,PM1,X1,NSTRMS,1,0)
      IF(NDATA(L1).EQ.0)GO TO 340
      CALL ALG01(R(1,L1),X(1,L1),NSTRMS,R(1,L1),X1,XX1,NSTRMS,0,1)
      L2=NDIMEN(L1)+1
      GO TO(240,260,280,300),L2
240   DO 250 J=1,NSTRMS
250   XX2(J)=R(J,L1)
      GO TO 320
260   DO 270 J=1,NSTRMS
270   XX2(J)=R(J,L1)/R(J,NSTRMS)
      GO TO 320
280   DO 290 J=1,NSTRMS
290   XX2(J)=XL(J,L1)
      GO TO 320
300   DO 310 J=1,NSTRMS
310   XX2(J)=XL(J,L1)/XL(NSTRMS,L1)
320   L2=IS2(L1)
      L3=NDATA(L1)
      CALL ALG01(DATAC(L2),DATA1(L2),L3,XX2,XX3,X1,NSTRMS,NTERP(L1),0)
      CALL ALG01(DATAC(L2),DATA3(L2),L3,XX2,XX4,X1,NSTRMS,NTERP(L1),0)
      DO 330 J=1,NSTRMS
      X1=(ATAN((R(J,L1+1)-R(J,L1))/(X(J,L1+1)-X(J,L1)))+ATAN((R(J,L1)-R(
     1J,L1-1))/(X(J,L1)-X(J,L1-1))))/2.0
      BETA1(J)=ATAN((TAN(XX3(J)/C1)*(1.0-XX1(J)*TAN(X1))-TAN(X1)*TAN(XX4
     1(J)/C1)*SQRT(1.0+XX1(J)**2))*COS(X1))
330   XINC(J)=(ATAN(TALPH1(J))-BETA1(J))*Q
340   DO 380 J=1,NSTRMS
      ANG(J)=XINC(J)+PM1(J)/C1
      X1=H(J,L1)-(VM(J,L1)**2+VW(J,L1)**2)/(2.0*G*EJ)
      IF(X1.LT.HMIN)X1=HMIN
      X4=ALG8(X1,S(J,L1))
      X2=(X4+1.0)/(X4-1.0)
      X3=SQRT(X2)
      X5=ALG9(X1,S(J,L1),VM(J,L1)**2*(1.0+TALPH1(J)**2))
      XMR(J)=SQRT(X5)
      X6=X5
      IF(X6.LT.1.0)X6=1.0
      X7=X3*ATAN(SQRT(X6-1.0)/X3)-ATAN(SQRT(X6-1.0))+ANG(J)
      X10=0.0
      IF(X7.LE.0.0)GO TO 376
      X8=0.4*PI*(X3-1.0)
      IF(X7.GT.X8)GO TO 374
      X9 = 1.0
      K=1
350   X10=X9-(X2+X9*X9)*(1.0+X9*X9)/(X9*X9*(X2-1.0))*(X3*ATAN(X9/X3)-ATA
     1N(X9)-X7)
      IF(ABS(X10-X9).LE.0.00001)GO TO 376
      IF(K.GT.20)GO TO 360
      K=K+1
      X9=X10
      GO TO 350
360   IF(IPRINT.EQ.0)GO TO 374
      CALL ALG03(LNCT,1)
      WRITE(LOG2,370)IPASS,I,J
370   FORMAT(5X,4HPASS,I3,9H  STATION,I3,12H  STREAMLINE,I3,58H  PRANDTL
     1-MEYER FUNCTION NOT CONVERGED - USE INLET MACH NO)
374   X10=SQRT(X6-1.0)
376   HIGHM(J)=SQRT(1.0+X10*X10)
      X1=(HIGHM(J)+SQRT(X6))/2.0
      IF(X5.LT.1.0)X1=X1*SQRT(X5)
      IF(X1.LE.1.0)GO TO 380
      X1=X1*X1
      WS(J)=(((X4+1.0)*X1/((X4-1.0)*X1+2.0))**(X4/(X4-1.0))*((X4+1.0)/(2
     1.0*X4*X1-X4+1.0))**(1.0/(X4-1.0))-1.0)/((1.0+(X4-1.0)/2.0*X5)**(X4
     2/(1.0-X4))-1.0)
380   WT(J)=WD(J)+WS(J)
384   IF(IPRINT.EQ.1)GO TO 400
      L2=IS2(I)
      L3=NTERP(I)
      L4=NDATA(I)
      IF(NWORK(I).GE.5)
     1CALL ALG01(DATAC(L2),DATA6(L2),L4,XX6,XX5,X1,NSTRMS,L3,0)
      CALL ALG01(DATAC(L2),DATA1(L2),L4,XX6,XX1,X1,NSTRMS,L3,0)
      CALL ALG01(DATAC(L2),DATA4(L2),L4,XX6,XX4,X1,NSTRMS,L3,0)
      CALL ALG01(DATAC(L2),DATA3(L2),L4,XX6,XX3,X1,NSTRMS,L3,0)
      NDATA(I)=NSTRMS
      L2=L2-1
      DO 390 J=1,NSTRMS
      K=L2+J
      DATAC(K)=XX6(J)
      IF(NWORK(I).GE.5)
     1DATA6(K)=XX5(J)
      DATA1(K)=XX1(J)
      IF(WT(J).GT.WMAX)WT(J)=WMAX
      DATA2(K)=WT(J)
      DATA3(K)=XX3(J)
      DATA4(K)=XX4(J)
390   DATA5(K)=SOL(J)
      GO TO 450
400   IF(LNCT+3.LE.NPAGE)GO TO 420
      IF(IPRTC.NE.0) WRITE(LOG2,410)
410   FORMAT(1H1)
      LNCT=4+NSTRMS
  420 IF(IPRTC.EQ.1) WRITE(LOG2,430)
430   FORMAT(5X,   'STREAM  INLET   OUTLET  CASCADE   DIFF       LOSS
     1DIFFUSION  BLADE  INCIDENCE  EXPANSION INLET  EXPANDED SHOCK   TOT
     2AL',/,5X,  '-LINE   RADIUS  RADIUS  SOLIDITY  FACTOR  PARAMETER
     3LOSS     ANGLE    ANGLE      ANGLE    M.NO  MACH NO   LOSS   LOSS
     4',/,2X)
      LNCT=LNCT+3
      DO 440 J=1,NSTRMS
      X1=BETA1(J)*C1*Q
      X2=XINC(J)*C1
      X3=ANG(J)*C1
  440 IF(IPRTC.EQ.1)
     *WRITE(LOG2,460)J,R(J,L1),R(J,I),SOL(J),DIF(J),WPARA(J),WD(J),X1,X2
     1,X3,XMR(J),HIGHM(J),WS(J),WT(J)
450   CONTINUE
460   FORMAT(I9,F10.3,F8.3,2F9.4,F10.5,F9.5,2F9.3,F10.3,F10.4,F8.4,F8.5,
     1F9.5)
      RETURN
      END

      SUBROUTINE AMGB1C (Q)
C
C     UNSTEADY FLOW ANALYSIS OF A SUPERSONIC CASCADE
C
      INTEGER         SLN
      COMPLEX         SBKDE1,SBKDE2,F4,F4S,AM4,F5S,F6S,AM4TST,SUM3,SUM4,
     1                AM5TT,AM6,SUMSV1,SUMSV2,SVKL1,SVKL2,F5,F5T,AM5,
     2                AM5T,AI,A,B,BSYCON,ALP,F1,AM1,ALN,BLKAPM,BKDEL3,
     3                F1S,C1,C2P,C2N,C2,AMTEST,FT2,BLAM1,FT3,AM2,SUM1,
     4                SUM2,F2,BLAM2,FT2T,C1T,FT3T,F2P,AM2P,SUM1T,SUM2T,
     5                C1P,C1N,BKDEL1,BKDEL2,BLKAP1,ARG,ARG2,FT3TST,BC,
     6                BC2,BC3,BC4,BC5,CA1,CA2,CA3,CA4,CLIFT,CMOMT,
     7                PRES1,PRES2,PRES3,PRES4,QRES4,FQA,FQB,FQ7,PRESU,
     8                PRESL,Q,GUSAMP
      DIMENSION       GYE(29,29),GEE(29,40),PRESU(29),PRESL(29),XUP(29),
     1                XTEMP(29),GEETMP(29,20),XLOW(29),AYE(10,29),
     2                INDEX(29,3),Q(NSTNS,NSTNS),PRES1(21),PRES2(21),
     3                PRES3(21),PRES4(21),QRES4(21),SBKDE1(201),
     4                SBKDE2(201),SUMSV1(201),SUMSV2(201),SVKL1(201),
     5                SVKL2(201),XLSV1(21),XLSV2(21),XLSV3(21),XLSV4(21)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /SYSTEM/ SYSBUF,IBBOUT
      COMMON /AMGMN / MCB(7),NROW,DUM(2),REFC,SIGM ,RFREQ
      COMMON /BAMG1L/ IREF,MINMAC,MAXMAC,NLINES,NSTNS,REFSTG,REFCRD,
     1                REFMAC,REFDEN,REFVEL,REFFLO,SLN,NSTNSX,STG,
     2                CHORD,RADIUS,BSPACE,MACH,DEN,VEL,FLOWA,AMACHD,
     3                REDFD,BLSPC,AMACHR,TSONIC
      COMMON /BLK1  / SCRK,SPS,SNS,DSTR,AI,PI,DEL,SIGMA,BETA,RES
      COMMON /BLK2  / BSYCON
      COMMON /BLK3  / SBKDE1,SBKDE2,F4,F4S,AM4,F5S,F6S,AM4TST,SUM3,SUM4,
     1                AM5TT,AM6,SUMSV1,SUMSV2,SVKL1,SVKL2,F5,F5T,AM5,
     2                AM5T,A,B,ALP,F1,AM1,ALN,BLKAPM,BKDEL3,F1S,C1,C2P,
     3                C2N,C2,AMTEST,FT2,BLAM1,FT3,AM2,SUM1,SUM2,F2,
     4                BLAM2,FT2T,C1T,FT3T,F2P,AM2P,SUM1T,SUM2T,C1P,C1N,
     5                BKDEL1,BKDEL2,BLKAP1,ARG,ARG2,FT3TST,BC,BC2,BC3,
     6                BC4,BC5,CA1,CA2,CA3,CA4,CLIFT,CMOMT,PRES1,PRES2,
     7                PRES3,PRES4,QRES4,FQA,FQB,FQ7
      COMMON /BLK4  / I,R,Y,A1,B1,C4,C5,GL,I6,I7,JL,NL,RI,RT,R5,SN,SP,
     1                XL,Y1,AMU,GAM,IDX,INX,NL2,RL1,RL2,RQ1,RQ2,XL1,
     2                ALP1,ALP2,GAMN,GAMP,INER,IOUT,REDF,STAG,STEP,
     3                AMACH,BETNN,BETNP,BKAP1,XLSV1,XLSV2,XLSV3,XLSV4,
     4                ALPAMP,AMOAXS,GUSAMP,DISAMP,PITAXS,PITCOR
C
C     THEORY DEPENDENT RESTRICTION OF NO MORE THAN 10 COMPUTING
C     STATIONS PER STREAMLINE IS REFLECTED IN CODING.
C
      IF (NSTNS .GT. 10) GO TO 420
C
      REDF  = REDFD
      AMACH = AMACHD
      AI    = CMPLX(0.0,1.0)
      PI    = 3.1415927
      PITCOR= BLSPC
      STAG  = 90.0 - STG
      SIGMA = -SIGM*PI/180.0
      BETA  = SQRT(AMACH**2 - 1.0)
      SCRK  = REDF*AMACH/(BETA**2)
      DEL   = SCRK*AMACH
      AMU   = REDF/(BETA**2)
      SP    = PITCOR*COS(STAG*PI/180.0)*2.0
      SN    = PITCOR*SIN(STAG*PI/180.0)*2.0
      SPS   = SP
      SNS   = SN*BETA
      DSTR  = SQRT(SPS**2 - SNS**2)
      SPS1  = ABS(SPS - SNS)
      IF (SPS1 .LT. .00001) GO TO 400
C
C     ZERO OUT GEE
C
      NSTNS2 = 2*NSTNS
      NSTNS4 = 4*NSTNS
      DO 10 I = 1,29
      DO 10 J = 1,NSTNS4
   10 GEE(I,J) = 0.0
      PITAXS = 0.0
      AMOAXS = 0.
      CALL ASYCON
      CALL AKP2
      RL1 = 9
      S1  = SPS - SNS
      AA  = S1/RL1
      XLSV1(1) = 0.0
      DO 20 JL = 1,9
   20 XLSV1(JL+1) = JL*AA
      AA  = SPS - SNS
      RL2 = 19
      S1  = 2.0 + SNS - SPS
      TEMP= S1/RL2
      XL  = AA
      DO 30 JL = 1,20
      XLSV2(JL) = XL
      XLSV3(JL) = XL + SNS - SPS
   30 XL  = XL  + TEMP
      XL  = SNS + 2.0 - SPS
      TEMP= (SPS-SNS)/RL1
      DO 40 JL = 1,10
      XLSV4(JL) = XL
   40 XL = XL + TEMP
C
C     ACCUMULATE PRESSURE VECTORS INTO G-MATRIX
C
      DO 140 NM = 1,NSTNS
      NTIMES = 1
      IF (NM .GT.2) NTIMES = 2
      DO 130 NMM = 1,NTIMES
C
C     DEFINE -----------------------------
C            ALPAMP - PITCHING AMP
C            DISAMP - PLUNGING AMP
C            GUSAMP - GUST AMP
C            GL -GUST WAVE NUMBER
C
      ALPAMP = 0.0
      IF (NM .EQ. 2) ALPAMP = 1.0
      DISAMP = 0.0
      IF (NM .EQ. 1) DISAMP = 1.0
      GUSAMP = 0.0
      GL     = 0.0
      IF (NM.GT.2 .AND. NMM.EQ.1) GUSAMP =-REDF/2.0 + (NM-2)*PI/4.0
      IF (NM.GT.2 .AND. NMM.EQ.1) GL = (NM-2)*PI/2.0
      IF (NM.GT.2 .AND. NMM.EQ.2) GUSAMP = REDF/2.0 + (NM-2)*PI/4.0
      IF (NM.GT.2 .AND. NMM.EQ.2) GL =-(NM-2)*PI/2.0
C
      A = (1.0+AI*REDF*PITAXS)*ALPAMP - AI*REDF*DISAMP
      B =-AI*REDF*ALPAMP
      IF (GL .EQ. 0.0) GO TO 50
      A = GUSAMP
      B = 0.0
   50 CONTINUE
      CALL SUBA
C
C     FIND  DELTA P(LOWER-UPPER)
C
      DO 80 NX = 1,10
      PRESU(NX) = PRES1(NX)
      XUP(NX)   = XLSV1(NX)
      IF (NX .EQ. 10) GO TO 60
      NXX = NX + 20
      PRESL(NXX) = PRES4(NX+1)
      XLOW( NXX) = XLSV4(NX+1)
      GO TO 70
   60 PRESU(NX) = (PRES1(10) + PRES2(1))/2.0
      XUP(10)   = (XLSV1(10) + XLSV2(1))/2.0
   70 CONTINUE
   80 CONTINUE
      DO 110 NX = 1,20
      NXX = NX + 10
      IF (NX .EQ. 20) GO TO 90
      PRESU(NXX) = PRES2(NX+1)
      XUP  (NXX) = XLSV2(NX+1)
      PRESL(NX)  = PRES3(NX)
      XLOW( NX)  = XLSV3(NX)
      GO TO 100
   90 PRESL(20) = (PRES3(20) + PRES4(1))/2.0
      XLOW(20)  = (XLSV3(20) + XLSV4(1))/2.0
  100 CONTINUE
  110 CONTINUE
      NM2 = NM + NSTNS
      NM3 = NM + 2*NSTNS
      NM4 = NM + 3*NSTNS
      DO 120 NMMM = 1,29
      GEE(NMMM,NM)  = GEE(NMMM,NM ) + REAL(PRESL(NMMM))
      GEE(NMMM,NM2) = GEE(NMMM,NM2) + AIMAG(PRESL(NMMM))
      GEE(NMMM,NM3) = GEE(NMMM,NM3) + REAL(PRESU(NMMM))
      GEE(NMMM,NM4) = GEE(NMMM,NM4) + AIMAG(PRESU(NMMM))
  120 CONTINUE
  130 CONTINUE
  140 CONTINUE
C
C     NOW DEFINE  I-MATRIX (NSTNS X 29)
C
      AYE(1,1) = 2.0
      CON = 1.0
      AYE(1,2) = 2.0
      N1N = 27
      DO 150 J = 1,N1N
      AYE(1,J+2) = CON*4.0/J/PI
  150 CON = 1.0 - CON
      AYE(2,1) = 2.0
      AYE(2,2) = 2.66666667
      CON = 1.0
      DO 160 J = 1,N1N
      AYE(2,J+2) = CON*4/J/PI
  160 CON = -CON
      DO 170 I = 3,NSTNS
      DO 170 J = 2,28
      CON = 0.0
      IF ((I-1) .EQ. J) CON = 1.0
  170 AYE(I,J+1) = CON
      DO 180 J = 3,NSTNS
      AYE(J,1) = AYE(1,J)
  180 AYE(J,2) = AYE(2,J)
C
C     Q DUE TO PRESL ONLY
C
C     NOW DEFINE LARGE G MATRIX
C
      DO 190 I = 1,29
      GYE(1,I) = 0.0
  190 GYE(I,1) = 1.0
C
C     PUT XLOW IN XTEMP
C
      DO 200 I = 1,29
  200 XTEMP(I) = XLOW(I)
      DO 210 J = 3,29
      CONST = (J-2)*PI/2.0
      DO 210 I = 2,29
      GYE(I,J) = SIN(CONST*XTEMP(I))
  210 CONTINUE
      DO 220 I = 2,29
  220 GYE(I,2) = XTEMP(I)
C
C     PUT PRESL PART OF GEE IN GEETMP
C
      DO 230 I = 1,29
      DO 230 J = 1,NSTNS2
  230 GEETMP(I,J) = GEE(I,J)
C
C     SOLVE FOR G-INVERSE G IN GEE MATRIV
C     ISING = 1 NON-SINGULAR (GYE)
C     ISING = 2  SIGULAR     (GYE)
C     INDEX IS WORK STORAGE FOR ROUTINE INVERS
C
      ISING = -1
      CALL INVERS (29,GYE,29,GEETMP,NSTNS2,DETERM,ISING,INDEX)
      IF (ISING .EQ. 2) GO TO 410
C
C     NOW  MULTIPLY  I*G-INVERSE*G(DELTA P'S)
C
      DO 250 J = 1,NSTNS
      DO 250 K = 1,NSTNS
      NF   = K + NSTNS
      SUMI = 0.0
      SUMR = 0.0
      DO 240 I = 1,29
      SUMR = AYE(J,I)*GEETMP(I,K ) + SUMR
      SUMI = AYE(J,I)*GEETMP(I,NF) + SUMI
  240 CONTINUE
C
C  NOTE - NOTE THAT DUE TO CEXP( - I*OMEGA*T) TYPE OF TIME DEPENDENCE
C         IN UCAS DEVELOPMENT, Q IS DEFINED AS THE COMPLEX CONJUGATE
C         OF 'USUAL' Q
C
  250 Q(J,K) = 2.0*CMPLX(SUMR,-SUMI)
C
C     FINALLY, Q DUE TO (PRESL-PRESU) IS COMPUTED BY SUBTRACTING Q DUE
C     TO PRESU FROM Q DUE TO PRESL ABOVE
C
C     LARGE G MATRIX
C
      DO 260 I = 1,29
      GYE(1,I) = 0.0
  260 GYE(I,1) = 1.0
C
C     PUT XUP IN XTEMP
C
      DO 270 I = 1,29
  270 XTEMP(I) = XUP(I)
      DO 280 J = 3,29
      CONST = (J-2)*PI/2.0
      DO 280 I = 2,29
      GYE(I,J) = SIN(CONST*XTEMP(I))
  280 CONTINUE
      DO 290 I = 2, 29
  290 GYE(I,2) = XTEMP(I)
C
C     PUT PRESU PART OF GEE IN GEETMP
C
      DO 300 I = 1,29
      DO 300 J = 1,NSTNS2
C
      NSNS2 = NSTNS2 + J
  300 GEETMP(I,J) = GEE(I,NSNS2)
C
C     SOLVE FOR G-INVERSE G IN GEETMP MATRIX
C     ISING = 1  NON-SINGULAR (GYE)
C     ISING = 2  SINGULAR GYE
C     INDEX IS WORK STORAGE FOR ROUTINE INVERS
C
      ISING = -1
      CALL INVERS (29,GYE,29,GEETMP,NSTNS2,DETERM,ISING,INDEX)
C
      IF (ISING .EQ. 2) GO TO 410
C
C     MULTIPLY I*G-INVERS*G
C
      DO 320 J = 1,NSTNS
      DO 320 K = 1,NSTNS
      NF = K + NSTNS
      SUMI = 0.0
      SUMR = 0.0
      DO 310 I = 1,29
C
      SUMR = AYE(J,I)*GEETMP(I,K ) + SUMR
      SUMI = AYE(J,I)*GEETMP(I,NF) + SUMI
C
  310 CONTINUE
C
  320 Q(J,K) = Q(J,K) - 2.0*CMPLX(SUMR,-SUMI)
C
      RETURN
C
  400 WRITE (IBBOUT,500) UFM
      GO TO 430
  410 WRITE (IBBOUT,510) UFM
      GO TO 430
  420 WRITE (IBBOUT,520) UFM,SLN,NSTNS
  430 CALL MESAGE (-61,0,0)
      RETURN
C
  500 FORMAT (A23,' - AMG MODULE -SUBROUTINE AMGB1C', /39X,
     1        'AXIAL MACH NUMB. IS EQUAL TO OR GREATER THAN ONE.')
  510 FORMAT (A23,' - AMG MODULE - LARGE G-MATRIX IS SINGULAR IN ',
     2        'ROUTINE AMGBIC.')
  520 FORMAT (A23,' - AMG MODULE - NUMBER OF COMPUTING STATIONS ON ',
     1        'STREAMLINE',I8,4H IS ,I3,1H. , /39X,'SUPERSONIC CASCADE',
     2        ' ROUTINE AMGB1C ALLOWS ONLY A MAXIMUM OF 10.')
      END

      SUBROUTINE FRRD1D (PD,ULL,LLL,SCR1,SCR2,UDV,IFR,NLOAD,IGOOD,NFREQ)
C
C     ROUTINE SOLVES FOR UDV GIVEN ULL,LLL, AND PD
C
C     IF IGOOD = 1 DCOMP FAILED -- PUT ZERO SOLUTION VECTORS OUT
C
C     1. PULL LOADS FROM PD ONTO SCR1
C     2. SOLVE FOR UDV-S ON SCR2
C     3. STACK SOLVED LOADS ON UDV
C
      INTEGER         SYSBUF,PD,ULL,LLL,SCR1,SCR2,UDV,FL,FU,FB,FX,PREC,
     1                FILE,ICORE(1),UDV1,MCB(7),NAME(2),MCORE(1)
      COMMON /MACHIN/ MACH
      COMMON /UNPAKX/ IT1,II,JJ,INCR
      COMMON /PACKX / IT2,IT3,II1,JJ1,INCR1
      COMMON /SYSTEM/ KSYSTM(65)
      COMMON /GFBSX / FL(7),FU(7),FB(7),FX(7),NX,PREC,ISIGN
      COMMON /FBSX  / MFL(7),MFLT(7),MFB(7),MFX(7),MX,MPREC,MSIGN,ISCRX
      COMMON /ZZZZZZ/ CORE(1)
      EQUIVALENCE     (KSYSTM(1),SYSBUF),(KSYSTM(55),IPREC),
     1                (CORE(1),ICORE(1),MCORE(1))
      DATA    NAME  / 4HFRRD,4H1D  /, IC / 0 /
C
      NX    = KORSZ(CORE)
      FB(1) = PD
      CALL RDTRL (FB)
      FX(1) = SCR2
      IF (IFR .EQ. 1) FX(1) = UDV
      FX(2) = NLOAD
      FX(3) = FB(3)
      FX(4) = 2
      FX(5) = 2 + IPREC
      IT1   = FB(5)
      INCR  = 1
      INCR1 = 1
      IT2   = IT1
      IT3   = 2 + IPREC
      IF (IGOOD .EQ. 1) GO TO 98
C
C     PULL LOADS FROM PD ONTO SCR1
C
      FU(1) = ULL
      CALL RDTRL (FU)
      FL(1) = LLL
      CALL RDTRL (FL)
      IF (NFREQ .EQ. 1) GO TO 30
      NZ = NX - SYSBUF
      CALL GOPEN (PD,CORE(NZ+1),0)
      CALL SKPREC (PD,IFR-1)
      NZ = NZ - SYSBUF
      CALL GOPEN (SCR1,CORE(NZ+1),1)
      CALL MAKMCB (MCB,SCR1,FB(3),2,IT3)
      DO 10 I = 1,NLOAD
      IF (I .GT. 1) CALL SKPREC (PD,NFREQ-1)
      II = 0
      CALL UNPACK (*28,PD,CORE)
      II1 = II
      JJ1 = JJ
   22 CALL PACK (CORE,SCR1,MCB)
      GO TO 10
   28 CORE(   1) = 0
      CORE(IC+2) = 0
      CORE(IC+3) = 0
      CORE(IC+4) = 0
      II1 = 1
      JJ1 = 1
      GO TO 22
   10 CONTINUE
      CALL WRTTRL (MCB)
      CALL CLOSE (PD,1)
      CALL CLOSE (SCR1,1)
C
C     SET UP FOR GFBS
C
      FB(1) = SCR1
   30 FB(2) = NLOAD
      CALL WRTTRL (FB)
      PREC = 1
      IF (FB(5).EQ.2 .OR. FB(5).EQ.4) PREC = 2
      ISIGN = 1
      IF (FU(1) .LT. 0) GO TO 40
      CALL GFBS (CORE,CORE)
      CALL WRTTRL (FX)
      GO TO 98
C
C     SET UP FOR FBS
C
   40 DO 41 I = 1,7
      MFL(I) = FL(I)
C
C     FBS DOES NOT USE THE MATRIX CONTROL BLOCK MFLT.
C     IF MFLT(1) EXISTS, SET ISCRX = MFLT(1) FILE FOR NEW FBS METHOD.
C     OTHERWISE SET ISCRX = 0, AND WE DO NOT HAVE A SCRATCH FILE FOR
C     NEW FBS. OLD FBS WILL BE USED.
C
      MFB(I) = FB(I)
      MFX(I) = FX(I)
   41 CONTINUE
      MPREC = PREC
      MSIGN = ISIGN
      MX    = KORSZ(MCORE)
      ISCRX = MFLT(1)
      MCORE(1) = MFLT(1)
      CALL RDTRL (MCORE(1))
      IF (MCORE(1) .LE. 0) ISCRX = 0
      CALL FBS (MCORE,MCORE)
      CALL WRTTRL (MFX)
   98 ICORE(1) = 16777215
C                16777215 = '00FFFFFF'X
      IFLAG = 1
C
C     STACK LOADS ONTO UDV
C
      FILE = UDV
      NZ   = NX-SYSBUF
      IF (IFR .EQ. 1) GO TO 300
      CALL OPEN (*900,UDV,CORE(NZ+1),0)
      FX(1) = UDV
      CALL RDTRL (FX)
      IF (MACH .NE. 1) GO TO 60
   50 CALL FWDREC (*51,UDV)
      GO TO 50
   51 CALL BCKREC (UDV)
      CALL SKPREC (UDV,1)
      GO TO 61
   60 CALL SKPFIL (UDV,1)
      CALL SKPFIL (UDV,-1)
   61 CALL CLOSE (UDV,2)
      CALL OPEN (*900,UDV,CORE(NZ+1),3)
C
C     RESET TYPE FLAGS
C
      IT1 = FX(5)
      IT2 = IT1
      IT3 = IT1
      IF (IGOOD .EQ. 1) GO TO 101
      NZ  = NZ - SYSBUF
      CALL GOPEN (SCR2,CORE(NZ+1),0)
  101 DO 55 I = 1,NLOAD
      IF (IGOOD .EQ. 1) GO TO 54
      II  = 0
      CALL UNPACK (*54,SCR2,CORE)
      II1 = II
      JJ1 = JJ
   53 CALL PACK (CORE,UDV,FX)
      GO TO 55
   54 CORE(   1) = 0
      CORE(IC+2) = 0
      CORE(IC+3) = 0
      CORE(IC+4) = 0
      II1 = 1
      JJ1 = 1
      GO TO 53
   55 CONTINUE
      CALL CLOSE (UDV,1)
      IF (IGOOD .EQ. 1) GO TO 56
      CALL CLOSE (SCR2,1)
   56 CONTINUE
      CALL WRTTRL (FX)
  350 RETURN
C
  300 IF (IGOOD .NE. 1) GO TO 350
      CALL GOPEN (UDV,CORE(NZ+1),1)
      FX(2) = 0
      FX(6) = 0
      FX(7) = 0
      CALL WRTTRL (FX)
      GO TO 101
C
C     ERROR MESAGES
C
  900 CALL MESAGE (-1,FILE,NAME)
C
C
      ENTRY FRRD1E (UDV1,UDV,NLOAD,NFREQ)
C     ===================================
C
      NZ = KORSZ(CORE) - SYSBUF
C
C     ROUTINE REORDERS SOLUTIONS TO GET SORT BY LOADS
C
      FILE = UDV1
      CALL OPEN (*900,UDV1,CORE(NZ+1),0)
      NZ   = NZ - SYSBUF
      CALL GOPEN (UDV,CORE(NZ+1),1)
      FILE = UDV1
      DO 400 I = 1,NLOAD
      CALL SKPREC (UDV1,I)
      DO 500 M = 1,NFREQ
      II  = 0
      CALL UNPACK (*420,UDV1,CORE)
      II1 = II
      JJ1 = JJ
  421 CALL PACK (CORE,UDV,MCB)
      GO TO 422
  420 CORE(   1) = 0
      CORE(IC+2) = 0
      CORE(IC+3) = 0
      CORE(IC+4) = 0
      II1 = 1
      JJ1 = 1
      GO TO 421
  422 IF (M .LT. NFREQ) CALL SKPREC (UDV1,NLOAD-1)
  500 CONTINUE
      CALL REWIND (UDV1)
  400 CONTINUE
      CALL CLOSE (UDV1,1)
      CALL CLOSE (UDV,1)
      FX(1) = UDV1
      CALL RDTRL (FX)
      FX(1) = UDV
      CALL WRTTRL (FX)
      RETURN
      END

      SUBROUTINE SQDME1
C
C          ECPT                        ECPT
C       RECEIVED BY                 REQUIRED BY
C         SQDME1                      STRME1
C     -----------------------     --------------------------
C     ECPT( 1) = EL. ID           ECPT( 1) = EL. ID
C     ECPT( 2) = GRD. PT. A       ECPT( 2) = GRD. PT. A
C     ECPT( 3) = GRD. PT. B       ECPT( 3) = GRD. PT. B
C     ECPT( 4) = GRD. PT. C       ECPT( 4) = GRD. PT. C
C     ECPT( 5) = GRD. PT. D       ECPT( 5) = THETA
C     ECPT( 6) = THETA            ECPT( 6) = MATERIAL ID
C     ECPT( 7) = MATERIAL ID      ECPT( 7) = T
C     ECPT( 8) = T                ECPT( 8) = NON-STRUCT. MASS
C     ECPT( 9) = NON-STRUCT. MASS ECPT( 9) = COORD. SYS. ID 1
C     ECPT(10) = COORD. SYS. ID 1 ECPT(10) = X1
C     ECPT(11) = X1               ECPT(11) = Y1
C     ECPT(12) = Y1               ECPT(12) = Z1
C     ECPT(13) = Z1               ECPT(13) = COORD. SYS. ID 2
C     ECPT(14) = COORD. SYS. ID 2 ECPT(14) = X2
C     ECPT(15) = X2               ECPT(15) = Y2
C     ECPT(16) = Y2               ECPT(16) = Z2
C     ECPT(17) = Z2               ECPT(17) = COORD. SYS. ID 3
C     ECPT(18) = COORD. SYS. ID 3 ECPT(18) = X3
C     ECPT(19) = X3               ECPT(19) = Y3
C     ECPT(20) = Y3               ECPT(20) = Z3
C     ECPT(21) = Z3               ECPT(21) = ELEMENT TEMPERATURE
C     ECPT(22) = COORD. SYS. ID 4
C     ECPT(23) = X4
C     ECPT(24) = Y4
C     ECPT(25) = Z4
C     ECPT(26) = ELEMENT TEMPERATURE
C
C     NOTE. THE FOLLOWING ARE INTEGERS - GRID POINTS, MAT ID, EL.ID,
C                                        COORD. SYS. IDS.
C           ALL OTHERS ARE REAL IN THE ECPT.
C
      INTEGER         NECPT(100)
      REAL            IVEC,JVEC,KVEC
      DIMENSION       M(12),R(6),NGRID(4),COORD(16),SSUBT(3),S(27)
      COMMON /CONDAS/ CONSTS(5)
      COMMON /SDR2X6/ DUMMY(100),SUM(36),STEMP(9),D1(3),D2(3),A1(3),
     1                A2(3),A3(3),A4(3),IVEC(3),JVEC(3),KVEC(3),VECL,H,
     2                V(8),ECPTSA(36),ST(3),NCOORD,NPOINT,NSUB1,NSUB2,
     3                NSUB3,T(9),COSANG,SINANG,U1,U2,DUMY(61)
      COMMON /SDR2X5/ ECPT(100),PH1OUT(100),FORVEC(25)
      COMMON /MATIN / MATID,INFLAG,ELTEMP,STRESS,SINTH,COSTH
      EQUIVALENCE     (CONSTS(4),DEGRA),(NECPT(1),ECPT(1)),
     1                (R(1),IVEC(1)),(NGRID(1),ECPTSA(2)),
     2                (COORD(1),ECPTSA(10)),(S(1),PH1OUT(10)),
     3                (SSUBT(1),PH1OUT(7))
      DATA    M     / 1, 2, 4, 2, 3, 1, 3, 4, 2, 4, 1, 3 /
C
C
      ANGL   = ECPT(6)*DEGRA
      COSANG = COS(ANGL)
      SINANG = SIN(ANGL)
C
C     VECTORS D1 AND D2  FMMS-46 PAGE 6
C     A1 A2 A3 A4
C
      DO 10 I = 1,3
      D1(I) = ECPT(I+18) - ECPT(I+10)
      D2(I) = ECPT(I+22) - ECPT(I+14)
      A1(I) = ECPT(I+14) - ECPT(I+10)
      A2(I) = ECPT(I+18) - ECPT(I+14)
      A3(I) = ECPT(I+22) - ECPT(I+18)
   10 A4(I) = ECPT(I+10) - ECPT(I+22)
C
C     K-VECTOR = NORMALIZED D1 CROSS D2
C
      KVEC(1) = D1(2)*D2(3) - D1(3)*D2(2)
      KVEC(2) = D1(3)*D2(1) - D1(1)*D2(3)
      KVEC(3) = D1(1)*D2(2) - D1(2)*D2(1)
      VECL    = SQRT(KVEC(1)**2 + KVEC(2)**2 + KVEC(3)**2)
      IF (VECL .LT. 1.0E-06) CALL MESAGE (-30,26,ECPT(1))
      KVEC(1) = KVEC(1)/VECL
      KVEC(2) = KVEC(2)/VECL
      KVEC(3) = KVEC(3)/VECL
C
C     I-VECTOR = NORMALIZED A SUB 12 - H * KVECTOR
C     GET H FIRST = (A SUB 12 DOT KVECTOR)/2
C
      H = (A1(1)*KVEC(1) + A1(2)*KVEC(2) + A1(3)*KVEC(3))/2.0
C
      IVEC(1) = A1(1) - H*KVEC(1)
      IVEC(2) = A1(2) - H*KVEC(2)
      IVEC(3) = A1(3) - H*KVEC(3)
      VECL    = SQRT(IVEC(1)**2 + IVEC(2)**2 + IVEC(3)**2)
      IF (VECL .LT. 1.0E-06) CALL MESAGE (-30,26,ECPT(1))
      IVEC(1) = IVEC(1)/VECL
      IVEC(2) = IVEC(2)/VECL
      IVEC(3) = IVEC(3)/VECL
C
C     J-VECTOR = K CROSS I
C
      JVEC(1) = KVEC(2)*IVEC(3) - KVEC(3)*IVEC(2)
      JVEC(2) = KVEC(3)*IVEC(1) - KVEC(1)*IVEC(3)
      JVEC(3) = KVEC(1)*IVEC(2) - KVEC(2)*IVEC(1)
C
      VECL    = SQRT(JVEC(1)**2 + JVEC(2)**2 + JVEC(3)**2)
      JVEC(1) = JVEC(1)/VECL
      JVEC(2) = JVEC(2)/VECL
      JVEC(3) = JVEC(3)/VECL
C
C
      V(1) = 1.0
      V(2) = 0.0
C
C     R ARRAY IS EQUIVALENCED TO IVECTOR AND JVECTOR
C
      CALL GMMATS (R,2,3,0, A2,3,1,0, V(3))
      CALL GMMATS (R,2,3,0, A3,3,1,0, V(5))
      CALL GMMATS (R,2,3,0, A4,3,1,0, V(7))
C
C     NORMALIZE THE 4 2X1 V ARRAYS
C
      DO 20 I = 1,4
      VECL = SQRT(V(2*I-1)**2 + V(2*I)**2)
      IF (VECL .LT. 1.0E-10) CALL MESAGE (-30,26,ECPT(1))
      V(2*I-1) = V(2*I-1)/VECL
   20 V(2*I  ) = V(2*I  )/VECL
C
C     MAPPING MATRIX M IS IN DATA STATEMENT.
C
C     NOW MAKE 4 CALLS TO STRME1 WHICH WILL RETURN
C     S , S , S , S , T SUB 0
C      A   B   C   T
C
C     SAVE GRID SILS AND COORDINATE SYSTEMS.
C
      DO 30 I = 1,36
   30 ECPTSA(I) = ECPT(I)
C
      ECPT(6) = ECPT(7)
      ECPT(7) = ECPT(8)
      ECPT(8) = ECPT(9)
C
C     ZERO OUT SUM MATRICES
C
      DO 40 I = 1,36
   40 SUM(I) = 0.0
      ST(1) = 0.0
      ST(2) = 0.0
      ST(3) = 0.0
C
      ECPT(21) = ECPT(26)
C
      DO 90 I = 1,4
C
C     POINTER TO THE SILS IN THE MAPPING MATRIX
C
      NCOORD = 8
      NPOINT = 3*I - 3
      DO 60 J = 2,4
      NPOINT = NPOINT + 1
      NSUB1  = M(NPOINT)
      DO 50 K = 1,4
      NSUB3  = 4*NSUB1 - 4 + K
      NCOORD = NCOORD + 1
   50 ECPT(NCOORD) = COORD(NSUB3)
   60 NECPT(J) = NGRID(NSUB1)
C
C     SET UP T MATRIX FOR THIS TRIANGLE.  T IS 3X3
C
      U1   = V(2*I-1)
      U2   = V(2*I  )
C
      T(1) = U1**2
      T(2) = U2**2
      T(7) = U1*U2
      T(3) =-2.0*T(7)
      T(4) = T(2)
      T(5) = T(1)
      T(6) =-T(3)
      T(8) =-T(7)
      T(9) = T(1) - T(2)
C
C     COMPUTE NET SINTH AND COSTH FOR ANISOTROPIC POSSIBILITY
C
      SINTH = SINANG*U1 - COSANG*U2
      COSTH = COSANG*U1 + SINANG*U2
C
      CALL STRME1 (1)
C
C
C     NOW TRANSFORM AND ADD THE S MATRICES INTO THE RESPECTIVE SUM
C     MATRICES.
C
      DO 80 J = 1,3
C
C     POINTER TO TRIANGLE I ROW IN THE MAPPING MATRIX
C
      NPOINT = 3*I - 3
C
C     TRANSFORM S
C
      CALL GMMATS (T,3,3,0, S(9*J-8),3,3,0, STEMP)
C
C     ADD STEMP INTO RESPECTIVE KSUM POSITIONS
C
C     ZERO POINTER INTO KSUM MATRICES
C
      NSUB1 = NPOINT + J
      NSUB1 = M(NSUB1)*9 - 9
      DO 70 K = 1,9
      NSUB1 = NSUB1 + 1
   70 SUM(NSUB1) = SUM(NSUB1) + STEMP(K)
   80 CONTINUE
C
C     TRANSFORM AND ADD IN S SUB T
C
      CALL GMMATS (T,3,3,0, S SUB T, 3,1,0, STEMP)
      ST(1) = ST(1) + STEMP(1)
      ST(2) = ST(2) + STEMP(2)
      ST(3) = ST(3) + STEMP(3)
   90 CONTINUE
C
C     ALL MATRICES COMPLETE
C
C     FILL OUTPUT BLOCK
C
      DO 100 I = 1,5
  100 PH1OUT(I) = ECPTSA(I)
      PH1OUT(7) = ST(1)*0.25
      PH1OUT(8) = ST(2)*0.25
      PH1OUT(9) = ST(3)*0.25
      DO 110 I = 1,36
  110 PH1OUT(I+9) = 0.25*SUM(I)
C
C     PHASE 1 COMPLETE OUTPUT BLOCK CONTAINS 45 WORDS
C
      RETURN
      END

      SUBROUTINE SOLVE1(A1,R1,RP,XI,LAM2,LAM3,LAM4,CONT)
C
C     ROUTINE TO SOLVE FOR LAMBDAS AS FNCTS. OF XI
C
C
      REAL LAM2,LAM3,LAM4
C
      IF (RP.EQ.0.0) GO TO 20
C
      SUM = A1 + XI / RP
      SINSUM = SIN(SUM)
      BB = R1 - RP * (SIN(A1) - SINSUM)
      RT = 0.0E0
      IF( SINSUM .NE. 0.0E0 ) RT = BB / SINSUM
      PSI1 = COS(SUM)
      PSI2 = -SINSUM / RP
C
C     CHECK FOR SHELL CAP CASE
      IF ( A1 .NE. 0.0 )  GO TO 40
      LAM2  = 0.0E0
      IF( BB .NE. 0.0E0 ) LAM2  = PSI1 / BB
      LAM3  =  1.0 / RP
      LAM4  = -1.0 / RP**2
      GO TO 50
C
C     ALF1 = ALF2
C
   20 SINA = SIN(A1)
      COSA = COS(A1)
      BB = R1 + XI * COSA
      RT = 0.0E0
      IF( SINA .NE. 0.0E0 ) RT = BB / SINA
      PSI1 = COSA
      PSI2 = 0.0
C
   40 LAM2 = 0.0E0
      IF( BB .NE. 0.0E0 ) LAM2 = PSI1 / BB
      LAM3 = 0.0E0
      IF( RT .NE. 0.0E0 ) LAM3 = 1.0E0 / RT
      LAM4 = 0.0E0
      IF( BB .NE. 0.0E0 ) LAM4 = PSI2 / BB
C
   50 CONTINUE
      RETURN
      END

      SUBROUTINE FLBPRT (IUSET,IEQEX,IBUF)
C
C     HYDROELEASTIC USET OUTPUT
C
C     PRINTS DOF VS. DISP SETS IF DIAG 32 IS ON.
C     PRINTS DISP SETS VS. DOF IF DIAG 33 IS ON.
C
      EXTERNAL        ANDF
      INTEGER         Z        ,SYSBUF   ,EQEXIN   ,D32      ,D33      ,
     1                FILE     ,NAME(2)  ,MSK(17)  ,ZGRD(10) ,TITLE(3,9)
     2,               ZDOF(10) ,TWO      ,UM       ,UO       ,UR       ,
     3                USG      ,USB      ,UL       ,UA       ,UF       ,
     4                US       ,UN       ,UG       ,UX       ,UY       ,
     5                UFR      ,UZ       ,UAB      ,UI       ,DASH     ,
     6                ASTRIC   ,BLANK    ,SBIT(17) ,EXPNT    ,UPBIT(17),
     7                ANDF
      CHARACTER       UFM*23   ,UWM*25
      COMMON /XMSSG / UFM      ,UWM
      COMMON /FLBFIL/ DUM1(8)  ,EQEXIN
      COMMON /ZZZZZZ/ Z(1)
      COMMON /SYSTEM/ SYSBUF   ,NOUT     ,DUM2(6)  ,NLPP     ,
     1                DUM3     ,NPAGE    ,LINE
      COMMON /TWO   / TWO(32)
      COMMON /BITPOS/ UM       ,UO       ,UR       ,USG      ,
     1                USB      ,UL       ,UA       ,UF       ,
     2                US       ,UN       ,UG       ,UE       ,
     3                UP       ,UNE      ,UFE      ,UD       ,
     4                UPS      ,USA      ,UK       ,UPA      ,
     5                U21      ,U22      ,U23      ,UX       ,
     6                UY       ,UFR      ,UZ       ,UAB      ,
     7                UI
      DATA    NAME  / 4HFLBP   , 4HRT    /
      DATA    TITLE / 4H       , 4H      , 4H MPC  ,
     1                4H       , 4H      , 4H SPC  ,
     2                4H       , 4H      , 4HOMIT  ,
     3                4H       , 4HANAL  , 4HYSIS  ,
     4                4H       , 4HPERM  , 4H SPC  ,
     5                4H       , 4HBDRY  , 4H SPC  ,
     6                4H   S   , 4HTRUC  , 4HTURE  ,
     7                4H       , 4H   F  , 4HLUID  ,
     8                4HFREE   , 4H SUR  , 4HFACE  /
      DATA    BLANK / 1H  /    , DASH    / 1H- /   , ASTRIC / 1H* /
C
C
C     DETERMINE IF ANY OUTPUT IS REQUESTED
C
      CALL SSWTCH (32,D32)
      CALL SSWTCH (33,D33)
      IF (D32.EQ.0 .AND. D33.EQ.0) RETURN
C
C     READ EQEXIN INTO CORE
C
      FILE = EQEXIN
      CALL OPEN (*1001,EQEXIN,Z(IBUF),0)
      CALL FWDREC (*1002,EQEXIN)
      CALL FWDREC (*1002,EQEXIN)
      NZ = IBUF - IEQEX
      CALL READ (*1002,*10,EQEXIN,Z(IEQEX),NZ,1,NEQEX)
      GO TO 1008
   10 CALL CLOSE (EQEXIN,1)
C
C     SORT ON INTERNAL ID
C
      CALL SORT (0,0,2,2,Z(IEQEX),NEQEX)
C
C     SET UP USET MASKS FOR DOF VS. DISP SET PRINTOUT
C
      IF (D32 .EQ. 0) GO TO 100
      MSK( 1) = TWO(USB)
      MSK( 2) = TWO(USG)
      MSK( 3) = TWO( UL)
      MSK( 4) = TWO( UA)
      MSK( 5) = TWO( UF)
      MSK( 6) = TWO( UN)
      MSK( 7) = TWO( UG)
      MSK( 8) = TWO( UR)
      MSK( 9) = TWO( UO)
      MSK(10) = TWO( US)
      MSK(11) = TWO( UM)
      MSK(12) = TWO( UX)
      MSK(13) = TWO( UY)
      MSK(14) = TWO(UFR)
      MSK(15) = TWO( UZ)
      MSK(16) = TWO(UAB)
      MSK(17) = TWO( UI)
C
      DO 20 I = 1,17
   20 SBIT(I) = 0
C
C     PASS THROUGH EQEXIN TABLE AND DETERMINE NUMBER OF DOF FOR EACH
C     POINT
C
      JUSET = IUSET - 1
      LINE  = NLPP
      INPNT = 0
      DO 60 K = 1,NEQEX,2
      ITYPE = MOD(Z(IEQEX+K),10)
      NDOF  = 6
      IF (ITYPE .EQ. 2) NDOF = 1
C
C     FOR EACH DOF - GET USET ENTRY AND TEST VARIOUS MACK BITS
C
      DO 50 KK = 1,NDOF
      JUSET = JUSET + 1
      IU    = Z(JUSET)
      INPNT = INPNT + 1
      EXPNT = Z(IEQEX+K-1)
      IDOF  = KK
      IF (NDOF .EQ. 1) IDOF = 0
      DO 30 IBIT = 1,17
      IF (ANDF(MSK(IBIT),IU) .NE. 0) GO TO 25
      UPBIT(IBIT) = BLANK
      GO TO 30
   25 UPBIT(IBIT) = ASTRIC
      SBIT (IBIT) = SBIT(IBIT) + 1
   30 CONTINUE
C
C     PRINT LINE OF OUTPUT
C
      LINE = LINE + 1
      IF (LINE .LE. NLPP) GO TO 40
      CALL PAGE1
      WRITE (NOUT,2000)
      LINE = 1
   40 WRITE (NOUT,2010) INPNT,EXPNT,DASH,IDOF,UPBIT
   50 CONTINUE
   60 CONTINUE
C
C     PRINT COLUMN TOTALS
C
      WRITE (NOUT,2020) SBIT
C
C     SET UP MASKS FOR DISP SET VS. DOF PRINTOUT
C
  100 IF (D33 .EQ. 0) RETURN
      MSK( 1) = TWO( UM)
      MSK( 2) = TWO( US)
      MSK( 3) = TWO( UO)
      MSK( 4) = TWO( UA)
      MSK( 5) = TWO(USG)
      MSK( 6) = TWO(USB)
      MSK( 7) = TWO( UX)
      MSK( 8) = TWO( UY)
      MSK( 9) = TWO(UFR)
C
C     PASS THROUGH EQEXIN TABLE ONCE FOR EACH DISP SET TO BE PRINTED
C
      DO 150 IMK = 1,9
      INUM  = -9
      ICOL  =  0
      LINE  = NLPP
      JUSET = IUSET - 1
      DO 130 K = 1,NEQEX,2
      ITYPE = MOD(Z(IEQEX+K),10)
      NDOF  = 6
      IF (ITYPE .EQ. 2) NDOF = 1
C
C     FOR EACH DOF - TEST IF IT IS IN DESIRED SET FOR THIS PASS
C
      EXPNT = Z(IEQEX+K-1)
      DO 120 KK = 1,NDOF
      JUSET = JUSET + 1
      IF (ANDF(Z(JUSET),MSK(IMK)) .EQ. 0) GO TO 120
      IDOF = KK
      IF (NDOF .EQ. 1) IDOF = 0
      ICOL = ICOL + 1
      ZGRD(ICOL) = EXPNT
      ZDOF(ICOL) = IDOF
      IF (ICOL .LT. 10) GO TO 120
C
C     WE HAVE ACUMULATED 10 POINTS - PRINT THEM
C
      ICOL = 0
      LINE = LINE + 1
      IF (LINE .LE. NLPP) GO TO 110
      CALL PAGE1
      WRITE (NOUT,2030) (TITLE(I,IMK),I=1,3)
      LINE = 1
  110 INUM = INUM + 10
      WRITE (NOUT,2040) INUM,(ZGRD(I),ZDOF(I),I=1,10)
C
  120 CONTINUE
  130 CONTINUE
C
C     PRINT ANY REMAINING ENTRIES
C
      IF (ICOL .EQ. 0) GO TO 150
      LINE = LINE + 1
      IF (LINE .LE. NLPP) GO TO 140
      CALL PAGE1
      WRITE (NOUT,2030) (TITLE(I,IMK),I=1,3)
      LINE = 1
  140 INUM = INUM + 10
      WRITE (NOUT,2040) INUM,(ZGRD(I),ZDOF(I),I=1,ICOL)
C
  150 CONTINUE
C
C     PRINT OUT COMPLETE
C
      RETURN
C
C     ERROR CONDITIONS - PRINT NON-FATAL MESSAGE
C
 1001 N = 1
      GO TO 1100
 1002 N = 2
      GO TO 1100
 1008 WRITE (NOUT,2050) UWM
      RETURN
 1100 CALL MESAGE (N,FILE,NAME)
      RETURN
C
C     FORMAT STATEMENTS
C
 2000 FORMAT (//12X,'INT DOF  EXT GP. DOF   SB   SG    L    A    F   ',
     1       'N    G    R    O    S    M    X    Y   FR    Z   AB    I',
     2       /1X,131(1H-))
 2010 FORMAT (10X,I8,1X,I8,1X,A1,I2,1X,17(4X,A1))
 2020 FORMAT (1H0,31H-- C O L U M N   T O T A L S -- ,17I5)
 2030 FORMAT (45X,3A4,17H DISPLACEMENT SET, //16X,3H-1-,8X,3H-2-,8X,
     1        3H-3-,8X,3H-4-,8X,3H-5-,8X,3H-6-,8X,3H-7-,8X,3H-8-,8X,
     2        3H-9-,7X,4H-10- ,/1H )
 2040 FORMAT (1H ,I6,1H=,10(1X,I8,1H-,I1))
 2050 FORMAT (A25,' 8011, INSUFFICIENT CORE TO HOLD CONTENTS OF EQEXIN',
     1     ' DATA BLOCK', /31X,'HYDROELASTIC USET PRINTOUT TERMINATED.')
      END

      SUBROUTINE XYPRPL
C
      LOGICAL         EXCEED,ANY
      INTEGER         SYSBUF,Z,TITLEC,TITLER,TITLEL,XTITLE,BUFF,IBUF(2),
     1                BLANK,EYE,CURVCH,CLORWD,EOR,SYMBOL(10),
     2                IGRAPH(3,8),XYPLTT
      REAL            GRAPH(3,8),BUF(2),FID(300)
      COMMON /SYSTEM/ SYSBUF, L
      COMMON /OUTPUT/ IHEAD(96)
      COMMON /XYPPPP/ IFRAME,TITLEC(32),TITLEL(14),TITLER(14),
     1                XTITLE(32),ID(300),MAXPLT,XMIN,XINC,EXCEED,I123,
     2                MAXROW
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE     (FID(1),ID(1)),(GRAPH(1,1),IGRAPH(1,1)),
     1                (BUF(1),IBUF(1))
      DATA    SYMBOL/ 1H*,1H0,1HA,1HB,1HC,1HD,1HE,1HF,1HG,1HH /
C
C     GRAPH ARRAY CONTENTS
C
C     COL 1 = LEFT COLUMN USED
C     COL 2 = CENTER COLUMN USED
C     COL 3 = RIGHT COLUMN USED
C     COL 4 = WIDTH OF GRAPH
C     COL 5 = YRATIO
C     COL 6 = YMIN
C     COL 7 = CENTER
C     COL 8 = YMAX
C
      DATA IGRAPH(1,1),IGRAPH(1,2),IGRAPH(1,3),IGRAPH(1,4)/1,60,119,118/
      DATA IGRAPH(2,1),IGRAPH(2,2),IGRAPH(2,3),IGRAPH(2,4)/1,30, 59, 58/
      DATA IGRAPH(3,1),IGRAPH(3,2),IGRAPH(3,3),IGRAPH(3,4)/61,90,119,58/
      DATA BLANK /4H    /, EYE/ 4HI    /
      DATA XYPLTT, MINXD, NOEOR, EOR, INPRWD, CLORWD /201,10,0,1,0,1/
C
C
      ICORE  = KORSZ(Z)
      BUFF   = ICORE - SYSBUF
C
      ICORE  = BUFF - 1
      MAXROW = ICORE/30
      ANY    =.FALSE.
      EXCEED =.FALSE.
      CALL OPEN (*180,XYPLTT,Z(BUFF),INPRWD)
   10 CALL FWDREC (*170,XYPLTT)
C
C     READ ID RECORD
C
   20 CALL READ (*170,*170,XYPLTT,ID(1),300,EOR,NWORDS)
C
C     SKIP RECORD IF PLOT ONLY
C
      IF (ID(289).EQ.0 .OR. ID(289).EQ.1) GO TO 10
C
C     SKIP INITIALIZATION IF AXIS AND SCALES ARE COMPLETE
C
      ICURVE = MOD(ID(3),10)
      IF (ICURVE .EQ. 0) ICURVE = 10
      CURVCH = SYMBOL(ICURVE)
      IF (ID(8) .EQ. 0) GO TO 160
C
C     1 = UPPER,  0 = WHOLE,  -1 = LOWER
C
      IF (ID(7)) 50,30,30
C
C     OUTPUT OUR GRAPH IF THERE IS ONE TO OUTPUT
C
   30 IF (ANY) CALL XYGRAF (IGRAPH)
      ANY = .TRUE.
C
C     INITIALIZE MATRIX TO ALL BLANKS
C
C
C     COMPUTE XRATIO = LINES/UNIT VALUE    FID(MINXD) = MIN-X  INCREMENT
C
C
C     MAX OF 400 LINES PER PLOT
C
      XMIN = FID(15)
      XMAX = FID(17)
      TEMP = AMIN1(400.,FLOAT(MAXROW))
      TEMP = AMIN1(TEMP,3.0*FLOAT(ID(246)))
      XINC = FID(MINXD)
      XINC = AMAX1(XINC,(XMAX-XMIN)/TEMP)
      XRATIO = 1.0/XINC
      MAXPLT = ABS((XMAX-XMIN)/XINC + 1.5)
      MAXPLT = MIN0(MAXPLT,MAXROW)
      N = 30*MAXPLT
      DO 40 I = 1,N
   40 Z(I) = BLANK
   50 CONTINUE
C
C     FILL CURVE TITLE AND HEADING
C     DEMO D10023A INDICATES HEADING WORDS (1-32, AND 36) ARE NUMERIC
C     0 OR 1. REPLACE THEM BY BLANKS.
C     (DON'T KNOW WHO PUTS THOSE 0 & 1 HERE)
C
      DO 60 I = 1,32
      XTITLE(I) = ID(I+178)
   60 TITLEC(I) = ID(I+145)
      DO 70 I = 1,96
      IHEAD(I) = ID(I+50)
      IF (IHEAD(I) .EQ. 0) IHEAD(I) = BLANK
   70 CONTINUE
      IF (IHEAD(36) .EQ. 1) IHEAD(36) = BLANK
      IFRAME = ID(281)
      IF (ID(7)) 100,80,120
   80 I123 = 1
      DO 90 I = 1,14
   90 TITLEL(I) = ID(I+210)
      GO TO 140
  100 I123 = 2
      DO 110 I = 1,14
  110 TITLEL(I) = ID(I+210)
      GO TO 140
  120 I123 = 3
      DO 130 I = 1,14
  130 TITLER(I) = ID(I+210)
C
C     PLOT GRID  (WHOLE LOWER OR UPPER)
C
  140 DO 150 J = 1,3
      DO 150 I = 1,MAXPLT
      CALL XYCHAR (I,IGRAPH(I123,J),EYE)
  150 CONTINUE
C
C     UNITS AND VALUES
C
      YMIN = FID(23)
      YMAX = FID(25)
      DELTA = YMAX - YMIN
      IF (DELTA .EQ. 0.0) DELTA = YMIN
      IF (DELTA .EQ. 0.0) DELTA = 1.0
      YRATIO = FLOAT(IGRAPH(I123,4))/DELTA
      CENTER = YMIN + DELTA/2.0
      GRAPH(I123,5) = YRATIO
      GRAPH(I123,6) = YMIN
      GRAPH(I123,7) = CENTER
      GRAPH(I123,8) = YMAX
C
C     READ DATA AND PLOT POINTS
C
  160 CALL READ (*170,*20,XYPLTT,BUF(1),2,NOEOR,NWORDS)
      IF (IBUF(1) .EQ. 1) GO TO 160
      IROW = (BUF(1) - XMIN)*XRATIO + 1.5
      ICOL = (BUF(2) - YMIN)*YRATIO + 1.5
      ICOL = ICOL + IGRAPH(I123,1) - 1
      CALL XYCHAR (IROW,ICOL,CURVCH)
      GO TO 160
C
C     TERMINIATE  (DUMP GRAPH IF ANY)
C
  170 IF (ANY) CALL XYGRAF (IGRAPH)
      CALL CLOSE (XYPLTT,CLORWD)
  180 RETURN
      END

      SUBROUTINE CHKOPN (NAME)
C
C     CHECKS IF A CALL TO SOFOPN HAS BEEN MADE.
C
      LOGICAL         OPNSOF
      DIMENSION       NAME(2)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /SOFCOM/ SOFDUM(25),OPNSOF
      COMMON /SYSTEM/ NBUFF,NOUT
C
      IF (OPNSOF) GO TO 20
      WRITE  (NOUT,10) UFM,NAME
   10 FORMAT (A23,' 6204, SUBROUTINE ',2A4,' - THE SUBROUTINE SOFOPN ',
     1       'SHOULD BE CALLED PRIOR TO ANY OF THE SOF UTILITY ',
     2       'SUBROUTINES.')
      CALL MESAGE (-61,0,0)
   20 RETURN
      END

      SUBROUTINE KFLUD2
C
C     THIS ROUTINE GENERATES THE PSUEDO STIFFNESS MATRIX TERMS
C     FOR THE CENTER PLUG FLUID ELEMENT
C
C     THE ECPT DATA BLOCK CONTAINS THE FOLLOWING DATA
C
C         FIELD    SYMBOL
C           1        ID
C           2        SIL1
C           3        SIL2
C           4        RHO
C           5        BULK
C           6        N
C           7        CSF
C           8        R1
C           9        Z1
C           10       -
C           11       CSF
C           12       R2
C           13       Z2
C           14       -
C           15       -
C
      LOGICAL          NOGO
      INTEGER          OUT,ELTYPE,NECPT(100)
      DOUBLE PRECISION R1,Z1,R2,Z2,CONSTD,DPI,
     1                 Z1P,Z2P,Z1P1,Z2P1,RK,RI,KFACT,F0,A,B,I2N0,I2N1,
     2                 I2N2,I2NP2,DZ,HPQ,PIRHO,TWOPR,KH,K1,K2
      CHARACTER        UFM*23
      COMMON  /XMSSG / UFM
      COMMON  /CONDAD/ CONSTD(5)
      COMMON  /SYSTEM/ SYSBUF,OUT,NOGO
      COMMON  /EMGDIC/ ELTYPE
      COMMON  /SMA1IO/ DUM1(10),IFKGG
      COMMON  /SMA1CL/ IOPT4,K4GGSW,NPVT
      COMMON  /SMA1DP/ Z1P,Z2P,RK,RI,KFACT,F0,A,B,I2N0,I2N1,I2N2,I2NP2,
     1                 DZ,HPQ(4),PIRHO,TWOPR,KH(4),K1,K2
      COMMON  /SMA1ET/ ECPT(100)
      EQUIVALENCE      (CONSTD(1),DPI),(ECPT(1),NECPT(1))
C
C
      IF (ECPT(13)-ECPT(9)) 5,10,10
    5 R1 = ECPT(12)
      R2 = ECPT(8)
      Z1 = ECPT(13)
      Z2 = ECPT(9)
      I  = NECPT(3)
      NECPT(3) = NECPT(2)
      NECPT(2) = I
      GO TO 15
   10 R1 = ECPT(8)
      Z1 = ECPT(9)
      R2 = ECPT(12)
      Z2 = ECPT(13)
   15 IF (R1.EQ.0.0D0 .OR. R2.EQ.0.0D0) GO TO 5000
      IF (Z1 .EQ. Z2) RETURN
C
C     CALCULATE THE INTEGRAL PARAMETERS I2N0,I2N1,I2N2,AND I2NP2
C
      K  = 2*NECPT(6)
      RK = K
      IF (K .GT. 0) GO TO 20
C
      I2N0 = 0.0
      I2N1 = 0.0
      I2N2 = 0.0
      I2NP2= (Z2-Z1)*(R2**2 + R2*R1 + R1**2)/6.0D0
C
      GO TO 300
C
   20 B    = (R2-R1)/(Z2-Z1)
      DUM  = DABS(B)
      IF (DUM .GT. 1.0E-6) GO TO 30
C
      Z1P  = ((R1+R2)/2.0D0)**K
      I2N0 = (Z1P/RK)*(Z2-Z1)
      I2N1 = I2N0*(Z2+Z1)/2.0D0
      I2N2 = I2N0*(Z2**2+Z2*Z1+Z1**2)/3.0D0
      I2NP2= I2N0*RK/(RK+2.0D0)*R1**2
      GO TO 300
   30 Z1P  = R1**(K+1)
      Z2P  = R2**(K+1)
      Z1P1 = Z1P*R1
      Z2P1 = Z2P*R2
C
      A    = 1.0D0/B
      I2N0 = A/(RK*(RK+1.0D0))*(Z2P-Z1P)
      I2N1 = A/(RK*(RK+1.0D0))*(Z2P*Z2-Z1P*Z1-A/(RK+2.0D0)*(Z2P1-Z1P1))
      I2N2 = A/(RK*(RK+1.0D0))*(Z2P*Z2**2-Z1P*Z1**2 -A/(RK+2.0D0)*2.0D0
     1     * (Z2P1*Z2-Z1P1*Z1-A/(RK+3.0D0)*(Z2P1*R2-Z1P1*R1)))
      I2NP2= A/((RK+2.0D0)*(RK+3.0D0))*(Z2P1*R2-Z1P1*R1)
  300 DZ   = Z2 - Z1
      N    = NECPT(6)
      Z1P  = R1**N
      Z2P  = R2**N
      HPQ(1) = Z2/(DZ*Z1P)
      HPQ(2) =-Z1/(DZ*Z2P)
      HPQ(3) =-1.0D0/(DZ*Z1P)
      HPQ(4) = 1.0D0/(DZ*Z2P)
      LP   = 1
      IF (NPVT .EQ. NECPT(2)) GO TO 320
      IF (NPVT .EQ. NECPT(3)) GO TO 310
      RETURN
C
  310 LP = 2
  320 IF (ECPT(4) .EQ. 0.0) RETURN
      PIRHO  = DPI/DBLE(ECPT(4))
      IF (N .EQ. 0) PIRHO = PIRHO*2.0D0
      RK = N
      TWOPR = 2.0*PIRHO*RK**2
      KH(1) = TWOPR*(I2N0*HPQ(LP)+I2N1*HPQ(LP+2))
      KH(2) = TWOPR*(I2N1*HPQ(LP)+I2N2*HPQ(LP+2)) +PIRHO*I2NP2*HPQ(LP+2)
      K1    = KH(1)*HPQ(1) + KH(2)*HPQ(3)
      K2    = KH(1)*HPQ(2) + KH(2)*HPQ(4)
      IFILE = IFKGG
      I     = NPVT
      J     = NECPT(2)
      CALL SMA1B (K1,J,I,IFILE,0.0D0)
      J     = NECPT(3)
      CALL SMA1B (K2,J,I,IFILE,0.0D0)
      RETURN
C
 5000 N = NECPT(1)
      IF (ELTYPE .EQ. 43) N = N/1000
      WRITE  (OUT,6000) UFM,N
 6000 FORMAT (A23,' 5000, NEGATIVE OR ZERO RADIUS DETECTED FOR ',
     1       'CFLUID2/CAXIF2 ELEMENT ID',I9)
      NOGO = .TRUE.
      RETURN
      END

      SUBROUTINE SDUMX1
C
C     DELETE ANY OF THE FOLLOW ENTRY POINT IF A SUBROUTINE OF THE SAME
C     NAME ALREADY EXISTS
C
      INTEGER         II(9),KK(9)
      CHARACTER       UFM*23,UWM*25
      COMMON /XMSSG / UFM,UWM
      COMMON /SYSTEM/ IBUF,NOUT
      DATA    II    / 9*0/,   JJ /4HSDUM/,     KK /
     1        2H11,2H21,2H31,2H41,2H51,2H61,2H71,2H81,2H91 /
C
      GO TO 30
C
C
      ENTRY SDUM91
C     ============
C
      J = 9
      GO TO 10
C
C
      ENTRY SDUM81
C     ============
C
      J = 8
      GO TO 10
C
C
      ENTRY SDUM71
C     ============
C
      J = 7
      GO TO 10
C
C
      ENTRY SDUM61
C     ============
C
      J = 6
      GO TO 10
C
C
      ENTRY SDUM51
C     ============
C
      J = 5
      GO TO 10
C
C
      ENTRY SDUM41
C     ============
C
      J = 4
      GO TO 10
C
C
      ENTRY SDUM31
C     ============
C
      J = 3
      GO TO 10
C
C
      ENTRY SDUM21
C     ============
C
      J = 2
      GO TO 10
C
C
      ENTRY SDUM11
C     ============
C
      J = 1
C     GO TO 10
C
   10 IF (II(J) .NE. 0) GO TO 30
      II(J)  = 1
      WRITE  (NOUT,20) UWM,JJ,KK(J)
   20 FORMAT (A25,' 2182, SUBROUTINE ',2A4,' IS DUMMY.  ONLY ONE OF ',
     1       'THESE MESSAGES WILL APPEAR PER OVERLAY OF THIS DECK.')
   30 RETURN
      END

      SUBROUTINE SELCAM (CAMERA,PLTNUM,OPT)
C
      REAL    EDGE(2)  ,ORIGIN(2),XYMAX(2) ,SAVE(2,3)
      INTEGER A(17)    ,CAMERA   ,CAMNUM   ,OPT      ,PLOTER   ,PLTNUM
     2,       CON10(2) ,CAM10(3)
C
      COMMON /PLTDAT/  PD(20,2)
C
      EQUIVALENCE (   MODEL,PD( 1,1)) , (  PLOTER,PD( 2,1))
     1,           (XYMAX(1),PD( 7,1)) , ( EDGE(1),PD( 9,1))
     2,           (  CAMNUM,PD(11,1)) ,(ORIGIN(1),PD( 8,2))
      DATA CON10,CAM10 / 1,2, 1,2,3 /
C
       DO 101 I = 1,2
      SAVE(I,1) = EDGE(I)
      EDGE(I) = 0.
      SAVE(I,2) = ORIGIN(I)
      ORIGIN(I) = 0.
      SAVE(I,3) = XYMAX(I)
      XYMAX(I) = 0.
      A(I) = IABS(PLTNUM)
  101 CONTINUE
      CAMNUM = MIN0(MAX0(CAMERA,1),3)
      IF(OPT) 165,160,165
C
C     PLOTTER 1, 2
C
  160 A(3) = A(1)
      A(1) = CON10(1)
      A(2) = 0
      A(4) = SAVE(1,3) + 2.*SAVE(1,1) + .1
      A(5) = SAVE(2,3) + 2.*SAVE(2,1) + .1
      A(6) = 0
      CALL WPLT10 (A,0)
  165 A(1) = CON10(2)
      A(2) = CAM10(CAMNUM)
      DO 166 I = 3,6
      A(I) = 0
  166 CONTINUE
      CALL WPLT10 (A,0)
C
      DO 301 I=1,2
      EDGE(I) = SAVE(I,1)
      ORIGIN(I) = SAVE(I,2)
      XYMAX(I) = SAVE(I,3)
  301 CONTINUE
      RETURN
      END

      SUBROUTINE DUMOD1
C
C
C     DUMMY DECK FOR MODULE DUMMOD1 - SEE USER'S MANUAL SECTION 5.6.
C                                     FOR MODULE PROPERTIES, CHECK
C                                     SUBROUTINE XMPLDD OR USE DIAG 31.
C
C     REVISED 5/91  BY G.CHAN/UNISYS
C     THIS DUMMY MODULE IS IN LINK3 ONLY (SEE XLNKDD). IT CAN BE USED TO
C     FORCE NASTRAN TO DO A LINK SWITCHING AND THEN CONTINUE. e.g.
C     MODULE XXX (NOT IN LINK3) GETS INTO TROUBLE WITH SFM 3018
C     (REQUIREMENTS EXCEED AVAILABLE FILES). USE DMAP ALTER TO CALL THIS
C     DUMOD1 MODLUE A STEP AHEAD OF MODULE XXX. THUS NASTRAN IS FORCED
C     TO DO A LINKSWITCH AND HOUSEKEEPING MODULE XSFA IS CALLED TO CLEAN
C     UP THE FILE ALLOCATION TABLE. THIS MAY SOLVE THE SFM 3018 PROBLEM.
C
C
      INTEGER PARM1,PARM2,PARM3,PARM4,PARM5
C     INTEGER INFILE(1),OUTFIL(2),SCRFIL(3)
C
      COMMON /BLANK / PARM1,PARM2,PARM3,PARM4,PARM5
C     COMMON /ZZZZZZ/ X(1)
C
C     DATA INFILE /101/
C     DATA OUTFIL /201,202/
C     DATA SCRFIL /301,302,303/
C
      RETURN
      END

      SUBROUTINE GUST3 (QHJK,WJ,PP,GUSTL,PDEL,PGUST,Q,NFREQ,NLOAD,
     1                  NROWJ,NCOLW)
C
C     THE PURPOSE OF THIS ROUTINE IS TO MULTIPLY QHJK(+) BY WJ
C     FORMING PDEL
C     PDEL IS THEN MULTIPLIED BY  Q*WG*PP(W)  FORMING PGUST
C
      INTEGER         QHJK,WJ,PP,GUSTL,PDEL,PGUST,IZ(1),SYSBUF,MCB(7),
     1                NAME(2)
      COMMON /PACKX / ITC1,ITC2,II1,JJ1,INCR1
      COMMON /UNPAKX/ ITC,II,JJ,INCR
      COMMON /SYSTEM/ SYSBUF
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE     (IZ(1),Z(1))
      DATA    NAME  / 4HGUST,1H3 /
C
C     INITIALIZE
C
      IBUF1 = KORSZ(IZ)- SYSBUF+1
      IBUF2 = IBUF1- SYSBUF
      IBUF3 = IBUF2- SYSBUF
      INCR1 = 1
      INCR  = 1
      IBUF4 = IBUF3- SYSBUF
      MCB(1)= QHJK
      CALL RDTRL(MCB)
      ITC  = 3
      ITC1 = ITC
      ITC2 = ITC
      CALL GOPEN (WJ,IZ(IBUF1),0)
      CALL GOPEN (QHJK,IZ(IBUF2),0)
      CALL GOPEN (PDEL,IZ(IBUF3),1)
C
C     SET UP TO PACK
C
      IT1 = 1
      JJ1 = MCB(3) / NROWJ
      NRQHJ = MCB(3)
      NTQHJ = NRQHJ*2
      CALL MAKMCB (MCB,PDEL,JJ1,2,ITC2)
      II   = 1
      IQHJ = 2*NFREQ+1
      IWJ  = IQHJ+NTQHJ
      NTWZ = NROWJ*2
      IPDEL= IWJ + NTWZ
      NTPDEL = JJ1*2
      NZ = IBUF4-1 - IPDEL + 2*JJ1
      IF (NZ  .LT. 0) CALL MESAGE (-8,0,NAME)
      DO 100 I = 1,NFREQ
      JJ = NRQHJ
      CALL UNPACK (*10,QHJK,Z(IQHJ))
C
C     MULTIPY EACH IMAGINARY PART BY K
C
      DO 5 J = 1,NTQHJ,2
      Z(IQHJ+J) = Z(IQHJ+J)*Z(2*I)
   5  CONTINUE
      GO TO 20
C
C     NULL COLUMN
C
   10 CALL ZEROC (Z(IQHJ),NTQHJ)
   20 CONTINUE
C
C     BRING WJ COLUMN INTO CORE
C
      JJ = NROWJ
      CALL UNPACK (*30,WJ,Z(IWJ))
      GO TO 40
   30 CALL ZEROC (Z(IWJ),NTWZ)
   40 CONTINUE
C
C     MULTIPLY
C
      CALL GMMATC (Z(IQHJ),JJ1,NROWJ,0,Z(IWJ),NROWJ,1,0,Z(IPDEL))
      CALL PACK (Z(IPDEL),PDEL,MCB)
  100 CONTINUE
      CALL CLOSE (WJ,1)
      CALL CLOSE (QHJK,1)
      CALL CLOSE (PDEL,1)
      CALL WRTTRL (MCB)
      CALL DMPFIL (-PDEL,Z,NZ)
C
C     REPEATEDLY READ PDEL MULTIPLYING BY Q,WG, AND PP
C
      CALL GOPEN (PDEL,IZ(IBUF1),0)
      CALL GOPEN (PP,IZ(IBUF2),0)
      CALL GOPEN (GUSTL,IZ(IBUF3),0)
      CALL GOPEN (PGUST,IZ(IBUF4),1)
      CALL MAKMCB (MCB,PGUST,MCB(3),MCB(4),MCB(5))
      DO 400 I = 1,NLOAD
      CALL REWIND (PDEL)
      CALL SKPREC (PDEL,1)
      CALL FREAD (GUSTL,IZ,5,1)
      IZ2 = 2
      QWG = Q*Z(IZ2+1)
      DO 300 J = 1,NFREQ
      JJ = 1
      CALL UNPACK (*310,PP,Z)
      QWGR = QWG * Z(1)
      QWGC = QWG * Z(IZ2)
      GO TO 320
  310 CONTINUE
      QWGR = 0.0
      QWGC = 0.0
  320 CONTINUE
      JJ = JJ1
      CALL UNPACK (*330,PDEL,Z)
      GO TO 340
  330 CALL ZEROC (Z,NTPDEL)
  340 CONTINUE
      DO 350 M = 1,NTPDEL,2
      PGR = QWGR*Z(M  ) - QWGC*Z(M+1)
      PGC = QWGR*Z(M+1) + QWGC*Z(M  )
      Z(M  ) = PGR
      Z(M+1) = PGC
  350 CONTINUE
      CALL PACK (Z,PGUST,MCB)
  300 CONTINUE
  400 CONTINUE
      CALL CLOSE (PDEL,1)
      CALL CLOSE (PP,1)
      CALL CLOSE (GUSTL,1)
      CALL CLOSE (PGUST,1)
      CALL WRTTRL (MCB)
      RETURN
      END

      SUBROUTINE DBMALB ( LENREQ, INDEX )
C********************************************************************
C     DBMALB - ALLOCATES A MEMORY BLOCK OF LENGTH "LENREQ"
C              FROM THE FREE CHAIN AND RETURNS THE
C              POINTER IN MEMORY FOR THE BLOCK IN "INDEX" (RELATIVE TO.
C              /DBM/.
C
C     EACH FREE BLOCK IN MEMORY HAS THE FOLLOWING FORMAT:
C         WORD 1  POINTER TO PREVIOUS FREE BLOCK (=0, IF FIRST)
C         WORD 2  POINTER TO NEXT FREE BLOCK (=0, IF END OF CHAIN)
C         WORD 3  NUMBER OF WORDS AVAILABLE IN THIS FREE BLOCK
C
C     NOTE:  IDBFRE POINTS TO THE FIRST FREE BLOCK OF THE CHAIN
C********************************************************************
      INCLUDE 'DSIOF.COM'
      INCLUDE 'ZZZZZZ.COM'
      NEXT  = IDBFRE
      IF ( IDBFRE .EQ. 0 ) GO TO 701
C  OBTAIN THE LENGTH OF THE FREE BLOCK
10    LENAVL = MEM( NEXT + 2 )
      IF ( LENAVL .GE. LENREQ ) GO TO 100
C  MEMORY NOT AVAILABLE IN THIS BLOCK, CHECK FOR OTHER BLOCKS
      NEXT  = MEM( NEXT + 1 )
C  IF NO MORE FREE BLOCKS, RETURN WITH INDEX SET TO -1
      IF ( NEXT .EQ. 0 ) GO TO 701
      GO TO 10
C  RETURN POINTER FOR THIS BLOCK
100   INDEX = NEXT
      IF ( LENREQ .NE. LENAVL ) GO TO 200
C  COME HERE WHEN REQUESTED BLOCK SAME SIZE AS FREE BLOCK
      NEXT  = MEM( NEXT+1 )
      IPREV = MEM(INDEX   )
      IF ( IPREV .EQ. 0 ) GO TO 110
      IF ( NEXT  .EQ. 0 ) GO TO 120
C  CONNECT THE PREVIOUS FREE BLOCK WITH THE NEXT FREE BLOCK
      MEM( IPREV+1 ) = NEXT
      MEM( NEXT    ) = IPREV
      GO TO 700
110   IF ( NEXT .EQ. 0 ) GO TO 130
C  NO PREVIOUS BLOCK, SET IDBFRE TO POINT TO NEW FIRST FREE BLOCK
      IDBFRE = NEXT
      MEM( NEXT ) = 0
      GO TO 700
C  PREVIOUS BLOCK EXITS BUT BLOCK ALLOCATED WAS LAST IN CHAIN
120   MEM( IPREV+1 ) = 0
      GO TO 700
C  NO MORE FREE BLOCKS EXIST, SET IDBFRE TO ZERO
130   IDBFRE = 0
      GO TO 700
C  COME HERE WHEN FREE BLOCK HAS MORE SPACE THEN REQUESTED
200   NEWIND = INDEX + LENREQ + 4
      IPREV  = MEM( INDEX  )
      NEXT   = MEM( INDEX+1)
C  CHECK TO DETERMINE IF ANY SPACE REMAINS
      IF ( ( LENAVL-LENREQ-4 ) .LE. 0 ) GO TO 240
C  RECOMPUTE FREE SPACE AND SET UP CHAIN WORDS
      MEM( NEWIND+2 ) = LENAVL - LENREQ - 4
      IF ( IPREV .EQ. 0 ) GO TO 210
      IF ( NEXT  .EQ. 0 ) GO TO 220
C  CONNECT TO PREVIOUS AND NEXT FREE BLOCK
      MEM( NEWIND  ) = IPREV
      MEM( NEWIND+1) = NEXT
      MEM( IPREV+1 ) = NEWIND
      MEM( NEXT    ) = NEWIND
      GO TO 700
210   IF ( NEXT .EQ. 0 ) GO TO 230
C  NO PREVIOUS BLOCK, NEWLY CREATED BLOCK BECOMES THE FIRST FREE BLOCK
      IDBFRE         = NEWIND
      MEM( NEWIND  ) = 0
      MEM( NEWIND+1) = NEXT
      MEM( NEXT    ) = NEWIND
      GO TO 700
C  PREVIOUS BLOCK EXISTS BUT THE NEWLY CREATED BLOCK IS LAST
220   MEM( IPREV+1 ) = NEWIND
      MEM( NEWIND  ) = IPREV
      MEM( NEWIND+1) = 0
      GO TO 700
C  NEW BLOCK IS THE ONLY FREE BLOCK
230   IDBFRE  = NEWIND
      MEM( NEWIND  ) = 0
      MEM( NEWIND+1) = 0
      GO TO 700
C  FREE CHAIN IS EXHAUSTED
240   IDBFRE = 0
701   INDEX = -1
      RETURN
700   CONTINUE
      RETURN
      END

      SUBROUTINE SUBB(KB,KS,I,J,JB,LB,LS,NDY,NYFL,PI,EPS,SGR,CGR,
     *   AR,BETA,SUM,RIA,DELX,YB,ZB,YS,ZS,X)
C   ***   COMPUTES ELEMENTS OF THE SUBMATRICES  DZP, DZZ, DZY, DYP,
C         DYZ  AND  DYY  USING  SUBROUTINE  DZY
      REAL       KD1R,KD1I, KD2R,KD2I
      COMPLEX    DPUR,DPUL,DPLR,DPLL,DP,SUM
      DIMENSION RIA(1),DELX(1),YB(1),ZB(1),YS(1),ZS(1),X(1)
      COMMON /AMGMN/ MCB(7),NROW,ND,NE,REFC,FMACH,KR
      COMMON     /KDS/ IND,KD1R,KD1I,KD2R,KD2I
      FLND = FLOAT(ND)
      FLNE = FLOAT(NE)
      IND  = 0
      DPUR = (0.0,0.0)
      DPUL = (0.0,0.0)
      DPLR = (0.0,0.0)
      DPLL = (0.0,0.0)
      ANOT = RIA(JB)
      DXS  = DELX(J)
      ABSYB= ABS(YB(LB))
      ABSZB= ABS(ZB(LB))
      IFLAG = 0
      IDFLAG = 0
      IF (KB.EQ.0)  GO TO  20
      TEST1= ABS(YB(LB) -YB(KB))
      TEST2= ABS(ZB(LB) -ZB(KB))
      IF  (TEST1.GT.EPS. OR .TEST2.GT.EPS)  GO TO  20
      IFLAG = 1
      IF(NDY .NE. NYFL) GO TO 20
      IF( I .NE. J ) GO TO 20
      IDFLAG = 1
      D2D  =       1.0 /(2.0*PI*ANOT*ANOT*(1.0+AR))
      IF    (NDY.NE.0)  D2D=D2D/AR
      SUM  = CMPLX(D2D,0.0)
      SIGN1 = 1.0
      IF(NDY.NE.0) SIGN1 = -1.0
      IF(ABSYB.LT.EPS) SUM=(1.0+SIGN1*FLND)*SUM
      IF(ABSZB.LT.EPS) SUM=(1.0+SIGN1*FLNE)*SUM
      DPUR = SUM
   20 CONTINUE
      XX   = X(I)
      Y    = YS(KS)
      Z    = ZS(KS)
      XI1  = X(J) - 0.5*DXS
      XI2  = X(J) + 0.5*DXS
      ETA  = YS(LS)
      ZETA = ZS(LS)
      AO   = ANOT
      IDZDY= NDY
      IGO  = 1
      LHS = 0
      IF(IFLAG .EQ. 1) GO TO 45
   30 CONTINUE
      CALL        DZY  (XX, Y, Z, SGR, CGR, XI1, XI2, ETA, ZETA, AR, AO,
     1  KR, REFC, BETA, FMACH, LHS,
     2         IDZDY ,   DZDYR ,   DZDYI )
      DP   = CMPLX(DZDYR,DZDYI)
      GO TO  (40,50,70,80),  IGO
   40 CONTINUE
C  UPPER RIGHT-HAND SIDE CONTRIBUTION
      DPUR = DP
      IF (KB.EQ.LB)  GO TO 100
   45 CONTINUE
      IF (ND.EQ.0) GO TO 60
      IF (IDFLAG.EQ.1.AND.ABSYB.LT.EPS) GO TO 60
      IGO  = 2
      ETA  = -YS(LS)
      LHS = 1
      GO TO  30
   50 CONTINUE
C  UPPER LEFT-HAND SIDE CONTRIBUTION
      DPUL = DP
   60 CONTINUE
      IF (NE.EQ.0) GO TO 90
      IF(IDFLAG.EQ.1.AND.ABSZB.LT.EPS) GO TO 90
      IGO  = 3
      ETA  =  YS(LS)
      ZETA = -ZS(LS)
      LHS = 1
      GO TO  30
   70 CONTINUE
C  LOWER RIGHT-HAND SIDE CONTRIBUTION
      DPLR = DP
      IF (ND.EQ.0) GO TO 90
      IF(IDFLAG.EQ.1.AND.ABSYB.LT.EPS) GO TO 90
      IGO  = 4
      ETA  = -YS(LS)
      ZETA = -ZS(LS)
      LHS = 0
      GO TO  30
   80 CONTINUE
C  LOWER  LEFT-HAND SIDE CONTRIBUTION
      DPLL = DP
   90 CONTINUE
      SUM  = DPUR + FLND*DPUL + FLNE*DPLR + FLND*FLNE*DPLL
  100 CONTINUE
      RETURN
      END

      SUBROUTINE DBASE
C
C     DRIVER FOR DATABASE MODULE
C
C     THIS UTILITY MODULE TRANSFERS GRID POINT DATA, CONNECTING ELEMENT
C     DATA, AND MOST OF THE OFP DATA BLOCKS (DISPLACEMENT, VELOCITY,
C     ACCELERTION, LOAD, GRID POINT FORCE, EIGENVECTOR, ELEMENT STRESS
C     AND ELEMENT FORCE) TO A FORTRAN FILE, FORMATTED OR UNFORMATTED.
C     THE GRID POINT DATA ARE IN BASIC COORDINATE SYSTEM, AND THE
C     DISPLACEMENT DATA IF REQUESTED, CAN BE IN BASIC SYSTEM (DEFAULT)
C     OR IN GLOBAL COORDINATE SYSTEM. GRID POINTS ARE IN EXTERNAL GRID
C     NUMBERING SYSTEM.
C     THE FORMATTED OUTTP FILE CAN BE PRINTED, OR EDITTED BY SYSTEM
C     EDITOR. ALL OUTPUT LINES ARE 132 COLUMNS OR LESS.
C
C
C     WRITTEN ON THE LAST DAY OF 1988 BY G.CHAN/UNISYS.
C     REVISED 10/89, EXPANDED TO INCLUDE THREE OFP FILES
C
C     DATABASE  EQEXIN,BGPDT,GEOM2,CSTM,O1,O2,O3//C,N,OUTTP/C,N,FORMAT
C                                                /C,N,BASIC   $
C
C               EQEXIN - MUST BE PRESENT
C               BGPDT  - IF PURGE, NO GRID POINT DATA SENT TO OUTTP
C               GEOM2  - IF PURGE, NO ELEMENT CONNECTIVITY DATA SENT TO
C                        OUTTP
C               CSTM   - IF PURGE, DISPLACEMENT VECTOR IN GLOBAL COORD.
C               Oi     - ANY ONE OF NASTRAN STANDARD OFP FILES LISTED
C                        BELOW. IF PURGE, NO DATA SENT TO OUTTP.
C                        IF THE DATA IN THIS OFP FILE IS COORDINATE
C                        SENSITIVE, SUCH AS DISPLACEMENT, THE DATA CAN
C                        BE SENT OUT TO OUTTP IN BASIC OR GLOBAL
C                        COORDINATES AS SPECIFIED THE PARAMETER BASIC.
C               OUTTP  - MUST BE ONE OF THE UT1,UT2,INPT,INP1,...,9 FILE
C               FORMAT = 0, UNFORMATTED OUTPUT TO OUTTP FILE (DEFAULT)
C                      = 1, FORMATTED
C               BASIC  = 0, DISPLACEMENT VECTORS REMAIN IN GLOBAL COORD.
C                           SYSTEM (DEFAULT)
C                      = 1, DISPLACEMENT VECTORS IN BASIC COORD. SYSTEM
C                           (NOT USED IN ELEMENT FORCES AND STRESSES)
C
C     LIST OF AVAILABLE OFP FILES (Oi)
C          OUDV1,  OUDVC1, OUGV1,  OUHV1,  OUHVC1, OUPV1,  OUPVC1,
C          OUDV2,  OUDVC2, OUGV2,  OUHV2,  OUHVC2, OUPV2,  OUPVC2,
C          OUBGV1, OPHID,  OPHIG,  OPHIH,  OCPHIP,
C          OPG1,   OPP1,   OPPC1,  OQG1,   OQP1,   OQPC1,  OQBG1,
C          OPG2,   OPP2,   OPPC2,  OQG2,   OQP2,   OQPC2,  OQBG2,
C          OEF1,   OEFC1,  OES1,   OESC1,  OEFB1,  OBEF1,
C          OEF2,   OEFC2,  OES2,   OESC2,  OESB1,  OBES1
C          OES1A,
C          HOUDV1, HOUGV1, HOPG1,  HOQG1,  HOEF1,  HOES1,  HOPNL1,
C          HOUDV2, HOUGV2, HOPP2,  HOQP2,  HOEF2,  HOEFIX, HOPNL2
C
C
C     MAP THIS ROUTINE IN LINK2, LINK4 AND LINK14
C
      IMPLICIT INTEGER (A-Z)
      LOGICAL          FMTTD,BASC,NOCSTM,NOBGPT,NOGEOM,DEBUG,EFS,ECXYZ
      INTEGER          SUB(2),B(5),NAM(8),A(10),FMT(4),ONAME(6),SUBN(3),
     1                 A1(80),F(79),F8(6),INPX(3),IX(1),FSTF(4),INP(8)
      REAL             RX(200),RZ(1),RA(1),T(9),FREQ
      CHARACTER*8      CA,MO,CAMO,BA,GL,BAGL,GPT,ELM,DIS,LOD,FORC,VELO,
     1                 ACC,EIGN,STR,ELF,DXX,DYY(3),DASH,BLK8
      CHARACTER        UFM*23,UWM*25,UIM*29
      COMMON /XMSSG /  UFM,UWM,UIM
      COMMON /SYSTEM/  SYSBUF,NOUT,NOGO
      COMMON /ZZZZZZ/  Z(1)
      COMMON /BLANK /  OUTTP,FORMTD,BASIC
      COMMON /GPTA1 /  NEL,LAST,INCR,E(1)
      COMMON /MACHIN/  MACH
      COMMON /NAMES /  RD,RDREW,WRT,WRTREW,REW,NOREW,EOFNRW
      EQUIVALENCE      (Z(1),RZ(1)),       (B(1),NAM(1)),
     1                 (A(1),RA(1),A1(3)), (RX(1),IX(1))
      DATA    EQEXIN,  BGPDT, GEOM2,  CSTM,  SCR1,  SUB              /
     1        101,     102,   103,    104,   301,   4HDBAS,4HE       /
      DATA    END1,    END2,  END3,   FMT                            /
     1        4H -EN,  2HD-,  2H--,   4H, UN,4HFORM,4HATTE,1HD       /
      DATA    FMT1,    MONE,  BLANK,  BZERO, IZERO,        DEBUG     /
     1        1H,,     -1,    4H    , 4H 0.0,4H-0  ,       .FALSE.   /
      DATA    LS,      INPX,                 LIMAF,        LIMRX     /
     1        1HS,     4H INP,4HINPT, 4H  UT,    78,       200       /
      DATA    GPT,            ELM,           DIS,          DASH      /
     1        'GRID PTS',     'ELEMENTS',    'DISPLCNT',  '--------' /
      DATA    LOD,            FORC,          VELO,         BLK8      /
     1        'LOADINGS',     'GD FORCE',    'VELOCITY',  '        ' /
      DATA    ACC,            EIGN,          STR,          ELF       /
     1        'ACCELERN',     'EIGENVCR',    'E.STRESS',  'E.FORCES' /
      DATA    CA,             MO,            BA,           GL        /
     1        ' CASE = ',     ' MODE = ',    '  BASIC ',  ' GLOBAL ' /
      DATA    FSTF / 4H1ST , 4H2ND ,4H3RD ,  4H4TH /   ,   INP       /
     1        4HEQEX,2HIN  , 4HBGPD,2HT  ,   4HGEOM,4H2   ,4HCSTM,1H /
C
C
      IF (DEBUG) WRITE (NOUT,10)
   10 FORMAT (/5X,'-- DBASE LOCAL DEBUG --')
      NAM(1) = 106
      CALL RDTRL (NAM(1))
      IF (NAM(1) .GT. 0) GO TO 20
      CALL PAGE
      WRITE  (NOUT,15) UIM
   15 FORMAT (A29,', DATABASE NEW DMAP FORMAT', //5X,
     1       'DATABASE   EQEXIN,BGPDT,GEOM2,CSTM,O1,O2,O3//C,N,OUTTP/',
     2       'C,N,FORMAT/C,N,BASIC  $', /5X,'FIRST 4 FILES ARE FIXED ',
     3       'IN NAMES AND ORDER, NEXT 3 FILES CAN BE SELECTED BY USER',
     4       /5X,'FIRST EQEXIN FILE MUST BE PRESENT, OTHERS CAN BE ',
     5       'SELECTIVELY OMITTED')
   20 IF (OUTTP.GE.11 .AND. OUTTP.LE.24) GO TO 30
      WRITE  (NOUT,25) UFM,OUTTP
   25 FORMAT (A23,', OUTPUT FILE SPEC. ERROR')
      CALL MESAGE (-37,0,SUB)
   30 EFS   = .FALSE.
      FMTTD = .FALSE.
      BASC  = .FALSE.
      ECXYZ = .FALSE.
      IF (FORMTD .EQ. 1) FMTTD = .TRUE.
      IF (BASIC  .EQ. 1) BASC  = .TRUE.
      IF (FMTTD) FMT(1) = FMT1
      CALL FNAME (101,NAM(1))
      IF (NAM(1).EQ.INP(1) .AND. NAM(2).EQ.INP(2)) GO TO 34
      CALL PAGE2 (3)
      WRITE  (NOUT,32) FSTF(1),NAM(1),NAM(2)
   32 FORMAT (//,' *** USER FATAL ERROR IN DATABASE MODULE, THE ',A4,
     1  'INPUT DATA BLOCK ',2A4,' IS ILLEGAL.', /5X,'THE FIRST 4 INPUT',
     2  ' DATA BLOCKS MUST BE ''EQEXIN,BGPDT,GEOM2,CSTM'', AND IN ',
     3  'EXACT ORDER SHOWN')
      NOGO   = 1
   34 NOBGPT = .FALSE.
      NOGEOM = .FALSE.
      NOCSTM = .FALSE.
      NAM(1) = BGPDT
      CALL RDTRL (NAM)
      IF (NAM(1) .LE. 0) NOBGPT = .TRUE.
      IF (NOBGPT) GO TO 35
      CALL FNAME (102,NAM(1))
      IF (NAM(1).EQ.INP(3) .AND. NAM(2).EQ.INP(4)) GO TO 35
      CALL PAGE2 (3)
      WRITE (NOUT,32) FSTF(2),NAM(1),NAM(2)
      NOGO = 1
   35 NAM(1) = GEOM2
      CALL RDTRL (NAM)
      IF (NAM(1) .LE. 0) NOGEOM = .TRUE.
      IF (NOGEOM) GO TO 36
      CALL FNAME (103,NAM(1))
      IF (NAM(1).EQ.INP(5) .AND. NAM(2).EQ.INP(6)) GO TO 36
      CALL PAGE2 (3)
      WRITE (NOUT,32) FSTF(3),NAM(1),NAM(2)
      NOGO = 1
   36 NAM(1) = CSTM
      CALL RDTRL (NAM)
      IF (NAM(1) .LE. 0) NOCSTM = .TRUE.
      IF (NOCSTM) GO TO 37
      CALL FNAME (104,NAM(1))
      IF (NAM(1).EQ.INP(7) .AND. NAM(2).EQ.INP(8)) GO TO 37
      CALL PAGE2 (3)
      WRITE (NOUT,32) FSTF(4),NAM(1),NAM(2)
      NOGO = 1
   37 IF (NOGO .EQ. 1) RETURN
C
      NZ    = KORSZ(Z(1))
      BUF1  = NZ   - SYSBUF
      BUF2  = BUF1 - SYSBUF
      NZ    = BUF2 - 1
      COOR  = 0
C
C     OPEN EQEXIN, READ FIRST RECORD, AND SORT EX-INT TABLE BY INTERNAL
C     NUMBERS, Z(1) THRU Z(NEQ)
C
      FILE = EQEXIN
      CALL OPEN   (*1300,EQEXIN,Z(BUF1),RDREW)
      CALL FWDREC (*1300,EQEXIN)
      CALL READ   (*1300,*60,EQEXIN,Z(1),NZ,1,NEQ)
      J = 0
   40 CALL READ (*1300,*50,EQEXIN,Z(1),NZ,1,NEQ)
      J = J + NZ
      GO TO 40
   50 J = J + NEQ
      J = J*2
      CALL MESAGE (-8,J,SUB)
C
   60 CALL CLOSE (EQEXIN,REW)
      LEFT = NZ - NEQ - 1
      NEQ2 = NEQ/2
      J = NEQ2*5 - LEFT
      IF (J .GT. 0) CALL MESAGE (-8,J,SUB)
      CALL SORT (0,0,2,2,Z(1),NEQ)
C
C     IF BGPDT FILE NOT REQUESTED, SKIP PROCESSING GRID POINT DATA
C
      IF (NOBGPT) GO TO 170
C
C
C     GRID POINTS PROCESSING
C     ======================
C
C     OPEN BGPDT, READ THE ENTIRE RECORD, AND REPLACE THE COORD.SYSTEM
C     WORD BY THE EXTERNAL GRID POINT NUMBER.
C     NOTE - EXT.GRID IDS ARE NO LONGER SORTED.
C     WRITE THE NEW DATA TO SCR1 FILE - EXT.GIRD ID, X,Y,Z BASIC COORD.
C
      FILE = SCR1
      CALL OPEN (*1300,SCR1,Z(BUF1),WRTREW)
      FILE  = BGPDT
      CALL OPEN (*170,BGPDT,Z(BUF2),RDREW)
      CALL FWDREC (*1300,BGPDT)
      NGD   = 0
  100 CALL READ (*110,*110,BGPDT,B(2),4,0,FLAG)
      NGD  = NGD + 1
      K    = NGD*2 - 1
      B(1) = Z(K)
      B(2) = 0
      CALL WRITE (SCR1,B,5,0)
      GO TO 100
  110 CALL WRITE (SCR1,0,0,1)
      CALL CLOSE (SCR1 ,REW)
      CALL CLOSE (BGPDT,REW)
C
C     OPEN SCR1 AND OUTTP
C     SORT THE GRID POINT DATA BY THEIR EXTERNAL NUMBERS
C
C     FOR UNFORMATTED TPAE, TRANSFER GRID DATA FROM SCR1 TO OUTTP IN ONE
C     LONG RECORD
C
C          WORD         CONTENT (UNFORMATTED, 2ND RECORD)
C        ------    ----------------------------------------------------
C             1     NO. OF WORDS (THIS FIRST WORD NOT INCLUDED) IN THIS
C                   RECORD (INTEGER)
C             2     EXTERNAL GRID ID (SORTED)
C             3     0 (NOT USED, RESERVED FOR FUTURE USE. INTEGER)
C         4,5,6     X,Y,Z COORDINATES IN BASIC COORD SYSTEM (REAL)
C             :     REPEAT 2 THRU 6 AS MANY TIMES AS THERE ARE GRIDS.
C
      FILE = SCR1
      JB   = NEQ+ 1
      JBP1 = JB + 1
      JBM1 = JB - 1
      K    = NGD*5
      CALL OPEN (*1300,SCR1,Z(BUF1),RDREW)
      CALL READ (*1300,*1310,SCR1,Z(JBP1),K,1,FLAG)
      CALL CLOSE (SCR1,REW)
      CALL SORT (0,0,5,1,Z(JBP1),K)
C
C     FIRST GRID POINT IDENTIFICATION RECORD TO OUTTP
C
      IF (.NOT.FMTTD) WRITE (OUTTP    ) GPT,DASH
      IF (     FMTTD) WRITE (OUTTP,120) GPT,DASH
  120 FORMAT (1X,2A8)
C
      IF (FMTTD) GO TO 130
      Z(JB) = K
      JE    = K + JB
      WRITE (OUTTP) (Z(J),J=JB,JE)
      GO TO 170
C
C     FOR FORMATTED TAPE
C
C       RECORD   WORD     CONTENT                               FORMAT
C       ------   ----    ----------------------------------------------
C           2      1      TOTAL NUMBER OF GRID POINTS             I8
C           3      1      EXTERNAL GRID ID (NOT SORTED)           I8
C                  2      0 (NOT USED, RESERVED FOR FUTURE USE)   I8
C                3,4,5    X,Y,Z COORDINATES IN BASIC SYSTEM  3(1P,E12.5)
C           :     1-5     REPEAT RECORD 3 AS MANY TIMES AS THERE
C                         ARE GRIDS
C
  130 WRITE  (OUTTP,140) NGD
  140 FORMAT (1X,I8,'= TOTAL NUMBER OF GRID POINTS')
      K = JB
      DO 160 I = 1,NGD
      WRITE  (OUTTP,150) Z(K+1),Z(K+2),RZ(K+3),RZ(K+4),RZ(K+5)
  150 FORMAT (1X,2I8,3(1P,E12.5))
  160 K = K + 5
C
C     IF GEOM2 IS NOT REQUESTED, SKIP PROCESSING ELEMENT DATA
C
  170 IF (NOGEOM) GO TO 490
C
C
C     ELEMENT CONNECTIVITY PROCESSING
C     ===============================
C
C     OPEN GEOM2 AND SCR1. TRANSFER ELEMENT DATA TO SCR1 FILE
C
      FILE = GEOM2
      CALL OPEN (*490,GEOM2,Z(BUF2),RDREW)
      CALL FWDREC (*1300,GEOM2)
C
C     FIRST ELEMENT IDENTIFICATION RECORD TO OUTTUP
C
      IF (.NOT.FMTTD) WRITE (OUTTP    ) ELM,DASH
      IF (     FMTTD) WRITE (OUTTP,120) ELM,DASH
C
  200 CALL READ (*420,*420,GEOM2,B,3,0,FLAG)
      IF (B(1).EQ.B(2) .AND. B(2).EQ.B(3)) GO TO 420
      DO 210 I = 4,LAST,INCR
      IF (B(1) .EQ. E(I)) GO TO 220
  210 CONTINUE
      CALL MESAGE (-61,0,0)
  220 NAM(1) = E(I-3)
      NAM(2) = E(I-2)
      ELTYP  = E(I-1)
      NWDS   = E(I+2)
      PID    = E(I+3)
      SYMBOL = E(I+12)
      NG     = E(I+6)
      G1     = E(I+9) - 1
      NG3    = NG +3
      NE     = 0
      MID    = 0
C               TETRA,WEDGE,HEXA1,HEXA2            FHEX1          FHEX2
      IF (ELTYP.GE.39 .AND. ELTYP.LE.42 .OR. ELTYP.EQ.76.OR.ELTYP.EQ.77)
     1   MID = 2
      NAM(3) = ELTYP
      NAM(4) = SYMBOL
      NAM(5) = NG
      NAM(6) = NE
      NAM(7) = NG3
      NAM(8) = 1
      IF (NG .GT. 13) NAM(8) = 2
      IF (NG .GT. 28) NAM(8) = 3
C
C     FOR UNFORMATTED TAPE -
C
C     ELEMENT HEADER RECORD WRITTEN TO SCR1
C
C        WORD        CONTENT  (UNFORMATTED)
C        ----    ----------------------------------------------------
C         1-2     ELEMENT BCD NAME
C           3     ELEMENT TYPE NUMBER, ACCORDING TO GPTABD ORDER
C           4     ELEMENT SYMBOL (2 LETTERS)
C           5     NG= NUMBER OF GRID POINTS
C           6     NE= TOTAL NO. OF ELEMENTS OF THIS CURRENT ELEMENT TYPE
C           7     NO. OF WORDS IN NEXT RECORD PER ELEMENT = NG+2
C           8     NO. OF 132-COLUMN LINES NEEDED IN NEXT RECORD IF OUTTP
C                 IS WRITTED WITH A FORMAT
C
      FILE  = SCR1
      CALL OPEN (*1300,SCR1,Z(BUF1),WRTREW)
      CALL WRITE (SCR1,NAM,8,0)
      FILE  = GEOM2
  230 CALL READ (*490,*250,GEOM2,A,NWDS,0,FLAG)
      A1(1) = A(1)
      A1(2) = A(2)
      A1(3) = 0
      IF (PID .EQ. 0) A1(2) = 0
      IF (MID .EQ. 2) A1(2) =-A(2)
      DO 240 J = 1,NG
  240 A1(J+3) = A(G1+J)
      CALL WRITE (SCR1,A1,NG3,0)
      NE = NE + 1
      GO TO 230
  250 CALL WRITE (SCR1,0,0,1)
      CALL CLOSE (SCR1,REW)
      FILE = SCR1
      CALL OPEN (*1300,SCR1,Z(BUF1),RDREW)
      CALL READ (*1300,*290,SCR1,Z(JB),LEFT,1,NWDS)
      CALL BCKREC (SCR1)
      IF (.NOT.FMTTD) GO TO 370
      J = 0
      CALL READ (*1300,*270,SCR1,Z(JB),LEFT,0,FLAG)
  270 CALL READ (*1300,*280,SCR1,Z(JB),LEFT,0,FLAG)
      J = J + LEFT
      GO TO 270
  280 J = J + FLAG
      CALL MESAGE (-8,J,SUB)
  290 CALL CLOSE (SCR1,REW)
      Z(JB+5) = NE
      IF (FMTTD) GO TO 300
      K = JB + 7
      WRITE (OUTTP) (Z(J),J=JB,K)
      I = K + 1
      K = NWDS + JB - 1
      WRITE (OUTTP) (Z(J),J=I,K)
      GO TO 200
C
C     ELEMENT RECORD TO SCR1
C
C       WORD      CONTENT, ALL INTEGERS  (UNFORMATTED)
C       ----    ------------------------------------------------
C         1      ELEMENT ID
C         2      POSITIVE INTEGER  = PROPERTY ID
C                ZERO IF ELEM HAS NO PROPERTY ID
C                NEGATIVE INTEGER  = MATERIAL ID (ELEMENT HAS NO
C                  PROPERTY ID, BUT IT HAS A MATERIAL ID)
C         3      0 (NOT USED. RESERVED FOR FUTURE USE)
C       4,5,...  ELEMENT CONNECTING GRID POINTS
C         :      REPEAT 1,2,3,4,... AS MANY TIMES AS THERE ARE ELEMENTS
C                  OF THIS SAME TYPE
C
C
C
C     FOR FORMATTED TAPE -
C
C     ELEMENT HEADER RECORD, IN 8-COLUMN FORMAT
C     (LINE ---+++ IS FOR VIDEO AID, NOT PART OF A RECORD)
C
C     --------++++++++--------++++++++--------++++++++--------++++++++
C     ELEMENT CBAR      TYPE =  34  BR GRIDS =       2 TOTAL = ETC...
C
C       RECORD  COLUMNS    CONTENT                             FORMAT
C       ------  -------  -----------------------------------------------
C          2      1- 8   'ELEMENT '                          8 LETTERS
C                 9-16   ELEMENT NAME                             2A4
C                17-24   '  TYPE ='                          8 LETTERS
C                25-28   ELEM. TYPE NO. ACCORDING TO GPTABD        I4
C                29,30   BLANK                                     2X
C                31-32   ELEMENT SYMBOL                            A2
C                33-40   ' GRIDS ='                          8 LETTERS
C                41-48   NO. OF GRIDS PER ELEMENT                  I8
C                49-56   ' TOTAL ='                          8 LETTERS
C                57-64   TOTAL NO. OF ELEMENTS OF THIS ELEM. TYPE  I8
C                65-72   ' WDS/EL='                          8 LETTERS
C                73-80   NO. OF WORDS PER ELEMENT IN NEXT RECORDS  I8
C                81-88   ' LINES ='                          8 LETTERS
C                89-96   NO. OF LINES (RECORDS) NEEDED ON NEXT     I8
C                        RECORD FOR THIS ELEMENT TYPE
C
C     ELEMENT RECORD
C     THERE SHOULD BE (TOTAL X LINES) RECORDS IN THIS GROUP
C
C       RECORD  WORD      CONTENT                               FORMAT
C       ------  ----     -----------------------------------------------
C          3      1       ELEMENT ID                               I8
C                 2       POSITIVE INTEGER  = PROPERTY ID          I8
C                         ZERO IF ELEM HAS NO PROPERTY ID
C                         NEGATIVE INTEGER  = MATERIAL ID (ELEMENT HAS
C                            NO PROPERTY ID, BUT IT HAS A MATERIAL ID)
C                 3       0 (NOT USED. RESERVED FOR FUTURE USE)    I8
C              4,5,...16  FIRST 13 EXTERNAL CONNECTING GRID PTS.  13I8
C          4              (IF NEEDED)
C              1,2,...15  NEXT 15 GRID POINTS                  8X,15I8
C          5              (IF NEEDED)
C              1,2,...15  MORE GRID POINTS                     8X,15I8
C
C
C     REPEAT FORMATTED RECORD 3 (AND POSSIBLE 4 AND 5) AS MANY TIMES AS
C     THERE ARE ELEMENTS
C
  300 WRITE  (OUTTP,310) (Z(J+JBM1),J=1,8)
  310 FORMAT (1X,'ELEMENT ',2A4,'  TYPE =',I4,2X,A2,' GRIDS =',I8,
     1        ' TOTAL =',I8,' WDS/EL=',I8,' LINES =',I8)
      I  = JB + 8
      DO 360 J = 9,NWDS,NG3
      JE = I + NG3 - 1
      IF (NG3 .GT. 16) GO TO 330
      WRITE (OUTTP,320,ERR=1390) (Z(K),K=I,JE)
C
C     320  FORMAT (1X,16I8,/,(1X,8X,15I8))
C     THIS FORMAT MAY CAUSE AN EXTRA LINE IN SOME MACHINE IF NG3=16
C
  320 FORMAT (1X,16I8)
      GO TO 360
  330 J16 = I + 15
      J17 = I + 16
      WRITE  (OUTTP,320,ERR=1390) (Z(K),K= I,J16)
      IF (NG3 .GT. 31) GO TO 350
      WRITE  (OUTTP,340,ERR=1390) (Z(K),K=J17,JE)
  340 FORMAT (1X,8X,15I8)
      GO TO 200
  350 J31 = I + 30
      J32 = I + 31
      WRITE (OUTTP,340,ERR=1390) (Z(K),K=J17,J31)
      WRITE (OUTTP,340,ERR=1390) (Z(K),K=J32,JE )
  360 I = JE + 1
      GO TO 200
C
C     BYPASSING INSUFF. CORE SITUATION, FORMATTED TAPE ONLY
C
  370 CALL READ (*1300,*1300,SCR1,A,8,0,FLAG)
      A(6) = NE
      WRITE (OUTTP,310,ERR=1390) (A(J),J=1,8)
  380 CALL READ (*1300,*410,SCR1,A,NG3,0,FLAG)
      IF (NG3  .GT. 16) GO TO 390
      WRITE (OUTTP,320,ERR=1390) (A(J),J=1,NG3)
      GO TO 380
  390 WRITE (OUTTP,320,ERR=1390) (A(J),J=1,16)
      IF (NG3  .GT. 32) GO TO 400
      WRITE (OUTTP,340,ERR=1390) (A(J),J=17,NG3)
      GO TO 380
  400 WRITE (OUTTP,340,ERR=1390) (A(J),J=17,32)
      WRITE (OUTTP,340,ERR=1390) (A(J),J=33,NG3)
      GO TO 380
  410 CALL CLOSE (SCR1,REW)
      GO TO 200
C
C
C     LAST RECORD FOR ELEMENT DATA, UNFORMATTED AND FORMATTED
C
C     --------++++++++--------++++++++--------++++++++--------++++++++
C     ELEMENT -END-     TYPE =   0  -- GRIDS =       0 TOTAL =  ETC...
C
  420 CALL CLOSE (GEOM2,REW)
      DO 430 I = 3,8
  430 NAM(I) = 0
      NAM(1) = END1
      NAM(2) = END2
      NAM(4) = END3
      IF (.NOT.FMTTD) WRITE (OUTTP    ) NAM
      IF (     FMTTD) WRITE (OUTTP,310) NAM
C
C
C     PROCESS OFP DATA BLOCKS   SIGNITURE
C     =======================   =========
C       DISPLACEMENT                 1
C       VELOCITIES                  10
C       ACCELERATIONS               11
C       LOADS                        2
C       GRID POINT OR SPC FORCES     3
C       EIGENVECTORS                 7
C       ELEMENT STRESSES, AND        5
C       ELEMENT STRAIN              21
C       ELEMENT FORCES               4
C
C    (GINO INPUT FILE 105,106,107)
C
  490 OFPSET = 0
      OFP  = 0
C
C     SETUP 500-1000 BIG LOOP FOR 3 OFP DATA BLOCKS
C
  500 OFP  = OFP + 1
      OFPX = CSTM + OFP
      NAM(1) = OFPX
      CALL RDTRL (NAM)
C
C     SKIP CURRENT OFP DATA BLOCK IF IT IS PURGED
C
      IF (NAM(1) .LE. 0) GO TO 1000
C
      FILE = OFPX
      CALL OPEN (*1000,OFPX,Z(BUF1),RDREW)
      CALL FWDREC (*980,OFPX)
      JOS  = 2*OFPSET + 1
      OFPSET = OFPSET + 1
      CALL FNAME (OFPX,ONAME(JOS))
      IF (BASC  .AND. NOBGPT .AND. .NOT.NOCSTM) GO TO 660
      IF (NOBGPT .OR. NOCSTM) BASC = .FALSE.
      KOUNT = 0
  510 KOUNT = KOUNT + 1
      FILE  = OFPX
      DO 515 I = 1,6
  515 F8(I) = 0
C
C     IDENTIFY CURRENT OFP DATA BLOCK IS A DISPLACEMENT FILE OR A NON-
C     DISPLACEMENT FILE
C
      CALL READ (*980,*980,OFPX,A,10,0,FLAG)
      DSPL = MOD(A(2),100)
      NWDS = A(10)
      DXX  = BLK8
      IF (NWDS.NE.8 .AND. NWDS.NE.14) GO TO 530
C
C     CURRENT OFP DATA BLOCK IS A DISPLACEMENT FILE
C
      CALL BCKREC (OFPX)
      IF (DSPL .EQ. 1) DXX = DIS
      IF (DSPL .EQ. 2) DXX = LOD
      IF (DSPL .EQ. 3) DXX = FORC
      IF (DSPL.EQ. 7 .OR. DSPL.EQ.14) DXX = EIGN
      IF (DSPL.EQ.15 .OR. DSPL.EQ.10) DXX = VELO
      IF (DSPL.EQ.16 .OR. DSPL.EQ.11) DXX = ACC
      IF (DXX .EQ. BLK8) GO TO 530
      F(1) = 1
      F(2) = 1
      DO 520 I = 3,NWDS
  520 F(I) = 2
      F8(1) = 11222222
      KK  = 1
      NA4 = 22
      IF (NWDS .EQ. 8) GO TO 600
      F8(2) = 22222200
      KK  = 2
      NA4 = 40
      GO TO 600
C
C     CURRENT OFP DATA BLOCK IS STRESS OR EL FORCE FILE.
C     THE DATA RECORDS HAVE VARIABLE LENGTH (I.E NWDS IS NOT A CONSTANT
C     OF 8 OR 14)
C     CONSTRUCT THE FORMAT CODE IN F AND F8
C           1 = INTEGER
C           2 = REAL
C           3 = BCD
C     AND TURN OFF GLOBAL TO BASIC CONVERSION FLAG BASC
C
  530 IF (DSPL .EQ. 4) DXX = ELF
      IF (DSPL .EQ. 5) DXX = STR
      IF (DXX  .EQ.  BLK8) GO TO 1260
      IF (NWDS .GT. LIMAF) GO TO 1350
      IF (BASC) GO TO 1370
      EFS  = .TRUE.
      CALL FWDREC (*980,OFPX)
      CALL READ (*980,*980,OFPX,A,NWDS,0,FLAG)
      DO 540 I = 1,NWDS
      J = NUMTYP(A(I))
      IF (J.EQ.0 .AND. I.GT.1) J = F(I-1)
  540 F(I)  = J
      IF (DEBUG) WRITE (NOUT,545) NWDS,(F(I),I=1,NWDS)
  545 FORMAT (/,' NWDS/@540=',I3,' F=',50I2, /,(14X,50I2))
      AGAIN = 0
      CALL READ (*980,*570,OFPX,A,NWDS,0,FLAG)
      DO 550 I = 1,NWDS
      J = NUMTYP(A(I))
      IF (F(I) .EQ. J) GO TO 550
      IF (J    .NE. 0) F(I) = -J
      AGAIN = 1
  550 CONTINUE
      IF (AGAIN .EQ. 0) GO TO 570
      CALL READ (*980,*570,OFPX,A,NWDS,0,FLAG)
      DO 560 I = 1,NWDS
      IF (F(I) .GT. 0) GO TO 560
      J = NUMTYP(A(I))
      IF (J .NE. 0) F(I) = J
  560 CONTINUE
      IMHERE = 560
      IF (DEBUG) WRITE (NOUT,545) IMHERE,(F(I),I=1,NWDS)
  570 F(NWDS+1) = -9
      CALL BCKREC (OFPX)
      CALL BCKREC (OFPX)
      NA4= 0
      KK = 0
      DO 580 I = 1,NWDS,8
      KK = KK + 1
      K  = I  + 7
      IF (K .GT. NWDS) K = NWDS
      L  = 10000000
      DO 580 J = I,K
      F8(KK) = F8(KK) + F(J)*L
      NA4 = NA4 + F(J)+ 1
      IF (F(J) .EQ. 3) NA4 = NA4 - 3
  580 L  = L/10
      IF (DEBUG) WRITE (NOUT,590) NA4,(F8(I),I=1,KK)
  590 FORMAT (/,'  NA4 =',I4,'  FORMAT CODE/@590 =',6I10)
C
  600 IF (KOUNT .GT. 1) GO TO 605
      IF (.NOT.FMTTD) WRITE (OUTTP    ) DXX,DASH
      IF (     FMTTD) WRITE (OUTTP,120) DXX,DASH
C
  605 IF (ECXYZ) GO TO 680
      ECXYZ = .TRUE.
      NCSTM = 0
      NSUB  = 0
      IF (.NOT.BASC) GO TO 680
C
C     DISPLACEMENT OFP FILE IS PRESENT, USER IS REQUESTING DISPLACEMENT
C     OUTPUT.
C
C     REMEMBER, WE STILL HAVE THE EXT-INT GRID TABLE IN Z(1) THRU Z(NEQ)
C     IN INTERNAL GIRD NUMBER (2ND WORD OF THE EXT-INT PAIR) SORT.
C     NOW, OPEN BGPDT, READ IN THE BASIC GRID POINT DATA (4 WORDS EACH
C     GRID) AND ADD THE EXTERNAL GRID POINT ID IN FRONT OF THE DATA SET.
C     THUS WE CREATE A NEW TABLE AFTER THE EXT-INT TABLE.
C
C     THE FOLLOWING 5 DATA WORDS FOR EACH GRID POINT:
C            EXTERNAL GRID ID
C            COORDINATE SYSTEM ID
C            X,Y,Z COORDINATES, IN BASIC COORD. SYSTEM
C
C     MOVE THIS NEW TABLE TO THE BEGINNING OF OPEN CORE SPACE
C     OVERWRITING THE OLD EXT-INT TABLE WHICH HAS NO LONGER NEEDED,
C     FROM Z(1) THRU Z(NBGT)
C     SORT THIS NEW TABLE BY THE EXTERNAL GRID NUMBERS.
C
      FILE = BGPDT
      CALL OPEN (*1300,BGPDT,Z(BUF2),RDREW)
      CALL FWDREC (*1300,BGPDT)
      K = -1
      J = JB
  610 CALL READ (*620,*620,BGPDT,Z(J+1),4,0,FLAG)
      K = K + 2
      Z(J) = Z(K)
      J = J + 5
      GO TO 610
  620 CALL CLOSE (BGPDT,REW)
      IF (K+1 .NE. NEQ) CALL MESAGE (-61,0,0)
      NBGT = J - JB
      NBG5 = NBGT/5
      DO 630 J = 1,NBGT
  630 Z(J) = Z(J+JBM1)
      CALL SORT (0,0,5,1,Z(1),NBGT)
      IF (DEBUG) WRITE (NOUT,640)
     1   (Z(J),Z(J+1),RZ(J+2),RZ(J+3),RZ(J+4),J=1,NBGT,5)
  640 FORMAT (/11X,'EXT.GRID - COOR - X,Y,Z/@640',/,(10X,2I8,3E11.4))
C
C     OPEN CSTM FILE IF IT EXISTS.  SAVE ALL COORDINATE TRANSFORMATION
C     MATRICES IN THE OPEN CORE SPACE IN Z(ICSTM) THRU Z(NCSTM), EITHER
C     AFTER THE EXT-COORD-X,Y,X TABLE, OR IN FRONT OF THE TABLE
C
      ICSTM = NBGT + 1
      NCSTM = NBGT
      FILE  = CSTM
      CALL OPEN (*1300,CSTM,Z(BUF2),RDREW)
      CALL FWDREC (*1300,CSTM)
      CALL READ (*650,*650,CSTM,Z(ICSTM),LEFT,1,FLAG)
      CALL MESAGE (-8,0,SUB)
  650 CALL CLOSE (CSTM,REW)
      NCSTM = NCSTM+FLAG
      CALL PRETRS (Z(ICSTM),FLAG)
      GO TO 680
C
  660 WRITE  (NOUT,670) UIM
  670 FORMAT (A29,' FROM DATABASE MODULE - DISPLACEMENT VECTORS REMAIN',
     1       ' IN GLOBAL COOR. SYSTEM', /5X,
     2       'DUE TO BGPDT OR CSTM FILE BEING PURGED',/)
      BASC = .FALSE.
C
C     NOW READ THE DISPLACMENT VECTORS (SUBCASES) FROM CURRENT OFP DATA
C     BLOCK, COMPUTE THE DISPLACEMENT FROM THE DISPLACMENT COORDINATE
C     BACK TO SYSTEM BASIC COORDINATE. SAVE THE VECTOR IN SCR1 FOR RE-
C     PROCESSING LATER.
C
C     2 (3 IF COMPLEX DATA) RECORDS PER ELEMENT TYPE,
C     SAME FORMAT AS GINO OUGV1 FILE
C
C     UNFORMATTED TAPE -
C
C     HEADER RECORD (UNFORMATTED)
C
C        RECORD  WORD       CONTENT (UNFORMATTED)
C        ------  ----   -----------------------------------------------
C           1      1     SUBCASE OR MODE NUMBER, INTEGER
C                  2     ZERO OR FREQUENCY, REAL
C                  3     NWDS, NUMBER OF WORDS PER ENTRY IN NEXT RECORD,
C                        INTEGER. (=8 FOR REAL DATA, OR =14 FOR COMPLEX
C                        FOR ALL DISPLACEMENT RECORDS)
C                 4-5    ORIGINAL GINO FILE NAME, BCD
C                 6-7    ' BASIC  '  OR 'GLOBAL  ', BCD
C                8-13    FORMAT CODE FOR NEXT RECORD, INTEGER
C                        8 DIGITS PER WORD,  1 FOR INTEGER
C                                            2 FOR REAL
C                        EX.  13222222       3 FOR BCD
C                                            0 NOT APPLICABLE
C               14-45    TITLE,    BCD
C               46-77    SUBTITLE, BCD
C              78-109    LABEL,    BCD
C
C     DISPLACEMENT RECORDS (UNFORMATTED)
C
C        RECORD  WORD       CONTENT (UNFORMATTED)
C        ------  ----   -----------------------------------------------
C           2      1     LENGTH, THIS FIRST WORD EXCLUDED, OF THIS
C                        RECORD (INTEGER)
C                  2     EXTERNAL GRID POINT NUMBER (INTEGER)
C                  3     POINT TYPE (1=GRID  PT.  2=SCALAR PT.
C                                    3=EXTRA PT.  4=MODAL  PT., INTEGER)
C                4-9     DISPLACEMENTS (REAL PARTS, REAL
C                        T1,T2,T3,R1,R2,R3)
C               10-15    (COMPLEX DATA ONLY)
C                        DISPLACEMENTS (IMGAGINARY PARTS, REAL
C                        T1,T2,T3,R1,R2,R3)
C                  :     REPEAT WORDS 2 THRU 9 (OR 15) AS MANY TIMES AS
C                        THERE ARE GRID POINT DISPLACEMENT DATA
C           :      :     REPEAT RECORD 2 AS MANY TIMES AS THERE ARE
C                        SUBCASES (OR MODES)
C
C
C     FORMATTED TAPE -
C
C     HEADER RECORD (FORMATTED)
C
C        RECORD   WORD      CONTENT (FORMATTED)                   FORMAT
C        ------   ----   -----------------------------------------------
C           1      1-2    ' CASE = ' OR ' MODE = '             8-LETTERS
C                    3    SUBCASE NUMBER                             I8
C                    4    ZERO OR FREQUENCY                     1P,E12.5
C                  5-6    ' WORDS ='                           8-LETTERS
C                    7    NWDS, NUMBER OF WORDS PER ENTRY IN NEXT    I8
C                         RECORD (=8 FOR REAL DATA, OR =14 COMPLEX,
C                         FOR ALL DISPLACEMENT RECORDS)
C                  8-9    ' INPUT ='                           8-LETTERS
C                10-11    ORIGINAL GINO FILE NAME                   2A4
C                12-13    ' COORD ='                           8-LETTERS
C                14-15    ' BASIC  ' OR 'GLOBAL  '                  2A4
C                16-17    '  CODE ='                           8-LETTERS
C                18-23    FORMAT CODE                               6I8
C                         8 DIGITS PER WORD,  1 FOR INTEGER
C                                             2 FOR REAL
C                         EX.  13222200       3 FOR BCD
C                                             0 NOT APPLICABLE
C                   23    NA4, NUMBER OF WORDS PER ENTRY IN NEXT    (I8)
C                         RECORD, IN A4-WORD COUNT (ONLY IF THE
C                         LAST FORMAT CODE WORD IS NOT USED)
C           2     1-32    TITLE,    32 BCD WORDS                   32A4
C           3    33-64    SUBTITLE, 32 BCD WORDS                   32A4
C           4    65-96    LABEL,    32 BCD WORDS                   32A4
C               (95-96    ELEMENT ID, STRESS AND FORCE ONLY         2A4)
C
C
C     DISPLACEMENT RECORDS (FORMATTED)
C
C        RECORD   WORD      CONTENT (FORMATTED)                   FORMAT
C        ------   ------------------------------------------------------
C           5       1     EXTERNAL GRID POINT NUMBER                 I8
C                   2     POINT TYPE (1=GRID  PT.  2=SCALAR PT.      I8
C                                     3=EXTRA PT.  4=MODAL  PT.)
C                 3-8     DISPLACEMENTS (REAL PARTS,         6(1P,E12.5)
C                         T1,T2,T3,R1,R2,R3)
C           6             (COMPLEX DATA ONLY)
C                 1-6     DISPLACEMENTS (IMAGINARY PARTS,    6(1P,E12.5)
C                         T1,T2,T3,R1,R2,R3)
C           :       :     REPEAT RECORD 5 (OR RECORDS 5 AND 6) AS MANY
C                         TIMES AS THERE ARE GRID POINT DISPLACMENT DATA
C         LAST      1     MINUS 0                                    I8
C                   2     MINUS 0                                    I8
C                 3-8     ZEROS                              6(1P,E12.5)
C        LAST+1           (COMPLEX DATA ONLY)
C                 1-6     ZEROS                              6(1P,E12.5)
C
C     IF CURRENT OFP DATA BLOCK IS AN ELEMENT STRESS OR ELEMENT FORCE
C     FILE, THE STRESS OR FORCE DATA HAVE VARIABLE LENGTH. (NWDS IS NO
C     LONGER 8 OR 14.)
C
C     THE ELEMENT STRESS OR FORCE RECORDS -
C
C        RECORD   WORD      CONTENT (UNFORMATTED)
C        ------   ------------------------------------------------------
C           2       1      NO. OF WORDS, EXCLUDING THIS FIRST WORD,
C                          IN THIS RECORD. (INTEGER)
C               2-NWDS+1   ELEMENT ID, STRESS OR FORCE DATA
C                          (VARIABLE DATA TYPES ARE DESCRIBED IN 'CODE')
C                   :      REPEAT (2-NWDS+1) WORDS AS MANY TIMES AS
C                          THERE ARE ELEMENTS
C           :       :      REPEAT RECORD 2 AS MANY TIMES AS THERE ARE
C                          SUBCASES.
C
C         WHERE NWDS IS THE NUMBER OF COMPUTER WORDS PER ENTRY, AND
C               CODE IS THE 6-WORD FORMAT CODE, AS DESCRIBED IN THE
C               HEADER RECORD.
C
C
C        RECORD   WORD      CONTENT (FORMATTED)                   FORMAT
C        ------   ------------------------------------------------------
C           5     1-NA4     ELEMENT ID, STRESS OR FORCE DATA       33A4
C                           (THE DATA TYPES ARE DESCRIBED IN
C                           'CODE'; ALL INTEGERS IN 2A4, REAL
C                           NUMBERS IN 3A4, AND BCD IN A4)
C           :       :       (MAXIMUM RECORD LENGTH IS 132 COLUMNS (33A4)
C                           CONTINUATION AND FOLDED INTO NEXT
C                           RECORD(S) IF NECESSARY.
C           :       :       A CARRIAGE CONTROL WORD ALWAYS PRECEEDS
C                           AN OUTPUT RECORD. THUS 1+132=133 COLUMNS
C                           LAST DATA VALUE ON A RECORD MAY SPILL
C                           TO THE NEXT RECORD)
C           :       :       REPEAT ABOVE RECORD(S) AS MANY TIMES
C                           AS THERE ARE ELEMENTS.
C
C         WHERE NA4 IS THE NUMBER OF WORDS PER ENTRY IN A4-WORD COUNT,
C               AND CODE IS 5-WORD FORMAT CODE
C
  680 FILE  = OFPX
      IOUGV = NCSTM + 1
      CALL READ (*980,*700,OFPX,Z(IOUGV),NZ-IOUGV,1,FLAG)
      CALL MESAGE (-37,FILE,SUB)
  700 IF (FLAG .NE. 146) GO TO 1320
      DSPL = MOD(Z(IOUGV+1),100)
      NWDS = Z(IOUGV+9)
      IF (.NOT.EFS .AND. NWDS.NE.8 .AND. NWDS.NE.14) GO TO 1320
      NSUB = NSUB + 1
      CAMO = CA
      CASE = Z(IOUGV+3)
      FREQ = 0.0
      IF (DSPL.NE.7 .AND. DSPL.NE.14) GO TO 710
      CAMO = MO
      CASE = Z (IOUGV+4)
      FREQ = RZ(IOUGV+5)
  710 BAGL = BA
      IF (.NOT.BASC) BAGL  = GL
      IF (FMTTD .AND. F8(6).EQ.0) F8(6) = NA4
      IF (.NOT.EFS) GO TO 715
      J = (Z(IOUGV+2)-1)*INCR
      Z(IOUGV+144) = E(J+1)
      Z(IOUGV+145) = E(J+2)
  715 IF (.NOT.FMTTD) WRITE (OUTTP)
     1   CASE,FREQ,NWDS,ONAME(JOS),ONAME(JOS+1),F8,(Z(J+IOUGV),J=50,145)
      IF ( FMTTD) WRITE (OUTTP,720) CAMO,CASE,
     1   FREQ,NWDS,ONAME(JOS),ONAME(JOS+1),BAGL,F8,(Z(J+IOUGV),J=50,145)
  720 FORMAT (1X,A8,I8,1P,E12.5,' WORDS =',I8,' INPUT =',2A4,
     1   ' COORD =',A8,'  CODE =',6I8, /1X,32A4, /1X,32A4, /1X,32A4)
      IF (FMTTD) GO TO 730
      FILE = SCR1
      CALL OPEN (*1300,SCR1,Z(BUF2),WRTREW)
      FILE = OFPX
  730 CALL READ (*970,*870,OFPX,A,NWDS,0,FLAG)
      A(1) = A(1)/10
      IF (EFS) GO TO 790
      IF (DEBUG) WRITE (NOUT,740) A(1)
  740 FORMAT (10X,'EXT.GRID/@740 =',I8)
      IF (BASC) GO TO 1200
  750 IF (COOR .LE. 0) GO TO 790
C
C     TRANSFORM THE DISPLACEMENT VECTOR FROM GLOBAL TO BASIC
C     UPON RETURN FROM 800, TRANSFORMATION MATRIX IN T
C
      DO 760 I = 3,NWDS
  760 RX(I)  = RA(I)
      CMPLX  = 0
  770 CALL GMMATS (T,3,3,0, RX(3),3,1,0, RA(3+CMPLX))
      CALL GMMATS (T,3,3,0, RX(6),3,1,0, RA(6+CMPLX))
      IF (NWDS.NE.14 .OR. CMPLX.EQ.6) GO TO 790
      CMPLX = 6
      DO 780 I = 3,8
  780 RX(I) = RX(I+CMPLX)
      GO TO 770
C
C     WRITE THE 8 (OR 14) DATA WORDS OUT TO SCR1 FILE IF OUTTP IS
C     UNFORMATTED, OR WRITE TO OUTTP DIRECTLY IF OUTTP IS FORMATTED
C
  790 IF (FMTTD) GO TO 800
      CALL WRITE (SCR1,A,NWDS,0)
      GO TO 730
  800 IF (EFS) GO TO 830
      WRITE  (OUTTP,810,ERR=1390) A(1),A(2),(RA(K),K=3,8)
  810 FORMAT (1X,2I8,6(1P,E12.5))
      IF (NWDS .EQ. 14) WRITE (OUTTP,820,ERR=1390) (RA(K),K=9,14)
  820 FORMAT (17X,6(1P,E12.5))
      GO TO 730
C
C     ELEMENT STRESS AND ELEMENT FORCE HAVE MIXED DATA, CHANGE THEM ALL
C     TO BCD WORDS, AND WRITE THEM OUT TO OUTTP UNDER A4 FORMAT
C     MAXIMUM OF 132 COLUMNS PER LINE.
C     NOTE - LAST DATA VALUE ON OUTPUT LINE MAY SPILL INTO NEXT RECORD.
C
  830 L = 0
      K = 0
  840 K = K + 1
      IF (F(K) .EQ. -9) GO TO 850
      IF (L+3 .GT. LIMRX) GO TO 1340
      CALL IFB2AR (F(K),A(K),IX,L)
      GO TO 840
  850 WRITE  (OUTTP,860,ERR=1390) (IX(K),K=1,L)
  860 FORMAT (1X,33A4)
      GO TO 730
C
C
C     JUST FINISH ONE VECTOR
C
C     UNFORMATTED TAPE -
C     TRANSFER THIS VECTOR FROM SCR1 TO OUTTP IN ONE LONG RECORD
C     (NO ZERO RECORD)
C     LOOP BACK FOR NEXT VECTOR
C
  870 IF (FMTTD) GO TO 890
      CALL WRITE (SCR1,0,0,1)
      CALL CLOSE (SCR1,REW)
      FILE = SCR1
      CALL OPEN (*1300,SCR1,Z(BUF2),RDREW)
      CALL READ (*880,*880,SCR1,Z(IOUGV+1),NZ-IOUGV,1,K)
      CALL MESAGE (-8,FILE,SUB)
  880 CALL CLOSE (SCR1,REW)
      Z(IOUGV) = K
      KIOUGV   = K + IOUGV
      WRITE (OUTTP) (Z(J),J=IOUGV,KIOUGV)
      GO TO 510
C
C     FORMATTED TAPE -
C     (DISPLACEMENTS ALREDY WRITTEN OUT IN SHORT RECORDS)
C     WRITE A ZERO RECORD
C     AND LOOP BACK FOR NEXT VECTOR
C
  890 IF (EFS) GO TO 920
      DO 900 I = 1,6
  900 RX(I) = 0.0
      WRITE  (OUTTP,910,ERR=1390) (RX(I),I=1,6)
  910 FORMAT (1X,2(6X,2H-0),6(1P,E12.5))
      IF (NWDS .EQ. 14) WRITE (OUTTP,820,ERR=1390) (RX(I),I=1,6)
      GO TO 510
C
C     WRITE A ZERO RECORD FOR EL.STRESS OR EL.FORCE TYPE OF DATA
C
  920 L = 0
      DO 960 I = 1,NWDS
      IX(L+2) = BLANK
      FI = F(I)
      GO TO (930,940,950), FI
  930 IX(L+1) = IZERO
      L = L + 2
      GO TO 960
  940 IX(L+1) = BZERO
      IX(L+3) = BLANK
      L = L + 3
      GO TO 960
  950 L = L + 1
  960 CONTINUE
      WRITE (OUTTP,860,ERR=1390) (IX(I),I=1,L)
      GO TO 510
C
C     END OF CURRENT OFP FILE
C     ADD AN ENDING RECORD TO OUTTP FILE AND ENDFILE
C
  970 CALL CLOSE (SCR1,REW)
  980 CALL CLOSE (OFPX,REW)
C
      DYY(OFPSET)  = DXX
      SUBN(OFPSET) = NSUB
      CASE = 0
      FREQ = 0.0
      Z(1) = 0
      J    = 0
      Z(J+2) = END1
      Z(J+3) = END2
      Z(J+4) = BLANK
      DO 985 J = 5,10
  985 Z(J) = 0
      DO 990 J = 11,106
  990 Z(J) = BLANK
      IF (.NOT.FMTTD) WRITE (OUTTP) CASE,FREQ,(Z(J),J=1,106)
      IF (     FMTTD) WRITE (OUTTP,720,ERR=1390) CAMO,CASE,FREQ,
     1                      (Z(J),J=1,106)
 1000 IF (OFP .LT. 3) GO TO 500
C
C     JOB DONE. WRITE A USER FRIENDLY MESSAGE OUT
C
      ENDFILE OUTTP
      REWIND  OUTTP
      SET = OFPSET
      IF (.NOT.NOBGPT) SET = SET + 1
      IF (.NOT.NOGEOM) SET = SET + 1
      J = BLANK
      IF (SET .GT. 1) J = LS
      K = 3 + 2*SET
      CALL PAGE2 (K)
      IF (OUTTP .GT. 12) GO TO 1010
      NAM(1) = INPX(3)
      NAM(2) = OUTTP - 10
      GO TO 1020
 1010 NAM(1) = INPX(1)
      NAM(2) = OUTTP - 14
      IF (OUTTP.NE.14 .AND. OUTTP.NE.25) GO TO 1020
      WRITE (NOUT,1030) UIM,SET,J,INPX(2)
      GO TO 1040
 1020 WRITE  (NOUT,1030) UIM,SET,J,NAM(1),NAM(2)
 1030 FORMAT (A29,' -', /5X,'DATABASE MODULE TRANSFERRED THE FOLLOWING',
     1       I3,' SET',A1,' OF DATA TO OUTPUT FILE ',A4,I1)
 1040 WRITE  (NOUT,1050) OUTTP,FMT
 1050 FORMAT (1H+,85X,'(FORTRAN UNIT',I3,1H),4A4)
      SET = 0
      IF (NOBGPT) GO TO 1070
      SET = SET + 1
      WRITE  (NOUT,1060) SET
 1060 FORMAT (/4X,I2,'. GRID POINT DATA - EXTERNAL NUMBERS AND BASIC ',
     1        'RECTANGULAR COORDINATES')
 1070 IF (NOGEOM) GO TO 1090
      SET = SET + 1
      WRITE  (NOUT,1080) SET
 1080 FORMAT (/4X,I2,'. ELEMENT CONNECTIVITY DATA - ALL GRID POINTS ',
     1        'ARE EXTERNAL NUMBERS')
 1090 IF (OFPSET .EQ. 0) GO TO 1190
      JSO = 1
      DO 1180 J = 1,OFPSET
      SET  = SET + 1
      NSUB = SUBN(J)
      WRITE  (NOUT,1100) SET,DYY(J),ONAME(JSO),ONAME(JSO+1)
 1100 FORMAT (/4X,I2,2H. ,A8,' DATA FROM INPUT FILE ',2A4)
      IF (EFS) GO TO 1120
      IF (     BASC) WRITE (NOUT,1110)
      IF (.NOT.BASC) WRITE (NOUT,1115)
 1110 FORMAT (1H+,46X,', CONVERTED TO BASIC RECT. COORDINATES,')
 1115 FORMAT (1H+,46X,', IN NASTRAN GLOBAL COORDINATE SYSTEM,')
      IF (DSPL.EQ.7 .OR. DSPL.EQ.14) GO TO 1140
 1120 IF (.NOT.EFS) WRITE (NOUT,1125) NSUB
      IF (     EFS) WRITE (NOUT,1130) NSUB
 1125 FORMAT (1H+,87X,I4,' SUBCASES')
 1130 FORMAT (1H+,46X,I4,' SUBCASES')
      GO TO 1160
 1140 WRITE  (NOUT,1150) NSUB
 1150 FORMAT (1H+,87X,I4,' FRQUENCIES')
 1160 IF (NOBGPT .AND. NOGEOM) WRITE (NOUT,1170)
 1170 FORMAT (/6X,'1. NONE')
 1180 JSO = JSO + 2
      RETURN
C
 1190 WRITE (NOUT,1170)
      RETURN
C
C     INTERNAL ROUTINE TO SEARCH FOR THE EXTERNAL GRID POINT AND RETURN
C     THE DISPLACEMENT COORDINATE ID ASSOCIATE WITH THAT POINT, AND SET
C     THE POINTER TO WHERE THE COORDINATE TRANSFORMATION MATRIX DATA
C     BEGINS.
C     EXTERNAL GRID VS. COORD SYSTEM ID TABLE IN Z(1) THRU Z(NEQ), IN
C     EXTERNAL GRID SORT
C     THE COORDINATE TRANSFORMATION MATRICES IN Z(ICSTM) THRU Z(NCSTM),
C     (14 WORDS PER MATRIX, FROM GLOBAL TO BASIC)
C
 1200 GRID = A(1)
      KLO  = 0
      KHI  = NBG5
      LASTK= 0
 1210 K = (KLO+KHI+1)/2
      IF (LASTK .EQ. K) CALL MESAGE (-61,0,0)
      LASTK = K
      K5  = K*5
      IF (GRID-Z(K5-4)) 1220,1240,1230
 1220 KHI = K
      GO TO 1210
 1230 KLO = K
      GO TO 1210
 1240 COOR = Z(K5-3)
      IF (COOR .LE. 0) GO TO 750
      CALL TRANSS (Z(K5-3),T)
      IF (.NOT.DEBUG) GO TO 750
      WRITE  (NOUT,1250) GRID,COOR,T
 1250 FORMAT (20X,'EXT GRID, COORD.ID AND TRANSF.MATRIX/@1250 =',2I8,
     1        /,(25X,3E13.5))
      GO TO 750
C
C     ILLEGITIMATE DATA IN OUGV FILE, ADVANCE TO NEXT RECORD
C
 1260 CALL FWDREC (*980,OUGV)
      CALL FWDREC (*980,OUGV)
      GO TO 510
C
C     ERRORS
C
 1300 J = -1
      GO TO 1400
 1310 J = -2
      GO TO 1400
 1320 WRITE  (NOUT,1325) UIM,ONAME(JSO),ONAME(JSO+1)
 1325 FORMAT (A29,', DATABASE MODULE SKIPS OUTPUTING ',2A4,
     1       ' FILE (OR PART OF THE FILE), DUE TO')
      WRITE  (NOUT,1330) NWDS
 1330 FORMAT (5X,'THE REQUEST OF AN ILLEGITIMATE DATA BLOCK.', 7X,
     1       'NO. OF WORDS =',I6)
      GO TO 1380
 1340 WRITE  (NOUT,1325) UIM,ONAME(JSO),ONAME(JSO+1)
      WRITE  (NOUT,1345) LIMRX
 1345 FORMAT (5X,'THE RX WORKING ARRAY OF',I5,' WORDS IN DBASE ',
     1       'SUBROUTINE IS NOT BIG ENOUGH TO RECEIVE OFP DATA.')
      GO TO 1360
 1350 WRITE  (NOUT,1325) UIM,ONAME(JSO),ONAME(JSO+1)
      WRITE  (NOUT,1355) LIMAF
 1355 FORMAT (5X,'THE A AND F WORKING ARRAYS OF',I4,' WORDS IN DBASE ',
     1       'SUBROUTINE ARE NOT BIG ENOUGH TO RECEIVE OFP DATA.')
 1360 WRITE  (NOUT,1365)
 1365 FORMAT (5X,'SUGGESTION - USE OUTPUT5 OR OUTPUT2 TO CAPTURE THE ',
     1       'REQUESTED DATA BLOCK')
      GO TO 1260
 1370 WRITE  (NOUT,1325) UIM,ONAME(JSO),ONAME(JSO+1)
      WRITE  (NOUT,1375)
 1375 FORMAT (5X,'ELEMENT STRESSES OR FORCES CAN NOT BE OUTPUT IN ',
     1       'BASIC COORDINATES AS REQUESTED')
 1380 CALL CLOSE (OFPX,REW)
      GO TO 1000
 1390 WRITE  (NOUT,1395)
 1395 FORMAT ('0*** SYSTEM FATAL ERROR WRITING FORMATTED TAPE IN DATA',
     1        'BASE MODULE')
      IF (MACH .EQ. 3) WRITE (NOUT,1396)
 1396 FORMAT (5X,'IBM USER - CHECK FILE ASSIGNMENT FOR DCB PARAMETER ',
     1       'OF 133 BYTES')
      J = -37
 1400 CALL MESAGE (J,FILE,SUB)
      RETURN
C     END
C
C
C     THE FOLLOWING PROGRAM WAS USED TO CHECKOUT THE UNFORMATTED TAPE
C     GENERATED BY DBASE. IT CAN BE SERVED AS A GUIDE TO OTHER USER WHO
C     WANTS TO ABSTRACT DATA FROM THAT TAPE.
C
C
C+    PROGRAM RDBASE
C
C     THIS FORTRAN PROGRAM READS THE UNFORMATTED OUTPUT FILE INP1
C     (FORTRAN UNIT 15) GENERATED BY DATABASE MODULE
C
C     (1) GRID POINTS DATA ARE READ AND SAVED IN GRID-ARRAY
C     (2) ELEMENTS DATA ARE READ AND SAVED IN ELM-ARRAY,
C         WITH ELEMENT NAMES AND POINTERS IN SAVE-ARRAY
C     (3) DISPLACEMENTS (VELOCITIES, ACCELERATIONS, LOADS, GRID-POINT
C         FORCE, OR EIGENVECTORS) DATA ARE READ AND SAVED IN DIS-ARRAY,
C         WITH SUBASES AND POINTERS IN SAVD-ARRAY
C
C     TO READ ELEMENT FORCES OR ELEMENT STRESSES, (3) ABOVE NEEDS SOME
C     CHANGES. PARTICULARLY WE NEED THE INFORMATION IN CODE TO GIVE US
C     THE TYPE OF EACH DATA WORD IN THE DATA LINE.
C     ASSUME CODE(1) = 11222222
C            CODE(2) = 31222000
C     THIS MEANS
C            THE 1ST, 2ND, AND 10TH DATA WORDS ARE INTEGERS;
C            9TH DATA WORD IS BCD; AND
C            3RD THRU 8TH, 11TH, 12TH AND 13TH WORDS ARE REAL NUMBERS
C
C
C     ANY OF ABOVE 3 SETS OF DATA NEED NOT EXIST IN ORIGINAL INP1 FILE
C
C     WRITTEN BY G.CHAN/UNISYS, JAN. 1989
C
C+    IMPLICIT INTEGER (A-Z)
C+    INTEGER          GRID(5,500),ELM(35,300),DIS(11200),SAVE(4,10),
C+   1                 SAVD(3,20),NAME(2),TITLE(32),SUBTTL(32),
C+   2                 LABL(32),CODE(6)
C+    REAL             GRIR(5,1),RIS(1),FREQ
C+    DOUBLE PRECISION GED,GD,EL,DS,ENDD,COORD
C+    EQUIVALENCE      (GRID(1),GRIR(1)),(DIS(1),RIS(1))
C+    DATA             INTAP, NOUT, MAXGRD, MAXELM, MAXDIS, MAXWDS    /
C+   1                 15,    6,    500,    300,    11200,  35        /
C+    DATA             GD,         EL,         DS,          END1      /
C+   1                 8HGRID PTS, 8HELEMENTS, 8HDISPLCNT,  4H -EN    /
C
C+    REWIND INTAP
C
C     READ DATA IDENTICATION RECORD
C
C+ 10 READ (INTAP,END=500) GED
C+    IF (NOUT .EQ. 6) WRITE (NOUT,20) GED
C+ 20 FORMAT (1X,A8,'--------')
C+    IF (GED .EQ. GD) GO TO 100
C+    IF (GED .EQ. EL) GO TO 200
C+    IF (GED .EQ. DS) GO TO 310
C+    STOP 'DATA TYPE UNKNOWN'
C
C     PROCESS GRID DATA
C     =================
C
C     READ GRID POINT DATA, ONE LONG RECORD OF MIXED INTEGERS AND REALS
C
C+100 READ (INTAP,END=500) L,(GRID(J,1),J=1,L)
C+    IF (NOUT .NE. 6) GO TO 10
C+    NGRID = L/5
C+    IF (NGRID .GT. MAXGRD) STOP 'GRID DIMENSION TOO SMALL'
C+    WRITE  (NOUT,110) NGRID
C+110 FORMAT (1X,I8,'=TOTAL NO. OF GRID POINTS')
C+    DO 130 I = 1,NGRID
C+    WRITE (NOUT,120) GRID(1,I),GRID(2,I),GRIR(3,I),GRIR(4,I),GRIR(5,I)
C+120 FORMAT (1X,2I8,3(1P,E12.5))
C+130 CONTINUE
C+    GO TO 10
C
C     PROCESS ELEMENT DATA
C     ====================
C
C+200 JS = 0
C+    JE = 0
C+
C+    READ ELEMENT HEADER RECORD, 8 WORDS
C+
C+210 READ (INTAP,END=500) NAME,TYPE,SYMBOL,GRIDS,TOTAL,WDS,LINE
C+    IF (NAME(1).EQ.END1 .AND. TYPE.EQ.0) GO TO 250
C+    IF (WDS .GT. MAXWDS) STOP 'ELM ROW DIMENSION TOO SMALL'
C+    IF (JE  .GT. MAXELM) STOP 'ELM COL DIMENSION TOO SMALL'
C+    JB = JE + 1
C+    JE = JE + TOTAL
C
C     READ ELEMENT DATA, ONE LONG RECORD PER ELEMENT TYPE (ALL INTEGERS)
C
C+    READ (INTAP) ((ELM(I,J),I=1,WDS),J=JB,JE)
C+    JS = JS + 1
C+    IF (JS .GE. 10) STOP 'SAVE DIMENSION TOO SMALL'
C
C     SAVE ELEMENT NAMES AND BEGINNING POINTERS IN SAVE-ARRAY
C     FOR EASY IDENTIFICATION
C
C+    SAVE(1,JS) = NAME(1)
C+    SAVE(2,JS) = NAME(2)
C+    SAVE(3,JS) = JB
C+    SAVE(4,JS) = WDS
C+    IF (NOUT .NE. 6) GO TO 210
C+    WRITE  (NOUT,220) NAME,TYPE,SYMBOL,GRIDS,TOTAL,WDS,LINE
C+220 FORMAT (1X,'ELEMNT =',2A4,'  TYPE =',I4,2X,A2,' GRIDS =',I8,
C+   1           ' TOTAL =',I8,' WDS/EL=',I8,      ' LINE  =',I8)
C+    DO 240 J = JB,JE
C+    WRITE  (NOUT,230) (ELM(I,J),I=1,WDS)
C+230 FORMAT (1X,3I8,13I8, /,(1X,8X,15I8))
C+240 CONTINUE
C+    GO TO 210
C
C     WRAP UP SAVE-ARRAY
C
C+250 JS = JS + 1
C+    SAVE(1,JS) = END1
C+    SAVE(2,JS) = NAME(2)
C+    SAVE(3,JS) = JE + 1
C+    SAVE(4,JS) = 0
C+    IF (NOUT .NE. 6) GO TO 10
C+    WRITE (NOUT,260)
C+    WRITE (NOUT,270) ((SAVE(I,J),I=1,4),J=1,JS)
C+260 FORMAT (/30X,'THIS REFERENCE TABLE IS NOT PART OF INPUT FILE')
C+270 FORMAT (40X,2A4,3H @ ,I4,',  WORDS=',I3)
C+    GO TO 10
C
C     PROCESS DISPLACEMENT DATA
C     =========================
C
C
C+300 STOP 'ERROR IN READING DISPLACEMENT DATA'
C+
C+310 KB = 1
C+    KS = 0
C
C     READ DISPLACEMENT HEADER RECORD
C
C+320 KS = KS + 1
C+    IF (KS .GT. 20) STOP 'SAVD DEMINSION TOO SMALL'
C+    READ (INTAP,END=390) CASE,FREQ,NWDS,NAME,COORD,CODE,TITLE,SUBTTL,
C+                         LABEL
C+    IF (CASE+NWDS .EQ. 0) GO TO 390
C+    IF (NOUT      .NE. 6) GO TO 340
C+    WRITE  (NOUT,330) CASE,FREQ,NWDS,NAME,COORD,CODE(1),CODE(2),TITLE,
C+                      SUBTTL,LABEL
C+330 FORMAT ('  CASES =',I8,1P,E12.5,' WORDS =',I8,' INPUT =',2A4,
C+   1        '  COORD =',A8,'  CODE = ',2I8, /,(1X,32A4))
C
C     DISPLACEMENT RECORS HAVE EITHER 8 OR 14 WORDS EACH DATA POINT
C     WITH CODE(1)=11222222, CODE(2) THRU (6) ARE ZEROS.
C
C
C     ------------------------------------------------------------------
C     IF ELEMENT STRESS OR ELEMENT FORCE FILE IS READ HERE, NWDS IS A
C     VARIABLE, NOT NECESSARY 8 OR 14. ALL INTEGERS ARE IN 2A4 FORMAT
C     (8-DIGITS), ALL REAL NUMBERS IN 3A4 (12-DIGITS), AND BCD WORD IN
C     A4 (4-LETTERS). THERE ARE NA4 A4-WORDS FOR EACH ELEMENT THAT HOLD
C     NWDS DATA VALUES.  MAXIMUM RECORD LENGTH IS 132 COLUMNS. ONE OR
C     MORE RECORDS ARE NEEDED PER ELEMENT. LAST DATA VALUE OF A RECORD
C     MAY SPILL INTO NEXT RECORD. NA4 IS THE 6TH WORD OF CODE. THE DATA
C     TYPE OF THIS RECORD IS DESCRIBED IN CODE. 1 FOR INTEGER, 2 FOR
C     REAL NUMBER, AND 3 FOR A BCD WORD. THERE ARE 5 CODE WORDS, EACH
C     HOLDS 8 DIGITS, AND ARE ARRANGED FROM LEFT TO RIGHT.
C
C     FOR EXAMPLE -
C     CODE(1)=12212222, CODE(2)=22213200, CODE(3)=CODE(4)=CODE(5)=0
C     INDICATE
C     DATA VALUES 1, 4 AND 12 ARE INTEGERS, DATA VALUE 13 IS ABCD WORD,
C     THE REST ARE REAL NUMBERS.
C     IN THIS EXAMPLE, NWDS SHOULD BE 14,
C                      NA4  SHOULD = 3X2 + 10X3 + 1X1 = 37.
C     2 RECORDS ARE NEEDED, 1ST RECORD 132 CHARACTERS LONG, 2ND RECORD
C     16 CHARACTERS. THESE TWO RECORDS CAN BE READ BY ONE FORTRAN LINE
C
C         READ (INTAP,10) (SS(J),J=1,NA4)
C     10  FORMAT (33A4)                        OR BY
C
C         READ (INTAP,20) IS(1),RS(2),RS(3),IS(4),(RS(J),J=5,11),IS(12)
C         READ (INTAP,30) IS(13),RS(14)
C     20  FORMAT (I8,2F12.0,I8,7F12.0,I8)
C     30  FORMAT (A4,F12.0)
C     ------------------------------------------------------------------
C
C+340 IF (NWDS.NE.8 .AND. NWDS.NE.14) STOP 'WORD COUNT ERROR'
C+    IF (CODE(1) .NE. 11222222) STOP 'FORMAT CODE ERROR'
C
C     SAVE SUBCASE NUMBER AND BEGINNING POINTERS IN SAVD-ARRAY
C     FOR EASY IDENTIFICATION
C
C+    KBM1 = KB - 1
C+    SAVD(1,KS) = CASE
C+    SAVD(2,KS) = KB
C+    SAVD(3,KS) = NWDS
C
C     READ DISPLACEMENT RECORD, ONE LONG RECORD PER SUBCASE (OR FREQ.)
C     EACH GRID POINT DISPLACEMENT DATA IN EVERY 8 OR 14 WORDS,
C     2 INTEGERS + 6 (OR 12) REALS
C
C+350 READ (INTAP,ERR=300) L,(DIS(I+KBM1),I=1,L)
C+    KE = L + KBM1
C+    DO 380 K = KB,KE,NWDS
C+    WRITE (NOUT,360) DIS(K),DIS(K+1),(RIS(K+I),I=2, 7)
C+    IF (NWDS .EQ. 14) WRITE (NOUT,370) (RIS(K+I),I=8,13)
C+360 FORMAT (1X,2I8,6(1P,E12.5))
C+370 FORMAT (1X,16X,6(1P,E12.5))
C+380 CONTINUE
C+    KB = KE + 1
C+    GO TO 320
C
C     WRAP UP SAVD-ARRAY
C
C+390 SAVD(1,KS) = 0
C+    SAVD(2,KS) = KE + 1
C+    SAVD(3,KS) = 0
C+    IF (NOUT .NE. 6) GO TO 10
C+    WRITE (NOUT,260)
C+    WRITE (NOUT,400) (SAVD(1,K),SAVD(2,K),SAVD(3,K),K=1,KS)
C+400 FORMAT (40X,'CASE',I8,3H @ ,I4,',  WORDS=',I4)
C+    GO TO 10
C
C+500 REWIND INTAP
      END

      SUBROUTINE GRIDIP (GRID,SEQSS,LEN,IPSET,CSET,NO,Z,LLOC)
C
C     THIS SUBROUTINE FINDS SETS OF IP NUMBERS AND DEGREE OF FREEDOM
C     COMPONENT NUMBERS FOR GRID POINTS DEFINED IN A BASIC
C     SUBSTRUCTURE THAT IS A COMPONENT OF A PSEUDO-STRUCTURE.
C
C     ARGUMENTS
C               GRID   - GRID POINT ID NUMBER
C               SEQSS  - THE STARTING ADDRESS IN OPEN CORE OF THE
C                        PSEUDO-STRUCTURE EQSS RECORD
C               LEN    - LENGTH OF THE EQSS
C               IPSET  - THE SET OF IP NUMBERS FOR GRID
C               CSET   - COMPONENTS OF GIVEN IP NUMBER
C               NO     - THE NUMBER OF IP DEFINED BY GRID
C
C
      EXTERNAL ORF,RSHIFT
      INTEGER  ORF,RSHIFT,GRID,SEQSS,IPSET(6),CSET(6),POSNO,Z(1)
      COMMON  /CMBFND/ INAM(2),IERR
C
      IERR = 0
      NENT = LEN/3
C
C     SEARCH FOR THE GRID ID IN THE EQSS
C
C     NOTE --- FOR RAPID LOCATION OF ALL IP FOR A GIVEN GRID,
C              THE COMPONENT WORD OF THE EQSS HAS HAD ITS FIRST
C              SIX BITS PACKED WITH A CODE-  THE FIRST THREE
C              BITS GIVE THE NUMBER OF THE IP AND THE SECOND
C              THREE THE TOTAL NO. OF IP.  E.G. 011101 MEANS
C              THE CURRENT IP IS THE THIRD OF FIVE FOR THIS
C              GRID ID.
C
C
      CALL BISLOC (*30,GRID,Z(SEQSS),3,NENT,LOC)
      K = SEQSS + LOC - 1
      ICODE = RSHIFT(Z(K+2),26)
C
C     ICODE CONTAINS SIX BIT CODE
C
      POSNO = ICODE/8
      NOAPP = ICODE - 8*POSNO
C
C     POSNO IS THE POSITION NUMBER OF THE GRID WE HAVE FOUND,
C     NOAPP IS THE TOTAL NUMBER OF APPEARANCES OF THAT GRID.
C
      IF (NOAPP .EQ. 0) POSNO = 1
      IF (NOAPP .EQ. 0) NOAPP = 1
      ISTART = K - 3*(POSNO-1)
      LLOC = ISTART
C
C     PICK UP RIGHT 26 BITS BY MASK26 FOR CSET(I), INSTEAD OF R/LSHIFT
C
      MASK26 = MASKN(26,0)
C
      DO 20 I = 1,NOAPP
      KK = ISTART + 3*(I-1)
      IPSET(I) = Z(KK+1)
      CSET(I)  = ORF(Z(KK+2),MASK26)
   20 CONTINUE
C
      NO = NOAPP
      GO TO 40
   30 IERR = 1
   40 RETURN
      END

      SUBROUTINE EMGCNG
C
C     THIS ROUTINE OF THE -EMG- MODULE READS -CNGRNT- CARD
C     IMAGES, IF ANY, FROM GEOM2 AND BUILDS A PAIRED LIST.
C
C     ON EACH -CNGRNT- DATA CARD THE  FIRST ID (NEED NOT BE THE SMALLEST
C     ID) BECOMES THE PRIMARY ID.  THIS ID WILL BE PAIRED WITH A ZERO
C     NOW AND A NEGATIVE DICTIONARY-TABLE  ADDRESS LATER.  AS SOME OF
C     THE ID-S APPEARING ON THE -CNGRNT- DATA CARD MAY NOT EVEN BE IN
C     THE PROBLEM, THE FIRST ID OF A CONGRUENT GROUP REFERENCED WILL
C     RESULT IN THE ELEMENT COMPUTATIONS AND THE SETTING OF A DICTIONARY
C     FILE TABLE ADDRESS WITH THE PRIMARY ID.
C
      LOGICAL         ANYCON, ERROR, HEAT
      INTEGER         Z, GEOM2, SYSBUF, BUF, SUBR(2), CNGRNT(2), EST,
     1                CSTM, DIT, DICTN, RD, WRT, WRTREW, RDREW, CLS,
     2                CLSREW, PRECIS, FLAG, FLAGS
      CHARACTER       UFM*23, UWM*25
      COMMON /XMSSG / UFM, UWM
      COMMON /SYSTEM/ KSYSTM(65)
      COMMON /NAMES / RD, RDREW, WRT, WRTREW, CLSREW, CLS
      COMMON /EMGFIL/ EST, CSTM, MPT, DIT, GEOM2, MATS(3), DICTN(3)
      COMMON /EMGPRM/ ICORE, JCORE, NCORE, ICSTM, NCSTM, IMAT, NMAT,
     1                IHMAT, NHMAT, IDIT, NDIT, ICONG, NCONG, LCONG,
     2                ANYCON, FLAGS(3), PRECIS, ERROR, HEAT,
     3                ICMBAR, LCSTM, LMAT, LHMAT
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE     (KSYSTM(1), SYSBUF), (KSYSTM(2), NOUT)
      DATA    SUBR  / 4HEMGC,  4HNG  /, NOEOR / 0 /, CNGRNT / 5008,50 /
C
      BUF = NCORE - SYSBUF - 2
      IF (BUF .LE. JCORE) CALL MESAGE (-8,JCORE-BUF,SUBR)
      ANYCON= .FALSE.
      ICONG = JCORE
      NCONG = JCORE - 1
      LCONG = 0
C
C     LOCATE -CNGRNT- BULK DATA CARDS IF ANY.
C
      CALL PRELOC (*90,Z(BUF),GEOM2)
      CALL LOCATE (*80,Z(BUF),CNGRNT,FLAG)
C
C     PROCESS ONE DATA CARD
C
   10 IF (NCONG+2 .GE. BUF) GO TO 35
      CALL READ (*40,*40,GEOM2,Z(NCONG+1),1,NOEOR,IWORDS)
      Z(NCONG+2) = 0
      IDPRIM = Z(NCONG+1)
      NCONG  = NCONG + 2
C
C     READ ANY SECONDARY IDS.
C
   20 IF (NCONG+2 .GE. BUF) GO TO 35
      CALL READ (*40,*40,GEOM2,Z(NCONG+1),1,NOEOR,IWORDS)
C
C     CHECK FOR THE FOLLOWING CONDITION
C
C     CONDITION 1
C     ------------
C
C     A SECONDARY ID ON THIS CARD IS THE SAME AS THE PRIMARY ID
C     ON THIS CARD.  THE SECONDARY ID IS IGNORED AND THE CONDITION
C     IS INDICATED BY A USER INFORMATION MESSAGE.
C
      IF (Z(NCONG+1).NE.IDPRIM) GO TO 25
C
C     THE ABOVE CONDITION EXISTS
C
      CALL PAGE2 (3)
      WRITE (NOUT,2010) UWM,IDPRIM
      GO TO 20
C
   25 IF (Z(NCONG+1)) 10,20,30
   30 Z(NCONG+2) = IDPRIM
      NCONG = NCONG + 2
      GO TO 20
C
C     INSUFFICIENT CORE TO PROCESS ALL -CNGRNT- CARDS
C
   35 ICRQ = NCONG + 2 - BUF
      CALL PAGE2 (2)
      WRITE (NOUT,2050) UWM,ICRQ
C
C     NO MORE -CNGRNT- CARDS
C
   40 LCONG = NCONG - ICONG + 1
      IF (LCONG .LE. 0) GO TO 80
      CALL SORT (0,0,2,1,Z(ICONG),LCONG)
C
C     CHECK FOR THE FOLLOWING ADDITIONAL CONDITIONS
C
C     CONDITION 2
C     -----------
C
C     A PRIMARY ID ON A CNGRNT CARD IS ALSO USED AS A SECONDARY
C     ID ON ANOTHER CNGRNT CARD.  THIS RESULTS IN A USER FATAL
C     MESSAGE.
C
C     CONDITION 3
C     -----------
C
C     A SECONDARY ID IS SPECIFIED AS CONGRUENT TO MORE THAN ONE
C     PRIMARY ID.  THIS ALSO RESULTS IN A USER FATAL MESSAGE.
C
C     CONDITION 4
C     -----------
C
C     A SECONDARY ID IS REDUNDANTLY SPECIFIED.  THE REDUNDANCIES ARE
C     IGNORED AND THE CONDITION IS INDICATED BY A USER INFORMATION
C     MESSAGE.
C
      NOGO   = 0
      NCONG1 = NCONG - 2
      DO 440 I = ICONG,NCONG1,2
      IF (Z(I  ) .NE. Z(I+2)) GO TO 440
      IF (Z(I+1) .EQ. Z(I+3)) GO TO 440
      NOGO = 1
      IF (Z(I+1).NE.0 .AND. Z(I+3).NE.0) GO TO 420
C
C     THIS IS CONDITION 2 DESCRIBED ABOVE
C
      WRITE (NOUT,2020) UFM,Z(I)
      GO TO 440
C
C     THIS IS CONDITION 3 DESCRIBED ABOVE
C
  420 WRITE (NOUT,2030) UFM,Z(I)
C
  440 CONTINUE
      IF (NOGO .EQ. 1) CALL MESAGE (-37,0,SUBR)
      NCONG2 = NCONG1
      DO 480 I = ICONG,NCONG1,2
      IF (Z(I) .LT.      0) GO TO 480
      IF (Z(I) .NE. Z(I+2)) GO TO 480
      J = I + 2
  450 DO 460 K = J,NCONG2,2
      Z(K  ) = Z(K+2)
      Z(K+1) = Z(K+3)
  460 CONTINUE
      LCONG = LCONG - 2
      NCONG = NCONG - 2
      Z(NCONG2-1) = -1
      NCONG2 = NCONG2 - 2
      IF (Z(J) .EQ. Z(I)) GO TO 450
      IF (Z(I+1) .EQ.  0) GO TO 480
C
C     THIS IS CONDITION 4 DESCRIBED ABOVE
C
      CALL PAGE2 (2)
      WRITE (NOUT,2040) UWM,Z(I)
C
  480 CONTINUE
C
C     REPLACE PRIMARY ID ASSOCIATED WITH EACH SECONDARY ID
C     WITH LOCATION OF PRIMARY ID IN TABLE.
C
      LNUM   = LCONG / 2
      ICONGZ = ICONG - 1
      DO 60 I = ICONG,NCONG,2
      IF (Z(I+1)) 50,60,50
   50 KID = Z(I+1)
      CALL BISLOC (*60,KID,Z(ICONG),2,LNUM,J)
      Z(I+1) = ICONGZ + J
   60 CONTINUE
C
C     TABLE IS COMPLETE
C
   80 CALL CLOSE (GEOM2,CLSREW)
      IF (NCONG .GT. ICONG) ANYCON = .TRUE.
      JCORE = NCONG + 1
   90 RETURN
C
C
 2010 FORMAT (A25,' 3169, PRIMARY ID',I9,' ON A CNGRNT CARD ALSO USED ',
     1       'AS A SECONDARY ID ON THE SAME CARD.', /5X,
     3       'SECONDARY ID IGNORED.')
 2020 FORMAT (A23,' 3170, PRIMARY ID',I9,' ON A CNGRNT CARD ALSO USED ',
     1       'AS A SECONDARY ID ON ANOTHER CNGRNT CARD.')
 2030 FORMAT (A23,' 3171, SECONDARY ID',I9,
     1       ' SPECIFIED AS CONGRUENT TO MORE THAN ONE PRIMARY ID.')
 2040 FORMAT (A25,' 3172, SECONDARY ID',I9,' REDUNDANTLY SPECIFIED ON ',
     1       'CNGRNT CARDS.  REDUNDANCY IGNORED.')
 2050 FORMAT (A25,' 3182, INSUFFICIENT CORE TO PROCESS ALL CNGRNT ',
     1       'CARDS.  ADDITIONAL CORE NEEDED =',I8,7H WORDS.)
C
      END

      SUBROUTINE DETCKX( JARG, IFGPST, NPVT )
C*****
C THIS ROUTINE GENERATES THE GRID POINT SINGULARITY TABLE BY EXAMINING
C THE TRANSLATIONAL AND DIAGONAL 3 X 3 SUBMATRICES OF THE KGG MATRIX.
C IF JARG = 0, THE PIVOT POINT HAS ELEMENTS ATTACHED TO IT.
C IF JARG =-1, THE PIVOT IS A SCALAR POINT AND NO ELEMENTS ARE
C CONNECTED TO IT.
C IF JARG = 1, THE PIVOT POINT IS A GRID POINT AND NO ELEMENTS ARE
C CONNECTED TO IT.
C*****
      DOUBLE PRECISION
     1                   DZ(1)              ,B(9)
     2,                  FL(3)              ,M(3)
     3,                  R(3)               ,TEMP
     4,                  FM                 ,FR
     5,                  DET                ,CONST
     6,                  DTOL               ,D(18)
C
      INTEGER
     1                   TNWDS              ,IARRAY(8)
     2,                  IZ(1)              ,BACK
     3,                  NAME(2)
C
      COMMON /MA1XX / D, B, DZ, FL, R, M
      COMMON /SYSTEM/ ISYS(69),TOLEL,SDUM(10)
C
C
      EQUIVALENCE
     1                   (IZ(1),DZ(1))      ,(IARRAY(1),IORDER)
     2,                  (IARRAY(2),NWDS)
C
C
C
      DATA  NEOR/ 0 /
      DATA NAME / 4HDETC,4HKX   /
C
      DTOL = TOLEL
      IARG = JARG
      IF (IARG) 35,10,52
   35 IORDER = 1
      NWDS = 1
      IARRAY(3) = NPVT
      CALL WRITE (IFGPST,IARRAY(1),3,NEOR)
      RETURN
C
C AT THIS POINT, BOTH TRANSLATIONAL AND ROTATIONAL DIAGONAL 3X3 S ARE
C STORED IN THE D ARRAY.  HENCE WE PROCESS THEM.
C
   10 CONTINUE
   52 CONTINUE
      IP = NPVT - 1
      ASSIGN 450 TO IGOTO
      IF (IARG .NE. 1) GO TO 55
      ASSIGN 425 TO BACK
      GO TO 425
   55 ASSIGN 70 TO BACK
      DO 60 I = 1,9
   60 B(I) = D(I)
      GO TO 90
   70 DO 80 I = 1,9
   80 B(I) = D(I+9)
C
C INSURE THE SYMMETRY OF THE B MATRIX
C
      IF (B(2) .NE. 0.0D0 .AND. B(4) .NE. 0.0D0) GO TO 82
      B(2) = 0.0D0
      B(4) = 0.0D0
      GO TO 83
   82 TEMP = (B(2) + B(4)) / 2.0D0
      B(2) = TEMP
      B(4) = TEMP
   83 IF (B(3) .NE. 0.0D0 .AND. B(7) .NE. 0.0D0) GO TO 84
      B(3) = 0.0D0
      B(7) = 0.0D0
      GO TO 85
   84 TEMP = (B(3) + B(7)) / 2.0D0
      B(3) = TEMP
      B(7) = TEMP
   85 IF (B(6) .NE. 0.0D0 .AND. B(8) .NE. 0.0D0) GO TO 86
      B(6) = 0.0D0
      B(8) = 0.0D0
      GO TO 90
   86 TEMP = (B(6) + B(8)) / 2.0D0
C
C SCALE THE MATRIX BY DIVIDING EACH ELEMENT OF B BY THE LARGEST ELEMENT.
C IF THE LARGEST ELEMENT IS NON-POSITIVE, THE SINGULARITY IS OF ORDER 3.
C
   90 TEMP = B(1)
      DO 100 I = 2,9
      IF (B(I) .GT. TEMP) TEMP = B(I)
  100 CONTINUE
      IF (TEMP .LE. 0.0D0) GO TO 425
      DO 110 I = 1,9
  110 B(I) = B(I) / TEMP
C
C FIND THE SQUARES OF THE MAGNITUDES OF THE VECTORS OF THE ROWS OF THE
C B MATRIX.
C
      IORDER = 0
      J = 0
      DO 120 I = 1,9,3
      J = J + 1
      FL(J) = B(I)**2 + B(I+1)**2 + B(I+2)**2
      IF (FL(J) .EQ. 0.0D0) IORDER = IORDER + 1
  120 CONTINUE
      IF (IORDER .EQ. 2)  GO TO 410
      IF (IORDER .EQ. 0)  GO TO 250
C
C AT THIS POINT ONE AND ONLY ONE FL(I) IS ZERO.
C
      DO 130 I = 1,3
      ISAVE = I
      IF (FL(I) .EQ. 0. 0D0) GO TO (140,150,160), ISAVE
  130 CONTINUE
      CALL MESAGE (-30,26,NAME)
  140 FM = B(5) * B(9)  -  B(6) * B(8)
      FR = DSQRT( (B(5)**2  +  B(6)**2)  *  (B(8)**2  +  B(9)**2) )
      GO TO 170
  150 FM = B(1) * B(9)  -  B(3) * B(7)
      FR = DSQRT( (B(1)**2  +  B(3)**2)  *  (B(7)**2  +  B(9)**2) )
      GO TO 170
  160 FM = B(1) * B(5)  -  B(2) * B(4)
      FR = DSQRT( (B(1)**2  +  B(2)**2)  *  (B(4)**2  +  B(5)**2) )
  170 IF( FM .EQ. 0.0D0 ) GO TO 171
      IF( FR .LE. 0.0D0 ) GO TO 240
      IF ( FM/FR .GE. DTOL ) GO TO 240
C
C HERE WE HAVE THAT THE ORDER OF THE SINGULARITY IS 2.
C
  171 IORDER = 2
      NWDS   = 0
      TNWDS  = 2
      GO TO (180,190,200), ISAVE
  180 K1   = 5
      K2   = 9
      INC1 = 1
      INC2 = 3
      INC3 = 2
      GO TO 210
  190 K1   = 1
      K2   = 9
      INC1 = 2
      INC2 = 3
      INC3 = 1
      GO TO 210
  200 K1   = 1
      K2   = 5
      INC1 = 3
      INC2 = 2
      INC3 = 1
  210 IF (B(K1) .LE. 0.0D0  .AND.  B(K2) .LE. 0.0D0) GO TO 425
      IF (B(K1) .LE. 0.0D0) GO TO 220
      NWDS      = 2
      TNWDS     = 4
      IARRAY(3) = IP + INC1
      IARRAY(4) = IP + INC2
      IPOINT    = 5
      GO TO 230
  220 IPOINT = 3
  230 IF (B(K2) .LE. 0.0D0) GO TO 430
      NWDS = NWDS + 2
      TNWDS = TNWDS + 2
      IARRAY(IPOINT)   = IP + INC1
      IARRAY(IPOINT+1) = IP + INC3
      GO TO 430
C
C AT THIS POINT WE HAVE THAT ONE AND ONLY ONE FL IS ZERO BUT THAT ORDER
C OF THE SINGULARITY IS 1.
C
  240 IORDER    = 1
      NWDS      = 1
      TNWDS     = 3
      IARRAY(3) = IP + ISAVE
      GO TO 430
C
C AT STATEMENT NO. 250, WE HAVE THAT ALL THE FL(I) ARE .GT. 0.0D0, SO
C THAT THE DETERMINANT, DET, OF B MUST BE COMPUTED.
C
  250 DET = B(1) * ( B(5)*B(9) - B(6)*B(8) )
     1    - B(2) * ( B(4)*B(9) - B(6)*B(7) )
     2    + B(3) * ( B(4)*B(8) - B(5)*B(7) )
      CONST = 0.05D0*DTOL * FL(1) * FL(2) * FL(3)
      IF (DET .GT. CONST) GO TO 440
C
C COMPUTE M(I) AND R(I)
C
      M(1) = B(5) * B(9) - B(6) * B(8)
      M(2) = B(1) * B(9) - B(3) * B(7)
      M(3) = B(1) * B(5)  -  B(2) * B(4)
      R(1) =   DSQRT ( B(5)**2 + B(6)**2 )
     1       * DSQRT ( B(8)**2 + B(9)**2 )
      R(2) =   DSQRT ( B(1)**2 + B(3)**2 )
     1       * DSQRT ( B(7)**2 + B(9)**2 )
      R(3) =   DSQRT ( B(1)**2 + B(2)**2 )
     1       * DSQRT ( B(4)**2 + B(5)**2 )
C
C FIND I1,J1,K1 SUCH THAT M(I1)/R(I1) .GE. M(J1)/R(J1) .GE. M(K1)/R(K1)
C
      I1 = 1
      J1 = 2
      K1 = 3
      IF (M(1)*R(2).GE.M(2)*R(1)) GO TO 270
      I1 = 2
      J1 = 1
  270 IF (M(I1)*R(K1).GE.M(K1)*R(I1)) GO TO 280
      ITEMP = I1
      I1    = K1
      K1    = ITEMP
  280 IF (M(J1)*R(K1).GE.M(K1)*R(J1)) GO TO 290
      ITEMP = J1
      J1    = K1
      K1 = ITEMP
  290 IF (M(I1).GE.R(I1)*DTOL) GO TO 400
C
C HERE THE SINGULARITY IS OF ORDER 2.
C
      NWDS   = 0
      TNWDS  = 2
      IORDER = 2
C
C FIND II, JJ, KK SUCH THAT B(II) .GE. B(JJ) .GE. B(KK)
C
      II = 1
      JJ = 5
      KK = 9
      IF (B(1) .GE. B(5)) GO TO 300
      II = 5
      JJ = 1
  300 IF (B(II) .GE. B(KK)) GO TO 310
      ITEMP = II
      II    = KK
      KK    = ITEMP
  310 IF (B(JJ) .GE. B(KK)) GO TO 320
      ITEMP = JJ
      JJ    = KK
      KK    = ITEMP
  320 LL    = II
      KOUNT = 0
      IPOINT= 3
  330 IF (B(LL) .LE. 0.0D0) GO TO 430
      NWDS  = NWDS + 2
      TNWDS = TNWDS + 2
      IF (LL - 5) 340,350,360
  340 INC1 = 2
      INC2 = 3
      GO TO 370
  350 INC1 = 1
      INC2 = 3
      GO TO 370
  360 INC1 = 1
      INC2 = 2
  370 IARRAY(IPOINT)   = IP + INC1
      IARRAY(IPOINT+1) = IP + INC2
      IPOINT = IPOINT + 2
      KOUNT  = KOUNT  + 1
      IF (KOUNT - 2) 380,390,430
  380 LL = JJ
      GO TO 330
  390 LL = KK
      GO TO 330
C
C AT THIS POINT THE SINGULARITY IS OF ORDER 1.
C
  400 IORDER = 1
      NWDS   = 1
      TNWDS  = 3
      IARRAY(3) = IP + I1
      IF (M(J1).LT.R(J1)*DTOL) GO TO 430
      NWDS  = 2
      TNWDS = 4
      IARRAY(4) = IP + J1
      IF (M(K1).LT.R(K1)*DTOL) GO TO 430
      NWDS  = 3
      TNWDS = 5
      IARRAY(5) = IP + K1
      GO TO 430
C
C AT THIS POINT 2 ROWS OF THE B MATRIX ARE IDENTICALLY ZERO.
C
  410 NWDS   = 2
      TNWDS  = 4
      IPOINT = 2
      DO 420 I = 1,3
      IF (FL(I) .NE. 0.0D0) GO TO 420
      IPOINT = IPOINT + 1
      IARRAY(IPOINT) = IP + I
  420 CONTINUE
      GO TO 430
C
C THE SINGULARITY IS OF ORDER 3
C
  425 IORDER = 3
      NWDS   = 3
      TNWDS  = 5
      IARRAY(3) = IP + 1
      IARRAY(4) = IP + 2
      IARRAY(5) = IP + 3
C
C WRITE IARRAY ON THE GPST FILE.
C
  430 CALL WRITE (IFGPST,IARRAY(1),TNWDS,NEOR)
  440 GO TO IGOTO, (450,460)
  450 ASSIGN 460 TO IGOTO
      IP = IP + 3
      GO TO BACK, (70,425)
  460 CONTINUE
      RETURN
      END

      SUBROUTINE DBMFDP
C********************************************************************
C     DBMFDP- DUMPS THE DIRECTORY CHAIN OF A GIVEN FILE.
C             ARGUMENT IDIR IS THE IN-MEMORY DIRECTORY FOR THE FILE
C********************************************************************
      COMMON / SYSTEM / ISYSBF, IWR
      INCLUDE  'ZZZZZZ.COM'
      INCLUDE  'DSIOF.COM'
      IBASE  = LOCFX( MEM )
      IVAL2  = IBASE + FCB(  9, IFILEX )
      IVAL3  = IBASE + FCB( 10, IFILEX )
      IVAL4  = IBASE + FCB( 11, IFILEX )
      INDEX  = FCB( 10, IFILEX )
      LBLOCK = MEM( INDEX+3 )
      WRITE ( IWR, 902 ) IFILEX, IVAL2, IVAL3, IVAL4, FCB(12,IFILEX)
      WRITE ( IWR, 903 )
      NEXT = FCB(  9, IFILEX )
      ICNT = 0
      IF ( NEXT .EQ. 0 ) GO TO 25
20    ICNT = ICNT + 1
      IF ( NEXT .EQ. 0 ) GO TO 30
      IVAL = IBASE + NEXT
      IVALP= IBASE + MEM(NEXT)
      IVALN= IBASE + MEM(NEXT+1)
      IF ( MEM( NEXT   ) .EQ. 0 ) IVALP = 0
      IF ( MEM( NEXT+1 ) .EQ. 0 ) IVALN = 0
      WRITE ( IWR, 904 )
     &       MEM(NEXT+3),MEM(NEXT+7),IVAL,IVALP,IVALN,MEM(NEXT+2)
990   FORMAT( 12(8(1X,I8),/))
      NEXT = MEM( NEXT+1 )
      GO TO 20
25    WRITE( IWR, 907 )
30    CONTINUE
      WRITE( IWR, 908 )
      RETURN
902   FORMAT(///,25X,' DUMP OF FILE CHAIN FOR UNIT=',I6,/
     &,14X,'( BLOCK ADDRESSES ARE IN WORDS,  BLOCK LENGTHS IN WORDS)',/
     &,/,7X,
     &' FIRST BLOCK ADDRESS   ',I12,'   LAST BLOCK ADDRESS      ',I12
     &,/,7X,
     &' CURRENT BLOCK ADDRESS ',I12,'   ORIGINAL BUFFER ADDRESS ',I12)
903   FORMAT(/,
     & '  IN-MEM     BUFFER',/
     &,' BLOCK NO.  BLOCK NO  BLOCK ADDRESS  PREV. BLOCK   NEXT BLOCK '
     &,' LENGTH')
904   FORMAT( I9,I11,5X,I12,7X,I12,5X,I12,I12)
907   FORMAT(//' *************** NO BLOCK ALLOCATED TO FILE **********')
908   FORMAT(///)
      END

      SUBROUTINE DELKLS (DEL,R,Z,KODE)
C
C     SINGLE PRECISION VERSION USE DELKLS (DEL,R,Z,KODE)
C
C     PURPOSE
C        EVAULATE THE FOLLOWING FUNCTION
C          DELT(K,L) = SURFACE-INTEGRAL((R**K)*(Z**L)) DR*DZ
C        WHERE  DR*DZ  IS EITHER A TRIANGLE OR A TRAPEZOID.
C
C     USAGE
C        WHERE  DEL   =  DOUBLE PRECISION ARRAY OF 15 LOCATIONS.
C                        CONTAINING THE RESULTS.
C        WHERE  R     =  DOUBLE PRECISION ARRAY OF  4 LOCATIONS.
C                        CONTAINING THE R-COORDINATES OF THE ELEM.
C        WHERE  Z     =  DOUBLE PRECISION ARRAY OF  4 LOCATIONS.
C                        CONTAINING THE Z-COORDINATES OF THE ELEM.
C               KODE  =  0  FOR TRIANGULAR  ELEMENT
C               KODE  =  1  FOR TRAPEZOIDAL ELEMENT
C
C     PROCEDURE
C        INFORMATION IS COMPUTED AND STORED AS FOLLOWS.
C           COMPUTED  FOR        ELEMENT         STORED
C        TRIANGLE   TRAPEZOID   DELT(K,L)       DEL(LOC)
C        ************************************************
C           X          X              0,0            01
C           X          X              1,0            02
C           X          X              0,1            03
C           X          X             -1,0            04
C           X          X             -1,1            05
C           X          X             -1,2            06
C                      X              1,1            07
C                      X              1,2            08
C                      X              2,1            09
C                      X              2,0            10
C                      X              0,2            11
C                      X              3,0            12
C                      X              3,1            13
C                      X              3,2            14
C                      X              2,2            15
C
      INTEGER    GOBACK
      REAL       DEL(15),R(4),Z(4),LN
C
C     ZERO ARRAY (ONLY THAT PORTION USING)
C
      N      = 15
      DO 2 L = 1,N
    2 DEL(L) = 0.
C
C     HERE FOR  LINE 1-2
C
      I      = 1
      M      = 2
      ASSIGN 23 TO GO BACK
      GO TO 500
C
C     HERE  FOR  LINE 2-3
C
   23 CONTINUE
      I      = 2
      M      = 3
      ASSIGN 3134 TO GO BACK
      GO TO 500
C
C     HERE  FOR  LINE 31 (TRIANGLE),  LINE 3-4 (TRAP)
C
 3134 CONTINUE
      I      = 3
      IF (KODE .GT. 0) GO TO 35
      M      = 1
      ASSIGN 90 TO GO BACK
      GO TO 500
   35 M      = 4
      ASSIGN 41 TO GO BACK
      GO TO 500
   41 I      = 4
      M      = 1
      ASSIGN 90 TO GO BACK
C
C     BEGIN LOCAL SUBROUTINE  (DEL-KL-I,M)
C
  500 RM     = R(M)
      RI     = R(I)
      R1     = RM - RI
      IF (ABS(R1) .LT. 1.E-5) GO TO 599
C
C     THIS LINE IS NOT PARALLEL TO Z-AXIS
C
      ZM     = Z(M)
      ZI     = Z(I)
      IF (ZI.EQ.0. .AND. ZM.EQ.0.) GO TO 599
C
C     SPECIAL CASE   ZM=ZI=0   THUS ALL  A,B = 0  AND
C     ALL DEL TERMS  = 0 .     THUS SKIP AND SAVE CPU.
C
      A      = (RM*ZI - RI*ZM)/R1
      B      = (ZM - ZI)/R1
      LN     = ALOG(RM/RI)
      SI     = RI * RI
      SM     = RM * RM
      R2     = SM - SI
      SI     = SI * RI
      SM     = SM * RM
      R3     = SM - SI
      SI     = SI * RI
      SM     = SM * RM
      R4     = SM - SI
      SI     = SI * RI
      SM     = SM * RM
      R5     = SM - SI
      A2     = A  * A
      A3     = A  * A2
      B2     = B  * B
      B3     = B  * B2
      AB     = A  * B
      AAB    = A  * AB
      ABB    = B  * AB
      DEL(1) = A*R1 + B*R2/2. + DEL(1)
      DEL(2) = A*R2/2.  +  B*R3/3.  + DEL(2)
      DEL(3) = A2*R1/2. + AB*R2 /2. + B2*R3/6.  + DEL(3)
      DEL(4) = A *LN    +  B*R1     + DEL(04)
      DEL(5) = A2*LN/2. + AB*R1     + B2*R2/4.  + DEL(5)
      DEL(6) = A3*LN/3. + AAB*R1    + ABB*R2/2. + B3*R3/9.  + DEL(6)
      DEL(7) = A2*R2/4. + AB*R3/3.  + B2*R4/8.  + DEL(7)
      DEL(8) = A3*R2/6. + AAB*R3/3. + ABB*R4/4. + B3*R5/15. + DEL(8)
      DEL(9) = A2*R3/6. + AB*R4/4.  + B2*R5/10. + DEL(9)
      DEL(10)= A*R3/3.  +  B*R4/4.  + DEL(10)
      DEL(12)= A*R4/4.  + B*R5/5.   + DEL(12)
      IF (KODE .LT. 1) GO TO 599
      SI     = SI * RI
      SM     = SM * RM
      R6     = SM - SI
      R7     = (SM*RM - SI*RI)
      DEL(11)= A3*R1/3. + AAB*R2/2. + ABB*R3/3. + B3*R4/12. + DEL(11)
      DEL(13)= A2*R4/8. + AB*R5/5.  + B2*R6/12. + DEL(13)
      DEL(14)= A3*R4/12.+ AAB*R5/5. + ABB*R6/6. + B3*R7/21. + DEL(14)
      DEL(15)= A3*R3/9. + AAB*R4/4. + ABB*R5/5. + B3*R6/18. + DEL(15)
  599 GO TO GO BACK, (23,3134,41,90)
C
C     THE ABSOLUTE VALUE IS CHOSEN SO THAT NODES INPUT MAY BE ORDERED
C     CW OR CCW. RESULTS ARE SAME FOR A GIVEN ELEMENT.
C
   90 DO 91 L = 1,N
   91 DEL(L) = ABS(DEL(L))
      RETURN
      END

      SUBROUTINE MBGATE(NTOTE,DPHITE,N,YWTE,Q,Q1,Q2,KTE,KTE1,KTE2)
C
C     SUM ON TRAILING EDGE
C
      LOGICAL CNTRL1,CNTRL2
      DIMENSION YWTE(1),KTE(1),KTE1(1),KTE2(1)
      COMPLEX Q(1),Q1(1),Q2(1),DPHITE(3,N),DPHI
      COMMON /MBOXC/ NJJ ,CRANK1,CRANK2,CNTRL1,CNTRL2
      COMMON /MBOXA/ X(12),Y(12)
      DO   1400   J = 1 , NTOTE
      DPHI  =  DPHITE(1,J) * 0.5 * AMIN0(J,2)
      IF(CNTRL1.AND.YWTE(J).GE.Y(7).AND.YWTE(J).LE.Y(11)) GO TO 1100
      IF(CNTRL2.AND.YWTE(J).GT.Y(11).AND.YWTE(J).LE.Y(12)) GO TO 1150
      ISP=KTE(J)
      Q(ISP) = DPHI
      GO TO 1300
 1100 ISP=KTE1(J)
      Q1(ISP) = DPHI
      GO TO 1300
 1150 ISP=KTE2(J)
      Q2(ISP) = DPHI
 1300 CONTINUE
 1400 CONTINUE
      RETURN
      END

        SUBROUTINE FILPOS ( FILE, IPOS )
        INCLUDE 'DSIOF.COM'
        INCLUDE 'XNSTRN.COM'
        INTEGER    FILE
        NAME  = FILE
        CALL DSGEFL
        NBLOCK = IAND( IPOS, MASKH2 )
        ICBLK  = FCB( 4, IFILEX )
        IF ( ICBLK .EQ. NBLOCK ) GO TO 10
        CALL DBMMGR( 6 )
10      CONTINUE
        INDCLR = IPOS/MULQ2 + INDBAS - 1
        INDCBP = INDCLR
        CALL DSSDCB
        RETURN
        END

      SUBROUTINE GUST2(FOL,WJ,ACPT,X0,V,CSTM,QHJL)
C
C     GUST2 MAKE  WJ(W) MATRIX FOR GUST
C
      INTEGER FOL,WJ,ACPT,CSTM,QHJL,BUF1,FILE
      INTEGER SYSBUF,IZ(1),TRL(7),ACDR(13),NAM(2)
C
      COMMON /CONDAS/ PI,TWOPI
      COMMON /SYSTEM/ SYSBUF
      COMMON /ZZZZZZ/ Z(1)
      COMMON /ZBLPKX/ A(4),IRN
C
      EQUIVALENCE (Z(1),IZ(1))
C
      DATA  NAM /4HGUST,1H2 /
      DATA NHNJU,NHACJ /4HNJU ,4HACJ /
C
      ICORE = KORSZ(IZ) - SYSBUF-2
      BUF1 = ICORE+1
C
C     READ IN FREQUENCYS AND CONVERT TO OMEGA
C
      FILE = FOL
      CALL OPEN(*999,FOL,Z(BUF1),0)
      CALL FREAD(FOL,Z,-2,0)
      CALL READ(*998,*10,FOL,Z,ICORE,0,NFREQ)
      GO TO 997
   10 DO 20 I=1,NFREQ
   20 Z(I) = Z(I) * TWOPI
      CALL CLOSE(FOL,1)
C
C     SPACE FOR COLUMN OF W - 2 * J  LONG  1 J FOR A  1 J FOR COEF.
C
      FILE = QHJL
      TRL(1) =  QHJL
      CALL RDTRL(TRL)
      IF(TRL(1).LT.0) GO TO 999
      NJ = TRL(3)
      JAP= NFREQ
      JCP = JAP + NJ
      IACPT = JCP + NJ + 1
      IF(IACPT.GT.ICORE) GO TO 997
      DO 30 I=1,NJ
   30 Z(JAP+I) = 0.0
C
C     SET UP WJ
C
      TRL(1) = WJ
      TRL(2) = 0
      TRL(3) = NJ
      TRL(4) = 2
      TRL(5) = 3
      TRL(6) = 0
      TRL(7) = 0
C
C     READ ACPT RECORDS BY METHOD AND FILL IN THE TWO COLUMNS
C     A =  COS G (CG) FOR DLB  1 FOR Z BODIES  0 FOR ALL ELSE
C     COEF =   XM  FOR PANELS AND BODIES
C
      CALL GOPEN(ACPT,Z(BUF1),0)
      NJU = 0
      FILE = ACPT
   40 CALL READ(*100,*100,ACPT,METH,1,0,NWR)
      GO TO (50,60,90,90,90), METH
C
C     DOUBLET LATTICE WITHOUT BODIES
C
   50 CALL READ(*998,*995,ACPT,ACDR,4,0,NWR)
      NP = ACDR(1)
      NSTRIP = ACDR(2)
      NJG = ACDR(3)
      NR = 2*NP + 5*NSTRIP + 2*NJG
      IF(IACPT+NR.GT.ICORE) GO TO 997
      CALL READ(*998,*995,ACPT,Z(IACPT),NR,1,NWR)
      IXIC  =  IACPT + 2*NP + 5*NSTRIP - 1
      IDELX =  IXIC + NJG
      ICG   =  IACPT + 2*NP + 4*NSTRIP
      K = 0
      KS= 0
      NBXR = IZ(IACPT)
      DO 59 I = 1,NJG
      Z(JAP+NJU+I)=Z(ICG+KS)
      Z(JCP+NJU+I)=Z(IXIC+I) + .5* Z(IDELX+I)
      IF(I.EQ.NJG) GO TO 59
      IF(I.EQ.IZ(IACPT+NP+K)) K=K+1
      IF(I.NE.NBXR) GO TO 59
      KS = KS+1
      NBXR = NBXR + IZ(IACPT+K)
   59 CONTINUE
      NJU = NJU+NJG
      GO TO 40
C
C     DOUBLET LATTICE WITH BODIES
C
   60 CALL READ(*998,*995,ACPT,ACDR,13,0,NWR)
      NJG = ACDR(1)
      NP  = ACDR(3)
      NB = ACDR(4)
      NTP = ACDR(5)
      NTO = ACDR(10)
      NTZS= ACDR(11)
      NTYS = ACDR(12)
      NSTRIP = ACDR(13)
      IC = IACPT
      IB = IC + NP
      IB1= IB + 2*NP
      IBS= IB1+ 2*NB
      NR = 3*NP + 3*NB
      CALL READ(*998,*995,ACPT,Z(IACPT),NR,0,NWR)
      NBEI = 0
      NBES = 0
      DO 61 I=1,NB
      NBEI= NBEI+ IZ(IB1+I-1)
      NBES= NBES+ IZ(IBS+I-1)
   61 CONTINUE
      ICG = IB+ NP
      IX  = ICG + NSTRIP  -1
      IXS1= IX  + 4*NTP + 2*NBEI + NBES
      IXS2= IXS1+ NBES
      NR = 11*NB + 4*NSTRIP
      CALL READ(*998,*995,ACPT,Z(ICG),-NR,0,NWR)
      NR =  NSTRIP + 4*NTP + 2*NBEI + 3* NBES
      IF(ICG+NR.GT.ICORE) GO TO 997
      CALL READ(*998,*995,ACPT,Z(ICG),NR,1,NWR)
      IF(NTP.EQ.0) GO TO 65
      K= 0
      KS=0
      NBXR = IZ(IC)
      DO 64 I=1,NTP
      Z(JAP+NJU+I)  =  Z(ICG+KS)
      Z(JCP+NJU+I)  =  Z(IX+I)
      IF(I.EQ.NTP) GO TO 64
      IF(I.EQ.IZ(IB+K)) K=K+1
      IF(I.NE.NBXR) GO TO 64
      KS = KS + 1
      NBXR = NBXR +  IZ(IC+K)
   64 CONTINUE
   65 NJU = NJU + NTO
      IF(NTZS.EQ.0) GO TO 80
      DO 70 I=1,NTZS
      Z(JAP+NJU+I) = 1.0
      Z(JCP+NJU+I) =  .5 * (Z(IXS1+I) + Z(IXS2+I))
   70 CONTINUE
   80 NJU = NJU + NTZS + NTYS
      GO TO 40
C
C     MACH BOX  STRIP  PISTON  THEORIES
C
   90 CALL READ(*998,*995,ACPT,NJG,1,1,NWR)
      NJU= NJU + NJG
      GO TO 40
  100 CALL CLOSE(ACPT,1)
      CALL BUG(NHNJU ,100,NJU,1)
      CALL BUG(NHACJ ,100,Z(JAP+1),2*NJ)
      IF(NJU.NE.NJ) GO TO 996
C
C     BUILD WJ LOOP OVER ALL FREQUENCIES WITH AN INNER LOOP ON NJ
C
      CALL GOPEN(WJ,Z(BUF1),1)
      DO 150 I=1,NFREQ
      FREQ = Z(I)
      CALL BLDPK(3,3,WJ,0,0)
      DO 140 J=1,NJ
      AM = Z(JAP+J)
      IF( AM .EQ. 0.0 ) GO TO 140
      IRN = J
      TEMP   =   FREQ *((Z(JCP+J)-X0)/V)
      A(1) = COS(TEMP)*AM
      A(2) = -SIN(TEMP)*AM
      CALL ZBLPKI
  140 CONTINUE
      CALL BLDPKN(WJ,0,TRL)
  150 CONTINUE
      CALL CLOSE(WJ,1)
      CALL WRTTRL(TRL)
      CALL DMPFIL(-WJ,Z,ICORE)
 1000 RETURN
C
C     ERROR MESSAGES
C
  995 CALL MESAGE(-3,FILE,NAM)
  996 CALL MESAGE(-7,0,NAM)
  997 CALL MESAGE(-8,0,NAM)
  998 CALL MESAGE(-2,FILE,NAM)
  999 CALL MESAGE(-1,FILE,NAM)
      GO TO 1000
      END

      SUBROUTINE FZY2 (XIJ, X1, X2,ETA,ZETA, YB, ZB, A, BETA2,CBAR, K,
     1           FZZR, FZZI, FZYR, FZYI, FYZR, FYZI, FYYR, FYYI)
C   ***   THIS SUBROUTINE IS AN ALTERNATIVE TO SUBROUTINE  FMZY   ---
C         IT IS USED WHENEVER THE OPTION FLAG   IBFS  =  1
C   ***
      REAL M,K,KBAR,KBAR2,I1,I2,I3,I4,I5,I6,I7,I8,I9,I10,I11,KBAR3
      DATA LASTBR /0/
      DATA    TEST1,TEST2,CTH,STH,RAIJ,RAIJ2 /0.142857, 0.5, 1.0,3*0.0/
      DATA    CAPDR,CAPDI,I1,I2,I3,I4,I5,I6,I7,I8,I9,I10,I11/ 13*0.0 /
      M      = SQRT(1.0 - BETA2)
      IF  (K. LE .0.0001 . AND . M. LE .0.0001)  GO TO  110
      KBAR   = 2.0 *K *M *A / CBAR
      KBAR2  = KBAR*KBAR
      GO TO  120
  110 CONTINUE
      KBAR   = 0.0
      KBAR2  = 0.0
  120 XA     = 0.5 * (X1 + X2)
      DX     = X2 - X1
      A2     = A * A
      EPS    = 0.001 * A2
      IF  (ETA. EQ .YB. AND . ZETA. EQ .ZB)  GO TO  130
      RAIJ2  = (ETA-YB)**2 + (ZETA-ZB)**2
      RAIJ   = SQRT(RAIJ2)
      CTH    = (ETA- YB) / RAIJ
      STH    = (ZETA-ZB) / RAIJ
      IF  (RAIJ2. GT .A2)  GO TO  150
      GO TO  140
  130 CONTINUE
      RAIJ   = 0.0
      RAIJ2  = 0.0
      CTH    = 1.0
      STH    = 0.0
  140 RWIG2  = A2
      GO TO 160
  150 RWIG2  = RAIJ2
  160 RAA    = SQRT((XA -XIJ)**2 + BETA2*RWIG2)
      CT2    = CTH*CTH
      ST2    = 0.0
      IF  (ABS(STH) . GT . 0.0001)  ST2=STH*STH
      RWIG   = SQRT(RWIG2)
      RAA2   = RAA * RAA
      RAA3   = RAA * RAA2
      RAA4   = RAA * RAA3
      CAPA   = M - (XA- XIJ) / RAA
      DELTA  = DX / RAA
      DELTA2 = DELTA * DELTA
      EARG   = 0.0
      IF  (KBAR . LE . 0.0001)  GO TO  180
      EARG   = KBAR * (M * (XA-XIJ) - RAA) / (BETA2 * A)
      QR     = COS(EARG) / (4.0 * DX)
      QI     = SIN(EARG) / (4.0 * DX)
      GO TO  190
  180 QR     = 1.0 / (4.0 * DX)
      QI     = 0.0
  190 CONTINUE
      IF  (DELTA. GT . TEST1)  GO TO  240
      I1     = DELTA / RAA2
      TRM1   = BETA2 * A * I1
      FTHR   = A * QR * TRM1
      FTHI   = A * QI * TRM1
      IF  (KBAR. LE .0.0001)  GO TO  210
      I4     = DELTA / RAA
      TRM2   = KBAR * I4
      FTHR   = FTHR - A * QI * TRM2
      FTHI   = FTHI + A * QR * TRM2
  210 CONTINUE
      IF  (RAIJ2. GT . (A2+EPS))  GO TO  220
      FRR    = FTHR
      FRI    = FTHI
      GO TO  370
  220 I6     = DELTA / RAA4
      TRM1   = -3.0 * A2 * BETA2*BETA2 * I6
      CAPDR  = RAIJ2 * QR * TRM1
      CAPDI  = RAIJ2 * QI * TRM1
      IF  (KBAR . LE . 0.0001)  GO TO  230
      I9     = DELTA / RAA3
      TRM1   = TRM1 + KBAR2 * I1
      TRM2   = -3.0 * A * BETA2 * KBAR * I9
      CAPDR  = RAIJ2 * (QR * TRM1 - QI * TRM2)
      CAPDI  = RAIJ2 * (QR * TRM2 + QI * TRM1)
  230 FRR    = FTHR + CAPDR
      FRI    = FTHI + CAPDI
      GO TO  370
  240 CONTINUE
      IF  (DELTA . GT . TEST2)  GO TO  320
      LASTBR = 0
      TAU    = (XA - XIJ) / RAA
      TAU2   = TAU * TAU
      I1     = DELTA * (1.0 - (-1.0+5.0*TAU2)*DELTA2/8.0) / RAA2
  250 TRM1   = A * BETA2 * I1
      FTHR   = A * QR * TRM1
      FTHI   = A * QI * TRM1
      IF  (KBAR . LE . 0.0001)  GO TO  270
      IF  (LASTBR . NE . 0)  GO TO  350
      DELTA3 = DELTA * DELTA2
      I2     = -(TAU * DELTA3) / (4.0 * RAA)
      I3     = DELTA3 / 12.0
      I4     = DELTA * (1.0 + (-1.0+3.0*TAU2)*DELTA2/12.0) / RAA
      I5     = -(TAU * DELTA3) / 6.0
  260 TRM1   = TRM1 - (KBAR2 * CAPA * I5) / (A * BETA2)
      TRM2   = KBAR * (CAPA * I2 + I4 - I3*BETA2*RWIG2/(2.0*RAA3) )
      FTHR   = A * (QR * TRM1 - QI * TRM2)
      FTHI   = A * (QR * TRM2 + QI * TRM1)
  270 IF  (RAIJ2. GT . (A2+EPS))  GO TO  280
      FRR    = FTHR
      FRI    = FTHI
      GO TO  370
  280 CONTINUE
      KBAR3  = KBAR*KBAR2
      IF  (LASTBR . NE . 0)  GO TO  340
      I6     = DELTA * (1.0 + 5.0*(-1.0+7.0*TAU2)*DELTA2/24.0) / RAA4
  290 TRM1   = -3.0 * A2 * BETA2*BETA2 * I6
      CAPDR  = RAIJ2 * QR * TRM1
      CAPDI  = RAIJ2 * QI * TRM1
      IF  (KBAR . LE . 0.0001)  GO TO  310
      IF  (LASTBR . NE . 0)  GO TO  360
      I7     = -5.0 * TAU * DELTA3 / (12.0 * RAA3)
      I8     = DELTA3 / (12.0 * RAA2)
      I9     = DELTA * (1.0 + (-1.0+6.0*TAU2)*DELTA2/6.0) / RAA3
      I10    = -DELTA3 * TAU / (3.0 * RAA2)
  300 TRM1   = TRM1 + KBAR2 * (I1 + 3.0 * CAPA * I10)
      TRM2   = 3.0*A*BETA2 * KBAR * (-CAPA*I7 +I8*BETA2*RWIG2/(2.0*RAA3)
     1    -I9) + KBAR3 * CAPA * I2 / (A * BETA2)
      CAPDR  = RAIJ2 * (QR * TRM1 - QI * TRM2)
      CAPDI  = RAIJ2 * (QR * TRM2 + QI * TRM1)
  310 FRR    = FTHR + CAPDR
      FRI    = FTHI + CAPDI
      GO TO  370
  320 CONTINUE
      LASTBR = 1
      RWIG   = SQRT(RWIG2)
      RA12   = (X1 - XIJ)**2 + BETA2 * RWIG2
      RA22   = (X2 - XIJ)**2 + BETA2 * RWIG2
      RA1    = SQRT(RA12)
      RA2    = SQRT(RA22)
      I1     = ((X2-XIJ)/RA2 - (X1-XIJ)/RA1) / (BETA2*RWIG2)
      GO TO  250
  340 CONTINUE
      RA13   = RA1 * RA12
      RA23   = RA2 * RA22
      I6     = ((X2-XIJ)/RA23-(X1-XIJ)/RA13 + 2.0*I1)/(3.0*BETA2*RWIG2)
      GO TO  290
  350 PART1  = 0.5 * DX * (XA - XIJ)
      I2     = -((PART1+RAA2)/RA2 + (PART1-RAA2)/RA1)/ (BETA2*RWIG2)
      DENOM  = X1 - XIJ + RA1
      I11    = ALOG(ABS((X2 - XIJ + RA2) / DENOM))
      I3     = I11 - 2.0*(XA - XIJ)*I2 - RAA2 * I1
      DENO4  = SQRT(BETA2) * RWIG
      ARG1   = (X2 - XIJ) / DENO4
      ARG2   = (X1 - XIJ) / DENO4
      I4     = (ATAN(ARG1) - ATAN(ARG2)) / DENO4
      I5     = 0.5 * ALOG(RA22 / RA12) - (XA - XIJ) * I4
      GO TO  260
  360 CONTINUE
      I7     = -(1.0/RA23 - 1.0/RA13) / 3.0 - (XA - XIJ) * I6
      I8     = I1 - 2.0 * (XA - XIJ) * I7 - RAA2 * I6
      I9     = ((X2-XIJ)/RA22-(X1-XIJ)/RA12 + I4) / (2.0*BETA2*RWIG2)
      I10    = -((PART1 + RAA2)/RA22 + (PART1 - RAA2)/RA12 +
     1           (XA - XIJ) * I4) / (2.0 * BETA2 * RWIG2)
      GO TO 300
  370 CONTINUE
      FZZR   = CT2 * FTHR + ST2 * FRR
      FZZI   = CT2 * FTHI + ST2 * FRI
      FYYR   = ST2 * FTHR + CT2 * FRR
      FYYI   = ST2 * FTHI + CT2 * FRI
      IF  (CTH. EQ .0.0 . OR . STH. EQ . 0.0)  GO TO  400
      FZYR   = CTH * STH * (FRR - FTHR)
      FZYI   = CTH * STH * (FRI - FTHI)
      GO TO  410
  400 FZYR   = 0.0
      FZYI   = 0.0
  410 CONTINUE
      FYZR = FZYR
      FYZI = FZYI
      RETURN
      END

      SUBROUTINE BDAT02
C
C     THIS SUBROUTINE PROCESSES CONCT BULK DATA AND WRITES CONNECTION
C     ENTRIES IN TERMS OF CODED GRID POINT ID NUMBERS ON SCR1
C
      EXTERNAL        RSHIFT,ANDF
      LOGICAL         TDAT,PRINT
      INTEGER         SCR1,OUTT,BUF1,BUF2,CONCT(2),FLAG,GEOM4,ID(2),
     1                COMP,NAMS(4),IO(9),AAA(2),CONSET,ANDF,RSHIFT,COMBO
      DIMENSION       IBITS(32),JBITS(32),NAME(14),IHD(16)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /CMB001/ SCR1,SCR2,SCBDAT,SCSFIL,SCCONN,SCMCON,SCTOC,
     1                GEOM4,CASECC
      COMMON /ZZZZZZ/ Z(1)
      COMMON /CMB002/ BUF1,BUF2,BUF3,BUF4,BUF5,SCORE,LCORE,INPT,OUTT
      COMMON /CMB003/ COMBO(7,5),CONSET,IAUTO,TOLER,NPSUB,CONECT,TRAN,
     1                MCON,RESTCT(7,7),ISORT,ORIGIN(7,3),IPRINT
      COMMON /CMB004/ TDAT(6)
      COMMON /OUTPUT/ ITITL(96),IHEAD(96)
      COMMON /CMBFND/ INAM(2),IERR
      COMMON /BLANK / STEP,IDRY
      DATA    AAA   / 4HBDAT,4H02       / , CONCT  / 210,2  /
      DATA    IHD   / 4H  SU , 4HMMAR , 4HY OF , 4H CON , 4HNECT ,
     1                4HION  , 4HENTR , 4HIES  , 4HSPEC , 4HIFIE ,
     2                4HD BY , 4H CON , 4HCT   , 4HBULK , 4H DAT ,
     3                4HA    /
      DATA    IBLNK / 4H     /
C
      DO 10 I = 1,96
      IHEAD(I) = IBLNK
   10 CONTINUE
      J = 1
      DO 20 I = 73,88
      IHEAD(I) = IHD(J)
   20 J = J + 1
      PRINT = .FALSE.
      IF (ANDF(RSHIFT(IPRINT,3),1) .EQ. 1) PRINT = .TRUE.
      NP2 = 2*NPSUB
      DO 30 I = 1,NP2,2
      J = I/2 + 1
      NAME(I  ) = COMBO(J,1)
      NAME(I+1) = COMBO(J,2)
   30 CONTINUE
      IFILE = SCR1
      CALL OPEN (*220,SCR1,Z(BUF2),3)
      CALL LOCATE (*180,Z(BUF1),CONCT,FLAG)
      IFILE = GEOM4
   40 CALL READ (*200,*170,GEOM4,ID,1,0,N)
      IF (ID(1) .EQ. CONSET) GO TO 60
      CALL READ (*200,*210,GEOM4,ID,-5,0,N)
   50 CALL READ (*200,*210,GEOM4,ID,2,0,N)
      IF (ID(1)+ID(2) .NE. -2) GO TO 50
      GO TO 40
   60 CALL READ (*200,*210,GEOM4,COMP,1,0,N)
      IF (.NOT.PRINT) GO TO 80
      CALL PAGE
      CALL PAGE2 (6)
      WRITE  (OUTT,70) (NAME(KDH),KDH=1,NP2)
   70 FORMAT (/24X,74HNOTE  GRID POINT ID NUMBERS HAVE BEEN CODED TO THE
     1 COMPONENT SUBSTRUCTURE ,/30X,75HWITHIN A GIVEN PSEUDOSTRUCTURE BY
     2 - 1000000*COMPONENT NO. + ACTUAL GRID ID., //15X,22HCONNECTED   C
     3ONNECTION,23X,33HGRID POINT ID FOR PSEUDOSTRUCTURE/18X,3HDOF,9X,
     44HCODE,3X,7(3X,2A4)/)
   80 CONTINUE
      TDAT(2) = .TRUE.
      CALL ENCODE (COMP)
      CALL READ (*200,*210,GEOM4,NAMS,4,0,N)
      CALL FINDER (NAMS(1),IS1,IC1)
      IF (IERR .NE. 1) GO TO 90
      WRITE (OUTT,100) UFM,NAMS(1),NAMS(2)
      IDRY = -2
   90 CONTINUE
      CALL FINDER (NAMS(3),IS2,IC2)
      IF (IERR .NE. 1) GO TO 110
      WRITE (OUTT,100) UFM,NAMS(3),NAMS(4)
      IDRY = -2
  100 FORMAT (A23,' 6523, THE BASIC SUBSTRUCTURE ',2A4, /30X,
     1       'REFERED TO BY A CONCT  BULK DATA CARD CAN NOT BE FOUND ',
     2       'IN THE PROBLEM TABLE OF CONTENTS.')
  110 CALL READ (*200,*210,GEOM4,ID,2,0,N)
C
      IF (ID(1)+ID(2) .EQ. -2) GO TO 40
      IF (IS1 .NE. IS2) GO TO 130
      KK = 2*IS1 - 1
      WRITE  (OUTT,120) UFM,ID(1),ID(2),NAME(KK),NAME(KK+1)
  120 FORMAT (A23,' 6536, MANUAL CONNECTION DATA IS ATTEMPTING TO ',
     1       'CONNECT', /31X,'GRID POINTS',I9,5X,4HAND ,I8, /31X,
     2       'WHICH ARE BOTH CONTAINED IN PSEUDOSTRUCTURE ',2A4)
      IDRY = -2
  130 CONTINUE
      DO 140 I = 1,9
  140 IO(I) = 0
      IO(1) = COMP
      IO(2) = 2**(IS1-1) + 2**(IS2-1)
      IO(2+IS1) = IC1*1000000 + ID(1)
      IO(2+IS2) = IC2*1000000 + ID(2)
      NWD = 2 + NPSUB
      CALL WRITE (SCR1,IO,NWD,1)
      IF (.NOT.PRINT .OR. IDRY.EQ.-2) GO TO 160
      CALL BITPAT (IO(1),IBITS)
      CALL BITPAT (IO(2),JBITS)
      CALL PAGE2 (1)
      WRITE (OUTT,150) (IBITS(KDH),KDH=1,2),(JBITS(KDH),KDH=1,2),
     1                 (IO(KDH+2),KDH=1,NPSUB)
  150 FORMAT (16X,A4,A2,6X,A4,A3,2X,7(3X,I8))
  160 CONTINUE
      GO TO 110
  170 CONTINUE
  180 CALL CLOSE (SCR1,1)
      RETURN
C
  200 IMSG = -2
      GO TO 230
  210 IMSG = -3
      GO TO 230
  220 IMSG = -1
  230 CALL MESAGE (IMSG,IFILE,AAA)
      RETURN
      END

      SUBROUTINE MPYA3D (AA,BB,NROW,BAND,CC)
C
C     WITH ENTRY MPYA3S (A,B,NROW,BAND,C)
C
C     WAS NAMED DATBAD/DATBAS IN UAI CODE
C
C     THESE ROUTINES PERFORM TRIPLE MATRIX MULTIPLY OF THE FORM
C
C                          T
C                 C = C + A * B * A
C
C     ON TWO INCOMING ROW-LOADED MATRICES A AND B, AND ADD THEM TO
C     MATRIX C
C
C     THE INCOMING MATRICES MUST BE SQUARE (AND OBVIOUSLY OF THE SAME
C     SIZE, NROW.) AND
C     SYMMETRICAL (SINCE WE OPERATE ONLY ON LOWER TRIANGULAR MATRICES)
C
C     MATRIX A CAN BE A PSUEDO-DIAGONAL MATRIX, I.E. A MATRIX HAVING
C     SQUARE PARTITIONS OF NON-ZERO TERMS ALONG ITS DIAGONAL.
C     THESE PARTITIONS ARE OF THE SIZE  BAND X BAND.
C     NOTE THAT NROW MUST BE AN INTEGER MULTIPLE OF BAND.
C
C     THIS ALGORITHM IS SUITABLE FOR TRIPLE MULTIPLIES INVOLVING GLOBAL
C     TRANSFORMATIONS.
C
C
      INTEGER          BAND
      REAL             A(1) ,B(1) ,C(1)
      DOUBLE PRECISION AA(1),BB(1),CC(1),DD
C
C
C     DOUBLE PRECISION VERSION
C
      II = 0
      DO 50 IB = 1,NROW
      IA1 = ((IB-1)/BAND+1)*BAND
C
      DO 40 ID1 = 1,NROW,BAND
      ID2 = ID1 + BAND - 1
      IF (ID1 .GT. IA1) GO TO 50
C
      ID11N = (ID1-1)*NROW
      DO 30 ID = ID1,ID2
      JJ = ID11N
      DD = 0.0D0
C
      DO 10 IC = ID1,ID2
      IBIC = II + IC
      ICID = JJ + ID
      IF (AA(ICID) .EQ. 0.0D0) GO TO 10
      DD = DD + BB(IBIC)*AA(ICID)
   10 JJ = JJ + NROW
C
      IF (DD .EQ. 0.0D0) GO TO 30
      KK = (ID-1)*NROW
C
      DO 20 IA = ID,IA1
      IBIA = II + IA
      IF (AA(IBIA) .EQ. 0.0D0) GO TO 20
      IAID = KK + ID
      CC(IAID) = CC(IAID) + DD*AA(IBIA)
   20 KK = KK + NROW
C
   30 CONTINUE
   40 CONTINUE
   50 II = II + NROW
C
C     COPY THE LOWER TRIANGLE TO THE UPPER
C
      KK = NROW - 1
      II = 0
      DO 70 I = 1,KK
      IB = I + 1
      JJ = I*NROW
      DO 60 J = IB,NROW
      CC(II+J) = CC(JJ+I)
   60 JJ = JJ + NROW
   70 II = II + NROW
C
      RETURN
C
C
      ENTRY MPYA3S (A,B,NROW,BAND,C)
C     ==============================
C
C     SINGLE PRECISION VERSION
C
      II = 0
      DO 150 IB = 1,NROW
      IA1 = ((IB-1)/BAND+1)*BAND
C
      DO 140 ID1 = 1,NROW,BAND
      ID2 = ID1 + BAND - 1
      IF (ID1 .GT. IA1) GO TO 150
C
      ID11N = (ID1-1)*NROW
      DO 130 ID = ID1,ID2
      JJ = ID11N
      DD = 0.0D0
C
      DO 110 IC = ID1,ID2
      IBIC = II + IC
      ICID = JJ + ID
      IF (A(ICID) .EQ. 0.0) GO TO 110
      DD = DD + DBLE(B(IBIC))*DBLE(A(ICID))
  110 JJ = JJ + NROW
      IF (DD .EQ. 0.0D0) GO TO 130
      KK = (ID-1)*NROW
C
      DO 120 IA = ID,IA1
      IBIA = II + IA
      IF (A(IBIA) .EQ. 0.0) GO TO 120
      IAID = KK + ID
      C(IAID) = SNGL(DBLE(C(IAID)) + DD*DBLE(A(IBIA)))
  120 KK = KK + NROW
C
  130 CONTINUE
  140 CONTINUE
  150 II = II + NROW
C
C     COPY THE LOWER TRIANGLE TO THE UPPER
C
      KK = NROW - 1
      II = 0
      DO 170 I = 1,KK
      IB = I + 1
      JJ = I*NROW
      DO 160 J = IB,NROW
      C(II+J) = C(JJ+I)
  160 JJ = JJ + NROW
  170 II = II + NROW
C
      RETURN
      END

      SUBROUTINE PRETRS (CSTMX,NCSTMX)
C
C     PRETRS SETS UP EVENTUAL CALLS TO TRANSS.  FOR A MODULE TO USE
C     TRANSS A CALL TO PRETRS MUST BE INITIATED BY THE MODULE DRIVER
C     ONCE AND ONLY ONCE.  CSTMX IS ARRAY OF COORDINATE SYSTEM
C     TRANSFORMATION MATRICES AND MCSTMX IS THE LENGTH OF THIS ARRAY.
C
C     THE CSTMX ARRAY MUST BE WITHIN OPEN CORE BOUND, AND THERE IS NO
C     CHECK ON THIS CONDITION
C
C     GIVEN THE ARRAY ECPT OF LENGTH 4, THE FIRST WORD BEING AN INTEGER
C     COORDINATE SYSTEM IDENTIFICATION NUMBER AND THE NEXT WORDS BEING
C     THE REAL COORDINATES OF A POINT IN BASIC COORDINATES, THIS ROUTINE
C     COMPUTES THE TRANSFORMATION (DIRECTION COSINE) MATRIX TA WHICH
C     WILL MAP A VECTOR FROM THE LOCAL SYSTEM LABELED ECPT(1) TO BASIC
C     COORDINATES.
C
C     REVISED  7/92 BY G.CHAN/UNISYS. NEW REFERENCE TO CSTM ARRAY SUCH
C     THAT THE SOURCE CODE IS UP TO ANSI FORTRAN 77 STANDARD.
C
      INTEGER         OFFSET
      REAL            KE
      DIMENSION       CSTMX(1),ECPT(4),TA(9),TL(9),KE(9),XN(3)
      COMMON /ZZZZZZ/ CSTM(1)
      EQUIVALENCE     (FL1,INT1),(FL2,INT2)
C
      NCSTM  = NCSTMX
      OFFSET = LOCFX(CSTMX(1)) - LOCFX(CSTM(1))
      IF (OFFSET .LT. 0) CALL ERRTRC ('PRETRS  ',1)
      ICHECK = 123456789
      RETURN
C
C
      ENTRY TRANSS (ECPT,TA)
C     ======================
C
      FL1 = ECPT(1)
      IF (INT1 .EQ. 0) GO TO 90
      IF (ICHECK .NE. 123456789) CALL ERRTRC ('PRETRS  ',10)
      DO 10 J = 1,NCSTM,14
      I   = J + OFFSET
      FL2 = CSTM(I)
      IF (INT1 .NE. INT2) GO TO 10
      KK = I
      FL2 = CSTM(I+1)
      GO TO (20,40,40), INT2
   10 CONTINUE
C
C     THE COORDINATE SYSTEM ID. COULD NOT BE FOUND IN THE CSTM.
C
      CALL MESAGE (-30,25,INT1)
C
C     THE COORDINATE SYSTEM IS RECTANGULAR.
C
   20 DO 30 J = 1,9
      K = KK + 4 + J
   30 TA(J) = CSTM(K)
      RETURN
C
   40 XN(1) = ECPT(2) - CSTM(KK+2)
      XN(2) = ECPT(3) - CSTM(KK+3)
      XN(3) = ECPT(4) - CSTM(KK+4)
      X = CSTM(KK+5)*XN(1) + CSTM(KK+ 8)*XN(2) + CSTM(KK+11)*XN(3)
      Y = CSTM(KK+6)*XN(1) + CSTM(KK+ 9)*XN(2) + CSTM(KK+12)*XN(3)
      Z = CSTM(KK+7)*XN(1) + CSTM(KK+10)*XN(2) + CSTM(KK+13)*XN(3)
      R = SQRT(X**2 + Y**2)
      IF (R .EQ. 0.0) GO TO 20
      DO 50 J = 1,9
      K = KK + 4 + J
   50 KE(J) = CSTM(K)
      GO TO (60,60,70), INT2
C
C     THE COORDINATE SYSTEM IS CYLINDRICAL.
C
   60 TL(1) = X/R
      TL(2) =-Y/R
      TL(3) = 0.0
      TL(4) =-TL(2)
      TL(5) = TL(1)
      TL(6) = 0.0
      TL(7) = 0.0
      TL(8) = 0.0
      TL(9) = 1.0
      GO TO 80
C
C     THE COORDINATE SYSTEM IS SPHERICAL.
C
   70 XL = SQRT(X**2 + Y**2 + Z**2)
      TL(1) = X/XL
      TL(2) = (X*Z)/(R*XL)
      TL(3) =-Y/R
      TL(4) = Y/XL
      TL(5) = (Y*Z)/(R*XL)
      TL(6) = X/R
      TL(7) = Z/XL
      TL(8) =-R/XL
      TL(9) = 0.0
   80 CALL GMMATS (KE(1),3,3,0, TL(1),3,3,0, TA(1))
      RETURN
C
C     THE LOCAL SYSTEM IS BASIC.
C
   90 DO 100 I = 1,9
  100 TA(I) = 0.0
      TA(1) = 1.0
      TA(5) = 1.0
      TA(9) = 1.0
      RETURN
      END

      SUBROUTINE T3PL4D
C
C     DOUBLE PRECISION ROUTINE TO PROCESS PLOAD4 PRESSURE DATA AND
C     GENERATE EQUIVALENT NODAL LOADS FOR A TRIA3 ELEMENT.
C
C     WAS NAMED T3PRSD (LOADVC,RPDATA,IPDATA) IN UAI
C
C                 EST  LISTING
C
C        WORD     TYP       DESCRIPTION
C     ----------------------------------------------------------------
C     ECT:
C         1        I   ELEMENT ID, EID
C         2-4      I   SIL LIST, GRIDS 1,2,3
C         5-7      R   MEMBRANE THICKNESSES T, AT GRIDS 1,2,3
C         8        R   MATERIAL PROPERTY ORIENTAION ANGLE, THETA
C               OR I   COORD. SYSTEM ID (SEE TM ON CTRIA3 CARD)
C         9        I   TYPE FLAG FOR WORD 8
C        10        R   GRID OFFSET, ZOFF
C    EPT:
C        11        I   MATERIAL ID FOR MEMBRANE, MID1
C        12        R   ELEMENT THICKNESS,T (MEMBRANE, UNIFORMED)
C        13        I   MATERIAL ID FOR BENDING, MID2
C        14        R   MOMENT OF INERTIA FACTOR, I (BENDING)
C        15        I   MATERIAL ID FOR TRANSVERSE SHEAR, MID3
C        16        R   TRANSV. SHEAR CORRECTION FACTOR, TS/T
C        17        R   NON-STRUCTURAL MASS, NSM
C        18-19     R   STRESS FIBER DISTANCES, Z1,Z2
C        20        I   MATERIAL ID FOR MEMBRANE-BENDING COUPLING, MID4
C        21        R   MATERIAL ANGLE OF ROTATION, THETA
C               OR I   COORD. SYSTEM ID (SEE MCSID ON PSHELL CARD)
C                      (DEFAULT FOR WORD 8)
C        22        I   TYPE FLAG FOR WORD 21 (DEFAULT FOR WORD 9)
C        23        I   INTEGRATION ORDER FLAG
C        24        R   STRESS ANGLE OF RATATION, THETA
C               OR I   COORD. SYSTEM ID (SEE SCSID ON PSHELL CARD)
C        25        I   TYPE FLAG FOR WORD 24
C        26        R   OFFSET, ZOFF1 (DEFAULT FOR WORD 10)
C    BGPDT:
C        27-38   I/R   CID,X,Y,Z  FOR GRIDS 1,2,3
C    ETT:
C        39        I   ELEMENT TEMPERATURE
C
C    DATA IN THE PLOAD4 ENTRY, 11 WORDS IN ISLT ARRAY
C
C       EID - ELEMENT ID, IPDATA(0)=ISLT(1)
C       PPP - CORNER GRID POINT PRESSURES PER UNIT SURFACE AREA,
C             RPDATA (1-4)
C       DUM - DUMMY DATA WORDS, IPDATA (5-6)
C       CID - COORDINATE SYSTEM FOR DEFINITION OF PRESSURE VECTOR,
C             IPDATA(7)
C       NV  - PRESSURE DIRECTION VECTOR, RPDATA(8-10)
C           - IF CID IS BLANK OR ZERO, THE PRESSURE ACTS NORMAL TO THE
C             SURFACE OF THE ELEMENT.
C
C     EQUIVALENT NUMERICAL INTEGRATION POINT LOADS PP(III) ARE OBTAINED
C     VIA BI-LINEAR INTERPOLATION
C
      LOGICAL          CONSTP,SHEART,NORMAL
      INTEGER          IPDATA(7),ISLT(1),IGPDT(4,3),SIL(3),IORDER(3),
     1                 ELID,CID,SYSBUF,NOUT,NOGO
      REAL             GPTH(3),BGPDT(4,3),NV(3),NVX(3),LOCATE(3),
     1                 PE(3,3),RPDATA(1),LOADVC
      DOUBLE PRECISION DPE(3,3),SHP(3),WEIGHT,DETJAC,V3T(3),
     1                 P,PPP(3),BTERMS(6),BMATRX(162),EGPDT(4,3),
     2                 CENTE(3),GPNORM(4,3),EPNORM(4,3),TEB(9),TUB(9),
     3                 DGPTH(3),TH,AVGTHK,AIC(1),EDGLEN(3),LX,LY
      COMMON /SYSTEM/  SYSBUF,NOUT,NOGO
      COMMON /ZZZZZZ/  LOADVC(1)
      COMMON /PINDEX/  EST(45),SLT(11)
      EQUIVALENCE      (SLT( 1),ISLT(1)),(EST( 1),ELID),(EST(2),SIL(1)),
     1                 (EST( 5),GPTH(1)),(EST(12),ELTH),
     2                 (EST(27),BGPDT(1,1),IGPDT(1,1)),
     3                 (SLT( 2),IPDATA(1) ,RPDATA(1))
C
C     INITIALIZE
C
      WEIGHT = 1.0D0/6.0D0
      SHEART = .FALSE.
      NNODE  = 3
      NDOF   = 3
      DO 10 I = 1,NDOF
      DO 10 J = 1,NNODE
      DPE(I,J) = 0.0D0
   10 CONTINUE
C
C     GET THE PRESSURE INFORMATION
C
C     EST (45 WORDS) AND SLT (11 WORDS) ARE THE DATA FOR EST AND SLT
C     WHICH ARE READ IN BY EXTERN AND ARE READY TO BE USED
C
C     IF ISLT(1).GT.0, GET THE PLOAD4 DATA FROM THE PROCESSED PLOAD2
C                      INFORMATION IN ARRAY SLT.
C                      (NOT AVAILABLE IN COSMIC/NASTRAN)
C     IF ISLT(1).LT.0, GET THE PLOAD4 DATA FROM THE ORIGINAL PLOAD4
C                      INFORMATION IN ARRAY RPDATA.
C                      (SET TO NEGATIVE BY PLOAD4 SUBROUTINE)
C
      IF (ISLT(1) .LT. 0) GO TO 20
      NORMAL = .TRUE.
      CONSTP = .TRUE.
      P = DBLE(SLT(2))
      GO TO 60
C
   20 DO 30 I = 1,NNODE
      PPP(I) = DBLE(RPDATA(I))
   30 CONTINUE
      CONSTP = PPP(2).EQ.0.0D0 .AND. PPP(3).EQ.0.0D0
      IF (CONSTP) P = PPP(1)
      CID = IPDATA(7)
C
C     GET THE DIRECTION VECTOR AND NORMALIZE IT
C
      X = 0.0
      DO 40 I = 1,NNODE
      NV(I) = RPDATA(I+7)
      X = X + NV(I)*NV(I)
   40 CONTINUE
      NORMAL = .TRUE.
      IF (X .LE. 0.0) GO TO 60
      NORMAL = .FALSE.
      X = SQRT(X)
      DO 50 I = 1,NNODE
      NV(I) = NV(I)/X
   50 CONTINUE
C
C     SET UP THE ELEMENT FORMULATION
C
   60 CALL T3SETD (IERR,SIL,IGPDT,ELTH,GPTH,DGPTH,EGPDT,GPNORM,EPNORM,
     1             IORDER,TEB,TUB,CENTE,AVGTHK,LX,LY,EDGLEN,ELID)
      IF (IERR .NE. 0) GO TO 200
C
C     START THE LOOP ON INTEGRATION POINTS
C
      DO 150 IPT = 5,7
C
      CALL T3BMGD (IERR,SHEART,IPT,IORDER,EGPDT,DGPTH,AIC,TH,DETJAC,SHP,
     1             BTERMS,BMATRX)
      IF (IERR .NE. 0) GO TO 200
C
C     CALCULATE THE PRESSURE AT THIS POINT
C
      IF (CONSTP) GO TO 80
      P = 0.0D0
      DO 70 I = 1,NNODE
      P = P + SHP(I)*PPP(I)
   70 CONTINUE
C
C     SET THE DIRECTION OF PRESSURE AT THIS POINT.
C     THE RESULTING VECTOR MUST BE IN THE BASIC COORD. SYSTEM
C
   80 IF (.NOT.NORMAL) GO TO 90
      V3T(1) = TEB(7)*DETJAC
      V3T(2) = TEB(8)*DETJAC
      V3T(3) = TEB(9)*DETJAC
      GO TO 120
C
   90 IF (CID .NE. 0) GO TO 100
      V3T(1) = NV(1)*DETJAC
      V3T(2) = NV(2)*DETJAC
      V3T(3) = NV(3)*DETJAC
      GO TO 120
C
C     FOR NON-ZERO CID, COMPUTE THE LOCATION OF THE INTEGRATION POINT SO
C     THAT WE CAN ROTATE THE USER VECTOR PER CID.  THIS LOCATION IS
C     REQUIRED ONLY IF CID IS CYLINDRICAL OR SPHERICAL.
C
  100 LOCATE(1) = 0.0
      LOCATE(2) = 0.0
      LOCATE(3) = 0.0
      DO 110 J  = 1,NNODE
      LOCATE(1) = LOCATE(1) + BGPDT(2,J)*SHP(J)
      LOCATE(2) = LOCATE(2) + BGPDT(3,J)*SHP(J)
      LOCATE(3) = LOCATE(3) + BGPDT(4,J)*SHP(J)
  110 CONTINUE
C
C     NOW ROTATE THE VECTOR
C
      CALL GLBBAS (NV(1),NVX(1),LOCATE(1),CID)
      V3T(1) = NVX(1)*DETJAC
      V3T(2) = NVX(2)*DETJAC
      V3T(3) = NVX(3)*DETJAC
C
C     COMPUTE THE CONTRIBUTION TO THE LOAD MATRIX FROM THIS INTEGRATION
C     POINT AS NT*P*V3T
C
  120 DO 130 I = 1,NNODE
      DO 130 J = 1,NDOF
      DPE(J,I) = DPE(J,I) + WEIGHT*P*SHP(I)*V3T(J)
      PE(J,I)  = DPE(J,I)
  130 CONTINUE
C
  150 CONTINUE
C
C     END OF NUMERICAL INTEGRATION LOOP
C     ADD ELEMENT LOAD TO OVERALL LOAD.
C
      DO 170 J = 1,NNODE
      IF (IGPDT(1,J) .NE. 0) CALL BASGLB (PE(1,J),PE(1,J),BGPDT(2,J),
     1                                    IGPDT(1,J))
      JP = SIL(J) - 1
      DO 170 I = 1,NDOF
      LOADVC(JP+I) = LOADVC(JP+I) + PE(I,J)
  170 CONTINUE
      GO TO 250
C
C     FATAL ERROR
C
  200 ISLT(1) = IABS(ISLT(1))
      CALL MESAGE (30,224,ISLT(1))
      NOGO = 1
C
  250 RETURN
      END

      SUBROUTINE INVFBS (DX,DY,IOBUF)
C
C     DOUBLE PRECISION VERSION
C
C     INVFBS IS A SPECIAL FORWARD-BACKWARD SUBSTITUTION ROUTINE FOR
C     INVPWR. IT OPERATES ON CONJUNCTION WITH SDCOMP.
C     THE ARITHMETIC PRECISION IS THAT OF THE INPUT FILE
C
C     FILEL    =  MATRIX CONTROL BLOCK FOR THE LOWER TRIANGLE L
C     FILEU    =  MATRIX CONTROL BLOCK FOR THE UPPER TRIANGLE U
C     DX       =  THE LOAD VECTOR B
C     DY       =  THE SOLUTION VECTOR X
C     IOBUF    =  THE INPUT BUFFER
C
C     COMMENT FROM G.CHAN/UNISYS, 6/89
C     IF LOAD IS SUDDENLY INCREADED TO A LARGE VALUE, THE VAX MACHINE
C     MAY BLOW ITS TOP (ARITHMETIC FAULT, FLOATING OVERFLOW) BECAUSE
C     VAX DOUBLE PRECISION REAL NUMBERS ARE LIMITED TO 10**38, SAME
C     LIMIT AS THE SINGLE PRECISION REAL NUMBERS. OTHER MACHINES ALLOW
C     MUCH LARGER LIMITS FOR DOUBLE PRECISION NUMBERS.
C
      INTEGER            FILEL     ,FILEU    ,TYPEAR   ,RDP      ,
     1                   PARM(4)   ,EOL      ,IJJ(2)
      DOUBLE PRECISION   DX(1)     ,DY(1)    ,DA       ,DTEMP    ,
     1                   DJJ       ,DYJ      ,EPSI
      DIMENSION          IOBUF(1)
      CHARACTER          UFM*23    ,UWM*25   ,UIM*29   ,SFM*25
      COMMON   /XMSSG /  UFM       ,UWM      ,UIM      ,SFM
      COMMON   /MACHIN/  MACH
      COMMON   /SYSTEM/  IBUF      ,NOUT
C     COMMON   /DESCRP/  LENGTH    ,MAJOR
      COMMON   /NAMES /  RD        ,RDREW    ,WRT      ,WRTREW   ,
     1                   REW       ,NOREW    ,EOFNRW   ,RSP      ,
     2                   RDP       ,CSP      ,CDP      ,SQR      ,
     3                   RECT      ,DIAG     ,LOWTRI   ,UPRTRI   ,
     4                   SYM       ,ROW      ,IDENTY
      COMMON   /TYPE  /  RC(2)     ,NWDS(4)
      COMMON   /ZNTPKX/  A(4)      ,II       ,EOL
      COMMON   /INFBSX/  FILEL(7)  ,FILEU(7)
      COMMON   /TRDXX /  IDUMMY(27),IOPEN
      EQUIVALENCE        (A(1),DA) ,(FILEL(3),NROW)    ,(DJJ,IJJ(1))
      DATA      EPSI  /  1.0D-24   /
      DATA      PARM(3), PARM(4)   /4HINVF,4HBS  /
C
C
C     TRANSFER THE LOAD VECTOR TO THE SOLUTION VECTOR
C
      DO 10 I = 1,NROW
   10 DY(I)  = DX(I)
      TYPEAR = RDP
C
C     OPEN FILE FOR THE LOWER TRIANGLE
C     IOPEN WAS SET TO -20 BY STEP2
C
      PARM(2) = FILEL(1)
      IF (IOPEN .EQ.  -20) CALL FWDREC (*360,FILEL(1))
      IF (FILEL(7) .LT. 0) GO TO 300
C
C     NASTRAN ORIGINAL CODE
C
C     BEGIN FORWARD PASS
C
      J = 1
   20 CALL INTPK (*100,FILEL(1),0,TYPEAR,0)
   30 IF (EOL) 220,40,220
   40 CALL ZNTPKI
      IF (J-II) 80,50,30
C
C     PERFORM THE REQUIRED ROW INTERCHANGE
C
   50 IN1   = J+IFIX(SNGL(DA))
      DTEMP = DY(J)
      DY(J) = DY(IN1)
      DY(IN1) = DTEMP
   60 IF (EOL) 100,70,100
   70 CALL ZNTPKI
   80 IF (MACH.NE.5 .OR.
     1   (DABS(DA).LT.1.D+19 .AND. DABS(DY(J)).LT.1.D+19)) GO TO 90
      X1 = ALOG10(ABS(SNGL(DA)))
      X2 = ALOG10(ABS(SNGL(DY(J))))
      IF (X1+X2 .GT. 38.) GO TO 200
   90 DY(II) = DY(II) - DY(J)*DA
      GO TO 60
  100 J = J + 1
      IF (J .LT. NROW) GO TO 20
      CALL REWIND (FILEL(1))
      IF (IOPEN .EQ. -20) GO TO 110
      CALL SKPREC (FILEL,1)
C
C     BEGIN BACKWARD PASS
C
  110 IOFF    = FILEU(7) - 1
      PARM(2) = FILEU(1)
      IF (IOPEN .EQ. -20) CALL FWDREC (*360,FILEU(1))
      J = NROW
  120 CALL INTPK (*220,FILEU(1),0,TYPEAR,0)
      IF (EOL .NE. 0) GO TO 220
  130 CALL ZNTPKI
      I = NROW - II + 1
      IF (I .NE. J) GO TO 150
C
C     DIVIDE BY THE DIAGONAL
C
      DY(I) = DY(I)/DA
C
C     SUBTRACT OFF REMAINING TERMS
C
  140 IF (I   .GT. J) GO TO 130
      IF (EOL .NE. 0) GO TO 180
      CALL ZNTPKI
      I   = NROW - II + 1
  150 IN1 = I
      IN2 = J
      IF (I .LT. J) GO TO 160
      K   = IN1
      IN1 = IN2 - IOFF
      IN2 = K
  160 IF (MACH.NE.5 .OR.
     1   (DABS(DA).LT.1.D+19 .AND. DABS(DY(IN2)).LT.1.D+19)) GO TO 170
      X1 = ALOG10(ABS(SNGL(DA)))
      X2 = ALOG10(ABS(SNGL(DY(IN2))))
      IF (X1+X2 .GT. 38.) GO TO 200
  170 DY(IN1) = DY(IN1) - DY(IN2)*DA
      GO TO 140
  180 J = J - 1
      IF (J .GT. 0) GO TO 120
      CALL REWIND (FILEU)
      IF (IOPEN .EQ. -20) RETURN
      CALL SKPREC (FILEU,1)
      GO TO 450
C
  200 WRITE  (NOUT,210) SFM,PARM(1),PARM(2)
  210 FORMAT (A25,' FROM ',2A4,'- SOLUTION VECTOR VALUE OVERFLOWS,',/5X,
     1       'POSSIBLY DUE TO SUDDEN INCREASE OF LARGE LOAD VECTOR OR ',
     2       'OTHER INPUT CONDITION')
      GO TO 420
  220 PARM(1) = -5
      GO TO 440
C
C
C     NEW METHOD
C     FILEL HAS BEEN RE-WRITTEN FORWARD FIRST THAN BACKWARD BY UNPSCR
C     IN INVP3)
C
C     THE LOAD VECTOR DX WILL BE DESTROYED IN THIS NEW METHOD
C
C     FORWARD SWEEP DIRECTLY ON SOLUTION VECTOR DY
C
  300 IFILE  =-FILEL(7)
      PARM(2)= IFILE
      NWD    = NWDS(FILEL(5))
      IF (FILEL(4) .NE. 2) GO TO 400
      IFW = +1
      CALL REWIND (IFILE)
      CALL SKPREC (IFILE,1)
      CALL READ (*360,*370,IFILE,DX,2,0,I)
      NTMS = 0
      DO 320 J = 1,NROW
      DJJ = DX(NTMS+1)
      II  = IJJ(1)
      JJ  = IJJ(2)
      IF (II .NE. J) GO TO 380
      NTMS = JJ - II + 1
      JI = NTMS*NWD + 2
      CALL READ (*360,*370,IFILE,DX,JI,0,I)
      IF (NTMS .LE. 1) GO TO 320
      DYJ = DY(J)
      IF (DABS(DYJ) .LT. EPSI) GO TO 320
      DO 310 I = 2,NTMS
      II = II + 1
      DY(II) = DY(II) + DX(I)*DYJ
  310 CONTINUE
  320 DY(J) = DY(J)/DX(1)
C
C     BACKWARD SUBSTITUTION OMIT DIAGONAL
C
      IFW = -1
      IF (NROW .EQ. 1) GO TO 450
      J  = NROW
      DO 340 JX = 1,NROW
      DJJ = DX(NTMS+1)
      II  = IJJ(1)
      JJ  = IJJ(2)
      IF (II .NE. J) GO TO 380
      NTMS = JJ - II + 1
      JI = NTMS*NWD + 2
      CALL READ (*360,*370,IFILE,DX,JI,0,I)
      IF (NTMS .LE. 1) GO TO 340
      DO 330 I = 2,NTMS
      II = II + 1
      DY(J) = DY(J) + DX(I)*DY(II)
  330 CONTINUE
  340 J = J - 1
      GO TO 450
C
C     ERROR
C
  360 PARM(1) = -2
      GO TO 440
  370 PARM(1) = -3
      GO TO 440
  380 WRITE  (NOUT,390) IFW,II,J
  390 FORMAT ('   ERROR IN INVFBS.   IFW),II,J =',I3,1H),2I6)
      GO TO 420
  400 WRITE  (NOUT,410) FILEL(4)
  410 FORMAT ('0*** FILEL MATRIX IN WRONG FORMAT. UNPSCR FLAG =',I3)
  420 PARM(1) = -37
  440 CALL MESAGE (PARM(1),PARM(2),PARM(3))
C
  450 RETURN
      END

      SUBROUTINE DNORM(X,MAG)
C
C     DOUBLE PRECISION NORMALIZATION
C
      DOUBLE PRECISION        X(3)     ,MAG      ,A
C
      MAG= 0.D0
      A= X(1)*X(1) + X(2)*X(2) +X(3)*X(3)
      IF (A .GT. 0.D0) MAG= DSQRT(A)
      IF(MAG .EQ. 0.0D0) RETURN
      X(1) = X(1) / MAG
      X(2) = X(2) / MAG
      X(3) = X(3) / MAG
      RETURN
      END

      SUBROUTINE GKAM1B(USETD,SCR1,SCR2,PHIDH,PHIDH1,MODES,CORE,
     1  LHSET,NOUE,SCR3)
C
      INTEGER       USET,USETD,PHIDH,PHIDH1,SCR1,SCR2
      INTEGER MCB(7),SYSBUF,CORE
      INTEGER SCR3
      DIMENSION CORE(1)
C
      COMMON  /SYSTEM/ SYSBUF
      COMMON  /PATX/LC,N1,N2,N3,USET
      COMMON  /BITPOS/UM,UO,UR,USG,USB,UL,UA,UF,US,UN,UG,UE,UP,UNE,UFE,
     1UD
      COMMON  /ZBLPKX/A(4),II
      COMMON  /PARMEG/ IA(7),IA11(7),IA12(7),IA21(7),IA22(7),LCORE,IRULE
C
C ----------------------------------------------------------------------
C
      LHSET =LHSET  + NOUE
C
C     BUILD  MERGE  VECTOR
C
      USET = USETD
      LC  = KORSZ(CORE(MODES))
      LCORE = LC
      CALL  CALCV(SCR1,UD,UA,UE,CORE(MODES))
C
C     BUILD  EXE  IDENTY   MATRIX
C
      NZ = LC-SYSBUF
      CALL GOPEN(SCR2,CORE(NZ+1),1)
      CALL MAKMCB(MCB,SCR2,NOUE,6,1)
      A(1) = 1.0
      DO 10 I=1,NOUE
      CALL BLDPK(1,1,SCR2,0,0)
      II = I
      CALL ZBLPKI
      CALL BLDPKN(SCR2,0,MCB)
   10 CONTINUE
      CALL  CLOSE(SCR2, 1)
      CALL WRTTRL ( MCB )
C
C     SET  UP  FOR  MERGE
C
      IRULE =0
      IA22(1)= SCR2
      CALL RDTRL(IA22)
      IA(1) = PHIDH
      IA(2)= LHSET
      IA(3) =  N1+N2+N3
      IA(4) =  2
      IA(5) = 1
      IA21 (1) = 0
      IA12 (1) = 0
      IA11 (1) = PHIDH1
      CALL MAKMCB(CORE(MODES),SCR3,LHSET,2,1)
      CALL RDTRL (IA11)
C
C     BUILD  VECTOR IN CORE
C
      CALL GOPEN(SCR3,CORE(NZ+1),1)
      CALL BLDPK(1,1,SCR3,0,0)
      II = MODES -1
      DO 20 I=1,NOUE
      II = II+1
      CALL ZBLPKI
   20 CONTINUE
      CALL BLDPKN( SCR3, 0, CORE(MODES) )
      CALL CLOSE(SCR3,1)
      CALL WRTTRL(CORE(MODES))
      CALL MERGE(SCR3,SCR1,CORE(MODES))
      CALL WRTTRL( IA )
      RETURN
      END

      SUBROUTINE CFEER (EED,METHOD,NFOUND)
C
C     PREVIOUS THIS ROUITNE IS CALLED CFCNTL
C
C     GIVEN REAL OR COMPLEX MATRICES, CFEER WILL SOLVE FOR THE
C     REQUESTED NUMBER OF EIGENVALUES AND EIGENVECTORS CLOSEST TO A
C     SPECIFIED POINT IN THE COMPLEX PLANE, FOR UP TO TEN POINTS,
C     VIA THE TRIDIAGONAL REDUCTION (FEER) METHOD.
C     THE SUBROUTINE NAME  CFEER  STANDS FOR COMPLEX FEER CONTROL.
C
C     DEFINITION OF INPUT AND OUTPUT PARAMETERS
C
C     IK(7)    = MATRIX CONTROL BLOCK FOR THE INPUT STIFFNESS MATRIX K
C     IM(7)    = MATRIX CONTROL BLOCK FOR THE INPUT MASS      MATRIX M
C     IB(7)    = MATRIX CONTROL BLOCK FOR THE INPUT DAMPING   MATRIX B
C     ILAM(7)  = MATRIX CONTROL BLOCK FOR THE OUTPUT EIGENVALUES
C     IPHI(7)  = MATRIX CONTROL BLOCK FOR THE OUTPUT EIGENVECTORS
C     IDMPFL   = FILE CONTAINING THE EIGENVALUE SUMMARY
C     ISCR(11) = SCRATCH FILES USED INTERNALLY
C     REG(1,I) = INPUT REAL      PART OF CENTER I (LAMBDA)
C     REG(2,I) = INPUT IMAGINARY PART OF CENTER I (LAMBDA)
C     REG(5,I) = PROBLEM SIZE MAXIMUM FOR SETTING QPR
C     REG(6,I) = SUPPRESSES ANY SPECIAL SYMMETRY LOGIC
C     REG(7,I) = NUMBER OF DESIRED ROOTS AROUND CENTER I
C     REG(8,1) = CONVERGENCE CRITERION (EQUIV. TO REG(1,2) TEMPORARILY)
C
      LOGICAL           NO B     ,SYMMET   ,QPR
      INTEGER           METHOD   ,EED      ,NAME(2)  ,IZ(1)     ,
     1                  EIGC(2)  ,WANT(10) ,HAVE(10)
      DOUBLE PRECISION  LAMBDA   ,EPS
      DIMENSION         IREG(7,1),IHEAD(10)
      CHARACTER         UFM*23   ,UWM*25   ,UIM*29
      COMMON  /XMSSG /  UFM      ,UWM      ,UIM
      COMMON  /FEERAA/  IK(7)    ,IM(7)    ,IB(7)    ,ILAM(7)   ,
     1                  IPHI(7)  ,IDMPFL   ,ISCR(11) ,REG(7,10) ,
     2                  MCBLT(7) ,MCBUT(7) ,MCBVEC(7),MCBLMB(7)
      COMMON  /FEERXC/  LAMBDA(2),SYMMET   ,MREDUC   ,NORD      ,
     1                  IDIAG    ,EPS      ,NORTHO   ,NORD2     ,
     2                  NORD4    ,NORDP1   ,NSWP     ,JSKIP     ,
     3                  NO B     ,IT       ,TEN2MT   ,TENMHT    ,
     4                  NSTART   ,QPR      ,JREG     ,NOREG     ,
     5                  NZERO    ,TENMTT   ,MINOPN   ,NUMORT    ,
     6                  NUMRAN
      COMMON  /ZZZZZZ/  Z(1)
      COMMON  /NAMES /  RD       ,RDREW    ,WRT      ,WRTREW    ,
     1                  REW      ,NOREW    ,EOFNRW   ,RSP       ,
     2                  RDP
      COMMON  /SYSTEM/  KSYSTM(65)
      COMMON  /OUTPUT/  HEAD(1)
      EQUIVALENCE       (IREG(1,1),REG(1,1)),(ANODES,NODES)     ,
     1                  (KSYSTM(2),NOUT)    ,(KSYSTM(40),NBPW)  ,
     2                  (ASYM,NONSYM)       ,(Z(1),IZ(1))
      DATA    EIGC   /  207,2/
      DATA    IHEAD  /  0,1009,2,7*0/
      DATA    NAME   /  4HCFCN,4HTL  /
C
C     FILE ALLOCATION
C
C     ISCR( 1)  CONTAINS  (LAMBDA**2*M + LAMBDA*B + K) = DYNAMIC MATRIX
C     ISCR( 2)  CONTAINS -(LAMBDA*M + B) = NOT REQUIRED WHEN B = 0
C     ISCR( 3)  CONTAINS LOWER TRIANGLE OF DECOMPOSED DYNAMIC MATRIX
C     ISCR( 4)  CONTAINS UPPER TRIANGLE OF DECOMPOSED DYNAMIC MATRIX
C     ISCR( 5)  CONTAINS REDUCED TRIDIAGONAL MATRIX ELEMENTS
C     ISCR( 6)  CONTAINS SPECIAL UPPER TRIANGLE FOR TRANSPOSED SWEEP
C     ISCR( 7)  CONTAINS THE ORTHOGONAL VECTORS
C     ISCR( 8)  CONTAINS OUTPUT EIGENVALUES , FOR INPUT TO CEAD1A
C     ISCR( 9)  CONTAINS OUTPUT EIGENVECTORS, FOR INPUT TO CEAD1A
C     ISCR(10)  SCRATCH FILE USED IN CFEER4
C     ISCR(11)  NOT USED
C
C     DEFINITION OF INTERNAL PARAMETERS
C
C     NODES  = NUMBER OF DESIRED ROOTS IN CURRENT NEIGHBORHOOD
C     EPS    = ACCURACY CRITERION - USED FOR REJECTING EIGENSOLUTIONS
C     NOREG  = TOTAL NUMBER OF CENTERS (NEIGHBORHOODS) INPUT,
C              EQUIVALENT TO THE NUMBER OF EIGC CONTINUATION CARDS
C     JREG   = COUNTER FOR CURRENT NEIGHBORHOOD
C     MREDUC = SIZE OF THE REDUCED PROBLEM IN CURRENT NEIGHBORHOOD
C     NFOUND = ACCUMULATED NUMBER OF ACCEPTABLE EIGENSOLUTIONS
C     NORD   = 2*N IF B.NE.0 AND = N IF B.EQ.0, WHERE B IS THE
C              DAMPING MATRIX AND N IS THE PROBLEM SIZE
C     NORD2  = VECTOR SIZE OF ORIGINAL PROBLEM (COMPLEX SINGLE
C              PRECISION OR COMPLEX DOUBLE PRECISION)
C     NSWP   = COMPLEX VECTOR SIZE FOR SWEEP ALGORITHM
C     NO B   = LOGICAL INDICATOR FOR ABSENCE OF DAMPING MATRIX B
C     SYMMET = LOGICAL INDICATOR FOR SYMMETRIC DYNAMIC MATRIX
C     NONSYM = PROGRAM INPUT WHICH FORCES THE PROGRAM TO CONSIDER
C              THE DYNAMIC MATRIX AS NON-SYMMETRIC
C     IT     = NUMBER OF DECIMAL DIGITS OF ACCURACY FOR THE COMPUTER
C     TEN2MT = 10**(2-T) CONVERGENCE CRITERION
C     TENMHT = 10**(-HALF*T) CONVERGENCE CRITERION
C     TENMTT = 10**(-THIRD*T) RIGID BODY ROOT CRITERION
C     NORTHO = TOTAL CURRENT NUMBER OF ORTHOGONAL VECTOR PAIRS ON
C              ORTHOGONAL VECTOR FILE. INITIALIZED TO NUMBER OF
C              EIGENVECTOR PAIRS ON THE RESTART FILE.
C     MINOPN = MINIMUM OPEN CORE NOT USED (WORDS)
C     NSTART = NUMBER OF INITIAL REORTHOGONALIZATION ATTEMPTS
C     IDIAG  = DIAG 12 PRINT CONTROL
C     QPR    = LOGICAL INDICATOR FOR VERY DETAILED PRINTOUT
C     WANT   = ARRAY OF DESIRED NUMBER OF ROOTS IN EACH NEIGHBORHOOD
C     HAVE   = ARRAY OF ACTUAL  NUMBER OF ROOTS IN EACH NEIGHBORHOOD
C
      NORTHO = 0
      NFOUND = NORTHO
      NZERO  = NORTHO
      JSKIP  = 0
      CALL SSWTCH (12,IDIAG)
C
C     TEST COMPUTING MACHINE TYPE AND SET PRECISION PARAMETERS
C
      IF (NBPW .GE. 60) GO TO 20
      IT = 8*KSYSTM(55)
      GO TO 21
   20 IT = 14*KSYSTM(55)
   21 TEN2MT = 10.**(2-IT)
      TENMHT = 10.**(-IT/2)
      TENMTT = 10.**(-IT/3)
      IK(1)  = 101
      CALL RDTRL (IK)
      IM(1)  = 103
      CALL RDTRL (IM)
      IB(1)  = 102
      CALL RDTRL (IB)
      IF (IB(1).LT.0 .OR. IB(6).EQ.0) IB(1) = 0
C
C     DETERMINE IF THE DYNAMIC MATRIX IS SYMMETRIC
C
      SYMMET = .FALSE.
      IF (IK(1).NE.0 .AND. IK(4).NE.6) GO TO 30
      IF (IM(1).NE.0 .AND. IM(4).NE.6) GO TO 30
      IF (IB(1).NE.0 .AND. IB(4).NE.6) GO TO 30
      SYMMET = .TRUE.
   30 DO 40 I = 1,11
   40 ISCR(I)= 300+I
      IDMPFL = 203
      NZ     = KORSZ(Z)
      IBUF   = NZ - KSYSTM(1) - 2
      LIMSUM = 12
      IOPN   = IBUF - LIMSUM
      IF (IDIAG .NE. 0) WRITE (NOUT,600) IOPN
      IF (IOPN  .LE. 0) CALL MESAGE (-8,0,NAME)
      MINOPN = IOPN
      ILAM(1)= 308
      IPHI(1)= 309
      IFILE  = ILAM(1)
      CALL OPEN (*500,ILAM,Z(IBUF),WRTREW)
      CALL CLOSE (ILAM,REW)
      IFILE  = IPHI(1)
      CALL OPEN (*500,IPHI,Z(IBUF),WRTREW)
      CALL CLOSE (IPHI,REW)
      CALL GOPEN (IDMPFL,Z(IBUF),WRTREW)
      CALL CLOSE (IDMPFL,EOFNRW)
C
C     PROCURE DATA FROM MAIN EIGC CARD
C
      IFILE = EED
      CALL PRELOC (*500,Z(IBUF),EED)
      CALL LOCATE (*500,Z(IBUF),EIGC(1),FLAG)
   50 CALL FREAD (EED,IREG,10,0)
      IF (IREG(1,1) .EQ. METHOD) GO TO 70
   60 CALL FREAD (EED,IREG,7,0)
      IF (IREG(6,1) .NE. -1) GO TO 60
      GO TO 50
   70 JREG  = 1
      EPS   =.1D0/IK(2)/100.D0
      IF (REG(1,2) .GT. 0.) EPS = DBLE(REG(1,2))/100.D0
      UNIDUM= SNGL(EPS)*100.
      IF (IDIAG .NE. 0) WRITE (NOUT,75) UNIDUM,REG(1,2)
   75 FORMAT (1H0,5HCFEER,6X,18HACCURACY CRITERION,1P,E16.8,
     2        8X,12H(INPUT VALUE,E16.8,1H))
C
C     PROCURE DATA FROM EIGC CONTINUATION CARDS
C
   80 CALL FREAD (EED,IREG(1,JREG),7,0)
      IF (IREG(6,JREG) .EQ. -1) GO TO 90
      JREG  = JREG + 1
      IF (JREG .GT. 10) GO TO 90
      GO TO 80
   90 CALL CLOSE (EED,REW)
      NOREG  = JREG - 1
      NODCMP = 0
      NUMORT = 0
      NUMRAN = 0
      JREG   = 0
C
C     PICK UP PARAMETERS FOR NEIGHBORHOOD I
C
  100 JREG = JREG + 1
      IF (JREG .LE. NOREG) GO TO 105
      JREG = NOREG
      IF (NZERO .GT. 0) JSKIP = -1
      GO TO 175
  105 X1 = REG(1,JREG)
      Y1 = REG(2,JREG)
      ANODES = REG(7,JREG)
      ASYM   = REG(6,JREG)
      IF (NONSYM .NE. 0) SYMMET = .FALSE.
      NPRINT = IFIX(REG(5,JREG))
      QPR = .FALSE.
      IF (IDIAG.NE.0 .AND. NPRINT.GE.IK(2)) QPR = .TRUE.
      IF (IDIAG .NE. 0) WRITE (NOUT,110) JREG,X1,Y1,NODES,NONSYM
  110 FORMAT (1H0,5HCFEER,6X,12HNEIGHBORHOOD,I3,8X,8HCENTER =,2F18.8,
     1        8X,15HNO. DES. RTS. =,I5,8X,8HNONSYM =,I2/1H )
C
C     TEST IF USER PICKED THE ORIGIN
C
      IF (X1.NE.0. .OR. Y1.NE.0.) GO TO 120
      X1 = X1 + .001
      WRITE (NOUT,601) UWM
  120 IF (NODES .GT. 0) GO TO 130
      WRITE (NOUT,602) UWM,NODES
      NODES = 1
  130 WANT(JREG) = NODES
      HAVE(JREG) = 0
      NORD  = 2*IK(2)
      NO B  = .FALSE.
      IF (IB(1) .GT. 0) GO TO 140
      NO B  = .TRUE.
      NORD  = IK(2)
  140 NSWP  = IK(2)
      NORD2 = 2*NORD
      NORD4 = 2*NORD2
      NORDP1= NORD + 1
      MREDUC= 2*NODES + 10
      NOMNF = NORD - NFOUND
      IF (MREDUC .GT. NOMNF) MREDUC = NOMNF
      LAMBDA(1) = X1
      LAMBDA(2) = Y1
      IF (NODES .GT. NORD) WRITE (NOUT,606) UWM,NODES,JREG,NOREG,LAMBDA,
     1                                      NORD
      ISING = 0
C
C      FORM (LAMBDA**2*M + LAMBDA*B + K) = THE DYNAMIC MATRIX
C
  150 CALL CFEER1
C
C     CALL IN CDCOMP TO DECOMPOSE THE DYNAMIC MATRIX
C
      NODCMP = NODCMP + 1
      CALL CFEER2 (IRET)
      IF (IRET .NE. 0) GO TO 160
      GO TO 170
  160 IRET = IRET + ISING
      WRITE (NOUT,603) UWM,IRET,LAMBDA
      IF (ISING .EQ. 1) GO TO 100
C
C     SINGULAR MATRIX. INCREMENT LAMBDA AND TRY ONCE MORE.
C
      ISING = 1
      LAMBDA(1) = LAMBDA(1) + .02D0
      LAMBDA(2) = LAMBDA(2) + .02D0
      GO TO 150
C
C     CALL IN DRIVER TO GENERATE REDUCED TRIDIAGONAL MATRIX
C
  170 CALL CFEER3
      IF (NSTART .GT. 2) GO TO 100
C
C     OBTAIN EIGENVALUES AND EIGENVECTORS
C
      CALL CFEER4
      HAVE(JREG) = MREDUC
      IF (MREDUC .LE. NODES) GO TO 180
      I = MREDUC - NODES
      WRITE (NOUT,607) UIM,I,NODES,JREG,NOREG,LAMBDA
  180 NFOUND = NFOUND + MREDUC
      IF (JREG.LT.NOREG .AND. NFOUND.LT.NORD) GO TO 100
C
C     FEER IS FINISHED. PERFORM WRAP-UP OPERATIONS.
C
  175 IF (JSKIP  .LT. 0) CALL CFEER4
      IF (NFOUND .EQ. 0) GO TO 250
      IF (NFOUND .GE. NORD) GO TO 220
  200 DO 210 I = 1,JREG
      IF (HAVE(I) .LT. WANT(I)) GO TO 240
  210 CONTINUE
      GO TO 230
C
C     ALL SOLUTIONS FOUND
C
  220 WRITE (NOUT,604) UIM
      IF (JREG .LT. NOREG) GO TO 240
      GO TO 200
C
C     EACH REQUESTED NEIGHBORHOOD HAS THE DESIRED NUMBER OF ROOTS
C
  230 ITERM = 0
      GO TO 260
C
C     AT LEAST ONE REQUESTED NEIGHBORHOOD FAILS TO HAVE THE DESIRED
C     NUMBER OF ROOTS
C
  240 ITERM = 1
      GO TO 260
C
C     ABNORMAL TERMINATION. NO ROOTS FOUND.
C
  250 ITERM = 2
C
C     WRITE INFORMATION ON NASTRAN SUMMARY FILE
C
  260 IFILE = IDMPFL
      CALL OPEN (*500,IDMPFL,Z(IBUF),WRT)
      DO 270 I = 1,LIMSUM
  270 IZ(I) = 0
      I = 0
      IZ(I+2) = NORTHO
      IZ(I+3) = NUMRAN
      IZ(I+5) = NODCMP
      IZ(I+6) = NUMORT
      IZ(I+7) = ITERM
      IZ(I+8) = 1
      I = 2
      CALL WRITE (IDMPFL,IHEAD(1),10,0)
      CALL WRITE (IDMPFL,IZ(I),40,0)
      CALL WRITE (IDMPFL,HEAD(1),96,1)
      CALL WRITE (IDMPFL,IZ(1),0,1)
      CALL CLOSE (IDMPFL,EOFNRW)
C
C     WRITE DUMMY TRAILER
C
      IXX   = IK(1)
      IK(1) = IDMPFL
      CALL WRTTRL (IK(1))
      IK(1) = IXX
C
C     INFORM USER IF RUN REGION SIZE CAN BE REDUCED
C
      IF (NBPW-36) 300,310,320
  300 I = 4
      GO TO 330
  310 I = 6
      GO TO 330
  320 I = 10
      IF (NBPW .EQ. 64) I = 8
  330 I = (I*MINOPN)/1000
      IF (I .LT. 0) I = 0
      WRITE (NOUT,605) UIM,MINOPN,I
      RETURN
C
  500 CALL MESAGE (-1,IFILE,NAME)
      RETURN
C
C
  600 FORMAT (1H1,27X,'*****  F E E R  *****  (FAST EIGENVALUE',
     1        ' EXTRACTION ROUTINE)  *****',  ////,1H ,I10,' SINGLE ',
     2        'PRECISION WORDS OF OPEN CORE, NOT USED (SUBROUTINE ',
     3        'CFEER)', //)
  601 FORMAT (A25,' 3149',//5X,'USER SPECIFIED NEIGHBORHOOD CENTERED AT'
     1,      ' ORIGIN NOT ALLOWED, CENTER SHIFTED TO THE RIGHT .001',//)
  602 FORMAT (A25,' 3150',//5X,'DESIRED NUMBER OF EIGENVALUES',I8,3X,
     1       'INVALID. SET = 1.',//)
  603 FORMAT (A25,' 3151',//5X,'DYNAMIC MATRIX IS SINGULAR (OCCURRENCE',
     1       I3,') IN NEIGHBORHOOD CENTERED AT ',1P,2D16.8,//)
  604 FORMAT (A29,' 3159',//5X,'ALL SOLUTIONS HAVE BEEN FOUND.',//)
  605 FORMAT (A29,' 3160',//5X,'MINIMUM OPEN CORE NOT USED BY FEER',I9,
     1       ' WORDS (',I9,'K BYTES).',//)
  606 FORMAT (A25,' 3161',//5X,'DESIRED NUMBER OF EIGENSOLUTIONS',I5,
     1       ' FOR NEIGHBORHOOD',I3,' OF',I3,' CENTERED AT ',1P,2D16.8,
     2       //5X,'EXCEEDS THE EXISTING NUMBER',I5,
     3       ', ALL EIGENSOLUTIONS WILL BE SOUGHT.',//)
  607 FORMAT (A29,' 3166',//1X,I5,' MORE ACCURATE EIGENSOLUTIONS THAN ',
     1       'THE',I5,' REQUESTED HAVE BEEN FOUND FOR NEIGHBORHOOD',I3,
     2       ' OF',I3, //5X,'CENTERED AT ',1P,2D16.8,
     3       '. USE DIAG 12 TO DETERMINE ERROR ESTIMATES.',//)
      END

      SUBROUTINE LINE10 (X1,Y1,X2,Y2,PENDEN,OPT)
C
C     X1,Y1  = STARTING POINT OF THE LINE
C     X2,Y2  = TERMINAL POINT OF THE LINE
C     PENDEN = PEN NUMBER OR LINE DENSITY
C     OPT    = -1 TO INITIATE  THE LINE MODE
C            = +1 TO TERMINATE THE LINE MODE
C            = 0 TO DRAW A LINE
C
      INTEGER PENDEN,OPT,OPTX,A(6)
      DATA    OPTX,LINE / -1, 5  /
C
      IF (OPTX .GE. 0) OPTX = OPT
      IF (OPT) 200,100,150
  100 A(1) = LINE
      A(2) = PENDEN
      A(3) = IFIX(X1+.1)
      A(4) = IFIX(Y1+.1)
      A(5) = IFIX(X2+.1)
      A(6) = IFIX(Y2+.1)
      IF (OPTX .EQ. 0) GO TO 120
C
C     INITIATE THE LINE MODE.
C
      A(1) = A(1) + 10
      OPTX = 0
C
C     DRAW THE LINE.
C
  120 CALL WPLT10 (A,0)
      GO TO 200
C
C     TERMINATE THE LINE MODE.
C
  150 CALL WPLT10 (A,1)
      OPTX = -1
C
  200 RETURN
      END

      SUBROUTINE SMA3C(IFLAG,K)
C
C     THIS ROUTINE WILL MERGE ZINVS,ZS,STZ,AND STZS INTO KE AND
C       BUILD KE UP TO G SIZE.  IF INFLAG .LT. 0 THERE ARE NO
C       UD-S
C
      DOUBLE PRECISION A11,B11,D11
      INTEGER ZINVS,ZS,STZ,STZS,GEI,SYSBUF,NAME(2),IZ(1)
      DIMENSION BLOCK1(20),BLOCK2(20),K(7)
C
      COMMON /BLANK/LUSET
      COMMON /ZZZZZZ/ Z(1)
      COMMON /ZBLPKX/ D11(2),ID
      COMMON /SYSTEM/ SYSBUF, DUMMY(53), IPREC
      COMMON /GENELY/GEI,DUM(4),STZS(1),ZINVS(1),ZS(1),STZ(1),DUM1(62),
     1  M,N
C
      EQUIVALENCE (Z(1),IZ(1))
      DATA NAME / 4HSMA3,4HC    /
C
C     IUI IS POINTER TO UI SET, IUD IS POINTER TO UD SET
C
      IUI =1
      IUD =M+1
      NZ = KORSZ(Z)
C
C     OPEN GEI(WITHOUT REWIND)
C
      NZ = NZ -SYSBUF
      CALL GOPEN(GEI,Z(NZ+1),2)
C
C     READ IN UI SET
C
      CALL FREAD(GEI,Z,-3,0)
      CALL FREAD(GEI,Z, M,0)
C
C     READ IN UD
C
      IF (IFLAG .LT. 0) GO TO 10
      CALL FREAD(GEI,Z(IUD),N,1)
C
C     OPEN BUFFERS FOR MATRICES
C
   10 LLEN = M+N+2*SYSBUF
      IF(IFLAG .GE. 0) LLEN = LLEN+3*SYSBUF
      IF (LLEN .GT. NZ) GO TO 220
      NZ = NZ-SYSBUF
      CALL GOPEN(K,Z(NZ+1),1)
      NZ = NZ -SYSBUF
      CALL GOPEN(ZINVS,Z(NZ+1),0)
      IF (IFLAG .LT. 0) GO TO 20
      NZ =NZ -SYSBUF
      CALL GOPEN(ZS,Z(NZ+1),0)
      NZ =NZ -SYSBUF
      CALL GOPEN(STZ,Z(NZ+1),0)
      NZ =NZ -SYSBUF
      CALL GOPEN(STZS,Z(NZ+1),0)
C
C     LOOP ON LUSET MAKING COLUMNS OF KGG
C
   20 K(2) = 0
      K(3) = LUSET
      K(4) = 6
      K(5) = 2
      K(6) = 0
      K(7) = 0
      IIP = 0
      IDP = 0
      DO 170 I=1,LUSET
      CALL BLDPK (2, IPREC, K(1), 0, 0)
      IF( IIP.GE.M )  GO TO 25
      L = IUI + IIP
      IF (I .EQ. IZ(L)) GO TO 30
   25 CONTINUE
      IF (IFLAG .LT. 0) GO TO 160
      IF( IDP.GE.N )  GO TO 160
      L = IUD + IDP
      IF (I .EQ. IZ(L)) GO TO 40
      GO TO 160
C
C     USING UI -- ZINVS AND STZ
C
   30 IIP = IIP +1
      NAM1 = ZINVS(1)
      NAM2 = STZ(1)
      GO TO 50
C
C     USING UD ZS AND STZS
C
   40 IDP = IDP +1
      NAM1 = ZS(1)
      NAM2 = STZS(1)
C
C     MERGE ROUTINE FOR COLUMN
C
   50 IAD = 0
      IBD = 0
      IHOP = 0
      CALL INTPK(*140,NAM1,BLOCK1(1),2,1)
   60 IF(IFLAG .LT. 0) GO TO 150
      CALL INTPK(*150,NAM2,BLOCK2(1),2,1)
   70 CALL INTPKI(A11,IA,NAM1,BLOCK1(1),IAEOL)
      L=  IUI +IA -1
      II = IZ(L)
      IF (IHOP .EQ. 1) GO TO 90
      IHOP = 1
   80 CALL INTPKI(B11,IB,NAM2,BLOCK2(1),IBEOL)
      L = IUD +IB -1
      JJ = IZ(L)
   90 IF (II-JJ) 100,320,120
C
C     PUT IN A11
C
  100 D11(1) =A11
      ID = II
      CALL ZBLPKI
      IF (IAEOL) 110,70,110
  110 IAD = 1
      II = 99999
      IF(IBD) 160,120,160
C
C     PUT IN BUU
C
  120 D11(1) = B11
      ID = JJ
      CALL ZBLPKI
      IF (IBEOL) 130,80,130
  130 IBD = 1
      JJ = 99999
      IF(IAD) 160,100,160
C
C     NULL NAM1
C
  140 IAD =1
      II = 99999
      GO TO 60
C
C     NO NAM2
C
  150 IBD =1
      JJ = 99999
      IHOP =1
      GO TO 70
C
C     END OF COLUMN
C
  160 CALL BLDPKN(K(1),0,K)
C
C     END LOOP
C
  170 CONTINUE
      CALL WRTTRL (K)
      CALL CLOSE (K(1),1)
      CALL CLOSE (ZINVS(1),1)
      IF (IFLAG .LT. 0) GO TO 180
      CALL CLOSE (STZ(1),1)
      CALL CLOSE (STZS(1),1)
      CALL CLOSE (ZS(1),1)
  180 RETURN
C
C     ERROR MESAGES
C
  220 CALL MESAGE(-8,GEI,NAME)
  320 CALL MESAGE(-7,0,NAME)
      RETURN
      END

      SUBROUTINE CFEER3
C
C     CFEER3 IS A DRIVER ROUTINE WHICH PERFORMS THE TRIDIAGONAL
C     REDUCTION FOR THE COMPLEX FEER METHOD
C
      INTEGER           SWITCH   ,CDP      ,SQR      ,SYSBUF     ,
     1                  NAME(2)
      DOUBLE PRECISION  LAMBDA   ,DZ(1)
      COMMON  /NAMES /  RD       ,RDREW    ,WRT      ,WRTREW     ,
     1                  REW      ,NOREW    ,EOFNRW   ,RSP        ,
     2                  RDP      ,CSP      ,CDP      ,SQR
      COMMON  /SYSTEM/  KSYSTM(65)
      COMMON  /ZZZZZZ/  Z(1)
      COMMON  /FEERXC/  LAMBDA(2),SWITCH   ,MREDUC   ,NORD       ,
     1                  IDIAG    ,EPSDUM(2),NORTHO   ,NORD2      ,
     2                  NORD4    ,NORDP1   ,XCDUM(12),MINOPN
      COMMON  /FEERAA/  IK(7)    ,IM(7)    ,IB(7)    ,ILAM(7)    ,
     1                  IPHI(7)  ,DUDXX    ,ISCR(11) ,DUMAA(84)  ,
     2                  MCBVEC(7)
      EQUIVALENCE       (DZ(1)   ,Z(1)   ) ,(KSYSTM(55),IPREC)   ,
     1                  (KSYSTM(1),SYSBUF) ,(KSYSTM( 2),NOUT )
      DATA     NAME  /  4HCFEE,4HR3  /
C
C     SCRATCH FILE AND BUFFER ALLOCATION
C
C     FILE  5  CONTAINS THE ELEMENTS OF REDUCED TRIDIAGONAL MATRIX
C     FILE  7  CONTAINS THE ORTHOGONAL VECTOR PAIRS (NUMBER OF
C              VECTOR PAIRS = NORTHO)
C
C     BUFFER Z(IBUF1) IS LOCAL SCRATCH BUFFER
C     BUFFER Z(IBUF2) IS LOCAL SCRATCH BUFFER
C     BUFFER Z(IBUF3) IS USED BY FILE 5
C
C
C     COMPUTE STORAGE ALLOCATIONS
C
      NZ    = KORSZ(Z)
      IBUF1 = NZ    - SYSBUF
      IBUF2 = IBUF1 - SYSBUF
      IBUF3 = IBUF2 - SYSBUF
      ITOP  = IBUF3
C
C     COMPUTE LOCATIONS OF RIGHT-HANDED VECTORS
C
      IV1 = 1
      IV2 = IV1 + NORD4
      IV3 = IV2 + NORD4
      IV4 = IV3 + NORD4
      IV5 = IV4 + NORD4
C
C     TEST FOR INSUFFICIENT CORE
C
      IEND = IPREC*(5*NORD4+1)
      IF (IEND .GT. ITOP) GO TO 70
C
C     COMPUTE LOCATIONS OF LEFT-HANDED VECTORS
C
      IV1L = IV1 + NORD2
      IV2L = IV2 + NORD2
      IV3L = IV3 + NORD2
      IV4L = IV4 + NORD2
      IV5L = IV5 + NORD2
      IOPN = ITOP- IEND
      IF (IDIAG .NE. 0) WRITE (NOUT,510) IOPN
      IF (IOPN .LT. MINOPN) MINOPN = IOPN
C
C     INITIALIZE SCRATCH FILE TO CONTAIN TRIDIAGONAL ELEMENTS
C
      CALL GOPEN (ISCR(5),Z(IBUF3),WRTREW)
C
C     GENERATE MATRIX CONTROL BLOCK FOR SCRATCH FILE TO CONTAIN
C     ORTHOGONAL VECTORS (LEFT VECTOR PACKED IMMEDIATELY AFTER
C     RIGHT, I. E., EACH COLUMN CONTAINS RIGHT VECTOR FOLLOWED BY
C     LEFT VECTOR)
C
      JPREC = IPREC + 2
      CALL MAKMCB (MCBVEC(1),ISCR(7),NORD2,2,JPREC)
C
C     PERFORM DOUBLE PRECISION FEER
C
      IF (IPREC.EQ.2) CALL CFER3D (DZ(IV1),DZ(IV1L), DZ(IV2),DZ(IV2L),
     1                             DZ(IV3),DZ(IV3L), DZ(IV4),DZ(IV4L),
     2                             DZ(IV5),DZ(IV5L), Z(IBUF1),Z(IBUF2))
C
C     PERFORM SINGLE PRECISION FEER
C
      IF (IPREC.NE.2) CALL CFER3S (Z(IV1),Z(IV1L), Z(IV2),Z(IV2L),
     1                             Z(IV3),Z(IV3L), Z(IV4),Z(IV4L),
     2                             Z(IV5),Z(IV5L), Z(IBUF1),Z(IBUF2))
C
C     TERMINATE SCRATCH FILE CONTAINING TRIDIAGONAL ELEMENTS
C
      CALL CLOSE (ISCR(5),NOREW)
      RETURN
C
   70 IEND = (IEND-ITOP)/1000 + 1
      WRITE  (NOUT,80) IEND
   80 FORMAT (5H0NEED,I4,17HK MORE CORE WORDS)
      CALL MESAGE (-8,0,NAME)
  510 FORMAT (1H ,I10,36H SINGLE PRECISION WORDS OF OPEN CORE,
     1       29H NOT USED (SUBROUTINE CFEER3))
      END

      SUBROUTINE DDRMM
C
C     DYNAMIC-DATA-RECOVERY-MATRIX-METHOD
C
C     DMAP SEQUENCES. ONLY SORT2 IS USED
C
C     (TRANSIENT RESPONCE)
C     ====================
C     DDRMM    CASEXX,UHVT,PPT,IPHIP2,IQP2,IES2,IEF2,XYCDB,EST,MPT,DIT/
C              ZUPV2,ZQP2,ZES2,ZEF2, $
C
C     (FREQUENCY RESPONSE)
C     ====================
C     DDRMM    CASEXX,UHVF,PPF,IPHIP1,IQP1,IES1,IEF1,XYCDB,EST,MPT,DIT/
C              ZUPVC1,ZQPC1,ZESC1,ZEFC1, $
C       OR
C     DDRMM    CASEXX,UHVF,PPF,IPHIP2,IQP2,IES2,IEF2,XYCDB,EST,MPT,DIT/
C              ZUPVC2,ZQPC2,ZESC2,ZEFC2, $
C
      LOGICAL  TRNSNT  ,SORT2    ,COL1     ,FRSTID
      INTEGER  OUTPT   ,SYSBUF   ,Z        ,RD       ,WRT      ,CLS
      INTEGER  FILE    ,BUF(150) ,UV       ,RDREW    ,WRTREW   ,CLSREW
      INTEGER  CASECC  ,PHASE    ,SUBR(2)  ,BUFF     ,DHSIZE
      INTEGER  PP      ,DVA(3)   ,SCRT1    ,SCRT2    ,SCRT3    ,SCRT4
      INTEGER  SCRT5   ,SCRT6    ,FRQSET   ,ENTRYS   ,SCRT     ,BUF1
      INTEGER  BUF2    ,BUF3     ,BUF4     ,BUF5     ,BUF6
      INTEGER  IFILE(4),OFILE(4) ,FILNAM   ,SETS     ,PASSES
      INTEGER  EOR     ,OUTFIL   ,SETID    ,UVSOL    ,SCRT7
      INTEGER  SAVDAT  ,SUBCAS   ,INBLK(15),OUBLK(15)
      REAL     RZ(1)   ,LAMBDA   ,RIDREC(146)
      CHARACTER         UFM*23   ,UWM*25   ,UIM*29   ,SFM*25   ,SWM*27
      COMMON  /XMSSG /  UFM      ,UWM      ,UIM,SFM  ,SWM
      COMMON  /SYSTEM/  SYSBUF   ,OUTPT    ,XSYS(22) ,ISWTCH
      COMMON  /NAMES /  RD       ,RDREW    ,WRT      ,WRTREW   ,CLSREW
     1                 ,CLS
      COMMON  /ZZZZZZ/  Z(1)
      COMMON  /DDRMC1/  IDREC(146),BUFF(6) ,PASSES   ,OUTFIL   ,JFILE
     1                 ,MCB(7)   ,ENTRYS   ,SETS(5,3),INFILE   ,LAMBDA
     2                 ,FILE     ,SORT2    ,COL1     ,FRSTID   ,NCORE
     3                 ,NSOLS    ,DHSIZE   ,FILNAM(2),RBUF(150),IDOUT
     4                 ,ICC      ,NCC      ,ILIST    ,NLIST    ,NWDS
     5                 ,SETID    ,TRNSNT   ,I1       ,I2       ,PHASE
     6                 ,ITYPE1   ,ITYPE2   ,NPTSF    ,LSF      ,NWDSF
     7                 ,SCRT(7)  ,IERROR   ,ITEMP    ,DEVICE   ,FORM
     8                 ,ISTLST   ,LSTLST   ,UVSOL    ,NLAMBS   ,NWORDS
     9                 ,OMEGA    ,IPASS    ,SUBCAS
      COMMON  /STDATA/  LMINOR   ,NSTXTR   ,NPOS     ,SAVDAT(110)
      EQUIVALENCE       (RZ(1),Z(1))   , (RBUF(1),BUF(1))
      EQUIVALENCE       (SCRT1,SCRT(1)), (SCRT2,SCRT(2))
      EQUIVALENCE       (SCRT3,SCRT(3)), (SCRT4,SCRT(4))
      EQUIVALENCE       (SCRT5,SCRT(5)), (SCRT6,SCRT(6))
      EQUIVALENCE       (SCRT7,SCRT(7)), (RIDREC(1),IDREC(1))
      EQUIVALENCE       (BUF1,BUFF(1)) , (BUF2,BUFF(2))
      EQUIVALENCE       (BUF3,BUFF(3)) , (BUF4,BUFF(4))
      EQUIVALENCE       (BUF5,BUFF(5)) , (BUF6,BUFF(6))
      DATA     IFROUT/  145 /,  DVA   / 20, 32, 29 /
      DATA     ISTRES,  IFORCE, ISPCF / 23, 26, 35 /
      DATA     ILSYM /  166 /
      DATA     SUBR  /  4HDDRM, 4HM        /
      DATA     EOR   ,  NOEOR  / 1,  0        /
      DATA     CASECC,  UV, PP /  101, 102, 103 /
      DATA     IFILE /  104, 105, 106, 107 /
      DATA     OFILE /  201, 202, 203, 204 /
C
C     DETERMINE OPEN CORE AVAILABLE AND ALLOCATE BUFFERS.
C
      DO 5 I = 1,100
    5 SAVDAT(I) = 0
      DO 6 I = 6,8
      SAVDAT(I   ) = 102
    6 SAVDAT(I+11) = 102
      SAVDAT(  15) = 102
      SAVDAT(  76) = 2
      SAVDAT(  77) = 10
      DO 10 I = 1,7
      SCRT(I) = I + 300
   10 CONTINUE
      NCORE = KORSZ(Z)
      DO 20 I = 1,6
      BUFF(I) = NCORE - SYSBUF - 2
      NCORE   = BUFF(I) - 1
   20 CONTINUE
C
C     GET FIRST SUBCASE OF CASE CONTROL INTO CORE
C
      IERROR = 0
      SUBCAS = 1
      ICC    = 1
      FILE   = CASECC
      CALL OPEN (*480,CASECC,Z(BUF1),RDREW)
      CALL FWDREC (*490,CASECC)
      CALL READ (*490,*30,CASECC,Z(ICC),NCORE-ICC,NOEOR,NWDS)
      IERROR = 1
      GO TO 510
C
   30 NCC = ICC + NWDS - 1
      CALL CLOSE (CASECC,CLS)
C
C     READ TRAILER OF SOLUTION DATA BLOCK. IF SOLUTION IS
C     COMPLEX, THEN FREQUENCY RESPONCE IS ASSUMED. IF REAL, THEN
C     TRANSIENT RESPONSE IS ASSUMED.
C
      MCB(1) = UV
      CALL RDTRL (MCB)
      TRNSNT = .TRUE.
      IF (MCB(5) .GT. 2) TRNSNT = .FALSE.
C
C     SET NUMBER OF EIGENVALUES = ROWS IN SOLUTION DATA BLOCK
C
      NLAMBS = MCB(3)
C
C     SET NUMBER OF SOLUTIONS.(TIME STEPS X 3, OR FREQUENCYS)
C
      NSOLS = MCB(2)
C
C     OPEN UV AND POSITION OVER HEADER RECORD.
C
      FILE = UV
      CALL OPEN (*480,UV,Z(BUF1),RDREW)
      CALL FWDREC (*490,UV)
      CALL CLOSE (UV,CLS)
C
C     READ LIST OF FREQUENCYS OR TIME STEPS FROM INPUT LOAD MATRIX
C     HEADER.
C
   33 ILIST = NCC + 1
      FILE  = PP
      CALL OPEN (*480,PP,Z(BUF1),RDREW)
      IERROR = 2
      CALL READ (*490,*500,PP,BUF(1),-2,NOEOR,NWDS)
      CALL READ (*490,*35,PP,Z(ILIST),NCORE-ILIST,NOEOR,ENTRYS)
      GO TO 510
C
   35 NLIST = ILIST + ENTRYS - 1
      CALL CLOSE (PP,CLSREW)
C
C     IF FREQUENCY RESPONSE PROBLEM, AND USER HAS SPECIFIED A LIST OF
C     FREQUENCYS TO BE USED AS A GUIDE IN DETERMINING A SUBSET OF
C     SOLUTIONS FOR OUTPUT PURPOSES, AND NOT ALL SOLUTIONS WILL BE
C     OUTPUT, THEN A MODIFIED SOLUTION MATRIX IS NOW FORMED ON
C     SCRATCH-1. THIS WILL ELIMINATE UNNECESSARY MATRIX-MULTIPLIES LATER
C
C     IN ANY EVENT THE NEXT SUBCASE-S SOLUTIONS ARE PLACED ON SCRT1.
C
      UVSOL = UV
      IF (TRNSNT) GO TO 190
C
C     EXPAND LIST OF FREQS PLACING A FLAG AFTER EACH.
C
      J = NLIST
      NLIST  = NLIST + ENTRYS
      IERROR = 4
      IF (NLIST .GT. NCORE) GO TO 510
      K = NLIST - 1
      DO 40 I = 1,ENTRYS
      Z(K  ) = Z(J)
      Z(K+1) = 0
      K = K - 2
      J = J - 1
   40 CONTINUE
C
C     SET FLAGS OF FREQUENCYS TO BE OUTPUT.
C
      INDEX  = ICC + IFROUT - 1
      FRQSET = Z(INDEX)
      IF (FRQSET .LE. 0) GO TO 60
      INDEX = ICC + ILSYM - 1
      INDEX = Z(INDEX) + 1
   50 ISETX = INDEX + 2
      NSETX = ISETX + Z(INDEX+1) - 1
      IF (Z(INDEX) .EQ. FRQSET) GO TO 80
      INDEX = NSETX + 1
      IF (INDEX .LT. NCC) GO TO 50
      FRQSET = -1
C
C     ALL FREQUENCYS TO BE OUTPUT.
C
   60 DO 70 I = ILIST,NLIST,2
      Z(I+1) = 1
   70 CONTINUE
      GO TO 110
C
C     COMPARE REQUESTED FREQS WITH ACTUAL FREQS.
C
   80 DO 100 I = ISETX,NSETX
      K    = 0
      DIFF = 1.0E+25
      FRQ  = RZ(I)
      DO 90 J = ILIST,NLIST,2
      IF (Z(J+1) .NE. 0) GO TO 90
      DIFF1 = ABS(RZ(J)-FRQ)
      IF (DIFF1 .GE. DIFF) GO TO 90
      DIFF = DIFF1
      K    = J
   90 CONTINUE
      IF (K .NE. 0) Z(K+1) = 1
  100 CONTINUE
C
  110 FILE = UV
      IERROR = 5
      CALL OPEN (*480,UV,Z(BUF1),RD)
      FILE = SCRT1
      CALL OPEN (*480,SCRT1,Z(BUF2),WRTREW)
      CALL FNAME (SCRT1,FILNAM)
      CALL WRITE (SCRT1,FILNAM,2,EOR)
      FILE = UV
C
C     COPY SOLUTION COLUMNS TO BE USED BY NOTEING FREQS MARKED FOR USE.
C
      NSOLS    = 0
      INBLK(1) = UV
      OUBLK(1) = SCRT1
      DO 150 I = ILIST,NLIST,2
      IF (Z(I+1)) 130,120,130
  120 CALL FWDREC (*490,UV)
      GO TO 150
C
C     BLAST COPY THIS SOLUTION.
C
  130 ICOL = (I-ILIST)/2 + 1
      CALL CPYSTR (INBLK,OUBLK,0,ICOL)
      NSOLS = NSOLS + 1
  150 CONTINUE
C
C     RESET -UV- DATA BLOCK DESIGNATOR TO POINT TO SCRT1, AND WRITE
C     A TRAILER.
C
      CALL CLOSE (UV,CLS)
      CALL CLOSE (SCRT1,CLSREW)
      MCB(1) = UV
      CALL RDTRL (MCB)
      MCB(1) = SCRT1
      MCB(2) = NSOLS
      CALL WRTTRL (MCB)
      UVSOL = SCRT1
C
C     SHRINK UP THE FREQUENCY LIST TO MATCH SOLUTION MATRIX
C
      J = ILIST - 1
      DO  180 I = ILIST,NLIST,2
      IF (Z(I+1)) 170,180,170
  170 J = J + 1
      Z(J) = Z(I)
  180 CONTINUE
      NLIST = J
C
C     IF THIS IS A TRANSIENT RESPONSE PROBLEM, THE SOLUTION MATRIX IS
C     NOW PARTITIONED INTO 3 SOLUTION MATRICES FOR DISP, VEL, AND ACCEL.
C
  190 IF (.NOT. TRNSNT) GO TO 260
      FILE   = UV
      IERROR = 6
      CALL OPEN (*480,UV,Z(BUF1),RD)
      MCB(1)   = UV
      INBLK(1) = UV
      CALL RDTRL (MCB)
      DO  200 I = 1,3
      FILE = SCRT(I)
      IBUF = BUFF(I+1)
      CALL OPEN (*480,FILE,Z(IBUF),WRTREW)
      CALL FNAME (FILE,FILNAM)
      CALL WRITE (FILE,FILNAM,2,EOR)
      MCB(1) = FILE
      MCB(2) = NSOLS/3
      CALL WRTTRL (MCB)
  200 CONTINUE
      IERROR = 7
      FILE   = UV
      DO 240 I = 1,NSOLS,3
      DO 230 J = 1,3
      OUBLK(1) = SCRT(J)
      CALL CPYSTR (INBLK,OUBLK,0,I)
  230 CONTINUE
  240 CONTINUE
      CALL CLOSE (UV,CLSREW)
      NSOLS = NSOLS/3
C
      DO 250 I = 1,3
      CALL CLOSE (SCRT(I),CLSREW)
  250 CONTINUE
C
C     SDR2 FORMED MODAL SOLUTIONS FOR DISPLACEMENTS, SINGLE-POINT-
C     CONSTRAINT-FORCES, ELEMENT STRESSES, AND ELEMENT FORCES MAY BE
C     PRESENT. (ALL WILL BE SORT1-REAL, OR SORT2-REAL)
C
C     IF THIS IS A TRANSIENT PROBLEM, THE SOLUTIONS PRESENT HAVE BEEN
C     PARTITIONED INTO THE DISPLACEMENT, VELOCITY, AND ACCELERATION
C     SUBSETS. ONLY WHEN OPERATING ON THE MODAL DISPLACEMENTS WILL THE
C     VELOCITY AND ACCELERATION SOLUTION SUBSET MATRICES BE USED.
C
  260 JFILE  = 1
  270 INFILE = IFILE(JFILE)
C
C     CHECK FOR EXISTENCE OF MODAL SOLUTION -INFILE-.
C
      CALL OPEN (*470,INFILE,Z(BUF1),RDREW)
      CALL FWDREC (*460,INFILE)
C
C     INFILE DOES EXIST.SET PARAMETERS FOR PROCESSING
C
C
C     OPEN OFP-FORMAT OUTPUT FILE FOR THIS INFILE.
C
      OUTFIL = OFILE(JFILE)
      IWRT = WRTREW
      IF (SUBCAS .GT. 1) IWRT = WRT
      CALL OPEN (*280,OUTFIL,Z(BUF4),IWRT)
      IF (SUBCAS .GT. 1) GO TO 305
      GO TO 300
  280 WRITE  (OUTPT,290) UWM,INFILE
  290 FORMAT (A25,' 2331. (DDRMM-2) OUTPUT DATA BLOCK CORRESPONDING TO',
     1       ' INPUT MODAL SOLUTION DATA BLOCK',I4, /5X,
     2       'IS NOT PRESENT.  INPUT DATA BLOCK IGNORED.')
      GO TO 460
C
  300 CALL FNAME (OUTFIL,FILNAM)
      CALL WRITE (OUTFIL,FILNAM,2,EOR)
  305 CALL CLOSE (OUTFIL,CLS)
C
C     READ FIRST OFP-ID RECORD AND DETERMINE WHAT THE HELL IS REALLY
C     PRESENT.
C
      IERROR = 14
      CALL READ (*460,*460,INFILE,IDREC,146,EOR,NWDS)
C
C     MAJOR ID AND SORT1 OR SORT2 DETERMINATION.
C
      ITYPE1 = IDREC(2)/1000
      SORT2  = .FALSE.
      IF (ITYPE1 .GT. 1) SORT2 = .TRUE.
      ITYPE1 = IDREC(2) - ITYPE1*1000
C
C     BRANCH ON MAJOR ID
C
      IF (ITYPE1.LT.1 .OR. ITYPE1.GT.7) GO TO 410
      PASSES = 1
      GO TO (410,410,370,380,390,410,310), ITYPE1
C
C     MODAL DISPLACEMENTS = EIGENVECTORS ARE ON INFILE.
C
  310 PASSES = 3
      NWORDS = 2
C
C     DETERMINE DISP, VEL, AND ACCEL SET REQUESTS.
C
  312 IBASE = ICC + ILSYM - 1
      IBASE = Z(IBASE) + 1
      DO 350 I = 1,PASSES
      IF (PASSES .EQ. 1) GO TO 315
      ITEMP = ICC + DVA(I) - 1
  315 SETS(1,I) = Z(ITEMP)
      SETS(2,I) = Z(ITEMP+1)
      SETS(3,I) = IABS(Z(ITEMP+2))
      SETS(4,I) = 0
      SETS(5,I) = 0
      IF (SETS(1,I)) 350,350,320
  320 INDEX = IBASE
  330 ISETX = INDEX + 2
      IF (Z(INDEX) .EQ. SETS(1,I)) GO TO 340
      INDEX = ISETX + Z(INDEX+1)
      IF (INDEX .LT. NCC) GO TO 330
      SETS(1,I) = -1
      GO TO 350
  340 SETS(4,I) = ISETX
      SETS(5,I) = Z(INDEX+1)
  350 CONTINUE
      GO TO 430
C
C     MODAL SPCF-S ARE ON INFILE.
C
  370 ITEMP  = ICC + ISPCF - 1
      NWORDS = 2
      GO TO 312
C
C     MODAL FORCES ARE ON INFILE.
C
  380 ITEMP  = ICC + IFORCE - 1
      NWORDS = 1
      GO TO 312
C
C     MODAL STRESSES ARE ON INFILE.
C
  390 ITEMP  = ICC + ISTRES - 1
      NWORDS = 1
      GO TO 312
C
C     ILLEGAL INFILE DATA.
C
  410 WRITE  (OUTPT,420) UWM,INFILE
  420 FORMAT (A25,' 2332.  (DDRMM-4) INVALID INPUT DATA DETECTED IN ',
     1       'DATA BLOCK',I5,'. PROCESSING STOPPED FOR THIS DATA BLOCK')
      GO TO 460
C
C     CALL PROCESSOR TO BUILD DATA-MATRIX ON SCRT5 AND MAPPING-DATA ON
C     SCRT4, AND THEN PERFORM OUTPUT OF RESULTS TO OUTFIL.
C
  430 IF (SORT2) GO TO 440
C
C     SORT1 PROCESSOR
C
      CALL DDRMM1 (*480,*490,*500,*510)
      GO TO 450
C
C     SORT2 PROCESSOR
C
  440 CALL DDRMM2 (*480,*490,*500,*510)
C
C     WRAP UP PROCESSING FOR THIS INFILE.
C
  450 MCB(1) = OUTFIL
      MCB(2) = 1
      CALL WRTTRL (MCB)
  460 CALL CLOSE (OUTFIL,CLSREW)
      CALL CLOSE (INFILE,CLSREW)
      CALL CLOSE (SCRT4, CLSREW)
      CALL CLOSE (SCRT5, CLSREW)
C
C     PROCESS NEXT MODAL SOLUTION INPUT.
C
  470 JFILE = JFILE + 1
      IF (JFILE .LE. 4) GO TO 270
C
C     ALL WORK COMPLETE FOR THIS SUBCASE. IF FREQUENCY RESPONSE PROCESS
C     NEXT SUBCASE.
C
      IF (TRNSNT) GO TO 479
      FILE   = CASECC
      IERROR = 471
      CALL OPEN (*480,CASECC,Z(BUF1),RD)
      CALL READ (*479,*472,CASECC,Z(ICC),NCORE-ICC,NOEOR,NWDS)
      GO TO 510
C
  472 NCC    = ICC + NWDS - 1
      SUBCAS = SUBCAS + 1
      CALL CLOSE (CASECC,CLS)
      GO TO 33
C
C//// SUBCAS  NUMBER NEEDS TO GET INTO OUTPUT BLOCKS
C
  479 IERROR = 511
      CALL CLOSE (CASECC,CLSREW)
      GO TO 560
C
C     ERRORS FORCING TERMINATION OF THIS MODULE.
C
  480 KK = 1
      GO TO 520
  490 KK = 2
      GO TO 520
  500 KK = 3
      GO TO 520
  510 KK = 8
      GO TO 520
  520 CALL MESAGE (KK,FILE,SUBR)
      WRITE  (OUTPT,530) SWM,IERROR
  530 FORMAT (A27,' 2333.  (DDRMM-1) MODULE DDRMM TERMINATED WITH ',
     1       'VARIABLE IERROR =',I10)
C
C     INSURE ALL FILES CLOSED BEFORE RETURNING.
C
      DO 550 L = 100,300,100
      DO 540 M = 1,11
      JFILE = M + L
      CALL CLOSE (JFILE,CLSREW)
  540 CONTINUE
  550 CONTINUE
C
C     INSURE ALL OUT-FILES HAVE AN EOF.
C
  560 DO 570 L = 201,204
      CALL OPEN (*570,L,Z(BUF1),WRT)
      CALL CLOSE (L,CLSREW)
  570 CONTINUE
      RETURN
      END

      SUBROUTINE SDR2AA
C
C     SDR2AA PROCESSES THE CASE CONTROL AND XYCDB DATA BLOCKS. IF XYCDB
C     IS PURGED, NO ACTION IS TAKEN. OTHERWISE, OUTPUT REQUESTS IN
C     CASE CONTROL ARE COMPARED WITH XY REQUESTS IN XYCDB. FOR EACH
C     SUBCASE AND EACH REQUEST TYPE, CASE CONTROL IS MODIFIED TO
C     REFLECT THE UNION OF THE REQUESTS. THE NEW CASE CONTROL IS
C     WRITTEN ON A SCRATCH FILE AND THE POINTER TO CASE CONTROL SWITCHED
C
      INTEGER         TAB   ,SDR2X1,BUF   ,CASECC,XYCDB ,SCR3  ,Z     ,
     1                APP   ,RD    ,RDREW ,WRT   ,WRTREW,CLSREW,SYSBUF,
     2                XSETNO,BUF1  ,BUF2  ,BUF3  ,SUBCSE,ANYNEW,FILE  ,
     3                DBNAME,SETNO ,ARG   ,ESTA  ,XYCDBF,TRN   ,FRQ   ,
     4                CEI   ,FORMT ,SORT2
      DIMENSION       SDR2X1(1)    ,TAB(14)      ,BUF(10)       ,NAM(2)
      COMMON /SDR2X1/ SDR2X1,IELDEF,ITLOAD,ISYMFL,ILOADS,IDISPL,ISTR  ,
     1                IELF  ,IACC  ,IVEL  ,ISPCF ,ITTL  ,ILSYM ,IFROUT,
     2                ISLOAD,IDLOAD
      COMMON /SDR2X2/ CASECC,CSTM  ,MPT   ,DIT   ,EQEXIN,SIL   ,GPTT  ,
     1                EDT   ,BGPDT ,PG    ,QG    ,UGV   ,EST   ,PHIG  ,
     2                EIGR  ,OPG1  ,OQG1  ,OUGV1 ,OES1  ,OEF1  ,PUGV1 ,
     3                OEIGR ,OPHIG ,PPHIG ,ESTA  ,GPTTA ,HARMS ,XYCDB ,
     4                SCR3
      COMMON /SDR2X4/ X4(72),FRQ(2),TRN(2),BKL(4),CEI(2)
      COMMON /BLANK / APP(2),SORT2
      COMMON /ZZZZZZ/ Z(1)
      COMMON /SYSTEM/ SYSBUF
      COMMON /NAMES / RD    ,RDREW ,WRT   ,WRTREW,CLSREW
      DATA    TAB   / 1,    6,
     1                2,    10,
     2                3,    9,
     3                4,    11,
     4                5,    5,
     5                6,    7,
     6                7,    8      /,
     7        XSETNO/ 100000000    /,
     8        NAM   / 4HSDR2,4HAA  /
C
C     SET BUFFER POINTERS AND PERFORM GENERAL INITIALIZATION.
C
      BUF1  = KORSZ(Z) - SYSBUF
      BUF2  = BUF1 - SYSBUF
      BUF3  = BUF2 - SYSBUF
      IMSTR = 1
      MASTER= 1
      LASTXY= 0
      ANYNEW= 0
      SORT2 =-1
C
C     OPEN XYCDB. IF PURGED, RETURN.
C
      CALL OPEN (*1034,XYCDB,Z(BUF1),RDREW)
      FILE = XYCDB
      CALL FWDREC (*1035,XYCDB)
      CALL FWDREC (*1035,XYCDB)
C
C     READ FIRST LINE OF XYCDB. IF SUBCASE = 0 (MEANING DATA APPLIES
C     TO ALL SUBCASES), READ IN DATA FOR ZERO SUBCASE.
C
      LAST   = 0
      XYCDBF = XYCDB
      CALL READ (*1035,*1035,XYCDB,BUF,6,0,FLAG)
      SORT2  = 0
      SUBCSE = BUF(1)
      IF (SUBCSE .NE. 0) GO TO 1013
      I      = IMSTR
 1011 Z(I  ) = BUF(2)
      Z(I+1) = BUF(3)
      I      = I + 2
      CALL READ (*2002,*1012,XYCDB,BUF,6,0,FLAG)
      IF (BUF(1) .EQ. 0) GO TO 1011
      NMSTR  = I - 2
      IXYSC  = I
      GO TO 1019
C
C     HERE IF MASTER SUBCASE IS THE ONLY SUBCASE IN XYCDB.
C
 1012 NMSTR  = I - 2
      NXYSC  = NMSTR
      MASTER = 0
      LASTXY = 1
C
C     REDUCE LIST TO UNIQUE PAIRS
C
      IF (IMSTR .EQ. NMSTR) GO TO 1019
      NMSTR  = NMSTR - 2
      J      = IMSTR
      DO 1014 I = IMSTR,NMSTR,2
      IF (Z(I+2).EQ.Z(J) .AND. Z(I+3).EQ.Z(J+1)) GO TO 1014
      Z(J+2) = Z(I+2)
      Z(J+3) = Z(I+3)
      J      = J + 2
 1014 CONTINUE
      NMSTR  = J
      NXYSC  = NMSTR
      GO TO 1019
C
C     HERE IF NO MASTER SUBCASE -- CREATE A DUMMY MASTER.
C
 1013 NMSTR  = IMSTR
      IXYSC  = IMSTR + 2
      Z(IMSTR  ) = 9999
      Z(IMSTR+1) = 0
      MASTER = -1
      GO TO 1019
C
C     OPEN CASE CONTROL AND SCRATCH FILE FOR MODIFIED CASE CONTROL
C
 1019 CALL GOPEN (CASECC,Z(BUF2),RDREW)
      FILE = SCR3
      CALL OPEN (*2001,SCR3,Z(BUF3),WRTREW)
      CALL FNAME (CASECC,BUF(9))
      CALL WRITE (SCR3,BUF(9),2,1)
C
C     READ DATA FOR ONE SUBCASE. STORE DATA BLOCK AND ID IN OPEN CORE.
C
 1020 IF (MASTER.EQ.0 .OR. LASTXY.NE.0) GO TO 1030
      SUBCSE = BUF(1)
      I      = IXYSC
 1021 Z(I  ) = BUF(2)
      Z(I+1) = BUF(3)
      I      = I + 2
      CALL READ (*1035,*1023,XYCDBF,BUF,6,0,FLAG)
      IF (BUF(1) .EQ. SUBCSE) GO TO 1021
      GO TO 1025
 1023 LASTXY = 1
C
C     COPY DATA FROM MASTER SUBCASE AFTER CURRENT SUBCASE.
C     THEN SORT DATA TOGETHER TO FORM SORTED UNION.
C
 1025 DO 1026 J = IMSTR,NMSTR,2
      Z(I  ) = Z(J  )
      Z(I+1) = Z(J+1)
      I      = I + 2
 1026 CONTINUE
      N = I - IXYSC
      CALL SORT (0,0,2,-2,Z(IXYSC),N)
      CALL SORT (0,0,2,-1,Z(IXYSC),N)
C
C     REDUCE LIST TO UNIQUE PAIRS.
C
      NXYSC = I - 4
      J = IXYSC
      DO 1027 I = IXYSC,NXYSC,2
      IF (Z(I+2).EQ.Z(J) .AND. Z(I+3).EQ.Z(J+1)) GO TO 1027
      Z(J+2) = Z(I+2)
      Z(J+3) = Z(I+3)
      J = J + 2
 1027 CONTINUE
      NXYSC = J
C
C     READ A RECORD IN CASE CONTROL. SET POINTERS FOR XYCDB DATA TO
C     EITHER MASTER SUBCASE OR CURRENT SUBCASE IN CORE.
C
 1030 ICC = NXYSC + 1
      CALL READ (*1035,*1031,CASECC,Z(ICC+1),BUF3-ICC,1,NCC)
      CALL MESAGE (-8,0,NAM)
 1031 IF (SUBCSE .EQ. Z(ICC+1)) GO TO 10311
      IF (MASTER .NE.       -1) GO TO 1032
      IF (SUBCSE .GT. Z(ICC+1)) GO TO 1030
      IF (LASTXY .EQ.        0) GO TO 1020
      IF (ANYNEW .EQ.        0) GO TO 1035
      CALL WRITE (SCR3,Z(ICC+1),NCC,1)
      GO TO 1030
10311 IXY = IXYSC
      NXY = NXYSC
      GO TO 1040
 1032 IXY = IMSTR
      NXY = NMSTR
      GO TO 1040
C
C     TERMINATE PROCESSING.
C
 1035 CALL CLOSE (CASECC,CLSREW)
      CALL CLOSE (XYCDBF,CLSREW)
      CALL CLOSE (SCR3  ,CLSREW)
      IF (ANYNEW .NE. 0) CASECC = SCR3
 1034 RETURN
C
C     PICK UP POINTER TO CURRENT OUTPUT REQUEST.
C     DETERMINE IF XYCDB REQUEST EXISTS.
C
 1040 LOOP   = 1
 1041 DBNAME = TAB(LOOP  )
      IX     = TAB(LOOP+1)
      IREQ   = ICC + SDR2X1(IX)
      SETNO  = Z(IREQ)
      DO 1042 J = IXY,NXY,2
      IF (Z(J) .EQ. DBNAME) GO TO 1043
 1042 CONTINUE
      GO TO 1100
 1043 IXYSET = J
      DO 1044 J = IXYSET,NXY,2
      IF (Z(J) .NE. DBNAME) GO TO 1045
 1044 CONTINUE
      NXYSET = NXY
      GO TO 1050
 1045 NXYSET = J - 2
C
C     BRANCH ON CASECC REQUEST - NOTE, NO ACTION IF REQUEST = ALL.
C
 1050 IF (SETNO) 1098,1060,1070
C
C     HERE IF NO CASECC REQUEST.
C     BUILD XYCDB SET IN CASECC SET FORMAT. ADD SET TO
C     CASECC RECORD AND TURN ON CASECC REQUEST FOR SET.
C
 1060 XSETNO = XSETNO + 1
      Z(IREQ  ) = XSETNO
      Z(IREQ+1) = 0
      FORMT  = -2
      IF (APP(1) .EQ. TRN(1)) FORMT = -1
      Z(IREQ+2) = FORMT
      SORT2  = 0
      IX     = ICC + NCC + 1
      Z(IX)  = XSETNO
      JX     = IX + 2
      Z(JX)  = Z(IXYSET+1)
      IF (IXYSET .EQ. NXYSET) GO TO 1066
      IXYSET = IXYSET + 2
      N      = 1
      DO 1065 J = IXYSET,NXYSET,2
      IF (Z(J+1)-Z(JX) .EQ. N) GO TO 1064
      IF (N .NE. 1) GO TO 1062
      JX     = JX + 1
      Z(JX)  = Z(J+1)
      GO TO 1065
 1062 Z(JX+1)=-Z(J-1)
      JX     = JX + 2
      Z(JX)  = Z(J+1)
      N      = 1
      GO TO 1065
 1064 N      = N + 1
 1065 CONTINUE
      IF (N .EQ. 1) GO TO 1066
      JX     = JX + 1
      Z(JX  )= -Z(NXYSET+1)
 1066 Z(IX+1)= JX - IX - 1
      NCC    = NCC + Z(IX+1) + 2
      ANYNEW = 1
      GO TO 1100
C
C     HERE IF CASECC SET AND XYCDB SET EXIST.
C     FIRST, LOCATE CASECC SET.
C
 1070 ILIST  = ICC + NCC + 3
      IX     = ICC + ILSYM
      ISETNO = IX  + Z(IX) + 1
 1071 ISET   = ISETNO + 2
      NSET   = Z(ISETNO+1) + ISET - 1
      IF (Z(ISETNO) .EQ. SETNO) GO TO 1080
      ISETNO = NSET + 1
      IF (ISETNO .LT. ILIST) GO TO 1071
      GO TO 1100
C
C     COMPARE EACH POINT IN XYCDB REQUEST WITH CASECC SET.
C     ADD ANY POINTS IN XYCDB NOT IN CASECC TO CASECC SET.
C
 1080 I = ISET
      J = IXYSET
      K = ILIST
      L = ISET
 1081 ARG = Z(J+1)
 1082 IF (I-NSET) 1083,1085,1088
 1083 IF (Z(I+1) .GT. 0) GO TO 1085
      N = 2
      IF (ARG-Z(I  )) 1088,1091,1084
 1084 IF (ARG+Z(I+1)) 1091,1087,1086
 1085 N = 1
      IF (ARG-Z(I)) 1088,1087,1086
 1086 I = I + N
      GO TO 1082
 1087 I = I + N
      GO TO 1091
 1088 IF (L .EQ. I) GO TO 1090
      LN = I - 1
      LL = L
      DO 1089 L = LL,LN
      Z(K) = Z(L)
      K = K + 1
 1089 CONTINUE
      L = I
 1090 Z(K) = ARG
      K = K + 1
 1091 J = J + 2
      IF (J .LE. NXYSET) GO TO 1081
      N = K - ILIST
      IF (N .EQ.    0) GO TO 1100
      IF (L .GT. NSET) GO TO 1094
      DO 1092 LL = L,NSET
      Z(K) = Z(LL)
      K = K + 1
 1092 CONTINUE
      N = K - ILIST
C
C     IF NO NEW POINTS IN SET, CURRENT CASECC SET IS UNION.
C     OTHERWISE, NEW SET IS UNION. TURN ON REQUEST FOR IT AND
C     EXTEND END OF CASECC RECORD.
C
 1094 XSETNO    = XSETNO + 1
      Z(IREQ)   = XSETNO
      Z(IREQ+1) = 10*SETNO + Z(IREQ+1)
      Z(IREQ+2) = -IABS(Z(IREQ+2))
      SORT2     = 0
      Z(ILIST-2)= XSETNO
      Z(ILIST-1)= N
      NCC       = NCC + N + 2
      ANYNEW    = 1
      GO TO 1100
C
C     HERE IF CASECC SET = ALL AND XY REQUEST EXISTS - TURN SORT2 ON.
C
 1098 Z(IREQ+2) = -IABS(Z(IREQ+2))
      SORT2     = 0
C
C     TEST FOR COMPLETION OF ALL CASECC REQUESTS FOR CURRENT SUBCASE.
C     WHEN COMPLETE, WRITE CURRENT SUBCASE ON SCRATCH FILE.
C
 1100 LOOP = LOOP + 2
      IF (LOOP .LE. 13) GO TO 1041
      CALL WRITE (SCR3,Z(ICC+1),NCC,1)
C
C     RETURN TO READ ANOTHER RECORD IN CASE CONTROL OR ANOTHER XYCDB
C     SUBCASE
C
      IF (MASTER .EQ.        0) GO TO 1030
      IF (SUBCSE .LE. Z(ICC+1)) GO TO 1020
      GO TO 1030
C
C     FATAL FILE ERRORS
C
 2000 CALL MESAGE (N,FILE,NAM)
 2001 N = -1
      GO TO 2000
 2002 N = -2
      GO TO 2000
      END

      SUBROUTINE DMPY (Z,ZD)
C
C     DMPY WILL PRE OR POST MULTIPLY AN ARBITRARY MATRIX BY A DIAGONAL
C     MATRIX.
C
C     FILEA = MATRIX CONTROL BLOCK FOR DIAGONAL MATRIX.
C     FILEB = MATRIX CONTROL BLOCK FOR ARBITRARY MATRIX.
C     FILEC = MATRIX CONTROL BLOCK FOR PRODUCT MATRIX.
C     Z     = ADDRESS OF A BLOCK OF CORE FOR WORKING SPACE. ZD IS SAME
C             BLOCK.
C     NZ    = LENGTH OF THIS BLOCK.
C     FLAG .EQ. 0 FOR PRE-MULTIPLICATION BY DIAGONAL.
C     FLAG .NE. 0 FOR POST-MULTIPLICATION BY DIAGONAL.
C     SIGN .EQ. +1 FOR POSITIVE PRODUCT.
C     SIGN .EQ. -1 FOR NEGATIVE PRODUCT.
C
C
      INTEGER          FILEA ,FILEB ,FILEC ,FLAG  ,SIGN  ,SYSBUF,EOL   ,
     1                 EOR   ,TYPE  ,ONE   ,Z(1)  ,RD    ,RDREW ,WRT   ,
     2                 BUF1  ,BUF2  ,CLSREW,RCC   ,PTYPE ,QTYPE ,WRTREW
      DOUBLE PRECISION ZD(1) ,AD    ,XD
      DIMENSION        FILEA(7)     ,FILEB(7)     ,FILEC(7)
      COMMON /DMPYX /  FILEA ,FILEB ,FILEC ,NZ    ,FLAG  ,SIGN
      COMMON /NAMES /  RD    ,RDREW ,WRT   ,WRTREW,CLSREW
      COMMON /ZNTPKX/  AD (2),I     ,EOL   ,EOR
      COMMON /ZBLPKX/  XD (2),IX
      COMMON /UNPAKX/  TYPE  ,ONE   ,NX    ,INCR
      COMMON /SYSTEM/  SYSBUF
C
C
C     PERFORM GENERAL INITIALIZATION
C
      BUF1 = NZ - SYSBUF + 1
      BUF2 = BUF1 - SYSBUF
      ONE  = 1
      INCR = 1
      FILEC(2) = 0
      FILEC(6) = 0
      FILEC(7) = 0
      NX = FILEA(3)
C
C     COMPUTE TYPE OF C MATRIX.
C     RCC = 1 FOR REAL, = 2 FOR COMPLEX
C     QTYPE = 2 FOR RDP, = 4 FOR CDP
C
      RCC = 0
      IF (FILEA(5).GT.2 .OR. FILEB(5).GT.2) RCC = 2
      QTYPE = RCC + 2
      IF (RCC .EQ. 0) RCC = 1
      TYPE  = QTYPE*SIGN
      PTYPE = FILEC(5)
C
C     OPEN PRODUCT MATRIX AND WRITE HEADER RECORD.
C
      CALL GOPEN (FILEC(1),Z(BUF1),WRTREW)
C
C     UNPACK DIAGONAL MATRIX IN CORE AND OPEN ARBITRARY MATRIX.
C
      CALL GOPEN (FILEA(1),Z(BUF2),RDREW)
      CALL UNPACK (*130,FILEA,Z)
      CALL CLOSE (FILEA(1),CLSREW)
      CALL GOPEN (FILEB(1),Z(BUF2),RDREW)
C
C     PERFORM MATRIX MULTIPLICATION.
C
      J  = 1
   60 KR = (J-1)*RCC + 1
      CALL BLDPK (QTYPE,PTYPE,FILEC(1),0,0)
      CALL INTPK (*90,FILEB(1),0,QTYPE,0)
   70 CALL ZNTPKI
      KL = (I-1)*RCC + 1
      K  = KL
      IF (FLAG .NE. 0) K = KR
      XD(1) = ZD(K)*AD(1)
      IF (RCC .EQ. 1) GO TO 80
      XD(1) = XD(1) - ZD(K+1)*AD(2)
      XD(2) = ZD(K)*AD(2) + ZD(K+1)*AD(1)
   80 IX = I
      CALL ZBLPKI
      IF (EOL .EQ. 0) GO TO 70
   90 CALL BLDPKN (FILEC(1),0,FILEC)
      J = J + 1
      IF (J .LE. FILEB(2)) GO TO 60
      GO TO 140
C
C     CODE FOR NULL DIAGONAL MATRIX.
C
  130 CALL BLDPKN (FILEC(1),0,FILEC)
      IF (FILEC(2) .LT. FILEB(2)) GO TO 130
C
C     CLOSE FILES AND RETURN.
C
  140 CALL CLOSE (FILEA(1),CLSREW)
      CALL CLOSE (FILEB(1),CLSREW)
      CALL CLOSE (FILEC(1),CLSREW)
      RETURN
      END

      SUBROUTINE SQDM22
C
C     PHASE-II STRESS-DATA-RECOVERY ROUTINE FOR THE -QDMEM2- ELEMENT.
C
C     THIS ROUTINE USES DATA PREPARED BY -SQDM21-, THE PHASE-I ROUTINE,
C     TOGETHER WITH THE DISPLACEMENT VECTOR AND TEMPERATURE DATA
C     TO ARRIVE AT STRESS AND FORCE OUTPUTS.
C
      INTEGER         IFORCE(1),ISTR(1),ISILS(4),EJECT,ISHED(7),ISTYP(2)
      REAL            STRESS(8),FORCE(17),KIJ(9,16),SG(36),PT(3,4),
     1                ST(3),RG(4),FRLAST(2)
      COMMON /ZZZZZZ/ Z(1)
      COMMON /SDR2X4/ DUMMY(35),IVEC,IVECN,LDTEMP,DEFORM,DUM8(8),TLOADS
      COMMON /SDR2X7/ ID(217)
      COMMON /SDR2X8/ VEC(4),SIGXYZ(3),F(4,3),SHEARS(4),CVC(4),FF(4,3),
     1                CFRVEC(20),CSHARS(4)
      COMMON /SDR2X9/ NCHK,ISUB,ILD,FRTMEI(2),TWOTOP,FNCHK
      COMMON /SYSTEM/ IBFSZ,NOUT,IDM(9),LINE
      EQUIVALENCE     (TEMP,LDTEMP)
      EQUIVALENCE     (ID(2),ISILS(1)),(ID(7),TSUB0),(ID(8),KIJ(1,1)),
     1                (ID(101),STRESS(1),ISTR(1)),
     2                (ID(152),SG(1)),(ID(188),PT(1,1)),
     3                (ID(200),ST(1)),(ID(201),FORCE(1),IFORCE(1)),
     4                (ID(203),RG(1))
      EQUIVALENCE     (F2,FORCE( 2)),(F1,FORCE( 3)),(F3,FORCE( 4)),
     1                (F4,FORCE( 5)),(F6,FORCE( 6)),(F5,FORCE( 7)),
     2                (F7,FORCE( 8)),(F8,FORCE( 9)),(FK1,FORCE(10)),
     3                (Q1,FORCE(11)),(FK2,FORCE(12)),(Q2,FORCE(13)),
     4                (FK3,FORCE(14)),(Q3,FORCE(15)),(FK4,FORCE(16)),
     5                (Q4,FORCE(17))
      EQUIVALENCE     (ISHED(1),LSUB),(ISHED(2),LLD),
     1                (ISHED(6),FRLAST(1))
      DATA    ISTYP / 4HQDME, 2HM2 /
      DATA    LSUB  , LLD,FRLAST   / 2*-1, -1.0E30,-1.0E30 /
C
C     SIG , SIG , TAU   = SUMMATION((S )(U )) - (S )(TEMP-T )
C        X     Y     XY               I   I       T        0
C
      SIGXYZ(1) = 0.0
      SIGXYZ(2) = 0.0
      SIGXYZ(3) = 0.0
      CFRVEC(2) = 0.0
      CFRVEC(3) = 0.0
      CFRVEC(4) = 0.0
C
      DO 20 I = 1,4
      J = IVEC + ISILS(I)
      CALL SMMATS (SG(9*I-8),3,3,0, Z(J-1),3,1,0, VEC,CVC)
      DO 10 J = 1,3
      SIGXYZ(J  ) = SIGXYZ(J  ) + VEC(J)
      CFRVEC(J+1) = CFRVEC(J+1) + CVC(J)
   10 CONTINUE
   20 CONTINUE
C
      IF (LDTEMP .EQ. -1) GO TO 40
      TBAR = TEMP - TSUB0
      DO 30 J = 1,3
      SIGXYZ(J) = SIGXYZ(J) - ST(J)*TBAR
   30 CONTINUE
C
C     FORCES
C          I                             T
C        (F ) = SUMMATION((K  )(U )) - (P )(TEMP-T )
C                           IJ   I       I        0
C
   40 IPART   = 0
      DO 60 I = 1,4
      F(I,1)  = 0.0
      F(I,2)  = 0.0
      F(I,3)  = 0.0
      FF(I,1) = 0.0
      FF(I,2) = 0.0
      FF(I,3) = 0.0
      DO 50 J = 1,4
      K       = IVEC  + ISILS(J)
      IPART   = IPART + 1
      CALL SMMATS (KIJ(1,IPART),3,3,0, Z(K-1),3,1,0, VEC,CVC)
      F(I,1)  = F(I,1)  + VEC(1)
      F(I,2)  = F(I,2)  + VEC(2)
      F(I,3)  = F(I,3)  + VEC(3)
      FF(I,1) = FF(I,1) + CVC(1)
      FF(I,2) = FF(I,2) + CVC(2)
      FF(I,3) = FF(I,3) + CVC(3)
   50 CONTINUE
      IF (LDTEMP .EQ. -1) GO TO 60
      TBAR   = TEMP - TSUB0
      F(I,1) = F(I,1) - PT(1,I)*TBAR
      F(I,2) = F(I,2) - PT(2,I)*TBAR
      F(I,3) = F(I,3) - PT(3,I)*TBAR
   60 CONTINUE
C
C     SHEARS = SUMMATION (R )(U )
C                          I   I
      DO 80 I = 1,4
      IP1 = I + 1
      IF (IP1 .EQ. 5) IP1 = 1
      SHEARS(I) = (F(IP1,2)-F(I,1))/RG(I)
      CSHARS(I) = (FF(IP1,2)-FF(I,1))/ABS(RG(I))
   80 CONTINUE
C
C     ALL COMPUTATIONS COMPLETE.
C
      Q1 = -SHEARS(1)
      Q2 =  SHEARS(2)
      Q3 = -SHEARS(3)
      Q4 =  SHEARS(4)
      CFRVEC(14) = -CSHARS(1)
      CFRVEC(16) = +CSHARS(2)
      CFRVEC(18) = -CSHARS(3)
      CFRVEC(20) = +CSHARS(4)
C
      ISTR(1)   = ID(1)
      CFRVEC(1) = STRESS(1)
      STRESS(2) = SIGXYZ(1)
      STRESS(3) = SIGXYZ(2)
      STRESS(4) = SIGXYZ(3)
C
      IFORCE(1) = ID(1)
      F1 = F(1,1)
      F2 = F(1,2)
      F3 = F(2,2)
      F4 = F(2,1)
      F5 = F(3,1)
      F6 = F(3,2)
      F7 = F(4,2)
      F8 = F(4,1)
      CFRVEC( 6) = FF(1,1)
      CFRVEC( 5) = FF(1,2)
      CFRVEC( 7) = FF(2,2)
      CFRVEC( 8) = FF(2,1)
      CFRVEC(10) = FF(3,1)
      CFRVEC( 9) = FF(3,2)
      CFRVEC(11) = FF(4,2)
      CFRVEC(12) = FF(4,1)
C
      FK1 = F(1,3)
      FK2 = F(2,3)
      FK3 = F(3,3)
      FK4 = F(4,3)
      CFRVEC(13) = FF(1,3)
      CFRVEC(15) = FF(2,3)
      CFRVEC(17) = FF(3,3)
      CFRVEC(19) = FF(4,3)
C
      TEMP = STRESS(2) - STRESS(3)
C
C     COMPUTE TAU
C
      STRESS(8) = SQRT((TEMP/2.0)**2+STRESS(4)**2)
      DELTA = (STRESS(2)+STRESS(3))/2.0
C
C     COMPUTE SIGMA 1 AND SIGMA 2
C
      STRESS(6) = DELTA + STRESS(8)
      STRESS(7) = DELTA - STRESS(8)
      DELTA = 2.0*STRESS(4)
C
C     COMPUTE PHI 1 DEPENDING ON WHETHER OR NOT SIGMA XY AND/OR
C               (SIGMA 1 - SIGMA 2) ARE ZERO
C
      IF (ABS(TEMP) .LT. 1.0E-15) GO TO 5
      STRESS(5) = ATAN2(DELTA,TEMP)*28.64788980
      GO TO 7
    5 IF (ABS(DELTA) .LT. 1.0E-15) GO TO 6
      STRESS(5) = 0.0
      GO TO 7
    6 STRESS(5) = 45.0
    7 IF (NCHK .LE. 0) GO TO 150
C
C     STRESS/FORCE PRECISION CHECK
C
      K = 0
C
C     STRESSES
C
      CALL SDRCHK (STRESS(2),CFRVEC(2),3,K)
C
C     FORCES
C
      CALL SDRCHK (FORCE(2),CFRVEC(5),16,K)
      IF (K .EQ. 0) GO TO 150
C
C     LIMITS EXCEEDED
C
      J = 0
      IF (LSUB.EQ.ISUB .AND. FRLAST(1).EQ.FRTMEI(1) .AND.
     1    LLD .EQ.ILD  .AND. FRLAST(2).EQ.FRTMEI(2)) GO TO 120
C
      LSUB = ISUB
      LLD  = ILD
      FRLAST(1) = FRTMEI(1)
      FRLAST(2) = FRTMEI(2)
      J = 1
      CALL PAGE1
  100 CALL SD2RHD (ISHED,J)
      LINE = LINE + 1
      WRITE  (NOUT,110)
  110 FORMAT (3X,4HTYPE,5X,3HEID,4X,2HSX,4X,2HSY,3X,3HSXY,11H  F1-4  F1-
     1,60H2  F2-1  F2-3  F3-2  F3-4  F4-3  F4-1   K-1  SH12   K-2  SH2
     2,25H3   K-3  SH34   K-4  SH41)
      GO TO 130
  120 IF (EJECT(2) .NE. 0) GO TO 100
C
  130 WRITE  (NOUT,140) ISTYP,CFRVEC
  140 FORMAT (2H0 ,A4,A2,I7,19F6.1)
C
  150 RETURN
      END

      SUBROUTINE TA1A
C
C     TA1A BUILDS THE ELEMENT SUMMARY TABLE (EST).
C     THE EST GROUPS ECT, EPT, BGPDT AND ELEMENT TEMP. DATA FOR EACH
C     SIMPLE ELEMENT OF THE STRUCTURE. THE EST CONTAINS ONE LOGICAL
C     RECORD PER SIMPLE ELEMENT TYPE.
C
      IMPLICIT INTEGER (A-Z)
      LOGICAL         EORFLG,ENDID ,RECORD,FRSTIM,Q4T3
      INTEGER         ZEROS(4)     ,BUF(50)      ,NAM(2),GPSAV(34)    ,
     1                PCOMP(2)     ,PCOMP1(2)    ,PCOMP2(2)           ,
     2                IPSHEL(16)
      REAL            DEFTMP,TLAM  ,ZOFFS ,ZZ(1) ,BUFR(50)            ,
     1                TGRID(33)    ,RPSHEL(16)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG / UFM   ,UWM   ,UIM   ,SFM
      COMMON /BLANK / LUSET ,NOSIMP,NOSUP ,NOGENL,GENL  ,COMPS
      COMMON /TA1COM/ NSIL  ,ECT   ,EPT   ,BGPDT ,SIL   ,GPTT  ,CSTM  ,
     1                MPT   ,EST   ,GEI   ,GPECT ,ECPT  ,GPCT  ,MPTX  ,
     2                PCOMPS,EPTX  ,SCR1  ,SCR2  ,SCR3  ,SCR4
      COMMON /SYSTEM/ KSYSTM(65)
      COMMON /GPTA1 / NELEM ,LAST  ,INCR  ,ELEM(1)
      COMMON /NAMES / RD    ,RDREW ,WRT   ,WRTREW,CLSREW,CLS
      COMMON /TA1ETT/ ELTYPE,OLDEL ,EORFLG,ENDID ,BUFFLG,ITEMP ,IDFTMP,
     1                IBACK ,RECORD,OLDEID
      COMMON /TA1ACM/ IG(90)
      COMMON /TWO   / KTWO(32)
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE     (KSYSTM( 1),SYSBUF ) , (KSYSTM( 2),NOUT ) ,
     1                (KSYSTM(10),TEMPID ) , (KSYSTM(56),IHEAT) ,
     2                (IDFTMP    ,DEFTMP ) , (BUFR(1)   ,BUF(1)),
     3                (Z(1)      ,ZZ(1)  ) , (IPSHEL( 1),RPSHEL(1))
      DATA    NAM   / 4HTA1A,4H    /
      DATA    ZEROS / 4*0   /
      DATA    BAR   / 34    /
      DATA    HBDY  / 52    /
      DATA    QDMEM2/ 63    /
      DATA    QUAD4 / 64    /
      DATA    TRIA3 / 83    /
      DATA    PCOMP / 5502, 55 /
      DATA    PCOMP1/ 5602, 56 /
      DATA    PCOMP2/ 5702, 57 /
      DATA    SYM   / 1     /
      DATA    MEM   / 2     /
      DATA    SYMMEM/ 3     /
C
C     PERFORM GENERAL INITIALIZATION
C
      IF (NELEM .GT. 90) GO TO 1190
      BUF1  = KORSZ(Z) - SYSBUF - 2
      BUF2  = BUF1 - SYSBUF - 3
      BUF3  = BUF2 - SYSBUF
      FRSTIM= .TRUE.
      LSTPRP= 0
      KSCALR= 0
      ITABL = 0
      NOSIMP=-1
      NOGOX = 0
      NOGO  = 0
      M8    =-8
      COMPS = 1
      NOPSHL=-1
      NPSHEL= 0
      OLDID = 0
      CALL SSWTCH (40,L40)
C
C     READ THE ELEMENT CONNECTION TABLE.
C     IF PROPERTY DATA IS DEFINED FOR THE ELEMENT, READ THE EPT INTO
C     CORE AND SORT IF REQUIRED. THEN FOR EACH ECT ENTRY, LOOK UP AND
C     ATTACH THE PROPERTY DATA. WRITE ECT+EPT ON SCR1.
C     IF PROPERTY DATA NOT DEFINED FOR ELEMENT, COPY ECT DATA ON SCR1.
C     IF NO SIMPLE ELEMENTS IN ECT, RETURN.
C
C     FOR THE PLATE AND SHELL ELEMENTS REFERENCING PCOMP, PCOMP1 OR
C     PCOMP2 BULK DATA ENTRIES, PROPERTY DATA IN THE FORM OF PSHELL
C     BULK DATA ENTRY IS CALLED AND WRITTEN TO SCR1
C
      FILE = ECT
      CALL OPEN (*540,ECT,Z(BUF1),RDREW)
      CALL SKPREC (ECT,1)
      FILE = SCR1
      CALL OPEN (*1100,SCR1,Z(BUF3),WRTREW)
      BUF(1) = EPT
      CALL RDTRL(BUF)
      NOEPT = BUF(1)
      IF (BUF(1) .LT. 0) GO TO 10
      CALL PRELOC (*10,Z(BUF2),EPT)
C
C     LOCATE, ONE AT A TIME, SIMPLE ELEMENT TYPE IN ECT. IF PRESENT,
C     WRITE POINTER ON  SCR1. SET POINTERS AND, IF DEFINED, LOCATE AND
C     READ ALL PROPERTY DATA FROM EPT.
C
   10 CALL ECTLOC (*200,ECT,BUF,I)
      ID = -1
      ELTYPE = ELEM(I+2)
      CALL WRITE (SCR1,I,1,0)
      Q4T3 = .FALSE.
      IF (ELTYPE.EQ.QUAD4 .OR. ELTYPE.EQ.TRIA3) Q4T3 = .TRUE.
      IF (ELEM(I+10) .EQ. 0) KSCALR = 1
      M  = ELEM(I+5)
      MM = ELEM(I+8)
      IF (MM .EQ. 0) GO TO 120
      MX = MM
      NOPROP = 0
      IF (ELEM(I+6) .NE. LSTPRP) GO TO 20
      IF (ELTYPE    .EQ. QDMEM2) NOPROP = 1
      GO TO 80
   20 IF (NOEPT .LT. 0) GO TO 1130
C
C     LOCATE PROPERTY CARD
C
      LL = 0
      CALL LOCATE (*50,Z(BUF2),ELEM(I+6),FLAG)
      NOPROP = 1
   30 LSTPRP = ELEM(I+6)
   40 IF (LL+MM .GE. BUF3) CALL MESAGE (-8,0,NAM)
      IF (NOPROP .EQ. 0) GO TO 80
      CALL READ (*1110,*55,EPT,Z(LL+1),MM,0,FLAG)
      LL = LL + MM
      GO TO 40
C
C     CHECK FOR QUAD4 AND TRIA3 ELEMENTS WITH ONLY PCOMP CARDS
C
C     SET POINTER FOR NO PSHELL DATA, AND
C     READ PCOMP, PCOMP1 AND PCOMP2 DATA INTO CORE
C
   50 IF (.NOT.Q4T3) GO TO 60
      NOPSHL = 1
      GO TO 700
C
C     CHECK FOR QUAD4 AND TRIA3 ELEMENTS WITH BOTH PCOMP AND PSHELL
C     CARDS
C
C     IF LL.GT.0 HERE, PSHELL DATA IS PRESENT,
C     NEED TO CHECK THE PRESENCE OF PCOMP DATA, AND RESET NOPSHL POINTER
C     IF NECCESSARY
C
C     EVENTUALLY, WE WILL HAVE
C
C     NOPSHL =-1, LOGIC ERROR FOR QUAD4/TRIA3 PROPERTY DATA
C            = 0, ONLY PSHELL DATA PRESENT
C            = 1, ONLY PCOMP TYPE DATA PRESENT
C            = 2, BOTH PSHELL AND PCOMP DATA PRESENT (SEE STA.760)
C
   55 IF (.NOT.Q4T3) GO TO 70
      IF (LL .LE. 0) GO TO 700
      NOPSHL = 0
      GO TO 70
C
   60 IF (NOPROP .EQ. 0) GO TO 1130
C
C     Z(1) THRU Z(LL) CONTAIN PROPERTY DATA
C
   70 IF (MM .LE. 4) CALL SORT (0,0,MM,1,Z(1),LL)
      KN = LL/MM
      IF (NOPSHL .EQ. 0) GO TO 700
C
C     READ ECT DATA FOR ELEMENT. LOOK UP PROPERTY DATA IF CURRENT ELEM.
C     HAS A PROPERTY ID DIFFERNENT FROM THAT OF THE PREVIOUS ELEMENT.
C     WRITE ECT + EPT (OR NEW GENERATED PSHELL) DATA ON SCR1.
C
   80 CALL READ (*1110,*140,ECT,BUF,M,0,FLAG)
      NOSIMP = NOSIMP + 1
      IF (BUF(2) .NE. ID) NOPROP = 1
      ID = BUF(2)
      BUF(2) = BUF(1)
      BUF(1) = M + MM - 2
      IF (NOPROP .EQ. 0) GO TO 90
      IF (Q4T3 .AND. NOPSHL.EQ.1) GO TO 800
      NPSHEL = 0
      GO TO 600
   90 CALL WRITE (SCR1,BUF(1),M,0)
      IF (.NOT.Q4T3) GO TO 100
      IF (NPSHEL .EQ. 1) GO TO 110
  100 CALL WRITE (SCR1,Z(KX+2),MM-1,0)
      NPSHEL = 0
      NOPROP = 0
      GO TO 80
  110 CALL WRITE (SCR1,IPSHEL(1),MM-1,0)
      NOPROP = 0
      GO TO 80
C
C     EPT DATA NOT DEFINED FOR ELEMENT. COPY ECT DATA ON SCR1.
C
  120 BUF(1) = M
      M1 = M + 1
  130 CALL READ  (*1110,*140,ECT,BUF(2),M,0,FLAG)
      CALL WRITE (SCR1,BUF(1),M1,0)
      NOSIMP = NOSIMP + 1
      GO TO 130
  140 CALL WRITE (SCR1,0,0,1)
      GO TO 10
C
C     HERE WHEN ALL ELEMENTS HAVE BEEN PROCESSED.
C     IF NONE FOUND, EXIT.
C
  200 CONTINUE
      IF (NOEPT .GE. 0) CALL CLOSE (EPT,CLSREW)
      CALL CLOSE (SCR1,CLSREW)
      IF (NOSIMP .EQ. -1) RETURN
      NOSIMP = NOSIMP + 1
C
C     READ THE BGPDT INTO CORE (UNLESS ALL SCALAR PROBLEM).
C     READ THE SIL INTO CORE.
C
      NBGP = 0
      IF (KSCALR .EQ. 0) GO TO 220
      FILE = BGPDT
      CALL OPEN   (*1100,BGPDT,Z(BUF1),RDREW)
      CALL FWDREC (*1110,BGPDT)
      CALL READ   (*1110,*210,BGPDT,Z(1),BUF2,1,NBGP)
      CALL MESAGE (M8,0,NAM)
  210 CALL CLOSE  (BGPDT,CLSREW)
  220 FILE = SIL
      CALL OPEN   (*1100,SIL,Z(BUF1),RDREW)
      CALL FWDREC (*1110,SIL)
      CALL READ   (*1110,*230,SIL,Z(NBGP+1),BUF2-NBGP,1,NSIL)
      CALL MESAGE (M8,0,NAM)
  230 CALL CLOSE  (SIL,CLSREW)
C
C     IF TEMP DEPENDENT MATERIALS IN PROBLEM,
C     OPEN GPTT AND POSITION TO PROPER THERMAL RECORD
C
      RECORD = .FALSE.
      ITEMP  = TEMPID
      IF (TEMPID .EQ. 0) GO TO 310
      FILE = GPTT
      CALL OPEN (*1160,GPTT,Z(BUF3),RDREW)
      ITMPID = NBGP+NSIL+3
      CALL READ (*1110,*240,GPTT,Z(ITMPID-2),BUF2-ITMPID,1,NID)
      CALL MESAGE (-8,0,NAM)
  240 NTMPID = ITMPID - 5 + NID
      DO 250 I = ITMPID,NTMPID,3
      IF (TEMPID .EQ. Z(I)) GO TO 260
  250 CONTINUE
      GO TO 1160
  260 IDFTMP = Z(I+1)
      IF (IDFTMP .NE. -1) DEFTMP = ZZ(I+1)
      N = Z(I+2)
      IF (N .EQ. 0) GO TO 310
      RECORD =.TRUE.
      N = N - 1
      IF (N .EQ. 0) GO TO 280
      DO 270 I = 1,N
      CALL FWDREC (*1110,GPTT)
  270 CONTINUE
C
C     READ SET ID AND VERIFY FOR CORRECTNESS
C
  280 CALL READ (*1110,*1120,GPTT,ISET,1,0,FLAG)
      IF (ISET .EQ. TEMPID) GO TO 300
      WRITE  (NOUT, 290) SFM,ISET,TEMPID
  290 FORMAT (A25,' 4020, TA1A HAS PICKED UP TEMPERATURE SET',I9,
     1       ' AND NOT THE REQUESTED SET',I9)
      CALL MESAGE (-61,0,0)
C
C     INITIALIZE /TA1ETT/ VARIABLES
C
  300 OLDEID = 0
      OLDEL  = 0
      EORFLG =.FALSE.
      ENDID  =.TRUE.
C
C     LOOP THRU THE ECT+EPT DATA
C     CONVERT INTERNAL GRID POINT INDICES TO SIL VALUES FOR EACH NON-
C     SCALER ELEMENT, ATTACH THE BGPDT DATA AND,
C     IF A TEMPERATURE PROBLEM, COMPUTE THE ELEMENT TEMP FROM THE GPTT
C     DATA OR SUBSTITUTE THE DEFAULT TEMP.
C     WRITE THE RESULT ON THE EST, ONE RECORD PER ELEMENT TYPE
C
  310 CALL OPEN  (*1100,SCR1,Z(BUF1),RDREW)
      CALL OPEN  (*1100,EST,Z(BUF2),WRTREW)
      CALL FNAME (EST,BUF)
      CALL WRITE (EST,BUF,2,1)
      LOCBGP = 1
C
C     RESET SOME OF THE /TA1ACM/ VALUES IF IT IS A -HEAT- FORMULATION
C
      IF (IHEAT .LE. 0) GO TO 320
C
C     TRIARG ELEMENT (TYPE 36)
      IG(36) = 14
C
C     TRAPRG ELEMENT (TYPE 37)
      IG(37) = 14
C
C     REPLACE QDMEM1 ELEMENT (TYPE 62) BY QDMEM ELEMENT (TYPE 16)
      IG(62) = 14
C
C     REPLACE QDMEM2 ELEMENT (TYPE 63) BY QDMEM ELEMENT (TYPE 16)
      IG(63) = 14
C
C     READ POINTER FROM SCR1. WRITE ELEMENT TYPE ON EST.
C     SET POINTERS FOR CONVERSION OF GRID NOS TO SIL VALUES.
C
  320 CALL READ (*500,*1120,SCR1,I,1,0,FLAG)
      ELTYPE = ELEM(I+2)
      CALL WRITE (EST,ELTYPE,1,0)
C
C     ELEMENT TYPE  USED TO INDEX INTO /TA1ACM/
C     AND SET USED  /OPEN CORE/  BLOCKS NEGATIVE
C
      IG(ELTYPE) = -IG(ELTYPE)
      NAME  = ELEM(I   )
      JSCALR= ELEM(I+10)
      MM    = ELEM(I+ 9)
      LX    = ELEM(I+12)
      IF (ELEM(I+8) .EQ. 0) LX = LX + 1
      MM    = LX + MM - 1
      JTEMP = ELEM(I+13)
      NTEMP = 1
      IF (JTEMP .EQ. 4) NTEMP = ELEM(I+14) - 1
C         IHEX1/2/3,TRIM6
C
C     READ ECT + EPT DATA FOR ELEMENT FROM SCR1.
C
  330 CALL READ (*1110,*400,SCR1,BUF,1,0,FLAG)
      CALL READ (*1110,*1120,SCR1,BUF(2),BUF(1),0,FLAG)
C
      IF (NOGO.NE.0 .OR. NOGOX.NE.0) GO TO 350
      IF (ELTYPE .NE. BAR) GO TO 350
C
C     FOR BAR AND BEAM ELEMENTS, STORE COORDINATES AND
C     COORDINATE SYSTEM ID FOR ORIENTATION VECTOR.
C
      KX = 4*(BUF(3)-1) + LOCBGP
      IF (BUF(8) .EQ. 1) GO TO 340
      BUF(8) = BUF(5)
      IF (BUF(8) .EQ. 0) GO TO 340
      K = 4*(BUF(8)-1)  + LOCBGP
      BUFR(5) = ZZ(K+1) - ZZ(KX+1)
      BUFR(6) = ZZ(K+2) - ZZ(KX+2)
      BUFR(7) = ZZ(K+3) - ZZ(KX+3)
      BUF(8)  = 0
      GO TO 350
  340 BUF(8)  = Z(KX)
C
C     SAVE INTERNAL GRID NOS, THEN CONVERT TO SIL NOS
C     AND WRITE ECT + EPT DATA ON EST.
C
  350 DO 360 L = LX,MM
      GPSAV(L) = 0
      IF (BUF(L) .EQ. 0) GO TO 360
      GPSAV(L) = BUF(L)
      K = GPSAV(L) + NBGP
      BUF(L) = Z(K)
  360 CONTINUE
      CALL WRITE (EST,BUF(2),BUF(1),0)
C
C     IF NOT SCALAR ELEMENT, PICK UP BGPDT DATA AND WRITE ON EST.
C
      IF (JSCALR .NE. 0) GO TO 330
      DO 380 L = LX,MM
      IF (GPSAV(L) .EQ. 0) GO TO 370
      K = (GPSAV(L)-1)*4
      CALL WRITE (EST,Z(K+1),4,0)
      IF (Z(K+1) .GE. 0) GO TO 380
      IF (ELTYPE.EQ.HBDY .AND. L.GT.LX+3) GO TO 380
      NOGO = 1
      CALL MESAGE (30,131,BUF(2))
      GO TO 380
  370 CALL WRITE (EST,ZEROS,4,0)
  380 CONTINUE
C
C     ELEMENT TEMP. IS NOT USED IN CONM1 AND CONM2 (ELEM TYPES 29 30)
C
      TGRID(1) = 0.
      IF (ELTYPE.EQ.29 .OR. ELTYPE.EQ.30) GO TO 390
C
C     IF NOT SCALAR ELEMENT, COMPUTE AND WRITE ELEMENT TEMP ON EST.
C
      CALL TA1ETD (BUF(2),TGRID,NTEMP)
      IF (ELTYPE .EQ. BAR) TGRID(1) = (TGRID(1)+TGRID(2))/2.0
  390 CALL WRITE (EST,TGRID,NTEMP,0)
      GO TO 330
C
C     CLOSE EST RECORD AND RETURN FOR ANOTHER ELEMENT TYPE.
C
  400 CALL WRITE (EST,0,0,1)
      GO TO 320
C
C     ALL ELEMENTS HAVE BEEN PROCESSED-- CLOSE FILES, WRITE TRAILER AND
C     EXIT
C
  500 CALL CLOSE (SCR1,CLSREW)
      CALL CLOSE (EST,CLSREW)
      CALL CLOSE (GPTT,CLSREW)
      BUF(1) = EST
      BUF(2) = NOSIMP
      IF (NOGOX .NE. 0) NOGO = 1
      IF (NOGO  .NE. 0) CALL MESAGE (-61,0,0)
      DO 510 I = 3,7
  510 BUF(I) = 0
C
C     PROCESS /TA1ACM/ LOAD EST TRAILER WITH FLAGS
C     TO THE USED /OPEN CORE/ BLOCKS
C
      DO 530 I = 1,NELEM
      IF (IG(I) .GE. 0) GO TO 530
      K = IG(I)
      DO 520 J = I,NELEM
  520 IF (IG(J) .EQ. K) IG(J) = -IG(J)
      J = IG(I)
      IF (J .GT. 48) CALL MESAGE (-61,I,J)
      K = (J-1)/16
      J = J - K*16
      BUF(K+5) = BUF(K+5) + KTWO(J+16)
  530 CONTINUE
      CALL WRTTRL (BUF)
  540 RETURN
C
C     **************************************************
C
C     INTERNAL BINARY SEARCH ROUTINE
C
  600 KLO = 1
      KHI = KN
  610 K   = (KLO+KHI+1)/2
  620 KX  = (K-1)*MX + ITABL
      IF (ID-Z(KX+1)) 630,90,640
  630 KHI = K
      GO TO 650
  640 KLO = K
  650 IF (KHI-KLO-1 ) 690,660,610
  660 IF (K .EQ. KLO) GO TO 670
      K   = KLO
      GO TO 680
  670 K   = KHI
  680 KLO = KHI
      GO TO 620
  690 IF (Q4T3 .AND. NOPSHL.GE.1) GO TO 800
      GO TO 1140
C
C     **************************************************
C
C     PROCESSING FOR LAMINATED COMPOSITES
C
C     INTERNAL SUBROUTINE TO READ PCOMP, PCOMP1 AND PCOMP2 DATA INTO
C     CORE
C
C
C     INITIALIZE VARIABLES AND SET POINTERS
C
  700 NPC    = 0
      NPC1   = 0
      NPC2   = 0
      TYPC   = 0
      TYPC1  = 0
      TYPC2  = 0
      N      = BUF3 - LL
C
C     LOCATE PCOMP DATA AND READ INTO CORE
C
      IPC  = LL + 1
      CALL LOCATE (*720,Z(BUF2),PCOMP,FLAG)
      CALL READ   (*1110,*710,EPT,Z(IPC),N,0,NPC)
      CALL MESAGE (-8,0,NAM)
  710 IF (NPC .GT. 0) TYPC = 1
      N = N - NPC
C
C     LOCATE PCOMP1 DATA AND READ INTO CORE
C
  720 IPC1 = IPC + NPC
      CALL LOCATE (*740,Z(BUF2),PCOMP1,FLAG)
      CALL READ   (*1110,*730,EPT,Z(IPC1),N,0,NPC1)
      CALL MESAGE (-8,0,NAM)
  730 IF (NPC1 .GT. 0) TYPC1 = 1
      N = N - NPC1
C
C     LOCATE PCOMP2 DATA AND READ INTO CORE
C
  740 IPC2 = IPC1 + NPC1
      CALL LOCATE (*760,Z(BUF2),PCOMP2,FLAG)
      CALL READ   (*1110,*750,EPT,Z(IPC2),N,0,NPC2)
      CALL MESAGE (-8,0,NAM)
  750 IF (NPC2 .GT. 0) TYPC2 = 1
C
C     SET SIZE OF LPCOMP. NUMBER OF WORDS READ INTO CORE
C
  760 LPCOMP = IPC2 + NPC2
      IF (LPCOMP-1 .GT. LL) COMPS = -1
C
C     CHECK FOR NO PCOMP, PCOMP1 OR PCOMP2 DATA
C     SET NOPSHL TO 2 IF BOTH 'PCOMP' AND PSHELL DATA ARE PRESENT
C
      IF (NOPSHL.EQ.1 .AND. COMPS.EQ. 1) GO TO 1130
      IF (NOPSHL.EQ.0 .AND. COMPS.EQ.-1) NOPSHL = 2
      GO TO 80
C
C     ***************************************************************
C
C     INTERNAL SUBROUTINE TO LOCATE A PARTICULAR PROPERTY ID FROM THE
C     'PCOMP' DATA AND TO CONVERT THE DATA TO PSHELL DATA FORMAT
C
  800 CONTINUE
C
C     Z(LL+1) THRU Z(LPCOMP) CONTAIN 'PCOMP' DATA
C
C     SET POINTERS
C
      KPC    = 4
      KPC2   = 2
      LEN    = 0
      NLAY   = 0
      EOELOC = 0
      PIDLOC = 0
      ITYPE  =-1
C
C     SEARCH FOR PID IN PCOMP DATA
C
      IF (TYPC .EQ. 0) GO TO 850
      Z(LPCOMP+1) = IPC
      NPCOMP = 0
      N = 2
C
      LPC = IPC1 - 1
      DO 820 IIP = IPC,LPC
      IF (Z(IIP) .NE. -1) GO TO 820
      Z(LPCOMP+N  ) = IIP
      Z(LPCOMP+N+1) = IIP + 1
      IF (IIP .EQ. LPC) Z(LPCOMP+N+1) = 0
      N = N + 2
      NPCOMP = NPCOMP + 1
  820 CONTINUE
      IF (LPCOMP+N-2 .GE. BUF3) CALL MESAGE (-8,0,NAM)
C
C     LOCATE PARTICULAR PID
C
      DO 830 IIP = 1,NPCOMP
      EOELOC = Z(LPCOMP+2*IIP  )
      PIDLOC = Z(LPCOMP+2*IIP-1)
      IF (Z(PIDLOC) .EQ. ID) GO TO 840
  830 CONTINUE
      GO TO 850
C
  840 LEN  = EOELOC - PIDLOC
      NLAY = (LEN-8)/KPC
      ITYPE= 0
      GO TO 940
C
C     SEARCH FOR PID IN PCOMP1 DATA
C
  850 IF (TYPC1 .EQ. 0) GO TO 890
C
      Z(LPCOMP+1) = IPC1
      NPCOMP = 0
      N = 2
C
      LPC1 = IPC2 - 1
      DO 860 IIP1 = IPC1,LPC1
      IF (Z(IIP1) .NE. -1) GO TO 860
      Z(LPCOMP+N  ) = IIP1
      Z(LPCOMP+N+1) = IIP1 + 1
      IF (IIP1 .EQ. LPC1) Z(LPCOMP+N+1) = 0
      NPCOMP = NPCOMP + 1
      N = N + 2
  860 CONTINUE
      IF (LPCOMP+N-2 .GE. BUF3) CALL MESAGE (-8,0,NAM)
C
C     LOCATE PARTICULAR PID
C
      DO 870 IIP1 = 1,NPCOMP
      EOELOC = Z(LPCOMP+2*IIP1  )
      PIDLOC = Z(LPCOMP+2*IIP1-1)
      IF (Z(PIDLOC) .EQ. ID) GO TO 880
  870 CONTINUE
      GO TO 890
C
  880 LEN  = EOELOC - PIDLOC
      NLAY = LEN - 8
      ITYPE= 1
      GO TO 940
C
C     SEARCH FOR PID IN PCOMP2 DATA
C
  890 IF (TYPC2 .EQ. 0) GO TO 930
C
      Z(LPCOMP+1) = IPC2
      NPCOMP = 0
      N = 2
C
      LPC2 = LPCOMP - 1
      DO 900 IIP2 = IPC2,LPC2
      IF (Z(IIP2) .NE. -1) GO TO 900
      Z(LPCOMP+N  ) = IIP2
      Z(LPCOMP+N+1) = IIP2 + 1
      IF (IIP2 .EQ. LPC2) Z(LPCOMP+N+1) = 0
      NPCOMP = NPCOMP + 1
      N = N + 2
  900 CONTINUE
      IF (LPCOMP+N-2 .GE. BUF3) CALL MESAGE (-8,0,NAM)
C
C     LOCATE PARTICULAR PID
C
      DO 910 IIP2 = 1,NPCOMP
      EOELOC = Z(LPCOMP+2*IIP2  )
      PIDLOC = Z(LPCOMP+2*IIP2-1)
      IF (Z(PIDLOC) .EQ. ID) GO TO 920
  910 CONTINUE
      GO TO 930
C
  920 LEN  = EOELOC - PIDLOC
      NLAY = (LEN-8)/KPC2
      ITYPE= 2
      GO TO 940
C
C     CHECK IF PID HAS BEEN FOUND IN 'PCOMP' DATA
C
  930 IF (ITYPE .LT. 0) GO TO 1140
C
C     DETERMINE DATA TO BE WRITTEN IN THE FORM OF PSHELL AND
C     WRITE TO SCR1
C
C     ITYPE  = 0,  PCOMP  ENTRY
C            = 1,  PCOMP1 ENTRY
C            = 2,  PCOMP2 ENTRY
C
C     CALCULATE LAMINATE THICKNESS - TLAM
C
  940 TLAM = 0.
C
C     NOTE - IF Z(PIDLOC+7) IS EQUAL TO SYM OR SYMMEM, THE OPTION
C            TO MODEL EITHER A SYMMETRICAL OR SYMMETRICAL-MEMBRANE
C            LAMINATE HAS BEEN EXERCISED.  THEREFORE, THE TOTAL
C            THICKNESS IS TLAM = 2.0*TLAM
C
C     SET LAMOPT
C
      LAMOPT = Z(PIDLOC+7)
C
C     PCOMP DATA
C
      IF (ITYPE .GT. 0) GO TO 960
      DO 950 K = 1,NLAY
      II   = (PIDLOC+5) + 4*K
      TLAM = TLAM + ZZ(II)
  950 CONTINUE
      IF (LAMOPT.EQ.SYM .OR. LAMOPT.EQ.SYMMEM) TLAM = 2.0*TLAM
      GO TO 1000
C
C     PCOMP1 DATA
C
  960 IF (ITYPE .GT. 1) GO TO 970
      II   = PIDLOC + 6
      TLAM = ZZ(II)*NLAY
      IF (LAMOPT.EQ.SYM .OR. LAMOPT.EQ.SYMMEM) TLAM = 2.0*TLAM
      GO TO 1000
C
C     PCOMP2 DATA
C
  970 DO 980 K = 1,NLAY
      II   = (PIDLOC+6) + 2*K
      TLAM = TLAM + ZZ(II)
  980 CONTINUE
      IF (LAMOPT.EQ.SYM .OR. LAMOPT.EQ.SYMMEM) TLAM = 2.0*TLAM
C
C
C     CREATE NEW PSHELL DATA AND WRITE TO ARRAY IPSHEL
C     NOTE - PID IS NOT WRITTEN TO IPSHEL
C
C     IPSHEL DATA TO BE WRITTEN TO SCR1
C     ============================================================
C     IPSHEL( 1)     = MID1     MEMBRANE MATERIAL
C     IPSHEL( 2)     = T        DEFAULT MEMBRANE THICKNESS
C     IPSHEL( 3)     = MID2     BENDING MATERIAL
C     IPSHEL( 4)     = 12I/T**3 BENDING STIFFNESS PARAMETER
C     IPSHEL( 5)     = MID3     TRANVERSE SHEAR MATERIAL
C     IPSHEL( 6)     = TS/T     SHEAR THICKNESS FACTOR
C     IPSHEL( 7)     = NSM      NON-STRUCTURAL MASS
C     IPSHEL(8,9)    = Z1,Z2    FIBRE DISTANCES
C     IPSHEL(10)     = MID4     MEMBRANE-BENDING COUPLING MATERIAL
C     IPSHEL(11)     = MCSID OR THETAM   //DATA FROM PSHELL
C     IPSHEL(12)     = FLAGM               OVERRIDDEN BY EST(18-19)//
C     IPSHEL(13)     = INTEGRATION ORDER (SET TO 0)
C                     (THE INTEGRATION ORDER IS NOT USED IN THE PROGRAM,
C                      BUT THIS WORD IS REQUIRED BECAUSE OF THE DESIGN
C                      OF THE EST DATA FOR THE CQUAD4/TRIA3 ELEMENTS.)
C     IPSHEL(14)     = SCSID OR THETAS   //DATA FROM PSHELL
C     IPSHEL(15)     = FLAGS               OVERRIDDEN BY EST(20-21)//
C     IPSHEL(16)     = ZOFF
C
C     CALCULATE ZOFFS
C
 1000 IF (Z(PIDLOC+1) .NE. 0) ZOFFS = ZZ(PIDLOC+1) + 0.5*TLAM
      IF (Z(PIDLOC+1) .EQ. 0) ZOFFS = 0.0
      IF (ABS(ZOFFS)  .LE. 0.001) ZOFFS = 0.0
C
C     SET POINTER TO INDICATE NEW PSHELL DATA CREATED
C
      NPSHEL = 1
C
C     INITIALIZE IPSHEL ARRAY
C
      DO 1010 KK = 1,16
      IPSHEL(KK) = 0
 1010 CONTINUE
C
      RPSHEL( 4) = 1.0
      RPSHEL( 6) = 1.0
C
      IPSHEL( 1) = ID + 100000000
      RPSHEL( 2) = TLAM
      IF (LAMOPT.EQ.MEM .OR. LAMOPT.EQ.SYMMEM) GO TO 1020
      IPSHEL( 3) = ID + 200000000
      IPSHEL( 5) = ID + 300000000
 1020 RPSHEL( 7) = ZZ(PIDLOC+2)
      RPSHEL( 9) = 0.5*TLAM
      RPSHEL( 8) =-RPSHEL(9)
      IF (LAMOPT.NE.SYM .AND. LAMOPT.NE.MEM .AND. LAMOPT.NE.SYMMEM)
     1    IPSHEL(10) = ID + 400000000
      IPSHEL(13) = 0
      RPSHEL(16) = ZOFFS
C
C     DO NOT WRITE TO OUTPUT FILE IF PREVIOUS ID IS SAME AS NEW ID.
C     OTHERWISE, WRITE THE NEWLY CREATED PSHELL BULK DATA ENTRY TO
C     OUTPUT FILE IF DIAG 40 IS TURNED ON
C
      IF (OLDID .EQ. ID) GO TO 1060
      IF (  .NOT.FRSTIM) GO TO 1040
      FRSTIM = .FALSE.
      IF (L40 .EQ. 0) GO TO 1060
CWKBR CALL PAGE (3)
      CALL PAGE2 (3)
      WRITE  (NOUT,1030)
 1030 FORMAT (//9X,'THE INPUT PCOMP, PCOMP1 OR PCOMP2 BULK DATA',
     1       ' ENTRIES HAVE BEEN REPLACED BY THE FOLLOWING PSHELL',
     2       ' AND MAT2 ENTRIES.',//)
 1040 IF (L40 .EQ. 0) GO TO 1060
      WRITE (NOUT,1050) ID,IPSHEL( 1),RPSHEL( 2),IPSHEL( 3),
     1                     RPSHEL( 4),IPSHEL( 5),RPSHEL( 6),
     2                     RPSHEL( 7),RPSHEL( 8),RPSHEL( 9),
     3                     IPSHEL(10),RPSHEL(11),RPSHEL(14),
     4                     RPSHEL(16)
 1050 FORMAT (' PSHELL',I14,I12,1X,1P,E11.4,I12,1X,1P,E11.4,I12,
     1       2(1X,1P,E11.4), /9X,2(1X,1P,E11.4),I12,2(1X,F11.1),1X,
     2       1P,E11.4)
C
C     SET OLDID TO ID
C
 1060 OLDID = ID
      GO TO 90
C
C     FATAL ERROR MESSAGES
C
 1100 J = -1
      GO TO 1150
 1110 J = -2
      GO TO 1150
 1120 J = -3
      GO TO 1150
 1130 BUF(1) = ELEM(I  )
      BUF(2) = ELEM(I+1)
      NOGOX  = 1
      CALL MESAGE (30,11,BUF)
      KX = ITABL
      GO TO 30
 1140 KSAVEW = BUF(3)
      BUF(3) = ID
      NOGO = 1
      CALL MESAGE (30,10,BUF(2))
      KX = ITABL
      BUF(3) = KSAVEW
      GO TO 90
 1150 CALL MESAGE (J,FILE,NAM)
 1160 BUF(1) = TEMPID
      BUF(2) = 0
      CALL MESAGE (-30,44,BUF)
      RETURN
C
C     ARRAY IG IS FIRST DIMENSIONED IN TA1ABD
C
 1190 WRITE  (NOUT,1200) SFM
 1200 FORMAT (A25,', IG ARRAY IN TA1A TOO SMALL')
      CALL MESAGE (-61,0,0)
C
      END

      SUBROUTINE IFPMDC
C
C     IFPMDC MODIFIES BULK DATA CARDS GIVEN THE INFORMATION ON IFIL
C
      EXTERNAL        LSHIFT,RSHIFT,ANDF,ORF
      LOGICAL         ABORT,CF,DIAG
      INTEGER         RET,ANDF,ORF,RSHIFT,T1,CNT,DUM,X,EXI,TEST,APPRCH,
     1                ICK(6),IVC(2),INC(2),XI(2),CON(38)
      DIMENSION       RM(1),RM1(1),CD(6)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG / UFM,UWM,UIM,SFM
      COMMON /IFPX1 / NCDS,T1(2,1)
      COMMON /MACHIN/ MACH
      COMMON /SYSTEM/ IBUF,NOUT,ABORT,DUM(17),APPRCH,DUM1(17),NBITS,X,
     1                NCPW,DUM2(41),JRUN
      COMMON /IFPDTA/ ID(2),KN,D1(52),M(50),MF(50),M1(35),M1F(35),
     1                D2(3),NOPEN,D3(6),KNT,D4(18)
      COMMON /TWO   / ITWO(32)
      COMMON /IFPX0 / LBD,LCC,IBITS(18),IPARPT
      COMMON /ZZZZZZ/ KOR(1)
      COMMON /XSRTCM/ IM1(6),IM2(5),IM3(4),IM4(4),IM5(2),IM6,IM7(8),IM8,
     1                ISFT(4),IM9(7),ISFIM,IM10(3),MIS
      EQUIVALENCE (RM(1),M(1)),(RM1(1),M1(1)),(ICK(1),CD(1)),(K,ICK(1))
      DATA CON/4H    ,4H   0,4H   1,4H   2,4H   3,4H   4,4H   5,4H   6,
     1  4H   7,4H   8,4H   9,4H   A,4H   B,4H   C,4H   D,4H   E,4H   F,
     2  4H   G,4H   H,4H   I,4H   J,4H   K,4H   L,4H   M,4H   N,4H   O,
     3  4H   P,4H   Q,4H   R,4H   S,4H   T,4H   U,4H   V,4H   W,4H   X,
     4  4H   Y,4H   Z,4H    /
      DATA    IFIL, IEOF, ICYCL,   IEFM,   IEND,   DIAG  /
     1        213,    0,     0, -32767, 4HZZZZ, .FALSE. /
C
      IF (IEOF .EQ. -1) GO TO 190
      CNT = 0
      IF (IEOF .EQ.  1) GO TO 10
C
C     FIRST CALL INITIALIZE OPEN FILE ADJUST CORE
C
      IBUF1 = NOPEN + 2*IBUF
      NOPEN = NOPEN - IBUF
      DO 1 I = 1,38
    1 CON(I) = ANDF(CON(I),IM3(4))
      IF (NOPEN .LE. 0) GO TO 1001
      CF   = .FALSE.
      IOD  = 0
      ISC  = 0
      NF   = 0
      IONF = 0
      ILST = 0
      IEOF = 1
      CALL OPEN (*1002,IFIL,KOR(IBUF1+1),0)
    5 CALL READ (*180,*180,IFIL,ICK,6,0,NW)
C
C     CHECK INCOMING  CALL FOR VARY MATCH SORT, UNSORT AND/OR CONT
C
   10 IF (K .EQ. KN) GO TO 20
C
C     NOT CARD WE ARE WORKING ON CHECK ALPH POSITION
C
      IF (CF .OR. IOD.EQ.KN) GO TO 190
      IOD = KN
      ISC = 0
      ASSIGN 15 TO EXI
      XI(1) = T1(1,K)
      XI(2) = T1(2,K)
      GO TO 100
   15 IVC(1) = XI(1)
      IVC(2) = XI(2)
      ASSIGN 16 TO EXI
      XI(1) = T1(1,KN)
      XI(I) = T1(2,KN)
      GO TO 100
   16 INC(1) = XI(1)
      INC(2) = XI(2)
      IF (MACH .EQ. 2) GO TO 18
      INC(1) = RSHIFT(INC(1),1)
      IVC(1) = RSHIFT(IVC(1),1)
   18 IF (INC(1) .LT. IVC(1)) GO TO 190
      IF (INC(1) .GT. IVC(1)) GO TO 1004
C
C     SHIFT IN CASE OF STAR
C
      INC(2) = RSHIFT(INC(2),NBITS)
      IVC(2) = RSHIFT(IVC(2),NBITS)
      IF (INC(2)-IVC(2)) 190,1004,1004
C
C     CARD TYPE FOUND TRY ID
C
   20 IF (ICK(2) .LT. 0) GO TO 70
      IF (CF .AND. NF.NE.0 .AND. ILST.EQ.ICK(2) .AND. CNT.EQ.1) GO TO 31
      IF (CF .AND. NF.NE.0 .AND. ILST.EQ.ICK(2)) GO TO 25
      IF (CF) GO TO 190
      NF   = 0
      IONF = 0
      ASSIGN 5 TO RET
      IF (M(1) .LT. ICK(2)) GO TO 190
      IF (M(1) .GT. ICK(2)) GO TO 1004
      ILST = ICK(2)
C
C     FIND FIELD FORMAT DOES NOT COUNT FOR FIELD  1 OR 10 K1=COUNT
C
   25 DO 27 I = 1,50
      IF (MF(I) .EQ. IEFM) GO TO 30
   27 CONTINUE
      GO TO 1002
   30 NF  = NF + I - 1
      CNT = 1
   31 K1  = ICK(3)
C
C     FIND NUMBER OF FIELDS TO PITCH
C
      I  = K1/10
      J  = (K1-1)/10
      K1 = K1 - I - J - 1
C
C     CHECK TO SEE IF WE HAVE IT NOW
C
      IF (K1 .GT. NF) GO TO 60
C
C     CHECK FORMAT FIELD FOR TYPE
C
      K1 = K1 - IONF
      IF (MF(K1).NE.2 .AND. MF(K1).NE.0) GO TO 1003
      J = 0
      DO 36 I = 1,K1
      J = J + 1
      IF (MF(I) .GT. 2) J = J +1
   36 CONTINUE
C
C     PERFORM VARY
C
      IF (CD(6) .EQ. 0.0) GO TO 38
      RM(J) = RM(J)*(1.0 + CD(4)*CD(5))**CD(6)
      IF (DIAG) WRITE (NOUT,1000) UIM,T1(1,K),T1(2,K),KNT,ICK(2),ICK(3),
     1          RM(J)
      GO TO 40
   38 RM(J ) = RM(J) + CD(4)*CD(5)
      MF(K1) = 2
      IF (DIAG) WRITE (NOUT,1000) UIM,T1(1,K),T1(2,K),KNT,ICK(2),ICK(3),
     1          RM(J)
      GO TO 40
C
C     SET RESTART BITS
C
   40 IF (APPRCH .GE. 0) GO TO 50
C
C     CHECK FOR PARAM CARDS (82)
C
      IF (KN .NE. 82) GO TO 45
      DO 41 I = IPARPT,NCDS
      IF (M(1).EQ.T1(1,I) .AND. M(2).EQ.T1(2,I)) GO TO 42
   41 CONTINUE
      GO TO 50
   42 J = I - 1
      GO TO 46
   45 J = KN - 1
   46 KARL = 1
      IF (ICYCL .EQ. 0) IBITS(KARL) = ORF(IBITS(KARL),RSHIFT(1,(X-1)))
      ICYCL = (J/31) + KARL
      IPOS  = MOD(J,31) + 2
      IBITS(ICYCL) = ORF(IBITS(ICYCL),ITWO(IPOS))
   50 GO TO RET, (5,90)
   60 IF (M1(1).NE.0 .AND. M1(2).NE.0) GO TO 1004
      GO TO 190
C
C     SORTED TYPE OF IDS NEED TO COUNT PARENTS IN THE GROUP
C
   70 CONTINUE
      IF (CF .AND. NF.NE.0 .AND. ISC.EQ.ICK(2) .AND. CNT.EQ.1) GO TO 31
      IF (CF .AND. NF.NE.0 .AND. ISC.EQ.ICK(2)) GO TO 25
      IF (CF) GO TO 190
      IF (CNT .EQ. 1) GO TO 80
      CNT = 1
      NF  = 0
      IONF= 0
      ASSIGN 90 TO RET
      ISC = ISC - 1
   80 CONTINUE
      IF (ISC .GT. ICK(2)) GO TO 190
      IF (ISC-ICK(2)) 1004,25,25
C
C     FOUND ID FIND FIELD
C
   90 CALL READ (*180,*180,IFIL,ICK,6,0,NW)
      IF (K.EQ.KN .AND. NF.NE.0 .AND. ISC.EQ.ICK(2)) GO TO 31
      GO TO 10
C
C     CHANGE EXTERNAL BCD TO INTERNAL BCD FOR SORT TEST
C
  100 DO 150 I = 1,2
      ITM  = XI(I)
      DO 130 J = 1,4
      JI   = 5 - J
      ISTS = ISFT(JI)
      TEST = RSHIFT(ANDF(ITM,IM3(J)),ISTS)
      DO 110 L = 1,37
      IF (TEST .EQ. CON(L)) GO TO 120
  110 CONTINUE
      L = 1
      GO TO 140
  120 ITM = ORF(ANDF(ITM,IM4(J)),LSHIFT(L,ISTS +ISFIM))
      IF (L .EQ. 1) GO TO 140
  130 CONTINUE
  140 XI(I) = ITM
      IF (L .EQ. 1) GO TO 160
  150 CONTINUE
  160 GO TO EXI, (15,16)
C
C     IFP IS DONE BUT VARY IS NOT   MESSAGES FOR ANY LEFT
C
  170 WRITE (NOUT,1014) UFM,T1(1,K),T1(2,K),ICK(2),ICK(3)
      CALL READ (*180,*180,IFIL,ICK,6,0,NW)
      GO TO 170
C
C     END OF IFIL
C
  180 CALL CLOSE (IFIL,1)
      IEOF  = -1
      NCORE = NCORE + IBUF
C
  190 CF = .FALSE.
      IONF = NF
      IF (M1(1).EQ.0 .AND. M1(2).EQ.0) CF = .TRUE.
      IF (M1(1) .NE. IEND) GO TO 200
C
C     LAST TIME ENTERED MAKE SURE FILE IS USED UP
C
      IF (IEOF .GE. 0) GO TO 170
  200 RETURN
C
C     ERROR MESSAGES
C
 1000 FORMAT (A29,' 3310, CARD TYPE ',2A4,' SORTED',I9,' ID',I9,
     1       ' FIELD',I9,' CHANGED TO ',E16.8)
 1001 WRITE  (NOUT,1011) UFM
 1011 FORMAT (A23,' 303, NO OPEN CORE IFP')
      GO TO  1111
 1002 WRITE  (NOUT,1012) SFM
 1012 FORMAT (A25,' 3037, ERROR IN IFPMDC')
      GO TO  1111
 1003 WRITE  (NOUT,1013) UFM,T1(1,K),T1(2,K),KNT,ICK(2),ICK(3)
 1013 FORMAT (A23,' 0301, FIELD TO VARY IS NOT A REAL NUMBER. CARD ',
     1        2A4,'SORTED',I9,' ID',I9,' FIELD',I9)
      ABORT = .TRUE.
      GO TO RET, (5,90)
 1004 WRITE  (NOUT,1014) UFM,T1(1,K),T1(2,K),ICK(2),ICK(3)
 1014 FORMAT (A23,' 520, CARD TO VARY NOT FOUND. CARD ',2A4,' ID',I9,
     1       ' FIELD',I9)
      GO TO RET, (5,90)
 1111 ABORT = .TRUE.
      NOPEN = NOPEN + IBUF
      IEOF  = -1
      GO TO 190
      END

      SUBROUTINE RCOVVA (IN,INTYP,OUTT,OUTU,OUTV,OUTA,SSNM,RZ,DZ,CZ)
C
C     THIS SUBROUTINE COMPUTES THE VELOCITIES AND ACCELERATIONS FOR
C     FOR A GIVEN DISPLACEMENT VECTOR
C
C     INTYP = 0   IN CONTAINS U ONLY AND V AND A ARE CALCULATED
C     INTYP = 1   U CONTAINS U, V AND A SO THEY ARE SPLIT ONTO OUTU,
C                 OUTV AND OUTA
C     INTYP =-1   OUTU, OUTV AND OUTA ARE MERGED ONTO OUTT
C
      INTEGER          DRY        ,RSS        ,UA         ,NAME(2)    ,
     1                 RC         ,RFNO       ,MCBU(7)    ,MCBV(7)    ,
     2                 SRD        ,SOLN       ,BUF1       ,BUF2       ,
     3                 BUF3       ,BUF4       ,INBLK3(15) ,OUTBLK(15) ,
     4                 SYSBUF     ,OUTT       ,OUTU       ,OUTV       ,
     5                 OUTA       ,MCB(7)     ,MCBA(7)    ,INBLK(15)  ,
     6                 OBLK1(15)  ,OBLK2(15)  ,OBLK3(15)  ,TEMP(4)    ,
     7                 FILE       ,SSNM(2)    ,INBLK1(15) ,INBLK2(15)
      REAL             RZ(4)      ,FREQ       ,RSCALE     ,ISCALE
      DOUBLE PRECISION DZ(1)      ,RVAL       ,IVAL
      COMPLEX          CZ(2)      ,SCALE
      CHARACTER        UFM*23     ,UWM*25     ,UIM*29     ,SFM*25     ,
     1                 SWM*27
      COMMON /XMSSG /  UFM        ,UWM        ,UIM        ,SFM        ,
     1                 SWM
      COMMON /BLANK /  DRY        ,LOOP       ,STEP       ,FSS(2)     ,
     1                 RFNO       ,NEIGV      ,LUI        ,UINMS(2,5) ,
     2                 NOSORT     ,UTHRES     ,PTHRES     ,QTHRES
      COMMON /RCOVCR/  ICORE      ,LCORE      ,BUF1       ,BUF2       ,
     1                 BUF3       ,BUF4       ,SOF1       ,SOF2       ,
     2                 SOF3
      COMMON /RCOVCM/  MRECVR     ,UA         ,PA         ,QA         ,
     1                 IOPT       ,RSS(2)     ,ENERGY     ,UIMPRO     ,
     2                 RANGE(2)   ,IREQ       ,LREQ       ,LBASIC
      COMMON /SYSTEM/  SYSBUF     ,NOUT
      COMMON /NAMES /  RD         ,RDREW      ,WRT        ,WRTREW     ,
     1                 REW        ,NOREW      ,EOFNRW     ,RSP        ,
     2                 RDP        ,CSP        ,CDP        ,SQUARE     ,
     3                 RECT       ,DIAG       ,UPPER      ,LOWER      ,
     4                 SYM
      COMMON /CONDAS/  PHI        ,TWOPHI
      COMMON /PACKX /  ITINP      ,ITOUTP     ,IRP        ,NRP        ,
     1                 INCRP
      COMMON /UNPAKX/  ITINU      ,IRU        ,NRU        ,INCRU
      COMMON /TYPE  /  PR(2)      ,NWORDS(4)
      EQUIVALENCE      (TEMP(1),SCALE,RSCALE) ,(TEMP(2),ISCALE)       ,
     1                 (INBLK1(1),OBLK1(1))   ,(INBLK2(1),OBLK2(1))   ,
     2                 (INBLK3(1),OBLK3(1))   ,(OUTBLK(1),INBLK(1))
      DATA    NAME  /  4HRCOV,4HVA   /
      DATA    SRD   /  1             /
      DATA    SOLN  /  4HSOLN        /
C
C     GET DISPLACEMENT TRAILER AND DETERMINE TYPE
C
      IF (OUTT.NE.0 .AND. OUTU+OUTV+OUTA.NE.0 .AND. INTYP.GE.0)
     1   GO TO 9007
C
      FILE = IN
      IF (INTYP .LT. 0) FILE = OUTU
      MCB(1) = FILE
      CALL RDTRL (MCB)
      IF (MCB(1) .LT. 0) GO TO 9001
      NCOL  = MCB(2)
      NROW  = MCB(3)
      IPREC = MCB(5)
      NWORD = NWORDS(IPREC)
      NWCOL = NROW*NWORD
C
C     SET UP PACK UNPACK COMMONS
C
      ITINU = IPREC
      IRU   = 1
      NRU   = NROW
      INCRU = 1
      ITINP = IPREC
      ITOUTP= IPREC
      IRP   = 1
      NRP   = NROW
      INCRP = 1
C
C     BRANCH ON TYPE OF DISPLACEMENTS OR RIGID FORMAT
C
      IF (INTYP .GT. 0) GO TO 400
      IF (INTYP .LT. 0) GO TO 500
C
      IF (RFNO .GT. 9) GO TO 9007
      GO TO (600,600,100,9007,9007,9007,9007,200,400), RFNO
C
C     NORMAL MODES
C
C     CHECK IF VECTORS ARE COMPLEX
C
  100 IF (IPREC .GE. 3) GO TO 200
C
C     REAL NORMAL MODES
C
C     V =  U*OMEGA
C     A = -V*OMEGA
C
      IF (LCORE .LT. NWCOL) GO TO 6313
      ITEM = SOLN
      CALL SFETCH (SSNM,SOLN,SRD,RC)
      IF (RC .NE. 1) GO TO 6000
      N = 1
      CALL SJUMP (N)
      IF (N .LT. 0) GO TO 6100
C
      CALL GOPEN (IN,RZ(BUF1),RDREW)
      IF (OUTT .NE. 0) CALL GOPEN (OUTT,RZ(BUF2),WRTREW)
      IF (OUTU .NE. 0) CALL GOPEN (OUTU,RZ(BUF2),WRTREW)
      IF (OUTV .NE. 0) CALL GOPEN (OUTV,RZ(BUF3),WRTREW)
      IF (OUTA .NE. 0) CALL GOPEN (OUTA,RZ(BUF4),WRTREW)
      CALL MAKMCB (MCB,OUTT,NROW,RECT,IPREC)
      CALL MAKMCB (MCBU,OUTU,NROW,RECT,IPREC)
      CALL MAKMCB (MCBV,OUTV,NROW,RECT,IPREC)
      CALL MAKMCB (MCBA,OUTA,NROW,RECT,IPREC)
C
C     LOOP THROUGH EACH COLUMN
C
      DO 180 I = 1,NCOL
C
C     GET SCALE FACTOR FOR THIS COLUMN
C
      CALL SUREAD (RZ,7,NWDS,RC)
      IF (RC .NE. 1) GO TO 6200
      RSCALE = RZ(4)
C
      CALL UNPACK (*110,IN,RZ)
      GO TO 120
  110 DO 105 J = 1,NWCOL
  105 RZ(J) = 0.0
  120 IF (OUTT .NE. 0) CALL PACK (RZ(1),OUTT,MCB)
      IF (OUTU .NE. 0) CALL PACK (RZ(1),OUTU,MCBU)
C
      DO 170 J = 1,2
      IF (IPREC .EQ. 2) GO TO 140
C
      DO 130 K = 1,NROW
  130 RZ(K) = RSCALE*RZ(K)
      GO TO 160
C
  140 DO 150 K = 1,NROW
  150 DZ(K) = RSCALE*DZ(K)
C
  160 IF (OUTT .NE. 0) CALL PACK (RZ(1),OUTT,MCB)
      IF (OUTV.NE.0 .AND. J.EQ.1) CALL PACK (RZ(1),OUTV,MCBV)
      IF (OUTA.NE.0 .AND. J.EQ.2) CALL PACK (RZ(1),OUTA,MCBA)
C
      RSCALE = -RSCALE
  170 CONTINUE
  180 CONTINUE
C
C
      CALL CLOSE (IN,REW)
      IF (OUTT .NE. 0) CALL CLOSE (OUTT,REW)
      IF (OUTU .NE. 0) CALL CLOSE (OUTU,REW)
      IF (OUTV .NE. 0) CALL CLOSE (OUTV,REW)
      IF (OUTA .NE. 0) CALL CLOSE (OUTA,REW)
      IF (OUTT .NE. 0) CALL WRTTRL (MCB)
      IF (OUTU .NE. 0) CALL WRTTRL (MCBU)
      IF (OUTV .NE. 0) CALL WRTTRL (MCBV)
      IF (OUTA .NE. 0) CALL WRTTRL (MCBA)
      GO TO 600
C
C     COMPLEX NORMAL MODES
C
C     V = U*POLE
C     A = V*POLE
C
C     FREQUENCY RESPONSE
C
C     V = U*TWOPHI*FREQ*I
C     A = V*TWOPHI*FREQ*I
C
  200 IF (LCORE .LT. NWCOL) GO TO 6313
      ITEM = SOLN
      CALL SFETCH (SSNM,SOLN,SRD,RC)
      IF (RC .NE. 1) GO TO 6000
      N = 1
      CALL SJUMP (N)
      IF (N .LT. 0) GO TO 6100
C
      CALL GOPEN (IN,RZ(BUF1),RDREW)
      IF (OUTT .NE. 0) CALL GOPEN (OUTT,RZ(BUF2),WRTREW)
      IF (OUTU .NE. 0) CALL GOPEN (OUTU,RZ(BUF2),WRTREW)
      IF (OUTV .NE. 0) CALL GOPEN (OUTV,RZ(BUF3),WRTREW)
      IF (OUTA .NE. 0) CALL GOPEN (OUTA,RZ(BUF4),WRTREW)
      CALL MAKMCB (MCB ,OUTT,NROW,RECT,IPREC)
      CALL MAKMCB (MCBU,OUTU,NROW,RECT,IPREC)
      CALL MAKMCB (MCBV,OUTV,NROW,RECT,IPREC)
      CALL MAKMCB (MCBA,OUTA,NROW,RECT,IPREC)
C
C     LOOP THROUGH EACH COLUMN
C
      DO 290 I = 1,NCOL
C
C     GET SCALE FACTOR FOR THIS COLUMN
C
      IF (RFNO .EQ. 8) GO TO 204
      CALL SUREAD (CZ(1),7,NWDS,RC)
      IF (RC .NE. 1) GO TO 6200
      SCALE = CZ(2)
      GO TO 206
  204 CALL SUREAD (FREQ,1,NWDS,RC)
      IF (RC .NE. 1) GO TO 6200
      SCALE = TWOPHI*FREQ*(0.0,1.0)
C
  206 CALL UNPACK (*210,IN,CZ(1))
      GO TO 230
  210 DO 220 J = 1,NWCOL
  220 RZ(J) = 0.0
  230 IF (OUTT .NE. 0) CALL PACK (CZ(1),OUTT,MCB)
      IF (OUTU .NE. 0) CALL PACK (CZ(1),OUTU,MCBU)
C
      DO 280 J = 1,2
      IF (IPREC .GT. 3) GO TO 250
C
      DO 240 K = 1,NROW
  240 CZ(K) = SCALE*CZ(K)
      GO TO 270
C
  250 NT = NROW*2
      DO 260 K = 1,NT,2
      RVAL = DZ(K  )
      IVAL = DZ(K+1)
      DZ(K  ) = RSCALE*RVAL - ISCALE*IVAL
  260 DZ(K+1) = RSCALE*IVAL + ISCALE*RVAL
C
  270 IF (OUTT .NE. 0) CALL PACK (CZ(1),OUTT,MCB)
      IF (OUTV.NE.0 .AND. J.EQ.1) CALL PACK (CZ(1),OUTV,MCBV)
      IF (OUTA.NE.0 .AND. J.EQ.2) CALL PACK (CZ(1),OUTA,MCBA)
C
  280 CONTINUE
C
  290 CONTINUE
C
      CALL CLOSE (IN,REW)
      IF (OUTT .NE. 0) CALL CLOSE (OUTT,REW)
      IF (OUTU .NE. 0) CALL CLOSE (OUTU,REW)
      IF (OUTV .NE. 0) CALL CLOSE (OUTV,REW)
      IF (OUTA .NE. 0) CALL CLOSE (OUTA,REW)
      IF (OUTT .NE. 0) CALL WRTTRL (MCB)
      IF (OUTU .NE. 0) CALL WRTTRL (MCBU)
      IF (OUTV .NE. 0) CALL WRTTRL (MCBV)
      IF (OUTA .NE. 0) CALL WRTTRL (MCBA)
      GO TO 600
C
C     THE DISPLACEMENT FILE ALREADY CONTAINS THE VELOCITIES AND
C     ACCELERATIONS SO WE JUST SANT TO SPLIT THEM UP
C
  400 IF (LCORE .LT. 0) GO TO 6313
      CALL GOPEN (IN,RZ(BUF1),RDREW)
      IF (OUTU .NE. 0) CALL GOPEN (OUTU,RZ(BUF2),WRTREW)
      IF (OUTV .NE. 0) CALL GOPEN (OUTV,RZ(BUF3),WRTREW)
      IF (OUTA .NE. 0) CALL GOPEN (OUTA,RZ(BUF4),WRTREW)
C
      INBLK(1) = IN
      OBLK1(1) = OUTU
      OBLK2(1) = OUTV
      OBLK3(1) = OUTA
      FILE = IN
      NCOL = NCOL/3
C
      DO 410 I = 1,NCOL
      IF (OUTU .NE. 0) CALL CPYSTR (INBLK,OBLK1,0,I)
      IF (OUTU .EQ. 0) CALL FWDREC (*9002,IN)
      IF (OUTV .NE. 0) CALL CPYSTR (INBLK,OBLK2,0,I)
      IF (OUTV .EQ. 0) CALL FWDREC (*9002,IN)
      IF (OUTA .NE. 0) CALL CPYSTR (INBLK,OBLK3,0,I)
      IF (OUTA .EQ. 0) CALL FWDREC (*9002,IN)
  410 CONTINUE
C
      CALL CLOSE (IN,REW)
      IF (OUTU .NE. 0) CALL CLOSE (OUTU,REW)
      IF (OUTV .NE. 0) CALL CLOSE (OUTV,REW)
      IF (OUTA .NE. 0) CALL CLOSE (OUTA,REW)
      MCB(2) = NCOL
      MCB(1) = OUTU
      IF (OUTU .NE. 0) CALL WRTTRL (MCB)
      MCB(1) = OUTV
      IF (OUTV .NE. 0) CALL WRTTRL (MCB)
      MCB(1) = OUTA
      IF (OUTA .NE. 0) CALL WRTTRL (MCB)
      GO TO 600
C
C     THE DISPLACEMENTS, VELOCITIES AND ACCLERATIONS ALREADY EXIST AND
C     ARE TO BE MERGED TOGETHER
C
  500 IF (LCORE .LT. 0) GO TO 6313
      CALL GOPEN (OUTU,RZ(BUF1),RDREW)
      CALL GOPEN (OUTV,RZ(BUF2),RDREW)
      CALL GOPEN (OUTA,RZ(BUF3),RDREW)
      CALL GOPEN (OUTT,RZ(BUF4),WRTREW)
C
      INBLK1(1) = OUTU
      INBLK2(1) = OUTV
      INBLK3(1) = OUTA
      OUTBLK(1) = OUTT
C
      J = 1
      DO 510 I = 1,NCOL
      CALL CPYSTR (INBLK1,OUTBLK,0,J)
      J = J + 1
      CALL CPYSTR (INBLK2,OUTBLK,0,J)
      J = J + 1
      CALL CPYSTR (INBLK3,OUTBLK,0,J)
      J = J + 1
  510 CONTINUE
C
      CALL CLOSE (OUTU,REW)
      CALL CLOSE (OUTV,REW)
      CALL CLOSE (OUTA,REW)
      CALL CLOSE (OUTT,REW)
      MCB(1) = OUTT
      MCB(2) = NCOL*3
      CALL WRTTRL (MCB)
C
C     NORMAL RETURN
C
  600 RETURN
C
C     ERRORS
C
 6000 IF (RC .EQ. 6) GO TO 9100
      CALL SMSG (RC-2,ITEM,SSNM)
      GO TO 9200
 6100 CALL SMSG (7,ITEM,SSNM)
      GO TO 9200
 6200 CALL SMSG (RC+4,ITEM,SSNM)
      GO TO 9200
 6313 WRITE  (NOUT,6314) SWM,RSS
 6314 FORMAT (A25,' 6313, INSUFFICIENT CORE FOR RCOVR MODULE WHILE ',
     1       'TRYING TO PROCESS', /34X,'PRINTOUT DATA BLOCKS FOR ',
     2       'SUBSTRUCTURE ',2A4)
      GO TO 9200
 9001 N = 1
      GO TO 9100
 9002 N = 2
      GO TO 9100
 9007 N = 7
 9100 CALL MESAGE (N,FILE,NAME)
 9200 IN = 0
      CALL CLOSE (IN,REW)
      IF (OUTT .NE. 0) CALL CLOSE (OUTT,REW)
      IF (OUTU .NE. 0) CALL CLOSE (OUTU,REW)
      IF (OUTV .NE. 0) CALL CLOSE (OUTV,REW)
      IF (OUTA .NE. 0) CALL CLOSE (OUTA,REW)
C
      RETURN
      END

      SUBROUTINE XPUNP
C
C     THIS SUBROUTINE POOLS AND UNPOOLS FILES AS PRESCRIBED BY XFIAT
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        LSHIFT    ,ANDF    ,ORF
      DIMENSION       HEADER( 8),HEAD( 2),NPUNP( 2),BLOCK(1000),
     1                DDBN  ( 1),DFNU( 1),FCUM ( 1),FCUS (   1),
     2                FDBN  ( 1),FEQU( 1),FILE ( 1),FKND (   1),
     3                FMAT  ( 1),FNTU( 1),FPUN ( 1),FON  (   1),
     4                FORD  ( 1),MINP( 1),MLSN ( 1),MOUT (   1),
     5                MSCR  ( 1),SAL ( 1),SDBN ( 1),SNTU (   1),
     6                SORD  ( 1)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG / UFM,UWM,UIM,SFM
      COMMON /XFIAT / FIAT(7)
      COMMON /XPFIST/ PFIST
      COMMON /XFIST / FIST(2)
      COMMON /XDPL  / DPD(6)
      COMMON /SYSTEM/ IBUFSZ,OUTTAP
      COMMON /ZZZZZZ/ BUF1(1)
      COMMON /XSFA1 / MD(401),SOS(1501),COMM(20),XF1AT(5)
      EQUIVALENCE               (DPD  (1),DNAF    ),(DPD  (2),DMXLG   ),
     1      (DPD  (3),DCULG   ),(DPD  (4),DDBN (1)),(DPD  (6),DFNU (1)),
     2      (FIAT (1),FUNLG   ),(FIAT (2),FMXLG   ),(FIAT (3),FCULG   ),
     3      (FIAT (4),FEQU (1)),(FIAT (4),FILE (1)),(FIAT (4),FORD (1)),
     4      (FIAT (5),FDBN (1)),(FIAT (7),FMAT (1)),(MD   (1),MLGN    ),
     5      (MD   (2),MLSN (1)),(MD   (3),MINP (1)),(MD   (4),MOUT (1)),
     6      (MD   (5),MSCR (1)),(SOS  (1),SLGN    ),(SOS  (2),SDBN (1)),
     7      (SOS  (4),SAL  (1)),(SOS  (4),SNTU (1)),(SOS  (4),SORD (1)),
     8      (XF1AT(1),FNTU (1)),(XF1AT(1),FON  (1)),(XF1AT(2),FPUN (1)),
     9      (XF1AT(3),FCUM (1)),(XF1AT(4),FCUS (1)),(XF1AT(5),FKND (1))
      EQUIVALENCE               (COMM (1),ALMSK   ),(COMM (2),APNDMK  ),
     1      (COMM (3),CURSNO  ),(COMM (4),ENTN1   ),(COMM (5),ENTN2   ),
     2      (COMM (6),ENTN3   ),(COMM (7),ENTN4   ),(COMM (8),FLAG    ),
     3      (COMM (9),FNX     ),(COMM(10),LMSK    ),(COMM(11),LXMSK   ),
     4      (COMM(12),MACSFT  ),(COMM(13),RMSK    ),(COMM(14),RXMSK   ),
     5      (COMM(15),S       ),(COMM(16),SCORNT  ),(COMM(17),TAPMSK  ),
     6      (COMM(18),THCRMK  ),(COMM(19),ZAP     )
      DATA  N/1000/  ,POOL/4HPOOL/  ,ENTN5/2/,  NPUNP/4HXPUN,4HP   /
C
C     ENTRY SIZE NUMBERS,  1=FIAT, 4=DPD
C
      ISW1 = 0
      ISW2 = 0
      ENTN1X  = ENTN1- 1
      FIST(2) = 1 + PFIST
C
C     COMPUTE INDEX FOR DUMMY ENTRY IN FIST
C
      FSTIDX = FIST(2)*2 + 1
      LMT3   = FCULG* ENTN1
C
C     CHECK FOR ANY FILES TO POOL
C
      FIST(FSTIDX) = 101
      DO 360 I = 1,LMT3,ENTN1
      IF (FPUN(I) .GE. 0) GO TO 360
      NN = ANDF(ALMSK,FPUN(I))
      FPUN(I)= 0
      IF (FMAT(I).NE.0 .OR.  FMAT(I+1).NE.0 .OR. FMAT(I+2).NE.0)
     1    GO TO 105
      IF (ENTN1.EQ.11 .AND. (FMAT(I+5).NE.0 .OR. FMAT(I+6).NE.0 .OR.
     1    FMAT(I+7).NE.0)) GO TO 105
      NN = 1
      GO TO 268
  105 CALL XPOLCK (FDBN(I),FDBN(I+1),FN,NX)
      IF (FN .EQ. 0) GO TO 110
      J = NX
      GO TO 268
  110 IF (ISW1 .NE. 0) GO TO 220
      ISW1 = 1
      CALL OPEN (*900,POOL,BUF1,2)
      CALL XFILPS (DNAF)
      CALL CLOSE (POOL,2)
      CALL OPEN (*900,POOL,BUF1,3)
      FNX = DNAF
  220 FIST(FSTIDX+1) = I + ENTN5
      CALL OPEN (*900,101,BUF1(IBUFSZ+1),0)
      NCNT = 0
C
C     WRITE SPECIAL FILE HEADER RECORD -- XPOOL DICT NAME    ( 2 WORDS )
C                                       + DATA BLOCK TRAILER ( 3 WORDS
C                                                         OR   6 WORDS )
C
      CALL WRITE (POOL,FDBN(I),2,0)
      IF (ENTN1 .EQ. 11) GO TO 230
      CALL WRITE (POOL,FMAT(I),3,1)
      GO TO 240
  230 CALL WRITE (POOL,FMAT(I  ),3,0)
      CALL WRITE (POOL,FMAT(I+5),3,1)
C
C     READ AND WRITE 1ST 2 WORDS OF DATA BLOCK HEADER.
C     THEN CALL CPYFIL TO COPY REMAINDER OF FILE.
C
  240 CALL READ (*910,*920,101,HEAD,2,0,FLAG)
      CALL WRITE (POOL,HEAD,2,0)
      CALL CPYFIL (101,POOL,BLOCK,N,FLAG)
      NCNT = ANDF(LXMSK,LSHIFT(FLAG/1000+1,16))
      CALL EOF (POOL)
      CALL CLOSE (101,1)
C
C     ADD FILE NAME OF FILE JUST POOLED TO DPD
C
      J = DCULG* ENTN4+ 1
      DCULG = DCULG+ 1
      IF (DCULG .GT. DMXLG) GO TO 700
      DFNU(J  ) = ORF(DNAF,NCNT)
      DDBN(J  ) = FDBN(I  )
      DDBN(J+1) = FDBN(I+1)
      CALL SSWTCH (3,L)
      IF (L .NE. 1)  GO TO 267
      CALL PAGE2 (-2)
      WRITE  (OUTTAP,266) DDBN(J),DDBN(J+1),HEAD(1),HEAD(2)
  266 FORMAT (16H0POOL FILE NAME , 2A4, 17H DATA BLOCK NAME ,2A4)
  267 DNAF = DNAF + 1
      FNX  = FNX  + 1
  268 HOLD = ANDF(RXMSK,FILE(I))
      LMT4 = I + ENTN1X
      DO 269 KK = I,LMT4
  269 FILE(KK) = 0
      FILE(I)  = HOLD
      FDBN(I)  = ALMSK
C
C     CHECK FOR EQUIV FILES
C
      IF (NN .EQ. 1) GO TO 360
C
C     THERE ARE EQUIV FILES
C
      DFNU(J) = ORF(S,DFNU(J))
      DFNUSV  = DFNU(J)
      DO 280 K = 1,LMT3,ENTN1
      IF (FEQU(K).GE.0 .OR. I.EQ.K) GO TO 280
      IF (ANDF(RMSK,FILE(I)) .NE. ANDF(RMSK,FILE(K))) GO TO 280
C
C     THIS IS AN EQUIV FILE
C
      CALL XPOLCK (FDBN(K),FDBN(K+1),FN,NX)
      IF (FN .EQ. 0) GO TO 272
      IF (DFNU(NX) .EQ. DFNUSV) GO TO 277
      DDBN(NX  ) = 0
      DDBN(NX+1) = 0
  272 J = J + ENTN4
      DCULG = DCULG + 1
      IF (DCULG .GT. DMXLG) GO TO 700
      DFNU(J  ) = DFNUSV
      DDBN(J  ) = FDBN(K)
      DDBN(J+1) = FDBN(K+1)
      LMT4= K+ ENTN1X
      DO 275 KK = K,LMT4
  275 FILE(KK) =  0
  277 NN = NN - 1
      IF (NN .EQ. 1) GO TO 360
  280 CONTINUE
      GO TO 930
  360 CONTINUE
      IF (ISW1 .EQ. 0) GO TO 400
      CALL CLOSE (POOL,1)
      FNX = 1
C
C     CHECK FOR ANY FILES TO UNPOOL
C
  400 FIST(FSTIDX) = 201
  405 FN = DNAF
      DO 420 I = 1,LMT3,ENTN1
      IF (FPUN(I).LE. 0 .OR. FPUN(I).GE.FN) GO TO 420
      FN = FPUN(I)
      II = I
  420 CONTINUE
      IF (FN .EQ. DNAF) GO TO 570
      FPUN(II) = 0
      IF (ISW2 .NE. 0) GO TO 470
      ISW2 = 1
      CALL OPEN (*900,POOL,BUF1,0)
      FNX = 1
  470 CALL XFILPS (FN)
      FNX= FN
      FIST(FSTIDX+1) = II + ENTN5
      CALL OPEN (*900,201,BUF1(IBUFSZ+1),1)
C
C     READ SPECIAL FILE HEADER RECORD AND, IF DIAG 3 IS ON, PRINT MSG
C
      CALL READ (*910,*920,POOL,HEADER,ENTN1-3,1,FLAG)
      CALL SSWTCH (3,L)
      IF (L .NE. 1) GO TO 500
      CALL PAGE2 (-2)
      WRITE  (OUTTAP,501) FDBN(II),FDBN(II+1),HEADER(1),HEADER(2)
  501 FORMAT (17H0XUNPL-DICT NAME ,2A4, 16H POOL FILE NAME , 2A4 )
C
C     COPY FILE USING CPYFIL
C
  500 CALL CPYFIL (POOL,201,BLOCK,N,FLAG)
      CALL CLOSE (201,1)
      FNX = FNX + 1
      FMAT(II  ) = HEADER(3)
      FMAT(II+1) = HEADER(4)
      FMAT(II+2) = HEADER(5)
      IF (ENTN1 .NE. 11) GO TO 510
      FMAT(II+5) = HEADER(6)
      FMAT(II+6) = HEADER(7)
      FMAT(II+7) = HEADER(8)
C
C     IS FILE EQUIVALENCED
C
  510 IF (FEQU(II) .GE. 0) GO TO 405
C
C     YES, COPY SAME TRAILER INTO ALL EQUIV FILES
C
      HOLD = ANDF(RMSK,FILE(II))
      DO 560 J = 1,LMT3,ENTN1
      IF (FEQU(J).GE.0 .OR. II.EQ.J) GO TO 560
      IF (HOLD .NE. ANDF(RMSK,FILE(J))) GO TO 560
      FMAT(J  ) = HEADER(3)
      FMAT(J+1) = HEADER(4)
      FMAT(J+2) = HEADER(5)
      IF (ENTN1 .NE.11) GO TO 560
      FMAT(J+5) = HEADER(6)
      FMAT(J+6) = HEADER(7)
      FMAT(J+7) = HEADER(8)
  560 CONTINUE
      GO TO 405
  570 IF (ISW2 .EQ. 0) GO TO 600
      CALL CLOSE (POOL,1)
      FNX = 1
  600 CONTINUE
      RETURN
C
C
  700 WRITE  (OUTTAP,701)
  701 FORMAT (1H0,23X,19H 1031, DPL OVERFLOW)
      GO TO 1000
  900 WRITE  (OUTTAP,901)
  901 FORMAT (1H0,23X,62H 1032, POOL OR FILE BEING POOLED/UN-POOLED COUL
     1D NOT BE OPENED)
      GO TO 1000
  910 WRITE  (OUTTAP,911)
  911 FORMAT (1H0,23X,39H 1033, ILLEGAL EOF ON FILE BEING POOLED)
      GO TO 1000
  920 WRITE  (OUTTAP,921)
  921 FORMAT (1H0,23X,39H 1034, ILLEGAL EOR ON FILE BEING POOLED)
      GO TO 1000
  930 WRITE  (OUTTAP,931)
  931 FORMAT (1H0,23X,33H 1035, EQUIV INDICATED,NONE FOUND)
 1000 CALL PAGE2 (-4)
      WRITE  (OUTTAP,1001) SFM
 1001 FORMAT (A25,1H.)
      CALL MESAGE (-37,0,NPUNP)
      RETURN
      END

      SUBROUTINE COM12  (*,IX,X,DX,ITERMM)
C
C*******
C      PROGRAM TO SOLVE A MATRIX OF ORDER ONE OR TWO FOR CDCOMP
C*******
      DOUBLE PRECISION DX(12),DET,MINDIA,DZ,DA
      INTEGER         SYSBUF,RDP,DUM
      INTEGER         TYPEL
      INTEGER         CDP
      INTEGER         SCRFLG,JPOSL,BBAR,CBCNT,R,BBBAR1,BBBAR,
     1                SR2FL,SR2FIL
      DIMENSION       SUB(2),X(1),IX(1)
      COMMON /SYSTEM/ SYSBUF
      COMMON /CDCMPX/ IFILA(7),IFILL(7),IFILU(7),DUM(3),DET(2),POWER,
     1                NX,MINDIA
      COMMON /NAMES / RD,RDREW,WRT,WRTREW,REW,NOREW,EOFNRW ,RSP,RDP,
     1                CSP,CDP
      COMMON /ZBLPKX/ DZ(2),JJ
      COMMON /PACKX / ITYPE1,ITYPE2,IY,JY,INCRY
      COMMON /UNPAKX/ ITYPEX,IXY,JXY,INCRX
      EQUIVALENCE     (IFILA(2),NCOL),(IFILL(5),TYPEL),(SR2FIL,DUM(2))
      DATA    SUB(1), SUB(2)  / 4HCOM1,4H2    /
C
      IBUF1 = NX-SYSBUF
      IBUF2 = IBUF1-SYSBUF
      CALL CLOSE(SR2FIL,REW)
      IBUF3 = IBUF2-SYSBUF
      IFILE = IFILU(1)
      IF(ITERMM .EQ. 1) IFILE = SR2FIL
      CALL GOPEN(IFILE,IX(IBUF3),WRTREW)
      CALL GOPEN(IFILA(1),IX(IBUF1),RDREW)
      ITYPEX = CDP
      ITYPE1 = CDP
      ITYPE2 = TYPEL
      INCRX  = 1
      INCRY  = 1
      IF(NCOL .EQ. 2) GO TO 100
      IF(NCOL .NE. 1) GO TO 5000
C*******
C     SOLVE A (1X1)
C*******
      IXY = 1
      JXY = 1
      CALL UNPACK(*5060,IFILA(1),DX)
      DET(1) = DX(1)
      DET(2) = DX(2)
      MINDIA = DSQRT(DX(1)**2+DX(2)**2)
      IY = 1
      JY = 1
      CALL PACK (DX,IFILE,IFILU)
      DX(1) = 0.D0
      DX(2) = 0.D0
      CALL PACK (DX,IFILL(1),IFILL)
   90 CALL CLOSE(IFILE,REW)
   95 CALL CLOSE(IFILA(1),REW)
      CALL CLOSE(IFILL(1),REW)
      RETURN
  100 IXY = 1
C*******
C     SOLVE A (2X2)
C*******
      JXY = 2
      CALL UNPACK(*5060,IFILA(1),DX   )
      CALL UNPACK(*5060,IFILA(1),DX(5))
      A = 1.
      IF(DX(1)**2+DX(2)**2 .GE. DX(3)**2+DX(4)**2) GO TO 150
C*******
C     PERFORM INTERCHANGE
C*******
      DET(1) = DX(1)
      DX(1)  = DX(3)
      DX(3)  = DET(1)
      DET(1) = DX(2)
      DX(2)  = DX(4)
      DX(4)  = DET(1)
      DET(1) = DX(5)
      DX(5)  = DX(7)
      DX(7)  = DET(1)
      DET(1) = DX(6)
      DX(6)  = DX(8)
      DX(8)  = DET(1)
      A      = -1.
  150 CONTINUE
      DET(1) = (DX(3)*DX(1)+DX(4)*DX(2))/(DX(1)**2+DX(2)**2)
      DX(4)  = (DX(4)*DX(1)-DX(3)*DX(2))/(DX(1)**2+DX(2)**2)
      DX(3)  = DET(1)
      DX(7)  = DX(7)-DX(3)*DX(5)+DX(4)*DX(6)
      DX(8)  = DX(8)-DX(3)*DX(6)-DX(4)*DX(5)
      DET(1) = DX(1)*DX(7)-DX(2)*DX(8)
      DET(2) = DX(2)*DX(7)+DX(1)*DX(8)
      IF((DX(1).EQ.0.D0 .AND. DX(2).EQ.0.D0) .OR. (DX(7).EQ.0.D0.AND.
     1    DX(8).EQ.0.D0)) GO TO 5060
      MINDIA = DMIN1(DSQRT(DX(1)**2+DX(2)**2),DSQRT(DX(7)**2+DX(8)**2))
      IY = 1
      JY = 2
      DX( 9) = 0.0D0
      DX(10) = 0.0D0
      IF(A .LT. 0.) DX(9) = 1.D0
      DX(11) = DX(3)
      DX(12) = DX(4)
      CALL PACK(DX(9),IFILL(1),IFILL)
      DX( 9) = 0.D0
      DX(10) = 0.D0
      JY = 1
      CALL PACK(DX(9),IFILL(1),IFILL)
      IF(ITERMM .EQ. 1) GO TO 160
      DX(3) = DX(5)
      DX(5) = DX(7)
      DX(7) = DX(3)
      DX(3) = DX(6)
      DX(6) = DX(8)
      DX(8) = DX(3)
      JY    = 2
      CALL PACK(DX(5),IFILU(1),IFILU)
      IY = 2
      CALL PACK (DX,IFILU(1),IFILU)
      GO TO 90
  160 CALL PACK(DX,IFILE,IFILU)
      JY = 2
      CALL PACK(DX(5),IFILE,IFILU)
      CALL CLOSE(IFILE,EOFNRW)
      GO TO 95
C
C
      ENTRY COMFIN (ITERM,SCRFLG,SR2FL,JPOSL,I1SP,BBAR,I1,CBCNT,
     1              IPAK,R,BBBAR1,BBBAR,I6SP,I4,I4SP,IX,DX,X,LCOL)
C
      IBUF1 = NX-SYSBUF
      IBUF2 = IBUF1-SYSBUF
      IBUF3 = IBUF2-SYSBUF
      CALL CLOSE(IFILA(1),REW)
      CALL OPEN(*5010,SR2FIL,IX(IBUF1),WRT)
      CALL CLOSE(SR2FIL,EOFNRW)
      K=0
      NAME =  IFILL(1)
      CALL OPEN(*5010,IFILL(1),IX(IBUF2),WRT)
      IF(SCRFLG.EQ.0) GO TO 2005
      NAME = SR2FL
      CALL OPEN(*5010,SR2FL,IX(IBUF3),RD)
 2005 LL = 0
 2010 JPOSL = JPOSL+1
      CALL BLDPK(CDP,TYPEL,IFILL(1),0,0)
      IN1 = I1SP+K
      JJ  = JPOSL
      DZ(1) = IX(IN1)
      DZ(2) = 0.D0
      CALL ZBLPKI
      KK   = 0
      IEND = MIN0(BBAR,NCOL-JJ)
      IF(IEND .EQ. 0) GO TO 2030
      IN1 = I1 +LL*BBAR*2
 2020 JJ  = JJ+1
      IN2 = IN1+KK+KK
      DZ(1) = DX(IN2)
      DZ(2) = DX(IN2+1)
      CALL ZBLPKI
      KK = KK+1
      IF(KK-IEND)2020,2030,5050
 2030 IF(CBCNT.EQ.0) GO TO 2050
C*******
C     PACK ACTIVE ROW ELEMENTS ALSO
C*******
      KK  = 0
 2035 IN1 = I6SP + KK
      IN2 = I4 +(IX(IN1)*BBBAR+K)*2
      DZ(1) = DX(IN2)
      DZ(2) = DX(IN2+1)
      IF(DZ(1) .EQ. 0.D0 .AND. DZ(2) .EQ. 0.D0) GO TO 2040
      IN1 = I4SP + IX(IN1)
      JJ  = IX(IN1)
      CALL ZBLPKI
 2040 KK = KK + 1
      IF(KK .LT. CBCNT) GO TO 2035
 2050 CALL BLDPKN(IFILL(1),0,IFILL)
      LL = LL + 1
      K  = K + 1
      IF (K .EQ. LCOL) GO TO 2080
      IF(K-R+1)2010,2060,2070
 2060 IF(R-BBBAR1)2070,2010,5050
 2070 LL  = LL-1
      IN1 = I1+LL*BBAR*2
      IBBAR4 = 4 * BBAR
      CALL READ(*5020,*5030,SR2FL,DX(IN1),IBBAR4,0,NO)
      GO TO 2010
 2080 CALL CLOSE(IFILL(1),REW)
      IF(SCRFLG.GT.0)CALL CLOSE(SR2FL,REW)
      IF(ITERM .NE. 0) RETURN
C*******
C     RE-WRITE THE UPPER TRIANGLE WITH THE RECORDS IN THE REVERSE ORDER
C*******
      INCRX  = 1
      INCRY  = 1
      ITYPE1 = TYPEL
      ITYPE2 = TYPEL
      ITYPEX = TYPEL
      IFILU(2) = 0
      IFILU(6) = 0
      IFILU(7) = 0
      NAME = SR2FIL
      CALL OPEN(*5010,SR2FIL,IX(IBUF1),RD)
      CALL GOPEN(IFILU(1),IX(IBUF2),WRTREW)
      DO 2300 I = 1,NCOL
      IXY = 0
      CALL BCKREC(SR2FIL)
      CALL UNPACK(*5060,SR2FIL,IX)
      CALL BCKREC(SR2FIL)
      KK = JXY-IXY+1
      K  = KK/2
      KK = KK + 1
      IF(TYPEL .EQ. 1) GO TO 2095
      IF(TYPEL .EQ. 4) GO TO 2061
      DO 2090 J = 1,K
      L  = KK-J
      DA = DX(J)
      DX(J) = DX(L)
 2090 DX(L) = DA
      GO TO 2100
 2061 KK = KK+KK-1
      K  = K+K
      DO 2092 J = 1,K,2
      L  = KK-J-1
      DA = DX(L)
      DX(L) = DX(J)
      DX(J) = DA
      DA = DX(L+1)
      DX(L+1) = DX(J+1)
 2092 DX(J+1) = DA
      GO TO 2100
 2095 DO 2097 J = 1,K
      L    = KK-J
      A    = X(J)
      X(J) = X(L)
 2097 X(L) = A
 2100 IY = NCOL-JXY+1
      JY = NCOL-IXY+1
      CALL PACK(IX,IFILU(1),IFILU)
 2300 CONTINUE
      CALL CLOSE(IFILU(1),REW)
      CALL CLOSE(SR2FIL,REW)
      RETURN
 5000 NO = -8
      GO TO 5500
 5010 NO = -1
      GO TO 5500
 5020 NO = -2
      GO TO 5500
 5030 NO = -3
      GO TO 5500
 5050 NO = -25
      GO TO 5500
 5060 RETURN 1
 5500 CALL MESAGE(NO,NAME,SUB(1))
      RETURN
      END

      SUBROUTINE EQMCKM
C
C     THIS SUBROUTINE CALCULATES THE MPC CONSTRAINT FORCES AND CREATES
C     THE OUTPUT FILE FOR OFP.
C     TASKS INCLUDE CREATING THE SCRATCH FILES FOR THE CURRENT SUBCASES
C     (PGG, QG - ALSO USED IN EQUILIBRIUM CHECKS).
C     NOT CODED TO HANDLE CONICAL ELEMENTS OR SORT2.
C
      LOGICAL         FIRSTC,FIRSTO,LASCAS,ANYOUT
      INTEGER         NAME(2),KON(10),IDAT(3),PARM,TRL,UG,UM,UN,MCB(7),
     1                RDNRW,RDRW,WRTNRW,WRTRW,ZZ,OCB(8)
      CHARACTER       UFM*23,UWM*25
      COMMON /XMSSG / UFM,UWM
      COMMON /NAMES / RDNRW,RDRW,WRTNRW,WRTRW,KRW,KNRW,KNERW
      COMMON /SYSTEM/ KSYSTM(80)
      COMMON /BITPOS/ UM,SKPS(8),UN,UG
      COMMON /BLANK / SKPB(2),NSKIP
      COMMON /EQMK1 / KSCC,KEXIN,KGPL,KBGDT,KSIL,KUSET,KGG,KGM,KUGV,
     1                KPGG,KQG,KCSTM,KLAM,KOQM,KSCR(7),KMPC,KLOAD,KSPC,
     2                PARM(4),TRL(7)
CZZ   COMMON /ZZSSA2/ ZZ(1)
      COMMON /ZZZZZZ/ ZZ(20000)
      COMMON /UNPAKX/ ITYPU,INRU,ILRU,INCU
      COMMON /MPYADX/ MA(7),MB(7),MC(7),MD(7),MZ,MT,MSAB,MSC,MPR,MSCR
      COMMON /PATX  / LCOR,INS(3),LUSET
      EQUIVALENCE     (MCB(1),OCB(1)),(KSYSTM(1),ISBZ),(KSYSTM(2),NOUT),
     1                (KSYSTM(15),ITIM),(KSYSTM(16),IDAT(1))
CWKBI 3/94 SPR93007      
      EQUIVALENCE     (KSYSTM(55),IPREC)
      DATA    NAME  / 4HEQMC,2HKM /
      DATA    KON   / 1,20,0,-1,0,0,0,0,1,8 /
      DATA    KG    / 1HG   /
C
C                      KNG
C     PARTITION  KGG = ---- , ONLY KMG SAVED
C                      KMG
      ANYOUT =.FALSE.
      NZZ    = KORSZ (ZZ(1))
      LCOR   = NZZ
      LUSET  = KUSET
      IF (KMPC .EQ. 0) GO TO 10
      KMPC   = -1
      CALL CALCV (KSCR(1),UG,UN,UM,ZZ)
      CALL SSG2A (KGG,0,KSCR(2),KSCR(1))
C
C     UNAPPEND FILES
C
   10 CONTINUE
      NZZ3 = NZZ - 3*ISBZ + 1
      NZZ2 = NZZ3 + ISBZ
      NZZ1 = NZZ2 + ISBZ
      NZZ4 = NZZ3
      IF (NSKIP.LE.0) NZZ4 = NZZ3 - ISBZ
C
      IF (NSKIP .LE. 1) GO TO 30
C
      IF (KLOAD .LE. 0) GO TO 20
      TRL(1) = KPGG
      MCB(1) = KSCR(4)
      CALL CURCAS (*15,NSKIP,TRL,MCB,ZZ,NZZ2)
      KPGG   = MCB(1)
       GO TO 20
   15 KLOAD  = 0
C
   20 IF (KUGV .LT. 0) GO TO 30
      TRL(1) = KUGV
      MCB(1) = KSCR(3)
      CALL CURCAS (*345,NSKIP,TRL,MCB,ZZ,NZZ2)
      KUGV   = MCB(1)
   30 CONTINUE
      IF (KMPC .EQ. 0) GO TO 360
C
C                      PN
C     PARTITION  PGG = --- , ONLY PM SAVED
C                      PM
      IF (KLOAD.GT.0) CALL SSG2A (KPGG,0,KSCR(7),KSCR(1))
C
C                 M
C     MULTIPLY  QM = -PM + KMG*UGV
C
      MD(1) = KSCR(5)
      MC(1) = KSCR(7)
      CALL RDTRL (MC)
      IF (KLOAD .LE. 0) MC(1) = 0
      MA(1) = KSCR(2)
      MB(1) = KUGV
      CALL RDTRL (MA)
      CALL RDTRL (MB)
      MD(3) = MA(3)
      MD(4) = MB(4)
CWKBR 11/93 SPR93007      MD(5) = 1
      MD(5) = IPREC
      MZ    = NZZ
      MT    = 0
      MSAB  = 1
      MSC   =-1
CWKBR 11/93 SPR93007      MPR   = 1
      MPR   = IPREC
      MSCR  = KSCR(1)
      CALL MPYAD (ZZ,ZZ,ZZ)
      IF (MD(3) .EQ. MD(2)) MD(4) = 1
      CALL WRTTRL (MD)
C
C                 N       T   M
C     MULTIPLY  QM = - GM * QM
C
      MD(1) = KSCR(6)
      MC(1) = 0
      MA(1) = KGM
      MB(1) = KSCR(5)
      CALL RDTRL (MA)
      CALL RDTRL (MB)
      MD(3) = MA(2)
      MD(4) = MB(4)
CWKBR SPR93007      MD(5) = 1
      MD(5) = IPREC
      MT    = 1
      MSAB  =-1
      CALL MPYAD (ZZ,ZZ,ZZ)
      IF (MD(3) .EQ. MD(2)) MD(4) = 1
      CALL WRTTRL (MD)
C
C             N      M
C     MERGE QM AND QM ON SCRATCH 3
C
      TRL(1) = KSCR(5)
      CALL RDTRL (TRL)
      IF (TRL(1) .LT. 0) GO TO 345
      KMPC   = 1
C
      CALL SDR1B (KSCR(1),KSCR(6),KSCR(5),KSCR(3),UG,UN,UM,KUSET,0,0)
      TRL(1) = KSCR(3)
      CALL RDTRL (TRL)
      MSZE   = 2*TRL(3)
C
C     CREATE MPC-CONSTRAINT OUTPUT FILE
C
      IF (KOQM .LE. 0) GO TO 360
      IAPP = 10
      IF (NSKIP .LT. 0) IAPP = 20
      CALL MXCID (*345,ZZ,KG,MSZE/2,2,KUSET,KGPL,KSIL,NZZ2)
      DO 40 I = 2,MSZE,2
   40 ZZ(I) = I/2
C
C     SORT ON EXTERNAL ID
C
      NENT = 2
      IF (MSZE .EQ. 2) GO TO 70
C
      IFIL = KSIL
      DO 60 I = 3,MSZE,2
      IF (ZZ(I) .GT. ZZ(I-2)) GO TO 50
      TRL(1) = ZZ(I)
      TRL(2) = ZZ(I+1)
      CALL BISHEL (*410,TRL,NENT,2,ZZ(1))
       GO TO 60
   50 NENT   = NENT + 2
   60 CONTINUE
C
   70 CONTINUE
      LKSCC  = MSZE + 1
      IF (LKSCC+146 .GE. NZZ4) GO TO 420
      IVEC   = 0
      TRL(1) = KSCR(3)
      CALL RDTRL (TRL)
      NVEC   = TRL(2)
      ITYPU  = 1
      INCU   = 1
      ISDONE = 0
      LASCAS = .FALSE.
      CALL GOPEN (KSCC,ZZ(NZZ1),RDRW)
      CALL GOPEN (KSCR(3),ZZ(NZZ3),RDRW)
C
      IF (NSKIP .GT. 0) GO TO 90
C
C     POSITION LAMA
C
      IFIL   = KLAM
      CALL OPEN (*350,KLAM,ZZ(NZZ4),RDRW)
      CALL READ (*440,*450,KLAM,0,0,1,I)
      CALL READ (*440,*450,KLAM,0,0,1,I)
   90 IFIL   = KOQM
      CALL OPEN (*430,KOQM,ZZ(NZZ2),WRTRW)
      CALL FNAME (KOQM,TRL(1))
      TRL(3) = ITIM
      TRL(4) = IDAT(1)
      TRL(5) = IDAT(2)
      TRL(6) = IDAT(3)
      TRL(7) = 1
      CALL WRITE (KOQM,TRL(1),7,1)
C
C     POSITION CASECC.  ASSUME USER WILL MISSET NSKIP
C
      IF (NSKIP .LE. 1) GO TO 100
      J    = NSKIP - 1
      IFIL = KSCC
      DO 95 I = 1,J
   95 CALL FWDREC (*440,KSCC)
C
C     LOOP ON EACH VECTOR
C
  100 IVEC = IVEC + 1
C
C     SUBCASE ID
C
      CALL READ (*160,*160,KSCC,ZZ(LKSCC),38,0,I)
      ISB = ZZ(LKSCC  )
      ILD = ZZ(LKSCC+3)
      IEG = 0
C
C     CLEAN UP UNUSED WORDS
C
      I = LKSCC + 10
      J = LKSCC + 49
      DO 105 K = I,J
  105  ZZ(K) = 0
C
C     TITLES
C
      CALL FREAD (KSCC,ZZ(LKSCC+50),96,0)
      CALL FREAD (KSCC,0,-31,0)
      CALL FREAD (KSCC,LCC,1,0)
      CALL FREAD (KSCC,0,-6,0)
C
C     MPCFORCE REQUEST
C
      NGSET = 0
      LSETD = LKSCC + 146
      CALL FREAD (KSCC,INS(1),3,0)
      IF (INS(1)) 110,120,130
C
C     ALL REQUESTED
C
  110 CALL FREAD (KSCC,0,0,1)
       GO TO 180
C
C     NONE REQUESTED
C
  120 IFIL = KLAM
      CALL FREAD (KSCC,0,0,1)
      IF (NSKIP .GT. 0) GO TO 240
      CALL READ (*350,*350,KLAM,TRL(1),7,0,I)
       GO TO 240
C
C     SET REQUESTED
C
  130 CONTINUE
      CALL FREAD (KSCC,0,-LCC+176,0)
C
C     SKIP SYMMETRY SEQUENCE
C
      CALL FREAD (KSCC,I,1,0)
      IF (I .LE. 0) GO TO 140
      CALL FREAD (KSCC,0,-I,0)
  140 IFIL = KSCC
      CALL READ (*440,*450,KSCC,TRL(1),2,0,I)
      IF (TRL(1) .EQ. INS(1)) GO TO 150
      CALL FREAD (KSCC,0,-TRL(2),0)
      GO TO 140
  150 IF (LSETD+TRL(2).GT.NZZ4) GO TO 420
      NGSET = TRL(2)
      CALL FREAD (KSCC,ZZ(LSETD),NGSET,1)
      GO TO 180
C
C     EOF ON CASE CONTROL.  CHECK IF REALLY DONE
C
  160 CONTINUE
      IF (NSKIP .LT.   0) GO TO 170
      IF (IVEC .GT. NVEC) GO TO 350
      IFIL = KSCC
      GO TO 440
C
  170 IF (IVEC .GT. NVEC) GO TO 350
      LASCAS = .TRUE.
      IVEC   = IVEC - 1
C
C     INITIALIZE
C
  180 CONTINUE
      IF (LASCAS) IVEC = IVEC + 1
      FIRSTC = .TRUE.
      FIRSTO = .TRUE.
      IF (NSKIP .GT. 0) GO TO 190
      CALL READ (*235,*235,KLAM,TRL(1),7,0,I)
      ILD = TRL(1)
      IEG = TRL(3)
  190 MT  = LKSCC - 1
      DO 200 J = 1,10
      I   = J + MT
  200 ZZ(I) = KON(J)
C
      IF (INS(3) .EQ. 1) GO TO 210
      CALL PAGE2 (2)
      WRITE  (6,205) UWM,NAME
  205 FORMAT (A25,' 2373, ONLY SORT1-REAL SUPPORTED IN ',2A4)
  210 ZZ(MT+1) = INS(2) + IAPP
      ZZ(MT+4) = ISB
      ZZ(MT+5) = ILD
      ZZ(MT+6) = IEG
      LVEC = LSETD + NGSET - 1
C
C     LOOP ON POINT DATA
C   MT = POINTER TO MATCID GRID ID, MS = POINTER TO CASECC GRID REQUEST.
C
      IDG = -1
      MT  = -1
      MS  = LSETD
  220 MT  = MT + 2
      IF (MT .GT. MSZE) GO TO 240
      IF (ZZ(MT)/10 .EQ. IDG) GO TO 220
      IDG = ZZ(MT)/10
      IF (INS(1) .LT. 0) GO TO 300
C
C     LOCATE POINT IN SET
C
  221 I = ZZ(MS)
  222 IF (MS-LVEC) 223,228,240
  223 IF (IDG-I) 230,300,224
  224 I = ZZ(MS+1)
      IF (I) 225,227,227
  225 IF (IDG+I) 300,300,226
  226 MS = MS+2
      GO TO 221
  227 MS = MS+1
      GO TO 222
C
C     LAST POINT IN SET
C
  228 IF (I.LT.0 .AND. IDG+I.LE.0) GO TO 300
      IF (IDG-I) 230,300,230
C
C     NOT IN SET
C
  230 IF (MT+2 .LT. LKSCC) GO TO 220
      GO TO 240
C
C     END-OF-FILE
C
  235 ISDONE = 1
C
C     NO MORE GRIDS IN THIS SET
C
  240 CONTINUE
      IF (.NOT.FIRSTO) CALL WRITE (KOQM,0,0,1)
      IF (IVEC+1 .GT. NVEC) GO TO 350
      IF (ISDONE .NE.    0) GO TO 350
C
C     CHECK IF COLUMN NEEDS TO BE SKIPPED
C
      IFIL = KSCR(3)
      IF (FIRSTC) CALL FWDREC (*440,KSCR(3))
C
      IF (LASCAS) GO TO 180
      GO TO 100
C
C     PROCESS THE GRID FOR OUTPUT
C
  300 MCB(1) = 10*IDG + INS(2)
      IF (.NOT.FIRSTC) GO TO 310
      IF (LVEC+MSZE/2 .GT. NZZ4) GO TO 420
      INRU = 1
      ILRU = MSZE/2
      FIRSTC = .FALSE.
      CALL UNPACK (*240,KSCR(3),ZZ(LVEC+1))
C
  310 CONTINUE
      L      = 1
      NENT   = 0
      OCB(3) = 0
      OCB(4) = 0
      OCB(5) = 0
      OCB(6) = 0
      OCB(7) = 0
      OCB(8) = 0
      M = MIN0(MT+10,MSZE)
      DO 330 I = MT,M,2
      J = ZZ(I)/10
      IF (J .NE. IDG) GO TO 335
      K = ZZ(I+1) + LVEC
      J = ZZ(I) - J *10 + 2
      IF (J .GT. 2) GO TO 320
C
C     SCALAR
C
      L = 2
      J = 3
C
  320 OCB(J) = ZZ(K)
      IF (ZZ(K) .NE. 0) NENT = NENT + 1
  330 CONTINUE
C
  335 OCB(2) = L
      IF (NENT .EQ. 0) GO TO 220
      IF (.NOT.FIRSTO) GO TO 340
C
C     WRITE OUT CONTROL RECORD (ODD NUMBER)
C
      ANYOUT = .TRUE.
      CALL WRITE (KOQM,ZZ(LKSCC),146,1)
      FIRSTO = .FALSE.
C
C     WRITE AN ENTRY OUT
C
  340 CALL WRITE (KOQM,OCB(1),8,0)
      GO TO 220
C
C     CLOSE FILES
C
  345 CALL CLOSE (KOQM,KRW)
      KOQM = -1
      ANYOUT = .FALSE.
  350 CALL CLOSE (KSCR(3),KRW)
      CALL CLOSE (KSCC,KRW)
      CALL CLOSE (KLAM,KRW)
      IF (ANYOUT) CALL EOF (KOQM)
      CALL CLOSE (KOQM,KRW)
      IF (.NOT.ANYOUT) GO TO 360
      TRL(1) = KOQM
      TRL(2) = NVEC
      TRL(3) = MSZE/2
      TRL(4) = 0
      TRL(5) = 0
      TRL(6) = 1
      TRL(7) = 0
      CALL WRTTRL (TRL)
  360 CONTINUE
C
C     CALCULATE UPDATED QG FILE - SCRATCH 5
C
      IF (KSPC  .EQ. 0) GO TO 405
      IF (NSKIP .LE. 1) GO TO 405
      TRL(1) = KQG
      MCB(1) = KSCR(5)
      CALL CURCAS (*407,NSKIP,TRL,MCB,ZZ,NZZ2)
      KQG = MCB(1)
C
  405 RETURN
C
C     ERROR CONDITIONS
C
C     KQG BAD
C
  407 KSPC = -1
      GO TO 405
C
  410 I = 7
      GO TO 490
  420 I = 8
      IFIL = NZZ4
      GO TO 490
  430 I = 1
      GO TO 490
  440 I = 2
      GO TO 490
  450 I = 3
  490 CALL MESAGE (I,IFIL,NAME)
C
C     MPC OUTPUT FILE NOT CREATED, BUT DATA IS ON SCR3 FOR EQMCKS
C
      CALL PAGE2 (2)
      WRITE  (NOUT,510) UWM,NAME
  510 FORMAT (A25,' 2380, MULTI-POINT CONSTRAINT FORCES NOT OUTPUT IN ',
     1        A4,A2,', SEE QUEUED MESSAGES.')
      GO TO 345
      END

      SUBROUTINE RAND3 (F,S,Q,N)
C
C     COMPUTES  MEAN RESPONSE  Q
C
      INTEGER         CHECK   ,NAME(2)
      REAL            Q(2)    ,F(1)     ,S(1)
      COMMON /CONDAS/ PHI     ,TWOPI    ,RADEG    ,DEGRA    ,
     1                S4PISQ
      DATA    NAME  / 4HRAND  ,4H3      /
C
C     F IS ARRAY OF FREQUENCIES
C     S IS ARRAY OF POWER SPECTRAL DENSITY FUNCTIONS
C     Q IS MEAN RESPONSE
C     N IS NUMBER OF FREQUENCIES
C
      SUM1 = 0.0
      NN   = N - 1
      SUM  = 0.0
      DO 10 I = 1,NN
      DF   = F(I+1) - F(I)
      SUM  = SUM + (S(I)+S(I+1))*DF
      FI   = F(I   )*F(I  )
      FI1  = F(I+1 )*F(I+1)
      FII1 = 2.*F(I)*F(I+1)
      ALP  = (3.*FI+FII1+FI1)/6.
      BTA  = (FI+FII1+3.*FI1)/6.
      SUM1 = SUM1 + (ALP*S(I)+BTA*S(I+1))*DF
   10 CONTINUE
      SUM  = SQRT(SUM*0.5)
      SUM1 = SQRT(SUM1*.5)
      Q(1) = SUM
      Q(2) = 0.0
      Q1   = Q(1)
      IF (Q1 .NE. 0.0) Q(2) = SUM1/Q1
      CHECK= 123456789
      RETURN
C
C     AUTOCORRALATION FUNCTION
C
      ENTRY RAND4 (F,S,TAU,R,N)
C     =========================
C
C     COMPUTES  AUTOCORRALATION FUNCTION R  AT TIME TAU
C     WHERE F,S AS ABOVE. IF TAU = 0.0  R = Q*Q
C
      IF (CHECK .NE. 123456789) CALL MESAGE (-37,0,NAME)
      IF (TAU .EQ. 0.0) GO TO 30
      NN  = N - 1
      A   = 2.0*PHI*TAU
      B   = 1.0/A
      SUM = 0.0
      DO 20 I = 1,NN
      SUM = SUM + B*(S(I+1)-S(I))/(F(I+1)-F(I))*(COS(A*F(I+1))
     1          - COS(A*F(I))) + S(I+1)*SIN(A*F(I+1))-S(I)*SIN(A*F(I))
   20 CONTINUE
      SUM = SUM*B
      R   = SUM
      GO TO 40
   30 R   = Q1*Q1
   40 RETURN
      END

      SUBROUTINE CNSTRC (GP,ELE,BUF,MAX)
C
C     THIS SUBROUTINE BUILDS THE ELSETS FILE
C     THIS SUBROUTINE IS CALLED ONLY BY DPLTST, WHICH IS THE DRIVER OF
C     DMAP MODULE PLTSET
C     THE SUBROUITNE PLTSET OF THE PLOT MODULE HAS NOTHING TO DO WITH
C     THIS SUBROUTINE
C
C     REVISED 10/1990 BY G.CHAN/UNISYS TO INCLUDE OFFSET FOR BAR, TRIA3
C     AND QUAD4 ELEMENTS
C
      INTEGER         AE       ,B1       ,B2       ,B3       ,BUF(1)  ,
     1                BUFSIZ   ,ELE(1)   ,ELID     ,ERR(2)   ,ETYPE   ,
     2                EXGP     ,GP(1)    ,GPT      ,GPTS(32) ,OUTNOR  ,
     3                OUTREW   ,REW      ,SETID    ,SETNUM   ,SIGN    ,
     4                TYPE(50) ,NAME(2)  ,MSG1(14) ,EID(2)   ,OFFSET  ,
     5                BR       ,T3       ,Q4       ,OFF(6)
      COMMON /BLANK / NGP      ,NSETS    ,SKP1(8)  ,SKP2     ,EXGPID  ,
     1                SKP3(8)  ,MERR     ,SKP4     ,GRID     ,ECT2    ,
     2                SKP5(6)  ,MSET     ,ECT1
      COMMON /SYSTEM/ BUFSIZ
      COMMON /NAMES / RD       ,INPREW   ,OUTNOR   ,OUTREW   ,REW     ,
     1                NOREW
      COMMON /GPTA1 / NTYPS    ,LAST     ,INCR     ,NE(1)
      EQUIVALENCE     (EID(1)  ,ELID)
      DATA    NAME  / 4H CNS   ,4HTRC  / ,AE   /    72       /
      DATA    NMSG1 / 14       /
      DATA    MSG1  / 4H(33X   ,4H,44H   ,4HNO P   ,4HLOTA   ,4HBLE   ,
     1                4HSTRU   ,4HCTUR   ,4HAL E   ,4HLEME   ,4HNTS   ,
     2                4HEXIS   ,4HT IN   ,4H SET   ,4H,I8)   /
      DATA    BR, T3, Q4       /2HBR     ,2HT3     ,2HQ4     /
C
      B1 = 1
      B2 = B1 + BUFSIZ
      B3 = B2 + BUFSIZ
      CALL GOPEN (MSET,BUF(B3),INPREW)
      CALL GOPEN (ECT2,BUF(B2),OUTREW)
C
      DO 450 SETNUM = 1,NSETS
      CALL FREAD (MSET,SETID,1,0)
      DO 10 I = 1,NGP
      GP(I) = 0
   10 CONTINUE
C
C     READ THE EXPLICIT ELEMENT NUMBERS IN THIS SET.
C
      CALL FREAD (MSET,NEL,1,0)
      IF (NEL .GE. MAX) CALL MESAGE (-8,0,NAME)
      ELE(NEL+1) = 0
      CALL FREAD (MSET,ELE,NEL,0)
C
C     READ THE ELEMENT TYPES TO BE INCLUDED OR EXCLUDED IN THIS SET.
C
      CALL FREAD (MSET,NTYPES,1,0)
      CALL FREAD (MSET,TYPE,NTYPES,0)
C
C     GENERATE AN ECT FOR THE ELEMENTS INCLUDED IN THIS SET.
C
      CALL GOPEN (ECT1,BUF(B1),INPREW)
   20 CALL READ (*300,*300,ECT1,ETYPE,1,0,I)
C
C     CHECK WHETHER OR NOT THIS ELEMENT TYPE IS TO BE EXCLUDED.
C
      MTYPE = -1
      LABGP =  1
      IF (ETYPE .EQ. AE) LABGP = -2
      IF (NTYPES .EQ. 0) GO TO 50
      DO 30 I = 1,NTYPES,2
      IF (-ETYPE .EQ. TYPE(I)) GO TO 40
   30 CONTINUE
      GO TO 50
   40 MTYPE = TYPE(I+1)
C
C     THIS ELEMENT TYPE MAY BE INCLUDED AS A TYPE AND/OR SOME OF THEM
C     MAY BE INCLUDED SPECIFICALLY. READ -NGPPE- = NUMBER OF GRID
C     POINTS PER ELEMENT FOR THIS TYPE.
C
   50 CALL FREAD (ECT1,NGPPE,1,0)
      IF (NGPPE .LE. 0) GO TO 290
      IDX    = (ETYPE-1)*INCR
      NELTYP = 0
      NE16   = NE(IDX+16)
      OFFSET = 0
      IF (NE16 .EQ. BR) OFFSET = 6
      IF (NE16.EQ.T3 .OR. NE16.EQ.Q4) OFFSET = 1
C
C     CHECK WHETHER OR NOT THIS ELEMENT TYPE IS TO BE INCLUDED.
C
      IF (NTYPES.EQ.0 .OR. MTYPE.GE.0) GO TO 70
      DO 60 I = 1,NTYPES,2
      IF (ETYPE.EQ.TYPE(I) .OR. TYPE(I).EQ.NTYPS+1) GO TO 200
   60 CONTINUE
C
C     NOW CHECK WHETHER OR NOT ANY OF THE ELEMENTS OF THIS TYPE ARE
C     EXPLICITLY INCLUDED. PUT ALL SUCH ON THE NEW ECT (ECT2).
C
   70 CALL READ (*280,*280,ECT1,EID,2,0,I)
      CALL FREAD (ECT1,GPTS,NGPPE,0)
      IF (OFFSET .NE. 0) CALL FREAD (ECT1,OFF,OFFSET,0)
      IF (NEL .LE. 0) GO TO 70
      M = 0
      N = 1
C
C     FOR TYPES DELETED ONLY SEARCH LIST AFTER TYPE WAS KNOWN TO BE
C     DELETED (2ND WORD OF TYPE)
C
      IF (MTYPE .GT. 0) N = MTYPE
      IF (N   .GT. NEL) GO TO 110
   80 CALL INTLST (ELE,N,SIGN,N1,N2)
      IF (SIGN .LT. 0) GO TO 90
      IF (ELID.GE.N1 .AND. ELID.LE.N2) M = 1
      GO TO 100
   90 IF (ELID.GE.N1 .AND. ELID.LE.N2) M = 0
  100 IF (N .LE. NEL) GO TO 80
  110 CONTINUE
      IF (M      .EQ. 0) GO TO 70
      IF (NELTYP .NE. 0) GO TO 120
      CALL WRITE (ECT2,NE(IDX+16),1,0)
      CALL WRITE (ECT2,NGPPE,1,0)
  120 CALL WRITE (ECT2,EID,2,0)
      CALL WRITE (ECT2,GPTS,NGPPE,0)
      IF (OFFSET .NE. 0) CALL WRITE (ECT2,OFF,OFFSET,0)
      NELTYP = NELTYP + 1
      DO 130 I = 1,NGPPE
      J = GPTS(I)
      GP(J) = LABGP
  130 CONTINUE
C
C     AERO ELEMENT - CENTER ONLY LABELED
C
      IF (ETYPE .EQ. AE) GP(J) = 1
      GO TO 70
C
C     THIS ELEMENT TYPE IS TO BE INCLUDED, EXCEPT THE ONES EXPLICITLY
C     EXCLUDED
C
C     ONLY SEARCH LIST AFTER TYPE WAS INCLUDED
C
  200 MTYPE = TYPE(I+1)
  210 CALL READ (*280,*280,ECT1,EID,2,0,I)
      CALL FREAD (ECT1,GPTS,NGPPE,0)
      IF (OFFSET .NE. 0) CALL FREAD (ECT1,OFF,OFFSET,0)
      IF (NEL .LE. 0) GO TO 250
      M = 1
      N = 1
      IF (MTYPE .GT. 0) N = MTYPE
      IF (N   .GT. NEL) GO TO 250
  220 CALL INTLST (ELE,N,SIGN,N1,N2)
      IF (SIGN .GT. 0) GO TO 230
      IF (ELID.GE.N1 .AND. ELID.LE.N2) M = 0
      GO TO 240
  230 IF (ELID.GE.N1 .AND. ELID.LE.N2) M = 1
  240 IF (N    .LE. NEL) GO TO 220
      IF (M    .EQ.   0) GO TO 210
  250 IF (NELTYP .NE. 0) GO TO 260
      CALL WRITE (ECT2,NE(IDX+16),1,0)
      CALL WRITE (ECT2,NGPPE,1,0)
  260 CALL WRITE (ECT2,EID,2,0)
      CALL WRITE (ECT2,GPTS,NGPPE,0)
      IF (OFFSET .NE. 0) CALL WRITE (ECT2,OFF,OFFSET,0)
      DO 270 I = 1,NGPPE
      J = GPTS(I)
      GP(J) = LABGP
  270 CONTINUE
C
C     AERO ELEMENT - CENTER ONLY LABELED
C
      IF (ETYPE .EQ. AE) GP(J) = 1
      NELTYP = NELTYP + 1
      GO TO 210
C
C     END OF NEW ECT FOR THIS ELEMENT TYPE
C
  280 IF (NELTYP .GT. 0) CALL WRITE (ECT2,0,1,0)
      GO TO 20
C
C     SKIP THIS ELEMENT TYPE (NON-EXISTENT)
C
  290 CALL FREAD (ECT1,0,0,1)
      GO TO 20
C
C     END OF ECT FOR THIS ELEMENT SET
C
  300 CALL CLOSE (ECT1,REW)
      CALL WRITE (ECT2,0,0,1)
C
C     FLAG ALL GRID POINTS TO BE EXCLUDED FROM A DEFORMED SHAPE.
C
      CALL FREAD (MSET,NGPTS,1,0)
      IF (NGPTS .GE. MAX) CALL MESAGE (-8,0,NAME)
      ELE(NGPTS+1) = 0
      CALL FREAD (MSET,ELE,NGPTS,1)
      IF (NGPTS .LE. 0) GO TO 400
      CALL GOPEN (EXGPID,BUF(B1),INPREW)
      DO 340 GPT = 1,NGP
      CALL FREAD (EXGPID,EXGP,1,0)
      CALL FREAD (EXGPID,INGP,1,0)
      M = 0
      N = 1
  310 CALL INTLST (ELE,N,SIGN,N1,N2)
      IF (SIGN .GT. 0) GO TO 320
      IF (EXGP.GE.N1 .AND. EXGP.LE.N2) M = INGP
      GO TO 330
  320 IF (EXGP.GE.N1 .AND. EXGP.LE.N2) M = 0
  330 IF (N .LE. NGPTS) GO TO 310
      IF (M .EQ.     0) GO TO 340
      IF (GP(M) .NE. -2) GP(M) = -GP(M)
  340 CONTINUE
      CALL CLOSE (EXGPID,REW)
C
C     GENERATE A GRID POINT LIST FOR THIS SET (CONVERT THE INTERNAL
C     GRID POINT NUMBERS TO POINTERS TO THE GRID POINTS PECULIAR TO
C     THIS SET)
C
  400 CALL GOPEN (GRID,BUF(B1),OUTNOR)
      NGPTS = 0
      DO 410 I = 1,NGP
      IF (GP(I) .EQ. 0) GO TO 410
      NGPTS = NGPTS+1
      GP(I) = ISIGN(NGPTS,GP(I))
  410 CONTINUE
      IF (NGPTS .NE. 0) GO TO 420
      ERR(1) = 1
      ERR(2) = SETID
      CALL WRTPRT (MERR,ERR,MSG1,NMSG1)
C
  420 CALL WRITE (GRID,NGPTS,1,0)
      CALL WRITE (GRID,GP,NGP,0)
      IF (SETNUM .NE. NSETS) CALL CLOSE (GRID,NOREW)
  450 CONTINUE
C
C     ALL DONE. THE SET DEFINITION FILE (MSET) + THE SHORT ECT FILE
C     (ECT1) WILL NOT BE NEEDED AGAIN.
C
      CALL CLSTAB (GRID,REW)
      CALL CLSTAB (ECT2,REW)
      CALL CLOSE  (MSET,REW)
      RETURN
      END

      SUBROUTINE OFP
C
C     THE OUTPUT FILE PROCESSOR
C
C     THIS SUBROUTINE IS THE MAIN AND ONLY DRIVER.
C     OFP1 OUTPUTS HEADINGS ONLY.
C
      IMPLICIT INTEGER (A-Z)
      LOGICAL          AXIC,FLUID,TEMPER,ONEFIL,HEADNG,SOLSET,ELEMEN,
     1                 PNCHED,HEAT,GPFB,ESE,DUMMY,GPST,EOR,PACK,STRAIN
      INTEGER          REAL(10),IMAG(5),ISAVE(20),GSE(4),I15BLK(2),
     1                 FILEX(6),B(23,4),FMT(300),IOUT(100),TSAVE(96),
     2                 SCAN(2),ID(50),BUFF(1),OF(56)
      REAL             FREAL(10),FIMAG(2),OUT(100)
      DOUBLE PRECISION DOUT(50)
CWKBI
      CHARACTER*1      CFMT(300)
      CHARACTER        UFM*23,UWM*25,UIM*29,SFM*25,SWM*27
      COMMON /XMSSG /  UFM,UWM,UIM,SFM,SWM
      COMMON /BLANK /  ICARD,OPTION(2)
      COMMON /SYSTEM/  KSYSTM(65)
      COMMON /OFPCOM/  TEMPER,MPUNCH
      COMMON /OFPBD1/  D(1)
      COMMON /OFPBD5/  ESINGL(64),E(1)
CZZ   COMMON /ZZOFPX/  CORE(1)
      COMMON /ZZZZZZ/  CORE(20000)
      COMMON /OFP1ID/  IDM(2)
      COMMON /OUTPUT/  HEAD(96)
      EQUIVALENCE      (KSYSTM( 1),SYSBUF), (KSYSTM( 2),L     ),
     1                 (KSYSTM( 9),MAXLNS), (KSYSTM(12),LINE  ),
     2                 (KSYSTM(38),AXIF  ), (KSYSTM(56),ITHERM),
     3                 (FREAL (1),REAL(1)), (FIMAG (1),IMAG(1)),
     4                 (ID    (3),IELTYP ), (IOUT(1),OUT(1),DOUT(1)),
     5                 (L1, OF(1),CORE(1)), (L2,OF(2)), (L3,OF(3)),
     6                 (L4, OF(4)), (L5,OF(5)), (ID(1),OF(6)),
     7                 (BUFF(1),OF(56))
CWKBI
      EQUIVALENCE      ( CFMT, FMT )
      DATA    PE    /  4H1P,E /,   PF   / 4H0P,F /
      DATA    E236  /  4H23.6 /,   F236 / 4H14.1 /
      DATA    E156  /  4H15.6 /,   F156 / 4H6.1  /
      DATA    I8    /  4H,I8, /,   I12  / 4H,I11 /
      DATA    I2X   /  4H2X   /,   I2XX / 4H,2X  /
      DATA    I1X   /  4H(1X  /,   I1XX / 4H,1X  /
      DATA    ISTAR /  4H,1H* /,   I15X / 4H/14X /
      DATA    IH0   /  4H/1H0 /,   I1H0 / 4H(1H0 /
      DATA    I9X   /  4H,9X  /,   I6X  / 4H,6X  /
      DATA    F174  /  4H17.4 /
      DATA    STATIC,  REIGEN  ,   FREQ ,  TRANS  , BK1  , CEIGEN  /
     1        1     ,  2       ,   5    ,  6      , 8    , 9       /
      DATA    A4    ,  COMMA   ,   CPAREN, OPAREN  /
     1        4HA4  ,  4H,     ,   4H)   , 4H(     /
      DATA    EEND  /  195    /,   I15BLK/ 4HA4,  , 4H11X /,
     1        GSE   /  4HG     ,   4HS   , 4HE    , 4HM   /
      DATA    FILEX /  101, 102,  103,104, 105    , 106   /
      DATA    IBLANK,  E9PT1  /    4H    , 195    /
      DATA    IHEAT /  4HHEAT /,   CENTER/ 4HTER  /
      DATA    PHASE /  4H1P9E /,   SCAN  / 4HSCAN , 4HNED /
      DATA    HEX1  ,  HEX2, HEX3 /4HHEX1, 4HHEX2 , 4HHEX3/
C
C
C     THE FOLLOWING ARE ZERO POINTERS TO THE DATA-BLOCK AND LINE-SET
C     SELECTION LISTS.  TO THIS THE SUBSET SELECTION POINTER IS ADDED.
C     THE SUBSET SELECTION POINTER IS BASED ON INFORMATION IN THE ID
C     RECORD.
C
C     A MINUS ONE IN THE FOLLOWING ARRAY INDICATES AN UNDEFINED OUTPUT.
C
C            S O R T - I    S O R T - I I
C          *************** ****************        ZERO-BASE
C          REAL    COMPLEX REAL    COMPLEX    POINTERS INTO C-ARY
C     *************************************   *******************
C     DISPLACEMENT VECTOR
      DATA B( 1,1),B( 1,2),B( 1,3),B( 1,4) /    0,   4,   2,   6 /
C
C     LOAD VECTOR
      DATA B( 2,1),B( 2,2),B( 2,3),B( 2,4) /    8,  12,  10,  14 /
C
C     SPCF VECTOR
      DATA B( 3,1),B( 3,2),B( 3,3),B( 3,4) /   16,  20,  18,  22 /
C
C     ELEMENT FORCE   (ZERO POINTERS INTO OVERLAY BLOCK DATA)
      DATA B( 4,1),B( 4,2),B( 4,3),B( 4,4) /    0,   0,   0,   0 /
C
C     ELEMENT STRESS  (ZERO POINTERS FOR OVERLAY BLOCK DATA)
      DATA B( 5,1),B( 5,2),B( 5,3),B( 5,4) /    0,   0,   0,   0 /
C
C     EIGENVALUE SUMMARY
      DATA B( 6,1),B( 6,2),B( 6,3),B( 6,4) /   38,  39,  -1,  -1 /
C
C     EIGENVECTOR
      DATA B( 7,1),B( 7,2),B( 7,3),B( 7,4) /   72,  40,  -1,  -1 /
C
C     GPST
      DATA B( 8,1),B( 8,2),B( 8,3),B( 8,4) /   73,  -1,  -1,  -1 /
C
C     EIGENVALUE ANALYSIS SUMMARY
      DATA B( 9,1),B( 9,2),B( 9,3),B( 9,4) /   64,  68,  -1,  -1 /
C
C     VELOCITY VECTOR
      DATA B(10,1),B(10,2),B(10,3),B(10,4) /   24,  30,  26,  32 /
C
C     ACCELERATION VECTOR
      DATA B(11,1),B(11,2),B(11,3),B(11,4) /   25,  34,  27,  36 /
C
C     NON-LINEAR-FORCE VECTOR
      DATA B(12,1),B(12,2),B(12,3),B(12,4) /   28,  -1,  29,  -1 /
C
C     GRID-POINT-WEIGHT-OUTPUT
      DATA B(13,1),B(13,2),B(13,3),B(13,4) /   -1,  -1,  -1,  -1 /
C
C     EIGENVECTOR (SOLUTION SET FROM VDR)
      DATA B(14,1),B(14,2),B(14,3),B(14,4) /   -1,  60,  -1,  62 /
C
C     DISP-VECTOR (SOLUTION SET FROM VDR)
      DATA B(15,1),B(15,2),B(15,3),B(15,4) /   42,  44,  43,  46 /
C
C     VELO-VECTOR (SOLUTION SET FROM VDR)
      DATA B(16,1),B(16,2),B(16,3),B(16,4) /   48,  50,  49,  52 /
C
C     ACCE-VECTOR (SOLUTION SET FROM VDR)
      DATA B(17,1),B(17,2),B(17,3),B(17,4) /   54,  56,  55,  58 /
C
C     ELEMENT STRAIN ENERGY (FROM GPFDR)
      DATA B(18,1),B(18,2),B(18,3),B(18,4) /   74,  -1,  -1,  -1 /
C
C     GRID POINT FORCE BALANCE (FROM GPFDR)
      DATA B(19,1),B(19,2),B(19,3),B(19,4) /   76,  -1,  -1,  -1 /
C
C     MPCFORCE VECTOR
      DATA B(20,1),B(20,2),B(20,3),B(20,4) /   78,  -1,  -1,  -1 /
C
C     ELEMENT STRAIN/CURVATURE (ZERO POINTER FOR OVERLAY BLOCK DATA)
      DATA B(21,1),B(21,2),B(21,3),B(21,4) /    0,  -1,  -1,  -1 /
C
C     STRESSES IN LAYERED COMPOSITE ELEMENTS (ZERO POINTER)
      DATA B(22,1),B(22,2),B(22,3),B(22,4) /    0,   0,   0,   0 /
C
C     FORCES IN LAYERED COMPOSITE ELEMENTS   (ZERO POINTER)
      DATA B(23,1),B(23,2),B(23,3),B(23,4) /    0,   0,   0,   0 /
C     ************************************   *******************
C
C     SAVE OLD TITLES WHATEVER THEY BE AND RESTORE BEFORE RETURNING
C
      CALL TOTAPE (3,BUFF(1))
      HEAT = .FALSE.
      IF (ITHERM .NE. 0) HEAT = .TRUE.
      OPTION(1) = 0
      IF (HEAT) OPTION(1) = IHEAT
      ONEFIL = .FALSE.
      GO TO 10
C
C
      ENTRY OFPDMP (IFILE1)
C     =====================
C
      ONEFIL = .TRUE.
   10 DO 20 I = 1,96
   20 TSAVE(I) = HEAD(I)
C
      ICORE = KORSZ(BUFF)
      IF (ICORE .GE. SYSBUF) GO TO 40
      WRITE  (6,30) UWM,ICORE,SYSBUF
   30 FORMAT (A25,' 2043, OFP HAS INSUFFICIENT CORE FOR ONE GINO ',
     1       'BUFFER ****    OFP NOT EXECUTED.')
      RETURN
C
   40 LINE  = 0
      IFILE = 0
C
C     LOOP FOR 6 FILES
C
   50 IFILE = IFILE + 1
      IF (ONEFIL .AND. IFILE.GT.1) GO TO 2060
      FILE = FILEX(IFILE)
      IF (ONEFIL) FILE = IFILE1
      CALL OPEN (*2050,FILE,BUFF(1),0)
      FROM = 55
      CALL FWDREC (*2020,FILE)
   60 CALL READ (*2040,*2040,FILE,  ID(1),50,0,FLAG)
      CALL READ (*2040,*2040,FILE,HEAD(1),96,1,FLAG)
      AXIC   = .FALSE.
      TEMPER = .FALSE.
      DUMMY  = .FALSE.
      GPST   = .FALSE.
      SORT   =  1
      PNCHED = .FALSE.
      HEADNG = .FALSE.
      GPFB   = .FALSE.
      ESE    = .FALSE.
      STRAIN = .FALSE.
C
C     COMPUTE I AND J, THE B ARRAY SUBSCRIPTS
C
      J = ID(2)/1000
      I = ID(2) - J*1000
      J = J + 1
      IF (I.NE.4 .AND. I.NE.5 .AND. I.NE.21) GO TO 70
      ICURV = ID(3)/1000
      ID(3) = ID(3) - 1000*ICURV
C
   70 PACK   = .FALSE.
      SOLSET = .FALSE.
      FLUID  = .FALSE.
      IF (AXIF .NE. 0) FLUID = .TRUE.
      ELEMEN = .FALSE.
      IAPP = ID(1)/10
      NADD = 1
      FROM = 75
      IF (J .GT. 4) GO TO 2020
      FROM = 77
      IF (J) 2020,80,80
   80 FROM = 80
      IF (I.LT.1 .OR. I.GT.23) GO TO 2020
      IF (J .GT. 2) SORT = 2
      IF (J.NE.3 .OR. IAPP.NE.STATIC) GO TO 120
      IF (HEAD(74).EQ.SCAN(1) .AND. HEAD(75).EQ.SCAN(2)) GO TO 100
      DO 90 IHD = 65,96
   90 HEAD(IHD) = IBLANK
      GO TO 120
  100 DO 110 IHD = 65,72
      IF (IHD .GE. 68) HEAD(IHD+22) = IBLANK
  110 HEAD(IHD) = IBLANK
  120 GO TO (150,150,150,230,240,270,150,290,300,150,
     1       150,150,340,380,380,380,380,390,400,220,
     2       410,420,420), I
  150 PACK = .TRUE.
      IF (ID(3) .EQ. 1000) AXIC = .TRUE.
      GO TO (200,210,220,160,160,160,280,160,160,310,320,330), I
  160 CALL MESAGE (-61,0,0)
C
C     DISPLACEMENT VECTOR
C
  200 IF (J.EQ.3 .AND. IAPP.EQ.TRANS) NADD = 7
      IF (OPTION(1) .NE. IHEAT) GO TO 500
      IF (I.EQ.1 .AND. (J.EQ.1 .OR. J.EQ.3)) TEMPER =.TRUE.
      GO TO 500
C
C     LOAD VECTOR
C
  210 IF (J.EQ.3 .AND. IAPP.EQ.TRANS) NADD = 7
      GO TO 500
C
C     SPCF VECTOR, MPCF VECTOR
C
  220 IF (J.EQ.3 .AND. IAPP.EQ.TRANS) NADD = 7
CWKBI 11/93 SPR93007
      PACK = .TRUE.
      GO TO 500
C
C     ELEMENT FORCE, ELEMENT STRESS
C
  230 CONTINUE
  240 FROM = 240
      IF (ID(3).LT. 1 .OR.  ID(3).GT.100) GO TO 2020
      IF (ID(3).GT.52 .AND. ID(3).LT. 62) DUMMY = .TRUE.
      ELEMEN = .TRUE.
      IOPT   = 2
      IF (ICURV.GT.0 .AND. J.EQ.1) GO TO 260
      IF (ICURV.GT.0 .AND. (J.EQ.2 .OR. J.EQ.4)) GO TO 250
      NADD = 6*(ID(3)-1) + 1
      IF (J.EQ.2 .OR. J.EQ.4) NADD = NADD*2 - 1
      GO TO 500
  250 FROM = 250
      IF (ICURV .GT. 1) GO TO 2020
      NADD = 0
      IF (ID(3) .EQ.  6) NADD =  1
      IF (ID(3) .EQ. 17) NADD = 13
      IF (ID(3) .EQ. 18) NADD = 25
      IF (ID(3) .EQ. 19) NADD = 37
      GO TO 500
C
C     ELEMENT STRESS IN MATERIAL COORDINATE SYSTEM
C
  260 FROM = 260
      IF (ICURV .GT. 2) GO TO 2020
      NADD = 0
      IF (ID(3) .EQ.  6) NADD =  1
      IF (ID(3) .EQ. 17) NADD =  7
      IF (ID(3) .EQ. 18) NADD = 13
      IF (ID(3) .EQ. 19) NADD = 19
      IF (ICURV .EQ.  2) NADD = 25
      GO TO 500
C
C     EIGENVALUE SUMMARY
C
  270 CONTINUE
      GO TO 500
C
C     EIGENVECTOR
C
  280 CONTINUE
      GO TO 500
C
C     GPST
C
  290 GPST = .TRUE.
      GO TO 500
C
C     EIGENVALUE ANALYSIS SUMMARY
C       ID(3) = 1  DETERMINANT METHOD TABLE
C       ID(3) = 2  INVERSE POWER TABLE
C       ID(3) = 3  DETERMINANT METHOD SWEPT FUNCTION DATA VECTORS
C       ID(3) = 4  UPPER HESSENBERG METHOD TABLE
C
  300 NADD = 6*(ID(3)-1) + 1
      FROM = 300
      IF (ID(3) .GT. 4) GO TO 2020
      GO TO 500
C
C     VELOCITY VECTOR
C
  310 CONTINUE
      GO TO 500
C
C     ACCELERATION VECTOR
C
  320 CONTINUE
      GO TO 500
C
C     NON-LINERAR FORCE VECTOR
C
  330 SOLSET = .TRUE.
      GO TO 500
C
C     GRID-POINT-WEIGHT-OUTPUT
C     (FROM = 345 AND 355 ARE SETUP IN OFPGPW)
C
  340 FROM = 340
      IF (J .GT. 1) GO TO 2020
      CALL OFPGPW (*2020,FILE,DOUT,FROM)
      GO TO 60
C
C     EIGENVECTOR, DISPLACEMENT, VELOCITY, ACCELERATION
C     (VDR OUTPUT ONLY)
C
  380 PACK   = .TRUE.
      SOLSET = .TRUE.
      GO TO 500
C
C     ELEMENT STRAIN ENERGY.
C
  390 ESE  = .TRUE.
      IOPT =  3
      GO TO 500
C
C     GRID POINT FORCE BALANCE.
C
  400 GPFB = .TRUE.
      IOPT =  4
      LASTID = 0
      GO TO 500
C
C     ELEMENT STRAIN/CURVATURE
C
  410 FROM = 410
      IF (ID(3).NE.6 .AND. ID(3).NE.17 .AND. ID(3).NE.18 .AND.
CWKBR NCL93012 3/94     1    ID(3).NE.19) GO TO 2020
     1    ID(3).NE.19 .AND. ID(3).NE.64 .AND. ID(3).NE.83) GO TO 2020
      FROM = 415
      IF (ICURV .GT. 2) GO TO 2020
      STRAIN = .TRUE.
      ELEMEN = .TRUE.
      IOPT = 2
      NADD = 0
      IF (ID(3) .EQ.  6) NADD =  1
      IF (ID(3) .EQ. 17) NADD =  7
      IF (ID(3) .EQ. 18) NADD = 13
      IF (ID(3) .EQ. 19) NADD = 19
CWKBNB NCL93012 3/94
      IF (ID(3) .EQ. 64) NADD = 55
      IF (ID(3) .EQ. 83) NADD = 61
CWKBNE NCL93012 3/94
      IF (ICURV .EQ.  1) NADD = NADD + 24
      IF (ICURV .EQ.  2) NADD = 49
      GO TO 500
C
C     STRESSES AND FORCES IN LAYERED COMPOSITE ELEMENTS
C
  420 CALL OFCOMP (*60,FILE,J,IELTYP,IAPP,HEADNG,PNCHED,I)
      GO TO 60
C
  500 FROM = 500
      IF (B(I,J) .EQ. -1) GO TO 2020
      IF (PACK ) IOPT = 1
      POINT = NADD + B(I,J)*6
C
C     IS THIS MAGNITUDE / PHASE OUTPUT
C
      IF (ID(9).EQ.3 .AND. (IAPP.EQ.FREQ .OR. IAPP.EQ.CEIGEN))
     1    POINT = POINT + 6
C
      IF (STRAIN) GO TO 660
      IF (ELEMEN) GO TO 510
C
C     CALL NON-STRESS AND NON-FORCE OVERLAY.
C
      CALL OFPMIS (IX,L1,L2,L3,L4,L5,POINT)
      FROM = 505
      GO TO 690
C
C     CALL PARTICULAR STRESS OR FORCE OVERLAY CONSIDERING
C     REAL, COMPLEX, SORT1, SORT2.
C
  510 IF (DUMMY) GO TO 580
      IF (ICURV .LE. 0) GO TO 515
      IF (J .EQ. 1) GO TO 650
      IF (J .EQ. 2) GO TO 670
      IF (J .EQ. 4) GO TO 680
  515 ITYPE = J + 4*(5-I)
      GO TO (520,530,540,560,570,610,620,640), ITYPE
C
  520 CALL OFPRS1 (IX,L1,L2,L3,L4,L5,POINT)
      FROM = 525
      GO TO 690
C
  530 CALL OFPCS1 (IX,L1,L2,L3,L4,L5,POINT)
      FROM = 535
      GO TO 690
C
  540 IF (IAPP .NE. STATIC) GO TO 550
      CALL OFRS2S (IX,L1,L2,L3,L4,L5,POINT)
      FROM = 545
      GO TO 690
  550 CALL OFPRS2 (IX,L1,L2,L3,L4,L5,POINT)
      FROM = 555
      GO TO 690
C
  560 CALL OFPCS2 (IX,L1,L2,L3,L4,L5,POINT)
      FROM = 565
      GO TO 690
C
  570 CALL OFPRF1 (IX,L1,L2,L3,L4,L5,POINT)
      FROM = 575
      IF (.NOT.HEAT .OR. ID(3).EQ.82) GO TO 690
      IF (ID(10) .NE. -9) GO TO 600
      L2 = 405
      L4 = 0
      L5 = 406
      ID(10) = 9
      GO TO 700
C
  580 CALL ODUM (1,IX,ITYPE,NMULT,NLINES,ID)
      DUMMY = .FALSE.
      FROM = 580
      GO TO 690
C
C     REAL FORCE SORT 1 (HEAT)
C
  600 L2 = 297
      IF (ID(10) .EQ. 5) L2 = 302
      L4 = 0
      L5 = 298
      IF (ID(10) .EQ. 5) L5 = 300
      GO TO 700
C
  610 CALL OFPCF1 (IX,L1,L2,L3,L4,L5,POINT)
      FROM = 615
      IF (HEAT) GO TO 2020
      GO TO 690
C
  620 IF (IAPP .NE. STATIC) GO TO 630
      CALL OFRF2S (IX,L1,L2,L3,L4,L5,POINT)
      FROM = 625
      GO TO 690
  630 CALL OFPRF2 (IX,L1,L2,L3,L4,L5,POINT)
      FROM = 635
      IF (.NOT.HEAT .OR. ID(3).EQ.82) GO TO 690
C
C     REAL FORCE SORT 2 (HEAT)
C
      L1 = 108
      L2 = 297
      IF (ID(10) .EQ. 5) L2 = 302
      L5 = 299
      IF (ID(10) .EQ. 5) L5 = 301
      GO TO 700
C
  640 CALL OFPCF2 (IX,L1,L2,L3,L4,L5,POINT)
      FROM = 645
      IF (HEAT) GO TO 2020
      GO TO 690
C
  650 CALL OFPSS1 (IX,L1,L2,L3,L4,L5,POINT)
      FROM = 655
      GO TO 690
  660 CALL OFPSN1 (IX,L1,L2,L3,L4,L5,POINT)
      FROM = 665
      GO TO 690
C
  670 CALL OFPCC1 (IX,L1,L2,L3,L4,L5,POINT)
      FROM = 675
      GO TO 690
C
  680 CALL OFPCC2 (IX,L1,L2,L3,L4,L5,POINT)
      FROM = 685
C
  690 IF (IX .EQ. 0) GO TO 2000
C
C     IF THERMAL DISPLACEMENTS IN -HEAT- PROBLEMS, CHANGE HEADING
C     FROM  DISPLACEMENT TO TEMPERATURE
C
  700 IF (TEMPER .AND. L2.EQ.1) L2 = 253
      IF (TEMPER .AND. L3.EQ.1) L3 = 253
C
C     HEAT PROBLEMS REAL-SORT1-VECTORS ONLY
C
      IF (HEAT .AND. PACK .AND. J.EQ.1) L5 = 296
      IF (HEAT .AND. SORT.EQ.2 .AND. .NOT.ELEMEN) L5 = 303
      IF (AXIC) L4 = -1
      IF (AXIC) L5 = 203
      IF (AXIC .AND. IAPP.EQ.TRANS  .AND. J.EQ.3) L5 = 402
      IF (AXIC .AND. IAPP.EQ.STATIC .AND. J.EQ.3) L5 = 403
      IF (AXIC .AND. IAPP.EQ.FREQ   .AND. J.EQ.4) L5 = 404
      IF (J .NE. 1) GO TO 710
      IF (IAPP.EQ.TRANS .AND. I.NE.8) L1 = 106
      IF ((IAPP.EQ.REIGEN .OR. IAPP.EQ.BK1) .AND. I.NE.6 .AND. I.NE.8
     1   .AND. I.NE.9) L1 = 102
      GO TO 720
  710 IF (J .NE. 2) GO TO 720
      IF (IAPP.EQ.CEIGEN .AND. I.NE.6 .AND. I.NE.9) L1 = 110
  720 IDD = 0
      IF (SORT .EQ. 1) GO TO 730
      IDD   = ID(5)
      ITEMP = IDD/10
      DEVICE= IDD - 10*ITEMP
      DEVICE= MOD(DEVICE,8)
      IDD   = ITEMP
      ID(5) = IDD
      IF (HEAT .AND. .NOT.ELEMEN .AND. SORT.EQ.2) L5 = 303
      IF (IAPP .EQ. STATIC) IDD = -1
C
C     SORT2 HARMONIC VECTOR OUTPUT
C
  730 IF (.NOT.PACK .OR. .NOT.FLUID .OR. SORT.EQ.1) GO TO 750
      IF (ID(5) .LT. 500000) GO TO 740
      IF (L1 .EQ. 107) L1 = 229
  740 FLUID = .FALSE.
      IF (ESE  .OR.   GPFB) GO TO 800
  750 IF (PACK .OR. ELEMEN) GO TO 800
      CALL OFP1
      HEADNG = .TRUE.
C
C     OUTPUT THE DATA BLOCK
C
  800 EOR = .FALSE.
      IF (ELEMEN  .AND. ID(3).EQ.35) AXIC = .TRUE.
      IF (ELEMEN  .AND. ID(3).EQ.70) AXIC = .TRUE.
      IF (ELEMEN  .AND. ID(3).EQ.71) AXIC = .TRUE.
      IF (AXIC) SOLSET = .TRUE.
C
C     D(IX) CONTINS TWO VALUES IN A PACKED 4 DIGIT NUMBER.
C     THE RIGHT 2 DIGITS GIVES THE NUMBER OF LINES FORMAT PRODUCES.
C     THE LEFT 2 DIGITS GIVES THE NUMBER OF DATA VECTORS PER LINE.
C     IF  THE LEFT 2 DIGITS ARE 0 OR NULL, 1 VECTOR IS ASSUMED.
C
      IF (HEAT ) GO TO 810
      IF (DUMMY) GO TO 820
      NMULT  = D(IX)/100
      NLINES = D(IX) - NMULT*100
      GO TO 820
  810 NMULT  = 1
      NLINES = 1
  820 IF (NMULT .EQ. 0) NMULT = 1
      NWDS  = ID(10)*NMULT
      NWDSAV= NWDS
      MAXN  = MAXLNS - NLINES
C
      IF (NWDS .EQ. 0) GO TO 60
  900 IF (EOR) GO TO 60
      FROM  = 900
      CALL READ (*2020,*910,FILE,IOUT(1),NWDS,0,FLAG)
      GO TO 920
  910 IF (FLAG .EQ. 0) GO TO 60
      IF (FLAG .EQ. 0) GO TO 60
      NWDS  = FLAG
      NWDSAV= NWDS
      EOR   = .TRUE.
  920 I1    = 0
      IF (AXIC) GO TO 930
      IGSE  = IOUT(2)
      IF (PACK .OR. GPST) IOUT(2) = GSE(IGSE)
      IF (ESE  .OR. GPFB) GO TO 930
      IF (.NOT.PACK .AND. .NOT.ELEMEN) GO TO 1030
  930 IF (SORT .EQ. 2) GO TO 990
      INCR = ID(10)
      I  = 1
      K1 = 1
  940 ITEMP  = IOUT(I)/10
      DEVICE = IOUT(I) - 10*ITEMP
      DEVICE = MOD(DEVICE,8)
      IOUT(I)= ITEMP
      IF (DEVICE .LT. 4) GO TO 950
      CALL OFPPUN (IOUT(I),IOUT(I),INCR,IOPT,IDD,PNCHED)
      DEVICE = DEVICE - 4
  950 IF (DEVICE .GT. 0) GO TO 980
C
C     ELIMINATE VECTOR FROM MULTIPLE VECTOR PER LINE
C
      NWDS = NWDS - INCR
      IF (NWDS .GT. I) GO TO 960
      DEVICE = 1
      IF (NWDS .GT. 0) GO TO 990
      IF (EOR) GO TO 60
      NWDS = NWDSAV
      GO TO 900
  960 K1 = K1 + INCR
      K2 = K1 + INCR - 1
      JJ = I - 1
      DO 970 J = K1,K2
      JJ = JJ + 1
  970 IOUT(JJ) = IOUT(J)
      GO TO 940
  980 I = I + INCR
      IF (I .LE. NWDS) GO TO 940
  990 IF (DEVICE .LT. 4) GO TO 1020
      IF (ELEMEN) GO TO 1000
      CALL OFPPUN (IOUT(1),IOUT(1),NWDS,IOPT,IDD,PNCHED)
      GO TO 1020
C
C     SORT 2 ELEMENT PUNCH
C
 1000 INCR = ID(10)
      DO 1010 JJ = 1,NWDS,INCR
      CALL OFPPUN (IOUT(JJ),IOUT(JJ),INCR,IOPT,IDD,PNCHED)
 1010 CONTINUE
 1020 IF (DEVICE.NE.1 .AND. DEVICE.NE.5) GO TO 900
 1030 IF (.NOT.PACK .OR. AXIC) GO TO 1100
      IF (FLUID .AND. SORT.EQ.1 .AND. IOUT(1).GE.500000) GO TO 1800
 1040 IF (IOUT(2) .NE. GSE(1)) GO TO 1720
C
C     BUILD FORMAT CHECKING DATA FOR SPECIAL CASES.
C
 1100 I = 1
      IF (HEAT .AND. ELEMEN .AND. ID(3).NE.82) GO TO 1400
      IF (DUMMY) GO TO 1640
      FMT(1) = OPAREN
      IFMT = 1
      J = IX + 1
      GO TO 1120
 1110 J = J + 1
      IFMT = IFMT + 1
      FMT(IFMT) = COMMA
C
C     IF K IS NEGATIVE THEN BUILDING BLOCK IS NOT FOR A VARIABLE.
C     IN THIS CASE THEN K IS ACTUAL POINTER TO BE USED IN THE ESINGL ARR
C
 1120 K = D(J)
      IF (K) 1130,1300,1140
 1130 K = -K
      IFMT = IFMT + 1
      FMT(IFMT) = ESINGL(K)
      GO TO 1110
C
C     CHECK FOR  SPECIAL PACKING FORMATS
C
 1140 K = 5*K - 5
      IF (.NOT. AXIC) GO TO 1150
      IF (K.NE.200 .AND. K.NE.275) GO TO 1160
      IF (IOUT(2) .EQ. IBLANK) GO TO 1230
      GO TO 1240
 1150 IF (.NOT.PACK .OR. IOUT(2).EQ.GSE(1)) GO TO 1160
      IF ((I.GE.I1 .AND. I.LE.8) .OR. (I.GE.I2 .AND. I.LE.14))
     1   GO TO 1250
C
C     IF SOLSET AND K=0 OR K=80 OR K=365 OR K=75 USE I15BLK IF INTEGER 1
C
 1160 IF (.NOT. SOLSET) GO TO 1170
      IF (K.NE.0 .AND. K.NE.80 .AND. K.NE.365 .AND. K.NE.75) GO TO 1170
      IF (IOUT(I) .NE. 1) GO TO 1170
      IOUT(I) = IBLANK
      IFMT = IFMT + 2
      FMT(IFMT-1) = I15BLK(1)
      FMT(IFMT  ) = I15BLK(2)
      IF (AXIC) FMT(IFMT) = I2X
      GO TO 1260
C
C     CHECK FOR  0.0 ON AN E-FORMAT
C
 1170 IF (K .LT. EEND) IF (OUT(I)) 1230,1240,1230
      IF (K .EQ.  440) IF (OUT(I)) 1230,1240,1230
C
C     CHECK FOR MID-EDGE OR CENTER STRESS POINTS ON ISOPARAMETRIC
C     SOLID ELEMENTS
C
      IF ((K.NE.390 .AND. K.NE.395) .OR. IOUT(I).NE.0) GO TO 1190
      IF (K .EQ. 395) GO TO 1180
      IOUT(I) = CENTER
      GO TO 1240
 1180 IOUT(I) = IBLANK
      GO TO 1240
C
C     CHECK FOR SPECIAL INTEGER ON E9.1 FORMAT ONLY
C
 1190 IF (K.NE.E9PT1 .OR. IOUT(I).NE.1) GO TO 1200
      IOUT(I) = IBLANK
      GO TO 1240
C
C     CHECK FOR SPECIAL GPST FORMATS
C
 1200 IF (IOUT(I).NE.0 .OR. K.LT.301 .OR. K.GT.325) GO TO 1210
      IOUT(I) = IBLANK
      GO TO 1240
C
C     CHECK FOR HARMONIC NUMBER OR POINT ANGLE
C
 1210 IF (K.NE.355 .AND. K.NE.360 .AND. K.NE.445) GO TO 1220
      IF (IOUT(I).LE.0 .OR. IOUT(I).GE.1000) GO TO 1220
      IOUT(I) = IOUT(I) - 1
      GO TO 1240
C
C     CHECK FOR PHASE ANGLE ON STRESSES WITH TRAPAX AND TRIAAX ELEMENTS
C
C     COMMENTS FROM G.CHAN/UNISYS   1/93
C     FMT AND PHASE ARE LOCAL. I SEE NOBODY SETTING UP FMT() TO PHASE.
C     PHASE IS '1PE9'. IN ANSI FORTRAN STANDARD, A COMMA IS NEEDED
C     BETWEEN P AND E IF PHASE IS REALLY USED IN SETTING UP FMT().
C
 1220 IF (K.NE.430 .OR. ID(9).NE.3 .OR. IAPP.NE.FREQ .OR. FMT(IFMT-4)
     1    .NE.PHASE) GO TO 1230
      GO TO 1240
C
C     NO OTHER SPECIAL CHECKS AT THIS TIME
C
C     *** ADD FORMAT BLOCKS ***
C
C     STANDARD BLOCKS
C
 1230 IFMT = IFMT + 2
      FMT(IFMT-1) = E(K+1)
      FMT(IFMT  ) = E(K+2)
      GO TO 1260
C
C     ALTERNATE BLOCKS
C
 1240 IFMT = IFMT + 3
      FMT(IFMT-2) = E(K+3)
      FMT(IFMT-1) = E(K+4)
      FMT(IFMT  ) = E(K+5)
      GO TO 1260
C
C     SPECIAL BLOCKS FOR PACKED OUTPUT
C
 1250 IFMT = IFMT + 1
      FMT(IFMT) = A4
      GO TO 1260
C
 1260 I = I + 1
      GO TO 1110
C
C     OUTPUT THE LINE OR LINES OF DATA WITH THE NEW FORMAT
C
 1300 FMT(IFMT) = CPAREN
      IF (LINE.GT.MAXN .OR. .NOT.HEADNG) CALL OFP1
      HEADNG = .TRUE.
      NWDS = NWDSAV
C
C     IF GRID-POINT-FORCE-BALANCE ENTRY, BLANK OUT NONEXISTENT (ZERO)
C     ELEMENT ID-S.
C
      IF (.NOT.GPFB) GO TO 1330
      IF (IOUT(2)) 1320,1310,1320
 1310 IOUT(2) = IBLANK
      FMT( 9) = A4
      FMT(10) = I9X
C
C     ALSO, FOR GPFB, SET FORMAT TO SPACE TWO LINES ON NEW POINT-ID.
C
 1320 IF (IOUT(1) .EQ. LASTID) GO TO 1330
      LASTID = IOUT(1)
      FMT(2) = IH0
      LINE   = LINE + 2
 1330 continue
!hgs revixe call to use new ofppnt: gfortran doesn't like variable format
!     ofppnt now calls forwrt to perform write
      CALL OFPPNT (IOUT,NWDS,FMT)
      GO TO 1700
C
C     ELEMENT FORCES IN HEAT PROBLEMS
C
 1400 IF (LINE.GT.MAXN .OR. .NOT.HEADNG) CALL OFP1
      HEADNG = .TRUE.
      IF (SORT .EQ. 2) GO TO 1520
C
C     BRANCH ON SPECIAL HBDY OUTPUT
C
      IF (NWDS    .EQ. 5) GO TO 1460
      IF (IOUT(5) .EQ. 1) GO TO 1440
      IF (IOUT(6) .EQ. 1) GO TO 1420
      IF (IOUT(2).EQ.HEX1 .OR. IOUT(2).EQ.HEX2) GO TO 1480
      IF (IOUT(2) .EQ. HEX3) GO TO 1500
CRPKR THE FOLLOWING LINE HAS BEEN CHANGED
CRPKR WRITE  (L,1410) IOUT(1),(OUT(I),I=2,9)
      WRITE  (L,1410) (IOUT(I),I=1,3), (OUT(I),I=4,9)
 1410 FORMAT (I14,4X,2A4,6(1P,E17.6))
      GO TO 1700
CRPKR THE FOLLOWING LINE HAS BEEN CHANGED
C1420 WRITE  (L,1430) IOUT(1),OUT(2),OUT(3),OUT(4),OUT(5),OUT(7),OUT(8)
 1420 WRITE  (L,1430) IOUT(1),IOUT(2),IOUT(3),OUT(4),OUT(5),
     *                OUT(7),OUT(8)
 1430 FORMAT (I14,4X,2A4,2(1P,E17.6),17X,2(1P,E17.6))
      GO TO 1700
CRPKR THE FOLLOWING LINE HAS BEEN CHANGED
C1440 WRITE  (L,1450) IOUT(1),OUT(2),OUT(3),OUT(4),OUT(7)
 1440 WRITE  (L,1450) IOUT(1),IOUT(2),IOUT(3),OUT(4),OUT(7)
 1450 FORMAT (I14,4X,2A4,1P,E17.6,34X,1P,E17.6)
      GO TO 1700
C
 1460 WRITE  (L,1470) IOUT(1),OUT(2),OUT(3),OUT(4),OUT(5)
 1470 FORMAT (18X,I18,4(1P,E18.6))
      GO TO 1700
C
 1480 WRITE  (L,1490) (IOUT(I),I=1,3),(OUT(I),I=4,9)
 1490 FORMAT (I14,1X,A4,I7,6(1P,E17.6))
      GO TO 1700
 1500 WRITE  (L,1510) (IOUT(I),I=1,3),(OUT(I),I=4,9)
 1510 FORMAT (I14,2X,A4,2X,A4,6(1P,E17.6))
      GO TO 1700
C
C     BRANCH ON SPECIAL HBDY FORCES
C
 1520 IF (NWDS    .EQ. 5) GO TO 1580
      IF (IOUT(5) .EQ. 1) GO TO 1560
      IF (IOUT(6) .EQ. 1) GO TO 1540
      IF (IOUT(2).EQ.HEX1 .OR. IOUT(2).EQ.HEX2) GO TO 1600
      IF (IOUT(2) .EQ. HEX3) GO TO 1620
CRPKR THE FOLLOWING LINE HAS BEEN CHANGED
CRPKR WRITE  (L,1530) (OUT(I),I=1,9)
      WRITE  (L,1530) OUT(1),IOUT(2),IOUT(3),(OUT(I),I=4,9)
 1530 FORMAT (1P,E14.6,4X,2A4,6(1P,E17.6))
      GO TO  1700
CRPKR THE FOLLOWING LINE HAS BEEN CHANGED
C1540 WRITE  (L,1550) (OUT(KK),KK=1,5),OUT(7),OUT(8)
 1540 WRITE  (L,1550) OUT(1),IOUT(2),IOUT(3),OUT(4),OUT(5),
     *                OUT(7),OUT(8)
 1550 FORMAT (1P,E14.6,4X,2A4,2(1P,E17.6),17X,2(1P,E17.6))
      GO TO  1700
CRPKR THE FOLLOWING LINE HAS BEEN CHANGED
C1560 WRITE  (L,1570) (OUT(KK),KK= 1,4),OUT(7)
 1560 WRITE  (L,1570) OUT(1),IOUT(2),IOUT(3),OUT(4),OUT(7)
 1570 FORMAT (1P,E14.6,4X,2A4,1P,E17.6,34X,1P,E17.6)
      GO TO  1700
 1580 WRITE  (L,1590) (OUT(KK),KK=1,5)
 1590 FORMAT (18X,5(1P,E18.6))
      GO TO  1700
CRPKR THE FOLLOWING LINE HAS BEEN CHANGED
C1600 WRITE  (L,1610) OUT(1),OUT(2),IOUT(3),(OUT(I),I=4,9)
 1600 WRITE  (L,1610) OUT(1),IOUT(2),IOUT(3),(OUT(I),I=4,9)
 1610 FORMAT (1P,E14.6,1X,A4,I7,6(1P,E17.6))
      GO TO  1700
CRPKR THE FOLLOWING LINE HAS BEEN CHANGED
C1620 WRITE  (L,1630) (OUT(I),I=1,9)
 1620 WRITE  (L,1630) OUT(1),IOUT(2),IOUT(3),(OUT(I),I=4,9)
 1630 FORMAT (1P,E14.6,2X,A4,2X,A4,6(1P,E17.6))
      GO TO  1700
C
C     DUMMY ELEMENT
C
 1640 IF (LINE.GT.MAXN .OR. .NOT.HEADNG) CALL ODUM (2,L,ITYPE,IAPP,0,ID)
      HEADNG = .TRUE.
      NWDS   = NWDSAV
      CALL ODUM (3,L,ITYPE,IAPP,NWDS,IOUT)
      GO TO 1700
C
 1700 LINE = LINE + NLINES
      IF (EOR ) GO TO 60
      IF (AXIC) GO TO 900
      IF (.NOT.PACK .OR. IOUT(2).EQ.GSE(1) .OR. I1.EQ.9) GO TO 900
C
C     TRANSFER THE SAVED BLOCK
C
      DO 1710 I = 1,NWDS
 1710 IOUT(I) = ISAVE(I)
      IF (.NOT.FLUID) GO TO 1040
      IF (IOUT(1) .GE. 500000) GO TO 1800
      GO TO 1040
C
C     SPECIAL ROUTINE TO PACK SCALAR OR EXTRA POINTS OUTPUT..
C     PACKING IS PERFORMED ONLY WHEN IDS ARE SEQUENTIAL,
C     AND THE TYPE REMAINS THE SAME.
C
 1720 I = 1
      GRDPT = IOUT(1)
      TYPE  = IOUT(2)
 1730 IF (I .EQ. 6) GO TO 1760
 1740 FROM = 1740
      CALL READ (*2020,*1790,FILE,ISAVE(1),NWDS,0,FLAG)
      IGSE = ISAVE(2)
      IF (PACK) ISAVE(2) = GSE(IGSE)
      IF (SORT .EQ. 2) GO TO 1750
      ITEMP  = ISAVE(1)/10
      DEVICE = ISAVE(1) - 10*ITEMP
      DEVICE = MOD(DEVICE,8)
      ISAVE(1) = ITEMP
 1750 IF (DEVICE .GE. 4) CALL OFPPUN (ISAVE(1),ISAVE(1),NWDS,IOPT,IDD,
     1                                PNCHED)
      IF (DEVICE.NE.1 .AND. DEVICE.NE.3 .AND. DEVICE.NE.5 .AND.
     1    DEVICE.NE.7) GO TO 1740
      J = GRDPT + I
      IF (FLUID .AND. ISAVE(1).GE.500000) GO TO 1760
      IF (ISAVE(2).NE.TYPE .OR. ISAVE(1).NE.(GRDPT+I)) GO TO 1760
C
C     PACK THIS VECTOR INTO LINE OF DATA
C     IF COMPLEX TWO LINES OF DATA
C     IMAGINARY PART WILL BE PACKED EVEN IF IT DOES NOT EXIST.
C
      I = I + 1
      IOUT(I+2) = ISAVE(3)
      IOUT(I+8) = ISAVE(9)
      GO TO 1730
C
C     PUT BLANKS IN ANY OPEN SLOTS
C
 1760 J = I + 3
      IF (J .GT. 8) GO TO 1780
      DO 1770 K  = J,8
      IOUT(K  ) = IBLANK
 1770 IOUT(K+6) = IBLANK
C
 1780 I1 = J
      I2 = J + 6
      GO TO 1100
C
 1790 EOR = .TRUE.
      GO TO 1760
C
C     SPECIAL LOGIC FOR SORT-1 VECTOR OUTPUT IN A FLUID PROBLEM FOR
C     HARMONIC POINTS ONLY
C
 1800 OLDHRM = -1
      L5  = 230
      LINE= MAXN + 1
      K   = 0
      EOR = .FALSE.
      GO TO 1820
 1810 FROM = 1810
      CALL READ (*2020,*1840,FILE,IOUT(1),NWDS,0,FLAG)
C
C     PUNCH PROCESSING
C
      ITEMP  = IOUT(1)/10
      DEVICE = IOUT(1) - 10*ITEMP
      IOUT(1)= ITEMP
      IF (DEVICE .LT. 4) GO TO 1820
      DEVICE = MOD(DEVICE,8)
      CALL OFPPUN (IOUT(1), IOUT(1),INCR,IOPT,IDD,PNCHED)
      DEVICE = DEVICE - 4
      IF (DEVICE .LE. 0) GO TO 1810
C
C     DECODE THE HARMONIC
C
 1820 ITEMP = MOD(IOUT(1),500000)
      NHARM = (IOUT(1)-ITEMP)/500000
      IOUT(1) = ITEMP
      IF (OLDHRM .EQ. -1) OLDHRM = NHARM
      IF (NHARM.NE.OLDHRM .OR. K.GE.5) GO TO 1850
      K = K + 1
 1830 REAL(2*K-1) = IOUT(1)
      REAL(2*K  ) = IOUT(3)
      IMAG(  K  ) = IOUT(9)
      GO TO 1810
C
C     OUTPUT THE LINE OF DATA
C
 1840 EOR = .TRUE.
      IF (K .LE. 0) GO TO 60
C
C     BUILD THE FORMAT
C
 1850 FMT(1) = I1X
      IF (NLINES .GT. 1) FMT(1) = I1H0
      FMT(2) = I12
      FMT(3) = I2XX
      IFMT   = 3
C
C     ADD STAR IF THIS IS AN UN-SYMETRIC HARMONIC
C
      IF (MOD(OLDHRM,2) .EQ. 0) GO TO 1860
      FMT(3) = ISTAR
      FMT(4) = I1XX
      IFMT   = 4
C
C     VARIABLES IN MAIN LINE
C
 1860 DO 1890 I = 1,K
      FMT(IFMT+1) = I8
      IF (FREAL(2*I)) 1870,1880,1870
 1870 FMT(IFMT+2) = PE
      FMT(IFMT+3) = E156
      IFMT = IFMT + 3
      GO TO 1890
 1880 FMT(IFMT+2) = PF
      FMT(IFMT+3) = F156
      FMT(IFMT+4) = I9X
      IFMT = IFMT + 4
 1890 CONTINUE
C
C     VARIABLES IN SECOND LINE IF COMPLEX
C
      IF (NLINES .LE. 1) GO TO 1940
      IFMT = IFMT + 1
      FMT(IFMT) = I15X
      DO 1930 I = 1,K
      IFMT = IFMT + 1
      FMT(IFMT) = COMMA
      IF (FIMAG(I)) 1910,1900,1910
 1900 FMT(IFMT+1) = PF
      FMT(IFMT+2) = F236
      FMT(IFMT+3) = I9X
      IFMT = IFMT + 3
      GO TO 1930
 1910 IF (L3 .EQ. 126) GO TO 1920
      FMT(IFMT+1) = PE
      FMT(IFMT+2) = E236
      IFMT = IFMT + 2
      GO TO 1930
 1920 FMT(IFMT+1) = PF
      FMT(IFMT+2) = F174
      FMT(IFMT+3) = I6X
      IFMT = IFMT + 3
 1930 CONTINUE
C
C     COMPLETE FORMAT
C
 1940 FMT(IFMT+1) = CPAREN
      IF (LINE .GT. MAXN) CALL OFP1
      LINE = LINE + NLINES
      K2   = 2*K
      IHARM= (OLDHRM-1)/2
      IF (NLINES .LE. 1) GO TO  1950
CRPKR THE FOLLOWING LINE HAS BEEN REPLACED BY TWO LINES
CRPKR WRITE (L,FMT) IHARM,(FREAL(I),I=1,K2),(FIMAG(I),I=1,K)
      WRITE (L,FMT) IHARM,(REAL(I),FREAL(I+1),I=1,K2,2),
     *                            (FIMAG(I),I=1,K)
      GO TO 1960
CRPKR THE FOLLOWING LINE HAS BEEN REPLACED
C1950 WRITE (L,FMT) IHARM,(FREAL(I),I=1,K2)
 1950 WRITE (L,FMT) IHARM,(REAL(I),FREAL(I+1),I=1,K2,2)
 1960 K = 1
      OLDHRM = NHARM
      IF (.NOT. EOR) GO TO 1830
      GO TO 60
C
C     ERROR CONDITION THIS FILE
C
 2000 WRITE  (L,2010) SWM,IX,POINT,FROM
 2010 FORMAT (A27,', OFP BLOCK DATA ROUTINES UNAVAILABLE FOR THIS ',
     1       'ELEMENT.',11X,'IX,POINT,FROM =,',3I5)
 2020 WRITE  (L,2030) UWM,FROM
 2030 FORMAT (A25,' 3030, OFP UNABLE TO PROCESS DATA BLOCK.  A TABLE ',
     1       'PRINT OF THE DATA BLOCK FOLLOWS.   FROM =',I5,'/OFP')
      CALL CLOSE  (FILE,1)
      CALL TABPRT (FILE)
      GO TO 2050
C
C     CLOSE FILE UP
C
 2040 CALL CLOSE (FILE,1)
 2050 IF (IFILE .EQ. 6) GO TO 2060
      GO TO 50
C
C     RESTORE TITLES TO WHATEVER THEY WERE AT ENTRY TO OFP
C
 2060 DO 2070 I = 1,96
 2070 HEAD(I) = TSAVE(I)
      RETURN
      END

      SUBROUTINE FNDGRD( ISUB , ICOMP , IGRID , IP , IC , N )
C
      INTEGER AAA(2),SCSFIL,BUF3,Z,SCORE,IP(6),IC(6)
      COMMON/CMB001/JUNK(3),SCSFIL
      COMMON/CMB002/JUNK1(2),BUF3,JUNK2(2),SCORE,LCORE
      COMMON/CMBFND/  INAM(2),IERR
      COMMON/ZZZZZZ/Z(1)
      DATA AAA/ 4HFNDG,4HRD   /
      CALL OPEN(*2001,SCSFIL,Z(BUF3),0)
      NFIL = ISUB-1
      CALL SKPFIL( SCSFIL , NFIL )
      NREC = ICOMP - 1
      IF( NREC .EQ. 0 ) GO TO 3
      DO 1 I=1,NREC
      CALL FWDREC(*2002,SCSFIL)
1     CONTINUE
3     CALL READ(*2002,*2,SCSFIL,Z(SCORE),LCORE,1,NWD)
      GO TO 2004
2     CONTINUE
      CALL GRIDIP( IGRID , SCORE , NWD , IP , IC , N , Z , LLOC )
      CALL CLOSE( SCSFIL , 1 )
      RETURN
2001  CALL MESAGE( -1 , SCSFIL , AAA )
2002  CALL MESAGE( -2 , SCSFIL , AAA )
2004  CALL MESAGE( -8 , SCSFIL , AAA )
      RETURN
      END

      SUBROUTINE CIDCK (Z,BUF,NOPEN)
C
C     BULK DATA CARD COORDINATE CHECK
C     THIS ROUTINE IS CALLED ONLY BY IFP, IN LINK1
C
C     WRITTEN BY G.CHAN/UNISYS   9/1989
C
C     LIST OF NASTRAN BULK DATA CARDS THAT REFERENCE COORDINATE CID -
C
C     BULK DATA      CID      NO. OF     GINO         LOCATE
C     CARD           FIELD    WORDS      FILE         INDEX
C     ----------   -------   -------   ---------   ------------
C     AXIF            1          1       AXIC         8815,88
C     BFIELD          1          2       GEOM1        3101,31
C     CEMLOOP*        13        13       GEOM3        3109,31
C     CONM2           3         13       GEOM2        1501,15
C     CORD1C          1          6       GEOM1        1701,17
C     CORD1R          1          6       GEOM1        1801,18
C     CORD1S          1          6       GEOM1        1901,19
C     CORD2C          1,4       13       GEOM1        2001,20
C     CORD2R          1,4       13       GEOM1        2101,21
C     CORD2S          1,4       13       GEOM1        2201,22
C     FORCE           3          7       GEOM3        4201,42
C     GEMLOOP*        3          -       GEOM3        3309,33
C     GRAV            2          6       GEOM3        4401,44
C     GRID/GRDSET     2,6        8       GEOM1        4501,45
C     GRIDB           3          5       GEOM1        8115,81
C     MDIPOLE*        2         10       GEOM3        3509,35
C     MOMENT          3          7       GEOM3        4801,48
C     PIHEX           3          7       EPT          7002,70
C     PLOAD4          9         12       GEOM3        6709,67
C     REMFLUX*        2          -       GEOM3        3409,34
CWKBR 2/95 SPR94015 RFORCE    3     8       GEOM3        5509,55    
C     RFORCE          3          7       GEOM3        5509,55    
C     SPCFLD*         2          -       GEOM3        3209,32
C
C     * THE CID'S ON THESE CARDS CURRENTLY MUST BE ZERO OR BLANK, AND
C       WERE CHECKED ALREADY IN IFS4P. THEREFORE THEY ARE NOT CHECKED
C       HERE.
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL ANDF
      LOGICAL  ABORT
      INTEGER  AXIF(2),   BFIELD(2), CONM2(2),  CORD(2),   FORCE(2),
     1         GRAV(2),   GRID(2),   GRIDB(2),  MOMENT(2), PIHEX(2),
     2         PLOAD4(2), RFORCE(2),
     3         Z(1),      BUF(1),    TRL(7),    NAME(2)
      CHARACTER*7  CC,    PCC,       CAXIF,     CBFIEL,    CCONM2,
     1         CCORD2,    CFORCE,    CGRAV,     CGRID,     CGRIDB,
     2         CMMENT,    CPIHEX,    CPLOD4,    CRFORC
      CHARACTER*23        UFM
      COMMON   /XMSSG /   UFM
      COMMON   /SYSTEM/   IBUF,      NOUT,      ABORT
      COMMON   /TWO   /   TWO(1)
      DATA     GEOM1,     GEOM2,     GEOM3,     EPT        /
     1         201,       208,       209,       202        /,
     2         AXIC,      NAME,      PCD,       PCC        /
     3         215,       4HCIDC,    2HK , 0,   'XXXX   '  /
      DATA     AXIF,      CAXIF  /   8815,88,   'AXIF   '  /
     1         BFIELD,    CBFIEL /   3101,31,   'BFIELD '  /,
     2         CONM2,     CCONM2 /   1501,15,   'CONM2  '  /
     3         CORD,      CCORD2 /   1601,16,   'CORD2  '  /,
     4         FORCE,     CFORCE /   4201,42,   'FORCE  '  /
     5         GRAV,      CGRAV  /   4401,44,   'GRAV   '  /,
     6         GRID,      CGRID  /   4501,45,   'GRID   '  /
     7         GRIDB,     CGRIDB /   8115,81,   'GRIDB  '  /,
     8         MOMENT,    CMMENT /   4801,48,   'MOMENT '  /
     9         PIHEX,     CPIHEX /   7002,70,   'PIHEX  '  /,
     O         PLOAD4,    CPLOD4 /   6709,67,   'PLOAD4 '  /
     1         RFORCE,    CRFORC /   5509,55,   'RFORCE '  /
C
C
C     OPEN GEOM1 AND SAVE ALL COORDINATE IDS IN Z(1) THRU Z(NCORD)
C     AND REFERENCED COORD ID IN Z(NRID) THRU Z(NOPEN). NOPEN IS
C     LENGTH OF THE AVAILABLE OPEN CORE.
C     SORT AND CHECK ID UNIQUENESS
C
      NCORD= 1
      NRID = NOPEN
      FILE = GEOM1
      CALL PRELOC (*960,BUF,GEOM1)
      K = 6
      DO 20 I = 1,6
      CORD(1) = CORD(1)+100
      CORD(2) = CORD(2)+1
      IF (I .EQ. 4) K = 13
      CALL LOCATE (*20,BUF,CORD(1),M)
 10   CALL READ (*910,*20,GEOM1,Z(NCORD),K,0,M)
      NCORD = NCORD+1
      IF (I.LT.4 .OR. Z(NCORD+2).EQ.0) GO TO 10
      Z(NRID) = Z(NCORD+2)
      NRID  = NRID-1
      GO TO 10
 20   CONTINUE
      NCORD = NCORD-1
      NRID  = NRID +1
      IF (NCORD .LE. 1) GO TO 60
      CALL SORT (0,0,1,1,Z(1),NCORD)
      J = 1
      DO 50 I = 2,NCORD
      IF (Z(I) .NE. Z(I-1)) GO TO 40
      CALL PAGE2 (-2)
      WRITE  (NOUT,30) UFM,Z(I)
 30   FORMAT (A23,' 328, DUPLICATE COORDINATE ID',I9)
      GO TO 50
 40   J = J+1
      Z(J) = Z(I)
 50   CONTINUE
      NCORD = J
C
C     IF CORD2C/R/S CARDS ARE PRESENT, CHECK REFERENCE COORDINATE ID
C
 60   IF (NRID .GT. NOPEN) GO TO 100
      CC = CCORD2
      DO 90 I = NRID,NOPEN
      CID = Z(I)
      IF (NCORD .LE. 0) GO TO 80
      DO 70 J = 1,NCORD
      IF (CID .EQ. Z(J)) GO TO 90
 70   CONTINUE
 80   CALL PAGE2 (-2)
      WRITE (NOUT,830) UFM,CID,CC
      ABORT = .TRUE.
 90   CONTINUE
C
C     DOUBLE THE COORDINATE ID ARRAY FOR 'CIRCULAR' SEARCH, AND MOVE
C     THE ARRAY TO HIGH END OF OPEN CORE, Z(II) THRU Z(NOPEN-1)
C
 100  II = NOPEN-2*NCORD-1
      IF (NCORD .EQ. 0) GO TO 120
      DO 110 I = 1,NCORD
      Z(II+I      ) = Z(I)
 110  Z(II+I+NCORD) = Z(I)
 120  NZ = II
      IM = II+NCORD
      II = II+1
      Z(NOPEN) = -999
C
C     CHECK CID ON GRID CARDS
C
      CC = CGRID
      CALL LOCATE (*190,BUF,GRID(1),M)
      NZX = (NZ/8)*8
 130  CALL READ (*910,*140,GEOM1,Z(1),NZX,0,M)
      M = NZX
      IF (M .LE. 0) GO TO 190
 140  PVCID = 0
      ASSIGN 150 TO IRTN
      I = -6
 150  I = I+8
      IF (I .GT. M) GO TO 160
      CID = Z(I)
      IF (CID.NE.0 .AND. CID.NE.PVCID) GO TO 790
      GO TO 150
 160  PVCID = 0
      ASSIGN 170 TO IRTN
      I = -2
 170  I = I+8
      IF (I .GT. M) GO TO 180
      CID = Z(I)
      IF (CID.NE.0 .AND. CID.NE.PVCID) GO TO 790
      GO TO 170
 180  IF (M .EQ. NZX) GO TO 130
C
C     CHECK GRIDB CARDS
C
 190  CC = CGRIDB
      CALL LOCATE (*240,BUF,GRIDB(1),M)
      NZX = (NZ/5)*5
 200  CALL READ (*910,*210,GEOM1,Z(1),NZX,0,M)
      M = NZX
      IF (M .LE. 0) GO TO 240
 210  PVCID = 0
      ASSIGN 220 TO IRTN
      I = -2
 220  I = I+5
      IF (I .GT. M) GO TO 230
      CID = Z(I)
      IF (CID.NE.0 .AND. CID.NE.PVCID) GO TO 790
      GO TO 220
 230  IF (M .EQ. NZX) GO TO 200
C
C     CHECK BFIELD CARDS
C
 240  CC = CBFIEL
      CALL LOCATE (*270,BUF,BFIELD(1),M)
      CALL READ (*910,*250,GEOM1,Z(1),NZ,1,M)
      GO TO 930
 250  PVCID = 0
      ASSIGN 260 TO IRTN
      I = -1
 260  I = I+2
      IF (I .GT. M) GO TO 270
      CID = Z(I)
      IF (CID.NE.0 .AND. CID.NE.PVCID) GO TO 790
      GO TO 260
C
C     END OF GEOM1 PROCESSING
C
 270  CALL CLOSE (GEOM1,1)
C
C
C     CHECK THE PRESENCE OF CONM2 CARDS IN GEOM2
C
      FILE = GEOM2
      K = CONM2(2)
      ASSIGN 300 TO JRTN
      GO TO 860
 300  IF (K .EQ. 0) GO TO 400
C
C     OPEN GEOM2, AND CHECK CONM2 CARDS
C
      CC = CCONM2
      CALL PRELOC (*400,BUF,GEOM2)
      CALL LOCATE (*350,BUF,CONM2(1),M)
      NZX = (NZ/13)*13
 310  CALL READ (*910,*320,GEOM2,Z(1),NZX,0,M)
      M = NZX
      IF (M .LE. 0) GO TO 350
 320  PVCID = 0
      ASSIGN 330 TO IRTN
      I = -10
 330  I = I+13
      IF (I .GT. M) GO TO 340
      CID = Z(I)
      IF (CID.NE.0 .AND. CID.NE.PVCID) GO TO 790
      GO TO 330
 340  IF (M .EQ. NZX) GO TO 310
C
 350  CONTINUE
      CALL CLOSE (GEOM2,1)
C
C
C     CHECK THE PRESENCE OF BULK DATA CARDS IN GEOM3
C     (FORCE, MOMENT, RFORCE, GRAV AND PLOAD4)
C
 400  FILE = GEOM3
      K = FORCE(2)
      ASSIGN 410 TO JRTN
      GO TO 860
 410  IF (K .NE. 0) GO TO 500
      K = MOMENT(2)
      ASSIGN 420 TO JRTN
      GO TO 870
 420  IF (K .NE. 0) GO TO 500
      K = RFORCE(2)
      ASSIGN 430 TO JRTN
      GO TO 870
 430  IF (K .NE. 0) GO TO 500
      K = GRAV(2)
      ASSIGN 440 TO JRTN
      GO TO 870
 440  IF (K .NE. 0) GO TO 500
      K = PLOAD4(2)
      ASSIGN 450 TO JRTN
      GO TO 870
 450  IF (K .NE. 0) GO TO 500
      GO TO 650
C
C     OPEN GEOM3, AND CHECK CID ON BULK DATA CARDS
C
 500  CALL PRELOC (*650,BUF,GEOM3)
      CALL LOCATE (*510,BUF,FORCE(1),M)
      CC = CFORCE
      IB = 3
      IC = 7
      ASSIGN 510 TO KRTN
      GO TO 600
 510  CALL LOCATE (*520,BUF,MOMENT(1),M)
      CC = CMMENT
      IB = 3
      IC = 7
      ASSIGN 520 TO KRTN
      GO TO 600
 520  CALL LOCATE (*530,BUF,RFORCE(1),M)
      CC = CRFORC
      IB = 3
CWKBR 2/95 SPR94015      IC = 8
      IC = 7
      ASSIGN 530 TO KRTN
      GO TO 600
 530  CALL LOCATE (*540,BUF,GRAV(1),M)
      CC = CGRAV
      IB = 2
      IC = 6
      ASSIGN 540 TO KRTN
      GO TO 600
 540  CALL LOCATE (*550,BUF,PLOAD4(1),M)
      CC = CPLOD4
      IB = 9
      IC = 12
      ASSIGN 550 TO KRTN
      GO TO 600
 550  CONTINUE
      GO TO 630
C
 600  CALL READ (*910,*610,GEOM3,Z(1),NZ,1,M)
      GO TO 930
 610  ASSIGN 620 TO IRTN
      I = IB-IC
 620  I = I +IC
      IF (I .GT. M) GO TO KRTN, (510,520,530,540,550)
      CID = Z(I)
      IF (CID .NE. 0) GO TO 800
      GO TO 620
C
 630  CALL CLOSE (GEOM3,1)
C
C
C     CHECK THE PRESENCE OF PIHEX CARD IN EPT. IF PRESENT, OPEN EPT,
C     AND CHECK CID ON PIHEX CARDS
C
 650  FILE = EPT
      K = PIHEX(2)
      ASSIGN 660 TO JRTN
      GO TO 860
 660  IF (K .EQ. 0) GO TO 700
      CALL PRELOC (*700,BUF,EPT)
      CALL LOCATE (*690,BUF,PIHEX(1),M)
      CALL READ (*910,*670,EPT,Z(1),NZ,1,M)
      GO TO 930
 670  CC = CPIHEX
      ASSIGN 680 TO IRTN
      I = -4
 680  I = I+7
      IF (I .GT. M) GO TO 690
      CID = Z(I)
      IF (CID .NE. 0) GO TO 800
      GO TO 680
 690  CALL CLOSE (EPT,1)
C
C
C     CHECK THE PRESENCE OF AXIF CARD IN AXIC. IF PRESENT, OPEN AXIC,
C     AND CHECK CID ON AXIF CARD. ONLY ONE AXIF CARD EXISTS
C
 700  FILE = AXIC
      K = AXIF(2)
      ASSIGN 710 TO JRTN
      GO TO 860
 710  IF (K .EQ. 0) GO TO 750
      CALL PRELOC (*750,BUF,AXIC)
      CALL LOCATE (*730,BUF,AXIF(1),M)
      CALL READ (*910,*720,AXIC,CID,1,1,M)
 720  CC = CAXIF
      ASSIGN 730 TO IRTN
      IF (CID .NE. 0) GO TO 800
 730  CALL CLOSE (AXIC,1)
C
 750  RETURN
C
C
C     INTERNAL ROUTINE TO LOOK FOR CID MATCH
C     CID ARRAY (DOUBLE) IS AT HIGH END OF CORE, Z(II) THRU Z(NOPEN)
C
 790  PVCID = CID
 800  IF (CID .EQ. Z(II)) GO TO 850
      IF (NCORD  .LE.  1) GO TO 820
      IE = II+NCORD-1
      DO 810 J = II,IE
      IF (CID .EQ. Z(J)) GO TO 840
 810  CONTINUE
 820  IF (CC.EQ.PCC .AND. CID.EQ.PCD) GO TO 850
      CALL PAGE2 (-2)
      WRITE  (NOUT,830) UFM,CID,CC
 830  FORMAT (A23,' 328, UNDEFINED COORDINATE',I9,' IS REFERENCED BY A '
     1,       A7,' CARD')
      PCC = CC
      PCD = CID
      ABORT = .TRUE.
      GO TO 850
 840  II = J
      IF (II .GT. IM) II = II-NCORD
 850  GO TO IRTN, (150,170,220,260,330,620,680,730)
C
C
C     INTERNAL ROUTINE TO CHECK THE PRESENCE OF A PARTICULAR BULK DATA
C     CARD
C
 860  TRL(1) = FILE
      CALL RDTRL (TRL(1))
 870  IF (TRL(1) .LT. 0) GO TO 880
      J = (K-1)/16
      L = K-16*J
      IF (ANDF(TRL(J+2),TWO(L+16)) .NE. 0) GO TO 890
 880  K = 0
 890  GO TO JRTN, (300,410,420,430,440,450,660,710)
C
C     ERRORS
C
 910  J = -2
      GO TO 950
 930  J = -8
 950  CALL MESAGE (J,FILE,NAME)
 960  RETURN
      END

      SUBROUTINE MCE1A
C
C     MCE1A PARTITIONS RG INTO RM AND RN
C
      INTEGER USET   ,RG    ,GM    ,SCR1  ,SCR2  ,SCR3  ,RM    ,RN    ,
     1        UM     ,UN    ,UG    ,A     ,A11   ,A21   ,A12   ,A22   ,
     2        RULE   ,USETXX,Z     ,RECT  ,SQUARE
      COMMON /BLANK / USET  ,RG    ,GM    ,SCR1  ,SCR2  ,SCR3  ,RM    ,
     1                RN    ,L     ,U     ,MCB(7)
      COMMON /BITPOS/ UM    ,UO    ,UR    ,USG   ,USB   ,UL    ,UA    ,
     1                UF    ,US    ,UN    ,UG
      COMMON /PARMEG/ A(7)  ,A11(7),A21(7),A12(7),A22(7),N     ,RULE
      COMMON /PATX  / NZ    ,NSUB1 ,NSUB2 ,NSUB3 ,USETXX
      COMMON /ZZZZZZ/ Z(1)
      DATA    RECT  / 2 /   ,SQUARE / 1 / ,I / 1 /
C
C     GENERATE ROW PARTITIONING VECTOR
C
      NZ = KORSZ(Z)
      USETXX = USET
      CALL CALCV (SCR1,UG,UN,UM,Z)
C
C     GENERATE NULL COLUMN PARTITIONING VECTOR
C
      Z(I  ) = 0
      Z(I+2) = NSUB2
      Z(I+7) = 1
      Z(I+8) = 2
      Z(I+9) =-16777215
C
C     INITIALIZE MATRIX CONTROL BLOCKS
C
      N    = NZ
      RULE = 0
      A(1) = RG
      CALL RDTRL (A)
      A11(1) = RN
      A11(2) = NSUB1
      A11(3) = NSUB2
      A11(4) = RECT
      A11(5) = A(5)
      A12(1) = RM
      A12(2) = NSUB2
      A12(3) = NSUB2
      A12(4) = SQUARE
      A12(5) = A(5)
      MCB(1) = SCR1
      CALL RDTRL (MCB)
      A21(1) = 0
      A22(1) = 0
C
C     PARTITION RG INTO RM AND RN
C
      CALL PARTN (MCB,Z,Z)
C
C     WRITE TRAILERS FOR RM AND RN
C
      CALL WRTTRL (A12)
      CALL WRTTRL (A11)
      RETURN
      END

      SUBROUTINE FRBK (V1,V2,V3,VB)
C
C     LAST REVISED BY G.CHAN/UNISYS  11/1991
C     . ELIMINATE UN-NECCESSARY REWIND AND SKIP AFTER FIRST CALL TO THIS
C       ROUTINE (NASTRAN ORIGINAL METHOD)
C     . ADDITION OF A NEW BACKWARD-FORWARD SUBSTITUTION METHOD WHICH IS
C       MORE EFFICIENT, AND IS ALREADY GOOD FOR VECTORIZATION
C
CDB   LOGICAL          DEBUG
      INTEGER          BASE    ,LJJ    ,IBLK(15),BUF(6)
      REAL             V1(1)   ,V2(1)  ,V3(1)   ,VB(1)  ,XL(1) ,XLJJ ,
     1                 ZERO    ,V3J    ,SUM
      COMMON  /OPINV / MCBLT(7),MCBSMA(7)
      COMMON  /SYSTEM/ KSYSTM  ,IO
      COMMON  /FEERXX/ DUMM(18),NZVB
      COMMON  /ZZZZZZ/ IZ(1)
      EQUIVALENCE      (XL(1),IZ(1))
      EQUIVALENCE      (LJJ,XLJJ)      ,(L16,DUMM(6))
      DATA     BUF   / 4HFRBK  ,4H     ,2*4HBEGN ,4HEND  ,4HBGIN /
      DATA     ZERO  / 0.0          /
CDB   DATA     DEBUG , ITER    ,MAX /  .FALSE.   ,0      ,3      /
C
CDB   IF (.NOT.DEBUG) GO TO 20
C     ITER = ITER + 1
C     IF (ITER .GT. MAX) DEBUG = .FALSE.
C     WRITE  (IO,10) NZVB,ITER
C  10 FORMAT ('  .... IN FRBK.  NZVB =',I8,',  ITER =',I3)
C  20 CONTINUE
      NROW = MCBLT(2)
      DO 30 I = 1,NROW
   30 V2(I) = V1(I)
C
C     SELECTION OF ORIGINAL OR NEW FBS METHOD
C
      J = NROW
      IF (MCBLT(7) .LT. 0) GO TO 200
C
C     NASTRAN ORIGIANL METHOD
C
      IBLK( 1) = MCBLT(1)
      IBLK( 9) = 1
      IBLK(10) = 1
C
C     BACKWARD SUBSTITUTION
C
      IF (BUF(3) .EQ. BUF(5)) GO TO 40
      BUF(3) = BUF(4)
      IF (L16 .NE. 0) CALL CONMSG (BUF,3,0)
C
C     REWIND AND SKIP TO COLUMN N
C
      CALL REWIND (MCBLT)
      CALL SKPREC (MCBLT,NROW+1)
      GO TO 50
C
C     ALREADY AT END, NO SKIP NEEDED
C
   40 BUF(3) = BUF(6)
      IF (L16 .NE. 0) CALL CONMSG (BUF,3,0)
C
   50 IBLK(8) = -1
   60 CALL GETSTB (*100,IBLK(1))
      NTMS = IBLK(6)
      JI   = IBLK(5)
      IK   = IBLK(4)
      IF (IK-NTMS+1 .NE. J) GO TO 70
      NTMS = NTMS - 1
      XLJJ = XL(JI-NTMS)
      IF (NTMS .EQ. 0) GO TO 90
   70 SUM  = ZERO
      DO 80 II = 1,NTMS
      SUM  = SUM + XL(JI)*V2(IK)
      JI   = JI - 1
      IK   = IK - 1
   80 CONTINUE
      V2(J)= V2(J) + SUM
   90 CALL ENDGTB (IBLK(1))
      GO TO 60
  100 V2(J)= V2(J)/XLJJ
      IF (J .EQ. 1) GO TO 110
      J    = J - 1
      GO TO 50
  110 CALL FRMLT (MCBSMA(1),V2(1),V3(1),VB(1))
C
C     FORWARD SWEEP DIRECTLY ON V3
C
      DO 160 J = 1,NROW
      IBLK(8) = -1
  120 CALL GETSTR (*160,IBLK(1))
      JI   = IBLK(5)
      NTMS = IBLK(6)
      IK   = IBLK(4)
      IF (IK .NE. J) GO TO 130
      NTMS = NTMS - 1
      V3(J)= V3(J)/XL(JI)
      JI   = JI + 1
      IK   = IK + 1
  130 IF (NTMS .EQ. 0) GO TO 150
      V3J  = V3(J)
      IF (V3J .EQ. ZERO) GO TO 150
      DO 140 II = 1,NTMS
      V3(IK) = V3(IK) + XL(JI)*V3J
      IK   = IK + 1
      JI   = JI + 1
  140 CONTINUE
  150 CALL ENDGET (IBLK(1))
      GO TO 120
  160 CONTINUE
      GO TO 500
C
C     NEW METHOD
C
C     MATRIX MCBLT HAS BEEN RE-WRITTEN TO MCBLTX BY UNPSCR/FEER3. NO
C     STRING OPERATIONS HERE.
C
  200 IF (BUF(3) .EQ. BUF(5)) BUF(3) = BUF(6)
      IF (L16 .NE. 0) CALL CONMSG (BUF,3,0)
      MCBLTX = -MCBLT(7)
      IF (MOD(MCBLT(4),10) .NE. 3) GO TO 440
      NREC = 0
      CALL REWIND (MCBLTX)
      CALL FWDREC (*400,MCBLTX)
C     NWDS = MCBLT(5)
C
C     IZ(1)                                                      GINO
C      / V1   V2    V3           VB (OPEN CORE LENGTH = NZVB)   BUFFERS
C     +-----+-----+-----+-----+-------------------------------+---------
C                          OPEN  CORE
C
C     BACKWARD SUBSTITUTION
C
      LL2  = 0
      BASE = 1
      IFB  = -350
      DO 280 IK = 1,NROW
      IF (BASE .LT. LL2) GO TO 240
      NREC = NREC + 1
CDB   IF (DEBUG) WRITE (IO,210) NREC,IFB
C 210 FORMAT ('  ...READING RECORD',I5,'.   IFB =',I5)
      CALL READ (*400,*220,MCBLTX,VB,NZVB,1,LL)
      CALL MESAGE (-8,0,NAM)
C 220 LL2  = LL/NWDS
  220 LL2  = LL
CDB   LL3  = LL2/30
C     LL4  = LL2 - LL3
C     IF (DEBUG) WRITE (IO,230) LL,NREC,LL2
C 230 FORMAT (1X,I10,' WORDS READ FROM RECORD NO.',I5,'.   LL2 =',I10)
      BASE = 1
  240 XLJJ = VB(BASE)
      II   = LJJ
      XLJJ = VB(BASE+1)
      JJ   = LJJ
CDB   IF (DEBUG .AND. (BASE.LT.LL3 .OR. BASE.GT.LL4))
C    1    WRITE (IO,250) J,BASE,II,JJ,IFB
C 250 FORMAT (11X,'J,BASE,II,JJ,IFB =',5I8)
      IF (II .NE. J) GO TO 420
      NTMS = JJ - II + 1
      IB   = BASE + 3
      IE   = BASE + 1 + NTMS
      BASE = IE + 1
      IF (NTMS .LE. 1) GO TO 270
      SUM  = ZERO
      DO 260 I = IB,IE
      II   = II + 1
  260 SUM  = SUM + VB(I)*V2(II)
      V2(J)= V2(J) + SUM
  270 V2(J)= V2(J)/VB(IB-1)
  280 J    = J - 1
      CALL FRMLT (MCBSMA(1),V2(1),V3(1),VB(1))
C
C     FORWARD SWEEP DIRECTLY ON V3
C
      IF (NROW .EQ. 1) GO TO 500
      NREC = 0
      LL2  = 0
      BASE = 1
      IFB  = +390
      DO 320 J = 1,NROW
      IF (BASE .LT. LL2) GO TO 300
      NREC = NREC + 1
CDB   IF (DEBUG) WRITE (IO,210) NREC,IFB
      CALL READ (*400,*290,MCBLTX,VB,NZVB,1,LL)
      CALL MESAGE (-8,0,NAM)
C 290 LL2  = LL/NWDS
  290 LL2  = LL
CDB   LL3  = LL2/30
C     LL4  = LL2 - LL3
C     IF (DEBUG) WRITE (IO,230) LL,NREC,LL2
      BASE = 1
  300 XLJJ = VB(BASE)
      II   = LJJ
      XLJJ = VB(BASE+1)
      JJ   = LJJ
CDB   IF (DEBUG .AND. (BASE.LT.LL3 .OR. BASE.GT.LL4))
C    1    WRITE (IO,250) J,BASE,II,JJ,IFB
      IF (II .NE. J) GO TO 420
      NTMS = JJ - II + 1
      V3(J)= V3(J)/VB(BASE+2)
      IF (NTMS .LE. 1) GO TO 320
      V3J  = V3(J)
      IF (V3J .EQ. ZERO) GO TO 320
      IB   = BASE + 3
      IE   = BASE + 1 + NTMS
      DO 310 I = IB,IE
      II   = II + 1
  310 V3(II) = V3(II) + VB(I)*V3J
  320 BASE = BASE + NTMS + 2
      GO TO 500
C
  400 I = MCBLT(4)/10
      WRITE  (IO,410) NREC,J,I,IFB
  410 FORMAT ('0*** TRY TO READ RECORD',I5,'.  J,MCBLT(4),IFB =',I7,2I5)
      CALL MESAGE (-3,MCBLTX,BUF(1))
  420 WRITE  (IO,430) J,II,IFB
  430 FORMAT ('0*** ROW MISMATCH.  J,II,(IFB =',I7,I12,3H  (,I4)
      GO TO 460
  440 J = MOD(MCBLT(4),10)
      WRITE  (IO,450) J
  450 FORMAT ('0*** MCBLT MATRIX IN WRONG FORM.  UNPSCR FLAG =',I3)
      GO TO 460
  460 CALL MESAGE (-37,0,BUF(1))
C
  500 BUF(3) = BUF(5)
      IF (L16 .NE. 0) CALL CONMSG (BUF,3,0)
      RETURN
      END

      SUBROUTINE MTRBSC
C
COMMENT.  ALL WRITE STATEMENTS WHICH HAVE BEEN COMMENTED OUT, HAVE BEEN
C         LEFT IN THE PROGRAMMING FOR ANY FUTURE DEBUGGING USE.
C
C
C      ************* BASIC BENDING TRIANGLE   ELEMENT ROUTINE **********
C
C     CALLS FROM THIS ROUTINE ARE MADE TO. . .
C
C          MAT    - MATERIAL DATA ROUTINE
C          SMA2B  - INSERTION ROUTINE
C          TRANSD - DOUBLE PRECISION TRANSFORMATION SUPPLIER
C          INVERD - DOUBLE PRECISION INVERSE ROUTINE
C          GMMATD - DOUBLE PRECISION MATRIX MULTIPLY AND TRANSPOSE
C          MESAGE - ERROR MESSAGE WRITER
C
C
C     ******************************************************************
C
      DOUBLE PRECISION        A        ,E        ,XSUBB    ,TEMP
     1                       ,XSUBC    ,D        ,YSUBC    ,XCYC
     2                       ,XCSQ     ,DETERM   ,YCSQ     ,XBSQ
     3                       ,G2X2     ,J2X2     ,HYQ      ,AIJ
     4                       ,BIJ      ,SIIJ     ,SIZERO   ,MBARAA
     5                       ,MAR      ,MRR      ,S
     6                       ,PROD9    ,TEMP9    ,G
     7                       ,YPRODJ   ,XPRODI
     8                       ,FJ       ,FJ2      ,FI       ,FIJ
C
C
      DIMENSION D(9)      ,G(9)      ,G2X2(4)   ,J2X2(4)   , S(18)
     1         ,ECPT(1)   ,HYQ(6)    ,SIIJ(7,7) ,MBARAA(9) , MAR(18)
     2         ,MRR(36)
C     DIMENSION MNAME(9)
C     DIMENSION NASTER(130)
C     DATA (MNAME(I), I = 1,9) /6H1(MAA),6H (MAB),6H (MAC),6H (MBA),
C    $6H (MBB),6H (MBC),6H (MCA),6H (MCB),6H (MCC) /
C     DATA NASTER /130*1H*/
C
      COMMON /SMA2IO/ DUM1(10), IFMGG, DUM2(25)
      COMMON /SMA2CL/  DUM3(2), NPVT
     2,                  DUMCL(7)
     3,                  LINK(10)           ,NOGO
      COMMON /MATIN / MATID,INFLAG,ELTEMP,STRESS,SINTH,COSTH
      COMMON /MATOUT/G11,G12,G13,G22,G23,G33,RHO,ALPHA1,ALPHA2,ALP12,
     1                T SUB 0, G SUB E, SIGTEN, SIGCOM, SIGSHE,
     2                G2X211, G2X212, G2X222, SPACE(2)
C
C     ECPT BLOCK
      COMMON /SMA2ET/
     1                   NECPT(1)      ,NGRID(3)
     2                  ,ANGLE         ,MATID1
     3                  ,EYE           ,MATID2
     4                  ,T2            ,FMU
     5                  ,Z11           ,Z22
     6                  ,DUMMY1        ,X1
     7                  ,Y1            ,Z1
     8                  ,DUMMY2        ,X2
     9                  ,Y2            ,Z2
     1                  ,DUMMY3        ,X3
     2                  ,Y3            ,Z3            ,DUMB(76)
C
      COMMON /SMA2DP/    A(225)        ,PROD9(9)
     1                  ,TEMP9(9)      ,XSUBB
     2                  ,XSUBC         ,YSUBC
     3                  ,E(9)          ,TEMP
     4                  ,XCSQ          ,XBSQ
     5                  ,YCSQ          ,XCYC
     6                  ,AIJ           ,DETERM
     7                  ,BIJ           ,SIZERO
     8                  ,FJ            ,FJ2
     9                  ,FI            ,FIJ
     T                  ,YPRODJ        ,XPRODI
     1
     2                  ,ISING         ,DUMMY(59)
C
      EQUIVALENCE
     1          (D(1),G(1),SIIJ(1,1),A(1))  ,(ECPT(1),NECPT(1))
     2         ,(G2X2(1),A(10))             ,(J2X2(1),A(14))
     3         ,(HYQ(1),A(50))              ,(MBARAA(1),A(136))
     4         ,(MAR(1),A(145))             ,(MRR(1),A(163))
     5         ,(S(1),A(82))
C
C     ECPT LIST FOR BASIC BENDING TRIANGLE             NAME IN
C                                                      THIS
C     ECPT                                             ROUTINE   TYPE
C     ******************************************************************
C     ECPT( 1) = ELEMENT ID                            NECPT(1)  INTEGER
C     ECPT( 2) = GRID POINT A                          NGRID(1)  INTEGER
C     ECPT( 3) = GRID POINT B                          NGRID(2)  INTEGER
C     ECPT( 4) = GRID POINT C                          NGRID(3)  INTEGER
C     ECPT( 5) = THETA = ANGLE OF MATERIAL             ANGLE     REAL
C     ECPT( 6) = MATERIAL ID 1                         MATID1    INTEGER
C     ECPT( 7) = I = MOMENT OF INERTIA                 EYE       REAL
C     ECPT( 8) = MATERIAL ID 2                         MATID2    INTEGER
C     ECPT( 9) = T2                                    T2        REAL
C     ECPT(10) = NON-STRUCTURAL-MASS                   FMU       REAL
C     ECPT(11) = Z1                                    Z11       REAL
C     ECPT(12) = Z2                                    Z22       REAL
C     ECPT(13) = COORD. SYSTEM ID 1                    NECPT(13) INTEGER
C     ECPT(14) = X1                                    X1        REAL
C     ECPT(15) = Y1                                    Y1        REAL
C     ECPT(16) = Z1                                    Z1        REAL
C     ECPT(17) = COORD. SYSTEM ID 2                    NECPT(17) INTEGER
C     ECPT(18) = X2                                    X2        REAL
C     ECPT(19) = Y2                                    Y2        REAL
C     ECPT(20) = Z2                                    Z2        REAL
C     ECPT(21) = COORD. SYSTEM ID 3                    NECPT(21) INTEGER
C     ECPT(22) = X3                                    X3        REAL
C     ECPT(23) = Y3                                    Y3        REAL
C     ECPT(24) = Z3                                    Z3        REAL
C     ECPT(25) = ELEMENT TEMPERATURE                   ELTEMP    REAL
C     ******************************************************************
C
C     SETTING UP G MATRIX
C
      INFLAG = 2
      MATID = MATID1
      CALL MAT( ECPT(1) )
C
C     FILL G-MATRIX WITH OUTPUT FROM MAT ROUTINE
C
      G(1) = G11
      G(2) = G12
      G(3) = G13
      G(4) = G12
      G(5) = G22
      G(6) = G23
      G(7) = G13
      G(8) = G23
      G(9) = G33
C
C     COMPUTATION OF D = I.G-MATRIX (EYE IS INPUT FROM THE ECPT)
C
      DO 50 I = 1,9
   50 D(I) = G(I) * DBLE(EYE)
C
C     F1LL  (HBAR) MATRIX STORING AT A(100). . .A(135)
      XCSQ = XSUBC ** 2
      YCSQ = YSUBC ** 2
      XBSQ = XSUBB ** 2
      XCYC = XSUBC * YSUBC
C
      DO 80 I = 100,135
   80 A(I) = 0.0D0
C
      A(100) = XBSQ
      A(103) = XBSQ * XSUBB
      A(107) = XSUBB
      A(112) = -2.0D0 * XSUBB
      A(115) = -3.0D0 * XBSQ
      A(118) = XCSQ
      A(119) = XCYC
      A(120) = YCSQ
      A(121) = XCSQ * XSUBC
      A(122) = YCSQ * XSUBC
      A(123) = YCSQ * YSUBC
      A(125) = XSUBC
      A(126) = YSUBC * 2.0D0
      A(128) = XCYC  * 2.0D0
      A(129) = YCSQ  * 3.0D0
      A(130) =-2.0D0 * XSUBC
      A(131) =-YSUBC
      A(133) =-3.0D0 * XCSQ
      A(134) =-YCSQ
C
C
C     ******************************************************************
C
      IF( T2 .EQ. 0.0E0 ) GO TO 110
C
C     ALL OF THE FOLLOWING OPERATIONS THROUGH STATEMENT LABEL 110
C     ARE NECESSARY IF T2 IS NON-ZERO.
C
C
C     GET THE G2X2 MATRIX
C
      MATID = MATID2
      INFLAG = 3
      CALL MAT( ECPT(1) )
      IF(G2X211.EQ.0.0E0 .AND. G2X212.EQ.0.0E0 .AND. G2X222.EQ.0.0E0)
     1  GO TO 110
      G2X2(1) = G2X211 * T2
      G2X2(2) = G2X212 * T2
      G2X2(3) = G2X2(2)
      G2X2(4) = G2X222 * T2
C
      DETERM = G2X2(1) * G2X2(4)  -  G2X2(3) * G2X2(2)
      J2X2(1) = G2X2(4) / DETERM
      J2X2(2) =-G2X2(2) / DETERM
      J2X2(3) = J2X2(2)
      J2X2(4) = G2X2(1) / DETERM
C
C
C     (H  ) IS PARTITIONED INTO A LEFT AND RIGHT PORTION AND ONLY THE
C       YQ  RIGHT PORTION IS COMPUTED AND USED AS A  (2X3). THE LEFT
C           2X3 PORTION IS NULL.  THE RIGHT PORTION WILL BE STORED AT
C           A(50)...A(55) UNTIL NOT NEEDED ANY FURTHER.
C
C
C
      TEMP  = 2.0D0 * D(2) + 4.0D0 * D(9)
      HYQ(1) = -6.0D0 * (J2X2(1) * D(1) + J2X2(2) * D(3))
      HYQ(2) = -J2X2(1) * TEMP - 6.0D0 * J2X2(2) * D(6)
      HYQ(3) = -6.0D0 * (J2X2(1) * D(6) + J2X2(2) * D(5))
      HYQ(4) = -6.0D0 * (J2X2(2) * D(1) + J2X2(4) * D(3))
      HYQ(5) = -J2X2(2) * TEMP - 6.0D0 * J2X2(4) * D(6)
      HYQ(6) = -6.0D0 * (J2X2(2) * D(6) + J2X2(4) * D(5))
C
C     ADD TO 6 OF THE (HBAR) ELEMENTS THE RESULT OF (H  )(H  )
C                                                    UY   YQ
C     THE PRODUCT IS FORMED DIRECTLY IN THE ADDITION PROCESS BELOW.
C     NO (H  ) MATRIX IS ACTUALLY COMPUTED DIRECTLY.
C          UY
C
C     THE FOLLOWING IS THEN STEP 6 PAGE 8, FMMS-66
C
      DO 100 I = 1,3
      A(I + 102) = A(I + 102) + XSUBB * HYQ(I)
  100 A(I + 120) = A(I + 120) + XSUBC * HYQ(I)    + YSUBC * HYQ(I + 3)
C
C     THIS ENDS ADDED COMPUTATION FOR CASE OF T2 NOT ZERO
C
C     ******************************************************************
C
  110 CONTINUE
C
C     AT THIS POINT INVERT  (H) WHICH IS STORED AT A(100). . .A(135)
C     STORE INVERSE BACK IN A(100). . A(135)
C     NO NEED TO COMPUTE DETERMINANT SINCE IT IS NOT USED SUBSEQUENTLY.
      ISING = -1
      CALL INVERD(6,A(100),6,A(136),0,DETERM,ISING,A(142))
C
C     CHECK TO SEE IF H WAS SINGULAR
      IF( ISING .NE. 2 ) GO TO 120
C
C
C     ISING = 2 IMPLIES SINGULAR MATRIX THUS ERROR CONDITION.
      CALL MESAGE(30,33,ECPT(1))
C
C  SET FLAG FOR FATAL ERROR WHILE ALLOWING ERROR MESSAGES TO ACCUMULATE
C
      NOGO=1
      RETURN
C
C
CHURN OUT INTEGRAL VALUES I   USED IN REFERENCED M MATRICES
C                          IJ                           SEE P.9, FMMS-66
C
C     THE CALCULATION FOR  (I  ) ARE AS FOLLOWS
C                            IJ
C                                                      ***
C         A1  = XSUBB * YSUBC**(J+1) / ((J+1)*(J+2))      *
C           0J                                            *
C                                                         *
C         B   = XSUBC * YSUBC**(J+1) / (J+2)              *
C           0J                                            ** J=0,6
C                                                         *
C         A   = A1   + B                                  *
C           0J    0J    0J                                *
C                                                         *
C         I   = MU * A1                                   *
C           0J         0J                              ***
C
C                                                            ***
C         A1  = I * XSUBB * A      /(I+J+2)                     *
C           IJ               I-1,J                              *
C                                                               *
C         B   = XSUBC**(I+1) * YSUBC**(J+1) /((I+1)*(I+J+2))    *  I=1,6
C           IJ                                                  ** J=0,6
C                                                               *
C         A   = A1   + B                                        *
C           IJ    IJ    IJ                                      *
C                                                               *
C         I     MU * A1                                         *
C           IJ=        IJ                                       *
C                                                            ***
C      NOTE.. LOOPS FOR PROGRAM BEGIN AT 1 INSTEAD OF 0
C                                      I.E.  I = 1,7
C                                            J = 1,7
C
  120 DO 140 J=1,7
      YPRODJ = YSUBC **J
      FJ  = J
      FJ2 = J+1
      AIJ       = XSUBB * YPRODJ /(FJ * FJ2)
      BIJ       = XSUBC * YPRODJ / FJ2
      SIIJ(1,J) = FMU   * AIJ
      AIJ       = AIJ   + BIJ
      IF(J .EQ. 7) GO TO 140
      K = 8 - J
      DO 130 I = 2,K
          XPRODI = XSUBC **I
          FI     = I
          FIJ    = I + J
          AIJ       = (FI-1.0D0) * XSUBB * AIJ / FIJ
          BIJ       = XPRODI * YPRODJ /(FI * FIJ)
          SIIJ(I,J) = FMU * AIJ
  130     AIJ       = AIJ + BIJ
C
  140 CONTINUE
      SIZERO = SIIJ(1,1) / 3.0D0
C
CHUNK IN NUMBERS FOR (M-BAR-AA)    3X3 MATRIX AS PER MS-48, PAGES 6-10
C
C                    (M  )         3X6 MATRIX
C                      AR
C
C                    (M  )         6X6 MATRIX
C                      RR
C
C     (M-BAR-AA) MATRIX
C
      MBARAA(1) =  SIIJ(1,1)
      MBARAA(2) =  SIIJ(1,2)
      MBARAA(3) = -SIIJ(2,1)
      MBARAA(4) =  SIIJ(1,2)
      MBARAA(5) =  SIIJ(1,3)
      MBARAA(6) = -SIIJ(2,2)
      MBARAA(7) = -SIIJ(2,1)
      MBARAA(8) = -SIIJ(2,2)
      MBARAA(9) =  SIIJ(3,1)
C
C     (M  ) MATRIX
C       AR
      MAR( 1) = SIIJ(3,1)
      MAR( 2) = SIIJ(2,2)
      MAR( 3) = SIIJ(1,3)
      MAR( 4) = SIIJ(4,1)
      MAR( 5) = SIIJ(2,3)
      MAR( 6) = SIIJ(1,4)
      MAR( 7) = SIIJ(3,2)
      MAR( 8) = SIIJ(2,3)
      MAR( 9) = SIIJ(1,4)
      MAR(10) = SIIJ(4,2)
      MAR(11) = SIIJ(2,4)
      MAR(12) = SIIJ(1,5)
      MAR(13) =-SIIJ(4,1)
      MAR(14) =-SIIJ(3,2)
      MAR(15) =-SIIJ(2,3)
      MAR(16) =-SIIJ(5,1)
      MAR(17) =-SIIJ(3,3)
      MAR(18) =-SIIJ(2,4)
C
C     (M  ) MATRIX  A 6X6 SYMMETRIC MATRIX
C       RR
      MRR( 1) = SIIJ(5,1)
      MRR( 2) = SIIJ(4,2)
      MRR( 3) = SIIJ(3,3)
      MRR( 4) = SIIJ(6,1)
      MRR( 5) = SIIJ(4,3)
      MRR( 6) = SIIJ(3,4)
      MRR( 7) = MRR(2)
      MRR( 8) = SIIJ(3,3)
      MRR( 9) = SIIJ(2,4)
      MRR(10) = SIIJ(5,2)
      MRR(11) = SIIJ(3,4)
      MRR(12) = SIIJ(2,5)
      MRR(13) = MRR(3)
      MRR(14) = MRR(9)
      MRR(15) = SIIJ(1,5)
      MRR(16) = SIIJ(4,3)
      MRR(17) = SIIJ(2,5)
      MRR(18) = SIIJ(1,6)
      MRR(19) = MRR( 4)
      MRR(20) = MRR(10)
      MRR(21) = MRR(16)
      MRR(22) = SIIJ(7,1)
      MRR(23) = SIIJ(5,3)
      MRR(24) = SIIJ(4,4)
      MRR(25) = MRR( 5)
      MRR(26) = MRR(11)
      MRR(27) = MRR(17)
      MRR(28) = MRR(23)
      MRR(29) = SIIJ(3,5)
      MRR(30) = SIIJ(2,6)
      MRR(31) = MRR( 6)
      MRR(32) = MRR(12)
      MRR(33) = MRR(18)
      MRR(34) = MRR(24)
      MRR(35) = MRR(30)
      MRR(36) = SIIJ(1,7)
C
      IF(T2 .EQ. 0.0) GO TO 146
      IF(G2X211.EQ.0.0E0 .AND. G2X212.EQ.0.0E0 .AND. G2X222.EQ.0.0E0)
     1   GO TO 146
C
      MAR( 4) = MAR( 4)   + HYQ(1) * SIIJ(2,1) + HYQ(4) * SIIJ(1,2)
      MAR( 5) = MAR( 5)   + HYQ(2) * SIIJ(2,1) + HYQ(5) * SIIJ(1,2)
      MAR( 6) = MAR( 6)   + HYQ(3) * SIIJ(2,1) + HYQ(6) * SIIJ(1,2)
      MAR(10) = MAR(10)   + HYQ(1) * SIIJ(2,2) + HYQ(4) * SIIJ(1,3)
      MAR(11) = MAR(11)   + HYQ(2) * SIIJ(2,2) + HYQ(5) * SIIJ(1,3)
      MAR(12) = MAR(12)   + HYQ(3) * SIIJ(2,2) + HYQ(6) * SIIJ(1,3)
      MAR(16) = MAR(16)   - HYQ(1) * SIIJ(3,1) - HYQ(4) * SIIJ(2,2)
      MAR(17) = MAR(17)   - HYQ(2) * SIIJ(3,1) - HYQ(5) * SIIJ(2,2)
      MAR(18) = MAR(18)   - HYQ(3) * SIIJ(3,1) - HYQ(6) * SIIJ(2,2)
      MRR( 4) = MRR( 4)   + HYQ(1) * SIIJ(4,1) + HYQ(4) * SIIJ(3,2)
      MRR( 5) = MRR( 5)   + HYQ(2) * SIIJ(4,1) + HYQ(5) * SIIJ(3,2)
      MRR( 6) = MRR( 6)   + HYQ(3) * SIIJ(4,1) + HYQ(6) * SIIJ(3,2)
      MRR(10) = MRR(10)   + HYQ(1) * SIIJ(3,2) + HYQ(4) * SIIJ(2,3)
      MRR(11) = MRR(11)   + HYQ(2) * SIIJ(3,2) + HYQ(5) * SIIJ(2,3)
      MRR(12) = MRR(12)   + HYQ(3) * SIIJ(3,2) + HYQ(6) * SIIJ(2,3)
      MRR(16) = MRR(16)   + HYQ(1) * SIIJ(2,3) + HYQ(4) * SIIJ(1,4)
      MRR(17) = MRR(17)   + HYQ(2) * SIIJ(2,3) + HYQ(5) * SIIJ(1,4)
      MRR(18) = MRR(18)   + HYQ(3) * SIIJ(2,3) + HYQ(6) * SIIJ(1,4)
      MRR(19) = MRR( 4)
      MRR(20) = MRR(10)
      MRR(21) = MRR(16)
      MRR(22) = MRR(22)   + HYQ(1) * (HYQ(1) * SIIJ(3,1) + 2.0D0
     1 * (SIIJ(5,1) + HYQ(4) * SIIJ(2,2))) + HYQ(4) * (2.0D0 * SIIJ(4,2)
     2 + HYQ(4) * SIIJ(1,3))
      MRR(23) = MRR(23)   + HYQ(2) * SIIJ(5,1) + HYQ(5) * SIIJ(4,2)
     1 + HYQ(1) * (SIIJ(3,3) + HYQ(2) * SIIJ(3,1) + HYQ(5) * SIIJ(2,2))
     2 + HYQ(4) * (SIIJ(2,4) + HYQ(2) * SIIJ(2,2) + HYQ(5) * SIIJ(1,3))
      MRR(24) = MRR(24)   + HYQ(3) * SIIJ(5,1) + HYQ(6) * SIIJ(4,2)
     1 + HYQ(1) * (SIIJ(2,4) + HYQ(3) * SIIJ(3,1) + HYQ(6) * SIIJ(2,2))
     2 + HYQ(4) * (SIIJ(1,5) + HYQ(3) * SIIJ(2,2) + HYQ(6) * SIIJ(1,3))
      MRR(25) = MRR( 5)
      MRR(26) = MRR(11)
      MRR(27) = MRR(17)
      MRR(28) = MRR(23)
      MRR(29) = MRR(29)   + HYQ(2) * (HYQ(2) * SIIJ(3,1) + 2.0D0
     1 * (SIIJ(3,3) + HYQ(5) * SIIJ(2,2))) + HYQ(5) * (2.0D0 * SIIJ(2,4)
     2 + HYQ(5) * SIIJ(1,3))
      MRR(30) = MRR(30)   + HYQ(3) * SIIJ(3,3) + HYQ(6) * SIIJ(2,4)
     1 + HYQ(2) * (SIIJ(2,4) + HYQ(3) * SIIJ(3,1) + HYQ(6) * SIIJ(2,2))
     2 + HYQ(5) * (SIIJ(1,5) + HYQ(3) * SIIJ(2,2) + HYQ(6) * SIIJ(1,3))
      MRR(31) = MRR( 6)
      MRR(32) = MRR(12)
      MRR(33) = MRR(18)
      MRR(34) = MRR(24)
      MRR(35) = MRR(30)
      MRR(36) = MRR(36)   + HYQ(3) * (HYQ(3) * SIIJ(3,1) + 2.0D0
     1 * (SIIJ(2,4) + HYQ(6) * SIIJ(2,2))) + HYQ(6) * (2.0D0 * SIIJ(1,5)
     2 + HYQ(6) * SIIJ(1,3))
C
  146 CONTINUE
C
C
C     FILL S-MATRIX EQUIVALENCED TO A(82)  (S IS  6X3 )
C
      S( 1) = 1.0D0
      S( 2) = 0.0D0
      S( 3) =-XSUBB
      S( 4) = 0.0D0
      S( 5) = 1.0D0
      S( 6) = 0.0D0
      S( 7) = 0.0D0
      S( 8) = 0.0D0
      S( 9) = 1.0D0
      S(10) = 1.0D0
      S(11) = YSUBC
      S(12) =-XSUBC
      S(13) = 0.0D0
      S(14) = 1.0D0
      S(15) = 0.0D0
      S(16) = 0.0D0
      S(17) = 0.0D0
      S(18) = 1.0D0
C
CAN NOW COMPUTE 9 (3X3) MASS MATRICES (FMMS-66, PAGES 10-11)
C
C
C                -1 T           -1
C     ( M ) = ( H  )  ( M  ) ( H  )
C                        RR
C
C              PARTITION (M)
C                                           ///       ///
C                                           /     *     /
C                                           / MBB * MBC /
C                                           /     *     /
C                                ( M )  =   / ********* /
C                                           /     *     /
C                                           / MCB * MCC /
C                                           /     *     /
C                                           ///       ///
C                                                       4 (3X3) MATRICES
C                        -1
C     ( M  ) = ( M  ) ( H  )
C        AI       AR
C
C              PARTITION (M  )              ///                 ///
C                          AI               /          *          /
C                               ( M  )  =   / M-BAR-AB * M-BAR-AC /
C                                  AI       /          *          /
C                                           ///                 ///
C                                                       2 (3X3) MATRICES
C                               T            T
C     ( MAB )  = (M-BAR-AB) - (S ) (MBB) - (S ) (MCB)
C                               B            C
C
C                               T            T
C     ( MAC )  = (M-BAR-AC) - (S ) (MBC) - (S ) (MCC)
C                               B            C
C
C                               T     T      T      T
C     ( MAA )  = (M-BAR-AA) - (S ) (M  ) - (S ) (MAC )
C                               B    AB      C
C
C                           - (M-BAR-AB) (S ) - (M-BAR-AC) (S )
C                                          B                 C
C
C                    T
C     ( MBA )  = (MAB )
C
C                    T
C     ( MCA )  = (MAC )
C
CHOOSE APPROPRIATE BLOCK OF A-ARRAY FOR STORAGE
C
C     (3X3)    STORED IN      (3X3)     STORED IN     (3X3)    STORED IN
C     (MAA)   A( 1... 9)      (MAB)   A(10)...8)      (MAC)   A(19...27)
C     (MBA)   A(28...36)      (MBB)   A(37)...45)     (MBC)   A(46...54)
C     (MCA)   A(55...63)      (MCB)   A(64...72)      (MCC)   A(73...81)
C
C       -1
C     (H  ) IS STORED AT A(100...135)
C     (S)   EQUIVALENCED A( 81... 99)
C     WORKING STORAGE IS A(181...216)
C     (M-BAR-AB) STORED UNTIL NO LONGER NEEDED IN A(163...171)
C     (M-BAR-AC) STORED UNTIL NO LONGER NEEDED IN A(172...180)
C
C               -1 T          -1
COMPUTE (M) = (H  )  ((M  ) (H  ))
C                       RR
C
      CALL GMMATD(MRR(1),6,6,0,A(100),6,6,0,A(37))
      CALL GMMATD(A(100),6,6,1,A( 37),6,6,0,A( 1))
C
CREATE PARTITION OF 4 (3X3)
      DO 150 I=1,3
        A(I+36) = A(I   )
        A(I+39) = A(I+ 6)
        A(I+42) = A(I+12)
C
        A(I+45) = A(I+ 3)
        A(I+48) = A(I+ 9)
        A(I+51) = A(I+15)
C
        A(I+63) = A(I+18)
        A(I+66) = A(I+24)
        A(I+69) = A(I+30)
C
        A(I+72) = A(I+21)
        A(I+75) = A(I+27)
  150   A(I+78) = A(I+33)
C
COMPUTE                 -1
C       (M  ) = (M  ) (H  )    AND  PARTITION INTO 2 (3X3)  (M-BAR-AB)
C         AI      AR                                    AND (M-BAR-AC)
C
      CALL GMMATD(MAR(1),3,6,0,A(100),6,6,0,A(181))
      DO 160 I=1,3
        A(I+162) = A(I+180)
        A(I+165) = A(I+186)
        A(I+168) = A(I+192)
C
        A(I+171) = A(I+183)
        A(I+174) = A(I+189)
  160   A(I+177) = A(I+195)
COMPUTE (MAB)
      CALL GMMATD(S( 1),3,3,1,A(37),3,3,0,A(181))
      CALL GMMATD(S(10),3,3,1,A(64),3,3,0,A(190))
      DO 170 I=1,9
  170   A(I+9)=A(I+162) - A(I+180) - A(I+189)
COMPUTE (MAC)
      CALL GMMATD(S( 1),3,3,1,A(46),3,3,0,A(181))
      CALL GMMATD(S(10),3,3,1,A(73),3,3,0,A(190))
      DO 180 I=1,9
  180   A(I+18) = A(I+171) - A(I+180) - A(I+189)
COMPUTE (MAA)
      CALL GMMATD(S(  1),3,3,1,A(10),3,3,1,A(181))
      CALL GMMATD(S( 10),3,3,1,A(19),3,3,1,A(190))
      CALL GMMATD(A(163),3,3,0,S( 1),3,3,0,A(199))
      CALL GMMATD(A(172),3,3,0,S(10),3,3,0,A(208))
      DO 190 I=1,9
  190   A(I) = MBARAA(I) - A(I+180) - A(I+189) - A(I+198) - A(I+207)
COMPUTE (MBA) AND (MCA)
      DO 200 I=1,3
        NPT = 3 * I + 7
        A(I+27) = A(NPT)
        A(I+30) = A(NPT + 1)
        A(I+33) = A(NPT + 2)
C
        A(I+54) = A(NPT +  9)
        A(I+57) = A(NPT + 10)
  200   A(I+60) = A(NPT + 11)
C
      RETURN
C
      END

      SUBROUTINE KTRAPR
C
C     THIS ROUTINE COMPUTES THE STIFFNESS MATRIX FOR A AXI-SYMMETRIC
C     RING WITH A TRAPEZOIDAL CROSS SECTION
C
C     ECPT FOR THE TRAPEZOIDAL RING
C                                                          TYPE
C     ECPT( 1) ELEMENT IDENTIFICATION                        I
C     ECPT( 2) SCALAR INDEX NO. FOR GRID POINT A             I
C     ECPT( 3) SCALAR INDEX NO. FOR GRID POINT B             I
C     ECPT( 4) SCALAR INDEX NO. FOR GRID POINT C             I
C     ECPT( 5) SCALAR INDEX NO. FOR GRID POINT D             I
C     ECPT( 6) MATERIAL ORIENTATION ANGLE(DEGREES)           R
C     ECPT( 7) MATERIAL IDENTIFICATION                       I
C     ECPT( 8) COOR. SYS. ID. FOR GRID POINT A               I
C     ECPT( 9) X-COOR. OF GRID POINT A (IN BASIC COOR.)      R
C     ECPT(10) Y-COOR. OF GRID POINT A (IN BASIC COOR.)      R
C     ECPT(11) Z-COOR. OF GRID POINT A (IN BASIC COOR.)      R
C     ECPT(12) COOR. SYS. ID. FOR GRID POINT B               I
C     ECPT(13) X-COOR. OF GRID POINT B (IN BASIC COOR.)      R
C     ECPT(14) Y-COOR. OF GRID POINT B (IN BASIC COOR.)      R
C     ECPT(15) Z-COOR. OF GRID POINT B (IN BASIC COOR.)      R
C     ECPT(16) COOR. SYS. ID. FOR GRID POINT C               I
C     ECPT(17) X-COOR. OF GRID POINT C (IN BASIC COOR.)      R
C     ECPT(18) Y-COOR. OF GRID POINT C (IN BASIC COOR.)      R
C     ECPT(19) Z-COOR. OF GRID POINT C (IN BASIC COOR.)      R
C     ECPT(20) COOR. SYS. ID. FOR GRID POINT D               I
C     ECPT(21) X-COOR. OF GRID POINT D (IN BASIC COOR.)      R
C     ECPT(22) Y-COOR. OF GRID POINT D (IN BASIC COOR.)      R
C     ECPT(23) Z-COOR. OF GRID POINT D (IN BASIC COOR.)      R
C     ECPT(24) EL. TEMPERATURE FOR MATERIAL PROPERTIES       R
C
      DOUBLE PRECISION CONSTD,   DEGRAD,   D ,       GAMBQ,    R,
     1                 Z,        EE48,     TEO,      EE,       DELINT,
     2                 AK,       AKI,      R1,       R2,       R3,
     3                 R4,       Z1,       Z2,       Z3,       Z4,
     4                 ZMIN,     DGAMA,    ER,       ET,       EZ,
     5                 VRT,      VTR,      VTZ,      VZT,      VZR,
     6                 VRZ,      GRZ,      DEL,      COSG,     SING,
     7                 DGAMR,    AKT,      TWOPI,    DAMPC,    RMIN,
     8                 RMAX,     RZINTD
      DIMENSION        JRZ(2),   IECPT(24),AKI(36),  AKT(9)
      COMMON /SYSTEM/  IBUF,     IOUT
      COMMON /CONDAD/  CONSTD(5)
      COMMON /MSGX  /  NMSG,     MMSG,     MSG(4,1)
      COMMON /SMA1IO/  DUM1(10), IFKGG,    IGKGG,    IF4GG,    DUM2(21)
      COMMON /SMA1CL/  IOPT4,    K4GGSW,   NPVT,     DUM4(7),  LINK(10),
     1                 IDETCK,   DODET,    NOGO
      COMMON /SMA1ET/  ECPT(24), DUM5(76)
      COMMON /SMA1DP/  D(64),    GAMBQ(64), R(4),    Z(4),     TEO(16),
     1                 EE(16),   DELINT(12),AK(64),  DGAMA,    ZMIN,
     2                 ER,       ET,       EZ,       VRT,      VTR,
     3                 VTZ,      VZT,      VZR,      VRZ,      GRZ,
     4                 DEL,      COSG,     SING,     DGAMR,    IGP(4),
     5                 ICS(4),   SP(24),   TEMPE
      COMMON /MATIN /  MATIDC,   MATFLG,   ELTEMP,   STRESS,   SINTH,
     1                 COSTH
      COMMON /MATOUT/  E(3),     ANU(3),   RHO,      G(3),     ALF(3),
     1                 TZERO,    G SUB E
      EQUIVALENCE      (CONSTD(2),TWOPI),  (CONSTD(4),DEGRAD),
     1                 (IECPT(1) ,ECPT(1)),
     2                 (R(1),R1),(R(2),R2),(R(3),R3), (R(4),R4),
     3                 (Z(1),Z1),(Z(2),Z2),(Z(3),Z3), (Z(4),Z4),
     4                 (AKI(1),GAMBQ(1))  ,(AKT(1),GAMBQ(37))
      DATA    IRG   /  4HTRAP    /
C
C
C     STORE ECPT PARAMETERS IN LOCAL VARIABLES
C
      IDEL   = IECPT(1)
      IGP(1) = IECPT(2)
      IGP(2) = IECPT(3)
      IGP(3) = IECPT(4)
      IGP(4) = IECPT(5)
      MATID  = IECPT(7)
      ICS(1) = IECPT(8)
      ICS(2) = IECPT(12)
      ICS(3) = IECPT(16)
      ICS(4) = IECPT(20)
      R(1)   = ECPT( 9)
      D(1)   = ECPT(10)
      Z(1)   = ECPT(11)
      R(2)   = ECPT(13)
      D(2)   = ECPT(14)
      Z(2)   = ECPT(15)
      R(3)   = ECPT(17)
      D(3)   = ECPT(18)
      Z(3)   = ECPT(19)
      R(4)   = ECPT(21)
      D(4)   = ECPT(22)
      Z(4)   = ECPT(23)
      TEMPE  = ECPT(24)
      DGAMA  = ECPT( 6)
C
C     CHECK INTERNAL GRID POINTS FOR PIVOT POINT
C
      IPP = 0
      DO 100 I = 1,4
      IF (NPVT .EQ. IGP(I)) IPP = I
  100 CONTINUE
      IF (IPP .EQ. 0) CALL MESAGE (-30,34,IDEL)
C
C     TEST THE VALIDITY OF THE GRID POINT COORDINATES
C
      DO 200 I = 1,4
      IF (R(I) .LT. 0.0D0) GO TO 910
      IF (D(I) .NE. 0.0D0) GO TO 910
  200 CONTINUE
C
C     COMPUTE THE ELEMENT COORDINATES
C
      ZMIN = DMIN1(Z1,Z2,Z3,Z4)
      Z1 = Z1 - ZMIN
      Z2 = Z2 - ZMIN
      Z3 = Z3 - ZMIN
      Z4 = Z4 - ZMIN
C
C     FATAL IF RATIO OF RADII IS TO LARGE FOR GUASS QUADRATURE FOR
C     IP =-1
C
      RMIN = DMIN1(R1,R2,R3,R4)
      RMAX = DMAX1(R1,R2,R3,R4)
      IF (RMIN .EQ. 0.D0) GO TO 206
      IF (RMAX/RMIN .GT. 10.D0) GO TO 930
C
  206 IF (R1.GE.R2 .OR. R4.GE.R3 .OR. Z4.LE.Z1) GO TO 910
      IF (DABS(Z1-Z2) .GT. 1.0D-3) GO TO 910
      IF (DABS(Z3-Z4) .GT. 1.0D-3) GO TO 910
      D(5) = (R1+R4)/2.0D0
      D(6) = (R2+R3)/2.0D0
      IF (D(5) .EQ. 0.0D0) GO TO 210
      IF (DABS((R1-R4)/D(5)) .GT. 0.5D-2) GO TO 210
      R1 = D(5)
      R4 = D(5)
  210 CONTINUE
      IF (D(6) .EQ. 0.0D0) GO TO 220
      IF (DABS((R2-R3)/D(6)) .GT. 0.5D-2) GO TO 220
      R(2) = D(6)
      R(3) = D(6)
  220 CONTINUE
C
      ICORE = 0
      J = 1
      DO 230 I = 1,4
      IF (R(I) .NE. 0.D0) GO TO 230
      ICORE  = ICORE + 1
      JRZ(J) = I
      J = 2
  230 CONTINUE
      IF (ICORE.NE.0 .AND. ICORE.NE.2) GO TO 910
C
C     FORM THE TRANSFORMATION MATRIX (8X8) FROM FIELD COORDINATES TO
C     GRID POINT DEGREES OF FREEDOM
C
      DO 300 I = 1,64
      GAMBQ(I) = 0.0D0
  300 CONTINUE
      GAMBQ( 1) = 1.0D0
      GAMBQ( 2) = R1
      GAMBQ( 3) = Z1
      GAMBQ( 4) = R1*Z1
      GAMBQ(13) = 1.0D0
      GAMBQ(14) = R1
      GAMBQ(15) = Z1
      GAMBQ(16) = GAMBQ(4)
      GAMBQ(17) = 1.0D0
      GAMBQ(18) = R2
      GAMBQ(19) = Z2
      GAMBQ(20) = R2*Z2
      GAMBQ(29) = 1.0D0
      GAMBQ(30) = R2
      GAMBQ(31) = Z2
      GAMBQ(32) = GAMBQ(20)
      GAMBQ(33) = 1.0D0
      GAMBQ(34) = R3
      GAMBQ(35) = Z3
      GAMBQ(36) = R3*Z3
      GAMBQ(45) = 1.0D0
      GAMBQ(46) = R3
      GAMBQ(47) = Z3
      GAMBQ(48) = GAMBQ(36)
      GAMBQ(49) = 1.0D0
      GAMBQ(50) = R4
      GAMBQ(51) = Z4
      GAMBQ(52) = R4*Z4
      GAMBQ(61) = 1.0D0
      GAMBQ(62) = R4
      GAMBQ(63) = Z4
      GAMBQ(64) = GAMBQ(52)
C
C     NO NEED TO COMPUTE DETERMINANT SINCE IT IS NOT USED SUBSEQUENTLY.
C
      ISING = -1
      CALL INVERD (8,GAMBQ(1),8,D(10),0,D(11),ISING,SP)
      IF (ISING.EQ.2) GO TO 920
C
C     MODIFY THE TRANSFORMATION MATRIX IF ELEMENT IS A CORE ELEMENT
C
      IF (ICORE .EQ. 0) GO TO 305
      JJ1 = 2*JRZ(1) - 1
      JJ2 = 2*JRZ(2) - 1
C
      DO 303 I = 1,8
      J = 8*(I-1)
      GAMBQ(I   ) = 0.0D0
      GAMBQ(I+16) = 0.0D0
      GAMBQ(J+JJ1)= 0.D0
      GAMBQ(J+JJ2)= 0.D0
  303 CONTINUE
  305 CONTINUE
C
C     CALCULATE THE INTEGRAL VALUES IN ARRAY DELINT WHERE THE ORDER IS
C     INDICATED BY THE FOLLOWING TABLE
C
C        DELINT( 1) - (-1,0)
C        DELINT( 2) - (-1,1)
C        DELINT( 3) - (-1,2)
C        DELINT( 4) - ( 0,0)
C        DELINT( 5) - ( 0,1)
C        DELINT( 6) - ( 0,2)
C        DELINT( 7) - ( 1,0)
C        DELINT( 8) - ( 1,1)
C        DELINT( 9) - ( 1,2)
C        DELINT(10) - ( 2,0)
C        DELINT(11) - ( 2,1)
C        DELINT(12) - ( 3,0)
C
      I1 = 0
      DO 400 I = 1,4
      IP = I - 2
      DO 350 J = 1,3
      IQ = J - 1
      I1 = I1 + 1
      IF (I1 .NE. 12) GO TO 340
      IP = 3
      IQ = 0
  340 CONTINUE
      IF (ICORE .EQ. 0) GO TO 345
      IF (I1 .GT. 3) GO TO 345
      DELINT(I1) = 0.0D0
      GO TO 350
  345 CONTINUE
      DELINT(I1) = RZINTD(IP,IQ,R,Z,4)
  350 CONTINUE
  400 CONTINUE
C
C     LOCATE THE MATERIAL PROPERTIES IN THE MAT1 OR MAT3 TABLE
C
      MATIDC = MATID
      MATFLG = 7
      ELTEMP = TEMPE
      CALL MAT (IDEL)
C
C     SET MATERIAL PROPERTIES IN DOUBLE PRECISION VARIABLES
C
      ER  = E(1)
      ET  = E(2)
      EZ  = E(3)
      VRT = ANU(1)
      VTZ = ANU(2)
      VZR = ANU(3)
      GRZ = G(3)
      VTR = VRT*ET/ER
      VZT = VTZ*EZ/ET
      VRZ = VZR*ER/EZ
      DEL = 1.0D0 - VRT*VTR - VTZ*VZT - VZR*VRZ - VRT*VTZ*VZR
     1    - VRZ*VTR*VZT
C
C     GENERATE ELASTIC CONSTANTS MATRIX (4X4)
C
      EE(1) = ER*(1.0D0-VTZ*VZT)/DEL
      EE(2) = ER*(VTR + VZR*VTZ)/DEL
      EE(3) = ER*(VZR + VTR*VZT)/DEL
      EE(4) = 0.0D0
      EE(5) = EE(2)
      EE(6) = ET*(1.0D0-VRZ*VZR)/DEL
      EE(7) = ET*(VZT+VRT*VZR)/ DEL
      EE(8) = 0.0D0
      EE(9) = EE(3)
      EE(10)= EE(7)
      EE(11)= EZ*(1.0D0-VRT*VTR)/DEL
      EE(12)= 0.0D0
      EE(13)= 0.0D0
      EE(14)= 0.0D0
      EE(15)= 0.0D0
      EE(16)= GRZ
C
C     FORM TRANSFORMATION MATRIX (4X4) FROM MATERIAL AXIS TO ELEMENT
C     GEOMETRIC AXIS
C
      DGAMR   = DGAMA*DEGRAD
      COSG    = DCOS(DGAMR)
      SING    = DSIN(DGAMR)
      TEO( 1) = COSG**2
      TEO( 2) = 0.0D0
      TEO( 3) = SING**2
      TEO( 4) = SING*COSG
      TEO( 5) = 0.0D0
      TEO( 6) = 1.0D0
      TEO( 7) = 0.0D0
      TEO( 8) = 0.0D0
      TEO( 9) = TEO(3)
      TEO(10) = 0.0D0
      TEO(11) = TEO(1)
      TEO(12) =-TEO(4)
      TEO(13) =-2.0D0*TEO(4)
      TEO(14) = 0.0D0
      TEO(15) =-TEO(13)
      TEO(16) = TEO(1) - TEO(3)
C
C     TRANSFORM THE ELASTIC CONSTANTS MATRIX FROM MATERIAL
C     TO ELEMENT GEOMETRIC AXIS
C
      CALL GMMATD (TEO,4,4,1, EE, 4,4,0, D )
      CALL GMMATD (D  ,4,4,0, TEO,4,4,0, EE)
C
C     FORM THE ELEMENT STIFFNESS MATRIX IN FIELD COORDINATES
C
      EE48   = EE(4) + EE(8)
      D ( 1) = EE(1) + 2.0D0*EE(2) + EE(6)
      AK( 1) = EE(6)*DELINT(1)
      AK( 2) = (EE(2) + EE(6))*DELINT(4)
      AK( 3) = EE(6)*DELINT(2) + EE(8)*DELINT(4)
      AK( 4) = (EE(2) + EE(6))*DELINT(5) + EE(8)*DELINT(7)
      AK( 5) = 0.0D0
      AK( 6) = EE(8)*DELINT(4)
      AK( 7) = EE(7)*DELINT(4)
      AK( 8) = EE(7)*DELINT(7) + EE(8)*DELINT(5)
      AK( 9) = AK(2)
      AK(10) = D(1)*DELINT(7)
      AK(11) = (EE(2) + EE(6))*DELINT(5) + EE48*DELINT(7)
      AK(12) = D(1)*DELINT(8) + EE48*DELINT(10)
      AK(13) = 0.0D0
      AK(14) = EE48*DELINT(7)
      AK(15) = (EE(3)+EE(7))*DELINT(7)
      AK(16) = (EE(3)+EE(7))*DELINT(10) + EE48*DELINT(8)
      AK(17) = AK( 3)
      AK(18) = AK(11)
      AK(19) = EE(6)*DELINT(3) + EE(16)*DELINT(7) + (EE(8) +
     1         EE(14))*DELINT(5)
      AK(20) = (EE(2) + EE(6))*DELINT(6) + EE(16)*DELINT(10) + (EE(8) +
     1          EE(13) + EE(14))*DELINT(8)
      AK(21) = 0.0D0
      AK(22) = EE(16)*DELINT(7) + EE(8)*DELINT(5)
      AK(23) = EE( 7)*DELINT(5) + EE(15)*DELINT(7)
      AK(24) = (EE(7) + EE(16))*DELINT(8) + EE(8)*DELINT(6) +
     1         EE(15)*DELINT(10)
      AK(25) = AK( 4)
      AK(26) = AK(12)
      AK(27) = AK(20)
      AK(28) = D(1)*DELINT(9) + EE(16)*DELINT(12) + (EE48 + EE(13) +
     1         EE(14))*DELINT(11)
      AK(29) = 0.0D0
      AK(30) = EE(16)*DELINT(10) + EE48*DELINT(8)
      AK(31) = (EE(3) + EE(7))*DELINT(8) + EE(15)*DELINT(10)
      AK(32) = (EE(3) + EE(7) + EE(16))*DELINT(11) + EE(15)*DELINT(12) +
     1         EE48*DELINT(9)
      AK(33) = 0.0D0
      AK(34) = 0.0D0
      AK(35) = 0.0D0
      AK(36) = 0.0D0
      AK(37) = 0.0D0
      AK(38) = 0.0D0
      AK(39) = 0.0D0
      AK(40) = 0.0D0
      AK(41) = AK( 6)
      AK(42) = AK(14)
      AK(43) = AK(22)
      AK(44) = AK(30)
      AK(45) = 0.0D0
      AK(46) = EE(16)*DELINT(7)
      AK(47) = EE(15)*DELINT(7)
      AK(48) = EE(16)*DELINT(8) + EE(15)*DELINT(10)
      AK(49) = AK( 7)
      AK(50) = AK(15)
      AK(51) = AK(23)
      AK(52) = AK(31)
      AK(53) = 0.0D0
      AK(54) = AK(47)
      AK(55) = EE(11)*DELINT( 7)
      AK(56) = EE(11)*DELINT(10) + EE(12)*DELINT(8)
      AK(57) = AK( 8)
      AK(58) = AK(16)
      AK(59) = AK(24)
      AK(60) = AK(32)
      AK(61) = 0.0D0
      AK(62) = AK(48)
      AK(63) = AK(56)
      AK(64) = EE(11)*DELINT(12) + EE(16)*DELINT(9) + (EE(12) +
     1         EE(15))*DELINT(11)
C
      DO 600 I = 1,64
      AK(I) = TWOPI*AK(I)
  600 CONTINUE
C
C     TRANSFORM THE ELEMENT STIFFNESS MATRIX FROM FIELD COORDINATES
C     TO GRID POINT DEGREES OF FREEDOM
C
      CALL GMMATD (GAMBQ,8,8,1, AK,8,8,0, D)
      CALL GMMATD (D,8,8,0, GAMBQ,8,8,0, AK)
C
C     ZERO OUT THE (6X6) MATRIX USED AS INPUT TO THE INSERTION ROUTINE
C
      DO 700 I = 1,36
      AKI(I) = 0.0D0
  700 CONTINUE
C
C     LOCATE THE TRANSFORMATION MATRICES FOR THE FOUR  GRID POINTS
C
      DO 800 I = 1,4
      IF (ICS(I) .EQ. 0) GO TO 800
      K = 9*(I-1) + 1
      CALL TRANSD (ICS(I),D(K))
  800 CONTINUE
C
C     START THE LOOP FOR INSERTION OF THE FOUR  (6X6) MATRICES
C     INTO THE MASTER STIFFNESS MATRIX
C
      IR1  = 2*IPP - 1
      IAPP = 9*(IPP-1) + 1
      DO 900 I = 1,4
C
C     PLACE THE APPROIATE (2X2) SUBMATRIX OF THE STIFFNESS MATRIX
C     IN A (3X3) MATRIX FOR TRANSFORMATION
C
      IC1    = 2*I - 1
      IRC    = (IR1-1)*8 + IC1
      AKT(1) = AK(IRC)
      AKT(2) = 0.0D0
      AKT(3) = AK(IRC+1)
      AKT(4) = 0.0D0
      AKT(5) = 0.0D0
      AKT(6) = 0.0D0
      AKT(7) = AK(IRC+8)
      AKT(8) = 0.0D0
      AKT(9) = AK(IRC+9)
C
C     TRANSFORM THE (3X3) STIFFNESS MATRIX
C
      IF (ICS(IPP) .EQ. 0) GO TO 820
      CALL GMMATD (D(IAPP),3,3,1, AKT(1),3,3,0, D(37))
      DO 810 J = 1,9
      AKT(J) = D(J+36)
  810 CONTINUE
  820 CONTINUE
      IF (ICS(I) .EQ. 0) GO TO 840
      IAI = 9*(I-1) + 1
      CALL GMMATD (AKT(1),3,3,0, D(IAI),3,3,0, D(37))
      DO 830 J = 1,9
      AKT(J) = D(J+36)
  830 CONTINUE
  840 CONTINUE
C
C     PLACE THE TRANSFORMED (3X3) MATRIX INTO A (6X6) MATRIX FOR
C     THE INSERTION ROUTINE
C
      J = 0
      DO 850 J1 = 1,18,6
      DO 850 J2 = 1,3
      J = J + 1
      K = J1 + J2 - 1
      AKI(K) = AKT(J)
  850 CONTINUE
C
C     CALL THE INSERTION ROUTINE
C
      CALL SMA1B (AKI(1),IGP(I),-1,IFKGG,0.0D0)
      IF (IOPT4.EQ.0 .OR. GSUBE.EQ.0.0) GO TO 900
      K4GGSW = 1
      DAMPC  = GSUBE
      CALL SMA1B (AKI(1),IGP(I),-1,IF4GG,DAMPC)
  900 CONTINUE
      RETURN
C
C     SET FLAG FOR FATAL ERROR WHILE ALLOWING ERROR MESSAGES TO
C     ACCUMULATE
C
  910 I = 37
      GO TO 950
  920 I = 26
      GO TO 950
  930 I = 221
C ...     221 WILL PRINT USER MESSAGE 2218
C
  950 IF (NMSG .EQ. 0) GO TO 970
      IF (NMSG .GE. MMSG) RETURN
      DO 960 J = 1,NMSG
      IF (MSG(3,J).EQ.IDEL .AND. MSG(2,J).EQ.I) RETURN
  960 CONTINUE
  970 ICS(1) = IDEL
      ICS(2) = IRG
      CALL MESAGE (30,I,ICS)
      NOGO = 1
      RETURN
C
      END

      SUBROUTINE AMPB(PHIDH,GTKA,D1JK,D2JK,D1JE,D2JE,USETA,
     1 DJH1,DJH2,GKI,SCR1,SCR2,SCR3)
C
C     THE PURPOSE OF THIS SUBROUTINE IS TO SOLVE FOR THE DJH MATRICES.
C      IT ALSO COMPUTES GKI FOR LATER USE.
C      THE STEPS ARE,
C
C     1. PHIDH GOES TO   1       1      1
C                        1 PHIA  1      1
C                        1 ----- 1 ---- 1
C                        1       1      1
C                        1       1      1
C
C     2. GKI =GTKA$PHIA
C
C     3. DJI1=D1JK*GKI
C     4. DJI2=D2JK*GKI
C     5.
C     6. DJH1= 1 DJI1 1 D1JE 1
C              1      1      1
C     7. DJH2= 1 DJI2 1 D2JE 1
C
C
C
      INTEGER PHIDH,GTKA,D1JK,D2JK,D1JE,D2JE,USETA,DJH1,DJH2,GKI,
     1 SCR1,SCR2,SCR3,PHIA,DJI1,DJI2,MCB(7),UD,UA,UE
C
      COMMON /BLANK/NOUE
      COMMON /PATX/LC,NS0,NS1,NS2,IUSET
      COMMON /BITPOS/UM,UO,UR,USG,USB,UL,UA,UF,US,UN,UG,UE,UP,UNE,UFE,UD
     1 ,UPS,USA,UK,UPA
      COMMON/ZZZZZZ/Z(1)
      COMMON/SYSTEM/SYSBUF,NOUT,SKIP(52),IPREC
      COMMON /AMPCOM/ NCOLJ
C
C-----------------------------------------------------------------------
C
      MCB(1)=PHIDH
      CALL RDTRL(MCB)
      NOH=MCB(2)
C
C     DETERMINE IF PHIDH MUST BE MODIFIED
C
      IF(NOUE.EQ.-1)GO TO 20
C
C     BUILD PARTITIONING VECTORS
C
      IUSET = USETA
      LC=KORSZ(Z)
      CALL CALCV(SCR1,UD,UA,UE,Z)
      CALL AMPB1(SCR2,NOH-NOUE,NOUE)
C
C     PERFORM PARTITION
C                       RP   CP
      CALL AMPB2(PHIDH,SCR3,0,0,0,SCR2,SCR1,0,0)
      PHIA=SCR3
      GO TO 30
C
C     NO MOD REQUIRED
C
   20 PHIA=PHIDH
   30 CONTINUE
C
C     COMPUTE GKI
C
      CALL SSG2B(GTKA,PHIA,0,GKI,1,IPREC,1,SCR1)
C
C     START COMPUTATION OF DJH MATRICES
C
      DJI1=SCR3
      DJI2=SCR3
      IF(NOUE.GT.0)GO TO 40
      DJI1=DJH1
      DJI2=DJH2
   40 CONTINUE
      CALL SSG2B(D1JK,GKI,0,DJI1,1,IPREC,1,SCR1)
      IF(NOUE.EQ.-1)GO TO 50
      CALL MERGED(DJI1,D1JE,0,0,DJH1,SCR2,0,0,NCOLJ)
   50 CONTINUE
      CALL SSG2B(D2JK,GKI,0,DJI2,1,IPREC,1,SCR1)
      IF(NOUE.EQ.-1)GO TO 60
      CALL MERGED(DJI2,D2JE,0,0,DJH2,SCR2,0,0,NCOLJ)
   60 CONTINUE
      RETURN
      END

        SUBROUTINE DSGNCL
      INCLUDE 'DSIOF.COM'
      INCLUDE 'GINOX.COM'
        IDSN =  MDSFCB( 2, IFILEX )
        CALL DSCLOS( IDSN )
        MDSFCB( 1,IDSN ) = IAND( MDSFCB( 1,IDSN ), MASKH1 )
        RETURN
        END

      SUBROUTINE BUFCHK
C
      IMPLICIT INTEGER (A-Z)
      LOGICAL          OD,OS,OR,STRDAT
      INTEGER          I(4)
      REAL             S(4)
      DOUBLE PRECISION D(2)
      CHARACTER*8      NAM,IIBL
      COMMON /ZZZZZZ/  B(1)
      COMMON /BUFCOM/  OFFSET,OUTBGN,OUTEND,OUTLVL
      EQUIVALENCE      (I(1),S(1),D(1))
      DATA             NOUT    ,  NAM      , IIBL      /
     1                 6       ,  'BUFCHK@','II,B(L)=' /
C VAX:
      DATA             RECTRL  ,  RCTRLL   , RCTRLC  , COLHDR, COLTRL /
     1                 '1'X    ,  '2'X     , '3'X    , '4'X  , '8'X   /
      DATA             RECHDR  ,  RCHDST   , STRDUM  , EOBSTR   /
     1                 'F1111'X,  'F2222'X , 'FAAAA'X, 'FBBBB'X /
      DATA             EOB     ,  EOF      , STRHDR  , STRTRL   /
     1                 'F5555'X,  'F7777'X , 'F8888'X, 'F9999'X /
C UNIX:
C     DATA             RECTRL  ,  RCTRLL   , RCTRLC  , COLHDR, COLTRL /
C    1                 X'1'    ,  X'2'     , X'3'    , X'4'  , X'8'   /
C     DATA             RECHDR  ,  RCHDST   , STRDUM  , EOBSTR   /
C    1                 X'F1111',  X'F2222' , X'FAAAA', X'FBBBB' /
C     DATA             EOB     ,  EOF      , STRHDR  , STRTRL   /
C    1                 X'F5555',  X'F7777' , X'F8888', X'F9999' /
C
C*****
      LSHIFT(K,J) = ISHFT(K, J)
      RSHIFT(K,J) = ISHFT(K,-J)
C     WHERE         ISHFT(K,+J) IS  LEFT-SHIFT K BY J BITS, ZERO FILL
C                   ISHFT(K,-J) IS RIGHT-SHIFT K BY J BITS, ZERO FILL
C     AND           ISHFT IS SYSTEM ROUTINE
C
C UNIX:
C     REMOVE ABOVE 2 ON-LINE FUNCTIONS IF THE SYSTEM ISHFT FUNCTION IS
C     NOT AVAILABLE.  LSHIFT AND RSHIFT ARE ALREADY ENTRY POINTS IN
C     SUBROUTINE MAPFNS.
C*****
C
      L      = OFFSET - 1
      DATBGN = L + 1
      DATEND = L + 8
      DATTYP = 5
      SKP    = 0
C
      DO 700 II = 1,10000
      IF (II .LE. OUTEND) GO TO 110
      IF (OD) WRITE (NOUT,100) NAM,II
  100 FORMAT (5X,A7,'100  LIMIT POINTER REACHED.  II=',I6)
      GO TO 900
  110 L   = L + 1
      OD  = II.GE.OUTBGN .AND. OUTLVL.GT.0
      OS  = II.GE.OUTBGN .AND. OUTLVL.GT.1
      OR  = II.GE.OUTBGN .AND. OUTLVL.GT.2
      SKP = SKP - 1
      IF (SKP .GT. 0) GO TO 700
      IF (L.GE.DATBGN .AND. L.LE.DATEND) GO TO 500
      W   = B(L)
      F1  = RSHIFT(       W    ,28)
      F2  = RSHIFT(LSHIFT(W, 4),16)
      F3  = RSHIFT(LSHIFT(W,20),20)
      F12 = RSHIFT(       W    ,12)
      F31 = RSHIFT(LSHIFT(W,20),24)
      F32 = RSHIFT(LSHIFT(W,28),28)
      IF (F12 .NE. RECHDR) GO TO 160
      DATBGN = L + 1
      DATEND = L + F3
      DATTYP = 5
      IF (OD) WRITE (NOUT,150) NAM,IIBL,II,B(L)
  150 FORMAT (5X,A7,'150  REC HDR - NO STRING.  ',A8,I6,Z8)
      GO TO 700
  160 IF (F12 .NE. RCHDST) GO TO 180
      IF (OD) WRITE (NOUT,170) NAM,IIBL,II,B(L)
  170 FORMAT (5X,A7,'170  REC HDR - STRING.  ',A8,I6,Z8)
      STRDAT = .TRUE.
      GO TO 700
  180 IF (.NOT.(F1.EQ.RECTRL .OR. F1.EQ.RCTRLL)) GO TO 210
      IF (OD) WRITE (NOUT,200) NAM,IIBL,II,B(L)
  200 FORMAT (5X,A7,'200  REC TRAILR - END OF RECORD.  ',A8,I6,Z8)
      GO TO 700
  210 IF (F1 .NE. RCTRLC) GO TO 240
      IF (OD) WRITE (NOUT,230) NAM,IIBL,II,B(L)
  230 FORMAT (5X,A7,'230  REC TRAILER - RECORD CONTINUES.  ',A8,I6,Z8)
      GO TO 700
  240 IF (F12 .NE. EOB) GO TO 260
      IF (OD) WRITE (NOUT,250) NAM,IIBL,II,B(L)
  250 FORMAT (5X,A7,'250  END OF BLOCK.  ',A8,I6,Z8)
      GO TO 700
  260 IF (F12 .NE. EOF) GO TO 280
      IF (OD) WRITE (NOUT,270) NAM,IIBL,II,B(L)
  270 FORMAT (5X,A7,'270  END OF FILE.  ',A8,I6,Z8)
      GO TO 700
  280 IF (F1 .NE. COLHDR) GO TO 310
      IF (OD) WRITE (NOUT,300) NAM,IIBL,II,B(L),F2
  300 FORMAT (5X,A7,'300  COLUMN HEADER.  ',A7,',F2=',I6,Z8,I8)
      DATTYP = F31
      GO TO 700
  310 IF (F1 .NE. COLTRL) GO TO 340
      IF (OD) WRITE (NOUT,330) NAM,IIBL,II,B(L),F2
  330 FORMAT (5X,A7,'330  COLUMN TRAILER.  ',A7,',F2=',I6,Z8,I8)
      GO TO 700
  340 IF (F12 .NE. STRHDR) GO TO 360
      IF (OD) WRITE (NOUT,350) NAM,IIBL,II,B(L),B(L+1),F3
  350 FORMAT (5X,A7,'350  STRING HEADER.  ',A7,',B(L+1),F3=',I6,2Z8,I8)
      SKP    = 2
      DATBGN = L + 1
      DATEND = L + F3
      GO TO 700
  360 IF (F12 .NE. STRTRL) GO TO 380
      IF (OD) WRITE (NOUT,370) NAM,IIBL,II,B(L),B(L+1),F3
  370 FORMAT (5X,A7,'370  STRING TRAILER.  ',A7,',B(L+1),F3=',I6,2Z8,I8)
      SKP = 2
      GO TO 700
  380 IF (F12 .NE. STRDUM) GO TO 410
      IF (OD) WRITE (NOUT,400) NAM,IIBL,II,B(L)
  400 FORMAT (5X,A7,'400  STRING DUMMY WORD.  ',A8,I6,Z8)
      GO TO 700
  410 WRITE (NOUT,430) NAM,IIBL,II,B(L)
  430 FORMAT (5X,A7,'430  INVALID CONTROL WORD.  ',A8,I6,Z8)
      GO TO 800
C
  500 CONTINUE
      DO 510 J = 1,4
  510 I(J) = B(L+J-1)
      GO TO (610,620,630,640,650) DATTYP
      WRITE (NOUT,550) NAM,DATTYP
  550 FORMAT (5X,A7,'550  BAD DATA TYP,  DATTYP=',I6)
      GO TO 800
  610 IF (OS) WRITE (NOUT,615) NAM,II,S(1)
  615 FORMAT (5X,A7,'615  II,S(1)=',I6,E13.6)
      GO TO 700
  620 IF (OS) WRITE (NOUT,625) NAM,II,D(1)
  625 FORMAT (5X,A7,'625  II,D(1)=',I6,D17.9)
      SKP = 2
      GO TO 700
  630 IF (OS) WRITE (NOUT,635) NAM,II,S(1),S(2)
  635 FORMAT (5X,A7,'635  II,S(1),S(2)=',I6,2E13.6)
      SKP = 2
      GO TO 700
  640 IF (OS) WRITE (NOUT,645) NAM,II,D(1),D(2)
  645 FORMAT (5X,A7,'645  II,D(1),D(2)=',I6,2D17.9)
      SKP = 4
      GO TO 700
  650 IF (OR) WRITE (NOUT,660) NAM,II,I(1)
  660 FORMAT (5X,A7,'615  II,I(1)=',I6,I14)
  700 CONTINUE
C
      WRITE (NOUT,750) NAM
  750 FORMAT (5X,A7,'750  BLOCK TOO LONG')
  800 CALL VAXEND
  900 RETURN
      END

      SUBROUTINE EMADTQ(NARG,MASS)
C  THE EMG MASS DOUBLE PRECISION ROUTINE FOR TRI S, QUAD S, TWIST +
C     SHEAR ELEMENTS
C
C  THIS SUBROUTINE CALCULATES THE MASS MATRIX FOR THE ELEMENTS LISTED
C   BELOW
C
C   NOTE THAT THE OUTPUT MASS MATRIX IS NOT ORDERED BY INCREASING SIL
C     DOUBLE PRECISION VERSION
C
C     ******************************************************************
C     E C P T    L I S T I N G S
C     **************************
C         MTWIST              MQDMEM                        MTRMEM
C         MSHEAR    MQUAD1    MQUAD2    MTRIA1    MTRBSC    MTRIA2
C **********************************************************************
C ECPT( 1)ELEM. ID  ELEM. ID  ELEM. ID  ELEM. ID  ELEM. ID  ELEM. ID
C ECPT( 2)GR.PT. A  GR.PT. A  GR.PT. A  GR.PT. A  GR.PT. A  GR.PT. A
C ECPT( 3)GR.PT. B  GR.PT. B  GR.PT. B  GR.PT. B  GR.PT. B  GR.PT. B
C ECPT( 4)GR.PT. C  GR.PT. C  GR.PT. C  GR.PT. C  GR.PT. C  GR.PT. C
C ECPT( 5)GR.PT. D  GR.PT. D  GR.PT. D  THETA     THETA     THETA
C ECPT( 6)MAT ID    THETA     THETA     MAT ID 1  MAT ID 1  MAT ID
C ECPT( 7)T         MAT ID 1  MAT ID    T1        I         T
C ECPT( 8)N S MASS  T1        T         MAT ID 2  MAT ID 2  NS MASS
C ECPT( 9)CSID 1    MAT ID 2  N S MASS  I         T2        CSID 1
C ECPT(10)X1        I         CSID 1    MAT ID 3  N S MASS  X1
C ECPT(11)Y1        MAT ID 3  X1        T2        Z1        Y1
C ECPT(12)Z1        T2        Y1        N S MASS  Z2        Z1
C ECPT(13)CSID 2    N S MASS  Z1        Z1        CSID 1    CSID 2
C ECPT(14)X2        Z1        CSID 2    Z2        X1        X2
C ECPT(15)Y2        Z2        X2        CSID 1    Y1        Y2
C ECPT(16)Z2        CSID 1    Y2        X1        Z1        Z2
C ECPT(17)CSID 3    X1        Z2        Y1        CSID 2    CSID 3
C ECPT(18)X3        Y1        CSID 3    Z1        X2        X3
C ECPT(19)Y3        Z1        X3        CSID 2    Y2        Y3
C ECPT(20)Z3        CSID 2    Y3        X2        Z2        Z3
C ECPT(21)CSID 4    X2        Z3        Y2        CSID 3    TEMP
C ECPT(22)X4        Y2        CSID 4    Z2        X3
C ECPT(23)Y4        Z2        X4        CSID 3    Y3
C ECPT(24)Z4        CSID 3    Y4        X3        Z3
C ECPT(25)TEMP      X3        Z4        Y3        TEMP
C ECPT(26)          Y3        TEMP      Z3
C ECPT(27)          Z3                  TEMP
C ECPT(28)          CSID 4
C ECPT(29)          X4
C ECPT(30)          Y4
C ECPT(31)          Z4
C ECPT(32)          TEMP
C **********************************************************************
C
      DOUBLE PRECISION MASS(100),V1(3),V2(3),V1XV2(3),
     X      FMU, T, AREA , TERM, RHOD
      DIMENSION NECPT (7)
      INTEGER HEAT
C
      COMMON /HMTOUT/ CP
      COMMON /MATIN/ MATID,INFLAG,ELTEMP
      COMMON /MATOUT/ RHO
      COMMON/SYSTEM/ KSYSTM(55),HEAT
C
      COMMON / EMGEST/ ECPT(100)
C
      EQUIVALENCE ( NECPT(1) , ECPT(1) )
      EQUIVALENCE (IFLAG , ECPT(8) )
      DATA PI23/2.0943952/
C
C     THIS ROUTINE COMPUTES A MASS MATRIX OF THE FOLLOWING FORM.
C
C   MASS MATRIX = (T1,T1,T1,T2,T2,T2,T3,T3,T3,IF REQ-D T4,T4,T4)  )
C
C                   *******************
C                   NTYPE = 1  -MQDMEM-
C                   NTYPE = 1  -MQUAD2-
C                   NTYPE = 2  -MQUAD1-
C                   NTYPE = 3  -MTRBSC-
C                   NTYPE = 3  -MTRPLT-
C                   NTYPE = 4  -MTRMEM-
C                   NTYPE = 4  -MTRIA2-
C                   NTYPE = 5  -MTRIA1-
C                   NTYPE = 6  -MSHEAR-
C                   NTYPE = 6  -MTWIST-
C                   NTYPE = 7  -MQDPLT-
C                   *******************
C
      NTYPE = NARG
      NDOF = 3
C
C            -MQDMEM-      -MTRPLT-MTRMEM-      -MTWIST-
C            -MQUAD2-MQUAD1-MTRBSC-MTRIA2-MTRIA1-MSHEAR-MQDPLT-
      GO TO(10,20,30,40,50,60,70),NTYPE
C
   10 NCSID = 10
      NGRIDS = 4
      MATID = NECPT(7)
      T     = ECPT(8)
      FMU   = ECPT(9)
      GO TO 80
C
   20 NCSID = 16
      NGRIDS = 4
      MATID = NECPT(7)
      T     = ECPT(8)
      FMU   = ECPT(13)
      GO TO 80
C
   30 NCSID =  13
      NGRIDS = 3
      MATID = NECPT( 6)
      T     =  0.0E0
      FMU   =  ECPT(10)
      GO TO 80
C
   40 NCSID = 9
      NGRIDS = 3
      MATID = NECPT(6)
      T     = ECPT(7)
      FMU   = ECPT(8)
      GO TO 80
C
   50 NCSID = 15
      NGRIDS = 3
      MATID = NECPT( 6)
      T     =  ECPT( 7)
      FMU   =  ECPT(12)
      GO TO 80
   60 NCSID = 9
      NGRIDS = 4
      MATID = NECPT(6)
      T     =  ECPT(7)
      FMU   =  ECPT(8)
      GO TO 80
   70 NCSID = 14
      NGRIDS = 4
      MATID = NECPT(7)
      T     = 0.0E0
      FMU   = ECPT(11)
C
C  30 COMPUTE PIVOT TRIANGLE AREA
C
C     FIRST SET UP THE POINTERS TO THE CSID OF THE 3 POINTS FROM THE
C     BASE CSID
C
80    DO 250 NPVT = 1,NGRIDS
      NPT1 = 0
      NPT2 = 4
      NPT3 = 8
      IF (NGRIDS .EQ. 3 )  GO TO 140
      ICHEK = 1
C     SELECT 3 POINTS FOR THE PIVOT TRIANGLE OF A QUADRILATERAL
      GO TO (110,140,130,120), NPVT
110   NPT3 = 12
      GO TO 140
120   NPT2  =  12
      GO TO 140
130   NPT1 = 12
C
  140 DO 150 I=1,3
      ISUB1 = NCSID + NPT1 + I
      ISUB2 = NCSID + NPT2 + I
      ISUB3 = NCSID + NPT3 + I
      V1(I) = ECPT(ISUB3) - ECPT(ISUB1)
  150 V2(I) = ECPT(ISUB3) - ECPT(ISUB2)
C
C     COMPUTE AREA OF QUAD OR TRI USING V1 AND V2
      AREA= 0.D0
C
  160 V1XV2(1) = V1(2) * V2(3)  -  V1(3) * V2(2)
      V1XV2(2) = V1(3) * V2(1)  -  V1(1) * V2(3)
      V1XV2(3) = V1(1) * V2(2)  -  V1(2) * V2(1)
C
      AREA = AREA + DSQRT(V1XV2(1)**2 + V1XV2(2)**2 + V1XV2(3)**2)/2.D0
C
      IF (NGRIDS .EQ. 3)  GO TO 190
      IF( ICHEK  ) 170,190,170
C
C     COMPUTE AREA OF WHOLE QUAD, FIRST SET UP V1 + V2 THEN TRA TO 600.
C
  170 IF ( NARG .NE. 1 .OR. IFLAG .NE. 1 ) GO TO 175
      ISUB1 = NCSID + NPT1 + 1
      ISUB2 = NCSID + NPT2 + 1
      ISUB3 = NCSID + NPT3 + 1
      T = PI23 * ( ECPT(ISUB1) + ECPT(ISUB2) + ECPT(ISUB3) )
  175 NPT1 = NCSID
      NPT2 = NCSID + 4
      NPT3 = NCSID + 8
      NPT4 = NCSID +12
      DO 180 I=1,3
      NPT1 = NPT1 + 1
      NPT2 = NPT2 + 1
      NPT3 = NPT3 + 1
      NPT4 = NPT4 + 1
      V1(I) = ECPT(NPT1) - ECPT(NPT3)
  180 V2(I) = ECPT(NPT2) - ECPT(NPT4)
      ICHEK = 0
C
      GO TO 160
C     ******************************************************************
C     FINAL COMPUTATION OF TERM AND SHIP OUT OF MATRIX.
C
190   CONTINUE
      IF( T ) 210,220,210
C     RHO NOT NEEDED IF T = 0
C
  210 INFLAG = 4
      IF (HEAT .EQ. 1)  GO TO 240
      CALL MAT( ECPT(1) )
      RHOD = RHO
C
C
  220 TERM =  (FMU + RHOD*T)* AREA/3.D0
      IF (NGRIDS .EQ. 4)  TERM = TERM/2.
      I1  = (NPVT-1)*3  + 1
      I2  =  I1 + 2
      DO 230  I = I1,I2
230   MASS(I) = TERM
      GO TO 250
C
C      HEAT FORMULATION
C
240   CALL HMAT(ECPT)
      CPD = CP
      MASS(NPVT) = (CPD*T)*AREA/3.D0
      IF (NGRIDS .EQ. 4)  MASS(NPVT) = MASS(NPVT) / 2.
C
250   CONTINUE
      RETURN
      END

      SUBROUTINE SMLEIG(D,O,VAL)
C
C     COMPUTES EIGENVALUES AND VECTORS FOR 1X1 AND 2X2
C
      DOUBLE PRECISION D(2),O(2),VAL(2),P,Q
      INTEGER ENTRY,XENTRY,SYSBUF,PHIA,MCB(7)
      DIMENSION VCOM(30)
C
      COMMON/SYSTEM/SYSBUF
      COMMON /GIVN / TITLE(150)
      COMMON /PACKX/IT1,IT2,II,JJ,INCR
      COMMON /UNPAKX/IT3,III,JJJ,INCR1
C
      EQUIVALENCE
     1 (MO,TITLE(2)),(MD,TITLE(3)),(ENTRY,TITLE(11)),(XENTRY,TITLE(20)),
     2 (VCOM(1),TITLE(101)),(N,VCOM(1)),(LAMA,VCOM(6)),(PHIA,VCOM(12)),
     3 (NFOUND,VCOM(10))
C
      DATA MCB/7*0/
C
C     D        ARRAY OF DIAGONALS
C     O        ARRAY OF OFF DIAGONALS
C     VAL      ARRAY OF EIGENVALUES
C     LAMA     FILE OF EIGENVALUES--HEADER,VALUES,ORDER FOUND
C     PHIA     FILE OF  VECTORS   --......,VECTORS-D.P.
C     MO       RESTART TAPE FOR MORE EIGENVALUES
C     MD       INPUT MATRIX
C     N        ORDER OF  PROBLEM
C     NFOUND   NUMBER OF EIGENVALUES/VECTOR PREVIOUSLY FOUND
C
      IBUF1 =(KORSZ(O) - SYSBUF +1 )/2  -1
C
C     OPEN INPUT MATRIX
C
      CALL GOPEN(MD,O(IBUF1),0)
C
C     SETUP FOR UNPACK
C
      IT3 = 2
      III = 1
      JJJ = N
      INCR1= 1
      ASSIGN 101 TO ITRA
      CALL UNPACK(*1000,MD,D)
  101 IF(N .EQ. 2) GO TO 110
C
C     THE MATRIX IS A 1X1
C
      O(1) = 0.0D0
      VAL(1) = D(1)
      LOC = 1
      GO TO 120
C
C     THE MATRIX IS A 2X2
C
  110 O(1) = D(2)
      O(2) = 0.0D0
      ASSIGN 111 TO ITRA
      III = 2
      CALL UNPACK(*1000,MD,D(2))
  111 P = D(1) + D(2)
      Q = DSQRT( P*P -4.0D0*(D(1)*D(2)- O(1)**2))
      VAL(1) =(P+Q)/2.0D0
      VAL(2) = (P-Q)/2.0D0
      LOC = 0
C
C     WRAP UP ROUTINE
C
  120 CALL CLOSE(MD,1)
C
C     COPY D,O,LOC ONTO MO FOR RESTART
C
      CALL GOPEN(MO,O(IBUF1),1)
C
C     SETUP FOR PACK
C
      IM1=1
      IT1=2
      IT2=2
      II =1
      JJ = N
      INCR =1
      CALL PACK(D,MO,MCB)
      CALL PACK(O,MO,MCB)
      CALL WRITE(MO,LOC,1,1)
      CALL CLOSE(MO,1)
      IF(N .NE. 1) GO TO 125
C
C     1X1 WRITE OUT VECTORS AND VALUES
C
      MCB(1) = PHIA
      MCB(2) = 0
      MCB(3) = 1
      MCB(4) = 2
      MCB(5) = 2
      MCB(6) = 0
      CALL GOPEN(PHIA,O(IBUF1),  1)
      JJ = 1
      CALL PACK(1.0D0,PHIA,MCB)
      CALL CLOSE(PHIA,1)
      CALL WRTTRL(MCB(1))
      CALL GOPEN(LAMA,O(IBUF1),1 )
      IF (NFOUND .EQ. 0) GO TO 128
      DO 126 I= 1,NFOUND
      CALL WRITE(LAMA,0.0,1,0)
  126 CONTINUE
  128 VALX = VAL(1)
      CALL WRITE(LAMA,VALX,1,1)
      IF (NFOUND .EQ. 0) GO TO 129
      DO 127 I= 1,NFOUND
      CALL WRITE(LAMA,I,1,0)
  127 CONTINUE
  129 CALL WRITE(LAMA,NFOUND+1,1,1)
      CALL CLOSE(LAMA,1)
      MCB(1) = LAMA
      CALL WRTTRL(MCB)
  125 XENTRY = -ENTRY
      RETURN
 1000 DO 1001 I =III,JJJ
      D(I) = 0.0D0
 1001 CONTINUE
      GO TO  ITRA,(111,101)
      END

      DOUBLE PRECISION FUNCTION DAPOLY(N,P)
C
C     CALCULATES AREA OF A POLYGON DESCRIBED BY N POINTS (P)
C        ( N .LE. 10 )
C
C        AREA= -1* LINE INTEGRAL OF Y*DX
C
C     AREA CONTRIBUTION FROM SIDE WHOSE ENDS ARE P(I), P(J):
C        A(I,J)= 0.5 * (Y(I)+Y(J)) * (X(I)-X(J))
C
      DOUBLE PRECISION P(2,1)
      INTEGER KEDGE(2,10), K(2,10)
C
      DATA KEDGE/ 1,2,  2,3,  3,4,  4,5,  5,6,  6,7,  7,8,  8,9,  9,10,
     1  10,1/
C
      DO 10 I=1,2
      DO 10 J=1,N
   10 K(I,J)= KEDGE(I,J)
      K(2,N)= 1
      DAPOLY= 0.0
C
      DO 20  NN= 1,N
      K1= K(1,NN)
      K2= K(2,NN)
   20 DAPOLY= DAPOLY +5.D-1 * (P(2,K1)+P(2,K2)) * (P(1,K1)-P(1,K2))
      RETURN
      END

          SUBROUTINE DSNMWR (IUNITU)
C
C         THIS SUBROUTINE IS CALLED BY ENDSYS
C
      INCLUDE 'DSIOF.COM'
      COMMON /GNDATE/ IGNDAT(2)
      WRITE (IUNITU) FCB, NUMDEV, DEV, MDSNAM, IGNDAT,MAXBLK,MAXDSK
      WRITE (IUNITU) NUMOPN, NUMCLS, NUMWRI, NUMREA
      RETURN
      END

      SUBROUTINE XSAVE
C     THE PURPOSE OF THIS ROUTINE IS TO PERFORM THE FUNCTIONS ASSIGNED
C     TO THE SAVE DMAP INSTRUCTION.
C
      COMMON/XVPS/ IVPS(1)
      COMMON/BLANK/ IPAR(1)
      COMMON /OSCENT/ IOSCR(7)
C     GET NUMBER OF PARAMETERS FROM OSCAR
      N = IOSCR(7)*2 + 6
      DO 20 I1 = 8,N,2
C     GET VPS POINTER AND POINTER TO VALUE IN BLANK COMMON.
      J = IOSCR(I1)
      K = IOSCR(I1+1)
C     GET LENGTH OF VALUE FROM VPS
      L = IVPS(J-1)
C     TRANSFER VALUE FROM BLANK COMMON TO VPS
      DO 10 I2 = 1,L
      IVPS(J) = IPAR(K)
      J = J + 1
   10 K = K + 1
   20 CONTINUE
      RETURN
      END

      SUBROUTINE FRD2C (A,B,X,SCR1,SCR2,SCR3,SCR4,SCR5,NLOAD,NFREQ)
C
C     SOLVE A X = B
C     USE INCORE DECOMP IF POSSIBLE
C
      INTEGER         A,B,X,SCR1,SCR2,SCR3,SCR4,SCR5,SYSBUF,OUT,TA(7),
     1                TB(7),TX(7)
      DIMENSION       ZZ(1)
      CHARACTER       UFM*23,UWM*25,UIM*29
      COMMON /XMSSG / UFM,UWM,UIM
      COMMON /SYSTEM/ SYSBUF,OUT,DUM(52),IPREC
      COMMON /PACKX / ITI,ITO,II,NN,INCR
      COMMON /UNPAKX/ IOUT,INN,NNN,INCR1
      COMMON /FRD2BC/ IH,IP
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE     (ZZ(1),Z(1))
C
      ICORE= KORSZ(Z)
      INCR = 1
      II   = 1
      INN  = 1
      INCR1= 1
      IOUT = 3
      IF (IH.EQ.0 .AND. IPREC.EQ.2) IOUT = 4
C
C     IH IN /FRD2BC/ IS INITIALIZED BY ROUTINE FRRD2.
C     (COMPLEX D.P. ARITHMETIC IS USED IF IH=0)
C
      ITO = IOUT
      ITI = ITO
C
C     DECIDE IF INCORE IS POSSIBLE
C
      TA(1) = A
      CALL RDTRL (TA)
      TB(1) = B
      CALL RDTRL (TB)
      NA    = TA(2)
      NB    = TB(3)*NLOAD
      IBUF1 = ICORE - SYSBUF
      NCORE = NA*NA*2 + NB*2 + NB*2 + SYSBUF
C
C     IF IH=0, COMPLEX D.P. COMPUTATION WILL BE USED.  NOTICE THAT THE
C     ROUTINE INCORE IS WRITTEN ONLY FOR COMPLEX S.P. OPERATION.
C
      IF (IH .EQ. 0) GO TO 102
      IF (NCORE .GT. ICORE) GO TO 100
C
C     DO INCORE
C
      IA = 1
      CALL GOPEN (A,Z(IBUF1),0)
      NNN = TA(3)
      INCR1 = NNN
      N = NA + NA
      DO 10 I = 1,N,2
      CALL UNPACK (*11,A,Z(I))
      GO TO 10
   11 DO 12 K = 1,N,2
      L = (K-1)*NNN
      Z(I+L  ) = 0.0
      Z(I+L+1) = 0.0
   12 CONTINUE
   10 CONTINUE
      CALL CLOSE (A,1)
C
C     GET FREQ FROM B
C
      IB   = NNN*NNN*2 + 1
      NNN  = TB(3)
      INCR1= NLOAD
      N1   = NNN + NNN
      J    = TB(2)/NLOAD - 1
      M    = 0
      CALL GOPEN (B,Z(IBUF1),0)
      CALL SKPREC (B,NFREQ-1)
      DO 30 I = 1,NLOAD
      CALL UNPACK (*31,B,Z(IB+M))
      GO TO 33
   31 DO 32 K = 1,N1,2
      L = (K-1)*NLOAD + IB + M
      Z(L  ) = 0.0
      Z(L+1) = 0.0
   32 CONTINUE
   33 IF (I .NE. NLOAD) CALL SKPREC (B,J)
      M = M+2
   30 CONTINUE
      CALL CLOSE (B,1)
      IX = NLOAD*NNN*2 + IB
      CALL INCORE (Z(IA),NA,Z(IB),Z(IX),NLOAD)
      NN = NA
      CALL GOPEN (X,Z(IBUF1),1)
      CALL MAKMCB (TX,X,NN,TB(4),ITO)
      INCR = NLOAD
      J = IX
      DO 50 I = 1,NLOAD
      CALL PACK (Z(J),X,TX)
   50 J = J + 2
      CALL CLOSE (X,1)
      CALL WRTTRL (TX)
      GO TO 1000
C
C     USE FILE SOLVE
C
  100 IF (IP .NE. 0) GO TO 102
      IP = NCORE - ICORE
      WRITE  (OUT,101) UIM,IP
  101 FORMAT (A29,' 2437, ADDITIONAL CORE NEEDED FOR IN-CORE ',
     1       'DECOMPOSITION IN FRRD2 MODULE IS',I8,' WORDS.')
  102 CALL CFACTR (A,SCR1,SCR2,SCR3,SCR4,SCR5,IOPT)
      ICORE = KORSZ(ZZ)
      IBUF1 = ICORE - SYSBUF
      IBUF2 = IBUF1 - SYSBUF
      CALL GOPEN (B,ZZ(IBUF1),0)
      CALL GOPEN (SCR3,ZZ(IBUF2),1)
      IOUT = 3
      IF (IH.EQ.0 .AND. IPREC.EQ.2) IOUT = 4
      INCR1 = 1
      J = TB(2)/NLOAD - 1
      NN = TB(3)
      CALL MAKMCB (TX,SCR3,NN,TB(4),ITO)
      CALL SKPREC (B,NFREQ-1)
      DO 110 I = 1,NLOAD
      CALL CYCT2B (B,SCR3,1,ZZ,TX)
      IF (I .NE. NLOAD) CALL SKPREC (B,J)
  110 CONTINUE
      CALL CLOSE (SCR3,1)
      CALL CLOSE (B,1)
      CALL WRTTRL (TX)
      CALL CFBSOR (SCR1,SCR2,SCR3,X,IOPT)
 1000 RETURN
      END

      INTEGER FUNCTION BUNPK (IG,I,J)
C
C     THIS ROUTINE IS USED ONLY IN BANDIT MODULE
C
C     UNPACK INTEGER GRID NO. FROM IG TABLE.   SEE BPACK FOR PACKING
C     USE APPROP. PORTION OF THIS ROUTINE FOR DIFFERENT TYPE OF MACHINE.
C
      INTEGER*2        IG(1)
C
      COMMON /BANDB /  NBIT,     DUM3B(3), IPASS,    NW,       DUM1B,
     1                 NBPW
      COMMON /BANDS /  DUM4S(4), II1,      DUM5S(5), MASK
C
      IPASS=IPASS+1
      LOC  =J-1
C
C     ********************************************
C     UNIVAC AND CDC MACHINES
C     ********************************************
C     INTEGER          RSHIFT,   ANDF
C
C     N1 =II1*(LOC/NW)+I
C     N2 =MOD(LOC,NW)*NBIT+NBIT
C     LOC=RSHIFT(IG(N1),NBPW-N2)
C     BUNPK=ANDF(LOC,MASK)
C     RETURN
C
C     ********************************************
C     IBM AND VAX MACHINES
C     (IG IS SET TO INTEGER*2 IN BPACK AND BUNPK, ELSEWHERE INTEGER*4)
C     INTEGER*2        IG(1)
C     ********************************************
C
      N1=II1*LOC+I
      BUNPK=IG(N1)
      RETURN
      END

      SUBROUTINE SDR1A (INPUT,IOUT)
C
C     THIS ROUTINE MAKES PS AND IUF COMPATABLE TO COMPUTE QS IN
C     CASE OF TRANSIENT ANALYSIS
C
      INTEGER        SYSBUF,BCD1(2),MCB(7),PS,IA(7),CORE(1100)
C
      COMMON /ZZZZZZ/ COREX(1)
      COMMON /SYSTEM/ SYSBUF,KSYSTM(65)
      COMMON /BLANK / LOADNN
      COMMON /UNPAKX/ IT1,II,JJ,INCR
      COMMON /PACKX / IT2,IT3,II1,JJ1,INCR1
      EQUIVALENCE     (CORE(1),COREX(1))
C
      DATA    BCD1  / 4HSDR1,4HA    /
C
      NZ = KORSZ(CORE) - SYSBUF
      CALL OPEN (*40,INPUT,CORE(NZ+1),0)
      CALL SKPREC (INPUT,1)
      NZ = NZ - SYSBUF
      LOADNN = MAX0(LOADNN,1)
      IF (LOADNN .EQ. 1) GO TO 50
      IA(1) = IOUT
      CALL RDTRL (IA)
      IF (IA(2) .EQ. 0) GO TO 50
      IA(1) = INPUT
      CALL RDTRL(IA)
      IF(IA(2) .EQ. 0) CALL MESAGE (-7,0,BCD1)
C
C     POSITION TO END
C
      CALL GOPEN  (IOUT,CORE(NZ+1),0)
      CALL SKPFIL (IOUT,+1)
      CALL SKPFIL (IOUT,-1)
      CALL CLOSE  (IOUT,+2)
      IA(1) = IOUT
      CALL RDTRL (IA)
      IA(7) = 0
      CALL GOPEN (IOUT,CORE(NZ+1),3)
   10 MCB(1) = INPUT
      CALL RDTRL (MCB)
      K   = MCB(2)
      IT1 = MCB(5)
      IT2 = IT1
      IT3 = IT2
      INCR  = 1
      INCR1 = 1
      DO 30 I = 1,K
      II = 0
      CALL UNPACK (*20,INPUT,CORE)
      II1 = II
      JJ1 = JJ
      CALL PACK (CORE,IOUT,IA)
      GO TO 30
   20 II1 = 1
      JJ1 = 1
      CORE(1) = 0
      CORE(2) = 0
      CORE(3) = 0
      CORE(4) = 0
      CALL PACK (CORE,IOUT,IA)
   30 CONTINUE
      CALL CLOSE (INPUT,1)
      CALL CLOSE (IOUT,1)
      CALL WRTTRL (IA)
   40 RETURN
C
C     FIRST TIME
C
   50 CALL GOPEN (IOUT,CORE(NZ+1),1)
      IA(1) = INPUT
      CALL RDTRL (IA)
      IA(2) = 0
      IA(6) = 0
      IA(7) = 0
      IA(1) = IOUT
      GO TO 10
C
C     SDR1D -
C
      ENTRY SDR1D (PS,IUF,IUF1,ITRAN)
C     ===============================
C
      IF (ITRAN .EQ. 0) GO TO 60
      ITRAN  = 1
      MCB(1) = PS
      CALL RDTRL (MCB)
      IF (MCB(1) .LE. 0) GO TO 100
      NCOLPS = MCB(2)
      MCB(1) = IUF
      CALL RDTRL (MCB)
      IF (NCOLPS .EQ. MCB(2)) RETURN
C
C     THIS IS A TRANSIENT PROBLEM
      ITRAN = 0
C
   60 MCB(1) = IUF
      CALL RDTRL (MCB)
      NCOLPS = MCB(2)/3
      IBF = KORSZ(CORE) - SYSBUF
      CALL GOPEN (IUF,CORE(IBF),0)
      IBF1 = IBF - SYSBUF
      CALL GOPEN (IUF1,CORE(IBF1),1)
      IT1  = MCB(5)
      IT2  = IT1
      IT3  = IT2
      INCR = 1
      INCR1  = 1
      MCB(1) = IUF1
      MCB(2) = 0
      MCB(6) = 0
      MCB(7) = 0
      DO 90 I = 1,NCOLPS
      II  = 0
      CALL UNPACK (*70,IUF,CORE)
      II1 = II
      JJ1 = JJ
      GO TO 80
   70 CORE(1) = 0
      CORE(2) = 0
      CORE(3) = 0
      CORE(4) = 0
      II1 = 1
      JJ1 = 1
   80 CALL SKPREC (IUF,2)
      CALL PACK (CORE,IUF1,MCB)
   90 CONTINUE
      CALL CLOSE (IUF1,1)
      CALL CLOSE (IUF,1)
      CALL WRTTRL (MCB)
  100 RETURN
      END

        SUBROUTINE DSGNRD
      INCLUDE 'XNSTRN.COM'
      INCLUDE 'DSIOF.COM'
      INCLUDE 'GINOX.COM'
        CHARACTER*4     CBUFF(2)
        EQUIVALENCE     (CBUFF,IBASE)
        IDSN   =  MDSFCB( 2, IFILEX )
        IDSNR  = IDSN
   10   ISTRB  = FCB( 5, IDSNR )
        IF ( NBLOCK .GE. ISTRB ) GO TO 20
        IDSNR  = MDSFCB( 3, IDSNR ) / MULQ2
        GO TO 30
   20   IEND   = FCB( 6, IDSNR )
        IF ( NBLOCK .LE. IEND ) GO TO 40
        IDSNR  = IAND( MDSFCB( 3, IDSNR  ), MASKH2 )
   30   IF ( IDSNR .GE. 1 .AND. IDSNR .LE. MAXDSN ) GO TO 10
        CALL DSMSG( 121 )
   40   IF ( IDSN .EQ. IDSNR ) GO TO 50
        CALL DSCLOS( IDSN )
        MDSFCB( 1,IDSN ) = IAND( MDSFCB( 1,IDSN ), MASKH1 )
        IDSN   = IDSNR
        MDSFCB( 1, IDSN )   = IOR ( MDSFCB( 1,IDSN ), MASKH2 )
        MDSFCB( 2, IFILEX ) = IDSN
        ISAVE = IOP
        IOP = 0
        CALL DSOPEN( MDSNAM(IDSN), IDSN, IOP )
        IOP = ISAVE
        CBUFF( INDBAS ) = MDSNAM( IDSN )
   50   IOBLK  = NBLOCK - ISTRB + 1
        CALL DSREAD( IDSN, IBASE(INDBAS+3), NBUFF, IOBLK )
        RETURN
        END

      SUBROUTINE ALG25 (IX,LX,LOG1,X,Y1)
C
      REAL        LINE
      DIMENSION   X(1),Y1(1),SYMBOL(1),LINE(121),XNUM(13)
      DATA SYMBOL/1H*/, DASH/1H-/, CROSS/1H+/, BLANK/1H /, XI/1HI/
C
      YMIN = Y1(1)
      YMAX = YMIN
      DO 200 I = 1,IX
      IF (Y1(I) .LT. YMIN) YMIN = Y1(I)
      IF (Y1(I) .GT. YMAX) YMAX = Y1(I)
200   CONTINUE
      IF (YMIN .EQ. YMAX) GO TO 900
      YH   = YMAX + (YMAX-YMIN)/18.0
      YL   = YMIN - (YMAX-YMIN)/18.0
      XH   = 60.0
      IF (LX .GT. 59) XH = FLOAT(LX) + 1.0
      XL   = XH - 60.0
      XMAX = ABS(XH)
      XMIN = ABS(XL)
      YMIN = ABS(YL)
      YMAX = ABS(YH)
      IF (XMIN .GT. XMAX) XMAX = XMIN
      IF (YMIN .GT. YMAX) YMAX = YMIN
      XMAX = ALOG10(XMAX)
      YMAX = ALOG10(YMAX)
      IF (XMAX .LT. 0.0) XMAX = XMAX - 1.0
      IF (YMAX .LT. 0.0) YMAX = YMAX - 1.0
      MX   = -XMAX
      MY   = -YMAX
      WRITE (LOG1,250) MX,MY
250   FORMAT (20X,46HSCALES - 'X' IS SHOWN TIMES 10 TO THE POWER OF,I3,
     1        40H   'Y' IS SHOWN TIMES 10 TO THE POWER OF,I3,/)
      YINC  = (YH-YL)/54.0
      YINC2 = YINC/2.0
      XRANGE= XH - XL
      DO 750 KLINE = 1,55
      IF (KLINE.EQ.1 .OR. KLINE.EQ.55) GO TO 350
      DO 265 L = 2,120
265   LINE(L) = BLANK
      IF (KLINE.EQ. 7 .OR. KLINE.EQ.13 .OR. KLINE.EQ.19 .OR.
     1    KLINE.EQ.25 .OR. KLINE.EQ.31 .OR. KLINE.EQ.37 .OR.
     2    KLINE.EQ.43 .OR. KLINE.EQ.49) GO TO 300
      LINE(  1) = XI
      LINE(121) = XI
      GO TO 400
300   LINE(  1) = DASH
      LINE(121) = DASH
      GO TO 400
350   DO 360 L = 2,120
360   LINE(L) = DASH
      LINE(1) = CROSS
      LINE(121) = CROSS
      DO 365 L = 11,111,10
365   LINE(L) = XI
      GO TO 650
400   DO 600 I = 1,IX
      IF (Y1(I).GT.YH+YINC2 .OR. Y1(I).LE.YH-YINC2) GO TO 600
      L = (X(I)-XL)/XRANGE*120.0 + 1.5
      LINE(L) = SYMBOL( 1)
600   CONTINUE
      IF (KLINE.EQ. 1 .OR. KLINE.EQ. 7 .OR. KLINE.EQ.13 .OR.
     1    KLINE.EQ.19 .OR. KLINE.EQ.25 .OR. KLINE.EQ.31 .OR.
     2    KLINE.EQ.37 .OR. KLINE.EQ.43 .OR. KLINE.EQ.49 .OR.
     3    KLINE.EQ.55) GO TO 650
      WRITE  (LOG1,610) LINE
610   FORMAT (8X,121A1)
      GO TO 750
650   YNUM = YH*10.0**MY
      WRITE  (LOG1,655) YNUM,LINE
655   FORMAT (1X,F6.3,1X,121A1)
750   YH   = YH - YINC
      XNUM(1) = XL*10.0**MX
      XINC = ((XH-XL)/12.0)*10.0**MX
      DO 800 I = 2,13
800   XNUM(I) = XNUM(I-1) + XINC
      WRITE  (LOG1,820) XNUM
820   FORMAT (6X,12(F6.3,4X),F6.3)
      RETURN
C
900   WRITE  (LOG1,910)
910   FORMAT (//35X,54HNO PLOT HAS BEEN MADE BECAUSE 'X' OR 'Y' RANGE IS
     1 ZERO)
      RETURN
      END

      SUBROUTINE TRMEMD
C
C     THIS SUBROUTINE CALCULATES THE STIFFNESS AND MASS MATRICES FOR
C     THE  TRIANGULAR MEMBRANE ELEMENT.  CALCULATIONS ARE PERFORMED
C     PRIMARILY BY SUBROUTINES EKTRMS AND EMASTQ.
C     DOUBLE PRECISION VERSION
C
C     ECPT FOR THE TRMEM ELEMENT
C***********************************************************************
C INDEX   DESCRIPTION                                       TYPE
C *****   ***********                                       ****
C   1     ELEMENT ID                                         I
C   2-4   GRID POINTS A,B,AND C                              I
C   5     THETA = ANGLE OF MATERIAL                          R
C   6     MATERIAL ID                                        I
C   7     T                                                  R
C   8     NON-STRUCTURAL MASS                                R
C   9     COORDINATE SYSTEM ID 1                             I
C 10-12   X1,Y1,Z1                                           R
C  13     COORDINATE SYSTEM ID 2                             I
C 14-16   X2,Y2,Z2                                           R
C  17     COORDINATE SYSTEM ID 3                             I
C 18-20   X3,Y3,Z3                                           R
C  21     ELEMENT TEMPERATURE                                R
C***********************************************************************
      DOUBLE PRECISION  K,KOUT,M(9),MOUT(9),KSAVE
     1,                 A,PROD9,TEMP9,XSUB,BFACT,E
      LOGICAL NOGO,HEAT
      INTEGER ELID,ESTID, DICT(10), IPART(3), NECPT(50), NGRID(3)
C
      COMMON /SYSTEM /  KSYSTM (60)
      COMMON /EMGPRM / DM(15),ISMB(3),IPREC,NOGO,HEAT,ICMBAR
      COMMON /EMGDIC /  QQ(3), ELID, ESTID
      COMMON /EMGEST /  ECPT(50)
      COMMON /EMGTRX /  A(225),PROD9(9),TEMP9(9),XSUB(3),BFACT,
     X                  E(18), K(324), KOUT(324),KSAVE(81)
C
      EQUIVALENCE   (ECPT(1),NECPT(1),IELID), (DICT5,DICT(5))
      EQUIVALENCE   (K(1),M(1)),(KOUT(1),MOUT(1)),(KSYSTM(2),IOUTPT)
      EQUIVALENCE   (KSYSTM(56), IHEAT), (ECPT(2), NGRID(1))
C
      DATA  IPART / 1,2, 3/
C
C
C
      IP = IPREC
      DICT(1) = ESTID
C
C     CREATE AN ARRAY POINTING TO GRID POINTS IN INCREASING ORDER
C
  100 DO 140 I=1,2
      IP1 = I+1
      II =  IPART(I)
      DO 120  J=IP1,3
      JJ = IPART(J)
      IF (NGRID(II).LE. NGRID(JJ)) GOTO 120
      IPART(I) =JJ
      IPART(J) =II
      II = JJ
      GO TO 100
  120 CONTINUE
  140 CONTINUE
C
C     IF STIFFNESS MATRIX IS REQUESTED CALL EKTRMS. OTHERWISE GO TO
C     MASS MATRIX CALCULATION SECTION
C
      IF (ISMB(1) .EQ. 0 ) GO TO  300
C
      CALL EKTRMD (0)
C
      IF (NOGO) RETURN
C
C     RE-ORDER  THE STIFFNESS MATRIX BY INCREASING SIL VALUE
C
      IF (HEAT) GO TO 200
      DO 190 I=1,3
      II = IPART(I)
      DO 180 J=1,3
      JJ = IPART(J)
      DO 170 KA=1,3
      DO 160 L=1,3
      ISAVE = (II-1)*27 + (JJ-1) *9 + (KA-1)*3  + L
      IOUT = (I-1)*27 + (J-1)*3  +  (KA-1)*9  + L
  160 K(IOUT)=KSAVE(ISAVE)
  170 CONTINUE
  180 CONTINUE
  190 CONTINUE
C    OUTPUT THE MATRIX
      DICT(2)=1
      DICT(3)=9
      DICT(4)=7
C
      CALL EMGOUT(K,K,81,1,DICT,1,IP)
      GO TO 300
C
C     OUTPUT HEAT MATRIX HERE
C
  200 DO 260 I=1,3
      DO 240 J=1,3
      IOUT = (I-1)* 3+ J
      IK  =  (IPART(I)-1)* 3 + IPART(J)
  240 K(IOUT)=KSAVE(IK)
  260 CONTINUE
C     OUTPUT   HEAT  K
      DICT(2) = 1
      DICT(3) = 3
      DICT(4) = 1
C
      CALL EMGOUT (K,K,9,1,DICT,1,IP)
C
C     PERFORM MASS MATRIX CALCULATIONS HERE
C
  300 IF (ISMB(2)  .EQ.0) RETURN
C
C     CONVENTIONAL MASS MATRIX
C
      CALL EMADTQ (4,M)
C     REORDER THE MASS MATRIX
      IF (HEAT) GO TO 350
      DO 340 I=1,3
      II = (I-1)*3
      IJ = IPART(I)
      JJ = (IJ-1)*3
      DO  320 J=1,3
      IOUT = II + J
      IK = JJ + J
  320 MOUT(IOUT) =  M(IK)
  340 CONTINUE
C
      DICT(2) =2
      DICT(3) = 9
      DICT(4) = 7
C
      CALL EMGOUT (MOUT, MOUT, 9,1,DICT,2,IP)
      RETURN
C
C     HEAT FORMULATION
C
  350 DO 360 I=1,3
      J=IPART(I)
  360 MOUT(I)=M(J)
      DICT(2)=2
      DICT(3)=3
      DICT(4)=1
C
      CALL EMGOUT(MOUT,MOUT,3,1,DICT,2,IP)
      RETURN
C
      END

      SUBROUTINE STRSL2 (TI)
C
C     PHASE II OF STRESS DATA RECOVERY
C
      LOGICAL         FLAG
      INTEGER         TLOADS
      REAL            TI(6),SDELTA(3)
      DIMENSION       REALI(4),NSIL(6),STR(18),NPH1OU(990),SI(36),
     1                STOUT(68)
      COMMON /ZZZZZZ/ Z(1)
      COMMON /SDR2X4/ DUMMY(35),IVEC,IVECN,LDTEMP,DEFORM,DUM8(8),
     1                TLOADS,MAXSIZ
      COMMON /SDR2X7/ PH1OUT(1200),FORVEC(24)
      COMMON /SDR2X8/ TEMP,DELTA,NPOINT,IJ1,IJ2,NPT1,VEC(5),TEM,
     1                Z1 OVR I,Z2 OVR I,STRESS(18)
      EQUIVALENCE     (NSIL(1),PH1OUT(2)),(NPH1OU(1),PH1OUT(1)),
     1                (SI(1),PH1OUT(22)),(LDTEMP,FTEMP),(F1,N1)
C
C     PHASE I OUTPUT FROM THE PLATE IS THE FOLLOWING
C
C     PH1OUT(1)                        ELEMENT ID
C     PH1OUT(2 THRU 7)                 6 SILS
C     PH1OUT(8 THRU 10)                TMEM1,TMEM3,TMEM5
C     PH1OUT(11 THRU 13) (14)-(21)     Z1 AND Z2  TBEND1,TBEND3,TBEND5
C     PH1OUT (22 THRU 741)             4 S SUB I MATRICES,EACH 6X5X6 ARR
C     PH1OUT (742-753)                 4 - 3X3 S SUB T MATRICES
C
C     PHASE 1 OUTPUT FROM THE MEMBRANE IS THE FOLLOWING
C
C     PH1OUT(754)             ELEMENT ID
C     PH1OUT(755-760)         6 SILS
C     PH1OUT(761)             T SUB 0
C     PH1OUT(762-1193)        4 SETS OF 6 NOS. 3 X 6 S SUB I
C     PH1OUT(1194-1196)       S SUB T MATRIX
C
C     THE ABOVE ELEMENTS ARE COMPOSED OF PLATES AND MEMBRANES...
C     SOME MAY ONLY CONTAIN PLATES WHILE OTHERS MAY ONLY CONTAIN
C     MEMBRANES.
C     A CHECK FOR A ZERO FIRST SIL IN THE PHASE I OUTPUT, WHICH
C     INDICATES WHETHER ONE OR THE OTHER HAS BEEN OMITTED, IS MADE BELOW
C
C     FIRST GET FORCE VECTOR FOR THE PLATE CONSIDERATION
C
C     M ,  M ,  M ,  V ,  V    FOR ALL SIX GRID POINTS
C      X   Y   XY   X   Y
C                                NPTS
C     THE 5X1 FORCE VECTOR = SUMMATION  (S )(U )   FOR EACH POINT
C                                I=1       I   I
C
C     ZERO FORVEC STORAGE
C
      NPTS = 6
      DO 15 I = 1,24
   15 FORVEC( I) = 0.0
      FORVEC( 1) = PH1OUT(1)
      FORVEC( 7) = PH1OUT(1)
      FORVEC(13) = PH1OUT(1)
      FORVEC(19) = PH1OUT(1)
      II = 0
   17 II = II+1
      IF (II .GT. 4) GO TO 155
C
C     ZERO OUT LOCAL STRESSES
C
      SIG X  1 = 0.0
      SIG Y  1 = 0.0
      SIG XY 1 = 0.0
      SIG X  2 = 0.0
      SIG Y  2 = 0.0
      SIG XY 2 = 0.0
C
      IF (NSIL(1) .EQ. 0) GO TO 30
C
C     FORM SUMMATION
C
      DO 20 I = 1,6
C
C     POINTER TO DISPLACEMENT VECTOR IN VARIABLE CORE
C
      NPOINT = IVEC + NSIL(I) - 1
C
      II1 = (II-1)*180 + 30*I - 29
      CALL GMMATS (SI(II1),5,6,0, Z(NPOINT),6,1,0, VEC(1))
C
      DO 10 J = 2,6
      IJ = (II-1)*6 + J
   10 FORVEC(IJ) = FORVEC(IJ) + VEC(J-1)
   20 CONTINUE
C
      IF (TLOADS .EQ. 0) GO TO 23
      JST  = 741 + (II-1)*3
      I1   = (II-1)*6
      FLAG = .FALSE.
      F1   = TI(6)
      IF (N1 .EQ. 1) GO TO 22
      FORVEC(I1+2) = FORVEC(I1+2) - TI(2)
      FORVEC(I1+3) = FORVEC(I1+3) - TI(3)
      FORVEC(I1+4) = FORVEC(I1+4) - TI(4)
      IF (TI(5).EQ.0.0 .AND. TI(6).EQ.0.0) FLAG = .TRUE.
      GO TO 23
   22 FORVEC(I1+2) = FORVEC(I1+2) + TI(2)*PH1OUT(JST+1)
      FORVEC(I1+3) = FORVEC(I1+3) + TI(2)*PH1OUT(JST+2)
      FORVEC(I1+4) = FORVEC(I1+4) + TI(2)*PH1OUT(JST+3)
      IF (TI(3).EQ.0.0 .AND. TI(4).EQ.0.0) FLAG = .TRUE.
   23 CONTINUE
C
C     FORCE VECTOR IS NOW COMPLETE
C
      IF (II .EQ. 4) GO TO 24
      I1 = 13 + 2*II - 1
      I2 = I1 + 1
      Z1 OVR I = -12.0*PH1OUT(I1)/PH1OUT(10+II)**3
      Z2 OVR I = -12.0*PH1OUT(I2)/PH1OUT(10+II)**3
      GO TO 25
   24 Z1 OVR I = -1.5/PH1OUT(20)**2
      Z2 OVR I = -Z1 OVR I
   25 CONTINUE
      II1 = (II-1)*6
C
      K1  = 0
      ASSIGN 26 TO IRETRN
      GO TO 170
C
   26 SIG X  1 = FORVEC(II1+2)*Z1 OVR I-SDELTA(1)
      SIG Y  1 = FORVEC(II1+3)*Z1 OVR I-SDELTA(2)
      SIG XY 1 = FORVEC(II1+4)*Z1 OVR I-SDELTA(3)
C
      K1 = 1
      ASSIGN 27 TO IRETRN
      GO TO 170
C
   27 SIG X  2 = FORVEC(II1+2)*Z2 OVR I-SDELTA(1)
      SIG Y  2 = FORVEC(II1+3)*Z2 OVR I-SDELTA(2)
      SIG XY 2 = FORVEC(II1+4)*Z2 OVR I-SDELTA(3)
C
      GO TO 40
   30 Z1 = 0.0
      Z2 = 0.0
C
   40 IF (NPH1OU(754) .EQ. 0) GO TO 90
C
C     ZERO STRESS VECTOR STORAGE
C
      DO 42 I = 1,3
   42 STRESS(I) = 0.0
C
C                            I=NPTS
C        STRESS VECTOR = (  SUMMATION(S )(U )  ) - (S )(LDTEMP - T )
C                            I=1       I   I         T            0
C
      DO 60 I = 1,6
C
C     POINTER TO I-TH SIL IN PH1OUT
C     POINTER TO DISPLACEMENT VECTOR IN VARIABLE CORE
C     POINTER TO S SUB I 3X3
C
      NPOINT = 754 + I
      NPOINT = IVEC + NPH1OU(NPOINT) - 1
      NPT1=762+(I-1)*18+(II-1)*108
      CALL GMMATS (PH1OUT(NPT1),3,6,0, Z(NPOINT),6,1,0, VEC(1))
C
      DO 50 J = 1,3
   50 STRESS(J) = STRESS(J) + VEC(J)
C
   60 CONTINUE
C
      IF (LDTEMP .EQ. -1) GO TO 80
C
C     POINTER TO T SUB 0 = 761
C
      TEM = FTEMP - PH1OUT(761)
      DO 70 I = 1,3
      NPOINT = 1193 + I
   70 STRESS(I) = STRESS(I) - PH1OUT(NPOINT)*TEM
C
C     ADD MEMBRANE STRESSES TO PLATE STRESSES
C
   80 SIG X  1 = SIG X  1 + STRESS(1)
      SIG Y  1 = SIG Y  1 + STRESS(2)
      SIG XY 1 = SIG XY 1 + STRESS(3)
      SIG X  2 = SIG X  2 + STRESS(1)
      SIG Y  2 = SIG Y  2 + STRESS(2)
      SIG XY 2 = SIG XY 2 + STRESS(3)
C
C     STRESS OUTPUT VECTOR IS THE FOLLOWING
C
C      1) ELEMENT ID
C      2) Z1 = FIBER DISTANCE 1
C      3) SIG X  1
C      4) SIG Y  1
C      5) SIG XY 1
C      6) ANGLE OF ZERO SHEAR AT Z1
C      7) SIG P1 AT Z1
C      8) SIG P2 AT Z1
C      9) TAU MAX = MAXIMUM SHEAR STRESS AT Z1
C     10) ELEMENT ID
C     11) Z2 = FIBER DISTANCE 2
C     12) SIG X  2
C     13) SIG Y  2
C     14) SIG XY 2
C     15) ANGLE OF ZERO SHEAR AT Z2
C     16) SIG P1 AT Z2
C     17) SIG P2 AT Z2
C     S7) SIG P2 AT Z2
C     18) TAU MAX = MAXIMUM SHEAR STRESS AT Z2
C
   90 IF (NPH1OU(755).EQ.0 .AND. NPH1OU(2).EQ.0) GO TO 120
C
C     COMPUTE PRINCIPAL STRESSES
C
      STR( 1) = PH1OUT(1)
      STR( 2) = PH1OUT(II*2+12)
      STR( 3) = SIG X 1
      STR( 4) = SIG Y 1
      STR( 5) = SIG XY 1
      STR(10) = PH1OUT(1)
      STR(11) = PH1OUT(II*2+13)
      STR(12) = SIG X  2
      STR(13) = SIG Y  2
      STR(14) = SIG XY 2
C
      DO 110 I = 3,12,9
      TEMP     = STR(I) - STR(I+1)
      STR(I+6) = SQRT((TEMP/2.0)**2+STR(I+2)**2)
      DELTA    = (STR(I)+STR(I+1))/2.0
      STR(I+4) = DELTA + STR(I+6)
      STR(I+5) = DELTA - STR(I+6)
      DELTA    = 2.0*STR(I+2)
      IF (ABS(DELTA).LT.1.0E-15 .AND. ABS(TEMP).LT.1.0E-15) GO TO 100
      STR(I+3) = ATAN2(DELTA,TEMP)*28.6478898
      GO TO 110
  100 STR(I+3) = 0.0
  110 CONTINUE
      GO TO 140
  120 DO 130 I = 2,18
  130 STR( I) = 0.0
  140 STR( 1) = PH1OUT(1)
      STR(10) = PH1OUT(1)
C
C     ADDITION TO ELIMINATE 2ND ELEMENT ID IN OUTPUT
C
      IJK = (II-1)*17
      STOUT(IJK+1) = PH1OUT(1)
      DO 149 I = 2,9
  149 STOUT(IJK+I) = STR(I)
      DO 150 I = 10,17
  150 STOUT (IJK+I) = STR(I+1)
      GO TO 17
  155 CONTINUE
C
      DO 156 I = 1,17
  156 PH1OUT(100+I) = STOUT(I)
      DO 159 J = 1,3
      DO 159 I = 1,16
      J1 = 117 + (J-1)*16 + I
      J2 = (J-1)*17 + I + 18
      PH1OUT(J1) = STOUT(J2)
  159 CONTINUE
      DO 157 I = 1,6
  157 PH1OUT(200+I) = FORVEC(I)
      DO 158 I = 1,5
      PH1OUT(206+I) = FORVEC(I+ 7)
  158 PH1OUT(211+I) = FORVEC(I+13)
      RETURN
C
C     INTERNAL SUBROUTINE
C
  170 IF (TLOADS.EQ.0 .OR. FLAG) GO TO 200
      JST = 741 + (II-1)*3
      REALI(1) = PH1OUT(11)**3/12.0
      REALI(2) = PH1OUT(12)**3/12.0
      REALI(3) = PH1OUT(13)**3/12.0
      REALI(4) = PH1OUT(20)**3/1.50
      IF (N1 .EQ. 1) GO TO 190
      FF = TI(K1+5) - TI(1)
      IF (ABS(PH1OUT(K1+12+2*II)) .LE. 1.0E-07) GO TO 200
      SDELTA(1) = (PH1OUT(JST+1)*FF +TI(2)*PH1OUT(K1+12+2*II))/REALI(II)
      SDELTA(2) = (PH1OUT(JST+2)*FF +TI(3)*PH1OUT(K1+12+2*II))/REALI(II)
      SDELTA(3) = (PH1OUT(JST+3)*FF +TI(4)*PH1OUT(K1+2*II+12))/REALI(II)
      GO TO 210
  190 CONTINUE
      IF (ABS(PH1OUT(K1+12+2*II)) .LE. 1.0E-07) GO TO 200
      FF = (TI(K1+3) - PH1OUT(K1+12+2*II)*TI(2) - TI(1))/REALI(II)
      SDELTA(1) = PH1OUT(JST+1)*FF
      SDELTA(2) = PH1OUT(JST+2)*FF
      SDELTA(3) = PH1OUT(JST+3)*FF
      GO TO 210
  200 SDELTA(1) = 0.0
      SDELTA(2) = 0.0
      SDELTA(3) = 0.0
  210 GO TO IRETRN, (26,27)
      END

      SUBROUTINE MCONE
C
C     MASS MATRIX GENERATION FOR AXIS-SYMETRIC CONICAL SHELL ELEMENT
C
C     ECPT( 1) = ELEMENT ID             INTEGER        ECT
C     ECPT( 2) = SIL PT A               INTEGER        ECT
C     ECPT( 3) = SIL PT B B             INTEGER        ECT
C     ECPT( 4) = MATID 1                INTEGER        EPT
C     ECPT( 5) = T   (MEMBRANE THICK)   REAL           EPT
C     ECPT( 6) = MATID 2                INTEGER        EPT
C     ECPT( 7) = I   (MOM.OF INERTIA)   REAL           EPT
C     ECPT( 8) = MATID 3                INTEGER        EPT
C     ECPT( 9) = TS  (SHEAR THICKNESS)  REAL           EPT
C     ECPT(10) = NON-STRUCTURAL-MASS    REAL           EPT
C     ECPT(11) = Z1                     REAL           EPT
C     ECPT(12) = Z2                     REAL           EPT
C     ECPT(13) = PHI  1                 REAL           EPT
C     ECPT(14) = PHI  2                 REAL           EPT
C     ECPT(15) = PHI  3                 REAL           EPT
C     ECPT(16) = PHI  4                 REAL           EPT
C     ECPT(17) = PHI  5                 REAL           EPT
C     ECPT(18) = PHI  6                 REAL           EPT
C     ECPT(19) = PHI  7                 REAL           EPT
C     ECPT(20) = PHI  8                 REAL           EPT
C     ECPT(21) = PHI  9                 REAL           EPT
C     ECPT(22) = PHI 10                 REAL           EPT
C     ECPT(23) = PHI 11                 REAL           EPT
C     ECPT(24) = PHI 12                 REAL           EPT
C     ECPT(25) = PHI 13                 REAL           EPT
C     ECPT(26) = PHI 14                 REAL           EPT
C     ECPT(27) = COORD. SYS. ID PT.1    INTEGER        BGPDT
C     ECPT(28) = RADIUS PT. 1           REAL           BGPDT
C     ECPT(29) = DISTANCE TO PT.1       REAL           BGPDT
C     ECPT(30) = NULL                   REAL           BGPDT
C     ECPT(31) = COORD. SYS. ID PT.2    INTEGER        BGPDT
C     ECPT(32) = RADIUS PT 2            REAL           BGPDT
C     ECPT(33) = DISTANCE TO PT. 2      REAL           BGPDT
C     ECPT(34) = NULL                   REAL           BGPDT
C     ECPT(35) = ELEMENT TEMPERATURE    REAL           GEOM3
C
      INTEGER          NECPT(100)
      REAL             L,MU
      DOUBLE PRECISION MASS
      COMMON /CONDAS/  PI, TWOPI, RADEG, DEGRA, S4PISQ
      COMMON /MATIN /  MATID, INFLAG, ELTEMP
      COMMON /MATOUT/  RHO
      COMMON /SMA2ET/  ECPT(100)
      COMMON /SMA2IO/  DUM4(10), IFMGG, DUM5(25)
      COMMON /SMA2CL/  DUM3(2),NPVT
      COMMON /SMA2DP/  MASS(36), TEMP, L, TERM, M1
      EQUIVALENCE      (RA,ECPT(28)), (RB,ECPT(32)), (ZA,ECPT(29)),
     1                 (ZB,ECPT(33)), (T,ECPT(5))  , (MU,ECPT(10)),
     2                 (NECPT(1),ECPT(1))
C
      L = SQRT((RB-RA)**2 + (ZB-ZA)**2)
C
C     NEXT LINE WAS REMOVED BY M.H./NAVY. ERROR FOR CONICAL SHELL MASS
C
C
      TEMP = RB/6.0 + RA/3.0
C
      IF (T) 30,40,30
   30 INFLAG = 4
      MATID  = NECPT(4)
      ELTEMP = ECPT(35)
      CALL MAT (NECPT(1))
   40 DO 50 I = 1,36
   50 MASS(I) = 0.0D0
      TERM = PI*L*TEMP*(RHO*T + MU)
      IF (NECPT(1)-(NECPT(1)/1000)*1000-1 .EQ. 0) TERM = TERM*2.0
      MASS( 1) = TERM
      MASS( 8) = TERM
      MASS(15) = TERM
      M1 = -1
      CALL SMA2B (MASS(1),NPVT,M1,IFMGG,0.0D0)
      RETURN
      END

      SUBROUTINE COMBO (CDATA,NX,EXTRA,NNAM,NAME,NN,VAR,IER)
C
C     THIS ROUTINE  PROCESSES THE  COMBINE INPUT.
C        THE  INPUT/ OUTPUTS  ARE
C
C                  CDATA  -  XRCARD  IMAGE OF  COMBINE CARD  (IN)
C                  NX     -  NUMBER OF EXTRAS                (IN)
C                  EXTRA  -  3 BY NX ARRAY OF EXTRAS         (IN)
C                  NNAM   -  NUMBER OF CURRENT SUBS NAMES (IN/OUT)
C                  NAMES  -  ARRAY OF  CURRENT SUBS NAMES (IN/OUT)
C                  NN     -  NUMBER OF SUBS TO BE COMBINED  (OUT)
C                  VAR    -  3 BY NVAR ARRAY OF VARIABLES   (OUT)
C                            ARRANGED AS- KEY WORD + 2 DATA WORDS
C
C
C
C
      EXTERNAL RSHIFT   ,COMPLF
C
      INTEGER  CDATA(5) ,EXTRA(3,1)    ,NAME(2,1) ,VAR( 3,2)
      INTEGER  RSHIFT   ,COMPLF        ,EQSN
C
      DIMENSION   INUM(7)   ,NUMBS(7) ,MOPT(3)   ,MSORT(3)  ,NAI(7)
C
      DATA   INUM   / 4HN1  , 4HN2  ,4HN3  ,4HN4  ,4HN5  ,4HN6  ,4HN7  /
      DATA   LPRN,    NOPT,   NSORT, MOPT                ,MSORT        /
     1       4H(    , 4HOPTS, 4HSORT,4HAUTO,4HMAN ,4HREST,4HX   ,4HY   ,
     2       4HZ    /
      DATA   MANU   / 4HMANU/
      DATA   NNO    / 4HNAME/ ,NNC /4HNAMC/, NAMS /4HNAMS/
      DATA   NAI    / 4HNA1 ,4HNA2 ,4HNA3  ,4HNA4 ,4HNA5 ,4HNA6 ,4HNA7 /
      DATA   NCNO   / 4HNCNO/
      DATA   EQSN   / 4H=   /
C
C
      LWORD  =  RSHIFT( COMPLF(0),1)
      IER    = 0
C     COMBINE OPERATION
C         PROCESS PRIMARY CARD -COMBINE( OPTS,SORT) = NAME1,NAME2, ETC
C     SET DEFAULTS
      DO 1210 I =1,150
 1210 VAR(I,1) = 0
      JNAM = 6
      VAR(1,1) = NOPT
      VAR(2,1) = MOPT(1)
      VAR(1,2) = NSORT
      VAR(2,2) = MSORT(1)
      IF( CDATA(5) .NE. LPRN) GO TO 1220
      K = 6
C
C     PROCESS  AUTO/MAN  OR XYZ
C
 1211 DO 1215 I =1,3
      IF (  CDATA(K) .NE. MOPT(I)) GO TO 1212
      VAR(2,1) = MOPT(I)
      GO TO 1216
 1212 IF ( CDATA(K) .NE. MANU) GO TO  1213
      VAR(2,1) = MOPT(2)
      GO TO 1216
 1213 IF (  CDATA(K) .NE. MSORT(I)) GO TO 1215
      VAR(2,2) = MSORT(I)
      GO TO 1216
 1215 CONTINUE
C     NOT VALID    ASSUME EQ SIGN OR NAME
C
      GO TO 1222
 1216 K  = K+2
      GO TO 1211
C
C     NO  OPTION
 1220 K = 4
C
C     CHECK FOR  EQ SIGN
 1222 IF ( CDATA( K+1) .EQ. EQSN)  K =K+2
C
C     PROCESS NAMES
      NN = 0
      DO 1235 I = 1,7
      KN = K + 2*I -2
      IF ( CDATA( KN) .EQ. LWORD) GO TO 1236
C
      VAR(1,I+2) = NAMS
      VAR(2,I+2) = CDATA(KN)
      VAR(3,I+2) = CDATA(KN+1)
C
C     FIND STRUCTURE NUMBER
      IF ( NNAM .EQ. 0 ) GO TO 1231
      DO 1230 J =1, NNAM
      IF ( CDATA(KN) .NE. NAME(1,J) .OR. CDATA(KN+1).NE.NAME(2,J))
     1     GO TO 1230
      NUMBS(I) = J
      GO TO 1232
 1230 CONTINUE
C
C     NEW NAME
C
 1231 NNAM  = NNAM +1
      NUMBS(I) = NNAM
      NAME(1,NNAM) = CDATA(KN)
      NAME(2,NNAM) = CDATA(KN+1)
 1232 NN= NN+1
 1235 CONTINUE
C
C
C     MOVE  EXTRAS INTO PLACE  CHANGE NAME TO NAMC
 1236 IC = 0
      DO 1240  J = 1,NX
      IX  = J +3*NN  +2
      IF ( EXTRA(1,J) .NE. NNO ) GO TO 1238
      EXTRA(1,J) = NNC
      IC = IX
 1238 DO 1240 K = 1,3
      VAR( K,IX) = EXTRA(K,J)
 1240 CONTINUE
C
C     SET  STRUCTURE NUMBER KEYS
C
      IF( NN .EQ. 0) GO TO 1248
C
      DO 1245  I = 1, NN
C
      IX =  I + NN  +2
      VAR(1,IX) = INUM(I)
      VAR(2,IX) = -1
      VAR(3,IX) = NUMBS(I)
      IY = IX+NN
      VAR(1,IY) = NAI(I)
      VAR(2,IY) = VAR(2,I+2)
      VAR(3,IY) = VAR(3,I+2)
 1245 CONTINUE
      GO TO 1250
 1248 IER = 1
C
C     CHECK  FOR NAMC AS A PREVIOUS NAME  OR MISSING
 1250 IF ( IC .EQ. 0) GO TO 1265
      DO 1260 J =1,NNAM
      IF (VAR(2,IC).NE. NAME(1,J).OR.VAR(3,IC).NE. NAME(2,J)) GO TO 1260
      GO TO 1265
 1260 CONTINUE
C
C     OK -NEW NAME , ADD TO LIST
C
      NNAM = NNAM+1
      NAME(1,NNAM) = VAR(2,IC)
      NAME(2,NNAM) = VAR(3,IC)
      IX = NX+3*NN+3
      VAR(1,IX) = NCNO
      VAR(2,IX) = -1
      VAR(3,IX) = NNAM
      RETURN
 1265 IER = IER +2
      RETURN
      END

      SUBROUTINE TSHEAR
C
C     ELEMENT TEMPERATURE AND DEFORMATION LOADING FOR THE SHEAR PANEL.
C
C     FORMULATION IS THAT OF A PSEUDO-ROD ON EACH EDGE OF THE SHEAR
C     PANEL.
C
C     ECPT( 1)         - ELEMENT ID
C     ECPT( 2 THRU 5)  - 4 GRID SILS
C     ECPT( 6)         - MATERIAL ID
C     ECPT( 7)         - THICKNESS
C     ECPT( 8)         - NON-STRUCTURAL MASS
C     ECPT( 9 THRU 24) - 4 POINTS (CSID,X,Y,Z) REPEATS
C     ECPT(25)         - ELEMENT TEMPERATURE
C     ECPT(26)         - F1 EFFECTIVENESS FACTOR DIRECTION 1, (NOT USED)
C     ECPT(27)         - F2 EFFECTIVENESS FACTOR DIRECTION 2, (NOT USED)
C
      INTEGER         NCSID(4,4)
      COMMON /SSGETT/ ELTYPE   ,OLDEL    ,EORFLG   ,ENDID   ,BUFFLG   ,
     1                ITEMP    ,IDEFT    ,IDEFM
      COMMON /TRIMEX/ ECPT(1)  ,ISILS(4) ,MID      ,THICK   ,FMU      ,
     1                CSID(4,4),ELTEMP   ,F12(2)
      COMMON /MATIN / MATID    ,INFLAG   ,TEMP     ,STRESS  ,SINTH    ,
     1                COSTH
      COMMON /MATOUT/ E1       ,G        ,NU       ,RHO     ,ALPHA    ,
     1                TO1      ,GE       ,SIGMAT   ,SIGMAC  ,SIGMAS
      COMMON /SSGWRK/ VEC(3,4) ,XL(4)    ,DIAG1(3) ,DIAG2(3),TI(16)   ,
     1                PA       ,TSQ      ,VECA(3)  ,VECB(3) ,AREA     ,
     2                VMAG     ,I        ,J        ,IA      ,IB       ,
     3                I12      ,TBAR     ,IN
      COMMON /ZZZZZZ/ PG(1)
      EQUIVALENCE     (NCSID,CSID)
C
      F12(1) = 1.00
      F12(2) = 1.00
C
      IF (F12(1).EQ.0.0 .AND. F12(2).EQ.0.0) RETURN
C
C     MATERIAL DATA ACQUISITION
C
      INFLAG = 1
      MATID  = MID
      TEMP   = ELTEMP
      CALL MAT (ECPT(1))
C
C     GRID POINT TEMPERATURES
C
      IF (ITEMP) 100,800,100
  100 CALL SSGETD (ECPT(1),TI,4)
C
C     ELEMENT DEFORMATION (NOT USED)
C
C     4 NORMALIZED EDGE VECTORS AND LENGTHS
C
      DO 300 I = 1,4
      IGRID2 = I + 1
      IF (I .EQ. 4) IGRID2 = 1
C
      DO 210 J = 1,3
      VEC(J,I) = CSID(J+1,I) - CSID(J+1,IGRID2)
  210 CONTINUE
C
      CALL NORM (VEC(1,I),XL(I))
  300 CONTINUE
C
      IF (F12(1).GT.1.01 .AND. F12(2).GT.1.01) GO TO 500
C
C     PROJECTED AREA IS NEEDED. FIRST OBTAIN THE DIAGONAL VECTORS.
C
      DO 400 I = 1,3
      DIAG1(I) = CSID(I+1,3) - CSID(I+1,1)
      DIAG2(I) = CSID(I+1,4) - CSID(I+1,2)
  400 CONTINUE
C
C     NORMAL VECTOR (DIAG1 X DIAG2)
C
      CALL SAXB (DIAG1,DIAG2,DIAG2)
      CALL NORM (DIAG2,VKL)
      PA = 0.5*VKL
C
C     LOOP THROUGH LOADS ON 4 EDGES.
C
  500 TSQ = THICK*THICK
      DO 700 I = 1,4
      I12 = MOD(I,2)
      IF (I12 .EQ. 0) I12 = 2
      IA = I
      IB = IA + 1
      IF (I .EQ. 4) IB = 1
C
C     TEMPERATURE
C
      TBAR = (TI(IA+1) + TI(IB+1))/2.0 - TO1
C
C     EXTENSIONAL AREA
C
      IF (F12(I12) .LE. 1.01) GO TO 550
      AREA = 0.50*F12(I12)*TSQ
      GO TO 560
  550 AREA = F12(I12)*PA*THICK/(XL(I12) + XL(I12+2))
C
  560 VMAG = E1*AREA*ALPHA*TBAR
      DO 570 J = 1,3
      VECA(J) = VMAG*VEC(J,I)
      VECB(J) =-VECA(J)
  570 CONTINUE
C
      IF (NCSID(1,IB)) 580,590,580
  580 CALL BASGLB (VECB(1),VECB(1),ISILS(IB),CSID(1,IB))
  590 IN = ISILS(IB) - 1
      DO 610 J = 1,3
      IN = IN + 1
      PG(IN) = PG(IN) + VECB(J)
  610 CONTINUE
C
      IF (NCSID(1,IA)) 620,630,620
  620 CALL BASGLB (VECA(1),VECA(1),ISILS(IA),CSID(1,IA))
  630 IN = ISILS(IA) - 1
      DO 640 J = 1,3
      IN = IN + 1
      PG(IN) = PG(IN) + VECA(J)
  640 CONTINUE
C
  700 CONTINUE
  800 RETURN
      END

      SUBROUTINE SMCPH1 ( ZI, ZR, ZD )              
      REAL              ZR(4)   ,MINDS
      LOGICAL           FRSTVAL 
      INTEGER           ZI(4)   ,ITEMP(4)
      INTEGER           PRC     ,WORDS   ,RLCMPX  ,NAME(2), REW
      DOUBLE PRECISION  ZD(4)   ,XND(10)
      CHARACTER         UFM*23  ,UWM*25  ,UIM*29  ,SFM*25
      CHARACTER*4       CNAME(2)
      CHARACTER*14      CTYPE(4)
C 
C  KTYPE   = TYPE (1-RS,2-RD,3-CS,4-CD) OF LOWER TRIANGULAR MATRIX
C  KPREC   = PRECISION (1-SINGL, 2-DOUBL) OF LOWER TRIANGULAR MATRIX
C  MAXROW  = HIGHEST ROW NUMBER REFERENCED THUS FAR IN PROCESSING
C            A GIVEN COLUMN - NEEDED TO DETERMINE CREATED TERMS DURING
C            DECOMPOSITION
C  MAXINLOP= MAXIMUM TERMS FOR ANY GIVEN INNER LOOP
C  MAXNCOL = MAXIMUM NUMBER OF COLUMNS REFERENCED BY ANY GIVEN COLUMN
C  LASCOL  = LAST COLUMN NUMBER OF MATRIX TO BE DECOMPOSED
C  NEXCOL  = FIRST NON-ZERO TERM IN CURRENT PIVOT COLUMN BELOW DIAGONAL
C            USED TO DETERMINE THE NEXT PIVOT COLUMN WHERE THE ROW
C            WILL BE NEEDED.
C  ICURCOL = CURRENT COLUMN BEING PROCESSED
C  MXRECL  = MAXIMUM SIZE IN WORDS OF ANY ONE RECORD WRITTEN TO THE 
C            SPILL FILE
C  NSPILL  = NUMBER OF COLUMNS WRITTEN TO THE SPILL FILE
C
      INCLUDE  'SMCOMX.COM'
      COMMON  /XMSSG /  UFM     ,UWM     ,UIM     ,SFM
      COMMON  /NTIME /  NITEMS  ,TMIO    ,TMBPAK  ,TMIPAK  ,TMPAK   
     1,                 TMUPAK  ,TMGSTR  ,TMPSTR  ,TMT(4)  ,TML(4)
      COMMON  /NAMES /  RDNRW   ,RDREW   ,WRT     ,WRTREW  ,REW     
     1,                 NOREW   ,EOFNRW  ,RSP     ,RDP     ,CSP     
     2,                 CDP     ,SQR     ,RECT    ,DIAG    ,LOWTRI  
     3,                 UPRTRI  ,SYM
      COMMON  /ZZZZZZ/  XNS(10)
      COMMON  /TYPE  /  PRC(2)  , WORDS(4), RLCMPX(4)     
      COMMON  /LOGOUT/  LOUT
      EQUIVALENCE       ( DDR     , DSR    ), (DDC    , DSC  )
      EQUIVALENCE       ( MINDD   , MINDS  ), (XNS    , XND  )
      EQUIVALENCE       ( MBLK(6) , MTERMS ), (MBLK(5), MSTR )
      EQUIVALENCE       ( MBLK(4) , MROW   ), (MBLK(2), MTYPE)
      EQUIVALENCE       ( CNAME   , NAME   )
      DATA              CTYPE / 'REAL SINGLE   ', 'REAL DOUBLE   '
     &,                         'COMPLEX SINGLE', 'COMPLEX DOUBLE' /
C
C   open core is allocated as follows for phase1 of the decomposition
C
C       -------------------------------
C       zi(1) -  Beginning of directory for in-memory column data
C       Directory (4,n) , n=number of columns of matrix
C                  (1,i) = index to active rows and terms within memory
C                  (2,i) = first column data needed for this pivot
C                  (3,i) = last pivot column to use this data
C                  (4,i) = savpos position pointer for data spilled to a
C                          scratch file
C       -------------------------------
C       zi(iacrow) - Beginning of active row vector.
C       Vector for determining active rows for each column, n words
C       Each row value will define the next column where the row value
C       is next needed for calculation of the lll matrix.
C       -------------------------------     
C       zi(IRVAL) - Stagging area for storing data 
C       Defines the values in the next section of open core, 2*n
C                  (1,i) = row number
C                  (2,i) = number of consecutive terms beginning at row
C       This section and the next section are staging areas for storing
C       of rows and row values of columns to be pointed to by the directory
C       in the first part of open core.
C       -------------------------------         
C       zi(IVVAL)
C       Row values of column as defined by previous section, n*iprec words
C       -------------------------------         
C       zi(idbase)
C       Memory for rows and terms of columns as pointed to by directory
C       in the first part of open core.  This data is loaded from the  
C       bottom up to allow for better management of open core in
C       subroutine smcph2 which is called after this subroutine.
C       The format for the storage of this data is as follows:
C          (index from directory above points to the first word of the
C           data that follows)
C               1.  Column number
C               2.  Length of active row section (m*2), m=number of
C                   repeats of contents of words 5 and 6 below.
C               3.  Total number of words in this block of allocation
C               4.  Length of values section
C               5.  row number
C               6.  number of consecutive values beginning at this row
C                   (words 5 and 6 repeat m times)
C           5+2*m.  row value for first row
C     5+2*m+iprec.  next row value (iprec=1,2,4)
C   5+2*m+iprec*l.  last row value for column (l=total values)
C       -------------------------------         
C       zi(ibuf2)
C       Buffer for spill file if all column values can not be kept in memory   
C       -------------------------------
C       zi(ibuf1)
C       Buffer for input matrix file to be decomposed
C       -------------------------------
C
c      CALL AUDIT ( 'BEGIN   ', 1 )
c      CALL AUDIT ( 'SMCPH1  ', 1 )
      CALL FNAME ( MCB, NAME ) 
      NCOL   = MCB( 2 )
      MEMCOLN= 0
      MXRECL = 0
      MAXNAC = 0
      MAXNAR = 0
      IPREC  = PRC  ( MCB( 5 ) )
      KTYPE  = MCB( 5 )
      IF ( ISPREC .EQ. 2 .AND. KTYPE .EQ. 1 ) KTYPE = 2
      IF ( ISPREC .EQ. 2 .AND. KTYPE .EQ. 3 ) KTYPE = 4
      IF ( ISPREC .EQ. 1 .AND. KTYPE .EQ. 2 ) KTYPE = 1
      IF ( ISPREC .EQ. 1 .AND. KTYPE .EQ. 4 ) KTYPE = 3
      IF ( KTYPE  .EQ. 1 .OR.  KTYPE .EQ. 3 ) KPREC = 1
      IF ( KTYPE  .EQ. 2 .OR.  KTYPE .EQ. 4 ) KPREC = 2
      IVWRDS = WORDS( KTYPE )
      IACROW = 4*NCOL + 1
      IRVAL  = IACROW + NCOL
      IVVAL  = IRVAL  + 2*NCOL
C
C ENSURE THAT IVVAL IS ON A DOUBLE WORD BOUNDARY
C      
      IF ( MOD( IVVAL,2 )  .EQ. 0 ) IVVAL = IVVAL + 1
      IDBASE = IVVAL  + IVWRDS*NCOL
C
C ENSURE THAT IDBASE IS ON A DOUBLE WORD BOUNDARY
C      
      IF ( MOD( IDBASE,2 ) .EQ. 0 ) IDBASE = IDBASE + 1
      IF ( LCORE .LT. (IDBASE + 2*ISYSBF) ) GO TO 7001
      IBUF1  = LCORE - ISYSBF
      IBUF2  = IBUF1 - ISYSBF
      IDBMAX = IBUF2 - 1
C
C ENSURE THAT IDBMAX IS ON A DOUBLE WORD BOUNDARY
C      
      IF ( MOD( IDBMAX,2 ) .EQ. 0 ) IDBMAX = IDBMAX - 1
      IDBIND = IDBMAX
      CALL OPEN   ( *7002, MCB, ZI(IBUF1), RDREW )
      CALL SKPREC ( MCB, 1 )
      MBLK(1) = MCB( 1 )
      LLL(2)  = MCB( 2 )
      LLL(3)  = MCB( 2 )
      LLL(4)  = 4
      LLL(5)  = KTYPE
      LLL(6)  = 0
      LLL(7)  = LSHIFT( 1, NBPW-2 - (NBPW-32) )
      ICURCOL = 1
      OPNSCR  = .FALSE.
      NSPILL  = 0
      MAXROW  = 0
      MAXINLOP= 0
      MAXNCOL = 0
      LASCOL  = 0
      POWER   = 0
      IF ( KPREC .NE. 2 ) GO TO 5
      DDR     = 1.0D0
      DDC     = 0.0D0
      MINDD   = 1.0D+25
      GO TO 8
5     DSR     = 1.0
      DCR     = 0.0
      MINDS   = 1.0E+25
8     CONTINUE
      MOBLK( 1 ) = LLL( 1 )
      MOBLK( 2 ) = KTYPE
      MOBLK( 3 ) = 1
C
C ZERO OUT THE ACTIVE COLUMN VECTOR
C      
      DO 10 I = 1, NCOL
      ZI( IACROW + I - 1 ) = 0
10    CONTINUE
      LEN = NCOL*4
C
C ZERO OUT THE DIRECTORY
C      
      DO 20 I = 1, LEN
      ZI( I )   = 0
20    CONTINUE
50    CONTINUE
      NTERMS  = 0
      FRSTVAL = .TRUE.
      INDEXR  = IRVAL
      INDEXV  = IVVAL
      INDEXVD = ( INDEXV / 2 ) + 1
      MBLK(8) = -1            
      NEXCOL  = 0
      INDDIR = (ICURCOL-1)*4 + 1    
100   CALL GETSTR ( *1000, MBLK )
      IF ( ICURCOL .LE. ( MROW+MTERMS-1) ) GO TO 120
C
C ALL ROW TERMS ARE BEFORE CURRENT PIVOT COLUMN; SKIP THESE TERMS
C AND GET NEXT STRING.
C CHECK TO SEE IF THIS IS THE FIRST TERM OF THE PIVOT COLUMN
C      
      IF ( ZI( INDDIR + 1 ) .EQ. 0 ) ZI( INDDIR + 1 ) = MROW 
      CALL ENDGET ( MBLK )
      GO TO 100
C
C SAVE SOME OR ALL OF THE TERMS IN THIS STRING
C IF THIS IS NOT THE FIRST STRING TO PROCESS, THEN SAVE ALL VALUES
C
120   ISKIP = 0
      IF ( .NOT. FRSTVAL ) GO TO 140
C
C CHECK IF THIS IS THE FIRST TERM OF THE PIVOT COLUMN
C      
      IF ( ZI( INDDIR + 1 ) .EQ. 0 ) ZI( INDDIR + 1 ) = MROW 
C
C OTHERWISE, CHECK IF ALL TERMS OR ONLY SOME ARE TO BE SAVED
C      
      FRSTVAL = .FALSE.
      IF ( ICURCOL .EQ. MROW ) GO TO 130
C
C CHECK FOR ZERO ON THE DIAGONAL
C      
      IF ( ICURCOL .LT. MROW ) GO TO 7004
C
C SKIP ALL TERMS BEFORE THE CURRENT PIVOT COLUMN 
C      
      ISKIP = ICURCOL - MROW 
      ZI( INDEXR   ) = ICURCOL
      NTERMS         = MTERMS - ISKIP
      ZI( INDEXR+1 ) = NTERMS 
      IF ( ( MTERMS-ISKIP ) .GT. 1 ) NEXCOL = ICURCOL + 1
      GO TO 200
130   CONTINUE
      IF ( MTERMS .GT. 1 ) NEXCOL = MROW + 1
      ZI(INDEXR   ) = MROW
      ZI(INDEXR+1 ) = MTERMS
      NTERMS        = MTERMS
      GO TO 200
140   CONTINUE
C
C CHECK TO SEE IF CURRENT STRING IS AN EXTENSION OF PREVIOUS STRING
C      
      IF ( (ZI( INDEXR )+ZI( INDEXR+1 ) ) .EQ. MROW ) GO TO 170
C
C NO, MUST CREATE NEW POINTER FOR VALUES
C BUT FIRST, CHECK FOR PROVIDING FOR COMPUTED TERMS OF 
C PREVIOUS PIVOT COLUMNS
C      
      IROW1 = ZI( INDEXR ) + ZI( INDEXR+1 )
      IROWN = MROW - 1
      IRFLAG = 1
      GO TO 6000
C
C NOW CHECK IF THE ADDED TERMS ARE PART OF SAME STRING AS THAT JUST
C GOTTEN FROM GETSTR CALL
C
150   IF ( ( ZI(INDEXR) + ZI(INDEXR+1) ) .EQ. MROW ) GO TO 170 
C
C NEW STRING TO BE DEFINED FOR THE CURRENT TERMS FROM GETSTR
C
160   INDEXR = INDEXR + 2
      ZI(INDEXR   ) = MROW
      ZI(INDEXR+1 ) = MTERMS 
      NTERMS        = NTERMS + MTERMS
      IF ( NEXCOL .EQ. 0 ) NEXCOL = MROW
      GO TO 200
170   CONTINUE
C
C TERMS ARE AN EXTENSION OF EXISTING DATA, CHANGE THE NUMBER OF TERMS 
C      
      ZI( INDEXR+1 ) = ZI( INDEXR+1 ) + MTERMS
      NTERMS         = NTERMS + MTERMS
      IF ( NEXCOL .EQ. 0 ) NEXCOL = MROW
200   CALL SMCRTR ( ZR, ZD )      
C
C SET ACTIVE COLUMN ROW NUMBERS FOR POSSIBLE EXPANDED TERMS
C      
      IROW1 = MROW + ISKIP
      IROWN = IROW1 + MTERMS - 1 - ISKIP
      DO 400 K = IROW1, IROWN
      ZI( IACROW + K - 1 ) = NEXCOL
400   CONTINUE
C
C GO AND GET ADDITIONAL STRINGS IF ANY
C      
      CALL ENDGET ( MBLK )
      GO TO 100
1000  CONTINUE
C
C END OF READING CURRENT COLUMN, CHECK IF DIAGONAL TERM FOUND
C      
C      PRINT *,' SMCPH1,ICURCOL,NEXCOL,MAXROW=',ICURCOL,NEXCOL,MAXROW
      IF ( FRSTVAL ) GO TO 7004
C
C SEE IF ANY COMPUTED TERMS FROM PREVIOUS PIVOT COLUMNS ARE TO BE 
C ADDED ONTO THE END OF THE CURRENT ACTIVE ROWS FOR THIS COLUMN
C      
      LROW  = ZI( INDEXR ) + ZI( INDEXR+1 ) - 1
      IF ( LROW .GT. MAXROW ) MAXROW = LROW
      IROW1 = LROW + 1
      IROWN = MAXROW
      IRFLAG = 2
C      PRINT *,' B1050,ICURCOL,IROWN,IROW1=',ICURCOL,IROWN,IROW1
      IF ( IROWN .GE. IROW1 ) GO TO 6000
C
C SET UP DIRECTORY AND SAVE DATA EITHER
C IN MEMORY OR ON SPILL FILE
C
 1050 CONTINUE
C
C RECOMPUTE LROW IN CASE NEW TERMS WERE ADDED FROM PREVIOUS PIVOT COLUMNS
C      
      LROW   = ZI( INDEXR ) + ZI( INDEXR+1 ) - 1     
C
C INDEXR POINTS TO CURRENT DIRECTORY ENTRY BUT INDEXV POINTS TO NEXT
C AVAILABLE POSITION FOR STORING TERMS
C      
      NRVALS = INDEXR - IRVAL + 2
      NVVALS = INDEXV - IVVAL 
      NWORDS = NRVALS + NVVALS + 4
C
C SAVE DATA IN MEMORY AND SET DIRECTORY ACCORDINGLY
C      
      ITEST = IDBIND - NWORDS + 1
C
C MAKE SURE ITEST IS ON DOUBLE WORD BOUNDARY
C      
      IF ( MOD( ITEST,2 ) .EQ. 0 ) ITEST = ITEST - 1
C
C CHECK TO SEE IF THERE IS SUFFICIENT MEMORY
C      
      MAXNAR = MAX0( NRVALS, MAXNAR )
      IF ( ITEST .LT. IDBASE ) GO TO 1800
      IDBIND = ITEST
      ZI( INDDIR     ) = IDBIND
      ZI( INDDIR + 3 ) = 0
      ZI( IDBIND     ) = ICURCOL
      ZI( IDBIND + 1 ) = NRVALS
      ZI( IDBIND + 2 ) = NWORDS
      ZI( IDBIND + 3 ) = NTERMS
      IDBIND = IDBIND + 3
      DO 1100 K = 1, NRVALS
      ZI( IDBIND + K ) = ZI( IRVAL + K - 1 )
1100  CONTINUE
      IDBIND = IDBIND + NRVALS
      IF ( KPREC .EQ. 2 ) GO TO 1300
      DO 1200 K = 1, NVVALS
      ZI( IDBIND + K ) = ZI( IVVAL + K - 1 )
1200  CONTINUE
      GO TO 1400
1300  INDXV = IDBIND / 2 
      NV    = NVVALS / 2                   
      IVD   = IVVAL  / 2 
      DO 1350 K = 1, NV
      ZD( INDXV+K ) = ZD( IVD+K )
1350  CONTINUE
1400  CONTINUE
      IDBIND = IDBIND + NVVALS - NWORDS
      LASCOL = ICURCOL
      MEMCOLN= ICURCOL
      ITEST  = NRVALS + NVVALS + 4
      IF ( ITEST .GT. MXRECL ) MXRECL = ITEST
      GO TO 2000
1800  CONTINUE
      IF ( OPNSCR ) GO TO 1810
      OPNSCR = .TRUE.
      CALL OPEN ( *7003, ISCR1, ZI(IBUF2), WRTREW )
C
C NO MORE MEMORY, SAVE COLUMN DATA TO SPILL FILE, KEEP RECORD POSITION
C
1810  ITEMP( 1 ) = ICURCOL
      ITEMP( 2 ) = NRVALS
      ITEMP( 3 ) = 0
      ITEMP( 4 ) = NTERMS
      CALL WRITE ( ISCR1, ITEMP, 4, 0 )
      CALL SAVPOS( ISCR1, KPOS )            
      CALL WRITE ( ISCR1, ZI( IRVAL ), INDEXR-IRVAL+2, 0 )
      CALL WRITE ( ISCR1, ZI( IVVAL ), INDEXV-IVVAL+2, 1 )
      ZI( INDDIR   ) = 0
      ZI( INDDIR+3 ) = KPOS
      NSPILL = NSPILL + 1
      ITEST  = NRVALS + NVVALS + 4
      IF ( ITEST .GT. MXRECL ) MXRECL = ITEST
2000  CONTINUE
      LROW   = ZI( INDEXR ) + ZI( INDEXR+1 ) - 1
C
C SAVE LAST PIVOT COLUMN FOR WHICH DATA IN THIS COLUMN IS USED
C      
      IF ( NTERMS .GT. MAXNAC ) MAXNAC = NTERMS
      ZI( INDDIR+2 ) = LROW
      IFIRSTC = ZI( INDDIR+1 )
      MAXTES  = ( ICURCOL - IFIRSTC + 1 )
      IF ( MAXTES .GT. MAXNCOL  ) MAXNCOL = MAXTES
      MAXTES  = NTERMS * ( ICURCOL - IFIRSTC )
      IF ( MAXTES .GT. MAXINLOP ) MAXINLOP = MAXTES
C
C CHECK TO DETERMINE IF ALL COLUMNS HAVE BEEN PROCESSED
C      
      IF ( ICURCOL .GE. NCOL ) GO TO 7777
C
C CHECK IF ONLY ONE TERM IN THIS COLUMN
C      
      IF ( NEXCOL .NE. 0 ) GO TO 2005
C
C MUST FIND FIRST NON-ZERO TERM FOLLOWING THE CURRENT PIVOT
C      
      DO 2002 K = ICURCOL+1, NCOL
      IF ( ZI( IACROW+K ) .NE. ICURCOL ) GO TO 2002
      NEXCOL = K
      GO TO 2005
2002  CONTINUE
      WRITE ( NOUT, 9901 ) ICURCOL
      GO TO 2030
9901  FORMAT(' SYMMETRIC DECOMPOSITION FOUND NO TERMS BEING '
     &,' CONNECTED TO DIAGONAL ON COLUMN ',I6)
2005  CONTINUE
C      PRINT *,' AFTER 2005,ICURCOL,NEXCOL=',ICURCOL,NEXCOL
C
C UPDATE ACTIVE ROWS IN COLUMN VECTOR FOR ALL TERMS OF THIS COLUMN
C      
      LEN = IRVAL + NRVALS - 1
      DO 2010 K = IRVAL, LEN, 2
      IROW = ZI( K )
      NROW = IROW + ZI( K+1 ) - 1
      DO 2010 L = IROW, NROW
      ZI( IACROW + L - 1 ) = NEXCOL      
2010  CONTINUE
      DO 2020 L = ICURCOL+1, MAXROW
      IF ( ZI( IACROW+L-1 ) .EQ. ICURCOL ) ZI( IACROW+L-1) = NEXCOL 
2020  CONTINUE
2030  CONTINUE
C
C END OF CURRENT COLUMN, PREPARE FOR NEXT COLUMN
C
C      write ( nout, 901 ) icurcol
C901   format(20x,' Active rows after processing column ',i10)
C      do 2040 l = 1, ncol
C      write ( nout, 902 ) l, zi(iacrow+l-1)
C902   format(' Row, next reference =',2i7)
C2040  continue
C      write ( nout, 903 )
C903   format(20x, ' Directory',/,
C     &' Column  Memory Index   First Used    Last Used    Savpos')
C      do 2050 l = 1, ncol
C      ind = ( l-1 ) * 4 + 1
C      write ( nout, 904 ) l, zi(ind), zi(ind+1), zi(ind+2), zi(ind+3)
C904   format( i7, i14, i13, i13, i9)
C2050  continue
      ICURCOL = ICURCOL + 1    
      INDDIR  = (ICURCOL-1)*4 + 1    
      GO TO 50
C
C THE FOLLOWING IS AN INTERNAL ROUTINE TO ADD COMPUTED TERMS RESULTING
C FROM THE PROCESSING OF PREVIOUS PIVOT COLUMNS INTO THE CURRENT ACTIVE
C ROWS FOR THE CURRENT COLUMN 
C
6000  CONTINUE
      DO 6100 K = IROW1, IROWN
      IF ( ZI(IACROW + K - 1 ) .LT. ICURCOL ) GO TO 6100
      IF ( NEXCOL .EQ. 0 ) NEXCOL = K 
C
C NEED TO ADD THIS TERM TO THE ACTIVE ROWS
C CHECK TO SEE IF THIS TERM IS AN EXTENSION OF CURRENT TERMS
C      
      IF ( (ZI( INDEXR ) + ZI( INDEXR+1 ) ) .EQ. K )
     &    GO TO 6010
C
C NO, NEED TO CREATE ANOTHER POINTER
C      
      INDEXR = INDEXR + 2
      ZI( INDEXR )   = K
      ZI( INDEXR+1 ) = 1
      NTERMS         = NTERMS +1
      GO TO 6020
6010  CONTINUE
C
C JUST ADD TO THE NUMBER OF CONSECUTIVE VALUES FOR CURRENT ROW
C      
      ZI( INDEXR+1 ) = ZI( INDEXR+1 ) + 1
      NTERMS         = NTERMS + 1
6020  CONTINUE      
C
C NOW, ZERO OUT ROW VALUE
C      
      GO TO ( 6030, 6040, 6050, 6060), KTYPE
C
C TYPE IS REAL SP
C
6030  ZR( INDEXV ) = 0.
      INDEXV = INDEXV + 1
      GO TO 6100
C
C TYPE IS REAL DP
C
6040  ZD( INDEXVD ) = 0.D0
      INDEXVD = INDEXVD + 1
      INDEXV  = INDEXV  + 2
      GO TO 6100
C
C TYPE IS COMPLEX SP
C
6050  ZR( INDEXV   ) = 0.
      ZR( INDEXV+1 ) = 0.
      INDEXV = INDEXV + 2
      GO TO 6100
C
C TYPE IS COMPLEX DP
C
6060  ZD( INDEXVD   ) = 0.D0
      ZD( INDEXVD+1 ) = 0.D0
      INDEXVD = INDEXVD + 2
      INDEXV  = INDEXV  + 4
      GO TO 6100
6100  CONTINUE
      GO TO ( 150, 1050 ), IRFLAG
C
C INSUFFICIENT MEMORY
C
7001  MINMUM = NCOL*7 + 2*NCOL*IVWRDS + 2*ISYSBF 
      WRITE ( NOUT, 9001 ) UFM, MCB(1), CNAME, NCOL, KTYPE
     &,                    LCORE, MINMUM
9001  FORMAT(1X,A23,/,' INSUFFICIENT MEMORY TO DECOMPOSE MATRIX IN '
     &,I4,' FILE NAME=',2A4
     &,/,' NUMBER OF COLUMNS=',I7,' TYPE=',I2,' MEMORY AVAILABLE =',I10
     &,/,' MINIMUM REQUIRED IS =',I10)
C      CALL MESAGE ( -8, 0, 0 )
      IERROR = 1
      GO TO 7777
7002  CALL FNAME ( MCB, NAME )
      WRITE ( NOUT, 9002 ) UFM, MCB(1), CNAME
9002  FORMAT(1X, A23, /,' SMCPH1 UNABLE TO OPEN FILE ',I4,' NAME= ',2A4)
      IERROR = 2
      CALL MESAGE ( -61, 0, 0 )
7003  CALL FNAME ( ISCR1, NAME )
      WRITE ( NOUT, 9003 ) UFM, ISCR1, CNAME
9003  FORMAT(1X, A23, /,' SMCPH1 UNABLE TO OPEN FILE ',I4,' NAME= ',2A4)
      IERROR = 2
      CALL MESAGE ( -61, 0, 0 )
C
C ZERO ON DIAGONAL, TERMINATE DECOMPOSITION BUT FIRST SCAN REST OF
C MATRIX TO DETERMINE OTHER COLUMNS WITH ZERO DIAGONALS.
C
7004  CONTINUE
      IERROR = 7
      IZEROS = 1
      INDEXZ = 0
      IF ( FRSTVAL ) GO TO 7020
      CALL ENDGET ( MBLK )
7010  CALL SKPREC ( MBLK, 1 )  
7020  INDEXZ = INDEXZ + 1
      ZI ( INDEXZ ) = ICURCOL
7025  ICURCOL = ICURCOL + 1
      IF ( ICURCOL .GT. NCOL ) GO TO 7050
      MBLK( 8 ) = -1
7030  CALL GETSTR ( *7020, MBLK )
      CALL ENDGET ( MBLK ) 
      IF ( ICURCOL .GE. MROW .AND. ICURCOL .LE. MROW+MTERMS-1)GO TO 7040
      IF ( MROW    .GT. ICURCOL ) GO TO 7010
      GO TO 7030
7040  CALL SKPREC ( MBLK, 1 )
      GO TO 7025
7050  CALL CLOSE ( MCB  , REW )
      CALL CLOSE ( ISCR1, REW )
      WRITE ( NOUT, 9050 ) UFM, CNAME, (ZI(K),K=1,INDEXZ)
9050  FORMAT(A23,' 3097, SYMMETRIC DECOMPOSITION OF DATA BLOCK ',2A4
     &,      ' ABORTED BECAUSE THE FOLLOWING COLUMNS ARE SINGULAR -'
     &,/,(5X,20I6,/))
      RETURN
7777  CONTINUE
C      CALL SMCHLP
C      CALL SMCDMP ( ZI, ZR, ZD )
7778  CONTINUE
      CALL CLOSE ( MCB, REW )
      ITWRDS  = IDBMAX - IDBIND
      ITCOLS  = NCOL   - NSPILL
      CALL SSWTCH ( 45, L45 )
      IF ( L45 .EQ. 0 ) GO TO 7779
      WRITE ( LOUT, 9004 ) ITCOLS , NSPILL , MAXNAC, MAXNCOL
     &,                    MAXINLOP, ITWRDS
9004  FORMAT(/
     &  ,14X,' STATISTICS FOR SYMMETRIC DECOMPOSITION OF FILE ',/
     &,/, 7X,' COLUMNS CONTAINED IN MEMORY                         =',I8
     &,/, 7X,' COLUMNS WRITTEN TO SPILL FILE                       =',I8
     &,/, 7X,' MAX. NO. OF ACTIVE ROWS FOR ANY ACTIVE COLUMN       =',I8
     &,/, 7X,' MAX. NUMBER OF COLUMNS REFERENCED BY A PIVOT COLUMN =',I8   
     &,/, 7X,' MAX. TERMS FOR ANY GIVEN INNER LOOP                 =',I8
     &,/, 7X,' TOTAL WORDS IN OPEN CORE USED FOR COLUMN DATA       =',I8 
     & )
      WRITE ( LOUT, 9005 ) 'INPUT ', CNAME, CTYPE( MCB( 5 ) )
      CALL FNAME ( LLL, NAME )
      WRITE ( LOUT, 9005 ) 'OUTPUT', CNAME, CTYPE( KTYPE )
9005  FORMAT(     
     &   8X, A6,' FILE: ',2A4     ,'      DATA TYPE= ',A14 )
c      CALL AUDIT( 'SMCPH1  ', 2 )
7779  CONTINUE
      RETURN
      END

      SUBROUTINE DPD
C
C     DPD IS MAIN CONTROL PROGRAM FOR THE DYNAMICS POOL DISTRIBUTOR.
C
      INTEGER         GPL   ,SIL   ,USET  ,USETD ,GPLD  ,SILD  ,DPOOL ,
     1                DLT   ,FRL   ,TFL   ,TRL   ,PSDL  ,EED   ,SCR1  ,
     2                SCR2  ,SCR3  ,SCR4  ,BUF   ,BUF1  ,BUF2  ,BUF3  ,
     3                BUF4  ,SYSBUF,NGRID ,EPOINT,SEQEP ,Z     ,LOADS ,
     5                EQDYN ,DLOAD ,FREQ1 ,FREQ  ,TIC   ,TSTEP ,TF    ,
     6                PSD   ,EIGR  ,EIGB  ,EIGC  ,SDT
      DIMENSION       BUF(24)   ,EPOINT(2)    ,SEQEP(2)     ,MCB(7)   ,
     1                NAM(2)    ,LOADS(32)    ,DLOAD(2)     ,FREQ1(2) ,
     2                FREQ(2)   ,ZZ(1)        ,BUFR(20)     ,NOLIN(21),
     3                TIC(2)    ,TSTEP(2)     ,TF(2)        ,PSD(2)   ,
     4                MSG(3)    ,EIGR(2)      ,EIGB(2)      ,EIGC(2)
      COMMON /BLANK / LUSET ,LUSETD,NOTFL ,NODLT ,NOPSDL,NOFRL ,NONLFT,
     1                NOTRL ,NOEED ,NOSDT ,NOUE
      COMMON /DPDCOM/ DPOOL ,GPL   ,SIL   ,USET  ,GPLD  ,SILD  ,USETD ,
     1                DLT   ,FRL   ,NLFT  ,TFL   ,TRL   ,PSDL  ,EED   ,
     2                SCR1  ,SCR2  ,SCR3  ,SCR4  ,BUF   ,BUF1  ,BUF2  ,
     3                BUF3  ,BUF4  ,EPOINT,SEQEP ,L     ,KN    ,NEQDYN,
     4                LOADS ,DLOAD ,FREQ1 ,FREQ  ,NOLIN ,NOGO  ,
     5                MSG   ,TIC   ,TSTEP ,TF    ,PSD   ,EIGR  ,EIGB  ,
     6                EIGC  ,MCB   ,NAM   ,EQDYN ,SDT   ,INEQC
      COMMON /ZZZZZZ/ Z(1)
      COMMON /SYSTEM/ SYSBUF
      EQUIVALENCE     (Z(1),ZZ(1)),(BUF(1),BUFR(1)),(MSG(2),NGRID)
C
C     INITIALIZE CONTROL PARAMETERS.
C
      NOTFL  = -1
      NODLT  = -1
      NOPSDL = -1
      NOFRL  = -1
      NONLFT = -1
      NOTRL  = -1
      NOEED  = -1
      NOSDT  = -1
      NOUE   = -1
      NOGO   =  0
      INEQ   =  0
      DO 10 I = 1,7
   10 MCB(I) = 0
C
C     PERFORM BUFFER ALLOCATION
C
      BUF1 = KORSZ(Z) - SYSBUF - 2
      BUF2 = BUF1 - SYSBUF
      BUF3 = BUF2 - SYSBUF
      BUF4 = BUF3 - SYSBUF
C
C     IF DYNAMICS POOL IS PURGED, EXIT. OTHERWISE, EXECUTE THE PHASES
C     OF DPD
C
      BUF(1) = DPOOL
      CALL RDTRL (BUF)
      IF (BUF(1) .NE. DPOOL) RETURN
      CALL DPD1
      CALL DPD2
      CALL DPD3
      CALL DPD4
      CALL DPD5
      IF (NOGO .NE. 0) CALL MESAGE (-61,0,0)
      RETURN
      END

      SUBROUTINE DYPZ(KB,KS,LS,I,J1,J2,NYFLAG,          SGR,CGR,
     *  FMACH,ARB,NBEA,LBO,LSO,JBO,DT)
C   ***   GENERATES ROWS OF THE SUBMATRICES  DYP, DYZ  AND DYY
C         USING  SUBROUTINE  SUBB
      COMPLEX SUM,DT(1)
      DIMENSION ARB(1),NBEA(1)
      COMMON /DLBDY/ NJ1,NK1,NP,NB,NTP,NBZ,NBY,NTZ,NTY,NT0,NTZS,NTYS,
     *   INC,INS,INB,INAS,IZIN,IYIN,INBEA1,INBEA2,INSBEA,IZB,IYB,
     *   IAVR,IARB,INFL,IXLE,IXTE,INT121,INT122,IZS,IYS,ICS,IEE,ISG,
     *   ICG,IXIJ,IX,IDELX,IXIC,IXLAM,IA0,IXIS1,IXIS2,IA0P,IRIA
     *  ,INASB,IFLA1,IFLA2,ITH1A,ITH2A,
     *   ECORE,NEXT,SCR1,SCR2,SCR3,SCR4,SCR5
      COMMON /ZZZZZZ / Z(1)
      NDY  = 1
      NYFL = NYFLAG
      PI   = 3.1415926
      EPS  = 0.00001
      BETA = SQRT(1.0-FMACH**2)
      JZ   = 0
      LB   = LBO
C  LB  IS THE BODY NUMBER ASSOCIATED WITH SENDING POINT  J
      LS   = LSO
C  LS IS THE INDEX OF THE  Y  AND  Z  COORDINATES OF SENDING POINT  J --
C  LS RUNS FROM NSTRIP+NB-NBY+1  THROUGH  NSTRIP+NB
      JB   = JBO-1
      AR   = ARB(LB)
      DO  30  J=J1,J2
      JB   = JB+1
      JZ   = JZ+1
      CALL SUBB(KB,KS,I,J,JB,LB,LS,NDY,NYFL,          PI,EPS,
     *   SGR,CGR,AR,BETA,SUM,Z(IRIA),Z(IDELX),Z(IYB),Z(IZB),Z(IYS),
     *  Z(IZS),Z(IX))
      DT(J)= SUM
      IF  (JZ.EQ.NBEA(LB))    GO TO  20
      GO TO 30
   20 CONTINUE
      JZ   = 0
      LB   = LB+1
      LS   = LS+1
      AR   = ARB(LB)
   30 CONTINUE
      RETURN
      END

      SUBROUTINE SMA1A
C
C     THIS SUBROUTINE FORMERLY GENERATED THE KGG AND K4GG MATRICES FOR
C     THE SMA1 MODULE.  THESE OPERATIONS ARE NOW PERFORMED IN THE EMG
C     AND EMA MODULES AND SMA1A IS RETAINED IN SKELETAL FORM TO PROVIDE
C     A VEHICLE FOR USER-PROVIDED ELEMENTS.
C
      LOGICAL          DODET,NOGO,HEAT,NOHEAT
      INTEGER          IZ(1),EOR,CLSRW,CLSNRW,FROWIC,SYSPRT,TNROWS,
     1                 OUTRW,OPTION
      DOUBLE PRECISION DZ,DPWORD
      DIMENSION        INPVT(2),DZ(1),NAME(2)
      CHARACTER        UFM*23,UWM*25,UIM*29,SFM*25,SWM*27
      COMMON /XMSSG /  UFM,UWM,UIM,SFM,SWM
      COMMON /BLANK /  NOGENL,NOK4GG,OPTION(2)
      COMMON /SYSTEM/  KSYSTM(65)
      COMMON /SMA1HT/  HEAT
      COMMON /SMA1IO/  IFCSTM,IFMPT,IFDIT,IDUM1,IFECPT,IGECPT,IFGPCT,
     1                 IGGPCT,IFGEI,IGGEI,IFKGG,IGKGG,IF4GG,IG4GG,
     2                 IFGPST,IGGPST,INRW,OUTRW,CLSNRW,CLSRW,NEOR,EOR,
     3                 MCBKGG(7),MCB4GG(7)
      COMMON /ZZZZZZ/  Z(1)
      COMMON /SMA1BK/  ICSTM,NCSTM,IGPCT,NGPCT,IPOINT,NPOINT,I6X6K,
     1                 N6X6K,I6X64,N6X64
      COMMON /SMA1CL/  IOPT4,K4GGSW,NPVT,LLEFT,FROWIC,LROWIC,NROWSC,
     1                 TNROWS,JMAX,NLINKS,LINK(10),IDETCK,DODET,NOGOO
      COMMON /GPTA1 /  NELEMS,LAST,INCR,NE(1)
      COMMON /SMA1ET/  ECPT(200)
      COMMON /ZBLPKX/  DPWORD,DUM(2),INDEX
      EQUIVALENCE      (KSYSTM(2),SYSPRT),(KSYSTM(3),NOGO),
     1                 (KSYSTM(55),IPREC),(Z(1),IZ(1),DZ(1))
      DATA    NAME  /  4HSMA1, 4HA   /
C
C     FLAG FOR ERROR CHECK IF A NON-HEAT ELEMENT IS REFERENCED
C     IN A -HEAT- FORMULATION.
C
      NOHEAT = .FALSE.
      IPR = IPREC
C
C     READ THE FIRST TWO WORDS OF NEXT GPCT RECORD INTO INPVT(1).
C     INPVT(1) IS THE PIVOT POINT.  INPVT(1) .GT. 0 IMPLIES THE PIVOT
C     POINT IS A GRID POINT.  INPVT(1) .LT. 0 IMPLIES THE PIVOT POINT IS
C     A SCALAR POINT.  INPVT(2) IS THE NUMBER OF WORDS IN THE REMAINDER
C     OF THIS RECORD OF THE GPCT.
C
      IF (NOGO) WRITE (SYSPRT,5) SWM
    5 FORMAT (A27,' 2055, NOGO FLAG IS ON AT ENTRY TO SMA1A AND IS ',
     1       'BEING TURNED OFF.')
      NOGO   = .FALSE.
   10 IDETCK = 0
      CALL READ (*1000,*700,IFGPCT,INPVT(1),2,NEOR,IFLAG)
      NGPCT = INPVT(2)
      CALL READ (*1000,*3000,IFGPCT,IZ(IGPCT+1),NGPCT,EOR,IFLAG)
C
C     FROWIC IS THE FIRST ROW IN CORE. (1 .LE. FROWIC .LE. 6)
C
      FROWIC = 1
C
C     DECREMENT THE AMOUNT OF CORE REMAINING.
C
      LEFT = LLEFT - 2*NGPCT
      IF (LEFT .LE. 0) GO TO 3003
      IPOINT = IGPCT + NGPCT
      NPOINT = NGPCT
      I6X6K  = IPOINT + NPOINT
      I6X6K  = (I6X6K-1)/2 + 2
C
C     CONSTRUCT THE POINTER TABLE, WHICH WILL ENABLE SUBROUTINE SMA1B
C     TO ADD THE ELEMENT STRUCTURAL AND/OR DAMPING MATRICES TO KGG AND
C     K4GG.
C
      IZ(IPOINT+1) = 1
      I1  = 1
      I   = IGPCT
      J   = IPOINT + 1
   30 I1  = I1 + 1
      IF (I1 .GT. NGPCT) GO TO 40
      I   = I + 1
      J   = J + 1
      INC = 6
      IF (IZ(I) .LT. 0) INC = 1
      IZ(J) = IZ(J-1) + INC
      GO TO 30
C
C     JMAX = THE NUMBER OF COLUMNS OF KGG THAT WILL BE GENERATED WITH
C     THE CURRENT GRID POINT.
C
   40 INC   = 5
      ILAST = IGPCT  + NGPCT
      JLAST = IPOINT + NPOINT
      IF (IZ(ILAST) .LT. 0) INC = 0
      JMAX  = IZ(JLAST) + INC
C
C     TNROWS = THE TOTAL NUMBER OF ROWS OF THE MATRIX TO BE GENERATED
C              FOR THE CURRENT PIVOT POINT.
C     TNROWS = 6 IF THE CURRENT PIVOT POINT IS A GRID POINT.
C     TNROWS = 1 IF THE CURRENT PIVOT POINT IS A SCALAR POINT.
C
      TNROWS = 6
      IF (INPVT(1) .LT. 0) TNROWS = 1
C
C     IF 2*TNROWS*JMAX .LT. LEFT THERE ARE NO SPILL LOGIC PROBLEMS FOR
C     THE KGG SINCE THE WHOLE DOUBLE PRECISION SUBMATRIX OF ORDER TNROWS
C     X JMAX CAN FIT IN CORE.
C
      ITEMP = TNROWS*JMAX
      IF (2*ITEMP .LT. LEFT) GO TO 80
      NAME(2) = INPVT(1)
      CALL MESAGE (30,85,NAME)
C
C     THE WHOLE MATRIX CANNOT FIT IN CORE, DETERMINE HOW MANY ROWS CAN
C     FIT. IF TNROWS = 1, WE CAN DO NOTHING FURTHER.
C
      IF (TNROWS .EQ. 1) GO TO 3003
      NROWSC = 3
   70 IF (2*NROWSC*JMAX .LT. LEFT) GO TO 90
      NROWSC = NROWSC - 1
      IF (NROWSC .EQ. 0) CALL MESAGE (-8,0,NAME)
      GO TO 70
   80 NROWSC = TNROWS
   90 FROWIC = 1
C
C     LROWIC IS THE LAST ROW IN CORE. (1 .LE. LROWIC .LE. 6)
C
      LROWIC = FROWIC + NROWSC - 1
C
C     ZERO OUT THE KGG SUBMATRIX IN CORE
C
  100 LOW = I6X6K + 1
      LIM = I6X6K + JMAX*NROWSC
      DO 115 I = LOW,LIM
  115 DZ(I) = 0.0D0
C
C     CHECK TO SEE IF THE K4GG MATRIX IS DESIRED.
C
      IF (IOPT4 .EQ. 0) GO TO 137
C
C     SINCE THE K4GG MATRIX IS TO BE COMPUTED, DETERMINE IF IT TOO CAN
C     FIT INTO CORE
C
      IF (NROWSC .NE. TNROWS) GO TO 120
      IF (4*TNROWS*JMAX .LT. LEFT)  GO TO 130
C
C     OPEN A SCRATCH FILE FOR K4GG.
C
  120 CALL MESAGE (-8,0,NAME)
C
C     THIS CODE TO BE FILLED IN LATER
C     ===============================
C
  130 I6X64 = I6X6K + JMAX*TNROWS
      LOW   = I6X64 + 1
      LIM   = I6X64 + JMAX*TNROWS
      DO 135 I = LOW,LIM
  135 DZ(I) = 0.0D0
C
C     INITIALIZE THE LINK VECTOR TO -1.
C
  137 DO 140 I = 1,NLINKS
  140 LINK(I) = -1
C
C     TURN FIRST PASS INDICATOR ON.
C
  150 IFIRST = 1
C
C     READ THE 1ST WORD OF THE ECPT RECORD, THE PIVOT POINT, INTO NPVT.
C
      CALL FREAD (IFECPT,NPVT,1,0)
C
C     READ THE NEXT ELEMENT TYPE INTO THE CELL ITYPE.
C
  160 CALL READ (*3025,*500,IFECPT,ITYPE,1,NEOR,IFLAG)
      IF (ITYPE.GE.53 .OR. ITYPE.LE.61) GO TO 165
      CALL PAGE2 (-3)
      WRITE  (SYSPRT,161) UFM,ITYPE
  161 FORMAT (A23,' 2201, ELEMENT TYPE',I4,' NO LONGER SUPPORTED BY ',
     1       'SMA1 MODULE.', /5X,
     2       'USE EMG AND EMA MODULES FOR ELEMENT MATRIX GENERATION')
      NOGO = .TRUE.
      GO TO 1000
  165 CONTINUE
C
C     READ THE ECPT ENTRY FOR THE CURRENT TYPE INTO THE ECPT ARRAY. THE
C     NUMBER OF WORDS TO BE READ WILL BE NWORDS(ITYPE).
C
      IDX = (ITYPE-1)*INCR
      CALL FREAD (IFECPT,ECPT,NE(IDX+12),0)
      ITEMP = NE(IDX+22)
C
C     IF THIS IS THE 1ST ELEMENT READ ON THE CURRENT PASS OF THE ECPT
C     CHECK TO SEE IF THIS ELEMENT IS IN A LINK THAT HAS ALREADY BEEN
C     PROCESSED.
C
      IF (IFIRST .EQ. 1) GO TO 170
C
C     THIS IS NOT THE FIRST PASS.  IF ITYPE(TH) ELEMENT ROUTINE IS IN
C     CORE, PROCESS IT.
C
      IF (ITEMP .EQ. LINCOR) GO TO 180
C
C     THE ITYPE(TH) ELEMENT ROUTINE IS NOT IN CORE.  IF THIS ELEMENT
C     ROUTINE IS IN A LINK THAT ALREADY HAS BEEN PROCESSED READ THE NEXT
C     ELEMENT.
C
      IF (LINK(ITEMP) .EQ. 1) GO TO 160
C
C     SET A TO BE PROCESSED LATER FLAG FOR THE LINK IN WHICH THE ELEMENT
C     RESIDES
C
      LINK(ITEMP) = 0
      GO TO 160
C
C     SINCE THIS IS THE FIRST ELEMENT TYPE TO BE PROCESSED ON THIS PASS
C     OF THE ECPT RECORD, A CHECK MUST BE MADE TO SEE IF THIS ELEMENT
C     IS IN A LINK THAT HAS ALREADY BEEN PROCESSED.  IF IT IS SUCH AN
C     ELEMENT, WE KEEP IFIRST = 1 AND READ THE NEXT ELEMENT.
C
  170 IF (LINK(ITEMP) .EQ. 1) GO TO 160
C
C     SET THE CURRENT LINK IN CORE = ITEMP AND IFIRST = 0
C
      LINCOR = ITEMP
      IFIRST = 0
      ITYPX  = ITYPE - 52
C
C     CALL THE PROPER ELEMENT ROUTINE.
C
  180 GO TO (
C                                  CDUM1   CDUM2   CDUM3   CDUM4
C                                    53      54      55      56
     7                              467,    468,    469,    470,
C          CDUM5   CDUM6   CDUM7   CDUM8   CDUM9
C            57      58      59      60      61
     8     471,    472,    473,    474,    475  ) , ITYPX
C
C
  467 CALL KDUM1
      GO TO 160
  468 CALL KDUM2
      GO TO 160
  469 CALL KDUM3
      GO TO 160
  470 CALL KDUM4
      GO TO 160
  471 CALL KDUM5
      GO TO 160
  472 CALL KDUM6
      GO TO 160
  473 CALL KDUM7
      GO TO 160
  474 CALL KDUM8
      GO TO 160
  475 CALL KDUM9
      GO TO 160
C
C     AT STATEMENT NO. 500 WE HAVE HIT AN EOR ON THE ECPT FILE.  SEARCH
C     THE LINK VECTOR TO DETERMINE IF THERE ARE LINKS TO BE PROCESSED.
C
  500 LINK(LINCOR) = 1
      DO  510 I = 1,NLINKS
      IF (LINK(I) .EQ. 0) GO TO 520
  510 CONTINUE
      GO TO 525
C
C     SINCE AT LEAST ONE LINK HAS NOT BEEN PROCESSED THE ECPT FILE MUST
C     BE BACKSPACED.
C
  520 CALL BCKREC (IFECPT)
      GO TO 150
C
C    CHECK NOGOO FLAG. IF 1 SKIP BKDPK AND PROCESS ANOTHER GRID POINT
C    FROM GPCT
C
  525 IF (NOGOO .EQ. 1) GO TO 10
C
C     IF NO GENERAL ELEMENTS EXIST, CHECK FOR GRID POINT SINGULARITIES.
C
CWKBR IF (DODET) CALL DETCK (0)
      IF (DODET) CALL DETCK (0,NPVT,IFGPST)
C
C     AT THIS POINT BLDPK THE NUMBER OF ROWS IN CORE UNTO THE KGG FILE.
C
      ASSIGN 580 TO IRETRN
      IFILE= IFKGG
      IMCB = 1
  530 I1   = 0
  540 I2   = 0
      IBEG = I6X6K + I1*JMAX
      CALL BLDPK (2,IPR,IFILE,0,0)
  550 I2  = I2 + 1
      IF (I2 .GT. NGPCT) GO TO 570
      JJ  = IGPCT + I2
      INDEX = IABS(IZ(JJ)) - 1
      LIM = 6
      IF (IZ(JJ) .LT. 0) LIM = 1
      JJJ = IPOINT + I2
      KKK = IBEG + IZ(JJJ) - 1
      I3  = 0
  560 I3  = I3 + 1
      IF (I3 .GT. LIM) GO TO 550
      INDEX = INDEX + 1
      KKK = KKK + 1
      DPWORD = DZ(KKK)
      IF (DPWORD .NE. 0.0D0) CALL ZBLPKI
      GO TO 560
  570 CALL BLDPKN (IFILE,0,MCBKGG(IMCB))
      I1 = I1 + 1
      IF (I1 .LT. NROWSC) GO TO 540
      GO TO IRETRN, (580,600)
C
C     IF THE K4GG IS CALLED FOR, BLDPK IT.
C
  580 IF (IOPT4 .EQ.  0) GO TO 600
      IF (IOPT4 .EQ. -1) GO TO 590
C
C     THE K4GG MATRIX IS IN CORE.
C
      ASSIGN 600 TO IRETRN
      I6X6K = I6X64
      IFILE = IF4GG
      IMCB  = 8
      GO TO 530
C
C     HERE WE NEED LOGIC TO READ K4GG FROM A SCRATCH FILE AND INSERT.
C
  590 CONTINUE
C
C     TEST TO SEE IF THE LAST ROW IN CORE, LROWIC, = THE TOTAL NO. OF
C     ROWS TO BE COMPUTED, TNROWS.  IF IT IS, WE ARE DONE.  IF NOT, THE
C     ECPT MUST BE BACKSPACED.
C
  600 IF (LROWIC .EQ. TNROWS) GO TO 10
      CALL BCKREC (IFECPT)
      FROWIC = FROWIC + NROWSC
      LROWIC = LROWIC + NROWSC
      GO TO 100
C
C     CHECK NOGOO = 1 SKIP BLDPK AND PROCESS ANOTHER RECORD
C
  700 IF (NOGOO .EQ. 1) GO TO 10
C
C     HERE WE HAVE A PIVOT POINT WITH NO ELEMENTS CONNECTED, SO THAT
C     NULL COLUMNS MUST BE OUTPUT ON THE KGG AND K4GG FILES.  IF DODET
C     IS TRUE, CALL THE DETERMINANT CHECK ROUTINE TO WRITE SINGULARITY
C     INFORMATION.
C
      NPVT = IABS(INPVT(1))
      IF (INPVT(1) .GT. 0) GO TO 703
      LIM  = 1
      IXX  = -1
      GO TO 706
  703 LIM  = 6
      IXX  = 1
CWKBR  706 IF (DODET) CALL DETCK (IXX)
  706 IF (DODET) CALL DETCK (IXX,NPVT,IFGPST)
      DO 710 I = 1,LIM
      CALL BLDPK (2,IPR,IFKGG,0,0)
      CALL BLDPKN (IFKGG,0,MCBKGG)
      IF (IOPT4 .NE. 1) GO TO 710
      CALL BLDPK (2,IPR,IF4GG,0,0)
      CALL BLDPKN (IF4GG,0,MCB4GG)
  710 CONTINUE
      CALL SKPREC (IFECPT,1)
      GO TO 10
C
C     RETURN SINCE AN EOF HAS BEEN HIT ON THE GPCT FILE
C
 1000 IF (.NOT.NOGO .AND. NOGOO.EQ.0) RETURN
      IPARM = -61
      GO TO 4010
C
C     ERROR RETURNS
C
 3000 IFILE = IFGPCT
      GO TO 4003
 3003 IPARM = -8
      GO TO 4010
 3025 IFILE = IFECPT
      IPARM = -2
      GO TO 4010
 4003 IPARM = -3
 4010 CALL MESAGE (IPARM,IFILE,NAME)
      CALL MESAGE (-30,87,ITYPE)
      RETURN
      END

      SUBROUTINE CMCKCD
C
C     THIS SUBROUTINE DETERMINES WHETHER MANUALLY SPECIFIED CONNECTION
C     ENTRIES ARE ALLOWABLE BASED ON THE PRESCRIBED GEOMETRIC TOLERANCE.
C
      INTEGER         SCSFIL,COMBO,SCORE,IST(7),SCCONN,CE(9),AAA(2),
     1                BUF2,OUTT
      DIMENSION       IPNUM(7),COORD(7,3),DIFF2(3)
      CHARACTER       UFM*23,UWM*25,UIM*29
      COMMON /XMSSG / UFM,UWM,UIM
      COMMON /CMB001/ SCR1,SCR2,SCBDAT,SCSFIL,SCCONN,SCMCON,SCTOC,
     1                GEOM4,CASECC,SCCSTM,SCR3
      COMMON /CMB002/ BUF1,BUF2,BUF3,BUF4,BUF5,SCORE,LCORE,INTP,OUTT
      COMMON /CMB003/ COMBO(7,5),CONSET,IAUTO,TOLER,NPSUB,CONECT,TRAN,
     1                MCON,RESTCT(7,7),ISORT,ORIGIN(7,3),IPRINT
      COMMON /ZZZZZZ/ Z(1)
      COMMON /BLANK / STEP,IDRY
      DATA    AAA   / 4HCMCK,4HCD   /
C
C     READ ALL BGSS INTO OPEN CORE
C
      IT    = 2
      IERR  = 0
      LLCO  = LCORE
      J     = 0
      IFILE = SCSFIL
      CALL OPEN (*200,SCSFIL,Z(BUF2),0)
      DO 30 I = 1,NPSUB
      NREC  = COMBO(I,5) + 1
      DO 10 JJ = 1,NREC
      CALL FWDREC (*210,SCSFIL)
   10 CONTINUE
      CALL READ (*210,*20,SCSFIL,Z(SCORE+J),LLCO,1,NNN)
      GO TO 220
   20 IST(I) = SCORE + J
      J = J + NNN
      LLCO  = LLCO - NNN
      CALL SKPFIL (SCSFIL,1)
   30 CONTINUE
      CALL CLOSE (SCSFIL,1)
C
C     READ CONNECTION ENTRIES AND LOAD INTO COORD ARRAY
C
      IFILE = SCCONN
      CALL OPEN (*200,SCCONN,Z(BUF2),0)
   40 CALL READ (*180,*50,SCCONN,CE,10,1,NNN)
C
C     LOAD COORD ARRAY
C     CE(3)... UP TO CE(9) ARE INTERNAL POINT NO.
C     IZ(IADD) IS THE COORD (CSTM) ID OF THE INTERNAL PTS.
C     Z(IADD+1,+2,+3) ARE THE COORD. ORIGINS
C
   50 NPT  = 0
      DO 80 I = 1,NPSUB
      IF (CE(I+2)) 80,80,60
   60 NPT  = NPT + 1
      IADD = 4*(CE(I+2)-1) + IST(I)
      IPNUM(NPT) = CE(I+2)
      DO 70 J = 1,3
      COORD(NPT,J) = Z(IADD+J)
   70 CONTINUE
   80 CONTINUE
C
C     COMPARE ALL PAIRS OF COORDINATES AGAINST TOLER.
C
      NPTM1 = NPT - 1
      DO 170 I = 1,NPTM1
      IT = IT - 1
      JJ = I  + 1
      DO 160 J = JJ,NPT
      DO 90 KK = 1,3
      DIFF2(KK) = (COORD(J,KK)-COORD(I,KK))**2
   90 CONTINUE
      SUM  = 0.0
      DO 100 KK = 1,3
      SUM  = SUM + DIFF2(KK)
  100 CONTINUE
      DIST = SQRT(SUM)
      IF (DIST .LE. TOLER) GO TO 160
      IF (IT .GT. 1) GO TO 120
      WRITE  (OUTT,110) UFM
  110 FORMAT (A23,' 6514, ERRORS HAVE BEEN FOUND IN MANUALLY SPECIFIED',
     1       ' CONNECTION ENTRIES. SUMMARY FOLLOWS')
      IERR = 1
      IDRY =-2
      IT   = 2
  120 IF (IT .GT. 2) GO TO 140
      WRITE  (OUTT,130) (CE(KDH),KDH=1,NNN)
  130 FORMAT ('0*** GEOMETRIC ERRORS HAVE BEEN FOUND IN THE FOLLOWING',
     1        ' CONNECTION ENTRY', /5X,9I10)
      IT   = 3
  140 WRITE (OUTT,150) IPNUM(I),(COORD(I,MM),MM=1,3),
     1                 IPNUM(J),(COORD(J,MM),MM=1,3)
  150 FORMAT ('0*** IP NUMBER',I10,13H COORDINATES  ,3E16.6,4H AND, /,
     1        '     IP NUMBER',I10,13H COORDINATES  ,3E16.6,
     2        ' ARE NOT WITHIN TOLER UNITS.')
  160 CONTINUE
  170 CONTINUE
      GO TO 40
C
  180 IF (IERR .EQ. 0) WRITE (OUTT,190) UIM
  190 FORMAT (A29,' 6516, ALL MANUAL CONNECTIONS SPECIFIED ARE ',
     1       'ALLOWABLE WITH RESPECT TO TOLERANCE')
      CALL CLOSE (SCCONN,1)
      GO TO 250
C
  200 IMSG = -1
      GO TO 230
  210 IMSG = -2
      GO TO 230
  220 IMSG = -8
  230 CALL MESAGE (IMSG,IFILE,AAA)
C
  250 RETURN
      END

      SUBROUTINE RCOVA
C
C     RCOVA CREATES THE SOLN ITEM FOR A FINAL SOLUTION STRUCTURE (FSS)
C     IN PHASE 2 OF SUBSTRUCTURING
C
      LOGICAL         MRECVR
      INTEGER         IZ(1)      ,NAME(2)    ,SOLN       ,DRY        ,
     1                STEP       ,FSS        ,RFNO       ,BUF1       ,
     2                BUF2       ,BUF3       ,SYSBUF     ,RC         ,
     3                SOF1       ,SOF2       ,SOF3       ,KM(5)      ,
     4                KMU(5)     ,SCHK       ,UVEC       ,PHIS       ,
     5                SCR1
      COMMON /BLANK / DRY        ,LOOP       ,STEP       ,FSS(2)     ,
     1                RFNO       ,NEIGV      ,LUI        ,UINMS(2,5) ,
     2                NOSORT     ,UTHRES     ,PTHRES     ,QTHRES
      COMMON /RCOVCR/ ICORE      ,LCORE      ,BUF1       ,BUF2       ,
     1                BUF3       ,BUF4       ,SOF1       ,SOF2       ,
     2                SOF3
      COMMON /RCOVCM/ MRECVR     ,UA         ,PA         ,QA         ,
     1                IOPT       ,RSS(2)     ,ENERGY     ,UIMPRO     ,
     2                RANGE(2)   ,IREQ       ,LREQ       ,LBASIC
      COMMON /SYSTEM/ SYSBUF     ,NOUT
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE     (Z(1),IZ(1))
      DATA    SOLN  , UVEC,  PHIS / 4HSOLN,4HUVEC,4HPHIS /
      DATA    KM    / 4HKMTX,4HMMTX,4HUVEC,4HBMTX,4HK4MX /
      DATA    KMU   / 103,104,106,109,110 /
      DATA    SCHK  / 3   /
      DATA    SCR1  / 301 /
      DATA    NAME  / 4HRCOV,4HA    /
C
C     INITIALIZE
C
      SOF1 = KORSZ(Z) - LREQ - SYSBUF + 1
      SOF2 = SOF1 - SYSBUF - 1
      SOF3 = SOF2 - SYSBUF
      BUF1 = SOF3 - SYSBUF
      BUF2 = BUF1 - SYSBUF
      BUF3 = BUF2 - SYSBUF
      ICORE= 1
      LCORE= BUF3 - 1
      IF (LCORE .LE. 0) CALL MESAGE (-8,0,NAME)
      CALL SOFOPN (Z(SOF1),Z(SOF2),Z(SOF3))
C
C     COPY KGG, MGG, UVEC, BGG AND K4GG TO THE SOF IF THEY ARNT THERE
C
      DO 20 I = 1,5
      IF (KM(I).EQ.UVEC .AND. MRECVR) GO TO 20
      IF (DRY .LT. 0) GO TO 5
    3 CALL MTRXO (KMU(I),FSS,KM(I),Z(BUF1),RC)
      GO TO (20,15,20,10,10,20), RC
    5 RC = 2
      CALL MTRXO (-1,FSS,KM(I),0,RC)
      GO TO 20
   10 CALL SMSG (RC-2,KM(I),FSS)
      GO TO 20
   15 CALL DELETE (FSS,KM(I),RC)
      GO TO 3
   20 CONTINUE
      IF (DRY) 440,70,70
C
C     IF MODAL RECOVER, COPY PHIS ITEM TO UVEC
C
   70 IF (.NOT.MRECVR) GO TO 90
      RFNO = 3
      CALL MTRXI (SCR1,FSS,PHIS,0,RC)
      IF (RC .EQ. 1) GO TO 80
      CALL SMSG (RC-2,PHIS,FSS)
      GO TO 9100
   80 CALL MTRXO (SCR1,FSS,UVEC,0,RC)
C
C     ATTEMPT TO FETCH SOLN ITEM FOR FSS.  IF IT ALREADY EXISTS, RETURN
C
   90 CALL SFETCH (FSS,SOLN,SCHK,RC)
      IF (RC .EQ. 1) GO TO 440
      IF (RC .EQ. 3) GO TO 100
      CALL SMSG (RC-2,SOLN,FSS)
      GO TO 440
C
C     CREATE SOLN ITEM FOR PROPER RIGID FORMAT
C
  100 IF (RFNO.LT.0 .OR. RFNO.GT.9) GO TO 9007
      GO TO (110,110,130,9007,9007,9007,9007,180,180) , RFNO
C
C     STATIC SOLUTION - R.F. 1 AND 2
C
  110 CALL RCOVSS
      GO TO 440
C
C     MODAL SOLUTION - R.F. 3
C
  130 CALL RCOVMS
      GO TO 440
C
C     DYNAMIC SOLUTION - R.F. 8 AND 9
C
  180 CALL RCOVDS
      GO TO 440
C
C     FINISHED
C
  440 CALL SOFCLS
      RETURN
C
C     DIAGNOSTICS
C
 9007 CALL MESAGE (7,0,NAME)
 9100 IOPT = -1
      CALL SOFCLS
      RETURN
      END

      SUBROUTINE TRIA3S
C
C     SINGLE PRECISION ROUTINE TO FORM STIFFNESS, MASS, AND DAMPING
C     MATRICES FOR THE CTRIA3 ELEMENT
C
C                 EST  LISTING
C
C        WORD     TYP       DESCRIPTION
C     ----------------------------------------------------------------
C     ECT:
C         1        I   ELEMENT ID, EID
C         2-4      I   SIL LIST, GRIDS 1,2,3
C         5-7      R   MEMBRANE THICKNESSES T, AT GRIDS 1,2,3
C         8        R   MATERIAL PROPERTY ORIENTAION ANGLE, THETA
C               OR I   COORD. SYSTEM ID (SEE TM ON CTRIA3 CARD)
C         9        I   TYPE FLAG FOR WORD 8
C        10        R   GRID OFFSET, ZOFF
C    EPT:
C        11        I   MATERIAL ID FOR MEMBRANE, MID1
C        12        R   ELEMENT THICKNESS,T (MEMBRANE, UNIFORMED)
C        13        I   MATERIAL ID FOR BENDING, MID2
C        14        R   MOMENT OF INERTIA FACTOR, I (BENDING)
C        15        I   MATERIAL ID FOR TRANSVERSE SHEAR, MID3
C        16        R   TRANSV. SHEAR CORRECTION FACTOR, TS/T
C        17        R   NON-STRUCTURAL MASS, NSM
C        18-19     R   STRESS FIBER DISTANCES, Z1,Z2
C        20        I   MATERIAL ID FOR MEMBRANE-BENDING COUPLING, MID4
C        21        R   MATERIAL ANGLE OF ROTATION, THETA
C               OR I   COORD. SYSTEM ID (SEE MCSID ON PSHELL CARD)
C                      (DEFAULT FOR WORD 8)
C        22        I   TYPE FLAG FOR WORD 21 (DEFAULT FOR WORD 9)
C        23        I   INTEGRATION ORDER FLAG
C        24        R   STRESS ANGLE OF RATATION, THETA
C               OR I   COORD. SYSTEM ID (SEE SCSID ON PSHELL CARD)
C        25        I   TYPE FLAG FOR WORD 24
C        26        R   OFFSET, ZOFF1 (DEFAULT FOR WORD 10)
C    BGPDT:
C        27-38   I/R   CID,X,Y,Z  FOR GRIDS 1,2,3
C    ETT:
C        39        I   ELEMENT TEMPERATURE
C
C
      LOGICAL          HEAT,NOALFA,NEEDK,NEEDM,SHEART,
     1                 MEMBRN,BENDNG,SHRFLX,MBCOUP,NORPTH
      INTEGER          SYSBUF,NOUT,NOGO,PREC,HUNMEG,NEST(39),NAME(2),
     1                 NECPT(4),DICT(11),IGPDT(4,3),ELID,ESTID,DMAT,
     2                 SIL(3),IORDER(3),CPMASS,MID(4),TYPE,INDEX(3,3)
      REAL             BGPDT(4,3),GPTH(3),NSM,ECPT(4),KHEAT,HTCP
      REAL             AMGG(1),AKGG(1),ALPHA(1),THETAM,CENTE(3),
     1                 DGPTH(3),EGPDT(4,3),EPNORM(4,3),GPNORM(4,3),
     2                 AREA,WTSTIF,WTMASS,RHO,XMASS(9),XMASSO,LX,LY,
     3                 EPS,OFFSET,SHPT(3),WEIGHT,G(9,9),GI(36),K11,K22,
     4                 JOK,JOG,ZZ(9),AIC(18),EGNOR(4),EDGLEN(3),
     5                 BMTRX(54),BMATRX(162),BTERMS(6),BMAT1(486),
     6                 AVGTHK,MOMINR,TS,TH,REALI,TSI,TSM,BDUM(3),
     7                 DETERM,DETJAC,TBG(9),TEB(9),TEM(9),TEU(9),
     8                 TUB(9),TUM(9),TOTTRN(324),TRANSK(324),TRANS(27),
     9                 TMPTRN(36),HTFLX(18),HTCAP(36),HTCON(36),
     O                 DHEAT,WEITC,DVOL
      COMMON /SYSTEM/  SYSBUF,NOUT,NOGO,IDUM(51),PREC
      COMMON /MATIN /  MATID,INFLAG,ELTEMP,DUMMY,SINMAT,COSMAT
      COMMON /HMTOUT/  KHEAT(7),TYPE
      COMMON /TERMS /  MEMBRN,BENDNG,SHRFLX,MBCOUP,NORPTH
      COMMON /EMGPRM/  ICORE,JCORE,NCORE,ICSTM,NCSTM,IMAT,NMAT,IHMAT,
     1                 NHMAT,IDIT,NDIT,ICONG,NCONG,LCONG,ANYCON,
     2                 KGG1,MGG1,IBGG1,PRECIS,ERROR,HEAT,CPMASS,
     3                 DUMM6(6),L38
      COMMON /EMGEST/  EST(39)
      COMMON /EMGDIC/  ELTYPE,LDICT,NLOCS,ELID,ESTID
      COMMON /ZZZZZZ/  Z(1)
      EQUIVALENCE      (EST( 1),NEST(1)), (EST( 2),SIL(1)),
     1                 (EST( 5),GPTH(1)), (EST(10),ZOFF),
     2                 (EST(12),ELTH)   , (EST(17),NSM),
     3                 (EST(23),INT)    , (EST(26),ZOFF1),
     4                 (EST(27),BGPDT(1,1),IGPDT(1,1)),
     5                 (EST(39),TEMPEL) , (DICT(5),ADAMP),
     6                 (NECPT(1),ECPT(1)),(Z(1),AMGG(1),AKGG(1)),
     7                 (KHEAT(4),HTCP)  , (HTCAP(1),XMASS(1))
      DATA     HUNMEG, EPS / 100000000, 1.0E-7 /
      DATA     NAME  , KMAT, MMAT, DMAT / 4HCTRI,4HA3  , 1, 2, 3 /
C
C     INITIALIZE
C
      ELID   = NEST(1)
      NNODE  = 3
      MOMINR = 0.0
      TS     = 0.0
      WEIGHT = 1.0/6.0
      ELTEMP = TEMPEL
      NEEDK  = KGG1.NE.0 .OR. IBGG1.NE.0
      NOALFA = .TRUE.
      SHEART = .TRUE.
      IEOE   = 1
      OFFSET = ZOFF
      IF (ZOFF .EQ. 0.0) OFFSET = ZOFF1
C
C     CHECK FOR SUFFICIENT OPEN CORE FOR ELEMENT STIFFNESS
C
C     OPEN CORE BEGINS AT JCORE
C     OPEN CORE ENDS   AT NCORE
C     LENGTH OF AVAILABLE WORDS = (NCORE-JCORE-1)/PREC
C
      JCORED = JCORE/PREC + 1
      LENGTH = (NCORE-JCORE-1)/PREC
      IF (LENGTH.LT.324 .AND. (.NOT.HEAT .AND. NEEDK)) GO TO 1100
C
C     SET UP THE ELEMENT FORMULATION
C
      CALL T3SETS (IERR,SIL,IGPDT,ELTH,GPTH,DGPTH,EGPDT,GPNORM,EPNORM,
     1             IORDER,TEB,TUB,CENTE,AVGTHK,LX,LY,EDGLEN,ELID)
      IF (IERR .NE. 0) GO TO 1110
      CALL GMMATS (TEB,3,3,0, TUB,3,3,1, TEU)
      AREA = LX*LY/2.0
C
C     SET THE NUMBER OF DOF'S
C
      NNOD2 = NNODE*NNODE
      NDOF  = NNODE*6
      NPART = NDOF*NDOF
      ND2   = NDOF*2
      ND6   = NDOF*6
      ND7   = NDOF*7
      ND8   = NDOF*8
      ND9   = NDOF*9
      JEND  = JCORED + NPART - 1
C
C     OBTAIN MATERIAL INFORMATION
C
C     PASS THE LOCATION OF THE ELEMENT CENTER FOR MATERIAL
C     TRANSFORMATIONS.
C
      DO 100 IEC = 2,4
      ECPT(IEC) = CENTE(IEC-1)
  100 CONTINUE
C
C     SET MATERIAL FLAGS
C     5.0/6.0 = 0.833333333
C
      IF (NEST(13) .NE.   0) MOMINR = EST(14)
      IF (NEST(13) .NE.   0) TS = EST(16)
      IF ( EST(16) .EQ. 0.0) TS = 0.83333333
      IF (NEST(13).EQ.0 .AND. NEST(11).GT.HUNMEG) TS = 0.833333333
C
      MID(1) = NEST(11)
      MID(2) = NEST(13)
      MID(3) = NEST(15)
      MID(4) = NEST(20)
C
      MEMBRN = MID(1).GT.0
      BENDNG = MID(2).GT.0 .AND. MOMINR.GT.0.0
      SHRFLX = MID(3).GT.0
      MBCOUP = MID(4).GT.0
      NORPTH = MID(1).EQ.MID(2) .AND. MID(1).EQ.MID(3) .AND. MID(4).EQ.0
     1         .AND. ABS(MOMINR-1.0).LE.EPS
C
C     SET UP TRANSFORMATION MATRIX FROM MATERIAL TO ELEMENT COORD.SYSTEM
C
      CALL SHCSGS (*1120,NEST(9),NEST(8),NEST(8),NEST(21),NEST(20),
     1             NEST(20),NECPT,TUB,MCSID,THETAM,TUM)
C
C     BRANCH ON FORMULATION TYPE.
C
      IF (HEAT) GO TO 800
C
C     FETCH MATERIAL PROPERTIES
C
      CALL GMMATS (TEU,3,3,0,TUM,3,3,0,TEM)
      CALL SHGMGS (*1130,ELID,TEM,MID,TS,NOALFA,GI,RHO,GSUBE,TSUB0,
     1             EGNOR,ALPHA)
C
C     TURN OFF THE COUPLING FLAG WHEN MID4 IS PRESENT WITH ALL
C     CALCULATED ZERO TERMS.
C
      IF (.NOT.MBCOUP) GO TO 120
      DO 110 I = 28,36
      IF (ABS(GI(I)) .GT. EPS) GO TO 120
  110 CONTINUE
      MBCOUP = .FALSE.
  120 CONTINUE
C
C     GET THE GEOMETRY CORRECTION TERMS
C
      IF (.NOT.BENDNG) GO TO 130
      CALL T3GEMS (IERR,EGPDT,IORDER,GI(10),GI(19),LX,LY,EDGLEN,SHRFLX,
     1             AIC,JOG,JOK,K11,K22)
      IF (IERR .NE. 0) GO TO 1110
C
C     REDUCED INTEGRATION LOOP FOR STIFFNESS
C
  130 IF (.NOT.NEEDK .OR. INT.NE.0) GO TO 160
C
C     DETERMINE THE AVERAGE [B] FOR OUT-OF-PLANE SHEAR
C
      DO 140 IPT = 1,3
      KPT = (IPT-1)*ND9 + 1
      CALL T3BMGS (IERR,SHEART,IPT,IORDER,EGPDT,DGPTH,AIC,TH,DETJAC,
     1             SHPT,BTERMS,BMAT1(KPT))
      IF (IERR .NE. 0) GO TO 1110
  140 CONTINUE
C
      DO 150 I = 1,NDOF
      BMTRX(I     ) = BMAT1(I+ND6) +BMAT1(I+ND6+ND9) +BMAT1(I+ND6+2*ND9)
      BMTRX(I+NDOF) = BMAT1(I+ND7) +BMAT1(I+ND7+ND9) +BMAT1(I+ND7+2*ND9)
      BMTRX(I+ND2 ) = BMAT1(I+ND8) +BMAT1(I+ND8+ND9) +BMAT1(I+ND8+2*ND9)
  150 CONTINUE
C
C     INITIALIZE FOR THE MAIN INTEGRATION LOOP
C
  160 NEEDM = MGG1.NE.0 .AND. (NSM.GT.0.0 .OR. RHO.GT.0.0)
      IF (.NOT.NEEDK .AND. .NOT.NEEDM) GO TO 200
      DO 170 I = JCORED,JEND
      AKGG(I) = 0.0
  170 CONTINUE
C
      DO 180 I = 1,9
      XMASS(I) = 0.0
  180 CONTINUE
C
C     MAIN INTEGRATION LOOP
C
  200 DO 500 IPT = 1,3
C
      CALL T3BMGS (IERR,SHEART,IPT,IORDER,EGPDT,DGPTH,AIC,TH,DETJAC,
     1             SHPT,BTERMS,BMATRX)
      IF (IERR .NE. 0) GO TO 1110
C
C     PERFORM STIFFNESS CALCULATIONS IF REQUIRED
C
      IF (.NOT.NEEDK) GO TO 400
      WTSTIF = DETJAC*WEIGHT
      REALI  = MOMINR*TH*TH*TH/12.0
      TSI = TS*TH
C
      IF (INT .NE. 0) GO TO 220
      DO 210 IX = 1,NDOF
      BMATRX(IX+ND6) = BMTRX(IX     )
      BMATRX(IX+ND7) = BMTRX(IX+NDOF)
      BMATRX(IX+ND8) = BMTRX(IX+ND2 )
  210 CONTINUE
C
C     FILL IN THE 9X9 [G]
C
  220 DO 240 IG = 1,9
      DO 230 JG = 1,9
      G(IG,JG) = 0.0
  230 CONTINUE
  240 CONTINUE
C
      IF (.NOT.MEMBRN) GO TO 270
      DO 260 IG = 1,3
      IG1 = (IG-1)*3
      DO 250 JG = 1,3
      G(IG,JG) = GI(IG1+JG)*TH*WTSTIF
  250 CONTINUE
  260 CONTINUE
C
  270 IF (.NOT.BENDNG) GO TO 340
      DO 290 IG = 4,6
      IG2 = (IG-2)*3
      DO 280 JG = 4,6
      G(IG,JG) = GI(IG2+JG)*REALI*WTSTIF
  280 CONTINUE
  290 CONTINUE
C
      TSM   = 1.0/(2.0*12.0*REALI)
      ZZ(1) = (JOG/TSI)* GI(22) + TSM*JOK*K22
      ZZ(2) =-(JOG/TSI)*(GI(20) + GI(21))/2.0
      ZZ(3) = 0.0
      ZZ(4) = ZZ(2)
      ZZ(5) = (JOG/TSI)* GI(19) + TSM*JOK*K11
      ZZ(6) = 0.0
      ZZ(7) = 0.0
      ZZ(8) = 0.0
      ZZ(9) = (JOG/TSI)*(GI(22) + GI(19))/2.0
     1      + TSM*12.0*AREA/SQRT(GI(10)*GI(14))
      CALL INVERS (3,ZZ,3,BDUM,0,DETERM,ISING,INDEX)
      IF (ISING .NE. 1) GO TO 1110
C
      DO 310 IG = 7,9
      IG3 = (IG-7)*3
      DO 300 JG = 7,9
      G(IG,JG) = ZZ(IG3+JG-6)*WTSTIF
  300 CONTINUE
  310 CONTINUE
C
      IF (.NOT.MBCOUP) GO TO 340
      DO 330 IG = 1,3
      IG4 = (IG+8)*3
      DO 320 JG = 1,3
      G(IG,JG+3) = GI(IG4+JG)*TH*TH*WTSTIF
      G(IG+3,JG) = G(IG,JG+3)
  320 CONTINUE
  330 CONTINUE
C
C     COMPUTE THE CONTRIBUTION TO THE STIFFNESS MATRIX FROM THIS
C     INTEGRATION POINT.
C
  340 CALL T3BGBS (9,NDOF,G,BMATRX,AKGG(JCORED))
C
C
C     END OF STIFFNESS CALCULATIONS.
C     SKIP MASS CALCULATIONS IF NOT REQUIRED
C
C
  400 IF (.NOT.NEEDM) GO TO 500
      WTMASS = (RHO*TH+NSM)*DETJAC*WEIGHT
      IF (CPMASS .LE. 0) GO TO 430
C
C     CONSISTENT MASS FORMULATION (OPTION)
C
      DO 420 I = 1,NNODE
      II = (I-1)*NNODE
      DO 410 J = 1,NNODE
      XMASS(II+J) = XMASS(II+J) + SHPT(I)*SHPT(J)*WTMASS
  410 CONTINUE
  420 CONTINUE
      GO TO 500
C
C     LUMPED MASS FORMULATION (DEFAULT)
C
  430 I3 = 1
      DO 440 I = 1,NNODE
      XMASS(I3) = XMASS(I3) + SHPT(I)*WTMASS
      I3 = I3 + 1 + NNODE
  440 CONTINUE
C
C     END OF MAIN INTEGRATION LOOP
C
  500 CONTINUE
C
C     PICK UP THE ELEMENT TO GLOBAL TRANSFORMATION FOR EACH NODE.
C
      DO 510 I = 1,NNODE
      IPOINT = 9*(I-1) + 1
      CALL TRANSS (IGPDT(1,I),TBG)
      CALL GMMATS (TEB,3,3,0, TBG,3,3,0, TRANS(IPOINT))
  510 CONTINUE
C
C     SHIP OUT THE STIFFNESS AND DAMPING MATRICES
C
      IF (.NOT.NEEDK) GO TO 600
C
      DICT(1) = ESTID
      DICT(2) = 1
      DICT(3) = NDOF
      DICT(4) = 63
      ADAMP   = GSUBE
C
C     BUILD THE 18X18 TRANSFORMATION MATRIX FOR ONE-SHOT MULTIPLY
C
      DO 520 I = 1,NPART
      TRANSK(I) = 0.0
      TOTTRN(I) = 0.0
  520 CONTINUE
C
      NDOF66 = 6*NDOF + 6
      II = 1
      DO 550 I = 1,NPART,NDOF66
      CALL TLDRS (OFFSET,II,TRANS,TMPTRN)
      DO 540 JJ = 1,36,6
      J  = JJ - 1
      KK = I - 1 + J*NNODE
      DO 530 K = 1,6
      TOTTRN(KK+K) = TMPTRN(J+K)
  530 CONTINUE
  540 CONTINUE
  550 II = II + 1
C
C     PERFORM THE TRIPLE MULTIPLY.
C
      CALL MPYA3S (TOTTRN,AKGG(JCORED),NDOF,6,TRANSK)
C
      CALL EMGOUT (TRANSK,TRANSK,NPART,IEOE,DICT,KMAT,PREC)
C
C     SHIP OUT THE MASS MATRIX
C
  600 IF (.NOT.NEEDM) GO TO 730
      NDOF    = NNODE*3
      NPART   = NDOF*NDOF
      DICT(2) = 1
      DICT(3) = NDOF
      DICT(4) = 7
      ADAMP   = 0.0
      JEND    = JCORED + NPART - 1
C
C     ZERO OUT THE POSITIONS, THEN LOOP ON I AND J TO LOAD THE MASS
C     MATRIX.
C
      DO 610 IJK = JCORED,JEND
      AMGG(IJK) = 0.0
  610 CONTINUE
C
      NDOFP1 = NDOF + 1
      DO 640 II = 1,NNOD2  ,NNODE
      I = II - 1
      DO 630 J = 1,NNODE
      XMASSO = XMASS(I+J)
      IPOINT = (J-1)*3 + I*9 + JCORED
      JPOINT = IPOINT + 3*NDOF
      DO 620 K = IPOINT,JPOINT,NDOFP1
      AMGG(K) = XMASSO
  620 CONTINUE
  630 CONTINUE
  640 CONTINUE
C
C     BYPASS TRANSFORMATIONS IF LUMPED MASS.
C
      IF (CPMASS .LE. 0) GO TO 700
C
C     BUILD THE 9X9 TRANSFORMATION MATRIX FOR ONE-SHOT MULTIPLY
C
      DO 650 I = 1,NPART
      TRANSK(I) = 0.0
      TOTTRN(I) = 0.0
  650 CONTINUE
C
      NDOF33 = 3*NDOF + 3
      DO 680 I = 1,NPART  ,NDOF33
      II = ((I-1)/(3*NDOF))*9
      DO 670 JJ = 1,9,3
      J  = JJ - 1
      KK = I - 1 + J*NNODE
      DO 660 K = 1,3
      TOTTRN(KK+K) = TRANS(II+J+K)
  660 CONTINUE
  670 CONTINUE
  680 CONTINUE
C
C     PERFORM THE TRIPLE MULTIPLY.
C
      CALL MPYA3S (TOTTRN,AMGG(JCORED),NDOF,3,TRANSK)
      GO TO 720
C
C     JUST COPY THE LUMPED MASS MATRIX OUT
C
  700 II = JCORED
      DO 710 I = 1,NPART
      TRANSK(I) = AMGG(II)
      II = II + 1
  710 CONTINUE
  720 CONTINUE
C
      CALL EMGOUT (TRANSK,TRANSK,NPART,IEOE,DICT,MMAT,PREC)
  730 CONTINUE
      GO TO 1200
C
C     HEAT CALCULATIONS
C
  800 CONTINUE
      INFLAG = 2
      SINMAT = SIN(THETAM)
      COSMAT = COS(THETAM)
      MATID  = NEST(11)
C
      CALL HMAT (ELID)
C
      GI(1) = KHEAT(1)
      GI(2) = KHEAT(2)
      GI(3) = GI(2)
      GI(4) = KHEAT(3)
C
      DO 900 I = 1,18
      HTCON(I) = 0.0
      HTCAP(I) = 0.0
  900 CONTINUE
C
C     BEGIN LOOP ON INTEGRATION POINTS
C
      DO 950 IPT = 1,3
      CALL T3BMGS (IERR,SHEART,IPT,IORDER,EGPDT,DGPTH,AIC,TH,DETJAC,
     1             SHPT,BTERMS,BMATRX)
      IF (IERR .NE. 0) GO TO 1110
C
      DVOL = WEIGHT*DETJAC*TH
      DO 910 I = 1,4
      G(I,1) = GI(I)*DVOL
  910 CONTINUE
      WEITC = DVOL*HTCP
C
      IP = 1
      DO 920 I = 1,NNODE
      HTFLX(IP  ) = G(1,1)*BTERMS(I) + G(2,1)*BTERMS(I+NNODE)
      HTFLX(IP+1) = G(3,1)*BTERMS(I) + G(4,1)*BTERMS(I+NNODE)
      IP = IP + 2
  920 CONTINUE
      CALL GMMATS (BTERMS,2,NNODE,-1, HTFLX,NNODE,2,1, HTCON)
C
C     FINISHED WITH HEAT CONDUCTIVITY MATRIX, DO HEAT CAPACITY IF
C     REQUIRED.
C
      IF (HTCP .EQ. 0.0) GO TO 950
      IP = 1
      DO 940 I = 1,NNODE
      DHEAT = WEITC*SHPT(I)
      DO 930 J = 1,NNODE
      HTCAP(IP) = HTCAP(IP) + DHEAT*SHPT(J)
      IP = IP + 1
  930 CONTINUE
  940 CONTINUE
C
  950 CONTINUE
C
C     END OF INTEGRATION LOOP, SHIP OUT THE RESULTS.
C
      DICT(1) = ESTID
      DICT(2) = 1
      DICT(3) = NNODE
      DICT(4) = 1
      IF (WEITC .EQ. 0.0) GO TO 1000
      ADAMP = 1.0
      CALL EMGOUT (HTCAP,HTCAP,NNOD2,IEOE,DICT,DMAT,PREC)
 1000 ADAMP = 0.0
      CALL EMGOUT (HTCON,HTCON,NNOD2,IEOE,DICT,KMAT,PREC)
C
      GO TO 1200
C
C
C     FATAL ERRORS
C
C     INSUFFICIENT MEMORY IS AVAILABLE
C
 1100 CALL MESAGE (-30,228,NAME)
      GO TO 1140
C
C     CTRIA3 ELEMENT HAS ILLEGAL GEOMETRY OR CONNECTIONS
C
 1110 J = 224
      GO TO 1140
C
C     THE X-AXIS OF THE MATERIAL COORDINATE SYSTEM HAS NO PROJECTION
C     ON TO THE PLANE OF CTRIA3 ELEMENT
C
 1120 J = 225
      NEST(2) = MCSID
      GO TO 1140
C
C     ILLEGAL DATA DETECTED ON MATERIAL ID REFERENCED BY CTRIA3 ELEMENT
C     FOR MID3 APPLICATION
C
 1130 J = 226
      NEST(2) = MID(3)
C
 1140 CALL MESAGE (30,J,NEST(1))
      IF (L38 .EQ. 1) CALL MESAGE (-61,0,0)
      NOGO = 1
C
 1200 CONTINUE
      RETURN
      END

      SUBROUTINE DETM4
      DOUBLE PRECISION P,DETX,PS1,DET1,PSAVE(1),DET(1),PS(1)
      INTEGER PREC,U1,U2,SCR1,SCR2,SCR3,SCR4,SCR5,SCR6,SCR7
      DIMENSION IPDET(1)
      COMMON /DETMX/P(4),DETX(4),PS1(4),DET1(4),N2EV,IPSAV,IPS,IDET,
     1  IPDETA,PREC, U1,U2,IC,NSMOVE,L2,IS,ND, IADD,SML1,IPDETX(4),
     2  IPDET1(4), IFAIL,K,FACT1
      COMMON  /REGEAN/ IM(7),IK(7),IEV(7),SCR1,SCR2,SCR3,SCR4,SCR5,LCORE
     1 , RMAX,RMIN,MZ,NEV,EPSI,RMINR,NE,NIT,NEVM,SCR6,SCR7
     2  ,NFOUND,LAMA
      COMMON /ZZZZZZ/PSAVE
      EQUIVALENCE  (PSAVE(1),PS(1),DET(1),IPDET(1))
C
C     RMAX = APPROXIMATE MAGNITUDE OF LARGEST EIGENVALUE OF INTEREST
C
C     RMIN = LOWEST  NON-ZERO  EIGENVALUE
C
C     MZ = NUMBER OF ZERO EIGENVALUES
C
C     NEV = NUMBER OF NON-ZERO EIGENVALUES IN RANGE OF INTEREST
C
C     EPSI = CONVERGENCE CRITERION
C
C     RMINR = LOWEST EIGENVALUE OF INTEREST
C
C     NE   =  NUMBER OF PERMISSIBLE CHANGES OF EPSI
C
C     NIT = INTERATIONS TO AN EIGENVALUE
C
C     NEVM = MAXIMUM NUMBER OF EIGENVALUES DESIRED
C
C     IS  = STARTING SET COUNTER
C
C     IC  = COUNTER FOR CHANGE OF CONVERGENCE CRITERIA
C
C     NFOUND  = THE NUMBER OF EIGENVALUES FOUND TO DATA
C
C     NSMOVE = THE NUMBER OF TIMES THE STATTING POINTS HAVE BEEN MOVED
C
C      IM = MASS MATRIX CONTROL BLOCK
C
C      IK = K MATRIX CONTROL BLOCK
C
C        A = M +P*K
C
C     IEV = EIGENVECTOR CONTROL BLOCK
C
      NN = IPSAV+NFOUND
      PSAVE(NN) = P(3)
      EPS1 = FACT1*DSQRT(DABS(P(3)))
      DO 40 N=1,3
      NN = N  + IADD -2
      NNP = NN+IPS
      IF(DABS(PS(NNP)-P(3)) .GE. 400.*EPS1) GO TO 40
   10 PS(NNP) = PS(NNP) +2.E3*EPS1
      NSMOVE = NSMOVE+1
      IF(NFOUND .EQ. 1) GO TO 30
      NFND = NFOUND-1
      DO 20 I=1,NFND
      NNZ = IPSAV+I
      IF(DABS(PS(NNP)-PSAVE(NNZ)) .GT. 400.*EPS1) GO TO 20
      GO TO 10
   20 CONTINUE
   30 NND = NN+IDET
      NNI = NN+IPDETA
      CALL EADD(-PS(NNP),PREC)
      CALL DETDET(DET(NND),IPDET(NNI),PS(NNP),SML1,0.0D0,1)
   40 CONTINUE
      N2EV2 = IADD + ND
      DO 50 I=1,N2EV2
      NND = I+IDET
      NNP = I+IPS
      NNI = I+IPDETA
      DET(NND) = DET(NND)/(PS(NNP)-P(3))
      CALL DETM6(DET(NND),IPDET(NNI))
   50 CONTINUE
      DO 60 I=1,3
   60 DET1(I) = DET1(I)/(PS1(I)-P(3))
      RETURN
      END

        SUBROUTINE ZNTPKI
      INCLUDE 'DSIOF.COM'
        COMMON / ZNTPKX / A(4), I, IEOL, IENDRC
      INCLUDE 'PAKBLK.COM'
      INCLUDE 'XNSTRN.COM'
        INTEGER            A
        IRETRN = 0
        I      = IBLKB( 4 )
        INDEX  = ( IBLKB(5)-1 )*IBLKB(14) + 1 + IBLKB(7)*IBLKB(11)
        ITYPOT = IBLKB( 13 )
CDIR$ NOVECTOR
        IF ( ITYPOT .NE. IBLKB(2) ) GO TO 50
        NUM = NWRDEL( ITYPOT )
        DO 40 KK = 1, NUM
        A( KK ) = IBASE( INDEX + KK - 1 )
40      CONTINUE
CDIR$ VECTOR
        GO TO 70
50      CALL DSUPKC( IBLKB(2), ITYPOT, IBASE( INDEX ), A )
70      CONTINUE
        IBLKB( 4 ) = IBLKB( 4 ) + 1
        IBLKB( 7 ) = IBLKB( 7 ) + 1
        IBLKB(10 ) = IBLKB( 4 )
        IF ( IBLKB( 7 ) .LT. IBLKB( 6 ) ) GO TO 200
        CALL ENDGET( IBLKB )
        CALL GETSTR( *100, IBLKB )
100     IBLKB( 7 ) = 0
200     CONTINUE
        IF ( IRETRN .NE. 0 ) GO TO 300
        IEOL    = 0
        IENDRC  = 0
        GO TO 700
300     IEOL    = 1
        IENDRC  = 1
700     RETURN
        END

      SUBROUTINE DBMSTF
      INCLUDE   'DSIOF.COM'
      COMMON / SYSTEM / ISYSBF, IWR
      COMMON / LOGOUT / LOUT
      IBLKSZ = ISYSBF - 4
      IF ( MAXBLK .NE. 0 )  PERC1 = MAXBLK*1.0 / MAXALC
      IPERC1 = PERC1 * 100.
      IMEMNU = ( MAXALC - MAXBLK ) * LENALC
      WRITE( LOUT, 901 ) LENOPC, IDBLEN, MAXBLK, MAXALC, IPERC1, MAXDSK
     &, IBLKSZ, NUMOPN, NUMCLS, NUMWRI, NUMREA
      IF ( IDBDIR .NE. 0 ) WRITE( LOUT, 902 ) IMEMNU
901   FORMAT(1H1
     &,5X,'STATISTICS ON IN-MEMORY DATA BASE AND DISK I/O USAGE',/
     &,/,8X,' LENGTH (IN WORDS) OF OPEN CORE ALLOCATED          ',I16
     &,/,8X,' LENGTH (IN WORDS) OF IN-MEMORY DATA BASE ALLOCATED',I16
     &,/,8X,' NUMBER OF BLOCKS USED IN THE IN-MEMORY DATA BASE  ',I16
     &,/,8X,' NUMBER OF BLOCKS ALLOCATED FOR THE IN-MEMORY DATA ',I16
     &,/,8X,' PERCENTAGE OF IN-MEMORY DATA USED                 ',I16
     &,'%'
     &,/,8X,' TOTAL BLOCKS WRITTEN TO DISK                      ',I16
     &,/,8X,' BLOCK SIZE (IN WORDS)                             ',I16
     &,/,8X,' NUMBER OF OPENS TO DISK FILES                     ',I16
     &,/,8X,' NUMBER OF CLOSES TO DISK FILES                    ',I16
     &,/,8X,' NUMBER OF WRITES TO DISK FILES                    ',I16
     &,/,8X,' NUMBER OF READS FROM DISK FILES                   ',I16)
902   FORMAT(
     &   8X,' MEMORY (IN WORDS) NOT USED BY IN-MEM. DATA BASE   ',I16
     & )
      RETURN
      END

      SUBROUTINE ROMBER (B,PRECIS,ITDONE,FINTG,K,X)
C
C     TO INTEGRATE F(X) FROM X = A TO X = B
C
C         A = LOWER LIMIT = 0.0
C         B = UPPER LIMIT
C         NOSIG = NUMBER OF CORRECT SIGNIFICANT DIGITS DESIRED
C                 (NOT MORE THAN 7) = 5
C         PRECIS = 0.0  UPON RETURN, PRECIS = ACTUAL NUMBER
C                       OF SIGNIFICANT DIGITS ATTAINED
C         NUM = MAXIMUM NUMBER OF HALVINGS OF B-A TO BE MADE
C               (NOT MORE THAN 99) = 15
C         PROGRAMMER MUST ALSO PROGRAM SUBROUTINE FUNCT(F,X)
C         GIVING F AS THE DESIRED FUNCTION OF X, UPON
C         DEMAND OF ROMBER
C         UPON RETURN FROM ROMBER, THE VALUE OF THE INTEGRAL
C         WILL BE FOUND IN FINTG
C         IT IS CUSTOMARY TO MEASURE THE PRECISION OF LARGE NUMBERS IN
C     TERMS OF NUMBER OF SIGNIFICANT DIGITS AND THE ACCURACY OF SMALL
C     NUMBERS IN TERMS OF NUMBER OF SIGNIFICANT DECIMALS.  TO CONFORM
C     TO THIS PRACTICE, THE SUBROUTINE TERMINATES WHEN EITHER OF THESE
C     CONDITIONS IS MET.
C
      DIMENSION   X(6)
      DIMENSION   FAAAA(20),FAAAB(20)
C
      FAAAC = 0.00001
      IAAAA = 1
      FAAAD = B
      X(1)  = 0.0
      ASSIGN 100 TO IRET
      GO TO (1000,2000,3000), K
  100 CONTINUE
      FAAAE = F
      X(1)  = B
      ASSIGN 200 TO IRET
      GO TO (1000,2000,3000), K
  200 CONTINUE
      FAAAE = FAAAE+F
      FAAAA(1) = 0.5*FAAAD*FAAAE
 9988 FAAAD = 0.5*FAAAD
      IAAAC = 2**(IAAAA-1)
      FAAAE = 0.0
      IAAAD = 0
 9986 IAAAD = IAAAD + 1
      FAAAF = IAAAD
      X(1)  = (2.0*FAAAF-1.0)*FAAAD
      ASSIGN 300 TO IRET
      GO TO (1000,2000,3000), K
  300 CONTINUE
      FAAAE = FAAAE+F
      IF (IAAAD .LT. IAAAC) GO TO 9986
      FAAAB(1) = 0.5*FAAAA(1)+FAAAD*FAAAE
      IAAAA = IAAAA+1
      DO 9985 IAAAD = 2,IAAAA
      FAAAG = 4.0**(IAAAD-1)
      FAAAH = FAAAG-1.0
      IAAAF = IAAAD-1
 9985 FAAAB(IAAAD) = (FAAAG*FAAAB(IAAAF)-FAAAA(IAAAF))/FAAAH
      IAAAC = 2*IAAAC+1
      DIFF  = FAAAB(IAAAA)- FAAAA(IAAAA-1)
      IF (ABS(DIFF) - ABS(FAAAC*FAAAB(IAAAA))) 9979,9981,9981
 9981 DO 9980 IAAAD = 1,IAAAA
 9980 FAAAA(IAAAD) = FAAAB(IAAAD)
      IF (IAAAA .LT. 15) GO TO 9988
 9979 PRECIS = DIFF
      ITDONE = IAAAA - 1
      FINTG  = FAAAB(IAAAA)
      RETURN
C
C     THIS CODE REPLACES F4
C
 1000 CONTINUE
      IF (X(1) .EQ. 0.0) GO TO 1020
      DEN = X(3) - X(2)*X(5) + X(2)*X(5)*COS(X(1))+X(2)*X(4)*SIN(X(1))
      F   = X(1)**(X(6)-1.0)* SIN(X(1))**2 / DEN
 1010 GO TO IRET, (100,200,300)
 1020 F = 0.0
      GO TO 1010
C
C     THIS CODE REPLACES F5
C
 2000 CONTINUE
      IF (X(1) .EQ. 0.0) GO TO 2020
      DEN = X(3) - X(2)*X(5) + X(2)*X(5)*COS(X(1))+X(2)*X(4)*SIN(X(1))
      F   = X(1)**(X(6)-1.0)*2. *SIN(X(1))*COS(X(1))/DEN
 2010 GO TO IRET, (100,200,300)
 2020 F = 0.0
      GO TO 2010
C
C     THIS CODE REPLACES F6
C
 3000 CONTINUE
      DEN = X(3) - X(2)*X(5) + X(2)*X(5)*COS(X(1))+X(2)*X(4)*SIN(X(1))
      IF (X(6) .EQ. 1.0) CONST = 1.0
      IF (X(6) .NE. 1.0) CONST = X(1)**(X(6) - 1.0)
      IF (DEN  .EQ. 0.0) GO TO 3020
      F = CONST*COS(X(1))**2 / DEN
 3010 GO TO IRET, (100,200,300)
 3020 F = 0.0
      GO TO 3010
      END

      SUBROUTINE FRSW2 (V1,V2,V3,VB)
C
C     LAST REVISED  11/91, BY G.CHAN/UNISYS
C     ADDITION OF A NEW FORWARD-BACKWARD SUBSTITUTION METHOD, WHICH IS
C     MORE EFFICIENT, AND IS ALREADY GOOD FOR VECTORIZATION.
C
CDB   LOGICAL          DEBUG
      INTEGER          NAM(6)  ,LJJ(2) ,IBLK(15),BASE
      DOUBLE PRECISION V1(1)   ,V2(1)  ,V3(1)   ,VB(1) ,XL(1) ,XLJJ  ,
     1                 V3J     ,ZERO   ,SUM
      COMMON  /OPINV / MCBLT(7),MCBSMA(7)
      COMMON  /SYSTEM/ KSYSTM  ,IO
      COMMON  /FEERXX/ DUMM(18),NZVB
      COMMON  /ZZZZZZ/ IZ(1)
      EQUIVALENCE      (XL(1),IZ(1))
      EQUIVALENCE      (LJJ(1) ,XLJJ)  ,(L16,DUMM(6))
      DATA     NAM   / 4HFRSW  ,4H2    ,2*4HBEGN,4HEND ,4HBGIN /
      DATA     ZERO  / 0.0D+0        /
CDB   DATA     DEBUG , ITER    ,MAX  / .FALSE.  ,0     ,3      /
C
CDB   IF (.NOT.DEBUG) GO TO 20
C     ITER = ITER + 1
C     IF (ITER .GT. MAX) DEBUG = .FALSE.
C     WRITE  (IO,10) NZVB,ITER
C  10 FORMAT ('  .... IN FRSW2.  NZVB =',I8,',   ITER =',I3)
C  20 CONTINUE
      NROW = MCBLT(2)
      CALL FRMLTD (MCBSMA(1),V1(1),V3(1),VB(1))
      IF (MCBLT(7) .LT. 0) GO TO 200
C
C     NASTRAN ORIGINAL METHOD
C
      IBLK( 1) = MCBLT(1)
      IBLK( 9) = 1
      IBLK(10) = 1
      CALL REWIND (MCBLT)
      CALL SKPREC (MCBLT,1)
C
C     FORWARD SWEEP DIRECTLY ON V3
C
      DO 80 J = 1,NROW
      IBLK(8) = -1
   30 CALL GETSTR (*70,IBLK(1))
      JI   = IBLK(5)
      NTMS = IBLK(6)
      IK   = IBLK(4)
      IF (IK .NE. J) GO TO 40
      NTMS = NTMS - 1
      XLJJ = XL(JI)
      JI   = JI + 1
      IK   = IK + 1
   40 IF (NTMS .EQ. 0) GO TO 60
      V3J  = V3(J)
      IF (V3J .EQ. ZERO) GO TO 60
      DO 50 II = 1,NTMS
      V3(IK) = V3(IK) + XL(JI)*V3J
      IK   = IK + 1
      JI   = JI + 1
   50 CONTINUE
   60 CALL ENDGET (IBLK(1))
      GO TO 30
   70 V3(J)= V3(J)/XLJJ
   80 CONTINUE
C
C     BACKWARD SUBSTITUTION OMIT DIAGONAL
C
      IF (NROW .EQ. 1) GO TO 500
      J    = NROW
   90 IBLK(8) = -1
  100 CALL GETSTB (*130,IBLK(1))
      NTMS = IBLK(6)
      JI   = IBLK(5)
      IK   = IBLK(4)
      IF (IK-NTMS+1 .EQ. J) NTMS = NTMS - 1
      IF (NTMS .EQ. 0) GO TO 120
      SUM  = ZERO
      DO 110 II = 1,NTMS
      SUM  = SUM + XL(JI)*V3(IK)
      JI   = JI - 1
      IK   = IK - 1
  110 CONTINUE
      V3(J)= V3(J) + SUM
  120 CALL ENDGTB (IBLK(1))
      GO TO 100
  130 IF (J .EQ. 1) GO TO 500
      J    = J - 1
      GO TO 90
C
C     NEW METHOD
C
C     THE MCBLT MATRIX HAS BEEN RE-WRITTEN FORWARD FIRST THAN BACKWARD
C     BY UNPSCR IN FEER3. NO STRING OPERATION HERE
C
  200 IF (NAM(3) .EQ. NAM(5)) NAM(3) = NAM(6)
      IF (L16 .NE. 0) CALL CONMSG (NAM,3,0)
      MCBLTX =-MCBLT(7)
      IF (MOD(MCBLT(4),10) .NE. 2) GO TO 440
      NREC = 0
      CALL REWIND (MCBLTX)
      CALL FWDREC (*400,MCBLTX)
      NWDS = MCBLT(5)
C
C     IZ(1)                                                     GINO
C      / V1   V2    V3          VB (OPEN CORE LENGTH = NZVB)   BUFFERS
C     +-----+-----+-----+-----+-------------------------------+--------
C                         OPEN  CORE
C
C     FORWARD SWEEP DIRECTLY ON V3
C
      LL2  = 0
      BASE = 1
      IFB  = +450
      DO 270 J = 1,NROW
      IF (BASE .LT. LL2) GO TO 240
      NREC = NREC + 1
CDB   IF (DEBUG) WRITE (IO,210) NREC,IFB
C 210 FORMAT ('  ...READING RECORD',I5,'.   IFB =',I5)
      CALL READ (*400,*220,MCBLTX,VB,NZVB,1,LL)
      CALL MESAGE (-8,0,NAM)
  220 LL2  = LL/NWDS
CDB   LL3  = LL2/30
C     LL4  = LL2 - LL3
C     IF (DEBUG) WRITE (IO,230) LL,NREC,LL2
C 230 FORMAT (5X,I10,' WORDS READ FROM RECORD',I5,'.   LL2 =',I8)
      BASE = 1
  240 XLJJ = VB(BASE)
      II   = LJJ(1)
      JJ   = LJJ(2)
CDB   IF (DEBUG .AND. (BASE.LT.LL3 .OR. BASE.GT.LL4))
C    1    WRITE (IO,250) J,BASE,II,JJ,IFB
C 250 FORMAT (11X,'J,BASE,II,JJ,IFB =',5I8)
      IF (II .NE. J) GO TO 420
      NTMS = JJ - II + 1
      IB   = BASE + 2
      IE   = BASE + NTMS
      BASE = IE + 1
      IF (NTMS .LE. 1) GO TO 270
      V3J  = V3(J)
      IF (V3J .EQ. ZERO) GO TO 270
      DO 260 I = IB,IE
      II   = II + 1
  260 V3(II) = V3(II) + VB(I)*V3J
  270 V3(J)= V3(J)/VB(IB-1)
C
C     BACKWARD SUBSTITUTION OMIT DIAGONAL
C
      IF (NROW .EQ. 1) GO TO 500
      NREC = 0
      LL2  = 0
      BASE = 1
      J    = NROW
      IFB  = -490
      DO 310 JX = 1,NROW
      IF (BASE .LT. LL2) GO TO 290
      NREC = NREC + 1
CDB   IF (DEBUG) WRITE (IO,210) NREC,IFB
      CALL READ (*400,*280,MCBLTX,VB,NZVB,1,LL)
      CALL MESAGE (-8,0,NAM)
  280 LL2  = LL/NWDS
CDB   LL3  = LL2/30
C     LL4  = LL2 - LL3
C     IF (DEBUG) WRITE (IO,230) LL,NREC,LL2
      BASE = 1
  290 XLJJ = VB(BASE)
      II   = LJJ(1)
      JJ   = LJJ(2)
CDB   IF (DEBUG .AND. (BASE.LT.LL3 .OR. BASE.GT.LL4))
C    1    WRITE (IO,250) J,BASE,II,JJ,IFB
      IF (II .NE. J) GO TO 420
      NTMS = JJ - II + 1
      IB   = BASE + 2
      IE   = BASE + NTMS
      BASE = IE + 1
      IF (NTMS .LE. 1) GO TO 310
      SUM  = ZERO
      DO 300 I = IB,IE
      II   = II + 1
  300 SUM  = SUM + VB(I)*V3(II)
      V3(J)= V3(J) + SUM
  310 J    = J - 1
      GO TO 500
C
C     ERROR
C
  400 I = MCBLT(4)/10
      WRITE  (IO,410) NREC,J,I,IFB
  410 FORMAT ('0*** TRY TO READ RECORD',I5,'.  J,MCBLT(4),IFB =',I7,2I5)
      CALL MESAGE (-2,MCBLTX,NAM)
  420 WRITE  (IO,430) IFB,II,J
  430 FORMAT ('0*** ERROR.   IFB),II,J =',I5,1H),2I8)
      GO TO 460
  440 J = MOD(MCBLT(4),10)
      WRITE  (IO,450) J
  450 FORMAT ('0*** MCBLT MATRIX IN WRONG FORM.  UNPSCR FLAG =',I3)
  460 CALL MESAGE (-37,0,NAM)
C
  500 NAM(3) = NAM(5)
      IF (L16 .NE. 0) CALL CONMSG (NAM,3,0)
      RETURN
      END

      SUBROUTINE XRGDCF (IRESTB)
C
C     PURPOSE - XRGDCF PROCESSES THE '****CARD', '****FILE' AND
C               '****RFMT' CONTROL CARDS WITHIN THE RIGID DMAP
C               DATA BASE.
C
C     AUTHOR  - RPK CORPORATION; DECEMBER, 1983
C
C     INPUT
C       /SYSTEM/
C         NOUT         UNIT NUMBER FOR THE OUTPUT PRINT FILE
C       /XRGDXX/
C         NUM          VALUE OF THE NUMBER OR RANGE OF NUMBERS
C                      IN THE CURRENT FIELD BEING PROCESSED
C
C     OUTPUT
C       ARGUMENTS
C         IRESTB       THE MODULE EXECUTION DECISION TABLE
C       OTHER
C         /XRGDXX/
C           ICOL       CURRENT COLUMN NUMBER BEING PROCESSED IN
C                      THE CARD
C           IERROR     ERROR FLAG - NON-ZERO IF AN ERROR OCCURRS
C
C     LOCAL VARIABLES
C       IBIT           BIT NUMBER FOR FLAG IN THE MODULE EXEC. DEC.
C                      TABLE
C       IEND           LAST NUMBER OF RANGE OF NUMBERS READ FROM
C                      THE CURRENT FIELD
C       ISTR           SAME AS IEND EXCEPT FIRST NUMBER
C       IWORD          SAME AS IBIT BUT REFERS TO THE WORD NUMBER
C
C     FUNCTIONS
C       XRGDCF PROCESSES THE ABOVE TYPES OF CARDS WHICH ALL HAVE
C       FORMATS AS FOLLOWS:  '****XXXX   M1,M2,..'
C       WHERE M- IS IN ANY OF THE FOLLOWING FORMS ( NNN  OR NNN-NNN).
C       NNN IS AN INTEGER NUMBER AND THE '-' REFERS TO A RANGE
C       WHERE THE RANGE MUST BE IN ASCENDING ORDER.
C       XRGDCF CALLS XDCODE TO CONVERT THE CARD IMAGE TO 80A1 AND
C       CALLS XRGDEV TO VALIDATE THE SYNTAX AND TO GET A M-
C       ENTRY FROM THE CARD.  BASED ON THE VALUE(S) RETURNED IN
C       NUM, THE CORRESPONDING BITS ARE TURNED ON IN THE MODULE
C       EXECUTION DECISION TABLE.  PROCESSING CONTINUES UNTIL ALL
C       FIELDS OF THE CARD HAVE BEEN PROCESSED.
C
C
C     SUBROUTINES CALLED - XDCODE, XRGDEV
C
C     CALLING SUBROUTINES - XRGRFM
C
C     ERRORS - NONE
C
      EXTERNAL        ORF
      INTEGER         RECORD, ORF   , IRESTB(7)
      COMMON /SYSTEM/ ISYSBF, NOUT  , DUM(98)
      COMMON /XRGDXX/ IRESTR, NSUBST, IPHASE, ICOL   , NUMBER, ITYPE ,
     1                ISTATE, IERROR, NUM(2), IND    , NUMENT        ,
     2                RECORD(20)    , ICHAR(80)      , LIMIT(2)      ,
     3                ICOUNT, IDMAP , ISCR  , NAME(2), MEMBER(2)     ,
     4                IGNORE
C
      IERROR = 0
      ICOL   = 9
      CALL XDCODE
 10   CALL XRGDEV
      IF (IERROR .NE. 0 .OR. ICOL .GT. 80) GO TO 30
      ISTR   = NUM(1)
      IEND   = NUM(2)
      DO 20 K = ISTR,IEND
      IWORD = (K-1)/31
      IBIT  = 2**(31*IWORD + 31 - K)
      IRESTB(IWORD+1) = ORF(IRESTB(IWORD+1),IBIT)
 20   CONTINUE
      ICOL = ICOL + 1
      GO TO 10
 30   CONTINUE
      RETURN
      END

      SUBROUTINE FLLD (X01,X02,Y0,Z0,SGR,CGR,SGS,CGS,KR,CBAR,FMACH,E,
     1                 L,KD1R,KD1I,KD2R,KD2I)
C
C     CALCULATION OF THE NUMERATOR OF A DOUBLET LINE OF FINITE LENGTH.
C     LIKE KERN, THERE ARE TWO OUTPUT COMPLEX VALUES REPRESENTED BY
C     FOUR REAL NUMBERS AND AN INPUT OPTION.
C
C     WRITTEN BY D. H. LARSON, STRUCTURAL MECHANICS MDAC 11/70
C
C     X01  -   X - XI1
C     X02  -   X - XI2
C     Y0   -   Y - ETA
C     Z0   -   Z - ZETA
C     SGR  -   SIN ( GAMMA-R)
C     CGR  -   COS ( GAMMA-R)
C     SGS  -   SIN ( GAMMA-S)
C     CGS  -   COS ( GAMMA-S)
C     KR   -   REDUCED FREQUENCY
C     BR   -   REFERENCE LENGTH
C     FMACH-   MACH NUMBER
C     E    -
C     L    -   OPTION FLAG USED IN TKER
C     KD1R -   REAL PART OF  KD1
C     KD1I -   IMAGINARY PART OF KD1
C     KD2R -   REAL PART OF  KD2
C     KD2I -   IMAGINARY PART OF KD2
C
      REAL           KR,KK1R,KK1I,KK2R,KK2I,KD1R,KD1I,KD2R,KD2I,K10T1,
     1               K20T2P,K1RT1,K10,K2IT2P,K20,K2RT2P,K1IT1
      COMPLEX        KD1,KD2,K1XI1,K1XI2,TEMP1,TEMP2,K2XI1,K2XI2
      COMMON  /KDS/  IND,KK1R,KK1I,KK2R,KK2I
      COMMON  /DLM/  K10,K20,K1RT1,K1IT1,K2RT2P,K2IT2P,K10T1,K20T2P
C
C     X01 = X-XI1  AND  X02 = X-XI2, DELXI = XI2-XI1
C
      DELXI = X01 - X02
C
C     FULL KERNEL FROM -TKER-
C
      IND  = 0
      KD1R = 0.0
      KD2R = 0.0
      T1   = KR*DELXI/CBAR
      BR   = CBAR/2.0
      ST1  = SIN(T1)
      CT1  = COS(T1)
      I    = 1
      X0   = X01
C
   10 CALL TKER (X0,Y0,Z0,KR,BR,SGR,CGR,SGS,CGS,RT1,RT2,FMACH)
C
      GO TO (30,40), I
   30 K1XI1 = CMPLX(KK1R,KK1I)
      K2XI1 = CMPLX(KK2R,KK2I)
      IF (L .EQ. 0) GO TO 35
      KD1R  = KD1R - K10T1
      KD2R  = KD2R - K20T2P
   35 CONTINUE
C
C     NOW GO CALCULATE FOR XI = XI2
C
      X0 = X02
      I  = 2
      GO TO 10
C
   40 K1XI2 = CMPLX(KK1R,KK1I)
      K2XI2 = CMPLX(KK2R,KK2I)
      IF (L .EQ. 0) GO TO 50
      KD1R  = KD1R + K10T1
      KD2R  = KD2R + K20T2P
   50 CONTINUE
C
      TEMP1 = CMPLX(CT1, ST1)
      TEMP2 = CMPLX(CT1,-ST1)
C
C     DESIRED RESULTS (COMPLEX)
C
      KD1   = K1XI1*TEMP1 - K1XI2*TEMP2
      KD2   = K2XI1*TEMP1 - K2XI2*TEMP2
C
C     CONVERT TO REAL AND IMAGINARY PARTS
C
      KD1R  = REAL (KD1) + KD1R
      KD1I  = AIMAG(KD1)
      KD2R  = REAL (KD2) + KD2R
      KD2I  = AIMAG(KD2)
      RETURN
      END

      SUBROUTINE FLFREE (FRREC,AFE,NAFE,KGE,NKGE)
C
C     CALCULATES THE AREA FACTOR MATRIX AND GRAVITATIONAL STIFFNESS
C     MATRIX FOR A SINGLE FLUID ELEMENT ON THE FREE SURFACE
C
      LOGICAL         ERROR    ,GRAV     ,LTILT
      INTEGER         FRREC(7) ,GF1      ,GF2      ,GF3      ,IZ(1)    ,
     1                GRID(3,4)
      DOUBLE PRECISION          R12(3)   ,R13(3)   ,A        ,RT(3)    ,
     1                AFE(16)  ,KGE(16)  ,AFACT    ,RHOXG
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /ZZZZZZ/ Z(1)
      COMMON /FLBPTR/ ERROR    ,ICORE    ,LCORE    ,IBGPDT   ,NGBPDT   ,
     1                ISIL     ,NSIL     ,IGRAV    ,NGRAV
      COMMON /MATIN / MATID    ,INFLAG
      COMMON /MATOUT/ DUM(3)   ,RHO
      COMMON /SYSTEM/ SYSBUF   ,NOUT
      COMMON /BLANK / NOGRAV   ,NOFREE   ,TILT(2)
      EQUIVALENCE     (Z(1),IZ(1))
C
C     GRID POINTS DEFINING FOUR OVERLAPING TRIANGLES IN A QUAD
C
      DATA    GRID  / 1        ,2        ,3        ,
     1                2        ,3        ,4        ,
     2                3        ,4        ,1        ,
     3                4        ,1        ,2        /
      DATA    LTILT / .FALSE.  /
C
C
C     CALCULATE SIZE OF ELEMENT MATRICES
C
      NGRIDF = 4
      IF (FRREC(6) .LT. 0) NGRIDF = 3
      NAFE = NGRIDF*NGRIDF*2
      NKGE = 0
C
C     OBTAIN MATERIAL PROPERTY AND GRAVITY DATA IF A GRAV ID IS GIVEN
C
      GRAV = .FALSE.
      IF (FRREC(7) .EQ. 0) GO TO 6
      INFLAG = 11
      MATID  = FRREC(2)
      CALL MAT (FRREC(1))
C
      IF (NGRAV .EQ. 0) GO TO 70
      LGRAV = IGRAV + NGRAV - 1
      DO 2 I = IGRAV,LGRAV,6
      IF (IZ(I) .EQ. FRREC(7)) GO TO 4
    2 CONTINUE
C
      GO TO 70
C
    4 G = SQRT(Z(I+3)**2 + Z(I+4)**2 + Z(I+5)**2)
C
C     USING THE FIRST GRAV VECTOR DETERMING THE FREE SURFACE PLOTTING
C     ANGLE
C
      IF (LTILT) GO TO 5
      TILT(1) = Z(I+5)/G
      TILT(2) = Z(I+3)/G
      LTILT   = .FALSE.
C
    5 G     = G*Z(I+2)
      RHOXG = DBLE(RHO)*DBLE(G)
      NKGE  = NAFE
      NOGRAV= 1
      GRAV  = .TRUE.
C
C     DETERMINE NUMBER OF OVERLAPING TRIANGLES TO BE UESED
C
C     1 IF TRIANGLAR FLUID FACE
C     4 IF QUADRATIC FLUID FACE
C
    6 ITRIA = 4
      IF (NGRIDF .NE. 4) ITRIA = 1
C
C     ZERO OUT GRAVITATIONAL STIFFNESS AND AREA FACTOR MATRIX
C
      DO 10 I = 1,16
      KGE(I) = 0.0D0
   10 AFE(I) = 0.0D0
C
C     LOOP OVER TRIANGLES
C
C     FIRST LOCATE GRID POINT COORDINATES FOR CORNERS FO THIS TRIANGLE
C
      DO 50 IT = 1,ITRIA
C
      I   = GRID(1,IT)
      GF1 = IBGPDT + (FRREC(I+2)-1)*4
      I   = GRID(2,IT)
      GF2 = IBGPDT + (FRREC(I+2)-1)*4
      I   = GRID(3,IT)
      GF3 = IBGPDT + (FRREC(I+2)-1)*4
C
C     CALCUATE AREA OF TRIAGLE
C     DIVIDE AREA BY TWO IF OVERLAPPING TRIAGLES USED
C
      DO 20 I = 1,3
      R12(I) = Z(GF2+I) - Z(GF1+I)
   20 R13(I) = Z(GF3+I) - Z(GF1+I)
C
      CALL DCROSS (R12,R13,RT)
C
      A = DSQRT(RT(1)*RT(1) + RT(2)*RT(2) + RT(3)*RT(3))/2.0D0
      IF (ITRIA .EQ. 4) A = A/2.0D0
C
C     INSERT AREA AND STIFFNESS CONTRIBUTIONS INTO FULL SIZE
C     ELEMTENT MATRICES
C
      DO 40 I = 1,3
      ICOL = GRID(I,IT)
      ILOC = NGRIDF*(ICOL-1)
      DO 30 J = 1,3
      IROW = GRID(J,IT)
      IF (IROW .EQ. ICOL) AFACT = A/6.0D0
      IF (IROW .NE. ICOL) AFACT = A/12.0D0
      AFE(ILOC+IROW) = AFE(ILOC+IROW) + AFACT
      IF (GRAV) KGE(ILOC+IROW) = KGE(ILOC+IROW) + RHOXG*AFACT
   30 CONTINUE
   40 CONTINUE
C
   50 CONTINUE
C
      RETURN
C
C     ERROR CONDITIONS
C
   70 WRITE  (NOUT,80) UFM,FRREC(1),FRREC(7)
   80 FORMAT (A23,' 8012, FLUID ELEMENT',I9,
     1       ' ON A CFFREE CARD REFERENCES UNDEFINED GRAVITY ID',I9)
      ERROR = .TRUE.
      RETURN
      END

      SUBROUTINE DPLOT
C
      IMPLICIT INTEGER (A-Z)
      INTEGER         TIT(32),NAME(2)
      CHARACTER       UFM*23,UWM*25
      COMMON /XMSSG / UFM,UWM
      COMMON /PLOTHD/ IUSED
      COMMON /SYSTEM/ BUFSIZ ,NOUT
      COMMON /ZZZZZZ/ X(1)
      COMMON /BLANK / NGP    ,LSIL   ,NSETS  ,PLTFLG ,PLTNUM ,NGPSET  ,
     1                NODEF  ,SKP1(3),PLTPAR ,GPSETS ,ELSETS ,CASECC  ,
     2                BGPDT  ,EQEXIN ,SIL    ,PDEF1  ,PDEF2  ,S2      ,
     3                PLOTX  ,SETD   ,ECPT   ,OES1   ,SCR1   ,SCR2    ,
     4                SCR3   ,SCR4
C
C     NOTE THAT NSETS IS DMAP PARAMETER JUMPPLOT
C     IUSED IS USED IN PLOT AND HDPLOT
C
      DATA    INPREW, REW / 0,1   /,
     1        TIT   / 12*1H ,4HMESS,4HAGES,4H FRO,4HM TH,4HE PL,4HOT M,
     2                4HODUL,1HE   ,12*1H    /
      DATA    NAME  / 4HDPLO,4HT   /
C
C     FILE NAMES FOR UNDEFORMED PLOTS MAY BE
C     108  = USET (GPTLBL - SPC DEGREES OF FREEDOM)
C     109  = ECT  (ELELBL - PROPERTY IDS)
C     110  = ECPT
C          = EPT (UNDEFORMED PLOT ONLY, DMAP NUMBER 25 OR LESS)
C            EPT IS NEEDED FOR PSHELL CARDS IN ORDER TO PICK UP ANY
C            OFFSET FOR CTRIA3 AND CQUAD4 (IN COMECT)
C
      PLTPAR = 101
      GPSETS = 102
      ELSETS = 103
      CASECC = 104
      BGPDT  = 105
      EQEXIN = 106
      SIL    = 107
      PDEF1  = 108
      PDEF2  = 109
      ECPT   = 110
      OES1   = 111
      OES1L  = 112
      ONRGY1 = 113
      PLOTX  = 201
      SCR1   = 301
      SCR2   = 302
      SCR3   = 303
      SCR4   = 304
      NODEF  = 0
      IF (NGP.LE.0 .OR. LSIL.LE.0) GO TO 80
      CALL TOTAPE (2,X(1))
C
C     OUTPUT THE TITLE FOR MESSAGE FILE
C     THE LAST BUFFER IS BUFSIZ+1 FOR SUBROUTINE ELELBL
C
      BUF = KORSZ(X) - 4*BUFSIZ
      IF (BUF-4*BUFSIZ .LT. 10) GO TO 85
      IF (NSETS .LE. 0) GO TO 60
      CALL GOPEN (PLOTX,X(BUF),REW)
C
C     COMMENTS FROM G.CHAN/UNISYS       11/90
C     NEXT 2 LINES ADD TIT HEADING TO THE 4TH LINE OF NASTRAN HEADERS
C     WHEN THE PLOTX FILE IS READ AND PRINTED BY PRTMSG MODULE.
C     THIS SHORTCUT TECHNIQUE IS NO WHERE DISCUSSED IN THE USER'S NOR
C     PROGRAMMER'S MAUNALS
C
      CALL WRITE (PLOTX,-4,1,0)
      CALL WRITE (PLOTX,TIT,32,0)
C
C     READ THE SETID-S FROM -GPSETS- FILE.  SET NEGATIVE SETID-S THAT
C     HAVE NO ASSOCIATED GRIDS.  FIND FIRST DEFINED SET OR EXIT IF NONE
C
      BUF = BUF - BUFSIZ
      CALL GOPEN (GPSETS,X(BUF),INPREW)
      CALL FREAD (GPSETS,X,NSETS,1)
      SETD = 0
      X(NSETS+1) = 1
C
      DO 50 I = 1,NSETS
      CALL READ (*30,*60,GPSETS,X(NSETS+2),1,1,I1)
      IF (X(NSETS+2) .GT. 0) GO TO 40
   30 WRITE  (NOUT,31) UWM,X(NSETS+1)
   31 FORMAT (A25,' 697, SET',I9,
     1       ' NOT DEFINED.  FIRST SET DEFINED WILL BE USED.')
      X(I) = -X(I)
      GO TO 50
   40 IF (SETD .EQ. 0) SETD = I
   50 CONTINUE
      CALL CLOSE (GPSETS,REW)
      IF (SETD .NE. 0) GO TO 70
   60 WRITE  (NOUT,61) UFM
   61 FORMAT (A23,' 698, NO SETS DEFINED FOR PLOTS')
      CALL MESAGE (-61,0,0)
C
C     PROCESS PLOT REQUESTS
C
   70 CALL GOPEN (PLTPAR,X(BUF),INPREW)
      I1 = 1
      I2 = I1  + NSETS
      BUF= BUF - BUFSIZ
      CALL PARAM (X(I1),X(I2),BUF-NSETS)
      CALL CLOSE (PLTPAR,REW)
C
C     SET JUMPPLOT NEGATIVE IF NO FUTHER REQUESTS
C
      IF (PLTFLG.GE.0 .AND. NODEF.EQ.0) NSETS = -1
      CALL CLSTAB (PLOTX,REW)
      CALL CLOSE  (GPSETS,REW)
      PLTFLG = -1
   80 RETURN
C
C     INSUFFICIENT CORE
C
   85 CALL MESAGE (-8,BUF,NAME)
      NSETS = -1
      PLTFLG= -1
      GO TO 80
      END

      INTEGER FUNCTION KHRFN3 (WORD1,WORD2,MOVE,IDIR)
C
C     CHARACTER FUNCTION KHRFN3 MERGES TWO WORDS, WORD1 AND WORD2, BY
C     BYTES
C
C     (+)MOVE IS NO. OF BYTES INVOLVED PRELIMINARY SHIFTING
C     (-)MOVE IS NO. OF BYTES IN MERGING, NO PRELIMINARY SHIFTING.
C     IDIR IS LEFT OR RIGHT SHIFT OF WORD2. THE VACANT BYTES ARE THEN
C     FILLED IN BY WORD1.  (LEFT SHIFT IF IDIR=1, RIGHT SHIFT OTHERWISE)
C
C     NOTE - KHRFN3 HANDLES ONLY 4 BYTES OF WORD. IF MACHINE WORD HAS
C     MORE THAN 4 BYTES PER WORD, KHRFN3 DOES NOT ZERO-FILL NOR BLANK-
C     FILL THE REST OF THE WORD. THE CALLER SHOULD MAKE THE PROPER
C     CHOICE BY ZERO-FILL OR BLANK-FILL THE INPUT WORDS, WORD1 ADN WORD2
C
C     THE FOLLOWING TABLE GIVES THE RESULTS OF KHRFN3 FOR VARIOUS INPUT
C     VALUES OF MOVE AND IDIR:
C
C        GIVEN:    WORD1=ABCD  AND  WORD2=1234  (IN BCD)
C                 IDIR=1   IDIR.NE.1            IDIR=1   IDIR.NE.1
C                --------------------          --------------------
C        MOVE= 0:   1234     1234      MOVE=-0:   1234     1234
C        MOVE= 1:   234D     A123      MOVE=-1:   123D     A234
C        MOVE= 2:   34CD     AB12      MOVE=-2:   12CD     AB34
C        MOVE= 3:   4BCD     ABC1      MOVE=-3:   1BCD     ABC4
C        MOVE= 4:   ABCD     ABCD      MOVE=-4:   ABCD     ABCD
C
C     THIS ROUTINE WAS WRITTEN BY G.CHAN TO REPLACE THE ORIGINAL VAX
C     ROUTINE WHICH WAS VERY VERY INEFFICIENT.
C
      INTEGER         WORD1(1),WORD2(1),WORD3
C
      NCPW  = 4
      IMOVE = IABS(MOVE)
      IEND  = NCPW - IMOVE
      WORD3 = WORD2(1)
      IF (MOVE) 50,90,10
 10   WORD3 = WORD1(1)
      IF (IMOVE .GE. NCPW) GO TO 90
      IF (IDIR  .EQ.    1) GO TO 30
      DO 20 I = 1,IEND
      WORD3 = KHRFN1(WORD3,I+IMOVE,WORD2(1),I)
 20   CONTINUE
      GO TO 90
 30   DO 40 I = 1,IEND
      WORD3 = KHRFN1(WORD3,I,WORD2(1),I+IMOVE)
 40   CONTINUE
      GO TO 90
 50   IF (IDIR .EQ. 1) GO TO 70
      DO 60 I = 1,IMOVE
      WORD3 = KHRFN1(WORD3,I,WORD1(1),I)
 60   CONTINUE
      GO TO 90
 70   DO 80 I = 1,IMOVE
      WORD3 = KHRFN1(WORD3,I+IEND,WORD1(1),I+IEND)
 80   CONTINUE
 90   KHRFN3 = WORD3
      RETURN
      END

      SUBROUTINE IFP4G (IBIT,FILE)
C
C     TURNS ON BIT -IBIT- IN TRAILER FOR DATA BLOCK -FILE-
C
      EXTERNAL    ORF
      INTEGER     ORF, TRAIL(7), FILE, TWO
      COMMON/TWO/ TWO(32)
C
      TRAIL(1) = FILE
      CALL RDTRL (TRAIL)
      I1 = (IBIT-1)/16 + 2
      I2 = IBIT - (I1-2)*16 + 16
      TRAIL(I1) = ORF(TRAIL(I1),TWO(I2))
      TRAIL(1) = FILE
      CALL WRTTRL (TRAIL)
      RETURN
      END

      SUBROUTINE FLBMG
C
C     DRIVER FOR MODULE FLBMG
C
C     COMPUTES THE HYDROELASTIC AREA FACTOR MATRIX AND THE
C     GRAVITATIONAL STIFFNESS MATRIX.
C
C     THE HYDROELASTIC USET VECTOR IA ALSO BUILT.
C
C     DMAP CALL
C
C        FLBMG    GEOM2,ECT,BGPDT,SIL,MPT,GEOM3,CSTM,USET,EQEXIN/
C                 USETF,USETS,AF,DKGG/S,N,NOGRAV/S,N,NOFREE/S,N,TILT $
C
C     INPUT DATA BLOCKS
C
C        GEOM2  - FLUID ELEMENT BOUNDARY DATA
C        ECT    - ELEMENT CONNECTION TABLE
C        BGPDT  - BASIC GRID POINT DEFINITION TABLE
C        SIL    - SCALAR INDEX LIST
C        MPT    - MATERIAL PROPERTIES TABLE
C        GEOM3  - GRAVITY LOAD DATA
C        CSTM   - COORDINATE SYSTEM TRANSFORMATION MATRICES
C        USET   - DISPLACEMENT SET DEFINITION TABLE
C        EQEXIN - EQUIVALENCE BETWEEN EXTERNAL AND INTERNAL GRID POINTS
C
C     OUTPUT DATA BLOCK
C
C        USETF  - FLUID AND STRUCTURAL POINT SET DEFINITION TABLE
C        USETS  - STRUCTURAL POINT SET DEFINITION TABLE
C        AF     - FLUID AREA FACTOR MATRIX
C        DKGG   - STRUCTURAL GRAVITY STIFFNESS AMTRIX
C
C     PARAMETERS
C
C        NOGRAV - INPUT  - FLAG WHICH SPECIFIES WHETHER GRAVITY
C                          EFFECTS ARE TO BE COMPUTED.
C        NOFREE - OUTPUT - FLAG WHICH SPECIFIES WHETHER A FLUID FREE
C                          SURFACE EXISTS.
C        TILT   - OUTPUT - FREE SURFACE TILT VECTOR USED IN PLOTTING
C
C     USER PRINT OPTIONS
C
C        DIAG 32 - PRINTS HYDROELASTIC SET DEFINITION.
C        DIAG 33 - PRINTS HYDROELASTIC DEGREE OF FREEDOM DEFINITION.
C
C
      LOGICAL         ERROR
      INTEGER         GEOM2    ,ECT      ,BGPDT    ,SIL      ,MPT      ,
     1                GEOM3    ,CSTM     ,USET     ,EQEXIN   ,USETF    ,
     2                USETS    ,AF       ,DKGG     ,FBELM    ,FRELM    ,
     3                CONECT   ,AFMAT    ,AFDICT   ,KGMAT    ,KGDICT   ,
     4                Z1       ,Z2(1)    ,SYSBUF
      CHARACTER       UFM*23   ,UWM*25   ,UIM*29
      COMMON /XMSSG / UFM      ,UWM      ,UIM
      COMMON /FLBFIL/ GEOM2    ,ECT      ,BGPDT    ,SIL      ,MPT      ,
     1                GEOM3    ,CSTM     ,USET     ,EQEXIN   ,USETF    ,
     2                USETS    ,AF       ,DKGG     ,FBELM    ,FRELM    ,
     3                CONECT   ,AFMAT    ,AFDICT   ,KGMAT    ,KGDICT
      COMMON /FLBPTR/ ERROR    ,ICORE    ,LCORE    ,IBGPDT   ,NBGPDT   ,
     1                ISIL     ,NSIL     ,IGRAV    ,NGRAV    ,IGRID    ,
     2                NGRID    ,IBUF1    ,IBUF2    ,IBUF3    ,IBUF4    ,
     3                IBUF5
      COMMON /SYSTEM/ SYSBUF   ,NOUT
      COMMON /BLANK / NOGRAV   ,NOFREE   ,TILT(2)
      COMMON /ZZZZZZ/ Z1(1)
      EQUIVALENCE     (Z2(1),Z1(1))
C
C
C     INITILIZE OPEN CORE FOR ELEMENT MATRIX GENERATION PHASE
C
      ERROR =.FALSE.
      LCORE = KORSZ(Z1(1))
      ICORE = 1
      IBUF1 = LCORE - SYSBUF - 1
      IBUF2 = IBUF1 - SYSBUF
      IBUF3 = IBUF2 - SYSBUF
      IBUF4 = IBUF3 - SYSBUF
      IBUF5 = IBUF4 - SYSBUF
C
C     PROCESS FLUID ELEMENTS ON THE FLUID / STRUCTURE BOUNDARY
C     AND THE FREE SURFACE .
C
      CALL FLBELM
      IF (ERROR) GO TO 20
C
C     BUILD THE HYDROELASTIC USET VECTOR
C
      CALL FLBSET
      IF (ERROR) GO TO 20
C
C     GENERATE THE ELEMENT MATRICES
C
      CALL FLBEMG
      IF (ERROR) GO TO 20
C
C     INITIALIZE CORE FOR THE MATRIX ASSEMBLY PHASE
C
      LCORE = KORSZ(Z2(1))
      ICORE = 1
      IBUF1 = LCORE - SYSBUF - 1
      IBUF2 = IBUF1 - SYSBUF
C
C     ASSEMBLE THE AREA FACTOR MATRIX
C
      CALL FLBEMA (1)
C
C     IF GRAVITY LOADS - ASSEMBLE THE GRAVITY STIFFNESS MATRIX
C
      IF (NOGRAV .LT. 0) GO TO 10
      CALL FLBEMA (2)
C
C     MODULE COMPLETION
C
   10 CONTINUE
      RETURN
C
C     FATAL ERROR OCCURED DURING PROCESSING - TERMINATE RUN
C
   20 WRITE  (NOUT,30) UIM
   30 FORMAT (A29,' 8000, MODULE FLBMG TERMINATED DUE TO ABOVE ERRORS.')
      CALL MESAGE (-61,0,0)
      RETURN
      END

      SUBROUTINE MRED2L (NUF,N2,NUS,UFBITS)
C
C     THIS SUBROUTINE PREFORMS PRELIMINARY CALCULATIONS AND MERGES OF
C     THE HK MATRIX FOR THE MRED2 MODULE.
C
      EXTERNAL        ANDF
      INTEGER         DRY,GBUF1,SBUF1,SBUF2,SBUF3,OTFILE,T,SIGNAB,SIGNC,
     1                PREC,SCR,TYPIN,TYPOUT,ANDF,ROWS,UFBITS,PHISS1,
     2                PHISS,DBLKOR,SGLKOR
      DOUBLE PRECISION DZ
      DIMENSION       ITRLR1(7),ITRLR2(7),MODNAM(2),ISUB(4),RZ(1),DZ(1)
      COMMON /BLANK / IDUM1,DRY,IDUM2,GBUF1,IDUM3(2),SBUF1,SBUF2,SBUF3,
     1                INFILE(12),OTFILE(6),ISCR(10),KORLEN,KORBGN,
     2                IDUM4(14),MODPTS,IDUM5(2),LSTZWD
      COMMON /ZZZZZZ/ Z(1)
      COMMON /MPYADX/ ITRLRA(7),ITRLRB(7),ITRLRC(7),ITRLRD(7),NZ,T,
     1                SIGNAB,SIGNC,PREC,SCR
      COMMON /PACKX / TYPIN,TYPOUT,IROW,NROW,INCR
      EQUIVALENCE     (GS,ISCR(7)),(PHISS1,ISCR(8)),(PHISS2,ISCR(9)),
     1                (IDENT,ISCR(5)),(PHISS,ISCR(6)),(PHIGS,ISCR(2)),
     2                (PHIS12,ISCR(2)),(PHI12I,ISCR(8)),(RPRTN,ISCR(5)),
     3                (CPRTN,ISCR(10)),(RZ(1),Z(1)),(DZ(1),Z(1))
      DATA    MODNAM/ 4HMRED,4H2L  /
C
C                  -1
C     COMPUTE PHISS1
C
      IF (DRY .EQ. -2) RETURN
      CALL SOFCLS
      IFILE = PHISS1
      ITRLR1(1) = PHISS1
      CALL RDTRL (ITRLR1)
      CALL GOPEN (PHISS1,Z(GBUF1),0)
      KOLUMN = ITRLR1(2)
      ROWS  = ITRLR1(3)
      ITEST = KOLUMN * ROWS
      IF ((KORBGN+ITEST+(3*KOLUMN)) .GE. KORLEN) GO TO 190
      KORE = 0
      DBLKOR = (KORBGN/2) + 1
      SGLKOR = (2*DBLKOR) - 1
      IF (ITRLR1(5) .EQ. 2) GO TO 15
      DO 10 I = 1,KOLUMN
      CALL READ (*170,*180,PHISS1,Z(SGLKOR+KORE),ROWS,0,NWDSRD)
   10 KORE  = KORE + ROWS
      ICORE = ((SGLKOR+ITEST)/2) + 1
      GO TO 19
   15 DO 18 I = 1,KOLUMN
      CALL READ (*170,*180,PHISS1,DZ(DBLKOR+KORE),ROWS,0,NWDSRD)
   18 KORE  = KORE + ROWS
      ICORE = DBLKOR + ITEST
   19 CALL CLOSE (PHISS1,1)
      INVERT = 0
C
C     NO NEED TO COMPUTE DETERMINANT SINCE IT IS NOT USED SUBSEQUENTLY.
C
      ISING = -1
      CALL INVERS (ROWS,DZ(DBLKOR),KOLUMN,B,INVERT,DETERM,ISING,
     1             DZ(ICORE))
      IF (ISING .EQ. 2) GO TO 192
      KORE  = 0
      INCR  = 1
      TYPIN = 1
      TYPOUT= 1
      IROW  = 1
      NROW  = KOLUMN
      CALL MAKMCB (ITRLR2,PHISS1,NROW,ITRLR1(4),ITRLR1(5))
      CALL GOPEN (PHISS1,Z(GBUF1),1)
      DO 29 I = 1,ROWS
      IF (ITRLR1(5) .EQ. 2) GO TO 25
      CALL PACK (RZ(SGLKOR+KORE),PHISS1,ITRLR2)
      GO TO 29
   25 CALL PACK (DZ(DBLKOR+KORE),PHISS1,ITRLR2)
   29 KORE = KORE + ROWS
      CALL CLOSE (PHISS1,1)
C
C     COMPUTE PHIGS
C
C                               -1
C        **     **    **      **  **     ** **  **
C        *       *    *        *  *       * *    *
C        * PHIGS * = -* PHISS1 *  * PHISS * * GS *
C        *       *    *        *  *       * *    *
C        **     **    **      **  **     ** **  **
C
      ITRLR1(1) = PHISS1
      ITRLR2(1) = PHISS
      CALL RDTRL (ITRLR1)
      CALL RDTRL (ITRLR2)
      ICOL = ITRLR2(3)
      DO 30 I = 1,7
      ITRLRA(I) = ITRLR1(I)
      ITRLRB(I) = ITRLR2(I)
   30 ITRLRC(I) = 0
      CALL MAKMCB (ITRLRD,PHISSI,ITRLR2(3),ITRLR2(4),ITRLR2(5))
      T = 0
      SIGNAB = -1
      SIGNC = 1
      PREC = 0
      SCR = ISCR(10)
      NZ = LSTZWD - ((2*DBLKOR)-1)
      CALL MPYAD (DZ(DBLKOR),DZ(DBLKOR),DZ(DBLKOR))
      CALL WRTTRL (ITRLRD)
      ITRLR1(1) = GS
      CALL RDTRL (ITRLR1)
      DO 40 I = 1,7
      ITRLRA(I) = ITRLRD(I)
   40 ITRLRB(I) = ITRLR1(I)
      CALL MAKMCB (ITRLRD,PHIGS,ITRLR1(3),ITRLR1(4),ITRLR1(5))
      SIGNAB = 1
      CALL MPYAD (DZ(DBLKOR),DZ(DBLKOR),DZ(DBLKOR))
      CALL WRTTRL (ITRLRD)
C
C     FORM HKPG MATRIX
C
C                   **               **
C                   *       .         *
C                   *       .      -1 *
C        **    **   * PHIGS . PHISS   *
C        *      *   *       .         *
C        * HKPG * = *.................*
C        *      *   *       .         *
C        **    **   *   0   .    0    *
C                   *       .         *
C                   **               **
C
      NROW = NUF + N2
      DO 90 I = 1,NROW
      RZ(KORBGN+I-1) = 0.0
      IF (I .GT. N2) RZ(KORBGN+I-1) = 1.0
   90 CONTINUE
      TYPIN  = 1
      TYPOUT = 1
      IROW   = 1
      INCR   = 1
      IFORM  = 7
      CALL MAKMCB (ITRLR1,CPRTN,NROW,IFORM,TYPIN)
      CALL GOPEN (CPRTN,Z(GBUF1),1)
      CALL PACK (Z(KORBGN),CPRTN,ITRLR1)
      CALL CLOSE (CPRTN,1)
      CALL WRTTRL (ITRLR1)
      NROW  = NUS + NUF
      IFILE = USETMR
      CALL GOPEN (USETMR,Z(GBUF1),0)
      DO 100 I = 1,NROW
      CALL READ (*170,*180,USETMR,Z(KORBGN),1,0,NWDSRD)
      RZ(KORBGN+I) = 0.0
      IF (ANDF(Z(KORBGN),UFBITS) .NE. 0) RZ(KORBGN+I) = 1.0
  100 CONTINUE
      CALL CLOSE (USETMR,1)
      NROW = ROWS
      ROWS = NUF + N2
      CALL MAKMCB (ITRLR2,RPRTN,NROW,IFORM,TYPIN)
      CALL GOPEN (RPRTN,Z(GBUF1),1)
      CALL PACK (Z(KORBGN+1),RPRTN,ITRLR2)
      CALL CLOSE (RPRTN,1)
      CALL WRTTRL (ITRLR2)
      ISUB(1) = NUF
      ISUB(2) = N2
      ISUB(3) = NUS
      ISUB(4) = N2
      ITYPE   = 2
      CALL GMMERG (HKPG,PHIGSH,0,PHISS1,0,RPRTN,CPRTN,ISUB,ITYPE,
     1             Z(KORBGN),KORLEN)
C
C     COMPUTE PHIS12
C
C                                -1
C        **      **    **      **  **      **
C        *        *    *        *  *        *
C        * PHIS12 * = -* PHISS1 *  * PHISS2 *
C        *        *    *        *  *        *
C        **      **    **      **  **      **
C
      ITRLR1(1) = PHISS1
      ITRLR2(1) = PHISS2
      CALL RDTRL (ITRLR1)
      CALL RDTRL (ITRLR2)
      MODPTS = ITRLR1(3) + ITRLR2(3)
      DO 110 I = 1,7
      ITRLRA(I) = ITRLR1(I)
  110 ITRLRB(I) = ITRLR2(I)
      CALL MAKMCB (ITRLRD,PHIS12,ITRLR2(3),ITRLR2(4),ITRLR2(5))
      SIGNAB = -1
      CALL MPYAD (DZ(DBLKOR),DZ(DBLKOR),DZ(DBLKOR))
      CALL WRTTRL (ITRLRD)
C
C     GENERATE IDENTITY MATRIX
C
      NROW = ITRLRD(3)
      CALL MAKMCB (ITRLR1,IDENT,NROW,ITRLRD(4),ITRLRD(5))
      CALL GOPEN (IDENT,Z(GBUF1),1)
      DO 130 I = 1,NROW
      DO 120 J = 1,NROW
      RZ(KORBGN+J-1) = 0.0
      IF (J .EQ. I) RZ(KORBGN+J-1) = 1.0
  120 CONTINUE
  130 CALL PACK (Z(KORBGN),IDENT,ITRLR1)
      CALL CLOSE (IDENT,1)
      CALL WRTTRL (ITRLR1)
C
C     GENERATE PHI12I MATRIX
C
C                     **      **
C                     *        *
C        **      **   * PHIS12 *
C        *        *   *        *
C        * PHI12I * = *........*
C        *        *   *        *
C        **      **   *   I    *
C                     *        *
C                     **      **
C
      ITRLR1(1) = PHIS12
      CALL RDTRL (ITRLR1)
      ISUB(3) = ITRLR1(3)
      ISUB(4) = NROW
      NROW = ITRLR1(2) + NROW
      DO 140 I = 1,NROW
      RZ(KORBGN+I-1) = 0.0
      IF (I .GT. ITRLR1(2)) RZ(KORBGN+I-1) = 1.0
  140 CONTINUE
      INCR = 1
      CALL MAKMCB (ITRLR2,CPRTN,NROW,IFORM,TYPIN)
      CALL GOPEN (CPRTN,Z(GBUF1),1)
      CALL PACK (Z(KORBGN),RPRTN,ITRLR2)
      CALL CLOSE (CPRTN,1)
      CALL WRTTRL (ITRLR2)
      CALL GMMERG (PHI12I,PHIS12,IDENT,0,0,0,CPRTN,ISUB,ITYPE,
     1             Z(KORBGN),KORLEN)
      CALL SOFOPN (Z(SBUF1),Z(SBUF2),Z(SBUF3))
      RETURN
C
C     PROCESS SYSTEM FATAL ERRORS
C
  170 IMSG = -2
      GO TO 200
  180 IMSG = -3
      GO TO 200
  190 IMSG = -8
      GO TO 194
  192 IMSG = -37
  194 IFILE = 0
  200 CALL SOFCLS
      CALL MESAGE (IMSG,IFILE,MODNAM)
      RETURN
      END

      SUBROUTINE DIPOLE(BUF,IBUF,XX,YY,ZZ,HC1,HC2,HC3)
C
C DIPOLE COMPUTES THE MAGNETIC INTENSITY AT THE POINT (XX,YY,ZZ) DUE
C TO A MAGNETIC DIPOLE MOMENT DEFINED ON AN MDIPOLE CARD STORED IN BUF.
C THE FORMULATION COMES FROM DARRELL NIXONS REPORT 27-23 MARCH 1972
C
      REAL MX,MY,MZ,MIN,MAX,MXA,MYB,MZC
      DIMENSION  BUF(50),IBUF(50)
      DATA FPI/12.566371/
C
      HC1=0.
      HC2=0.
      HC3=0.
C
C ICID IS 0 FOR NOW AND WILL NOT BE USED. COORDS. AND MOMENT
C ARE ASSUMED TO BE IN BASIC COORDS
C
      ICID=IBUF(1)
C
C COORDS OF POINT DIPOLE
C
      CX=BUF(2)
      CY=BUF(3)
      CZ=BUF(4)
      MX=BUF(5)
      MY=BUF(6)
      MZ=BUF(7)
      MIN=BUF(8)
      MAX=BUF(9)
C
C H WILL BE COMPUTED ONLY IF DISTANCE FROM (CX,CY,CZ) TO (XX,YY,ZZ) IS
C BETWEEN MIN AND MAX- IF MAX IS 0, COMPUTE FOR ALL POINTS GREATER THAN
C MIN
C
      RMR1=SQRT((XX-CX)**2+(YY-CY)**2+(ZZ-CZ)**2)
      IF(MIN.LE.1.E-6)GO TO 5
      IF(RMR1.LT.MIN)GO TO 20
    5 IF(MAX.LE.1.E-6)GO TO 10
      IF(RMR1.GT.MAX)GO TO 20
C
   10 MXA=3.*MX*(XX-CX)
      MYB=3.*MY*(YY-CY)
      MZC=3.*MZ*(ZZ-CZ)
C
      R3=RMR1**3
      R5=R3*RMR1**2
      XNUM=(MXA+MYB+MZC)/R5
C
      HC1=-MX/R3+XNUM*(XX-CX)
      HC1=HC1/FPI
C
      HC2=-MY/R3+XNUM*(YY-CY)
      HC2=HC2/FPI
C
      HC3=-MZ/R3+XNUM*(ZZ-CZ)
      HC3=HC3/FPI
C
   20 RETURN
      END

      SUBROUTINE READ1 (DM,MR,SCR1,SCR2,SCR3,PHIA,USET,NR1,LAMA,SCR4)
C
      INTEGER          DM,MR,IMR(7),SYSBUF,SCR1,SCR2,ISCR1(7),PHIA,
     1                 SCR4,SCR3,NAM(2)
      DOUBLE PRECISION DCORE(1),SI,TERM
      CHARACTER        UFM*23
      COMMON /XMSSG /  UFM
      COMMON /SYSTEM/  SYSBUF,NOUT,KSYSTM(63)
      COMMON /ZZZZZZ/  CORE(1)
      COMMON /UNPAKX/  ITB,II,JJ,INCUR
      COMMON /PACKX /  ITA1,ITB1,II1,JJ1,INCUR1
      COMMON /BITPOS/  UM,UO,UR,USG,USB,UL,UA,UF,US,UN,UG
      EQUIVALENCE      (DCORE(1),CORE(1))
      DATA    NAM   /  4HREAD,4H1    /
C
C     BRING MR INTO CORE
C
      LC = KORSZ(CORE) - SYSBUF
      CALL GOPEN (MR,CORE(LC+1),0)
      IMR(1) = MR
      CALL RDTRL (IMR)
      NR   = IMR(2)
      NR1  = NR
      II   = 1
      JJ   = NR
      INCUR= 1
      ITB  = IMR(5)
      NR2  = ITB*NR
      IVI  = NR*NR
      IPHI = IVI
      IVI2 = ITB*IVI
      IALPH= 2*IVI
      ILOOP= 0
      K    = 0
      DO 20 I = 1,NR
      CALL UNPACK (*12,MR,CORE(K+1))
      GO TO 16
C
C     NULL COLUMN
C
   12 DO 14 J = 1,NR2
      CORE(J+K) = 0.0
   14 CONTINUE
   16 KKK = K + IVI2
      DO 10 J = 1,NR2
      CORE(J+KKK) = 0.0
   10 CONTINUE
      IF (ITB .EQ. 1) GO TO 18
      KKK = KKK/2
      DCORE(KKK+I) = 1.0D0
      GO TO 19
   18 CORE(KKK+I) = 1.0
   19 K = K + NR2
   20 CONTINUE
      CALL CLOSE (MR,1)
C
C     COMPUTE SI
C
      IF (ITB .NE. 2) GO TO 35
   30 SI = 0.0D0
      DO 50 I = 1,NR
      TERM = 0.0D0
      DO 40 J = 1,NR
      K  = (J-1)*NR + I
      KK = IVI + J
   40 TERM = TERM + DCORE(K)*DCORE(KK)
      K  = IVI + I
      SI = SI + TERM*DCORE(K)
   50 CONTINUE
      IF (SI .GT. 0.0D0) GO TO 51
   53 WRITE  (NOUT,52) UFM
   52 FORMAT (A23,' 2200, INCONSISTENT RIGID BODY SYSTEM.')
      CALL MESAGE (-61,0,NAM)
   51 CONTINUE
      SI = 1.0D0/DSQRT(SI)
C
C     CONVERT VI INTO PHI
C
      DO 60 I = 1,NR
      K = IVI + I
   60 DCORE(K) = DCORE(K) *SI
      ILOOP = ILOOP + 1
      IF (ILOOP .EQ. NR) GO TO 120
C
C     CALCULATE ALPHAJ
C
      DO 90 J = 1,ILOOP
      K = IALPH + J
      DCORE(K) = 0.0D0
      DO 80 I = 1,NR
      TERM = 0.0D0
      DO 70 L = 1,NR
      KK  = (L-1)*NR + I
      KKK = IVI + NR + L
   70 TERM = TERM + DCORE(KK)*DCORE(KKK)
      KK = IPHI + (J-1)*NR + I
   80 DCORE(K) = DCORE(K)+TERM*DCORE(KK)
   90 CONTINUE
C
C     COMPUTE NEXT V VECTOR
C
      DO 110 I = 1,NR
      TERM = 0.0D0
      DO 100 J = 1,ILOOP
      KK = IALPH + J
      K  = IPHI + (J-1)*NR + I
  100 TERM = TERM + DCORE(KK)*DCORE(K)
      K = IVI + NR + I
  110 DCORE(K) = DCORE(K) - TERM
      IVI = IVI + NR
      GO TO 30
   35 SSI = 0.0
      DO 55 I = 1,NR
      STERM = 0.0
      DO 45 J = 1,NR
      K  = (J-1)*NR + I
      KK = IVI + J
   45 STERM = STERM + CORE(K)*CORE(KK)
      K   = IVI + I
      SSI = SSI + STERM*CORE(K)
   55 CONTINUE
      IF (SSI .LE. 0.0) GO TO 53
      SSI = 1.0/SQRT(SSI)
C
C     CONVERT VI INTO PHI
C
      DO 65 I = 1,NR
      K = IVI + I
   65 CORE(K) = CORE(K)*SSI
      ILOOP = ILOOP + 1
      IF (ILOOP .EQ. NR) GO TO 120
C
C     CALCULATE ALPHAJ
C
      DO 95 J = 1,ILOOP
      K = IALPH + J
      CORE(K) = 0.0
      DO 85 I = 1,NR
      STERM = 0.0
      DO 75 L = 1,NR
      KK  = (L-1)*NR + I
      KKK = IVI + NR + L
   75 STERM = STERM + CORE(KK)*CORE(KKK)
      KK = IPHI + (J-1)*NR + I
   85 CORE(K) = CORE(K) + STERM*CORE(KK)
   95 CONTINUE
C
C     COMPUTE NEXT V VECTOR
C
      DO 115 I = 1,NR
      STERM = 0.0
      DO 105 J = 1,ILOOP
      KK = IALPH + J
      K  = IPHI + (J-1)*NR + I
  105 STERM = STERM + CORE(KK)*CORE(K)
      K = IVI + NR + I
  115 CORE(K) = CORE(K) - STERM
      IVI = IVI + NR
      GO TO 35
C
C     PACK PHIRO
C
  120 ITA1 = ITB
      ITB1 = ITB
      II1  = 1
      JJ1  = NR
      INCUR1 = 1
      CALL GOPEN (SCR1,CORE(LC+1),1)
      CALL MAKMCB (ISCR1,SCR1,NR,1,ITB)
      DO 130 I = 1,NR
      K = IVI2 + (I-1)*NR2
  130 CALL PACK (CORE(K+1),SCR1,ISCR1)
      CALL CLOSE (SCR1,1)
      CALL WRTTRL (ISCR1(1))
C
C     COMPUTE PHILO = DM*PHIRO
C
      CALL SSG2B (DM,SCR1,0,SCR2,0,ITB,1,SCR4)
C
C     MERGE PHIRP AND PHILO TO FORM PHIA
C
      CALL SDR1B (SCR3,SCR2,SCR1,SCR4,UA,UL,UR,USET,0,0)
      CALL GOPEN (SCR4,CORE(LC+1),0)
      LC = LC - SYSBUF
      CALL GOPEN (PHIA,CORE(LC+1),1)
      IMR(1) = SCR4
      CALL RDTRL (IMR(1))
      NPROB = IMR(3)
      DCORE(1) = 0.D0
      JJ = NPROB
      INCUR = 1
      I3 = 3
      DO 170 J = 1,NR
      II = 0
      CALL UNPACK (*150,SCR4,CORE(I3))
      II1 = II
      JJ1 = JJ
      CALL PACK (CORE(I3),PHIA,ISCR1)
      GO TO 170
C
C     NULL COLUMN
C
  150 II1 = 1
      JJ1 = 1
      CALL PACK (CORE,PHIA,ISCR1)
  170 CONTINUE
      CALL CLOSE (SCR4,1)
      CALL CLOSE (PHIA,1)
      LC = LC + SYSBUF
C
C     PUT NR ZEROS ON LAMA
C
      CALL GOPEN (LAMA,CORE(LC+1),1)
      DCORE(1) = 0.D0
      DO 180 I = 1,NR
  180 CALL WRITE (LAMA,CORE,ITB,1)
      CALL CLOSE (LAMA,2)
      RETURN
      END

      SUBROUTINE SDR2E (*,IEQEX,NEQEX)
C
C     THIS ROUTINE WHICH IS CALLED ONLY FROM SDR2D WILL PROCESS THE ESTA
C     FILE ONCE AND OUTPUT FORCE AND OR STRESS RESULTS ON OEF1 AND OR
C     OES1 WHICH ARE OPENED IN SDR2D.
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        ANDF
      LOGICAL         EORFLG,ENDID ,RECORD,ACSTIC,AXIC  ,AGAIN ,IDSTRS,
     1                IDFORC,EOFCC ,IDLYST,IDLYFR,OK2WRT,HEAT  ,DDRMM ,
     2                STRAIN,ILOGIC(4)
      INTEGER         BUF(50)      ,PLATIT(12)   ,COMPLX(478)  ,
     1                ISAVEF(75)   ,ISAVES(75)
      REAL            ZZ(1) ,BUFR(1)      ,TGRID(33)    ,DIFF1 ,DIFF  ,
     1                DEFORM,FRTMEI,TEMP  ,TWOTOP,FNCHK
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG / UFM   ,UWM   ,UIM   ,SFM
      COMMON /LHPWX / LH(6) ,MTISA
      COMMON /BLANK / APP(2),SORT2 ,ISTRN ,IDUM1 ,COMPS ,IDUM4(4)     ,
     1                STRAIN
      COMMON /SDR2C1/ IPCMP ,NPCMP ,IPCMP1,NPCMP1,IPCMP2,NPCMP2,NSTROP
      COMMON /SDR2X1/ IEIGEN,IELDEF,ITLOAD,ISYMFL,ILOADS,IDISPL,ISTR  ,
     1                IELF  ,IACC  ,IVEL  ,ISPCF ,ITTL  ,ILSYM ,IFROUT,
     2                ISLOAD,IDLOAD,ISORC
      COMMON /SDR2X2/ CASECC,CSTM  ,MPT   ,DIT   ,EQEXIN,SIL   ,GPTT  ,
     1                EDT   ,BGPDT ,PG    ,QG    ,UGV   ,EST   ,PHIG  ,
     2                EIGR  ,OPG1  ,OQG1  ,OUGV1 ,OES1  ,OEF1  ,PUGV1 ,
     3                OEIGR ,OPHIG ,PPHIG ,ESTA  ,GPTTA ,HARMS ,IDUM3(3)
     4,               OES1L ,OEF1L
      COMMON /GPTA1 / NELEM ,LAST  ,INCR  ,ELEM(1)
      COMMON /SDR2X4/ NAM(2),END   ,MSET  ,ICB(7),OCB(7),MCB(7),DTYPE(8)
     1,               ICSTM ,NCSTM ,IVEC  ,IVECN ,TEMP  ,DEFORM,FILE  ,
     2                BUF1  ,BUF2  ,BUF3  ,BUF4  ,BUF5  ,ANY   ,ALL   ,
     3                TLOADS,ELDEF ,SYMFLG,BRANCH,KTYPE ,LOADS ,SPCF  ,
     4                DISPL ,VEL   ,ACC   ,STRESS,FORCE ,KWDEST,KWDEDT,
     5                KWDGPT,KWDCC ,NRIGDS,STA(2),REI(2),DS0(2),DS1(2),
     6                FRQ(2),TRN(2),BK0(2),BK1(2),CEI(2),PLA(22)      ,
     7                NRINGS,NHARMS,AXIC  ,KNSET ,ISOPL ,STRSPT,DDRMM
      COMMON /SDR2X7/ ELESTA(100)  ,BUFA(100)    ,BUFB(4076)
      COMMON /SDR2X8/ ELWORK(300)
      COMMON /SDR2X9/ NCHK  ,ISUB  ,ILD   ,FRTMEI(2)    ,TWOTOP,FNCHK
      COMMON /ZZZZZZ/ Z(1)
      COMMON /ISAVE / ISAVEF,ISAVES
      COMMON /NAMES / RD    ,RDREW ,WRT   ,WRTREW,CLSREW
      COMMON /CLSTRS/ COMPLX
      COMMON /SYSTEM /KSYSTM(100)
      COMMON /SDR2DE/ BUF6  ,COEF  ,DEFTMP,DIFF  ,DIFF1 ,DEVICE,ESTAWD,
     1                ELEMID,ELTYPE,EOF   ,EOFCC ,IREQX ,FLAG  ,FN    ,
     2                FORCEX,FSETNO,FORMT ,ICC   ,I     ,IEDT  ,ISETNO,
     3                ISETF ,ISETS ,IDEF  ,ISYMN ,SDEST ,IX    ,ISETNF,
     4                ISEQ  ,IRETRN,IRECX ,ISAVE ,FDEST ,IPART ,ILIST ,
     5                IGPTTA,ICORE ,IELEM ,IESTA ,BUF8  ,JFORC ,JSTRS ,
     6                JANY  ,JLIST ,J     ,KTYPE1,KHI   ,KX    ,K     ,
     7                KLO   ,KN    ,KTYPEX,KFRQ  ,KCOUNT,LSYM  ,M     ,
     8                MIDVEC,NWDSA ,NWDSTR,NLOGIC,NWDS  ,NDEF  ,N     ,
     9                N1    ,N2    ,NOTSET,NSETS ,NSETF ,NWORDS,NX    ,
     O                TDUMM(4)     ,NWDFOR,NGPTT ,NESTA ,NVECTS,NLIST ,
     A                OFILE ,OUTFL ,RETX  ,SETNO ,STRESX,SAVE  ,TLOAD ,
     B                UGVVEC,IXSETS,NXSETS,IXSETF,NXSETF,XSETNS,XSETNF,
     C                SORC  ,TMPREC,BUF7  ,TGRID
      COMMON /SDRETT/ IELTYP,OLDEL ,EORFLG,ENDID ,BUFFLG,ITEMP ,XX2(2),
     1                RECORD,OLDEID
      EQUIVALENCE     (KSYSTM( 2),OPTE  ) ,(KSYSTM(55),IPREC  ),
     1                (KSYSTM(56),ITHERM)
      EQUIVALENCE     (BUF(1),BUFR(1)   ) ,(Z(1)  ,ZZ(1)      ),
     1                (IDSTRS,ILOGIC(1) ) ,(IDFORC,ILOGIC(2)  ),
     2                (IDLYST,ILOGIC(3) ) ,(IDLYFR,ILOGIC(4)  ),
     3                (TEMP  ,JTEMP     ) ,(NELHAR,ELWORK(155))
      DATA PLATIT / 4HLOAD,4H FAC,4HTOR , 9*0    /
      DATA BUF    / 50*0 /, IELOLD / 0 /, IELCHK / 0 /
C
C     INITIALIZE ESTA POINTERS.
C
      IF (STRESX.EQ.0 .AND. FORCEX.EQ.0) RETURN
      HEAT   = .FALSE.
      IF (ITHERM .NE. 0) HEAT = .TRUE.
      ESTAWD = IESTA
      ISTORE = 0
      IX     = ICC + HARMS
      AGAIN  =.FALSE.
      OHARMS = Z(IX)
      IF (OHARMS .LT. 0) OHARMS = NHARMS
      ISAVE  = IVEC
      ISVSRC = SORC
      ELTYPE = Z(ESTAWD)
      FILE   = ESTA
      IX     = ICC + ISTR + 2
      SPHASE = IABS(Z(IX))
      IX     = ICC + IELF + 2
      FPHASE = IABS(Z(IX))
      TWO TO P = ALOG10(2.0**MTISA)
C
C     POSITION TO THE PROPER THERMAL RECORD IF NECESSARY.
C
      RECORD = .FALSE.
      IF (TLOADS .EQ. 0) GO TO 18
      IF (TMPREC .EQ. 0) GO TO 18
      CALL REWIND (GPTT)
      FILE = GPTT
      DO 15 I = 1,TMPREC
      CALL FWDREC (*980,GPTT)
   15 CONTINUE
C
C     READ AND VERIFY SET-ID  (FAILSAFE)
C
      CALL READ (*980,*990,GPTT,ISETID,1,0,FLAG)
      IF (TLOADS .EQ. ISETID) GO TO 17
      WRITE  (OPTE,16) SFM,TLOADS,ISETID
   16 FORMAT (A25,' 4019, SDR2E DETECTS INVALID TEMPERATURE DATA FOR ',
     1       'TEMPERATURE LOAD SET',2I10)
      CALL MESAGE (-61,0,0)
   17 RECORD = .TRUE.
C
C     INITIALIZE /SDRETT/ VARIABLES
C
      OLDEID = 0
      OLDEL  = 0
      EORFLG = .FALSE.
      ENDID  = .TRUE.
   18 ITEMP  = TLOADS
      IF (NESTA .NE. 0) GO TO 25
      CALL REWIND (ESTA)
   20 CALL READ (*950,*990,ESTA,ELTYPE,1,0,FLAG)
C
C     ELEMENT PARAMETERS FOR NEW ELEMENT TYPE
C
   25 IELEM  = (ELTYPE-1)*INCR
      IELTYP = ELTYPE
      IPR    = IPREC
      IF (IPR .NE. 1) IPR = 0
      JLTYPE = 2*ELTYPE - IPR
      JCORE  = ICORE
      IF (HEAT .AND. ELTYPE.NE.82) GO TO 27
C                            FTUBE
      NWDSA  = ELEM(IELEM+17)
      NPTSTR = ELEM(IELEM+20)
      NPTFOR = ELEM(IELEM+21)
      NWDSTR = ELEM(IELEM+18)
      NWDFOR = ELEM(IELEM+19)
      GO TO 28
C
   27 NWDFOR = 9
      NWDSTR = 0
      NPTFOR = 0
      NPTSTR = 0
      NWDSA  = 142
C
C     CHOP OFF 483 WORDS FROM OPEN CORE SPACE FOR CIHEX ELEMENTS
C
      IF (ELTYPE.LT.65 .OR. ELTYPE.GT.67) GO TO 28
      ICORE  = ICORE - 483
C
   28 CONTINUE
C
C     SETUP STRESS PRECISION CHECK.
C
      NCHK  = Z(ICC+146)
      FNCHK = NCHK
C
C     SUBCASE ID
C
      ISUB  = Z(ICC+1)
C
C     DETERMINE LOAD/MODE, EIGENVALUE/FREQ/TIME HEADER
C
      FRTMEI(1) = 0.
      FRTMEI(2) = 0.
      IF (BRANCH.EQ.5 .OR. BRANCH.EQ.6)  GO TO 31
      IF (BRANCH.EQ.2 .OR. BRANCH.EQ.8 .OR. BRANCH.EQ.9) GO TO 32
C
C     STATICS
C
      I   = ICC + ISLOAD
      ILD = Z(I)
      GO TO 35
C
C     FREQUENCY/TRANSIENT
C
   31 I   = ICC + IDLOAD
      ILD = Z(I)
      FRTMEI(1) = ZZ(JLIST)
      GO TO 35
C
C     EIGENVALUES
C
   32 ILD       =  Z(JLIST  )
      FRTMEI(1) = ZZ(JLIST+1)
      FRTMEI(2) = ZZ(JLIST+2)
      IF (BRANCH .NE. 2) GO TO 35
      IF (ZZ(JLIST+1) .GT. 0.) FRTMEI(1) = SQRT(ZZ(JLIST+1))/6.2831852
   35 CONTINUE
      LSTRES = NWDSTR
      LFORCE = NWDFOR
      IDSTRS = .FALSE.
      IDFORC = .FALSE.
      IDLYST = .FALSE.
      IDLYFR = .FALSE.
      OK2WRT = .TRUE.
      IF (KTYPE.NE.1 .AND. NPTSTR.EQ.0 .AND. NPTFOR.EQ.0) GO TO 40
      IF (NWDSTR+NWDFOR .GT. 0) GO TO 70
C
C     NO STRESS OR FORCE WORDS POSSIBLE FOR THIS ELEMENT TYPE IF FALL
C     HERE
C
   40 IF (NESTA) 60,50,60
C
C     FORWARD REC ON FILE TO NEXT ELEMENT TYPE
C
   50 CALL FWDREC (*980,ESTA)
      GO TO 20
C
C     FIND END OF CURRENT ELEMEMT TYPE LIST IN CORE
C
   60 ESTAWD = ESTAWD + NWDSA
      IF (Z(ESTAWD+1)) 60,940,60
C
C     OK SOME STRESS AND OR FORCE REQUESTS EXIST FOR THIS ELEMENT TYPE.
C     PROCESS INDIVIDUAL ELEMENTS REQUESTED
C
   70 IF (NESTA .NE.     0) GO TO 90
      IF (NWDSA .LE. ICORE) GO TO 80
      CALL MESAGE (8,0,NAM(1))
C
C
C     INSUFFICIENT CORE TO HOLD ESTA FOR 1 ELEMENT OF CURRENT ELEMENT
C     TYPE TRY PROCESSING THE OTHER ELEMENT TYPES IN AVAILABLE CORE.
C
      GO TO 50
C
   80 CALL READ (*980,*910,ESTA,Z(IESTA),NWDSA,0,FLAG)
      ESTAWD = IESTA - 1
C
C     DETERMINE IF THIS PARTICULAR ELEMENT OF THE CURRENT ELEMENT TYPE
C     HAS A STRESS OR FORCE REQUEST IN THE CURRENT CASE CONTROL RECORD.
C
   90 ELEMID = Z(ESTAWD+1)
C
C     THE FOLLOWING CODE (THRU 93) IS FOR THE COMPLEX ANALYSIS OF IHEX
C     ELEMENTS ONLY (ELEM. TYPES 65,66,67)
C
      IF (KTYPE.NE.2 .OR. ELTYPE.LT.65 .OR. ELTYPE.GT.67) GO TO 93
      IF (IPART.NE.2 .OR. ISTRPT.NE.(NIP3+NGP1+1)) GO TO 91
C
C     DONE FOR THIS IHEX ELEMENT, RESET CHECKING VARIABLES
C
      IPART  = 0
      IELOLD = 0
      IELCHK = 0
      GO TO 93
C
C     FIRST INTEGRATION POINT FOR IMAGINARY RETULS FOR THIS IHEX ELEMENT
C     SAVE ELEMENT ID AND CURRENT ESTAWD
C
   91 IF (IPART.NE.1 .OR. ISTRPT.NE.1) GO TO 92
      IELOLD = ELEMID
      OLDAWD = ESTAWD - NWDSA
      GO TO 93
C
C     FIRST INTEGRATION POINT FOR REAL RESULTS FOR THIS IHEX ELEMENT,
C     SAVE ELEMENT ID TO CHECK WITH EARLIER ELEMENT ID SAVED ABOVE
C
   92 IF (IPART.EQ.2 .AND. ISTRPT.EQ.1) IELCHK = ELEMID
C
C     END OF SPECIAL TREATMENT FOR IHEX ELEMENT
C
   93 IDELEM = ELEMID
C
C     DECODE ELEMID TO FIND IT IN SET
C
      IF (.NOT. AXIC) GO TO 95
      NELHAR = ELEMID - (ELEMID/1000)*1000
      ELEMID = ELEMID/1000
   95 JSTRS  = 0
      JFORC  = 0
      I      = ISETS
      IF (NWDSTR .EQ. 0) GO TO 140
      IF (STRESX) 110,140,100
  100 IF (I .EQ. NSETS) GO TO 120
      IF (Z(I+1) .GT.0) GO TO 120
      I = I + 1
      IF (ELEMID.LT.Z(I-1) .OR. ELEMID.GT.-Z(I)) GO TO 130
  110 JSTRS = 1
      GO TO 140
  120 IF (ELEMID .EQ. Z(I)) GO TO 110
  130 I = I + 1
      IF (I .LE. NSETS) GO TO 100
  140 I = ISETF
      IF (NWDFOR .EQ. 0) GO TO 190
      IF (FORCEX) 160,190,150
  150 IF (I .EQ. NSETF) GO TO 170
      IF (Z(I+1) .GT.0) GO TO 170
      I = I + 1
      IF (ELEMID.LT.Z(I-1) .OR. ELEMID.GT.-Z(I)) GO TO 180
  160 JFORC = 1
      GO TO 190
  170 IF (ELEMID .EQ. Z(I)) GO TO 160
  180 I = I + 1
      IF (I .LE. NSETF) GO TO 150
  190 JANY= JSTRS + JFORC
      IF (JANY .EQ. 0) IF (NESTA) 890,80,890
C
C     OK FALL HERE AND A STRESS OR FORCE REQUEST EXISTS
C     IF THERMAL LOADING, GET THE ELEMENT THERMAL DATA.
C     IF ELEMENT DEFORMATIONS, LOOK UP THE DEFORMATION
C
C
C     ELEMENT TEMPERATURE
C
      IF (TLOADS .EQ. 0) GO TO 330
      N = ELEM(IELEM+10)
C
C     IF NEW ELEMENTS ARE ADDED THAT HAVE SPECIAL BENDING THERMAL DATA
C     POSSIBLE THEN THE FOLLOWING TEST SHOULD BE EXPANDED TO INCLUDE
C     THEIR ELEMENT TYPE SO AS TO RECEIVE ZEROS AND ONLY THE AVERAGE
C     TEMPERATURE RATHER THAN SIMULATED GRID POINT TEMPERATURES IN THE
C     ABSENCE OF ANY USER SPECIFIED DATA.
C
      IF (IELTYP.EQ.34 .OR. IELTYP.EQ. 6 .OR. IELTYP.EQ.7  .OR.
     1    IELTYP.EQ. 8 .OR. IELTYP.EQ.15 .OR. IELTYP.EQ.17 .OR.
     2    IELTYP.EQ.18 .OR. IELTYP.EQ.19) N = 0
      IF (IELTYP.EQ.74 .OR. IELTYP.EQ.75) N = 0
      IF (IELTYP.EQ.64 .OR. IELTYP.EQ.83) N = 0
C
C
      CALL SDRETD (IDELEM,TGRID,N)
C
C     SET THE AVERAGE ELEMENT TEMPERATURE CELL.
C
      TEMP = TGRID(1)
      GO TO 340
C
C     NORMALLY TGRID(1) WILL CONTAIN THE AVERAGE ELEMENT TEMPERATUE
C     AND IF GRID POINT TEMPERATURES ARE RETURNED THEY WILL BEGIN
C     IN TGRID(2).
C
  330 JTEMP = -1
C
C     ELEMENT DEFORMATION
C
  340 DEFORM = 0.0
      IF (ELDEF .EQ. 0) GO TO 360
      DO 350 I = IDEF,NDEF,2
      IF (Z(I) .EQ. ELEMID) GO TO 355
  350 CONTINUE
      GO TO 360
  355 DEFORM = ZZ(I+1)
C
C     WRITE ID FOR STRESSES IF NOT YET WRITTEN FOR THIS ELEMENT TYPE.
C
  360 IF (STRESS.EQ.0 .OR.  NWDSTR.EQ.0 .OR. JSTRS.EQ.0) GO TO 365
      IF (COMPS.EQ.-1 .AND. NSTROP.GT.1) GO TO 362
      IF (IDSTRS) GO TO 365
      NLOGIC = 1
      OFILE  = OES1
      DEVICE = SDEST
      ISEQ   = 4
      IFLTYP = DTYPE(ISEQ)
      IRECX  = ICC + ISTR
      NWDS   = NWDSTR
      JCMPLX = NPTSTR
      ASSIGN 365 TO IRETRN
      GO TO 630
C
  362 IF (IDLYST) GO TO 365
      NLOGIC = 3
      OFILE  = OES1L
      DEVICE = SDEST
      IFLTYP = 22
      IRECX  = ICC + ISTR
      NWDS   = 10
      JCMPLX = 0
      OK2WRT = .FALSE.
      ASSIGN 365 TO IRETRN
      GO TO 630
C
C     WRITE ID FOR FORCES IF NOT YET WRITTEN FOR THIS ELEMENT TYPE.
C
  365 IF (FORCE.EQ. 0 .OR.  NWDFOR.EQ.0 .OR.  JFORC .EQ.0) GO TO 375
      IF (COMPS.EQ.-1 .AND. NSTROP.GT.1 .AND. STRESS.NE.0) GO TO 367
      IF (IDFORC) GO TO 375
      NLOGIC = 2
      OFILE  = OEF1
      DEVICE = FDEST
      ISEQ   = 5
      IFLTYP = DTYPE(ISEQ)
      IRECX  = ICC + IELF
      NWDS   = NWDFOR
      JCMPLX = NPTFOR
      ASSIGN 375 TO IRETRN
      GO TO 630
C
  367 IF (IDLYFR) GO TO 375
      NLOGIC = 4
      OFILE  = OEF1L
      DEVICE = FDEST
      IFLTYP = 23
      IRECX  = ICC + IELF
      NWDS   = 9
      JCMPLX = 0
      OK2WRT = .FALSE.
      ASSIGN 375 TO IRETRN
      GO TO 630
C
C     MOVE ESTA DATA INTO /SDR2X7/
C
  375 NSESTA = ESTAWD
      IF (IELCHK.EQ.0 .OR. IPART.LT.2 .OR. IELCHK.NE.IELOLD) GO TO 377
      IPART  = 1
      GO TO 380
  377 IPART  = 0
  380 IPART  = IPART + 1
      DO 390 I = 1,NWDSA
      ESTAWD = ESTAWD + 1
  390 ELESTA(I) = Z(ESTAWD)
      ACSTIC = .FALSE.
C
C     CALL APPROPRIATE ELEMENT ROUTINE FOR STRESS AND FORCE COMPUTATIONS
C
      IF (HEAT) GO TO 1680
      LOCAL = JLTYPE - 100
      IF (LOCAL) 394,394,395
C
C     PAIRED -GO TO- ENTRIES PER ELEMENT SINGLE/DOUBLE PRECISION
C
C             1 CROD      2 C.....    3 CTUBE     4 CSHEAR    5 CTWIST
  394 GO TO( 400,  400,  610,  610,  400,  400,  420,  420,  430,  430
C
C             6 CTRIA1    7 CTRBSC    8 CTRPLT    9 CTRMEM   10 CONROD
     1,      450,  450,  460,  460,  470,  470,  480,  480,  400,  400
C
C            11 ELAS1    12 ELAS2    13 ELAS3    14 ELAS4    15 CQDPLT
     2,      490,  490,  490,  490,  490,  490,  490,  490,  500,  500
C
C            16 CQDMEM   17 CTRIA2   18 CQUAD2   19 CQUAD1   20 CDAMP1
     3,      520,  520,  450,  450,  540,  540,  540,  540,  610,  610
C
C            21 CDAMP2   22 CDAMP3   23 CDAMP4   24 CVISC    25 CMASS1
     4,      610,  610,  610,  610,  610,  610,  610,  610,  610,  610
C
C            26 CMASS2   27 CMASS3   28 CMASS4   29 CONM1    30 CONM2
     5,      610,  610,  610,  610,  610,  610,  610,  610,  610,  610
C
C            31 PLOTEL   32 C.....   33 C.....   34 CBAR     35 CCONE
     6,      610,  610,  610,  610,  610,  610,  560,  560,  570,  570
C
C            36 CTRIARG  37 CTRAPRG  38 CTORDRG  39 CTETRA   40 CWEDGE
     7,      580,  580,  590,  590,  600,  600,  601,  601,  602,  602
C
C            41 CHEXA1   42 CHEXA2   43 CFLUID2  44 CFLUID3  45 CFLUID4
     8,      603,  603,  604,  604,  610,  610,  610,  610,  610,  610
C
C            46 CFLMASS  47 CAXIF2   48 CAXIF3   49 CAXIF4   50 CSLOT3
     9,      610,  610,  605,  605,  606,  606,  607,  607,  608,  608
C
     *), JLTYPE
C
C            51 CSLOT4   52 CHBDY    53 CDUM1    54 CDUM2    55 CDUM3
  395 GO TO( 609,  609,  610,  610, 1614, 1614, 1615, 1615, 1616, 1616
C
C            56 CDUM4    57 CDUM5    58 CDUM6    59 CDUM7    60 CDUM8
     B,     1617, 1617, 1618, 1618, 1619, 1619, 1620, 1620, 1621, 1621
C
C            61 CDUM9    62 CQDMEM1  63 CQDMEM2  64 CQUAD4   65 CIHEX1
     C,     1622, 1622, 1623, 1623, 1624, 1624, 1625, 1625, 1626, 1626
C
C            66 CIHEX2   67 CIHEX3   68 CQUADTS  69 CTRIATS  70 CTRIAAX
     D,     1626, 1626, 1626, 1626, 1632, 1632, 1633, 1633, 1634, 1634
C
C            71 CTRAPAX  72 CAERO1   73 CTRIM6   74 CTRPLT1  75 CTRSHL
     E,     1635, 1635,  610,  610, 1640, 1640, 1645, 1645, 1650, 1650
C
C            76 CFHEX1   77 CFHEX2   78 CFTETRA  79 CFWEDGE  80 CIS2D8
     F,      610,  610,  610,  610,  610,  610,  610,  610, 1660, 1660
C
C            81 CELBOW   82 CFTUBE   83 CTRIA3
     G,      1670, 1670, 610,  610, 1630, 1630
C
     *), LOCAL
C
  400 CALL SROD2
      GO TO 620
  420 K = 4
      GO TO 440
  430 K = 5
  440 CALL SPANL2 (K)
      GO TO 620
  450 K = 3
      GO TO 550
  460 K = 0
      GO TO 510
  470 K = 3
      GO TO 510
  480 K = 1
      GO TO 530
  490 CALL SELAS2
      GO TO 620
  500 K = 4
  510 CALL SBSPL2 (K,TGRID(1))
      GO TO 620
  520 K = 2
  530 CALL STQME2 (K)
      GO TO 620
  540 K = 4
  550 CALL STRQD2 (K,TGRID(1))
      GO TO 620
  560 CALL SBAR2 (TGRID(1))
      GO TO 620
  570 AGAIN = .FALSE.
      CALL SCONE2 (SORC)
      GO TO 620
  580 CALL STRIR2 (TGRID(2))
      GO TO 620
  590 CALL STRAP2 (TGRID(2))
      GO TO 620
  600 CALL STORD2 (TGRID(2))
      GO TO 620
  601 CALL SSOLD2 (1,TGRID(2))
      GO TO 620
  602 CALL SSOLD2 (2,TGRID(2))
      GO TO 620
  603 CALL SSOLD2 (3,TGRID(2))
      GO TO 620
  604 CALL SSOLD2 (4,TGRID(2))
      GO TO 620
  605 KK = 0
      GO TO 611
  606 KK = 1
      GO TO 611
  607 KK = 2
  611 CALL SAXIF2 (KK,IPART,BRANCH,Z(JLIST))
      ACSTIC = .TRUE.
      GO TO 620
  608 KK = 0
      GO TO 612
  609 KK = 1
  612 CALL SSLOT2 (KK,IPART,BRANCH,Z(JLIST))
      ACSTIC = .TRUE.
      GO TO 620
 1614 CALL SDUM12
      GO TO 620
 1615 CALL SDUM22
      GO TO 620
 1616 CALL SDUM32
      GO TO 620
 1617 CALL SDUM42
      GO TO 620
 1618 CALL SDUM52
      GO TO  620
 1619 CALL SDUM62
      GO TO 620
 1620 CALL SDUM72
      GO TO 620
 1621 CALL SDUM82
      GO TO 620
 1622 CALL SDUM92
      GO TO 620
 1623 CALL SQDM12
      GO TO 620
 1624 CALL SQDM22
      GO TO 620
 1625 CALL SQUD42
      GO TO 620
 1626 CALL SIHEX2 (ELTYPE-64,TGRID(1),NIP,ISTRPT,ISTORE)
      NGP  = 12*(ELTYPE-64) - 4
      NGP1 = NGP + 1
      IF (ELTYPE .EQ. 67) NGP1 = 21
      NIP3 = NIP**3
      IF (ISTRPT .LT. NIP3+1) GO TO 905
      IF (ISTRPT .EQ. NIP3+1) GO TO 1626
      IF (ISTRPT .EQ. NIP3+1+NGP1) ISTORE = 0
      IF (KTYPE .EQ. 1) GO TO 620
      NGPX = ISTRPT - (NIP3+1)
      NW   = 22
      IF (ELTYPE .EQ. 67) NW = 23
      IST = NW*(NGPX-1)
      IF (IPART .GE. KTYPE) GO TO 1628
C
C     STORE IMARINARY PARTS FOR THIS GRID (IHEX ELEMENTS)
C
      IJK = IST + ICORE
      DO 1627 J = 1,NW
 1627 Z(J+IJK) = BUFA(J)
      IF (ISTORE .NE. 0) GO TO 1626
      IVEC   = MIDVEC
      ESTAWD = OLDAWD
      GO TO 380
C
C     RETRIEVE IMAGINARY PARTS FOR THIS GRID (IHEX ELEMENTS)
C
 1628 IJK = IST + ICORE
      DO 1629 J = 1,NW
 1629 ISAVES(J) = Z(J+IJK)
      GO TO 620
C
 1630 CALL STRI32
      GO TO 620
 1632 CONTINUE
      GO TO 620
 1633 CONTINUE
      GO TO 620
 1634 AGAIN = .FALSE.
      CALL STRAX2 (SORC,TGRID(2))
      GO TO 620
 1635 AGAIN = .FALSE.
      CALL STPAX2 (SORC,TGRID(2))
      GO TO 620
 1640 CALL STRM62 (TGRID(1))
      GO TO 620
 1645 CALL STRP12 (TGRID(1))
      GO TO 620
 1650 CALL  STRSL2 (TGRID(1))
      GO TO 620
 1660 CALL SS2D82 (IEQEX,NEQEX,TGRID(1))
      GO TO 620
 1670 CALL SELBO2 (TGRID(1))
      GO TO 620
C
C     PHASE TWO HEAT ONLY (ALL ELEMENTS)
C
 1680 CALL SDHTF2 (IEQEX,NEQEX)
      GO TO 620
  610 GO TO 900
C
C     CALL ELEMENT TWO TIMES FOR COMPLEX VECTOR.  IMAGINARY FIRST, REAL
C     SECOND.  CALL ELEMENT ROUTINE TWICE IF AXIC PROBLEM
C     ONCE FOR EACH OF THE 2 VECTORS IN CORE
C
  620 IF (AXIC .AND. MIDVEC.NE.0 .AND. IPART.EQ.1) GO TO 625
      IF (IPART .GE. KTYPE) GO TO 615
  625 IVEC = MIDVEC
C
C     FOR CONICAL SHELL ONLY
C
      IF (AXIC .AND. KTYPE.NE.1) GO TO 626
      ITEMP = 1
      IF (SORC .EQ. 1) ITEMP = 2
      SORC  = ITEMP
  626 CONTINUE
      ESTAWD = NSESTA
      IF (AXIC .AND. KTYPE.EQ.1) GO TO 380
C
C     SAVE IMAGINARY OUTPUTS  (NOT MORE THAN 75 STRESS OR FORCE WORDS)
C
      DO 622 I = 1,75
      ISAVES(I) = BUFA(I)
  622 ISAVEF(I) = BUFB(I)
      GO TO 380
C
C     SPLIT OUTPUT FROM SECOND CALL FOR ACOUSTIC ELEMENTS
C     AXIF2, AXIF3, AXIF4, SLOT3, OR SLOT4.
C
  615 IF (.NOT. ACSTIC) GO TO 617
      IF (IPART .LT. 2) GO TO 617
      DO 613 I = 1,12
      ISAVES(I) = BUFA(I   )
      BUFA(I)   = BUFA(I+12)
  613 CONTINUE
C
C
C     OUTPUT ONLY FIRST N HARMONICS REQUESTED
C
  617 IF (.NOT. AXIC) GO TO 616
      IF (NELHAR.LT.0 .OR. NELHAR.GT.OHARMS) GO TO 880
      IF (IPART.EQ.2 .AND. KTYPE.EQ.1) GO TO 880
C
C     OUTPUT STRESS RESULTS ON OES1 (IF REQUESTED)
C
  616 IF (JSTRS.EQ.0 .OR. NWDSTR.EQ.0) GO TO 860
      IF (KTYPE .EQ. 1) GO TO 850
C
C     COMBINE COMPLEX OUTPUT DESIRED PER FORMAT IN COMPLX ARRAY.
C          REAL PARTS ARE IN BUFA   BUFB
C          IMAG PARTS ARE IN ISAVES ISAVEF
C
C
C     COMPLEX STRESSES
C
      IOUT = 0
      I    = NPTSTR
  651 NPT  = COMPLX(I)
      IF (NPT) 652,653,654
  652 NPT  = -NPT
      IF (SPHASE .NE. 3) GO TO 654
C
C     COMPUTE MAGNITUDE/PHASE
C
      CALL MAGPHA (BUFA(NPT),ISAVES(NPT))
  655 IOUT = IOUT + 1
      ELWORK(IOUT) = BUFA(NPT)
      I    = I + 1
      GO TO 651
  654 IF (NPT .LE. LSTRES) GO TO 655
      NPT  = NPT - LSTRES
      IOUT = IOUT + 1
      ELWORK(IOUT) = ISAVES(NPT)
      I    = I + 1
      GO TO 651
C
C     TRANSFER RESULTS TO BUFA
C
  653 DO 659 I = 1,IOUT
  659 BUFA(I) = ELWORK(I)
      NWDSTR  = IOUT
C
C     WRITE STRESSES
C
C
C     DETERMINE DESTINATION FOR STRESS ENTRY
C
  850 IF (STRESS .EQ. 0) GO TO 860
      IF (.NOT.  OK2WRT) GO TO 860
      ID = BUFA(1)
      BUFA(1) = 10*ID + SDEST
      IF (XSETNS) 858,851,852
  851 BUFA(1) = 10*ID
      GO TO 858
  852 IX = IXSETS
  853 IF (IX .EQ. NXSETS) GO TO 854
      IF (Z(IX+1) .GT. 0) GO TO 854
      IF (ID.GE.Z(IX) .AND. ID.LE.(-Z(IX+1))) GO TO 858
      IX = IX + 2
      GO TO 855
  854 IF (ID .EQ. Z(IX)) GO TO 858
      IX = IX + 1
  855 IF (IX .LE. NXSETS) GO TO 853
      GO TO 851
C
C     NOW WRITE STRESS ENTRY
C
  858 CALL WRITE (OES1,BUFA(1),NWDSTR,0)
      BUFA(1) = ID
C
C     OUTPUT FORCE RESULTS ON OEF1 (IF REQUESTED)
C
  860 IF (JFORC .EQ. 0  .OR. NWDFOR .EQ. 0) GO TO 880
      IF (KTYPE .EQ. 1) GO TO 870
C
C     COMPLEX FORCES
C
      IOUT = 0
      I    = NPTFOR
  951 NPT  = COMPLX(I)
      IF (NPT) 952,953,954
  952 NPT  = -NPT
      IF (FPHASE .NE. 3) GO TO 954
C
C     COMPUTE MAGNITUDE/PHASE FOR FORCES
C
      CALL MAGPHA (BUFB(NPT),ISAVEF(NPT))
  955 IOUT = IOUT + 1
      ELWORK(IOUT) = BUFB(NPT)
      I    = I + 1
      GO TO 951
  954 IF (NPT .LE. LFORCE) GO TO 955
      NPT  = NPT - LFORCE
      IOUT = IOUT + 1
      ELWORK(IOUT) = ISAVEF(NPT)
      I    = I + 1
      GO TO 951
C
C     TRANSFER RESULTS TO BUFB
C
  953 DO 959 I = 1,IOUT
  959 BUFB(I) = ELWORK(I)
      NWDFOR  = IOUT
C
C     WRITE FORCES
C
C
C     DETERMINE DESTINATION FOR FORCE ENTRY
C
  870 IF (FORCE .EQ. 0) GO TO 880
      IF (.NOT. OK2WRT) GO TO 880
      ID = BUFB(1)
      BUFB(1) = 10*ID + FDEST
      IF (XSETNF) 878,871,872
  871 BUFB(1) = 10*ID
      GO TO 878
  872 IX = IXSETF
  873 IF (IX .EQ. NXSETF) GO TO 874
      IF (Z(IX+1) .GT. 0) GO TO 874
      IF (ID.GE.Z(IX) .AND. ID.LE.(-Z(IX+1))) GO TO 878
      IX = IX + 2
      GO TO 875
  874 IF (ID .EQ. Z(IX)) GO TO 878
      IX = IX + 1
  875 IF (IX .LE. NXSETF) GO TO 873
      GO TO 871
C
C     NOW WRITE FORCE ENTRY
C
  878 CALL WRITE (OEF1,BUFB(1),NWDFOR,0)
      BUFB(1) = ID
  880 GO TO 900
  890 ESTAWD = ESTAWD + NWDSA
  900 IF (AGAIN) GO TO 903
      IF (ISTORE .EQ. 1) GO TO 1626
      IF (KTYPE.NE.1 .OR. (AXIC .AND. MIDVEC.NE.0)) IVEC = ISAVE
      IF (AXIC .AND. MIDVEC.NE.0) SORC = ISVSRC
      IF (.NOT. AXIC) GO TO 905
      IF (NELHAR .NE. NHARMS) GO TO 905
  903 IF (ELTYPE .EQ. 35) CALL SCONE3 (AGAIN)
      IF (ELTYPE .EQ. 70) CALL STRAX3 (AGAIN)
      IF (ELTYPE .EQ. 71) CALL STPAX3 (AGAIN)
      NELHAR = -1
      GO TO 616
  905 IF (NESTA .EQ. 0) GO TO 80
      IF (Z(ESTAWD+1) .NE. 0) GO TO 90
C
C     END OF ESTA FOR CURRENT ELEMENT TYPE
C
  910 IF (.NOT. IDSTRS) GO TO 915
      CALL WRITE (OES1,0,0,1)
  915 IF (.NOT. IDFORC) GO TO 920
      CALL WRITE (OEF1,0,0,1)
  920 IF (.NOT. IDLYST) GO TO 925
      CALL WRITE (OES1L,0,0,1)
  925 IF (.NOT. IDLYFR) GO TO 930
      CALL WRITE (OEF1L,0,0,1)
  930 IF (NESTA .EQ. 0) GO TO 20
  940 ESTAWD = ESTAWD + 2
      IF (ESTAWD .GE. NESTA) GO TO 950
      ELTYPE = Z(ESTAWD)
      GO TO 25
C
C     END OF ESTA FILE HIT
C
  950 CONTINUE
  960 CONTINUE
      IVEC  = ISAVE
      ICORE = JCORE
      RETURN
C
C     INTERNAL SUBROUTINE FOR WRITING ID RECORDS TO OUTPUT FILES
C
  630 DO 635 I = 1,50
  635 BUF(I) = 0
C
C     IF THE ID IS BEING WRITTEN TO A FILE WITH COMPLEX DATA,
C     CHANGE THE NUMBER OF WORDS TO REFLECT THE ACTUAL COUNT
C     OF WORDS BEING PUT TOGETHER USING THE STRING OF NUMBERS
C     IN THE 'COMPLX' ARRAY.  (SEE FORTRAN LABELS 651 THRU 654
C     AND 951 THRU 954)
C
      IF (KTYPE  .EQ. 1) GO TO 645
      IF (JCMPLX .EQ. 0) RETURN 1
      JOUT = 0
      I    = JCMPLX
  638 NCMPLX = COMPLX(I)
      IF (NCMPLX) 640,642,640
  640 JOUT = JOUT + 1
      I    = I + 1
      GO TO 638
  642 NWDS = JOUT
C
C     CHECK FOR VON MISES STRESS REQUEST.  SET WORD 11 IF
C     REQUEST IS FOUND.
C
  645 IF (ANDF(NSTROP,1) .NE. 0) BUF(11) = 1
C
      GO TO (650,660,650,650,670,790,650,660,660,650), BRANCH
C
C     NORMAL STATICS OR DIFF.STIFF. PHASE 0 OR 1 OR BUCKLING PHASE 0.
C
  650 BUF(2) = IFLTYP
      IX     = ICC + ISLOAD
      BUF(5) = Z(ICC+1)
      BUF(6) = 0
      BUF(7) = 0
      BUF(8) = Z(IX)
      IF (BRANCH .NE. 10) GO TO 840
      IX     = ICC + ITTL + 84
      Z(IX)  = PLATIT(1)
      Z(IX+1)= PLATIT(2)
      Z(IX+2)= PLATIT(3)
      CALL INT2AL (UGVVEC-1,Z(IX+3),PLATIT(4))
      GO TO 840
C
C     EIGENVALUES OR BUCKLING PHASE 1.
C
  660 BUF(2) = IFLTYP + KTYPEX
      BUF(5) = Z(JLIST)
      BUF(6) = Z(JLIST+1)
      BUF(7) = Z(JLIST+2)
      BUF(8) = 0
      GO TO 840
C
C     FREQUENCY RESPONSE.
C
  670 IX     = ICC + IDLOAD
      BUF(8) = Z(IX)
      BUF(6) = 0
      BUF(7) = 0
      BUF(2) = IFLTYP + KTYPEX
  671 CONTINUE
C
C     FIRST TIME FOR THIS LOAD VECTOR ONLY - MATCH LIST OF
C
      IF (KFRQ .NE. 0) GO TO 740
C
C     USER REQUESTED FREQS WITH ACTUAL FREQS. MARK FOR
C     OUTPUT EACH ACTUAL FREQ WHICH IS CLOSEST TO USER REQUEST.
C
      KFRQ   = 1
      IX     = ICC + IFROUT
      FSETNO = Z(IX)
      IF (FSETNO .LE. 0) GO TO 690
      IX     = ICC + ILSYM
      ISETNF = IX+Z(IX) + 1
  680 ISETFR = ISETNF + 2
      NSETFR = Z(ISETNF+1) + ISETFR - 1
      IF (Z(ISETNF) .EQ. FSETNO) GO TO 710
      ISETNF = NSETFR + 1
      IF (ISETNF .LT. IVEC) GO TO 680
      FSETNO = -1
  690 DO 700 J = ILIST,NLIST,2
  700 Z(J+1) = 1
      GO TO 740
  710 DO 730 I = ISETFR,NSETFR
      K      = 0
      DIFF   = 1.E25
      BUFR(1)= ZZ(I)
      DO 720 J = ILIST,NLIST,2
      IF (Z(J+1) .NE. 0) GO TO 720
      DIFF1  = ABS(ZZ(J) - BUFR(1))
      IF (DIFF1 .GE. DIFF) GO TO 720
      DIFF = DIFF1
      K    = J
  720 CONTINUE
      IF (K .NE. 0) Z(K+1) = 1
  730 CONTINUE
C
C     DETERMINE IF CURRENT FREQ IS MARKED FOR OUTPUT.
C
  740 IF (Z(JLIST+1) .EQ. 0) GO TO 960
      BUF(5) = Z(JLIST)
      GO TO 840
C
C     TRANSIENT RESPONSE.
C
  790 BUF(5) = Z(JLIST)
      BUF(2) = IFLTYP
      IX     = ICC + IDLOAD
      BUF(8) = Z(IX)
      BUF(6) = 0
      BUF(7) = 0
      GO TO 671
C
C     WRITE ID RECORD ON OUTPUT FILE.
C     (FOR MORE DETAIL, SEE OES1 FILE IN PROGRAMMER MANUAL P.2.3-130)
C
  840 BUF(1) = DEVICE + 10*BRANCH
      BUF(3) = ELTYPE
C
C     CHECK FOR TRIA1, TRIA2, TRIA3, QUAD1, QUAD2, QUAD4  ELEMENTS
C
      IF (ELTYPE.NE. 6 .AND. ELTYPE.NE.17 .AND. ELTYPE.NE.18 .AND.
     1    ELTYPE.NE.19 .AND. ELTYPE.NE.64 .AND. ELTYPE.NE.83)
     2    GO TO 845
C
C     CHECK FOR STRAIN OPTION
C
      IF (BUF(2).EQ.5 .AND. STRAIN) BUF(2) = 21
  845 BUF(4) = Z(ICC+1)
      IF (DDRMM) BUF(4) = 9999
      BUF(9) = IABS(Z(IRECX+2))
      IF (BUF(9).EQ.1 .AND. KTYPE.EQ.2) BUF(9) = 2
      BUF(10) = NWDS
      CALL WRITE (OFILE,BUF(1),50,0)
      IX = ICC + ITTL
      CALL WRITE (OFILE,Z(IX),96,1)
      ILOGIC(NLOGIC) = .TRUE.
      GO TO IRETRN, (365,375)
C
C     ERRORS
C
  980 N = 2
      GO TO 1000
  990 N = 3
      GO TO 1000
 1000 CALL MESAGE (N,FILE,NAM)
      RETURN 1
C
      END

      SUBROUTINE DETGBS (IY,IOBUF,KCOUNT)
C
C     DETGFBS IS A SPECIAL VERSION OF THE DETFBS ROUTINE AND IS USED BY
C     THE REAL DETERMINANT METHOD FOR UNSYMMETRIC DECOMPOSITION.  
C     IT IS SUITABLE FOR BOTH SINGLE AND DOUBLE PRECISION OPERATION.
C
C
C     DEFINITION OF PARAMETERS
C     ------------------------
C
C     FILEU  = MATRIX CONTROL BLOCK FOR THE UPPER TRIANGLE
C     FILEV  = SAME AS FILEU
C     FILEVT = MATRIX CONTROL BLOCK FOR THE TRANSPOSE OF THE UPPER
C              TRIANGLE
C     X, DX  = THE SOLUTION VECTOR
C     Y, DY  = REGION USED FOR UNPACKING
C     IY     = POINTER TO Y (DY) RELATIVE TO X (DX)
C     IOBUF  = THE INPUT BUFFER
C     NROW   = MATRIX SIZE
C     KCOUNT = EIGENVALUE COUNTER
C
      INTEGER          FILEU(7),PARM(4) ,IOBUF(7),OPTION , FC
     1,                SCR3    ,SCR4    ,SCR6    ,EOL  
      REAL             X(1)    ,Y(1)
      DOUBLE PRECISION DX(1)   ,DY(1)   ,DXMIN   ,DSDIAG ,DA(2)
      COMMON /ZZZZZZ/  CORE(1)
      COMMON /DETMX /  DUM3(36),IPDETA
      COMMON /NAMES /  RD      ,RDREW   ,WRT     ,WRTREW  ,REW
      COMMON /REGEAN/  DUM1(23),SCR3    ,SCR4    ,DUM2(11),SCR6
      COMMON /REIGKR/  OPTION
      COMMON /UNPAKX/  ITYPEX  , IUNPAK ,JUNPAK  ,INCR
      COMMON /ZNTPKX/  A(4)    , II     ,EOL
      COMMON /DCOMPX/  FA(7)   , FL(7)  ,FC(7)
      EQUIVALENCE      (CORE(1),X(1),DX(1),Y(1),DY(1))    
     1,                (XMIN,DXMIN) ,   (SDIAG,DSDIAG)
     2,                (A(1),DA(1) )
      DATA    PARM(3), PARM(4) / 4HDETG, 4HFBS  /
C
      FILEU(1) = FC(1)
      CALL RDTRL ( FILEU )
      ITYPEX = FILEU(5)
      NROW   = FILEU(2)
      IOFF   = FILEU(7)-1
      IPREC  = 1
      IF ( ITYPEX .EQ. 2 ) IPREC = 2
      INDEX  = -1
      INCR   = 1
      NFILE  = FILEU(1)
      INDEX  = 1
      LCORE  = IPDETA - IY*ITYPEX - 1
      IF (LCORE .LT. 0) CALL MESAGE (-8,0,PARM(3))
      NFILE  = FILEU(1)
      PARM(2) = NFILE
      CALL GOPEN (NFILE,IOBUF,RDREW)
      XMIN = 1.0E20
      IF (ITYPEX .NE. 1) DXMIN = 1.0D20
      DO 80 I = 1,NROW
      IUNPAK = I
      JUNPAK = I
      IND    = NROW - I + 1 
      IF (ITYPEX .NE. 1) GO TO 70
      CALL UNPACK (*400,NFILE,X(IND))
      IF (XMIN .GT. ABS(X(IND))) XMIN = ABS(X(IND))
      GO TO 80
   70 CALL UNPACK (*400,NFILE,DX(IND))
      IF (DXMIN .GT. DABS(DX(IND))) DXMIN = DABS(DX(IND))
   80 CONTINUE
      IF (ITYPEX.EQ.1 .AND. XMIN .NE.0.0  ) GO TO 120
      IF (ITYPEX.NE.1 .AND. DXMIN.NE.0.0D0) GO TO 120
      XMIN = 1.0E20
      IF (ITYPEX .NE. 1) DXMIN = 1.0D20
      DO 100 I = 1,NROW
      IF (ITYPEX .NE. 1) GO TO 90
      IF (X(I) .EQ. 0.0) GO TO 100
      IF (XMIN .GT. ABS(X(I))) XMIN = ABS(X(I))
      GO TO 100
   90 IF (DX(I) .EQ. 0.0D0) GO TO 100
      IF (DXMIN .GT. DABS(DX(I))) DXMIN = DABS(DX(I))
  100 CONTINUE
      IF (ITYPEX .NE. 1) GO TO 110
      IF (XMIN .GT. 1.0E-8) XMIN = 1.0E-8
      GO TO 120
  110 IF (DXMIN .GT. 1.0D-8) DXMIN = 1.0D-8
C
C     BUILD LOAD VECTOR FOR BACKWARD PASS
C
  120 SDIAG = 1.0
      IF (ITYPEX .NE. 1) DSDIAG = 1.0D0
      DO 160 I = 1,NROW
      ANUM = (-1)**(I*KCOUNT)
      AI   = I
      ADEN = 1.0 + (1.0 - AI/NROW)*KCOUNT
      AVALUE = ANUM/ADEN
      IF (ITYPEX .NE.    1) GO TO 140
  130 X(I) = XMIN*AVALUE/SDIAG
      GO TO 160
  140 DX(I) = DXMIN*AVALUE/DSDIAG
  160 CONTINUE
C
C     BEGIN BACKWARD PASS
C
      CALL REWIND ( FILEU )
      CALL SKPREC ( FILEU, 1 )
      J = NROW
  390 CALL INTPK (*650,FILEU(1),0,IPREC,0)
      IF (EOL) 650,410,650
  410 CALL ZNTPKI
      I = NROW - II + 1
      IF (I .NE. J) GO TO 510
C
C     DIVIDE BY THE DIAGONAL
C
      IN1 = I
      K   = 0
  420 GO TO (430,440), IPREC
  430 CONTINUE
      IF ( A(1) .GE. 0.0 .AND. ABS( A(1)) .LT. XMIN ) A(1) =  XMIN 
      IF ( A(1) .LT. 0.0 .AND. ABS( A(1)) .LT. XMIN ) A(1) = -XMIN 
      X(IN1) = X(IN1)/A(1)      
      GO TO 470
  440 CONTINUE
      IF ( DA(1) .GE. 0.0D0 .AND. DABS(DA(1)).LT. DXMIN) DA(1) =  DXMIN   
      IF ( DA(1) .LT. 0.0D0 .AND. DABS(DA(1)).LT. DXMIN) DA(1) = -DXMIN   
      DX(IN1) = DX(IN1)/DA(1) 
  470 GO TO 490
C
C     SUBTRACT OFF REMAINING TERMS
C
  480 IF (I .GT. J) GO TO 410
  490 IF (EOL) 590,500,590
  500 CALL ZNTPKI
      I   = NROW - II + 1
  510 IN1 = I
      IN2 = J
      IF (I .LT. J) GO TO 530
      K   = IN1
      IN1 = IN2 - IOFF
      IN2 = K
  530 GO TO (540,550), IPREC
  540 X(IN1) = X(IN1) - A(1)*X(IN2)
      GO TO 580
  550 DX(IN1) = DX(IN1) - DX(IN2)*DA(1)
  580 IN1 = IN1 + NROW
      IN2 = IN2 + NROW
      GO TO 480
  590 J = J - 1
      IF (J .GT. 0) GO TO 390
C END OF BACKWARD SUBSTITUTION, NEGATE TERMS AND RETURN
      GO TO (600,620), IPREC
  600 DO 610 K = 1, NROW
      X(K)  = -X(K)
  610 CONTINUE 
      GO TO 700
  620 DO 630 K = 1, NROW
      DX(K) = -DX(K)
  630 CONTINUE
  700 CONTINUE
      CALL CLOSE ( FILEU, REW )
      RETURN
C
C     ATTEMPT TO OPERATE ON SINGULAR MATRIX
C
  400 PARM(1) = -5
      CALL MESAGE (PARM(1),PARM(2),PARM(3))
  650 CALL MESAGE ( -5    ,PARM(2),PARM(3))
      RETURN
      END

      SUBROUTINE RAND5 (NFREQ,NPSDL,NTAU,XYCB,LTAB,IFILE,PSDF,AUTO,
     1                  NFILE)
C
C     THIS ROUTINE COMPUTES RANDOM RESPONSE FOR UNCOUPLED POWER SPECTRAL
C     DENSITY COEFFICIENTS
C
      INTEGER IZ(1),SYSBUF,FILE,XYCB,PSDF,AUTO,IFILE(1),NAME(2),
     1        MCB1(7),MCB2(7),OLDLD
      REAL    Q(2),DATA(100)
C
      COMMON /SYSTEM/ SYSBUF
      COMMON /ZZZZZZ/ Z(1)
C
      EQUIVALENCE  (Z(1),IZ(1))
C
      DATA    NAME,MCB1,MCB2 /4HRAND,4H5   ,14*0/
      DATA    IPSDF,IAUTO    /  4001,4002       /
C *****
C     DEFINITION OF VARIABLES
C *****
C     NFREQ    NUMBER OF FREQUENCIES
C     NPSDL    NUMBER OF SUBCASES ON PSDL CARDS
C     NTAU     NUMBER OF TIMES
C     XYCB     DATA BLOCK CONTAINING XY USER REQUESTS
C     LTAB     LENGTH OF CORE  USED FOR TABLES BY PRETAB
C     IFILE    ARRY CONTAINING FILE NAMES FOR SORT 2 INPUT FILES
C     PSDF     OUTPUT FILE FOR POWER SPECTRAL DENSITY FUNCTIONS
C     AUTO     OUTPUT FILE FOR AUTOCORRELATION FUNCTIONS
C     NFILE    LENGTH OF IFILE ARRAY
C     MCB1     TRAILER FOR PSDF
C     MCB2     TRAILER FOR AUTO
C     IPSDF    OFP ID FOR  PSDF
C     IAUTO    OFP ID FOR  AUTO
C     LCORE    AVAIABLE CORE FOR ANY LIST
C     IBUF1    BUFFER POINTERS
C     IBUF2
C     IBUF3
C     ITAU     POINTER TO FIRST TAU -1
C     ISAA     POINTER TO FIRST S(AA) -1
C     TAU      TIMES FOR AUTTOCORRELATION
C     SAA      POWER SPECTRAL DENSITY FACTORS
C     ICORE    POINTER  TO FIRST REQUEST -1
C     SYSBUF   LENGTH OF ONE BUFFER
C     NPOINT   NUMBER OF REQUESTS
C     NZ       CORE AVAILABLE FOR STORING PSDF-S
C     IP       POINTER TO FIRST POINT OF CURRENT CORE LOAD
C     NDONE    NUMBER OF REQUESTS PROCESSED
C     OLDLD    LOAD ID OF OLD LOAD SET
C     NDO      NUMBER POSSIBLE TO DO IN CORE
C     ICS      POINTER TO FIRST PSDF VECTOR
C     NLOAD    NUMBER OF PSDL CARDS PROCESSED
C     ICDONE   NUMBER CURRENTLY DONE-- SEVERAL COMP FROM EACH VALUE
C     LOAD     SUBCASE ID FROM INPUT RECORD
C     IF       FORMAT FLAG  IF =0  DATA IS REA/IMAG IF.NE.0 MAG/PHASE
C     LEN      LENGTH OF DATA RECORD
C     Q        MEAN RESPONSE
C     R        AUTO CORRALATION FUNCTION AT TIME TAU
C     IP1      LOCAL POINT POINTER
C
C
C *****
C     CORE LAYOUT DURING EXECUTION
C *****
C     FREQUENCIES   NFREQ OF THEM
C     RANDPS DATA   NPSDL OF THEM  5 WORDS PER CARD
C                   LOAD ID   LOAD ID   X    Y=0. TABLE
C     TAUS          NTAU OF THEM
C     TABLE DATA    LTAB OF IT
C     S(AA)         NFREQ OF THEM  THESE ARE  REEVALUATED WHEN LOAD CHAG
C     REQUESTS      NPOINT OF THEM 5 WORDS PER REQUEST
C                   D.B. ID   COMP O.P. P/P
C     S(J,A)        NO  DO OF THEM      LENGTH = NFREQ
C
C
C     BUFFERS       3 NEEDED
C
C
C     INITALIZE GENERAL VARIABLES, ASSIGN BUFFERS  ETC
C
      MCB1(1) = PSDF
      MCB2(1) = AUTO
      LCORE = KORSZ(Z)
      IBUF1 = LCORE -SYSBUF+1
      IBUF2 = IBUF1 -SYSBUF
      IBUF3 = IBUF2 -SYSBUF
      ITAU  = NFREQ +5*NPSDL
      ISAA  = NTAU  +LTAB+ITAU
      ICORE = ISAA  +NFREQ
      LCORE = LCORE -ICORE-3*SYSBUF
      ICRQ  =-LCORE
      IF (LCORE .LE. 0) GO TO 980
C
C     OPEN OUTPUT FILES
C
      CALL GOPEN (PSDF,Z(IBUF2),1)
      CALL GOPEN (AUTO,Z(IBUF3),1)
C
C     BEGIN LOOP ON EACH FILE
C
      DO 1000 I = 1,NFILE
C
C     BUILD POINT LIST FOR FILE(I)
C
      CALL RAND6 (XYCB,Z(IBUF1),NPOINT,IZ(ICORE+1),IFILE(I),LCORE)
      IF (NPOINT .EQ. 0) GO TO 1000
      NZ   = LCORE -5*NPOINT
      ICRQ =-NZ
      IF (NZ .LE. 0) GO TO 980
C
C     OPEN INPUT FILE
C
      FILE  = IFILE(I)
      CALL OPEN (*1000,FILE,Z(IBUF1),0)
      IP    = ICORE +1
      NDONE = 0
      OLDLD = 0
      ICS   = ICORE +5*NPOINT +1
      LLIST = 5*NPOINT
      IPS   = IP
      LLISTS= LLIST
   13 NDO   = MIN0(NPOINT-NDONE,NZ/NFREQ)
      ICRQ  = MAX0(NPOINT-NDONE,NFREQ)
      IF (NDO .EQ. 0) GO TO 980
      NLOAD = 0
C
C     ZERO CORE
C
      JJ = ICS + NDO*NFREQ-1
      DO 16 K = ICS,JJ
      Z(K) = 0.0
   16 CONTINUE
      ICDONE = 0
C
C     GET READY TO OBTAIN FIRST VALUE
C
   15 CALL RAND2 (IFILE(I),IZ(IP),LOAD,IF,LEN,LLIST)
C
C     CHECK FOR NEW LOAD
C
      IF (LOAD .EQ. 0) IF (NLOAD-NPSDL) 111,100,111
      IF (LOAD .EQ. OLDLD) GO TO 50
C
C     NEW LOAD --EVALUATE S(AA) FUNCTIONS FOR THIS LOAD
C
      J  = NFREQ +1
      JJ = ITAU
      DO 10 K = J,JJ,5
      IF (IZ(K) .EQ. LOAD) GO TO 20
   10 CONTINUE
C
C     LOAD NOT NEEDED --REJECT
C
      GO TO 15
C
C     GOOD LOAD --EVALUATE
C
   20 OLDLD = LOAD
      NLOAD = NLOAD +1
      DO 30 J = 1,NFREQ
      JJ = ISAA +J
C
C                TAB      X    F(X)
      CALL TAB (IZ(K+4),Z(J),Z(JJ))
      IF (IZ(K+4) .EQ. 0) Z(JJ) = 1.0
      Z(JJ) = Z(JJ)*Z(K+2)
   30 CONTINUE
C
C     BRING IN DATA
C
   50 IF (LEN .GT. 100) GO TO 970
      DO 60 J = 1,NFREQ
C
C     ACCESS DATA FROM FILE INTO DATA ARRAY
C
      CALL RAND2A (DATA(1))
      IP1 = IP
      II  = ICDONE
      LL  = ISAA +J
C
C     COMPUTE  MAGNITUDE         OF CURRENT COMPONENT
C
   52 IF ((LEN-2)/2 .GE. IZ(IP1+2)) GO TO 53
C
C     REQUEST OUT OF RANGE
C
      CALL MESAGE (52,IZ(IP1),IZ(IP1+1))
      IZ(IP1+2) = (LEN-2)/2
   53 JJ = IZ(IP1+2) +2
      IF (IF .NE. 0) GO TO 51
C
C     REAL + IMAGINARY
C
      K  = JJ + LEN/2 -1
      DATA(JJ) = SQRT(DATA(JJ)*DATA(JJ) + DATA(K)*DATA(K))
C
C     COMPUTE POWER SPECTRAL DENSITY FUNCTION
C
   51 K = ICS + II*NFREQ-1 +J
      Z(K) = Z(K) + DATA(JJ)*Z(LL)*DATA(JJ)
      IF (II .EQ. NDO-1) GO TO 60
C
C     IS NEXT REQUEST FROM SAME POINT
C
      IF (IZ(IP1).NE.IZ(IP1+5) .OR. IZ(IP1+1).NE.IZ(IP1+6)) GO TO 60
      II = II +1
      IP1= IP1+ 5
      GO TO 52
   60 CONTINUE
      LLIST  = LLIST - 5*(II-ICDONE+1)
      ICDONE = II +1
      IP = IP1 +5
C     HAVE I DONE ALL REQUEST(IN CURRENT CORE)
C
      IF (ICDONE .NE. NDO) GO TO 15
C
C     HAVE I ADDED IN ALL LOADS
C
      IP = IPS
      IF (NLOAD .EQ. NPSDL) GO TO 100
C
C     START AGAIN ON NEXT LOAD
C
      LLIST  = LLISTS
      ICDONE =  0
      GO TO 15
C
C     ALL LOADS FOR CURRENT BUNCH DONE
C
  100 JJ = IP
      J  = NDO* 5 +JJ-1
      L  = ICS - NFREQ
      DO 110 K = JJ,J,5
      L = L+ NFREQ
C
C     COMPUTE MEAN RESPONSE   Q
C
      CALL RAND3 (Z(1),Z(L),Q,NFREQ)
      IF (IZ(K+3) .EQ. 2) GO TO 105
C
C     PSDF REQUESTED
C
C     PUT OUT ID RECORD
C
      MCB1(7) = MCB1(7) +1
      CALL RAND1 (PSDF,IPSDF,IZ(K),IZ(K+1),IZ(K+4),Q)
C
C     PUT OUT DATA RECORD
C
      DO 101 LL = 1,NFREQ
      KK = L +LL -1
      CALL WRITE (PSDF,Z(LL),1,0)
      CALL WRITE (PSDF,Z(KK),1,0)
  101 CONTINUE
      CALL WRITE (PSDF,0,0,1)
  105 IF (IZ(K+3) .EQ. 1) GO TO 110
C
C     AUTOCORRELATION REQUESTED
C
      IF (NTAU .EQ. 0) GO TO 110
      CALL RAND1 (AUTO,IAUTO,IZ(K),IZ(K+1),IZ(K+4),Q)
      MCB2(7) = MCB2(7)+1
C
C     PUT OUT DATA RECORD
C
      DO 106 LL = 1,NTAU
      KK = ITAU + LL
      CALL WRITE (AUTO,Z(KK),1,0)
C
C     COMPUTE AUTO
C
      CALL RAND4 (Z(1),Z(L),Z(KK),R,NFREQ)
      CALL WRITE (AUTO,R,1,0)
  106 CONTINUE
      CALL WRITE (AUTO,0,0,1)
  110 CONTINUE
      CALL REWIND (IFILE(I))
      NDONE = NDONE +NDO
      IF (NDONE .NE. NPOINT) GO TO 200
  111 CALL CLOSE (IFILE(I),1)
      GO TO 1000
C
C     SPILL ON POINT LISTS --GO AGAIN
C
  200 OLDLD = 0
      IP  = IP + 5*NDO
      IPS = IP
      LLISTS = LLISTS-5*NDO
      GO TO 13
 1000 CONTINUE
C
C     ALL STUFF DONE --GET OUT
C
      CALL CLOSE (PSDF,1)
      CALL CLOSE (AUTO,1)
      CALL WRTTRL (MCB1)
      CALL WRTTRL (MCB2)
      RETURN
C
C     FILE + MISC ERRORS
C
  901 CALL MESAGE (IP1,FILE,NAME)
      RETURN
  970 IP1 = -7
      GO TO 901
  980 IP1 = -8
      FILE= ICRQ
      GO TO 901
      END

      SUBROUTINE CDIVID(A,B,D,NCOL)
      DOUBLE PRECISION A(1),B(1),D(2),DTEMP,DENM
C
C     THIS ROUTINE DIVIDES THE VECTOR A BY D AND STORE RESULT IN B
C
      DENM = D(1)**2 + D(2)**2
      DO 10 I = 1,NCOL,2
      DTEMP = (A(I)*D(1) +A(I+1)*D(2))/DENM
      B(I+1) = (A(I+1)*D(1) -A(I) * D(2))/DENM
      B(I) = DTEMP
   10 CONTINUE
      RETURN
      END

      SUBROUTINE DETM3 (*,*,*)
C
C     RMAX   = APPROXIMATE MAGNITUDE OF LARGEST EIGENVALUE OF INTEREST
C     RMIN   = LOWEST  NON-ZERO  EIGENVALUE
C     MZ     = NUMBER OF ZERO EIGENVALUES
C     NEV    = NUMBER OF NON-ZERO EIGENVALUES IN RANGE OF INTEREST
C     EPSI   = CONVERGENCE CRITERION
C
C     NEVM   = MAXIMUM NUMBER OF EIGENVALUES DESIRED
C     IS     = STARTING SET COUNTER
C     IC     = COUNTER FOR CHANGE OF CONVERGENCE CRITERIA
C     NFOUND = THE NUMBER OF EIGENVALUES FOUND TO DATA
C     IM     = MASS MATRIX CONTROL BLOCK
C     IK     = K MATRIX CONTROL BLOCK
C     IEV    = EIGENVECTOR CONTROL BLOCK
C
C     A      = M + P*K
C
      INTEGER          PREC,U2,SCR1,SCR2,SCR3,SCR4,SCR5,SCR6,SCR7
      DOUBLE PRECISION P,DETX,PS1,DET1,PSAVE(1),DET(1),PS(1),AA,HK1,HK,
     1                 LAMDAK,DELTAK,GK,ROOT,ROOT1,LAMDK1,A,XLAMSV,PTRY,
     2                 DETRY,SRP,H1,H2,H3,GK1,HKP1,T1,T2,DIST,DSAVE,
     3                 TEMP2
      DIMENSION        IPDET(1)
      COMMON /DETMX /  P(4),DETX(4),PS1(4),DET1(4),N2EV,IPSAV,IPS,IDET,
     1                 IPDETA,PREC,NSTART,U2,IC,L1,L2,IS,ND,IADD,SML1,
     2                 IPDETX(4),IPDET1(4),IFAIL,K,FACT1,IFFND,NFAIL,
     3                 NPOLE
      COMMON /REGEAN/  IM(7),IK(7),IEV(7),SCR1,SCR2,SCR3,SCR4,SCR5,
     1                 LCORE,RMAX,RMIN,MZ,NEV,EPSI,RMINR,NE,NIT,NEVM,
     2                 SCR6,SCR7,NFOUND,LAMA
      COMMON /ZZZZZZ/  PSAVE
      EQUIVALENCE      (PSAVE(1),PS(1),DET(1),IPDET(1))
C
      CALL ARRM (PS1,DET1,IPDET1)
      AA = PS1(3) - PS1(2)
      DSAVE = 1.0E38
C
C     COPY INTO INTERATION BLOCK
C
      DO 30 N = 1,3
      DETX(N) = DET1(N)
      P(N) = PS1(N)
   30 IPDETX(N) = IPDET1(N)
C
C     START INTERATION LOOP
C
      K     = 1
      IGOTO = 1
   40 HK1   = P(2) - P(1)
      HK    = P(3) - P(2)
      LAMDAK= HK/HK1
      IF (DABS(HK) .LE. DABS(EPSI*100.0*P(3))) GO TO 240
C
C     CHECK FOR EARLY CONVERGENCE
C
      DELTAK = 1.0D0 + LAMDAK
C
C     COMPUTE  GK
C
      CALL SUMM (T1,IT1,DETX(1)*LAMDAK*LAMDAK,IPDETX,DETX(2)*DELTAK*
     1           DELTAK,IPDETX(2),-1)
      CALL SUMM (GK,IGK,T1,IT1,DETX(3)*(LAMDAK+DELTAK),IPDETX(3),1)
C
C     COMPUTE ROOT1
C
      CALL SUMM (T1,IT1,DETX(1)*LAMDAK,IPDETX(1),DETX(2)*DELTAK,
     1           IPDETX(2),-1)
      CALL SUMM (T2,IT2,T1,IT1,DETX(3),IPDETX(3),1)
      CALL SUMM (ROOT1,IROOT1,GK*GK,2*IGK,-4.0*DELTAK*LAMDAK*DETX(3)*T2,
     1           IPDETX(3)+IT2,1)
C
C     COMPUTE ROOT = DSQRT (ROOT1)
C
      CALL SQRTM (ROOT,IROOT,ROOT1,IROOT1)
      A   = -2.0*DETX(3)*DELTAK
      GK1 = GK
      DO 90 N = 1,2
      IF (ROOT1 .LT. 0.0) GO TO 50
      TEMP2 = ROOT
      IF (GK1 .NE. 0.0D0) TEMP2 = DSIGN(ROOT,GK1)
C
      CALL SUMM (T1,IT1,GK,IGK,TEMP2,IROOT,1)
C
      LAMDK1 = A/T1
      ILMK   = IPDETX(3) - IT1
      LAMDK1 = LAMDK1*10.0**ILMK
      GO TO 60
C
C     T1= GK*GK + DABS(ROOT1)
C
   50 CALL SUMM (T1,IT1,GK*GK,IGK+IGK,DABS(ROOT1),IROOT1,1)
      LAMDK1 = A*GK/T1
      ILMK   = IPDETX(3) + IGK - IT1
      LAMDK1 = LAMDK1*10.0**ILMK
      GO TO 100
   60 IF (K .NE. 1) GO TO 100
C
C     IF (K .EQ. 1) RECALC LK1 TO MINIMIZE DIST
C
      DIST = 0.0D0
      DO 70 I = 1,3
      DIST = DABS(PS1(I)-PS1(3)-LAMDK1*AA) + DIST
   70 CONTINUE
      IF (DIST .GE. DSAVE) GO TO 80
      DSAVE  = DIST
      XLAMSV = LAMDK1
   80 GK1 = -GK1
   90 CONTINUE
      LAMDK1 = XLAMSV
  100 HKP1 = LAMDK1*HK
      PTRY = P(3) + HKP1
C
C     RANGE CHECKS
C
      IF (PTRY .GT. RMAX) GO TO 120
      IF (IS .EQ. N2EV-1) GO TO 110
      NNP = IS + IPS
      IF (PTRY .GT. 0.45*PS(NNP+2)+0.55*PS(NNP+3)) GO TO 120
  110 IF (PTRY .LT. RMINR) GO TO 111
      GO TO 140
C
C     INCREASE POLE  AT LOWEST  E. V. GEOMETRICALLY
C
  111 NPOLE1 = NPOLE + 1
      NPOLE  = 2*NPOLE + 1
C
C     SWEEP PREVIOUSLY EVALUATED STARTING POINTS BY POLES
C
      N2EV2 = ND + IADD
      DO 113 N = 1,N2EV2
      NND   = N + IDET
      NNP   = N + IPS
      NNI   = N + IPDETA
      PTRY  = 1.0D0
      IPTRY = 0
      DO 112 I = 1,NPOLE1
      PTRY = PTRY*(PS(NNP)-RMINR)
      CALL DETM6 (PTRY,IPTRY)
  112 CONTINUE
      DET(NND)   = DET(NND)/PTRY
      IPDET(NNI) = IPDET(NNI) - IPTRY
      CALL DETM6 (DET(NND),IPDET(NNI))
  113 CONTINUE
      GO TO 120
C
C     NEW STARTING SET
C
  120 IFAIL = 0
  119 IS    = IS + 1
      IF (IS  .GE. N2EV) GO TO 130
      IF (NSTART .EQ. 0) IADD = IADD + 1
      RETURN 1
C
C      LOOK AT OLD STARTING SETS AGAIN
C
  130 IF (IFFND .NE. 1) RETURN 2
      IFFND  = 0
      IS     = 1
      NSTART = NSTART + 1
      RETURN 1
C
C     TRY FOR CONVERGENCE
C
  140 CALL TMTOGO (IPTRY)
      IF (IPTRY .LE. 0) RETURN 3
      CALL EADD (-PTRY,PREC)
      CALL DETDET (DETRY,IPTRY,PTRY,SML1,DETX(3),IPDETX(3))
      IF (DETRY .NE. 0.0D0) GO TO 145
      IGOTO = 2
      GO TO 180
C
C     BEGIN CONVERGENCE TESTS
C
  145 IF (K .LE. 2) GO TO 170
      SRP = DSQRT(DABS(P(3)))
      H1  = DABS(HK1)/SRP
      H2  = DABS(HK)/SRP
      H3  = DABS(HKP1)/SRP
  150 FACT1 = EPSI*SQRT(RMAX)
      IF (H1 .GT. 2.E7*FACT1) GO TO 200
      IF (H2 .GT. 2.E4*FACT1) GO TO 200
      IF (H3 .GT. H2) GO TO 160
      IF (H3 .GT. 2.*FACT1) GO TO 200
      IGOTO = 2
      GO TO 180
  160 IF (H2 .GT. 20.*FACT1) GO TO 200
      IGOTO = 2
      GO TO 180
C
C     INTERATE AGAIN
C
  170 K = K + 1
  180 DO 190 I = 1,2
      P(I) = P(I+1)
      IPDETX(I) = IPDETX(I+1)
  190 DETX(I)   = DETX(I+1)
      IPDETX(3) = IPTRY
      DETX(3)   = DETRY
      P(3) = PTRY
      GO TO (40,240), IGOTO
C
C     FAIL TEST
C
  200 K = K + 1
      IF (K-NIT) 180,210,220
  210 IF (IFAIL.EQ.1 .AND. IC.LT.NE) GO TO 230
  220 IFAIL = 1
      NFAIL = NFAIL + 1
      GO TO 119
  230 EPSI = 10.0*EPSI
      IC = IC + 1
      GO TO 150
C
C     ACCEPT PK
C
  240 IFFND = 1
      RETURN
      END

      SUBROUTINE EGNVCT (C1,C2,EIGEN,C3,N1,N2,N)
C
C     SUBROUTINE TO OBTAIN EIGENVECTOR FROM REAL NON-SYMMETRIC
C     MATRICES FOR WHICH THE EIGENVALUE IS KNOWN.  THE METHOD
C     USED IS THE DIRECT METHOD OUTLINED IN ERR-FW-   BY DR.
C     A. M. CUNNINGHAM.
C
      INTEGER N1(N),N2(N)
      COMPLEX C1(N,N),C2(N),C3(N),EIGEN,D1,D2,D3,D4,D5,D6,D8
C
      II3 = N
      II2 = N - 1
      X1  = 0.0
      DO 20 J = 1,N
      N1(J) = J
      N2(J) = J
      C1(J,J) = C1(J,J) - EIGEN
      DO 10 I = 1,N
      X2 = CABS(C1(I,J))
      IF (X1-X2) 5,10,10
    5 X1 = X2
      I1 = I
      J1 = J
   10 CONTINUE
   20 CONTINUE
      DO 150 K6 = 2,N
      IF (CABS(C1(I1,J1))) 50,30,50
   30 K5 = K6 - 1
C
C     SINGULAR MATRIX RETURN ZERO
C
      DO 36 I = 1,N
   36 C3(I) = 0.0
      GO TO 250
C
   50 D1 = (1.0,0.0)/C1(I1,J1)
      D2 = C1(I1,II3)
      D3 = C1(II3,J1)
      D4 = C1(II3,II3)
      DO 60 I = 1,II2
      C3(I    ) = C1(I,J1)
      C1(I,J1 ) = C1(I,II3)
      C1(I,II3) =-C3(I)*D1
      D5 = -C1(I1,I)*D1
      C1(I1 ,I) = C1(II3,I)
      C1(II3,I) = D5
   60 CONTINUE
      C3(I1) = D3
      C1(I1  ,J1) = D4
      C1(II3 ,J1) =-D2*D1
      C1(I1 ,II3) =-D3*D1
      C1(II3,II3) = D1
      IF (II3 .EQ. N) GO TO 80
      II4 = II3 + 1
      DO 70 I = II4,N
      D6 = C1(I1,I)
      C1(I1 ,I) = C1(II3,I)
      C1(II3,I) = D6
      C3(I    ) = C1(I,J1)
      C1(I,J1 ) = C1(I,II3)
   70 C1(I,II3) = C3(I)
   80 I = N1(J1)
      N1(J1 ) = N1(II3)
      N1(II3) = I
      I = N2(I1)
      N2(I1 ) = N2(II3)
      N2(II3) = I
      X1 = 0.0
      DO 140 J = 1,II2
      D8 = C1(II3,J)
      DO 130 I = 1,II2
      C1(I,J) = C1(I,J) + C3(I)*D8
      X2 = CABS(C1(I,J))
      IF(X1-X2) 120,130,130
  120 X1 = X2
      I1 = I
      J1 = J
  130 CONTINUE
  140 CONTINUE
      II3 = II3 - 1
      II2 = II2 - 1
  150 CONTINUE
C
      C3(2) = C1(2,1)
      C3(1) = (1.0,0.0)
      DO 180 J = 3,N
      C3(J) = (0.0,0.0)
      J1 = J - 1
      DO 170 I = 1,J1
      C3(J) = C3(J) + C3(I)*C1(J,I)
  170 CONTINUE
  180 CONTINUE
      IF (CABS(C1(1,1)) .LT. 1.0E-20) GO TO 202
      DO 201 K6 = 1,2
C
      DO 184 J = 1,N
      I1 = N2(J)
      DO 182 I = 1,N
      IF (I1 .EQ. N1(I)) GO TO 184
  182 CONTINUE
  184 C2(J) = C3(I)
C
      DO 190 J = 2,N
      I1 = N - J + 1
      J1 = I1 + 1
      DO 185 I = 1,I1
      C2(I) = C2(I) + C1(I,J1)*C2(J1)
  185 CONTINUE
  190 CONTINUE
      D1 = C1(1,1)/C2(1)
      C3(1) = (1.0,0.0)
      DO 200 J = 2,N
      I1 = J - 1
      C3(J) = C2(J)*C1(J,J)*D1
      DO 195 I = 1,I1
      C3(J) = C3(J) + C1(J,I)*C3(I)
  195 CONTINUE
  200 CONTINUE
  201 CONTINUE
C
C     C3(I) NOW CONTAINS THE EIGENVECTOR WHICH MUST BE RE-ARRANGED
C     ACCORDING TO THE ORDER DICTATED BY N1(I) BACK TO THE ORIGINAL
C     ORDER.
C
  202 DO 230 I = 1,N
      I1 = N1(I)
      N1(I) = I
  205 IF (I1-I) 210,230,210
  210 D1 = C3(I1)
      C3(I1) = C3(I)
      C3(I ) = D1
      K = N1(I1)
      N1(I1) = I1
      I1 = K
      GO TO 205
  230 CONTINUE
      N1(1) = 2
C
  250 RETURN
      END

      SUBROUTINE MSLOT(ITYPE)
C*****
C     THIS ROUTINE CALCULATES THE MASS MATRIX TERMS FOR THE
C         CSLOT3 AND CSLOT4 TWO DIMENSIONAL LAPLACE ELEMENTS
C                  IOPT-  CSLOT3 = 0,  CSLOT4 = 1
C*****
C     THE ECPT DATA FOR THESE ELEMENTS ARE
C
C     FIELD   CSLOT3                CSLOT4
C       1       ID                  ID
C       2       SIL1                SIL1
C       3       SIL2                SIL2
C       4       SIL3                SIL3
C       5       RHO                 SIL4
C       6       BULK                RHO
C       7       M                   BULK
C       8       N                   M
C       9       CID1                N
C       10      R1                  CID1
C      11       Z1                  R1
C      12       W1                  Z1
C      13       CID2                W1
C      14       R2                  CID2
C      15       Z2                  R2
C      16       W2                  Z2
C      17       CID3                W2
C      18       R3                  CID3
C      19       Z3                  R3
C      20       W3                  Z3
C      21       TEMP                W3
C      22                           CID4
C      23                           R4
C      24                           Z4
C***** 25                           W4
C***** 26                           TEMP
C
      INTEGER NECPT(100)
      DOUBLE PRECISION   COEF          ,A2            ,WB
     1                  ,R             ,Z             ,W
     2                  ,MIJ
C*****
      COMMON  /SMA2CL/  IOPT4,K4GGSW,NPVT
      COMMON  /SMA2ET/  ECPT(100)
      COMMON  /SMA2IO/  DUM1(10),IFILE
      COMMON/SMA2DP/     COEF          ,A2            ,WB
     1                  ,R(3)          ,Z(3)          ,W(3)
     2                  ,MIJ           ,IRET          ,IP
     3                  ,K
C*****
      EQUIVALENCE  (ECPT(1),NECPT(1))
C*****
      IF(ITYPE .GT. 0) GO TO 50
      IF(ECPT(6) .EQ.0.0.OR.NECPT(7) .EQ. 0 ) RETURN
      K=-1
   10 K=K+1
      IF(2*NECPT(8) - K*NECPT(7)  ) 30,20,10
   20 NECPT(7) = NECPT(7)*2
   30 ECPT(7) = FLOAT(NECPT(7))/2.0
      DO 40 I=1,20
   40 ECPT(I+50)= ECPT(I)
      IRET =4
      GO TO 140
C*****
C     THE CSLOT4 ELEMENT IS CHECKED FOR VALIDITY AND THE DATA ARE
C     REARRANGED TO CONFORM TO THE CSLOT3 FORMAT
C*****
   50 IF(ECPT(7).EQ.0.0 .OR.NECPT(8).EQ.0 ) RETURN
      K =-1
   60 K =K+1
      IF( 2*NECPT(9) - K*NECPT(8) ) 80,70,60
   70 NECPT(8) =NECPT(8)*2
   80 ECPT(8) = FLOAT(NECPT(8))/2.0
      DO 90 I=1,4
   90  ECPT(I+50) = ECPT(I)
      DO 100 I=6,21
  100  ECPT(I+49) = ECPT(I)
       ECPT(56) = ECPT(7)*2.0
      IRET =1
      GO TO 140
  110 ECPT(54)= ECPT(5)
      ECPT(68) = ECPT(23)
      ECPT(69) = ECPT(24)
      ECPT(70) = ECPT(25)
      IRET =2
      GO TO 140
  120 ECPT(53)= ECPT(4)
      ECPT(64)= ECPT(19)
      ECPT(65)= ECPT(20)
      ECPT(66)= ECPT(21)
      IRET =3
      GO TO 140
  130 ECPT(52)= ECPT(3)
      ECPT(60)= ECPT(15)
      ECPT(61)= ECPT(16)
      ECPT(62)= ECPT(17)
      IRET =4
C*****
C     EACH CSLOT3 ELEMENT OR SUBELEMENT IS FORMULATED AS FOLLOWS
C*****
  140 IF((NECPT(52).NE.NPVT).AND.(NECPT(53).NE.NPVT).AND.
     1   (NECPT(54).NE.NPVT)) GO TO 170
      DO 150 I=1,3
      IP = 4*(I-1)+60
      R(I) =ECPT(IP)
      Z(I) =ECPT(IP+1)
      W(I) =ECPT(IP+2)
      IF(NPVT .EQ. NECPT(I+51)) IPVT=I
  150 CONTINUE
      A2 = (R(2)-R(1))*(Z(3)-Z(1))  -(R(3)-R(1))*(Z(2)-Z(1))
      WB = W(1) +W(2) +W(3)+W(IPVT)
      COEF = DABS(A2)*ECPT(57) /(120.0D0 *ECPT(56))
      I=NPVT
      DO 160 J=1,3
      K = NECPT(J+51)
      MIJ = COEF *( WB + W(J) )
      IF (IPVT .EQ. J) MIJ =MIJ*2.0D0
      CALL SMA2B(MIJ,K,I,IFILE,0.0D0)
  160 CONTINUE
  170 GO TO (110,120,130,180),IRET
  180 RETURN
      END

      SUBROUTINE SQDM12
C
C      PHASE TWO STRESS DATA RECOVERY QUADRILATERAL MEMBRANE
C
C      ELEMENT ID
C      4 SILS
C      T SUB 0
C      S SUB T 3X1
C      4 S ARRAYS EACH 3X3
C
C
C     STRES(1) - PH1OUT(1)
C     STRES(2) - SIGMA X
C     STRES(3) - SIGMA Y
C     STRES(4) - SIGMA XY
C     STRES(5) - PHI 1 ANGLE OF PRINCIPAL DIRECTION OF STRESS
C     STRES(6) - SIGMA 1
C     STRES(7) - SIGMA 2
C     STRES(8) - TAU MAXIMUM SHEAR STRESS
C
      DIMENSION NSIL(4),S(36),ST(3),FRLAST(2),PH1OUT(45)
      INTEGER EJECT,ISHED(7),ISTYP(2)
C
      COMMON   /SYSTEM/  IBFSZ    ,NOUT     ,IDM(9)   ,LINE
      COMMON   /ZZZZZZ/ Z(1)
      COMMON   /SDR2X4/ DUMMY(35),IVEC,IVECN,LDTEMP,DEFORM
      COMMON   /SDR2X7/ EST(100),STRES(100),FORVEC(25)
      COMMON   /SDR2X8/ STRESS(3),VEC(3),TEM,TEMP,NPOINT,DELTA,NSIZE,
     1      CSTRS(4),CVC(3)
      COMMON /SDR2X9/ NCHK,ISUB,ILD,FRTMEI(2),TWOTOP,FNCHK
C
      EQUIVALENCE (PH1OUT(1),EST(1)) , (NSIL(1),PH1OUT(2)) ,
     1 (TSUB0,PH1OUT(6)) , (ST(1),PH1OUT(7)) , (S(1),PH1OUT(10))
     2, (FTEMP,LDTEMP) , (ISHED(1),LSUB) , (ISHED(2),LLD)
     3, (ISHED(6),FRLAST(1))
      DATA ISTYP / 4HQDME, 2HM1 /
      DATA LSUB,LLD,FRLAST / 2*-1, -1.0E30, -1.0E30 /
C
C      ZERO OUT THE STRESS VECTOR
C
      STRESS(1)=0.
      STRESS(2)=0.
      STRESS(3)=0.
      CSTRS(2) = 0.0E0
      CSTRS(3) = 0.0E0
      CSTRS(4) = 0.0E0
C
C                           I=4                      -
C         STRESS VECTOR =(SUMMATION (S )(U )) - (S )(T - T)
C                           I=1       I   I       T       0
      DO 3 I=1,4
      NPOINT=IVEC+NSIL(I)-1
      CALL SMMATS (S(9*I-8),3,3,0, Z(NPOINT),3,1,0, VEC(1),CVC(1))
      DO 2 J=1,3
      IF (NCHK.LE.0)GO TO 1
      CSTRS(J+1) = CSTRS(J+1) + CVC(J)
    1 STRESS(J) = STRESS(J) + VEC(J)
    2 CONTINUE
    3 CONTINUE
      STRES(1) = PH1OUT(1)
      STRES(2) = STRESS(1)
      STRES(3) = STRESS(2)
      STRES(4) = STRESS(3)
      CSTRS(1) = STRES(1)
C
C      ADD IN TEMPERATURE EFFECTS
C
      IF(LDTEMP.EQ.(-1)) GO TO 200
      TEM = FTEMP-TSUB0
      DO 4 I=2,4
      STRES(I)=STRES(I)-ST(I-1)*TEM
    4 CONTINUE
C
C      STRESS VECTOR COMPLETE AND CONTAINS SIGMA X ,  SIGMA Y ,  SIGMA X
C
C      PRINCIPAL STRESSES AND ANGLE OF ACTION PHI
C
  200 TEMP=STRES(2)-STRES(3)
C
C     COMPUTE TAU
C
      STRES(8)=SQRT((TEMP/2.0E0)**2+STRES(4)**2)
      DELTA=(STRES(2)+STRES(3))/2.0E0
C
C     COMPUTE SIGMA 1 AND SIGMA 2
C
      STRES(6)=DELTA+STRES(8)
      STRES(7)=DELTA-STRES(8)
      DELTA=2.0E0*STRES(4)
      IF (ABS(DELTA).LT.1.0E-15.AND.ABS(TEMP).LT.1.0E-15) GO TO 5
      IF(ABS(TEMP) .LT. 1.0E-15) GO TO 6
C
C     COMPUTE PHI 1 DEPENDING ON WHETHER OR NOT SIGMA XY AND/OR
C               (SIGMA 1 - SIGMA 2) ARE ZERO
C
      STRES(5)=ATAN2(DELTA,TEMP)*28.6478898E00
      GO TO 7
    5 STRES(5)=0.0E0
      GO TO 7
    6 STRES(5)=45.
    7 IF (NCHK.LE.0) GO TO 150
C
C  . STRESS PRECISION CHECK...
C
      K = 0
      CALL SDRCHK (STRES(2),CSTRS(2),3,K)
      IF (K.EQ.0) GO TO 150
C
C  . LIMITS EXCEEDED...
      J = 0
      IF (LSUB.EQ.ISUB .AND. FRLAST(1).EQ.FRTMEI(1) .AND.
     1    LLD  .EQ.ILD  .AND. FRLAST(2).EQ.FRTMEI(2)) GO TO 120
C
      LSUB = ISUB
      FRLAST(1) = FRTMEI(1)
      FRLAST(2) = FRTMEI(2)
      LLD = ILD
      J = 1
      CALL PAGE1
  100 CALL SD2RHD (ISHED,J)
      WRITE(NOUT,110)
      LINE = LINE + 1
  110 FORMAT (7X,4HTYPE,5X,3HEID,5X,2HSX,5X,2HSY,4X,3HSXY)
      GO TO 130
  120 IF (EJECT (2) .NE. 0) GO TO 100
C
  130 WRITE(NOUT,140) ISTYP,CSTRS
  140 FORMAT (1H0,5X,A4,A2,I7,4F7.1)
C
  150 CONTINUE
      RETURN
      END

      SUBROUTINE TRD
C
C     TRANSIENT RESPONSE MODULE DRIVER
C
C     INPUTS   CASEXX,     TRL,NLFT,DIT,KHH,BHH,MHH,PH
C              CASEXX,     TRL,NLFT,DIT,KDD,BDD,MDD,PD
C
C     OUTPUTS  UDVT,PNLD
C              UHVT,PNLH
C
C     PARAMETERS -- MODAL --BCD--INPUT--MODAL=MODAL IMPLIES MODAL
C                   NOUE  --INT--INPUT--NUMBER OF EXTRA POINTS
C                   NONCUP--INT--INPUT--NONCUP=-1 IMPLIES NONCOUPLED
C                   NCOL  --INT--IN/OUT--APPEND FLAG 0  NO APPEND
C                                                    +  COL NUMBER OF
C                                                        LAST TIME STEP
C
C     SCRATCHES   --
C
C
C
C
C
C
C
      INTEGER            CASEXX    ,TRL      ,NLFT     ,DIT      ,
     1                   KDD       ,BDD      ,MDD      ,PD       ,
     1                   UDVT      ,PNLD     ,MODAL(2) ,SCR1     ,
     1                   SCR2      ,SCR3     ,SCR4     ,SCR5     ,
     1                   SCR6      ,SCR7     ,SCR8     ,
     1                   SR1       ,SR2      ,SR3      ,SR4      ,
     1                   SR5       ,SR6      ,NAME(2)  ,
     1                   IZ(1)
C
      COMMON /BLANK/  MODAL     ,NOUE     ,NONCUP   ,NCOL
      COMMON/SYSTEM/IBUF, IDUMMY(53), IPREC
      COMMON   /ZZZZZZ /  Z(1)
      COMMON   /TRDXX /  IK(7)     ,IM(7)    ,IB(7)    ,SR1      ,
     1                   SR2       ,SR3      ,SR4      ,SR5      ,
     2                   SR6       ,IOPEN    ,ISYM     ,TO       ,
     3                   NOPD      ,ISPNL
C
      EQUIVALENCE        ( Z(1)    ,IZ(1))
C
      DATA               CASEXX    ,TRL      ,NLFT     ,DIT      /
     1                   101       ,102      ,103      ,104      /
     1                   ,KDD      ,BDD      ,MDD      ,PD       /
     1                   105       ,106      ,107      ,108      /
     1                   ,UDVT     ,PNLD     ,SCR1     ,SCR2     /
     1                   201       ,202      ,301      ,302      /
     1                   ,SCR3     ,SCR4     ,SCR5     ,SCR6     /
     1                   303       ,304      ,305      ,306      /
     1                   ,SCR7     ,SCR8     ,         MODA      /
     1                   307       ,308      ,         4HMODA    /
     1                   ,NAME               /
     1                   4HTRD     ,4H       /
C
C ----------------------------------------------------------------------
C
C     INITIALIZE
C
      MODA1 = -1
      IF ( MODA .EQ. MODAL(1)) MODA1 = 1
C
C     BUILD INITIAL CONDITIONS
C
      IF (IPREC.EQ.1)
     1CALL TRD1A  (CASEXX, TRL, SCR1, NLFTP, NGROUP, MODA1)
      IF (IPREC.EQ.2)
     1CALL TRD1A2 (CASEXX, TRL, SCR1, NLFTP, NGROUP, MODA1)
C
C     TEST FOR ZERO APPLIED LOAD
C
      IK(1) = SCR1
      CALL RDTRL(IK(1))
      IF ( IK(6) .NE. 0) GO TO 10
      IF ( NLFTP .NE. 0) GO TO 10
      IK(1) = PD
      IK(6) = 0
      CALL RDTRL(IK)
      IF(  IK(6) .NE. 0) GO TO 10
      IF (NCOL.GT.0) GO TO 10
      CALL MESAGE(-46,0,0)
   10 CONTINUE
C
C     ESTIMATE CORE
C
      IF( NONCUP .LT. 0 .AND. MODAL(1) .EQ. MODA .AND. NLFTP .EQ. 0)
     1  GO TO 100
      NZ = KORSZ (Z)
      IGROUP = NZ- 3*NGROUP +1
      IK(1) = KDD
      CALL RDTRL( IK)
      IF( IK(1) .LT. 0) GO TO 20
      NROW = IK(3)
      GO TO 21
   20 IK(1) = 0
   21 IB(1) = BDD
      CALL RDTRL(IB)
      IF( IB(1) .LT. 0) GO TO 30
      NROW = IB(3)
      GO TO 31
   30 IB(1) = 0
   31 IM(1) = MDD
      CALL RDTRL(IM)
      IF( IM(1) .LT. 0) GO TO 35
      NROW = IM(3)
      GO TO 36
   35 IM(1) = 0
   36 CONTINUE
      ICRQ = 8*IBUF + 7*IPREC*NROW - IGROUP
      IF(ICRQ.GT.0) CALL MESAGE(-8,ICRQ,NAME)
C
C     SET UP COMMON
C
      SR1=SCR2
      SR2=SCR3
      SR3=SCR4
      SR4=SCR5
      SR5=SCR6
      SR6=SCR7
      ISKIP  = 1
      JGROUP = IGROUP
      DO 45 I = 1, NGROUP
      NSKIP = IZ(JGROUP+2)
      IF (NSKIP .EQ. 1) GO TO 40
      ISKIP = 0
      GO TO 47
   40 JGROUP = JGROUP + 3
   45 CONTINUE
   47 DO 50  I= 1,NGROUP
      CALL KLOCK(ITIME1)
      NSTEP = IZ(IGROUP)
      DELTA =  Z(IGROUP+1)
      IGROUP= IGROUP +3
      IF (IPREC.EQ.1) CALL INITL  (3*NGROUP, DELTA)
      IF (IPREC.EQ.2) CALL INITL2 (3*NGROUP, DELTA)
      CALL KLOCK(ITIME3)
      IF (IPREC.EQ.1)
     1CALL TRD1C  (SCR1, PD, NGROUP, NLFTP, UDVT, I, SCR8, DIT, NLFT,
     2             NOUE, MODA1, PNLD, ISKIP)
      IF (IPREC.EQ.2)
     1CALL TRD1C2 (SCR1, PD, NGROUP, NLFTP, UDVT, I, SCR8, DIT, NLFT,
     2             NOUE, MODA1, PNLD, ISKIP)
      CALL KLOCK (ITIME2)
      CALL TMTOGO(ITLEFT)
      IF( ITLEFT .LE. 0) GO TO 60
      IF(  I .EQ. NGROUP) GO TO 50
C
C     COMPUTE TIME TO DO NEXT ITERATION
C
      IF (2*(ITIME3-ITIME1 + ((ITIME2-ITIME3)/NSTEP)*IZ(IGROUP)).GE.
     1   ITLEFT) GO TO 60
   50 CONTINUE
   55 IK(1) = UDVT
      CALL RDTRL (IK(1))
      NCOL = IK(2)/3
      RETURN
C
C     UNCOUPLED MODAL
C
  100 CALL TRD1E(MDD,BDD,KDD,PD,UDVT,NGROUP)
      GO TO 55
C
C     INSUFFICIENT TIME LEFT TO FINISH
C
   60 CONTINUE
      IK(1) =UDVT
      CALL RDTRL( IK(1))
      NCOL = IK(2)/3
      IK(1) = PD
      CALL RDTRL( IK)
      CALL MESAGE (45, IK(2)-NCOL, NAME)
      IF (NCOL.EQ.0) CALL MESAGE(-37,0,NAME)
      RETURN
      END

      SUBROUTINE ETRBKD (IOPT)
C
C     THIS SUBROUTINE CALCULATES THE STIFFNESS MATRIX FOR THE BASIC
C     BENDING TRIANGLE.  IT IS USED BY SUBROUTINES TRBSCD,QDPLTD,
C     TRPLTD, QUAD1D, TRIA1D, TRIA2D
C     DOUBLE PRECISION VERSION
C     IOPT MAY BE VARIED AS FOLLOWS TO PRODUCE APPROPRIATE RESULTS
C     ******************************************************************
C
C
C
C     IOPT = 0   IMPLIES DO COMPLETE BASIC BENDING TRIANGLE.
C     IOPT = 1   IMPLIES COMPUTE ONLY THE NINE (3X3)MATRICES
C                WHICH FORM THE 9X9 K SUPER U - MATRIX.
C     IOPT = 2   SAME AS IOPT = 1,BUT SAVE H-INVERSE AND S...
C
C     ******************************************************************
C     ECPT LIST FOR BASIC BENDING TRIANGLE             NAME IN
C                                                      THIS
C     ECPT                                             ROUTINE   TYPE
C     ******************************************************************
C     ECPT( 1) = ELEMENT ID                            NECPT(1)  INTEGER
C     ECPT( 2) = GRID POINT A                          NGRID(1)  INTEGER
C     ECPT( 3) = GRID POINT B                          NGRID(2)  INTEGER
C     ECPT( 4) = GRID POINT C                          NGRID(3)  INTEGER
C     ECPT( 5) = THETA = ANGLE OF MATERIAL             ANGLE     REAL
C     ECPT( 6) = MATERIAL ID 1                         MATID1    INTEGER
C     ECPT( 7) = I = MOMENT OF INERTIA                 EYE       REAL
C     ECPT( 8) = MATERIAL ID 2                         MATID2    INTEGER
C     ECPT( 9) = T2                                    T2        REAL
C     ECPT(10) = NON-STRUCTURAL-MASS                   FMU       REAL
C     ECPT(11) = Z1                                    Z11       REAL
C     ECPT(12) = Z2                                    Z22       REAL
C     ECPT(13) = COORD. SYSTEM ID 1                    NECPT(13) INTEGER
C     ECPT(14) = X1                                    X1        REAL
C     ECPT(15) = Y1                                    Y1        REAL
C     ECPT(16) = Z1                                    Z1        REAL
C     ECPT(17) = COORD. SYSTEM ID 2                    NECPT(17) INTEGER
C     ECPT(18) = X2                                    X2        REAL
C     ECPT(19) = Y2                                    Y2        REAL
C     ECPT(20) = Z2                                    Z2        REAL
C     ECPT(21) = COORD. SYSTEM ID 3                    NECPT(21) INTEGER
C     ECPT(22) = X3                                    X3        REAL
C     ECPT(23) = Y3                                    Y3        REAL
C     ECPT(24) = Z3                                    Z3        REAL
C     ECPT(25) = ELEMENT TEMPERATURE                   ELTEMP    REAL
C     ******************************************************************
C
      LOGICAL NOGO
      INTEGER NECPT(26),NO(2)
      REAL  ECPT(25)
      DOUBLE PRECISION  J2X2(4), G2X2(4),S(18),G(9),TJTE(18),TITE(18)
     1,                 TI(9),A,PROD9,TEMP9,XSUBB,XSUBC,YSUBC,DICT5
     2,                 E,K,AOUT,D(9)
     3,                 CONSTS,DEGRA,TEMP,THETA,SINTH,COSTH,AREA,XBAR
     4,                 YBAR,XCSQ,YCSQ,XBSQ,XCYC,PX2,PY2,PXY2,XBAR3
     5,                 YBAR3,YBAR2,DETERM
C
      COMMON  /CONDAD/  CONSTS(5)
      COMMON /MATIN / MATID,INFLAG,ELTEMP,STRESS,SINTH,COSTH
      COMMON /MATOUT/G11,G12,G13,G22,G23,G33,RHO,ALPHA1,ALPHA2,ALP12,
     1                T SUB 0, G SUB E, SIGTEN, SIGCOM, SIGSHE,
     2                G2X211, G2X212, G2X222
C
      COMMON /EMGPRM/ DUM(15),SMB(3),IPREC,NOGO
      COMMON /EMGEST/ IELID , NGRID(3)
     2                  ,ANGLE         ,MATID1
     3                  ,EYE           ,MATID2
     4                  ,T2            ,FMU
     5                  ,Z11           ,Z22
     6                  ,DUMMY1        ,X1
     7                  ,Y1            ,Z1
     8                  ,DUMMY2        ,X2
     9                  ,Y2            ,Z2
     1                  ,DUMMY3        ,X3
     2                  ,Y3            ,Z3            ,DUMB(76)
      COMMON /EMGTRX/ A(225),PROD9(9),TEMP9(9),XSUBB,XSUBC,YSUBC,DICT5,
     2                E(18),K(324),AOUT(324)
C
      EQUIVALENCE ( CONSTS(4) , DEGRA  )
      EQUIVALENCE (IELID,ECPT(1),NECPT(1)), (D(1),G(1), A(79))
     2            ,(G2X2(1),A(88))
     3             ,(TJTE(1),A(100))   ,(TITE(1),S(1),A(82))
     4                 ,(J2X2(1),A(92))     ,(TI(1),A(118))
C
      DATA NO /81,190/
      NTYPE = 0
      IF( IOPT.GT.0 ) NTYPE = 1
      IF (NTYPE .EQ. 1) GOTO 100
      ELTEMP = ECPT(25)
C     SET UP  I, J, K VECTORS STORING AS FOLLOWS AND ALSO CALCULATE
C     X-SUB-B, X-SUB-C, AND Y-SUB-C.
C
C     E(11), E(14), E(17) WILL BE THE I-VECTOR.
C     E(12), E(15), E(18) WILL BE THE J-VECTOR.
C     E( 1), E( 4), E( 7) WILL BE THE K-VECTOR.
C
C     FIND I-VECTOR = RSUBB - RUBA (NON-NORMALIZED)
      E(11) =  DBLE(X2) -  DBLE(X1)
      E(14) =  DBLE(Y2) -  DBLE(Y1)
      E(17) =  DBLE(Z2) -  DBLE(Z1)
C
C     FIND LENGTH = X-SUB-B COOR. IN ELEMENT SYSTEM
      XSUBB =  DSQRT(E(11)**2  +  E(14)**2  + E(17)**2)
      IF  (XSUBB  .LE.  1.D-6)  GO TO 7770
C
      E(11) =  E(11)/XSUBB
      E(14) =  E(14)/XSUBB
      E(17) =  E(17)/XSUBB
C
C     TAKE RSUBC - RSUBA AND STORE TEMPORARILY IN E(2), E(5), E(8)
C
      E(2)  =  DBLE(X3) -  DBLE(X1)
      E(5)  =  DBLE(Y3) -  DBLE(Y1)
      E(8)  =  DBLE(Z3) -  DBLE(Z1)
C
C     X-SUB-C = I . (RSUBC - RSUBA), THUS
C
      XSUBC = E(11) * E(2)  +  E(14) * E(5)  +  E(17) * E(8)
C
C     CROSSING I-VECTOR TO (RSUBC - RSUBA) GIVES THE K-VECTOR
C     (NON-NORMALIZED)
C
      E(1) = E(14) * E( 8)  -  E( 5) * E(17)
      E(4) = E( 2) * E(17)  -  E(11) * E( 8)
      E(7) = E(11) * E( 5)  -  E( 2) * E(14)
C
C     FIND LENGTH = Y-SUB-C COOR. IN ELEMENT SYSTEM
      YSUBC =  DSQRT(E(1)**2  + E(4)**2  +  E(7)**2)
      IF (YSUBC  .LE.  1.0-6)  GO TO 7780
C
C     NORMALIZE K-VECTOR WITH Y-SUB-C
C
      E(1) = E(1)/YSUBC
      E(4) = E(4) / YSUBC
      E(7) = E(7) / YSUBC
C
C     NOW HAVING I AND K VECTORS GET -- J = K CROSS I
C
      E(12) = E( 4) * E(17)  -  E(14) * E( 7)
      E(15) = E(11) * E( 7)  -  E( 1) * E(17)
      E(18) = E( 1) * E(14)  -  E(11) * E( 4)
C
C     NORMALIZE J-VECTOR FOR COMPUTER EXACTNESS JUST TO MAKE SURE
C
      TEMP =  DSQRT(E(12)**2  + E(15)**2  + E(18)**2)
      E(12) = E(12) / TEMP
      E(15) = E(15) / TEMP
      E(18) = E(18) / TEMP
      E(2) = 0.
      E(3) = 0.
      E(5) = 0.
      E(6) = 0.
      E(8) = 0.
      E(9) = 0.
      E(10) = 0.
      E(13) = 0.
      E(16) = 0.
C
C     CONVERT ANGLE FROM DEGREES TO RADIANS STORING IN THETA.
C
      THETA =  DBLE(ANGLE) * DEGRA
      SINTH =  DSIN(THETA)
      COSTH =  DCOS(THETA)
      IF (DABS(SINTH) .LT.  1.D-6)  SINTH = 0.D0
C
C     ******************************************************************
C
C     SETTING UP G MATRIX
  100 INFLAG = 2
      MATID = MATID1
      CALL MAT( ECPT(1) )
C
C     FILL G-MATRIX WITH OUTPUT FROM MAT ROUTINE
C
      G(1) = G11
      G(2) = G12
      G(3) = G13
      G(4) = G12
      G(5) = G22
      G(6) = G23
      G(7) = G13
      G(8) = G23
      G(9) = G33
C
C     ******************************************************************
C
C  50 COMPUTATION OF D = I.G-MATRIX (EYE IS INPUT FROM THE ECPT)
C
      DO 120 I=1,9
  120 D(I) =  G(I) * DBLE(EYE)
C
C     ******************************************************************
C
      AREA  =  XSUBB* YSUBC/2.D0
      XBAR  =  (XSUBB + XSUBC)/3.D0
      YBAR  =  YSUBC/3.D0
C
      XCSQ = XSUBC ** 2
      YCSQ = YSUBC ** 2
      XBSQ = XSUBB ** 2
      XCYC = XSUBC * YSUBC
      PX2   =  (XBSQ + XSUBB*XSUBC + XCSQ)/6.D0
      PY2   =  YCSQ/6.D0
      PXY2  =  YSUBC*(XSUBB + 2.D0*XSUBC)/12.D0
      XBAR3 =  3.D0 * XBAR
      YBAR3 =  3.D0 * YBAR
      YBAR2 =  2.D0 * YBAR
C
C     ******************************************************************
C                 X
C     FILL THE  (K ) MATRIX STORING IN  A(1). . .A(36)
C
      A( 1) = D( 1)
      A( 2) = D( 3)
      A( 3) = D( 2)
      A( 4) = D( 1) * XBAR3
      A( 5) = D( 2) * XBAR   +  YBAR2 * D(3)
      A( 6) = D( 2) * YBAR3
      A( 7) = A( 2)
      A( 8) = D( 9)
      A( 9) = D( 6)
      A(10) = D( 3) * XBAR3
      A(11) = D( 6) * XBAR   +  YBAR2 * D(9)
      A(12) = D( 6) * YBAR3
      A(13) = A( 3)
      A(14) = A( 9)
      A(15) = D( 5)
      A(16) = D( 2) * XBAR3
      A(17) = D( 5) * XBAR   +  YBAR2 * D(6)
      A(18) = D( 5) * YBAR3
      A(19) = A( 4)
      A(20) = A(10)
      A(21) = A(16)
      A(22) = D(1)*9.*PX2
      A(23) = D(2)*3.*PX2  +  6.*PXY2*D(3)
      A(24) = D(2)*9.*PXY2
      A(25) = A( 5)
      A(26) = A(11)
      A(27) = A(17)
      A(28) = A(23)
      A(29) =  D(5)*PX2 + 4.*PXY2*D(6)   +  4.*PY2*D(9)
      A(30) =  D(5)*3.*PXY2  +  6.*PY2*D(6)
      A(31) = A( 6)
      A(32) = A(12)
      A(33) = A(18)
      A(34) = A(24)
      A(35) = A(30)
      A(36) =  D(5)*9.*PY2
      TEMP =  4.*AREA
      DO 140  I=1,36
  140 A(I) = A(I)*TEMP
C
C     ******************************************************************
C
C     F1LL  (HBAR) MATRIX STORING AT A(37). . .A(72)
C
      DO 160 I =37,72
  160 A(I)=0.
C
      A(37) = XBSQ
      A(40) = XBSQ * XSUBB
      A(44) = XSUBB
      A(49) = -2.*XSUBB
      A(52) = -3.*XBSQ
      A(55) = XCSQ
      A(56) = XCYC
      A(57) = YCSQ
      A(58) = XCSQ * XSUBC
      A(59) = YCSQ * XSUBC
      A(60) = YCSQ * YSUBC
      A(62) = XSUBC
      A(63) = YSUBC*2.
      A(65) =  XCYC*2.
      A(66) =  YCSQ*3.
      A(67) =  -2.*XSUBC
      A(68) =-YSUBC
      A(70) =  -3.*XCSQ
      A(71) =-YCSQ
C
C     ******************************************************************
C
      IF (T2 .EQ. 0.) GO TO 220
C
C     ALL OF OPERATIONS THRU STMT 220
C     ARE NECESSARY IF T2 IS NON-ZERO.
C
C     ******************************************************************
C
C
C     GET THE G2X2 MATRIX
C
      MATID = MATID2
      INFLAG = 3
      CALL MAT( ECPT(1) )
      IF(G2X211.EQ.0.0E0 .AND. G2X212.EQ.0.0E0 .AND. G2X222.EQ.0.0E0)
     1    GO TO 220
      G2X2(1) =  DBLE(G2X211) * DBLE(T2)
      G2X2(2) =  DBLE(G2X212) * DBLE(T2)
      G2X2(3) =  DBLE(G2X212) * DBLE(T2)
      G2X2(4) =  DBLE(G2X222) * DBLE(T2)
C
      DETERM = G2X2(1) * G2X2(4)  -  G2X2(3) * G2X2(2)
      J2X2(1) = G2X2(4) / DETERM
      J2X2(2) =-G2X2(2) / DETERM
      J2X2(3) =-G2X2(3) / DETERM
      J2X2(4) = G2X2(1) / DETERM
C
C     ******************************************************************
C
C     (H  ) IS PARTITIONED INTO A LEFT AND RIGHT PORTION AND ONLY THE
C       YQ  RIGHT PORTION IS COMPUTED AND USED AS A  (2X3). THE LEFT
C           2X3 PORTION IS NULL.  THE RIGHT PORTION WILL BE STORED AT
C           A(73)...A(78) UNTIL NOT NEEDED ANY FURTHER.
C
C
C
      TEMP = 2.*D(2) + 4.*D(9)
      A(73) =  -6.* (J2X2(1)*D(1) + J2X2(2)*D(3))
      A(74) =  -J2X2(1)*TEMP - 6.*J2X2(2)*D(6)
      A(75) =  -6.*(J2X2(1)*D(6)  + J2X2(2)*D(5))
      A(76) =  -6.*(J2X2(2)*D(1) + J2X2(4)*D(3))
      A(77) =  -J2X2(2)*TEMP - 6.*J2X2(4)*D(6)
      A(78) =  -6.*(J2X2(2)*D(6) + J2X2(4)*D(5))
C
C     THE ABOVE 6 ELEMENTS NOW REPRESENT THE (H  ) MATRIX (2X3)
C                                              YQ
C
C     NOW FORMING  PRODUCT (G2X2)(H  ) AND STORING AS AN INTERMEDIATE
C     STEP.                        YQ
C
C
      CALL GMMATD (G2X2, 2,2,0,   A(73), 2,3,0,  A(79))
C
C                                                               Y
C     WITH LAST PRODUCT  FORM  LOWER RIGHT 3 X 3 PARTITION OF (K )
C
C              Y                   T
C     THUS   (K ) PARTITION = (H  ) (LAST PRODUCT)   STORE AT A(85)
C                               YQ
C
      CALL GMMATD (A(73), 2,3,1,  A(79), 2,3,0,  A(85))
C
C                                                     X
C     NOW ADD THE 9 ELEMENTS OF THIS 3X3 PORTION TO (K )
C     PER STEP 5 PAGE -16- MS-17                            Y
C     MULTIPLY IN AREA AT SAME TIME WHICH WAS LEFT OUT OF (K ) ABOVE.
C
      DO 180 I=1,3
      A(I + 21) = A(I + 21) + A(I + 84) * AREA
      A(I + 27) = A(I + 27) + A(I + 87) * AREA
  180 A(I + 33) = A(I + 33) + A(I + 90)*AREA
C
C     ADD TO 6 OF THE (HBAR) ELEMENTS THE RESULT OF (H  )(H  )
C                                                    UY   YQ
C     THE PRODUCT IS FORMED DIRECTLY IN THE ADDITION PROCESS BELOW.
C     NO (H  ) MATRIX IS ACTUALLY COMPUTED DIRECTLY.
C          UY
C
C     THE FOLLOWING IS THEN PER STEPS 6 AND 7 PAGE -16- MS-17.
C
      DO 200 I=1,3
      A(I + 39) = A(I + 39) + XSUBB * A(I + 72)
  200 A(I+57) =  A(I+57) + XSUBC*A(I+72) + YSUBC*A(I+75)
C
C     THIS ENDS ADDED COMPUTATION FOR CASE OF T2 NOT ZERO
C
C     ******************************************************************
C
  220 CONTINUE
C
C     AT THIS POINT INVERT  (H) WHICH IS STORED AT A(37). . .A(72)
C     STORE INVERSE BACK IN A(37) . . . A(72)
C     NO NEED TO COMPUTE DETERMINANT SINCE IT IS NOT USED SUBSEQUENTLY.
      ISING = -1
      CALL INVERD (6, A(37), 6,A(73), 0, DETERM,ISING,A(79))
C
C     CHECK TO SEE IF H WAS SINGULAR
      IF (ISING .EQ. 2) GO TO 7790
C
C
C     ******************************************************************
C              Q   -1
C     FORM   (K )(H  )  AND STORE AT  A(73). . .A(108)
C                 X                     Q
C     NOTE THAT (K ) AT THIS POINT IS (K )...
C
      CALL GMMATD (A(1), 6,6,0, A(37), 6,6,0,  A(73))
C
C                    -1 T
C     FORM(K  ) = (H  ) (LAST PRODUCT) STORE AT A(109). . .A(144)
C            II
C
      CALL GMMATD (A(37), 6,6,1, A(73), 6,6,0, A(109))
C
C     ******************************************************************
C
C     FILL S-MATRIX EQUIVALENCED TO A(82)  (S IS  6X3 )
C
      IF (IOPT .NE. 2) GO TO 260
C
C     SAVE H-INVERSE TO BE USED BY TRIANGULAR PLATE ROUTINE.
C
      DO 240 I = 37,72
  240 A(I+108) = A(I)
C
  260 S(1) = 1.0
      S(2) = 0.
      S( 3) =-XSUBB
      S(4) = 0.
      S(5) = 1.
      S(6) = 0.
      S(7) = 0.
      S(8) = 0.
      S(9) = 1.
      S(10)= 1.
      S(11) = YSUBC
      S(12) =-XSUBC
      S(13)= 0.
      S(14)= 1.
      S(15)= 0.
      S(16)= 0.
      S(17)= 0.
      S(18)= 1.
C
C     ******************************************************************
C                     T
C     FORM   K   = K   = -K   S  STORING AT A(46)   (K   IS 6X3)
C             IA    AI     II                         IA
C
      CALL GMMATD (A(109), 6,6,0, S(1), 6,3,0, A(46))
C
C     THIS PRODUCT IS MULTIPLIED BY SCALER -1 BELOW.
C
C                    T
C          (K  ) = (S )(-K  )
C            AA           IA
C
C     NOTE K    HAS NOT BEEN MULTIPLIED ABOVE BY -1, THUS IGNORE MINUS
C           IA                                                   HERE.
C
      CALL GMMATD (S(1), 6,3,1,  A(46), 6,3,0, A(1))
C
C     NOW MULTIPLY  K   BY SCALER (-1)
C                    IA
C
      DO 280 I =46,63
  280 A(I) = -A(I)
C
C     AT THIS POINT, STORED BY ROWS ARE
C
C                  K     (6X6) AT A(109). . .A(144)
C                   II
C
C                  K     (6,3) AT  A(46). . .A(63)
C                   IA
C
C                  K     (3X3) AT A(  1). . .A(  9)
C                   AA
C
C     ARRANGE NINE 3X3 MATRICES OF K SUPER U
      DO 300 I = 28,36
  300 A(I) = A(I+18)
       A(10) = A(46)
       A(11) = A(49)
       A(12) = A(52)
       A(13) = A(47)
       A(14) = A(50)
       A(15) = A(53)
       A(16) = A(48)
       A(17) = A(51)
       A(18) = A(54)
       A(19) = A(55)
       A(20) = A(58)
       A(21) = A(61)
       A(22) = A(56)
       A(23) = A(59)
       A(24) = A(62)
       A(25) = A(57)
       A(26) = A(60)
       A(27) = A(63)
       A(37) = A(109)
       A(38) = A(110)
       A(39) = A(111)
       A(40) = A(115)
       A(41) = A(116)
       A(42) = A(117)
       A(43) = A(121)
       A(44) = A(122)
       A(45) = A(123)
       A(46) = A(112)
       A(47) = A(113)
       A(48) = A(114)
       A(49) = A(118)
       A(50) = A(119)
       A(51) = A(120)
       A(52) = A(124)
       A(53) = A(125)
       A(54) = A(126)
       A(64) = A(127)
       A(65) = A(128)
       A(66) = A(129)
       A(67) = A(133)
       A(68) = A(134)
       A(69) = A(135)
       A(70) = A(139)
       A(71) = A(140)
       A(72) = A(141)
       A(73) = A(130)
       A(74) = A(131)
       A(75) = A(132)
       A(76) = A(136)
       A(77) = A(137)
       A(78) = A(138)
       A(79) = A(142)
       A(80) = A(143)
       A(81) = A(144)
      DICT5 = GSUBE
      IF (NTYPE .NE. 1)  GO TO 350
      LOOPND = NO(IOPT)
      DO 320 I=1,LOOPND
  320 AOUT(I) = A(I)
      RETURN
  350 CONTINUE
C
C     ******************************************************************
C
C
      DO 600 NPIVOT = 1,3
C
C
C     AT THIS POINT START ASSEMBLY OF 3   6X6 MATRICES FOR I = PIVOT,
C     AND J =1,2,3  IN THE FOLLOWING EQUATION.
C
C                   T         U    T
C        (K  ) = (T  ) (E) (K  ) (E ) (T )
C          IJ      I         IJ         J
C
C     ******************************************************************
C
C     FIRST GET THE PRODUCT APPLICABLE TO ALL 3 K  .
C                                                IJ
C                   T
C              = (T  ) (E)    A 6X3 MATRIX.
C                  I
C
C
C     CHECK TO SEE IF TI-MATRIX IS NEEDED
C     IF THE CSID IS ZERO FOR THE PIVOT POINT SKIP TRANSFORMATION.
C
      IF (NECPT(4*NPIVOT+9) .EQ. 0) GO TO 420
C
C     GET  TI AND MULTIPLY WITH E TO FILL TITE (THE COMMON PRODUCT)
C
      CALL TRANSD (NECPT(4*NPIVOT+9),TI)
C
C     TI IS EQUIVALENCED TO A(118) AND IS 3X3.
C
C     FORM TITE (UPPER AND LOWER) OK OK OK....
C
      CALL GMMATD (TI(1),3,3,1, E(1),3,3,0, TITE(1))
      CALL GMMATD (TI(1), 3,3,1, E(10),3,3,0, TITE(10))
C
      GO TO 460
C
C 250 COMING HERE IMPLIES TI NOT USED.
C     JUST SET TITE = E MATRIX
  420 DO 440 I=1,18
440   TITE(I) = E(I)
C
C     ******************************************************************
C                                                  T
C 280 AT THIS POINT COMMON PRODUCT IS COMPLETE =(T  )(E)  STORED IN TITE
C                                                 I
C
C     THE PIVOT I IS NPIVOT
460   NPT1 = 189
C
C     THE ABOVE SETS A POINTER, NPT1, TO POINT TO 18 FREE DOUBLE PREC.
C     CORE LOCATIONS IN THE A-ARRAY FOR STORAGE OF THE FOLLOWING
C     SUB-PRODUCT.
C                     U   T
C                  (K  )(E )(T )
C                    IJ       J
C
C     ******************************************************************
C
C     LOOP THRU FOR THE 3 - 6X6 K   ARRAYS.
C                                IJ
      DO 580 J=1,3
C                          T
C     TAKE SUB PRODUCT = (E )(T )..     STORE IN TJTE MATRIX
C                              J
C
C     NOTE.. THE TRANSPOSE OF THE ABOVE IS BEING FOUND AND USED,
C                           T
C                      = (T  )(E),  AND STORED IN TJTE-MATRIX
C                          J        EQUIVALENCED TO A(100)
C
C
C     CHECK TO SEE IF TRANSFORMATION IS NEEDED.
C     IF NOT SKIP TO  480
C
      IF (NECPT(4*J +9)  .EQ. 0)  GO TO 480
C
      CALL TRANSD (NECPT(4*J+9),TI)
C
      CALL GMMATD (TI(1), 3,3,1, E(1),3,3,0, TJTE(1))
      CALL GMMATD (TI(1),3,3,1, E(10),3,3,0, TJTE(10))
      GO TO 500
C
C 480 COMING HERE IF TRANSFORMATION NOT USED
C
C 480 SET TJTE = E
  480 DO 490 I =1,18
  490 TJTE(I) = E(I)
C
C     ******************************************************************
C           T       T
C 880   ( (E )(T ) )  IS COMPLETE AND STORED BY ROWS IN TJTE-MATRIX.
C               J
C                     U   T
C     NOW FORM,    (K  )(E )(T ), STORING AT A(NPT1)
C                    IJ       J
C
C                                  U
C     TO COMPUTE ABOVE USE 3X3   K
C                                 (NPIVOT,J)
C     COMPUTE POINTER TO THIS 3X3.
C
  500 NPT2 = 27*NPIVOT+9*J  - 35
C
      CALL GMMATD (A(NPT2), 3,3,0, TJTE, 6,3,1, A(NPT1))
C
C     ******************************************************************
C
C 950 AT THIS POINT,
C                       U   T
C                    (K  )(E )(T )  IS STORED AT A(NPT1), (3X6).
C                      IJ       J
C
C     AND,              T
C                    (T  )(E)      IS STORED AT TITE(1) = A(82)  (6X3)
C                      I
C     ******************************************************************
C
C     FORMING FINAL PRODUCT, AND STORING AT A(100) THE 6X6.
C
      CALL GMMATD (TITE(1), 6,3,0, A(NPT1), 3,6,0, A(100))
C
C     ******************************************************************
C
C
C    NOW STORE  THE 6X6 MATRIX IN AOUT
C
      IOUT = (NPIVOT-1)*27 + (J-1)*9 + 1
      I = 113
      DO 570 II=1,3
      DO 550 JJ=1,3
      IA = I + (II-1)*6 + JJ
      AOUT(IOUT) = A(IA)
550   IOUT = IOUT+1
570   CONTINUE
C
  580 CONTINUE
C
  600 CONTINUE
C
      RETURN
C
C     ERROR RETURNS
C
 7770 CALL MESAGE (30,31,ECPT(1))
 7777 NOGO = .TRUE.
      RETURN
C
 7780 CALL MESAGE (30,32,IELID)
      GO TO 7777
C
 7790 CALL MESAGE (30,33,IELID)
      GO TO 7777
C     ******************************************************************
      END

      SUBROUTINE CURV
C
C     MAIN DRIVING ROUTINE OF MODULE -CURV-.
C
C     DMAP CALLING SEQUENCE.
C
C     CURV   OES1,MPT,CSTM,EST,SIL,GPL/OES1M,OES1G/P1/P2 $
C
      LOGICAL         FOES1G, EOFOS1, STRAIN
      INTEGER         SUBR(6), FILE, MCB(7)
      CHARACTER       UFM*23, UWM*25, UIM*29, SFM*25
      COMMON /XMSSG / UFM, UWM, UIM, SFM
      COMMON /BLANK / IP1, IP2
      COMMON /SYSTEM/ ISYSBF, IOUTPT
      COMMON /CURVTB/ INDEXS(108)
      COMMON /ZZZZZZ/ IZ(1)
C
C     COMMON /ZZCURV/ MUST BE AT THE LONGEST OF OVERLAYS WITH CURV1,
C     CURV2, AND CURV3.
C
      EQUIVALENCE     (INDEXS( 16),LMCSID), (INDEXS( 52),LCORE),
     1                (INDEXS( 79),LOC), (INDEXS( 80),FILE),
     2                (INDEXS( 81),IMSG), (INDEXS(100),EOFOS1),
     3                (INDEXS(103),FOES1G), (INDEXS(104),STRAIN),
     4                (INDEXS(105),LOGERR)
      DATA     SUBR / 4HCURV,4H1   ,4HCURV,4H2   ,4HCURV,4H3     /
C
C
C     CHECK TO SEE IF COMPUTATIONS NEED TO BE DONE
C
      IF (IP1 .LT. 0) RETURN
C
C     CHECK TO SEE IF THE INPUT FILE EXISTS
C
      MCB(1) = 101
      CALL RDTRL (MCB(1))
      IF (MCB(1) .LE. 0) RETURN
C
C     PERFORM INITIALIZATION AND CREATE ESTX ON SCRATCH FILE 1.
C
      DO 10 I = 1,107
      INDEXS(I) = 777777777
   10 CONTINUE
      IMSG = 0
      JSUB = 1
      CALL CURV1
      IF (IMSG  .EQ. -8) GO TO 10001
      IF (IMSG  .LT.  0) GO TO 9000
      IF (LMCSID .LE. 0) GO TO 8000
C
C     CREATE OES1M FOR NEXT SUBCASE IF NOT AT EOF IN OES1.
C
  100 IF (EOFOS1) GO TO 4000
      JSUB = 2
      CALL CURV2
      IF (IMSG .EQ. -8) GO TO 10001
      IF (IMSG .LT.  0) GO TO 9000
C
C     IF OES1G IS TO BE FORMED CALL CURV3 OVERLAY.  PROCESS CURRENT
C     SUBCASE
C
      IF (.NOT.FOES1G) GO TO 100
      JSUB = 3
      CALL CURV3
      IF (IMSG .EQ. -8) GO TO 10001
      IF (IMSG .LT.  0) GO TO 9000
      GO TO 100
C
C     EOF HIT IN OES1.  ALL THROUGH.
C
 4000 CONTINUE
      RETURN
C
C     NO NON-ZERO MATERIAL COORDINATE SYSTEM IDS ENCOUNTERED
C
 8000 CALL PAGE2 (3)
      WRITE (IOUTPT,8100) UWM
      IF (.NOT.STRAIN) WRITE (IOUTPT,8200)
      IF (     STRAIN) WRITE (IOUTPT,8300)
 8100 FORMAT (A25,' 3173, NO NON-ZERO MATERIAL COORDINATE SYSTEM IDS ',
     1        'ENCOUNTERED IN MODULE CURV.')
 8200 FORMAT (39H STRESSES IN MATERIAL COORDINATE SYSTEM,
     1        14H NOT COMPUTED.)
 8300 FORMAT (49H STRAINS/CURVATURES IN MATERIAL COORDINATE SYSTEM,
     1        14H NOT COMPUTED.)
      GO TO 4000
C
C     ERROR CONDITION IN CURV1, CURV2, OR CURV3.
C
 9000 IF (IMSG .NE. -37) GO TO 9999
      WRITE  (IOUTPT,9100) SFM,JSUB,IMSG,LOC,JSUB,FILE
 9100 FORMAT (A25,' 3174, SUBROUTINE CURV',I1,
     1        ' HAS RETURNED WITH ERROR CONDITION ',I4, /5X,
     2        'LOCATION CODE = ',I4,' IN SUBROUTINE CURV',I1, /5X,
     3        'FILE NUMBER   = ',I4)
      WRITE  (IOUTPT,9998) INDEXS
 9998 FORMAT (/5X,29H CONSTANTS IN COMMON /CURVTB/ , /,(3X,4I15))
C
C     INSURE ALL FILES CLOSED
C
 9999 CONTINUE
      DO 10000 I = 1,9
      DO 10000 J = 100,300,100
      CALL CLOSE (I+J,1)
10000 CONTINUE
10001 WRITE (IOUTPT,9100) SFM,JSUB,IMSG,LOC,JSUB,FILE
      JSUB = 2*JSUB - 1
      IF (IMSG .EQ. -8) FILE = LCORE
      CALL MESAGE (IMSG,FILE,SUBR(JSUB))
      GO TO 4000
      END

      SUBROUTINE PLTOPR
C
      INTEGER         PRNT,PLOTER,PLTYPE,EOF,ITYPE(4),LIST(20),SKIP,
     1                PLTTYP(3,3),A1(9),A2(12),A3(25),A4(13),A5(17),
     2                A6(6),B1(16),B2(16),B5(10),C1(16),C2(17),C3(24),
     3                FILM(2),PAPER(2),ILAY(20),D1(11),D2(6),D3(29),
     4                PRJ(3,3),PLUS,MINUS,XYZ(3),SYMM(4),BLANK,E1(12),
     5                E2(20),E3(14),E4(18),F1(22),F2(25),F3(12),F4(23),
     6                STRESS(34),DIST(12),WAY(4),G1(13),G2(11),G3(16),
     7                G4(6),G5(11),G6(8),G7(4),DISPLA(10),SPACE,LAYER,
     8                CAMERA,BFRAMS,PLTMDL,TAPDEN,PAPTYP,PENSIZ,PENCLR,
     9                AXIS,DAXIS,PRJECT,ORIGIN,STRAIN(4),P6(23),ORG,
     O                H1(11)
      REAL            ALST(20),CSCALE
      COMMON /BLANK / SKPCOM(20),PRNT
      COMMON /XXPARM/ PBUFSZ,CAMERA,BFRAMS,PLTMDL(2),TAPDEN,NPENS,
     1                PAPSIZ(2),PAPTYP(2),PENSIZ(8),PENCLR(8,2),PENPAP,
     2                SCALE(2),SKPSCL(3),AXIS(3),DAXIS(3),VANGLE(9),
     3                VANTX1,R0,S0L,S0R,T0,D0,VANTX2(2),PRJECT,S0S,
     4                FOR,ORG,NORG,ORIGIN(11),ORIGX3(11,4),
     5                XY(11,3),NCNTR,CNTR(50),ICNTVL,IWHERE,IDIREC,
     6                SKIP23(23),LAYER
      COMMON /PLTDAT/ MODEL,PLOTER,SKPPLT(17),CSCALE,SKPA(2),CNTSIN,
     1                SKPB(3),NOPENS,SKPC(2),PLTYPE,SKPD(2),EOF,CNTIN3
      EQUIVALENCE     (LIST(1),ALST(1))
C
      DATA    NSKIP , SKIP    /1        ,4H(1X)                     /
      DATA    FILM  , PAPER   /4HFILM   ,1H       ,4HPAPE   ,1HR    /
C
C     PLOTTER TYPE FORMATS.
C
      DATA    NP6   / 23 /
      DATA    P6    / 4H(10X  ,4H,38H   ,4HTHE    ,4HFOLL   ,4HOWIN  ,
     1                4HG PL  ,4HOTS    ,4HARE    ,4HFOR    ,4HA NA  ,
     2                4HSTPL  ,4HT ,2   ,4HA4,A   ,4H2,8H   ,4HPLOT  ,
     3                4HTER   ,4H,2A4   ,4H,17H   ,4HTYPI   ,4HNG C  ,
     4                4HAPAB  ,4HILIT   ,4HY,/)   /
      DATA    PLTTYP/ 4HMICR  ,4HOFIL   ,1HM      ,
     1                4H  TA  ,4HBLE    ,1H       ,
     2                4H  DR  ,4HUM     ,1H       /
      DATA    ITYPE / 4HWITH  ,4H       ,
     1                4HWITH  ,4HOUT    /
C
C     GENERAL PLOTTER FORMATS.
C
      DATA    NA1   / 9 /
      DATA    A1    / 4H(//,  ,4H25H    ,4HP L    ,4HO T    ,4HT E   ,
     1                4HR     ,4H D A   ,4H T A   ,4H,/)    /
      DATA    NA2   / 12 /
      DATA    A2    / 4H(10X  ,4H,27H   ,4HTHE    ,4HPLOT   ,4H TAP  ,
     1                4HE IS  ,4H WRI   ,4HTTEN   ,4H AT,   ,4HI4,4  ,
     2                4HH BP  ,4HI,/)   /
      DATA    NA3   / 25 /
      DATA    A3    / 4H(10X  ,4H,89H   ,4HTHE    ,4HPLOT   ,4HS AR  ,
     1                4HE SE  ,4HPARA   ,4HTED    ,4HBY E   ,4HND-O  ,
     2                4HF-FI  ,4HLE M   ,4HARKS   ,4H...T   ,4HWO E  ,
     3                4HND-O  ,4HF-FI   ,4HLE M   ,4HARKS   ,4H FOL  ,
     4                4HLOW   ,4HTHE    ,4HLAST   ,4H PLO   ,4HT,/)  /
      DATA    NA4   / 13 /
      DATA    A4    / 4H(10X  ,4H,41H   ,4HAN E   ,4HND-O   ,4HF-FI  ,
     1                4HLE M  ,4HARK    ,4HFOLL   ,4HOWS    ,4HTHE   ,
     2                4HLAST  ,4H PLO   ,4HT,/)   /
      DATA    NA5   / 17 /
      DATA    A5    / 4H(10X  ,4H,56H   ,4HTHE    ,4HFIRS   ,4HT CO  ,
     1                4HMMAN  ,4HD FO   ,4HR EA   ,4HCH P   ,4HLOT   ,
     2                4HCONT  ,4HAINS   ,4H THE   ,4H PLO   ,4HT NU  ,
     3                4HMBER  ,4H,/)    /
      DATA    NA6   / 6  /
      DATA    A6    / 4H(10X  ,4H,9HC   ,4HSCAL   ,4HE =    ,4H,F5.  ,
     1                4H2,/)  /
C
C     TABLE PLOTTER FORMATS.
C
      DATA    NB1   / 16 /
      DATA    B1    / 4H(10X  ,4H,30H   ,4HSET    ,4HTHE    ,4HX +   ,
     1                4HY SC  ,4HALE    ,4HFACT   ,4HORS    ,4HAT,F  ,
     2                4H6.1,  ,4H12H    ,4HCOUN   ,4HTS/I   ,4HNCH,  ,
     3                4H/)    /
      DATA    NB2   / 16 /
      DATA    B2    / 4H(10X  ,4H,12H   ,4HPAPE   ,4HR SI   ,4HZE =  ,
     1                4H,F5.  ,4H1,2H   ,4H X,F   ,4H5.1,   ,4H16H,  ,
     2                4H  PA  ,4HPER    ,4HTYPE   ,4H = ,   ,4H2A4,  ,
     3                4H/)    /
      DATA    NB5   / 10 /
      DATA    B5    / 4H(10X  ,4H,3HP   ,4HEN,I   ,4H2,7H   ,4H - S  ,
     1                4HIZE,  ,4HI2,2   ,4HH, ,   ,4H2A4,   ,4H/)    /
C
C     ELECTRONIC PLOTTER FORMATS.
C
      DATA    NC1   / 16 /
      DATA    C1    / 4H(10X  ,4H,37H   ,4HTHE    ,4HFOLL   ,4HOWIN   ,
     1                4HG PL  ,4HOTS    ,4HARE    ,4HREQU   ,4HESTE   ,
     2                4HD ON  ,4H ,A4   ,4H,A1,   ,4H5H O   ,4HNLY,   ,
     3                4H/)    /
      DATA    NC2   / 17 /
      DATA    C2    / 4H(10X  ,4H,54H   ,4HTHE    ,4HFOLL   ,4HOWIN   ,
     1                4HG PL  ,4HOTS    ,4HARE    ,4HREQU   ,4HESTE   ,
     2                4HD ON  ,4H BOT   ,4HH FI   ,4HLM +   ,4H PAP   ,
     3                4HER,/  ,4H)      /
      DATA    NC3   / 24 /
      DATA    C3    / 4H(10X  ,4H,I1,   ,4H79H    ,4HBLAN   ,4HK FR   ,
     1                4HAMES  ,4H WIL   ,4HL BE   ,4H INS   ,4HERTE   ,
     2                4HD ON  ,4H FIL   ,4HM ON   ,4HLY B   ,4HETWE   ,
     3                4HEN E  ,4HACH    ,4HOF T   ,4HHE F   ,4HOLLO   ,
     4                4HWING  ,4H PLO   ,4HTS,/   ,4H)      /
C
C     ENGINEERING DATA FORMATS.
C
      DATA    ND1   / 11 /
      DATA    D1    / 4H(//3  ,4H3H E   ,4H N G   ,4H I N   ,4H E E   ,
     1                4H R I  ,4H N G   ,4H       ,4HD A    ,4HT A,   ,
     2                4H/)    /
      DATA    ND2   / 6  /
      DATA    D2    / 4H(10X  ,4H,3A4   ,4H,11H   ,4H PRO   ,4HJECT   ,
     1                4HION)  /
      DATA    ND3   / 29 /
      DATA    D3    / 4H(10X  ,4H,29H   ,4HROTA   ,4HTION   ,4HS (D   ,
     1                4HEGRE  ,4HES)    ,4H- GA   ,4HMMA    ,4H=,F7   ,
     2                4H.2,8  ,4HH, B   ,4HETA    ,4H=,F7   ,4H.2,9   ,
     3                4HH, A  ,4HLPHA   ,4H =,F   ,4H7.2,   ,4H10H,   ,
     4                4H  AX  ,4HES =   ,4H ,2A   ,4H1,2(   ,4H1H,,   ,
     5                4H2A1)  ,4H,2H,   ,4H ,4A   ,4H4)     /
     5
      DATA    PRJ   , PLUS    ,MINUS    ,XYZ      ,SYMM     ,BLANK    /
     1                4HORTH  ,4HOGRA   ,4HPHIC   ,4HPERS   ,4HPECT   ,
     2                4HIVE   ,4HSTER   ,4HEOSC   ,4HOPIC   ,1H+,1H-  ,
     3                1HX     ,1HY      ,1HZ      ,4HANTI   ,4HSYMM   ,
     4                4HETRI  ,1HC      ,1H       /
C
C     ORTHOGRAPHIC + PERSPECTIVE ENGINEERING DATA FORMATS.
C
      DATA    NE1   / 12 /
      DATA    E1    / 4H(10X  ,4H,29H   ,4HSCAL   ,4HE (O   ,4HBJEC   ,
     1                4HT-TO  ,4H-PLO   ,4HT SI   ,4HZE)    ,4H=,1P   ,
     2                4H,E13  ,4H.6)    /
      DATA    NE2   / 20 /
      DATA    E2    / 4H(10X  ,4H,29H   ,4HVANT   ,4HAGE    ,4HPOIN   ,
     1                4HT (I  ,4HNCHE   ,4HS) -   ,4H RO    ,4H=,1P   ,
     2                4H,E13  ,4H.6,6   ,4HH, S   ,4H0 =,   ,4HE13.   ,
     3                4H6,6H  ,4H, T0   ,4H =,E   ,4H13.6   ,4H)      /
      DATA    NE3   / 14 /
      DATA    E3    / 4H(10X  ,4H,38H   ,4HPROJ   ,4HECTI   ,4HON P   ,
     1                4HLANE  ,4H SEP   ,4HARAT   ,4HION    ,4H(INC   ,
     2                4HHES)  ,4H =,1   ,4HP,E1   ,4H3.6)   /
      DATA    NE4   / 18 /
      DATA    E4    / 4H(10X  ,4H,6HO   ,4HRIGI   ,4HN,I8   ,4H,11H   ,
     1                4H   -  ,4H   X   ,4H0 =,   ,4H1P,E   ,4H14.6   ,
     2                4H,6H,  ,4H Y0    ,4H=,E1   ,4H4.6,   ,4H5X,8   ,
     3                4HH(IN  ,4HCHES   ,4H))      /
C
C     STEREO ENGINEERING DATA FORMATS.
C
      DATA    NF1   / 22 /
      DATA    F1    / 4H(10X  ,4H,30H   ,4HSCAL   ,4HES -   ,4H (MO   ,
     1                4HDEL-  ,4HTO-P   ,4HLOT    ,4HSIZE   ,4H =,1   ,
     2                4HP,E1  ,4H3.6,   ,4H25H,   ,4H  OB   ,4HJECT   ,
     3                4H-TO-  ,4HMODE   ,4HL SI   ,4HZE =   ,4H,E13   ,
     4                4H.6,1  ,4HH))    /
      DATA    NF2   / 25 /
      DATA    F2    / 4H(10X  ,4H,29H   ,4HVANT   ,4HAGE    ,4HPOIN   ,
     1                4HT (I  ,4HNCHE   ,4HS) -   ,4H R0    ,4H=,1P   ,
     2                4H,E13  ,4H.6,9   ,4HH, S   ,4H0(L)   ,4H =,E   ,
     3                4H13.6  ,4H,9H,   ,4H S0(   ,4HR) =   ,4H,E13   ,
     4                4H.6,6  ,4HH, T   ,4H0 =,   ,4HE13.   ,4H6)     /
      DATA    NF3   / 12 /
      DATA    F3    / 4H(10X  ,4H,28H   ,4HOCUL   ,4HAR S   ,4HEPAR   ,
     1                4HATIO  ,4HN (I   ,4HNCHE   ,4HS) =   ,4H,1P,   ,
     2                4HE13.  ,4H6)     /
      DATA    NF4   / 23 /
      DATA    F4    / 4H(10X  ,4H,6HO   ,4HRIGI   ,4HN,I8   ,4H,14H   ,
     1                4H   -  ,4H   X   ,4H0(L)   ,4H =,1   ,4HP,E1   ,
     2                4H4.6,  ,4H9H,    ,4HX0(R   ,4H) =,   ,4HE14.   ,
     3                4H6,6H  ,4H, Y0   ,4H =,E   ,4H14.6   ,4H,5X,   ,
     4                4H8H(I  ,4HNCHE   ,4HS))    /
C
C     CONTOUR PLOTTING DATA FORMATS
C
      DATA    NG1   / 13 /
     1        G1    / 4H(//4  ,4H2H C   ,4H O N   ,4H T O   ,4H U R   ,
     2                4H   P  ,4H L O   ,4H T T   ,4H I N   ,4H G     ,
     3                4H D A  ,4H T A   ,4H,/)    /
      DATA    NG2   / 11 /
     1        G2    / 4H(9X,  ,4H32HA   ,4HBOVE   ,4H PLO   ,4HT IS   ,
     2                4H A C  ,4HONTO   ,4HUR P   ,4HLOT    ,4HOF ,   ,
     3                4H4A4)  /
      DATA    NG3   / 16 /
     1        G3    / 4H(9X,  ,4H52HT   ,4HHE C   ,4HONTO   ,4HUR V   ,
     2                4HALUE  ,4HS AR   ,4HE CA   ,4HLCUL   ,4HATED   ,
     3                4H AT   ,4HFIBR   ,4HE DI   ,4HSTAN   ,4HCE ,   ,
     4                4H3A4)  /
      DATA    NG4   / 6  /
     1        G4    / 4H(9X,  ,4H4HIN   ,4H A,2   ,4HA4,6   ,4HHSYS   ,
     2                4HTEM)  /
      DATA    NG5   / 11 /
     1        G5    / 4H(//,  ,4H51X,   ,4H28HT   ,4HABLE   ,4H  OF   ,
     2                4H  PL  ,4HOTTI   ,4HNG     ,4HSYMB   ,4HOLS,   ,
     3                4H/)    /
      DATA    NG6   / 8  /
     1        G6    / 4H(5(5  ,4HX,13   ,4HHSYM   ,4HBOL    ,4H VAL   ,
     2                4HUE,6  ,4HX),/   ,4H)      /
      DATA    NG7   / 4  /
     1        G7    / 4H(5(I  ,4H9,1P   ,4H,E15   ,4H.6))   /
C
      DATA    NH1   / 11 /
      DATA    H1    / 4H(//5  ,4H0X,2   ,4H9HPL   ,4HOT M   ,4HODUL   ,
     1                4HE ME  ,4HSSAG   ,4HES C   ,4HONTI   ,4HNUE    ,
     2                4H,/)   /
C
      DATA   STRAIN / 4HSTRA  ,4HIN E   ,4HNERG   ,4HIES    /,
     1       DIST   / 4H Z2   ,2*1H     ,4H Z1    ,2*1H     ,4HMAX    ,
     2                4H- Z1  ,4H,Z2    ,4HAVER   ,4H-Z1,   ,4HZ2     /,
     3       WAY    / 4H LOC  ,4HAL     ,4H COM   ,4HMON    /
C
      DATA   SPACE  / 4H      /
     1       DISPLA / 4HDEFO  ,4HRMAT   ,4HION    ,1HX,1HY,1HZ, 3HMAG ,
     2                3*0     /
C
C                              1              3
      DATA   STRESS /       4HSTRE,4HSS,  ,4HSHEA,4HR -  ,
C               5 (1)          7 (2)          9 (3)         11 (4)
     1       4HMAJO,4HR-PR ,4HMINO,4HR-PR ,4HMAXI,4HMUM  ,4HNORM,4HAL X,
C              13 (5)         15 (6)         17     18      19
     2       4HNORM,4HAL Y ,4HNORM,4HAL Z ,4HXY  ,4HXZ   ,4HYZ   ,
C              20 (14)        22 (15)        24(16)         26 (17)
     3       4HNORM,4HAL 1 ,4HNORM,4HAL 2 ,4HSHEA,4HR 12 ,4HSHEA,4HR 1Z,
C              28 (18)        30 (19)        32             34
     4       4HSHEA,4HR 1Z ,4HBOND,4HSH12 ,4HLAYE,4HR NU ,4HMBER /
C
      DATA   ILAY   / 4H  1 ,4H  2 ,4H  3 ,4H  4 ,4H  5 ,4H  6 ,
     1                4H  7 ,4H  8 ,4H  9 ,4H 10 ,4H 11 ,4H 12 ,
     2                4H 13 ,4H 14 ,4H 15 ,4H 16 ,4H 17 ,4H 18 ,
     3                4H 19 ,4H 20 /
C
      IF (NCNTR .GT. 0) GO TO 201
C
C     PRINT THE PLOTTER ID.
C
      LIST(1) = 0
      CALL WRITE  (PRNT,LIST,1,0)
      CALL WRTPRT (PRNT,LIST,A1,NA1)
C
C     NASTRAN GENERAL PURPOSE PLOTTER.
C
      LIST(1) = 5
      J = IABS(PLTYPE)
      DO 126 I = 1,3
      LIST(I+1) = PLTTYP(I,J)
  126 CONTINUE
      MM = 1
      IF (PLTYPE .LT. 0) MM = 3
      LIST(5) = ITYPE(MM  )
      LIST(6) = ITYPE(MM+1)
      CALL WRTPRT (PRNT,LIST,P6,NP6)
C
C     GENERAL PLOTTER INFORMATION.
C
      IF (TAPDEN .LE. 0) GO TO 151
      LIST(1) = 1
      LIST(2) = TAPDEN
      CALL WRTPRT (PRNT,LIST,A2,NA2)
  151 IF (EOF .NE. 0) GO TO 152
      CALL WRTPRT (PRNT,0,A3,NA3)
      GO TO 154
  152 CALL WRTPRT (PRNT,0,A4,NA4)
  154 CALL WRTPRT (PRNT,0,A5,NA5)
      LIST(1) = 1
      ALST(2) = CSCALE
      CALL WRTPRT (PRNT,LIST,A6,NA6)
      IF (IABS(PLTYPE)-2) 170,160,163
C
C     TABLE PLOTTER INFORMATION.
C
  160 LIST(1) = 1
      ALST(2) = CNTSIN
      CALL WRTPRT (PRNT,LIST,B1,NB1)
  163 LIST(1) = 4
      ALST(2) = PAPSIZ(1)
      ALST(3) = PAPSIZ(2)
      LIST(4) = PAPTYP(1)
      LIST(5) = PAPTYP(2)
      CALL WRTPRT (PRNT,LIST,B2,NB2)
C
      LIST(1) = 4
      N = MIN0(NPENS,NOPENS)
      DO 168 I = 1,N
      LIST(2) = I
      LIST(3) = PENSIZ(I)
      IF (LIST(3) .LT. 0) GO TO 168
      LIST(4) = PENCLR(I,1)
      LIST(5) = PENCLR(I,2)
      IF (LIST(4).EQ.BLANK .AND. LIST(5).EQ.BLANK) GO TO 168
      CALL WRTPRT (PRNT,LIST,B5,NB5)
  168 CONTINUE
      CALL WRTPRT (PRNT,0,SKIP,NSKIP)
      GO TO 180
C
C     ELECTRONIC PLOTTER INFORMATION.
C
  170 IF (CAMERA-2) 171,172,174
  171 LIST(2) = FILM(1)
      LIST(3) = FILM(2)
      GO TO 173
  172 LIST(2) = PAPER(1)
      LIST(3) = PAPER(2)
  173 LIST(1) = 2
      CALL WRTPRT (PRNT,LIST,C1,NC1)
      GO TO 175
  174 CALL WRTPRT (PRNT,0,C2,NC2)
  175 IF (CAMERA.EQ.2 .OR. BFRAMS.EQ.0) GO TO 180
      LIST(1) = 1
      LIST(2) = BFRAMS
      CALL WRTPRT (PRNT,LIST,C3,NC3)
C
C     ENGINEERING DATA.
C
  180 CALL WRTPRT (PRNT,0,D1,ND1)
      LIST(1) = 3
      DO 181 I = 1,3
      LIST(I+1) = PRJ(I,PRJECT)
  181 CONTINUE
      CALL WRTPRT (PRNT,LIST,D2,ND2)
C
      LIST(1) = 13
      ALST(2) = VANGLE(3)
      IF (VANGLE(2) .GT. -1.E10) GO TO 1815
      IF (PRJECT .NE. 2) VANGLE(2) = VANGLE(4)
      IF (PRJECT .EQ. 2) VANGLE(2) = VANGLE(5)
 1815 ALST(3) = VANGLE(2)
      ALST(4) = VANGLE(1)
      DO 182 I = 1,3
      J = 2*I + 3
      K = IABS(AXIS(I))
      LIST(J) = PLUS
      IF (AXIS(I) .LT. 0) LIST(J) = MINUS
      LIST(J+1) = XYZ(K)
  182 CONTINUE
      N = 1
      IF (AXIS(1) .EQ. DAXIS(1)) N = 2
      LIST(14) = BLANK
      J = 1
      DO 183 I = N,4
      LIST(J+10) = SYMM(I)
      J = J + 1
  183 CONTINUE
      CALL WRTPRT (PRNT,LIST,D3,ND3)
      IF (PRJECT .EQ. 3) GO TO 195
C
C     ORTHOGRAPHIC + PERSPECTIVE ENGINEERING DATA.
C
      LIST(1) = 1
      ALST(2) = SCALE(1)/CNTSIN
      CALL WRTPRT (PRNT,LIST,E1,NE1)
      IF (PRJECT .EQ. 1) GO TO 191
      LIST(1) = 3
      ALST(2) = R0
      ALST(3) = S0L
      ALST(4) = T0
      CALL WRTPRT (PRNT,LIST,E2,NE2)
      LIST(1) = 1
      ALST(2) = D0
      CALL WRTPRT (PRNT,LIST,E3,NE3)
C
  191 CALL WRTPRT (PRNT,0,SKIP,NSKIP)
      LIST(1) = 3
      DO 192 I = 1,ORG
      LIST(2) = ORIGIN(I)
      ALST(3) = XY(I,1)/CNTSIN
      ALST(4) = XY(I,3)/CNTSIN
      CALL WRTPRT (PRNT,LIST,E4,NE4)
  192 CONTINUE
      GO TO 260
C
C     STEREO ENGINEERING DATA.
C
  195 LIST(1) = 2
      ALST(2) = SCALE(1)/CNTIN3
      ALST(3) = SCALE(2)
      CALL WRTPRT (PRNT,LIST,F1,NF1)
      LIST(1) = 4
      ALST(2) = R0
      ALST(3) = S0L
      ALST(4) = S0R
      ALST(5) = T0
      CALL WRTPRT (PRNT,LIST,F2,NF2)
      LIST(1) = 1
      ALST(2) = D0
      CALL WRTPRT (PRNT,LIST,E3,NE3)
      ALST(2) = S0S
      CALL WRTPRT (PRNT,LIST,F3,NF3)
C
      CALL WRTPRT (PRNT,0,SKIP,NSKIP)
      LIST(1) = 4
      DO 196 I = 1,ORG
      LIST(2) = ORIGIN(I)
      ALST(3) = XY(I,1)/CNTSIN
      ALST(4) = XY(I,2)/CNTSIN
      ALST(5) = XY(I,3)/CNTSIN
      CALL WRTPRT (PRNT,LIST,F4,NF4)
  196 CONTINUE
      GO TO 260
C
C     CONTOUR PLOTTING DATA
C
  201 LIST(1) = 0
      CALL WRTPRT (PRNT,LIST,G1,NG1)
      LIST(1) = 4
      IF (ICNTVL.GT.9 .AND. ICNTVL.LT.14) GO TO 210
C
C     STRESS CONTOURS
C
      I = 1
      IF (ICNTVL.GT. 6 .OR. ICNTVL.EQ. 3) I = 3
      IF (ICNTVL.GE.14 .AND.ICNTVL.LE.19) I = 1
      IF (ICNTVL .NE. 20) GO TO 203
C
C     STRAIN CONTOURS
C
      LIST(1) = 4
      LIST(2) = STRAIN(1)
      LIST(3) = STRAIN(2)
      LIST(4) = STRAIN(3)
      LIST(5) = STRAIN(4)
      CALL WRTPRT (PRNT,LIST,G2,NG2)
      GO TO 205
C
  203 LIST(2) = STRESS(I)
      LIST(3) = STRESS(I+1)
      I = ICNTVL*2 + 3
      IF (ICNTVL.GT.13 .AND. ICNTVL.LT.20) I = (ICNTVL-14)*2 + 20
      IF (ICNTVL.GT. 6 .AND. ICNTVL.LE. 9) I = ICNTVL + 10
      LIST(4) = STRESS(I)
      LIST(5) = SPACE
      IF (ICNTVL.LT.7 .OR. ICNTVL .GE.14) LIST(5) = STRESS(I+1)
      CALL WRTPRT (PRNT,LIST,G2,NG2)
C
C     ADDING LAYER NUMBER TO OUTPUT WHEN REQUESTED
C
      IF (ICNTVL.LT.14 .OR. ICNTVL.EQ.20) GO TO 204
      LIST(1) = 4
      LIST(2) = STRESS(32)
      LIST(3) = STRESS(33)
      LIST(4) = STRESS(34)
      LIST(5) = ILAY(LAYER)
      CALL WRTPRT (PRNT,LIST,G2,NG2)
      GO TO 205
C
  204 LIST(1) = 3
      I = IWHERE
      IF (IWHERE .LE. 0) I = 0
      I = I*3 + 1
      LIST(2) = DIST(I)
      LIST(3) = DIST(I+1)
      LIST(4) = DIST(I+2)
      CALL WRTPRT (PRNT,LIST,G3,NG3)
C
  205 J = 2*(IDIREC-1) + 1
      GO TO 220
C
C     DISPLACEMENT CONTOURS
C
  210 I = 1
      LIST(2) = DISPLA(I  )
      LIST(3) = DISPLA(I+1)
      LIST(4) = DISPLA(I+2)
      LIST(5) = DISPLA(ICNTVL-6)
      CALL WRTPRT (PRNT,LIST,G2,NG2)
      J = 3
  220 IF (ICNTVL.LT.4 .OR. ICNTVL.EQ.13) GO TO 235
      LIST(1) = 2
      LIST(2) = WAY(J  )
      LIST(3) = WAY(J+1)
      CALL WRTPRT (PRNT,LIST,G4,NG4)
  235 LIST(1) = 0
      CALL WRTPRT (PRNT,LIST,G5,NG5)
      CALL WRTPRT (PRNT,LIST,G6,NG6)
      L = (NCNTR-1)/10 + 1
      LIST(1) = 2*L
      K = MIN0(NCNTR,10)
      DO 250 J = 1,K
      N = J + (L-1)*10
      M = 2
      DO 240 I = J,N,10
      IF (I .GT. NCNTR) GO TO 245
      LIST(M  ) = I
      ALST(M+1) = CNTR(I)
  240 M = M + 2
      GO TO 247
  245 LIST(1) = LIST(1) - 2
      L = L - 1
  247 CALL WRTPRT (PRNT,LIST,G7,NG7)
  250 CONTINUE
C
  260 LIST(1) = 0
      CALL WRTPRT (PRNT,LIST,H1,NH1)
      RETURN
      END

      SUBROUTINE SMA1
C*****
C THIS ROUTINE IS A DRIVER AND INITIALIZATION PROGRAM FOR MODULE
C 2.4.1 OF THE NASTRAN SYSTEM.  IT GENERATES THE STIFFNESS MATRIX, KGG,
C THE STRUCTURAL DAMPING MATRIX, K4GG, AND THE GRID POINT SINGULARITY
C TABLE, GPST.
C*****
      DOUBLE PRECISION
     1                   DZ                 ,DPDUM
C
      INTEGER
     1                   IZ(1)              ,EOR
     2,                  CLSRW              ,CLSNRW
     3,                  FROWIC
     4,                  TNROWS             ,OUTRW
     5,                  OPTION
C
      LOGICAL           ANYTAB        ,LINEAR
      LOGICAL            DODET              ,HEAT
C
      DIMENSION
     1                   NMSMA1(2)
      DIMENSION IBUF(7)
C
      COMMON /BLANK/  NOGENL             ,NOK4GG   ,OPTION(2)
      COMMON   /SYSTEM/  ISYS,SKIP(53),IPREC,ITHERM
C
C SMA1 I/O PARAMETERS
C
      COMMON   /SMA1IO/
     1                   IFCSTM             ,IFMPT
     2,                  IFDIT              ,IDUM1
     3,                  IFECPT             ,IGECPT
     4,                  IFGPCT             ,IGGPCT
     5,                  IFGEI              ,IGGEI
     6,                  IFKGG              ,IGKGG
     7,                  IF4GG              ,IG4GG
     8,                  IFGPST             ,IGGPST
     9,                  INRW               ,OUTRW
     T,                  CLSNRW             ,CLSRW
     1,                  NEOR               ,EOR
     2,                  MCBKGG(7)          ,MCB4GG(7)
C
C SMA1 VARIABLE CORE
C
      COMMON   /ZZZZZZ /  Z(1)
C
C SMA1 VARIABLE CORE BOOKKEEPING PARAMETERS
C
      COMMON   /SMA1BK/
     1                   ICSTM              ,NCSTM
     2,                  IGPCT              ,NGPCT
     3,                  IPOINT             ,NPOINT
     4,                  I6X6K              ,N6X6K
     5,                  I6X64              ,N6X64
C
C SMA1 PROGRAM CONTROL PARAMETERS
C
      COMMON   /SMA1CL/
     1                   IOPT4              ,K4GGSW
     2,                  NPVT               ,LEFT
     3,                  FROWIC             ,LROWIC
     4,                  NROWSC             ,TNROWS
     5,                  JMAX               ,NLINKS
     6,                  LINK(10)           ,IDETCK
     7,                  DODET              ,NOGO
C
C ELEMENT DATA
C
      COMMON /GPTA1/ NELEMS, LAST, INCR, NE(1)
C
C ECPT COMMON BLOCK
C
      COMMON   /SMA1ET/
     1                   ECPT(100)
C
C SCRATCH COMMON BLOCK USED BY ELEMENT ROUTINES.
C
      COMMON   /SMA1DP/
     1                   DPDUM(300)
C
C COMMON INTERFACE FOR HMAT -HEAT- MATERIAL ROUTINE.
C
      COMMON /HMATDD/ IHMAT,NHMAT,MPTMPT,IDIT,LINEAR,ANYTAB
C
      COMMON   /SMA1HT/  HEAT
C
      EQUIVALENCE
     1                   (Z(1),IZ(1),DZ)
C
      DATA
     1                   NMSMA1(1) /4HSMA1/ ,NMSMA1(2) /4H    /
C*****
C  SET THE LOGICAL HEAT FLAG IF THIS IS A -HEAT- FORMULATION
C*****
      CALL DELSET
      LINEAR =.TRUE.
      OPTION(1) = -1
      HEAT = .FALSE.
      IF( ITHERM .NE. 0 )   HEAT = .TRUE.
C
      IZMAX = KORSZ(Z)
C
C IF NOGENL .GT. 0, GENERAL ELEMENTS EXIST AND HENCE THE GPST IS NOT
C CREATED AND SO DETCK WILL NOT BE CALLED.
C
      DODET = .TRUE.
      IF (NOGENL .GT. 0) DODET = .FALSE.
      IBUF(1) = IFECPT
      CALL RDTRL(IBUF(1))
      IF (IBUF(3).EQ.1) DODET = .FALSE.
C
C SET K4GG PURGE FLAGS
C
      NOK4GG = -1
      K4GGSW = -1
C
C ATTEMPT TO OPEN THE OUTPUT FILE FOR THE KGG  MATRIX.  IF IT IS NOT
C IN THE OSCAR, EXECUTION WILL BE TERMINATED SINCE WE DO NOT ALLOW
C THE USER TO GENERATE ONLY A K4GG.
C
      IGKGG = IZMAX - ISYS
      CALL OPEN(*100,IFKGG,Z(IGKGG),OUTRW)
C
C WRITE A TWO WORD BCD HEADER AND CLOSE THE KGG FILE WITHOUT REWIND.
C
      CALL FNAME (IFKGG,Z(1))
      CALL WRITE (IFKGG,Z(1),2,EOR)
      CALL CLOSE (IFKGG,CLSNRW)
C
C ATTEMPT TO OPEN THE K4GG FILE.
C
      IG4GG = IGKGG
      IOPT4 = 0
      CALL OPEN(*10,IF4GG,Z(IG4GG),OUTRW)
      IOPT4 = 1
      IG4GG = IG4GG - ISYS
      CALL FNAME (IF4GG,Z(1))
      CALL WRITE (IF4GG,Z(1),2,EOR)
      CALL CLOSE(IF4GG,CLSNRW)
C
C SET UP POINTERS TO GINO BUFFERS AND SET UP MATRIX CONTROL BLOCKS.
C
   10 IGECPT = IG4GG - ISYS
      IGGPCT = IGECPT - ISYS
      IGGPST = IGGPCT - ISYS
      IF (.NOT. DODET) IGGPST = IGGPST + ISYS
      MCBKGG(1) = IFKGG
      MCBKGG(2) = 0
      MCBKGG(3) = 0
      MCBKGG(4) = 6
      MCBKGG(5) = IPREC
      MCBKGG(6) = 0
      MCBKGG(7) = 0
      IF (IOPT4 .EQ. 0) GO TO 30
      MCB4GG(1) = IF4GG
      DO 20 I = 2,7
   20 MCB4GG(I) = MCBKGG(I)
C
C ATTEMPT TO READ THE CSTM INTO CORE.
C
   30 NCSTM = 0
      ICSTM = 0
      LEFT = IGGPST - 1
      CALL OPEN(*50,IFCSTM,Z(IGKGG),INRW)
      CALL FWDREC(*9020,IFCSTM)
      CALL READ(*9030,*40,IFCSTM,Z(1),LEFT,EOR,NCSTM)
C
C IF CORE WAS FILLED WITHOUT HITTING AN EOR CALL MESAGE
C
      CALL MESAGE (-8,IFCSTM,IFCSTM)
   40 LEFT = LEFT - NCSTM
C
C PRETRD SETS UP FUTURE CALLS TO TRANSD.
C
      CALL PRETRD (Z(ICSTM+1),NCSTM)
      CALL PRETRS(Z(ICSTM+1),NCSTM)
      CALL CLOSE (IFCSTM,CLSRW)
   50 IMAT1 = NCSTM
      NMAT1 = 0
      NMAT2 = 0
      NMAT3 = 0
      NMAT4 = 0
C
C CALL PREMAT TO READ MPT AND THE DIT INTO CORE
C
      IMAT11 = IMAT1 + 1
C*****
C  IF THIS IS A -HEAT- PROBLEM THE HMAT ROUTINE IS USED TO READ MAT4 AND
C  MAT5 CARDS INTO CORE.
C*****
      IF( .NOT. HEAT ) GO TO 56
      IHMAT = IMAT11 + 1
      NHMAT = IMAT11 + LEFT - 2
      MPTMPT = IFMPT
      IDIT = IFDIT
      CALL HMAT( 0 )
      LEFT = LEFT - NHMAT + IHMAT
      IGPCT = NHMAT + 1
      GO TO 58
C*****
C  NORMAL PREMAT PROCESSING.
C*****
   56 CALL PREMAT (IZ(IMAT11),Z(IMAT11),Z(IGKGG),LEFT,MATCR,IFMPT,IFDIT)
      LEFT = LEFT - MATCR
      IGPCT = NCSTM + MATCR
C
C OPEN THE ECPT AND GPCT INPUT FILES AND THE GPST OUTPUT FILE.
C
   58 CALL OPEN(*9070,IFECPT,Z(IGECPT),INRW)
      CALL FWDREC(*9080,IFECPT)
      CALL OPEN(*9090,IFGPCT,Z(IGGPCT),INRW)
      CALL FWDREC(*9100,IFGPCT)
      IF (.NOT. DODET) GO TO 60
      CALL OPEN(*9110,IFGPST,Z(IGGPST),OUTRW)
      CALL FNAME(IFGPST,ECPT(1))
      CALL WRITE(IFGPST,ECPT(1),2,EOR)
C
C REOPEN THE KGG OUTPUT FILE WITHOUT REWIND, AND THE K4GG, IF CALLED FOR
C
   60 CALL OPEN(*9120,IFKGG,Z(IGKGG),3)
      IF(IOPT4.NE.0)CALL OPEN(*9130,IF4GG,Z(IG4GG),3)
C
C CALL SUBROUTINE SMA1A WHICH WILL PERFORM ALL THE COMPUTATIONS.
C
      CALL SMA1A
      IF(.NOT. LINEAR) OPTION(1)= 1
C
C CLOSE FILES AND WRITE TRAILERS.
C
      CALL CLOSE(IFECPT,CLSRW)
      CALL CLOSE(IFGPCT,CLSRW)
      IF (.NOT. DODET) GO TO 70
      CALL CLOSE (IFGPST,CLSRW)
      CALL WRTTRL (IFGPST)
   70 CALL CLOSE (IFKGG,CLSRW)
      MCBKGG(3) = MCBKGG(2)
      CALL WRTTRL (MCBKGG(1))
      IF (IOPT4 .EQ. 0) GO TO 100
      CALL CLOSE(IF4GG,CLSRW)
      IF (MCB4GG(6) .EQ. 0) GO TO 80
      MCB4GG(3) = MCB4GG(2)
      CALL WRTTRL (MCB4GG(1))
      NOK4GG = 1
      GO TO 100
   80 DO 90 I = 2,7
   90 MCB4GG(I) = 0
      NOK4GG = -1
  100 RETURN
C
C SUBROUTINE SMA1 ERROR EXITS.
C
 9020 IFILE = IFCSTM
      GO TO 10002
 9030 IFILE = - IFCSTM
      GO TO 10002
 9070 IFILE = IFECPT
      GO TO 10001
 9080 IFILE = IFECPT
      GO TO 10002
 9090 IFILE = IFGPCT
      GO TO 10001
 9100 IFILE = IFGPCT
      GO TO 10002
 9110 IFILE = IFGPST
      GO TO 10001
 9120 IFILE = IFKGG
      GO TO 10001
 9130 IFILE = IF4GG
10001 IPARM = -1
      GO TO 10010
10002 IPARM = -2
10010 CALL MESAGE (IPARM,IFILE,NMSMA1(1))
      RETURN
      END

      SUBROUTINE PROMPT
C
C     DRIVER FOR  INTERACTIVE MODULE - PROMPT
C
C        PROMPT    //S,N,PEXIT/S,N,PLOT1/S,N,PLOT2/S,N,XYPLOT/
C                    S,N,SCAN1/S,N,SCAN2/DUM1/DUM2/DUM3/DUM4 $
C
      IMPLICIT INTEGER  (A-Z)
      COMMON /BLANK / PARAM(10)
      COMMON /SYSTEM/ KSYSM(100)
      EQUIVALENCE     (NOUT ,KSYSM(2)),  (SOLN ,KSYSM(22)),
     1                (IN   ,KSYSM(4)),  (INTRA,KSYSM(86))
      DATA    P,S,C,B / 1HP, 1HS, 1HC, 1H /
C
      INTRA=IABS(INTRA)
      NOUT = 6
      DO 10 I=1,10
 10   PARAM(I)=0
C
 20   WRITE (NOUT,110)
      READ (IN,130,ERR=20) J
      IF (J.LT.1 .OR. J.GT.6) GO TO 20
      IF (SOLN.EQ.3 .AND. (J.EQ.4 .OR. J.EQ.6)) GO TO 70
      PARAM(J)=-1
      IF (J .EQ. 1) RETURN
 40   WRITE (NOUT,120)
      I=B
      READ (IN,140,END=50) I
 50   IF (I .EQ. B) RETURN
      IF (I .EQ. C) GO TO 60
      IF (I.NE.P .AND. I.NE.S) GO TO 40
      IF (I .EQ. S) INTRA = MOD(INTRA,10)
      IF (I .EQ. P) INTRA = MOD(INTRA,10) + 10
      RETURN
C
 60   PARAM(J)=0
      GO TO 20
 70   WRITE (NOUT,80) J,SOLN
 80   FORMAT (/,' OPTION',I3,' IS NOT AVAILABLE FOR SOLUTION',I3)
      GO TO 20
C
 110  FORMAT (9X,'1. EXIT',
     1       /9X,'2. STRUCTURE PLOTS - UNDEFORMED',
     3       /9X,'3. STRUCTURE PLOTS - DEFORMED',
     4       /9X,'4. XYPLOTS',
     5       /9X,'5. SCAN OUTPUT - SORT1',
     6       /9X,'6. SCAN OUTPUT - SORT2',
     7       //9X,'SELECT ONE OPTION FROM MENU -')
 120  FORMAT (/9X,'OUTPUT TO SCREEN, OR TO PRINTFILE, OR CANCEL OPTION (
     1S/P/C) -')
 130  FORMAT (I1)
 140  FORMAT (A1)
      END

      SUBROUTINE SSOLD1(ITYPE)
C*****
C
C  E C P T     TETRA          WEDGE          HEXA
C  -----------------------------------------------
C  ECPT( 1) =  EL ID          EL ID          EL ID
C  ECPT( 2) =  MAT-ID         MAT-ID         MAT-ID
C  ECPT( 3) =  GRID-1         GRID-1         GRID-1
C  ECPT( 4) =  GRID-2         GRID-2         GRID-2
C  ECPT( 5) =  GRID-3         GRID-3         GRID-3
C  ECPT( 6) =  GRID-4         GRID-4         GRID-4
C  ECPT( 7) =  CSID-1         GRID-5         GRID-5
C  ECPT( 8) =  X1             GRID-6         GRID-6
C  ECPT( 9) =  Y1             CSID-1         GRID-7
C  ECPT(10) =  Z1             X1             GRID-8
C  ECPT(11) =  CSID-2         Y1             CSID-1
C  ECPT(12) =  X2             Z1             X1
C  ECPT(13) =  Y2             CSID-2         Y1
C  ECPT(14) =  Z2             X2             Z1
C  ECPT(15) =  CSID-3         Y2             CSID-2
C  ECPT(16) =  X3             Z2             X2
C  ECPT(17) =  Y3             CSID-3         Y2
C  ECPT(18) =  Z3             X3             Z2
C  ECPT(19) =  CSID-4         Y3             CSID-3
C  ECPT(20) =  X4             Z3             X3
C  ECPT(21) =  Y4             CSID-4         Y3
C  ECPT(22) =  Z4             X4             Z3
C  ECPT(23) =  EL-TEM         Y4             CSID-4
C  ECPT(24)                   Z4             X4
C  ECPT(25)                   CSID-5         Y4
C  ECPT(26)                   X5             Z4
C  ECPT(27)                   Y5             CSID-5
C  ECPT(28)                   Z5             X5
C  ECPT(29)                   CSID-6         Y5
C  ECPT(30)                   X6             Z5
C  ECPT(31)                   Y6             CSID-6
C  ECPT(32)                   Z6             X6
C  ECPT(33)                   ELTEMP         Y6
C  ECPT(34)                                  Z6
C  ECPT(35)                                  CSID-7
C  ECPT(36)                                  X7
C  ECPT(37)                                  Y7
C  ECPT(38)
C  ECPT(39)                                  CSID-8
C  ECPT(40)                                  X8
C  ECPT(41)                                  Y8
C  ECPT(42)                                  Z8
C  ECPT(43)                                  EL-TEMP
C*****
      REAL NU
      INTEGER NECPT(100),NPHI(170), M(14,4)
C
      COMMON / SDR2X5/ ECPT(100),PHIOUT(170)
      COMMON / SDR2X6 /       CMAT(18,8)         ,BETA(8)
     1                       ,TEMP(18)           ,ELVOL
     2                       ,VOL                ,FACT
     3                       ,NPTS               ,NEL
     4                       ,MFIRST             ,NROW
     5                       ,ITEST              ,FLOC
     6                       ,J1                 ,JLOC
     7                       ,KPT                ,NTEMP
     8                       ,GE(36)             ,H(4,4)
     9                       ,R(3,3)             ,TI(9)
      COMMON / MATIN / NMAT,MATFLG,ELTEMP
      COMMON / MATOUT/ E,G,NU,RHO,ALFA,TEMPO
C
      EQUIVALENCE (NPHI(1),PHIOUT(1))
      EQUIVALENCE (NECPT(1),ECPT(1))
C
      DATA  M( 1,1),M( 1,2),M( 1,3),M( 1,4)/ 1   ,2   ,3   ,4 /
C
      DATA  M( 2,1),M( 2,2),M( 2,3),M( 2,4)/ 1   ,2   ,3   ,6 /
      DATA  M( 3,1),M( 3,2),M( 3,3),M( 3,4)/ 1   ,2   ,6   ,5 /
      DATA  M( 4,1),M( 4,2),M( 4,3),M( 4,4)/ 1   ,4   ,5   ,6 /
C
      DATA  M( 5,1),M( 5,2),M( 5,3),M( 5,4)/ 1   ,2   ,3   ,6 /
      DATA  M( 6,1),M( 6,2),M( 6,3),M( 6,4)/ 1   ,3   ,4   ,8 /
      DATA  M( 7,1),M( 7,2),M( 7,3),M( 7,4)/ 1   ,3   ,8   ,6 /
      DATA  M( 8,1),M( 8,2),M( 8,3),M( 8,4)/ 1   ,5   ,6   ,8 /
      DATA  M( 9,1),M( 9,2),M( 9,3),M( 9,4)/ 3   ,6   ,7   ,8 /
      DATA  M(10,1),M(10,2),M(10,3),M(10,4)/ 2   ,3   ,4   ,7 /
      DATA  M(11,1),M(11,2),M(11,3),M(11,4)/ 1   ,2   ,4   ,5 /
      DATA  M(12,1),M(12,2),M(12,3),M(12,4)/ 2   ,4   ,5   ,7 /
      DATA  M(13,1),M(13,2),M(13,3),M(13,4)/ 2   ,5   ,6   ,7 /
      DATA  M(14,1),M(14,2),M(14,3),M(14,4)/ 4   ,5   ,7   ,8 /
C
      GO TO (100,110,120,130),ITYPE
C*****
C     THE TYPE OF THE ELEMENT DETERMINES THE FOLLOWING PARAMETERS
C*****
  100 NPTS  =4
      NEL   =1
      MFIRST=1
      GO TO 140
  110 NPTS  =6
      NEL   =3
      MFIRST=2
      GO TO 140
  120 NPTS  =8
      NEL   =5
      MFIRST=5
      GO TO 140
  130 NPTS  =8
      NEL   =10
      MFIRST=5
  140 CONTINUE
C*****
C     ZERO OUT ARRAYS
C*****
      ELVOL =0.0
      DO 200  J =1,NPTS
      BETA(J) =0.0
      DO 200  I =1,18
      CMAT(I,J) = 0.0
  200 CONTINUE
C*****
C     LOOP ON SUBELEMENTS
C*****
      DO 1000 ME =1,NEL
      NROW = MFIRST +ME -1
C*****
C     J  CORRESPONDS TO THE X,Y,AND Z LOCATIONS OF EACH CONNECTED POINT
C*****
      DO 400 J =1,3
      J1 = M(NROW,1)*4 +NPTS +J -1
C*****
C     I  CORRESPONDS TO POINTS 2,3,AND 4
C*****
      DO 400 I= 1,3
      JLOC = M(NROW,I+1)*4 + NPTS + J - 1
C*****
C     ECPT(JLOC) IS THE JTH COMPONENT OF POINT I+1
C*****
  400 R(I,J) = ECPT(JLOC) -ECPT(J1)
C*****
C     INVERT THE GEOMETRY MATRIX EXPLICITLY USING VECTOR OPERATORS
C*****
      CALL SAXB(   R(1,3),R(1,2),TEMP)
      H(2,1) = TEMP(1) + TEMP(2) + TEMP(3)
      H(2,2) = R(2,2)*R(3,3) -R(3,2)*R(2,3)
      H(2,3) = R(3,2)*R(1,3) -R(1,2)*R(3,3)
      H(2,4) = R(1,2)*R(2,3) -R(2,2)*R(1,3)
      CALL SAXB(   R(1,1),R(1,3),TEMP)
      H(3,1) = TEMP(1)+ TEMP(2) +TEMP(3)
      H(3,2) = R(2,3)*R(3,1) -R(3,3)*R(2,1)
      H(3,3) = R(3,3)*R(1,1) -R(1,3)*R(3,1)
      H(3,4) = R(1,3)*R(2,1) -R(2,3)*R(1,1)
      CALL SAXB(   R(1,1),R(1,2),TEMP)
      H(4,1) =-TEMP(1) -TEMP(2)-TEMP(3)
      H(4,2) = R(2,1)*R(3,2) -R(3,1)*R(2,2)
      H(4,3) = R(3,1)*R(1,2) -R(1,1)*R(3,2)
      H(4,4) = R(1,1)*R(2,2) -R(2,1)*R(1,2)
      VOL =   (R(1,3)*TEMP(1) + R(2,3)*TEMP(2) +R(3,3)*TEMP(3))/6.0
      ELVOL = ELVOL +VOL
      DO 500 I = 1,4
      KPT = M(NROW,I)
      BETA(KPT) = BETA(KPT) + VOL
      CMAT(1, KPT) = H(2,I)/6.0  + CMAT(1 ,KPT)
      CMAT(5, KPT) = H(3,I)/6.0  + CMAT(5 ,KPT)
      CMAT(9, KPT) = H(4,I)/6.0  + CMAT(9 ,KPT)
      CMAT(11,KPT) = H(4,I)/6.0  + CMAT(11,KPT)
      CMAT(12,KPT) = H(3,I)/6.0  + CMAT(12,KPT)
      CMAT(13,KPT) = H(4,I)/6.0  + CMAT(13,KPT)
      CMAT(15,KPT) = H(2,I)/6.0  + CMAT(15,KPT)
      CMAT(16,KPT) = H(3,I)/6.0  + CMAT(16,KPT)
      CMAT(17,KPT) = H(2,I)/6.0  + CMAT(17,KPT)
  500 CONTINUE
 1000 CONTINUE
C*****
C     END OF ELEMENT LOOP
C*****
C*****
C     CMAT CONTAINS THE SUM OF THE STRAIN -DISPLACEMENT MATRICES
C                       TIMES THE VOLUME OF THE CONNECTED TETRAHEDRON
C
C     CALL THE MATERIAL  ROUTINE TO OBTAIN PARAMETERS
C*****
      NMAT = NECPT(2)
      MATFLG =1
      ELTEMP = ECPT(5*NPTS+3)
      CALL MAT (ECPT(1))
      FACT = E /((1.0+NU)*(1.0-2.0*NU) )
      DO 1010 I = 1,36
 1010 GE(I) = 0.0
      GE(1) = FACT*(1.0-NU)
      GE(2) = FACT* NU
      GE(3) = GE(2)
      GE(7) = GE(2)
      GE(8) = GE(1)
      GE(9) = GE(2)
      GE(13)= GE(2)
      GE(14)= GE(2)
      GE(15)= GE(1)
      GE(22)= G
      GE(29)= G
      GE(36)= G
C*****
C     EACH CMAT MATRIX IS PREEMULTIPLIED BY THE STRESS-STRAIN GE MATRIX
C         AND DIVIDED BY THE SUM OF THE VOLUMES.
C     IF NECESSARY THE MATRIX IS POST-MULTIPLIED BY A GLOBAL TRANSFORM T
C
C     LOOP ON GRID POINTS
C*****
      DO 2000 I =1,NPTS
      NPHI(I+1) = NECPT(I+2)
      K= NPTS+I +8
      PHIOUT(K) =  BETA(I)/(4.0*ELVOL)
      ICORD = NPTS +4*I -1
      DO 1100 J =1,18
 1100 CMAT(J,I) = CMAT(J,I)/ELVOL
      K= NPTS*2 +18*I -9
      IF(NECPT(ICORD).NE.0) GO TO 1200
      CALL GMMATS( GE,6,6,0,CMAT(1,I),6,3,0,PHIOUT(K) )
      GO TO 2000
 1200 CALL TRANSS(NECPT(ICORD), TI )
      CALL GMMATS( CMAT(1,I),6,3,0,TI,3,3,0,TEMP)
      CALL GMMATS( GE,6,6,0,TEMP,6,3,0, PHIOUT(K) )
 2000 CONTINUE
C
      NPHI(1) = NECPT(1)
      PHIOUT(NPTS+2) = TEMPO
      TEMP(1)= ALFA
      TEMP(2)= ALFA
      TEMP(3)= ALFA
      TEMP(4)= 0.0
      TEMP(5)= 0.0
      TEMP(6)= 0.0
C*****
C     THE THERMAL EXPANSION VECTOR IS MULTIPLIED BY THE STRESS-STRAIN
C       MATRIX,GE
C*****
      CALL GMMATS( GE,6,6,0,TEMP(1),6,1,0,PHIOUT(NPTS+3) )
C*****
C     THE OUTPUT ARRAY IS NOW COMPLETE
C*****
      RETURN
C*****
C     PHIOUT CONTAINS THE FOLLOWING WHERE N IS THE NUMBER OF CORNERS
C
C              ELEMENT ID
C              N SILS
C              T SUB 0
C              6 THERMAL STRESS COEFFICIENTS
C              N VOLUME RATIO COEFFICIENTS
C              N 6 BY 3 MATRICES RELATING STRESS TO DISPLACEMENTS
C
C*****
      END

      SUBROUTINE TRLGA (CASECC,USETD,DLT,SLT,BGPDT,SIL,CSTM,AP,TMLDTB,
     1                 ITRL,ISCR1,ISCR2,ISCR3,EST,NEWSLT,MGG,ISCR4,MPT1)
C
C     THE PURPOSE OF THIS ROUTINE IS TO CONSTRUCT THE AP MATRIX
C     WHICH HAS 1 COLUMN FOR EACH FUNCTION OF TIME
C     AND TO BUILD THE TIME FUNCTION TABLE (FORMAT SHOWN IN TRLGC)
C
      EXTERNAL        ANDF
      INTEGER         CASECC,USETD,DLT,SLT,BGPDT,SIL,CSTM,AP,TMLDTB,
     1                SYSBUF,ANDF,PG(7),NAME(2),SLT1,BGPDT1,CSTM1,SIL1,
     2                MCB(7),IZ(38),FILE,NAMT(2),GVECT(30),TWO1,IZB(4),
     3                MINUS(2),EST,EST1
      COMMON /BLANK / NG
      COMMON /ZZZZZZ/ Z(1)
      COMMON /LOADX / LC,SLT1,BGPDT1,OLD,CSTM1,SIL1,ISIL,EST1,MPT,GPTT,
     1                EDT,N(3),LODC,MASS,NOBLD,IDIT
      COMMON /SYSTEM/ KSYSTM(65)
      COMMON /BITPOS/ ISK(11),IUE
      COMMON /ZBLPKX/ ZA(4),IIB
      COMMON /ZNTPKX/ ZB(4),III,IEOL,IEOR
      COMMON /TWO   / TWO1(32)
      COMMON /QVECT / ITRAN,IQVECT
      EQUIVALENCE     (KSYSTM(1),SYSBUF),(Z(1),IZ(1)),(ZB(1),IZB(1))
      DATA    NAME  / 4HTRLG,4HA   /,  NAMT/ 4HDLT ,4HTRLG /
      DATA    ITRAN1, MINUS /4HTRAN,-1,-1  /
C
C     CORE IS ALLOCATED AS FOLLOWS -
C     . EXTERN PHASE (BUILD STATIC LOADS)
C                                                           POINTER
C     DLOAD STUFF--TLOAD ID,RECORD NO.IN DLT,SCALE FACTOR   ILLST
C     EXTERN LOAD LIST IN SLT ((NEX LENGTH)                 ISLLST
C     2  BUFFERS
C     1  G VECTOR (NG)  COMING FROM TOP
C        N.B.  EXTER WILL OPEN NEWSLT,BGPDT,CSTM,SIL
C
C     . DYNAMIC PHASE
C     DLOAD STUFF                                           ILLST
C     EXTERN LOAD LIST                                      ISLLST
C     SIL TO SILD CONVERTER (NG LENGTH)                     ISILD
C     4  BUFFERS
C     2  P SIZE VECTORS
C     COMPRESSED LIST  SILD,A,TAU                           ICLST
C
C     BRING IN DATA FROM CASECC(DLOAD ID -- TSTEP ID)
C
      NSUBL = 0
      NZ    = KORSZ(IZ)
      IBUF1 = NZ - SYSBUF + 1
      NX    = IBUF1 - 1
      CALL GOPEN (CASECC,IZ(IBUF1),0)
      CALL FREAD (CASECC,IZ(1),166,1)
      IDLOAD = IZ(13)
      ITRL   = IZ(38)
      CALL CLOSE (CASECC,1)
      IF (IDLOAD .EQ. 0) GO TO 1020
C
C     BUILD NEW SLT
C
      CALL SSGSLT (SLT,NEWSLT,EST)
C
C     FIND DLOAD, TLOAD
C
      FILE = DLT
      CALL OPEN (*900,DLT,IZ(IBUF1),0)
      CALL READ (*910,*10,DLT,IZ(1),NX,0,IFLAG)
      GO TO 980
C
C     IS IT A DLOAD SET
C
   10 NDLOAD = IZ(3)
      NSIMPL = IFLAG - 3 - NDLOAD
      IF (NDLOAD .EQ. 0) GO TO 100
      K = 3
      DO 20 I = 1,NDLOAD
      K = K + 1
      IF (IZ(K) .EQ. IDLOAD) GO TO 30
   20 CONTINUE
C
C     ITS  A SIMPLE LOAD
C
      GO TO 100
C
C     PROCESS DLOAD SET
C     FORMAT OF DLOAD = SET ID,SCALE,SCALE,ID,SCALE,ID .... -1,-1
C
   30 NZ1 = NX - IFLAG
C
C     BRING  IN  ALL  DLOADS
C
      L =  IFLAG + 1
      CALL READ (*910,*40,DLT,IZ(L),NZ1,0,I)
      GO TO 980
C
C     FIND SELECTED ID
C
   40 ISEL = L
   50 IF (IZ(ISEL) .EQ. IDLOAD) GO TO 70
   60 ISEL = ISEL + 2
      IF (IZ(ISEL+1) .NE. -1) GO TO 60
      ISEL = ISEL + 2
      IF (ISEL-L .GT. I) GO TO 990
      GO TO 50
C
C     FOUND DLOAD SELECTED
C
   70 SCALE = Z(ISEL+1)
C
C     CONVERT SCALE FACTORS TO OVERALL SCALE FACTORS
C     BUILD LIST OF TRIPLES-- TLOAD ID,RECORD NO.IN DLT, SCALE FACTOR
C
      L = ISEL + 2
      M = ISEL + I
      IFLAG  = M
      NSUBL  = 0
   80 IDLOAD = IZ(L+1)
      Z(L)   = Z(L)*SCALE
      K = NDLOAD + 3
      DO 90 I = 1,NSIMPL
      K = K + 1
      IF (IZ(L+1) .EQ. IZ(K)) GO TO 95
C
   90 CONTINUE
      GO TO 990
C
C     FOUND SIMPLE ID
C
   95 IZ(M  ) = IZ(L+1)
       Z(M+1) = Z(L)
      IZ(M+2) = I
      L = L + 2
      M = M + 3
      NSUBL = NSUBL + 1
      IF (IZ(L+1) .GE. 0) GO TO 80
      GO TO 150
C
C     PROCESS SIMPLE LOAD REQUEST
C
  100 M = IFLAG + 1
      IFLAG  = M
      IZ(M ) = IDLOAD
      Z(M+1) = 1.0
      L = NDLOAD + 3
      DO 110 I = 1,NSIMPL
      L = L + 1
      IF (IZ(L) .EQ. IDLOAD) GO TO 120
  110 CONTINUE
      GO TO 990
C
C     FOUND SIMPLE LOAD
C
  120 IF (NDLOAD .NE. 0) I = I + 1
      IZ(M+2) = I - 1
      NSUBL   = 1
C
C     MOVE STUFF TO BOTTOM OF CORE
C
  150 CALL CLOSE(DLT,1)
      ILLST = NZ - NSUBL*3 + 1
      NZ    = NZ - NSUBL*3
      IBUF1 = NZ - SYSBUF + 1
      L     = IFLAG
      K     = ILLST
      DO 160 I = 1,NSUBL
      CALL GOPEN  (DLT,IZ(IBUF1),0)
      CALL SKPREC (DLT,IZ(L+2))
      CALL FREAD  (DLT,IZB,2,0)
      IZ(K) = IZB(2)
      CALL CLOSE (DLT,1)
      IZ(K+1) = IZ(L+2)
      IZ(K+2) = IZ(L+1)
      L = L + 3
      K = K + 3
  160 CONTINUE
C
C     SET UP FOR EXTERN
C
      FILE   = NEWSLT
      NX     = IBUF1 - 1
      ISLLST = ILLST
      NOSLT  = 0
      MCB(1) = SLT
      CALL RDTRL (MCB)
      IF (MCB(1) .LE. 0) NOSLT = -1
      MCB(1) = SIL
      MCB(3) = 0
      CALL RDTRL (MCB)
      NG     = MCB(3)
      IF (NOSLT .NE. 0) GO TO 191
      CALL OPEN (*900,NEWSLT,IZ(IBUF1),0)
      CALL READ (*910,*170,NEWSLT,IZ(1),NX,0,IFLAG)
      GO TO 980
  170 CALL CLOSE (NEWSLT,1)
      M = ILLST
      DO 180 I = 1,NSUBL
      DO 175 J = 3,IFLAG
      IF (IZ(M) .NE. IZ(J)) GO TO 175
C
C     FOUND LOAD TO BUILD
C
      IZ(J) = -IABS(IZ(J))
      GO TO 179
  175 CONTINUE
  179 M = M + 3
  180 CONTINUE
C
C     ZERO LOADS NOT TO BUILD
C
      M = ILLST - IFLAG + 2
      ISLLST = M
      DO 190 J = 3,IFLAG
      IF (IZ(J) .LT. 0) GO TO 185
      IZ(M) = 0
      GO TO 189
  185 IZ(M) = IABS(IZ(J))
  189 M     = M + 1
  190 CONTINUE
      NEX   = IFLAG - 2
      NZ    = NZ - NEX
      NGRAV = 0
      IHARM = 0
      N1    = NEX
      IBUF1 = NZ - SYSBUF + 1
      IBUF2 = IBUF1 - SYSBUF
C
C     SET UP SCRATCH FILE FOR QLOADL
C
      ITRAN  = ITRAN1
      IQVECT = ISCR1
      CALL GOPEN (ISCR1,IZ(IBUF1),1)
      CALL MAKMCB (PG,ISCR2,NG,2,1)
      SLT1   = NEWSLT
      BGPDT1 = BGPDT
      CSTM1  = CSTM
      SIL1   = SIL
      EST1   = EST
      MASS   = MGG
      MPT    = MPT1
      CALL GOPEN (PG,IZ(IBUF2),1)
      LC     = IBUF2 - 1
      CALL EXTERN (NEX,NGRAV,GVECT,IZ(ISLLST),PG,N1,IHARM)
      CALL CLOSE  (PG,1)
      CALL WRTTRL (PG)
      CALL WRITE  (ISCR1,MINUS,2,1)
      CALL CLOSE  (ISCR1,1)
      IF (NGRAV .EQ. 0) GO TO 191
C
C     DO GRAVITY LOADS
C
      MCB(1) = MGG
      CALL RDTRL (MCB)
      IF (MCB(1) .LE. 0) CALL MESAGE (-56,0,NAVE)
C
C     SAVE LOAD LIST IN CORE
C
      CALL GOPEN (ISCR4,IZ(IBUF2),1)
      CALL WRITE (ISCR4,IZ(ISLLST),3*NSUBL+NEX,1)
      CALL CLOSE (ISCR4,1)
      CALL GRAVL1 (NGRAV,GVECT,ISCR3,IHARM)
      CALL SSG2B (MGG,ISCR3,0,TMLDTB,0,1,1,AP)
      CALL GRAVL2 (NGRAV,TMLDTB,PG)
      N1 = N1 + NGRAV
C
C     RESTORE LOAD LIST TO CORE
C
      CALL GOPEN (ISCR4,IZ(IBUF2),0)
      CALL FREAD (ISCR4,IZ(ISLLST),3*NSUBL+NEX,1)
      CALL CLOSE (ISCR4,1)
C
C     BUILD SIL  TO SILD CONVERTER
C
  191 CONTINUE
      FILE   = USETD
      CALL GOPEN (USETD,IZ(IBUF1),0)
      MCB(1) = USETD
      CALL RDTRL (MCB)
      LUSETD = MCB(2)
      CALL FREAD (USETD,IZ(1),LUSETD,1)
      CALL CLOSE (USETD,1)
      ISILD  = ISLLST - NG
      MSKUE  = TWO1(IUE)
      L    = ISILD
      DO  200 I = 1,LUSETD
      IF (ANDF(IZ(I),MSKUE) .NE. 0) GO TO 200
      IZ(L)= I
      L    = L + 1
  200 CONTINUE
      NZ   = NZ - NG
C
C     BEGIN LOOP ON EACH TLOAD CARD
C
      IBUF1 = NZ - SYSBUF + 1
      ICLST = 2*LUSETD + 1
      IBUF2 = IBUF1 - SYSBUF
      IBUF3 = IBUF2 - SYSBUF
      CALL MAKMCB (MCB,AP,LUSETD,2,1)
      CALL GOPEN (AP,IZ(IBUF2),1)
      ITERM = 0
      CALL GOPEN (TMLDTB,IZ(IBUF3),1)
      IQVRN = 0
      IBUF4 = IBUF3 - SYSBUF
      CALL GOPEN (ISCR3,IZ(IBUF4),1)
      NZ    = IBUF4 - 1
      IF (NZ .LT. 5*LUSETD) GO TO 980
      DO 1000 ILOOP = 1,NSUBL
C
C     ZERO AP AND TAU AREA
C
      K = 2*LUSETD
      DO 210 I = 1,K
      Z(I) = 0.0
  210 CONTINUE
C
C     FIND APPROPRIATE STATIC LOAD
C
      K = ILLST + (ILOOP-1)*3
      SCALE  = Z(K+2)
      IDLOAD = IZ(K )
      IDLTR  = IZ(K+1)
      IF (NOSLT .NE. 0) GO TO 300
      K = ISLLST - 1
      M = 0
      DO 220 I = 1,NEX
      L = K + I
      IF (IZ(L) .EQ. IDLOAD) GO TO 221
      IF (IZ(L) .NE. 0) M = M + 1
  220 CONTINUE
      GO TO 300
C
C     POSITION TO PROPER AP RECORD
C
  221 FILE = PG(1)
      CALL GOPEN (PG,IZ(IBUF1),0)
      CALL SKPREC (PG,M)
      CALL INTPK (*290,PG,0,1,0)
  240 IF (IEOL .NE. 0) GO TO 290
      CALL  ZNTPKI
      ZB(1) = ZB(1)*SCALE
      K = ISILD + III - 1
      K = IZ(K)
      Z(K) = ZB(1)
      GO TO 240
  290 CALL CLOSE (PG,1)
C
C     PROCESS DLT STUFF
C
  300 CALL GOPEN (DLT,IZ(IBUF1),0)
      FILE = DLT
      CALL SKPREC (DLT,IDLTR)
      CALL FREAD (DLT,GVECT,8,0)
C
C     READS AND BUILDS COMPRESSED LIST SILD,AI,TAU,FOR ALL AI.S
C
  320 CALL READ (*910,*330,DLT,IZB,4,0,IFLAG)
      L    = IZB(1)
      Z(L) = ZB(2) + Z(L)
      Z(L+LUSETD) = ZB(3)
      GO TO 320
  330 CALL CLOSE (DLT,1)
      IQR = 0
      ASSIGN 370 TO IRETN
      M = 0
      K = ICLST
      DO 336 I = 1,LUSETD
      IF (Z(I) .EQ. 0.0) GO TO 336
      Z(I)   = Z(I)*SCALE
      M      = M + 1
      IZ(K ) = I
      Z(K+1) = Z(I)
      Z(K+2) = Z(I+LUSETD)
      K      = K + 3
  336 CONTINUE
C
C     SORT ON TAU
C
  339 K = 3*M + ICLST - 4
      IF (ICLST .GT. K) GO TO 1335
      DO 335  L = ICLST,K,3
      IF (Z(L+5).GT.Z(L+2) .OR. (Z(L+5).EQ.Z(L+2) .AND.
     1   IZ(L+3).GE.IZ(L))) GO TO 335
      LL      = L
      IZ(K+4) = IZ(L+3)
      Z(K+5)  = Z(L+4)
      Z(K+6)  = Z(L+5)
  338 IZ(LL+3)= IZ(LL)
      Z(LL+4) = Z(LL+1)
      Z(LL+5) = Z(LL+2)
      LL      = LL - 3
      IF (LL.GE.ICLST .AND. (Z(K+6).LT.Z(LL+2) .OR. (Z(K+6).EQ.Z(LL+2)
     1   .AND. IZ(K+4).LT.IZ(LL)))) GO TO 338
      IZ(LL+3)= IZ(K+4)
      Z(LL+4) = Z(K+5)
      Z(LL+5) = Z(K+6)
  335 CONTINUE
 1335 CONTINUE
C
C     OUTPUT PVECTOR FOR EACH UNIQUE TAU
C
      L    = ICLST
CWKBR 8/94 ALPHA  341 TAUO = Z(L+2)              
  341 ITAUO = IZ(L+2)            
      CALL BLDPK (1,1,AP,0,0)
  345 ZA(1)= Z(L+1)
      IIB  = IZ(L)
      CALL ZBLPKI
      L = L +3
CWKBR 8/94 ALPHA IF (L.LT.3*M+ICLST .AND. Z(L+2).EQ.TAUO) GO TO 345           
      IF (L.LT.3*M+ICLST .AND. IZ(L+2).EQ.ITAUO) GO TO 345     
      CALL BLDPKN (AP,0,MCB)
C
C     PUT OUT LINE OF TIME TABLE
C
      ITERM = ITERM + 1
      CALL WRITE (TMLDTB,ITERM,1,0)
      CALL WRITE (TMLDTB,IDLOAD,1,0)
      CALL WRITE (TMLDTB,GVECT,1,0)
CWKBR 8/94 ALPHA CALL WRITE (TMLDTB,TAUO,1,0)                    
      CALL WRITE (TMLDTB,ITAUO,1,0)              
      CALL WRITE (TMLDTB,GVECT(3),6,0)
      CALL WRITE (TMLDTB,IQR,1,0)
      IF (L .GE. ICLST+3*M) GO TO IRETN, (370,390)
      GO TO 341
C
C     FIND PROPER QVEC RECORD
C
  370 CONTINUE
      IF (NOSLT .NE. 0) GO TO 1000
      CALL GOPEN (ISCR1,IZ(IBUF1),0)
      FILE = ISCR1
  380 CALL READ (*450,*920,ISCR1,IQVID,1,0,IFLAG)
      IF (IQVID .EQ.     -1) GO TO 450
      IF (IQVID .EQ. IDLOAD) GO TO 390
      CALL FWDREC (*910,ISCR1)
      GO TO 380
C
C     BUILD LIST OF SILD,AI,TAU FROM QVEC STUFF
C
  390 CALL FREAD (ISCR1,M,1,0)
      K = ICLST
      IF (M .EQ. -1) GO TO 450
      DO 400 I = 1,M
      CALL FREAD (ISCR1,ZB,2,0)
      ZB(2) = ZB(2)*SCALE
      J = ISILD + IZB(1) - 1
      J = IZ(J)
      IZ(K)  = J
      Z(K+1) = ZB(2)
      Z(K+2) = Z(J+LUSETD)
      K = K + 3
  400 CONTINUE
      IQVRN = IQVRN + 1
      IQR   = IQVRN
      CALL FREAD (ISCR1,IZ(K),9,0)
      CALL WRITE (ISCR3,IZ(K),9,0)
      ASSIGN 390 TO IRETN
      GO TO 339
C
C     END OF QVECT PROCESSING
C
  450 CALL CLOSE (ISCR1,1)
C
C     END OF TLOAD CARD LOOP
C
 1000 CONTINUE
      CALL CLOSE (AP,1)
      CALL WRTTRL (MCB)
      CALL CLOSE (ISCR3,1)
C
C     APPEND QVECT STUFF TO TMLDTB
C
      CALL GOPEN (ISCR3,IZ(IBUF1),0)
      FILE = ISCR3
      CALL WRITE (TMLDTB,0,0,1)
      CALL READ (*1010,*1010,ISCR3,IZ(1),NZ,0,IFLAG)
      GO TO 980
 1010 CALL WRITE (TMLDTB,IZ(1),IFLAG,1)
      CALL CLOSE (TMLDTB,1)
      MCB(1) = TMLDTB
      MCB(2) = ITERM
      MCB(3) = IFLAG
      CALL WRTTRL (MCB)
      CALL CLOSE (ISCR3,1)
 1020 CONTINUE
      RETURN
C
C     FATAL ERRORS
C
  900 IP1 = -1
  901 CALL MESAGE (IP1,FILE,NAME)
      RETURN
  903 CALL MESAGE (-61,0,NAME)
      RETURN
  910 IP1 = -2
      GO TO 901
  920 IP1 = -3
      GO TO 901
  980 CALL MESAGE (-8,0,NAME)
      GO TO 903
  990 CALL MESAGE (-31,IDLOAD,NAMT)
      RETURN
      END

      SUBROUTINE OFP1
C
C     THIS ROUTINE OUTPUTS A PAGE HEADING BASED ON PARAMETERS COMING
C     THROUGH COMMON.
C     THIS ROUTINE CALLS OPF1A, OFP1B OR OFP1C FOR ACTUAL PRINTING, SUCH
C     THAT OFP1A, OFP1B AND OFP1C CAN BE OVERLAYED IN PARALLEL.
C
      INTEGER         L123(5),ID(50),OF(6)
      COMMON /SYSTEM/ KSYS(100)
      COMMON /ZZZZZZ/ CORE(1)
      EQUIVALENCE     (CORE(1),OF(1),L123(1)), (ID(1),OF(6)),
     1                (NOUT,KSYS(2)), (LINET,KSYS(12)), (IFLAG,KSYS(33))
C
C     IFLAG IS WORD 33 OF /SYSTEM/ AND IS SET TO INCIDATE OFP PRINTED
C     LAST.
C
      CALL PAGE1
      IFLAG = 1
      DO 1000 I = 1,5
      LINE = L123(I)
      IF (LINE) 1000,800,500
 500  IF (LINE .GT. 174) GO TO 600
C
C ... 1 THRU 174-
C
      CALL OFP1A (LINE)
      GO TO 1000
 600  IF (LINE .GT. 380) GO TO 700
C
C ... 175 THRU 380 -
C
      CALL OFP1B (LINE)
      GO TO 1000
C
C ... 381 UP -
C
 700  CALL OFP1C (LINE)
      GO TO 1000
C
 800  WRITE  (NOUT,900)
 900  FORMAT (1H )
C
 1000 CONTINUE
      LINET = LINET + 4
      RETURN
      END

      SUBROUTINE SORT (IDUM,JDUM,NR,KEYWD,Z,NWDS)
C
C     THE ORIGINAL NASTRAN SORT ROUTINE FOR IN-CORE SORTING AND FILE
C     SORT IS NOW RENAMED SORTI
C     (ONLY 5 PERCENT OF NASTRAN ROUTINES ACTUALLY CALL SORTI, WITH NON-
C     ZERO IDUM AND JDUM)
C
C     THIS NEW SORT ROUTINE WITH IDUM=JDUM=0, PERFORMS ONLY IN-CORE SORT
C     FOR INTEGERS, FLOATING POINT NUMBERS, AND BCD WORDS, BY THE
C     MODIFIED SHELL METHOD
C     IT USES MUCH LESS CORE SPACE
C
C     ARRAY Z IS NR-ROWS BY (NWDS/NR)-COLUMNS IN SIZE
C     DATA STORED ROW-WISE IN Z, AND TO BE SORTED BY KEYWD-TH ROW
C
C     USE A NEGATIVE KEYWD  IF THE ORIGINAL ORDER OF THE TABLE ENTRIES
C     ARE TO BE PRESERVED AND THE COLUMN OF KEYWORDS CONTAINS DUPLICATES
C     (INTEGER SORT ONLY)    E.G.
C
C     ORIGINAL TABLE     SORTED(KEYWD=+1)       SORTED(KEYWD=-1)
C     ---------------    ----------------       ----------------
C       1      4             1      4               1      4
C       2      2             1     10               1      3
C       1      3             1      3               1     10
C       1     10             2      2               2      2
C
C
C     THIS ROUTINE WOULD SWITCH BACK TO THE OLD SHUTTLE EXCHANGE METHOD
C     NUMBERS OVERFLOW DUE TO THE REQUIREMENT THAT ORIGINAL ORDER MUST B
C     MAINTAINED
C
C     ENTRY POINTS
C
C     SORT   - TABLE SORT BY INTEGER
C     SORTF  - TABLE SORT BY F.P. NUMBER
C     SORTA  - TABLE SORT BY ALPHABETS, 4-BCD CHARACTERS
C     SORTA8 - TABLE SORT BY ALPHABETS, 8-BCD CHAR. (KEYWD AND KEYWD+1)
C     SORTA7 - SAME AS SORTA8, EXCEPT LEADING CHAR. IS IGNORED
C     SORT2K - 2-KEYWORD SORT, SORT BY KEYWD AND KEYWD+1, INTEGER OR
C              REAL NUMBER KEYS. NEGATIVE KEYWD IS IGNORED
C
C     THE TWO SORT CALLS OF THE FOLLOWING FORM CAN BE REPLACED BY ONE CA
C     TO SORT2K, WHICH IS FASTER, NO DANGER OF NUMBER OVERFLOW, AND THE
C     ORIGINAL SEQUENCE WILL NOT CHANGE WHEN THERE ARE DUPLICATES.
C
C         CALL SORT (0,0,N1,-(N2+1),TABLE,N3)
C         CALL SORT (0,0,N1,-N2,    TABLE,N3)
C              CAN BE REPLACED BY
C         CALL SORT2K (0,0,N1,N2,TABLE,N3)
C
C
C     WRITTEN BY G.CHAN/SPERRY, 3/1987
C
      LOGICAL         RVSBCD
      INTEGER         ZI,      ZN,      TEMP,    Z(NR,1), TWO31,   TWO,
     1                SUBR(6)
      REAL            RI,      RN
      COMMON /SYSTEM/ IBUF,    NOUT,    DM37(37),NBPW
      COMMON /MACHIN/ MACH,    IJHLF(2),LQRO
      COMMON /TWO   / TWO(16)
      EQUIVALENCE     (ZI,RI), (ZN,RN)
      DATA    SUBR  / 2H  ,    2HF ,    2HA ,    2HA8,    2HA7,    2H2K/
C
C     CHECK ERROR, CHECK DATA TYPE, AND PREPARE FOR SORT
C
      ISORT = 1
      GO TO 10
C
      ENTRY SORTF (IDUM,JDUM,NR,KEYWD,Z,NWDS)
C     =======================================
      ISORT = 2
      GO TO 10
C
      ENTRY SORTA (IDUM,JDUM,NR,KEYWD,Z,NWDS)
C     =======================================
      ISORT = 3
      GO TO 10
C
      ENTRY SORTA8 (IDUM,JDUM,NR,KEYWD,Z,NWDS)
C     ========================================
      ISORT = 4
      GO TO 10
C
      ENTRY SORTA7 (IDUM,JDUM,NR,KEYWD,Z,NWDS)
C     ========================================
      ISORT = 5
      GO TO 10
C
      ENTRY SORT2K (IDUM,JDUM,NR,KEYWD,Z,NWDS)
C     ========================================
      ISORT = 6
C
   10 IF (NWDS .EQ. 0) GO TO 330
      IF (IDUM.NE.0 .OR. JDUM.NE.0) GO TO 300
      RVSBCD = MOD(LQRO,10) .EQ. 1
      KEY  = IABS(KEYWD)
      IF (KEY .GT. NR) GO TO 280
      NC = NWDS/NR
      IF (NC*NR .NE. NWDS) GO TO 280
      M  = NC
      IF (ISORT.NE.1 .OR. KEYWD.GE.0) GO TO 30
C
C                     - INTEGER SORT ONLY -
C     IF ORIGINAL ORDER IS TO BE MAINTAINED WHERE DUPLICATE KEYWORDS MAY
C     OCCUR, ADD INDICES TO THE KEYWORDS (GOOD FOR BOTH POSITIVE AND
C     NEGATIVE RANGES, AND BE SURE THAT KEYWORDS ARE NOT OVERFLOWED),
C     SORT THE DATA, AND REMOVE THE INDICES LATER
C
C     IF KEYWORD OVERFLOWS, SWITCH TO SHUTTLE EXCHANGE METHOD
C
      IF (NC.GE.TWO(16) .AND. NBPW.LE.32) GO TO 200
      J = 30
      IF (NBPW .GE. 60) J = 62
      TWO31 = 2**J
      LIMIT = (TWO31-NC)/NC
      DO 20 I = 1,NC
      J = Z(KEY,I)
      IF (IABS(J) .GT. LIMIT) GO TO 200
      J = J*NC + I
      K =-1
      IF (J .LT. 0) K =-NC
   20 Z(KEY,I) = J + K
C
C     SORT BY
C     MODIFIED SHELL METHOD, A SUPER FAST SORTER
C
   30 M = M/2
      IF (M .EQ. 0) GO TO 180
      J = 1
      K = NC - M
   40 I = J
   50 N = I + M
      ZI= Z(KEY,I)
      ZN= Z(KEY,N)
      GO TO (60,80,90,90,90,60), ISORT
C           INT FP A4 A8 A7 2K
C
   60 IF (ZI-ZN) 170,70,150
   70 IF (ISORT .EQ. 1) GO TO 170
      IF (Z(KEY+1,I)-Z(KEY+1,N)) 170,170,150
   80 IF (RI-RN) 170,170,150
   90 KK = 1
      IF (ISORT .EQ. 5) GO TO 110
C
C     COMPARE 1ST BYTE, THEN COMPARE 2ND, 3RD, AND 4TH BYTES TOGETHER
C     IF MACHINE DOES NOT USE REVERSED BCD ORDER. THOSE MACHINES WITH
C     REVERSED BCD ORDER (VAX, ULTRIX, S/G) MUST COMPARE EACH BYTE
C     SEPERATELY BECAUSE OF THE SIGN BIT
C
  100 IF (KHRFN1(ZERO,4,ZI,1) - KHRFN1(ZERO,4,ZN,1)) 170,110,150
  110 IF (.NOT.RVSBCD) IF (KHRFN1(ZI,1,ZERO,4)-KHRFN1(ZN,1,ZERO,4))
     1                                               170,140,150
      IF (KHRFN1(ZERO,4,ZI,2) - KHRFN1(ZERO,4,ZN,2)) 170,120,150
  120 IF (KHRFN1(ZERO,4,ZI,3) - KHRFN1(ZERO,4,ZN,3)) 170,130,150
  130 IF (KHRFN1(ZERO,4,ZI,4) - KHRFN1(ZERO,4,ZN,4)) 170,140,150
  140 IF (ISORT.LE.3 .OR. KK.EQ.2) GO TO 170
      ZI = Z(KEY+1,I)
      ZN = Z(KEY+1,N)
      KK = 2
      GO TO 100
  150 DO 160 L = 1,NR
      TEMP = Z(L,I)
      Z(L,I) = Z(L,N)
  160 Z(L,N) = TEMP
      I = I - M
      IF (I .GE. 1) GO TO 50
  170 J = J + 1
      IF (J-K) 40,40,30
  180 IF (ISORT.NE.1 .OR. KEYWD.GE.0) GO TO 330
      DO 190 I = 1,NC
  190 Z(KEY,I) = Z(KEY,I)/NC
      GO TO 330
C
C     SORT BY
C     SHUTTLE EXCHANGE THETHOD, A SLOW SORTER
C     (THIS WAS NASTRAN ORIGINAL SORTER, MODIFIED FOR 2-D ARRAY OPERATIO
C     WITH 20-COLUMN LIMITATION REMOVED)
C
  200 IF (I .LE. 1) GO TO 220
      J = I - 1
      DO 210 I = 1,J
  210 Z(KEY,I) = Z(KEY,I)/NC
C
  220 DO 270 II = 2,NC
      ZI = Z(KEY,II)
      JJ = II - 1
      IF (ZI .GE. Z(KEY,JJ)) GO TO 270
  230 JJ = JJ - 1
      IF (JJ .GT. 0) IF (ZI-Z(KEY,JJ)) 230,240,240
  240 JJ = JJ + 2
      DO 260 I = 1,NR
      TEMP = Z(I,II)
      M = II
      DO 250 J = JJ,II
      Z(I,M) = Z(I,M-1)
  250 M = M - 1
  260 Z(I,JJ-1) = TEMP
  270 CONTINUE
      GO TO 330
C
C     ERROR. FORCING A WALK BACK
C
  280 WRITE  (NOUT,290) SUBR(ISORT),NR,KEY,NWDS,NC
  290 FORMAT ('0*** ERROR IN SORT',A2,4I8)
      GO TO 320
  300 WRITE  (NOUT,310)
  310 FORMAT ('0*** CALLING ROUTINE SHOULD CALL SORTI')
CWKBR  320 CALL ERRTRC ('SORT    ',320)
  320 CONTINUE
  330 RETURN
      END

      SUBROUTINE SETEQ (NAME1,NAME2,PREFX,DRY2,ITEST,IMORE,LIM)
C
C     SETS THE SUBSTRUCTURE NAME2 EQUIVALENT TO THE SUBSTRUCTURE NAME1.
C     THE OUTPUT VARIABLE ITEST TAKES ON ONE OF THE FOLLOWING VALUES
C
C         4  IF NAME1 DOES NOT EXIST
C         8  IF DRY DOES NOT EQUAL ZERO AND NAME2 OR ONE OF THE NEW
C            NAMES ALREADY EXISTS
C         9  IF DRY IS EQUAL TO ZERO AND NAME2 OR ONE OF THE NEW NAMES
C            DOES NOT EXIST
C         1  OTHERWISE
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        LSHIFT,RSHIFT,ANDF,ORF,COMPLF
      LOGICAL         DITUP,MDIUP,MORE
      DIMENSION       NAME1(2),NAME2(2),ISAVE(50),NAMNEW(2),
     1                IMORE(1),NMSBR(2)
      CHARACTER       UFM*23,UWM*25,UIM*29
      COMMON /XMSSG / UFM,UWM,UIM
      COMMON /MACHIN/ MACH,IHALF,JHALF
      COMMON /ZZZZZZ/ BUF(1)
      COMMON /SOF   / DIT,DITPBN,DITLBN,DITSIZ,DITNSB,DITBL,
     1                IO ,IODUM(7),MDI,MDIPBN,MDILBN,MDIBL,
     2                NXTDUM(15),DITUP,MDIUP
      COMMON /SYS   / BLKSIZ,DIRSIZ,SYS(3),IFRST
      COMMON /OUTPUT/ TITLE(96),SUBTIT(96)
      COMMON /SYSTEM/ NBUFF,NOUT,DUM(36),NBPC,NBPW,NCPW
      COMMON /ITEMDT/ NITEM,ITEM(7,1)
      DATA    PS, SS, IB, LL, CS, HL, BB,   IRD, IWRT,  INDSBR  /
     1        1 , 1 , 1 ,  2,  2,  2,  1,     1,    2,      15  /
      DATA    IEMPTY, MASK,   NMSBR         /
     2        4H    , 4HMASK, 4HSETE,4HQ    /
C
      CALL CHKOPN (NMSBR(1))
      IF (NITEM+IFRST-1 .GT. 50) GO TO 970
      DRY   = DRY2
      ITEST = 1
      CALL FDSUB (NAME1(1),IND1)
      IF (IND1 .EQ. -1) GO TO 900
      MASK   = ANDF(MASK,2**(NBPW-4*NBPC)-1)
      MASKSS = COMPLF(LSHIFT(1023,10))
      MASKLL = COMPLF(LSHIFT(1023,20))
      MASKBB = LSHIFT(1023,20)
C
C     IF NAME2 EXISTS - VERIFY THAT IT IS MARKED EQUIVALENT TO NAME1.
C     NAME2 MAY ALREADY EXIST FOR RUN=GO OR OPTIONS=PA
C
      CALL FDSUB (NAME2(1),IND2)
      IF (IND2 .EQ. -1) GO TO 10
      DRY = 0
C
      CALL FMDI (IND2,IMDI)
      IPS = ANDF(BUF(IMDI+PS),1023)
      IF (IPS .EQ.    0) GO TO 920
      IF (IPS .EQ. IND1) GO TO 10
      CALL FMDI (IND1,IMDI)
      IPP = ANDF(BUF(IMDI+PS),1023)
      IF (IPS .NE. IPP) GO TO 920
C
C     STEP 1.  MAKE A LIST OF ALL THE SUBSTRUCTURES CONTRIBUTING TO THE
C     SUBSTRUCTURE NAME1, AND STORE IT IN THE ARRAY IMORE
C
   10 ITOP  = 1
      IMORE(ITOP) = IND1
      IPTR  = 1
   20 CALL FMDI (IND1,IMDI)
      I     = BUF(IMDI+LL)
      INDLL = RSHIFT(ANDF(I,1073741823),20)
      INDCS = RSHIFT(ANDF(I,1048575)   ,10)
      IF (INDLL .EQ. 0) GO TO 40
      DO 30 J = 1,ITOP
      IF (IMORE(J) .EQ. INDLL) GO TO 40
   30 CONTINUE
      ITOP  = ITOP + 1
      IF (ITOP .GT. LIM) GO TO 960
      IMORE(ITOP) = INDLL
   40 IF (INDCS.EQ.0 .OR. IPTR.EQ.1) GO TO 60
      DO 50 J = 1,ITOP
      IF (IMORE(J) .EQ. INDCS) GO TO 60
   50 CONTINUE
      ITOP  = ITOP + 1
      IF (ITOP .GT. LIM) GO TO 960
      IMORE(ITOP) = INDCS
   60 IF (IPTR .EQ. ITOP) GO TO 100
      IPTR  = IPTR + 1
      IND1  = IMORE(IPTR)
      GO TO 20
C
C     STEP 2.  CREATE AN IMAGE SUBSTRUCTURE FOR EACH SUBSTRUCTURE IN THE
C     ARRAY IMORE, AND STORE ITS INDEX IN THE ARRAY IMAGE.  NOTE THAT
C     SINCE IMORE(1) CONTAINS THE INDEX OF NAME1, IMAGE(1) WILL CONTAIN
C     THE INDEX OF NAME2
C     FOR EACH NEW NAME CHECK THAT MAKING ROOM FOR THE PREFIX DOES NOT
C     TRUNCATE THE NAME
C
  100 IF (IPTR .NE. 1) GO TO 110
      CALL FDSUB (NAME2(1),I)
      GO TO 120
  110 CALL FDIT (IND1,IDIT)
      FIRST = KLSHFT(KRSHFT(PREFX,NCPW-1),NCPW-1)
      REST  = KLSHFT(KRSHFT(BUF(IDIT),NCPW-3),NCPW-4)
      NAMNEW(1) = ORF(ORF(FIRST,REST),MASK)
      FIRST = KLSHFT(KRSHFT(BUF(IDIT),NCPW-4),NCPW-1)
      REST  = KLSHFT(KRSHFT(BUF(IDIT+1),NCPW-3),NCPW-4)
      NAMNEW(2)= ORF(ORF(FIRST,REST),MASK)
      IF (KHRFN1(IEMPTY,4,BUF(IDIT+1),4) .NE. IEMPTY)
     1    WRITE (NOUT,850) UWM,NAMNEW,BUF(IDIT),BUF(IDIT+1)
      CALL FDSUB (NAMNEW(1),I)
  120 IF (DRY .NE. 0) GO TO 130
      IF (I   .NE.-1) GO TO 170
      GO TO 910
  130 IF (I .EQ. -1) GO TO 150
      IPTR = IPTR + 1
      IF (IPTR .GT. ITOP) GO TO 920
      DO 140 I = IPTR,ITOP
      IMAGE = IMORE(LIM+I)
      CALL FDIT (IMAGE,IDIT)
      BUF(IDIT  ) = IEMPTY
      BUF(IDIT+1) = IEMPTY
      DITUP = .TRUE.
  140 CONTINUE
      GO TO 920
  150 IF (IPTR .NE. 1) GO TO 160
      CALL CRSUB (NAME2(1),I)
      GO TO 170
  160 CALL CRSUB (NAMNEW(1),I)
  170 IMORE(IPTR+LIM) = I
      IF (IPTR .EQ. 1) GO TO 200
      IPTR = IPTR - 1
      IND1 = IMORE(IPTR)
      GO TO 100
C
C     STEP 3.  BUILD THE MDI OF NAME2, AND OF ALL IMAGE SUBSTRUCTURES
C
  200 IND2 = I
  210 CALL FMDI (IND1,IMDI)
      DO 220 J = 1,DIRSIZ
      ISAVE(J) = BUF(IMDI+J)
  220 CONTINUE
C
C     SET THE SS ENTRY FOR THE SUBSTRUCTURE WITH INDEX IND1
C
      IF (DRY .EQ. 0) GO TO 230
      BUF(IMDI+SS) = ORF(ANDF(BUF(IMDI+SS),MASKSS),LSHIFT(IND2,10))
      MDIUP = .TRUE.
  230 CALL FMDI (IND2,IMDI)
      IF (DRY .EQ. 0) GO TO 420
      I = ISAVE(PS)
C
C     SET THE PS ENTRY FOR THE SUBSTRUCTURE WITH INDEX IND2
C
      IPS = ANDF(I,1023)
      IF (IPS .EQ. 0) GO TO 240
      BUF(IMDI+PS) = IPS
      GO TO 250
  240 BUF(IMDI+PS) = IND1
C
C     SET THE SS ENTRY FOR THE SUBSTRUCTURE WITH INDEX IND2
C
  250 ISS = RSHIFT(ANDF(I,1048575),10)
      IF (ISS .EQ. 0) GO TO 260
      BUF(IMDI+SS) = ORF(ANDF(BUF(IMDI+SS),MASKSS),LSHIFT(ISS,10))
C
C     SET THE BB ENTRY FOR THE SUBSTRUCTURE WITH INDEX IND2
C
  260 IBS = ANDF(I,MASKBB)
      BUF(IMDI+BB) = ORF(ANDF(BUF(IMDI+BB),MASKLL),IBS)
      I = ISAVE(LL)
C
C     SET THE HL ENTRY FOR THE SUBSTRUCTURE WITH INDEX IND2
C
      IF (IPTR .EQ. 1) GO TO 300
      IHL = ANDF(I,1023)
      IF (IHL.EQ.0) GO TO 280
      ASSIGN 270 TO IRET
      IWANT = IHL
      GO TO 320
  270 BUF(IMDI+HL) = IFND
C
C     SET THE CS ENTRY FOR THE SUBSTRUCTURE WITH INDEX IND2
C
  280 ICS = RSHIFT(ANDF(I,1048575),10)
      IF (ICS .EQ. 0) GO TO 300
      ASSIGN 290 TO IRET
      IWANT = ICS
      GO TO 320
  290 BUF(IMDI+CS) = ORF(ANDF(BUF(IMDI+CS),MASKSS),LSHIFT(IFND,10))
C
C     SET THE LL ENTRY FOR THE SUBSTRUCTURE WITH INDEX IND2
C
  300 ILL = RSHIFT(ANDF(I,1073741823),20)
      IF (ILL .EQ. 0) GO TO 400
      ASSIGN 310 TO IRET
      IWANT = ILL
      GO TO 320
  310 BUF(IMDI+LL) = ORF(ANDF(BUF(IMDI+LL),MASKLL),LSHIFT(IFND,20))
      GO TO 400
C
C     FIND THE INDEX OF THE IMAGE SUBSTRUCTURE TO THE SUBSTRUCTURE WITH
C     INDEX IWANT.  STORE THE FOUND INDEX IN IFND
C
  320 DO 330 K = 1,ITOP
      IF (IMORE(K) .NE. IWANT) GO TO 330
      IFND = IMORE(LIM+K)
      GO TO IRET, (270,290,310)
  330 CONTINUE
      GO TO 930
C
C     SET THE POINTERS OF THE ITEMS BELONGING TO THE SUBSTRUCTURE WITH
C     INDEX IND2
C
  400 DO 410 J = IFRST,DIRSIZ
  410 BUF(IMDI+J) = 0
  420 IF (IPTR .EQ. 1) GO TO 440
C
C     IMAGE SUBSTRUCTURE - SET POINTERS TO SHARED ITEMS AND SET IB BIT
C
      DO 430 J = 1,NITEM
      IF (ITEM(4,J) .NE. 0) GO TO 430
      ITM = J + IFRST - 1
      IF (BUF(IMDI+ITM) .EQ. 0) BUF(IMDI+ITM) = ISAVE(ITM)
  430 CONTINUE
      BUF(IMDI+IB) = ORF(BUF(IMDI+IB),LSHIFT(1,30))
      GO TO 500
C
C     SECONDARY SUBSTRUCTURE - SET POINTERS TO SHARED ITEMS
C
  440 DO 450 J = 1,NITEM
      IF (ITEM(5,J) .NE. 0) GO TO 450
      ITM = J + IFRST - 1
      IF (BUF(IMDI+ITM) .EQ. 0) BUF(IMDI+ITM) = ISAVE(ITM)
  450 CONTINUE
C
C     COPY APPROPRIATE ITEMS OF NAME1 AND WRITE THEM FOR
C     NAME2 AFTER CHANGING NAME1 TO NAME2 AND INSERTING THE NEW PREFIX
C     TO THE NAMES OF ALL CONTRIBUTING SUBSTRUCTURES
C
  500 DO 700 J = 1,NITEM
      IF (ITEM(3,J) .EQ. 0) GO TO 700
      KK = J + IFRST - 1
      IF (BUF(IMDI+KK) .NE. 0) GO TO 700
      IRDBL = ANDF(ISAVE(KK),JHALF)
      IF (IRDBL.NE.0 .AND. IRDBL.NE.JHALF) GO TO 510
      BUF(IMDI+KK) = ISAVE(KK)
      GO TO 700
  510 CALL SOFIO (IRD,IRDBL,BUF(IO-2))
      CALL FDIT (IND2,IDIT)
      BUF(IO+1) = BUF(IDIT  )
      BUF(IO+2) = BUF(IDIT+1)
      CALL GETBLK (0,IWRTBL)
      IF (IWRTBL .EQ. -1) GO TO 940
      NEWBLK = IWRTBL
      NUMB = ITEM(3,J)/1000000
      MIN  = (ITEM(3,J) - NUMB*1000000)/1000
      INC  = ITEM(3,J) - NUMB*1000000 - MIN*1000
      NUMB = BUF(IO+NUMB)
      IF (NUMB.GT.1 .OR. ILL.NE.0 .OR. IPTR.NE.1) GO TO 530
C
C     BASIC SUBSTRUCTURE
C
      BUF(IO+MIN  ) = NAME2(1)
      BUF(IO+MIN+1) = NAME2(2)
      MORE = .FALSE.
      GO TO 580
C
C     NOT A BASIC SUBSTRUCTURE
C
  530 IF (NUMB .LE. (BLKSIZ-MIN+1)/INC) GO TO 540
      NUMB = NUMB - (BLKSIZ-MIN+1)/INC
      MAX  = BLKSIZ
      MORE = .TRUE.
      GO TO 550
  540 MAX  = MIN + INC*NUMB - 1
      MORE = .FALSE.
C
C     INSERT THE NEW PREFIX TO THE NAMES OF ALL CONTRIBUTING SUBSTRUC-
C     TURES
C     IF THE COMPONENT IS FOR MODAL DOF ON THE SECONDARY SUBSTRUCTURE,
C     USE THE ACTUAL NAME INSTEAD OF ADDING A PREFIX
C
  550 DO 570 K = MIN,MAX,INC
      IF (BUF(IO+K).EQ.NAME1(1) .AND. BUF(IO+K+1).EQ.NAME1(2))
     1    GO TO 560
      FIRST = KLSHFT(KRSHFT(PREFX,NCPW-1),NCPW-1)
      REST  = KLSHFT(KRSHFT(BUF(IO+K  ),NCPW-3),NCPW-4)
      FIRST2= KLSHFT(KRSHFT(BUF(IO+K  ),NCPW-4),NCPW-1)
      REST2 = KLSHFT(KRSHFT(BUF(IO+K+1),NCPW-3),NCPW-4)
      BUF(IO+K  ) = ORF(ORF(FIRST ,REST ),MASK)
      BUF(IO+K+1) = ORF(ORF(FIRST2,REST2),MASK)
      GO TO 570
C
  560 BUF(IO+K  ) = NAME2(1)
      BUF(IO+K+1) = NAME2(2)
  570 CONTINUE
C
C     WRITE OUT UPDATED DATA BLOCK
C
  580 CALL SOFIO (IWRT,IWRTBL,BUF(IO-2))
      CALL FNXT (IRDBL,INXT)
      IF (MOD(IRDBL,2) .EQ. 1) GO TO 590
      NEXT = ANDF(RSHIFT(BUF(INXT),IHALF),JHALF)
      GO TO 600
  590 NEXT = ANDF(BUF(INXT),JHALF)
  600 IF (NEXT .EQ. 0) GO TO 620
C
C     MORE BLOCKS TO COPY
C
      IRDBL = NEXT
      CALL GETBLK (IWRTBL,NEXT)
      IF (NEXT.NE.-1) GO TO 610
      CALL RETBLK (NEWBLK)
      GO TO 940
  610 IWRTBL = NEXT
      CALL SOFIO (IRD,IRDBL,BUF(IO-2))
      MIN = 1
      IF (MORE) GO TO 530
      GO TO 580
C
C     NO MORE BLOCKS TO COPY.  UPDATE MDI OF NAME2
C
  620 BUF(IMDI+KK) = ORF(LSHIFT(RSHIFT(ISAVE(KK),IHALF),IHALF),NEWBLK)
  700 CONTINUE
C
      MDIUP = .TRUE.
      IF (IPTR .EQ. ITOP) GO TO 720
      IPTR = IPTR + 1
      IND1 = IMORE(IPTR    )
      IND2 = IMORE(IPTR+LIM)
      GO TO 210
C
C     WRITE USER MESSAGES
C
  720 IF(DRY .EQ. 0) GO TO 780
      DO 730 I = 1,96
  730 SUBTIT(I) = IEMPTY
      CALL PAGE
      CALL PAGE2 (-4)
      WRITE (NOUT,800) NAME2,NAME1
      IMAGE = IMORE(LIM+1)
      CALL FMDI (IMAGE,IMDI)
      IPS = ANDF(BUF(IMDI+1),1023)
      CALL FDIT (IPS,I)
      CALL PAGE2 (-2)
      WRITE (NOUT,810) NAME2,BUF(I),BUF(I+1)
      IPTR = 2
      IF (IPTR .GT. ITOP) GO TO 990
      CALL PAGE2 (-2)
      WRITE (NOUT,820)
  740 DO 750 I = 1,16
  750 IMORE(I) = IEMPTY
      J = 1
  760 IMAGE = IMORE(IPTR+LIM)
      CALL FDIT (IMAGE,I)
      IMORE(J  ) = BUF(I  )
      IMORE(J+1) = BUF(I+1)
      IPTR = IPTR + 1
      IF (IPTR .GT. ITOP) GO TO 770
      J = J + 2
      IF (J .LT. 16) GO TO 760
  770 CALL PAGE2 (-2)
      WRITE (NOUT,830) (IMORE(J),J=1,16)
      IF (IPTR .LE. ITOP) GO TO 740
      GO TO 990
C
C     DRY RUN - PRINT MESSAGE INDICATING ONLY ADDITIONS MADE
C
  780 CALL PAGE2 (-3)
      WRITE (NOUT,840) UIM,NAME2,NAME1,NAME2
      GO TO 990
C
  800 FORMAT (32X,67HS U B S T R U C T U R E   E Q U I V A L E N C E   O
     1 P E R A T I O N ,///23X,13HSUBSTRUCTURE ,2A4,56H HAS BEEN CREATED
     2 AND MARKED EQUIVALENT TO SUBSTRUCTURE ,2A4)
  810 FORMAT (1H0,22X,28HTHE PRIMARY SUBSTRUCTURE OF ,2A4,4H IS ,2A4)
  820 FORMAT (1H0,22X, 56HTHE FOLLOWING IMAGE SUBSTRUCTURES HAVE BEEN GE
     1NERATED --)
  830 FORMAT (1H0,22X,10(2A4,2X))
  840 FORMAT (A29,' 6228, SUBSTRUCTURE ',2A4,' IS ALREADY AN EQUIVALENT'
     1,      ' SUBSTRUCTURE TO ',2A4, /36X,'ONLY ITEMS NOT PREVIOUSLY ',
     2       'EXISTING FOR ',2A4,' HAVE BEEN MADE EQUIVALENT.')
  850 FORMAT (A25,' 6236, DURING THE CREATION OF A NEW IMAGE SUBSTRUC',
     1       'TURE NAMED ',2A4,' THE LAST CHARACTER ', /5X,
     2       'OF SUBSTRUCTURE NAMED ',2A4,' WAS TRUNCATED TO MAKE ROOM',
     3       ' FOR THE PREFIX.')
C
C     ERROR CONDITIONS
C
  900 ITEST = 4
      GO TO 990
  910 ITEST = 9
      GO TO 990
  920 ITEST = 8
      GO TO 990
  930 CALL ERRMKN (INDSBR,3)
  940 WRITE  (NOUT,950) UFM
  950 FORMAT (A23,' 6223, SUBROUTINE SETEQ - THERE ARE NO MORE FREE ',
     1        'BLOCKS AVAILABLE ON THE SOF.')
      K = -37
      GO TO 980
  960 K = -8
      GO TO 980
  970 CALL ERRMKN (INDSBR,10)
  980 CALL SOFCLS
      CALL MESAGE (K,0,NMSBR)
C
  990 RETURN
      END

      SUBROUTINE REIG
C
C     READ   KAA,MAA,MR,DM,EED,USET,CASECC/LAMA,PHIA,MI,OEIGS/C,N,IPROB
C            /V,N,NUMMOD/C,N,ICASE/C,N,XLAMDA $
C
      INTEGER         SYSBUF   ,EIGR(4)  ,ICORE(12),CASECC   ,FILE     ,
     1                ERROR(3) ,FEERX    ,SDET     ,UDET     ,INV      ,
     2                SINV     ,UINV     ,GIVI     ,STURM    ,GIVN(7)  ,
     3                DM       ,EED      ,LAMA     ,PHIA     ,MI       ,
     4                USET     ,POUT     ,SCR1     ,SCR2     ,SCR3     ,
     5                SCR4     ,SCR5     ,SCR6     ,SCR7     ,OPTION   ,
     6                SUBNAM(2),IX(7)    ,OPTN2
      REAL            LMIN     ,LMAX     ,LFREQ    ,MB(1)
      DOUBLE PRECISION DCORE(1)
      CHARACTER       UFM*23   ,UWM*25   ,UIM*29
      COMMON /XMSSG / UFM      ,UWM      ,UIM
      COMMON /BLANK / IPROB(2) ,NUMMOD   ,ICASE    ,XLAMDA
     1       /INVPWX/ IFILK(7) ,IFILM(7) ,IFILLM(7),IFILVC(7),ISCR1    ,
     2                ISCR2    ,ISCR3    ,ISCR4    ,ISCR5    ,ISCR6    ,
     3                ISCR7    ,ISCR8    ,IDUMP    ,LMIN     ,LMAX     ,
     4                NOEST    ,NDPLUS   ,NDMNUS   ,EPS      ,NOVECT
     5       /GIVN  / DUM(100) ,N        ,LFREQ    ,ORDER    ,D1       ,
     6                HFREQ    ,D2       ,NV       ,NPRT     ,D4       ,
     7                NFR
      COMMON /FEERCX/ IFKAA(7) ,IFMAA(7) ,IFLELM(7),IFLVEC(7),SR1FLE   ,
     1                SR2FLE   ,SR3FLE   ,SR4FLE   ,SR5FLE   ,SR6FLE   ,
     2                SR7FLE   ,SR8FLE   ,DMPFLE   ,NORD     ,XLMBDA   ,
     3                NEIG     ,MORD     ,IBK      ,CRITF    ,NORTHO   ,
     4                IFLRVA   ,IFLRVC   ,IEPX
     5       /NTIME / LNTIME   ,TCONS(15)
     6       /REGEAN/ IM(7)    ,IK(7)    ,IEV(7)   ,SCR1     ,SCR2     ,
     7                SCR3     ,SCR4     ,SCR5     ,LCORE    ,RMAX     ,
     8                RMIN     ,MZ       ,NEV      ,EPSI     ,RMINR    ,
     9                NE       ,NIT      ,NEVM     ,SCR6     ,SCR7     ,
     O                NFOUND   ,LAMDA    ,IBUCK    ,NSYM
      COMMON /STURMX/ STURM    ,SHFTPT   ,KEEP     ,PTSHFT   ,NR       ,
     1                SHFTZO
     2       /REIGKR/ OPTION   ,OPTN2
     3       /SYSTEM/ SYSBUF   ,NOUT     ,NOGO     ,KSYS(51) ,JPREC
      COMMON /CONDAS/ PI       ,TWOPI    ,RADEG    ,DEGRA    ,
     1                FPS
      COMMON /PACKX / ITP1     ,ITP2     ,IIP      ,JJP      ,INCRP
      COMMON /UNPAKX/ ITU      ,IIU      ,JJU      ,INCRU
     1       /ZZZZZZ/ CORE(1)
      EQUIVALENCE     (GIVN(1) ,CORE(1))
      EQUIVALENCE     (TCONS(4),APC    ) ,(TCONS(5),APU      ) ,
     1                (TCONS(8),MB(1)  ) ,(ERROR(2),SUBNAM(1)) ,
     2                (DCORE(1) ,CORE(1) ,ICORE (1))
      DATA            EIGR                                   ,CASECC/
     1                307      ,3        ,107      ,1        ,107   /,
     2                SDET     ,UDET     ,INV      ,SINV     ,I0    /
     3                4HSDET   ,4HUDET   ,4HINV    ,4HSINV   ,0     /,
     4                UINV     ,GIVI     ,KAA      ,MAA      ,MR    /
     5                4HUINV   ,4HGIV    ,101      ,102      ,103   /,
     6                DM       ,EED      ,USET     ,LAMA     ,PHIA  /
     7                104      ,105      ,106      ,201      ,202   /,
     8                MI       ,POUT     ,ICR1     ,ICR2     ,MODE  /
     9                203      ,204      ,301      ,302      ,4HMODE/,
     O                ERROR                        ,FEERX    ,MGIV  /
     1                4HEED    ,4HREIG   ,4H       ,4HFEER   ,4HMGIV/
C
C
      IBUCK  = 1
      LCORE  = KORSZ(CORE) - SYSBUF - 3
      LLCORE = LCORE - SYSBUF
      CALL GOPEN (LAMDA,CORE(LCORE+1),1)
      CALL CLOSE (LAMDA,2)
      IF (IPROB(1) .NE. MODE) IBUCK = 3
      STURM  = -1
      KEEP   = 0
      SHFTPT = 0.0
      PTSHFT = 0.0
      NR     = 0
      SHFTZO = 0.0
      CALL OPEN (*10,CASECC,CORE(LCORE+1),0)
      CALL SKPREC (CASECC,ICASE)
      CALL FREAD (CASECC,ICORE,166,1)
      CALL CLOSE (CASECC,1)
      METHOD = ICORE(5)
      GO TO 20
   10 METHOD = -1
   20 FILE   = EED
      CALL PRELOC (*170,CORE(LCORE+1),EED)
      CALL LOCATE (*40,CORE(LCORE+1),EIGR(IBUCK),IFLAG)
   30 CALL READ (*40,*40,EED,CORE(1),18,0,IFLAG)
      IF (METHOD.EQ.ICORE(1) .OR. METHOD.EQ.-1) GO TO 50
      GO TO 30
C
C     NO SET NUMBER FOUND
C
   40 CALL MESAGE (-32,METHOD,ERROR)
C
C     FOUND DATA CARD
C
   50 NORM = ICORE(10)
      CALL CLOSE (EED,1)
C
C     TEST THE SIZE OF THE K AND M MATRICES VIA THEIR TRAILERS
C
      CALL RDTRL (IK(1))
      CALL RDTRL (IM(1))
      IF (IM(2).EQ.IK(2) .AND. IM(3).EQ.IK(3)) GO TO 51
C
C     K AND M MATRICES ARE NOT OF THE SAME SIZE
C
      WRITE  (NOUT,200) UFM
  200 FORMAT (A23,' 3131, INPUT STIFFNESS AND MASS MATRICES ARE NOT ',
     1       'COMPATIBLE.')
      CALL MESAGE (-37,0,ERROR(2))
C
C     K AND M MATRICES ARE COMPATIBLE
C
   51 CONTINUE
C
C     CHECK TO SEE IF THE INPUT STIFFNESS AND/OR MASS MATRIX IS NULL
C
      IF (IK(6).EQ.0 .OR. IM(6).EQ.0) CALL MESAGE (-60,0,0)
C
C     SET FLAG FOR THE METHOD OF ANALYSIS AND THE PROPER
C     TYPE OF DECOMPOSITION
C
      OPTION = ICORE(2)
      OPTN2  = ICORE(3)
      IF (OPTION.EQ.GIVI .OR. OPTION.EQ.UDET .OR. OPTION.EQ.UINV)
     1    GO TO 53
      IF (OPTION.EQ.FEERX .OR. OPTION.EQ.MGIV) GO TO 53
      IF (OPTION.EQ.SDET  .OR. OPTION.EQ.SINV) GO TO 52
      OPTION = UDET
      IF (ICORE(2) .EQ. INV) OPTION = UINV
      IF (IM(4).NE.6 .OR. IK(4).NE.6) GO TO 53
      OPTION = SDET
      IF (ICORE(2) .EQ. INV) OPTION = SINV
      GO TO 53
   52 IF (IM(4).EQ.6 .AND. IK(4).EQ.6) GO TO 53
      WRITE (NOUT,2100) UWM
      OPTION = UDET
      IF (ICORE(2) .EQ. SINV) OPTION = UINV
   53 ISIL  = ICORE(12)
      I     = 9
      EPSII = CORE(I)
      IF (IBUCK .EQ. 3) GO TO 60
C
C     CONVERT FREQUENCY TO LAMDA
C
      IF ((ICORE(2).EQ.GIVI .OR. ICORE(2).EQ.MGIV) .AND. ICORE(7).GT.0)
     1    GO TO 55
      IF (CORE(I0+4) .GE. 0.0) GO TO 55
      WRITE (NOUT,2000) UWM
      CORE(I0+4) = 0.0
   55 CORE(I0+4) = FPS*CORE(I0+4)*CORE(I0+4)
      IF (ICORE(2) .NE. FEERX) CORE(I0+5) = FPS*CORE(I0+5)*CORE(I0+5)
   60 CONTINUE
      CORE4  = CORE(I0+4)
      CORE5  = CORE(I0+5)
      ICORE6 = ICORE(6)
      ICORE7 = ICORE(7)
      ICORE8 = ICORE(8)
      IF (ICORE(2).EQ.GIVI .OR. ICORE(2).EQ.MGIV) GO TO 70
      IF (ICORE(2) .EQ. FEERX) GO TO 65
      IF (ICORE(7) .EQ. 0) ICORE(7) = 3*ICORE(6)
      ICORE7 = ICORE(7)
C
C     FEER, INVERSE POWER AND DETERMINANT METHODS
C
C     CHECK IF IT IS A NORMAL MODES PROBLEM OR A BUCKLING PROBLEM
C
   65 IF (IBUCK .EQ. 3) GO TO 80
C
C     NORMAL MODES PROBLEM
C
C     CHECK FOR APPEND
C
      IF (NUMMOD .LE. 0) GO TO 70
      IX(1) = PHIA
      CALL RDTRL (IX)
      IF (IX(1).LE.0 .OR. IX(2).LE.0) GO TO 70
C
C     NEW EIGENVALUES AND EIGENVECTORS WILL BE APPENDED TO THOSE
C     PREVIOUSLY CHECKPOINTED
C
      NR = IX(2)
      IF (NUMMOD .LT. NR) NR = NUMMOD
      WRITE (NOUT,2200) UIM,NR
C
C     RETRIEVE EIGENVALUES AND EIGENVECTORS PREVIOUSLY CHECKPOINTED.
C
C     COPY OLD EIGENVALUES FROM LAMA FILE TO ICR1 FILE.
C
C     COPY OLD EIGENVECTORS FROM PHIA FILE TO ICR2 FILE.
C
      CALL READ7 (NR,LAMA,PHIA,ICR1,ICR2)
      GO TO 80
C
C     NO APPEND
C
C     CHECK IF RIGID BODY MODES ARE TO BE COMPUTED SEPARATELY
C
   70 IX(1) = MR
      CALL RDTRL (IX)
      IF (IX(1) .LT. 0) GO TO 75
C
C     COMPUTE RIGID BODY MODES
C
      CALL READ1 (DM,MR,SCR4,SCR5,SCR3,ICR2,USET,NR,ICR1,SCR6)
C
C     RIGID BODY EIGENVALUES ARE ON ICR1
C
C     RIGID BODY EIGENVECTORS ARE ON ICR2
C
   75 IF (OPTION.EQ.GIVI .OR. OPTION.EQ.MGIV) GO TO 100
   80 IF (OPTION .EQ.FEERX) GO TO  95
      IF (OPTION .EQ. SDET) GO TO 109
      IF (OPTION .EQ. UDET) GO TO 110
C
C
C     INVERSE POWER METHOD
C     ********************
C
      LMIN   = CORE4
      LMAX   = CORE5
      NOEST  = ICORE6
      NDPLUS = ICORE7
      NDMNUS = 0
      IF (IBUCK .EQ. 3) NDMNUS = ICORE8
      EPS = EPSII
      IF (EPS .LE.      0.) EPS = .0001
      IF (EPS .LT. .000001) EPS = .000001
      CALL RDTRL (IFILK(1))
      CALL RDTRL (IFILM(1))
      NOVECT = NR
      CALL INVPWR
      METHOD = 2
      NUMMOD = NOVECT
      GO TO 140
C
C
C     FEER METHOD
C     ***********
C
   95 IFLRVA = ICR1
      IFLRVC = ICR2
      XLMBDA = CORE4
      NEIG   = ICORE7
      IEPX   = ICORE8
      IF (IBUCK .EQ. 3) NEIG = ICORE6
      NORTHO = NR
      CRITF  = CORE5
      IX(1)  = KAA
      CALL RDTRL (IX)
      N = IX(2)
      IF (CRITF .EQ. 0.) CRITF = .001/N
      CALL FEER
      METHOD = 2
      NUMMOD = MORD + NR
      CALL SSWTCH (26,L26)
      IF (NUMMOD.GT.NEIG .AND. L26.NE.0) NUMMOD = NEIG
      IFILK(2) = NORD
      GO TO 140
C
C
C     GIVENS METHOD
C     *************
C
  100 LFREQ = CORE4
      HFREQ = CORE5
      METHOD= 3
      NFR   = NR
      NPRT  = ICORE6
      NV    = ICORE7
      GIVN(   1) = KAA
      GIVN(I0+2) = MAA
      GIVN(I0+3) = PHIA
      DO 105 I = 1,4
  105 GIVN(I+3) = EIGR(I)
      CALL GIVENS
      NNV = GIVN(1)
      NUMMOD = N
      GO TO 145
C
C
C     DETERMINANT METHOD
C     ******************
C
  109 NSYM  = 1
  110 METHOD= 4
      RMIN  = CORE4
      RMAX  = CORE5
      IF (RMIN .EQ. 0.0 ) RMIN = RMAX*1.0E-4
      RMINR = -.01*RMIN
      NEV   = ICORE6
      IF (IBUCK.EQ.3 .AND. EPSII.NE.0.0) EPSI = EPSII
      NEVM  = ICORE7
      CALL RDTRL (IM(1))
      IEV(3) = IK(3)
      IF (NEVM .GT. IK(3)) NEVM = IK(3)
      MZ = NR
C
C     PICK UP UNREMOVED FREE BODY MODES
C
      IF (ICORE8 .GT. NR) MZ = -ICORE8
      IEV(2) = NR
      CALL DETM
      NUMMOD = NFOUND + NR
      IFILK(2) = IEV(3)
C
C     SORT EIGENVECTORS AND VALUES
C
  140 IF (NUMMOD .EQ. 0) GO TO 160
      CALL READ3 (NUMMOD,IFILK(2),LAMDA,IEV,PHIA,LAMA)
  145 IF (METHOD.EQ.2 .OR. NUMMOD.EQ.1) GO TO 150
C
C     CHECK ORTHOGONALITY
C
      IFILVC(1) = PHIA
      CALL RDTRL (IFILVC(1))
      CALL READ4 (LAMA,IFILVC(1),SCR1,EPSII,MAA)
  150 CONTINUE
C
C     SET FLAG FOR GIVENS METHOD FOR USE IN READ2 ROUTINE
C
      DUM(1) = 0.0
      IF (METHOD .EQ. 3) DUM(1) = 1.0
      NV = NNV
C
C     FORM MODAL MASS, NORMALIZE AND FORM SUMMARY FILE.
C
      CALL READ2 (MAA,PHIA,SCR1,NORM,ISIL,XXX,MI,LAMA,POUT,ICR2,
     1            EPSII,SCR6)
      GO TO 165
  160 NUMMOD = -1
      CALL READ5 (POUT)
  165 IF (NOGO .EQ. 14) WRITE (NOUT,166)
  166 FORMAT ('0*** THIS NASTRAN JOB WILL BE TERMINATED')
      RETURN
C
  170 IP1 = -1
  180 CALL MESAGE (IP1,FILE,SUBNAM)
      GO TO 180
C
C     ERROR MESSAGES
C
 2000 FORMAT (A25,' 2367, FREQUENCY F1 (FIELD 4) ON THE EIGR BULK DATA',
     1       ' CARD IS NEGATIVE', /5X,
     2        'IT IS ASSUMED TO BE ZERO FOR CALCULATION PURPOSES.',/)
 2100 FORMAT (A25,' 2368, SYMMETRIC DECOMPOSITION IS SPECIFIED ON THE ',
     1        'EIGR BULK DATA CARD, BUT', /5X,
     2        'UNSYMMETRIC DECOMPOSITION WILL BE USED AS THIS IS THE ',
     3        'PROPER TYPE OF DECOMPOSITION FOR THIS PROBLEM.')
 2200 FORMAT (A29,' 3143, THE EIGENVALUES AND EIGENVECTORS FOUND IN ',
     1        'THIS ANALYSIS WILL BE APPENDED', /5X,'TO THE',I8,
     2        ' EIGENVALUES AND EIGENVECTORS COMPUTED EARLIER.')
C
      END

        SUBROUTINE UNPACK ( *, FILE, A )
      INCLUDE 'PAKBLK.COM'
      INCLUDE 'DSIOF.COM'
      INCLUDE 'XNSTRN.COM'
        COMMON / UNPAKX / ITYPOT, IROBGN, LASROW, INCR
        INTEGER           FILE
        REAL              A(4), IBASE
        DATA              LARGE / 65536 /
        NAME = FILE
        NUM    = NWRDEL( IABS( ITYPOT ) )
        CALL DSIPK1( IBLKD, ITYPOT )
        IF ( IRETRN .EQ. 1 ) GO TO 7700
        IF ( IROBGN .LE. 0 .OR. LASROW .LE. 0 ) GO TO 10
        IROW   = IROBGN
        ILSROW = LASROW
        GO TO 20
10      IROBGN = IBLKD( 4 )
        IROW   = IROBGN
        ILSROW = LARGE
20      CONTINUE
        INDEX2 = 1
        ITYPE  = IBLKD( 13 )
        INDEX1 = ( IBLKD( 5 ) - 1 ) * IBLKD( 14 ) + 1
        NUMINC = NUM * INCR
90      IF ( IBLKD( 4 ) .GT. ILSROW ) GO TO 200
        IF ( ( IBLKD( 4 ) + IBLKD( 6 ) - 1 ) .LT. IROBGN ) GO TO 145
100     IDIFF = ( IBLKD( 4 ) + IBLKD( 7 ) ) - IROW
        IBLKD( 7 ) = IBLKD( 7 ) + 1
        IF ( IDIFF .EQ. 0 ) GO TO 140
        IF ( IDIFF .LT. 0 ) GO TO 142
        DO 130 K = 1, NUM
        DO 110   KKK = 1, IDIFF
        A( INDEX2 + K - 1 + (KKK-1)*NUMINC ) = 0.
110     CONTINUE
130     CONTINUE
        INDEX2 = INDEX2 + IDIFF*NUMINC
        IROW   = IROW + IDIFF
140     IF ( IBLKD(2) .NE. ITYPE ) GO TO 1400
CDIR$ NOVECTOR
        DO 141 K = 1, NUM
        A( INDEX2 + K - 1 ) = IBASE( INDEX1 + K - 1 )
141     CONTINUE
CDIR$ VECTOR
        GO TO 1401
1400    CALL DSUPKC( IBLKD( 2 ), ITYPE, IBASE( INDEX1 ), A( INDEX2 ) )
1401    CONTINUE
        IF ( IROW .GE. ILSROW ) GO TO 225
        IROW = IROW + 1
        INDEX2 = INDEX2 + NUMINC
142     INDEX1 = INDEX1 + IBLKD( 11 )
        IF ( IBLKD( 7 ) .NE. IBLKD( 6 ) ) GO TO 100
145     CALL ENDGET( IBLKD )
        CALL GETSTR( *200, IBLKD )
        INDEX1 = ( IBLKD( 5 ) - 1 ) * IBLKD( 14 ) + 1
        IBLKD( 7 ) = 0
150     IF ( IBLKD( 8 ) .LT. 1 ) GO TO 90
200     IF ( ILSROW .EQ. LARGE ) GO TO 230
        NUMLEF = LASROW - IROW + 1
        IF ( NUMLEF .LE. 0 ) GO TO 225
        DO 220 KK = 1, NUM
        DO 210 K  = 1, NUMLEF
        A( INDEX2 + KK - 1 + (K-1)*NUMINC ) = 0.
210     CONTINUE
220     CONTINUE
225     IF ( IBLKD( 8 ) .GE. 1 ) GO TO 240
        CALL DSSKRC
        CALL DSSDCB
        GO TO 240
230     LASROW = IROW - 1
240     RETURN
7700    RETURN 1
        END

      SUBROUTINE SMA2
C ******
C THIS ROUTINE IS A DRIVER AND INITIALIZATION PROGRAM FOR MODULE
C 2.4.2 OF THE NASTRAN SYSTEM.  IT GENERATES THE MASS MATRIX, MGG, AND
C THE DAMPING MATRIX, BGG.
C ******
C
C
C
C
      LOGICAL             HEAT
C
C
      DOUBLE PRECISION
     1                   DZ                 ,ZZZZZZ
C
C
C
      INTEGER
     1                   IZ(1)              ,EOR
     2,                  CLSRW              ,CLSNRW
     3,                  FROWIC
     4,                  TNROWS             ,OUTRW
     5,                  BGGIND
C
C
C
      DIMENSION
     1                   NMSMA2(2)
      COMMON /BLANK/      WTMASS             ,NOMGG
     1,                  NOBGG
C
C
C
      COMMON   /SYSTEM/  ISYS,ISEW1(53),IPREC,ITHERM
C
C SMA2 I/O PARAMETERS
C
      COMMON   /SMA2IO/
     1                   IFCSTM             ,IFMPT
     2,                  IFDIT              ,IDUM1
     3,                  IFECPT             ,IGECPT
     4,                  IFGPCT             ,IGGPCT
     5,                  IDUM2              ,IDUM3
     6,                  IFMGG              ,IGMGG
     7,                  IFBGG              ,IGBGG
     8,                  IDUM4              ,IDUM5
     9,                  INRW               ,OUTRW
     T,                  CLSNRW             ,CLSRW
     1,                  NEOR               ,EOR
     2,                  MCBMGG(7)          ,MCBBGG(7)
C
C SMA2 VARIABLE CORE
C
      COMMON   /ZZZZZZ /  Z(1)
C
C SMA2 VARIABLE CORE BOOKKEEPING PARAMETERS.
C
      COMMON   /SMA2BK/
     1                   ICSTM              ,NCSTM
     2,                  IGPCT              ,NGPCT
     3,                  IPOINT             ,NPOINT
     4,                  I6X6M              ,N6X6M
     5,                  I6X6B              ,N6X6B
C
C SMA2 PROGRAM CONTROL PARAMETERS
C
      COMMON   /SMA2CL/
     1                   IOPTB              ,BGGIND
     2,                  NPVT               ,LEFT
     3,                  FROWIC             ,LROWIC
     4,                  NROWSC             ,TNROWS
     5,                  JMAX               ,NLINKS
     6,                  LINK(10)           ,NOGO
C
C ELEMENT DATA
C
      COMMON   /GPTA1/ NELEMS, LAST, INCR, NE(1)
C
C ECPT COMMON BLOCK
C
      COMMON   /SMA2ET/
     1                   ECPT(100)
C
C SCRATCH BLOCK FOR ELEMENT ROUTINES
C
      COMMON   /SMA2DP/
     1                   ZZZZZZ(300)
C
      COMMON   /SMA2HT/  HEAT
C
      COMMON   /HMATDD/  IHMAT, NHMAT, MPTMPT, IDIT
C
C
      EQUIVALENCE
     1                   (Z(1),IZ(1),DZ)
C
C
C
      DATA
     1                   NMSMA2(1) /4HSMA2/ ,NMSMA2(2) /4H    /
C
C*****
C  SET HEAT FLAG
C*****
      HEAT = .FALSE.
      IF( ITHERM .NE. 0 )   HEAT = .TRUE.
C
C
      CALL DELSET
      IZMAX = KORSZ (Z)
C
C SET PURGE FLAGS FOR BGG AND NO PURGE FLAG FOR MGG.
C
      BGGIND = -1
      NOBGG  = -1
      NOMGG = 1
C
C ATTEMPT TO OPEN THE OUTPUT FILE FOR THE MASS MATRIX.  IF IT IS NOT
C IN THE OSCAR, EXECUTION WILL BE TERMINATED SINCE WE DO NOT ALLOW
C THE USER TO GENERATE ONLY A BGG. (EXCEPT IN A HEAT TRANSER PROBLEM)
C
      IGMGG = IZMAX - ISYS
      IF( HEAT ) GO TO 5
      CALL OPEN(*100,IFMGG,Z(IGMGG),OUTRW)
C
C WRITE A TWO WORD BCD HEADER AND CLOSE THE MGG FILE WITHOUT REWIND.
C
      CALL FNAME (IFMGG,Z(1))
      CALL WRITE (IFMGG,Z(1),2,EOR)
      CALL CLOSE (IFMGG,CLSNRW)
C
C ATTEMPT TO OPEN THE BGG FILE.
C
    5 IGBGG = IGMGG
      IOPTB = 0
      CALL OPEN(*10,IFBGG,Z(IGBGG),OUTRW)
      IOPTB = 1
      IGBGG = IGBGG - ISYS
      CALL FNAME (IFBGG,Z(1))
      CALL WRITE (IFBGG,Z(1),2,EOR)
      CALL CLOSE(IFBGG,CLSNRW)
C
C SET UP POINTERS TO GINO BUFFERS AND SET UP MATRIX CONTROL BLOCKS.
C
   10 IGECPT = IGBGG  - ISYS
      IGGPCT = IGECPT - ISYS
      MCBMGG(1) = IFMGG
      MCBMGG(2) = 0
      MCBMGG(3) = 0
      MCBMGG(4) = 6
      MCBMGG(5) = IPREC
      MCBMGG(6) = 0
      MCBMGG(7) = 0
      IF (IOPTB .EQ. 0) GO TO 30
      MCBBGG(1) = IFBGG
      DO 20 I = 2,7
   20 MCBBGG(I) = MCBMGG(I)
C
C ATTEMPT TO READ THE CSTM INTO CORE.
C
   30 NCSTM = 0
      ICSTM = 0
      LEFT = IGGPCT - 1
      CALL OPEN(*50,IFCSTM,Z(IGMGG),INRW)
      CALL FWDREC(*9020,IFCSTM)
      CALL READ(*9030,*40,IFCSTM,Z(1),LEFT,EOR,NCSTM)
C
C IF CORE WAS FILLED WITHOUT HITTING AN EOR CALL MESAGE
C
      CALL MESAGE (-8,IFCSTM,IFCSTM)
   40 LEFT = LEFT - NCSTM
C
C PRETRD SETS UP FUTURE CALLS TO TRANSD.
C
      CALL PRETRD (Z(ICSTM+1),NCSTM)
      CALL PRETRS(Z(ICSTM+1),NCSTM)
      CALL CLOSE (IFCSTM,CLSRW)
   50 IMAT1 = NCSTM
      NMAT1 = 0
      NMAT2 = 0
      NMAT3 = 0
      NMAT4 = 0
      IMAT11 = IMAT1 + 1
C*****
C  IF -HEAT- PROBLEM THEN HMAT IS USED FOR MAT4 AND MAT5 CARDS.
C*****
      IF( .NOT. HEAT ) GO TO 56
      IHMAT = IMAT11 + 1
      NHMAT = IMAT11 + LEFT - 2
      MPTMPT = IFMPT
      IDIT = IFDIT
      CALL HMAT( 0 )
      LEFT = LEFT - NHMAT + IHMAT
      IGPCT = NHMAT +1
      GO TO 58
   56 CALL PREMAT(IZ(IMAT11),Z(IMAT11),Z(IGMGG),LEFT,MATCR,IFMPT,IFDIT)
      LEFT = LEFT - MATCR
      IGPCT = NCSTM + MATCR
C
C OPEN THE ECPT INPUT FILE AND THE GPCT INPUT FILE.
C
   58 CALL OPEN(*9070,IFECPT,Z(IGECPT),INRW)
      CALL FWDREC(*9080,IFECPT)
      CALL OPEN(*9090,IFGPCT,Z(IGGPCT),INRW)
      CALL FWDREC(*9100,IFGPCT)
C
C REOPEN THE MGG OUTPUT FILE WITHOUT REWIND, AND THE BGG, IF CALLED FOR.
C
      IF(.NOT.HEAT)CALL OPEN(*9110,IFMGG,Z(IGMGG),3)
      IF(IOPTB.NE.0)CALL OPEN(*9120,IFBGG,Z(IGBGG),3)
C
C CALL SUBROUTINE SMA2A WHICH WILL PERFORM ALL THE COMPUTATIONS.
C
      CALL SMA2A
C
C CLOSE FILES AND WRITE TRAILERS.
C
      CALL CLOSE (IFGPCT,CLSRW)
      CALL CLOSE (IFECPT,CLSRW)
      CALL CLOSE (IFMGG ,CLSRW)
      MCBMGG(3) = MCBMGG(2)
      IF (MCBMGG(6) .NE. 0) GO TO 70
      DO 60 I = 2,7
   60 MCBMGG(I) = 0
      NOMGG = -1
   70 IF( .NOT. HEAT ) CALL WRTTRL( MCBMGG )
      IF (IOPTB .EQ. 0) GO TO 100
      CALL CLOSE (IFBGG ,CLSRW)
      IF (MCBBGG(6) .EQ. 0) GO TO 80
      MCBBGG(3) = MCBBGG(2)
      CALL WRTTRL (MCBBGG(1))
      NOBGG = 1
      GO TO 100
   80 DO 90 I = 2,7
   90 MCBBGG(I) = 0
      NOBGG = -1
  100 RETURN
C
C SUBROUTINE SMA2 ERROR EXITS.
C
 9020 IFILE = IFCSTM
      GO TO 10002
 9030 IFILE = - IFCSTM
      GO TO 10002
 9070 IFILE = IFECPT
      GO TO 10001
 9080 IFILE = IFECPT
      GO TO 10002
 9090 IFILE = IFGPCT
      GO TO 10001
 9100 IFILE = IFGPCT
      GO TO 10002
 9110 IFILE = IFMGG
      GO TO 10002
 9120 IFILE = IFBGG
      GO TO 10002
10001 IPARM = -1
      GO TO 10010
10002 IPARM = -2
10010 CALL MESAGE (IPARM,IFILE,NMSMA2(1))
      RETURN
      END

      SUBROUTINE RBMG3
C*****
C     SOLVE KLL * DM = -KLR  FOR DM (WHERE LLL IS THE TRI FACTOR)
C     THEN COMPUTE X = KRR + KLR(T) * DM
C     AND ESP = NORM(X) / NORM(KRR)
C*****
      INTEGER       DM    ,SCR1  ,SCR2
C
      DATA    LLL         ,KLR   ,KRR   /101   ,102   ,103   /
     1       ,DM                        /201/
     2       ,SCR1 ,SCR2                /301   ,302   /
C*****
      CALL SOLVER(LLL,DM,KLR,KRR,SCR1,EPS,1,SCR2)
      CALL MESAGE(35,0,EPS)
      RETURN
C
      END

      SUBROUTINE Q2TRMS(RA,RB,RC,ALPHA,ISINTH,ICOSTH,GSUBE,IT,
     1                  IERROR,IOPT,KMAT,PMAT,SMAT,ZMAT)
C*****
C  SUB-TRIANGLE COMPUTATION ROUTINE FOR THE QDMEM2 ELEMENT
C
C  ON INPUT
C  ========
C            RA,RB,RC = 3 (3X1) COORDINATE VECTORS FOR TRIANGLE
C            IOPT     = 1  CALL FROM STIFFNESS GENERATION MODULE
C                     = 2  CALL FROM STATIC LOAD MODULE
C                     = 3  CALL FROM STRESS RECOVERY MODULE
C            ALPHA    = 3X1 VECTOR APPROPRIATE FOR CALL
C            ISINTH   = SIN OF MATERIAL ANGLE(WHOLE - ELEMENT)
C            ICOSTH   = COS OF MATERIAL ANGLE(WHOLE - ELEMENT)
C            GSUBE    = MATERIAL MATRIX (3X3)
C            IT       = THICKNESS OF ELEMENT
C
C  ON OUTPUT
C  =========
C            IERROR = 0  IF NO ERROR
C                   = 1  IF BAD ELEMENT GEOMETRY
C
C            KMAT,PMAT,SMAT,ZMAT = FOLLOWING PER IOPT VALUE SENT
C
C
C            IOPT=1
C            ------
C            KMAT = 7 (3X3)-S = KCA,KCB,KCC,KAA,KAB,KBA,KBB
C            PMAT = UNCHANGED
C            SMAT = UNCHANGED
C            ZMAT = UNCHANGED
C
C            IOPT=2
C            ------
C            KMAT = 3 (3X3)-S = KCA,KCB,KCC
C            PMAT = 3 (3X1)-S = PA,PB,PC
C            SMAT = UNCHANGED
C            ZMAT = UNCHANGED
C
C            IOPT=3
C            ------
C            KMAT = 7 (3X3)-S = KCA,KCB,KCC,KAA,KAB,KBA,KBB
C            PMAT = 3 (3X1)-S = PTA,PTB,PTC
C            SMAT = 3 (3X3)-S = SA,SB,SC
C            ZMAT = 3 (3X1)-S = ZA,ZB,ZC
C
C*****
      REAL              ALPHA(3) ,E(9)     ,IAREAT   ,I33
      REAL              RA(3)    ,KMAT(1)  ,ZMAT(1)  ,MAG      ,IVEC(3)
      REAL              RB(3)    ,PMAT(1)  ,V12(3)   ,IAREA    ,JVEC(3)
      REAL              RC(3)    ,SMAT(1)  ,V13(3)   ,IXSUBB   ,KVEC(3)
      REAL              IC       ,ISINTH   ,CA(6)    ,IXSUBC   ,TM(9)
      REAL              IS       ,ICOSTH   ,CB(6)    ,IYSUBC   ,TM3(3)
      REAL              IT                 ,CC(6)    ,C(3,6)   ,ALP(3)
      REAL              TEMP9(9) ,HI(27)   ,HITGE(9) ,GSUBE(9)
C
      REAL              SADOTB
C
      INTEGER           IPART(3,3)
C
      EQUIVALENCE (C(1,1),CA(1)), (C(1,3),CB(1)), (C(1,5),CC(1))
      EQUIVALENCE (E(1),IVEC(1)), (E(4),JVEC(1)), (E(7),KVEC(1))
C
      DATA IPART/ 28,46,1,   37,55,10,   0,0,19 /
C
C     V    = R   - R   ,      V    = R   - R
C      12     B     A          13     C     B
C
      DO 10 I = 1,3
      V12(I) = RB(I) - RA(I)
      V13(I) = RC(I) - RA(I)
   10 CONTINUE
C
C     KVEC(UN-NORMALIZED)  =  V     X  V
C                              12       13
C
      CALL SAXB( V12, V13, KVEC )
      MAG =  SQRT( SADOTB( KVEC, KVEC ) )
      IF( MAG ) 190,190,20
C
C     NORMALIZE  K-VECTOR, AND AREA
C
   20 KVEC(1) = KVEC(1) / MAG
      KVEC(2) = KVEC(2) / MAG
      KVEC(3) = KVEC(3) / MAG
      IAREA = 0.50 * MAG
C
C     I-VECTOR = V   (NORMALIZED) THUS
C                 12
C
      MAG =  SQRT( SADOTB( V12, V12 ) )
      IF( MAG ) 190,190,30
   30 IVEC(1) = V12(1) / MAG
      IVEC(2) = V12(2) / MAG
      IVEC(3) = V12(3) / MAG
      IXSUBB = MAG
C
C     J-VECTOR = K-VECTOR CROSS I-VECTOR THUS
C
      CALL SAXB( KVEC, IVEC, JVEC )
C
C     MATERIAL COEFFICIENTS C AND S    U,V,W = I-VECTOR
C
      MAG = SQRT( IVEC(1)**2 + IVEC(2)**2 )
      IF( MAG .LE. 0.E0 ) GO TO 190
      IF( MAG .LE. 0 ) GO TO 190
      IC =(IVEC(1)*ICOSTH + IVEC(2)*ISINTH)/MAG
      IS =(IVEC(1)*ISINTH - IVEC(2)*ICOSTH)/MAG
C
C     X = MAGNITUDE OF V  , X = I-VEC DOT V  , Y = J-VEC DOT V
C      B                12   C             13   C             13
C
      IXSUBC = SADOTB( IVEC, V13 )
      IYSUBC = SADOTB( JVEC, V13 )
      IF( IXSUBB ) 40,190,40
   40 IF( IYSUBC ) 50,190,50
C
   50 CA(1) = -1.0E0 / IXSUBB
      CA(2) = 0.0E0
      I33 = 1.0E0 / IYSUBC
      CA(3) = I33 * (IXSUBC/IXSUBB - 1.0E0)
      CA(4) = 0.0E0
      CA(5) = CA(3)
      CA(6) = CA(1)
C
      CB(1) = -CA(1)
      CB(2) = 0.0E0
      CB(3) = - I33   * (IXSUBC / IXSUBB )
      CB(4) = 0.0E0
      CB(5) = CB(3)
      CB(6) = CB(1)
C
      CC(1) = 0.0E0
      CC(2) = 0.0E0
      CC(3) = I33
      CC(4) = 0.0E0
      CC(5) = I33
      CC(6) = 0.0E0
C
C     FORM MATERIAL-ORIENTATION-TRANSFORMATION-MATRIX  (BY-ROWS)
C
      TM(1) = IC * IC
      TM(2) = IS * IS
      TM(3) = IC * IS
      TM(4) = TM(2)
      TM(5) = TM(1)
      TM(6) = -TM(3)
      TM(7) = 2.0E0 * TM(6)
      TM(8) = -TM(7)
      TM(9) = TM(1) - TM(2)
      IAREAT= IAREA * IT
C
C     IF SSG CALL MULTIPLY ALPHA(T-TO) VECTOR BY IAREAT
C
      IF( IOPT .NE. 2 ) GO TO 60
      ALP(1) = ALPHA(1) * IAREAT
      ALP(2) = ALPHA(2) * IAREAT
      ALP(3) = ALPHA(3) * IAREAT
C
C     IF SDR CALL COMPUTE AREA   = X  * T
C                                   B
   60 IF( IOPT .NE. 3 ) GO TO 70
      TM3(1) = TM(3) * IT
      TM3(2) = TM(6) * IT
      TM3(3) = TM(9) * IT
C
C     SET FIRST PARTITION ROW TO COMPUTE FOR STIFFNESS MATRICES.
C
   70 IROW1 = 1
      IF( IOPT .EQ. 2 ) IROW1 = 3
C*****
C           M
C     H  = T  C  E
C      I       I
C
C*****
      DO 80 I = 1,3
      CALL GMMATS( TM,3,3,0, C(1,2*I-1),2,3,1, TEMP9 )
      CALL GMMATS( TEMP9,3,2,0, E,2,3,0, HI(9*I-8) )
   80 CONTINUE
C*****
C     FORM OUTPUTS FOR POINTS I = A,B,C
C*****
      DO 180 I = 1,3
C
C              T
C     HITGE= H  G
C             I  E
C
      CALL GMMATS( HI(9*I-8),3,3,1, GSUBE,3,3,0, HITGE )
C
C     STIFFNESS MATRIX CALCULATIONS
C
C     ONLY KAA,KAB     ARE FORMED.  OUTPUT ORDER WITH EACH 3X3 STORED
C          KBA,KBB                  BY ROWS =
C          KCA,KCB,KCC              KCA,KCB,KCC,KAA,KAB,KBA,KBB
C
      IF( I .LT. IROW1 ) GO TO 150
      KK = 0
      DO 140 J = 1,3
      IPARTN = IPART(I,J)
      IF( IPARTN )140,140,90
   90 DO 100 K = 1,9
      KK = KK + 1
      TEMP9(K) = HI(KK)*IAREAT
  100 CONTINUE
      CALL GMMATS( HITGE,3,3,0, TEMP9,3,3,0, KMAT(IPARTN) )
  140 CONTINUE
  150 GO TO(180,160,170),IOPT
C****
C  SSG LOAD GENERATION CALL ADDITIONAL DATA TO OUTPUT.
C
C  ONLY PA,PB,PC ARE FORMED.
C*****
  160 CALL GMMATS( HITGE,3,3,0,   ALP,3,1,0, PMAT(3*I-2) )
      GO TO 180
C*****
C  SDR ADDITIONAL PHASE-1 STRESS OUTPUTS
C*****
  170 JPARTN = 9*I-8
      CALL GMMATS( GSUBE,3,3,0, HI(JPARTN),3,3,0, SMAT(JPARTN) )
      IPARTN = 3*I - 2
      CALL GMMATS( HITGE,3,3,0, ALPHA,3,1,0, PMAT(IPARTN)  )
      CALL GMMATS( TM3,3,1,1, SMAT(JPARTN),3,3,0, ZMAT(IPARTN) )
      DO 175 J=1,3
      K = IPARTN + J - 1
      PMAT(K) = PMAT(K)*IAREAT
  175 CONTINUE
C
  180 CONTINUE
      IERROR = 0
      RETURN
C*****
C  ERROR CONDITION, BAD GEOMETRY.
C*****
  190 IERROR = 1
      RETURN
      END

      SUBROUTINE SUBPB (I,L,LS,J,SGR,CGR,YREC,ZREC,SUM,XIC,DELX,EE,XLAM,
     1                  SG,CG,YS,ZS,NAS,NASB,AVR,ZB,YB,ARB,XLE,XTE,X,NB)
C
C     COMPUTES ELEMENTS OF THE SUBMATRICES  DPP, DPZ  AND  DPY
C     USING  SUBROUTINES  SNPDF, INCRO AND SUBI
C
      REAL           KR,M
      COMPLEX        DPUR,DPUL,DPLR,DPLL,DP,SUM
      DIMENSION      XIC(1),DELX(1),EE(1),XLAM(1),SG(1),CG(1),YS(1),
     1               ZS(1),NAS(1),NASB(1),AVR(1),ZB(1),YB(1),ARB(1),
     2               XLE(1),XTE(1),X(1)
      COMMON /AMGMN/ MCB(7),NROW,ND,NE,REFC,FMACH,KR
C
      EPS  = 0.00001
      M    = FMACH
      BETA = SQRT(1.0-M*M)
      FL   = REFC
      FLND = FLOAT(ND)
      FLNE = FLOAT(NE)
      SGS  = SG(LS)
      CGS  = CG(LS)
      DPUR = (0.0,0.0)
      DPUL = (0.0,0.0)
      DPLR = (0.0,0.0)
      DPLL = (0.0,0.0)
      DIJ  = 0.0
      DELR = 0.0
      DELI = 0.0
      DIJI = 0.0
      DELRI= 0.0
      DELII= 0.0
      INFL = 0
      IOUTFL = 0
C
C     UPPER RIGHT SENDING POINT
C
      IGO  = 1
      TL   = XLAM(J)
      SQTL = SQRT(1.0+TL**2)
      SL   = TL/SQTL
      CL   = 1.0/SQTL
      X0   = X(I) - XIC(J)
      Y0   = YREC - YS(LS)
      Z0   = ZREC - ZS(LS)
      ES   = EE(LS)
      DXS  = DELX(J)
      AX   = X0
      AY   = Y0
      AZ   = Z0
      CV   = DXS
C
   30 NOBI = 1
      NA2  = 0
      CALL SNPDF (SL,CL,TL,SGS,CGS,SGR,CGR,X0,Y0,Z0,ES,DIJ,BETA,CV)
      IF (KR .LE. EPS) GO TO 40
      SDELX = DXS
      DELY = 2.0*ES
      AX1  = AX + ES*TL
      AY1  = AY + ES*CGS
      AZ1  = AZ + ES*SGS
      AX2  = AX - ES*TL
      AY2  = AY - ES*CGS
      AZ2  = AZ - ES*SGS
      CALL INCRO (AX,AY,AZ,AX1,AY1,AZ1,AX2,AY2,AZ2,SGR,CGR,SGS,CGS,
     1            KR,FL,BETA,SDELX,DELY,DELR,DELI)
   40 IF (NB .EQ. 0) GO TO 120
      NOAS = NAS(L)
C
C     CHECK FOR ASSOCIATED BODIES
C
      IF (NOAS .EQ. 0) GO TO 120
      DIJS  = DIJ
      DELRS = DELR
      DELIS = DELI
      DIJI  = 0.0
      DELRI = 0.0
      DELII = 0.0
      NA1   = NA2 + 1
      NA2   = NA2 + NOAS
      IF (NA2 .GT. NB) NA2 = NB
C
C     START DO-LOOP FOR THE SUMMATION OF THE WING-IMAGE CONTRIBUTIONS
C     OVER  RANGE(P)
C
      DO 110 NA = NA1,NA2
      NOB  = NASB(NA)
C
C     NOB IS THE SEQUENCE NUMBER OF THE CURRENT BODY ASSOCIATED WITH
C     PANEL  L  IN WHICH THE SENDING POINT  J  LIES
C
      NOBI = NOB
      DA   = AVR(NOB)
      DAR  = ARB(NOB)
      DXLE = XLE(NOB)
      DXTE = XTE(NOB)
      GO TO (50,60,70,80), IGO
   50 CONTINUE
      DZB  = ZB(NOB)
      DYB  = YB(NOB)
      DETA = YS(LS)
      DZETA= ZS(LS)
      GO TO  90
   60 CONTINUE
      DZB  = ZB(NOB)
      DYB  =-YB(NOB)
      DETA =-YS(LS)
      DZETA= ZS(LS)
      GO TO  90
   70 CONTINUE
      DZB  =-ZB(NOB)
      DYB  = YB(NOB)
      DETA = YS(LS)
      DZETA=-ZS(LS)
      GO TO  90
   80 CONTINUE
      DZB  =-ZB(NOB)
      DYB  =-YB(NOB)
      DETA =-YS(LS)
      DZETA=-ZS(LS)
   90 CONTINUE
      DCGAM= CGS
      DSGAM= SGS
      DEE  = ES
      DXI  = XIC(J)
      IF (DXI.LT.DXLE .OR. DXI.GT.DXTE) GO TO 110
      CALL SUBI (DA,DZB,DYB,DAR,DETA,DZETA,DCGAM,DSGAM,DEE,DXI,TL,DETAI,
     1           DZETAI,DCGAMI,DSGAMI,DEEI,DTLAMI,DMUY,DMUZ,INFL,IOUTFL)
      DIJ  = 0.0
      IF (INFL.NE.0 .OR. IOUTFL.EQ.0) GO TO 100
      DTL  = DTLAMI
      DSQRTL = SQRT(1.0+DTL**2)
      DSL  = DTL/DSQRTL
      DCL  = 1.0/DSQRTL
      X0I  = X0
      Y0I  = YREC - DETAI
      Z0I  = ZREC - DZETAI
      CALL SNPDF (DSL,DCL,DTL,DSGAMI,DCGAMI,SGR,CGR,X0I,Y0I,Z0I,DEEI,
     1            DIJ,BETA,CV)
      DIJI = DIJI + DIJ
      IF  (KR .LE. EPS) GO TO 100
      DELR = 0.0
      DELI = 0.0
      AYI  = Y0I
      AZI  = Z0I
      AY1I = AYI - DEEI*DCGAMI
      AZ1I = AZI - DEEI*DSGAMI
      AY2I = AYI + DEEI*DCGAMI
      AZ2I = AZI + DEEI*DSGAMI
      DEEI2 = 2.0*DEEI
      CALL INCRO (AX,AYI,AZI,AX1,AY1I,AZ1I,AX2,AY2I,AZ2I,SGR,CGR,DSGAMI,
     1            DCGAMI,KR,FL,BETA,SDELX,DEEI2,DELR,DELI)
      DELRI = DELRI + DELR
      DELII = DELII + DELI
      GO TO 110
  100 CONTINUE
      DELRI = 0.0
      DELII = 0.0
  110 CONTINUE
      DIJ  = DIJS
      DELR = DELRS
      DELI = DELIS
  120 CONTINUE
      DP = CMPLX(((DIJ+DIJI)-(DELR+DELRI)),(-DELI-DELII))
      GO TO (140,150,170,180), IGO
  140 CONTINUE
      DPUR = DP
      IF (ND .EQ. 0) GO TO 160
C
C     UPPER LEFT  SENDING POINT
C
      IGO = 2
      SGS =-SGS
      TL  =-TL
      SL  =-SL
      Y0  = YREC + YS(LS)
      AY  = Y0
      GO TO 30
  150 CONTINUE
      DPUL = DP
  160 CONTINUE
      IF (NE .EQ. 0) GO TO 190
C
C     LOWER RIGHT SENDING POINT
C
      IGO = 3
      TL  = XLAM(J)
      SL  = TL/(SQRT(1.0+TL*TL))
      Y0  = YREC - YS(LS)
      Z0  = ZREC + ZS(LS)
      AY  = Y0
      AZ  = Z0
      SGS =-SG(LS)
      GO TO 30
  170 CONTINUE
      DPLR = DP
      IF (ND .EQ. 0) GO TO 190
C
C     LOWER LEFT  SENDING POINT
C
      IGO = 4
      SGS = SG(LS)
      TL  =-XLAM(J)
      SL  = TL/(SQRT(1.0+TL*TL))
      Y0  = YREC + YS(LS)
      AY  = Y0
      GO TO 30
  180 CONTINUE
      DPLL = DP
  190 CONTINUE
      SUM  = DPUR + FLND*DPUL + FLNE*DPLR + FLND*FLNE*DPLL
      RETURN
      END

      SUBROUTINE DBMSRF (  NAME, IFILEX )
C********************************************************************
C  DBMNAM RETURNS THE UNIT NUMBER ASSOCIATED WITH A DMAP FILE NAME
C     ARGUMENTS
C       NAME    (INPUT) (2A4) DMAP FILE NAME
C       IFILEX  (OUTPUT) (I)  UNIT ASSOCIATED WITH FILE NAME IN FIAT
C********************************************************************
      INTEGER FIST(100), FIAT(100), NAME(2)
      COMMON / XFIST / FIST
      COMMON / XFIAT / FIAT
      LIM  = FIAT(2)*11 + 3
      DO 10 I = 4, LIM, 11
      IF ( NAME( 1 ) .NE. FIAT( I+1 ) .OR. NAME( 2 ) .NE. FIAT( I+2 ) )
     &   GO TO 10
      IFILEX = IAND( FIAT( I ), 32767 )
      GO TO 700
10    CONTINUE
      IFILEX = 0
700   RETURN
      END

      SUBROUTINE SETVAL
C
      EXTERNAL        ANDF,RSHIFT
      INTEGER         ANDF,RSHIFT,P,OSCAR,VPS,SUBNAM(2)
      COMMON /BLANK / P(2,5)
      COMMON /SYSTEM/ KSYSTM(65)
      COMMON /XVPS  / VPS(1)
      COMMON /OSCENT/ OSCAR(1)
      EQUIVALENCE     (KSYSTM(40),NBPW)
      DATA    SUBNAM/ 4HSETV,4HAL   /
C
      J = 12
      DO 100 I = 1,5
C
C     CHECK ODD PARAMETERS TO FIND VARIABLE ONES
C
      IF (ANDF(RSHIFT(OSCAR(J+1),NBPW-1),1) .EQ. 0) GO TO 200
C
C     PARAMETER IS VARIABLE
C
      K = ANDF(OSCAR(J+1),65535)
      P(1,I) = P(2,I)
      VPS(K) = P(1,I)
      J = J + 2
      IF (ANDF(RSHIFT(OSCAR(J),NBPW-1),1) .EQ. 0) J = J + 1
  100 CONTINUE
      GO TO 500
C
  200 CONTINUE
      IF (I .GT. 1) GO TO 500
      CALL MESAGE (-7,0,SUBNAM)
C
  500 CONTINUE
      RETURN
      END

      SUBROUTINE CEAD1A (LAMI,PHIDI,PHIDLI,LAMD,PHID,PHIDL,NFOUND,NVECT,
     * CAPP)
C
C     ROUTINE SORTS LAMI, PHIDI AND PHIDLI (INV. POWER), BASED ON LAMI,
C     AND CREATES LAMD, PHID AND PHIDL
C
      DOUBLE PRECISION ZD(1),D1,D2
      INTEGER PHIDI,PHID,SYSBUF,IZ(1),IH(7),FILE
      INTEGER NAME(2)
      INTEGER CAPP,DET,HES
      INTEGER FILEK,FILEM,FILEB
      INTEGER PHIDLI,PHIDL
C
      COMMON /SYSTEM/ KSYSTM(65)
      COMMON /OUTPUT/HEAD(1)
      COMMON /ZZZZZZ/ Z(1)
      COMMON /CINVPX/ FILEK(7),FILEM(7),FILEB(7)
      COMMON /CONDAS/    PI       ,TWOPI    ,RADEG    ,DEGRA    ,
     1                   S4PISQ
      COMMON /PACKX/ IT1,IT2,II,JJ,INCUR
C
      EQUIVALENCE ( KSYSTM( 1) , SYSBUF )
      EQUIVALENCE (IZ(1),Z(1)),(Z(1),ZD(1))
C
      DATA NAME/4HCEAD,4H1A  /
      DATA IH / 7*0 /
      DATA DET,HES / 4HDET ,4HHESS /
C
C     INITIALIZE POINTER ARRAY
C
      DO 10 I=1,NFOUND
      IZ(I)= I
   10 CONTINUE
C
C     BRING IN  EIGENVALUES
C
      ILAMA =(NFOUND+1)/2  +1
      IBUF = KORSZ(IZ)-SYSBUF+1
      FILE = LAMI
      CALL OPEN(*170,LAMI,IZ(IBUF),0)
      K =ILAMA
      DO 20 I=1,NFOUND
      CALL READ(*190,*200,LAMI,ZD(K),4,1,IFLAG)
      K= K +2
   20 CONTINUE
      CALL CLOSE(LAMI,1)
      IF(NFOUND .EQ.1) GO TO 70
C
C
C     SORT ON SIGN IMAGINARY THEN ON MAG IMAG
C
      JJ = NFOUND-1
      DO 60 I=1,JJ
      II = I+1
      M  = ILAMA+ 2*I -2
      DO 50 J=II,NFOUND
      L =  ILAMA +2*J-2
C
C     SIGN IMAG
C
      D1 = DSIGN(1.0D0,ZD(L+1))
      D2 = DSIGN(1.0D0,ZD(M+1))
      IF(D1 .EQ. D2) GO TO 40
      IF( D1 .EQ. 1.0D0)GO TO 50
C
C     SWITCH
C
   30 D1 = ZD(L)
      ZD(L) =ZD(M)
      ZD(M)=D1
      D1 =ZD(L+1)
      ZD(L+1)=ZD(M+1)
      ZD(M+1)=D1
      IT1 = IZ(J)
      IZ(J)= IZ(I)
      IZ(I)= IT1
      GO TO 50
C
C     TEST MAGNITIDE IMAG
C
   40 IF(DABS(ZD(L+1)) -DABS(ZD(M+1))) 30,50,50
   50 CONTINUE
   60 CONTINUE
C
C     PUT OUT LAMA-S IN ORDER GIVEN BY LIST
C
   70 CALL GOPEN(LAMD,IZ(IBUF),1)
      IH(2) =1006
      IH(1) = 90
      CALL WRITE(LAMD,  IH, 4,0)
      IH(6) = 6
      CALL WRITE(LAMD,  IH, 6,0)
      CALL WRITE(LAMD,  IZ,40,0)
      CALL WRITE(LAMD,HEAD,96,1)
      L = 5*NFOUND +2
      DO 90 I=1,NFOUND
      IZ(L)=I
      IZ(L+1)=IZ(I)
      K = 2*I-2+ILAMA
      Z(L+2) =ZD(K)
      Z(L+3) = ZD(K+1)
      Z(L+4) = 0.0
      Z(L+5) = 0.0
      IF(ABS(Z(L+3)) .LE. 1.0E-3*ABS(Z(L+2))) GO TO 80
      Z(L+4) = ABS(Z(L+3))/TWOPI
      Z(L+5) = -2.0*Z(L+2)/ABS(Z(L+3))
   80 CALL WRITE(LAMD,IZ(L),6,0)
   90 CONTINUE
      CALL CLOSE(LAMD,1)
      IH(1) =LAMD
      CALL WRTTRL(IH)
C
C     BRING IN PHIDI IN ORDER NEEDED AND OUTPUT
C
      IBUF1 = IBUF -SYSBUF
      CALL GOPEN(PHID,IZ(IBUF1),1)
      IT1 = 4
      IT2 = 3
      INCUR =1
      II =1
      IH(1)=PHID
      IH(2)= 0
      IH(4) =2
      IH(5) =3
      IH(6) = 0
      K = 1
  101 IF(IZ(K) .LE. NVECT) GO TO 111
      K = K+1
      GO TO 101
  111 FILE = PHIDI
      IPOS =1
      CALL OPEN(*170,PHIDI,IZ(IBUF),0)
      DO 160 I=1,NVECT
      IF (NVECT .EQ. 1) GO TO 130
  100 L= IZ(I)-IPOS
      IF(L) 150,130,110
  110 CALL SKPREC(PHIDI,L)
C
C     BRING IN EIGENVECTORS
C
  130 CALL READ(*190,*140,PHIDI,ZD(ILAMA),IBUF1-1,0,M)
      GO TO 210
  140 JJ= M/4
      IPOS = IZ(K) +1
      CALL PACK(ZD(ILAMA),PHID,IH)
      GO TO 159
C
C     PAST VECTOR NEEDED
C
  150 CALL REWIND(PHIDI)
      IPOS =1
      GO TO 100
  159 K = K+1
  160 CONTINUE
      CALL CLOSE(PHID,1)
      CALL CLOSE(PHIDI,1)
      IH(3) =JJ
      CALL WRTTRL(IH)
C
C     OUTPUT PHIDL IF NOT PURGED AND IF AT LEAST ONE INPUT MATRIX IS
C     UNSYMMETRIC
C
      IH(1) = PHIDL
      CALL RDTRL (IH)
      IF (IH(1) .LT. 0) RETURN
      IF (CAPP .NE. DET .AND. CAPP .NE. HES) GO TO 301
      FILEK(1) = 101
      CALL RDTRL (FILEK)
      FILEM(1) = 103
      CALL RDTRL (FILEM)
      FILEB(1) = 102
      CALL RDTRL (FILEB)
  301 IF (FILEK(1) .GT. 0 .AND. FILEK(4) .NE. 6) GO TO 302
      IF (FILEM(1) .GT. 0 .AND. FILEM(4) .NE. 6) GO TO 302
      IF (FILEB(1) .GT. 0 .AND. FILEB(4) .NE. 6) GO TO 302
      RETURN
  302 CALL GOPEN (PHIDL,IZ(IBUF1),1)
      CALL MAKMCB (IH,PHIDL,0,2,3)
      IF (CAPP .NE. DET .AND. CAPP .NE. HES) GO TO 305
      CALL CLVEC (LAMD,NVECT,PHIDL,IH,IBUF,IBUF1)
      GO TO 395
  305 K = 1
  310 IF (IZ(K) .LE. NVECT) GO TO 320
      K = K + 1
      GO TO 310
  320 FILE = PHIDLI
      IPOS = 1
      CALL OPEN(*170,PHIDLI,IZ(IBUF),0)
      DO 390 I=1,NVECT
      IF (NVECT .EQ. 1) GO TO 350
  330 L = IZ(I) - IPOS
      IF (L) 370,350,340
  340 CALL SKPREC (PHIDLI,L)
C
C     BRING IN LEFT EIGENVECTORS
C
  350 CALL READ(*190,*360,PHIDLI,ZD(ILAMA),IBUF1-1,0,M)
      GO TO 210
  360 JJ = M/4
      IPOS = IZ(K) + 1
      CALL PACK (ZD(ILAMA),PHIDL,IH)
      GO TO 380
C
C     PAST VECTOR NEEDED
C
  370 CALL REWIND (PHIDLI)
      IPOS = 1
      GO TO 330
  380 K = K + 1
  390 CONTINUE
      CALL CLOSE (PHIDLI,1)
  395 CALL CLOSE (PHIDL,1)
      IH(3) = JJ
      CALL WRTTRL (IH)
      RETURN
C
C     ERROR MESAGES
C
  170 IP1 =-1
  180 CALL MESAGE(IP1,FILE,NAME)
  190 IP1 =-2
      GO TO 180
  200 IP1 = -3
      GO TO 180
  210 IP1 = -8
      GO TO 180
      END

      SUBROUTINE XRGNUM
C
C     XRGNUM PROCESSES THE NUMBER ON A CARD OR FILE NAME TABLE ENTRY
C     THIS ROUTINE IS CALLED ONLY BY XRGDTB
C
C     WRITTEN BY  RPK CORPORATION; DECEMBER, 1983
C
C     INPUT
C       /SYSTEM/
C         OPTAPE       UNIT NUMBER FOR THE OUTPUT PRINT FILE
C       /XRGDXX/
C         ICHAR        CONTAINS THE CARD IMAGE IN 80A1 FORMAT
C         ICOL         CURRENT COLUMN BEING PROCESSED
C         RECORD       CONTAINS THE CARD IMAGE IN 20A4 FORMAT
C
C     OUTPUT
C       /XRGDXX/
C         ICOL         CURRENT COLUMN BEING PROCESSED
C         NUMBER       VALUE OF THE NUMBER IN INTEGER FORMAT
C
C     LOCAL VARIABLES
C         BLANK          CONTAINS THE VALUE 1H
C         IFRCOL         FIRST COLUMN TO BE EXAMINED BY XRGNUM
C         NEWNUM         INTEGER VALUE OF THE CHARACTER IN THE CURRENT
C                        COLUMN
C         NUMS           CONTAINS THE ALPHA VALUES 1,2,...0
C
C     THE CARD IS SCANED TO FIND THE VALUE OF THE NUMBER IN THE FIRST
C     FIELD OF THE CARD
C
C     MESSAGE 8030 MAY BE ISSUED
C
      INTEGER         RECORD, OPTAPE, BLANK , NUMS(10)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /XRGDXX/ IRESTR, NSUBST, IPHASE, ICOL  , NUMBER, ITYPE ,
     1                ISTATE, IERROR, NUM(2), IND   , NUMENT,
     2                RECORD(20)    , ICHAR(80)     , LIMIT(2),
     3                ICOUNT, IDMAP , ISCR  ,NAME(2), MEMBER(2),
     4                IGNORE
      COMMON /SYSTEM/ ISYSBF, OPTAPE, DUM(98)
      DATA    NUMS  / 1H1, 1H2, 1H3, 1H4, 1H5, 1H6, 1H7, 1H8, 1H9, 1H0/
      DATA    BLANK / 1H  /
C
      IFRCOL = ICOL
      NUMBER = 0
 50   IF (ICOL .GE. 80) GO TO 350
      IF (ICHAR(ICOL) .EQ. BLANK) GO TO 200
      DO 100 K = 1,10
      IF (ICHAR(ICOL) .NE. NUMS(K)) GO TO 100
      NEWNUM = MOD(K,10)
      NUMBER = NUMBER*10 + NEWNUM
      GO TO 150
 100  CONTINUE
      GO TO 250
 150  ICOL = ICOL + 1
      GO TO 50
 200  ICOL = ICOL + 1
      IF (NUMBER .EQ. 0) GO TO 50
      GO TO 350
 250  NUMBER = 0
      J = 0
      K = 1
      WRITE  (OPTAPE,300) UFM,IFRCOL,RECORD,J,(I,I=1,8),K,(J,I=1,8)
 300  FORMAT (A23,' 8030, EXPECTED AN INTEGER NEAR COLUMN',I3,
     1        ' IN THE FOLLOWING CARD', //20X,20A4, /,(20X,I1,I9,7I10))
 350  RETURN
      END

      SUBROUTINE TMTSIO (*,DEBUG1)
C
C     TMTSIO TIME TESTS GINO AND THE PACK ROUTINES
C
C     COMMENT FORM G.CHAN/UNISYS   5/91
C     BASICALLY THIS ROUTINE IS SAME AS TIMTS1.
C
      INTEGER         SYSBUF, OUTPUT, FILES(2), F1 , F2, BUF1  , BUF2  ,
     1                END   , MCB(7), EOL     , EOR    , TYPE  , TYPIN1,
     2                TYPOU1, TYPOU2, ABLK(15), BBLK(15),ZERO  , DEBUG1,
     3                ISUBR(2)
      REAL            X(1)  , Z(1)  , T(23)
      DOUBLE  PRECISION       ZD    , XD
      CHARACTER       UFM*23, UWM*25, UIM*29  , SFM*25
      COMMON /XMSSG / UFM   , UWM   , UIM     , SFM
      COMMON /NTIME / NITEMS, TGINO , TBLDPK  , TINTPK , TPACK ,
     1                TUNPAK, TGETST, TPUTST  ,
     2                TTLRSP, TTLRDP, TTLCSP  , TTLCDP ,
     3                TLLRSP, TLLRDP, TLLCSP  , TLLCDP , TGETSB
     *                      , RGINO , RBLDPK  , RINTPK , RPCK   ,
     *                        RUNPAK, RGETST  , RPUTST
      COMMON /SYSTEM/ SYSBUF, OUTPUT, IDUM(52), IPREC  , JDUM(21), ISY77
      COMMON /GINOX / G(86) , IG(75), NBUFF3  , PU(226), IWR(75)
      COMMON /ZBLPKX/ ZD(2),  IZ
      COMMON /ZNTPKX/ XD(2),  IX    , EOL     , EOR
      COMMON /PACKX / TYPIN1, TYPOU1, I1 , J1 , INCR1
      COMMON /UNPAKX/ TYPOU2, I2, J2, INCR2
      COMMON /ZZZZZZ/ A(1)
      EQUIVALENCE     (ZD(1),Z(1)), (XD(1),X(1)), (T(1),TGINO)
      DATA    FILES / 301, 304/, ZERO  / 0    /
      DATA    I1000 / 1000    /, I1001 / 1001 /
      DATA    ISUBR / 4HTMTS   , 4HIO  /
C
C
C     CHECK KORSZ AND DUMMY SUBROUTINES HERE.
C     IF NASTRAN SUBROUTINES WERE NOT COMPILED WITH STATIC OPTION, BUF1
C     COULD BE NEGATIVE HERE.
C     CALL DUMMY NEXT TO SEE WHETHER THE RIGHT DUMMY ROUTINE IS SET UP
C     FOR THIS MACHINE
C
      KERR = 1
      BUF1 = KORSZ(A)
      IF (BUF1 .LE. 0) GO TO 930
      IF (DEBUG1 .GT. 0) WRITE (OUTPUT,10)
   10 FORMAT (' -LINK1 DEBUG- TMTSIO CALLINS DUMMY NEXT')
CWKBD CALL DUMMY
C
C     NOTE - ISY77 (WHICH IS BULKDATA OPTION) AND TGINO DETERMINE TO
C            SKIP TMTSIO AND TMTSLP OR NOT. DIAG 35 CAN NOT BE USED AT
C            THIS POINT SINCE THE DIAG CARD HAS NOT BEEN READ YET.
C
      IF (TGINO.GT.0. .AND. ISY77.NE.-3) RETURN 1
C
C     INITIALIZE
C
      CALL PAGE1
      WRITE  (OUTPUT,20)
   20 FORMAT ('0*** USER INFORMATION MESSAGE 225, GINO TIME CONSTANTS ',
     1        'ARE BEING COMPUTED', /5X,
     2       '(SEE NASINFO FILE FOR ELIMINATION OF THESE COMPUTATIONS)')
      IF (TGINO .GT. 0.) WRITE (OUTPUT,30) T
   30 FORMAT ('0*** EXISTING TIME CONSTANTS IN /NTIME/ -',
     1        /,2(/5X,9F8.3))
      N = 50
      M = N
      TYPE = IPREC
C     NITEMS = 23
C
      F1   = FILES(1)
      F2   = FILES(2)
      BUF1 = BUF1 - SYSBUF
      BUF2 = BUF1 - SYSBUF
      END  = N*M
      IF (END .GE. BUF1-1) CALL MESAGE (-8,0,ISUBR)
      DO 40 I = 1,END
      A(I) = I
   40 CONTINUE
      N10 = N*10
      M10 = M/10
      IF (M10 .LE. 0) M10 = 1
      FN  = N
      FM  = M
C
C     WRITE TEST
C
      IF (DEBUG1 .GT. 0) WRITE (OUTPUT,50) NBUFF3,IG
   50 FORMAT (' -LINK1 DEBUG- OPEN OUTPUT FILE NEXT FOR WRITE. NBUFF3 ='
     1,       I5, /5X,'GINO BUFADD 75 WORDS =', /,(2X,11I7))
      CALL OPEN (*900,F1,A(BUF1),1)
      IF (DEBUG1 .LE. 0) GO TO 60
      WRITE  (OUTPUT,53) NBUFF3,IG
   53 FORMAT (' -LINK1 DEBUG- FILE OPEN OK. NBUFF3 =',I5, /5X,
     1        'GINO BUFADD 75 WORDS =', /,(2X,11I7))
      WRITE  (OUTPUT,55) IWR(41)
   55 FORMAT (5X,'RWFLG(41) =',I7, //,
     1        ' -LINK1 DEBUG- CALLING SECOND NEXT')
   60 CALL CPUTIM (T1,T1,1)
      DO 70 I = 1,N
      CALL WRITE (F1,A,M,1)
   70 CONTINUE
      CALL CPUTIM (T2,T2,1)
      IF (DEBUG1 .GT. 0) WRITE (OUTPUT,80)
   80 FORMAT (' -LINK1 DEBUG- CLOSE FILE NEXT')
      CALL CLOSE  (F1,1)
      IF (DEBUG1 .GT. 0) WRITE (OUTPUT,90)
   90 FORMAT (' -LINK1 DEBUG- OPEN ANOTHER OUTPUT FILE NEXT FOR WRITE')
      CALL OPEN   (*900,F2,A(BUF2),1)
      CALL CPUTIM (T3,T3,1)
      DO 100 I = 1,N10
      CALL WRITE (F2,A,M10,1)
  100 CONTINUE
      CALL CPUTIM (T4,T4,1)
      CALL CLOSE  (F2,1)
      ASSIGN 610 TO IRET
      GO TO 600
C
C     READ TEST
C
  110 IF (DEBUG1 .GT. 0) WRITE (OUTPUT,120)
  120 FORMAT (' -LINK1 DEBUG- OPEN INPUT FILE NEXT FOR READ')
      CALL OPEN (*900,F1,A(BUF1),0)
      CALL CPUTIM (T1,T1,1)
      DO 130 I = 1,N
      CALL READ (*910,*920,F1,A(I1000),M,1,FLAG)
  130 CONTINUE
      CALL CPUTIM (T2,T2,1)
      CALL CLOSE  (F1,2)
      CALL OPEN   (*900,F2,A(BUF2),0)
      CALL CPUTIM (T3,T3,1)
      DO 140 I = 1,N10
      CALL READ (*910,*920,F2,A(I1000),M10,1,FLAG)
  140 CONTINUE
      CALL CPUTIM (T4,T4,1)
      CALL CLOSE  (F2,2)
      ASSIGN 620 TO IRET
      GO TO 600
C
C     BACKWARD READ TEST
C
  150 CONTINUE
      CALL OPEN (*900,F1,A(BUF1),2)
      CALL CPUTIM (T1,T1,1)
      DO 160 I = 1,N
      CALL BCKREC (F1)
      CALL READ   (*910,*920,F1,A(I1000),M,1,FLAG)
      CALL BCKREC (F1)
  160 CONTINUE
      CALL CPUTIM (T2,T2,1)
      CALL CLOSE  (F1,1)
      CALL OPEN   (*900,F2,A(BUF2),2)
      CALL CPUTIM (T3,T3,1)
      DO 170 I = 1,N10
      CALL BCKREC (F2)
      CALL READ   (*910,*920,F2,A(I1000),M10,1,FLAG)
      CALL BCKREC (F2)
  170 CONTINUE
      CALL CPUTIM (T4,T4,1)
      CALL CLOSE  (F2,1)
      ASSIGN 630 TO IRET
      GO TO 600
C
C     BLDPK TEST
C
  180 CONTINUE
      CALL OPEN   (*900,F1,A(BUF1),1)
      CALL MAKMCB (MCB,F1,M,2,TYPE)
      CALL CPUTIM (T1,T1,1)
      DO 200 I = 1,N
      CALL BLDPK (TYPE,TYPE,F1,0,0)
      DO 190 J = 1,M
      Z(1) = 1.0
      IZ   = J
      CALL ZBLPKI
  190 CONTINUE
      CALL BLDPKN (F1,0,MCB)
  200 CONTINUE
      CALL CPUTIM (T2,T2,1)
      CALL WRTTRL (MCB)
      CALL CLOSE  (F1,1)
      CALL MAKMCB (MCB,F2,M10,2,TYPE)
      CALL OPEN   (*900,F2,A(BUF2),1)
      CALL CPUTIM (T3,T3,1)
      DO 220 I = 1,N10
      CALL BLDPK (TYPE,TYPE,F2,0,0)
      DO 210 J = 1,M10
      Z(1) = 2.0
      IZ   = J
      CALL ZBLPKI
  210 CONTINUE
      CALL BLDPKN (F2,0,MCB)
  220 CONTINUE
      CALL CPUTIM (T4,T4,1)
      CALL WRTTRL (MCB)
      CALL CLOSE  (F2,1)
      ASSIGN 640 TO IRET
      GO TO 600
C
C     INTPK TEST
C
  230 CONTINUE
      CALL OPEN   (*900,F1,A(BUF1),0)
      CALL CPUTIM (T1,T1,1)
      DO 250 I = 1,N
      CALL INTPK  (*910,F1,0,TYPE,0)
      DO 240 J = 1,M
      CALL ZNTPKI
      IF (IX  .NE. J) GO TO 800
      IF (EOL .EQ. 0) GO TO 240
      IF (IX  .NE. M) GO TO 800
  240 CONTINUE
      IF (EOL .EQ. 0) GO TO 800
  250 CONTINUE
      CALL CPUTIM (T2,T2,1)
      CALL CLOSE  (F1,1)
      CALL OPEN   (*900,F2,A(BUF2),0)
      CALL CPUTIM (T3,T3,1)
      DO 270 I = 1,N10
      CALL INTPK (*910,F2,0,TYPE,0)
      DO 260 J = 1,M10
      CALL ZNTPKI
      IF (IX  .NE. J) GO TO 800
      IF (EOL .EQ. 0) GO TO 260
      IF (IX  .NE. M10) GO TO 800
  260 CONTINUE
      IF (EOL .EQ. 0) GO TO 800
  270 CONTINUE
      CALL CPUTIM (T4,T4,1)
      CALL CLOSE  (F2,1)
      ASSIGN 650 TO IRET
      GO TO 600
C
C     PACK TEST
C
  280 CONTINUE
      CALL MAKMCB (MCB,F1,M,2,TYPE)
      TYPIN1 = TYPE
      TYPOU1 = TYPE
      I1     = 1
      J1     = M
      INCR1  = 1
      MX     = M*TYPE
      DO 290 I = 1,MX
      A(I+1000) = I
  290 CONTINUE
      CALL OPEN (*900,F1,A(BUF1),1)
      CALL CPUTIM (T1,T1,1)
      DO 300 I = 1,N
      CALL PACK (A(I1001),F1,MCB)
  300 CONTINUE
      CALL CPUTIM (T2,T2,1)
      CALL WRTTRL (MCB)
      CALL CLOSE  (F1,1)
      CALL MAKMCB (MCB,F2,M10,2,TYPE)
      J1 = M10
      CALL OPEN (*900,F2,A(BUF2),1)
      CALL CPUTIM (T3,T3,1)
      DO 310 I = 1,N10
      CALL PACK (A(I1001),F2,MCB)
  310 CONTINUE
      CALL CPUTIM (T4,T4,1)
      CALL WRTTRL (MCB)
      CALL CLOSE  (F2,1)
      ASSIGN 660 TO IRET
      GO TO 600
C
C     UNPACK TEST
C
  320 CONTINUE
      TYPOU2 = TYPE
      I2     = 1
      J2     = M
      INCR2  = 1
      CALL OPEN (*900,F1,A(BUF1),0)
      CALL CPUTIM (T1,T1,1)
      DO 330 I = 1,N
      CALL UNPACK (*910,F1,A(I1001))
  330 CONTINUE
      CALL CPUTIM (T2,T2,1)
      CALL CLOSE  (F1,1)
      J2 = M10
      CALL OPEN (*900,F2,A(BUF2),0)
      CALL CPUTIM (T3,T3,1)
      DO 340 I = 1,N10
      CALL UNPACK (*910,F2,A(I1001))
  340 CONTINUE
      CALL CPUTIM (T4,T4,1)
      CALL CLOSE  (F2,2)
      ASSIGN 670 TO IRET
      GO TO 600
  350 CONTINUE
C
C     PUTSTR TEST
C
      KERR    = 2
      ABLK(1) = F1
      ABLK(2) = TYPE
      ABLK(3) = 1
      CALL GOPEN (F1,A(BUF1),1)
      NWDS = TYPE
      IF (TYPE .EQ. 3) NWDS = 2
      CALL CPUTIM (T1,T1,1)
      DO 400 I = 1,N
      ABLK(4) = 0
      ABLK(8) = -1
      DO 390 J = 1,10
      NBRSTR  = M10
  360 CALL PUTSTR (ABLK)
      IF (NBRSTR .EQ. 0) GO TO 930
      ABLK(7) = MIN0(ABLK(6),NBRSTR)
      ABLK(4) = ABLK(4) + ABLK(7) + 4
      MM      = ABLK(7)*NWDS
      DO 370 K = 1,MM
      X(1) = A(K)
  370 CONTINUE
      IF (ABLK(7) .EQ. NBRSTR) GO TO 380
      CALL ENDPUT (ABLK)
      NBRSTR = NBRSTR - ABLK(7)
      GO TO 360
  380 IF (J .EQ. 10) ABLK(8) = 1
      CALL ENDPUT (ABLK)
  390 CONTINUE
  400 CONTINUE
      CALL CPUTIM (T2,T2,1)
      CALL CLOSE (F1,1)
      M100 = MAX0(M10/10,1)
      CALL GOPEN (F2,A(BUF2),1)
      KERR    = 3
      BBLK(1) = F2
      BBLK(2) = TYPE
      BBLK(3) = 1
      CALL CPUTIM (T3,T3,1)
      DO 450 I = 1,N10
      BBLK(4) = 0
      BBLK(8) =-1
      DO 440 J = 1,10
      NBRSTR = M100
  410 CALL PUTSTR (BBLK)
      IF (NBRSTR .EQ. 0) GO TO 930
      BBLK(7) = MIN0(BBLK(6),NBRSTR)
      BBLK(4) = BBLK(4) + BBLK(7) + 4
      MM = BBLK(7)*NWDS
      DO 420 K = 1,MM
      X(1) = A(K)
  420 CONTINUE
      IF (BBLK(7) .EQ. NBRSTR) GO TO 430
      NBRSTR = NBRSTR - BBLK(7)
      GO TO 410
  430 IF (J .EQ. 10) BBLK(8) = 1
      CALL ENDPUT (BBLK)
  440 CONTINUE
  450 CONTINUE
      CALL CPUTIM (T4,T4,1)
      CALL CLOSE  (F2,1)
      ASSIGN 680 TO IRET
      GO TO 600
C
C     GETSTR TEST (GET STRING FORWARD)
C
  460 CONTINUE
      CALL GOPEN (F1,A(BUF1),0)
      CALL CPUTIM (T1,T1,1)
      DO 490 I = 1,N
      ABLK(8) = -1
  470 CALL GETSTR (*490,ABLK)
      MM = ABLK(6)*NWDS
      DO 480 K = 1,MM
      X(1) = A(K)
  480 CONTINUE
      CALL ENDGET (ABLK)
      GO TO 470
  490 CONTINUE
      CALL CPUTIM (T2,T2,1)
C     CALL CLOSE  (F1,1)
      CALL GOPEN  (F2,A(BUF2),0)
      CALL CPUTIM (T3,T3,1)
      DO 520 I = 1,N10
      BBLK(8) = -1
  500 CALL GETSTR (*520,BBLK)
      MM = BBLK(6)*NWDS
      DO 510 K = 1,MM
      X(1) = A(K)
  510 CONTINUE
      CALL ENDGET (BBLK)
      GO TO 500
  520 CONTINUE
      CALL CPUTIM (T4,T4,1)
C     CALL CLOSE  (F2,1)
      ASSIGN 690 TO IRET
      GO TO 600
C
C     GETSTB TEST, (GET BACKWARD STRING)
C     F1 AND F2 FILES ARE STILL OPENED, AND POSITIONED AT THE END
C
  530 CONTINUE
C     CALL GOPEN (F1,A(BUF1),0)
C     CALL REWIND (F1)
C     CALL SKPFIL (F1,N+1)
      CALL CPUTIM (T1,T1,1)
      DO 560 I = 1,N
      ABLK(8) = -1
  540 CALL GETSTB (*560,ABLK)
      MM = ABLK(6)*NWDS
      DO 550 K = 1,MM
      X(1) = A(K)
  550 CONTINUE
      CALL ENDGTB (ABLK)
      GO TO 540
  560 CONTINUE
      CALL CPUTIM (T2,T2,1)
      CALL CLOSE  (F1,1)
C     CALL GOPEN  (F2,A(BUF2),0)
C     CALL REWIND (F2)
C     CALL SKPFIL (F2,N10+1)
      CALL CPUTIM (T3,T3,1)
      DO 590 I = 1,N10
      BBLK(8) = -1
  570 CALL GETSTB (*590,BBLK)
      MM = BBLK(6)*NWDS
      DO 580 K = 1,MM
      X(1) = A(K)
  580 CONTINUE
      CALL ENDGTB (BBLK)
      GO TO 570
  590 CONTINUE
      CALL CPUTIM (T4,T4,1)
      CALL CLOSE  (F2,1)
      ASSIGN 700 TO IRET
C
C     INTERNAL ROUTINE TO STORE TIMING DATA IN /NTIME/ COMMON BLOCK
C
  600 CONTINUE
      TIME1  = T2 - T1
      TIME2  = T4 - T3
      TPRREC = 1.0E6*(TIME2 - TIME1)/(9.0*FN)
      TPRWRD = (1.0E6*TIME1 - FN*TPRREC)/(FN*FM)
      GO TO IRET, (610,620,630,640,650,660,670,680,690,700)
  610 TGINO  = TPRWRD
      RGINO = TPRREC
      GO TO 110
  620 TGINO  = TGINO + TPRWRD
      RGINO  = RGINO + TPRREC
      GO TO 150
  630 TGINO  = TGINO + TPRWRD
      TGINO  = TGINO/3.0
      RGINO  = RGINO + TPRREC
      RGINO  = RGINO/3.0
      GO TO 180
  640 TBLDPK = TPRWRD
      RBLDPK = TPRREC
      GO TO 230
  650 TINTPK = TPRWRD
      RINTPK = TPRREC
      GO TO 280
  660 TPACK  = TPRWRD
      RPACK  = TPRREC
      GO TO 320
  670 TUNPAK = TPRWRD
      RUNPAK = TPRREC
      GO TO 350
  680 TPUTST = TPRWRD
      RPUTST = TPRREC
      GO TO 460
  690 TGETST = TPRWRD
      RGETST = TPRREC
      GO TO 530
  700 TGETSB = TPRWRD
      IF (DEBUG1 .GT. 0) WRITE (OUTPUT,710)
  710 FORMAT (' -LINK1 DEBUG- TMTSIO FINISHED')
      RETURN
C
C     INTERNAL ROUTINE CALLED FOR AN ABORT IN THE INTPK TEST
C
  800 WRITE  (OUTPUT,810) SFM
  810 FORMAT (A25,' 2197, ABORT CALLED DURING TIME TEST OF INTPK')
C
C     ABNORMAL RETURNS FROM GINO - ALL FATAL ERRORS
C
  900 CONTINUE
  910 CONTINUE
  920 CALL MESAGE (-61,0,0)
  930 WRITE  (OUTPUT,940) KERR
  940 FORMAT ('0*** TMTSIO FATAL ERROR',I7)
      GO TO 920
      END

      SUBROUTINE STPPT2(INPUT,W1JK,W2JK)
      INTEGER W1JK,W2JK
      COMPLEX ONE,ZERO
      COMMON /PACKX/ ITI,IT0,II,NN,INCR
      COMMON /AMGP2/ TW1JK(7),TW2JK(7)
      ONE = (1.0,0.0)
      ZERO = (0.0,0.0)
      CALL FREAD(INPUT,NJ,1,1)
      DO 10 I=1,NJ
      NN = II
      CALL PACK(ONE,W1JK,TW1JK)
      CALL PACK(ZERO,W2JK,TW2JK)
      II = II+1
   10 CONTINUE
      RETURN
      END

      SUBROUTINE AXLOOP (BUF,IBUF,XX,YY,ZZ,HC1,HC2,HC3)
C
      INTEGER         OTPE
      DIMENSION       BUF(50),IBUF(50)
      CHARACTER       UFM*23,UWM*25
      COMMON /XMSSG / UFM,UWM
      COMMON /SYSTEM/ SYSBUF,OTPE
      COMMON /BLANK / IDUM(3),EPSE
C
      PI    = 3.1415926536
      PIBY2 = 1.5707963268
      FPI   = 12.56637062
      C     = 1.
C
      XJ  = BUF(1)
      IAXI= IBUF(2)
      X1  = BUF(3)
      Y1  = BUF(4)
      Z1  = BUF(5)
      X2  = BUF(6)
      Y2  = BUF(7)
      Z2  = BUF(8)
      XC  = BUF(9)
      YC  = BUF(10)
      ZC  = BUF(11)
C
C     FOR NOW, ICID = 0
C
      ICID = IBUF(12)
C
C     CHECK FOR AXISYMMETRIC PROBLEM
C
      IF (IAXI .NE. 1) GO TO 10
      XC = 0.
      YC = 0.
      ZC = Z1
      X2 = 0.
      Y2 = X1
      Z2 = Z1
   10 CONTINUE
C
C     DETERMINE THE DIRECTION OF THE CURRENT LOOP AXIS
C
      CX = X1 - XC
      CY = Y1 - YC
      CZ = Z1 - ZC
      BX = X2 - XC
      BY = Y2 - YC
      BZ = Z2 - ZC
C
C     THE VECTOR AN IS NORMAL TO THE PLANE OF THE LOOP
C
      ANX = CY*BZ - CZ*BY
      ANY = CZ*BX - CX*BZ
      ANZ = CX*BY - CY*BX
      AT1 = SQRT(ANX*ANX + ANY*ANY + ANZ*ANZ)
      AT2  = BX*BX + BY*BY + BZ*BZ
      RAD2 = CX*CX + CY*CY + CZ*CZ
      RADIUS = SQRT(RAD2)
      XIACPI = (XJ*RAD2*PI)/C
C
      ANX = ANX/AT1
      ANY = ANY/AT1
      ANZ = ANZ/AT1
C
C     THE VECTOR R IS FROM THE CENTER OF LOOP TO THE FIELD POINT
C
      RX = XX - XC
      RY = YY - YC
      RZ = ZZ - ZC
C
      R2 = RX*RX + RY*RY + RZ*RZ
      R  = SQRT(R2)
C
C     AT (OR NEAR) CENTER OF LOOP TEST
C
      IF (R .GE. .001) GO TO 218
      COSTHE = 1.
      SINTHE = 0.
      SQAR2S = SQRT(RAD2+R2)
      RX  = ANX
      RY  = ANY
      RZ  = ANZ
      RPX = 0.
      RPY = 0.
      RPZ = 0.
      GO TO 220
  218 CONTINUE
C
      RX = RX/R
      RY = RY/R
      RZ = RZ/R
      COSTHE = ANX*RX + ANY*RY + ANZ*RZ
      SINTHE = SQRT(1. - COSTHE*COSTHE)
C
C     ON (OR VERY NEAR) AXIS OF LOOP TEST
C
      IF (SINTHE .GE. .000001) GO TO 219
      COSTHE = 1.
      SINTHE = 0.
      SQAR2S = SQRT(RAD2+R2)
      RX  = ANX
      RY  = ANY
      RZ  = ANZ
      RPX = 0.
      RPY = 0.
      RPZ = 0.
      GO TO 220
  219 CONTINUE
C
      SQAR2S = SQRT(RAD2 + R2 + (2.*RADIUS*R*SINTHE))
      REALK2 = (4.*RADIUS*R*SINTHE)/(RAD2+R2+(2.*RADIUS*R*SINTHE))
      REALK  = SQRT(REALK2)
      XIACR  = (XJ*RADIUS)/(C*R)
C
C     A CROSS R, NORMAL TO THE PLANE OF A AND R
C
      TX = ANY*RZ - ANZ*RY
      TY = ANZ*RX - ANX*RZ
      TZ = ANX*RY - ANY*RX
C
C     (A CROSS R) CROSS R, NORMAL TO THE PLANE OF R AND (A AND R)
C
      TRPX = TY*RZ - TZ*RY
      TRPY = TZ*RX - TX*RZ
      TRPZ = TX*RY - TY*RX
      AT3  = SQRT(TRPX*TRPX + TRPY*TRPY + TRPZ*TRPZ)
C
C     RPERP, PERPENDICULAR TO THE VECTOR FROM THE CENTER TO THE FIELD PT
C
      RPX = TRPX/AT3
      RPY = TRPY/AT3
      RPZ = TRPZ/AT3
C
C     FOR SMALL POLAR ANGLE OR SMALL RADIUS USE ALTERNATIVE APPROX.
C
      IF (REALK2 .LT. .0001) GO TO 220
C
C     COMPUTE ELLIPTIC INTEGRAL OF FIRST KIND
C
      F = 1.
      DELTF1 = 1.
      DO 240 N = 1,15000
      XN2  = 2.*FLOAT(N)
      XN21 = XN2 - 1.
      DELTF1 = DELTF1*(XN21/XN2)*REALK
      DELTF2 = DELTF1*DELTF1
      F = F + DELTF2
      IF (ABS(DELTF2/F) .LE. EPSE) GO TO 250
  240 CONTINUE
      DELF = ABS(DELTF2/F)
      WRITE (OTPE,245) UWM,XX,YY,ZZ,XC,YC,ZC,X1,Y1,Z1,X2,Y2,Z2,DELF,EPSE
  245 FORMAT (A25,', CONVERGENCE OF ELLIPTIC INTEGRAL IS UNCERTAIN. ',
     1     'GRID OR INTEGRATION POINT AT COORDINATES', /5X,
     2     1P,3E15.6,'  IS TOO CLOSE TO CURRENT LOOP WITH CENTER AT',
     3     /5X,1P,3E15.6,' AND 2 POINTS AT ',1P,3E15.6, /5X,4HAND ,1P,
     4     3E15.6,' COMPUTATIONS WILL CONTINUE WITH LAST VALUES', /5X,
     5     'CONVERGENCE VALUE WAS ',1P,E15.6,
     6     ' CONVERGENCE CRITERION IS ',1P,E15.6)
  250 F = PIBY2*F
C
C     COMPUTE ELLIPTIC INTEGRAL OF SECOND KIND
C
      E = 1.
      DELTE1 = 1.
      DO 260 N = 1,15000
      XN2  = 2.*FLOAT(N)
      XN21 = XN2-1.
      DELTE1 = DELTE1*(XN21/XN2)*REALK
      DELTE2 = (DELTE1*DELTE1)/XN21
      E = E - DELTE2
      IF (ABS(DELTE2/E) .LE. .000001) GO TO 270
  260 CONTINUE
      DELE = ABS(DELTE2/E)
      WRITE (OTPE,245) UWM,XX,YY,ZZ,XC,YC,ZC,X1,Y1,Z1,X2,Y2,Z2,DELE
  270 E = PIBY2*E
C
C     COMPUTE THE RADIAL COMPONENT OF THE MAGNETIC FIELD
C
      BR = XIACR*(COSTHE/SINTHE)*(E/SQAR2S)*(REALK2/(1.-REALK2))
C
C     COMPUTE THE POLAR COMPONENT OF THE MAGNETIC FIELD
C
      BTHE = XIACR*(1./(SQAR2S*RADIUS*R*SINTHE))*
     1       (((((2.*R2)-((R2+(RADIUS*R*SINTHE))*REALK2))/
     2       (1.-REALK2))*E)-(2.*R2*F))
C
C     GO TO THE RESOLUTION OF FIELD COMPONENTS
C
      GO TO 230
C
C     ALTERNATIVE APPROXIMATION FOR SMALL K**2
C
C     COMPUTE THE RADIAL COMPONENT OF THE MAGNETIC FIELD
C
  220 CONTINUE
      BR = XIACPI*COSTHE*(((2.*RAD2)+(2.*R2)+(RADIUS*R*SINTHE))/
     1     ((SQAR2S)**5))
C
C     COMPUTE THE POLAR COMPONENT OF THE MAGNETIC FIELD
C
      BTHE = -XIACPI*SINTHE*
     1       (((2.*RAD2)-R2+(RADIUS*R*SINTHE))/((SQAR2S)**5))
C
C     RESOLVE MAGNETIC FIELD COMPONENTS INTO RECTANGULAR COMPONENTS
C
  230 CONTINUE
      HCX = RX*BR + RPX*BTHE
      HCY = RY*BR + RPY*BTHE
      HCZ = RZ*BR + RPZ*BTHE
      HC1 = HCX/FPI
      HC2 = HCY/FPI
      HC3 = HCZ/FPI
      RETURN
      END

      SUBROUTINE BMGTNS(CSTM,NCSTM,ECPT,TA)
C/// THIS ROUTINE WAS LIFTED FROM PRETRD AND TRANSD AND CONVERTED
C///// TO HAVE ONE ENTRY POINT
C
C PRETRD SETS UP EVENTUAL CALLS TO TRANSD.  FOR A MODULE TO USE TRANSD
C A CALL TO PRETRD MUST BE INITIATED BY THE MODULE DRIVER ONCE AND ONLY
C ONCE.  CSTM IS ARRAY OF COORDINATE SYSTEM TRANSFORMATION MATRICES
C AND NCSTM IS THE LENGTH OF THIS ARRAY.
C
      DIMENSION          CSTM(1)
C*****
C GIVEN THE ECPT ARRAY OF LENGTH 4, THE FIRST WORD BEING AN INTEGER
C COORDINATE SYSTEM IDENTIFICATION NUMBER AND THE NEXT WORDS BEING THE
C REAL COORDINATES OF A POINT IN BASIC COORDINATES, THIS ROUTINE
C COMPUTES THE TRANSFORMATION (DIRECTION COSINE) MATRIX TA WHICH WILL
C MAP A VECTOR FROM THE LOCAL SYSTEM LABELED ECPT(1) TO BASIC COORDI-
C NATES.  TA IS A DOUBLE PRECISION MATRIX.
C*****
      DIMENSION          ECPT(4)
C
      DOUBLE PRECISION
     1                   TA(9)              ,TL(9)
     2,                  XN(3)              ,X
     3,                  Y                  ,Z
     4,                  R                  ,KE(9)
     5,                  XL
C
      EQUIVALENCE        (FL1,INT1)         ,(FL2,INT2)
C
      FL1 = ECPT(1)
      IF(INT1.EQ.0) GO TO 13
      DO 6 I = 1,NCSTM,14
      FL2 = CSTM(I)
      IF(INT1.NE.INT2) GO TO 6
      KK = I
      FL2 = CSTM(I + 1)
      GO TO (7,10,10),INT2
    6 CONTINUE
C
C THE COORDINATE SYSTEM ID. COULD NOT BE FOUND IN THE CSTM.
C
      CALL MESAGE (-30,25,INT1)
C
C THE COORDINATE SYSTEM IS RECTANGULAR.
C
    7 DO 8 J = 1,9
      K = KK + 4 + J
    8 TA(J) = CSTM(K)
      RETURN
   10 XN(1) = ECPT(2) - CSTM(KK+2)
      XN(2) = ECPT(3) - CSTM(KK+3)
      XN(3) = ECPT(4) - CSTM(KK + 4)
      X = CSTM(KK+5)*XN(1)+CSTM(KK+8)*XN(2)+CSTM(KK+11)*XN(3)
      Y = CSTM(KK+6)*XN(1)+CSTM(KK+9)*XN(2)+CSTM(KK+12)*XN(3)
      Z = CSTM(KK+7)*XN(1)+CSTM(KK+10)*XN(2)+CSTM(KK+13)*XN(3)
      R = DSQRT(X**2+Y**2)
      IF (R .EQ. 0.0D0) GO TO 7
      DO 110 J=1,9
      K=KK+4+J
  110 KE(J)=CSTM(K)
      GO TO (11,11,12),INT2
C
C THE COORDINATE SYSTEM IS CYLINDRICAL.
C
   11 TL(1)=X/R
      TL(2)=-Y/R
      TL(3)=0.0D0
      TL(4)=-TL(2)
      TL(5)=TL(1)
      TL(6)=0.0D0
      TL(7)=0.0D0
      TL(8)=0.0D0
      TL(9)=1.0D0
      GO TO 125
C
C THE COORDINATE SYSTEM IS SPHERICAL.
C
   12 XL=DSQRT(X*X+Y*Y+Z*Z)
      TL(1)=X/XL
      TL(2)=(X*Z)/(R*XL)
      TL(3)=-Y/R
      TL(4)=Y/XL
      TL(5)=(Y*Z)/(R*XL)
      TL(6)=X/R
      TL(7)=Z/XL
      TL(8)=-R/XL
      TL(9)=0.0D0
  125 CALL GMMATD (KE(1),3,3,0, TL(1),3,3,0, TA(1))
      RETURN
C
C THE LOCAL SYSTEM IS BASIC.
C
   13 DO 14 I=1,9
   14 TA(I)=0.0D0
      TA(1)=1.0D0
      TA(5)=1.0D0
      TA(9)=1.0D0
      RETURN
      END

      SUBROUTINE SQDM21
C
C     PHASE-I STRESS-DATA-RECOVERY ROUTINE FOR THE -QDMEM2- ELEMENT.
C
C     THIS ROUTINE WILL PREPARE FOR USE BY -SQDM22-, THE PHASE-II
C     ROUTINE, A TABLE CONTAINING THE FOLLOWING.
C
C     TABLE WORDS        DISCRIPTION
C     ------------------------------------------------------
C       1 THRU   1       ELEMENT-ID
C       2 THRU   5       4 SILS
C       6 THRU   6       ELEMENT-THICKNESS
C       7 THRU   7       REFERENCE TEMP -TSUB0-
C       8 THRU 151       16 (3X3) KIJ-G MATRICES
C     152 THRU 187       4 (3X3) STRESS MATRICES
C     188 THRU 199       4 (3X1) TEMP VECTORS
C     200 THRU 202       ST (3X1) STRESS-TEMPERATURE VECTOR
C     203 THRU 206       4 SIDE LENGTHS
C
C     ELEMENT EST ENTRY CONTENTS
C     + + + + + + + + + + + + + + + + + + + + + + + + + +
C     +   1 = ID                                        +
C     +   2 = SIL-PT-A            (ELEMENT CONNECTS     +
C     +   3 = SIL-PT-B             GRID POINTS A,B,     +
C     +   4 = SIL-PT-C             C,D IN THAT ORDER)   +
C     +   5 = SIL-PT-D                                  +
C     +   6 = MATERIAL-ANGLE                            +
C     +   7 = MATERIAL-ID                               +
C     +   8 = THICKNESS OF ELEMENT                      +
C     +   9 = NON-STRUCTURAL-MASS                       +
C     +  10 = COORD-SYS-ID PT-A OR 0                    +
C     +  11 = XA                                        +
C     +  12 = YA                                        +
C     +  13 = ZA                                        +
C     +  14 = COORD-SYS-ID PT-B OR 0                    +
C     +  15 = XB                                        +
C     +  16 = YB                                        +
C     +  17 = ZB                                        +
C     +  18 = COORD-SYS-ID PT-C OR 0                    +
C     +  19 = XC                                        +
C     +  20 = YC                                        +
C     +  21 = ZC                                        +
C     +  22 = COORD-SYS-ID PT-D OR 0                    +
C     +  23 = XD                                        +
C     +  24 = YD                                        +
C     +  25 = ZD                                        +
C     +  26 = AVERAGE OF CONNECTED GRID TEMPERATURES    +
C     + + + + + + + + + + + + + + + + + + + + + + + + + +
C
      LOGICAL         PLANAR
      INTEGER         NEST(7), MAP(4,3)
      REAL            K1SUM, K5SUM, ISINTH, ICOSTH, KMAT(63), SMAT(27),
     1                PMAT(9), JTEMP9, K5MOD, KTEMP9(9), ZMAT(9),
     2                ITEMP9(9), Q(3,3,4), IMAT12, RMAT(3,5), ETI(36),
     3                DVEC(3,4), KVEC(3)
      CHARACTER       UFM*23, UWM*25
      COMMON /XMSSG / UFM, UWM
C
C     FOLLOWING COMMON BLOCK MUST BE DIMENSIONED AT LEAST 350 IN SDR2B
C
      COMMON /SDR2X5/ EST(100), ID, ISILS(4), ELTHIK, REFTMP,
     1                K1SUM(9,16), SG(36),PT(3,4), ST(3),RG(4)
C
C     WORKING STORAGE BLOCK (KEEP .LE. 300 WORDS)
C
      COMMON /SDR2X6/ K5SUM(9,5), SISUM(9,5), PISUM(3,5), R(3,4,5),
     1                K5MOD(9,5), G(36),  T(9), E(9), IMAT12(12),
     2                JTEMP9(9), GSUBE(9)
      COMMON /MATIN / MATID, INFLAG, ELTEMP, STRESS, SINTH, COSTH
      COMMON /MATOUT/ G11, G12, G13, G22, G23, G33, RHO, ALPS(3), TSUB0
      COMMON /SYSTEM/ KSYSTM(65)
      COMMON /CONDAS/ PI, TWOPI, RADEG, DEGRA, S4PISQ
      EQUIVALENCE     (KSYSTM(2),IOUTPT), (NEST(1),EST(1))
      DATA    MAP   / 1, 2, 3, 4,
     1                2, 3, 4, 1,
     2                5, 5, 5, 5  /
C
C     COMPUTE BASIC SIN AND COSINE OF ELEMENT MATERIAL ANGLE.
C
      ANGL   = EST(6)*DEGRA
      ISINTH = SIN(ANGL)
      ICOSTH = COS(ANGL)
C
C     COMPUTE GSUBE MATRIX
C
      INFLAG = 2
      MATID  = NEST(7)
      ELTEMP = EST(26)
      SINTH  = 0.0
      COSTH  = 1.0
      CALL MAT (NEST(1))
      GSUBE(1) = G11
      GSUBE(2) = G12
      GSUBE(3) = G13
      GSUBE(4) = G12
      GSUBE(5) = G22
      GSUBE(6) = G23
      GSUBE(7) = G13
      GSUBE(8) = G23
      GSUBE(9) = G33
C
C     BASIC WHOLE-ELEMENT CALCULATIONS
C
      CALL Q2BCS (EST,PLANAR,RMAT,E,IERROR)
      IF (IERROR) 10,10,400
C
C     ZERO SUMMATION ARRAYS
C
   10 DO 40 I = 1,9
      DO 20 J = 1,16
      K1SUM(I,J) = 0.0
   20 CONTINUE
      DO 30 J = 1,5
      K5SUM(I,J) = 0.0
      SISUM(I,J) = 0.0
   30 CONTINUE
   40 CONTINUE
C
      DO 60 I = 1,5
      PISUM(1,I) = 0.0
      PISUM(2,I) = 0.0
      PISUM(3,I) = 0.0
   60 CONTINUE
C
C     SUB-TRIANGLES ARE COMPUTED AND RESULTS SUMMED.
C
      DO 100 I = 1,4
C
C     CALL TRIANGLE CALCULATION ROUTINE TO GET (3X3) SUB-PARTITIONS
C
      IA = MAP(I,1)
      IB = MAP(I,2)
      IC = MAP(I,3)
C
      CALL Q2TRMS (RMAT(1,IA),RMAT(1,IB),RMAT(1,IC),ALPS ,ISINTH,ICOSTH,
     1             GSUBE,EST(8),IERROR,3,KMAT,PMAT,SMAT,ZMAT)
      IF (IERROR) 70,70,400
C
C     SUM IN KCA,KCB,KCC 3-(3X3)-S STORED FIRST IN KMAT
C
C     ALSO SUM IN KAA,KAB,KBA,KBB = LAST 4-(3X3)-S STORED IN KMAT.
C     THESE GO INTO 4 OF THE 16 POSSIBLE (3X3) SUM MATRICES = ,
C
C     K11,K12,K13,K14,K21,K22,K23,K24,K31,K32,K33,K34,K41,K42,K43,K44
C
C     J1,J2,J3,J4 WILL EACH POINT TO 1 OF THE 16 (3X3)-S.
C
   70 J1 = 5*IA - 4
      J2 = 4*IA - 4 + IB
      J3 = 4*IB - 4 + IA
      J4 = 5*IB - 4
C
      DO 80 K = 1,9
      K5SUM(K,IA) = K5SUM(K,IA) + KMAT(K   )
      K5SUM(K,IB) = K5SUM(K,IB) + KMAT(K+ 9)
      K5SUM(K,IC) = K5SUM(K,IC) + KMAT(K+18)
      K1SUM(K,J1) = K1SUM(K,J1) + KMAT(K+27)
      K1SUM(K,J2) = K1SUM(K,J2) + KMAT(K+36)
      K1SUM(K,J3) = K1SUM(K,J3) + KMAT(K+45)
      K1SUM(K,J4) = K1SUM(K,J4) + KMAT(K+54)
      SISUM(K,IA) = SISUM(K,IA) + SMAT(K   )
      SISUM(K,IB) = SISUM(K,IB) + SMAT(K+ 9)
      SISUM(K,IC) = SISUM(K,IC) + SMAT(K+18)
   80 CONTINUE
C
      DO 90 K = 1,3
      PISUM(K,IA) = PISUM(K,IA) + PMAT(K  )
      PISUM(K,IB) = PISUM(K,IB) + PMAT(K+3)
      PISUM(K,IC) = PISUM(K,IC) + PMAT(K+6)
   90 CONTINUE
C
  100 CONTINUE
C
C     FORMATION OF THE FOUR (3X3) G MATRICES.
C                     -1
C     (G ) = -(K5SUM  ) (K  )   NOTE.  IF -PLANAR- THEN MODIFIED
C       I           55    5I           K5SUM MATRICES ARE USED.
C
      IF (PLANAR) GO TO 120
      DO 110 I = 1,5
      DO 110 J = 1,9
      K5MOD(J,I) = K5SUM(J,I)
  110 CONTINUE
      GO TO 140
C
  120 DO 130 I = 1,5
      K5MOD(1,I) = K5SUM(1,I)
      K5MOD(2,I) = K5SUM(2,I)
      K5MOD(3,I) = K5SUM(3,I)
      K5MOD(4,I) = K5SUM(4,I)
      K5MOD(5,I) = K5SUM(5,I)
      K5MOD(6,I) = K5SUM(6,I)
      K5MOD(7,I) = 0.0
      K5MOD(8,I) = 0.0
      K5MOD(9,I) =-0.25
  130 CONTINUE
      K5MOD(9,5) = 1.0
C
C     INVERT K5MOD   AND NEGATE RESULT.
C                 55
C
  140 CONTINUE
C
C     NO NEED TO COMPUTE DETERMINANT SINCE IT IS NOT USED SUBSEQUENTLY.
C
      ISING = -1
      CALL INVERS (3,K5MOD(1,5),3,DUMMY,0,DETERM,ISING,ITEMP9)
      IF (ISING .EQ. 2) GO TO 400
C
      DO 150 I = 1,9
      K5MOD(I,5) = -K5MOD(I,5)
  150 CONTINUE
C
C     FORM G MATRICES
C
      DO 160 I = 1,4
      CALL GMMATS (K5MOD(1,5),3,3,0, K5MOD(1,I),3,3,0, G(9*I-8))
  160 CONTINUE
C
C     FORM STIFFNESS MATRIX BY ROW-PARTIONS.
C
      DO 210 I = 1,4
C                          T
C     IF -PLANAR- FORM (G ) (K  ) FOR USE IN COLUMN-PARTITIONS LOOP.
C                        I    55
C
      IF (.NOT.PLANAR) GO TO 170
      CALL GMMATS (G(9*I-8),3,3,1, K5SUM(1,5),3,3,0, ITEMP9)
C
C     COLUMN-PARTITIONS-LOOP
C
  170 DO 200 J = 1,4
C                                   T
C     FORM (K  ) = (K1SUM  ) + (K  ) (G )
C            IJ          IJ      5I    J
C
      CALL GMMATS (K5SUM(1,I),3,3,1, G(9*J-8),3,3,0, JTEMP9)
      LPART = 4*I - 4 + J
      DO 180 K = 1,9
      K1SUM(K,LPART) = K1SUM(K,LPART) + JTEMP9(K)
  180 CONTINUE
C
C     BALANCE OF TERMS IF -PLANAR-
C
C                T            T
C     ADD IN (G ) (K  ) + (G ) (K  )(G )
C              I    5J      I    55   J
C
      IF (.NOT.PLANAR) GO TO 200
      CALL GMMATS (ITEMP9,3,3,0, G(9*J-8),3,3,0, JTEMP9)
      CALL GMMATS (G(9*I-8),3,3,1, K5SUM(1,J),3,3,0, KTEMP9)
      DO 190 K = 1,9
      K1SUM(K,LPART) = K1SUM(K,LPART) + KTEMP9(K) + JTEMP9(K)
  190 CONTINUE
  200 CONTINUE
  210 CONTINUE
C
C     CALCULATION OF 4 (Q ) MATRICES, EACH 3X3.
C                        I
C
      DO 260 I = 1,4
      IA = MAP(I,1)
      IB = MAP(I,2)
      DO 230 J = 1,3
      DVEC(J,I) = RMAT(J,IB) - RMAT(J,IA)
  230 CONTINUE
      FMAG  = SQRT(SADOTB(DVEC(1,I),DVEC(1,I)))
      RG(I) = FMAG
      IF (FMAG) 400,400,240
  240 DO 250 J = 1,3
      DVEC(J,I) = DVEC(J,I)/FMAG
  250 CONTINUE
  260 CONTINUE
C
      DO 280 I = 1,4
      J = I - 1
      IF (J .EQ. 0) J = 4
      I1 = MAP(J,1)
      I2 = MAP(J,2)
      CALL SAXB (DVEC(1,I2),DVEC(1,I1),KVEC)
C
C     NORMALIZE, NEGATE, AND STORE AS DELTA-VEC IN (Q )
C                                                    I
      FMAG = SQRT(SADOTB(KVEC,KVEC))
      IF (FMAG) 400,400,270
  270 Q(1,3,I) = -KVEC(1)/FMAG
      Q(2,3,I) = -KVEC(2)/FMAG
      Q(3,3,I) = -KVEC(3)/FMAG
C
C     STORE D VECTORS AS ALPHA- VECTORS IN (Q )
C                                            I
      Q(1,1,I) = -DVEC(1,I)
      Q(2,1,I) = -DVEC(2,I)
      Q(3,1,I) = -DVEC(3,I)
C
      Q(1,2,I) = DVEC(1,J)
      Q(2,2,I) = DVEC(2,J)
      Q(3,2,I) = DVEC(3,J)
C
C     INVERT 3X3
C
C     AGAIN NO NEED TO COMPUTE DETERMINANT SINCE IT IS NOT USED .
C     SUBSEQUENTLY.
C
      ISING = -1
      CALL INVERS (3,Q(1,1,I),3,DUMMY,0,DETERM,ISING,JTEMP9)
      IF (ISING .EQ. 2) GO TO 400
  280 CONTINUE
C
C     FORM FINAL OUTPUTS
C
      DO 370 I = 1,4
      II = 9*I - 8
C
C     TRANSFORMATION ETI = (E)(T )
C                               I
C
      KK = 4*I
      IF (NEST(KK+6)) 290,300,290
  290 CALL TRANSS (NEST(KK+6),T)
      CALL GMMATS (E,3,3,0, T,3,3,0, ETI(II))
      GO TO 320
C
  300 KK = II
      DO 310 J = 1,9
      ETI(KK) = E(J)
      KK = KK + 1
  310 CONTINUE
C
C       G            E      E
C     (S ) = 0.25( (S ) + (S )(G ) )(E)(T )
C       I            I      5   I        I
C
  320 CALL GMMATS (SISUM(1,5),3,3,0, G(II),3,3,0, JTEMP9)
      DO 330 J = 1,9
      JTEMP9(J) = 0.25*(JTEMP9(J)+SISUM(J,I))
  330 CONTINUE
      CALL GMMATS (JTEMP9,3,3,0, ETI(II),3,3,0, SG(II))
C
C       T     -         T -
C     (P ) = (P ) + (G ) (P )
C       I      I      I    5
C
      CALL GMMATS (G(II),3,3,1, PISUM(1,5),3,1,0, PT(1,I))
      DO 360 J = 1,3
      PISUM(J,I) = PT(J,I) + PISUM(J,I)
  360 CONTINUE
      CALL GMMATS (Q(1,1,I),3,3,1, PISUM(1,I),3,1,0, PT(1,I))
  370 CONTINUE
C
C     TRANSFORM STIFFNESS MATRIX TO GLOBAL
C
C        G           E
C     (K  ) = (Q )(K  )(E)(T )
C       IJ      I   IJ      J
C
      JPART = 0
      DO 390 I = 1,4
      DO 380 J = 1,4
      JPART = JPART + 1
      CALL GMMATS (Q(1,1,I),3,3,1, K1SUM(1,JPART),3,3,0, JTEMP9)
      CALL GMMATS (JTEMP9,3,3,0, ETI(9*J-8),3,3,0, K1SUM(1,JPART))
  380 CONTINUE
  390 CONTINUE
C
C     (S ) = (GSUBE)(ALPHAS)
C       T
C
      CALL GMMATS (GSUBE,3,3,0, ALPS,3,1,0, ST)
C
C     MISC. DATA FOR PHASE-II
C
      ID       = NEST(1)
      ISILS(1) = NEST(2)
      ISILS(2) = NEST(3)
      ISILS(3) = NEST(4)
      ISILS(4) = NEST(5)
      ELTHIK   = EST(8)
      REFTMP   = TSUB0
      RETURN
C
C     ERROR CONDITION
C
  400 WRITE  (IOUTPT,410) UWM,NEST(1)
  410 FORMAT (A25,' 3101, SINGULARITY OR BAD GEOMETRY FOR QDMEM2 ELEM.',
     1       ' ID =',I9, /5X,'STRESS OR FORCES WILL BE INCORRECT.')
      RETURN
      END

      SUBROUTINE VDR
C
C     VDR IS THE CONTROL PROGRAM FOR THE VECTOR DATA RECOVERY MODULE
C
C                                                          OPHID
C                                  PHID                    OUDVC1
C                                  UDVF CLAMA              OUDV1
C             CASECC  EQDYN  USETD UDVT PPF          PHLD  OPHIH  OPNL1
C     VDR     CASEXX,HEQDYN,HUSETD,PHIH,TOL   ,XYCBD,PNLH /OUHVC1,HOPNL1
C                                  UHVT HTOL         HPNLD OUHV1
C                                  HUDVT                   HOUVD1
C
C                   TRANRESP     DIRECT
C              /C,N,FREQRESP/C,N,MODAL /V,N,SORT2/V,N,OUTPUT/V,N,SDR2
C                   CEIGN
C
C              /V,N,FMODE  $      PROGRAMMER'S MANUAL PP. 4.60-1 TRHU -7
C
C
      INTEGER         PNL   ,OUTFLE,OPNL1 ,APP   ,TRN   ,VDRREQ,SORT2 ,
     1                OUTPUT,SDR2  ,SSCELL,BUF   ,CASECC
      DIMENSION       NAM(2),BUF(50)      ,MASKS(6)     ,MCB(7),CEI(2),
     1                FRQ(2),TRN(2),MODAL(2)     ,DIRECT(2)
      COMMON /VDRCOM/ VDRCOM,IDISP ,IVEL  ,IACC  ,ISPCF ,ILOADS,ISTR  ,
     1                IELF  ,IADISP,IAVEL ,IAACC ,IPNL  ,ITTL  ,ILSYM ,
     2                IFROUT,IDLOAD,CASECC,EQDYN ,USETD ,INFILE,OEIGS ,
     3                PP    ,XYCDB ,PNL   ,OUTFLE,OPNL1 ,SCR1  ,SCR2  ,
     4                BUF1  ,BUF2  ,BUF3  ,NAM   ,BUF   ,MASKS ,CEI   ,
     5                FRQ   ,TRN   ,DIRECT,XSET0 ,VDRREQ,MODAL
      COMMON /BLANK / APP(2),FORM(2),SORT2,OUTPUT,SDR2  ,IMODE
      COMMON /SYSTEM/ DUMI(68),SSCELL
C
C     EXECUTE THE PHASES OF VDR.
C
      DO 10 I = 1,50
   10 BUF(I) = 0
      CASECC = 101
      OUTPUT = -1
      SORT2  = -1
      CALL VDRA
      IF (SSCELL .NE. 0) SDR2 = 1
      IF (VDRREQ .EQ. 0) RETURN
      MCB(1) = INFILE
      CALL RDTRL (MCB)
      IF (MCB(1) .NE. INFILE) GO TO 20
      CALL VDRB (INFILE,OUTFLE,IADISP)
   20 IF (APP(1) .NE. TRN(1)) RETURN
      MCB(1) = PNL
      CALL RDTRL (MCB)
      IF (MCB(1) .NE. PNL) RETURN
      CALL VDRB (PNL,OPNL1,IPNL)
      RETURN
      END

      SUBROUTINE FA1PKA(A,M1K,M1B,EIV,NCORE,N)
C
C     FA1PKA BUILDS THE MATRIX FOR ALLMAT
C
      INTEGER NAME(2)
      REAL A(1),EIV(1)
      REAL M1K(1),M1B(1)
      DATA NAME /4HFA1P,4HKA  /
      DATA NHEIGS,NHEIGE /4HEIGS,4HEIGE/
      N2 = N*2
      IZ = 0
      IMK = N
      IMI = N*N*2
      IMB = IMI + N
      K = 0
      DO 10 I = 1,N
      DO 20 J = 1,N
      K = K +1
      A(IZ+J) = 0.0
      A(IMK+J) = M1K(K)
      A(IMB+J) = M1B(K)
      A(IMI+J) = 0.0
      IF(I.EQ.J) A(IMI+J) = 1.0
   20 CONTINUE
      IZ = IZ + N2
      IMK = IMK + N2
      IMI = IMI + N2
      IMB = IMB + N2
   10 CONTINUE
C
C     CALL HSBG AND ATEIG FOR EIVENVALUES
C
      N4=N2*2
      IL = 1
      IH = IL + N2
      IM=IH+N4
      II=IM+N4
      IF(II     .GT.NCORE) CALL MESAGE(-8,0,NAME)
      CALL SSWTCH(39,L39)
      IF(L39.NE.0) CALL CONMSG(NHEIGS,1,0)
      CALL HSBG(N2,A,N2,A)
      CALL ATEIG(N2,A,EIV(IH),EIV(IM),EIV(IL),N2,
     *              A,EIV(IH),EIV(IM))
      IL = 0
      DO 30 I=1,N2
      EIV(I+IL) = EIV(I+IH-1)
      EIV(I+IL+1) = EIV(I + IM -1)
      IL = IL +1
   30 CONTINUE
      IF(L39.NE.0) CALL CONMSG(NHEIGE,1,0)
      RETURN
      END

        SUBROUTINE ZBLPKI
        INTEGER A
      INCLUDE 'DSIOF.COM'
      INCLUDE 'PAKBLK.COM'
      INCLUDE 'XNSTRN.COM'
        COMMON / ZBLPKX / A(4), I
        IBLKA(15) = I
        ITYPIN = IBLKA( 13 )
        NWORDS = NWRDEL( ITYPIN )
        IF ( IBLKA( 2 ) .GE. 3 ) GO TO 5
        INCCNT = 1
        GO TO 8
5       INCCNT = 2
8       CONTINUE
        DO 10 K = 1, NWORDS
        IF ( A( K ) .NE. 0 ) GO TO 20
10      CONTINUE
        GO TO 7000
20      IF ( IBLKA( 4 ) .EQ. 0 ) GO TO 35
        NEXROW = IBLKA( 4 ) + IBLKA( 7 )
        ICROW  = IBLKA( 15 )
        IF ( ICROW .GE. NEXROW ) GO TO 30
        CALL DSMSG1( IBLKA )
        CALL DSMSG( 119 )
30      IF ( ICROW .EQ. NEXROW ) GO TO 40
        CALL ENDPUT( IBLKA )
        CALL PUTSTR( IBLKA )
        IBLKA( 7 ) = 0
35      ICROW = IBLKA( 15 )
        IBLKA( 4 ) = ICROW
40      INDEX  = ( IBLKA( 5 ) - 1  ) * IBLKA( 14 ) + 1
        IF ( ITYPIN .NE. IBLKA(2) ) GO TO 100
CDIR$ NOVECTOR
        DO 50 KK = 1, NWORDS
        IBASE( INDEX + KK - 1 ) = A( KK )
50      CONTINUE
CDIR$ VECTOR
        GO TO 200
100     CALL DSUPKC ( ITYPIN, IBLKA( 2 ), A, IBASE( INDEX ) )
200     CONTINUE
        IBLKA( 5 ) = IBLKA( 5 ) + INCCNT
        IBLKA( 7 ) = IBLKA( 7 ) + 1
        IBLKA(10 ) = IBLKA(10 ) + IBLKA( 11 )
        IF ( IBLKA( 6 ) .GT. IBLKA( 7 ) ) GO TO 7000
        CALL ENDPUT( IBLKA )
        CALL PUTSTR( IBLKA )
        IBLKA( 4 ) = 0
        IBLKA( 7 ) = 0
7000    RETURN
        END

      SUBROUTINE ONLINS (*,LX)
C
C     ON-LINE SCAN ROUTINE, CALLED ONLY BY SCAN
C
C     WRITTEN FEBY G.CHAN/SPERRY,  FEB. 1986
C
      IMPLICIT INTEGER          (A-Z)
      EXTERNAL        LSHIFT,   RSHIFT,   ANDF,     ORF,      COMPLF
      LOGICAL         DEBUG
      INTEGER         NAME(2),  CARD(20), IZ(1)
      REAL            R(2),     Z(30)
      COMMON /MACHIN/ MACH
      COMMON /BLANK / IELT(2),  ICOMP,    NTOP,     AMAX,     AMIN,
     1                IBEG,     IEND,     ICOMPX
      COMMON /SYSTEM/ IBUF,     OUTTAP,   NOGO,     IN,       DUM(74),
     1                SWTCH1,   JDUM(6),  INTRA
      COMMON /XSCANX/ SKIP(2),  LCORE,    LBEG,     LEND,     DUMM(2),
     1                IEL,      IOPT,     ISET,     ISORT,    IDUM(4),
     2                DEBUG
      COMMON /IFP1A / SCR1,     CASECC,   IS,       NWPC,     NCPW,
     1                NMODES,   ICC,      NSET,     DUMMY(3), ISUB,
     2                LENCC,    IBLNK,    IEQUAL,   IEOR
C
C            /ZZIFP1/ IS THE OPEN CORE FOR SCAN
      COMMON /ZZZZZZ/ LCSE(400),CORE(1)
      EQUIVALENCE     (IZ(1),LCSE(1))
      EQUIVALENCE     (IMAX,AMAX),        (IMIN,AMIN),
     1                (IDUPL,IBEG),       (INC,IEND),
     2                (CARD(1),CORE(1)),  (IZ(1),Z(1))
      DATA    BLANK , EQUAL ,   STOP  ,   ALL   ,   NAME             /
     1        4H    , 4H=   ,   4HSTOP,   4HALL ,   4HONLI,   4HNS   /
      DATA    LU    , DEBUG1,   DEBUG2,   DEBUG3,   I0               /
     1        1     , 4HDEBU,   4HG ON,   4HG OF,   0                /
C
C     INITIALIZE /IFP1A/
C
      SCR1   = 301
      CASECC = 101
      IS     = 0
      NWPC   = 20
      NCPW   = 4
      NMODES = 0
      ICC    = 0
      ISUB   = 1
      IBLNK  = BLANK
      IEQUAL = EQUAL
      IEOR   = COMPLF(0)
      IEOR   = RSHIFT(IEOR,1)
C
C     SET INTERACTIVE FLAG TO POSITIVE, A SIGNAL TO SCAN, TOTAPE, IFP1C
C
      INTRA  = IABS(INTRA)
      IF (INTRA .EQ. 0) INTRA = 1
C
      ICOMP = LX
      NWPC1 = NWPC + 1
      NOUT  = OUTTAP
      WRITE  (NOUT,10)
 10   FORMAT (///1X,'*** SCAN INTERACTIVE INPUT ***')
C
C     READ CASECC FILE AND SAVE DATA IN LCSE, ONE SUBCASE AT A TIME
C     SAVE SET DATA IN CORE BEGIN AT CORE(BGN)
C
 15   LCSE(166) = 200
      LCSE(199) = 0
      LCSE(200) = 0
      NZ    = KORSZ(CORE(1)) - 3*IBUF - 1
      NZ    = MIN0(NZ,LCORE)
      ISCAN = 0
      NSET  = 0
      I81   = NWPC1
      SUBID =-1
      LX    = 0
      IF (ICOMP .EQ. -2) GO TO 30
C
C     NO QUESTION ASKED IF SORT2 DATA TYPE IS USED.
C
      LX = 1
 20   WRITE  (NOUT,25)
 25   FORMAT (//,' ENTER SUBCASE ID (DEFAULT=FIRST SUBCASE)')
      READ   (IN,26) R
 26   FORMAT (2A4)
      CALL A82INT (*20,R,8,SUBID,I)
      IF (SUBID .EQ.  0) SUBID = -1
      IF (INTRA .GT. 10) WRITE (LU,27) SUBID
 27   FORMAT (///3X,'SUBCASE ID',I8)
 30   JJ = 1
      CALL REWIND (CASECC)
      CALL FWDREC (*110,CASECC)
 32   JJ = JJ + 1
      CALL READ (*110,*110,CASECC,LCSE(JJ),1,0,I)
      IF (SUBID .EQ. -1) SUBID = LCSE(JJ)
      IF (LCSE(JJ) .EQ. SUBID) GO TO 35
      CALL FWDREC (*110,CASECC)
      GO TO 32
 35   LCSE(1) = LCSE(JJ)
      CALL READ (*110,*125,CASECC,LCSE(2),199,0,I)
      LENCC = LCSE(166)
      LSEM  = LCSE(LENCC)
      NSET  = LCSE(LENCC-1)
      IF (LSEM .GT. 0) CALL READ (*110,*125,CASECC,CORE(I81),LSEM,0,I)
      I81   = I81 + LSEM
      BGN   = I81
      END   = I81
 37   CALL READ (*40,*40,CASECC,CORE(I81),2,0,I)
      JMP   = CORE(I81+1)
      CORE(I81+2) = JJ
      I81  = I81 + 3
      CALL READ (*110,*125,CASECC,CORE(I81),JMP,0,I)
      NSET = NSET + 1
      I81  = I81 + JMP
      GO TO 37
C
C     SET CARD
C
 40   WRITE  (NOUT,43)
 43   FORMAT (//,' ENTER A BLANK, OR A SET CARD (SEE USER MANUAL P. ',
     1       '2.3-44)', /,' E.G.  SET 101 = 1, 5 THRU 20')
 45   CORE(I81) = IEOR
      NOGO  = 0
      CALL XREAD (*40,CARD)
      IF (CARD(1).EQ.BLANK .AND. CARD(2).EQ.BLANK) GO TO 60
      WRITE (LU,77) CARD
      IF (CARD(1) .NE. DEBUG1) GO TO 46
      J  = LSHIFT(1,20)
      IF (CARD(2) .EQ. DEBUG2) SWTCH1 = ORF(J,SWTCH1)
      J  = COMPLF(J)
      IF (CARD(2) .EQ. DEBUG3) SWTCH1 = ANDF(J,SWTCH1)
      DEBUG = .FALSE.
      IF (CARD(2) .EQ. DEBUG2) DEBUG = .TRUE.
      GO TO 40
 46   IB  = I81
      NZZ = NZ - I81
      CALL XRCARD (CORE(I81),NZZ,CARD(1))
      IF (CORE(I81+8) .NE. ALL) GO TO 47
      CORE(I81  ) = CORE(I81+4)
      CORE(I81+1) = 1
      CORE(I81+2) = JJ
      CORE(I81+3) =-1
      I81 = I81 + 4
      GO TO 50
 47   ICC = 1
      CALL IFP1C (I81,NZZ)
C
C     CONTINUATION CARDS FOR SET ARE READ IN BY IFP1C
C
      IF (NOGO .EQ. 0) GO TO 50
      I81  = IB
      GO TO 40
 50   NSET = NSET + 1
      WRITE  (NOUT,52) CORE(IB)
 52   FORMAT (/,' THIS NEW SET',I6,' IS DEFINED FOR LOCAL USE ONLY',
     1       //,' ENTER A BLANK, OR ANOTHER SET CARD')
      KK = 55
      IF (DEBUG) WRITE (6,55) KK,I81
 55   FORMAT ('   ONLINS/',I2,4X,'I81 =',I7)
      GO TO 45
C
C     SET DATA - FROM CORE(BGN) THRU CORE(END)
C
 60   END = I81 - 1
      NZZ = NZ - I81
C
C     SCAN CARD
C
 70   WRITE  (NOUT,72)
 72   FORMAT (//,' ENTER A BLANK, OR A SCAN CARD (SEE USER MANUAL P.2.3-
     141A',   /,'  E.G. SCAN (STRESS,CBAR,AXIAL,SA/MAX) = 15, SET 102',
     2        /,'       SCAN (FORCE,3,ROD,2) = +2000.,-1500.',
     3        /,'       SCAN (HELP)' )
C
 75   JUMPH = 0
      CALL XREAD (*70,CARD)
      IF (CARD(1).EQ.STOP  .AND. CARD(2).EQ.BLANK) GO TO 135
      IF (CARD(1).EQ.BLANK .AND. CARD(2).EQ.BLANK) GO TO 90
      WRITE  (LU,77) CARD
 77   FORMAT (20A4)
      IB = I81
      CALL XRCARD (CORE(I81),NZZ,CARD(1))
      CALL IFP1H (I81,NZZ,JUMPH)
      IF (NOGO  .NE. 0) GO TO 80
      IF (JUMPH .EQ. 0) GO TO 82
      CALL IFP1H (0,0,2)
 80   I81 = IB
      IF (NOGO) 70,75,70
C
 82   J = CORE(IB)
      IF (ISCAN .EQ. 0) ISCAN = J
      IF (ISCAN .EQ. J) ISCAN = 30000000
      WRITE  (NOUT,85)
 85   FORMAT (/,' ENTER A BLANK, OR ANOTHER SCAN CARD')
      KK = 87
      IF (DEBUG) WRITE (6,55) KK,I81
      GO TO 75
C
C     MOVE SET AND SCAN DATA TO THE END OF CASECC ARRAY IN /ZZIFP1/
C     THEN, MOVE THE ENTIRE CASECC DATA (SET AND SCAN INCLUDED) TO
C     THE END OF THE OPEN CORE. FINALLY, MOVE THE SAME DATA BLOCK
C     TO THE BEGINNING OF THE OPEN CORE SPACE IN /ZZSCAN/ FOR SCAN
C     OPERATION
C
 90   L   = LENCC
      IF (I81 .LE. NWPC1) GO TO 100
      J   = BGN + 2
      I81 = I81 - 1
      DO 95 I = NWPC1,I81
      IF (I .NE. J) GO TO 92
      J   = J + CORE(J-1) + 3
      GO TO 95
 92   L   = L + 1
      LCSE(L) = CORE(I)
 95   CONTINUE
      J   = LCORE
      DO 96 I = 1,L
      LCSE(J) = LCSE(I)
 96   J   = J - 1
      IF (I .GT. J) CALL MESAGE (+8,0,NAME)
      J   = LCORE
      DO 97 I = 1,L
      Z(I) = LCSE(J)
 97   J   = J - 1
      IF (DEBUG) WRITE (6,99) (Z(I),I=1,L)
 99   FORMAT (//,' Z(1...200+) =', (/4X,10I7))
 100  IF (LX .GT. 0) LX = L
C
      IF (ISCAN .EQ. 20000000) GO TO 103
      IF (Z(25) .EQ. 0) GO TO 140
C
C     STRESS SCAN
C
      Z(24) =-1
      Z(25) = 1
      Z(26) = 1
 103  IF (ISCAN .NE. 20000000) GO TO 105
      IF (Z(28) .EQ. 0) GO TO 150
C
C     FORCE SCAN
C
      Z(27) =-1
      Z(28) = 1
      Z(29) = 1
 105  IF (INTRA .GT. 10) OUTTAP = LU
      RETURN
C
 110  JJ = JJ - 1
      WRITE  (NOUT,115) SUBID,(Z(I),I=1,JJ)
 115  FORMAT (//,' SUBCASE',I5,' NOT FOUND',
     1        //,' EXISTING SUBCASES ARE -', (/5X,10I7))
      GO TO 15
C
 125  CALL MESAGE (+2,CASECC,NAME)
      GO TO 105
 135  RETURN 1
C
 140  WRITE  (NOUT,145)
 145  FORMAT (//,' STRESS OUTPUT FILE NOT AVAILABLE FOR SCAN',//)
      GO TO 75
 150  WRITE  (NOUT,155)
 155  FORMAT (//,' FORCE  OUTPUT FILE NOT AVAILABLE FOR SCAN',//)
      GO TO 75
      END

      SUBROUTINE DVECTR (GPT,X,U,PEN)
C
      INTEGER GPT(1),PEN
      REAL    X(3,1),U(2,1)
      COMMON /BLANK/ NGP
C
      CALL LINE (0,0,0,0,0,-1)
C
C     DO NOT DRAW A VECTOR AT ANY GRID POINT WHOSE INDEX .LE. 0.
C
      DO 120 I = 1,NGP
      J  = GPT(I)
      IF (J .LE. 0) GO TO 120
      X1 = X(2,J)
      Y1 = X(3,J)
      X2 = U(1,J)
      Y2 = U(2,J)
      CALL LINE (X1,Y1,X2,Y2,PEN,0)
  120 CONTINUE
C
      CALL LINE (0,0,0,0,0,1)
      RETURN
      END

      SUBROUTINE CXLOOP (X,Y,N)
      DOUBLE PRECISION X(1), Y(1)
      DOUBLE PRECISION XX(2) , YY(2), MPY(2)
      NN = N + N
      DO 10 I = 1,NN
   10 X(I) = Y(I)
      RETURN
      ENTRY CLOOP( XX, YY, MPY, M)
      MM = M+M
      DO 20 I = 1,MM,2
      XX(I) = XX(I) - MPY(1)*YY(I) + MPY(2) * YY(I+1)
   20 XX(I+1) = XX(I+1) -MPY(2)*YY(I) -MPY(1)*YY(I+1)
      RETURN
      END

      SUBROUTINE ADRPRT (CASECC,PKF,SPLINE,SILA,USETA,FREQ,NFREQ,
     1                   NCORE,NLOAD)
C
C     ADRPRT FORMATS PKF BY USER SET REQUEST FOR EACH FREQUENCY
C
      EXTERNAL        ANDF
      INTEGER         CASECC,PKF,SPLINE,SILA,USETA,SYSBUF,OUT,NAM(2),
     1                LSP(2),ANDF,SETNO,ALL,EXTID,TRL(7)
      REAL            FREQ(1),Z(1),BUF(12),TSAVE(96)
      COMMON /SYSTEM/ SYSBUF,OUT,DUM1(6),NLPP
      COMMON /UNPAKX/ ITO,II,NN,INCR
      COMMON /TWO   / ITWO(32)
      COMMON /BITPOS/ IBIT(64)
      COMMON /OUTPUT/ HEAD(96)
      COMMON /ZZZZZZ/ IZ(1)
      EQUIVALENCE     (Z(1),IZ(1))
      DATA    IAERO / 176 /, LCS /200/
      DATA    NHFSSU, NAM /  4HFSSU,4HADRP,4HRT  /
      DATA    LSP   / 200,2/
C
C     CORE LAYOUT
C       FREQ LIST          NFREQ
C       SPLINE TRIPLETS    3*K POINTS
C       SILS FOR K POINTS  1 PER K
C       USET MASKS         6*K POINTS
C       CASECC RECORD      TRL(4) LONG
C       LOAD VECTOR        K SIZE
C       BUFFERS            2 * SYSBUF
C
      MASK = IBIT(19)
      MASK = ITWO(MASK)
      DO 5 I = 1,96
    5 TSAVE(I) = HEAD(I)
      IBUF1 = NCORE - SYSBUF - 1
      IBUF2 = IBUF1 - SYSBUF
      IZSPL = NFREQ
      NR = IBUF2 - IZSPL
      CALL PRELOC (*1000,Z(IBUF1),SPLINE)
      CALL LOCATE (*1000,Z(IBUF1),LSP,DUM)
      CALL READ (*1000,*10,SPLINE,Z(IZSPL+1),NR,0,NWR)
      GO TO 999
   10 NSPL  = NWR
      IZSIL = IZSPL + NWR
      CALL CLOSE (SPLINE,1)
C
C     FIND SMALLEST SILGA POINTER (-1+NEXTRA = NSKIP ON SILA)
C
      ISMAL = 1000000
      DO 20 I = 1,NSPL,3
      ISMAL = MIN0(ISMAL,IZ(IZSPL+I+1))
   20 CONTINUE
      ISMAL = ISMAL - 1
      TRL(1)= SILA
      CALL RDTRL (TRL)
      IF (TRL(1) .LT. 0) GO TO 1000
      NEXTRA = TRL(3)
      CALL GOPEN (SILA,Z(IBUF1),0)
      NSKIP = ISMAL + NEXTRA
      NR = IBUF2 - IZSIL
      CALL READ (*1000,*1000,SILA,Z(IZSIL+1),-NSKIP,0,NWR)
      CALL READ (*1000,*30,SILA,Z(IZSIL+1),NR,0,NWR)
      GO TO 999
   30 NSIL = NWR
      CALL CLOSE (SILA,1)
      IZUSET = IZSIL + NWR
      NR = IBUF2 - IZUSET
      NSKIP = IZ(IZSIL+1) -1
      CALL OPEN (*1000,USETA,Z(IBUF1),0)
      CALL FWDREC (*1000,USETA)
      CALL READ (*1000,*1000,USETA,Z(IZUSET+1),-NSKIP,0,NWR)
      CALL READ (*1000,*40,USETA,Z(IZUSET+1),NR,0,NWR)
      GO TO 999
   40 ICC = IZUSET + NWR
      CALL CLOSE (USETA,1)
C
C     ADJUST SILA AND USET POINTERS FOR SHRUNKEN LISTS
C
      DO 50 I = 1,NSPL,3
      IZ(IZSPL+I+1) = IZ(IZSPL+I+1) - ISMAL
   50 CONTINUE
      DO 60 I = 1,NSIL
      IZ(IZSIL+I) = IZ(IZSIL+I) - NSKIP
   60 CONTINUE
      CALL BUG (NHFSSU,60,Z,ICC)
      TRL(1) = CASECC
      CALL RDTRL (TRL)
      LCC = TRL(4) + 1
      IZVECT = ICC + LCC
      TRL(1) = PKF
      CALL RDTRL (TRL)
      ITO = 3
      II  = 1
      NN  = TRL(3)
      INCR  = 1
      NVECT = TRL(3)*2
      IEND  = IZVECT + NVECT
      IF (IEND .GT. IBUF2) GO TO 999
      CALL OPEN (*1000,CASECC,Z(IBUF1),0)
      CALL FWDREC (*1000,CASECC)
      CALL OPEN (*1000,PKF,Z(IBUF2),0)
      CALL FWDREC (*1000,PKF)
C
C     LOOP OVER NLOAD (CASECC RECORDS)
C     THEN LOOP OVER NFREQ  (PKF COLUMNS)
C     OUTPUT K POINTS FOR SET LIST
C
      DO 300 K = 1,NLOAD
      CALL READ (*1000,*65,CASECC,Z(ICC+1),LCC,1,NWR)
   65 SETNO = IZ(ICC+IAERO)
      ALL = 0
      DO 61 I = 1,96
   61 HEAD(I) = Z(ICC+I+38)
      IF(SETNO) 70,250,80
   70 ALL = 1
      GO TO 100
   80 ISETNO = LCS + IZ(ICC+LCS) + 1 + ICC
   90 ISET = ISETNO + 2
      NSET = IZ(ISETNO+1) + ISET - 1
      IF (IZ(ISETNO) .EQ. SETNO) GO TO 100
      ISETNO = NSET +1
      IF (ISETNO .LT. IZVECT) GO TO 90
      ALL = 1
  100 DO 240 J = 1,NFREQ
      NLPPP = NLPP
      CALL UNPACK (*110,PKF,Z(IZVECT+1))
      GO TO 120
  110 CALL ZEROC (Z(IZVECT+1),NVECT)
C
C     PRINT LOOP
C
  120 IF (ALL .EQ. 0) GO TO 150
      ASSIGN 140 TO IRET
      L = 1
      GO TO 181
  140 L = L + 3
      IF (L .GE. NSPL) GO TO 240
      GO TO 181
  150 I = ISET
  155 IF (I .EQ. NSET) GO TO 170
      IF (IZ(I+1) .GT. 0) GO TO 170
      ID = IZ(I  )
      N  =-IZ(I+1)
      I  = I+1
      ASSIGN 160 TO IRET1
      GO TO 180
  160 ID = ID + 1
      IF (ID .LE. N) GO TO 180
      GO TO 175
  170 ID = IZ(I)
      ASSIGN 175 TO IRET1
      GO TO 180
  175 I = I + 1
      IF (I .LE. NSET) GO TO 155
      GO TO 240
C
C     LOCATE ELEMENT THEN  PRINT DATA
C
  180 ASSIGN 190 TO IRET
      CALL BISLOC (*190,ID,IZ(IZSPL+1),3,NSPL/3,L)
  181 EXTID = IZ(IZSPL+L)
      IPSIL = IZ(IZSPL+L+1)
      IROW  = IZ(IZSPL+L+2) *2 - 1 + IZVECT
      IPUSET= IZ(IZSIL+IPSIL) + IZUSET - 1
      GO TO 200
  190 GO TO IRET1, (160,175)
C
C     PRINT
C
  200 IF (NLPPP .LT. NLPP) GO TO 210
      CALL PAGE1
      WRITE  (OUT,201) J,FREQ(J)
  201 FORMAT (44X,42HAERODYNAMIC LOADS  (UNIT DYNAMIC PRESSURE),  /
     1  30X,7HVECTOR ,I8,10X,12HFREQUENCY = ,1P,E14.6,7H  HERTZ,  /,
     2  11H BOX OR    ,12X,7HT1 / R1,23X,7HT2 / R2,23X,7HT3 / R3, /,
     3  11H BODY ELMT., 3(4X,4HREAL,10X,12HIMAGINARY   ))
      NLPPP = 1
  210 DO 220 M = 1,6
      MM = M*2 - 1
      BUF(MM  ) = 0.0
      BUF(MM+1) = 0.0
      IF (ANDF(IZ(IPUSET+M),MASK) .EQ. 0) GO TO 220
      BUF(MM  ) = Z(IROW  )
      BUF(MM+1) = Z(IROW+1)
      IROW = IROW + 2
  220 CONTINUE
      WRITE  (OUT,221) EXTID,BUF
  221 FORMAT (1H0,I10,6(1P,E15.6), /11X,6(1P,E15.6))
      NLPPP = NLPPP + 3
      GO TO IRET, (140,190)
  240 CONTINUE
  250 IF (K .EQ. NLOAD) GO TO 300
      CALL REWIND (PKF)
      CALL SKPREC (PKF,1)
  300 CONTINUE
C
C     CLOSE UP AND RETURN
C
 1000 CALL CLOSE (CASECC,1)
      CALL CLOSE (PKF,1)
      CALL CLOSE (SILA,1)
      CALL CLOSE (SPLINE,1)
      DO 1001 I = 1,96
 1001 HEAD(I) = TSAVE(I)
      CALL PAGE2 (1)
      RETURN
C
C     ERROR MESSAGES
C
  999 CALL MESAGE (8,0,NAM)
      GO TO 1000
      END

      SUBROUTINE SOFUT
C
C     THE PURPOSE OF THE MODULE IS TO PERFORM THE TASKS OF ALTERING THE
C     SOF FILE IN ORDER TO EDIT, PURGE, AND EQUIVALENCE THE DATA ITEMS
C     OF SELECTED SUBSTRUCTURES.  THE CALLING SEQUENCE TO THE MODULE IS
C
C     SOFUT     //V,N,DRY/C,N,NAME1/C,N,OPER/C,N,OPT/C,N,NAME2/
C                 C,N,PREFX/C,N,IA/C,N,IB/C,N,IC/C,N,ID/C,N,IE $
C
      EXTERNAL        RENAME
      LOGICAL         DITUP
      INTEGER         DRY,OPER,OPT,PREFX,SYSBUF,DELE,RENAM,NAME(2)
      CHARACTER       UFM*23,UWM*25
      COMMON /XMSSG / UFM,UWM
      COMMON /BLANK / DRY,NAME1(2),OPER(2),OPT,NAME2(2),PREFX(2),
     1                ITEMS(10)
      COMMON /SOF   / SSS(33),DITUP
      COMMON /ZZZZZZ/ IZ(1)
      COMMON /SYSTEM/ SYSBUF,NOUT
      DATA    IEDIT , IDEST,IEQUIV / 4HEDIT    ,4HDEST ,4HEQUI   /
      DATA    IPRNT / 4HSOFP/
      DATA    DELE  / 4HDELE/
      DATA    RENAM / 4HRENA/
      DATA    NAME  / 4HSOFU,4HT   /
      DATA    ISCR1 / 301   /
C
      ITASK = 0
      IF (OPER(1) .EQ.  IEDIT) ITASK = 1
      IF (OPER(1) .EQ.  IDEST) ITASK = 2
      IF (OPER(1) .EQ. IEQUIV) ITASK = 3
      IF (OPER(1) .EQ.  IPRNT) ITASK = 4
      IF (OPER(1) .EQ.   DELE) ITASK = 5
      IF (OPER(1) .EQ.  RENAM) ITASK = 6
      IF (ITASK .EQ. 0) GO TO 1000
C
C     ALLOCATE BUFFERS FOR THE SOF UTILITY SUBROUTINES
C
      NZ  = KORSZ(IZ)
      IF (3*SYSBUF .GT. NZ) CALL MESAGE (-8,0,NAME(1))
      IB1 = NZ  - SYSBUF + 1
      IB2 = IB1 - SYSBUF - 1
      IB3 = IB2 - SYSBUF
      CALL SOFOPN (IZ(IB1),IZ(IB2),IZ(IB3))
      NZ  = IB3 - 1
      GO TO (20,30,40,130,180,200), ITASK
C
C     EDIT OPERATION
C
   20 CALL EDIT (NAME1(1),OPT,ITEST)
      GO TO 50
C
C     DESTROY OPERATION
C
   30 I = NZ/2 + 1
      CALL DSTROY (NAME1(1),ITEST,IZ,IZ(I),I-1)
      GO TO 50
C
C     EQUIVALENCE OPERATION
C
   40 I = NZ/2 + 1
      CALL SETEQ (NAME1,NAME2,PREFX,DRY,ITEST,IZ,I-1)
C
C     TEST RETURN CODE
C
   50 GO TO (110,110,110,60,110,70,110,80,90,100), ITEST
   60 WRITE (NOUT,1010) UWM,NAME1
      GO TO 100
   70 WRITE (NOUT,1020) UWM,NAME1
      GO TO 100
   80 WRITE (NOUT,1030) UWM,NAME2
      GO TO 100
   90 WRITE (NOUT,1040) UWM,NAME2
  100 DRY = -2
  110 CALL SOFCLS
      GO TO 1100
C
C     PRINT OPERATIONS
C
  130 IF (OPT) 140,140,150
C
C     PRINT SOF TABLE OF CONTENTS (DIT MDI)
C
  140 CALL SOFTOC
      IF (OPT .EQ. 0) GO TO 170
C
C     PRINT SOF DATA ITEMS
C
  150 DO 160 I = 1,5
      II = ITTYPE(ITEMS(2*I-1))
      IF (II) 160,152,154
C
C     TABLE ITEM
C
  152 CALL ITMPRT (NAME1,ITEMS(2*I-1),NZ,OPT)
      GO TO 160
C
C     MATRIX ITEM
C
  154 CALL MATWRT (ISCR1,NAME1,ITEMS(2*I-1),NZ)
C
  160 CONTINUE
  170 CALL SOFCLS
      GO TO 1100
C
C     DELETE OPERATION
C
  180 DO 190 I = 1,10
  190 CALL DELETE (NAME1,ITEMS(I),ITEST)
      GO TO 50
C
C     RENAME OPERATION
C
  200 CALL RENAME (NAME1,NAME2,IZ(1),NZ,ITEST)
      GO TO 50
C
C     ERROR MESSAGES
C
 1000 WRITE  (NOUT,1001) UWM,OPER(1),OPER(2)
 1001 FORMAT (A25,' 6217, MODULE SOFUT - ',2A4,' IS AN ILLEGAL ',
     1       'PARAMETER NAME.')
      GO TO 1100
C
 1010 FORMAT (A25,' 6212, MODULE SOFUT - THE SUBSTRUCTURE ',2A4,
     1       ' DOES NOT EXIST.')
C
 1020 FORMAT (A25,' 6218, MODULE SOFUT - THE SUBSTRUCTURE ',2A4,1X,
     1       'CANNOT BE DESTROYED BECAUSE IT IS AN IMAGE SUBSTRUCTURE.')
C
 1030 FORMAT (A25,' 6219, MODULE SOFUT - RUN EQUALS DRY OR STEP AND ',
     1       'SUBSTRUCTURE ',2A4, /33X,
     2       'OR ONE OF THE NEW NAMES ALREADY EXISTS.')
C
 1040 FORMAT (A25,' 6220, MODULE SOFUT - RUN = GO AND SUBSTRUCTURE ',
     1        2A4,' OR ONE OF THE NEW NAMES DOES NOT EXIST')
C
 1100 RETURN
      END

      SUBROUTINE AXIS (XA,YA,XB,YB,PENX,OPT)
C
C     (XA,YA) = STARTING POINT OF THE AXIS.
C     (XB,YB) = TERMINAL POINT OF THE AXIS.
C     PENX    = PEN NUMBER OR LINE DENSITY (DEPENDS ON PLOTTER).
C     OPT     = -1 TO INITIATE  THE LINE MODE.
C             = +1 TO TERMINATE THE LINE MODE.
C             =  0 TO DRAW A LINE.
C
      INTEGER PEN,PENX,OPT,PLOTER
      COMMON /PLTDAT/ MODEL,PLOTER,SKPPLT(18),SKPA(6),NPENS
C
      IF (OPT .NE. 0) GO TO 110
      PEN = MAX0(PENX,1)
      PEN = PEN - NPENS*((PEN-1)/NPENS)
C
  110 CALL AXIS10 (XA,YA,XB,YB,PEN,OPT)
      RETURN
      END

      SUBROUTINE SQUD41
C
C     PHASE 1  STRESS DATA RECOVERY FOR CQUAD4 ELEMENT
C
C                EST  LISTING
C
C     WORD       TYPE         DESCRIPTION
C     --------------------------------------------------------------
C       1          I    ELEMENT ID, EID
C       2 THRU 5   I    SILS, GRIDS 1 THRU 4
C       6 THRU 9   R    MEMBRANE THICKNESSES T AT GRIDS 1 THRU 4
C      10          R    MATERIAL PROPERTY ORIENTATION ANGLE, THETA
C               OR I    COORD. SYSTEM ID (SEE TM ON CQUAD4 CARD)
C      11          I    TYPE FLAG FOR WORD 10
C      12          R    GRID ZOFF  (OFFSET)
C      13          I    MATERIAL ID FOR MEMBRANE, MID1
C      14          R    ELEMENT THICKNESS, T (MEMBRANE, UNIFORMED)
C      15          I    MATERIAL ID FOR BENDING, MID2
C      16          R    BENDING INERTIA FACTOR, I
C      17          I    MATERIAL ID FOR TRANSVERSE SHEAR, MID3
C      18          R    TRANSV. SHEAR CORRECTION FACTOR TS/T
C      19          R    NON-STRUCTURAL MASS, NSM
C      20 THRU 21  R    Z1, Z2  (STRESS FIBRE DISTANCES)
C      22          I    MATERIAL ID FOR MEMBRANE-BENDING COUPLING, MID4
C      23          R    MATERIAL ANGLE OF ROTATION, THETA
C               OR I    COORD. SYSTEM ID (SEE MCSID ON PSHELL CARD)
C      24          I    TYPE FLAG FOR WORD 23
C      25          I    INTEGRATION ORDER
C      26          R    STRESS ANGLE OF ROTATION, THETA
C               OR I    COORD. SYSTEM ID (SEE SCSID ON PSHELL CARD)
C      27          I    TYPE FLAG FOR WORD 26
C      28          R    ZOFF1 (OFFSET)  OVERRIDDEN BY EST(12)
C      29 THRU 44  I/R  CID,X,Y,Z - GRIDS 1 THRU 4
C      45          R    ELEMENT TEMPERATURE
C
C
      LOGICAL         BADJAC,MEMBRN,BENDNG,SHRFLX,MBCOUP,NORPTH,NOCSUB
      INTEGER         NEST(45),NPHI(2395),SIL(4),KSIL(4),KCID(8),
     1                IGPDT(4,4),ELID,SCSID,FLAGS,FLAGM,NECPT(4),
     2                INDEX(3,3),MID(4),Q4STRS,IPN(4),HUNMEG,ROWFLG,
     3                TYPE,NAME(2)
      REAL            BGPDM(3,4),CENT(3),GPTH(4),GPNORM(4,4),BGPDT(4,4),
     1                MATSET,MOMINR,TMPTHK(4),TGRID(4,4),EPNORM(4,4),
     2                EGPDT(4,4),G(6,6),GI(36),SHP(4),DSHP(8),GGE(9),
     3                GGU(9),PTINT(2),PTINTP(3),TBS(9),TEU(9),TSE(9),
     4                TEB(9),TBG(9),TUB(9),TUM(9),TSU(9),U(9),GT(9),
     5                TBM(9),TEM(9),TMI(9),ECPT(4),GPC(3),XA(4),YB(4),
     6                ALFA(3),GPTH2(4),RELOUT(300),NUNORX,NUNORY,
     7                UGPDM(3,4),CENTE(3),BMATRX(192),XYBMAT(96),
     8                JACOB(3,3),PHI(9),PSITRN(9),TMPSHP(4),DSHPTP(8),
     9                KHEAT,TMS(9),DQ(24),JACOBU(9),JACBS(9),JACOBE(9),
     O                ZC(4),VNT(3,4)
CWKBNB 11/93 SPR 93020
      REAL            VD1(3), VD2(3), VKN(3), VKS(3)
     1,               V12(3), V41(3), VP12(3),VIS(3), VJS(3)
CWKBNE 11/93 SPR 93020
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /SDR2X5/ EST(100),PHIOUT(2395)
      COMMON /SDR2X6/ IELOUT(300)
      COMMON /CONDAS/ PI,TWOPI,RADDEG,DEGRAD
      COMMON /SYSTEM/ SYSTM(100)
      COMMON /MATIN / MATID,INFLAG,ELTEMP
      COMMON /MATOUT/ RMTOUT(25)
      COMMON /Q4DT  / DETJ,HZTA,PSITRN,NNODE,BADJAC,NODE
      COMMON /TERMS / MEMBRN,BENDNG,SHRFLX,MBCOUP,NORPTH
      COMMON /HMTOUT/ KHEAT(7),TYPE
      COMMON /Q4COMS/ ANGLEI(4),EDGSHR(3,4),EDGEL(4),UNV(3,4),
     1                UEV(3,4),ROWFLG,IORDER(4)
      EQUIVALENCE     (IGPDT(1,1),BGPDT(1,1)),(EST(1)  ,NEST(1)   ),
     1                (BGPDT(1,1),EST(29)   ),(GPTH(1) ,EST(6)    ),
     2                (ELTH      ,EST(14)   ),(SIL(1)  ,NEST(2)   ),
     3                (NPHI(1)   ,PHIOUT(1) ),(INT     ,NEST(25)  ),
     4                (ZOFF      ,NEST(12)  ),(ZOFF1   ,EST(28)   ),
     5                (IELOUT(1) ,RELOUT(1) ),(MATSET  ,RMTOUT(25)),
     6                (NECPT(1)  ,ECPT(1)   ),(SYSTM(2),NOUT      ),
     7                (PHIOUT(65),GPTH2(1)  ),(SYSTM(3),NOGO      ),
     8                (HTCP      ,KHEAT(4)  ),(ITHERM  ,SYSTM(56) )
      DATA    EPS1  / 1.0E-16/   ,IPN / 1,4,2,3 /
      DATA    NAME  / 4HQUAD,4H4      /
      DATA    HUNMEG/ 100000000       /
      DATA    CONST / 0.57735026918962/
C
C     PHIOUT DATA BLOCK
C     --------------------------------------------------------------
C     PHIOUT(1)                 = ELID (ELEMENT ID)
C     PHIOUT(2-9)               = SIL NUMBERS
C     PHIOUT(10-17)             = ARRAY IORDER
C     PHIOUT(18)                = TSUB0 (REFERENCE TEMP.)
C     PHIOUT(19-20)             = Z1 & Z2 (FIBER DISTANCES)
C     PHIOUT(21)                = AVGTHK  (AVERAGE THICKNESS)
C     PHIOUT(22)                = MOMINR  (MOMENT OF INER. FACTOR)
C     PHIOUT(23-58)             = GBAR (BASIC MAT. PROP. MATRIX)
C                                 (W/O SHEAR)
C     PHIOUT(59-61)             = THERMAL EXPANSION COEFFICIENTS
C                                 FOR MEMBRANE MATERIAL
C     PHIOUT(62-64)             = THERMAL EXPANSION COEFFICIENTS
C                                 FOR BENDING MATERIAL
C     PHIOUT(65-68)             = CORNER NODE THICKNESSES
C     PHIOUT(69-77)             = 3X3 TRANSFORMATION FROM USER TO
C                                 MATERIAL COORD. SYSTEM
C     PHIOUT(78)                = OFFSET OF ELEMENT FROM GP PLANE
C     PHIOUT(79)                = ID OF THE ORIGINAL PCOMP(I)
C                                 PROPERTY ENTRY FOR COMPOSITES
C     PHIOUT(80-(79+9*NNODE))   = 3X3 TRANSFORMATIONS FROM GLOBAL
C                                 TO ELEMENT COORDINATE SYSTEM
C                                 FOR EACH EXISTING NODE
C
C     THE FOLLOWING IS REPEATED FOR EACH EVALUATION POINT AND THE
C     CENTER POINT (10 TIMES). THE EVALUATION POINTS ARE AT THE
C     STANDARD 2X2X2 GAUSSIAN POINTS. THE CHOICE OF THE
C     FINAL STRESS AND FORCE OUTPUT POINTS IS MADE AT THE SUBCASE
C     LEVEL (PHASE 2.)
C
C              1                  THICKNESS OF THE ELEMENT AT THIS
C                                 EVALUATION POINT
C            2 - 10               3X3 TRANSFORMATION FROM TANGENT
C                                 TO STRESS C.S. AT THIS EVAL. PT.
C           11 - 19               CORRECTION TO GBAR-MATRIX FOR
C                                 MEMBRANE-BENDING COUPLING AT THIS
C                                 EVALUATION POINT
C           20 - 28               3X3 TRANSFORMATION FROM MATERIAL
C                                 TO INTEGRATION PT. COORDINATE
C                                 SYSTEM
C           29 - 32               2X2 PROPERTY MATRIX FOR OUT-OF-
C                                 PLANE SHEAR (G3)
C         32+1 - 32+NNODE         ELEMENT SHAPE FUNCTIONS
C   32+NNODE+1 - 32+NNODE+8*NDOF  STRAIN RECOVERY MATRIX
C
C
C              IELOUT DATA BLOCK      (TOTAL OF NWORDS = 102)
C     --------------------------------------------------------------
C              1                  ELEMENT ID
C              2                  AVERAGE THICKNESS
C
C     THE FOLLOWING IS REPEATED FOR EACH CORNER POINT.
C
C         WORD  1                 SIL NUMBER
C         WORD  2-10              TBS TRANSFORMATION FOR Z1
C         WORD 11-19              TBS TRANSFORMATION FOR Z2
C         WORD 20-22              NORMAL VECTOR IN BASIC C.S.
C         WORD 23-25              GRID COORDS IN BASIC C.S.
C
C
      Q4STRS = 0
      ELID   = NEST(1)
      NPHI(1)= ELID
      NORPTH =.FALSE.
      NODE   = 4
      NNODE  = 4
      NDOF   = NNODE*6
      ND2    = NDOF*2
      ND3    = NDOF*3
      ND4    = NDOF*4
      ND5    = NDOF*5
      ND6    = NDOF*6
      ND7    = NDOF*7
      ND8    = NDOF*8
C
C     FILL IN ARRAY GGU WITH THE COORDINATES OF GRID POINTS 1, 2 AND 4.
C     THIS ARRAY WILL BE USED LATER TO DEFINE THE USER COORD. SYSTEM
C     WHILE CALCULATING  TRANSFORMATIONS INVOLVING THIS COORD. SYSTEM.
C
      DO 10 I = 1,3
      II = (I-1)*3
      IJ = I
      IF (IJ .EQ. 3) IJ = 4
      DO 10 J = 1,3
      JJ = J + 1
   10 GGU(II+J) = BGPDT(JJ,IJ)
CWKBD 11/93 SPR93020      CALL BETRNS (TUB,GGU,0,ELID)
CWKBNB 11/93 SPR93020
C    ADD FROM SHEAR ELEMENT
C
C    COMPUTE DIAGONAL VECTORS
C
      DO 21 I = 1,3
      II=I+1
      VD1(I) = BGPDT(II,3) - BGPDT(II,1)
   21 VD2(I) = BGPDT(II,4) - BGPDT(II,2)
C
C    COMPUTE THE NORMAL VECTOR VKN, NORMALIZE, AND COMPUTE THE PROJECTED
C    AREA, PA
C
      VKN(1) = VD1(2)*VD2(3) - VD1(3)*VD2(2)
      VKN(2) = VD1(3)*VD2(1) - VD1(1)*VD2(3)
      VKN(3) = VD1(1)*VD2(2) - VD1(2)*VD2(1)
      VKL = SQRT( VKN(1)**2 + VKN(2)**2 + VKN(3)**2 )
      IF ( VKL .EQ. 0. ) WRITE( NOUT, 2070 ) EST(1)
2070  FORMAT(//,' ILLEGAL GEOMETRY FOR QUAD4 ELEMENT, ID=',I10 )
      VKS(1) = VKN(1)/VKL
      VKS(2) = VKN(2)/VKL
      VKS(3) = VKN(3)/VKL
      PA = VKL/2.
C
C  COMPUTE SIDES -12- AND -41-
      DO 25 I = 1,3
      II = I + 1
      V12(I) = BGPDT(II,2) - BGPDT(II,1)
      V41(I) = BGPDT(II,1) - BGPDT(II,4)
25    CONTINUE
C
C  COMPUTE DOT PRODUCT, V12DK, OR V12 AND VK, THE VECTORS VP12, VI, VJ
C
      V12DK   = V12(1)*VKS(1) + V12(2)*VKS(2) + V12(3)*VKS(3)
      VP12(1) = V12(1) - V12DK*VKS(1)
      VP12(2) = V12(2) - V12DK*VKS(2)
      VP12(3) = V12(3) - V12DK*VKS(3)
      VP12L   = SQRT( VP12(1)**2 + VP12(2)**2 + VP12(3)**2 )
      IF ( VP12L .EQ. 0. ) WRITE( NOUT, 2070 ) EST(1)
      VIS(1) = VP12(1) / VP12L
      VIS(2) = VP12(2) / VP12L
      VIS(3) = VP12(3) / VP12L
      VJS(1) = VKS(2)*VIS(3) - VKS(3)*VIS(2)
      VJS(2) = VKS(3)*VIS(1) - VKS(1)*VIS(3)
      VJS(3) = VKS(1)*VIS(2) - VKS(2)*VIS(1)
C
C   NORMALIZE J FOR GOOD MEASURE
C
      VJL = SQRT( VJS(1)**2 + VJS(2)**2 + VJS(3)**2 )
      IF ( VJL .EQ. 0. ) WRITE ( NOUT, 2070 ) EST(1)
      VJS(1) = VJS(1) / VJL
      VJS(2) = VJS(2) / VJL
      VJS(3) = VJS(3) / VJL
      DO 29 I = 1,3
      TUB(I)   = VIS(I)
      TUB(I+3) = VJS(I)
      TUB(I+6) = VKS(I)
29    CONTINUE
CWKBNE 11/93 SPR93020

C
C     STORE INCOMING BGPDT FOR ELEMENT C.S.
C
      DO 20 I = 1,3
      I1 = I + 1
      DO 20 J = 1,4
   20 BGPDM(I,J) = BGPDT(I1,J)
C
C     TRANSFORM BGPDM FROM BASIC TO USER C.S.
C
      DO 30 I = 1,3
      IP = (I-1)*3
      DO 30 J = 1,4
      UGPDM(I,J) = 0.0
      DO 30 K = 1,3
      KK = IP + K
   30 UGPDM(I,J) = UGPDM(I,J) + TUB(KK)*((BGPDM(K,J))-GGU(K))
C
C     THE ORIGIN OF THE ELEMENT C.S. IS IN THE MIDDLE OF THE ELEMENT
C
      DO 40 J = 1,3
      CENT(J) = 0.0
      DO 40 I = 1,4
   40 CENT(J) = CENT(J) + UGPDM(J,I)/NNODE
C
C     STORE THE CORNER NODE DIFF. IN THE USER C.S.
C
      X31 = UGPDM(1,3) - UGPDM(1,1)
      Y31 = UGPDM(2,3) - UGPDM(2,1)
      X42 = UGPDM(1,4) - UGPDM(1,2)
      Y42 = UGPDM(2,4) - UGPDM(2,2)
      AA  = SQRT(X31*X31 + Y31*Y31)
      BB  = SQRT(X42*X42 + Y42*Y42)
C
C     NORMALIZE XIJ'S
C
      X31 = X31/AA
      Y31 = Y31/AA
      X42 = X42/BB
      Y42 = Y42/BB
      EXI = X31 - X42
      EXJ = Y31 - Y42
C
C     STORE GGE ARRAY, THE OFFSET BETWEEN ELEMENT C.S. AND USER C.S.
C
      GGE(1) = CENT(1)
      GGE(2) = CENT(2)
      GGE(3) = CENT(3)
C
      GGE(4) = GGE(1) + EXI
      GGE(5) = GGE(2) + EXJ
      GGE(6) = GGE(3)
C
      GGE(7) = GGE(1) - EXJ
      GGE(8) = GGE(2) + EXI
      GGE(9) = GGE(3)
C
C     START FILLING IN IELOUT ARRAY WITH DATA TO BE STORED IN GPSRN
C
      IELOUT(1) = ELID
      DO 50 I = 1,4
      IELOUT(3+(I-1)*25) = SIL(I)
      DO 50 J = 1,3
      RELOUT(25*I+J-1) = BGPDT(J+1,I)
   50 CONTINUE
C
C     THE ARRAY IORDER STORES THE ELEMENT NODE ID IN
C     INCREASING SIL ORDER.
C
C     IORDER(1) = NODE WITH LOWEST  SIL NUMBER
C     IORDER(4) = NODE WITH HIGHEST SIL NUMBER
C
C     ELEMENT NODE NUMBER IS THE INTEGER FROM THE NODE LIST G1,G2,G3,G4.
C     THAT IS, THE 'I' PART OF THE 'GI' AS THEY ARE LISTED ON THE
C     CONNECTIVITY BULK DATA CARD DESCRIPTION.
C
C
      DO 60 I = 1,4
      IORDER(I) = 0
   60 KSIL(I) = SIL(I)
C
      DO 80 I = 1,4
      ITEMP = 1
      ISIL  = KSIL(1)
      DO 70 J = 2,4
      IF (ISIL .LE. KSIL(J)) GO TO 70
      ITEMP = J
      ISIL  = KSIL(J)
   70 CONTINUE
      IORDER(I)   = ITEMP
      KSIL(ITEMP) = 99999999
   80 CONTINUE
C
C     ADJUST EST DATA
C
C     USE THE POINTERS IN IORDER TO COMPLETELY REORDER THE
C     GEOMETRY DATA INTO INCREASING SIL ORDER.
C     DON'T WORRY!! IORDER ALSO KEEPS TRACK OF WHICH SHAPE
C     FUNCTIONS GO WITH WHICH GEOMETRIC PARAMETERS!
C
      DO 100 I = 1,4
      KSIL(I)   = SIL(I)
      TMPTHK(I) = GPTH(I)
      KCID(I)   = IGPDT(1,I)
      DO 90 J = 2,4
      TGRID(J,I) = BGPDT(J,I)
   90 CONTINUE
  100 CONTINUE
      DO 120 I = 1,4
      IPOINT  = IORDER(I)
      GPTH(I) = TMPTHK(IPOINT)
      IGPDT(1,I) = KCID(IPOINT)
      SIL(I)     = KSIL(IPOINT)
      NPHI(I+1 ) = KSIL(IPOINT)
      NPHI(I+5 ) = 0
      NPHI(I+9 ) = IPOINT
      NPHI(I+13) = 0
      DO 110 J = 2,4
      BGPDT(J,I) = TGRID(J,IPOINT)
  110 CONTINUE
  120 CONTINUE
C
      NPHI(19) = NEST(20)
      NPHI(20) = NEST(21)
      PHIOUT(18) = 0.0
      OFFSET   = ZOFF
      IF (ZOFF .EQ. 0.0) OFFSET = ZOFF1
      PHIOUT(78) = OFFSET
C
C     COMPUTE NODE NORMALS
C
      CALL Q4NRMS (BGPDT,GPNORM,IORDER,IFLAG)
      IF (IFLAG .EQ. 0) GO TO 130
      WRITE (NOUT,1710) UFM,ELID
      GO TO 1430
  130 CONTINUE
C
C     PUT NORMALS IN IELOUT
C
      DO 140 I = 1,NNODE
      IO  = IORDER(I)
      IOP = (IO-1)*25 + 21
      RELOUT(IOP+1) = GPNORM(2,I)
      RELOUT(IOP+2) = GPNORM(3,I)
      RELOUT(IOP+3) = GPNORM(4,I)
  140 CONTINUE
C
C     COMPUTE NODE NORMALS
C
      AVGTHK = 0.0
      DO 160 I = 1,NNODE
      IO = IORDER(I)
      IF (GPTH(I) .EQ. 0.0) GPTH(I) = ELTH
      IF (GPTH(I) .GT. 0.0) GO TO 150
      WRITE (NOUT,1700) UFM,ELID,SIL(I)
      GO TO 1430
  150 AVGTHK = AVGTHK + GPTH(I)/NNODE
      GPTH2(IO) = GPTH(I)
  160 CONTINUE
C
      MOMINR = 0.0
      TSFACT = 5.0/6.0
      NOCSUB = .FALSE.
      IF (NEST(15) .NE.  0) MOMINR = EST(16)
      IF (NEST(17) .NE.  0) TS = EST(18)
      IF ( EST(18) .EQ. .0) TS = 5.0/6.0
      PHIOUT(21) = AVGTHK
      PHIOUT(22) = MOMINR
C
C     SET LOGICAL NOCSUB IF EITHER MOMINR OR TS ARE NOT DEFAULT
C     VALUES. THIS WILL BE USED TO OVERRIDE ALL CSUBB COMPUTATIONS.
C     I.E. DEFAULT VALUES OF UNITY ARE USED.
C
      EPSI = ABS(MOMINR - 1.0)
      EPST = ABS(TS  - TSFACT)
      EPS  = .05
C     NOCSUB = EPSI.GT.EPS .OR. EPST.GT.EPS
C
C     PUT THE AVERAGE THICKNESS IN RELOUT
C
      RELOUT(2) = AVGTHK
C
C     THE COORDINATES OF THE ELEMENT GRID POINTS HAVE TO BE
C     TRANSFORMED FROM THE BASIC C.S. TO THE ELEMENT C.S.
C
      CALL BETRNS (TEU,GGE,0,ELID)
      CALL GMMATS (TEU,3,3,0, TUB,3,3,0, TEB)
      CALL GMMATS (TUB,3,3,1, CENT,3,1,0, CENTE)
C
      DO 170 I = 1,3
      II = I + 1
      IP = (I-1)*3
      DO 170 J = 1,NNODE
      EPNORM(II,J) = 0.0
      EGPDT (II,J) = 0.0
      DO 170 K = 1,3
      KK = IP + K
      K1 = K + 1
      CC = BGPDT(K1,J) - GGU(K) - CENTE(K)
      EPNORM(II,J) = EPNORM(II,J) + TEB(KK)*GPNORM(K1,J)
  170 EGPDT (II,J) = EGPDT (II,J) + TEB(KK)*CC
C
C     INITIALIZE MATERIAL VARIABLES
C
C     SET INFLAG = 12 SO THAT SUBROUTINE MAT WILL SEARCH FOR-
C     ISOTROPIC MATERIAL PROPERTIES AMONG THE MAT1 CARDS,
C     ORTHOTROPIC MATERIAL PROPERTIES AMONG THE MAT8 CARDS, AND
C     ANISOTROPIC MATERIAL PROPERTIES AMONG THE MAT2 CARDS.
C
      INFLAG = 12
      RHO    = 0.0
      ELTEMP =  EST(45)
      MID(1) = NEST(13)
      MID(2) = NEST(15)
      MID(3) = NEST(17)
      MID(4) = NEST(22)
      MEMBRN = MID(1).GT.0
      BENDNG = MID(2).GT.0 .AND. MOMINR.GT.0.0
      SHRFLX = MID(3).GT.0
      MBCOUP = MID(4).GT.0
C
C     CHECK FOR COMPOSITE MATERIAL
C
      NPHI(79) = 0
      DO 180 IMG = 1,4
      IF (MID(IMG) .GT. HUNMEG) GO TO 190
  180 CONTINUE
      GO TO 200
  190 NPHI(79) = MID(IMG) - IMG*HUNMEG
  200 CONTINUE
C
C     DETERMINE FACTORS TO BE USED IN CSUBB CALCULATIONS
C
      IF (.NOT.BENDNG) GO TO 250
      DO 220 I = 1,4
      DO 210 J = 1,NNODE
      JO = IORDER(J)
      IF (I .NE. JO) GO TO 210
      XA(I) = EGPDT(2,J)
      YB(I) = EGPDT(3,J)
      ZC(I) = EGPDT(4,J)
      VNT(1,I) = EPNORM(2,J)
      VNT(2,I) = EPNORM(3,J)
      VNT(3,I) = EPNORM(4,J)
  210 CONTINUE
  220 CONTINUE
C
      A = 0.5*(XA(2) + XA(3) - XA(1) - XA(4))
      B = 0.5*(YB(4) + YB(3) - YB(1) - YB(2))
      IF (A .GT. B) ASPECT = B/A
      IF (A .LE. B) ASPECT = A/B
C
C     IRREGULAR 4-NODE CODE-  GEOMETRIC VARIABLES
C
C     CALCULATE AND NORMALIZE- UNIT EDGE VECTORS,UNIT NORMAL VECTORS
C
      DO 230 I = 1,4
      J = I + 1
      IF (J .EQ. 5) J = 1
      UEV(1,I) = XA(J) - XA(I)
      UEV(2,I) = YB(J) - YB(I)
      UEV(3,I) = ZC(J) - ZC(I)
      UNV(1,I) = (VNT(1,J)+VNT(1,I))*0.50
      UNV(2,I) = (VNT(2,J)+VNT(2,I))*0.50
      UNV(3,I) = (VNT(3,J)+VNT(3,I))*0.50
      CC       = UEV(1,I)**2 + UEV(2,I)**2 + UEV(3,I)**2
      IF (CC .GE. 1.0E-8) CC = SQRT(CC)
      EDGEL(I) = CC
      UEV(1,I) = UEV(1,I)/CC
      UEV(2,I) = UEV(2,I)/CC
      UEV(3,I) = UEV(3,I)/CC
      CC       = SQRT(UNV(1,I)**2 + UNV(2,I)**2 + UNV(3,I)**2)
      UNV(1,I) = UNV(1,I)/CC
      UNV(2,I) = UNV(2,I)/CC
      UNV(3,I) = UNV(3,I)/CC
  230 CONTINUE
C
C     CALCULATE INTERNAL NODAL ANGLES
C
      DO 240 I = 1,4
      J = I - 1
      IF (J .EQ. 0) J = 4
      ANGLEI(I) =-UEV(1,I)*UEV(1,J)-UEV(2,I)*UEV(2,J)-UEV(3,I)*UEV(3,J)
      IF (ABS(ANGLEI(I)) .LT. 1.0E-8) ANGLEI(I) = 0.0
  240 CONTINUE
  250 CONTINUE
C
C     SET THE INTEGRATION POINTS
C
      PTINT(1) = -CONST
      PTINT(2) =  CONST
C
      IF (ITHERM .NE. 0) GO TO 1500
C
C     IN PLANE SHEAR REDUCTION
C
      XI  = 0.0
      ETA = 0.0
      KPT = 1
C
      CALL Q4SHPS (XI,ETA,SHP,DSHP)
C
C     SORT THE SHAPE FUNCTIONS AND THEIR DERIVATIVES INTO SIL ORDER.
C
      DO 260 I = 1,4
      TMPSHP(I  ) = SHP (I  )
      DSHPTP(I  ) = DSHP(I  )
  260 DSHPTP(I+4) = DSHP(I+4)
      DO 270 I = 1,4
      KK = IORDER(I)
      SHP( I  ) = TMPSHP(KK  )
      DSHP(I  ) = DSHPTP(KK  )
  270 DSHP(I+4) = DSHPTP(KK+4)
C
      DO 280 IZTA = 1,2
      ZETA = PTINT(IZTA)
C
C     COMPUTE THE JACOBIAN AT THIS GAUSS POINT,
C     ITS INVERSE AND ITS DETERMINANT.
C
      HZTA = ZETA/2.0
C
      CALL JACOBS (ELID,SHP,DSHP,GPTH,EGPDT,EPNORM,JACOB)
      IF (BADJAC) GO TO 1430
C
C     COMPUTE PSI TRANSPOSE X JACOBIAN INVERSE.
C     HERE IS THE PLACE WHERE THE INVERSE JACOBIAN IS FLAGED TO BE
C     TRANSPOSED BECAUSE OF OPPOSITE MATRIX LOADING CONVENTION BETWEEN
C     INVER AND GMMAT.
C
      CALL GMMATS (PSITRN,3,3,0, JACOB,3,3,1, PHI)
C
C     CALL Q4BMGS TO GET B MATRIX
C     SET THE ROW FLAG TO 2. IT WILL SAVE THE 3RD ROW OF B-MATRIX AT
C     THE TWO INTEGRATION POINTS.
C
      ROWFLG = 2
      CALL Q4BMGS (DSHP,GPTH,EGPDT,EPNORM,PHI,XYBMAT(KPT))
      KPT = KPT + ND2
  280 CONTINUE
C
C     FETCH MATERIAL PROPERTIES
C
C     SET THE ARRAY OF LENGTH 4 TO BE USED IN CALLING TRANSS.
C     NOTE THAT THE FIRST WORD IS THE COORDINATE SYSTEM ID WHICH
C     WILL BE SET IN POSITION LATER.
C
  290 DO 300 IEC = 2,4
  300 ECPT(IEC) = 0.0
C
C
C     EACH MATERIAL PROPERTY MATRIX G HAS TO BE TRANSFORMED FROM
C     THE MATERIAL COORDINATE SYSTEM TO THE ELEMENT COORDINATE
C     SYSTEM. THESE STEPS ARE TO BE FOLLOWED-
C
C     1- IF MCSID HAS BEEN SPECIFIED, SUBROUTINE TRANSS IS CALLED
C        TO CALCULATE TBM-MATRIX (MATERIAL TO BASIC TRANSFORMATION).
C        THIS WILL BE FOLLOWED BY A CALL TO SUBROUTINE BETRNS
C        TO CALCULATE TEB-MATRIX (BASIC TO ELEMENT TRANSFORMATION).
C        TBM-MATRIX IS THEN PREMULTIPLIED BY TEB-MATRIX TO OBTAIN
C        TEM-MATRIX. THEN STEP 3 WILL BE TAKEN.
C
C     2- IF THETAM HAS BEEN SPECIFIED, SUBROUTINE ANGTRS IS CALLED
C        TO CALCULATE TEM-MATRIX (MATERIAL TO ELEMENT TRANSFORMATION).
C
C                          T
C     3-           G   =  U   G   U
C                   E          M
C
C
      FLAGM = NEST(11)
      IF (FLAGM .EQ. 0) GO TO 360
      MCSID = NEST(10)
C
C     CALCULATE TUM-MATRIX USING MCSID
C
  310 IF (MCSID .GT. 0) GO TO 330
      DO 320 I = 1,9
  320 TEM(I) = TEB(I)
      GO TO 340
  330 NECPT(1) = MCSID
      CALL TRANSS (ECPT,TBM)
C
C     MULTIPLY TEB AND TBM MATRICES
C
      CALL GMMATS (TEB,3,3,0, TBM,3,3,0, TEM)
C
C     CALCULATE THETAM FROM THE PROJECTION OF THE X-AXIS OF THE
C     MATERIAL C.S. ON TO THE XY PLANE OF THE ELEMENT C.S.
C
  340 CONTINUE
      XM = TEM(1)
      YM = TEM(4)
      IF (ABS(XM).GT.EPS1 .OR. ABS(YM).GT.EPS1) GO TO 350
      NEST(2) = MCSID
      J = 231
      GO TO 1440
  350 THETAM = ATAN2(YM,XM)
      GO TO 370
C
C     CALCULATE TEM-MATRIX USING THETAM
C
  360 THETAM = EST(10)*DEGRAD
      IF (THETAM .EQ. 0.0) GO TO 380
  370 CALL ANGTRS (THETAM,1,TUM)
      CALL GMMATS (TEU,3,3,0, TUM,3,3,0, TEM)
      GO TO 400
C
C     DEFAULT IS CHOSEN, LOOK FOR VALUES OF MCSID AND/OR THETAM
C     ON THE PSHELL CARD.
C
  380 FLAGM = NEST(24)
      IF (FLAGM .EQ. 0) GO TO 390
      MCSID = NEST(23)
      GO TO 310
C
  390 THETAM = EST(23)*DEGRAD
      GO TO 370
C
  400 CONTINUE
C
C     STORE TUM IN PHIOUT
C
      DO 410 IEM = 1,9
  410 PHIOUT(68+IEM) = TUM(IEM)
C
      IF (ITHERM .NE. 0) GO TO 1600
C
C     BEGIN THE LOOP TO FETCH PROPERTIES FOR EACH MATERIAL ID
C
      DO 420 LL = 1,36
  420 GI(LL) = 0.0
C
      M    = 0
      IT0  = 0
      IGOBK= 0
  430 M    = M + 1
      IF (M .GT. 4) GO TO 680
      IF (M.EQ.4 .AND. IGOBK.EQ.1) GO TO 690
      MATID = MID(M)
      IF (MATID.EQ.0 .AND. M.NE.3) GO TO 430
      IF (MATID.EQ.0 .AND. M.EQ.3 .AND. .NOT.BENDNG) GO TO 430
      IF (MATID.EQ.0 .AND. M.EQ.3 .AND. BENDNG) MATID = MID(2)
C
      IF (M-1) 460,450,440
  440 IF (MATID.EQ.MID(M-1) .AND. IGOBK.EQ.0) GO TO 460
  450 CALL MAT (ELID)
  460 CONTINUE
C
      IF (IT0 .GT. 0) GO TO 470
      TSUB0 = RMTOUT(11)
      IF (MATSET .EQ. 8.0) TSUB0 = RMTOUT(10)
      PHIOUT(18) = TSUB0
      IT0 = 1
  470 CONTINUE
C
      COEFF = 1.0
C     IF (M .EQ. 2) COEFF = MOMINR
      IF (M .EQ. 3) COEFF = TS
      LPOINT = (M-1)*9 + 1
C
      CALL Q4GMGS (M,COEFF,GI(LPOINT))
C
CWKBDB 11/93 SPR93020
C      IF (M .GT. 0) GO TO 490
C      IF (.NOT.SHRFLX .AND. BENDNG) GO TO 480
C      NEST(2) = MATID
C      J = 231
C      GO TO 1440
C
C  480 M = -M
C  490 CONTINUE
C      MTYPE = IFIX(MATSET+.05) - 2
C      IF (NOCSUB) GO TO 580
C      GO TO (580,500,540,580), M
CC
C  500 IF (MTYPE) 510,520,530
C  510 ENORX = RMTOUT(16)
C      ENORY = RMTOUT(16)
C      GO TO 580
C  520 ENORX = RMTOUT(1)
C      ENORY = RMTOUT(4)
C      GO TO 580
C  530 ENORX = RMTOUT(1)
C      ENORY = RMTOUT(3)
C      GO TO 580
C
C  540 IF (MTYPE) 550,560,570
C  550 GNORX = RMTOUT(6)
C      GNORY = RMTOUT(6)
C      GO TO 580
C  560 GNORX = RMTOUT(1)
C      GNORY = RMTOUT(4)
C      GO TO 580
C  570 GNORX = RMTOUT(6)
C      GNORY = RMTOUT(5)
C      IF (GNORX .EQ. 0.0) GNORX = RMTOUT(4)
C      IF (GNORY .EQ. 0.0) GNORY = RMTOUT(4)
C  580 CONTINUE
CWKBDE 11/93 SPR93020
CWKBNB 11/93 SPR93020
      IF (M .GT. 0) GO TO 490
      IF (.NOT.SHRFLX .AND. BENDNG) GO TO 480
      NEST(2) = MATID
      J = 231
      GO TO 1440
  480 M = -M
  490 CONTINUE
      MTYPE = IFIX(MATSET+.05) - 2
      IF (NOCSUB) GO TO 580
      GO TO (580,500,540,580), M
CWKBNE 11/93 SPR93020
CWKBNB 2/94 SPR93020
  500 IF ( MTYPE ) 510, 520, 530
  510 ENORX = RMTOUT(16)
      ENORY = RMTOUT(16)
      DNUX  = GI( LPOINT+1 ) / GI( LPOINT )
      DNUY  = GI( LPOINT+3 ) / GI( LPOINT+4 )
      GO TO 580
  520 ENORX = RMTOUT(1)
      ENORY = RMTOUT(4)
      DNUX  = GI( LPOINT+1 ) / GI( LPOINT )
      DNUY  = GI( LPOINT+3 ) / GI( LPOINT+4 )
      GO TO 580
  530 ENORX = RMTOUT(1)
      ENORY = RMTOUT(3)
      DNUX  = GI( LPOINT+1 ) / GI( LPOINT )
      DNUY  = GI( LPOINT+3 ) / GI( LPOINT+4 )
      GO TO 580
  540 IF ( MTYPE ) 550, 560, 570
  550 GNORX = RMTOUT(6)
      GNORY = RMTOUT(6)
      GO TO 580
  560 GNORX = RMTOUT(1)
      GNORY = RMTOUT(4)
      GO TO 580
  570 GNORX = RMTOUT(6)
      GNORY = RMTOUT(5)
      IF ( GNORX .EQ. 0.0D0 ) GNORX = RMTOUT(4)
      IF ( GNORY .EQ. 0.0D0 ) GNORY = RMTOUT(4)
  580 CONTINUE
CWKBNE 2/94 SPR93020
      IF (MATSET .EQ. 1.0) GO TO 610
      IF (M      .EQ.   3) GO TO 590
      U(1) = TEM(1)*TEM(1)
      U(2) = TEM(2)*TEM(2)
      U(3) = TEM(1)*TEM(2)
      U(4) = TEM(4)*TEM(4)
      U(5) = TEM(5)*TEM(5)
      U(6) = TEM(4)*TEM(5)
      U(7) = TEM(1)*TEM(4)*2.0
      U(8) = TEM(2)*TEM(5)*2.0
      U(9) = TEM(1)*TEM(5) + TEM(2)*TEM(4)
      L    = 3
      GO TO 600
C
  590 U(1) = TEM(5)*TEM(9) + TEM(6)*TEM(8)
      U(2) = TEM(4)*TEM(9) + TEM(6)*TEM(7)
      U(3) = TEM(2)*TEM(9) + TEM(3)*TEM(8)
      U(4) = TEM(1)*TEM(9) + TEM(3)*TEM(7)
      L    = 2
C
  600 CALL GMMATS (U(1),L,L,1, GI(LPOINT),L,L,0, GT(1))
      CALL GMMATS (GT(1),L,L,0, U(1),L,L,0, GI(LPOINT))
C
C     TRANSFORM THERMAL EXPANSION COEFF'S AND STORE THEM IN PHIOUT
C
  610 CONTINUE
      IF (M      .GT. 2 ) GO TO 430
      IF (MATSET .EQ. 2.) GO TO 620
      IF (MATSET .EQ. 8.) GO TO 640
C
C     MAT1
C
      ALFA(1) = RMTOUT(8)
      ALFA(2) = RMTOUT(8)
      ALFA(3) = 0.0
      GO TO 650
C
C     MAT2
C
  620 DO 630 IMAT = 1,3
  630 ALFA(IMAT) = RMTOUT(7+IMAT)
      GO TO 650
C
C     MAT8
C
  640 ALFA(1) = RMTOUT(8)
      ALFA(2) = RMTOUT(9)
      ALFA(3) = 0.0
C
  650 MPOINT = (M-1)*3 + 59
      IF (MATSET .EQ. 1.0) GO TO 660
      CALL INVERS (3,U,3,BDUM,0,DETU,ISNGU,INDEX)
      CALL GMMATS (U,3,3,0, ALFA,3,1,0, PHIOUT(MPOINT))
      GO TO 430
  660 DO 670 IALF = 1,3
      MP = MPOINT - 1 + IALF
  670 PHIOUT(MP) = ALFA(IALF)
      GO TO 430
  680 CONTINUE
      IF (MID(3) .LT. HUNMEG) GO TO 690
      IF (GI(19).NE.0. .OR. GI(20).NE.0. .OR. GI(21).NE.0. .OR.
     1    GI(22).NE.0.) GO TO 690
      IGOBK = 1
      M = 2
      MID(3) = MID(2)
      GO TO 430
  690 CONTINUE
C
      NOCSUB = ENORX.EQ.0.0 .OR. ENORY.EQ.0.0 .OR.
     1         GNORX.EQ.0.0 .OR. GNORY.EQ.0.0 .OR.
     2        MOMINR.EQ.0.0
C
C
C     FILL IN THE BASIC 6X6 MATERIAL PROPERTY MATRIX G
C
      DO 700 IG = 1,6
      DO 700 JG = 1,6
  700 G(IG,JG) = 0.0
C
      IF (.NOT.MEMBRN) GO TO 720
      DO 710 IG = 1,3
      IG1 = (IG-1)*3
      DO 710 JG = 1,3
      JG1 = JG + IG1
      G(IG,JG) = GI(JG1)
  710 CONTINUE
C
  720 IF (.NOT.BENDNG) GO TO 750
      DO 730 IG = 4,6
      IG2 = (IG-2)*3
      DO 730 JG = 4,6
      JG2 = JG + IG2
      G(IG,JG) = GI(JG2)
  730 CONTINUE
C
      IF (.NOT.MEMBRN) GO TO 750
      DO 740 IG = 1,3
      KG  = IG + 3
      IG1 = (IG-1)*3
      DO 740 JG = 1,3
      LG  = JG + 3
      JG1 = JG + IG1
      G(IG,LG) = GI(JG1)
      G(KG,JG) = GI(JG1)
  740 CONTINUE
C
C     STORE 6X6 GBAR-MATRIX IN PHIOUT
C
  750 IG1 = 22
      DO 760 IG = 1,6
      DO 760 JG = 1,6
      IG1 = IG1 + 1
  760 PHIOUT(IG1) = G(IG,JG)
C
C
C     STRESS TRANSFORMATIONS
C     ----------------------
C
C     THE NECESSARY TRANSFORMATIONS ARE PERFORMED IN THE FOLLOWING
C     MANNER-
C
C     1- ALL THE TRANSFORMATIONS ARE CALCULATED IN PHASE I AND THEN
C        TRANSFERED THRU DATA BLOCK 'PHIOUT' TO PHASE II WHERE THE
C        ACTUAL MULTIPLICATIONS ARE PERFORMED.
C
C     2- THE STRAIN RECOVERY MATRIX B
C        IS EVALUATED IN THE ELEMENT COORDINATE SYSTEM IN PHASE I
C        AND TRANSFERED TO PHASE II. THE DISPLACEMENTS, HOWEVER,
C        ENTER PHASE II IN GLOBAL COORDINATES. THEREFORE,
C        2A) 3X3 TRANSFORMATIONS FROM GLOBAL TO ELEMENT COORDINATE
C            SYSTEM (TEG) FOR EACH GRID POINT ARE CALCULATED AND
C            STORED IN  PHIOUT (80 - (79+9*NNODE)).
C            USING THESE TRANSFORMATIONS THE DISPLACEMENTS AT
C            EACH GRID POINT WILL BE EVALUATED IN THE ELEMENT
C            COORDINATE SYSTEM AFTER ENTERING PHASE II.
C
C        2B) A 3X3 TRANSFORMATION FROM THE TANGENT TO THE USER-
C            DEFINED STRESS COORDINATE SYSTEM (TSI) IS CALCULATED
C            FOR EACH INTEGRATION POINT AND STORED ALONG WITH OTHER
C            DATA FOR THAT INTEGRATION POINT AT POSITIONS 2-10 OF
C            THE REPEATED DATA FOR EACH EVALUATION POINT.
C            IT WILL BE USED TO TRANSFORM THE STRESS OUTPUT TO
C            ANY DESIRED COORDINATE SYSTEM.
C            NOTE THAT THESE CALCULATIONS WILL BE PERFORMED INSIDE
C            THE DOUBLE LOOP.
C
C     CALCULATIONS FOR TEG-MATRIX
C
C     CALCULATE  TBG-MATRIX (GLOBAL TO BASIC), THEN
C     MULTIPLY  TEB AND TBG MATRICES  TO GET  TEG-MATRIX
C     FOR THIS GRID POINT AND STORE IT IN PHIOUT.
C
      DO 820 I = 1,NNODE
      IP = 80 + (I-1)*9
      IF (IGPDT(1,I) .LE. 0) GO TO 800
      CALL TRANSS (IGPDT(1,I),TBG)
      CALL GMMATS (TEB,3,3,0, TBG,3,3,0, PHIOUT(IP))
      GO TO 820
C
  800 DO 810 J = 1,9
  810 PHIOUT(IP+J-1) = TEB(J)
  820 CONTINUE
C
C     INITIALIZE THE ARRAYS USED IN THE DOUBLE LOOP CALCULATION.
C     EVALUATION OF STRESSES IS DONE AT 2X2 POINTS AND AT THE
C     CENTER OF THE ELEMENT, AT THE MID-SURFACE.
C
      IF (BENDNG) GO TO 840
      J = ND3 + 1
      DO 830 IBMX = J,ND8
  830 BMATRX(IBMX) = 0.0
  840 CONTINUE
C
      ICOUNT = -(8*NDOF+NNODE+32) + 79 + 9*NNODE
C
      PTINTP(1) =-CONST
      PTINTP(2) = CONST
      PTINTP(3) = 0.0
C
C
C     HERE BEGINS THE TRIPLE LOOP ON STATEMENTS 835 AND 840
C     -----------------------------------------------------
C
      DO 1420 IXSI = 1,3
      XI = PTINTP(IXSI)
C
      DO 1420 IETA = 1,3
      ETA = PTINTP(IETA)
      IF (IXSI.EQ.3 .AND. IETA.NE.3) GO TO 1420
      IF (IXSI.NE.3 .AND. IETA.EQ.3) GO TO 1420
C
      CALL Q4SHPS (XI,ETA,SHP,DSHP)
C
C     SORT THE SHAPE FUNCTIONS AND THEIR DERIVATIVES INTO SIL ORDER.
C
      DO 900 I = 1,4
      TMPSHP(I  ) = SHP (I  )
      DSHPTP(I  ) = DSHP(I  )
  900 DSHPTP(I+4) = DSHP(I+4)
      DO 910 I = 1,4
      KK = IORDER(I)
      SHP (I  ) = TMPSHP(KK  )
      DSHP(I  ) = DSHPTP(KK  )
  910 DSHP(I+4) = DSHPTP(KK+4)
C
      TH = 0.0
      DO 920 ITH = 1,NNODE
  920 TH = TH + SHP(ITH)*GPTH(ITH)
      REALI = MOMINR*TH*TH*TH/12.0
      TSI = TS*TH
C
      IF (NOCSUB) GO TO 970
      IF (.NOT.BENDNG) GO TO 970
C      NUNORX = MOMINR*ENORX/(2.0*GNORX) - 1.0
C      NUNORY = MOMINR*ENORY/(2.0*GNORY) - 1.0
CWKBNB 2/94 SPR93020
      NUNORX = MOMINR*ENORX/(2.0*GNORX) - 1.0
      NUNORY = MOMINR*ENORY/(2.0*GNORY) - 1.0
      IF ( NUNORX .LT. 0. ) NUNORX = DNUX
      IF ( NUNORY .LT. 0. ) NUNORY = DNUY
CWKBNE 2/94 SPR93020
CWKBDB 2/94 SPR93020
C      EIX = MOMINR*ENORX
C      EIY = MOMINR*ENORY
C      TGX = 2.0*GNORX
C      TGY = 2.0*GNORY
C      NUNORX = EIX/TGX - 1.0
C      IF (EIX .GT. TGX) NUNORX = 1.0 - TGX/EIX
C      NUNORY = EIY/TGY - 1.0
C      IF (EIY .GT. TGY) NUNORY = 1.0 - TGY/EIY
C      IF (NUNORX .GT. 0.999999) NUNORX = 0.999999
C      IF (NUNORY .GT. 0.999999) NUNORY = 0.999999
CWKBDE 2/94 SPR93020
C     IF (NUNORX .GT. .49) NUNORX = 0.49
C     IF (NUNORY .GT. .49) NUNORY = 0.49
      CC = ASPECT
      AX = A
      IF (ETA .LT. 0.0) AX = A + CONST*(XA(2)-XA(1)-A)
      IF (ETA .GT. 0.0) AX = A + CONST*(XA(3)-XA(4)-A)
      PSIINX = 32.0*REALI/((1.0-NUNORX)*TSI*AX*AX)
      BY = B
      IF (XI .LT. 0.0) BY = B + CONST*(YB(4)-YB(1)-B)
      IF (XI .GT. 0.0) BY = B + CONST*(YB(3)-YB(2)-B)
      PSIINY = 32.0*REALI/((1.0-NUNORY)*TSI*BY*BY)
      IF (.NOT.SHRFLX) GO TO 930
      TSMFX = PSIINX
      TSMFY = PSIINY
      IF (TSMFX .GT. 1.0) TSMFX = 1.0
      IF (TSMFY .GT. 1.0) TSMFY = 1.0
      GO TO 980
  930 IF (PSIINX .GE. 1.0) GO TO 940
      TSMFX = PSIINX/(1.0-PSIINX)
      IF (TSMFX .LE. 1.0) GO TO 950
  940 TSMFX = 1.0
  950 IF (PSIINY .GE. 1.0) GO TO 960
      TSMFY = PSIINY/(1.0-PSIINY)
      IF (TSMFY .LE. 1.0) GO TO 980
  960 TSMFY = 1.0
      GO TO 980
C
  970 TSMFX = 1.0
      TSMFY = 1.0
  980 CONTINUE
C
C     IRREGULAR 4-NODE CODE-  CALCULATION OF NODAL EDGE SHEARS
C                             AT THIS INTEGRATION POINT
C
C
      DO 1050 IJ = 1,4
      II = IJ - 1
      IF (II .EQ. 0) II = 4
      IK = IJ + 1
      IF (IK .EQ. 5) IK = 1
C
      DO 1000 IR = 1,4
      IF (IJ .NE. IORDER(IR)) GO TO 1000
      IOJ = IR
      GO TO 1010
 1000 CONTINUE
 1010 DO 1020 IR = 1,4
      IF (IK .NE. IORDER(IR)) GO TO 1020
      IOK = IR
      GO TO 1030
 1020 CONTINUE
 1030 AA = SHP(IOJ)
      BB = SHP(IOK)
C
      DO 1040 IS = 1,3
      EDGSHR(IS,IJ) = (UEV(IS,IJ)+ANGLEI(IJ)*UEV(IS,II))*AA/
     1                (1.0-ANGLEI(IJ)*ANGLEI(IJ))
     2              + (UEV(IS,IJ)+ANGLEI(IK)*UEV(IS,IK))*BB/
     3                (1.0-ANGLEI(IK)*ANGLEI(IK))
 1040 CONTINUE
 1050 CONTINUE
C
      DO 1410 IZTA = 1,2
      ZETA = PTINT(IZTA)
      HZTA = ZETA/2.0
      IBOT = (IZTA-1)*ND2
C
C     SET THE PHIOUT POINTER
C
      ICOUNT = ICOUNT + 32 + NNODE + 8*NDOF
C
      PHIOUT(ICOUNT+1) = TH
C
C     STORE SHAPE FUNCTION VALUES IN PHIOUT
C
      DO 1060 I = 1,NNODE
      PHIOUT(ICOUNT+32+I) = SHP(I)
 1060 CONTINUE
C
C     STORE THE CORRECTION TO GBAR-MATRIX IN PHIOUT
C
      IG1 = ICOUNT + 10
      IG4 = 28
      DO 1070 IG = 1,9
      IG1 = IG1 + 1
      PHIOUT(IG1) = -GI(IG4)*ZETA*6.0
 1070 IG4 = IG4 + 1
C
C     STORE G3-MATRIX IN PHIOUT
C
      IPH = ICOUNT + 28
      PHIOUT(IPH+1) = TSMFY*GI(19)
      PHIOUT(IPH+2) = SQRT(TSMFX*TSMFY)*GI(20)
      PHIOUT(IPH+3) = SQRT(TSMFX*TSMFY)*GI(21)
      PHIOUT(IPH+4) = TSMFX*GI(22)
C
C     COMPUTE THE JACOBIAN AT THIS GAUSS POINT,
C     ITS INVERSE AND ITS DETERMINANT.
C
      CALL JACOBS (ELID,SHP,DSHP,GPTH,EGPDT,EPNORM,JACOB)
      IF (BADJAC) GO TO 1430
C
C     COMPUTE PSI TRANSPOSE X JACOBIAN INVERSE.
C     HERE IS THE PLACE WHERE THE INVERSE JACOBIAN IS FLAGED TO BE
C     TRANSPOSED BECAUSE OF OPPOSITE MATRIX LOADING CONVENTION BETWEEN
C     INVER AND GMMAT.
C
      CALL GMMATS (PSITRN,3,3,0, JACOB,3,3,1, PHI)
C
      CALL GMMATS (TEM,3,3,1, PSITRN,3,3,1, TMI)
C
C     STORE TMI-MATRIX IN PHIOUT
C
      IPH = ICOUNT + 20
      DO 1080 I = 1,9
      PHIOUT(IPH) = TMI(I)
 1080 IPH = IPH + 1
C
C     ARRAY ECPT(4) WHICH IS USED IN TRANSS CONSISTS OF THE C.S. ID
C     AND THE COORDINATES (IN BASIC C.S.) OF THE POINT FROM (OR TO)
C     WHICH THE TRANSFORMATION IS BEING PERFORMED. THE COORDINATES
C     ARE NOT USED IF THE DESIGNATED COORDINATE SYSTEM IS RECTANGULAR.
C
      DO 1100 I = 1,3
      GPC(I) = 0.0
      II = I + 1
      DO 1090 J = 1,NNODE
 1090 GPC(I) = GPC(I) + SHP(J)*(BGPDT(II,J) + HZTA*GPTH(J)*GPNORM(II,J))
 1100 ECPT(II) = GPC(I)
C
C     CALCULATIONS FOR TSE-MATRIX
C
      FLAGS = NEST(27)
      IF (FLAGS .EQ. 0) GO TO 1300
C
C     FLAGS IS 1, I.E. SCSID HAS BEEN SPECIFIED.
C     CALCULATE TBS-MATRIX (STRESS TO BASIC)
C
      SCSID = NEST(26)
      IF (SCSID .LE. 0) GO TO 1200
      NECPT(1) = SCSID
      CALL TRANSS (ECPT,TBS)
      GO TO 1220
 1200 DO 1210 I = 1,3
      II = (I-1)*3
      DO 1210 J = 1,3
      JJ = (J-1)*3
 1210 TSU(II+J) = TUB(I+JJ)
      GO TO 1230
C
C     MULTIPLY
C               T         T
C            TBS  AND  TUB  TO GET TSU-MATRIX (USER TO STRESS)
C
 1220 CALL GMMATS (TBS,3,3,1, TUB,3,3,1, TSU)
C
C     CALCULATE THETAS FROM THE PROJECTION OF THE X-AXIS OF THE
C     STRESS C.S. ON TO THE XY PLANE OF THE ELEMENT C.S.
C
 1230 CONTINUE
      XS = TSU(1)
      YS = TSU(2)
      IF (ABS(XS).GT.EPS1 .OR. ABS(YS).GT.EPS1) GO TO 1240
      NEST(2) = SCSID
      J = 233
      GO TO 1440
 1240 THETAS = ATAN2(YS,XS)
      GO TO 1310
C
C     FLAGS IS 0, I.E. THETAS HAS BEEN SPECIFIED.
C     SUBROUTINE ANGTRS RETURNS THE 3X3 TRANSFORMATION USING THETAS.
C     NOTE THAT IF THETAS IS LEFT BLANK (DEFAULT), THE TRANSFORMATION
C     WILL BE IDENTITY,  I.E. THE STRESSES WILL BE OUTPUT IN THE
C     ELEMENT COORDINATE SYSTEM.
C     IF Q4STRS IS SET EQUAL TO 1, STRESSES WILL BE OUTPUT IN THE E C.S.
C     WHICH COOINCIDES WITH MSC'S  VERSION OF ELEMENT COORDINATE SYSTEM.
C
 1300 THETAS = EST(26)*DEGRAD
 1310 IF (Q4STRS .EQ. 1) GO TO 1320
      CALL ANGTRS (THETAS,0,TSU)
      CALL GMMATS (TSU,3,3,0, TEU,3,3,1, TSE)
      GO TO 1330
 1320 CALL ANGTRS (THETAS,0,TSE)
C                                   T
C     CALCULATE  TSI  = TSE X PSITRN  AND STORE IT IN PHIOUT
C
 1330 CALL GMMATS (TSE,3,3,0, PSITRN,3,3,1, PHIOUT(ICOUNT+2))
C
C     FOR CORNER POINTS (THE STRESS EVALUATION POINTS EXCEPT FOR THE
C     ONES AT THE CENTER), CALCULATE TSB-MATRIX AND STORE IT IN IELOUT.
C
      IF (IXSI+IETA .GT. 4) GO TO 1340
      IP  = (IXSI-1)*2 + IETA
      IP1 = IPN(IP)
      IP2 = (IP1-1)*25 + 4 + (IZTA-1)*9
      CALL GMMATS (TSE,3,3,0, TEB,3,3,0, RELOUT(IP2))
 1340 CONTINUE
C
C     CALL Q4BMGS TO GET B MATRIX
C     SET THE ROW FLAG TO 3 TO CREATE THE FIRST 6 ROWS. THEN SET IT
C     TO 1 FOR THE LAST 2 ROWS.
C
      ROWFLG = 3
      CALL Q4BMGS (DSHP,GPTH,EGPDT,EPNORM,PHI,BMATRX(1))
      DO 1350 IX = 1,NDOF
 1350 BMATRX(IX+ND2) = XYBMAT(IBOT+IX)
C
      IF (.NOT.BENDNG) GO TO 1370
      ROWFLG = 1
      CALL Q4BMGS (DSHP,GPTH,EGPDT,EPNORM,PHI,BMATRX(1+ND6))
      DO 1360 IX = 1,NDOF
 1360 BMATRX(IX+ND5) = XYBMAT(IBOT+IX+NDOF)
 1370 CONTINUE
C
C
C     HERE WE SHIP OUT THE STRAIN RECOVERY MATRIX.
C     --------------------------------------------
C
      KCOUNT = ICOUNT + 32 + NNODE
      DO 1400 IPH = 1,ND8
 1400 PHIOUT(KCOUNT+IPH) = BMATRX(IPH)
 1410 CONTINUE
 1420 CONTINUE
      RETURN
C
 1430 NOGO = 1
      RETURN
C
 1440 CALL MESAGE (30,J,NAME)
      GO TO 1430
C
C     BEGINNING OF HEAT RECOVERY.
C
 1500 CONTINUE
      MATID    = NEST(13)
      INFLAG   = 2
      NPHI(22) = 2
      NPHI(23) = NNODE
      NPHI(24) = NAME(1)
      NPHI(25) = NAME(2)
      XI  = 0.0
      ETA = 0.0
      CALL Q4SHPS (XI,ETA,SHP,DSHP)
C
C     SORT THE SHAPE FUNCTIONS AND THEIR DERIVATIVES INTO SIL ORDER.
C
      DO 1510 I = 1,4
      TMPSHP(I  ) = SHP (I  )
      DSHPTP(I  ) = DSHP(I  )
 1510 DSHPTP(I+4) = DSHP(I+4)
      DO 1520 I = 1,4
      KK = IORDER(I)
      SHP (I  ) = TMPSHP(KK  )
      DSHP(I  ) = DSHPTP(KK  )
 1520 DSHP(I+4) = DSHPTP(KK+4)
C
      HZTA = 0.0
      CALL JACOBS (ELID,SHP,DSHP,GPTH,EGPDT,EPNORM,JACOBE)
      IF (BADJAC) GO TO 1430
C
      DO 1530 I = 2,4
      ECPT(I) = 0.0
      DO 1530 J = 1,NNODE
 1530 ECPT(I) = ECPT(I) + SHP(J)*BGPDT(I,J)
C
      FLAGS = NEST(27)
      IF (FLAGS .EQ. 0) GO TO 1580
      SCSID = NEST(26)
      IF (SCSID .LE. 0) GO TO 1540
      NECPT(1) = SCSID
      CALL TRANSS (ECPT,TBS)
      CALL GMMATS (TBS,3,3,1, TUB,3,3,1, TSU)
      GO TO 1560
 1540 DO 1550 I = 1,3
      II = (I-1)*3
      DO 1550 J = 1,3
      JJ = (J-1)*3
 1550 TSU(II+J) = TUB(I+JJ)
 1560 CONTINUE
      XS = TSU(1)
      YS = TSU(2)
      IF (ABS(XS).GT.EPS1 .OR. ABS(YS).GT.EPS1) GO TO 1570
      NEST(2) = SCSID
      J = 233
      GO TO 1440
 1570 THETAS = ATAN2(YS,XS)
      GO TO 1590
 1580 THETAS = EST(26)*DEGRAD
 1590 CALL ANGTRS (THETAS,0,TSU)
      SINMAT = 0.0
      COSMAT = 1.0
      CALL HMAT (ELID)
      PHIOUT(26) = KHEAT(1)
      PHIOUT(27) = KHEAT(2)
      PHIOUT(28) = KHEAT(2)
      PHIOUT(29) = KHEAT(3)
C
C     BRANCH IF THERMAL CONDUCTIVITY KHEAT IS ISOTROPIC.
C     OTHERWISE, FIND TBM, TBS AND TMS AND COMPUTE THE KHEAT
C     TENSOR IN 2-DIMENSIONAL STRESS COORDINATE SYSTEM.
C
C     COMMENTS FROM G.CHAN/UNISYS     10/88
C     HMAT ROUTINE DOES NOT RETURN 'TYPE' IN COSMIC NASTRAN
C     SO WE CAN ONLY ASSUME THERMAL CONDUCTIVITY IS ISOTROPIC AND
C     BRANCH TO 1610 UNCONDITIOANLLY BY SETTING TYPE =-1
C
                                                TYPE =-1
C
      IF (TYPE.EQ.4 .OR. TYPE.EQ.-1) GO TO 1610
      GO TO 290
 1600 CONTINUE
      CALL GMMATS (TUM,3,3,1, TSU,3,3,1, TMS)
      TMS(3) = TMS(4)
      TMS(4) = TMS(5)
      CALL GMMATS (TMS,2,2,1, PHIOUT(26),2,2,0, TUM)
      CALL GMMATS (TUM,2,2,0, TMS,2,2,0, PHIOUT(26))
 1610 CONTINUE
      CALL GMMATS (TEU,3,3,1, JACOBE,3,3,0, JACOBU)
      CALL GMMATS (TSU,3,3,0, JACOBU,3,3,0, JACBS)
      DO 1620 J = 1,NNODE
      DQ(J) = DSHP(J)
      JN = J + NNODE
      DQ(JN) = DSHP(J+4)
      JN = JN + NNODE
 1620 DQ(JN) = 0.0
      CALL GMMATS (JACBS,3,3,0, DQ,3,NNODE,0, PHIOUT(35))
      RETURN
C
 1700 FORMAT (A23,', QUAD4 ELEMENT HAS UNDEFINED THICKNESS.  ELEMENT',
     1       ' ID =',I8,', SIL ID =',I8)
 1710 FORMAT (A23,', MODULE SDR2 DETECTS BAD OR REVERSE GEOMETRY FOR ',
     1       'ELEMENT ID =',I8)
      END

      SUBROUTINE OLPLOT
C
C     DRIVER FOR USER SUPPLIED INTERACTIVE PLOTTER
C
C     NOTE - ALL FORTRAN STOPS MUST BE CHANGED TO RETURNS
C     OTHERWISE THE FORTRAN STOPS WILL KILL THE INTERACTIVE SESSION.
C
      INTEGER PLT2
      COMMON /SYSTEM/ IBUF,NOUT
      DATA PLT2/13/
C
      WRITE (NOUT,10)
   10 FORMAT ('    USER MUST SUPPLY SITE DEPENDENT PLOTTING PACKAGE',
     1       /4X, 'IN SUBROUTINE OLPLOT FOR INTERACTIVE PLOTS')
C
C
      REWIND PLT2
C     CALL THE SITE DEPENDENT PLOTTING ROUTINES HERE.
C     CALL NASPLOT
      RETURN
      END

      SUBROUTINE TIGER (IG,LIST,INV,II3,NORIG,KG,JG)
C
C     THIS ROUTINE MAKES ADDITIONS TO THE CONNECTION TABLE IG TO REFLECT
C     THE PRESENCE OF MPC'S AND STORES THE DEPENDENT POINTS IN LIST.
C     THIS ROUTINE IS USED ONLY IN BANDIT MODULE
C
C     NEQ =NUMBER OF MPC EQUATIONS.
C     NEQR=NUMBER OF MPC EQUATIONS COMING FROM RIGID ELEMENTS
C
      INTEGER          SCR1,     BUNPK,    RDREW,    RD,       REW
      DIMENSION        IG(1),    LIST(1),  NORIG(1), KG(1),    SUB(2),
     1                 JG(1),    INV(II3,1)
      COMMON /BANDA /  IBUF1,    NOMPC,    NODEP
      COMMON /BANDB /  DUM6B(6), KDIM
      COMMON /BANDD /  DUM(7),   NEQ,      NEQR
      COMMON /BANDS /  NN,       MM,       DUM2S(2), MAXGRD,   MAXDEG,
     1                 DUM3S(3), NEDGE
      COMMON /GEOMX /  GDUM(3),  SCR1
      COMMON /SYSTEM/  IBUF,     NOUT
      COMMON /NAMES /  RD,       RDREW,    NDUM(2),  REW
      COMMON /ZZZZZZ/  IZ(1)
      DATA             SUB /     4HTIGE, 4HR   /
C
      IF (NEQ+NEQR .EQ. 0) GO TO 170
      KDIM4=KDIM*4
      CALL OPEN (*200,SCR1,IZ(IBUF1),RDREW)
C
C     GENERATE NEW CONNECTIONS.
C     TWO PASSES.   FIRST PASS FOR MPC CARDS, AND SECOND FOR RIGID ELEM.
C
      DO 60 JJ=1,2
      IF (JJ .EQ. 1) NQ=NEQ
      IF (JJ .EQ. 2) NQ=NEQR
      IF (NQ .EQ. 0) GO TO 60
C
C     READ MPC EQUATIONS AND RIGID ELEMENT GRIDS
C     AND CONVERT ORIGINAL GRID NOS. TO INTERNAL LABELS.
C
      DO 50 II=1,NQ
      CALL READ (*210,*210,SCR1,NTERM,1,0,M)
      KK=1
      J2=2
      IF (JJ .EQ. 1) GO TO 10
      K=MOD(NTERM,1000)
      NTERM=NTERM/1000
      KK=NTERM-K
      J2=NTERM
   10 IF (NTERM.GT.KDIM4) GO TO 70
      CALL READ (*210,*210,SCR1,KG,NTERM,1,M)
      CALL SCAT (KG,NTERM,INV,II3,NORIG)
C
      DO 40 K=1,KK
      IGRID=KG(K)
      IF (NODEP.EQ.+1) LIST(IGRID)=IGRID
C
C     IGRID=DEPENDENT GRID POINT IN AN MPC EQUATION.
C
      CALL BUNPAK(IG,IGRID,MAXDEG,JG)
      DO 30 I=1,MAXDEG
      L=JG(I)
      IF (L.LE.0) GO TO 40
C
C     L= A GRID POINT THAT IGRID IS CONNECTED TO BEFORE THE MPC IS APPLI
C
      IF (NTERM.LT.2) GO TO 30
      DO 20 J=J2,NTERM
      CALL SETIG (L,KG(J),IG,NORIG)
   20 CONTINUE
   30 CONTINUE
   40 CONTINUE
   50 CONTINUE
   60 CONTINUE
      GO TO 90
C
   70 WRITE (NOUT,80)
   80 FORMAT (72H0*** MPC CARDS NOT PROCESSED IN BANDIT DUE TO INSUFFICI
     1ENT SCRATCH SPACE,//)
      NEQ =0
      NEQR=0
   90 CALL CLOSE (SCR1,REW)
C
C     QUIT HERE IF MPC DEPENDENT POINTS ARE NOT TO BE DELETED FROM THE
C     CONNECTION TABLE IG.
C
      IF (NODEP.NE.+1) GO TO 170
C
C     COMPRESS OUT ZEROS FORM LIST
C
      N=0
      DO 110 I=1,NN
      IF (LIST(I).EQ.0) GO TO 110
      N=N+1
      LIST(N)=LIST(I)
  110 CONTINUE
C
C     DELETES ALL REFERENCE IN THE CONNECTION TABLE IG TO THOSE POINTS
C     IN LIST
C
      IF (N.LE.0) GO TO 170
      MM1=MM-1
      DO 160 II=1,N
      I=LIST(II)
      CALL BUNPAK (IG,I,MM,JG)
      DO 150 J=1,MM
      L=JG(J)
      IF (L.EQ.0) GO TO 160
      NEDGE=NEDGE-1
      K=0
  120 K=K+1
      M=BUNPK(IG,L,K)
      IF (M.NE. I) GO TO 120
      IF (K.GE.MM) GO TO 140
      DO 130 NP=K,MM1
      IS=BUNPK(IG,L,NP+1)
  130 CALL BPACK (IG,L,NP,IS)
  140 CALL BPACK (IG,L,MM1+1,0)
      CALL BPACK (IG,I,J,0)
  150 CONTINUE
  160 CONTINUE
  170 RETURN
C
C     SCR1 FILE ERROR
C
  200 K=-1
      GO TO 220
  210 K=-2
  220 CALL MESAGE (K,SCR1,SUB)
      RETURN
      END

        SUBROUTINE DSZBKK ( BLOCK, A )
        INTEGER BLOCK(15), A(4)
      INCLUDE 'DSIOF.COM'
      INCLUDE 'XNSTRN.COM'
        ITYPIN = BLOCK( 13 )
        NWORDS = NWRDEL( ITYPIN )
        IF ( BLOCK( 2 ) .GE. 3 ) GO TO 5
        INCCNT = 1
        GO TO 8
5       INCCNT = 2
8       CONTINUE
        DO 10 K = 1, NWORDS
        IF ( A( K ) .NE. 0 ) GO TO 20
10      CONTINUE
        GO TO 7000
20      IF ( BLOCK( 4 ) .EQ. 0 ) GO TO 35
        NEXROW = BLOCK( 4 ) + BLOCK( 7 )
        ICROW  = BLOCK( 15 )
        IF ( ICROW .GE. NEXROW ) GO TO 30
        CALL DSMSG1( BLOCK )
        CALL DSMSG( 119 )
30      IF ( ICROW .EQ. NEXROW ) GO TO 40
        CALL ENDPUT( BLOCK )
        CALL PUTSTR( BLOCK )
        BLOCK( 7 ) = 0
35      ICROW = BLOCK( 15 )
        BLOCK( 4 ) = ICROW
40      INDEX  = ( BLOCK( 5 ) - 1  ) * BLOCK( 14 ) + 1
        CALL DSUPKC ( ITYPIN, BLOCK( 2 ), A, IBASE( INDEX ) )
        BLOCK( 5 ) = BLOCK( 5 ) + INCCNT
        BLOCK( 7 ) = BLOCK( 7 ) + 1
        BLOCK(10 ) = BLOCK(10 ) + BLOCK( 11 )
        IF ( BLOCK( 6 ) .GT. BLOCK( 7 ) ) GO TO 7000
        CALL ENDPUT( BLOCK )
        CALL PUTSTR( BLOCK )
        BLOCK( 4 ) = 0
        BLOCK( 7 ) = 0
7000    RETURN
        END

      SUBROUTINE SMCOMP (*,ZI,ZR,ZD)
C      
C DRIVER PROGRAM FOR SYMMETRIC DECOMPOSITION.  SUBROUTINE SMCPH1 READS
C THE INPUT MATRIX AND STORES THE DATA EITHER IN MEMORY OR ON THE
C SPILL FILE.  SUBROUTINE SMCPH2 IS THEN CALLED TO PERFORM THE
C MATRIX DECOMPOSITION.
C
      REAL              ZR(4)
      INTEGER           ZI(4)
      INTEGER           MODULE(5), BEGN, END
      DOUBLE PRECISION  ZD(4)
      INCLUDE          'SMCOMX.COM'
C  mcb   - matrix control block for input matrix
C  lll   - matrix control block for lower triangular matrix
C  dbc   - dbc(1) = available scratch file, dbc(2-7) are not used
C  scr1, scr2, scr3 - three available scratch files
C  lcore - amount of open core available for use
C  ddr   - d.p. values of (real, imaginary) for scaled value of determinant
C  power - scale factor to apply to determinant, determinant=det * 10**power
C  mindd - d.p. value for minimum value of diagonal elements
C  chlsky - cholesky option when =1, i.e., form c matrix
C     
      DATA  MODULE / 4HSMCO, 4HMP  , 3*4H    /
      DATA  BEGN   / 4HBEGN /
      DATA  END    / 4HEND  /
      IERROR = 0 
      NCOL   = MCB(2)
      MODULE( 3 ) = BEGN
      STURM  = 0
      CALL CONMSG ( MODULE, 5, 0 )
      CALL SMCPH1 ( ZI, ZR, ZD )
      IF ( IERROR .EQ. 1 ) GO TO 701
      IF ( IERROR .NE. 0 ) GO TO 700
      CALL SMCPH2 ( ZI, ZR, ZD )
      IF ( IERROR .EQ. 1 ) GO TO 701
C
C print roots information if this is an eigenvalue problem, and keep
C two largest shift point data if several shift point movings are involved.
C      
      IF ( SHFTPT .GT. 0. ) WRITE ( NOUT, 901 ) STURM, SHFTPT
901   FORMAT( 20X, I5, ' ROOTS BELOW ', 1P,E14.6 )
      IF ( STURM .NE. 0 ) GO TO 100
      IF ( KEEP  .LE. 0 ) GO TO 700
      STURM  = KEEP
      SHFTPT = PTSHFT
      GO TO 700
100   IF ( KEEP .GT. STURM ) GO TO 700
      JJ     = KEEP
      RS     = PTSHFT
      KEEP   = STURM
      PTSHFT = JJ
      SHFTPT = RS
700   MODULE( 3 ) = END
      CALL CONMSG ( MODULE, 5, 0 )
      IF ( IERROR .NE. 0 ) RETURN 1
      GO TO 777
701   CONTINUE
      MODULE( 3 ) = END
      CALL CONMSG ( MODULE, 5, 0 )
777   CONTINUE
      RETURN
      END

      SUBROUTINE ASCM02 (NAME,IPHASE,ISOL,NOGO)
C
C     RUN COMMAND DATA
C
      INTEGER        COMND(6,2),SUBNAM(2),RDMAP(18,6),PTBS(7,1)
      COMMON /ASDBD/ IRDM,NRDM,IXTRA,NXTRA,IOCT,NOCT,IPTBS,NPTBS,
     1               IPH,NPH,IDAT(117)
      DATA    COMND/
     1               4HRUN     ,  1    ,  0    ,  0    ,  1    ,  0  ,
     2               4HENDD    ,  6    ,  0    ,  0    ,  0    ,  0  /
      DATA    RDMAP/
     1 4HPARA,4HM   ,4H  //,4H*ADD,4H*/DR,4HY/-1,4H /0 ,4H$   ,4H    ,
     * 4H    , 8*4H    ,
     2 4HLABE,4HL   ,4H  LB,4HSEND,4H $  ,13*4H    ,
     3 4HPARA,4HM   ,4H  //,4H*ADD,4H*/DR,4HY/DR,4HY/1 ,4H$   ,4H    ,
     * 4H    , 8*4H    ,
     4 4HCOND,4H    ,4H  FI,4HNIS,,4HDRY ,4H$   ,12*4H    ,
     5 4HREPT,4H    ,4H  LB,4HSBEG,4H,1 $,13*4H    ,
     6 4HJUMP,4H    ,4H  FI,4HNIS ,4H$   ,13*4H           /
      DATA    PTBS /
     1               1,  22, 23, 3,  4HRUN ,  0,  0       /
C
      DATA   SUBNAM/ 4HASCM,2H02  /
C
C     VALIDATE COMMAND AND SET POINTERS
C
      DO 10 I = 1, 2
      IF (NAME .EQ. COMND(1,I)) GO TO 20
   10 CONTINUE
      GO TO 70
   20 ICOMND = I
      IRDM   = 1
      NRDM   = COMND(2,ICOMND)
      IXTRA  = IRDM  + 18*NRDM
      NXTRA  = COMND(3,ICOMND)
      IOCT   = IXTRA + NXTRA
      NOCT   = COMND(4,ICOMND)
      IPTBS  = IOCT  + 3*NOCT
      NPTBS  = COMND(5,ICOMND)
      IPH    = IPTBS + 7*NPTBS
      NPH    = COMND(6,ICOMND)
C
C     MOVE RDMAP DATA
C
      K = 0
      IF (NRDM .EQ. 0) GO TO 40
      DO 30 J = 1,NRDM
      DO 30 I = 1,18
      K = K + 1
   30 IDAT(K) = RDMAP(I,J)
   40 CONTINUE
C
C     MOVE PTBS DATA
C
      IF (NPTBS .EQ. 0) GO TO 60
      DO 50 J = 1,NPTBS
      DO 50 I = 1,7
      K = K + 1
   50 IDAT(K) = PTBS(I,J)
   60 CONTINUE
C
      RETURN
C
C     INPUT ERROR
C
   70 CALL MESAGE (7,0,SUBNAM)
      NOGO = 1
      RETURN
C
      END

        SUBROUTINE DSUPKC ( ITIN, ITOUT, A, B )
        COMMON / SYSTEM / ISYSBF, IWR
        REAL               A(4), B(4), AA(4), BB(4)
        INTEGER           NWORDS(4)
        REAL              RS1, RS2
        DOUBLE PRECISION  RD1, RD2, RDI1, RDI2
        EQUIVALENCE       (AA,RS1,RD1), (BB,RS2,RD2)
        EQUIVALENCE       ( AA(3), RDI1 ), ( BB(3), RDI2 )
        DATA              NWORDS / 1,2,2,4/
        IWRD1   = NWORDS( ITIN )
        IF ( ITIN .NE. ITOUT ) GO TO 20
CDIR$ NEXTSCALAR
        DO 10 K = 1, IWRD1
        B( K )  = A( K )
10      CONTINUE
        GO TO 7777
20      IF ( ITOUT .GT. 64 ) GO TO 30
        ITOUT2 = ITOUT
        IWRD2  = NWORDS( ITOUT )
        SSIGN  = 1.0
        GO TO 40
30      ITOUT2 = ITOUT - 64
        IWRD2  = NWORDS( ITOUT2 )
        SSIGN  = -1.0
CDIR$ NEXTSCALAR
40      DO 50 K = 1, IWRD1
        AA( K ) = A( K )
50      CONTINUE
        GO TO ( 1000, 2000, 3000, 4000 ), ITIN
1000    GO TO ( 1100, 1200, 1300, 1400 ), ITOUT2
1100    RS2 = SSIGN * RS1
        GO TO 7000
1200    RD2 = SSIGN * RS1
        GO TO 7000
1300    BB( 1 ) = SSIGN * RS1
        BB( 2 ) = 0.
        GO TO 7000
1400    RD2 = SSIGN * RS1
        RDI2 = 0.
        GO TO 7000
2000    GO TO ( 2100, 2200, 2300, 2400 ), ITOUT2
2100    RS2 = SSIGN * RD1
        GO TO 7000
2200    RD2 = SSIGN * RD1
        GO TO 7000
2300    BB( 1 ) = SSIGN * RD1
        BB( 2 ) = 0.
        GO TO 7000
2400    RD2 = SSIGN * RD1
        RDI2 = 0.
        GO TO 7000
3000    GO TO ( 3100, 3200, 3300, 3400 ), ITOUT2
3100    RS2 = SSIGN * AA( 1 )
        GO TO 7000
3200    RD2 = SSIGN * AA( 1 )
        GO TO 7000
3300    BB( 1 ) = SSIGN * AA( 1 )
        BB( 2 ) = SSIGN * AA( 2 )
        GO TO 7000
3400    RD2 = SSIGN * AA( 1 )
        RDI2 = SSIGN * AA( 2 )
        GO TO 7000
4000    GO TO ( 4100, 4200, 4300, 4400 ), ITOUT2
4100    RS2 = SSIGN * RD1
        GO TO 7000
4200    RD2 = SSIGN * RD1
        GO TO 7000
4300    BB( 1 ) = SSIGN * RD1
        BB( 2 ) = SSIGN * RDI1
        GO TO 7000
4400    RD2 = SSIGN * RD1
        RDI2 = SSIGN * RDI1
        GO TO 7000
CDIR$ NEXTSCALAR
7000    DO 7200 K = 1, IWRD2
        B( K ) = BB( K )
7200    CONTINUE
7777    RETURN
        END

      SUBROUTINE XRGDEV
C
C     PURPOSE - XRGDEV PROCESSES A FIELD FROM A ****CARD, ****FILE,
C               ****SBST, OR A ****RFMT CARD FROM THE RIGID FORMAT
C               DATA BASE
C
C     AUTHOR  - RPK CORPORATION; DECEMBER, 1983
C
C     INPUT
C      /SYSTEM/
C       NOUT    UNIT NUMBER FOR OUTPUT PRINT FILE
C      /XRGDXX/
C       ICOL    COLUMN CONTAINING THE FIRST CHARACTER OF THE FIELD
C       LIMIT   2 WORD ARRAY CONTAINING THE LOWER/UPPER LIMITS FOR
C               VALUES GIVEN IN THE FIELD
C       NUMBER  INTEGER VALUE FOR A ALPHA NUMBER WITHIN THE FIELD
C       RECORD  ARRAY IN 20A4 FORMAT CONTAINING THE CARD IMAGE
C
C     OUTPUT
C      /XRGDXX/
C       IERROR  ERROR FLAG IS NON-ZERO IF AN ERROR OCCURRED
C       NUM     2 WORD ARRAY CONTAINING THE VALUE(S) WITHIN THE CURRENT
C               FIELD
C
C     LOCAL VARIABLES
C       IND     INDEX TO THE ARRAY NUM
C       ISTATE  NEXT STATE (ROW = IN THE ABOVE DATA STATEMENT) TO BE
C               USED FOR SYNTAX VALIDATION BASED ON THE TYPE OF THE NEXT
C               CHARACTER IN THE FIELD
C       ISTR    COLUMN CONTAINING THE FIRST CHARACTER WITHIN THE FIEL
C       K       DO LOOP INDEX FOR SCANING CHARACTERS WITHIN THE FIELD
C       STATE   TABLE USED TO VALIDATE THE SYNTAX OF THE FIELD.  THE
C               NUMBER IN EACH ENTRY INDICATES THE ROW TO BE USED FOR
C               VALIDATING THE SYNTAX OF THE NEXT CHARACTER.  IF THE
C               VALUE IS 0 THEN A SYNTAX ERROR OCCURRED.
C
C     FUNCTIONS
C     XRGDEV SCANS THE FIELD FOR SYNTAX ERRORS AND FOR PLACING THE NUMBE
C     INTO THE NUM ARRAY.  VALID FIELDS ARE OF THE FORM 'NNN,' OR
C     'NNN-NNN,' WITH EMBEDDED BLANKS ALLOWED AND NUMBERS MAY BE OF
C     ANY VALUE THAT IS WITHIN THE LIMITS OF THE ARRAY LIMIT.
C
C     SUBROUTINES CALLED - XRGDTP
C
C     CALLING SUBROUTINES - XRGSUB,XRGDCF
C
C     ERRORS
C       ERROR MESSAGES 8021 AND 8022 ARE GIVEN FOR SYNTAX OR VALUE RANGE
C       ERRORS.
C
      INTEGER         RECORD, STATE(5,7)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /XRGDXX/ IRESTR, NSUBST, IPHASE, ICOL  , NUMBER, ITYPE ,
     1                ISTATE, IERROR, NUM(2), IND   , NUMENT        ,
     2                RECORD(20)    , ICHAR(80)     , LIMIT(2)      ,
     3                ICOUNT, IDMAP , ISCR  , NAME(2),MEMBER(2)     ,
     4                IGNORE
      COMMON /SYSTEM/ ISYSBF, NOUT  , DUM(98)
C                   NUMBER  ,      -    BLANK    OTHER
      DATA    STATE / 1,   2,      3,      6,      0,
     2                1,   0,      0,      2,      0,
     3                4,   0,      0,      3,      0,
     4                4,   2,      0,      5,      0,
     5                0,   2,      0,      5,      0,
     6                0,   2,      3,      6,      0,
     7                1,   0,      0,      7,      0 /
C
      IF (ICOL .GT. 80) GO TO 110
      ISTATE = 7
      IND    = 1
      NUM(1) = 0
      ISTR   = ICOL
      DO 50 K = ISTR,80
      ICOL = K
      CALL XRGDTP
      ISTATE = STATE(ITYPE,ISTATE)
      IF (ISTATE .NE. 0) GO TO 20
      IERROR = 1
      J = 0
      WRITE  (NOUT,10) UFM,K,RECORD,J,(I,I=1,8),IERROR,(J,I=1,8)
 10   FORMAT (A23,' 8020, SYNTAX ERROR NEAR COLUMN ',I3,
     2       ' IN THE FOLLOWING CARD- ',/20X,20A4, /,(20X,I1,I9,7I10))
      GO TO 110
 20   GO TO (30,60,40,30,50,50,50), ISTATE
 30   NUM(IND) = NUM(IND)*10 + NUMBER
      GO TO 50
 40   IND    = 2
      NUM(2) = 0
 50   CONTINUE
 60   IF (IND .EQ. 2) GO TO 70
      NUM(2) = NUM(1)
      GO TO 90
 70   IF (NUM(2) .GT. NUM(1)) GO TO 90
      IERROR = 1
      WRITE  (NOUT,80) UFM,NUM(1),NUM(2),RECORD
 80   FORMAT (A23,' 8021, NON-INCREASING RANGE ',I3,1H-,I3,
     1       ' IN THE FOLLOWING CARD -', /20X,20A4)
 90   CONTINUE
      IF (NUM(1).GE.LIMIT(1) .AND. NUM(2).LE.LIMIT(2)) GO TO 110
      WRITE  (NOUT,100) UFM,LIMIT,RECORD
 100  FORMAT (A23,' 8022, NUMBERS ARE OUT OF THE RANGE ',I3,1H-,I3,
     1       ' IN THE FOLLOWING CARD - ', /20X,20A4)
      IERROR = 1
 110  CONTINUE
      RETURN
      END

      SUBROUTINE MRED2J (NUF,N2)
C
C     THIS SUBROUTINE PARTITIONS THE PHISS MATRIX FOR THE MRED2 MODULE.
C
      INTEGER         DRY,GBUF1,OTFILE,TYPIN,TYPOUT,PHISS,RPRTN,
     1                ITRLR1(7),MODNAM(2)
      COMMON /BLANK / IDUM1,DRY,IDUM4,GBUF1,IDUM2(5),INFILE(12),
     1                OTFILE(6),ISCR(10),KORLEN,KORBGN,IDUM3(14),NMODES
      COMMON /ZZZZZZ/ RZ(1)
      COMMON /PACKX / TYPIN,TYPOUT,IROW,NROW,INCR
      EQUIVALENCE     (PHISS,INFILE(3)),(PHISS1,ISCR(8)),
     1                (PHISS2,ISCR(9)) ,(RPRTN,ISCR(10))
      DATA    MODNAM/ 4HMRED,4H2J  /
C
C     SET UP PARTITIONING VECTOR
C
      IF (DRY .EQ. -2) RETURN
      TYPIN  = 1
      TYPOUT = 1
      IROW   = 1
      INCR   = 1
C
C     COMMENTS FROM G.CHAN/UNISYS    4/92
C     ORIGINALLY AT THIS POINT, THE FOLLOWING DO 20 LOOP IS IN ERROR
C       1. KOLUMN AND J ARE NOT DEFINED
C       2. NROW AND ITRLR1 ARE ALSO NOT YET DEFINED
C
C     MY BEST GUESS IS THE NEXT 10 LINES THAT FOLLOW
C
      IFILE = PHISS
      ITRLR1(1) = PHISS
      CALL RDTRL (ITRLR1)
      IF (ITRLR1(1) .LT. 0) GO TO 30
      KOLUMN = ITRLR1(2)
      NROW   = ITRLR1(3)
      DO 20 I = 1,KOLUMN
      RZ(KORBGN+I-1) = 0.0
      IF (I .GT. NUF) RZ(KORBGN+I-1) = 1.0
   20 CONTINUE
C
      IFORM = 7
      CALL MAKMCB (ITRLR1,RPRTN,NROW,IFORM,ITRLR1(5))
      CALL GOPEN  (RPRTN,RZ(GBUF1),1)
      CALL PACK   (RZ(KORBGN),RPRTN,ITRLR1)
      CALL CLOSE  (RPRTN,1)
      CALL WRTTRL (ITRLR1)
C
C     PARTITION PHISS MATRIX
C
C        **     **   **               **
C        *       *   *        .        *
C        * PHISS * = * PHISS1 . PHISS2 *
C        *       *   *        .        *
C        **     **   **               **
C
      ITRLR1(1) = PHISS
      CALL RDTRL (ITRLR1)
      N2 = NMODES - NUF
      CALL GMPRTN (PHISS,PHISS1,0,PHISS2,0,RPRTN,0,NUF,N2,RZ(KORBGN),
     1             KORLEN)
      RETURN
C
C     PROCESS SYSTEM FATAL ERRORS
C
   30 IMSG = -1
      CALL SOFCLS
      CALL MESAGE (IMSG,IFILE,MODNAM)
      RETURN
      END

      SUBROUTINE SCALAR
C
C     CONVERTS MATRIX ELEMENT TO PARAMETER
C
C     SCALAR   MTX//C,N,ROW/C,N,COL/V,N,RSP/V,N,RDP/V,N,SPLX/V,N,DPLX $
C
C     INPUT GINO FILE
C       MTX = ANY MATRIX, S.P. OR D.P.; REAL OR COMPLEX
C     OUTPUT GINO FILE
C       NONE
C     INPUT PARAMETERS
C       ROW, COL = ROW AND COLUMN OF MTX (DEFAULT ARE 1,1)
C     OUTPUT PARAMETERS
C       RSP  = VALUE OF MTX(ROW,COL), REAL SINGLE PRECISION
C       RDP  = VALUE OF MTX(ROW,COL), REAL DOUBLE PRECISION
C       SPLX = VALUE OF MTX(ROW,COL), S.P. COMPLEX
C       DPLX = VALUE OF MTX(ROW,COL), D.P. COMPLEX
C
C     ORIGINALY WRITTEN BY R. MITCHELL, GSFC, NOV. 1972
C
C     COMPLETELY REWRITTEN BY G.CHAN/UNISYS IN JUNE 1988, SUCH THAT THE
C     OUTPUT PARAMETERS ARE SAVED CORRECTLY ACCORDING TO THEIR PRECISION
C     TYPES. (THE PRTPARM MODULE WILL BE ABLE TO PRINT THEM OUT
C     CORRECTLY.) PLUS IMPROVED MESSAGES (WHICH CAN BE SUPPRESSED BY
C     DIAG 37)
C
      IMPLICIT INTEGER (A-Z)
      LOGICAL          NOPRT
      INTEGER          NAME(2),IA(7),FNM(2),PNM(2)
      REAL             RSP,SPLX,A,VPS(1),SP(4)
      DOUBLE PRECISION DA(2),RDP,DPLX(2),DP(2)
      CHARACTER        UFM*23,UWM*25,UIM*29,TYPE(4)*10
      COMMON /XMSSG /  UFM,UWM,UIM
      COMMON /XVPS  /  IVPS(1)
      COMMON /SYSTEM/  SYSBUF,NOUT
      COMMON /ZNTPKX/  A(4),II,EOL,EOR
      COMMON /ZZZZZZ/  CORE(1)
      COMMON /BLANK /  BK(1),ROW,COL,RSP,R2(2),SPLX(2),D4(4)
      EQUIVALENCE      (R2(1),RDP),(D4(1),DPLX(1)),(IA(2),NCOL),
     1                 (IA(3),NROW),(IA(4),FORM),(IA(5),PREC),
     2                 (DA(1),A(1)),(DP(1),SP(1)),(VPS(1),IVPS(1))
      DATA  IN1,NAME/  101, 4HSCAL,4HAR  / , FIRST / 12 /
      DATA  TYPE    /  'S.P. REAL ' ,    'D.P. REAL '   ,
     1                 'S.P. CMPLX' ,    'D.P. CMPLX'   /
C
C     SUPPRESS ALL SCALAR MESSAGES IF DIAG 37 IS ON
C
      CALL SSWTCH (37,I)
      NOPRT = I .EQ. 1
C
C     MOVE VARIALBES IN /BLANK/ BY ONE WORD TO GET BY WORD BOUNDARY
C     ALIGNMENT SITUATION
C
      J = 12
      DO 10 I = 1,11
      BK(J) = BK(J-1)
   10 J = J - 1
C
C     INITIALIZATION
C
      LCORE = KORSZ(CORE)
      IBUF  = LCORE - SYSBUF + 1
      IF (IBUF .LT. 1) GO TO 400
      RSP     = 0.
      SPLX(1) = 0.
      SPLX(2) = 0.
      RDP     = 0.D0
      DPLX(1) = 0.D0
      DPLX(2) = 0.D0
      DP(1)   = 0.D0
      DP(2)   = 0.D0
      CALL FNAME (IN1,FNM)
      CALL PAGE2 (FIRST)
      FIRST   = 3
C
C     GET STATUS OF INPUT MATRIX
C     CHECK FOR PURGED INPUT OR OUT OF RANGE INPUT PARAMETERS
C
      IA(1) = IN1
      CALL RDTRL (IA)
      IF (IA(1).LT.   0) GO TO 410
      IF (ROW .GT. NROW) GO TO 420
C
      GO TO (20,20,40,60,70,20,50,30), FORM
C     SQUARE, RECTANGULAR OR SYMMETRIC MATRIX
C
   20 IF (COL .GT. NCOL) GO TO 420
      GO TO 100
C
C     IDENTITY MATRIX
C
   30 IF (ROW .NE. COL) GO TO 200
      RSP = 1.0
      RDP = 1.D0
      SPLX(1) = 1.
      DPLX(1) = 1.D0
      GO TO 200
C
C     DIAGONAL MATRIX
C
   40 IF (ROW .NE.  COL) GO TO 200
      IF (COL .GT. NROW) GO TO 420
C     SET COL TO 1 FOR SPECIAL DIAGONAL FORMAT
      COL = 1
      GO TO 100
C
C     ROW VECTOR
C     SWITCH ROW AND COLUMN FOR PROPER INDEXING
C
   50 ROW = COL
      COL = 1
      GO TO 100
C
C     LOWER TRIANGULAR MATRIX (UPPER HALF= 0)
C
   60 IF (COL-ROW) 100,100,200
C
C     UPPER TRIANGULAR MATRIX (LOWER HALF= 0)
C
   70 IF (ROW-COL) 100,100,200
C
C     OPEN INPUT FILE AND SKIP HEADER RECORD AND UNINTERSTING COLUMNS
C
  100 CALL OPEN (*410,IN1,CORE(IBUF),0)
      CALL SKPREC (IN1,COL)
C
C     READ AND SEARCH COLUMN CONTAINING DESIRED ELEMENT.
C     RECALL THAT DEFAULT VALUE WAS SET TO ZERO
C
      CALL INTPK (*200,IN1,0,PREC,0)
C
C     FETCH ONE ELEMENT
C     CHECK FOR DESIRED ELEMENT
C     IF INDEX HIGHER, IT MEANS ELEMENT WAS 0.
C
  110 CALL ZNTPKI
      IF (II-ROW) 120,130,200
C
C     CHECK FOR LAST NON-ZERO ELEMENT IN COLUMN.
C
  120 IF (EOL) 110,110,200
C
C     MOVE VALUES TO OUTPUT PARAMETER AREA.
C     CHECK PRECISION OF INPUT VALUE.
C
  130 GO TO (140,150,170,180), PREC
C
  140 RSP = A(1)
      RDP = DBLE(RSP)
      GO TO 160
C
  150 RDP = DA(1)
      RSP = SNGL(RDP)
  160 SPLX(1) = RSP
      DPLX(1) = RDP
      GO TO 200
C
  170 SPLX(1) = A(1)
      SPLX(2) = A(2)
      DPLX(1) = DBLE(SPLX(1))
      DPLX(2) = DBLE(SPLX(2))
      GO TO 190
C
  180 DPLX(1) = DA(1)
      DPLX(2) = DA(2)
      SPLX(1) = SNGL(DPLX(1))
      SPLX(2) = SNGL(DPLX(2))
  190 RSP = 0.0
      RDP = 0.D0
C
C     MOVE VALUES TO OUTPUT PARAMETERS AS REQUESTED BY USER, AND
C     SAVE PARAMETERS
C
  200 IF (NOPRT) GO TO 215
      CALL PAGE2 (3)
      WRITE  (NOUT,210) UIM
  210 FORMAT (A29,' FROM SCALAR MODULE -', /5X,
     1        '(ALL SCALAR MESSAGES CAN BE SUPPRESSED BY DIAG 37)')
  215 CALL FNDPAR (-3,J)
      IF (J .LE. 0) GO TO 260
      PNM(1) = IVPS(J-3)
      PNM(2) = IVPS(J-2)
      IF (PREC .GE. 3) GO TO 240
      VPS(J) = RSP
      IF (NOPRT) GO TO 260
      WRITE (NOUT,220) RSP,PNM
  220 FORMAT (73X,E15.8,4H  = ,2A4)
      WRITE (NOUT,230) ROW,COL,TYPE(PREC),FNM
  230 FORMAT (1H+,4X,'ELEMENT (',I5,'-ROW,',I5,'-COL) OF ',A10,' INPUT',
     1       ' FILE ',2A4,2H =)
      GO TO 260
  240 WRITE  (NOUT,250) UWM,PNM
  250 FORMAT (A25,' - INVALID OUTPUT REQUEST.', /5X,'ORIG. ELEM. IN ',
     1       'COMPLEX FORM. OUTPUT PARAMETER ',2A4,' NOT SAVED)',/)
  260 CALL FNDPAR (-4,J)
      IF (J .LE. 0) GO TO 290
      PNM(1)   = IVPS(J-3)
      PNM(2)   = IVPS(J-2)
      IF (PREC .GE. 3) GO TO 280
      DP(1)    = RDP
      VPS(J  ) = SP(1)
      VPS(J+1) = SP(2)
      IF (NOPRT) GO TO 290
      WRITE (NOUT,270) RDP,PNM
  270 FORMAT (73X,D15.8,4H  = ,2A4)
      WRITE (NOUT,230) ROW,COL,TYPE(PREC),FNM
      GO TO 290
  280 WRITE (NOUT,250) UWM,PNM
  290 CALL FNDPAR (-5,J)
      IF (J .LE. 0) GO TO 310
      VPS(J  ) = SPLX(1)
      VPS(J+1) = SPLX(2)
      PNM(1)   = IVPS(J-3)
      PNM(2)   = IVPS(J-2)
      IF (NOPRT) GO TO 310
      WRITE (NOUT,300) SPLX,PNM
  300 FORMAT (73X,1H(,E15.8,1H,,E15.8,1H),4H  = ,2A4)
      WRITE (NOUT,230) ROW,COL,TYPE(PREC),FNM
  310 CALL FNDPAR (-6,J)
      IF (J .LE. 0) GO TO 330
      DP(1)    = DPLX(1)
      DP(2)    = DPLX(2)
      VPS(J  ) = SP(1)
      VPS(J+1) = SP(2)
      VPS(J+2) = SP(3)
      VPS(J+3) = SP(4)
      PNM(1)   = IVPS(J-3)
      PNM(2)   = IVPS(J-2)
      IF (NOPRT) GO TO 330
      WRITE (NOUT,320) DPLX,PNM
  320 FORMAT (73X,1H(,D15.8,1H,,D15.8,1H),4H  = ,2A4)
      WRITE (NOUT,230) ROW,COL,TYPE(PREC),FNM
C
C     CLOSE INPUT UNIT AND RETURN
C
  330 CALL CLOSE (IN1,1)
      RETURN
C
C     ERROR MESSAGES, SET THEM ALL TO NON-FATAL
C
C     NOT ENOUGH CORE FOR GINO BUFFER
C
  400 J = 8
      GO TO 430
C
C     INPUT FILE ERROR
C
  410 J = 1
      GO TO 430
C
C     INVALID ROW OR COLUMN NUMBER
C
  420 J = 7
C
  430 CALL MESAGE (J,IN1,NAME)
      RETURN
C
      END

      SUBROUTINE MFLUD4
C*****
C     THIS ROUTINE IS USED FOR THE 4-SIDED FLUID ELEMENT. IT REARRANGES
C      THE DATA AND  CALLS THE MFLUD3 ROUTINE FOR EACH SUBELEMENT.
C****
C     THE ECPT DATA FOR THE ELEMENT AND ITS SUBELEMENTS ARE
C
C        FIELD      SYMBOL(FLUID4)      SYMBOL(FLUID3)
C           1            ID                  ID
C           2            SIL1                SIL1
C           3            SIL2                SIL2
C           4            SIL3                SIL3
C           5            SIL4                RHO
C           6            RHO                 BULK
C           7            BULK                N
C           8            N                   CSF
C           9            CSF                 R1
C          10            R1                  Z1
C          11            Z1                  -
C          12            -                   CSF
C          13            CSF                 R2
C          14            R2                  Z2
C          15            Z2                  -
C          16            -                   CSF
C          17            CSF                 R3
C          18            R3                  Z3
C          19            Z3                  -
C          20            -
C          21            CSF
C          22            R4
C          23            Z4
C          24            -
C          25            -
C****
      INTEGER  NECPT(100)
      COMMON/SMA2IO/ DUM1(10),IFMGG
      COMMON /SMA2CL/    IOPT1,K1GGSW,NPVT
      COMMON /SMA2ET/    ECPT(100)
      EQUIVALENCE   (ECPT(1),NECPT(1))
      IF(ECPT(7) .EQ. 0.0) GO TO 120
      ECPT(7)=ECPT(7)*2.0
      DO 50 I=1,24
   50 ECPT(I+50) =ECPT(I)
      DO 60 I= 5,19
   60 ECPT(I)= ECPT(I+1)
      IRET =1
      GO TO 100
   70 ECPT(4) = ECPT(55)
      ECPT(17)= ECPT(72)
      ECPT(18)= ECPT(73)
      IRET =2
      GO TO 100
   80 ECPT(13)= ECPT(68)
      ECPT(14)= ECPT(69)
      ECPT(3)= ECPT(54)
      IRET=3
      GO TO 100
   90 ECPT(9) = ECPT(64)
      ECPT(10)= ECPT(65)
      ECPT(2)= ECPT(53)
      IRET=4
C*****
C
  100 IF((NECPT(2).NE.NPVT).AND.(NECPT(3).NE.NPVT).AND.
     1   (NECPT(4).NE.NPVT))  GO TO 110
C*****
      CALL MFLUD3
  110 GO TO (70,80,90,120),IRET
  120 RETURN
      END

      SUBROUTINE SOFCLS
C
C     WRITES OUT AT THE TERMINATION OF A MODULE ALL THE IN CORE BUFFERS
C     AND COMMON BLOCKS.
C
      LOGICAL         DITUP,MDIUP,NXTUP,OPNSOF,NXTRST
      INTEGER         BUF,A,B,FILNAM,FILSIZ,PSSWRD,DIT,DITPBN,DITLBN,
     1                MDI,MDIPBN,MDILBN
      COMMON /ZZZZZZ/ BUF(1)
      COMMON /SOF   / A(37)
      COMMON /SYS   / B(6)
      COMMON /ITEMDT/ NITEM,ITEM(7,1)
      COMMON /SYSTEM/ NBUFF
      COMMON /SOFCOM/ NFILES,FILNAM(10),FILSIZ(10),STATUS,PSSWRD(2),
     1                FIRST,OPNSOF
      EQUIVALENCE     (DIT   ,A(1) ),(DITPBN,A(2) ),(DITLBN,A(3) ),
     1                (MDI   ,A(15)),(MDIPBN,A(16)),(MDILBN,A(17)),
     2                (NXT   ,A(19)),(NXTPBN,A(20)),(NXTLBN,A(21)),
     3                (DITUP ,A(34)),(MDIUP ,A(35)),(NXTUP ,A(36)),
     4                (NXTRST,A(37))
      DATA    IWRT  / 2 /
C
      IF (.NOT.OPNSOF) RETURN
      IF (DITPBN .EQ. 0) GO TO 20
      IF (.NOT.DITUP) GO TO 20
      CALL SOFIO (IWRT,DITPBN,BUF(DIT-2))
      DITUP = .FALSE.
      GO TO 40
   20 IF (NXTPBN .EQ. 0) GO TO 40
      IF (.NOT.NXTUP) GO TO 40
      CALL SOFIO (IWRT,NXTPBN,BUF(NXT-2))
      NXTUP = .FALSE.
   40 IF (MDIPBN .EQ. 0) GO TO 60
      IF (.NOT.MDIUP) GO TO 60
      CALL SOFIO (IWRT,MDIPBN,BUF(MDI-2))
      MDIUP = .FALSE.
C
C     WRITE OUT COMMON BLOCKS.
C
   60 LAST = NBUFF - 4
      DO 62 I = 1,LAST
   62 BUF(DIT+I) = 0
      BUF(DIT+1) = PSSWRD(1)
      BUF(DIT+2) = PSSWRD(2)
      BUF(DIT+4) = NFILES
      DO 70 I = 1,NFILES
      BUF(DIT+ 4+I) = FILNAM(I)
      BUF(DIT+14+I) = FILSIZ(I)
      BUF(DIT+33+I) = A(22+I)
   70 CONTINUE
      DO 80 I = 1,4
      BUF(DIT+24+I) = B(I)
   80 CONTINUE
      BUF(DIT+29) = A(4)
      BUF(DIT+30) = A(5)
      BUF(DIT+31) = A(6)
      BUF(DIT+32) = A(18)
      BUF(DIT+33) = A(22)
      BUF(DIT+44) = A(33)
      NXTRST      = .FALSE.
      BUF(DIT+45) = A(37)
      BUF(DIT+46) = B(5)
      BUF(DIT+47) = B(6)
C
      BUF(DIT+100) = NITEM
      K = 100
      DO 92 I = 1,NITEM
      DO 90 J = 1,7
   90 BUF(DIT+K+J) = ITEM(J,I)
   92 K = K + 7
      IBL = 1
      DO 100 I = 1,NFILES
      BUF(DIT+3) = I
      CALL SOFIO (IWRT,IBL,BUF(DIT-2))
      IBL = IBL + FILSIZ(I)
  100 CONTINUE
      CALL SOFIO (7, 0, 0)
      OPNSOF = .FALSE.
      RETURN
      END

      SUBROUTINE FORM22 (UDDIP1, UDIPRM, UIPRM, PIPRM, IBUF)
C*******
C     FORM22 GENERATES THE VECTORS NECESSARY TO CHANGE THE TIME STEP
C
C     THIS ROUTINE IS SUITABLE FOR DOUBLE PRECISION OPERATION
C*******
      DOUBLE PRECISION UDDIP1(1), UDIPRM(1), UIPRM(1), PIPRM(1)
C
      DIMENSION IBUF(1)
C
      COMMON   /TRDXX /  IFILK(7)  ,IFILM(7) ,IFILB(7)
C*******
C     FORM UDOT(I+1), UDDOT(I+1), UDOT-(I), AND U-(I)
C*******
      CALL MATVC2(UDDIP1(1),PIPRM(1),IFILM(1),IBUF)
      CALL MATVC2(UDIPRM(1),PIPRM(1),IFILB(1),IBUF)
      CALL MATVC2(UIPRM(1),PIPRM(1),IFILK(1),IBUF)
      RETURN
      END

      SUBROUTINE MSGWRT
C
C     MSGWRT WILL PRINT THE INDICATED ERROR MESSAGES ON THE OUTPUT TAPE
C
      INTEGER         OUTTAP,NAME(2),POS(2),NEG(2),PNG(2)
      DIMENSION       XMSG(4,1),IPAG(2)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25,SWM*27
      COMMON /XMSSG / UFM,UWM,UIM,SFM,SWM
      COMMON /MACHIN/ MACH
      COMMON /SYSTEM/ SYSBUF,OUTTAP
      COMMON /MSGX  / N,M,MSG(4,1)
      EQUIVALENCE     (XMSG(1,1),MSG(1,1))
      DATA   POS,NEG/ 4HWARN,4HING ,4HFATA,4HL    /
      DATA   NMSGS  / 117/ , IPAG / 4H PAG,4HE2   /
C
      DO 99 I = 1,N
      L = IABS(MSG(1,I))
      IF (MACH.EQ.3 .AND. L.GE.1125 .AND. L.LE.1320) GO TO 80
C
C     *** NOTE ***  CHANGE IF STATEMENT WHEN YOU CHANGE GO TO
C                   MAKE SURE MESSAGE NO. IS WITHIN GO TO RANGE
C
      IF (L .GT. NMSGS) GO TO 98
      IF (L .EQ.    30) GO TO 30
      IF (MSG(3,I).NE.IPAG(1) .AND. MSG(4,I).NE.IPAG(2)) CALL PAGE2 (4)
      IF (L.GE.71 .AND. L.LE.NMSGS) GO TO 210
C
C     --- NOTE --- INCREASE THE UPPER LIMIT TO ADD MORE MESSAGES
C
      LPLUS = L + 3000
      DO 205 J = 1,2
      PNG(J) = POS(J)
      IF (MSG(1,I) .LT. 0) PNG(J) = NEG(J)
  205 CONTINUE
      CALL FNAME (MSG(2,I),NAME)
C
      GO TO (  1,  2,  3,  4,  5,  6,  7,  8,  9, 10,
     1        11, 12, 13, 14, 15, 16, 17, 18, 19, 20,
     2        21, 22, 23, 24, 25, 26, 27, 28, 29, 30,
     3        31, 32, 33, 34, 35, 36, 37, 38, 39, 40,
     4        41, 42, 43, 44, 45, 46, 47, 48, 49, 50,
     5        51, 52, 53, 54, 55, 56, 57, 58, 59, 60,
     6        61, 62, 63, 64, 65, 66, 67, 68, 69, 70), L
C
C     *** CHANGE L INTO CORRECT GINO.NASTIO.PACKUNPK ERROR NUMBER
C
  210 LPLUS = L + 1055
      WRITE (OUTTAP,2005) SFM,LPLUS
C
C     *** BRANCH TO PRINT APPROPRIATE ERROR MESSAGE
C     --- NOTE - EACH NEW MESSAGE REQUIRES A NEW PRINT STATEMENT
C
      LPLUS = L - 70
      GO TO ( 226,  227,  228,  229,  230,  231,  232,  233,  234,
     9  235,  236,  237,  238,  239,  240,  241,  242,  243,  244,
     8  245,  246,  247,  248,  249,  250,  251,  252,  253,  254,
     7  255,  256,  257,  258,  259,  260,  261,  262,  263,  264,
     6  265,  266,  267,  268,  269,  270,  271,  272), LPLUS
C
C     *** GINO FORMAT NUMBERS MATCH THE MESSAGE NUMBER.
C
  226 WRITE (OUTTAP,1126)
      GO TO 99
  227 WRITE (OUTTAP,1127)
      GO TO 99
  228 WRITE (OUTTAP,1128)
      GO TO 99
  229 WRITE (OUTTAP,1129)
      GO TO 99
  230 WRITE (OUTTAP,1130)
      GO TO 99
  231 WRITE (OUTTAP,1131)
      GO TO 99
  232 WRITE (OUTTAP,1132)
      GO TO 99
  233 WRITE (OUTTAP,1133)
      GO TO 99
  234 WRITE (OUTTAP,1134)
      GO TO 99
  235 WRITE (OUTTAP,1135)
      GO TO 99
  236 WRITE (OUTTAP,1136)
      GO TO 99
  237 WRITE (OUTTAP,1137)
      GO TO 99
  238 WRITE (OUTTAP,1138)
      GO TO 99
  239 WRITE (OUTTAP,1139)
      GO TO 99
  240 WRITE (OUTTAP,1140)
      GO TO 99
  241 WRITE (OUTTAP,1141)
      GO TO 99
  242 WRITE (OUTTAP,1142)
      GO TO 99
  243 WRITE (OUTTAP,1143)
      GO TO 99
  244 WRITE (OUTTAP,1144)
      GO TO 99
  245 WRITE (OUTTAP,1145)
      GO TO 99
  246 WRITE (OUTTAP,1146)
      GO TO 99
  247 WRITE (OUTTAP,1147)
      GO TO 99
  248 WRITE (OUTTAP,1148)
      GO TO 99
  249 WRITE (OUTTAP,1149)
      GO TO 99
  250 WRITE (OUTTAP,1150)
      GO TO 99
  251 WRITE (OUTTAP,1151)
      GO TO 99
  252 WRITE (OUTTAP,1152)
      GO TO 99
  253 WRITE (OUTTAP,1153)
      GO TO 99
  254 WRITE (OUTTAP,1154)
      GO TO 99
  255 WRITE (OUTTAP,1155)
      GO TO 99
  256 WRITE (OUTTAP,1156)
      GO TO 99
  257 WRITE (OUTTAP,1157)
      GO TO 99
  258 WRITE (OUTTAP,1158)
      GO TO 99
  259 WRITE (OUTTAP,1159)
      GO TO 99
  260 WRITE (OUTTAP,1160)
      GO TO 99
  261 WRITE (OUTTAP,1161)
      GO TO 99
  262 WRITE (OUTTAP,1162) SFM
      GO TO 99
  263 WRITE (OUTTAP,1163) SFM
      GO TO 99
  264 WRITE (OUTTAP,1164)
      GO TO 99
  265 WRITE (OUTTAP,1165)
      GO TO 99
  266 WRITE (OUTTAP,1166) SFM
      GO TO 99
  267 WRITE (OUTTAP,1167) SFM
      GO TO 99
  268 WRITE (OUTTAP,1168)
      GO TO 99
  269 WRITE (OUTTAP,1169) SFM
      GO TO 99
  270 WRITE (OUTTAP,1170)
      GO TO 99
  271 WRITE (OUTTAP,1171)
      GO TO 99
  272 WRITE (OUTTAP,1172) SFM
      GO TO 99
C
C    *** END OF GINO ERRORS SECTION
C
    1 WRITE (OUTTAP,2000) PNG,LPLUS
      WRITE (OUTTAP,101 ) MSG(2,I),MSG(3,I),MSG(4,I)
      GO TO 99
    2 WRITE (OUTTAP,2000) PNG,LPLUS
      WRITE (OUTTAP,102 ) NAME,MSG(2,I),MSG(3,I),MSG(4,I)
      GO TO 99
    3 WRITE (OUTTAP,2000) PNG,LPLUS
      WRITE (OUTTAP,103 ) NAME,MSG(2,I),MSG(3,I),MSG(4,I)
      GO TO 99
    4 WRITE (OUTTAP,2005) SFM,LPLUS
      WRITE (OUTTAP,104 ) NAME
      GO TO 99
    5 WRITE (OUTTAP,2001) PNG,LPLUS
      WRITE (OUTTAP,105 ) NAME,MSG(3,I),MSG(4,I)
      GO TO 99
    6 WRITE (OUTTAP,106 ) SFM,MSG(3,I),MSG(4,I),MSG(2,I)
      GO TO 99
    7 WRITE (OUTTAP,2005) SFM,LPLUS
      WRITE (OUTTAP,107 ) MSG(3,I),MSG(4,I)
      IF (MSG(1,I) .GE. 0) GO TO 99
      CALL ERRTRC ('MSGWRT  ',0)
      GO TO 99
    8 WRITE (OUTTAP,2000) PNG,LPLUS
      WRITE (OUTTAP,108 ) MSG(3,I),MSG(4,I)
      IF (MSG(2,I) .GT.0) WRITE (OUTTAP,1081) MSG(2,I)
      J = -MSG(2,I)
      IF (J .GT. 0) WRITE (OUTTAP,1082) J
      IF (MACH.EQ.3 .OR. MACH.EQ.5) WRITE (OUTTAP,1083)
      GO TO 99
    9 WRITE (OUTTAP,2000) PNG,LPLUS
      WRITE (OUTTAP,109 ) NAME,MSG(2,I)
      GO TO 99
   10 WRITE (OUTTAP,2000) PNG,LPLUS
      WRITE (OUTTAP,110 ) NAME,MSG(2,I)
      GO TO 99
   11 WRITE (OUTTAP,2000) PNG,LPLUS
      WRITE (OUTTAP,111 ) MSG(2,I)
      GO TO 99
   12 WRITE (OUTTAP,2000) PNG,LPLUS
      WRITE (OUTTAP,112 ) NAME,MSG(2,I)
      GO TO 99
   13 WRITE (OUTTAP,2000) PNG,LPLUS
      WRITE (OUTTAP,113 ) NAME,MSG(2,I)
      GO TO 99
   14 WRITE (OUTTAP,2000) PNG,LPLUS
      WRITE (OUTTAP,114 ) NAME,MSG(2,I)
      GO TO 99
   15 WRITE (OUTTAP,2000) PNG,LPLUS
      WRITE (OUTTAP,115 ) NAME,MSG(2,I)
      GO TO 99
   16 WRITE (OUTTAP,2005) SFM,LPLUS
      WRITE (OUTTAP,116 ) NAME,MSG(3,I),MSG(4,I)
      GO TO 99
   17 WRITE (OUTTAP,2010) UWM,LPLUS
      IF (MSG(2,I) .EQ. 0) WRITE (OUTTAP,117 )
      IF (MSG(2,I) .NE. 0) WRITE (OUTTAP,1175)
      GO TO 99
   18 WRITE (OUTTAP,2000) PNG,LPLUS
      WRITE (OUTTAP,118 ) MSG(3,I),MSG(4,I),MSG(2,I)
      GO TO 99
   19 WRITE (OUTTAP,2015) UFM,LPLUS
      WRITE (OUTTAP,119 ) MSG(3,I),MSG(4,I),MSG(2,I)
      GO TO 99
   20 WRITE (OUTTAP,2000) PNG,LPLUS
      WRITE (OUTTAP,120 ) MSG(2,I),MSG(3,I),MSG(4,I)
      GO TO 99
   21 WRITE (OUTTAP,2000) PNG,LPLUS
      WRITE (OUTTAP,121 ) MSG(2,I)
      GO TO 99
   22 WRITE (OUTTAP,2025) SWM,LPLUS
      WRITE (OUTTAP,2026)
      WRITE (OUTTAP,122 ) MSG(3,I),MSG(4,I)
      GO TO 99
   23 CONTINUE
      WRITE (OUTTAP,123 ) UIM,MSG(2,I),MSG(3,I),MSG(4,I)
      GO TO 99
   24 WRITE (OUTTAP,2020) UIM,LPLUS
      WRITE (OUTTAP,124 ) NAME,MSG(3,I)
      GO TO 99
   25 WRITE (OUTTAP,2005) SFM,LPLUS
      WRITE (OUTTAP,125 ) MSG(3,I),MSG(4,I)
      GO TO 99
   26 WRITE (OUTTAP,2005) SFM,LPLUS
      WRITE (OUTTAP,126 ) NAME,MSG(3,I),MSG(4,I)
      GO TO 99
   27 WRITE (OUTTAP,2020) UIM,LPLUS
      WRITE (OUTTAP,127 ) MSG(2,I)
      GO TO 99
   28 CONTINUE
      WRITE (OUTTAP,128 ) UIM,MSG(2,I),MSG(3,I),MSG(4,I)
      GO TO 99
   29 WRITE (OUTTAP,129 ) SFM,NAME,MSG(2,I)
      GO TO 99
   30 CALL USRMSG (I)
      GO TO 99
   31 CONTINUE
   32 WRITE (OUTTAP,2015) UFM,LPLUS
      WRITE (OUTTAP,132 ) MSG(2,I),MSG(3,I),MSG(4,I)
      GO TO 99
   33 WRITE (OUTTAP,133 ) UFM,MSG(2,I)
      GO TO 99
   34 WRITE (OUTTAP,2010) UWM,LPLUS
      WRITE (OUTTAP,134 ) XMSG(2,I),XMSG(3,I)
      GO TO 99
   35 WRITE (OUTTAP,2020) UIM,LPLUS
      WRITE (OUTTAP,135 ) MSG(2,I),XMSG(3,I)
      GO TO 99
   36 WRITE (OUTTAP,2000) PNG,LPLUS
      WRITE (OUTTAP,136 ) MSG(3,I),MSG(4,I)
      GO TO 99
   37 WRITE (OUTTAP,2000) PNG,LPLUS
      WRITE (OUTTAP,137 ) MSG(3,I),MSG(4,I)
      GO TO 99
   38 WRITE (OUTTAP,2000) PNG,LPLUS
      WRITE (OUTTAP,138 ) MSG(2,I)
      GO TO 99
   39 WRITE (OUTTAP,139 ) SFM
      GO TO 99
   40 WRITE (OUTTAP,2000) PNG,LPLUS
      WRITE (OUTTAP,140 ) NAME,MSG(2,I)
      GO TO 99
   41 WRITE (OUTTAP,2010) UWM,LPLUS
      WRITE (OUTTAP,141 ) MSG(2,I)
      GO TO 99
   42 WRITE (OUTTAP,2010) UWM,LPLUS
      WRITE (OUTTAP,142 ) XMSG(2,I)
      GO TO 99
   43 WRITE (OUTTAP,2015) UFM,LPLUS
      WRITE (OUTTAP,143 ) MSG(2,I),MSG(3,I),MSG(4,I)
      GO TO 99
   44 WRITE (OUTTAP,2015) UFM,LPLUS
      WRITE (OUTTAP,144 ) MSG(2,I),MSG(3,I)
      GO TO 99
   45 WRITE (OUTTAP,145 ) UWM,MSG(2,I),MSG(3,I),MSG(4,I)
      GO TO 99
   46 WRITE (OUTTAP,146 ) UFM
      GO TO 99
   47 WRITE (OUTTAP,147 ) UFM
      GO TO 99
   48 WRITE (OUTTAP,148 ) SFM,MSG(2,I),MSG(3,I),MSG(4,I)
      GO TO 99
   49 WRITE (OUTTAP,149 ) SFM,MSG(3,I),MSG(4,I),MSG(2,I)
      GO TO 99
   50 WRITE (OUTTAP,150 ) SFM,MSG(3,I),MSG(4,I),MSG(2,I)
      GO TO 99
   51 WRITE (OUTTAP,151 ) UFM,MSG(2,I)
      GO TO 99
   52 WRITE (OUTTAP,152 ) UWM,MSG(2,I),MSG(3,I),MSG(4,I)
      GO TO 99
   53 WRITE (OUTTAP,153 ) UWM,MSG(2,I),MSG(3,I)
      GO TO 99
   54 WRITE (OUTTAP,154 ) UWM,MSG(2,I),XMSG(3,I)
      GO TO 99
   55 WRITE (OUTTAP,2001) PNG,LPLUS
      WRITE (OUTTAP,155 ) MSG(3,I),MSG(4,I)
      GO TO 99
   56 WRITE (OUTTAP,2001) PNG,LPLUS
      WRITE (OUTTAP,156 )
      GO TO 99
   57 WRITE (OUTTAP,2001) PNG,LPLUS
      WRITE (OUTTAP,157 ) NAME
      GO TO 99
   58 WRITE (OUTTAP,2001) PNG,LPLUS
      WRITE (OUTTAP,158 ) XMSG(2,I),MSG(3,I)
       GO TO 99
   59 WRITE (OUTTAP,2001) PNG,LPLUS
      WRITE (OUTTAP,159 ) MSG(2,I),MSG(3,I),MSG(4,I)
      GO TO 99
   60 WRITE (OUTTAP,160 ) UFM
      GO TO 99
   61 CONTINUE
      GO TO 99
   62 WRITE (OUTTAP,162 ) SFM
      GO TO 99
   63 WRITE (OUTTAP,163 ) SFM
      GO TO 99
   64 WRITE (OUTTAP,164 ) SFM
      GO TO 99
   65 WRITE (OUTTAP,165 ) SFM
      GO TO 99
   66 WRITE (OUTTAP,166 ) SFM
      GO TO 99
   67 WRITE (OUTTAP,167 ) SFM
      GO TO 99
   68 WRITE (OUTTAP,168 ) SFM
      GO TO 99
   69 WRITE (OUTTAP,169 ) SFM
      GO TO 99
   70 WRITE (OUTTAP,170 ) SFM
      GO TO 99
   80 CALL MSGUNI (L)
      GO TO 99
   98 WRITE (OUTTAP,198 ) MSG(1,I),MSG(2,I),MSG(3,I),MSG(4,I)
   99 CONTINUE
      IF (N .GE. M) WRITE (OUTTAP,199) UWM,M
      I = N
      N = 0
      IF (MSG(1,I) .GE. 0) GO TO 1000
CWKBI WRITE (OUTTAP,100)
      CALL ERRTRC ('WRTMSG  ',100)
 1000 RETURN
C
C
C 100 FORMAT ('0FATAL ERROR')
  101 FORMAT ('0ATTEMPT TO OPEN DATA SET',I4,' IN SUBROUTINE ',A4,A2,
     1        ', WHICH WAS NOT DEFINED IN THE FIST')
  102 FORMAT ('0EOF ENCOUNTERED WHILE READING DATA SET ',2A4,'(FILE',
     1        I4,') IN SUBROUTINE ',2A4)
  103 FORMAT ('0ATTEMPT TO READ PAST THE END OF A LOGICAL RECORD IN ',
     1        'DATA SET ',2A4,'(FILE',I4,') IN SUBROUTINE ',2A4)
  104 FORMAT ('0INCONSISTENT TYPE FLAGS ENCOUNTERED WHILE PACKING DATA',
     1        'SET ',2A4)
  105 FORMAT ('0ATTEMPT TO OPERATE ON THE SINGULAR MATRIX ',2A4,
     1        ' IN SUBROUTINE ',2A4)
  106 FORMAT (A25,' 3006, BUFFER ASSIGNED WHEN OPENING DATA BLOCK ',2A4,
     1        6H,FILE ,I5,1H,, /5X,'CONFLICTS WITH BUFFERS CURRENTLY ',
     2        'OPEN.')
  107 FORMAT ('0ILLEGAL INPUT TO SUBROUTINE ',2A4)
  108 FORMAT ('0INSUFFICIENT CORE AVAILABLE FOR SUBROUTINE ',2A4)
 1081 FORMAT (' ADDITIONAL CORE REQUIRED =',I10,' WORDS.')
 1082 FORMAT (' PRESENT OPEN CORE SIZE =',I10,' WORDS.')
 1083 FORMAT (' USE NASTRAN HICORE CARD TO INCREASE CORE SIZE')
  109 FORMAT ('0DATA TRANSMISSION ERROR ON DATA SET ',2A4,'(FILE',I4,
     1        1H))
  110 FORMAT ('0ATTEMPT TO MANIPULATE DATA SET ',2A4,'(FILE',I4,
     1        ' BEFORE OPENING THE FILE')
  111 FORMAT ('0ATTEMPT TO WRITE A TRAILER ON FILE',I4,
     1        ' WHEN IT HAS BEEN PURGED')
  112 FORMAT ('0ATTEMPT TO OPEN DATA SET ',2A4,'(FILE',I4,
     1        ') WHICH HAS ALREADY BEEN OPENED')
  113 FORMAT ('0ATTEMPT TO READ DATA SET ',2A4,'(FILE',I4,
     1        ') WHEN IT WAS OPENED FOR OUTPUT')
  114 FORMAT ('0ATTEMPT TO WRITE DATA SET ',2A4,'(FILE',I4,
     1        ') WHEN IT WAS OPENED FOR INPUT')
  115 FORMAT ('0ATTEMPT TO FWDREC ON DATA SET ',2A4,'(FILE',I4,
     1        ') WHEN IT WAS OPENED FOR OUTPUT')
  116 FORMAT (1H0,2A4,' MATRIX IS NOT IN PROPER FORM IN SUBROUTINE ',
     1        2A4)
  117 FORMAT ('0    ONE OR MORE POTENTIAL SINGULARITIES HAVE NOT BEEN ',
     1        'REMOVED BY SINGLE OR MULTI-POINT CONSTRAINTS.', /5X,
     2        '(USER COULD REQUEST NASTRAN AUTOMATIC SPC GENERATION ',
     3        'VIA A ''PARAM AUTOSPC'' BULK DATA CARD)')
 1175 FORMAT ('0    ONE OR MORE POTENTIAL SINGULARITIES HAVE NOT BEEN ',
     1        'REMOVED BY SINGLE OR MULTI-POINT CONSTRAINTS.')
  118 FORMAT ('0MODULE ',2A4,', SEQUENCE NO.',I5,
     1        ', REQUIREMENTS EXCEED AVAILABLE FILES')
  119 FORMAT ('0MAXIMUM LINE COUNT EXCEEDED IN SUBROUTINE ',2A4,
     1        ' LINE COUNT EQUALS',I8)
  120 FORMAT ('0GNFIST OVERFLOWED FIST TABLE AT SEQUENCE NO.',I5,
     1        '  DATA SET ',2A4)
  121 FORMAT ('0FILE',I4,' NOT DEFINED IN FIST')
  122 FORMAT (5X,'DATA BLOCK ',2A4,' MAY BE REQUIRED AS INPUT AND IS ',
     1        'NOT OUTPUT BY A PREVIOUS MODULE IN THE CURRENT DMAP ',
     2        'ROUTE.')
  123 FORMAT (A29,' 3028   B =',I5,' C =',I5,' R =',I5)
  124 FORMAT ('0THE BANDWIDTH OF MATRIX ',2A4,' EXCEEDS THE MAXIMUM ',
     1        'BANDWIDTH. A MAXIMUM BANDWIDTH OF',I5,' WILL BE USED')
  125 FORMAT ('0ILLEGAL INDEX IN ACTIVE ROW OR COLUMN CALCULATION IN ',
     1        2A4)
  126 FORMAT ('0MATRIX ',2A4,' EXCEEDS MAXIMUM ALLOWABLE SIZE FOR BAND',
     1        'WIDTH PLUS ACTIVE COLUMNS. BMAX =',I6,' CMAX =',I6)
  127 FORMAT ('0DECOMPOSITION TIME ESTIMATE IS',I6)
  128 FORMAT (A29,' 3028, BBAR =',I5,' CBAR =',I5,' R =',I5)
  129 FORMAT (A25,' 3029, PHYSICAL EOF ENCOUNTERED ON DATA SET ',2A4,
     1        ' (FILE',I4,3H ).)
  132 FORMAT ('0UNABLE TO FIND SELECTED SET (',I8,') IN TABLE (',A4,
     1        ') IN SUBROUTINE (',A4,2H).)
  133 FORMAT (A23,' 3033, SUBCASE ID',I9,' IS REFERENCED ON ONE OR MORE'
     1,       ' RANDPS CARDS', /5X,'BUT IS NOT A CURRENT SUBCASE ID.')
  134 FORMAT ('0ORTHOGONALITY CHECK FAILED, LARGEST TERM = ',1P,E14.7,
     1        ', EPSILON = ',1P,E14.7)
  135 FORMAT (5X,'FOR SUBCASE NUMBER',I6,', EPSILON SUB E = ',1P,E15.7)
  136 FORMAT ('0DATA SET ',2A4,' IS REQUIRED AS INPUT BUT HAS NOT ',
     1        'BEEN GENERATED OR PURGED')
  137 FORMAT ('0JOB TERMINATED IN SUBROUTINE ',2A4)
  138 FORMAT ('0DATA SET ',A4,' DOES NOT HAVE MULTI-REEL CAPABILITY')
  139 FORMAT (A25,' 3039, ENDSYS CANNOT FIND SAVE FILE.')
  140 FORMAT ('0ATTEMPT TO WRITE DATA SET ',2A4,'(FILE',I4,
     1        ') WHEN IT IS AN INPUT FILE')
  141 FORMAT ('0EXTERNAL GRID POINT',I9,' DOES NOT EXIST OR IS NOT A ',
     1        'GEOMETRIC GRID POINT.',
     2        /5X,'THE BASIC ORIGIN WILL BE USED.')
  142 FORMAT ('0INCONSISTENT SCALAR MASSES HAVE BEEN USED.  EPSILON/',
     1        'DELTA = ',1P,E15.7)
  143 FORMAT ('0UNCONNECTED EXTRA POINT (MODAL COORDINATE =',I9,
     1        ') HAS BEEN DETECTED BY SUBROUTINE ',2A4)
  144 FORMAT ('0A POINT ON NON-LINEAR LOAD SET',I9,' NOLIN',I1,
     1        ' IS NOT AN EXTRA POINT.', /5X,'ONLY EXTRA POINTS MAY ',
     2        'HAVE NON-LINEAR LOADS IN A MODAL FORMULATION.')
  145 FORMAT (A25,' 3045, INSUFFICIENT TIME TO COMPLETE THE REMAINING',
     1        I6,' SOLUTION(S) IN MODULE ',2A4)
  146 FORMAT (A23,' 3046, YOUR SELECTED LOADING CONDITION, INITIAL ',
     1        'CONDITION, AND NON-LINEAR FORCES ARE NULL', /5X,
     2        'A ZERO SOLUTION WILL RESULT.')
  147 FORMAT (A23,' 3047, NO MODES WITHIN RANGE AND LMODES = 0. A MODAL'
     1,       ' FORMULATION CANNOT BE MADE.')
  148 FORMAT (A25,' 3048, BUFFER CONTROL WORD INCORRECT FOR GINO ',A4,
     1        ' OPERATION ON DATA BLOCK ',2A4)
  149 FORMAT (A25,' 3049, GINO UNABLE TO POSITION DATA BLOCK ',2A4,
     1        ' CORRECTLY DURING ',A4,' OPERATION.')
  150 FORMAT (A25,' 3050, INSUFFICIENT TIME REMAINING FOR ',2A4,
     1        '.  TIME ESTIMATE IS',I9,' SECONDS.')
  151 FORMAT (A23,' 3051, INITIAL CONDITION SET',I9,' WAS SELECTED FOR',
     1        ' A MODAL TRANSIENT PROBLEM.' ,/5X,
     2        'INITIAL CONDITIONS ARE NOT ALLOWED IN SUCH A PROBLEM.')
  152 FORMAT (A25,' 3052, A RANDOM REQUEST FOR CURVE TYPE - ',A4,
     1        ' -, POINT -',I9, /5X,'COMPONENT -',I4,
     2        ' -, SPECIFIES TOO LARGE A COMPONENT ID.  THE LAST ',
     3        'COMPONENT WILL BE USED.')
  153 FORMAT (A25,' 3053, THE ACCURACY OF EIGENVALUE',I6,' IS IN DOUBT.'
     1,       ' GIVENS-QR FAILED TO CONVERGE IN',I4,' ITERATIONS.')
  154 FORMAT (A25,' 3054, THE ACCURACY OF EIGENVECTOR',I6,' CORRESPOND',
     1        'ING TO THE EIGENVALUE ',1P,E15.7,' IS IN DOUBT.')
  155 FORMAT ('0AN ATTEMPT TO MULTIPLY OR MULTIPLY AND ADD NON-CONFOR',
     1        'MABLE MATRICES TOGETHER WAS MADE IN SUBROUTINE ',2A4)
  156 FORMAT ('0NO MASS MATRIX IS PRESENT BUT MASS DATA IS REQUIRED')
  157 FORMAT ('0MATRIX ',2A4,' IS NOT POSITIVE DEFINITE.')
  158 FORMAT ('0EPSILON IS LARGER THAN ',1P,E14.7,' FOR SUBCASE',I5)
  159 FORMAT ('0SET IDENTIFIER ',A4,' DOES NOT EXIST. ERROR DETECTED ',
     1        'IN SUBROUTINE ',2A4)
  160 FORMAT (A23,' 3060, READ MODULE FINDS THAT THE INPUT STIFFNESS ',
     1        'AND/OR MASS MATRIX IS NULL.')
  162 FORMAT (A25,' 3062, NO MESSAGE.')
  163 FORMAT (A25,' 3063, NO MESSAGE.')
  164 FORMAT (A25,' 3064, NO MESSAGE.')
  165 FORMAT (A25,' 3065, NO MESSAGE.')
  166 FORMAT (A25,' 3066, NO MESSAGE.')
  167 FORMAT (A25,' 3067, NO MESSAGE.')
  168 FORMAT (A25,' 3068, NO MESSAGE.')
  169 FORMAT (A25,' 3069, NO MESSAGE.')
  170 FORMAT (A25,' 3070, NO MESSAGE.')
  198 FORMAT ('0NO MESSAGE FOR MESSAGE NO. =',I5 ,/5X,'PARAMETERS = ',
     1        3I20)
  199 FORMAT (A25,' 3199, NON-FATAL MESSAGES MAY HAVE BEEN LOST BY ',
     1        'ATTEMPTING TO QUEUE MORE THAN',I5,' MESSAGES')
 1126 FORMAT ('0ADDRESS OF BUFFER LESS THAN ADDRESS OF /XNSTRN/.')
 1127 FORMAT ('0BUFFER ASSIGNED EXTENDS INTO MASTER INDEX AREA.')
 1128 FORMAT ('0ON AN OPEN CALL WITHOUT REWIND, THE BLOCK NUMBER READ ',
     1        'DOES NOT MATCH EXPECTED VALUE.')
 1129 FORMAT ('0ON A CALL WRITE THE WORD COUNT IS NEGATIVE.')
 1130 FORMAT ('0ON A CALL READ THE CONTROL WORD AT WHICH THE FILE IS ',
     1        'POSITIONED IS NOT ACCEPTABLE.')
 1131 FORMAT ('0LOGICAL RECORD TRAILER NOT RECOGNIZABLE AS SUCH.')
 1132 FORMAT ('0UNRECOGNIZABLE CONTROL WORD DURING PROCESSING OF A ',
     1        'BCKREC CALL.')
 1133 FORMAT ('0AFTER A POSITIONING CALL TO IO6600, DURING PROCESSING ',
     1        'OF A BCKREC CALL THE BLOCK READ WAS NOT THE EXPECTED ',
     2        'ONE.')
 1134 FORMAT ('0CALL SKPFIL IN A FORWARD DIRECTION ON A FILE NOT ',
     1        'OPENED FOR OUTPUT IS NOT SUPPORTED.')
 1135 FORMAT ('0FILPOS WAS CALLED ON A FILE OPENED FOR OUTPUT.')
 1136 FORMAT ('0ENDPUT WAS CALLED WITH BLOCK(8) EQUAL TO -1.')
 1137 FORMAT ('0MORE TERMS WRITTEN IN STRING THAN WERE AVAILABLE TO ',
     1        'WRITE.')
 1138 FORMAT ('0CURRENT BUFFER POINTER EXCEEDS LAST DATA WORD IN BLOCK')
 1139 FORMAT ('0ON AN INITIAL CALL TO GETSTR, THE RECORD IS NOT ',
     1        'POSITIONED AT THE COLUMN HEADER.')
 1140 FORMAT ('0STRING DEFINITION WORD NOT RECOGNIZABLE.')
 1141 FORMAT ('0FIRST WORD OF A DOUBLE PRECISION STRING IS NOT ON A ',
     1        'DOUBLE PRECISION BOUNDARY.')
 1142 FORMAT ('0CURRENT BUFFER POINTER IS BEYOND RANGE OF INFORMATION ',
     1        'IN BUFFER.')
 1143 FORMAT ('0ON AN INITIAL CALL TO GETSTB, THE FILE IS NOT ',
     1        'POSITIONED AT AN ACCEPTABLE POINT.')
 1144 FORMAT ('0END-OF-SEGMENT CONTROL WORD SHOULD HAVE IMMEDIATELY ',
     1        'PRECED CURRENT POSITION AND IT DID NOT.')
 1145 FORMAT ('0COLUMN TRAILER NOT FOUND.')
 1146 FORMAT ('0PREVIOUS RECORD TO BE READ BACKWARDS WAS NOT WRITTEN ',
     1        'WITH STRING TRAILERS.')
 1147 FORMAT ('0STRING RECOGNITION WORD NOT RECOGNIZED.')
 1148 FORMAT ('0RECORD CONTROL WORD NOT IN EXPECTED POSITION.')
 1149 FORMAT ('0RECTYP WAS CALLED FOR A FILE OPENED FOR OUTPUT.')
 1150 FORMAT ('0RECTYP MUST BE CALLED WHEN THE FILE IS POSITIONED AT ',
     1        'THE BEGINNING OF A RECORD.')
 1151 FORMAT ('ON A CALL TO OPEN THE BUFFER ASSIGNED OVERLAPS A ',
     1        'PREVIOUSLY ASSIGNED BUFFER.')
 1152 FORMAT ('0A CALL TO OPEN FOR AN ALREADY OPEN FILE.')
 1153 FORMAT ('0FILE NOT OPEN.')
 1154 FORMAT ('0GINO REFERENCE NAME NOT IN FIST OR FILE NOT OPEN.')
 1155 FORMAT ('0A CALL TO GETSTR OCCURRED WHEN THE FILE WAS POSITIONED',
     1        'AT END-OF-FILE.')
 1156 FORMAT ('0ATTEMPTED TO WRITE ON AN INPUT FILE.')
 1157 FORMAT ('0ATTEMPTED TO READ FROM AN OUTPUT FILE.')
 1158 FORMAT ('0A CALL TO BLDPK OR PACK IN WHICH EITHER TYPIN OR ',
     1        'TYPOUT IS OUT OF RANGE.')
 1159 FORMAT ('0ROW POSITIONS OF ELEMENTS FURNISHED TO ZBLPKI OR ',
     1        'BLDPKI ARE NOT IN A MONOTONIC INCREASING SEQUENCE.', /,
     2        ' (POSSIBLY DUE TO ROW OR COLUMN INDEX ERROR)')
 1160 FORMAT ('0ON A CALL TO BLDPKN, FILE NAME DOES NOT MATCH PREVIOUS',
     1        'CALLS.')
 1161 FORMAT ('0A CALL TO INTPK OR UNPACK IN WHICH TYPOUT IS OUT OF ',
     1        'RANGE.')
 1162 FORMAT (A25,' 1162, NO MESSAGE.')
 1163 FORMAT (A25,' 1163, NO MESSAGE.')
 1164 FORMAT ('0 FOLLOWING A READ ATTEMPT ON AN INDEXED FILE, EITHER ',
     1        'AN END-OF-FILE WAS ENCOUNTERED OR THE NUMBER OF WORDS ',
     2        'READ WAS INCORRECT.')
 1165 FORMAT ('0ON AN ATTEMPT TO READ A SEQUENTIAL FILE, AN END-OF-',
     1        'FILE OR AN END-OF-INFORMATION WAS ENCOUNTERED.')
 1166 FORMAT (A25,' 1166, NO MESSAGE.')
 1167 FORMAT (A25,' 1167, NO MESSAGE.')
 1168 FORMAT ('0A CALL TO IO6600 WITH OPCODE=5 (FORWARD SPACE) IS NOT ',
     1        'SUPPORTED.')
 1169 FORMAT (A25,' 1169, NO MESSAGE.')
 1170 FORMAT ('0ILLEGAL CALL TO NASTIO, LOGIC ERROR IN IO6600.')
 1171 FORMAT ('0ON A POSITION CALL, THE BLOCK NUMBER REQUESTED IS NOT ',
     1        'FOUND IN CORE WHEN IT IS EXPECTED THERE.')
 1172 FORMAT (A25,' 1172, NO MESSAGE.')
 2000 FORMAT (12H0*** SYSTEM ,2A4,8H MESSAGE,I5)
 2001 FORMAT (10H0*** USER ,2A4,9H MESSAGE ,I5)
 2005 FORMAT (A25,I5)
 2010 FORMAT (A25,I5)
 2015 FORMAT (A23,I5)
 2020 FORMAT (A29,I5)
 2025 FORMAT (A27,I5)
 2026 FORMAT (1H+,33X,'(SEE PROG. MANUAL SEC. 4.9.7, OR ',7HUSERS' ,
     1        'MANUAL P. 6.5-3)')
      END

      SUBROUTINE FQRW (M,E,ER,A,B,W,P,Q,XM,INT,ZB,SRFLE,MCBC)
C
      LOGICAL            INT(1)
      INTEGER            SRFLE
      DOUBLE PRECISION   DLAMDA
      REAL               LAMBDA
      DIMENSION          A(1)     ,B(2)    ,W(1)   ,P(1)   ,E(1)    ,
     1                   Q(1)     ,ER(1)   ,XM(1)
      DIMENSION          ZB(1)    ,MCB(7)  ,MCBC(7)
      CHARACTER          UFM*23   ,UWM*25
      COMMON   /XMSSG /  UFM      ,UWM
      COMMON   /FEERXX/  DLAMDA   ,CNDFLG  ,ITER   ,TIMED  ,L16
      COMMON   /NAMES /  RD       ,RDREW   ,WRT    ,WRTREW ,REW     ,
     1                   NOREW    ,EOFNRW
      COMMON   /LHPWX /  LHPW(3)  ,IACC
      COMMON   /SYSTEM/  KSYSTM(65)
      COMMON   /PACKX /  ITP1     ,ITP2    ,IIP    ,NNP    ,INCRP
      COMMON   /UNPAKX/  IPRC     ,II      ,NN     ,INCR
      EQUIVALENCE        (KSYSTM(2),IO)    ,(KSYSTM(55),IPREC)
      DATA      ILIM  ,  IEXP   ,BASE /    120, 60,  2.    /
C
C     IACC  =  ACCURACY CONTROL (EPSILON) FOR UNDERFLOW
C
      IF (M .EQ. 1) RETURN
      LAMBDA = DLAMDA
      IPRC = 1
      CALL MAKMCB (MCB(1),SRFLE,M,2,IPRC)
      ICF  = MCBC(1)
      INCR = 1
      INCRP= 1
      ITP1 = IPRC
      ITP2 = IPRC
      IT   = IACC*IPREC
      PRC  = 10.**(-IT)
      PPRC = 10.E-4
      JERR = 0
      EPX  = 10.**(2-IT)
      EPX2 = EPX**2
      HOV  = BASE**IEXP
      M1   = M - 1
      DO 20 I = 1,M
   20 E(I) = A(I)
      TOL  = PRC/(10.*FLOAT(M))
      BMAX = 0.
      TMAX = 0.
      W(M+1) = 0.
      DO 30 I = 1,M
      IF (BMAX .LT. ABS(B(I))) BMAX = ABS(B(I))
      IF (TMAX .LT. ABS(A(I))) TMAX = ABS(A(I))
   30 CONTINUE
      IF (TMAX .LT. BMAX) TMAX = BMAX
      SCALE = 1.
      DO 40 I = 1,ILIM
      IF (SCALE*TMAX .GT. HOV) GO TO 50
   40 SCALE = SCALE*2.
   50 IF (BMAX .EQ. 0.) GO TO 170
      DO 60 I = 1,M
      E(I) =  A(I)*SCALE
   60 W(I) = (B(I)*SCALE)**2
      DELTA= TMAX*SCALE*TOL
      EPS  = DELTA*DELTA
      K  = M
   70 L  = K
      IF (L .LE. 0) GO TO 140
      L1 = L - 1
      DO 80 I = 1,L
      K1 = K
      K  = K - 1
      IF (W(K1) .LT. EPS) GO TO 90
   80 CONTINUE
   90 IF (K1 .NE. L) GO TO 100
      W(L) = 0.
      GO TO 70
  100 T = E(L) - E(L1)
      X = W(L)
      Y = .5*T
      S = SQRT(X)
      IF (ABS(T) .GT. DELTA) S = (X/Y)/(1.+SQRT(1.+X/Y**2))
      E1 = E(L ) + S
      E2 = E(L1) - S
      IF (K1 .NE. L1) GO TO 110
      E(L ) = E1
      E(L1) = E2
      W(L1) = 0.
      GO TO 70
  110 SHIFT = E1
      IF (ABS(T).LT.DELTA .AND. ABS(E2).LT.ABS(E1)) SHIFT = E2
      S  = 0.
      C  = 1.
      GG = E(K1) - SHIFT
      GO TO 130
  120 C  = F/T
      S  = X/T
      X  = GG
      GG = C*(E(K1) - SHIFT) - S*X
      E(K) = (X - GG) + E(K1)
  130 IF (ABS(GG) .LT. DELTA) GG = GG + C*DELTA*GG/ABS(GG)
      F  = GG**2/C
      K  = K1
      K1 = K + 1
      X  = W(K1)
      T  = X + F
      W(K) = S*T
      IF (K .LT. L) GO TO 120
      E(K) = GG + SHIFT
      GO TO 70
  140 DO 150 I = 1,M
  150 E(I) = E(I)/SCALE
      DO 155 L = 1,M1
      K = M - L
      DO 155 I = 1,K
      IF (E(I) .GT. E(I+1)) GO TO 155
      X = E(I)
      E(I  ) = E(I+1)
      E(I+1) = X
  155 CONTINUE
      DO 160 L = 1,M1
      K = M - L
      DO 160 I = 1,K
      IF (ABS(E(I)) .GT. ABS(E(I+1))) GO TO 160
      X = E(I)
      E(I  ) = E(I+1)
      E(I+1) = X
  160 CONTINUE
  170 IF (M .EQ. 0) RETURN
C
C     COMPUTE EIGENVECTORS BY INVERSE ITERATION
C
      ERF  = B(M+1)
      MVEC = M
      F = SCALE/HOV
      DO 190 I = 1,M
      A(I) = A(I)*F
  190 B(I) = B(I)*F
      DIMF = 10.**(-IT/3)
      DO 460 NV = 1,MVEC
      IJ   = NV
      SUMX = 0.
      IRP  = 0
      IF (NV .EQ. 1) GO TO 200
      RATIO = ABS(E(NV)/E(NV-1) - 1.)
      DIM   = .02*ABS(1.-LAMBDA*E(NV))
      IF (RATIO.LT.DIM .OR. RATIO.LT.DIMF) GO TO 220
      NRP = 0
      GO TO 225
  200 NRP = 0
      DO 210 I = 1,M
  210 W(I) = 1.
      IIP  = 1
      NNP  = M
      GO TO 330
C
C     MULTIPLE EIGENVALUES
C
  220 NRP = NRP + 1
  225 IF (NV .NE. 2) GO TO 230
      CALL GOPEN (SRFLE,ZB(1),WRTREW)
      MCB(2) = 0
      MCB(6) = 0
      GO TO 240
  230 CALL GOPEN (SRFLE,ZB(1),WRT)
  240 IIP = 1
      NNP = M
      CALL PACK (W(1),SRFLE,MCB(1))
      CALL CLOSE (SRFLE,NOREW)
      SS  = 1.0
      SUM = 0.
      DO 250 I = 1,M
      SS =-SS
      IJ = IJ + 1
      P(I) = FLOAT(MOD(IJ,3)+1)/(3.0*FLOAT((MOD(IJ,13)+1)*(1+5*I/M)))
      P(I) = P(I)*SS
  250 SUM  = SUM + P(I)**2
      SUM  = 1./SQRT(SUM)
      DO 255 I = 1,M
      P(I) = P(I)*SUM
  255 Q(I) = P(I)
      CALL GOPEN (SRFLE,ZB(1),RDREW)
      J = 0
  260 SUM = 0.
      J = J + 1
      DO 270 I = 1,M
  270 SUM = SUM + W(I)*P(I)
      DO 280 I = 1,M
  280 Q(I) = Q(I) - SUM*W(I)
      IF (J .EQ. NV-1) GO TO 290
      II = 1
      NN = M
      CALL UNPACK (*290,SRFLE,W(1))
      GO TO 260
  290 CALL CLOSE (SRFLE,NOREW)
      SUM = 0.
      DO 300 I = 1,M
  300 SUM = SUM + Q(I)**2
      SUM = 1./SQRT(SUM)
      DO 310 I = 1,M
      Q(I) = Q(I)*SUM
  310 W(I) = Q(I)
  330 EV = E(NV)*F
      X  = A(1) - EV
      Y  = B(2)
      DO 350 I = 1,M1
      C  = A(I+1) - EV
      S  = B(I+1)
      IF (ABS(X) .GE. ABS(S)) GO TO 340
      P(I) = S
      Q(I) = C
      INT(I) = .TRUE.
      Z = -X/S
      X = Y + Z*C
      IF (I .LT. M1) Y = Z*B(I+2)
      GO TO 350
  340 IF (ABS(X) .LT. TOL) X = TOL
      P(I) = X
      Q(I) = Y
      INT(I) = .FALSE.
      Z = -S/X
      X = C + Z*Y
      Y = B(I+2)
  350 XM(I) = Z
      IF (ABS(X) .LT. TOL) X = TOL
      NITER = 0
  360 NITER = NITER + 1
      W(M)  = W(M)/X
      EMAX  = ABS(W(M))
      DO 370 L = 1,M1
      I = M - L
      Y = W(I) - Q(I)*W(I+1)
      IF (INT(I)) Y = Y - B(I+2)*W(I+2)
      W(I) = Y/P(I)
      IF (ABS(W(I)) .GT. EMAX) EMAX = ABS(W(I))
  370 CONTINUE
      SUM = 0.
      DO 375 I = 1,M
      W(I) = (W(I)/EMAX)/EPX
      IF (ABS(W(I)) .LT. EPX2) W(I) = EPX2
  375 SUM  = SUM + W(I)**2
      S    = SQRT(SUM)
      DO 380 I = 1,M
      W(I) = W(I)/S
  380 CONTINUE
      IF (NITER .GE. 4) GO TO 402
      DO 400 I = 1,M1
      IF (INT(I)) GO TO 390
      W(I+1) = W(I+1) + XM(I)*W(I)
      GO TO 400
  390 Y = W(I)
      W(I  ) = W(I+1)
      W(I+1) = Y + XM(I)*W(I)
  400 CONTINUE
      GO TO 360
  402 IF (NV .EQ. 1) GO TO 410
C
C     MULTIPLE EIGENVALUES AND ORTHOGONALIZATION
C
      IRP = IRP + 1
      CALL GOPEN (SRFLE,ZB(1),RDREW)
      DO 404 I = 1,M
  404 Q(I) = W(I)
      SUMX = 0.
      JRP  = NV - 1
      DO 407 I = 1,JRP
      II = 1
      NN = M
      CALL UNPACK (*408,SRFLE,P(1))
      SUM = 0.
      DO 405 J = 1,M
  405 SUM = SUM + P(J)*Q(J)
      IF (ABS(SUM) .GT. SUMX) SUMX = ABS(SUM)
      DO 406 J = 1,M
  406 W(J) = W(J) - SUM*P(J)
  407 CONTINUE
  408 CALL CLOSE (SRFLE,NOREW)
  410 CONTINUE
C
C     LOGIC SETTING SUM (BY G.CHAN/UNISYS  7/92)
C
C     SUM = PRC*PREC COULD PRODUCE UNDERFLOW
C     SUM = ZERO, COULD CAUSE DIVIDED BY ZERO AFTER 420 FOR NULL VECTOR
C     SO, WE CHOOSE SUM A LITTLE SMALLER THAN PRC
C
C     SUM = PRC*PRC
C     SUM = 0.0
      SUM = PRC*1.0E-4
C
      DO 420 I = 1,M
  420 SUM = SUM + W(I)*W(I)
      SUM = 1./SQRT(SUM)
      DO 430 I = 1,M
  430 W(I) = W(I)*SUM
      IF (SUMX.GT.0.9 .AND. IRP.LT.3) GO TO 330
      IF (L16 .NE. 0) WRITE (IO,435) NV,NITER,IRP,SUMX
  435 FORMAT (10X,18H FEER QRW ELEMENT ,I5,6H ITER ,2I3,6H PROJ ,E16.8)
      IF (JERR.GT. 0) GO TO 450
      ZERR = ABS(W(1))
      DO 440 I = 2,M
      IF (ABS(W(I)) .GT. ZERR) ZERR = ABS(W(I))
  440 CONTINUE
      ZERR = (ABS(W(M)))/ZERR
      IF (ZERR .GT. PPRC) JERR = NV-1
      IF (JERR .NE.    0) WRITE (IO,445) UWM,JERR
  445 FORMAT (A25,' 2399', /5X,'ONLY THE FIRST',I6,' EIGENSOLUTIONS ',
     1       'CLOSEST TO THE SHIFT POINT (F1 OR ZERO) PASS THE FEER ',
     2       'ACCURACY TEST FOR EIGENVECTORS.')
  450 CONTINUE
      CALL PACK (W(1),ICF,MCBC(1))
      ER(NV) = ABS(W(M)*ERF/E(NV))
  460 CONTINUE
      RETURN
      END

      SUBROUTINE RCARD2 (OUT,FMT,NFLAG,IN)
CDIR$ INTEGER=64
C
C     CDIR$ IS CRAY COMPILE DIRECTIVE. 64-BIT INTEGER IS USED LOCALLY
C
C     THIS ROUTINE IS MUCH MORE EFFICIENT THAN THE OLD ROUTINE RCARD
C     IT CAN SAFELY REPLACE THE OLD RCARD ROUTINE
C     WRITTEN BY G.CHAN/UNISYS            10/1987
C     REVISED, 8/1989, IMPROVED EFFICIENCY BY REDUCING CHARACTER
C     OPERATIONS (VERY IMPORTANT FOR CDC MACHINE)
C     LAST REVISED, 8/1991, SETTING UP REAL NO. UPPER AND LOWER BOUNDS
C     FOR VARIOUS MACHINES
C
C     RCARD2 ASSUMES ALL INPUT FIELDS IN 'IN' ARE LEFT-ADJUSTED.
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL         LSHIFT   ,RSHIFT   ,COMPLF
      LOGICAL          SEQGP    ,DECIML   ,MINUS    ,NOGO     ,
     1                 EXPONT   ,DOUBLE   ,BLKON
      INTEGER          IN(20)   ,OUT(1)   ,FMT(1)   ,TYPE(16) ,
     1                 NT(16)   ,OUTX(100),IDOUBL(2),VALUE(16),
     2                 NUM1(9)  ,CHR1(16) ,A1(80)
      REAL             FPT
      DOUBLE PRECISION DDOUBL
      CHARACTER*1      BLANKC   ,STARC    ,DOTC     ,PLUSC    ,
     1                 MINUSC   ,DC       ,EC       ,ZEROC    ,
     2                 KHR1(16) ,K1(80)
      CHARACTER*4      IN4(40)  ,C4(1)    ,CHR4(4)  ,OUT4(100)
      CHARACTER*5      D5       ,SEQGP5   ,SEQEP5
      CHARACTER*100    TMP100   ,OUT100(4)
      CHARACTER        NUM9*9   ,UFM*23   ,E80*80
      COMMON /XMSSG /  UFM
      COMMON /LHPWX /  LOWPW    ,HIGHPW
      COMMON /SYSTEM/  BUFSZ    ,NOUT     ,NOGO     ,DUM1(8)  ,
     1                 NLINES
      COMMON /XECHOX/  DUM2(4)  ,XSORT2
      EQUIVALENCE      (CHR11,CHR1(1)),   (K1(1),IN4(1),D5,E80),
     1                 (FPT,INTGR),       (KHR1(1),CHR4(1)),
     2                 (DDOUBL,IDOUBL(1)),(OUT4(1),OUT100(1))
      DATA    BLANKC,  STARC,   PLUSC,  MINUSC,  DOTC,  EC,   DC    /
     1        ' ',     '*',     '+',    '-',     '.',   'E',  'D'   /
      DATA    BLANK,   STARS,   SEQGP5, SEQEP5,  ZEROC, NUM9        /
     1        4H    ,  4H====,  'SEQGP','SEQEP', '0',   '123456789' /
      DATA    PLUS1 /  0    /
C
      IF (PLUS1 .NE. 0) GO TO 10
      CALL K2B (BLANKC,BLANK1,1)
      CALL K2B (STARC ,STAR1 ,1)
      CALL K2B (PLUSC ,PLUS1 ,1)
      CALL K2B (MINUSC,MINUS1,1)
      CALL K2B (DOTC  ,DOT1  ,1)
      CALL K2B (EC    ,E1    ,1)
      CALL K2B (DC    ,D1    ,1)
      CALL K2B (ZEROC ,ZERO1 ,1)
      CALL K2B (NUM9  ,NUM1  ,9)
   10 CONTINUE
C
      CALL BCDKH8 (IN,E80)
      CALL K2B (E80,A1,80)
      GO TO 30
C
C
      ENTRY RCARD3 (OUT,FMT,NFLAG,C4)
C     ===============================
C
C     IN RCARD2, 'IN' IS 4-BYTE BCD  AND 'OUT' IS 4-BYTE BCD
C     IN RCARD3, 'C4' IS CHARACTER*4 AND 'OUT' IS 4-BYTE BCD
C     'IN' AND 'C4' ARE INPUT, AND 'OUT' IS OUTPUT
C
      DO 20 I = 1,20
   20 IN4(I) = C4(I)
      CALL K2B (C4,A1,80)
C
   30 FIELD  = 0
      IOUT   = 0
      IFMT   = 0
      WORD   = 0
      NWORDS = 2
      SEQGP  = .FALSE.
      A67777 = RSHIFT(LSHIFT(COMPLF(0),1),1)/10 - 10
      N 8 OR 16 = 8
      DO 40 I = 1,100
   40 OUTX(I) = BLANK
C
C     PROCESS ONE FIELD (2 OR 4 WORDS) AT A TIME,
C     GET FIRST NON-BLANK CHARATER
C
   50 IF (WORD .EQ. 18) GO TO 860
      FIELD  = FIELD + 1
      DECIML =.FALSE.
      MINUS  =.FALSE.
      EXPONT =.FALSE.
      DOUBLE =.FALSE.
      BLKON  =.FALSE.
      SIGN1  = BLANK1
      PLACES = 0
      IT     = 0
      POWER  = 0
C
C     READ 8 OR 16 CHARATERS OF ONE FIELD
C     FOR EACH CHARACTER, SET TYPE TO
C            0 IF IT IS A BLANK
C           -1 IF IT IS BCD CHARACTER, AND
C           +1 IF IT IS NUMERIC
C
      BASE = WORD*4
      WORD = WORD + NWORDS
      DO 110 N = 1,N 8 OR 16
      A1NB = A1(N+BASE)
      IF (A1NB .EQ. BLANK1) GO TO 70
      IF (A1NB .EQ. ZERO1 ) GO TO 80
      DO 60 K = 1,9
      IF (A1NB .EQ. NUM1(K)) GO TO 90
   60 CONTINUE
      TYPE(N) = -1
      GO TO 100
   70 TYPE(N) = 0
      GO TO 100
   80 K = 0
   90 TYPE(N) = 1
      VALUE(N)= K
  100 CHR1(N) = A1NB
      KHR1(N) = K1(N+BASE)
  110 CONTINUE
C
      IF (SEQGP) GO TO (120,120,690,120,690,120,690,120,690), FIELD
C
C     BRANCH ON BCD, BLANK, OR NUMERIC
C
  120 IF (TYPE(1)) 150,  130,    320
C                  BCD BLANK NUMERIC
C
C     A BLANK FIELD -
C     ===============
C
  130 IF (FIELD .EQ. 1) GO TO 180
  140 IOUT       = IOUT + 1
      OUTX(IOUT) = 0
      IFMT       = IFMT + 1
      FMT(IFMT)  = 0
      GO TO 50
C
C     BCD FIELD -
C     ===========
C
C     FIRST NON-BLANK CHARATER IS ALPHA, STAR, DOT, PLUS, OR MINUS
C
  150 IF (FIELD.EQ.1 .AND. CHR11.EQ.STAR1) GO TO 270
      IF (CHR11 .EQ. PLUS1 ) GO TO 290
      IF (CHR11 .EQ. DOT1  ) GO TO 300
      IF (CHR11 .EQ. MINUS1) GO TO 310
C
C     TRUE ALPHA BCD-CHARACTER FIELD
C
C     CHECKING FOR DOULBE-FIELD ASTERISK (*) IF WE ARE IN FIELD 1
C     SET DOUBLE FLAGS N8OR16, NWORDS, AND REMOVE THE ASTERISK
C
      IF (FIELD .NE. 1) GO TO 180
      J = 8
      DO 160 I = 2,8
      IF (CHR1(J).EQ.STAR1 .AND. TYPE(J).EQ.-1) GO TO 170
  160 J = J - 1
      GO TO 180
  170 NWORDS = 4
      N 8 OR 16 = 16
      CHR1(J) = BLANK1
      KHR1(J) = BLANKC
C
  180 IOUT = IOUT + 2
      IF (TYPE(1)) 190,200,190
  190 IF (NWORDS.EQ.4 .AND. FIELD.EQ.1) GO TO 200
      N = WORD - NWORDS
      OUT4(IOUT-1) = IN4(N+1)
      OUT4(IOUT  ) = IN4(N+2)
      GO TO 260
C
  200 OUT4(IOUT-1) = CHR4(1)
      OUT4(IOUT  ) = CHR4(2)
  260 IFMT = IFMT + 1
      FMT(IFMT) = 3
C
C     IF FIRST FIELD IS SEQGP OR SEQEP, SET SEQGP FLAG TO TRUE
C
      IF (FIELD.EQ.1 .AND. (D5.EQ.SEQGP5 .OR. D5.EQ.SEQEP5))
     1    SEQGP = .TRUE.
      GO TO 50
C
C     FIRST CHARATER ON CARD IS AN ASTERISK (*)
C
  270 NWORDS = 4
      N 8 OR 16 = 16
  280 IOUT = IOUT + 2
      OUTX(IOUT-1) = 0
      OUTX(IOUT  ) = 0
      IFMT = IFMT + 1
      FMT(IFMT) = 3
      GO TO 50
C
C     FIRST CHARATER IN FIELD IS A PLUS (+)
C     IGNOR IT AND ASSUMING REMAINING FIELD IS NUMBERIC
C
  290 IF (FIELD-1) 340,280,340
C
C     FIRST CHARATER IN FIELD IS A DOT (.)
C
  300 DECIML = .TRUE.
      PLACES = 0
      GO TO 340
C
C     FIRST CHARATER IN FIELD IS A MINUS (-)
C
  310 MINUS = .TRUE.
      GO TO 340
C
C     NUMERIC -  0 TO 9
C     =================
C
  320 IF (VALUE(1) .EQ. 0) GO TO 340
      NT(1) = VALUE(1)
      IT = 1
C
C     PROCESS REMAINING DIGITS
C
  340 DO 370 N = 2,N 8 OR 16
      IF (TYPE(N) .GT. 0) GO TO 360
C
C     A NON-NUMERIC CHARACTER ENCOUNTERED
C
      IF (CHR1(N) .NE. DOT1) GO TO 430
      IF (DECIML) GO TO 950
      PLACES = 0
      DECIML = .TRUE.
      GO TO 370
C
C     A NUMERIC CHARACTER, 0 TO 9, SAVE IT IN NT
C
  360 IT = IT + 1
      NT(IT) = VALUE(N)
      IF (DECIML) PLACES = PLACES + 1
  370 CONTINUE
C
C     IF DECIML IS .FALSE. NUMERIC IS AN INTEGER
C
      IF (DECIML) GO TO 570
C
C     INTEGER FOUND.  NASTRAN INTEGER LIMIT = 10*A67777
C
  390 NUMBER = 0
      IF (IT .EQ. 0) GO TO 410
      DO 400 I = 1,IT
      IF (NUMBER .GT. A67777) GO TO 930
  400 NUMBER = NUMBER*10 + NT(I)
  410 IF (MINUS) NUMBER = - NUMBER
  420 IOUT = IOUT + 1
      OUTX(IOUT) = NUMBER
      IFMT = IFMT + 1
      FMT(IFMT) = 1
      GO TO 50
C
C     PROBABLY WE JUST ENCOUNTERED (E, D, +, -) EXPONENT, OR BLANK
C
  430 IF (TYPE(N)) 460,440,460
C
C     IT IS A BLANK
C     THUS ONLY AN EXPONENT OR BLANKS PERMITTED FOR BALANCE OF FIELD
C
  440 IF (N .EQ. N 8 OR 16) GO TO 450
      N = N + 1
      IF (TYPE(N)) 460,440,970
C
C     FALL THRU ABOVE LOOP IMPLIES BALANCE OF FIELD WAS BLANKS
C
  450 IF (DECIML) GO TO 570
      GO TO 390
C
C     A NON-BLANK CHARACTER -
C     IT HAS TO BE A (+, -, D, OR E ) OF THE EXPONENT STRING
C
  460 EXPONT = .TRUE.
      IF (CHR1(N) .NE. PLUS1) GO TO 470
      SIGN1  = PLUS1
      GO TO 500
  470 IF (CHR1(N) .NE. E1) GO TO 480
      GO TO 500
  480 IF (CHR1(N) .NE. MINUS1) GO TO 490
      SIGN1  = MINUS1
      GO TO 500
  490 IF (CHR1(N) .NE. D1) GO TO 970
      DOUBLE = .TRUE.
C
C     READ INTEGER POWER, WITH OR WITHOUT SIGN
C
  500 IF (N .EQ. N 8 OR 16) GO TO 970
      N = N + 1
C
      IF (TYPE(N)) 510,500,520
  510 IF (CHR1(N).NE.PLUS1 .AND. CHR1(N).NE.MINUS1) GO TO 520
      IF (SIGN1 .NE. BLANK1) GO TO 970
      SIGN1 = CHR1(N)
      GO TO 500
C
C     FIRST DIGIT OF INTEGER POWER AT HAND NOW
C
  520 POWER = 0
      BLKON = .FALSE.
C
  530 IF (TYPE(N)) 970,970,540
  540 POWER = POWER*10 + VALUE(N)
C
C     GET ANY MORE DIGITS IF PRESENT
C
  550 IF (N .EQ. N 8 OR 16) GO TO 570
      N = N + 1
      IF (BLKON) IF (TYPE(N)) 990,550,990
      IF (TYPE(N)) 530,560,530
C
C     IS A BLANK.  BALANCE OF FIELD MUST BE BLANKS
C
  560 BLKON = .TRUE.
      GO TO 550
C
C     SINGLE OR DOUBLE PRECISION FLOATING POINT NUMBER
C     COMPLETE AND OUTPUT IT
C
C     15 SIGNIFICANT FIGURES POSSIBLE ON INPUT
C     CONSIDERED SINGLE PRECISION UNLESS D EXPONENT IS PRESENT
C
  570 IF (SIGN1 .EQ. MINUS1) POWER = -POWER
      POWER = POWER - PLACES
C
      NUMBER = 0
      IF (IT) 580,620,580
  580 IF (IT .LT. 7) GO TO 590
      N = 7
      GO TO 600
  590 N = IT
  600 DO 610 I = 1,N
  610 NUMBER = NUMBER*10 + NT(I)
  620 DDOUBL = DBLE(FLOAT(NUMBER))
      IF (IT .LE. 7) GO TO 640
      NUMBER = 0
      DO 630 I = 8,IT
  630 NUMBER = NUMBER*10 + NT(I)
      DDOUBL = DDOUBL*10.0D0**(IT-7) + DBLE(FLOAT(NUMBER))
  640 IF (MINUS) DDOUBL = -DDOUBL
C
C     CHECK FOR POWER IN RANGE OF MACHINE
C
      CHECK = POWER + IT
      IF (DDOUBL .EQ. 0.0D0) GO TO 660
      IF (CHECK.LT.LOWPW+1 .OR. CHECK.GT.HIGHPW-1 .OR.
     1    POWER.LT.LOWPW+1 .OR. POWER.GT.HIGHPW-1) GO TO 900
C
      DDOUBL = DDOUBL*10.0D0**POWER
  660 IFMT = IFMT + 1
      IF (DOUBLE) GO TO 670
      FPT  = DDOUBL
      IOUT = IOUT + 1
      OUTX(IOUT)= INTGR
      FMT(IFMT) = 2
      GO TO 50
  670 IOUT = IOUT + 2
      OUTX(IOUT-1) = IDOUBL(1)
      OUTX(IOUT  ) = IDOUBL(2)
      FMT(IFMT) = 4
      GO TO 50
C
C     FIRST CHARATER OF FIELD 3, 5, 7,  OR 9 ON SEQGP/SEQEP CARD
C     ENCOUNTERED. IT HAS TO BE A 1 TO 9 FOR NO ERROR
C
  690 DO 700 N = 1,N 8 OR 16
      IF (TYPE(N)) 1020,700,710
  700 CONTINUE
      GO TO 140
C
C     STORE NUMBER IN NT
C
  710 NPOINT = 0
  720 IT = IT + 1
      NT(IT) = VALUE(N)
  730 IF (N .EQ. N 8 OR 16) GO TO 800
      N = N + 1
C
C     GET NEXT CHARATER
C
      IF (NPOINT.GT.0 .AND. .NOT.DECIML .AND. .NOT.BLKON) GO TO 790
      IF (DECIML)  GO TO 770
      IF (BLKON )  GO TO 750
      IF (TYPE(N)) 740,740,720
  740 IF (CHR1(N) .EQ. DOT1) GO TO 760
  750 IF (TYPE(N) .NE.    0) GO TO 1020
      BLKON = .TRUE.
      GO TO 730
C
  760 DECIML = .TRUE.
      NPOINT = NPOINT + 1
      GO TO 730
C
  770 IF (TYPE(N)) 1020,1020,780
C
  780 DECIML = .FALSE.
      GO TO 720
C
  790 IF (CHR1(N).EQ.DOT1 .AND. TYPE(N).LT.0) GO TO 760
      GO TO 750
C
C     READY TO COMPUTE INTEGER VALUE OF SPECIAL SEQGP/SEQEP INTEGER
C
  800 NPOINT = 3 - NPOINT
      IF (NPOINT) 1020,830,810
  810 DO 820 K = 1,NPOINT
      IT = IT + 1
  820 NT(IT) = 0
C
C     COMPUTE NUMBER.  NASTRAN INTEGER LIMIT = 10*A67777
C
  830 NUMBER = 0
      IF (IT) 840,420,840
  840 DO 850 K = 1,IT
      IF (NUMBER .GT. A67777) GO TO 1040
      NUMBER = NUMBER*10 + NT(K)
  850 CONTINUE
      GO TO 420
C
C     ALL FIELDS PROCESSED
C
  860 NFLAG = IOUT
      FMT(IFMT+1) = -1
C
C     CONVERT CHARACTERS TO BCD, AND INSERT NUMERIC VALUES IF
C     APPLICABLE
C
      N = 1
      DO 890 I = 1,NFLAG,25
      K = I + 24
      TMP100 = OUT100(N)
      CALL KHRBC1 (TMP100,OUT(I))
      DO 880 J = I,K
      IF (OUTX(J) .NE. BLANK) OUT(J)=OUTX(J)
  880 CONTINUE
  890 N = N + 1
      RETURN
C
C     ERROR
C
  900 WRITE  (NOUT,910) UFM
  910 FORMAT (A23,' 300, DATA ERROR IN FIELD UNDERLINED.')
      WRITE  (NOUT,920)
  920 FORMAT (10X,'FLOATING POINT NUMBER OUT OF MACHINE RANGE')
      WRITE  (NOUT,925) POWER,IT,CHECK,LOWPW,HIGHPW
  925 FORMAT (10X,'POWER,IT,CHECK,LOWPW,HIGHPW =',5I5)
      GO TO  1060
  930 WRITE  (NOUT,910) UFM
      WRITE  (NOUT,940)
  940 FORMAT (10X,'INTEGER MAGNITUDE OUT OF MACHINE RANGE')
      GO TO  1060
  950 IF (XSORT2 .EQ. 2) GO TO 50
      WRITE  (NOUT,910) UFM
      WRITE  (NOUT,960)
  960 FORMAT (10X,'DATA NOT RECOGNIZEABLE')
      GO TO  1060
  970 EXPONT = .FALSE.
      IF (XSORT2 .EQ. 2) GO TO 50
      WRITE  (NOUT,910) UFM
      WRITE  (NOUT,980)
  980 FORMAT (10X,'POSSIBLE ERROR IN EXPONENT')
      GO TO  1060
  990 IF (XSORT2 .EQ. 2) GO TO 50
      WRITE  (NOUT,910) UFM
      WRITE  (NOUT,1000)
 1000 FORMAT (10X,'POSSIBLE IMBEDDED BLANK')
      GO TO  1060
 1020 IF (XSORT2 .EQ. 2) GO TO 50
      WRITE  (NOUT,910) UFM
      WRITE  (NOUT,1030)
 1030 FORMAT (10X,'INCORRECT DEWEY DECIMAL NUMBER')
      GO TO  1060
 1040 IF (XSORT2 .EQ. 2) GO TO 50
      WRITE  (NOUT,910) UFM
      WRITE  (NOUT,1050)
 1050 FORMAT (10X,'INTERNAL CONVERSION OF DEWEY DECIMAL IS TOO LARGE')
 1060 DO 1070 J = 1,20
      IF (OUTX(J) .NE. STARS) OUTX(J) = BLANK
 1070 CONTINUE
      WORD = (FIELD-1)*NWORDS + 2
      K = STARS
 1080 OUTX(WORD  ) = K
      OUTX(WORD-1) = K
      IF (NWORDS.EQ.2 .OR. FIELD.EQ.1) GO TO 1090
      OUTX(WORD-2) = K
      OUTX(WORD-3) = K
 1090 IF (K .EQ. 0) GO TO 1150
      IF (NWORDS .EQ. 4) GO TO 1110
      WRITE  (NOUT,1100)
 1100 FORMAT (10X,'---1--- +++2+++ ---3--- +++4+++ ---5--- +++6+++ ',
     1            '---7--- +++8+++ ---9--- +++10+++')
      GO TO  1130
 1110 WRITE  (NOUT,1120)
 1120 FORMAT (10X,'---1--- +++++2+&+3+++++ -----4-&-5----- +++++6+&',
     1            '+7+++++ -----8-&-9----- +++10+++')
 1130 WRITE  (NOUT,1140) (IN4(I),I=1,20),OUTX
 1140 FORMAT (10X,20A4)
      NLINES = NLINES + 7
      K = 0
      GO TO  1080
 1150 IOUT = IOUT + 1
      OUTX(IOUT) = 0
      IFMT = IFMT + 1
      FMT(IFMT) = -1
      NOGO =.TRUE.
      GO TO 50
C
      END

      SUBROUTINE HDSURF (GPLST,X,U,PEN,DEFORM,NMAX,MAXSF,IZ,IB,PEDGE,
     1                   IOPCOR)
C
C     THIS ROUTINE PREPARES THE ELEMENT SURFACES FOR HIDDEN LINE PLOT
C     IT ALSO GENERATES THE SHRINK PLOT IF SHRINK ALONE IS REQUESTED.
C     IF SHRINK AND HIDDEN ARE REQUESTED, THIS ROUTINE WILL PREPARE THE
C     SHRUNK SURFACES FOR HDPLOT.
C
C     REVISED  10/1990 BY G.CHAN/UNISYS
C     (1) HIDDEN PLOT WITH SOLID ELEMENTS BUGS
C     (2) HIDDEN AND SHRINK TOGETHER
C     (3) SKIP ANY OFFSET DATA IN ELSET FILE IF THEY ARE PRESENT
C
      LOGICAL         SHRINK,HIDDEN
      INTEGER         GPLST(1),PEN,DEFORM,PEDGE,ETYP,G,NAME(2),GP,ELID,
     1                ELSET,IZ(14,1),M1(16),LDX(9),FILE,SOLID,TEMP(27),
     2                OFFSET
      REAL            X(3,1),U(2,1)
      COMMON /BLANK / NGP,SKP11(11),ELSET,SKP22(7),MERR,IDUM(3),NSCR1,
     1                NSCR2,NSCR3
      COMMON /SYSTEM/ IBUF,IOUT
      COMMON /PLTSCR/ NNN,G(3)
      COMMON /HDREC / NOFSUR,NS,ELID,LID,NPERS,P(3,13)
C
C     DIMENSIONS      TEMP, IZ, AND P ARE TEMP(2*N+1), IZ(N+1,1), AND
C                     P(3,N) WHERE N=LETSZ2=MAX OF LETSZ(2,I), I=1,9
C
      DIMENSION       LET1(5),LET2(4,4),LET3(5,5),LET4(5,6),LET5(9,6),
     1                LET6(13,6),LET7(5),LET8(7),LET9(9),LET(229),
     2                LETSZ(3,9)
      EQUIVALENCE     (LET(  1),LET1(  1)), (LET(  6),LET2(1,1)),
     1                (LET( 22),LET3(1,1)), (LET( 47),LET4(1,1)),
     2                (LET( 77),LET5(1,1)), (LET(131),LET6(1,1)),
     3                (LET(209),LET7(  1)), (LET(214),LET8(  1)),
     4                (LET(221),LET9(  1))
C
      DATA    NAME  / 4HHDSU, 4HRF   / ,
     1        NM1,M1/ 16,4H(33X, 4H,13H, 4HELEM, 4HENT , 4HTYPE, 4H A5,,
     2        4H4HWI, 4HTHI8, 4H,24H, 4H GRI, 4HDS S, 4HKIPP, 4HED I,
     3        4HN LI, 4HNEL., 4H)    /
C
C     SPECIAL ELEMENT CONNECTION PATTERNS
C
      DATA    LDX   / 2HD1,2HD2,2HD3,2HD4,2HD5,2HD6,2HD7,2HD8,2HD9  /
      DATA    KTET  / 2HTE /,   KWEG  / 2HWG /,    KHX1  / 2HH1 /,
     1        KHX2  / 2HH2 /,   KIX1  / 2HXL /,    KIX2  / 2HXQ /,
     2        KIX3  / 2HXC /,   KAE   / 2HAE /,    KTRIM6/ 2HT6 /,
     3        KTRPLT/ 2HP6 /,   KTRSHL/ 2HSL /,    KIS2D8/ 2HD8 /,
     4        KFHEX1/ 2HFA /,   KFHEX2/ 2HFB /,    KFTETA/ 2HFT /,
     5        KFWEDG/ 2HFW /,   KBAR  / 2HBR /,    KT3   / 2HT3 /,
     6        KQ4   / 2HQ4 /
C    7        KELBOW/ 2HEB /
C
C     1   -   LINE,TRIANGLE,QUAD    5   -   IHEXA2
C     2   -   TETRA                 6   -   IHEXA3
C     3   -   WEDGE                 7   -   AERO
C     4   -   HEXA                  8   -   TRIM6 AND TRPLT1 AND TRSHL
C
      DATA    LETSZ2/ 13 /
      DATA    LETSZ /
     1         1,      5,     1,
     2         4,      4,     6,
     3         5,      5,    22,
     4         6,      5,    47,
     5         6,      9,    77,
     6         6,     13,   131,
     7         1,      5,   209,
     8         1,      7,   214,
     9         1,      9,   221/
C         NELSRF,   NPTS,    IS
      DATA    LET1  /
     1         1,  2,  3,  4,  5/
      DATA    LET2  /
     1         1,  2,  3,  1,
     2         1,  2,  4,  1,
     3         2,  3,  4,  2,
     4         1,  3,  4,  1/
      DATA    LET3  /
     1         1,  2,  3,  1,  0,
     2         4,  5,  6,  4,  0,
     3         1,  3,  6,  4,  1,
     4         1,  2,  5,  4,  1,
     5         2,  3,  6,  5,  2/
      DATA    LET4  /
     1         1,  2,  3,  4,  1,
     2         5,  6,  7,  8,  5,
     3         3,  4,  8,  7,  3,
     4         1,  2,  6,  5,  1,
     5         2,  3,  7,  6,  2,
     6         1,  4,  8,  5,  1/
      DATA    LET5  /
     1         1,  2,  3,  4,  5,  6,  7,  8,  1,
     2        13, 14, 15, 16, 17, 18, 19, 20, 13,
     3         3, 10, 15, 16, 17, 11,  5,  4,  3,
     4         5, 11, 17, 18, 19, 12,  7,  6,  5,
     5         7, 12, 19, 20, 13,  9,  1,  8,  7,
     6         1,  2,  3, 10, 15, 14, 13,  9,  1/
      DATA    LET6  /
     1         1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12,  1,
     2        21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 21,
     3         4,  5,  6,  7, 15, 19, 27, 26, 25, 24, 18, 14,  4,
     4         7,  8,  9, 10, 16, 20, 30, 29, 28, 27, 19, 15,  7,
     5        10, 11, 12,  1, 13, 17, 21, 32, 31, 30, 20, 16, 10,
     6         1,  2,  3,  9, 14, 18, 24, 23, 22, 21, 17, 13,  1/
      DATA    LET7  /
     1         1,  2,  3,  4,  1/
      DATA    LET8  /
     1         1,  2,  3,  4,  5,  6,  1/
      DATA    LET9  /
     1         1,  5,  2,  6,  3,  7,  4,  8,  1/
C
C     PEDGE FLAG = 2 OR 200    - HIDDEN LINE PLOT
C                = 10 THRU 100 - SHRINK PLOT.
C                = 100         - FILL, NOT USED HERE
C                = .GT.    200 - SHRINK AND HIDDEN LINE PLOT
C     E.G. PEDGE = 270 INDICATES HIDDEN LINE PLOT WITH EACH ELEMENT
C                  SHRUNK TO 70 PERCENT OF FULL SIZE.
C
      IPEDGE = MOD(PEDGE,200)
      NWDS   = 0
      NMAX   = 0
      LS     = 0
      LSMAX  = IOPCOR/14
      IF (PEDGE .GT. 200) LSMAX = 0
      NOFSUR = 0
      SHK    = 1.0
      SHRINK = .FALSE.
      IF (PEDGE .LT. 10) GO TO 10
      SHRINK = .TRUE.
      SHK = 1. - FLOAT(IPEDGE)/100.
      CALL LINE (0.,0.,0.,0.,1.,-1)
   10 HIDDEN = .FALSE.
      IF (PEDGE.NE.2 .AND. PEDGE.LT.200) GO TO 20
      HIDDEN = .TRUE.
      CALL GOPEN (NSCR2,GPLST(IB),1)
      NWDS = 3*LETSZ2 + 5
C
   20 CALL READ (*310,*190,ELSET,ETYP,1,0,I)
      CALL FREAD (ELSET,I,1,0)
      NGPEL  = IABS(I)
      NGPELX = NGPEL
      SOLID  = 0
C
      OFFSET = 0
      IF (ETYP .EQ. KBAR) OFFSET = 6
      IF (ETYP.EQ.KT3 .OR. ETYP.EQ.KQ4) OFFSET = 1
      ITYPE = 1
      IF (ETYP .EQ. KTET    ) ITYPE = 2
      IF (ETYP .EQ. KFTETA  ) ITYPE = 2
      IF (ETYP .EQ. KWEG    ) ITYPE = 3
      IF (ETYP .EQ. KFWEDG  ) ITYPE = 3
      IF (ETYP .EQ. KHX1   .OR. ETYP .EQ. KHX2 .OR. ETYP .EQ. KIX1 .OR.
     1    ETYP .EQ. KFHEX1 .OR. ETYP .EQ. KFHEX2) ITYPE = 4
      IF (ETYP .EQ. KIX2    ) ITYPE = 5
      IF (ETYP .EQ. KIS2D8  ) ITYPE = 9
      IF (ETYP .EQ. KIX3    ) ITYPE = 6
      IF (ETYP .EQ. KAE     ) ITYPE = 7
      IF (ETYP .EQ. KTRIM6 .OR. ETYP .EQ. KTRPLT .OR. ETYP .EQ. KTRSHL)
     1    ITYPE = 8
C
      IF (ITYPE .NE. 1) GO TO 40
C
C     SIMPLE ELEMENT
C
      IF (NGPEL.GT.2 .AND. I.GT.0) NGPELX = NGPEL + 1
      IF (NGPEL .GT. 4) GO TO 130
      NPTS = NGPELX
      GO TO 50
C
C     COMPLEX ELEMENT
C
   40 CONTINUE
      IF (ITYPE.GE.2 .AND. ITYPE.LE.6) SOLID = 1
      NPTS = LETSZ(2,ITYPE)
   50 IF (NPTS-1 .GT. NMAX) NMAX = NPTS - 1
C
C     READ THE ELEMENT DATA
C
   60 CALL FREAD (ELSET,ELID,1,0)
      IF (ELID .LE. 0) GO TO 20
      CALL FREAD (ELSET,LID,1,0)
      CALL FREAD (ELSET,G,NGPEL,0)
      IF (OFFSET .NE. 0) CALL FREAD (ELSET,0,-OFFSET,0)
      IF (NGPEL .NE. NGPELX) G(NGPELX) = G(1)
      IF (HIDDEN .AND. .NOT.SHRINK) GO TO 80
      XC = 0.
      YC = 0.
      ZC = 0.
      DO 70 I = 1,NGPEL
      GP = G(I)
      GP = IABS(GPLST(GP))
      XC = XC + X(2,GP)
      YC = YC + X(3,GP)
      ZC = ZC + X(1,GP)
   70 CONTINUE
      XC = XC/NGPEL
      YC = YC/NGPEL
      ZC = ZC/NGPEL
C
   80 NELSRF = LETSZ(1,ITYPE)
      IS = LETSZ(3,ITYPE)
C
      DO 120 NS = 1,NELSRF
      NN = 0
      MM = (NS-1)*NPTS + IS - 1
      NPERS = NPTS
      DO 110 I = 1,NPTS
      M = MM + I
      N = LET(M)
      IF (N .NE. 0) GO TO 85
   82 NPERS = NPERS - 1
      GO TO 110
   85 GP = G(N)
      IF (GP .EQ. 0) GO TO 82
      NN = NN + 1
      GP = IABS(GPLST(GP))
      P(3,NN) = X(1,GP)
      IF (DEFORM .NE. 0) GO TO 90
      P(1,NN) = X(2,GP)
      P(2,NN) = X(3,GP)
      GO TO 100
   90 P(1,NN) = U(1,GP)
      P(2,NN) = U(2,GP)
  100 CONTINUE
      IF (.NOT.SHRINK) GO TO 110
      IF (     HIDDEN) GO TO 105
      IF (NN .EQ. 1) GO TO 110
      X1 = P(1,NN-1) - (P(1,NN-1)-XC)*SHK
      Y1 = P(2,NN-1) - (P(2,NN-1)-YC)*SHK
      X2 = P(1,NN  ) - (P(1,NN  )-XC)*SHK
      Y2 = P(2,NN  ) - (P(2,NN  )-YC)*SHK
      IPEN = PEN
      IF (IPEDGE.EQ.100 .AND. PEN.GT.31 .AND. I.EQ.NPERS) PEN = 0
      IF (SHRINK) CALL LINE (X1,Y1,X2,Y2,PEN,0)
      IF (PEN .EQ. 0) PEN = IPEN
      GO TO 110
  105 P(3,NN) = X(1,GP) - (X(1,GP)-ZC)*SHK
      P(1,NN) = X(2,GP) - (X(2,GP)-XC)*SHK
      P(2,NN) = X(3,GP) - (X(3,GP)-YC)*SHK
      IF (DEFORM .EQ. 0) GO TO 110
      P(1,NN) = U(1,GP) - (X(2,GP)-XC)*SHK
      P(2,NN) = U(2,GP) - (X(3,GP)-YC)*SHK
  110 CONTINUE
      IF (SHRINK .AND. .NOT.HIDDEN) GO TO 120
      CALL WRITE (NSCR2,NOFSUR,NWDS,0)
      NOFSUR = NOFSUR + 1
      IF (SOLID.EQ.0 .OR. .NOT.HIDDEN) GO TO 120
C
C     SAVE SOLID SURFACE DATA IN IZ SPACE FOR SECOND PROCESSING, HIDDEN
C     PLOT ONLY. SAVE AS MANY AS OPEN CORE CAN HOLD
C
      IF (LS .GE. LSMAX) GO TO 120
      LS = LS + 1
      NPS1 = NPERS - 1
      DO 112 I = 1,NPS1
      M  = MM + I
      N  = LET(M)
      GP = G(N)
      TEMP(I     ) = GP
  112 TEMP(I+NPS1) = GP
      M  = 1
      MIN= TEMP(1)
      DO 114 I = 2,NPS1
      IF (TEMP(I) .GE. MIN) GO TO 114
      M  = I
      MIN= TEMP(I)
  114 CONTINUE
      IF (M .EQ. 1) M = M + NPS1
      N = + 1
      IF (TEMP(M-1) .LT. TEMP(M+1)) N = -1
      IF (N.EQ.-1  .AND. M.LT.NPS1) M = M + NPS1
      K = NPS1 + 2
      DO 116 I = 3,K
      IZ(I,LS) = TEMP(M)
  116 M = M + N
      IZ(1,LS) = NOFSUR
      IZ(2,LS) = NPS1
C
  120 CONTINUE
      GO TO 60
C
C     CHECK FOR PDUM ELEMENTS BEFORE  EJECTING
C
  130 DO 135 I = 1,9
      IF (ETYP .EQ. LDX(I)) GO TO 160
  135 CONTINUE
C
C     ILLEGAL ELEMENT, NO CORE FOR 1 ELEMENT
C
  140 G(1) = 2
      G(2) = ETYP
      G(3) = NGPEL
      CALL WRTPRT (MERR,G,M1,NM1)
C
C     READ TO THE END OF THIS ELEMENT
C
  150 CALL READ (*180,*20,ELSET,ELID,1,0,M)
      IF (ELID .LE. 0) GO TO 20
      J = 1 + NGPEL + OFFSET
      CALL FREAD (ELSET,0,-J,0)
      GO TO 150
  160 WRITE  (IOUT,170) I
  170 FORMAT ('0*** MISSING PDUM',I1,' SUBROUTINE/HDSURF')
      GO TO 140
  180 CALL MESAGE (-8,ELSET,NAME)
C
  190 CONTINUE
      MAXSF = NOFSUR
      CALL BCKREC (ELSET)
      IF (SHRINK) CALL LINE (0.,0.,0.,0.,1.,+1)
      IF (.NOT.HIDDEN) GO TO 300
      CALL WRITE (NSCR2,0,0,1)
      IF (LS .LT. 60) GO TO 280
C
C     REPROCESS NSCR2 TO REMOVE DUPLICATE SURFACES (INTERIOR-INTERFACES)
C     AND SAVE REDUCED DATA IN NSCR1.
C     INTERCHANGE NSCR1 AND NSCR2 INDICES
C
      J = (LETSZ2+1)*LS
      CALL SORT2K (0,0,LETSZ2+1,3,IZ,J)
      M = 0
      NPS1 = 0
      DO 240 I = 1,LS
      NPS2 = IZ(2,I) + 2
      IF (NPS2 .EQ. NPS1) GO TO 200
      NPS1 = NPS2
      GO TO 240
  200 IM1  = I - 1
      DO 210 J = 3,NPS1
      IF (IZ(J,I) .NE. IZ(J,IM1)) GO TO 240
  210 CONTINUE
      IF (M .EQ. 0) GO TO 220
      IF (IZ(M,1) .EQ. IZ(1,IM1)) GO TO 230
  220 M = M + 1
      IZ(M,1) = IZ(1,IM1)
  230 M = M + 1
      IZ(M,1) = IZ(1,I)
  240 CONTINUE
C
      IF (M .LT. 20) GO TO 280
      CALL SORT (0,0,1,1,IZ,M)
      IZ(M+1,1) = 999999999
      FILE = NSCR1
      CALL GOPEN (NSCR1,GPLST(IB+IBUF),1)
      FILE = NSCR2
      CALL CLOSE (NSCR2,1)
      CALL GOPEN (NSCR2,GPLST(IB),0)
      N = 1
      DO 270 I = 1,MAXSF
      CALL READ (*320,*330,NSCR2,NOFSUR,NWDS,0,J)
      IF (I-IZ(N,1)) 250,260,260
  250 CALL WRITE (NSCR1,NOFSUR,NWDS,0)
      GO TO 270
  260 N = N + 1
  270 CONTINUE
C
      CALL CLOSE (NSCR2,1)
      J = NSCR2
      NSCR2 = NSCR1
      NSCR1 = J
      MAXSF = MAXSF - M
      CALL WRITE (NSCR2,0,0,1)
  280 CALL CLOSE (NSCR2,1)
  300 RETURN
C
  310 J = -1
      FILE = ELSET
      GO TO 340
  320 J = -2
      GO TO 340
  330 J = -3
  340 CALL MESAGE (J,FILE,NAME)
      GO TO 190
      END

      SUBROUTINE FERXTD (V1,V2,V3,V4,V5,ZB,IFN)
C
C     FERXTD is a modification of the old subroutine FNXTVC.  The
C     modification allows for reading the orthogonal vectors and the
C     SMA and LT matrices from memory instead of from files.  The
C     SMA and LT matrices may be partially in memory and part read
C     from the file.
C     FERXTD OBTAINS THE REDUCED TRIDIAGONAL MATRIX B WHERE FERFBD
C     PERFORMS THE OPERATIONAL INVERSE.   (DOUBLE PREC VERSION)
C
C           T   -
C      B = V  * A  * V
C
C     V1  = SPACE FOR THE PREVIOUS CURRENT TRIAL VECTOR. INITALLY NULL
C     V2  = SPACE FOR THE CURRENT TRIAL VECTOR. INITIALLY A PSEUDO-
C           RANDOM START VECTOR
C     V3,V4,V5 = WORKING SPACES FOR THREE VECTORS
C     IFN = NO. OF TRIAL VECOTRS EXTRACTED. INITIALLY ZERO.
C     SEE FEER FOR DEFINITIONS OF OTHER PARAMETERS. ALSO PROGRAMMER'S
C           MANUAL PP. 4.48-19G THRU I
C
C     REAL*16, MARKED BY 'CQ', WAS TRIED FOR IMPROVED ACCURACY. BUT THE
C     REAL*16  OPERATIONS ON VAX WERE 10 TIMES SLOWER THAN REAL*8
C     (NUMERIC ACCURACY IS VERY IMPORTANT IN THIS SUBROUTINE)
C
      INTEGER            SYSBUF    ,CNDFLG   ,SR5FLE   ,NAME(5)  ,
     1                   VCDOT     ,SMAPOS   ,EOFNRW
      DOUBLE PRECISION   V1(1)     ,V2(1)    ,V3(1)    ,V4(1)    ,
     1                   V5(1)     ,LMBDA    ,LAMBDA   ,B(2)     ,
     2                   ZERO      ,ZB(1)
CQ    REAL*16            D         ,DB       ,DSQ      ,SD       ,
      DOUBLE PRECISION   ZD
      DOUBLE PRECISION   D         ,DB       ,DSQ      ,SD       ,
     1                   AII       ,DBI      ,DEPX     ,DEPX2    ,
     2                   SDMAX     ,DTMP     ,OPDEPX   ,OMDEPX
      CHARACTER          UFM*23    ,UWM*25
      COMMON   /ZZZZZZ/  ZD(1)
      COMMON   /FEERIM/  NIDSMA    ,NIDLT    ,NIDORV   ,NLTLI
     1,                  NSMALI    ,IBFSMA   ,IBFLT
     2,                  IBFORV    ,SMAPOS(7),LTPOS(7)
      COMMON   /XMSSG /  UFM       ,UWM
      COMMON   /FEERCX/  IFKAA(7)  ,IFMAA(7) ,IFLELM(7),IFLVEC(7),
     1                   SR1FLE    ,SR2FLE   ,SR3FLE   ,SR4FLE   ,
     2                   SR5FLE    ,SR6FLE   ,SR7FLE   ,SR8FLE   ,
     3                   DMPFLE    ,NORD     ,XLMBDA   ,NEIG     ,
     4                   MORD      ,IBK      ,CRITF    ,NORTHO   ,
     5                   IFLRVA    ,IFLRVC
      COMMON   /FEERXX/  LAMBDA    ,CNDFLG   ,ITER     ,TIMED    ,
     1                   L16       ,IOPTF    ,EPX      ,ERRC     ,
     2                   IND       ,LMBDA    ,IFSET    ,NZERO    ,
     3                   NONUL     ,IDIAG    ,MRANK    ,ISTART
      COMMON   /SYSTEM/  KSYSTM(65)
      COMMON   /OPINV /  MCBLT(7)  ,MCBSMA(7),MCBVEC(7),MCBRM(7)
      COMMON   /UNPAKX/  IPRC      ,II       ,NN       ,INCR
      COMMON   /PACKX /  ITP1      ,ITP2     ,IIP      ,NNP      ,
     1                   INCRP
      COMMON   /NAMES /  RD        ,RDREW    ,WRT      ,WRTREW   ,
     1                   REW       ,NOREW    ,EOFNRW
      EQUIVALENCE        (KSYSTM(1),SYSBUF)  ,(KSYSTM(2),IO)
      DATA      NAME  /  4HFERX    ,4HTD     ,2*4HBEGN ,4HEND    /
      DATA      VCDOT ,  ZERO /     4HVC.    ,0.0D+0             /
C
C     SR5FLE CONTAINS THE REDUCED TRIDIAGONAL ELEMENTS
C
C     SR6FLE CONTAINS THE G VECTORS
C     SR7FLE CONTAINS THE ORTHOGONAL  VECTORS
C     SR8FLE CONTAINS THE CONDITIONED MAA MATRIX
C
      IF (MCBLT(7) .LT. 0) NAME(2) = VCDOT
      NAME(3) = NAME(4)
      CALL CONMSG (NAME,3,0)
      ITER  = ITER + 1
      IPRC  = 2
      INCR  = 1
      INCRP = INCR
      ITP1  = IPRC
      ITP2  = IPRC
      IFG   = MCBRM(1)
      IFV   = MCBVEC(1)
      DEPX  = EPX
      DEPX2 = DEPX**2
      OPDEPX= 1.0D+0 + DEPX
      OMDEPX= 1.0D+0 - DEPX
CQ    OPDEPX= 1.0Q+0 + DEPX
CQ    OMDEPX= 1.0Q+0 - DEPX
      D     = ZERO
      NORD1 = NORD - 1
C
C     NORMALIZE START VECTOR
C
      DSQ = ZERO
      IF (IOPTF .EQ. 1) GO TO 20
      CALL FERLTD (MCBSMA(1),V2(1),V3(1),V5(1))
      DO 10 I = 1,NORD
   10 DSQ = DSQ + V2(I)*V3(I)
      GO TO 40
   20 DO 30 I = 1,NORD
   30 DSQ = DSQ + V2(I)*V2(I)
   40 DSQ = 1.0D+0/DSQRT(DSQ)
CQ 40 DSQ = 1.0D+0/QSQRT(DSQ)
      DO 50 I = 1,NORD
   50 V2(I) = V2(I)*DSQ
      IF (NORTHO .EQ. 0) GO TO 200
C
C     ORTHOGONALIZE WITH PREVIOUS VECTORS
C
      DO 60 I = 1,NORD
   60 V3(I) = V2(I)
C
C     READ ORTHOGONAL VECTORS INTO MEMORY IF SPACE EXISTS
C
      IF ( NIDORV .EQ. 0 ) GO TO 70
      IF ( NORTHO .EQ. 0 ) GO TO 70
      CALL GOPEN ( IFV, ZB(1), RDREW )
      II = 1
      NN = NORD
      NIDX = NIDORV/2 + 1 
      DO 65 IC = 1, NORTHO
      ILOC = ( IC-1 ) * NORD + NIDX
      CALL UNPACK ( *65, IFV, ZD( ILOC ) )
   65 CONTINUE
      CALL CLOSE ( IFV, EOFNRW )
C
C     BEGINNING OF ITERATION LOOP
C   
   70 DO 170 IX = 1,14
      NONUL = NONUL + 1
      IF (IOPTF .EQ. 0) 
     &  CALL FERLTD (MCBSMA(1),V2(1),V3(1),V5(1))
      IF ( NIDORV .NE. 0 ) GO TO 1000
C     
C  READ ORTHOGONAL VECTORS FROM FILE
C
      CALL GOPEN (IFV,ZB(1),RDREW)        
      SDMAX = ZERO
      DO 110 IY = 1,NORTHO
      II = 1
      NN = NORD
      SD = ZERO
      CALL UNPACK (*90,IFV,V5(1))
      DO 80 I = 1,NORD
      SD = SD + V3(I)*V5(I)
   80 CONTINUE
   90 IF (DABS(SD) .GT. SDMAX) SDMAX = DABS(SD)
CQ 90 IF (QABS(SD) .GT. SDMAX) SDMAX = QABS(SD)
      DO 100 I = 1,NORD
  100 V2(I) = V2(I) - SD*V5(I)
  110 CONTINUE
      CALL CLOSE (IFV,EOFNRW)
      GO TO 2000
C
C ORTHOGONAL VECTORS ARE IN MEMORY
C 
 1000 CONTINUE
      SDMAX = ZERO
      NIDX  = NIDORV/2 + 1 
      DO 1110 IY = 1, NORTHO
      SD    = ZERO
      ILOC  = (IY-1)*NORD + NIDX - 1 
      DO 1080 I = 1, NORD
      SD    = SD + V3(I)*ZD(ILOC+I)
 1080 CONTINUE
      IF ( DABS( SD ) .GT. SDMAX ) SDMAX = DABS( SD )
      DO 1100 I = 1, NORD
      V2(I) = V2(I) - SD*ZD(ILOC+I)
 1100 CONTINUE
 1110 CONTINUE
 2000 CONTINUE
      DSQ = ZERO
      IF (IOPTF .EQ. 1) GO TO 130
      CALL FERLTD (MCBSMA(1),V2(1),V3(1),V5(1))
      DO 120 I = 1,NORD1
  120 DSQ = DSQ + V2(I)*V3(I)
      GO TO 150
  130 DO 140 I = 1,NORD1
  140 DSQ = DSQ + V2(I)*V2(I)
C
C 150 IF (DSQ .LT. DEPX2) GO TO 500
C
C     COMMENTS FORM G.CHAN/UNISYS ABOUT DSQ AND DEPX2 ABOVE,   1/92
C
C     DEPX2 IS SQUARE OF EPX. ORIGINALLY SINCE DAY 1, EPX (FOR VAX AND
C     IBM) IS 10.**-14 AND THEREFORE DEPX2 = 10.**-28. (10.**-24 FOR
C     THE 60/64 BIT MACHINES, USING S.P. COMPUTATION)
C     (EPX WAS SET TO 10.**-10 FOR ALL MACHINES, S.P. AND D.P., 1/92)
C
C     NOTICE THAT DSQ IS THE DIFFERENCE OF TWO CLOSE NUMERIC NUMBERS.
C     THE FINAL VAULES OF DSQ AND THE PRODUCT OF V2*V2 OR V2*V3 APPROACH
C     ONE ANOTHER, AND DEFFER ONLY IN SIGN. THEREFORE, THE NUMBER OF
C     DIGITS (MANTISSA) AS WELL AS THE EXPONENT ARE IMPORTANT HERE
C     (PREVIOUSLY, DO LOOPS 120 AND 140 COVERED 1 THRU NORD)
C
C     MOST OF THE 32 BIT MACHINES HOLD 15 DIGIT IN D.P. WORD, AND SAME
C     FOR THE 64 BIT MACHINES USING S.P. WORD. THEREFORE, CHECKING DSQ
C     DOWN TO 10.**-28 (OR 10.**-24) IS BEYOND THE HARDWARE LIMITS.
C     THIS MAY EXPLAIN SOME TIMES THE RIGID BODY MODES (FREQUENCY = 0.0)
C     GO TO NEGATIVE; IN SOME INSTANCES REACHING -1.E+5 RANGE
C
C     NEXT 7 LINES TRY TO SOLVE THE ABOVE DILEMMA
C
  150 D = V3(NORD)
      IF (IOPTF .EQ. 1) D = V2(NORD)
      D = V2(NORD)*D
      DTMP = DSQ
      DSQ  = DSQ + D
      IF (DSQ .LT. DEPX2) GO TO 500
      DTMP = DABS(D/DTMP)
CQ    DTMP = QABS(D/DTMP)
      IF (DTMP.GT.OMDEPX .AND. DTMP.LT.OPDEPX) GO TO 500
      D = ZERO
C
      DSQ = DSQRT(DSQ)
CQ    DSQ = QSQRT(DSQ)
      IF (L16 .NE. 0) WRITE (IO,620) IX,SDMAX,DSQ
      DSQ = 1.0D+0/DSQ
      DO 160 I = 1,NORD
      V2(I) = V2(I)*DSQ
  160 V3(I) = V2(I)
      IF (SDMAX .LT. DEPX) GO TO 200
  170 CONTINUE
C
      GO TO 500
  200 IF (IFN .NE. 0) GO TO 300
C
C     SWEEP START VECTOR FOR ZERO ROOTS
C
      DSQ = ZERO
      IF (IOPTF .EQ. 1) GO TO 220
      CALL FERSWD (V2(1),V3(1),V5(1))
      CALL FERLTD (MCBSMA(1),V3(1),V4(1),V5(1))
      DO 210 I = 1,NORD
  210 DSQ = DSQ + V3(I)*V4(I)
      GO TO 240
  220 CONTINUE
      CALL FERFBD (V2(1),V4(1),V3(1),V5(1))
      DO 230 I = 1,NORD
  230 DSQ = DSQ + V3(I)*V3(I)
  240 DSQ = 1.0D+0/DSQRT(DSQ)
CQ240 DSQ = 1.0D+0/QSQRT(DSQ)
      DO 250 I = 1,NORD
  250 V2(I) = V3(I)*DSQ
      GO TO 320
C
C     CALCULATE OFF DIAGONAL TERM OF B
C
  300 D = ZERO
      DO 310 I = 1,NORD
  310 D = D + V2(I)*V4(I)
C
C     COMMENTS FROM G.CHAN/UNISYS 1/92
C     WHAT HAPPENS IF D IS NEGATIVE HERE? NEXT LINE WOULD BE ALWAY TRUE.
C
      IF (D .LT. DEPX*DABS(AII)) GO TO 500
CQ    IF (D .LT. DEPX*QABS(AII)) GO TO 500
  320 CALL GOPEN (IFG,ZB(1),WRT)
      IIP = 1
      NNP = NORD
      IF (IOPTF .EQ. 1) GO TO 330
      CALL FERSWD (V2(1),V3(1),V5(1))
      CALL FERLTD (MCBSMA(1),V3(1),V4(1),V5(1))
      CALL PACK (V2(1),IFG,MCBRM(1))
      GO TO 350
  330 CONTINUE
      CALL FERFBD (V2(1),V4(1),V3(1),V5(1))
      CALL PACK (V4(1),IFG,MCBRM(1))
      DO 340 I = 1,NORD
  340 V4(I) = V3(I)
  350 CALL CLOSE (IFG,NOREW)
C
C     CALCULATE DIAGONAL TERM OF B
C
      AII = ZERO
      DO 400 I = 1,NORD
  400 AII = AII + V2(I)*V4(I)
      IF (D .EQ. ZERO) GO TO 420
      DO 410 I = 1,NORD
  410 V3(I) = V3(I) - AII*V2(I) - D*V1(I)
      GO TO 440
  420 DO 430 I = 1,NORD
  430 V3(I) = V3(I) - AII*V2(I)
  440 DB = ZERO
      IF (IOPTF .EQ. 1) GO TO 460
      CALL FERLTD (MCBSMA(1),V3(1),V4(1),V5(1))
      DO 450 I = 1,NORD
  450 DB = DB + V3(I)*V4(I)
      GO TO 480
  460 DO 470 I = 1,NORD
  470 DB = DB + V3(I)*V3(I)
  480 DB = DSQRT(DB)
CQ480 DB = QSQRT(DB)
      ERRC = SNGL(DB)
      B(1) = AII
      B(2) = D
      CALL WRITE (SR5FLE,B(1),4,1)
      IF ( NIDORV .NE. 0 ) GO TO 3000
      CALL GOPEN (IFV,ZB(1),WRT)
      IIP  = 1
      NNP  = NORD
      CALL PACK (V2(1),IFV,MCBVEC(1))
      CALL CLOSE (IFV,NOREW)
      GO TO 4000
3000  CONTINUE
      NIDX = NIDORV/2 + 1 
      ILOC = NORTHO * NORD + NIDX
      DO 3100 I = IIP, NNP
      ZD( ILOC+I-1 ) = V2( I )
3100  CONTINUE
4000  CONTINUE
      NORTHO = NORTHO + 1
      IFN  = NORTHO - NZERO
      IF (L16 .NE. 0) WRITE (IO,610) IFN,MORD,AII,DB,D
      IF ( IFN .LT. MORD ) GO TO 6000
C
C NEED TO SAVE ORTHOGONAL VECTORS BACK TO FILE
C
      CALL GOPEN ( IFV, ZB(1), WRT ) 
      IIP  = 1
      NNP  = NORD
      NIDX = NIDORV/2 + 1 
      DO 5000 I = 1, NORTHO
      ILOC = (I-1)*NORD + NIDX
      CALL PACK ( ZD( ILOC ), IFV, MCBVEC(1) )
5000  CONTINUE
      CALL CLOSE ( IFV, NOREW )
6000  CONTINUE
      IF (IFN .GE. MORD) GO TO 630
C
C     IF NULL VECTOR GENERATED, RETURN TO OBTAIN A NEW SEED VECTOR
C
      IF (DB .LT. DEPX*DABS(AII)) GO TO 630
C
C     A GOOD VECTOR IN V2. MOVE IT INTO 'PREVIOUS' VECTOR SPACE V1,
C     NORMALIZE V3 AND V2. LOOP BACK FOR MORE VECTORS.
C
      DBI = 1.0D+0/DB
      DO 490 I = 1,NORD
      V1(I) = V2(I)
      V3(I) = V3(I)*DBI
  490 V2(I) = V3(I)
      GO TO 70
C
  500 MORD = IFN
      WRITE (IO,600) UWM,MORD
      GO TO 630
C
  600 FORMAT (A25,' 2387, PROBLEM SIZE REDUCED TO',I5,' DUE TO -', /5X,
     1        'ORTHOGONALITY DRIFT OR NULL TRIAL VECTOR', /5X,
     2        'ALL EXISTING MODES MAY HAVE BEEN OBTAINED.  USE DIAG 16',
     3        ' TO DETERMINE ERROR BOUNDS',/)
  610 FORMAT (5X,'TRIDIAGONAL ELEMENTS ROW (IFN)',I5, /5X,'MORD =',I5,
     1        ', AII,DB,D = ',1P,3D16.8)
  620 FORMAT (11X,'ORTH ITER (IX)',I5,',  MAX PROJ (SDMAX)',1P,D16.8,
     1        ',  NORMAL FACT (DSQ)',1P,D16.8)
C
  630 NAME(3) = NAME(5)
      CALL CONMSG (NAME,3,0)
      RETURN
      END

      SUBROUTINE CPYSTR (INBLK,OUTBLK,FLAG,COL)
C
C     CPYSTR COPIES A LOGICAL RECORD WRITTEN IN STRING FORMAT
C     FROM ONE FILE TO ANOTHER FILE.
C
C     INBLK  = 15-WORD STRING COMMUNICATION BLOCK FOR INPUT FILE
C     OUTBLK = 15-WORD STRING COMMUNICATION BLOCK FOR OUTPUT FILE
C     FLAG .NE. 0 MEANS 1ST CALL GETSTR HAS BEEN MADE FOR THE RECORD
C          .EQ. 0 MEANS 1ST CALL GETSTR HAS NOT BEEN MADE
C     COL .EQ. 0 MEANS COLUMN NUMBER IS IN INBLK(12)
C         .NE. 0 MEANS COL IS COLUMN NUMBER
C
C
      INTEGER          INBLK(15),OUTBLK(15),FLAG,PRC,WORDS,RLCMPX,TYPE,
     1                 PREC,RC,OUT,COL
      DOUBLE PRECISION XND(1)
      COMMON /ZZZZZZ/  XNS(1)
      COMMON /TYPE  /  PRC(2),WORDS(4),RLCMPX(4)
      EQUIVALENCE      (XNS(1),XND(1))
C
C     ON OPTION, MAKE 1ST CALL TO GETSTR AND THEN INITIALIZE
C
      IF (FLAG .NE. 0) GO TO 10
      INBLK(8) = -1
      CALL GETSTR (*50,INBLK)
   10 OUTBLK(2) = INBLK(2)
      OUTBLK(3) = INBLK(3)
      OUTBLK(4) = INBLK(4)
      OUTBLK(8) = -1
      OUTBLK(12) = COL
      IF (COL .EQ. 0) OUTBLK(12) = INBLK(12)
      OUTBLK(13)= 0
      TYPE = INBLK(2)
      PREC = PRC(TYPE)
      RC   = RLCMPX(TYPE)
C
C     COPY A STRING
C
   12 CALL PUTSTR (OUTBLK)
      NPREV = 0
      OUTBLK(7) = MIN0(INBLK(6),OUTBLK(6))
   14 IN   = INBLK(5)
      OUT  = OUTBLK(5)
      NSTR = OUT + RC*(OUTBLK(7) - NPREV) - 1
      IF (PREC .EQ. 2) GO TO 18
C
      DO 16 JOUT = OUT,NSTR
      XNS(JOUT) = XNS(IN)
      IN = IN + 1
   16 CONTINUE
      GO TO 20
C
   18 DO 19 JOUT = OUT,NSTR
      XND(JOUT) = XND(IN)
      IN = IN + 1
   19 CONTINUE
C
C     TEST FOR END OF INPUT STRING(S)
C
   20 IF (OUTBLK(7) .EQ. INBLK(6)+NPREV) GO TO 30
      OUTBLK(13) = OUTBLK(13) + OUTBLK(7)
      CALL ENDPUT (OUTBLK)
      OUTBLK(4) = OUTBLK(4) + OUTBLK(7)
      INBLK(6)  = INBLK(6)  - (OUTBLK(7) - NPREV)
      INBLK(5)  = IN
      GO TO 12
C
C     INPUT STRING HAS BEEN COPIED.  GET ANOTHER STRING.
C
   30 CALL ENDGET (INBLK)
      CALL GETSTR (*40,INBLK)
C
C     TEST FOR STRING CONTIGUOUS WITH PREVIOUS STRING.
C     IF SO, AND IF TERMS AVAILABLE, CONCATENATE WITH PREVIOUS STRING.
C
      IF (INBLK(4) .NE. OUTBLK(4)+OUTBLK(7)) GO TO 35
      IF (OUTBLK(7).GE. OUTBLK(6)) GO TO 35
      OUTBLK(5) = NSTR + 1
      NPREV     = OUTBLK(7)
      OUTBLK(7) = MIN0(OUTBLK(7)+INBLK(6),OUTBLK(6))
      GO TO 14
   35 OUTBLK(13) = OUTBLK(13) + OUTBLK(7)
      CALL ENDPUT (OUTBLK)
      OUTBLK(4) = INBLK(4)
      GO TO 12
C
C     NO MORE STRINGS -  CLOSE RECORD AND RETURN
C
   40 OUTBLK(8) = 1
      CALL ENDPUT (OUTBLK)
      OUTBLK(13) = (OUTBLK(13)+OUTBLK(7))*WORDS(TYPE)
      RETURN
C
C     HERE IF NO STRINGS IN RECORD - MAKE A NULL RECORD
C
   50 OUTBLK(2) = 1
      OUTBLK(3) = 0
      OUTBLK(8) = -1
      CALL PUTSTR (OUTBLK)
      OUTBLK(8) = 1
      CALL ENDPUT (OUTBLK)
      RETURN
      END

      SUBROUTINE FLBELM
C
C     READS CFLSTR AND CFREE BULK DATA AND BUILDS INCORE TABLES TO
C     DESCRIBE THE CONNECTIVITY BETWEEN THE STRUCTURE AND FLUID
C
      LOGICAL         ERROR
      INTEGER         GEOM2    ,ECT      ,BGPDT    ,SIL      ,MPT      ,
     1                GEOM3    ,CSTM     ,USET     ,EQEXIN   ,USETF    ,
     2                USETS    ,AF       ,DKGG     ,FBELM    ,FRELM    ,
     3                CONECT   ,AFMAT    ,AFDICT   ,KGMAT    ,KGDICT   ,
     4                Z        ,FILE     ,NAME(2)  ,MCB(7)   ,CFLSTR(2),
     5                CARD(10) ,ID(3)    ,GRID(4)  ,CFREE(2) ,ELM2D(7,3)
     6,               ELMFL(4,3)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /FLBFIL/ GEOM2    ,ECT      ,BGPDT    ,SIL      ,MPT      ,
     1                GEOM3    ,CSTM     ,USET     ,EQEXIN   ,USETF    ,
     2                USETS    ,AF       ,DKGG     ,FBELM    ,FRELM    ,
     3                CONECT   ,AFMAT    ,AFDICT   ,KGMAT    ,KGDICT
      COMMON /FLBPTR/ ERROR    ,ICORE    ,LCORE    ,IBGPDT   ,NBGPDT   ,
     1                ISIL     ,NSIL     ,IGRAV    ,NGRAV    ,IGRID    ,
     2                NGRID    ,IBUF1    ,IBUF2    ,IBUF3    ,IBUF4    ,
     3                IBUF5
      COMMON /ZZZZZZ/ Z(1)
      COMMON /SYSTEM/ SYSBUF   ,NOUT
      COMMON /BLANK / NOGRAV   ,NOFREE
      DATA    CFLSTR/ 7610,76/ ,CFREE / 4810,48 /  ,MCB / 7*0 /
      DATA    NAME  / 4HFLBE , 4HLM   /
C
C     TWO DIMENSIONAL STRUCTURAL ELEMENTS DESCRIPTIONS
C
      DATA    N2D   / 7 /
      DATA    ELM2D /
C
C                     TRIA1  TRIA2   TRMEM  QUAD1  QUAD2  QDMEM  SHEAR
C     1  IFP CARD NUMBERS
C     2  NUMBER OF GRIDS
C     3  NUMBER OF WORDS IN ECT RECORD
C
     1                52    ,53     ,56    ,57    ,58    ,60    ,61   ,
     2                3     ,3      ,3      ,4     ,4     ,4     ,4   ,
     3                6     ,6      ,6      ,7      ,7    ,7      ,6  /
C
C     FLUID ELEMENT DESCRIPTIONS
C
      DATA    NFL   / 4 /
      DATA    ELMFL /
C
C                     FHEX1     FHEX2     FTETRA    FWEDGE
C    1  IFP CARD NUMBERS
C    2  NUMBER OF GRIDS
C    3  NUMBER OF WORDS IN ECT RECORD
C
     1                333      ,334      ,335      ,336     ,
     2                8        ,8        ,4        ,6       ,
     3                10       ,10       ,6        ,8       /
C
C
C     READ BGPDT INTO OPEN CORE
C
      IBGPDT = 1
      FILE   = BGPDT
      CALL GOPEN (BGPDT,Z(IBUF1),0)
      NZ = IBUF3 - 1
      CALL READ (*1002,*10,BGPDT,Z(IBGPDT),NZ,1,NBGPDT)
      GO TO 1008
   10 ICORE = IBGPDT + NBGPDT
      NGRDT = NBGPDT/4
      CALL CLOSE (BGPDT,1)
C
C     LOCATE CFLSTR CARDS ON GEOM2 AND READ THEM INTO ELEMENT TABLE
C     IN CORE.   ONE ELEMENT TABLE RECORD WILL LOOK AS FOLLOWS -
C
C                  WORD      DESCRIPTION
C
C                  1         STRUCTURE ELEMENT ID
C                  2         FLUID ELEMENT ID
C                  3-6       ZERO
C                  7         GRAV LOAD ID
C
      FILE = GEOM2
      CALL PRELOC (*1001,Z(IBUF1),GEOM2)
      CALL LOCATE (*1200,Z(IBUF1),CFLSTR,ID)
      IELMT = ICORE
   20 CALL READ (*1002,*40,GEOM2,ID,2,0,N)
   30 CALL READ (*1002,*1003,GEOM2,IDS,1,0,N)
      IF (IDS .LT. 0) GO TO 20
      IF (ICORE+7 .GE. IBUF3) GO TO 1008
      Z(ICORE  ) = IDS
      Z(ICORE+1) = ID(1)
      Z(ICORE+2) = 0
      Z(ICORE+3) = 0
      Z(ICORE+4) = 0
      Z(ICORE+5) = 0
      Z(ICORE+6) = ID(2)
      ICORE = ICORE + 7
      GO TO 30
C
   40 NELMT = ICORE - IELMT
      NELM  = NELMT/7
C
C     SORT ELEMENT TABLE BY STRUCTUREAL ELEMENT ID
C
      CALL SORT (0,0,7,1,Z(IELMT),NELMT)
C
C     READ ECT AND PROCESS 2D STRUCTURAL ELEMENTS
C
      FILE = ECT
      CALL GOPEN (ECT,Z(IBUF2),0)
   50 CALL READ (*100,*1002,ECT,CARD,3,0,N)
      DO 60 I = 1,N2D
      IF (CARD(3) .EQ. ELM2D(I,1)) GO TO 70
   60 CONTINUE
C
C     SKIP RECORD BECAUSE NOT ACCEPTABLE 2D ELEMENT TYPE
C
      CALL FWDREC (*1001,ECT)
      GO TO 50
C
C     PROCESS THE 2D ELEMENT
C
   70 NGRDS = ELM2D(I,2)
      NWDS  = ELM2D(I,3)
C
C     READ DATA FOR ONE 2D ELEMENT
C
   80 CALL READ (*1001,*50,ECT,CARD,NWDS,0,N)
C
C     CHECK IF STRUCTURAL ELEMENT IS CONNECTED TO ANY FLUID ELEMENT
C     MAKE SURE BISLOC FINDS FIRST OF SEVERAL POSSIBLE ENTRIES
C
      CALL BISLOC (*80,CARD(1),Z(IELMT),7,NELM,JLOC)
   82 IF (JLOC.EQ.1 .OR. Z(IELMT+JLOC-8).NE.CARD(1)) GO TO 84
      JLOC = JLOC - 7
      GO TO 82
C
C     INSERT ELEMENT GRID POINTS INTO ELEMENT TABLE WORDS 3-6
C
   84 DO 90 I = 1,NGRDS
   90 Z(IELMT+JLOC+I) = CARD(I+2)
      IF (NGRDS .EQ. 3) Z(IELMT+JLOC+4) = -1
C
C     CHECK IF NEXT ENTRY IS FOR THE SAME STRUCTURAL ELEMENT
C
      IF (JLOC+7.GE.NELMT .OR. Z(IELMT+JLOC+6).NE.CARD(1)) GO TO 80
      JLOC = JLOC + 7
      GO TO 84
C
  100 CONTINUE
C
C     PASS THROUGH ELEMENT TABLE AND CHECK THAT EACH ENTRY HAS GRIDS.
C     ALSO SWITCH THE STRUCTURE AND FLUID ELEMENTS IN THE TABLE FOR
C     FUTURE WORD WITH FLUID ID.
C
      LELMT = IELMT + NELMT - 1
      DO 110 I = IELMT,LELMT,7
      IDS  = Z(I  )
      Z(I) = Z(I+1)
      IF (Z(I+2) .NE. 0) GO TO 110
      ERROR = .TRUE.
      WRITE (NOUT,8002) UFM,IDS
      IDS  = 0
  110 Z(I+1) = IDS
C
C     ALLOCATE AND ZERO THE GRID POINT CONNECTIVE TABLE AT THE BOTTOM
C     OF CORE
C
C     TABLE ENTRIES WILL BE AS FOLLOWS
C
C     POSITIVE LESS THEN 1,000,000  - NUMBER OF STRUCTURAL POINTS
C                                     CONNECTED TO THIS FLUID POINT
C     MULTIPLES OF 1,000,000        - NUMBER OF FREE SURFACE POINTS
C                                     CONNECTED TO THIS FLUID POINT
C     NEGATIVE                      - NUMBER OF STRUCTURAL POINTS
C                                     CONNECTED TO THIS STRUCTURAL
C                                     POINT
C
      IGRID = IBUF3 - NGRDT - 1
      IF (IGRID .LT. ICORE) GO TO 1008
      NGRID = NGRDT
      LGRID = IBUF3 - 1
      DO 115 I = IGRID,LGRID
  115 Z(I) = 0
C
C     LOCATE CFREE CARDS ON GEOM2 AND ADD THEM TO THE ELEMENT TABLE.
C     THESE ELEMENT RECORDS WILL APPEAR AS FOLLOWS
C
C                  WORD      DESCRIPTION
C
C                  1         FLUID ELEMENT ID
C                  2         -1
C                  3         FACE ID
C                  4-6       ZERO
C                  7         GRAV ID
C
      FILE = GEOM2
      CALL LOCATE (*124,Z(IBUF1),CFREE,ID)
      NOFREE = 1
  120 CALL READ (*1002,*130,GEOM2,ID,3,0,N)
      IF (ICORE+7 .GE. IGRID) GO TO 1008
      Z(ICORE  ) = ID(1)
      Z(ICORE+1) = -1
      Z(ICORE+2) = ID(3)
      Z(ICORE+3) = 0
      Z(ICORE+4) = 0
      Z(ICORE+5) = 0
      Z(ICORE+6) = ID(2)
      ICORE = ICORE + 7
      GO TO 120
C
C     NO CFREE CARDS - THIS IMPLIES THAT THERE WILL BE NO FREE SURFACE
C
  124 NOFREE = -1
C
C     COMPLETE CORE ALLOCATION FOR THIS PHASE
C
  130 NELMT = ICORE - IELMT
      NELM  = NELMT/7
      CALL CLOSE (GEOM2,1)
C
C     SORT ELEMENT TABLE BY FLUID ID
C
      CALL SORT (0,0,7,1,Z(IELMT),NELMT)
C
C     OPEN FBELM AND FRELM SCRATCH FILES
C
      CALL GOPEN (FBELM,Z(IBUF1),1)
      CALL GOPEN (FRELM,Z(IBUF3),1)
C
C     READ ECT AND PROCESS FLUID ELEMENTS
C
      FILE = ECT
      CALL REWIND (ECT)
      CALL FWDREC (*1002,ECT)
  140 CALL READ (*220,*1003,ECT,CARD,3,0,N)
      DO 150 I = 1,NFL
      IF (CARD(3) .EQ. ELMFL(I,1)) GO TO 160
  150 CONTINUE
C
C     SKIP RECORD BECAUSE NOT FLUID ELEMENT TYPE
C
      CALL FWDREC (*1001,ECT)
      GO TO 140
C
C     PRECESS FLUID ELEMENT
C
  160 NTYPE = ELMFL(I,1)
      NWDS  = ELMFL(I,3)
C
C     READ DATA FOR ONE FLUID ELEMENT
C
  170 CALL READ (*1001,*140,ECT,CARD,NWDS,0,N)
C
C     FIND IF FLUID ELEMENT IS ON FREE SURFACE OR STRUCTURAL BOUNDARY.
C     MAKE SURE BISLOC FINDS THE FIRST OF SEVERAL POSSIBLE ENTRIES.
C
      CALL BISLOC (*170,CARD(1),Z(IELMT),7,NELM,JLOC)
  175 IF (JLOC.EQ.1 .OR. Z(IELMT+JLOC-8).NE.CARD(1)) GO TO 180
      JLOC = JLOC - 7
      GO TO 175
C
C     DETERMINE IF ENTRY IS EITHER A BOUNDARY OR FREE SURFACE
C     DESCRIPTION - IGNORE ENTRY IF IT WAS IN ERROR DURING STRUCTURAL
C     ELEMENT PROCESSING
C
  180 IF (Z(IELMT+JLOC) .GT.  0) GO TO 190
      IF (Z(IELMT+JLOC) .EQ. -1) GO TO 200
      GO TO 210
C
C     THIS ENTRY DESCRIBES THE FLUID / STRUCTURE BOUNDARY - FIND THE
C     FLUID GRID POINTS WHICH COINCIDE WITH THE STRUCTURAL POINTS
C
  190 CALL FLFACE (NTYPE,CARD,Z(IELMT+JLOC-1),GRID)
      IF (ERROR) GO TO 210
C
C     INCLUDE CONNECTIONS IN GRID POINT CONNECTIVITY TABLE
C        1) NUMBER OF STRUCTURE GRID POINTS CONNECTED TO EACH FLUID
C        2) NUMBER OF STRUCTURAL GRID POINTS CONNECTED TO EACH
C           STRUCTURE POINT
C
      NGRDF = 4
      IF (GRID(4) .LT. 0) NGRDF = 3
      NGRDS = 4
      IF (Z(IELMT+JLOC+4) .LT. 0) NGRDS = 3
      DO 192 I = 1,NGRDF
      J = GRID(I) - 1
  192 Z(IGRID+J) = Z(IGRID+J) + NGRDS
      DO 194 I = 1,NGRDS
      J = Z(IELMT+JLOC+I) - 1
  194 Z(IGRID+J) = Z(IGRID+J) - NGRDS
C
C     WRITE 12 WORD RECORD FOR THIS ENTRY ON FBELM
C
C                  WORD      DESCRIPTION
C
C                  1         FLUID ELEMENT ID
C                  2         STRUCTURAL ELEMENT ID
C                  3-6       STRUCTURE GRID POINTS
C                  7         GRAVITY LOAD ID
C                  8         MATERIAL ID
C                  9-12      FLUID GRID POINTS
C
      CALL WRITE (FBELM,Z(IELMT+JLOC-1),7,0)
      CALL WRITE (FBELM,CARD(2),1,0)
      CALL WRITE (FBELM,GRID,4,0)
      GO TO 210
C
C     THIS ENTRY DESCRIBES THE FREE SURFACE - FIND THE FLUIDS GRID
C     POINTS WHICH DEFINE THE FACE ID GIVEN
C
  200 CALL FLFACE (NTYPE,CARD,Z(IELMT+JLOC-1),GRID)
      IF (ERROR) GO TO 210
C
C     INCLUDE CONNECTIONS IN GRID POINT CONNECTIVITY TABLE
C        1) NUMBER OF FREE SURFACE POINTS CONNECTED TO THIS FREE
C           SURFACE POINT
C
      NGRDF = 4
      IF (GRID(4) .LT. 0) NGRDF = 3
      DO 202 I = 1,NGRDF
      J = GRID(I) - 1
  202 Z(IGRID+J) = Z(IGRID+J) + NGRDF*1000000
C
C     WRITE 7 WORD RECORD ON FRELM FILE
C
C                  WORD      DESCRIPTION
C
C                  1         FLUID ELEMENT ID
C                  2         MATERIAL FLAG
C                  3-6       FLUID GRID POINTS
C                  7         GRAVITY LOAD ID
C
      Z(IELMT+JLOC) = CARD(2)
      CALL WRITE (FRELM,Z(IELMT+JLOC-1),2,0)
      CALL WRITE (FRELM,GRID,4,0)
      CALL WRITE (FRELM,Z(IELMT+JLOC+5),1,0)
C
C     FLAG THE ELEMENT TABLE ENTRY AS BEEN PROCESSED AND CHECK IF
C     THE NEXT ENTRY IS FOR THE SAME FLUID ELEMENT
C
  210 Z(IELMT+JLOC) = -2
      IF (JLOC+7.GE.NELMT .OR. Z(IELMT+JLOC+6).NE.CARD(1)) GO TO 170
      JLOC = JLOC + 7
      GO TO 180
C
  220 CALL CLOSE (ECT,1)
      CALL CLOSE (FBELM,1)
      CALL CLOSE (FRELM,1)
      MCB(1) = FBELM
      MCB(2) = NGRDT
      MCB(3) = NELM
      CALL WRTTRL (MCB)
      MCB(1) = FRELM
      CALL WRTTRL (MCB)
C
C     MAKE ONE FINAL PASS THROUGH ELEMENT TABLE AND VERIFY THAT
C     EVERY FLUID ELEMENT WAS PROCESSED
C
      LELMT = IELMT + NELMT - 1
      DO 240 I = IELMT,LELMT,7
      IF (Z(I+1) .EQ. -2) GO TO 240
      IF (Z(I+1) .EQ. -1) GO TO 230
      ERROR = .TRUE.
      WRITE (NOUT,8003) UFM,Z(I)
      GO TO 240
C
  230 ERROR = .TRUE.
      WRITE (NOUT,8004) UFM,Z(I)
C
  240 CONTINUE
C
C     ELEMENT TABLE IS NO LONGER NEEDED SO DELETE IT AND RETURN
C
      ICORE = IELMT
      RETURN
C
C     ERROR CONDITIONS
C
 1001 N = -1
      GO TO 1100
 1002 N = -2
      GO TO 1100
 1003 N = -3
      GO TO 1100
 1008 N = -8
 1100 CALL MESAGE (N,FILE,NAME)
C
C     NO FLUID / STRUCTURE BOUNDARY DEFINED.  FATAL ERROR BECAUSE DMAP
C     CANNOT HANDLE THIS CONDITION
C
 1200 ERROR = .TRUE.
      WRITE (NOUT,8001) UFM
      RETURN
C
C     ERROR FORMATS
C
 8001 FORMAT (A23,' 8001. THERE MUST BE A FLUID/STRUCTURE BOUNDARY IN ',
     1       'HYDROELASTIC ANALYSIS.')
 8002 FORMAT (A23,' 8002, ELEMENT ID',I9,' ON A CFLSTR CARD DOES NOT ',
     1       'REFERENCE A VALID 2D STRUCTURAL ELEMENT.')
 8003 FORMAT (A23,' 8003. ELEMENT ID',I9,' ON A CFLSTR CARD DOES NOT ',
     1       'REFERENCE A VALID FLUID ELEMENT.')
 8004 FORMAT (A23,' 8004. ELEMENT ID',I9,' ON A CFFREE CARD DOES NOT ',
     1       'REFERENCE A VALID FLUID ELEMENT.')
      END

      SUBROUTINE EM1D (ELTYPE,ISTART,ITYPE,NCOUNT,IDO,IWORDS,NBDYS,
     1                 ALL,NELOUT)
C
C     COMPUTE LOAD DUE TO MAGNETIC FIELD,  K*A + F = 0
C     SOLVE FOR -F
C
C     USE ELEMENT COORDINATES  FOR  ROD
C
C     SET UP COMMON BLOCKS, TABLES
C
C     KSYSTM(1) = 1ST POS. OF OPEN CORE
C     KSYSTM(2) = OUTPUT FILE NO.
C     KSYSTM(56) NE 0 FOR HEAT TRANSFER OPTION
C
C     Z      = OPEN CORE ARRAY
C     OUTPT  = OUTPUT FILE NO.
C     NELEMS = NO OF ELEMENTS (TYPES) IN THIS TABLE
C     LAST   = LOC OF 1ST WORD OF LAST ENTRY(EL) IN TABLE
C     INCR   = MAX NO WDS ALLOWED IN ANY ENTRY
C
C     BUF1   = BUFFER FOR EST
C     EST    = ELEMENT SUMMARY TABLE(PROG MAN 2.3.56)
C     SLT    = STAIC LOADS TABLE(2.3.51)
C     SYSTEM 2.4.13 PROG MANUAL
C     GPTA1  2.5.6
C     EST    2.3.56
C     SLT    2.3.51
C
C     ISTART GIVES 1ST POSITION OF HC OR REMFLUX VALUES
C     ROD IS IN ELEMENT COORDINATES, AS ARE TUBE,CONROD,BAR
C
C     X1 = 0.   X2 = X
C     AREA OF ROD NEEDED TO COMPUTE VOL
C     VOL  = LENGTH  * A
C     AREA OF TUBE CONPUTED WT OUTS.DIA.
C
C     OPEN FILE EST FOR ELEMENT DATA
C
C     INTEGRAL OVER VOL OF (GRADIENT SHAPE FUNC. TIMES GNU TIMES HC)
C
C     Z(1)  1ST POSITION OF LOAD
C     NELEMS = NO OF ELEMENTS
C     INCR   = MAX NO OF WORDS FOR AN ELEMENT OF THE ES T TABLE
C     NE(1 AND2) = ELEMENT NAME
C
      LOGICAL         ONLYC
      INTEGER         ELTYPE,ESTWDS,OUTPT,SYSBUF,ALL,SCR6
      DIMENSION       XN(2),XLOAD(2),NSIL(2),IZ(1),NAM(2),
     1                NECPT(200),NAME(2),HCX(2),HCY(2),HCZ(2),
     2                ZI(3),DNDX(2),DNDY(2),DNDZ(2),BUF(50),IBUF(50),
     3                XLACC(3),XI(2),W(2),SC(5),ISC(5)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /SYSTEM/ KSYSTM(64)
      COMMON /ZZZZZZ/ Z(1)
      COMMON /GPTA1 / NELEMS,LAST,INCR,NE(1)
      COMMON /EMECPT/ ECPT(200)
      COMMON /MATIN / MATID,INFLAG,ELTEMP
      COMMON /HMTOUT/ XMAT
      EQUIVALENCE     (IBUF(1)   ,BUF(1)), (SC(1)  ,ISC(1)  ),
     1                (KSYSTM(1 ),SYSBUF), (KSYSTM(2),OUTPT ),
     2                (KSYSTM(56),ITHRML), (ECPT(1),NECPT(1)),
     3                (Z(1)      ,IZ(1) ), (NSIL(1),NECPT(2))
      DATA     NAM  / 4H  EM,4H1D  /
      DATA     SCR6 / 306          /
C
C     FROM EST GET ALL NECESSARY ELEMENT INFO
C
      ONLYC  = .FALSE.
      NG     = 3
      ISC(1) = NECPT(1)
      ISC(2) = 1
      XI(1)  = -.5773502692
      XI(2)  = -XI(1)
      W(1)   = 1.
      W(2)   = 1.
      IDX    = (ELTYPE-1)*INCR
      ESTWDS = NE(IDX+12)
      NGRIDS = NE(IDX+10)
      NAME(1)= NE(IDX+ 1)
      NAME(2)= NE(IDX+ 2)
C
C     CHECK TO SEE IF THIS ELEMENT CONTAINS A GRID POINT ON A PERMBDY
C     CARD. IF SO, OR IF NO PERMBDY CARD EXISTS, COMPUTE LOADS FOR THE
C     ELEMENT IF NOT, COMPUTE HC CENTROIDAL VALUE ONLY. (ONLYC=.TRUE.)
C     THE PERMBDY SILS START AT Z(ISTART-NBDYS-1)
C
      IF (NBDYS .EQ. 0) GO TO 20
C
      DO 10 I = 1,NGRIDS
      DO 10 J = 1,NBDYS
      IF (NSIL(I) .EQ. IZ(ISTART-NBDYS-NELOUT+J-1)) GO TO 20
   10 CONTINUE
C
C     ELEMENT HAS NO GRIDS ON PERMBDY
C
      ONLYC = .TRUE.
      NG    = 1
   20 CONTINUE
      IF (ONLYC .AND. ITYPE.EQ.24) RETURN
C
C     IF ONLYC=TRUE, CHECK TO SEE IF THE ELEMENT HAD AN ELFORCE REQUEST.
C     IF SO, CONTINUE. IF NOT, JUST WRITE ZEROS TO HCCEN,SCR6) AND
C     RETURN.
C
      IF (.NOT.ONLYC) GO TO 40
      IF (ALL .EQ. 1) GO TO 40
      IF (NELOUT .EQ. 0) GO TO 70
C
      DO 30 I = 1,NELOUT
      IF (NECPT(1) .EQ. IZ(ISTART-NELOUT+I-1)) GO TO 40
   30 CONTINUE
      GO TO 70
   40 CONTINUE
C
C     1ST CHECK FOR ZERO LOAD
C
      IF (ITYPE.NE.20 .AND. ITYPE.NE.24) GO TO 80
      H1 = 0.
      H2 = 0.
      H3 = 0.
      DO 50 I = 1,2
      ISUB = ISTART + 3*NSIL(I) - 3
      IF (ITYPE .EQ. 24) ISUB = ISTART + 3*NCOUNT - 3
      H1 = H1 + ABS(Z(ISUB  ))
      H2 = H2 + ABS(Z(ISUB+1))
      H3 = H3 + ABS(Z(ISUB+2))
      IF (ITYPE .EQ. 24) GO TO 60
   50 CONTINUE
   60 HL = H1 + H2 + H3
      IF (HL    .NE. 0.) GO TO 80
      IF (ITYPE .EQ. 24) RETURN
C
C     ALL ZEROS-WRITE ON SCR6
C
   70 SC(3) = 0.
      SC(4) = 0.
      SC(5) = 0.
      CALL WRITE (SCR6,SC,5,0)
      RETURN
C
   80 CONTINUE
C
C     ROD ELTYPE 1
C     TUBE       3
C     CONROD    10
C     BAR       34
C     OTHERWISE  GET OUT
C     ONED  SOLVES LOAD DUE TO MAGNETIC FILED
C
      PI    = 3.14159
      INFLAG= 1
      IF (ELTYPE.NE.1 .AND. ELTYPE.NE.10) GO TO 90
      MID   = 4
      ITEMP = 17
      IX1   = 10
      IX2   = 14
      IY1   = 11
      IY2   = 15
      IZ1   = 12
      IZ2   = 16
      IAR   = 5
      GO TO 110
   90 IF (ELTYPE .NE. 3) GO TO 100
      MID   = 4
      ITEMP = 16
      IX1   = 9
      IX2   = 13
      IY1   = 10
      IY2   = 14
      IZ1   = 11
      IZ2   = 15
C
C     COMPUTE AREA
C
      DIA   = ECPT(5)
      TH    = ECPT(6)
      RAD   = DIA - 2.*TH
      ARROD = PI*((DIA/2)**2 - (RAD/2.)**2)
      GO TO 110
  100 IF (ELTYPE .NE. 34) GO TO 300
      MID   = 16
      ITEMP = 42
      IX1   = 35
      IX2   = 39
      IY1   = 36
      IY2   = 40
      IZ1   = 37
      IZ2   = 41
      IAR   = 17
  110 IF (ONLYC) GO TO 120
      XL    = ECPT(IX2) - ECPT(IX1)
      YL    = ECPT(IY2) - ECPT(IY1)
      ZL    = ECPT(IZ2) - ECPT(IZ1)
      XLEN  = SQRT(XL**2 + YL**2 + ZL**2)
      XN(1) = -1./XLEN
      XN(2) =  1./XLEN
      IF (ELTYPE .NE. 3) ARROD = ECPT(IAR)
      ELTEMP= ECPT (ITEMP)
      MATID = NECPT(MID)
C
C     ARROD = AREA OF CROSS SECTION OF ROD
C
      IF (ITYPE .NE. 24) CALL HMAT (NECPT(1))
      GNU = XMAT
      IF (ITYPE .EQ. 24) GNU = 1.
C
C     HC   FROM Z(ISTART)
C     YIELDS X COORD OF HC FOR GRID PT DEFINED BY NSIL
C
      VOL = ARROD*XLEN
C
C     COMPUTE BASIC TO LOCAL TRANSFORMATION
C
      ZI(1) = XL/XLEN
      ZI(2) = YL/XLEN
      ZI(3) = ZL/XLEN
C
C     PARTIALS OF N W.R.T X-GLOBAL,Y-GLOBAL,Z-GLOBAL
C
      DNDX(1) = -ZI(1)/XLEN
      DNDY(1) = -ZI(2)/XLEN
      DNDZ(1) = -ZI(3)/XLEN
      DNDX(2) = -DNDX(1)
      DNDY(2) = -DNDY(1)
      DNDZ(2) = -DNDZ(1)
      CONST   = .5*GNU*VOL
      IF (ITYPE .EQ. 24)GO TO 250
  120 CONTINUE
      JTYPE   = ITYPE - 19
      XLACC(1)= 0.
      XLACC(2)= 0.
      XLACC(3)= 0.
C
C     LOOP OVER INTEGRATION POINTS-ASSUME CUBIC VARIATION. SO NEED 2
C     INTEGRATION POINTS + CENTROID
C
      DO 240 NPTS = 1,NG
      IF (NPTS .NE. NG) GO TO 130
      XX = .5*(ECPT(IX1) + ECPT(IX2))
      YY = .5*(ECPT(IY1) + ECPT(IY2))
      ZZ = .5*(ECPT(IZ1) + ECPT(IZ2))
C
C     AVERAGE SPCFLD
C
      XLX  = .5
      XLXP = .5
      GO TO 140
C
C     COMPUTE LOCAL COORDINATE OF SAMPLING POINT
C
  130 XLOCAL = .5*XLEN*(1.+XI(NPTS))
      XLX  = XLOCAL/XLEN
      XLXP = 1. - XLX
C
C     COMPUTE BASIC COORDS FOR XLOCAL
C
      XX   = XLXP*ECPT(IX1) + XLX*ECPT(IX2)
      YY   = XLXP*ECPT(IY1) + XLX*ECPT(IY2)
      ZZ   = XLXP*ECPT(IZ1) + XLX*ECPT(IZ2)
  140 AHCX = 0.
      AHCY = 0.
      AHCZ = 0.
C
C     COMPUTE HC AT THIS POINT DUE TO ALL LOADS OF THIS TYPE
C
      DO 220 IJK = 1,IDO
      IF (ITYPE .EQ. 20) GO TO 160
      ISUB = ISTART + (IJK-1)*IWORDS - 1
      DO 150 I = 1,IWORDS
  150 BUF(I) = Z(ISUB+I)
      GO TO (160,180,190,200), JTYPE
C
C     SPCFLD
C
  160 DO 170 I = 1,2
      IS = ISTART + 3*NSIL(I) -3
      HCX(I) = Z(IS  )
      HCY(I) = Z(IS+1)
  170 HCZ(I) = Z(IS+2)
C
C     INTERPOLATE GRID VALUES TO INTEGRATION POINT
C
      HC1 = XLXP*HCX(1) + XLX*HCX(2)
      HC2 = XLXP*HCY(1) + XLX*HCY(2)
      HC3 = XLXP*HCZ(1) + XLX*HCZ(2)
      GO TO 210
  180 CALL AXLOOP (BUF,IBUF,XX,YY,ZZ,HC1,HC2,HC3)
      GO TO 210
  190 CALL GELOOP (BUF,IBUF,XX,YY,ZZ,HC1,HC2,HC3)
      GO TO 210
  200 CALL DIPOLE (BUF,IBUF,XX,YY,ZZ,HC1,HC2,HC3)
  210 AHCX  = AHCX + HC1
      AHCY  = AHCY + HC2
      AHCZ  = AHCZ + HC3
  220 CONTINUE
      IF (NPTS .NE. NG) GO TO 230
      SC(3) = AHCX
      SC(4) = AHCY
      SC(5) = AHCZ
      CALL WRITE (SCR6,SC,5,0)
      IF (ONLYC) RETURN
      GO TO 240
C
C     WE HAVE HC AT THIS INTEGRATION POINT. MULT. BY WEIGHT AND
C     ACCUMULATE
C
  230 XLACC(1) = XLACC(1) + AHCX*W(NPTS)
      XLACC(2) = XLACC(2) + AHCY*W(NPTS)
      XLACC(3) = XLACC(3) + AHCZ*W(NPTS)
  240 CONTINUE
C
C     MULT. BY CONST AND GRAD N TO GET LOADS
C
      XLOAD(1) = CONST*(DNDX(1)*XLACC(1) + DNDY(1)*XLACC(2) +
     1           DNDZ(1)*XLACC(3))
      XLOAD(2) = CONST*(DNDX(2)*XLACC(1) + DNDY(2)*XLACC(2) +
     1           DNDZ(2)*XLACC(3))
      GO TO 260
C
C     REMFLUX
C
  250 IS   = ISTART + 3*NCOUNT - 3
      AHCX = Z(IS  )
      AHCY = Z(IS+1)
      AHCZ = Z(IS+2)
C
      XLOAD(1) = GNU*VOL*(DNDX(1)*AHCX + DNDY(1)*AHCY + DNDZ(1)*AHCZ)
      XLOAD(2) = GNU*VOL*(DNDX(2)*AHCX + DNDY(2)*AHCY + DNDZ(2)*AHCZ)
  260 DO 290 I = 1,2
      J = NSIL(I)
C
C     IF PERMBDY EXISTS AND IF GRID IS NOT ON IT, IGNORE ITS LOAD
C
      IF (NBDYS .EQ. 0) GO TO 280
      DO 270 K = 1,NBDYS
      IF (J .NE. IZ(ISTART-NBDYS-NELOUT+K-1)) GO TO 270
      GO TO 280
  270 CONTINUE
      GO TO 290
  280 CONTINUE
  290 Z(J) = Z(J) - XLOAD(I)
      RETURN
C
  300 WRITE  (OUTPT,310) UFM
  310 FORMAT (A23,', ELEMENT TYPE ',2A4,' WAS USED IN AN E AND M ',
     1       'PROBLEM.')
      CALL MESAGE (-37,0,NAM)
      RETURN
      END

      SUBROUTINE EMGPRO (IBUF)
C
C     THIS ROUTINE OF THE -EMG- MODULE IS THE MAIN PROCESSOR.  IT WILL
C     PASS THE -EST- DATA BLOCK ONCE, ELEMENT TYPE BY ELEMENT TYPE.
C
C     ELEMENT TYPES CONTRIBUTING TO STIFFNESS, MASS, OR DAMPING MATRICES
C     WILL BE PROCESSED.
C
      LOGICAL          ANYCON, ERROR, HEAT
      INTEGER          Z, EST, CSTM, DIT, GEOM2, DICTN, SAVJCR, ELID,
     1                 OUTPT, EOR, SUBR(2), ELTYPE, PRECIS, ESTBUF,
     2                 ELEM, ESTWDS, ESTID, SAVNCR, DOSI(2), FLAGS,
     3                 SIL(32), SYSBUF, SCR3, SCR4, RET
      DOUBLE PRECISION DUMMY
      DIMENSION        IZ(1), IPOS(32), IBUF(7), TRIM6(2), TRPL1(2),
     1                 TRSHL(2), ESTX(12)
      CHARACTER        UFM*23, UWM*25, UIM*29, SFM*25, SWM*27
      COMMON /XMSSG /  UFM, UWM, UIM, SFM, SWM
      COMMON /BLANK /  NOK, NOM, NOB, NOK4GG, NOKDGG, NOCMAS, NCPBAR,
     1                 NCPROD, NCPQD1, NCPQD2, NCPTR1, NCPTR2, NCPTUB,
     2                 NCPQDP, NCPTRP, NCPTRB, VOLUME, SURFAC
      COMMON /SYSTEM/  KSYSTM(65)
      COMMON /GPTA1 /  NELEM, LAST, INCR, ELEM(1)
      COMMON /EMGFIL/  EST, CSTM, MPT, DIT, GEOM2, MATS(3), DICTN(3)
      COMMON /EMGPRM/  ICORE, JCORE, NCORE, ICSTM, NCSTM, IMAT, NMAT,
     1                 IHMAT, NHMAT, IDIT, NDIT, ICONG, NCONG, LCONG,
     2                 ANYCON, FLAGS(3), PRECIS, ERROR, HEAT,
     3                 ICMBAR, LCSTM, LMAT, LHMAT, KFLAGS(3), L38
      COMMON /EMGEST/  ESTBUF(200)
      COMMON /EMGDIC/  ELTYPE, LDICT, NLOCS, ELID, ESTID
      COMMON /ZZZZZZ/  Z(1)
      COMMON /IEMGOT/  NVAL(3)
      COMMON /MATOUT/  EGNU(6), RHO
      COMMON /IEMGOD/  DUMMY, KTYPES
      COMMON /IEMG1B/  ICALL, ILAST
      COMMON /SMA1CL/  KDUMMY(22), KNOGO
      COMMON /SMA2CL/  MDUMMY(20), MNOGO
      EQUIVALENCE      (KSYSTM( 2),OUTPT), (KSYSTM( 1),SYSBUF ),
     1                 (KSYSTM(55),IPREC), (ESTBUF( 1),ESTX(1)),
     2                 (IZ    ( 1),Z(1) )
      DATA    TRIM6,         TRPL1,         TRSHL               /
     1        4HCTRI,  4HM6  , 4HCTRP,4HLT1 , 4HCTRS,4HHL       /
      DATA    SCR3  ,  SCR4  / 303, 304 /
      DATA    EOR   ,  NOEOR / 1, 0     /, SUBR / 4HEMGP,4HRO   /
      DATA    DOSI  /  4HDOUB, 4HSING   /
C
      IQDMM1 = 0
      IQDMM2 = 0
      NVAL(1)= 0
      NVAL(2)= 0
      NVAL(3)= 0
      LTYPES = 0
      KTYPES = 0
      DUMMY  = 0.0D0
      ICALL  = 0
      ILAST  = 0
C
C     INITIALIZE /SMA1CL/ AND /SMA2CL/
C
      KNOGO = 0
      MNOGO = 0
      KDUMMY(10) = 10
      MDUMMY(10) = 10
C
C     FOLLOWING CALL PREPS /GPTA1/ FOR DUMMY ELEMENTS
C
      CALL DELSET
C
C     DEFINE WORKING CORE BLOCK FOR RESET PURPOSES.
C
      IPR = PRECIS
      IF (IPR .NE. 1) IPR = 0
      SAVJCR = JCORE
      SAVNCR = NCORE
      ESTID  = 0
      LNUM   = LCONG/2
C
C     READ THE ELEMENT TYPE FROM THE EST.
C
   10 CALL READ (*1340,*1360,EST,ELTYPE,1,NOEOR,IWORDS)
      IZERO = INCR*(ELTYPE-1)
C
C     CHECK FOR ALLOWABLE ELEMENT TYPES
C
      IF (ELTYPE.EQ. 2 .OR. ELTYPE.EQ.32 .OR. ELTYPE.EQ.33 .OR.
     1    ELTYPE.EQ.68 .OR. ELTYPE.EQ.69 .OR. ELTYPE.EQ.72) GO TO 15
      IF (ELTYPE.GE.1 .AND. ELTYPE.LE.NELEM) GO TO 40
   15 WRITE  (OUTPT,20) SFM,ELEM(IZERO+1),ELEM(IZERO+2),ELTYPE
   20 FORMAT (A25,' 3105, EMGPRO FINDS ',2A4,' ELEMENTS (ELEM. TYPE ',
     1       I3,') UNDEFINED IN EST DATA BLOCK AND/OR ELEMENT ROUTINE.')
   30 CALL FWDREC (*1350,EST)
      ERROR = .TRUE.
      GO TO 10
C
C     RESTORE CORE POINTERS
C
   40 JCORE = SAVJCR
      NCORE = SAVNCR
C
C     CLEAR ESTBUF
C
      DO 50 I = 1,200
      ESTBUF(I) = 0
   50 CONTINUE
C
C     SET VARIOUS PARAMETERS = FUNCTION OF THIS ELEMENT TYPE
C
C     TURN ON COUPLED MASS FLAG IF EITHER OF ALL-COUPLED-MASS-FLAG
C     OR SPECIFIC-TYPE-COUPLED-MASS-FLAG IS ON.
C
      IF (FLAGS(2)) 51,53,51
   51 IF (NOCMAS  ) 53,52,54
   52 IF (ELTYPE .EQ. 34) IF (NCPBAR) 53,53,54
      IF (ELTYPE .EQ.  1) IF (NCPROD) 53,53,54
      IF (ELTYPE .EQ. 19) IF (NCPQD1) 53,53,54
      IF (ELTYPE .EQ. 18) IF (NCPQD2) 53,53,54
      IF (ELTYPE .EQ.  6) IF (NCPTR1) 53,53,54
      IF (ELTYPE .EQ. 17) IF (NCPTR2) 53,53,54
      IF (ELTYPE .EQ.  3) IF (NCPTUB) 53,53,54
      IF (ELTYPE .EQ. 15) IF (NCPQDP) 53,53,54
      IF (ELTYPE .EQ.  8) IF (NCPTRP) 53,53,54
      IF (ELTYPE .EQ.  7) IF (NCPTRB) 53,53,54
   53 ICMBAR = -1
      GO TO 56
C
   54 ICMBAR = 1
C
   56 JLTYPE = 2*ELTYPE - IPR
      ESTWDS = ELEM(IZERO+12)
      NSILS  = ELEM(IZERO+10)
      ISIL   = ELEM(IZERO+13)
      IF (ELEM(IZERO+9) .NE. 0) ISIL = ISIL - 1
      I1 = ISIL
      I2 = ISIL + NSILS - 1
      ISAVE2 = 0
      IF (ESTWDS. LE. 200) GO TO 70
      WRITE  (OUTPT,60) SFM,ELTYPE
   60 FORMAT (A25,' 3106, EMGPRO FINDS THAT ELEMENT TYPE ',I3,
     1        ' HAS EST ENTRIES TOO LARGE TO HANDLE CURRENTLY.')
      GO TO 30
C
C     CHECK TO SEE IF ILLEGAL ELEMENTS ARE USED IN -HEAT- FORMULATION
C
   70 IF (.NOT.HEAT) GO TO 80
      IF (ELTYPE.EQ. 1 .OR.  ELTYPE.EQ. 3 .OR. ELTYPE.EQ. 6) GO TO 80
      IF (ELTYPE.GE. 9 .AND. ELTYPE.LE.14) GO TO 80
      IF (ELTYPE.GE.16 .AND. ELTYPE.LE.24) GO TO 80
      IF (ELTYPE.EQ.34 .OR.  ELTYPE.EQ.36 .OR. ELTYPE.EQ.37) GO TO 80
      IF (ELTYPE.GE.39 .AND. ELTYPE.LE.42) GO TO 80
      IF (ELTYPE.EQ.52 .OR.  ELTYPE.EQ.62 .OR. ELTYPE.EQ.63) GO TO 80
      IF (ELTYPE.GE.64 .AND. ELTYPE.LE.67) GO TO 80
      IF (ELTYPE.EQ.80 .OR.  ELTYPE.EQ.81 .OR. ELTYPE.EQ.83) GO TO 80
C
      WRITE  (OUTPT,75) UFM,ELEM(IZERO+1),ELEM(IZERO+2),ELTYPE
   75 FORMAT (A23,' 3115, EMGPRO FINDS ',2A4,' ELEMENTS (ELEMENT TYPE ',
     1        I3,') PRESENT IN A HEAT FORMULATION.')
      GO TO 30
C
C     SET UP VARIABLES TO BE WRITTEN AS DICTIONARY 3-WORD HEADER
C
   80 NLOCS = NSILS
      LDICT = NLOCS + 5
C
C     READ AN ELEMENT EST ENTRY
C
   90 CALL READ (*1350,*1200,EST,ESTBUF,ESTWDS,NOEOR,IWORDS)
      ELID  = ESTBUF(1)
      ESTID = ESTID + 1
C
C     CHECK TO SEE IF THIS ELEMENT IS CONGRUENT TO ANOTHER ALREADY
C     POSSESSING A DICTIONARY IN CORE.
C
      IF (.NOT.ANYCON) GO TO 150
      CALL BISLOC (*150,ELID,Z(ICONG),2,LNUM,J)
C
C     MATCH FOUND.  CHECK FOR DICTIONARY-TABLE ON PRIMARY.
C
      IPRIME = Z(ICONG+J  )
      IDPRIM = Z(ICONG+J-1)
  100 IF (IPRIME) 120,104,110
C
C     SET UP ELEMENT MATRIX MAPPING ARRAY FOR LATER USE BY OTHER
C     ELEMENTS IN THIS CONGRUENT SET
C
  104 ICG    = JCORE
      JJCORE = JCORE  + 2*NSILS + 5
      ICRQ   = JJCORE - NCORE
      IF (JJCORE .GE .NCORE) GO TO 1800
      JCORE   = JJCORE
      IZ(ICG) = IDPRIM
      IZ(ICG+1) = NSILS
      IZ(ICG+2) = 0
      IZ(ICG+3) = 0
      IZ(ICG+4) = 0
      IGOTO = 0
      GO TO 1380
C
C     IPRIME POINTS TO PRIMARY ID
C
  110 IDPRIM = Z(IPRIME  )
      IPRIME = Z(IPRIME+1)
      GO TO 100
C
C     IPRIME IS NEGATIVE TABLE ADDRESS IMPLYING DICTIONARY EXISTS.
C
  120 IF (ERROR) GO TO 150
      IPRIME =-IPRIME
      IMATCH = 0
      IBFIND = 1
      J = 0
  125 J = J + 1
      IADD = Z(IPRIME+J)
      IF (IADD) 140,140,130
C
C     COPY DICTIONARY FROM CORE TO DICTIONARY FILE.
C
  130 Z(IADD)  = ESTID
      FLAGS(J) = FLAGS(J) + 1
      CALL WRITE (DICTN(J),Z(IADD),5,NOEOR)
      IADDD  = IADD + 5
      IF (IMATCH .EQ. 1) GO TO 135
      IF (IMATCH .EQ. 2) GO TO 1600
      INDCNG = SAVJCR
      IGOTO  = 1
  131 IF (IZ(INDCNG) .EQ. IDPRIM) GO TO 1380
      JJCORE = INDCNG + 2*IZ(INDCNG+1) + 5
      IF (JJCORE .GE. NCORE) GO TO 1820
      INDCNG = JJCORE
      GO TO 131
  133 DO 134 L = 1,NSILS
      IF (IPOS(L) .NE. IZ(INDCNG+NSILS+L+4)) GO TO 137
  134 CONTINUE
      IMATCH = 1
  135 CALL WRITE (DICTN(J),Z(IADDD),NSILS,NOEOR)
      GO TO 140
  137 IMATCH = 2
      GO TO 1600
  140 IBFIND = IBFIND + 2
      IF (J .LT. 3) GO TO 125
      GO TO 90
C
C     BRANCH ON ELEMENT TYPE.  INDIVIDUAL ROUTINES WILL COMPUTE AND
C     OUTPUT ALL MATRIX TYPES DESIRED BASED ON FLAGS AVAILABLE TO THEM.
C
  150 IF (ELTYPE .EQ. LTYPES) GO TO 152
      LTYPES = ELTYPE
      IF (LTYPES .GT. NELEM) GO TO 15
      CALL PAGE2 (3)
      WRITE  (OUTPT,151) UIM,DOSI(IPR+1),ELEM(IZERO+1),ELEM(IZERO+2),
     1                   ELTYPE,ELID
  151 FORMAT (A29,' 3113,', /5X,'EMG MODULE PROCESSING ',A4,
     1       'LE PRECISION ',2A4,' ELEMENTS (ELEMENT TYPE ',I3,
     2       ') STARTING WITH ID ',I8)
      IF (ELTYPE.GE.84 .AND. ELTYPE.LE.86) WRITE (OUTPT,2300)
  152 IF (L38 .NE. 1) GO TO 154
      CALL PAGE2 (1)
      WRITE  (OUTPT,153) ELID
  153 FORMAT (5X,'ELEMENT ',I8,' IS BEING PROCESSED')
  154 LOCAL = JLTYPE - 100
      IF (LOCAL) 155,155,156
C
C     PAIRED -GO TO- ENTRIES PER ELEMENT SINGLE/DOUBLE PRECISION
C
C             1 CROD      2 C.....    3 CTUBE     4 CSHEAR    5 CTWIST
  155 GO TO (210,  215,   15,   15,  230,  235,  240,  245,  250,  255,
C
C             6 CTRIA1    7 CTRBSC    8 CTRPLT    9 CTRMEM   10 CONROD
     1       260,  265,  270,  275,  280,  285,  290,  295,  210,  215,
C
C            11 ELAS1    12 ELAS2    13 ELAS3    14 ELAS4    15 CQDPLT
     2       320,  320,  325,  325,  335,  335,  345,  345,  350,  355,
C
C            16 CQDMEM   17 CTRIA2   18 CQUAD2   19 CQUAD1   20 CDAMP1
     3       360,  365,  370,  375,  380,  385,  390,  395,  405,  405,
C
C            21 CDAMP2   22 CDAMP3   23 CDAMP4   24 CVISC    25 CMASS1
     4       415,  415,  425,  425,  435,  435,  440,  445,  455,  455,
C
C            26 CMASS2   27 CMASS3   28 CMASS4   29 CONM1    30 CONM2
     5       465,  465,  475,  475,  485,  485,  490,  495,  500,  505,
C
C            31 PLOTEL   32 C.....   33 C.....   34 CBAR     35 CCONEAX
     6       510,  515,   15,   15,   15,   15,  540,  545,  550,  555,
C
C            36 CTRIARG  37 CTRAPRG  38 CTORDRG  39 CTETRA   40 CWEDGE
     7       560,  565,  570,  575,  580,  585,  590,  595,  600,  605,
C
C            41 CHEXA1   42 CHEXA2   43 CFLUID2  44 CFLUID3  45 CFLUID4
     8       610,  615,  620,  625,  630,  635,  640,  645,  650,  655,
C
C            46 CFLMASS  47 CAXIF2   48 CAXIF3   49 CAXIF4   50 CSLOT3
     9       660,  665,  670,  675,  680,  685,  690,  695,  700,  705
C
     *       ), JLTYPE
C
C
C            51 CSLOT4   52 CHBDY    53 CDUM1    54 CDUM2    55 CDUM3
  156 GO TO (710,  715,  720,  725,  730,  730,  740,  740,  750,  750,
C
C            56 CDUM4    57 CDUM5    58 CDUM6    59 CDUM7    60 CDUM8
     B       760,  760,  770,  770,  780,  780,  790,  790,  800,  800,
C
C            61 CDUM9    62 CQDMEM1  63 CQDMEM2  64 CQUAD4   65 CIHEX1
     C       810,  810,  820,  825,  830,  835,  950,  955,  850,  855,
C
C            66 CIHEX2   67 CIHEX3   68 CQUADTS  69 CTRIATS  70 CTRIAAX
     D       850,  855,  850,  855,   15,   15,   15,   15,  880,  885,
C
C            71 CTRAPAX  72 CAERO1   73 CTRIM6   74 CTRPLT1  75 CTRSHL
     E       890,  895,   15,   15,  900,  905,  910,  915,  920,  925,
C
C            76 CFHEX1   77 CFHEX2   78 CFTETRA  79 CFWEDGE  80 CIS2D8
     F       610,  615,  620,  625,  590,  595,  600,  605,  930,  935,
C
C            81 CELBOW   82 FTUBE    83 CTRIA3   84 CPSE2    85 CPSE3
     G       940,  945,  840,  840,  960,  965,   90,   90,   90,   90,
C
C            86 CPSE4
     H        90,   90
C
     *       ), LOCAL
C
C     ==================================================================
C     A WALKING TOUR OF EMG TO COMPUTE STIFFNESS (K-) AMD MASS (M-)
C     MATRICES FOR AN 'OLD' ELEMENT SUCH AS CTRIA2.
C     SEE HOW EASY IT IS.      G.CHAN/UNISYS, 7/87
C
C       EMG SUPPORTING ROUTINES -
C       EMGTAB,EMGCNG,EMGCOR,EMGFIN,
C       EMGSOC (WHICH COMPUTES OFFSET BETWWEN /ZZEMGX/ AND /ZZEMII/ AND
C           /   SETS ICORE,JCORE,NCORE IN /EMGPRM/ FOR OPEN CORE USAGE)
C          /
C         /                                --->EMG1B---->EMGOUT
C        /                                /   OUTPUT PIVOT ROW PARTITION
C     EMG---->EMGPRO---->CTRIA2          /    AFTER KTRIQD IS DONE, AND
C               /      AN ENTRY POINT   /     ALSO AFTER MTRIQD
C            /ZZEMGX/     IN           /                             (*)
C                        OLDEL3--->EMGOLD--->KTRIQD--->KTRMEM--->KTRPLT
C                                    /                              /
C                                    ------->MTRIQD             /ZZEM14/
C            (*)                                 (&)          UNIT 14 IS
C             KTRPLT---------------->KTRBSC                   ALLOCATED
C           TO COMPUTE BENDING     TO COMPUTE MEMBRANE        TO CTRIA2
C           FOR CTRIA2             FOR CTRIA2                 BY TA1ABD
C                  /                      /
C                 ------->SMA1B<----------
C                           \
C                            ---->EMG1B---->EMGOUT
C                                          OUTPUT A K-MATRIX
C           (&)                            PARTITION
C             MTRIQD BRANCH, FOR M-MATRIX
C             FOR CTRIA2 ELEMENT, IS SIMILARLY
C             STRUCTURED AS THAT OF THE KTRIQD BRANCH
C
C             REPEAT DAMPING B-MATRIX IF NECESSARY
C             IF ELEMENT HAS HEAT CAPBABILITY - WHAT DO I DO NOW?
C
C     THIS SYMBOL '>' IS RIGHT ARROW HEAD, AND '<' IS LEFT ARROW HEAD
C     ==================================================================
C
  210 CALL RODS
      GO TO 90
  215 CALL RODD
      GO TO 90
  230 CALL TUBES
      GO TO 90
  235 CALL TUBED
      GO TO 90
  240 CALL SHEARS
      GO TO 90
  245 CALL SHEARD
      GO TO 90
  250 CALL TWISTS
      GO TO 90
  255 CALL TWISTD
      GO TO 90
  260 CALL TRIA1S
      GO TO 300
  265 CALL TRIA1D
      GO TO 300
  270 CALL TRBSCS
      GO TO 300
  275 CALL TRBSCD
      GO TO 300
  280 CALL TRPLTS
      GO TO 300
  285 CALL TRPLTD
      GO TO 300
  290 CALL TRMEMS
      GO TO 300
  295 CALL TRMEMD
  300 KHT = 7
      L   = 9
      IF (VOLUME.EQ.0 .AND. SURFAC.EQ.0) GO TO 90
      CALL WRITE (SCR4,ELEM(IZERO+1),2,0)
      CALL WRITE (SCR4,ESTBUF(1),1,0)
      ESTX(5)   = ESTX(KHT)
      ESTX(6)   = RHO
      ESTBUF(7) = 3
      CALL WRITE (SCR4,ESTBUF(5), 3,0)
      CALL WRITE (SCR4,ESTBUF(2), 3,0)
      CALL WRITE (SCR4,ESTBUF(L),12,1)
      GO TO 90
  310 KHT = 8
      L   = 10
  315 IF (VOLUME.EQ.0 .AND. SURFAC.EQ.0) GO TO 90
      CALL WRITE (SCR4,ELEM(IZERO+1),2,0)
      CALL WRITE (SCR4,ESTBUF(1),1,0)
      ESTX(5)   = ESTX(KHT)
      ESTX(6)   = RHO
      ESTBUF(7) = 4
      CALL WRITE (SCR4,ESTBUF(5), 3,0)
      CALL WRITE (SCR4,ESTBUF(2), 4,0)
      CALL WRITE (SCR4,ESTBUF(L),16,1)
      GO TO 90
  320 NSCAL1 = 1
      GO TO 346
  325 NSCAL1 = 2
      GO TO 346
  335 NSCAL1 = 3
      GO TO 346
  345 NSCAL1 = 4
  346 NSCAL2 = 1
      GO TO 487
  350 CALL QDPLTS
  352 KHT = 10
      L   = 14
      GO TO 315
  355 CALL QDPLTD
      GO TO 352
  360 CALL QDMEMS
      GO TO 310
  365 CALL QDMEMD
      GO TO 310
  370 CALL TRIA2S
      GO TO 300
  375 CALL TRIA2D
      GO TO 300
  380 CALL QUAD2S
      GO TO 310
  385 CALL QUAD2D
      GO TO 310
  390 CALL QUAD1S
  392 IF (ESTX(12) .LE. 0.0) ESTX(12) = ESTX(8)
      KHT = 12
      L   = 14
      GO TO 315
  395 CALL QUAD1D
      GO TO 392
  405 NSCAL1 = 1
      GO TO 436
  415 NSCAL1 = 2
      GO TO 436
  425 NSCAL1 = 3
      GO TO 436
  435 NSCAL1 = 4
  436 NSCAL2 = 3
      GO TO 487
  440 CALL VISCS
      IF (FLAGS(3) .EQ. 0) WRITE (OUTPT,442) UWM
  442 FORMAT (A25,' 2422, VISC DATA NOT PROCESSED BY EMGPRO.')
      GO TO 90
  445 CALL VISCD
      IF (FLAGS(3) .EQ. 0) WRITE (OUTPT,442) UWM
      GO TO 90
  455 NSCAL1 = 1
      GO TO 486
  465 NSCAL1 = 2
      GO TO 486
  475 NSCAL1 = 3
      GO TO 486
  485 NSCAL1 = 4
  486 NSCAL2 = 2
  487 CALL SCALED (NSCAL1,NSCAL2)
      GO TO 90
  490 CALL CONM1S
      GO TO 90
  495 CALL CONM1D
      GO TO 90
  500 CALL CONM2S
      GO TO 90
  505 CALL CONM2D
      GO TO 90
  510 CALL PLOTLS
      GO TO 90
  515 CALL PLOTLD
      GO TO 90
  540 CALL BARS
      GO TO 90
  545 CALL BARD
      GO TO 90
  550 CALL CONES
      GO TO 90
  555 CALL CONED
      GO TO 90
  560 CALL TRIARS
      GO TO 90
  565 CALL TRIARD
      GO TO 90
  570 CALL TRAPRS
      GO TO 90
  575 CALL TRAPRD
      GO TO 90
  580 CALL TORDRS
      GO TO 90
  585 CALL TORDRD
      GO TO 90
  590 CALL TETRAS
      GO TO 90
  595 CALL TETRAD
      GO TO 90
  600 CALL WEDGES
      GO TO 90
  605 CALL WEDGED
      GO TO 90
  610 CALL HEXA1S
      GO TO 90
  615 CALL HEXA1D
      GO TO 90
  620 CALL HEXA2S
      GO TO 90
  625 CALL HEXA2D
      GO TO 90
  630 CALL FLUD2S
      GO TO 90
  635 CALL FLUD2D
      GO TO 90
  640 CALL FLUD3S
      GO TO 90
  645 CALL FLUD3D
      GO TO 90
  650 CALL FLUD4S
      GO TO 90
  655 CALL FLUD4D
      GO TO 90
  660 CALL FLMASS
      GO TO 90
  665 CALL FLMASD
      GO TO 90
  670 CALL AXIF2S
      GO TO 90
  675 CALL AXIF2D
      GO TO 90
  680 CALL AXIF3S
      GO TO 90
  685 CALL AXIF3D
      GO TO 90
  690 CALL AXIF4S
      GO TO 90
  695 CALL AXIF4D
      GO TO 90
  700 CALL SLOT3S
      GO TO 90
  705 CALL SLOT3D
      GO TO 90
  710 CALL SLOT4S
      GO TO 90
  715 CALL SLOT4D
      GO TO 90
  720 CALL HBDYS
      GO TO 90
  725 CALL HBDYD
      GO TO 90
  730 CALL KDUM1
      GO TO 90
  740 CALL KDUM2
      GO TO 90
  750 CALL KDUM3
      GO TO 90
  760 CALL KDUM4
      GO TO 90
  770 CALL KDUM5
      GO TO 90
  780 CALL KDUM6
      GO TO 90
  790 CALL KDUM7
      GO TO 90
  800 CALL KDUM8
      GO TO 90
  810 CALL KDUM9
      GO TO 90
  820 IF (.NOT.HEAT) GO TO 822
      IF (IQDMM1 .NE. 0) GO TO 360
      ASSIGN 360 TO RET
      IQDMM1 = 1
      GO TO 1000
  822 CALL QDMM1S
      GO TO 310
  825 IF (.NOT.HEAT) GO TO 827
      IF (IQDMM1 .NE. 0) GO TO 365
      ASSIGN 365 TO RET
      IQDMM1 = 1
      GO TO 1000
  827 CALL QDMM1D
      GO TO 310
  830 IF (.NOT.HEAT) GO TO 832
      IF (IQDMM2 .NE. 0) GO TO 360
      ASSIGN 360 TO RET
      IQDMM2 = 1
      GO TO 1000
  832 CALL QDMM2S
      GO TO 310
  835 IF (.NOT.HEAT) GO TO 837
      IF (IQDMM2 .NE. 0) GO TO 365
      ASSIGN 365 TO RET
      IQDMM2 = 1
      GO TO 1000
  837 CALL QDMM2D
      GO TO 310
  840 CALL FTUBE
      GO TO 90
  850 CALL IHEXS (ELTYPE-64)
      GO TO 90
  855 CALL IHEXD (ELTYPE-64)
      GO TO 90
  880 CALL TRIAAX
      GO TO 90
  885 CALL TRIAAD
      GO TO 90
  890 CALL TRAPAX
      GO TO 90
  895 CALL TRAPAD
      GO TO 90
  900 CALL KTRM6S
      L = 14
      GO TO 927
  905 CALL KTRM6D
      L = 14
      GO TO 927
  910 CALL KTRPLS
      L = 24
      GO TO 927
  915 CALL KTRPLD
      L = 24
      GO TO 927
  920 CALL KTSHLS
      L = 28
      GO TO 927
  925 CALL KTSHLD
      L = 28
  927 IF (VOLUME.EQ.0.0 .AND. SURFAC.EQ.0.0) GO TO 90
      ESTX(8) = ELEM(IZERO+1)
      ESTX(9) = ELEM(IZERO+2)
      IF (ESTX(11) .LE. 0.0) ESTX(11) = ESTX(10)
      IF (ESTX(12) .LE. 0.0) ESTX(12) = ESTX(10)
      THK = (ESTX(10) + ESTX(11) + ESTX(12))/3.
      ESTBUF(10) = ESTBUF(1)
      ESTX  (11) = THK
      ESTX  (12) = RHO
      ESTBUF(13) = 6
      CALL WRITE (SCR4,ESTBUF(8), 6,0)
      CALL WRITE (SCR4,ESTBUF(2), 6,0)
      CALL WRITE (SCR4,ESTBUF(L),24,1)
      GO  TO  90
  930 CALL IS2D8S
      GO TO 90
  935 CALL IS2D8D
      GO TO 90
  940 CALL ELBOWS
      GO TO 90
  945 CALL ELBOWD
      GO TO 90
  950 CALL QUAD4S
      GO TO 90
  955 CALL QUAD4D
      GO TO 90
  960 CALL TRIA3S
      GO TO 90
  965 CALL TRIA3D
      GO TO 90
C
C     PRINT WARNING MESSAGE TO INDICATE THAT QDMEM1 ELEMENTS
C     (ELEMENT TYPE 62) AND QDMEM2 ELEMENTS (ELEMENT TYPE 63)
C     ARE REPLACED BY QDMEM ELEMENTS (ELEMENT TYPE 16) IN
C     -HEAT- FORMULATION
C
 1000 INDEX  = 15*INCR
      INDEX1 = 16
      CALL PAGE2 (3)
      WRITE  (OUTPT,1100) UWM,ELEM(IZERO+1),ELEM(IZERO+2),ELTYPE,
     1                    ELEM(INDEX+1),ELEM(INDEX+2),INDEX1
 1100 FORMAT (A25,' 3144, EMGPRO FINDS ',2A4,' ELEMENTS (ELEMENT TYPE ',
     1       I3,') PRESENT IN A HEAT FORMULATION AND IS',/5X,'REPLACING'
     2,      ' THE SAME BY ',2A4,' ELEMENTS (ELEMENT TYPE ',I3,2H).)
      GO TO RET, (360,365)
C
C     ALL ELEMENTS OF THIS ELEMENT TYPE PROCESSED.
C     COMPLETE DICTIONARY RECORD FOR ELEMENT TYPE.
C
 1200 IF (ERROR) GO TO 1310
      DO 1300 I = 1,3
      IF (FLAGS(I) .LE. 0) GO TO 1300
      FLAGS(I) = -FLAGS(I)
      CALL WRITE (DICTN(I),0,0,EOR)
 1300 CONTINUE
C
C     FOR SAFETY AND IF CONGRUENCY EXISTS CLEAR OFF ANY TABLE POINTERS
C     ON PRIMARY-IDS IN THE CONGRUENCY LIST
C
 1310 IF (.NOT.ANYCON) GO TO 10
      DO 1330 I = ICONG,NCONG,2
      IF (Z(I+1) .LT. 0) Z(I+1) = 0
 1330 CONTINUE
      GO TO 10
C
C     ALL ELEMENT TYPES HAVE BEEN PROCESSED.
C
 1340 CONTINUE
      IF (KNOGO.GT.0 .OR. MNOGO.GT.0) CALL MESAGE (-61,0,0)
      RETURN
C
C     IMPROPER ENCOUNTER OF AN -EOF-
C
 1350 JFILE = EST
 1355 CALL MESAGE (-2,JFILE,SUBR)
C
C     IMPROPER ENCOUNTER OF AN -EOR-
C
 1360 JFILE = EST
      CALL MESAGE (-3,JFILE,SUBR)
C
C     FILE NOT IN FIST
C
 1370 CALL MESAGE (-1,JFILE,SUBR)
C
C     COMPUTE MAPPING DATA FOR CONGRUENT ELEMENTS
C
 1380 L1 = NSILS
      DO 1430 L = I1,I2
      IF (ESTBUF(L) .EQ. 0) GO TO 1420
      M = 1
      DO 1410 N = I1,I2
      IF (ESTBUF(N)-ESTBUF(L)) 1400,1390,1410
 1390 IF (N.GE.L) GO TO 1410
 1400 IF (ESTBUF(N) .NE. 0) M = M + 1
 1410 CONTINUE
      GO TO 1425
 1420 M  = L1
      L1 = L1 - 1
 1425 IPOS(M) = L - I1 + 1
      SIL(M) = ESTBUF(L)
 1430 CONTINUE
      IF (IGOTO .EQ. 1) GO TO 133
      DO 1460 L = I1,I2
      L1 = L - I1 + 1
      DO 1440 N = 1,NSILS
      IF (ESTBUF(L) .NE. SIL(N)) GO TO 1440
      IZ(ICG+L1+4) = N
      GO TO 1450
 1440 CONTINUE
 1450 IZ(ICG+NSILS+L1+4) = IPOS(L1)
 1460 CONTINUE
      GO TO 150
C
C     CHECK IF THE ELEMENT MATRIX IS DIAGONAL
C
 1600 IF (IZ(IADD+1) .NE. 2) GO TO 1604
C
C     ELEMENT MATRIX IS DIAGONAL.
C     RE-WRITE ONLY THE ELEMENT DICTIONARY FOR A CONGRUENT ELEMENT.
C
      DO 1602 L = 1,NSILS
      M = IPOS(L)
      N = IZ(INDCNG+M+4) - 1
      CALL WRITE (DICTN(J),Z(IADDD+N),1,NOEOR)
 1602 CONTINUE
      GO TO 140
C
C     ELEMENT MATRIX IS SQUARE.
C     PICK UP ELEMENT MATRIX DATA FOR A CONGRUENT ELEMENT THAT HAS
C     ALREADY BEEN PROCESSED AND STORE IT ON SCR3.
C
 1604 IBUF1 = NCORE - SYSBUF - 2
      ICRQ  = JCORE - IBUF1
      IF (ICRQ .GT. 0) GO TO 1840
      IBUF3 = IBUF1 - 1
      ICRQ  = JCORE - IBUF3 + 36*NSILS*IPREC
      IF (ICRQ .GT. 0) GO TO 1840
      IFILE = MATS(J)
      IF (IZ(INDCNG+J+1) .NE. 0) GO TO 1640
      CALL SAVPOS (IFILE,ISAVE1)
      CALL CLOSE  (IFILE,1)
      IBUF2 = IBUF(IBFIND+1)
      CALL GOPEN  (IFILE,Z(IBUF2),0)
      CALL FILPOS (IFILE,Z(IADDD))
      IF (ISAVE2 .NE. 0) GO TO 1605
      CALL GOPEN (SCR3,Z(IBUF1),1)
      GO TO 1607
 1605 JFILE = SCR3
      CALL OPEN (*1370,SCR3,Z(IBUF1),3)
 1607 JFILE = IFILE
      DO 1620 L1 = 1,NSILS
      CALL READ  (*1355,*1610,IFILE,Z(JCORE),IBUF3,EOR,N)
 1610 CALL WRITE (SCR3,Z(JCORE),N,EOR)
      IF (L1 .EQ. 1) CALL SAVPOS (SCR3,IZ(INDCNG+J+1))
 1620 CONTINUE
      CALL FILPOS (IFILE,ISAVE1)
      CALL SKPREC (IFILE,1)
      CALL CLOSE  (IFILE,2)
      CALL OPEN   (*1370,IFILE,Z(IBUF2),3)
      CALL SAVPOS (SCR3,ISAVE2)
      CALL CLOSE  (SCR3,1)
C
C     ELEMENT MATRIX DATA IS AVAILABLE ON SCR3.  REARRANGE IT IN
C     THE REQUIRED ORDER AND WRITE IT ON THE OUTPUT DATA BLOCK.
C
 1640 CALL GOPEN (SCR3,Z(IBUF1),0)
      JFILE = SCR3
      DO 1680 L = 1,NSILS
      CALL FILPOS (SCR3,IZ(INDCNG+J+1))
      M = IPOS(L)
      N = IZ(INDCNG+M+4) - 1
      CALL SKPREC (SCR3,N)
      CALL READ (*1355,*1650,SCR3,Z(JCORE),IBUF3,EOR,N)
 1650 NNWRDS = N/(NSILS*IPREC)
      NNWRDS = SQRT(NNWRDS+0.5)
      NWORDS = NNWRDS*IPREC
      JJCORE = JCORE
      DO 1670 L2 = 1,NNWRDS
      DO 1660 L1 = 1,NSILS
      M = IPOS(L1)
      N = IZ(INDCNG+M+4) - 1
      CALL WRITE (IFILE,Z(JJCORE+N*NWORDS),NWORDS,NOEOR)
 1660 CONTINUE
      JJCORE = JJCORE + NWORDS*NSILS
 1670 CONTINUE
      CALL WRITE  (IFILE,0,0,1)
      CALL SAVPOS (IFILE,ISAVE1)
      CALL WRITE  (DICTN(J),ISAVE1,1,NOEOR)
 1680 CONTINUE
      CALL FILPOS (SCR3,ISAVE2)
      CALL SKPREC (SCR3,1)
      CALL CLOSE  (SCR3,2)
      GO TO 140
 1800 WRITE (OUTPT,2000) UIM,IDPRIM
      WRITE (OUTPT,2400) ICRQ
      GO TO 1850
 1820 WRITE (OUTPT,2100) SWM,ESTID
      GO TO 1850
 1840 WRITE (OUTPT,2200) UIM,ESTID
      WRITE (OUTPT,2400) ICRQ
 1850 CALL PAGE2 (4)
      GO TO 150
C
 2000 FORMAT (A29,' 2382, ELEMENT MATRICES FOR ELEMENTS CONGRUENT TO ',
     1        'ELEMENT ID =',I10, /5X,'WILL BE RE-COMPUTED AS THERE IS',
     2        ' INSUFFICIENT CORE AT THIS TIME TO HOLD CONGRUENCY ',
     3        'MAPPING DATA.')
 2100 FORMAT (A27,' 2383, UNABLE TO LOCATE CONGRUENCY MAPPING DATA FOR',
     1        ' ELEMENT ID =',I10,1H., /5X,'ELEMENT MATRICES FOR THIS ',
     2        'ELEMENT WILL, THEREFORE, BE RE-COMPUTED.')
 2200 FORMAT (A29,' 2384, CONGRUENCY OF ELEMENT ID =',I10,
     1        ' WILL BE IGNORED AND ITS ELEMENT MATRICES', /5X,
     2        'WILL BE RE-COMPUTED AS THERE IS INSUFFICIENT CORE AT ',
     3        'THIS TIME TO PERFORM CONGRUENCY MAPPING COMPUTATIONS.')
 2300 FORMAT (5X,'(STEPPING THRU ONLY. NO REAL COMPUTATION HERE FOR ',
     1        'THIS DIFFERENTIAL STIFFNESS ELEMENT)')
 2400 FORMAT (5X,'ADDITIONAL CORE NEEDED =',I9,' WORDS.')
C
      END

      SUBROUTINE SPLT10( ICOMP, COMPS, NC)
      INTEGER COMPS(9)
      IF( ICOMP .EQ. 0) ICOMP= 1
      IC = ICOMP
      NC = 0
      DO 10  I=1,9
      IX = IC/10
      JX = IC - 10*IX
      IC = IX
      IF ( JX .EQ. 0) GO TO 5
      NC =NC+1
      COMPS(NC)= JX
    5 IF( IC .EQ. 0) GO TO 15
   10 CONTINUE
   15 IF (NC .EQ. 1) RETURN
      CALL SORT (0,0,1,1, COMPS,NC )
C
C     REMOVE DUPLICATES
      IX= 1
      DO 20 I=2,NC
      IF ( COMPS(I) .EQ. COMPS(I-1)) GO TO 20
      IX = IX+1
      COMPS(IX) = COMPS(I)
   20 CONTINUE
      NC = IX
      RETURN
      END

      SUBROUTINE DISPLA (GPLST,X,S,U,PEN,DEFORM,LABEL,PT,B1)
C
      INTEGER         GPLST(1),PEN,DEFORM,B1,SCR1,ECT2,AXIS,DAXIS,ELID,
     1                GPTS(12),GP,COLOR,OFFSET
      REAL            MAXDEF,X(3,1),U(3,1),S(2,1)
      DIMENSION       SIGN(3),A(4),PT(8),XX(4),YY(4),LABEL(50),MVECT(3),
     1                MSG(13)
      COMMON /BLANK / SKIP(5),NGPSET,SK(6),ECT2,SKP(7),MERR,SKI(6),SCR1
      COMMON /XXPARM/ SKIP1(39),MAXDEF,DEFMAX,AXIS(3),DAXIS(3),
     1                SKIP2(110),NCNTR,CNTR(50),ICNTVL,SKPPAR(6),
     2                SK18(18),COLOR
      COMMON /PLTDAT/ SKIP3(2),XMIN
      DATA    NMSG  / 13   /,
     1        MSG   / 4H(33X, 4H,41H, 4H*** , 4HINCO, 4HMPLE, 4HTE P,
     2                4HLOT , 4HDUE , 4HTO I, 4HNPUT, 4H OR , 4HFILE,
     3                4H.)  /
      DATA    MVECT / 3*0   /,        KBAR,KT3,KQ4 / 2HBR,2HT3,2HQ4 /
C
C
      CALL GOPEN (SCR1,GPLST(B1),1)
      IF (ABS(DEFMAX) .GT. 1.E-8) GO TO 5
      CALL WRTPRT (MERR,MVECT,MSG,NMSG)
      GO TO 120
C
    5 DO 10 I = 1,3
      SIGN(I) = DAXIS(I)/AXIS(I)
   10 CONTINUE
      DO 20 GP = 1,NGPSET
      DO 15 I  = 1,3
      J  = AXIS(I)
      IJ = IABS(J)
      A(IJ) = SIGN(IJ)*U(I,GP)
   15 CONTINUE
      DMAX = MAXDEF
      IF (DMAX .LT. .00001) DMAX = 1.0
      DO 16 I = 1,3
      U(I,GP) = A(I)*(DEFMAX/DMAX)
   16 CONTINUE
   20 CONTINUE
      INDEX = ICNTVL - 9
      NCNTR = MIN0(NCNTR,50)
      IF (CNTR(1) .NE. CNTR(2)) GO TO 40
      IF (INDEX .LE. 3) CONMIN = U(INDEX,1)
      IF (INDEX .GT. 3) CONMIN = SQRT(U(1,1)**2 + U(2,1)**2 + U(3,1)**2)
      CONMAX = CONMIN
      DO 30 GP = 1,NGPSET
      IF (INDEX .GT. 3) GO TO 25
      CONMIN = AMIN1(CONMIN,U(INDEX,GP))
      CONMAX = AMAX1(CONMAX,U(INDEX,GP))
      GO TO 30
   25 D = SQRT(U(1,GP)**2 + U(2,GP)**2 + U(3,GP)**2)
      CONMIN = AMIN1(CONMIN,D)
      CONMAX = AMAX1(CONMAX,D)
   30 CONTINUE
      DELTA = (CONMAX-CONMIN)/FLOAT(NCNTR-1)
      CNTR(1) = CONMIN
      J = NCNTR - 1
      DO 35 I = 2,J
      CNTR(I) = CNTR(I-1) + DELTA
   35 CONTINUE
      CNTR(NCNTR) = CONMAX
   40 CALL LINE (0.,0.,0.,0.,PEN,+1)
      DO 45 I = 1,NCNTR
      LABEL(I) = 3
   45 CONTINUE
   50 CALL READ  (*100,*100,ECT2,ITYPE,1,0,M)
      OFFSET = 0
      IF (ITYPE .EQ. KBAR) OFFSET = 6
      IF (ITYPE.EQ.KT3 .OR. ITYPE.EQ.KQ4) OFFSET = 1
      CALL FREAD (ECT2,NGPPE,1,0)
   55 CALL FREAD (ECT2,ELID,1,0)
      IF (ELID .EQ. 0) GO TO 50
      CALL FREAD (ECT2,0,-1,0)
      CALL FREAD (ECT2,GPTS,NGPPE,0)
      IF (OFFSET .NE. 0) CALL FREAD (ECT2,0,-OFFSET,0)
      IF (NGPPE .LE. 2) GO TO 55
      IJ = 1
      IK = 3
   60 J  = 0
      DO 70 I = IJ,IK
      J  = J + 1
      IG = GPTS(I)
      IG = IABS(GPLST(IG))
      IF (INDEX .LE. 3) A(J) = U(INDEX,IG)
      IF (INDEX .GT. 3) A(J) = SQRT(U(1,IG)**2 +U(2,IG)**2 +U(3,IG)**2)
      IF (DEFORM .NE. 0) GO TO 65
      PT(2*J-1) = X(2,IG)
      PT(2*J  ) = X(3,IG)
      GO TO 70
   65 PT(2*J-1) = S(1,IG)
      PT(2*J  ) = S(2,IG)
   70 CONTINUE
      PT(7) = PT(1)
      PT(8) = PT(2)
      A(4)  = A(1)
      DO 90 I = 1,NCNTR
      IF (COLOR .EQ. 0) GO TO 75
      J = IABS(COLOR)
      IF (NCNTR .LE. J) PEN = I*J/NCNTR
      IF (NCNTR .GT. J) PEN = 1 + I/(NCNTR/J)
      IF (PEN   .GT. J) PEN = J
   75 CONTINUE
      DO 80 J = 1,3
      XX(J) = XMIN - 1.0
      D = A(J) - A(J+1)
      IF (ABS(A(J  )-CNTR(I)).GT.ABS(D) .OR.
     1    ABS(A(J+1)-CNTR(I)).GT.ABS(D)) GO TO 80
      IF (D .EQ. 0.0) D = 1.0
      XX(J) = PT(2*J-1) + (PT(2*J+1)-PT(2*J-1))*(A(J)-CNTR(I))/D
      YY(J) = PT(2*J  ) + (PT(2*J+2)-PT(2*J  ))*(A(J)-CNTR(I))/D
   80 CONTINUE
      XX(4) = XX(1)
      YY(4) = YY(1)
      DO 85 J = 1,3
      IF (XX(J).LT.XMIN .OR. XX(J+1).LT.XMIN) GO TO 85
      CALL LINE (XX(J),YY(J),XX(J+1),YY(J+1),PEN,0)
      LABEL(I) = LABEL(I) + 1
      IF (LABEL(I) .NE. 4) GO TO 85
      LABEL(I) = 0
      CALL WRITE (SCR1,I,1,0)
      CALL WRITE (SCR1,XX(J),1,0)
      CALL WRITE (SCR1,YY(J),1,0)
   85 CONTINUE
   90 CONTINUE
      IF (NGPPE.EQ.3 .OR. IJ.EQ.3) GO TO 55
      GPTS(NGPPE+1) = GPTS(1)
      IJ = 3
      IK = 5
      GO TO 60
  100 CALL BCKREC (ECT2)
      DO 115 GP = 1,NGPSET
      DO 105 I  = 1,3
      J  = AXIS(I)
      IJ = IABS(J)
      A(I) = SIGN(I)*U(IJ,GP)
  105 CONTINUE
      DO 110 I = 1,3
      U(I,GP) = A(I)*(DMAX/DEFMAX)
  110 CONTINUE
  115 CONTINUE
  120 CALL CLOSE (SCR1,1)
      RETURN
      END

      SUBROUTINE MATGEN
C
C     THE PURPOSE OF THIS MODULE IS TO GENERATE CERTAIN KINDS OF
C     MATRICES ACCORDING TO ONE OF SEVERAL SIMPLE USER SELECTED OPTIONS
C
C     MATGEN      TAB/OUT/P1/P2/P3/P4/P5/P6/P7/P8/P9/P10/P11  $
C
C     TAB - INPUT TABLE - (OPTIONAL) FOR USE IN GENERATING THE MATIRX
C                 (THIS DATA MAY BE ASSUMED TO BE INPUT VIA DTI CARDS.)
C             = EQEXIN TABLE  FOR P1 =  9
C             = USET   TABLE  FOR P1 = 11
C             = ANY GINO FILE FOR P1 = 10
C
C     OUT - OUTPUT MATRIX - IF PURGED AND P1 IS NOT 10, P1 WILL BE SET
C               TO -1 AND RETURN
C
C     P1      - INPUT - INTEGER, OPTION SELECTION. (DEFULAT P1 = 3)
C             = 1, GENERATE A RSP IDENTITY MATRIX OF ORDER P2.
C             = 2, GENERATE AN IDENTITY MATRIX OF ORDER P2, FORM 8
C             = 3, GENERATE A DIAGONAL MATRIX FORM INPUT FILE T
C             = 4, GENERATE A PARTERN MATRIX
C             = 5, GENERATE A MATRIX OF PSEUDO-RANDOM NUMBERS.
C             = 6, GENERATE PARTITION VECTOR OF ORDER P2, WITH P3 ZERO'S
C                  CLOOWED BY P4 ONE'S FOLLOWED BY P5 ZERO'S ETC.
C                  REMAINER IS ALWAYS AERO. TOO MANY DEFINITIONS IS AN
C                  ERROR.
C             = 7, GENERATE A NULL MATRIX
C             = 8, GENERATE A MATRIX FROM EQUATIONS BASED ON ITS INDICES
C             = 9, GENERATE A TRANSFORMATION BETWEEN EXTERNAL AND
C                  INTERANL MATRICES, OF G-SET SIZE.
C                  P2 = 0, OUTPUTS INT-EXT (DEFAULT)
C                  P2 = 1, OUTPUTS TRANSPOSE EXT-INT
C                  P3 = NO. OF TERMS IN G-SET (REQUIRED). USE LUSET IN
C                       MOST SOLUTION SEQUENCES.
C             =10, ALLOW USER TO ALTER DATA BLOCK TRAILER.
C             =11, GENERATE A RECTANGULAR MATRIX, DRIVEN BY USET TABLE
C
C     P2 - P11 -   OPTION PARAMETERS - INTEGER - INPUT AND OUTPUT
C                  INPUT  AS OPTION VALUE (1 THRU NP)
C                  OUTPUT AS -1 IF AND ONLY IF OUTPUT DATA BLOCK IS PRE-
C                  PURGED
C                  DEFAULT VALUES FOR P2 THRU P11 ARE ZEROS
C
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL         LSHIFT
      INTEGER          MCB(7),NAM(2),P(11),CODE(2),IX(12)
      REAL             VAL,RX(7),TMP(7)
      DOUBLE PRECISION D(2)
      CHARACTER        UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG /  UFM,UWM,UIM,SFM
      COMMON /BLANK /  P1,P2,P3,P4,P5,P6,P7,P8,P9,P10,P11
      COMMON /SYSTEM/  SYSBUF,NOUT,DUM37(37),NBPW,DUM14(14),IPREC
      COMMON /MACHIN/  MACHX
      COMMON /ZBLPKX/  VAL(4),ROW
      COMMON /PACKX /  ITA,ITB,I2,J2,INCR2
CZZ   COMMON /ZZMGEN/  X(1)
      COMMON /ZZZZZZ/  X(20000)
      EQUIVALENCE      (VAL(1),D(1)),(X(1),IX(1),RX(1)),(P(1),P1)
      DATA    NAM   /  4HMATG,4HEN  /,  NP /  11   /
      DATA    EQE   ,  XIN / 4HEQEX, 4HIN  /, CODE / 6,1 /
      DATA    OUT   ,  T      /
     1        201   ,  101    /
C
C     IF OUTPUT DATA BLOCK IS PRE-PURGED, SET P1 = -1 AND RETURN
C
      IF (P1 .EQ. 10) GO TO 30
      MCB(1) = OUT
      CALL RDTRL (MCB)
      IF (MCB(1) .LE. 0) GO TO 1580
C
C     CHECK INPUT FILE REQUIREMENT
C
   30 IX(1) = T
      CALL RDTRL (IX(1))
      IF (P1 .EQ. 10) GO TO 1000
      IF (P1.EQ.3 .OR. P1.EQ.9 .OR. P1.EQ.10 .OR. P1.EQ.11) GO TO 50
      IF (IX(1) .EQ. 0) GO TO 50
      CALL FNAME (IX(1),RX(2))
      WRITE  (NOUT,40) UWM,RX(2),RX(3),P1
   40 FORMAT (A25,' FROM MODULE MATGEN. INPUT DATA BLOCK ',2A4,' IS ',
     1       'NOT NEEDED FOR OPTION',I3)
C
C     CHECK OPEN CORE AND OPEN OUTPUT DATA BLOCK
C
   50 LCOR = KORSZ(IX(1))
      IF (P1 .EQ. 2) GO TO 200
      IF (LCOR .LT. SYSBUF) GO TO 1500
      IBUF1 = LCOR  - SYSBUF - 1
      IBUF2 = IBUF1 - SYSBUF
      CALL GOPEN (OUT,IX(IBUF1),1)
      LCOR = LCOR - SYSBUF
C
C     TEST FOR VALID OPTION AND BRANCH ON OPTION.
C
      IF (P1 .EQ. 0) P1 = 3
      IF (P1.LT.0 .OR. P1.GT.NP) GO TO 1510
      GO TO (100,200,300,400,500,600,700,800,900,1000,1100), P1
C
C     OPTION 1 - GENERATE A RSP IDENTITY MATRIX OF ORDER P2, AND TRAILER
C     ========   P2 = ORDER OF MATRIX
C                P3 = SKEW FLAG, IF NONZERO, GENERATE A SKEW-DIAGONAL
C                     MATRIX
C                P4 = PRECISION (1 OR 2). IF ZERO, USE MACHINE PRECISION
C
  100 IF (P2 .GT. 0) GO TO 110
      IPX = 2
      PX  = P2
      GO TO 1530
  110 ITA = 1
      ITB = P4
      IF (P4 .EQ. 0) ITB = IPREC
      INCR2 = 1
      CALL MAKMCB (MCB,OUT,P2,6,ITB)
      DO 150 I = 1,P2
      RX(I) = 1.0
      I2 = I
      J2 = I
      CALL PACK (IX,OUT,MCB)
  150 CONTINUE
CWKBI SPR93023 12/93
      CALL CLOSE ( OUT, 1 )
      GO TO 210
C
C     OPTION 2 - GENERATE AN IDENTITY TRAILER (FORM = 8)
C     ========   P2 = ORDER OF MATRIX
C
C                ** CAUTION ** FORM = 8 MATRICES DO NOT REALLY EXIST
C                ONLY CERTAIN  ROUTINES CAN PROCESS THEM
C                e.g. FBS, MPYAD, CEAD etc.
C
  200 MCB(1) = OUT
      MCB(2) = P2
      MCB(3) = P2
      MCB(4) = 8
      MCB(5) = 1
      MCB(6) = 1
C     MCB(7) = LSHIFT(1,NBPW-2) + P2
      MCB(7) = LSHIFT(1,NBPW-2 - (NBPW-32)) + P2
C
C     ADD (NBPW-32) TO MCB(7) SO THAT CRAY, WITH 48-BIT INTEGER WILL
C     NOT GET INTO TROUBLE. (SEE SDCOMP AND WRTTRL)
C
  210 CALL WRTTRL (MCB)
      GO TO 1700
C
C     OPTION 3 - GENERATE A DIAGONAL MATRIX FROM INPUT TABLE T
C     ========   P2 = DATA TYPE OF T
C                P3 = 0, FORM 6 MATRIX IS GENERATED
C                   = 1, FORM 3 MATRIX IS GENERATED
C
C     THIS OPTION IS THE ORIGINAL MATGEN IN COSMIC MATGEN
C     SKIP HEADER RECORD, AND BEGINNING RECORD ON T
C     PICKUP DATA IN ARRAY OF 7 WORDS. DIAGONAL VAULE ON THE 3RD
C
  300 LCOR = LCOR - SYSBUF
      IF (LCOR .LT. SYSBUF) GO TO 1500
      IF (P2 .EQ. 0) P2 = 1
      CALL OPEN (*1550,T,IX(IBUF2),0)
      CALL SKPREC (T,2)
      ITA = P2
      ITB = IPREC
      INCR2 = 1
      FORM = 6
      IF (P3 .EQ. 1) FORM = 3
      CALL MAKMCB (MCB,OUT,0,FORM,IPREC)
      M  = 0
  310 CALL READ (*1560,*330,T,TMP,7,0,0)
      M  = M + 1
      IF (P3 .EQ. 1) GO TO 320
      I2 = M
      J2 = M
      CALL PACK (TMP(3),OUT,MCB)
      GO TO 310
  320 RX(M) = TMP(3)
      GO TO 310
  330 IF (P3 .EQ. 1) GO TO 340
      MCB(3) = MCB(2)
      GO TO 350
  340 I2 = 1
      J2 = M
      CALL PACK (RX,OUT,MCB)
      MCB(2) = 1
      MCB(3) = M
  350 CALL CLOSE (T,1)
      GO TO 210
C
C     OPTION 4 - GENERATE A PATTERN MATRIX
C     ========   P2 = NUNBER OF COLUMNS
C                P3 = NUMBER OF ROWS
C                P4 = PRECISION (1 OR 2). IF 0, USE MACHINE PRECISION
C                P5 = NUMBER OF TERMS PER STRING. IF 0, USE 1
C                P6 = INCREMENT BETWEEN STRINGS. IF 0, USE 1
C                P7 = ROW NUMBER OF 1ST STRING IN COLUMN 1. IF 0, USE 1
C                P8 = INCREMENT TO 1ST ROW FOR SUBSEQUENT COLUMNS.
C                P9 = NUMBER OF COLS BEFORE RETURNING TO P7.
C
C                THE VALUE OF EACH NON-ZERO TERM IN THE MATRIX WILL BE
C                THE COLUMN NUMBER
C                e.g. TO GENERATE A 10x10 DIAGONAL MATRIX WITH THE COL.
C                NUMBER IN EACH DIAGONAL POSITION, CODE
C
C                MATGEN   ,/DIAG/4/10/10/0/1/10/1/1/10  $
C
  400 P2 = MAX0(P2,1)
      P3 = MAX0(P3,1)
      IF (P4.NE.1 .AND. P4.NE.2) P4 = 0
      IF (P4 .EQ. 0) P4 = IPREC
      P5 = MAX0(P5,1)
      P6 = MAX0(P6,1)
      P7 = MAX0(P7,1)
      P8 = MAX0(P8,0)
      P9 = MAX0(P9,1)
      IROW1 = P7
      L = 1
      CALL MAKMCB (MCB,OUT,P3,2,P4)
C
      DO 440 J = 1,P2
      IF (P4 .EQ. 1) VAL(1) = J
      IF (P4 .EQ. 2) D(  1) = J
      ROW = IROW1
      CALL BLDPK (P4,P4,OUT,0,0)
  410 CONTINUE
      DO 420 K = 1,P5
      IF (ROW .GT. P3) GO TO 430
      CALL ZBLPKI
      ROW = ROW + 1
  420 CONTINUE
      ROW = ROW + P6 - 1
      GO TO 410
  430 CALL BLDPKN (OUT,0,MCB)
CWKBI 9/93
  435 CONTINUE
      L = L + 1
      IROW1 = IROW1 + P8
CWKBR 9/93 IF (L .LE. P9) GO TO 430
      IF (L .LE. P9) GO TO 435
      L = 1
      IROW1 = P7
  440 CONTINUE
      GO TO 1400
C
C     OPTION 5 - GENERATE A MATRIX OF PSEUDO-RANDOM NUMBERS. THE NUMBERS
C     ========   SPAN THE RANGE 1. TO 1.0 WITH A NORMAL DISTRIBUTION
C                P2 = NUMBER OF COLUMNS
C                P3 = NUMBER OF ROWS
C                P4 = PRECISION (1 OR 2).  IF 0, USED MACHINE PRECISION
C                P5 = SEED FOR RANDOM NUMBER GENERATION.  IF P5.LE.0,
C                     THE TIME OF DAY (SECONDS PAST MIDNIGHT) WILL BE
C                     USED
C
C     OPTION 5 WAS WRITTEN BY G.CHAN/UNISYS 2/93
C
  500 ITA = 1
      ITB = P4
      IF (P4 .EQ. 0) ITB = IPREC
      FORM = 2
      IF (P2 .EQ. P3) FORM = 1
      I2 = 1
      J2 = P3
      INCR2 = 1
      CALL MAKMCB (MCB,OUT,P2,FORM,ITB)
      K  = P5
      IF (MACHX .EQ. 4) GO TO 560
C                   CDC
      IF (MACHX .EQ. 9) GO TO 530
C                    HP
C
      DO 520 I = 1,P2
      IF (P5 .EQ. 0) CALL CPUTIM (K,K,0)
      K  = (K/2)*2 + 1
      DO 510 J = 1,P3
CWKBR 5/95 SUN     RX(J) = RAN(K)
      RX(J) = RAND(K)
  510 CONTINUE
      CALL PACK (RX(1),OUT,MCB)
  520 CONTINUE
      GO TO 590
C
C     HP ONLY
C     ACTIVATE SRAND AND RAND() BELOW, AND COMMENT OUT RAN(K) ABOVE
C
  530 CONTINUE
      WRITE  (NOUT,535) SFM
  535 FORMAT (A25,'. MATGEN NEEDS TO ACTIVATE SRAND AND RAND() FOR HP')
      CALL MESAGE (-61,0,0)
      DO 550 I = 1,P2
      IF (P5 .EQ. 0) CALL CPUTIM (K,K,0)
C     CALL SRAND (K)
      DO 540 J = 1,P3
C     RX(J) = RAND()
  540 CONTINUE
      CALL PACK (RX(1),OUT,MCB)
  550 CONTINUE
      GO TO 590
C
C     CDC ONLY
C     ACTIVATE SRAND AND RAND() BELOW, AND COMMENT OUT RAN(K) ABOVE
C
  560 CONTINUE
      WRITE  (NOUT,565) SFM
  565 FORMAT (A25,'. MATGEN NEEDS TO ACTIVATE RANSET AND RANF() FOR CDC'
     1       )
      CALL MESAGE (-61,0,0)
      DO 580 I = 1,P2
      IF (P5 .EQ. 0) CALL CPUTIM (K,K,0)
C     CALL RANSET (K)
      DO 570 J = 1,P3
C     RX(J) = RANF()
  570 CONTINUE
      CALL PACK (RX(1),OUT,MCB)
  580 CONTINUE
C
  590 CALL CLOSE  (OUT,1)
      CALL WRTTRL (MCB(1))
      GO TO 1700
C
C     OPTION 6 - GENERATE A PARTITIONING VECTOR FOR USE IN PARTN OR
C     ========   MERGE
C                P2 = NUMBER OF ROWS
C                P3,P5,P7,P9  = NUMBER OF ROWS WITH ZERO COEFFICIENTS
C                P4,P6,P8,P10 = NUMBER OF ROWS WITH UNIT COEFFICIENTS
C
C                IF SUM OF P3 THRU P10 IS .LT. P2, THE REMAINING TERMS
C                CONTAIN ZEROS
C                IF SUM OF P3 THRU P10 IS .GT. P2, THE TERMS ARE IGNORED
C                AFTER P2
C                e.g. GENERATE A VECTOR OF 5 UNIT TERMS FOLLOWED BY 7
C                ZEROS, FOLLOWED BY TWO UNIT TERMS
C
C                MATGEN,   ,/UPART/6/14/0/5/7/2   $
C
C     OPTION 6 WAS ORIGINALLY WRITTEN BY P.KIRCHMAN/SWALES 1/92
C     RE-CODED BY G.CHAN/UNISYS FOR ALL COMPILERS,  2/93
C
  600 IPX = 2
      PX  = P2
      IF (P2 .LE. 0) GO TO 1530
      INCR2 = 1
      I2  = 1
      J2  = P2
      ITA = 1
      ITB = 1
      CALL MAKMCB (MCB,OUT,P2,2,ITB)
      TOT = 0
      DO 610 I = 3,11
  610 TOT = TOT + P(I)
      IF (TOT .GT. P2) WRITE (NOUT,620) UFM,P1,P2
      IF (TOT .LT. P2) WRITE (NOUT,630) UWM,P1
  620 FORMAT (A23,' FROM MATGEN, OPTION',I3,'. TOO MANY ENTRIES FOR ',
     1       'SPECIFIED SIZE',I7)
  630 FORMAT (A25,' FORM MATGEN, OPTION',I3,'. THE NUMBER OF ENTRIES ',
     1       'SPECIFIED BY PARAMETERS IS LESS THAN THE TOTAL SIZE', /5X,
     2       'OF THE PARTITION. THE REMAINING RENTRIES ARE ZERO FILLED')
      K = 1
      DO 660 I = 3,9,2
      PI = P(I)
      DO 640 J = 1,PI
CWKBR SPR 93023 12/93      IX(K) = 0
      RX(K) = 0.
  640 K = K + 1
      PI = P(I+1)
      DO 650 J = 1,PI
CWKBR SPR 93024 12/93      IX(K) = 1
      RX(K) = 1.0
  650 K = K + 1
  660 CONTINUE
      IF (K .GE. P2) GO TO 680
      DO 670 I = K,P2
  670 IX(I) = 0
  680 CALL PACK (IX,OUT,MCB)
      CALL CLOSE (OUT,1)
      CALL WRTTRL (MCB)
      GO TO 1700
C
C     OPTION 7 - GENERATE A NULL MATRIX
C     ========   P2 = NUMBER OF ROWS
C                P3 = NUMBER OF COLUMNS
C                P4 = FORM; IF P4 = 0, AND P2 = P3, FORM WILL BE 6
C                     (SYMMETRIC). OTHERWISE P4 IS 2 (RECTANGULAR)
C                P5 = TYPE: IF P5 = 0, TYPE IS MACHINE PRECISION
C
  700 D(1) = 0.0D0
      D(2) = 0.0D0
      ITA = 1
      ITB = P5
      IF (P5 .EQ. 0) ITB = IPREC
      FORM = P4
      IF (P4.EQ.0 .AND. P2.EQ.P3) FORM = 6
      IF (P4.EQ.0 .AND. P2.NE.P3) FORM = 2
      I2 = 1
      J2 = 1
      INCR2 = 1
      CALL MAKMCB (MCB,OUT,P2,FORM,ITB)
      DO 750 I = 1,P3
      CALL PACK (VAL,OUT,MCB)
  750 CONTINUE
      CALL CLOSE  (OUT,1)
      CALL WRTTRL (MCB(1))
      GO TO 1700
C
C     OPTION 8 - GENERATE A MATRIX FROM EQUATIONS BASED ON IT INDICES
C     ========   P2 =  0, GENERATE ALL TERMS
C                  .NE.0, GENERATE ONLY DIAGONAL TERMS
C                P3 =     NUMBER OF ROWS
C                P4 =     NUMBER OF COLUMNS
C                P5 =     NUMBER OF THE RECORD IN THE INPUT DTI TABLE
C                         USED TO DEFINE REAL COEFFICIENTS
C                  .LT.0, COEFFICIENT TAKEN FROM DTI TRAILER
C                         COEFF(TRAILER1) = FLOAT(TRAILER2)   TRAILER
C                         COEFF(TRAILER3) = FLOAT(TRAILER4)   ITEMS ARE
C                         COEFF(TRAILER5) = FLOAT(TRAILER6)   INTEGERS
C
C                   = 0,  DATA PAIRS FROM RECORD 0 (DATA BLOCK HEADER
C                         RECORD) ARE INTERPRETED AS DFINING
C                         COEFF(V1) = V2     V1 IS INTEGER, V2 IS REAL
C                  .GT.0, DATA PAIRS FROM RECORD P5 INTERPRETED AS ABOVE
C                P6 =     NUMBER OF THE RECORD IN THE INPUT DTI TABLE
C                         USED TO DEFINE IMAGINARY DOEFFICIENTS D(I)
C                  .LE.0, NO DOEFFICIENTS DEFINED
C                  .GT.0, DATA PAIRS FROM RECORD P6 INTERPRETED AS ABOVE
C                         WHERE D(V1) = V2
C                P7 =     FORM OF OUTPUT MATRIX
C                  .LE.0, FORM = 1 OR 2, DEPENDING ON P3 AND P4
C                  .GT.0, FORM SET TO P7
C                P8 =     COEFFICIENT PRINT FLAG
C                   = 0,  DO NOT PRINT COEFFICIENT LISTS
C                  .NE.0, PRINT COEFFICIENTS LISTS C(L) AND D(L) FROM
C                         DTI INPUT. (PRINT D(L) LIST ONLY IF P6.GT.0)
C
C                SEE USER MANUAL FOR THE EQUATION USED TO DETERMINE THE
C                COEFFICIENT OF THE (I,J)TH TERM OF THE OUTPUT MATRIX
C
  800 WRITE (NOUT,1200) UWM,P1
      GO TO 1700
C
C     OPTION 9 - GENERATE A TRANSFORMATION BETWEEN EXTERNAL AND INTERNAL
C     ========   MATRICES FOR G-SET SIZE MATRICES
C                P2 = 0, OUTPUT NON-TRANSPOSED FACTOR, UEXT = MAT*UINT
C                   = 1, OUTPUT TRANSPOSED FACTOR, UEXT = MAT*UINT
C                P3 = NUMBER OF TERMS IN G-SET. THE PARAMETER LUSET
C                     CONTAINS THIS NUMBER IN MOST SOLUTION SEQUENCES
C
C                EXAMPLES -
C                1. TRANSFORM A g-SET SIZE VECTOR TO EXTERNAL SEQUENCE
C                ALTER XX  $ AFTER SDR1, ALL SDR1 OUTPUTS ARE IN
C                            INTERNAL SEQUENCE
C                MATGEN  EQEXIN/INTEXT/9//LUSET $
C                MPYAD   INTEXT,UGV,/UGVEXT/1 $
C
C                2. TRANSFORM AN a-SET SIZE MATRIX TO EXTERNAL SEQUENCE
C                ALTER XX  $ AFTER KAA IS GENERATED, ALL MATRICES ARE IN
C                            INTERNAL SEQUENCE
C                MATGET  EQEXIN/INTEXT/9/0/LUSET $
C                SMPYAD  INTEXT,KAGG,INTEXT,,/KAAGEXT/3////1////6 $
C                $ (KAAGEXT) = TRANSPOSE(INTEXT)*(KAAG)*(INTEXT)
C                $ ITS FORM IS 6 (SYMMETRIC)
C
C     OPTION 9 WAS ORIGINALLY WRITTEN BY P.KIRCHMAN/SWALES 1/92
C     RE-CODED BY G.CHAN/UNISYS FOR ALL COMPILERS,  2/93
C
  900 IPX = 3
      PX  = P(3)
      IF (PX .LE. 0) GO TO 1530
      NUSET = PX
      L     = 2
      NVAL  = IX(L)
      CALL FNAME (T,TMP(1))
      IF (TMP(1).NE.EQE .OR. TMP(2).NE.XIN) GO TO 1600
      CALL OPEN (*1550,T,IX(IBUF2),0)
      CALL FWDREC (*1560,T)
      CALL FWDREC (*1560,T)
      CALL READ (*1560,*910,T,IX(1),IBUF2-1,1,L)
  910 CALL CLOSE (T,1)
      IF (L .NE. NVAL*2) GO TO 1620
      ITA = IPREC
      ITB = ITA
      CALL MAKMCB (MCB,OUT,NUSET,2,ITB)
      INCR2 = 1
      VAL(1)= 1.0
      IF (ITA .EQ. 2) D(1) = 1.0D+0
      TOT   = 0
      IF (P2 .GT. 0) GO TO 930
C
C     NO TRANSPOSE
C
      DO 920 I = 1,NVAL
      IS2 = I*2
      A = IX(IS2)/10
      B = MOD(IX(IS2),10)
      C = CODE(B)
      DO 920 J = 1,C
      I2 = A
      J2 = A
      CALL PACK (VAL,OUT,MCB)
  920 A = A + 1
      TOT = TOT + C
      GO TO 980
C
C     TRANSPOSE
C
  930 NVAL2 = NVAL*2
      POS = 1
      DO 940 I = 1,NVAL
      IS2 = I*2
      A = IX(IS2)/10
      B = MOD(IX(IS2),10)
      IX(IS2-1) = POS
  940 POS = POS + CODE(B)
      DO 970 I = 4,NVAL2,2
      J = NVAL2
      FLAG = 0
  950 IF (IX(J) .GE. IX(J-2)) GO TO 960
      FLAG = 1
      K = IX(J  )
      L = IX(J-1)
      IX(J  ) = IX(J-2)
      IX(J-1) = IX(J-3)
      IX(J-2) = K
      IX(J-3) = L
  960 J = J - 2
      IF (J .GE. I) GO TO 950
      IF (FLAG .EQ. 0) GO TO 980
  970 CONTINUE
C
  980 DO 990 I = 1,NVAL
      IS2 = I*2
      A = IX(IS2)/10
      B = MOD(IX(IS2),10)
      A = IX(IS2-1)
      C = CODE(B)
      DO 990 J = 1,C
      I2 = A
      J2 = A
      CALL PACK (VAL,OUT,MCB)
  990 A  = A + 1
      TOT = NVAL*C
      IF (NUSET .NE. TOT) GO TO 1640
      CALL WRTTRL (MCB)
      CALL CLOSE  (OUT,1)
      GO TO 1700
C
C     OPTION 10 - ALLOW USER TO ALTER DATA BLOCK TRAILER
C     =========
C     IF PI IS NEGATIVE, THE CORRESPONDING TRAILER WORD (I) IS SET TO
C     ZERO
C
 1000 IF (IX(1) .EQ. 0) GO TO 1050
      CALL FNAME (IX(1),IX(11))
      WRITE  (NOUT,1010) UIM,IX(11),IX(12),(IX(I),I=2,7)
 1010 FORMAT (A29,' FROM MATGEN MODULE, OPTION 10. TRAILER OF ',2A4,2H -
     1,      /5X,'OLD - ',6I7)
      DO 1020 I = 2,7
      IF (P(I) .NE. 0) IX(I) = P(I)
      IF (P(I) .LT. 0) IX(I) = 0
 1020 CONTINUE
      WRITE  (NOUT,1030) (IX(I),I=2,7)
 1030 FORMAT (5X,'NEW - ',6I7)
      IF (IX(2).EQ.IX(3) .AND. IX(4).EQ.2 .AND. IX(7).NE.0)
     1   WRITE (NOUT,1040) UIM
 1040 FORMAT (A29,'. SINCE ROW = COLUMN, RECTANGULAR FORM 2 WILL BE ',
     1       'CHANGED TO SQUARE FORM 1 AUTOMATICALLY')
      IX(1) = 199
      CALL WRTTRL (IX(1))
      GO TO 1700
C
 1050 WRITE  (NOUT,1060) UWM
 1060 FORMAT (A25,' FROM MATGEN, OPTION 10. INPUT FILE MISSING')
      GO TO 1700
C
C     OPTION 11 - GENERATE A RECTANGULAR MATRIX, DRIVEN BY USET TABLE
C     =========   P2 = 1, GENERATE A NULL MATRIX
C                  .NE.1, GENERATE A NULL MATRIX WITH AN IDENTITY MATRIX
C                         STORED IN IT
C                 P3 = NUMBER OF COLUMNS OF OUTPUT MATRIX, IF P2 = 1
C                    = BIT POSITION OF SET THAT DEFINES NUMBER OF ROW,
C                      IF P2.NE.1. SEE SECTION 1.4.10 FOR BIT POSITION
C                      LIST. DEFAULT IS A-SET SIZE.
C                 P4 = NOT USED IF P2 = 1. THE OUTPUT MATRIX WILL BE
C                      NULL AND HAVE P3 COLUMNS AND A-SET SIZE ROWS
C                    = BIT POSITION OF SET THAT DEFINES NUMB OF COLUMNS
C                      IF P2.NE.1. DEFAULT IS L-SET SIZE
C
C                 IF P2.NE.1, AND ONE OR BOTH OF THE SETS REQUESTED IN
C                 P3 AND P4 DOES NOT EXIST, THEN MAT IS RETURNED PURGED,
C                 AND P5 IS RETURNED WITH THE VALUE OF -1. IF MAT DOES
C                 EXISTS, P5 IS RETURNED WITH THE VALUE 0
C
 1100 WRITE  (NOUT,1200) UWM,P1
 1200 FORMAT (A25,' FROM MATGEN MODULE, OPTION',I3,' IS NOT AVAILABLE')
      GO TO 1700
C
C     WRAP-UP AND RETURN TO EXECUTIVE SYSTEM
C
 1400 CALL CLOSE  (OUT,1)
      CALL WRTTRL (MCB)
      GO TO 1700
C
C     ERROR MESSAGES
C
 1500 CONTINUE
      LCOR = SYSBUF - LCOR
      CALL MESAGE (-8,LCOR,NAM)
      GO TO 1700
C
 1510 WRITE  (NOUT,1520) UFM,P1
 1520 FORMAT (A23,' IN MATGEN, ILLEGAL VALUE FOR OPTION PARAMETER =',I5)
      GO TO 1690
C
 1530 WRITE  (NOUT,1540) UFM,IPX,PX
 1540 FORMAT (A23,' IN MATGEN, ILLEGAL VALUE FOR PARAMETER ',I1,3H = ,
     1        I5)
C
 1550 J = -1
      GO TO 1570
 1560 J = -2
 1570 CALL MESAGE (J,T,NAM)
C
 1580 WRITE  (NOUT,1590) UFM,P1
 1590 FORMAT (A23,'. OPTION',I3,' OUTPUT DATA BLOCK IS MISSING')
      P1 = -1
      GO TO  1700
 1600 WRITE  (NOUT,1610) UFM,TMP(1),TMP(2)
 1610 FORMAT (A23,'. OPTION 9. INPUT FILE IS ',2A4,', NOT EQEXIN')
      GO TO  1690
 1620 WRITE  (NOUT,1630) UFM,L,NVAL
 1630 FORMAT (A23,'. EQEXIN RECORD LENGTH NOT MATCH TWICE TRAIL(2)',2I9)
      GO TO  1690
 1640 WRITE  (NOUT,1650) UFM,NUSET,TOT
 1650 FORMAT (A23,'. OPTION 9, LUSET OF',I9,' DOES NOT AGREE WITH SIZE',
     1       ' OF EQEXIN',I9)
 1690 CALL MESAGE (-61,0,NAM)
 1700 RETURN
      END

      SUBROUTINE FBSINV (X,Y,IOBUFF)
C
C     SINGLE PRECISION VERSION
C
C     FBSINV IS A SPECIAL FORWARD-BACKWARD SUBSTITUTION ROUTINE FOR
C     INVPWR. IT OPERATES ON CONJUNCTION WITH SDCOMP.
C     THE ARITHMETIC PRECISION IS THAT OF THE INPUT FILE
C
C     FILEL  = MATRIX CONTROL BLOCK FOR THE LOWER TRIANGLE
C     X      = THE LOAD VECTOR
C     Y      = THE SOLUTION VECTOR
C     IOBUFF = NOT USED
C
      INTEGER         FILEL   ,PARM(3)  ,IBLK(15)
      REAL            X(1)    ,Y(1)
      COMMON /FBSX  / FILEL(7)
      EQUIVALENCE    (FILEL(3),NROW), (FILEL(5),LTYPE)
      DATA    PARM  / 4H      ,4HFBSI, 4HNV   /
C
C     FORWARD PASS
C
      PARM(1) = FILEL(1)
      IBLK(1) = FILEL(1)
      IF (LTYPE .EQ. 2) GO TO 20
      IF (LTYPE .NE. 1) GO TO 50
C
C     TRANSFER THE SINGLE PRECISION LOAD VECTOR TO THE SOLUTION VECTOR
C
      DO 10 I = 1,NROW
   10 Y(I) = X(I)
      CALL FBS1 (IBLK,Y,Y,NROW)
      GO TO 40
C
C     TRANSFER THE DOUBLE PRECISION LOAD VECTOR TO THE SOLUTION VECTOR
C
   20 NROW2 = 2*NROW
      DO 30 I = 1,NROW2
   30 Y(I) = X(I)
      CALL FBS2 (IBLK,Y,Y,NROW2)
C
   40 CALL REWIND (FILEL)
      CALL SKPREC (FILEL,1)
      RETURN
C
C     FATAL ERRORS
C
   50 CALL MESAGE (-7,PARM(1),PARM(2))
      RETURN
      END

      SUBROUTINE XYDUMP (OUTFIL,TYPE)
C
      LOGICAL         PUNCH      ,PLOT       ,PRINT      ,OUTOPN    ,
     1                NULL       ,RANDOM     ,ONES       ,PAPLOT    ,
     2                ON         ,OK         ,INTORE     ,DEC
      INTEGER         ONEONE(2)  ,EOR        ,OUTFIL     ,TCURVE    ,
     1                XAXIS      ,YAXIS      ,YTAXIS     ,YBAXIS    ,
     2                CURVE      ,YCYCLE(2)  ,XCYCLE     ,CENTER    ,
     3                Z          ,LIMIT(2,3) ,STEPS      ,VECTOR    ,
     4                FILE       ,SUBC       ,VECID      ,BUF       ,
     5                BEGIN      ,TYPE       ,TWO1
      REAL            YMIN(2)    ,YMAX(2)    ,VALUE(60)  ,RZ(1)     ,
     1                RBUF(100)  ,IDOUTR(300),YLIMIT(2,3)
      COMMON /MACHIN/ MACHX
      COMMON /BLANK / BLKCOM     ,VARI(3)    ,NFRAME     ,NCARD
      COMMON /TWO   / TWO1(32)
      COMMON /ZZZZZZ/ Z(1)
      COMMON /XYWORK/ FILE       ,TCURVE(32) ,NTOPS      ,PRINT     ,
     1                IFILE      ,XAXIS(32)  ,NBOTS      ,PLOT      ,
     2                VECTOR     ,YAXIS(32)  ,VECID(5)   ,PUNCH     ,
     3                MAJOR      ,YTAXIS(32) ,SUBC(5)    ,CENTER    ,
     4                RANDOM     ,YBAXIS(32) ,IDIN(153)  ,BUF(100)  ,
     5                IVALUE(60) ,IAT        ,IDOUT(300) ,OUTOPN    ,
     6                STEPS      ,NAT        ,PAPLOT
      EQUIVALENCE     (LIMIT(1,1),YLIMIT(1,1)) ,(Z(1),RZ(1)) ,
     1                (BUF(1),RBUF(1)) ,(IDOUT(1),IDOUTR(1)) ,
     2                (IVALUE(1),VALUE(1))
      DATA   ONEONE / 1,1 /, EOR/ 1 /, NOEOR/ 0 /
      DATA   NPAPLT / 0   /
C
C     SET MINIMUM X-DIFFERENCE
C
C     BUT FIRST CONVERT X FROM INTERGER TO REAL IF NECESSARY.
C
      INTORE = .FALSE.
      DEC = MACHX.EQ.5 .OR. MACHX.EQ.6 .OR. MACHX.EQ.21
      J   = 1
      IS1 = STEPS - 1
C
C     NOW SEARCH LIST FOR FIRST NON-ZERO ENTRY
C
   10 IF (Z(IAT+J) .NE. 0) GO TO 20
      J = J + 1
      IF (J .GT. IS1) GO TO 50
      GO TO 10
C
C              UNIVAC             CDC             CRAY
   20 IF (MACHX.EQ.3 .OR. MACHX.EQ.4 .OR. MACHX.EQ.12)
     1   IF (IABS(Z(IAT+J))-TWO1(2)) 40,40,50
C
C     IBM, VAX, UNIX
C
      IF (.NOT.DEC .AND. IABS(Z(IAT+J)).GT.TWO1(9)) GO TO 50
      IF (     DEC .AND. (Z(IAT+J).LT.1 .OR. Z(IAT+J).GT.127)) GO TO 50
   40 INTORE = .TRUE.
      IF (J .EQ. 1) RZ(IAT+J) = Z(IAT+J)
C
   50 OK = .FALSE.
      DO 70 I = 1,IS1
      J = IAT + I
      IF (INTORE) RZ(J+1) = Z(J+1)
      DIFF = RZ(J+1) - RZ(J)
      IF (.NOT.OK) GO TO 60
      IF (DIFF .EQ. 0.0) GO TO 70
      XINC = AMIN1(XINC,DIFF)
      GO TO 70
   60 IF (DIFF .EQ. 0.0) GO TO 70
      XINC = DIFF
      OK   = .TRUE.
   70 CONTINUE
      IF (.NOT.OK) XINC = 1.0
C
C     SET XMIN AND XMAX FOR ALL DATA
C
      XCYCLE    = 0
      YCYCLE(1) = 0
      YCYCLE(2) = 0
      XMIN = RZ(IAT+1)
      J    = IAT + STEPS
      XMAX = RZ(J)
C
C     REDUCE THESE LIMITS TO USER SPECIFIED LIMITS
C
      IF (IVALUE(1) .NE. 1) XMIN = (VALUE(1))
      IF (IVALUE(2) .NE. 1) XMAX = (VALUE(2))
C
C     FURTHER EXPAND XLIMITS TO INCLUDE Y-AXIS INTERCEPT
C
      IF (IVALUE(9) .EQ. 1) GO TO 80
      IF (IVALUE(36).EQ.1 .AND. VALUE(9).LE.0.0) GO TO 90
      XMIN = AMIN1(XMIN,VALUE(9))
      XMAX = AMAX1(XMAX,VALUE(9))
C
C     IF X-DIRECTION IS LOG AND XMIN IS NEGATIVE OR ZERO, SET YMIN
C     EQUAL TO THE SMALLEST NON-ZERO POSITIVE VALUE
C
   80 IF (IVALUE(36) .NE. 1) GO TO 130
   90 IF (XMIN    .GT.  0.0) GO TO 120
      DO 100 I = 1,STEPS
      J = IAT + I
      IF (RZ(J) .GT. 0.0) GO TO 110
  100 CONTINUE
      XMIN = 1.0
      XMAX = 10.
      GO TO 120
  110 XMIN = RZ(J)
  120 CALL XYLOG (XMIN,XMAX,XCYCLE)
C
C     SWITCH XMIN AND XMAX (SAFETY CHECK) IF NECESSARY
C
  130 IF (XMIN .LE. XMAX) GO TO 140
      TEMP = XMIN
      XMIN = XMAX
      XMAX = TEMP
C
C     USING XMIN AND XMAX AS LIMITS DETERMINE Y-LIMITS FOR TOP AND
C     BOTTOM.
C
C     I1 = FIRST STEP WITHIN XMIN TO XMAX
C     I2 = LAST  STEP WITHIN XMIN TO XMAX
C
C     FIRST FIND I1 AND I2
C
  140 DO 150 I = 1,STEPS
      J = IAT + I
      IF (XMIN.LE.RZ(J) .AND. RZ(J).LE.XMAX) GO TO 160
  150 CONTINUE
      I1 = 0
      GO TO 180
  160 I1 = I
      J  = IAT + STEPS + 1
      DO 170 I = 1,STEPS
      J = J - 1
      IF (XMIN.LE.RZ(J) .AND. RZ(J).LE.XMAX) GO TO 190
  170 CONTINUE
  180 I2 = 0
      GO TO 200
  190 I2 = J - IAT
  200 IF (I1 .NE. 0) GO TO 210
C
C     FIND FOLLOWING VALUES FOR CURVES AS A GROUP
C
C    YLIMIT(1,1)=YMIN TOP, YLIMIT(1,2)=YMAX TOP, YLIMIT(1,3)=MIN POS TOP
C    YLIMIT(2,1)=YMIN BOT, YLIMIT(2,2)=YMAX BOT, YLIMIT(2,3)=MIN POS BOT
C
      YMIN(1) = 0.0
      YMIN(2) = 0.0
      YMAX(1) = 10.
      YMAX(2) = 10.
      GO TO 330
  210 M = 1
      IF (NBOTS .NE. 0) M = 2
      BEGIN = IAT
      DO 280 I = 1,M
      LIMIT(I,1) = 1
      LIMIT(I,2) = 1
      LIMIT(I,3) = 1
      DO 260 J = 1,NTOPS
      K  = J*STEPS + BEGIN
      J1 = K + I1
      J2 = K + I2
      IF (LIMIT(I,1) .NE. 1) GO TO 240
C
C     FIND FIRST NON-INTEGER 1 VALUE
C
      DO 220 K = J1,J2
      IF (Z(K) .NE. 1) GO TO 230
  220 CONTINUE
      GO TO 260
  230 YLIMIT(I,1) = RZ(K)
      YLIMIT(I,2) = RZ(K)
  240 DO 250 K = J1,J2
      IF (Z(K) .EQ. 1) GO TO 250
      YLIMIT(I,1) = AMIN1(RZ(K),YLIMIT(I,1))
      YLIMIT(I,2) = AMAX1(RZ(K),YLIMIT(I,2))
      IF (RZ(K) .LE. 0.0) GO TO 250
      IF (LIMIT(I,3) .EQ. 1) YLIMIT(I,3) = RZ(K)
      YLIMIT(I,3) = AMIN1(YLIMIT(I,3),RZ(K))
  250 CONTINUE
  260 CONTINUE
      BEGIN = CENTER
C
C     DEFAULT YLIMITS IF ALL CURVES NULL
C
      IF (LIMIT(I,1) .NE. 1) GO TO 270
      YLIMIT(I,1) = 0.0
      YLIMIT(I,2) = 100.
  270 IF (LIMIT(I,3) .EQ. 1) YLIMIT(I,3) = 10.0
C
  280 CONTINUE
C
C     SET FINAL Y-LIMITS FOR UPPER AND LOWER CURVES
C
C
C     K=1 IMPLIES WHOLE CURVES
C     K=2 IMPLIES UPPER AND LOWER CURVES
C
      K = 1
      IF (NBOTS .GT. 0) K = 2
      DO 320 I = 1,K
      YMIN(I) = YLIMIT(I,1)
      YMAX(I) = YLIMIT(I,2)
C
C     REDUCE THESE CURVE LIMITS TO LIMITS SET BY USER
C
      ITEMP = 2*(I+K)
      IF (IVALUE(ITEMP-1) .NE. 1) YMIN(I) = (VALUE(ITEMP-1))
      IF (IVALUE(ITEMP  ) .NE. 1) YMAX(I) = (VALUE(ITEMP  ))
C
C     FURTHER EXPAND LIMITS TO INCLUDE X-AXIS
C
      ITEMP = I + K
      IF (IVALUE(ITEMP+8) .EQ. 1) GO TO 290
      IF (IVALUE(ITEMP+35).EQ.1 .AND. VALUE(ITEMP+8).LE.0.E0) GO TO 300
      YMIN(I) = AMIN1(YMIN(I),VALUE(ITEMP+8))
      YMAX(I) = AMAX1(YMAX(I),VALUE(ITEMP+8))
C
C     IF Y-DIRECTION IS LOG AND YMIN IS NEGATIVE OR ZERO SET YMIN
C     EQUAL TO SMALLEST POSITIVE CURVE VALUE WITHIN XLIMITS
C
  290 IF (IVALUE(ITEMP+35) .NE. 1) GO TO 310
  300 IF (YMIN(I) .LE. 0.0) YMIN(I) = YLIMIT(I,3)
      CALL XYLOG (YMIN(I),YMAX(I),YCYCLE(I))
C
C     SWITCH YMIN AND YMAX (SAFETY CHECK) IF NECESSARY
C
  310 IF (YMIN(I) .LE. YMAX(I)) GO TO 320
      TEMP    = YMIN(I)
      YMIN(I) = YMAX(I)
      YMAX(I) = TEMP
  320 CONTINUE
C
C     ALL CURVE LIMITS HAVE NOW BEEN SET FOR THIS FRAME
C
C
C     OUTPUT EACH CURVE AND AN IDOUT RECORD IF PLOTS = .TRUE.
C
C     FILL IDOUT
C
  330 DO 340 I = 1,300
  340 IDOUT(I) = 0
      IF (PLOT .AND. OUTOPN) NFRAME = NFRAME + 1
      IDOUT(1) = SUBC(FILE)
      IDOUT(2) = NFRAME
      IDOUT(6) = VECTOR
      IDOUT(9) = IVALUE(45)
      IF (IVALUE(43) .EQ. 0) VALUE(43) = 1.0
      IDOUT(43)  = IVALUE(43)
      IDOUTR(10) = XINC
      IDOUT(245) = TYPE
      IDOUT(246) = STEPS
      IDOUTR(282)= VALUE(57)
      IF (IDOUTR(282) .LT. 1.0) IDOUTR(282) = 1.0
      IDOUT(283) = IVALUE(50)
      IF (IVALUE(47) .EQ. 3) IDOUT(283) = IVALUE(41)
      IDOUT(284) = IVALUE(47)
      IDOUT(285) = IVALUE(48)
      IDOUT(286) = IVALUE(49)
      IDOUT(287) = IVALUE(46)
      IDOUT( 44) = IVALUE(58)
      IDOUT( 45) = IVALUE(59)
      IF (PRINT) IDOUT(288) = 1
      IF (PLOT ) IDOUT(289) = 1
      IF (.NOT.PAPLOT) GO TO 350
      IF (.NOT.PLOT) IDOUT(289) = -1
      IF (     PLOT) IDOUT(289) =  2
      NPAPLT = NPAPLT+1
      IDOUT(281) = NPAPLT
  350 ON = .FALSE.
      IF (PLOT .OR. PAPLOT) ON = .TRUE.
      IF (PUNCH) IDOUT(290) = 1
      DO 360 I = 51,146
  360 IDOUT(I) = IDIN(I)
C
C     BRANCH ON TOP, BOTTOM, OR WHOLE CURVE (FIRST WILL BE TOP OR WHOLE)
C
      I = 3
      IF (Z(I).EQ.0 .OR. RANDOM) GO TO 400
C
C     TOP CURVE ID
C
      CURVE = 0
      IDOUT(7) = 1
      IDOUT(8) = 1
      IDOUTR(11) = XMIN
      IDOUTR(12) = XMAX
      IDOUTR(13) = YMIN(1)
      IDOUTR(14) = YMAX(1)
      IFLAG = 0
      IF (INTORE) IFLAG = 1
      CALL XYTICS (IDOUT(15),IDOUTR(15),IVALUE(17),IDOUT(11) ,
     1             IDOUT(12),IVALUE(21),XCYCLE,IFLAG)
      CALL XYTICS (IDOUT(23),IDOUTR(23),IVALUE(19),IDOUT(13),
     1             IDOUT(14),IVALUE(23),YCYCLE(1),0)
      IDOUT(31) = IVALUE(34) + IVALUE(25)
      IDOUT(32) = IVALUE(34) + IVALUE(26)
      IDOUT(33) = IVALUE(34) + IVALUE(29)
      IDOUT(34) = IVALUE(34) + IVALUE(30)
      IDOUT(35) = XCYCLE
      IDOUT(36) = YCYCLE(1)
      IDOUT(37) = IVALUE(15)
      IDOUT(38) = IVALUE(11)
      IF (IDOUT(38)  .EQ. 1) IDOUTR(38) = 0.0
      IF (IDOUTR(38) .LT. YMIN(1)) IDOUT(37) = 0
      IDOUT(39) = IVALUE(14)
      IDOUT(40) = IVALUE( 9)
      IF (IDOUT(40)  .EQ. 1) IDOUTR(40) = 0.0
      IF (IDOUTR(40) .LT. XMIN) IDOUT(39) = 0
      IDOUT(41) = IVALUE(40)
      IDOUT(243) = IVALUE(53)
      IDOUT(244) = IVALUE(54)
      DO 370 I=1,32
      IDOUT(I+146) = TCURVE(I)
      IDOUT(I+178) = XAXIS(I)
      IDOUT(I+210) = YTAXIS(I)
  370 CONTINUE
      GO TO 420
C
C     BOTTOM CURVE ID (SET ONLY VALUES THAT CHANGE FROM THE TOP CURVES)
C
  380 CURVE = 0
      IDOUT(7)   = -1
      IDOUTR(13) = YMIN(2)
      IDOUT(8)   = 1
      IDOUTR(14) = YMAX(2)
      CALL XYTICS (IDOUT(23),IDOUTR(23),IVALUE(20),IDOUT(13),
     1             IDOUT(14),IVALUE(24),YCYCLE(2),0)
      IDOUT(31) = IVALUE(35) + IVALUE(25)
      IDOUT(32) = IVALUE(35) + IVALUE(26)
      IDOUT(33) = IVALUE(35) + IVALUE(31)
      IDOUT(34) = IVALUE(35) + IVALUE(32)
      IDOUT(36) = YCYCLE(2)
      IDOUT(37) = IVALUE(16)
      IDOUT(38) = IVALUE(12)
      IF (IDOUT(38)  .EQ. 1) IDOUTR(38) = 0.0
      IF (IDOUTR(38) .LT. YMIN(2)) IDOUT(37) = 0
      IDOUT(243) = IVALUE(55)
      IDOUT(244) = IVALUE(56)
      DO 390 I = 1,32
      IDOUT(I+146) = TCURVE(I)
      IDOUT(I+178) = XAXIS(I)
      IDOUT(I+210) = YBAXIS(I)
  390 CONTINUE
      IPAIR = CENTER + STEPS
      GO TO 430
C
C     WHOLE CURVE ID
C
  400 CURVE = 0
      IDOUT(7) = 0
      IDOUT(8) = 1
      IDOUTR(11) = XMIN
      IDOUTR(12) = XMAX
      IDOUTR(13) = YMIN(1)
      IDOUTR(14) = YMAX(1)
      IFLAG = 0
      IF (INTORE) IFLAG = 1
      CALL XYTICS (IDOUT(15),IDOUTR(15),IVALUE(17),IDOUT(11),
     1             IDOUT(12),IVALUE(21),XCYCLE,IFLAG)
      CALL XYTICS (IDOUT(23),IDOUTR(23),IVALUE(18),IDOUT(13),
     1             IDOUT(14),IVALUE(22),YCYCLE(1),0)
      IDOUT(31) = IVALUE(33) + IVALUE(25)
      IDOUT(32) = IVALUE(33) + IVALUE(26)
      IDOUT(33) = IVALUE(33) + IVALUE(27)
      IDOUT(34) = IVALUE(33) + IVALUE(28)
      IDOUT(35) = XCYCLE
      IDOUT(36) = YCYCLE(1)
      IDOUT(37) = IVALUE(13)
      IDOUT(38) = IVALUE(10)
      IF (IDOUT(38)  .EQ. 1) IDOUT(38) = 0.0
      IF (IDOUTR(38) .LT. YMIN(1)) IDOUT(37) = 0
      IDOUT(39) = IVALUE(14)
      IDOUT(40) = IVALUE( 9)
      IF (IDOUT(40)  .EQ. 1) IDOUTR(40) = 0.0
      IF (IDOUTR(40) .LT. XMIN) IDOUT(39) = 0
      IDOUT(41 ) = IVALUE(40)
      IDOUT(243) = IVALUE(51)
      IDOUT(244) = IVALUE(52)
      DO 410 I=1,32
      IDOUT(I+146) = TCURVE(I)
      IDOUT(I+178) = XAXIS(I)
      IDOUT(I+210) = YAXIS(I)
  410 CONTINUE
      GO TO 420
C
C     IDOUT IS COMPLETE   OUTPUT CURVES
C
  420 ASSIGN 590 TO ICONT
      IPAIR = IAT + STEPS
      N = 1
C
  430 MCOUNT = 0
      DO 580 M = 1,NAT,3
      MCOUNT = MCOUNT + 1
C
C     CURVE NUMBER, ID, COMPONENT
C
      IDOUT(4) = Z(M)
      ITEMP = M + N
      IDOUT(5) = Z(ITEMP)
      IF (IDOUT(5) .NE. 1000) CURVE = CURVE + 1
      IDOUT(3) = CURVE
C
C     MEAN RESPONSE IN PLACE OF SUBCASE IF RANDOM
C
      IF (RANDOM) IDOUT(1) = Z(ITEMP+1)
C
C     SET NUMBER OF ZERO CROSSINGS IF RANDOM
C
      IF (RANDOM) IDOUT(42) = BUF(MCOUNT+20)
C
C     COMPUTE Y1 = YMIN  AND Y2 = YMAX  FOR ALL DATA FOR THIS CURVE
C
      BEGIN = IPAIR + MCOUNT*STEPS - STEPS
      NULL  = .TRUE.
      DO 460 K = 1,STEPS
      I = BEGIN + K
      IF (Z(I) .EQ. 1) GO TO 460
      IF (.NOT.NULL  ) GO TO 440
      NX1 = K
      NX2 = K
      Y1  = RZ(I)
      Y2  = RZ(I)
      NULL= .FALSE.
      GO TO 460
  440 IF (RZ(I) .GE. Y1) GO TO 450
      Y1  = RZ(I)
      NX1 = K
      GO TO 460
  450 IF (RZ(I) .LE. Y2) GO TO 460
      Y2  = RZ(I)
      NX2 = K
  460 CONTINUE
C
      IF (.NOT.NULL) GO TO 470
      IDOUTR(297) = 0.0
      IDOUTR(298) = 0.0
      IDOUTR(299) = 0.0
      IDOUTR(300) = 0.0
      GO TO 480
  470 NX1 = NX1 + IAT
      NX2 = NX2 + IAT
      IDOUTR(297) = Y1
      IDOUTR(298) = RZ(NX1)
      IDOUTR(299) = Y2
      IDOUTR(300) = RZ(NX2)
C
C     COMPUTE Y1 AND Y2 FOR DATA BETWEEN XMIN AND XMAX
C
  480 NULL = .TRUE.
      IF (I1 .EQ. 0) GO TO 520
      DO 510 K = I1,I2
      I = BEGIN + K
      IF (Z(I) .EQ. 1) GO TO 510
      IF (.NOT.NULL  ) GO TO 490
      NX1 = K
      NX2 = K
      Y1  = RZ(I)
      Y2  = RZ(I)
      NULL= .FALSE.
      GO TO 510
  490 IF (RZ(I) .GE. Y1) GO TO 500
      Y1  = RZ(I)
      NX1 = K
      GO TO 510
  500 IF (RZ(I) .LE. Y2) GO TO 510
      Y2  = RZ(I)
      NX2 = K
  510 CONTINUE
      IF (.NOT.NULL) GO TO 530
  520 IDOUTR(293) = 0.0
      IDOUTR(294) = 0.0
      IDOUTR(295) = 0.0
      IDOUTR(296) = 0.0
      GO TO 540
  530 NX1 = NX1 + IAT
      NX2 = NX2 + IAT
      IDOUTR(293) = Y1
      IDOUTR(294) = RZ(NX1)
      IDOUTR(295) = Y2
      IDOUTR(296) = RZ(NX2)
C
  540 IDOUTR(291) = RZ(IAT+1)
      ITEMP = IAT + STEPS
      IDOUTR(292) = RZ(ITEMP)
C
C     IDOUT IS COMPLETE FOR THIS CURVE
C
      IF (IDOUT(5).NE.0 .AND. IDOUT(5).NE.1000)
     1    CALL XYOUT (-1,IDOUT(1),IDOUTR(1))
      IF (ON) CALL WRITE (OUTFIL,IDOUT(1),300,EOR)
      IDOUT(8) = 0
C
C     DUMP ALL PAIRS TO PRINTER AND PUNCH,  THOSE IN RANGE TO PLOTTER
C
      Y1 = IDOUTR(13)
      Y2 = IDOUTR(14)
      IF (ON) CALL WRITE (OUTFIL,ONEONE(1),2,NOEOR)
      ONES = .TRUE.
      IF (IDOUT(5) .EQ. 1000) GO TO 570
      DO 560 K = 1,STEPS
      I = BEGIN + K
      J = IAT + K
      BUF(1) = Z(J)
      BUF(2) = Z(I)
      IF (Z(I) .EQ. 1) GO TO 560
      IF (K.LT.I1 .OR. K.GT.I2) GO TO 560
      IF (PRINT .OR. PUNCH) CALL XYOUT (1,BUF(1),RBUF(1))
      IF (RZ(I).LT.Y1 .OR. RZ(I).GT.Y2) GO TO 550
      IF (ON) CALL WRITE (OUTFIL,BUF(1),2,NOEOR)
      ONES = .FALSE.
      GO TO 560
  550 IF (ONES) GO TO 560
      IF (ON) CALL WRITE (OUTFIL,ONEONE(1),2,NOEOR)
      ONES = .TRUE.
  560 CONTINUE
  570 IF (ON) CALL WRITE (OUTFIL,BUF(1),0,EOR)
  580 CONTINUE
C
      GO TO ICONT, (590,600)
C
C     DO BOTTOM CURVES IF ANY
C
  590 ASSIGN 600 TO ICONT
      N = 2
      IF (IDOUT(7) .GT. 0) GO TO 380
  600 RETURN
      END

      SUBROUTINE DPSE2
C
C     THIS ROUTINE COMPUTES THE TWO 6 X 6 MATRICES K(NPVT,NPVT) AND
C     K(NPVT,J), PRESSURE STIFFNESS MATRICES FOR A CPSE2 PRESSURE
C     STIFFNESS ELEMENT (ROD, 2 GRID POINTS)
C
C     DOUBLE PRECISION VERSION
C
C     WRITTEN BY E. R. CHRISTENSEN/SVERDRUP  7/91, VERSION 1.0
C     INSTALLED IN NASTRAN AS ELEMENT DPSE2 BY G.CHAN/UNISYS, 2/92
C
C     REFERENCE - E. CHRISTENEN: 'ADVACED SOLID ROCKET MOTOR (ASRM)
C                 MATH MODELS - PRESSURE STIFFNESS EFFECTS ANALYSIS',
C                 NASA TD 612-001-02, AUGUST 1991
C
C     LIMITATION -
C     (1) ALL GRID POINTS USED BY ANY OF THE CPSE2/3/4 ELEMENTS MUST BE
C         IN BASIC COORDINATE SYSTEM!!!
C     (2) CONSTANT PRESSURE APPLIED OVER AN ENCLOSED VOLUMN ENCOMPASSED
C         BY THE CPSE2/3/4 ELEMENTRS
C     (3) PRESSURE ACTS NORMALLY TO THE CPSE2/3/4 SURFACES
C
C     SEE NASTRAN DEMONSTRATION PROBLEM -  T13021A
C
C     ECPT FOR THE PRESSURE STIFFNESS
C     CPSE2 ELEMENT                                CARD
C                                                  TYPE  TYPE   TABLE
C                                                 ------ ----- ------
C     ECPT( 1) ELEMENT ID.                         CPSE2   I     ECT
C     ECPT( 2) SCALAR INDEX NUMBER FOR GRD.PT. A   CPSE2   I     ECT
C     ECPT( 3) SCALAR INDEX NUMBER FOR GRD.PT. B   CPSE2   I     ECT
C     ECPT( 4) PRESSURE P                          PPSE    R     EPT
C     ECPT( 5) NOT USED                            PPSE    R     EPT
C     ECPT( 6) NOT USED                            PPSE    R     EPT
C     ECPT( 7) NOT USED                            PPSE    R     EPT
C     ECPT( 8) COOR. SYS. ID. NO. FOR GRD.PT. A    GRID    I    BGPDT
C     ECPT( 9) X-COORDINATE OF GRD.PT. A (IN BASIC COOR)   R    BGPDT
C     ECPT(10) Y-COORDINATE OF GRD.PT. A (IN BASIC COOR)   R    BGPDT
C     ECPT(11) Z-COORDINATE OF GRD.PT. A (IN BASIC COOR)   R    BGPDT
C     ECPT(12) COOR. SYS. ID. NO. FOR GRD.PT. B            I    BGPDT
C     ECPT(13) X-COORDINATE OF GRD.PT. B (IN BASIC COOR)   R    BGPDT
C     ECPT(14) Y-COORDINATE OF GRD.PT. B (IN BASIC COOR)   R    BGPDT
C     ECPT(15) Z-COORDINATE OF GRD.PT. B (IN BASIC COOR)   R    BGPDT
C     ECPT(16) ELEMENT TEMPERATURE
C     ECPT(17) THRU ECPT(24) = DUM2 AND DUM6, NOT USED IN THIS ROUTINE
C
      DOUBLE PRECISION KE,TA,TB,D,X,Y,Z,XL,ALPHA
      DIMENSION        IECPT(3)
C     COMMON /SYSTEM/  IBUF,NOUT
      COMMON /DS1AAA/  NPVT,ICSTM,NCSTM
      COMMON /DS1AET/  ECPT(16),DUM2(2),DUM6(6)
      COMMON /DS1ADP/  KE(36),TA(9),TB(9),D(18),X,Y,Z,XL,ALPHA
      EQUIVALENCE      (ECPT(1),IECPT(1))
C
      IELEM = IECPT(1)
      IF (IECPT(2) .EQ. NPVT) GO TO 10
      IF (IECPT(3) .NE. NPVT) CALL MESAGE (-30,34,IECPT(1))
      ITEMP = IECPT(2)
      IECPT(2) = IECPT(3)
      IECPT(3) = ITEMP
      KA  = 12
      KB  =  8
      ALPHA = -1.0D0
      GO TO 20
   10 KA  =  8
      KB  =  12
      ALPHA = 1.0D0
C
C     AT THIS POINT KA POINTS TO THE COOR. SYS. ID. OF THE PIVOT GRID
C     POINT. SIMILARLY FOR KB AND THE NON-PIVOT GRID POINT.
C
C     NOW COMPUTE THE LENGTH OF THE CPSE2 ELEMENT.
C
C
C     WE STORE THE COORDINATES IN THE D ARRAY SO THAT ALL ARITHMETIC
C     WILL BE DOUBLE PRECISION
C
C     CHECK TO SEE THAT THE CPSE2 HAS A NONZERO LENGTH
C
   20 D(1) = ECPT(KA+1)
      D(2) = ECPT(KA+2)
      D(3) = ECPT(KA+3)
      D(4) = ECPT(KB+1)
      D(5) = ECPT(KB+2)
      D(6) = ECPT(KB+3)
      X    = D(1) - D(4)
      Y    = D(2) - D(5)
      Z    = D(3) - D(6)
      XL = DSQRT(X**2 + Y**2 + Z**2)
      IF (XL .EQ. 0.0D0) GO TO 70
C
C     COMPUTE THE 3 X 3 NON-ZERO SUBMATRIX OF KDGG(NPVT,NONPVT)
C
      D(1) = 0.0D0
      D(2) = ALPHA*ECPT(4)/2.0D0
      D(3) = D(2)
      D(4) =-D(2)
      D(5) = 0.0D0
      D(6) = D(2)
      D(7) = D(4)
      D(8) = D(4)
      D(9) = 0.0D0
C
C     ZERO OUT KE MATRIX
C
      DO 30 I = 1,36
   30 KE(I) = 0.0D0
C
C     FILL UP THE 6 X 6 KE
C
C     IF PIVOT GRID POINT IS IN BASIC COORDINATES, GO TO 40
C
      K1 = 1
      IF (IECPT(KA) .EQ. 0) GO TO 40
      CALL TRANSD (ECPT(KA),TA)
      CALL GMMATD (TA,3,3,1, D(1),3,3,0, D(10))
      K1  = 10
      KB1 = 10
      KB2 = 1
      GO TO 50
C
C     IF NON-PIVOT GRID POINT IS IN BASIC COORDINATES, GO TO 60
C
   40 KB1 = 1
      KB2 = 10
   50 IF (IECPT(KB) .EQ. 0) GO TO 60
      CALL TRANSD (ECPT(KB),TB)
      CALL GMMATD (D(KB1),3,3,0, TB,3,3,0, D(KB2))
      K1 = KB2
C
   60 KE( 1) = D(K1  )
      KE( 2) = D(K1+1)
      KE( 3) = D(K1+2)
      KE( 7) = D(K1+3)
      KE( 8) = D(K1+4)
      KE( 9) = D(K1+5)
      KE(13) = D(K1+6)
      KE(14) = D(K1+7)
      KE(15) = D(K1+8)
      CALL DS1B (KE,IECPT(3))
      RETURN
C
C     ERROR
C
   70 CALL MESAGE (30,26,IECPT(1))
      NOGO = 1
      RETURN
      END

      SUBROUTINE SMCCRS ( TEMP, ZIL, ILIM, ZOL )
      REAL       TEMP( ILIM ), ZIL( ILIM ), ZOL
      DO 10 I = 1, ILIM
      TEMP( I ) = TEMP( I ) + ZIL( I ) * ZOL
10    CONTINUE
      RETURN
      END
      
      

      SUBROUTINE FFREAD (*,CARD)
C
C     THIS ROUTINE READS INPUT CARDS IN FREE FIELD OR FIXED FIELD
C     FORMATS.
C
C     IF READFILE COMMAND IS ENCOUNTERED, IT SWITCHE THE INPUT FILE TO
C     THE ONE SPECIFIED BY READFILE UNTIL EOF IS REACHED. THEN IT
C     SWITCHES BACK TO THE NORMAL CARD READER. NESTED READFILE IS
C     ALLOWED.
C
C     IT ALSO PRINTS THE INPUT CARDS IF UNSORTED ECHO FLAG IS ONE
C
C     ALL INTEGERS, BCD, AND REAL NUMBERS ARE LEFT ADJUSTED BEFORE
C     RETURNING TO THE CALLER, XSORT2
C
C     IN BULK DATA SECTION -
C     ALL INTEGERS ARE LIMITED TO 8 DIGITS. REAL NUMBERS CAN BE UP TO 12
C     DIGITS IF INPUT VIA FREE-FIELD, OR UP TO 8 DIGITS IF FIXED-FIELD.
C     ALL REAL NUMBER MUST HAVE A DECIMAL POINT.  10E-6 OR 1+7 ARE
C     NOT ACCEPTABLE
C
C     THREE WORDS ARE ATTACHED TO THE END OF AN INPUT CARD TO BE USED
C     FOR ALPHA-NUMERIC SORTING
C
      LOGICAL         FP,       STAR,     PCT,      NOTYET,   TWODOT
      INTEGER         FFFLAG,   INFLAG,   NONE,     SCREEN,   PROM,
     1                UNIVC(11),XSORT,    WASFF
      INTEGER         IB,       IC,       IE,       IS,       IL,
     1                IR,       ID,       IP,       IM,       IG,
     2                IA,       IH,       PT,       SP,       AII,
     3                A1,       DOT,      AT,       A(94)
      CHARACTER*1     CB,       CC,       CE,       CS,       CL,
     1                CR,       CD,       CP,       CM,       CG,
     2                CA,       CH,       CT,       C1,       C(80),
     3                CX(94),   TMP,      QMARK,    DOTC
      CHARACTER*4     PROMPT,   ON,       OFF,      YES,      TEMP4,
     1                ECHO
      CHARACTER*5     A5,       SEQGP,    SEQEP
      CHARACTER*8     CARD(10), BLANK,    A8(10),   A81,      CANCEL,
     1                SAVE,     RDFL,     SKFL,     DEND,     DBGN,
     2                TEMP,     FROM,     SPILL,    LIST,     HELP,
     3                STOP,     SCALE8,   SCALE1,   NOPRT,    SLASH,
     4                A8X(12)
      CHARACTER*48    A48
      COMMON /XREADX/ SCREEN,   LOOP,     KOUNT,    PROM,     NOTYET,
     1                STAR,     PCT,      JC(9),    L(9),     RC(9),
     2                F(9)
      COMMON /QMARKQ/ QMARK,    TMP(8),   SPILL,    SAVE(10)
      COMMON /XECHOX/ FFFLAG,   IECHOU,   IECHOS,   IECHOP,   XSORT,
     1                WASFF,    NCARD,    DUM(2),   NOECHO
      COMMON /XXREAD/ INFLAG,   INSAVE,   LOOP4,    IBMCDC,   IERR
      COMMON /MACHIN/ MCHN
      COMMON /SYSTEM/ IBUF,     NOUT,     NOGO,     IN
      EQUIVALENCE     (C(1),CX(1),A8(1),A8X(1),A5,A48,A81),  (KKF,FKK),
     1                (TEMP4,TEMP,TMP(1)),(A1,A(1))
C
      DATA            NONE,     PROMPT,   ON,       OFF,      YES     /
     1                4HNONE,   'PROM',   'ON, ',   'OFF,',   'YES,'  /
      DATA            BLANK,    DEND,     DBGN,     FROM,     SLASH   /
     1                '      ','$   END ','$   ...',' FROM-', '/    ' /
      DATA            CT,       XXXX,     CANCEL,   LIST,     LOUT    /
     1                '.',      4HXXXX,   'CANCEL', 'LIST',   3       /
      DATA            RDFL,               SKFL,     DOTC,     ECHO    /
     1                'READFILE',        'SKIPFILE','.',      'ECHO'  /
      DATA            HELP,     IWO,      SCALE8,   SCALE1,   STOP    /
     1                'HELP',   60,      'SCALE/8','SCALE/10','STOP'  /
      DATA            A,        IB,       NOPRT,    SEQGP,    SEQEP   /
     1                94*1H ,   0,       'NOPRINT,','SEQGP',  'SEQEP' /
      DATA            CB , CC , CE , CS , CL , CR , CD , CP , CM , CG /
     1                ' ', ',', '=', '*', '(', ')', '$', '+', '-', '%'/
      DATA            L12, L94/ 10, 80 /, CA, CH, AT / '/', '!', 2H@  /
      DATA            UNIVC   / 4H*ADD,   4H,E  ,   8*4H    ,  4H .   /
C
C     THIS ROUTINE IS A PREPROCESSOR FOR THE XREAD ROUTINE IN NASTRAN
C     WRITTEN BY G. CHAN/SPERRY,  APRIL 1985
C
C     FFFLAG IN /XECHOX/ MUST BE SET TO 1234 FOR FREE-FIELD INPUT.
C     IECHOS IS SET TO -2 IN STAND-ALONE VERSION.
C     MUST RESERVE 43 WORDS IN SEMINT FOR /XREADX/ IN ALL MACHINES.
C
C     FREE FIELD INPUT IS TRIGGERED BY THE PRESENCE OF COMMA (,) OR
C     EQUAL SIGN (=) IN COLS. 1 THRU 10, AND AFTER BEGIN BULK CARD WAS
C     READ.
C
C     FFREAD IS DESIGNED TO BE USER FRIENDLY -
C     UNDER NO CIRCUMSTANCES SHOULD THE USER BE KICKED OUT OF THE
C     COMPUTER DUE TO HIS OR HER STUPID INPUT ERROR(S).
C
C     DURING FREE-FIELD INPUT SESSION, FOUR CONTROL CARDS ARE ALLOWED -
C
C        ECHO  = SORT, UNSORT, BOTH, NONE, PUNCH, LINK1
C        PROMPT= ON, OFF, YES    (YES = ON + GENERATED CARD ECHO)
C        CANCEL= N, TO CANCEL N PREVIOUSLY GENERATED LINES
C        LIST  =-N, TO   LIST N PREVIOUSLY GENERATED LINES
C        (CANCEL AND LIST ARE AVAILABLE ONLY IN STAND-ALONE VERSION AND
C         A SAVE FILE HAS BEEN REQUESTED)
C
C     WRITTEN BY G.CHAN/UNISYS ON A COLD DECEMBER MORNING, 1983
C     REFERENCE - CHAN, G.C.: 'COSMIC/NASTRAN FREE-FIELD INPUT',
C                 12TH NASTRAN USERS' COLLOQUIUM, MAY 1984
C
C     THIS ROUTINE WILL HANDLE COMPUTER WORD OF ANY SIZE, 32,36,60,64
C     BITS, UPPER CASE AND LOWER CASE ASCII AND EBCDIT CHARACTER SETS.
C
C     VAX AND UNIX ONLY -
C     (UNIVAC TOO, ONLY IF OPEN STATEMENT IS USED FOR LOGICAL UNIT 5)
C     DURING FREE-FIELD SESSION, 94 COLUMNS, INSTEAD OF REGULARLY 80,
C     ARE ALLOWED FOR AN INPUT CARD COMING FROM CARD READER OR READFILE
C     (A MAXINUM OF 94 COLUMNS IS ALLOWED IN PRINT FORMAT 310)
C
C     THIS ROUTINE CALLS THE FOLLOWING SUPPORTING SUBROUTINES FOR BCD
C     (LEFT ADJUSTED), INTEGER, AND F.P. NUMBER CONVERSION -
C
C        INT 2 K8  - DECODES INTEGER TO A8 CHAR.
C        FP  2 K8  - DECODES F.P. NUMBER TO A8 CHAR.
C        NK1 2 IF  - ENCODES N(A1) CHAR. TO INTEGER OR F.P. NUMBER
C        NK1 2 K8  - ENCODES N(A1) CHARS. TO A A8 CHAR. WORD
C        K8  2 INT - DECODES A8 CHAR. TO INTEGER
C        K8  2 FP  - DECODES A8 CHAR. TO F.P. NUMBER
C        UPCASE    - REPLACES ANY LOWER-CASE LETTER BY ITS UPPER CASE
C
C     THIS ROUTINE WILL ALSO HANDLE 'READFILE' AND 'SKIPFILE' CARDS.
C     FILE NAME IS LIMITED UP TO 48 CHARACTERS,  8/91
C
C     THIS ROUTINE TRIES NOT TO USE SYSTEM ENCODE/DECODE FUNCTIONS,
C     SHIFT, AND ANY NON-STANDARD CHARACTER FUNCTIONS.
C
C
C     INPUT FILE LOGIC:
C
C     IN UNIVAC, INPUT CARDS ARE READ FROM CARD READER INFLAG, UNIT 5.
C     ALL OTHER INPUT FILES, NESTED OR NOT, ARE DYNAMICALLY INSERTED IN-
C     TO INPUT STREAM (WITH THE E-O-F MARK STRIPPED OFF), AND READ INTO
C     COMPUTER SYSTEM FROM UNIT 5 ALSO. IF AN E-O-F MARK ENCOUNTERED
C     BEFORE ENDDATA CARD, IT IS FATAL. INFLAG=TWO=IN=5
C
C     IN ALL OTHER MACHINES, INPUT CARDS ARE READ FROM CARD READER
C     INFLAG, UNIT 5. WHEN A READFILE CARD IS ENCOUNTERED, DATA ARE READ
C     INTO COMPUTER SYSTEM FROM UNIT INFLAG, WHICH BEGINS AT 60;
C          INFLAG = IWO = 60 FOR THE FIRST FILE
C          INFLAG = 61 FOR THE SECOND FILE
C          INFLAG = 62 FOR THE THIRD  FILE, ETC.
C     (NOTE, SINCE NASTRAN USES READFILE INTERNALLY TO READ RIGID FORMAT
C     FILE, NESTED READFILE IS NOT UNCOMMON)
C     WHEN E-O-F IS ENCOUNTERED, CURRENT FILE IS CLOSED AND INFLAG IS
C     DECREASE BY 1. INFLAG IS SET TO ZERO WHEN INFLAG .LE. IWO (END
C     OF CURRENT NESTED FILE OPERATION). NEXT READFILE, NESTED OR NOT,
C     IS ALLOWED.
C
C     ADD READFILE,NOPRINT OPTION.  2/2/1989
C     LAST REVISED, 8/1989, IMPROVED EFFICIENCY BY REDUCING CHARACTER
C     OPERATIONS (VERY IMPORTANT FOR CDC MACHINE)
C     8/93, LIBERAL READFILE NOPRINT FORMATS:
C           READFILE,NOPRINT  FILENAME
C           READFILE,NOPRINT, FILENAME
C           READFILE NOPRINT  FILENAME
C           READFILE(NOPRINT) FILENAME
C           (EMBEDDED BLANK, COMMA, BRACKETS, AND EQUAL-SIGN ALLOWED)
C           READFILE = FILENAME
C
C     INITIALIZE THE FOLLOWING ITEMS SO THAT COMPILER WILL NOT COMPLAIN
C
      DATA   C1,I,II,JJ,KK / ' ', 4*0 /
C
      MACH = MCHN
      IF (MACH .EQ. 12) MACH = 4
      IF (MACH .LT. 5) GO TO 40
      L12 = 12
      L94 = 94
   40 IF (IB .NE. 0) GO TO 50
      CALL K2B (CB,IB,1)
      CALL K2B (CC,IC,1)
      CALL K2B (CE,IE,1)
      CALL K2B (CS,IS,1)
      CALL K2B (CL,IL,1)
      CALL K2B (CR,IR,1)
      CALL K2B (CD,ID,1)
      CALL K2B (CP,IP,1)
      CALL K2B (CM,IM,1)
      CALL K2B (CG,IG,1)
      CALL K2B (CA,IA,1)
      CALL K2B (CH,IH,1)
      CALL K2B (CT,PT,1)
      CALL K2B (DOTC,DOT,1)
      CALL KHRFN1 (UNIVC(1),1,AT,1)
C
 50   IF (KOUNT  .NE. 0) GO TO 300
 60   IF (INFLAG .EQ. 0) IF (FFFLAG-1234) 80,200,80
      READ (INFLAG,65,END=150) (A8X(J),J=1,L12)
 65   FORMAT (11A8,A6)
C     NCARD = NCARD + 1
      IF (IECHOS .EQ. -2) WRITE (LOUT,65) A8X
      IF (A81 .EQ. RDFL) GO TO 4500
      IF (A81.EQ.SKFL .AND. A8(2).EQ.BLANK) GO TO 130
      IF (FFFLAG .EQ. 1234) GO TO 240
      DO 70 I = 1,10
      CARD(I) = A8(I)
 70   SAVE(I) = A8(I)
      GO TO 2800
C
C     10A8 INPUT
C
 80   READ (IN,90,END=150) CARD
 90   FORMAT (10A8)
      NCARD = NCARD + 1
      IF (IECHOS .EQ. -2) WRITE (LOUT,90) CARD
C
      IF (CARD(1).EQ.SKFL .AND. CARD(2).EQ.BLANK) GO TO 130
      IF (CARD(1) .NE. RDFL) GO TO 2000
      DO 120 I = 1,10
 120  A8(I) = CARD(I)
      CALL K2B (A8,A,80)
      GO TO 350
C
C     IT IS A SKIPFILE CARD - TO SKIP TO THE END OF INPUT FILE
C
 130  IF (INFLAG .EQ. 0) GO TO 5200
 140  READ (INFLAG,90,END=5100) CARD
      GO TO 140
C
C     CLOSE FILE, AND SET INFLAG BACK TO ZERO, OR PREVIOUS FILE OPENED
C
 150  IF (MACH .GE. 5) GO TO 154
      GO TO (154,154,158,152), MACH
 152  IF (INFLAG .EQ.   0) RETURN 1
      IF (INFLAG .GE. IWO) REWIND INFLAG
      IERR = IERR + 1
      IF (IERR-15) 156,156,3070
 154  IF (INFLAG .EQ.   0) RETURN 1
 156  CLOSE (UNIT=INFLAG)
 158  IF (INFLAG .EQ. 0) RETURN 1
      INFLAG = INFLAG - 1
      IF (INFLAG .LE. IWO) INFLAG = 0
      CARD(1) = DEND
      CARD(2) = RDFL
      DO 160 J = 3,10
 160  CARD(J) = BLANK
      IF (IECHOS .EQ. -2) GO TO 60
      CALL PAGE2 (-2)
      NOECHO = NOECHO - 1
      IF (NOECHO .GE. 0) WRITE (NOUT,165) NOECHO
 165  FORMAT (12X,1H(,I4,' CARDS READ)')
      WRITE  (NOUT,460) CARD
      NOECHO = 0
      GO TO 60
C
 170  LOOP  = 0
      LOOP4 = LOOP - 4
      KOUNT = 0
      STAR  = .FALSE.
      PCT   = .FALSE.
      NOTYET= .FALSE.
      DO 180 J = 1,9
      L(J)  = 0
 180  F(J)  = 0.0
      IF (INFLAG-IWO) 200,60,60
C
C     FREE FIELD INPUT
C
 190  WRITE (NOUT,3020)
      IERR = IERR + 1
      IF (IERR .GT. 3) GO TO 3070
      WRITE (SCREEN,3060) A8
      IF (MACH.EQ.4 .AND. IN.EQ.5) REWIND IN
 200  IF (PROM .NE. 0) WRITE (SCREEN,210)
 210  FORMAT (7H ENTER )
      READ   (IN,220,END=190) (CX(J),J=1,L94)
 220  FORMAT (94A1)
      NCARD = NCARD + 1
      LASH  = 0
 240  CONTINUE
      IF (IECHOS .EQ. -2) WRITE (LOUT,220) CX
      CALL K2B (A8,A,L94)
      IF (A1 .EQ. ID) GO TO 280
C
      IF (A81 .EQ. RDFL) GO TO 350
      IF (A81.EQ.SKFL .AND. A8(2).EQ.BLANK) GO TO 130
      IF (FFFLAG  .EQ. 1234) GO TO 260
      DO 250 I = 1,10
 250  CARD(I) = A8(I)
      GO TO 2800
 260  WASFF = +1
      DO 270 I = 1,10
      IF (A(I).EQ.IC .OR. A(I).EQ.IE) GO TO 300
 270  CONTINUE
 280  WASFF = -1
      IF (IECHOU.EQ.0 .OR. XSORT.EQ.0) GO TO 288
      CALL PAGE2 (-1)
      WRITE  (NOUT,285) A
 285  FORMAT (30X,94A1)
 288  IF (A1 .EQ. ID) GO TO 60
      J = 0
      DO 290 I = 1,10
      IF (A8(I) .NE. BLANK) J = 1
 290  CARD(I) = A8(I)
      LOOP  = -1
      LOOP4 = LOOP - 4
      IF (J.EQ.0 .AND. IECHOS.EQ.-2) GO TO 4700
      GO TO 2000
C
 300  IF (IECHOS .EQ. -2) GO TO 340
      IF (IECHOU.EQ.0 .OR. KOUNT.GE.1) GO TO 320
      CALL PAGE2 (-1)
      WRITE  (NOUT,310) A
 310  FORMAT (30X,4H-FF-,4X,94A1)
 320  IF (LOOP .EQ. -1) GO TO 340
      DO 330 J = 1,10
 330  CARD(J) = SAVE(J)
 340  IF (KOUNT .NE. 0) GO TO 900
 350  KE = 0
      K  = 0
      DO 380 J = 1,L94
      AII = A(J)
      IF (AII .NE. IB) GO TO 360
      IF (KE  .EQ.  0) GO TO 380
      IF (A(KE ).EQ.IC .OR. A(KE ).EQ.IL) GO TO 380
      IF (A(J+1).EQ.IC .OR. A(J+1).EQ.IB) GO TO 380
      IF (A(J+1).EQ.IR .AND.     K.EQ. 1) GO TO 370
      AII = IC
 360  IF (AII .EQ. ID) GO TO 390
      KE = KE + 1
      A(KE) = AII
      C(KE) = C(J)
      IF (AII .EQ. IC) C(KE) = CC
      IF (AII .EQ. IL) K = K + 1
      IF (AII .EQ. IR) K = K - 1
      IF (K-1) 380,380,5000
 370  K = 0
 380  CONTINUE
      IF (K  .GT. 0) GO TO 5000
      IF (KE .EQ. 0) GO TO 4700
 390  IF (A(KE) .EQ. IC) GO TO 400
      KE = KE + 1
      A(KE) = IC
      C(KE) = CC
 400  IF (A81 .NE. RDFL) GO TO 520
C
C     IT IS A READFILE CARD -
C     CHECK NOPRINT OPTION, SET NOECHO = 1, IF FOUND.
C     LOOK FOR FILE NAME. SET INFLAG TO UNIT IWO (OR IWO+ IF NESTED
C     READFFILE), AND OPEN USERS FILE (NOT MEMBER OF A FILE AS IN IBM)
C
C     READFILE FORMAT - '(', ')', ',', AND '=' ARE IGNORED.
C
      NOECHO = 0
      NOEC = 0
      I    = 9
 405  A(1) = IB
      C(1) = CB
      C(8) = CC
      J = 0
 410  I = I + 1
      IF (I .GT. L94) GO TO 480
      AII = A(I)
      IF (AII .EQ. IB) GO TO 415
      IF (AII.EQ.IL .OR. AII.EQ.IR .OR. AII.EQ.IC .OR. AII.EQ.IE)
     1    IF (NOEC) 410,410,415
      J = J + 1
      IF (J .GT. 48) GO TO 480
      A(J) = AII
      C(J) = C(I)
      IF (J.NE.7 .OR. A81.NE.NOPRT) GO TO 410
      NOECHO = 1
      NOEC = 1
      GO TO 405
 415  IF (J .EQ.  0) GO TO 410
      IF (J .GE. 60) GO TO 422
      J1 = J + 1
      DO 420 I = J1,60
      C(I) = CB
 420  A(I) = IB
 422  IF (MACH .EQ. 3) GO TO 425
      IF (INFLAG .LT. IWO) INFLAG = IWO - 1
      INFLAG = INFLAG + 1
CWKBI 8/94 ALPHA-VMS
      IF ( MACH .EQ. 21 ) GO TO 423
      IF (IBMCDC.EQ.0) OPEN(UNIT=INFLAG,FILE=A8(1),STATUS='OLD',ERR=470)
      IF (IBMCDC.NE.0) OPEN(UNIT=INFLAG,FILE=A48  ,STATUS='OLD',ERR=470)
CWKBNB 8/94 ALPHA-VMS
      GO TO 424
423   INDX = INDEX( A48, ' ' )
      A48(INDX:INDX) = '.'
      OPEN(UNIT=INFLAG,FILE=A48,STATUS='OLD',ERR=470)
424   CONTINUE
CWKBNE 8/94 ALPHA-VMS
C
      IF (MACH .EQ. 4) REWIND INFLAG
      GO TO 450
C
C     UNIVAC - USE SYSTEM FACSF ROUTINE, SO THAT IT CAN READ A FILE OR
C              AN ELEMENT OF A FILE. INPUT UNIT IWO IS NOT USED
C              MAKE SURE FILE NAME CONTAINS A DOT
C
 425  K = 0
      DO 430 I = 1,48
      IF (A(I) .EQ. DOT) GO TO 440
      IF (A(I) .NE.  IB) K = 1
      IF (K.EQ.1 .AND. A(I).EQ.IB) GO TO 435
 430  CONTINUE
      I = 49
 435  A(I) = DOT
 440  INFLAG = IN
      IWO    = IN
      READ (A48,445) (UNIVC(I),I=3,14)
 445  FORMAT (12A4)
      I = FACSF(UNIVC)
      IF (I .NE. 0) GO TO 470
C
 450  CARD(1) = DBGN
      CARD(2) = RDFL
      CARD(3) = FROM
      DO 455 J = 4,10
 455  CARD(J) = A8(J-3)
      IF (IECHOS .EQ. -2) GO TO 465
      CALL PAGE2 (-1)
      WRITE  (NOUT,460) CARD
 460  FORMAT (5H0*** ,10A8)
      GO TO 60
 465  PROM = +1
      GO TO 60
C
 470  WRITE  (NOUT,475) INFLAG,(A(I),I=1,J)
 475  FORMAT (//,29H *** CAN NOT OPEN FILE (UNIT=,I3,4H) - ,94A1)
      GO TO 500
 480  J = J - 1
      WRITE  (NOUT,485) (A(I),I=1,J)
 485  FORMAT (//,23H *** FILE NAME ERROR - ,48A1)
      IF (J .GE. 48) WRITE (NOUT,490)
 490  FORMAT (5X,31HFILE NAME EXCEEDS 48 CHARACTERS)
 500  NOGO = 1
      IF (MACH.EQ.3 .OR. MACH.GE.5) WRITE (NOUT,505)
 505  FORMAT (5X,38HSUGGESTION- CHECK USER ID OR QUALIFIER)
      INFLAG = INFLAG - 1
      IF (INFLAG .LE. IWO) INFLAG = 0
      CARD(1) = BLANK
      CARD(2) = BLANK
      RETURN
C
C     HERE WE GO
C
 520  KK = 0
      II = 0
      JJ = 0
      TWODOT = .FALSE.
 530  IISAVE = JJ - 2
 540  JJ = II + 1
 550  II = II + 1
      IF (II .GT. KE) GO TO 1500
      AII = A(II)
      IF (AII .EQ. IH) GO TO 540
      IF (AII .EQ. IE) GO TO 700
      IF (JJ  .GT.  1) GO TO 580
      IF ((STAR .OR. PCT) .AND. LOOP.NE.-1) WRITE (NOUT,560)
 560  FORMAT (' *** PREVIOUS CARD SETTING UP FOR DUPLICATION IS NOW ',
     1        'ABANDONNED')
      KOUNT = 0
      LOOP  = 0
      STAR  =.FALSE.
      PCT   =.FALSE.
      NOTYET=.FALSE.
      DO 570 J = 1,9
      L(J) = 0
 570  F(J) = 0.0
 580  IF (AII .EQ. IC) GO TO 600
      IF (AII .EQ. IA) GO TO 650
      IF (AII .EQ. IR) GO TO 1300
      IF (AII.EQ.IS .OR. AII.EQ.IG) GO TO 1000
      IF (AII .EQ. IL) GO TO 5400
      GO TO 550
C
C ... COMMA (,):
C
 600  KK = KK + 1
      IF (KK.EQ.1 .OR. KK.EQ.10) GO TO 620
      JE = II - 1
      IF (JE .LE. JJ) GO TO 620
      I = 0
      DO 610 J = JJ,JE
      IF (A(J) .EQ. PT) I = I + 1
 610  CONTINUE
      IF (I .LE. 1) GO TO 620
      IF (A5.NE.SEQGP .AND. A5.NE.SEQEP) GO TO 4400
      TWODOT =.TRUE.
      LOOP =-1
 620  CALL NK12K8 (*3200,C(JJ),II-JJ,CARD(KK),1)
      GO TO 530
C
C ... ECHO OR PROMPT:
C
 630  CALL NK12K8 (*3200,C(JJ),II-JJ,TEMP,1)
      IF (TEMP.EQ.CANCEL .OR. TEMP.EQ.LIST) GO TO 1600
      IF (TEMP4 .EQ.   ECHO) GO TO 4600
      IF (TEMP4 .NE. PROMPT) GO TO 3000
      CALL NK12K8 (*3200,C(II+1),4,TEMP,-1)
      IF (TEMP4.NE.ON .AND. TEMP4.NE.OFF .AND. TEMP4.NE.YES) GO TO 3000
      IF (TEMP4 .EQ. ON ) PROM =-1
      IF (TEMP4 .EQ. OFF) PROM = 0
      IF (TEMP4 .EQ. YES) PROM =+1
      GO TO 60
C
C ... SLASH (/):
C
 650  IF (IISAVE .LE. 0) GO TO 660
      A(II) = IH
      C(II) = CH
      II = II + 1
      IF (A(II) .NE. IC) GO TO 655
      A(II) = IH
      C(II) = CH
 655  II = IISAVE - 1
      GO TO 540
 660  IF (LASH.EQ.0 .AND. KK.EQ. 0) GO TO 680
      J = KK + 1
      WRITE  (NOUT,670) J
 670  FORMAT (34H *** ILLEGAL USE OF SLASH IN FIELD,I3)
      GO TO 540
C
C     A DELETE CARD (/) READ
C
 680  LASH = +1
      GO TO 530
C
C ... EQUAL (=):
C
 700  IF (JJ .NE. II) GO TO 630
      KK = KK + 1
      II = II + 1
      IF (II .GT. KE) GO TO 3600
      AII = A(II)
      IF (AII .EQ. IL) GO TO 750
      IF (AII .EQ. IE) GO TO 730
      IF (AII .EQ. IC) GO TO 530
      GO TO 3600
C
 730  KK = 10
      IF (TWODOT) GO TO 2400
      IF (LOOP) 2000,2000,850
C
C ... DUPLICATE WITH INCREMENT, =(N):
C
 750  IF (KK .NE. 1) GO TO 3600
      JJ = II + 1
 800  II = II + 1
      IF (II  .GT. KE) GO TO 3600
      AII = A(II)
      IF (AII .EQ. IR) GO TO 820
      IF (AII.EQ.IC .OR. AII.EQ.IS .OR. AII.EQ.IE) GO TO 3000
      GO TO 800
 820  INT = 1
      CALL NK12IF (*3800,C(JJ),II-JJ,LOOP,INT)
      IF (LOOP .LE. 0) GO TO 4100
      LOOP4 = LOOP - 4
      II = II + 1
      IF (II+1 .LT. KE) GO TO 530
      IF (.NOT.STAR .AND. .NOT.PCT) GO TO 3300
 850  KOUNT = 0
      IF (.NOT.NOTYET) GO TO 900
      NOTYET = .FALSE.
      DO 880 KK = 2,9
      IF (L(KK) .EQ. NONE) GO TO 860
      IF (F(KK) .NE. XXXX) GO TO 870
      F(KK) = 0.0
      I = (L(KK)-JC(KK))/LOOP
      IF (I*LOOP+JC(KK) .NE. L(KK)) GO TO 4200
      L(KK) = I
      GO TO 880
 860  L(KK) = 0
      F(KK) = (F(KK)-RC(KK))/FLOAT(LOOP)
      GO TO 880
 870  IF (L(KK) .NE.   0) JC(KK) = JC(KK) - L(KK)
      IF (F(KK) .NE. 0.0) RC(KK) = RC(KK) - F(KK)
 880  CONTINUE
 900  KOUNT = KOUNT + 1
      IF (KOUNT .GT. LOOP) GO TO 170
      DO 950 KK = 2,9
      IF (L(KK) .EQ. 0) GO TO 920
      JC(KK) = JC(KK) + L(KK)
      CALL INT2K8 (*3200,JC(KK),CARD(KK))
      GO TO 950
 920  IF (F(KK) .EQ. 0.0) GO TO 950
      RC(KK) = RC(KK) + F(KK)
      CALL FP2K8 (*3000,RC(KK),CARD(KK))
 950  CONTINUE
      IF (PROM.LT.0 .AND. KOUNT.EQ.LOOP) WRITE (SCREEN,970) LOOP,CARD
 970  FORMAT (/,I5,' ADDITIONAL CARDS WERE GENERATED.  LAST CARD WAS-',
     1        /1X,10A8)
      GO TO 2000
C
C ... STAR (*), OR PERCENTAGE (%):
C
 1000 SP = AII
      II = II + 1
      IF (A(II) .NE. IL) GO TO 4000
      JJ = II + 1
      FP =.FALSE.
      IF (STAR .OR. PCT) GO TO 1030
      DO 1020 K = 1,9
      L(K) = 0
 1020 F(K) = 0.0
 1030 IF (SP .EQ. IS) STAR =.TRUE.
      IF (SP .EQ. IG) PCT  =.TRUE.
 1050 II = II + 1
      AII= A(II)
      IF (II.GT.KE .OR. AII.EQ.IC) GO TO 4000
      IF (AII .EQ. PT) FP =.TRUE.
      IF (II.GT.JJ .AND. (AII.EQ.IP .OR. AII.EQ.IM)) FP =.TRUE.
      IF (AII .NE. IR) GO TO 1050
      IF (II  .LE. JJ) GO TO 4000
      KK = KK + 1
      IF (FP) GO TO 1070
      INT = 1
      CALL NK12IF (*3800,C(JJ),II-JJ,L(KK),INT)
      CALL K82INT (*3100,SAVE(KK),8,JC(KK),INT)
 1060 IF (SP  .EQ. IG) GO TO 1120
      IF (LOOP .GT. 0) GO TO 1100
      JC(KK) = JC(KK) + L(KK)
      CALL INT2K8 (*3200,JC(KK),CARD(KK))
      GO TO 1100
 1070 INT =-1
      CALL NK12IF (*3900,C(JJ),II-JJ,KKF,INT)
      F(KK) = FKK
      CALL K82FP  (*3100,SAVE(KK),8,RC(KK),INT)
 1080 IF (SP  .EQ. IG) GO TO 1150
      IF (LOOP .GT. 0) GO TO 1100
      RC(KK) = RC(KK) + F(KK)
      CALL FP2K8 (*3000,RC(KK),CARD(KK))
 1100 II = II + 1
      GO TO 530
C
 1120 IF (LOOP .GT. 0) GO TO 1130
      F(KK) = XXXX
      GO TO 1160
 1130 I = (L(KK)-JC(KK))/LOOP
      IF (I*LOOP+JC(KK) .NE. L(KK)) GO TO 4200
      L(KK) = I
      GO TO 1100
 1150 IF (LOOP .GT. 0) GO TO 1180
      L(KK)  = NONE
 1160 NOTYET =.TRUE.
      GO TO 1100
 1180 F(KK) = (F(KK)-RC(KK))/FLOAT(LOOP)
      GO TO 1100
C
C ... RIGHT BRACKET ):
C
 1300 IF (KK   .EQ.  0) GO TO 1450
      IF (II+1 .GE. KE) GO TO 3400
      AII = A(II+1)
      IF (AII.EQ.IS .OR. AII.EQ.IE) GO TO 3400
      J  = 10
      INT= 1
      IF (AII .NE. IP) CALL NK12IF (*3900,C(JJ),II-JJ,J,INT)
      IF (J.LE.0 .OR. J.GT.10) GO TO 3700
      IF (J .LE. KK) GO TO 1400
      KK = KK + 1
      DO 1350 K = KK,J
 1350 CARD(K) = BLANK
      KK = J
 1400 IF (A(II+1) .EQ. IC) II = II + 1
      JJ = II + 1
 1420 II = II + 1
      IF (II    .GT. KE) GO TO 1430
      IF (A(II) .NE. IC) GO TO 1420
 1430 CALL NK12K8 (*3000,C(JJ),II-JJ,CARD(J),1)
      IF (KK .LT. 10) IF (II-KE) 530,1500,1500
      GO TO 730
 1450 KK = 1
      CARD(KK) = SAVE(10)
      II = II + 1
      IF (II.GT.KE .OR. A(II).NE.IC) GO TO 3000
      GO TO 530
C
C ... END OF CARD READ
C
 1500 IF (KK-10) 1550,730,3500
 1550 KK = KK + 1
      CARD(KK) = BLANK
      IF (KK .LT. 10) GO TO 1550
      GO TO 730
C
C ... CANCEL = N, LIST = +N
C
 1600 IF (IECHOS .NE. -2) GO TO 5300
      CARD(1) = TEMP
      JJ = II + 1
 1650 II = II + 1
      IF (A(II) .NE. IC) GO TO 1650
      INT = 1
      CALL NK12IF (*3800,C(JJ),II-JJ,JC(1),INT)
      IF (TEMP.EQ.CANCEL .AND. JC(1).LE.0) GO TO 3800
      IF (TEMP.EQ.  LIST .AND. JC(1).LE.0) GO TO 3800
      CARD(3) = TEMP
      GO TO 2800
C
C     PREPARE TO RETURN
C
 2000 IF (NOTYET) GO TO 60
C
C ... UPDATE CONTINUATION FIELDS IF WE ARE IN A DUPLICATION LOOP
C
      IF (LOOP .EQ. -1) GO TO 2400
      IF (KOUNT.EQ.0 .AND. .NOT.STAR) GO TO 2400
      KK = 10
      IF (SAVE(KK) .EQ. BLANK) GO TO 2300
 2100 TEMP = SAVE(KK)
      IF (TMP(1) .NE. CP) GO TO 2300
      JJ = 0
      DO 2150 I = 3,8
      IF (TMP(I) .EQ. CM) JJ = I
      IF (TMP(I) .EQ. CB) GO TO 2200
 2150 CONTINUE
      I = 9
 2200 IF (JJ .EQ. 0) GO TO 2300
      INT = 1
      CALL NK12IF (*4800,TMP(JJ+1),I-JJ-1,J,INT)
      IF (MACH .EQ. 3) GO TO 2230
      J = J + 1
      CALL INT2K8 (*3800,J,TMP(JJ+1))
      GO TO 2270
C
C ... UNIVAC USES NEXT 5 CARDS INSTEAD OF THE 3 ABOVE
C
 2230 CALL INT2K8 (*3800,J,SPILL)
      J = 9 - JJ
      DO 2250 I = 1,J
      TMP(JJ+I) = TMP(8+I)
 2250 CONTINUE
 2270 J = 9
      IF (TMP(J) .NE. CB) GO TO 4900
      CARD(KK) = TEMP
 2300 IF (KK .EQ. 1) GO TO 2400
      KK = 1
      GO TO 2100
C
 2400 IF (FFFLAG .NE. 1234) GO TO 2700
      IF (LASH .EQ. +1) CARD(1) = SLASH
      IF (PROM .NE. +1) GO TO 2500
      IF (KOUNT.LT.7  .OR. KOUNT.GT.LOOP4) WRITE (SCREEN,2450) CARD
      IF (KOUNT.EQ.7 .AND. KOUNT.LE.LOOP4) WRITE (SCREEN,2460)
 2450 FORMAT (1X,10A8)
 2460 FORMAT (9X,1H.,2(/,9X,1H.))
 2500 IF (LOOP .EQ. -1) GO TO 2700
      DO 2600 KK = 1,10
 2600 SAVE(KK) = CARD(KK)
 2700 IF (CARD(1).EQ.HELP .AND. CARD(2).EQ.BLANK .AND. IECHOS.EQ.-2)
     1    CALL FFHELP (*60,*2900,2)
      IF (CARD(1).EQ.STOP .AND. CARD(2).EQ.BLANK .AND. IECHOS.NE.-2)
     1    GO TO 2900
      IF (CARD(1).NE.SCALE8 .AND. CARD(1).NE.SCALE1) GO TO 2800
      IF (CARD(1) .EQ. SCALE8) WRITE (NOUT,2710) (I,I=1,10)
      IF (CARD(1) .EQ. SCALE1) WRITE (NOUT,2720) (I,I=1,8 )
 2710 FORMAT (/1X,10(I5,3X),/1X,5('--------++++++++'))
 2720 FORMAT (/1X,     8I10,/1X,8('1234567890'))
      GO TO 60
C
 2800 RETURN
 2900 STOP
C
C     ERRORS
C
 3000 WRITE  (SCREEN,3020)
 3020 FORMAT (31H *** CARD ERROR - INPUT IGNORED)
 3050 IF (IECHOS .EQ. -2) GO TO 170
      IF (IERR   .LE. 15) WRITE (SCREEN,3060) A8
 3060 FORMAT (5X,1H',10A8,1H',/)
      NOGO = 1
      IERR = IERR + 1
      IF (IERR .LT. 30) GO TO 170
 3070 WRITE  (SCREEN,3080)
 3080 FORMAT (48H0*** JOB TERMINATED DUE TO TOO MANY INPUT ERRORS)
      STOP
 3100 JE = II - 1
      WRITE  (SCREEN,3150) KK,CARD(KK),(A(J),J=JJ,JE)
 3150 FORMAT (5X,5HFIELD,I3,2H (,A8,') OF PREVIOUS CARD SHOULD NOT BE ',
     1       'USED FOR', /5X,'INCREMENTATION (BY ',8A1,
     2       ').  ZERO IS ASSUMED')
      IF (INT .GT. 0) JC(KK) = 0
      IF (INT .LT. 0) RC(KK) = 0.0
      IF (INT) 1080,3000,1060
 3200 JE = II - 1
      WRITE  (SCREEN,3250) KK,(A(J),J=JJ,JE)
 3250 FORMAT (5X,'FIELD',I3,' IS TOO LONG. ONLY 8 DIGITS ALLOWED - ',
     1        16A1)
      GO TO  3000
 3300 WRITE  (SCREEN,3350)
 3350 FORMAT (5X,44HPREVIOUS CARD WAS NOT SET UP FOR DUPLICATION)
      GO TO  3000
 3400 WRITE  (SCREEN,3450) A8
 3450 FORMAT (35H *** INDEX ERROR.  NO VALUE AFTER ))
      GO TO  3050
 3500 WRITE  (SCREEN,3550)
 3550 FORMAT (49H *** INPUT ERROR - TOO MANY FIELDS.  REPEAT INPUT)
      GO TO  3050
 3600 WRITE  (SCREEN,3650)
 3650 FORMAT (37H *** INPUT ERROR AFTER EQUAL SIGN (=))
      IF (IECHOS .EQ. -2) GO TO 60
      WRITE  (SCREEN,3060) A8
      NOGO = 1
      GO TO  60
 3700 WRITE  (SCREEN,3750)
 3750 FORMAT (5X,'INDEX ERROR BEFORE RIGHT BRACKET )')
      GO TO  3050
 3800 JE = II - 1
      WRITE  (SCREEN,3850) (A(J),J=JJ,JE)
 3850 FORMAT (5X,18HINVALID INTEGER - ,16A1)
      GO TO  3000
 3900 JE = II - 1
      WRITE  (SCREEN,3950) (A(J),J=JJ,JE)
 3950 FORMAT (5X,22HINVALID F.P. NUMBER - ,16A1)
      GO TO  3000
 4000 WRITE  (SCREEN,4050)
 4050 FORMAT (47H *** INPUT ERROR AFTER STAR (*), OR PERCENT (%))
      GO TO  3050
 4100 WRITE  (SCREEN,4150)
 4150 FORMAT (41H *** ZERO LOOP COUNT.  NO CARDS GENERATED)
      GO TO  3050
 4200 WRITE  (SCREEN,4250) KK,L(KK),JC(KK),LOOP
 4250 FORMAT (5X,5HFIELD,I3,2H (,I8,1H-,I8,21H) IS NOT DIVIDABLE BY,I4,
     1       /5X,12HRESUME INPUT,/)
 4300 IF (IECHOS .NE. -2) NOGO = 1
      DO 4350 J = 1,10
 4350 CARD(J) = SAVE(J)
      GO TO  60
 4400 WRITE  (SCREEN,4450) (A(J),J=JJ,JE)
 4450 FORMAT (5X,27HMORE THAN ONE DEC. PT.,  - ,16A1)
      GO TO  3000
 4500 WRITE  (SCREEN,4550)
 4550 FORMAT (39H *** WARNING- NESTED READFILE OPERATION)
      GO TO  350
 4600 WRITE  (SCREEN,4650)
 4650 FORMAT (45H *** SO BE IT.  TO RUN NASTRAN LINK1 ONLY ***,/)
      GO TO  60
 4700 WRITE  (SCREEN,4750)
 4750 FORMAT (23H *** BLANK LINE IGNORED)
      GO TO  60
 4800 WRITE  (SCREEN,4850) TEMP
 4850 FORMAT (40H *** INTEGER ERROR IN CONTINUATION ID - ,A8)
      IF (IECHOS .NE. -2) WRITE (SCREEN,3060) A8
      GO TO  4300
 4900 WRITE  (SCREEN,4950) (TMP(J),J=1,9)
 4950 FORMAT (35H *** CONTINUATION FIELD TOO LONG - ,9A1, /5X,
     1        25HLAST GENERATED CARD WAS -,/)
      WRITE  (SCREEN,2450) SAVE
      GO TO  4300
 5000 WRITE  (SCREEN,5050)
 5050 FORMAT (27H *** TOO MANY LEFT BRACKETS)
      GO TO  3050
 5100 WRITE  (NOUT,5150)
 5150 FORMAT (/,20H *** EOF ENCOUNTERED )
      IF (MACH.EQ.4 .AND. INFLAG.EQ.5) REWIND INFLAG
      GO TO  60
 5200 WRITE  (NOUT,5250)
 5250 FORMAT (/,48H *** SKIPFILE IGNORED.  FILE HAS NOT BEEN OPENED)
      GO TO  60
 5300 WRITE  (NOUT,5350)
 5350 FORMAT (/,26H *** FEATURE NOT AVAILABLE)
      IF (IECHOS .NE. -2) WRITE (SCREEN,3060) A8
      GO TO  60
 5400 WRITE  (NOUT,5450)
 5450 FORMAT (/,73H *** LEFT BRACKET ENCOUNTERED WITHOUT FIRST PRECEEDED
     1 BY '=', '*', OR '%')
      GO TO  3000
C
      END

      SUBROUTINE ADR
C
C     AERODYNAMIC DATA RECOVERY   -  FORCE OUTPUT BY SET SELECTION
C
C     DMAP
C     FLUTTER
C     ADR  CPHIH1,CASEZZ,QKHL,CLAMAL1,SPLINE,SILA,USETA/PKF/C,N,BOV/C,
C          N,MACH=0.0/C,N,APP $
C     DYNAMICS
C     ADR  UHVT1,CASECC,QKHL,TOL1,SPLINE,SILA,USETA/PKF/V,N,BOV/C,Y,
C          MACH=0.0/C,N,APP $
C
      INTEGER         SYSBUF,OUT,CASECC,DISP,QKHL,LOAD,SPLINE,SILA,
     1                USETA,IZ(1),PKF,APP,FLUT,FREQ,SCR1,SCR2,SCR3,SCR4,
     2                MCB(7)
      REAL            MACH
      CHARACTER       UFM*23,UWM*25,UIM*29
      COMMON /XMSSG / UFM,UWM,UIM
      COMMON /BLANK / BOV,MACH,APP
      COMMON /SYSTEM/ SYSBUF,OUT
      COMMON /CONDAS/ PI,TWOPI
      COMMON /UNPAKX/ IOUT,INN,NNN,INCR1
      COMMON /PACKX / ITI,ITO,II,NN,INCR
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE     (Z(1),IZ(1))
      DATA    IAERO / 176/
      DATA    FLUT  / 4HFLUT/, FREQ /4HFREQ/
      DATA    DISP  / 101/ , CASECC /102/ , QKHL /103/ , LOAD /104/
      DATA    SPLINE/ 105/ , SILA   /106/ , USETA/107/ , PKF  /201/
      DATA    SCR1  / 301/ , SCR2   /302/ , SCR3 /303/ , SCR4 /304/
C
C
C     BUILD    P    =  Q    *  U
C               KF      KH      H
C     WHERE  QKH INTERPOLATED FOR A EIGENVALUE OR FREQUENCY - MACH DEP.
C            UH  - EIGENVALUE OR FREQUENCY
C
C
C     INITIALIZE  - LOOK FOR A REQUEST
C
      IF (APP.EQ.FLUT .OR. APP.EQ.FREQ) GO TO 5
      GO TO 1000
    5 NCORE  = KORSZ(Z)
      IBUF1  = NCORE - SYSBUF
      CALL OPEN (*1000,CASECC,IZ(IBUF1),0)
      CALL FWDREC (*1000,CASECC)
      CALL READ (*1000,*10,CASECC,Z,IBUF1,0,NW)
   10 IF (IZ(IAERO) .EQ. 0) GO TO 1000
      CALL CLOSE (CASECC,1)
C
C     BUILD INTERPOLATED MATRIX FROM QHKL ON SCR1
C     DEPENDENT LIST
C     IF CLAMAL1 PICK UP FREQUENCY FROM OFP TABLE
C     IF TOL1    PICK UP FREQUENCY FROM HEADER
C     INDEPENDENT LIST ON QKHL
C
      CALL OPEN (*1000,LOAD,IZ(IBUF1),0)
      IF (APP .EQ. FLUT) GO TO 30
C
C     TOL1 = LOAD
C
      MCB(1) = CASECC
      CALL RDTRL (MCB)
      CALL READ (*1000,*1000,LOAD,IZ,-2,0,NFREQ)
      CALL READ (*1000,*20,LOAD,IZ,IBUF1,0,NFREQ)
      GO TO 999
   20 NLOAD = MCB(2)
      GO TO 60
C
C     CLAMAL1 = LOAD
C
   30 CALL FWDREC (*1000,LOAD)
      CALL FWDREC (*1000,LOAD)
      CALL READ (*1000,*40,LOAD,IZ,IBUF1,0,NFREQ)
      GO TO 999
   40 NFREQ = NFREQ/6
      IF(BOV .EQ. 0.0) GO TO 997
      DO 50 I = 1,NFREQ
      K     =  I*6 - 1
      Z(I)  = Z(K)/(TWOPI*BOV)
   50 CONTINUE
      NLOAD = 1
C
C     CALL ADRI TO BUILD  (AFTER ADRI FREQUENCY*2PI*BOV IS IN Z AT EVERY
C     OTHER SLOT 0.0 ,W FOR NFREQ*2
C
   60 CALL CLOSE (LOAD,1)
      CALL ADRI (Z,NFREQ,NCORE,QKHL,SCR1,SCR2,SCR3,SCR4,NROW,NCOL,NOGO)
      IF (NOGO .NE. 0) GO TO 1000
C
C     SCR1 NOW HAS QKH INTERPOLATED    NROW*NCOL(ROW5)  NFREQ(COLUMNS)
C
      IPQ   = NFREQ*2 + 1
C
C     BUILD PKF
C
      IOUT  = 3
      ITI   = 3
      ITO   = 3
      INCR  = 1
      INCR1 = 1
      MCB(1)= DISP
      CALL RDTRL (MCB)
      IF (MCB(1) .LT.    0) GO TO 1000
      IF (MCB(3) .NE. NCOL) GO TO 998
      NNS1  = NROW*NCOL
      II    = 1
      NN    = NROW
      INN   = 1
      IBUF2 = IBUF1 - SYSBUF
      CALL GOPEN (PKF,Z(IBUF2),1)
      IBUF3 = IBUF2 - SYSBUF
      CALL GOPEN (DISP,Z(IBUF3),0)
      CALL GOPEN (SCR1,Z(IBUF1),0)
      MCB(1) = PKF
      MCB(2) = 0
      MCB(3) = NN
      MCB(6) = 0
      MCB(7) = 0
      NTERMS = NNS1*2
      NTERMD = NCOL*2
      NTERMA = NROW*2
      IPD    = IPQ + NTERMS
      IPA    = IPD + NTERMD
      NEXT   = IPA + NTERMA
      IF (NEXT .GT. IBUF3) GO TO 999
      DO 150 I = 1,NLOAD
      DO 140 J = 1,NFREQ
C
C     UNPACK INTERPOLATED MATRIX COLUMN THEN DISP VECTOR  MULTIPLY AND
C     PACK OUT
C
      NNN = NNS1
      CALL UNPACK (*70,SCR1,Z(IPQ))
C
C     MULTIPLY BACK BY FREQUENCY (K)
C
      DO 71 L = 1,NTERMS,2
      M = J*2
      Z(IPQ+L) = Z(IPQ+L)*Z(M)
   71 CONTINUE
      GO TO 75
   70 CALL ZEROC (Z(IPQ),NTERMS)
   75 NNN = NCOL
      CALL UNPACK (*80,DISP,Z(IPD))
      GO TO 90
   80 CALL ZEROC (Z(IPD),NTERMD)
   90 CALL GMMATC (Z(IPD),1,NCOL,0,Z(IPQ),NCOL,NROW,0,Z(IPA))
      CALL PACK (Z(IPA),PKF,MCB)
  140 CONTINUE
      IF (I .EQ. NLOAD) GO TO 150
      CALL REWIND (SCR1)
      CALL SKPREC (SCR1,1)
  150 CONTINUE
      CALL CLOSE  (SCR1,1)
      CALL CLOSE  (DISP,1)
      CALL CLOSE  (PKF, 1)
      CALL WRTTRL (MCB)
      CALL DMPFIL (-PKF,Z(IPQ),IBUF3-IPQ)
C
C     PUT FREQUENCY BACK TO ORIGINAL VALUE
C
      DO 160 I = 1,NFREQ
      Z(I) = Z(I*2)/(TWOPI*BOV)
  160 CONTINUE
C
C     PRINT RESULTS
C
      CALL ADRPRT (CASECC,PKF,SPLINE,SILA,USETA,Z,NFREQ,NCORE,NLOAD)
C
C     STOP  CLOSE ALL POSSIBLE OPENS
C
 1000 CALL CLOSE (CASECC,1)
      CALL CLOSE (LOAD  ,1)
      CALL CLOSE (PKF   ,1)
      CALL CLOSE (DISP  ,1)
      RETURN
C
C     ERROR MESSAGES
C
  999 CALL MESAGE (8,0,NAM)
      GO TO 1000
  998 CALL MESAGE (7,0,NAM)
      GO TO 1000
  997 WRITE  (OUT,9970) UIM
 9970 FORMAT (A29,' 2272, NO FLUTTER CALCULATIONS CAN BE MADE IN ',
     1        'MODULE ADR SINCE BOV = 0.0.')
      GO TO 1000
      END

      SUBROUTINE NORM1 (X,DIV)
C*******
C     NORM WILL NORMALIZE X TO MAXIMUM ELEMENT EQUAL TO ONE AND STORE TH
C     DIVISOR IN MAX
C*******
      DOUBLE PRECISION   X(1)      ,MAX      ,DIV
      COMMON   /INVPWX/  FILEK(7)
      EQUIVALENCE        (NCOL,FILEK(2))
      DATA IND1 /1/
      MAX = 0.D0
      DO 10 I=1,NCOL
      DIV = DABS( X(I) )
      IF( DIV .LE. MAX ) GO TO 10
      MAX = DIV
      IND = I
   10 CONTINUE
      IF( X(IND) .LT. 0.D0 ) IND = -IND
      I = IABS(IND1)
      XX = X(I)
      DIV = SIGN(1.,XX)*FLOAT(ISIGN(1,IND1))*MAX
      XX = DIV
      IND1 = IND*IFIX(SIGN(1.,XX))
      MAX = 1.D0/DIV
      DO 20 I=1,NCOL
      XI = X(I)*MAX
      IF (ABS(XI) .LT. 1.E-36) XI=0.
   20 X(I)= XI
      RETURN
      END

      SUBROUTINE NA1 2 A8 (*,A,N,B,NOTUSE)
C
      INTEGER         A(1),     B(2),    CDC
      CHARACTER*1     C(1),     T(8)
      CHARACTER*8     D(1)
      CHARACTER*10    BLNK,     TEMP
      COMMON /XREADX/ NOUT
      COMMON /MACHIN/ MACH
      EQUIVALENCE     (T(1),TEMP)
      DATA            BLNK / '          '  /, CDC / 4  /
C
C     THESE ROUTTNES CONVERT N A1 BCD WORDS IN A, OR N A1 CHARACTERS IN
C     C TO AN 8-BYTE BCD WORD IN B (CDC ONLY), (OR TO TWO 4-BYTE BCD
C     WORDS IN B, ALL OTHER NON-CDC MACHINES), OR AN 8-CHARACTER WORD
C     IN D, LEFT ADJUSTED.
C     CALLING ROUTINE MUST NOT USE LOGICAL*1 FOR A-ARRAY.
C     (NO SYSTEM ENCODE/DECODE FUNCTIONS ARE USED)
C
C     ENTRY POINTS   NA1 2 A8  (BCD-BYTE  VERSION)
C                    NK1 2 K8  (CHARACTER VERSION)
C
C
C     WRITTEN BY G.CHAN/SPERRY IN AUG. 1985
C     PARTICULARLY FOR XREAD ROUTINE, IN SUPPORT OF ITS NEW FREE-FIELD
C     INPUT FORMAT.  THIS SUBROUTINE IS MACHINE INDEPENDENT
C
C     LAST REVISED  8/1988
C
      IF (N .GT. 8) GO TO 40
      TEMP = BLNK
      CALL B2K (A,TEMP,N)
      IF (MACH .NE. CDC) CALL KHRBC2 (TEMP,B(1))
CWKBD IF (MACH .EQ. CDC) B(1) = ISWAP(TEMP)
      RETURN
C
      ENTRY NK1 2 K8 (*,C,N,D,NOTUSE)
C     ===============================
C
      IF (N .GT. 8) GO TO 40
      TEMP = BLNK
      DO 30 I = 1,N
 30   T(I) = C(I)
      D(1) = TEMP
      RETURN
C
 40   WRITE  (NOUT,50) N
 50   FORMAT ('   N.GT.8/NA12A8',I6)
      J = NOTUSE
      RETURN 1
      END

      SUBROUTINE PULL (BCD,OUT,ICOL,NCHAR,FLAG)
C
C     THIS ROUTINE EXTRACTS BCD DATA (OUT) FROM A STRING,(BCD)
C     STARTING AT POSITION ICOL
C
      EXTERNAL        ORF
      LOGICAL         FIRST
      INTEGER         BCD(1),OUT(1),FLAG,CPERWD,BLANK,ORF
      COMMON /SYSTEM/ IDUM(38),NBPC,NBPW,NCPW
      DATA    CPERWD/ 4 /, BLANK / 4H     /, FIRST / .TRUE. /
C
      NWDS  = (NCHAR-1)/CPERWD + 1
      IF (.NOT.FIRST) GO TO 5
      FIRST = .FALSE.
      NX    = NCPW - CPERWD
      IXTRA = NX*NBPC
      IBL   = 0
      IB1   = KRSHFT(BLANK,NCPW-1)
      IF (NX .EQ. 0) GO TO 5
      DO 2 I = 1,NX
      IBL = ORF(IBL,KLSHFT(IB1,I-1))
    2 CONTINUE
    5 DO 10 I = 1,NWDS
   10 OUT(I) = IBL
C
      IWD = (ICOL-1)/CPERWD + 1
      M1  = (ICOL-(IWD-1)*CPERWD-1)*NBPC
      M2  = CPERWD*NBPC - M1
C
      DO 20 I = 1,NWDS
      IBCD   = IWD + I - 1
      ITEMP  = KRSHFT(BCD(IBCD),IXTRA/NBPC)
      OUT(I) = ORF(OUT(I),KLSHFT(ITEMP,(M1+IXTRA)/NBPC))
      ITEMP  = KRSHFT(BCD(IBCD+1),(M2+IXTRA)/NBPC)
      OUT(I) = ORF(OUT(I),KLSHFT(ITEMP,IXTRA/NBPC))
   20 CONTINUE
      IF (NWDS*CPERWD .EQ. NCHAR) RETURN
C
C     REMOVE EXTRA CHARACTERS FROM LAST OUT WORD
C
      NBL   = (NWDS-1)*CPERWD + NCPW - NCHAR
      LWORD = KRSHFT(OUT(NWDS),NBL)
      OUT(NWDS) = KLSHFT(LWORD,NBL)
C
      ITEMP = 0
      DO 40 I = 1,NBL
      ITEMP = ORF(ITEMP,KLSHFT(IB1,I-1))
   40 CONTINUE
      OUT(NWDS) = ORF(OUT(NWDS),ITEMP)
C
      RETURN
      END

      SUBROUTINE GENDSB(NCARAY,NBARAY,SG,CG,NFL,NBEA1,NBEA2,IFLA1,
     *   IFLA2,DT,DPZ,DPY)
      INTEGER SCR1,SCR2,SCR3,SCR4,SCR5,ECORE,SYSBUF
      INTEGER Z
      DIMENSION NAME(2)
      DIMENSION NCARAY(1),NBARAY(1),SG(1),CG(1),NFL(1),NBEA1(1)
      DIMENSION NBEA2(1),IFLA1(1),IFLA2(1)
      COMPLEX DT(1),DPZ(1),DPY(1)
      COMMON /SYSTEM/ SYSBUF
      COMMON /ZZZZZZ / Z(1)
      COMMON /AMGMN / MCB(7),NROW,ND,NE,REFC,FMACH,RFK,TSKJ(7),ISK,NSK
      COMMON /DLBDY/ NJ1,NK1,NP,NB,NTP,NBZ,NBY,NTZ,NTY,NTO,NTZS,NTYS,
     *   INC,INS,INB,INAS,IZIN,IYIN,INBEA1,INBEA2,INSBEA,IZB,IYB,
     *   IAVR,IARB,INFL,IXLE,IXTE,INT121,INT122,IZS,IYS,ICS,IEE,ISG,
     *   ICG,IXIJ,IX,IDELX,IXIC,IXLAM,IA0,IXIS1,IXIS2,IA0P,IRIA,
     *   INASB,IFLAX,IFLA ,ITH1A,ITH2A,
     *   ECORE,NEXT,SCR1,SCR2,SCR3,SCR4,SCR5,NTBE
      DATA NAME /4HGEND,4HB   /
C   ***   GENERATES THE INFLUENCE COEFFICIENT MATRIX  DT   USING THE
C         FOLLOWING FOUR SUBROUTINES  --  DPPS, DPZY, DZPY,  AND  DYPZ
      NBOX = NTP
      LBO  = 1
      LSO  = 1
      JBO  = 1
      KB   = 0
      KT   = 0
      DO 40 I=1,NTBE
      DPY(I) = (0.0,0.0)
      DT(I) = (0.0,0.0)
   40 CONTINUE
      NBUF = 4
      IF(NTP.EQ.0) NBUF = NBUF - 1
      IF(NTZ.EQ.0) NBUF = NBUF - 1
      IF(NTY.EQ.0) NBUF = NBUF - 2
      IF(NEXT + NBUF*SYSBUF .GT. ECORE) CALL MESAGE(-8,0,NAME)
      IBUF1 = ECORE - SYSBUF
      IBUF2 = IBUF1 - SYSBUF
      NSTRIP = 0
      J2 = 0
      I2 = 0
      NYFLAG = 0
      IF(NTP.NE.0) CALL GOPEN(SCR1,Z(IBUF1),1)
      IF(NTP .EQ.0) GO TO 201
      I1   = 1
      I2   = NTP
      J1   = 1
      J2   = NTP
C  DPP-LOOP
      K    = 1
C  K IS THE PANEL NUMBER ASSOCIATED WITH RECEIVING POINT  I
      KS   = 1
C  KS IS THE STRIP NUMBER ASSOCIATED WITH RECEIVING POINT  I
      NBXR = NCARAY(K)
      DO  60  I=I1,I2
      SGR  = SG(KS)
      CGR  = CG(KS)
      CALL      DPPSB(  KS,I,J1,J2,SGR,CGR,           Z(IYS),Z(IZS),
     *   NBARAY,NCARAY,DT,Z(1))
      CALL WRITE(SCR1,DT,2*NTP,0)
      IF (I.EQ.I2)  GO TO  60
      IF (I.EQ.NBARAY(K))  K=K+1
      IF (I.EQ.NBXR)  GO TO   50
      GO TO  60
   50 CONTINUE
      KS   = KS+1
      NBXR = NBXR+NCARAY(K)
   60 CONTINUE
      CALL WRITE(SCR1,0,0,1)
      NSTRIP = KS
      NZYSV= 0
      DO  70  J=J1,J2
      DT(J)= (0.0,0.0)
   70 CONTINUE
      NLT1 = 0
      NLT2 = 0
      IF (NTZ.EQ.0)  GO TO  180
      IF(NTY.NE.0) CALL GOPEN(SCR4,Z(IBUF2),1)
      I1   = I2+1
      I2   = I2+NTZ
C  DPZ-LOOP    **    ALSO USED FOR GENERATING THE DPY-MATRIX  --  SEE
C  COMMENT IN  DPY-LOOP  BELOW
   80 CONTINUE
      KB   = KB+1
C  KB  IS THE BODY NUMBER ASSOCIATED WITH RECEIVING POINT  I
      IZ   = 0
      KT   = KT+1
C  KT  IS THE INDEX OF THE ARRAY OF FIRST-AND-LAST-ELEMENTS FOR THETA-1
      ICOUNT = 1
      IFL    = NFL(KB)
      NZYKB = NBEA2(KB)
      IFIRST = IFLA1(KT)
      ILAST = IFLA2(KT)
      DO  170  I=I1,I2
      DO  90  J=J1,J2
      DPZ(J) = (0.0,0.0)
      DPY(J) = (0.0,0.0)
   90 CONTINUE
      CALL       DPZY(   KB,IZ,I,J1,J2,IFIRST,ILAST,Z(IYB),
     * Z(IZB),Z(IAVR),Z(IARB),Z(ITH1A+NLT1),Z(ITH2A+NLT2),Z(INT121),
     * Z(INT122),NBARAY,NCARAY,NZYKB,DPZ,DPY)
      GO TO  (100,100,110),  NZYKB
  100 CONTINUE
      CALL WRITE(SCR1,DPZ,2*NTP,0)
      IF (NZYKB.EQ.1)  GO TO 120
  110 CONTINUE
      CALL WRITE(SCR4,DPY,2*NTP,0)
  120 CONTINUE
      IF (IZ.EQ.NBEA1(KB) )  GO TO 130
      IF (IZ.EQ.ILAST.AND.ICOUNT.LT.IFL)  GO TO 160
      GO TO  170
  130 CONTINUE
      IZ     = 0
      IF (NZYSV.LE.1.AND.NZYKB.GE.2)  GO TO  140
      GO TO  150
  140 CONTINUE
      LBO  = KB
      LSO  = NSTRIP+LBO
      JBO  = I-NBEA1(KB) -NBOX+1
  150 CONTINUE
      NZYSV = NZYKB
      IF(I.EQ.I2) GO TO 180
      KB     = KB+1
      ICOUNT = 0
      IFL    = NFL(KB)
      NZYKB = NBEA2(KB)
  160 CONTINUE
      KT     = KT+1
      ICOUNT = ICOUNT+1
      IFIRST = IFLA1(KT)
      ILAST = IFLA2(KT)
  170 CONTINUE
  180 CONTINUE
      IF(I2.EQ.NTBE) GO TO 190
C  DPY-LOOP    **    THIS LOOP IS REDUCED TO SETTING THE CORRECT INDICES
C  AND USING THE  DPZ-LOOP  ABOVE
      IF(NTZ.EQ.0) CALL GOPEN(SCR4,Z(IBUF2),1)
      I1   = I2+1
      I2 = NTBE
      GO TO 80
  190 CALL WRITE(SCR1,0,0,1)
      IF(NTY.NE.0) CALL WRITE(SCR4,0,0,1)
      CALL CLOSE(SCR1,1)
      CALL CLOSE(SCR4,1)
      I1   = 1
      I2   = NTP
      IF (NTZ.EQ.0)  GO TO  250
      CALL GOPEN(SCR2,Z(IBUF1),1)
C  DZP-LOOP
      K    = 1
C  K  IS THE PANEL NUMBER ASSOCIATED WITH RECEIVING POINT  I
      KS   = 1
C  KS  IS THE STRIP NUMBER ASSOCIATED WITH RECEIVING POINT  I
      NBXR = NCARAY(K)
      KB   = 0
C  HERE  KB=0  SERVES AS A FLAG INDICATING THAT THE RECEIVING POINT   I
C  IS ON A PANEL AND NOT   ON A BODY
      J1   = J2+1
      J2   = J2+NTZ
      DO  210  I=I1,I2
      LS   = NSTRIP+1
      SGR  = SG(KS)
      CGR  = CG(KS)
      CALL       DZPY(KB,KS,LS,   I,J1,J2,NYFLAG,          SGR,CGR,
     1           FMACH,   Z(IARB),Z(INBEA1),DT)
      CALL WRITE(SCR2,DT(J1),2*NTZ,0)
      IF (I.EQ.I2)  GO TO  210
      IF (I.EQ.NBARAY(K))  K =K +1
      IF (I.EQ.NBXR)  GO TO  200
      GO TO  210
  200 CONTINUE
      KS   = KS+1
      NBXR = NBXR+NCARAY(K)
  210 CONTINUE
      CALL WRITE(SCR2,0,0,1)
  201 CONTINUE
      IF(NTZ.EQ.0) GO TO 250
      IF(NTP.EQ.0) CALL GOPEN(SCR2,Z(IBUF1),1)
      NYFLAG = 0
C  DZZ-LOOP    **    ALSO USED FOR GENERATING THE  DZY  MATRIX  --  SEE
C  COMMENT IN  DZY-LOOP  BELOW
      KB   = 1
C  KB  IS THE BODY NUMBER ASSOCIATED WITH RECEIVING POINT  I
      KS   = NSTRIP+1
      IZ   = 0
      I1   = I2+1
      I2   = I2+NTZ
      SGR  = 0.0
      CGR  = 1.0
  220 CONTINUE
      LS   = NSTRIP+1
      LSX  = LS
      DO  240  I=I1,I2
      LS   = LSX
      IZ   = IZ+1
C  KS IS THE INDEX OF THE Y  AND  Z  COORDINATES OF RECEIVING POINT I
C  IN THE  DZZ-LOOP  KS RUNS FROM  (NSTRIP+1)  THROUGH  (NSTRIP+NBZ)
C  IN THE  DZY-LOOP  KS  RUNS FROM  (NSTRIP+NB-NBY+1) THROUGH  NSTRIP+NB
      CALL       DZPY(KB,KS,LS,   I,J1,J2,NYFLAG,          SGR,CGR,
     1           FMACH,   Z(IARB),Z(INBEA1),DT)
      CALL WRITE(SCR2,DT(J1),2*NTZ,0)
      IF (IZ.EQ.NBEA1(KB) )  GO TO  230
      GO TO  240
  230 CONTINUE
      IZ   = 0
      KB   = KB+1
      KS   = KS+1
  240 CONTINUE
      CALL WRITE(SCR2,0,0,1)
      IF(NTY.EQ.0) CALL CLOSE(SCR2,1)
      IF (NTY.EQ.0)  GO TO 320
      IF (NYFLAG.NE.0)  GO TO  250
C  DZY-LOOP    **    THIS LOOP IS REDUCED TO SETTING THE CORRECT INDICES
C  AND USING THE  DZZ-LOOP  ABOVE
      I1 = NTBE-NTY+1
      I2 = NTBE
      NYFLAG = 1
      KB   = LBO
      KS   = LSO
      SGR  =-1.0
      CGR  = 0.0
      GO TO  220
  250 CONTINUE
      CALL CLOSE(SCR2,1)
      IF (NTY.EQ.0)  GO TO 320
      CALL GOPEN(SCR3,Z(IBUF1),1)
      I1   = 1
      I2   = NTP
      J1 = NTBE-NTY+1
      J2 = NTBE
      IF(NTP.EQ.0) GO TO 275
C  DYP-LOOP
      K    = 1
      KS   = 1
      KB   = 0
      NBXR = NCARAY(K)
      SGR  = SG(KS)
      CGR  = CG(KS)
      DO  270  I=I1,I2
      CALL       DYPZ(KB,KS,LS,   I,J1,J2,NYFLAG,          SGR,CGR,
     1           FMACH,   Z(IARB),Z(INBEA1),          LBO,LSO,JBO,DT)
      CALL WRITE(SCR3,DT(J1),2*NTY,0)
      IF (I.EQ.NBARAY(K))  K=K+1
      IF (I.EQ.NBXR)  GO TO  260
      GO TO  270
  260 CONTINUE
      KS   = KS+1
      NBXR = NBXR+NCARAY(K)
      SGR  = SG(KS)
      CGR  = CG(KS)
  270 CONTINUE
      CALL WRITE(SCR3,0,0,1)
  275 CONTINUE
      NYFLAG = 0
      IZ   = 0
      IF (NTZ.EQ.0)  GO TO  310
C  DYZ-LOOP    **    ALSO USED FOR GENERATING THE  DYY  MATRIX  --  SEE
C  COMMENT IN  DYY-LOOP  BELOW
      I1   = I2+1
      I2   = I2+NTZ
      KS   = NSTRIP+1
      KB   = 1
      SGR  = 0.0
      CGR  = 1.0
  280 CONTINUE
      DO  300  I=I1,I2
      LS   = LSO
      IZ   = IZ+1
      CALL       DYPZ(KB,KS,LS,   I,J1,J2,NYFLAG,          SGR,CGR,
     1           FMACH,   Z(IARB),Z(INBEA1),          LBO,LSO,JBO,DT)
      CALL WRITE(SCR3,DT(J1),2*NTY,0)
      IF (IZ.EQ.NBEA1(KB) )  GO TO  290
      GO TO  300
  290 CONTINUE
      IZ   = 0
      KB   = KB+1
      KS   = KS+1
  300 CONTINUE
      CALL WRITE(SCR3,0,0,1)
  310 CONTINUE
      IF (NYFLAG.NE.0)  GO TO 320
C  DYY-LOOP    **    THIS LOOP IS REDUCED TO SETTING THE CORRECT INDICES
C  AND USING THE  DYZ-LOOP  ABOVE
      IF(NTP.EQ.0.AND.NTZ.EQ.0) CALL GOPEN(SCR3,Z(IBUF1),1)
      I1 = NTBE-NTY+1
      I2 = NTBE
      NYFLAG = 1
      KB   = LBO
      KS   = LSO
      SGR  =-1.0
      CGR  = 0.0
      GO TO  280
  320 CONTINUE
      CALL CLOSE(SCR3,1)
C
C     BUILD SCR5 WITH GEND PART OF A MATRIX
C
      I1   = 1
      I2   = NTP+NTZ
      NYFLAG = 0
      CALL GOPEN(SCR5,Z(IBUF1),1)
      IBUF3 = IBUF2 - SYSBUF
      IBUF4 = IBUF3 - SYSBUF
      IF(NTZ.NE.0) CALL GOPEN(SCR2,Z(IBUF3),0)
      IF(NTY.NE.0) CALL GOPEN(SCR3,Z(IBUF4),0)
      ITAPE = SCR1
      IF(I2.EQ.0) GO TO 365
  330 IF(NTP.NE.0) CALL GOPEN(ITAPE,Z(IBUF2),0)
      DO 360  I=I1,I2
      J1   = 1
      J2   = NTP
      IF(NTP.NE.0) CALL FREAD(ITAPE,DT,2*J2,0)
      IF(I.EQ.NTP) CALL FREAD(ITAPE,0,0,1)
      IF (NTZ.EQ.0)  GO TO 340
      J1   = J2+1
      J2   = J2+NTZ
      CALL FREAD(SCR2,DT(J1),2*NTZ,0)
      IF(I.EQ.NTP) CALL FREAD(SCR2,0,0,1)
  340 CONTINUE
      IF (NTY.EQ.0)  GO TO 350
      J1   = J2+1
      J2 = J2+NTY
      CALL FREAD(SCR3,DT(J1),2*NTY,0)
      IF(I.EQ.NTP) CALL FREAD(SCR3,0,0,1)
  350 CONTINUE
      CALL WRITE(SCR5,DT,2*J2,0)
  360 CONTINUE
      IF (NTY.EQ.0)  GO TO 370
      IF (NYFLAG.NE.0)  GO TO 370
      IF(NTZ.NE.0.AND.NTP.NE.0)CALL FREAD(SCR2,0,0,1)
      IF(NTY.NE.0.AND.NTP.NE.0)CALL FREAD(SCR3,0,0,1)
      CALL CLOSE(ITAPE,1)
  365 CONTINUE
      NYFLAG = 1
      I1   = I2+1
      I2   = I2+NTY
      ITAPE = SCR4
      GO TO 330
  370 CONTINUE
      CALL WRITE(SCR5,0,0,1)
      CALL CLOSE(SCR1,1)
      CALL CLOSE(SCR2,1)
      CALL CLOSE(SCR3,1)
      CALL CLOSE(SCR4,1)
      CALL CLOSE(SCR5,1)
      CALL DMPFIL(SCR5,Z(NEXT),ECORE-NEXT-100)
      RETURN
      END

      SUBROUTINE MBMODE(INPUT,OUT,ICOR,NCOR,Z,NI,ND,XD,YD,IS,CR)
C
C     MBMODE BUILDS THE MODE LIKE DATA ON OUT FROM SURFACE SPLINE INTER
C
      DIMENSION Z(1),XD(1),YD(1),NAME(2)
      DATA NAME /4HMBMO,4HDE  /
      NNI = NI*2
      NND = ND*2
      IF(ICOR+NNI+NND.GT.NCOR) CALL MESAGE(-8,0,NAME)
      CALL FREAD(INPUT,Z(ICOR),NNI,0)
      IDP = ICOR + NNI
      L = 0
      DO 10 I=1,ND
      Z(IDP+L) = XD(I)
      Z(IDP+L+1) = YD(I)
      L = L+2
   10 CONTINUE
      ICC = IDP+L
      NCORE = NCOR-ICC
C
C     CALL SSPLIN TO INTERPOLATE
C
      CALL SSPLIN(NI,Z(ICOR),ND,Z(IDP),0,0,1,0,0.0,Z(ICC),NCORE,IS)
      IF(IS.EQ.2) GO TO 1000
C
C     REORDER INTO MACH BOX ORDER
C
      M = IDP+ND
      ICC = ICC-1
      DO 30 I=1,NI
      L = 0
      DO 20 J=1,NND,2
      Z(IDP+L) = Z(ICC+J)
      Z(M+L) = Z(ICC+J+1) * CR
      L = L+1
   20 CONTINUE
      CALL WRITE(OUT,Z(IDP),NND,0)
      ICC = ICC + NND
   30 CONTINUE
 1000 RETURN
      END

      SUBROUTINE DSSIZE ( NAMFIL, NCOLS, NTERMS, NSTRGS, NWDTRM )
C
C   DSSIZE DETERMINES THE SIZE OF A GIVEN MATRIX FILE
C      NCOLS  = NUMBER OF COLUMNS
C      NTERMS = TOTAL NUMBER OF NON-ZERO TERMS IN MATRIX
C      NSTRGS = TOTAL NUMBER OF STRINGS OF CONSECUTIVE TERMS IN MATRIX
C      NWDTRM = NUMBER OF WORDS PER TERM
C
      INCLUDE 'DSIOF.COM'
      COMMON / ZZZZZZ / MEM( 4 )
      INTEGER   MCB(7)
      CALL GETURN( NAMFIL )
      IF ( IFILEX .EQ. 0 ) GO TO 701
      MCB( 1 ) = NAMFIL
      CALL RDTRL ( MCB )
      NCOLS  = MCB( 2 )
      NSTRGS = FCB( 16, IFILEX )
      NTERMS = FCB( 17, IFILEX )
      NWDTRM = 2
      IF ( MCB( 5 ) .EQ. 1 ) NWDTRM = 1
      IF ( MCB( 5 ) .EQ. 4 ) NWDTRM = 4
      GO TO 777
701   NTERMS = 0
      NSTRGS = 0
      NCOLS  = 0
      NWDTRM = 0
777   CONTINUE
      RETURN
      END

      SUBROUTINE NUMBER (SND,NUM,NDSTK,LVLS2,NDEG,RENUM,LVLST,LSTPT,
     1           NFLG,IBW2,IPF2,IPFA,ISDIR,STKA,STKB,STKC,STKD,NU,IDIM)
C
C     THIS ROUTINE IS USED ONLY IN BANDIT MODULE
C
C     NUMBER PRODUCES THE NUMBERING OF THE GRAPH FOR MIN BANDWIDTH
C
C     SND-      ON INPUT THE NODE TO BEGIN NUMBERING ON
C     NUM-      ON INPUT AND OUTPUT, THE NEXT AVAILABLE NUMBER
C     LVLS2-    THE LEVEL STRUCTURE TO BE USED IN NUMBERING
C     RENUM-    THE ARRAY USED TO STORE THE NEW NUMBERING
C     LVLST-    ON OUTPUT CONTAINS LEVEL STRUCTURE
C     LSTPT(I)- ON OUTPUT, INDEX INTO LVLST TO FIRST NODE IN ITH LVL
C               LSTPT(I+1) - LSTPT(I) = NUMBER OF NODES IN ITH LVL
C     NFLG-     =+1 IF SND IS FORWARD END OF PSEUDO-DIAM
C               =-1 IF SND IS REVERSE END OF PSEUDO-DIAM
C     IBW2-     BANDWIDTH OF NEW NUMBERING COMPUTED BY NUMBER
C     IPF2-     PROFILE OF NEW NUMBERING COMPUTED BY NUMBER
C     IBW2 AND IPF2 HERE DO NOT INCLUDE DIAGONAL TERMS.
C     IPFA-     WORKING STORAGE USED TO COMPUTE PROFILE AND BANDWIDTH
C     ISDIR-    INDICATES STEP DIRECTION USED IN NUMBERING(+1 OR -1)
C     STACKS HAVE DIMENSION OF IDIM
C     NU-       WORK SPACE FOR BUNPAK
C
      INTEGER          SND,      STKA,     STKB,     STKC,     STKD,
     1                 XA,       XB,       XC,       XD,       END,
     2                 CX,       RENUM,    TEST
      DIMENSION        STKA(1),  STKB(1),  STKC(1),  STKD(1),  LVLS2(1),
     1                 NDEG(1),  RENUM(1), LVLST(1), LSTPT(1), NU(1),
     2                 IPFA(1),  NDSTK(1)
      COMMON /BANDB /  DUM3(3),  NGRID
      COMMON /BANDG /  N,        IDPTH,    IDEG
      COMMON /BANDS /  DUMS(4),  MAXGRD,   MAXDEG
      COMMON /SYSTEM/  IBUF,     NOUT
C
C     SET UP LVLST AND LSTPT FROM LVLS2
C
      DO 10 I=1,N
   10 IPFA(I)=0
      NSTPT=1
      DO 15 I=1,IDPTH
      LSTPT(I)=NSTPT
      DO 15 J=1,N
      IF (LVLS2(J).NE.I) GO TO 15
      LVLST(NSTPT)=J
      NSTPT=NSTPT+1
   15 CONTINUE
      LSTPT(IDPTH+1)=NSTPT
C
C     THIS ROUTINE USES FOUR STACKS, A,B,C,AND D, WITH POINTERS
C     XA,XB,XC, AND XD.  CX IS A SPECIAL POINTER INTO STKC WHICH
C     INDICATES THE PARTICULAR NODE BEING PROCESSED.
C     LVLN KEEPS TRACK OF THE LEVEL WE ARE WORKING AT.
C     INITIALLY STKC CONTAINS ONLY THE INITIAL NODE, SND.
C
      LVLN=0
      IF (NFLG.LT.0) LVLN=IDPTH+1
      XC=1
      STKC(XC)=SND
   20 CX=1
      XD=0
      LVLN=LVLN+NFLG
      LST=LSTPT(LVLN)
      LND=LSTPT(LVLN+1)-1
C
C     BEGIN PROCESSING NODE STKC(CX)
C
   25 IPRO=STKC(CX)
      RENUM(IPRO)=NUM
      NUM=NUM+ISDIR
      END=NDEG(IPRO)
      XA=0
      XB=0
C
C     CHECK ALL ADJACENT NODES
C
      CALL BUNPAK(NDSTK,IPRO,END,NU)
      DO 40 I=1,END
      TEST =NU(I)
      INX=RENUM(TEST)
C
C     ONLY NODES NOT NUMBERED OR ALREADY ON A STACK ARE ADDED
C
      IF (INX.EQ.0) GO TO 30
      IF (INX.LT.0) GO TO 40
C
C     DO PRELIMINARY BANDWIDTH AND PROFILE CALCULATIONS
C
      NBW=(RENUM(IPRO)-INX)*ISDIR
      IF (ISDIR.GT.0) INX=RENUM(IPRO)
      IF (IPFA(INX).LT.NBW) IPFA(INX)=NBW
      GO TO 40
   30 RENUM(TEST)=-1
C
C     PUT NODES ON SAME LEVEL ON STKA, ALL OTHERS ON STKB
C
      IF (LVLS2(TEST).EQ.LVLS2(IPRO)) GO TO 35
      XB=XB+1
      IF (XB.GT.IDIM) GO TO 100
      STKB(XB)=TEST
      GO TO 40
   35 XA=XA+1
      IF (XA.GT.IDIM) GO TO 100
      STKA(XA)=TEST
   40 CONTINUE
C
C     SORT STKA AND STKB INTO INCREASING DEGREE AND ADD STKA TO STKC
C     AND STKB TO STKD
C
      IF (XA.EQ.0) GO TO 50
      IF (XA.EQ.1) GO TO 45
      CALL SORTDG (STKC,STKA,XC,XA,NDEG)
      GO TO 50
   45 XC=XC+1
      IF (XC.GT.IDIM) GO TO 100
      STKC(XC)=STKA(XA)
   50 IF (XB.EQ.0) GO TO 65
      IF (XB.EQ.1) GO TO 60
      CALL SORTDG (STKD,STKB,XD,XB,NDEG)
      GO TO 65
   60 XD=XD+1
      IF (XD.GT.IDIM) GO TO 100
      STKD(XD)=STKB(XB)
C
C     BE SURE TO PROCESS ALL NODES IN STKC
C
   65 CX=CX+1
      IF (XC.GE.CX) GO TO 25
C
C     WHEN STKC IS EXHAUSTED LOOK FOR MIN DEGREE NODE IN SAME LEVEL
C     WHICH HAS NOT BEEN PROCESSED
C
      MAX=IDEG+1
      SND=N+1
      DO 70 I=LST,LND
      TEST=LVLST(I)
      IF (RENUM(TEST).NE. 0) GO TO 70
      IF (NDEG(TEST).GE.MAX) GO TO 70
      RENUM(SND)=0
      RENUM(TEST)=-1
      MAX=NDEG(TEST)
      SND=TEST
   70 CONTINUE
      IF (SND.EQ.N+1) GO TO 75
      XC=XC+1
      IF (XC.GT.IDIM) GO TO 100
      STKC(XC)=SND
      GO TO 25
C
C     IF STKD IS EMPTY WE ARE DONE, OTHERWISE COPY STKD ONTO STKC
C     AND BEGIN PROCESSING NEW STKC
C
   75 IF (XD.EQ.0) GO TO 90
      DO 80 I=1,XD
   80 STKC(I)=STKD(I)
      XC=XD
      GO TO 20
C
C     DO FINAL BANDWIDTH AND PROFILE CALCULATIONS
C
   90 DO 95 I=1,N
      IF (IPFA(I).GT.IBW2) IBW2=IPFA(I)
      IPF2=IPF2+IPFA(I)
   95 CONTINUE
      RETURN
C
C     DIMENSION EXCEEDED  . . .  STOP JOB.
C
  100 NGRID=-3
      RETURN
      END

      SUBROUTINE VARIAN
C
C     VARIANCE ANALYSIS POST PROCESSOR MODULE
C
C     INPUTS--O1,O2,O3,O4,O5 OR EDT
C
C     OUTPUTS--O1O,O2O,O3O,O4O,O5O
C
C     PARAMETERS--OP--BCD'DER' OR 'VAR'
C                 DELTA--REAL--DEFAULT=1.0
C
      LOGICAL TAPBIT
      INTEGER IT1,IT2,IT3,IT4,IT5,OT1,OT2,OT3,OT4,OT5,NAME(2),MCB(7),
     1        SYSBUF,SCR1,SCR2,DER,VAR,FILE,ITF(5),ITO(5),VARL(3),
     2        DERL(3),VARAN(2),IZ(260)
      REAL    Z(200)
      COMMON /SYSTEM/ SYSBUF,SKIP(91),JRUN
      COMMON /BLANK / IOP(2),DELTA
      COMMON /ZZZZZZ/ RZ(1)
      EQUIVALENCE (IT1,ITF(1)),(ITF(2),IT2) ,(ITF(3),IT3),(ITF(4),IT4),
     1            (ITF(5),IT5),(ITO(1) ,OT1),(ITO(2),OT2),(ITO(3),OT3),
     2            (ITO(4),OT4),(ITO(5),OT5) ,(Z(1),IZ(1),RZ(1))
      DATA IT1,IT2,IT3,IT4,IT5,OT1,OT2,OT3,OT4,SCR1,OT5,INPT, SCR2 /
     1     101,102,103,104,105,201,202,203,204,301 ,205,4HINPT,302 /
      DATA  DER   , VAR   , DERL  ,                 NAME             /
     1      4HDER , 4HVAR , 4HDERI, 4HVATI, 4HVE  , 4HVARI, 4HAN     /
      DATA  VARL  ,                 IBLNK , VARAN   ,       MCB      /
     1      4HVARI, 4HANCE, 4H    , 4H    , 4202, 42,       7*0      /
C
      IBUF1 = KORSZ(Z(1))-SYSBUF
      IBUF2 = IBUF1-SYSBUF
      IBUF3 = IBUF2-SYSBUF
      NZ    = IBUF3-1
      IF (NZ .LE. 0) CALL MESAGE(-8,0,NAME)
      IF (.NOT.TAPBIT(INPT)) CALL MESAGE(-7,0,NAME)
      CALL INT2A8 (*5,JRUN,IZ)
    5 NJRUN=IZ(1)
      NW=1
      IF (IOP(1) .EQ. VAR) GO TO 300
      IF (IOP(1) .NE. DER) RETURN
C
C     DERIVATIVES SECTION
C
      IF (JRUN .NE. 0) GO TO 30
C
C     COPY INPUT FILES TO INPT TAPE
C
      CALL OPEN (*900,INPT,IZ(IBUF1),1)
      I=1
      ASSIGN 20 TO IRET
   10 FILE = ITF(I)
      GO TO 700
   20 I = I + 1
      IF (I .LE. 5) GO TO 10
      CALL CLOSE (INPT,2)
      RETURN
C
C     COMPUTE DERIVATIVES  DJ = (OJ - O0)/DELTA
C
   30 CONTINUE
      CALL OPEN (*900,INPT,IZ(IBUF1),0)
C
      DO 250 I = 1,5
      IFOUND = 0
      CALL FWDREC (*220,INPT)
      CALL OPEN (*230,ITF(I),IZ(IBUF2),0)
      CALL FWDREC (*910,ITF(I))
      CALL GOPEN (ITO(I),IZ(IBUF3),1)
      FILE = ITF(I)
   40 ASSIGN 60 TO IRTN
   50 CALL READ (*220,*920,INPT,IZ(1),146,1,IFLAG)
      GO TO IRTN, (60,70)
   60 CALL READ (*230,*920,FILE,IZ(147),146,1,IFLAG)
C
C     CHECK FOR MATCH ON SUBCASE
C
   70 IF (IZ(4)-IZ(150)) 80,100,90
C
C     NEED NEW INPT RECORD
C
   80 CALL FWDREC (*910,INPT)
      ASSIGN 70 TO IRTN
      GO TO 50
C
C     NEED NEW FILE RECORD
C
   90 CALL FWDREC (*910,FILE)
      GO TO 60
C
C     CHECK FOR MATCH ON TIME, FREQ ETC
C
  100 IF (Z(5)-Z(151)) 80,110,90
C
C     CHECK FOR MATCH ON ELTYPE
C
  110 IF (IZ(3)-IZ(149)) 80,120,90
C
C     WE GOT ONE
C
  120 CONTINUE
      IZ(257) = DERL(1)
      IZ(258) = DERL(2)
      IZ(259) = DERL(3)
      IZ(260) = NJRUN
      IFOUND  = 1 + IFOUND
      CALL WRITE (ITO(I),IZ(147),146,1)
      NREC=IZ(10)
  130 ASSIGN 150 TO IRTN1
  140 CALL READ (*910,*190,INPT,IZ(1),NREC,0,IFLAG)
      ID1 = IZ(1)/10
      GO TO IRTN1, (150,160)
  150 CALL READ (*910,*200,FILE,IZ(NREC+1),NREC,0,IFLAG)
      ID2 = IZ(NREC+1)/10
      ASSIGN 160 TO IRTN1
  160 IF (ID1-ID2) 140,170,150
C
C     POINT CHECKS
C
  170 CONTINUE
      DO 180 J=2,NREC
      ITYPE = NUMTYP(IZ(J))
      IF (ITYPE.NE.2 .AND. ITYPE.NE.0) GO TO 180
      Z(NREC+J) = (Z(NREC+J) - Z(J))/DELTA
  180 CONTINUE
      CALL WRITE (ITO(I),IZ(NREC+1),NREC,0)
      GO TO 130
C
C     END OF DATA RECORD
C
  190 CALL FWDREC (*910,FILE)
      GO TO 210
  200 CALL FWDREC (*910,INPT)
  210 CALL WRITE (ITO(I),0,0,1)
      GO TO 40
C
C     EOF ON INPT
C
  220 GO TO 240
C
C     EOF ON FILE
C
  230 CALL SKPFIL (INPT,1)
  240 CALL CLOSE (FILE,1)
      CALL CLOSE (ITO(I),1)
      MCB(1)=ITO(I)
      MCB(2)=IFOUND
      IF (IFOUND .NE. 0) CALL WRTTRL (MCB)
  250 CONTINUE
C
C     SKIP OVER OLD DERIVATIVES
C
      I = 5*JRUN - 5
      CALL SKPFIL (INPT,I)
      CALL CLOSE (INPT,2)
      CALL GOPEN (INPT,IZ(IBUF1),3)
      I = 1
      ASSIGN 270 TO IRET
  260 FILE = ITO(I)
      MCB(1) = FILE
      CALL RDTRL (MCB)
      IF (MCB(2) .NE. 0) GO TO 700
      CALL EOF (INPT)
  270 I = I + 1
      IF (I .LE. 5) GO TO 260
      CALL CLOSE (INPT,2)
  280 RETURN
C
C     VARIANCE SECTION
C
  300 IF (JRUN .EQ. 0) RETURN
C
C     SEE IF VARIANCE IS TO BE COMPUTED
C
      CALL PRELOC (*280,IZ(IBUF1),IT1)
      CALL LOCATE (*320,IZ(IBUF1),VARAN,IFLAG)
C
C     READ IN VARIANCES
C
      CALL READ (*910,*310,IT1,IZ(1),NZ,0,IFLAG)
      CALL MESAGE (-8,0,NAME)
  310 IF (IFLAG-1 .EQ. JRUN) GO TO 330
  320 CALL CLOSE (IT1,1)
      RETURN
C
C     SET UP FOR VARIANCES
C
  330 CALL CLOSE (IT1,1)
      CALL OPEN (*900,INPT,IZ(IBUF1),0)
      CALL SKPFIL (INPT,5)
      IN1 = INPT
      IO1 = SCR1
      DO 620 I = 1,JRUN
      IF (I .EQ. JRUN) GO TO 340
      CALL OPEN (*900,IO1,IZ(IBUF2),1)
  340 CONTINUE
      IF (I .EQ. 1) GO TO 350
      CALL OPEN (*900,IN1,IZ(IBUF3),0)
  350 CONTINUE
      DO 610 J = 1,5
      IF (I .NE. JRUN) GO TO 360
C
C     FIX UP FOR WRITING ON OUTPUT FILES
C
      CALL OPEN (*610,ITO(J),IZ(IBUF2),1)
      CALL FNAME (ITO(J),MCB)
      CALL WRITE (ITO(J),MCB,2,1)
      IFOUND = 0
      IO1 = ITO(J)
  360 CONTINUE
      CALL FWDREC (*590,INPT)
  370 ASSIGN 400 TO IRTN2
  380 CALL READ (*600,*920,IN1,IZ(JRUN+1),146,1,IFLAG)
      IF (I .NE. 1) GO TO 390
      IZ(JRUN+111) = VARL(1)
      IZ(JRUN+112) = VARL(2)
      IZ(JRUN+113) = VARL(3)
      IZ(JRUN+114) = IBLNK
      GO TO 460
C
C     CHECK FOR MATCH
C
  390 GO TO IRTN2, (400,410)
  400 CALL READ (*580,*920,INPT,IZ(JRUN+147),146,1,IFLAG)
  410 IF (IZ(JRUN+4)-IZ(JRUN+150)) 420,440,430
  420 CALL FWDREC (*910,IN1)
      ASSIGN 410 TO IRTN2
      GO TO 380
  430 CALL FWDREC (*910,INPT)
      GO TO 400
  440 IF ( Z(JRUN+5)- Z(JRUN+151)) 420,450,430
  450 IF (IZ(JRUN+3)-IZ(JRUN+149)) 420,460,430
C
C     MATCH
C
  460 CALL WRITE (IO1,IZ(JRUN+1),146,1)
      NREC = IZ(JRUN+10)
      M = JRUN + NREC
  470 ASSIGN 490 TO IRTN3
  480 CALL READ (*910,*550,IN1,IZ(JRUN+1),NREC,0,IFLAG)
      IF (I .EQ. 1) GO TO 510
      ID1 = IZ(JRUN+1)/10
      GO TO IRTN3, (490,500)
  490 CALL READ (*910,*560,INPT,IZ(M+1),NREC,0,IFLAG)
      ID2 = IZ(M+1) /10
      ASSIGN 500 TO IRTN3
  500 IF (ID1-ID2) 480,510,490
C
C     POINT MATCH
C
  510 CONTINUE
      IF (I .EQ. JRUN) IFOUND = IFOUND +1
      DO 540 K =2,NREC
      ITYPE = NUMTYP(IZ(JRUN+K))
      IF (ITYPE.NE.2 .AND. ITYPE.NE.0) GO TO 540
      IF (I .NE. 1) GO TO 520
      Z(JRUN+K) = (Z(JRUN+K)*Z(1))**2
      GO TO 530
  520 Z(JRUN+K) = Z(JRUN+K) + (Z(M+K)*Z(I))**2
  530 IF (I .NE. JRUN) GO TO 540
      Z(JRUN+K) = SQRT(Z(JRUN+K))
  540 CONTINUE
      CALL WRITE (IO1,IZ(JRUN+1),NREC,0)
      GO TO 470
C
C     END OF DATA ON IN1
C
  550 IF (I .EQ. 1) GO TO 570
      CALL FWDREC (*910,INPT)
      GO TO 570
  560 CALL FWDREC (*910,IN1)
  570 CALL WRITE (IO1,0,0,1)
      GO TO 370
C
C     EOF ON INPT
C
  580 CALL SKPFIL (IN1,1)
  590 CALL EOF (IO1)
      IF (I .NE. JRUN) GO TO 610
      CALL CLOSE (IO1,1)
      MCB(1) = IO1
      MCB(2) = IFOUND
      CALL WRTTRL (MCB)
      GO TO 610
  600 IF (I .EQ. 1) GO TO 590
      CALL SKPFIL (INPT,1)
      GO TO 590
  610 CONTINUE
C
C     SWITCH FILES
C
      IF (I .NE. JRUN) CALL CLOSE (IO1,1)
      IF (I .NE.    1) CALL CLOSE (IN1,1)
      J=IN1
      IN1=IO1
      IO1=J
      IF (I .EQ. 1) IO1 = SCR2
  620 CONTINUE
      CALL CLOSE (INPT,1)
      JRUN = 9999999
      RETURN
C
C     INTERNAL ROUTINE TO COPY FILES
C
  700 CONTINUE
      CALL OPEN (*730,FILE,IZ(IBUF2),0)
  710 IEOR = 1
      CALL READ (*730,*720,FILE,IZ(1),NZ,0,IREAD)
      IEOR = 0
  720 CALL WRITE (INPT,IZ(1),IREAD,IEOR)
      GO TO 710
  730 CALL EOF (INPT)
      CALL CLOSE (FILE,1)
      GO TO IRET, (20,270)
C
C     ERROR MESSAGES
C
  900 IP1 = -1
      GO TO 930
  910 IP1 = -2
      GO TO 930
  920 IP1 = -3
  930 CALL MESAGE (IP1,FILE,NAME)
      STOP
      END

      SUBROUTINE GPWG1C  (B,E,EIG,IFLAG)
C
C     DOUBLE PRECISION VERSION, BY G.CHAN/SPERRY    8/86
C
C     IFLAG=0 MEANS RUN OK
C     IFLAG=1 MEANS NO SOLUTION IN 20 ITERATIONS
C
      DOUBLE PRECISION  E(3,3),EP(3,3),B(3,3),BP(3,3),EIG(3)
      DOUBLE PRECISION  DETB,EPSIL,BMAX,R,S,C,T
C
      DETB = 0.0D0
      DO 5 I = 1,3
      DO 5 J = 1,3
      DETB = DETB+B(I,J)*B(I,J)
    5 CONTINUE
      EPSIL = DSQRT(DETB)*1.0D-5
      IFLAG =0
      II = 1
      DO 10 I=1,3
      DO 10 J=1,3
      E(I,J) = 0.0D0
      IF (I .EQ. J) E(I,J) = 1.0D0
   10 CONTINUE
      IF (DETB .EQ. 0.0D0) GO TO 100
   15 BMAX = DMAX1(DABS(B(1,2)),DABS(B(1,3)),DABS(B(2,3)))
      IF (DABS(BMAX)  .LT. EPSIL) GO TO 100
      IF (BMAX .NE. DABS(B(1,2))) GO TO 20
      I = 1
      J = 2
      K = 3
      GO TO 40
   20 IF (BMAX .NE. DABS(B(1,3))) GO TO 30
      I = 1
      J = 3
      K = 2
      GO TO 40
   30 I = 2
      J = 3
      K = 1
   40 R = (B(J,J)-B(I,I))/B(I,J)
      IF (DABS(R) .LT. 1.0D-6) GO TO 50
      IF (DABS(R) .GT. 1.0D+6) GO TO 60
      T = DSQRT((R*R)/4.0D0+1.0D0)-0.5D0*R
      C = DSQRT(1.0D0+T*T)
      S = T/C
      C = 1.0D0/C
      GO TO 70
   50 S = DSQRT(.5D0)
      C = S
      GO TO 70
   60 S = 0.0D0
      C = 1.0D0
   70 BP(I,I) = B(I,I)*C*C+B(J,J)*S*S-2.0D0*B(I,J)*S*C
      BP(J,J) = B(I,I)*S*S+B(J,J)*C*C+2.0D0*B(I,J)*S*C
      BP(K,K) = B(K,K)
      BP(J,I) = 0.0D0
      BP(I,J) = 0.0D0
      BP(K,I) = B(I,K)*C-B(J,K)*S
      BP(I,K) = BP(K,I)
      BP(K,J) = B(J,K)*C+B(I,K)*S
      BP(J,K) = BP(K,J)
      EP(I,1) = E(I,1)*C-E(J,1)*S
      EP(J,1) = E(I,1)*S+E(J,1)*C
      EP(K,1) = E(K,1)
      EP(I,2) = E(I,2)*C-E(J,2)*S
      EP(J,2) = E(I,2)*S+E(J,2)*C
      EP(K,2) = E(K,2)
      EP(I,3) = E(I,3)*C-E(J,3)*S
      EP(J,3) = E(I,3)*S+E(J,3)*C
      EP(K,3) = E(K,3)
      DO 80  I=1,3
      DO 80  J=1,3
      B(I,J) = BP(I,J)
      E(I,J) = EP(I,J)
   80 CONTINUE
      IF (II .GE. 21) GO TO 90
      II = II+1
      GO TO 15
   90 IFLAG=1
      GO TO 120
  100 DO 110  I=1,3
  110 EIG(I) = B(I,I)
  120 RETURN
      END

      SUBROUTINE INTPRT (A,CR,O,NAME)
C
      INTEGER         O,CR,COLNUM,CRFMT(3),CROPT(2,2)
      REAL            A(1),NAME(2)
      COMMON /SYSTEM/ SKIP,MO
      DATA    CRFMT / 4H(60X , 4H,2A4 , 4H,I5) /
      DATA    CROPT / 4HCOLU , 4HMN   , 4HROW  , 4H     /
C
C     CR   = 0  IF MATRIX BY COLUMNS.
C          = 1  IF MATRIX BY ROWS.
C     IF O = 0, THE MATRIX WILL NOT BE PRINTED.
C     NAME = 8  CHARACTER BCD NAME OF THE MATRIX.
C
      IF (CR .NE. 0) GO TO 100
      ICROPT = 1
      GO TO 110
  100 ICROPT = 2
C
  110 CALL MATPRT (*120,*130,A,-1,COLNUM)
      GO TO 150
  120 WRITE  (MO,125) NAME(1),NAME(2)
  125 FORMAT (50X,24HINTERMEDIATE MATRIX ... ,2A4//)
  130 WRITE  (MO,CRFMT) (CROPT(I,ICROPT),I=1,2),COLNUM
      CALL PRTMAT (*120,*130,COLNUM)
  150 RETURN
C
      END

      SUBROUTINE INTLST (LIST,N,SIGN,N1,N2)
C
      INTEGER LIST(1),SIGN,TO,THRU
      DATA    TO,THRU/ 2HTO,4HTHRU /
C
      SIGN = ISIGN(1,LIST(N))
      N1 = IABS(LIST(N))
      IF (LIST(N+1).EQ.TO .OR. LIST(N+1).EQ.THRU) GO TO 110
      N2 = N1
      N  = N + 1
      GO TO 150
C
  110 N2 = IABS(LIST(N+2))
      N  = N + 3
      IF (N1 .LE. N2) GO TO 150
      I  = N1
      N1 = N2
      N2 = I
C
  150 RETURN
      END

      SUBROUTINE AMPB2(A,A11,A12,A21,A22,RP,CP,N1,N2)
C
C     THIS SUBROUTINE IS A GENERAL DRIVER FOR PARTN
C
      INTEGER A11,A12,A21,A22,A,RP,CP,RULE,MCB(20),MCB1(20)
C
      COMMON /PARMEG/MCBA(7),MCBA11(7),MCBA21(7),MCBA12(7),MCBA22(7),
     1 NX,RULE
      COMMON /ZZZZZZ/ IZ(1)
C
C-----------------------------------------------------------------------
C
      MCB(1)=RP
      CALL RDTRL(MCB)
      MCB1(1)=CP
      CALL RDTRL(MCB1)
      NX=KORSZ(IZ)
      RULE=0
      MCBA11(1)=A11
      IF(A11.EQ.0)GO TO 10
      CALL RDTRL(MCBA11)
      IF(MCBA11(1).LE.0)MCBA11(1)=0
   10 CONTINUE
      MCBA21(1)=A21
      IF(A21.LE.0)GO TO 20
      CALL RDTRL(MCBA21)
      IF(MCBA21(1).LE.0)MCBA21(1)=0
   20 CONTINUE
      MCBA12(1)=A12
      IF(A12.EQ.0)GO TO 30
      CALL RDTRL(MCBA12)
      IF(MCBA12(1).LE.0)MCBA12(1)=0
   30 CONTINUE
      MCBA22(1)=A22
      IF(A22.EQ.0)GO TO 40
      CALL RDTRL(MCBA22)
      IF(MCBA22(1).LE.0)MCBA22(1)=0
   40 CONTINUE
      MCBA(1)=A
      CALL RDTRL(MCBA)
      MCBA11(2) = MCBA(2) - MCB(6)
      MCBA11(3) = MCBA(3) -MCB1(6)
      MCBA12(2) = MCBA(2) -MCBA11(2)
      MCBA12(3) = MCBA11(3)
      MCBA21(2) = MCBA11(2)
      MCBA21(3) = MCBA(3) -MCBA11(3)
      MCBA22(2) = MCB(6)
      MCBA22(3) = MCB1(6)
      MCBA11(4)=2
      MCBA21(4)=2
      MCBA12(4)=2
      MCBA22(4)=2
      MCBA11(5)=MCBA(5)
      MCBA21(5)=MCBA(5)
      MCBA12(5)=MCBA(5)
      MCBA22(5)=MCBA(5)
      CALL PARTN(MCB,MCB1,IZ)
      IF(MCBA11(1).GT.0)CALL WRTTRL(MCBA11)
      IF(MCBA21(1).GT.0)CALL WRTTRL(MCBA21)
      IF(MCBA12(1).GT.0)CALL WRTTRL(MCBA12)
      IF(MCBA22(1).GT.0)CALL WRTTRL(MCBA22)
      RETURN
      END

        SUBROUTINE GETURN ( NAMFIL )
      INCLUDE 'DSIOF.COM'
        COMMON / XFIST  / IFSTMX, IFSTCA, IFIST( 100 )
        COMMON / XFIAT  / IFATUF, IFATMX, IFATCA, IFIAT( 640 )
        COMMON / XXFIAT / IXFIAT( 19 )
        INTEGER*2         IUNIT
        COMMON / DSUNIT / IUNIT( 220 )
        DATA  MASK / '00007FFF'X /
        IF ( NAMFIL .EQ. LASNAM .AND. IFILEX .NE. 0 ) GO TO 20
        IFILEX = 0
        LIM = 2 * IFSTCA - 1
        DO 15 IFST = 1, LIM, 2
        IF ( NAMFIL .NE. IFIST( IFST ) ) GO TO 15
        IF ( NAMFIL .GE. 101 .AND. NAMFIL .LE. 320 ) GO TO 10
        IF ( IFIST( IFST + 1 ) .GT. 0 ) GO TO 5
        IFILEX = IXFIAT( IABS( IFIST( IFST+1 ) ) + 1 )
        IF (IFILEX .LE. MAXPRI) GO TO 20
   2    IFILEX = 0
        GO TO 200
   5    IFILEX = IAND( IFIAT( IFIST( IFST+1 ) - 2 ), MASK )
        GO TO 20
   10   IFILEX = IAND( IFIAT( IFIST( IFST+1 ) - 2 ), MASK )
        IF (IFILEX .GT. MAXPRI) GO TO 2
        IUNIT( NAMFIL-100 ) = IFILEX
        GO TO 20
   15   CONTINUE
        GO TO 200
   20   IPRVOP = FCB( 1, IFILEX )
        IF ( IPRVOP .EQ. 2 ) IPRVOP = 0
        NLR    = FCB( 3, IFILEX )
        NBLOCK = FCB( 4, IFILEX )
        LASNAM = NAMFIL
  200   CONTINUE
        RETURN
        END

      SUBROUTINE MRED2H
C
C     THIS SUBROUTINE CREATES THE REDUCED SUBSTRUCTURE NEW TABLE ITEMS
C     FOR THE MRED2 MODULE.
C
C     INPUT DATA
C     GINO  - EQST   - TEMPORARY SUBSTRUCTURE EQUIVALENCE TABLE FOR
C                      SUBSTRUCTURE BEING REDUCED
C
C     OUTPUT DATA
C     SOF   - EQSS   - SUBSTRUCTURE EQUIVALENCE TABLE FOR REDUCED
C                      SUBSTRUCTURE
C             BGSS   - BASIC GRID POINT DEFINITION TABLE FOR REDUCED
C                      SUBSTRUCTURE
C             LODS   - LOAD SET DATA FOR REDUCED SUBSTRUCTURE
C             LOAP   - APPENDED LOAD SET DATA FOR REDUCED SUBSTRUCTURE
C             PLTS   - PLOT SET DATA FOR REDUCED SUBSTRUCTURE
C             CSTM   - COORDINATE SYSTEM TRANSFORMATION DATA FOR REDUCED
C                      SUBSTRUCTURE
C
C     PARAMETERS
C     INPUT - DRY    - MODULE OPERATION FLAG
C             POPT   - LOAD OPTION FLAG
C             GBUF1  - GINO BUFFER
C             INFILE - INPUT FILE NUMBERS
C             KORLEN - LENGTH OF OPEN CORE
C             KORBGN - BEGINNING ADDRESS OF OPEN CORE
C             OLDNAM - NAME OF SUBSTRUCTURE BEING REDUCED
C             NEWNAM - NAME OF REDUCED SUBSTRUCTURE
C             FREBDY - FREEBODY OPR
C             FREBDY - FREEBODY OPTIONS FLAG
C             IO     - OUTPUT OPTIONS FLAG
C             MODPTS - NUMBER OF MODAL POINTS
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        RSHIFT,ANDF
      LOGICAL         FREBDY,PONLY
      REAL            ZERO,RZ(1)
      DIMENSION       MODNAM(2),LSTBIT(32),ITRLR(7),ITMLST(3),ITMNAM(2)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /BLANK / IDUM1,DRY,POPT,GBUF1,IDUM2(5),INFILE(12),
     1                IDUM3(16),KORLEN,KORBGN,OLDNAM(2),NEWNAM(2),
     2                FREBDY,IDUM4(3),USRMOD,IO,IDUM6(4),MODPTS,IDUM9,
     3                PONLY
      COMMON /ZZZZZZ/ Z(1)
      COMMON /SYSTEM/ IDUM5,IPRNTR,IDUM7(6),NLPP,IDUM8(2),LINE
      EQUIVALENCE     (EQST,INFILE(4)), (RZ(1),Z(1))
      DATA    MODNAM/ 4HMRED,4H2H  /
      DATA    PAPP  , LODS,LOAP    /4HPAPP,4HLODS,4HLOAP/
      DATA    FARIND, IZERO,ZERO   /6,0,0.0/
      DATA    ITMLST/ 4HEQSS,4HBGSS,4HLAMS /
      DATA    SOFEOG/ 4H$EOG       /
C
C     CHECK FOR LOADS PROCESSING ONLY
C
      IF (PONLY) GO TO 55
C
C     PROCESS EQSS, BGSS DATA
C
      IF (DRY .EQ. -2) GO TO 300
      ITRLR(1) = EQST
      CALL RDTRL (ITRLR)
      ITMNAM(1) = NEWNAM(1)
      ITMNAM(2) = NEWNAM(2)
      IFILE = EQST
      IF (ITRLR(1) .LT. 0) GO TO 210
      CALL GOPEN (EQST,Z(GBUF1),0)
      ITEST = 3
      ITEM  = ITMLST(1)
      CALL SFETCH (NEWNAM,4HEQSS,2,ITEST)
      IF (ITEST .NE. 3) GO TO 250
      NEWPTS = MODPTS
      IF (FREBDY) NEWPTS = NEWPTS + FARIND
C
C     PROCESS EQSS GROUP 0 DATA
C
      IF (KORBGN+ITRLR(2)+2 .GE. KORLEN) GO TO 230
      CALL READ (*215,*220,EQST,Z(KORBGN),ITRLR(2),1,NWDSRD)
      NCSUBS = Z(KORBGN+2)
      Z(KORBGN+2) = Z(KORBGN+2) + 1
      Z(KORBGN+3) = Z(KORBGN+3) + NEWPTS
      NEWCS = ITRLR(2)
      Z(KORBGN+NEWCS  ) = NEWNAM(1)
      Z(KORBGN+NEWCS+1) = NEWNAM(2)
      NEWCS = ITRLR(2) + 2
      CALL SUWRT (Z(KORBGN),NEWCS,2)
C
C     PROCESS REMAINING EQSS GROUPS
C
      NWDS = KORLEN - KORBGN
      DO 20 I = 1,NCSUBS
      CALL READ (*215,*10,EQST,Z(KORBGN),NWDS,1,NWDSRD)
      GO TO 230
   10 IF (KORBGN+1+NWDSRD .GE. KORLEN) GO TO 230
   20 CALL SUWRT (Z(KORBGN),NWDSRD,2)
C
C     PROCESS MODAL AND FREE-BODY POINTS
C
      IF (KORBGN+3*NEWPTS .GE. KORLEN) GO TO 230
      DO 30 I = 1,NEWPTS
      KORE = 3*(I-1)
      IF (.NOT.FREBDY) GO TO 24
      IF (I .GT. FARIND) GO TO 22
      Z(KORBGN+KORE) = I
      GO TO 26
   22 Z(KORBGN+KORE) = 100 + I - FARIND
      GO TO 26
   24 Z(KORBGN+KORE  ) = 100 + I
   26 Z(KORBGN+KORE+1) = ITRLR(4)/2 + I
   30 Z(KORBGN+KORE+2) = 1
      NWDSRD = 3*NEWPTS
      CALL SUWRT (Z(KORBGN),NWDSRD,2)
C
C     PROCESS EQSS SIL DATA
C
      IF (KORBGN+ITRLR(4)+2*NEWPTS .GE. KORLEN) GO TO 230
      CALL READ (*215,*220,EQST,Z(KORBGN),ITRLR(4),1,NWDSRD)
      NWDSRD = ITRLR(4) - 1
      ICODE  = Z(KORBGN+NWDSRD)
      CALL DECODE (ICODE,LSTBIT,NWDSD)
      LSTSIL = Z(KORBGN+NWDSRD-1) + NWDSD - 1
      DO 40 I = 1,NEWPTS
      KORE = ITRLR(4) + 2*(I-1)
      Z(KORBGN+KORE  ) = LSTSIL + I
   40 Z(KORBGN+KORE+1) = 1
      NWDSRD = ITRLR(4) + 2*NEWPTS
      CALL SUWRT (Z(KORBGN),NWDSRD,2)
      CALL SUWRT (Z(KORBGN),0,3)
C
C     PROCESS BGSS DATA
C
      IF (KORBGN+ITRLR(5)+4*NEWPTS .GE. KORLEN) GO TO 230
      ITEM  = ITMLST(2)
      ITEST = 3
      CALL SFETCH (NEWNAM,4HBGSS,2,ITEST)
      IF (ITEST .NE. 3) GO TO 250
      CALL READ (*215,*220,EQST,Z(KORBGN),3,1,NWDSRD)
      Z(KORBGN  ) = NEWNAM(1)
      Z(KORBGN+1) = NEWNAM(2)
      Z(KORBGN+2) = Z(KORBGN+2) + NEWPTS
      LOCBGS = KORBGN
      CALL SUWRT (Z(KORBGN),3,2)
      CALL READ (*215,*220,EQST,Z(KORBGN),ITRLR(5),1,NWDSRD)
      DO 50 I = 1,NEWPTS
      KORE = ITRLR(5) + 4*(I-1)
      Z(KORBGN+KORE   ) = -1
      RZ(KORBGN+KORE+1) = 0.0
      RZ(KORBGN+KORE+2) = 0.0
   50 RZ(KORBGN+KORE+3) = 0.0
      NWDSRD = ITRLR(5) + 4*NEWPTS
      CALL SUWRT (Z(KORBGN),NWDSRD,2)
      CALL SUWRT (Z(KORBGN),0,3)
      KORBGN = KORBGN + ITRLR(5)
C
C     PROCESS LODS, LOAP ITEM
C
   55 ITEM = LODS
      IF (POPT .EQ. PAPP) ITEM = LOAP
      ITEST = 3
      CALL SFETCH (OLDNAM,ITEM,1,ITEST)
      IF (ITEST .EQ. 3) GO TO 60
      CALL SUREAD (Z(KORBGN),-1,NWDSRD,ITEST)
      IF ((KORBGN + NWDSRD) .GE. KORLEN) GO TO 230
      Z(KORBGN  ) = NEWNAM(1)
      Z(KORBGN+1) = NEWNAM(2)
      Z(KORBGN+3) = Z(KORBGN+3) + 1
      Z(KORBGN+NWDSRD  ) = NEWNAM(1)
      Z(KORBGN+NWDSRD+1) = NEWNAM(2)
      Z(KORBGN+NWDSRD+2) = SOFEOG
      IWDS  = NWDSRD + 3
      CALL SUREAD (Z(KORBGN+IWDS),-2,NWDSRD,ITEST)
      IF (KORBGN+IWDS+NWDSRD+2 .GE. KORLEN) GO TO 230
      Z(KORBGN+IWDS+NWDSRD  ) = 0
      Z(KORBGN+IWDS+NWDSRD+1) = SOFEOG
      IWDS  = IWDS + NWDSRD + 2
      ITEST = 3
      CALL SFETCH (NEWNAM,ITEM,2,ITEST)
      IF (ITEST .NE. 3) GO TO 250
      CALL SUWRT (Z(KORBGN),IWDS,3)
      IF (PONLY) GO TO 130
C
C     PROCESS PLTS ITEM
C
   60 CALL SFETCH (OLDNAM,4HPLTS,1,ITEST)
      IF (ITEST .EQ. 3) GO TO 70
      CALL SUREAD (Z(KORBGN),-1,NWDSRD,ITEST)
      Z(KORBGN  ) = NEWNAM(1)
      Z(KORBGN+1) = NEWNAM(2)
      ITEST = 3
      CALL SFETCH (NEWNAM,4HPLTS,2,ITEST)
      IF (ITEST .NE. 3) GO TO 250
      ITEST = 2
      CALL SUWRT (Z(KORBGN),NWDSRD,ITEST)
      ITEST = 3
      CALL SUWRT (Z(KORBGN),0,ITEST)
C
C     PROCESS CSTM ITEM
C
   70 CALL SFETCH (OLDNAM,4HCSTM,1,ITEST)
      IF (ITEST .EQ. 3) GO TO 130
      CALL SUREAD (Z(KORBGN),-2,NWDSRD,ITEST)
      IF (KORBGN+2*NWDSRD .GE. KORLEN) GO TO 230
      Z(KORBGN  ) = NEWNAM(1)
      Z(KORBGN+1) = NEWNAM(2)
      KORE = NWDSRD - 4
      CALL SORT(0,0,14,1,Z(KORBGN+3),KORE)
      KORE = KORE/14
      IF (KORBGN+2*NWDSRD+KORE .GE. KORLEN) GO TO 230
      DO 80 I = 1, KORE
   80 Z(KORBGN+NWDSRD+I-1) = 0
      NBGSS = ITRLR(5)/4
      DO 100 I = 1, NBGSS
      K = 4*(I-1)
      IF (Z(LOCBGS+K) .LE. 0) GO TO 100
      DO 90 J = 1,KORE
      LOC = 14*(J-1)
      IF (Z(KORBGN+3+LOC) .NE. Z(LOCBGS+K)) GO TO 90
      Z(KORBGN+NWDSRD+J-1) = 1
      GO TO 100
   90 CONTINUE
  100 CONTINUE
      LOCNEW = 0
      DO 120 I = 1,KORE
      IF (Z(KORBGN+NWDSRD+I-1) .EQ. 0) GO TO 120
      LOCOLD = 14*(I-1)
      DO 110 J = 1,14
  110 Z(KORBGN+NWDSRD+KORE+LOCNEW+J-1) = Z(KORBGN+3+LOCOLD+J-1)
      LOCNEW = LOCNEW + 14
  120 CONTINUE
      IF (LOCNEW .EQ. 0) GO TO 130
      ITEST = 3
      CALL SFETCH (NEWNAM,4HCSTM,2,ITEST)
      CALL SUWRT (NEWNAM,2,2)
      CALL SUWRT (Z(KORBGN+NWDSRD+KORE),LOCNEW,2)
      CALL SUWRT (Z(KORBGN),0,3)
C
C     OUTPUT EQSS ITEM
C
  130 CALL CLOSE (EQST,1)
      IF (ANDF(RSHIFT(IO,4),1) .NE. 1) GO TO 150
      CALL SFETCH (NEWNAM,4HEQSS,1,ITEST)
      IF (ITEST .NE. 1) GO TO 250
      CALL SUREAD (Z(KORBGN), 4,NWDSRD,ITEST)
      CALL SUREAD (Z(KORBGN),-1,NWDSRD,ITEST)
      LOC = KORBGN + NWDSRD
      NCSUBS = NCSUBS + 1
      DO 140 I = 1, NCSUBS
      CALL SUREAD (Z(LOC),-1,NWDSRD,ITEST)
      NAMLOC = KORBGN + 2*(I-1)
      CALL CMIWRT (1,NEWNAM,Z(NAMLOC),LOC,NWDSRD,Z,Z)
  140 CONTINUE
      CALL SUREAD (Z(LOC),-1,NWDSRD,ITEST)
      IF ((LOC + NWDSRD) .GE. KORLEN) GO TO 230
      CALL CMIWRT (8,NEWNAM,0,LOC,NWDSRD,Z,Z)
C
C     OUTPUT BGSS ITEM
C
  150 IF (ANDF(RSHIFT(IO,5),1) .NE. 1) GO TO 160
      CALL SFETCH (NEWNAM,4HBGSS,1,ITEST)
      IF (ITEST .NE. 1) GO TO 250
      NGRP = 1
      CALL SJUMP (NGRP)
      CALL SUREAD (Z(KORBGN),-1,NWDSRD,ITEST)
      CALL CMIWRT (2,NEWNAM,NEWNAM,KORBGN,NWDSRD,Z,Z)
C
C     OUTPUT CSTM ITEM
C
  160 IF (ANDF(RSHIFT(IO,6),1) .NE. 1) GO TO 170
      CALL SFETCH (NEWNAM,4HCSTM,1,ITEST)
      IF (ITEST .EQ. 3) GO TO 170
      NGRP = 1
      CALL SJUMP (NGRP)
      CALL SUREAD (Z(KORBGN),-1,NWDSRD,ITEST)
      CALL CMIWRT (3,NEWNAM,NEWNAM,KORBGN,NWDSRD,Z,Z)
C
C     OUTPUT PLTS ITEM
C
  170 IF (ANDF(RSHIFT(IO,7),1) .NE. 1) GO TO 180
      CALL SFETCH (NEWNAM,4HPLTS,1,ITEST)
      IF (ITEST .EQ. 3) GO TO 180
      CALL SUREAD (Z(KORBGN), 3,NWDSRD,ITEST)
      CALL SUREAD (Z(KORBGN),-1,NWDSRD,ITEST)
      CALL CMIWRT (4,NEWNAM,NEWNAM,KORBGN,NWDSRD,Z,Z)
C
C     OUTPUT LODS ITEM
C
  180 IF (ANDF(RSHIFT(IO,8),1) .NE. 1) GO TO 200
      CALL SFETCH (NEWNAM,ITEM,1,ITEST)
      IF (ITEST .EQ. 3) GO TO 200
      CALL SUREAD (Z(KORBGN), 4,NWDSRD,ITEST)
      CALL SUREAD (Z(KORBGN),-1,NWDSRD,ITEST)
      LOC = KORBGN + NWDSRD
      ITYPE = 5
      IF (ITEM .EQ. LOAP) ITYPE = 7
      DO 190 I = 1,NCSUBS
      NAMLOC = KORBGN + 2*(I-1)
      CALL SUREAD (Z(LOC),-1,NWDSRD,ITEST)
      CALL CMIWRT (ITYPE,NEWNAM,Z(NAMLOC),LOC,NWDSRD,Z,Z)
      ITYPE = 6
  190 CONTINUE
C
C     OUTPUT MODAL DOF SUMMARY
C
  200 IF (ANDF(RSHIFT(IO,9),1) .NE. 1) GO TO 209
      ITEM = ITMLST(3)
      ITMNAM(1) = OLDNAM(1)
      ITMNAM(2) = OLDNAM(2)
      CALL SFETCH (OLDNAM,ITEM,1,ITEST)
      IF (ITEST .NE. 1) GO TO 250
      CALL SUREAD (Z(KORBGN),-1,NWDSRD,ITEST)
      CALL PAGE1
      WRITE (IPRNTR,901) NEWNAM
      LINE = LINE + 11
      NOFREQ = Z(KORBGN+3)
      LAMLOC = KORBGN
      MODUSE = LAMLOC + 7*NOFREQ + 1
      CALL SUREAD (Z(KORBGN),-2,NWDSRD,ITEST)
      IF ((KORBGN + NWDSRD) .GE. KORLEN) GO TO 230
      IF (USRMOD .GT. 1) GO TO 205
      ITEM = ITMLST(1)
      ITMNAM(1) = NEWNAM(1)
      ITMNAM(2) = NEWNAM(2)
      CALL SFETCH (NEWNAM,ITEM,1,ITEST)
      IF (ITEST .NE. 1) GO TO 250
      KORBGN = KORBGN + MODUSE + NOFREQ
      IF (KORBGN .GE. KORLEN) GO TO 230
      CALL SUREAD (Z(KORBGN),-1,NWDSRD,ITEST)
      DO 201 I = 1,NCSUBS
      CALL SUREAD (Z(KORBGN),-1,NWDSRD,ITEST)
      IF (KORBGN+NWDSRD .GE. KORLEN) GO TO 230
  201 CONTINUE
      IPRB = 0
      IF (FREBDY) IPRB = Z(KORBGN+1) - 1
      NWDSRD = NWDSRD/3
      LOCEQS = KORBGN
      DO 202 I = 1,NWDSRD
      J = 1 + 3*(I-1)
      IPID = Z(LOCEQS+J)
      IF (Z(LOCEQS+J-1) .GT. 100) GO TO 203
  202 CONTINUE
  203 KORBGN = KORBGN + 3*NWDSRD
      IPID = 2*IPID
      IF (KORBGN+IPID .GE. KORLEN) GO TO 230
      CALL SUREAD (Z(KORBGN),IPID,NWDSRD,ITEST)
      IPS = Z(KORBGN+IPID-2)
      IF (.NOT. FREBDY) GO TO 205
      DO 204 I = 1,FARIND
      J = 3*(I-1)
      K = 2*((I-1) + IPRB)
  204 WRITE (IPRNTR,902) IZERO,ZERO,IZERO,Z(LOCEQS+J),Z(KORBGN+K)
  205 INDEX1 = -3
      IF (FREBDY) INDEX1 = 3*FARIND - 3
      DO 208 I = 1,NOFREQ
      IF (LINE .LE. NLPP) GO TO 206
      CALL PAGE1
      WRITE (IPRNTR,901) NEWNAM
      LINE = LINE + 11
  206 IF ((Z(MODUSE+I-1) .GT. 1) .OR. (USRMOD .GT. 1)) GO TO 207
      INDEX1 = INDEX1 + 3
      MODE = 7*(I-1)
      WRITE (IPRNTR,902) Z(LAMLOC+MODE),RZ(LAMLOC+MODE+4),Z(MODUSE+I-1),
     1       Z(LOCEQS+INDEX1),IPS
      IPS = IPS + 1
      GO TO 208
  207 MODE = 7*(I-1)
      WRITE (IPRNTR,902) Z(LAMLOC+MODE),RZ(LAMLOC+MODE+4),Z(MODUSE+I-1)
  208 LINE = LINE + 1
  209 CONTINUE
      GO TO 300
C
C     PROCESS SYSTEM FATAL ERRORS
C
  210 IMSG = -1
      GO TO 240
  215 IMSG = -2
      GO TO 240
  220 IMSG = -3
      GO TO 240
  230 IMSG = -8
      IFILE = 0
  240 CALL SOFCLS
      CALL MESAGE (IMSG,IFILE,MODNAM)
      GO TO 300
C
C     PROCESS MODULE FATAL ERRORS
C
  250 GO TO (260,260,260,270,280,280), ITEST
  260 CALL SMSG1 (-9,ITEM,ITMNAM,MODNAM)
      DRY = -2
      GO TO 300
  270 IMSG = -2
      GO TO 290
  280 IMSG = -3
  290 CALL SMSG (IMSG,ITEM,ITMNAM)
  300 RETURN
C
  901 FORMAT (1H0,36X,43HMODAL DOF SUMMARY FOR REDUCED SUBSTRUCTURE ,
     1       2A4, //30X,36HUSAGE CODES ARE 0 - RIGID BODY POINT, /46X,
     2       25H1 - INCLUDED IN MODAL SET, /46X,20H2 - EXCLUDED FROM MO,
     3       36HDAL SET BECAUSE OF NON-PARTICIPATION,/46X,10H3 - EXCLUD,
     4       42HED FROM MODAL SET BECAUSE OF RANGE OR NMAX,//40X,4HMODE,
     5       22X,15HUSAGE      GRID, /39X,6HNUMBER,8X,6HCYCLES,8X,
     6       26HCODE    POINT ID       SIL,/)
  902 FORMAT (39X,I5,5X,1P,E13.6,6X,I1,6X,I8,4X,I6)
C
      END

      SUBROUTINE  CSUMM(D1,D2,ID1,D3,D4,ID2,D5,D6,ID5)
C
C     ADDS  D1+D2 TO  D3+D4 SCALING OUTPUT
C
      DOUBLE PRECISION D1,D2,D3,D4,D5,D6,T1,T2,T3,T4
      MULT = IABS(ID1-ID2)
      IF(MULT .LE. 38) FACTOR = 10.0**MULT
      T1 =D1
      T2 =D2
      T3 =D3
      T4 =D4
      ID5 =ID1
      IF(ID1-ID2) 30,50,20
   30 IF(MULT .GT. 38) GO TO 40
      T3 =T3*FACTOR
      T4 =T4*FACTOR
      GO TO 50
   20 IF(MULT .GT. 38) GO TO 35
      T1 = T1*FACTOR
      T2 = T2*FACTOR
      ID5= ID2
      GO TO 50
   35 D5 = D3
      D6 =D4
      ID5 = ID2
      GO TO 70
   40 D5 = D1
      D6 = D2
      GO TO 70
   50 D5 = T1 +T3
      D6 = T2 + T4
   70 RETURN
      ENTRY CSQRTN(D1,D2,ID1,D3,D4,ID2)
C
C     COMPUTES COMPLEX SQRT = SCALED
C
      ID2 = ID1
      D3=D1
      D4= D2
      IF( MOD(ID1,2) .EQ. 0) GO TO 100
      ID2 = ID2 -1
      IF(ID2 .LT. 0) GO TO 105
  101 D3 = D3*10.0
      D4 =D4*10.0
  100 ID2 = ID2/2
      T1 =DSQRT(D3*D3 +D4*D4)
      T2 = DSQRT( DABS(D3+T1)/2.0)
      T3 = DSQRT(DABS(-D3+T1)/2.0)
      D3 =T2
      D4 = T3
      IF(D2 .EQ. 0.0D0) GO TO 70
      D4 =DSIGN(T3,D2)
      GO TO 70
C
C     NEGATIVE EXPONENT
C
  105 ID2 = ID2+1
      GO TO 101
C
C     SCALES DETERMINANT
C
      ENTRY CDETM3(D1,D2,ID1)
      T1 = DMAX1(DABS(D1),DABS(D2))
      IF(T1 .EQ. 0.0D0) GO TO 70
 4125 IF(T1 .GT. 10.0D0) GO TO 4153
 4126 IF(T1 .LT. 1.0D0) GO TO 4140
      GO TO 70
 4153 D1 = D1*0.1D0
      D2 = D2*0.1D0
      T1 = T1*0.1D0
      ID1 = ID1+1
      GO TO 4125
 4140 D1 = D1*10.0D0
      D2 = D2*10.0D0
      T1 = T1*10.0D0
      ID1 = ID1-1
      GO TO 4126
      END

      SUBROUTINE APD4
C
      EXTERNAL        ORF
      INTEGER         NAM(2),IZ(1),BACK,PSPA,IC(16),EID,PID,CIDBX,SILB,
     1                SCR1,ECTA,BGPA,GPLA,USETA,SILA,ACPT,BUF10,CA4S,
     2                CA4E,PA4S,PA4E,AUSET(6,2),SILC,ORF,USA,UK,EIDB,
     3                SILDX(4),ACSIX(4),CID(5),NECTA(2)
      REAL            VX1(3),VX2(3),ACPL(3,3),RB1(3)
      DIMENSION       AI(6),HEAD(9),IHEAD(9)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /BLANK / NK,NJ,LUSETA
      COMMON /APD1C / EID,PID,CP,NSPAN,NCHORD,LSPAN,LCHORD,IGID,
     1                X1,Y1,Z1,X12,X4,Y4,Z4,X43,XOP,X1P,ALZO,MCSTM,
     2                NCST1,NCST2,CIDBX,ACSID,IACS,SILB,NCRD,SCR1,
     3                SCR2,SCR3,SCR4,SCR5,ECTA,BGPA,GPLA,USETA,SILA,
     4                CSTMA,ACPT,BUF10,BUF11,BUF12,NEXT,LEFT,ISILN,
     5                NCAM,NAEF1,NAEF2,
     6                NCA1,NCA2,CA2S,CA2E,CA3S,CA3E,CA4S,CA4E,
     7                NPA1,NPA2,PA2S,PA2E,PA3S,PA3E,PA4S,PA4E
      COMMON /APD1D / ICPL(14),YP4,S1,C1,XP2,XP3,XP4,RA1(3)
      COMMON /ZZZZZZ/ Z(1)
      COMMON /BITPOS/ IBIT(64)
      COMMON /TWO   / ITWO(32)
      COMMON /SYSTEM/ SYSBUF,NOT
      EQUIVALENCE     (ICPL(3),RB1(1)),(ICPL(6),ACPL(1,1)),
     1                (NECTA(1),EIDB),(NECTA(2),CID(1)),
     2                (ACSIX(2),VX2(1)),(Z(1),IZ(1)),(EID,IC(1)),
     3                (SILDX(1),ICID),(SILDX(3),SILC),
     4                (AI(1),DY),(AI(2),BLOC),(AI(3),D),(AI(4),CA),
     5                (AI(5),GAP),(AI(6),NSIZE),(HEAD(1),IHEAD(1))
      DATA     NAM  / 4HAPD4,4H    /
C
      LCA  = 16
      NC4  = ((CA4E-CA4S)+1)/LCA
      NCAM = NCAM + NC4
C
C     INITIAL SETUP
C
      I17 = IBIT(17)
      I18 = IBIT(18)
      I19 = IBIT(19)
      I20 = IBIT(20)
      PSPA= ORF(ITWO(I17),ITWO(I20))
      USA = ORF(PSPA,ITWO(I18))
      UK  = ORF(ITWO(I19),ITWO(I20))
      DO 5 J = 1,2
      DO 5 I = 1,6
    5 AUSET(I,J) = USA
      AUSET(3,2) = UK
      AUSET(5,2) = UK
      IHEAD(1) = 4
      SILC = SILB
C
C     LOOP ON NC4 MOVING CAERO4 CARD TO COMMON
C
      DO 400 I = 1,NC4
      NTOT = 0
      N = (I-1)*LCA - 1
      DO 10 J = 1,LCA
      IC(J) = IZ(CA4S+N+J)
   10 CONTINUE
      MCSTM = MCSTM + 1
      IZ(CA4S+N+2) = MCSTM
      IZ(CA4S+N+8) = 4
      ACSIX(1) = MCSTM
C
C     FIND PAERO4 CARD
C
      CALL APDOE (PID,IZ,PA4S,PA4E,IPID,NPC)
      IF (IPID .EQ. 0) GO TO 999
C
C     FIND NUMBER OF STRIPS
C
      ISPAN = NSPAN
      IAST  = 0
      IF (NSPAN .NE. 0) GO TO 20
      CALL APDOE (NCHORD,IZ,NAEF1,NAEF2,IAST,NSPAN)
      IF (IAST .EQ. 0) GO TO 998
      NSPAN = NSPAN - 1
      IAST  = IAST + 1
   20 IZ(CA4S+N+4) = NSPAN
      IZ(CA4S+N+5) = 1
      IPP = IPID + 5
      NPC = NPC - 4
      NPC = NPC/3
      IF (NPC .LT. NSPAN ) GO TO 997
      IHEAD(8) = NSPAN
C
C     GET POINTS IN PROPER COORD SYSTEM
C
      CALL APDCS
      HEAD(9) = 1.0/SQRT(1.0+((XP4+.25*(X43-X12))/YP4)**2)
      IF (NEXT+6*NSPAN .GT. LEFT) GO TO 996
      IOC = NEXT
C
C     GENERATE DATA FOR BOXES
C
      NCRDP = NCRD
      FSJ1  = APDF(Z(IAST),1,ISPAN)
      YJ1   = FSJ1*YP4
      DJ1   = FSJ1*XP4
      CJ1   = X12 + FSJ1*(X43-X12)
      XIJ1  = DJ1
      XI1J1 = DJ1 + CJ1
      EIDB  = EID - 1
      DO 100 J = 1,NSPAN
      YJ    = YJ1
      FSJ1  = APDF(Z( IAST),J+1,ISPAN)
      YJ1   = FSJ1*YP4
      DJ1   = FSJ1*XP4
      CJ1   = X12 + FSJ1*(X43-X12)
      DY    = (YJ1 - YJ)
      YA    = .5*DY + YJ
      YSP   = YA
      CLOC  = X12 - (X12-X43)*YA/YP4
      BLOC  = CLOC*.5
      DOC   = Z(IPP)
      CAOC  = Z(IPP+1)
      GAPOC = Z(IPP+2)
      IPP   = IPP + 3
      D     = DOC*CLOC
      CA    = CAOC*CLOC
      GAP   = GAPOC*CLOC
      NSIZE = 2
      IF (CAOC .NE. 0.0) NSIZE = 3
      NJ    = NJ + NSIZE
      NK    = NK + NSIZE
      NTOT  = NTOT + NSIZE
      KK    = 0
      DO 40 K = 1,6
      Z(IOC+J+KK) =  AI(K)
      KK = KK + NSPAN
   40 CONTINUE
C
C     EXTERNAL ID S
C
      EIDB   = EIDB + 1
      CID(1) = CIDBX + 1 + 2*(J-1)
      CID(2) = CID(1) + 1
      CID(3) = CID(1) + 2
      CID(4) = CID(3) + 1
      CID(5) = EIDB
      NCID   = CID(4)
C
C     BGPDT , SPL, AND USET
C
      XIJ    = XIJ1
      XI1J   = XI1J1
      XIJ1   = DJ1
      XI1J1  = DJ1 + CJ1
      XIC    = (XIJ+XIJ1+BLOC)*.5
      VX1(3) = 0
      IF (J .NE. 1) GO TO 310
      ASSIGN 300 TO BACK
      ICID   = CID(1)
      VX1(1) = XIJ
      VX1(2) = YJ
      KK     = 1
      GO TO 340
  300 ASSIGN 310 TO BACK
      ICID   = CID(2)
      VX1(1) = XI1J
      VX1(2) = YJ
      KK     = 1
      GO TO 340
  310  ASSIGN 320 TO BACK
      ICID   = CID(3)
      VX1(1) = XIJ1
      VX1(2) = YJ1
      KK     = 1
      GO TO 340
  320 ASSIGN 330 TO BACK
      ICID   = CID(4)
      VX1(1) = XI1J1
      VX1(2) = YJ1
      KK     = 1
      GO TO 340
  330 ASSIGN 360 TO BACK
      ICID   = CID(5)
      VX1(1) = XIC
      IF (NSIZE .EQ. 3) AUSET(6,2) = UK
      VX1(2) = YSP
      KK     = 2
  340 CALL GMMATS (ACPL,3,3,0,VX1,3,1,0,VX2)
      DO 350 K = 1,3
  350 VX2(K) = VX2(K) + RB1(K)
      CALL WRITE (BGPA,ACSIX,4,0)
      CALL WRITE (GPLA,ICID,1,0)
      CALL WRITE (USETA,AUSET(1,KK),6,0)
C
C     SIL AND EQEXIN
C
      NCRD   = NCRD + 1
      SILC   = SILC + 6
      ISILN  = ISILN +6
      SILDX(4) = ISILN
      LUSETA = SILC
      SILDX(2) = 10*SILC + 1
      CALL WRITE (SILA,SILC,1,0)
      CALL WRITE (SCR2,ISILN,1,0)
      CALL WRITE (SCR2,SILC,1,0)
      CALL WRITE (SCR1,ICID,2,0)
      GO TO BACK, (300,310,320,330,360)
C
C     ECT
C
  360 CID(1) = IAPD(1,J  ,1,NCRDP)
      CID(2) = IAPD(2,J  ,1,NCRDP)
      CID(4) = IAPD(1,J+1,1,NCRDP)
      CID(3) = IAPD(2,J+1,1,NCRDP)
      CID(5) = CID(3) + 1
      CALL WRITE (ECTA,NECTA(1),6,0)
      AUSET(6,2) = USA
  100 CONTINUE
      CIDBX = NCID
C
C     PUT OUT ACPT REC
C
      IHEAD(2) = NTOT
      IHEAD(3) = IZ(IPID+1)
      LCLA     = IHEAD(3)
      IHEAD(4) = IZ(IPID+2)
      IHEAD(5) = IZ(IPID+3)
      ICIRC    = IHEAD(5)
      IHEAD(6) = IZ(IPID+4)
      IHEAD(7) = 0
      IL       = 0
      IN       = NSPAN + 1
C
C     PROPERTY DATA
C
      IF (LCLA.EQ.0 .AND. ICIRC.EQ.0) GO TO 70
      IF (LCLA .EQ. 0) GO TO 50
      CALL APDOE (IHEAD(4),IZ,NAEF1,NAEF2,IL,NW)
      IF (IL .EQ. 0) GO TO 994
      IF (MOD(NW,IN) .NE. 0) GO TO 994
      IHEAD(7) = NW/IN
      GO TO 70
   50 IF (ICIRC .EQ. 0) GO TO 70
      CALL APDOE (IHEAD(6),IZ,NAEF1,NAEF2,IL,NW)
      IF (IL .EQ. 0) GO TO 995
      IN = 2 + 2*ICIRC
      IF (MOD(NW,IN) .NE. 0) GO TO 995
      IHEAD(7) = NW/IN
   70 CALL WRITE (ACPT,IHEAD,9,0)
      CALL WRITE (ACPT,Z(IOC+1),NSPAN*6,0)
      IF (IL .NE. 0) CALL WRITE (ACPT,Z(IL+1),NW,0)
      CALL WRITE (ACPT,0,0,1)
  400 CONTINUE
      SILB = SILC
 1001 RETURN
C
C     ERROR MESSAGES
C
  994 I = IHEAD(4)
 9941 WRITE  (NOT,9942) UFM,I,EID
 9942 FORMAT (A23,' 2429, WRONG NUMBER OF WORDS OR CARD NOT FOUND FOR ',
     1       'CARD ID',I9, /29X,'ASSOCIATED WITH CAERO4 ID',I9)
      GO TO 1000
  995 I = IHEAD(6)
      GO TO 9941
  996 CALL MESAGE (-8,0,NAM)
  997 I = PID
      GO TO 9941
  998 I = NCHORD
      GO TO 9941
  999 CALL EMSG (0,2323,1,2,0)
      WRITE  (NOT,891) PID,EID
  891 FORMAT (10X,16HPAERO4 CARD NO. ,I8,31H REFERENCED BY CAERO4 CARD N
     *O. ,I8,15H DOES NOT EXIST)
      GO TO 1000
 1000 CALL MESAGE (-61,0,NAM)
      GO TO 1001
      END

      SUBROUTINE READ6 (IRIG,GPHIA,NR,PHIA)
C
C     ADDS GIVENS EIGENVECTORS TO RIGID BODY MODES ON PHIA
C
      INTEGER         GPHIA,SYSBUF,PHIA,MCB(7),FILE
      REAL            Z(3)
      COMMON /SYSTEM/ SYSBUF
      COMMON /ZZZZZZ/ IZ(1)
      COMMON /UNPAKX/ IT2U,IIU,JJU,INCR1U
      COMMON /PACKX / IT1,IT2,II,JJ,INCR1
      EQUIVALENCE     (IZ(1),Z(1))
C
C
      IBUF1 =  KORSZ(Z) - SYSBUF + 1
      IBUF2 =  IBUF1 - SYSBUF
      MCB(1)= GPHIA
      CALL RDTRL (MCB)
      NCOL = MCB(2) - NR
      II   = 1
      JJ   = MCB(3)
      IT1  = MCB(5)
      IT2  = MCB(5)
      IT2U = MCB(5)
      CALL MAKMCB (MCB,PHIA,JJ,MCB(4),IT1)
      INCR1 = 1
      CALL GOPEN (PHIA,Z(IBUF1),1)
      IF (NR .EQ. 0) GO TO 21
      FILE = IRIG
      CALL GOPEN (IRIG,Z(IBUF2),0)
      Z(1) = 0.0
      Z(2) = 0.0
      DO 20 I = 1,NR
      IIU = 0
      CALL UNPACK (*11,IRIG,Z(3))
      II = IIU
      JJ = JJU
      CALL PACK (Z(3),PHIA,MCB)
      GO TO 20
   11 II = 1
      JJ = 1
      CALL PACK (Z,PHIA,MCB)
   20 CONTINUE
      CALL CLOSE (IRIG,1)
   21 CONTINUE
      IF (NCOL .LE. 0) GO TO 31
      CALL GOPEN (GPHIA,Z(IBUF2),0)
      FILE = GPHIA
      INCR1U = 1
      Z(1) = 0.0
      Z(2) = 0.0
      CALL SKPREC (GPHIA,NR)
      DO 30 I = 1,NCOL
      IIU = 0
      CALL UNPACK (*35,GPHIA,Z(3))
      II = IIU
      JJ = JJU
      CALL PACK (Z(3),PHIA,MCB)
      GO TO 30
   35 II = 1
      JJ = 1
      CALL PACK (Z,PHIA,MCB)
   30 CONTINUE
      CALL CLOSE (GPHIA,1)
   31 CALL CLOSE (PHIA,1)
      CALL WRTTRL (MCB)
      RETURN
      END

      SUBROUTINE FERLTS (IFILE,DZ,DY,ZM)
C
C   FEER MATRIX TRANSPOSE MULTIPLY  (SINGLE PRECISION)
C   SEE SUBROUTINE FERRDM FOR CONTENTS OF SMAPOS AND HOW THE MATRIX
C   DATA IS STORED IN MEMORY.
C
      REAL             DZ(1)     ,DY(1)     ,DSUM      ,ZM(1)
      REAL             DCORE(1) 
      INTEGER          IFILE(7)  ,SMAPOS
      COMMON  /FEERIM/ NIDSMA    ,NIDLT     ,NIDORV    ,NLTLI
     1,                NSMALI    ,IBFSMA    ,IBFLT
     2,                IBFORV    ,SMAPOS(7) ,LTPOS(7)
      COMMON  /UNPAKX/ IPRC      ,IP        ,NP        ,INCR
      COMMON  /ZZZZZZ/ ICORE(1)
      EQUIVALENCE      ( DCORE(1),ICORE(1) )
      N     = IFILE(2)   
      ICCOL = 1
      IF ( NIDSMA .EQ. 0 ) GO TO 1005
      MEM   = NIDSMA
      ILCOL = SMAPOS( 1 )
      DO 20 I = 1,N
      ICCOL = I
C CHECK TO SEE IF REMAINING DATA IS ON THE FILE AND NOT IN MEMORY
      IF ( ICCOL .GT. ILCOL ) GO TO 1000
      DY(I) = 0.
      DSUM  = 0.
    5 ICOL  = ICORE(MEM)
      IF( ICOL .NE. I ) GO TO 20
      NTMS  = ICORE(MEM+1)
      IP    = ICORE(MEM+2+NTMS)
      NP    = IP+NTMS-1
      INDX  = MEM+1
      II    =  0
      DO 10 J = IP,NP
      II = II +1
   10 DSUM  = DSUM + DCORE(INDX+II) * DZ(J)
      DY(I) = DSUM
      MEM   = MEM+4+NTMS
      GO TO 5
   20 CONTINUE
      GO TO 7000
 1000 CONTINUE
      CALL DSSPOS ( IFILE, SMAPOS(2), SMAPOS(3), SMAPOS(4) )
      GO TO 1008
 1005 CALL REWIND ( IFILE )
      CALL SKPREC ( IFILE, 1 )
 1008 CONTINUE
      INCR  = 1
      IPRC  = IFILE(5)
      DO 1020 I = ICCOL, N
      DY(I) = 0.        
      IP    = 0
      CALL UNPACK(*1020,IFILE,ZM(1))
      II    = 0
      DSUM  = 0.0
      DO 1010 J = IP,NP
      II    = II +1
 1010 DSUM  = DSUM + ZM(II) * DZ(J)
      DY(I) = DSUM
 1020 CONTINUE
 7000 CONTINUE
      RETURN
      END

      SUBROUTINE TIS2D8 (TEMP,PG)
C
C     THIS ROUTINE COMPUTES EQUIVALENT LOADS DUE TO GRID POINT
C     TEMPERATURES FOR THE 2-D, 8 GRID POINT ISOPARAMETRIC ELEMENT
C
C     ECPT LIST                        IN
C                                      THIS
C     ECPT       DESCRIPTION           ROUTINE         TYPE
C     --------   --------------------  --------       -------
C     ECPT( 1) = ELEMENT ID            NECPT(1)       INTEGER
C     ECPT( 2) = GRID POINT 1          NGRID(1)       INTEGER
C     ECPT( 3) = GRID POINT 2          NGRID(2)       INTEGER
C     ECPT( 4) = GRID POINT 3          NGRID(3)       INTEGER
C     ECPT( 5) = GRID POINT 4          NGRID(4)       INTEGER
C     ECPT( 6) = GRID POINT 5          NGRID(5)       INTEGER
C     ECPT( 7) = GRID POINT 6          NGRID(6)       INTEGER
C     ECPT( 8) = GRID POINT 7          NGRID(7)       INTEGER
C     ECPT( 9) = GRID POINT 8          NGRID(8)       INTEGER
C     ECPT(10) = COORD SYS ID-STRESS   ID1            INTEGER
C     ECPT(11) = ANIS. MATERIAL ANGLE  TH             REAL
C     ECPT(12) = MATERIAL ID           MATID1         INTEGER
C     ECPT(13) = THICKNESS             T              REAL
C     ECPT(14) = COORD SYS ID 1        ISYS1          INTEGER
C     ECPT(15) = X1                    X1             REAL
C     ECPT(16) = Y1                    Y1             REAL
C     ECPT(17) = Z1                    Z1             REAL
C     ECPT(18) = COORD SYS ID 2        ISYS2          INTEGER
C     ECPT(19) = X2                    X2             REAL
C     ECPT(20) = Y2                    Y2             REAL
C     ECPT(21) = Z2                    Z2             REAL
C     ECPT(22) = COORD SYS ID 3        ISYS3          INTEGER
C     ECPT(23) = X3                    X3             REAL
C     ECPT(24) = Y3                    Y3             REAL
C     ECPT(25) = Z3                    Z3             REAL
C     ECPT(26) = COORD SYS ID 4        ISYS4          INTEGER
C     ECPT(27) = X4                    X4             REAL
C     ECPT(28) = Y4                    Y4             REAL
C     ECPT(29) = Z4                    Z4             REAL
C     ECPT(30) = COORD SYS ID 5        ISYS5          INTEGER
C     ECPT(31) = X5                    X5             REAL
C     ECPT(32) = Y5                    Y5             REAL
C     ECPT(33) = Z5                    Z5             REAL
C     ECPT(34) = COORD SYS ID 6        ISYS6          INTEGER
C     ECPT(35) = X6                    XL             REAL
C     ECPT(36) = Y6                    Y6             REAL
C     ECPT(37) = Z6                    Z6             REAL
C     ECPT(38) = COORD SYS ID 7        ISYS7          INTEGER
C     ECPT(39) = X7                    X7             REAL
C     ECPT(40) = Y7                    Y7             REAL
C     ECPT(41) = Z7                    Z7             REAL
C     ECPT(42) = COORD SYS ID 8        ISYS8          INTEGER
C     ECPT(43) = X8                    X8             REAL
C     ECPT(44) = Y8                    Y8             REAL
C     ECPT(45) = Z8                    Z8             REAL
C     ECPT(46) = ELEMENT TEMP          TTEMP          REAL
C
      REAL            KX,KY
      DIMENSION       G(9),QQ(15),XI(8),ETA(8),XY1(3),XY2(3),BT(12),
     1                ECPT(1),TEMPAR(8),DNX(1),DNY(1),IZ(1),DNXI(1),
     2                DNETA(1),TEMP(8),PG(1),DN(8),IWS(2,3),
     3                VEC(3),VVEC(3),VECI(3),VECJ(3),VECK(3),E1T(6)
      COMMON /TRANX / Z(14)
      COMMON /TRIMEX/ NECPT(1),NGRID(8),ID1,TH,MATID1,T,ISYS1,X1,Y1,Z1,
     1                ISYS2,X2,Y2,Z2,ISYS3,X3,Y3,Z3,ISYS4,X4,Y4,Z4,
     2                ISYS5,X5,Y5,Z5,ISYS6,X6,Y6,Z6,ISYS7,X7,Y7,Z7,
     3                ISYS8,X8,Y8,Z8,TTEMP,SAVE(16),RTSIDE(3),TEMPAV,
     4                ALPHAS(3),XX(16),DNC(16),DNL(16),XXJB(2,2),
     5                XJB(4),PT(3),H(3),G,BT,DETERM,DUMARG
      COMMON /MATIN / MATID,INFLAG,ELTEMP,STRESS,SINTH,COSTH
      COMMON /MATOUT/ G11,G12,G13,G22,G23,G33,RHO,ALPHA1,ALPHA2,ALP12,
     1                TREF,GE,KX,KY,C
      EQUIVALENCE     (ECPT(1),NECPT(1)),(Z(1),IZ(1)),(QQ(1),G11),
     1                (DNC(1),DNXI(1)),(DNC(9),DNETA(1)),
     2                (DNL(1),DNX(1)),(DNL(9),DNY(1)),
     3                (TEMPAR(1),BT(1)),(XY1(1),X1),(XY2(1),X2)
      DATA    XI    / -1., 1., 1., -1., 0., 1., 0., -1./
      DATA    ETA   / -1.,-1., 1.,  1.,-1., 0., 1.,  0./
C
C     UNIT I VECTOR IS FROM GRID POINT 1 TO GRID POINT 2
C
      DO 20 I = 1,3
      VECI(I) = XY2(I) - XY1(I)
   20 CONTINUE
      VECIL = SQRT(VECI(1)**2 + VECI(2)**2 + VECI(3)**2)
      IF (VECIL .EQ. 0.0) GO TO 40
      VECI(1) = VECI(1)/VECIL
      VECI(2) = VECI(2)/VECIL
      VECI(3) = VECI(3)/VECIL
C
C     K VECTOR IS OBTAINED BY CROSSING I INTO VECTOR FROM GRID PT. 1 TO
C     GRID
C
      VECK(1) = VECI(2)*(Z4-Z1) - VECI(3)*(Y4-Y1)
      VECK(2) = VECI(3)*(X4-X1) - VECI(1)*(Z4-Z1)
      VECK(3) = VECI(1)*(Y4-Y1) - VECI(2)*(X4-X1)
      VECKL   = SQRT(VECK(1)**2 + VECK(2)**2 + VECK(3)**2)
      IF (VECKL .EQ. 0.0) GO TO 40
      VECK(1) = VECK(1)/VECKL
      VECK(2) = VECK(2)/VECKL
      VECK(3) = VECK(3)/VECKL
C
C     J VECTOR IS OBTAINED BY CROSSING K INTO I
C
      VECJ(1) = VECK(2)*VECI(3) - VECK(3)*VECI(2)
      VECJ(2) = VECK(3)*VECI(1) - VECK(1)*VECI(3)
      VECJ(3) = VECK(1)*VECI(2) - VECK(2)*VECI(1)
C
      E1T(1) = VECI(1)
      E1T(2) = VECI(2)
      E1T(3) = VECI(3)
      E1T(4) = VECJ(1)
      E1T(5) = VECJ(2)
      E1T(6) = VECJ(3)
C
C     STORE ELEMENT COORDS FOR GRIDS 1 AND 2
C
      XX(1) = 0.
      XX(2) = 0.
      XX(3) = VECIL
      XX(4) = 0.
C
C     FOR GRIDS 3-8, THE X COORDINATE IS THE DOT PRODUCT OF HTE VECTOR
C     FROM THE GRID POINT TO
C     GRID POINT 1 TO THE GRID POINT AND THE I VECTOR. THE Y COORD. IS
C     THE L OF THE I VECTOR CROSSED INTO THE VECTOR FROM GRID 1 TO THE
C     GRID POINT.
C
      DO 30 I = 3,8
      IXX  = 2*I - 1
      ISUB = 4*I + 11
      VEC(1)  = ECPT(ISUB  ) - X1
      VEC(2)  = ECPT(ISUB+1) - Y1
      VEC(3)  = ECPT(ISUB+2) - Z1
      XX(IXX) = VEC(1)*VECI(1) + VEC(2)*VECI(2) + VEC(3)*VECI(3)
      VVEC(1) = VECI(2)*VEC(3) - VECI(3)*VEC(2)
      VVEC(2) = VECI(3)*VEC(1) - VECI(1)*VEC(3)
      VVEC(3) = VECI(1)*VEC(2) - VECI(2)*VEC(1)
      XX(IXX+1) = SQRT(VVEC(1)**2 + VVEC(2)**2 + VVEC(3)**2)
   30 CONTINUE
      GO TO 150
C
C     INAPPROPRIATE GEOMETRY
C
   40 CALL MESAGE (-30,31,ECPT(1))
C
C     COMPUTE MATERIAL PROPERTIES
C
  150 TTH   = TH*3.1415927/180.
      SINTH = SIN(TTH)
      COSTH = COS(TTH)
      INFLAG= 2
      MATID = MATID1
C
C     ZERO OUT SOME MATRICES
C
      DO 225 I = 1,16
  225 SAVE(I) = 0.
C
      PT(1) =-0.57735027
      PT(2) =-PT(1)
      H(1)  = 1.
      H(2)  = 1.
      IF (ID1 .EQ. 2) GO TO 226
      PT(1) =-0.77459667D0
      PT(2) = 0.D0
      PT(3) =-PT(1)
      H(1)  = 5.0/9.0
      H(2)  = 8.0/9.0
      H(3)  = H(1)
C
C     2 OR 3 QUADRATURE POINTS
C
  226 DO 255 III = 1,ID1
      DO 255 JJJ = 1,ID1
C
C     COMPUTE DERIVATIVES WITH RESPECT TO XI AND ETA
C     EACH GRID POINT
C
      DO 230 N = 1,4
      DN(N)   = 0.25*(1.+PT(III)*XI(N))*(1.+PT(JJJ)*ETA(N))*
     1          (PT(III)*XI(N)+PT(JJJ)*ETA(N)-1.)
      DNXI(N) = 0.25*XI(N)*(1.+PT(JJJ)*ETA(N))*
     1          (2.*PT(III)*XI(N)+PT(JJJ)*ETA(N))
      DNETA(N)= 0.25*ETA(N)*(1.+PT(III)*XI(N))*
     1          (PT(III)*XI(N)+2.*PT(JJJ)*ETA(N))
  230 CONTINUE
C
      DO 231 N = 5,7,2
      DN(N)   = 0.5*(1.-PT(III)*PT(III))*(1.+PT(JJJ)*ETA(N))
      DNXI(N) =-PT(III)*(1.+PT(JJJ)*ETA(N))
      DNETA(N)= 0.5*(1.-PT(III)*PT(III))*ETA(N)
  231 CONTINUE
C
      DO 232 N = 6,8,2
      DN(N)   = 0.5*(1.+PT(III)*XI(N))*(1.-PT(JJJ)*PT(JJJ))
      DNXI(N) = 0.5*XI(N)*(1.-PT(JJJ)*PT(JJJ))
      DNETA(N)=-PT(JJJ)*(1.+PT(III)*XI(N))
  232 CONTINUE
C
C     COMPUTE JACOBEAN
C
C           N1XI   N2XI   N3XI   N4XI   N5XI   N6XI   N7XI   N8XI
C     DNC = N1ETA  N2ETA  N3ETA  N4ETA  N5ETA  N6ETA  N7ETA  N8ETA
C
C          X1  Y1
C          X2  Y2
C          X3  Y3
C     XX = X4  Y4
C          X5  Y5
C          X6  Y6
C          X7  Y7
C          X8  Y8
C
      CALL GMMATS (DNC,2,8,0, XX,8,2,0, XJB)
C
C     XJB IS ROW-STORED-IT MUST BE COLUMN-STORED AND DOUBLY DIMENSIONED
C     FOR INVERSION
C
      K = 0
      DO 240 I = 1,2
      DO 240 J = 1,2
      K = K + 1
  240 XXJB(I,J) = XJB(K)
C
C     COMPUTE INVERSE AND DETERMINANT OF JACOBEAN
C
      CALL INVERS (2,XXJB,2,DUMARG,0,DETERM,ISING,IWS)
      IF (ISING .EQ. 2) CALL MESAGE (-30,143,ECPT(1))
C
C     COMPUTE DERIVATIVES WITH RESPECT TO X,Y,AND Z
C
      K = 0
      DO 245 I = 1,2
      DO 245 J = 1,2
      K = K + 1
  245 XJB(K) = XXJB(I,J)
      CALL GMMATS (XJB,2,2,0, DNC,2,8,0, DNL)
C
C           N1X N2X N3X N4X N5X N6X N7X N8X
C     DNL = N1Y N2Y N3Y N4Y N5Y N6Y N7Y N8Y
C
      COEF = DETERM*H(III)*H(JJJ)
C
C     COMPUTE GAUSS POINT TEMPERATURE
C
      GSTEMP = 0.
      DO 234 N = 1,8
      GSTEMP = GSTEMP + DN(N)*(TEMP(N))
  234 CONTINUE
C
C     GSTEMP IS THE GAUSS POINT TEMPERATURE. FIND MATERIAL PROPERTIES
C     BASED ON THIS TEMPERATURE. IF SAME AS PREVIOUS TEMPERATURE,DO NOT
C     RECOMPUTE.
C
      LLL = III*JJJ
      IF (LLL .EQ. 1) GO TO 236
      IF (GSTEMP .EQ. ELTEMP) GO TO 237
  236 ELTEMP = GSTEMP
      CALL MAT (ECPT(1))
      DO 160 I = 1,3
  160 G(I) = QQ(I)
      G(4) = QQ(2)
      G(5) = QQ(4)
      G(6) = QQ(5)
      G(7) = QQ(3)
      G(8) = QQ(5)
      G(9) = QQ(6)
      ALPHAS(1) = ALPHA1
      ALPHAS(2) = ALPHA2
      ALPHAS(3) = ALP12
C
      CALL GMMATS (G,3,3,0, ALPHAS,3,1,0, RTSIDE)
C
C     COMPUTE RELATIVE GAUSS POINT TEMPERATURE
C
      RGTEMP = GSTEMP - TREF
C
  237 CONTINUE
C
      COEF = COEF*RGTEMP
C
C     SET UP BT
C
      DO 239 KK = 1,8
C
      DO 238 I = 1,6
  238 BT(I) = 0.
C
      BT(1) = DNX(KK)
      BT(3) = DNY(KK)
      BT(5) = BT(3)
      BT(6) = BT(1)
C
      CALL GMMATS (BT,2,3,0, RTSIDE,3,1,0, TEMPAR(7))
C
C     ADD TO PREVIOUS RESULTS
C
      SAVE(2*KK-1) = SAVE(2*KK-1) + TEMPAR(7)*COEF
      SAVE(2*KK  ) = SAVE(2*KK  ) + TEMPAR(8)*COEF
C
C     CONTINUE FOR MORE GRID POINTS
C
  239 CONTINUE
C
C     CONTINUE FOR MORE GAUSS POINTS
C
  255 CONTINUE
C
C     TRANSFORMATIONS AND ADD TO OVERALL VECTOR
C
      DO 350 KK = 1,8
      TEMPAR(7) = SAVE(2*KK-1)
      TEMPAR(8) = SAVE(2*KK  )
C
C     CONVERT FROM ELEMENT COORDINATES TO BASIC
C
      CALL GMMATS (E1T,2,3,1, TEMPAR(7),2,1,0, TEMPAR(1))
      ISUB = 4*KK + 10
      IF (NECPT(ISUB) .EQ. 0) GO TO 300
C
C     MUST TRANSFORM FROM BASIC COORDS TO GLOBAL
C
      CALL BASGLB (TEMPAR(1),TEMPAR(1),ECPT(ISUB+1),NECPT(ISUB))
C
C     ADD THIS VECTOR TO OVERALL LOAD VECTOR
C
  300 DO 310 I = 1,3
      L = NGRID(KK) + I - 1
  310 PG(L) = PG(L) + TEMPAR(I)*T
C
C     GET ANOTHER PARTITION
C
  350 CONTINUE
      RETURN
      END

      SUBROUTINE KBAR
C
C     THIS ROUTINE COMPUTES THE TWO 6X6 MATRICES K(NPVT,NPVT) AND
C     K(NPVT,J) FOR A BAR ELEMENT HAVING END POINTS NUMBERED NPVT AND J.
C
C                  ECPT FOR THE BAR
C
C     ECPT( 1)  -  IELID       ELEMENT ID. NUMBER
C     ECPT( 2)  -  ISILNO(2)   * SCALAR INDEX NOS. OF THE GRID POINTS
C     ECPT( 3)  -   ...        *
C     ECPT( 4)  -  SMALLV(3)   $ REFERENCE VECTOR
C     ECPT( 5)  -   ...        $
C     ECPT( 6)  -   ...        $
C     ECPT( 7)  -  ICSSV       COOR. SYS. ID FOR SMALLV VECTOR
C     ECPT( 8)  -  IPINFL(2)   * PIN FLAGS
C     ECPT( 9)  -   ...        *
C     ECPT(10)  -  ZA(3)       $ OFFSET VECTOR FOR POINT A
C     ECPT(11)  -   ...        $
C     ECPT(12)  -   ...        $
C     ECPT(13)  -  ZB(3)       * OFFSET VECTOR FOR POINT B
C     ECPT(14)  -   ...        *
C     ECPT(15)  -   ...        *
C     ECPT(16)  -  IMATID      MATERIAL ID.
C     ECPT(17)  -  A           CROSS-SECTIONAL AREA
C     ECPT(18)  -  I1          $ AREA MOMENTS OF INERTIA
C     ECPT(19)  -  I2          $
C     ECPT(20)  -  FJ          TORSIONAL CONSTANT
C     ECPT(21)  -  NSM         NON-STRUCTURAL MASS
C     ECPT(22)  -  FE          FORCE ELEMENT DESCRIPTIONS (FORCE METHOD)
C     ECPT(23)  -  C1          * STRESS RECOVERY COEFFICIENTS
C     ECPT(24)  -  C2          *
C     ECPT(25)  -  D1          *
C     ECPT(26)  -  D2          *
C     ECPT(27)  -  F1          *
C     ECPT(28)  -  F2          *
C     ECPT(29)  -  G1          *
C     ECPT(30)  -  G2          *
C     ECPT(31)  -  K1          $ AREA FACTORS FOR SHEAR
C     ECPT(32)  -  K2          $
C     ECPT(33)  -  I12         AREA MOMENT OF INERTIA
C     ECPT(34)  -  MCSIDA      COOR. SYS. ID. FOR GRID POINT A
C     ECPT(35)  -  GPA(3)      * BASIC COORDINATES FOR GRID POINT A
C     ECPT(36)  -   ...        *
C     ECPT(37)  -   ...        *
C     ECPT(38)  -  MCSIDB      COOR. SYS. ID. FOR GRID POINT B
C     ECPT(39)  -  GPB(3)      $ BASIC COORDINATES FOR GRID POINT B
C     ECPT(40)  -   ...        $
C     ECPT(41)  -   ...        $
C     ECPT(42)  -  ELTEMP      AVG. ELEMENT TEMPERATURE
C
C     SEE SUBROUTINE KELBOW ON THE DISCUSSION OF K1 AND K2, THE AERA
C     FACTORS FOR SHEAR CORRECTION
C
      LOGICAL          HEAT      ,ABASIC    ,BBASIC    ,BASIC    ,
     1                 AOFSET    ,BOFSET    ,OFFSET
      REAL             K1        ,K2        ,I1        ,I2       ,
     1                 I12       ,NSM
      DOUBLE PRECISION TA(18)    ,TB(9)     ,SMALV0(6) ,DELA     ,
     1                 DELB      ,KE        ,KEP       ,VECI     ,
     2                 VECJ      ,VECK      ,FL        ,FLL      ,
     3                 EI1       ,EI2       ,GAK1      ,GAK2     ,
     4                 R1        ,R2        ,SK1       ,SK2      ,
     5                 SK3       ,SK4       ,AEL       ,GJL      ,
     6                 LR1       ,LR2       ,L         ,LSQ      ,
     7                 LCUBE     ,DP(8)     ,BETA      ,LB       ,
     8                 L2B3      ,L2B6      ,DAMPC
      DIMENSION        VECI(3)   ,VECJ(3)   ,VECK(3)   ,ECPT(100),
     1                 IECPT(100),IPIN(10)
      COMMON /SYSTEM/  ISYS
      COMMON /SMA1IO/  IFCSTM    ,IFMPT     ,IFDIT     ,IDUM1    ,
     1                 IFECPT    ,IGECPT    ,IFGPCT    ,IGGPCT   ,
     2                 IFGEI     ,IGGEI     ,IFKGG     ,IGKGG    ,
     3                 IF4GG     ,IG4GG     ,IFGPST    ,IGGPST   ,
     4                 INRW      ,OUTRW     ,CLSNRW    ,CLSRW    ,
     5                 NEOR      ,EOR       ,MCBKGG(7) ,MCB4GG(7)
C
C     SMA1 VARIABLE CORE BOOKKEEPING PARAMETERS
C
      COMMON /SMA1BK/  ICSTM     ,NCSTM     ,IGPCT     ,NGPCT    ,
     1                 IPOINT    ,NPOINT    ,I6X6K     ,N6X6K    ,
     2                 I6X64     ,N6X64
C
C     SMA1 PROGRAM CONTROL PARAMETERS
C
      COMMON /SMA1CL/  IOPT4     ,K4GGSW    ,NPVT      ,LEFT     ,
     1                 FROWIC    ,LROWIC    ,NROWSC    ,TNROWS   ,
     2                 JMAX      ,NLINKS    ,LINK(10)  ,IDETCK   ,
     3                 DODET     ,NOGO
      COMMON /SMA1HT/  HEAT
      COMMON /SMA1ET/  IELID     ,ISILNO(2) ,SMALLV(3) ,ICSSV    ,
     1                 IPINFL(2) ,ZA(3)     ,ZB(3)     ,IMATID   ,
     2                 A         ,I1        ,I2        ,FJ       ,
     3                 NSM       ,FE        ,C1        ,C2       ,
     4                 D1        ,D2        ,F1        ,F2       ,
     5                 G1        ,G2        ,K1        ,K2       ,
     6                 I12       ,           MCSIDA    ,GPA(3)   ,
     7                 MCSIDB    ,GPB(3)    ,TEMPEL
C
C     SMA1 LOCAL VARIABLES
C
      COMMON /SMA1DP/  KE(144)   ,KEP(144)  ,DELA(6)   ,DELB(6)
C
C     INPUT AND OUTPUT BLOCKS FOR SUBROUTINE MAT
C
      COMMON /MATIN/   MATIDC    ,MATFLG    ,ELTEMP    ,STRESS
C
      COMMON /MATOUT/  E         ,G         ,NU        ,RHO      ,
     1                 ALPHA     ,TSUBO     ,GSUBE     ,SIGT     ,
     2                 SIGC      ,SIGS
      COMMON /HMTOUT/  FK
C
      EQUIVALENCE      (IELID,ECPT(1),IECPT(1)) , (TA(10),TB(1)) ,
     1                 (ECPT(71),DP(1))
C
C     DETERMINE WHICH POINT IS THE PIVOT POINT.
C
      IPVT = 1
      IF (ISILNO(1) .EQ. NPVT) GO TO 20
      IPVT = 2
      IF (ISILNO(2) .NE. NPVT) CALL MESAGE (-30,34,IECPT(1))
C
C     SET UP POINTERS TO COOR. SYS. IDS., OFFSET VECTORS, AND PIN FLAGS.
C     ICSIDA AND ICSIDB ARE COOR. SYS. IDS.
C
   20 JCSIDA = 34
      JCSIDB = 38
      JOFSTA = 10
      JOFSTB = 13
      JPINA  =  8
      JPINB  =  9
      ICSIDA = IECPT(34)
      ICSIDB = IECPT(38)
C
C     NORMALIZE THE REFERENCE VECTOR WHICH LIES IN THE FIRST PRINCIPAL
C     AXIS PLANE  (FMMS - 36 P. 4)
C     WE STORE SMALLV IN SMALV0 SO THAT ARITHMETIC WILL BE DOUBLE
C     PRECISION
C
      DO 50 I = 1,3
   50 SMALV0(I) = SMALLV(I)
      FL = DSQRT(SMALV0(1)**2 + SMALV0(2)**2 + SMALV0(3)**2)
      IF (FL .LE. 0.0D0) GO TO 1010
      DO 60 I = 1,3
   60 SMALV0(I) = SMALV0(I)/FL
C
C     DETERMINE IF POINT A AND B ARE IN BASIC COORDINATES OR NOT.
C
      ABASIC = .TRUE.
      BBASIC = .TRUE.
      IF (ICSIDA .NE. 0) ABASIC = .FALSE.
      IF (ICSIDB .NE. 0) BBASIC = .FALSE.
C
C     COMPUTE THE TRANSFORMATION MATRICES TA AND TB IF NECESSARY
C
      IF (.NOT. ABASIC) CALL TRANSD (ECPT(JCSIDA),TA)
      IF (.NOT. BBASIC) CALL TRANSD (ECPT(JCSIDB),TB)
C
C     DETERMINE IF WE HAVE NON-ZERO OFFSET VECTORS.
C
      AOFSET = .TRUE.
      J = JOFSTA - 1
      DO 70 I = 1,3
      J = J + 1
      IF (ECPT(J) .NE. 0.0) GO TO 80
   70 CONTINUE
      AOFSET = .FALSE.
   80 BOFSET = .TRUE.
      J = JOFSTB - 1
      DO 90 I = 1,3
      J = J + 1
      IF (ECPT(J) .NE. 0.0) GO TO 100
   90 CONTINUE
      BOFSET = .FALSE.
C
C     FORM THE CENTER AXIS OF THE BEAM WITHOUT OFFSETS.
C     FIRST WE STORE THE COORDINATES IN THE ARRAY DP SO THAT ALL
C     ARITHMETIC WILL BE DOUBLE PRECISION.
C
  100 DP(1) = ECPT(JCSIDA+1)
      DP(2) = ECPT(JCSIDA+2)
      DP(3) = ECPT(JCSIDA+3)
      DP(4) = ECPT(JCSIDB+1)
      DP(5) = ECPT(JCSIDB+2)
      DP(6) = ECPT(JCSIDB+3)
      VECI(1) = DP(1) - DP(4)
      VECI(2) = DP(2) - DP(5)
      VECI(3) = DP(3) - DP(6)
C
C     TRANSFORM THE OFFSET VECTORS IF NECESSARY
C
      IF (.NOT.AOFSET .AND. .NOT.BOFSET)  GO TO 150
C
C     TRANSFORM THE OFFSET VECTOR FOR POINT A IF NECESSARY.
C
      IDELA = 1
      J = JOFSTA - 1
      DO 110 I = 1,3
      J = J + 1
  110 DELA(I) = ECPT(J)
      IF (ABASIC) GO TO 120
      IDELA = 4
      CALL GMMATD (TA,3,3,0, DELA(1),3,1,0, DELA(4))
C
C     TRANSFORM THE OFFSET VECTOR FOR POINT B IF NECESSARY
C
  120 IDELB = 1
      J = JOFSTB - 1
      DO 130 I = 1,3
      J = J + 1
  130 DELB(I) = ECPT(J)
      IF (BBASIC) GO TO 140
      IDELB = 4
      CALL GMMATD (TB,3,3,0, DELB(1),3,1,0, DELB(4))
C
C     SINCE THERE WAS AT LEAST ONE NON-ZERO OFFSET VECTOR RECOMPUTE VECI
C
  140 VECI(1) = VECI(1) + DELA(IDELA  ) - DELB(IDELB  )
      VECI(2) = VECI(2) + DELA(IDELA+1) - DELB(IDELB+1)
      VECI(3) = VECI(3) + DELA(IDELA+2) - DELB(IDELB+2)
C
C     COMPUTE THE LENGTH OF THE BIG V (VECI) VECTOR AND NORMALIZE
C
  150 VECI(1) = -VECI(1)
      VECI(2) = -VECI(2)
      VECI(3) = -VECI(3)
      FL = DSQRT(VECI(1)**2 + VECI(2)**2 + VECI(3)**2)
      IF (FL .EQ. 0.0D0) GO TO 1010
C
C     NOW THAT LENGTH HAS BEEN COMPUTED, BRANCH IF THIS IS A -HEAT-
C     FORMULATION.
C
      IF (HEAT) GO TO 2000
      DO 160 I = 1,3
  160 VECI(I) = VECI(I)/FL
C
C     COMPUTE THE SMALL V SUB 0 VECTOR, SMALV0.  ***CHECK THIS LOGIC***
C
      ISV = 1
      IF (ICSSV .EQ. 0) GO TO 180
      ISV = 4
      CALL GMMATD (TA,3,3,0, SMALV0(1),3,1,0, SMALV0(4))
C
C     COMPUTE THE K VECTOR, VECK = VECI  X  SMALV0, AND NORMALIZE
C
  180 VECK(1) =  VECI(2)*SMALV0(ISV+2) - VECI(3)*SMALV0(ISV+1)
      VECK(2) =  VECI(3)*SMALV0(ISV  ) - VECI(1)*SMALV0(ISV+2)
      VECK(3) =  VECI(1)*SMALV0(ISV+1) - VECI(2)*SMALV0(ISV  )
      FLL = DSQRT(VECK(1)**2 + VECK(2)**2 + VECK(3)**2)
      IF (FLL .EQ. 0.0D0) GO TO 1010
      VECK(1) =  VECK(1)/FLL
      VECK(2) =  VECK(2)/FLL
      VECK(3) =  VECK(3)/FLL
C
C     COMPUTE THE J VECTOR, VECJ = VECK  X  VECI, AND NORMALIZE
C
      VECJ(1) =  VECK(2)*VECI(3) - VECK(3)*VECI(2)
      VECJ(2) =  VECK(3)*VECI(1) - VECK(1)*VECI(3)
      VECJ(3) =  VECK(1)*VECI(2) - VECK(2)*VECI(1)
      FLL = DSQRT(VECJ(1)**2 + VECJ(2)**2 + VECJ(3)**2)
      IF (FLL .EQ. 0.0D0) GO TO 1010
      VECJ(1) =  VECJ(1)/FLL
      VECJ(2) =  VECJ(2)/FLL
      VECJ(3) =  VECJ(3)/FLL
C
C     SEARCH THE MATERIAL PROPERTIES TABLE FOR E, G AND THE DAMPING
C     CONSTANT.
C
      MATIDC = IMATID
      MATFLG = 1
      ELTEMP = TEMPEL
      CALL MAT (IECPT(1))
      DAMPC = G SUB E
C
C     SET UP INTERMEDIATE VARIABLES FOR ELEMENT STIFFNESS MATRIX
C     CALCULATION
C
      L = FL
      LSQ = L**2
      LCUBE = LSQ*L
C
C     STORE ECPT AND MPT VARIABLES IN DOUBLE PRECISION LOCATIONS.
C
      DP(1) = E
      DP(2) = G
      DP(3) = I1
      DP(4) = I2
      DP(5) = A
      EI1 = DP(1)*DP(3)
      EI2 = DP(1)*DP(4)
      IF (K1.EQ.0.0 .OR. I12.NE.0.0) GO TO 210
      DP(6) = K1
      GAK1  = DP(2)*DP(5)*DP(6)
      R1 = (12.0D0*EI1*GAK1)/(GAK1*LCUBE + 12.0D0*L* EI1)
      GO TO 220
  210 R1 =  12.0D0*EI1/LCUBE
  220 IF (K2.EQ.0.0 .OR. I12.NE.0.0) GO TO 230
      DP(7) = K2
      GAK2  = DP(2)*DP(5)*DP(7)
      R2 = (12.0D0*EI2*GAK2)/(GAK2*LCUBE + 12.0D0*L*EI2)
      GO TO 240
  230 R2 =  12.0D0*EI2/LCUBE
C
C     COMPUTE THE -SMALL- K-S, SK1, SK2, SK3 AND SK4
C
  240 SK1 = 0.25D0*R1*LSQ + EI1/L
      SK2 = 0.25D0*R2*LSQ + EI2/L
      SK3 = 0.25D0*R1*LSQ - EI1/L
      SK4 = 0.25D0*R2*LSQ - EI2/L
C
C     COMPUTE THE TERMS THAT WILL BE NEEDED FOR THE 12 X 12 MATRIX KE
C
      AEL  = DP(5)*DP(1)/L
      LR1  = L*R1/2.0D0
      LR2  = L*R2/2.0D0
      DP(8)= FJ
      GJL  = DP(2)*DP(8)/L
C
C     CONSTRUCT THE 12 X 12 MATRIX KE
C
      DO 250 I = 1,144
  250 KE(I) = 0.0D0
      KE(  1) =  AEL
      KE(  7) = -AEL
      KE( 14) =  R1
      KE( 18) =  LR1
      KE( 20) = -R1
      KE( 24) =  LR1
      KE( 27) =  R2
      KE( 29) = -LR2
      KE( 33) = -R2
      KE( 35) = -LR2
      KE( 40) =  GJL
      KE( 46) = -GJL
      KE( 51) = -LR2
      KE( 53) =  SK2
      KE( 57) =  LR2
      KE( 59) =  SK4
      KE( 62) =  LR1
      KE( 66) =  SK1
      KE( 68) = -LR1
      KE( 72) =  SK3
      KE( 73) = -AEL
      KE( 79) =  AEL
      KE( 86) = -R1
      KE( 90) = -LR1
      KE( 92) =  R1
      KE( 96) = -LR1
      KE( 99) = -R2
      KE(101) =  LR2
      KE(105) =  R2
      KE(107) =  LR2
      KE(112) = -GJL
      KE(118) =  GJL
      KE(123) = -LR2
      KE(125) =  SK4
      KE(129) =  LR2
      KE(131) =  SK2
      KE(134) =  LR1
      KE(138) =  SK3
      KE(140) = -LR1
      KE(144) =  SK1
      IF (I12 .EQ. 0.0) GO TO 255
      DP(8)   =  I12
      BETA    =  12.0D0*DP(1)*DP(8)/LCUBE
      LB      =  L*BETA/2.0D0
      L2B3    =  LSQ*BETA/3.0D0
      L2B6    =  LSQ*BETA/6.0D0
      KE( 15) =  BETA
      KE( 17) = -LB
      KE( 21) = -BETA
      KE( 23) = -LB
      KE( 26) =  BETA
      KE( 30) =  LB
      KE( 32) = -BETA
      KE( 36) =  LB
      KE( 50) = -LB
      KE( 54) = -L2B3
      KE( 56) =  LB
      KE( 60) = -L2B6
      KE( 63) =  LB
      KE( 65) = -L2B3
      KE( 69) = -LB
      KE( 71) = -L2B6
      KE( 87) = -BETA
      KE( 89) =  LB
      KE( 93) =  BETA
      KE( 95) =  LB
      KE( 98) = -BETA
      KE(102) = -LB
      KE(104) =  BETA
      KE(108) = -LB
      KE(122) = -LB
      KE(126) = -L2B6
      KE(128) =  LB
      KE(132) = -L2B3
      KE(135) =  LB
      KE(137) = -L2B6
      KE(141) = -LB
      KE(143) = -L2B3
C
C     DETERMINE IF THERE ARE NON-ZERO PIN FLAGS.
C
  255 KA = IECPT(JPINA)
      KB = IECPT(JPINB)
      IF (KA.EQ.0 .AND. KB.EQ.0) GO TO 325
C
C     SET UP THE IPIN ARRAY
C
      DO 260 I = 1,5
      IPIN(I  ) = MOD(KA,10)
      IPIN(I+5) = MOD(KB,10) + 6
      IF (IPIN(I+5) .EQ. 6) IPIN(I+5) = 0
      KA = KA/10
  260 KB = KB/10
C
C     ALTER KE MATRIX DUE TO PIN FLAGS.
C
      DO 320 I = 1,10
      IF (IPIN(I) .EQ. 0) GO TO 320
      II = 13*IPIN(I) - 12
      IF (KE(II) .NE. 0.0D0) GO TO 280
      IL = IPIN(I)
      II = II - IL
      DO 270 J = 1,12
      II = II + 1
      KE(II) = 0.0D0
      KE(IL) = 0.0D0
      IL = IL + 12
  270 CONTINUE
      GO TO 320
  280 DO 300 J = 1,12
      JI  = 12*(J-1) + IPIN(I)
      IJ  = 12*(IPIN(I)-1) + J
      DO 290 LL = 1,12
      JLL = 12*(J-1) + LL
      ILL = 12*(IPIN(I)-1) + LL
      KEP(JLL) = KE(JLL) - (KE(ILL)/KE(II))*KE(JI)
  290 CONTINUE
      KEP(IJ ) = 0.0D0
      KEP(JI ) = 0.0D0
  300 CONTINUE
      DO 310 K = 1,144
  310 KE(K) = KEP(K)
  320 CONTINUE
C
C            E
C     STORE K       AT KEP(1),...,KEP(36)   AND
C            NPVT,A
C
C            E
C           K        AT KEP(37),...,KEP(72)
C            NPVT,B
C
  325 J = 0
      IF (IPVT .EQ. 2) GO TO 327
      ILOW = 1
      ILIM = 72
      GO TO 329
  327 ILOW = 73
      ILIM = 144
  329 DO 340 I = ILOW,ILIM,12
      LOW = I
      LIM = LOW + 5
      DO 330 K = LOW,LIM
      J = J + 1
      KEP(J   ) = KE(K  )
  330 KEP(J+36) = KE(K+6)
  340 CONTINUE
C
C                                                            T
C     STORE VECI, VECJ, VECK IN KE(1),...,KE(9) FORMING THE A  MATRIX.
C
      KE(1) = VECI(1)
      KE(2) = VECI(2)
      KE(3) = VECI(3)
      KE(4) = VECJ(1)
      KE(5) = VECJ(2)
      KE(6) = VECJ(3)
      KE(7) = VECK(1)
      KE(8) = VECK(2)
      KE(9) = VECK(3)
C
C     ZERO OUT THE ARRAY WHERE THE 3X3 MATRIX H AND THE W  AND W  6X6
C     MATRICES WILL RESIDE.                              A      B
C
      DO 350 I = 28,108
  350 KE(I) = 0.0D0
      IPASS = 1
      IWBEG = 0
C
C     SET UP POINTERS
C
      IF (IPVT-1) 365,360,365
  360 BASIC  = ABASIC
      JCSID  = JCSIDA
      OFFSET = AOFSET
      JOFSET = JOFSTA
      IKEL   = 1
      INDEX  = ISILNO(1)
      GO TO 368
  365 BASIC  = BBASIC
      JCSID  = JCSIDB
      OFFSET = BOFSET
      JOFSET = JOFSTB
      IKEL   = 37
      INDEX  = ISILNO(2)
C
C     SET UP THE -G- MATRIX. IG POINTS TO THE BEGINNING OF THE G MATRIX.
C     G = AT X TI
C
  368 IG = 1
      IF (BASIC) GO TO 370
      CALL TRANSD (ECPT(JCSID),KE(10))
      CALL GMMATD (KE(1),3,3,0, KE(10),3,3,0, KE(19))
      IG = 19
C
C     IF THERE IS A NON-ZERO OFFSET FOR THE POINT, SET UP THE D 3X3
C     MATRIX.
C
  370 IF (.NOT.OFFSET) GO TO 380
      KE(10) =  0.0D0
      KE(11) =  ECPT(JOFSET+2)
      KE(12) = -ECPT(JOFSET+1)
      KE(13) = -KE(11)
      KE(14) =  0.0D0
      KE(15) =  ECPT(JOFSET)
      KE(16) = -KE(12)
      KE(17) = -KE(15)
      KE(18) =  0.0D0
C
C     FORM THE 3X3 PRODUCT H = G X D, I.E., KE(28) = KE(IG) X KE(10)
C
      CALL GMMATD (KE(IG),3,3,0, KE(10),3,3,0, KE(28))
C
C
C     FORM THE W  MATRIX OR THE W  MATRIX IN KE(37) OR KE(73) DEPENDING
C               A                B
C     UPON WHICH POINT - A OR B - IS UNDER CONSIDERATION.  G WILL BE
C     STORED IN THE UPPER LEFT AND LOWER RIGHT CORNERS.  H, IF NON-ZERO,
C     WILL BE STORED IN THE UPPER RIGHT CORNER.
C
  380 KE(IWBEG+37) = KE(IG  )
      KE(IWBEG+38) = KE(IG+1)
      KE(IWBEG+39) = KE(IG+2)
      KE(IWBEG+43) = KE(IG+3)
      KE(IWBEG+44) = KE(IG+4)
      KE(IWBEG+45) = KE(IG+5)
      KE(IWBEG+49) = KE(IG+6)
      KE(IWBEG+50) = KE(IG+7)
      KE(IWBEG+51) = KE(IG+8)
      KE(IWBEG+58) = KE(IG  )
      KE(IWBEG+59) = KE(IG+1)
      KE(IWBEG+60) = KE(IG+2)
      KE(IWBEG+64) = KE(IG+3)
      KE(IWBEG+65) = KE(IG+4)
      KE(IWBEG+66) = KE(IG+5)
      KE(IWBEG+70) = KE(IG+6)
      KE(IWBEG+71) = KE(IG+7)
      KE(IWBEG+72) = KE(IG+8)
      IF (.NOT. OFFSET) GO TO 390
      KE(IWBEG+40) = KE(28)
      KE(IWBEG+41) = KE(29)
      KE(IWBEG+42) = KE(30)
      KE(IWBEG+46) = KE(31)
      KE(IWBEG+47) = KE(32)
      KE(IWBEG+48) = KE(33)
      KE(IWBEG+52) = KE(34)
      KE(IWBEG+53) = KE(35)
      KE(IWBEG+54) = KE(36)
C
C                       T      E
C     FORM THE PRODUCT W   X  K   AND STORE IN KEP(73)
C                       NPVT
C
  390 CALL GMMATD (KE(37),6,6,1, KEP(IKEL),6,6,0, KEP(73))
C
C     COMPUTE THE FINAL ANSWER AND STORE IN KEP(109)
C
      CALL GMMATD (KEP(73),6,6,0, KE(IWBEG+37),6,6,0, KEP(109))
C
C     INSERT THIS 6X6
C
      CALL SMA1B (KEP(109),INDEX,-1,IFKGG,0.0D0)
      IF (IOPT4.EQ.0 .OR. GSUBE.EQ.0.0) GO TO 400
      K4GGSW = 1
      CALL SMA1B (KEP(109),INDEX,-1,IF4GG,DAMPC)
C
C     IF IPASS = 2, WE ARE DONE.  OTHERWISE COMPUTE THE OFF-DIAGONAL 6X6
C
  400 IF (IPASS .EQ. 2) GO TO 500
      IWBEG = 36
      IPASS = 2
      DO 410 I = 28,36
  410 KE(I) = 0.0D0
      IF (IPVT-1) 360,365,360
  500 RETURN
C
 1010 CALL MESAGE (30,26,IECPT(1))
C
C     SET FLAG FOR FATAL ERROR WHILE ALLOWING ERROR MESSAGES TO
C     ACCUMULATE
C
      NOGO = 1
      RETURN
C
C     HEAT FORMULATION CONTINUES HERE.  GET MATERIAL PROPERTY -K- FROM
C     HMAT
C
 2000 MATFLG = 1
      MATIDC = IECPT(16)
      ELTEMP = ECPT(42)
      CALL HMAT (IELID)
C
      FL = DBLE(FK)*DBLE(ECPT(17))/FL
      IF (NPVT .EQ. IECPT(3)) FL = -FL
      DO 2020 I = 1,2
      CALL SMA1B (FL,IECPT(I+1),NPVT,IFKGG,0.0D0)
      FL = -FL
 2020 CONTINUE
      RETURN
      END

      SUBROUTINE MRED2A
C
C     THIS SUBROUTINE PARTITIONS THE STIFFNESS MATRIX INTO BOUNDARY AND
C     INTERIOR POINTS AND THEN SAVES THE PARTITIONING VECTOR ON THE SOF
C     AS THE UPRT ITEM FOR THE MRED2 MODULE.
C
C     INPUT DATA
C     GINO - USETMR   - USET TABLE FOR REDUCED SUBSTRUCTURE
C            KAA      - SUBSTRUCTURE STIFFNESS MATRIX
C
C     OUTPUT DATA
C     GINO - KBB      - KBB PARTITION MATRIX
C            KIB      - KIB PARTITION MATRIX
C            KII      - KII PARTITION MATRIX
C     SOF  - UPRT     - PARTITION VECTOR FOR ORIGINAL SUBSTRUCTURE
C
C     PARAMETERS
C     INPUT  - GBUF   - GINO BUFFER
C              INFILE - INPUT FILE NUMBERS
C              ISCR   - SCRATCH FILE NUMBERS
C              KORLEN - LENGTH OF OPEN CORE
C              KORBGN - BEGINNING ADDRESS OF OPEN CORE
C              OLDNAM - NAME OF SUBSTRUCTURE BEING REDUCED
C     OTHERS - USETMR - USETMR INPUT FILE NUMBER
C              KAA    - KAA INPUT FILE NUMBER
C              KBB    - KBB OUTPUT FILE NUMBER
C              KIB    - KIB OUTPUT FILE NUMBER
C              KII    - KII OUTPUT FILE NUMBER
C              UPRT   - KAA PARTITION VECTOR FILE NUMBER
C
      LOGICAL         BOUNDS
      INTEGER         DRY,GBUF1,OLDNAM,USRMOD,Z,UN,UB,UI,FUSET,
     1                USETMR,UPRT,EQST,MODNAM(2),ITRLR(7)
      COMMON /BLANK / IDUM1,DRY,IDUM6,GBUF1,IDUM2(5),INFILE(12),
     1                IDUM3(6),ISCR(10),KORLEN,KORBGN,OLDNAM(2),
     2                IDUM7(6),USRMOD,IDUM9,BOUNDS
      COMMON /ZZZZZZ/ Z(1)
      COMMON /BITPOS/ IDUM4(9),UN,IDUM5(10),UB,UI
      COMMON /PATX  / LCORE,NSUB(3),FUSET
      COMMON /SYSTEM/ IDUM8,IPRNTR
      EQUIVALENCE     (EQST,INFILE(4)),(USETMR,INFILE(5)),
     1                (KAA,INFILE(6)),(KBB,ISCR(1)),(KIB,ISCR(2)),
     2                (KII,ISCR(3)),(UPRT,ISCR(5))
      DATA    MODNAM/ 4HMRED,4H2A  /
      DATA    ITEM  / 4HUPRT/
C
C     LOCATE PARTITIONING VECTOR
C
      IF (DRY .EQ. -2) GO TO 100
      IF (BOUNDS) GO TO 10
      LCORE = KORLEN
      FUSET = USETMR
      CALL CALCV (UPRT,UN,UI,UB,Z(KORBGN))
      GO TO 20
   10 CALL MTRXI (UPRT,OLDNAM,ITEM,0,ITEST)
      IF (ITEST .NE. 1) GO TO 30
      ITRLR(1) = EQST
      CALL RDTRL (ITRLR)
      NSUB(1) = ITRLR(6)
      NSUB(2) = ITRLR(7)
C
C     PARTITION STIFFNESS MATRIX
C
C                  **         **
C                  *     .     *
C        **   **   * KBB . KBI *
C        *     *   *     .     *
C        * KAA * = *...........*
C        *     *   *     .     *
C        **   **   * KIB . KII *
C                  *     .     *
C                  **         **
C
   20 CONTINUE
      CALL GMPRTN (KAA,KII,0,KIB,KBB,UPRT,UPRT,NSUB(1),NSUB(2),
     1             Z(KORBGN),KORLEN)
C
C     SAVE PARTITIONING VECTOR
C
      IF (BOUNDS) GO TO 25
      CALL MTRXO (UPRT,OLDNAM,ITEM,0,ITEST)
      IF (ITEST .NE. 3) GO TO 30
   25 CONTINUE
      GO TO 100
C
C     PROCESS MODULE FATAL ERRORS
C
   30 GO TO (40,45,50,55,60,80), ITEST
   40 IMSG = -9
      GO TO 90
   45 IMSG = -11
      GO TO 90
   50 IMSG = -1
      GO TO 70
   55 IMSG = -2
      GO TO 70
   60 IMSG = -3
   70 CALL SMSG (IMSG,ITEM,OLDNAM)
      GO TO 100
   80 IMSG = -10
   90 DRY = -2
      CALL SMSG1 (IMSG,ITEM,OLDNAM,MODNAM)
  100 RETURN
C
      END

      SUBROUTINE QDMM2 (TEMPS,PG)
C
C     THERMAL LOAD GENERATION FOR THE QDMEM2 ELEMENT.
C
C     ELEMENT EST ENTRY CONTENTS
C     + + + + + + + + + + + + + + + + + + + + + + + + + +
C     +   1 = ID                                        +
C     +   2 = SIL-PT-A            (ELEMENT CONNECTS     +
C     +   3 = SIL-PT-B             GRID POINTS A,B,     +
C     +   4 = SIL-PT-C             C,D IN THAT ORDER)   +
C     +   5 = SIL-PT-D                                  +
C     +   6 = MATERIAL-ANGLE                            +
C     +   7 = MATERIAL-ID                               +
C     +   8 = THICKNESS OF ELEMENT                      +
C     +   9 = NON-STRUCTURAL-MASS                       +
C     +  10 = COORD-SYS-ID PT-A OR 0                    +
C     +  11 = XA                                        +
C     +  12 = YA                                        +
C     +  13 = ZA                                        +
C     +  14 = COORD-SYS-ID PT-B OR 0                    +
C     +  15 = XB                                        +
C     +  16 = YB                                        +
C     +  17 = ZB                                        +
C     +  18 = COORD-SYS-ID PT-C OR 0                    +
C     +  19 = XC                                        +
C     +  20 = YC                                        +
C     +  21 = ZC                                        +
C     +  22 = COORD-SYS-ID PT-D OR 0                    +
C     +  23 = XD                                        +
C     +  24 = YD                                        +
C     +  25 = ZD                                        +
C     +  26 = AVERAGE OF CONNECTED GRID TEMPERATURES    +
C     + + + + + + + + + + + + + + + + + + + + + + + + + +
C
      LOGICAL         PLANAR
      INTEGER         NEST(7),MAP(4,3)
      REAL            RMAT(3,5),ET(9),K5SUM(9,5),ISINTH,KMAT(27),
     1                ITEMP9(9),ALPHA(3),PMAT(9),JTEMP9(9),ICOSTH,
     2                GSUBE(9),TEMPS(1),PG(1),PSUM(3,5),IT
      CHARACTER       UFM*23,UWM*25
      COMMON /XMSSG / UFM,UWM
      COMMON /MATIN / MATID, INFLAG, ELTEMP, STRESS, SINTH, COSTH
      COMMON /MATOUT/ G11,G12,G13,G22,G23,G33, RHO, ALPS(3), TSUB0
      COMMON /SYSTEM/ KSYSTM(65)
      COMMON /TRIMEX/ EST(26)
      COMMON /CONDAS/ PI,TWOPI,RADEG,DEGRA,S4PISQ
      EQUIVALENCE     (KSYSTM(2),IOUTPT),(NEST(1),EST(1))
      DATA    MAP   / 1, 2, 3, 4,
     1                2, 3, 4, 1,
     2                5, 5, 5, 5 /
C
C     COMPUTE BASIC SIN AND COSINE OF ELEMENT MATERIAL ANGLE.
C
      ANGL   = EST(6)*DEGRA
      ISINTH = SIN(ANGL)
      ICOSTH = COS(ANGL)
C
C     COMPUTE GSUBE MATRIX
C
      INFLAG = 2
      MATID  = NEST(7)
      ELTEMP = EST(26)
      SINTH  = 0.0
      COSTH  = 1.0
      CALL MAT (NEST(1))
      GSUBE(1) = G11
      GSUBE(2) = G12
      GSUBE(3) = G13
      GSUBE(4) = G12
      GSUBE(5) = G22
      GSUBE(6) = G23
      GSUBE(7) = G13
      GSUBE(8) = G23
      GSUBE(9) = G33
C
C     FORM  ALPHA = ALPS *(T-T )  3X1 VECTOR USED IN SUB-TRIANGLE CALCS
C                       E     0
C
      TBAR     = TEMPS(1) - TSUB0
      ALPHA(1) = ALPS(1)*TBAR
      ALPHA(2) = ALPS(2)*TBAR
      ALPHA(3) = ALPS(3)*TBAR
C
C     NOTE THE ABOVE MAY BE MOVED TO BELOW AND COMPUTED USING THE
C     GRID TEMPS OF SUB-TRIANGLE.  (I.E. TOTAL AVERAGE FOR CENTER POINT
C     ONLY.)  AVERAGE OF WHOLE ELEMENT IS USED EXCLUSIVELY NOW.
C
C     BASIC WHOLE-ELEMENT CALCULATIONS
C
      CALL Q2BCS (EST,PLANAR,RMAT,ET,IERROR)
      IF (IERROR) 10,10,140
C
C     ZERO SUMMATION ARRAYS
C
   10 DO 30 I = 1,5
      DO 20 J = 1,9
      K5SUM(J,I) = 0.0
   20 CONTINUE
      PSUM(1,I) = 0.0
      PSUM(2,I) = 0.0
      PSUM(3,I) = 0.0
   30 CONTINUE
C
C     SUB-TRIANGLE COMPUTATIONS AND SUMMATIONS.
C
      DO 70 I = 1,4
      IA = MAP(I,1)
      IB = MAP(I,2)
      IC = MAP(I,3)
      IT = EST(8)
      CALL Q2TRMS (RMAT(1,IA),RMAT(1,IB),RMAT(1,IC),ALPHA(1),ISINTH,
     1             ICOSTH,GSUBE,IT,IERROR,2,KMAT,PMAT,DUMMY,DUMMY)
      IF (IERROR) 40,40,140
C
C     SUM IN KCA,KCB,KCC
C
   40 DO 50 K = 1,9
      K5SUM(K,IA) = K5SUM(K,IA) + KMAT(K   )
      K5SUM(K,IB) = K5SUM(K,IB) + KMAT(K+ 9)
      K5SUM(K,IC) = K5SUM(K,IC) + KMAT(K+18)
   50 CONTINUE
C
C     SUM IN PA,PB,PC
C
      DO 60 K = 1,3
      PSUM(K,IA) = PSUM(K,IA) + PMAT(K  )
      PSUM(K,IB) = PSUM(K,IB) + PMAT(K+3)
      PSUM(K,IC) = PSUM(K,IC) + PMAT(K+6)
   60 CONTINUE
C
   70 CONTINUE
C
C     IF -PLANAR- MODIFY THE K5SUM MATRICES.
C
      IF (.NOT.PLANAR) GO TO 90
      DO 80 I = 1,5
      K5SUM(7,I) = 0.0
      K5SUM(8,I) = 0.0
      K5SUM(9,I) =-0.25
   80 CONTINUE
      K5SUM(9,5) = 1.0
C
C     INVERT K   AND NEGATE THE RESULT.
C             55
C
   90 CONTINUE
C
C     NO NEED TO COMPUTE DETERMINANT SINCE IT IS NOT USED SUBSEQUENTLY.
C
      ISING = -1
      CALL INVERS (3,K5SUM(1,5),3,DUMMY,0,DETERM,ISING,ITEMP9)
      IF (ISING .EQ. 2) GO TO 140
C
      DO 100 I = 1,9
      K5SUM(I,5) = -K5SUM(I,5)
  100 CONTINUE
C
C     4 (3X1) LOAD VECTORS ARE COMPUTED AND ADDED INTO THE P-VECTOR IN
C     CORE
C
C       G        T   T                  -1      T
C     (P ) = (T ) (E) ((PSUM ) + ((-K  ) (K  )) (PSUM ))
C       I      I            I        55    5I        5
C
      DO 130 I = 1,4
      CALL GMMATS (K5SUM(1,5),3,3,0,K5SUM(1,I),3,3,0,ITEMP9)
      CALL GMMATS (ITEMP9,3,3,1,PSUM(1,5),3,1,0,JTEMP9)
      DO 110 J = 1,3
      PSUM(J,I) = PSUM(J,I) + JTEMP9(J)
  110 CONTINUE
      CALL GMMATS (ET,3,3,1,PSUM(1,I),3,1,0,JTEMP9)
      JTEMP9(4) = 0.0
      JTEMP9(5) = 0.0
      JTEMP9(6) = 0.0
      K = 4*I + 6
      IF (NEST(K) .NE. 0) CALL BASGLB (JTEMP9,JTEMP9,NEST(K+1),NEST(K))
C
C     ADD LOAD TO CORE FOR THIS GRID
C                                   I
      L = NEST(I+1)
      DO 120 J = 1,3
      PG(L) = PG(L) + JTEMP9(J)
      L = L + 1
  120 CONTINUE
C
  130 CONTINUE
      RETURN
C
C     ERROR CONDITIONS
C
  140 WRITE  (IOUTPT,150) UWM,NEST(1)
  150 FORMAT (A25,' 3100, ELEMENT THERMAL LOAD COMPUTATION FOR QDMEM2 ',
     1       'ELEMENT ID =',I9, /5X,'FINDS ILLEGAL GEOMETRY THUS NO ',
     2       'LOADS OUTPUT FOR ELEMENT-ID NOTED.')
      RETURN
      END

      SUBROUTINE SETINP
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL         RSHIFT,COMPLF
      REAL             FWRD
      DOUBLE PRECISION DWRD
      DIMENSION        NAME(2),EL(1),GP(1),CARD(65),TYP(100),AWRD(2),
     1                 PCARD(20),POCARD(200)
      CHARACTER        UFM*23,UWM*25,UIM*29
      COMMON /XMSSG /  UFM,UWM,UIM
      COMMON /BLANK /  SKP11,NSETS,SKP12(8),PCDB,SKP2(9),
     1                 MERR,PLOT,MSETID,SKP3(7),MSET,IPCDB
      COMMON /SYSTEM/  BUFSIZ,NOUT,NOGO,NIN,NSK(81),INTR
      COMMON /GPTA1 /  NTYPES,LAST,INCR,NE(1)
      COMMON /ZZZZZZ/  X(1)
      EQUIVALENCE      (X(1),EL(1),GP(1))
      EQUIVALENCE      (WORD,AWRD(1),IWRD,FWRD,DWRD)
      DATA    INPREW,  OUTREW,REW,NOREW,EOR / 0, 1, 1, 3, 1000000      /
      DATA    BLNK  ,  STOP,GO,NAME /4H    ,4HSTOP,4HGO  ,4H SET,3HINP /
      DATA    SET   ,  INCL,  EXCL,  ELEM,  GRID,  POIN,  EXCE,  TO    /
     1        3HSET ,  4HINCL,4HEXCL,4HELEM,4HGRID,4HPOIN,4HEXCE,2HTO  /
      DATA    THRU  ,  ALL,    ILXX /4HTHRU,3HALL, 2HXX /
C
      CALL DELSET
      B1 = KORSZ(X) - 5*BUFSIZ + 1
      B2 = B1 + BUFSIZ
      B3 = B2 + BUFSIZ
      B4 = B3 + BUFSIZ
      NOGO  = 0
      ORG   = 0
      PORG  = -1
      ALLON = COMPLF(0)
      POCARD(200) = RSHIFT(ALLON,1)
      ENCARD = POCARD(200)
C
C     OPEN ALL NECESSARY FILES
C
      IOREW = INPREW
      IF (INTR .LE. 0) GO TO 10
      PCDB  = IPCDB
      IOREW = OUTREW
   10 CALL OPEN (*210,PCDB,X(B1),IOREW)
      IF (INTR .LE. 0) GO TO 50
C
      WRITE (NOUT,270)
   20 DO 25 J = 1,20
   25 PCARD(J) = BLNK
      DO 26 J = 1,199
   26 POCARD(J) = BLNK
      CALL XREAD (*28,PCARD)
      IF (PCARD(1) .EQ. STOP) GO TO 220
      IF (PCARD(1) .EQ.   GO) GO TO 40
      CALL XRCARD (POCARD,199,PCARD)
      CALL IFP1PC (1,ICONT,POCARD,ORG,PORG)
      IF (NOGO .EQ. 0) GO TO 30
      NOGO = 0
   28 WRITE (NOUT,300)
      GO TO 20
   30 WRITE (1,290) PCARD
      IE = 1
      DO 33 J = 1,199
      IF (POCARD(J) .NE. 0) GO TO 32
      DO 31 JC = 1,5
   31 IF (POCARD(J+JC) .NE. BLNK) GO TO 32
      NW = J
      GO TO 34
   32 IF (POCARD(J) .NE. ENCARD) GO TO 33
      NW = J
      GO TO 34
   33 CONTINUE
      NW = 80
   34 CALL WRITE (PCDB,POCARD,NW,IE)
      GO TO 20
   40 CALL CLOSE (PCDB,REW)
      IF (INTR .GT. 10) NOUT = 1
      CALL OPEN (*210,PCDB,X(B1),INPREW)
   50 IF (INTR .LE. 0) CALL FREAD (PCDB,0,-2,1)
      CALL GOPEN (PLOT,X(B2),OUTREW)
      CALL GOPEN (MSET,X(B3),OUTREW)
      CALL GOPEN (MSETID,X(B4),OUTREW)
      CALL RDMODX (PCDB,MODE,WORD)
C
C     READ MODE FLAG.  SHOULD BE ALPHABETIC
C
  100 CALL READ (*200,*200,PCDB,MODE,1,0,I)
      IF (MODE) 101,100,102
  101 I = 1
      IF (MODE .EQ. -4) I = 2
      CALL FREAD (PCDB,0,-I,0)
      GO TO 100
  102 IF (MODE .LT. EOR) GO TO 103
      CALL FREAD (PCDB,0,0,1)
      GO TO 100
  103 MODE = MODE + 1
      CALL RDWORD (MODE,WORD)
      CALL RDWORD (MODE,WORD)
      IF (WORD.EQ.SET .AND. MODE.EQ.0) GO TO 115
C
C     THIS CARD IS A PLOT CONTROL CARD
C
  105 CALL BCKREC (PCDB)
  106 CALL READ (*200,*110,PCDB,CARD,65,1,I)
      WRITE  (NOUT,108)
  108 FORMAT ('  ARRAY CARD OF 65 TOO SAMLL')
      CALL MESAGE (-37,0,NAME)
  110 CALL WRITE (PLOT,CARD,I,1)
      IF (CARD(I)) 100,106,100
C
C     THIS CARD DEFINES A NEW SET
C
  115 ASSIGN 116 TO TRA
      CALL RDMODE (*250,*105,*100,MODE,WORD)
  116 SETID = IWRD
      NELX  = 0
      NGPX  = B1
      NT    = 0
      XX    = 1
      ELGP  = 0
C
      IF (MODE .LE. 0) CALL RDMODE (*136,*121,*175,MODE,WORD)
  121 CALL RDWORD (MODE,WORD)
C
C     CHECK FOR AN -INCLUDE- OR -EXCLUDE- CARD
C
  125 IF (WORD.NE.INCL .AND. WORD.NE.EXCL .AND. WORD.NE.EXCE) GO TO 128
  126 IF (WORD .EQ. INCL) XX = 1
      IF (WORD .EQ. EXCL) XX =-1
      IF (WORD .EQ. EXCE) XX =-XX
      IF (MODE.EQ.0) CALL RDMODE (*136,*127,*175,MODE,WORD)
  127 CALL RDWORD (MODE,WORD)
  128 IF (WORD .EQ. GRID) GO TO 131
      IF (WORD .NE. ELEM) GO TO 147
C
C     ELEMENTS ARE TO BE INCLUDED OR EXCLUDED (BY ID OR TYPE)
C
      ELGP = 0
      IF (MODE) 136,135,121
C
C     A LIST OF GRID POINTS IS TO BE INCLUDED OR EXCLUDED (PERTAIN ONLY
C     TO DEFORMED PLOTS)
C
  131 IF (MODE .LE. 0) CALL RDMODE (*131,*132,*175,MODE,WORD)
  132 CALL RDWORD (MODE,WORD)
      IF (WORD.NE.POIN .OR. MODE.NE.0) GO TO 125
      ELGP = 1
C
C     A LIST OF ELEMENT OR GRID POINT ID-S CAN BE EXPLICITLY LISTED, OR
C     PREFERABLY A RANGE CAN BE SPECIFIED (SEPARATED BY THE WORD -TO-
C     OR -THRU-)
C
  135 CALL RDMODE (*136,*121,*175,MODE,WORD)
  136 ASSIGN 137 TO TRA
      GO TO 250
  137 IF (NELX+1 .GE. NGPX) CALL MESAGE (-8,0,NAME)
      IF (ELGP .NE. 0) GO TO 138
      NELX = NELX + 1
      EL(NELX) = ISIGN(IWRD,XX)
      GO TO 140
  138 NGPX = NGPX - 1
      GP(NGPX) = ISIGN(IWRD,XX)
C
  140 CALL RDMODE (*250,*141,*175,MODE,WORD)
  141 CALL RDWORD (MODE,WORD)
      IF (WORD.NE.TO .AND. WORD.NE.THRU) GO TO 125
      IF (MODE .NE. 0) GO TO 125
      ASSIGN 142 TO TRA
      CALL RDMODE (*250,*125,*175,MODE,WORD)
  142 IF (NELX+2 .GE. NGPX) CALL MESAGE (-8,0,NAME)
      IF (ELGP .NE. 0) GO TO 143
      EL(NELX+1) = TO
      EL(NELX+2) = IWRD
      NELX = NELX + 2
      GO TO 135
  143 GP(NGPX-1) = TO
      GP(NGPX-2) = ISIGN(IWRD,XX)
      NGPX = NGPX - 2
      GO TO 135
C
C     AN ELEMENT TYPE CAN BE INCLUDED OR EXCLUDED
C
  145 IF (MODE .LE. 0) CALL RDMODE (*136,*146,*175,MODE,WORD)
  146 CALL RDWORD (MODE,WORD)
  147 IF (WORD.EQ.INCL .OR. WORD.EQ.EXCL .OR. WORD.EQ.EXCE) GO TO 126
      IF (WORD.EQ.GRID .OR. WORD.EQ.ELEM) GO TO 128
      IF (WORD .NE. ALL) GO TO 150
      I  = NTYPES + 1
  149 NT = NT + 2
C
C     SECOND WORD FOR EACH TYP LOCATES ELEMENT INCLUDE/EXCLUDE SEARCH
C     POINTER.  ELEMENT ID-S GIVEN PRIOR TO NELX ARE SKIPPED
C
      TYP(NT-1) = ISIGN(I,XX)
      TYP(NT  ) = NELX + 1
      ELGP = 0
      GO TO 145
C
  150 DO 151 I = 1,NTYPES
      IDX = (I-1)*INCR
C
C     SKIP ELEMENTS WITH
C       1 GRID
C       SCALAR CONNECTIONS POSSIBLE
C       SPECIAL PLOTTER MNEMONIC OF -XX-
C
      IF (NE(IDX+10).LE.1 .OR. NE(IDX+11).NE.0) GO TO 151
      IF (NE(IDX+16) .EQ. ILXX) GO TO 151
      IF (AWRD(1).EQ.NE(IDX+1) .AND. AWRD(2).EQ.NE(IDX+2)) GO TO 149
  151 CONTINUE
      WRITE  (NOUT,155) UFM,AWRD
  155 FORMAT (A23,' 699,',2A4,' ELEMENT IS INVALID')
      NOGO = 1
      ELGP = 0
      GO TO 145
C
C     A SET HAS BEEN COMPLETELY DEFINED.  FIRST, WRITE THE SET ID
C
  175 IF (NELX.EQ.0 .AND. NT.EQ.0) GO TO 100
      CALL WRITE (MSETID,SETID,1,0)
      CALL WRITE (MSET,SETID,1,0)
C
C     WRITE THE SET OF EXPICIT ELEMENT ID-S
C
      CALL WRITE (MSET,NELX,1,0)
      CALL WRITE (MSET,EL,NELX,0)
C
C     DELETE ALL ELEMENT TYPE DUPLICATES + WRITE REMAINING ONES
C
      N = 0
      IF (NT .EQ. 0) GO TO 178
      DO 177 J = 1,NT,2
      XX = TYP(J)
      IF (XX .EQ. 0) GO TO 177
      DO 176 I = J,NT,2
      IF (I.EQ.J .OR. IABS(XX).NE.IABS(TYP(I))) GO TO 176
C
C     DELETE BOTH IF NEGATIVE OF OTHER
C
      IF (XX .EQ. -TYP(I)) TYP(J) = 0
      TYP(I) = 0
  176 CONTINUE
      IF (TYP(J) .EQ. 0) GO TO 177
      N = N + 2
      TYP(N-1) = XX
      TYP(N  ) = TYP(J+1)
  177 CONTINUE
  178 CALL WRITE (MSET,N,1,0)
      CALL WRITE (MSET,TYP,N,0)
C
C     WRITE THE SET OF EXPLICIT GRID POINT ID-S
C
      N = B1 - NGPX
      CALL WRITE (MSET,N,1,0)
      CALL WRITE (MSET,GP(NGPX),N,1)
      NSETS = NSETS + 1
      GO TO 100
C
C     END OF -PCDB-
C
  200 CALL CLSTAB (MSET,REW)
      CALL CLSTAB (PLOT,REW)
      CALL CLSTAB (MSETID,NOREW)
      CALL CLOSE  (PCDB,REW)
      IF (NSETS .EQ. 0) WRITE (NOUT,205) UIM
  205 FORMAT (A29,', NO SETS EXIST IN PLOT PACKAGE')
      IF (NOGO .NE. 0) CALL MESAGE (-61,0,0)
  210 RETURN
  220 NOGO = 1
      RETURN
C
C     READ AN INTEGER
C
  250 IF (MODE .EQ. -1) GO TO 260
      IF (MODE .EQ. -4) IWRD = DWRD
      IF (MODE .NE. -4) IWRD = FWRD
  260 GO TO TRA, (116,137,142)
C
  270 FORMAT (' ENTER PLOT DEFINITION OR ''GO'' IF DONE.')
  290 FORMAT (20A4)
  300 FORMAT (' BAD CARD TRY AGIAN')
      END

      SUBROUTINE GENVEC (*,IBUF,FILEA,NX,IX,NCOL,B,BBAR,C,CBAR,R,IENTRY)
C
C     GENVEC WILL PICK THE OPTIMUM VALUE OF B AND BBAR FOR A GIVEN
C     MATRIX
C
      INTEGER         FILEA(1)  ,NAME(2)  ,BMAX     ,CMAX     ,
     1                IX(2)     ,RSP      ,EOL      ,SYSBUF   ,
     2                B         ,BBAR     ,C        ,CBAR     ,
     3                R         ,BB       ,CC       ,BBR      ,
     4                CCR       ,RRR      ,BBR1     ,CCR1     ,
     5                BBR2      ,CCR2     ,RR1      ,RR2      ,
     6                P         ,DBNAME(2),FINDC    ,NAMIN(2,2)
      DIMENSION       IBUF(1)   ,XMB(2)
      CHARACTER       UFM*23    ,UWM*25   ,UIM*29
      COMMON /XMSSG / UFM       ,UWM      ,UIM
      COMMON /NAMES / RD        ,RDREW    ,WRT      ,WRTREW   ,
     1                REW       ,NOREW    ,EOFNRW   ,RSP
      COMMON /ZNTPKX/ IA(4)     ,II       ,EOL
C     COMMON /DESCRP/ LENGTH    ,MAJOR(1)
      COMMON /NTIME / LNTIME    ,TCONS(15)
      COMMON /SYSTEM/ ISTV(65)
      COMMON /DCOMPX/ DUM(35)   ,ISYM
      EQUIVALENCE     (ISTV( 1),SYSBUF)   ,(ISTV( 2),NOUT  )  ,
     1                (ISTV(55),P     )   ,(TCONS(8),XMB(1))
      DATA    NAME  / 4HGENV,4HEC  /  ,CMAX / 200 /,
     1        NAMIN / 4H REA,1HL   ,4HCOMP,3HLEX  /
C
C
      CALL FNAME (FILEA,DBNAME)
      CALL SSWTCH (11,L11)
      IF (L11 .NE. 0) WRITE (NOUT,6) FILEA
    6 FORMAT ('O*** DIAG 11 OUTPUT FROM GENVEC (UNSYMMETRIC DECOMP) FOR'
     1,       ' FILE',I6 , /9X,1HB,6X,4HBBAR,9X,1HC,6X,4HCBAR,9X,1HR,3X,
     2        4HTIME )
C
      BMAX = MIN0(IFIX(1.0E+05/SQRT(FLOAT(NCOL)*XMB(P))),NCOL)
      IFILE= FILEA(1)
      CALL OPEN (*280,FILEA(1),IBUF,RDREW)
      I1   = NCOL
      I4   = 4*NCOL + 2*CMAX
      ICRQ = I4 - NX + SYSBUF
      IF (I4 .GT. NX-SYSBUF) GO TO 300
      DO 10 I = 1,I4
   10 IX(I) = 0
      NMAX  = 0
      MMAX  = 0
      CALL FWDREC (*290,FILEA(1))
C
C     GENERATE THE ROW AND COLUMN VECTORS
C
      DO 60 I = 1,NCOL
      CALL INTPK (*320,FILEA(1),0,RSP,0)
      CALL ZNTPKI
      IN1  = I1 + I
      IX(IN1) = II
      NMAX = MAX0(NMAX,I-II+1)
   20 IF (IX(II)) 40,30,40
   30 IX(II) = I
      MMAX = MAX0(MMAX,II-I+1)
   40 IF (EOL) 60,50,60
   50 CALL ZNTPKI
      GO TO 20
   60 CONTINUE
      CALL CLOSE (FILEA(1),REW)
      I2   = I1 + NCOL + 1
      I3   = I2 + 2*NCOL
      NMAX = MIN0(NMAX,BMAX)
      MMAX = MIN0(MMAX,BMAX)
      MMAX = MAX0(MMAX,2)
C
C     SET UP ACTIVE COLUMN BANDWIDTH VECTOR
C
      DO 100 I = 2,NCOL
      J = NCOL - I + 1
      ICOUNT = 0
      DO 90 K = 1,J
      L = I2 - K
      IF (IX(L)-I) 70,80,80
   70 ICOUNT = ICOUNT + 1
   80 L = I2 + (J-K)*2
   90 IX(L) = MAX0(IX(L),ICOUNT)
  100 CONTINUE
C
C     REDUCE LIST TO UNIQUE PAIRS
C
      I = I2
      J = I2 + 2
      K = 2
  110 IF (IX(J) .EQ. 0) GO TO 140
      IF (IX(J) -IX(I)) 120,130,120
  120 I = I + 2
      IX(I  ) = IX(J)
      IX(I+1) = K
  130 J = J + 2
      K = K + 1
      GO TO 110
  140 CONTINUE
      I = I + 2
      IX(I  ) = 0
      IX(I+1) = K
      ILAST   = 0
C
C     BEGIN SEARCH FOR B,BBAR
C
      TIME = 1000000.
      B    = 0
      BBAR = 0
      C    = 0
      CBAR = 0
  150 BB = IX(I+1)
      IF (BB .LE. BMAX) GO TO 155
      I  = I - 2
      GO TO 150
  155 CONTINUE
C
C    MAKE PRELIMINARY SEARCH
C
      TT1 = 1000000.
  156 CONTINUE
      BB  = IX(I+1)
      CC  = IX(I) + 1
      IF (CC .EQ. 1) CC = 0
      BBR = BB
      CCR = CC
      CALL RCORE (BB,BBR,CC,CCR,NCOL,IENTRY,NX,RRR)
      RRR = MIN0(RRR,BB+BBR-1,NCOL-1)
      IF (RRR .LT. 2) GO TO 157
      CALL TIMEEQ (FLOAT(BB),FLOAT(BBR),FLOAT(CC),FLOAT(CCR),FLOAT(RRR),
     1             IENTRY,NCOL,TT)
      IF (ILAST .EQ. 0) ILAST = I
      IF (L11   .EQ. 0) GO TO 1500
      WRITE  (NOUT,151) BB,BBR,CC,CCR,RRR,TT
  151 FORMAT (5I10,F10.2)
 1500 CONTINUE
      IF (TT .GT. TT1) GO TO 157
      TT1  = TT
      BBR1 = BBR
      CCR1 = CCR
      RR1  = RRR
  157 I    = I - 2
      IF (BB .LT.   3) GO TO 158
      IF (I .GE. I2+2) GO TO 156
  158 CONTINUE
      I  = I + 2
      IF (TT1 .EQ. 1000000.)GO TO 300
      BB = BBR1
      CC = CCR1
      TT1= 1000000.
C
C     SEARCH ON INCREASING BBAR
C
  159 BBR = BB
      INCRXX = MAX1(.02*FLOAT(BB),1.)
  160 CCR = FINDC(BB,BBR,NCOL,IX(1),IX(I3))
      CALL RCORE (BB,BBR,CC,CCR,NCOL,IENTRY,NX,RRR)
      RRR = MIN0(RRR,BB+BBR-1)
      RRR = MIN0(RRR,NCOL-1)
      IF (RRR .LT. 2) GO TO 170
      CALL TIMEEQ (FLOAT(BB),FLOAT(BBR),FLOAT(CC),FLOAT(CCR),FLOAT(RRR),
     1             IENTRY,NCOL,TT)
      IF (L11 .EQ. 0) GO TO 1600
      WRITE (NOUT,151) BB,BBR,CC,CCR,RRR,TT
 1600 CONTINUE
      IF (TT1 .EQ. 1000000.) TT1 = TT
      IF (TT  .GT. TT1) GO TO 170
      TT1  = TT
      BBR1 = BBR
      CCR1 = CCR
      RR1  = RRR
  170 CONTINUE
      BBR = BBR + INCRXX
      IF (TT .GT. 1.2*TT1) GO TO 180
      IF (CCR  .EQ.     0) GO TO 180
      IF (BBR  .LT.  BMAX) GO TO 160
C
C     BEGIN SEARCH ON DECREASING BBAR
C
  180 TT2 = 1000000.
      BBR = BB - INCRXX
  190 IF (BBR .LE. 2 ) GO TO 210
      CCR = FINDC(BB,BBR,NCOL,IX(1),IX(I3))
      CALL RCORE (BB,BBR,CC,CCR,NCOL,IENTRY,NX,RRR)
      RRR = MIN0(RRR,BB+BBR-1)
      RRR = MIN0(RRR,NCOL-1)
      IF (RRR .LT. 2) GO TO 200
      CALL TIMEEQ (FLOAT(BB),FLOAT(BBR),FLOAT(CC),FLOAT(CCR),FLOAT(RRR),
     1             IENTRY,NCOL,TT)
      IF (L11 .EQ. 0) GO TO 195
      WRITE (NOUT,151) BB,BBR,CC,CCR,RRR,TT
  195 CONTINUE
      IF (TT2 .EQ. 1000000.) TT2 = TT
      IF (TT  .GT. TT2) GO TO 200
      TT2  = TT
      BBR2 = BBR
      CCR2 = CCR
      RR2  = RRR
  200 CONTINUE
      BBR  = BBR - INCRXX
      IF (TT .GT. 1.20*TT2) GO TO 210
      GO TO 190
  210 CONTINUE
      IF (TT1 .GE. TIME) GO TO 220
      TIME = TT1
      B    = BB
      C    = CC
      BBAR = BBR1
      CBAR = CCR1
      R    = RR1
  220 IF (TT2 .GE. TIME) GO TO 230
      TIME = TT2
      B    = BB
      C    = CC
      BBAR = BBR2
      CBAR = CCR2
      R    = RR2
  230 IF (TT1.EQ.1000000. .AND. TT2.EQ.1000000.) GO TO 275
      IB = B
      IC = C
      IBBAR = BBAR
      ICBAR = CBAR
      IR    = R
      IX(1) = C
      IX(2) = R
      CALL PAGE2 (4)
      WRITE  (NOUT,240) UIM,B,BBAR,C,CBAR,R
  240 FORMAT (A29,' 3028',6X,3HB =,I5,5X,6HBBAR =,I5, /40X,3HC =,I5,5X,
     1       6HCBAR =,I5, /40X,3HR =,I5)
      CALL TFIN (FLOAT(B),FLOAT(BBAR),FLOAT(C),FLOAT(CBAR),FLOAT(R),
     1           IENTRY,FLOAT(NCOL),TIME)
      IX(1) = TIME
      CALL PAGE2 (3)
      WRITE  (NOUT,250) UIM,NAMIN(1,IENTRY),NAMIN(2,IENTRY),DBNAME,NCOL,
     1                  IX(1)
  250 FORMAT (A29,' 3027, UNSYMMETRIC ',2A4,' DECOMPOSITION OF DATA ',
     1       'BLOCK ',2A4,6H (N = ,I5,1H), /5X,'TIME ESTIMATE = ',I8,
     2       8H SECONDS)
      CALL TMTOGO (IXY)
      IF (IXY .LT. IX(1)) CALL MESAGE (-50,IX(1),NAME)
      RETURN
C
C     TRY TO FIND POSSIBLE SOLUTION WITHIN FEASIBLE RANGE BY VARYING  BB
C
  275 I  = I + 2
      IF (I .GT. ILAST) GO TO 300
      BB = IX(I+1)
      CC = IX(I) + 1
      IF (BB .GT. BMAX) GO TO 300
      GO TO 159
  280 NO = -1
      GO TO 310
  290 NO = -2
      GO TO 310
  300 NO = -8
      IFILE = ICRQ
  310 CALL MESAGE (NO,IFILE,NAME)
      RETURN
C
C     NULL COLUMN DISCOVERED
C
  320 WRITE  (NOUT,325) UFM,I,NAMIN(1,IENTRY),NAMIN(2,IENTRY)
  325 FORMAT (A23,' 3097, COLUMN',I7,' IS SINGULAR.  UNSYMMETRIC ',2A4,
     1       'DECOMP ABORTED.')
      RETURN 1
C
      END

      SUBROUTINE GFSMOD
C
C     THIS ROUTINE PERFORMS THE MODAL FORMULATION OF THE
C     FLUID / STRUCTURE MATRICES
C
      EXTERNAL        ANDF
      INTEGER         SCR1     ,SCR2     ,SCR3     ,SCR4     ,SCR5     ,
     1                SCR6     ,SCR7     ,SCR8     ,SCR9     ,SCR10    ,
     2                AXY      ,AFRY     ,KYY      ,DKAA     ,DKFRFR   ,
     3                USETF    ,PHIA     ,PHIX     ,AC       ,POUT     ,
     4                LAMA     ,KMAT     ,MMAT     ,GIA      ,PVEC     ,
     5                IDENT    ,USET     ,USETD    ,KC       ,H        ,
     6                COMPTP   ,AZY      ,AHY      ,AHJ      ,AJH      ,
     7                KJJ      ,AYH      ,KJJL     ,GJH      ,MZZ      ,
     8                KZZ      ,MHHBAR   ,PHIAR    ,KZZBAR   ,KHHBAR   ,
     9                GYH      ,MCB(7)   ,SFBIT    ,FILE     ,UM       ,
     1                UZ       ,UNZ      ,UFR      ,UH       ,UY       ,
     2                UF       ,US       ,UI       ,Z        ,SYSBUF   ,
     3                TWO      ,TYPIN    ,TYPOUT   ,BADD(11) ,NAME(2)  ,
     4                PHIXR    ,ANDF     ,NAMEX(2)
      REAL            RZ(1)
      DOUBLE PRECISION          DBADD(5)
      CHARACTER       UFM*23   ,UWM*25
      COMMON /XMSSG / UFM      ,UWM
      COMMON /BLANK / NOGRAV   ,NOFREE   ,KCOMP    ,COMPTP   ,FORM     ,
     1                LLMODE
      COMMON /SYSTEM/ SYSBUF   ,NOUT
      COMMON /PATX  / LCORE    ,NSUB0    ,NSUB1    ,NSUB2    ,USET
      COMMON /ZZZZZZ/ Z(1)
      COMMON /PACKX / TYPIN    ,TYPOUT   ,II       ,NN       ,INCR
      COMMON /TWO   / TWO(32)
      COMMON /BITPOS/ UNZ      ,UZ       ,UM       ,UH       ,BIT1(3)  ,
     1                UF       ,US       ,BIT2(15) ,UY       ,UFR      ,
     2                BIT3(2)  ,UI
      COMMON /GFSMOX/ AXY      ,AFRY     ,KYY      ,DKAA     ,DKFRFR   ,
     1                USETF    ,PHIA     ,PHIX     ,LAMA     ,
     2                KMAT     ,MMAT     ,GIA      ,POUT     ,
     3                SCR1     ,SCR2     ,SCR3     ,SCR4     ,SCR5     ,
     4                SCR6     ,SCR7     ,SCR8     ,
     5                LMODES   ,NMODES   ,IBUF     ,SFBIT    ,BADD     ,
     6                NAME
      EQUIVALENCE     (BADD(2),DBADD(1)) ,(RZ(1),Z(1)) ,
     1                (SCR1,USETD) ,(SCR2,PVEC,IDENT,KJJL) ,
     2                (SCR3,AZY,AHJ,KJJ,GJH) ,(SCR4,AJH,KHHBAR,GYH) ,
     3                (SCR5,AC,AYH,MZZ,KZZBAR) ,(SCR6,KZZ) ,
     4                (SCR7,KC,AHY) ,(SCR8,H) ,(SCR9,MMAT) ,
     5                (SCR10,GIA,MHHBAR)
C     DATA            AXY      ,AFRY     ,KYY      ,DKAA     ,DKFRFR   ,
C    1                USETF    ,PHIA     ,PHIX     ,LAMA     ,
C    2                KMAT     ,MMAT     ,GIA      ,POUT     ,
C    3                SCR1     ,SCR2     ,SCR3     ,SCR4     ,SCR5     ,
C    4                SCR6     ,SCR7     ,SCR8     /
C    5                101      ,102      ,103      ,104      ,105      ,
C    6                111      ,112      ,113      ,114      ,
C    7                201      ,202      ,203      ,204      ,
C    8                301      ,302      ,303      ,304      ,305      ,
C    9                306      ,307      ,308      /
C
C     DATA    BADD  / 11*0   /
      DATA    NAMEX / 4HGFSM , 4HOD   /
C
      AXY    = 101
      AFRY   = 102
      KYY    = 103
      DKAA   = 104
      DKFRFR = 105
      USETF  = 111
      PHIA   = 112
      PHIX   = 113
      LAMA   = 114
      KMAT   = 201
      MMAT   = 202
      GIA    = 203
      POUT   = 204
      SCR1   = 301
      SCR2   = 302
      SCR3   = 303
      SCR4   = 304
      SCR5   = 305
      SCR6   = 306
      SCR7   = 307
      SCR8   = 308
      NAME(1)= NAMEX(1)
      NAME(2)= NAMEX(2)
      DO 5 I = 1,11
    5 BADD(I)= 0
C
C
      PHIAR = SCR4
      PHIXR = SCR2
C
      LCORE = KORSZ(Z(1))
      IBUF  = LCORE - SYSBUF - 1
      IF (IBUF .LT. 0) GO TO 1008
C
C     CREATE A DUMMY USET VECTOR TOR USE WITH THE MODAL DISPLACEMENTS
C
C     BIT POSITIONS WILL BE
C
C     UM  - MODAL POINT  UZ + UNZ
C     UZ  - DESIRED MODAL POINT
C     UNZ - MODAL POINT TO BE SKIPPED
C     UFR - FREE SURFACE POINT
C     UH  - UFR + UZ
C
C     SET MODAL DISPLACEMENTS
C
      FILE   = PHIX
      MCB(1) = PHIX
      CALL RDTRL (MCB)
      IF (MCB(1) .LT. 0) GO TO 1001
      NMODES = MCB(2)
      IF (LLMODE.GT.NMODES .OR. LLMODE.EQ.0) LLMODE = -1
      LMODES = LLMODE
      IF (LMODES .LE. 0) LMODES = NMODES
      IF (LMODES.LE.0 .OR. LMODES.GT.NMODES) LMODES = NMODES
      IZM  = TWO(UZ)  + TWO(UM) + TWO(UH)
      INZM = TWO(UNZ) + TWO(UM)
      IF (IBUF .LE. NMODES) GO TO 1008
      DO 10 I = 1,NMODES
      Z(I) = IZM
      IF (I .GT. LMODES) Z(I) = INZM
   10 CONTINUE
C
C     SET FREE SURFACE DISPLACEMENTS
C
      IFR  = TWO(UFR) + TWO(UH)
      LVEC = NMODES
      IF (NOFREE) 45,20,20
   20 CALL GOPEN (USETF,Z(IBUF),0)
   30 CALL READ (*40,*40,USETF,IBIT,1,0,N)
      IF (ANDF(IBIT,TWO(UFR)) .EQ. 0) GO TO 30
      LVEC = LVEC + 1
      IF (LVEC .GE. IBUF) GO TO 1008
      Z(LVEC) = IFR
      GO TO 30
C
   40 CALL CLOSE (USETF,1)
C
C     WRITE DUMMY USETD FILE
C
   45 CALL GOPEN (USETD,Z(IBUF),1)
      CALL WRITE (USETD,Z(1),LVEC,1)
      CALL CLOSE (USETD,1)
      MCB(1) = USETD
      MCB(2) = LVEC
      DO 50 I = 3,7
   50 MCB(I) = 0
      CALL WRTTRL (MCB)
C
C     EXTRACT THE DESIRED MODES FORM THE PHIX MATRIX
C
      USET = USETD
      IF (LMODES .GE. NMODES) GO TO 70
      CALL CALCV (PVEC,UM,UZ,UNZ,Z(1))
      CALL GFSPTN (PHIX,PHIXR,0,0,0,PVEC,0)
      GO TO 80
C
   70 PHIXR = PHIX
C
C     TRANSFORM THE FLUID STRUCTURE AREA MATRIX
C
   80 CALL SSG2B (PHIXR,AXY,0,AZY,1,2,1,SCR5)
C
C     IF FREE SURFACE POINTS EXIST - MERGE THEM WITH THE TRANSFORMED
C     AREA MATRIX
C
      IF (NOFREE) 100,90,90
   90 CALL CALCV (PVEC,UH,UZ,UFR,Z(1))
      CALL GFSMRG (AHY,AZY,AFRY,0,0,0,PVEC)
      GO TO 110
C
  100 CALL GFSWCH (AHY,AZY)
C
C     DETERMINE IF ANY SINGLE POINT CONSTRAINTS EXIST ON THE FLUID
C
  110 USET = USETF
      CALL CALCV (PVEC,UY,UF,US,Z(1))
      NUY = NSUB0 + NSUB1
      SFBIT = 1
      IF (NSUB1 .EQ. 0) SFBIT = 0
C
C     IF SPC POINTS EXIST ON THE FLUID - PARTITION THEM OUT OF THE
C     FLUID AREA AND STIFFNESS MATRICES
C
      IF (SFBIT) 120,130,120
  120 CALL GFSPTN (AHY,AHJ,0,0,0,PVEC,0)
      CALL GFSTRN (AHJ,AJH,SCR5,SCR6)
      CALL GFSPTN (KYY,KJJ,0,0,0,PVEC,PVEC)
      GO TO 160
C
C     IF NO SPC POINTS EXIST ON THE FLUID, CONSTRAIN THE FIRST FLUID
C     POINT TO REMOVE POTENTIAL SINGULARITIES
C
  130 IF (COMPTP .GT. 0) WRITE (NOUT,140) UWM
  140 FORMAT (A25,' 8015. THE PURELY INCOMPRESSIBLE METHOD IS AVAIL',
     1       'ABLE ONLY WITH THE DIRECT FORMULATION.')
      CALL GFSSPC (NUY,PVEC)
      NSUB0 = NUY - 1
      NSUB1 = 1
      CALL GFSPTN (KYY,KJJ,0,0,0,PVEC,PVEC)
C
C     GENERATE THE H TRANSFORMATION MATRIX
C
      CALL GFSH (NUY,H)
      CALL GFSTRN (AHY,AYH,SCR2,SCR6)
      CALL SSG2B (H,AYH,0,AJH,0,2,1,SCR6)
C
C     GENERATE THE COMPRESSIBLITY MATRIX
C
      CALL GFSCOM (AHY,NUY,KC,IDENT,AC,SCR6)
C
C     SOLVE FOR THE INITIAL PRESSURE TRANSFORMATION MATRIX
C
  160 CALL FACTOR (KJJ,KJJL,SCR5,SCR6,SCR9,SCR10)
      CALL SSG3A (0,KJJL,AJH,GJH,SCR5,SCR6,-1,0)
C
C     FOR COMPUTER CORE CONSERVATION REASON, THE REST OF GFSMOD IS
C     MOVED TO GFSMO2, WHICH CAN BE SEGMENTED IN PARALLEL WITH GFSMOD.
C
      RETURN
C
C     ERROR EXITS
C
 1001 N = -1
      GO TO 9999
 1008 N = -8
C
 9999 CALL MESAGE (N,FILE,NAME)
      RETURN
      END

      SUBROUTINE CMRD2
C
C     THIS SUBROUTINE IS THE CMRED2 MODULE WHICH PERFORMS THE MAJOR
C     COMPUTATIONS FOR THE COMPLEX MODAL REDUCE COMMAND.
C
C     DMAP CALLING SEQUENCE
C     CMRED2   CASECC,LAMAMR,PHISSR,PHISSL,EQST,USETMR,KAA,MAA,BAA,K4AA,
C              PAA/KHH,MHH,BHH,K4HH,PHH,POVE/STEP/S,N,DRY/POPT $
C
C     INPUT  DATA
C     GINO - CASECC - CASE CONTROL DATA
C            LAMAMR - EIGENVALUE TABLE FOR SUBSTRUCTURE BEING REDUCED
C            PHISSR - RIGHT HAND EIGENVECTORS FOR SUBSTRUCTURE BEING
C                     REDUCED
C            PHISSL - LEFT HAND EIGENVECTORS FOR SUBSTRUCTURE BEING
C                     REDUCED
C            EQST   - EQSS DATA FOR BOUNDARY SET FOR SUBSTRUCTURE BEING
C                     REDUCED
C            USETMR - USET TABLE FOR REDUCED SUBSTRUCTURE
C            KAA    - SUBSTRUCTURE STIFFNESS MATRIX
C            MAA    - SUBSTRUCTURE MASS MATRIX
C            BAA    - SUBSTRUCTURE VISCOUS DAMPING MATRIX
C            K4AA   - SUBSTRUCTURE STRUCTURE DAMPINF MATRIX
C            PAA    - SUBSTRUCTURE LOAD MATRIX
C     SOF  - LAMS   - EIGENVALUE TABLE FOR ORIGINAL SUBSTRUCTURE
C            PHIS   - RIGHT HAND EIGENVECTOR TABLE FOR ORIGINAL
C                     SUBSTRUCTURE
C            PHIL   - LEFT HAND EIGENVECTOR TABLE FOR ORIGINAL
C                     SUBSTRUCTURE
C            HORG   - RIGHT HAND H TRANSFORMATION MATRIX FOR ORIGINAL
C                     SUBSTRUCTURE
C            HLFT   - LEFT HAND H TRANSFORMATION MATRIX FOR ORIGINAL
C                     SUBSTRUCTURE
C
C     OUTPUT DATA
C     GINO - KHH    - REDUCED STIFFNESS MATRIX
C            MHH    - REDUCED MASS MATRIX
C            BHH    - REDUCED VISCOUS DAMPING MATRIX
C            K4HH   - REDUCED STRUCTURE DAMPING MATRIX
C            PHH    - REDUCED LOAD MATRIX
C            POVE   - INTERIOR POINT LOAD MATRIX
C     SOF  - LAMS   - EIGENVALUE TABLE FOR ORIGINAL SUBSTRUCTURE
C            PHIS   - RIGHT HAND EIGENVECTOR TABLE FOR ORIG.SUBSTRUCTURE
C            PHIL   - LEFT HAND EIGENVECTOR TABLE FOR ORIG. SUBSTRUCTURE
C            GIMS   - G TRANSFORMATION MATRIX FOR BOUNDARY POINTS FOR
C                     ORIGINAL SUBSTRUCTURE
C            HORG   - RIGHT HAND H TRANSFORMATION MATRIX FOR ORIGINAL
C                     SUBSTRUCTURE
C            HLFT   - LEFT HAND H TRANSFORMATION MATRIX FOR ORIGINAL
C                     SUBSTRUCTURE
C            UPRT   - PARTITIONING VECTOR FOR CREDUCE FOR ORIGINAL
C                     SUBSTRUCTURE
C            POVE   - INTERNAL POINT LOADS FOR ORIGINAL SUBSTRUCTURE
C            POAP   - INTERNAL POINTS APPENDED LOADS FOR ORIGINAL
C                     SUBSTRUCTURE
C            EQSS   - SUBSTRUCTURE EQUIVALENCE TABLE FOR REDUCED
C                     SUBSTRUCTURE
C            BGSS   - BASIC GRID POINT DEFINITION TABLE FOR REDUCED
C                     SUBSTRUCTURE
C            CSTM   - COORDINATE SYSTEM TRANSFORMATION MATRICES FOR
C                     REDUCED SUBSTRUCTURE
C            LODS   - LOAD SET DATA FOR REDUCED SUBSTRUCTURE
C            LOAP   - APPENDED LOAD SET DATA FOR REDUCED SUBSTRUCTURE
C            PLTS   - PLOT SET DATA FOR REDUCED SUBSTRUCTURE
C            KMTX   - STIFFNESS MATRIX FOR REDUCED SUBSTRUCTURE
C            MMTX   - MASS MATRIX FOR REDUCED SUBSTRUCTURE
C            PVEC   - LOAD MATRIX FOR REDUCED SUBSTRUCTURE
C            PAPD   - APPENDED LOAD MATRIX FOR REDUCED SUBSTRUCTURE
C            BMTX   - VISCOUS DAMPING MATRIX FOR REDUCED SUBSTRUCTURE
C            K4MX   - STRUCTURE DAMPING MATRIX FOR REDUCED SUBSTRUCTURE
C
C     PARAMETERS
C     INPUT  - STEP   - CONTROL DATA CASECC RECORD (INTEGER)
C              POPT   - PVEC OR PAPP OPTION FLAG (BCD)
C     OUTPUT - DRY    - MODULE OPERATION FLAG (INTEGER)
C     OTHERS - GBUF   - GINO BUFFERS
C              SBUF   - SOF BUFFERS
C              INFILE - INPUT FILE NUMBERS
C              OTFILE - OUTPUT FILE NUMBERS
C              ISCR   - ARRAY OF SCRATCH FILE NUMBERS
C              KORLEN - LENGTH OF OPEN CORE
C              KORBGN - BEGINNING ADDRESS OF OPEN CORE
C              OLDNAM - NAME OF SUBSTRUCTURE BEING REDUCED
C              NEWNAM - NAME OF REDUCED SUBSTRUCTURE
C              SYMTRY - SYMMETRY FLAG
C              RANGE  - RANGE OF FREQUENCIES TO BE USED
C              NMAX   - MAXIMUM NUMBER OF FREQUENCIES TO BE USED
C              IO     - IO OPTIONS FLAG
C              MODES  - OLDMODES OPTION FLAG
C              RSAVE  - SAVE REDUCTION PRODUCT FLAG
C              LAMSAP - BEGINNING ADDRESS OF MODE USE DESCRIPTION ARRAY
C              MODLEN - LENGTH OF MODE USE ARRAY
C              MODPTS - NUMBER OF MODAL POINTS
C
      EXTERNAL        ORF
      LOGICAL         SYMTRY,MODES,RSAVE,PONLY
      INTEGER         STEP,DRY,POPT,GBUF1,GBUF2,GBUF3,SBUF1,SBUF2,SBUF3,
     1                OTFILE,OLDNAM,Z,SYSBUF,CASECC,YES,PHISSL,ORF
      DIMENSION       MODNAM(2),NMONIC(8),RZ(1),ITRLR(7)
      COMMON /BLANK / STEP,DRY,POPT,GBUF1,GBUF2,GBUF3,SBUF1,SBUF2,SBUF3,
     1                INFILE(11),OTFILE(6),ISCR(11),KORLEN,KORBGN,
     2                OLDNAM(2),NEWNAM(2),SYMTRY,RANGE(2),NMAX,IO,MODES,
     3                RSAVE,LAMSAP,MODPTS,MODLEN,PONLY,LSTZWD
      COMMON /ZZZZZZ/ Z(1)
      COMMON /SYSTEM/ SYSBUF,IPRNTR
      EQUIVALENCE     (CASECC,INFILE(1)),(PHISSL,INFILE(4)),(RZ(1),Z(1))
      DATA    NMONIC/ 4HNAMA,4HNAMB,4HSYMF,4HRANG,4HNMAX,4HOUTP,4HOLDM,
     1                4HRSAV/
      DATA    KAA   / 107 /, IBLANK,YES /4H    , 4HYES /
      DATA    MODNAM/ 4HCMRD,4H2   /
      DATA    NHLODS, NHLOAP,NHHORG,NHHLFT /4HLODS,4HLOAP,4HHORG,4HHLFT/
C
C     COMPUTE OPEN CORE AND DEFINE GINO, SOF BUFFERS
C
      IF (DRY .EQ. -2) RETURN
      NOZWDS = KORSZ(Z(1))
      LSTZWD = NOZWDS - 1
      GBUF1  = NOZWDS - SYSBUF - 2
      GBUF2  = GBUF1  - SYSBUF
      GBUF3  = GBUF2  - SYSBUF
      SBUF1  = GBUF3  - SYSBUF
      SBUF2  = SBUF1  - SYSBUF - 1
      SBUF3  = SBUF2  - SYSBUF
      KORLEN = SBUF3  - 1
      KORBGN = 1
      IF (KORLEN .LE. KORBGN) GO TO 290
C
C     INITIALIZE SOF
C
      CALL SOFOPN (Z(SBUF1),Z(SBUF2),Z(SBUF3))
C
C     INITIALIZE CASE CONTROL PARAMETERS
C
      DO 6 I = 1,11
      IF (I .GT. 6) GO TO 2
      INFILE(I) = 100 + I
      OTFILE(I) = 200 + I
      ISCR(I) = 300 + I
      GO TO 6
    2 INFILE(I) = 100 + I
      ISCR(I) = 300 + I
    6 CONTINUE
      DO 10 I = 1,2
      OLDNAM(I) = IBLANK
   10 NEWNAM(I) = IBLANK
      RANGE(1) = -1.0E+35
      RANGE(2) =  1.0E+35
      SYMTRY = .FALSE.
      NMAX   = 2147483647
      IO     = 0
      MODES  = .FALSE.
      RSAVE  = .FALSE.
      NRANGE = 0
      PONLY  = .FALSE.
C
C     PROCESS CASE CONTROL
C
      IFILE = CASECC
      CALL OPEN (*260,CASECC,Z(GBUF2),0)
      IF (STEP) 20,40,20
   20 DO 30 I = 1,STEP
   30 CALL FWDREC (*280,CASECC)
C
C     READ CASECC
C
   40 CALL READ (*270,*280,CASECC,Z(KORBGN),2,0,NWDSRD)
      NWDSCC = Z(KORBGN+1)
      DO 200 I = 1,NWDSCC,3
      CALL READ (*270,*280,CASECC,Z(KORBGN),3,0,NWDSRD)
C
C     TEST CASE CONTROL MNEMONICS
C
      DO 50 J = 1,8
      IF (Z(KORBGN) .EQ. NMONIC(J)) GO TO 60
   50 CONTINUE
      GO TO 200
C
C     SELECT DATA TO EXTRACT
C
   60 GO TO (70,90,110,120,140,160,180,190), J
C
C     EXTRACT NAME OF SUBSTRUCTURE BEING REDUCED
C
   70 DO 80 K = 1,2
   80 OLDNAM(K) = Z(KORBGN+K)
      GO TO 200
C
C     EXTRACT NAME OF REDUCED SUBSTRUCTURE
C
   90 DO 100 K = 1,2
  100 NEWNAM(K) = Z(KORBGN+K)
      GO TO 200
C
C     EXTRACT SYMMETRY FLAG
C
  110 IF (Z(KORBGN+1) .NE. YES) GO TO 200
      SYMTRY = .TRUE.
      GO TO 200
C
C     EXTRACT FREQUENCY RANGE
C
  120 IF (NRANGE .EQ. 1) GO TO 125
      NRANGE = 1
      RANGE(1) = RZ(KORBGN+2)
      GO TO 200
  125 RANGE(2) = RZ(KORBGN+2)
      GO TO 200
C
C     EXTRACT MAXIMUM NUMBER OF FREQUENCIES
C
  140 IF (Z(KORBGN) .EQ. 0) GO TO 200
      NMAX = Z(KORBGN+2)
      GO TO 200
C
C     EXTRACT OUTPUT FLAGS
C
  160 IO = ORF(IO,Z(KORBGN+2))
      GO TO 200
C
C     EXTRACT OLDMODES FLAG
C
  180 IF (Z(KORBGN+1) .NE. YES) GO TO 200
      MODES = .TRUE.
      GO TO 200
C
C     EXTRACT REDUCTION SAVE FLAG
C
  190 IF (Z(KORBGN+1) .NE. YES) GO TO 200
      RSAVE = .TRUE.
  200 CONTINUE
      CALL CLOSE (CASECC,1)
C
C     CHECK FOR SYMMETRY
C
      ITRLR(1) = PHISSL
      CALL RDTRL (ITRLR)
      NPASS = 2
      IF (ITRLR(1) .GT. 0) GO TO 204
      SYMTRY = .TRUE.
      NPASS = 1
C
C     CHECK FOR RUN = GO
C
  204 IHORG = 0
      IF (DRY .EQ. 0) GO TO 240
C
C     CHECK FOR STIFFNESS PROCESSING
C
      ITRLR(1) = KAA
      CALL RDTRL (ITRLR)
      IF (ITRLR(1) .GT. 0) GO TO 208
C
C     CHECK FOR LOADS ONLY PROCESSING
C
      CALL SFETCH (NEWNAM,NHLODS,3,ITEST)
      IF (ITEST .EQ. 3) PONLY = .TRUE.
      CALL SFETCH (NEWNAM,NHLOAP,3,ITEST)
      IF (ITEST .EQ. 3) PONLY = .TRUE.
      GO TO 240
C
C     PROCESS STIFFNESS MATRIX
C
  208 CALL CMRD2A
C
C     BEGIN COMPLEX MODAL REDUCTION
C     NPASS .EQ. 1, SYMMETRIC REDUCTION
C     NPASS .EQ. 2, UNSYMMETRIC REDUCTION
C
      DO 230 J = 1,NPASS
C
C     TEST FOR H TRANSFORMATION MATRICES
C
      GO TO (212,214), J
  212 CALL SOFTRL (OLDNAM,NHHORG,ITRLR)
      IF (ITRLR(1) .EQ. 1) GO TO 230
      IHORG = IHORG + 1
      GO TO 216
  214 CALL SOFTRL (OLDNAM,NHHLFT,ITRLR)
      IF (ITRLR(1) .EQ. 1) GO TO 230
      IHORG = IHORG + 2
C
C     PREFORM GUYAN REDUCTION
C
  216 CALL CMRD2C (J)
C
C     PROCESS OLDMODES FLAG
C
      CALL CMRD2B (J)
C
C     CALCULATE MODAL TRANSFORMATION MATRIX
C
      CALL CMRD2D (J)
      IF (J .EQ. 1) CALL CMRD2B (3)
C
C     CALCULATE H TRANSFORMATION MATRIX
C
      CALL CMRD2E (J)
  230 CONTINUE
C
C     CALCULATE STRUCTURAL MATRICES
C     IHORG .EQ. 0, BOTH HORG, HLFT ON SOF
C     IHORG .EQ. 1, HORG CALCULATED, HLFT ON SOF
C     IHORG .EQ. 2, HORG ON SOF, HLFT CALCULATED
C     IHORG .EQ. 3, BOTH HORG, HLFT CALCULATED
C
  240 CALL CMRD2F (IHORG)
      IF (IHORG .EQ. 0) GO TO 250
C
C     PROCESS NEW TABLE ITEMS
C
      CALL CMRD2G
C
C     CLOSE ANY OPEN FILES
C
  250 CALL SOFCLS
      IF (DRY .EQ. -2) WRITE (IPRNTR,900)
      RETURN
C
C     PROCESS SYSTEM FATAL ERRORS
C
  260 IMSG = -1
      GO TO 300
  270 IMSG = -2
      GO TO 300
  280 IMSG = -3
      GO TO 300
  290 IMSG = -8
      IFILE = 0
  300 CALL SOFCLS
      CALL MESAGE (IMSG,IFILE,MODNAM)
      RETURN
C
  900 FORMAT (50H0  MODULE CREDUCE TERMINATING DUE TO ABOVE ERRORS.)
C
      END

      SUBROUTINE SGENB (TYPE,BUF,MCB,IFILE,ICODE,IEXTRA,OFILE,OCODE,
     1                  OEXTRA)
C
C     THIS ROUTINE READS SUBSTRUCTURING CONSTRAINT CARDS AND CONVERTS
C     THEM TO NASTRAN FORMAT
C
C     INPUTS -
C
C     TYPE   - BCD CARD NAME
C     BUF    - GINO BUFFER FOR INPUT FILE
C     MCB    - MATRIX CONTROL BLOCK FOR INPUT FILE
C     IFILE  - INPUT FILE NAME
C     ICODE  - LOCATE CODE FOR INPUT CARD TYPE
C     IEXTRA - NUMBER OF EXTRA WORDS (AFTER GRID) TO BE READ
C     OFILE  - OUTPUT FILE NAME
C     OCODE  - LOCATE CODE FOR OUTPUT CARD TYPE
C     OEXTRA - NUMBER OF EXTRA WORDS (AFTER GRID) TO BE WRITTEN
C
      EXTERNAL        ANDF,COMPLF,ORF
      INTEGER         TYPE(2),BUF(1),MCB(7),ICODE(4),OFILE,OCODE(4),
     1                OEXTRA,Z,SYSBUF,OUTT,TWO,SUBNAM(2),CARD(20),COMP,
     2                CIN(6),CODE,CEXIST(6),ANDF,COMPLF,ORF
      CHARACTER       UFM*23,UWM*25
      COMMON /XMSSG / UFM,UWM
      COMMON /BLANK / IDRY,NAME(2)
      COMMON /SGENCM/ NONO,NSS,IPTR
      COMMON /ZZZZZZ/ Z(1)
      COMMON /SYSTEM/ SYSBUF,OUTT
      COMMON /TWO   / TWO(32)
      DATA    SUBNAM/ 4HSGEN,4HB    /
C
C     LOCATE CARDS ON FILE
C
      CALL LOCATE (*200,BUF(1),ICODE(1),ICD)
      ICODE(4) = 1
C
C     WRITE HEADER RECORD ON OUTPUT FILE
C
      CALL WRITE (OFILE,ICODE(1),3,0)
C
C     READ SID, SUBSTRUCTURING NAME, AND COMPONENT CODE FORM CARD
C
   10 CALL READ (*1002,*150,IFILE,CARD,4,0,NWDS)
      CARD(5) = CARD(1)
      N = 6 + OEXTRA
      DO 20 I = 6,N
   20 CARD(I) = 0
      CARD(7+OEXTRA) = -1
C
C     FIND SUBSTRUCTURE
C
      DO 30 I = 1,NSS
      INAM = 2*I + 3
      IF (Z(INAM).EQ.CARD(2) .AND. Z(INAM+1).EQ.CARD(3)) GO TO 50
   30 CONTINUE
C
C     SUBSTRUCTURE NOT FOUND - SKIP OVER DATA
C
      CALL PAGE2 (-4)
      WRITE (OUTT,63290) UWM,(CARD(J),J=2,3),TYPE,NAME
   40 CALL FREAD (IFILE,CARD,1+IEXTRA,0)
      IF (CARD(1)) 10,40,40
C
C     FOUND SUBSTRUCTURE NAME
C
   50 IPT  = IPTR + I - 1
      IGRD = Z(IPT)
      NGRD = (Z(IPT+1) - Z(IPT))/3
C
C     SPLIT COMPONENTS
C
      COMP = CARD(4)
      IF (COMP .EQ. 0) COMP = 1
      CALL SPLT10 (COMP,CIN,NCIN)
C
C     PROCESS GRID POINTS
C
   60 CALL FREAD (IFILE,CARD(7),1+IEXTRA,0)
      IGRID = CARD(7)
      IF (IGRID .EQ. -1) GO TO 10
      IF (IGRID .EQ.  0) GO TO 60
      CALL BISLOC (*80,IGRID,Z(IGRD),3,NGRD,IGR)
      IG = IGR + IGRD - 1
      NPRO = 0
   70 IF (Z(IG-3) .NE. Z(IG)) GO TO 90
      IF (IG .LE. IGRD) GO TO 90
      IG = IG - 3
      GO TO 70
C
C     BAD GRID
C
   80 NONO = 1
      CALL PAGE2 (-3)
      WRITE (OUTT,60220) UFM,(CARD(J),J=2,3),IGRID,COMP,TYPE,NAME
      GO TO 60
C
C     DECODE 32-BIT WORD
C
   90 ISIL = Z(IG+1)
      CODE = Z(IG+2)
      IF (CODE .EQ. 0) CODE = 1
      CALL DECODE (CODE,CEXIST,NC)
C
C     FIND ACTUAL REMAINING COMPONENTS AND WRITE CONVERTED DATA TO
C     OUTPUT FILE
C
      DO 110 J  = 1,NC
      DO 110 JG = 1,NCIN
      IF (CIN(JG)-CEXIST(J)-1) 110,100,110
  100 NPRO = NPRO + 1
      CARD(7) = ISIL + J - 1
      CALL WRITE (OFILE,CARD(5),3+OEXTRA,0)
  110 CONTINUE
      IF (NPRO .GE. NCIN) GO TO 60
      IF (Z(IG+3) .NE. Z(IG)) GO TO 80
      IF ((IG+3) .GE. (IGRD+3*NGRD)) GO TO 80
      IG = IG + 3
      GO TO 90
C
C     FINISH PROCESSING CARDS BY CLOSING OUTPUT FILE RECORD
C
  150 CALL WRITE (OFILE,0,0,1)
C
C     TURN OFF TRAILER FOR INPUT CARD TYPE
C
      J = (ICODE(2)-1)/16
      I = ICODE(2) - 16*J
      MCB(J+2) = ANDF(COMPLF(TWO(I+16)),MCB(J+2))
C
C     TURN ON TRAILER FOR OUTPUT CARD TYPE
C
      J = (OCODE(2)-1)/16
      I = OCODE(2) - 16*J
      MCB(J+2) = ORF(TWO(I+16),MCB(J+2))
C
C     RETURN
C
  200 RETURN
C
C     ERRORS
C
 1002 CALL MESAGE (-2,IFILE,SUBNAM)
      RETURN
60220 FORMAT (A23,', SUBSTRUCTURE ',2A4,', GRID POINT',I9,
     1       ', COMPONENTS',I9,1H, /30X,'REFERENCED ON ',2A4,
     2       ' CARD, DO NOT EXIST ON SOLUTION STRUCTURE ',2A4)
63290 FORMAT (A25,' 6329, SUBSTRUCTURE ',2A4,' REFERENCED ON ',2A4,
     1       ' CARD', /30X,'IS NOT A COMPONENT BASIC SUBSTRUCTURE OF ',
     2       'SOLUTION STRUCTURE ',2A4,/30X,'THIS CARD WILL BE IGNORED')
      END

      SUBROUTINE PSROD
C*****
C THIS ROUTINE COMPUTES STRESSES AND FORCES FOR THE ROD ELEMENT FOR THE
C PLA3 FUNCTIONAL MODULE.
C*****
C
C                        E C P T  F O R  T H E  R O D
C
C                                                                CARD
C                                                 TYPE   TABLE   TYPE
C ECPT( 1)ELEMENT ID.                               I     ECT    CROD
C ECPT( 2)SCALAR INDEX NUMBER FOR GRID POINT A      I     ECT    CROD
C ECPT( 3)SCALAR INDEX NUMBER FOR GRID POINT B      I     ECT    CROD
C ECPT( 4)MATERIAL ID.                              I     EPT    PROD
C ECPT( 5)AREA  (A)                                 R     EPT    PROD
C ECPT( 6)POLAR MOMENT OF INERTIA (J)               R     EPT    PROD
C ECPT( 7) TORSIONAL STRESS COEFF (C)                R    EPT    PROD
C ECPT( 8) NON-STRUCTRAL MASS (MU)                   R    EPT    PROD
C ECPT( 9) COOR. SYS. ID. NO. FOR GRID POINT A       I   BGPDT   GRID
C ECPT(10) X-COORDINATE OF GRID PT. A (IN BASIC COOR)R   BGPDT
C ECPT(11) Y-COORDINATE OF GRID PT. A (IN BASIC COOR)R   BGPDT
C ECPT(12) Z-COORDINATE OF GRID PT. A (IN BASIC COOR)R   BGPDT
C ECPT(13) COOR. SYS. ID. NO. FOR GRID POINT B       I   BGPDT
C ECPT(14) X-COORDINATE OF GRID PT. B (IN BASIC COOR)R   BGPDT
C ECPT(15) Y-COORDINATE OF GRID PT. B (IN BASIC COOR)R   BGPDT
C ECPT(16) Z-COORDINATE OF GRID PT. B (IN BASIC COOR)R   BGPDT
C ECPT(17) ELEMENT TEMPERATURE
C ECPT(18) PREVIOUS STRAIN VALUE, ONCE REMOVED (EPS STAR SUB 0)
C ECPT(19) PREVIOUS STRAIN VALUE  (EPS STAR)
C ECPT(20) PREVIOUSLY COMPUTED VALUE OF MODULUS OF ELASTICITY (ESTAR)
C ECPT(21) PREVIOUSLY COMPUTED TORSIONAL MOMENT (TSTAR)
C ECPT(22) INCREMENTAL DISPLACEMENT VECTOR FOR GRID POINT A
C ECPT(23)                       ...
C ECPT(24)                       ...
C ECPT(25)                       ...
C ECPT(26)                       ...
C ECPT(27)                       ...
C ECPT(28) INCREMENTAL DISPLACEMENT VECTOR FOR GRID POINT B
C ECPT(29)                       ...
C ECPT(30)                       ...
C ECPT(31)                       ...
C ECPT(32)                       ...
C ECPT(33)                       ...
C
C
C
      DIMENSION
     1                   ECPT(100)          ,IECPT(100)
     2,                  XN(3)              ,UA(9)
     3,                  UB(9)              ,DIFF(3)
     4,                  TA(9)              ,TB(9)
C
C EST (ECPT) COMMON BLOCK
C
      COMMON   /PLA32E/
     1                   ECPT
C
C SCRATCH BLOCK FOR VARIABLES LOCAL TO PLA3 ELEMENT ROUTINES.
C
      COMMON   /PLA32S/
     1                   XL                 ,XN
     2,                  UA                 ,UB
     3,                  TA                 ,TB
     4,                  DIFF
C
C PLA32 COMMUNICATION BLOCK
C
      COMMON   /PLA32C/  GAMMA              ,GAMMAS
C
C OUTPUT BLOCK FOR ELEMENT STRESSES
C
      COMMON   /SOUT  /
     1                   JSELID             ,SIGMA
     2,                  SMSIG              ,TAU
     3,                  SMTAU
C
C INPUT AND OUTPUT BLOCKS FOR SUBROUTINE MAT
C
      COMMON   /MATIN/
     1                   MATIDC             ,MATFLG
     2,                  TEMDUM             ,PLAARG
     3,                  DUM2(2)
C
C
C
      COMMON   /MATOUT/
     1                   E SUB 0            ,G SUB 0
     2,                  MATDUM(5)          ,SIGMAT
     3,                  SIGMAC             ,SIGMAS
C
C
C
      EQUIVALENCE
     1                   (IECPT(1),ECPT(1)) ,(E SUB 0,PLAANS)
     2,                  (SMSIG,MSSIG)      ,(SMTAU,MSTAU)
C
C CALL MAT ROUTINE TO GET MATERIAL PROPERTIES AND STORE IN LOCAL NAMES.
C
      MATIDC = IECPT(4)
      MATFLG = 1
      CALL MAT (IECPT(1))
      E SUB 0 L = E SUB 0
      G SUB 0 L = G SUB 0
C
C SET UP VECTOR ALONG THE ROD, COMPUTE LENGTH AND NORMALIZE
C
      XN(1) = ECPT(10) - ECPT(14)
      XN(2) = ECPT(11) - ECPT(15)
      XN(3) = ECPT(12) - ECPT(16)
      XL    =  XN(1)**2 + XN(2)**2 + XN(3)**2
      XL    = SQRT (XL)
      XN(1) = XN(1) / XL
      XN(2) = XN(2) / XL
      XN(3) = XN(3) / XL
C
C STORE DISPLACEMENT VECTORS IN LOCAL VARIABLES
C
      DO 10 I = 1,6
      UA(I) = ECPT(I+21)
   10 UB(I) = ECPT(I+27)
C
C TRANSFORM DISPLACEMENT VECTOR TRANSLATIONAL COMPONENTS IF NECESSARY
C
      IBASEA = 0
      IF (IECPT(9) .EQ. 0) GO TO 20
      IBASEA = 6
      CALL TRANSS (IECPT(9),TA)
      CALL GMMATS (TA,3,3,0, UA(1),3,1,0, UA(7))
   20 IBASEB = 0
      IF (IECPT(13) .EQ. 0) GO TO 30
      IBASEB = 6
      CALL TRANSS (IECPT(13),TB)
      CALL GMMATS (TB,3,3,0, UB(1),3,1,0, UB(7))
C
C FORM DIFFERENCE VECTOR, DOT PRODUCT AND INCREMENT OF STRAIN
C
   30 DIFF(1) = UA(IBASEA+1) - UB(IBASEB+1)
      DIFF(2) = UA(IBASEA+2) - UB(IBASEB+2)
      DIFF(3) = UA(IBASEA+3) - UB(IBASEB+3)
      CALL GMMATS (XN,3,1,1, DIFF,3,1,0, TERM)
      DEPS1 = TERM / XL
      EPSIN2 = ECPT(19)
      EPSIN1 = ECPT(18)
      DEPS2 = EPSIN2 - EPSIN1
C
C COMPUTE EPS1 AND EPS2 AND FETCH VIA MAT STRESSES SIGMA1 AND SIGMA2
C
      EPS1 = EPSIN2 + DEPS1
      EPS2 = EPSIN2  +  (DEPS1+GAMMAS**2*DEPS2)*(GAMMA+1.0)/(GAMMAS+1.0)
     1     + GAMMAS*(DEPS1-GAMMAS*DEPS2)*(GAMMA+1.0)**2 / (GAMMAS+1.0)
      MATFLG = 6
      PLAARG = EPS1
      CALL MAT (IECPT(1))
      SIGMA1 = PLAANS
      PLAARG = EPS2
      CALL MAT (IECPT(1))
      SIGMA2 = PLAANS
      IF (EPS1 .EQ. EPS2) GO TO 42
      E = (SIGMA2 - SIGMA1) / (EPS2 - EPS1)
      GO TO 44
   42 E = ECPT(20)
   44 G = ECPT(20) * G SUB 0 L / E SUB 0 L
C
C COMPUTE STRESSES
C
      ISELID = IECPT(1)
      SIGMA  = SIGMA1
      P      =  ECPT(5) * SIGMA1
C
C TRANSFORM DISPLACEMENT VECTOR ROTATIONAL DISPLACEMENTS IF NECESSARY.
C
      IBASEA = 3
      IF (IECPT(9) .EQ. 0) GO TO 60
      CALL GMMATS (TA,3,3,0, UA(4),3,1,0, UA(7))
      IBASEA = 6
   60 IBASEB = 3
      IF (IECPT(13) .EQ. 0) GO TO 70
      IBASEB = 6
      CALL GMMATS (TB,3,3,0, UB(4),3,1,0, UB(7))
   70 DIFF(1) = UA(IBASEA+1) - UB(IBASEB+1)
      DIFF(2) = UA(IBASEA+2) - UB(IBASEB+2)
      DIFF(3) = UA(IBASEA+3) - UB(IBASEB+3)
      CALL GMMATS (XN,3,1,1, DIFF,3,1,0, TERM)
      T = ECPT(6) * G * TERM / XL  +  ECPT(21)
      IF (ECPT(6) .EQ. 0.0) GO TO 80
      TAU = ECPT(7) * T / ECPT(6)
      GO TO 90
   80 TAU = 0.0
C
C COMPUTE MARGIN OF SAFETY IN EXTENSION
C
   90 IF(SIGMA.LE.0.0)GO TO 101
      IF(SIGMAT.LE.0.0)GO TO 102
      SMSIG=SIGMAT/SIGMA-1.0
      GO TO 180
  101 IF(SIGMA.NE.0.0) GO TO 103
      GO TO 102
  103 SIGMAC=-ABS(SIGMAC)
      SMSIG=SIGMAC/SIGMA - 1.0
      GO TO 180
  102 MSSIG=1
C
C     COMPUTE MARGIN OF SAFETY IN TORSION
C
  180 IF(SIGMAS.LE.0.0) GO TO 190
      IF(TAU.EQ.0.0)GO TO 190
      SMTAU= SIGMAS/ABS(TAU) - 1.0
      GO TO 210
  190 MSTAU=1
  210 JSELID = IECPT(1)
C
C UPDATE EST (ECPT) ENTRY
C
      ECPT(18) = ECPT(19)
      ECPT(19) = EPS1
      ECPT(20) = E
      ECPT(21) = T
      RETURN
      END

      SUBROUTINE SMP2
C*****
C THIS MODULE, WHICH IS CALLED ONLY FOR DIFFERENTIAL STIFFNESS, PARTI-
C TIONS KDFF AND THEN COMPUTES KDAA AS FOLLOWS ....
C                       I
C               -D      I     D
C               K       I    K
C   D            AA     I     AO
C  K   =     ----------------------
C   FF                  I
C                D  T   I     D
C              (K  )    I    K
C                AO     I     OO
C                       I
C
C   D     -D         D                 D         T             D
C  K   =  K     +   K    X  G    +   (K    X  G )    +   G  X K    X  G
C   AA     AA        AO      O         AO      O          O    OO      O
C
C*****
C
C DMAP CALL ...
C
C     SMP2     USET,GO,KDFF/KDAA/
C
      INTEGER
     1                   USET               ,GO
     2,                  SCR1               ,SCR2
     3,                  UF                 ,UA
     4,                  UO                 ,MCB(7)
C
C
C
      COMMON /BLANK/ ICOM
C
C INPUT FILES
C
      DATA     USET,GO,KDFF /101,102,103/
C
C OUTPUT FILE
C
      DATA     KDAA /201/
C
C SCRATCH FILES
C
      DATA     SCR1,SCR2,KDAAB,KDAO,KDOO /301,302,303,304,305/
C
C USET BIT POSITIONS
C
      DATA     UF,UA,UO/26,25,30/
C
C  TEST FOR PRESENCE OF KDFF
C
      MCB(1)=KDFF
      CALL RDTRL(MCB)
      IF(MCB(1).LT.0) RETURN
C
C PARTITION KFF
C
      CALL UPART (USET,SCR1,UF,UA,UO)
      CALL MPART (KDFF,KDAAB,KDAO,O,KDOO)
C
C COMPUTE KDAA
C
      CALL ELIM(KDAAB,KDAO,KDOO,GO,KDAA,SCR1,SCR2,306)
      RETURN
      END

      SUBROUTINE CONE (TI,Z)
C
C     THIS ROUTINE COMPUTES THE THERMAL LOADS ON A AXISYMMETRIC CONE
C
      REAL    I00      ,I10
      REAL    I01      ,I11      ,I21      ,I31      ,I41
      REAL    I02      ,I12      ,I22
      REAL    I03      ,I13      ,I23      ,I33
      REAL    TI(2)    ,Z(1)     ,PA(8)    ,XI(6)    ,ECPT(35)
      REAL    N2D33    ,NSP      ,NCP      ,NSPOPI
      REAL    EHT(96)  ,HUQ(100) ,HYQ(10)
      COMMON /CONDAS/   PI       ,TWOPI    ,RADEG    ,DEGRA    ,
     1                  S4PISQ
      COMMON /TRIMEX/   MECPT(35)
      COMMON /MATIN /   MATID    ,INFLAG   ,TEMP     ,STRESS   ,SINTH  ,
     1                  COSTH
      COMMON /MATOUT/   G11,G12  ,G13,G22  ,G23,G33  ,RHO,ALPH1,ALPH2  ,
     1                  ALPH3    ,TSUB0    ,GSUBE    ,SIGTEN   ,SIGCOM ,
     2                  SIGSHE   ,G2X211   ,G2X212   ,G2X222
      EQUIVALENCE      (ECPT( 1) ,MECPT(1)),(ECPT( 9), TS    )
      EQUIVALENCE      (ECPT(28) ,RA      ),(ECPT(32), RB    )
      EQUIVALENCE      (ECPT(29) ,ZA      ),(ECPT(33), ZB    )
      EQUIVALENCE      (ECPT( 6) ,MATID2  ),(ECPT( 8), MATID3)
      EQUIVALENCE      (GSHEAR   ,G12     )
      DATA    ONE   /  1.0   /
C
C     DEFINITION OF VARIABLES
C
C        ECPT  ENTRIES FOR CONE
C
C     ECPT(1)  INTEGER   ELEMENT ID = 1000*ELID + HARMONIC
C     ECPT(2)  INTEGER   SIL  A
C     ECPT(3)  INTEGER   SIL  B
C     ECPT(4)  INTEGER   MAT ID  1
C     ECPT(5)  REAL      T    MEMBRANE THICKNESS
C     ECPT(6)  INTEGER   MAT ID  2
C     ECPT(7)  REAL      MOMENT OF INERTIA
C     ECPT(8)  INTEGER   MAT ID 3
C     ECPT(9)  REAL      SHEAR THICKNESS
C     ECPT(10) REAL      NON -STRUCTRAL  MASS
C     ECPT(11) REAL      Z1
C     ECPT(12) REAL      Z2
C     ECPT(13) REAL      PHI 1
C     ECPT(14) REAL          2
C     ECPT(15) REAL          3
C     ECPT(16) REAL          4
C     ECPT(17) REAL          5
C     ECPT(18) REAL          6
C     ECPT(19) REAL          7
C     ECPT(20) REAL          8
C     ECPT(21) REAL          9
C     ECPT(22) REAL         10
C     ECPT(23) REAL         11
C     ECPT(24) REAL         12
C     ECPT(25) REAL         13
C     ECPT(26) REAL         14
C     ECPT(27) INTEGER   COORDINANT SYSTEM FOR POINT  A
C     ECPT(28) REAL      R   (A)
C     ECPT(29) REAL      Z   (A)
C     ECPT(30) REAL      NULL
C     ECPT(31) INTEGER   COORDINANT SYSTEM FOR POINT B
C     ECPT(32) REAL      R    (B)
C     ECPT(33) REAL      Z    (B)
C     ECPT(34) REAL      NULL
C     ECPT(35) REAL      TEMPERATURE OF MATERIAL
C
C     XL       LENGTH  BETWEEN  POINTS
C     SP       SINE  OF  PHI
C     CP       COSINE OF PHI
C     I-S      INTEGRAL  FROM  PAGE 46 MS,28
C     MATID    MATERIAL ID  (MAT 1 CARD)
C     INFLAG   OPTION  2  OF MAT ROUTINE
C     TEMP     MATERIAL TEMPERATURE
C     SINTH    0.0  DUMMY
C     COSTH    1.0  DUMMY
C     XN       HARMONIC NUMBER
C     PA(8)    TOTAL LOAD VECTOR
C     XI(6)    CYLINDRICAL LOAD
C
C
C     IF MEMBRANE THICKNESS = 0, THEN LOAD IS ZERO
C
      IF (ECPT(5) .EQ. 0.0) GO TO 160
C
C     COMPUTE  L, SINPHI, COSPHI
C
      RBMA = RB - RA
      ZBMA = ZB - ZA
      XL2  = RBMA**2 + ZBMA**2
      XL   = SQRT(XL2)
      IF (XL .EQ. 0.0) GO TO 160
      SP = RBMA/XL
      CP = ZBMA/XL
C
C     COMPUTE  I-S
C
      XL4 = XL2*XL2
      RAV = (RA + RB)*0.5
      I00 = XL *RAV
      I10 = XL2*(RA + 2.0*RB)/6.0
      I01 = XL
      I11 = XL2/2.0
      I21 = XL2*XL/3.0
      I31 = XL4/4.0
      I41 = XL4*XL/5.0
C
C     SET UP FOR MAT ROUTINE
C
      MATID = MECPT(4)
      INFLAG= 2
      TEMP  = ECPT(35)
      SINTH = 0.0
      COSTH = 1.0
      CALL MAT (MECPT(1))
C
C     COMPUTE COEFICCIENTS
C
      F  = (G12*ALPH2 + G22*ALPH1)*ECPT(5)*PI
      FF = (G11*ALPH2 + G12*ALPH1)*ECPT(5)*PI
C
C     COMPUTE  A
C
      A = (TI(1)-TSUB0)*F
C
C     COMPUTE  B
C
      B = (TI(2)-TI(1))/XL*F
C
C     COMPUTE  C
C
      C = (TI(1)-TSUB0)*FF
C
C     COMPUTE  D
C
      D = (TI(2)-TI(1))/XL*FF
C
C     DECODE  N
C
      IXN = MECPT(1)/1000
      XN  = MECPT(1) - IXN*1000 - 1
C
C     COMPUTE  PA
C
      F  = I01*A + I11*B
      FF = I11*A + I21*B
      PA(1) = XN*F
      PA(2) = XN*FF
      PA(3) = SP*F
      PA(4) = SP*FF + I00*C + I10*D
      PA(5) = CP*F
      PA(6) = CP*FF
      PA(7) = CP*(I21*A + I31*B)
      PA(8) = CP*(I31*A + I41*B)
C
C     CHECK HARMONIC NO.  IF(XN = 0.0) DOUBLE PA VECTOR
C
      IF (XN .NE. 0.0) GO TO 30
      DO 20 I = 1,8
   20 PA(I) = 2.0*PA(I)
C
C     OMPUTE TRANSFORMATION MATRIX HUQ. SEE MS-28, PP. 15, 16, 24, 25
C
   30 DO 40 I = 1,100
   40 HUQ(I) = 0.0
      HUQ(  1) = ONE
      HUQ( 13) = ONE
      HUQ( 25) = ONE
      HUQ( 36) = ONE
      HUQ( 41) = CP/RA
      HUQ( 45) = XN/RA
      HUQ( 49) = ONE
      HUQ( 51) = ONE
      HUQ( 52) = XL
      HUQ( 63) = ONE
      HUQ( 64) = XL
      HUQ( 75) = ONE
      HUQ( 76) = XL
      HUQ( 77) = XL2
      HUQ( 78) = HUQ(77)*XL
      HUQ( 86) = ONE
      HUQ( 87) = 2.0*XL
      HUQ( 88) = 3.0*HUQ(77)
      HUQ( 91) = CP/RB
      HUQ( 92) = HUQ(91)*XL
      HUQ( 95) = XN/RB
      HUQ( 96) = HUQ(95)*XL
      HUQ( 97) = HUQ(95)*XL2
      HUQ( 98) = HUQ(96)*XL2
      HUQ( 99) = ONE
      HUQ(100) = XL
C
C     CHCEK IF HYQ VECTOR NEEDED
C
      IF (MATID2 .EQ.0   .OR. MATID3 .EQ.0  ) GO TO 60
      IF (ECPT(7).EQ.0.0 .OR. ECPT(9).EQ.0.0) GO TO 60
C
C     FORM  (D) = I*(G)
C
      D11 = ECPT(7)*G11
      D12 = ECPT(7)*G12
      D22 = ECPT(7)*G22
      D33 = ECPT(7)*G33
C
C     PICK UP GSHEAR FROM MAT
C
      INFLAG = 1
      MATID  = MATID3
      TEMP   = ECPT(35)
      CALL MAT (MECPT(1))
      IF (GSHEAR .EQ. 0.0) GO TO 60
C
C     COMPUTE INTEGRALS
C
      B  = SP
      B2 = B*B
      B3 = B*B2
      B4 = B*B3
      RLOG = ALOG(RB/RA)
      RASQ = RA*RA
      RBMA2  = RBMA*RAV
      ORBORA = ONE/RB - ONE/RA
      TWORA  = RA + RA
C
C     IF SP = 0 EVALUATE INTEGRALS DIFFERENTLY
C
      IF (SP .NE. 0.0) GO TO 45
      TEMP1= RAV*RAV
      TEMP3= XL2*XL
      I02  = XL/RAV
      I12  = XL2/(2.0*RAV)
      I22  = TEMP3/(3.0*RAV)
      I03  = XL/TEMP1
      I13  = XL2/(2.0*TEMP1)
      I23  = TEMP3/(3.0*TEMP1)
      I33  = (XL2*XL2)/(4.0*TEMP1)
      GO TO 49
   45 CONTINUE
      I02 = RLOG/B
      I12 = (RBMA - RA*RLOG)/B2
      I22 = (RBMA2 - TWORA*RBMA + RASQ*RLOG)/B3
      I03 =-ORBORA/B
      I13 = (RLOG + RA*ORBORA)/B2
      I23 = (RBMA - TWORA*RLOG - RASQ*ORBORA)/B3
      I33 = (RBMA2 - 3.0*RA*RBMA + 3.0*RASQ*RLOG + RASQ*RA*ORBORA)/B4
C
C     COMPUTE HYQ
C
   49 CONTINUE
      CP2 = CP*CP
      SP2 = SP*SP
      XN2 = XN*XN
      OPI = ONE/PI
      N2D33  = XN2*D33
      SP2D22 = SP2*D22
      OQ  = XL*TS*GSHEAR*RAV + I02*(N2D33 + SP2D22)*OPI
      OQ  = ONE/OQ
      NSP = XN*SP
      NCP = XN*CP
      NSPOPI  = NSP*OPI
      TWOD33  = 2.0*D33
      TEMP1   = D12*ORBORA
      TEMP2   = NSPOPI*(D22 + D33)
      TEMP3   = XN*NSPOPI*(TWOD33 + D22)
      TEMP4   = OQ*0.5*N2D33*CP*OPI
      TEMP5   = OPI*(XN2*TWOD33 + SP2D22)
      TEMP6   = D12*XN2*XL2/RB
      TEMP7   = NSPOPI*CP*0.5
      HYQ( 1) = OQ*(TEMP1*NCP - TEMP7*I03*(D33 + 2.0*D22))
      HYQ( 2) = OQ*(NCP*XL/RB*D12 - TEMP7*I13*(3.0*D33 + D22)
     1        + 1.5*NCP*OPI*I02*D33)
      HYQ( 3) = TEMP4*I03
      HYQ( 4) = TEMP4*I13
      HYQ( 5) = OQ*(TEMP1*XN2  -  TEMP3*I03)
      HYQ( 6) = OQ*(D12*XN2*XL/RB - TEMP3*I13 + TEMP5*I02)
      HYQ( 7) = OQ*(2.0*D11*(RA-RB) + TEMP6 + 2.0*I12*TEMP5 - TEMP3*I23)
      HYQ( 8) = OQ*(-D11*6.*XL*RB + TEMP6*XL + 3.*I22*TEMP5 - TEMP3*I33)
      HYQ( 9) =-OQ*TEMP2*I02
      HYQ(10) = OQ*(XN*XL*(D12 + D33) - TEMP2*I12)
      DO 50 I = 1,10
      HUQ(I+30) = HUQ(I+30) - HYQ(I)
   50 HUQ(I+80) = HUQ(I+80) - HYQ(I)
C
      ITEST = 1
      GO TO 61
   60 ITEST = 0
      HUQ(41) = 0.0
      HUQ(45) = 0.0
      HUQ(91) = 0.0
      HUQ(92) = 0.0
      HUQ(95) = 0.0
      HUQ(96) = 0.0
      HUQ(97) = 0.0
      HUQ(98) = 0.0
      HUQ(99) = 0.0
   61 CONTINUE
C
C     NO NEED TO COMPUTE DETERMINANT SINCE IT IS NOT USED SUBSEQUENTLY.
C
      ISING = -1
      CALL INVERS (10,HUQ(1),10,DUM,0,DETERM,ISING,EHT(1))
      IF (ISING .EQ. 2) CALL MESAGE (-30,40,MECPT(1))
      IF (ITEST .NE. 0) GO TO 62
      HUQ( 85) = 0.0
      HUQ(100) = 0.0
   62 CONTINUE
C
C     COMPLETE SOLUTION
C
C     FIRST OBTAIN PRODUCTS
C                       T
C        EHAT  =  (E)(H  )      AND STORE AT EHT(1) . . . EHT(48)
C                      A
C
C                       T
C        EHBT  =  (E)(H  )      AND STORE AT EHT(49). . . EHT(96)
C                      B
C                                /
C              WHERE  (HUQ) = (HA/HB)
C                                /
C              AND
C                             0    CP   SP   0    0
C
C                             1    0    0    0    0
C
C                             0    CP  -SP   0    0
C                  E MATRIX =
C                             0    0    0    0    SP
C
C                             0    0    0    1    0
C
C                             0    0    0    0    CP
C
      INC1 = 0
      INC2 = 0
  110 DO 120 I = 1,8
      KROW = I + INC1
      NCOL = (I-1)*10 + INC2
      EHT(KROW   ) = SP*HUQ(NCOL+2) + CP*HUQ(NCOL+3)
      EHT(KROW+ 8) =    HUQ(NCOL+1)
      EHT(KROW+16) = CP*HUQ(NCOL+2) - SP*HUQ(NCOL+3)
      EHT(KROW+24) = SP*HUQ(NCOL+5)
      EHT(KROW+32) =    HUQ(NCOL+4)
  120 EHT(KROW+40) = CP*HUQ(NCOL+5)
      IF (INC1 .GT. 0) GO TO 130
      INC1 = 48
      INC2 = 5
      GO TO 110
C
C     PERFORM TRANSFORMATION OF LOAD VECTOR
C
  130 DO 150 J = 1,2
      CALL GMMATS (EHT(48*J-47),6,8,0,PA(1),8,1,0,XI(1))
      K = MECPT(J+1) - 1
      DO 140 I = 1,6
      K = K + 1
  140 Z(K) = Z(K) + XI(I)
  150 CONTINUE
C
  160 RETURN
C
      END

      SUBROUTINE DMPFIL (IFILE,Z,LZ)
C
C     DUMPS A FILE ON DIAG 20 SETTING.
C
      INTEGER         SYSBUF,OUTPT,BUF,Z(2),FILE,NAME(2)
      COMMON /SYSTEM/ SYSBUF,OUTPT
      COMMON /NAMES / RD,RDREW,WRT,WRTREW,CLSREW,CLS
      COMMON /UNPAKX/ IOUT,IROW,NROW,INCR
      DATA    NAME  / 4HDMPF,2HIL  /
C
    1 FORMAT (1H0,I5,10(1X,I10,1X))
    2 FORMAT (1H ,5X,10(1X,1P,E11.4))
    3 FORMAT (1H ,5X,10(4X,A4,4X))
C
      CALL SSWTCH (20,L)
      IF (L .EQ. 0) RETURN
C
      FILE = IABS(IFILE)
      BUF  = LZ - SYSBUF + 1
      IF (BUF .LT. 6) GO TO 91
      LCORE = (BUF-1)/5
      LCORE = LCORE*5
      CALL OPEN (*90,FILE,Z(BUF),RDREW)
      WRITE  (OUTPT,10) FILE
   10 FORMAT (14H1DUMP OF FILE ,I3)
      IF (IFILE .LE. 0) GO TO 100
C
      IREC = 0
   20 WRITE  (OUTPT,30) IREC
   30 FORMAT (8H0RECORD ,I6,6X,100(1H-))
   40 CALL READ (*70,*60,FILE,Z,LCORE,0,IWORDS)
C
      I1 = -9
   50 I1 = I1 + 10
      I2 = MIN0(I1+9,LCORE)
      WRITE (OUTPT,1) I1,(Z(I),I=I1,I2)
      WRITE (OUTPT,2)    (Z(I),I=I1,I2)
      WRITE (OUTPT,3)    (Z(I),I=I1,I2)
      IF (LCORE-I2) 40,40,50
C
   60 I1 = -9
   65 I1 = I1 + 10
      I2 = MIN0(I1+9,IWORDS)
      WRITE (OUTPT,1) I1,(Z(I),I=I1,I2)
      WRITE (OUTPT,2)    (Z(I),I=I1,I2)
      WRITE (OUTPT,3)    (Z(I),I=I1,I2)
      IF (IWORDS .GT. I2) GO TO 65
      IREC = IREC + 1
      GO TO 20
C
   70 Z(1) = FILE
      CALL CLOSE (FILE,CLSREW)
      CALL RDTRL (Z)
      WRITE  (OUTPT,80) (Z(I),I=1,7)
   80 FORMAT (4H0EOF ,//,8H0TRAILER  ,/,7(1X,I12 /))
   90 RETURN
C
   91 CALL MESAGE (8,0,NAME)
      GO TO 90
C
  100 CALL READ (*70,*101,FILE,Z,2,1,IWORDS)
  101 WRITE  (OUTPT,102) Z(1),Z(2)
  102 FORMAT (14H0HEADER RECORD  ,/1H0,2A4)
      Z(1) = FILE
      CALL RDTRL (Z)
      NCOLS = Z(2)
      IF (NCOLS .GT. 300) NCOLS = 100
      IOUT = 1
      INCR = 1
      IF (NCOLS) 70,70,110
  110 DO 150 J = 1,NCOLS
      WRITE  (OUTPT,115) J
  115 FORMAT (7H0COLUMN  ,I5)
      IROW = 0
      NROW = 0
      CALL UNPACK (*140,FILE,Z)
      WRITE  (OUTPT,118) IROW,NROW
  118 FORMAT (1H+,20X,3HROW  ,I4,11H   THRU ROW   ,I5)
      IF (NROW .GT. 300) NROW = 100
      NELS = NROW - IROW + 1
      IF (NELS .LE. 0) GO TO 150
      WRITE  (OUTPT,119) (Z(K),K=1,NELS)
  119 FORMAT (1P,10E13.4)
      GO TO 150
  140 WRITE  (OUTPT,141)
  141 FORMAT (13H NULL COLUMN  )
  150 CONTINUE
      GO TO 70
C
      END

      SUBROUTINE SDRCHK (FORVEC,CFRVEC,LVEC,KONT)
C   THIS ROUTINE IS USED BY ELEMENT SUBROUTINES THAT DETERMINE IF THE
C REQUESTED STRESS/FORCE PRECISION IS AVAILABLE...
C-----
      REAL    FORVEC(LVEC) ,CFRVEC(LVEC)
      COMMON /SDR2X9/ NCHK(5),TWOTOP,FNCHK
C
       DO 20 I = 1,LVEC
      IF (CFRVEC(I).EQ.0.0) R = 1.0E0
      IF (CFRVEC(I).NE.0.0) R = ABS (FORVEC(I)/CFRVEC(I) )
      IF (R.GT.1.001) R = 1.0E0
      IF (R.EQ.0.0) RJ = TWOTOP
      IF (R.NE.0.0) RJ = TWOTOP + ALOG10 (R)
      IF (RJ.LT.0.0) RJ = 0.0
      CFRVEC(I) = RJ
      IF (RJ.LT.FNCHK) KONT = KONT + 1
   20 CONTINUE
C-----
      RETURN
      END

      SUBROUTINE PKTQ2 (NPTS)
C
C     THIS ROUTINE CALCULATES PHASE II OUTPUT FOR PLA4 FOR COMBINATION
C     ELEMENTS
C
C     **** PHASE II OF STRESS DATA RECOVERY *********
C
C     NPTS = 3 IMPLIES STRIA1 OR STRIA2  (PHASE II)
C     NPTS = 4 IMPLIES SQUAD1 OR SQUAD2  (PHASE II)
C
      DIMENSION       NSIL(4),NPH1OU(1),SI(36)
      COMMON /PLA4UV/ IVEC,Z(24)
      COMMON /PLA4ES/ PH1OUT(300)
      COMMON /PLA42S/ STRESS(3),TEMP,DELTA,NPOINT,I,J,NPT1,VEC(5),TEM,
     1                Z1OVRI, Z2OVRI,DUM1(308)
      EQUIVALENCE     (NSIL(1),PH1OUT(2)),(NPH1OU(1),PH1OUT(1)),
     1                (SI(1),PH1OUT(9))
C
C     PHASE I OUTPUT FROM THE MEMBRANE IS THE FOLLOWING
C     NOTE..BEGIN = 30*NPTS+8
C
C     PH1OUT(BEGIN+ 1)               ELEMENT ID
C     PH1OUT(BEGIN+ 2 THRU BEGIN +5) 3 SILS AND DUMMY OR 4 SILS
C     PH1OUT(BEGIN+ 6 THRU BEGIN +9) DUMMY
C     PH1OUT(BEGIN+10 THRU BEGIN +9*NPTS+9) 3 OR 4 S SUB I 3X3 ARRAYS
C
C
C     FIND SIG X, SIG Y, SIG XY, FOR MEMBRANE CONSIDERATION
C
      IF (NPH1OU(30*NPTS+10) .EQ. 0) RETURN
C
C                       I=NPTS
C     STRESS VECTOR = (SUMMATION(S )(U ))
C                       I=1       I   I
C
      DO 60 I = 1,NPTS
C
C     POINTER TO I-TH SIL IN PH1OUT
C
      NPOINT = 30*NPTS + 9 + I
C
C     POINTER TO DISPLACEMENT VECTOR IN VARIABLE CORE
C
      NPOINT = IVEC + NPH1OU(NPOINT) - 1
C
C     POINTER TO S SUB I 3X3
C
      NPT1 = 30*NPTS + 9 + 9*I
C
      CALL GMMATS (PH1OUT(NPT1),3,3,0, Z(NPOINT),3,1,0, VEC(1))
C
      DO 50 J = 1,3
   50 STRESS(J) = STRESS(J) + VEC(J)
C
   60 CONTINUE
C
      RETURN
      END

      SUBROUTINE MAGBDY
C
C     THIS ROUTINE PICKS UP THE GRIDS ON THE AIR/IRON INTERFACES
C     FROM A PERMBDY CARD,CONVERTS EXTERNAL TO INTERNAL SILS, AND
C     STORES RESULTS ON PERMBD WHICH IS READ IN SSG1. SSG1 WILL NEED TO
C     COMPUTE MAGNETIC LOADS ONLY AT THESE POINTS.
C
C     MAGBDY   GEOM1,HEQEXIN/PERMBD/V,N,IPG $
C
      INTEGER         BUF1,FILE,GEOM1,EQEXIN,PERMBD,SYSBUF,PERMBY(2)
      DIMENSION       IZ(1),NAM(2),MCB(7)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /SYSTEM/ SYSBUF,IOUT
      COMMON /BLANK / IPG
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE     (Z(1),IZ(1))
      DATA    NAM   / 4HMAGB,4HDY  /
      DATA    GEOM1 , EQEXIN,PERMBD/101,102,201/
      DATA    PERMBY/ 4201,42 /
C
      LCORE = KORSZ(Z)
      BUF1  = LCORE - SYSBUF
      LCORE = BUF1 - 1
      IF (LCORE .LE. 0) GO TO 1008
C
C     SEE IF A PERMBDY CARD EXISTS
C
      IPG  = -1
      FILE = GEOM1
      CALL PRELOC (*1001,Z(BUF1),GEOM1)
      CALL LOCATE (*10,Z(BUF1),PERMBY,IDX)
      IPG  = 1
      GO TO 20
C
C     NO PERMBDY CARD - RETURN
C
   10 CALL CLOSE (GEOM1,1)
      RETURN
C
C     READ PERMBDY INTO CORE
C
   20 CALL READ (*1002,*30,GEOM1,Z,LCORE,0,NPTS)
      GO TO 1008
   30 CALL CLOSE (GEOM1,1)
C
C     READ IN 1ST RECORD OF EQEXIN
C
      LCORE = LCORE - NPTS
      IEQEX = NPTS
      CALL GOPEN (EQEXIN,Z(BUF1),0)
      FILE  = EQEXIN
      CALL READ (*1002,*40,EQEXIN,Z(IEQEX+1),LCORE,0,NEQ)
      GO TO 1008
   40 CALL CLOSE (EQEXIN,1)
      NGRIDS = NEQ/2
      LCORE  = LCORE - NEQ
C
C     GET THE INTERNAL NUMBER (=SIL NUMBER FOR HEAT TRAMSFER)FOR EACH
C     POINT ON PERMBDY AND STORE IT BACK ONTO EXTERNAL NUMBER,SINCE THE
C     EXTERNAL IS NO LONGER NEEDED
C
      DO 50 I = 1,NPTS
      CALL BISLOC (*60,IZ(I),IZ(IEQEX+1),2,NGRIDS,JLOC)
      IZ(I) = IZ(IEQEX+JLOC+1)
   50 CONTINUE
      GO TO 70
C
   60 WRITE  (IOUT,65) UFM,IZ(I)
   65 FORMAT (A23,', GRID',I9,' ON PERMBDY CARD DOES NOT EXIST')
      CALL MESAGE(-61,0,0)
C
C     WRITE THESE INTERNAL ID-S ONTO PERMBD
C
   70 CALL GOPEN (PERMBD,Z(BUF1),1)
      CALL WRITE (PERMBD,IZ(1),NPTS,1)
      CALL CLOSE (PERMBD,1)
      MCB(1) = PERMBD
      MCB(2) = NPTS
      DO 80 I = 3,7
   80 MCB(I) = 0
      CALL WRTTRL(MCB)
C
      RETURN
C
 1001 N =-1
      GO TO 1010
 1002 N =-2
      GO TO 1010
 1008 N =-8
      FILE = 0
 1010 CALL MESAGE (N,FILE,NAM)
      RETURN
      END

      SUBROUTINE PRINT (X,Y,XYD,CHR,N,OPT)
C
C     (X,Y) = STARTING OR ENDING POINT OF THE LINE TO BE PRINTED (ALWAYS
C             LEFT-TO-RIGHT OR TOP-TO-BOTTOM).
C     CHR   = CHARACTERS TO BE PRINTED (4 PER WORD).
C     N     = NUMBER OF 4 CHARACTER WORDS.
C     XYD   = +/-1 IF X = STARTING OR ENDING POINT OF THE LINE.
C     ...   = +/-2 .. Y = ........ .. ...... ..... .. ... .....
C     OPT   = -1 TO INITIATE  THE TYPING MODE.
C     ...   = +1 .. TERMINATE ... ...... .....
C     ...   =  0 .. PRINT A LINE.
C
      EXTERNAL        ORF,KRSHFT,KLSHFT
      INTEGER         XYD,CHR(1),OPT,ORF,C(80),BLANK,BLNK,CHARX,D
      REAL            XY(2,2)
      COMMON /PLTDAT/ SKPPLT(20),SKPA(3),CNTCHR(2)
      COMMON /SYSTEM/ SKPSYS(40),NCPW
      DATA    BLANK / 1H /
C
      IF (OPT .NE. 0) GO TO 150
      BLNK = KRSHFT(KLSHFT(BLANK,1),1)
      D = MAX0(IABS(XYD),1)
      S = CNTCHR(D)
      IF (XYD.EQ.-1 .OR. XYD.EQ.2) S = -S
      XY(1,1) = X
      XY(2,1) = Y
      XY(1,2) = XY(1,1)
      XY(2,2) = XY(2,1)
C
C     SEPARATE 80 CHARACTERS AT A TIME.
C
      DO 130 J = 1,N,20
      IF (XYD .LT. 0) GO TO 105
      L1 = J
      L2 = L1 + 19
      IF (L2 .GT. N) L2 = N
      GO TO 106
  105 L2 = N - J + 1
      L1 = L2 - 19
      IF (L1 .LE. 0) L1 = 1
C
  106 NC = 0
      DO 120 L = L1,L2
      DO 110 I = 1,4
      CHARX = KRSHFT(CHR(L),NCPW-I)
      NC = NC + 1
      C(NC) = ORF(KLSHFT(CHARX,NCPW-1),BLNK)
  110 CONTINUE
  120 CONTINUE
C
C     TYPE THE -NC- CHARACTERS JUST SEPARATED.
C
      XY(D,2) = XY(D,1) + S*FLOAT(L1-1)
      CALL TIPE (XY(1,2),XY(2,2),XYD,C,NC,0)
  130 CONTINUE
      GO TO 200
C
C     OPT = +/-1
C
  150 CALL TIPE (0,0,0,0,0,OPT)
  200 RETURN
      END

      SUBROUTINE DPD4
C
C     DPD4 ASSEMBLES THE NON-LINEAR FORCING TABLE (NLFT)
C     AND THE TRANSIENT RESPONSE LIST (TRL).
C
      EXTERNAL        ANDF
      INTEGER         GPL   ,SIL   ,USET  ,USETD ,GPLD  ,SILD  ,DPOOL ,
     1                DLT   ,FRL   ,TFL   ,TRL   ,PSDL  ,EED   ,SCR1  ,
     2                SCR2  ,SCR3  ,SCR4  ,BUF   ,BUF1  ,BUF2  ,BUF3  ,
     3                BUF4  ,FLAG  ,FILE  ,EPOINT,SEQEP ,Z     ,LOADS ,
     5                ANDF  ,DLOAD ,FREQ1 ,FREQ  ,TIC   ,TSTEP ,TF    ,
     6                PSD   ,EIGR  ,EIGB  ,EIGC  ,NGRID ,EQDYN ,SDT   ,
     7                UD    ,UE    ,TWO
      DIMENSION       BUF(24)   ,EPOINT(2)    ,SEQEP(2)     ,MCB(7)   ,
     1                NAM(2)    ,LOADS(32)    ,DLOAD(2)     ,FREQ1(2) ,
     2                FREQ(2)   ,ZZ(1)        ,BUFR(20)     ,NOLIN(21),
     3                TIC(2)    ,TSTEP(2)     ,TF(2)        ,PSD(2)   ,
     4                MSG(3)    ,EIGR(2)      ,EIGB(2)      ,EIGC(2)
      COMMON /BLANK / LUSET ,LUSETD,NOTFL ,NODLT ,NOPSDL,NOFRL ,NONLFT,
     1                NOTRL ,NOEED
      COMMON /NAMES / RD    ,RDREW ,WRT   ,WRTREW,CLSREW
      COMMON /DPDCOM/ DPOOL ,GPL   ,SIL   ,USET  ,GPLD  ,SILD  ,USETD ,
     1                DLT   ,FRL   ,NLFT  ,TFL   ,TRL   ,PSDL  ,EED   ,
     2                SCR1  ,SCR2  ,SCR3  ,SCR4  ,BUF   ,BUF1  ,BUF2  ,
     3                BUF3  ,BUF4  ,EPOINT,SEQEP ,L     ,KN    ,NEQDYN,
     4                LOADS ,DLOAD ,FREQ1 ,FREQ  ,NOLIN ,NOGO  ,
     5                MSG   ,TIC   ,TSTEP ,TF    ,PSD   ,EIGR  ,EIGB  ,
     6                EIGC  ,MCB   ,NAM   ,EQDYN ,SDT   ,INEQ
      COMMON /TWO   / TWO(32)
      COMMON /BITPOS/ UM    ,UO    ,UR    ,USG   ,USB   ,UL    ,UA    ,
     1                UF    ,US    ,UN    ,UG    ,UE    ,UP    ,UNE   ,
     2                UFE   ,UD
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE     (Z(1) ,ZZ(1)),(BUF(1),BUFR(1)),(MSG(2),NGRID)
      DATA            NOLINR/ 7 /
C
C     INITIALIZE POINTERS. OPEN SCR1. OPEN DYNAMICS POOL.
C
      INOLIN = NEQDYN + 2
      J = INOLIN
      MSKUD = TWO(UD)
      MSKUE = TWO(UE)
      INCORE = 0
      II = 1
      I  = 1
      MSG(1) = 67
      CALL PRELOC (*2001,Z(BUF1),DPOOL)
      CALL OPEN (*2001,SCR1,Z(BUF2),WRTREW)
      INEQ = 0
C
C     LOCATE NOLINI CARD. IF PRESENT, TURN NONLFT FLAG OFF,
C
 1320 CALL LOCATE (*1358,Z(BUF1),NOLIN(I),FLAG)
      NONLFT = 1
      NWDIN  = NOLIN(I+2)
C
C     READ A NOLINI CARD. CONVERT POINTS ON CARD TO SIL NOS.
C     STORE DATA IN CORE. IF SPILL, WRITE ON SCRATCH FILE.
C
 1340 CALL READ (*2002,*1358,DPOOL,BUF,NWDIN,0,FLAG)
      MSG(3) = 100000000*II + BUF(1)
      IF (II .GE. 5) IF (II-6)  1350,  1354,  1342
C                             NOLIN5,NFTUBE,NOLIN6
      III = II
      IF (BUF(6) .LT. 10) GO TO 1341
      III = II + 4
      BUF(6) = BUF(6) - 10
 1341 IF (II .NE. 2) GO TO 1343
      IF (BUF(8) .LT. 10) GO TO 1343
      BUF(8) = BUF(8) - 10
      IF(III.EQ.2) III = 10
      IF(III.EQ.6) III = 9
      GO TO 1343
 1342 III = 13
      IF (BUF(6) .LT. 10) GO TO 1343
      III = 14
      BUF(6) = BUF(6) - 10
 1343 L = 2
      CALL DPDAA
      BUF(3) = BUF(2)
      L = 5
      CALL DPDAA
      L = 7
      IF (II .EQ. 2) CALL DPDAA
      BUF(6) = BUF(7)
      BUF(2) = III
 1344 NN = 6
 1345 IF (INCORE  .NE. 0) GO TO 1348
      IF (J+NN .GE. BUF2) GO TO 1347
      DO 1346 K = 1,NN
      Z(J) = BUF(K)
 1346 J = J + 1
      GO TO 1340
 1347 CALL WRITE (SCR1,Z(INOLIN),J-INOLIN,0)
      INCORE = 1
 1348 CALL WRITE (SCR1,BUF,NN,0)
      GO TO 1340
C
C     SPECIAL HANDLING OF NOLIN5 CARD
C     CARD FORMAT AS RECEIVED FROM IFP
C        SID  AA   AB   FAB  EA/TEA  EB/TEB  ALPA/TALPA  ALPB/TALPB
C        GA1  GA2  GA3  GA4  GB1     GB2     GB3         GB4
C
C     WE CONVERT THIS CARD INTO THE FOLLOWING 6-WORD ENTRY FORMAT
C
C        SID  12  SILA1  AA          SILA2  AB
C        SID  12  SILA3  FAB         SIL4   0
C        SID  12  SILB1  EA/TEA      SILB2  EB/TEB
C        SID  12  SILB3  ALPA/TALPA  SILB4  ALPB/TALPB
C
 1350 L = 23
      KK= 16
      DO 1351 K = 1,8
      BUF(L+1) = 0
      BUF(L  ) = BUF(KK)
      IF (BUF(L) .NE. 0) CALL DPDAA
      KK = KK - 1
 1351 L  = L -2
      BUF(24) = BUF( 8)
      BUF(22) = BUF( 7)
      BUF(18) = BUF( 6)
      BUF(16) = BUF( 5)
      BUF(12) = 0
      BUF(10) = BUF( 4)
      BUF( 6) = BUF( 3)
      BUF( 4) = BUF( 2)
      BUF( 3) = BUF( 9)
      BUF( 5) = BUF(11)
      BUF( 9) = BUF(13)
      BUF(11) = BUF(15)
      BUF(17) = BUF(19)
      DO 1352 K = 1,24,6
      BUF(K  ) = BUF(1)
 1352 BUF(K+1) = 12
      NN = 24
      GO TO 1345
C
 1354 L = 7
      BUF(7) = BUF(2)
      BUF(8) = 1
      CALL DPDAA
      BUF(3) = BUF(7)
      BUF(7) = BUF(3)
      BUF(8) = 1
      CALL DPDAA
      BUF(5) = BUF(7)
      BUF(6) = BUF(5)
      BUF(2) = 11
      MSG(3) = BUF(1)
      GO TO 1344
C
C     HERE WHEN ALL CARDS OF CURRENT TYPE HAVE BEEN READ.
C     TEST FOR ALL CARDS READ.
C
 1358 I  = I + 3
      II = II+ 1
      IF (II .LE. NOLINR) GO TO 1320
      CALL WRITE (SCR1,0,0,1)
      CALL CLOSE (SCR1,CLSREW)
      IF (NONLFT .EQ. -1) GO TO 1400
C
C     SORT THE DATA ON SET ID.
C
      IF (INCORE .NE. 0) GO TO 1362
      NNOLIN = J - 6
      N = J - INOLIN
      GO TO 1364
 1362 CALL OPEN (*2001,SCR1,Z(BUF2),RDREW)
      CALL READ (*2002,*1363,SCR1,Z,BUF1,1,N)
      CALL MESAGE (-8,0,NAM)
 1363 CALL CLOSE (SCR1,CLSREW)
      INOLIN = 1
      NNOLIN = N - 5
 1364 CALL SORT (0,0,6,1,Z(INOLIN),N)
C
C     READ USETD INTO CORE.
C
      FILE = USETD
      CALL OPEN (*2001,USETD,Z(BUF2),RDREW)
      CALL FWDREC (*2002,USETD)
      IUSETD = NNOLIN + 7
      CALL READ (*2002,*1365,USETD,Z(IUSETD),BUF2-IUSETD,1,N)
      CALL MESAGE (-8,0,NAM)
 1365 CALL CLOSE (USETD,CLSREW)
C
C     OPEN THE NLFT. WRITE SET IDS IN HEADER RECORD.
C
      FILE = NLFT
      CALL OPEN (*1392,NLFT,Z(BUF2),WRTREW)
      CALL FNAME (NLFT,BUF)
      CALL WRITE (NLFT,BUF,2,0)
      Z(NNOLIN+6) = 0
      DO 1371 I = INOLIN,NNOLIN,6
      IF (Z(I+6) .NE. Z(I)) CALL WRITE (NLFT,Z(I),1,0)
 1371 CONTINUE
      CALL WRITE (NLFT,0,0,1)
C
C     WRITE ONE RECORD PER SET. WITHIN EACH SET, SORT DATA ON SIL NO.
C     CONVERT SIL NOS. TO SIL NOS. IN UD AND UE SETS
C
      I = INOLIN
 1381 J = I
 1382 IF (Z(I+6) .NE. Z(I)) GO TO 1383
      I = I + 6
      GO TO 1382
 1383 N = I + 6 - J
C
C ... THE FOLLOWING SORT WAS REMOVED DUE TO THE INSTALLATION OF NOLIN5
C     CALL SORT (0,0,6,3,Z(J),N)
C
CWKBR SPR94005 6/94   DO 1387 KC = J,I,6                      
      DO 1387 K = J,I,6                
      BUF(1) = Z(K+1)
      BUF(2) = Z(K+2)
      BUF(4) = Z(K+3)
      BUF(5) = Z(K+4)
      BUF(8) = Z(K+5)
      BUF(9) = 0
      DO 1386 KK = 2,8,3
      IF (KK.GE.8 .AND. BUF(1).NE.2 .AND. BUF(1).NE.6 .AND. BUF(1).NE.9
     1   .AND.  BUF(1).NE.10.AND.KK.EQ.8) GO TO 1386
      K1 = 0
      K2 = 0
      NUSETD = IUSETD + BUF(KK) - 1
      IF (NUSETD .LT. IUSETD) GO TO 1385
      DO 1384 KKK = IUSETD,NUSETD
      BUF(10) = Z(KKK)
      IF (ANDF(BUF(10),MSKUD) .NE. 0) K1 = K1 + 1
      IF (ANDF(BUF(10),MSKUE) .NE. 0) K2 = K2 + 1
 1384 CONTINUE
 1385 BUF(KK  ) = K1
      BUF(KK+1) = K2
      IF (NUSETD .LT. IUSETD) GO TO 1386
      IF (ANDF(BUF(10),MSKUE) .EQ. 0) BUF(KK+1) = 0
      IF (ANDF(BUF(10),MSKUD) .NE. 0) GO TO 1386
      NOGO = 1
      BUF(1) = Z(K)
      BUF(2) = K1
      CALL MESAGE (30,93,BUF)
 1386 CONTINUE
      BUF(7) = BUF(8)
      BUF(8) = BUF(9)
      CALL WRITE (NLFT,BUF,8,0)
 1387 CONTINUE
      CALL WRITE (NLFT,0,0,1)
      I = I + 6
      IF (Z(I) .NE. 0) GO TO 1381
C
C     CLOSE FILE AND WRITE TRAILER.
C
      CALL CLOSE (NLFT,CLSREW)
      MCB(1) = NLFT
      MCB(2) = (NNOLIN-INOLIN)/6 + 1
      CALL WRTTRL (MCB)
      IF (INCORE .NE. 0) INEQ = 0
      GO TO 1400
 1392 NONLFT =-1
C
C     LOCATE TIC CARDS IN DYNAMICS POOL.
C
 1400 NOTRL =-1
      NOTIC = 0
      NOTSTP= 0
      CALL LOCATE (*1500,Z(BUF1),TIC,FLAG)
      NOTRL = 1
C
C     OPEN SCR1. INITIALIZE TO READ TIC CARDS.
C
      FILE = SCR1
      CALL OPEN (*2001,SCR1,Z(BUF2),WRTREW)
      ITIC = NEQDYN + 2
      NSET = BUF3 - 1
      J    = NSET
      L    = 2
      MSG(1) = 69
      ID   = 0
C
C     READ A TIC CARD. IF SET ID IS DIFFERENT, STORE IT IN LIST.
C     IF NOT FIRST CARD, SORT DATA ON SIL NO. AND WRITE IT IN SCR1.
C
 1420 CALL READ (*2002,*1440,DPOOL,BUF,5,0,FLAG)
      IF (BUF(1) .EQ. ID) GO TO 1430
      IF (ID .EQ. 0) GO TO 1421
      N = I - ITIC
      CALL SORT (0,0,3,1,Z(ITIC),N)
      CALL WRITE (SCR1,Z(ITIC),N,1)
 1421 ID = BUF(1)
      Z(J) = ID
      J  = J - 1
      I  = ITIC
      MSG(3) = ID
C
C     CONVERT POINT AND COMPONENT TO SIL NO.
C     STORE SIL NO., UO, VO IN CORE.
C
 1430 CALL DPDAA
      Z(I  ) = BUF(2)
      Z(I+1) = BUF(4)
      Z(I+2) = BUF(5)
      I = I + 3
      IF (I .LT. J) GO TO 1420
      CALL MESAGE (-8,0,NAM)
C
C     HERE WHEN LAST CARD READ - SORT AND WRITE LAST RECORD.
C
 1440 N = I - ITIC
      CALL SORT (0,0,3,1,Z(ITIC),N)
      CALL WRITE (SCR1,Z(ITIC),N,1)
      CALL CLOSE (SCR1,CLSREW)
      ISET = J + 1
C
C     OPEN TRL. WRITE SET IDS IN HEADER.
C
      FILE = TRL
      CALL OPEN (*1493,TRL,Z(BUF2),WRTREW)
      CALL FNAME (TRL,BUF)
      N = NSET - ISET + 1
      BUF(3) = N
      NOTIC  = N
      CALL WRITE (TRL,BUF,3,0)
      I  = ISET
      J  = NSET
 1451 ID = Z(J)
      Z(J) = Z(I)
      Z(I) = ID
      I  = I + 1
      J  = J - 1
      IF (I .LT. J) GO TO 1451
      CALL WRITE (TRL,Z(ISET),N,0)
C
C     READ USETD INTO CORE.
C     COMPUTE NO. OF POINTS UN UD SET. WRITE NO. AS LAST WORD OF HEADER.
C
 1460 FILE = USETD
      CALL OPEN (*2001,USETD,Z(BUF3),RDREW)
      CALL FWDREC (*2002,USETD)
      IUSETD = 1
      INEQ   = 0
      CALL READ (*2002,*1462,USETD,Z(IUSETD),BUF3-IUSETD,1,N)
      CALL MESAGE (-8,0,NAM)
 1462 CALL CLOSE (USETD,CLSREW)
      NUSETD = IUSETD + N - 1
      K = 0
      DO 1463 I = IUSETD,NUSETD
      IF (ANDF(Z(I),MSKUD) .NE. 0) K = K + 1
 1463 CONTINUE
      CALL WRITE (TRL,K,1,1)
      IF (NOTIC .EQ. 0) GO TO 1481
C
C     READ SCR1. CONVERT SIL NO. TO AN SIL NO. IN THE D-SET.
C     WRITE TRL ONE RECORD PER SET.
C
      FILE = SCR1
      KSET = ISET
      CALL OPEN (*2001,SCR1,Z(BUF3),RDREW)
 1475 K = 0
      IPOINT = IUSETD
 1471 CALL READ (*1474,*1473,SCR1,BUF,3,0,FLAG)
      NUSETD = IUSETD + BUF(1) - 1
      DO 1472 I = IPOINT,NUSETD
      IF (ANDF(Z(I),MSKUD) .NE. 0) K = K + 1
 1472 CONTINUE
      BUF(1) = K
      IF (ANDF(Z(NUSETD),MSKUD) .NE. 0) GO TO 1476
      NOGO = 1
      CALL MESAGE (30,133,Z(KSET))
 1476 CALL WRITE (TRL,BUF,3,0)
      IPOINT = NUSETD + 1
      GO TO 1471
 1473 CALL WRITE (TRL,0,0,1)
      KSET = KSET + 1
      GO TO 1475
 1474 CALL CLOSE (SCR1,CLSREW)
C
C     IF TSTEP CARDS PRESENT, COPY THEM ONTO TRL.
C
      CALL LOCATE (*1490,Z(BUF1),TSTEP,FLAG)
 1481 CALL READ (*2002,*1483,DPOOL,BUF,1,0,FLAG)
      NOTSTP = NOTSTP + 1
      CALL WRITE (TRL,BUF,1,0)
 1482 CALL READ (*2002,*2003,DPOOL,BUF,3,0,FLAG)
      IF (BUF(1) .EQ. -1) GO TO 1485
      CALL WRITE (TRL,BUF,3,0)
      GO TO 1482
 1485 CALL WRITE (TRL,0,0,1)
      GO TO 1481
 1483 CONTINUE
C
C     CLOSE FILES AND WRITE TRAILER.
C
 1490 CALL CLOSE (TRL,CLSREW)
      MCB(1) = TRL
      MCB(2) = NOTIC
      MCB(3) = NOTSTP
      CALL WRTTRL (MCB)
 1492 CALL CLOSE (DPOOL,CLSREW)
      RETURN
C
 1493 NOTRL = -1
      GO TO 1492
C
C     HERE IF NO TIC CARDS - LOCATE TSTEP CARDS IN DYNAMICS POOL.
C     IF ABSENT, RETURN. OTHERWISE OPEN TRL AND WRTIE HEADER.
C
 1500 CALL LOCATE (*1492,Z(BUF1),TSTEP,FLAG)
      NOTRL = 1
      FILE  = TRL
      CALL OPEN (*1493,TRL,Z(BUF2),WRTREW)
      CALL FNAME (TRL,BUF)
      BUF(3) = 0
      CALL WRITE (TRL,BUF,3,0)
      GO TO 1460
C
C     FATAL FILE ERRORS
C
 2001 N = -1
      GO TO 2005
 2002 N = -2
      GO TO 2005
 2003 N = -3
 2005 CALL MESAGE (N,FILE,NAM)
      RETURN
      END

      SUBROUTINE COMB1
C
C     THIS IS THE MODULE FOR THE COMBINATION OF SUBSTRUCTURES.
C
C     IT IS PRIMARILY AN INITIALIZER AND DRIVER CALLING THE ROUTINES
C     NECESSARY TO PROCESS THE COMBINE. THE SUBROUTINES ARE
C
C          CMCASE  -  READS THE CASECC DATA BLOCK AND INITIALIZES
C                     PARAMETERS FOR THE COMBINE OPERATION.
C          CMTOC   -  GENERATES THE TABLE OF CONTENTS OF PSEUDO-
C                     STRUCTURES BEING COMBINED AND THEIR COMPONENT
C                     BASIC SUBSTRUCTURES.
C          BDAT01  -  PROCESSES THE CONCT1 BULK DATA.
C          BDAT02  -  PROCESSES THE CONCT  BULK DATA.
C          BDAT03  -  PROCESSES THE TRANS  BULK DATA.
C          BDAT04  -  PROCESSES THE RELES  BULK DATA.
C          BDAT05  -  PROCESSES THE GNEW   BULK DATA.
C          BDAT06  -  PROCESSES THE GTRAN  BULK DATA.
C          CMSFIL  -  GENERATES SUBFIL - THE BASIC FILE USED TO STORE
C                     THE DATA NECESSARY TO AFFECT THE COMBINATION.
C          CMCONT  -  GENERATES THE CONNECTION ENTRIES TO BE USED.
C          CMCKCD  -  CHECKS VALIDITY OF MANUALLY-SPECIFIED CONNECTIONS
C          CMAUTO  -  PROCESSES USERS REQUEST FOR AUTOMATIC
C                     COMBINATION OF SUBSTRUCTURES.
C          CMRELS  -  APPLIES ANY MANUAL RELEASE DATA TO THE SYSTEM.
C          CMCOMB  -  PROCESSES MULTIPLY CONNECTED POINTS.
C          CMDISC  -  PROCESSES GRID POINTS NOT TO BE CONNECTED.
C          CMSOFO  -  GENERATES NEW SOF ITEMS FOR THE RESULTANT
C                     COMBINED STRUCTURE.
C          CMHGEN  -  GENERATES THE DOF TRANSFORMATION MATRIX FOR
C                     EACH COMPONENT TO THE COMBINATION
C
      LOGICAL         TDAT,CONECT,IAUTO,TRAN,MCON,TOCOPN,LONLY
      INTEGER         SCR1,SCR2,SCBDAT,SCSFIL,SCCONN,SCMCON,SCTOC,GEOM4,
     1                CASECC,BUF1,BUF2,BUF3,BUF4,BUF5,SCORE,DRY,STEP,
     2                SYS,OUTT,AAA(2),RESTCT,SCCSTM,SCR3
      CHARACTER       UFM*23,UWM*25,UIM*29
      COMMON /XMSSG / UFM,UWM,UIM
      COMMON /CMB001/ SCR1,SCR2,SCBDAT,SCSFIL,SCCONN,SCMCON,SCTOC,
     1                GEOM4,CASECC,SCCSTM,SCR3
      COMMON /CMB002/ BUF1,BUF2,BUF3,BUF4,BUF5,SCORE,LCORE,INTP,OUTT
      COMMON /CMB003/ COMBO(7,5),CONSET,IAUTO,TOLER,NPSUB,CONECT,TRAN,
     1                MCON,RESTCT(7,7),ISORT,ORIGIN(7,3),IPRINT,TOCOPN
      COMMON /CMB004/ TDAT(6),NIPNEW,CNAM(2),LONLY
      COMMON /ZZZZZZ/ Z(1)
      COMMON /SYSTEM/ SYS(69)
      COMMON /BLANK / STEP,DRY
      DATA    AAA   / 4HCOMB,4H1    /
C
      IF (DRY.EQ.0 .OR. DRY.EQ.-2) GO TO 210
      SCR1   = 301
      SCR2   = 302
      SCBDAT = 303
      SCSFIL = 304
      SCCONN = 305
      SCMCON = 306
      SCTOC  = 307
      SCCSTM = 308
      SCR3   = 309
      GEOM4  = 102
      CASECC = 101
      DO 10 I = 1,6
      TDAT(I) = .FALSE.
   10 CONTINUE
      DO 20 I = 1,7
      DO 20 J = 1,3
      ORIGIN(I,J) = 0.0
   20 CONTINUE
      LONLY = .FALSE.
      INTP  = SYS(4)
      OUTT  = SYS(2)
      IBUF  = SYS(1)
C
      NZ    = KORSZ(Z(1))
      BUF1  = NZ - IBUF - 2
      BUF2  = BUF1 - IBUF
      BUF3  = BUF2 - IBUF
      BUF4  = BUF3 - IBUF
      BUF5  = BUF4 - IBUF
      IB1   = BUF5 - IBUF
      IB2   = IB1  - IBUF
      IB3   = IB2  - IBUF
      SCORE = 1
      LCORE = IB3 - 1
      IF (LCORE .GT. 0) GO TO 30
      CALL MESAGE (8,0,AAA)
      DRY   = -2
      GO TO 210
C
   30 CALL OPEN (*120,SCCONN,Z(BUF2),1)
      CALL CLOSE (SCCONN,2)
      CALL SOFOPN (Z(IB1),Z(IB2),Z(IB3))
C
      CALL CMCASE
      IF (DRY .EQ. -2) GO TO 130
      CALL CMTOC
      IF (.NOT.LONLY) GO TO 40
      CALL CMSOFO
      GO TO 70
C
   40 IFILE = GEOM4
      CALL PRELOC (*90,Z(BUF1),GEOM4)
      IF (.NOT.CONECT) GO TO 50
      CALL BDAT01
      CALL BDAT02
   50 IFILE = SCBDAT
      CALL OPEN (*120,SCBDAT,Z(BUF2),1)
      CALL BDAT05
      CALL BDAT06
      CALL BDAT03
      CALL CLOSE (GEOM4,1)
C
      CALL CMSFIL
      CALL PRELOC (*100,Z(BUF1),GEOM4)
      CALL BDAT04
      CALL CLOSE (GEOM4,1)
      IF (DRY .EQ. -2) GO TO 150
   60 IF (TDAT(1) .OR. TDAT(2)) CALL CMCONT
      IF (DRY .EQ. -2) GO TO 170
      CALL CMAUTO
      IF (TDAT(1) .OR. TDAT(2)) CALL CMCKCD
      IF (DRY .EQ. -2) GO TO 170
      IF (TDAT(4)) CALL CMRELS
      CALL CMMCON (NCE)
      NPS  = NPSUB + 1
      NDOF = 6
      IF (MCON) CALL CMCOMB (NPS,NCE,NDOF,Z)
      IF (DRY .EQ. -2) GO TO 170
C
      CALL CMCKDF
      IF (DRY .EQ. -2) GO TO 170
      CALL CMDISC
      CALL CMSOFO
      CALL CMHGEN
C
   70 CALL SOFCLS
      IF (TOCOPN) CALL CLOSE (SCTOC,1)
      WRITE  (OUTT,80) UIM
   80 FORMAT (A29,' 6521, MODULE COMB1 SUCCESSFULLY COMPLETED.')
      GO TO 210
C
   90 IF (CONECT .OR. TRAN) GO TO 100
      IFILE = SCBDAT
      CALL OPEN (*120,SCBDAT,Z(BUF2),1)
      CALL EOF (SCBDAT)
      CALL CLOSE (SCBDAT,1)
      CALL CMSFIL
      IF (.NOT.CONECT) GO TO 60
C
C     ERRORS
C
  100 WRITE  (OUTT,110) UFM
  110 FORMAT (A23,' 6510, THE REQUESTED COMBINE OPERATION REQUIRES ',
     1       'SUBSTRUCTURE BULK DATA WHICH HAS NOT BEEN GIVEN.')
      GO TO  190
  120 CALL MESAGE (1,SCBDAT,AAA)
      GO TO  170
  130 WRITE  (OUTT,140) UFM
  140 FORMAT (A23,' 6535, MODULE COMB1 TERMINATING DUE TO ABOVE ',
     1       'SUBSTRUCTURE CONTROL ERRORS.')
      GO TO  200
  150 WRITE  (OUTT,160) UFM
  160 FORMAT (A23,' 6536, MODULE COMB1 TERMINATING DUE TO ABOVE ERRORS',
     1       ' IN BULK DATA.')
      GO TO  190
  170 WRITE  (OUTT,180) UFM
  180 FORMAT (A23,' 6537, MODULE COMB1 TERMINATING DUE TO ABOVE ERRORS')
  190 IF (TOCOPN) CALL CLOSE (SCTOC,1)
  200 DRY = -2
      CALL SOFCLS
  210 RETURN
      END

      SUBROUTINE SMPYAD
C
      INTEGER         SRESLT   ,SADD     ,TMAT     ,TRLRA    ,TRLRB  ,
     1                TRLRC    ,TRLRD    ,TRNSP    ,SIGNAB   ,SIGNC  ,
     1                SCRTCH   ,TRLR(7,5),MAT(5)   ,ADDMAT   ,RESMAT ,
     1                RECMAT   ,DOSI(3)  ,REFUS(3) ,OUTPT    ,NAME(2)
      CHARACTER       UFM*23   ,UWM*25   ,UIM*29   ,SFM*25   ,SWM*27
      COMMON /XMSSG / UFM      ,UWM      ,UIM      ,SFM      ,SWM
      COMMON /MPYADX/ TRLRA(7) ,TRLRB(7) ,TRLRC(7) ,TRLRD(7) ,NA     ,
     1                TRNSP    ,SIGNAB   ,SIGNC    ,IPREC1   ,SCRTCH
     2       /ZZZZZZ/ A(1)
     3       /BLANK / N        ,SRESLT   ,SADD     ,IPREC    ,TMAT(4)
     4       /SYSTEM/ KSYSTM(65)
      EQUIVALENCE     (KSYSTM(55),KPREC) ,(KSYSTM(2),OUTPT)
      DATA    MAT   / 101      ,102      ,103      ,104      ,105 /
      DATA    ADDMAT, RESMAT   ,INTRES   ,MPYADS   ,RECMAT        /
     1        106   , 201      ,301      ,302      ,2             /
      DATA    DOSI  / 4HSING   ,4HDOUB   ,4HMLTP   /
      DATA    REFUS / 2*3H     ,3HREF    /
      DATA    NAME  / 4HSMPY   ,4HAD     /
     1
C
      IF (N .LE. 1) GO TO 200
      IF (N .GT. 5) N = 5
      IPREC1 = 1
      ITYPE  = 0
C
C     IF ONE OF THE -N- MATRICES IN THE PRODUCT DOES NOT EXIST,
C     SKIP THE ENTIRE CALCULATION.
C
      DO 101 I = 1,N
      TRLR(1,I) = MAT(I)
      CALL RDTRL (TRLR(1,I))
      IF (TRLR(1,I).LE.0 .OR. TRLR(2,I).LE.0 .OR. TRLR(3,I).LE.0)
     1    GO TO 200
      IF (TRLR(5,I).EQ.2 .OR. TRLR(5,I).EQ.4) IPREC1 = 2
      IF (TRLR(5,I).EQ.3 .OR. TRLR(5,I).EQ.4) ITYPE  = 2
  101 CONTINUE
C
C     CHECK TO SEE IF THE INPUT MATRICES ARE CONFORMABLE
C
      NM1  = N - 1
      NOGO = 0
      DO 170 I = 1,NM1
      ICOL = TRLR(2,I)
      IF (TMAT(I) .NE. 0) ICOL = TRLR(3,I)
      IROW = TRLR(3,I+1)
      IF (I .EQ. NM1) GO TO 160
      IF (TMAT(I+1) .NE. 0) IROW = TRLR(2,I+1)
  160 IF (ICOL .NE. IROW) NOGO = 1
  170 CONTINUE
      TRLRC(1) = ADDMAT
      CALL RDTRL (TRLRC)
      IF (TRLRC(1) .LE. 0) GO TO 180
      IROW = TRLR(3,1)
      IF (TMAT(1) .NE. 0) IROW = TRLR(2,1)
      ICOL = TRLR(2,N)
      IF (IROW.NE.TRLRC(3) .OR. ICOL.NE.TRLRC(2)) NOGO = 1
  180 IF (NOGO .EQ. 1) CALL MESAGE (-55,0,NAME)
C
      IF (IPREC1.LT.1 .OR. IPREC1.GT.2) IPREC1 = KPREC
      IF (IPREC.EQ.IPREC1 .OR. IPREC.EQ.0) GO TO 222
      IF (IPREC.LT.1 .OR. IPREC.GT.2) IPREC = 3
      WRITE  (OUTPT,221) SWM,DOSI(IPREC),REFUS(IPREC),NAME,DOSI(IPREC1)
  221 FORMAT (A27,' 2163, REQUESTED ',A4,'LE PRECISION ',A3,'USED BY ',
     1        2A4,2H. ,A4,'LE PRECISION IS LOGICAL CHOICE')
      IF (IPREC .NE. 3) IPREC1 = IPREC
  222 IPREC = IPREC1
      ITYPE = ITYPE + IPREC1
C
C     SETUP THE MPYADX COMMON BLOCK.
C
      IF ((N+1)/2 .EQ. N/2) GO TO 105
      TRLRB(1) = INTRES
      M = RESMAT
      GO TO 106
  105 TRLRB(1) = RESMAT
      M = INTRES
  106 TRLRC(1) = 0
      DO 107 I = 1,7
      TRLRD(I) = TRLR(I,N)
  107 CONTINUE
      TRLRD(4) = RECMAT
      NA = KORSZ(A)
      SIGNAB = 1
      SIGNC  = SADD
      SCRTCH = MPYADS
C
C     DO THE N-1 MULTIPLICATIONS.
C
      DO 125 K = 2,N
      J = N - K + 1
      TRLRA(1) = TRLR(1,J)
      IF (K .NE. 3) L = TRLRB(1)
      IF (K .EQ. 3) L = M
      TRLRB(1) = TRLRD(1)
      TRLRD(1) = L
      DO 110 I = 2,7
      TRLRA(I) = TRLR(I,J)
      TRLRB(I) = TRLRD(I)
  110 CONTINUE
      IF (K .NE. N) GO TO 111
      TRLRC(1) = ADDMAT
      CALL RDTRL (TRLRC)
      IF (TRLRC(1). LT. 0) TRLRC(1) = 0
      TRLRD(5) = ITYPE
      SIGNAB   = SRESLT
      GO TO 115
  111 TRLRD(5) = IPREC1
      IF (TRLRA(5).GT.2 .OR. TRLRB(5).GT.2) TRLRD(5) = IPREC1 + 2
  115 TRNSP = TMAT(J)
      TRLRD(3) = TRLRA(3)
      IF (TRNSP .NE. 0) TRLRD(3) = TRLRA(2)
      TRLRD(2) = TRLRB(2)
      CALL MPYAD (A,A,A)
  125 CONTINUE
      IF (TRLRD(2) .EQ. TRLRD(3)) TRLRD(4) = 1
      CALL WRTTRL (TRLRD)
  200 RETURN
      END

      SUBROUTINE AMGT1C (Q,NSTNS2,C1SBAR,C2SBAR)
C
C     SUPERSONIC CASCADE CODE FOR SWEPT TURBOPROPS.
C
      INTEGER         SLN
      REAL            M2SBAR
      COMPLEX         SBKDE1,SBKDE2,F4,F4S,AM4,F5S,F6S,AM4TST,SUM3,SUM4,
     1                AM5TT,AM6,SUMSV1,SUMSV2,SVKL1,SVKL2,F5,F5T,AM5,
     2                AM5T,AI,A,B,BSYCON,ALP,F1,AM1,ALN,BLKAPM,BKDEL3,
     3                F1S,C1,C2P,C2N,C2,AMTEST,FT2,BLAM1,FT3,AM2,SUM1,
     4                SUM2,F2,BLAM2,FT2T,C1T,FT3T,F2P,AM2P,SUM1T,SUM2T,
     5                C1P,C1N,BKDEL1,BKDEL2,BLKAP1,ARG,ARG2,FT3TST,BC,
     6                BC2,BC3,BC4,BC5,CA1,CA2,CA3,CA4,CLIFT,CMOMT,
     7                PRES1,PRES2,PRES3,PRES4,QRES4,FQA,FQB,FQ7,PRESU,
     8                PRESL,Q,GUSAMP
      DIMENSION       GYE(29,29),GEE(29,80),PRESU(29),PRESL(29),XUP(29),
     1                XTEMP(29),GEETMP(29,40),XLOW(29),AYE(10,29),
     2                INDEX(29,3),Q(NSTNS2,NSTNS2),PRES1(21),PRES2(21),
     3                PRES3(21),PRES4(21),QRES4(21),SBKDE1(201),
     4                SBKDE2(201),SUMSV1(201),SUMSV2(201),SVKL1(201),
     5                SVKL2(201),XLSV1(21),XLSV2(21),XLSV3(21),XLSV4(21)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /SYSTEM/ SYSBUF,IBBOUT
      COMMON /TAMG1L/ IREF,MINMAC,MAXMAC,NLINES,NSTNS,REFSTG,REFCRD,
     1                REFMAC,REFDEN,REFVEL,REFSWP,SLN,NSTNSX,STG,
     2                CHORD,DCBDZB,BSPACE,MACH,DEN,VEL,SWEEP,AMACHD,
     3                REDFD,BLSPC,AMACHR,TSONIC
      COMMON /AMGMN / MCB(7),NROW,DUM(2),REFC,SIGM,RFREQ
      COMMON /BLK1  / SCRK,SPS,SNS,DSTR,AI,PI,DEL,SIGMA,BETA,RES
      COMMON /BLK2  / BSYCON
      COMMON /BLK3  / SBKDE1,SBKDE2,F4,F4S,AM4,F5S,F6S,AM4TST,SUM3,SUM4,
     1                AM5TT,AM6,SUMSV1,SUMSV2,SVKL1,SVKL2,F5,F5T,AM5,
     2                AM5T,A,B,ALP,F1,AM1,ALN,BLKAPM,BKDEL3,F1S,C1,C2P,
     3                C2N,C2,AMTEST,FT2,BLAM1,FT3,AM2,SUM1,SUM2,F2,
     4                BLAM2,FT2T,C1T,FT3T,F2P,AM2P,SUM1T,SUM2T,C1P,C1N,
     5                BKDEL1,BKDEL2,BLKAP1,ARG,ARG2,FT3TST,BC,BC2,BC3,
     6                BC4,BC5,CA1,CA2,CA3,CA4,CLIFT,CMOMT,PRES1,PRES2,
     7                PRES3,PRES4,QRES4,FQA,FQB,FQ7
      COMMON /BLK4  / I,R,Y,A1,B1,C4,C5,GL,I6,I7,JL,NL,RI,RT,R5,SN,SP,
     1                XL,Y1,AMU,GAM,IDX,INX,NL2,RL1,RL2,RQ1,RQ2,XL1,
     2                ALP1,ALP2,GAMN,GAMP,INER,IOUT,REDF,STAG,STEP,
     3                AMACH,BETNN,BETNP,BKAP1,XLSV1,XLSV2,XLSV3,XLSV4,
     4                ALPAMP,AMOAXS,GUSAMP,DISAMP,PITAXS,PITCOR
C
C
C     THEORY DEPENDENT RESTRICTION OF NO MORE THAN 10 COMPUTING
C     STATIONS PER STREAMLINE IS REFLECTED IN CODING.
C
      IF (NSTNS .GT. 10) GO TO 9993
C
      REDF  = REDFD
      AMACH = AMACHD
      AI    = CMPLX(0.0,1.0)
      PI    = 3.1415927
      PITCOR= BLSPC
      STAG  = 90.0 - STG
      SIGMA = -SIGM*PI/180.0
      BETA  = SQRT(AMACH**2-1.0)
      SCRK  = REDF*AMACH/(BETA**2)
      DEL   = SCRK*AMACH
      AMU   = REDF/(BETA**2)
      SP    = PITCOR*COS(STAG*PI/180.0)*2.0
      SN    = PITCOR*SIN(STAG*PI/180.0)*2.0
      SPS   = SP
      SNS   = SN*BETA
      DSTR  = SQRT(SPS**2-SNS**2)
      SPS1  = ABS(SPS-SNS)
      IF (SPS1 .LT. .00001)  GO TO 9991
C
C     PARAMETERS RELATED TO SWEEP CHANGES
C
      CSBAR  = .25*(DEN*VEL**2*CHORD**2)/(REFDEN*REFVEL**2)
      CSBAR1 = 2.0/CHORD
      M2SBAR = -DCBDZB/CHORD
      C2SSCH = CSBAR1*C2SBAR
      CSBLSB = CSBAR*CSBAR1
      CSBM2S = CSBAR*M2SBAR
      TANLAM = TAN(SWEEP*PI/180.)
      DLSDZB = DCBDZB/2.0
      TD     = TANLAM*DLSDZB
C
C     ZERO OUT GEE
C
      NSTNS4 = 4*NSTNS
      NSTNS8 = 8 * NSTNS
      DO 50 I = 1,29
      DO 50 J = 1,NSTNS8
   50 GEE(I,J) = 0.0
      PITAXS   = 0.0
      AMOAXS   = 0.
      CALL ASYCON
      CALL AKP2
      RL1 = 9
      S1  = SPS - SNS
      AA  = S1/RL1
      XLSV1(1) = 0.0
      DO 4541 JL = 1,9
4541  XLSV1(JL+1) = JL*AA
      AA  = SPS - SNS
      RL2 = 19
      S1  = 2.0 + SNS - SPS
      TEMP= S1/RL2
      XL  = AA
      DO 4571 JL = 1,20
      XLSV2(JL) = XL
      XLSV3(JL) = XL + SNS - SPS
4571  XL = XL + TEMP
      XL = SNS + 2.0 - SPS
      TEMP = (SPS-SNS)/RL1
      DO 458 JL = 1,10
      XLSV4(JL) = XL
458   XL = XL + TEMP
C
C     ACCUMULATE PRESSURE VECTORS INTO G-MATRIX
C
      DO 100 NM = 1,NSTNS
      NTIMES = 1
      IF (NM .GT. 2) NTIMES = 2
      DO 100 NMM = 1,NTIMES
C
      JNDX = 0
 5000 IF (JNDX .EQ. 0) GO TO 5010
C
      IF (NM .GT. 2) GO TO 5020
C
      GL = 0.0
      IF (NM .EQ. 1) A = TANLAM/CSBAR1
      IF (NM .EQ. 1) B = 0.0
      IF (NM .EQ. 2) A = 0.0
      IF (NM .EQ. 2) B = TANLAM/CSBAR1
C
      GO TO 2047
C
 5020 IF (NMM .EQ. 1) GUSAMP =-AI*TANLAM/CSBAR1/2.0
      IF (NMM .EQ. 1) GL = (NM-2)*PI/2.0
      IF (NMM .EQ. 2) GUSAMP = AI*TANLAM/CSBAR1/2.0
      IF (NMM .EQ. 2) GL =-(NM-2)*PI/2.0
C
      A = GUSAMP
      B = 0.0
C
      GO TO 2047
C
C     DEFINE -----------------------------
C              ALPAMP - PITCHING AMP
C              DISAMP - PLUNGING AMP
C              GUSAMP - GUST AMP
C              GL -GUST WAVE NUMBER
 5010 ALPAMP = 0.0
      IF (NM .EQ. 2) ALPAMP = 1.0
      DISAMP = 0.0
      IF (NM .EQ. 1) DISAMP = 1.0
      GUSAMP = 0.0
      GL     = 0.0
      IF (NM.GT.2 .AND. NMM.EQ.1) GUSAMP =-(REDF+AI*TD)/2.+(NM-2)*PI/4.
      IF (NM.GT.2 .AND. NMM.EQ.1) GL = (NM-2)*PI/2.0
      IF (NM.GT.2 .AND. NMM.EQ.2) GUSAMP = (REDF+AI*TD)/2.+(NM-2)*PI/4.
      IF (NM.GT.2 .AND. NMM.EQ.2) GL =-(NM-2)*PI/2.0
C
      A = (1.0+AI*REDF*PITAXS)*ALPAMP - (AI*REDF-TD)*DISAMP
      B =-(AI*REDF-TD)*ALPAMP
      IF (GL .EQ. 0.0) GO TO 2047
      A = GUSAMP
      B = 0.0
 2047 CONTINUE
C
      CALL SUBA
C
C     FIND  DELTA P(LOWER-UPPER)
C
      DO 60 NX = 1,10
      PRESU(NX) = PRES1(NX)
      XUP(NX)   = XLSV1(NX)
      IF (NX .EQ. 10) GO TO 55
      NXX = NX + 20
      PRESL(NXX) = PRES4(NX+1)
      XLOW( NXX) = XLSV4(NX+1)
      GO TO 610
   55 PRESU(NX) = (PRES1(10) + PRES2(1))/2.0
      XUP(10)   = (XLSV1(10) + XLSV2(1))/2.0
 610  CONTINUE
   60 CONTINUE
      DO 70 NX = 1,20
      NXX = NX + 10
      IF (NX .EQ. 20) GO TO 65
      PRESU(NXX) = PRES2(NX+1)
      XUP  (NXX) = XLSV2(NX+1)
      PRESL(NX)  = PRES3(NX  )
      XLOW( NX)  = XLSV3(NX  )
      GO TO 710
   65 PRESL(20) = (PRES3(20) + PRES4(1))/2.0
      XLOW(20)  = (XLSV3(20) + XLSV4(1))/2.0
  710 CONTINUE
   70 CONTINUE
C
      JX   = JNDX*4*NSTNS
      NMZ  = NM + JX
      NM2Z = NM + NSTNS   + JX
      NM3Z = NM + 2*NSTNS + JX
      NM4Z = NM + 3*NSTNS + JX
C
      DO 101 NMMM = 1,29
      GEE(NMMM,NMZ ) = GEE(NMMM,NMZ ) + REAL(PRESL(NMMM))
      GEE(NMMM,NM2Z) = GEE(NMMM,NM2Z) + AIMAG(PRESL(NMMM))
      GEE(NMMM,NM3Z) = GEE(NMMM,NM3Z) + REAL(PRESU(NMMM))
      GEE(NMMM,NM4Z) = GEE(NMMM,NM4Z) + AIMAG(PRESU(NMMM))
C
  101 CONTINUE
C
      IF (JNDX .NE. 0) GO TO 100
      JNDX = 1
      GO TO 5000
C
  100 CONTINUE
C
C     NOW DEFINE  I-MATRIX (NSTNS X 29)
C
      AYE(1,1) = C1SBAR*2.0 + C2SSCH*2.0
      AYE(1,2) = C1SBAR*8.0/3.0 + C2SSCH*2.0
      AYE(2,1) = C1SBAR*8.0/3.0 + C2SSCH*2.0
      AYE(2,2) = C1SBAR*4.0 + C2SSCH*8.0/3.0
C
      CONZ1 = 1.0
C
      DO 280 I = 3,NSTNS
      CONZ4 = (1.+CONZ1 )*2./(PI*(J-2))
      CONZ5 = CONZ1*4./ (PI*(J-2))
      CONZ6 = CONZ1*8./(PI*(J-2)) - (1.+CONZ1)*16./(PI*(J-2))**3
C
      AYE(I,1) = C1SBAR*CONZ5 + C2SSCH*CONZ4
      AYE(I,2) = C1SBAR*CONZ6 + C2SSCH*CONZ5
  280 CONZ1    = -CONZ1
C
      CONZ1 = 1.0
C
      DO 282 J = 3,29
      CONZ4 = (1.+CONZ1)*2./(PI*(J-2))
      CONZ5 = CONZ1*4./(PI*(J-2))
      CONZ6 = CONZ1*8./(PI*(J-2)) - (1.+CONZ1)*16./(PI*(J-2))**3
C
      AYE(1,J) = C1SBAR*CONZ5 + C2SSCH*CONZ4
      AYE(2,J) = C1SBAR*CONZ6 + C2SSCH*CONZ5
  282 CONZ1    = -CONZ1
C
      DO 284 I = 3, NSTNS
C
      DO 284 J = 3,29
      CONZ1 = 0.0
      IF (J .EQ. I) GO TO 286
      IF ((I+J)/2*2 .EQ. (I+J)) GO TO 285
      CONZ1 = -16.*(I-2)*(J-2)/(PI*PI*(I-J)*(I-J)*(I+J-4)**2)
  285 CONZ2 = 0.0
      GO TO 284
  286 CONZ1 = 1.0
      CONZ2 = 1.0
  284 AYE(I,J) = C1SBAR*CONZ1 + C2SSCH*CONZ2
C
C
C     Q DUE TO PRESL ONLY
C
C     NOW DEFINE LARGE G MATRIX
C
      DO 110 I = 1,29
      GYE(1,I) = 0.0
  110 GYE(I,1) = 1.0
C
C     PUT XLOW IN XTEMP
C
      DO 120 I = 1,29
  120 XTEMP(I) = XLOW(I)
      DO 160 J = 3,29
      CONST = (J-2)*PI/2.0
      DO 160 I = 2,29
      GYE(I,J) = SIN(CONST*XTEMP(I))
  160 CONTINUE
      DO 165 I = 2,29
  165 GYE(I,2) = XTEMP(I)
C
C     PUT PRESL PARTS OF GEE IN GEETMP (UNPRIMED AND PRIMED TERMS)
C
      DO 1655 I = 1,29
      DO 1655 J = 1,NSTNS2
      GEETMP(I,J) = GEE(I,J)
 1655 GEETMP(I,J+NSTNS2) = GEE(I,J+NSTNS4)
C
C     SOLVE FOR G-INVERSE G IN GEE MATRIV
C     ISING = 1  NON-SINGULAR (GYE)
C     ISING = 2  SIGULAR      (GYE)
C     INDEX IS WORK STORAGE FOR ROUTINE INVERS
C
      ISING = -1
      CALL INVERS (29,GYE,29,GEETMP,NSTNS4,DETERM,ISING,INDEX)
      IF (ISING .EQ. 2) GO TO 9992
C
C     NOW  MULTIPLY  I*G-INVERSE*G(DELTA P'S)
C
      DO  360  J = 1,NSTNS
      DO  360  K = 1,NSTNS
C
      SUMR1 = 0.0
      SUMI1 = 0.0
      SUMR2 = 0.0
      SUMI2 = 0.0
C
      DO 350 I = 1,29
      SUMR1 = SUMR1 + AYE(J,I)*GEETMP(I,K)
      SUMI1 = SUMI1 + AYE(J,I)*GEETMP(I,K+NSTNS)
      SUMR2 = SUMR2 + AYE(J,I)*GEETMP(I,K+NSTNS4)
  350 SUMI2 = SUMI2 + AYE(J,I)*GEETMP(I,K+NSTNS+NSTNS4)
C
      CONZ1 = CSBLSB*SUMR1 + CSBM2S*SUMR2
      CONZ2 = CSBLSB*SUMI1 + CSBM2S*SUMI2
      CONZ3 = CSBAR*SUMR2
      CONZ4 = CSBAR*SUMI2
C
      Q(J,K      ) = 2.0*CMPLX(CONZ1,-CONZ2)
      Q(J,K+NSTNS) = 2.0*CMPLX(CONZ3,-CONZ4)
      Q(J+NSTNS,K) = (0.0,0.0)
  360 Q(J+NSTNS,K+NSTNS) = (0.0,0.0)
C
C     FINALLY, Q DUE TO (PRESL-PRESU) IS COMPUTED BY SUBTRACTING Q DUE
C     TO PRESU FROM Q DUE TO PRESL ABOVE
C
C     LARGE G MATRIX
C
      DO 1101 I = 1,29
      GYE(1,I) = 0.0
 1101 GYE(I,1) = 1.0
C
C     PUT XUP IN XTEMP
C
      DO 1201 I = 1,29
 1201 XTEMP(I) = XUP(I)
      DO 1601 J = 3,29
      CONST = (J-2)*PI/2.0
      DO 1601 I = 2,29
      GYE(I,J) = SIN(CONST*XTEMP(I))
 1601 CONTINUE
      DO 1651 I = 2,29
 1651 GYE(I,2) = XTEMP(I)
C
C     PUT PRESU PARTS OF GEE IN GEETMP (UNPRIMED AND PRIMED TERMS)
C
      DO 2655 I = 1,29
      DO 2655 J = 1,NSTNS2
C
      NSNS2 = NSTNS2 + J
      GEETMP(I,J) = GEE(I,NSNS2)
 2655 GEETMP(I,NSNS2) = GEE(I,NSNS2+NSTNS4)
C
C     SOLVE FOR G-INVERSE G IN GEETMP MATRIX
C     ISING = 1  NON-SINGULAR (GYE)
C     ISING = 2  SINGULAR GYE
C     INDEX IS WORK STORAGE FOR ROUTINE INVERS
C
      ISING = -1
      CALL INVERS (29,GYE,29,GEETMP,NSTNS4,DETERM,ISING,INDEX)
C
      IF (ISING .EQ. 2) GO TO 9992
C
C    MULTIPLY I*G-INVERS*G
C
      DO 3601 J = 1,NSTNS
      DO 3601 K = 1,NSTNS
C
      SUMR1 = 0.0
      SUMI1 = 0.0
      SUMR2 = 0.0
      SUMI2 = 0.0
C
      DO 3501 I = 1, 29
      SUMR1 = SUMR1 + AYE(J,I)*GEETMP(I,K)
      SUMI1 = SUMI1 + AYE(J,I)*GEETMP(I,K+NSTNS)
      SUMR2 = SUMR2 + AYE(J,I)*GEETMP(I,K+NSTNS4)
 3501 SUMI2 = SUMI2 + AYE(J,I)*GEETMP(I,K+NSTNS+NSTNS4)
C
      CONZ1 = CSBLSB*SUMR1 + CSBM2S*SUMR2
      CONZ2 = CSBLSB*SUMI1 + CSBM2S*SUMI2
      CONZ3 = CSBAR*SUMR2
      CONZ4 = CSBAR*SUMI2
C
      Q(J,K      ) = Q(J,K) - 2.0*CMPLX(CONZ1,-CONZ2)
 3601 Q(J,K+NSTNS) = Q(J,K+NSTNS) - 2.0*CMPLX(CONZ3,-CONZ4)
      RETURN
C
 9991 WRITE (IBBOUT,3000) UFM
      GO TO 9999
 9992 WRITE (IBBOUT,3001) UFM
      GO TO 9999
 9993 WRITE (IBBOUT,3002) UFM,SLN,NSTNS
 9999 CALL MESAGE (-61,0,0)
      RETURN
C
 3000 FORMAT (A23,' - AMG MODULE -SUBROUTINE AMGT1C', /39X,
     1       'AXIAL MACH NUMB. IS EQUAL TO OR GREATER THAN ONE.')
 3001 FORMAT (A23,' - AMG MODULE - LARGE G-MATRIX IS SINGULAR IN ',
     1        'ROUTINE AMGT1C.')
 3002 FORMAT (A23,' - AMG MODULE - NUMBER OF COMPUTING STATIONS ON ',
     1       'STREAMLINE',I8,4H IS ,I3,1H. ,/39X,'SUPERSONIC CASCADE ',
     2       'ROUTINE AMGT1C ALLOWS ONLY A MAXIMUM OF 10.')
      END

      SUBROUTINE HDPLOT (GPLST,NMAX,MAXSF,IOPCOR,IB)
C
      IMPLICIT INTEGER (A-Z)
      LOGICAL         DEBUG
      INTEGER         GPLST(1),NAME(2),ISYS(100),PTRS(29)
      REAL            DV,PSI,PHI,THETA,SCF,P,X(20),Y(20),Z(20)
      COMMON /BLANK / NGP,NSIL,NSETS,SKP1(7),
     1                SKP2(2),ELSET,SKP22(7),
     2                MERR,IDUM(3),NSCR1,NSCR2,NSCR3
      COMMON /SYSTEM/ SKPS,IOUT
      COMMON /PLTSCR/ NNN,G(3)
      COMMON /HDREC / NOFSUR,NS,ELID,LID,NPERS,P(3,13)
      COMMON /ZZZZZZ/ RZ(1)
      COMMON /HDPTRS/ XDUM,XCC,XASOLV,YASOLV,ZASOLV,X1SKT,Y1SKT,Z1SKT,
     1                ZCOEF1,ZCOEF,ICOUNT,IRCT,X21,Y21,Z21,IIA,XE,YE,
     2                XU,YU,XI,YI,ZI,DI,IBEG,IEND,ICT,ICCT,WORK
      COMMON /HDSC  / SCF,PSI,PHI,THETA,MNE,DV,MNP,ICORE
      COMMON /PLOTHD/ USED
      EQUIVALENCE     (ISYS(1),SKPS), (PTRS(1),XDUM)
      DATA    NAME  / 4HHDPL,4HOT  /
      DATA    DEBUG / .FALSE.      /
C
C     CALL SSWTCH (47,J)
C     IF (J .EQ. 1) DEBUG = .TRUE.
C
C     SET MNE EQUAL TO THE MAXIMUM NUMBER OF EDGES IN ANY ONE POLYGON.
C
      MNE = NMAX
C
C     MNP=MNE+2+2*NHOLES   WHERE NHOLES IS THE NUMBER OF HOLES,IF ANY
C
      NHOLES = 0
      MNP = MNE + 2 + 2*NHOLES
C
C     SET DISTANCE FROM VIEWER, AND SET SCALING FACTOR = 1 UNITS/INCH
C
      DV  = 99999.
      SCF = 1.00
C
C     SET MAX. LINES OF INTERSECTION ALLOWED IN HDSOLV (DIMEN. OF XCC)
C
      LINTC = 800
      IF (ISYS(85) .NE. 0) LINTC = ISYS(85)
C
C     DEFINE EULERIAN ANGLES IN DEGREES.
C
      PSI = 0.
      PHI = 0.
      THETA = 0.
C
C     INITIALIZE ARRAY POINTERS IN OPEN CORE SPACE (USED, SET BY PLOT,
C     IS NO. OF WORDS ALREADY IN USE)
C
      XDUM  = 1
      XCC   = XDUM  + USED
      XASOLV= XCC   + LINTC
      YASOLV= XASOLV+ 50
      ZASOLV= YASOLV+ 50
      X1SKT = ZASOLV+ 50
      Y1SKT = X1SKT + 160
      Z1SKT = Y1SKT + 160
      ZCOEF1= Z1SKT + 160
      ZCOEF = ZCOEF1+ 150
      ICOUNT= ZCOEF + 150
      IRCT  = ICOUNT+ 150
      X21   = IRCT  + 100
      Y21   = X21   + 200
      Z21   = Y21   + 200
      IIA   = Z21   + 200
      XE    = IIA   + 200
      YE    = XE    + 150
      XU    = YE    + 150
      YU    = XU    + 150
      IBEG  = YU    + 150
      IEND  = IBEG  + 100
      ICT   = IEND  + 100
      ICCT  = ICT   + 100
      XI    = ICCT  + 100
      ICORE = (25+5*MNE+4*MNP)*(MAXSF+1)
      J     = (IOPCOR-ICORE-XI)/5
      YI    = XI    + J
      ZI    = YI    + J
      DI    = ZI    + J
      WORK  = DI    + J
      IF (DEBUG .OR. J.LT.300) WRITE (IOUT,55) NMAX,MAXSF,ICORE,USED,
     1                         LINTC,IOPCOR,IB,NSETS,J,PTRS
      IF (J .GE. 300) GO TO 5
      J = 300*5 + XI + ICORE - IOPCOR
      CALL MESAGE (-8,J,NAME)
C
    5 CALL GOPEN (NSCR2,GPLST(IB),0)
      CALL LINE (0.,0.,0.,0.,1,-1)
   10 CONTINUE
      CALL READ (*25,*25,NSCR2,NOFSUR,44,0,M)
      NPS = NPERS
      DO 20 I = 1,NPS
      X(I) = P(1,I)
      Y(I) = P(2,I)
      Z(I) = P(3,I)
   20 CONTINUE
      IF (DEBUG) WRITE (IOUT,65)
     1           NOFSUR,NS,ELID,LID,NPS,(X(N),Y(N),Z(N),N=1,NPS)
      NC = 0
      CALL HDSKET (X,Y,Z,NPS,NC)
      GO TO 10
   25 CALL CLOSE (NSCR2,1)
      NC = 1
      CALL HDSKET (X,Y,Z,NPS,NC)
      IF (NC .EQ. 0) GO TO 40
      WRITE  (IOUT,30) NC,ICORE,DV
   30 FORMAT (22H CODE FOR HIDDEN ERROR,I3,6H ICORE,I9,3H DV,F15.5)
   40 CALL LINE (0.,0.,0.,0.,1,+1)
      IF (DEBUG) WRITE (IOUT,60)
      RETURN
C
   55 FORMAT (1X,10HIN HDPLOT ,9I8, /,(5X,15I8))
   60 FORMAT (1X,10HOUT HDPLOT)
   65 FORMAT (1X,5I10/(1X,3G20.4))
      END

      SUBROUTINE OPT2C (PT,IEL,IPR,PR,RR)
C
      LOGICAL         KPUN
      INTEGER         B1,PT(2,1),COUNT,EID,EJECT,EST1,EST2,ETYP,HEADNG,
     1                OUTTAP,IEL(1),IPR(1),IZ(100),NAME(2),NEOP(21),
     2                SYSBUF,WDOPT(42),YCOR,ZCOR,MCB(7),IY(1),
     3                TUBE,QUAD4,TRIM6,TRIA3
      REAL            PR(1),RR(1),Y(1),BLK,PCD(2,21),G(2,10),PARM(8)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG / UFM,UWM,UIM,SFM
      COMMON /BLANK / SKP1(2),COUNT,NCARD,SKP2,YCOR,B1,NELOP,NWDSE,
     1                NWDSP,SKP3(2),EST1,SKP4,EST2,NELW,NPRW,NKLW,NTOTL,
     2                CONV
      COMMON /OPTPW2/ ZCOR,Z(100)
      COMMON /ZZZZZZ/ CORE(1)
      COMMON /NAMES / NRD,NOEOR,NWRT,NWEOR
      COMMON /SYSTEM/ SYSBUF,OUTTAP,SKPS1(6),NLPP,SKPS2(2),NLINES,
     1                SKPS3(78),LPCH
      COMMON /GPTA1 / NTYPES,LAST,INCR,NE(1)
      EQUIVALENCE     (IZ(1),Z(1)),   (EID,Z(1)), (CORE(1),PARM(1),MAX),
     1                (G(1,1),IZ(100)), (G(1,10),IG10), (IPRNT,PARM(7)),
     2                (IY(1),Y(1),PARM(8))
C     EQUIVALENT ARE  (IPR,PR)
C
C
C     NOTE - CHANGE EQUIVALENCE IF AN ELEMENT TO BE OPTIMIZED HAS EST
C     (EPT ONLY) ENTRIES BEYOND 100 WORDS.
C
      DATA   NAME   / 4H OPT, 4H2C   /
      DATA   NMES   , YES,PLUS,BLK   /  0, 4HYES , 4H+AAA, 4H    /
      DATA   TUBE   , QUAD4,TRIM6,TRIA3  / 3, 64 , 73, 83        /
      DATA   PCD    /
     1       4HPBAR,4H    , 4HPELB,4HOW  , 4HPIS2,4HD8  , 4HPQDM,4HEM  ,
     2       4HPQDM,4HEM1 , 4HPQDM,4HEM2 , 4HPQDP,4HLT  , 4HPQUA,4HD1  ,
     3       4HPQUA,4HD2  , 4HPROD,4H    , 4HPSHE,4HAR  , 4HPTRB,4HSC  ,
     4       4HPTRI,4HA1  , 4HPTRI,4HA2  , 4HPTRI,4HM6  , 4HPTRM,4HEM  ,
     5       4HPTRP,4HLT  , 4HPTUB,4HE   , 4HPSHE,4HLL  , 4HPSHE,4HLL  ,
     6       4HYYYY,4H    /
C
C     POINTERS TO WORDS ON EST TO CONVERT.  NEOP(ITP) IS POINTER INTO
C     -WDOPT- ARRAY.  THE -WDOPT- FIRST ENTRY FOR THE ELEMENT IS THE
C     NUMBER OF ENTRIES ON -EST- TO CONVERT FOLLOWED BY THE WORD NUMBERS
C     TO OPTIMIZE.
C
      DATA   NEOP   / 21,30,39,15,15,  15,27,17,15,1,  6,12,8,6,35,
     1                 6,12, 4,41,41,   0/
      DATA WDOPT /
C
C     ROD (A,J)
     1  2,   5,6
C
C     TUBE (O.D.)
     2, 1,   5
C
C     SHEAR(T), TRMEM(T), TRIA2(T)
     3, 1,   7
C
C     TRIA1(T1,T2,I)
     4, 3,   7,9,11
C
C     TRBSC(T2,I),TRPLT(T2,I)
     5, 2,   7,9
C
C     QDMEM(T), QDMEM1(T), QDMEM2(T), QUAD2(T)
     6, 1,   8
C
C     QUAD1(T1,T2,I)
     7, 3,   8,10,12
C
C     BAR(A,J,I1,I2,I12)
     8, 5,   17,18,19,20,33
C
C     QDPLT(T2,I)
     9, 2,   8,10
C
C     ELBOW(A,J,I1,I2)
     O, 4,   9,10,11,12
C
C     TRIM6(T1,T3,T5)
     1, 3,   10,11,12
C
C     IS2D8(T)
     2, 1,   13
C
C     QUAD4(T), TRIA3(T) PSHELL ONLY
     3, 1,   14
     * /
C
C     DETERMINE IF PROPTETY CARDS ARE TO BE PUNCHED
C
      KPUN = .FALSE.
      KOUNT  = 0
      HEADNG = 0
      CH     = 1.0
      ICP    = NTOTL
      IF (COUNT.EQ.MAX .OR. CONV.EQ.2.0) KPUN =.TRUE.
      IF (PARM(5) .NE. YES) KPUN = .FALSE.
      IF (IPRNT .NE. 0) NLINES = NLPP
      IE2 = 1
      LEL = 0
C
C     READ EST1 ELEMENT TYPE
C
   10 CALL READ (*400,*360,EST1,ETYP,1,NOEOR,I)
      CALL WRITE (EST2,ETYP,1,NOEOR)
      ITP = IY(ETYP)
      IF (ITP .EQ. 0) GO TO 20
      IE1 = PT(1,ITP)
C
C     CHECK IF CORE ELEMENTS SKIPPED BECAUSE TYPE NOT ON EST
C
      IF (IE1 .GT. IE2) GO TO 60
      IE2 = PT(1,ITP+1)
      LEL = IEL(IE1)
      IP1 = PT(2,ITP) - 1
      IF (IE2 .GT. IE1) GO TO 40
C
C     SKIP THIS ELEMENT TYPE.  COPY RECORD TO EST2
C
   20 J = 1
      N = ZCOR
      CALL READ (*30,*30,EST1,Z,ZCOR,NOEOR,N)
      J = 0
   30 CALL WRITE (EST2,Z(1),N,J)
      IF (J) 10,20,10
C
C     ELEMENT TYPE HAS CORE ENTRIES
C
   40 CONTINUE
      NWDS = INCR*(ETYP-1) + 12
      NWDS = NE(NWDS)
      NPCARD = 0
      IF (NWDS .GT. ZCOR) CALL MESAGE (-8,ZCOR,NAME)
C
C     READ ONE EST1 ELEMENT INTO CORE
C
   50 CALL READ (*350,*340,EST1,Z,NWDS,NOEOR,I)
      IF (EID-LEL) 55,80,60
C
C     ELEMENT ID NOT IN CORE
C
   55 CALL WRITE (EST2,IZ(1),NWDS,NOEOR)
      GO TO 50
C
C     ELEMENT IN CORE NOT ON EST
C
   60 I = EJECT(2)
      IF (I .EQ. 0) GO TO 68
      IF (COUNT.EQ.MAX .OR. CONV.EQ.2.0) GO TO 66
      WRITE  (OUTTAP,65) COUNT
   65 FORMAT (1H0,8X,45HPROPERTIES USED DURING INTERMEDIATE ITERATION,
     1        I5, 10H BY OPTPR2/)
      GO TO 68
   66 WRITE  (OUTTAP,67) COUNT
   67 FORMAT (1H0,8X,38HPROPERTIES USED DURING FINAL ITERATION,
     1        I5, 10H BY OPTPR2/)
   68 WRITE  (OUTTAP,70) SFM,ETYP,LEL,NAME
   70 FORMAT (A25,' 2297, INCORRECT LOGIC FOR ELEMENT TYPE',I4,
     1        ', ELEMENT',I8,2H (,2A4,2H).)
      CALL MESAGE (-61,LEL,NAME)
C
C     ELEMENT IN CORE - CONVERT THE ENTRIES
C
   80 IPL = IEL(IE1+4) + IP1
      IE1 = IE1 + NWDSE
      LEL = IEL(IE1)
      IF (IE1 .GT. IE2) LEL = 100000000
      A = PR(IPL+4)
      IF (A .GT. 0.0) GO TO 100
      NMES = NMES + 1
      IF (IPRNT.EQ.0 .OR. NMES.GT.100) GO TO 55
      I = EJECT (2)
      IF (I .EQ. 0) GO TO 88
      IF (COUNT.EQ.MAX .OR. CONV.EQ.2.0) GO TO 84
      WRITE (OUTTAP,65) COUNT
      GO TO 88
   84 WRITE  (OUTTAP,65) COUNT
   88 WRITE  (OUTTAP,90) UIM,EID
   90 FORMAT (A29,' 2305, OPTPR2 DETECTED NEGATIVE ALPHA FOR ELEMENT',
     1        I8)
      GO TO 55
C
  100 LOCF = NEOP(ITP)
      J = LOCF
      K = WDOPT(LOCF)
      IRR = (IPL+NWDSP)/NWDSP
      IF (ABS(PARM(3)-1.0) .LT. 0.0001) CH = 0.25*RR(IRR) + 0.75
      C = (A/(A+(1.0-A)*PARM(3)))**CH
      IF (ETYP .NE. TRIM6) GO TO 105
C
C     SPECIAL HANDLING FOR TRIM6
C     IF THICKNESS-3 OR THICKNESS-5 IS ZERO, SET EQUAL TO THICKNESS-1
C
      DO 102 JJ = 1,K
      J = J +1
      L = WDOPT(J)
      IF (JJ.NE.K .AND. ABS(Z(L+1)).LT.1.E-7) Z(L+1) = Z(L)
      PC = Y(ICP+JJ)
  102 Z(L) = Z(L)*(PC/(PC+(1.0-PC)*PARM(3)))
      ICP = ICP + 4
      GO TO 115
C
  105 DO 110 I = 1,K
      J = J + 1
      L = WDOPT(J)
  110 Z(L) = C*Z(L)
      IF (ETYP.NE.QUAD4 .AND. ETYP.NE.TRIA3) GO TO 112
      Z(L+6) =  0.5*Z(L)
      Z(L+7) = -0.5*Z(L)
  112 IF (ETYP.EQ.TUBE .AND. Z(L).LT.2.*Z(L+1)) Z(L+1) = .5*Z(L)
  115 CALL WRITE (EST2,Z(1),NWDS,NOEOR)
C
C     PUNCH AND/OR PRINT PROPERTY CARDS
C
      IF (IPRNT.EQ.0 .OR. IPR(IPL).LE.0) GO TO 50
      GO TO (120,130,140,150,150,150,160,170,150,180,150,160,170,150,
     1       180,150,160,190,170,170), ITP
C
C     PBAR
C
  120 K1 = 02222211
      K2 = 22222222
      K3 = 00000222
      GO TO 250
C
C     PELBOW
C
  130 K1 = 02222211
      K2 = 22222222
      K3 = 22222222
      GO TO 250
C
C     PIS2D8
C
  140 K1 = 00000211
      GO TO 230
C
C     PQDMEM, PQDMEM1, PQDMEM2, PQUAD2, PSHEAR, PTRIA2, PTRMEM
C
  150 K1 = 00002211
      GO TO 230
C
C     PQDPLT, PTRBSC, PTRPLT
C
  160 K1 = 22221211
      GO TO 230
C
C     PQUAD1, PTRIA1, PSHELL
C
  170 K1 = 22121211
      K2 = 00000022
      GO TO 240
C
C     PROD, PTRIM6
C
  180 K1 = 00222211
      GO TO 230
C
C     PTUBE
C
  190 K1 = 00022211
C
C     OUTPUT THE CARD(S)
C
  230 K2 = 0
  240 K3 = 0
  250 II = WDOPT(LOCF+1) - 4
      KK = K1
      G(1,1)   = PCD(1,ITP)
      G(2,1)   = PCD(2,ITP)
      IZ(II+2) = IPR(IPL)
      IPR(IPL) =-IPR(IPL)
  260 DO 270 I = 2,9
      G(1,I) = BLK
      G(2,I) = BLK
      J = MOD(KK,10)
      IF (J .EQ. 0) GO TO 270
      IF (J .EQ. 1) CALL INT2A8 (*370,IZ(I+II),G(1,I))
      IF (J .EQ. 2) CALL  FP2A8 (*380, Z(I+II),G(1,I))
  270 KK = KK/10
      G(1,10) = BLK
      G(2,10) = BLK
      IF (K2.EQ.0 .OR. (K2.EQ.-1 .AND. K3.EQ.0) .OR. K3.EQ.-1) GO TO 320
      KOUNT = KOUNT + 1
      CALL INT2A8 (*375,KOUNT,G(1,10))
      G(2,10) = G(1,10)
      IG10 = KHRFN3(G(1,1),PLUS,-3,1)
      IF (HEADNG .EQ. 0) GO TO 320
  280 WRITE  (OUTTAP,290) G
  290 FORMAT (5X,10(2A4,1X))
      IF (.NOT.KPUN) GO TO 300
      WRITE  (LPCH,295) G
  295 FORMAT (20A4)
      NCARD = NCARD + 1
C
C     SET UP FOR CONTINUATION CARD(S)
C
  300 IF (K2.EQ.0 .OR. (K2.EQ.-1 .AND. K3.EQ.0) .OR. K3.EQ.-1) GO TO 50
      G(1,1) = G(1,10)
      G(2,1) = G(2,10)
      II     = II + 8
      IF (K2) 315,50,310
  310 KK = K2
      K2 = -1
      GO TO 260
  315 KK = K3
      K3 = -1
      GO TO 260
C
C     PRINT HEADING
C
  320 HEADNG = 1
      IF (EJECT(1) .EQ. 0) GO TO 280
      IF (COUNT.EQ.MAX .OR. CONV.EQ.2.0) GO TO 330
      WRITE (OUTTAP,65) COUNT
      GO TO 280
  330 WRITE (OUTTAP,67) COUNT
      GO TO 280
C
C     EOR ON EST1
C
  340 CALL WRITE (EST2,0,0,NWEOR)
      IF (IE1-IE2) 60,10,10
C
C     ERRORS
C
  350 CALL MESAGE (-2,EST1,NAME)
  360 CALL MESAGE (-3,EST1,NAME)
  370 J = 370
      GO TO 390
  375 J = 375
      I = KOUNT
      GO TO 390
  380 J = 380
  390 WRITE  (OUTTAP,395) J,G(1,1),G(2,1),I,II,IZ(I+II),Z(I+II)
  395 FORMAT (16H0*** OPT2C/ERROR,I5,9X,5HELEM ,2A4,3I9,E10.4 )
      GO TO 50
C
  400 CALL EOF (EST2)
      MCB(1) = EST1
      CALL RDTRL(MCB)
      MCB(1) = EST2
      CALL WRTTRL(MCB)
      RETURN
      END

      SUBROUTINE SSGHT1 (IEST,FILE,NEQUIV  )
C*****
C     THIS ROUTINE CONVERTS THE EST DATA FOR ALL THERMAL ELEMENTS TO A
C     COMMON FORMAT. OPTIONAL TASKS INCLUDE CALCULATING MATOUT DATA AND
C     CONVERTING  SIL VALUES TO UN VALUES.
C*****
      INTEGER  ELID, SUB, SIL, NESTO(45), ELEM, NEST(2),ZP, BUFM
      INTEGER  TYPE,FILE, POINTR(8,23), NEQUIV(1) ,SUBR(2),FLAG
      INTEGER POINT1(8,20),POINT2(8, 3)
      REAL     EST(100)
      LOGICAL  LINEAR
C
      COMMON/ CONDAS/ CONSTS(5)
      COMMON/ ESTOUT/ ELID,SUB,NAME(2),SIL(8),IMAT,AF,THETA,R(3,8),
     1                MATO(6)
      COMMON/  MATIN/ MATID,INFLAG,ELTEMP,DUM(1),SINTH,COSTH
      COMMON/ HMTOUT/ BUFM(7)
      COMMON/ GPTA1 / NELEMS, LAST, INCR, ELEM(1)
      COMMON/ HMATDD/ XXX(4), LINEAR
C
      EQUIVALENCE  (CONSTS(1) , PI     )
      EQUIVALENCE  (NESTO(1),ELID) ,( NEST(1), EST(1) )
      EQUIVALENCE  (POINT1(1,1),POINTR(1,1)), (POINT2(1,1),POINTR(1,21))
C
      DATA SUBR / 4HSSGH ,4HT1   /
      DATA NUMELT / 23 /
C*****
C     THE POINTERS TO THE EST DATA ARE
C
C        IM    MAT ID
C        ITH   THETA
C        IA    AREA
C        IG    GRID POINT DATA
C        IS    SIL MINUS 1
C        NP    NO. OF POINTS
C        SUB   SUBROUTINE TYPE
C                       NO.  IS   ITH  IM   IA   IG   NP   SUB
C                      ----  --   ---  --   --   --   --   ----
      DATA   POINT1 /    1   ,0   ,0   ,4   ,5   ,9   ,2   ,1
     2                  ,3   ,0   ,0   ,4   ,5   ,8   ,2   ,1
     3                  ,6   ,0   ,5   ,6   ,7   ,15  ,3   ,2
     4                  ,9   ,0   ,5   ,6   ,7   ,9   ,3   ,2
     5                  ,10  ,0   ,0   ,4   ,5   ,9   ,2   ,1
     6                  ,16  ,0   ,6   ,7   ,8   ,10  ,4   ,3
     7                  ,17  ,0   ,5   ,6   ,7   ,9   ,3   ,2
     8                  ,18  ,0   ,6   ,7   ,8   ,10  ,4   ,3
     9                  ,19  ,0   ,6   ,7   ,8   ,16  ,4   ,3
     T                  ,34  ,0   ,0   ,16  ,17  ,34  ,2   ,1
     1                  ,36  ,0   ,5   ,6   ,0   ,7   ,3   ,4
     2                  ,37  ,0   ,6   ,7   ,0   ,8   ,4   ,5
     3                  ,39  ,1   ,0   ,2   ,0   ,7   ,4   ,6
     4                  ,40  ,1   ,0   ,2   ,0   ,9   ,6   ,7
     5                  ,41  ,1   ,0   ,2   ,0   ,11  ,8   ,8
     6                  ,42  ,1   ,0   ,2   ,0   ,11  ,8   ,9
     7                  ,52  ,1   ,0   ,15  ,16  ,21  ,8   ,10
     8                  ,62  ,0   ,6   ,7   ,8   ,10  ,4   ,3
     9                  ,63  ,0   ,6   ,7   ,8   ,10  ,4   ,3
     T                  ,65  ,0   ,0   ,10  ,0   ,16  ,8   ,16 /
      DATA   POINT2 /    66  ,0   ,0   ,22  ,0   ,28  ,20  ,16
     2                  ,67  ,0   ,0   ,34  ,0   ,40  ,32  ,1
     3                  ,76  ,0   ,11  ,12  ,13  ,14  ,8   ,17 /
C*****
      CALL DELSET
   10 CALL READ(*120,*140,IEST,TYPE,1,0,FLAG)
      DO 20 I =1,NUMELT
      IEL = I
      IF (TYPE   - POINTR(1,I)) 30,40,20
   20 CONTINUE
   30 CALL FWDREC(*150,IEST)
      GO TO 10
C
   40 CONTINUE
      ZP =   (TYPE-1)*INCR
      NAME(1)= ELEM(ZP+1)
      NAME(2)= ELEM(ZP+2)
      NWORDS = ELEM(ZP+12)
   50 CONTINUE
      CALL READ(*150,*130,IEST,EST,NWORDS,0,FLAG)
      ELID = NEST(1)
      DO 55 I = 5,45
      NESTO(I) = 0
   55 CONTINUE
      IF( TYPE .EQ. 3) EST(5) = PI*EST(6)*(EST(5)-EST(6))
      IF( TYPE.EQ.52 .AND. NEST(2).EQ.7) EST(16)=PI*(EST(19)+EST(20))
      IS = POINTR(2,IEL)
      ITH= POINTR(3,IEL)
      IM = POINTR(4,IEL)
      IA = POINTR(5,IEL)
      IG = POINTR(6,IEL)
      SUB= POINTR(8,IEL)
      NP = POINTR(7,IEL)
C
      IF(SUB .EQ. 10) SUB = SUB + NEST(2)-1
      INFLAG =1
      IF( SUB .GE. 16) INFLAG=3
      IF( SUB .LT. 2 .OR. SUB .GT. 5)  GO TO 60
      INFLAG =2
      GO TO 70
   60 IF(SUB  .LT. 6 .OR. SUB .GT. 9)  GO TO 70
      INFLAG =3
   70 CONTINUE
      IF( IA.GT. 0) AF = EST(IA)
      MATID = NEST(IM)
      IF(MATID .LE. 0) GO TO 50
      SINTH=0.0
      COSTH=1.0
      IF( INFLAG .NE. 2) GO TO 80
      THETA= EST(ITH)*PI/180.0
      IF( THETA .EQ.0.0)GO TO 80
      SINTH= SIN(THETA)
      COSTH= COS(THETA)
   80 ITEMP = IG + 4*NP
      ELTEMP = EST(ITEMP)
      IMAT = MATID
      LINEAR=.FALSE.
      CALL HMAT( ELID )
C*****
C     TEST IF NONLINEAR
C*****
      IF( LINEAR ) GO TO 50
      DO 90 I=1,6
   90 MATO(I)= BUFM(I)
      DO 110 I=1,NP
      JPOINT = 4*(I-1) + IG
      DO 100 J=1,3
      ILOC = JPOINT + J
  100 R(J,I) = EST(ILOC)
      ISIL= IS+I + 1
      IPT    =NEST(ISIL)
      IF( IPT.EQ. 0) GO TO 110
      SIL(I) = NEQUIV(IPT)
  110 CONTINUE
C*****
C     WRITE A UNIFORM EST GROUP OF CONVERTED DATA HERE
C*****
      CALL WRITE(FILE,NESTO(1), 45, 0 )
C*****
C     RETURN FOR ANOTHER ELEMENT
C******
      GO TO 50
  120 RETURN
C*****
C     DONE WITH THIS ELEMENT TYPE
C*****
  130 IF( FLAG .EQ. 0) GO TO 10
C******
  140 J=-3
      GO TO 160
  150 J = -2
  160 CALL MESAGE(J,IEST,SUBR)
      RETURN
      END

      SUBROUTINE MATPRN
C
C     MATRIX PRINT MODULE
C     WILL PRINT UP TO 5 DBi INPUT MATRICES
C     INPUT MATRICES CAN BE IN S.P, D.P, S.P.COMPLEX, OR D.P.COMPLEX
C
C     MATPRN  DB1,DB2,DB3,DB4,DB5//C,N,P1/C,N,P2/C,N,P3/C,N,P4/C,N,P5/
C                                  C,N,P6
C
C     WHERE   P1 AND P2 ARE PRINT FORMAT CONTROLS
C             P1 = 0, MATRICES PRINTED IN THEIR ORIG. PREC. (DEFAULT),
C                = 1, MATRICES PRINTED IN S.P. PREC. (e.g.  x.xxxE+xx)
C                = 2, MATRICES PRINTED IN D.P. PREC. (e.g. -x.xxxD+xx)
C                =-1, ONLY THE DIAGONAL ELEMENTS OF THE MATRIX WILL BE
C                     PRINTED IN THEIR ORIG. PRECISON
C             P2 = NO. OF DATA VALUES PRINTED PER LINE (132 DIGITS/LINE)
C                = 8 TO 14 IF MATRICES ARE PRINTED IN S.P. (DEFAULT=10)
C                = 6 TO 12 IF MATRICES ARE PRINTED IN D.P. (DEFAULT= 9)
C
C             P3, P4, P5 ARE PRINTOUT CONTROLS
C             P3 = m, MATRIX COLUMNS, 1 THRU m, WILL BE PRINTED.
C                  DEFAULT = 0, ALL MATRIX COLUMNS WILL BE PRINTED.
C                =-m, SEE P4 = -n
C             P4 = n, LAST n MATRIX COLUMNS ARE PRINTED. DEFAULT = 0
C                =-n, AND P3 = -m, EVERY OTHER n MATRIX COLUMNS WILL BE
C                  PRINTED, STARTIN FROM COLUMN m.
C             P5 = k, EACH PRINTED COLUMN WILL NOT EXCEED k LINES LONG
C                  AND THE REMAINING DATA WILL BE OMITTED.
C             P6 = LU, WHERE LU LOGICAL FILE NUMBER = 11(UT1), 12(UT2),
C                  14(INPT), 15(INT1),...,23(INT9), 24(IBM'S INPT).
C                  DEFAULT IS ZERO, SYSTEM PRINTER.
C                  IF LU IS 11 THRU 24, THE MATRIX PRINTOUT IS SAVED IN
C                  FORTRAN UNIT LU.
C
C
C     LAST REVISED BY G.CHAN/UNISYS
C     12/91, NEW MODULE PARAMETERS TO ALLOW USER SOME CONTROL OVER
C            POSSIBLY MASSIVE MATRIX PRINTOUT
C     8/92,  TO PRINT ONLY THE DIAGONAL ELEMENTS FOR POSSIBLY MATRIX
C            SINGULARITY CHECK, AND PARAMETER P6
C
      INTEGER         P1,P2,P3,P4,P5,P6
      DIMENSION       MCB(7)
      CHARACTER       UFM*23,UWM*25
      COMMON /XMSSG / UFM,UWM
      COMMON /BLANK / P1,P2,P3,P4,P5,P6
      COMMON /SYSTEM/ IBUF,NOUT
C
      IF (P1.LE.2 .AND. P2.LE.14) GO TO 30
      WRITE  (NOUT,10) UWM,P1,P2,P3,P4,P5,P6
   10 FORMAT (A25,', MATPRN PARAMETERS APPEAR IN ERROR.  P1,P2,P3,P4,',
     1        'P5,P6 =',6I5, /5X,'P1 IS RESET TO ZERO, AND P2 TO 6 TO',
     2        ' 14 DEPENDING ON TYPE OF DATA')
C
C     CHECK THAT USER REALY WANTS TO SET P3,P4,P5, AND INSTEAD HE SETS
C     THEM TO P1,P2,P3
C
      IF (P4.NE.0 .OR. P5.NE.0 .OR. P3.GT.50) GO TO 30
      P3 = P1
      P4 = P2
      P5 = P3
      WRITE  (NOUT,20) P3,P4,P5
   20 FORMAT (5X,'P3,P4,P5 ARE SET TO ',3I5)
      GO TO 30
   30 DO 110 I = 1,5
      MCB(1) = 100 + I
      CALL RDTRL (MCB(1))
      IF (MCB(1) .LT. 0) GO TO 110
      IF (P1 .EQ. -1) GO TO 90
      ITYP = MCB(5)
      NDPL = P2
      IF (NDPL .NE. 0) GO TO 40
      NDPL = 9
      IF (MOD(ITYP,2) .EQ. 1) NDPL = 10
   40 NPL  = NDPL
      GO TO (50,60,70,80), ITYP
   50 IF (NDPL .LT.  8) NPL = 8
      IF (NDPL .GT. 14) NPL = 14
      GO TO 90
   60 IF (NDPL .LT.  6) NPL = 6
      IF (NDPL .GT. 12) NPL = 12
      GO TO 90
   70 NDPL = (NDPL/2)*2
      NPL  = NDPL
      IF (P1.LE.0 .OR. P1.GT.2) GO TO 50
      GO TO (50,60), P1
   80 NDPL = (NDPL/2)*2
      NPL  = NDPL
      IF (P1.LE.0 .OR. P1.GT.2) GO TO 60
      GO TO (50,60), P1
   90 IPREC = P1
      IF (IPREC.EQ.1 .OR. IPREC.EQ.2 .OR. P1.EQ.-1) GO TO 100
      IPREC = 2
      IF (MOD(ITYP,2) .EQ. 1) IPREC = 1
  100 IOUT = NOUT
      IF (P6.GE.11 .AND. P6.LE.24) IOUT = P6
      CALL MATDUM (MCB(1),IPREC,NPL,IOUT)
  110 CONTINUE
      RETURN
      END

      SUBROUTINE FWMW (ND,NE,SGS,CGS,IRB,A0,ARB,XBLE,XBTE,YB,ZB,XS,
     1                 YS,ZS,NAS,NASB,KR,BETA2,CBAR,AVR,FWZ,FWY)
C
C     CALCULATES THE EFFECT OF A DOUBLET PLUS ANY CONTRIBUTIONS DUE TO
C     IMAGES, SYMMETRY AND GROUND EFFECT ON BODY
C
      COMPLEX   FWZ,FWY
      DIMENSION YB(1),ZB(1),NASB(1),AVR(1),ARB(1)
C
C     ND        SYMMETRY FLAG
C     NE        GROUND EFFECTS FLAG
C     SGS       SINE   OF SENDING POINT DIHEDRAL ANGLE
C     CGS       COSINE OF SENDING POINT DIHEDRAL ANGLE
C     IRB       NUMBER OF THE RECEIVING BODY
C     A0        RADIUS OF THE BODY
C     ARB       ARRAY OF RATIOS OF BODY AXIS
C     XBLE      LEADING  EDGE COORDINATE OF SLENDER BODY ELEMENT
C     XBTE      TRAILING EDGE COORDINATE OF SLENDER BODY ELEMENT
C     YB        ARRAY CONTAINING THE Y-COORDINATES OF THE BODIES
C     ZB        ARRAY CONTAINING THE Y-COORDINATES OF THE BODIES
C     XS        1/4-CHORD  X-COORDINATE  OF SLENDER BODY ELEMENT
C     YS        Y-COORDINATE OF SENDING POINT
C     ZS        Z COORDINATE OF THE SENDING POINT
C     NAS       NUMBER OF ASSOCIATED BODIES
C     NASB      ARRAY CONTAINING THE ASSOCIATED BODY NOS.
C     KR        REDUCED FREQUENCY
C     BETA2     = 1 - MACH**2
C     CBAR      REFERENCE CHARD LENGTH
C     AVR       ARRAY OF BODY RADII
C     FWZ       OUTPUT Z-FORCE
C     FWY       OUTPUT Y FORCE
C
      FWZ  = CMPLX(0.0,0.0)
      FWY  = CMPLX(0.0,0.0)
C
      DMMY = 0.0
      INFL = 1
C
C     ARG-R  ARGUMENTS
C
      DYB  = YB(IRB)
      DZB  = ZB(IRB)
      DA   = A0
      DELEPS = 1.0
      C    = CGS
      S    =-SGS
      DY   = YS
      DZ   = ZS
      ITYPE= 1
      K    = 1
      ASSIGN 100 TO IRET1
      GO TO 2000
  100 SY   = 1.0
      SZ   = 1.0
      SG   = SGS
      ASSIGN 200 TO IRET1
      GO TO 5000
  200 CONTINUE
C
C     CHECK SYMMETRY FLAG. BRANCH IF EQUAL TO ZERO
C
      IF (ND .EQ. 0) GO TO 700
C
C     PORTION FOR SYMMETRIC CALCULATIONS
C
      DELEPS = ND
      C    = CGS
      S    = SGS
      DY   =-YS
      DZ   = ZS
      ITYPE= 1
      K    = 2
      ASSIGN 300 TO IRET1
      GO TO 2000
  300 CONTINUE
      SY   =-1.0
      SZ   = 1.0
      SG   =-SGS
      ASSIGN 400 TO IRET1
      GO TO 5000
  400 CONTINUE
C
C     CHECK GROUND EFFECTS FLAG. SKIP IF ZERO
C
      IF (NE .EQ. 0) GO TO 7000
C
C     PORTION FOR COMBINATION OF SYMMETRY AND GROUND EFFECTS
C
      ITYPE = 1
      K     = 3
      DELEPS= ND*NE
      C     = CGS
      S     =-SGS
      DY    =-YS
      DZ    =-ZS
      ASSIGN 500 TO IRET1
      GO TO 2000
  500 CONTINUE
      SY    =-1.0
      SG    = SGS
      SZ    =-1.0
      ASSIGN 600 TO IRET1
      GO TO 5000
  600 CONTINUE
      GO TO 800
C
C     SKIP GROUND EFFECTS CALCULATIONS IF FLAG IS ZERO
C
  700 IF (NE .EQ. 0) GO TO 7000
C
C     PORTION FOR GROUND EFFECTS ONLY
C
  800 CONTINUE
      DELEPS = NE
      DY   = YS
      DZ   =-ZS
      C    = CGS
      S    = SGS
      ITYPE= 1
      K    = 4
      ASSIGN 900 TO IRET1
      GO TO 2000
  900 CONTINUE
      SY   = 1.0
      SZ   =-1.0
      SG   =-SGS
      ASSIGN 1000 TO IRET1
      GO TO 5000
 1000 CONTINUE
      RETURN
C
C     CALCULATION OF EFFECTIVE FORCES
C
 2000 CONTINUE
      RHO2 = (DY-DYB)**2 + (DZ-DZB)**2
      RHO  = SQRT(RHO2)
      B    = AVR(IRB)*ARB(IRB)
      RHODB= RHO/B
      F    = 1.0
      IF (RHO .LE. B) GO TO 2020
      F    = RHODB/(ARB(IRB)*(RHODB-1.0)+1.0)
2020  CONTINUE
      ZBAR = (DZ-DZB)/(F*ARB(IRB)) + DZB
      CALL FZY2 (XS,XBLE,XBTE,DY,ZBAR,DYB,DZB,DA,BETA2,CBAR,KR,DFZZR,
     1           DFZZI,DFZYR,DFZYI,DFYZR,DFYZI,DFYYR,DFYYI)
C
      FWZR = C*DFZZR + S*DFZYR
      FWZI = C*DFZZI + S*DFZYI
      FWZ  = FWZ + DELEPS*CMPLX(FWZR,FWZI)
      FWYR = C*DFYZR + S*DFYYR
      FWYI = C*DFYZI + S*DFYYI
      FWY  = FWY + DELEPS*CMPLX(FWYR,FWYI)
 2060 GO TO (3000,6000), ITYPE
 3000 GO TO IRET1, (100,200,300,400,500,600,800,900,1000)
C
C     CALCULATION LOOP FOR ASSOCIATED BODIES
C
 5000 IF (NAS .LE. 0) GO TO 3000
      I = 1
      ITYPE = 2
 5100 IB = NASB(I)
C
C     CHECK TO SEE IF THE ASSOCIATED BODY IS THE RECEIVING BODY.
C
      IF (IB .NE. IRB) GO TO 5800
C
C     IF IT IS DETERMINE IF THE SENDING POINT IS OUTSIDE OR INSIDE THE
C     BODY.
C
      GO TO (5600,5500,5400,5300), K
 5300 IF (DYB .NE. 0.0) GO TO 5800
      GO TO 5800
 5400 IF (DYB .NE. 0.0) GO TO 5800
 5500 IF (DZB .NE. 0.0) GO TO 5800
 5600 CONTINUE
 5800 CONTINUE
      ETA   = SY*YS
      ZETA  = SZ*ZS
      ZBI   = SZ*ZB(IB)
      YBI   = SY*YB(IB)
      DARIB = ARB(IB)
      DAIB  = AVR(IB)
      CALL SUBI (DAIB,ZBI,YBI,DARIB,ETA,ZETA,CGS,SG,DMMY,DMMY,DMMY,DY,
     1           DZ,DMMY,DMMY,DMMY,DMMY,S,C,INFL,IOUTFL)
      IF (IOUTFL) 2000,2060,2000
 6000 I = I + 1
      IF (I - NAS) 5100,5100,3000
 7000 RETURN
      END

      SUBROUTINE HDLIN (X,Y,Z,NP,NC,
     1           XCC,ICOUNT,IRCT,X21,Y21,Z21,IIA,XE,YE,XU,YU,XI,YI,ZI,
     2           DI,IBEG,IEND,ICT,ICCT,
     3           IND,NIND,XXX,CCC,IN,IN1,IN2,TGM,TGMT,TGI,ZM,ZMI,RV,
     4           RVI,NNO,NOCT,YMIN,ZMIN,COORD,SNDT,NEH,KEEP)
C
C
C     THIS SUBROUTINE IS THE EXECUTIVE.
C
C
      DIMENSION     X(1),Y(1),Z(1),I2(2),I3(2),RRX(20),NGX(15),H(15),
     1              U(6),V(6),W(6),X1(10),Y1(10)
      DIMENSION     XCC(1),ICOUNT(1),IRCT(1),X21(1),Y21(1),Z21(1),
     1              IIA(1),XE(1),YE(1),XU(1),YU(1),XI(1),YI(1),ZI(1),
     2              DI(1),IBEG(1),IEND(1),ICT(1),ICCT(1)
      DIMENSION     IND(1),NIND(1),XXX(1),CCC(1),IN(1),IN1(1),IN2(1),
     1              TGM(1),TGMT(1),TGI(1),ZM(1),ZMI(1),RV(1),RVI(1),
     2              NNO(1),NOCT(1),YMIN(1),ZMIN(1),COORD(1),SNDT(1),
     3              NEH(1),KEEP(1)
      COMMON /GO3 / L0,L1,L00,L01,L2,L3,L4,L5,L6,L7,L8,L9,L10,L11,L12,
     1              L13
      COMMON /HDSC/ SCX,YAW,ROLL,PIT,LZ,VP,JJJ,ICORE
      COMMON /HEDG/ JAT,ME,JT,VX,VX1,VX2,VX3,NN
C
      IF (VP .LT. 0.) GO TO 20
      HXX = .015
      AVA = .0
      HX1 = .001
      LC  = 10**6
      IXXX= 0
      IF (SCX .LT. 0.) IXXX = 1
      SCX = ABS(SCX)
C
C     INITIALIZE VARIABLES.
C
      LZ  = LZ*5
      SW1 = 0
      SW  = 0
      IDAV= 0
C
C     CALCULATE MAXIMUM ALLOWABLE ELEMENTS.
C
      IABC = ICORE/(25+LZ+4*JJJ)
      SCT  = 1.
      VP   = VP/SCT
      VPX  = ABS(VP)
      ISAVE= NC
      NC   = IABC
      L5   = 0
      L6   = NC
      L7   = 2*NC
      L8   = 3*NC
      L2   = 4*NC
      L3   = 5*NC
      L4   = 6*NC
      L00  = 7*NC
      L01  = 8*NC
      L1   = 9*NC
      L0   = 10*NC
      L9   = 11*NC
      L10  = 12*NC
      L11  = 13*NC
      L15  = 14*NC
      L16  = 15*NC
      L17  = 16*NC
      L18  = 19*NC
      L12  = 20*NC
      L13  = 25*NC
      L14  = L13 + LZ*NC
      DO 10 J = 1,NC
      RVI(L8+J) = 10**6
      TGM(L5+J) = 10**6
      RV (L7+J) =-RVI(L8+J)
      TGI(L6+J) =-TGM(L5+J)
      NOCT(L9+J)= 0
      ZM  (L2+J)= RV(L7+J)
      ZMI(L3+J) = RVI(L8+J)
      NIND(L16+J) = 0
      IND (L15+J) = J
      KEEP(L18+J) = 0
   10 CONTINUE
      NC  = ISAVE
      IK  = 0
      IKT = 0
      KR  = JJJ
      PI  = 3.1416/180.
      U(6)= SCX
      V(6)= SCX
      VP  =-VP
C
C     STORE EULERIAN ANGLES.
C
      XX   = YAW*PI
      YY   = ROLL*PI
      ZZ   = PIT*PI
      COSY = COS(YY)
      SINY = SIN(YY)
      COSZ = COS(ZZ)
      SINZ = SIN(ZZ)
      COSX = COS(XX)
      SINX = SIN(XX)
   20 CONTINUE
      NT  = NP-1
      IKK = IK+1
      IK  = IK+1
C
C     SET ERROR CODES, IF NECESSARY.
C
      IF (IKK .LE. IABC) GO TO 30
      SW = 1
   30 CONTINUE
      IF (NC .EQ. 0) GO TO 40
      IDAV = 1
      NC   =-SW1
      IF (SW .EQ. 0.) GO TO 50
      ICORE = (25+LZ+4*JJJ)*IKK
      NC    =-(SW+SW1)
   40 CONTINUE
   50 CONTINUE
      DO 60 J = 1,NP
      X21(J) = X(J)
      Y21(J) = Y(J)
      Z21(J) = Z(J)
   60 CONTINUE
C
C     STORE COORDINATES AND SET PEN POSITION WHENEVER ABS(Z)=9999.
C
      DO 70 J = 1,NT
      IIA(J) = 0
      IF (Z21(J) .NE. 9999.) GO TO 70
      IIA(J) = 1
      IXU = J - 2
      IBB = J - ISIGN(1,IXU)
      X21(J) = X21(IBB)
      Y21(J) = Y21(IBB)
      Z21(J) = Z21(IBB)
   70 CONTINUE
      IIA(NP) = 1
      Z21(NP) = Z21(NT)
      Y21(NP) = Y21(NT)
      X21(NP) = X21(NT)
      JXX = IKK
      I   = 1
      VL  = ABS(VP)
C
C     LOOP THAT DOES THE THREE DIMENSIONAL TRANSFORMATION ON THE
C     COORDINATES.
C
      JV = L14 + (IKK-1)*4*JJJ
      JT = 1
      DO 90 J = 1,NP
      XJ = X21(J)/SCT
      YJ = Y21(J)/SCT
      ZJ = Z21(J)/SCT
      U(I) = ZJ*(COSY*SINX) + XJ*(COSY*COSX) - YJ*SINY
      TW = YJ*COSY*COSZ
      TZ = XJ*( SINZ*SINX+SINY*COSZ*COSX)
      TY = ZJ*(-SINZ*COSX+SINY*COSZ*SINX)
      V(I) = TZ + TW + TY
      PT = YJ*COSY*SINZ
      PK = ZJ*( COSZ*COSX+SINY*SINZ*SINX)
      PS = XJ*(-COSZ*SINX+SINY*SINZ*COSX)
      ZJ = PK + PS + PT
      IF (ZJ .LT. VL) GO TO 80
      SW1 = 2
      VPX = AMAX1(ZJ,VPX)
      VPX = VPX + (.5/SCT)
   80 CONTINUE
      T = SW + SW1
      IF (T .NE. 0.) GO TO 90
C
C     CALCULATES PERSPECTIVE BASED ON VALUE VP(DV) FROM CALLING PROGRAM.
C
      HH = VL/(VL-ZJ)
      X21(J) = U(I)*HH
      Y21(J) = V(I)*HH
      Z21(J) = ZJ*HH
C
C     CALCULATES MAX/MIN VALUES OF EACH ELEMENT ON THE X,Y,Z DIMENSION
C
      RV (L7+JXX) = AMAX1(RV (L7+JXX),Y21(J))
      RVI(L8+JXX) = AMIN1(RVI(L8+JXX),Y21(J))
      TGI(L6+JXX) = AMAX1(TGI(L6+JXX),X21(J))
      TGM(L5+JXX) = AMIN1(TGM(L5+JXX),X21(J))
      ZM (L2+JXX) = AMAX1(ZM (L2+JXX),Z21(J))
      ZMI(L3+JXX) = AMIN1(ZMI(L3+JXX),Z21(J))
      COORD(JT+JV  ) = X21(J)
      COORD(JT+JV+1) = Y21(J)
      COORD(JT+JV+2) = Z21(J)
      COORD(JT+3+JV) = IIA(J)
      JT = JT + 4
   90 CONTINUE
      IF (IDAV .EQ. 1) VP = VPX*SCT
      IF (T   .NE. 0.) GO TO 400
      NOCT(L9+IKK) = NOCT(L9+IKK) + NP
      NS  = NP
      AVA = AVA + (TGI(L6+JXX)-TGM(L5+JXX))*(RV(L7+JXX)-RVI(L8+JXX))
      IF (IXXX .EQ. 1) GO TO 95
C
C     CALL SUBROUTINE WHICH CALCULATES BOTH THE EQUATIONS OF THE LINE
C     SEGMENTS AND POLYGONS.
C
      CALL HDCOEF (X21,Y21,Z21,XXX,JXX,NS,CCC,LZ)
C
C     CHECKS TO SEE IF ALL ELEMENTS(SETS) HAVE BEEN PASSED.
C
   95 CONTINUE
      IF (IDAV .EQ. 1) GO TO 100
      GO TO 400
  100 CONTINUE
      AVA = AVA/IKK
      DO 1301 J = 1,100
      ICCT(J) = 0
      ICT (J) = 0
      IRCT(J) = J - 1
      IBEG(J) = 1
      IEND(J) = 0
 1301 CONTINUE
      IAUG  = 50 + (IKK/10000)*2
      AMAXX =-999999.
      AMAXY =-999999.
      AMINX = 999999.
      AMINY = 999999.
      DO 1400 J = 1,IKK
      AMAXX = AMAX1(AMAXX,TGI(L6+J))
      AMAXY = AMAX1(AMAXY,RV (L7+J))
      AMINX = AMIN1(AMINX,TGM(L5+J))
      AMINY = AMIN1(AMINY,RVI(L8+J))
 1400 CONTINUE
      TMAX = (AMAXX-AMINX)*(AMAXY-AMINY)
      IBL  = TMAX/AVA
      IBL  = IBL/4
C
C     DETERMINES THE NUMBER OF GRID POINTS IN THE GRID.
C
C
      EN = IKK
      K  = (ALOG(EN)/ALOG(2.)) + .01
      K  = K + IAUG
      K  = MIN0(K,IBL)
      IF (K .LE. 1) K = 1
      T  = K
      R  = T**.5
      KS = R + .5
      S  = T/KS
      MS = S + .5
      N  = KS*MS
      MND= N + 1
      XMD= MND
      T  = 3./(MND-1)
      IGY= T*IKK
      K  = KS
      K1 = MS
      CRX= (AMAXX-AMINX)/K
      CRY= (AMAXY-AMINY)/K1
C
C
C     DETERMINES THE RELEVANT ELEMENTS VIA THE GRID BLOCKS.
C
C
      DO 3 J = 1,IKK
      IA = 0
      XMAT = TGI(L6+J)
      XMIT = TGM(L5+J)
      YMAT =  RV(L7+J)
      YMIT = RVI(L8+J)
      M = 0
      DO 1 I = 1,K1
      DO 2 L = 1,K
      M  = M + 1
      S  = XMAT - ((L-1)*CRX+AMINX)
      S1 = XMAT - (L*CRX+AMINX)
      R  = XMIT - ((L-1)*CRX+AMINX)
      R1 = XMIT - (L*CRX+AMINX)
      A  = YMAT - ((I-1)*CRY+AMINY)
      A1 = YMAT - (I*CRY+AMINY)
      B  = YMIT - ((I-1)*CRY+AMINY)
      B1 = YMIT - (I*CRY+AMINY)
      IF (S.LE.0. .OR. R1.GE.0.) GO TO 2
      IF (A.LE.0. .OR. B1.GE.0.) GO TO 2
      IF (S*S1.GT.0. .OR. R*R1.GT.0.) GO TO 4
      IF (A*A1.GT.0. .OR. B*B1.GT.0.) GO TO 4
      NIND(L16+J) = M
      GO TO 3
    4 CONTINUE
      IA = IA + 1
      IF (IA .LE. 4) GO TO 8000
      NIND(J+L16) = 0
      GO TO 8001
 8000 CONTINUE
      NIND(L16+J) = NIND(L16+J) + M*(MND**(IA-1))
 8001 CONTINUE
      IF (ICCT(M) .LT. 0) GO TO 2
      ICCT(M) = ICCT(M) + 1
      JK      = (M-1)*IGY+ICCT(M) + L17
      NEH(JK) = J
      IF (ICCT(M) .GE. IGY) ICCT(M) = -1
    2 CONTINUE
    1 CONTINUE
    3 CONTINUE
      CALL HDVS1 (NIND(L16+1),IK,IND(L15+1))
      SW = 0
      L  = 1
      DO 5 I = 1,IKK
   11 CONTINUE
      IF (NIND(L16+I) .NE. IRCT(L)) GO TO 6
      SW = SW + 1
      IF (SW .EQ. 1.) LT = I
      ICT(L) = ICT(L) + 1
      GO TO 5
    6 CONTINUE
      IF (SW .NE. 0.) GO TO 8
      L = L + 1
      GO TO 11
    8 CONTINUE
      IBEG(L) = LT
      IEND(L) = LT + ICT(L) - 1
      SW = 0
      IF (NIND(L16+I) .GE. MND) GO TO 2110
      L = L + 1
      GO TO 11
    5 CONTINUE
      IBEG(L) = LT
      IEND(L) = LT + ICT(L) - 1
 2110 CONTINUE
      DO 2111 J = 1,IKK
      SNDT(L4+J) = IND(L15+J)
 2111 CONTINUE
      CALL HDVSR (SNDT(L4+1),IK,NIND(L16+1))
      EN  = IKK
      IGX = (ALOG(EN)/ALOG(2.)) + 1.
      DO 105 J = 1,IGX
      RRX(J) = 2**(IGX-J)
  105 CONTINUE
      U(6) = SCX
      V(6) = SCX
      W(6) = SCX
      IKT  = NC
      T    = AMINY
      T1   = AMINX
      V(5) = T
      U(5) = T1
      IJ   = 0
      X1(3)= U(5)
      Y1(3)= V(5)
      X1(4)= U(6)
      Y1(4)= V(6)
      X1(4)= X1(4)/SCT
      Y1(4)= Y1(4)/SCT
      DO 115 J = 1,IKK
      IN(L11 +J) = J
      IN1(L0 +J) = J
      IN2(L00+J) = J
      TGMT(L10+J) = TGM(L5+J)
      YMIN(L1 +J) = RVI(L8+J)
      ZMIN(L01+J) = ZM(L2+J)
  115 CONTINUE
C
C     CALL SUBROUTINE WHICH WILL SORT ON X,Y AND Z.
C
      CALL HDVSR (TGMT(L10+1),IK,IN(L11+1))
      CALL HDVSR (YMIN(L1+1),IK,IN1(L0+1))
      CALL HDVSR (ZMIN(L01+1),IK,IN2(L00+1))
      H(8) = 0
      DO 395 J = 1,IKK
      KS = IKK
      JJ = L14 + (J-1)*4*JJJ
      JH = 1
      II = 0
      IXR= NOCT(L9+J)
      NIT= 0
      JT = L12 + 5*(J-1)
      JO = L13 + LZ*(J-1)
      IF (IXXX .EQ. 1) GO TO 200
      NS = XXX(5+JT)
      NG = NS*5
      A3 = XXX(1+JT)
      B3 = XXX(2+JT)
      C3 = XXX(3+JT)
      D3 = XXX(4+JT)
      I  = 0
      DO 121 IX = 1,NG,5
      IF (IXR .LE. 3) GO TO 121
      I = I + 1
      XE(I) = CCC(IX+3+JO)
      IF (CCC(IX+JO) .NE. 0.) GO TO 120
      XE(I) =-CCC(IX+2+JO)
      YE(I) = CCC(IX+3+JO)
      GO TO 121
  120 CONTINUE
      YE(I) =-CCC(IX+2+JO) - CCC(IX+1+JO)*XE(I)
  121 CONTINUE
C
C     THIS LOOP DETERMINES THE RELEVANT ELEMENTS AS THEY RELATE TO A
C     PARTICULAR ELEMENT.  THAT IS, EACH ELEMENT HAS ASSOCIATED WITH IT
C     THOSE OTHER ELEMENTS WHICH COULD POSSIBLY HIDE SOME PORTION
C     OF THE GIVEN ELEMENT.
C
      K  = 2**IGX
      K1 = K
      K2 = K
C
C     DO LOGARITHMIC SEARCH TO DETERMINE RELEVANT ELEMENTS.
C
      S = -1
      DO 131 I = 1,IGX
      K = K + SIGN(RRX(I),S)
      IF (K .GT. IKK) K = IKK
      S  = TGI(L6+J) - TGMT(L10+K  )
      S1 = TGI(L6+J) - TGMT(L10+K-1)
      IF (S*S1 .LE. 0.) GO TO 132
  131 CONTINUE
      K = IKK
  132 CONTINUE
      S = -1
      DO 133 I = 1,IGX
      K1 = K1 + SIGN(RRX(I),S)
      IF (K1 .GT. IKK) K1 = IKK
      S  = RV(L7+J) - YMIN(L1+K1  )
      S1 = RV(L7+J) - YMIN(L1+K1-1)
      IF (S*S1 .LE. 0.) GO TO 134
  133 CONTINUE
      K1 = IKK
  134 CONTINUE
      S = -1
      DO 135 I = 1,IGX
      K2 = K2 + SIGN(RRX(I),S)
      IF (K2 .LE.   1) K2 = 2
      IF (K2 .GT. IKK) K2 = IKK
      S  = ZMI(L3+J) - ZMIN(L01+K2  )
      S1 = ZMI(L3+J) - ZMIN(L01+K2-1)
      IF (S*S1 .LE. 0.) GO TO 136
  135 CONTINUE
      K2 = 1
  136 CONTINUE
      I1 = IKK - K2 + 1
C
C     RETRIEVE THE RELEVANT ELEMENTS DETERMINED FROM SCHEME 1.
C
      IF  (NIND(L16+J) .EQ. 0) GO TO 1270
      IR = NIND(L16+J)
      VX = NIND(L16+J)
      T  = ALOG(VX)
      IF (NIND(L16+J) .LE. LC) GO TO 1800
      E  = LC
      LG = NIND(L16+J)/LC
      MU = MOD(IR,LC)
      UX = LG + (MU/E)
      T  = ALOG(UX) + ALOG(E)
 1800 CONTINUE
      IXT = 0
      IEXP= (T/ALOG(XMD)) + 1
      DO 8004 L = 1,IEXP
      IV = IR/(MND**(IEXP-L))
      IR = IR - IV*(MND**(IEXP-L))
      IV = IV + 1
      IF (ICCT(IV-1) .EQ. 0) GO TO 4000
      IF (ICCT(IV-1) .GT. 0) GO TO 4001
      GO TO 1270
 4001 CONTINUE
      KE = ICCT(IV-1)
      IL = 0
      JTT= (IV-2)*IGY + L17
      DO 4003 I = 1,KE
      KV = NEH(I+JTT)
      IF (KEEP(L18+KV) .EQ. J) GO TO 4003
      IL = IL + 1
      NNO(L4+IXT+IL) = KV
      KEEP(L18+KV) = J
 4003 CONTINUE
      IXT = IXT + IL
 4000 CONTINUE
      IX  = IBEG(IV)
      IX1 = IEND(IV)
      DO 1170 I = IX,IX1
 1170 NNO(L4+IXT+I-IX+1) = IND(L15+I)
      IXT = IXT + IX1 - IX + 1
 8004 CONTINUE
      KS = IXT
 1270 CONTINUE
      IM = MIN0(I1,K,K1)
C
C     PICK MINIMUM COUNT FROM BOTH SCHEMES.
C
      IF (KS .LT. IM) GO TO 129
      IF (IM .EQ. I1) GO TO 1000
      IF (IM .EQ.  K) GO TO 1001
      IF (IM .EQ. K1) GO TO 1002
 1000 CONTINUE
      KS = I1
      DO 1003 I = 1,KS
 1003 NNO(L4+I) = IN2(L00+IKK-I+1)
      GO TO 129
 1001 CONTINUE
      KS = K
      DO 1004 I = 1,KS
 1004 NNO(L4+I) = IN(L11+I)
      GO TO 129
 1002 CONTINUE
      KS = K1
      DO 1006 I = 1,KS
 1006 NNO(L4+I) = IN1(L0+I)
  129 CONTINUE
      DO 170 I = 1,KS
      IT = 0
      JB = NNO(L4+I)
      IF (J .EQ. JB) GO TO 170
      JK = L13 + LZ*(JB-1)
      JS = L12 +  5*(JB-1)
      IF (TGM(L5+J).GE.TGI(L6+JB) .OR. TGI(L6+J).LE.TGM(L5+JB))
     1    GO TO 170
      IF (RV(L7+J).LE.RVI(L8+JB) .OR. RVI(L8+J).GE.RV(L7+JB)) GO TO 170
      IF (ZMI(L3+J) .GE. ZM(L2+JB)) GO TO 170
      NV = XXX(5+JS)
      IF (XXX(JS+3) .EQ. 0.) GO TO 170
      IF (XXX(3+JT) .EQ. 0.) GO TO 165
      NB = 5*NV
C
C
C     TEST TO SEE IF ALL VERTICES LIE EITHER BEHIND OR IN FRONT OF
C     THE GIVEN POLYGON.
C
C
      M = 0
      DO 145 IX = 1,NB,5
      M = M + 1
      A = CCC(IX+3+JK)
      IF (CCC(IX+JK) .NE. 0.) GO TO 130
      A =-CCC(IX+2+JK)
      B = CCC(IX+3+JK)
      GO TO 140
  130 CONTINUE
      B =-CCC(IX+2+JK) - CCC(IX+1+JK)*A
  140 CONTINUE
      XU(M) = A
      YU(M) = B
      VX  = XXX(4+JS)
      VX1 = XXX(2+JS)*B
      VX2 = XXX(1+JS)*A
      ZS  =-(VX+VX1+VX2)/XXX(3+JS)
      VX  = XXX(4+JT)
      VX1 = XXX(2+JT)*B
      VX2 = XXX(1+JT)*A
      ZS1 =-(VX+VX1+VX2)/XXX(3+JT)
      IF (ABS(ZS-ZS1) .LT. HXX) GO TO 145
      IT = IT + 1
      ICOUNT(IT) = 0
      IF (ZS .GT. ZS1) ICOUNT(IT) = 1
  145 CONTINUE
C
C
C     TESTS FOR SEMI-RELEVANT PLANES.  THAT IS,NEGATIVE INDEXES
C     INDICATE ELEMENT IS TO BE USED FOR VISIBILITY TEST, BUT NOT FOR
C     INTERSECTION LINE DETERMINATION.
C
C
      IF (IT .EQ. 0) GO TO 170
      L = 0
      DO 150 M = 1,IT
  150 L = L + ICOUNT(M)
      IF (L  .EQ.  0) GO TO 170
      IF (L  .EQ. IT) JB = -JB
      IF (II .NE.  0) GO TO 165
C
C
C     INTERROGATE THE RELATIONSHIP OF THE CANDIDATE POLYGON TO THE
C     GIVEN POLYGON BY DETERMINING IF THE PROJECTION OF ONE POLYGON
C     CAN BE SEPARATED BY AN EDGE FROM THE OTHER'S PROJECTION
C
C
      C3 = XXX(3+JT)
      C4 = XXX(3+JS)
      SD = 0
      I3(1) = JK
      I3(2) = JO
      I2(1) = NV*5
      I2(2) = NS*5
      DO 164 KU = 1,2
      IS = I3(KU)
      IB = I2(KU)
      DO 163 L = 1,IB,5
  151 CONTINUE
      IF (SD .EQ. 1.) GO TO 152
      A = XXX(2+JT)*C4 - XXX(2+JS)*C3
      B = XXX(1+JT)*C4 - XXX(1+JS)*C3
      C = XXX(4+JT)*C4 - XXX(4+JS)*C3
      GO TO 153
  152 CONTINUE
      A = CCC(L+IS  )
      B = CCC(L+IS+1)
      C = CCC(L+IS+2)
  153 CONTINUE
      IF (A.EQ.0. .AND. B.EQ.0.) GO TO 162
      IF (A .NE. 0.) GO TO 154
      A = 0
      C = C/B
      B = 1
      GO TO 155
  154 CONTINUE
      B = B/A
      C = C/A
      A = 1
  155 CONTINUE
      M = 0
      R1= 0
      DO 158 IX = 1,NV
      M = M + 1
      YG= YU(M)
      IF (A .NE. 0.) GO TO 156
      DY = -C/B
      YG = XU(M)
      GO TO 157
  156 CONTINUE
      DY = -C - B*XU(M)
  157 IF (ABS(DY-YG) .LT. HXX) GO TO 158
      R = YG - DY
      IF (R*R1 .LT. 0.) GO TO 162
      R1 = R
  158 CONTINUE
      M  = 0
      R2 = 0
      DO 161 IX = 1,NS
      M  = M + 1
      YG = YE(M)
      IF (A .NE. 0.) GO TO 159
      DY = -C/B
      YG = XE(M)
      GO TO 160
  159 CONTINUE
      DY = -C - B*XE(M)
  160 IF (ABS(DY-YG) .LT. HXX) GO TO 161
      R  = YG - DY
      IF (R*R2 .LT. 0.) GO TO 162
      R2 = R
  161 CONTINUE
      IF (R1*R2 .LT. 0.) GO TO 170
  162 CONTINUE
      IF (SD .NE. 0.) GO TO 163
      SD = 1
      GO TO 151
  163 CONTINUE
  164 CONTINUE
  165 CONTINUE
      II = II + 1
      NNO(L4+II) = JB
  170 CONTINUE
      JS  = 1
      JAT =-4
      JT  = L12 + (J-1)*5
      NN  = XXX(JT+5)
      VX  = XXX(JT+4)
      VX1 = XXX(2+JT)
      VX2 = XXX(1+JT)
      VX3 = XXX(3+JT)
      IF (IXR .LE. 2) GO TO 200
      IF (II  .EQ. 0) GO TO 190
C
C     CALL SUBROUTINE WHICH SOLVES FOR THE LINES OF INTERSECTION,IF ANY,
C     OF THE JTH ELEMENT WITH OTHER ELEMENTS.
C
      CALL HDSOLV(IXR,J,XXX,CCC,II,NNO,NIT,X21,Y21,Z21,IIA,NC,ZM,ZMI,LZ)
  190 CONTINUE
  200 CONTINUE
      DO 210 JM = 1,IXR
      X21(JM) = COORD(JH  +JJ)
      Y21(JM) = COORD(JH+1+JJ)
      Z21(JM) = COORD(JH+2+JJ)
      IIA(JM) = COORD(JH+3+JJ)
      JH = JH + 4
  210 CONTINUE
      IXR = IXR + 3*NIT
      IF (II   .EQ. 0) GO TO 220
      IF (IXXX .NE. 1) GO TO 240
  220 CONTINUE
      DO 230 JM = 1,IXR
      X1(2) = X21(JM)
      Y1(2) = Y21(JM)
      IM = IIA(JM)
      CALL HDPLT (X1,Y1,IJ,IM)
  230 CONTINUE
      GO TO 390
  240 CONTINUE
      JX = 1
  250 CONTINUE
C
C     PLOTS IF IIA(JX+1) IS EQUAL TO 1.
C
      IF (IIA(JX).EQ.0 .AND. IIA(JX+1).EQ.0) GO TO 260
      IM    = IIA(JX+1)
      X1(2) = X21(JX+1)
      Y1(2) = Y21(JX+1)
      CALL HDPLT (X1,Y1,IJ,IM)
      JX = JX + 2
      IF (JX .GE. IXR) GO TO 390
      GO TO 250
  260 CONTINUE
      JAT = JAT + 5
      ME  = 0
C
C     CALL SUBROUTINE WHICH DETERMINES THE POINTS OF INTERSECTIONS
C     OF THE LINES OF THE JTH SET WITH THE RELEVANT LINES AND PLANES
C     OF OTHER ELEMENTS.
C
      CALL HDCHK (XXX,CCC,NNO,II,XI,YI,NGX,ZM,ZMI,RV,RVI,TGM,TGI,ZI,LZ,
     1            XCC)
      IF (JS .NE. 1) STOP 'MY GOSH. JS IS NOT 1 /HDLIN'
      NG = NGX(JS) + 2
      XI(1)  = X21(JX)
      YI(1)  = Y21(JX)
      ZI(1)  = Z21(JX)
      XI(NG) = X21(JX+1)
      YI(NG) = Y21(JX+1)
      ZI(NG) = Z21(JX+1)
      IF (NG .LE. 3) GO TO 340
C
C     THE FOLLOWING CODE SORTS THE INTERSECTION POINTS IN ASCENDING
C     ORDER OF OCCURENCE AND THEN SHRINKS THE LIST IF REDUNDANCY EXIST.
C
      NI  = NG - 2
      NII = NI
      DO 270 M = 1,NG
      DI(M) = (XI(M)-XI(1))**2
      PPPPP = (YI(M)-YI(1))**2
      DI(M) = DI(M) + PPPPP
  270 CONTINUE
      DO 290 M = 2,NI
      DO 280 MX= 2,NII
      IF (DI(MX) .LE. DI(MX+1)) GO TO 280
      HOLD   = DI(MX)
      HOLD1  = XI(MX)
      HOLD2  = YI(MX)
      HOLD3  = ZI(MX)
      XI(MX) = XI(MX+1)
      YI(MX) = YI(MX+1)
      ZI(MX) = ZI(MX+1)
      DI(MX) = DI(MX+1)
      DI(MX+1) = HOLD
      XI(MX+1) = HOLD1
      YI(MX+1) = HOLD2
      ZI(MX+1) = HOLD3
  280 CONTINUE
      NII = NII - 1
  290 CONTINUE
      LX  = 1
      NPX = NG
  300 NPX = NPX - 1
      I   = LX
      DO 320 M = I,NPX
      RX  = 0
      T   = XI(M) - XI(M+1)
      T1  = YI(M) - YI(M+1)
      T   = (T**2+T1**2)**.5
      IF (T .GT. HX1) GO TO 320
      IX  = M
      IX1 = NPX
      DO 310 MX = IX,IX1
      XI(MX) = XI(MX+1)
      YI(MX) = YI(MX+1)
      ZI(MX) = ZI(MX+1)
  310 CONTINUE
      RX = 1
      LX = M
      IF (LX .EQ. NPX) GO TO 330
      GO TO 300
  320 CONTINUE
  330 CONTINUE
      IF (RX .EQ. 1.) NPX = NPX - 1
      NG = NPX + 1
  340 CONTINUE
C
C     THIS CODE DETERMINES THE HDSTUS(VISIBILITY) OF EVERY OTHER POINT
C     AS SUGGESTED BY THE THEOREM IN THE TECHNICAL REPORT.
C
      DO 350 L = 1,NG,2
C
      OJ  = XI(L)
      TMJ = YI(L)
      ZJ  = ZI(L)
      CALL HDSTUS (OJ,TMJ,XXX,TGM,RV,RVI,TGI,ZM,NNO,II,H,IM,JXT,ZJ,NC,
     1             ZMI,CCC,LZ)
      DI(L) = IM
  350 CONTINUE
      DO 370 L = 1,NG,2
      IF (L .EQ. NG  ) GO TO 370
      IF (L .EQ. NG-1) GO TO 360
      C = DI(L) + DI(L+2)
      IF (C .NE. 2.) GO TO 360
      DI(L+1) = DI(L)
      GO TO 370
  360 OJ  = XI(L+1)
      TMJ = YI(L+1)
      ZJ  = ZI(L+1)
      CALL HDSTUS (OJ,TMJ,XXX,TGM,RV,RVI,TGI,ZM,NNO,II,H,IM,JXT,ZJ,NC,
     1             ZMI,CCC,LZ)
      DI(L+1) = IM
  370 CONTINUE
C
C     THE FOLLOWING CODE ACTUALLY PLOTS THE POINTS ON A GIVEN LINE
C     GOVERNED BY THE VALUE(IM) RETURNED BY HDSTUS SUBROUTINE.
C     1 MEANS INVISIBLE,...0 MEANS VISIBLE.
C
      DO 380 L = 1,NG
      X1(2) = XI(L)
      Y1(2) = YI(L)
      IM = DI(L)
      CALL HDPLT (X1,Y1,IJ,IM)
      IF (L .EQ. NG) GO TO 380
      C = DI(L) + DI(L+1)
      IF (C .GT. 0.) GO TO 380
      H(8) = 1
      OJ   = (XI(L)+XI(L+1))/2
      TMJ  = (YI(L)+YI(L+1))/2
      ZJ   = (ZI(L)+ZI(L+1))/2
      CALL HDSTUS (OJ,TMJ,XXX,TGM,RV,RVI,TGI,ZM,NNO,II,H,IM,JXT,ZJ,NC,
     1             ZMI,CCC,LZ)
      H(8) = 0
      X1(2)= OJ
      Y1(2)= TMJ
      CALL HDPLT (X1,Y1,IJ,IM)
  380 CONTINUE
      JX = JX + 1
      GO TO 250
  390 CONTINUE
C
C     DECREMENTS THE COUNT OF THE NUMBER OF LINES IN THE JTH SET
C     SINCE THE LINES OF INTERSECTIONS WERE ADDED TO THIS ELEMENT
C     BY THE SUBROUTINE SOLVE.
C
      XXX(5+JT) = XXX(5+JT) - NIT
  395 CONTINUE
  400 CONTINUE
      RETURN
      END

      SUBROUTINE MATGPR
C
C     DMAP FOR MATGPR MODULE
C
C     MATGPR    GPL,USET,SIL,KFS//C,N,F/C,N,S/C,N,PRTOPT/
C                                 C,N,FILTER/C,N,FLTRFLAG $
C
C     THIS MODULE ENHANCED BY P.R.PAMIDI/RPK CORPORATION, 3/1988
C
      EXTERNAL        ANDF
      INTEGER         GPL,USET,SIL,IM(7),TWO1,ANDF,SYSBUF,CORE,BLANK,
     1                OTPE,TYCOMP,SCALAR,COMPS(6),EXID,PRBUF(15),
     2                HEAD2(32),IPRBF(4),ICHAR(17),PRBUFC(5)
      INTEGER         NAME(2),EXTRA,HSET
      REAL            A(4),PRBUFX(5),XXBUF(15)
      CHARACTER       UFM*23,UWM*25
      COMMON /XMSSG / UFM,UWM
      COMMON /CONDAS/ IDUM(2),RADDEG
      COMMON /SYSTEM/ SYSBUF,OTPE,INX(6),NLPP,INX1(2),LINE
      COMMON /ZZZZZZ/ CORE(1)
      COMMON /BITPOS/ IBITS(32),ICHAR
      COMMON /OUTPUT/ HEAD(96),LABEL(96)
      COMMON /ZNTPKX/ IA(4),II,IEOL,IEOR
      COMMON /BLANK / IISET(2),KKSET(2),IPOPT(2),FILTER,IFLFLG
      COMMON /TWO   / TWO1(32)
      EQUIVALENCE     (XXBUF(1),PRBUF(1))
      EQUIVALENCE     (PRBUFC(1),PRBUFX(1))
      EQUIVALENCE     (IA(1), A(1))
      DATA    GPL,USET,SIL,MATRX    / 101   ,102   ,103   ,104     /
      DATA    SCALAR,COMPS,NLINE    / 4H S  ,4HT1  ,4HT2  ,4HT3    ,
     1                                4HR1  ,4HR2  ,4HR3  ,15      /
      DATA    NAME  / 4HMATG, 4HPR  /
      DATA    NULL  / 4HNULL        /
      DATA    BLANK,  EXTRA,  HSET  / 4H    ,4H E  ,4H H           /
      DATA    IHSET / 4HH           /
      DATA    IALLP / 4HALLP        /
      DATA    HEAD2 /
     1        4H    , 4HPOIN, 4HT   , 4H    , 4H   V, 4HALUE, 4H    ,
     2        4H POI, 4HNT  , 4H    , 4H    , 4HVALU, 4HE   , 4H  P0,
     3        4HINT , 4H    , 4H    , 4H VAL, 4HUE  , 4H   P, 4HOINT,
     4        4H    , 4H    , 4H  VA, 4HLUE , 4H    , 4H POI, 4HNT  ,
     5        4H    , 4H    , 4HVALU, 4HE   /
C
C
      ISET = IISET(1)
      KSET = KKSET(1)
      INLOPT = 0
      IF (IPOPT(1) .EQ. NULL) INLOPT = 1
      IF (FILTER   .EQ.  0.0) GO TO 5
      IFLAG = 1
      IF (FILTER .LT. 0.0) IFLAG = 2
      IF (IFLFLG .NE.   0) IFLAG = IFLAG + 2
    5 IM(1) = MATRX
      CALL RDTRL (IM(1))
      IF (IM(1) .LT. 0) GO TO 380
C
C     CONVERT BCD TO BIT POSITION IN USET
C
      DO 10 I = 1,32
      IF (ICHAR(I) .EQ. ISET) GO TO 20
   10 CONTINUE
      IF (ISET .NE. IHSET) GO TO 15
      ISET = -1
      GO TO 21
   15 WRITE  (OTPE,16) UWM,IISET
   16 FORMAT (A25,', UNKNOWN SET ',2A4,' SPECIFIED FOR THE FIRST PARA',
     1        'METER OF THE MATGPR MODULE.  MODULE NOT EXECUTED.')
      RETURN
C
   20 ISET = IBITS(I)
   21 CONTINUE
      DO 30 I = 1,32
      IF (ICHAR(I) .EQ. KSET) GO TO 40
   30 CONTINUE
      KSET = ISET
      GO TO 50
   40 KSET = IBITS(I)
   50 CONTINUE
      LCORE = KORSZ(CORE) - SYSBUF
      IBUF  = LCORE + 1
      IF (ISET+KSET .EQ. -2)  GO TO 51
      CALL GOPEN (GPL,CORE(IBUF),0)
      CALL READ  (*460,*60,GPL,CORE(1),LCORE,0,LGPL)
      CALL CLOSE (GPL,1)
      GO TO 500
C
C     NSET ONLY  NO GPL,USET,  ETC.
C
   51 LGPL  = 0
      LUSET = 0
      LSIL  = 0
      IUSET = 1
      ISIL  = 1
      GO TO 81
   60 CALL CLOSE (GPL,1)
      LCORE = LCORE - LGPL
      CALL GOPEN (USET,CORE(IBUF),0)
      IUSET = LGPL + 1
      CALL READ  (*480,*70,USET,CORE(LGPL+1),LCORE,0,LUSET)
      CALL CLOSE (USET,1)
      GO TO 500
   70 CALL CLOSE (USET,1)
      LCORE = LCORE - LUSET
      CALL GOPEN (SIL,CORE(IBUF),0)
      ISIL  = LGPL + LUSET + 1
      CALL READ  (*490,*80,SIL,CORE(ISIL),LCORE,0,LSIL)
      CALL CLOSE (SIL,1)
      GO TO 500
   80 CALL CLOSE (SIL,1)
      K = ISIL + LSIL
      LCORE   = LCORE - LSIL - 1
      CORE(K) = LUSET + 1
C
C     LOAD HEADER FOR PAGES
C
      LSIL = LSIL + 1
   81 CONTINUE
      DO 90 I = 1,96
   90 LABEL(I) = BLANK
      DO 100 I = 1,32
      K = 32 + I
  100 LABEL(K) = HEAD2(I)
      NCOL  = IM(2)
      CALL FNAME (MATRX,LABEL(4))
      CALL GOPEN (MATRX,CORE(IBUF),0)
      IE    = IBITS(12)
      INULL = 0
      LOOP  = 0
      ICMPX = 1
      IF (IM(5) .GT. 2) ICMPX = 3
      IF (ISET .NE. -1) MASK  = TWO1(ISET)
      IF (KSET .NE. -1) MASK1 = TWO1(KSET)
      MUSET = 0
      JC    = 0
      IKSIL = 1
      L     = 1
      ASSIGN 210 TO IOUT
      CALL PAGE
C
C     START LOOP ON EACH COLUMN
C
  110 LOOP = LOOP + 1
      CALL INTPK (*390,MATRX,0,ICMPX,0)
      IF (INULL .NE. 0) GO TO 400
  120 CONTINUE
      IF (INLOPT .EQ. 1) GO TO 359
C
C     CHECK FOR HSET
C
  121 IF (ISET  .EQ.   -1) GO TO 150
      IF (MUSET .EQ. LOOP) GO TO 160
  130 JC = JC + 1
      IF (JC .GT. LUSET) GO TO 150
      KK = LGPL + JC
      IF (ANDF(CORE(KK),MASK)) 140,130,140
C
C     FOUND COLUMN IN USET
C
  140 MUSET = MUSET + 1
      GO TO 121
C
C     COLUMN NOT IN USET
C
  150 IPRBF(L  ) = LOOP
      IPRBF(L+1) = HSET
      GO TO 200
C
C     JC IS INDEX OF NON-ZERO IN G SET-- SOOK UP SIL
C
  160 IF (IKSIL .EQ. LSIL+1) GO TO 150
      KK = ISIL + IKSIL
      IF (JC .LT. CORE(KK)) GO TO 170
      IKSIL = IKSIL + 1
      GO TO 160
  170 ICOMP = JC - CORE(KK-1) + 1
      IF (ICOMP .NE. 1) GO TO 180
C
C     CHECK FOR SCALAR POINT
C
      IF (CORE(KK)-CORE(KK-1) .GT. 1) GO TO 180
      TYCOMP = SCALAR
C
C     CHECK FOR EXTRA
C
      KK = LGPL + JC
      IF (ANDF(CORE(KK),TWO1(IE))) 171,190,171
  171 TYCOMP = EXTRA
      GO TO 190
  180 TYCOMP = COMPS(ICOMP)
  190 EXID   = CORE(IKSIL)
      IPRBF(L+1) = TYCOMP
      IPRBF(L  ) = EXID
  200 GO TO IOUT, (210,420,430)
  210 WRITE  (OTPE,220)LOOP,IPRBF(1),IPRBF(2)
  220 FORMAT ('0COLUMN',I8,2H (,I8,1H-,A2,2H).)
      LINE  = LINE + 2
      IF (LINE .GE.NLPP) CALL PAGE
      JJ    = 0
      KUSET = 0
      KSIL  = 1
      IPB   = 1
      IPBC  = 1
      IEND  = 0
  230 IF (IEOL) 350,240,350
  240 CALL ZNTPKI
C
C     CHECK FILTER
C
      IF (FILTER .EQ. 0.0) GO TO 246
C
C     FILTER IS NON-ZERO
C
      VALUE = A(1)
      IF (ICMPX .EQ. 3) VALUE = SQRT(A(1)*A(1) + A(2)*A(2))
      GO TO (241,242,243,244), IFLAG
C
  241 IF (ABS(VALUE) .LT. FILTER) GO TO 230
      GO TO 246
  242 IF (ABS(VALUE) .GT. ABS(FILTER)) GO TO 230
      GO TO 246
  243 IF (VALUE.LT.FILTER .AND. VALUE.GT.0.0) GO TO 230
      GO TO 246
  244 IF (VALUE.GT.FILTER .AND. VALUE.LT.0.0) GO TO 230
C
C     CHECK FOR HSET
C
  246 IF (KSET .EQ. -1) GO TO 306
C
C     LOOK UP ROW IN USET
C
  250 IF (KUSET .GT. LUSET+1) GO TO 500
      IF (KUSET .EQ.      II) GO TO 280
  260 JJ = JJ + 1
C
C     PROTECT AGINST NO BITPOS OR NO USET
C
      IF (JJ .GT. LUSET) GO TO 306
      KK = LGPL + JJ
      IF (ANDF(CORE(KK),MASK1)) 270,260,270
C
C     FOUND ELEMENT IN USET
C
  270 KUSET = KUSET + 1
      GO TO 250
C
C     JJ IS INDEX OF NON-ZERO IN G SET - NOW SEARCH SIL FOR JJ
C
  280 IF (KSIL .EQ. LSIL+1) GO TO 510
      KK = ISIL + KSIL
      IF (JJ .LT. CORE(KK)) GO TO 290
      KSIL = KSIL + 1
      GO TO 280
  290 ICOMP = JJ - CORE(KK-1) + 1
      IF (ICOMP .NE. 1) GO TO 300
C
C     CHECK FOR SCALAR POINT
C
      IF (CORE(KK)-CORE(KK-1) .GT. 1) GO TO 300
      TYCOMP = SCALAR
C
C     CHECK FOR EXTRA POINT
C
      KK = LGPL + JJ
      IF (ANDF(CORE(KK),TWO1(IE))) 305,310,305
C
C     EXTRA POINT
C
  305 TYCOMP = EXTRA
      GO TO 310
C
C     H POINT
C
  306 TYCOMP = HSET
      EXID   = II
      GO TO 311
  300 TYCOMP = COMPS(ICOMP)
  310 EXID   = CORE(KSIL)
  311 IF (IPB .GE. NLINE) GO TO 330
  320 PRBUF(IPB  ) = EXID
      PRBUF(IPB+1) = TYCOMP
      IF (ICMPX .EQ. 1) GO TO 325
      IF (IPOPT(1) .NE. IALLP) GO TO 325
      AMAG = SQRT(A(1)*A(1) + A(2)*A(2))
      IF (AMAG .EQ. 0.0) GO TO 325
      A(2) = ATAN2(A(2),A(1))*RADDEG
      IF (A(2) .LT. -0.00005) A(2) = A(2) + 360.0
      A(1) = AMAG
  325 PRBUF(IPB+2) = IA(1)
      PRBUFC(IPBC) = IA(2)
      IPBC = IPBC + 1
      IPB  = IPB  + 3
      GO TO 230
  330 IPB1 = IPB  - 1
      IPBC = IPBC - 1
      WRITE  (OTPE,340) (PRBUF(I),PRBUF(I+1),XXBUF(I+2),I=1,IPB1,3)
  340 FORMAT (5X,5(1X,I8,1X,1A2,1X,1P,E12.5))
      LINE = LINE + 1
      IF (ICMPX .EQ. 1) GO TO 343
      WRITE  (OTPE,341) (PRBUFX(I),I=1,IPBC)
  341 FORMAT (5X,5(13X,1P,E12.5))
      WRITE  (OTPE,342)
  342 FORMAT (1H )
      LINE = LINE + 2
  343 CONTINUE
      IPBC = 1
      IPB  = 1
      IF (LINE .GE. NLPP) CALL PAGE
      IF (IEND .EQ. 1) GO TO 360
      GO TO 320
C
C     END OF COLUMN
C
  350 IEND = 1
      IF (IPB .EQ. 1) GO TO 360
      GO TO 330
  359 CALL FWDREC (*510,MATRX)
  360 IF (LOOP  .NE. NCOL) GO TO 110
      IF (INULL .NE.    0) GO TO 450
  370 CALL CLOSE (MATRX,1)
  380 RETURN
C
  390 IF (INULL .NE. 0) GO TO 360
      INULL = 1
      IBEGN = LOOP
      GO TO 360
  400 IFIN  = LOOP - 1
      INULL = 0
  410 LOOPS = LOOP
      LOOP  = IBEGN
      ASSIGN 420 TO IOUT
      GO TO 121
  420 L = 3
      LOOP = IFIN
      ASSIGN 430 TO IOUT
      GO TO 121
  430 ASSIGN 210 TO IOUT
      L = 1
      LOOP = LOOPS
      WRITE  (OTPE,440) IBEGN,IPRBF(1),IPRBF(2),IFIN,IPRBF(3),IPRBF(4)
  440 FORMAT ('0COLUMNS',I8,2H (,I8,1H-,A2,6H) THRU,I8,2H (,I8,1H-,A2,
     1        11H) ARE NULL.)
      LINE = LINE + 2
      IF (LINE .GE. NLPP) CALL PAGE
      IF (IFIN .NE. NCOL) GO TO 120
      GO TO 370
  450 IFIN = LOOP
      GO TO 410
  460 IN = GPL
  470 CALL MESAGE (-2,IN,NAME)
  480 IN = USET
      GO TO 470
  490 IN = SIL
      GO TO 470
  500 CALL MESAGE (8,0,NAME)
      GO TO 370
  510 CALL MESAGE (7,0,NAME)
      GO TO 370
      END

      BLOCK DATA READBD
CREADBD
      INTEGER         SCR1,SCR2,SCR3,SCR4,SCR5,SCR6,SCR7,ORDER,RSTRT,
     1                PHIA,OEIGS
      REAL            LMIN,LMAX
      COMMON /REGEAN/ IM(7),IK(7),IEV(7),SCR1,SCR2,SCR3,SCR4,SCR5,LCORE,
     1                RMAX,RMIN,MZ,NEV,EPSI,RMINR,NE,NIT,NEVM,SCR6,SCR7,
     2                NFOUND,LAMA,IBUCK,NSYM
      COMMON /INVPWX/ IFILK(7),IFILM(7),IFILLM(7),IFILVC(7),
     1                ISCR1,ISCR2,ISCR3,ISCR4,ISCR5,ISCR6,ISCR7,ISCR8,
     2                IDUMP,LMIN,LMAX,NOEST,NDPLUS,NDMNUS,EPS,NOVECT
      COMMON /GIVN  / G1,MO,MD,MR1,M1,M2,M3,M4,G2(8),RSTRT,NCOL,G3(2),
     1                G4(82),ORDER,G5(2),LGAMA,G6(4),OEIGS,PHIA,G7(2),
     2                MAX,X(35)
      DATA    MO    , MD ,MR1,M1 ,M2 ,M3 ,M4 ,LGAMA,OEIGS,PHIA /
     1        301   , 304,202,303,307,308,309,201  ,204  ,305  /
      DATA    ORDER , RSTRT,NCOL,MAX,IM     ,IK     ,IEV             /
     1        -2    , 0    ,0   ,253,102,6*0,101,6*0,302,0,0,2,1,0,0 /
      DATA    SCR1  , SCR2,SCR3,SCR4,SCR5,LAMA,SCR6,SCR7 /
     1        306   , 307 ,303 ,304 ,305 ,301 ,308 ,204  /
      DATA    RMAX  , RMIN,EPSI   ,RMINR      /
     1        100.0 , .01 ,1.0E-11,-.001      /
      DATA    MZ    , NEV,NE,NIT,NEVM,NFOUND  /
     1        0     , 9  ,4 ,30 ,5   ,0       /
      DATA    IFILK , IFILM  ,IFILLM ,IFILVC  /
     1        101,6*0,102,6*0,201,6*0,202,6*0 /
      DATA    ISCR1 ,ISCR2,ISCR3,ISCR4,ISCR5,ISCR6,ISCR7,ISCR8,IDUMP/
     1        301   ,302  ,303  ,304  ,305  ,306  ,307  ,308  ,204  /
      DATA    NOEST ,NDPLUS,NDMNUS,EPS  ,NOVECT,LMIN,LMAX,NSYM      /
     1        5     ,5     ,0     ,.0001,0     ,0.  ,60.  ,0        /
      END

        SUBROUTINE DSRDMB ( IDATA, M )
      INCLUDE 'DSIOF.COM'
      INCLUDE 'XNSTRN.COM'
        INTEGER           IDATA(2)
        IRWORD = 0
10      LEN     = IAND( IBASE( INDCLR ) , MASKH2 )
        IF ( LEN .EQ. 0 ) GO TO 40
        IDIFF   = INDCBP - INDCLR
        IWORDS  = LEN - IDIFF
        IREQ    = IABS( NWORDS )
        IF ( IREQ .GT. ( IWORDS+IRWORD ) ) GO TO 40
        INUM    = IREQ - IRWORD
        IF ( INUM .EQ. 0 ) GO TO 7000
        IF ( NWORDS .LT. 0 ) GO TO 30
        DO 20 K = 1, INUM
        IDATA( IRWORD+K ) = IBASE( INDCBP+K )
20      CONTINUE
30      INDCBP = INDCBP + INUM
        GO TO 7000
40      ID = IAND( IBASE( INDCLR+LEN+1 ), MASKQ2 )
        IF ( LEN .EQ. 0 ) GO TO 65
        IF ( NWORDS .LT. 0 ) GO TO 60
        DO 50 K = 1, IWORDS
        IDATA( IRWORD+K ) = IBASE( INDCBP+K )
50      CONTINUE
60      IRWORD = IRWORD + IWORDS
65      IF ( ID .EQ. IDSC ) GO TO 70
        CALL DSRDNB
        GO TO 10
70      IRETRN = 2
        IEOR   = 1
        M      = IRWORD
7000    RETURN
        END

      SUBROUTINE PKTRMS (NTYPE)
C
C     THIS ROUTINE CALCULATES AND SHIPS TO PLA4B THE STIFFNESS MATRIX
C     FOR PLA4
C
C     *** TRIANGULAR MEMBRANE ELEMENT ***
C
C     CALLS FROM THIS ROUTINE ARE MADE TO
C
C     PLAMAT - ROTATES AND RETURNS GP
C     PLA4B  - INSERTION ROUTINE
C     TRANSD - DOUBLE PRECISION TRANSFORMATION SUPPLIER
C     GMMATD - DOUBLE PRECISION MATRIX MULTIPLY AND TRANSPOSE
C     MESAGE - ERROR MESSAGE WRITER
C
C     IF NTYPE = 0  COMPLETE MEMBRANE COMPUTATION IS PERFORMED
C
C     IF NTYPE = 1 RETURN 3 TRANSFORMED  3X3 MATRICES ONLY FOR THE PIVOT
C
C     ECPT LIST
C                                                      IN
C                                                      THIS
C     ECPT       DESCRIPTION                         ROUTINE   TYPE
C     ===============================================================
C     ECPT( 1) = ELEMENT ID                          NECPT(1)  INTEGER
C     ECPT( 2) = GRID POINT A                        NGRID(1)  INTEGER
C     ECPT( 3) = GRID POINT B                        NGRID(2)  INTEGER
C     ECPT( 4) = GRID POINT C                        NGRID(3)  INTEGER
C     ECPT( 5) = THETA = ANGLE OF MATERIAL           ANGLE     REAL
C     ECPT( 6) = MATERIAL ID                         MATID     INTEGER
C     ECPT( 7) = T                                   T         REAL
C     ECPT( 8) = NON-STRUCTURAL MASS                 FMU       REAL
C     ECPT( 9) = COORD. SYSTEM ID 1                  NECPT(9)  INTEGER
C     ECPT(10) = X1                                  X1        REAL
C     ECPT(11) = Y1                                  Y1        REAL
C     ECPT(12) = Z1                                  Z1        REAL
C     ECPT(13) = COORD. SYSTEM ID 2                  NECPT(13) INTEGER
C     ECPT(14) = X2                                  X2        REAL
C     ECPT(15) = Y2                                  Y2        REAL
C     ECPT(16) = Z2                                  Z2        REAL
C     ECPT(17) = COORD. SYSTEM ID 3                  NECPT(17) INTEGER
C     ECPT(18) = X3                                  X3        REAL
C     ECPT(19) = Y3                                  Y3        REAL
C     ECPT(20) = Z3                                  Z3        REAL
C     ECPT(21) = ELEMENT TEMPERATURE                 ELTEMP    REAL
C
      DOUBLE PRECISION TEMPAR,C,E,TI,TEMP,G,XSUBC,VOL,XSUBB,YSUBC,
     1                 REELMU,FLAMDA,DELTA,KIJ
      DIMENSION        G(9),ECPT(1)
      COMMON /CONDAS/  CONSTS(5)
      COMMON /PLA42C/  NPVT,DUM1(148),NOGO
      COMMON /PLA4ES/  NECPT(1),NGRID(3),ANGLE,MATID1,T,FMU,DUMMY1,X1,
     1                 Y1,Z1,DUMMY2,X2,Y2,Z2,DUMMY3,X3,Y3,Z3,DUMB(80)
      COMMON /MATIN /  MATID,INFLAG,ELTEMP,STRESS,SINTH,COSTH
      COMMON /MATOUT/  G11,G12,G13,G22,G23,G33
      COMMON /PLA42D/  KIJ(36),C(18),E(9),TEMPAR(27),TI(9),TEMP,XSUBB,
     1                 XSUBC,YSUBC,VOL,REELMU,DELTA,FLAMDA,THETA,KA,
     2                 NPOINT,NSAVE,DUMMY(382)
      EQUIVALENCE      (CONSTS(4),DEGRA),(G(1),TEMPAR(19)),
     1                 (ECPT(1),NECPT(1))
C
C     SET UP THE E MATRIX WHICH IS (3X2) FOR THE TRI-MEMBRANE
C
C     E(1), E(3), E(5) WILL BE THE I-VECTOR
C     E(2), E(4), E(6) WILL BE THE J-VECTOR
C     E(7), E(8), E(9) WILL BE THE K-VECTOR NOT USED IN E FOR MEMBRANE
C
C     FIRST FIND I-VECTOR = RSUBB - RSUBA  (NON-NORMALIZED)
C
      E(1) = DBLE(X2) - DBLE(X1)
      E(3) = DBLE(Y2) - DBLE(Y1)
      E(5) = DBLE(Z2) - DBLE(Z1)
C
C     NOW FIND LENGTH = X-SUB-B   COORD. IN ELEMENT SYSTEM
C
      XSUBB = DSQRT(E(1)**2 + E(3)**2 + E(5)**2)
      IF (XSUBB .GT. 1.0D-06) GO TO 20
      CALL MESAGE (30,31,ECPT(1))
C
C     SET FLAG FOR FATAL ERROR WHILE ALLOWING ERROR MESSAGES TO
C     ACCUMULATE
C
      NOGO = 1
      RETURN
C
C  20 NOW NORMALIZE I-VECTOR WITH X-SUB-B
C
   20 E(1) = E(1)/XSUBB
      E(3) = E(3)/XSUBB
      E(5) = E(5)/XSUBB
C
C     HERE WE NOW TAKE RSUBC - RSUBA AND STORE TEMPORARILY IN
C     E(2), E(4), E(6) WHICH IS WHERE THE J-VECTOR WILL FIT LATER
C
      E(2) = DBLE(X3) - DBLE(X1)
      E(4) = DBLE(Y3) - DBLE(Y1)
      E(6) = DBLE(Z3) - DBLE(Z1)
C
C     X-SUB-C  =  I . (RSUBC - RSUBA),  THUS
C
      XSUBC = E(1)*E(2) + E(3)*E(4) + E(5)*E(6)
C
C     AND CROSSING THE I-VECTOR TO (RSUBC-RSUBA) GIVES THE K-VECTOR
C     (NON-NORMALIZED)
C
      E(7) = E(3)*E(6) - E(5)*E(4)
      E(8) = E(5)*E(2) - E(1)*E(6)
      E(9) = E(1)*E(4) - E(3)*E(2)
C
C     THE LENGTH OF THE K-VECTOR IS NOW FOUND AND EQUALS Y-SUB-C
C     COORD. IN ELEMENT SYSTEM
C
      YSUBC = DSQRT(E(7)**2 + E(8)**2 + E(9)**2)
      IF (YSUBC .GT. 1.0D-06) GO TO 25
      CALL MESAGE (30,32,ECPT(1))
C
C     SET FLAG FOR FATAL ERROR WHILE ALLOWING ERROR MESSAGES TO
C     ACCUMULATE
C
      NOGO = 1
      RETURN
C
C  25 NOW NORMALIZE K-VECTOR WITH YSUBC JUST FOUND
C
   25 E(7) = E(7)/YSUBC
      E(8) = E(8)/YSUBC
      E(9) = E(9)/YSUBC
C
C     J VECTOR = K CROSS I
C     STORE IN THE SPOT FOR J
C
      E(2) = E(5)*E(8) - E(3)*E(9)
      E(4) = E(1)*E(9) - E(5)*E(7)
      E(6) = E(3)*E(7) - E(1)*E(8)
C
C     AND JUST FOR COMPUTER EXACTNESS NORMALIZE J-VECTOR TO MAKE SURE.
C
      TEMP = DSQRT(E(2)**2 + E(4)**2 + E(6)**2)
      IF (TEMP .NE. 0.0D0) GO TO 26
      CALL MESAGE (30,26,ECPT(1))
C
C     SET FLAG FOR FATAL ERROR WHILE ALLOWING ERROR MESSAGES TO
C     ACCUMULATE
C
      NOGO = 1
      RETURN
C
   26 E(2) = E(2)/TEMP
      E(4) = E(4)/TEMP
      E(6) = E(6)/TEMP
C
C     VOLUME OF ELEMENT, THETA, MU, LAMDA, AND DELTA
C
      VOL = XSUBB*YSUBC*DBLE(T)/2.0D0
      REELMU = 1.0D0/XSUBB
      FLAMDA = 1.0D0/YSUBC
      DELTA  = XSUBC/XSUBB - 1.0D0
C
C     NOW FORM THE  C MATRIX   (3X6) PARTITIONED AS FOLLOWS HERE.
C         CSUBA = (3X2) STORED IN C( 1) THRU C( 6) BY ROWS
C         CSUBB = (3X2) STORED IN C( 7) THRU C(12) BY ROWS
C         CSUBC = (3X2) STORED IN C(13) THRU C(18) BY ROWS
C
      C(1)  = -REELMU
      C(2)  =  0.0D0
      C(3)  =  0.0D0
      C(4)  =  FLAMDA*DELTA
      C(5)  =  C(4)
      C(6)  = -REELMU
      C(7)  =  REELMU
      C(8)  =  0.0D0
      C(9)  =  0.0D0
      C(10) = -FLAMDA*REELMU*XSUBC
      C(11) =  C(10)
      C(12) =  REELMU
      C(13) =  0.0D0
      C(14) =  0.0D0
      C(15) =  0.0D0
      C(16) =  FLAMDA
      C(17) =  FLAMDA
      C(18) =  0.0D0
      IF (NTYPE .EQ. 1) GO TO 30
C
      THETA = ANGLE*DEGRA
      SINTH = SIN(THETA)
      COSTH = COS(THETA)
   30 IF (ABS(SINTH) .LT. 1.0E-06) SINTH = 0.0E0
      MATID = MATID1
      INFLAG = -1
      CALL PLAMAT
C
C     FILL G-MATRIX WITH OUTPUT FROM MAT ROUTINE
C
      G(1) = G11
      G(2) = G12
      G(3) = G13
      G(4) = G12
      G(5) = G22
      G(6) = G23
      G(7) = G13
      G(8) = G23
      G(9) = G33
C
C     AT THIS POINT, G, E, AND C MATRICES ARE COMPLETE
C
C     AT THIS POINT THE FOLLOWING EQUATION CAN BE SOLVED FOR K-SUB-IJ
C
C                     T        T             T
C       K   = VOL . T  * E * C  * G * C  * E  * T
C        IJ          I        I        J         J
C
C     T-SUB-I WILL BE USED IN THE ABOVE ONLY IF THE PIVOT COORDINATE
C     SYSTEM ID IS NOT ZERO, OTHERWISE IT IS ASSUMED TO BE THE
C     IDENTITY MATRIX.
C
C     THE I SUBSCRIPT IMPLIES THE PIVOT POINT  1,2, OR 3 (ELEMENT SYST)
C     THE J SUBSCRIPT IMPLIES  1 THRU 3  FOR EACH CALL TO THIS ROUTINE.
C
C     FIRST LOCATE WHICH POINT IS THE PIVOT
C
      DO 100 I = 1,3
      IF (NGRID(I) .NE. NPVT) GO TO 100
      KA = 4*I + 5
      NPOINT = 6*I - 5
      GO TO 150
  100 CONTINUE
C
C     FALLING THRU ABOVE LOOP INDICATES THE PIVOT POINT SPECIFIED BY
C     NPVT WAS NOT FOUND EQUAL TO ANY OF THE 3 GRID POINTS IN THE ECPT
C     THUS ERROR CONDITION.
C
      CALL MESAGE (-30,34,ECPT(1))
C
C                     T
C     COMPUTE   E * C   * G       AND STORE IN TEMPAR( 1 THRU 9 )
C                    I
C
  150 CALL GMMATD (E,3,2,0, C(NPOINT),3,2,1, TEMPAR(10))
      CALL GMMATD (TEMPAR(10),3,3,0, G,3,3,0, TEMPAR(1))
C
C     NCOM WILL ALWAYS POINT TO THE COMMON 3 X 3 PRODUCT ABOVE
C     NPT1 WILL POINT TO FREE WORKING SPACE LENGTH 9
C
      NCOM = 1
      NPT1 = 10
C
C     MULTIPLY COMMON PRODUCT BY SCALER VOL
C
      DO 90 I = 1,9
   90 TEMPAR(I) = TEMPAR(I)*VOL
C
C     CHECK FOR PIVOT  CSID = 0,  IF ZERO SKIP TRANSFORMATION TSUBI.
C
      IF (NECPT(KA) .EQ. 0) GO TO 80
C
C     NOT-ZERO THUS GET TI
C
      CALL TRANSD (NECPT(KA),TI)
C
C     INTRODUCE TI INTO THE COMMON PRODUCT AND STORE AT
C     TEMPAR(10 THRU 18)
C
      CALL GMMATD (TI,3,3,1, TEMPAR(1),3,3,0, TEMPAR(10))
C
C     COMMON PRODUCT NOW STARTS AT TEMPAR(10) THUS CHANGE NCOM AND NPT1
C
      NCOM = 10
      NPT1 =  1
C
C  80 NOW HAVE COMMON PRODUCT STORED BEGINNING TEMPAR(NCOM),  (3X3).
C     NPT1 POINTS TO FREE WORKING SPACE LENGTH 9.
C
C     PROCEED NOW AND RUN OUT THE 3 6X6 MATRICES KIJ-SUB-1,2,3.
C
C     FIRST ZERO OUT (6 X 6) K
C                             IJ
C
   80 NSAVE = NPT1
      DO 700 I = 1,36
  700 KIJ(I) = 0.0D0
      NPOINT = 0
C
      DO 500 I = 1,3
      CALL GMMATD (C(6*I-5),3,2,0, E,3,2,1, TEMPAR(NSAVE))
C
C                                                                 T
C     NPT2 IS SET TO POINT TO THE BEGINNING OF THE PRODUCT  C  * E  * T
C                                                            J         J
C
      NPT2 = NSAVE
      NPT1 = 19
C
C     CHECK FOR ZERO CSID IN WHICH CASE TJ IS NOT NEEDED
C
      IF (NECPT(4*I+5) .EQ. 0) GO TO 60
C
C     COMMING HERE IMPLIES NEED FOR TJ
C     WILL STORE TJ IN TI
C
      CALL TRANSD (NECPT(4*I+5),TI)
      CALL GMMATD (TEMPAR(NPT2),3,3,0, TI,3,3,0, TEMPAR(19))
      NPT1 = NPT2
      NPT2 = 19
C
C  60 AT THIS POINT COMPLETE COMPUTATION FOR  K-SUB-I,J
C
   60 CALL GMMATD (TEMPAR(NCOM),3,3,0, TEMPAR(NPT2),3,3,0, TEMPAR(NPT1))
C
      IF (NTYPE .EQ. 0) GO TO 95
      DO 96 J = 1,9
      NPOINT = NPOINT + 1
      NPT2   = NPT1 + J - 1
   96 KIJ(NPOINT) = TEMPAR(NPT2)
      GO TO 500
C
   95 KIJ( 1) = TEMPAR(NPT1  )
      KIJ( 2) = TEMPAR(NPT1+1)
      KIJ( 3) = TEMPAR(NPT1+2)
      KIJ( 7) = TEMPAR(NPT1+3)
      KIJ( 8) = TEMPAR(NPT1+4)
      KIJ( 9) = TEMPAR(NPT1+5)
      KIJ(13) = TEMPAR(NPT1+6)
      KIJ(14) = TEMPAR(NPT1+7)
      KIJ(15) = TEMPAR(NPT1+8)
      CALL PLA4B (KIJ(1),NECPT(I+1))
C
  500 CONTINUE
      RETURN
      END

      SUBROUTINE CDCMPD (*,IX,X,DX)
C
C     DOUBLE-PRECISION VERSION OF CDCOMP
C     (THIS ROUTINE WAS PREVIOUSLY CALLED CDCOMP AND IS NOW RENAMED
C     TO CDCMPD)    BY G.CHAN/SPERRY  6/85
C
C     TO ELIMINATE IBM UNDERFLOW MESSAGES, THIS VERSION ZEROS OUT
C     THE COMPUTED DX ELEMENT IF /IT/ IS LESS THAN 1.0D-38
C
C     CDCOMP WILL DECOMPOSE A COMPLEX UNSYMETRIC MATRIX INTO A UNIT LOWE
C     TRIANGULAR MATRIX AND AN UPPER TRIANGULAR MATRIX,USING PARTIAL
C     PIVOTING WITHIN THE LOWER BAND
C
C     DEFINITION OF INPUT PARAMETERS
C
C     FILEA    =  MATRIX CONTROL BLOCK FOR THE INPUT  MATRIX A
C     FILEL    =  MATRIX CONTROL BLOCK FOR THE OUTPUT MATRIX L
C     FILEU    =  MATRIX CONTROL BLOCK FOR THE OUTPUT MATRIX U
C     SR1FIL   =  SCRATCH FILE
C     SR2FIL   =  SCRATCH FILE
C     SR3FIL   =  SCRATCH FILE
C     NX       =  NUMBER OF CELLS OF CORE AVAILABLE AT IX
C     DET      =  CELL WHERE THE DETERMINATE OF A WILL BE STORED
C     POWER    =  SCALE FACTOR TO BE APPLIED TO THE DETERMINATE
C                 (DETERMINATE = DET*10**POWER)
C     MINDIA   =  CELL WHERE THE VALUE OF THE MINIMUM DIAGONAL WILL BE S
C     IX       =  BLOCK OF CORE AVAILABLE AS WORKING STORAGE TO DECOMP
C     X        =  SAME BLOCK AS IX, BUT TYPED REAL
C     DX       =  SAME BLOCK AS IX, BUT TYPED DOUBLE PRECISION
C
      INTEGER            FILEA     ,FILEL    ,FILEU    ,POWER    ,
     1                   SYSBUF    ,FORMA    ,TYPEA    ,RDP      ,
     2                   TYPEL     ,EOL      ,PARM(5)  ,BUFA     ,
     3                   OUTBUF    ,SR1BUF   ,SR2BUF   ,SR3BUF   ,
     4                   B         ,BBAR     ,C        ,CBAR     ,
     5                   BBAR1     ,R        ,CCOUNT   ,CBCNT    ,
     6                   SCRFLG    ,END      ,BBBAR    ,BBBAR1   ,
     7                   COUNT     ,SR2FL    ,SR3FL    ,SR1FIL   ,
     8                   SR2FIL    ,SR3FIL   ,SQR      ,SYM      ,
     9                   FLAG      ,ITRAN(6)
      DOUBLE PRECISION   DZ(2)     ,DA(2)    ,DET      ,MAX(2)   ,
     1                   MINDIA    ,DX(1)    ,DTRN(2)  ,DX1      ,
     2                   DX2       ,EPSI
      DIMENSION          IX(1)     ,X(1)
      CHARACTER          UFM*23    ,UWM*25   ,UIM*29
      COMMON   /XMSSG /  UFM       ,UWM      ,UIM
      COMMON   /CDCMPX/  FILEA(7)  ,FILEL(7) ,FILEU(7) ,SR1FIL   ,
     1                   SR2FIL    ,SR3FIL   ,DET(2)   ,POWER    ,
     2                   NX        ,MINDIA   ,B        ,BBAR     ,
     3                   C         ,CBAR     ,R
      COMMON   /SYSTEM/  SYSBUF    ,NOUT
      COMMON   /NAMES /  RD        ,RDREW    ,WRT      ,WRTREW   ,
     1                   REW       ,NOREW    ,EOFNRW   ,RSP      ,
     2                   RDP       ,CSP      ,CDP      ,SQR      ,
     3                   RECT      ,DIAG     ,LOWTRI   ,UPRTRI   ,
     4                   SYM       ,ROW      ,IDENT
      COMMON   /ZNTPKX/  A(4)      ,II       ,EOL
      COMMON   /DESCRP/  LENGTH    ,MAJOR
      COMMON   /ZBLPKX/  Z(4)      ,JJ
      COMMON   /UNPAKX/  ITYPEX    ,IXY      ,JXY      ,INCRX
      COMMON   /PACKX /  ITYPE1    ,ITYPE2   ,IY       ,JY       ,
     1                   INCRY
      EQUIVALENCE        (DA(1),A(1))        ,(DZ(1),Z(1))       ,
     1                   (FORMA,FILEA(4))    ,(TYPEA,FILEA(5))   ,
     2                   (NCOL,FILEA(3))     ,(TYPEL,FILEL(5))   ,
     3                   (ITRAN(1),ITRN)     ,(ITRAN(2),JTRN)    ,
     4                   (ITRAN(3),DTRN(1))
      DATA      PARM(3), PARM(4)  /4HCDCO,4HMP  /
      DATA      IBEGN  , IEND     /4HBEGN,4HEND /
      DATA      EPSI   / 1.0D-38  /
C
C     BUFFER ALLOCATION
C
      BUFA   = NX     - SYSBUF
      IBUFL  = BUFA   - SYSBUF
      OUTBUF = IBUFL  - SYSBUF
      SR1BUF = OUTBUF - SYSBUF
      SR2BUF = SR1BUF - SYSBUF
      SR3BUF = SR2BUF - SYSBUF
      ICRQ   =-SR3BUF
      IF (ICRQ .GT. 0) GO TO 1715
      DET(1) = 1.D0
      DET(2) = 0.D0
      POWER  = 0
      MINDIA = 1.D+25
      ITERM  = 0
      IF (FILEA(1) .LT. 0) ITERM = 1
      FILEA(1) = IABS(FILEA(1))
C
C     WRITE THE HEADER RECORD ON THE OUTPUT TAPES AND INITIALIZE THE
C     TRAILER RECORDS.
C
      CALL GOPEN (FILEL,IX(IBUFL),WRTREW)
      PARM(2) = SR2FIL
      CALL OPEN (*1680,SR2FIL,IX(OUTBUF),WRTREW)
      CALL FNAME (FILEU(1),X(1))
      CALL WRITE (SR2FIL,X(1),2,1)
      FILEL(2) = 0
      FILEL(3) = NCOL
      FILEL(4) = 4
      FILEL(6) = 0
      FILEL(7) = 0
      FILEU(2) = 0
      FILEU(3) = NCOL
      FILEU(4) = 5
      FILEU(6) = 0
      FILEU(7) = 0
C
C     CALL GENVEC TO PICK B,BBAR,C,CBAR, AND R
C
      IF (B.GT.0 .AND. BBAR.GT.0) GO TO 11
      CALL GENVEC (*1720,IX(BUFA),FILEA(1),NX,IX(1),NCOL,B,BBAR,C,CBAR,
     1             R,2)
   11 CONTINUE
      BBAR1  = BBAR + 1
      BBBAR  = MIN0(B+BBAR,NCOL)
      BBBAR1 = BBBAR - 1
      SCRFLG = 0
      IF (R .LT. BBBAR1) SCRFLG = 1
      IF (SCRFLG .EQ. 0) GO TO 20
      ICRQ = (BBBAR1-R)*4*BBAR
      CALL PAGE2(2)
      WRITE  (NOUT,15) UIM,ICRQ
   15 FORMAT (A29,' 2177, SPILL WILL OCCUR IN COMPLEX UNSYMMETRIC ',
     1       'DECOMPOSITION.', /1X,I10,
     2       ' ADDITIONAL WORDS NEEDED TO STAY IN CORE.')
C
C     INITIALIZE POINTERS TO SPECIFIC AREAS OF CORE
C
   20 I1   = 1
      IPAK = I1 + 2*BBAR*R + BBBAR/2 + 1
      I1SP = BBAR*R*4 + 1
      I2   = IPAK
      I3SP = (I2  + 2*MIN0(NCOL,BBBAR + BBAR))*2 - 1
      I3   = I2   + 2*MIN0(NCOL,BBBAR+BBAR) + C
      I4SP = I3SP + (BBAR+2)*C*4 - 2*C
      I4   = I3   + 2*BBAR1*C + CBAR
      I5   = I4   + 2*BBBAR*CBAR
      I6SP = (I5  + 2*C*CBAR)*2 - 1
      I7SP = I6SP + CBAR
      PARM(5) = IBEGN
      CALL CONMSG (PARM(3),3,0)
      END  = I7SP + C
C
C     DEFINITION OF KEY PROGRAM PARAMETERS
C
C     I1     =  POINTER TO AREA WHERE COMPLETED COLUMNS OF L ARE STORED
C     I1SP   =  POINTER TO AREA WHERE THE PERMUTATION INDEXES ARE STORED
C     IPAK   =  POINTER TO AREA WHERE COLUMNS WILL BE PACKED FROM
C     I2     =  POINTER TO AREA WHERE THE NEXT COLUMN OF A IS STORED
C     I3     =  POINTER TO AREA WHERE ACTIVE COLUMNS ARE STORED
C     I4     =  POINTER TO AREA WHERE ACTIVE ROWS ARE STORED
C     I5     =  POINTER TO AREA WHERE INTERACTION ELEMENTS ARE STORED
C     I6SP   =  POINTER TO AREA WHERE SEQUENCED ACTIVE ROW INDICES
C               ARE STORED
C     I7SP   =  POINTER TO AREA WHERE SEQUENCED ACTIVE COLUMN INDICES
C               ARE STORED
C     B      =  UPPER HALF-BAND
C     BBAR   =  LOWER HALF-BAND
C     C      =  NUMBER OF ACTIVE COLUMNS
C     CBAR   =  NUMBER OF ACTIVE ROWS
C     R      =  NUMBER OF COLUMNS OF L THAT CAN BE STORED IN CORE
C     JPOS   =  CURRENT PIVOTAL COLUMN INDEX
C     JPOSL  =  NEXT COLUMN OF L TO BE WRITTEN OUT
C     LCOL   =  NUMBER OF COLUMNS OF L CURRENTLY STORED IN CORE OR ON
C               SCRATCH FILES
C     CCOUNT =  CURRENT NUMBER OF ACTIVE COLUMNS
C     CBCNT  =  CURRENT NUMBER OF ACTIVE ROWS
C     ITRN   =  ROW INDEX OF NEXT ACTIVE COLUMN ELEMENT
C     JTRN   =  COLUMN INDEX  OF NEXT ACTIVE COLUMN ELEMENT
C     IOFF   =  ROW POSITION OF THE FIRST ELEMENT IN AREA II
C     ITERM  =  IF NONZERO, TERMINATE BEFORE THE RE-WRITE
C     NCOL   =  SIZE OF THE INPUT MATRIX
C     BBBAR  =  B + BBAR
C     BBAR1  =  BBAR + 1
C     BBBAR1 =  B + BBAR - 1
C     SCRFLG =  NONZERO MEANS SPILL
C
C     ****************************************************************
C     RE-WRITE THE UPPER TRIANGLE OF ACTIVE ELEMENTS IN THE TRANSPOSED
C     ORDER
C     ****************************************************************
C
      PARM(2) = FILEA(1)
      CALL OPEN (*1680,FILEA(1),IX(BUFA),RDREW)
      CCOUNT = 0
      IF (C .EQ. 0) GO TO 40
      CALL CTRNSP (IX(1),X(1),NX,FILEA(1),B,SR1FIL)
C
C     ZERO CORE
C
   40 DO 50 I = 1,END
   50 X(I) = 0.
      IF (C .EQ. 0) GO TO 260
C
C     ****************************************************************
C     OPEN THE FILE CONTAINING THE TRANSPOSED ACTIVE ELEMENTS AND READ
C     IN THE FIRST BBAR + 1 ROWS
C     ****************************************************************
C
      PARM(2) = SR1FIL
      CALL OPEN (*1680,SR1FIL,IX(SR1BUF),RD)
      K = 0
   60 CALL READ (*1690,*1700,SR1FIL,ITRAN(1),6,0,FLAG)
      IF (ITRN .GT. 0) GO TO 70
      CALL CLOSE (SR1FIL,REW)
      GO TO 140
   70 IF (ITRN .GT. K+1) GO TO 130
C
C     DETERMINE IF COLUMN IS ALREADY ACTIVE
C
      IF (JTRN .LE. BBBAR) GO TO 60
      KK  = 0
   80 IN1 = I3SP + KK
      IF (IX(IN1) .EQ. JTRN) GO TO 90
      KK  = KK + 1
      IF (KK-C) 80,100,1710
C
C     ADD IN ACTIVE ELEMENT TO EXISTING COLUMN
C
   90 IN1 = I3 + 2*KK*BBAR1 + K + K
      DX(IN1  ) = DTRN(1)
      DX(IN1+1) = DTRN(2)
      IF (DABS(DX(IN1  )) .LT. EPSI) DX(IN1  ) = 0.0D0
      IF (DABS(DX(IN1+1)) .LT. EPSI) DX(IN1+1) = 0.0D0
      GO TO 60
C
C     CREATE NEW ACTIVE COLUMN
C
  100 CCOUNT = CCOUNT + 1
      KK  = 0
  110 IN1 = I3SP + KK
      IF (IX(IN1) .EQ. 0) GO TO 120
      KK  = KK + 1
      IF (KK - C) 110,1710,1710
  120 IX(IN1) = JTRN
      IN1 = IN1 + C
      IX(IN1) = K + 1
      IN1 = I3 + 2*KK*BBAR1 + K + K
      DX(IN1  ) = DTRN(1)
      DX(IN1+1) = DTRN(2)
      IF (DABS(DX(IN1  )) .LT. EPSI) DX(IN1  ) = 0.0D0
      IF (DABS(DX(IN1+1)) .LT. EPSI) DX(IN1+1) = 0.0D0
      GO TO 60
  130 K = K + 1
      IF (K-BBAR1) 70,140,1710
C
C     SET INDEXES IN AREA VII TO POINT TO THE ACTIVE COLUMNS IN SEQUENCE
C
  140 ASSIGN 260 TO KK
  150 IN1 = I7SP
      K   = 0
  160 IN2 = I3SP + K
      IF (IX(IN2)) 1710,180,190
  170 IN1 = IN1 + 1
  180 K   = K + 1
      IF (K-C) 160,250,1710
  190 IF (IN1 .NE. I7SP) GO TO 200
      IX(IN1) = K
      GO TO 170
  200 KKK = 0
  210 IN3 = IN1 - KKK
      IF (IN3 .GT. I7SP) GO TO 220
      IX(IN3) = K
      GO TO 170
  220 IN4 = I3SP + IX(IN3-1)
      IF (IX(IN2)-IX(IN4)) 240,1710,230
  230 IX(IN3) = K
      GO TO 170
  240 IX(IN3) = IX(IN3-1)
      KKK = KKK + 1
      GO TO 210
  250 GO TO KK, (260,1570)
  260 CONTINUE
C
C     INITIALIZE
C
      SR2FL = FILEU(1)
      SR3FL = SR3FIL
      JPOS  = 1
      PARM(2) = FILEA(1)
      CALL FWDREC (*1690,FILEA(1))
      LCOL  = 0
      CBCNT = 0
      JPOSL = 0
  270 IF (JPOS .GT. NCOL) GO TO 1670
C
C     ****************************************************************
C     READ NEXT COLUMN OF A INTO AREA II
C     ****************************************************************
C
      IOFF  = MAX0(1,JPOS-BBBAR1)
      COUNT = CBCNT
      CALL INTPK (*1720,FILEA(1),0,CDP,0)
      K = 1
      IF (JPOS .GT. BBBAR) K = JPOS - B + 1
  280 IF (EOL) 400,290,400
  290 CALL ZNTPKI
      IF (II .LT. K) GO TO 280
      K = JPOS + BBAR
  300 IF (II .GT. K) GO TO 330
C
C     READ ELEMENTS WITHIN THE BAND INTO AREA II
C
      IN1 = I2 + 2*(II-IOFF)
      DX(IN1  ) = DA(1)
      DX(IN1+1) = DA(2)
      IF (DABS(DX(IN1  )) .LT. EPSI) DX(IN1  ) = 0.0D0
      IF (DABS(DX(IN1+1)) .LT. EPSI) DX(IN1+1) = 0.0D0
  310 IF (EOL) 400,320,400
  320 CALL ZNTPKI
      GO TO 300
C
C     TAKE CARE OF ACTIVE ELEMENTS BELOW THE BAND
C
  330 KK  = 0
  340 IN1 = I4SP + KK
      IF (IX(IN1)-II) 350,360,350
  350 KK  = KK + 1
      IF (KK-CBAR) 340,370,1710
C
C     ADD IN ACTIVE ELEMENT TO EXISTING ROW
C
  360 IN1 = I4 + 2*(KK+1)*BBBAR - 2
      DX(IN1  ) = DA(1)
      DX(IN1+1) = DA(2)
      IF (DABS(DX(IN1  )) .LT. EPSI) DX(IN1  ) = 0.0D0
      IF (DABS(DX(IN1+1)) .LT. EPSI) DX(IN1+1) = 0.0D0
      GO TO 310
C
C     CREATE NEW ACTIVE ROW
C
  370 KK  = 0
  380 IN1 = I4SP + KK
      IF (IX(IN1) .EQ. 0) GO TO 390
      KK  = KK + 1
      IF (KK-CBAR) 380,1710,1710
  390 IX(IN1) = II
      IN1 = IN1 + CBAR
      IX(IN1) = JPOS
      IN1 = I4 + (KK+1)*BBBAR*2 - 2
      DX(IN1  ) = DA(1)
      DX(IN1+1) = DA(2)
      IF (DABS(DX(IN1  )) .LT. EPSI) DX(IN1  ) = 0.0D0
      IF (DABS(DX(IN1+1)) .LT. EPSI) DX(IN1+1) = 0.0D0
      CBCNT = CBCNT + 1
      GO TO 310
C
C     ARRANGE ACTIVE ROW INDEXES IN SEQUENCE AND STORE THEM IN AREA VI
C
  400 IF (COUNT .EQ. CBCNT) GO TO 500
      IN1 = I6SP
      K   = 0
  410 IN2 = I4SP + K
      IF (IX(IN2)) 1710,430,440
  420 IN1 = IN1 + 1
  430 K   = K + 1
      IF (K-CBAR) 410,500,1710
  440 IF (IN1 .NE. I6SP) GO TO 450
      IX(IN1) = K
      GO TO 420
  450 KK  = 0
  460 IN3 = IN1 - KK
      IF (IN3 .GT. I6SP) GO TO 470
      IX(IN3) = K
      GO TO 420
  470 IN4 = I4SP + IX(IN3-1)
      IF (IX(IN2)-IX(IN4)) 490,1710,480
  480 IX(IN3) = K
      GO TO 420
  490 IX(IN3) = IX(IN3-1)
      KK = KK + 1
      GO TO 460
  500 CONTINUE
C
C     TEST FOR POSSIBLE MERGING BETWEEN AN INACTIVE-ACTIVE COLUMN AND
C     THE CURRENT PIVOTAL COLUMN
C
      IF (CCOUNT .EQ. 0) GO TO 600
      IN1 = IX(I7SP) + I3SP
      IF (IX(IN1)-JPOS) 1710,510,600
C
C     MERGE ACTIVE COLUMN AND CURRENT PIVOTAL COLUMN AND ZERO THAT
C     ACTIVE COLUMN IN AREA III
C
  510 IX(IN1) = 0
      IN1     = IN1 + C
      IX(IN1) = 0
      IN1     = I3 + IX(I7SP)*BBAR1*2
      CCOUNT  = CCOUNT - 1
      KK  = 0
  520 IN2 = IN1 + KK + KK
      IN3 = I2  + KK + KK
      DX(IN3  ) = DX(IN3  ) + DX(IN2  )
      DX(IN3+1) = DX(IN3+1) + DX(IN2+1)
      DX(IN2  ) = 0.D0
      DX(IN2+1) = 0.D0
      KK = KK + 1
      IF (KK-BBAR1) 520,530,1710
C
C     MERGE INTERACTION ELEMENTS
C
  530 CONTINUE
      IF (CBCNT .EQ. 0) GO TO 580
      IN1 = I5 + 2*IX(I7SP)*CBAR
      K   = 0
  540 IN2 = I4SP + K
      IF (IX(IN2) .EQ. 0) GO TO 560
      IN3 = IN1 + 2*K
      IF (DABS(DX(IN3)).LT.EPSI .AND. DABS(DX(IN3+1)).LT.EPSI)
     1    GO TO 560
      IF (IX(IN2) .GT. JPOS+BBAR) GO TO 570
C
C     STORE ELEMENT WITHIN THE LOWER BAND
C
      IN2 = I2 + 2*(IX(IN2)-IOFF)
      DX(IN2  ) = DX(IN2  ) - DX(IN3  )
      DX(IN2+1) = DX(IN2+1) - DX(IN3+1)
  550 DX(IN3  ) = 0.D0
      DX(IN3+1) = 0.D0
  560 K = K + 1
      IF (K-CBAR) 540,580,1710
C
C     STORE ELEMENT IN THE ACTIVE ROW
C
  570 IN2 = I4 + 2*(K+1)*BBBAR - 2
      DX(IN2+1) = DX(IN2+1) - DX(IN3+1)
      DX(IN3+1) = 0.D0
      DX(IN2  ) = DX(IN2) - DX(IN3)
      DX(IN3  ) = 0.D0
      GO TO 550
C
C     MOVE THE POINTERS IN AREA VII UP ONE
C
  580 IN1 = I7SP + CCOUNT - 1
      DO 590 I = I7SP,IN1
  590 IX(I) = IX(I+1)
      IX(IN1+1) = 0
  600 IF (LCOL .EQ. 0) GO TO 830
C
C     ****************************************************************
C     OPERATE ON THE CURRENT COLUMN OF A BY ALL PREVIOUS COLUMNS OF L,
C     MAKING NOTED INTERCHANGES AS YOU GO
C     ****************************************************************
C
      IF (SCRFLG .EQ. 0) GO TO 630
      IF (LCOL-(R-1)) 630,620,610
  610 PARM(2) = SR2FL
      CALL OPEN (*1680,SR2FL,IX(SR2BUF),RD)
  620 PARM(2) = SR3FL
      CALL OPEN (*1680,SR3FL,IX(SR3BUF),WRTREW)
  630 LL   = 0
      LLL  = 0
      LLLL = 0
C
C     PICK UP INTERCHANGE INDEX FOR COLUMN JPOSL + LL + 1
C
  640 IN1 = I1SP + LL
      INTCHN = IX(IN1)
      IN2 = I2 + LL + LL
      IF (INTCHN .EQ. 0) GO TO 650
C
C     PERFORM ROW INTERCHANGE
C
      IN1 = IN2 + 2*INTCHN
      DA(  1) = DX(IN1)
      DX(IN1) = DX(IN2)
      DX(IN2) = DA(1)
      DA(1  ) = DX(IN1+1)
      DX(IN1+1) = DX(IN2+1)
      DX(IN2+1) = DA(1)
  650 CONTINUE
C
C     COMPUTE THE CONTRIBUTION FROM THAT COLUMN
C
      END = MIN0(BBAR1,NCOL-(JPOSL+LL))
      IF (DABS(DX(IN2)).LT.EPSI .AND. DABS(DX(IN2+1)).LT.EPSI)
     1    GO TO 720
      IN1 = I1 + 2*LLL*BBAR
      CALL CLOOP (DX(IN2+2),DX(IN1),DX(IN2),END-1)
      IF (CBCNT .EQ. 0) GO TO 720
C
C     TEST TO SEE IF AN INACTIVE-ACTIVE ROW CONTRIBUTION SHOULD BE
C     ADDED IN
C
      KKK = 0
  690 IN3 = I6SP + KKK
      IN1 = IX(IN3) + I4SP
      IF (IX(IN1) .GT. JPOS+BBAR) GO TO 720
      KK  = IN1 + CBAR
      IF (IX(KK) .GT. JPOSL+LL+1) GO TO 710
      IF (IX(IN1)-JPOSL-BBAR1 .LE. LL) GO TO 710
C
C     ADD IN EFFECT OF THE INACTIVE-ACTIVE ROW
C
      IN4 = I2 + 2*(IX(IN1)-IOFF)
      K   = I4 + 2*(JPOSL+BBBAR - JPOS+LL + IX(IN3)*BBBAR)
      DX1 = DX(K  )
      DX2 = DX(K+1)
      IF (DABS(DX1) .LT. EPSI) DX1 = 0.0D0
      IF (DABS(DX2) .LT. EPSI) DX2 = 0.0D0
      DX(IN4  ) = DX(IN4  ) - DX1*DX(IN2) + DX2*DX(IN2+1)
      DX(IN4+1) = DX(IN4+1) - DX(IN2+1)*DX1 - DX(IN2)*DX2
      IF (DABS(DX(IN4  )) .LT. EPSI) DX(IN4  ) = 0.0D0
      IF (DABS(DX(IN4+1)) .LT. EPSI) DX(IN4+1) = 0.0D0
  710 KKK = KKK + 1
      IF (KKK .LT. CBCNT) GO TO 690
  720 LL  = LL  + 1
      LLL = LLL + 1
      IF (LL .EQ. LCOL) GO TO 780
      IF (LL-R+1) 640,730,760
  730 IF (R .EQ. BBBAR1) GO TO 640
      IN1  = I1  + 2*LL*BBAR
  750 ICRQ = IN1 + BBAR*4 - 1 - SR3BUF
      IF (ICRQ .GT. 0) GO TO 1715
      IBBAR4 = BBAR*4
      CALL READ (*1690,*1700,SR2FL,DX(IN1),IBBAR4,0,FLAG)
      GO TO 640
  760 IN1 = I1 + (LLL-1)*BBAR *2
      IF (LL.EQ.R .AND. LCOL.EQ.BBBAR1) GO TO 770
      CALL WRITE (SR3FL,DX(IN1),4*BBAR,0)
  770 LLL = LLL - 1
      GO TO 750
  780 CONTINUE
C
C     COMPUTE ELEMENTS FOR THE ACTIVE ROWS
C
      IF (CBCNT .EQ. 0) GO TO 830
      K   = 0
  790 IN1 = I4SP + K
      IF (IX(IN1) .GT. JPOS+BBAR) GO TO 810
  800 K   = K + 1
      IF (K-CBAR) 790,830,1710
  810 IN1 = IN1 + CBAR
      IF (IX(IN1) .EQ. JPOS) GO TO 800
      KKK = MAX0(0,BBBAR-JPOS+IX(IN1)-1)
      IN2 = I4  + 2*K*BBBAR - 2
      IN3 = I2  + 2*(KKK-1-MAX0(0,BBBAR-JPOS))
      IN1 = IN2 + 2*BBBAR
      IN2 = IN2 + 2*KKK
  820 IN2 = IN2 + 2
      KKK = KKK + 1
      IN3 = IN3 + 2
      DX(IN1  ) = DX(IN1  ) - DX(IN2)*DX(IN3) + DX(IN2+1)*DX(IN3+1)
      DX(IN1+1) = DX(IN1+1) - DX(IN2+1)*DX(IN3) - DX(IN2)*DX(IN3+1)
      IF (DABS(DX(IN1  )) .LT. EPSI) DX(IN1  ) = 0.0D0
      IF (DABS(DX(IN1+1)) .LT. EPSI) DX(IN1+1) = 0.0D0
      IF (KKK-BBBAR1) 820,800,1710
C
C     SEARCH THE LOWER BAND FOR THE MAXIMUM ELEMENT AND INTERCHANGE
C     ROWS TO BRING IT TO THE DIAGONAL
C
  830 K   = 1
      IN1 = I2 + (JPOS-IOFF)*2
      DX1 = 0.D0
      DX2 = 0.D0
      IF (DABS(DX(IN1  )) .GT. EPSI)  DX1 = DX(IN1  )**2
      IF (DABS(DX(IN1+1)) .GT. EPSI)  DX2 = DX(IN1+1)**2
      MAX(1) = DX1 + DX2
      INTCHN = 0
      END = MIN0(BBAR1,NCOL-JPOS+1)
      IF (END .EQ. 1) GO TO 870
  840 IN2 = IN1 + K + K
      DX1 = 0.D0
      DX2 = 0.D0
      IF (DABS(DX(IN2  )) .GT. EPSI)  DX1 = DX(IN2  )**2
      IF (DABS(DX(IN2+1)) .GT. EPSI)  DX2 = DX(IN2+1)**2
      DX2 = DX2 + DX1
      IF (DX2 .GT. MAX(1)) GO TO 860
  850 K   = K + 1
      IF (K-END) 840,870,1710
  860 MAX(1) = DX2
      INTCHN = K
      GO TO 850
C
  870 IF (INTCHN .EQ. 0) GO TO 880
C
C     INTERCHANGE ROWS IN AREA II
C
      DET(1) = -DET(1)
      DET(2) = -DET(2)
C
      MAX(1) = DX(IN1)
      IN2    = IN1 + 2*INTCHN
      DX(IN1) = DX(IN2)
      DX(IN2) = MAX(1)
      MAX(1)  = DX(IN1+1)
      DX(IN1+1) = DX(IN2+1)
      DX(IN2+1) = MAX(1)
C
C     STORE THE PERMUTATION INDEX
C
      IN2 = I1SP + LCOL
      IX(IN2) = INTCHN
C
C     DIVIDE THE LOWER BAND BY THE DIAGONAL ELEMENT
C
  880 DX1 = 0.D0
      DX2 = 0.D0
      IF (DABS(DX(IN1  )) .GT. EPSI)  DX1 = DX(IN1  )**2
      IF (DABS(DX(IN1+1)) .GT. EPSI)  DX2 = DX(IN1+1)**2
      DA(1) = DX1 + DX2
      IF (DABS(DA(1)) .LT. EPSI) GO TO 1720
      MAX(1) = DX(IN1  )/DA(1)
      MAX(2) =-DX(IN1+1)/DA(1)
      MINDIA = DMIN1(DSQRT(DA(1)),MINDIA)
      DA(1)  = DMAX1(DABS(DET(1)),DABS(DET(2)))
  890 IF (DA(1) .LE. 10.D0) GO TO 900
      DET(1) = DET(1)*.1D0
      DET(2) = DET(2)*.1D0
      DA(1)  = DA(1) *.1D0
      POWER  = POWER + 1
      GO TO 890
  900 IF (DA(1).GE. .1D0) GO TO 910
      DET(1) = DET(1)*10.D0
      DET(2) = DET(2)*10.D0
      DA(1)  = DA(1) *10.D0
      POWER  = POWER - 1
      GO TO 900
  910 DA(1)  = DET(1)*DX(IN1) - DET(2)*DX(IN1+1)
      DET(2) = DET(2)*DX(IN1) + DET(1)*DX(IN1+1)
      DET(1) = DA(1)
      K   = 1
      END = MIN0(BBAR1,NCOL-JPOS+1)
      IF (END .EQ. 1) GO TO 930
  920 IN2 = IN1 + K + K
      DA(1) = DX(IN2)*MAX(1) - DX(IN2+1)*MAX(2)
      DX(IN2+1) = DX(IN2)*MAX(2) + DX(IN2+1)*MAX(1)
      DX(IN2  ) = DA(1)
      IF (DABS(DX(IN2  )) .LT. EPSI) DX(IN2  ) = 0.0D0
      IF (DABS(DX(IN2+1)) .LT. EPSI) DX(IN2+1) = 0.0D0
      K = K + 1
      IF (K-END) 920,930,1710
  930 IF (CBCNT .EQ. 0) GO TO 950
C
C     DIVIDE THE ACTIVE ROWS BY THE DIAGONAL
C
      K   = 0
      IN1 = I4 + 2*BBBAR1
  940 DA(    1) = DX(IN1)*MAX(1) - DX(IN1+1)*MAX(2)
      DX(IN1+1) = DX(IN1)*MAX(2) + DX(IN1+1)*MAX(1)
      DX(IN1  ) = DA(1)
      IF (DABS(DX(IN1  )) .LT. EPSI) DX(IN1  ) = 0.0D0
      IF (DABS(DX(IN1+1)) .LT. EPSI) DX(IN1+1) = 0.0D0
      IN1 = IN1 + 2*BBBAR
      K   = K + 1
      IF (K-CBAR) 940,950,1710
  950 CONTINUE
C
C     INTERCHANGE ACTIVE COLUMNS AND ADD IN EFFECT OF THE CURRENT COLUMN
C
      IF (CCOUNT  .EQ.  0) GO TO 1000
      IF (JPOS .LT. BBBAR) GO TO 1000
      INTCH = IX(I1SP)
      K   = 0
  960 IN1 = I3SP + K
      IF (INTCH .EQ. 0) GO TO 970
      IN1 = I3  + 2*K*BBAR1
      IN2 = IN1 + INTCH + INTCH
      DA(  1) = DX(IN1)
      DX(IN1) = DX(IN2)
      DX(IN2) = DA(1)
      DA(1  ) = DX(IN1+1)
      DX(IN1+1) = DX(IN2+1)
      DX(IN2+1) = DA(1)
  970 KK  = 1
      IN2 = I1 - 2
      IN1 = I3 + 2*K*BBAR1
      IF (DABS(DX(IN1)).LT.EPSI .AND. DABS(DX(IN1+1)).LT.EPSI)
     1    GO TO 990
  980 IN3 = IN1 + KK + KK
      IN4 = IN2 + KK + KK
      DX(IN3  ) = DX(IN3  ) - DX(IN1)*DX(IN4) + DX(IN1+1)*DX(IN4+1)
      DX(IN3+1) = DX(IN3+1) - DX(IN1)*DX(IN4+1) - DX(IN1+1)*DX(IN4)
      IF (DABS(DX(IN3  )) .LT. EPSI) DX(IN3  ) = 0.0D0
      IF (DABS(DX(IN3+1)) .LT. EPSI) DX(IN3+1) = 0.0D0
      KK = KK + 1
      IF (KK-BBAR1) 980,990,1710
  990 K  = K + 1
      IF (K-C) 960,1000,1710
C
C     WRITE OUT THE NEXT COLUMN OF U AND THE ROW OF ACTIVE ELEMENTS
C
 1000 PARM(2) = SR2FIL
      CALL BLDPK (CDP,TYPEL,SR2FIL,0,0)
      IN1 = I2
      JJ  = IOFF
 1010 DZ(1) = DX(IN1  )
      DZ(2) = DX(IN1+1)
      IF (DABS(DZ(1)).LT.EPSI .AND. DABS(DZ(2)).LT.EPSI) GO TO 1030
      CALL ZBLPKI
 1030 IN1 = IN1 + 2
      JJ  = JJ  + 1
      IF (JJ-JPOS) 1010,1010,1040
 1040 IF (DABS(DX(IN1-2)).LT.EPSI .AND. DABS(DX(IN1-1)).LT.EPSI)
     1    GO TO 1720
C
C     PACK ACTIVE COLUMN ELEMENTS ALSO
C
      IF (CCOUNT .EQ.   0) GO TO 1090
      IF (JPOS .LT. BBBAR) GO TO 1090
      K   = 0
 1060 IN1 = I7SP + K
      IN2 = IX(IN1) + I3SP
      GO TO 1080
 1070 K   = K + 1
      IF (K-CCOUNT) 1060,1090,1710
 1080 IN3 = I3 + 2*(IX(IN1)*BBAR1)
      DZ(1) = DX(IN3  )
      DZ(2) = DX(IN3+1)
      IF (DABS(DZ(1)).LT.EPSI .AND. DABS(DZ(2)).LT.EPSI) GO TO 1070
      JJ  = IX(IN2)
      CALL ZBLPKI
      GO TO 1070
 1090 CALL BLDPKN (SR2FIL,0,FILEU)
C
C     COMPUTE ACTIVE ROW-COLUMN INTERACTION
C
      IF (CCOUNT.EQ.0 .OR. CBCNT.EQ.0) GO TO 1140
      IF (JPOS .LT. BBBAR) GO TO 1140
      K   = 0
 1100 CONTINUE
      IN1 = I3 + 2*K*BBAR1
      IF (DABS(DX(IN1)).LT.EPSI .AND. DABS(DX(IN1+1)).LT.EPSI)
     1    GO TO 1130
      KK  = 0
 1110 IN2 = I4 + 2*KK*BBBAR
      IF (DABS(DX(IN2)).LT.EPSI .AND. DABS(DX(IN2+1)).LT.EPSI)
     1    GO TO 1120
      IN3 = I5 + 2*(K*CBAR+KK)
      DX(IN3  ) = DX(IN3  ) + DX(IN2)*DX(IN1) - DX(IN2+1)*DX(IN1+1)
      DX(IN3+1) = DX(IN3+1) + DX(IN2)*DX(IN1+1) + DX(IN2+1)*DX(IN1)
      IF (DABS(DX(IN3  )) .LT. EPSI) DX(IN3  ) = 0.0D0
      IF (DABS(DX(IN3+1)) .LT. EPSI) DX(IN3+1) = 0.0D0
 1120 KK = KK + 1
      IF (KK-CBAR) 1110,1130,1710
 1130 K = K + 1
      IF (K-C) 1100,1140,1710
C
C     MOVE ELEMENTS IN AREA III UP ONE CELL
C
 1140 IF (CCOUNT .EQ.   0) GO TO 1190
      IF (JPOS .LT. BBBAR) GO TO 1190
      K   = 0
 1150 IN1 = I3SP + K
      IF (IX(IN1) .EQ. 0) GO TO 1180
      KK  = 0
      IN1 = I3  + 2*K*BBAR1
 1160 IN2 = IN1 + KK + KK
      DX(IN2  ) = DX(IN2+2)
      DX(IN2+1) = DX(IN2+3)
      KK  = KK + 1
      IF (KK-BBAR) 1160,1170,1710
 1170 DX(IN2+2) = 0.D0
      DX(IN2+3) = 0.D0
 1180 K   = K + 1
      IF (K-C) 1150,1190,1710
C
C
C     DETERMINE IF A COLUMN OF L CAN BE WRITTEN OUT
C
 1190 IF (LCOL-BBBAR1) 1370,1200,1200
C
C     OUTPUT A COLUMN OF L
C
 1200 PARM(2) = FILEL(1)
      JPOSL   = JPOSL + 1
      CALL BLDPK (CDP,TYPEL,FILEL(1),0,0)
C
C     STORE THE PERMUTATION INDEX AS THE DIAGONAL ELEMENT
C
      JJ    = JPOSL
      DZ(1) = IX(I1SP)
      DZ(2) = 0.D0
      CALL ZBLPKI
      K     = 0
 1210 JJ    = JPOSL + K   + 1
      IN2   = I1 + K + K
      DZ(1) = DX(IN2  )
      DZ(2) = DX(IN2+1)
      IF (DABS(DZ(1)).LT.EPSI .AND. DABS(DZ(2)).LT.EPSI) GO TO 1230
      CALL ZBLPKI
 1230 K = K + 1
      IF (K-BBAR) 1210,1240,1710
C
C     PACK ACTIVE ROW ELEMENTS ALSO
C
 1240 IF (CBCNT .EQ. 0) GO TO 1280
      K   = 0
 1250 IN1 = I6SP + K
      IN2 = I4 + (IX(IN1)*BBBAR)*2
      IN1 = IX(IN1) + I4SP
      JJ  = IX(IN1)
      DZ(1) = DX(IN2  )
      DZ(2) = DX(IN2+1)
      IF (DABS(DZ(1)).LT.EPSI .AND. DABS(DZ(2)).LT.EPSI) GO TO 1270
      CALL ZBLPKI
 1270 K = K + 1
      IF (K-CBCNT) 1250,1280,1710
 1280 CALL BLDPKN (FILEL,0,FILEL)
C
C     MOVE PERMUTATION INDICES OVER ONE ELEMENT
C
      END = I1SP + LCOL
      DO 1290 I = I1SP,END
 1290 IX(I) = IX(I+1)
C
C     MOVE ELEMENTS IN AREA I OVER ONE COLUMN
C
      K = 0
      IF (SCRFLG .EQ. 0) GO TO 1310
      CALL CLOSE (SR2FL,REW)
      CALL OPEN  (*1680,SR2FL,IX(SR2BUF),RD)
      IF (R .GT. 2) GO TO 1310
      ICRQ = I1 + BBAR*4 - 1 - SR3BUF
      IF (ICRQ .GT. 0) GO TO 1715
      IBBAR4 = BBAR*4
      CALL READ (*1690,*1700,SR2FL,DX(I1),IBBAR4,0,FLAG)
      GO TO 1360
 1310 IN1 = I1  + K*BBAR*2
      IN2 = IN1 + BBAR+BBAR
      CALL CXLOOP (DX(IN1),DX(IN2),BBAR)
      K   = K + 1
      IF (K-R+2) 1310,1340,1360
 1340 IF (R-BBBAR1) 1350,1310,1710
 1350 ICRQ = IN2 + BBAR*4 - 1 - SR3BUF
      IF (ICRQ .GT. 0) GO TO 1715
      IBBAR4 = BBAR*4
      CALL READ (*1690,*1700,SR2FL,DX(IN2),IBBAR4,0,FLAG)
 1360 LCOL = LCOL - 1
C
C     STORE CURRENT COLUMN OF L
C
 1370 IF (CBCNT .EQ. 0) GO TO 1420
C
C     MOVE ELEMENTS IN AREA IV UP ONE CELL
C
      K   = 0
 1380 IN1 = I4SP + K
      IF (IX(IN1) .EQ. 0) GO TO 1410
      KK  = 0
      IN1 = I4 + 2*K*BBBAR
 1390 IN2 = IN1 + KK+KK
      DX(IN2  ) = DX(IN2+2)
      DX(IN2+1) = DX(IN2+3)
      KK  = KK + 1
      IF (KK-BBBAR1) 1390,1400,1710
 1400 DX(IN2+2) = 0.D0
      DX(IN2+3) = 0.D0
 1410 K   = K + 1
      IF (K-CBAR) 1380,1420,1710
 1420 IF (SCRFLG .NE. 0) GO TO 1450
C
C     STORE COLUMN IN CORE
C
 1430 IN1 = I1 + 2*LCOL*BBAR
      END = MIN0(BBAR,NCOL-JPOS)
      IF (END .EQ. 0) GO TO 1480
      K   = 0
      IN3 = I2 + 2*(JPOS-IOFF+1)
 1440 IN2 = IN1 + K + K
      IN4 = IN3 + K + K
      DX(IN2  ) = DX(IN4  )
      DX(IN2+1) = DX(IN4+1)
      K   = K + 1
      IF (K-END) 1440,1480,1710
C
C     STORE COLUMN ON THE SCRATCH FILE
C
 1450 IF (LCOL-R+1) 1430,1470,1460
 1460 IN1 = I1 + (LLL-1)*BBAR*2
      CALL WRITE (SR3FL,DX(IN1),BBAR*4,0)
 1470 IN1 = I2 + 2*(JPOS-IOFF+1)
      CALL WRITE (SR3FL,DX(IN1),BBAR*4,0)
C
C     CLOSE SCRATCH FILES AND SWITCH THE POINTERS TO THEM
C
      CALL CLOSE (SR3FL,REW)
      CALL CLOSE (SR2FL,REW)
      IN1   = SR2FL
      SR2FL = SR3FL
      SR3FL = IN1
 1480 LCOL  = LCOL + 1
      IF (C .EQ. 0) GO TO 1570
      IF (JPOS .LT . BBBAR) GO TO 1570
C
C     READ IN THE NEXT ROW OF ACTIVE COLUMN ELEMENTS
C
      COUNT = CCOUNT
      IF (ITRN .LT. 0) GO TO 1570
 1490 IF (ITRN .GT. JPOS-B+2) GO TO 1560
C
C     TEST TO SEE IF COLUMN IS ALREADY ACTIVE
C
      K   = 0
 1500 IN1 = I3SP + K
      IF (IX(IN1) .EQ. JTRN) GO TO 1540
      K   = K + 1
      IF (K-C) 1500,1510,1710
C
C     CREATE A NEW ACTIVE COLUMN
C
 1510 K   = 0
 1520 IN1 = I3SP + K
      IF (IX(IN1) .EQ. 0) GO TO 1530
      K   = K + 1
      IF (K-C) 1520,1710,1710
 1530 IX(IN1) = JTRN
      IN1 = IN1 + C
      IX(IN1) = ITRN
      IN1 = I3 + 2*(K+1)*BBAR1 - 2
      DX(IN1  ) = DTRN(1)
      DX(IN1+1) = DTRN(2)
      IF (DABS(DX(IN1  )) .LT. EPSI) DX(IN1  ) = 0.0D0
      IF (DABS(DX(IN1+1)) .LT. EPSI) DX(IN1+1) = 0.0D0
      CCOUNT = CCOUNT + 1
      GO TO 1550
C
C     STORE ELEMENT IN EXISTING COLUMN
C
 1540 IN1 = I3 + 2*(K+1)*BBAR1 - 2
      DX(IN1  ) = DX(IN1  ) + DTRN(1)
      DX(IN1+1) = DX(IN1+1) + DTRN(2)
 1550 CALL READ (*1690,*1700,SR1FIL,ITRAN(1),6,0,FLAG)
      IF (ITRN .GT. 0) GO TO 1490
      CALL CLOSE (SR1FIL,REW)
 1560 IF (CCOUNT .EQ. COUNT) GO TO 1570
C
C     RE-ARRANGE INDEXES IN SEQUENTIAL ORDER
C
      ASSIGN 1570 TO KK
      GO TO 150
 1570 CONTINUE
      JPOS = JPOS + 1
C
C     ZERO AREA II
C
      END = I2 + 2*MIN0(JPOS-IOFF+BBAR-1,NCOL-1) + 1
      DO 1590 I = I2,END
 1590 DX(I) = 0.D0
C
C      TEST TO SEE IF ROW INTERACTION ELEMENTS WILL MERGE INTO AREA III
C
      IF (CBCNT  .EQ. 0) GO TO 270
      IF (CCOUNT .EQ. 0) GO TO 1640
      IF (JPOS-1 .LT. BBBAR) GO TO 270
      IN1 = I4SP
      K   = 0
 1600 IN2 = IN1 + K
      IF (IX(IN2) .EQ. JPOS-B+1) GO TO 1610
      K   = K + 1
      IF (K .LT. CBAR) GO TO 1600
      GO TO 270
 1610 IN1 = I5 + K + K
      IN2 = I3 + BBAR + BBAR
      K   = 0
 1620 DX(IN2  ) = DX(IN2  ) - DX(IN1  )
      DX(IN2+1) = DX(IN2+1) - DX(IN1+1)
      DX(IN1  ) = 0.D0
      DX(IN1+1) = 0.D0
      IN2 = IN2 + BBAR1 + BBAR1
      IN1 = IN1 + CBAR  + CBAR
      K   = K + 1
      IF (K .LT. C) GO TO 1620
C
C     TEST TO SEE IF A ACTIVE ROW HAS BEEN ELIMINATED
C
 1640 IN1 = IX(I6SP) + I4SP
      IF (IX(IN1)-JPOSL-BBAR1) 270,1650,270
C
C     ELIMINATE THE ACTIVE ROW
C
 1650 IX(IN1) = 0
      IN1     = IN1 + CBAR
      IX(IN1) = 0
      CBCNT   = CBCNT - 1
C
C     MOVE INDEXES IN AREA VI UP ONE
C
      IN1 = I6SP + CBCNT - 1
      DO 1660 I = I6SP,IN1
 1660 IX(I) = IX(I+1)
      IX(IN1+1) = 0
      GO TO 270
C
C     FINISH WRITING OUT THE COMPLETED COLUMNS OF L
C
 1670 CALL CLOSE (SR1FIL,REW)
      CALL CLOSE (FILEL,NOREW)
      CALL CLOSE (SR2FIL,NOREW)
      CALL COMFIN (ITERM,SCRFLG,SR2FL,JPOSL,I1SP,BBAR,I1,CBCNT,IPAK,R,
     1             BBBAR1,BBBAR,I6SP,I4,I4SP,IX,DX,X,LCOL)
      PARM(5) = IEND
      CALL CONMSG (PARM(3),3,0)
      FILEU(7) = BBBAR
      RETURN
C
C     ERROR EXITS
C
 1680 PARM(1) = -1
      GO TO 1730
 1690 PARM(1) = -2
      GO TO 1730
 1700 PARM(1) = -3
      GO TO 1730
 1710 PARM(1) = -25
      GO TO 1730
 1715 PARM(1) = -8
      PARM(2) = ICRQ
      GO TO 1730
C
C     SINGULAR MATRIX - CLOSE ALL FILES AND RETURN TO USER
C
 1720 CALL CLOSE (FILEA(1),REW)
      CALL CLOSE (FILEL(1),REW)
      CALL CLOSE (FILEU(1),REW)
      CALL CLOSE (SR1FIL,REW)
      CALL CLOSE (SR2FIL,REW)
      CALL CLOSE (SR3FIL,REW)
      FILEU(2) = BBBAR
      RETURN 1
C
 1730 CALL MESAGE (PARM(1),PARM(2),PARM(3))
      RETURN
      END

      SUBROUTINE CMCASE
C
C     THIS SUBROUTINE PROCESSES THE CASE CONTROL DATA BLOCK
C
      EXTERNAL        ORF
      LOGICAL         IAUTO,TRAN,CONECT,LF(3),LONLY,SRCH
      INTEGER         CASECC,BUF2,STEP,Z,CNAM,RESTCT,COMBO,OUTT,AUTO,
     1                ORF,NCNAM(2),IHD(96),IBITS(32),CONSET,MNEM(11),
     2                SNAM(7,2),IDIR(3),COMP(7,2),SYMT(7),TRANS(7),
     3                ISYM(15,2),AAA(2),PORA,PAPP
      DIMENSION       AZ(1)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /CMB001/ JUNK(8),CASECC
      COMMON /CMB002/ BUF1,BUF2,JUNK1(6),OUTT
      COMMON /CMB003/ COMBO(7,5),CONSET,IAUTO,TOLER,NPSUB,CONECT,TRAN,
     1                MCON,RESTCT(7,7),ISORT,ORIGIN(7,3),IPRINT
      COMMON /CMB004/ TDAT(6),NIPNEW,CNAM(2),LONLY
      COMMON /ZZZZZZ/ Z(1)
      COMMON /OUTPUT/ ITITL(96),IHEAD(96)
      COMMON /SYSTEM/ XXX,IOT,MUNK(6),NLPP,JUNK3(2),LINE,JUNK2(2),
     1                IDAT(3)
      COMMON /BLANK / STEP,IDRY,PORA
      EQUIVALENCE     (Z(1),AZ(1))
      DATA    NMNEM / 11 /, IDIR/ 1HX, 1HY, 1HZ /,  AUTO/ 4HAUTO / ,
     1        AAA   / 4HCMCA, 4HSE   /
      DATA    MNEM  / 4HOPTS, 4HSORT, 4HNAMC, 4HNAMS, 4HTOLE, 4HCONN,
     1                4HCOMP, 4HTRAN, 4HSYMT, 4HSEAR, 4HOUTP/
      DATA    ISYM  / 4,2,1,6,6,5,5,3,3,6*7,1HX,1HY,1HZ,2HXY,2HYX,2HXZ,
     1                2HZX,2HYZ,2HZY,3HXYZ,3HXZY,3HYXZ,3HYZX,3HZXY,
     2                3HZYX /
      DATA    IHD   / 74*4H    , 4H SUM , 4HMARY , 4H OF  , 4HCASE ,
     1                4H CON ,   4HTROL , 4H FOR , 4H COM , 4HBINE ,
     2                4H OPE ,   4HRATI , 4HON   , 10*4H           /
      DATA    NHEQSS/ 4HEQSS /
      DATA    PAPP  , LOAP,LODS/ 4HPAPP , 4HLOAP , 4HLODS /
C
C     OPEN CASECC DATA BLOCK AND READ INTO OPEN CORE
C
      SRCH = .FALSE.
      IERR = 0
      DO 10 I = 1,96
      IHEAD(I) = IHD(I)
   10 CONTINUE
      IFILE = CASECC
      CALL OPEN (*580,CASECC,Z(BUF2),0)
      NREC = STEP
      IF (NREC .EQ. 0) GO TO 30
      DO 20 I = 1,NREC
      CALL FWDREC (*580,CASECC)
   20 CONTINUE
   30 CALL READ (*570,*590,CASECC,Z(1),5,0,NNN)
      I = 2
      NWDSCC = Z(I  )
      NPSUB  = Z(I+1)
      CALL READ (*570,*40,CASECC,Z(1),NWDSCC,1,NNN)
   40 JJ = 0
      KK = 0
      IPRINT = 0
C
C     INITIALIZE COMBO AND RESTCT ARRAYS
C
      DO 70 I = 1,7
      DO 50 J = 1,5
      COMBO(I,J) = 0
   50 CONTINUE
      DO 60 J = 1,7
      RESTCT(I,J) = 0
   60 CONTINUE
   70 CONTINUE
C
C     INITIALIZE COMP,TRANS,AND SYMT ARRAYS
C
      CONECT = .FALSE.
      TRAN   = .FALSE.
      DO 90 I = 1,7
      SYMT(I) = 0
      TRANS(I)= 0
      DO 80 J = 1,2
      COMP(I,J) = 0
   80 CONTINUE
   90 CONTINUE
      DO 100 I = 1,3
      LF(I) = .FALSE.
  100 CONTINUE
      CNAM(1) = 0
      CNAM(2) = 0
C
C     PROCESS CASE CONTROL MNEMONICS
C
      DO 350 I = 1,NWDSCC,3
      DO 110 J = 1,NMNEM
      IF (Z(I) .NE. MNEM(J)) GO TO 110
      GO TO (120,130,160,170,180,190,200,220,230,260,290), J
  110 CONTINUE
      GO TO 350
  120 IAUTO = .FALSE.
      IF (Z(I+1) .EQ. AUTO) IAUTO = .TRUE.
      GO TO 350
C
  130 DO 140 L = 1,3
      IF (Z(I+1) .EQ. IDIR(L)) GO TO 150
  140 CONTINUE
      ISORT = 1
      GO TO 350
  150 ISORT = L
      GO TO 350
C
  160 IF (LF(1)) GO TO 300
      LF(1)   = .TRUE.
      CNAM(1) = Z(I+1)
      CNAM(2) = Z(I+2)
      GO TO 350
C
  170 JJ = JJ + 1
      SNAM(JJ,1) = Z(I+1)
      SNAM(JJ,2) = Z(I+2)
      GO TO 350
C
  180 IF (LF(2)) GO TO 300
      LF(2) = .TRUE.
      TOLER = AZ(I+2)
      GO TO 350
C
  190 IF (LF(3)) GO TO 300
      LF(3)  = .TRUE.
      CONSET = Z(I+2)
      CONECT = .TRUE.
      GO TO 350
C
  200 KK = KK + 1
      COMP(KK,1) = Z(I+1)
      COMP(KK,2) = Z(I+2)
      DO 210 LINDX = 1,NPSUB
      IF (Z(I+1).EQ.SNAM(LINDX,1) .AND. Z(I+2).EQ.SNAM(LINDX,2))
     1   GO TO 350
  210 CONTINUE
      WRITE (OUTT,630) UFM,Z(I+1),Z(I+2)
      IERR = 1
      GO TO 350
C
  220 TRANS(KK) = Z(I+2)
      TRAN = .TRUE.
      GO TO 350
C
  230 DO 240 L = 1,15
      IF (Z(I+1) .EQ. ISYM(L,2)) GO TO 250
  240 CONTINUE
      IERR = 1
      WRITE (OUTT,620) UFM,Z(I+1),COMP(KK,1),COMP(KK,2)
      GO TO 350
  250 SYMT(KK) = ISYM(L,1)
      GO TO 350
C
  260 DO 270 L = 1,NPSUB
      IF (Z(I+1).EQ.SNAM(L,1) .AND. Z(I+2).EQ.SNAM(L,2)) GO TO 280
  270 CONTINUE
      WRITE (OUTT,630) UFM,Z(I+1),Z(I+2)
      IERR = 1
      GO TO 350
  280 SRCH = .TRUE.
      RESTCT(LINDX,L) = 1
      RESTCT(L,LINDX) = 1
      GO TO 350
C
  290 IPRINT = ORF(IPRINT,Z(I+2))
      GO TO 350
C
  300 GO TO (350,350,310,350,320,330) , J
  310 WRITE (OUTT,740) UFM
      GO TO 340
  320 WRITE (OUTT,750) UFM
      GO TO 340
  330 WRITE (OUTT,760) UFM
  340 IERR = 1
  350 CONTINUE
C
C     IF NO SEARCH OPTIONS SPECIFIED - SEARCH ALL POSSIBLE CONNECTIONS
C
      IF (SRCH) GO TO 370
      DO 360 I = 1,7
      DO 360 J = 1,7
  360 RESTCT(I,J) = 1
  370 CONTINUE
      DO 400 I = 1,NPSUB
      DO 380 J = 1,NPSUB
      IF (SNAM(I,1).EQ.COMP(J,1) .AND. SNAM(I,2).EQ.COMP(J,2)) GO TO 390
  380 CONTINUE
      COMBO(I,1) = SNAM(I,1)
      COMBO(I,2) = SNAM(I,2)
      COMBO(I,3) = 0
      COMBO(I,4) = 0
      GO TO 400
  390 COMBO(I,1) = SNAM(I,1)
      COMBO(I,2) = SNAM(I,2)
      COMBO(I,3) = TRANS(J)
      COMBO(I,4) = SYMT(J)
  400 CONTINUE
      CALL CLOSE (CASECC,1)
      CALL PAGE
      WRITE (OUTT,690) NPSUB
      IF (IAUTO) WRITE (OUTT,700)
      IF (.NOT. IAUTO) WRITE (OUTT,710)
      IF (.NOT.(IAUTO .OR. CONECT)) GO TO 550
  410 IF (CONECT) WRITE (OUTT,720) CONSET
      IF (CNAM(1).EQ.0 .AND. CNAM(2).EQ.0) GO TO 560
      WRITE (OUTT,640) CNAM
      CALL FDSUB (CNAM,ITEST)
      IF (ITEST .NE. -1) GO TO 500
      IF (PORA .EQ. PAPP) GO TO 540
  420 IF (.NOT.LF(2)) GO TO 530
      WRITE (OUTT,670) TOLER
      CALL DECODE (IPRINT,IBITS,NFLG)
      IF (NFLG .EQ. 0) IBITS(1) = 0
      IF (NFLG .EQ. 0) GO TO 440
      DO 430 I = 1,NFLG
      IBITS(I) = IBITS(I) + 1
  430 CONTINUE
  440 CONTINUE
      WRITE (OUTT,810) (IBITS(KDH),KDH=1,NFLG )
  450 DO 480 I = 1,NPSUB
      WRITE (OUTT,770) I,COMBO(I,1),COMBO(I,2)
      NCNAM(1) = COMBO(I,1)
      NCNAM(2) = COMBO(I,2)
      CALL SFETCH (NCNAM,NHEQSS,3,ITEST)
      IF (ITEST .EQ. 4) WRITE (OUTT,780) UFM,NCNAM
      IF (ITEST .EQ. 4) IDRY = -2
      IF (COMBO(I,3) .NE. 0) WRITE (OUTT,790) COMBO(I,3)
      IF (COMBO(I,4) .EQ. 0) GO TO 480
      DO 460 MJ = 1,15
      IF (COMBO(I,4) .EQ. ISYM(MJ,1)) GO TO 470
  460 CONTINUE
  470 WRITE (OUTT,800) ISYM(MJ,2)
  480 CONTINUE
  490 IF (IERR .EQ. 1) IDRY = -2
      GO TO 610
  500 LITM = LODS
      IF (PORA .EQ. PAPP) LITM = LOAP
      CALL SFETCH (CNAM,LITM,3,ITEST)
      LONLY = .FALSE.
      IF (ITEST .EQ. 3) GO TO 520
      IF (PORA .EQ. PAPP) GO TO 510
      WRITE (OUTT,650) UFM
      IERR = 1
      GO TO 420
C
C     OPTIONS PA YET LOAP ITEM ALREADY EXISTS
C
  510 WRITE (OUTT,820) UFM,CNAM
      IERR = 1
      GO TO 490
C
C     NEW LODS ONLY DEFINED
C
  520 LONLY = .TRUE.
      RETURN
C
  530 WRITE (OUTT,660) UFM
      IERR = 1
      GO TO 450
C
C     OPTIONS PA YET SUBSTRUCTURE DOES NOT EXIST
C
  540 WRITE (OUTT,830) UFM,CNAM
      IERR = 1
      GO TO 490
  550 WRITE (OUTT,680) UFM
      IERR = 1
      GO TO 410
  560 WRITE (OUTT,730) UFM
      IERR = 1
      GO TO 490
  570 IMSG = -2
      GO TO 600
  580 IMSG = -1
      GO TO 600
  590 IMSG = -3
  600 CALL MESAGE (IMSG,IFILE,AAA)
  610 CONTINUE
      RETURN
C
  620 FORMAT (A23,' 6505, THE SYMMETRY OPTION ',A4,
     1       ' CONTAINS AN INVALID SYMBOL.')
  630 FORMAT (A23,' 6506, THE COMPONENT SUBSTRUCTURE ',2A4,
     1       ' IS NOT ONE OF THOSE ON THE COMBINE CARD.')
  640 FORMAT (/10X,38HTHE RESULTANT PSEUDOSTRUCTURE NAME IS ,2A4)
  650 FORMAT (A23,' 6508, THE NAME SPECIFIED FOR THE RESULTANT ',
     1       'PSEUDOSTRUCTURE', /32X,'ALREADY EXISTS ON THE SOF.')
  660 FORMAT (A23,' 6504, A TOLERANCE MUST BE SPECIFIED FOR A COMBINE ',
     1       'OPERATION.')
  670 FORMAT (/10X,32HTHE TOLERANCE ON CONNECTIONS IS ,E15.6)
  680 FORMAT (A23,' 6501, THE MANUAL COMBINE OPTION HAS BEEN SPECIFIED',
     1       ', BUT NO CONNECTION SET WAS GIVEN.')
  690 FORMAT (/10X,'THIS JOB STEP WILL COMBINE ',I1,' PSEUDOSTRUCTURES')
  700 FORMAT (/10X,40HCONNECTIONS ARE GENERATED AUTOMATICALLY. )
  710 FORMAT (/10X,35HCONNECTIONS ARE SPECIFIED MANUALLY. )
  720 FORMAT (/10X,25HTHE CONNECTION SET ID IS ,I8)
  730 FORMAT (A23,' 6502, NO NAME HAS BEEN SPECIFIED FOR THE RESULTANT',
     1       ' COMBINED PSEUDOSTRUCTURE.')
  740 FORMAT (A23,' 6519, REDUNDANT NAMES FOR RESULTANT PSEUDOSTRUCTURE'
     1,      ' HAVE BEEN SPECIFIED.')
  750 FORMAT (A23,' 6520, REDUNDANT VALUES FOR TOLER HAVE BEEN ',
     1       'SPECIFIED.')
  760 FORMAT (A23,' 6512, REDUNDANT CONNECTION SET ID S HAVE BEEN ',
     1       'SPECIFIED.')
  770 FORMAT (/10X, 27HCOMPONENT SUBSTRUCTURE NO. ,I1,8H NAME = ,2A4)
  780 FORMAT (A23,' 6507, THE SUBSTRUCTURE ',2A4,' DOES NOT EXIST ON ',
     1       'THE SOF FILE')
  790 FORMAT (/15X, 15HTRANS SET ID = ,I8)
  800 FORMAT (15X,22HSYMMETRY DIRECTIONS = ,A4)
  810 FORMAT (/10X,30HTHE PRINT CONTROL OPTIONS ARE ,25I3)
  820 FORMAT (A23,' 6533, OPTIONS PA HAS BEEN SPECIFIED BUT THE LOAP ',
     1       'ITEM ALREADY EXISTS FOR SUBSTRUCTURE ',2A4)
  830 FORMAT (A23,' 6534, OPTIONS PA HAS BEEN SPECIFIED BUT THE ',
     1       'SUBSTRUCTURE ',2A4,' DOES NOT EXIST.', /30X,
     2       'YOU CANNOT APPEND SOMETHING TO NOTHING.')
      END

      SUBROUTINE DETFBS (IY,IOBUF,FILEU,NROW,KCOUNT)
C
C     DETFBS IS A SPECIAL VERSION OF THE GFBS ROUTINE AND IS USED BY
C     THE REAL DETERMINANT METHOD.  IT IS SUITABLE FOR BOTH SINGLE
C     AND DOUBLE PRECISION OPERATION.
C
C
C     DEFINITION OF PARAMETERS
C     ------------------------
C
C     FILEU  = MATRIX CONTROL BLOCK FOR THE UPPER TRIANGLE
C     FILEV  = SAME AS FILEU
C     FILEVT = MATRIX CONTROL BLOCK FOR THE TRANSPOSE OF THE UPPER
C              TRIANGLE
C     X, DX  = THE SOLUTION VECTOR
C     Y, DY  = REGION USED FOR UNPACKING
C     IY     = POINTER TO Y (DY) RELATIVE TO X (DX)
C     IOBUF  = THE INPUT BUFFER
C     NROW   = MATRIX SIZE
C     KCOUNT = EIGENVALUE COUNTER
C
      INTEGER          FILEU(7),PARM(4) ,IOBUF(7),OPTION ,SDET ,FILEV ,
     1                 FILEVT  ,SCR3    ,SCR4    ,SCR6   ,SCR
      REAL             X(1)    ,Y(1)
      DOUBLE PRECISION DX(1)   ,DY(1)   ,DXMIN   ,DSDIAG
      COMMON /ZZZZZZ/  CORE(1)
      COMMON /DETMX /  DUM3(36),IPDETA
      COMMON /NAMES /  RD      ,RDREW   ,WRT     ,WRTREW  ,REW
      COMMON /REGEAN/  DUM1(23),SCR3    ,SCR4    ,DUM2(11),SCR6
      COMMON /REIGKR/  OPTION
      COMMON /TRNSPX/  FILEV(7),FILEVT(7),LCORE  ,NCR     ,SCR(2)
      COMMON /UNPAKX/  ITYPEX  , IUNPAK ,JUNPAK  ,INCR
      EQUIVALENCE      (CORE(1),X(1),DX(1),Y(1),DY(1))    ,
     1                 (XMIN,DXMIN) ,   (SDIAG,DSDIAG)
      DATA    SDET  /  4HSDET  /
      DATA    PARM(3), PARM(4) / 4HDETF, 4HBS   /
C
CWKBI SPR 94011 10/94
      IF ( OPTION .NE. SDET ) GO TO 1000
      ITYPEX = FILEU(5)
      INDEX  = -1
      INCR   = 1
      NFILE  = FILEU(1)
      IF (OPTION .EQ. SDET) GO TO 30
      INDEX  = 1
      LCORE  = IPDETA - IY*ITYPEX - 1
      IF (LCORE .LT. 0) CALL MESAGE (-8,0,PARM(3))
      NCR = 2
      SCR(1) = SCR3
      SCR(2) = SCR4
      DO 20 I = 1,7
      FILEV(I)  = FILEU(I)
      FILEVT(I) = FILEU(I)
   20 CONTINUE
   30 FILEVT(1) = SCR6
      NFILE  = FILEVT(1)
      IF (ITYPEX .EQ. 1) CALL TRNSP ( Y(IY))
      IF (ITYPEX .NE. 1) CALL TRNSP (DY(IY))
      IF (ITYPEX .EQ. 1) GO TO 50
      ASSIGN 230 TO ISD
      ASSIGN 260 TO IUS
   40 PARM(2) = NFILE
      CALL GOPEN (NFILE,IOBUF,RDREW)
      GO TO 60
   50 ASSIGN 240 TO ISD
      ASSIGN 270 TO IUS
      GO TO 40
   60 XMIN = 1.0E20
      IF (ITYPEX .NE. 1) DXMIN = 1.0D20
      DO 80 I = 1,NROW
      IUNPAK = 0
      IF (ITYPEX .NE. 1) GO TO 70
      CALL UNPACK (*400,NFILE,X(I))
      IF (XMIN .GT. ABS(X(I))) XMIN = ABS(X(I))
      GO TO 80
   70 CALL UNPACK (*400,NFILE,DX(I))
      IF (DXMIN .GT. DABS(DX(I))) DXMIN = DABS(DX(I))
   80 CONTINUE
      IF (ITYPEX.EQ.1 .AND. XMIN .NE.0.0  ) GO TO 120
      IF (ITYPEX.NE.1 .AND. DXMIN.NE.0.0D0) GO TO 120
      XMIN = 1.0E20
      IF (ITYPEX .NE. 1) DXMIN = 1.0D20
      DO 100 I = 1,NROW
      IF (ITYPEX .NE. 1) GO TO 90
      IF (X(I) .EQ. 0.0) GO TO 100
      IF (XMIN .GT. ABS(X(I))) XMIN = ABS(X(I))
      GO TO 100
   90 IF (DX(I) .EQ. 0.0D0) GO TO 100
      IF (DXMIN .GT. DABS(DX(I))) DXMIN = DABS(DX(I))
  100 CONTINUE
      IF (ITYPEX .NE. 1) GO TO 110
      IF (XMIN .GT. 1.0E-8) XMIN = 1.0E-8
      GO TO 120
  110 IF (DXMIN .GT. 1.0D-8) DXMIN = 1.0D-8
C
C     BUILD LOAD VECTOR FOR BACKWARD PASS
C
  120 SDIAG = 1.0
      IF (ITYPEX .NE. 1) DSDIAG = 1.0D0
      DO 160 I = 1,NROW
      ANUM = (-1)**(I*KCOUNT)
      AI   = I
      ADEN = 1.0 + (1.0 - AI/NROW)*KCOUNT
      AVALUE = ANUM/ADEN
      IF (ITYPEX .NE.    1) GO TO 140
      IF (OPTION .NE. SDET) GO TO 130
      SDIAG = X(I)
      IF (X(I).GE.0.0 .AND. ABS(X(I)).LT.XMIN) SDIAG = XMIN
      IF (X(I).LT.0.0 .AND. ABS(X(I)).LT.XMIN) SDIAG =-XMIN
  130 X(I) = XMIN*AVALUE/SDIAG
      GO TO 160
  140 IF (OPTION .NE. SDET) GO TO 150
      DSDIAG = DX(I)
      IF (DX(I).GE.0.0 .AND. DABS(DX(I)).LT.DXMIN) DSDIAG = DXMIN
      IF (DX(I).LT.0.0 .AND. DABS(DX(I)).LT.DXMIN) DSDIAG =-DXMIN
  150 DX(I) = DXMIN*AVALUE/DSDIAG
  160 CONTINUE
C
C
C     BEGIN BACKWARD PASS
C
      DO 300 I = 1,NROW
      IUNPAK = 0
      J = NROW - I + 1
      CALL BCKREC (NFILE)
      IF (ITYPEX .EQ. 1) CALL UNPACK (*400,NFILE,Y(IY))
      IF (ITYPEX .NE. 1) CALL UNPACK (*400,NFILE,DY(IY))
      CALL BCKREC (NFILE)
      ISING = 0
      K = JUNPAK - IUNPAK + IY
      GO TO ISD, (230,240)
C
C     DIVIDE BY THE DIAGONAL TERM
C
  200 IF (OPTION .EQ. SDET) GO TO 300
      IF (DY(K).GE.0.0D0 .AND. DABS(DY(K)).LT.DXMIN) DY(K) = DXMIN
      IF (DY(K).LT.0.0D0 .AND. DABS(DY(K)).LT.DXMIN) DY(K) =-DXMIN
      DX(J) = DX(J)/DY(K)
      GO TO 300
  210 IF (OPTION .EQ. SDET) GO TO 300
      IF (Y(K).GE.0.0 .AND. ABS(Y(K)).LT.XMIN) Y(K) = XMIN
      IF (Y(K).LT.0.0 .AND. ABS(Y(K)).LT.XMIN) Y(K) =-XMIN
      X(J) = X(J)/Y(K)
      GO TO 300
  220 K = K - 1
      JUNPAK = JUNPAK - 1
      IF (K .LT. IY) GO TO 280
      GO TO ISD, (230,240)
  230 IF (DY(K) .EQ. 0.0D0) GO TO 220
      IF (JUNPAK - J) 280,200,250
  240 IF (Y(K) .EQ. 0.0) GO TO 220
      IF (JUNPAK - J) 280,210,250
  250 GO TO IUS, (260,270)
  260 DX(J) = DX(J) - INDEX*DX(JUNPAK)*DY(K)
      GO TO 220
  270 X(J) = X(J) - INDEX*X(JUNPAK)*Y(K)
      GO TO 220
  280 IF (ISING .EQ. 0) GO TO 400
  300 CONTINUE
C
      IF (OPTION .EQ. SDET) GO TO 340
      IF (ITYPEX .EQ.    1) GO TO 320
      DO 310 I = 1,NROW
      DX(I) = -DX(I)
  310 CONTINUE
      GO TO 340
  320 DO 330 I = 1,NROW
      X(I) = -X(I)
  330 CONTINUE
  340 CALL CLOSE (NFILE,REW)
CWKBI 10/94 SPR94011 
  700 CONTINUE
      RETURN
CWKBNB 10/94 SPR94011
1000  CALL DETGBS( IY, IOBUF, KCOUNT )
      GO TO 700
CWKBNE 10/94 SPR94011
C
C     ATTEMPT TO OPERATE ON SINGULAR MATRIX
C
  400 PARM(1) = -5
      CALL MESAGE (PARM(1),PARM(2),PARM(3))
      RETURN
      END

      SUBROUTINE TABFMT
C
C     MODULE MAIN PROGRAM FOR DMAP MODULE TABPRT
C
C     THE CALL TO THIS MODULE IS
C
C     TABPRT TDB // C,N,KEY / C,N,OPT1 / C,N,OPT2 $
C
C            TDB IS THE TABLE DATA BLOCK TO BE PRINTED.
C
C            KEY IS THE BCD VALUE WHICH DETERMINES THE FORMAT BY
C                 WHICH THE TABLE IS PRINTED.
C                 THERE IS NO DEFAULT VALUE FOR KEY.
C
C            OPT1 IS A SKIP FACTOR BETWEEN DATA LINES.
C                 OPT1.EQ.0 MEANS  NO SPACE BETWEEN DATA LINES.
C                 OPT1.NE.0 MEANS ONE SPACE BETWEEN DATA LINES.
C                 THE DEFAULT VALUE FOR OPT1 IS 0
C
C            OPT2 IS ZERO BY DEFAULT.
C                 SKIP FILE-NAME AND KEY CHECKING IF OPT2 IS NON-ZERO.
C
      INTEGER         P,P2,P3,NA,R,X(14),SUBNAM(2),NAME(2),NONE(2),
     1                NAM(2),RE,F,T(7),WD,RL,Y,Z(2),EID,A,B,
     2                H1,H2,H3,HX,ZERO,ONE,TWO
      REAL            RX(14)
      CHARACTER       UFM*23,UWM*25
      COMMON /XMSSG / UFM,UWM
      COMMON /BLANK / P(2),P2,P3
      COMMON /SYSTEM/ NB,NO,JUNK1(6),NLPP,JUNK2(2),LINE
      COMMON /OUTPUT/ T1(32),T2(32),T3(32),H1(32),H2(32),H3(32)
      COMMON /TABFTX/ LA,NA(2,21)  ,  HX(32,40)  , RE(21)
      COMMON /ZZZZZZ/ IX(1)
      EQUIVALENCE     (RX(1),X(1),IX(1))
      DATA    NONE  / 4H (NO , 4HNE)  /
      DATA    SUBNAM/ 4HTABF , 4HMT   /
      DATA    F     / 101   /
      DATA    ZERO  / 4H  0 /, ONE    / 4H  1 / , TWO / 4H  2 /
C
C
    1 FORMAT (1H )
C
      LC = KORSZ(X) - NB
      IB = LC + 1
      IF (LC .LE. 0) CALL MESAGE (-8,LC,SUBNAM)
      LS = 1
      IF (P2 .NE. 0) LS = 2
C
      DO 100 I = 1,LA
      IF (P(1).EQ.NA(1,I) .AND. P(2).EQ.NA(2,I)) GO TO 200
  100 CONTINUE
      GO TO 9901
C
  200 CONTINUE
      CALL FNAME (F,NAME)
      IF (NAME(1).EQ.NONE(1) .AND. NAME(2).EQ.NONE(2)) GO TO 9902
      T(1) = F
      CALL RDTRL (T)
      IF (T(1) .LE. 0) GO TO 9902
      CALL OPEN (*9902,F,X(IB),0)
      CALL READ (*9903,*9904,F,NAM,2,RE(I),KF)
      IF (NAM(1).EQ.P(1) .AND. NAM(2).EQ.P(2)) GO TO 250
      IF (P3 .EQ. 0) GO TO 9901
  250 CONTINUE
C
      GO TO (1100,1200,1300,1400,1500,1600,1700,1800,1900,2000
     1      ,2100,2200,2300,2400,2500,2600,2700,2800,2900,3000
     2      ,3100), I
C
C     PRINT CONTENTS OF TABLE DATA BLOCK BGPDT.
C
 1100 CONTINUE
      M1 = 2
      M2 = 3
      M3 = 4
      ASSIGN 1110 TO R
      GO TO 8000
 1110 CONTINUE
      H1(19) = P(1)
      H1(20) = P(2)
      H1(24) = ONE
      IF (LC .LT. 4) GO TO 9905
      J = 0
 1120 CALL READ (*9903,*1180,F,X,4,0,KF)
      J = J + 1
      LINE = LINE + LS
      IF (LINE .LE. NLPP) GO TO 1140
      CALL PAGE
      WRITE (NO,1)
      LINE = LS
 1140 IF (P2 .NE. 0) WRITE (NO,1)
      WRITE  (NO,1150) J,X(1),(RX(L),L=2,4)
 1150 FORMAT (20X,I10,I13,1X,1P,3E20.5)
      GO TO 1120
 1180 CONTINUE
      IF (KF .EQ. 0) GO TO 9000
      GO TO 9906
C
C     PRINT CONTENTS OF TABLE DATA BLOCK GPL.
C
 1200 CONTINUE
C
C     RECORD 1
C
      M1 = 2
      M2 = 5
      M3 = 6
      ASSIGN 1205 TO R
      GO TO 8000
 1205 CONTINUE
      H1(19) = P(1)
      H1(20) = P(2)
      H1(24) = ONE
      IF (LC .LT. 5) GO TO 9905
      J = -4
 1210 CALL READ (*9903,*1230,F,X,5,0,KF)
      J = J + 5
      LINE = LINE + LS
      IF (LINE.LE.NLPP) GO TO 1220
      CALL PAGE
      WRITE (NO,1)
      LINE = LS
 1220 IF (P2 .NE. 0) WRITE (NO,1)
      WRITE  (NO,1225) J,(X(L),L=1,5)
 1225 FORMAT (11X,I8,5(9X,I8,3X))
      GO TO 1210
 1230 CONTINUE
      IF (KF .EQ. 0) GO TO 1250
      J = J + 5
      LINE = LINE + LS
      IF (LINE .LE. NLPP) GO TO 1240
      CALL PAGE
      WRITE (NO,1)
      LINE = LS
 1240 IF (P2 .NE. 0) WRITE (NO,1)
      WRITE (NO,1225) J,(X(L),L=1,KF)
C
C     RECORD 2
C
 1250 IF (I .EQ. 4) GO TO 9000
      M1 = 2
      M2 = 7
      M3 = 8
      ASSIGN 1255 TO R
      GO TO 8000
 1255 CONTINUE
      H1(19) = P(1)
      H1(20) = P(2)
      H1(24) = TWO
      IF (LC .LT. 6) GO TO 9905
      J = -2
 1260 CALL READ (*9903,*1280,F,X,6,0,KF)
      J = J + 3
      LINE = LINE + LS
      IF (LINE .LE. NLPP) GO TO 1270
      CALL PAGE
      WRITE (NO,1)
      LINE = LS
 1270 IF (P2 .NE. 0) WRITE (NO,1)
      WRITE  (NO,1275) J,(X(L),L=1,6)
 1275 FORMAT (11X,I8,2X,3(9X,I8,4X,I12))
      GO TO 1260
 1280 CONTINUE
      IF (KF .EQ. 0) GO TO 1292
      J = J + 3
      LINE = LINE + LS
      IF (LINE .LE. NLPP) GO TO 1290
      CALL PAGE
      WRITE (NO,1)
      LINE = LS
 1290 IF (P2 .NE. 0) WRITE (NO,1)
      WRITE (NO,1275) J,(X(L),L=1,KF)
C
 1292 IF (MOD(KF,2) .EQ. 0) GO TO 9000
      GO TO 9906
C
C     PRINT CONTENTS OF TABLE DATA BLOCK CSTM
C
 1300 CONTINUE
      M1 = 2
      M2 = 9
      M3 = 10
      ASSIGN 1310 TO R
      GO TO 8000
 1310 CONTINUE
      H1(19) = P(1)
      H1(20) = P(2)
      H1(24) = ONE
      IF (LC .LT. 14) GO TO 9905
      J = 0
 1320 CALL READ (*9903,*1380,F,X,14,0,KF)
      J = J + 1
      LINE = LINE + LS + 2
      IF (LINE .LE. NLPP) GO TO 1340
      CALL PAGE
      WRITE (NO,1)
      LINE = LS + 2
 1340 IF (P2 .NE. 0) WRITE (NO,1)
      WRITE (NO,1350) J,X(1),X(2),RX( 6),RX( 7),RX( 8),RX( 3)
     1                           ,RX( 9),RX(10),RX(11),RX( 4)
     2                           ,RX(12),RX(13),RX(14),RX( 5)
 1350 FORMAT( 10X,I10,I10,I10, 1P,3E20.8,10X,1P,E20.8
     1       /40X,             1P,3E20.8,10X,1P,E20.8
     2       /40X,             1P,3E20.8,10X,1P,E20.8)
      GO TO 1320
 1380 CONTINUE
      IF (KF .EQ. 0) GO TO 9000
      GO TO 9906
C
C     PRINT CONTENTS OF TABLE DATA BLOCK GPLD
C
 1400 CONTINUE
      GO TO 1200
C
C     PRINT CONTENTS OF TABLE DATA BLOCK EQEXIN
C
 1500 CONTINUE
      M1 = 2
      M2 = 11
      M3 = 12
      ASSIGN 1501 TO R
      GO TO 8000
 1501 CONTINUE
      H1(19) = P(1)
      H1(20) = P(2)
      H1(24) = ONE
 1502 IF (LC .LT. 8) GO TO 9905
      J = -3
 1510 CALL READ (*9903,*1530,F,X,8,0,KF)
      J = J + 4
      LINE = LINE + LS
      IF (LINE .LE. NLPP) GO TO 1520
      CALL PAGE
      WRITE (NO,1)
      LINE = LS
 1520 IF (P2 .NE. 0) WRITE (NO,1)
      WRITE  (NO,1525) J,(X(L),L=1,8)
 1525 FORMAT (7X,I8,4(7X,I8,6X,I8))
      GO TO 1510
 1530 CONTINUE
      IF (KF .EQ. 0) GO TO 1550
      J = J + 4
      LINE = LINE + LS
      IF (LINE .LE. NLPP) GO TO 1540
      CALL PAGE
      WRITE (NO,1)
      LINE = LS
 1540 IF (P2 .NE. 0) WRITE (NO,1)
      WRITE (NO,1525) J,(X(L),L=1,KF)
C
C     RECORD 2
C
 1550 IF (H1(24) .EQ. TWO) GO TO 9000
      M1 = 2
      M2 = 11
      M3 = 22
      ASSIGN 1555 TO R
      GO TO 8000
 1555 CONTINUE
      H1(19) = P(1)
      H1(20) = P(2)
      H1(24) = TWO
      GO TO 1502
C
C     PRINT CONTENTS OF TABLE DATA BLOCK EQDYN
C
 1600 CONTINUE
      GO TO 1500
C
C     PRINT CONTENTS OF TABLE DATA BLOCK GPDT
C
 1700 CONTINUE
      M1 = 2
      M2 = 13
      M3 = 14
      ASSIGN 1710 TO R
      GO TO 8000
 1710 CONTINUE
      H1(19) = P(1)
      H1(20) = P(2)
      H1(24) = ONE
      IF (LC .LT. 7) GO TO 9905
      J = 0
 1720 CALL READ (*9903,*1750,F,X,7,0,KF)
      J = J + 1
      LINE = LINE + LS
      IF (LINE .LE. NLPP) GO TO 1730
      CALL PAGE
      WRITE (NO,1)
      LINE = LS
 1730 IF (P2 .NE. 0) WRITE (NO,1)
      WRITE  (NO,1740) X(1),X(2),RX(3),RX(4),RX(5),X(6),X(7)
 1740 FORMAT (7X,I8,10X,I8,10X,3(1P,E12.5,5X),5X,I8,10X,I8)
      GO TO 1720
 1750 CONTINUE
      IF (KF .EQ. 0) GO TO 9000
      GO TO 9906
C
C     PRINT CONTENTS OF TABLE DATA BLOCK GPTT
C
 1800 CONTINUE
C
C     RECORD 0
C
      M1 = 2
      M2 = 15
      M3 = 16
      ASSIGN 1805 TO R
      GO TO 8000
 1805 CONTINUE
      H1(19) = P(1)
      H1(20) = P(2)
      H1(24) = ZERO
      IF ((LC/3)*3 .EQ. 0) GO TO 9905
      IVAL = (LC/3)*3
      CALL READ (*9903,*1812,F,X,IVAL,0,KF)
      GO TO 9905
 1812 WD = ((KF-1)/3) + 1
      IF (KF .EQ. 0) WD = ((LC-1)/3) + 1
      DO 1825 J = 1,WD
      LINE = LINE + LS
      IF (LINE .LE. NLPP) GO TO 1815
      CALL PAGE
      WRITE (NO,1)
      LINE = LS
 1815 IF (P2 .NE. 0) WRITE (NO,1)
      IF (X(3*J-1) .EQ. -1) GO TO 1822
      WRITE  (NO,1821) J,X(3*J-2),RX(3*J-1),X(3*J)
 1821 FORMAT (7X,I8,10X,I8,14X,1P,E12.5,19X,I8)
      GO TO 1825
 1822 WRITE  (NO,1823) J,X(3*J-2),X(3*J-1),X(3*J)
 1823 FORMAT (7X,I8,10X,I8,14X,6X,I3,22X,I8)
 1825 CONTINUE
C
C     RECORD 1 AND ALL OTHERS
C
      M1 = 17
      M2 = 1
      M3 = 18
      ASSIGN 1835 TO R
      GO TO 8000
 1835 CONTINUE
      DO 1895 RL = 1,J
      IF (X(3*RL)   .EQ. 0) GO TO 1895
      IF ((LC-3*WD) .LT. 4) GO TO 9905
      CALL READ (*9903,*9904,F,Y,1,0,KF)
 1840 CALL READ (*9903,*1895,F,Z,2,0,KF)
 1845 CALL READ (*9903,*9904,F,EID,1,0,KF)
C
C     ELEMENT ID EQUALS ZERO INDICATES THE END OF DATA FOR CURRENT TYPE
C
      IF ((LC-3*WD) .LT. Z(2)) GO TO 9905
C
C     ELEMENT ID LESS THAN ZERO INDICATES NONEXISTENT TEMPERATURE VALUES
C
      IF (EID) 1848,1840,1847
 1847 IVAL = 3*WD + 1
      CALL READ (*9903,*9904,F,X(IVAL),Z(2),0,KF)
 1848 A = 3*WD + 1
      B = A + 7
      IF (B .GE. (A+Z(2))) B = A + Z(2) - 1
      LINE = LINE + LS
      IF (LINE .LE. NLPP) GO TO 1865
      CALL PAGE
      WRITE  (NO,1850) X(3*RL),Y
 1850 FORMAT (9X,I8,11X,I8,11X,I8,13X,I8)
      WRITE  (NO,1860)
 1860 FORMAT (14H0   ELEMENT ID,8X,5H( 1 ),9X,5H( 2 ),9X,5H( 3 ),9X,
     1                             5H( 4 ),9X,5H( 5 ),9X,5H( 6 ),9X,
     2                             5H( 7 ),9X,5H( 8 ) )
      WRITE (NO,1)
      LINE = LS + 3
 1865 IF (EID) 1866,1840,1867
 1866 WRITE (NO,1870) EID
      GO TO 1845
 1867 WRITE  (NO,1870) EID,(RX(L),L=A,B)
 1870 FORMAT (4X,I8,3X,8(2X,1P,E12.5) )
      IF (P2 .NE. 0) WRITE (NO,1)
      IF (B .EQ. (A+Z(2)-1)) GO TO 1845
      A = A + 8
 1875 B = A + 7
      IF (B .GE. (A+Z(2))) B = A + Z(2) - 1
      LINE = LINE + LS
      IF (LINE .LE. NLPP) GO TO 1880
      CALL PAGE
      WRITE (NO,1850) X(3*RL),Y
      WRITE (NO,1)
      LINE = LS + 3
 1880 WRITE  (NO,1885) (RX(L),L=A,B)
 1885 FORMAT (17X,1P,E12.5,2X,1P,E12.5,2X,1P,E12.5,2X,1P,E12.5,
     1         2X,1P,E12.5,2X,1P,E12.5,2X,1P,E12.5,2X,1P,E12.5)
      IF (P2 .NE. 0) WRITE (NO,1)
      IF (B .EQ. (A+Z(2)-1)) GO TO 1845
      A = A + 8
      GO TO 1875
 1895 CONTINUE
      IF (KF .EQ. 0) GO TO 9000
      GO TO 9906
C
C     PRINT CONTENTS OF TABLE DATA BLOCK GPCT
C
 1900 CONTINUE
      M1 = 19
      M2 = 20
      M3 = 21
      ASSIGN 1910 TO R
      GO TO 8000
 1910 CONTINUE
      IF (LC .LT. 12) GO TO 9905
      J = 0
 1920 CALL READ (*1990,*9904,F,PI,1,0,KF)
      J  = J + 1
      WD = 10
      LINE = LINE + LS
      IF (LINE .LE. NLPP) GO TO 1930
      CALL PAGE
      WRITE (NO,1)
      LINE = LS
 1930 IF (P2 .NE. 0) WRITE (NO,1)
      CALL READ (*9903,*1980,F,M,1,0,KF)
      CALL READ (*9903,*1940,F,X,10,0,KF)
      GO TO 1945
 1940 WD = KF
 1945 WRITE  (NO,1950) J,PI,M,(X(L),L=1,WD)
 1950 FORMAT (3X,I8,12(2X,I8))
      IF (M .LE. 10) GO TO 1920
 1960 LINE = LINE + LS
      IF (LINE .LE. NLPP) GO TO 1965
      CALL PAGE
      WRITE (NO,1)
      LINE = LS
 1965 IF (P2 .NE. 0) WRITE (NO,1)
      CALL READ (*9903,*1975,F,X,10,0,KF)
      WRITE  (NO,1970) (X(L),L=1,WD)
 1970 FORMAT (31X,10(2X,I8))
      GO TO 1960
 1975 WD = KF
      WRITE (NO,1970) (X(L),L=1,WD)
      GO TO 1920
 1980 M = 0
      WRITE (NO,1950) PI,M
      GO TO 1920
 1990 IF (J .EQ. 0) GO TO 9903
      GO TO 9000
C
C     PRINT CONTENTS OF
C
 2000 CONTINUE
      GO TO 9000
C
 2100 CONTINUE
      GO TO 9000
C
 2200 CONTINUE
      GO TO 9000
C
 2300 CONTINUE
      GO TO 9000
C
 2400 CONTINUE
      GO TO 9000
C
 2500 CONTINUE
      GO TO 9000
C
 2600 CONTINUE
      GO TO 9000
C
 2700 CONTINUE
      GO TO 9000
C
 2800 CONTINUE
      GO TO 9000
C
 2900 CONTINUE
      GO TO 9000
C
 3000 CONTINUE
      GO TO 9000
C
 3100 CONTINUE
      GO TO 9000
C
C
C     INTERNAL ROUTINE TO SET HEADINGS AND INITIALIZE LINE COUNTER.
C     -------------------------------------------------------------
C
 8000 CONTINUE
      DO 8010 M = 1,32
      H1(M) = HX(M,M1)
      H2(M) = HX(M,M2)
      H3(M) = HX(M,M3)
 8010 CONTINUE
      LINE = NLPP
      GO TO R, (1110,1205,1255,1310,1501,1555,1710,1805,1835,1910)
C
C
C     PRINT TRAILER OF TABLE DATA BLOCK
C     ---------------------------------
C
 9000 CONTINUE
      WRITE  (NO,9010) (T(L),L=2,7)
 9010 FORMAT (15H0*** TRAILER = ,6I18)
      GO TO 9999
C
C
 9901 WRITE  (NO,9951) UWM,P
 9951 FORMAT (A25,' 2094, SUBROUTINE TABFMT, KEYNAME ',2A4,
     1       ' NOT IN LIST OF AVAILABLE KEYNAMES.')
      GO TO 9993
C
 9902 WRITE  (NO,9952) UWM
 9952 FORMAT (A25,' 2095, SUBROUTINE TABFMT, PURGED INPUT.')
      GO TO 9995
C
 9903 WRITE  (NO,9953) UWM
 9953 FORMAT (A25,' 2096, SUBROUTINE TABFMT, EOF ENCOUNTERED.')
      GO TO 9995
C
 9904 WRITE  (NO,9954) UWM
 9954 FORMAT (A25,' 2097, SUBROUTINE TABFMT, EOR ENCOUNTERED.')
      GO TO 9995
C
 9905 WRITE  (NO,9955) UWM
 9955 FORMAT (A25,' 2098, SUBROUTINE TABFMT, INSUFFICIENT CORE.')
      GO TO 9995
C
 9906 WRITE  (NO,9956) UWM,KF
 9956 FORMAT (A25,' 2099, SUBROUTINE TABFMT, KF =',I10)
      GO TO 9995
C
 9993 WRITE  (NO,9994) (NA(1,L),NA(2,L),L=1,LA)
 9994 FORMAT ('0*** LIST OF RECOGNIZED KEYNAMES FOLLOWS...', /(20X,2A4))
C
 9995 CONTINUE
C
C     DO NOT CALL PEXIT SINCE THIS IS AN OUTPUT PROCESSOR.
C
 9999 CALL CLOSE (F,1)
      RETURN
C
      END

      SUBROUTINE AXIS10 (X1,Y1,X2,Y2,PENDEN,OPT)
C
C     (X1,Y1) = STARTING POINT OF THE AXIS.
C     (X2,Y2) = TERMINAL POINT OF THE AXIS.
C     PENDEN  = PEN NUMBER OR LINE DENSITY.
C     OPT     = -1 TO INITIATE  THE AXIS MODE.
C     ...     = +1 TO TERMINATE THE AXIS MODE.
C     ...     =  0 TO DRAW AN AXIS.
C
      INTEGER PENDEN,OPT,OPTX,A(6),AXIS
      REAL    XY(2,2)
      COMMON /PLTDAT/ SKPPLT(2),XYMIN(2),XYMAX(2)
      DATA    OPTX  / -1 /
      DATA    AXIS  /  6 /
C
      IF (OPTX .GE. 0) OPTX = OPT
      IF (OPT) 200,100,150
  100 XY(1,1) = X1
      XY(2,1) = Y1
      XY(1,2) = X2
      XY(2,2) = Y2
      DO 101 J = 1,2
      DO 101 I = 1,2
      IF (XY(I,J) .LT. XYMIN(I)) XY(I,J) = XYMIN(I)
      IF (XY(I,J) .GT. XYMAX(I)) XY(I,J) = XYMAX(I)
  101 CONTINUE
C
C     DRAW THE AXIS.
C
      A(1) = AXIS
      A(2) = PENDEN
      DO 110 J = 1,2
      A(2*J+1) = XY(1,J) + .1
      A(2*J+2) = XY(2,J) + .1
  110 CONTINUE
      IF (OPTX .EQ. 0) GO TO 120
C
C     INITIATE THE AXIS MODE.
C
      A(1) = A(1) + 10
      OPTX = 0
C
C     DRAW THE LINE.
C
  120 CALL WPLT10 (A,0)
      GO TO 200
C
C
C     TERMINATE THE LINE MODE.
C
  150 CALL WPLT10 (A,1)
      OPTX = -1
C
  200 RETURN
      END

      SUBROUTINE FBSI (ZS,ZD)
C
C     GIVEN A LOWER TRIANGULAR FACTOR WITH DIAGONAL SUPERIMPOSED, AND
C     WRITTEN WITH TRAILING STRING DEFINITION WORDS, FBS WILL PERFORM
C     THE FORWARD-BACKWARD SUBSTITUTION NECESSARY TO SOLVE A LINEAR
C     SYSTEM OF EQUATIONS.
C
C     OPEN CORE IS DEFINED AS FOLLOWS
C
C     ZS(   1         ) - FIRST RIGHT HAND VECTOR ON FILE DBB
C                         (SIZE = NCOL*NWDS)
C                         NCOL = NUMBER OF COLUMNS (ROWS) IN LOWER  
C                                TRIANGULAR MATRIX
C                         NWDS = 1, IF MATRICES ARE REAL SINGLE
C                              = 2, IF MATRICES ARE REAL DOUBLE OR 
C                                COMPLEX SINGLE
C                              = 4, IF MATRICES ARE COMPLEX DOUBLE
C     ZS( NCOL*NWDS+1 ) - NEXT RIGHT HAND VECTOR
C         .
C         .               ( "NRHV" RIGHT HAND VECTORS WILL BE LOADED INTO 
C         .               MEMORY)
C         .
C     ZS( MTRIA       ) - MEMORY FOR STORAGE OF ALL OR PART OF THE LOWER
C                         TRIANGULAR MATRIX.  (SEE SUBROUTINE FBSRDM FOR
C                         FORMAT OF STORAGE OF MATRIX.)
C     ZS( BUF1        ) - BUFFER FOR FILE WITH RIGHT HAND VECTORS
C                         AND FOR SOLUTION VECTORS
C     ZS( BUF2        ) - BUFFER FOR FILE WITH TRIANGULAR MATRIX
C
      IMPLICIT INTEGER (A-Z)
      LOGICAL         IDENT
      INTEGER         SUBNAM(2) ,BLOCK(15),BEGN     ,END      ,INAME(2)
      REAL            ZS(1)     ,XS(4)    ,YS(4)
      DOUBLE  PRECISION          ZD(1)    ,XD       ,YD
      CHARACTER       UFM*23    ,UWM*25   ,UIM*29
      COMMON /LOGOUT/ LOUT
      COMMON /XMSSG / UFM       ,UWM      ,UIM
      COMMON /FBSX  / DBL(7)    ,DBU(7)   ,DBB(7)   ,DBX(7)   ,LCORE   ,
     1                PREC      ,SIGN     ,SCRX
      COMMON /FBSM  / NVEC      ,NVECSZ   ,NWDS     ,LASIND   ,IPOS(7)
      COMMON /SYSTEM/ SYSBUF    ,NOUT     ,SKIP(91) ,KSYS94
      COMMON /NAMES / RD        ,RDREW    ,WRT      ,WRTREW   ,REW     ,
     1                NOREW     ,EOFNRW   ,RSP      ,RDP      ,CSP     ,
     2                CDP
      COMMON /TYPE  / PRC(2)    ,WORDS(4) ,RLCMPX(4)
      COMMON /PACKX / ITYPE1    ,ITYPE2   ,I1       ,J1       ,INCR1
      COMMON /UNPAKX/ ITYPE3    ,I2       ,J2       ,INCR2
      COMMON /ZNTPKX/ XD(2)     ,IX       ,EOL
      COMMON /ZBLPKX/ YD(2)     ,IY
      EQUIVALENCE     (DBL(2),NCOL),   (DBB(5),TYPEB), (DBX(5),TYPEX),
     1                (XD(1),XS(1)), (YD(1),YS(1))
      DATA    SUBNAM/ 4HFBSI,4H    /  
      DATA    BEGN  / 4HBEGN/
      DATA    END   / 4HEND /
C
C     GENERAL INITIALIZATION
C
      BUF2     = LCORE - SYSBUF
      BUF1     = BUF2  - SYSBUF
      TYPEL    = DBL(5)            
      RCB      = RLCMPX( TYPEB )
      RCL      = RLCMPX( TYPEL )
      NWDS     = WORDS ( TYPEB )
      IF ( RCB .EQ. RCL .AND. TYPEL .GT. TYPEB ) NWDS = WORDS( TYPEL )
      NRHVWD   = NWDS * NCOL      
      NWDS     = WORDS ( TYPEL )
      NRHV     = DBB(2)
      IDENT    = .FALSE.
      IF (DBB(4) .EQ. 8) IDENT = .TRUE.
      IF (IDENT) NRHV = NCOL
      SWITCH   = 1
C 
C SET SWITCH AS FOLLOWS:
C  =1, IF LOWER TRIANGULAR MATRIX AND RIGHT HAND VECTORS ARE SAME TYPE
C  =2, LOWER TRIANGULAR MATRIX IS REAL SINGLE AND RIGHT HAND VECTOR IS 
C      COMPLEX
C  =3, LOWER TRIANGULAR MATRIX IS REAL DOUBLE AND RIGHT HAND VECTOR IS 
C      COMPLEX
C  (NOTE, IF SWITCH IS .NE. 1, THEN THE REAL AND IMAGINARY PARTS OF THE
C   THE RIGHT HAND VECTOR ARE TREATED AS TWO SEPARATE VECTORS.  I.E.,
C   THE REAL PART BECOMES ONE VECTOR AND THE IMAGINARY PART BECOMES A
C   SECOND VECTOR.)
C
      IF (TYPEL.EQ.RSP .AND. RCB.EQ.2) SWITCH = 2
      IF (TYPEL.EQ.RDP .AND. RCB.EQ.2) SWITCH = 3
      IF (SWITCH .EQ. 1 ) GO TO 90
      IF (SWITCH .EQ. 3 ) GO TO 70
      NRHVWD   = 2 * NCOL      
      GO TO 90
70    CONTINUE
      NRHVWD   = 4 * NCOL      
90    CONTINUE
      MTRIA    = NRHV * NRHVWD + 1
C
C ENSURE DOUBLE WORD BOUNDARY
C
      MTRIA    = ( MTRIA/2 ) * 2 + 1
      MEMAVL   = BUF1 - MTRIA - 2
      SUBNAM(2) = BEGN
      CALL CONMSG (SUBNAM,2,0)
      CALL FBSRDM ( DBL   , ZS(MTRIA), ZS(MTRIA), ZS(MTRIA) 
     &,             MEMAVL, ZS(BUF2 ), LASIND   , IPOS )
      CALL SSWTCH ( 47, L47 )
      CALL FNAME ( DBL, INAME )
      IF ( L47 .EQ. 0 ) GO TO 100
      WRITE ( LOUT, 9001 ) DBL(1), INAME, IPOS( 1 ), NCOL, LCORE, MEMAVL
      CALL FNAME ( DBB, INAME )
      WRITE ( LOUT, 9002 ) DBB(1), INAME, DBL, DBB
9001  FORMAT(4X
     &,      ' FORWARD BACKWARD SUBSTITUTION OF FILE ',I3,'   NAME=',2A4
     &,/,4X, ' LAST COLUMN OF TRIANGULAR MATRIX IN MEMORY        =',I8
     &,/,4X, ' TOTAL COLUMNS IN TRIANGULAR MATRIX                =',I8
     &,/,4X, ' TOTAL OPEN CORE AVAILABLE FOR USE                 =',I8
     &,/,4X, ' OPEN CORE AVAILABLE FOR TRIANGULAR MATRIX STORAGE =',I8 )
9002  FORMAT(4X
     &,      ' RIGHT HAND VECTOR FILE ',I3,'   NAME=',2A4
     &,/,4X, ' TRIANGULAR MATRIX TRAILER    =', 7I6 
     &,/,4X, ' RIGHT HAND VECTOR(S) TRAILER =', 7I6 )   
100   CONTINUE
      I2       = 1
      J2       = NCOL
      INCR2    = 1
      I1       = 1
      J1       = NCOL
      INCR1    = 1
      ITYPE1   = TYPEL
      ITYPE2   = TYPEX
      ITYPE3   = SIGN*TYPEL
      DBX(2)   = 0
      DBX(6)   = 0
      DBX(7)   = 0
      BLOCK(1) = DBL(1)
C
C     OPEN RIGHT HAND VECTORS FILE (DBB)
C
      LAST  = NRHV*NRHVWD
      IF ( IDENT ) GO TO 280
      CALL GOPEN ( DBB, ZS(BUF1), RDREW )
      GO TO ( 140, 180, 230 ), SWITCH
C
C     READ RIGHT HAND VECTORS INTO MEMORY
C
  140 DO 170 L = 1, LAST, NRHVWD
      CALL UNPACK ( *150, DBB, ZS(L) )
      GO TO 170
  150 LN = L + NRHVWD - 1
      DO 160 LL = L,LN
  160 ZS( LL ) = 0.
  170 CONTINUE
      GO TO 390
C
C     SPECIAL CASE - LOWER TRIANGULAR MATRIX IS RSP AND VECTORS ARE CSP
C
  180 LAST2 = LAST / 2
      L = 0
      DO 190 K = 1,LAST2
  190 ZD(K)    = 0.0D+0
      DO 220 K = 1, NRHV
      ICSPSG   = CSP*SIGN
      CALL INTPK ( *210, DBB, 0, ICSPSG, 0 )
  200 CALL ZNTPKI
      ZS(L+IX     ) = XS(1)
      ZS(L+IX+NCOL) = XS(2)
      IF ( EOL .EQ. 0 ) GO TO 200
  210 L = L + 2*NCOL
  220 CONTINUE
      GO TO 390
C
C     SPECIAL CASE - LOWER TRIANGULAR MATRIX IS RDP AND VECTORS ARE CDP
C
  230 LAST2 = LAST / 2
      L = 0
      DO 240 K = 1,LAST2
  240 ZD(K)    = 0.0D+0
      DO 270 K = 1, NRHV
      ICDPSG   = CDP*SIGN
      CALL INTPK ( *260, DBB, 0, ICDPSG, 0 )
  250 CALL ZNTPKI
      ZD(L+IX     ) = XD(1)
      ZD(L+IX+NCOL) = XD(2)
      IF ( EOL .EQ. 0 ) GO TO 250
  260 L        = L + 2*NCOL
  270 CONTINUE
      GO TO 390
C
C     SPECIAL CASE - GENERATE IDENTITY MATRIX
C
  280 LAST = NRHV * NRHVWD
      DO 290 K = 1,LAST
  290 ZD(K) = 0.0D+0
      L = 0
      GO TO ( 300, 320, 340, 360 ), TYPEL
  300 DO 310 K = 1, NRHV
      ZS(L+K)  = 1.0
  310 L        = L + NRHVWD
      GO TO 400
  320 DO 330 K = 1, NRHV
      ZD(L+K)  = 1.0D+0
  330 L        = L + NRHVWD
      GO TO 400
  340 DO 350 K    = 1, NRHV
      ZS(L+2*K-1) = 1.0
  350 L           = L + NRHVWD
      GO TO 400
  360 DO 370 K    = 1, NRHV
      ZD(L+2*K-1) = 1.0D+0
  370 L           = L + NRHVWD
      GO TO 400
C
C    CLOSE RIGHT HAND VECTORS FILE (DBB).
C    START FORWARD-BACKWARD SUBSTITUTION ON RIGHT HAND VECTORS
C
  390 CALL CLOSE  (DBB,REW)
  400 CONTINUE
      J      = TYPEL 
      NVEC   = NRHV
      NVECSZ = NCOL
      IF ( SWITCH .GT. 1 ) NVEC = NVEC*2
      GO TO ( 410, 420, 430, 440), J
  410 CONTINUE
      CALL FBSI1 ( BLOCK, ZS, ZS(MTRIA), ZS(MTRIA), ZS(BUF2) ) 
      GO TO 500
  420 CONTINUE  
      CALL FBSI2 ( BLOCK, ZS, ZS(MTRIA), ZS(MTRIA), ZS(BUF2) ) 
      GO TO 500
  430 CONTINUE
      CALL FBSI3 ( BLOCK, ZS, ZS(MTRIA), ZS(MTRIA), ZS(BUF2) ) 
      GO TO 500
  440 CONTINUE
      CALL FBSI4 ( BLOCK, ZS, ZS(MTRIA), ZS(MTRIA), ZS(BUF2) ) 
      GO TO 500
C
C     OPEN AND PACK SOLUTION VECTORS ONTO OUTPUT FILE (DBX)
C
  500 CALL GOPEN ( DBX, ZS(BUF1), WRTREW)
      GO TO ( 510, 530, 560 ), SWITCH
C
C     NORMAL CASE - CALL PACK
C
  510 DO 520 L = 1, LAST, NRHVWD
      CALL PACK ( ZS(L), DBX, DBX )
  520 CONTINUE
      GO TO 600
C
C     SPECIAL CASE - LOWER TRIANGULAR MATRIX IS RSP AND VECTORS ARE CSP
C
  530 L = 0
      DO 550 K = 1, NRHV
      CALL BLDPK ( CSP, TYPEX, DBX, 0, 0 )
      DO 540 I = 1, NCOL
      YS(1)    = ZS(L+I     )
      YS(2)    = ZS(L+I+NCOL)
      IY       = I
      CALL ZBLPKI
  540 CONTINUE
      CALL BLDPKN ( DBX, 0, DBX )
      L        = L + 2*NCOL
  550 CONTINUE
      GO TO 600
C
C     SPECIAL CASE - LOWER TRIANGULAR MATRIX IS RDP AND VECTORS ARE CDP
C
  560 L = 0
      DO 580 K = 1, NRHV
      CALL BLDPK ( CDP, TYPEX, DBX, 0, 0 )
      DO 570 I = 1,NCOL
      YD(1)    = ZD(L+I     )
      YD(2)    = ZD(L+I+NCOL)
      IY       = I
      CALL ZBLPKI
  570 CONTINUE
      CALL BLDPKN ( DBX, 0, DBX )
      L        = L + 2*NCOL
  580 CONTINUE
      GO TO 600
C
C     JOB DONE. CLOSE TRIANGULAR MATRIX AND SOLUTION FILE.
C
  600 CALL CLOSE ( DBX, REW )
      SUBNAM( 2 ) = END
      CALL CONMSG ( SUBNAM, 2, 0 )
      RETURN
      END

      FUNCTION AI (I,J,K,L,M,N,IP,IQ,R,Z)
C
      DIMENSION  R(1),Z(1)
C
      IF (R(I) .EQ. R(J)) GO TO 20
      RD   = R(J)
      IF (R(J) .EQ. 0.0) RD = R(I)
      ABS1 = ABS((R(I)-R(J))/RD)
      IF (ABS1 .LE. .0001) GO TO 20
      AMKL = (R(L)*Z(K)-R(K)*Z(L))/(R(L)-R(K))
      AKKL = (Z(L)-Z(K))/(R(L)-R(K))
      AMMN = (R(N)*Z(M)-R(M)*Z(N))/(R(N)-R(M))
      AKMN = (Z(N)-Z(M))/(R(N)-R(M))
      IF (AKMN.NE.AKKL .OR. AMMN.NE.AMKL) GO TO 30
   20 AI  = 0.0
      GO TO 510
   30 CONTINUE
      ISS = IABS(IP)
      IRR = IABS(IQ)
      IF (IQ + 1) 100,300,50
   50 CONTINUE
      MM = IP
      NN = IQ + 1
      AI = BINT(I,J,AMMN,AKMN,MM,NN,R,Z) - BINT(I,J,AMKL,AKKL,MM,NN,R,Z)
      GO TO 510
  100 CONTINUE
      IF (IP .LT. 0) GO TO 200
      MM = IP
      NN = IRR - 1
      AI = F89(I,AMKL,AKKL,MM,NN,R) - F89(I,AMMN,AKMN,MM,NN,R)
     1   - F89(J,AMKL,AKKL,MM,NN,R) + F89(J,AMMN,AKMN,MM,NN,R)
      ARR= IRR
      AI = (1.0/(1.0 - ARR))*AI
      GO TO 510
  200 CONTINUE
      MM = ISS
      NN = IRR - 1
      AI = FF100(I,AMKL,AKKL,MM,NN,R) -FF100(I,AMMN,AKMN,MM,NN,R)
     1   - FF100(J,AMKL,AKKL,MM,NN,R) +FF100(J,AMMN,AKMN,MM,NN,R)
      ARR= IRR
      AI = (1.0/(1.0-ARR))*AI
      GO TO 510
  300 CONTINUE
      IF (IP + 1) 400,500,301
  301 CONTINUE
      MM = IP + 1
      AMM= MM
      XX = R(I)**MM/AMM
      AI = (
     1   +XX*ALOG(ABS(AMKL+AKKL*R(I)))-AKKL/AMM*F89(I,AMKL,AKKL,MM,1,R)
     2   -XX*ALOG(ABS(AMMN+AKMN*R(I)))+AKMN/AMM*F89(I,AMMN,AKMN,MM,1,R)
     3     )
      XX = R(J)**MM/AMM
      AI = (
     1   -XX*ALOG(ABS(AMKL+AKKL*R(J)))+AKKL/AMM*F89(J,AMKL,AKKL,MM,1,R)
     2   +XX*ALOG(ABS(AMMN+AKMN*R(J)))-AKMN/AMM*F89(J,AMMN,AKMN,MM,1,R)
     3     ) + AI
      GO TO 510
  400 CONTINUE
      MM = ISS - 1
      AMM= MM
      XX = AMM*R(I)**MM
      AI = (
     1  -ALOG(ABS(AMKL+AKKL*R(I)))/XX+AKKL/AMM*FF100(I,AMKL,AKKL,MM,1,R)
     2  +ALOG(ABS(AMMN+AKMN*R(I)))/XX-AKMN/AMM*FF100(I,AMMN,AKMN,MM,1,R)
     3     )
      XX = AMM*R(J)**M
      AI = (
     1  +ALOG(ABS(AMKL+AKKL*R(J)))/XX-AKKL/AMM*FF100(J,AMKL,AKKL,MM,1,R)
     2  -ALOG(ABS(AMMN+AKMN*R(J)))/XX+AKMN/AMM*FF100(J,AMMN,AKMN,MM,1,R)
     3     ) + AI
      GO TO 510
  500 CONTINUE
      AI = F6211(I,AMKL,AKKL,R) - F6211(I,AMMN,AKMN,R)
     1   - F6211(J,AMKL,AKKL,R) + F6211(J,AMMN,AKMN,R)
  510 CONTINUE
      RETURN
      END

      SUBROUTINE ANISOP
C
C     COMPUTES DIRECTION COSINES FOR RECTANGULAR COORD. SYSTEMS
C     (W.R.T. BASIC COORD. SYSTEM) DESCRIBING ORIENTATION OF ANIS.
C     MATERIAL FOR ISOPARAMETRIC SOLIDS
C
C     ANISOP  GEOM1,EPT,BGPDT,EQEXIN,MPT/MPTA/S,N,ISOP $
C     EQUIV   MPTA,MPT/ISOP $
C     ISOP=-1 MEANS SUCH MATERIALS EXIST
C
      INTEGER         GEOM1,EPT,BGPDT,FILE,BUF1,BUF2,EQEXIN
      DIMENSION       IZ(1),NAM(2),IC1(2),IC2(2),IPI(2),IMAT6(2),
     1                IDUM(31),A(3),B(3),C(3),XP(3),YP(3),ZP(3),
     2                STORE(9),XD(9),ITRL(7),MAT1(2)
      CHARACTER       UFM*23,UWM*25
      COMMON /XMSSG / UFM,UWM
      COMMON /BLANK / ISOP
      COMMON /SYSTEM/ IBUF,NOUT
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE     (Z(1),IZ(1))
      DATA    GEOM1 , EPT,BGPDT,EQEXIN,MPT,MPTA /
     1        101   , 102,103  ,104   ,105,201  /
      DATA    IPI   / 7002,70/ ,IC1 / 1801,18   /, IC2 / 2101,21 /,
     1        IMAT6 / 2503,25/ ,MAT1/  103, 1   /
      DATA    NAM   / 4HANIS, 4HOP  /
C
      ISOP  = 1
      LCORE = KORSZ(Z)
      BUF1  = LCORE - IBUF - 1
      BUF2  = BUF1  - IBUF
      LCORE = BUF2 - 1
      IF (LCORE .LE. 0) GO TO 1008
C
C     GET LIST OF MAT1 AND MAT6 ID-S
C
      NMAT1 = 0
      NMAT6 = 0
      I     = 0
CWKBI SPR93033 5/94
      FILE  = MPT
      CALL PRELOC (*1001,Z(BUF1),MPT)
      CALL LOCATE (*2,Z(BUF1),MAT1,IDX)
CWKBD SPR93022 5/94      FILE  = MPT
    1 CALL READ (*1002,*2,MPT,IDUM,12,0,M)
      NMAT1 = NMAT1 + 1
      I = I + 1
      IF (I .GT. LCORE) GO TO 1008
      IZ(I) = IDUM(1)
      GO TO 1
C
C     DONE WITH MAT1
C
    2 CALL LOCATE (*4,Z(BUF1),IMAT6,IDX)
    3 CALL READ (*1002,*4,MPT,IDUM,31,0,M)
      NMAT6 = NMAT6 + 1
      I = I + 1
      IF (I .GT. LCORE) GO TO 1008
      IZ(I) = IDUM(1)
      GO TO 3
    4 CALL CLOSE (MPT,1)
C
C     LOCATE PIHEX CARDS ON EPT AND FORM A LIST OF MATERIAL COORD.
C     SYSTEM ID
C
CWKBI SPR93033 5/94
      FILE = EPT
      CALL PRELOC (*310,Z(BUF1),EPT)
      CALL LOCATE (*310,Z(BUF1),IPI,IDX)
CWKBD SPR93033 5/94      FILE = EPT
   10 CALL READ (*1002,*40,EPT,IDUM,7,0,M)
C
      ICID = IDUM(3)
      MID  = IDUM(2)
C
C     IF CID = 0, MID MUST BE MAT1
C     IF CID IS NOT 0, MID MUST BE MAT6
C
      IF (ICID  .GT. 0) GO TO 11
      IF (NMAT1 .EQ. 0) GO TO 14
      II = 1
      NN = NMAT1
      GO TO 12
   11 IF (NMAT6 .EQ. 0) GO TO 14
      II = NMAT1 + 1
      NN = NMAT1 + NMAT6
   12 DO 13 III = II,NN
      IF (MID .EQ. IZ(III)) GO TO 1141
   13 CONTINUE
   14 WRITE  (NOUT,1140) UFM,MID
 1140 FORMAT (A23,', MATERIAL',I8,', SPECIFIED ON A PIHEX CARD, DOES ',
     1       'NOT REFERENCE THE PROPER MATERIAL TYPE', /5X,
     2       'CID = 0 MEANS MAT1, CID NOT 0 MEANS MAT6')
      GO TO 115
 1141 CONTINUE
C
C     STORE ALL CID,MID PAIRS WHERE CID IS NOT 0
C
      IF (ICID .EQ. 0) GO TO 10
      I = I + 1
      IZ(I) = ICID
      I = I + 1
      IZ(I) = MID
      GO TO 10
C
C     LIST IS MADE. MOVE IT UP TO IZ(1)
C
   40 CALL CLOSE (EPT,1)
      NCID = I - NMAT1 - NMAT6
      IF (NCID .EQ. 0) RETURN
C
      DO 41 II = 1,NCID
      JJ = NMAT1 + NMAT6 + II
      IZ(II) = IZ(JJ)
   41 CONTINUE
C
C     NOW MAKE A UNIQUE LIST OF CID-S
C
      IJK = NCID + 1
      NUM = 1
      IZ(IJK) = IZ(1)
      IF (NCID .EQ. 2) GO TO 44
      DO 43 II = 3,NCID,2
      ICID = IZ(II)
      DO 42 JJ = 1,NUM
      NCJJ = NCID + JJ
      IF (ICID .EQ. IZ(NCJJ)) GO TO 43
   42 CONTINUE
C
C     UNIQUE - LIST IT
C
      IJK = IJK + 1
      NUM = NUM + 1
      IF (IJK .GT. LCORE) GO TO 1008
      IZ(IJK) = ICID
   43 CONTINUE
C
C     UNIQUE LIST IS MADE- CHECK AGAINST CORD1R AND CORD2R ID-S
C
   44 ICORD = NCID + NUM + 1
C
      NCORD1 = 0
      NCORD2 = 0
      FILE   = GEOM1
      CALL PRELOC (*1001,Z(BUF1),GEOM1)
      CALL LOCATE (*70,Z(BUF1),IC1,IDX)
   45 IF (ICORD+12 .GT. LCORE) GO TO 1008
      CALL READ (*1002,*70,GEOM1,Z(ICORD),6,0,M)
C
C     COMPARE AGAINST CIDS ON PIHEX-S
C
      DO 50 JJ = 1,NUM
      J = NCID + JJ
      IF (IZ(ICORD) .EQ. IZ(J)) GO TO 60
   50 CONTINUE
      GO TO 45
C
C     MATCH- RESERVE 13 WORDS SINCE THIS CORD1R WILL BE CONVERTED TO
C     CORD2R TYPE ENTRY LATER
C
   60 IZ(J)  =-IZ(J)
      NCORD1 = NCORD1 + 1
      ICORD  = ICORD  + 13
      IF (NCORD1 .EQ. NUM) GO TO 120
      GO TO 45
C
C     TRY CORD2R
C
   70 CALL LOCATE (*100,Z(BUF1),IC2,IDX)
   75 IF (ICORD+12 .GT. LCORE) GO TO 1008
      CALL READ (*1002,*100,GEOM1,Z(ICORD),13,0,M)
C
C     COMPARE
C
      DO 80 JJ = 1,NUM
      J = NCID + JJ
      IF (IZ(ICORD) .EQ. IZ(J)) GO TO 90
   80 CONTINUE
      GO TO 75
C
C     MATCH ON CORD2R. CHECK FOR RID. MUST BE 0
C
   90 IF (IZ(ICORD+3) .NE. 0) GO TO 330
C
      IZ(J)  =-IZ(J)
      NCORD2 = NCORD2 + 1
      ICORD  = ICORD  + 13
      IF (NCORD1+NCORD2 .EQ. NUM) GO TO 120
      GO TO 75
C
C     EXHAUSTED CORD2R-S, BUT NOT ALL  CID-S ARE LOCATED
C
  100 DO 110 JJ = 1,NUM
      J = NCID + JJ
      IF (IZ(J) .LT. 0) GO TO 110
      WRITE  (NOUT,105) UFM,IZ(J)
  105 FORMAT (A23,', CID',I8,' ON A PIHEX CARD IS NOT DEFINED TO BE ',
     1       'CORD1R OR CORD2R')
  110 CONTINUE
  115 CALL MESAGE (-61,0,NAM)
C
C
C     MATCHING IS COMPLETE
C
  120 CALL CLOSE (GEOM1,1)
C
C     CID,MATID PAIRS ARE IN Z(1)-Z(NCID). UNIQUE CID LIST IS IN
C     Z(NCID+1)-Z(NCID+NUM). THERE ARE NCORD1 CORD1R-S AND NCORD2
C     CORD2R-S AT 13 WORDS EACH STARTING AT Z(NCID+NUM+1).
C     NEXT AVAILABLE OPEN CORE IS AT Z(ICORD)
C
      DO 130 JJ = 1,NUM
      J = NCID + JJ
  130 IZ(J) =-IZ(J)
C
C     FOR CID-S ON CORD1R WE MUST OBTAIN THE BASIC COORDINATES OF EACH
C     POINT FROM BGPDT. FIRST, THE EXTERNAL POINT NUMBERS ON CORD1R MUST
C     BE CONVERTED TO  INTERNAL.
C
      LCORE = LCORE - (ICORD-1)
      IF (LCORE .LE. 0) GO TO 1008
      MCORE  = LCORE
      IBGPDT = ICORD
      IF (NCORD1 .EQ. 0) GO TO 200
      CALL GOPEN (BGPDT,Z(BUF1),0)
      FILE = BGPDT
      CALL READ (*1002,*140,BGPDT,Z(IBGPDT),LCORE,0,M)
      GO TO 1008
  140 CALL CLOSE (BGPDT,1)
      IEQ   = IBGPDT + M
      LCORE = LCORE  - M
      CALL GOPEN (EQEXIN,Z(BUF1),0)
      FILE = EQEXIN
      CALL READ (*1002,*150,EQEXIN,Z(IEQ),LCORE,0,M)
      GO TO 1008
  150 CALL CLOSE (EQEXIN,1)
      LCORE = LCORE - M
C
C     FOR EACH CORD1R ENTRY, FIND THE BASIC COORDINATES FOR EACH POINT
C     AND FORM A CORD2R ENTRY BACK WHERE THE CORD1R IS STORED
C
      DO 190 J = 1,NCORD1
      IPOINT = 13*(J-1) + NCID + NUM
      ICID   = IZ(IPOINT+1)
      DO 170 K = 1,3
      ISUBK = IPOINT + 3 + K
      K3 = 3*(K-1)
      IGRID = IZ(ISUBK)
      CALL BISLOC (*350,IGRID,Z(IEQ),2,M/2,JP)
C
C     IM IS POINTER TO INTERNAL NUMBER. NOW FIND BGPDT ENTRY
C
      IM = IEQ + JP
      IP = 4*(IZ(IM)-1)
      DO 160 L = 1,3
      ISUBB = IBGPDT + IP + L
      ISUBL = K3 + L
      STORE(ISUBL) = Z(ISUBB)
  160 CONTINUE
  170 CONTINUE
C
C     WE HAVE THE BASIC COORDINATES OF THE 3 POINTS. STORE IT BACK INTO
C     THE CORD1R ENTRY. THE ENTRY STARTS AT Z(IPOINT+1)
C
      IP4 = IPOINT + 4
      IZ(IP4) = 0
      DO 180 L = 1,9
      ISUBL = IP4 + L
      Z(ISUBL) = STORE(L)
  180 CONTINUE
C
C     GO BACK FOR ANOTHER CORD1R
C
  190 CONTINUE
C
C     FOR EACH COORDINATE SYSTEM, COMPUTE THE 9 DIRECTION COSINES FROM
C     THE BASIC COORDINATE SYSTEM. Z(ICORD) IS THE NEXT AVAILABLE
C     LOCATION OF OPEN CORE SINCE WE NO LONGER NEED EQEXIN OR BGPDT
C     INFO.
C
  200 LCORE = MCORE
      CALL GOPEN (MPT,Z(BUF1),0)
      CALL GOPEN (MPTA,Z(BUF2),1)
      IF (ICORD+30 .GT. LCORE) GO TO 1008
C
C     COPY MPT TO MPTA UNTIL MAT6 IS REACHED
C
      FILE = MPT
  210 CALL READ (*280,*1003,MPT,Z(ICORD),3,0,M)
      CALL WRITE (MPTA,Z(ICORD),3,0)
      IF (IZ(ICORD) .EQ. IMAT6(1)) GO TO 240
  220 CALL READ (*1002,*230,MPT,Z(ICORD),LCORE,0,M)
      CALL WRITE (MPTA,Z(ICORD),LCORE,0)
      GO TO 220
  230 CALL WRITE (MPTA,Z(ICORD),M,1)
      GO TO 210
C
C     MAT6 RECORD FOUND. EACH MAT6 CONTAINS 31 WORDS. INCREASE THAT
C     TO 40
C
  240 CALL READ (*1002,*270,MPT,Z(ICORD),31,0,M)
C
C     SEE IF THIS ID MATCHES A CID ON PIHEX) IT NEED NOT
C
      DO 250 J = 2,NCID,2
      IF (IZ(J) .EQ. IZ(ICORD)) GO TO 258
  250 CONTINUE
C
C     NO MATCH. MAT6 NOT REFERENCED BY PIHEX. COPY IT TO MAT6 AND FILL
C     IN ALL 3 DIRECTION COSINES. THIS MAT6 IS NOT REFERENCED BY PIHEX
C
      DO 255 K = 1,9
  255 XD(K) = 0.
      GO TO 265
C
C     MATCH. NOW FIND IT IN CORD1R,CORD2R LIST
C
  258 ICID = IZ(J-1)
      DO 259 II = 1,NUM
      IPOINT = NCID + NUM + 13*(II-1)
      IF (ICID .EQ. IZ(IPOINT+1)) GO TO 260
  259 CONTINUE
C
C     LOGIC ERROR
C
      GO TO 370
C
  260 IZ(IPOINT+1) = -IZ(IPOINT+1)
      A(1) = Z(IPOINT+ 5)
      A(2) = Z(IPOINT+ 6)
      A(3) = Z(IPOINT+ 7)
      B(1) = Z(IPOINT+ 8)
      B(2) = Z(IPOINT+ 9)
      B(3) = Z(IPOINT+10)
      C(1) = Z(IPOINT+11)
      C(2) = Z(IPOINT+12)
      C(3) = Z(IPOINT+13)
C
C     ZP AXIS IS B-A. YP IS ZP X (C-A). XP IS YP X ZP
C
      ZP(1) = B(1) - A(1)
      ZP(2) = B(2) - A(2)
      ZP(3) = B(3) - A(3)
      STORE(1) = C(1) - A(1)
      STORE(2) = C(2) - A(2)
      STORE(3) = C(3) - A(3)
      YP(1) = ZP(2)*STORE(3) - ZP(3)*STORE(2)
      YP(2) = ZP(3)*STORE(1) - ZP(1)*STORE(3)
      YP(3) = ZP(1)*STORE(2) - ZP(2)*STORE(1)
      XP(1) = YP(2)*ZP(3) - YP(3)*ZP(2)
      XP(2) = YP(3)*ZP(1) - YP(1)*ZP(3)
      XP(3) = YP(1)*ZP(2) - YP(2)*ZP(1)
C
C     NOW COMPUTE DIRECTION COSINES BETWEEN XP,YP, ZP AND BASIC X,Y,Z
C     X=(1,0,0),Y=(0,1,0),Z=(0,0,1)
C     COS(THETA)=(DP.D)/(LENGTH OF DP)*(LENGTH OF D) WHERE DP=XP,YP,OR
C     ZP   AND D=X,Y,OR Z. LENGTH OF D=1
C
      DL    = SQRT(XP(1)**2 + XP(2)**2 + XP(3)**2)
      XD(1) = XP(1)/DL
      XD(2) = XP(2)/DL
      XD(3) = XP(3)/DL
      DL    = SQRT(YP(1)**2 + YP(2)**2 + YP(3)**2)
      XD(4) = YP(1)/DL
      XD(5) = YP(2)/DL
      XD(6) = YP(3)/DL
      DL    = SQRT(ZP(1)**2 + ZP(2)**2 + ZP(3)**2)
      XD(7) = ZP(1)/DL
      XD(8) = ZP(2)/DL
      XD(9) = ZP(3)/DL
C
C     WRITE OUT NEW MAT6 RECORD WITH DIRECTION COSINES APPENDED
C
  265 CALL WRITE (MPTA,Z(ICORD),31,0)
      CALL WRITE (MPTA,XD,9,0)
C
C     GET ANOTHER MAT6
C
      GO TO 240
C
C     MAT6 RECORD FINISHED. WRITE EOR, COPY REMAINDER OF MPT, AND CHECK
C     TO SEE THAT ALL PIHEX CID-S HAVE BEEN ACCOUNTED FOR.
C
  270 CALL WRITE (MPTA,0,0,1)
      GO TO 210
C
C     MPT EXHAUSTED
C
  280 CALL CLOSE (MPT,1)
      CALL CLOSE (MPTA,1)
      ITRL(1) = MPT
      CALL RDTRL (ITRL)
      ITRL(1) = MPTA
      CALL WRTTRL (ITRL)
      ISOP = -1
  285 RETURN
C
CWKBDB 5/94 SPR 93033
C  310 WRITE  (NOUT,320) UWM
C  320 FORMAT (A25,', EITHER EPT IS PURGED OR NO PIHEX CARDS FOUND ON ',
C     1       'EPT IN ANISOP')
CWKBDE 5/94 SPR 93033
CWKBI  SPR 93033 5/94
  310 CALL CLOSE ( EPT, 1 )
      GO TO 285
  330 WRITE  (NOUT,340) UFM,IZ(J)
  340 FORMAT (A23,', CORD2R',I8,' DEFINES A PIHEX CID BUT HAS NONZERO',
     1       ' RID')
      GO TO 115
  350 WRITE  (NOUT,360) UFM,IGRID
  360 FORMAT (A23,', EXTERNAL GRID',I8,' CANNOT BE FOUND ON EQEXIN IN ',
     1       'ANISOP')
      GO TO 115
  370 WRITE  (NOUT,380) UFM
  380 FORMAT (A23,', NON-UNIQUE COORDINATE SYSTEMS ON PIHEX CARDS', /5X,
     1       '(SEE USER MANUAL P.2.4-233(05/30/86))')
      GO TO 115
C
CWKBDB SPR93033 5/94
C 1001 N = -1
C      GO TO 1010
CWKBDE SPR93033 5/94
CWKBIB SPR93033 5/94
 1001 CALL CLOSE ( MPT, 1 )
      CALL CLOSE ( GEOM1, 1 )
      GO TO 285
CWKBIE SPR93033 5/94
 1002 N = -2
      GO TO 1010
 1003 N = -3
      GO TO 1010
 1008 FILE = 0
      N = -8
 1010 CALL MESAGE (N,FILE,NAM)
      RETURN
      END

      SUBROUTINE BGRID
C
C     THIS ROUTINE COMPUTES PROBLEM SIZE, INTEGER PACKING FACTOR, AND
C     MAXGRD AND MAXDEG CONSTANTS.
C     THIS ROUTINE IS USED ONLY IN BANDIT MODULE
C
      EXTERNAL        ANDF
      INTEGER         GRID(2),  SEQGP,    GEOM1,    TWO,      ANDF,
     1                GEOM2,    GEOM4,    SCR1,     REW,      SUB(2),
     2                ITRL(8)
      CHARACTER       UFM*23,   UWM*25,   UIM*29
      COMMON /XMSSG / UFM,      UWM,      UIM
      COMMON /MACHIN/ MACHX
      COMMON /BANDA / IBUF1,    NOMPC,    NODEP,    NOPCH,    NORUN,
     1                METHOD,   ICRIT,    NGPTS(2)
      COMMON /BANDB / NBITIN,   KOR,      DUM,      NGRID,    IPASS,
     1                NW,       KDIM,     NBPW,     IREPT
      COMMON /BANDD / IDUM5D(5),NZERO,    NEL,      NEQ,      NEQR
      COMMON /BANDS / NN,       MM,       DUM2S(2), MAXGRD,   MAXDEG,
     1                KMOD,     MACH,     MINDEG,   NEDGE,    MASK
      COMMON /BANDW / DUM4W(4), I77
      COMMON /GEOMX / GEOM1,    GEOM2,    GEOM4,    SCR1
      COMMON /SYSTEM/ ISYS(100)
      COMMON /TWO   / TWO(1)
      COMMON /NAMES / RDUM(4),  REW,      NOREW
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE     (NOUT,ISYS(2))
      DATA            IGEOM1,   IGEOM2,   IGEOM4,   ISCR1   /
     1                201,      208,      210,      301     /
      DATA            KDIMX,    NELX,     NEQX,     NEQRX   /
     1                150,      0,        0,        0       /
      DATA            GRID,     SEQGP,    SUB               /
     1                4501,45,  53,       4HBGRI,4HD        /
C
      IF (IREPT .EQ. 2) GO TO 100
      GEOM1 = IGEOM1
      GEOM2 = IGEOM2
      GEOM4 = IGEOM4
      SCR1  = ISCR1
      NEL   = NELX
      NEQ   = NEQX
      NEQR  = NEQRX
      NGRID = 0
C
C     BANDIT QUITS IF DMI CARDS ARE PRESENT. (CHK WAS DONE IN IFS2P)
C     RE-SET PROGRAM PARAMETERS IF USER REQUESTED VIA NASTRAN CARD.
C
      K = ISYS(I77)
      IF (K) 250,30,10
   10 IF (K .EQ. +9) GO TO 230
      DO 20 I = 1,7
      ITRL(I) = MOD(K,10)
      K = K/10
   20 CONTINUE
      IF (ITRL(1).GT.0 .AND. ITRL(1).LE.4) ICRIT  = ITRL(1)
      IF (ITRL(2).GT.0 .AND. ITRL(2).LE.3) METHOD = ITRL(2) - 2
      NOMPC = ITRL(3)
      IF (ITRL(4) .EQ. 1) NODEP = -NODEP
      IF (ITRL(5) .EQ. 1) NOPCH = -NOPCH
      IF (ITRL(5) .EQ. 9) NOPCH = +9
      IF (ITRL(6) .EQ. 1) NORUN = -NORUN
      IF (ITRL(7).GE.2 .AND. ITRL(7).LE.9) KDIM = ITRL(7)
C
   30 IF (NORUN .EQ. +1) GO TO 40
C
C     OPEN GEOM1 FILE AND CHECK THE PRESENCE OF ANY SEQGP CARD.  IF
C     ONE OR MORE IS PRESENT, ABORT BANDIT JOB.  OTHERWISE CONTINUE TO
C     COUNT HOW MANY GRID POINTS IN THE PROBLEM.
C     RESET GEOM1 TO THE BEGINNING OF GRID DATA FOR BSEQGP, AND CLOSE
C     GEOM1 WITHOUT REWINDING THE FILE
C
C     COMMENT FROM G.CHAN/SPERRY
C     IF TIME AND $ ALLOW, WE SHOULD MAKE USE OF THE SORTED GRID DATA
C     FROM GEOM1 FILE AND GET RID OF INV, INT, NORIG, ILD ARRAYS LATER.
C     THE SCATTERING TECHNEQUE (REALLY A HASHING METHOD) CAN BE REPLACED
C     BY A SIMPLE BINARY SEARCH. ROUTINES SCAT, BRIGIT, AND INTERN
C     COULD BE ELIMINATED.
C
      ITRL(1) = GEOM1
      CALL RDTRL (ITRL)
      J  = ITRL(2) + ITRL(3) + ITRL(4) + ITRL(5) + ITRL(6) + ITRL(7)
      IF (ITRL(1).LT.0 .OR. J.EQ.0) GO TO 250
      K  = SEQGP
      K1 = (K-1)/16
      K2 = K - 16*K1
      K  = ANDF(ITRL(K1+2),TWO(K2+16))
      IF (K .NE. 0) GO TO 210
C
C     WE ASSUME THAT THE GRID POINT DATA IN GEOM1 AT THIS TIME IS NOT
C     SORTED. IF IT IS, WE CAN BLAST READ THE GRID POINT RECORD AND
C     TAKE THE LAST GRID POINT TO BE THE LARGEST GRID EXTERNAL NUMBER.
C
   40 CALL PRELOC (*170,Z(IBUF1),GEOM1)
      CALL LOCATE (*70,Z(IBUF1),GRID,K)
      MAX = 0
   50 CALL READ (*60,*60,GEOM1,ITRL,8,0,K)
      NGRID = NGRID + 1
      IF (ITRL(1) .GT. MAX) MAX = ITRL(1)
      GO TO 50
   60 CALL BCKREC (GEOM1)
   70 CALL CLOSE (GEOM1,NOREW)
C
C     IF SPOINTS ARE PRESENT, ADD THEM TO THE GRID COUNT
C
      N = 0
      CALL PRELOC (*90,Z(IBUF1),GEOM2)
      NGPTS(1) = 5551
      NGPTS(2) = 49
      CALL LOCATE (*80,Z(IBUF1),NGPTS,K)
      CALL READ (*80,*80,GEOM2,Z(1),IBUF1,1,N)
   80 CALL CLOSE (GEOM2,REW)
   90 NGPTS(1) = NGRID
      NGPTS(2) = N
      NGRID = NGRID + N
C
      IF (NOPCH.EQ.9 .AND. NGRID.EQ.1) NGRID = MAX
  100 IF (NGRID .LE.  0) GO TO 180
      IF (NGRID .LT. 15) GO TO 160
C
C     SET WORD PACKING CONSTANT, NW - (NUMBER OF INTEGERS PER WORD)
C     MACHX =  1 DUMMY,   =  2 IBM 360/370, =  3 UNIVAC 1100, =  4 CDC,
C           =  5 VAX 780, =  6 DEC ULTRIX,  =  7 SUN,         =  8 AIX,
C           =  9 HP,      = 10 SILIC.GRAPH  = 11 MAC,         = 12 CRAY,
C           = 13 CONVEX,  = 14 NEC          = 15 FUJITSU,     = 16 DG,
C           = 17 AMDAHL   = 18 PRIME        = 19 486,         = 20 DUMMY
C           = 21 ALPHA    = 22 RESERVED
C
      GO TO (130,120,130,110,120,120,120,120,120,120,
     1       120,135,120,110,110,120,120,120,120,120,
     2       120,120), MACHX
  110 NW = 6
      IF (NGRID .GT.   510) NW = 5
      IF (NGRID .GT.  2045) NW = 4
      IF (NGRID .GT. 16380) NW = 3
      IF (NGRID .GT.524288) NW = 2
      GO TO 140
  120 NW = 2
      GO TO 140
  130 NW = 4
      IF (NGRID .GT. 508) NW = 3
      IF (NGRID .GT.4095) NW = 2
      GO TO 140
  135 NW = 8
      IF (NGRID.GT.255) NW = 4
C
  140 NBITIN = NBPW/NW
      MASK   = 2**NBITIN - 1
C
C     KDIM IS THE ARRAY DIMENSNION OF A SCRATCH ARRAY USED ONLY BY GPS
C     METHOD. IT IS 150 WORDS OR 10% OF TOTAL GRID POINT NUMBER. IF
C     USER SPECIFIED BANDTDIM = N, (WHERE N IS FROM 1 THRU 9), THE ARRAY
C     DIMENSION WILL BE N*10 PERCENT INSTEAD OF THE DEFAULT OF 10%.
C
      KDIM = NGRID*KDIM/10
      IF (METHOD .NE. -1) KDIM = MAX0(KDIM,KDIMX,NGRID/10)
      IF (METHOD .EQ. -1) KDIM = MIN0(KDIM,KDIMX,NGRID/10)
      N = NGRID
      IF (N .LT. 10) N = 10
C
C     CALCULATE WIDTH MAXDEG AND EFFECTIVE LENGTH MAXGRD OF IG MATRIX.
C
      MAXGRD = N
      KORE   = KOR
  150 MAXDEG = ((((KORE-4*KDIM-8*MAXGRD-5)*NW)/(MAXGRD+NW))/NW)*NW
      MAXDEG = MIN0(MAXDEG,MAXGRD-1)
      IF (MAXDEG .LE. 0) GO TO 200
      J      = MAXDEG*2.2
      KORE   = KORE - J
      IF (KOR-J .EQ. KORE) GO TO 150
C
C     INITIALIZE VARIABLES
C
      NN     = 0
      MM     = 0
      NEDGE  = 0
      IPASS  = 0
      KMOD   = 2*MAXGRD - IFIX(2.3715*SQRT(FLOAT(MAXGRD)))
      MINDEG = 500000
      RETURN
C
C     ERROR OR QUIT
C
  160 WRITE  (NOUT,280) UIM
      WRITE  (NOUT,270)
      GO TO  250
  170 CALL MESAGE (-1,GEOM1,SUB)
  180 WRITE  (NOUT,280) UIM
      WRITE  (NOUT,190)
  190 FORMAT (5X,25HTHE ABSENCE OF GRID CARDS)
      CALL CLOSE (GEOM1,REW)
      GO TO  250
  200 CALL MESAGE (-8,0,SUB)
  210 WRITE  (NOUT,280) UIM
      WRITE  (NOUT,220)
  220 FORMAT (5X,27HTHE PRESENCE OF SEQGP CARDS)
      GO TO  250
  230 WRITE  (NOUT,280) UIM
      WRITE  (NOUT,240)
  240 FORMAT (5X,25HTHE PRESENCE OF DMI CARDS)
  250 ISYS(I77) = 0
      IF (NOPCH .GT. 0) ISYS(I77) = -2
      IF (ISYS(I77) .NE. -2) WRITE (NOUT,260)
  260 FORMAT (1H0,10X,'**NO ERRORS FOUND - EXECUTE NASTRAN PROGRAM**')
  270 FORMAT (5X,'SMALL PROBLEM SIZE')
  280 FORMAT (A29,' -  GRID-POINT RESEQUENCING PROCESSOR BANDIT IS ',
     1       'NOT USED DUE TO')
      RETURN
      END

      SUBROUTINE XYTICS (IOUT,OUT,NDEVIS,R1,R2,ISKIP,LOG,IFLAG)
C
C     THIS SUBROUTINE PERFORMS ONLY TIC COMPUTATIONS FOR XYDUMP.
C
      INTEGER IOUT(8)
      REAL    OUT(8),LENGTH
C
      IF (LOG .NE. 0) GO TO 70
      IF (R1 .EQ. R2) R2 = R1 + 1.0
      DIV = NDEVIS
      IF (DIV .LE. 0.0) DIV = 5.0
      LENGTH = R2 - R1
      IF (IFLAG  .NE. 0  ) DIV = LENGTH
      IF (LENGTH .LE. 0.0) GO TO 50
      FINC = 1.0001*LENGTH/DIV
C
C     CONVERT FINC TO SCIENTIFIC AND ROUND OFF TO 1 DIGIT (1 TO 10)
C
      IPOWER = 0
      IF (FINC .LT.  1.0) GO TO 20
   10 IF (FINC .LT. 10.0) GO TO 30
      IPOWER = IPOWER + 1
      FINC   = FINC/10.0
      GO TO 10
   20 IPOWER = IPOWER - 1
      FINC = FINC*10.0
      IF (FINC .LT. 1.0) GO TO 20
   30 IINC = 10
      IF (FINC .LT. 7.5) IINC = 5
      IF (FINC .LT. 3.5) IINC = 2
      IF (FINC .LT. 1.5) IINC = 1
C
C     ACTUAL INCREMENT
C
      FINC = FLOAT(IINC)*10.0**IPOWER
C
C     COMPUTE FIRST DIVISION POINT
C
      NFIRST = R1*10.0**(-IPOWER) + SIGN(0.555,R1)
C
C     GUARANTEE THAT TICKS WILL STEP THROUGH ZERO
C
      NTEMP  = NFIRST/IINC
      NFIRST = NTEMP*IINC
      FIRST  = FLOAT(NFIRST)*10.0**(IPOWER)
C
C     GET LOWEST VALUE OF FRAME
C
      IF (FIRST .LE. R1) GO TO 35
C
C     CHECK ABAINST EPSILON DIFFERENCE.  SENSITIVE TO TRUNCATION
C
      LENGTH = FINC*1.0E-4
      IF (FIRST-R1 .LT. LENGTH) FIRST = FIRST - LENGTH
      IF (FIRST-R1 .GE. LENGTH) FIRST = FIRST - FINC
      NFIRST = FIRST*10.0**(-IPOWER) + SIGN(0.5,R1)
   35 ITICS  = (R2-FIRST)/FINC + 1.5
      TEMP   = FLOAT(ITICS-1)*FINC + FIRST
      ENDV   = TEMP
      IF (ENDV .GE. R2) GO TO 37
      LENGTH = FINC*2.0E-4
      IF (ENDV+LENGTH .GE. R2)  ENDV = ENDV + LENGTH
      IF (ENDV+LENGTH .LT. R2)  ENDV = ENDV + FINC
      ITICS = (ENDV-FIRST)/FINC + 0.5
      TEMP  = FLOAT(ITICS-1)*FINC + FIRST
   37 CONTINUE
      IF (ENDV-TEMP .LT. FINC/4.0) ITICS = ITICS - 1
C
C     FIND MAXIMUM NUMBER OF DIGITS
C
      LAST   = NFIRST + IINC*ITICS
      LAST   = MAX0(IABS(LAST),IABS(NFIRST))
      MAXDIG = 1
   40 IF (LAST .LT. 10) GO TO 60
      MAXDIG = MAXDIG + 1
      LAST   = LAST/10
      GO TO 40
C
C     LENGTH = 0
C
   50 ITICS   = 0
   60 OUT(1)  = FIRST
      OUT(2)  = FINC
      OUT(3)  = ENDV
      IOUT(4) = MAXDIG
      IOUT(5) = IPOWER
      IOUT(6) = ITICS
      IOUT(7) = ISKIP
      RETURN
C
C     LOG SCALE - INITIAL LABELING CALCULATED
C
   70 FIRST  = R1
      ITICS  = LOG
      ENDV   = R2
      FINC   = 10.0
      MAXDIG = 1
      IPOWER = 0
      GO TO 60
C
      END

      SUBROUTINE ALGAN
C
      REAL            IX,IY,IXY,IPX,IPY,IXN,IYN,IXYN,IXD,IYD
      DIMENSION       RLES(21),TCS(21),TES(21),ZZS(21),PERSPT(21),
     1                ALPB(10,21),BLOCK(10,21),EPSLON(10,21),CCORD(21),
     2                YS(21,70),YP(21,70),XP(21,70),XS(21,70),ZS(21,70),
     3                ZQ(21),TQ(21),BLAFOR(10,21),XCAMB(21,10),
     4                THARR(21,10),TITLE(18),IDATA(24),RDATA(6)
      COMMON /SYSTEM/ KSYSTM(90),LPUNCH
      COMMON /UD3PRT/ IPRTC,ISTRML,IPGEOM
      COMMON /UDSTR2/ NBLDES,STAG(21),CHORDD(21)
      COMMON /CONTRL/ NANAL,NAERO,NARBIT,LOG1,LOG2,LOG3,LOG4,LOG5,LOG6
      COMMON /UD3ANC/ EPZ(80,4),R(10,21),ZOUT(21),SS(100),X(100),
     1                YPRIME(100),YSEMI(21,31),XSEMI(21,31),ZP(21,70),
     2                ZSEMI(21,31),TITLE2(18),XHERE(10),XTEMP(100),
     3                RAD(100),TEMP1(21),TEMP2(21),TEMP3(21),TEMP4(21),
     4                ZR(21),B1(21),B2(21),PP(21),QQ(21),ZZ(21),RLE(21),
     5                TC(21),TE(21),CORD(21),DELX(21),DELY(21),S(21),
     6                BS(21),XSEMJ(21,31),YSEMJ(21,31),ZSEMJ(21,31),
     7                XSTA(21,10),RSTA(21,10),KPTS(21),SIGMA(100),
     8                TANPHI(10,21),ZCAMB(21,10),YCAMB(21,10),
     9                IFANGS(10),THETA(21,10),ALPHA(21,10)
      EQUIVALENCE     (TITLE(1),TITLE2(1))
C
      PI = 4.0*ATAN(1.0)
      C1 = 180.0/PI
      CALL FREAD (LOG1,TITLE2,18,1)
      IF (IPRTC .EQ. 1) WRITE (LOG2,120) TITLE2
 120  FORMAT (1H1,31X,'PROGRAM ALG - COMPRESSOR DESIGN - ANALYTIC MEAN',
     1       'LINE BLADE SECTION', /32X,65(1H*), //10X,5HTITLE,25X,1H=,
     2       18A4)
      CALL FREAD (LOG1,IDATA,17,1)
      NLINES = IDATA(1)
      NSTNS  = IDATA(2)
      NZ     = IDATA(3)
      NSPEC  = IDATA(4)
      NPOINT = IDATA(5)
      NBLADE = IDATA(6)
      ISTAK  = IDATA(7)
      IPUNCH = IDATA(8)
      ISECN  = IDATA(9)
      IFCORD = IDATA(10)
      IFPLOT = IDATA(11)
      IPRINT = IDATA(12)
      ISPLIT = IDATA(13)
      INAST  = IDATA(14)
      IRLE   = IDATA(15)
      IRTE   = IDATA(16)
      NSIGN  = IDATA(17)
      NBLDES = NBLADE
      IF (IPRTC .EQ. 0) IPRINT = 3
      IF (INAST.EQ.0 .AND. IPGEOM.NE.-1) INAST = -4
      IF (IPRTC .EQ. 1) WRITE (LOG2,140) NLINES,NSTNS,NZ,NSPEC,NPOINT,
     1    NBLADE,ISTAK,IPUNCH,ISECN,IFCORD,IFPLOT,IPRINT,ISPLIT,INAST,
     2    IRLE,IRTE,NSIGN
 140  FORMAT (10X,24HNUMBER OF STREAMSURFACES,6X,1H=,I3, /10X,18HNUMBER
     1OF STATIONS,12X,1H=,I3, /10X,27HNUMBER OF CONSTANT-Z PLANES,3X,1H=
     2,I3, /10X,27HNUMBER OF BLADE DATA POINTS,3X,1H=,I3, /10X,31HNUMBER
     3 OF POINTS ON SURFACES  =,I3, /10X,29HNUMBER OF BLADES IN BLADE RO
     4W,1X,1H=,I3, /10X,5HISTAK,25X,1H=,I3, /10X,6HIPUNCH,24X,1H=,I3, /1
     50X,5HISECN,25X,1H=,I3,/,10X,6HIFCORD,24X,1H=,I3, /10X,6HIFPLOT,24X
     6,1H=,I3, /10X,6HIPRINT,24X,1H=,I3, /10X,6HISPLIT,24X,1H=,I3, /10X,
     75HINAST,25X,1H=,I3, /10X,4HIRLE,26X,1H=,I3, /10X,4HIRTE,26X,1H=,I3
     8, /10X,5HNSIGN,25X,1H=,I3)
      CALL FREAD (LOG1,RDATA,5,1)
      ZINNER = RDATA(1)
      ZOUTER = RDATA(2)
      SCALE  = RDATA(3)
      STACKX = RDATA(4)
      PLTSZE = RDATA(5)
      IF (IPRTC .EQ. 1) WRITE (LOG2,160) ZINNER,ZOUTER,SCALE,STACKX,
     1                                   PLTSZE
 160  FORMAT (/10X,6HZINNER,24X,1H=,F8.4, /10X,6HZOUTER,24X,1H=,F8.4, /
     110X,5HSCALE,25X,1H=,F8.4, /10X,6HSTACKX,24X,1H=,F8.4, /10X,6HPLTSZ
     2E,24X,1H=,F8.4, //20X,36HSTREAMSURFACE GEOMETRY SPECIFICATION)
      LNCT = 30
      DO 300 I = 1,NSTNS
      CALL FREAD (LOG1,IDATA,2,1)
      KPTS(I)   = IDATA(1)
      IFANGS(I) = IDATA(2)
      KPT = KPTS(I)
      DO 165 K = 1,KPT
      CALL FREAD (LOG1,RDATA,2,1)
      XSTA(K,I) = RDATA(1)
 165  RSTA(K,I) = RDATA(2)
      IF (KPTS(I) .GE. 2) GO TO 170
      KPTS(I) = 2
      XSTA(2,I) = XSTA(1,I)
      RSTA(2,I) = RSTA(1,I) + 1.0
 170  DO 180 J = 1,NLINES
      CALL FREAD (LOG1,RDATA,2,1)
      R(I,J)      = RDATA(1)
 180  BLAFOR(I,J) = RDATA(2)
      IDUM = KPTS(I)
      IF (NLINES .GT. IDUM) IDUM = NLINES
      IF (LNCT .LE. 54-IDUM) GO TO 210
      IF (IPRTC .NE. 0) WRITE (LOG2,200)
 200  FORMAT (1H1)
      LNCT = 2
 210  LNCT = LNCT + IDUM + 7
      IF (INAST .NE. 0) GO TO 240
      IF (IPRTC .EQ. 1)  WRITE (LOG2,220) I,KPTS(I),I,IFANGS(I)
 220  FORMAT (/10X,'COMPUTING STATION',I3,5X,'NUMBER OF DESCRIBING ',
     1        'POINTS=',I3,6X,7HIFANGS(,I2,2H)=,I3, //6X,'DESCRIPTION',
     2        9X,'STREAMLINE',5X,5HRADII,/6X,1HX,9X,1HR,11X,6HNUMBER,//)
      DO 230 K = 1,IDUM
      IF (IPRTC.EQ.1 .AND. K.LE.KPTS(I).AND.K.LE.NLINES)
     1    WRITE (LOG2,260) XSTA(K,I),RSTA(K,I),K,R(I,K)
      IF (IPRTC.EQ.1 .AND. K.LE.KPTS(I).AND.K.GT.NLINES)
     1    WRITE (LOG2,270) XSTA(K,I),RSTA(K,I)
      IF (IPRTC.EQ.1 .AND. K.GT.KPTS(I).AND.K.LE.NLINES)
     1    WRITE (LOG2,280) K,R(I,K)
 230  CONTINUE
      IF (INAST .EQ. 0) GO TO 300
 240  IF (IPRTC .EQ. 1) WRITE (LOG2,290) I,KPTS(I),I,IFANGS(I)
      DO 250 K = 1,IDUM
      IF (IPRTC.EQ.1 .AND. K.LE.KPTS(I).AND.K.LE.NLINES)
     1    WRITE (LOG2,260) XSTA(K,I),RSTA(K,I),K,R(I,K),BLAFOR(I,K)
      IF (IPRTC.EQ.1 .AND. K.LE.KPTS(I).AND.K.GT.NLINES)
     1    WRITE (LOG2,270) XSTA(K,I),RSTA(K,I)
      IF (IPRTC.EQ.1 .AND. K.GT.KPTS(I).AND.K.LE.NLINES)
     1    WRITE (LOG2,280) K,R(I,K),BLAFOR(I,K)
 250  CONTINUE
 260  FORMAT (3X,F8.4,2X,F8.4,8X,I2,9X,F8.4,9X,F8.4)
 270  FORMAT (3X,F8.4,2X,F8.4)
 280  FORMAT (29X,I2,9X,F8.4,9X,F8.4)
 290  FORMAT (/10X,'COMPUTING STATION',I3,5X,'NUMBER OF DESCRIBING ',
     1       'POINTS=',I3,6X,7HIFANGS(,I2,2H)=,I3, //6X,'DESCRIPTION',
     2       9X,'STREAMLINE',5X,5HRADII,9X,'DELTA PRESSURE', /6X,1HX,
     3       9X,1HR,11X,6HNUMBER, //)
 300  CONTINUE
      SQ = 0.0
      SB = 0.0
      IF (ISECN.EQ.1 .OR. ISECN.EQ.3) GO TO 340
      DO 305 ISBS = 1,NSPEC
      S(ISBS)  = 0.0
 305  BS(ISBS) = 0.0
      IF (LNCT .LE. 54-NSPEC) GO TO 310
      IF (IPRTC .NE. 0) WRITE (LOG2,200)
      LNCT = 1
 310  LNCT = LNCT + NSPEC + 6
      DO 315 J = 1,NSPEC
      CALL FREAD (LOG1,RDATA,6,1)
      ZR(J)  = RDATA(1)
      B1(J)  = RDATA(2)
      B2(J)  = RDATA(3)
      PP(J)  = RDATA(4)
      QQ(J)  = RDATA(5)
      RLE(J) = RDATA(6)
      CALL FREAD (LOG1,RDATA,6,1)
      TC(J)   = RDATA(1)
      TE(J)   = RDATA(2)
      ZZ(J)   = RDATA(3)
      CORD(J) = RDATA(4)
      DELX(J) = RDATA(5)
 315  DELY(J) = RDATA(6)
      IF (IPRTC .EQ. 1) WRITE (LOG2,330) (ZR(J),B1(J),B2(J),PP(J),QQ(J),
     1    RLE(J),TC(J),TE(J),ZZ(J),CORD(J),DELX(J),DELY(J),J=1,NSPEC)
 330  FORMAT (/20X,'SECTION GEOMETRY SPECIFICATION', //10X,'STREAMLINE',
     1       '  INLET',5X,6HOUTLET,4X,6HY2 LE/,4X,6HY2 TE/,3X,48HLE RADI
     2US MAX THICK TE THICK  POINT OF  CHORD OR,3X,7HX STACK,3X,7HY STAC
     3K, /11X,6HNUMBER,5X,5HANGLE,5X,5HANGLE,3X,19HMAX VALUE MAX VALUE,3
     4X,6H/CHORD,4X,6H/CHORD,3X,8H/2*CHORD,2X,18HMAX THICK AXIAL CD,4X,6
     5HOFFSET,4X,6HOFFSET, //,(10X,F7.2,3X,F8.3,F10.3,2F10.4,3F10.5,
     62F10.4,F11.6,F10.6))
      GO TO 390
 340  IF (LNCT .LE. 50-2*NSPEC) GO TO 350
      IF (IPRTC .NE. 0) WRITE (LOG2,200)
      LNCT = 1
 350  LNCT = LNCT + 10 + 2*NSPEC
      DO 360 J = 1,NSPEC
      CALL FREAD (LOG1,RDATA,6,1)
      ZR(J)  = RDATA(1)
      B1(J)  = RDATA(2)
      B2(J)  = RDATA(3)
      PP(J)  = RDATA(4)
      QQ(J)  = RDATA(5)
      RLE(J) = RDATA(6)
      CALL FREAD (LOG1,RDATA,6,1)
      TC(J)   = RDATA(1)
      TE(J)   = RDATA(2)
      ZZ(J)   = RDATA(3)
      CORD(J) = RDATA(4)
      DELX(J) = RDATA(5)
      DELY(J) = RDATA(6)
      CALL FREAD (LOG1,RDATA,2,1)
      S(J)  = RDATA(1)
 360  BS(J) = RDATA(2)
      IF (IPRTC .EQ. 1) WRITE (LOG2,330) (ZR(J),B1(J),B2(J),PP(J),QQ(J),
     1    RLE(J),TC(J),TE(J),ZZ(J),CORD(J),DELX(J),DELY(J),J=1,NSPEC)
      IF (IPRTC.EQ.1 .AND. ISECN.EQ.1) WRITE (LOG2,370) (ZR(J),S(J),
     1    BS(J),J=1,NSPEC)
 370  FORMAT (/10X,'STREAMLINE  INFLECTION  INFLECTION', /11X,'NUMBER',
     1       8X,5HPOINT,7X,5HANGLE, //,(10X,F7.2,F14.5,F11.3))
      IF (IPRTC.EQ.1 .AND. ISECN.EQ.3) WRITE (LOG2,380) (ZR(J),S(J),
     1    BS(J),J=1,NSPEC)
 380  FORMAT (/10X,'STREAMLINE  TRANSITION  DEL ANGLE', /11X,'NUMBER',
     1       8X,5HPOINT,6X,7HFROM LE, //,(10X,F7.2,F14.5,F11.3))
 390  IF (ISPLIT .EQ. 0) GO TO 430
      DO 400 J = 1,NSPEC
      CALL FREAD (LOG1,RDATA,5,1)
      RLES(J)   = RDATA(1)
      TCS(J)    = RDATA(2)
      TES(J)    = RDATA(3)
      ZZS(J)    = RDATA(4)
 400  PERSPT(J) = RDATA(5)
      IF (IPRTC .EQ. 1) WRITE (LOG2,410)
 410  FORMAT (/20X,13HSPLITTER DATA, //10X,10HSTREAMLINE,2X,47HLE RADIUS
     1 MAX THICK TE THICK  POINT OF PER CENT, /11X,6HNUMBER,7X,6H/CHORD,
     2 4X,6H/CHORD,3X,8H/2*CHORD,2X,9HMAX THICK,2X,8HSPLITTER, /)
      IF (IPRTC .EQ. 1) WRITE (LOG2,420) (ZR(J),RLES(J),TCS(J),TES(J),
     1    ZZS(J),PERSPT(J),J=1,NSPEC)
 420  FORMAT (10X,F7.2,3X,F8.3,F10.3,3F10.4)
 430  CONTINUE
      IF (IFPLOT.EQ.0 .OR. IFPLOT.EQ.4) GO TO 440
      IKDUM = 0
      IF (B1(1) .LT. 0.0) IKDUM = 1
      IF (IFPLOT.EQ.1 .OR. IFPLOT.EQ.3) CALL ALG17 (ISTAK,PLTSZE,1,
     1    TITLE,IKDUM,IFPLOT)
 440  NDUM  = NPOINT
      IIDUM = ISECN
      DO 870 J = 1,NLINES
      NPOINT = NDUM
      ISECN  = IIDUM
      DO 450 I = 1,NSTNS
      KPT = KPTS(I)
 450  CALL ALG15 (RSTA(1,I),XSTA(1,I),KPT,R(I,J),XHERE(I),1,0)
      X(1)   = XHERE(1)
      X(100) = XHERE(NSTNS)
      AX = (X(100)-X(1))/99.0
      DO 460 I = 2,99
 460  X(I) = X(I-1) + AX
      CALL ALG14 (XHERE,R(1,J),NSTNS,X,XDUM,YPRIME,100,1)
      CALL ALG14 (XHERE,R(1,J),NSTNS,XHERE,XDUM,TANPHI(1,J),NSTNS,1)
      SS(1) = 0.0
      DO 470 I = 2,100
 470  SS(I) = SS(I-1) + AX*SQRT(1.0+((YPRIME(I)+YPRIME(I-1))/2.0)**2)
      XJ = J
      CALL ALG15 (ZR,B1,NSPEC,XJ,BETA1,1,0)
      CALL ALG15 (ZR,B2,NSPEC,XJ,BETA2,1,0)
      CALL ALG15 (ZR,PP,NSPEC,XJ,P,1,0)
      CALL ALG15 (ZR,QQ,NSPEC,XJ,Q,1,0)
      CALL ALG15 (ZR,RLE,NSPEC,XJ,YZERO,1,0)
      CALL ALG15 (ZR,TC,NSPEC,XJ,T,1,0)
      CALL ALG15 (ZR,TE,NSPEC,XJ,YONE,1,0)
      CALL ALG15 (ZR,DELX,NSPEC,XJ,XDEL,1,0)
      CALL ALG15 (ZR,DELY,NSPEC,XJ,YDEL,1,0)
      CALL ALG15 (ZR,ZZ,NSPEC,XJ,Z,1,0)
      CALL ALG15 (ZR,CORD,NSPEC,XJ,CHD,1,0)
      IF (ISECN.EQ.0 .OR. ISECN.EQ.2) GO TO 480
      CALL ALG15 (ZR,S,NSPEC,XJ,SQ,1,0)
      CALL ALG15 (ZR,BS,NSPEC,XJ,SB,1,0)
 480  IF (ISPLIT .EQ. 0) GO TO 490
      CALL ALG15 (ZR,RLES,NSPEC,XJ,YZEROS,1,1)
      CALL ALG15 (ZR,TCS,NSPEC,XJ,TS,1,1)
      CALL ALG15 (ZR,TES,NSPEC,XJ,YONES,1,1)
      CALL ALG15 (ZR,ZZS,NSPEC,XJ,ZSPMXT,1,1)
      CALL ALG15 (ZR,PERSPT,NSPEC,XJ,PERSPJ,1,1)
 490  CALL ALG15 (X,SS,100,STACKX,BX,1,1)
      CALL ALG13 (J,YS,YP,XS,XP,YSEMI,XSEMI,LOG1,LOG2,NPOINT,IPRINT,
     1     BETA1,BETA2,P,Q,YZERO,T,YONE,XDEL,YDEL,Z,CHD,LNCT,IFCORD,SQ,
     2     SB,ISECN,XSEMJ,YSEMJ,ISTAK,XHERE,X,SS,NSTNS,R,XTEMP,YPRIME,
     3     RAD,EPZ,BX,SIGMA,CCORD,ISPLIT,YZEROS,TS,YONES,ZSPMXT,PERSPJ,
     4     INAST,IRLE,IRTE,THARR)
      CALL ALG15 (X,SS,100,STACKX,BX,1,1)
      DO 500 I = 1,100
      X(I)  = X(I) - STACKX
 500  SS(I) = SS(I)- BX
      DO 510 I = 1,NSTNS
 510  XHERE(I) = XHERE(I) - STACKX
      IF (IFPLOT.EQ.0 .OR. IFPLOT.EQ.2 .OR. IFPLOT.EQ.4) GO TO 570
      XPLOT = XS(J,1)*SCALE
      YPLOT = YS(J,1)*SCALE
      DO 520 I = 2,NPOINT
      XPLOT = XS(J,I)*SCALE
      YPLOT = YS(J,I)*SCALE
 520  CONTINUE
      IF (ISECN .NE. 2) GO TO 540
      DO 530 I = 2,30
      XPLOT = XSEMJ(J,I)*SCALE
      YPLOT = YSEMJ(J,I)*SCALE
 530  CONTINUE
 540  DO 550 II = 1,NPOINT
      I = NPOINT - II + 1
      XPLOT = XP(J,I)*SCALE
      YPLOT = YP(J,I)*SCALE
 550  CONTINUE
      DO 560 I = 2,30
      XPLOT = XSEMI(J,I)*SCALE
      YPLOT = YSEMI(J,I)*SCALE
 560  CONTINUE
      XPLOT = XS(J,1)*SCALE
      YPLOT = YS(J,1)*SCALE
 570  IJDUM = 0
      DO 580 I = 1,NSTNS
      IF (IFANGS(I).GE.1) IJDUM = 1
 580  CONTINUE
      IF (IJDUM.EQ.0 .AND. INAST.EQ.0) GO TO 600
      CALL ALG15 (SS,X,100,XTEMP,XTEMP,100,1)
      DO 590 I = 1,NSTNS
      CALL ALG15 (XTEMP,SIGMA,100,XHERE(I),THETA(J,I),1,1)
      CALL ALG15 (XTEMP,YPRIME,100,XHERE(I),ALPHA(J,I),1,1)
      ZCAMB(J,I) = R(I,J)*COS(THETA(J,I))
      XCAMB(J,I) = XHERE(I)
 590  YCAMB(J,I) = R(I,J)*SIN(THETA(J,I))
 600  DO 610 I = 1,NPOINT
 610  XTEMP(I) = XS(J,I)
      CALL ALG15 (SS,X,100,XTEMP,XTEMP,NPOINT,1)
      CALL ALG15 (XHERE,R(1,J),NSTNS,XTEMP,RAD,NPOINT,0)
      K = 1
      DO 620 I = 1,NPOINT
      EPS = EPZ(I,K)
      ZS(J,I) = RAD(I)*COS(EPS)
      YS(J,I) = RAD(I)*SIN(EPS)
 620  XS(J,I) = XTEMP(I)
      DO 630 I = 1,NPOINT
 630  XTEMP(I) = XP(J,I)
      CALL ALG15 (SS,X,100,XTEMP,XTEMP,NPOINT,1)
      CALL ALG15 (XHERE,R(1,J),NSTNS,XTEMP,RAD,NPOINT,0)
      K = 2
      DO 640 I = 1,NPOINT
      EPS = EPZ(I,K)
      ZP(J,I) = RAD(I)*COS(EPS)
      YP(J,I) = RAD(I)*SIN(EPS)
 640  XP(J,I) = XTEMP(I)
      DO 650 I = 1,31
 650  XTEMP(I) = XSEMI(J,I)
      CALL ALG15 (SS,X,100,XTEMP,XTEMP,31,1)
      CALL ALG15 (XHERE,R(1,J),NSTNS,XTEMP,RAD,31,0)
      K = 3
      DO 660 I = 1,31
      EPS = EPZ(I,K)
      ZSEMI(J,I) = RAD(I)*COS(EPS)
      YSEMI(J,I) = RAD(I)*SIN(EPS)
 660  XSEMI(J,I) = XTEMP(I)
      IF (ISECN .NE. 2) GO TO 690
      DO 670 I = 1,31
 670  XTEMP(I) = XSEMJ(J,I)
      CALL ALG15 (SS,X,100,XTEMP,XTEMP,31,1)
      CALL ALG15 (XHERE,R(1,J),NSTNS,XTEMP,RAD,31,0)
      K = 4
      DO 680 I = 1,31
      EPS = EPZ(I,K)
      ZSEMJ(J,I) = RAD(I)*COS(EPS)
      YSEMJ(J,I) = RAD(I)*SIN(EPS)
 680  XSEMJ(J,I) = XTEMP(I)
 690  IF (IPRINT .GE. 2) GO TO 870
      IF (LNCT  .LE. 50) GO TO 700
      IF (IPRTC .NE.  1) WRITE (LOG2,200)
      LNCT = 1
 700  LNCT = LNCT + 5
      IF (IPRTC .EQ. 1) WRITE (LOG2,710) J
 710  FORMAT (/10X,38HCARTESIAN COORDINATES ON STREAMSURFACE,I3, //10X,
     1       8HPOINT NO,5X,2HZ1,12X,2HX1,12X,2HY1,16X,2HZ2,12X,2HX2,
     2       12X,2HY2, /)
      I = 1
 720  IF (IPRTC .EQ. 1) WRITE (LOG2,730) I,ZS(J,I),XS(J,I),YS(J,I),
     1    ZP(J,I),XP(J,I),YP(J,I)
 730  FORMAT (10X,I5,3X,1P,3E14.5,4X,1P,3E14.5)
      I = I + 1
      LNCT = LNCT + 1
      IF (I .GT. NPOINT) GO TO 750
      IF (LNCT .LE.  59) GO TO 720
      IF (IPRTC .EQ.  1) WRITE (LOG2,740)
 740  FORMAT (1H1,9X,8HPOINT NO,5X,2HZ1,12X,2HX1,12X,2HY1,16X,2HZ2,12X,
     1        2HX2,12X,2HY2, /)
      LNCT = 2
      GO TO 720
 750  IF (LNCT .LE. 50) GO TO 760
      IF (IPRTC .NE. 0) WRITE (LOG2,200)
      LNCT = 1
 760  LNCT = LNCT + 3
      IF (ISECN .NE. 2) GO TO 770
      GO TO 820
 770  IF (IPRTC .EQ. 1) WRITE (LOG2,780)
 780  FORMAT (/10X,8HPOINT NO,4X,5HZSEMI,9X,5HXSEMI,9X,5HYSEMI, /)
 790  FORMAT (/10X,8HPOINT NO,4X,5HZSEMI,9X,5HXSEMI,9X,5HYSEMI,13X,
     15HZSEMJ,9X,5HXSEMJ,9X,5HYSEMJ, /)
      I = 1
 800  IF (IPRTC .EQ. 1) WRITE (LOG2,810) I,ZSEMI(J,I),XSEMI(J,I),
     1    YSEMI(J,I)
 810  FORMAT (10X,I5,3X,1P,3E14.5)
      GO TO 850
 820  IF (IPRTC .EQ. 1) WRITE (LOG2,790)
      I = 1
 830  IF (IPRTC .EQ. 1) WRITE (LOG2,840) I,ZSEMI(J,I),XSEMI(J,I),
     1                  YSEMI(J,I),ZSEMJ(J,I),XSEMJ(J,I),YSEMJ(J,I)
 840  FORMAT (10X,I5,3X,1P,3E14.5,4X,1P,3E14.5)
 850  I = I + 1
      LNCT = LNCT + 1
      IF (I .GT. 31) GO TO 870
      IF (LNCT.LE.59 .AND. ISECN.EQ.2) GO TO 830
      IF (ISECN .NE. 2) GO TO 860
      IF (IPRTC .NE. 0) WRITE (LOG2,200)
      IF (IPRTC .EQ. 1) WRITE (LOG2,790)
      LNCT = 4
      GO TO 830
 860  IF (LNCT .LE. 59) GO TO 800
      IF (IPRTC .NE. 0) WRITE (LOG2,200)
      IF (IPRTC .EQ. 1) WRITE (LOG2,780)
      LNCT = 4
      GO TO 800
 870  CONTINUE
      IF (IPRINT .EQ. 1) GO TO 1030
      VOL = 0.0
      DO 880 J = 2,NLINES
      VOL = VOL + (((XS(J,1)-XP(J,1))**2+(YS(J,1)-YP(J,1))**2) +
     1      ((XS(J-1,1)-XP(J-1,1))**2 + (YS(J-1,1)-YP(J-1,1))**2))*
     2      (ZS(J,1)+ZP(J,1)-ZS(J-1,1) - ZP(J-1,1))*PI/32.0
      DO 880 I = 2,NPOINT
 880  VOL = VOL + ((SQRT((XS(J,I)-XP(J,I))**2+(YS(J,I)-YP(J,I))**2) +
     1      SQRT((XS(J,I-1)-XP(J,I-1))**2+(YS(J,I-1)-YP(J,I-1))**2))*
     2      (SQRT((XS(J,I-1)-XS(J,I))**2+(YS(J,I-1)-YS(J,I))**2) +
     3      SQRT((XP(J,I-1)-XP(J,I))**2+(YP(J,I-1)-YP(J,I))**2)) +
     4      (SQRT((XS(J-1,I)-XP(J-1,I))**2+(YS(J-1,I)-YP(J-1,I))**2) +
     5      SQRT((XS(J-1,I-1)-XP(J-1,I-1))**2+(YS(J-1,I-1)-YP(J-1,I-1))
     6      **2))*(SQRT((XS(J-1,I-1)-XS(J-1,I))**2+(YS(J-1,I-1)-
     7      YS(J-1,I))**2)+SQRT((XP(J-1,I-1)-XP(J-1,I))**2+(YP(J-1,I-1)-
     8      YP(J-1,I))**2)))*(ZS(J,I)+ZS(J,I-1)+ZP(J,I)+ZP(J,I-1)-
     9      ZS(J-1,I)-ZS(J-1,I-1)-ZP(J-1,I)-ZP(J-1,I-1))/32.0
      IF (LNCT .LE. 56) GO TO 890
      LNCT = 1
      IF (IPRTC .NE. 0) WRITE (LOG2,200)
 890  LNCT = LNCT + 4
      IF (IPRTC .EQ. 1) WRITE (LOG2,900) VOL
 900  FORMAT (//40X,25HVOLUME OF BLADE SECTION =,1P,E11.4, /40X,36(1H*))
      IF (IJDUM  .EQ. 0) GO TO 1030
      IF (IPRINT .NE. 3) WRITE (LOG2,200)
      IF (IPRINT .EQ. 3) WRITE (LOG2,910)
 910  FORMAT (//)
      IF (IPRTC .EQ. 1) WRITE (LOG2,920)
 920  FORMAT (1H1,42X,43HBLADE CALCULATIONS FOR AERODYNAMIC ANALYSIS,
     1        /43X,43(1H*))
      IDUM = 7
      LNCT = LNCT + 4
      IF (IPRINT .NE. 3) LNCT = 3
      DO 1020 I = 1,NSTNS
      IF (IFANGS(I).EQ.0 .OR. (ISPLIT.GE.1 .AND. IFANGS(I).EQ.1))
     1    GO TO 1020
      DO 940 J = 1,NLINES
      CALL ALG15 (RSTA(1,I),XSTA(1,I),KPTS(I),R(I,J),XDUM,1,0)
      CALL ALG14 (RSTA(1,I),XSTA(1,I),KPTS(I),R(I,J),XDUM,ZQ(J),1,1)
      DO 930 K = 1,NPOINT
      SS(K)  = XS(J,K)
      RAD(K) = YS(J,K)
      XTEMP(K) = XP(J,K)
 930  X(K) = YP(J,K)
      XDUM = XDUM - STACKX
      CALL ALG15 (SS,RAD,NPOINT,XDUM,YY1,1,1)
      CALL ALG15 (XTEMP,X,NPOINT,XDUM,YY2,1,1)
      W1 = YY1/R(I,J)
      W2 = YY2/R(I,J)
      TQ(J) = ABS(ATAN(W1/SQRT(1.-W1**2))-ATAN(W2/SQRT(1.-W2**2)))/
     1        (2.*PI)*FLOAT(NBLADE)
 940  CONTINUE
      CALL ALG14 (ZCAMB(1,I),YCAMB(1,I),NLINES,ZCAMB(1,I),XDUM,RLE,
     1            NLINES,1)
      IF (LNCT+IDUM+NLINES .LE. 59) GO TO 950
      IF (IPRTC .NE. 0) WRITE (LOG2,200)
      LNCT = 2
 950  LNCT = LNCT + IDUM + NLINES
      IF (IPRTC .EQ. 1) WRITE (LOG2,960) I,NLINES
 960  FORMAT (///48X,8HSTATION ,I2,5X,17HNUMBER OF RADII= ,I2,  //36X,6H
     1RADIUS,5X,7HSECTION,6X,4HLEAN,9X,5HBLADE,7X,5HTHETA, /48X,5HANGLE,
     26X,5HANGLE,7X,8HBLOCKAGE, /)
      DO 1000 J = 1,NLINES
      EPS = (THETA(J,I)-ATAN(RLE(J)))*C1
      ALPHB = ALPHA(J,I)
      ALP = (ATAN((TANPHI(I,J)*TAN(EPS/C1)+ALPHB*SQRT(1.+TANPHI(I,J)**2)
     1      )/(1.-TANPHI(I,J)*ZQ(J))))*C1
      ALPB(I,J) = ALP
      EPSLON(I,J) = ATAN(TAN(EPS/C1)/SQRT(1.0+ZQ(J)**2))*C1
      IF (ISPLIT .LT. 1) GO TO 990
      CALL FREAD (LOG1,RDATA,4,1)
      XB = RDATA(4)
      IF (IPRTC .EQ. 1) WRITE (LOG2,980) XB,I,J
 980  FORMAT(90X,14HADDIT. BLOCK =,F7.5,3H I=,I2,3H J=,I2)
      TQ(J) = TQ(J) + XB
 990  IF (IPRTC .EQ.1) WRITE (LOG2,1010) R(I,J),ALP,EPS,TQ(J),THETA(J,I)
 1000 BLOCK(I,J) = TQ(J)
 1010 FORMAT (30X,5F12.4)
 1020 CONTINUE
 1030 IF (IFPLOT.LT.2 .OR. IFPLOT.EQ.4) GO TO 1040
      CALL ALG17 (ISTAK,PLTSZE,2,TITLE,IKDUM,IFPLOT)
 1040 IF (IPRINT.EQ.1 .OR. IPRINT.EQ.3) GO TO 1060
      LNCT = 2
      IF (IPRTC .EQ. 1) WRITE (LOG2,1050)
 1050 FORMAT (1H1,27X,74HBLADE SURFACE GEOMETRY IN CARTESIAN COORDINATES
     1 AT SPECIFIED VALUES OF  Z , /28X,18(4H****),2H**)
 1060 IF (IPRINT.EQ.1 .AND. IFPLOT.LE.1) GO TO 1470
      XZ = NZ - 1
      DZ = (ZOUTER-ZINNER)/XZ
      ZOUT(1) = ZINNER
      DO 1070 J = 3,NZ
 1070 ZOUT(J-1) = ZOUT(J-2) + DZ
      ZOUT(NZ) = ZOUTER
      DO 1080 I = 1,NPOINT
      CALL ALG15 (ZS(1,I),XS(1,I),NLINES,ZOUT,TEMP1,NZ,0)
      CALL ALG15 (ZS(1,I),YS(1,I),NLINES,ZOUT,TEMP2,NZ,0)
      CALL ALG15 (ZP(1,I),XP(1,I),NLINES,ZOUT,TEMP3,NZ,0)
      CALL ALG15 (ZP(1,I),YP(1,I),NLINES,ZOUT,TEMP4,NZ,0)
      DO 1080 J = 1,NZ
      XS(J,I) = TEMP1(J)
      YS(J,I) = TEMP2(J)
      XP(J,I) = TEMP3(J)
 1080 YP(J,I) = TEMP4(J)
      DO 1090 I = 1,31
      CALL ALG15 (ZSEMI(1,I),XSEMI(1,I),NLINES,ZOUT,TEMP1,NZ,0)
      CALL ALG15 (ZSEMI(1,I),YSEMI(1,I),NLINES,ZOUT,TEMP2,NZ,0)
      DO 1090 J = 1,NZ
      XSEMI(J,I) = TEMP1(J)
 1090 YSEMI(J,I) = TEMP2(J)
      IF (ISECN .NE. 2) GO TO 1110
      DO 1100 I = 1,31
      CALL ALG15 (ZSEMJ(1,I),XSEMJ(1,I),NLINES,ZOUT,TEMP1,NZ,0)
      CALL ALG15 (ZSEMJ(1,I),YSEMJ(1,I),NLINES,ZOUT,TEMP2,NZ,0)
      DO 1100 J = 1,NZ
      XSEMJ(J,I) = TEMP1(J)
 1100 YSEMJ(J,I) = TEMP2(J)
 1110 DO 1460 J = 1,NZ
      RD = SQRT((XS(J,1)-XP(J,1))**2+(YS(J,1)-YP(J,1))**2)/2.0
      AREA = PI*RD**2/2.0
      BETA1 = ATAN((YS(J,2)+YP(J,2)-YS(J,1)-YP(J,1))/(XS(J,2)+XP(J,2)-
     1        XS(J,1)-XP(J,1)))
      XINT = AREA*((XP(J,1)+XS(J,1))/2.0-COS(BETA1)*4.0/(3.0*PI)*RD)
      YINT = AREA*((YP(J,1)+YS(J,1))/2.0-SIN(BETA1)*4.0/(3.0*PI)*RD)
      IF (ISECN .NE. 2) GO TO 1120
      N1 = NPOINT
      N  = N1
      N2 = N1 - 1
      BETA2 = ATAN((YS(J,N1)+YP(J,N1)-YS(J,N2)-YP(J,N2))/(XS(J,N1)+
     1        XP(J,N1)-XS(J,N2)-XP(J,N2)))
      XINT = XINT + AREA*((XP(J,N)+XS(J,N))/2.+COS(BETA2)*4./(3.*PI)*RD)
      YINT = YINT + AREA*((YP(J,N)+YS(J,N))/2.+SIN(BETA2)*4./(3.*PI)*RD)
      AREA = 2.*AREA
 1120 DO 1130 I = 2,NPOINT
      DELA = (SQRT((XS(J,I)-XP(J,I))**2+(YS(J,I)-YP(J,I))**2)+
     1        SQRT((XS(J,I-1)-XP(J,I-1))**2+(YS(J,I-1)-YP(J,I-1))**2))*
     2        (SQRT((XS(J,I-1)-XS(J,I))**2+(YS(J,I-1)-YS(J,I))**2)+
     3        SQRT((XP(J,I-1)-XP(J,I))**2+(YP(J,I-1)-YP(J,I))**2))/4.0
      AREA = AREA + DELA
      XINT = XINT + DELA*(XS(J,I)+XS(J,I-1)+XP(J,I)+XP(J,I-1))/4.0
 1130 YINT = YINT + DELA*(YS(J,I)+YS(J,I-1)+YP(J,I)+YP(J,I-1))/4.0
      YINT = YINT/AREA
      XINT = XINT/AREA
      X1   = (XS(J,1)+XP(J,1))/2.
      Y1   = (YS(J,1)+YP(J,1))/2.
      T1   = SQRT((XS(J,1)-XP(J,1))**2+(YS(J,1)-YP(J,1))**2)
      F    = 0.
      U    = 0.
      DO 1140 I = 2,NPOINT
      T2   = SQRT((XS(J,I)-XP(J,I))**2+(YS(J,I)-YP(J,I))**2)
      X2   = (XS(J,I)+XP(J,I))/2.
      Y2   = (YS(J,I)+YP(J,I))/2.
      DELU = SQRT((X2-X1)**2+(Y2-Y1)**2)
      U    = U + DELU
      TAV3 = (T1**3+T2**3)/2.
      F    = F + TAV3*DELU
      X1   = X2
      Y1   = Y2
 1140 T1   = T2
      TORCON = ((1./3.)*F)/(1.+(4./3.)*F/AREA/U**2)
      IX   = 0.0
      IY   = 0.0
      IXY  = 0.0
      DO 1150 I = 2,NPOINT
      XD   = (SQRT((XS(J,I-1)-XP(J,I-1))**2+(YS(J,I-1)-YP(J,I-1))**2)+
     1        SQRT((XS(J,I)-XP(J,I))**2+(YS(J,I)-YP(J,I))**2))/2.0
      YD   = (SQRT((XS(J,I)-XS(J,I-1))**2+(YS(J,I)-YS(J,I-1))**2)+
     1        SQRT((XP(J,I)-XP(J,I-1))**2+(YP(J,I)-YP(J,I-1))**2))/2.0
      IXD  = YD*YD*YD*XD/12.0
      IYD  = XD*XD*XD*YD/12.0
      ANG  = ATAN((YS(J,I)+YP(J,I)-YS(J,I-1)-YP(J,I-1))/(XP(J,I)+XS(J,I)
     1       -XP(J,I-1)-XS(J,I-1)))
      COSANG = COS(2.0*ANG)
      IXN  = (IXD+IYD+(IXD-IYD)*COSANG)/2.0
      IYN  = (IXD+IYD-(IXD-IYD)*COSANG)/2.0
      IXYN = 0.0
      IF (ANG .NE. 0.0) IXYN = ((IXN-IYN)*COSANG-IXD+IYD)/
     1                         (2.0*SIN(2.0*ANG))
      DELA = XD*YD
      YMN  = (YS(J,I)+YS(J,I-1)+YP(J,I)+YP(J,I-1))/4.0-YINT
      XMN  = (XS(J,I)+XS(J,I-1)+XP(J,I)+XP(J,I-1))/4.0-XINT
      IX   = IX + IXN + DELA*YMN*YMN
      IY   = IY + IYN + DELA*XMN*XMN
 1150 IXY  = IXY+ IXYN+ DELA*YMN*XMN
      ANG  = ATAN(2.0*IXY/(IY-IX))
      IPX  = (IX+IY)/2.0+(IX-IY)/2.0*COS(ANG)-IXY*SIN(ANG)
      IPY  = (IX+IY)/2.0-(IX-IY)/2.0*COS(ANG)+IXY*SIN(ANG)
      ANG  = ANG/2.0*C1
      IF (IPRINT.EQ.1 .OR. IPRINT.EQ.3) GO TO 1320
      IF (LNCT .LE. 45) GO TO 1160
      IF (IPRTC .NE. 0) WRITE (LOG2,200)
      LNCT = 1
 1160 LNCT = LNCT + 16
      IF (IPRTC .EQ. 1) WRITE (LOG2,1170) J,ZOUT(J),AREA,XINT,YINT,IX,
     1    IY,IXY,IPX,ANG,IPY,ANG
 1170 FORMAT (/50X,14HSECTION NUMBER,I3,3X,5H Z  =,F9.4, /50X,    34H***
     1*******************************, ///20X,18HSECTION PROPERTIES,7X,1
     22HSECTION AREA,26X,1H=,1P,E12.4,//45X,20HLOCATION OF CENTROID,11X,
     34HXBAR,3X,1H=,E12.4, /45X,22HRELATIVE TO STACK AXIS,9X,4HYBAR,3X,1
     4H=,E12.4, //45X,22HSECOND MOMENTS OF AREA,9X,2HIX,5X,1H=,E12.4, /4
     55X,14HABOUT CENTROID,17X,2HIY,5X,1H=,E12.4, /76X,3HIXY,4X,1H=,E12.
     64, //45X,24HPRINCIPAL SECOND MOMENTS,7X,3HIPX,4X,1H=,E12.4,4H (AT,
     70P,F7.2,21H DEGREES TO  X  AXIS),/45X,22HOF AREA ABOUT CENTROID,9X
     8,3HIPY,4X,1H=,1P,E12.4,4H (AT,0P,F7.2,21H DEGREES TO  Y  AXIS))
      IF (IPRTC .EQ. 1) WRITE (LOG2,1180) TORCON
 1180 FORMAT (/45X,18HTORSIONAL CONSTANT,20X,1H=,1P,E12.4, /)
      LNCT = LNCT + 3
      IF (LNCT .LE. 50) GO TO 1190
      IF(IPRTC .NE.  0) WRITE (LOG2,200)
      LNCT = 1
 1190 LNCT = LNCT + 5
      IF (IPRTC .EQ. 1) WRITE (LOG2,1200)
 1200 FORMAT (/20X,19HSECTION COORDINATES, /)
      IF (IPRTC .EQ. 1) WRITE (LOG2,1210)
 1210 FORMAT (31X,8HPOINT NO,5X,2HX1,12X,2HY1,16X,2HX2,12X,2HY2, /)
      DO 1220 I = 1,NPOINT
      LNCT = LNCT + 1
      IF (LNCT .LE. 60) GO TO 1220
      LNCT = 4
      IF (IPRTC .NE. 0) WRITE (LOG2,200)
      IF (IPRTC .EQ. 1) WRITE (LOG2,1210)
 1220 IF (IPRTC .EQ. 1) WRITE (LOG2,1230) I,XS(J,I),YS(J,I),XP(J,I),
     1                                    YP(J,I)
 1230 FORMAT (31X,I5,3X,1P,2E14.5,4X,1P,2E14.5)
      IF (LNCT.LE.55) GO TO 1240
      LNCT = 1
      IF (IPRTC .NE. 0) WRITE (LOG2,200)
 1240 LNCT = LNCT + 3
      IF (IPRTC.EQ.1 .AND. ISECN.EQ.2) WRITE (LOG2,1260)
      IF (ISECN .EQ. 2) GO TO 1270
      IF (IPRTC .EQ. 1) WRITE (LOG2,1250)
 1250 FORMAT (/31X,8HPOINT NO,5X,5HXSEMI,9X,5HYSEMI, /)
 1260 FORMAT (/31X,8HPOINT NO,5X,5HXSEMI,9X,5HYSEMI,12X,5HXSEMJ,9X,
     1        5HYSEMJ, /)
 1270 DO 1300 I = 1,31
      LNCT = LNCT + 1
      IF (LNCT .LE. 60) GO TO 1290
      IF (IPRTC .NE. 0) WRITE (LOG2,200)
      IF (IPRTC.EQ.1 .AND. ISECN.EQ.2) WRITE (LOG2,1260)
      IF (ISECN .EQ. 2) GO TO 1280
      IF (IPRTC .EQ. 1) WRITE (LOG2,1250)
 1280 LNCT = 4
 1290 IF (IPRTC.EQ.1 .AND. ISECN.EQ.2) WRITE (LOG2,1230) I,XSEMI(J,I),
     1    YSEMI(J,I),XSEMJ(J,I),YSEMJ(J,I)
      IF (ISECN .EQ. 2) GO TO 1300
      IF (IPRTC .EQ. 1) WRITE (LOG2,1310) I,XSEMI(J,I),YSEMI(J,I)
 1300 CONTINUE
 1310 FORMAT (31X,I5,3X,1P,2E14.5)
 1320 IF (IFPLOT .LT. 2) GO TO 1460
      IF (IFPLOT .EQ. 4) GO TO 1380
      XPLOT = XS(J,1)*SCALE
      YPLOT = YS(J,1)*SCALE
      DO 1330 I = 2,NPOINT
      XPLOT = XS(J,I)*SCALE
      YPLOT = YS(J,I)*SCALE
 1330 CONTINUE
      IF (ISECN .NE. 2) GO TO 1350
      DO 1340 I = 2,30
      XPLOT = XSEMJ(J,I)*SCALE
      YPLOT = YSEMJ(J,I)*SCALE
 1340 CONTINUE
 1350 DO 1360 II = 1,NPOINT
      I = NPOINT + 1 - II
      XPLOT = XP(J,I)*SCALE
      YPLOT = YP(J,I)*SCALE
 1360 CONTINUE
      DO 1370 I = 2,30
      XPLOT = XSEMI(J,I)*SCALE
      YPLOT = YSEMI(J,I)*SCALE
 1370 CONTINUE
      XPLOT = XS(J,1)*SCALE
      YPLOT = YS(J,1)*SCALE
      GO TO 1460
 1380 CONTINUE
      XJ = J
      STAGER = ATAN((YS(J,NPOINT)+YP(J,NPOINT)-YS(J,1)-YP(J,1))/
     1         (XS(J,NPOINT)+XP(J,NPOINT)-XS(J,1)-XP(J,1)))*C1
      XSIGN  = FLOAT(NSIGN)
      SINSTG = SIN(STAGER/C1)
      COSSTG = COS(STAGER/C1)
      YPLOT  = 4.75
      XPLOT  = 4.75*SINSTG/COSSTG
      IF (ABS(XPLOT) .LE. 22.0) GO TO 1390
      XPLOT  = 22.0
      YPLOT  =-22.0/SINSTG*COSSTG
 1390 CONTINUE
      XPLOT = -XPLOT
      YPLOT = -YPLOT
      XPLOT = 22.0
      YPLOT =-22.0*SINSTG/COSSTG
      IF (ABS(YPLOT) .LE. 4.75) GO TO 1400
      YPLOT =-4.75
      XPLOT = 4.75/SINSTG*COSSTG
 1400 CONTINUE
      XPLOT = -XPLOT
      YPLOT = -YPLOT
      XPLOT = SCALE*(XS(J,1)*COSSTG+YS(J,1)*SINSTG)
      YPLOT = SCALE*(YS(J,1)*COSSTG-XS(J,1)*SINSTG)
      DO 1410 I = 2,NPOINT
      XPLOT = SCALE*(XS(J,I)*COSSTG+YS(J,I)*SINSTG)
      YPLOT = SCALE*(YS(J,I)*COSSTG-XS(J,I)*SINSTG)
 1410 CONTINUE
      IF (ISECN.NE.2) GO TO 1430
      DO 1420 I = 2,30
      XPLOT = SCALE*(XSEMJ(J,I)*COSSTG+YSEMJ(J,I)*SINSTG)
      YPLOT = SCALE*(YSEMJ(J,I)*COSSTG-XSEMJ(J,I)*SINSTG)
 1420 CONTINUE
 1430 DO 1440 II = 1,NPOINT
      I = NPOINT + 1 - II
      XPLOT = SCALE*(XP(J,I)*COSSTG+YP(J,I)*SINSTG)
      YPLOT = SCALE*(YP(J,I)*COSSTG-XP(J,I)*SINSTG)
 1440 CONTINUE
      DO 1450 I = 2,30
      XPLOT = SCALE*(XSEMI(J,I)*COSSTG+YSEMI(J,I)*SINSTG)
      YPLOT = SCALE*(YSEMI(J,I)*COSSTG-XSEMI(J,I)*SINSTG)
 1450 CONTINUE
      XPLOT = SCALE*(XS(J,1)*COSSTG+YS(J,1)*SINSTG)
      YPLOT = SCALE*(YS(J,1)*COSSTG-XS(J,1)*SINSTG)
 1460 CONTINUE
 1470 CONTINUE
      IF (INAST .EQ. 0) GO TO 1580
      XSIGN = FLOAT(NSIGN)
      WRITE  (LOG2,1471)
 1471 FORMAT (1H0,10X,34HNASTRAN COMPRESSOR BLADE BULK DATA , /10X,
     1        36(1H*), //)
      IF (IPGEOM .EQ. 1) GO TO 1562
      WRITE  (LOG2,1472)
 1472 FORMAT (11X,30H*** CTRIA2 AND PTRIA2 DATA ***, /)
      NSTAD = IRTE - IRLE + 1
      JLOOP = 0
      NELEM = 0
      NSTRD = NLINES - 1
      IRT   = IRTE - 1
      NT    = 1995
      DO 1520 J = 1,NSTRD
      DO 1510 I = IRLE,IRT
      NELEM = NELEM + 1
      IGRD1 = I - 1 + JLOOP
      IGRD3 = IGRD1 + NSTAD
      IGRD2 = IGRD1 + NSTAD + 1
      NT    = NT + 5
      WRITE (LPUNCH,1530) NELEM,NT,IGRD1,IGRD2,IGRD3
      WRITE (LOG2,1531) NELEM,NT,IGRD1,IGRD2,IGRD3
      IF (ABS(FLOAT(INAST)) .GT. 3.5) GO TO 1480
      THCK = (THARR(J,I)+THARR(J+1,I)+THARR(J+1,I+1))/3.
      PRES =-XSIGN*(BLAFOR(I,J)+BLAFOR(I,J+1)+BLAFOR(I+1,J+1))/3.
      GO TO 1490
 1480 THCK = (THARR(J,I)+THARR(J+1,I)+THARR(J+1,I+1)+THARR(J,I+1))/4.
      PRES =-XSIGN*(BLAFOR(I,J)+BLAFOR(I,J+1)+BLAFOR(I+1,J+1)+
     1       BLAFOR(I+1,J))/4.
 1490 WRITE (LPUNCH,1540) NT,THCK
      WRITE (LOG2,1541)   NT,THCK
      IF (INAST .GT. 0) WRITE (LPUNCH,1550) PRES,NELEM
      IF (INAST .GT. 0) WRITE (LOG2,1551)   PRES,NELEM
      NELEM = NELEM + 1
      IGRD3 = IGRD2
      IGRD2 = IGRD1 + 1
      IF (ABS(FLOAT(INAST)) .GT. 3.5) GO TO 1500
      NT   = NT + 5
      THCK = (THARR(J,I)+THARR(J,I+1)+THARR(J+1,I+1))/3.
      PRES = -XSIGN*(BLAFOR(I,J)+BLAFOR(I+1,J)+BLAFOR(I+1,J+1))/3.
      WRITE (LPUNCH,1540) NT,THCK
      WRITE (LOG2,1541)   NT,THCK
 1500 WRITE (LPUNCH,1530) NELEM,NT,IGRD1,IGRD2,IGRD3
      WRITE (LOG2,1531)   NELEM,NT,IGRD1,IGRD2,IGRD3
      IF (INAST .GT. 0) WRITE (LPUNCH,1550) PRES,NELEM
      IF (INAST .GT. 0) WRITE (LOG2,1551)   PRES,NELEM
 1510 CONTINUE
 1520 JLOOP = JLOOP + NSTAD
 1530 FORMAT (6HCTRIA2,7X,I3,4X,I4,3(5X,I3))
 1531 FORMAT (1X,6HCTRIA2,7X,I3,4X,I4,3(5X,I3))
 1540 FORMAT (6HPTRIA2,6X,I4,7X,1H1,F8.4,6X,2H0.)
 1541 FORMAT (1X,6HPTRIA2,6X,I4,7X,1H1,F8.4,6X,2H0.)
 1550 FORMAT (6HPLOAD2,8X,2H60,F8.4,5X,I3)
 1551 FORMAT (1X,6HPLOAD2,8X,2H60,F8.4,5X,I3)
 1560 FORMAT (4HGRID,9X,I3,8X,3F8.4)
 1561 FORMAT (1X,4HGRID,9X,I3,8X,3F8.4)
 1562 CONTINUE
      WRITE  (LOG2,1563)
 1563 FORMAT (1H0,10X,29H*** BLADE GRID POINT DATA *** ,/)
      JD = 0
      DO 1570 J = 1,NLINES
      DO 1570 I = IRLE,IRTE
      JD = JD + 1
      YCAMB(J,I) = -XSIGN*YCAMB(J,I)
      WRITE (LOG2,1561) JD,XCAMB(J,I),YCAMB(J,I),ZCAMB(J,I)
 1570 WRITE (LPUNCH,1560) JD,XCAMB(J,I),YCAMB(J,I),ZCAMB(J,I)
      IF (ISTRML.EQ.-1 .OR. ISTRML.EQ.2) GO TO 1580
      WRITE  (LOG2,1571)
 1571 FORMAT (1H0,10X,27H*** BLADE STREAML1 DATA ***,/)
      NSTAD  = IRTE - IRLE + 1
      NSTAD1 = NSTAD - 1
      DO 1572 J = 1,NLINES
      ND1 = (J-1)*NSTAD + 1
      ND2 = ND1 + NSTAD1
      WRITE  (LPUNCH, 1573) J,ND1,ND2
 1572 WRITE  (LOG2,1574) J,ND1,ND2
 1573 FORMAT (8HSTREAML1,I8,I8,8H THRU   ,I8)
 1574 FORMAT (1X,8HSTREAML1,I8,I8,8H THRU   ,I8)
 1580 CONTINUE
      IF (NAERO.EQ.1 .OR. IPUNCH.EQ.1) CALL ALG19 (LOG1,LOG2,LOG3,LOG5,
     1    NLINES,NSPEC,KPTS,RSTA,XSTA,R,ZR,B1,B2,TC,PI,C1,NBLADE,CCORD,
     2    BLOCK,ALPB,EPSLON,IFANGS,IPUNCH,NAERO)
C     IF (IFPLOT .NE. 0) CALL PLOT (0.0,0.0,-3)
      RETURN
      END

      SUBROUTINE FA1PKE (KHH,BHH,MHH,BXHH,FSAVE,NLOOP,BREF,RREF,NEIW,
     1                   EPS)
C
C     FA1PKE COMPUTES THE EIGENVALUES FOR THE PK METHOD
C
C     LAST REVISED  2/91, BY J.PETKAS/LOCKHEED
C     ELEMENTS OF INTERPOLATION MATRIX IN D.P. AND LEAST SQUARE FIT
C
      LOGICAL          EIGV
      INTEGER          BHH,BXHH,SYSBUF,NAME(2),TRL(7),BUF1,FLOOP,FSAVE
      REAL             KINT
      DOUBLE PRECISION DX1,DX2,DSUM,DZ(1)
      CHARACTER        UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG /  UFM,UWM,UIM,SFM
      COMMON /SYSTEM/  SYSBUF,NOUT
      COMMON /UNPAKX/  IOUT,INN,NNN,INCR1
      COMMON /ZZZZZZ/  Z(1)
      COMMON /FA1PKC/  NCORE,NK,IMVR,IK,IA,IQ,ICP,IFLAG
      COMMON /BLANK /  FLOOP
      COMMON /CONDAS/  PI,TWOPI
      EQUIVALENCE      (Z(1),DZ(1))
      DATA    NAME  /  4HFA1P,4HKE  /
      DATA    ISTART/  0 /
C
C     REINITIALIZE EVERY TIME MACH CHANGES
C
      IF (IFLAG .EQ. 0) GO TO 100
      CALL SSWTCH (39,L39)
      TRL(1) = KHH
      CALL RDTRL (TRL)
      NROW  = TRL(2)
      NEIW  = MIN0(NEIW,NROW)
      NEIGN = NROW*2
      IOUT  = 1
      INN   = 1
      INCR1 = 1
      NNN   = NROW
      IEIGNS= NCORE  - NROW*5 - 1
      BUF1  = IEIGNS - SYSBUF
      NN    = NROW*NROW
      NN2   = NN*2
      IMH   = ICP
      IBH   = IMH + NN
      IKH   = IBH + NN
      IV    = IKH + NN
      IB    = IV  + NN
      IMA   = IB  + NN
      IF (MOD(IMA,2) .EQ. 0) IMA = IMA + 1
      IOP   = IMA + NN2*4
C
C     CORE CHECK
C
      IF (IOP+SYSBUF .GT. IEIGNS) CALL MESAGE (-8,0,NAME)
C
C     PUT K B M IN CORE
C
      IFL = KHH
      JI  = IKH
   10 CALL GOPEN (IFL,Z(BUF1),0)
      DO 20 I = 1,NROW
      CALL UNPACK (*15,IFL,Z(JI))
      GO TO 20
   15 CALL ZEROC (Z(JI),NROW)
   20 JI = JI + NROW
      CALL CLOSE (IFL,1)
      IF (IFL .EQ. MHH) GO TO 40
      IF (IFL .EQ. BHH) GO TO 30
      IFL = BHH
      JI  = IBH
      TRL(1) = BHH
      CALL RDTRL (TRL)
      IF (TRL(1) .GT. 0) GO TO 10
      CALL ZEROC (Z(JI),NN)
   30 IFL = MHH
      JI  = IMH
      GO TO 10
   40 CONTINUE
C
C     MODIFICATION FOR LEVEL 17.7 UPDATE
C     REPLACE CALLS TO INVAER WITH CALLS TO INVERS.
C     NO NEED TO COMPUTE DETERMINANT SINCE IT IS NOT USED SUBSEQUENTLY.
C
      ISING = -1
      CALL INVERS (NROW,Z(IMH),NROW,0,0,DET,ISING,Z(IOP))
      IF (ISING .EQ. 2) CALL MESAGE (-7,0,NAME)
C
C     START OF LARGE LOOP WITH K = 0.0
C
  100 KINT = 0.0
      IF (EPS .LE. 0.0) EPS = .001
      KN1 = NK + 1
      IQ0 = IEIGNS - (NN2+1)
      IC0 = IQ0 - KN1*2 - 2
      IF (MOD(IC0,2) .EQ. 0) IC0 = IC0 - 1
      IP0 = IC0 - KN1*2 - 2
      IF (MOD(IP0,2) .EQ. 0) IP0 = IP0 - 1
C
      I   = (FLOOP-1)*3
      EIGV= .FALSE.
      IF (Z(IMVR+I+1) .LT. 0.0) EIGV = .TRUE.
      VEL = ABS(Z(IMVR+I+1))
      VELS= VEL*VEL
      RHO = (RREF*Z(IMVR+I+2))/2.0
      IF (L39 .NE. 0) WRITE (NOUT,105) FLOOP,Z(IMVR+I),Z(IMVR+I+1),
     1                                 Z(IMVR+I+2)
  105 FORMAT ('0 TRACE FOR PK METHOD LOOP',I5,6X,4HMACH,8X,
     1        8HVELOCITY,8X,7HDENSITY,/,30X,1P,E15.5,1P,E15.5,1P,E15.5)
      NIT   = 0
      NROOT = 0
C
C     INITIALIZE LEAST SQUARE COEFFCIENTS
C
      XAV   = 0.
      YAV1  = 0.
      X10   = 0.
      X11   = 0.
      X12   = 0.
      Y10   = 0.
      Y11   = 0.
C
C     BUILD P
C
  110 CONTINUE
      NIT = NIT + 1
C
C     SUM LEAST SQUARE COEFFICIENTS ASSOCIATED WITH INDEPENDENT
C     VARIABLE STARTING WITH SECOND TRIAL
C
      IF (NIT .EQ. 1) GO TO 115
      XAV = XAV + KINT
      X10 = X10 + 1.
      X11 = X11 + KINT
      X12 = X12 + KINT**2
C
  115 IP0D = IP0/2 + 1
      DX1  = KINT
      DO 120 I = 1,NK
      DX2 = Z(IK+I-1)
      DZ(IP0D+I) = DABS((DX1-DX2)**3) + (DX1+DX2)**3
  120 CONTINUE
      DZ(IP0D+KN1) = 1.D0
C
C     FIND C = A-1  P
C
      IAD  = IA/2  + 1
      IC0D = IC0/2 + 1
      L = IAD
      DO 135 I = 1,KN1
      DSUM = 0.D+0
      DO 130 J = 1,KN1
      DSUM = DSUM + DZ(L)*DZ(IP0D+J)
      L = L + 1
  130 CONTINUE
      DZ(IC0D+I) = DSUM
  135 CONTINUE
C
C     FIND QR AND QI = Q  C  Q IS COLUMN STORED
C
      L = IQ
      DO 145 I = 1,NN2
      DSUM = 0.D+0
      DO 140 J = 1,NK
      K = L + (J-1)*NN2
      DSUM = DSUM + Z(K)*DZ(IC0D+J)
  140 CONTINUE
      L = L + 1
      Z(IQ0+I) = DSUM
  145 CONTINUE
C
C     COLUMN STORED M-1  BHH  KNH  QR (Z(IQ0+1)   QI (Z(IQ3+NN+1)
C
C     B  =  -BHH  + RHO*BREF*VEL  QHHI
C
C     K  =  -KHH  + RHO*VELS      QHHR
C
C     BUILD  A
C                  0         I
C
C                   -1       -1
C                 -M K     -M B
C
      NREM = IQ0 - IOP
      IF (NREM-NN .LE. 0) CALL MESAGE (-8,0,NAME)
      IT = IOP
      IF (MOD(IT,2) .EQ. 0) IT = IT + 1
      IF (EIGV .AND. IT+NN.GT.BUF1) CALL MESAGE (-8,0,NAME)
      BOV = BREF/VEL
      RBV = RHO*BREF*VEL
      IQR = IQ0
      IQI = IQ0 + NN
      RVS = RHO*VELS
C
C     BUILD M-1K IN IB AND M-1B IN IT  THEN GMMATS INTO IV AND IB
C
      DO 150 I = 1,NN
      Z(IT+I-1) = -Z(IBH+I-1) + RBV*Z(IQI+I)
      Z(IB+I-1) = -Z(IKH+I-1) + RVS*Z(IQR+I)
  150 CONTINUE
      CALL GMMATS (Z(IB),NROW,NROW,0,Z(IMH),NROW,NROW,0,Z(IV))
      CALL GMMATS (Z(IT),NROW,NROW,0,Z(IMH),NROW,NROW,0,Z(IB))
C
C     CALL FA1PKA TO MAKE A MATRIX AND GET EIGENVALUES
C
      CALL FA1PKA (Z(IMA),Z(IV),Z(IB),Z(IT),IEIGNS-IT,NROW)
C
C     SORT EIGENVALUES
C
      J = NEIGN*2
      CALL RSORT (2,1,Z(IT),J)
      CALL RSORT (2,2,Z(IT),J)
      IF (KINT .NE. 0.0) GO TO 180
      NLFT = NEIGN
      DO 160 I = 1,J,2
      IF (Z(IT+I) .GE. 0.0) GO TO 170
      NLFT = NLFT - 1
  160 CONTINUE
  170 NL = IT + (NEIGN-NLFT)*2
      NR = 0
      DO 175 I = 1,J,2
      IF (Z(IT+I) .NE. 0.0) GO TO 175
      NR = NR + 1
      IF (EIGV) CALL FA1PKV (Z(IMA),Z(IV),Z(IB),NROW,Z(IT+I-1),Z(IMA),
     1                       BREF,PI,VEL,Z(BUF1))
  175 CONTINUE
      NRS = NR + 1
      NR  = NR/2
      NRA = 0
  180 CONTINUE
      IF (L39 .EQ. 0) GO TO 200
      WRITE  (NOUT,182) KINT
  182 FORMAT (1H0,29H ESTIMATED REDUCED FREQUENCY ,1P,E15.5, /10X,
     1        11HEIGENVALUES,10X,18H REDUCED FREQUENCY,4X,9HFREQUENCY,
     2        6X,8H DAMPING,/,7X,4HREAL,10X,4HIMAG)
      DO 190 I = 1,J,2
      ER = Z(IT+I-1)
      EI = Z(IT+I  )
      IF (EI .EQ. 0.0) GO TO 183
      RK = BOV*EI
      RF = (1.0/TWOPI)*EI
      RG = (2.0*ER)/EI
      GO TO 185
  183 RK = 0.0
      RF = 0.0
      RG = (BREF/(PI*VEL))*ER
  185 WRITE  (NOUT,186) ER,EI,RK,RF,RG
  186 FORMAT (1H ,1P,E15.5,1P,E15.5,3X,1P,E15.5,1P,E15.5,1P,E15.5)
  190 CONTINUE
C
C     ROOT ACCEPTANCE AND SAVING
C
  200 J = NLFT*2
      L = NROOT*2 + 1 + NRA*2
      IMHERE = 200
      IF (L .GT. J) GO TO 360
C
      DO 270 I = L,J,2
      K = (NROOT*5) + 1 + IEIGNS
      IF (Z(NL+I) .NE. 0.0) GO TO 220
      IF (KINT    .NE. 0.0) GO TO 220
      IF (NRS .NE. NR) NRS = NRS - 1
      IF (NRS .NE. NR) GO TO 270
      NRA = NRA + 1
      Z(K  ) = Z(NL+I-1)
      Z(K+1) = Z(NL+I  )
      Z(K+2) = 0.0
      Z(K+3) = 0.0
      Z(K+4) = (BREF/(.34657*VEL))*Z(NL+I-1)
  210 NROOT  = NROOT + 1
C
C     PRINT EIGENVECTORS IF ASKED FOR
C
      NIT = 0
C
C     NO. OF ITERATIONS RESET TO ZERO. RE-INITIALIZE LEASE SQUARE COEFF.
C
      XAV = 0.
      YAV1= 0.
      X10 = 0.
      X11 = 0.
      X12 = 0.
      Y10 = 0.
      Y11 = 0.
      IF (NROOT .GE. NEIW) GO TO 300
      GO TO 270
  220 RKTST = BOV*Z(NL+I)
      IF (ABS(RKTST-KINT) .LT. EPS) GO TO 230
      IF (RKTST .EQ. 0.0) GO TO 230
C
C     SUM LEAST SQUARE COEFFICIENTS ASSOCIATED WITH DEPENDENT VARIABLE
C     STARTING WITH RESULT OF SECOND TIRAL
C
      IF (NIT .EQ. 1) GO TO 225
      YAV1 = YAV1 + RKTST
      Y10  = Y10  + RKTST
      Y11  = Y11  + RKTST*KINT
  225 KINT = RKTST
      IF (NIT .EQ. 10) GO TO 240
      GO TO 110
C
C     START LOOP OVER
C
  230 Z(K  ) = Z(NL+I-1)
      Z(K+1) = Z(NL+I  )
      Z(K+2) = RKTST
      Z(K+3) = (1.0/TWOPI)*Z(NL+I)
      IF (Z(NL+I) .NE. 0.0) Z(K+4) = (2.0*Z(NL+I-1))/Z(NL+I)
      IF (Z(NL+I) .EQ. 0.0) Z(K+4) = (BREF/(.34657*VEL))*Z(NL+I-1)
      IF (EIGV) CALL FA1PKV (Z(IMA),Z(IV),Z(IB),NROW,Z(K),Z(IMA),
     1                       BREF,PI,VEL,Z(BUF1))
      GO TO 210
C
C     FAILURE TO CONVERGE. REPLACE LOOP END WITH LEAST SQUARES FIT
C
  240 NIT  = NIT + 1
      XAV1 = XAV/(NIT-2)
      XAV  = (XAV + RKTST)/(NIT-1)
      YAV1 = YAV1/(NIT-2)
      D1   = X12*X10  - X11*X11
      A11  = (X10*Y11 - X11*Y10)/D1
      A10  = (X12*Y10 - X11*Y11)/D1
      RKTST= -A10/(A11-1.)
      WRITE  (NOUT,250) UWM,NIT,FLOOP,NROOT,NEIW
  250 FORMAT (A25,', PK METHOD FIALED TO CONVERGE', /1X,I4,
     1       ' ITERATIONS ON LOOP',I5,',  FOUND',I5,',  ROOTS WANTED',
     2       I5, /5X,'LEAST SQUARES FIT APPROXIMATION IMPLEMENTED.')
      IF (L39 .EQ. 1) WRITE (NOUT,260) XAV1,YAV1,XAV, A11,A10,RKTST
  260 FORMAT (/5X,'AVG. TRIAL = ',1P,E12.5,',  AGV. RESLT. = ',1P,E12.5,
     4   ',  NET AVG. = ',1P,E12.5,  //9X,'SLOPE = ',1P,E12.5,
     5   ',    INTERCEPT = ',1P,E12.5,',  VALUE    = ',1P,E12.5)
      GO TO 230
C
  270 CONTINUE
C
C     LOGIC ERROR
C
      IMHERE = 270
      GO TO 360
C
C     SAVE EIGENVALUES ON BXHH
C
  300 IF (ISTART .NE. 0) GO TO 310
      ISTART = 1
      CALL GOPEN (BXHH,Z(BUF1),1)
      CALL CLOSE (BXHH,2)
  310 CALL GOPEN (BXHH,Z(BUF1),3)
      CALL WRITE (BXHH,Z(IEIGNS+1),NROOT*5,1)
      IF (FLOOP .GE. NLOOP) GO TO 320
      CALL CLOSE (BXHH,3)
      RETURN
C
C     LAST LOOP BUILD FSAVE
C
  320 CALL CLOSE (BXHH,1)
      IBUF2 = BUF1 - SYSBUF
      CALL GOPEN (BXHH,Z(BUF1),0)
      CALL GOPEN (FSAVE,Z(IBUF2),0)
      CALL SKPREC (FSAVE,3)
      CALL CLOSE (FSAVE,2)
      CALL GOPEN (FSAVE,Z(IBUF2),3)
  330 CALL READ  (*350,*340,BXHH,Z(1),IBUF2,1,NWR)
  340 CALL WRITE (FSAVE,Z(1),NWR,1)
      GO TO 330
  350 CALL CLOSE (BXHH,1)
      CALL CLOSE (FSAVE,1)
      TRL(1) = FSAVE
      TRL(2) = NLOOP
      TRL(7) = NEIW
      CALL WRTTRL (TRL)
      GO TO 400
C
  360 WRITE  (NOUT,370) SFM,IMHERE,L,J
  370 FORMAT (A25,'. ERROR IN FA1PKE/@',I3,'  L,J=',2I7)
      CALL MESAGE (-61,0,0)
C
  400 RETURN
      END

      SUBROUTINE SCALEX(ILVAL,CODE,L)
      INTEGER L(1),CODE,EXPND(6)
      DO 101 I=1,6
  101 L(I)=0
      IF(CODE) 102,102,103
  102 L(1) = ILVAL
      GO TO 110
  103 ID=CODE
      DO 104 I=1,6
      INV=7-I
      EXPND(INV)=MOD(ID,10)
  104 ID=ID/10
      J=0
      DO 107 I=1,6
      IF(EXPND(I).EQ.0) GO TO 107
      IF(I.LT.2) GO TO 106
      II=I-1
      DO 105 K=1,II
      IF(EXPND(K).EQ.EXPND(I)) GO TO 107
  105 CONTINUE
  106 J=J+1
      L(J)=EXPND(I)
  107 CONTINUE
      I=0
  108 I=I+1
      L(I)=ILVAL+L(I)-1
      IF(I-J) 108,110,110
  110 RETURN
      END

      SUBROUTINE PLA41
C
C     THIS ROUTINE APPENDS DISPLACEMENT VECTOR INFORMATION TO THE
C     ECPTNL DATA BLOCK AND CREATES A SCRATCH DATA BLOCK, ECPTS, OF
C     THIS MERGED INFORMATION.  ECPTS IS PROCESSED BY SUBROUTINE PLA41.
C
      INTEGER         SYSBUF,CLSRW,BUFFR1,BUFFR2,UGV,ECPTNL,ECPTS,
     1                EOR,FILE,ELTYPE
      DIMENSION       NAME(2),MCBUGV(7),NWORDS(40),NGPTS(40),
     1                XECPT(100),IECPT(100)
      COMMON /SYSTEM/ SYSBUF
      COMMON /ZZZZZZ/ Z(1)
      COMMON /UNPAKX/ ITYPEB,IUNPK,JUNPK,INCUPK
      EQUIVALENCE     (XECPT(1),IECPT(1))
      DATA    UGV   , ECPTNL,ECPTS / 106,103,301   /
      DATA    NAME  / 4HPLA4,4H1   /
      DATA    EOR   , NEOR,CLSRW   / 1,0,1         /
C
C    1        ROD       BEAM      TUBE      SHEAR     TWIST
C    2        TRIA1     TRBSC     TRPLT     TRMEM     CONROD
C    3        ELAS1     ELAS2     ELAS3     ELAS4     QDPLT
C    4        QDMEM     TRIA2     QUAD2     QUAD1     DAMP1
C    5        DAMP2     DAMP3     DAMP4     VISC      MASS1
C    6        MASS2     MASS3     MASS4     CONM1     CONM2
C    7        PLOTEL    REACT     QUAD3     BAR       CONE
C    8          X         X         X         X         X
C
      DATA   NWORDS/
     1         20,        0,       19,        0,        0,
     2         33,        0,        0,       27,       20,
     3          0,        0,        0,        0,        0,
     4         32,       27,       32,       38,        0,
     5          0,        0,        0,        0,        0,
     6          0,        0,        0,        0,        0,
     7          0,        0,        0,       45,        0,
     8          0,        0,        0,        0,        0 /
      DATA   NGPTS /
     1          2,        2,        2,        4,        4,
     2          3,        3,        3,        3,        2,
     3          2,        2,        2,        2,        4,
     4          4,        3,        4,        4,        2,
     5          2,        2,        2,        2,        2,
     6          2,        2,        2,        2,        2,
     7          2,        0,        0,        2,        2,
     8          0,        0,        0,        0,        0 /
C
C     INITIALIZE
C
      IZMAX  = KORSZ(Z)
      BUFFR1 = IZMAX  - SYSBUF
      BUFFR2 = BUFFR1 - SYSBUF
      LEFT   = BUFFR2 - 1
C
C     READ THE DISPLACEMENT VECTOR INTO OPEN CORE.
C
      FILE = UGV
      CALL GOPEN (UGV,Z(BUFFR1),0)
      MCBUGV(1) = UGV
      CALL RDTRL (MCBUGV)
      IF (LEFT .LT. MCBUGV(3)) CALL MESAGE (-8,0,NAME)
      ITYPEB = 1
      IUNPK  = 1
      JUNPK  = MCBUGV(3)
      INCUPK = 1
      CALL UNPACK (*9050,UGV,Z(1))
      CALL CLOSE  (UGV,CLSRW)
C
C     OPEN THE ECPTNL AND ECPTS FILES.
C
      CALL GOPEN (ECPTS ,Z(BUFFR1),1)
      CALL GOPEN (ECPTNL,Z(BUFFR2),0)
C
C     READ AND WRITE THE PIVOT POINT
C
   10 CALL READ  (*60,*9030,ECPTNL,NPVT,1,NEOR,IFLAG)
      CALL WRITE (ECPTS,NPVT,1,NEOR)
C
C     READ ELEMENT TYPE
C
   20 CALL READ (*9020,*50,ECPTNL,ELTYPE,1,NEOR,IFLAG)
      J = NWORDS(ELTYPE)
      IF (J .LE. 0) CALL MESAGE (-30,114,IECPT(1))
C
C     READ THE ECPT ENTRY FOR THIS ELEMENT.
C
      CALL FREAD (ECPTNL,XECPT,J,0)
C
C     APPEND DISPLACEMENT VECTOR TO THE ECPT ENTRY
C
      J = J + 1
      NWDS = 3
      IF (ELTYPE .EQ. 34) NWDS = 6
      NOGPTS = NGPTS(ELTYPE)
      DO 40 I = 1,NOGPTS
      INDEX = IECPT(I+1)
      DO 30 K = 1,NWDS
      XECPT(J) = Z(INDEX)
      INDEX = INDEX + 1
   30 J = J + 1
   40 CONTINUE
C
C     THE ECPT ENTRY IS NOW COMPLETE.  WRITE IT OUT.
C
      CALL WRITE (ECPTS,ELTYPE, 1,NEOR)
      CALL WRITE (ECPTS,XECPT,J-1,NEOR)
      GO TO 20
C
C     AN EOR HAS BEEN READ ON ECPTNL.  WRITE EOR ON ECPTS.
C
   50 CALL WRITE (ECPTS,0,0,EOR)
      GO TO 10
C
C     PROCESSING IS COMPLETE.  CLOSE FILES.
C
   60 CALL CLOSE (ECPTNL,CLSRW)
      CALL CLOSE (ECPTS,CLSRW)
      RETURN
C
C     FATAL ERRORS
C
 9020 CALL MESAGE (-2,FILE,NAME)
 9030 CALL MESAGE (-3,FILE,NAME)
 9050 CALL MESAGE (-30,83,NAME)
      RETURN
      END

      SUBROUTINE GAUSS2 (A,N,N2)
C
      COMPLEX A(20,1)
      DOUBLE COMPLEX DA(20,30)
C
      DO 5 I = 1, N
      DO 5 J = 1, N2
      DA(I,J) = A(I,J)
5     CONTINUE
      DO 100 I=1,N
      K=I+1
      DO 10 J=K,N2
   10 DA(I,J)=DA(I,J)/DA(I,I)
      DO 30 M=1,N
      IF(M.EQ.I) GO TO 30
      DO 20 L=K,N2
   20 DA(M,L)=DA(M,L)-DA(M,I)*DA(I,L)
   30 CONTINUE
  100 CONTINUE
      DO 150 I = 1, N
      DO 150 J = 1, N2
      A(I,J) = DA(I,J)
  150 CONTINUE
      RETURN
      END

      SUBROUTINE KTSHLS
C
C     ECPT ENTRIES
C
C     ECPT( 1) = ELEMENT ID                                     INTEGER
C     ECPT( 2) = SCALAR INDEX NUMBER FOR GRID POINT 1           INTEGER
C     ECPT( 3) = SCALAR INDEX NUMBER FOR GRID POINT 2           INTEGER
C     ECPT( 4) = SCALAR INDEX NUMBER FOR GRID POINT 3           INTEGER
C     ECPT( 5) = SCALAR INDEX NUMBER FOR GRID POINT 4           INTEGER
C     ECPT( 6) = SCALAR INDEX NUMBER FOR GRID POINT 5           INTEGER
C     ECPT( 7) = SCALAR INDEX NUMBER FOR GRID POINT 6           INTEGER
C     ECPT( 8) = THETA                                          REAL
C     ECPT( 9) = MATERIAL ID 1                                  INTEGER
C     ECPT(10) = THICKNESS T1 AT GRID POINT G1
C     ECPT(11) = THICKNESS T3 AT GRID POINT G3
C     ECPT(12) = THICKNESS T5 AT GRID POINT G5
C     ECPT(13) = MATERIAL ID 2                                  INTEGER
C     ECPT(14) = THICKNESS TBEND1 FOR BENDING AT GRID POINT G1
C     ECPT(15) = THICKNESS TBEND3 FOR BENDING AT GRID POINT G3
C     ECPT(16) = THICKNESS TBEND5 FOR BENDING AT GRID POINT G5
C     ECPT(17) = MATERIAL ID 3                                  INTEGER
C     ECPT(18) = THICKNESS TSHR1 FOR TRANSVERSE SHEAR AT GRID POINT G1
C     ECPT(19) = THICKNESS TSHR3 FOR TRANSVERSE SHEAR AT GRID POINT G3
C     ECPT(20) = THICKNESS TSHR5 FOR TRANSVERSE SHEAR AT GRID POINT G5
C     ECPT(21) = NON-STRUCTURAL MASS                            REAL
C     ECPT(22) = DISTANCE Z11 FOR STRESS CALCULATION  AT GRID POINT G1
C     ECPT(23) = DISTANCE Z21 FOR STRESS CALCULATION  AT GRID POINT G1
C     ECPT(24) = DISTANCE Z13 FOR STRESS CALCULATION  AT GRID POINT G3
C     ECPT(25) = DISTANCE Z23 FOR STRESS CALCULATION  AT GRID POINT G3
C     ECPT(26) = DISTANCE Z15 FOR STRESS CALCULATION  AT GRID POINT G5
C     ECPT(27) = DISTANCE Z25 FOR STRESS CALCULATION  AT GRID POINT G5
C
C     X1,Y1,Z1 FOR ALL SIX POINTS ARE  IN NASTRAN BASIC SYSTEM
C
C     ECPT(28) = COORDINATE SYSTEM ID FOR GRID A                INTEGER
C     ECPT(29) = COORDINATE X1                                  REAL
C     ECPT(30) = COORDINATE Y1                                  REAL
C     ECPT(31) = COORDINATE Z1                                  REAL
C     ECPT(32) = COORDINATE SYSTEM ID FOR GRID B                INTEGER
C     ECPT(33) = COORDINATE X1                                  REAL
C     ECPT(34) = COORDINATE Y1                                  REAL
C     ECPT(35) = COORDINATE Z1                                  REAL
C     ECPT(36) = COORDINATE SYSTEM ID FOR GRID C                INTEGER
C     ECPT(37) = COORDINATE X1                                  REAL
C     ECPT(38) = COORDINATE Y1                                  REAL
C     ECPT(39) = COORDINATE Z1                                  REAL
C     ECPT(40) = COORDINATE SYSTEM ID FOR GRID D                INTEGER
C     ECPT(41) = COORDINATE X1                                  REAL
C     ECPT(42) = COORDINATE Y1                                  REAL
C     ECPT(43) = COORDINATE Z1                                  REAL
C     ECPT(44) = COORDINATE SYSTEM ID FOR GRID E                INTEGER
C     ECPT(45) = COORDINATE X1                                  REAL
C     ECPT(46) = COORDINATE Y1                                  REAL
C     ECPT(47) = COORDINATE Z1                                  REAL
C     ECPT(48) = COORDINATE SYSTEM ID FOR GRID F                INTEGER
C     ECPT(49) = COORDINATE X1                                  REAL
C     ECPT(50) = COORDINATE Y1                                  REAL
C     ECPT(51) = COORDINATE Z1                                  REAL
C     EST (52) = ELEMENT TEMPERATURE
C
      LOGICAL         IMASS,NOTS,NOGO,UNIMEM,UNIBEN
      INTEGER         XU(32),YU(32),XV(32),YV(32),XW(32),YW(32),
     1                SIL(6),SIL1,SIL2,SAVE(6),XTHK(10),YTHK(10),
     2                RK(3),SK(3),ELTYPE,ELID,ESTID,DICT(15),SMALL(6)
C                     RK AND SK ARE EXPONENTS IN THICKNESS VARIATION
      REAL            J11,J12,J22,NSM,MSHL(1024),KSHL(1024),KSUB(6,6),
     1                KSUBT(6,6),IVECT(3),JVECT(3),KVECT(3),KSUP,KSUPT
      DIMENSION       INDEX(20,3),ICS(6),IEST(42),NL(6),IND(6,3),
     1                QQQINV(360),XC(6),YC(6),ZC(6),QQQ(20,20),
     2                CMT(1296),CMS(900),CM1(30,30),TRAND(9),BALOTR(36),
     3                CC(10),CAB(3),QKS(960),KSUP(36),KSUPT(36),
     4                CTM(36,36),NAME(2)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /BLANK / NOK,NOM,NOB
      COMMON /EMGEST/ EST(100)
      COMMON /EMGDIC/ ELTYPE,LDICT,NLOCS,ELID,ESTID
      COMMON /SMA1DP/ F(14,14),Q(6,6),EE(30),CSUBT(6,5),CSUB(5,5)
      COMMON /SMA2DP/ TRAND,BALOTR,KSUB,KSUBT,FAC,XC,YC,ZC,IVECT,JVECT,
     1                KVECT,CC,CAB,DICT,SIL,SAVE,SMALL,INDEX,ICS,NL
      COMMON /SMA1CL/ KDUMMY(22),KNOGO
      COMMON /EMGPRM/ IXTRA,IZR,NZR,DUMY(12),KMBGG(3),IPREC,NOGO
      COMMON /SYSTEM/ KSYSTM(65)
      COMMON /MATIN / MATID,MATFLG,ELTEMP,PLA34,SINTH,COSTH
      COMMON /MATOUT/ EM(6),RHOY,ALF(3),TREF,GSUBE,SIGTY,SIGCY,SIGSY,
     1                RJ11,RJ12,RJ22
C
C     SMA1 WORKING STORAGE
C
C     EQUIVALENCE IECPT WITH ECPT IN COMMON BLOCK /SMA1ET/ SINCE ECPT IS
C     A MIXED INTEGER AND REAL ARRAY
C
      EQUIVALENCE    (C1,CC(1)), (C2,CC(2)), (C3,CC(3)), (C4,CC(4)),
     1               (C5,CC(5)), (C6,CC(6)), (C7,CC(7)), (C8,CC(8)),
     2               (C9,CC(9)), (C10,CC(10)),
     3               (KSUB(1,1),KSUP(1)), (KSUBT(1,1),KSUPT(1)),
     4               (CMT(1),CTM(1,1)),   (QKS(1),CMT(1025))
      EQUIVALENCE    (A,DISTA), (B,DISTB), (C,DISTC), (IEST(1),EST(1))
      EQUIVALENCE    (CMT(1),KSHL(1),MSHL(1),QQQ(1,1))
      EQUIVALENCE    (KSYSTM(2),IOUTPT)
      EQUIVALENCE    (THK1,TBEND1), (THK2,TBEND3), (THK3,TBEND5)
      EQUIVALENCE    (CM1(1,1),CMS(1)), (IND(1,1),INDEX(1,1))
      DATA   XU    / 0,1,0,2,1,0,26*0     /,
     1       YU    / 0,0,1,0,1,2,26*0     /,
     2       XV    / 6*0,0,1,0,2,1,0,20*0 /,
     3       YV    / 6*0,0,0,1,0,1,2,20*0 /,
     4       XW    / 12*0,0,1,0,2,1,0,3,2,1,0,4,3,2,1,0,5,3,2,1,0/
     5       YW    / 12*0,0,0,1,0,1,2,0,1,2,3,0,1,2,3,4,0,2,3,4,5/
      DATA   BLANK , NAME  / 4H    , 4HTRSH, 4HL     /
      DATA   RK    / 0,1,0 /
      DATA   SK    / 0,0,1 /
      DATA   DEGRA / 0.0174532925        /
      DATA   XTHK  / 0,1,0,2,1,0,3,2,1,0 /
      DATA   YTHK  / 0,0,1,0,1,2,0,1,2,3 /
C
      DICT(1) = ESTID
C
C     COMPONENT CODE,ICODE,IS  111111  AND HAS A VALUE OF 63
C
      ICODE  = 63
      NDOF   = 36
      NSQ    = NDOF**2
      DICT(2)= 1
      DICT(3)= NDOF
      DICT(4)= ICODE
      DICT(5)= GSUBE
      NOTS   =.FALSE.
      IMASS  =.FALSE.
      IF (NOM .GT. 0) IMASS =.TRUE.
      IPASS  = 1
      IDELE  = IEST(1)
      DO 10 I = 1,6
      NL(I)  = IEST(I+1)
   10 CONTINUE
      THETAM = EST(8)
      MATID1 = IEST(9)
      TMEM1  = EST(10)
      TMEM3  = EST(11)
      TMEM5  = EST(12)
      MATID2 = IEST(13)
      TBEND1 = (EST(14)*12.0)**0.3333333333
      TBEND3 = (EST(15)*12.0)**0.3333333333
      TBEND5 = (EST(16)*12.0)**0.3333333333
      MATID3 = IEST(17)
      TSHR1  = EST(18)
      TSHR3  = EST(19)
      TSHR5  = EST(20)
      NSM    = EST(21)
      J      = 0
      DO 20 I = 28,48,4
      J      = J + 1
      ICS(J) = IEST(I )
      XC(J)  = EST(I+1)
      YC(J)  = EST(I+2)
      ZC(J)  = EST(I+3)
   20 CONTINUE
C
C     IF TMEM3 OR TMEM5 EQUAL TO ZERO OR BLANK, THEY WILL BE
C     SET EQUAL TO TMEM1 SO ALSO FOR TSHR3,TSHR5,TBEND3 AND TBEND5
C
      IF (TMEM3.EQ.0.0 .OR. TMEM3.EQ.BLANK) TMEM3 = TMEM1
      IF (TMEM5.EQ.0.0 .OR. TMEM5.EQ.BLANK) TMEM5 = TMEM1
      IF (TSHR3.EQ.0.0 .OR. TSHR3.EQ.BLANK) TSHR3 = TSHR1
      IF (TSHR5.EQ.0.0 .OR. TSHR5.EQ.BLANK) TSHR5 = TSHR1
      IF (TSHR1 .EQ. 0.0) NOTS=.TRUE.
      TSHR = (TSHR1 + TSHR3 + TSHR5)/3.0
      IF (TBEND3.EQ.0.0 .OR. TBEND3.EQ.BLANK) TBEND3 = TBEND1
      IF (TBEND5.EQ.0.0 .OR. TBEND5.EQ.BLANK) TBEND5 = TBEND1
      ELTEMP = EST(52)
      THETA1 = THETAM*DEGRA
      SINTH  = SIN(THETA1)
      COSTH  = COS(THETA1)
      IF (ABS(SINTH) .LE. 1.0E-06) SINTH = 0.0
C
C     EVALUTE MATERIAL PROPERTIES
C
      MATFLG = 2
      MATID  = MATID1
      IF  (MATID1 .EQ. 0) GO TO 30
      CALL MAT (IDELE)
C
      G11 = EM(1)
      G12 = EM(2)
      G13 = EM(3)
      G22 = EM(4)
      G23 = EM(5)
      G33 = EM(6)
   30 CONTINUE
      MATFLG = 2
      MATID  = MATID2
      IF (MATID2 .EQ. 0) GO TO 40
      CALL MAT (IDELE)
      D11 = EM(1)
      D12 = EM(2)
      D13 = EM(3)
      D22 = EM(4)
      D23 = EM(5)
      D33 = EM(6)
      J11 = 0.0
      J12 = 0.0
      J22 = 0.0
      IF (NOTS) GO TO 40
      MATFLG = 3
      MATID  = MATID3
      CALL MAT (IDELE)
      J11 = 1.0/(RJ11*TSHR)
      J12 = 0.0
      J22 = 1.0/(RJ22*TSHR)
   40 CONTINUE
C
C     CALCULATIONS FOR THE TRIANGLE
C
      CALL TRIF (XC,YC,ZC,IVECT,JVECT,KVECT,A,B,C,IEST(1),NAME)
C
C     COMPUTE THE AREA INTEGRATION FUNCTION F
C
      CALL AF (F,14,A,B,C,0,0,0,0,0,0,-1)
C
C     CALCULATIONS FOR QMATRIX (QQQ) AND ITS INVERSE
C
      DO 50 I = 1,20
      DO 50 J = 1,20
   50 QQQ(I,J) = 0.0
      DO 60 I = 1,6
      I1 = (I-1)*3 + 1
      I2 = (I-1)*3 + 2
      I3 = (I-1)*3 + 3
      QQQ(I1, 1) = 1.0
      QQQ(I1, 2) = XC(I)
      QQQ(I1, 3) = YC(I)
      QQQ(I1, 4) = XC(I)*XC(I)
      QQQ(I1, 5) = XC(I)*YC(I)
      QQQ(I1, 6) = YC(I)*YC(I)
      QQQ(I1, 7) = QQQ(I1, 4)*XC(I)
      QQQ(I1, 8) = QQQ(I1, 4)*YC(I)
      QQQ(I1, 9) = QQQ(I1, 5)*YC(I)
      QQQ(I1,10) = QQQ(I1, 6)*YC(I)
      QQQ(I1,11) = QQQ(I1, 7)*XC(I)
      QQQ(I1,12) = QQQ(I1, 7)*YC(I)
      QQQ(I1,13) = QQQ(I1, 8)*YC(I)
      QQQ(I1,14) = QQQ(I1, 9)*YC(I)
      QQQ(I1,15) = QQQ(I1,10)*YC(I)
      QQQ(I1,16) = QQQ(I1,11)*XC(I)
      QQQ(I1,17) = QQQ(I1,12)*YC(I)
      QQQ(I1,18) = QQQ(I1,13)*YC(I)
      QQQ(I1,19) = QQQ(I1,14)*YC(I)
      QQQ(I1,20) = QQQ(I1,15)*YC(I)
      QQQ(I2, 3) = 1.0
      QQQ(I2, 5) = XC(I)
      QQQ(I2, 6) = YC(I)*2.0
      QQQ(I2, 8) = QQQ(I1, 4)
      QQQ(I2, 9) = QQQ(I1, 5)*2.0
      QQQ(I2,10) = QQQ(I1, 6)*3.0
      QQQ(I2,12) = QQQ(I1, 7)
      QQQ(I2,13) = QQQ(I1, 8)*2.0
      QQQ(I2,14) = QQQ(I1, 9)*3.0
      QQQ(I2,15) = QQQ(I1,10)*4.0
      QQQ(I2,17) = QQQ(I1,12)*2.0
      QQQ(I2,18) = QQQ(I1,13)*3.0
      QQQ(I2,19) = QQQ(I1,14)*4.0
      QQQ(I2,20) = QQQ(I1,15)*5.0
      QQQ(I3, 2) =-1.0
      QQQ(I3, 4) =-2.0*XC(I)
      QQQ(I3, 5) =-YC(I)
      QQQ(I3, 7) =-QQQ(I1, 4)*3.0
      QQQ(I3, 8) =-QQQ(I1, 5)*2.0
      QQQ(I3, 9) =-QQQ(I1, 6)
      QQQ(I3,11) =-QQQ(I1, 7)*4.0
      QQQ(I3,12) =-QQQ(I1, 8)*3.0
      QQQ(I3,13) =-QQQ(I1, 9)*2.0
      QQQ(I3,14) =-QQQ(I1,10)
      QQQ(I3,16) =-QQQ(I1,11)*5.0
      QQQ(I3,17) =-QQQ(I1,13)*3.0
      QQQ(I3,18) =-QQQ(I1,14)*2.0
      QQQ(I3,19) =-QQQ(I1,15)
   60 CONTINUE
      QQQ(19,16) = 5.0*A**4*C
      QQQ(19,17) = 3.0*A**2*C**3 - 2.0*A**4*C
      QQQ(19,18) =-2.0*A*C**4 + 3.0*A**3*C**2
      QQQ(19,19) = C**5 - 4.0*A**2*C**3
      QQQ(19,20) = 5.0*A*C**4
      QQQ(20,16) = 5.0*B**4*C
      QQQ(20,17) = 3.0*B**2*C**3 - 2.0*B**4*C
      QQQ(20,18) = 2.0*B*C**4 - 3.0*B**3*C**2
      QQQ(20,19) = C**5 - 4.0*B**2*C**3
      QQQ(20,20) =-5.0*B*C**4
      DO 70 I = 1,6
      DO 70 J = 1,6
      I1 = (I-1)*3 + 1
      Q(I,J) = QQQ(I1,J)
   70 CONTINUE
C
C     NO NEED TO COMPUTE DETERMINANT SINCE IT IS NOT USED SUBSEQUENTLY.
C
      ISING = -1
      CALL INVERS (6,Q,6,BALOTR(1),0,DETERM,ISING,IND)
      IF (ISING .EQ. 2) GO TO 700
C
C     FOURTH ARGUMENT IS A DUMMY LOCATION FOR INVERSE AND HENCE TS1(1)
C     IS U
C
      ISING = -1
      CALL INVERS (20,QQQ,20,BALOTR(1),0,DETERM,ISING,INDEX)
C
C     ISING EQUAL TO 2 IMPLIES THAT QQQ IS SINGULAR
C
      IF (ISING .EQ. 2) GO TO 700
C
C     FIRST 18 COLUMNS OF QQQ INVERSE IS THE QQQINV FOR USE IN STIFFNESS
C     CALCULATIONS
C
C
      DO 80 I = 1,20
      DO 80 J = 1,18
      IJK = (I-1)*18 + J
      QQQINV(IJK) = QQQ(I,J)
   80 CONTINUE
C
C     START EXECUTION FOR STIFFNESS MATRIX CALCULATION
C
C     CM IS STIFFNESS MATRIX IN ELEMENT COORDINATES
C
   90 CONTINUE
C
C     EVALUATE THE CONSTANTS C1,C2,AND C3 IN THE LINEAR EQUATION FOR
C     THICKNESS VARIATION - MEMBRANE
C
      CALL AF (F,14,A,B,C,C1,C2,C3,TMEM1,TMEM3,TMEM5,1)
      CAB(1) = C1
      CAB(2) = C2
      CAB(3) = C3
      AREA = F(1,1)
      VOL  = C1*F(1,1) + C2*F(2,1) + C3*F(1,2)
C
C
      D334 = D33*4.0
      D132 = D13*2.0
      D232 = D23*2.0
C
C     A1,A2,A3 ARE THE COEFFICIENTS OF LINEAR EQUATION FOR VARIATION
C     OF BENDING THICKNESSES
C
      CALL AF (F,14,A,B,C,A1,A2,A3,THK1,THK2,THK3,1)
      UNIMEM =.FALSE.
      UNIBEN =.FALSE.
      IF (ABS(C2).LE.1.0E-06 .AND. ABS(C3).LE.1.0E-06) UNIMEM =.TRUE.
      IF (ABS(A2).LE.1.0E-06 .AND. ABS(A3).LE.1.0E-06) UNIBEN =.TRUE.
      A1SQ= A1*A1
      A2SQ= A2*A2
      A3SQ= A3*A3
      C1  = A1SQ*A1
      C2  = 3.0*A1SQ*A2
      C3  = 3.0*A1SQ*A3
      C4  = 3.0*A1*A2SQ
      C5  = 6.0*A1*A2*A3
      C6  = 3.0*A3SQ*A1
      C7  = A2SQ*A2
      C8  = 3.0*A2SQ*A3
      C9  = 3.0*A2*A3SQ
      C10 = A3*A3SQ
C
C     AA1, AA2, AA3  ARE COEFFICIENTS IN THICKNESS VARIATION FOR
C     TRANSVERSE SHEAR
C
C
C    (POSSIBLY AN ERROR HERE - AA1,AA2, AND AA3 ARE NOT USED IN PROGRAM)
C     CALL AF (F,14,A,B,C,AA1,AA2,AA3,TSHR1,TSHR3,TSHR5,1)
C
      H4 = Q(4,1)*ZC(1) + Q(4,2)*ZC(2) + Q(4,3)*ZC(3) + Q(4,4)*ZC(4) +
     1     Q(4,5)*ZC(5) + Q(4,6)*ZC(6)
      H5 = Q(5,1)*ZC(1) + Q(5,2)*ZC(2) + Q(5,3)*ZC(3) + Q(5,4)*ZC(4) +
     1     Q(5,5)*ZC(5) + Q(5,6)*ZC(6)
      H6 = Q(6,1)*ZC(1) + Q(6,2)*ZC(2) + Q(6,3)*ZC(3) + Q(6,4)*ZC(4) +
     1     Q(6,5)*ZC(5) + Q(6,6)*ZC(6)
      H4 = H4*2.0
      H6 = H6*2.0
C
C     H5 IS MULTIPLIED BY 2.0, SO THAT EXY=DU/DY + DV/DX - ZXY*W
C
      H5 = H5*2.0
C
      DO 230 I = 1,32
      IX   = XU(I)
      RIX  = IX
      JX   = YU(I)
      RJX  = JX
      KX   = XV(I)
      RKX  = KX
      LX   = YV(I)
      RLX  = LX
      MX   = XW(I)
      RMX  = MX
      NX   = YW(I)
      RNX  = NX
      RMNX = RMX*RNX
      RMX1 = RMX*(RMX-1.0)
      RNX1 = RNX*(RNX-1.0)
      IXP1 = IX + 1
      JXP1 = JX + 1
      KXP1 = KX + 1
      LXP1 = LX + 1
      MXP1 = MX + 1
      NXP1 = NX + 1
      DO 220 J = I,32
      IJ  = (I-1)*32 + J
      JI  = (J-1)*32 + I
      IY  = XU(J)
      RIY = IY
      JY  = YU(J)
      RJY = JY
      KY  = XV(J)
      RKY = KY
      LY  = YV(J)
      RLY = LY
      MY  = XW(J)
      RMY = MY
      NY  = YW(J)
      RNY = NY
      RMNY= RMY*RNY
      RMY1= RMY*(RMY-1.0)
      RNY1= RNY*(RNY-1.0)
      MX0 = MX + MY
      MX1 = MX + MY - 1
      MX2 = MX + MY - 2
      MX3 = MX + MY - 3
      NX0 = NX + NY
      NX1 = NX + NY - 1
      NX2 = NX + NY - 2
      NX3 = NX + NY - 3
      MY1 = MX + MY + 1
      NY1 = NX + NY + 1
      IX0 = IX + IY
      IX1 = IX0- 1
      IX01= IX0+ 1
      JX0 = JX + JY
      JX1 = JX0- 1
      JX01= JX0+ 1
      KX0 = KX + KY
      KX1 = KX0- 1
      KX01= KX0+ 1
      LX0 = LX + LY
      LX1 = LX0- 1
      LX01= LX0+ 1
      IF (IPASS .EQ. 1) GO TO 110
      IX011 = IX01 + 1
      JX011 = JX01 + 1
      RHO   = RHOY*1.0
      IF (J .GT. 12) GO TO 100
      MSHL(IJ) = RHO*(CAB(1)*F(IX01,JX01) + CAB(2)*F(IX011,JX01) +
     1           CAB(3)*F(IX01,JX011)) + NSM*F(IX01,JX01)
      MSHL(JI) = MSHL (IJ)
  100 CONTINUE
      MX01 = MX0  + 1
      NX01 = NX0  + 1
      MX011= MX01 + 1
      NX011= NX01 + 1
      MSHL(IJ) = RHO*(A1*F(MX01,NX01) + A2*F(MX011,NX01) +
     1           A3*F(MX01,NX011)) + NSM*F(MX01,NX01)
      MSHL(JI) = MSHL(IJ)
      GO TO 210
  110 CONTINUE
      ST = 0.0
      IF (I.LE.12 .AND. J.GT.12) GO TO 160
      IF (I .GT. 12) GO TO 140
      DO 120 K = 1,3
      IXR1  = IX1  + RK(K)
      JXS01 = JX01 + SK(K)
      LXS1  = LX1  + SK(K)
      KXR01 = KX01 + RK(K)
      IXR01 = IX01 + RK(K)
      JXS1  = JX1  + SK(K)
      KXR1  = KX1  + RK(K)
      LXS01 = LX01 + SK(K)
      IYKX1 = IY + KX + RK(K)
      JYLX1 = JY + LX + SK(K)
      IXKY1 = IX + KY + RK(K)
      JXLY1 = JX + LY + SK(K)
      IXIY0 = IX + IY + RK(K)
      JXJY0 = JX + JY + SK(K)
      IYKX2 = IYKX1 - 1
      JYLX0 = JYLX1 + 1
      IXKY2 = IXKY1 - 1
      JXLY0 = JXLY1 + 1
      KXKY0 = KX + KY + RK(K)
      LXLY0 = LX + LY + SK(K)
      IXKY0 = IX + KY + RK(K) + 1
      JXLY2 = JXLY1 - 1
      IYKX0 = IY + KX + RK(K) + 1
      JYLX2 = JYLX1 - 1
      ST11  = 0.0
      ST22  = 0.0
      ST331 = 0.0
      ST332 = 0.0
      ST121 = 0.0
      ST122 = 0.0
      ST131 = 0.0
      ST132 = 0.0
      ST133 = 0.0
      ST231 = 0.0
      ST232 = 0.0
      ST233 = 0.0
      IF (IXR1 .GT. 0) ST11  = G11*RIX*RIY*F(IXR1,JXS01)
      IF (LXS1 .GT. 0) ST22  = G22*RLX*RLY*F(KXR01,LXS1)
      IF (JXS1 .GT. 0) ST331 = G33*RJX*RJY*F(IXR01,JXS1)
      IF (KXR1 .GT. 0) ST332 = G33*RKX*RKY*F(KXR1,LXS01)
      IF (IXKY1.GT.0 .AND. JXLY1.GT.0) ST121 = (G33*RJX*RKY +
     1                                 G12*RIX*RLY)*F(IXKY1,JXLY1)
      IF (IYKX1.GT.0 .AND. JYLX1.GT.0) ST122 = (G33*RJY*RKX +
     1                                 G12*RIY*RLX)*F(IYKX1,JYLX1)
      IF (IXIY0.GT.0 .AND. JXJY0.GT.0) ST131 = G13*(RIY*RJX +
     1                                 RIX*RJY)*F(IXIY0,JXJY0)
      IF (IYKX2 .GT. 0) ST132 = G13*RIY*RKX*F(IYKX2,JYLX0)
      IF (IXKY2 .GT. 0) ST133 = G13*RIX*RKY*F(IXKY2,JXLY0)
      IF (KXKY0.GT.0 .AND. LXLY0.GT.0) ST231 = G23*(RKX*RLY +
     1                                 RKY*RLX)*F(KXKY0,LXLY0)
      IF (JXLY2 .GT. 0) ST232 = G23*RJX*RLY*F(IXKY0,JXLY2)
      IF (JYLX2 .GT. 0) ST233 = G23*RJY*RLX*F(IYKX0,JYLX2)
C
      ST1 = (ST11  + ST22  + ST331 + ST332 + ST121 + ST122 + ST131 +
     1       ST132 + ST133 + ST231 + ST232 + ST233)* CAB(K)
      ST  = ST + ST1
      IF (UNIMEM) GO TO 130
  120 CONTINUE
  130 CONTINUE
      GO TO 200
  140 CONTINUE
      ST = 0.0
      DO 150 K = 1,10
      MX3X = MX3 + XTHK(K)
      NY1Y = NY1 + YTHK(K)
      MY1X = MY1 + XTHK(K)
      NX3Y = NX3 + YTHK(K)
      MX1X = MX1 + XTHK(K)
      NX1Y = NX1 + YTHK(K)
      MX2X = MX2 + XTHK(K)
      NX0Y = NX0 + YTHK(K)
      MX0X = MX0 + XTHK(K)
      NX2Y = NX2 + YTHK(K)
      S11  = 0.0
      S22  = 0.0
      S33  = 0.0
      S13  = 0.0
      S23  = 0.0
      IF (MX3X .GT. 0) S11 = D11*RMX1*RMY1*CC(K)*F(MX3X,NY1Y)
      IF (NX3Y .GT. 0) S22 = D22*RNX1*RNY1*CC(K)*F(MY1X,NX3Y)
      IF (MX1X.GT.0 .AND. NX1Y.GT.0) S33 = (D334*RMNX*RMNY +
     1    D12*(RMX1*RNY1 + RMY1*RNX1))*CC(K)*F(MX1X,NX1Y)
      IF (MX2X.GT.0 .AND. NX0Y.GT.0) S13 = D132*(RMX1*RMNY +
     1    RMNX*RMY1)*CC(K)*F(MX2X,NX0Y)
      IF (MX0X.GT.0 .AND. NX2Y.GT.0) S23 = D232*(RMNX*RNY1 +
     1    RNX1*RMNY)*CC(K)*F(MX0X,NX2Y)
      ST = ST + (S11 + S22 + S33 + S13 + S23)/12.0
      IF (UNIBEN) GO TO 160
  150 CONTINUE
  160 CONTINUE
      SB 7 = 0.0
      SB 9 = 0.0
      SB10 = 0.0
      SB18 = 0.0
      SB21 = 0.0
      SB26 = 0.0
      SB28 = 0.0
      SB31 = 0.0
      SB36 = 0.0
      SB38 = 0.0
      DO 180 K = 1,3
      IXMYR = IX + MY + RK(K)
      JXNYS1= JX + NY + SK(K) + 1
      SB1  = 0.0
      SB2  = 0.0
      SB3  = 0.0
      SB4  = 0.0
      SB5  = 0.0
      SB6  = 0.0
      SB8  = 0.0
      SB11 = 0.0
      SB12 = 0.0
      SB13 = 0.0
      SB14 = 0.0
      SB15 = 0.0
      SB16 = 0.0
      SB17 = 0.0
      SB19 = 0.0
      SB20 = 0.0
      SB22 = 0.0
      SB23 = 0.0
      SB24 = 0.0
      SB25 = 0.0
      SB27 = 0.0
      SB29 = 0.0
      SB30 = 0.0
      SB32 = 0.0
      SB33 = 0.0
      SB34 = 0.0
      SB35 = 0.0
      SB37 = 0.0
      SB39 = 0.0
      SB40 = 0.0
      IF (IXMYR .GT. 0)  SB 1 =-G11*RIX*H4*CAB(K)*F(IXMYR,JXNYS1)
      IYMXR  = IY + MX + RK(K)
      JYNXS1 = JY + NX + SK(K) + 1
      IF (IYMXR .GT. 0)  SB 2 =-G11*RIY*H4*CAB(K)*F(IYMXR,JYNXS1)
      MXMYR1 = MX + MY + RK(K) + 1
      NXNYS1 = NX + NY + SK(K) + 1
                         SB 3 = G11*H4**2*CAB(K)*F(MXMYR1,NXNYS1)
      KXMYR1 = KX + MY + RK(K) + 1
      LXNYS  = LX + NY + SK(K)
      IF (LXNYS .GT. 0)  SB 4 =-G22*RLX*H6*CAB(K)*F(KXMYR1,LXNYS)
      MXKYR1 = MX + KY + RK(K) + 1
      NXLYS  = NX + LY + SK(K)
      IF (NXLYS .GT. 0)  SB 5 =-G22*RLY*H6*CAB(K)*F(MXKYR1,NXLYS)
      MXMYR1 = MX + MY + RK(K) + 1
      NXNYS1 = NX + NY + SK(K) + 1
                         SB 6 = G22*H6**2*CAB(K)*F(MXMYR1,NXNYS1)
      IXMYR1 = IX + MY + RK(K) + 1
      JXNYS  = JX + NY + SK(K)
       IF(JXNYS .GT. 0)  SB 8 =-G33*RJX*H5*CAB(K)*F(IXMYR1,JXNYS)
      KXMYR  = KX + MY + RK(K)
      LXNYS1 = LX + NY + SK(K) + 1
      IF (KXMYR .GT. 0)  SB11 =-G33*RKX*H5*CAB(K)*F(KXMYR,LXNYS1)
      MXIYR1 = MX + IY + RK(K) + 1
      NXJYS  = NX + JY + SK(K)
      IF (NXJYS .GT. 0)  SB12 =-G33*RJY*H5*CAB(K)*F(MXIYR1,NXJYS)
      MXKYR  = MX + KY + RK(K)
      NXLYS1 = NX + LY + SK(K) + 1
      IF (MXKYR .GT. 0)  SB13 =-G33*RKY*H5*CAB(K)*F(MXKYR,NXLYS1)
      MXMYR1 = MX + MY + RK(K) + 1
      NXNYS1 = NX + NY + SK(K) + 1
                         SB14 = G33*H5**2*CAB(K)*F(MXMYR1,NXNYS1)
      IXMYR  = IX + MY + RK(K)
      JXNYS1 = JX + NY + SK(K) + 1
      IF (IXMYR .GT. 0)  SB15 =-G12*RIX*H6*CAB(K)*F(IXMYR,JXNYS1)
      MXKYR1 = MX + KY + RK(K) + 1
      NXLYS  = NX + LY + SK(K)
      IF (NXLYS .GT. 0)  SB16 =-G12*RLY*H4*CAB(K)*F(MXKYR1,NXLYS)
      MXMYR1 = MX + MY + RK(K) + 1
      NXNYS1 = NX + NY + SK(K) + 1
                         SB17 = 2*G12*H4*H6*CAB(K)*F(MXMYR1,NXNYS1)
      KXMYR1 = KX + MY + RK(K) + 1
      LXNYS  = LX + NY + SK(K)
      IF (LXNYS .GT. 0)  SB19 =-G12*RLX*H4*CAB(K)*F(KXMYR1,LXNYS)
      MXIYR  = MX + IY + RK(K)
      NXJYS1 = NX + JY + SK(K) + 1
      IF (MXIYR .GT. 0)  SB20 =-G12*RIY*H6*CAB(K)*F(MXIYR,NXJYS1)
      IXMYR  = IX + MY + RK(K)
      JXNYS1 = JX + NY + SK(K) + 1
      IF (IXMYR .GT. 0)  SB22 =-G13*RIX*H5*CAB(K)*F(IXMYR,JXNYS1)
      MXIYR1 = MX + IY + RK(K) + 1
      NXJYS  = NX + JY + SK(K)
      IF (NXJYS .GT. 0)  SB23 =-G13*RJY*H4*CAB(K)*F(MXIYR1,NXJYS)
      MXKYR  = MX + KY + RK(K)
      NXLYS1 = NX + LY + SK(K) + 1
      IF (MXKYR .GT. 0)  SB24 =-G13*RKY*H4*CAB(K)*F(MXKYR,NXLYS1)
      MXMYR1 = MX + MY + RK(K) + 1
      NXNYS1 = NX + NY + SK(K) + 1
                         SB25 = 2*G13*H4*H5*CAB(K)*F(MXMYR1,NXNYS1)
      IXMYR1 = IX + MY + RK(K) + 1
      JXNYS  = JX + NY + SK(K)
      IF (JXNYS .GT. 0)  SB27 =-G13*RJX*H4*CAB(K)*F(IXMYR1,JXNYS)
      KXMYR  = KX + MY + RK(K)
      LXNYS1 = LX + NY + SK(K) + 1
      IF (KXMYR .GT. 0)  SB29 =-G13*RKX*H4*CAB(K)*F(KXMYR,LXNYS1)
      MXIYR  = MX + IY + RK(K)
      NXJYS1 = NX + JY + SK(K) + 1
      IF (MXIYR .GT. 0)  SB30 =-G13*RIY*H5*CAB(K)*F(MXIYR,NXJYS1)
      KXMYR1 = KX + MY + RK(K) + 1
      LXNYS  = LX + NY + SK(K)
      IF (LXNYS .GT. 0)  SB32 =-G23*RLX*H5*CAB(K)*F(KXMYR1,LXNYS)
      MXIYR1 = MX + IY + RK(K) + 1
      NXJYS  = NX + JY + SK(K)
      IF (NXJYS .GT. 0)  SB33 =-G23*RJY*H6*CAB(K)*F(MXIYR1,NXJYS)
      MXKYR  = MX + KY + RK(K)
      NXLYS1 = NX + LY + SK(K) + 1
      IF (MXKYR .GT. 0)  SB34 =-G23*RKY*H6*CAB(K)*F(MXKYR,NXLYS1)
      MXMYR1 = MX + MY + RK(K) + 1
      NXNYS1 = NX + NY + SK(K) + 1
                         SB35 = 2*G23*H5*H6*CAB(K)*F(MXMYR1,NXNYS1)
      IXMYR1 = IX + MY + RK(K) + 1
      JXNYS  = JX + NY + SK(K)
      IF (JXNYS .GT. 0)  SB37 =-G23*RJX*H6*CAB(K)*F(IXMYR1,JXNYS)
      KXMYR  = KX + MY + RK(K)
      LXNYS1 = LX + NY + SK(K) + 1
      IF (KXMYR .GT. 0)  SB39 =-G23*RKX*H6*CAB(K)*F(KXMYR,LXNYS1)
      MXKYR1 = MX + KY + RK(K) + 1
      NXLYS  = NX + LY + SK(K)
      IF (NXLYS. GT. 0)  SB40 =-G23*RLY*H5*CAB(K)*F(MXKYR1,NXLYS)
      SB41 = SB3 + SB6 + SB14 + SB17 + SB25 + SB35
      IF (I .LE. 12) SB41 = 0.0
       ST =  ST   + SB1  + SB2  + SB4  + SB5  + SB7  + SB8  + SB9  +
     1       SB10 + SB11 + SB12 + SB13 + SB15 + SB16 + SB18 + SB19 +
     2       SB20 + SB21 + SB22 + SB23 + SB24 + SB26 + SB27 + SB28 +
     3       SB29 + SB30 + SB31 + SB32 + SB33 + SB34 + SB36 + SB37 +
     4       SB38 + SB39 + SB40 + SB41
      IF (UNIMEM) GO TO 190
  180 CONTINUE
  190 CONTINUE
  200 CONTINUE
      KSHL(IJ) = ST
      KSHL(JI) = KSHL(IJ)
  210 CONTINUE
  220 CONTINUE
  230 CONTINUE
      IF (IPASS .EQ. 2) GO TO 240
C
C    CURRENTLY,TRANSVERSE SHEAR CALCULATIONS ARE NOT CODED FOR SHELL
C    ELEMENT WHEN IT IS CODED, CALL THE ROUTINE HERE
C
  240 CONTINUE
C
C     (QQQINV) TRANSPOSE (KTR3)  (QQQINV)
C
      CALL GMMATS (Q,6,6,0, KSHL(1),6,32,0, QKS(1))
      CALL GMMATS (Q,6,6,0, KSHL(193),6,32,0, QKS(193))
      CALL GMMATS (QQQINV,20,18,+1, KSHL(385),20,32,0, QKS(385))
      DO 260 I = 1,30
      DO 250 J = 1,6
      IJ =(I-1)*32 + J
      JI =(I-1)*6  + J
      KSHL(    JI) = QKS(  IJ)
      KSHL(180+JI) = QKS(6+IJ)
  250 CONTINUE
  260 CONTINUE
      DO 280 I = 1,30
      DO 270 J = 1,20
      IJ = (I-1)*32 + J + 12
      JI = (I-1)*20 + J + 360
      KSHL(JI) = QKS(IJ)
  270 CONTINUE
  280 CONTINUE
      CALL GMMATS (KSHL(1  ),30,6 ,0,Q,6,6,1 ,QKS(1  ))
      CALL GMMATS (KSHL(181),30,6 ,0,Q,6,6,1 ,QKS(181))
      CALL GMMATS (KSHL(361),30,20,0, QQQINV,20,18,0, QKS(361))
      DO 300 I = 1,30
      DO 290 J = 1,6
      IJ = (I-1)*30 + J
      JI = (I-1)*6  + J
      CMS(IJ  ) = QKS(JI    )
      CMS(IJ+6) = QKS(JI+180)
  290 CONTINUE
  300 CONTINUE
      DO 320 I = 1,30
      DO 310 J = 1,18
      IJ = (I-1)*30 + J + 12
      JI = (I-1)*18 + J + 360
      CMS(IJ) = QKS(JI)
  310 CONTINUE
  320 CONTINUE
      DO 330 I = 1,30
      EE(I) = 0.0
  330 CONTINUE
      EE( 1) =  IVECT(1)
      EE( 2) =  JVECT(1)
      EE( 3) =  KVECT(1)
      EE( 6) =  IVECT(2)
      EE( 7) =  JVECT(2)
      EE( 8) =  KVECT(2)
      EE(11) =  IVECT(3)
      EE(12) =  JVECT(3)
      EE(13) =  KVECT(3)
      EE(19) =  IVECT(1)
      EE(20) =  JVECT(1)
      EE(24) =  IVECT(2)
      EE(25) =  JVECT(2)
      EE(29) =  IVECT(3)
      EE(30) =  JVECT(3)
      DO 360 K = 1,6
      DO 350 I = 1,2
      K1 = 6*(I-1) + K
      I1 = 5*(K-1) + I
      DO 340 J = 1,30
      CTM (I1,J) = CM1(K1,J)
  340 CONTINUE
  350 CONTINUE
  360 CONTINUE
      DO 390 K = 1,6
      DO 380 I = 1,3
      I2 =  5*(K-1) + I + 2
      K2 = 12+(K-1)*3 + I
      DO 370 J = 1,30
      CTM (I2,J) = CM1(K2,J)
  370 CONTINUE
  380 CONTINUE
  390 CONTINUE
      DO 420 K = 1,6
      DO 410 I = 1,2
      K1 = 6*(I-1) + K
      I1 = 5*(K-1) + I
      DO 400 J = 1,30
      CM1(J,I1) = CTM(J,K1)
  400 CONTINUE
  410 CONTINUE
  420 CONTINUE
      DO 450 K = 1,6
      DO 440 I = 1,3
      I2 =  5*(K-1) + I + 2
      K2 = 12+(K-1)*3 + I
      DO 430 J = 1,30
      CM1(J,I2) = CTM(J,K2)
  430 CONTINUE
  440 CONTINUE
  450 CONTINUE
      DO 460 I = 1,1296
      CMT(I) = 0.0
  460 CONTINUE
C
C     LUMPED MASS COMPUTATION
C
      IF (IPASS .NE. 2) GO TO 490
  470 AMASS = (RHOY*VOL + NSM*AREA)/6.
      DO 480 I = 1,1296,37
      CMT(I) = AMASS
  480 CONTINUE
      IPASS = 2
      GO TO 690
C
C     LOCATE THE TRANSFORMATION MATRICES FROM BASIC TO LOCAL (THAT IS
C     COORDINATE AT ANY GRID POINT IN WHICH DISPLACEMENT AND STRESSES
C     ARE R
C     - NOT NEEDED IF FIELD 7 IN GRID CARD IS ZERO)
C
C     TRANSFORM STIFFNESS MATRIX FROM ELEMENT COORDINATES TO BASIC
C     COORDINATES
C
C     TRANSFORM STIFFNESS MATRIX FROM BASIC COORDINAYES TO GLOBAL (DISP)
C     COORDINATES
C
C     INSERT THE 6X6 SUBMATRIX  INTO KGG MATRIX
C
  490 DO 500 I = 1,6
      SAVE(I) = NL(I)
  500 CONTINUE
      DO 530 I = 1,6
      SMALL(I) = I
      ISMALL = NL(I)
      DO 520 J = 1,6
      IF (ISMALL .LE. NL(J)) GO TO 510
      SMALL(I) = J
      ISMALL = NL(J)
  510 CONTINUE
  520 CONTINUE
      ISM = SMALL(I)
      NL(ISM) = 1000000
  530 CONTINUE
      DO 540 I = 1,6
      NL(I) = SAVE(I)
  540 CONTINUE
      DO 680 I = 1,6
      SIL1 = SMALL(I)
      DO 670 J = I,6
      SIL2 = SMALL(J)
      DO 550 II = 1,36
      BALOTR(II) = 0.0
      KSUP(II)   = 0.0
  550 CONTINUE
      DO 570 K = 1,5
      K1 = (SIL1-1)*5 + K
      DO 560 L = 1,5
      L1 = (SIL2-1)*5 + L
      CSUB(K,L) = CM1(K1,L1)
  560 CONTINUE
  570 CONTINUE
      CALL GMMATS (EE,6,5,0, CSUB,5,5,0, CSUBT)
      CALL GMMATS (CSUBT,6,5,0, EE,6,5,+1, KSUPT)
      DO 580 K = 1,6
      DO 580 L = 1,6
      K1 =(K-1)*6 + L
      L1 =(L-1)*6 + K
      KSUP(L1) = KSUPT(K1)
  580 CONTINUE
C
C     TRANSFORM THE KSUP(36) FROM BASIC TO DISPLACEMENT COORDINATES
C
      IF (NL(SIL1).EQ.0 .OR. ICS(SIL1).EQ.0) GO TO 610
      JJ = 4*SIL1 + 24
      CALL TRANSS (IEST(JJ),TRAND)
      DO 590 JJ = 1,3
      L = 6*(JJ-1) + 1
      M = 3*(JJ-1) + 1
      BALOTR(L   ) = TRAND(M  )
      BALOTR(L+1 ) = TRAND(M+1)
      BALOTR(L+2 ) = TRAND(M+2)
      BALOTR(L+21) = TRAND(M  )
      BALOTR(L+22) = TRAND(M+1)
      BALOTR(L+23) = TRAND(M+2)
  590 CONTINUE
      CALL GMMATS (BALOTR(1),6,6,1, KSUP(1),6,6,0, KSUPT)
      DO 600 K = 1,36
      KSUP(K) = KSUPT(K)
  600 CONTINUE
  610 CONTINUE
      IF (NL(SIL2).EQ.0 .OR. ICS(SIL2).EQ.0) GO TO 650
      IF (J .EQ. I) GO TO 630
      JJ = 4*SIL2 + 24
      CALL TRANSS (IEST(JJ),TRAND)
      DO 620 JJ = 1,3
      L = 6*(JJ-1) + 1
      M = 3*(JJ-1) + 1
      BALOTR(L   ) = TRAND(M  )
      BALOTR(L+1 ) = TRAND(M+1)
      BALOTR(L+2 ) = TRAND(M+2)
      BALOTR(L+21) = TRAND(M  )
      BALOTR(L+22) = TRAND(M+1)
      BALOTR(L+23) = TRAND(M+2)
  620 CONTINUE
  630 CONTINUE
      CALL GMMATS (KSUP(1),6,6,0, BALOTR(1),6,6,0, KSUPT)
      DO 640 K = 1,36
      KSUP(K) = KSUPT(K)
  640 CONTINUE
  650 CONTINUE
      DO 660 II = 1,6
      DO 660 JJ = 1,6
      I1 = (I-1)*6 + II
      J1 = (J-1)*6 + JJ
      CTM(I1,J1) = KSUB(JJ,II)
      CTM(J1,I1) = KSUB(JJ,II)
  660 CONTINUE
  670 CONTINUE
  680 CONTINUE
  690 CALL EMGOUT (CMT(1),CMT(1),1296,1,DICT,IPASS,IPREC)
      IF (.NOT.IMASS .OR. IPASS.GE.2) RETURN
C
C     TO TO 295 TO COMPUTE LUMPED MASS MATRIX
C     GO TO 211 TO COMPUTE CONSIST. MASS MATRIX (THIS PATH DOES NOT
C     WROK)
C
      IPASS = 3
      GO TO (720,90,470), IPASS
C
C     ERROR
C
  700 CONTINUE
      NOGO  = .TRUE.
      KNOGO = 1
      WRITE  (IOUTPT,710) UFM,IEST(1)
  710 FORMAT (A23,' 2416, MATRIX RELATING GENERALIZED PARAMETERS AND ',
     1       'GRID POINT DISPLACEMENTS IS SINGULAR.', //26X,
     2       'CHECK COORDINATES OF ELEMENT  TRSHL WITH ID',I9,1H.)
  720 CONTINUE
      RETURN
      END

      SUBROUTINE IFP3
C
C     DATA PROCESSING AND GENERATION OF THE AXIS-SYMETRIC-CONICAL SHELL
C
C          CARDS          TYPE       REC.ID-BIT CARDS-FILE,  CARDS-FILE
C     ===  =======      ===========  ========== ===========  ==========
C      1   AXIC     --  AX.SY.SHELL     515- 5
C      2   CCONEAX  --  AX.SY.SHELL    8515-85  CCONE-GEOM2,
C      3   FORCEAX  --  AX.SY.SHELL    2115-21  FORCE-GEOM3,
C      4   FORCE    --  STANDARD       4201-42  FORCE-GEOM3,
C      5   GRAV     --  STANDARD       4401-44   GRAV-GEOM3,
C      6   LOAD     --  STANDARD       4551-61   LOAD-GEOM3,
C      7   MOMAX    --  AX.SY.SHELL    3815-38  MOMNT-GEOM3,
C      8   MOMENT   --  STANDARD       4801-48  MOMNT-GEOM3,
C      9   MPCADD   --  STANDARD       4891-60 MPCADD-GEOM4,
C     10   MPCAX    --  AX.SY.SHELL    4015-40    MPC-GEOM4,
C     11   OMITAX   --  AX.SY.SHELL    4315-43   OMIT-GEOM4,
C     12   POINTAX  --  AX.SY.SHELL    4915-49    MPC-GEOM4, GRID-GEOM1
C     13+  RFORCE   --  STANDARD       5509-55 RFORCE-GEOM3,
C     14   RINGAX   --  AX.SY.SHELL    5615-56    SPC-GEOM4, GRID-GEOM1
C     15   SECTAX   --  AX.SY.SHELL    6315-63    MPC-GEOM4, GRID-GEOM1
C     16   SEQGP    --  STANDARD       5301-53  SEQGP-GEOM1,
C     17   SPCADD   --  STANDARD       5491-59 SPCADD-GEOM4,
C     18   SPCAX    --  AX.SY.SHELL    6215-62    SPC-GEOM4,
C     19   SUPAX    --  AX.SY.SHELL    6415-64 SUPORT-GEOM4,
C     20   TEMPAX   --  AX.SY.SHELL    6815-68   TEMP-GEOM3,
C     21   TEMPD    --  STANDARD       5641-65  TEMPD-GEOM3,
C     22   CTRIAAX  --  AX.TR.CR       7012-70  CTRIA-GEOM2
C     23   CTRAPAX  --  AX.TRA.CR      7042-74  CTRAP-GEOM2
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        LSHIFT    ,RSHIFT    ,ANDF      ,ORF       ,
     1                COMPLF
      LOGICAL         SECD      ,NOGO      ,RECOFF    ,PIEZ
      REAL            NPHI      ,NPHI1     ,NISQ      ,NI        ,
     1                A1        ,A2        ,A3        ,A4        ,
     2                ANGLE     ,RADDEG    ,PI        ,DIFPHI    ,
     3                RZ        ,T1        ,T2        ,COEF      ,
     4                CONSTS    ,SUM       ,TWOPI
      DIMENSION       GEOM(4)   ,Z(8)      ,NUM(11)   ,INUM(11)  ,
     1                MSG1(2)   ,MSG2(2)
      CHARACTER       UFM*23    ,UWM*25    ,UIM*29    ,SFM*25
      COMMON /XMSSG / UFM       ,UWM       ,UIM       ,SFM
      COMMON /SYSTEM/ IBUFSZ    ,NOUT      ,NOFLAG    ,DUMDUM(8) ,
     1                NLINES    ,DUM1(26)  ,NBPC      ,NBPW      ,
     2                DUM37(37) ,IPIEZ
      COMMON /TWO   / TWO(32)
      COMMON /CONDAS/ CONSTS(5)
      COMMON /IFP3LV/            RECID(3)  ,RECID1(3) ,RECIDX(3) ,
     1                IEND      ,REC(3)    ,REC1(3)   ,TRAIL(7)  ,
     2                IT        ,AXTRL(7)  ,OPENFL(6) ,N         ,
     3                A1        ,CSID      ,NI        ,NISQ      ,
     4                A2        ,IBUFF1    ,IBUFF2    ,IBUFF3    ,
     5                A3        ,BUFF      ,NOGO      ,OP        ,
     6                A4        ,IHEADR    ,IBITR     ,IFILE     ,
     7                NOREG     ,LAST      ,IERRTN    ,ICONT     ,
     8                NOAXIC    ,RINGID    ,OUTBUF    ,VEOR      ,
     9                ISTART    ,IRETRN    ,FLAG      ,IAMT      ,
     O                SUM       ,IBIT      ,SETID     ,SORC      ,
     1                IBEGIN    ,MPCON     ,NWORDS    ,NNN       ,
     2                ANGLE     ,K3OR6     ,NPHI1     ,ZPT       ,
     3                NMOVE     ,CSSET     ,NOPONT    ,NON       ,
     4                IPHI      ,RECOFF    ,NPHI      ,N3OR5     ,
     5                ION       ,NPLUS1    ,NOSECT    ,COEF      ,
     6                IPT       ,COMPON    ,ICORE     ,ISCRAT    ,
     7                ICORE1    ,NCARDS    ,I1        ,IAT       ,
     8                I2        ,T1        ,T2        ,NFILE     ,
     9                NADD      ,NCARD
      COMMON /IFP3CM/ FILE(6)   ,INAME(12) ,CDTYPE(50),AXIC1(3)  ,
     1                CCONEX(3) ,FORCEX(3) ,FORCE(3)  ,GRAV(3)   ,
     2                LOAD(3)   ,MOMAX(3)  ,MOMENT(3) ,MPCADD(3) ,
     3                MPCAX(3)  ,OMITAX(3) ,POINTX(3) ,PRESAX(3) ,
     4                RINGAX(3) ,SECTAX(3) ,SEQGP(3)  ,SPCAX(3)  ,
     5                SUPAX(3)  ,TEMPAX(3) ,TEMPD(3)  ,PLOAD(3)  ,
     6                MPC(3)    ,SPC(3)    ,GRID(3)   ,SUPORT(3) ,
     7                NEG111(3) ,T65535(3) ,TEMP(3)   ,OMIT(3)   ,
     8                SPCADD(3) ,ONE       ,ZERO      ,IHEADB(96),
     9                CTRIAA(3) ,CTRAPA(3) ,ICONSO    ,RFORCE(3)
      COMMON /OUTPUT/ DUMMY(96) ,IHEAD(96)
      COMMON /ZZZZZZ/ RZ(1)
      EQUIVALENCE     (CONSTS(1),PI     )  ,(CONSTS(2),TWOPI  )  ,
     1                (CONSTS(4),RADDEG )  ,(Z(1)     ,RZ(1)  )  ,
     2                (GEOM(1)  ,FILE(1))  ,(SCRTCH   ,FILE(5))  ,
     3                (AXIC     ,FILE(6))  ,(NUM(11)  ,B      )  ,
     4                (NOEOR    ,INPRWD    ,ZERO)                ,
     5                (EOR      ,CLORWD    ,OUTRWD    ,ONE    )
      DATA    INUM  / 1H0,1H1,1H2,1H3,1H4,1H5,1H6,1H7,1H8,1H9,1H /
      DATA    IFIAT / 4HFIAT/, IFIST  /  4HFIST/,I5,I6 / 5,6     /
      DATA    MSG1  / 4HIFP3 , 4HBEGN /, MSG2  / 4HIFP3, 4HEND   /
C
      CALL CONMSG (MSG1,2,0)
C
C     RIGHT-JUSTIFY INUM AND CALL IT NUM
C
      DO 1 I = 1,11
    1 NUM(I) = RSHIFT(INUM(I),NBPW-NBPC)
C
C     INITIAL CHECK TO MAKE SURE TRAILER BITS ARE ALL OFF FOR GEOM1,
C     GEOM2, GEOM3, GEOM4.
C
      DO 10 I = 1,96
   10 IHEAD(I) = IHEADB(I)
C
      IF (NOFLAG) 30,20,30
   20 NOGO = .FALSE.
      GO TO 40
   30 NOGO = .TRUE.
C
   40 OPENFL(1) = 0
      OPENFL(2) = 0
      OPENFL(3) = 0
      OPENFL(4) = 0
      OPENFL(5) = 0
      OPENFL(6) = 0
      DO 110 I = 1,4
      TRAIL(1) = GEOM(I)
      CALL RDTRL (TRAIL(1))
      IF (TRAIL(1)) 50,50,70
   50 CALL PAGE2 (3)
      IMSG = 1061
      WRITE  (NOUT,55) SFM,IMSG
   55 FORMAT (A25,I5)
      WRITE  (NOUT,60) GEOM(I),INAME(2*I-1),INAME(2*I),IFIAT
   60 FORMAT (5X,11HFILE NUMBER,I4,3H ( ,2A4,12H) IS NOT IN ,A4,1H.)
      NOGO = .TRUE.
      GO TO 110
C
   70 DO 100 J = 2,7
      IF (TRAIL(J)) 80,100,80
   80 CALL PAGE2 (3)
      IMSG = 1062
      WRITE  (NOUT,55) SFM,IMSG
      WRITE  (NOUT,90) GEOM(I),INAME(2*I-1),INAME(2*I)
   90 FORMAT (5X,'FILE NUMBER',I4,3H ( ,2A4,') HAS TRAILER BIT ON.  ',
     1       'FILE SHOULD BE CLEAN AT ENTRY TO IFP3.')
      NOGO = .TRUE.
      GO TO 110
  100 CONTINUE
  110 CONTINUE
C
C     PROCEED TO SETUP CORE AND OPEN AXIC FILE
C     ICORE1 WILL ALWAYS EQUAL THE GROSS OPEN CORE TO IFP3 AT START
C
      ICORE1 = KORSZ(Z)
      IBUFF1 = ICORE1 - IBUFSZ - 2
      IBUFF2 = IBUFF1 - IBUFSZ
      IBUFF3 = IBUFF2 - IBUFSZ
      ICORE  = IBUFF3 - 1
      ICRQ   = 100 - ICORE
      IF (ICORE .LT. 100) GO TO 1310
C
C     OPEN  AXIC FILE
C
      CALL PRELOC (*1330,Z(IBUFF1),AXIC)
      OPENFL(6) = 1
      AXTRL(1)  = AXIC
      CALL RDTRL (AXTRL(1))
C
C     READ AXIC CARD
C
      CALL LOCATE (*130,Z(IBUFF1),AXIC1(1),FLAG)
      CALL READ (*1600,*130,AXIC,Z(1),2,EOR,FLAG)
      N    = Z(1)
      CSID = Z(2)
      NNN  = N
      NCARD= 1
      ASSIGN 140 TO IERRTN
      GO TO 1420
C
C     MISSING REQUIRED AXIC CARD
C
  130 ASSIGN 140 TO IERRTN
      NNN   = 0
      NCARD = 1
      GO TO 1510
  140 N = NNN
      NPLUS1 = N + 1
C
C
C     GEOM2  PROCESSING
C     =================
C
C     OPEN GEOM2
C
      IFILE= GEOM(2)
      I    = 2
      OP   = OUTRWD
      BUFF = IBUFF2
      ASSIGN 150 TO IRETRN
      GO TO 1350
C
C     CCONEAX CARDS
C
  150 REC(1) = CCONEX(1)
      REC(2) = CCONEX(2)
      REC(3) = CCONEX(3)
      NCARD  = 2
C
C     IF THERE IS NO CCONEAX CARD, THEN GO TO 1750 AND LOOK FOR
C     CTRAPAX OR CTRIAAX CARDS
C
      ICONB  = 0
      ICONSO = 0
      CALL LOCATE (*1750,Z(IBUFF1),REC(1),FLAG)
C
C     INPUT IS IN 4-WORD CARDS
C     OUTPUT IS N+1 4-WORD CARDS FOR EACH CARD INPUT
C
C     RECORD HEADER FOR CCONES
C
      ASSIGN 160 TO IHEADR
      GO TO 1470
C
  160 CALL READ (*1600,*220,AXIC,Z(1),4,NOEOR,IAMT)
C
C     CHECK RING ID-S FOR SIZE
C
      NNN = Z(3)
      ASSIGN 170 TO IERRTN
      GO TO 1440
  170 NNN = Z(4)
      ASSIGN 180 TO IERRTN
      GO TO 1440
C
C     CHECK CCONEAX ID FOR 1-9999 ALLOWABLE RANGE
C
  180 IF (Z(1).GT.0 .AND. Z(1).LT.10000) GO TO 200
      CALL PAGE2 (3)
      IMSG = 361
      WRITE  (NOUT,185) UFM,IMSG
  185 FORMAT (A23,I4)
      WRITE  (NOUT,190) Z(1)
  190 FORMAT (5X,'CCONEAX ID =',I10,'.  OUT OF 1 TO 9999 PERMISSIBLE ',
     1       'RANGE')
      NOGO = .TRUE.
C
  200 Z(1) = Z(1)*1000
      DO 210 I = 1,NPLUS1
      Z(1) = Z(1) + 1
      Z(3) = Z(3) + 1000000
      Z(4) = Z(4) + 1000000
      IF (NOGO) GO TO 210
      CALL WRITE (GEOM(2),Z(1),4,NOEOR)
  210 CONTINUE
      GO TO 160
C
C     OUT OF CCONEAX CARDS
C
  220 IF (IAMT) 230,240,230
C
C     GO TO 356 FOR RECORD ERROR
C
  230 ASSIGN 260 TO IERRTN
      GO TO 1490
C
C     WRITE EOR AND PUT BITS IN TRAILER
C
  240 ASSIGN 250 TO IRETRN
      ICONSO = 1
      GO TO 1270
  250 ICONB = 1
      GO TO 1750
C
C     CLOSE GEOM2
C
  260 I = 2
      ASSIGN 270 TO IRETRN
      GO TO 1380
C
C     GEOM3 PROCESSING
C     ================
C
C     OPEN GEOM3
C
  270 IFILE= GEOM(3)
      I    = 3
      OP   = OUTRWD
      BUFF = IBUFF2
      ASSIGN 280 TO IRETRN
      GO TO 1350
C
C     FORCE, FORCEAX, MOMNT, AND MOMNTAX CARDS
C
  280 RECID(1) = FORCE(1)
      RECID(2) = FORCE(2)
      RECID(3) = FORCE(3)
      RECIDX(1)= FORCEX(1)
      RECIDX(2)= FORCEX(2)
      RECIDX(3)= FORCEX(3)
      NCARD    = 3
      ASSIGN 620 TO ICONT
C
C     SET NOREG = 0 OR 1, DEPENDING ON PRESSENCE OF RECID
C     SET NOAXIC= 0 OR 1, DEPENDING ON PRESSENCE OF RECIDX
C
  290 IBIT = RECIDX(2)
      ASSIGN 300 TO IBITR
      GO TO 1460
  300 NOAXIC = NON
      IBIT = RECID(2)
      ASSIGN 310 TO IBITR
      GO TO 1460
  310 NOREG = NON
C
      REC(1) = RECID(1)
      REC(2) = RECID(2)
      REC(3) = RECID(3)
C
      IF (NOAXIC) 340,320,340
  320 IF (NOREG ) 330,610,330
C
C     TRANSFER FORCE OR MOMENT RECORD DIRECTLY.
C     THERE ARE NO FORCEAX OR MOMAX CARDS RESPECTIVELY.
C
  330 ASSIGN 610 TO IRETRN
      GO TO 1230
C
C     AT 410 READ IN ALL FORCEAX OR MOMNTAX CARDS AND PUT OUT ON GEOM(3)
C     IF NOREG=0,AND ON SCRTCH IF NOREG NON-ZERO.FIRST WRITE 3-WORD-
C     REC ID ON GEOM3.
C
  340 ASSIGN 350 TO IHEADR
      GO TO 1470
C
C     OPEN SCRATCH IF NEEDED
C
  350 IF (NOREG) 360,370,360
  360 I    = 5
      OP   = OUTRWD
      BUFF = IBUFF3
      ASSIGN 370 TO IRETRN
      GO TO 1350
  370 CALL LOCATE (*1530,Z(IBUFF1),RECIDX(1),FLAG)
  380 CALL READ (*1600,*440,AXIC,Z(1),8,NOEOR,IAMT)
C
C     CHECK RING ID
C
      ASSIGN 390 TO IERRTN
      NNN = Z(2)
      GO TO 1440
C
C     CHECK HARMONIC NUMBER AND FOR A SEQUENCE OF HARMONICS
C
  390 IF (Z(4) .EQ. 0) GO TO 396
      II   = 1
      NH1  = 0
      NH2  = 0
      SECD = .TRUE.
      WORD = 4
      DO 391 IJ = 1,2
      DO 392 IX = 1,4
      CHR = RSHIFT(LSHIFT(Z(WORD),NBPC*IABS(IX-4)),NBPW-NBPC)
      IF (CHR .EQ. B) GO TO 392
      DO 393 I = 1,10
      K = I-1
      IF (NUM(I) .EQ. CHR) GO TO 394
  393 CONTINUE
      SECD = .FALSE.
      II   = 1
      GO TO 392
  394 IF (SECD) GO TO 395
      NH1 = NH1 + II*K
      II  = II*10
      GO TO 392
  395 NH2 = NH2 + II*K
      II  = II*10
  392 CONTINUE
  391 WORD = WORD -1
      IF (NH1 .LE. NH2) GO TO 398
      WORD = NH1
      NH1  = NH2
      NH2  = WORD
  398 NNN  = NH1
      ASSIGN 397 TO IERRTN
      GO TO 1420
  396 NH1  = Z(3)
      NH2  = Z(3)
  397 NNN  = NH2
      ASSIGN 400 TO IERRTN
      GO TO 1420
  400 Z(4) = Z(5)
      Z(5) = Z(6)
      Z(6) = Z(7)
      Z(7) = Z(8)
      NH1  = NH1 + 1
      NH2  = NH2 + 1
      SUM  = Z(2)
      MUS  = Z(2)
      DO 430 I = NH1,NH2
      Z(2) = MUS + I*1000000
      Z(3) = 0
C
C     OUTPUT TO GEOM(3) IF NOREG = 0
C     OUTPUT TO SCRTCH  IF NOREG = NON-ZERO
C
      IF (NOGO ) GO TO 380
      IF (NOREG) 420,410,420
  410 NFILE = GEOM(3)
      GO TO 430
  420 NFILE = SCRTCH
  430 CALL WRITE (NFILE,Z(1),7,NOEOR)
      GO TO 380
C
C     OUT OF CARDS
C
  440 IF (IAMT) 450,460,450
C
C     CHECK FOR RECORD INCONSISTANCY ERROR.
C
  450 REC(1) = RECIDX(1)
      REC(2) = RECIDX(2)
      REC(3) = RECIDX(3)
      ASSIGN 460 TO IERRTN
      GO TO 1490
C
  460 IF (NOREG) 470,590,470
C
C     CLOSE THE SCRTCH FILE AND THEN MERGE SCRTCH WITH AXIC
C     ON TO GEOM3
C
  470 I = 5
      ASSIGN 480 TO IRETRN
      GO TO 1380
C
C     OPEN SCRTCH FILE FOR INPUT AND LOCATE FORCE OR MOMENT CARDS ON
C     AXIC FILE.
C
  480 ASSIGN 490 TO IRETRN
      OP = INPRWD
      GO TO 1350
  490 CALL LOCATE (*1560,Z(IBUFF1),RECID(1),FLAG)
      IF (NOGO) GO TO 610
C
      CALL READ (*1600,*600,AXIC,Z(1),7,NOEOR,IAMT)
      CALL READ (*1610,*1610,SCRTCH,Z(8),7,NOEOR,IAMT)
C
  500 IF (Z(1) .LE. Z(8)) GO TO 510
C
      NFILE  = SCRTCH
      OUTBUF = 8
      GO TO 520
C
  510 NFILE  = AXIC
      OUTBUF = 1
C
  520 IF (NOGO) GO TO 610
      CALL WRITE (GEOM(3),Z(OUTBUF),7,NOEOR)
      CALL READ (*1620,*540,NFILE,Z(OUTBUF),7,NOEOR,IAMT)
      GO TO 500
C
C     OK ALL WORDS PROCESSED FOR FILE-NFILE
C
  540 IF (NFILE .EQ. AXIC) GO TO 550
      NFILE  = AXIC
      OUTBUF = 1
      GO TO 560
  550 NFILE  = SCRTCH
      OUTBUF = 8
  560 IF (NOGO) GO TO 610
      CALL WRITE (GEOM(3),Z(OUTBUF),7,NOEOR)
      CALL READ (*1620,*580,NFILE,Z(OUTBUF),7,NOEOR,IAMT)
      GO TO 560
C
C     CLOSE SCRTCH, WRITE EOR, AND PUT BITS IN TRAILER.
C
  580 I = 5
      ASSIGN 590 TO IRETRN
      GO TO 1380
  590 ASSIGN 610 TO IRETRN
      GO TO 1270
C
C     RECORD LENGTH ERROR
C
  600 REC(1) = RECID(1)
      REC(2) = RECID(2)
      REC(3) = RECID(3)
      ASSIGN 610 TO IERRTN
      GO TO 1490
C
  610 GO TO ICONT, (620,650)
C
C     GRAV CARD
C
  620 REC(1) = GRAV(1)
      REC(2) = GRAV(2)
      REC(3) = GRAV(3)
      ASSIGN 630 TO IRETRN
      GO TO 1230
C
C     LOAD CARD
C
  630 REC(1) = LOAD(1)
      REC(2) = LOAD(2)
      REC(3) = LOAD(3)
      ASSIGN 640 TO IRETRN
      GO TO 1230
C
C     MOMENT AND MOMAX CARDS
C
  640 RECID(1)  = MOMENT(1)
      RECID(2)  = MOMENT(2)
      RECID(3)  = MOMENT(3)
      RECIDX(1) = MOMAX(1)
      RECIDX(2) = MOMAX(2)
      RECIDX(3) = MOMAX(3)
      NCARD = 7
      ASSIGN 650 TO ICONT
      GO TO 290
C
C     PRESAX CARD
C
  650 CALL LOCATE (*722,Z(IBUFF1),PRESAX(1),FLAG)
C
C     RECORD HEADER FOR PRESAX CARDS IS FORMED HERE
C
      REC(1) = PRESAX(1)
      REC(2) = PRESAX(2)
      REC(3) = PRESAX(3)
      NCARD  = 13
      ASSIGN 660 TO IHEADR
      GO TO 1470
C
  660 CALL READ (*1600,*700,AXIC,Z(1),6,NOEOR,IAMT)
C
C     CREATE N+1 CARDS OF SAME LENGTH AS INPUT CARD.
C
C     CHECK RING ID-S IN FIELDS 3 AND 4 FOR PROPER SIZE.
C
C     CHECK FOR PIEZOELECTRIC
C
      PIEZ = .FALSE.
      IF (IPIEZ.EQ.1 .AND. Z(3).LT.0) PIEZ = .TRUE.
      IF (.NOT. PIEZ) GO TO 661
      Z(3) = -Z(3)
  661 CONTINUE
      NNN = Z(3)
      ASSIGN 670 TO IERRTN
      GO TO 1440
  670 NNN = Z(4)
      ASSIGN 680 TO IERRTN
      GO TO 1440
C
  680 DIFPHI = ABS(RZ(I6) - RZ(I5))
      DO 690 I = 1,NPLUS1
      Z(7) = I - 1
      Z(3) = Z(3) + 1000000
      IF (PIEZ) Z(3) = -Z(3)
      Z(4) = Z(4) + 1000000
      IF (NOGO) GO TO 690
      IF (DIFPHI .EQ. 0.0) GO TO 690
      IF (I.GT.1 .AND. ABS(DIFPHI-360.).LT.1.E-6) GO TO 690
      CALL WRITE (GEOM(3),Z(1),7,NOEOR)
      IF (PIEZ) Z(3) = -Z(3)
  690 CONTINUE
      GO TO 660
C
C     OUT OF PRESAX CARDS
C
  700 IF (IAMT) 710,720,710
C
C     CHECK FOR RECORD INCONSISTANCY ERROR.
C
  710 ASSIGN 722 TO IERRTN
      REC(1) = PRESAX(1)
      REC(2) = PRESAX(2)
      REC(3) = PRESAX(3)
      GO TO 1490
C
C     WRITE EOR AND PUT BITS IN TRAILER
C
  720 ASSIGN 722 TO IRETRN
      GO TO 1270
C
C     RFORCE CARD
C
 722  CALL LOCATE (*730,Z(IBUFF1),RFORCE(1),FLAG)
      REC(1) = RFORCE(1)
      REC(2) = RFORCE(2)
      REC(3) = RFORCE(3)
      NCARD  = 24
      ASSIGN 723 TO IHEADR
      GO TO 1470
C
C     PROCESS RFORCE DATA
C
  723 CALL READ (*1600,*725,AXIC,Z(1),7,NOEOR,IAMT)
      IF (Z(2).EQ.0 .AND. Z(3).EQ.0 .AND. Z(5).EQ.0 .AND. Z(6).EQ.0)
     1    GO TO 7240
      WRITE  (NOUT,724) UFM,Z(1)
  724 FORMAT (A23,' 336, RFORCE DATA IN SET NO.',I8,
     1       ' CONTAINS ILLEGAL DIRECTION FOR AXISYMMETRIC PROBLEM')
      NOGO = .TRUE.
      GO TO 723
 7240 Z(2) = 0
      Z(3) = 0
      Z(5) = 0
      Z(6) = Z(7)
      Z(7) = 0
      CALL WRITE (GEOM(3),Z(1),7,NOEOR)
      GO TO 723
C
C     END OF RFORCE CARDS
C
  725 IF (IAMT) 726,727,726
C
C     RECORD INCONSISTENCY ERROR
C
  726 ASSIGN 730 TO IERRTN
      REC(1) = RFORCE(1)
      REC(2) = RFORCE(2)
      REC(3) = RFORCE(3)
      GO TO 1490
C
C     WRITE EOR AND BITS IN TRAILER
C
  727 ASSIGN 730 TO IRETRN
      GO TO 1270
C
C     TEMPD CARD
C
  730 REC(1) = TEMPD(1)
      REC(2) = TEMPD(2)
      REC(3) = TEMPD(3)
      ASSIGN 740 TO IRETRN
      IF (NOGO) GO TO 740
      CALL LOCATE (*740,Z(IBUFF1),REC(1),FLAG)
      CALL WRITE (IFILE,REC(1),3,NOEOR)
      VEOR = 0
  735 CALL READ (*1600,*738,AXIC,Z(1),ICORE,NOEOR,IAMT)
      IAMT = ICORE
  736 DO 737 I = 1,IAMT,2
  737 Z(I) = Z(I) + 100000000
      CALL WRITE (IFILE,Z(1),IAMT,0)
      DO 739 I = 1,IAMT,2
  739 Z(I) = Z(I) + 100000000
      CALL WRITE (IFILE,Z(1),IAMT,VEOR)
      IF (VEOR) 1290,735,1290
  738 VEOR = 1
      GO TO 736
C
C     TEMPAX CARD
C
  740 CALL LOCATE (*1210,Z(IBUFF1),TEMPAX(1),FLAG)
C
C     RECORD HEADER ON GEOM3 FOR TEMP CARDS
C
      REC(1) = TEMP(1)
      REC(2) = TEMP(2)
      REC(3) = TEMP(3)
      NCARD  = 20
      ASSIGN 750 TO IHEADR
      GO TO 1470
C
C     AT 604(?) SET UP SCRATCH FILE.
C
  750 I    = 5
      BUFF = IBUFF3
      OP   = OUTRWD
      ASSIGN 760 TO IRETRN
      GO TO 1350
C
C     PICK UP FIRST TEMPAX CARD = 4 WORDS.
C
  760 LAST = 0
      CALL READ (*1600,*1200,AXIC,Z(1),4,NOEOR,IAMT)
  770 K = 0
      SETID = Z(1)
      RINGID= Z(2)
C
C     CHECK RING ID FOR PROPER RANGE OF VALUE
C
      NNN = RINGID
      ASSIGN 780 TO IERRTN
      GO TO 1440
C
  780 IAT = 3
  790 K   = K + 1
      IAT = IAT + 2
      ICRQ= IAT + 3 - ICORE
      IF (ICORE .LT. IAT+3) GO TO 1310
C
C     ALL TEMPAX CARDS HAVING SAME SET AND RING ID MUST BE ABLE TO
C     HAVE 2 WORDS EACH FIT IN CORE.
C
      Z(IAT  ) = Z(3)
      Z(IAT+1) = Z(4)
C
      CALL READ (*1600,*1130,AXIC,Z(1),4,NOEOR,IAMT)
C
C     DOES THIS CARD HAVE SAME SET AND RING ID AS LAST IN CURRENT SERIES
C
      IF (Z(1) .NE. SETID ) GO TO 800
      IF (Z(2) .NE. RINGID) GO TO 800
      GO TO 790
C
C     WE HAVE A  K X 2  ARRAY OF  PHI-S  AND T-S.
C
C     CONVERT ALL  PHIS SUCH THAT (0.LE. PHI .LT.TWOPI)
C
  800 IEND   = IAT + 1
      IBEGIN = 5
C
      DO 840 I = IBEGIN,IEND,2
      ANGLE = RZ(I)
      IF (ANGLE) 810,840,830
  810 IF (ANGLE) 820,840,840
  820 ANGLE = ANGLE + 360.0
      GO TO 810
C
  830 IF (ANGLE .LT. 360.0) GO TO 840
      ANGLE = ANGLE - 360.0
      GO TO 830
C
  840 RZ(I) = ANGLE*RADDEG
C
C     SIMPLE SORT FOR THE K X 2  MATRIX.
C     SORT IS PERFORMED ON COLUMN 1 ONLY
C
      IF (K .EQ. 1) GO TO 950
      ISTART = IBEGIN + 2
      DO 900 I = ISTART,IEND,2
      IAT = I - 2
      IF (RZ(I) .GE. RZ(IAT)) GO TO 900
C
C     ROW NOT HIGH ENOUGH.  MOVE IT UP.
C
  850 IAT = IAT - 2
      IF (IAT-IBEGIN) 870,870,860
  860 IF (RZ(I) .LT. RZ(IAT)) GO TO 850
      IAT = IAT + 2
      GO TO 880
  870 IAT = IBEGIN
C
C     THE ELEMENTS (I) AND (I+1) WILL BE MOVED UP TO POSITIONS (IAT) AND
C     (IAT+1) AND ELEMENTS (IAT) THRU (I-1) WILL BE  MOVED DOWN 1 ROW.
C
C     FIRST SAVE THE ROW BEING MOVED UP
C
  880 RZ(IEND+1) = RZ(I)
      RZ(IEND+2) = RZ(I+1)
      NMOVE = I - IAT
      IAT   = I + 2
      DO 890 J = 1,NMOVE
      IAT = IAT - 1
  890 RZ(IAT) = RZ(IAT-2)
C
C     REPLACE SAVE ROW IN NEW SLOT
C
      RZ(IAT-2) = RZ(IEND+1)
      RZ(IAT-1) = RZ(IEND+2)
C
  900 CONTINUE
C
C     CHECK FOR ANY DUPLICATE ANGLES AND REMOVE THEM...
C
      IBEGIN = IBEGIN + 2
  910 DO 920 I = IBEGIN,IEND,2
      IF (Z(I) .EQ. Z(I-2)) GO TO 930
  920 CONTINUE
      GO TO 950
C
C     DUPLICATE, SHRINK LIST UP OVER IT.
C
  930 IEND = IEND - 2
      K=K-1
      DO 940 J = I,IEND,2
      Z(J  ) = Z(J+2)
  940 Z(J+1) = Z(J+3)
      IBEGIN = I
      IF (IBEGIN - IEND) 910,950,950
C
C     SET UP K + 1  CARD
C
  950 RZ(IEND+1) = RZ(I5) + TWOPI
      RZ(IEND+2) = RZ(I6)
C
C     THERE ARE K CARDS NOW WITH SETID, AND RINGID, NOT INCLUDING THE
C     K + 1ST CARD
C
C     N+1 TEMP CARDS FOR S SET (PUT ON GEOM3)
C     N+1 TEMP CARDS FOR C SET (PUT ON SCRTCH FOR NOW)
C
C     NOTE FMMS-52  (10/04/67) PAGE -9- FOR FOLLOWING...
C
      CSSET = 1
      SETID = SETID + 100000000
C
C     CSSET = 0 FOR C-SET  AND NON-ZERO FOR S-SET.
C
      IBEGIN = K + K + 7
      ICRQ   = IBEGIN + 2 - ICORE
      IF ((IBEGIN+2) .GT. ICORE) GO TO 1310
C
  960 NADD = 0
      Z(IBEGIN) = SETID
      DO 1100 I = 1,NPLUS1
      NADD = NADD + 1000000
C
C     NI IS REAL
C
      NI   = I - 1
      NISQ = (I-1)**2
      Z(IBEGIN+1) = RINGID + NADD
      IPHI = 3
      IT   = 4
      SUM  = 0.0E0
      IF (NI   ) 1010,970,1010
  970 IF (CSSET) 1000,980,1000
  980 DO 990 IK = 1,K
      IPHI = IPHI + 2
      IT   = IT   + 2
  990 SUM  = SUM  + (RZ(IT)+RZ(IT+2))*(RZ(IPHI+2)-RZ(IPHI))
 1000 RZ(IBEGIN+2) = 0.25*SUM/PI
      GO TO 1060
C
C     NON-ZERO NI
C
 1010 IF (K .EQ. 1) GO TO 1050
      DO 1040 IK = 1,K
      IPHI = IPHI + 2
      IT   = IT   + 2
      NPHI = NI*RZ(IPHI  )
      NPHI1= NI*RZ(IPHI+2)
C
      IF (CSSET) 1030,1020,1030
C
C     C-SET
C
 1020 A1 =  SIN(NPHI1)
      A2 = -SIN(NPHI )
      A3 =  COS(NPHI1)
      A4 = -COS(NPHI )
      GO TO 1040
C
C     S-SET
C
 1030 A1 = -COS(NPHI1)
      A2 =  COS(NPHI )
      A3 =  SIN(NPHI1)
      A4 = -SIN(NPHI )
C
C
 1040 SUM = SUM + (((RZ(IT)*RZ(IPHI+2) - RZ(IT+2)*RZ(IPHI))*
     1      (A1 + A2)/NI) + ((RZ(IT+2) - RZ(IT))*
     2      (A3 + A4 + NPHI1*A1 + NPHI*A2)/NISQ))/
     3      (RZ(IPHI+2) - RZ(IPHI))
C
 1050 RZ(IBEGIN+2) = SUM/PI
C
 1060 IF (NOGO ) GO TO 1105
      IF (CSSET) 1070,1080,1070
 1070 NFILE = GEOM(3)
      GO TO 1090
 1080 NFILE = SCRTCH
 1090 CALL WRITE (NFILE,Z(IBEGIN),3,NOEOR)
 1100 CONTINUE
 1105 IF (CSSET) 1110,1120,1110
 1110 CSSET = 0
      SETID = SETID + 100000000
      GO TO 960
C
C     THIS SERIES OF TEMPAX CARDS COMPLETE GO FOR MORE IF LAST = 0
C
 1120 IF (LAST) 1140,770,1140
 1130 LAST = 1
      GO TO 800
C
C     ALL TEMPAX CARDS COMPLETE. CLOSE SCRATCH, OPEN SCRATCH
C     AND COPY SCRATCH TO GEOM3.
C
 1140 IF (NOGO) GO TO 1210
      CALL WRITE (SCRTCH,Z(1),0,EOR)
      CALL CLOSE (SCRTCH,CLORWD)
      CALL OPEN  (*1640,SCRTCH,Z(IBUFF3),INPRWD)
C
      VEOR = 0
 1150 CALL READ (*1610,*1170,SCRTCH,Z(1),ICORE,NOEOR,IAMT)
      IAMT = ICORE
 1160 CALL WRITE (GEOM(3),Z(1),IAMT,VEOR)
      IF (VEOR) 1180,1150,1180
 1170 VEOR = 1
      GO TO 1160
C
C     ALL  TEMPAX  CARDS  PROCESSED.
C
 1180 CALL CLOSE (SCRTCH,CLORWD)
C
C     PUT BITS IN TRAILER FOR TEMP CARDS WRITTEN
C
      REC(1) = TEMP(1)
      REC(2) = TEMP(2)
      REC(3) = TEMP(3)
      ASSIGN 1210 TO IRETRN
      GO TO 1290
C
C     RECORD LENGTH ERROR
C
 1200 REC(1) = TEMPAX(1)
      REC(2) = TEMPAX(2)
      REC(3) = TEMPAX(3)
      ASSIGN 1210 TO IERRTN
      GO TO 1490
C
C     CLOSE GEOM3
C
 1210 I = 3
      ASSIGN 1220 TO IRETRN
      GO TO 1380
C
C     CTRIAAX CARD
C
 1700 REC(1) = CTRIAA (1)
      REC(2) = CTRIAA (2)
      REC(3) = CTRIAA (3)
      NCARD  = 43
      CALL LOCATE (*1800,Z(IBUFF1),REC(1),FLAG)
C
C     RECORD HEADER FOR CTRIAAX
C
      ASSIGN 1710 TO IHEADR
      ICONB  = 2
      ICONSO = 1
      GO TO 1470
 1710 CALL READ (*1600,*1770,AXIC,Z(1),6,NOEOR,IAMT)
      Z(1) = Z(1)*1000
      DO 1720 I = 1,NPLUS1
      Z(1) = Z(1) + 1
      Z(3) = Z(3) + 1000000
      Z(4) = Z(4) + 1000000
      Z(5) = Z(5) + 1000000
      IF (NOGO) GO TO 1720
      CALL WRITE (GEOM(2),Z(1),6,NOEOR)
 1720 CONTINUE
      GO TO 1710
C
C     OUT OF CTRIAAX CARD
C
 1770 IF (IAMT) 1730,1740,1730
 1730 ASSIGN 260 TO IERRTN
      GO TO 1490
C
C     PUT BITS IN TRILER
C
 1740 ASSIGN 260 TO IRETRN
      GO TO 1270
 1800 IF (ICONSO .EQ. 1) GO TO 1740
      ASSIGN 260 TO IERRTN
C
C     MISSING REQUIRED CCONEAX OR CTRIAAX OR CTRAPAX CARD
C
      CALL PAGE2 (3)
      IMSG = 362
      WRITE (NOUT,185) UFM,IMSG
      WRITE (NOUT,1910) CDTYPE(3),CDTYPE(4),CDTYPE(43),CDTYPE(44),
     1                  CDTYPE(45),CDTYPE(46)
 1910 FORMAT (5X,'MINIMUM PROBLEM REQUIRES ',2A4,2H,  ,2A4,4H OR ,2A4,
     1       ' CARD.  NONE FOUND')
      NOGO = .TRUE.
      GO TO IERRTN, (260,240)
C
C     CTRAPAX CARD
C     ============
C
 1750 REC(1) = CTRAPA (1)
      REC(2) = CTRAPA (2)
      REC(3) = CTRAPA (3)
      CALL LOCATE (*1700,Z(IBUFF1),REC(1),FLAG)
      ICONB  = 1
C
C     RECORD HEADER FOR CTRAPAX
C
      ASSIGN 1751 TO IHEADR
      ICONSO = 1
      GO TO 1470
 1751 CALL READ (*1600,*1753,AXIC,Z(1),7,NOEOR,IAMT)
      Z(1) = Z(1)*1000
      DO 1752 I = 1,NPLUS1
      Z(1) = Z(1) + 1
      Z(3) = Z(3) + 1000000
      Z(4) = Z(4) + 1000000
      Z(5) = Z(5) + 1000000
      Z(6) = Z(6) + 1000000
      IF (NOGO) GO TO 1752
      CALL WRITE (GEOM(2),Z(1),7,NOEOR)
 1752 CONTINUE
      GO TO 1751
C
C     OUT OF CTRAPAX CARD
C
 1753 IF (IAMT) 1754,1755,1754
 1754 ASSIGN 260 TO IERRTN
      GO TO 1490
C
C     PUT BITS IN TRILER
C
 1755 ASSIGN 260 TO IRETRN
      IF (NOGO) GO TO 1300
      CALL WRITE (IFILE,Z(1),IAMT,EOR)
      I1 = (REC(2)-1)/16 + 2
      I2 = REC(2) - (I1-2)*16 + 16
      TRAIL (I1) = ORF(TRAIL(I1),TWO(I2))
      GO TO 1700
C
C     GEOM4 AND GEOM1 PROCESSING IS PERFORMED IN IFP3B ROUTINE
C                                                =====
C
 1220 CALL IFP3B
      GO TO 1570
C
C     UTILITY SECTION FOR IFP3
C     AXIS-SYMETRIC-CONICAL-SHELL DATA GENERATOR.
C     ==========================================
C
C     COMMON CODE FOR TRANSFER OF RECORD FROM AXIC FILE TO SOME
C     OTHER FILE
C
 1230 CALL LOCATE (*1300,Z(IBUFF1),REC(1),FLAG)
      IF (NOGO) GO TO 1300
      CALL WRITE (IFILE,REC(1),3,NOEOR)
 1260 CALL READ (*1600,*1270,AXIC,Z(1),ICORE,NOEOR,IAMT)
      IAMT = ICORE
      CALL WRITE (IFILE,Z(1),IAMT,NOEOR)
      GO TO 1260
 1270 IF (NOGO) GO TO 1300
      IF (IFILE .EQ. GEOM(3)) GO TO 1280
      IF (IFILE.EQ.GEOM(2) .AND. ICONB.EQ.1) GO TO 1300
 1280 CALL WRITE (IFILE,Z(1),IAMT,EOR)
C
C     PUT BITS IN TRAILER
C
 1290 I1 = (REC(2)-1)/16 + 2
      I2 =  REC(2) - (I1-2)*16 + 16
      TRAIL(I1) = ORF(TRAIL(I1),TWO(I2))
C
 1300 GO TO IRETRN, (250,260,610,630,640,722,730,740,1210)
C
C     OUT OF CORE
C
 1310 CALL PAGE2 (4)
      IMSG = 363
      WRITE  (NOUT, 185) IMSG
      WRITE  (NOUT,1320) ICRQ
 1320 FORMAT (5X,'INSUFFICIENT CORE TO PROCESS AXIC DATA IN SUBROUTINE',
     1       'IFP3', /5X,'ADDITIONAL CORE NEEDED =',I8,' WORDS.')
      NOGO = .TRUE.
C
C     GO TO FATAL ERROR RETURN
C
      GO TO 1570
C
C     AXIC FILE NOT IN FIST
C
 1330 CALL PAGE2 (3)
      IMSG = 1061
      WRITE (NOUT,55) SFM,IMSG
      WRITE (NOUT,60) AXIC,INAME(11),INAME(12),IFIST
      NOGO = .TRUE.
C
C     GO TO FATAL ERROR RETURN
C
      GO TO 1570
C
C     OPEN A FILE AND GET THE TRAILER
C
 1350 IF (NOGO) GO TO 1360
      CALL OPEN (*1370,FILE(I),Z(BUFF),OP)
      OPENFL(I) = 1
      IF (I .GT. 4) GO TO 1360
C
C     WRITE THE HEADER RECORD
C
      CALL WRITE (FILE(I),INAME(2*I-1),2,EOR)
      TRAIL(1) = FILE(I)
      CALL RDTRL (TRAIL(1))
C
 1360 GO TO IRETRN, (150,280,370,760,490)
C
 1370 CALL PAGE2 (3)
      IMSG = 1061
      WRITE (NOUT,55) SFM,IMSG
      WRITE (NOUT,60) FILE(I),INAME(2*I-1),INAME(2*I),IFIST
      NOGO = .TRUE.
      GO TO 1570
C
C     CLOSE A FILE
C
 1380 IF (OPENFL(I)) 1390,1410,1390
 1390 IF (I.GT. 4) GO TO 1400
      CALL WRITE (FILE(I),T65535(1),3,EOR)
 1400 CALL CLOSE (FILE(I),CLORWD)
      OPENFL(I) = 0
      IF (I .GT. 4) GO TO 1410
      CALL WRTTRL (TRAIL(1))
 1410 GO TO IRETRN, (270,590,1220,480)
C
C     HARMONIC NUMBER ... ON CARD TYPE ...... IS OUT OF RANGE 0 TO 998
C
 1420 IF (NNN.LT.999 .AND. NNN.GE.0 .AND. NNN.LE.N)
     1    GO TO IERRTN, (140,400,397)
      CALL PAGE2 (3)
      IMSG = 364
      WRITE  (NOUT,185 ) UFM,IMSG
      WRITE  (NOUT,1430) NNN,CDTYPE(2*NCARD-1),CDTYPE(2*NCARD),N
 1430 FORMAT (5X,'HARMONIC NUMBER ',I6,4H ON ,2A4,' CARD OUT OF 0 TO ',
     1        I4,' ALLOWABLE RANGE.')
      NOGO = .TRUE.
      GO TO IERRTN, (140,400,397)
C
C     RING ID OUT OF PERMISSABLE RANGE OF 1 TO 999999
C
 1440 IF (NNN.GT.0 .AND. NNN.LE.999999)
     1    GO TO IERRTN, (170,180,390,670,680,780)
      CALL PAGE2 (3)
      IMSG = 365
      WRITE  (NOUT,185 ) UFM,IMSG
      WRITE  (NOUT,1450) NNN,CDTYPE(2*NCARD-1),CDTYPE(2*NCARD)
 1450 FORMAT (5X,'RING ID',I10,4H ON ,2A4,' CARD OUT OF 1 TO 999999 ',
     1       'ALLOWABLE RANGE')
      NOGO = .TRUE.
      GO TO IERRTN, (170,180,390,670,680,780)
C
C     CHECK BIT-IBIT IN TRAILER AND RETURN NON = ZERO OR NON-ZERO...
C
 1460 I1 = (IBIT-1)/16 + 2
      I2 = IBIT - (I1-2)*16 + 16
      NON = ANDF(AXTRL(I1),TWO(I2))
      GO TO IBITR, (300,310)
C
C     WRITE 3 WORD RECORD HEADER
C
 1470 IF (NOGO) GO TO 1480
      CALL WRITE (IFILE,REC(1),3,NOEOR)
 1480 GO TO IHEADR, (160,350,660,723,750,1710,1751)
C
C     END-OF-RECORD ON AXIC FILE
C
 1490 CALL PAGE2 (3)
      IMSG = 1063
      WRITE  (NOUT,55) SFM,IMSG
      WRITE  (NOUT,1500) CDTYPE(2*NCARD-1),CDTYPE(2*NCARD)
 1500 FORMAT (5X,'EOR ON AXIC FILE WHILE READING ',2A4,'CARD RECORDS.')
      NOGO = .TRUE.
      GO TO IERRTN, (260,460,610,722,730,1210)
C
C     MISSING REQUIRED CARD
C
 1510 CALL PAGE2 (3)
      IMSG = 362
      WRITE  (NOUT,185 ) UFM,IMSG
      WRITE  (NOUT,1520) CDTYPE(2*NCARD-1),CDTYPE(2*NCARD)
 1520 FORMAT (5X,'MINIMUM PROBLEM REQUIRES ',2A4,' CARD.  NONE FOUND.')
      NOGO = .TRUE.
      GO TO IERRTN, (260,140)
C
C     AXIC TRAILER BIT ON BUT CAN NOT LOCATE RECORD
C
 1530 CALL PAGE2 (3)
      IMSG = 1064
      WRITE  (NOUT,55) SFM,IMSG
      WRITE  (NOUT,1540) CDTYPE(2*NCARD-1),CDTYPE(2*NCARD)
 1540 FORMAT (5X,2A4,' CARD COULD NOT BE LOCATED ON AXIC FILE AS ',
     1       'EXPECTED')
 1550 NOGO = .TRUE.
      GO TO 610
 1560 CALL PAGE2 (2)
      WRITE (NOUT,1540) RECID(1),RECID(2),RECID(3)
      GO TO 1550
C
C     CLOSE ANY OPEN FILES AND RETURN
C
 1570 DO 1590 I = 1,6
      IF (OPENFL(I)) 1580,1590,1580
 1580 CALL CLOSE (FILE(I),CLORWD)
      OPENFL(I) = 0
 1590 CONTINUE
      IF (NOGO) NOFLAG = 32767
      CALL CONMSG (MSG2,2,0)
      RETURN
C
C     EOF ENCOUNTERED READING AXIC FILE.
C
 1600 NFILE = AXIC
      IN  = 11
      IN1 = 12
      GO TO 1620
 1610 NFILE = SCRTCH
      IN  = 9
      IN1 = 10
 1620 CALL PAGE2 (3)
      IMSG = 3002
      WRITE  (NOUT,55) SFM,IMSG
      WRITE  (NOUT,1630) INAME(IN),INAME(IN1),NFILE
 1630 FORMAT (5X,'EOF ENCOUNTERED WHILE READING DATA SET ',2A4,' (FILE',
     1        I4,') IN SUBROUTINE IFP3')
      NOGO = .TRUE.
      GO TO 1570
C
 1640 I = 5
      GO TO 1370
      END

      SUBROUTINE ODUMX (Z)
C
      ENTRY ODUM1 (Z)
      GO TO 10
C
      ENTRY ODUM2 (Z)
      GO TO 10
C
      ENTRY ODUM3 (Z)
      GO TO 10
C
      ENTRY ODUM4 (Z)
      GO TO 10
C
      ENTRY ODUM5 (Z)
      GO TO 10
C
      ENTRY ODUM6 (Z)
      GO TO 10
C
      ENTRY ODUM7 (Z)
      GO TO 10
C
      ENTRY ODUM8 (Z)
      GO TO 10
C
      ENTRY ODUM9 (Z)
C
   10 NOTUSE = Z
      RETURN
      END

      SUBROUTINE GKAD
C
C     GENERAL K ASSEMBLER DIRECT
C
C     INPUT = 10,  USETD,GM,GO,KAA,BAA,MAA,K4AA,K2PP,M2PP,B2PP
C     OUTPUT = 8,  KDD,BDD,MDD,GMD,GOD,K2DD,M2DD,B2DD
C     SCRATCHES = 6
C     PARAMETERS 3 BCD, 3 REAL, 11 INTERGER
C     - TYPE,APP,FORM, G,W3,W4, NOK2PP,MOM2PP,NOB2PP,MULTI,SINGLE,OMIT,
C       NOUE,NOK4GG,NOBGG,NOKMGG,MODACC
C
C
      INTEGER         TYPE(2),APP(2),FORM(2),IBLOCK(11),BLCK(12),MCB(7),
     1                TRAN,FORC,OMIT,BAA,B2PP,B2DD,B1DD,SCR1,SCR2,SCR3,
     2                SCR4,SCR5,SCR6,GM,GO,GOD,GMD,BDD,USETD,SINGLE
      DOUBLE PRECISION BLOCK(5)
      COMMON /BLANK / TYPE,APP,FORM, G,W3,W4, IK2PP,IM2PP,IB2PP,MULTI,
     1                SINGLE,OMIT,NOUE,NOK4GG,NOBGG,NOKMGG,MODACC
      COMMON /BITPOS/ UM,UO,UR,USG,USB,UL,UA,UF,US,UN,UG,UE,UP,UNE,UFE,
     1                UD
      EQUIVALENCE     (IBLOCK(1),BLCK(2)),(BLOCK(1),BLCK(3))
      DATA    USETD , GM, GO, KAA,BAA,MAA,K4AA,K2PP,M2PP,B2PP /
     1        101   , 102,103,104,105,106,107, 108, 109, 110  /
      DATA    KDD   , BDD,MDD,GMD,GOD,K2DD,M2DD,B2DD /
     1        201   , 202,203,204,205,206, 207, 208  /
      DATA    SCR1  , SCR2,SCR3,SCR4,SCR5,SCR6 /
     1        301   , 302, 303, 304, 305, 306  /
      DATA    FORC  , TRAN,MODAL / 4HFORC,4HTRAN,4HMODA     /
      DATA    BLOCK(1),BLOCK(2),BLOCK(4),BLOCK(5),IBLOCK(1),IBLOCK(7) /
     1        1.0D0 , 0.0D0,    1.0D0,   0.0D0,   2,        2         /
      DATA    XNUM  , MCB / 1.0,7*0  /  ,IBLOCK(6) /    -1  /
C
C
      KDD   = 201
      BDD   = 202
      MDD   = 203
      K2DD  = 206
      M2DD  = 207
      B2DD  = 208
      K1DD  = 302
      M1DD  = 303
      B1DD  = 304
      K41DD = 305
      SCR3  = 303
      SCR4  = 304
      IF (NOUE .GT. 0) GO TO 10
C
C     NO E-S A = 1DD
C
      K1DD  = KAA
      B1DD  = BAA
      M1DD  = MAA
      K41DD = K4AA
   10 IF (TYPE(1) .EQ. TRAN) GO TO 20
C
C     COMPLEX EIGENVALUE OR FREQUENCY RESPONSE - SET UP FOR FINAL ADD
C
      IF (IB2PP .LT. 0) B1DD = BDD
      IF (IM2PP .LT. 0) M1DD = MDD
      GO TO 50
C
C     TRANSIENT ANALYSIS - SETUP FOR FINAL ADD
C
   20 IF (IK2PP .LT. 0) K1DD = KDD
      IF (IM2PP .LT. 0) M1DD = MDD
      IF (W3 .NE.  0.0) GO TO 30
      G  = 0.0
      W3 = 1.0
   30 IF (W4 .NE. 0.0) GO TO 50
      W4   = 1.0
      XNUM = 0.0
   50 IF (APP(1) .NE. FORC) GO TO 60
C
C     FORCE APPROACH P = D
C
      K2DD = K2PP
      B2DD = B2PP
      M2DD = M2PP
      GO TO 140
C
C     DISPLACEMENT APPROACH - REDUCE P TO D
C
C     IF MODAL DO NOT MAKE KDD AND BDD
C
   60 IF (FORM(1) .NE. MODAL) GO TO 70
      KDD  = 0
      K1DD = 0
      BDD  = 0
      B1DD = 0
   70 IF (NOUE .LT. 0) GO TO 100
C
C     BUILD GMD AND GOD
C
C     M-S PRESENT
C
      IF (MULTI .GE. 0) CALL GKAD1A (USETD,GM,GMD,SCR1,UE,UN,UNE)
C
C     0-S PRESENT
C
      IF (OMIT .GE. 0) CALL GKAD1A (USETD,GO,GOD,SCR1,UE,UA,UD)
C
  100 IF (MULTI.LT.0 .AND. SINGLE.LT.0 .AND. OMIT .LT.0) GO TO 130
      IF (IM2PP.LT.0 .AND. IB2PP .LT.0 .AND. IK2PP.LT.0) GO TO 130
C
C     REDUCE 2PP-S TO 2DD-S
C
      CALL GKAD1C (GMD,GOD,SCR1,SCR2,SCR3,SCR4,SCR5,SCR6,USETD)
      IF (IK2PP .GE. 0) CALL GKAD1D (K2PP,K2DD)
      IF (IM2PP .GE. 0) CALL GKAD1D (M2PP,M2DD)
      IF (IB2PP .GE. 0) CALL GKAD1D (B2PP,B2DD)
  130 IF (FORM(1).EQ.MODAL .AND. MODACC.LT.0) GO TO 180
      IF (NOUE .LT. 0) GO TO 140
C
C     EXPAND AA-S TO DD SET
C
      CALL GKAD1B (USETD,KAA,MAA,BAA,K4AA,K1DD,M1DD,B1DD,K41DD,UA,UE,
     1             UD,SCR1)
  140 IF (TYPE (1) .EQ. TRAN) GO TO 190
C
C     FREQUENCY RESPONSE OR COMPLEX EIGENVALUE
C
      IF (B1DD.EQ.BDD .OR. NOBGG.LT.0 .OR. FORM(1).EQ.MODAL) GO TO 150
      CALL SSG2C (B1DD,B2DD,BDD,1,IBLOCK(1))
  150 IF (M1DD.EQ.MDD .OR. NOKMGG.LT.0) GO TO 160
      CALL SSG2C (M1DD,M2DD,MDD,1,IBLOCK(1))
  160 IF (K1DD.EQ.KDD .OR. FORM(1).EQ.MODAL .OR. NOKMGG.LT.0) GO TO 180
      IBLOCK(1) = 4
      BLOCK(2)  = G
      IF (NOK4GG .LT. 0) SCR4 = KDD
C
C     DETERMINE IF KDD IS REAL OR IMAGINARY  (COMPLEX EIGEN)
C
      MCB(1) = K2DD
      CALL RDTRL (MCB(1))
      IF (G.NE.0.0 .OR. NOK4GG.GT.0 .OR. MCB(5).GT.2) GO TO 170
      IBLOCK(1) = 2
      IBLOCK(7) = 2
  170 CALL SSG2C (K1DD,K2DD,SCR4,1,IBLOCK)
      IF (NOK4GG .LT. 0) GO TO 180
      BLOCK(1) = 0.0D0
      BLOCK(2) = 1.0D0
      CALL SSG2C (K41DD,SCR4,KDD,1,IBLOCK(1))
  180 RETURN
C
C     TRANSIENT ANALYSIS
C
  190 IBLOCK(1) = 2
      IBLOCK(7) = 2
      IF (K1DD.EQ.KDD .OR. NOKMGG.LT.0) GO TO 200
      CALL SSG2C (K1DD,K2DD,KDD,1,IBLOCK(1))
  200 IF (M1DD.EQ.MDD .OR. NOKMGG.LT.0) GO TO 210
      CALL SSG2C (M1DD,M2DD,MDD,1,IBLOCK(1))
  210 IF (B1DD .EQ. BDD) GO TO 180
      BLOCK(1) = G/W3
      BLOCK(4) = XNUM/W4
      IF (G.EQ.0.0 .AND. XNUM.EQ.0.0 .AND. NOBGG.LT.0 .AND. IB2PP.LT.0)
     1    GO TO 180
      IF (NOBGG.LT.0 .AND. IB2PP.LT.0) SCR3 = BDD
      CALL SSG2C (K1DD,K41DD,SCR3,1,IBLOCK(1))
      IF (SCR3 .EQ. BDD) GO TO 180
      BLOCK(1) = 1.0D0
      BLOCK(4) = 1.0D0
      CALL SSG2C (B1DD,B2DD,SCR5,1,IBLOCK(1))
      CALL SSG2C (SCR5,SCR3,BDD, 1,IBLOCK(1))
      GO TO 180
      END

      SUBROUTINE SSGHTP(ORDER,Z,LZ)
C*****
C  SPECIAL IN-PLACE PARTITIONING ROUTINE USED ONLY BY SSGHT MODULE.
C*****
      INTEGER ORDER(LZ), Z(LZ), SAVE1, SAVE2, PTR
      I = 1
      ISAVE = 1
C
C     CHECK TO SEE THAT POINTER TO NEXT SLOT HAS NOT BEEN USED YET.
C
   10 PTR = ORDER(I)
      IF( PTR .GT. 1000000 ) GO TO 40
      ORDER(I) = PTR + 1000000
C
C     IF THE MOVE-TO LOCATION IS THE SAME, THEN DO NOTHING.
C
      IF( PTR .EQ. I ) GO TO 40
C
C     SAVE VALUE CURRENTLY IN SLOT WE ARE MOVING TO.
C
      SAVE1 = Z(PTR)
C
C     MOVE ITEM INTO SLOT
C
      Z(PTR) = Z(I)
C
C     SET POINTER TO WHERE -SAVE1- IS TO BE MOVED.
C
   20 JPTR = ORDER(PTR)
      IF( JPTR .GT. 1000000 ) GO TO 30
      ORDER(PTR) = JPTR + 1000000
      SAVE2 = Z(JPTR)
      Z(JPTR) = SAVE1
      SAVE1 = SAVE2
      PTR = JPTR
      GO TO 20
C
C     END OF CHAIN.  GO BACK AND LOOK FOR ANOTHER.
C
   30 I = ISAVE + 1
      GO TO 50
   40 I = I + 1
   50 ISAVE = I
      IF( I .LE. LZ ) GO TO 10
C
C     CLEAR OUT FLAGS AND RETURN.
C
      DO 60 I = 1,LZ
      ORDER(I) = ORDER(I) - 1000000
   60 CONTINUE
      RETURN
      END

      SUBROUTINE BARD
C
C     THIS SUBROUTINE PROCESSES BAR  ELEMENT DATA TO PRODUCE STIFFNESS
C     AND MASS MATRICES. IF THE HEAT TRANSFER OPTION IS ON, CONDUCTIVITY
C     AND CAPACITY  MATRICES ARE PRODUCED.
C
C     DOUBLE PRECISION VERSION
C     THIS ROUTINE WILL PRODUCE MASS MATRICES BY EITHER THE CONSISTENT
C     OR CONVENTIONAL MASS METHODS.
C     THE ECPT/EST  ENTRIES FOR THE BAR (ELEMENT TYPE 34) ARE
C
C
C     ECPT( 1)  -  IELID          ELEMENT ID. NUMBER
C     ECPT( 2)  -  ISILNO(2)      * SCALAR INDEX NOS. OF THE GRID POINTS
C     ECPT( 3)  -    ...          *
C     ECPT( 4)  -  SMALLV(3)      $ REFERENCE VECTOR
C     ECPT( 5)  -    ...          $
C     ECPT( 6)  -    ...          $
C     ECPT( 7)  -  ICSSV          COOR. SYS. ID FOR SMALLV VECTOR
C     ECPT( 8)  -  IPINFL(2)      * PIN FLAGS
C     ECPT( 9)  -    ...          *
C     ECPT(10)  -  ZA(3)          $ OFFSET VECTOR FOR POINT A
C     ECPT(11)  -    ...          $
C     ECPT(12)  -    ...          $
C     ECPT(13)  -  ZB(3)          * OFFSET VECTOR FOR POINT B
C     ECPT(14)  -    ...          *
C     ECPT(15)  -    ...          *
C     ECPT(16)  -  IMATID         MATERIAL ID.
C     ECPT(17)  -  A              CROSS-SECTIONAL AREA
C     ECPT(18)  -  I1             $ AREA MOMENTS OF INERTIA
C     ECPT(19)  -  I2             $
C     ECPT(20)  -  FJ             TORSIONAL CONSTANT
C     ECPT(21)  -  NSM            NON-STRUCTURAL MASS
C     ECPT(22)  -  FE             FORCE ELEM DESCRIPTIONS (FORCE METHOD)
C     ECPT(23)  -  C1             * STRESS RECOVERY COEFFICIENTS
C     ECPT(24)  -  C2             *
C     ECPT(25)  -  D1             *
C     ECPT(26)  -  D2             *
C     ECPT(27)  -  F1             *
C     ECPT(28)  -  F2             *
C     ECPT(29)  -  G1             *
C     ECPT(30)  -  G2             *
C     ECPT(31)  -  K1             $ AREA FACTORS FOR SHEAR
C     ECPT(32)  -  K2             $
C     ECPT(33)  -  I12            AREA MOMENT OF INERTIA
C     ECPT(34)  -  MCSIDA         COOR. SYS. ID. FOR GRID POINT A
C     ECPT(35)  -  GPA(3)         * BASIC COORDINATES FOR GRID POINT A
C     ECPT(36)  -    ...          *
C     ECPT(37)  -    ...          *
C     ECPT(38)  -  MCSIDB         COOR. SYS. ID. FOR GRID POINT B
C     ECPT(39)  -  GPB(3)         $ BASIC COORDINATES FOR GRID POINT B
C     ECPT(40)  -    ...          $
C     ECPT(41)  -    ...          $
C     ECPT(42)  -  ELTEMP         AVG. ELEMENT TEMPERATURE
C
      LOGICAL          BASIC,OFFSET,NOGO,AOFSET,BOFSET
      INTEGER          DICT(7),IS12OR(4),IS21OR(4),GSUBE,ESTID,IECPT(38)
      REAL             K1,K2,I1,I2,I12,NSM
      DIMENSION        ECPT(42),IPIN(10),IKK(4)
      DOUBLE PRECISION CONST,BL22,BLSQ3,FM,KE,KK,KEP,M,MEP,ME,
     1                 LR1,LR2,LB,L2B3,L2B6,VECI(3),VECJ(3),VECK(3),
     2                 SMALVN,TA,TB,VEC,DELA,DELB,FL,SMALLV(3),
     3                 FLL,BL,BLSQ,BLCUBE,EI1,EI2,R1,R2,SK1,SK2,
     4                 SK3,SK4,AEL,GJL,BETA,BL13,BLSQ4,A2B,LIMIT,
     5                 EPSI,EPSI2
      CHARACTER        UFM*23,UWM*25
      COMMON /XMSSG /  UFM,UWM
      COMMON /SYSTEM/  KSYSTM(100)
      COMMON /EMGEST/  IELID,ISILNO(2),SMALV(3),ICSSV,IPINFL(2),ZA(3),
     1                 ZB(3),IMATID,A,I1,I2,FJ,NSM,FE,C1,C2,D1,D2,
     2                 F1,F2,G1,G2,K1,K2,I12,MCSIDA,GPA(3),MCSIDB,
     3                 GPB(3),TEMPEL
      COMMON /EMGPRM/  IXTRA,JCORE,NCORE,DUM(12),ISTIF,IMASS,IDAMP,
     1                 IPREC,NOGO,HEAT,ICMBAR,LCSTM,LMAT,LHMAT
      COMMON /EMGDIC/  IDUMM, LDICT,NGRIDS,ELID,ESTID
      COMMON /EMGTRX/  KE(144),KEP(144),M(12,12),ME(144),MEP(144),
     1                 KK(144),SMALVN(6),TA(18),TB(9),VEC(10),
     2                 DELA(6),DELB(6)
      COMMON /MATIN /  MATIDC,MATFLG,ELTEMP,STRESS,SINTH,COSTH
      COMMON /MATOUT/  E,G,NU,RHO,ALPHA,TSUBO,GSUBE,SIGT,SIGC,SIGS
      COMMON /HMTOUT/  FK
      EQUIVALENCE      (KSYSTM(2),IOUTPT),(KSYSTM(56),IHEAT),
     1                 (ECPT(1),IECPT(1),IELID),(KSYSTM(87),KSY87),
     2                 (VEC(1),VECI(1)),(VEC(4),VECJ(1)),
     3                 (VEC(7),VECK(1))
      DATA    IKK   /  1,7,73,79   /, EPSI,EPSI2 / 1.0D-18,1.0D-7 /
      DATA    IS12OR/  1,37,109,73 /, IS21OR     / 73,109,37,1    /
C
C
      DICT(1) = ESTID
C
C     SET UP POINTERS TO COOR. SYS. IDS., OFFSET VECTORS, AND PIN FLAGS.
C     ICSIDA AND ICSIDB ARE COOR. SYS. IDS.
C
      JCSIDA = 34
      JCSIDB = 38
      JOFSTA = 10
      JOFSTB = 13
      JPINA  =  8
      JPINB  =  9
      ICSIDA = IECPT(34)
      ICSIDB = IECPT(38)
      LIMIT  = DBLE(IABS(KSY87))*.01D0
C
C     NORMALIZE THE REFERENCE VECTOR WHICH LIES IN THE FIRST PRINCIPAL
C     AXIS PLANE  (FMMS - 36 P. 4)
C
      FL = 0.D0
      DO 40 I = 1,3
      SMALLV(I) = SMALV(I)
   40 FL = FL + SMALLV(I)**2
      FL = DSQRT(FL)
      IF (DABS(FL) .LT. EPSI) GO TO 7770
      DO 50 I = 1,3
   50 SMALVN(I) = SMALLV(I)/FL
C
C     DETERMINE IF POINT A AND B ARE IN BASIC COORDINATES OR NOT.
C     COMPUTE THE TRANSFORMATION MATRICES TA AND TB IF NECESSARY
C
      IF (ICSIDA .NE. 0) CALL TRANSD(ECPT(JCSIDA),TA)
      IF (ICSIDB .NE. 0) CALL TRANSD(ECPT(JCSIDB),TB)
C
C     DETERMINE IF WE HAVE NON-ZERO OFFSET VECTORS.
C
      AOFSET = .TRUE.
      J = JOFSTA - 1
      DO 70 I = 1,3
      J = J + 1
      IF (ECPT(J) .NE. 0.0) GO TO 80
   70 CONTINUE
      AOFSET = .FALSE.
   80 BOFSET = .TRUE.
      J = JOFSTB - 1
      DO 90 I = 1,3
      J = J + 1
      IF (ECPT(J) .NE. 0.0) GO TO 100
   90 CONTINUE
      BOFSET = .FALSE.
C
C     FORM THE CENTER AXIS OF THE BEAM WITHOUT OFFSETS.
C
  100 DO 105 I = 1,3
      JTA = I + JCSIDA
      JTB = I + JCSIDB
  105 VECI(I) = ECPT(JTA) - ECPT(JTB)
C
C     SAVE IN A2B THE LENGTH OF BAR, WITHOUT OFFSET, FROM GRID PT. A
C     TO B
C
      A2B = DSQRT(VECI(1)**2 + VECI(2)**2 + VECI(3)**2)
C
C     TRANSFORM THE OFFSET VECTORS IF NECESSARY
C
      IF (.NOT.AOFSET .AND. .NOT.BOFSET) GO TO 150
C
C     TRANSFORM THE OFFSET VECTOR FOR POINT A IF NECESSARY.
C
      IDELA = 1
      J = JOFSTA - 1
      DO 110 I = 1,3
      J = J + 1
  110 DELA(I) = ECPT(J)
      IF (ICSIDA .EQ. 0) GO TO 120
      IDELA = 4
      CALL GMMATD (TA, 3,3,0, DELA(1),3,1,0, DELA(4))
C
C     TRANSFORM THE OFFSET VECTOR FOR POINT B IF NECESSARY
C
  120 IDELB = 1
      J = JOFSTB - 1
      DO 130 I = 1,3
      J = J + 1
  130 DELB(I) = ECPT(J)
      IF (ICSIDB .EQ. 0) GOTO 140
      IDELB = 4
      CALL GMMATD (TB, 3,3,0, DELB(1),3,1,0, DELB(4))
C
C     SINCE THERE WAS AT LEAST ONE NON-ZERO OFFSET VECTOR RECOMPUTE VECI
C
  140 DO 145 I = 1,3
      JTA = I - 1 + IDELA
      JTB = I - 1 + IDELB
  145 VECI(I) = VECI(I)+DELA(JTA) - DELB(JTB)
C
C     COMPUTE THE LENGTH OF THE BIG V (VECI) VECTOR AND NORMALIZE
C
  150 FL = 0.D0
      DO 155 I = 1,3
      VECI(I) = -VECI(I)
  155 FL = FL + VECI(I)**2
      FL = DSQRT(FL)
      IF (DABS(FL) .LT. EPSI) GO TO 7770
      DO 160 I = 1,3
  160 VECI(I) = VECI(I)/FL
C
C     NOW THAT LENGTH HAS BEEN COMPUTED, CHECK POSSIBLE OFFSET ERROR
C     ISSUE WARNING MESSAGE IF OFFSET EXCEEDS A2B BY 'LIMIT' PERCENT.
C     (DEFAULT IS 15 PERCENT, KSYSTM(87) WORD)
C
      IF (DABS(FL-A2B)/A2B .LE. LIMIT) GO TO 170
      WRITE  (IOUTPT,165) UWM,IELID
  165 FORMAT (A25,' - UNUSUALLY LARGE OFFSET IS DETECTED FOR CBAR ',
     1       'ELEMENT ID =',I8)
      IF (KSY87 .LE. 0) GO TO 170
      WRITE  (IOUTPT,167) KSY87
  167 FORMAT (/5X,'(OFFSET BAR LENGTH EXCEEDS NON-OFFSET LENGTH BY',
     1        I4,' PERCENT, SET BY SYSTEM 87TH WORD)')
      KSY87 = -KSY87
C
C     BRANCH IF THIS IS A -HEAT- FORMULATION.
C
  170 IF (IHEAT .EQ.1) GO TO 500
C
C     COMPUTE THE  SMALV0  VECTOR
C
      ISV = 1
      IF (ICSSV .EQ. 0) GO TO 180
      ISV = 4
      CALL GMMATD (TA,3,3,0, SMALVN(1),3,1,0, SMALVN(4))
C
C     COMPUTE THE K VECTOR, VECK = VECI  X  SMALV0, AND NORMALIZE
C
  180 VECK(1) = VECI(2)*SMALVN(ISV+2) - VECI(3)*SMALVN(ISV+1)
      VECK(2) = VECI(3)*SMALVN(ISV  ) - VECI(1)*SMALVN(ISV+2)
      VECK(3) = VECI(1)*SMALVN(ISV+1) - VECI(2)*SMALVN(ISV  )
      FLL     = DSQRT(VECK(1)**2 + VECK(2)**2 + VECK(3)**2)
      IF (DABS(FLL) .LT. EPSI2) GO TO 7770
      DO 190 I = 1,3
  190 VECK(I) = VECK(I)/FLL
C
C     COMPUTE THE J VECTOR, VECJ = VECK  X  VECI, AND NORMALIZE
C
      VECJ(1) = VECK(2)*VECI(3) - VECK(3)*VECI(2)
      VECJ(2) = VECK(3)*VECI(1) - VECK(1)*VECI(3)
      VECJ(3) = VECK(1)*VECI(2) - VECK(2)*VECI(1)
      FLL     = DSQRT (VECJ(1)**2 + VECJ(2)**2 + VECJ(3)**2)
      IF (DABS(FLL) .LT. EPSI2) GO TO 7770
      VECJ(1) = VECJ(1)/FLL
      VECJ(2) = VECJ(2)/FLL
      VECJ(3) = VECJ(3)/FLL
C
C     SEARCH THE MATERIAL PROPERTIES TABLE FOR E,G AND THE DAMPING
C     CONSTANT.
C
      MATIDC = IMATID
      MATFLG = 1
      ELTEMP = TEMPEL
      CALL MAT (IECPT(1))
C
      IF (ISTIF .EQ. 0) GOTO 600
C
C     IF ELASTICITY AND SHEAR MODULES BOTH ZERO, SKIP STIFFNESS
C     CALCULATION
C
      IF (E.EQ.0. .AND. G.EQ.0.) GO TO 600
C
C     SET UP INTERMEDIATE VARIABLES FOR ELEMENT STIFFNESS MATRIX
C     CALCULATION
C
      ASSIGN 305 TO K OR M
  205 BL    = FL
      BLSQ  = FL**2
      BLCUBE= BLSQ*BL
C
C     COMPUTE SOME TERMS TO BE USED IN STIFFNESS MATRIX KE
C
      EI1  = DBLE(E)*DBLE(I1)
      EI2  = DBLE(E)*DBLE(I2)
      IF (K1.EQ.0.0 .OR. I12.NE.0.0) GO TO 210
      GAK1 = DBLE(G)*DBLE(A)*DBLE(K1)
      R1   = (12.D0*EI1*GAK1)/(GAK1*BLCUBE + 12.D0*BL*EI1)
      GO TO 220
  210 R1   = 12.D0*EI1/BLCUBE
  220 IF (K2.EQ.0.0 .OR. I12.NE.0.0) GO TO 230
      GAK2 = DBLE(G)*DBLE(A)*DBLE(K2)
      R2   = (12.D0*EI2*GAK2)/(GAK2*BLCUBE + 12.D0*BL*EI2)
      GO TO 240
  230 R2  = 12.D0*EI2/BLCUBE
C
  240 SK1 = .25D0*R1*BLSQ + EI1/BL
      SK2 = .25D0*R2*BLSQ + EI2/BL
      SK3 = .25D0*R1*BLSQ - EI1/BL
      SK4 = .25D0*R2*BLSQ - EI2/BL
C
      AEL = DBLE(A)*DBLE(E)/BL
      LR1 = BL*R1/2.D0
      LR2 = BL*R2/2.D0
      GJL = DBLE(G)*DBLE(FJ)/BL
C
C
C     CONSTRUCT  THE GENERAL 12X12 MATRIX FOR THE BAR ELEMENT
C
C                      **       **
C                      * K    K  *
C                      *  AA   AB*
C                K =   *  T      *
C                      * K    K  *
C                      *  AB   BB*
C                      **       **
C
C
C
C     FIRST SET THE COMPONENT CODE AND THE DOF
C
      ICODE = 63
      NDOF  = 12
      NSQ   = NDOF**2
C
C     CONSTRUCT THE 12 X 12 MATRIX KE
C
C     **                                    **
C     *  1                73                 *
C     *    14          62    86         134  *
C     *       27    51          99   123     *
C     *          40               112        *
C     *       29    53         101   125     *
C     *    18          66    90         138  *
C     *  7                79                 *
C     *    20          68    92         140  *
C     *       33    57         105   129     *
C     *          46               118        *
C     *       35    59         107   131     *
C     *    24          72    96         144  *
C     **                                    **
C
      DO 300 I = 1,144
  300 KE(I) = 0.D0
      KE(  1) =  AEL
      KE(  7) = -AEL
      KE( 14) =  R1
      KE( 18) =  LR1
      KE( 20) = -R1
      KE( 24) =  LR1
      KE( 27) =  R2
      KE( 29) = -LR2
      KE( 33) = -R2
      KE( 35) = -LR2
      KE( 40) =  GJL
      KE( 46) = -GJL
      KE( 51) = -LR2
      KE( 53) =  SK2
      KE( 57) =  LR2
      KE( 59) =  SK4
      KE( 62) =  LR1
      KE( 66) =  SK1
      KE( 68) = -LR1
      KE( 72) =  SK3
      KE( 73) = -AEL
      KE( 79) =  AEL
      KE( 86) = -R1
      KE( 90) = -LR1
      KE( 92) =  R1
      KE( 96) = -LR1
      KE( 99) = -R2
      KE(101) =  LR2
      KE(105) =  R2
      KE(107) =  LR2
      KE(112) = -GJL
      KE(118) =  GJL
      KE(123) = -LR2
      KE(125) =  SK4
      KE(129) =  LR2
      KE(131) =  SK2
      KE(134) =  LR1
      KE(138) =  SK3
      KE(140) = -LR1
      KE(144) =  SK1
      IF (I12 .EQ. 0.) GOTO 303
      BETA = 12.D0*DBLE(E)*DBLE(I12)/BLCUBE
      LB      =   BL*BETA/2.0D0
      L2B3    = BLSQ*BETA/3.0D0
      L2B6    = BLSQ*BETA/6.0D0
      KE( 15) =  BETA
      KE( 17) = -LB
      KE( 21) = -BETA
      KE( 23) = -LB
      KE( 26) =  BETA
      KE( 30) =  LB
      KE( 32) = -BETA
      KE( 36) =  LB
      KE( 50) = -LB
      KE( 54) = -L2B3
      KE( 56) =  LB
      KE( 60) = -L2B6
      KE( 63) =  LB
      KE( 65) = -L2B3
      KE( 69) = -LB
      KE( 71) = -L2B6
      KE( 87) = -BETA
      KE( 89) =  LB
      KE( 93) =  BETA
      KE( 95) =  LB
      KE( 98) = -BETA
      KE(102) = -LB
      KE(104) =  BETA
      KE(108) = -LB
      KE(122) = -LB
      KE(126) = -L2B6
      KE(128) =  LB
      KE(132) = -L2B3
      KE(135) =  LB
      KE(137) = -L2B6
      KE(141) = -LB
      KE(143) = -L2B3
  303 GO TO K OR M, (305,640,465,750)
C
C     DETERMINE IF THERE ARE NON-ZERO PIN FLAGS.
C
  305 KA = IECPT(JPINA)
      KB = IECPT(JPINB)
      IF (KA.EQ.0 .AND. KB.EQ.0) GOTO 345
C
C     SET UP THE IPIN ARRAY
C
      DO 310 I = 1,5
      IPIN(I  ) = MOD(KA,10)
      IPIN(I+5) = MOD(KB,10) + 6
      IF (IPIN(I+5) .EQ. 6) IPIN(I+5) = 0
      KA = KA/10
  310 KB = KB/10
C
C     ALTER KE MATRIX DUE TO PIN FLAGS.
C
      DO 340 I = 1,10
      IF (IPIN(I) .EQ.0) GO TO 340
      II = 13*IPIN(I) - 12
      IF (KE(II) .NE. 0.D0) GO TO 320
      IL = IPIN(I)
      II = II - IL
      DO 315 J = 1,12
      II = II + 1
      KE(II) = 0.D0
      KE(IL) = 0.D0
      IL = IL + 12
  315 CONTINUE
      GO TO 340
  320 DO 330 J = 1,12
      JI = 12*(J-1) + IPIN(I)
      IJ = 12*(IPIN(I)-1) + J
      DO 325  LL = 1,12
      JLL = 12*(J-1) + LL
      ILL = 12*(IPIN(I)-1) + LL
      KEP(JLL) = KE(JLL) - (KE(ILL)/KE(II))*KE(JI)
  325 CONTINUE
      KEP(IJ) = 0.D0
      KEP(JI) = 0.D0
  330 CONTINUE
      DO 335 K = 1,144
  335 KE(K) = KEP(K)
  340 CONTINUE
C
C     DIVIDE KE INTO FOUR SUBMATRICES AND STORE IN OPEN CORE
C
C      E                   E                   E
C     K   = KK(1 TO 36)   K   = KK(37 TO 72)  K   = KK(73 TO 108)
C      AA                  AB                  BA
C
C      E
C     K   =  KK(109 TO 144)
C      BB
C
C
  345 J = 0
      DO 355 I = 1,72,12
      LOW = I
      LIM = I + 5
      DO 350 K = LOW,LIM
      J = J + 1
      KK(J   ) = KE(K   )
      KK(J+36) = KE(K+ 6)
      KK(J+72) = KE(K+72)
  350 KK(J+108)= KE(K+78)
  355 CONTINUE
C
      ASSIGN 465 TO K OR M
C
C     ZERO OUT THE ARRAY WHERE THE 3X3 MATRIX H AND THE W  AND W  6X6
C     MATRICES WILL RESIDE.                              A      B
C      T
C     A   MATRIX NOW STORED IN KE
C
  358 DO 357 I = 1,9
  357 KE(I) = VEC(I)
C
      DO 360 I = 28,144
  360 KE(I) = 0.D0
C
C
C     SET UP POINTERS
C
      BASIC  = ICSIDA.EQ.0
      JCSID  = JCSIDA
      OFFSET = AOFSET
      JOFSET = JOFSTA
      DO 395 I = 1,2
      IWBEG  = I*36
C
C     SET UP THE -G- MATRIX.  IG POINTS TO THE BEGINNING OF THE G MATRIX
C     G = AT X TI
C
      IG = 1
      IF (BASIC) GO TO 380
      CALL TRANSD (ECPT(JCSID),KE(10))
      CALL GMMATD (KE(1), 3,3,0, KE(10), 3,3,0, KE(19))
      IG = 19
C
C     IF THERE IS A NON-ZERO OFFSET FOR THE POINT, SET UP THE D 3X3
C     MATRIX.
C
  380 IF (.NOT.OFFSET) GO TO 385
      KE(10) =  0.D0
      KE(11) =  ECPT(JOFSET+2)
      KE(12) = -ECPT(JOFSET+1)
      KE(13) = -KE(11)
      KE(14) =  0.D0
      KE(15) =  ECPT(JOFSET)
      KE(16) = -KE(12)
      KE(17) = -KE(15)
      KE(18) =  0.D0
C
C     FORM THE 3X3 PRODUCT H = G X D, I.E., KE(28) = KE(IG) X KE(10)
C
      CALL GMMATD (KE(IG), 3,3,0, KE(10), 3,3,0, KE(28))
C
C
C     FORM THE W SUBMATRICES IN KE(37) AND KE(73)
C
C
  385 KE(IWBEG+ 1) = KE(IG  )
      KE(IWBEG+ 2) = KE(IG+1)
      KE(IWBEG+ 3) = KE(IG+2)
      KE(IWBEG+ 7) = KE(IG+3)
      KE(IWBEG+ 8) = KE(IG+4)
      KE(IWBEG+ 9) = KE(IG+5)
      KE(IWBEG+13) = KE(IG+6)
      KE(IWBEG+14) = KE(IG+7)
      KE(IWBEG+15) = KE(IG+8)
      KE(IWBEG+22) = KE(IG  )
      KE(IWBEG+23) = KE(IG+1)
      KE(IWBEG+24) = KE(IG+2)
      KE(IWBEG+28) = KE(IG+3)
      KE(IWBEG+29) = KE(IG+4)
      KE(IWBEG+30) = KE(IG+5)
      KE(IWBEG+34) = KE(IG+6)
      KE(IWBEG+35) = KE(IG+7)
      KE(IWBEG+36) = KE(IG+8)
      IF (.NOT.OFFSET) GO TO 390
      KE(IWBEG+ 4) = KE(28)
      KE(IWBEG+ 5) = KE(29)
      KE(IWBEG+ 6) = KE(30)
      KE(IWBEG+10) = KE(31)
      KE(IWBEG+11) = KE(32)
      KE(IWBEG+12) = KE(33)
      KE(IWBEG+16) = KE(34)
      KE(IWBEG+17) = KE(35)
      KE(IWBEG+18) = KE(36)
  390 BASIC  = ICSIDB.EQ.0
      JCSID  = JCSIDB
      OFFSET = BOFSET
      JOFSET = JOFSTB
  395 CONTINUE
C
C     CONVERT THE K PARTITIONS TO GLOBAL COORDINATES AND STORE IN KEP
C
      IAFT = 37
      DO 400 I = 1,4
      IKX = (I-1)*36 + 1
      IK  = IKX
      IF (I .GE. 3) IKX = (7-I-1)*36 + 1
      IFORE = ((I-1)/2)*36 + 37
      CALL GMMATD (KE(IFORE), 6,6,1, KK(IKX), 6,6,0, KE(109))
      CALL GMMATD (KE(109),  6,6,0, KE(IAFT), 6,6,0, KEP(IK))
      IAFT = 73
      IF (I .EQ. 3) IAFT = 37
  400 CONTINUE
C
C     REFORM THE K MATRIX (12X12) FROM THE FOUR SUBMATRICES (6X6) AND
C     ORDER  THE SUBMATRICES BY INCREASING SIL VALUE
C
      DO 460 II = 1,4
      IX1 = IKK(II)
      IX2 = IX1 + 60
      IS  = IS12OR(II)
      IF (ISILNO(1) .GT. ISILNO(2)) IS = IS21OR(II)
      DO 450 I = IX1,IX2,12
      IP5 = I + 5
      DO 440 J = I,IP5
      KE(J) = KEP(IS)
  440 IS = IS + 1
  450 CONTINUE
  460 CONTINUE
C
      GO TO K OR M, (305,640,465,750)
C
C     OUTPUT THE STIFFNESS MATRIX
C
  465 DICT(2) = 1
      DICT(3) = NDOF
      DICT(4) = ICODE
      DICT(5) = GSUBE
      CALL EMGOUT (KE(1),KE(1),NSQ,1,DICT,1,IPREC)
      GO TO 600
C
C     THE MASS MATRIX IS GENERATED HERE.  IF THE PARAMETER ICMBAR IS
C     .LT. 0, CALL THE CONVENTIONAL MASS MATRIX GENERATION ROUTINE FOR
C     THE BAR.  OTHERWISE CALL THE ROUTINE TO GENERATE CONSISTENT MASS
C     MATRICES FOR THE BAR.
C
  600 CONST = (FL*(DBLE(RHO)*DBLE(A) +  DBLE(NSM)))/420.D0
      IF (IMASS.EQ.0 .OR. CONST.EQ.0.D0) RETURN
      IF (ICMBAR .LT. 0) GO TO 800
C
C     CALCULATE THE CONSISTENT/CONVENTIONAL MASS MATRIX
C
C     CALL THE MAT ROUTINE TO FETCH SINGLE PRECISION MATERIAL PROPERTIES
C
      MATIDC = IMATID
      MATFLG = 1
      ELTEMP = TEMPEL
      CALL MAT (IECPT(1))
C
C     COMPUTE TERMS OF THE ELEMENT MASS MATRIX
C
      BL22  = 22.D0*FL
      BL13  = 13.D0*FL
      BLSQ4 =  4.D0*FL**2
      BLSQ3 =  3.D0*FL**2
C
C     CONSTRUCT THE ELEMENT MASS MATRIX.
C
      DO 610 I = 1,12
      DO 610 J = 1,12
  610 M( I, J) = 0.D0
      M( 1, 1) = 175.D0
      M( 1, 7) = 35.D0
      M( 2, 2) = 156.D0
      M( 2, 6) = BL22
      M( 2, 8) = 54.D0
      M( 2,12) =-BL13
      M( 3, 3) = 156.D0
      M( 3, 5) =-BL22
      M( 3, 9) = 54.D0
      M( 3,11) = BL13
      M( 5, 5) = BLSQ4
      M( 5, 9) =-BL13
      M( 5,11) =-BLSQ3
      M( 6, 6) = BLSQ4
      M( 6, 8) = BL13
      M( 6,12) =-BLSQ3
      M( 7, 7) = 175.D0
      M( 8, 8) = 156.D0
      M( 8,12) =-BL22
      M( 9, 9) = 156.D0
      M( 9,11) = BL22
      M(11,11) = BLSQ4
      M(12,12) = BLSQ4
C
C     STORE THE UPPER TRIANGULAR PART OF THE MATRIX IN THE LOWER PART.
C
      DO 625  I = 1,10
      LOW = I + 1
      DO 620 J = LOW,12
      M(J,I) = M(I,J)
  620 CONTINUE
  625 CONTINUE
C
C     MULTIPLY BY CONSTANT AND STORE ROW-WISE IN THE ARRAY ME
C
      K = 0
      DO 630 I = 1,12
      DO 630 J = 1,12
      K = K + 1
  630 ME(K) = CONST*M(I,J)
C
C     IF THERE ARE NO PIN FLAGS THERE IS NO NEED TO CALCULATE THE
C     ELEMENT STIFFNESS MATRIX
C
      KA = IECPT(JPINA)
      KB = IECPT(JPINB)
      IF (KA.EQ.0 .AND. KB.EQ.0) GO TO 705
C
C     COMPUTE THE STIFFNESS MATRIX KE
C
C
      ASSIGN 640 TO K OR M
      GO TO 205
C
C     RETURN HERE AFTER COMPUTING THE STIFFNESS MATRIX
C
C
C     SET UP TNHE IPIN ARRAY
C
  640 DO 645 I = 1,5
      IPIN(I  ) = MOD(KA,10)
      IPIN(I+5) = MOD(KB,10)+6
      IF (IPIN(I+5) .EQ. 6) IPIN(I+5) = 0
      KA = KA/10
  645 KB = KB/10
C
C     ALTER THE ELEMENT MASS MATRIX DUE TO PIN FLAGS.  NOTE THAT THE
C     FOLLOWING CODE IS CONGRUENT AS IT WERE TO THE CODE IN SUBROUTINE
C     DBEAM IN THE DSMG1 MODULE.
C
      DO 700 J = 1,10
      IF (IPIN(J) .EQ. 0) GO TO 700
      JJ = 12*(IPIN(J)-1) + IPIN(J)
      IF (KE(JJ) .EQ. 0.) GO TO 680
      DO 660 I = 1,12
      JI = 12*(IPIN(J)-1) + I
      IJ = 12*(I-1) + IPIN(J)
      DO 650 L1 = 1,12
      IL = 12*(I -1) + L1
      LJ = 12*(L1-1) + IPIN(J)
      MEP(IL) = ME(IL) - KE(LJ)*ME(JI)/KE(JJ) - KE(JI)*ME(LJ)/KE(JJ)
     1                 + KE(LJ)*KE(JI)*ME(JJ)/KE(JJ)**2
  650 CONTINUE
  660 CONTINUE
      DO 670 K = 1,144
  670 ME(K) = MEP(K)
C
C     ZERO OUT THE IPIN(J) TH ROW AND COLUMN OF ME
C
  680 J1 = JJ - IPIN(J)
      J2 = IPIN(J)
      DO 690 K = 1,12
      J1 = J1 + 1
      ME(J1) = 0.D0
      ME(J2) = 0.D0
  690 J2 = J2 + 12
  700 CONTINUE
C
C           E                   E                    E
C    STORE M   AT KK(1 TO 36), M  AT KK (37 TO 72), M  AT KK(73 TO 108)
C           AA                  AB                   BA
C
C           E
C          M   AT KK(109 TO 144)
C           BB
C
  705 J = 0
      DO 720 I = 1,72,12
      LOW = I
      LIM = LOW + 5
      DO 710 K = LOW,LIM
      J = J + 1
      KK(J) = ME(K)
      KK(J+ 36) = ME(K+ 6)
      KK(J+ 72) = ME(K+72)
  710 KK(J+108) = ME(K+78)
  720 CONTINUE
C
C     CALCULATE THE TRANSFORMATION VECTORS
C
      ASSIGN 750 TO K OR M
      GO TO 358
C
C     OUTPUT THE CONSISTENT MASS MATRIX
C
  750 DICT(2) = 1
      DICT(3) = NDOF
      DICT(4) = ICODE
      DICT(5) = 0
      CALL EMGOUT (KE(1),KE(1),144,1,DICT,2,IPREC)
      RETURN
C
C     CALCULATE THE CONVENTIONAL MASS MATRIX HERE
C
C
C     GET RHO FROM MPT BY CALLING MAT
C
  800 MATIDC = IMATID
      MATFLG = 4
      ELTEMP = TEMPEL
      CALL MAT (ECPT(1))
      DO 810 I = 1,72
  810 MEP(I) = 0.D0
      FM = .5D0*FL*(DBLE(RHO)*DBLE(A) + DBLE(NSM))
C
C     DETERMINE IF THE GRID POINT IS ASSOCIATED WITH A NON-ZERO OFFSET.
C
      JOFSET = 9
      DO 850 II = 1,2
      IX = (II-1)*36
      J  = JOFSET
      DO 815 I = 1,3
      J  = J + 1
      IF (ECPT(J) .NE. 0.) GO TO 820
  815 CONTINUE
      GO TO 840
C
C     FORM UPPER RIGHT CORNER OF THE MATRIX
C
  820 MEP(IX+ 1) = 1.D0
      MEP(IX+ 8) = 1.D0
      MEP(IX+15) = 1.D0
      MEP(IX+ 5) = ECPT(JOFSET+3)
      MEP(IX+ 6) =-ECPT(JOFSET+2)
      MEP(IX+12) = ECPT(JOFSET+1)
      MEP(IX+10) =-MEP(IX+ 5)
      MEP(IX+16) =-MEP(IX+ 6)
      MEP(IX+17) =-MEP(IX+12)
      MEP(IX+20) =-MEP(IX+ 5)
      MEP(IX+21) =-MEP(IX+ 6)
      MEP(IX+25) =-MEP(IX+10)
      MEP(IX+27) =-MEP(IX+12)
      MEP(IX+31) =-MEP(IX+16)
      MEP(IX+32) =-MEP(IX+17)
      MEP(IX+22) = ECPT(JOFSET+3)**2 + ECPT(JOFSET+2)**2
      MEP(IX+29) = ECPT(JOFSET+3)**2 + ECPT(JOFSET+1)**2
      MEP(IX+36) = ECPT(JOFSET+2)**2 + ECPT(JOFSET+1)**2
      MEP(IX+23) =-ECPT(JOFSET+1)*ECPT(JOFSET+2)
      MEP(IX+24) =-ECPT(JOFSET+1)*ECPT(JOFSET+3)
      MEP(IX+30) =-ECPT(JOFSET+2)*ECPT(JOFSET+3)
      MEP(IX+28) = MEP(IX+23)
      MEP(IX+34) = MEP(IX+24)
      MEP(IX+35) = MEP(IX+30)
C
C     MULTIPLY M BY THE CONSTANT FL
C
      DO 830 I = 1,36
      IS = IX + I
  830 MEP(IS) = MEP(IS)*FM
      GO TO 850
C
C     HERE WE HAVE A ZERO OFFSET VECTOR
C
  840 MEP(IX+ 1) = FM
      MEP(IX+ 8) = FM
      MEP(IX+15) = FM
  850 JOFSET = 12
C
C     INSERT THE  M  AND  M  SUBMATRICES INTO M ACCORDING TO INCREASING
C     SIL          A       B
C
      DO 860 I = 1,144
  860 ME(I) = 0.D0
C
      IF (ISILNO(1) - ISILNO(2)) 870,870,880
  870 IX1 = 1
      IX2 = 37
      GO TO 890
  880 IX1 = 37
      IX2 = 1
  890 CONTINUE
      DO 900 JJ = 1,36
      MM = MOD(JJ,6)
      IF (MM .EQ. 0) MM = 6
      I = ((JJ-1)/6)*12  + MM
      J = I + 78
      ME(I) = MEP(IX1)
      ME(J) = MEP(IX2)
      IX1 = IX1 + 1
  900 IX2 = IX2 + 1
C
C     OUTPUT THE CONVENTIONAL MASS MATRIX
C
      DICT(2) = 1
      DICT(3) = NDOF
      DICT(4) = ICODE
      DICT(5) = 0
C
      CALL EMGOUT (ME,ME,144,1,DICT,2,IPREC)
C
      RETURN
C
C     HEAT FORMULATION CONTINUES HERE.  GET MATERIAL PROPERTY -K- FROM
C     HMAT
C
  500 MATFLG  = 1
      MATIDC  = IECPT(16)
      ELTEMP  = ECPT(42)
      DICT(2) = 1
      DICT(3) = 2
      DICT(4) = 1
      DICT(5) = 0
      IF (ISTIF .EQ. 0) GO TO 540
      CALL HMAT (IELID)
C
      KK(1) = DBLE(FK)*DBLE(ECPT(17))/FL
      IF (KK(1).EQ. 0.D0) GO TO 520
      KK(2) =-KK(1)
      KK(3) = KK(2)
      KK(4) = KK(1)
      CALL EMGOUT (KK(1),KK(1),4,1,DICT,1,IPREC)
C
  520 MATFLG = 4
C
C     ERROR IN NEXT CARD FOR HEAT FORMULATION. REMOVED BY G.CHAN/SPERRY,
C     1984.   ALSO, CHANGE  GO TO 520 TO 540, 11-TH CARD ABOVE, AND
C     CALL EMGOUT BELOW AND WRITE TO THE 3-RD FILE INSTEAD OF THE 2-ND.
C
      CALL HMAT (IELID)
      KK(1) = (DBLE(FK)*DBLE(ECPT(17)))*FL/2.D0
      IF (KK(1) .EQ. 0.D0) RETURN
      KK(2) = KK(1)
      DICT(2) = 2
      CALL EMGOUT (KK(1),KK(1),2,1,DICT,3,IPREC)
  540 RETURN
C
C     ERROR RETURNS
C
 7770 CONTINUE
      WRITE  (IOUTPT,7775) UFM,IELID
 7775 FORMAT (A23,' 3176, BAR ELEMENT ID',I9,
     1        ' HAS ILLEGAL GEOMETRY OR CONNECTIONS.')
      NOGO = .TRUE.
      RETURN
      END

      SUBROUTINE BISLC2 (*,ID,AA,NC,NR,LOC)
C-----
C     BINARY SEARCH ROUTINE - LOCATE ID POSTION IN AA
C     SEARCH BY FIRST 2 WORDS (ROWS) OF ENTRIES.
C
C     ID  = TARGET WORD SEARCH, 2 BCD-WORDS
C     AA  = A (NR X NC) TABLE TO SEARCH FOR ID.
C     NR  = SIZE   OF ENTRIES (ROW   ) IN THE AA.
C     NC  = NUMBER OF ENTRIES (COLUMN) IN THE AA.
C     LOC = POINTER RETURNED, OF NC LOCATION
C
C     NONSTANDARD RETURN IN THE EVENT OF NO MATCH.
C
      INTEGER  ID(2),AA(NR,NC)
C
      KLO = 1
      KHI = NC
   10 K   = (KLO+KHI+1)/2
   20 IF (ID(1) - AA(1,K)) 30,25,40
   25 IF (ID(2) - AA(2,K)) 30,90,40
   30 KHI = K
      GO TO 50
   40 KLO = K
   50 IF (KHI-KLO -1) 100,60,10
   60 IF (K .EQ. KLO)  GO TO 70
      K   = KLO
      GO TO 80
   70 K   = KHI
   80 KLO = KHI
      GO TO 20
   90 LOC = K
      RETURN
  100 RETURN 1
      END

      SUBROUTINE OPTPX1 (*,STOR,NOGO,NEN,LOC1)
C
C     PROCESS PID DATA ON PLIMIT CARD
C
      INTEGER         STOR(15),SYSBUF,OUTTAP,YCOR,THRU,NAM(2),X(7),IY(1)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /BLANK / SKP1(5),YCOR
      COMMON /ZZZZZZ/ CORE(1)
      COMMON /SYSTEM/ SYSBUF,OUTTAP
      EQUIVALENCE     (CORE(1),X(1)),(X(7),IY(1))
      DATA    THRU  / 4HTHRU  /
C
      NAM(1) = STOR(1)
      NAM(2) = STOR(2)
      IF (STOR(6) .EQ. THRU) GO TO 100
C
C     USER SPECIFIED BY EXPLICIT ID-S
C
      CALL SORT (0,0,1,1,STOR(5),5)
C
C     CREATE PSEUDO THRU RANGE
C     LOCATE FIRST NONZERO
C
      DO 10 L = 5,9
      IF (STOR(L) .NE. 0) GO TO 30
   10 CONTINUE
      CALL PAGE2 (-2)
      WRITE  (OUTTAP,20) UFM,NAM
   20 FORMAT (A23,' 2293, NO PID ENTRIES ON PLIMIT CARD (',2A4,2H).)
      NOGO = NOGO + 1
      GO TO 110
C
C     LOOP ON ENTRIES
C
   30 CONTINUE
      I1 = STOR(L)
      I3 = 1
   35 I2 = STOR(L+1)
      IF (L-9) 40,60,130
   40 IF (I2-I1-I3) 80,50,60
C
C     THRU CAN BE EXPANDED
C
   50 L  = L  + 1
      I3 = I3 + 1
      GO TO 35
C
C     PUT OUT I1,I2
C
   60 STOR(1) = I1
      STOR(2) = STOR(L)
      IF (LOC1+3+NEN .GT. YCOR) GO TO 120
      CALL BISHEL (*80,STOR,NEN,4,IY(LOC1))
   70 L = L + 1
      IF (L-9) 30,30,110
C
C     DUPLICATE ENTRIES FOUND
C
   80 CALL PAGE2 (-2)
      WRITE  (OUTTAP,90) UFM,I1,I2,NAM
   90 FORMAT (A23,' 2294, DUPLICATE',I8,' THRU',I8,' RANGE FOR ELEMENT',
     1        1X,2A4,' REJECTED PLIMIT. SCAN CONTINUED.')
      NOGO = NOGO + 1
      GO TO 70
C
C     USER SPECIFIED BY USING THRU
C
  100 L = 8
      STOR(9) = STOR(8)
      STOR(8) = STOR(5)
      GO TO 30
C
C     THIS PLIMIT FINISHED
C
  110 CONTINUE
      RETURN
C
C     INSUFFICIENT CORE
C
  120 CONTINUE
      STOR(1) = NAM(1)
      STOR(2) = NAM(2)
      RETURN 1
C
  130 CALL MESAGE (-7,0,NAM)
      GO TO 120
      END

      SUBROUTINE FVRS1E (A,K,N)
C
C     PURPOSE
C       TO SORT THE ELEMENTS OF A REAL*4 VECTOR, A, INTO ASCENDING
C       ORDER AND TO CONSTRUCT AN INTEGER*4 VECTOR, K, WHICH INDICATES
C       HOW THE ELEMENTS OF A HAVE BEEN REARRANGED.
C
C     USAGE
C       CALL FVRS1E(A,K,N)
C
C     DESCRIPTION OF PARAMETERS
C       A - REAL*4 VECTOR.
C              ON INPUT - A CONTAINS THE NUMBERS TO BE SORTED.
C              ON OUTPUT- A CONTAINS THE NUMBERS IN ASCENDING ORDER.
C       K - OUTPUT VECTOR CONTAINING INTERCHANGE INFORMATION, I.E.,
C           THE NUMBER IN A(K(I)) (OF THE INPUT A) HAS BEEN MOVED TO
C           A(I).
C       N - LENGTH OF A AND K.
C
C     SUBROUTINES AND FUNCTION SUBPROGRAMS REQUIRED
C       NONE
C
C     REMARKS
C       THE K-VECTOR CAN BE USED IN CONJUNCTION WITH SUBROUTINE FVRS1E
C       TO REARRANGE OTHER VECTORS IN THE SAME WAY THAT THE A-VECTOR
C       HAS BEEN REARRANGED.
C
C     METHOD
C       THIS ROUTINE IS A TRANSLATION OF THE ALGOL PROCEDURE,
C       'SHELLSORT', ALGORITHM 201, 'COLLECTED ALGORITHMS FROM CACM',
C       BY J. BOOTHROYD.
C
      DIMENSION A(1),K(1)
C
      DO 17 IKL =1,N
   17 K(IKL) = IKL
      I = 1
    1 I = I+I
      IF(I-N)1,2,7
    7 I = I/2
    2 CONTINUE
      M = 2*I-1
    5 CONTINUE
      M = M/2
      K1 = N-M
      DO 6 J=1,K1
      I = J
    3 IPM = I+M
      AIPM = A(IPM)
      IF(AIPM.GE.A(I)) GO TO 4
      W = A(I)
      KW = K(I)
      A(I) = AIPM
      K(I) = K(IPM)
      A(IPM) = W
      K(IPM) = KW
      I = I-M
      IF(I.GE.1) GO TO 3
    4 CONTINUE
    6 CONTINUE
      IF(M.GT.1) GO TO 5
      RETURN
      END

      SUBROUTINE AMGB1 (INPUT,MATOUT,SKJ)
C
C     DRIVER FOR COMPRESSOR BLADE THEORY.
C     COMPUTATIONS ARE FOR THE AJJL AND SKJ MATRICES.
C     FOR COMPRESSOR BLADES K-SET = J-SET = NLINES*NSTNS.
C     SKJ = W*F(INVERS)TRANSPOSE.
C
C
      LOGICAL         TSONIC,DEBUG
      INTEGER         ECORE,SYSBUF,IZ(1),NAME(2),SLN,SKJ,TSKJ
      REAL            MINMAC,MAXMAC,MACH,RADII(50)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /AMGMN / MCB(7),NROW,DUM(2),REFC,SIGMA,RFREQ,TSKJ(7),ISK,
     1                NSK
      COMMON /CONDAS/ PI,TWOPI,RADEG,DEGRA,S4PISQ
      COMMON /BAMG1L/ IREF,MINMAC,MAXMAC,NLINES,NSTNS,REFSTG,REFCRD,
     1                REFMAC,REFDEN,REFVEL,REFFLO,SLN,NSTNSX,STAGER,
     2                CHORD,RADIUS,BSPACE,MACH,DEN,VEL,FLOWA,AMACH,
     3                REDF,BLSPC,AMACHR,TSONIC,XSIGN
      COMMON /ZZZZZZ/ WORK(1)
      COMMON /SYSTEM/ SYSBUF,IOUT
      COMMON /PACKX / ITI,ITO,II,NN,INCR
      COMMON /BLANK / NK,NJ
      COMMON /AMGBUG/ DEBUG
      EQUIVALENCE     (WORK(1),IZ(1))
      DATA    NAME  / 4HAMGB,4H1   /
C
C     READ PARAMETERS IREF,MINMAC,MAXMAC,NLINES AND NSTNS
C
      CALL READ (*999,*999,INPUT,IREF,5,0,N)
      IF (DEBUG) CALL BUG1 ('ACPT-REF  ',5,IREF,5)
C
C     READ REST OF ACPT RECORD INTO OPEN CORE AND LOCATE REFERENCE
C     PARAMETERS REFSTG,REFCRD,REFMAC,REFDEN,REFVEL AND REFFLO
C     STORE STREAMLINE RADIUS FOR ALL STREAMLINES
C
      ECORE = KORSZ(IZ) - 4*SYSBUF
      CALL READ (*10,*10,INPUT,IZ,ECORE,1,NWAR)
      GO TO 998
   10 IRSLN = 0
      IF (DEBUG) CALL BUG1 ('ACPT-REST ',10,IZ,NWAR)
      NTSONX= 0
      NDATA = 3*NSTNS + 10
      NLINE = 0
      DO 20 I = 1,NWAR,NDATA
C
C     LOCATE REFERENCE STREAMLINE NUMBER (IREF = SLN)
C
      IF (IREF .EQ. IZ(I)) IRSLN = I
C
C     STORE AMACH FOR LATER DATA CHECK. COUNT TRANSONIC STREAMLINES
C
      AMACHL = WORK(I+6)*COS(DEGRA*(WORK(I+9)-WORK(I+2)))
      IF (AMACHL.GT.MAXMAC .AND. AMACHL.LT.MINMAC) NTSONX = NTSONX + 1
      NLINE = NLINE + 1
      WORK(NWAR+NLINE) = AMACHL
      RADII(NLINE) = WORK(I+4)
   20 CONTINUE
C
C     DETERMINE DIRECTION OF BLADE ROTATION VIA Y-COORDINATES AT TIP
C     STREAMLINE. USE COORDINATES OF FIRST 2 NODES ON STREAMLINE.
C
      IPTR  = NDATA*(NLINES-1)
      XSIGN = 1.0
      IF (WORK(IPTR+15) .LT. WORK(IPTR+12)) XSIGN = -1.0
C
      IF (DEBUG) CALL BUG1 ('RADII     ',25,RADII,NLINES)
C
C     INPUT CHECKS -
C     (1) AMACH MUST INCREASE FROM BLADE ROOT TO BLADE TIP
C     (2) ALL TRANSONIC AMACH-S ARE NOT ALLOWED AT PRESENT
C
      IBAD = 0
      IF (NTSONX .LT. NLINES) GO TO 30
      IBAD = 1
      WRITE (IOUT,1001) UFM
   30 CONTINUE
      NW1 = NWAR + 1
      NW2 = NWAR + NLINES - 1
      DO 35 I = NW1,NW2
      IF (WORK(I) .GT. WORK(I+1)) GO TO 40
   35 CONTINUE
      GO TO 45
   40 IBAD = 1
      ISLN = (I-NWAR-1)*NDATA + 1
      WRITE (IOUT,1002) UFM,IZ(ISLN)
   45 IF (IBAD .NE. 0) GO TO 997
C
C     SET TSONIC IF THERE ARE ANY TRANSONIC STREAMLINES
C
      TSONIC = .FALSE.
      IF (NTSONX .GT. 0) TSONIC = .TRUE.
C
C     STORE REFERENCE PARAMETERS
C     DID IREF MATCH AN SLN OR IS THE DEFAULT TO BE TAKEN  (BLADE TIP)
C
      IF (IRSLN .EQ. 0) IRSLN = (NLINES-1)*NDATA + 1
      REFSTG = WORK(IRSLN+2)
      REFCRD = WORK(IRSLN+3)
      REFMAC = WORK(IRSLN+6)
      REFDEN = WORK(IRSLN+7)
      REFVEL = WORK(IRSLN+8)
      REFFLO = WORK(IRSLN+9)
C
C     REPOSITION ACPT TO BEGINNING OF COMPRESSOR BLADE DATA
C
      CALL BCKREC (INPUT)
      CALL FREAD (INPUT,0,-6,0)
      IF (DEBUG) CALL BUG1 ('BAMG1L    ',47,IREF,26)
C
C     COMPUTE POINTERS AND SEE IF THERE IS ENOUGH CORE
C     IP1 AND IP2 ARE COMPLEX POINTERS
C
      NAJJC  = NSTNS
      NTSONX = 1
      IF (TSONIC) NAJJC  = NLINES*NSTNS
      IF (TSONIC) NTSONX = NLINES
      IP1  = 1
      IP2  = IP1 + 2*(NSTNS*NAJJC)
      IP3  = IP2 + 2*NSTNS
      IP4  = IP3 + NTSONX
      IP5  = IP4 + NTSONX
      NEXT = IP5 + NTSONX
      IF (NEXT .GT. ECORE) GO TO 998
C
C     CALL ROUTINE TO COMPUTE AND OUTPUT AJJL.
C
      ITI = 3
      ITO = 3
C
      CALL AMGB1A (INPUT,MATOUT,WORK(IP1),WORK(IP2),WORK(IP3),
     1             WORK(IP4),WORK(IP5))
      IF (DEBUG) CALL BUG1 ('AJJL      ',48,WORK(IP1),IP2-1)
C
C     COMPUTE F(INVERSE) AND W(FACTOR) FOR EACH STREAMLINE
C
C     COMPUTE POINTERS AND SEE IF THERE IS ENOUGH CORE
C
      NSNS = NSTNS*NSTNS
      IP1  = 1
      IP2  = IP1 + NSNS
      NEXT = IP2 + 3*NSTNS
      IF (NEXT .GT. ECORE) GO TO 998
C
C     REPOSITION ACPT TO BEGINNING OF COMPRESSOR BLADE DATA
C
      CALL BCKREC (INPUT)
      CALL FREAD  (INPUT,0,-6,0)
C
      ITI = 1
      ITO = 3
C
      II  = ISK
      NSK = NSK + NSTNS
      NN  = NSK
      DO 100 NLINE = 1,NLINES
      CALL AMGB1S (INPUT,WORK(IP1),WORK(IP2),WORK(IP2),RADII,WFACT,
     1             NLINE)
C
C     OUTPUT SKJ (= WFACT*F(INVERS)TRANSPOSE) FOR THIS STREAMLINE
C
      IP3 = IP2 + NSTNS - 1
      DO 60 I = 1,NSTNS
      K  = I
      DO 50 J = IP2,IP3
      WORK(J) = WORK(K)*WFACT
   50 K  = K + NSTNS
      CALL PACK (WORK(IP2),SKJ,TSKJ)
      IF (DEBUG) CALL BUG1 ('SKJ       ',55,WORK(IP2),NSTNS)
   60 CONTINUE
      II = II + NSTNS
      IF (NLINE .EQ. NLINES) GO TO 100
      NN = NN + NSTNS
  100 CONTINUE
C
C     UPDATE NROW AND PACK POINTERS
C
      NROW = NROW + NLINES*NSTNS
      IF (DEBUG) CALL BUG1 ('NEW-NROW  ',110,NROW,1)
      ISK = II
      NSK = NN
      RETURN
C
C     ERROR MESSAGES
C
C     BAD STREAMLINE DATA
C
  997 CALL MESAGE (-61,0,0)
C
C     NOT ENOUGH CORE
C
  998 CALL MESAGE (-8,0,NAME)
C
C     INPUT NOT POSITIONED PROPERLY OR INCORRECTLY WRITTEN
C
  999 CALL MESAGE (-7,0,NAME)
      RETURN
C
 1001 FORMAT (A23,' -AMG MODULE- ALL TRANSONIC STREAMLINES NOT ALLOWED',
     1       /39X,'CHECK MACH ON STREAML2 BULK DATA CARDS OR', /39X,
     2       'CHANGE PARAMETERS MINMACH AND MAXMACH.')
 1002 FORMAT (A23,' -AMG MODULE- MACH NUMBERS MUST INCREASE FROM BLADE',
     1       ' ROOT TO BLADE TIP.', /39X,
     2       'CHECK STREAML2 BULK DATA CARD WITH SLN =',I3)
      END

      SUBROUTINE MODAC2(     NV,INP1,IOUT)
C
C     MODAC2  REDUCES THE SIZE OF INP1 (BY REMOVING SELECTED COLUMNS)
C
C     CORE IS LAIDED OUT AS FOLLOWS
C
C         CONTENTS            LENGTH  TYPE   POINTER
C         --------            ------  ----   -------
C
C         NEW TIMES           NFN      R     IFN
C         KEEP/REMOVE         NFO      I     IKR
C         COPIED COLUMN       MCB(3)   R     ICOL
C
C         2  BUFFERS          SYSBUF   I     IBUF1
C                             SYSBUF   I     IBUF2
C
C     VARIABLES
C
C     NV       NUMBER OF COLUMS TO PROCESS TOGETHER (MINUS SAYS ADD HEAD
C     INP1     COPY FROM THIS FILE
C     IOUT     COPY TO  THIS  FILE
C
C
C
      INTEGER   IZ,SYSBUF,NAME(2),IHD(2),MCB(7),FILE
      REAL  Z(1)
      COMMON /UNPAKX/ITC,II,JJ,INCR
      COMMON /SYSTEM/ SYSBUF
      COMMON /MODAC3/ NFO,NFN,NZ
      COMMON /ZZZZZZ/ IZ(1)
      EQUIVALENCE (Z(1),IZ(1))
      DATA  NAME /4HMODA,4HC2  /
C
C     ALLOCATE CORE
C
      MCB(1) =IOUT
      CALL RDTRL(MCB)
      IF ( MCB(1) .LE. 0) RETURN
      MCB(1) =  INP1
      CALL RDTRL(MCB)
      IF (MCB(1)  .LE. 0) RETURN
      NLOAD = MCB(2)/(NFO*IABS(NV))
      IFN =1
      IKR = IFN + NFN
      ICOL = IKR + NFO
      IBUF1 = NZ -SYSBUF+1
      IBUF2 = IBUF1- SYSBUF
      IF ( ICOL + MCB(3) + 2*SYSBUF .GT. NZ) CALL MESAGE(-8,0,NAME)
C
C     OPEN  FILES
C
      FILE = INP1
      CALL GOPEN(INP1,IZ(IBUF1),0)
      FILE = IOUT
      CALL OPEN(*900,IOUT,IZ(IBUF2),1)
      CALL FNAME(IOUT,IHD)
      CALL WRITE(IOUT,IHD,2,0)
      IF ( NV  .GT. 0) GO  TO  10
      CALL  WRITE(IOUT,Z,NFN,0)
   10 CALL  WRITE(IOUT,0,0,1)
C
C     SET UP MATRIX TRAILER
C
      FILE = INP1
      MCB(2) =0
      MCB(6) =0
      MCB(7) =0
      MCB(1) = IOUT
      ITC = MCB(5)
      INCR = 1
      INV = IABS(NV)
      DO 200 M = 1,NLOAD
      K = IKR -1
      DO  100  I =1,NFO
      K  =K+1
      IF( IZ(K) .EQ. 0)  GO TO 20
C
C     KEEP COLUMN
C
      CALL CYCT2B(INP1,IOUT,INV,IZ(ICOL),MCB)
      GO TO 100
C
C     SKIP COLUMN
C
   20 DO 30 J = 1,INV
      CALL FWDREC(*910,INP1)
   30 CONTINUE
  100 CONTINUE
  200 CONTINUE
C
C     CLOSE  UP
C
      CALL CLOSE(INP1,1)
      CALL CLOSE(IOUT,1)
      CALL WRTTRL(MCB)
      RETURN
C
C     ERROR MESSAGES
C
  900 IP1= -1
  901 CALL MESAGE(IP1,FILE,NAME)
  910 IP1 = -2
      GO TO 901
      END

      SUBROUTINE DIAM (NC,MAXDEG,NL,NODESL,IDEM,MAXLEV,IG,IC,IDEG,
     1                 IDIS,IW,ICC,JG)
C
C     DETERMINE NL STARTING POINTS AND STORE IN NODESL.
C     THIS ROUTINE IS USED ONLY IN BANDIT MODULE
C
      DIMENSION       IG(1),    IDIS(1),  IW(1),    ICC(1),   IC(1),
     1                JG(1),    IDEG(1),  NODESL(1)
      COMMON /BANDS / NN
C
      NL = 0
      MAXLEV = 600000
      DO 100 I = 1,NN
      IF (NC-IC(I)) 100,40,100
   40 IF (MAXDEG-IDEG(I)) 100,50,50
   50 MD = IDIST(I,ML,MAXLEV,IG,IC,IDEG,IDIS,IW,ICC,JG)
      IF (MD) 120,120,60
   60 IF (ML-MAXLEV) 70,80,100
   70 MAXLEV = ML
      NL = 1
      NODESL(1) = I
      GO TO 100
   80 IF (NL .GE. IDEM) GO TO 100
      NL = NL + 1
      NODESL(NL) = I
  100 CONTINUE
      RETURN
C
  120 ML = 1
      NODESL(1) = I
      MAXLEV = 0
      RETURN
      END

      SUBROUTINE GFSMRG (FILEA,FILE11,FILE21,FILE12,FILE22,RPART,CPART)
C
C     GENERAL MATRIX MERGE ROUTINE
C
C
C                  --               --
C                  I        I        I
C                  I FILE11 I FILE12 I   --     --
C                  I        I        I   I       I
C                  I-----------------I = I FILEA I
C                  I        I        I   I       I
C                  I FILE21 I FILE22 I   --     --
C                  I        I        I
C                  --               --
C
C        WHERE
C
C             RPART - ROW PARTITIONING VECTOR
C             CPART - COLUMN PARTITION VECTOR
C
C
      INTEGER       FILEA    ,FILE11   ,FILE12   ,FILE21   ,FILE22  ,
     1              RPART    ,CPART    ,RULE     ,CORE     ,NAME(2) ,
     2              RP(7)    ,CP(7)
C
C     OPEN CORE
C
      COMMON / ZZZZZZ /       CORE(1)
C
C     CALCV COMMON BLOCK
C
      COMMON / PATX   /       LCORE    ,NSUB0    ,NSUB1
C
C     PARTITION - MERGE COMMON BLOCK
C
      COMMON / PARMEG /       IA(7)    ,IA11(7)  ,IA21(7)  ,IA12(7) ,
     1                        IA22(7)  ,LCR      ,RULE
C
      DATA     NAME   /       4HGFSM   , 4HRG    /
C
C
C     GET TRAILERS FOR INPUTS
C
      RP(1) = RPART
      IF (RPART .NE. 0) CALL RDTRL (RP)
      CP(1) = CPART
      IF (CPART .NE. 0) CALL RDTRL (CP)
C
      DO 10 I = 2,7
      IA(I)   = 0
      IA11(I) = 0
      IA12(I) = 0
      IA21(I) = 0
   10 IA22(I) = 0
C
      IA11(1) = FILE11
      IF (FILE11  .NE. 0) CALL RDTRL (IA11)
      IF (IA11(1) .LT. 0) IA11(1) = 0
      IA12(1) = FILE12
      IF (FILE12  .NE. 0) CALL RDTRL (IA12)
      IF (IA12(1) .LT. 0) IA12(1) = 0
      IA21(1) = FILE21
      IF (FILE21  .NE. 0) CALL RDTRL (IA21)
      IF (IA21(1) .LT. 0) IA21(1) = 0
      IA22(1) = FILE22
      IF (FILE22  .NE. 0) CALL RDTRL (IA22)
      IF (IA22(1) .LT. 0) IA22(1) = 0
C
C     SET UP MATRIX CONTROL BLOCK FOR OUTPUT
C
      IA(1) = FILEA
      IA(4) = 2
      IF (RPART.NE.0 .AND. CPART.NE.0) IA(4) = 1
      IA(5) = MAX0(IA11(5),IA12(5),IA21(5),IA22(5))
C
C     SET UP DUMMY PARTITION VECTOR
C
      I = 0
      CORE(  1) = 0
      CORE(I+2) = 1
      CORE(I+3) = IA(2)
      CORE(I+4) = 2
      CORE(I+5) = 1
      CORE(I+6) = 0
C
      RULE = 0
      LCR = KORSZ(CORE)
C
      IF (RPART .EQ. 0) GO TO 30
      IF (CPART .EQ. 0) GO TO 20
C
C     FULL MERGE
C
      IA(2) = NSUB0 + NSUB1
      IA(3) = IA(2)
      CALL MERGE (RP,CP,CORE)
      GO TO 40
C
C     ROW MERGE
C
   20 IA(2) = NSUB0 + NSUB1
      IA(3) = MAX0(IA11(3),IA12(3))
      CALL MERGE (RP,CORE,CORE)
      GO TO 40
C
C     COLUMN MERGE
C
   30 IF (CPART .EQ. 0) GO TO 50
      IA(2) = MAX0(IA11(2),IA21(2))
      IA(3) = NSUB0 + NSUB1
      CALL MERGE (CORE,CP,CORE)
C
C     WRITE TRIALER FOR OUTPUT
C
   40 CALL WRTTRL (IA)
C
      RETURN
C
C     ILLEGAL INPUT - NO PARTITION VECTOR
C
   50 CALL MESAGE (-7,0,NAME)
      RETURN
      END

      SUBROUTINE EMA1D( J, NSCA, SCALAS, PIVOT, DICT, CGV, KGG, CP, F )
C     SUBROUTINE EMA1S( J, NSCA, SCALAS, PIVOT, DICT, CGV, KGG, CP, F )
C*******
C EMA1S ADDS A COLUMN VECTOR IN REAL SINGLE PRECISION
C EMA1D ADDS A COLUMN VECTOR IN REAL DOUBLE PRECISION
C
C     J        INDEX IN SCALAS TO CURRENT RELATIVE COLUMN NBR
C     NSCA     NBR OF ROWS( TERMS ) PER GRID POINT IN COLUMN VECTOR
C     SCALAS   ARRAY OF RELATIVE ROW/COLUMN NUMBERS
C     PIVOT    6-WORD ARRAY AS FOLLOWS...
C          (1) INTERNAL INDEX OF PIVOT
C          (2) DOF OF PIVOT
C          (3) DOF OF EACH POINT CONNECTED TO PIVOT
C          (4) NBR OF CONNECTED POINTS
C          (5) INTERNAL INDEX OF  1ST CONNECTED POINT
C          (6) INTERNAL INDEX OF LAST CONNECTED POINT
C     DICT     DICTIONARY ENTRY FOR ELEMENT AS FOLLOWS...
C          (1) ELEMENT ID
C          (2) FORM( 1=RECT, 2=DIAG )
C          (3) NBR OF TERMS PER COLUMN
C          (4) COMPONENT CODE( DECODED IN SCALAS ARRAY )
C          (5) GE
C          (6) INTERNAL INDEX OF 1ST POINT
C          (7) GINO ADDR OF 1ST COLUMN PARTITION
C         ....
C     CGV      CONNECTED GRID POINT VECTOR
C     KGG      ADDR OF KGG COLUMNS FOR PIVOT
C     CP       ADDR OF COLUMN PARTITION
C     F        FACTOR( RSP ) TO BE APPLIED TO EACH TERM IN CP
C
C******
      INTEGER SCALAS(1) ,PIVOT(6) ,DICT(7)  ,CGV(1)
C
C     REAL             KGG(1), CP(1)
      DOUBLE PRECISION KGG(1), CP(1)
C
C INITIALIZE
C
      ICOL0 = SCALAS(J)*PIVOT(3)*PIVOT(4)
      II0   = PIVOT(5) - 1
      L     = 1
      IF( DICT(2) .NE. 2 ) GO TO 20
C
C PROCESS DIAGONAL PARTITION
C
      II = PIVOT(1)
      IMAT = ICOL0 + CGV(II-II0)+ SCALAS(J)
      KGG(IMAT) = KGG(IMAT) + F*CP(1)
      RETURN
C
C PROCESS RECTANGULAR PARTITION
C
   20 CONTINUE
      NGRID = 4 + 2*DICT(3)/NSCA
      DO 28 I=6,NGRID,2
      K = DICT(I)
      IF( K.EQ. 0 ) RETURN
      IMAT = ICOL0 + CGV(K-II0)
      DO 26 K=1,NSCA
      M = SCALAS(K)
      KGG(IMAT+M) = KGG(IMAT+M) + F*CP(L)
      L = L + 1
   26 CONTINUE
   28 CONTINUE
      RETURN
      END

      SUBROUTINE SHEARS
C
C     THIS SUBROUTINE COMPUTES THE 12 X 12 STIFFNESS MATRIX FOR THE
C     SHEAR PANEL ELEMENT, AS WELL AS ITS DIAGONALIZED MASS MATRIX.
C
C     SINGLE PRECISION VERSION
C
C     ECPT FOR THE SHEAR PANEL ELEMENT
C
C     ECPT( 1)  -  IELID          ELEMENT ID. NO.
C     ECPT( 2)  -  ISILNO(4)      SCALAR INDEX NUMBERS
C     ECPT( 3)  -   ...                   ...
C     ECPT( 4)  -   ...                   ...
C     ECPT( 5)  -   ...                   ...
C     ECPT( 6)  -  MATID          MATERIAL ID.
C     ECPT( 7)  -  T              THICKNESS
C     ECPT( 8)  -  FMU            NON-STRUCTURAL MASS
C     ECPT( 9)  -  ICSID1         COOR. SYS. ID. FOR GRID POINT 1
C     ECPT(10)  -  GP1(3)         BASIC COORDINATES FOR GRID POINT 1
C     ECPT(11)  -   ...                      ...
C     ECPT(12)  -   ...                      ...
C     ECPT(13)  -  ICSID2         COOR. SYS. ID. FOR GRID POINT 2
C     ECPT(14)  -  GP2(3)         BASIC COORDINATES FOR GRID POINT 2
C     ECPT(15)  -   ...                      ...
C     ECPT(16)  -   ...                      ...
C     ECPT(17)  -  ICSID3         COOR. SYS. ID. FOR GRID POINT 3
C     ECPT(18)  -  GP3(3)         BASIC COORDINATES FOR GRID POINT 3
C     ECPT(19)  -   ...                      ...
C     ECPT(20)  -   ...                      ...
C     ECPT(21)  -  ICSID4         COOR. SYS. ID. FOR GRID POINT 4
C     ECPT(22)  -  GP4(3)         BASIC COORDINATES FOR GRID POINT 4
C     ECPT(23)  -   ...                      ...
C     ECPT(24)  -   ...                      ...
C     ECPT(25)  -  TEMPEL         ELEMENT TEMPERATURE
C
      LOGICAL          IHEAT,NOGO
      INTEGER          IPART(4),DICT(11),ESTID
      REAL             NU,NUC,ME(144),KOUT(144),MOUT(144)
      REAL             KE(144),VLEFT(6),VRIGHT(6),TI(9),P(4),VD1(3),
     1                 VD2(3),VKN(3),VK(3),V12(3),V41(3),VP12(3),VI(3),
     2                 VJ(3),AVEC(4),SMALLU(4),SMALLV(4)
      DIMENSION        IECPT(100),ECPT(100)
      COMMON /SYSTEM/  KSYSTM(55),IHEAT
      COMMON /EMGPRM/  IXR,JCORE,NCORE,DUM(12),ISMB(3),IPREC,NOGO,HEAT
      COMMON /EMGDIC/  IDM, LDICT,NGRIDS,ELID,ESTID
      COMMON /EMGEST/  IELID,ISILNO(4),MATID,TSP,FMU,ICSID1,GP1(3),
     1                 ICSID2,GP2(3),ICSID3,GP3(3),ICSID4,GP4(3),TEMPEL
C
C     INPUT AND OUTPUT BLOCKS FOR SUBROUTINE MAT
C
      COMMON /MATOUT/  ESP,GSP,NU,RHO,ALPHA,TSUB0,GSUBE,SIGT,SIGC,SIGS
      COMMON /MATIN /  MATIDC,MATFLG,ELTEMP,STRESS,SINTH,COSTH
      EQUIVALENCE      (ME(1),KE(1)),(KOUT(1),MOUT(1)),
     1                 (IECPT(1),ECPT(1),IELID),(DICT(5),DICT5)
      DATA    IPART /  1,2,3,4 /
C
      NGRIDS = 4
      LDICT  = 5 + NGRIDS
C
C     IF STIFFNESS MATRIX NOT NEEDED GO TO PERFORM MASS CALCULATIONS
C
      IF (ISMB(1) .EQ. 0) GO TO 400
C
      DICT(1) = ESTID
      DICT(2) = 1
      DICT(3) = 12
      DICT(4) = 7
      IP      = IPREC
      ISORT   = 0
C
C     CALL MAT TO GET MATERIAL PROPERTIES.
C
      MATIDC = MATID
      MATFLG = 1
      ELTEMP = TEMPEL
      CALL MAT (IECPT(1))
      DICT5  = GSUBE
C
      T   = TSP
      G   = GSP
      E   = ESP
      IF (T*G .EQ. 0.0) GO TO 7770
      C23 = 2.0/3.0
      NUC = 1.0/(1.0+NU)
C
C     COMPUTE DIAGONAL VECTORS.
C
      DO 10 I = 1,3
      VD1(I) = GP3(I) - GP1(I)
   10 VD2(I) = GP4(I) - GP2(I)
C
C     COMPUTE THE NORMAL VECTOR VKN, NORMALIZE, AND COMPUTE THE
C     PROJECTED AREA, PA
C
      VKN(1) = VD1(2)*VD2(3) - VD1(3)*VD2(2)
      VKN(2) = VD1(3)*VD2(1) - VD1(1)*VD2(3)
      VKN(3) = VD1(1)*VD2(2) - VD1(2)*VD2(1)
      VKL    = SQRT(VKN(1)**2 + VKN(2)**2  + VKN(3)**2)
      IF (VKL .EQ. 0.) GO TO 7770
      VK(1)  = VKN(1)/VKL
      VK(2)  = VKN(2)/VKL
      VK(3)  = VKN(3)/VKL
      PA     = VKL/2.
C
C     COMPUTE  SIDES -12- AND -41-
C
      DO 20 I = 1,3
      V12(I) = GP2(I) - GP1(I)
   20 V41(I) = GP1(I) - GP4(I)
C
C     COMPUTE DOT PRODUCT, V12DK, OF V12 AND VK, THE VECTORS VP12, VI,
C     VJ
C
      V12DK   = V12(1)*VK(1) + V12(2)*VK(2) + V12(3)*VK(3)
      VP12(1) = V12(1) - V12DK*VK(1)
      VP12(2) = V12(2) - V12DK*VK(2)
      VP12(3) = V12(3) - V12DK*VK(3)
      VP12L   = SQRT(VP12(1)**2 + VP12(2)**2 + VP12(3)**2)
      IF (VP12L .EQ. 0.) GO TO 7770
      VI(1) = VP12(1)/VP12L
      VI(2) = VP12(2)/VP12L
      VI(3) = VP12(3)/VP12L
      VJ(1) = VK(2)*VI(3) - VK(3)*VI(2)
      VJ(2) = VK(3)*VI(1) - VK(1)*VI(3)
      VJ(3) = VK(1)*VI(2) - VK(2)*VI(1)
C
C     NORMALIZE J FOR GOOD MEASURE
C
      VJL = SQRT(VJ(1)**2 + VJ(2)**2 + VJ(3)**2)
      IF (VJL .EQ. 0.) GO TO 7770
      VJ(1) = VJ(1)/VJL
      VJ(2) = VJ(2)/VJL
      VJ(3) = VJ(3)/VJL
      X1 = 0.
      Y1 = 0.
      X2 = VP12L
      Y2 = 0.
      X3 = VI(1)*VD1(1) + VI(2)*VD1(2) + VI(3)*VD1(3)
      Y3 = VJ(1)*VD1(1) + VJ(2)*VD1(2) + VJ(3)*VD1(3)
      X4 =-VI(1)*V41(1) - VI(2)*V41(2) - VI(3)*V41(3)
      Y4 =-VJ(1)*V41(1) - VJ(2)*V41(2) - VJ(3)*V41(3)
C
C     CHECK TO SEE IF INTERIOR ANGLES ARE LESS THAN 180 DEGREES. IF NOT,
C     CALL FATAL ERROR MESSAGE.
C
      IF (Y3 .LE. 0.) GO TO 7780
      IF (Y4 .LE. 0.) GO TO 7800
      IF (X3 .LE. Y3*X4/Y4) GO TO 7790
      IF (X4 .GE. X2-(X2-X3)*Y4/Y3) GO TO 7810
C
C     TEST FOR PARALLEL EFFECTS.
C
      CEP1 = ABS(Y3-Y4)
      CEPX = ABS(X3-X4)
      TEMP = X3 - X2
      CEP2 = ABS(Y4*TEMP-Y3*X4)
      CEPY = ABS(X4*TEMP+Y4*Y3)
      EP   = 0.010
      IF (CEP1 .LT. EP*CEPX) GO TO 30
      IF (CEP2 .LT. EP*CEPY) GO TO 40
      GO TO 70
   30 IF (CEP2 .LT. EP*CEPY) GO TO 50
C
C     AT THIS POINT THE LINE CONNECTING POINTS 3 AND 4 IS -PARALLEL- TO
C     THE LINE CONNECTING POINTS 1 AND 2.
C
      TEMP = Y3*X4 - Y4*(X3-X2)
      YP   = X2*Y3*Y4/TEMP
      P(1) = YP - Y1
      P(2) = YP - Y2
      P(3) = YP - Y3
      P(4) = YP - Y4
      XP   = X2*Y3*X4/TEMP
      SA   = (X2 - XP)/YP
      C    = (X1 - XP)/YP
      Z    = ((P(1)*P(2)*PA)/(P(3)*P(4)*2.*G*T))*(1.+C23*NUC*
     X       (SA**2+SA*C+C**2))
      GO TO 80
C
C     AT THIS POINT THE LINE CONNECTING POINTS 1 AND 4 IS -PARALLEL- TO
C     THE LINE CONNECTING POINTS 2 AND 3.
C
   40 D    = -.5*(X4/Y4 + (X3-X2)/Y3)
      XQ   = X4 - Y4*(X3-X4)/(Y3-Y4)
      TEMP = 1.0/SQRT(1.0+D**2)
      P(1) = (XQ-X1-D*Y1)*TEMP
      P(2) = (XQ-X2-D*Y2)*TEMP
      P(3) = (XQ-X3-D*Y3)*TEMP
      P(4) = (XQ-X4-D*Y4)*TEMP
      TEMP = XQ - X4
      B    = (TEMP*D+Y4)/(TEMP-Y4*D)
      Z    = ((P(1)*P(2)*PA)/(P(3)*P(4)*2.*G*T))*(1.+C23*NUC*(B**2+B*D
     1     + D**2))
      GO TO 80
C
C     IN THIS CASE THE PANEL APPROXIMATES A PARALLELOGRAM.
C
   50 DO 60 I = 1,4
   60 P(I) = 1.
      D = -.50*(X4/Y4+(X3-X2)/Y3+(Y3-Y4)/(X3-X4))
      Z = PA/(2.*G*T)*(1.+2.*D**2*NUC)
      GO TO 80
C
C     IN THIS CASE NO PARALLEL EFFECTS EXIST.
C
   70 XQ   = X4 - (X3-X4)/(Y3-Y4)*Y4
      TEMP = Y3*X4 - Y4*(X3-X2)
      XP   = X2*Y3*X4/TEMP
      YP   = X2*Y3*Y4/TEMP
      XL   = SQRT((XQ-XP)**2 + YP**2)
      D    = (XQ-XP)/YP
      TEMP = YP/XL
      P(1) = TEMP*(XQ-X1-D*Y1)
      P(2) = TEMP*(XQ-X2-D*Y2)
      P(3) = TEMP*(XQ-X3-D*Y3)
      P(4) = TEMP*(XQ-X4-D*Y4)
      C    = XL/P(1) - D
      B    = XL/P(4) - C
      A    = XL/P(2) - D
      A2   = A**2
      B2   = B**2
      C2   = C**2
      D2   = D**2
      A3   = A2*A
      B3   = B2*B
      C3   = C2*C
      D3   = D2*D
      A4   = A3*A
      B4   = B3*B
      C4   = C3*C
      D4   = D3*D
      A5   = A4*A
      B5   = B4*B
      C5   = C4*C
      D5   = D4*D
      TEMP = .50*P(1)*P(2)*P(3)*P(4)/XL**2
      TERM = (A + B + C23*(A3+B3) + .20*(A5+B5))*ALOG(ABS(A+B))
      TERM1= (C + D + C23*(C3+D3) + .20*(C5+D5))*ALOG(ABS(C+D))
      TERM2= (B + C + C23*(B3+C3) + .20*(B5+C5))*ALOG(ABS(B+C))
      TERM3= (D + A + C23*(D3+A3) + .20*(D5+A5))*ALOG(ABS(D+A))
      TERM4= .10*((A2-C2)*(B3-D3)+ (B2-D2)*(A3-C3))
      TERM5= .20*((A-C)*(B4-D4) + (B-D)*(A4-C4))
      F    = TEMP*(TERM+TERM1-TERM2-TERM3+TERM4-TERM5)
      Z    = P(1)*P(2)/(P(3)*P(4)*2.*G*T)*(PA+4.*NUC*(F-C23*PA))
   80 XL13 = SQRT(X3**2 + Y3**2)
      XL24 = SQRT((X4-X2)**2 + Y4**2)
      SMALLU(1) = X3/XL13
      SMALLU(2) = (X4-X2)/XL24
      SMALLU(3) = SMALLU(1)
      SMALLU(4) = SMALLU(2)
      SMALLV(1) = Y3/XL13
      SMALLV(2) = Y4/XL24
      SMALLV(3) = SMALLV(1)
      SMALLV(4) = SMALLV(2)
      TEMP    = X4*Y3 - X3*Y4
      AVEC(1) = -.5*X2*Y4*XL13/TEMP
      AVEC(2) =  .5*X2*Y3 *XL24/(TEMP -X2*(Y3-Y4))
      AVEC(3) = -AVEC(1)
      AVEC(4) = -AVEC(2)
C
      DO 90 I = 1,144
   90 KE(I) = 0.
      DO 230 IPVT = 1,4
      CON = AVEC(IPVT)/(2.*Z)
C
C     COMPUTE THE -VLEFT- VECTOR
C
      IVLBEG = 1
      VLEFT(1) = VI(1)*SMALLU(IPVT) + VJ(1)*SMALLV(IPVT)
      VLEFT(2) = VI(2)*SMALLU(IPVT) + VJ(2)*SMALLV(IPVT)
      VLEFT(3) = VI(3)*SMALLU(IPVT) + VJ(3)*SMALLV(IPVT)
      IF (IECPT(4*IPVT+5) .EQ. 0) GO TO 150
      CALL TRANSS (IECPT(4*IPVT+5),TI)
      IVLBEG = 4
      CALL GMMATS (TI,3,3,1, VLEFT(1),3,1,0, VLEFT(4))
C
C     COMPUTE THE 6 X 6 -S
C
  150 DO 220 J = 1,4
      IVRBEG = 1
      VRIGHT(1) = SMALLU(J)*VI(1) + SMALLV(J)*VJ(1)
      VRIGHT(2) = SMALLU(J)*VI(2) + SMALLV(J)*VJ(2)
      VRIGHT(3) = SMALLU(J)*VI(3) + SMALLV(J)*VJ(3)
      IF (IECPT(4*J+5) .EQ. 0) GO TO 170
      CALL TRANSS (IECPT(4*J+5),TI)
      CALL GMMATS (VRIGHT(1),1,3,0, TI,3,3,0, VRIGHT(4))
      IVRBEG = 4
170   JT = (IPVT-1)*36 + (J-1)*9 + 1
      CALL GMMATS (VLEFT(IVLBEG),3,1,0, VRIGHT(IVRBEG),1,3,0, KE(JT))
      JT8 = JT + 8
      DO 180 K = JT,JT8
  180 KE(K) = CON*KE(K)*AVEC(J)
 220  CONTINUE
 230  CONTINUE
C
C     NOW REARRANGE KE BY INCREASING SIL THEN OUTPUT IT VIA EMGOUT
C     FIRST DETERMINE WHAT INCREASING SIL ORDER WILL BE
C
      ASSIGN 290 TO K OR M
  275 CONTINUE
      DO 280 I = 1,3
      IP1 = I + 1
      IT  = IPART(I)
      DO 270 J = IP1,4
      JT = IPART(J)
      IF (ISILNO(IT) .LE. ISILNO(JT)) GO TO 270
      IPART(I) = JT
      IPART(J) = IT
      IT = JT
      GO TO 275
 270  CONTINUE
 280  CONTINUE
      ISORT = 1
      GO TO KORM, (290,420)
C
C     NOW REARRANGE TERMS IN THE STIFFNESS MATRIX KE AND STORE IN KOUT
C
C     KE = (K  ,K  ,K  ,K  ,K  ,...,K  ,K  ,...,K  )
C            11  12  13  14  21      24  31      44
C
C     WHERE  K  IS A 3X3 SUBMATRIX AND  SILS ARE IN GRID POINT ORDER
C             IJ
C
C     AND    *****                  ****
C            * K     K     K     K     *
C            *  L1L1  L1L2  L1L3  L1L4 *
C            *                         *
C            * K     K     K     K     *
C     KOUT = *  L2L1  L2L2  L2L3  L2L4 *
C            *                         *
C            * K     K     K     K     *
C            *  L3L1  L3L2  L3L3  L3L4 *
C            *                         *
C            * K     K     K     K     *
C            *  L4L1  L4L2  L4L3  L4L4 *
C            ****                   ****
C
C     WHERE  KOUT     IS A   3X3    MATRIX AND SILS ARE IN INCREASING
C                LILJ
C     ORDER
C
 290  CONTINUE
      DO 300 I = 1,4
      IS = IPART(I)
      DO 300 J = 1,4
      JS = IPART(J)
      DO 300 K = 1,3
      DO 300 L = 1,3
      IOUT = (I -1)*36 + (J -1)*3 + (K-1)*12 + L
      IKE  = (IS-1)*36 + (JS-1)*9 + (K-1)* 3 + L
  300 KOUT(IOUT) = KE(IKE)
C
C     OUTPUT THE STIFFNESS MATRIX
C
      CALL EMGOUT (KOUT,KOUT,144,1,DICT,1,IP)
C
C     HERE WE CALCULATE THE MASS MATRIX VIA SUBROUTINE EMASTQ
C
  400 IF (ISMB(2) .EQ. 0) RETURN
C
CWKBR 3/94 CALL EMADTQ (6,ME)
      CALL EMASTQ (6,ME)
      IF (ISORT .EQ. 1) GO TO 420
      ASSIGN 420 TO KORM
      GO TO 275
C
C     RETURN WITH A GRID POINT SORT ARRAY IN IPART
C
  420 DO 440 I = 1,4
      IT = 1 + (IPART(I)-1)*3
      IJ = (I-1)*3 + 1
      MOUT(IJ  ) = ME(IT  )
      MOUT(IJ+1) = ME(IT+1)
  440 MOUT(IJ+2) = ME(IT+2)
C
      DICT(1) = ESTID
      DICT(2) = 2
      DICT(3) = 12
      DICT(4) =  7
      DICT5   = 0.
C
      CALL  EMGOUT (KOUT,KOUT,12,1,DICT,2,IP)
      RETURN
C
C     ERROR EXITS
C
 7770 CALL MESAGE (30,26,IECPT(1))
 7777 NOGO = .TRUE.
      RETURN
C
 7780 IECPT(2) = 2
      GO TO 7820
 7790 IECPT(2) = 4
      GO TO 7820
 7800 IECPT(2) = 1
      GO TO 7820
 7810 IECPT(2) = 3
 7820 CALL MESAGE (30,27,IECPT(1))
      GO TO 7777
      END

      SUBROUTINE EM3D (ELTYPE,ISTART,ITYPE,NCOUNT,IDO,IWORDS,NBDYS,ALL,
     1                 NELOUT)
C
C     E  AND  M LOADS FOR 3-D ELEMENTS
C     TETRA  39   WEDGE  40   HEXA1 41  HEXA2  42
C     IHEX1  65   IHEX2  66   IHEX3 67
C
      LOGICAL         ONLYC
      INTEGER         SCR6,ALL,TYPOLD,ELID,
     1                ELTYPE,OUTPT,SYSBUF,POINTR(7,7),FRSTGD,TMAP(88)
      REAL            LL(4,5),W(5)
      DIMENSION       ISC(5),SC(5),XLACC(3),BUF(50),IBUF(50),HCX3(60),
     1                HCX(4),HCY(4),HCZ(4),
     2                G(9),NECPT(1),DR(24),IZ(1),IP(4),R(3,8),XLOAD(8),
     3                GPT(32),BXYZ(3,32),S(4),H(4),GAUSS(8),F(32),
     4                SHP(32),DSHP(3,32),XJACOB(3,3),DSHPB(3,32),HC(96),
     5                HCXYZ(3),GH(3)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /SYSTEM/ KSYSTM(2)
      COMMON /ZZZZZZ/ Z(1)
      COMMON /EMECPT/ ECPT(200)
      COMMON /MATIN / MATID,INFLAG,ELTEMP
      COMMON /HMTOUT/ XMAT(6)
      EQUIVALENCE     (KSYSTM(1),SYSBUF), (KSYSTM(2),OUTPT),
     1                (ECPT(1),NECPT(1)), (Z(1),IZ(1)), (I1,IP(1)),
     2                (I2,IP(2)),(I3,IP(3)), (I4,IP(4))
      EQUIVALENCE     (BUF(1),IBUF(1))  , (ISC(1),SC(1))
C
C     GRID POINT NO FOR EACH ELEMENT
C
      DATA    TMAP  / 1, 2, 3, 4,    1, 2, 3, 5,    1, 2, 3, 6,
     1                1, 4, 5, 6,    2, 4, 5, 6,    3, 4, 5, 6,
     2                1, 2, 4, 6,    2, 3, 4, 6,    1, 3, 4, 5,
     3                2, 3, 4, 5,    1, 3, 5, 6,    1, 2, 5, 6,
     4                1, 2, 3, 6,    1, 3, 4, 8,    1, 3, 8, 6,
     5                1, 5, 6, 8,    3, 6, 7, 8,    2, 3, 4, 7,
     6                1, 2, 4, 5,    2, 4, 5, 7,    2, 5, 6, 7,
     7                4, 5, 7, 8/
C     DATA    NAM   / 4HEM3D,4H       /
      DATA    TYPOLD/ 0               /
      DATA    SCR6  / 306             /
C
C     SET UP GAUSSIAN INTEGRATION POINTS
C
      DATA    GAUSS / 0.57735027,     0.55555556,
     1                0.77459667,     0.88888889,
     2                0.34785484,     0.86113631,
     3                0.65214515,     0.33998104/
C
C     SET UP POINTR ARRAY ONTO EST
C
C                    TYPE  MID   FRSTGD  ISYS1   NIP     ITEMP     NELS
      DATA    POINTR/ 39,   2,    3    ,  7,      0,      23,       1,
     1                40,   2,    3,      9,      0,      33,      12,
     2                41,   2,    3,      11,     0,      43,       5,
     3                42,   2,    3,      11,     0,      43,       10,
     4                65,   10,   2,      16,     12,     48,       1,
     5                66,   22,   2,      28,     24,     108,      1,
     6                67,   34,   2,      40,     36,     168,      1 /
C
C
      ONLYC  =.FALSE.
      NOPTS  = 6
      IF (ELTYPE .EQ. TYPOLD) GO TO 30
      TYPOLD = ELTYPE
      DO 10 L = 1,7
      ILIS   = L
      IF (ELTYPE-POINTR(1,L)) 1200,20,10
   10 CONTINUE
      GO TO 1200
C
C     SET UPPOINTERS INTO EST(ECPT) DATA
C
   20 MID = POINTR(2,ILIS)
C
C     MATERIAL ID
C
      FRSTGD = POINTR(3,ILIS)
C
C     FIRST SIL
C
      ISYS1 = POINTR(4,ILIS)
C
C     FIRST CSIL
C
      NIP = POINTR(5,ILIS)
C
C     NO OF INTEGRATION POINTS (ISOPARAMETRICS ONLY)
C
      ITEMP = POINTR(6,ILIS)
C
C     TEMPERATURE DATA
C
      NELS = POINTR(7,ILIS)
C
C     NO. OF ELEMENTS
C
C     GO TO SECTION 190 FOR ISOPARAMETRICS
C
C     CHECK FOR ZERO LOAD
C
   30 NGRID = ISYS1 - FRSTGD
      IF (ELTYPE .GE. 65) NGRID = NGRID - 6
C                     65 TO 67 ??
      ISC(1) = NECPT(1)
      ISC(2) = 1
      IF (ELTYPE .EQ. 65) ISC(2) = 9
      IF (ELTYPE.EQ.66 .OR. ELTYPE.EQ.67) ISC(2) = 21
C
C     CHECK TO SEE IF THIS ELEMENT CONTAINS A GRID POINT ON A PERMBDY
C     CARD. IF SO, OR IF NO PERMBDY CARD EXISTS, COMPUTE LOADS FOR THE
C     ELEMENT. IF NOT, COMPUTE HC CENTROIDAL VALUE ONLY. (ONLYC=.TRUE.)
C     THE PERMBDY SILS START AT Z(ISTART-NBDYS-1)
C
      IF (NBDYS .EQ. 0) GO TO 50
C
      DO 40 I = 1,NGRID
      NG = NECPT(FRSTGD+I-1)
      DO 40 J = 1,NBDYS
      IF (NG .EQ. IZ(ISTART-NBDYS-NELOUT+J-1)) GO TO 50
   40 CONTINUE
C
C     ELEMENT HAS NO GRIDS ON PERMBDY
C
      ONLYC =.TRUE.
      NOPTS = 1
   50 IF (ONLYC .AND. ITYPE.EQ.24) RETURN
C
C     IF ONLYC=TRUE, CHECK TO SEE IF THE ELEMENT HAD AN ELFORCE REQUEST.
C     IF SO, CONTINUE. IF NOT, JUST WRITE ZEROS TO HCCEN,SCR6) AND
C     RETURN.
C
      IF (.NOT.ONLYC) GO TO 70
      IF (ALL .EQ. 1) GO TO 70
      IF (NELOUT .EQ. 0) GO TO 100
C
      DO 60 I = 1,NELOUT
      IF (NECPT(1) .EQ. IZ(ISTART-NELOUT+I-1)) GO TO 70
   60 CONTINUE
      GO TO 100
   70 IF (ITYPE.NE.20 .AND. ITYPE.NE.24) GO TO 130
      G1 = 0.
      G2 = 0.
      G3 = 0.
      H1 = 0.
      H2 = 0.
      H3 = 0.
      DO 80 I = 1,NGRID
      ISUB = ISTART + 3*NECPT(FRSTGD+I-1) - 3
      IF (ITYPE .EQ. 24) ISUB = ISTART + 3*NCOUNT - 3
      H1 = H1 + ABS(Z(ISUB  ))
      H2 = H2 + ABS(Z(ISUB+1))
      H3 = H3 + ABS(Z(ISUB+2))
      G1 = G1 + Z(ISUB  )
      G2 = G2 + Z(ISUB+1)
      G3 = G3 + Z(ISUB+2)
      IF (ITYPE .EQ. 24) GO TO 90
   80 CONTINUE
   90 HL = H1 + H2 + H3
      IF (HL .NE. 0.) GO TO 120
      IF (ITYPE .EQ. 24) RETURN
C
  100 SC(3) = 0.
      SC(4) = 0.
      SC(5) = 0.
      CALL WRITE (SCR6,SC,2,0)
      ISC2  = ISC(2)
      DO 110 I = 1,ISC2
      CALL WRITE (SCR6,SC(3),3,0)
  110 CONTINUE
      RETURN
C
  120 IF (ITYPE .EQ. 24) GO TO 130
C
C     AVERGAGE SPCFLD
C
      AHCX = G1/FLOAT(NGRID)
      AHCY = G2/FLOAT(NGRID)
      AHCZ = G3/FLOAT(NGRID)
C
  130 IF (ELTYPE .GE. 65) GO TO 500
      IF (ONLYC) GO TO 140
C
C     GET MATERIAL INFO
C     INFLAG = 3  RETURNS A 3X3 MATRIX
C
      LL(1,1) = .25
      LL(2,1) = .25
      LL(3,1) = .25
      LL(4,1) = .25
      LL(1,2) = .5
      LL(2,2) = 1./6.
      LL(3,2) = LL(2,2)
      LL(4,2) = LL(2,2)
      LL(1,3) = 1./6.
      LL(2,3) = .5
      LL(3,3) = LL(1,3)
      LL(4,3) = LL(1,3)
      LL(1,4) = 1./6.
      LL(2,4) = LL(1,4)
      LL(3,4) = .5
      LL(4,4) = LL(1,4)
      LL(1,5) = 1./6.
      LL(2,5) = LL(1,5)
      LL(3,5) = LL(1,5)
      LL(4,5) = .5
      W(1)    =-.8
      W(2)    = 9./20.
      W(3)    = W(2)
      W(4)    = W(2)
      W(5)    = W(2)
      INFLAG  = 3
      MATID   = NECPT(MID)
      ELTEMP  = ECPT(ITEMP)
      CALL HMAT (NECPT(1))
C
C     G STORED BY ROW
C
      G(1) = XMAT(1)
      G(2) = XMAT(2)
      G(3) = XMAT(3)
      G(4) = XMAT(2)
      G(5) = XMAT(4)
      G(6) = XMAT(5)
      G(7) = XMAT(3)
      G(8) = XMAT(5)
      G(9) = XMAT(6)
C
C     PUT COORDINATES OF GRID POINTS INTO ARRAY
C     FOR HEXA2  DIVIDE VOLUME BY 2.
C
      XM = 1.
      IF (ELTYPE .EQ. 42) XM = 2.
C
C     TETRA   4 GRID PTS    1 ELEMENT
C     WEDGE   6 GRID PTS   18 ELEMENTS(6 ARE DUPLICATES-4 POINTS AT A
C     HEXA1   8 GRID PTS    5 ELEMENT (4 PTS AT A TIME)
C     HEXA2   8 GRID PTS    10ELEMENT (4 PTS AT A TIME)
C     SET UP PROPER POINTERS VIA TMAP
C     R ARRAY CONTAINS COORDINATE INFO
C
  140 DO 150 I = 1,NGRID
      ITT    = ISYS1 + 4*I - 4
      R(1,I) = ECPT(ITT+1)
      R(2,I) = ECPT(ITT+2)
      R(3,I) = ECPT(ITT+3)
  150 CONTINUE
C
C     SET UP POINTER TO GRID PT NO
C
      IROW = 0
      IF (ELTYPE.EQ.41 .OR. ELTYPE.EQ.42) IROW = 12
      DO 160 I = 1,8
  160 XLOAD(I) = 0.0
C
C     SET UP POINTS FOR AVERAGE COORDINATES
C
      XXC = 0.
      YYC = 0.
      ZZC = 0.
      DO 170 I = 1,NGRID
      XXC = XXC + R(1,I)
      YYC = YYC + R(2,I)
      ZZC = ZZC + R(3,I)
  170 CONTINUE
      XXC = XXC/FLOAT(NGRID)
      YYC = YYC/FLOAT(NGRID)
      ZZC = ZZC/FLOAT(NGRID)
C
C     PRINCIPAL LOOP OVER ELEMENT OF THE GIVEN TYPE
C
      DO 400 IEL = 1,NELS
      IF (ONLYC) GO TO 200
C
C     RESET XM FOR WEDGES. 1ST 12 CONFIGURATIONS ARE MULTIPLIED BY 2.
C     ALL 18 ARE DIVIDED BY 6.(SINCE XM IS A DIVISOR, USE RECIPROCALS)
C
      IF (ELTYPE.EQ.40 .AND. IEL.LE.6) XM = 6./2.
      IF (ELTYPE.EQ.40 .AND. IEL.GT.6) XM = 6.
      ISUB = (IROW+IEL-1)*4
      DO 180 I = 1,4
      F(I)  = 0.
      IP(I) = I
      IF (ELTYPE .GE. 40) IP(I) = TMAP(ISUB+I)
  180 CONTINUE
C
C     NEED DET TO COMPUTE VOL
C
      TERM1 =  R(3,I4)*((R(1,I2)-R(1,I1))*R(2,I3) +
     1        (R(1,I1)-R(1,I3))*R(2,I2) + (R(1,I3)-R(1,I2))*R(2,I1))
      TERM2 =  R(3,I3)*((R(1,I1)-R(1,I2))*R(2,I4) +
     1        (R(1,I4)-R(1,I1))*R(2,I2) + (R(1,I2)-R(1,I4))*R(2,I1))
      TERM3 =  R(3,I2)*((R(1,I3)-R(1,I1))*R(2,I4) + (R(1,I1)-R(1,I4))*
     1         R(2,I3) + (R(1,I4)-R(1,I3))*R(2,I1))
      TERM4 =  R(3,I1)*((R(1,I2)-R(1,I3))*R(2,I4) + (R(1,I4)-R(1,I2))*
     1         R(2,I3) + (R(1,I3)-R(1,I4))*R(2,I2))
      DET   =  TERM1 + TERM2 + TERM3 + TERM4
      VOL   =  ABS(DET)/6.
C
C     GRADIENTS OF SHAPE FUNCTIONS
C
      DR( 1) = R(3,I3)*R(2,I4) - R(3,I4)*R(2,I3) + R(2,I2)*(R(3,I4)-
     1         R(3,I3)) - R(3,I2)*(R(2,I4)-R(2,I3))
      DR( 2) = R(1,I3)*R(3,I4) - R(1,I4)*R(3,I3) - R(1,I2)*(R(3,I4)-
     1         R(3,I3)) + R(3,I2)*(R(1,I4)-R(1,I3))
      DR( 3) = R(2,I3)*R(1,I4) - R(1,I3)*R(2,I4) + R(1,I2)*(R(2,I4)-
     1         R(2,I3)) - R(2,I2)*(R(1,I4)-R(1,I3))
      DR( 4) = R(2,I3)*R(3,I4) - R(2,I4)*R(3,I3) - R(2,I1)*(R(3,I4)-
     1         R(3,I3)) + R(3,I1)*(R(2,I4)-R(2,I3))
      DR( 5) = R(1,I4)*R(3,I3) - R(1,I3)*R(3,I4) + R(1,I1)*(R(3,I4)-
     1         R(3,I3)) - R(3,I1)*(R(1,I4)-R(1,I3))
      DR( 6) = R(1,I3)*R(2,I4) - R(2,I3)*R(1,I4) - R(1,I1)*(R(2,I4)-
     1         R(2,I3)) + R(2,I1)*(R(1,I4)-R(1,I3))
      DR( 7) = R(3,I2)*R(2,I4) - R(2,I2)*R(3,I4) + R(2,I1)*(R(3,I4)-
     1         R(3,I2)) - R(3,I1)*(R(2,I4)-R(2,I2))
      DR( 8) = R(1,I2)*R(3,I4) - R(1,I4)*R(3,I2) - R(1,I1)*(R(3,I4)-
     1         R(3,I2)) + R(3,I1)*(R(1,I4)-R(1,I2))
      DR( 9) = R(2,I2)*R(1,I4) - R(1,I2)*R(2,I4) + R(1,I1)*(R(2,I4)-
     1         R(2,I2)) - R(2,I1)*(R(1,I4)-R(1,I2))
      DR(10) = R(2,I2)*R(3,I3) - R(3,I2)*R(2,I3) - R(2,I1)*(R(3,I3)-
     1         R(3,I2)) + R(3,I1)*(R(2,I3)-R(2,I2))
      DR(11) = R(3,I2)*R(1,I3) - R(1,I2)*R(3,I3) + R(1,I1)*(R(3,I3)-
     1         R(3,I2)) - R(3,I1)*(R(1,I3)-R(1,I2))
      DR(12) = R(1,I2)*R(2,I3) - R(2,I2)*R(1,I3) - R(1,I1)*(R(2,I3)-
     1         R(2,I2)) + R(2,I1)*(R(1,I3)-R(1,I2))
C
      DO 190  K = 1,12
  190 DR(K) = DR(K)/DET
C
C     MULTIPLY SHAPE FUNCTION  BY G
C
      IF (ITYPE .NE. 24) CALL GMMATS (DR(1),4,3,0,G,3,3,0,DR(13))
C
C     COMPUTE HC
C
      IF (ITYPE .NE. 24) GO TO 200
C
C     REMFLUX
C
      NSUBX = ISTART + 3*NCOUNT - 3
      HC(1) = Z(NSUBX)
      HC(2) = Z(NSUBX+1)
      HC(3) = Z(NSUBX+2)
      GO TO 360
C
C     INTEGRATE TO GET HC
C
  200 KTYPE = ITYPE - 19
      XLACC(1) = 0.
      XLACC(2) = 0.
      XLACC(3) = 0.
C
C     START INTEGRATION PROCEDURE-NEED 5 POINTS FOR CUBIC + CENTROID
C
      DO 340 NPTS = 1,NOPTS
C
C     DO CENTROID FOR ONLY 1ST TETRA
C
      IF (NPTS.EQ.NOPTS .AND. IEL.GT.1) GO TO 340
C
C     COMPUTE BASIC COORDS OF INTEGRATION POINT
C
      IF (NPTS .NE. NOPTS) GO TO 210
C
C     CENTROID
C
      XX = XXC
      YY = YYC
      ZZ = ZZC
      IF (ITYPE .NE. 20) GO TO 220
C
C     AVERAGE SPCFLD
C
      HC(1) = AHCX
      HC(2) = AHCY
      HC(3) = AHCZ
      GO TO 310
  210 XX = LL(1,NPTS)*R(1,I1) + LL(2,NPTS)*R(1,I2) + LL(3,NPTS)*R(1,I3)
     1   + LL(4,NPTS)*R(1,I4)
      YY = LL(1,NPTS)*R(2,I1) + LL(2,NPTS)*R(2,I2) + LL(3,NPTS)*R(2,I3)
     1   + LL(4,NPTS)*R(2,I4)
      ZZ = LL(1,NPTS)*R(3,I1) + LL(2,NPTS)*R(3,I2) + LL(3,NPTS)*R(3,I3)
     1   + LL(4,NPTS)*R(3,I4)
  220 HC(1) = 0.
      HC(2) = 0.
      HC(3) = 0.
C
C     COMPUTE HC AT THIS PPOINT FOR ALL LOADS OF THIS TYPE IN THIS
C     SUBCASE
C
      DO 300 IJK = 1,IDO
      IF (ITYPE .EQ. 20) GO TO 240
      ISUB = ISTART + (IJK-1)*IWORDS - 1
      DO 230 I = 1,IWORDS
  230 BUF(I) = Z(ISUB+I)
C
      GO TO (240,260,270,280), KTYPE
C
C     SPCFLD
C
  240 DO 250 I = 1,4
      ISIL = FRSTGD - 1 + IP(I)
      IST  = ISTART + 3*NECPT(ISIL) - 3
      HCX(I) = Z(IST  )
      HCY(I) = Z(IST+1)
      HCZ(I) = Z(IST+2)
  250 CONTINUE
      HC1 = LL(1,NPTS)*HCX(1) + LL(2,NPTS)*HCX(2) + LL(3,NPTS)*HCX(3) +
     1      LL(4,NPTS)*HCX(4)
      HC2 = LL(1,NPTS)*HCY(1) + LL(2,NPTS)*HCY(2) + LL(3,NPTS)*HCY(3) +
     1      LL(4,NPTS)*HCY(4)
      HC3 = LL(1,NPTS)*HCZ(1) + LL(2,NPTS)*HCZ(2) + LL(3,NPTS)*HCZ(3) +
     1      LL(4,NPTS)*HCZ(4)
      GO TO 290
C
C     CEMLOOP,GEMLOOP,MDIPOLE
C
  260 CALL AXLOOP (BUF,IBUF,XX,YY,ZZ,HC1,HC2,HC3)
      GO TO 290
  270 CALL GELOOP (BUF,IBUF,XX,YY,ZZ,HC1,HC2,HC3)
      GO TO 290
  280 CALL DIPOLE (BUF,IBUF,XX,YY,ZZ,HC1,HC2,HC3)
  290 HC(1) = HC(1) + HC1
      HC(2) = HC(2) + HC2
      HC(3) = HC(3) + HC3
  300 CONTINUE
  310 IF (NPTS .NE. NOPTS) GO TO 320
      SC(3) = HC(1)
      SC(4) = HC(2)
      SC(5) = HC(3)
      CALL WRITE (SCR6,SC,5,0)
      GO TO 340
C
C     WE HAVE HC AT THIS POINT. MULT. BY  WEIGHT AND ACCUMULATE
C
  320 DO 330 I = 1,3
  330 XLACC(I) = XLACC(I) + HC(I)*W(NPTS)
C
C     GET ANOTHER INTEGRATTION POINT
C
  340 CONTINUE
C
      IF (ONLYC) RETURN
      DO 350 I = 1,3
  350 HC(I) = XLACC(I)
  360 CONTINUE
C
C     MULTIPLY HC BY GRADIENTS AND MATERIALS
C
      ISUBX = 13
      IF (ITYPE .EQ. 24) ISUBX = 1
      CALL GMMATS (DR(ISUBX),4,3,0,HC,3,1,0,F(1))
C
      DO 370 K = 1,4
      KK = IP(K)
  370 XLOAD(KK) = XLOAD(KK) + F(K)*VOL/XM
C
C     XLOAD   IS SUM OF ALL LOADS FOR ALL THE ELEMENTS
C     F COMPUTED FOR A GIVEN TETRA OF THE TOTAL SHAPE
C     SO MULTIPLY BY VOL
C
  400  CONTINUE
C
      DO 430  I = 1,NGRID
      IS   = FRSTGD - 1 + I
      ISIL = NECPT(IS)
C
C     IF PERMBDY EXISTS AND IF GRID IS NOT ON IT, IGNORE ITS LOAD
C
      IF (NBDYS .EQ. 0) GO TO 420
      DO 410 J = 1,NBDYS
      IF (ISIL .NE. IZ(ISTART-NBDYS-NELOUT+J-1)) GO TO 410
      GO TO 420
  410 CONTINUE
      GO TO 430
  420 Z(ISIL) = Z(ISIL) - XLOAD(I)
  430 CONTINUE
      RETURN
C
C     ISOPARAMETRIC SOLIDS
C
  500 JTYPE = ITYPE
      ITYPE = ELTYPE - 64
      INIP  = NECPT(NIP)
      IF (INIP .EQ. 0) INIP = ITYPE/2 + 2
      NP    = 12*ITYPE - 4
      ELID  = NECPT(1)
C
C     SET UP FOR FETCHING SHAPE FUNCTIONS
C
      DO 510 I = 1,NP
      GPT(I) = ECPT(ITEMP-1+I)
      DO 510 J = 1,3
      BXYZ(J,I) = ECPT(NP+4+4*I+J)
  510 CONTINUE
      IF (ONLYC) GO TO 570
      I = INIP - 1
      GO TO (520,530,540), I
  520 H(1)  = 1.
      S(1)  = GAUSS(1)
      H(2 ) = H(1)
      S(2)  = -S(1)
      GO TO 550
  530 H(1)  = GAUSS(2)
      S(1)  = GAUSS(3)
      H(2 ) = GAUSS(4)
      S(2)  = 0.
      H(3 ) = H(1)
      S(3 ) = -S(1)
      GO TO 550
  540 H(1 ) = GAUSS(5)
      S(1)  = GAUSS(6)
      H(2)  = GAUSS(7)
      S(2)  = GAUSS(8)
      H(3)  = H(2)
      S(3)  = -S(2)
      H(4) = H(1)
      S(4) = -S(1)
  550 DO 560 I = 1,32
  560 F(I) = 0.0
C
C     SET UP HC ARRAY GIVING HC AT EACH GRID
C
      IF (JTYPE .NE. 24) GO TO 570
C
C     REMFLUX
C
      ISUB  = ISTART + 3*NCOUNT - 3
      GH(1) = Z(ISUB)
      GH(2) = Z(ISUB+1)
      GH(3) = Z(ISUB+2)
      GO TO 610
C
C     IF SPCFLD,PICK UP GRID VALUES HERE. IF NOT, PICK UP INTEGRATION
C     POINT VALUES LATER.(THERE IS ONLY ONE SPCFLD CARD AT THIS POINT)
C
  570 IF (JTYPE .NE. 20) GO TO 590
      DO 580 I = 1,NP
      ISIL = 3*NECPT(I+1)
      HC(3*I-2) = Z(ISTART+ISIL-3)
      HC(3*I-1) = Z(ISTART+ISIL-2)
      HC(3*I  ) = Z(ISTART+ISIL-1)
  580 CONTINUE
  590 INFLAG = 3
      MATID  = NECPT(MID)
  610 KTYPE  = JTYPE - 20
      IF (ONLYC) GO TO 850
C
C     START INTEGRATION
C
      DO 800 I = 1,INIP
      DO 800 J = 1,INIP
      DO 800 K = 1,INIP
C
C     FETCH SHAPE FUNCTIONS FOR THIS INTEGRATION POINT
C
      CALL IHEXSS(ITYPE,SHP,DSHP,XJACOB,DETJ,ELID,S(I),S(J),S(K),BXYZ)
C
C     COMPUTE NI W.R.T. X,Y,Z(REVERVSE CALLING SEQUENCE,SINCE COL STOR)
C
      CALL GMMATS(DSHP,NP,3,0,XJACOB,3,3,0,DSHPB)
C
C     COMPUTE TEMPERATURES AND HC  AT THIS INTEGRSTION POINT
C
      ELTEMP = 0
      DO 620 L = 1,NP
      ELTEMP = ELTEMP + SHP(L)*GPT(L)
  620 CONTINUE
      IF (JTYPE .EQ. 24) GO TO 730
      HCXYZ(1) = 0.
      HCXYZ(2) = 0.
      HCXYZ(3) = 0.
      IF (JTYPE .EQ. 20) GO TO 700
C
C     FOR LOOPS AND DIPOLES, COMPUTE BASIC COORDS FOR THIS INTEGRATION
C     POINT
C
      XX = 0.
      YY = 0.
      ZZ = 0.
      DO 630 L = 1,NP
      XX = XX + SHP(L)*BXYZ(1,L)
      YY = YY + SHP(L)*BXYZ(2,L)
      ZZ = ZZ + SHP(L)*BXYZ(3,L)
  630 CONTINUE
      DO 690 IJK = 1,IDO
      ISUB = ISTART + (IJK-1)*IWORDS - 1
      DO 640 L = 1,IWORDS
  640 BUF(L) = Z(ISUB+L)
C
C     COMPUTE HC AT THIS POINT DUE TO ALL LOADS OF PRESENT TYPE
C
      GO TO (650,660,670), KTYPE
  650 CALL AXLOOP (BUF,IBUF,XX,YY,ZZ,HC1,HC2,HC3)
      GO TO 680
  660 CALL GELOOP (BUF,IBUF,XX,YY,ZZ,HC1,HC2,HC3)
      GO TO 680
  670 CALL DIPOLE (BUF,IBUF,XX,YY,ZZ,HC1,HC2,HC3)
  680 HCXYZ(1) = HCXYZ(1) + HC1
      HCXYZ(2) = HCXYZ(2) + HC2
      HCXYZ(3) = HCXYZ(3) + HC3
  690 CONTINUE
      GO TO 720
C
C     SPCFLD
C
  700 DO 710  L = 1,NP
      HCXYZ(1) = HCXYZ(1) + SHP(L)*HC(3*L-2)
      HCXYZ(2) = HCXYZ(2) + SHP(L)*HC(3*L-1)
      HCXYZ(3) = HCXYZ(3) + SHP(L)*HC(3*L  )
  710 CONTINUE
C
      CALL HMAT(ELID)
C
  720 G(1) = XMAT(1)
      G(2) = XMAT(2)
      G(3) = XMAT(3)
      G(4) = XMAT(2)
      G(5) = XMAT(4)
      G(6) = XMAT(5)
      G(7) = XMAT(3)
      G(8) = XMAT(5)
      G(9) = XMAT(6)
C
      CALL GMMATS (G,3,3,0,HCXYZ,3,1,0,GH)
C
  730 SFACT = H(I)*H(J)*H(K)*DETJ
      DO 740 L = 1,NP
      F(L) = F(L) + (DSHPB(1,L)*GH(1) + DSHPB(2,L)*GH(2) +
     1       DSHPB(3,L)*GH(3))*SFACT
  740 CONTINUE
C
C     GET ANOTHER INTEGRATIONPOINT
C
  800 CONTINUE
C
C     ADD LOADS INTO LOAD ARRAY
C
      DO 840 L = 1,NP
      ISIL = NECPT(FRSTGD+L-1)
C
C     IF PERMBDY EXISTS AND IF GRID IS NOT ON IT, IGNORE ITS LOAD
C
      IF (NBDYS .EQ. 0) GO TO 830
      DO 820 I = 1,NBDYS
      IF (ISIL .NE. IZ(ISTART-NBDYS-NELOUT+I-1)) GO TO 820
      GO TO 830
  820 CONTINUE
      GO TO 840
  830 Z(ISIL) = Z(ISIL) - F(L)
  840 CONTINUE
  850 ITYPE = JTYPE
C
C     BEFORE LEAVING, WE MUST COMPUTE HC VALUES AT GRIDS OF ISOPARA-
C     METRICS AND WRITE TO SCR6
C
      IF (JTYPE .EQ. 24) GO TO 1150
      CALL WRITE (SCR6,ISC,2,0)
      IF (JTYPE .NE. 20) GO TO 1010
C
C     FOR SPCFLD THE VALUES ARE IN CORE(EXCEPT FOR MIFPOINTS OF IHEX3)
C
      IF (ELTYPE .EQ. 67) GO TO 880
      CALL WRITE (SCR6,HC,3*NP,0)
C
C     CENTROID/ XI = ETA = ZETA = 0
C
  860 CALL IHEXSS (ELTYPE-64,SHP,DSHP,XJACOB,DETJ,ELID,0.,0.,0.,BXYZ)
      HCX3(1) = 0.
      HCX3(2) = 0.
      HCX3(3) = 0.
      DO 870 L = 1,NP
      HCX3(1) = HCX3(1) + SHP(L)*HC(3*L-2)
      HCX3(2) = HCX3(2) + SHP(L)*HC(3*L-1)
      HCX3(3) = HCX3(3) + SHP(L)*HC(3*L  )
  870 CONTINUE
      CALL WRITE (SCR6,HCX3,3,0)
      GO TO 1150
  880 ISUB1 = 1
      ISUB2 = 10
      J = -5
  890 DO 900 I = ISUB1,ISUB2,3
      J = J + 6
      K = 3*I - 2
      HCX3(J  ) = HC(K  )
      HCX3(J+1) = HC(K+1)
      HCX3(J+2) = HC(K+2)
      HCX3(J+3) = .5*(HC(K+3) + HC(K+6))
      HCX3(J+4) = .5*(HC(K+4) + HC(K+7))
      HCX3(J+5) = .5*(HC(K+5) + HC(K+8))
  900 CONTINUE
      IF (ISUB1 .EQ. 21) GO TO 1000
      J = 22
      DO 910 I = 13,16
      J = J + 3
      K = 3*I - 2
      HCX3(J  ) = .5*(HC(K  ) + HC(K+12))
      HCX3(J+1) = .5*(HC(K+1) + HC(K+13))
      HCX3(J+2) = .5*(HC(K+2) + HC(K+14))
  910 CONTINUE
      ISUB1 = 21
      ISUB2 = 30
      J = 31
      GO TO 890
C
C     DONE - WRITE RESULTS
C
 1000 CALL WRITE (SCR6,HCX3,60,0)
      GO TO 860
C
C     CEMLOOP, GEMLOOP, MDIPOLE
C
 1010 NX = NP + 1
      IF (ELTYPE .EQ. 67) NX = 21
      DO 1140 J = 1,NX
      IF (J .NE. NX) GO TO 1030
C
C     CENTROID
C
      CALL IHEXSS (ELTYPE-64,SHP,DSHP,XJACOB,DETJ,ELID,0.,0.,0.,BXYZ)
      XX = 0.
      YY = 0.
      ZZ = 0.
      DO 1020 L = 1,NP
      XX = XX + SHP(L)*BXYZ(1,L)
      YY = YY + SHP(L)*BXYZ(2,L)
      ZZ = ZZ + SHP(L)*BXYZ(3,L)
 1020 CONTINUE
      GO TO 1070
C
 1030 IF (ELTYPE .NE. 67) GO TO 1060
C
C     IHEX3
C
      IF (J.EQ. 1) K1 =-1
      IF (J.EQ.13) K1 = 7
      IF (J.EQ. 1) K2 =-1
      IF (J.EQ.13) K2 = 7
      IF (J.LT.9 .OR. J.GT.12) GO TO 1040
      XX = .5*(BXYZ(1,J+4) + BXYZ(1,J+8))
      YY = .5*(BXYZ(2,J+4) + BXYZ(2,J+8))
      ZZ = .5*(BXYZ(3,J+4) + BXYZ(3,J+8))
      GO TO 1070
 1040 IF ((J/2)*2 .NE. J)GO TO 1050
      K1 = K1 + 1
      XX = .5*(BXYZ(1,J+K1) + BXYZ(1,J+K1+1))
      YY = .5*(BXYZ(2,J+K1) + BXYZ(2,J+K1+1))
      ZZ = .5*(BXYZ(3,J+K1) + BXYZ(3,J+K1+1))
      GO TO 1070
 1050 K2 = K2 + 1
      XX = BXYZ(1,J+K2)
      YY = BXYZ(2,J+K2)
      ZZ = BXYZ(3,J+K2)
      GO TO 1070
C
 1060 XX = BXYZ(1,J)
      YY = BXYZ(2,J)
      ZZ = BXYZ(3,J)
 1070 HC(1) = 0.
      HC(2) = 0.
      HC(3) = 0.
      DO 1130 IJK = 1,IDO
      ISUB = ISTART + (IJK-1)*IWORDS - 1
      DO 1080 I = 1,IWORDS
 1080 BUF(I) = Z(ISUB+I)
C
C     COMPUTE HC AT THIS POINT
C
      GO TO (1090,1100,1110), KTYPE
 1090 CALL AXLOOP (BUF,IBUF,XX,YY,ZZ,HC1,HC2,HC3)
      GO TO 1120
 1100 CALL GELOOP (BUF,IBUF,XX,YY,ZZ,HC1,HC2,HC3)
      GO TO 1120
 1110 CALL DIPOLE (BUF,IBUF,XX,YY,ZZ,HC1,HC2,HC3)
 1120 HC(1) = HC(1) + HC1
      HC(2) = HC(2) + HC2
      HC(3) = HC(3) + HC3
 1130 CONTINUE
C
      CALL WRITE (SCR6,HC,3,0)
 1140 CONTINUE
C
 1150 RETURN
C
 1200 WRITE  (OUTPT,1210) UFM
 1210 FORMAT (A23,' - WRONG ELEMENT TYPE IN EM3D PROBLEM.')
      CALL MESAGE (-61,0,0)
      RETURN
      END

      SUBROUTINE CMAUTO
C
C     THIS SUBROUTINE PROCESSES THE AUTOMATIC CONNECTION OF
C     SUBSTRUCTURES IN THE COMB1 MODULE
C
      EXTERNAL        RSHIFT,ANDF
      LOGICAL         PRINT,FOUND,TDAT,BACK,IAUTO
      INTEGER         SCSFIL,SCCONN,BUF1,BUF2,SNEXT(8),ST,NWD(8),SCORE,
     1                Z,SPK,SNK,CE(9),SVKK,ANDF,AAA(2),SSIL(8),NSIL(8),
     2                STS,COMBO,RESTCT,OUTT,NAME(14),RSHIFT,IHD(12),
     3                IBITS(2),JBITS(2)
      DIMENSION       RZ(1),A(3),B(3)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /CMB001/ SCR1,SCR2,SCBDAT,SCSFIL,SCCONN,SCMCON,SCTOC,
     1                GEOM4,CASECC
      COMMON /CMB002/ BUF1,BUF2,BUF3,BUF4,BUF5,SCORE,LCORE,INPT,OUTT
      COMMON /CMB003/ COMBO(7,5),CONSET,IAUTO,TOLER,NPSUB,CONECT,TRAN,
     1                MCON,RESTCT(7,7),ISORT,ORIGIN(7,3),IPRINT
      COMMON /CMB004/ TDAT(6)
      COMMON /ZZZZZZ/ Z(1)
      COMMON /BLANK / STEP,IDRY
      COMMON /OUTPUT/ ITITL(96),IHEAD(96)
      COMMON /SYSTEM/ XXX,IOT,JUNK(6),NLPP,JUNK1(2),LINE,JUNK2(2),
     1                IDAT(3),JUNK7(7),ISW
      EQUIVALENCE     (Z(1),RZ(1))
      DATA    AAA   / 4HCMAU, 2HTO /, IBLNK / 4H    /
      DATA    IHD   / 4H SUM, 4HMARY, 4H OF , 4H AUT, 4HOMAT, 4HICAL,
     1                4HLY G, 4HENER, 4HATED, 4H CON, 4HNECT, 4HIONS/
C
      NLIN  = 1000
      FOUND = .FALSE.
      PRINT = .FALSE.
      IF (ANDF(RSHIFT(IPRINT,10),1) .EQ. 1) PRINT = .TRUE.
      NP2 = 2*NPSUB
      DO 10 I = 1,NP2,2
      J = I/2 + 1
      NAME(I  ) = COMBO(J,1)
      NAME(I+1) = COMBO(J,2)
   10 CONTINUE
      DO 20 I = 1,96
      IHEAD(I) = IBLNK
   20 CONTINUE
      J = 1
      DO 30 I = 75,86
      IHEAD(I) = IHD(J)
   30 J = J + 1
      ISAVS = SCORE
      ISAVL = LCORE
      IFILE = SCCONN
      CALL OPEN (*310,SCCONN,Z(BUF2),3)
      IF (IAUTO) GO TO 40
      CALL CLOSE (SCCONN,1)
      RETURN
C
   40 IFILE = SCSFIL
      CALL OPEN (*310,SCSFIL,Z(BUF1),0)
      SSIL(1) = SCORE
      NOUT = NPSUB + 2
      IDIR = ISORT + 1
      DO 110 I = 1,NPSUB
      STS = SSIL(I)
      NCSUB = COMBO(I,5)
      DO 50 J = 1,NCSUB
      CALL FWDREC (*320,SCSFIL)
   50 CONTINUE
C
C     READ SIL,C FOR THE I-TH PSEUDOSTRUCTURE
C
      CALL READ (*320,*60,SCSFIL,Z(STS),LCORE,1,NSIL(I))
      GO TO 330
   60 LCORE = LCORE - NSIL(I)
      SNEXT(I) = SCORE + NSIL(I)
      SCORE = SCORE + NSIL(I)
      ST = SNEXT(I)
C
C     READ BGSS FOR THE I-TH PSEUDOSTRUCTURE
C
      CALL READ (*320,*70,SCSFIL,Z(ST),LCORE,1,NWD(I))
      GO TO 330
   70 SNEXT(I+1) = SNEXT(I) + NWD(I)
      SSIL(I+1)  = SNEXT(I) + NWD(I)
      SCORE = SCORE + NWD(I)
      CALL SKPFIL (SCSFIL,1)
      LCORE = LCORE - NWD(I)
      NI = NWD(I) + ST
C
C     WRITE THE IP NUMBER OVER THE CID IN THE BGSS
C     WILL BE USED AFTER SORTING
C
      DO 100 J = ST,NI,4
      JJ = (J-ST+4)/4
      IF (Z(J)+1) 80,90,80
   80 Z(J) = JJ
      GO TO 100
   90 Z(J) = -JJ
  100 CONTINUE
  110 CONTINUE
C
C     SORT EACH BGSS IN THE SPECIFIED COORDINATE DIRECTION
C
      DO 120 I = 1,NPSUB
      ST = SNEXT(I)
      CALL SORTF (0,0,4,IDIR,RZ(ST),NWD(I))
  120 CONTINUE
      I    = 1
  130 K    = 0
      KK   = 0
      BACK = .FALSE.
      SVKK = 0
      IC1  = SSIL(I)
      NIPI = NWD(I)/4
      J    = I + 1
      IF (RESTCT(I,J) .NE. 1) GO TO 280
  140 IC2  = SSIL(J)
      NIPJ = NWD(J)/4
  150 SPK  = SNEXT(I) + K + 1
      IF (Z(SPK-1) .LT. 0) GO TO 260
      A(1) = RZ(SPK  )
      A(2) = RZ(SPK+1)
      A(3) = RZ(SPK+2)
  160 SNK  = SNEXT(J) + KK + 1
      IF (Z(SNK-1) .LT. 0) GO TO 270
      B(1) = RZ(SNK  )
      B(2) = RZ(SNK+1)
      B(3) = RZ(SNK+2)
      IF (A(ISORT) .LT. B(ISORT)-TOLER) GO TO 250
      IF (B(ISORT) .LT. A(ISORT)-TOLER) GO TO 270
      IF (BACK) GO TO 170
      BACK = .TRUE.
      SVKK = KK
  170 CONTINUE
      ASEJ = A(ISORT)
      BSEJ = B(ISORT)
      XSEJ = ASEJ - BSEJ
      DO 180 MM = 1,3
      IF (MM .EQ. ISORT) GO TO 180
      ASEJ = A(MM)
      BSEJ = B(MM)
      XSEJ = A(MM) - B(MM)
      IF (ABS(XSEJ) .GT. TOLER) GO TO 270
  180 CONTINUE
C
C     GENERATE THE NEW CONNECTION ENTRY
C
      DO 190 KDH = 1,9
  190 CE(KDH) = 0
      CE(2)   = 2**(I-1) + 2**(J-1)
      CE(2+I) = IABS(Z(SPK-1))
      CE(2+J) = IABS(Z(SNK-1))
      M1 = IABS(Z(SPK-1))
      M2 = IABS(Z(SNK-1))
      CE(1) = ANDF(Z(IC1+2*M1-1),Z(IC2+2*M2-1))
      FOUND = .TRUE.
C
C     WRITE THE CONNECTION ENTRY ON SCCONN
C
      IF (CE(1) .NE. 0) CALL WRITE (SCCONN,CE,NOUT,1)
      IF (  .NOT.PRINT) GO TO 240
      IF (CE(1) .EQ. 0) GO TO 240
      IF (NLIN .LT. NLPP) GO TO 220
  200 NLIN = 0
      CALL PAGE
      WRITE  (OUTT,210) (NAME(KDH),KDH=1,NP2)
  210 FORMAT (/14X,22HCONNECTED   CONNECTION,29X,22HPSEUDOSTRUCTURE  NAM
     1ES, /17X,3HDOF,9X,4HCODE,3X,7(3X,2A4)//)
      NLIN = NLIN + 10
  220 CALL BITPAT (CE(1),IBITS)
      CALL BITPAT (CE(2),JBITS)
      NLIN = NLIN + 1
      IF (NLIN .GT. NLPP) GO TO 200
      WRITE (OUTT,230) IBITS(1),IBITS(2),JBITS(1),JBITS(2),
     1                 (CE(KDH+2),KDH=1,NPSUB)
  230 FORMAT (16X,A4,A2,5X,A4,A3,2X,7(3X,I8))
  240 CONTINUE
      GO TO 270
  250 KK   = SVKK
      BACK = .FALSE.
  260 K    = K + 4
      IF (K/4 .LT. NIPI) GO TO 150
      K    = 0
      KK   = 0
      SVKK = 0
      BACK = .FALSE.
      GO TO 280
  270 KK = KK + 4
      IF (KK/4 .LT. NIPJ) GO TO 160
      GO TO 250
  280 J = J + 1
      IF (J .LE. NPSUB) GO TO 140
      I = I + 1
      J = I
      IF (I .LT. NPSUB) GO TO 130
      WRITE  (OUTT,290)
  290 FORMAT (//40X,'NOTE - GRID POINTS IN PSEUDOSTRUCTURE INTERNAL',
     1                  ' GRID NUMBERS')
      CALL CLOSE (SCCONN,1)
      CALL CLOSE (SCSFIL,1)
      SCORE = ISAVS
      LCORE = ISAVL
      IF (FOUND .OR. TDAT(1).OR.TDAT(2)) RETURN
C
      WRITE  (OUTT,300) UFM
  300 FORMAT (A23,' 6531, NO CONNECTIONS HAVE BEEN FOUND DURING ',
     1       'AUTOMATIC CONNECTION PROCEDURE.')
      IDRY = -2
      RETURN
C
  310 IMSG = -1
      GO TO 350
  320 IMSG = -2
      GO TO 350
  330 IMSG = -8
  350 CALL MESAGE (IMSG,IFILE,AAA)
      RETURN
      END

      SUBROUTINE MINTRP(NI,XI,ND,XD,TYPE,SYMM1,SYMK1,DZ,INFILE,OUTFIL,
     *                  SCR,SCR1,G,NCORE,NOGO,IPRES)
C
      INTEGER SYSBUF,SYMK1,SYMM1,ISNG,SCR,SCR1,OUTFIL,SCRM
      INTEGER A,B,C,D,NAME(2),TYPE,BUFF,GPOINT
      LOGICAL NIMAG
      LOGICAL SPEC
      COMPLEX ALPHA
      DOUBLE PRECISION AR,AI
      DIMENSION XI(1),XD(2),G(1)
C
      COMMON /SYSTEM/ SYSBUF
      COMMON / PACKX/ ITI,ITO,II,NN,INCR
      COMMON /MPYADX/ A(7),B(7),C(7),D(7),NWORDS,NT,ISAB,ISC,IPRE,SCRM
      COMMON /SADDX / NMAT,LCORE,MA(7),ITA,ALPHA(2),DUM(48),MC(7)
      COMMON /UNPAKX/ IOUT,IN,NNN,INCRU
C
      EQUIVALENCE (ALPHA(1),AR),(ALPHA(2),AI)
C
      DATA NAME /4HMINT,4HRP  /
C
C-----------------------------------------------------------------------
C
      SPEC = .FALSE.
      NOGO = 0
C
C     DETERMINE TYPE OF CALL FOR G
C     NEGATIVE VALUE FOR KO CALL LSPLIN, POSITIVE CALL SSPLIN
C
C
C     CHECK CORE NEED AT LEAST 1 BUFFER + G
C
      ITY = IABS(TYPE)
      KD = 0
      IF(ITY.GT.3) KD=1
      NCOL = (1+KD)*ND
      IF(SYSBUF+NCOL*NI  .GT. NCORE) CALL MESAGE(-8,0,NAME)
C
C     PROTECT AGAINST BAD CALL
      IF(SYMK1.LT.0) SYMK1 = -1
      IF(SYMM1.LT.0) SYMM1 = -1
      IF(SYMK1.GT.0) SYMK1 = 1
      IF(SYMM1.GT.0) SYMM1 = 1
C     TRANSPOSE FLAG ON
      KT = 1
C     SPECIAL CASE
      IF(ND.EQ.1.AND.ITY.LT.4) GO TO 300
   10 IF(TYPE.LT.0) GO TO 100
      CALL SSPLIN(NI,XI,ND,XD,SYMM1,SYMK1,KD,KT,DZ,G,NCORE,ISNG)
      IF(ISNG.EQ.2) GO TO 999
      GO TO 200
  100 NII = 2*NI
      DO 110 I=1,NII,2
      XI(I) = 0.0
  110 CONTINUE
      NII = 2*ND
      DO 120 I = 1,NII,2
      XD(I) = 0.0
  120 CONTINUE
      CALL LSPLIN(NI,XI,ND,XD,SYMK1,KD,KT,DZ,-1.0,-1.0,1.0,G,NCORE,ISNG)
      IF(ISNG.EQ.2) GO TO 999
C     PUT OUT G
  200 BUFF = NCORE-SYSBUF+1
      NIMAG = .TRUE.
      IF(ITY.EQ.3.OR.ITY.EQ.6) NIMAG = .FALSE.
      IF(NIMAG) GO TO 210
      ITI = SCR
      SCR = OUTFIL
      OUTFIL = ITI
  210 ITO = 1
      JJ = NCOL
      ITI = 1
      NN = NI
      B(3) = NI
      B(5) = 1
      GPOINT = 1
  215 INCR = 1
      J = 1
      II = 1
      B(1) = SCR
      B(2) = 0
      B(4) = 2
      B(6) = 0
      B(7) = 0
      CALL GOPEN(SCR,G(BUFF),1)
      DO 220 I = J,JJ
      CALL PACK(G(GPOINT),SCR,B)
      GPOINT = GPOINT + NI
  220 CONTINUE
      CALL CLOSE(SCR,1)
      CALL WRTTRL(B)
      IF(SPEC) GO TO 1000
C
C     MULT INFILE BY G
C
      C(1) = 0
      A(1) = INFILE
      CALL RDTRL(A)
      D(1) = OUTFIL
      D(3) = A(3)
      D(4) = 2
      D(5) = A(5)
      IF(ITY.EQ.2.OR.ITY.EQ.5) D(5) = 1
      IF(D(5).EQ.1.AND.A(5).EQ.4) D(5) = 2
      NWORDS = NCORE
      NT = 0
      ISAB = 1
      IPRE = IPRES
      SCRM = SCR1
      CALL MPYAD(G,G,G)
      CALL WRTTRL(D)
      IF(NIMAG) GO TO 1000
C
C     IMAG PART ONLY WANTED
C
      NMAT = 1
      LCORE = NCORE
      MA(1) = OUTFIL
      CALL RDTRL(MA)
      ITA = 3
      ALPHA(1) = (0.0,-1.0)
      MC(1) = SCR
      MC(2) = MA(2)
      MC(3) = MA(3)
      MC(4) = 2
      MC(5) = MA(5)
      MC(6) = 0
      MC(7) = 0
      AI = -1.0D0
      IF(MA(5) .EQ.4) ITA = 4
      IF(ITA.EQ.4) AR = 0.0D0
      CALL SADD(G,G)
      CALL WRTTRL(MC)
      GO TO 1000
C
C     TEST FOR SPECIAL CASE
C
  300 NII = 2*NI
      K = 0
      DO 310 I = 1,NII,2
      K = K+1
      IF(XI(I).EQ.XD(1).AND.XI(I+1).EQ.XD(2)) GO TO 315
  310 CONTINUE
      GO TO 10
C
C     PACK OUT COLUMN OF INFILE
C
  315 A(1) = INFILE
      CALL RDTRL(A)
      BUFF = NCORE-SYSBUF +1
      CALL GOPEN(INFILE,G(BUFF),0)
      INCRU = 1
      IN = 1
      NNN = A(3)
      IOUT = A(5)
      IF(K.EQ.1) GO TO 330
      K = K-1
      CALL SKPREC(INFILE,K)
  330 CALL UNPACK(*998,INFILE,G)
      CALL CLOSE(INFILE,1)
      SPEC = .TRUE.
      SCR = OUTFIL
      ITI = A(5)
      NN = A(3)
      JJ = 1
      GPOINT = 1
      IF(ITY.EQ.3) GPOINT = 2
      ITO = 1
      IF(ITY .EQ.1) ITO = 3
      IF(A(5).EQ.4) ITO = ITO+1
      B(3) = A(3)
      B(5) = ITO
      GO TO 215
  998 CALL MESAGE(-7,0,NAME)
  999 NOGO = 1
 1000 RETURN
      END

      SUBROUTINE DADD5
C
C     DMAP DRIVER FOR SADD (MATRIX ADD) ROUTINE
C     THE DMAP CALL FOR THIS MODULE IS
C     ADD5 A,B,C,D,E / X / V,N,P1 / V,N,P2 / V,N,P3 / V,N,P4 / V,N,P5 $
C     THE PARAMETERS ARE ALL COMPLEX SINGLE-PRECISION.
C
      DIMENSION       INX(5),AMCBS(1),MC(5)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /SYSTEM/ IBUF,NOUT
      COMMON /SADDX / NOMAT,LCORE,MCBS(67)
      COMMON /ZZZZZZ/ CORE(1)
      COMMON /BLANK / ALPHA(10)
      EQUIVALENCE     (MCBS(1),AMCBS(1)),(MCBS(61),MC(1))
      DATA    INX   / 101,102,103,104,105 /, IOUT /201/
C
      LCORE = KORSZ(CORE)
C
      DO 10 I = 1,67
   10 MCBS(I) = 0
C
C     SETUP MATRIX CONTROL BLOCKS OF THE INPUT MATRICES
C
      I = 1
      K = 0
C
      MC(5) = 1
      DO 20 J = 1,5
      MCBS(I) = INX(J)
      CALL RDTRL (MCBS(I))
C
C     EXCLUDE NULL MATRICES FROM MCBS ARRAY
C
      IF (MCBS(I) .LE. 0) GO TO 20
C
C     MOVE MULTIPLIERS TO MCBS ARRAY
C
      MCBS (I+7) = 1
      AMCBS(I+8) = ALPHA(2*J-1)
      AMCBS(I+9) = ALPHA(2*J)
      IF (AMCBS(I+9) .NE. 0.0) MCBS(I+7) = 3
C
C     DETERMINE THE PRECISION AND TYPE OF THE OUTPUT MATRIX
C
      MC(5) = MAX0(MC(5),MCBS(I+4),MCBS(I+7))
      IF (MCBS(I+4) .EQ. 2) K = 1
      I = I + 12
   20 CONTINUE
C
      MC(1) = IOUT
      NOMAT = I/12
      IF (NOMAT .EQ. 0) RETURN
      IF (NOMAT .EQ. 1) GO TO 60
C
C     CHECK TO ENSURE THAT THE MATRICES BEING ADDED ARE OF THE SAME
C     ORDER
C
      I = 14
      DO 50 J = 2, NOMAT
      IF (MCBS(2).EQ.MCBS(I) .AND. MCBS(3).EQ.MCBS(I+1)) GO TO 40
      WRITE  (NOUT,30) UFM
   30 FORMAT (A23,' 4149, ATTEMPT TO ADD MATRICES OF UNEQUAL ORDER IN ',
     1       'MODULE ADD5.')
      CALL MESAGE (-61,0,0)
   40 I = I + 12
   50 CONTINUE
   60 MC(2) = MCBS(2)
      MC(3) = MCBS(3)
      MC(4) = MCBS(4)
      IF (MC(5).EQ.3 .AND. K.NE.0) MC(5) = 4
      MC(5) = MIN0(4,MC(5))
C
C     ADD MATRICES
C
      CALL SADD   (CORE,CORE)
      CALL WRTTRL (MC(1))
      RETURN
C
      END

      SUBROUTINE GFBS (X,DX)
C
C     GIVEN THE TRIANGULAR FACTORS FOR A GENERAL MATRIX, GFBS WILL
C     PERFORM THE FORWARD-BACKWARD SUBSTITUTION NECESSARY TO SOLVE
C     A SYSTEM OF EQUATIONS
C
C     DEFINITION OF INPUT PARAMETERS
C
C     FILEL    =  MATRIX CONTROL BLOCK FOR THE LOWER TRIANGLE L
C     FILEU    =  MATRIX CONTROL BLOCK FOR THE UPPER TRIANGLE U
C     FILEB    =  MATRIX CONTROL BLOCK FOR THE LOAD   VECTORS B
C     FILEX    =  MATRIX CONTROL BLOCK FOR THE SOLUTION VECTORS X
C     NX       =  NUMBER OF CELLS OF CORE AVAILABLE AT X
C     PREC     =  DESIRED PRECISION OF ARITHMETIC OPERATIONS
C                (1 = SINGLE PRECISION, 2 = DOUBLE PRECISION)
C     ISIGN    =  SIGN TO BE APPLIED TO THE LOAD VECTORS
C     X        =  BLOCK OF CORE AVAILABLE AS WORKING STORAGE
C     DX       =  SAME BLOCK AS X, BUT TYPED DOUBLE PRECISION
C
      INTEGER            FILEL     ,FILEU    ,FILEB    ,FILEX    ,
     1                   TYPEA     ,TYPE1    ,TYPE2    ,FORMB    ,
     2                   SYSBUF    ,PREC     ,EOL      ,TYPEAR   ,
     3                   TYPEX     ,TYPEL    ,RC       ,REW      ,
     4                   TYPEB     ,TRA1     ,TRA2     ,TRA3     ,
     5                   TRA4      ,TRA5     ,PARM(4)  ,CMPLX    ,
     6                   EOFNRW    ,COL      ,FSTCOL   ,CLSOP
      REAL               ZEROS(4)  ,
     1                   SUBNAM(2) ,BUF(2)   ,BEGN     ,END
      DOUBLE PRECISION   DX(1)     ,DA(2)    ,DTEMP
      DIMENSION          X(1)
      CHARACTER          UFM*23    ,UWM*25   ,UIM*29   ,SFM*25
      COMMON   /XMSSG /  UFM       ,UWM      ,UIM      ,SFM
      COMMON   /SYSTEM/  SYSBUF    ,NOUT
      COMMON   /TYPE  /  PRC(2)    ,NWDS(4)  ,RC(10)
C     COMMON   /DESCRP/  LENGTH    ,MAJOR
      COMMON   /NAMES /  RD        ,RDREW    ,WRT      ,WRTREW   ,
     1                   REW       ,NOREW    ,EOFNRW   ,RSP      ,
     2                   RDP       ,CSP      ,CDP      ,SQR      ,
     3                   RECT      ,DIAG     ,LOWTRI   ,UPRTRI   ,
     4                   SYM       ,ROW      ,IDENTY
      COMMON   /UNPAKX/  TYPEA     ,IXY      ,JXY      ,INCRY
      COMMON   /PACKX /  TYPE1     ,TYPE2    ,IY       ,JY       ,
     1                   INCRX
      COMMON   /ZNTPKX/  A(4)      ,II       ,EOL
      COMMON   /GFBSX /  FILEL(7)  ,FILEU(7) ,FILEB(7) ,FILEX(7) ,
     1                   NX        ,PREC     ,ISIGN
      EQUIVALENCE        (A(1),DA(1))        ,(FILEL(5),TYPEL)   ,
     1                   (FILEL(3),NROW)     ,(FILEX(5),TYPEX)   ,
     2                   (FILEB(4),FORMB)    ,(FILEB(5),TYPEB)
      DATA      PARM(3), PARM(4)  /4HGFBS,4H     /
      DATA      ZEROS /  0., 0., 0., 0. /
      DATA      SUBNAM/  4HGFBS,4H      /, BEGN/ 4HBEGN/, END/ 4HEND /
C
      BUF(1) = SUBNAM(1)
      BUF(2) = BEGN
      CALL CONMSG (BUF,2,0)
C
C     INITIALIZE
C
      IF (FORMB .EQ. IDENTY)TYPEB = 1
      TYPEAR = PREC
      IF (RC(TYPEL)+RC(TYPEB)-1 .GT. 1) TYPEAR = PREC + 2
      INCR  = NWDS(TYPEAR)*NROW
      TYPEA = TYPEAR*ISIGN
      TYPE1 = TYPEAR
      TYPE2 = TYPEX
      INCRX = 1
      INCRY = 1
      CMPLX = RC(TYPEAR)
      IOBUF = NX - SYSBUF
      ICOL  = IOBUF - 1
      COL   = 1
      CLSOP = EOFNRW
C
C     SET UP TRANSFER VECTORS FOR THE ARITHMETIC TYPES
C
      GO TO (10,20,30,40), TYPEAR
   10 ASSIGN 120 TO TRA1
      ASSIGN 240 TO TRA2
      ASSIGN 330 TO TRA3
      ASSIGN 430 TO TRA4
      ASSIGN 540 TO TRA5
      GO TO 50
   20 ASSIGN 130 TO TRA1
      ASSIGN 250 TO TRA2
      ASSIGN 340 TO TRA3
      ASSIGN 440 TO TRA4
      ASSIGN 550 TO TRA5
      GO TO 50
   30 ASSIGN 140 TO TRA1
      ASSIGN 260 TO TRA2
      ASSIGN 350 TO TRA3
      ASSIGN 450 TO TRA4
      ASSIGN 560 TO TRA5
      GO TO 50
   40 ASSIGN 150 TO TRA1
      ASSIGN 270 TO TRA2
      ASSIGN 360 TO TRA3
      ASSIGN 460 TO TRA4
      ASSIGN 570 TO TRA5
   50 CONTINUE
      NM = (IOBUF-1)/INCR
      IF (NM .LE. 0) GO TO 640
      NOLOAD = FILEB(2)
      IF (FORMB .EQ. IDENTY)NOLOAD = NROW
      IDENT  = 1
      LSTLOD = NOLOAD
C
C     WRITE OUTPUT HEADER RECORDS AND INITIALIZE MATRIX CONTROL BLOCKS
C
      CALL GOPEN (FILEX,X(IOBUF),1)
      CALL CLOSE (FILEX(1),NOREW)
      FILEX(2) = 0
      FILEX(6) = 0
      FILEX(7) = 0
      IF (FORMB .EQ. IDENTY) GO TO 100
C
C     OPEN THE LOAD FILE AND FILL CORE WITH LOAD VECTORS
C
      CALL GOPEN (FILEB,X(IOBUF),0)
   60 NN  = 0
      KHR = ICOL
      FSTCOL = COL
      L   = 1
      IXY = 1
      JXY = NROW
   70 IF (L+INCR .GE. KHR) GO TO 85
      CALL UNPACK (*80,FILEB,X(L))
      NN  = NN + 1
      X(KHR) = COL
      KHR = KHR - 1
      L   = L + INCR
   80 IF (COL .EQ. LSTLOD) GO TO 90
      COL = COL + 1
      GO TO 70
   85 COL  = COL - 1
   90 NCOL = KHR
      X(NCOL) = LSTLOD + 1
      LSTCOL  = COL
      IF (LSTCOL .EQ. LSTLOD) CLSOP = REW
      CALL CLOSE (FILEB,CLSOP)
      IF (NN .EQ. 0) GO TO 592
      GO TO 180
C
C     GENERATE COLUMNS OF THE IDENTITY MATRIX
C
  100 NN = MIN0(NM,NOLOAD)
      L  = 1
      DO 170 I = 1,NN
      J1 = L
      J2 = J1 + INCR - 1
      DO 110 K = J1,J2
  110 X(K) = 0.
      K = L + IDENT - 1
      GO TO TRA1, (120,130,140,150)
  120 X(K) = 1.
      GO TO 160
  130 K = (L-1)/2 + IDENT
      DX(K) = 1.D0
      GO TO 160
  140 KK = K + IDENT - 1
      X(KK) = 1.
      GO TO 160
  150 KK = (L-1)/2 + 2*IDENT - 1
      DX(KK) = 1.D0
  160 IDENT  = IDENT + 1
  170 L = L + INCR
      FSTCOL = COL
      COL    = IDENT - 1
      LSTCOL = COL
  180 IJK    = 0
C
C     OPEN FILE FOR THE LOWER TRIANGLE
C
      PARM(2) = FILEL(1)
      CALL GOPEN (FILEL,X(IOBUF),0)
C
C     BEGIN FORWARD PASS
C
      J = 1
  190 CALL INTPK (*380,FILEL(1),0,TYPEAR,0)
  200 IF (EOL) 650,210,650
  210 CALL ZNTPKI
      IF (J-II) 310,220,200
C
C     PERFORM THE REQUIRED ROW INTERCHANGE
C
  220 INTCHN = A(1)
      K = 0
      IF (PREC .EQ. 2) INTCHN = DA(1)
      IN1 = J*CMPLX
      IN2 = IN1 + INTCHN*CMPLX
  230 GO TO TRA2, (240,250,260,270)
  240 TEMP     = X(IN1)
      X(IN1)   = X(IN2)
      X(IN2)   = TEMP
      GO TO 280
  250 DTEMP    = DX(IN1)
      DX(IN1)  = DX(IN2)
      DX(IN2)  = DTEMP
      GO TO 280
  260 TEMP     = X(IN1)
      X(IN1)   = X(IN2)
      X(IN2)   = TEMP
      TEMP     = X(IN1-1)
      X(IN1-1) = X(IN2-1)
      X(IN2-1) = TEMP
      GO TO 280
  270 DTEMP    = DX(IN1)
      DX(IN1)  = DX(IN2)
      DX(IN2)  = DTEMP
      DTEMP    = DX(IN1-1)
      DX(IN1-1) = DX(IN2-1)
      DX(IN2-1) = DTEMP
  280 IN1 = IN1 + NROW*CMPLX
      IN2 = IN2 + NROW*CMPLX
      K   = K + 1
      IF (K-NN) 230,290,290
  290 IF (EOL) 380,300,380
  300 CALL ZNTPKI
  310 K = 0
      IN2 = J*CMPLX
      IN1 = II*CMPLX
  320 K = K + 1
      GO TO TRA3, (330,340,350,360)
  330 X(IN1) = X(IN1) - X(IN2)*A(1)
      GO TO 370
  340 DX(IN1) = DX(IN1) - DX(IN2)*DA(1)
      GO TO 370
  350 X(IN1-1) = X(IN1-1) - A(1)*X(IN2-1) + A(2)*X(IN2  )
      X(IN1  ) = X(IN1  ) - A(1)*X(IN2  ) - A(2)*X(IN2-1)
      GO TO 370
  360 DX(IN1-1) = DX(IN1-1) - DA(1)*DX(IN2-1) + DA(2)*DX(IN2  )
      DX(IN1  ) = DX(IN1  ) - DA(1)*DX(IN2  ) - DA(2)*DX(IN2-1)
  370 IN1 = IN1 + NROW *CMPLX
      IN2 = IN2 + NROW *CMPLX
      IF (K-NN) 320,290,290
  380 J = J + 1
      IF (J .LT. NROW) GO TO 190
      CALL CLOSE (FILEL(1),REW)
C
C     BEGIN BACKWARD PASS
C
      IOFF = FILEU(7)-1
      PARM(2) = FILEU(1)
      CALL GOPEN (FILEU,X(IOBUF),0)
      J = NROW
  390 CALL INTPK (*650,FILEU(1),0,TYPEAR,0)
      IF (EOL) 650,410,650
  410 CALL ZNTPKI
      I = NROW - II + 1
      IF (I .NE. J) GO TO 510
C
C     DIVIDE BY THE DIAGONAL
C
      IN1 = I*CMPLX
      K   = 0
  420 GO TO TRA4, (430,440,450,460)
  430 X(IN1) = X(IN1)/A(1)
      GO TO 470
  440 DX(IN1) = DX(IN1)/DA(1)
      GO TO 470
  450 TEMP   = (A(1)*X(IN1-1) + A(2)*X(IN1  ))/(A(1)*A(1) + A(2)*A(2))
      X(IN1) = (A(1)*X(IN1  ) - A(2)*X(IN1-1))/(A(1)*A(1) + A(2)*A(2))
      X(IN1-1) = TEMP
      GO TO 470
  460 DTEMP   = (DA(1)*DX(IN1-1) + DA(2)*DX(IN1  ))/(DA(1)**2 +DA(2)**2)
      DX(IN1) = (DA(1)*DX(IN1  ) - DA(2)*DX(IN1-1))/(DA(1)**2 +DA(2)**2)
      DX(IN1-1) = DTEMP
  470 K = K + 1
      IN1 = IN1 + NROW*CMPLX
      IF (K-NN) 420,490,490
C
C     SUBTRACT OFF REMAINING TERMS
C
  480 IF (I .GT. J) GO TO 410
  490 IF (EOL) 590,500,590
  500 CALL ZNTPKI
      I   = NROW - II + 1
  510 IN1 = I*CMPLX
      IN2 = J*CMPLX
      IF (I .LT. J) GO TO 520
      K   = IN1
      IN1 = IN2 - IOFF*CMPLX
      IN2 = K
  520 K   = 0
  530 GO TO TRA5, (540,550,560,570)
  540 X(IN1) = X(IN1) - A(1)*X(IN2)
      GO TO 580
  550 DX(IN1) = DX(IN1) - DX(IN2)*DA(1)
      GO TO 580
  560 X(IN1-1) = X(IN1-1) - A(1)*X(IN2-1) + A(2)*X(IN2  )
      X(IN1  ) = X(IN1  ) - A(1)*X(IN2  ) - A(2)*X(IN2-1)
      GO TO 580
  570 DX(IN1-1) = DX(IN1-1) - DA(1)*DX(IN2-1) + DA(2)*DX(IN2  )
      DX(IN1  ) = DX(IN1  ) - DA(1)*DX(IN2  ) - DA(2)*DX(IN2-1)
  580 IN1 = IN1 + NROW*CMPLX
      IN2 = IN2 + NROW*CMPLX
      K   = K + 1
      IF (K-NN) 530,480,480
  590 J = J - 1
      IF (J .GT. 0) GO TO 390
      CALL CLOSE (FILEU(1),REW)
C
C     OUTPUT LOAD VECTORS
C
  592 CONTINUE
      CALL GOPEN (FILEX,X(IOBUF),WRT)
      L  = 1
      IY = 1
      IF (FORMB .NE. IDENTY) NXTNZ = X(ICOL)
      KHR = ICOL
      DO 600 COL = FSTCOL,LSTCOL
      IF (FORMB .EQ. IDENTY) GO TO 595
C 593 CONTINUE
      IF (COL-NXTNZ) 594,595,901
  594 JY = 1
      CALL PACK (ZEROS,FILEX,FILEX)
      GO TO 600
  595 JY = NROW
      CALL PACK (X(L),FILEX,FILEX)
      L   = L + INCR
      KHR = KHR - 1
      IF (FORMB .NE. IDENTY) NXTNZ = X(KHR)
  600 CONTINUE
      IF (FORMB.NE.IDENTY .AND. KHR.NE.NCOL) GO TO 902
      IF (LSTCOL .EQ. LSTLOD) CLSOP = REW
      CALL CLOSE (FILEX,CLSOP)
      NOLOAD = NOLOAD - (LSTCOL-FSTCOL+1)
      IF (LSTCOL .EQ. LSTLOD) GO TO 670
      COL = LSTCOL + 1
      IF (FORMB .EQ. IDENTY) GO TO 100
      CALL GOPEN (FILEB,X(IOBUF),RD)
      GO TO 60
  640 PARM(1) = -8
      GO TO 660
  650 PARM(1) = -5
  660 CALL MESAGE (PARM(1),PARM(2),PARM(3))
  670 IF (FILEX(2) .NE. LSTLOD) GO TO 903
      BUF(1) = SUBNAM(1)
      BUF(2) = END
      CALL CONMSG (BUF,2,0)
      RETURN
C
C     LOGIC ERRORS LAND HERE
C
  901 KERR = 593
      GO TO 997
  902 KERR = 600
      GO TO 997
  903 KERR = 670
      GO TO 997
  997 WRITE  (NOUT,998) SFM,KERR
  998 FORMAT (A25,I4,' - LOGIC ERROR IN GFBS')
      CALL MESAGE (-61,0,0)
      RETURN
      END

      SUBROUTINE QPARMD
C
C     MODULE PARAMD PERFORMS THE FOLLOW OP ON PARAMETERS IN DOUBLE
C     PRECISION
C     (REFERENCE - MODULE PARAMR AND SUBROUTINE QPARMR)
C
C     DMAP
C     PARAMD  / /C,N,OP/ V,N,OUTD/V,N,IND1/V,N,IND2/
C                        V,N,OUTC/V,N,INC1/V,N,INC2/V,N,FLAG $
C
C         OP        COMPUTE
C         --        -------------------------------------------
C      BY DEFAULT   FLAG = 0
C      1  ADD       OUTD = IND1 + IND2
C      2  SUB       OUTD = IND1 - IND2
C      3  MPY       OUTD = IND1 * IND2
C      4  DIV       OUTD = IND1 / IND2 (IF IND2 = 0, FLAG IS SET TO +1)
C      5  NOP       RETURN
C      6  SQRT      OUTD = DSQRT(IND1)
C      7  SIN       OUTD = DSIN(IND1) WHERE IND1 IS IN RADIANS
C      8  COS       OUTD = DCOS(IND1) WHERE IND1 IS IN RADIANS
C      9  ABS       OUTD = DABS(IND1)
C     10  EXP       OUTD = DEXP(IND1)
C     11  TAN       OUTD = DTAN(IND1) WHERE IND1 IS IN RADIANS
C     12  ADDC      OUTC = INC1 + INC2
C     13  SUBC      OUTC = INC1 - INC2
C     14  MPYC      OUTC = INC1 * INC2
C     15  DIVC      OUTC = INC1 / INC2 (IF INC2 = 0, FLAG IS SET TO +1)
C     16  COMPLEX   OUTC = (IND1,IND2)
C     17  CSQRT     OUTC = DCSQRT(INC1)
C     18  NORM      OUTD = DSQRT(OUTC(1)**2 + OUTC(2)**2)
C     19  REAL      IND1 = OUTC(1),  IND2 = OUTC(2)
C     20  POWER     OUTD = IND1**IND2
C     21  CONJ      OUTC = DCONJG(INC1)
C     22  EQ        FLAG =-1 IF IND1 COMPARES WITH IND2
C     23  GT        FLAG =-1 IF IND1 IS GT IND2
C     24  GE        FLAG =-1 IF IND1 IS GE IND2
C     25  LT        FLAG =-1 IF IND1 IS LT IND2
C     26  LE        FLAG =-1 IF IND1 IS LE IND2
C     27  NE        FLAG =-1 IF IND1 IS NE IND2
C     28  LOG       OUTD = DLOG10(IND1)
C     29  LN        OUTD = DLOG(IND1)
C     30  FIX       FLAG = OUTD
C     31  FLOAT     OUTD = FLOAT(FLAG)
C
C     NEW OP CODE ADDED IN THIS NEW VERSION, 12/1988 -
C
C     32  ERR       IF FLAG IS 0, SYSTEM NOGO FLAG IS SET TO ZERO
C                   IF FLAG IS NON-ZERO, JOB TERMINATED IF ANY PREVIOUS
C                      PARAMD (OR PARAMR) CONTAINS NON-FATAL ERROR(S)
C
      LOGICAL          PRT
      INTEGER          OP,OPCODE(50),FLAG,IVPS(1),NAME(2),IL(8),ILX(8),
     1                 NAM(2),BLNK
      REAL             TEMP(2)
      DOUBLE PRECISION OUTD,IND1,IND2,OUTC,INC1,INC2,DENOM,TEMPD
      CHARACTER        UFM*23,UWM*25,UIM*29
      COMMON /XMSSG /  UFM,UWM,UIM
      COMMON /BLANK /  OP(2),OUTD,IND1,IND2,OUTC(2),INC1(2),INC2(2),FLAG
      COMMON /XVPS  /  VPS(1)
      COMMON /ILXXD /  IL1,IL2,IL3,IL4,IL5,IL6,IL7,IL8
      COMMON /SYSTEM/  IBUF,NOUT,NOGO,DUMMY(33),KSYS37
      EQUIVALENCE      (VPS(1),IVPS(1)), (TEMPD,TEMP(1)), (IL,IL1)
      DATA NAME     /  4HQPAR,4HMD  /      ,IFIRST / 15  /
      DATA OPCODE   /  4HADD ,4HSUB ,4HMPY ,4HDIV ,4HNOP ,
     1                 4HSQRT,4HSIN ,4HCOS ,4HABS ,4HEXP ,
     2                 4HTAN ,4HADDC,4HSUBC,4HMPYC,4HDIVC,
     3                 4HCOMP,4HCSQR,4HNORM,4HREAL,4HPOWE,
     4                 4HCONJ,4HEQ  ,4HGT  ,4HGE  ,4HLT  ,
     5                 4HLE  ,4HNE  ,4HLOG ,4HLN  ,4HFIX ,
     6                 4HFLOA,4HERR ,4H    ,4H    ,4H    ,
     7                 4H    ,4H    ,4H    ,4H    ,4H    ,
     8                 4H    ,4H    ,4H    ,4H    ,4H    ,
     9                 4H    ,4H    ,4H    ,4H    ,4H    /
      DATA ILX      /  4H1ST ,4H2ND ,4H3RD ,4H4TH ,4H5TH ,
     1                 4H6TH ,4H7TH ,4H8TH               /
      DATA PARM,NAM /  4HPARM,4H/PAR,3HAMD/,BLNK  /4H    /
C
C     SUPPRESS ALL PARAMETER CHECK MESSAGES IF DIAG 37 IS ON
C
      CALL SSWTCH (37,I)
      PRT = I .EQ. 0
      IF (PRT) NAM(1) = BLNK
      IF (PRT) NAM(2) = BLNK
C
C     COMPUTE VPS INDEXES AND PARAMETER NAMES
C
      DO 2 I = 2,8
      CALL FNDPAR (-I,IL(I))
    2 CONTINUE
      IF (.NOT.PRT) GO TO 4
      CALL PAGE2 (IFIRST)
      IFIRST = 6
      WRITE  (NOUT,3) UIM,OP
    3 FORMAT (A29,' FROM PARAMD MODULE - OP CODE = ',2A4, /5X,
     1        '(ALL PARAMD MESSAGES CAN BE SUPPRESSED BY DIAG 37)')
C
C     BRANCH ON OPERATION CODE
C
    4 IFLAG = FLAG
      FLAG  = 0
      IERR  = 0
C
      DO 5 IOP = 1,32
      IF (OP(1) .EQ. OPCODE(IOP)) GO TO
     1   (  10,  20,  30,  40,  50,  60,  70,  80,  90, 100,
     2     110, 120, 130, 140, 150, 160, 170, 180, 190, 200,
     3     210, 220, 230, 240, 250, 260, 270, 280, 290, 300,
     4     310, 320    ), IOP
    5 CONTINUE
      WRITE  (NOUT,6) OP(1),NAM
    6 FORMAT (22X,'UNRECOGNIZABLE OP CODE = ',A4,' (INPUT ERROR)  ',2A4)
      CALL MESAGE (-7,0,NAME)
C
C *******
C     D.P. REAL NUMBER FUNCTIONS
C *******
C
C     ADD
C
   10 OUTD = IND1 + IND2
      GO TO 600
C
C     SUBTRACT
C
   20 OUTD = IND1 - IND2
      GO TO 600
C
C     MULTIPLY
C
   30 OUTD = IND1*IND2
      GO TO 600
C
C     DIVIDE
C
   40 OUTD = 0.D+0
      IF (IND2 .EQ. 0.D+0) GO TO 45
      OUTD = IND1/IND2
      GO TO 600
   45 WRITE  (NOUT,47) NAM
   47 FORMAT (5X,'ERROR - DIVIDED BY ZERO  ',2A4)
      IERR = 1
      FLAG =+1
      IF (IL8 .LE. 0) GO TO 730
      IVPS(IL8) = FLAG
      I = IL8 - 3
      IF (PRT) WRITE (NOUT,48) IVPS(I),IVPS(I+1),FLAG
   48 FORMAT (22X,2A4,2H =,I10,'   (OUTPUT)')
      GO TO 730
C
C     NOP
C
   50 RETURN
C
C     SQUARE ROOT
C
   60 IF (IND1 .LT. 0.D+0) GO TO 65
      OUTD = DSQRT(IND1)
      GO TO 650
   65 WRITE  (NOUT,67) NAM
   67 FORMAT (5X,'ERROR - OPERATING ON A NEGATIVE NUMBER  ',2A4)
      OUTD = 0.D+0
      IERR = 1
      GO TO 650
C
C     SINE
C
   70 OUTD = DSIN(IND1)
      GO TO 650
C
C     COSINE
C
   80 OUTD = DCOS(IND1)
      GO TO 650
C
C     ABSOLUTE VALUE
C
   90 OUTD = DABS(IND1)
      GO TO 650
C
C     EXPONENTIAL
C
  100 OUTD = DEXP(IND1)
      GO TO 650
C
C     TANGENT
C
  110 OUTD = DTAN(IND1)
      GO TO 650
C
C     NORM
C
  180 OUTD = DSQRT(OUTC(1)**2 + OUTC(2)**2)
      GO TO 690
C
C     POWER
C
  200 OUTD  = IND1**IND2
      GO TO 600
C
C     LOG
C
  280 IF (IND1 .LT. 0.D+0) GO TO 65
      OUTD = DLOG10(IND1)
      GO TO 650
C
C     NATURAL LOG
C
  290 IF (IND1 .LT. 0.D+0) GO TO 65
      OUTD = DLOG(IND1)
      GO TO 650
C
C     FLOAT
C
  310 OUTD = IFLAG
      GO TO 670
C
C     ERR
C
  320 IF (IFLAG.NE.0 .AND. KSYS37.NE.0) GO TO 970
      KSYS37 = 0
      NOGO   = 0
      IF (PRT) WRITE (NOUT,325)
  325 FORMAT (5X,'SYSTEM NOGO FLAG IS RESET TO INTEGER ZERO',/)
      GO TO 990
C
C *******
C     COMPLEX FUNCTIONS
C *******
C
C     ADD COMPLEX
C
  120 OUTC(1) = INC1(1) + INC2(1)
      OUTC(2) = INC1(2) + INC2(2)
      GO TO 730
C
C     SUBTRACT COMPLEX
C
  130 OUTC(1) = INC1(1) - INC2(1)
      OUTC(2) = INC1(2) - INC2(2)
      GO TO 730
C
C     MULTIPLY COMPLEX
C
  140 OUTC(1) = INC1(1)*INC2(1) - INC1(2)*INC2(2)
      OUTC(2) = INC1(1)*INC2(2) + INC1(2)*INC2(1)
      GO TO 730
C
C     DIVIDE COMPLEX
C
  150 DENOM = INC2(1)**2 + INC2(2)**2
      IF (DENOM .EQ. 0.D+0) GO TO 155
      OUTC(1) = (INC1(1)*INC2(1) + INC1(2)*INC2(2))/DENOM
      OUTC(2) = (INC1(2)*INC2(1) - INC1(1)*INC2(2))/DENOM
      GO TO 730
  155 OUTC(1) = 0.D+0
      OUTC(2) = 0.D+0
      GO TO 45
C
C     COMPLEX
C
  160 OUTC(1) = IND1
      OUTC(2) = IND2
      GO TO 710
C
C     COMPLEX SQUARE ROOT
C
  170 OUTC(1) = (INC1(1)**2 + INC1(2)**2)**0.25D0
     1          *DCOS(0.5D0*DATAN2(INC1(2),INC1(1)))
      OUTC(2) = (INC1(1)**2 + INC1(2)**2)**0.25D0
     1          *DSIN(0.5D0*DATAN2(INC1(2),INC1(1)))
      GO TO 760
C
C     CONJUGATE
C
  210 OUTC(1) = INC1(1)
      OUTC(2) =-INC1(2)
      GO TO 760
C
C     REAL
C
  190 IND1 = OUTC(1)
      IND2 = OUTC(2)
      GO TO 770
C
C     EQUAL
C
  220 IF (IND1 .EQ. IND2) FLAG = -1
      GO TO 660
C
C     GREATER THAN
C
  230 IF (IND1 .GT. IND2) FLAG = -1
      GO TO 660
C
C     GREATER THAN OR EQUAL
C
  240 IF (IND1 .GE. IND2) FLAG = -1
      GO TO 660
C
C     LESS THAN
C
  250 IF (IND1 .LT. IND2) FLAG = -1
      GO TO 660
C
C     LESS THAN OR EQUAL
C
  260 IF (IND1 .LE. IND2) FLAG = -1
      GO TO 660
C
C     NOT EQUAL
C
  270 IF (IND1 .NE. IND2) FLAG = -1
      GO TO 660
C
C     FIX
C
  300 FLAG = OUTD
      GO TO 720
C
C ---------------------------------------------------
C
C     INPUT PARAMETER ECHO
C
  600 ASSIGN 620 TO IRTN3
      ASSIGN 800 TO IRTN4
  610 IF (.NOT.PRT) GO TO 615
      I = IL3 - 3
      IF (IL3 .LE. 0) WRITE (NOUT,640) ILX(3),PARM,IND1
      IF (IL3 .GT. 0) WRITE (NOUT,640) IVPS(I),IVPS(I+1),IND1
  615 IF (IL3 .EQ. 0) IERR = 1
      GO TO IRTN3, (620,800)
  620 IF (.NOT.PRT) GO TO 645
      J = IL4 - 3
      IF (IL4 .LE. 0) WRITE (NOUT,640) ILX(4),PARM,IND2
      IF (IL4 .GT. 0) WRITE (NOUT,640) IVPS(J),IVPS(J+1),IND2
  640 FORMAT (22X,2A4,3H = ,D15.8,'  (INPUT)')
  645 IF (IL4 .EQ. 0) IERR = 1
      GO TO IRTN4, (800,880,910)
C
  650 ASSIGN 800 TO IRTN3
      GO TO 610
C
  660 ASSIGN 620 TO IRTN3
      ASSIGN 910 TO IRTN4
      GO TO 610
C
  670 IF (.NOT.PRT) GO TO 685
      I = IL8 - 3
      IF (IL8 .LE. 0) WRITE (NOUT,680) ILX(8),PARM,IFLAG
      IF (IL8 .GT. 0) WRITE (NOUT,680) IVPS(I),IVPS(I+1),IFLAG
  680 FORMAT (22X,2A4,2H =,I10,'   (INPUT)')
  685 IF (IL8 .EQ. 0) IERR = 1
      GO TO 800
C
  690 IF (.NOT.PRT) GO TO 705
      I = IL5 - 3
      IF (IL5 .LE. 0) WRITE (NOUT,700) ILX(5),PARM,OUTC
      IF (IL5 .GT. 0) WRITE (NOUT,700) IVPS(I),IVPS(I+1),OUTC
  700 FORMAT (22X,2A4,4H = (,D15.8,1H,,D15.8,')   (INPUT)')
  705 IF (IL5 .EQ. 0) IERR = 1
      GO TO 800
C
  710 ASSIGN 620 TO IRTN3
      ASSIGN 880 TO IRTN4
      GO TO 610
C
  720 IF (.NOT.PRT) GO TO 725
      I = IL2 - 3
      IF (IL2 .LE. 0) WRITE (NOUT,640) ILX(2),PARM,OUTD
      IF (IL2 .GT. 2) WRITE (NOUT,640) IVPS(I),IVPS(I+1),OUTD
  725 IF (IL2 .EQ. 0) IERR = 1
      GO TO 910
C
  730 ASSIGN 750 TO IRTN6
  740 IF (.NOT.PRT) GO TO 745
      I = IL6 - 3
      IF (IL6 .LE. 0) WRITE (NOUT,700) ILX(6),PARM,INC1
      IF (IL6 .GT. 0) WRITE (NOUT,700) IVPS(I),IVPS(I+1),INC1
      IF (IL6 .EQ. 0) IERR = 1
  745 GO TO IRTN6, (750,880)
  750 IF (.NOT.PRT) GO TO 755
      J = IL7 - 3
      IF (IL7 .LE. 0) WRITE (NOUT,700) ILX(7),PARM,INC2
      IF (IL7 .GT. 0) WRITE (NOUT,700) IVPS(J),IVPS(J+1),INC2
  755 IF (IL7 .EQ. 0) IERR = 1
      GO TO 880
C
  760 ASSIGN 880 TO IRTN6
      GO TO 740
C
  770 IF (.NOT.PRT) GO TO 775
      I = IL5 - 3
      IF (IL5 .LE. 0) WRITE (NOUT,700) ILX(5),PARM,OUTC
      IF (IL5 .GT. 0) WRITE (NOUT,700) IVPS(I),IVPS(I+1),OUTC
  775 IF (IL5 .EQ. 0) IERR = 1
      GO TO 840
C
C     OUTPUT PARAMETER CHECK
C
C     SECOND PARAMETER - OUTD
C
  800 IF (IL2  .GT.  0) GO TO 820
      WRITE  (NOUT,810) ILX(2),NAM
  810 FORMAT (22X,A4,'PARAMETER IS MISSING    (OUTPUT ERROR)  ',2A4)
      IERR = 1
      GO TO 950
  820 IF (IERR .EQ. 0) GO TO 825
      TEMP(1) = VPS(IL2  )
      TEMP(2) = VPS(IL2+1)
      OUTD  = TEMPD
  825 TEMPD = OUTD
      VPS(IL2  ) = TEMP(1)
      VPS(IL2+1) = TEMP(2)
      I = IL2 - 3
      IF (PRT) WRITE (NOUT,830) IVPS(I),IVPS(I+1),OUTD
  830 FORMAT (22X,2A4,3H = ,D15.8,'  (OUTPUT)')
      GO TO 950
C
C     THIRD AND FOURTH PARAMETERS - IND1, IND2
C
  840 IF (IL3 .GT.  0) GO TO 850
      WRITE (NOUT,810) ILX(3),NAM
      IERR = 1
      GO TO 860
  850 IF (IERR .EQ. 0) GO TO 855
      TEMP(1) = VPS(IL3  )
      TEMP(2) = VPS(IL3+1)
      IND1  = TEMPD
  855 TEMPD = IND1
      VPS(IL3  ) = TEMP(1)
      VPS(IL3+1) = TEMP(2)
      I = IL3 - 3
      IF (PRT) WRITE (NOUT,830) IVPS(I),IVPS(I+1),IND1
  860 IF (IL4 .GT.  0) GO TO 870
      WRITE (NOUT,810) ILX(4),NAM
      IERR = 1
      GO TO 950
  870 IF (IERR .EQ. 0) GO TO 875
      TEMP(1) = VPS(IL4  )
      TEMP(2) = VPS(IL4+1)
      IND2  = TEMPD
  875 TEMPD = IND2
      VPS(IL4  ) = TEMP(1)
      VPS(IL4+1) = TEMP(2)
      J = IL4 - 3
      IF (PRT) WRITE (NOUT,830) IVPS(J),IVPS(J+1),IND2
      GO TO 950
C
C     FIFTH PARAMETER - OUTC
C
  880 IF (IL5 .GT.  0) GO TO 890
      WRITE (NOUT,810) ILX(5),NAM
      IERR = 1
      GO TO 950
  890 IF (IERR .EQ. 0) GO TO 895
      TEMP(1) = VPS(IL5  )
      TEMP(2) = VPS(IL5+1)
      OUTC(1) = TEMPD
      TEMP(1) = VPS(IL5+2)
      TEMP(2) = VPS(IL5+3)
      OUTC(2) = TEMPD
  895 TEMPD = OUTC(1)
      VPS(IL5  ) = TEMP(1)
      VPS(IL5+1) = TEMP(2)
      TEMPD = OUTC(2)
      VPS(IL5+2) = TEMP(1)
      VPS(IL5+3) = TEMP(2)
      I = IL5 - 3
      IF (PRT) WRITE (NOUT,900) IVPS(I),IVPS(I+1),OUTC
  900 FORMAT (22X,2A4,4H = (,D15.8,1H,,D15.8,')   (OUTPUT)')
      GO TO 950
C
C     EIGHTH PARAMETER - FLAG
C
  910 IF (IL8 .GT.  0) GO TO 920
      WRITE (NOUT,810) ILX(8),NAM
      IERR = 1
      GO TO 950
  920 IF (IERR .EQ. 0) IVPS(IL8) = FLAG
      I = IL8 - 3
      IF (PRT) WRITE (NOUT,930) IVPS(I),IVPS(I+1),IVPS(IL8)
  930 FORMAT (22X,2A4,2H =,I12,6X,'(OUTPUT)')
C
  950 IF (IERR .EQ.  0) GO TO 990
      WRITE  (NOUT,960) UWM,NAM
  960 FORMAT (A25,' - I/O ERROR, OUTPUT NOT SAVED. OUTPUT DEFAULT ',
     1       'VALUE REMAINS ',2A4,/)
      GO TO 990
  970 WRITE  (NOUT,980) NAM
  980 FORMAT (5X,'JOB TERMINTATED DUE TO PREVIOUS ERROR(S)  ',2A4,/)
      CALL PEXIT
  990 IF (KSYS37 .EQ. 0) KSYS37 = IERR
      RETURN
C
      END

      FUNCTION MASKN (L2,L1)
C
C     TO BUILD AN INTEGER MASK FOR BIT MANIPULATION
C                                                                   0 OR
C     64  60        48     36   32         <--- BIT COUNT ---          1
C      +---+---------+------+----+-------------------------------------+
C       ...   ....     ....   ...  ....00000011111111111111111111000...
C      +---+---------+------+----+-------------------------------------+
C                                            /                  /
C                                            L2                L1
C
C      BIT COUNTS FROM RIHGT (L1) TO LEFT (L2).  L1=0 IS SAME AS L1=1
C
C      E.G.      L2    L1      MASK PATTERN, WITH LEADING ZERO BITS
C               ----  ----  ------------------------------------------
C                12     0    A 12 BIT MASK, RIGHT ADJUSTED
C                24     8    A 24 BIT MASK, RIGHT ADJUSTED, WITH 8
C                            TRAILING ZERO BITS.
C
C      THIS ROUTINE IS SUITABLE FOR MACHINE WORD OF ANY BIT SIZE
C      BIT PATTERN CAN ALSO INCLUDE SIGN BIT.
C      SYSTEM MASK ROUINTE, IF IT EXISTS, IS NOT USED.
C
C      WRITTEN BY G.CHAN/UNISYS  10/1992
C
       EXTERNAL        RSHIFT,LSHIFT
       INTEGER         RSHIFT
C
       IF (L2 .LT. L1) CALL ERRTRC ('MASKN   ',L2-L1)
       MASKN = LSHIFT(1,L2) - 1
       IF (L1 .GT. 1) MASKN = LSHIFT(RSHIFT(MASKN,L1-1),L1-1)
       RETURN
       END

      SUBROUTINE TTRAPR (TI,PG)
C
C     THIS ROUTINE COMPUTES THE THERMAL LOAD FOR THE TRAPEZOIDAL
C     CROSS SECTION RING
C
C     ECPT FOR THE TRAPEZOIDAL RING
C                                                          TYPE
C     ECPT( 1) ELEMENT IDENTIFICATION                        I
C     ECPT( 2) SCALAR INDEX NO. FOR GRID POINT A             I
C     ECPT( 3) SCALAR INDEX NO. FOR GRID POINT B             I
C     ECPT( 4) SCALAR INDEX NO. FOR GRID POINT C             I
C     ECPT( 5) SCALAR INDEX NO. FOR GRID POINT D             I
C     ECPT( 6) MATERIAL ORIENTATION ANGLE(DEGREES)           R
C     ECPT( 7) MATERIAL IDENTIFICATION                       I
C     ECPT( 8) COOR. SYS. ID. FOR GRID POINT A               I
C     ECPT( 9) X-COOR. OF GRID POINT A (IN BASIC COOR.)      R
C     ECPT(10) Y-COOR. OF GRID POINT A (IN BASIC COOR.)      R
C     ECPT(11) Z-COOR. OF GRID POINT A (IN BASIC COOR.)      R
C     ECPT(12) COOR. SYS. ID. FOR GRID POINT B               I
C     ECPT(13) X-COOR. OF GRID POINT B (IN BASIC COOR.)      R
C     ECPT(14) Y-COOR. OF GRID POINT B (IN BASIC COOR.)      R
C     ECPT(15) Z-COOR. OF GRID POINT B (IN BASIC COOR.)      R
C     ECPT(16) COOR. SYS. ID. FOR GRID POINT C               I
C     ECPT(17) X-COOR. OF GRID POINT C (IN BASIC COOR.)      R
C     ECPT(18) Y-COOR. OF GRID POINT C (IN BASIC COOR.)      R
C     ECPT(19) Z-COOR. OF GRID POINT C (IN BASIC COOR.)      R
C     ECPT(20) COOR. SYS. ID. FOR GRID POINT D               I
C     ECPT(21) X-COOR. OF GRID POINT D (IN BASIC COOR.)      R
C     ECPT(22) Y-COOR. OF GRID POINT D (IN BASIC COOR.)      R
C     ECPT(23) Z-COOR. OF GRID POINT D (IN BASIC COOR.)      R
C     ECPT(24) EL. TEMPERATURE FOR MATERIAL PROPERTIES       R
C
C
      DIMENSION       TI(4),PG(1),IECPT(24),D(22),GAMBQ(64),R(4),Z(4),
     1                TEO(16),EE(16),DELINT(12),GAMQS(96),Q(32),
     2                GAMBL(144),ALFB(4),IGP(4),ICS(4),SP(24),HPRIM(16),
     3                TL(12),TS(4),JRZ(2)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /CONDAS/ CONSTS(5)
      COMMON /TRIMEX/ ECPT(24)
      COMMON /MATIN / MATIDC,MATFLG,ELTEMP,STRESS,SINTH,COSTH
      COMMON /MATOUT/ E(3),ANU(3),RHO,G(3),ALF(3),TZERO
      COMMON /SYSTEM/ IBUF,IOUT
      EQUIVALENCE     (CONSTS(2),TWOPI),(CONSTS(4),DEGRA),
     1                (IECPT(1),ECPT(1)),
     2                (R(1),R1),(R(2),R2),(R(3),R3),(R(4),R4),
     3                (Z(1),Z1),(Z(2),Z2),(Z(3),Z3),(Z(4),Z4),
     4                (GAMBL(1),EE(1)),(GAMBL(17),TEO(1)),
     5                (GAMBL(33),ALFB(1)),(GAMBL(37),TS(1)),
     6                (GAMBL(41),DELINT(1)),(GAMBL(1),GAMBQ(1)),
     7                (GAMBL(65),Q(1)),(GAMBL(97),HPRIM(1)),
     8                (GAMBL(113),SP(1)),(GAMBL(1),GAMQS(1))
C
C     STORE ECPT PARAMETERS IN LOCAL VARIABLES
C
      IDEL   = IECPT( 1)
      IGP(1) = IECPT( 2)
      IGP(2) = IECPT( 3)
      IGP(3) = IECPT( 4)
      IGP(4) = IECPT( 5)
      MATID  = IECPT( 7)
      ICS(1) = IECPT( 8)
      ICS(2) = IECPT(12)
      ICS(3) = IECPT(16)
      ICS(4) = IECPT(20)
      R(1)   = ECPT ( 9)
      D(1)   = ECPT (10)
      Z(1)   = ECPT (11)
      R(2)   = ECPT (13)
      D(2)   = ECPT (14)
      Z(2)   = ECPT (15)
      R(3)   = ECPT (17)
      D(3)   = ECPT (18)
      Z(3)   = ECPT (19)
      R(4)   = ECPT (21)
      D(4)   = ECPT (22)
      Z(4)   = ECPT (23)
      TEMPE  = ECPT (24)
      DGAMA  = ECPT ( 6)
C
C     TEST THE VALIDITY OF THE GRID POINT COORDINATES
C
      DO 200 I = 1,4
      IF (R(I) .LT. 0.0) CALL MESAGE (-30,37,IDEL)
      IF (D(I) .NE. 0.0) CALL MESAGE (-30,37,IDEL)
  200 CONTINUE
C
C     COMPUTE THE ELEMENT COORDINATES
C
      ZMIN = AMIN1(Z1,Z2,Z3,Z4)
      Z1 = Z1 - ZMIN
      Z2 = Z2 - ZMIN
      Z3 = Z3 - ZMIN
      Z4 = Z4 - ZMIN
      RMIN = AMIN1(R1,R2,R3,R4)
      RMAX = AMAX1(R1,R2,R3,R4)
      IF (RMIN .EQ. 0.) GO TO 206
      IF (RMAX/RMIN .LE. 10.) GO TO 206
C
C     RATIO OF RADII IS TOO LARGE FOR GAUSS QUADRATURE FOR IP=-1
C
      WRITE  (IOUT,205) UFM,IDEL
  205 FORMAT (A23,', TRAPRG ELEMENT',I9,' HAS A MAXIMUM TO MINIMUM ',
     1       'RADIUS RATIO EXCEEDING 10.'/5X,'ACCURACY OF NUMERICAL ',
     2       'INTEGRATION WOULD BE IN DOUBT.')
      CALL MESAGE (-61,0,0)
  206 CONTINUE
      ICORE = 0
      J = 1
      DO 210 I = 1,4
      IF (R(I) .NE. 0.) GO TO 210
      ICORE  = ICORE + 1
      JRZ(J) = I
      J = 2
  210 CONTINUE
      IF (ICORE.NE.0 .AND. ICORE.NE.2) CALL MESAGE (-61,0,0)
C
C     CALCULATE THE INTEGRAL VALUES IN ARRAY DELINT WHERE THE ORDER IS
C     INDICATED BY THE FOLLOWING TABLE
C
C       DELINT( 1) - ( 0,0)
C       DELINT( 2) - ( 0,1)
C       DELINT( 3) - ( 0,2)
C       DELINT( 4) - ( 1,0)
C       DELINT( 5) - ( 1,1)
C       DELINT( 6) - ( 1,2)
C       DELINT( 7) - ( 2,0)
C       DELINT( 8) - ( 2,1)
C       DELINT( 9) - ( 2,2)
C       DELINT(10) - ( 3,0)
C       DELINT(11) - ( 3,1)
C
      I1 = 0
      DO 400 I = 1,4
      IP = I - 1
      DO 350 J = 1,3
      IQ = J - 1
      I1 = I1 + 1
      IF (I1 .EQ. 12) GO TO 350
      DELINT(I1) = RZINTS(IP,IQ,R,Z,4)
  350 CONTINUE
  400 CONTINUE
C
C     LOCATE THE MATERIAL PROPERTIES IN THE MAT1 OR MAT3 TABLE
C
      MATIDC = MATID
      MATFLG = 7
      ELTEMP = TEMPE
      CALL  MAT (IDEL)
C
C     SET MATERIAL PROPERTIES IN LOCAL VARIABLES
C
      ER  = E(1)
      ET  = E(2)
      EZ  = E(3)
      VRT = ANU(1)
      VTZ = ANU(2)
      VZR = ANU(3)
      GRZ = G(3)
      TZ  = TZERO
      VTR = VRT*ET/ER
      VZT = VTZ*EZ/ET
      VRZ = VZR*ER/EZ
      DEL = 1.0 - VRT*VTR - VTZ*VZT - VZR*VRZ - VRT*VTZ*VZR
     1          - VRZ*VTR*VZT
C
C     GENERATE ELASTIC CONSTANTS MATRIX (4X4)
C
      EE( 1) = ER*(1.0 - VTZ*VZT)/DEL
      EE( 2) = ER*(VTR + VZR*VTZ)/DEL
      EE( 3) = ER*(VZR + VTR*VZT)/DEL
      EE( 4) = 0.0
      EE( 5) = EE(2)
      EE( 6) = ET*(1.0 - VRZ*VZR)/DEL
      EE( 7) = ET*(VZT + VRT*VZR)/DEL
      EE( 8) = 0.0
      EE( 9) = EE(3)
      EE(10) = EE(7)
      EE(11) = EZ*(1.0 - VRT*VTR)/DEL
      EE(12) = 0.0
      EE(13) = 0.0
      EE(14) = 0.0
      EE(15) = 0.0
      EE(16) = GRZ
C
C     FORM TRANSFORMATION MATRIX (4X4) FROM MATERIAL AXIS TO ELEMENT
C     GEOMETRIC AXIS
C
      DGAMR   = DGAMA*DEGRA
      COSG    = COS(DGAMR)
      SING    = SIN(DGAMR)
      TEO( 1) = COSG**2
      TEO( 2) = 0.0
      TEO( 3) = SING**2
      TEO( 4) = SING*COSG
      TEO( 5) = 0.0
      TEO( 6) = 1.0
      TEO( 7) = 0.0
      TEO( 8) = 0.0
      TEO( 9) = TEO(3)
      TEO(10) = 0.0
      TEO(11) = TEO(1)
      TEO(12) =-TEO(4)
      TEO(13) =-2.0*TEO(4)
      TEO(14) = 0.0
      TEO(15) =-TEO(13)
      TEO(16) = TEO(1) - TEO(3)
C
C     TRANSFORM THE ELASTIC CONSTANTS MATRIX FROM MATERIAL
C     TO ELEMENT GEOMETRIC AXIS
C
      CALL GMMATS (TEO,4,4,1, EE, 4,4,0, D )
      CALL GMMATS (D  ,4,4,0, TEO,4,4,0, EE)
C
C     COMPUTE THE THERMAL STRAIN VECTOR
C
      DO 600 I = 1,3
      ALFB(I) = ALF(I)
  600 CONTINUE
      ALFB(4) = 0.0
C
      CALL GMMATS (EE(1),4,4,0, ALFB(1),4,1,0, TS(1))
C
C     FORM THE Q MATRIX (8X4)
C
      D( 1) = TS(1) + TS(2)
      Q( 1) = TS(2)*DELINT(1)
      Q( 2) = TS(2)*DELINT(4)
      Q( 3) = TS(2)*DELINT(2)
      Q( 4) = TS(2)*DELINT(5)
      Q( 5) =  D(1)*DELINT(4)
      Q( 6) =  D(1)*DELINT(7)
      Q( 7) =  D(1)*DELINT(5)
      Q( 8) =  D(1)*DELINT(8)
      Q( 9) = TS(2)*DELINT(2)
      Q(10) = TS(2)*DELINT(5)
      Q(11) = TS(2)*DELINT(3)
      Q(12) = TS(2)*DELINT(6)
      Q(13) =  D(1)*DELINT(5)
      Q(14) =  D(1)*DELINT(8)
      Q(15) =  D(1)*DELINT(6)
      Q(16) =  D(1)*DELINT(9)
      DO 630 I = 17,24
      Q( I) = 0.0
  630 CONTINUE
      Q(25) = TS(3)*DELINT( 4)
      Q(26) = TS(3)*DELINT( 7)
      Q(27) = TS(3)*DELINT( 5)
      Q(28) = TS(3)*DELINT( 8)
      Q(29) = TS(3)*DELINT( 7)
      Q(30) = TS(3)*DELINT(10)
      Q(31) = TS(3)*DELINT( 8)
      Q(32) = TS(3)*DELINT(11)
C
C     FORM THE TRANSFORMATION MATRIX (8X8) FROM FIELD COORDINATES TO
C     GRID POINT DEGREES OF FREEDOM
C
      DO 650 I = 1,64
      GAMBQ(I) = 0.0
  650 CONTINUE
      GAMBQ( 1) = 1.0
      GAMBQ( 2) = R1
      GAMBQ( 3) = Z1
      GAMBQ( 4) = R1*Z1
      GAMBQ(13) = 1.0
      GAMBQ(14) = R1
      GAMBQ(15) = Z1
      GAMBQ(16) = GAMBQ(4)
      GAMBQ(17) = 1.0
      GAMBQ(18) = R2
      GAMBQ(19) = Z2
      GAMBQ(20) = R2*Z2
      GAMBQ(29) = 1.0
      GAMBQ(30) = R2
      GAMBQ(31) = Z2
      GAMBQ(32) = GAMBQ(20)
      GAMBQ(33) = 1.0
      GAMBQ(34) = R3
      GAMBQ(35) = Z3
      GAMBQ(36) = R3*Z3
      GAMBQ(45) = 1.0
      GAMBQ(46) = R3
      GAMBQ(47) = Z3
      GAMBQ(48) = GAMBQ(36)
      GAMBQ(49) = 1.0
      GAMBQ(50) = R4
      GAMBQ(51) = Z4
      GAMBQ(52) = R4*Z4
      GAMBQ(61) = 1.0
      GAMBQ(62) = R4
      GAMBQ(63) = Z4
      GAMBQ(64) = GAMBQ(52)
C
C     NO NEED TO COMPUTE DETERMINANT SINCE IT IS NOT USED SUBSEQUENTLY.
C
      ISING = -1
      CALL INVERS (8,GAMBQ(1),8,D(10),0,D(11),ISING,SP)
C
      IF (ISING .EQ. 2) CALL MESAGE (-30,26,IDEL)
C
C     FORM THE HPRIM MATRIX (4X4)
C
      K  = 0
      DO 670 I = 1,4
      KK =  8*(I-1) - 1
      DO 670 J = 1,4
      K  = K  + 1
      KK = KK + 2
      HPRIM(K) = GAMBQ(KK)
  670 CONTINUE
C
C     MODIFY THE TRANSFORMATION MATRIX IF ELEMENT IS A CORE ELEMENT
C
      IF (ICORE .EQ. 0) GO TO 665
      JJ1 = 2*JRZ(1) - 1
      JJ2 = 2*JRZ(2) - 1
C
      DO 663 I = 1,8
      J = 8*(I-1)
      GAMBQ(I    ) = 0.0
      GAMBQ(I+ 16) = 0.0
      GAMBQ(J+JJ1) = 0.
      GAMBQ(J+JJ2) = 0.
  663 CONTINUE
  665 CONTINUE
C
C     FORM THE TEMPERATURE VECTOR
C
      DO 680 I = 1,4
      TI(I) = TI(I) - TZERO
  680 CONTINUE
C
C     COMPUTE THE THERMAL LOAD IN FIELD COORDINATES
C
      CALL GMMATS (HPRIM(1),4,4,0, TI(1),4,1,0, TL(1))
      CALL GMMATS (Q(1),    8,4,0, TL(1),4,1,0,  D(1))
C
C     TRANSFORM THE THERMAL LOAD TO GRID POINT DEGREES OF FREEDOM
C
      CALL GMMATS (GAMBQ(1),8,8,1, D(1),8,1,0, TL(1))
C
C     GENERATE THE TRANSFORMATION MATRIX FROM TWO TO THREE DEGREES OF
C     FREEDOM PER POINT
C
      DO 700 I = 1,96
      GAMQS( I) = 0.0
  700 CONTINUE
      GAMQS( 1) = 1.0
      GAMQS(15) = 1.0
      GAMQS(28) = 1.0
      GAMQS(42) = 1.0
      GAMQS(55) = 1.0
      GAMQS(69) = 1.0
      GAMQS(82) = 1.0
      GAMQS(96) = 1.0
C
C     TRANSFORM THE   THERMAL LOAD   FROM TWO TO THREE DEGREES OF
C     FREEDOM PER POINT
C
      CALL GMMATS (GAMQS(1),8,12,1, TL(1),8,1,0, D(10))
C
C     LOCATE THE TRANSFORMATION MATRICES FOR THE FOUR  GRID POINTS
C
      DO 750 I = 1,144
      GAMBL(I) = 0.0
  750 CONTINUE
      DO 800 I = 1,4
      CALL GBTRAN (ICS(I),ECPT(4*I+4),D(1))
      K  = 39*(I-1) + 1
      DO 800 J = 1,3
      KK = K + 12*(J-1)
      JJ = 3*(J-1) + 1
      GAMBL(KK  ) = D(JJ  )
      GAMBL(KK+1) = D(JJ+1)
      GAMBL(KK+2) = D(JJ+2)
  800 CONTINUE
C
C     TRANSFORM THE   THERMAL LOAD   FROM BASIC TO LOCAL COORDINATES
C
      CALL GMMATS (GAMBL(1),12,12,1, D(10),12,1,0, TL(1))
      DO 850 I = 1,12
      TL(I) = TWOPI*TL(I)
  850 CONTINUE
C
C     ADD THE ELEMENT THERMAL LOAD TO THE STRUCTURE THERMAL LOAD
C
      K = 0
      DO 900 I = 1,4
      L = IGP(I) - 1
      DO 900 J = 1,3
      K = K + 1
      L = L + 1
      PG(L) = PG(L) + TL(K)
  900 CONTINUE
C
      RETURN
      END

      SUBROUTINE CURVPS (SIGS, PRIN)
C*****
C  COMPUTES PRINCIPAL STRESSES OR STRAINS AND ANGLE OF MAXIMUM.
C*****
      REAL SIGS(3), PRIN(4)
C
      TEMP = SIGS(1) - SIGS(2)
      PRIN(4) = SQRT( (TEMP/2.0)**2 + SIGS(3)**2 )
      DELTA = ( SIGS(1) + SIGS(2) ) / 2.0
      PRIN(2) = DELTA + PRIN(4)
      PRIN(3) = DELTA - PRIN(4)
      DELTA = 2.0 * SIGS(3)
      IF( ABS(DELTA).LT.1.0E-15 .AND. ABS(TEMP).LT.1.0E-15 ) GO TO 100
      PRIN(1) = ATAN2( DELTA, TEMP )*28.6478898E0
      RETURN
C
  100 PRIN(1) = 0.0
      RETURN
      END

      SUBROUTINE IFP1
C
C     READS AND INTERPRETS CASE CONTROL DECK FOR NASTRAN
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        RSHIFT,ANDF,ORF,COMPLF
      LOGICAL         TAPBIT,SETCD,PLOTCD,BIT64
      REAL            SYMSEQ(360),XCORE(1),XINTCD
      DIMENSION       CASE(200,2),XCASE(200,2),NIFP(2),CASEN(11),
     1                NAME(2),TTLCD(9),CCCD(9),CCCDS(54),XYPRM(5),
     2                OUTOP(15),ISUBC(5),OUTPCH(13),CORE(7),COREY(401)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /OUTPUT/ TITLE(32),SUBTIT(32),LABEL(32),HEAD1(32),
     1                HEAD2(32),HEAD3(32),PLTID(32)
      COMMON /SYSTEM/ SYSBUF,OTPE,NOGO,INTP,MPCN,SPCN,LOGFL,LOADNN,NLPP,
     1                STFTEM,IPAGE,LINE,TLINE,MAXLIN,DATE(3),TIM,IECHO,
     2                SPLOTS,APP,IDUM,LSYSTM,DUMMS(16),NBPW,DUMMY(28),
     3                ISUBS,DUMZ(16),INTRA,DMZ(4),LPCH
      COMMON /ZZZZZZ/ COREX(1)
      COMMON /XIFP1 / BLANK,BIT64
      COMMON /IFP1A / SCR1,CASECC,IS,NWPC,NCPW4,NMODES,ICC,NSET,
     1                NSYM,ZZZZBB,ISTR,ISUB,LENCC,IBEN,EQUAL,IEOR
      COMMON /IFP1HX/ MSST,MISSET(20)
      COMMON /XSORTX/ IBUF41
      EQUIVALENCE     (COREX(1) ,XCASE(1,1) , CASE(1,1),COREY(1)),
     1                (CORE(1)  ,XCORE( 1)  , COREY(401)        ),
     2                (NONO     ,OUTOP(15)) , (IAXIC  ,DUMMS(4) ),
     3                (IAXIF    ,DUMMS(15)) , (SET    ,CCCD( 7) ),
     4                (PLOT     ,TTLCD(4) ) , (XYPL   ,XYPRM(1) ),
     5                (OUTP     ,CCCD( 1) ) , (BEGI   ,CCCD( 2) ),
     6                (BOTH     ,OUTOP(1) ) , (NONE   ,OUTOP(2) )
      DATA    NIFP  / 4H  IF, 4HP1  /
      DATA    CASEN / 4HC A , 4HS E , 4H   C, 4H O N, 4H T R, 4H O L,
     1                4H   D, 4H E C, 4H K  , 4H E C, 4H H O  /
      DATA    IBOB,   ISYMCM, LOADN , IOUT2 , INOMOR          /
     A        0,      0,      1,      0,      0               /
      DATA    OUTPCH/ 11,18 , 21,24 , 27,30 , 33,36 , 152,155,158,168,
     1                171   /
      DATA    BLANK4, CARD  , COUN  , T     , EQUAL1, NPTP   ,DOL1   /
     1        4H    , 4HCARD, 4HCOUN, 4HT   , 4H=   , 4HNPTP ,4H$    /
      DATA    NAME  / 4HCASE, 4HCC  /
      DATA    TTLCD / 4HTITL, 4HSUBT, 4HLABE, 4HPLOT, 4HXTIT, 4HYTIT,
     1                4HTCUR, 4HYTTI, 4HYBTI /
      DATA    CCCD  / 4HOUTP, 4HBEGI, 4HSYM , 4HSUBC, 4HSYMC, 4HREPC,
     1                4HSET , 4HNCHE, 4HSCAN /
      DATA    CCCDS / 4HMPC , 4HSPC , 4HLOAD, 4HNLLO, 4HDEFO, 4HTEMP,
     1                4HDLOA, 4HMETH, 4HFREQ, 4HIC  , 4HDISP, 4HVECT,
     2                4HPRES, 4HTHER, 4HSTRE, 4HELST, 4HELFO, 4HFORC,
     3                4HACCE, 4HVELO, 4HSPCF, 4HMAXL, 4HTSTE, 4HSYMS,
     4                4HSUBS, 4HECHO, 4HMODE, 4HLINE, 4HDSCO, 4HK2PP,
     5                4HM2PP, 4HB2PP, 4HTFL , 4HFMET, 4HOFRE, 4HOTIM,
     6                4HCMET, 4HSDAM, 4HSDIS, 4HSVEC, 4HSVEL, 4HSACC,
     7                4HNONL, 4HPLCO, 4HAXIS, 4HHARM, 4HRAND, 4HOLOA,
     8                4HGPFO, 4HESE , 4HMPCF, 4HAERO, 4HGUST, 4HSTRA/
      DATA    ALL   / 4HALL /, COSI / 4HCOSI/
      DATA    DEFA  / 4HDEFA/, MAT  / 4HMATE/
      DATA    OM    / 4HOM  /, ONEB / 4H1   /
      DATA    PCDB  / 4HPCDB/, PLT1 / 4HPLT1/
      DATA    PLT2  / 4HPLT2/, SINE / 4HSINE/
      DATA    XYCB  / 4HXYCD/, XYOU / 4HXYOU/
      DATA    PTIT  / 4HPTIT/, FLUI / 4HFLUI/
      DATA    SYMM  / 4HSYMM/, ANTI / 4HANTI/
      DATA    ANOM  / 4HANOM/
      DATA    XYPRM / 4HXYPL, 4HXYPR, 4HXYPU, 4HXYPE, 4HXYPA /
      DATA    OUTOP / 4HBOTH, 4HNONE, 4HUNSO, 4HSORT, 4HPUNC, 4HPRIN,
     1                4HREAL, 4HIMAG, 4HPHAS, 4HNOPR, 4HMAXS, 4HVONM,
     2                4HEXTR, 4HLAYE, 4HNONO/
C
C     INITIALIZE
C
      ICC    = 1
      ICNT   = 0
      NSET   = 0
      NSYM   = 0
      ISUB   = 1
      MSST   = 0
      ORG    = 0
      PORG   =-1
      ISTR   = 1
      NCPW4  = 4
      NWPC   = 20
      JUMPH  = 0
      NPCH   = 0
      NOGOPC = 0
      SCR1   = 301
      SETCD  =.FALSE.
      PLOTCD =.FALSE.
      BLANK  = BLANK4
      BIT64  = NBPW.EQ.64
      CASECC = NAME(1)
      ZZZZBB = 0
      ZZZZBB = KHRFN1(ZZZZBB,1,ZZZZBB,4)
      EQUAL  = KHRFN1(ZZZZBB,1,EQUAL1,1)
      DOL    = KHRFN1(ZZZZBB,1,DOL1  ,1)
      IBEN   = KHRFN1(ZZZZBB,1,BLANK ,1)
      IS     = 9999999
      IEOR   = RSHIFT(COMPLF(0),1)
      NMODES = 1
      LENCC  = 200
      DO 50 J = 1,2
      DO 50 I = 1,LENCC
   50 CASE(I,J) = 0
      CASE(166,1) = LENCC
      DO 60 J = 1,2
      DO 60 I = 1,96
   60 CASE(I+38,J) = BLANK
      DO 61 I = 1,5
      ISUBC(I) = BLANK
   61 CONTINUE
      NZ = KORSZ(CORE) - NWPC - 1
C
C     BLANK TITLE
C
      DO 65 I = 1,96
      TITLE(I) = BLANK
   65 CONTINUE
      DO 70 I = 1,11
   70 HEAD1(I+9) = CASEN(I)
      HEAD2(  4) = CARD
      HEAD3(  4) = COUN
      HEAD3(  5) = T
C
      I81 = NWPC + 1
C
C     READ IN DATA-- STORE TITLE CARDS
C
      NZ   = NZ  - SYSBUF
      ICRQ = I81 - NZ
      IF (I81 .GT. NZ) GO TO 330
      CALL OPEN (*300,SCR1,COREX(NZ+1),1)
   80 CALL XREAD (*2000,CORE(1))
      CALL WRITE (SCR1,CORE(1),NWPC,0)
      IF (IBUF41 .EQ. -1) GO TO 80
C
C     IS THIS A TITLE SUBTITLE,LABEL,ETC CARD
C
      CALL IFP1F (*80,IWORD,I2)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWORD,0)
      ASSIGN 80 TO IRET1
      ISTR = 0
      ISUB = 1
      DO 100 I = 1,6
      IF (IWORD .EQ. CCCD(I)) GO TO (145, 340, 140, 140, 140, 140), I
C                                    OUTP BEGI SYM  SUBC SYMC REPC
C
  100 CONTINUE
      IF (INOMOR .EQ. 1) GO TO 80
      DO 101 I = 1,3
      IF (IWORD .EQ. TTLCD(I)) GO TO (110, 120, 130), I
C                                     TITL SUBT LABE
C
  101 CONTINUE
      GO TO 80
  110 IF (LOGFL .LE. 0) CALL LOGFIL (CORE(1))
  115 ITYPE = 1
      GO TO 150
  120 ITYPE = 2
      GO TO 150
  130 ITYPE = 3
      GO TO 150
  131 ITYPE = 7
      GO TO 150
C
C     STOP TITLE SEARCH
C
  140 INOMOR = 1
      GO TO 80
C
C     IDENTIFY PLOT PACKETS
C
  145 CALL XRCARD (CORE(I81),NZ,CORE(1))
      TEMP = CORE(I81+5)
      IF (BIT64) CALL MVBITS (BLANK,0,32,TEMP,0)
      IF (TEMP .EQ. PLOT) GO TO 146
      IF (TEMP.EQ.XYPL .OR. TEMP.EQ.XYOU) GO TO 140
      GO TO 80
C
C     SET PLOT FLAG
C
  146 CASE(135,1) = 1
      GO TO 140
C
C     FIND EQUAL SIGN COPY REMAINING DATA ON CARD
C
  150 CALL IFP1G (ITYPE,CASE(1,1),ISUB)
      GO TO IRET1, (80,350)
C
C     FILE ERRORS
C
  300 IP1 = -1
  301 CALL MESAGE (IP1,FILE,NIFP)
      RETURN
C
  310 IP1 = -2
      GO TO 301
  320 IP1 = -3
      GO TO 301
  330 IP1 = -8
      FILE = ICRQ
      GO TO 301
  340 CALL CLOSE (SCR1,1)
C
C     START BUILDING RECORDS
C
      CALL PAGE
      NWDSC  = NWPC + 1
      ASSIGN 350 TO IRET1
      IHOWDY = 1
      NSYM   = 0
      NSYMS  = 0
      IUN    = 0
      IXYPL  = 0
      ICASEC = 0
      ISTR   = 1
      NSUB   = 0
      MSST   = 0
      IBUF1  = NZ + 1
      FILE   = SCR1
      CALL OPEN (*300,SCR1,COREX(IBUF1),0)
      NZ     = NZ - SYSBUF
      IBUF2  = NZ + 1
      FILE   = CASECC
      IF (ISUBS .EQ. 0) GO TO 603
C
C     IN SUBSTRUCTURES, THE CASECC FILE CONTAINS DATA ON THE FRONT.
C     SKIP FILE BEFORE WRITING.
C
      CALL OPEN (*603,FILE,COREX(IBUF2),3)
      CALL WRITE (FILE,NAME,2,1)
  350 FILE  = SCR1
      ICONT = 0
      ICRQ  = I81 - NZ
      IF (I81 .GT. NZ) GO TO 330
  351 CONTINUE
      CALL READ (*310,*320,SCR1,CORE(1),NWPC,0,FLAG)
      WRITE  (OTPE,360) ICC,(CORE(I),I=1,NWPC)
  360 FORMAT (11X,I8,6X,20A4)
      ICC  = ICC  + 1
      LINE = LINE + 1
      IF (LINE .GE. NLPP) CALL PAGE
      IF (DOL .EQ. KHRFN1(ZZZZBB, 1,CORE(1),1))  GO TO 350
C
C     IS THIS TITLE SUBTITLE OR LABEL CARD
C
      CALL IFP1F (*350,IWORD,I2)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWORD,0)
      DO 372 I = 1,4
      IF (IWORD.EQ.TTLCD(I) .AND. IBOB+IXYPL.EQ.0)
     1    GO TO (115, 120, 130, 131 ), I
C                TITL SUBT LABE PLOT
C
  372 CONTINUE
      IF (IWORD.EQ.PTIT .AND. IBOB.EQ.1) GO TO 1838
      IF (IXYPL .NE. 1) GO TO 374
      DO 373 I = 5,9
      IF (IWORD .EQ. TTLCD(I)) GO TO 1838
  373 CONTINUE
  374 CALL XRCARD (CORE(I81),NZ,CORE(1))
      IF (ICONT .EQ. 1) GO TO 650
C
      IF (BIT64) CALL MVBITS (BLANK,0,32,CORE(I81+1),0)
      IF (CORE(I81+1) .EQ. OUTP) GO TO 590
      IF (CORE(I81+1) .EQ. BEGI) GO TO 1320
      IF (IBOB  .EQ. 1) GO TO 1500
      IF (IXYPL .EQ. 1) GO TO 1836
      IF (CORE(I81) .LT. 0) GO TO 380
      IWORD = CORE(I81+1)
      DO 375 I = 3,9
      IO = I - 2
      IF (IWORD .EQ. CCCD(I))
     1    GO TO (580, 1060, 1560, 1720, 1050, 791, 1055), IO
C                SYM  SUBC  SYMC  REPC  SET  NCHE  SCAN
C
  375 CONTINUE
C
C
C     FIND VALUE AFTER EQUAL SIGN
C
      L = 2*IABS(CORE(I81)) + I81
      DO 376 I = I81,L
      TEMP = CORE(I)
      IF (BIT64) CALL MVBITS (BLANK,0,32,TEMP,0)
      IF (TEMP .EQ. EQUAL1) GO TO 377
  376 CONTINUE
      IL = -617
      GO TO 1291
  377 I1 = I + 1
      IF (I .EQ. L) I1 = I1 + 1
C
      IWORD = CORE(I81+1)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWORD,0)
      DO 379 I = 1,54
      IF (IWORD .EQ. CCCDS(I))
C
C               MPC   SPC   LOAD  NLLO  DEFO  TEMP  DLOA  METH  FREQ
     1  GO TO ( 400,  430,  440,  460,  540,  690,  550,  760,  560,
C
C                IC   DISP  VECT  PRES  THER  STRE  ELST  ELFO  FORC
     2          570,  770,  770,  770,  770,  780,  780,  790,  790,
C
C               ACCE  VELO  SPCF  MAXL  TSTE  SYMS  SUBS  ECHO  MODE
     3          800,  810,  820,  610,  620,  630,  630, 1420, 1490,
C
C               LINE  DSCO  K2PP  M2PP  B2PP  TFL   FMET  OFRE  OTIM
     4         1630, 1660, 1680, 1700, 1710, 1730, 1880, 1740, 1740,
C
C               CMET  SDAM  SDIS  SVEC  SVEL  SACC  NONL  PLCO  AXIS
     5         1750, 1760, 1780, 1780, 1790, 1800, 1810, 1665, 1850,
C
C               HARM  RAND  OLOA  GPFO  ESE   MPCF  AERO  GUST  STRA
     6         1860, 1870,  480, 1890, 1900,  405, 1910, 1930, 1950), I
C
  379 CONTINUE
C
C     UNABLE TO FIND CARD TYPE
C
  380 CALL IFP1D (-601)
      IUN  = IUN + 1
      IF (IUN .LT. 10) GO TO 350
C
C     ASSUME BEGIN BULK MISSING
C
      CALL IFP1D (-611)
      GO TO 1320
C
C     MPC CARD FOUND
C
  400 IK = 2
      GO TO 490
C
C     MPCFORCE CARD
C
  405 IK = 173
      GO TO 830
C
C     TOO MANY SPECIFICATIONS
C
  410 CALL IFP1D  (602)
      GO TO IRET, (720,500,860)
C
C     SPC CARD DETECTED
C
  430 IK = 3
      GO TO 490
C
C     LOAD SET SELECTION
C
  440 IK = 4
      GO TO 490
C
C     PNL FOR VDR
C
  460 IK = 10
      GO TO 830
C
C     OUTPUT LOAD SET
C
  480 IK = 17
      GO TO 830
  490 IF (CORE(I1) .LE. 0) CALL IFP1D (-617)
  491 ASSIGN 500 TO IRET
C
C     SKIP CHECK FOR HARMONIC AS DEFAULT IS NON-ZERO
C
      IF (CASE(IK,ISUB) .NE. 0) GO TO 410
  500 CASE(IK,ISUB) = CORE(I1)
  501 IF (CORE(I1-1) .NE. -1) GO TO 520
C
C     CHECK FOR END OF DATA
C
      IF (CORE(I1+1) .EQ. IEOR) GO TO 350
C
C     DATA CARD DID NOT END PROPERLY
C
  503 CONTINUE
      IL = -603
      GO TO 1291
C
C     NO INTEGER IN INTEGER FIELD
C
  520 IL = -604
      GO TO 1291
C
C     DEFORMATION SET
C
  540 IK = 6
      GO TO 490
C
C     DLOAD CARD
C
  550 IK = 13
      GO TO 490
C
C     FREQUENCY CARD
C
  560 IK = 14
      GO TO 490
C
C     IC CARD
C
  570 IK = 9
      GO TO 490
C
C     SYM CARD
C
  580 NSYM = NSYM + 1
      IF (NSYM-361) 585,586,1070
  585 SYMSEQ(NSYM) = 1.0
      GO TO 1070
  586 CALL IFP1D (-633)
      GO TO 1070
C
C     OUTPUT
C
  590 IOUT2 = 1
C
C     BLANK CHECK
C
      TEMP = CORE(I81+5)
      IF (BIT64) CALL MVBITS (BLANK,0,32,TEMP,0)
      IF (CORE(I81+3).EQ.IEOR .AND. CORE(I81).EQ.1) GO TO 350
      IF (TEMP .EQ. PLOT) GO TO 600
      IF (IBOB.EQ.1 .AND. .NOT.(SETCD.AND.PLOTCD)) CALL IFP1D (-631)
      IF (TEMP.EQ.XYPL .OR. TEMP.EQ.XYOU) GO TO 1830
      IL = -617
      GO TO 1291
  600 IBOB = 1
C
C     TURN ON TRAIL BITS FOR PLOT
C
      CORE(1) = PCDB
      CORE(2) = 0
      CORE(3) = 0
      CORE(4) = 0
      CORE(5) = 7777
      CORE(6) = 0
      CORE(7) = 0
      CALL WRTTRL (CORE(1))
C
C     CHECK FOR PRESENCE OF PLOT TAPE
C     (SPLOTS COULD BE SET ALREADY BY NASTRAN PLTFLG CARD)
C
      IF (ISUBS.EQ.0 .AND. .NOT.TAPBIT(PLT1) .AND. .NOT.TAPBIT(PLT2))
     1    CALL IFP1D (-618)
      IF (SPLOTS .EQ. 0) SPLOTS = 1
      IF (SPLOTS .LT. 0) SPLOTS =-SPLOTS
      ASSIGN 605 TO IRET3
      GO TO 1321
C
C     CLOSE OPEN STUFF
C
  605 IF (IXYPL .NE. 1) GO TO 602
C
C     TERMINANT XY PACKAGE
C
      IHOWDY = -1
      CALL IFP1XY (IHOWDY,XINTCD)
      CALL CLOSE (XYCB,1)
      IXYPL = 0
  602 CALL CLOSE (CASECC,1)
C
C     OPEN  PCDB
C
      FILE = PCDB
C
C     OPEN WRITE FILE
C
  603 CALL GOPEN (FILE,COREX(IBUF2),1)
      GO TO 350
C
C     MAXLINES CARD
C
  610 MAXLIN = CORE(I1)
      GO TO 501
C
C     TIME STEP CARD
C
  620 IK = 38
      GO TO 490
C
C     SYMSEQ AND SUBSEQ
C
  630 IF (ISYMCM .NE. 0) GO TO 631
C
C     SYMSEQ  CARD WITHOUT SYMCOM
C
      IL = -605
      GO TO 1291
  631 NSYMSQ = 1
      NSYM = 1
  650 IF (NSYM-361) 655,665,660
  655 SYMSEQ(NSYM) = XCORE(I1)
  660 IF (CORE(I1+1)) 670,680,350
  665 CALL IFP1D (-633)
      GO TO 660
C
C     CHECK FOR END OF DATA
C
  670 IF (CORE(I1+1) .EQ. IEOR) GO TO 350
      NSYM = NSYM + 1
      I1   = I1 + 2
      GO TO 650
C
C     CONTINUATION CARD
C
  680 ICONT = 1
      NSYM  = NSYM + 1
      I1    = I81  + 1
      GO TO 351
C
C     TEMPERATURE CARD
C
  690 IF (CORE(I81) .EQ. 2) GO TO 710
      TEMP = CORE(I81+5)
      IF (BIT64) CALL MVBITS (BLANK,0,32,TEMP,0)
      IF (TEMP .EQ. BOTH) GO TO 710
      IF (TEMP .EQ.  MAT) GO TO 730
C
C     THERMAL LOAD
C
  700 IK = 7
      GO TO 490
C
C     THERMAL + STIFFNESS
C
  710 ASSIGN 720 TO IRET
  720 CASE(8,ISUB) = CORE(I1)
      STFTEM = CORE(I1)
      IF (ISUB .NE. 1) GO TO 740
      GO TO 700
C
C     STIFNESS LOAD
C
  730 IK = 8
      STFTEM = CORE(I1)
      IF (ISUB .NE. 1) GO TO 740
      GO TO 490
C
C     THERMAL REQUEST AT SUBCASE LEVEL
C
  740 IL = 606
      GO TO 1291
C
C     METHOD
C
  760 IK = 5
      GO TO 490
C
C     DISP(PLOT,1) CARD
C
  770 IK = 20
      GO TO 830
C
C     STRESS CARD
C
  780 IK = 23
      GO TO 830
C
C     ELFORCE CARD
C
  790 IK = 26
      GO TO 830
C
C     NCHECK CARD
C
  791 IK = 146
      IF (CORE(I81  ) .EQ.  1) GO TO 793
      IF (CORE(I81+5) .EQ. -1) GO TO 792
      IL = -617
      GO TO 1291
  792 CASE(IK,ISUB) = CORE(I81+6)
      IF (CORE(I81+7) .NE. IEOR) GO TO 503
      GO TO 350
  793 CASE(IK,ISUB) = 5
      GO TO 350
C
C     ACC
C
  800 IK = 29
      GO TO 830
C
C     VEL CARD
C
  810 IK = 32
      GO TO 830
C
C     SPC FORC
C
  820 IK = 35
      GO TO 830
C
C     OUTPUT SPECIFICATION
C     STRESS AND FORCE FLAGS MAY BE PRE-SET TO 2 (NOPRINT) BY IFP1H
C
  830 ASSIGN 860 TO IRET
      IF ((IK.EQ.23 .OR. IK.EQ.26) .AND. CASE(IK+1,ISUB).EQ.2) GO TO 860
      IF (CASE(IK,ISUB) .NE. 0) GO TO 410
C
C     FIND EQUAL SIGN
C
  860 IDO = CORE(I81)
      CASE(IK+1,ISUB) = 0
      CASE(IK+2,ISUB) = 1
      DO 950 I = 1,IDO
      II   = I81 + 2*I
      TEMP = CORE(II)
      IF (BIT64) CALL MVBITS (BLANK,0,32,TEMP,0)
      IF (TEMP .EQ. EQUAL1) GO TO 960
      IWRD = CORE(II-1)
      DO 880 IO = 4,14
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWRD,0)
      IOP = IO - 3
      IF (IWRD .EQ. OUTOP(IO)) GO TO
     1   (940, 890, 900, 910, 920, 930, 905, 950, 943, 950, 946), IOP
C         SORT PUNC PRIN REAL IMAG PHAS NOPR MAXS VONM EXTR LAYE
C
  880 CONTINUE
      GO TO 950
C
C     PUNCH
C
  890 CASE(IK+1,ISUB) = CASE(IK+1,ISUB) + 4
      GO TO 950
C
C     PRINT
C
  900 CASE(IK+1,ISUB) = CASE(IK+1,ISUB) + 1
      GO TO 950
C
C     COMPUTE BUT NO PRINT
C     DEVICE CODE IS 2 (AND SUBPRESS PRINT CODE 1)
C
  905 CASE(IK+1,ISUB) = CASE(IK+1,ISUB) - MOD(CASE(IK+1,ISUB),2) + 2
      GO TO 950
C
C     REAL PRINT OUT FORMAT
C
  910 II = 1
      GO TO 931
C
C     REAL AND IMAGINARY
C
  920 II = 2
      GO TO 931
C
C     MAGNITUE AND PHASE ANGLE
C
  930 II = 3
  931 CASE(IK+2,ISUB) = ISIGN(II,CASE(IK+2,ISUB))
      GO TO 950
C
C     SORT TWO REQUEST
C     (COMMENTS FORM G.C.  7/1989
C     SINCE OES2L FILE HAS NOT BEEN IMPLEMENTED IN ALL DMAPS, SORT2
C     STRESS REQUEST ON LAYERED ELEMENTS IS NOT AVAILABLE)
C
  940 TEMP = CORE(II)
      IF (BIT64) CALL MVBITS (BLANK,0,32,TEMP,0)
      IF (TEMP .EQ. ONEB) GO TO 950
      IF (IK.EQ.23 .AND. CASE(183,ISUB).GE.2) CALL IFP1D (-645)
      CASE(IK+2,ISUB) = -IABS(CASE(IK+2,ISUB))
      GO TO 950
C
C     VON MISES STRESS
C     (183 WORD ON CASECC, FIRST RIGHT-MOST BIT)
C
  943 CASE(183,ISUB) = ORF(CASE(183,ISUB),1)
      GO TO 950
C
C     LAYER STRESSES FOR COMPOSITE ELEMENTS
C     (183 WORD ON CASECC, SECOND RIGHT-MOST BIT)
C     (SORT2 STRESS REQUEST ON LAYERED ELEMENTS NOT AVAILABLE)
C
  946 IF (IK .NE. 23) CALL IFP1D (-646)
      IF (IK.EQ.23 .AND. CASE(25,ISUB).LT.0) CALL IFP1D (-645)
      CASE(183,ISUB) = ORF(CASE(183,ISUB),2)
C
  950 CONTINUE
  960 IF (CASE(IK+1,ISUB) .EQ. 0) CASE(IK+1,ISUB) = 1
      IF (CORE(II+1) .NE.  0) GO TO 962
      CALL IFP1D (610)
      GO TO 970
  962 TEMP = CORE(II+1)
      IF (BIT64) CALL MVBITS (BLANK,0,32,TEMP,0)
      IF (TEMP .EQ. ALL) GO TO 970
      IF (TEMP.EQ.NONE .OR. TEMP.EQ.NONO) GO TO 980
      IF (CORE(II+1) .EQ. -1) GO TO 964
      IL = -617
      GO TO 1291
  964 I1 = II + 2
      GO TO 990
C
C     ALL SPECIFIED -- SET SET NO. MINUS
C
  970 CASE(IK,ISUB) = -1
      GO TO 1042
C
C     NONE SPECIFIED
C
  980 CASE(IK,ISUB) = NONE
      GO TO 1042
C
C     FIND SET NUMBER
C
  990 IF (NSET .NE. 0) GO TO 1020
C
C     UNDEFINED SET ID ON CARD
C
 1000 CALL IFP1D (-608)
      GO TO 350
 1020 JJ = NWDSC
      DO 1030 IL = 1,NSET
      IF (CORE(JJ) .EQ. CORE(I1)) GO TO 1040
      JJ = JJ + CORE(JJ+1) + 3
 1030 CONTINUE
      GO TO 1000
 1040 CASE(IK,ISUB) =CORE(I1)
 1042 IF (CORE(II+3) .NE. IEOR) GO TO 503
      GO TO 350
C
C     SET CARD
C
 1050 NSET = NSET + 1
      CALL IFP1C (I81,NZ)
      GO TO 350
C
C     SCAN CARD
C
 1055 CALL IFP1H (I81,NZ,JUMPH)
      GO TO 350
C
C     SUBCASE
C
 1060 TEMP = CORE(I81+2)
      IF (BIT64) CALL MVBITS (BLANK,0,32,TEMP,0)
      IF (TEMP   .EQ. OM) GO TO 1560
      IF (ISYMCM .EQ.  1) GO TO 1330
      NSYM  = 0
      NSYMS = NSYMS + 1
      IF (NSYMS-361) 1062,1064,1070
 1062 SYMSEQ(NSYMS) = 1.0
      GO TO 1070
 1064 CALL IFP1D (-633)
 1070 ASSIGN 350 TO IRET3
      IF (ISUB .EQ. 2) GO TO 1080
      ISUB  = 2
      LOADN = CORE(I81+4)
      CALL IFP1F (*350,IWORD,I2)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWORD,0)
      DO 1071 I = 1,5
      ISUBC(I) = CORE(I2)
      I2 = I2 + 1
 1071 CONTINUE
      IF (CORE(I81+3) + 1) 1290,350,1290
C
C     TURN STRESS AND FORCE NO-PRINT FLAGS ON IF INTERACTIVE FLAG IS ON
C
 1080 IF (INTRA .LT. 2) GO TO 1085
      CASE(24,ISUB) = ORF(CASE(24,ISUB),8)
      CASE(27,ISUB) = ORF(CASE(27,ISUB),8)
C
 1085 CASE(1,ISUB) = LOADN
      IF (CORE(I81+4) .LE. LOADN+NMODES-1) GO TO 1310
      LOADN = CORE(I81+4)
      IF (CORE(I81+3) .NE. -1) GO TO 1310
 1090 IF (CASE(137,1) .EQ.  0) CASE(137,1) = 1
      CALL IFP1E (ISUBC(1),SYMSEQ,NWDSC,I81,ICASTE)
      STFTEM = ICASTE
      NSUB = NSUB + NMODES
C
C     CHECK SET NOS. THAT WERE SPECIFIED AFTER SCAN CARDS
C
C     FORM G.C./UNISYS   4/1990
C     IFP1H IS BY-PASSING THIS NEW CODE HERE (MSST=0) BECAUSE SET DATA
C     IS NOT AVAILABLE HERE. SAVE THIS CODE FOR FURTHER INVESTIGATION.
C
      IF (MSST .EQ. 0) GO TO 1281
      MM = 0
      LL = LENCC + CASE(LENCC,ISUB) + 1
      DO 1094 M = 1,MSST
      I  = LL
      MSET = MISSET(M)
C
C     WRITE (6,2345) MSET,MSST,LL
C
 1091 ISET = CASE(I,ISUB)
C
C     LX1 = I - 3
C     LX2 = I + 3
C     WRITE (6,6789) ISET,(CASE(LX,ISUB),LX=LX1,LX2)
C
      IF (ISET .EQ. 0) GO TO 1094
      IF (MSET-ISET) 1092,1093,1092
 1092 I = I + CASE(I+1,ISUB)
      IF (I .GE. 400) GO TO 1094
      GO TO 1091
 1093 MISSET(M) = 0
      MM = MM + 1
 1094 CONTINUE
      IF (MM .EQ. MSST) GO TO 1281
      DO 1096 M = 1,MSST
      IF (MISSET(M) .EQ. 0) GO TO 1096
      WRITE  (OTPE,1095) UFM,MISSET(M)
 1095 FORMAT (A23,' 608A, UNIDENTIFIED SET',I8,' WAS REQUESTED FOR ',
     1       'SCAN')
      NOGO = 1
 1096 CONTINUE
C
 1281 GO TO IRET3, (350,1370,605,1835)
C
C     SUBCASE ID MISSING
C
 1290 IL = -609
      LOADN = CASE(1,2)
 1291 CALL IFP1D (IL)
      GO TO 350
 1310 CALL IFP1D (-609)
      LOADN = CASE(1,2)
      GO TO 1090
C
C     BEGIN BULK
C
 1320 ASSIGN 1370 TO IRET3
 1321 CORE(I81+3) = -1
      CORE(I81+4) = 9999999
      IF (ICASEC .EQ. 1) GO TO 1281
      ICASEC = 1
      IF (ISYMCM .EQ. 1) GO TO 1330
      NSYM = 0
      GO TO 1080
C
C     PUT OUT SUBCOM OR SYMCOM RECORD
C
 1330 ISYMCM = 0
 1340 IF (NSYMSQ.NE.0 .OR. NSYM.NE.0) GO TO 1360
C
C     NO SUBSEQ OR SYMSEQ CARD
C
      NSYM = NSYMS
C
 1360 NSYMSQ = 0
      CASE(LENCC,2) = MAX0(NSYM,0)
      CASE(16,2) = NSYM
      GO TO 1080
 1370 CALL CLOSE (SCR1,1)
      IF (IBOB.NE.1 .AND. IXYPL.NE.1) CALL CLOSE (CASECC,1)
      IF (IBOB .EQ. 1) CALL CLOSE (PCDB,1)
      IF (IBOB.EQ.1 .AND. .NOT.(SETCD.AND.PLOTCD)) CALL IFP1D (-631)
      IF (IXYPL .NE. 1) GO TO 1371
C
C     TERMINATE XYPLOT PACKAGE
C
      IHOWDY = -1
      CALL IFP1XY (IHOWDY,XINTCD)
      CALL CLOSE  (XYCB,1)
C
C     PUT CASECC ON NPTP
C
 1371 CONTINUE
      FILE  = CASECC
      CALL OPEN (*300,CASECC,COREX(IBUF1),0)
      FILE  = NPTP
      MAXCC = 0
      CALL OPEN (*300,NPTP,COREX(IBUF2),3)
 1380 CALL READ (*1400,*1390,CASECC,CORE(1),NZ,0,FLAG)
      ICRQ  = NZ
      GO TO 330
 1390 CALL WRITE (NPTP,CORE(1),FLAG,1)
      MAXCC = MAX0(MAXCC,FLAG)
C
C     CHECK ANY PUNCH REQUEST  ON OUTPUT DATA BLOCKS
C
      IF (NPCH.EQ.1 .OR. FLAG.LT.166) GO TO 1380
      DO 1393 I = 1,13
      J = OUTPCH(I)
      IF (ANDF(CORE(J),4) .NE. 0) GO TO 1395
 1393 CONTINUE
      GO TO 1380
 1395 NPCH = 1
      GO TO 1380
 1400 CALL CLOSE (CASECC,1)
      CALL EOF (NPTP)
      CALL CLOSE (NPTP,2)
      IF (SPLOTS .LT. 0) SPLOTS = 0
C
C     IF THIS IS A RESTART  SET CHANGE FLAGS IN IFP1B
C
      IF (APP .LT. 0) CALL IFP1B
      IF (IUN .NE. 0) CALL IFP1D (-612)
      CALL MAKMCB (CORE,CASECC,NSUB,0,0)
      CORE(2) = NSUB
      CORE(4) = MAXCC
      CALL WRTTRL (CORE)
C
C     SET NOGO FLAG TO -9 IF ERROR IN BULKDATA AND PLOT COMMANDS
C     SET NOGO FLAG TO POSITIVE IF ERROR IN BULKDATA, AND NOT IN PLOT
C     SET NOGO FLAG TO NEGATIVE IF NO ERROR IN BULKDATA, BUT IN PLOT
C     PUNCH AN IDENTIFICATION CARD IF PUNCH IS REQUESTED ON OUTPUT DATA,
C     AND PRINT SCAN KEYWORDS IF ERROR FLAG (JUMPH) WAS TURNED ON
C
      IF (NOGO.NE.0 .AND. NOGOPC.EQ.-1) NOGO = -9
      IF (NOGO .EQ. 0) NOGO = NOGOPC
      IF (NPCH .EQ. 1) WRITE (LPCH,1415) (TITLE(J),J=1,17)
 1415 FORMAT (2H$ ,17A4)
      IF (JUMPH .EQ. 1) CALL IFP1H (0,0,2)
      RETURN
C
C     ECHO REQUEST
C
 1420 IECHO = 0
      IDO = CORE(I81) - 2
      DO 1460 I = 1,IDO
      IWRD = CORE(I1)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWRD,0)
      DO 1421 IO = 1,5
      IF (IWRD .EQ. OUTOP(IO)) GO TO (1435, 1480, 1440, 1430, 1431), IO
C                                     BOTH  NONE  UNSO  SORT  PUNC
C
 1421 CONTINUE
      IF (IWRD .EQ. OUTOP(15)) GO TO 1470
      CALL IFP1D (629)
      GO TO 1432
C
C     SORTED ECHO
C
 1430 CONTINUE
      IF (ANDF(IECHO,2) .NE. 0) CALL IFP1D (629)
 1432 IECHO = ORF(IECHO,2)
      GO TO 1450
C
C     PUNCH ECHO
C
 1431 CONTINUE
      IF (ANDF(IECHO,4) .NE. 0) CALL IFP1D (629)
      IECHO = ORF(IECHO,4)
      NPCH  = 1
      GO TO 1450
C
C     BOTH ECHO
C
 1435 CONTINUE
      IF (ANDF(IECHO,3) .NE. 0) CALL IFP1D (629)
      IECHO = ORF(IECHO,3)
      GO TO 1450
C
C     UNSORTED ECHO
C
 1440 CONTINUE
      IF (ANDF(IECHO,1) .NE. 0) CALL IFP1D (629)
      IECHO = ORF(IECHO,1)
 1450 I1 = I1 + 2
 1460 CONTINUE
C
      GO TO 350
C
C     NONO ECHO - ABSOLUTELY NO ECHO, NO EVEN IN RESTART
C
 1470 IO = 16
C
C     NONE ECHO
C
 1480 CONTINUE
      IF (IECHO.NE.0 .OR. I.LT.IDO) CALL IFP1D (630)
      IECHO = -1
      IF (IO .EQ. 16) IECHO = -2
      GO TO 350
C
C     LOOP CONTROL FOR EIGENVALUE
C
 1490 NMODES = CORE(I1)
      GO TO 350
C
C     PLOT DATA FOR BO BATA
C
 1500 I1 = I81
C
C     TEST FOR REQUIRED PLOT AND SET CARDS IN STRUCTURE PLOT OUTPUT PKG
C
      TEMP = CORE(I81+2)
      IF (BIT64) CALL MVBITS (BLANK,0,32,TEMP,0)
      IF (CORE(I81+1).EQ.PLOT .AND. TEMP.EQ.BLANK) PLOTCD =.TRUE.
      IF (CORE(I81+1) .EQ. SET) SETCD  = .TRUE.
C
C     TEST FOR XYPLOT COMMAND CARDS IN STRUCTURE PLOT OUTPUT PACKAGE
C
      IWRD = CORE(I81+1)
      DO 1501 I = 1,5
      IF (IWRD .EQ. XYPRM(I)) CALL IFP1D (-632)
 1501 CONTINUE
C
C     TEST FORMAT OF PLOT COMMAND CARDS
C
      I = NOGO
      NOGO = 0
      CALL IFP1PC (I81,ICNT,XINTCD,ORG,PORG)
      IF (NOGO .NE. 0) NOGOPC = -1
      NOGO = I
C
C     COMPUTE LENGTH OF RECORD
C
      IK = 0
 1510 IF (CORE(I1)) 1520,1550,1530
 1520 CONTINUE
      IP = 2
      GO TO 1540
 1530 IF (CORE( I1) .EQ. IEOR) GO TO 1550
      IP = 2*CORE(I1) + 1
 1540 IK = IK + IP
      I1 = I1 + IP
      GO TO 1510
 1550 CALL WRITE (PCDB,CORE(I81),IK+1,1)
      GO TO 350
C
C     PLOT TITLE CARD
C
 1555 CORE(I81  ) = 10
      CORE(I81+1) = IWORD
      CORE(I81+2) = BLANK
      CALL IFP1G (ITYPE,CORE(I81+3),1)
      CORE(I81+21) = 9999999
      IK = 21
      GO TO 1550
C
C     SYMCOM OR SUBCOM CARD
C
 1560 IF (ISYMCM .EQ. 0) GO TO 1570
      ASSIGN 350 TO IRET3
      GO TO 1340
 1570 ISYMCM = 1
      NSYMSQ = 0
      GO TO 1070
C
C     LINE CARD - NLPP BOTTOM-LIMITED TO 10
C
 1630 CONTINUE
      IF (CORE(I1-1) .NE. -1) GO TO 520
      IF (IABS(CORE(I1)) .GT. 0) NLPP = IABS(CORE(I1))
      IF (NLPP .LT. 10) NLPP = 10
      GO TO 350
C
C     DIFFERENTIAL STIFFNESS OR PIECEWISE LINEAR COEFFICIENT SET
C
 1660 IK = 138
      GO TO 1670
 1665 IK = 164
 1670 TEMP = CORE(I1)
      IF (BIT64) CALL MVBITS (BLANK,0,32,TEMP,0)
      IF (TEMP .NE. DEFA) GO TO 490
      CORE(I1  ) = -1
      CORE(I1+1) = IEOR
      CORE(I1-1) = -1
      GO TO 491
C
C     K2PP
C
 1680 IK = 139
 1690 CASE(IK  ,ISUB) = CORE(I1  )
      CASE(IK+1,ISUB) = CORE(I1+1)
      GO TO 350
C
C     M2PP
C
 1700 IK = 141
      GO TO 1690
C
C     B2PP
C
 1710 IK = 143
      GO TO 1690
C
C     REPRINT OF ABOVE CASE
C
 1720 NSYM = -1
      IF(ISUB .NE. 2) CALL IFP1D (-607)
      GO TO 1560
C
C     TRANSFER FUNCTION SELECTION
C
 1730 IK = 15
      GO TO 490
C
C     OUTPUT FREQUENCY LIST SET
C
 1740 IK = 145
      TEMP = CORE(I1)
      IF (BIT64) CALL MVBITS (BLANK,0,32,TEMP,0)
      IF (TEMP .NE. ALL) GO TO 830
      CORE(I1  ) = -1
      CORE(I1-1) = -1
      CORE(I1+1) = IEOR
      GO TO 491
C
C     COMPLEX EIGENVALUE METHOD
C
 1750 IK = 148
      GO TO 490
C
C     STRUCTURAL DAMPING TABLE
C
 1760 IK = 149
      GO TO 490
C
C     INERTIA RELIEF SET SELECTION
C
C1770 IK = 150
C     GO TO 490
C
C     ANALYSIS SET FOR VDR
C
 1780 IK = 151
      GO TO 830
C
C     ANALYSIS VELOCITY
C
 1790 IK = 154
      GO TO 830
C
C     ANALYSIS ACCELERATION
C
 1800 IK = 157
      GO TO 830
C
C     NON LINEAR FORCE VECTOR FOR TRANSIENT ANALYSIS
C
 1810 IK = 160
      GO TO 490
C
C     X-Y PLOTTER PACKAGE
C
 1830 ASSIGN 1835 TO IRET3
      GO TO 1321
 1835 CALL CLOSE (CASECC,1)
      DO 1834 I = 2,6
 1834 CORE(I) = 0
      CORE(1) = XYCB
      CORE(7) = 1
      CALL WRTTRL (CORE(1))
C
C     OPEN XYCB
C
      IF (IBOB .NE. 1) GO TO 1837
      CALL CLOSE (PCDB,1)
      IBOB  = 0
 1837 FILE  = XYCB
      IXYPL = 1
      I81   = NWPC + 1
      GO TO 603
C
C     AXIS TITLE CARDS
C
 1838 ITYPE = 8
      CORE(1) = IWORD
      DO 1839 I = 1,32
      K = I81 + I - 1
      CORE(K) = BLANK
 1839 CONTINUE
      IF (IBOB .EQ. 1) GO TO 1555
      CALL IFP1G (ITYPE,CORE(I81),1)
C
C     PROCESS XYPLOTTER CARD
C
 1836 CALL IFP1XY (IHOWDY,XINTCD)
      GO TO 350
C
C     DELETE SETS FOR FORCE
C
C1840 IK = 161
C     GO TO 490
C
C     AXISYM CARD
C
 1850 TEMP = CORE(I1)
      IF (BIT64) CALL MVBITS (BLANK,0,32,TEMP,0)
      IF (TEMP .EQ. SINE) GO TO 1851
      IF (TEMP .EQ. COSI) GO TO 1852
      IF (TEMP .EQ. FLUI) GO TO 1852
      IF (TEMP .EQ. SYMM) GO TO 1853
      IF (TEMP .EQ. ANTI) GO TO 1854
      IF (TEMP .EQ. ANOM) GO TO 1855
C
C     ILLEGAL  SPECIFICATION
C
      IL = -617
      GO TO 1291
 1851 CASE(136,ISUB) = 1
      IAXIC = 1
      GO TO 350
 1852 CASE(136,ISUB) = 2
      IF (TEMP .EQ. COSI) IAXIC = 1
      IF (TEMP .EQ. FLUI) IAXIF = 1
      GO TO 350
 1853 CASE(136,ISUB) = -2
      GO TO 1856
 1854 CASE(136,ISUB) = -1
      GO TO 1856
 1855 CASE(136,ISUB) = -30
      GO TO 350
 1856 TEMP = CORE(I1+1)
      IF (BIT64) CALL MVBITS (BLANK,0,32,TEMP,0)
      IF (TEMP .EQ. ANOM) CASE(136,ISUB) = CASE(136,ISUB)*10
      GO TO 350
C
C     HARMONIC SELECTOR
C
 1860 IK = 137
      TEMP = CORE(I1)
      IF (BIT64) CALL MVBITS (BLANK,0,32,TEMP,0)
      IF (TEMP .EQ.  ALL) GO TO 1861
      IF (TEMP .EQ. NONE) GO TO 1862
      CORE(I1) = CORE(I1) + 1
      GO TO 490
 1861 CORE(I1) = -1
      GO TO 1863
 1862 CASE(137,1)= 0
      CORE(I1  ) = 0
 1863 CORE(I1-1) = -1
      CORE(I1+1) = IEOR
      GO TO 491
C
C     RANDOM SET SELECTION
C
 1870 IK = 163
      GO TO 490
C
C     FMETHOD
C
 1880 IK = 165
      GO TO 490
C
C     GRID POINT FORCE REQUEST
C
 1890 IK = 167
      GO TO 830
C
C     ELEMENT STRAIN ENERGY
C
 1900 IK = 170
      GO TO 830
C
C     AEROFORCE OUTPUT REQUEST
C
 1910 IK = 176
      GO TO 830
C
C     AEROELASTIC GUST LOAD REQUEST
C
 1930 IK = 179
      GO TO 490
C
C     STRAIN CARD
C     (180 THRU 182 WORDS OF CASECC)
C
 1950 IK = 180
      GO TO 830
C
C     EOF ON INPUT UNIT
C
 2000 CALL IFP1D  (-624)
      CALL MESAGE (-37,0,NIFP)
      RETURN
      END

      SUBROUTINE LOCPT ( N,P, M,S,K,KS, EPS, LOC)
C
C     DETERMINES POSITION OF EACH OF N POINTS (P) RELATIVE TO SURFACE
C        BOUNDED BY M POINTS (S)
C        ALL POINTS IN THE SAME COORDINATE SYSTEM
C     KS IS THE (UNIT) VECTOR NORMAL TO THE SURFACE
C     LOC(I) IS FLAG INDICATING POSITION OF POINT I RELATIVE TO SURFACE:
C        LOC= 1    WHEN POINT WITHIN SURFACE BOUNDRY
C        LOC= 0    WHEN POINT IS ON SURFACE BOUNDRY
C        LOC= -1   WHEN POINT OUTSIDE SURFACE BOUNDRY
C
C     MAXIMUM OF 4 POINTS MAY BE LOCATED RELATIVE
C        TO SURFACE WITH MAXIMUM OF 4 SIDES
C        WHOSE ENDPOINTS ARE IN K(2,M)
C
      DOUBLE PRECISION P(3,4), S(3,4), KS(3)
      DOUBLE PRECISION VE(3,4), VP(3), V(3),VEMAG(4)
      DOUBLE PRECISION VMAG, VPMAG, VDOTK, EDOTP
      DOUBLE PRECISION DVMAG, DADOTB, EPS(2)
C
      INTEGER LOC(1), K(2,1)
C
C
C     EPS ARRAY FOR SIGNIFICANCE TESTING
C        EPS(1) IS AREA, ANGLE LIMIT
C        EPS(2) IS LENGTH LIMIT
C
C
C
C     SET UP VECTORS ALONG EACH SURFACE EDGE
C
      DO 20 NE=1,M
      K1= K(1,NE)
      K2= K(2,NE)
C
      DO 15 I=1,2
C     VE IS VECTOR ALONG SURFACE EDGE
   15 VE(I,NE)= S(I,K2) -S(I,K1)
      VE(3,NE)=0.D0
      VEMAG(NE)= DVMAG( VE(1,NE), EPS(2) )
   20 CONTINUE
C
C      DETERMINE LOCATION OF POINT RELATIVE TO SURFACE
C
      DO 40 NP= 1,N
C        (PRESET POINT FLAG TO INTERIOR CODE)
      LOC(NP)= 1
C
      DO 30 NE= 1,M
      K1= K(1,NE)
C
      DO 24  I=1,2
C     VP IS VECTOR FROM FIRST END OF EDGE VECTOR TO POINT
   24 VP(I)= P(I,NP) -S(I,K1)
      VP(3)= 0.D0
      VPMAG= DVMAG(VP,EPS(2))
C
C     V= VE CROSS VP
      CALL DAXB(VE(1,NE), VP,V)
      VMAG= DVMAG(V,EPS(1))
C     VDOTK= (VE CROSS VP) DOT K,  K NORMAL TO PLANE OF SURFACE
      VDOTK= DADOTB(V, KS)
C     EDOTP IS VE DOT VP
      EDOTP= DADOTB( VE(1,NE), VP)
      IF (VPMAG .LE. EPS(2) )    GO TO 37
      IF (VDOTK .GT. EPS(1))           GO TO 30
C                                      INSIDE THIS EDGE
      IF (         (VDOTK .LT. -EPS(1) )         .OR.
     1             (EDOTP .LE. EPS(1))           .OR.
     2             (VEMAG(NE) +EPS(2) .LT. VPMAG) )        GO TO 35
C                                                          OUTSIDE
                   GO TO 37
C                  ON THIS EDGE
   30 CONTINUE
C     POINT IS WITHIN SURFACE BOUNDRY IF NOT OUTSIDE ANY EDGE
C        AND NOT ON SURFACE BOUNDRY
      GO TO 40
C
C     POINT IS OUTSIDE SURFACE BOUNDRY IF OUTSIDE ANY EDGE
   35 LOC(NP)= -1
      GO TO 40
C
C
C     POINT IS ON BOUNDRY WHEN ANGLE IS EFFECTIVELY ZERO
C        OR (EFFECTIVELY) COINCIDENT WITH EDGE POINT
   37 LOC(NP)= 0
C
   40 CONTINUE
      RETURN
      END

      SUBROUTINE SDCMPS (ZI,ZR,ZD)
C
C     SDCMPS PERFORMS THE TRIANGULAR DECOMPOSITION OF A SYMMETRIC
C     MATRIX. THE REAL MATRIX INPUT MAY BE SINGLE OR DOUBLE PRECISION.
C     THE OUTPUT MATRICES HAVE POSITIVE DEFINATE CHECKS AND DIAGONAL
C     SINGULARITY CHECKS
C
C     IF SYSTEM(57) IS .GT.1 - USED FOR -CLOS-,
C                      .LT.0 - STOP AFTER PREPASS
C
      EXTERNAL          LSHIFT   ,ANDF     ,ORF
      LOGICAL SPILL    ,SPLOUT   ,SPLIN    ,ROWONE   ,OPNSCR   ,FIRST
      INTEGER ABLK     ,ANDF     ,ANY      ,BEGN     ,BBLK     ,BLK    ,
     1        BUF1     ,BUF2     ,BUF3     ,BUF4     ,BUF5     ,BUF6   ,
     2        C        ,CAVG     ,CHLSKY   ,CI       ,CLOS     ,CMAX   ,
     3        COL      ,C5MAX    ,DBA      ,DBC      ,DBL      ,END    ,
     4        DIAGCK   ,DIAGET   ,SYS60    ,HICORE   ,DBNAME(2)        ,
     5        EOR      ,FRSTPC   ,GROUPS   ,KEY(1)   ,ORF      ,ROW    ,
     6        PARM     ,PCAVG    ,PCGROU   ,PCMAX    ,PCROW    ,
     7        PCSQR    ,PDEFCK   ,POWER    ,PRC      ,PREC     ,PREVC  ,
     8        RC       ,RLCMPX
      INTEGER S        ,SAVG     ,SC       ,SCRA     ,SCRB     ,SCRC   ,
     1        SCRD     ,SCRDIA   ,SCRMSG   ,SCR1     ,SCR2     ,SCR3   ,
     2        SPFLG    ,SPROW    ,START    ,STATFL   ,STSCR    ,ZI(1)  ,
     3        SX       ,SYSBUF   ,SUBNAM(3),TYPEA    ,TWO24    ,TWO25  ,
     5        WA       ,WB       ,WORDS
      REAL    MINDS    ,SAVE(4)  ,ZR(1)    ,DDRR(2)
      DOUBLE PRECISION  DDIA     ,DDC      ,DDR      ,DMANT    ,DV     ,
     1        MINDD    ,PDEFD    ,ZD(1)
      CHARACTER*10      UNUSE    ,ADDI     ,UNADD
      CHARACTER         UFM*23   ,UWM*25   ,UIM*29   ,SFM*25
      COMMON /XMSSG /   UFM      ,UWM      ,UIM      ,SFM
      COMMON /MACHIN/   MACHX
      COMMON /LHPWX /   LHPW(6)  ,MTISA
      COMMON /SFACT /   DBA(7)   ,DBL(7)   ,DBC(7)   ,SCR1     ,SCR2   ,
     1                  LCORE    ,DDR      ,DDC      ,POWER    ,SCR3   ,
     2                  MINDD    ,CHLSKY
      COMMON /NTIME /   NITEMS   ,TMIO     ,TMBPAK   ,TMIPAK   ,TMPAK  ,
     1                  TMUPAK   ,TMGSTR   ,TMPSTR   ,TMT(4)   ,TML(4)
      COMMON /SYSTEM/   KSYSTM(100)
      COMMON /NAMES /   RDNRW    ,RDREW    ,WRT      ,WRTREW   ,REW
      COMMON /TYPE  /   PRC(2)   ,WORDS(4) ,RLCMPX(4)
      COMMON /ZZZZZZ/   XNS(1)
      COMMON /SDCOMX/   ROW      ,C        ,SPFLG    ,START    ,FRSTPC ,
     1                  LASTPL   ,LASTI    ,SC       ,IAC      ,NZZADR ,
     2                  WA       ,WB       ,PREVC    ,NZZZ     ,SPROW  ,
     3                  S        ,BLK(15)  ,ABLK(15) ,BBLK(20)
      COMMON /SDCQ  /   NERR(2)  ,NOGLEV   ,BUF6     ,SCRMSG   ,SCRDIA ,
     1                  STSCR    ,PDEFCK   ,DIAGCK   ,DIAGET   ,PREC   ,
     2                  PARM(4)  ,OPNSCR   ,FIRST
      COMMON /PACKX /   ITYPE1   ,ITYPE2   ,I1       ,J1       ,INCR1
      COMMON /UNPAKX/   ITYPE3   ,I2       ,J2       ,INCR2
      EQUIVALENCE       (NROW,DBA(3))  ,(TYPEA,DBA(5)) ,
     1                  (JSTR,BLK(5))  ,(COL  ,BLK(4)) ,(NTERMS,BLK(6)),
     2                  (ROW ,KEY(1))  ,(DSR   ,DDR  ) ,
     3                  (DSC,DDC)      ,(MINDS,MINDD ) ,(DDRR(1),RDIA ),
     4                  (DV,RV) ,(DMANT,RMANT),(DDIA,RDIA),(PDEFD,PDEFR)
      EQUIVALENCE       (KSYSTM( 1),SYSBUF) ,(KSYSTM( 2),NOUT) ,
     1                  (KSYSTM(31),HICORE) ,(KSYSTM(40),NBPW) ,
     2                  (KSYSTM(60),SYS60 )
      DATA    UNUSE  ,  ADDI  /'    UNUSED', 'ADDITIONAL' /
      DATA    SUBNAM /  4HSDCM,2HPS, 1H   /,
     1        NKEY   /  6 / ,BEGN/ 4HBEGN /,  END/ 4HEND  /,
     2        TWO24  /  16777216 /, TWO25 /   33554432    /
C
C     STATEMENT FUNCTIONS
C
      NBRWDS(I) = I + NWDS*(I*(I+1))/2
      SX(X)     = X - SQRT(AMAX1(X*(X+4.0)-CONS,0.0)) - 1.0
      MAXC(J)   = (SQRT(2.*FNWDS*FLOAT(J))-3.0)/FNWDS
C
C     VAX, UNIVAC, AND ALL WORKSTATIONS - OPEN CORE CAN BE INCREASED
C     LOCALLY FOR SDCOMP BY SYS60
C
      X = 1.0
      KORCHG = 0
      IF (SYS60.EQ.0 .OR. MACHX.EQ.2 .OR. NBPW.GT.36) GO TO 20
      KORCHG = SYS60 - HICORE
      IF (KORCHG .LE. 0) GO TO 20
      LCORE = LCORE + KORCHG
      WRITE  (NOUT,10) UIM,SYS60
   10 FORMAT (A29,' - OPEN CORE FOR SDCOMP IS INCREASED TO',I8,
     1       ' WORDS BY SYSTEM(60)',/)
   20 IF (LCORE .LE. 0) CALL MESAGE (-8,0,SUBNAM)
C
C     BUFFER ALLOCATION
C
      BUF1 = LCORE- SYSBUF
      BUF2 = BUF1 - SYSBUF
      BUF3 = BUF2 - SYSBUF
      BUF4 = BUF3 - SYSBUF
      BUF5 = BUF4 - SYSBUF
      BUF6 = BUF5 - SYSBUF
C
C     INITIALIZATION AS A FUNCTION OF TYPE OF A MATRIX
C     RC   = 1 IF A IS REAL (2 IF A IS COMPLEX - ILLEGAL)
C     PREC = 1 IF A IS SINGLE, 2 IF A IS DOUBLE
C
      RC    = RLCMPX(TYPEA)
      IF (RC .NE. 1) GO TO 1600
      STATFL= IABS(KSYSTM(57))
      PREC  = PRC(TYPEA)
      NWDS  = WORDS(TYPEA)
      FNWDS = NWDS
C
C     CHECK INPUT PARAMETERS
C
      IF (DBA(2) .NE. DBA(3)) GO TO 1600
      ICRQ = NROW + 200 - BUF6
      IF (ICRQ .GT. 0) GO TO 1850
C
C     INITIALIZE POSITIVE DEFINATE CHECKS.  FILES SET IN DRIVER
C
      PARM(1) = 0
      PARM(3) = SUBNAM(1)
      PARM(4) = SUBNAM(2)
      NERR(1) = 0
      NERR(2) = 0
      IF (PDEFCK .LT. 0) GO TO 50
      I = -DIAGET
      J = 1 - MTISA
      IF (PREC .EQ. 2) GO TO 30
      PDEFR = 2.0E0**I
      RMANT = 2.0E0**J
      GO TO 50
   30 PDEFD = 2.0D0**I
      DMANT = 2.0D0**J
      GO TO 50
   50 CONTINUE
C
C     STSCR IS STATUS OF -SCRDIA- FILE AT BUF6
C       0 = NOT OPEN
C       1 = READ
C       2 = WRITE
C
      STSCR = 2
      CALL GOPEN (SCRDIA,ZI(BUF6),WRTREW)
      SCRA = SCR3
      SCRB = IABS(DBC(1))
      NOGLEV = 0
      IF (NROW .EQ. 1) GO TO 1510
C
C     GENERAL INITIALIZATION
C
      LOOP  = 1
      ISPILL= BUF6 - MAX0(100,NROW/100)
      FCMAX = 0.
   60 ISPILL= ISPILL - (LOOP-1)*NROW/100
      NSPILL= ISPILL
      KROW  = NROW + 1
      ICRQ  = (3-LOOP)*NROW/100 - ISPILL
      IF (ISPILL .LE. 0) GO TO 1850
      ZI(ISPILL) = 0
      PCGROU= 0
      PCAVG = 0
      PCSQR = 0
      PCMAX = 0
      CSQR  = 0.0
      SAVG  = 0
      CLOS  = ALOG(FLOAT(NROW)) + 5.0
      IF (STATFL .GT. 1) CLOS = STATFL
      PCROW = -CLOS
      ZI(1) = -NROW
      DO 70 I = 2,NROW
   70 ZI(I) = 0
      CALL FNAME (DBA,DBNAME)
      POWER = 0
      SPILL = .FALSE.
      GROUPS= 0
      CONS  = 2*ISPILL/NWDS
      C5MAX = MAXC(ISPILL)
      DSR   = 1.0
      DSC   = 0.
      MINDS = 1.E+25
      IF (PREC .EQ. 1) GO TO 80
      DDR   = 1.0D0
      DDC   = 0.D0
      MINDD = 1.D+25
   80 CONTINUE
      CAVG  = 0
      CMAX  = 0
      CSPILL= 0.0
C
C     THE FOLLOWING CODE GENERATES THE ACTIVE COLUMN VECTOR FOR EACH
C     ROW, SPILL GROUPS AND TIMING AND USER INFORMATION ABOUT THE
C     DECOMPOSITION
C
      BLK(1)  = DBA(1)
      ABLK(1) = SCRA
      ABLK(2) = TYPEA
      ABLK(3) = 0
      CALL GOPEN (DBA ,ZI(BUF1),RDREW )
      CALL GOPEN (SCRA,ZI(BUF2),WRTREW)
      ROW = 1
      JJ  = 0
      EOR = 1
C
C     LSTDIA DETERMINES THE LAST DIAGONAL WRITTEN TO SCRATCH FILE
C
      LSTDIA = 0
C
C     BEGIN A ROW BY LOCATING THE DIAGONAL ELEMENT
C
   90 BLK(8) = -1
C
C     ANY DETERMINES IF ANY STRINGS SKIPPED PRIOR TO DIAGONAL
C     AND -KK- ALLOWS STRING BEYOND ZERO DIAGONAL TO BE SAVED
C
      ANY = 0
      KR  = KROW
  100 CALL GETSTR (*110,BLK)
      IF (PREC .EQ. 2) JSTR = 2*(JSTR-1) + 1
      KK  = NTERMS
      ANY = COL
      IF (COL.GT.ROW) GO TO 130
      KK  = 0
      IF (COL+NTERMS-1 .GE. ROW) GO TO 140
      CALL ENDGET (BLK)
      GO TO 100
C
C     NULL COLUMN FOUND.  SAVE COLUMN ID AND SET NOGLEV
C
  110 KK = -1
      IF (ANY .NE. 0) GO TO 130
      IF (LSTDIA .LT. ROW) CALL SDCMQ (*710,1,0.,0.,0.D0,0.D0,ROW,ZI)
  120 IF (BLK(8) .NE. 1) CALL FWDREC (*1680,BLK)
      ROW = ROW + 1
      IF (ROW .LE. NROW) GO TO 90
      GO TO 710
C
C     ZERO DIAGONAL FOUND.  FILL CORE AND POINTERS
C
  130 COL = ROW
      ZI(KR  ) = COL
      ZI(KR+1) = 1
      ZI(KR+2) = 0
      IF (NWDS .EQ. 2) ZI(KR+3) = 0
      KR = KR + 2 + NWDS
      NTERMS = NWDS
      IF (LSTDIA .GE. ROW) GO TO 140
      DDIA = 0.0D0
      CALL SDCMQ (*710,7,0.,0.,0.D0,0.D0,ROW,ZI)
      IF (NOGLEV .GT. 1) GO TO 120
      CALL WRITE (SCRDIA,RDIA,NWDS,EOR)
      LSTDIA = ROW
      GO TO 180
C
C     DIAGONAL TERM IS LOCATED -- COMPLETE ENTRIES IN THE FULL COLUMN
C     VECTOR AND SAVE THE TERMS FROM EACH STRING IN CORE
C
  140 CONTINUE
      JSTR = JSTR + (ROW-COL)*NWDS
      IF (LSTDIA .GE. ROW) GO TO 150
      RDIA = XNS(JSTR)
      IF (PREC .EQ. 2) DDRR(2) = XNS(JSTR+1)
      IF (NOGLEV .LE. 1) CALL WRITE (SCRDIA,RDIA,NWDS,EOR)
      LSTDIA = ROW
  150 CONTINUE
      NTERMS = NTERMS - (ROW-COL)
      COL = ROW
  160 ZI(KR  ) = COL
      ZI(KR+1) = NTERMS
      KR = KR + 2
      NSTR = JSTR + NTERMS*NWDS - 1
      DO 170 JJ = JSTR,NSTR
      ZR(KR) = XNS(JJ)
      KR = KR + 1
  170 CONTINUE
  180 CONTINUE
      N = COL + NTERMS - 1
      DO 240 J = COL,N
      IF (ZI(J)) 190,200,230
  190 M = IABS(ZI(J))
      ZI(J) = ROW
      IF (M .NE. 1) ZI(J+1) = -(M-1)
      GO TO 240
  200 I = J
  210 I = I - 1
      IF (I .LE. 0) GO TO 1610
      IF (ZI(I)) 220,210,1620
  220 M = IABS(ZI(I))
      ZI(I) = -(J-I)
      ZI(J) = ROW
      LEFT  = M - (J-I+1)
      IF (LEFT .GT. 0) ZI(J+1) = -LEFT
      GO TO 240
  230 IF (ZI(J).GT.ROW .AND. ZI(J).LT.TWO24) ZI(J) = ZI(J) +TWO24 +TWO25
  240 CONTINUE
      ICRQ = KR - ISPILL
      IF (KR .GE. ISPILL) GO TO 700
C
C     CHECK IF ZERO DIAGONAL WAS JUST PROCESSED
C
      IF (KK) 270,250,260
  250 CALL ENDGET (BLK)
      CALL GETSTR (*280,BLK)
      IF (PREC .EQ. 2) JSTR = 2*JSTR - 1
      GO TO 160
  260 COL = ANY
      NTERMS = KK
      KK = 0
      GO TO 140
C
C     EXTRACT ACTIVE COLUMN VECTOR FROM THE FULL COLUMN VECTOR
C
  270 IF (BLK(8) .NE. 1) CALL FWDREC (*1680,BLK)
  280 IAC = KR
      I = IAC
      J = ROW
      LASTPL = -1
  290 IF (ZI(J)) 360,1630,300
  300 IF (ZI(J)-ROW) 310,320,350
  310 ZI(I) = J
      GO TO 330
  320 ZI(I) = -J
      IF (LASTPL .LT. 0) LASTPL = I - IAC
  330 I = I + 1
  340 J = J + 1
      GO TO 370
  350 IF (ZI(J) .LT. TWO24) GO TO 340
      IF (ZI(J) .LT. TWO25) GO TO 310
      ZI(J) = ZI(J) - TWO25
      GO TO 320
  360 J = J - ZI(J)
  370 IF (J .LE. NROW) GO TO 290
      ICRQ = I - ISPILL
      IF (I .GT. ISPILL) GO TO 700
      C = I - IAC
      CMAX = MAX0(CMAX,C)
      NAC = IAC + C - 1
      IF (LASTPL .LT. 0) LASTPL = C
C
C     MAKE SPILL CALCULATIONS
C
      SPFLG = 0
      FC    = C
      START = 2
      IF (C .EQ. 1) START = 0
      FRSTPC = 0
      IF (.NOT. SPILL) GO TO 490
      IF (ROW .LT. LSTROW) GO TO 410
C
C *3* CURRENT ROW IS LAST ROW OF A SPILL GROUP. DETERMINE IF ANOTHER
C     SPILL GROUP FOLLOWS AND, IF SO, ITS RANGE
C
  400 CONTINUE
      START = 0
      IF (C .GT. C5MAX) GO TO 500
      SPILL = .FALSE.
      GO TO 540
C
C *2* CURRENT ROW IS NEITHER FIRST NOR LAST IN CURRENT SPILL GROUP.
C     TEST FOR PASSIVE COL CONDITION. IF SO, TERMINATE SPILL GROUP.
C     TEST FOR POSSIBLE REDEFINITION OF SPILL GROUP. IF SO, TEST FOR
C     OVERFLOW OF REDEFINITION TABLE,  IF SO, TRY A DIFFERENT STRATEGY
C     FOR DEFINING S AND REDO PREFACE UP TO A LIMIT OF 3 TIMES.
C
  410 CONTINUE
      IF (IABS(ZI(IAC+1))-ROW .LT. CLOS) GO TO 420
      ASSIGN 550 TO ISWTCH
      LSTROW= ROW
      SPILL = .FALSE.
      START = 0
      IF (NSPILL+2 .LT. BUF6) GO TO 470
      GO TO 450
  420 ASSIGN 580 TO ISWTCH
      IF (C .LE. ZI(SPROW)) GO TO 580
      JJ = NAC
  430 IF (IABS(ZI(JJ)) .LE. LSTROW) GO TO 440
      JJ = JJ - 1
      GO TO 430
  440 SC = JJ - IAC
      M  = SX(FC)
      IF (SC .LE. M) GO TO 580
      IF (NSPILL+2 .LT. BUF6) GO TO 460
  450 CONTINUE
      FCMAX = AMAX1(FCMAX,FLOAT(CMAX))
      CALL CLOSE (SCRA,REW)
      CALL CLOSE (DBA ,REW)
      LOOP = LOOP + 1
      IF (LOOP .LE. 3) GO TO 60
      ICRQ = BUF6 - NSPILL - 3
      GO TO 1850
  460 S = M
      IJKL = MAX0(IAC,JJ - (SC-M))
      LSTROW = IABS(ZI(IJKL))
  470 IF (ZI(NSPILL).NE.0 .AND. ZI(NSPILL).NE.SPROW) NSPILL = NSPILL + 3
      ZI(NSPILL  ) = SPROW
      ZI(NSPILL+1) = S
      ZI(NSPILL+2) = LSTROW
      IF (ROW-LSTROW) 480,400,1670
  480 CONTINUE
      GO TO ISWTCH, (550,580)
C
C *1* CURRENT ROW IS NOT PART OF A SPILL GROUP. TEST FOR
C     CREATION OF A NEW SPILL GROUP
C
  490 CONTINUE
      IF (C .LE. C5MAX) GO TO 540
  500 SPILL = .TRUE.
      SPROW = ROW
      GROUPS= GROUPS + 1
      S = MIN0(SX(FC),NROW-SPROW)
      IF (LOOP .EQ. 1) GO TO 530
      JJ = IAC + S - 1
  510 IF (IABS(ZI(JJ)) .LE. SPROW+S) GO TO 520
      JJ = JJ - 1
      GO TO 510
  520 S = JJ - IAC + 1
      IF (LOOP .EQ. 3) S = MIN0(S,SX(FCMAX))
  530 S = MIN0(S,NROW-SPROW)
      LSTROW = IABS(ZI(IAC+S-1))
      SPFLG  = S
      FRSTPC = LSTROW
      SAVG   = SAVG + S
      GO TO 580
C
C     TEST FOR CONDITION IN WHICH PASSIVE COLUMNS ARE CREATED
C
  540 COL = IABS(ZI(IAC+1))
      IF (ROW-PCROW.LT.CLOS .OR. C.LT.CLOS/2 .OR. COL-ROW.LT.CLOS)
     1    GO TO 580
C
C     CREATE PASSIVE COLUMNS BY CHANGING THEIR FIRST
C     APPEARANCE IN THE FULL COLUMN VECTOR
C
  550 FRSTPC= 2
      PCROW = ROW
      PCAVG = PCAVG + C - 1
      PCSQR = PCSQR + (C-1)**2
      PCMAX = MAX0(PCMAX,C-1)
      PCGROU= PCGROU + 1
      NAC   = IAC + C - 1
      IJKL  = IAC + 1
      DO 570 I = IJKL,NAC
      JJ = IABS(ZI(I))
      IF (ZI(JJ) .LE. ROW) GO TO 560
      ZI(JJ) = MIN0(ANDF(ZI(JJ),TWO24-1),COL)
      GO TO 570
  560 ZI(JJ) = COL
  570 CONTINUE
C
C     WRITE ACTIVE COLUMN VECTOR
C
  580 IF (NOGLEV .GT. 1) GO TO 630
      CALL WRITE (SCRA,KEY,NKEY,0)
      CALL WRITE (SCRA,ZI(IAC),C,1)
C
C     WRITE ROW OF INPUT MATRIX. -IAC- POINTS TO END OF OUTPUT
C
      ABLK(8)  = -1
      ABLK(12) = ROW
      KR = KROW
  590 ABLK(4)= ZI(KR)
      NBRSTR = ZI(KR+1)
      KR = KR + 2
  600 CALL PUTSTR (ABLK)
      ABLK(7) = MIN0(ABLK(6),NBRSTR)
      JSTR = ABLK(5)
      IF (PREC .EQ. 2) JSTR = 2*JSTR - 1
      NSTR = JSTR + ABLK(7)*NWDS - 1
      DO 610 JJ = JSTR,NSTR
      XNS(JJ) = ZR(KR)
      KR = KR + 1
  610 CONTINUE
      IF (KR .GE. IAC) GO TO 620
      CALL ENDPUT (ABLK)
      IF (ABLK(7) .EQ. NBRSTR) GO TO 590
      ABLK(4) = ABLK(4) + ABLK(7)
      NBRSTR  = NBRSTR  - ABLK(7)
      GO TO 600
  620 ABLK(8) = 1
      CALL ENDPUT (ABLK)
C
C     ACCUMULATE TIMING AND STATISTICS INFORMATION
C
  630 CAVG = CAVG + C
      CSQR = CSQR + C**2
      IF (SPILL) CSPILL = CSPILL + C**2
      ZI(ROW) = C
      IF (ROW .EQ. NROW) GO TO 710
      ROW = ROW + 1
      GO TO 90
C
C     HERE WHEN ALL ROWS PROCESSED -- CLOSE FILES AND, IF SINGULAR
C     MATRIX, PRINT SINGULAR COLUMNS AND GIVE ALTERNATE RETURN
C
  700 PARM(1) = -8
      PARM(2) = ICRQ
      NOGLEV  = 2
  710 CALL CLOSE (SCRA,REW)
      CALL CLOSE (DBA ,REW)
      CALL CLOSE (SCRDIA,REW)
C
C     CALCULATE TIME ESTIMATE, PRINT USER INFORMATION AND
C     CHECK FOR SUFFICIENT TIME TO COMPLETE DECOMPOSITION
C
      IF (GROUPS .NE. 0) SAVG = SAVG/GROUPS
      SAVG    = MAX0(SAVG,1)
      SAVE(1) = 0.5*TMT(TYPEA)*CSQR*1.0E-6
      SAVE(2) = 0.5*(TMPSTR+TMGSTR)*FLOAT(PCSQR)*1.E-6
      SAVE(3) = TMPSTR*FLOAT(CAVG)*1.E-6
      SAVE(4) = TMIO*(FNWDS+1.0)*CSPILL/FLOAT(SAVG)*1.0E-6
      MORCOR  = NBRWDS(CMAX) - ISPILL + 1
C
      CAVG = CAVG/NROW
      IF (PCGROU .NE. 0) PCAVG = PCAVG/PCGROU
      CALL TMTOGO (IJKL)
      JKLM = SAVE(1) + SAVE(2) + SAVE(3) + SAVE(4) + 1.0
C
      IF (DBC(1) .GT. 0) CALL PAGE2 (9)
      UNADD = UNUSE
      IF (MORCOR .GT. 0) UNADD = ADDI
      IF (DBC(1) .GT. 0) WRITE (NOUT,720)  UIM,   DBNAME,   NROW,
     1                      JKLM,   CAVG,  PCAVG, GROUPS,   SAVG,
     2        UNADD,      MORCOR,   CMAX,  PCMAX, PCGROU,   LOOP
  720 FORMAT (A29,' 3023 - PARAMETERS FOR SYMMETRIC DECOMPOSITION OF ',
     1       'DATA BLOCK ',2A4,6H ( N = , I5, 2H ) , /
     2  14X, 17H  TIME ESTIMATE = , I7, 17H          C AVG = , I6,
     3       17H         PC AVG = , I6,18H    SPILL GROUPS = , I6,
     4       17H          S AVG = , I6, /
     5  14X, A10 ,      7H CORE = , I7, 17H WORDS    C MAX = , I6,
     6       17H          PCMAX = , I6,18H       PC GROUPS = , I6,
     7       17H  PREFACE LOOPS = , I6  )
      IF (MORCOR .GT. 0) WRITE (NOUT,730)
  730 FORMAT (15X,'(FOR OPTIMIZED OPERATION)')
      IF (DBC(1) .GT. 0) WRITE (NOUT,740) UIM,SUBNAM(1),SUBNAM(2),SAVE
  740 FORMAT (A29,' 2378,',A4,A3,' ESTIMATE OF CPU TIME FOR MT =',
     1        1P,E10.3,/18X,'PASSIVE COL. = ',E10.3,14X,'ACTIVE COL. =',
     2        E10.3, /25X,'SPILL = ',E10.3)
C
C     ESTIMATE FBS TIME AT ONE PASS, 1 LOAD
C
      SAVE(1) = 2.0*FLOAT(NROW)*CAVG*(TMT(TYPEA)+TMPSTR)*1.E-6
      IF (DBC(1) .GT. 0) WRITE (NOUT,750) SAVE(1)
  750 FORMAT (10X,41HESTIMATE FOR FBS, ONE PASS AND ONE LOAD =,1P,E10.3)
C
      IF (JKLM .GE. IJKL) GO TO 1840
      IF (NOGLEV .GT.  1) GO TO 1880
      IF (KSYSTM(57) .LT. 0) GO TO 1880
C
C     WRITE A END-OF-MATRIX STRING ON THE PASSIVE COLUMN FILE
C
      CALL GOPEN (SCRB,ZI(BUF2),WRTREW)
      BBLK(1) = SCRB
      BBLK(2) = TYPEA
      BBLK(3) = 0
      BBLK(8) = -1
      CALL PUTSTR (BBLK)
      BBLK(4) = NROW + 1
      BBLK(7) = 1
      BBLK(8) = 1
      CALL ENDPUT (BBLK)
      CALL CLOSE (SCRB,REW)
      SUBNAM(3) = BEGN
      CALL CONMSG (SUBNAM,3,0)
C
C     THE STAGE IS SET AT LAST TO PERFORM THE DECOMPOSITION -
C     SO LETS GET THE SHOW UNDERWAY
C
      CALL GOPEN (SCRA,ZI(BUF1),RDREW )
      CALL GOPEN (SCRB,ZI(BUF2),RDREW )
      CALL GOPEN (DBL ,ZI(BUF3),WRTREW)
      CALL GOPEN (SCRDIA,ZI(BUF6),RDREW)
      STSCR = 1
      SCRC  = SCR1
      SCRD  = SCR2
      IF (ZI(NSPILL) .NE. 0) NSPILL = NSPILL + 3
      ZI(NSPILL) = NROW + 1
      SPLIN  = .FALSE.
      SPLOUT = .FALSE.
      SPILL  = .FALSE.
      IF (GROUPS .NE. 0) SPILL = .TRUE.
      NZZZ   = ORF(ISPILL-1,1)
      ROWONE = .FALSE.
      DBL(2) = 0
      DBL(6) = 0
      DBL(7) = LSHIFT(1,NBPW-2 - (NBPW-32))
C
C     THIS 'NEXT TO SIGN' BIT WILL BE PICKED UP BY WRTTRL. ADD (NBPW-32)
C     SO THAT CRAY, WITH 48-BIT INTEGER, WILL NOT GET INTO TROUBLE
C
      BLK(1) = DBL(1)
      BLK(2) = TYPEA
      BLK(3) = 1
      WA     = NZZZ
      WB     = WA
      PREVC  = 0
      BBLK(8)= -1
      CALL GETSTR (*1690,BBLK)
      KSPILL = ISPILL
C
C     READ KEY WORDS AND ACTIVE COLUMN VECTOR FOR CURRENT ROW
C
  800 NAME = SCRA
      IF (SPLIN) NAME = SCRD
      CALL FREAD (NAME,KEY,NKEY,0)
      IAC = C*NWDS + 1
      CALL FREAD (NAME,ZI(IAC),C,1)
      NAC = IAC + C - 1
      IF (ZI(IAC) .LT. 0) PREVC = 0
      IF (SPLIN) GO TO 840
C
C     READ TERMS FROM THE INPUT MATRIX
C
      CALL FREAD (SCRDIA,RDIA,NWDS,EOR)
      ABLK(8) = -1
      CALL GETSTR (*1860,ABLK)
      N = IAC - 1
      DO 810 I = 1,N
      ZR(I) = 0.
  810 CONTINUE
      CALL SDCINS (*1830,ABLK,ZI(IAC),C,ZR,ZD)
C
C     IF DEFINED, MERGE ROW FROM PASSIVE COLUMN FILE
C
  820 IF (ROW-BBLK(4)) 850,830,1700
  830 CALL SDCINS (*1830,BBLK,ZI(IAC),C,ZR,ZD)
      BBLK(8) = -1
      CALL GETSTR (*1710,BBLK)
      GO TO 820
C
C     READ CURRENT PIVOT ROW FROM SPILL FILE. IF LAST ROW, CLOSE FILE
C
  840 PREVC = 0
      CALL FREAD (SCRD,ZR,C*NWDS,1)
      IF (ROW .LT. LSTSPL) GO TO 850
      CALL CLOSE (SCRD,REW)
C
C     IF 1ST ROW OF A NEW SPILL GROUP, OPEN SCRATCH FILE TO WRITE
C
  850 IF (ROWONE) GO TO 880
      IF (SPLOUT) GO TO 950
      IF (SPFLG .EQ. 0) GO TO 950
      SPLOUT = .TRUE.
      CALL GOPEN (SCRC,ZI(BUF4),WRTREW)
      SPROW = ROW
      S = SPFLG
      LSTROW = FRSTPC
      FRSTPC = 0
C
C     IF S WAS REDEFINED, GET NEW DEFINITION
C
      DO 860 I = KSPILL,NSPILL,3
      IF (ROW-ZI(I)) 860,870,880
  860 CONTINUE
      GO TO 880
  870 S = ZI(I+1)
      LSTROW = ZI(I+2)
      KSPILL = I + 3
C
C     WRITE ANY TERMS ALREADY CALCULATED WHICH ARE
C     BEYOND THE RANGE OF THE CURRENT SPILL GROUP
C
  880 IF (.NOT. SPLOUT) GO TO 950
      N = 0
      IJKL = NAC
  890 IF (IABS(ZI(IJKL)) .LE. LSTROW) GO TO 900
      IJKL = IJKL - 1
      GO TO 890
  900 IJKL = IJKL + 1
      IF (IJKL .GT. NAC) GO TO 920
      DO 910 I = IJKL,NAC
      IF (ZI(I) .GT. 0.) N = N + 1
  910 CONTINUE
      N = NWDS*N*(N+1)/2
  920 CALL WRITE (SCRC,N,1,0)
      CALL WRITE (SCRC,ZR(NZZZ-N),N,1)
C
C     MOVE WA TO ACCOUNT FOR ANY TERMS JUST WRITTEN
C
      IF (N .EQ. 0) GO TO 950
      J = NZZZ
      I = NZZZ - N
      IF ((NZZZ-WA) .EQ. N) GO TO 940
  930 J = J - 1
      I = I - 1
      ZR(J) = ZR(I)
      IF (I .GT. WA) GO TO 930
  940 WA = J
C
C     IF THE PIVOTAL ROW DID NOT COME FROM THE SPILL FILE, IT IS CREATED
C
  950 IF (SPLIN) GO TO 1180
      I = IAC
      L = WA
      IF (PREC  .EQ. 2) L = (WA-1)/2 + 1
      IF (TYPEA .EQ. 2) GO TO 1060
C
C     CREATE PIVOT ROW IN RSP, ACCUMULATE DETERMINANT AND MIN DIAGONAL
C
      IF (ZI(IAC) .LT. 0) GO TO 980
      DO 970 J = 1,C
      IF (ZI(I) .LT. 0) GO TO 960
      ZR(J) = ZR(J) + ZR(L)
      L = L + 1
  960 I = I + 1
  970 CONTINUE
  980 CONTINUE
C
C     CHECK DIAGONAL AND CORRECT
C
      IF (ZR(1) .EQ. 0.0) CALL SDCMQ (*1870,2,RDIA,ZR(1),0,0,ROW,ZI)
  990 IF (ABS(DSR) .LT. 10.) GO TO 1000
      DSR   = DSR/10.
      POWER = POWER + 1
      GO TO 990
 1000 IF (ABS(DSR) .GT. 0.1) GO TO 1010
      DSR   = DSR*10.
      POWER = POWER - 1
      GO TO 1000
 1010 DSR   = DSR*ZR(1)
      MINDS = AMIN1(ZR(1),MINDS)
C
C     PERFORM MATRIX COND. CHECKS - S.P. REAL
C
      IF (ZR(1)) 1020,1030,1050
 1020 I = 3
      GO TO 1040
 1030 I = 2
 1040 CALL SDCMQ (*1870,I,RDIA,ZR(1),0,0,ROW,ZI)
C
 1050 IF (DIAGCK .LT. 0) GO TO 1170
      IF (RDIA .EQ. 0.0) RDIA = ZR(1)
      IF (RDIA .EQ. ZR(1)) GO TO 1170
      RV = ABS(ZR(1)/RDIA )
      IF (RV .GT. 1.001E0) CALL SDCMQ (*1870,6,RDIA,ZR(1),0,0,ROW,ZI)
      RV = RMANT/RV
      IF (RV .GT. PDEFR) CALL SDCMQ (*1870,4,RDIA,ZR(1),0,0,ROW,ZI)
      GO TO 1170
C
C     CREATE PIVOT ROW IN RDP, ACCUMULATE DETERMINANT AND MIN DIAGONAL
C
 1060 CONTINUE
      IF (ZI(IAC) .LT. 0) GO TO 1090
      DO 1080 J = 1,C
      IF (ZI(I) .LT. 0) GO TO 1070
      ZD(J) = ZD(J) + ZD(L)
      L = L + 1
 1070 I = I + 1
 1080 CONTINUE
 1090 CONTINUE
C
C     CHECK DIAGONAL AND CORRECT
C
      IF (ZD(1) .EQ. 0.0D0) CALL SDCMQ (*1870,2,0,0,DDIA,ZD(1),ROW,ZI)
 1100 IF (DABS(DDR) .LT. 10.0D0) GO TO 1110
      DDR   = DDR/10.D0
      POWER = POWER + 1
      GO TO 1100
 1110 IF (DABS(DDR) .GT. 0.1D0) GO TO 1120
      DDR   = DDR*10.D0
      POWER = POWER - 1
      GO TO 1110
 1120 DDR   = DDR*ZD(1)
      MINDD = DMIN1(ZD(1),MINDD)
C
C     PERFORM MATRIX COND. CHECKS - D.P. REAL
C
      IF (ZD(1)) 1130,1140,1160
 1130 I = 3
       GO TO 1150
 1140 I = 2
 1150 CALL SDCMQ (*1870,I,0,0,DDIA,ZD(1),ROW,ZI)
C
 1160 IF (DIAGCK .LT.   0) GO TO 1170
      IF (DDIA .EQ. 0.0D0) DDIA = ZD(1)
      IF (DDIA .EQ. 0.0D0) GO TO 1170
      DV = DABS(ZD(1)/DDIA)
      IF (DV .GT. 1.001D0) CALL SDCMQ (*1870,6,0,0,DDIA,ZD(1),ROW,ZI)
      DV = DMANT/DV
      IF (DV .GT. PDEFD) CALL SDCMQ (*1870,4,0,0,DDIA,ZD(1),ROW,ZI)
C
C     CALCULATE WB
C
 1170 CONTINUE
 1180 LASTI = 1
      IF (START .EQ. 0) GO TO 1260
      IF (SPLIN ) GO TO 1190
      IF (SPLOUT) GO TO 1200
      CI = C
      SC = C
      GO TO 1230
 1190 CI = C - (START-2)
      SC = CI
      JJ = NAC
      IF (SPLOUT) GO TO 1210
      IF (CI .GT. C5MAX) GO TO 1720
      GO TO 1230
 1200 CI = C
      SC = LSTROW - SPROW
      JJ = MIN0(NAC,IAC+START+SC-2)
 1210 IF (IABS(ZI(JJ)) .LE. LSTROW) GO TO 1220
      JJ = JJ - 1
      GO TO 1210
 1220 SC = JJ - IAC - START + 2
      IF (SC .GT. 0) GO TO 1230
      SC = 0
      WB = WA
      GO TO 1240
 1230 NTERMS = SC*(CI-1) - (SC*(SC-1))/2
      NWORDS = NTERMS*NWDS
      WB = NZZZ - NWORDS
      IF (PREC .EQ. 2) WB = ORF(WB-1,1)
      IF (WB .LT. IAC+C) GO TO 1660
      IF (WB .GT. WA+NWDS*PREVC) GO TO 1730
 1240 CONTINUE
      IF (SPLIN .AND. ROW.EQ.LSTSPL) SPLIN = .FALSE.
      LASTI = MIN0(START+SC-1,C)
      IF (SC .EQ. 0) GO TO 1260
C
C     NOW CALCULATE CONTIBUTIONS FROM CURRENT PIVOT ROW TO
C     SECOND TERM IN EQUATION (4) IN MEMO CWM-19. NOTE-TERMS ARE
C     CALCULATED ONLY FOR ROW/COL COMBINATIONS IN THE CURRENT SPILL
C     GROUP
C
      IF (TYPEA .EQ. 2) GO TO 1250
      CALL SDCOM1 (ZI,ZI(IAC),ZR(WA+PREVC),ZR(WB))
      GO TO 1260
 1250 CALL SDCOM2 (ZI,ZI(IAC),ZR(WA+2*PREVC),ZR(WB))
C
C     SHIP PIVOT ROW OUT TO EITHER MATRIX OR SPILL FILE
C
 1260 IF (LASTI .EQ. C) GO TO 1300
      IF (.NOT. SPLOUT) GO TO 1640
C
C     PIVOT ROW GOES TO SPILL FILE - SET INDEX WHERE TO BEGIN NEXT AND
C                                    WRITE ROW AND ACTIVE COLUMN VECTOR
C
      IJKL  = SPFLG
      II    = FRSTPC
      SPFLG = 0
      FRSTPC= 0
      START = LASTI + 1
      CALL WRITE (SCRC,KEY,NKEY, 0)
      CALL WRITE (SCRC,ZI(IAC),C,1)
      CALL WRITE (SCRC,ZR,C*NWDS,1)
      IF (ROW .LT. LSTROW) GO TO 1410
C
C     LAST ROW OF CURRENT SPILL GROUP - REWIND FILE AND OPEN IT TO READ.
C                                      IF ANOTHER SPILL GROUP, SET IT UP
C
      CALL CLOSE (SCRC,REW)
      JKLM = SCRC
      SCRC = SCRD
      SCRD = JKLM
      CALL GOPEN (SCRD,ZI(BUF5),RDREW)
      LSTSPL = ROW
      SPLIN  = .TRUE.
      SPLOUT = .FALSE.
      IF (IJKL .EQ. 0) GO TO 1290
      SPLOUT = .TRUE.
      SPROW  = ROW
      S      = IJKL
      LSTROW = II
      CALL GOPEN (SCRC,ZI(BUF4),WRTREW)
C
C     IF S WAS REDEFINED, GET NEW DEFINITION
C
      DO 1270 I = KSPILL,NSPILL,3
      IF (ROW-ZI(I)) 1270,1280,1290
 1270 CONTINUE
      GO TO 1290
 1280 S = ZI(I+1)
      LSTROW = ZI(I+2)
      KSPILL = I + 3
C
C     READ ANY TERMS SAVED FROM PREVIOUS SPILL GROUP
C
 1290 IF (ROW .EQ. NROW) GO TO 1500
      CALL FREAD (SCRD,N,1,0)
      WA = NZZZ - N
      CALL FREAD (SCRD,ZR(WA),N,1)
      ROWONE = .TRUE.
      GO TO 800
C
C     PIVOT ROW GOES TO OUTPUT FILE - IF REQUIRED, CONVERT TO CHOLESKY
C
 1300 IF (ROW .NE. DBL(2)+1) GO TO 1650
      IF (CHLSKY .EQ. 0) GO TO 1340
      IF (PREC   .EQ. 2) GO TO 1320
      IF (ZR(1) .LT. 0.) CALL SDCMQ (*1870,3,RDIA,ZR(1),0,0,ROW,ZI)
      ZR(1) = SQRT(ZR(1))
      IF (C .EQ. 1) GO TO 1340
      DO 1310 I = 2,C
      ZR(I) = ZR(I)*ZR(1)
 1310 CONTINUE
      GO TO 1340
 1320 IF (ZD(1) .LT. 0.0D0) CALL SDCMQ (*1870,3,0,0,DDIA,ZD(1),ROW,ZI)
      ZD(1) = DSQRT(ZD(1))
      IF (C .EQ. 1) GO TO 1340
      DO 1330 I = 2,C
      ZD(I) = ZD(I)*ZD(1)
 1330 CONTINUE
C
C     WRITE THE ROW WITH PUTSTR/ENDPUT
C
 1340 CALL SDCOUT (BLK,0,ZI(IAC),C,ZR,ZR)
C
C     IF ACTIVE COLUMNS ARE NOW GOING PASSIVE, MERGE ROWS IN CORE
C     WITH THOSE NOW ON THE PC FILE THUS CREATING A NEW PC FILE
C
      IF (FRSTPC .EQ. 0) GO TO 1400
      IF (SPLIN .OR. SPLOUT) GO TO 1740
      CALL GOPEN (SCRC,ZI(BUF4),WRTREW)
      BLK(1) = SCRC
      BLK(3) = 0
      IJKL   = IAC + 1
      DO 1370 I = IJKL,NAC
 1350 IF (IABS(ZI(I)) .LE. BBLK(4)) GO TO 1360
      CALL CPYSTR (BBLK,BLK,1,0)
      BBLK(8) = -1
      CALL GETSTR (*1750,BBLK)
      GO TO 1350
 1360 CI = NAC - I + 1
      CALL SDCOUT (BLK,0,ZI(I),CI,ZR(WB),ZR(WB))
      WB = WB + CI*NWDS
 1370 CONTINUE
      ICRQ = WB - ISPILL
      IF (WB .GT. ISPILL) GO TO 1850
 1380 CALL CPYSTR (BBLK,BLK,1,0)
      IF (BBLK(4) .EQ. NROW+1) GO TO 1390
      BBLK(8) = -1
      CALL GETSTR (*1760,BBLK)
      GO TO 1380
 1390 CALL CLOSE (SCRB,REW)
      CALL CLOSE (SCRC,REW)
      I    = SCRB
      SCRB = SCRC
      SCRC = I
      CALL GOPEN (SCRB,ZI(BUF2),RDREW)
      BBLK(1) = SCRB
      BBLK(8) = -1
      CALL GETSTR (*1770,BBLK)
      BLK(1) = DBL(1)
      BLK(3) = 1
C
C     ACCUMULATE MCB INFORMATION FOR PIVOT ROW
C
 1400 CONTINUE
      NWORDS = C*NWDS
      DBL(2) = DBL(2) + 1
      DBL(6) = MAX0(DBL(6),NWORDS)
      DBL(7) = DBL(7) + NWORDS
C
C     PREPARE TO PROCESS NEXT ROW.
C
 1410 IF (ROW .EQ. NROW) GO TO 1500
      PREVC = C - 1
      ROWONE= .FALSE.
      WA    = WB
      GO TO 800
C
C     CLOSE FILES AND PUT END MESSAGE IN RUN LOG.
C
 1500 SUBNAM(3) = END
      CALL CONMSG (SUBNAM,3,0)
      GO TO 1870
C
C     DECOMPOSE A 1X1 MATRIX
C
 1510 ITYPE1= TYPEA
      ITYPE2= TYPEA
      ITYPE3= TYPEA
      POWER = 0
      I1    = 1
      J1    = 1
      I2    = 1
      J2    = 1
      INCR1 = 1
      INCR2 = 1
      CALL GOPEN (DBA,ZI(BUF1),RDREW)
      PARM(2) = DBA(1)
      CALL UNPACK (*1570,DBA,ZR)
      CALL CLOSE (DBA,REW)
      CALL GOPEN (DBL,ZI(BUF1),WRTREW)
      DBL(2) = 0
      DBL(6) = 0
      IF (TYPEA.EQ.2) GO TO 1520
      MINDS = ZR(1)
      DSR   = ZR(1)
      IF (ZR(1)) 1530,1540,1560
 1520 MINDD = ZD(1)
      DDR   = ZD(1)
      IF (ZD(1)) 1530,1540,1560
C
 1530 I = 3
      GO TO 1550
 1540 I = 2
 1550 CALL SDCMQ (*1870,I,ZR,ZR,ZD,ZD,1,ZI)
 1560 CALL PACK (ZR,DBL,DBL)
      CALL CLOSE (DBL,REW)
      GO TO 1880
C
C     1X1 NULL COLUMN
C
 1570 CALL SDCMQ (*1870,1,0.,0.,0.D0,0.D0,1,ZI)
      GO TO 1870
C
C     VARIOUS ERRORS LAND HERE
C
 1600 CALL MESAGE (-7,DBA(2),SUBNAM)
 1610 KERR = 1045
      GO TO  1800
 1620 KERR = 1046
      GO TO  1800
 1630 KERR = 1051
      GO TO  1800
 1640 KERR = 1311
      GO TO  1800
 1650 KERR = 1320
      GO TO  1800
 1660 KERR = 1288
      GO TO  1800
 1670 KERR = 1065
      GO TO  1800
 1680 KERR = 1034
      GO TO  1800
 1690 KERR = 1204
      GO TO  1800
 1700 KERR = 1215
      GO TO  1800
 1710 KERR = 1216
      GO TO  1800
 1720 KERR = 1288
      GO TO  1800
 1730 KERR = 1289
      GO TO  1800
 1740 KERR = 1330
      GO TO  1800
 1750 KERR = 1333
      GO TO  1800
 1760 KERR = 1340
      GO TO  1800
 1770 KERR = 1344
      GO TO  1800
 1800 WRITE  (NOUT,1810) SFM,KERR
 1810 FORMAT (A25,' 2379, LOGIC ERROR',I6,' IN SDCMPS.')
      J = 66
      WRITE  (NOUT,1820) (KEY(I),I=1,J)
 1820 FORMAT (36H0   CONTENTS OF / SDCOMX / FOLLOW --, /,(1X,10I12))
 1830 PARM(1) = -37
      PARM(2) = 0
      PARM(3) = SUBNAM(1)
      PARM(4) = SUBNAM(2)
      GO TO 1870
C
C     INSUFFICIENT TIME
C
 1840 PARM(1) = -50
      PARM(2) = IJKL
      GO TO 1870
C
C     INSUFFICIENT CORE
C
 1850 PARM(1) = -8
      PARM(2) = ICRQ
      GO TO 1870
C
C     UNEXPECTED NULL COLUMN
C
 1860 DV = 0.0
      CALL SDCMQ (*1870,5,RV,RV,DV,DV,ROW,ZI)
C
 1870 CALL CLOSE (DBA, REW)
      CALL CLOSE (SCRA,REW)
      CALL CLOSE (SCRB,REW)
      CALL CLOSE (DBL ,REW)
 1880 CALL CLOSE (SCRDIA,REW)
      IF (NERR(1)+NERR(2) .LE. 0) GO TO 1890
      CALL GOPEN (SCRMSG,ZI(BUF6),WRT)
      BBLK(2) = 0
      BBLK(3) = 0
      BBLK(4) = 0
      CALL WRITE (SCRMSG,BBLK(2),3,1)
      CALL CLOSE (SCRMSG,REW)
 1890 CONTINUE
      IF (KORCHG .GT. 0) LCORE = LCORE - KORCHG
      RETURN
      END

      SUBROUTINE GP2
C
C     GP2 BUILDS THE ELEMENT CONNECTION TABLE (ECT).
C     STRUCTURAL ELEMENT CONNECTION CARDS ARE ON GEOM2.
C     EACH EXTERNAL GRID PT. NO. IS CONVERTED TO AN INTERNAL INDEX.
C     IN ADDITION, GENERAL ELEMENT CARDS ARE READ AND
C     EXTERNAL GRID NUMBERS ARE CONVERTED TO INTERNAL NUMBERS.
C
C
      INTEGER         ELEM  ,SYSBUF,BUF1  ,BUF2  ,EQEXIN,RD    ,RDREW ,
     1                WRT   ,WRTREW,CLSREW,CLS   ,ECT   ,GEOMP ,B     ,
     2                FILE  ,Z     ,GENEL ,GEOM2 ,RET   ,RET1  ,GP2H  ,
     3                CBAR  ,CBEAM ,BUF3  ,TWO
      DIMENSION       B(34) ,GP2H(2)      ,MCB(7)       ,GENEL(2)
      COMMON /BLANK / NOECT
      COMMON /ZZZZZZ/ Z(1)
      COMMON /GPTA1 / NELEM ,LAST  ,INCR  ,ELEM(1)
      COMMON /SYSTEM/ SYSBUF,JUNK(36)     ,IAXIF ,NBPC  ,NBPW
      COMMON /NAMES / RD    ,RDREW ,WRT   ,WRTREW,CLSREW,CLS
      COMMON /SETUP / NFILE(6)
      COMMON /TWO   / TWO(32)
      EQUIVALENCE     (GEOMP,GEOM2)
C
C     INPUT  DATA FILES
      DATA   GEOM2,EQEXIN / 101,102 /
C
C     OUTPUT DATA FILES
      DATA   ECT / 201 /
C
C     MISC   DATA
      DATA   GP2H/ 4HGP2 ,4H    /, CBAR / 4HBAR /, CBEAM / 4HBEAM /
C
C     GENEL DATA CARDS PROCESSED BY GP2 IN ADDITION TO ELEMENTS.
      DATA  GENEL / 4301, 43 /
C
C
C     PERFORM GENERAL INITIALIZATION
C
      CALL DELSET
      BUF1  = KORSZ(Z) - SYSBUF - 2
      BUF2  = BUF1 - SYSBUF
      NOECT = -1
      BUF3  = BUF2 - SYSBUF
      MCB(1)= GEOM2
      CALL RDTRL (MCB)
C
C     READ EQEXIN INTO CORE
C
      FILE = EQEXIN
      CALL OPEN (*580,EQEXIN,Z(BUF1),RDREW)
      CALL FWDREC (*590,EQEXIN)
      CALL READ (*590,*30,EQEXIN,Z,BUF2,1,N)
      CALL MESAGE (-8,0,GP2H)
   30 CALL CLOSE (EQEXIN,CLSREW)
      KN = N/2
      N1 = N + 1
C
C     OPEN GEOM2. IF PURGED, RETURN.
C     OTHERWISE, OPEN ECT AND WRITE HEADER RECORD.
C
      NOGEO2 = 0
      CALL PRELOC (*50,Z(BUF1),GEOM2)
      NOGEO2 = 1
      GO TO 60
   50 RETURN
C
   60 NOECT = 1
      NOGO  = 0
      FILE  = ECT
      CALL OPEN (*580,ECT,Z(BUF2),WRTREW)
      CALL FNAME (ECT,B)
      CALL WRITE (ECT,B,2,1)
C
C     READ 3-WORD ID FROM GEOM2. SEARCH ELEMENT TABLE FOR MATCH.
C     IF FOUND, BRANCH TO ELEMENT CODE. IF NOT FOUND, SEARCH GENEL
C     TABLE  FOR MATCH. IF FOUND BRANCH TO APPROPRIATE CODE. IF NOT
C     FOUND, SKIP RECORD AND CONTINUE.
C
   70 CALL READ (*460,*600,GEOM2,B,3,0,FLAG)
      DO 80 I = 1,LAST,INCR
      IF (ELEM(I+3) .EQ. B(1)) GO TO 120
   80 CONTINUE
      IF (GENEL(1) .EQ. B(1)) GO TO 110
      CALL FWDREC (*460,GEOM2)
      GO TO 70
  110 K = (I+1)/2
      GO TO 280
C
C     WRITE 3-WORD ID ON ECT. READ ALL CARDS FOR ELEMENT AND
C     CONVERT EXTERNAL GRID NOS. TO INTERNAL NOS.  WRITE ENTRIES ON ECT
C     DIRECTLY AFTER CONVERSION.
C
  120 ASSIGN 170 TO RET
      ASSIGN 630 TO RET1
      CALL WRITE (ECT,B,3,0)
      M  = ELEM(I+5)
      LX = ELEM(I+12)
      MM = LX + ELEM(I+9)
      NAME = ELEM(I)
      II   = N1
      FILE = GEOM2
  150 CALL READ (*590,*270,FILE,B,M,0,FLAG)
C
C     CHECK LATER TO SEE IF RESTRICTION APPLIES TO AXIF PROBLEMS
C
      IF (IAXIF .NE. 0) GO TO 155
      IF (NBPW.LE.32 .AND. B(1).GT.16777215) GO TO 670
C                                  16777215 = 2**24 - 1
  155 L = LX
  160 IF (B(L) .NE. 0) GO TO 470
  170 L= L + 1
      IF (L    .LT.    MM) GO TO 160
      IF (NAME .EQ. CBEAM) GO TO 180
      IF (NAME .NE.  CBAR) GO TO 200
C
C     SPECIAL PROCESSING FOR BAR AND BEAM ELEMENTS
C
      IF (B(8) .EQ. 1) GO TO 200
      ASSIGN 190 TO RET
      L = 5
      GO TO 470
  180 IF (B(8) .EQ. 0) GO TO 200
      ASSIGN 190 TO RET
      L = 8
      GO TO 470
  190 ASSIGN 170 TO RET
C
  200 CALL WRITE (ECT,B,M,0)
      GO TO 150
C
C     CURRENT ELEMENT IS COMPLETE
C
  270 CALL WRITE (ECT,0,0,1)
      GO TO 70
C
C     GENERAL ELEMENTS-- WRITE 3-WORD ID ON ECT. READ ALL GENELS,
C     CONVERT EXTERNAL GRID NOS. TO INTERNAL NOS. AND WRITE THEM ON ECT.
C
  280 CALL WRITE (ECT,B,3,0)
      FILE = GEOM2
      L = 2
      ASSIGN 310 TO RET
      ASSIGN 640 TO RET1
  290 IJK = 0
      CALL READ (*590,*360,GEOM2,B,1,0,FLAG)
      CALL WRITE (ECT,B,1,0)
  300 CALL READ (*590,*600,GEOM2,B(2),2,0,FLAG)
      IF (B(2) .EQ. -1) GO TO 320
      GO TO 470
  310 CALL WRITE (ECT,B(2),2,0)
      GO TO 300
  320 NUD = B(3)
      IF (IJK .NE. 0) GO TO 330
      NUI = B(3)
      IJK = 1
      GO TO 310
  330 CALL WRITE (ECT,B(2),2,0)
      CALL READ (*590,*600,GEOM2,IJK1,1,0,FLAG)
      CALL WRITE (ECT,IJK1,1,0)
      NCORE = BUF2 - N1
      NZ = (NUI*(NUI+1))/2
      NREAD = 0
  340 N= MIN0(NCORE,NZ-NREAD)
      CALL READ (*590,*600,GEOM2,Z(N1),N,0,FLAG)
      CALL WRITE (ECT,Z(N1),N,0)
      NREAD = NREAD + N
      IF (NREAD .LT. NZ) GO TO 340
      CALL READ (*590,*600,GEOM2,IJK,1,0,FLAG)
      CALL WRITE (ECT,IJK,1,0)
      IF (IJK .EQ. 0) GO TO 290
      NS = NUI*NUD
      NREAD = 0
  350 N= MIN0(NCORE,NS-NREAD)
      CALL READ (*590,*600,GEOM2,Z(N1),N,0,FLAG)
      CALL WRITE (ECT,Z(N1),N,0)
      NREAD = NREAD + N
      IF (NREAD .LT. NS) GO TO 350
      GO TO 290
  360 CALL WRITE (ECT,0,0,1)
      GO TO 70
C
C     CLOSE FILES, WRITE TRAILER AND RETURN.
C
  460 CALL CLOSE (GEOM2,CLSREW)
      CALL CLOSE (ECT  ,CLSREW)
      MCB(1) = GEOM2
      CALL RDTRL (MCB)
      MCB(1) = ECT
      CALL WRTTRL (MCB)
      IF (NOGO .NE. 0) CALL MESAGE (-61,0,0)
      RETURN
C
C
C     INTERNAL BINARY SEARCH ROUTINE
C     ==============================
C
  470 KLO = 1
      KHI = KN
      IGRID = B(L)
  480 K = (KLO+KHI+1)/2
  490 IF (IGRID-Z(2*K-1)) 500,560,510
  500 KHI = K
      GO TO 520
  510 KLO = K
  520 IF (KHI-KLO-1) 570,530,480
  530 IF (K .EQ. KLO) GO TO 540
      K = KLO
      GO TO 550
  540 K = KHI
  550 KLO = KHI
      GO TO 490
  560 B(L) = Z(2*K)
      GO TO RET,  (170,310,190)
  570 GO TO RET1, (630,640)
C
C
C     FATAL ERROR MESSAGES
C
  580 J = -1
      GO TO 610
  590 J = -2
      GO TO 610
  600 J = -3
  610 CALL MESAGE (J,FILE,GP2H)
  630 K = 7
      GO TO 660
  640 K = 61
  660 B(2) = IGRID
      CALL MESAGE (30,K,B)
      NOGO = 1
      GO TO RET, (170,310)
  670 NOGO = 1
      CALL MESAGE (30,138,B)
      GO TO 155
      END

      SUBROUTINE PCOORD (PEN)
C
C     PLOTS A COORDINATE TRIAD AT THE LOWER RIGHT CORNER OF A STRUCTURAL
C     PLOT. THIS ROUTINE IS CALLED ONLY BY DRAW
C
C     WRITTEN BY G.CHAN/UNISYS      10/1990
C
      INTEGER         PEN,FPLTIT,SYM(2)
      COMMON /XXPARM/ IDUMM(215),FPLTIT
      COMMON /PLTDAT/ IDUM20(20),SIZE,IDUM2(2),CNTCHR(2)
      COMMON /DRWAXS/ G(3,4)
C
C
C     COMPUTE THE ORIGIN, WHICH IS A FUNCTION OF FRAME SIZE, CHARACTER
C     VERTICAL AND HORIZONTAL SCALES, PRESENCE OF PTITLE LINE, AND THE
C     OVERALL SIZE OF THE TRIAD
C
C     ALL THE NUMERIC MULTIPLIERS USED BELOW WERE WORKED OUT WITH FRAME
C     SIZE OF 1023.0. THEY SHOULD BE APPLICABLE TO FRAME SIZE OF 3000.
C
      X2 = 0.0
      Y2 = 0.0
      Y1 = 0.0
      DO 10 I = 1,3
      IF (G(2,I) .GT. X2) X2 = G(2,I)
      IF (G(3,I) .LT. Y2) Y2 = G(3,I)
      IF (G(3,I) .GT. Y1) Y1 = G(3,I)
   10 CONTINUE
      DE = 1.8*CNTCHR(1)
      SF = 2.7*CNTCHR(2)
      IF (FPLTIT .EQ. 0) SF = 1.3*SF
      SF = SF/(Y1-Y2)
      X1 = SIZE - X2*SF - DE
      Y1 = -Y2*SF
      IF (FPLTIT .NE. 0) Y1 = Y1 + 0.8*CNTCHR(2)
      EP = 0.0001
      OF = -1.
      IF (G(2,1).LE.EP .AND. G(2,2).LE.EP .AND. G(2,3).LE.EP) OF = +1.
      IF (OF .EQ. +1.) X1 = X1 - DE
C
C     DRAW THE X-Y-Z COORDINATE TRIAD
C     DRAW A CIRCLE AT THE ORIGIN IF ANY AXIS IS IN LINE WITH VIEWER
C
      SYM(1) = 6
      SYM(2) = 0
      DE = 0.8*CNTCHR(1)
      OF = 1.3*OF*CNTCHR(1)
      DO 30 I = 1,3
      X2 = G(2,I)*SF + X1
      Y2 = G(3,I)*SF + Y1
      CALL LINE (X1,Y1,X2,Y2,PEN,0)
      IF (ABS(G(2,I))+ABS(G(3,I)) .GE. EP) GO TO 20
      CALL SYMBOL (X1,Y1,SYM,0)
      CALL TIPE (X2+OF,Y2,1,G(I,4),1,0)
      GO TO 30
   20 IF (G(2,I) .GT. 0.0) CALL TIPE (X2+DE,Y2,1,G(I,4),1,0)
      IF (G(2,I) .LE. 0.0) CALL TIPE (X2-DE,Y2,1,G(I,4),1,0)
   30 CONTINUE
C
      RETURN
      END

      SUBROUTINE SHXTRS (NROW,NCOL,ARRAY)
C
C     TO EXTRAPOLATE VALUES IN ARRAY FROM A SET OF EVALUATION POINTS TO
C     THE GRID POINTS OF SPECIFIC SHELL ELEMENTS.
C     THE EXTRAPOLATION IS IN TWO DIMENSIONS.
C
C     INPUT :
C           NROW   - SIZE OF THE SET OF VALUES
C           NCOL   - NUMBER OF EVALUATION POINTS
C           ARRAY  - ARRAY OF DATA TO BE EXTRAPOLATED
C
C     OUTPUT:
C           ARRAY  - ARRAY OF EXTRAPOLATED DATA
C
C
      LOGICAL TRIA
      REAL    ARRAY(NROW,1),TEMP(4,4),SHP(4),TPOINT(2,3),QPOINT(2,4),
     1        XSI,ETA
C
C
C
      DATA    TPOINT  / 0.0,  0.0,  1.0,  0.0,  0.0,  1.0             /
      DATA    QPOINT  /-1.0, -1.0,  1.0, -1.0,  1.0,  1.0, -1.0,  1.0 /
C
C     INITIALIZE
C
      TRIA   = NCOL .EQ. 3
C
      DO 10 I = 1,NROW
      DO 10 J = 1,NCOL
      TEMP(I,J) = 0.0
   10 CONTINUE
C
C     BEGIN LOOP ON DESTINATION POINTS
C
      DO 70 I = 1,NCOL
C
C     EVALUATE PSEUDO-SHAPE FUNCTIONS
C
      IF (.NOT.TRIA) GO TO 30
C
      XSI    = TPOINT(1,I)
      ETA    = TPOINT(2,I)
      SHP(1) = 1.66666667 - 2.0*XSI - 2.0*ETA
      SHP(2) = 2.0*XSI - 0.33333333
      SHP(3) = 2.0*ETA - 0.33333333
      GO TO 40
C
   30 XSI    = QPOINT(1,I)
      ETA    = QPOINT(2,I)
      CONST  = 0.577350269
      SHP(1) = 0.75*(CONST-XSI)*(CONST-ETA)
      SHP(2) = 0.75*(CONST-XSI)*(CONST+ETA)
      SHP(3) = 0.75*(CONST+XSI)*(CONST-ETA)
      SHP(4) = 0.75*(CONST+XSI)*(CONST+ETA)
C
C     EXTRAPOLATE
C
   40 DO 50 J = 1,NROW
      DO 50 K = 1,NCOL
      TEMP(J,I) = TEMP(J,I) + SHP(K)*ARRAY(J,K)
   50 CONTINUE
C
   70 CONTINUE
C
C     COPY THE EXTRAPOLATED DATA BACK INTO ARRAY
C
      DO 90 J = 1,NCOL
      DO 90 I = 1,NROW
      ARRAY(I,J) = TEMP(I,J)
   90 CONTINUE
C
      RETURN
      END

      SUBROUTINE DETCK (JARG,IFGPST,NPVT)
C
C     COMMENTS FROM G.CHAN/UNISYS, 5/1991,
C     THIS ROUTINE WAS NAMED DETCKX BEFORE, WHICH HAD NOT BEEN TESTED.
C     THE ONE THAT USED TO BE DETCK APPEARS TO BE AN OLDER VERSION, AND
C     SHOULD BE REPLACED BY THIS ONE, IF THIS ONE WORKS
C
C     THIS ROUTINE GENERATES THE GRID POINT SINGULARITY TABLE BY
C     EXAMINING THE TRANSLATIONAL AND DIAGONAL 3 X 3 SUBMATRICES OF THE
C     KGG MATRIX.
C     IF JARG = 0, THE PIVOT POINT HAS ELEMENTS ATTACHED TO IT.
C     IF JARG =-1, THE PIVOT IS A SCALAR POINT AND NO ELEMENTS ARE
C                  CONNECTED TO IT.
C     IF JARG = 1, THE PIVOT POINT IS A GRID POINT AND NO ELEMENTS ARE
C                  CONNECTED TO IT.
C
      INTEGER          TNWDS,IARRAY(8),IZ(1),BACK,NAME(2)
      DOUBLE PRECISION D,B,DZ,FL,R,M,TEMP,FM,FR,DET,CONST,DTOL
      COMMON /MA1XX /  D(18),B(9),DZ(1),FL(3),R(3),M(3)
      COMMON /SYSTEM/  ISYS(69),TOLEL
      EQUIVALENCE      (IZ(1),DZ(1)),(IARRAY(1),IORDER),(IARRAY(2),NWDS)
      DATA    NAME  /  4HDETC,4HK   /,  NEOR  / 0 /
C
      DTOL = TOLEL
      IARG = JARG
      IF (IARG) 10,20,25
   10 IORDER = 1
      NWDS   = 1
      IARRAY(3) = NPVT
      CALL WRITE (IFGPST,IARRAY(1),3,NEOR)
      RETURN
C
C     AT THIS POINT, BOTH TRANSLATIONAL AND ROTATIONAL DIAGONAL 3X3 S
C     ARE STORED IN THE D ARRAY.  HENCE WE PROCESS THEM.
C
   20 CONTINUE
   25 CONTINUE
      IP = NPVT - 1
      ASSIGN 450 TO IGOTO
      IF (IARG .NE. 1) GO TO 30
      ASSIGN 425 TO BACK
      GO TO 425
   30 ASSIGN 50 TO BACK
      DO 40 I = 1,9
   40 B(I) = D(I)
      GO TO 90
   50 DO 60 I = 1,9
   60 B(I) = D(I+9)
C
C     INSURE THE SYMMETRY OF THE B MATRIX
C
      IF (B(2).NE.0.0D0 .AND. B(4).NE.0.0D0) GO TO 65
      B(2) = 0.0D0
      B(4) = 0.0D0
      GO TO 70
   65 TEMP = (B(2) + B(4))/2.0D0
      B(2) = TEMP
      B(4) = TEMP
   70 IF (B(3).NE.0.0D0 .AND. B(7).NE.0.0D0) GO TO 75
      B(3) = 0.0D0
      B(7) = 0.0D0
      GO TO 80
   75 TEMP = (B(3) + B(7))/2.0D0
      B(3) = TEMP
      B(7) = TEMP
   80 IF (B(6).NE.0.0D0 .AND. B(8).NE.0.0D0) GO TO 85
      B(6) = 0.0D0
      B(8) = 0.0D0
      GO TO 90
   85 TEMP = (B(6) + B(8))/2.0D0
C
C     SCALE THE MATRIX BY DIVIDING EACH ELEMENT OF B BY THE LARGEST
C     ELEMENT. IF THE LARGEST ELEMENT IS NON-POSITIVE, THE SINGULARITY
C     IS OF ORDER 3.
C
   90 TEMP = B(1)
      DO 100 I = 2,9
      IF (B(I) .GT. TEMP) TEMP = B(I)
  100 CONTINUE
      IF (TEMP .LE. 0.0D0) GO TO 425
      DO 110 I = 1,9
  110 B(I) = B(I)/TEMP
C
C     FIND THE SQUARES OF THE MAGNITUDES OF THE VECTORS OF THE ROWS OF
C     THE B MATRIX.
C
      IORDER = 0
      J = 0
      DO 120 I = 1,9,3
      J = J + 1
      FL(J) = B(I)**2 + B(I+1)**2 + B(I+2)**2
      IF (FL(J) .EQ. 0.0D0) IORDER = IORDER + 1
  120 CONTINUE
      IF (IORDER .EQ. 2)  GO TO 410
      IF (IORDER .EQ. 0)  GO TO 250
C
C     AT THIS POINT ONE AND ONLY ONE FL(I) IS ZERO.
C
      DO 130 I = 1,3
      ISAVE = I
      IF (FL(I) .EQ. 0. 0D0) GO TO (140,150,160), ISAVE
  130 CONTINUE
      CALL MESAGE (-30,26,NAME)
  140 FM = B(5)*B(9) - B(6)*B(8)
      FR = DSQRT((B(5)**2 + B(6)**2)*(B(8)**2 + B(9)**2))
      GO TO 170
  150 FM = B(1)*B(9) - B(3)*B(7)
      FR = DSQRT((B(1)**2 + B(3)**2)*(B(7)**2 + B(9)**2))
      GO TO 170
  160 FM = B(1)*B(5) - B(2)*B(4)
      FR = DSQRT((B(1)**2 + B(2)**2)*(B(4)**2 + B(5)**2))
  170 IF (FM .EQ. 0.0D0) GO TO 175
      IF (FR.LE.0.0D0 .OR. FM/FR.GE.DTOL) GO TO 240
C
C     HERE WE HAVE THAT THE ORDER OF THE SINGULARITY IS 2.
C
  175 IORDER = 2
      NWDS   = 0
      TNWDS  = 2
      GO TO (180,190,200), ISAVE
  180 K1   = 5
      K2   = 9
      INC1 = 1
      INC2 = 3
      INC3 = 2
      GO TO 210
  190 K1   = 1
      K2   = 9
      INC1 = 2
      INC2 = 3
      INC3 = 1
      GO TO 210
  200 K1   = 1
      K2   = 5
      INC1 = 3
      INC2 = 2
      INC3 = 1
  210 IF (B(K1).LE.0.0D0 .AND. B(K2).LE.0.0D0) GO TO 425
      IF (B(K1) .LE. 0.0D0) GO TO 220
      NWDS      = 2
      TNWDS     = 4
      IARRAY(3) = IP + INC1
      IARRAY(4) = IP + INC2
      IPOINT    = 5
      GO TO 230
  220 IPOINT = 3
  230 IF (B(K2) .LE. 0.0D0) GO TO 430
      NWDS  = NWDS  + 2
      TNWDS = TNWDS + 2
      IARRAY(IPOINT  ) = IP + INC1
      IARRAY(IPOINT+1) = IP + INC3
      GO TO 430
C
C     AT THIS POINT WE HAVE THAT ONE AND ONLY ONE FL IS ZERO BUT THAT
C     ORDER OF THE SINGULARITY IS 1.
C
  240 IORDER    = 1
      NWDS      = 1
      TNWDS     = 3
      IARRAY(3) = IP + ISAVE
      GO TO 430
C
C     AT STATEMENT NO. 250, WE HAVE THAT ALL THE FL(I) ARE .GT. 0.0D0,
C     SO THAT THE DETERMINANT, DET, OF B MUST BE COMPUTED.
C
  250 DET = B(1)*(B(5)*B(9) - B(6)*B(8)) - B(2)*(B(4)*B(9) - B(6)*B(7))
     1    + B(3)*(B(4)*B(8) - B(5)*B(7))
      CONST = 0.05D0*DTOL*FL(1)*FL(2)*FL(3)
      IF (DET .GT. CONST) GO TO 440
C
C     COMPUTE M(I) AND R(I)
C
      M(1) = B(5)*B(9) - B(6)*B(8)
      M(2) = B(1)*B(9) - B(3)*B(7)
      M(3) = B(1)*B(5) - B(2)*B(4)
      R(1) = DSQRT(B(5)**2 + B(6)**2) * DSQRT(B(8)**2 + B(9)**2)
      R(2) = DSQRT(B(1)**2 + B(3)**2) * DSQRT(B(7)**2 + B(9)**2)
      R(3) = DSQRT(B(1)**2 + B(2)**2) * DSQRT(B(4)**2 + B(5)**2)
C
C     FIND I1, J1, K1
C     SUCH THAT M(I1)/R(I1) .GE. M(J1)/R(J1) .GE. M(K1)/R(K1)
C
      I1 = 1
      J1 = 2
      K1 = 3
      IF (M(1)*R(2) .GE. M(2)*R(1)) GO TO 270
      I1 = 2
      J1 = 1
  270 IF (M(I1)*R(K1) .GE. M(K1)*R(I1)) GO TO 280
      ITEMP = I1
      I1    = K1
      K1    = ITEMP
  280 IF (M(J1)*R(K1) .GE. M(K1)*R(J1)) GO TO 290
      ITEMP = J1
      J1    = K1
      K1    = ITEMP
  290 IF (M(I1) .GE. R(I1)*DTOL) GO TO 400
C
C     HERE THE SINGULARITY IS OF ORDER 2.
C
      NWDS   = 0
      TNWDS  = 2
      IORDER = 2
C
C     FIND II, JJ, KK SUCH THAT B(II) .GE. B(JJ) .GE. B(KK)
C
      II = 1
      JJ = 5
      KK = 9
      IF (B(1) .GE. B(5)) GO TO 300
      II = 5
      JJ = 1
  300 IF (B(II) .GE. B(KK)) GO TO 310
      ITEMP = II
      II    = KK
      KK    = ITEMP
  310 IF (B(JJ) .GE. B(KK)) GO TO 320
      ITEMP = JJ
      JJ    = KK
      KK    = ITEMP
  320 LL    = II
      KOUNT = 0
      IPOINT= 3
  330 IF (B(LL) .LE. 0.0D0) GO TO 430
      NWDS  = NWDS  + 2
      TNWDS = TNWDS + 2
      IF (LL - 5) 340,350,360
  340 INC1 = 2
      INC2 = 3
      GO TO 370
  350 INC1 = 1
      INC2 = 3
      GO TO 370
  360 INC1 = 1
      INC2 = 2
  370 IARRAY(IPOINT  ) = IP + INC1
      IARRAY(IPOINT+1) = IP + INC2
      IPOINT = IPOINT + 2
      KOUNT  = KOUNT  + 1
      IF (KOUNT - 2) 380,390,430
  380 LL = JJ
      GO TO 330
  390 LL = KK
      GO TO 330
C
C     AT THIS POINT THE SINGULARITY IS OF ORDER 1.
C
  400 IORDER = 1
      NWDS   = 1
      TNWDS  = 3
      IARRAY(3) = IP + I1
      IF (M(J1) .LT. R(J1)*DTOL) GO TO 430
      NWDS  = 2
      TNWDS = 4
      IARRAY(4) = IP + J1
      IF (M(K1) .LT. R(K1)*DTOL) GO TO 430
      NWDS  = 3
      TNWDS = 5
      IARRAY(5) = IP + K1
      GO TO 430
C
C     AT THIS POINT 2 ROWS OF THE B MATRIX ARE IDENTICALLY ZERO.
C
  410 NWDS   = 2
      TNWDS  = 4
      IPOINT = 2
      DO 420 I = 1,3
      IF (FL(I) .NE. 0.0D0) GO TO 420
      IPOINT = IPOINT + 1
      IARRAY(IPOINT) = IP + I
  420 CONTINUE
      GO TO 430
C
C     THE SINGULARITY IS OF ORDER 3
C
  425 IORDER = 3
      NWDS   = 3
      TNWDS  = 5
      IARRAY(3) = IP + 1
      IARRAY(4) = IP + 2
      IARRAY(5) = IP + 3
C
C     WRITE IARRAY ON THE GPST FILE.
C
  430 CALL WRITE (IFGPST,IARRAY(1),TNWDS,NEOR)
  440 GO TO IGOTO, (450,460)
  450 ASSIGN 460 TO IGOTO
      IP = IP + 3
      GO TO BACK, (50,425)
  460 CONTINUE
      RETURN
      END

      SUBROUTINE CMCONT
C
C     THIS ROUTINE DEFINES THE CONNECTION ENTRIES IN TERMS OF IP
C     NUMBERS.
C
      EXTERNAL        LSHIFT,RSHIFT,ANDF
      LOGICAL         ODD
      INTEGER         SCSFIL,SCMCON,BUF3,BUF4,OFILE,SCR1,SCR2,BUF1,BUF2,
     1                SCORE,ISTRT(100),ILEN(100),II(9),IO(9),ANDF,
     2                RSHIFT,DOF(6),IP(6),AAA(2),SCCONN,COMBO,OUTT
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /CMB001/ SCR1,SCR2,SCBDAT,SCSFIL,SCCONN,SCMCON,SCTOC,
     1                GEOM4,CASECC
      COMMON /CMB002/ BUF1,BUF2,BUF3,BUF4,BUF5,SCORE,LCORE,INPT,OUTT
      COMMON /CMB003/ COMBO(7,5),CONSET,IAUTO,TOLER,NPSUB
      COMMON /CMBFND/ INAM(2),IERR
      COMMON /BLANK / STEP,IDRY
      COMMON /ZZZZZZ/ Z(1)
      DATA    AAA   / 4HCMCO,4HNT   /
C
      ICOR  = SCORE
      ICLEN = LCORE
      MFILE = SCSFIL
      CALL OPEN (*200,SCSFIL,Z(BUF3),0)
      OFILE = SCR2
      IFILE = SCR1
      NWD   = 2 + NPSUB
      ODD   = .FALSE.
C
      DO 120 I = 1,NPSUB
      ODD   = .NOT.ODD
      NCSUB = COMBO(I,5)
C
C     READ IN EQSS FOR ITH PSEUDO-STRUCTURE
C
      MFILE = IFILE
      CALL OPEN (*200,IFILE,Z(BUF1),0)
      MFILE = OFILE
      CALL OPEN (*200,OFILE,Z(BUF2),1)
C
C     MOVE TO FIRST COMPONENT EQSS
C
      DO 20 J = 1,NCSUB
      MFILE = SCSFIL
      CALL READ (*210,*10,SCSFIL,Z(SCORE),LCORE,1,NNN)
      GO TO 220
   10 ISTRT(J) = SCORE
      ILEN(J)  = NNN
      SCORE = SCORE + NNN
      LCORE = LCORE - NNN
   20 CONTINUE
      CALL SKPFIL (SCSFIL,1)
C
C     CONNECTION ENTRIES IN TERMS OF GRID POINT ID ARE ON SCR1
C     IN THE FORM...
C        C/CC/G1/G2/G3/G4/G5/G6/G7
C
C     READ CONNECTION ENTRY..
C
      MFILE = IFILE
   30 CALL READ (*110,*40,IFILE,II,10,1,NNN)
   40 CONTINUE
      ICOMP = II(2+I)/1000000
      IGRID = II(2+I) - 1000000*ICOMP
      IF (IGRID .EQ. 0) GO TO 100
C
C     THE ABOVE RETRIEVED THE ORIGINAL GRID PT. NO., NOW FIND OUT
C     IF IT HAS SEVERAL IP NO.
C
      IF (ILEN(ICOMP) .EQ. 0) GO TO 50
      CALL GRIDIP (IGRID,ISTRT(ICOMP),ILEN(ICOMP),IP,DOF,NIP,Z,NNN )
      IF (IERR .NE. 1) GO TO 70
   50 IDRY = -2
      WRITE  (OUTT,60) UFM,IGRID,COMBO(I,1),COMBO(I,2),ICOMP
   60 FORMAT (A23,' 6535, A MANUAL CONNECTION SPECIFIES GRID ID ',I8,
     1       ' OF PSEUDOSTRUCTURE ',2A4, /30X,
     2       'COMPONENT STRUCTURE,I4,22H WHICH DOES NOT EXIST.')
      GO TO 30
   70 DO 90 J = 1,NIP
      II2 = RSHIFT(DOF(J),26)
      II2 = LSHIFT(II2,26)
      DOF(J) = DOF(J) - II2
      IO(1)  = ANDF(II(1),DOF(J))
      IF (IO(1) .EQ. 0) GO TO 90
      IO(2) = II(2)
      DO 80 JJ = 1,NWD
      IO(2+JJ) = II(2+JJ)
   80 CONTINUE
      IO(2+I) = IP(J)
      CALL WRITE (OFILE,IO,NWD,1)
   90 CONTINUE
      GO TO 30
  100 CALL WRITE (OFILE,II,NWD,1)
      GO TO 30
  110 CALL CLOSE (IFILE,1)
      IF (I .EQ. NPSUB ) CALL CLOSE (OFILE,2)
      IF (I .LT. NPSUB ) CALL CLOSE (OFILE,1)
      ISAVE = IFILE
      IFILE = OFILE
      OFILE = ISAVE
  120 CONTINUE
      SCCONN = SCR1
      IF (ODD) SCCONN = SCR2
      IF (SCCONN .EQ. SCR1) SCR1 = 305
      IF (SCCONN .EQ. SCR2) SCR2 = 305
      SCORE = ICOR
      LCORE = ICLEN
      CALL CLOSE (SCSFIL,1)
      RETURN
C
  200 IMSG = -1
      GO TO 230
  210 IMSG = -2
      GO TO 230
  220 IMSG = -8
  230 CALL MESAGE (IMSG,MFILE,AAA)
      RETURN
      END

      SUBROUTINE MATVC2 (Y,X,FILEA,BUF)
C
C     MATVC2 WILL FORM THE PRODUCT X = X + A*Y WHERE A IS A MATRIX
C     AND Y IS A VECTOR
C
C     THIS ROUTINE IS SUITABLE FOR DOUBLE PRECISION OPERATION
C
      INTEGER            FILEA(7)  ,SUB(2)   ,DIAG     ,RDP     ,EOL
      DOUBLE PRECISION   Y(1)      ,X(1)     ,A        ,DA
      DIMENSION          BUF(1)
      COMMON   /ZNTPKX/  A(2)      ,II       ,EOL
C     COMMON   /DESCRP/  LENGTH    ,MAJOR(1)
      COMMON   /NAMES /  RD        ,RDREW    ,WRT      ,WRTREW   ,
     1                   REW       ,NOREW    ,EOFNRW   ,RSP      ,
     2                   RDP       ,CSP      ,CDP      ,SQR      ,
     3                   RECT      ,DIAG     ,IWTRI    ,UPRTRI   ,
     4                   SYM       ,ROW      ,IDENTY
      COMMON   /TRDXX /  IDUM(27)  ,IOPEN
      EQUIVALENCE        (A(1),DA)
      DATA      SUB   /  4HMATV, 4HC2   /
C
      IF (FILEA(1) .EQ. 0) RETURN
      NCOL = FILEA(2)
      IF (FILEA(4) .EQ. IDENTY) GO TO 60
      IF (IOPEN .EQ. 1) GO TO 5
      CALL OPEN (*90,FILEA(1),BUF,RDREW)
    5 CALL FWDREC (*100,FILEA(1))
      IF (FILEA(4) .EQ. DIAG) GO TO 40
C
C     MATRIX IS FULL
C
      DO 30 I = 1,NCOL
      IF (Y(I) .EQ. 0.0D0) GO TO 20
      CALL INTPK (*30,FILEA(1),0,RDP,0)
   10 CALL ZNTPKI
      X(II) = DA*Y(I) + X(II)
      IF (EOL) 30,10,30
   20 CALL FWDREC (*100,FILEA(1))
   30 CONTINUE
      GO TO 80
C
C     MATRIX IS DIAGONAL
C
   40 CALL INTPK (*80,FILEA(1),0,RDP,0)
   50 CALL ZNTPKI
      X(II) = Y(II)*DA +X(II)
      IF (EOL) 80,50,80
C
C     MATRIX IS THE IDENTITY
C
   60 DO 70 I = 1,NCOL
   70 X(I) = Y(I) + X(I)
      RETURN
C
   80 CALL REWIND (FILEA(1))
      IF (IOPEN .EQ. 0) CALL CLOSE (FILEA(1),REW)
      RETURN
C
   90 NO = -1
      GO TO 110
  100 NO = -2
  110 CALL MESAGE (NO,FILEA(1),SUB(1))
      RETURN
      END

      INTEGER FUNCTION KHRFN2 (WORD,J,IZB)
C
C     CHARACTER FUNCTION KHRFN2 RECIEVES THE J-TH BYTE OF WORD
C     LEFT ADJUSTED IF J IS .GE. ZERO, OR RIGHT ADJUSTED IF J .LT. ZERO
C     ZERO FILL IF IZB IS ZERO, OTHERWISE, BLANK FILL
C
      INTEGER         WORD(1), BLANK
      COMMON /SYSTEM/ DUMMY(40), NCPW
      DATA    BLANK / 4H      /
C
      I  = 1
      KHRFN2 = BLANK
      IF (IZB .EQ. 0) KHRFN2 = 0
      IF (J   .LT. 0) I = NCPW
      IJ = IABS(J)
      KHRFN2 = KHRFN1(KHRFN2,I,WORD(1),IJ)
      RETURN
      END

      SUBROUTINE SSG1
C
      INTEGER         PG,SLT,BGPDT,CSTM,SIL,ECPT,MPT,GPTT,EDT,CASECC,
     1                CORE(166),SYSBUF,IWORD(4),MCB(7),SUBNAM(2)
      DIMENSION       PG(7),ILIST(360),ARY(1),DEFML(2),IDEFML(2),
     1                IARY(1),GVECT(1080)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /LOADX / LC,SLT,BGPDT,OLD,CSTM,SIL,ISIL,ECPT,MPT,GPTT,EDT,
     1                N(3),LODC,MASS,NOBLD,IDIT,DUM6(6)
      COMMON /BLANK / NROWSP,LOADNN
      COMMON /SYSTEM/ SYSBUF,IOTPE,DUM53(53),ITHERM
      COMMON /LOADS / NLOAD,IPTR
      COMMON /ZZZZZZ/ ICORE(1)
      EQUIVALENCE     (CORE(1),ICORE(1),IARY(1),ARY(1)),
     1                (DEFML(1),IDEFML(1))
      DATA    IWORD / 4,6,7,162/
      DATA    SUBNAM/ 4HSSG1,4H    /
C
C     MODIFY OPEN CORE POINTER IPTR FOR MAGNETICS PROBLEM
C
      IPTR  = MAX0(NROWSP,166)
      MCB(1)= 105
      CALL RDTRL (MCB(1))
      IF (MCB(1) .GT. 0) IPTR = MAX0(3*NROWSP,3*MCB(2),166)
C
C     INITIALIZE.
C
      LC    = KORSZ(ICORE(1))
      NLLST = LC - 2*SYSBUF
      SLT   = 101
      BGPDT = 102
      CSTM  = 103
      SIL   = 104
      ECPT  = 105
      MPT   = 106
      GPTT  = 107
      EDT   = 108
      MASS  = 109
      CASECC= 110
      IDIT  = 111
      LODC  = 201
C             205 = NEWSLT (THERMAL)
      PG(1) = 301
      ICR2  = 302
      ICR3  = 303
      DO 10 I = 2,7
   10 PG(I) = 0
      PG(3) = NROWSP
      PG(4) = 2
      PG(5) = 1
C
C     AVOID CALCULATING UNUSED LOADS
C
C     NEDT  = NUMBER OF ELEMENT  DEFORMATIONS
C     NTEMP = NUMBER OF THERMAL LOADS
C     NCENT = NUMBER OF CENTRIFUGAL LOADS
C
      CALL SSG1A (N1,ILIST(1),NEDT,NTEMP,NCENT,CASECC,IHARM)
      N1A = N1 + 1
      LC  = LC - SYSBUF
      CALL OPEN (*310,PG(1),ICORE(LC+1),1)
      CALL WRITE (PG(1),PG(1),2,1)
      NGRAV = 0
      NEX   = N1 + NTEMP + NEDT + NCENT
      IF (N1 .EQ. 0) GO TO 21
C
C     MODIFY SLT -QVOL-, -QBDY1-, -QBDY2-, AND -QVECT- CARDS.
C
      NEWSLT = ICR3
      IF (ITHERM .NE. 0) NEWSLT = 205
      ISLT = SLT
      CALL SSGSLT (SLT,NEWSLT,ECPT)
      SLT = NEWSLT
      CALL EXTERN (NEX,NGRAV,GVECT(1),ILIST(1),PG(1),N1,IHARM)
C
C     RESET -SLT- TO ORIGINAL SLT DATA BLOCK
C
      SLT = ISLT
      N1  = N1 - NGRAV
   21 IF (NTEMP) 30,40,30
   30 CALL TEMPL (NTEMP,ILIST(N1+1),PG(1))
      N1 = N1 + NTEMP
   40 IF (NEDT) 50,60,50
   50 CALL EDTL (NEDT,ILIST(N1+1),PG(1))
      N1 = N1 + NEDT
   60 CALL CLOSE (PG,1)
      CALL WRTTRL (PG(1))
      IF (NGRAV) 90,100,90
   90 CONTINUE
C
C     CHECK TO SEE IF THE MASS MATRIX IS PURGED
C
      MCB(1) = MASS
      CALL RDTRL (MCB(1))
      IF (MCB(1) .LE. 0) CALL MESAGE (-56,0,IWORD)
      CALL GRAVL1 (NGRAV,GVECT(1),ICR2,IHARM)
C
C     USE LOAD FILE AS SCRATCH NOTHING ON IT NOW
C
      CALL SSG2B (MASS,ICR2,0,ICR3,0,1,1,LODC)
      CALL GRAVL2 (NGRAV,ICR3,PG(1))
      N1 = N1 + NGRAV
  100 IPONT1 = IPTR + 2
      IPONT  = IPTR + 1
      NLOAD  = 0
      DO 110 I = 1,NLLST
  110 IARY(I) = 0
      CALL OPEN (*320,CASECC,ICORE(LC+1),0)
      LC1  = LC - SYSBUF
      ISLT = 0
      CALL OPEN (*130,SLT,ICORE(LC1+1),0)
      ISLT = 1
      DO 120 I = 1,N1A
      CALL FWDREC (*270,SLT)
  120 CONTINUE
  130 DO 140 I = 1,LOADNN
      CALL FWDREC (*320,CASECC)
  140 CONTINUE
      IFRST = 0
  150 CALL READ (*250,*250,CASECC,CORE(1),166,1,FLAG)
      IF (IFRST .NE. 0) GO TO 151
      IFRST = 1
      ISPCN = CORE(3)
      MPCN  = CORE(2)
  151 CONTINUE
C
C     TEST FOR SYMMETRY, BUCKLING OR DIFFERENTIAL STIFFNESS.
C
      IF (CORE(16).NE.0 .OR. CORE(5).NE.0 .OR. CORE(138).NE.0) GO TO 150
      IF (CORE(3).NE.ISPCN .OR. CORE(2).NE.MPCN) GO TO 250
      INULL = 0
      DO 230 K = 1,4
      I = IWORD(K)
      IF (ITHERM.NE.0 .AND. I.EQ.7) GO TO 230
      IF (CORE(I) .EQ. 0) GO TO 230
      DO 160 J = 1,N1
      IF (CORE(I) .EQ. ILIST(J)) GO TO 220
  160 CONTINUE
C
C     COMBINATION CARD
C
      INULL = 1
  170 CALL READ (*270,*330,SLT,IDEFML(1),2,0,IFLAG)
      IF (CORE(I) .EQ. IDEFML(1)) GO TO 190
  180 CALL READ (*270,*330,SLT,IDEFML(1),2,0,IFLAG)
      IF (IDEFML(2) .EQ. -1) GO TO 170
      GO TO 180
  190 A = DEFML(2)
  200 CALL READ (*270,*330,SLT,IDEFML(1),2,0,IFLAG)
      IF (IDEFML(2) .EQ.  -1) GO TO 210
      IF (IPONT+1 .GT. NLLST) GO TO 340
      IARY(IPONT  ) = IARY(IPONT) + 1
      IARY(IPONT1 ) = IDEFML(2)
      ARY(IPONT1+1) = A*DEFML(1)
      IPONT1 = IPONT1 + 2
      GO TO 200
  210 CALL BCKREC (SLT)
      GO TO 230
  220 IARY(IPONT) = IARY(IPONT) + 1
      IF (IPONT+1 .GT. NLLST) GO TO 340
      IARY(IPONT1 ) = CORE(I)
      ARY(IPONT1+1) = 1.0
      IPONT1 = IPONT1 + 2
      INULL  = 1
  230 CONTINUE
      IF (INULL .EQ. 0) GO TO 260
  240 IPONT = IPONT + IARY(IPONT)*2 + 1
      NLOAD = NLOAD + 1
      IPONT1= IPONT1+ 1
      GO TO 150
  250 CALL CLOSE (CASECC,1)
      IF (ISLT .EQ. 1) CALL CLOSE (SLT,1)
      CALL COMBIN (PG(1),ILIST(1),N1)
      RETURN
C
  260 IARY(IPONT) = 1
      IF (IPONT+1 .GT. NLLST) GO TO 340
      IARY(IPONT1 ) =-1
      ARY(IPONT1+1) = 1.0
      IPONT1 = IPONT1 + 2
      GO TO 240
C
  270 IP1 = SLT
  280 IP2 =-1
  290 CALL MESAGE (IP2,IP1,SUBNAM)
      IP1 = CASECC
      GO TO 280
  310 IP1 = PG(1)
      GO TO 280
  320 IP1 = CASECC
      GO TO 280
  330 IP2 =-2
      IP1 = SLT
      GO TO 290
C
  340 I = ICORE(I)
      NWDS = 0
  350 CALL READ (*330,*360,SLT,CORE(1),LC,0,IFLAG)
      NWDS = NWDS + LC
      GO TO 350
  360 NWDS = NWDS + IFLAG
      WRITE  (IOTPE,370) UFM,I,NLLST,NWDS
  370 FORMAT (A23,' 3176, INSUFFICIENT OPEN CORE AVAILABLE TO PROCESS ',
     1       'ALL LOAD CARD COMBINATIONS IN MODULE SSG1.',
     2       /32X,'CURRENT LOAD ID BEING PROCESSED IS',I9,1H.,
     3       /32X,'OPEN CORE AVAILABLE IS',I9,' WORDS.',
     4       /32X,'ADDITIONAL OPEN CORE REQUIRED IS',I9,' WORDS.')
      IP1 = 0
      IP2 =-61
      GO TO 290
      END

      SUBROUTINE XYFIND (*,*,*,MAJID,IDZ)
C
      LOGICAL         RANDOM    ,RETRY
      INTEGER         MAJID(11) ,FILE      ,VECTOR    ,VECID   ,
     1                Z         ,EOR       ,FLAG      ,SUBC
      COMMON /ZZZZZZ/ Z(1)
      COMMON /XYWORK/ FILE      ,TCURVE(32),NTOPS     ,PRINT   ,
     1                IFILE     ,XAXIS(32) ,NBOTS     ,PLOT    ,
     2                VECTOR    ,YAXIS(32) ,VECID(5)  ,PUNCH   ,
     3                MAJOR     ,YTAXIS(32),SUBC(5)   ,CENTER  ,
     4                RANDOM    ,YBAXIS(32),IDIN(153) ,BUF(100),
     5                IVALUE(60),IAT       ,IDOUT(300),OUTOPN  ,
     6                STEPS     ,NAT       ,PAPLOT    ,KNT
      DATA    EOR   / 1 /
C
C     THIS SUBROUTINE LOCATES THE ID RECORD FOR A PARTICULAR ELEMENT OR
C     POINT ID AND IF THIS IS A RANDOM PLOT IT CONSIDERS THE COMPONENT
C
      K = 1
      RETRY = .FALSE.
      ITEMP = IDZ
      IF (SUBC(FILE)) 15,1,1
    1 CONTINUE
      IF (KNT) 3,15,7
    3 CONTINUE
      ISAV = IDIN(4)
    5 CALL READ (*80,*110,IFILE,IDIN(1),146,1,FLAG)
      IF (ISAV .EQ. IDIN(4)) GO TO 21
      CALL FWDREC (*100,IFILE)
      GO TO 5
    7 CONTINUE
      ISAV = IDIN(4)
      GO TO 11
    9 CALL FWDREC (*100,IFILE)
   11 CALL READ (*80,*110,IFILE,IDIN(1),146,1,FLAG)
      IF (IDIN(4) .EQ. ISAV) GO TO 9
      GO TO 21
   15 CALL REWIND (IFILE)
      CALL FWDREC (*100,IFILE)
      VECID(FILE) = 0
   20 CALL READ (*80,*110,IFILE,IDIN(1),146,EOR,FLAG)
   21 CONTINUE
      IF (MAJOR .NE. IDIN(2)) GO TO 25
      IF (SUBC(FILE) .EQ.  0) GO TO 30
      IF (SUBC(FILE) .EQ. IDIN(4)) GO TO 30
   25 CONTINUE
      CALL FWDREC (*100,IFILE)
      K = K + 1
      GO TO 20
C
C     MATCH ON MAJOR ID MADE
C
   30 VECID(FILE) = VECTOR
   40 IF (IDIN(5)/10 .EQ. Z(IDZ)) GO TO 90
      ITEMP = -1
   50 CALL FWDREC (*100,IFILE)
      CALL READ (*80,*110,IFILE,IDIN(1),146,EOR,FLAG)
      IF (MAJOR .EQ. IDIN(2)) GO TO 40
C
C     ELEMENT DATA ARE NOT IN ASCENDING SORT LIKE GRID DATA, BUT ARE
C     SORTED BY ELEMENT NAME, THEN BY ELEMENT NUMBER.
C     SINCE IT IS POSSIBLE FOR THE DESIRED ELEMENT TO BE AHEAD OF THE
C     CURRENT POSITION OF FILE, REWIND AND TRY AGAIN TO FIND MISSING
C     ELEMENT DATA FOR FORCES AND STRESSES.
C
   80 IF (KNT.EQ.0 .OR. RETRY .OR. SUBC(FILE).EQ.0) GO TO 82
      RETRY = .TRUE.
      GO TO 15
   82 IF (SUBC(FILE) .NE. 0) GO TO 85
      SUBC(FILE) = -1
      RETURN
C
   85 CONTINUE
      VECID(FILE) = 0
      IDZ = ITEMP
      CALL REWIND (IFILE)
      CALL FWDREC (*100,IFILE)
      RETURN 3
C
C     IF RANDOM CHECK COMPONENT FOR MATCH
C
   90 IF (Z(IDZ+1).NE.IDIN(6) .AND. RANDOM) GO TO 50
      IF (SUBC(FILE) .EQ. 0) RETURN
      IF (SUBC(FILE) .NE. IDIN(4)) GO TO 50
      RETURN
C
C     EOF HIT WHEN AN EOF SHOULD NOT HAVE BEEN HIT
C
  100 RETURN 1
C
C     EOR HIT WHEN AN EOR SHOULD NOT HAVE BEEN HIT
C
  110 RETURN 2
C
      END

      SUBROUTINE SDCOM1 (P,AC,WA,WB)
C
      INTEGER         AC(1),ROW,C,START
      REAL            P(1),WA(1),WB(1)
      COMMON /SDCOMX/ ROW,C,SPFLG,START,FRSTPC,LASTPL,LASTI
C
      J  = 1
      L  = 1
      K1 = LASTPL + 1
      IEND   = MIN0(LASTPL,LASTI)
      ISTART = MAX0(K1,START)
      IF (C .EQ. LASTPL) GO TO 200
      IF (START .GT. LASTPL) GO TO 100
      DO 48 I = START,IEND
      PI   =-P(I)/P(1)
      IJMK = J - I
      ILMK = L - I
      DO 10 K = I,LASTPL
      WB(K+IJMK) = PI*P(K) + WA(K+ILMK)
   10 CONTINUE
      L = ILMK + K1
      DO 18 K = K1,C
      IF (AC(K) .GT. 0) GO TO 12
      WB(K+IJMK) = PI*P(K)
      GO TO 18
   12 WB(K+IJMK) = PI*P(K) + WA(L)
      L = L + 1
   18 CONTINUE
      J = IJMK + C + 1
      P(I) = PI
   48 CONTINUE
      IF (LASTPL .GE. LASTI) RETURN
  100 DO 148 I = ISTART,LASTI
      PI   = -P(I)/P(1)
      IJMK = J - I
      IF (AC(I) .LT. 0) GO TO 120
      DO 118 K = I,C
      IF (AC(K) .GT. 0) GO TO 112
      WB(K+IJMK) = PI*P(K)
      GO TO 118
  112 WB(K+IJMK) = PI*P(K) + WA(L)
      L = L + 1
  118 CONTINUE
      GO TO 140
  120 DO 128 K = I,C
      WB(K+IJMK) = PI*P(K)
  128 CONTINUE
  140 J = IJMK + C + 1
      P(I) = PI
  148 CONTINUE
      RETURN
C
  200 IF (START .GT. LASTPL) GO TO 300
      DO 248 I = START,IEND
      PI   = -P(I)/P(1)
      IJMK = J - I
      ILMK = L - I
      DO 238 K = I,LASTPL
      WB(K+IJMK) = PI*P(K) + WA(K+ILMK)
  238 CONTINUE
      J = IJMK + K1
      L = ILMK + K1
      P(I) = PI
  248 CONTINUE
      IF (LASTPL .GE. LASTI) RETURN
  300 DO 348 I = ISTART,LASTI
      PI   = -P(I)/P(1)
      IJMK = J - I
      IF (AC(I) .LT. 0) GO TO 320
      DO 318 K = I,C
      IF (AC(K) .GT. 0) GO TO 312
      WB(K+IJMK) = PI*P(K)
      GO TO 318
  312 WB(K+IJMK) = PI*P(K) + WA(L)
      L = L + 1
  318 CONTINUE
      GO TO 340
  320 DO 328 K = I,C
      WB(K+IJMK) = PI*P(K)
  328 CONTINUE
  340 J = IJMK + C + 1
      P(I) = PI
  348 CONTINUE
      RETURN
      END

      FUNCTION F89 (I,A,B,M,N,X)
C
      DIMENSION X(1)
C
      F89  = 0.0
      CAPX = A + B*X(I)
      NFAC = M
      ASSIGN 5 TO IRET
      GO TO 1000
    5 AMF = IFAC
      N1  = M + 1
      N2  = N1 - N
      AN1 = N1
      AN2 = N2
      IS  = 0
      S   = 0.0
      SF  = 1.0
      AMMSF = AMF
      GO TO 50
   10 IS = IS + 1
      S  = IS
      SF = SF*S
      AMMSF = AMMSF/(AN1-S)
   50 CONTINUE
      N3 = N2 - IS
      IF (N3 .EQ. 0) GO TO 100
      F89 = F89 + AMF*((-A)**IS)*(CAPX**N3)/(AMMSF*SF*(AN2-S))
      GO TO 200
  100 CONTINUE
      NFAC = N2
      ASSIGN 110 TO IRET
      GO TO 1000
  110 AMN1F = IFAC
      NFAC  = N - 1
      ASSIGN 120 TO IRET
      GO TO 1000
  120 ANM1F = IFAC
      F89 = F89 + AMF*((-A)**N2)*ALOG(ABS(CAPX))/(AMN1F*ANM1F)
  200 IF (IS .LT.  M) GO TO 10
      IF (B .EQ. 0.0) GO TO 300
      F89 = F89/(B**N1)
      RETURN
C
  300 F89 = 0.0
      RETURN
C
 1000 IFAC = 1
      IF (NFAC .LT. 2) GO TO 1020
      DO 1010 LFAC = 2,NFAC
      IFAC = IFAC*LFAC
 1010 CONTINUE
 1020 GO TO IRET, (5,110,120)
      END

      COMPLEX FUNCTION TRAILE (X,J,N,P,M,BOXL)
C
C     ROUTINE TO FIND PHI FOR TRAILING EDGE
C
      DIMENSION N(1)
      COMPLEX P(3,M)
C
C     CHECK TO SEE IF TRAILING EDGE HAS BEEN COMPUTED
C
      IF (N(J) .GE. 0) GO TO 300
 200  TRAILE = P(1,J)
      RETURN
C
 300  XA = X/BOXL + 0.5 - FLOAT(N(J))
      IF (REAL(P(2,J)) .EQ. 0.0) GO TO 200
      TRAILE = P(1,J) + XA*(P(1,J) - P(2,J))
      RETURN
      END

      SUBROUTINE SOFINT (IB1,IB2,NUMB,IBL1)
C
C     CALLED ONCE BY EVERY RUN USING THE SOF UTILITY SUBROUTINES.
C     SHOULD BE CALLED BEFORE ANY OF THEM IS CALLED.  IF THE SOF IS
C     NOT EMPTY, SOME SECURITY CHECKS WILL BE TAKEN CARE OF, AND THE
C     SOF COMMON BLOCKS WILL BE UPDATED AND WRITTEN OUT ON THE FIRST
C     BLOCK OF EACH OF THE SOF FILES.  IF THE SOF IS EMPTY, THE DIT
C     MDI, AND ARRAY NXT WILL BE INITIALIZED AND WRITTEN OUT ON THE
C     THIRD, FOURTH, AND SECOND BLOCKS OF THE FIRST FILE OF THE SOF,
C     AND THE SOF COMMON BLOCKS WILL BE INITIALIZED AND WRITTEN OUT
C     ON THE FIRST BLOCK OF EACH OF THE SOF FILES.
C
C     THE FIRST BLOCK OF EACH OF THE SOF FILES CONTAINS THE FOLLOWING
C     INFORMATION
C       WORD                   WORD                   WORD
C      NUMBER  CONTENTS       NUMBER  CONTENTS       NUMBER  CONTENTS
C      ------  --------       ------  --------       ------  --------
C       1- 2   PASSWORD          26   DIRSIZ            32   MDIBL
C          3   FILE NUMBER       27   SUPSIZ            33   NXTTSZ
C          4   NFILES            28   AVBLKS         34-43   NXTFSZ
C       5-14   FILNAM            29   DITSIZ            44   NXTCUR
C      15-24   FILSIZ            30   DITNSB            45   NXTRST
C         25   BLKSIZ            31   DITBL             46   HIBLK
C                                                       47   IFRST
C
C     STARTING AT LOCATION 100 THE CONTENTS OF THE ITEMDT COMMON BLOCK
C     ARE STORED
C
C
      EXTERNAL        LSHIFT,RSHIFT,ORF
      LOGICAL         FIRST
      INTEGER         FILNAM,FILSIZ,STATUS,FILE,PSSWRD,ORF,HIBLK,
     1                BUF,RSHIFT,NAME(2)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25,SWM*27,SIM*31
      COMMON /XMSSG / UFM,UWM,UIM,SFM,SWM,SIM
      COMMON /MACHIN/ MAC,IHALF
      COMMON /ZZZZZZ/ BUF(1)
      COMMON /SOFCOM/ NFILES,FILNAM(10),FILSIZ(10),STATUS,PSSWRD(2),
     1                FIRST
      COMMON /SYSTEM/ NBUFF,NOUT,X1(36),NBPC,NBPW,NCPW
      COMMON /SYS   / NSBUFF,X4(3),HIBLK,IFRST
      COMMON /ITEMDT/ NITEM,ITEM(7,1)
      DATA    IRD,IWRT    /1, 2  /
      DATA    IEMPTY,NAME /4H    ,4HSOFI,4HNT  /
C
      IF (NCPW .LE. 4) GO TO 5
      N = NBPW - NBPC*4
      DO 3 I = 1,10
      FILNAM(I) = LSHIFT(RSHIFT(FILNAM(I),N),N)
    3 CONTINUE
    5 IF (NFILES .LE. 0) GO TO 1000
      IF (STATUS .EQ. 0) GO TO 250
C
C     THE SOF IS NOT EMPTY.  READ THE FIRST BLOCK OF THE FIRST SOF FILE
C     AND VERIFY THE SECURITY VARIABLES.
C
      FILE = FILNAM(1)
      CALL SOFIO (IRD,1,BUF(IB1-2))
      IF ((BUF(IB1+1).NE.PSSWRD(1)) .OR. (BUF(IB1+2).NE.PSSWRD(2)))
     1     GO TO 1050
      IF (BUF(IB1+3) .NE. 1) GO TO 1060
      IF (BUF(IB1+25) .NE. NSBUFF) GO TO 1040
C
C     CHECK IF THE SPECIFIED NUMBER OF FILES AND THEIR SIZES IS ADEQUATE
C
      IF (BUF(IB1+4) .GE. NFILES) GO TO 10
      MAX = BUF(IB1+4) - 1
      GO TO 20
   10 MAX = NFILES - 1
   20 IF (MAX .LT. 1) GO TO 50
      DO 30 I = 1,MAX
      IF (BUF(IB1+14+I) .EQ. FILSIZ(I)) GO TO 30
      FILE = FILNAM(I)
      GO TO 1070
   30 CONTINUE
C
C     CHECK IF ALL SOF FILES HAVE THE CORRECT PASSWORD AND SEQUENCE
C     NUMBER
C
      MAX = MAX + 1
      IBL = 1
      DO 40 I = 2,MAX
      FILE = FILNAM(I)
      IBL  = IBL + FILSIZ(I-1)
      CALL SOFIO (IRD,IBL,BUF(IB1-2))
      IF ((BUF(IB1+1).NE.PSSWRD(1)) .OR. (BUF(IB1+2).NE.PSSWRD(2)))
     1     GO TO 1050
      IF (BUF(IB1+3) .NE. I) GO TO 1060
   40 CONTINUE
      CALL SOFIO (IRD,1,BUF(IB1-2))
      MAX = MAX - 1
   50 IF (BUF(IB1+14+MAX+1) .EQ. FILSIZ(MAX+1)) GO TO 130
      MAXNXT = 0
      IF (MAX .LT. 1) GO TO 70
      DO 60 I = 1,MAX
      MAXNXT = MAXNXT+BUF(IB1+33+I)
   60 CONTINUE
   70 LASTSZ = (FILSIZ(MAX+1)-1)/BUF(IB1+27)
      IF (FILSIZ(MAX+1)-1 .EQ. LASTSZ*BUF(IB1+27)) GO TO 80
      LASTSZ = LASTSZ + 1
   80 MAXNXT = MAXNXT + LASTSZ
      IF (BUF(IB1+33) .GT. MAXNXT) GO TO 1080
      MAXOLD = MAXNXT - LASTSZ + BUF(IB1+33+MAX+1)
      IF (BUF(IB1+33) .NE. MAXOLD) GO TO 130
      IF (BUF(IB1+14+MAX+1) .GT. FILSIZ(MAX+1)) GO TO 1080
      LSTSIZ = MOD(BUF(IB1+14+MAX+1)-2,BUF(IB1+27)) + 1
      IF (LSTSIZ .EQ. BUF(IB1+27)) GO TO 130
C
C     THE SIZE OF THE LAST SUPERBLOCK THAT WAS USED ON FILE (MAX+1)
C     SHOULD BE INCREASED.
C
      IF (FILSIZ(MAX+1)-BUF(IB1+14+MAX+1) .GE. BUF(IB1+27)-LSTSIZ)
     1    GO TO 90
      NUMB = FILSIZ(MAX+1) - BUF(IB1+14+MAX+1)
      GO TO 100
   90 NUMB = BUF(IB1+27) - LSTSIZ
  100 IBL1 = 0
      IF (MAX .LT. 1) GO TO 120
      DO 110 I = 1,MAX
      IBL1 = IBL1 + FILSIZ(I)
  110 CONTINUE
  120 IBL1 = IBL1 + BUF(IB1+14+MAX+1) + 1
      GO TO 135
  130 NUMB = 0
C
C     UPDATE THE VARIABLE WHICH INDICATES THE NUMBER OF FREE BLOCKS ON
C     THE SOF.
C
  135 IF (NFILES-BUF(IB1+4)) 140,160,170
  140 IDIFF = BUF(IB1+14+NFILES) - FILSIZ(NFILES)
      MIN   = NFILES + 1
      LAST  = BUF(IB1+4)
      DO 150 I = MIN,LAST
      IDIFF = IDIFF + BUF(IB1+14+I)
  150 CONTINUE
      GO TO 190
  160 IDIFF = BUF(IB1+14+NFILES) - FILSIZ(NFILES)
      GO TO 190
  170 IHERE1 = BUF(IB1+4)
      IDIFF  = BUF(IB1+14+IHERE1) - FILSIZ(IHERE1)
      MIN    = BUF(IB1+4) + 1
      DO 180 I = MIN,NFILES
      IDIFF = IDIFF - FILSIZ(I)
  180 CONTINUE
  190 BUF(IB1+28) = BUF(IB1+28) - IDIFF
C
C     IF NO ITEM STRUCTURE IS ON THE SOF (THE SOF WAS CREATED BEFORE
C     LEVEL 17.0) THEN USE THE LEVEL 16.0 ITEM STRUCTURE.
C
      IF (BUF(IB1+100).GT.0 .AND. BUF(IB1+100).LE.100) GO TO 198
      WRITE (NOUT,6235) UWM
      BUF(IB1+ 47) = 3
      BUF(IB1+100) = 18
      K = 100
      DO 194 I = 1,18
      DO 192 J = 1,7
  192 BUF(IB1+K+J) = ITEM(J,I)
  194 K = K + 7
      GO TO 200
C
C     CHECK IF THE DIRECTORY SIZE HAS BEEN CHANGED
C
  198 IF (NITEM .EQ. BUF(IB1+100)) GO TO 200
      WRITE (NOUT,6233) UWM
C
C     UPDATE THE COMMON BLOCKS USED BY THE SOF UTILITY SUBROUTINES.
C
  200 BUF(IB1+4) = NFILES
      DO 210 I = 1,NFILES
      BUF(IB1+4 +I) = FILNAM(I)
      BUF(IB1+14+I) = FILSIZ(I)
      BUF(IB1+33+I) = (FILSIZ(I)-1)/BUF(IB1+27)
      IF (FILSIZ(I)-1 .EQ. BUF(IB1+33+I)*BUF(IB1+27)) GO TO 210
      BUF(IB1+33+I) = BUF(IB1+33+I) + 1
  210 CONTINUE
C
C     WRITE THE UPDATED ARRAY A ON THE FIRST BLOCK OF EACH OF THE SOF
C     FILES.
C
      IBL = 1
      DO 220 I = 1,NFILES
      BUF(IB1+3) = I
      CALL SOFIO (IWRT,IBL,BUF(IB1-2))
      IBL = IBL + FILSIZ(I)
  220 CONTINUE
      GO TO 340
C
C     THE SOF IS EMPTY.  INITIALIZE THE SOF COMMON BLOCKS WHICH ARE
C     STORED IN THE ARRAY A.
C     CHECK IF THE NASTRAN BUFFER SIZE IS LARGE ENOUGH
C
  250 MIN = 100 + 7*NITEM + (NBUFF-NSBUFF)
      IF (NBUFF .LT. MIN) GO TO 1090
      LAST  = NBUFF - 4
      HIBLK = 0
      IFRST = 3
      DO 255 I = 1,LAST
  255 BUF(IB1+ I) = 0
      BUF(IB1+ 1) = PSSWRD(1)
      BUF(IB1+ 2) = PSSWRD(2)
      BUF(IB1+25) = NSBUFF
      BUF(IB1+26) = NITEM + IFRST - 1
      BUF(IB1+27) = 2*(BUF(IB1+25)-1)
      BUF(IB1+28) = -4
      DO 260 I = 1,NFILES
      BUF(IB1+28) = BUF(IB1+28) + FILSIZ(I)
  260 CONTINUE
      BUF(IB1+29) = 0
      BUF(IB1+30) = 0
      BUF(IB1+31) = 3
      BUF(IB1+32) = 4
      BUF(IB1+33) = 1
      BUF(IB1+44) = 1
      BUF(IB1+45) = 0
      BUF(IB1+46) = 4
      BUF(IB1+47) = IFRST
C
      BUF(IB1+100) = NITEM
      K = 100
      DO 280 I = 1,NITEM
      DO 270 J = 1,7
  270 BUF(IB1+K+J) = ITEM(J,I)
  280 K = K + 7
C
C     INITIALIZE THE ARRAY NXT AND WRITE IT ON THE SECOND BLOCK OF THE
C     FIRST SOF FILE.
C
      DO 300 I = 1,LAST
      BUF(IB2+I) = 0
  300 CONTINUE
      IF (BUF(IB1+27)+1 .GT. FILSIZ(1)) GO TO 302
      MAX = BUF(IB1+25) - 1
      BUF(IB2+MAX+1) = LSHIFT(BUF(IB1+27)+1,IHALF)
      BUF(IB2+1) = BUF(IB1+27) + 1
      GO TO 308
  302 IF (MOD(FILSIZ(1),2) .EQ. 1) GO TO 304
      MAX = FILSIZ(1)/2
      GO TO 306
  304 MAX = (FILSIZ(1)-1)/2
      BUF(IB2+MAX+1) = LSHIFT(FILSIZ(1),IHALF)
  306 BUF(IB2+1) = FILSIZ(1)
  308 BUF(IB2+1) = ORF(BUF(IB2+1),LSHIFT(5,IHALF))
      BUF(IB2+2) = 0
      BUF(IB2+3) = 6
      DO 310 I = 4,MAX
      BUF(IB2+I) = 2*I
      BUF(IB2+I) = ORF(BUF(IB2+I),LSHIFT(2*I-1,IHALF))
  310 CONTINUE
      CALL SOFIO (IWRT,1,BUF(IB2-2))
      CALL SOFIO (IWRT,2,BUF(IB2-2))
C
C     INITIALIZE THE DIT AND WRITE IT ON THE THIRD BLOCK OF THE FIRST
C     SOF FILE.
C
      DO 320 I = 1,LAST
      BUF(IB2+I) = IEMPTY
  320 CONTINUE
      CALL SOFIO (IWRT,3,BUF(IB2-2))
C
C     INITIALIZE THE MDI AND WRITE IT ON THE FOURTH BLOCK OF THE FIRST
C     SOF FILE.
C
      DO 330 I = 1,LAST
      BUF(IB2+I) = 0
  330 CONTINUE
      CALL SOFIO (IWRT,4,BUF(IB2-2))
      NUMB = 0
      GO TO 200
C
C     PRINT MESSAGE INDICATING THE STATUS OF THE CURRENT SOF FILES.
C
  340 WRITE (NOUT,360) SIM,NFILES
      DO 350 I = 1,NFILES
      WRITE (NOUT,370) I,FILSIZ(I)
  350 CONTINUE
      WRITE  (NOUT,380) BUF(IB1+25)
  360 FORMAT (A31,' 6201,',I3,' FILES HAVE BEEN ALLOCATED TO THE SOF ',
     1       'WHERE --')
  370 FORMAT (18H     SIZE OF FILE ,I2,3H = ,I10,7H BLOCKS)
  380 FORMAT (32H     AND WHERE A BLOCK CONTAINS ,I4,6H WORDS)
      RETURN
C
C     ERROR MESSAGES.
C
 1000 WRITE  (NOUT,1001) SFM
 1001 FORMAT (A25,' 6202.  THE REQUESTED NO. OF FILES IS NON POSITIVE.')
      CALL MESAGE (-37,0,NAME(1))
      RETURN
C
 1040 I = (NBUFF-NSBUFF) + BUF(IB1+25)
      WRITE  (NOUT,1041) UFM,I
 1041 FORMAT (A23,' 6205, SUBROUTINE SOFINT - THE BUFFER SIZE HAS BEEN',
     1       ' MODIFIED.', /30X,
     2       'THE CORRECT NASTRAN PARAMETER IS BUFFSIZE = ',I6)
      GO TO 1082
C
 1050 WRITE  (NOUT,1051) UFM,FILE
 1051 FORMAT (A23,' 6206, SUBROUTINE SOFINT - WRONG PASSWORD ON SOF ',
     1       'FILE ',A4,1H.)
      GO TO 1082
C
 1060 WRITE  (NOUT,1061) UFM,FILE
 1061 FORMAT (A23,' 6207, SUBROUTINE SOFINT - THE SOF FILE ',A4,
     1       ' IS OUT OF SEQUENCE.')
      GO TO 1082
C
 1070 WRITE  (NOUT,1071) UFM,FILE
 1071 FORMAT (A23,' 6208, SUBROUTINE SOFINT - THE SIZE OF THE SOF FILE '
     1,       A4,' HAS BEEN MODIFIED.')
      GO TO 1082
C
 1080 WRITE  (NOUT,1081) UFM,FILE
 1081 FORMAT (A23,' 6209, SUBROUTINE SOFINT - THE NEW SIZE OF FILE ',A4,
     1       ' IS TOO SMALL.')
 1082 CALL MESAGE (-61,0,0)
C
 1090 WRITE  (NOUT,1091) UFM,MIN
 1091 FORMAT (A23,' 6234, THE NASTRAN BUFFER SIZE IS TO SMALL FOR THE',
     1       ' SOF FILE.', /30X,'MINIMUM BUFFER SIZE IS ',I10)
      GO TO 1082
C
 6233 FORMAT (A25,' 6233, THE ITEM STRUCTURE HAS BEEN CHANGED FOR THE ',
     1       'SOF.', /32X,'NEW CAPABILITIES USING THESE ITEMS MAY NOT ',
     2       'BE USED WITH THIS SOF.')
C
 6235 FORMAT (A25,'6235, THE OLD SOF CONTAINS NO ITEM STRUCTURE ',
     1       'INFORMATION.', /27X,'THE LEVEL 16.0 ITEM STRUCTURE WILL ',
     2       'BE USED.')
C
      END

      SUBROUTINE DBMREL
C********************************************************************
C  DBMREL  -   RELEASES IN-MEMORY BLOCKS THAT ARE CURRENTLY
C              ALLOCATED TO AN IN-MEMORY FILE
C********************************************************************
      INCLUDE   'DSIOF.COM'
      INCLUDE   'ZZZZZZ.COM'
      COMMON / SYSTEM / ISYSBF, IWR
      IF ( FCB( 9, IFILEX ) .EQ. 0 .OR. FCB( 10, IFILEX ) .EQ. 0 )
     &    GO TO 701
      IF ( IDBFRE .NE. 0 ) GO TO 10
C FREE CHAIN IS EMPTY, THIS CHAIN BECOMES FREE CHAIN
      IDBFRE = FCB( 9, IFILEX )
      GO TO 777
C SET FIRST OF BLOCKS TO BE FREED AT FIRST OF FREE CHAIN AND
C THEN CONNECT LAST OF BLOCKS TO BE FREED WITH FIRST OF EXISTING
C FREE CHAIN
10    CONTINUE
      IF ( FCB( 9, IFILEX ) .EQ. FCB( 10, IFILEX ) ) GO TO 20
      ISAVE          = IDBFRE
      IDBFRE         = FCB(  9, IFILEX )
      MEM( ISAVE )   = FCB( 10, IFILEX )
      INDEX          = FCB( 10, IFILEX )
      MEM( INDEX+1 ) = ISAVE
      GO TO 777
C FILE HAD ONLY ONLY ONE BLOCK ALLOCATED TO IT
20    CONTINUE
      ISAVE          = IDBFRE
      IDBFRE         = FCB(  9, IFILEX )
      MEM( ISAVE )   = IDBFRE
      MEM( IDBFRE+1) = ISAVE
      GO TO 777
701   WRITE( IWR, 901 )
901   FORMAT(///,' ERROR IN ATTEMPT TO FREE BLOCKS TO FREE CHAIN',
     &       /,' CONTENTS OF THE DIRECTORY ARE AS FOLLOWS')
      CALL DBMDMP
      CALL MESAGE ( -61, 0, 0 )
777   CONTINUE
      FCB(  9, IFILEX ) = 0
      FCB( 10, IFILEX ) = 0
      FCB( 11, IFILEX ) = 0
      RETURN
      END

      SUBROUTINE SS2D82 (IEQEX,NEQEX,TGRID)
C
C     PHASE 2 OF STRESS DATA RECOVERY FOR 2-D, 8 GRID POINT
C     ISOPARAMETRIC STRUCTURAL ELEMENT
C
C     PH1OUT CONTAINS THE FOLLOWING
C     ELEMENT ID
C     8 SILS
C     TREF
C     ST ARRAY
C     TRANSFORMATION MATRIX FROM GLOBAL TO ELEMENT COORDINATES
C     COORD SYSTEM ID FOR STRESS OUTPUT
C     G MATRIX
C     DNX,DNY AT EACH GRID POINT -EVALUATED 8 TIMES
C
C
      DIMENSION       TGRID(8),ST(3),TA(48),G(9),B(9),DB(72),DISP(24),
     1                SIG(3),BB(72),DNX(8),DNY(8),TB(6),TEMP(9),
     2                ISTRES(3),NSIL(1),NPH1(1),DN(8),XI(8),ETA(8),
     3                PT(3),EX2D82(32),EX2D83(72),SIGS(27),SIGT(24),
     4                IZ(1),STRESS(43)
      COMMON /ZZZZZZ/ Z(1)
      COMMON /SDR2X4/ DUMMY(35),IVEC,IVECN,LDTEMP,DEFORM
      COMMON /SDR2X7/ PH1OUT(100),STR(250),FORVEC(250)
      COMMON /SDR2X8/ DISP,DNX,DNY,DNZ,B,TB,BB,DB,SIG,IBASE,NSTRT,NPT,
     1                IS,IDTEMP
      EQUIVALENCE     (PH1OUT(1),NPH1(1)),(PH1OUT(1),ID),
     1                (NSIL(1),PH1OUT(2)),(TREF,PH1OUT(10)),
     2                (ST(1),PH1OUT(11)),(TA(1),PH1OUT(14)),
     3                (G(1),PH1OUT(63)),(PH1OUT(62),ID1),
     4                (ISTRES(1),STRESS(1)),(LDTEMP,ELTEMP),
     5                (Z(1),IZ(1))
      DATA    EX2D82/
     1 1.86603,-.50000,-.50000, .13397,-.50000, .13397,1.86603,-.50000,
     2  .13397,-.50000,-.50000,1.86603,-.50000,1.86603, .13397,-.50000,
     3  .68301,-.18301, .68301,-.18301,-.18301,-.18301, .68301, .68301,
     4 -.18301, .68301,-.18301, .68301, .68301, .68301,-.18301,-.18301/
      DATA    EX2D83/
     1 2.18694,-.98589, .27778,-.98589, .44444,-.12522, .27778,-.12522,
     2  .03528, .27778,-.12522, .03528,-.98589, .44444,-.12522,2.18694,
     3 -.98589, .27778, .03528,-.12522, .27778,-.12522, .44444,-.98589,
     4  .27778,-.98589,2.18694, .27778,-.98589,2.18694,-.12522, .44444,
     5 -.98589, .03528,-.12522, .27778,-.00000,0.00000,-.00000,1.47883,
     6 -.66667, .18784, .00000,-.00000,-.00000,-.00000, .18784, .00000,
     7 -.00000,-.66667,-.00000, .00000,1.47883, .00000,-.00000,0.00000,
     8  .00000, .18784,-.66667,1.47883, .00000,-.00000, .00000,-.00000,
     9 1.47883, .00000,-.00000,-.66667,-.00000,-.00000, .18784,0.00000/
      DATA    XI    / -1., 1., 1.,-1., 0., 1., 0.,-1./
      DATA    ETA   / -1.,-1., 1., 1.,-1., 0., 1., 0./
C
C     SET UP DISPLACEMENTS FOR THIS ELEMENT
C
      IS  = 0
      DO 10 I = 1,8
      NSTRT = IVEC + NSIL(I) - 1
      DO 10 J = 1,3
      IS  = IS + 1
      NPT = NSTRT + J - 1
      DISP(IS) = Z(NPT)
   10 CONTINUE
C
C     INITIALIZE SOME MATRICES
C
      DO 30 I = 1,72
   30 BB(I) = 0.
C
C     SET UP INDICATOR FOR GRID POINT TEMPERATURES
C
      IDTEMP = 0
      DO 40 I = 1,8
      IF (TGRID(I) .NE. 0.) GO TO 50
   40 CONTINUE
      GO TO 60
   50 IDTEMP = 1
C
C     START LOOPING FOR STRESSES
C
   60 IDN = 4
      IF (ID1 .EQ. 3) IDN = 9
      III = 0
      PT(1) = -0.57735027
      PT(2) = -PT(1)
      IF (ID1 .EQ. 2) GO TO 133
      PT(1) = -0.77459667
      PT(2) = 0.
      PT(3) = -PT(1)
  133 DO 135 JII = 1,ID1
      DO 135 JJJ = 1,ID1
      III = III + 1
C
C     COMPUTE BASE POINTER FOR PICKING UP DERIVATIVES
C
      IBASE = 71 + 16*(III-1)
C
      DO 70 N = 1,8
      NX = N + IBASE
      NY = N + IBASE + 8
      DNX(N) = PH1OUT(NX)
      DNY(N) = PH1OUT(NY)
   70 CONTINUE
C
      DO 130 N = 1,8
C
C     SET UP THE B MATRIX
C
      DO 75 I = 1,9
      TEMP(I) = 0.
   75 B(I) = 0.
      B(1) = DNX(N)
      B(4) = DNY(N)
      B(5) = DNY(N)
      B(6) = DNX(N)
C
C     TRANSFORM TO ELEMENT COORDINATES
C
      KK = 6*N - 6
      DO 80 I = 1,6
      K  = KK + I
      TB(I) = TA(K)
   80 CONTINUE
      CALL GMMATS (B,3,2,0,TB,2,3,0,TEMP(1))
      N3 = 3*N
      BB(N3- 2) = TEMP(1)
      BB(N3- 1) = TEMP(2)
      BB(N3   ) = TEMP(3)
      BB(N3+22) = TEMP(4)
      BB(N3+23) = TEMP(5)
      BB(N3+24) = TEMP(6)
      BB(N3+46) = TEMP(7)
      BB(N3+47) = TEMP(8)
      BB(N3+48) = TEMP(9)
  130 CONTINUE
C
C     BRING IN G MATRIX
C
      CALL GMMATS (G,3,3,0,BB,3,24,0,DB)
C
C     COMPUTE STRESSES
C
      CALL GMMATS (DB,3,24,0,DISP,24,1,0,SIG)
C
C     STORE GAUSS POINT STRESSES INTO SIGT
C
      I3 = 3*(III-1)
      DO 131 I = 1,3
      ISUB = I3 + I
      SIGS(ISUB) = SIG(I)
  131 CONTINUE
C
C     COMPUTE GAUSS POINT  TEMPERATURES
C
      IF (LDTEMP .EQ. -1) GO TO 135
      IF (IDTEMP .EQ.  1) GO TO 229
      RGTEMP = ELTEMP - TREF
      GO TO 250
C
C     ALL TEMPERATURES ARE DEFAULT VALUE
C
  229 DO 230 N = 1,4
      DN(N) = .25*(1.+PT(JII)*XI(N))*(1.+PT(JJJ)*ETA(N))
     1           *(PT(JII)*XI(N)+PT(JJJ)*ETA(N)-1.)
  230 CONTINUE
      DO 231 N = 5,7,2
      DN(N) = .5*(1.-PT(JII)*PT(JII))*(1.+PT(JJJ)*ETA(N))
  231 CONTINUE
      DO 232 N = 6,8,2
      DN(N) = .5*(1.+PT(JII)*XI(N))*(1.-PT(JJJ)*PT(JJJ))
  232 CONTINUE
      GSTEMP = 0.
      DO 240 N = 1,8
      GSTEMP = GSTEMP + DN(N)*TGRID(N)
  240 CONTINUE
      RGTEMP = GSTEMP - TREF
  250 CONTINUE
      DO 260 I = 1,3
      ISUB = I3 + I
      SIGS(ISUB) = SIGS(ISUB) - ST(I)*RGTEMP
  260 CONTINUE
C
  135 CONTINUE
C
C     MULTIPLY BY TRANSFORMATION FROM GAUSS POINTS TO GRID POINTS
C
      IF (ID1 .EQ. 2) CALL GMMATS (EX2D82,8,4,0,SIGS,4,3,0,SIGT)
      IF (ID1 .EQ. 3) CALL GMMATS (EX2D83,8,9,0,SIGS,9,3,0,SIGT)
C
C     FINISH UP
C
      DO 500 III = 1,8
C
C     MOVE A ROW OF SIGT INTO SIG
C
      I3 = 3*(III-1)
      DO 132 I = 1,3
      ISUB = I3 + I
      SIG(I) = SIGT(ISUB)
  132 CONTINUE
C
C     STORE STRESSES
C
      JSUB  = 5*(III-1) + 4
      ISUB1 = IEQEX + 1
      ISUB2 = IEQEX + NEQEX - 1
      DO 161 JJJ = ISUB1,ISUB2,2
      NS = IZ(JJJ)/10
      IF (NS .NE. NSIL(III)) GO TO 161
      ISTRES(JSUB) = IZ(JJJ-1)
      GO TO 162
  161 CONTINUE
      CALL MESAGE (-30,164,IZ(JJJ))
  162 CONTINUE
      ISTRES(JSUB+1) = 0
      DO 170 I = 1,3
      JJSUB = JSUB + 1 + I
      STRESS(JJSUB) = SIG(I)
  170 CONTINUE
C
C     LOOP FOR OTHER GRID POINTS
C
  500 CONTINUE
C
C     FINISH UP
C
C     ELEMENT ID
C
      ISTRES(1) = ID
C
C     NUMBER OF GRID POINTS PER ELEMENT
C
      ISTRES(2) = 8
C
C     NUMBER OF STRESSES OUTPUT PER ELEMENT
C
      ISTRES(3) = 3
C
      DO 600 I = 1,43
  600 STR(I) = STRESS(I)
C
      RETURN
      END

      SUBROUTINE GFSWCH (FILE1,FILE2)
C
C     THE PURPOSE OF THIS SUBROUTINE IS TO INTERCHANGE THE NAMES OF
C     TWO FILES.  THIS IS ACCOMPLISHED BY THE DIRECT UPDATEING
C     OF THE FIAT AND THE FIST
C
      EXTERNAL         LSHIFT,RSHIFT,ANDF,ORF,COMPLF
      INTEGER          FILE1,FILE2,MODNAM(2),NAME(2),PSAVE1,PSAVE2,
     1                 ANDF,ORF,RSHIFT,COMPLF,UNIT,UNIT1,UNIT2,UNT
      CHARACTER        UFM*23,UWM*25,UIM*29,SFM*25
      COMMON  /XMSSG / UFM,UWM,UIM,SFM
      COMMON  /XFIAT / IFIAT(3)
      COMMON  /XFIST / IFIST(2)
      COMMON  /XPFIST/ IPFIST
      COMMON  /SYSTEM/ SYSBUF,NOUT,SKIP(21),ICFIAT
      DATA     MODNAM/ 4HGFSW,4HCH   /
C
      MASK   = LSHIFT(1,30) - 1
      MASK   = LSHIFT(RSHIFT(MASK,16),16)
      MASK1  = COMPLF(MASK)
      MASK2  = 32767
      MASK3  = COMPLF(MASK2)
      NUNIQE = IFIAT(1)*ICFIAT + 3
      MXE    = IFIAT(2)*ICFIAT + 3
      LASTWD = IFIAT(3)*ICFIAT + 3
C
C     LOCATE FILE POINTERS IN THE FIST
C
      NWD    = 2*IPFIST   + 2
      NACENT = 2*IFIST(2) + 2
      NFILES = NACENT - NWD
      PSAVE1 = 0
      PSAVE2 = 0
      DO 25 I = 1,NFILES,2
      IF (IFIST(NWD+I).NE.FILE1 .AND. IFIST(NWD+I).NE.FILE2) GO TO 25
      IF (IFIST(NWD+I) - FILE1) 10,15,10
   10 IF (IFIST(NWD+I) - FILE2) 25,20,25
   15 PSAVE1 = IFIST(NWD+I+1) + 1
      ILOC1  = I+NWD
      GO TO 25
   20 PSAVE2 = IFIST(NWD+I+1) + 1
      ILOC2  = I+NWD
   25 CONTINUE
C
C     CHECK THAT FILES ARE IN FIST
C
      IF (PSAVE1 .EQ. 0) CALL MESAGE (-1,FILE1,MODNAM)
      IF (PSAVE2 .EQ. 0) CALL MESAGE (-1,FILE2,MODNAM)
C
C     SWITCH THE FIST POINTERS
C
      IFLOC = IFIST(ILOC1+1)
      IFIST(ILOC1+1) = IFIST(ILOC2+1)
      IFIST(ILOC2+1) = IFLOC
C
C     SWITCH FILE NAMES IN FIAT
C
      NAME(1)= IFIAT(PSAVE1+1)
      NAME(2)= IFIAT(PSAVE1+2)
      UNIT1  = ANDF(MASK2,IFIAT(PSAVE1))
      UNIT2  = ANDF(MASK2,IFIAT(PSAVE2))
      NWD    = ICFIAT*IFIAT(3)-2
      LTU1   = ANDF(MASK,IFIAT(PSAVE1))
      LTU2   = ANDF(MASK,IFIAT(PSAVE2))
      IFIAT(PSAVE1  ) = ORF(ANDF(IFIAT(PSAVE1),MASK2 ),LTU2)
      IFIAT(PSAVE1+1) = IFIAT(PSAVE2+1)
      IFIAT(PSAVE1+2) = IFIAT(PSAVE2+2)
      IFIAT(PSAVE2  ) = ORF(ANDF(IFIAT(PSAVE2),MASK2),LTU1)
      IFIAT(PSAVE2+1) = NAME(1)
      IFIAT(PSAVE2+2) = NAME(2)
C
C     SWITCH STACKED DATA BLOCKS
C
      DO 100 I = 4,NWD,ICFIAT
      IF (PSAVE1.EQ.I .OR. PSAVE2.EQ.I) GO TO 100
      IF (IFIAT(I+1).EQ.0 .AND. IFIAT(I+2).EQ.0) GO TO 100
      UNIT = ANDF(MASK2,IFIAT(I))
      IF (UNIT.NE.UNIT1 .AND. UNIT.NE.UNIT2) GO TO 100
      IF (UNIT .EQ. UNIT1) UNT = UNIT2
      IF (UNIT .EQ. UNIT2) UNT = UNIT1
      IF (I .GT. NUNIQE) GO TO 70
C
C     DATA BLOCK RESIDES IN UNIQUE PART OF FIAT
C     MOVE ENTRY TO BOTTOM
C
      IF (LASTWD+ICFIAT .LE. MXE) GO TO 40
      WRITE  (NOUT,30) SFM
   30 FORMAT (A25,' 1021, FIAT OVERFLOW')
      CALL MESAGE (-37,0,MODNAM)
   40 IFIAT(LASTWD+1) = ORF(ANDF(IFIAT(I),MASK3),UNT)
      DO 50 K = 2,ICFIAT
   50 IFIAT(LASTWD+K) = IFIAT(I+K-1)
      LASTWD   = LASTWD   + ICFIAT
      IFIAT(3) = IFIAT(3) + 1
C
C     CLEAR OLD ENTRY IN UNIQUE PART
C
      IFIAT(I) = ANDF(IFIAT(I),MASK2)
      J1 = I + 1
      J2 = I + ICFIAT - 1
      DO 60 K = J1,J2
   60 IFIAT(K) = 0
      GO TO 100
C
C     DATA BLOCK RESIDES IN NON-UNIQUE PORTION OF FIAT
C     SWITCH UNIT NUMBERS
C
   70 IFIAT(I) = ORF(ANDF(IFIAT(I),MASK3),UNT)
  100 CONTINUE
      RETURN
      END

      SUBROUTINE TLTR3D
C
C     DOUBLE PRECISION ROUTINE TO GENERATE EQUIVALENT THERMAL LOADS FOR
C     THE CTRIA3 ELEMENT.
C
C     WAS NAMED T3THLD (LOADVC,INTZ,Z) IN UAI
C
C
C
C                 EST  LISTING
C
C        WORD     TYP       DESCRIPTION
C     ----------------------------------------------------------------
C     ECT:
C         1        I   ELEMENT ID, EID
C         2-4      I   SIL LIST, GRIDS 1,2,3
C         5-7      R   MEMBRANE THICKNESSES T, AT GRIDS 1,2,3
C         8        R   MATERIAL PROPERTY ORIENTAION ANGLE, THETA
C               OR I   COORD. SYSTEM ID (SEE TM ON CTRIA3 CARD)
C         9        I   TYPE FLAG FOR WORD 8
C        10        R   GRID OFFSET, ZOFF
C    EPT:
C        11        I   MATERIAL ID FOR MEMBRANE, MID1
C        12        R   ELEMENT THICKNESS,T (MEMBRANE, UNIFORMED)
C        13        I   MATERIAL ID FOR BENDING, MID2
C        14        R   MOMENT OF INERTIA FACTOR, I (BENDING)
C        15        I   MATERIAL ID FOR TRANSVERSE SHEAR, MID3
C        16        R   TRANSV. SHEAR CORRECTION FACTOR, TS/T
C        17        R   NON-STRUCTURAL MASS, NSM
C        18-19     R   STRESS FIBER DISTANCES, Z1,Z2
C        20        I   MATERIAL ID FOR MEMBRANE-BENDING COUPLING, MID4
C        21        R   MATERIAL ANGLE OF ROTATION, THETA
C               OR I   COORD. SYSTEM ID (SEE MCSID ON PSHELL CARD)
C                      (DEFAULT FOR WORD 8)
C        22        I   TYPE FLAG FOR WORD 21 (DEFAULT FOR WORD 9)
C        23        I   INTEGRATION ORDER FLAG
C        24        R   STRESS ANGLE OF RATATION, THETA
C               OR I   COORD. SYSTEM ID (SEE SCSID ON PSHELL CARD)
C        25        I   TYPE FLAG FOR WORD 24
C        26        R   OFFSET, ZOFF1 (DEFAULT FOR WORD 10)
C    BGPDT:
C        27-38   I/R   CID,X,Y,Z  FOR GRIDS 1,2,3
C    ETT:
C        39        I   ELEMENT TEMPERATURE
C
C
C
      LOGICAL          MEMBRN,BENDNG,SHRFLX,MBCOUP,NORPTH,COMPOS,
     1                 TEMPP1,TEMPP2,SHEART,NOALFA
      INTEGER          HUNMEG,NEST(39),ELID,PID,MID(4),SIL(3),
     1                 IGPDT(4,3),NECPT(4),IORDER(3),COMPS,FLAG,
     2                 INDXG2(3,3),SYSBUF,NOUT,NOGO
      REAL             GPTH(3),BGPDT(4,3),ECPT(4),TSUB0,STEMP,Z,
     1                 LOADVC(1)
      DOUBLE PRECISION PT(6,3),PTG(6,3),PI,TWOPI,RADDEG,DEGRAD,
     1                 EGPDT(4,3),EPNORM(4,3),GPNORM(4,3),DGPTH(6),RHO,
     2                 THETAM,CENTE(3),SHPT(3),WEIGHT,WTSTIF,LX,LY,
     3                 BMATRX(162),BTERMS(6),DETJAC,G(6,6),GI(36),
     4                 AIC(1),DETG2,G2(3,3),EGNOR(4),MOMINR,TS,TH,
     5                 REALI,AVGTHK,TEM(9),TBG(9),TEB(9),TEU(9),TUB(9),
     6                 TUM(9),ALPHA(6),ALFAM(3),ALFAB(3),TALFAM(3),
     7                 TALFAB(3),TBAR,TGRAD,TMEAN,FTHERM(6),THRMOM(3),
     8                 GTEMPS(3),EPSLNT(6),EPSUBT(6),GEPSBT(6),
     9                 TRANS(27),OFFSET,TMPTRN(36),EPS,THETAE,EDGLEN(3)
      COMMON /SYSTEM/  SYSBUF,NOUT,NOGO
      COMMON /MATIN /  MATID,INFLAG,ELTEMP,DUMMY,SINMAT,COSMAT
      COMMON /BLANK /  NROWSP,IPARAM,COMPS
      COMMON /CONDAD/  PI,TWOPI,RADDEG,DEGRAD
      COMMON /TERMS /  MEMBRN,BENDNG,SHRFLX,MBCOUP,NORPTH
      COMMON /ZZZZZZ/  Z(1)
      COMMON /SGTMPD/  STEMP(7)
      COMMON /TRIMEX/  EST(39)
      EQUIVALENCE      (EST( 1),NEST(1)),(EST( 2),SIL(1)),
     1                 (EST( 5),GPTH(1)),(EST(10),ZOFF  ),
     2                 (EST(12),ELTH   ),(EST(26),ZOFF1 ),
     3                 (EST(39),TEMPEL ),(EST(27),BGPDT(1,1),IGPDT(1,1))
      EQUIVALENCE      (NECPT(1),ECPT(1)),(STEMP(7),FLAG),
     1                 (Z(1),LOADVC(1))
      DATA    HUNMEG,  EPS / 100000000, 1.0D-7 /
C
C
C     INITIALIZE
C
      NNODE  = 3
      ELID   = NEST(1)
      WEIGHT = 1.0D0/6.0D0
      SHEART =.FALSE.
      NOALFA =.FALSE.
      TGRAD  = 0.0D0
      ELTEMP = TEMPEL
      OFFSET = ZOFF
      IF (ZOFF .EQ. 0.0) OFFSET = ZOFF1
C
      DO 10 LL = 1,3
      TALFAM(LL) = 0.0D0
      TALFAB(LL) = 0.0D0
      FTHERM(LL) = 0.0D0
      FTHERM(LL+3) = 0.0D0
   10 CONTINUE
C
C     TEST FOR COMPOSITE ELEMENT
C
      PID    = NEST(11) - HUNMEG
      COMPOS = COMPS.EQ.-1 .AND. PID.GT.0
C
C     CHECK FOR THE TYPE OF TEMPERATURE DATA
C     - TYPE TEMPP1 ALSO INCLUDES TYPE TEMPP3.
C     - IF TEMPPI ARE NOT SUPPLIED, GRID POINT TEMPERATURES ARE PRESENT.
C
      TEMPP1 = FLAG .EQ. 13
      TEMPP2 = FLAG .EQ. 2
C
C     SET UP THE ELEMENT FORMULATION
C
      CALL T3SETD (IERR,SIL,IGPDT,ELTH,GPTH,DGPTH,EGPDT,GPNORM,EPNORM,
     1             IORDER,TEB,TUB,CENTE,AVGTHK,LX,LY,EDGLEN,ELID)
      IF (IERR .NE. 0) GO TO 520
      CALL GMMATD (TEB,3,3,0, TUB,3,3,1, TEU)
C
C     SET THE NUMBER OF DOF'S
C
      NNOD2 = NNODE*NNODE
      NDOF  = NNODE*6
      NPART = NDOF*NDOF
      ND2   = NDOF*2
      ND6   = NDOF*6
      ND7   = NDOF*7
      ND8   = NDOF*8
C
C     OBTAIN MATERIAL INFORMATION
C
C     PASS THE LOCATION OF THE ELEMENT CENTER FOR MATERIAL
C     TRANSFORMATIONS.
C
      DO 20 IEC = 2,4
      ECPT(IEC) = CENTE(IEC-1)
   20 CONTINUE
C
C     SET MATERIAL FLAGS
C     0.833333333D0 = 5.0D0/6.0D0
C
      IF (NEST(13) .NE.  0) MOMINR = EST(14)
      IF (NEST(13) .NE.  0) TS = EST(16)
      IF ( EST(16) .EQ. .0) TS = 0.83333333D0
      IF (NEST(13).EQ.0 .AND. NEST(11).GT.HUNMEG) TS = 0.83333333D0
C
      MID(1) = NEST(11)
      MID(2) = NEST(13)
      MID(3) = NEST(15)
      MID(4) = NEST(20)
C
      MEMBRN = MID(1).GT.0
      BENDNG = MID(2).GT.0 .AND. MOMINR.GT.0.0D0
      SHRFLX = MID(3).GT.0
      MBCOUP = MID(4).GT.0
      NORPTH = MID(1).EQ.MID(2) .AND. MID(1).EQ.MID(3) .AND. MID(4).EQ.0
     1         .AND. DABS(MOMINR-1.0D0).LE.EPS
C
C     SET UP TRANSFORMATION MATRIX FROM MATERIAL TO ELEMENT COORD.SYSTEM
C
      CALL SHCSGD (*530,NEST(9),NEST(8),NEST(8),NEST(21),NEST(20),
     1             NEST(20),NECPT,TUB,MCSID,THETAM,TUM)
      CALL GMMATD (TEU,3,3,0, TUM,3,3,0, TEM)
C
C     CALCULATE THE ANGLE BETWEEN THE MATERIAL AXIS AND THE ELEMENT AXIS
C
      THETAE = DATAN2(TEM(4),TEM(1))
C
C     FETCH MATERIAL PROPERTIES
C
      CALL SHGMGD (*540,ELID,TEM,MID,TS,NOALFA,GI,RHO,GSUBE,TSUB0,
     1             EGNOR,ALPHA)
C
      DO 30 IAL = 1,3
      ALFAM(IAL) = ALPHA(IAL  )
      ALFAB(IAL) = ALPHA(IAL+3)
   30 CONTINUE
C
C     TURN OFF THE COUPLING FLAG WHEN MID4 IS PRESENT WITH ALL
C     CALCULATED ZERO TERMS.
C
      IF (.NOT.MBCOUP) GO TO 50
      DO 40 I = 28,36
      IF (DABS(GI(I)) .GT. EPS) GO TO 50
   40 CONTINUE
      MBCOUP = .FALSE.
C
C     OBTAIN TEMPERATURE INFORMATION
C
C     IF TEMPP1 DATA, GET AVERAGE TEMP AND THERMAL GRADIENT.
C
   50 IF (.NOT.TEMPP1) GO TO 60
      TMEAN = STEMP(1)
      TGRAD = STEMP(2)
      GO TO 90
C
C     IF TEMPP2 DATA, GET THERMAL MOMENTS.
C
   60 IF (.NOT.TEMPP2) GO TO 70
      TMEAN = STEMP(1)
C
      THRMOM(1) = STEMP(2)
      THRMOM(2) = STEMP(3)
      THRMOM(3) = STEMP(4)
C
      FTHERM(4) = THRMOM(1)
      FTHERM(5) = THRMOM(2)
      FTHERM(6) = THRMOM(3)
      GO TO 90
C
C     TEMPPI TEMPERATURE DATA IS NOT AVAILABLE, THEREFORE SORT THE GRID
C     POINT TEMPERATURES (IN STEMP(1-7)).
C
   70 DO 80 I = 1,NNODE
      IPNT = IORDER(I)
      GTEMPS(I) = STEMP(IPNT)
   80 CONTINUE
      TMEAN = (GTEMPS(1)+GTEMPS(2)+GTEMPS(3))/3.0D0
   90 TBAR = TMEAN - TSUB0
C
C     CALCULATE THERMAL STRAINS FOR COMPOSITE ELEMENTS
C
      IF (.NOT.COMPOS) GO TO 100
      CALL SHCTSD (IERR,ELID,PID,MID,AVGTHK,TMEAN,TGRAD,THETAE,FTHERM,
     1             EPSLNT,Z,Z)
      IF (IERR .NE. 0) GO TO 500
C
C     INITIALIZE FOR THE MAIN INTEGRATION LOOP
C
  100 DO 110 I = 1,6
      EPSUBT(I) = 0.0D0
      DO 110 J = 1,NNODE
      PT (I,J)  = 0.0D0
      PTG(I,J)  = 0.0D0
  110 CONTINUE
C
C     MAIN INTEGRATION LOOP
C
      DO 400 IPT = 1,NNODE
      CALL T3BMGD (IERR,SHEART,IPT,IORDER,EGPDT,DGPTH,AIC,TH,DETJAC,
     1             SHPT,BTERMS,BMATRX)
      IF (IERR .NE. 0) GO TO 520
C
      WTSTIF = DETJAC*WEIGHT
      REALI  = MOMINR*TH*TH*TH/12.0D0
C
C     FILL IN THE 6X6 [G]
C
      DO 200 IG = 1,6
      DO 200 JG = 1,6
      G(IG,JG) = 0.0D0
  200 CONTINUE
C
      IF (.NOT.MEMBRN) GO TO 220
      DO 210 IG = 1,3
      IG1 = (IG-1)*3
      DO 210 JG = 1,3
      G(IG,JG) = GI(IG1+JG)*TH
  210 CONTINUE
C
  220 IF (.NOT.BENDNG) GO TO 250
      DO 230 IG = 4,6
      IG2 = (IG-2)*3
      DO 230 JG = 4,6
      G(IG,JG) = GI(IG2+JG)*REALI
  230 CONTINUE
C
      IF (.NOT.MBCOUP) GO TO 250
      DO 240 IG = 1,3
      IG4 = (IG+8)*3
      DO 240 JG = 1,3
      G(IG,JG+3) = GI(IG4+JG)*TH*TH
      G(IG+3,JG) = G(IG,JG+3)
  240 CONTINUE
C
C     PREPARE THERMAL STRAINS FOR COMPOSITE ELEMENTS
C
  250 IF (.NOT.COMPOS) GO TO 270
      DO 260 IR = 1,6
      EPSUBT(IR) = WTSTIF*EPSLNT(IR)
  260 CONTINUE
      GO TO 370
C
C     CALCULATE THERMAL STRAINS FOR NON-COMPOSITE ELEMENTS
C
  270 IF (.NOT.MEMBRN) GO TO 290
      DO 280 I = 1,3
      TALFAM(I) = TBAR*ALFAM(I)
  280 CONTINUE
C
  290 IF (.NOT.BENDNG) GO TO 350
      IF (.NOT.TEMPP1) GO TO 310
      DO 300 I = 1,3
      TALFAB(I) = -TGRAD*ALFAB(I)
  300 CONTINUE
      GO TO 350
C
  310 IF (.NOT.TEMPP2) GO TO 330
      DO 320 IG = 1,3
      DO 320 JG = 1,3
      G2(IG,JG) = G(IG+3,JG+3)
  320 CONTINUE
C
      CALL INVERD (3,G2,3,GDUM,0,DETG2,ISNGG2,INDXG2)
      CALL GMMATD (G2,3,3,0, THRMOM,3,1,0, TALFAB)
      GO TO 350
C
  330 DO 340 I = 1,3
      TALFAB(I) = 0.0D0
  340 CONTINUE
C
  350 DO 360 I = 1,3
      EPSUBT(I  ) = WTSTIF*TALFAM(I)
      EPSUBT(I+3) = WTSTIF*TALFAB(I)
  360 CONTINUE
C
C                                T
C     [P]  = [P]  + WTSTIF*[B] [G][EPS]
C        T      T                      T
C
  370 CALL GMMATD (G,6,6,0, EPSUBT,6,1,0, GEPSBT)
      CALL GMMATD (BMATRX,6,NDOF,-1, GEPSBT,6,1,0, PT)
C
  400 CONTINUE
C
C     END OF MAIN INTEGRATION LOOP
C
C     PICK UP THE ELEMENT TO GLOBAL TRANSFORMATION FOR EACH NODE.
C
      DO 420 I = 1,NNODE
      IPOINT = 9*(I-1)+1
      CALL TRANSD (BGPDT(1,I),TBG)
      CALL GMMATD (TEB,3,3,0, TBG,3,3,0, TRANS(IPOINT))
  420 CONTINUE
C
C     TRANSFORM THE THERMAL LOAD VECTOR INTO THE INDIVIDUAL GLOBAL
C     COORDINATE SYSTEMS OF EACH NODE.
C
C                 T
C     [PT] = [TEG] [PT]
C         G            E
C
      DO 430 I = 1,NNODE
      CALL TLDRD  (OFFSET,I,TRANS,TMPTRN)
      CALL GMMATD (TMPTRN,6,6,1, PT(1,I),6,1,0, PTG(1,I))
  430 CONTINUE
C
C     ADD THE THERMAL LOAD VECTOR TO THE GLOBAL LOAD VECTOR WHICH
C     RESIDES IN [LOADVC].
C
      DO 440 I = 1,NNODE
      K = SIL(I) - 1
      DO 440 J = 1,6
      LOADVC(K+J) = LOADVC(K+J) + SNGL(PTG(J,I))
  440 CONTINUE
      GO TO 600
C
C     FATAL ERRORS
C
  500 WRITE  (NOUT,510)
  510 FORMAT ('0*** SYSTEM FATAL ERROR.  APPROPRIATE COMPOSITE DATA ',
     1        'NOT FOUND IN MODULE SSG1.')
      GO TO 560
  520 J = 224
      GO TO 550
  530 J = 225
      NEST(2) = MCSID
      GO TO 550
  540 J = 226
      NEST(2) = MID(3)
  550 CALL MESAGE (30,J,NEST(1))
  560 NOGO = 1
C
  600 RETURN
      END

      SUBROUTINE FA1K (IMETH,K,RHO,OUTFIL,ICO)
C
C     FA1K BUILDS AN INTERPOLATED MATRIX ON OUTFIL FROM QHHL OR FSAVE
C
      LOGICAL         NEW
      INTEGER         SYSBUF,OUT,BUFF,BUFF1,FLOOP,NS(2),TYPE,TRL(7),
     1                OUTFIL,FSAVE,QHHL,SCR2,SCR3,SCR4,MCB(7)
      REAL            K
      DIMENSION       Z(1)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /ZZZZZZ/ IZ(1)
      COMMON /UNPAKX/ IOUT,INN,NNN,INCR1
      COMMON /PACKX / ITI,ITO,II,NN,INCR
      COMMON /SYSTEM/ SYSBUF,OUT,DUM(52),IPREC
      COMMON /BLANK / FLOOP
      EQUIVALENCE     (IZ(1),Z(1))
      DATA    FSAVE / 201/, QHHL /104/, SCR2,SCR3,SCR4 /302,303,304/
      DATA    NS    / 4HFA1K,4H    /
C
      NCORE = KORSZ(IZ) - ICO
      BUFF  = NCORE - SYSBUF
      BUFF1 = BUFF  - SYSBUF
      TRL(1)= FSAVE
      CALL RDTRL (TRL)
C
C     READ IN DEPENDENT POINTS AND SET K AND RHO
C
      JJ    = TRL(3)*3
      IFIL  = FSAVE
      CALL GOPEN (FSAVE,IZ(BUFF+1),0)
      CALL READ (*430,*5,FSAVE,Z,JJ,1,NWR)
    5 CONTINUE
      I     = (FLOOP-1)*3 + 1
      CMACH = Z(I  )
      K     = Z(I+1)
      RHO   = Z(I+2)
      INCR1 = 1
      INCR  = 1
      II    = 1
      INN   = 1
      GO TO (10,100), IMETH
C
C     SURFACE SPLINE INTERPOLATION
C
   10 IF (FLOOP .NE. 1) GO TO 70
C
C     SET UP CALL TO SPLINE INTERPOLATOR
C
      NRHO = TRL(7)
      JI   = NRHO*3
      J    = 1
      DO 50 I = 1,JJ,JI
      Z(J  ) = Z(I  )
      Z(J+1) = Z(I+1)
   50 J    = J + 2
      ND   = JJ/JI
      NI   = TRL(4)
      TYPE = 1
      IDP  = 1
      IIP  = ND*2 + IDP
      IG   = IIP + 2*NI
      NI2  = NI*2
      CALL READ (*430,*60,FSAVE,Z(IIP),NI2,1,NWR)
   60 CALL FWDREC (*430,FSAVE)
      CALL CLOSE (FSAVE,2)
C
C     REWRITE QHHL SO EACH LIST MATRIX IS A COLUMN
C
      GO TO 300
   15 J  = 1
   20 JI = IG
      GO TO 350
   30 IF (J .EQ. NCOL) GO TO 40
      J  = J + 1
      GO TO 20
   40 CALL CLOSE (QHHL,1)
      CALL CLOSE (OUTFIL,1)
      CALL WRTTRL (TRL)
      GO TO 200
C
C     GET A COLUMN FROM FSAVE AND BUILD QHH ON OUTFIL
C
   70 NF = 2 + (FLOOP-1)/TRL(7)
      DO 80 I = 1,NF
      CALL FWDREC (*430,FSAVE)
   80 CONTINUE
   85 IOUT = TRL(6)
      ITI  = IOUT
      ITO  = IOUT
      NWC  = 1
      IF (ITO.EQ.2 .OR. ITO.EQ.3) NWC = 2
      IF (ITO .EQ. 4) NWC = 4
      MCB(1) = QHHL
      CALL RDTRL (MCB)
      NC   = MCB(3)
      NN   = NC
      NNN  = NC*NC
      CALL UNPACK (*410,FSAVE,Z)
      IJ   = 1
      CALL CLOSE (FSAVE,1)
      CALL GOPEN (OUTFIL,IZ(BUFF+1),1)
      MCB(1) = OUTFIL
      MCB(2) = 0
      MCB(3) = NC
      MCB(4) = 1
      MCB(5) = IOUT
      MCB(6) = 0
      MCB(7) = 0
      DO 90 I = 1,NC
      CALL PACK (Z(IJ),OUTFIL,MCB)
      IJ = IJ + NC*NWC
   90 CONTINUE
      CALL CLOSE (OUTFIL,1)
      CALL WRTTRL (MCB)
      GO TO 450
C
C     LINEAR SPLINE INTERPOLATION
C
C
C     IS A GOOD MATRIZ ON FSAVE
C
  100 EPS = .001
      NEW = .TRUE.
      NI  = TRL(4)
      IF (FLOOP .EQ. 1) GO TO 110
      OK    = Z(I-2)
      OMACH = Z(I-3)
      IF (ABS(CMACH-OMACH) .LT. EPS) NEW = .FALSE.
C
C     REWRITE QHHL IF NEW IS TRUE
C
      IF (.NOT.NEW) GO TO 180
      IF (FLOOP .NE. 1) GO TO 120
C
C     TEST TO SEE IF QHHL HAS ENOUGH MACH NUMBERS
C
  110 NIP  = NI*2
      NOGO = 0
      IIP  = JJ + 1
      CALL READ (*430,*111,FSAVE,Z(IIP),NIP,1,NWR)
  111 CALL BCKREC (FSAVE)
      TEMP = 0.0
      DO 119 I = 1,JJ,3
      IF (TEMP .EQ. Z(I)) GO TO 119
      TEMP = Z(I)
      NF   = 0
      DO 115 J = 1,NIP,2
      IF (TEMP-Z(IIP+J-1) .LT. EPS) NF = NF + 1
  115 CONTINUE
      IF (NF .GT. 1) GO TO 119
      WRITE (OUT,400) UFM,TEMP
      NOGO = 1
  119 CONTINUE
      IF (NOGO .EQ.1 ) GO TO 410
  120 J   = 1
      NRD = 0
      DO 125 I = 1,JJ,3
      IF (ABS(CMACH-Z(I)) .LT. EPS) GO TO 126
      GO TO 125
  126 IF (Z(I+2) .NE. RHO) GO TO 125
      Z(J  ) = Z(I  )
      Z(J+1) = Z(I+1)
      J   = J + 2
      NRD = NRD + 1
  125 CONTINUE
      IDP = 1
      IIP = NRD*2 + IDP
      NI2 = NI*2
      CALL READ (*430,*130,FSAVE,Z(IIP),NI2,1,NWR)
  130 CALL FWDREC (*430,FSAVE)
      CALL CLOSE (FSAVE,2)
      GO TO 300
  135 IG  = IIP + NI*2
      NF  = 0
      IK  = 1
      IFIL= QHHL
      JJ  = 2*NI + 1
      I   = 1
  138 IF (ABS(CMACH-Z(IIP+I-1)) .LT. EPS) GO TO 140
C
C     SKIP MATRIX
C
      DO 139 J = 1,NCM
  139 CALL FWDREC (*430,QHHL)
      GO TO 150
  140 Z(IIP+IK) = Z(IIP+I)
      IK = IK + 2
      NF = NF + 1
      JI = IG
      GO TO 350
  150 CONTINUE
      I  = I + 2
      IF (I .EQ. JJ) GO TO 160
      GO TO 138
  160 CALL CLOSE (QHHL,1)
      CALL CLOSE (OUTFIL,1)
      CALL WRTTRL (TRL)
C
C     SET UP CALL TO SPLINE INTERPOLATION
C
      TYPE = -1
      ND   = NRD
      NI   = NF
      GO TO 200
C
C     GET COLUMN FROM FSAVE AND BUILD QHH
C
  170 CALL GOPEN (FSAVE,IZ(BUFF+1),0)
      IJ = 3
  171 DO 175 I = 1,IJ
  175 CALL FWDREC (*430,FSAVE)
      GO TO 85
  180 IF (OK-K.EQ.0.0) GO TO 190
      TRL(7) = TRL(7) + 1
  190 IJ = TRL(7) + 1
      CALL WRTTRL (TRL)
      GO TO 171
C
C     CALL MINTRP
C
  200 IG   = IIP + 2*NI
      NC   = NCORE - IG
      NOGO = 0
      CALL MINTRP (NI,Z(IIP),ND,Z(IDP),TYPE,0,0,0.0,OUTFIL,SCR2,SCR3,
     1             SCR4,Z(IG),NC,NOGO,IPREC)
      IF (NOGO .EQ. 1) GO TO 410
C
C     INTERPOLATED MATRIX IS ON SCR2 MOVE TO FSAVE
C
      CALL OPEN (*430,FSAVE,IZ(BUFF+1),3)
      CALL GOPEN (SCR2,IZ(BUFF1+1),0)
      TRL(1) = SCR2
      CALL RDTRL (TRL)
      NCOL = TRL(2)
      NN   = TRL(3)
      NNN  = NN
      ITI  = TRL(5)
      ITO  = ITI
      IOUT = ITI
      TRL(1) = FSAVE
      TRL(2) = 0
      TRL(6) = 0
      TRL(7) = 0
      I = 1
  210 CALL UNPACK (*410,SCR2,Z)
      CALL PACK (Z,FSAVE,TRL)
      IF (I .EQ. NCOL) GO TO 230
      I = I + 1
      GO TO 210
  230 CALL CLOSE (SCR2,1)
      CALL CLOSE (FSAVE,1)
      CALL RDTRL (TRL)
      TRL(6) = ITO
      IF (IMETH .EQ. 2) TRL(7) = 1
      CALL WRTTRL (TRL)
      GO TO 170
C
C     SET UP COLUMN - MATRIX COPY
C
  300 CALL GOPEN (QHHL,IZ(BUFF+1),0)
      TRL(1) = QHHL
      CALL RDTRL (TRL)
      NCOL = TRL(2)/TRL(3)
      NCM  = TRL(3)
      CALL GOPEN (OUTFIL,IZ(BUFF1+1),1)
      NNN  = NCM
      NN   = NCM*NCM
      ITI  = TRL(5)
      ITO  = ITI
      IOUT = ITI
      NWC  = 1
      IF (ITO.EQ.2 .OR. ITO.EQ.3) NWC = 2
      IF (ITO .EQ. 4) NWC = 4
      TRL(1) = OUTFIL
      TRL(2) = 0
      TRL(3) = NN
      TRL(6) = 0
      TRL(7) = 0
      GO TO (15,135), IMETH
C
C     MAKE A COLUMN INTO MATRIX
C
  350 DO 390 ILOP = 1,NCM
      CALL UNPACK (*360,QHHL,Z(JI))
      GO TO 380
  360 N = NCM*NWC
      DO 370 IJ = 1,N
  370 Z(JI+IJ-1) = 0.0
  380 JI = JI + NCM*NWC
  390 CONTINUE
      CALL PACK (Z(IG),OUTFIL,TRL)
      GO TO (30,150), IMETH
C
C     ERROR MESSAGES
C
  400 FORMAT (A23,' 2270, LINEAR INTERPOLATION WITHOUT ENOUGH IND. ',
     1       'MACH NUMBERS EQUAL TO DEP. MACH ',F10.4)
  410 WRITE  (OUT,420) UFM
  420 FORMAT (A23,' 2271, INTERPOLATION MATRIX IS SINGULAR')
      GO TO  440
  430 CALL MESAGE (-3,IFIL,NS)
  440 CALL MESAGE (-61,0,NS)
  450 RETURN
      END

      SUBROUTINE MMA2 ( ZI, ZR, ZD, ZC, ZDC )
C
C     MMA2 PERFORMS THE MATRIX OPERATION USING METHODS 20 AND 21 
C       (+/-)A(T & NT) * B (+/-)C = D
C     
C     MMA2 IS DESIGNED AS FOLLOWS:
C       1.  THIS IS FOR "A" NON-TRANSPOSED AND TRANSPOSED
C       2.  UNPACK AS MANY COLUMNS OF "B" INTO MEMORY AS POSSIBLE
C           LEAVING SPACE FOR A COLUMN OF "D" FOR EVERY COLUMN "B" READ.
C       3.  INITIALIZE EACH COLUMN OF "D" WITH THE DATA FROM "C".
C       4.  CALL UNPACK TO READ MATRICES "B" AND "C".
C       5.  FOR METHOD 20, CALL UNPACK TO READ COLUMNS OF MATRIX "A".
C       6.  FOR METHOD 21, CALL MMARC1,2,3,4 TO READ COLUMNS OF MATRIX "A"
C           INTO MEMORY IN COMPACT FORM.
C
      INTEGER           ZI(2)      ,MODULE(3),SYSBUF,SCRTCH
      INTEGER           TYPEI      ,TYPEP    ,TYPEU ,SIGNAB, SIGNC
      INTEGER           RD         ,RDREW    ,WRT   ,WRTREW, CLSREW,CLS
      INTEGER           FILEA      ,FILEB ,FILEC , FILED
      REAL              ZR(2)
      DOUBLE PRECISION  ZD(2)
      COMPLEX           ZC(2)
      DOUBLE COMPLEX    ZDC(2)
      INCLUDE           'MMACOM.COM'
      COMMON / NAMES  / RD         ,RDREW    ,WRT   ,WRTREW, CLSREW,CLS
      COMMON / TYPE   / IPRC(2)    ,NWORDS(4),IRC(4)
      COMMON / MPYADX / FILEA(7)   ,FILEB(7) ,FILEC(7)    
     1,                 FILED(7)   ,NZ       ,T     ,SIGNAB,SIGNC ,PREC1 
     2,                 SCRTCH     ,TIME
      COMMON / SYSTEM / KSYSTM(152)
      COMMON / UNPAKX / TYPEU      ,IUROW1   ,IUROWN, INCRU
      COMMON / PACKX  / TYPEI      ,TYPEP    ,IPROW1, IPROWN , INCRP
      EQUIVALENCE       (KSYSTM( 1),SYSBUF)  , (KSYSTM( 2),NOUT  ) 
     1,                 (KSYSTM(58),KSYS58)
      EQUIVALENCE       (FILEA(2)  ,NAC   )  , (FILEA(3)  ,NAR   )
     1,                 (FILEA(4)  ,NAFORM)  , (FILEA(5)  ,NATYPE)
     2,                 (FILEA(6)  ,NANZWD)  , (FILEA(7)  ,NADENS)
      EQUIVALENCE       (FILEB(2)  ,NBC   )  , (FILEB(3)  ,NBR   )
     1,                 (FILEB(4)  ,NBFORM)  , (FILEB(5)  ,NBTYPE)
     2,                 (FILEB(6)  ,NBNZWD)  , (FILEB(7)  ,NBDENS)
      EQUIVALENCE       (FILEC(2)  ,NCC   )  , (FILEC(3)  ,NCR   )
     1,                 (FILEC(4)  ,NCFORM)  , (FILEC(5)  ,NCTYPE)
     2,                 (FILEC(6)  ,NCNZWD)  , (FILEC(7)  ,NCDENS)
      EQUIVALENCE       (FILED(2)  ,NDC   )  , (FILED(3)  ,NDR   )
     1,                 (FILED(4)  ,NDFORM)  , (FILED(5)  ,NDTYPE)
     2,                 (FILED(6)  ,NDNZWD)  , (FILED(7)  ,NDDENS)
C
      DATA    MODULE / 4HMMA2  , 4H     ,4H    /
      DATA    KZERO  / 1H0    /
      DATA    KONE   / 1H1    /
      DATA    JBEGN  / 4HBEGN/ , JEND  / 3HEND /
      IF ( NASTOR .EQ. 1 .OR. KSYS58 .EQ. 20 ) MODULE( 2 ) = KZERO
      IF ( NASTOR .EQ. 2 .OR. KSYS58 .EQ. 21 ) MODULE( 2 ) = KONE
      MODULE( 3 ) = JBEGN
      CALL CONMSG ( MODULE, 3, 0 )
      INCRU  = 1
      TYPEI  = NDTYPE
      TYPEP  = NDTYPE
      NWDD   = NWORDS( NDTYPE )
      IRFILE = FILEA( 1 )
C
C   OPEN CORE ALLOCATION AS FOLLOWS:
C     Z( 1        ) = ARRAY FOR ONE COLUMN OF "A" MATRIX
C     Z( IDX      ) = ARRAY FOR MULTIPLE COLUMNS OF "D" MATRIX
C     Z( IBX      ) = ARRAY FOR MULTIPLE COLUMNS OF "B" MATRIX
C        THROUGH
C     Z( LASMEM   )
C     Z( IBUF4    ) = BUFFER FOR "D" FILE
C     Z( IBUF3    ) = BUFFER FOR "C" FILE
C     Z( IBUF2    ) = BUFFER FOR "B" FILE 
C     Z( IBUF1    ) = BUFFER FOR "A" FILE
C     Z( NZ       ) = END OF OPEN CORE THAT IS AVAILABLE
C
      IDX    = 1 + NWDD*NAR  
      IF ( NASTOR .NE. 2 .AND. KSYS58 .NE. 21 ) GO TO 90
C
C REDEFINE IDX AND INSURE A QUAD WORD BOUNDARY FOR COMPLEX DOUBLE
C
      IDX = 1 + NWDD*NAR + NAR
      ITEST  = MOD ( IDX, 4 )
      IF ( ITEST .EQ. 1 ) GO TO 90
      IF ( ITEST .EQ. 0 ) IDX = IDX + 1
      IF ( ITEST .EQ. 2 ) IDX = IDX + 3
      IF ( ITEST .EQ. 3 ) IDX = IDX + 2
90    CONTINUE
      IDX2   = ( ( IDX+1 ) / 2 ) - 1
      IDX4   = ( IDX+1 ) / 4
      IBUF1  = NZ    - SYSBUF
      IBUF2  = IBUF1 - SYSBUF
      IF ( FILEC( 1 ) .EQ. 0 ) GO TO 100
      IBUF3  = IBUF2 - SYSBUF
      IBUF4  = IBUF3 - SYSBUF
      GO TO 200
100   CONTINUE
      IBUF4  = IBUF2 - SYSBUF
200   CONTINUE
      LASMEM = IBUF4 - 1
      IPROW1 = 1
      IPROWN = NDR
      INCRP  = 1
      SIGN   = 1.0
      CALL GOPEN  ( FILEA, ZR( IBUF1 ), RDREW )
      CALL GOPEN  ( FILEB, ZR( IBUF2 ), RDREW )   
      IF ( FILEC( 1 ) .NE. 0 ) CALL GOPEN  ( FILEC, ZR( IBUF3 ), RDREW )   
      CALL GOPEN  ( FILED, ZR( IBUF4 ), WRTREW )   
      FILED( 2 ) = 0
      FILED( 6 ) = 0
      FILED( 7 ) = 0
C
C   DETERMINE HOW MANY COLUMNS OF "B" CAN BE READ INTO MEMORY AND HOW
C   MANY COLUMNS OF "D" CAN BE HELD IN MEMORY FOR ONE PASS
C
      IAVAIL = LASMEM - IDX + 1 
C
C   NCOLPP  -  NUMBER OF COLUMNS OF "B" THAT CAN BE READ IN ONE PASS
C   NPASS   -  NUMBER OF PASSES NEEDED TO READ ENTIRE "B" MATRIX
C      
      NWDDNDR = NWDD * NDR
      NWDDNBR = NWDD * NBR
      NCOLPP  = IAVAIL / ( 2+ NWDDNBR + NWDDNDR )
      IF ( NCOLPP .LE. 0 ) 
     &     CALL MESAGE ( -8, IAVAIL+NWDDNBR+NWDDNDR, MODULE)
      IF ( NCOLPP .GT. NBC ) NCOLPP = NBC
      NPASS   = ( (NBC-1) / NCOLPP ) + 1
      IBX     = IDX + NCOLPP*NWDDNDR
      DO 70000 M = 1, NPASS
      IPASS   = M
      IF ( M .EQ. NPASS ) NCOLPP = NBC - ( NCOLPP*(NPASS-1) )
      CALL REWIND ( FILEA )
      CALL SKPREC ( FILEA, 1 )
      INDXB  = IBX
      INDXD  = IDX
      TYPEU  = NDTYPE * SIGNAB  
      DO 600 I = 1, NCOLPP
      IUROW1 = -1
      CALL UNPACK ( *500, FILEB, ZR( INDXB+2 ) )
      ZI( INDXB   ) = IUROW1
      ZI( INDXB+1 ) = IUROWN
      GO TO 550
500   CONTINUE
C NULL COLUMN READ ON "B"
      ZI( INDXB   ) = 0
      ZI( INDXB+1 ) = 0
550   CONTINUE
      INDXB   = INDXB + NWDDNBR + 2
600   CONTINUE
      IF ( FILEC( 1 ) .EQ. 0 .OR. SIGNC .EQ. 0 ) GO TO 800
      TYPEU   = NDTYPE * SIGNC  
      IUROW1 = 1
      IUROWN = NCR
      DO 700 I = 1, NCOLPP
      CALL UNPACK ( *650, FILEC, ZR( INDXD ) )
      GO TO 680
C
C NULL COLUMN READ ON "C" 
C
650   CONTINUE
      LEN     = INDXD + NWDDNDR - 1
      DO 620 K = INDXD, LEN
      ZR( K ) = 0.0
620   CONTINUE
680   CONTINUE
      INDXD   = INDXD + NWDDNDR  
700   CONTINUE
      GO TO 900
C
C "C" MATRIX IS NULL OR "SIGNC" IS ZERO
C
800   CONTINUE
      LEN = IDX + NCOLPP*NWDDNDR - 1
      DO 850 K = IDX, LEN
      ZR( K ) = 0.
850   CONTINUE
900   CONTINUE
C
C PROCESS ALL OF THE COLUMNS OF "A" 
C      
      IF ( KSYS58 .EQ. 21 ) GO TO 1000
      IF ( KSYS58 .EQ. 20 ) GO TO 950
      IF ( NASTOR .EQ. 2  ) GO TO 1000
950   CONTINUE
      IF ( NDTYPE .EQ. 1 ) CALL MMA201 ( ZI, ZR )        
      IF ( NDTYPE .EQ. 2 ) CALL MMA202 ( ZI, ZD )   
      IF ( NDTYPE .EQ. 3 ) CALL MMA203 ( ZI, ZC )
      IF ( NDTYPE .EQ. 4 ) CALL MMA204 ( ZI, ZD, ZDC )
      GO TO 70000
1000  CONTINUE
      IF ( NDTYPE .EQ. 1 ) CALL MMA211 ( ZI, ZR )        
      IF ( NDTYPE .EQ. 2 ) CALL MMA212 ( ZI, ZD )   
      IF ( NDTYPE .EQ. 3 ) CALL MMA213 ( ZI, ZC )
      IF ( NDTYPE .EQ. 4 ) CALL MMA214 ( ZI, ZD, ZDC )
70000 CONTINUE
      CALL CLOSE ( FILEA, CLSREW )
      CALL CLOSE ( FILEB, CLSREW )
      CALL CLOSE ( FILEC, CLSREW )
      CALL CLOSE ( FILED, CLSREW )
      MODULE( 3 ) = JEND
      CALL CONMSG ( MODULE, 3, 0 )
      RETURN
      END

      SUBROUTINE DDCOMP
C
C     DDCOMP IS THE DMAP DRIVER FOR DECOMP
C
C     DECOMP    KAA/LLL,ULL/SYM/CHLSKY/MINDIA/DET/POWER/SING $
C
C        SYM    =  1 - USE SYMMETRIC DECOMPOSITION
C                  0 - CHOOSE WHICH DECOMPOSITION BASED ON INPUT MATRIX
C                 -1 - USE UNSYMETRIC DECOMPOSITION
C        CHLSKY =  1 USE CHOLESKY DECOMPOSITION LLL = C
C        DET    =  DETERMINANT OF KAA
C        POWER  =  SCALE FACTOR FOR DET
C        MINDIA =  MINIMUM DIAGONAL OF ULL
C        SING   = -1 SINGULAR MATRIX
C
      INTEGER          ULL       ,SYM      ,POWER    ,SING     ,
     1                 CHLSKY    ,NAME(2)  ,SQR      ,RECT     ,
     2                 OUTPT     ,UPPER
      REAL             ZZ(1)     ,ZZZ(1)
      DOUBLE PRECISION CDET      ,CMNDIA   ,MINDIA   ,SDETC    ,
     1                 MINDS     ,DDET     ,DMNDIA   ,SDET
      CHARACTER        UFM*23    ,UWM*25   ,UIM*29   ,SFM*25   ,
     1                 SWM*27
      COMMON /XMSSG /  UFM       ,UWM      ,UIM      ,SFM      ,
     1                 SWM
      COMMON /BLANK /  ISYM      ,CHLSKY                       ,
     1                 MINDIA    ,DET(2)   ,POWER    ,SING
      COMMON /SFACT /  IFILA(7)  ,IFILL(7) ,IFILU(7) ,KSCR1    ,
     1                 KSCR2     ,NZ       ,SDET     ,SDETC    ,
     2                 KPOW      ,KSCR3    ,MINDS    ,ICHLK
      COMMON /DCOMPX/  IA(7)     ,IL(7)    ,IU(7)    ,ISCR1    ,
     1                 ISCR2     ,ISCR3    ,DDET     ,IPOW     ,
     2                 NZZ       ,DMNDIA   ,IB
      COMMON /CDCMPX/  JA(7)     ,JL(7)    ,JU(7)    ,JSCR1    ,
     1                 JSCR2     ,JSCR3    ,CDET(2)  ,JPOW     ,
     2                 NZZZ      ,CMNDIA   ,JB
      COMMON /NAMES /  KNAMES(19)
      COMMON /SYSTEM/  KSYSTM(65)
      COMMON /ZZZZZZ/  Z(1)
      EQUIVALENCE      (ZZ(1),Z(1))
      EQUIVALENCE      (ZZZ(1),Z(1))
      EQUIVALENCE      (KSYSTM( 2),OUTPT)  ,(KNAMES(12),SQR)   ,
     1                 (KNAMES(13),RECT )  ,(KNAMES(17),SYM)   ,
     2                 (KNAMES(16),UPPER)  ,(KNAMES(15),LOWER)
      DATA    KAA,     LLL,   ULL,    LSCR1,  LSCR2,  LSCR3,  LSCR4 /
     1        101,     201,   202,    301  ,  302  ,  303  ,  304   /
      DATA    NAME  /  4HDDCO,4HMP    /
C
      SING  = 0
      JA(1) = KAA
      CALL RDTRL (JA)
      IFORM = JA(4)
      IF (ISYM) 10,50,30
   10 IF (IFORM .EQ. SYM) WRITE (OUTPT,20) SWM,NAME
   20 FORMAT (A27,' 2340, MODULE ',2A4,' HAS BEEN REQUESTED TO DO ',
     1       'UNSYMMETRIC DECOMPOSITION OF A SYMMETRIC MATRIX')
      IFORM = RECT
      IF (JA(2) .EQ. JA(3)) IFORM = SQR
      GO TO 50
   30 IF (JA(2).EQ.JA(3) .AND. IFORM.NE.SYM) WRITE (OUTPT,40) SWM,NAME
   40 FORMAT (A27,' 2341, MODULE ',2A4,'HAS BEEN FURNISHED A SQUARE ',
     1       'MATRIX MARKED UNSYMMETRIC FOR SYMMETRIC DECOMPOSITION.')
      IFORM = SYM
   50 ISYM  = -1
      IF (IFORM .EQ. SYM) ISYM = 1
      JA(4) = IFORM
      IF (ISYM .LT. 0) GO TO 200
C
C     SET UP CALL TO SDCOMP
C
      IFILA(1) = KAA
      CALL RDTRL (IFILA)
      IFILL(1) = LLL
      IFILU(1) = LSCR4
      KSCR1    = LSCR1
      KSCR2    = LSCR2
      KSCR3    = LSCR3
      NZ       = KORSZ(Z)
      IFILL(5) = IFILA(5)
      ICHLK    = CHLSKY
      CALL SDCOMP (*400,Z,Z,Z)
      DET(1)   = SDET
      DET(2)   = SDETC
      MINDIA   = MINDS
      POWER    = KPOW
      IFILL(2) = IFILA(2)
      IFILL(3) = IFILA(3)
      IFILL(4) = LOWER
      CALL WRTTRL (IFILL)
      RETURN
C
C     SET UP CALL TO DECOMP
C
  200 CONTINUE
      IF (JA(5) .GT. 2) GO TO 300
      IA(1)  = KAA
      CALL RDTRL (IA)
      IL(1)  = LLL
      IU(1)  = ULL
      NZZ    = KORSZ(ZZ)
      ISCR1  = LSCR1
      ISCR2  = LSCR2
      ISCR3  = LSCR3
      IB     = 0
      IL(5)  = 2
      CALL DECOMP (*400,ZZ,ZZ,ZZ)
      IU(5)  = 2
      IL(4)  = LOWER
      IU(4)  = UPPER
      IL(3)  = IL(2)
      IU(3)  = IU(2)
      DET(1) = DDET
      DET(2) = 0.0
      POWER  = IPOW
      MINDIA = DMNDIA
      CALL WRTTRL (IU)
      CALL WRTTRL (IL)
      RETURN
C
C     SET UP CALL TO CDCOMP
C
  300 CONTINUE
      JL(1)  = LLL
      JU(1)  = ULL
      JSCR1  = LSCR1
      JSCR2  = LSCR2
      JSCR3  = LSCR3
      NZZZ   = KORSZ(ZZZ)
      JL(5)  = 4
      JB     = 0
      CALL CDCOMP (*400,ZZZ,ZZZ,ZZZ)
      JU(5)  = 4
      JL(4)  = LOWER
      JU(4)  = UPPER
      JL(3)  = JL(2)
      JU(3)  = JU(2)
      DET(1) = CDET(1)
      DET(2) = CDET(2)
      MINDIA = CMNDIA
      POWER  = JPOW
      CALL WRTTRL (JL)
      CALL WRTTRL (JU)
      RETURN
C
  400 SING   = -1
      DET(1) = 0.0
      DET(2) = 0.0
      POWER  = 0
      MINDIA = 0.0
      CALL FNAME (KAA,JA(1))
      WRITE  (OUTPT,410) UIM,JA(1),JA(2)
  410 FORMAT (A29,' FORM DECOMP MODULE. MATRIX ',2A4,' IS SINGULAR')
      RETURN
      END

      SUBROUTINE CASEGE
C
C GENERATES IDENTICAL SUBCASES LMODES*NDIR TIMES FOR DDAM
C
C     CASEGEN  CASECC/CASEDD/C,Y,LMODES/V,N,NDIR/V,N,NMODES $
C    EQUIV CASEDD,CASECC  $
C
      INTEGER BUF1,BUF2,SYSBUF,CASECC,CASEDD
      DIMENSION IZ(1),NAM(2),MCB(7)
      COMMON/SYSTEM/SYSBUF
      COMMON/BLANK/LMODES,NDIR,NMODES
      COMMON/ZZZZZZ/Z(1)
      EQUIVALENCE (Z(1),IZ(1))
      DATA CASECC,CASEDD/101,201/
      DATA NAM/4HCASE,4HGE  /
C
      LCORE=KORSZ(Z)
      BUF1=LCORE-SYSBUF+1
      BUF2=BUF1-SYSBUF
      LCORE=BUF2-1
      IF(LCORE.LE.0)GO TO 1008
C
      CALL GOPEN(CASECC,Z(BUF1),0)
      CALL GOPEN(CASEDD,Z(BUF2),1)
      CALL READ (*1002,*10,CASECC,Z,LCORE,0,IWORDS)
      GO TO 1008
   10 IF(LMODES.GT.NMODES)LMODES=NMODES
      ITOT=LMODES*NDIR
      DO 20 I=1,ITOT
      IZ(1)=I
      CALL WRITE(CASEDD,Z,IWORDS,1)
   20 CONTINUE
      CALL CLOSE(CASECC,1)
      CALL CLOSE(CASEDD,1)
      MCB(1)=CASECC
      CALL RDTRL(MCB)
      MCB(1)=CASEDD
      MCB(2)=ITOT
      CALL WRTTRL(MCB)
      RETURN
C
 1002 CALL MESAGE(-2,CASECC,NAM)
 1008 CALL MESAGE(-8,0,NAM)
      RETURN
      END

      SUBROUTINE FERFBD(V1,V2,V3,VB)
C
C  FERFBD is a modification of the old FRBK2 subroutine.  It has been
C  modified to read matrix data from memory until that data is exhausted
C  and then to read the remaining data from the file.
C
      DOUBLE PRECISION  DCORE(1)
      DOUBLE PRECISION  V1(1)     ,V2(1)     ,V3(1)     ,VB(1)  ,
     1                  XL(1)     ,XLJJ      ,V3J       ,V2J
      INTEGER           IBLK(20)  ,SMAPOS
      COMMON / ZZZZZZ / ICORE(1)   
      COMMON / OPINV  / MCBLT(7)  ,MCBSMA(7)
      COMMON / SYSTEM / KSYSTM(65)
      COMMON / FEERIM / NIDSMA    ,NIDLT     ,NIDORV    ,NLTLI   
     1,                 NSMALI    ,IBFSMA    ,IBFLT
     2,                 IBFORV    ,SMAPOS(7) ,LTPOS(7)
      EQUIVALENCE       ( KSYSTM(02),NOUT)
      EQUIVALENCE       ( DCORE(1)  ,ICORE(1), XL )  
C
      NROW    = MCBLT(2)
      DO 10 I = 1,NROW
   10 V2(I) = V1(I)
      ILROW = LTPOS( 1 )
      ICROW = NROW
C      PRINT *,' FERFBD,ILROW,NIDLT=',ILROW,NIDLT
C      PRINT *,' LTPOS=',LTPOS
      IF ( ILROW .EQ. NROW .AND. NIDLT .NE. 0 ) GO TO 1000
C
C     BACKWARD SUBSTITUTION
C
C     POSITION FILE TO LAST COLUMN
C
      IF ( NIDLT .EQ. 0 ) GO TO 12
  11  CONTINUE
      CALL DSSPOS ( MCBLT, LTPOS(5), LTPOS(6), LTPOS(7) )
      GO TO 16
  12  IF ( LTPOS( 5 ) .NE. -1 ) GO TO 11
      CALL REWIND ( MCBLT )
      CALL SKPREC ( MCBLT, NROW+1 )
      CALL DSCPOS ( MCBLT, IBLOCK, ICLR, ICBP )
      LTPOS( 5 ) = IBLOCK
      LTPOS( 6 ) = ICLR
      LTPOS( 7 ) = ICBP
  16  CONTINUE
      IBLK( 1 ) = MCBLT( 1 )
      J       = NROW
  15  IBLK(8) = -1
      ICROW   = J
      IF ( J .LE. ILROW ) GO TO 1000
  20  CALL GETSTB(*50,IBLK(1))
      NTMS    = IBLK(6)
      JI      = IBLK(5)
      IK      = IBLK(4)
      IF( IK - NTMS + 1 .NE. J) GO TO 25
      NTMS    = NTMS - 1
      XLJJ    = XL(JI-NTMS)
      IF(NTMS .EQ. 0) GO TO 40
   25 V2J     = V2(J)
      DO 30 II= 1,NTMS
      V2J     = V2J + XL(JI) * V2(IK)
      JI      = JI - 1
      IK      = IK - 1
   30 CONTINUE
      V2(J)   = V2J
   40 CALL ENDGTB(IBLK(1))
      GO TO 20
   50 V2(J)   = V2(J) / XLJJ
      IF(J .EQ. 1) GO TO 2000
      J       = J -1
      GO TO 15
C
C     CONTINUE BACKWARD SUBSTITUTION WITH DATA IN MEMORY
C
1000  CONTINUE
      MEM     = NLTLI
C      PRINT *,' AT 1000,NLTLI=',NLTLI
      NTMS    = ICORE(MEM)
C      PRINT *,' ICORE(NLTLI,-1=',ICORE(NLTLI),ICORE(NLTLI-1)
      MEM     = MEM - 2*NTMS - 3
      J       = ICROW
 1015 ICOL    = ICORE(MEM)
C      PRINT *,' MEM,ICORE(MEM-1,0,+1=',MEM,ICORE(MEM-1),ICORE(MEM),
C     & ICORE(MEM+1)
C      PRINT *,' ICOL,MEM,NTMS,ICROW,J=',ICOL,MEM,NTMS,ICROW,J
      IF ( ICOL .NE. J ) GO TO 1050
      NTMS    = ICORE(MEM+1)
C      PRINT *,' FERFBD,A1015,J,NTMS,ICOL=',J,NTMS,ICOL
      NTMSS   = NTMS
      JI      = MEM/2 + 1 + NTMS
      IK      = ICORE( MEM + 2 + 2*NTMS ) + NTMS - 1
C      PRINT *,' FERFBD,IK=',IK
      IF( IK-NTMS+1 .NE. J) GO TO 1025
      NTMS    = NTMS - 1
      XLJJ    = DCORE(JI-NTMS)
C      PRINT *,' FERFBD,XLJJ=',XLJJ
      IF(NTMS .EQ. 0) GO TO 1040
 1025 V2J     = V2(J)
      DO 1030 II= 1,NTMS
      V2J     = V2J + DCORE(JI) * V2(IK)
      JI      = JI - 1
      IK      = IK - 1
 1030 CONTINUE
      V2(J)   = V2J
 1040 IF ( MEM .EQ. NIDLT ) GO TO 1050
      NTMSNX  = ICORE( MEM-1 )
      MEM     = MEM - 2*NTMSNX - 4
      GO TO 1015
 1050 V2(J)   = V2(J) / XLJJ
      IF(J .EQ. 1) GO TO 2000
      J       = J -1
      GO TO 1015
2000  CONTINUE
      CALL FERLTD(MCBSMA(1),V2(1),V3(1),VB(1) )
C
C BEGIN FORWARD SWEEP DIRECTLY ON V3
C
      ICROW = 1
      IF ( NIDLT .EQ. 0 ) GO TO 3005
      MEM=NIDLT
      DO 2120 J = 1, NROW
      ICROW = J
      IF ( J .GT. ILROW ) GO TO 3000
 2080 ICOL  = ICORE(MEM)
      IF( ICOL .NE. J ) GO TO 2120
      JI    = MEM/2 + 2
      NTMS  = ICORE( MEM+1 )
      NTMSS = NTMS
      IK    = ICORE(MEM + 2 + 2*NTMS)
      IF ( IK .NE. J ) GO TO 2085
      NTMS  = NTMS - 1
      V3(J) = V3(J) / DCORE(JI)
      JI    = JI + 1
      IK    = IK + 1
 2085 IF(NTMS .EQ. 0) GO TO 2100
      V3J   = V3(J)
      DO 2090 II = 1,NTMS
      V3(IK)= V3(IK) + DCORE(JI) * V3J
      IK    = IK + 1
      JI    = JI + 1
 2090 CONTINUE
 2100 MEM   = MEM + 2*NTMSS + 4
      GO TO 2080
 2120 CONTINUE
      GO TO 7000
 3000 CONTINUE
C
C     CONTINUE FORWARD SWEEP DIRECTLY ON V3
C
C     POSITION FILE TO CONTINUE READING COLUMN DATA NOT IN MEMORY
C
      CALL DSSPOS ( MCBLT, LTPOS(2), LTPOS(3), LTPOS(4) )
      GO TO 3008
 3005 CALL REWIND ( MCBLT )
      CALL SKPREC ( MCBLT, 1 )
 3008 CONTINUE
      DO 3120 J = ICROW, NROW
      IBLK( 8 ) = -1
 3080 CALL GETSTR( *3120, IBLK )
C      PRINT *,' GETSTR,J,IBLK(12=',J,IBLK(12)
      IK    = IBLK( 4 )
      JI    = IBLK( 5 )
      NTMS  = IBLK( 6 )
      IF ( IK .NE. J) GO TO 3085
      NTMS  = NTMS - 1
C      PRINT *,' IK,JI,XL(JI=',IK,JI,XL(JI)
      V3(J) = V3(J) / XL(JI)
      JI    = JI + 1
      IK    = IK + 1
 3085 IF(NTMS .EQ. 0) GO TO 3100
      V3J   = V3(J)
      DO 3090 II = 1,NTMS
      V3(IK)= V3(IK) + XL(JI) * V3J
      IK    = IK + 1
      JI    = JI + 1
 3090 CONTINUE
 3100 CALL ENDGET(IBLK(1))
      GO TO 3080
 3120 CONTINUE
      GO TO 7000
 7000 CONTINUE
      RETURN
      END

      SUBROUTINE EMGOUT (RBUF,DBUF,LBUF,EOE,DICT,FILE,INPREC)
C
C     THIS ROUTINE OF THE -EMG- MODULE WRITES THE DATA IN -BUF- TO
C     -FILE-.
C
C     BEFORE CALLING THIS ROUTINE THE CALLING ROUTINE SETS UP THE
C     FOLLOWING ARGUMENTS.....
C
C     RBUF,DBUF  =  BOTH POINT TO THE SAME MATRIX ARRAY CONTAINING THE
C                   MATRIX DATA TO BE OUTPUT.
C
C     LBUF   = NUMBER OF DATA VALUES TO BE OUTPUT ON CURRENT CALL NOT
C              CONSIDERING THE PRECISION OF THE DATA VALUES.
C
C     EOE    = SEE BELOW.
C
C     DICT   = ARRAY OF SIZE NLOCS (SEE BELOW) + 5.  WORDS 1 THROUGH 5
C              OF THIS ARRAY ARE SET BY THE CALLING ROUITNE.(SEE BELOW)
C
C     FILE   = SET TO 1 IF STIFFNESS MATRIX
C              SET TO 2 IF MASS MATRIX
C              SET TO 3 IF DAMPING MATRIX
C
C     INPREC = PRECISION OF THE DATA  RBUF AND DBUF POINT TO.
C              SET = 1 IF SINGLE AND SET TO 2 IF DOUBLE.
C
C     --- IMPORTANT--- UNDER NO CIRCUMSTANCES SHOULD THE CALLING PROGRAM
C     MODIFY DATA IN COMMON BLOCK /EMGDIC/.
C
C     NOTE.  ON EACH CALL TO THIS ROUTINE THE CALLING ROUTINE MUST SEND
C     AN AMOUNT OF DATA FOR ONE OR MORE GRID POINT-PARTITIONS OF THE
C     TOTAL ELEMENT MATRIX.  THIS IS CONSIDERING DEGREES OF FREEDOM AND
C     ANY CONDENSATION OF THE DATA IF A DIAGONAL MATRIX IS BEING SENT.)
C
C     IE. FOR A MATRIX WHERE 6 DEGREES OF FREEDOM ARE LISTED IN THE CODE
C     WORD OF THE DICTIONARY THEN THE FOLLWING WOULD BE CONSIDERED.
C
C     IF THE MATRIX WAS DIAGONAL THE VALUE OF LBUF WOULD BE SIMPLY
C     (0 TO NLOCS) TIMES 6
C
C     IF THE MATRIX WAS SQUARE THEN LBUF WOULD BE
C     (0 TO NLOCS) TIMES 6 TIMES NLOCS TIMES 6.  NOTE THE PRECISION DOES
C     NOT ENTER INTO THE CALCULATION OF LBUF BY THE CALLING ROUTINE)
C
C     IF -EOE- IS GREATER THAN 0, INDICATING END-OF-ELEMENT-DATA, THE
C     DICTIONARY WILL BE WRITTEN TO THE APPROPRIATE COMPANION FILE
C     OF -FILE-.  IF CONGRUENT LOGIC IS ACTIVE THE DICTIONARY WILL
C     ALSO BE PLACED IN CORE IF POSSIBLE.
C
C     CHECKS TO INSURE THAT THE CALLING ROUTINE SENT A REASONABLY
C     CORRECT AMOUNT OF MATRIX DATA ARE MADE BY THIS ROUTINE.
C
C     DICTIONARY FORMAT 1)ELEMENT-COUNTER-ID-POSITON-IN-EST
C     ================= 2)F = 1 IF SQUARE, = 2 IF DIAGONAL FORMAT DATA.
C     DICTIONARY        3)N = NUMBER OF CONNECTED GRID POINTS * FREEDOMS
C     CAN EXPAND        4)COMPONENT-CODE-WORD
C     THROUGH THE       5)DAMPING CONSTANT
C     MIDDLE.                    .
C           LDICT-NLOC+1)GINO-LOC. (FIRST PARTITION)
C                                .
C                                .
C                                . (NLOCS GINO-LOC VALUES)
C                                .
C                LDICT-1)GINO-LOC. (NEXT TO LAST PARTITION)
C                  LDICT)GINO-LOC. (LAST PARTITION OF THIS ELEMENT IF
C                                  ALL -NLOCS- GRID POINTS CONNECTED.)
C
C     THIS ROUTINE WILL WRITE PARTITIONS OF THE MATRIX WHERE THE NUMBER
C     OF COLUMNS IN EACH PARTITION WRITTEN EQUALS ACTIVE FREEDOMS
C     WHICH = NUMBER OF BITS ON IN THE CODE WORD ( DICT(4) ).
C
C     THE VALUES OF DICT(1), DICT(2), DICT(3), DICT(4), AND DICT(5) MUST
C     REMAIN CONSTANT BETWEEN CALLS TO THIS ROUTINE WITH RESPECT TO
C     A PARTICULAR ELEMENT ID AND FILE TYPE.
C
C     ONE OR MORE PARTITIONS WILL BE WRITTEN ON EACH CALL.
C
      LOGICAL          ANYCON, ERROR, HEAT
      INTEGER          LOCS(3), OUTPT, DICT(5), FILE, EOE, Z,
     1                 DICTN, NLOCS, PART(3), ELTYPE, ELID, EOR, PRECIS,
     2                 ESTID, FLAGS, QFILE, FREDMS(3)
      REAL             RBUF(LBUF)
      DOUBLE PRECISION DBUF(LBUF), DA
      CHARACTER        UFM*23, UWM*25, UIM*29, SFM*25
      COMMON /XMSSG /  UFM, UWM, UIM, SFM
      COMMON /BLANK /  XXXXX(3), NOK4GG
      COMMON /SYSTEM/  KSYSTM(65)
      COMMON /EMGDIC/  ELTYPE, LDICT, NLOCS, ELID, ESTID
      COMMON /EMGFIL/  MISC(5), MATRIX(3), DICTN(3)
      COMMON /EMGPRM/  ICORE, JCORE, NCORE, ICSTM, NCSTM, IMAT, NMAT,
     1                 IHMAT, NHMAT, IDIT, NDIT, ICONG, NCONG, LCONG,
     2                 ANYCON, FLAGS(3), PRECIS, ERROR, HEAT, ICMBAR,
     3                 LCSTM, LMAT, LHMAT, KFLAGS(3)
      COMMON /ZZZZZZ/  Z(1)
      COMMON /IEMGOT/  NVAL(3)
      EQUIVALENCE      (KSYSTM(2), OUTPT), (FFF,IFFF)
      DATA    EOR   ,  NOEOR, MAXFIL / 1, 0, 3 /
C
      IF (ERROR) RETURN
      IF (FILE.GE.1 .AND. FILE.LE.MAXFIL) GO TO 30
C
C     ILLEGAL FILE VALUE
C
      WRITE  (OUTPT,10) SFM,FILE
   10 FORMAT (A25,' 3108, EMGOUT RECEIVES ILLEGAL FILE TYPE =',I10)
   20 ERROR = .TRUE.
      RETURN
C
C     ON FIRST CALL TO THIS ROUTINE FOR THIS ELEMENT THE SIZE OF COLUMN
C     AND SIZE OF PARTITION BEING WRITTEN IS SET.
C     IF NVAL(FILE) .GT. 0 THEN THIS IS NOT THE FIRST CALL.
C
   30 IF (KFLAGS(FILE) .EQ. 0) RETURN
      IF (NVAL(FILE)) 40,40,80
   40 NVAL(FILE) = DICT(3)
C
C     DETERMINE NUMBER OF ACTIVE FREEDOMS BY COUNTING BITS ON IN CODE
C     WORD.  THIS CODE ADDED AS AN TEMPORARY NECESSITY.
C
      IF (DICT(4) .EQ. 63) GO TO 46
      I = DICT(4)
      ITEMP = 0
      DO 45 J = 1,31
      IF (MOD(I,2)) 44,44,43
   43 ITEMP = ITEMP + 1
   44 I = I / 2
      IF (I) 47,47,45
   45 CONTINUE
      GO TO 47
C
   46 ITEMP = 6
   47 FREDMS(FILE) = ITEMP
C
C     CHECK NUMBER OF ACTIVE GRID POINTS FOR THIS ELEMENT TO BE
C     LESS THAN OR EQUAL TO NLOCS.
C
      IGRIDS = DICT(3)/FREDMS(FILE)
      IF (IGRIDS .LE. NLOCS) GO TO 48
      WRITE  (OUTPT,42) SFM,IGRIDS,ELID
   42 FORMAT (A25,' 3122,  EMGOUT HAS DETERMINED THAT THERE ARE',I10,
     1       ' CONNECTING GRID POINTS FOR ELEMENT ID =',I10, /5X,
     2       'THIS IS GREATER THAN THE MAXIMUM AS PER /GPTA1/ TABLE ',
     3       'FOR THE TYPE OF THIS ELEMENT. PROBABLE ERROR IN ELEMENT',
     4       ' ROUTINE PROGRAM')
      GO TO 20
C
   48 LOCS(FILE) = LDICT - NLOCS
C
C     ZERO ALL GINO-LOC SLOTS IN DICTIONARY.
C
      I = LDICT - NLOCS + 1
      DO 49 J = I,LDICT
      DICT(J) = 0
   49 CONTINUE
      IF (DICT(2) .EQ. 1) GO TO 60
      IF (DICT(2) .EQ. 2) GO TO 70
      WRITE  (OUTPT,50) SFM,DICT(2),ELID
   50 FORMAT (A25,' 3109, EMGOUT HAS BEEN SENT AN INVALID DICTIONARY ',
     1       'WORD-2 =',I10,' FROM ELEMENT ID =',I10)
      GO TO 20
C
C     FULL SQUARE MATRIX WILL BE OUTPUT. (VALUES PER PARTITION TO WRITE)
C
   60 PART(FILE) = DICT(3)*FREDMS(FILE)
      GO TO 80
C
C     DIAGONAL MATRIX.  (VALUES PER PARTITION TO WRITE)
C
   70 PART(FILE) = FREDMS(FILE)
C
C     WRITE MATRIX DATA TO FILE DESIRED.
C
   80 NWORDS = PART(FILE)
      IF (MOD(LBUF,NWORDS)) 90,110,90
   90 WRITE  (OUTPT,100) SFM,ELID
  100 FORMAT (A25,' 3110, EMGOUT HAS BEEN CALLED TO WRITE AN INCORRECT',
     1       ' NUMBER OF WORDS FOR ELEMENT ID =',I10)
      GO TO 20
C
  110 ILOC = LOCS(FILE)
      IF (LBUF .LE. 0) GO TO 130
      QFILE = MATRIX(FILE)
      IF (INPREC .NE. PRECIS) GO TO 121
C
C     INPUT AND OUTPUT PRECISIONS ARE THE SAME
C
      N2WORD = PRECIS*NWORDS
      K = 1
      DO 120 I = 1,LBUF,NWORDS
      ILOC = ILOC + 1
      CALL WRITE (QFILE,RBUF(K),N2WORD,EOR)
      CALL SAVPOS (QFILE,DICT(ILOC))
      K = K + N2WORD
  120 CONTINUE
      GO TO 129
C
C     INPUT PRECISION IS DIFFERENT FROM OUTPUT PRECISION
C
  121 K = 0
      DO 126 I = 1,LBUF,NWORDS
      K = K + NWORDS
      IF (PRECIS .EQ. 2) GO TO 123
C
C     DOUBLE PRECISION INPUT AND SINGLE PRECISION OUTPUT
C
      DO 122 J = I,K
      RA = DBUF(J)
      CALL WRITE (QFILE,RA,1,NOEOR)
  122 CONTINUE
      GO TO 125
C
C     SINGLE PRECISION INPUT AND DOUBLE PRECISION OUTPUT
C
  123 DO 124 J = I,K
      DA = RBUF(J)
      CALL WRITE (QFILE,DA,2,NOEOR)
  124 CONTINUE
  125 ILOC = ILOC + 1
      CALL WRITE (QFILE,0,0,EOR)
      CALL SAVPOS (QFILE,DICT(ILOC))
  126 CONTINUE
C
  129 LOCS(FILE) = ILOC
C
C     IF -EOE- .GT. 0 (IMPLYING END-OF-ELEMENT-DATA) WRITE
C     OUT THE COMPLETED DICTIONARY.
C
  130 IF (EOE) 140,140,150
  140 RETURN
C
C     OK -EOE- IS ON.  FIRST WRITE DICTIONARY OUT.
C     INSURE ALL -LOCS- SET CONSIDERING THE NUMBER OF ACTIVE GRID POINTS
C     FOR THIS PARTICULAR ELEMENT.
C
  150 IF (LOCS(FILE) .EQ. LDICT-NLOCS+DICT(3)/FREDMS(FILE)) GO TO 170
      WRITE  (OUTPT,160) SFM,ELID,FILE
  160 FORMAT (A25,' 3111, INVALID NUMBER OF PARTITIONS WERE SENT EMGOUT'
     1,      ' FOR ELEMENT ID =',I10, /5X,'WITH RESPECT TO DATA BLOCK ',
     2       'TYPE =',I3,1H.)
      GO TO 20
C
  170 IF (FLAGS(FILE) .GE. 0) GO TO 172
      FLAGS(FILE) = IABS(FLAGS(FILE))
      CALL WRITE (DICTN(FILE),ELTYPE,3,NOEOR)
  172 FLAGS(FILE) = FLAGS(FILE) + 1
      CALL WRITE (DICTN(FILE),DICT,LDICT,NOEOR)
      NVAL(FILE)  = 0
C
C     EXISTENCE OF NON-ZERO DAMPING CONSTANT TURNS ON NOK4GG FLAG.
C
      IF (NOK4GG) 177,177,179
  177 IFFF = DICT(5)
      IF (FFF) 178,179,178
  178 NOK4GG = 1
C
C     CHECK FOR THIS ELEMENT BEING IN CONGRUENT LIST.
C
C     EMGOUT WILL NEVER BE CALLED FOR AN ELEMENT WHICH IS IN THE
C     CONGRUENT LIST AND ALREADY HAS A DICTIONARY.
C
  179 IF (.NOT. ANYCON) GO TO 140
      CALL BISLOC (*140,ELID,Z(ICONG),2,LCONG/2,J)
C
C     OK ELEMENT IS CONGRUENT, FIND PRIMARY ID.
C
      IADD   = ICONG + J
  180 IPRIME = Z(IADD)
C
C     IPRIME .GT. 0 POINTS TO PRIMARY ID
C     IPRIME .EQ. 0 IS PRIMARY ID TABLE POINTER AND NO TABLE EXISTS
C     IPRIME .LT. 0 IS TABLE POINTER NEGATED.
C
      IF (IPRIME) 260,210,200
C
C     IPRIME POINTS TO PRIMARY ID
C
  200 IADD = IPRIME + 1
      GO TO 180
C
C     IPRIME IS TABLE POINTER AND NONE EXISTS YET.
C     THUS ADD ONE TO CORE, FROM THE BOTTOM OF CORE.
C
  210 IF (NCORE-MAXFIL .GT. JCORE) GO TO 240
C
C     NOT ENOUGH CORE SO CONGRUENCY IS IGNORED.
C
      ICRQ = JCORE - NCORE + MAXFIL
  220 CALL PAGE2 (4)
      WRITE  (OUTPT,230) UIM,ELID
  230 FORMAT (A29,' 3112, ELEMENTS CONGRUENT TO ELEMENT ID =',I10, /5X,
     1       'WILL BE RE-COMPUTED AS THERE IS INSUFFICIENT CORE AT ',
     2       'THIS MOMENT TO HOLD DICTIONARY DATA.')
      WRITE  (OUTPT,232) ICRQ
  232 FORMAT (5X,24HADDITIONAL CORE NEEDED =,I8,7H WORDS.)
      GO TO 140
C
C     ALLOCATE SMALL TABLE FOR POINTERS TO DICTIONARY FOR EACH FILE TYPE
C     POSSIBLE.
C
C     NOTE THAT THE ELEMENT-ID (IF SECONDARY) WILL HAVE A POINTER TO THE
C     PRIMARY-ID.  THE PRIMARY-ID  THEN WILL HAVE A POINTER TO A TABLE
C     OF SIZE -MAXFIL- POINTING TO -MAXFIL- DICTIONARYS.  (SOME OF WHICH
C     MAY NOT YET OR EVER BE CREATED).
C     NO CORE IS USED UNTIL A DICTIONARY IS CREATED.
C
  240 I2    = NCORE
      NCORE = NCORE - MAXFIL
      I1    = NCORE + 1
      DO 250 I = I1,I2
      Z(I)  = 0
  250 CONTINUE
C
C     STORE ZERO ADDRESS OF THIS TABLE WITH PRIMARY ID.
C
      Z(IADD) = -NCORE
      IPRIME  = -NCORE
C
C     IPRIME IS NEGATIVE ZERO POINTER TO FILE-DICTIONARY-TABLE FOR THIS
C     CONGRUENCY SET.
C
  260 ITAB = -IPRIME
C
C     ALLOCATE DICTIONARY SPACE IN CORE, IF THERE IS CORE,
C     SET FILE POSITION IN TABLE TO POINT TO THIS DICTIONARY,
C     AND STORE THE DICTIONARY.
C
      IF (NCORE-LDICT .GT. JCORE) GO TO 270
C
C     INSUFFICIENT CORE THUS IGNORE CONGRUENCY, AND FOR SAFETY
C     PURGE THIS CONGRUENCY FOR ALL FILES.
C
      ICRQ = JCORE - NCORE + LDICT
      Z(IADD) = 0
      GO TO 220
C
C     ALLOCATE AND WRITE DICTIONARY
C
  270 NCORE = NCORE - LDICT
      J = NCORE
      DO 280 I = 1,LDICT
      J = J + 1
      Z(J) = DICT(I)
  280 CONTINUE
C
C     STORE DICTIONARY ADDRESS IN TABLE(FILE), WHERE TABLE BEGINS
C     AT Z(ITAB+1).
C
      Z(ITAB+FILE) = NCORE + 1
      GO TO 140
      END

      SUBROUTINE MBREG (IREG,NW1,NWN,NC21,NC2N,NC1,NCN,ND1,NDN,XK,YK,
     1                  XK1,YK1,XK2,YK2,XWTE,YWTE,KTE,KTE1,KTE2,PAREA)
C
C     SUBROUTINE TO COMPUTE LIMITS OF REGION AND PERCENTAGE OF BOX IN
C     EACH
C
      LOGICAL         CNTRL2,CNTRL1,CRANK1,CRANK2,ASYM,DEBUG
      DIMENSION       NW1(1),NWN(1),NC21(1),NC2N(1),NC1(1),NCN(1),
     1                ND1(1),NDN(1),XK(1),YK(1),XK1(1),YK1(1),XK2(1),
     2                YK2(1),XWTE(1),YWTE(1),KTE(1),KTE1(1),KTE2(1)
      DIMENSION PAREA(50,50,3)
      COMMON /SYSTEM/ SYS,N6
      COMMON /MBOXA / X(12),Y(12),TANG(10),ANG(10),COTANG(10)
      COMMON /MBOXC / NJJ ,CRANK1,CRANK2,CNTRL1,CNTRL2,NBOX,NPTS0,NPTS1,
     1                NPTS2,ASYM,GC,CR,MACH,BETA,EK,EKBAR,EKM,BOXL,BOXW,
     2                BOXA ,NCB,NSB,NSBD,NTOTE,KC,KC1,KC2,KCT,KC1T,KC2T
      DATA    DEBUG / .FALSE./
C
      IPRINT = 0
      IF (DEBUG) IPRINT = 1
C
      IREG = 1
      BOXA = BOXL*BOXW
      KPT  = 0
      KC1T = 0
      KC2T = 0
      DO 20 I = 1,50
      NW1(I)  = 0
      NWN(I)  = 0
      NC1(I)  = 0
      NCN(I)  = 0
      NC21(I) = 0
      NC2N(I) = 0
      ND1(I)  = 0
      NDN(I)  = 0
      KTE(I)  = 0
      KTE1(I) = 0
      KTE2(I) = 0
      XWTE(I) = 0.0
      YWTE(I) = 0.0
      DO 10 J = 1,50
      DO 10 KP = 1,3
      PAREA(I,J,KP) = 0.
   10 CONTINUE
   20 CONTINUE
      DO 30 I = 1,200
      XK(I) = 0.0
   30 YK(I) = 0.0
      DO 40 I = 1,125
      XK1(I) = 0.0
      YK1(I) = 0.0
      XK2(I) = 0.0
   40 YK2(I) = 0.0
C
C     LEADING EDGE OF MAIN
C
      XRE = 0.0
      YBE = 0.0
      K   = 1
      YR  = -0.5*BOXW
      DO 220 I = 1,NSB
      YL  = YR
      YR  = (FLOAT(I)-0.5)*BOXW
      XLE = XRE
      IF (YR .GT. Y(K+1)) GO TO 50
      XRE = (YR-Y(K))*TANG(K) + X(K)
      GO TO 60
   50 XRE = (YR-Y(K+1))*TANG(K+1) + X(K+1)
      KPT = 1
   60 XT  = XLE - AMOD(XLE,BOXL)
      XB  = XT + BOXL
      J1  = XB/BOXL + 0.01
C
C
      DO 170 J = J1,NCB
      IF (XRE .GT. XB) GO TO 100
      IF (XLE .GT. XT) GO TO 90
C
      IF (XT .LE. X(K+1)) GO TO 70
      YTE  = (XT-X(K+1))*COTANG(K+1) + Y(K+1)
      GO TO 80
   70 YTE  = (XT-X(K))*COTANG(K) + Y(K)
      IF (KPT .EQ. 1) KPT =  2
   80 A = 0.5*(YR-YTE)*(XRE-XT)
      IF (KPT .EQ. 2) A = A + (XT*(Y(K+1)-YR) - YTE*(X(K+1)-XRE) +
     1                    X(K+1)*YR - XRE*Y(K+1))/2.0
      PA = 1.0 - A/BOXA
      GO TO 180
C
   90 A  = 0.5*(XLE+XRE-2.0*XT)*(YR-YL)
      IF (KPT .GT. 0) A = A + (XLE*(Y(K+1)-YR) - YL*(X(K+1)-XRE) +
     1                    X(K+1)*YR - XRE*Y(K+1))/2.0
      PA = 1.0 - A/BOXA
      GO TO 180
C
  100 IF (XLE .GT. XT) GO TO 130
C
      YTE = YBE
      IF (XB .GT. X(K+1)) GO TO 110
      YBE = (XB-X(K))*COTANG(K) + Y(K)
      GO TO 120
  110 YBE = (XB-X(K+1))*COTANG(K+1) + Y(K+1)
      IF (KPT .EQ. 1) KPT  =  2
  120 A = 0.5*(YTE+YBE-2.0*YL)*BOXL
      IF (KPT .EQ. 2) A = A + (XT*(YBE-Y(K+1)) - YTE*(XB-X(K+1)) +
     1                    XB*Y(K+1) - YBE*X(K+1))/2.0
      PA = A/BOXA
      GO TO 160
C
  130 IF (XB .GT. X(K+1)) GO TO 140
      YBE = (XB-X(K))*COTANG(K) + Y(K)
      GO TO 150
  140 YBE = (XB-X(K+1))*COTANG(K+1) + Y(K+1)
      IF (KPT .EQ. 1) KPT =  2
  150 A   = 0.5*(XB-XLE)*(YBE-YL)
      IF (KPT .EQ. 2) A = A + (XLE*(YBE-Y(K+1)) - YL*(XB-X(K+1)) +
     1                    XB*Y(K+1) - YBE*X(K+1))/2.0
      PA  = A/BOXA
  160 XT  = XB
      XB  = FLOAT(J+1)*BOXL
      IF (KPT .EQ. 2) KPT = 3
      IF (I .EQ. 1) PA = 2.0*PA - 1.0
      PAREA(J,I,1) = PA
  170 CONTINUE
      GO TO 190
C
  180 IF (I .EQ. 1) PA = 2.0*PA - 1.0
      PAREA(J,I,1) = PA
  190 YC  = YR - 0.5*BOXW
      IF (KPT .LE. 0) GO TO 200
      IF (YC .LE. Y(K+1)) GO TO 200
      XC  = (YC-Y(K+1))*TANG(K+1) + X(K+1)
      GO TO 210
  200 XC  =  (YC-Y(K))*TANG(K) + X(K)
  210 NW1(I) = XLE/BOXL + 1.0001
      IF (KPT .GT. 0) K = K + 1
      KPT = 0
  220 CONTINUE
      IF (IPRINT .LE. 0) GO TO 250
      WRITE  (N6,240)
      WRITE  (N6,230) (NW1(I),I=1,NSB)
  230 FORMAT (10I12)
  240 FORMAT (4H NW1)
  250 CONTINUE
C
C     TRAILING EDGE OF MAIN
C
      XRE = X(4)
      K   = 4
      YR  = 0.0
      DO 460 I = 1,NSB
      YL  = YR
      YR  = (FLOAT(I)-0.5)*BOXW
      XLE = XRE
      IF (YR .GT. Y(K+1)) GO TO 260
      XRE = (YR-Y(K))*TANG(K) + X(K)
      GO TO 270
  260 XRE = (YR-Y(K+1))*TANG(K+1) + X(K+1)
      KPT = 1
  270 XT  = XLE - AMOD(XLE,BOXL)
      XB  = XT + BOXL
      J   = XB/BOXL + 0.01
      IF (J .GT. 50) GO TO 410
      IPT = 0
      IF (XRE.GT.XB .OR. XRE.LT.XT) GO TO 280
      A   = 0.5*(XLE+XRE-2.0*XT)*(YR-YL)
      IF (KPT .GT. 0) A = A + (XLE*(Y(K+1)-YR) - YL*(X(K+1)-XRE) +
     1                    X(K+1)*YR - Y(K+1)*XRE)/2.0
      IF (I .EQ. 1) A = 2.0*A
      GO TO 430
C
  280 IPT = 1
      IF (XLE .LT. XRE) GO TO 340
      IPT = -1
  290 IF (XRE .LT. XT) GO TO 300
C
      A  =  0.5*(XB-XRE)*(YR-YTE)
      IF (KPT.GT.0 .AND. KPT.LT.3) A = A - (XRE*(YTE - Y(K+1)) -
     1                   YR*(XB-X(K+1)) + XB*Y(K+1) - YTE*X(K+1))/2.0
      IF (I .EQ. 1) A = 2.0*A
      GO TO 420
C
  300 YBE = YTE
      IF (XT .LT. X(K+1)) GO TO 310
      YTE = (XT-X(K))*COTANG(K) + Y(K)
      GO TO 320
  310 YTE = (XT-X(K+1))*COTANG(K+1) + Y(K+1)
      IF (KPT .EQ. 1) KPT =  2
  320 IF (XLE .GT. XB) GO TO 330
C
      A = 0.5*(XLE-XT)*(YTE-YL)
      IF (KPT .EQ. 2) A = A + (XT*(YL-Y(K+1)) - YTE*(XLE-X(K+1)) +
     1                    XLE*Y(K+1) - YL*X(K+1))/2.0
      GO TO 390
C
  330 A = 0.5*BOXL*(YTE+YBE - 2.0*YL)
      IF (KPT .EQ. 2) A = A + (XT*(YBE-Y(K+1)) - YTE*(XB- X(K+1)) +
     1                    XB*Y(K+1) - YBE*X(K+1))/2.0
      GO TO 390
C
  340 IF (XRE .GT. XB) GO TO 350
C
      A = 0.5*(YR-YBE)*(XRE-XT)
      IF (KPT.GT.0 .AND. KPT.LT.3) A = A + (XT*(Y(K+1)-YR) -
     1                   YBE*(X(K+1)-XRE ) + X(K+1)*YR - Y(K+1)*XRE)/2.0
      IF (I .EQ. 1) A = 2.0*A
      GO TO 430
C
  350 YTE = YBE
      IF (XB .GT. X(K+1)) GO TO 360
      YBE = (XB-X(K))*COTANG(K) + Y(K)
      GO TO 370
  360 YBE = (XB-X(K+1))*COTANG(K+1) + Y(K+1)
      IF (KPT .EQ.  1) KPT = 2
  370 IF (XLE .LT. XT) GO TO 380
C
      A  = 0.5*(XB-XLE)*(YBE-YL)
      IF (KPT .EQ. 2) A = A - (XLE*(Y(K+1)-YBE) - YL* (X(K+1)-XB) +
     1                    X(K+1)*YBE - Y(K+1)*XB)/2.0
      IF (I .EQ. 1) A = 2.0*A
      A  =  BOXA - A
      GO TO 400
C
  380 A  =  0.5*BOXL*(2.0*YR - YTE - YBE)
      IF (KPT .EQ. 2) A = A + (XT*(Y(K+1)-YBE) - YTE*(X(K+1)-XB) +
     1                    X(K+1)*YBE - Y(K+1)*XB)/2.0
C
  390 IF (I .EQ. 1) A = 2.0*A
  400 PA = A/BOXA
      A  = 1.0
      IF (PAREA(J,I,1) .GT. 0.0) A = PAREA(J,I,1)
      PAREA(J,I,1) = PA*A
      J  = J + IPT
      IF (J .GT. 50) GO TO 410
      XB = FLOAT(J)*BOXL
      XT = XB - BOXL
      IF (KPT .EQ. 2) KPT = 3
      IF (IPT .GT. 0) GO TO 340
      GO TO 290
  410 IREG = 2
      RETURN
C
  420 A  = BOXA - A
  430 YC = YR - 0.5*BOXW
      IF (KPT .LE. 0) GO TO 440
      IF (YC .LE. Y(K+1)) GO TO 440
      XC = (YC-Y(K+1))*TANG(K+1) + X(K+1)
      GO TO 450
  440 XC = (YC-Y(K))*TANG(K) + X(K)
  450 NWN(I) = AMAX1(XLE,XRE)/BOXL + 0.9999
      PA = A/BOXA
      A  = 1.0
      IF (PAREA(J,I,1) .GT. 0.0) A = PAREA(J,I,1)
      PAREA(J,I,1) = PA*A
      XWTE(I) = XC
      YWTE(I) = YC
      IF (KPT .GT. 0) K = K + 1
      KPT =  0
  460 CONTINUE
      IF (IPRINT .LE. 0) GO TO 480
      WRITE  (N6,470)
      WRITE  (N6,230) (NWN(I),I=1,NSB)
  470 FORMAT (4H NWN)
  480 CONTINUE
      NTOTE = NSB
C
C     FILL IN MAIN PERCENTAGES
C
      DO 520 I = 1,NSB
      N1 = NW1(I)
      NN = NWN(I)
      DO 490 J = N1,NN
      IF (PAREA(J,I,1) .LE. 0.0) PAREA(J,I,1) = 1.0
  490 CONTINUE
C
C     DIAPHRAGM INDEX
C
      IF (I .NE. 1) GO TO 500
      ND1(1) = NW1(1)
      NDN(1) = NWN(1)
      GO TO 520
  500 ND1(I) = MIN0(NW1(I),ND1(I-1)+1)
      NDN(I) = MAX0(NWN(I),NDN(I-1)-1)
      IF (NDN(I) .LE. NDN(I-1)+1) GO TO 520
      DO 510 K = 2,I
      KK = I - K + 1
      IF (NDN(KK) .GE. NDN(KK+1)-1) GO TO 520
      NDN(KK) = MAX0(NDN(KK),NDN(KK+1)-1)
  510 CONTINUE
  520 CONTINUE
      J  =  NSB + 1
  530 IF (ND1(J-1) .GE. NDN(J-1)-1) GO TO 540
      ND1(J) = ND1(J-1) + 1
      NDN(J) = NDN(J-1) - 1
      J  = J + 1
      IF (J .LE. 50) GO TO 530
      IREG =  2
      RETURN
C
  540 NSBD =  J - 1
      IF (IPRINT .LE. 0) GO TO 580
      WRITE  (N6,550)
      WRITE  (N6,230) (ND1(I),I=1,NSBD)
  550 FORMAT (4H ND1)
      WRITE  (N6,560)
      WRITE  (N6,230) (NDN(I),I=1,NSBD)
  560 FORMAT (4H NDN)
C
      WRITE  (N6,610)
      DO 570 I = 1,NCB
      WRITE (N6,640) I
      WRITE (N6,600) (PAREA(I,J,1),J=1,NSB)
  570 CONTINUE
  580 IF (CNTRL1) CALL MBCTR (1,IL1,IR1,NCN,NC1,NWN,NW1,PAREA)
      IF (CNTRL2) CALL MBCTR (2,IL2,IR2,NC2N,NC21,NWN,NW1,PAREA)
      IF (IPRINT .EQ. 0) GO TO 650
      DO 590 KXYZ = 1,3
      IF (KXYZ .EQ. 1) WRITE (N6,610)
      IF (KXYZ .EQ. 2) WRITE (N6,620)
      IF (KXYZ .EQ.3 ) WRITE (N6,630)
      DO 590 I = 1,NCB
      WRITE (N6,640) I
      WRITE (N6,600) (PAREA(I,J,KXYZ),J=1,NSB)
  590 CONTINUE
  600 FORMAT (5X,10F9.5)
  610 FORMAT (12H PAREA, MAIN)
  620 FORMAT (14H PAREA, CNTRL1)
  630 FORMAT (14H PAREA, CNTRL2)
  640 FORMAT (4H ROW,I4)
C
C     MAIN BOX CTR. COORDINATES
C
  650 KC = 0
      DO 660 I = 1,NCB
      IXR = I - 1
      DO 660 J = 1,NSB
      IF (.NOT.(I.GE.(ND1(J)) .AND. I.LE.(NDN(J)))) GO TO 660
      IF (PAREA(I,J,1) .LT. 0.005) GO TO 660
      JXR = J  - 1
      KC  = KC + 1
      IF (KC .GE. 200) GO TO 830
      XK(KC) = BOXL*(FLOAT(IXR)+0.5)
      YK(KC) = BOXW*FLOAT(JXR)
  660 CONTINUE
      DO 670 J = 1,NSB
      KC = KC + 1
      IF (KC .GE. 200) GO TO 830
      KTE(J) = KC
      XK(KC) = XWTE(J)
      YK(KC) = YWTE(J)
  670 CONTINUE
      KCT = KC
      IF (IPRINT .LE. 0) GO TO 700
      WRITE  (N6,680) (I,XK(I),I=1,KC)
  680 FORMAT (1H1,23H MAIN BOX CTR. X COORD.,/(10(1X,I4,F8.2)))
      WRITE  (N6,690) (I,YK(I),I=1,KC)
  690 FORMAT (1H1,23H MAIN BOX CTR. Y COORD.,/(10(1X,I4,F8.2)))
  700 CONTINUE
C
C     CNTRL1 BOX CTR. COORDINATES
C
      IF (.NOT.CNTRL1) GO TO 750
      KC1 = 0
      DO 710 I = 1,NCB
      IXR = I - 1
      DO 710 J = IL1,IR1
      IF (PAREA(I,J,2) .LT. 0.005) GO TO 710
      JXR = J - 1
      KC1 = KC1 + 1
      IF (KC1 .GE. 125) GO TO 830
      XK1(KC1) = BOXL*(FLOAT(IXR)+0.5)
      YK1(KC1) = BOXW*FLOAT(JXR)
  710 CONTINUE
      DO 720 J = IL1,IR1
      KC1 = KC1 + 1
      IF (KC1 .GE. 125) GO TO 830
      KTE1(J)  = KC1
      XK1(KC1) = XWTE(J)
      YK1(KC1) = YWTE(J)
  720 CONTINUE
      KC1T = KC1
      IF (IPRINT .LE. 0) GO TO 750
      WRITE  (N6,730) (I,XK1(I),I=1,KC1)
  730 FORMAT (1H1,25H CNTRL1 BOX CTR. X COORD.,/(10(1X,I4,F8.2)))
      WRITE  (N6,740) (I,YK1(I),I=1,KC1)
  740 FORMAT (1H1,25H CNTRL1 BOX CTR. Y COORD.,/(10(1X,I4,F8.2)))
C
C     CNTRL2 BOX CTR. COORDINATES
C
  750 IF (.NOT.CNTRL2) GO TO 800
      KC2 = 0
      DO 760 I = 1,NCB
      IXR = I - 1
      DO 760 J = IL2,IR2
      IF (PAREA(I,J,3) .LT. 0.005) GO TO 760
      JXR = J - 1
      KC2 = KC2 + 1
      IF (KC2 .GE. 125) GO TO 830
      XK2(KC2) = BOXL*(FLOAT(IXR)+0.5)
      YK2(KC2) = BOXW*FLOAT(JXR)
  760 CONTINUE
      DO 770 J = IL2,IR2
      KC2 = KC2 + 1
      IF (KC2 .GE. 125) GO TO 830
      KTE2(J)  = KC2
      XK2(KC2) = XWTE(J)
      YK2(KC2) = YWTE(J)
  770 CONTINUE
      KC2T = KC2
      IF (IPRINT .LE. 0) GO TO 800
      WRITE  (N6,780) (I,XK2(I),I=1,KC2)
  780 FORMAT (1H1,25H CNTRL2 BOX CTR. X COORD.,/(10(1X,I4,F8.2)))
      WRITE  (N6,790) (I,YK2(I),I=1,KC2)
  790 FORMAT (1H1,25H CNTRL2 BOX CTR. Y COORD.,/(10(1X,I4,F8.2)))
  800 CONTINUE
      BOXL = BOXL/CR
      BOXW = BOXW/CR
      BOXA = BOXA/CR**2
      DO 810 I = 1,12
      X(I) = X(I)/CR
  810 Y(I) = Y(I)/CR
      DO 820 I = 1,50
      XWTE(I) = XWTE(I)/CR
  820 YWTE(I) = YWTE(I)/CR
      GO TO 840
  830 IREG = 2
  840 RETURN
      END

      SUBROUTINE EXFOWR
     &  ( IUN, IPREC, FORM, InDATA, NWDS )
C********************************************************************
C    EXPECTED TYPES OF FORMAT CODES ARE AS FOLLOWS
C        NH------       NENN.N       NDNN.N         NX
C        NFNN.N         NINN         NGNN.N         NAN
C        NPENN.N        NPFNN.N      NPN(----)
C        SPECIAL CHARACTERS:  /(),
C     ICHAR = CURRENT CHARACTER NUMBER BEING PROCESSED IN "FORM"
C     ICOL  = CURRENT CHARACTER COLUMN POSITION WITHIN THE LINE
C     NCNT  = NUMBER OF VALUES OF IDATA AND DATA THAT HAVE BEEN PROCESSE
C********************************************************************
      CHARACTER*1     FORM(1000)
      CHARACTER*1     SLASH , BLANK
      CHARACTER*1     LPAREN, RPAREN, PERIOD, COMMA, NUMBER(10)
      CHARACTER*1     H, E, D, X, F, I, G, A, P
      CHARACTER*2     PFACT
      CHARACTER*4     CDATA(200)
      CHARACTER*132   LINE
      CHARACTER*132   TFORM
      INTEGER*4       IDATA(200)
      REAL*4          DATA(200)
      REAL*8          DDATA(100)
      integer*4       indata(200)
      COMMON /SYSTEM/ ISYSBF, IWR
      equivalence     ( idata, data, ddata, cdata )
      DATA            H/'H'/, E/'E'/, D/'D'/, X/'X'/, F/'F'/
      DATA            I/'I'/, G/'G'/, A/'A'/, P/'P'/
      DATA            LPAREN /'('/, RPAREN/')'/, PERIOD/'.'/
      DATA            COMMA  /','/, SLASH /'/'/, BLANK /' '/
      DATA            NUMBER /'0','1','2','3','4','5','6','7','8','9'/
      if ( nwds .le. 200 ) go to 2
      print *,' word limit exceeded in exfowr, limit=200'
      return
2     do 3 kb = 1, nwds
      idata( kb ) = indata( kb )
3     continue
      ILOOP = 0
      ICHAR = 1
      NCNT  = 1
      ICOL  = 1
      LINE  = BLANK
      PFACT = BLANK
      ICYCLE= 0
5     IF ( FORM(ICHAR) .EQ. LPAREN ) GO TO 75
      ICHAR = ICHAR + 1
      IF ( ICHAR .LE. 1000 ) GO TO 5
      GO TO 7702
70    IF ( ICHAR .GT. 1000 ) GO TO 7702
      IF ( NCNT  .GT. NWDS ) GO TO 1200
      IF ( FORM(ICHAR) .EQ. BLANK ) GO TO 75
      IF ( FORM(ICHAR) .EQ. SLASH ) GO TO 100
      IF ( FORM(ICHAR) .GE. NUMBER(1) .AND.
     &     FORM(ICHAR) .LE. NUMBER(10) ) GO TO 200
      IF ( FORM(ICHAR) .EQ. A ) GO TO 300
      IF ( FORM(ICHAR) .EQ. I ) GO TO 400
      IF ( FORM(ICHAR) .EQ. H ) GO TO 500
      IF ( FORM(ICHAR) .EQ. X ) GO TO 600
      IF ( FORM(ICHAR) .EQ. P ) GO TO 700
      IF ( FORM(ICHAR) .EQ. F ) GO TO 800
      IF ( FORM(ICHAR) .EQ. G ) GO TO 800
      IF ( FORM(ICHAR) .EQ. D ) GO TO 800
      IF ( FORM(ICHAR) .EQ. E ) GO TO 800
      IF ( FORM(ICHAR) .EQ. LPAREN ) GO TO 1000
      IF ( FORM(ICHAR) .EQ. RPAREN ) GO TO 1100
      IF ( FORM(ICHAR) .NE. COMMA  ) GO TO 7702
      IF ( ICYCLE .EQ. 0 ) PFACT = BLANK
75    ICHAR = ICHAR + 1
      GO TO 70
C PROCESS SLASH
100   CONTINUE
      IF ( LINE .NE. BLANK ) WRITE ( IWR,900 ) LINE
900   FORMAT(A132)
      IF ( LINE .EQ. BLANK ) WRITE ( IWR,901 )
901   FORMAT(/)
      LINE   = BLANK
      IF ( ICYCLE .EQ. 0 ) PFACT = BLANK
      ICOL = 1
      GO TO 75
C GET MULTIPLIER FOR FIELD CONVERSION
200   CALL FORNUM ( FORM, ICHAR, IMULT )
      GO TO 70
C PROCESS ALPHA FIELD--FORMAT(NNANNN) (NN=IMULT,NNN=IFIELD)
300   ICHAR = ICHAR + 1
      IF ( NCNT .GT. NWDS ) GO TO 1200
      CALL FORNUM ( FORM, ICHAR, IFIELD )
      IF ( IMULT .EQ. 0 ) IMULT = 1
      WRITE ( TFORM, 902 ) IMULT, IFIELD
902   FORMAT('(',I2,'A',I2,')')
      I1 = ICOL
      LENGTH = IMULT*IFIELD
      NEND   = NCNT + IMULT - 1
      IF ( NEND .GT. NWDS ) NEND = NWDS
      LAST   = ICOL + LENGTH - 1
      WRITE( LINE(ICOL:LAST), TFORM ) (CDATA(KK),KK=NCNT,NEND)
      ICOL   = ICOL + LENGTH
      NCNT   = NCNT + IMULT
      IMULT = 1
      GO TO 70
C PROCESS INTEGER FIELD -- FORMAT(NNINNN) (NN=IMULT,NNN=IFIELD)
400   ICHAR = ICHAR + 1
      IF ( NCNT .GT. NWDS ) GO TO 1200
      CALL FORNUM ( FORM, ICHAR, IFIELD )
      IF ( IMULT .EQ. 0 ) IMULT = 1
      WRITE ( TFORM, 903 ) IMULT, IFIELD
903   FORMAT('(',I2,'I',I2,')')
      I1 = ICOL
      LENGTH = IMULT*IFIELD
      NEND   = NCNT + IMULT - 1
      LAST   = ICOL + LENGTH - 1
      IF ( NEND .GT. NWDS ) NEND = NWDS
      WRITE( LINE(ICOL:LAST), TFORM ) (IDATA(KK),KK=NCNT,NEND)
      ICOL   = ICOL + LENGTH
      NCNT   = NCNT + IMULT
      IMULT  = 1
      GO TO 70
C PROCESS HOLERITH FIELD -- FORMAT(NNH----) (NN=IMULT)
500   LAST   = ICOL  + IMULT - 1
      ICHAR  = ICHAR + 1
      LCHAR  = ICHAR + IMULT - 1
      WRITE ( LINE(ICOL:LAST), 904 ) (FORM(KK),KK=ICHAR,LCHAR)
904   FORMAT(133A1)
      ICOL   = ICOL  + IMULT
      ICHAR  = LCHAR
      IMULT  = 1
      GO TO 75
C PROCESS X FIELD -- FORMAT(NNX) (NN=IMULT)
600   WRITE ( TFORM, 905 ) IMULT
905   FORMAT('(',I2,'X',')')
      LAST   = ICOL + IMULT - 1
      WRITE( LINE(ICOL:LAST), TFORM )
      ICOL   = ICOL + IMULT
      IMULT  = 1
      GO TO 75
C PROCESS P FACTOR FOR FLOATING FORMAT
700   WRITE ( PFACT,904 ) FORM(ICHAR-1), FORM(ICHAR)
      IF ( NCNT .GT. NWDS ) GO TO 1200
      GO TO 75
C PROCESS FLOATING FIELD -- FORMAT(NPNNXNNN.NNNN)  WHERE
C          (NP = PFACT, NN=IMULT, NNN=IFIELD, NNNN=IDEC)
800   ITYPE = ICHAR
      IF ( NCNT .GT. NWDS ) GO TO 1200
      ICHAR = ICHAR + 1
      CALL FORNUM ( FORM, ICHAR, IFIELD )
810   IF ( FORM( ICHAR ) .EQ. PERIOD ) GO TO 820
      ICHAR = ICHAR + 1
      GO TO 810
820   ICHAR = ICHAR + 1
      CALL FORNUM ( FORM, ICHAR, IDEC )
      IF ( IMULT .EQ. 0 ) IMULT = 1
      WRITE ( TFORM, 906 ) PFACT, IMULT, FORM(ITYPE),IFIELD, IDEC
906   FORMAT('(',A2,I2,A1,I2,'.',I2,')')
      I1 = ICOL
      LENGTH = IMULT*IFIELD
      NEND   = NCNT + IMULT - 1
      LAST   = ICOL + LENGTH - 1
      IF ( NEND .GT. NWDS ) NEND = NWDS
      IF ( IPREC .EQ. 2 )
     &  WRITE( LINE(ICOL:LAST), TFORM ) (DDATA(KK),KK=NCNT,NEND)
      IF ( IPREC .NE. 2 )
     &  WRITE( LINE(ICOL:LAST), TFORM ) (DATA(KK),KK=NCNT,NEND)
      ICOL   = ICOL + LENGTH
      NCNT   = NCNT + IMULT
      IMULT  = 1
      GO TO 70
C PROCESS LEFT PAREN (NOT THE FIRST LEFT PAREN BUT ONE FOR A GROUP)
C IMULT HAS THE MULTIPLIER TO BE APPLIED TO THE GROUP
1000  ICYCLE = IMULT-1
      ICSAVE = ICHAR+1
      ILOOP  = 1
      IMULT  = 1
      GO TO 75
C PROCESS RIGHT PAREN ( CHECK IF IT IS THE LAST OF THE FORMAT)
C IF IT IS PART OF A GROUP, THEN ICYCLE WILL BE NON-ZERO
1100  IF ( ICYCLE .GT. 0 ) GO TO 1110
      IF ( ILOOP  .NE. 0 ) GO TO 1120
      IF ( NCNT .GT. NWDS ) GO TO 1200
C NO GROUP, THEREFORE MUST RE CYCLE THROUGH FORMAT
C UNTIL LIST IS SATISFIED
      WRITE ( IUN,900 ) LINE
      ICHAR  = 2
      LINE   = BLANK
      PFACT  = BLANK
      ICOL   = 1
      GO TO 70
C GROUP BEING PROCESSED, DECREMENT COUNT AND RESET ICHAR TO BEGINNING
C OF THE GROUP
1110  ICYCLE = ICYCLE - 1
      ICHAR  = ICSAVE
      GO TO 70
C FINISHED WITH LOOP, CONTINUE WITH FORMAT
1120  ILOOP  = 0
      ICYCLE = 0
      GO TO 75
1200  WRITE ( IUN,900 ) LINE
      IF ( NCNT .GT. NWDS ) GO TO 7000
      LINE = BLANK
      GO TO 70
7000  CONTINUE
      RETURN
7702  WRITE( IWR, 9901 ) ICHAR, FORM
9901  FORMAT(///' SUBROUTINE EXFOWR UNABLE TO DECIPHER THE FOLLOWING'
     & ,' FORMAT AT CHARACTER ',I4,/,' FORMAT GIVEN WAS THE FOLLOWING:'
     & ,/,(1X,131A1))
      END

      SUBROUTINE AMGT1A (INPUT,MATOUT,AJJ,TSONX,TAMACH,TREDF,NSTNS2)
C
C     COMPUTE AJJ MATRIX FOR SWEPT TURBOPROP BLADES.
C
      LOGICAL         TSONIC,DEBUG
      INTEGER         SLN,NAME(2),TSONX(1)
      REAL            MINMAC,MAXMAC,MACH
      COMPLEX         AJJ(NSTNS2,1)
      DIMENSION       TAMACH(1),TREDF(1)
      COMMON /AMGMN / MCB(7),NROW,DUM(2),REFC,SIGMA,RFREQ
      COMMON /CONDAS/ PI,TWOPI,RADEG,DEGRA,S4PISQ
      COMMON /PACKX / ITI,ITO,II,NN,INCR
      COMMON /TAMG1L/ IREF,MINMAC,MAXMAC,NLINES,NSTNS,REFSTG,REFCRD,
     1                REFMAC,REFDEN,REFVEL,REFSWP,SLN,NSTNSX,STAGER,
     2                CHORD,DCBDZB,BSPACE,MACH,DEN,VEL,SWEEP,AMACH,
     3                REDF,BLSPC,AMACHR,TSONIC
      COMMON /AMGBUG/ DEBUG
      DATA    NAME  / 4HAMGT,4H1A  /
C
C     LOOP ON STREAMLINES, COMPUTE AJJ FOR EACH STREAMLINE AND THEN
C     PACK AJJ INTO AJJL MATRIX AT CORRECT POSITION
C
      II = 0
      NN = 0
      NSTNS3 = 3*NSTNS
      DO 70 LINE = 1,NLINES
C
C     READ STREAMLINE DATA (SKIP COORDINATE DATA)
C
      CALL READ (*400,*400,INPUT,SLN,10,0,NWAR)
C
C     COMPUTE PARAMETERS
C
      AMACH = MACH
      REDF  = RFREQ*(CHORD/REFCRD)*(REFVEL/VEL)
      BLSPC = BSPACE/CHORD
C
C     COMPUTE C3 AND C4 FOR THIS STREAMLINE.
C
C     INPUT IS POSITIONED AT THE FIRST 10 WORDS OF THE NEXT
C     STREAMLINE WHEN IT RETURNS FROM AMGT1T
C
      CALL AMGT1T (NLINES,LINE,INPUT,NSTNS,C3,C4)
C
      IF (DEBUG) CALL BUG1 ('TAMG1L    ',5,IREF,26)
C
C     COMPUTE POINTER FOR LOCATION INTO AJJ MATRIX
C
      IAJJC = 1
      IF (TSONIC) IAJJC = NSTNS2*(LINE-1) + 1
C
C     BRANCH TO SUBSONIC, SUPERSONIC OR TRANSONIC CODE
C
      TAMACH(LINE) = AMACH
      TREDF(LINE)  = REDF
      IF (AMACH .LE. MAXMAC) GO TO 10
      IF (AMACH .GE. MINMAC) GO TO 20
C
C     TRANSONIC STREAMLINE. STORE DATA FOR TRANSONIC INTERPOLATION
C
      TSONX(LINE) = IAJJC
      GO TO 70
C
C     SUBSONIC STREAMLINE
C
   10 CALL AMGT1B (AJJ(1,IAJJC),NSTNS2,C3,C4)
      GO TO 30
C
C     SUPERSONIC STREAMLINE
C
   20 CALL AMGT1C (AJJ(1,IAJJC),NSTNS2,C3,C4)
   30 CONTINUE
C
C     IF THERE ARE NO TRANSONIC STREAMLINES OUTPUT THIS AJJ SUBMATRIX
C
      IF (TSONIC) GO TO 60
      II = NN + 1
      NN = NN + NSTNS2
C
C     OUTPUT AJJ MATRIX
C
      DO 50 I = 1,NSTNS2
      IF (DEBUG) CALL BUG1 ('SS-AJJL   ',40,AJJ(1,I),NSTNS2*2)
      CALL PACK (AJJ(1,I),MATOUT,MCB)
   50 CONTINUE
      GO TO 70
   60 TSONX(LINE) = 0
   70 CONTINUE
C
C     PERFORM TRANSONIC INTERPOLATION, IF NECESSARY
C
      IF (.NOT.TSONIC) GO TO 300
      IF (DEBUG) CALL BUG1 ('TSONX     ', 80,TSONX,NLINES)
      IF (DEBUG) CALL BUG1 ('TAMACH    ', 90,TAMACH,NLINES)
      IF (DEBUG) CALL BUG1 ('TREDF     ',100,TREDF,NLINES)
      CALL AMGT1D (AJJ,TSONX,TAMACH,TREDF,NSTNS2)
C
C     OUTPUT AJJ FOR EACH STREAMLINE
C
      DO 200 NLINE = 1,NLINES
      II = NN + 1
      NN = NN + NSTNS2
      DO 120 I = II,NN
      IF (DEBUG) CALL BUG1 ('STS-AJJL  ',110,AJJ(1,I),NSTNS2*2)
      CALL PACK (AJJ(1,I),MATOUT,MCB)
  120 CONTINUE
  200 CONTINUE
  300 RETURN
C
C     ERROR MESSAGES
C
C     INPUT NOT POSITIONED PROPERLY OR INCORRECTLY WRITTEN
C
  400 CALL MESAGE (-7,0,NAME)
      RETURN
      END

      SUBROUTINE SMCPH2 ( ZI, ZR, ZD )              
C     
C SMCPH2 PERFORMS THE ACTUAL DECOMPOSITION OF THE MATRIX THAT WAS 
C SETUP IN MEMORY AND/OR THE SPILL BY SMCPH1.
C SEE SMCPH1 FOR THE DEFINITION OF SOME OF THE VARIABLES IN /SMCOMX/
C
      REAL              ZR(10)
      DOUBLE PRECISION  ZD(10)  ,XND(10)              
      INTEGER           ZI(10)  ,ITEMP(4)
      INTEGER           PRC     ,WORDS   ,RLCMPX  ,NAME(2)
      CHARACTER*4       CNAME(2)
      CHARACTER         UFM*23  ,UWM*25  ,UIM*29  ,SFM*25
      INCLUDE           'SMCOMX.COM'                    
      COMMON  /LOGOUT/  LOUT
      COMMON  /XMSSG /  UFM     ,UWM     ,UIM     ,SFM
      COMMON  /NAMES /  RDNRW   ,RDREW   ,WRT     ,WRTREW  ,REW     
     1,                 NOREW   ,EOFNRW  ,RSP     ,RDP     ,CSP     
     2,                 CDP     ,SQR     ,RECT    ,DIAG    ,LOWTRI  
     3,                 UPRTRI  ,SYM
      COMMON  /ZZZZZZ/  XNS(10)
      COMMON  /TYPE  /  PRC(2)  , WORDS(4), RLCMPX(4)     
      EQUIVALENCE       ( XNS, XND )
      EQUIVALENCE       ( MBLK(6), MTERMS ), (MBLK(5), MSTR )
      EQUIVALENCE       ( MBLK(4), MROW   ), (MBLK(2), MTYPE)
      EQUIVALENCE       ( NAME   , CNAME  )
c
c   open core is allocated as follows for the decomposition
c
C       -------------------------------
C       zi(1)
C       Directory  (4,n) , n=number of columns of matrix
C                  (1,i) = index to active rows and terms within memory
C                  (2,i) = first column data needed for this pivot
C                  (3,i) = last pivot column to use this data
C                          (also, the last active row of this column)
C                  (4,i) = savpos position pointer for data spilled to a
C                          scratch file
C       -------------------------------
C       zi(nar)
C       Area for storage of row numbers used for previous column of
C       decomposition (length=MAXNAR+2)
C       -------------------------------    
C       zi(ispill)
C       Area to read data from spill file (length =MXRECL+4)
C       This area is not needed if no columns written to spill file
C       -------------------------------
C       zi(ILSROW)
C       Area for storage of last non-zero row term for a given column
C       (length=MAXNCOL)
C       -------------------------------
C       zi(ioloop)
C       Values for outer loop terms in all row computations in the
C       current pivotal column.
C
C         temp = temp + a(i,j) * a(k,j) / a(j,j)
C                                ===============
C            i = row of column
C            k = pivotal column being processed
C            j = 1, k-1
C          a(i,k) = a(i,k) - temp
C          (Note, length is 2*MAXNCOL)
C          MAXNCOL = maximum number of columns referenced by any
C                    pivotal column
C       -------------------------------     
C       zi(iiloop)
C       Values for inner loop terms in each row computation
C         temp = temp + a(i,j) * a(k,j) / a(j,j)
C                       ======
C            i = row of column
C            k = pivotal column being processed
C            j = 1, k-1
C          a(i,k) = a(i,k) - temp  
C          (Note, length is  MAXNCOL*MAXNAC)
C          MAXNAC = MAXIMUM NUMBER OF ACTIVE ROWS FOR ANY GIVEN COLUMN
C       -------------------------------         
C       zi(iwork)
C       Temporary storage for storing "temp" values for each row (see
C       "temp" in above equation for zi(iiloop) )
C       -------------------------------
C       zi(idbase)
C       Memory for rows and terms of columns as pointed to by directory
C       in the first part of open core.  This data is loaded from the  
C       bottom up to allow for better management of open core.
C       The format for the storage of this data is as follows:
C          (index from directory above points to the first word of the
C           data that follows)
C               1.  Column number
C               2.  Length of active row section (m*2), m=number of
C                   repeats of contents of words 5 and 6 below.
C               3.  Total number of words in this block of allocation
C               4.  Length of values section
C               5.  row number
C               6.  number of consecutive values beginning at this row
C                   (words 5 and 6 repeat m times)
C           5+2*m.  value for first row
C     5+2*m+iprec.  next row value (iprec=1,2,4)
C   5+2*m+iprec*l.  last row value for column (l=total values)
C       -------------------------------         
C       zi(ibuf2)
C       Buffer for spill file if all column values can not be kept in memory   
C       -------------------------------
C       zi(ibuf1)
C       Buffer for input matrix file to be decomposed
C       -------------------------------
C
c      CALL AUDIT ('SMCPH2  ',1 )
      NAR    = NCOL*4 + 1
      ILSROW = NAR + MAXNAR + 2
      MSPILL = 0
      ISPILL = 0
      IF ( NSPILL .EQ. 0 ) GO TO 5
      ISPILL = NAR + MAXNAR + 1   
      IF ( MOD( ISPILL,2 ) .EQ. 0 ) ISPILL = ISPILL + 1
      ILSROW = ISPILL + MXRECL + 4
5     CONTINUE
      IOLOOP = ILSROW + MAXNCOL + 2  
      IF ( MOD( IOLOOP,2 ) .EQ. 0 ) IOLOOP = IOLOOP + 1
      IILOOP = IOLOOP + 2*MAXNCOL*IVWRDS
      IWORK  = IILOOP + MAXNCOL*MAXNAC*IVWRDS
      ITOTAL = IWORK  + MAXNAC*IVWRDS
      INDDIR = LASCOL * 4 - 3
      IDBASE = ZI( INDDIR )
      MEMFRE = 0
      MEMLAS = 0
      MEMLCK = 0
      MEMCOL1= 1
      XNCOL  = NCOL
      XSPILL = NSPILL 
      XFACT  = XNCOL / ( XNCOL-NSPILL )
C
C  MORE = ESTIMATED NUMBER OF WORDS NEEDED FOR STORING ALL OF MATRIX
C  IADJ = WORDS OF COLUMN DATA THAT WILL NEED TO BE WRITTEN TO THE SPILL
C         FILE TO ALLOW FOR "ITOTAL" WORDS FOR THE PHASE II ARRAYS.
C
      MORE   = XFACT * ( LCORE - IDBASE )
      IADJ   = 0
      IF ( ITOTAL .GT. IDBASE ) IADJ = ITOTAL - IDBASE
      MAXMEM = ITOTAL + MORE + IADJ
      CALL SSWTCH ( 45, L45 )
      IF ( NSPILL .EQ. 0 .AND. L45 .EQ. 0 ) GO TO 10
      WRITE ( LOUT, 8002 ) MAXMEM, LCORE
8002  FORMAT(
     &    7X,' ESTIMATED OPEN CORE NEEDED TO ELIMINATE USE OF SPILL=',I8
     &,/, 7X,' OPEN CORE AVAILABLE FOR THIS DECOMPOSITION          =',I8 
     & )
C
C TEST TO BE SURE THAT AT LEAST HALF OF THE MEMORY IS AVAILABLE.
C IF NOT, USE OLD METHOD INSTEAD OF THIS ONE.
C
      XMAXMEM = MAXMEM
      XCORE   = LCORE
      PERCNT  = XCORE / XMAXMEM
      IF ( PERCNT .LT. .5 ) GO TO 7008
C
C CHECK TO SEE IF ENOUGH OPEN CORE FOR INNER AND OUTER LOOP VALUES
C
10    IF ( ITOTAL .LT. IDBASE ) GO TO 500
C
C NEED MORE OPEN CORE FOR LOOP AREAS.  WRITE COLUMN DATA TO SPILL FILE.
C IF COLUMNS WERE WRITTEN TO SPILL FILE FROM SMCPH1, THEN FILE WILL
C STILL BE OPEN.  IF NOT, MUST ALLOW FOR SPILL AREA IN OPEN CORE AND
C RE-ADJUST THE OPEN CORE POINTERS.
C      
      NEXTRA = 0
      IF ( OPNSCR ) GO TO 20
      OPNSCR = .TRUE.
      CALL OPEN ( *7003, ISCR1, ZI( IBUF2 ), WRTREW )
      ISPILL = NAR + MAXNAR + 1   
      IF ( MOD( ISPILL,2 ) .EQ. 0 ) ISPILL = ISPILL + 1
      ILSROW = ISPILL + MXRECL + 4
      IOLOOP = ILSROW + MAXNCOL + 2
      IF ( MOD( IOLOOP,2 ) .EQ. 0 ) IOLOOP = IOLOOP + 1
      IILOOP = IOLOOP + 2*MAXNCOL*IVWRDS
      IWORK  = IILOOP + MAXNCOL*MAXNAC*IVWRDS
      ITOTAL = IWORK  + MAXNAC*IVWRDS
20    CONTINUE
C
C WRITE THE LAST COLUMN OF DATA CURRENTLY IN MEMORY TO THE SPILL FILE
C      
      INDEX  = ZI( INDDIR ) 
      IRVAL  = INDEX + 4                                            
      NRVALS = ZI( INDEX+1 )
      NTERMS = ZI( INDEX+3 )                         
      IVVAL  = IRVAL + NRVALS         
      ITEMP( 1 ) = ZI( INDEX )
      ITEMP( 2 ) = NRVALS
      ITEMP( 3 ) = 0
      ITEMP( 4 ) = NTERMS
C      PRINT *,' SMCPH2 CALLING WRITE FOR ITEMP,NRVALS,NTERMS,IVWRDS'
C      PRINT *,                           ITEMP,NRVALS,NTERMS,IVWRDS
      CALL WRITE ( ISCR1, ITEMP, 4, 0 )
      CALL SAVPOS( ISCR1, KPOS )   
      CALL WRITE ( ISCR1, ZR( IRVAL ), NRVALS, 0 )
      CALL WRITE ( ISCR1, ZR( IVVAL ), NTERMS*IVWRDS, 1 )  
      ZI( INDDIR   ) = 0       
      ZI( INDDIR+3 ) = KPOS
50    INDDIR = INDDIR - 4
      IF ( INDDIR .LE. 0 ) GO TO 7008
      IF ( ZI ( INDDIR ) .EQ. 0 ) GO TO 50
C
C RESET IDBASE TO INDICATE THE LAST COLUMN OF DATA IN MEMORY
C      
      IDBASE = ZI( INDDIR )
      MSPILL = MSPILL + 1
      GO TO 10
C
C OPEN THE OUTPUT FILE
C
500   CONTINUE
      LEFT   = IDBASE - ITOTAL
C
C DETERMINE HOW MANY MORE COLUMNS OF THE INNER LOOP AREA AND
C EXTRA TERMS OF THE OUTER LOOP AREA ARE AVAILABLE
C   NEXTRA = NUMBER OF EXTRA COLUMNS AVAILABLE IN THE INNER LOOP AREA
C          = NUMBER OF EXTRA COLUMNS AVAILABLE IN THE OUTER LOOP AREA
C            (INNER LOOP AREA SIZE = MAXNAC * ( MAXNCOL + NEXTRA ) )
C            (OUTER LOOP AREA SIZE = 2      * ( MAXNCOL + NEXTRA ) )
C          = NUMBER OF EXTRA ROWS IN THE "ILSROW" ARRAY (MAXNCOL+NEXTRA)
C  (Note: for each column added, we need the following:
C           for array ILSROW:                1
C           to insure double word boundary:  1
C           for outer loop:                  2*IVWRDS
C           for inner loop:                  MAXNAC*IVWRDS
C           ( must allow for temp array size:    MAXNAC*IVWRDS
      NEED   = 2 + 2*IVWRDS + MAXNAC*IVWRDS
      NEXTRA = ( LEFT - 2 - (MAXNAC*IVWRDS) ) / NEED
C      PRINT *,' LEFT,NEED,NEXTRA=',LEFT,NEED,NEXTRA
      IF ( NEXTRA .EQ. 0 ) GO TO 505
      IOLOOP = ILSROW +            ( MAXNCOL+NEXTRA ) + 2   
      IF ( MOD( IOLOOP,2 ) .EQ. 0 ) IOLOOP = IOLOOP + 1
      IILOOP = IOLOOP + ( 2      * ( MAXNCOL+NEXTRA ) ) * IVWRDS
      IWORK  = IILOOP + ( MAXNAC * ( MAXNCOL+NEXTRA ) ) * IVWRDS
      ITOTAL = IWORK  +            ( MAXNAC           ) * IVWRDS
505   IF ( KPREC .EQ. 2 ) IOLOOP = IOLOOP / 2 + 1
      IF ( KPREC .EQ. 2 ) IILOOP = IILOOP / 2 + 1
      IF ( KPREC .EQ. 2 ) IWORK  = IWORK  / 2 + 1
      NVTERM = 1
      IF ( KTYPE .GE. 3 ) NVTERM = 2
      IF ( MSPILL .NE. 0 ) WRITE ( LOUT, 8001 ) MSPILL
8001  FORMAT(8X,'ADDITIONAL COLUMNS WRITTEN TO SPILL '
     &,'FOR PHASE II PROCESSING =',I6)
      IF ( .NOT. OPNSCR ) GO TO 510
      CALL CLOSE ( ISCR1, 1 )
      CALL OPEN  ( *7002, ISCR1, ZI( IBUF2 ), RDREW )
510   CONTINUE
      CALL OPEN ( *7001, LLL, ZI( IBUF1 ), WRTREW )
      CALL FNAME ( LLL, NAME )
      CALL WRITE ( LLL, NAME, 2, 1 )
C
C DO THE DECOMPOSITION NOW
C      
c      CALL AUDIT ( 'SMC2RD  ', 1 )
C      PRINT *,' IILOOP,IOLOOP,NAR,ILSROW,NEXTRA,IDBASE,IWORK,ISPILL'
C      PRINT *,  IILOOP,IOLOOP,NAR,ILSROW,NEXTRA,IDBASE,IWORK,ISPILL
      GO TO ( 1000, 2000, 3000, 4000 ), KTYPE
1000  CONTINUE
      CALL SMC2RS ( ZI, ZR, ZR( IILOOP ), ZR( IOLOOP ), ZI( NAR )
     &,    ZI( ILSROW ), ZR( IWORK ), MAXNAC, MAXNCOL+NEXTRA, MAXNAR )
      GO TO 5000
2000  CONTINUE
      CALL SMC2RD ( ZI, ZD, ZD( IILOOP ), ZD( IOLOOP ), ZI( NAR )
     &,    ZI( ILSROW ), ZD( IWORK ), MAXNAC, MAXNCOL+NEXTRA, MAXNAR )
      GO TO 5000
3000  CONTINUE                 
C      PRINT *,' CALLING SMC2CS'
      CALL SMC2CS ( ZI, ZR, ZD( IILOOP ), ZD( IOLOOP ), ZI( NAR )
     &,    ZI( ILSROW ), ZD( IWORK ), MAXNAC, MAXNCOL+NEXTRA, MAXNAR )
      GO TO 5000
4000  CONTINUE
C      PRINT *,' CALLING SMC2CD'
      CALL SMC2CD ( ZI, ZD, ZD( IILOOP ), ZD( IOLOOP ), ZI( NAR )
     &,    ZI( ILSROW ), ZD( IWORK ), MAXNAC, MAXNCOL+NEXTRA, MAXNAR )
      GO TO 5000
5000  CONTINUE
c      CALL AUDIT ( 'SMC2RD  ', 2 )
      CALL CLOSE ( LLL  , 1 )
      CALL CLOSE ( ISCR1, 1 )
      GO TO 7777
7001  CONTINUE
      CALL FNAME ( LLL, NAME )
      IERROR = 2
      WRITE ( NOUT, 9001 ) UFM, LLL(1), CNAME
9001  FORMAT(1X,A23,/,' SMCPH2 UNABLE TO OPEN FILE ',I4,' ;FILE NAME ='
     &,  2A4 )
      GO TO 7100
7002  CALL FNAME ( ISCR1, NAME )
      WRITE ( NOUT, 9001 ) UFM, ISCR1, CNAME
      IERROR = 3
      GO TO 7100
7003  CONTINUE
      IERROR = 2
      CALL FNAME ( ISCR1, NAME )
      WRITE ( NOUT, 9001 ) UFM, ISCR1, CNAME
      GO TO 7100
7008  CONTINUE
      CALL FNAME ( LLL, NAME )
      MINUM = (.5 * XMAXMEM ) - LCORE
      WRITE ( LOUT, 9008 ) NCOL, MINUM
9008  FORMAT(8X,'INSUFFICIENT OPEN CORE FOR DECOMPOSITION WITH NEW'
     &,' METHOD'
     &,/,    8X,'TOTAL NUMBER OF COLUMNS IN MATRIX =',I8
     &,/,    8X,'SUGGESTED ADDITIONAL OPEN CORE IS =',I8)
      CALL CLOSE ( ISCR1, 1 )
C      CALL MESAGE ( -8, 0, 0 )
      IERROR = 1
      GO TO 7777
7100  CALL MESAGE ( -61, 0, 0 )  
7777  CONTINUE
c      CALL AUDIT ( 'SMCPH2  ',2)
c      CALL AUDIT ( 'END     ',1)
c      IF ( NCOL .NE. 0 ) STOP
      RETURN
      END

      SUBROUTINE SCAT (KG,NCON,INV,II3,NORIG)
C
C     THIS ROUTINE IS USED ONLY IN BANDIT MODULE
C
C     THIS ROUTINE USES SCATTER SORT TECHNIQUES FOR EACH GRID POINT
C     ENCOUNTERED TO DETERMINE WHETHER OR NOT THE POINT HAS BEEN SEEN
C     BEFORE.   IF NOT, INV, NORIG, AND NN ARE UPDATED.
C
C     INV(I,1) CONTAINS AN ORIGINAL GRID POINT NUMBER
C     INV(I,2) CONTAINS THE INTERNAL NUMBER ASSIGNED TO IT (BEFORE SORT)
C
      DIMENSION       KG(1),    NORIG(1),    INV(II3,2)
      COMMON /BANDB / DUM3B(3), NGRID
      COMMON /BANDS / NN,       DUM3(3),  MAXGRD,   MAXDEG,   KMOD
      COMMON /SYSTEM/ ISYS,     NOUT
C
      IF (NCON .LT. 1) RETURN
      DO 50 I = 1,NCON
      NOLD = KG(I)
      IF (NOLD .EQ. 0) GO TO 50
      LOC = NOLD - 1
   20 LOC = MOD(LOC,KMOD) + 1
      IF (INV(LOC,1) .NE. 0) GO TO 30
      INV(LOC,1) = NOLD
      NN = NN + 1
      IF (NN .GT. MAXGRD) GO TO 60
      NORIG(NN) = NOLD
      INV(LOC,2) = NN
      GO TO 40
   30 IF (INV(LOC,1) .NE. NOLD) GO TO 20
   40 KG(I) = INV(LOC,2)
   50 CONTINUE
      RETURN
C
   60 NGRID = -1
      RETURN
      END

      SUBROUTINE MRED2F
C
C     THIS SUBROUTINE COMPUTES THE FREEBODY EFFECTS FOR THE MRED2
C     MODULE.
C
C     INPUT DATA
C     GINO   - MAA    - SUBSTRUCTURE MASS MATRIX
C              DMR    - FREEBODY MATRIX
C     SOF    - GIMS   - G TRANSFORMATION MATRIX FOR BOUNDARY POINTS OF
C                       ORIGINAL SUBSTRUCTURE
C
C     OUTPUT DATA
C     GINO   - HGH    - HORG PARTITION MATRIX
C     SOF    - HORG   - H TRANSFORMATION MATRIX FOR ORIG. SUBSTRUCTURE
C
C     PARAMETERS
C     INPUT  - GBUF   - GINO BUFFERS
C              INFILE - INPUT FILE NUMBERS
C              ISCR   - SCRATCH FILE NUMBERS
C              KORLEN - LENGTH OF OPEN CORE
C              KORBGN - BEGINNING ADDRESS OF OPEN CORE
C              FREBDY - FREEBODY MODES OPTION FLAG
C     OTHERS - RPRTN  - ROW PARTITIONING VECTOR FILE NUMBER
C              LII    - LII PARTITION MATRIX FILE NUMBER (ISCR11)
C              IDENT  - IDENTITY MATRIX FILE NUMBER
C              ZERO   - ZERO MATRIX FILE NUMBER
C              HIE    - HIE PARTITION MATRIX FILE NUMBER
C              HIR    - HIR PARTITION MATRIX FILE NUMBER
C              HIRSCR - HIR SCRATCH PARTITION MATRIX FILE NUMBER
C              FBR    - FBR PARTITION MATRIX FILE NUMBER
C              FIR    - FIR PARTITION MATRIX FILE NUMBER
C              GIB    - GIMS INPUT FILE NUMBER
C              CPRTN  - COLUMN PARTITIONING VECTOR FILE NUMBER
C              HIM    - HIM PARTITION MATRIX FILE NUMBER
C              HGH    - HORG MATRIX FILE NUMBER
C
      LOGICAL          FREBDY,BOUNDS
      INTEGER          DRY,GBUF1,GBUF2,SBUF1,SBUF2,SBUF3,OLDNAM,Z,T,
     1                 SIGNAB,SIGNC,PRECMP,SCR,FUSET,PRECFB,SIGN,TYPINP,
     2                 TYPEOP,TYPINU,UN,UB,UI,DMR,FAR,FIR,FARIND,ZERO,
     3                 RPRTN,HIE,HIR,CPRTN,HIM,HGH,GIB,HIRSCR,USETMR,
     4                 DBLKOR,SGLKOR
      DOUBLE           PRECISION DZ,DHIRMG
      DIMENSION MODNAM (2),ITRLR1(7),ITRLR2(7),RZ(1),ISUB(4),ITMLST(4),
     1                 DZ(1)
      COMMON /BLANK /  IDUM1,DRY,IDUM7,GBUF1,GBUF2,IDUM2,SBUF1,SBUF2,
     1                 SBUF3,INFILE(12),OTFILE(6),ISCR(10),KORLEN,
     2                 KORBGN,OLDNAM(2),IDUM4(2),FREBDY,IDUM8(5),BOUNDS,
     3                 IDUM9(6),LSTZWD,ISCR11
      COMMON /ZZZZZZ/  Z(1)
      COMMON /MPYADX/  ITRLRA(7),ITRLRB(7),ITRLRC(7),ITRLRD(7),NZMPY,T,
     1                 SIGNAB,SIGNC,PRECMP,SCR
      COMMON /BITPOS/  IDUM5(9),UN,IDUM6(10),UB,UI
      COMMON /PATX  /  LCORE,NSUB(3),FUSET
      COMMON /FBSX  /  JTRLRL(7),JTRLRU(7),JTRLRB(7),JTRLRX(7),NZFBS,
     1                 PRECFB,SIGN
      COMMON /PACKX /  TYPINP,TYPEOP,IROWP,NROWP,INCRP
      COMMON /UNPAKX/  TYPINU,IROWU,NROWU,INCRU
      COMMON /SYSTEM/  IDUM3,IPRNTR
      EQUIVALENCE      (USETMR,INFILE(5)),(MAA,INFILE(7)),
     1                 (DMR,INFILE(11)),(RPRTN,ISCR(9)),(IDENT,ISCR(5)),
     2                 (CPRTN,ISCR(10)),(PPRTN,ISCR(4)),(RZ(1),Z(1)),
     3                 (DZ(1),Z(1)),(GIB,ISCR(4)),(LII ,ISCR11),
     4                 (HIRSCR,ISCR(5)),(HGH,ISCR(8)),(ZERO,ISCR(6)),
     5                 (HIM,ISCR(8)),(HIE,ISCR(7)),(HIR ,ISCR(9)),
     6                 (FAR,ISCR(9)),(FIR,ISCR(10))
      DATA    MODNAM/  4HMRED,4H2F  /
      DATA    FARIND,  ISCR7 ,ISCR8 /6, 307, 308  /
      DATA    ITMLST/  4HGIMS,4HHORG,4HUPRT,4HLMTX/
C
C     TEST FREEBODY MODES CALCULATION FLAG
C
      IF (DRY .EQ. -2) GO TO 300
      ITRLR2(1) = DMR
      CALL RDTRL (ITRLR2)
      IF (ITRLR2(1) .LT. 0) GO TO 110
C
C     COMPUTE FREEBODY MATRIX
C
C        **   **   **   ** **   **
C        *     *   *     * *     *
C        * FAR * = * MAA * * DMR *
C        *     *   *     * *     *
C        **   **   **   ** **   **
C
      CALL SOFCLS
      FREBDY = .TRUE.
      ITRLR1(1) = MAA
      CALL RDTRL (ITRLR1)
      DO 10 I = 1,7
      ITRLRA(I) = ITRLR1(I)
      ITRLRB(I) = ITRLR2(I)
   10 ITRLRC(I) = 0
      IFORM = 2
      IPRC  = 1
      ITYP  = 0
      IF (ITRLRA(5).EQ.2 .OR. ITRLRA(5).EQ.4) IPRC = 2
      IF (ITRLRB(5).EQ.2 .OR. ITRLRB(5).EQ.4) IPRC = 2
      IF (ITRLRA(5) .GE. 3) ITYP = 2
      IF (ITRLRB(5) .GE. 3) ITYP = 2
      ITYPE = IPRC + ITYP
      CALL MAKMCB (ITRLRD,FAR,ITRLR1(3),IFORM,ITYPE)
      T     = 0
      SIGNAB= 1
      SIGNC = 1
      PREC  = 0
      SCR   = ISCR(4)
      DBLKOR= 1 + KORBGN/2
      NZMPY = LSTZWD - 2*DBLKOR - 1
      CALL MPYAD  (DZ(DBLKOR),DZ(DBLKOR),DZ(DBLKOR))
      CALL WRTTRL (ITRLRD)
C
C     PARTITION FAR INTO BOUNDARY, INTERIOR POINTS
C
C                  **   **
C                  *     *
C        **   **   * FBR *
C        *     *   *     *
C        * FAR * = *.....*
C        *     *   *     *
C        **   **   * FIR *
C                  *     *
C                  **   **
C
      LCORE = NZMPY
      FUSET = USETMR
      CALL CALCV (PPRTN,UN,UI,UB,Z(KORBGN))
      CALL GMPRTN (FAR,FIR,0,0,0,0,PPRTN,NSUB(1),NSUB(2),Z(KORBGN),
     1             KORLEN)
C
C     CALCULATE FREEBODY TRANSFORMATION MATRIX
C
C                       T
C        **   ** **   ** **   **    **   **
C        *     * *     * *     *    *     *
C        * LII * * LII * * HIR * = -* FIR *
C        *     * *     * *     *    *     *
C        **   ** **   ** **   **    **   **
C
      IF (.NOT.BOUNDS) GO TO 20
      ITEM = ITMLST(4)
      CALL SOFTRL (OLDNAM,ITEM,JTRLRL)
      ITEST = JTRLRL(1)
      IF (ITEST .NE. 1) GO TO 20
      JTRLRL(1) = LII
      CALL SOFOPN (Z(SBUF1),Z(SBUF2),Z(SBUF3))
      CALL MTRXI (LII,OLDNAM,ITEM,0,ITEST)
      IF (ITEST .NE. 1) GO TO 210
      CALL SOFCLS
      GO TO 30
   20 JTRLRL(1) = LII
      CALL RDTRL (JTRLRL)
   30 JTRLRB(1) = FIR
      CALL RDTRL (JTRLRB)
      IFORM = 2
      IPRC  = 1
      ITYP  = 0
      IF (JTRLRL(5).EQ.2 .OR. JTRLRL(5).EQ.4) IPRC = 2
      IF (JTRLRB(5).EQ.2 .OR. JTRLRB(5).EQ.4) IPRC = 2
      IF (JTRLRL(5) .GE. 3) ITYP = 2
      IF (JTRLRB(5) .GE. 3) ITYP = 2
      ITYPE = IPRC + ITYP
      CALL MAKMCB (JTRLRX,HIR,JTRLRB(3),IFORM,ITYPE)
      NZFBS  = NZMPY
      PRECFB = ITYPE
      SIGN   = -1
      CALL FBS (Z(KORBGN),Z(KORBGN))
      CALL WRTTRL (JTRLRX)
C
C     UNPACK HIR COLUMNS FOR SCALING
C
      TYPINU = JTRLRX(5)
      IROWU  = 1
      NROWU  = JTRLRX(3)
      INCRU  = JTRLRX(5)
      TYPINP = JTRLRX(5)
      TYPEOP = JTRLRX(5)
      IROWP  = 1
      NROWP  = JTRLRX(3)
      INCRP  = JTRLRX(5)
      CALL GOPEN (HIR,Z(GBUF1),0)
      IFORM  = JTRLRX(4)
      CALL MAKMCB (ITRLR1,HIRSCR,JTRLRX(3),IFORM,JTRLRX(5))
      CALL GOPEN (HIRSCR,Z(GBUF2),1)
      SGLKOR = 2*DBLKOR - 1
      DO 80 I = 1,FARIND
      CALL UNPACK (*60,HIR,DZ(DBLKOR))
C
C     CALCULATE MAGNITUDE OF HIR
C
      IF (JTRLRX(5) .EQ. 2) GO TO 42
      HIRMAG = RZ(SGLKOR)
      IF (NROWU .EQ. 1) GO TO 50
      DO 40 J = 2,NROWU
      IF (ABS(RZ(SGLKOR+J-1)) .GT. ABS(HIRMAG)) HIRMAG = RZ(SGLKOR+J-1)
   40 CONTINUE
      GO TO 50
   42 DHIRMG = DZ(DBLKOR)
      IF (NROWU .EQ. 1) GO TO 50
      DO 44 J = 2,NROWU
      IF (DABS(DZ(DBLKOR+J-1)) .GT. DABS(DHIRMG)) DHIRMG =DZ(DBLKOR+J-1)
   44 CONTINUE
C
C     SCALE HIR COLUMN
C
   50 IF (JTRLRX(5) .EQ. 2) GO TO 54
      DO 52 J = 1,NROWU
   52 RZ(SGLKOR+J-1) = RZ(SGLKOR+J-1)/HIRMAG
      GO TO 80
   54 DO 56 J = 1,NROWU
   56 DZ(DBLKOR+J-1) = DZ(DBLKOR+J-1)/DHIRMG
      GO TO 80
C
C     NULL COLUMN
C
   60 IF (JTRLRX(5) .EQ. 2) GO TO 74
      DO 72 J = 1,NROWU
   72 RZ(SGLKOR+J-1) = 0.0
      GO TO 80
   74 DO 76 J = 1,NROWU
   76 DZ(DBLKOR+J-1) = 0.0D0
C
C     PACK HIR COLUMN
C
   80 CALL PACK (DZ(DBLKOR),HIRSCR,ITRLR1)
      CALL CLOSE (HIRSCR,1)
      CALL CLOSE (HIR,1)
      CALL WRTTRL (ITRLR1)
      ISUB(1) = ITRLR1(2)
C
C     SET UP MERGE COLUMN PARTITION VECTOR
C
      ITRLR2(1) = HIM
      CALL RDTRL (ITRLR2)
      I = ITRLR1(2) + ITRLR2(2)
      ISUB(2) = ITRLR2(2)
      DO 100 J = 1,I
      RZ(KORBGN+J-1) = 0.0
      IF (J .GT. ISUB(1)) RZ(KORBGN+J-1) = 1.0
  100 CONTINUE
      TYPINP = 1
      TYPEOP = 1
      IROWP  = 1
      NROWP  = I
      INCRP  = 1
      IFORM  = 7
      CALL MAKMCB (ITRLR2,RPRTN,NROWP,IFORM,TYPINP)
      CALL GOPEN (RPRTN,Z(GBUF1),1)
      CALL PACK(RZ (KORBGN),RPRTN,ITRLR2)
      CALL CLOSE (RPRTN,1)
      CALL WRTTRL (ITRLR2)
C
C     MERGE FREEBODY, MODAL TRANSFORMATION MATRICES
C
C        **   **   **         **
C        *     *   *     .     *
C        * HIE * = * HIR . HIM *
C        *     *   *     .     *
C        **   **   **         **
C
      IF (HIE .NE. HIM) GO TO 105
      HIE = ISCR8
      HGH = ISCR7
  105 ITYPE = 1
      IF (I .NE. ITRLR2(3)) ITYPE = 2
      CALL GMMERG (HIE,HIRSCR,0,HIM,0,RPRTN,0,ISUB,ITYPE,Z(KORBGN),
     1             KORLEN)
      CALL SOFOPN (Z(SBUF1),Z(SBUF2),Z(SBUF3))
      GO TO 120
C
C     FREEBODY MODES NOT REQUESTED
C
  110 HIE = HIM
      IF (HIE .EQ. ISCR7) HGH = ISCR8
      IF (HIE .EQ. ISCR8) HGH = ISCR7
C
C     FORM HGH MATRIX
C
C                  **         **
C                  *     .     *
C        **   **   *  I  .  0  *
C        *     *   *     .     *
C        * HGH * = *...........*
C        *     *   *     .     *
C        **   **   * GIB . HIE *
C                  *     .     *
C                  **         **
C
  120 CALL SOFTRL (OLDNAM,ITMLST(2),ITRLR1)
      IF (ITRLR1(1) .EQ. 1) GO TO 190
C
C     GENERATE IDENTITY MATRIX
C
      CALL SOFTRL (OLDNAM,ITMLST(1),ITRLR1)
      ITEST = ITRLR1(1)
      ITEM  = ITMLST(1)
      IF (ITEST .NE. 1) GO TO 210
      TYPINP = 1
      TYPEOP = ITRLR1(5)
      IROWP  = 1
      NROWP  = ITRLR1(2)
      INCRP  = 1
      IFORM  = 8
      II = ITRLR1(2)
      CALL MAKMCB (ITRLR1,IDENT,NROWP,IFORM,TYPEOP)
      CALL GOPEN  (IDENT,Z(GBUF1),1)
      DO 140 I = 1,II
      DO 130 J = 1,II
      RZ(KORBGN+J-1) = 0.0
      IF (I .EQ. J) RZ(KORBGN+J-1) = 1.0
  130 CONTINUE
  140 CALL PACK (RZ(KORBGN),IDENT,ITRLR1)
      CALL CLOSE (IDENT,1)
      CALL WRTTRL (ITRLR1)
C
C     SET UP MERGE ROW PARTITION VECTOR
C
      ITRLR1(1) = HIE
      CALL RDTRL (ITRLR1)
      ITER  = ITRLR1(2)
      NROWP = II + ITER
      DO 170 I = 1,NROWP
      RZ(KORBGN+I-1) = 0.0
      IF (I .GT. II) RZ(KORBGN+I-1) = 1.0
  170 CONTINUE
      TYPINP = 1
      TYPEOP = 1
      INCRP  = 1
      IFORM  = 7
      CALL MAKMCB (ITRLR2,RPRTN,NROWP,IFORM,TYPINP)
      CALL GOPEN (RPRTN,Z(GBUF1),1)
      CALL PACK (RZ(KORBGN),RPRTN,ITRLR2)
      CALL CLOSE (RPRTN,1)
      CALL WRTTRL (ITRLR2)
      NROWS = NROWP
C
C     SET UP MERGE COLUMN PARTITION VECTOR
C
      ITEM = ITMLST(3)
      CALL MTRXI (CPRTN,OLDNAM,ITEM,0,ITEST)
      IF (ITEST .NE. 1) GO TO 210
C
C     SET UP GIB MATRIX
C
      CALL MTRXI (GIB,OLDNAM,ITMLST(1),0,ITEST)
      ITEM = ITMLST(1)
      IF (ITEST .NE. 1) GO TO 210
C
C     MERGE ALL STRUCTURAL REDUCTION TRANSFORMATION MATRICES
C
      ISUB(1) = II
      ISUB(2) = ITER
      ISUB(3) = ITRLR1(3)
      ISUB(4) = II
      ITYPE   = 1
      IF (NROWS .NE. NROWP) ITYPE = 2
      CALL GMMERG (HGH,GIB,IDENT,HIE,0,RPRTN,CPRTN,ISUB,ITYPE,Z(KORBGN),
     1             KORLEN)
C
C     SAVE HGH ON SOF AS HORG MATRIX
C
      CALL MTRXO (HGH,OLDNAM,ITMLST(2),0,ITEST)
      ITEM = ITMLST(2)
      IF (ITEST .NE. 3) GO TO 210
  190 CONTINUE
      GO TO 300
C
C     PROCESS MODULE FATAL ERRORS
C
  210 GO TO (220,230,240,250,260,280), ITEST
  220 IMSG = -9
      GO TO 290
  230 IMSG = -11
      GO TO 290
  240 IMSG = -1
      GO TO 270
  250 IMSG = -2
      GO TO 270
  260 IMSG = -3
  270 CALL SMSG (IMSG,ITEM,OLDNAM)
      GO TO 300
  280 IMSG = -10
  290 DRY  = -2
      CALL SMSG1 (IMSG,ITEM,OLDNAM,MODNAM)
  300 RETURN
      END

      SUBROUTINE FLBEMA (TYPE)
C
C     ASSEMBLES THE AF OR DKGG MATRIX UTITLIZING THE ELEMENT
C     MATRICES GENERATED IN FLBEMG
C
C     TYPE = 1  AFF MATRIX
C     TYPE = 2  DKGG MATRIX
C
      LOGICAL         ERROR    ,SKIP
      INTEGER         GEOM2    ,ECT      ,BGPDT    ,SIL      ,MPT      ,
     1                GEOM3    ,CSTM     ,USET     ,EQEXIN   ,USETF    ,
     2                USETS    ,AF       ,DKGG     ,FBELM    ,FRELM    ,
     3                CONECT   ,AFMAT    ,AFDICT   ,KGMAT    ,KGDICT   ,
     4                TYPE     ,OUTMAT   ,XMAT     ,XDICT    ,Z        ,
     5                FILE     ,NAME(2)  ,MCB(7)   ,ALLOC(3) ,DICT(2)  ,
     6                TYPIN    ,TYPOUT   ,ROWSIL(4),COLSIL(12)         ,
     7                OPTC     ,OPTW     ,RD       ,RDREW    ,WRT      ,
     8                WRTREW   ,REW      ,NOREW    ,TERMS(288)
      CHARACTER       UFM*23   ,UWM*25   ,UIM*29   ,SFM*25
      COMMON /XMSSG / UFM      ,UWM      ,UIM      ,SFM
      COMMON /FLBFIL/ GEOM2    ,ECT      ,BGPDT    ,SIL      ,MPT      ,
     1                GEOM3    ,CSTM     ,USET     ,EQEXIN   ,USETF    ,
     2                USETS    ,AF       ,DKGG     ,FBELM    ,FRELM    ,
     3                CONECT   ,AFMAT    ,AFDICT   ,KGMAT    ,KGDICT
      COMMON /ZZZZZZ/ Z(1)
      COMMON /FLBPTR/ ERROR    ,ICORE    ,LCORE    ,IBGPDT   ,NBGPDT   ,
     1                ISIL     ,NSIL     ,IGRAV    ,NGRAV    ,IGRID    ,
     2                NGRID    ,IBUF1    ,IBUF2    ,IBUF3    ,IBUF4    ,
     3                IBUF5
      COMMON /SYSTEM/ SYSBUF   ,NOUT
      COMMON /NAMES / RD       ,RDREW    ,WRT      ,WRTREW   ,REW      ,
     1                NOREW
      DATA    NAME  / 4HFLBE,4HMA   /
C
C
C     ASSIGN FILES DEPENDING ON TYPE
C
      GO TO (2,4), TYPE
C
C     AF MATRIX
C
    2 OUTMAT = AF
      XMAT   = AFMAT
      XDICT  = AFDICT
      GO TO 6
C
C     DKGG MATRIX
C
    4 OUTMAT = DKGG
      XMAT   = KGMAT
      XDICT  = KGDICT
C
C     ALLOCATE COLUMN POINTER VECTOR IN TOP OF CORE
C
    6 MCB(1) = USET
      CALL RDTRL(MCB)
      LUSET = MCB(3)
      ICOL  = 1
      NCOL  = LUSET
      DO 10 I = 1,NCOL
   10 Z(I) = 0
C
C     INITILIZE OPEN AND CLOSE OPTIONS
C
      OPTW = WRTREW
      OPTC = NOREW
C
C     POSITION CONNECT FILE TO PROPER RECORD
C
      FILE = CONECT
      CALL OPEN (*1001,CONECT,Z(IBUF1),RDREW)
      IF (TYPE .EQ. 2) CALL SKPFIL (CONECT,1)
      CALL FWDREC (*1002,CONECT)
      CALL CLOSE (CONECT,NOREW)
C
C     INITIALIZE PACK - UNPACK DATA
C
      TYPIN  = 2
      TYPOUT = 2
      MCB(1) = OUTMAT
      MCB(2) = 0
      MCB(3) = LUSET
      MCB(4) = 3 - TYPE
      MCB(5) = TYPOUT
      MCB(6) = 0
      MCB(7) = 0
C
C     SET UP CORE POINTERS
C
      ICORE = NCOL  + 1
      LCORE = IBUF2 - 1
      NCORE = LCORE - ICORE
      IF (NCORE .LT. 200) GO TO 1008
C
      SKIP  = .FALSE.
      ILCOL = 0
C
C
C     ALLOCATE ALL AVALABLE CORE FOR THIS PASS BY USE OF CONECT FILE
C
   30 IFCOL = ILCOL + 1
      JCORE = ICORE
      FILE  = CONECT
C
      CALL GOPEN (CONECT,Z(IBUF1),RD)
C
      IF (SKIP) GO TO 60
   50 CALL READ (*70,*1008,CONECT,ALLOC,3,1,N)
C
   60 ISIL     = ALLOC(1)
      Z(ISIL)  = JCORE
      Z(JCORE) = JCORE + 1
      JCORE    = JCORE + 1 + ALLOC(2) + 2*ALLOC(3)
      IF(JCORE .GT. LCORE ) GO TO 80
      ILCOL = ISIL
      GO TO 50
C
C     END OF RECORD ON CONECT - ALL COLUMNS ALLOCATED
C
   70 ILCOL = LUSET
      OPTC  = REW
      GO TO 90
C
C     INSUFFICIENT CORE FOR NEXT COLUMN - SET FLAG TO SAVE CURRENT
C     CONECT ALLOCATION RECORD
C
   80 SKIP = .TRUE.
C
   90 CALL CLOSE (CONECT,OPTC)
C
C     OPEN DICTIONARY AND MATRIX FILES AND PREPARE TO MAKE PASS
C
      CALL GOPEN (XDICT,Z(IBUF1),RDREW)
      CALL GOPEN (XMAT,Z(IBUF2),RDREW)
      ICPOS = 0
C
C     READ XDICT ENTRY AND DETERMINE IF COLUMN IS IN CORE FOR THIS
C     PASS
C
  100 FILE = XDICT
      CALL READ (*1002,*200,XDICT,DICT,2,0,N)
      ISIL = DICT(1)
      IF (ISIL.LT.IFCOL .OR. ISIL.GT.ILCOL) GO TO 100
C
C     THE COLUMN IS IN CORE - OBTAIN MATRIX DATA FROM XMAT FILE IF
C     WE DO NOT ALREADY HAVE IT
C
      IF (DICT(2) .EQ. ICPOS) GO TO 150
      ICPOS = DICT(2)
      FILE  = XMAT
      CALL FILPOS (XMAT,ICPOS)
      CALL READ (*1002,*1003,XMAT,ROWSIL,4,0,N)
      CALL READ (*1002,*1003,XMAT,COLSIL,4,0,N)
      NROW  = 4
      IF (ROWSIL(4) .LT. 0) NROW = 3
      NCOL  = 4
      IF (COLSIL(4) .LT. 0) NCOL = 3
      CALL READ (*1002,*110,XMAT,TERMS,289,0,NWDS)
      ICODE = 1
      GO TO 8010
C
C     EXPAND COLSIL TO INCLUDE ALL SILS
C
  110 IF(NWDS .LT. 162) GO TO 130
      DO 120 I = 1,4
      J = 4 - I
      COLSIL(3*J+1) = COLSIL(J+1)
      COLSIL(3*J+2) = COLSIL(J+1) + 1
  120 COLSIL(3*J+3) = COLSIL(J+1) + 2
      NCOL   = NCOL * 3
  130 NTPERS = 2
      IF(NWDS .LT. 54) GO TO 150
      NTPERS = 6
C
C     LOCATE POSITION OF MATRIX TERMS FOR DESIRED SIL
C
  150 DO 160 KCOL = 1,NCOL
      IF (COLSIL(KCOL) .EQ. ISIL) GO TO 170
  160 CONTINUE
      ICODE = 2
      GO TO 8010
C
  170 ILOC = (KCOL-1)*NROW*NTPERS + 1
C
C     EXTRACT MATRIX TERMS AND STORE THEM IN CORE
C
      ICODE = 3
      JCORE = Z(ISIL)
      IF (JCORE .EQ. 0) GO TO 8010
      KCORE = Z(JCORE)
      DO 190 I = 1,NROW
      Z(KCORE) = ROWSIL(I)
      IF (NTPERS .EQ. 2) Z(KCORE) = -ROWSIL(I)
      KCORE = KCORE + 1
      DO 180 J = 1,NTPERS
      Z(KCORE) = TERMS(ILOC)
      ILOC  = ILOC  + 1
  180 KCORE = KCORE + 1
  190 CONTINUE
      Z(JCORE) = KCORE
C
      GO TO 100
C
C     END OF FILE ON XDICT - PREPARE TO PACK OUT COLUMNS IN CORE
C
  200 CALL CLOSE (XDICT,OPTC)
      CALL CLOSE (XMAT,OPTC)
      CALL GOPEN (OUTMAT,Z(IBUF1),OPTW)
C
C     PACK OUT COLUMNS
C
      DO 210 I = IFCOL,ILCOL
      CALL BLDPK (TYPIN,TYPOUT,OUTMAT,0,0)
      IF (Z(I) .EQ. 0) GO TO 210
C
      ILOC = Z(I) + 1
      NLOC = Z(ILOC-1) - ILOC
      CALL PAKCOL (Z(ILOC),NLOC)
C
  210 CALL BLDPKN (OUTMAT,0,MCB)
C
      CALL CLOSE (OUTMAT,OPTC)
C
C     RETURN FOR ADDITIONAL PASS IF MORE NONZERO COLUMNS REMAIN
C
      OPTW = WRT
      IF (ILCOL .LT. LUSET) GO TO 30
C
C     ALL COLUMNS PROCESSED - WRITE TRAILER AND RETURN
C
      CALL WRTTRL (MCB)
      RETURN
C
C     ERROR CONDITIONS
C
 1001 N = -1
      GO TO 1100
 1002 N = -2
      GO TO 1100
 1003 N = -3
      GO TO 1100
 1008 N = -8
      GO TO 1100
C
 1100 CALL MESAGE (N,FILE,NAME)
C
 8010 WRITE  (NOUT,9010) SFM,ICODE
 9010 FORMAT (A25,' 8010, LOGIC ERROR IN SUBROUTINE FLBEMA - CODE',I3/)
      N = -61
      GO TO 1100
      END

      SUBROUTINE CONTOR (GPLST,X,U,DD,Z,IZ,PPEN,DEFORM,B1,OPCOR)
C
      INTEGER         OPCOR,IZ(1),GPLST(1),PPEN,PEN,DEFORM,PARM,EST,
     1                STRESS,SORT,SCR1,BUFSIZ,B1,B2,B3,ELID,ERR,SUB(2),
     2                COLOR,ELMID,GPTS(12),PEDGE,ESYM,OFFSET
      REAL            XB(8),X(3,1),DD(3,1),U(2,1),CENTER,RCNTRL,RCOLOR
      DIMENSION       LABL(50),Z(1),IBEGIN(2),PT(8)
      CHARACTER       UFM*23,UWM*25,UIM*29
      COMMON /XMSSG / UFM,UWM,UIM
      COMMON /BLANK / SKIP(10),PARM,SKP4,EST,SKP8(11),STRESS,SORT,
     1                NEWOES,SCR1
      COMMON /XXPARM/ SKIP2(157),NCNTR,CNTR(50),ICNTVL,SKIP6(5),ISET,
     1                SK18(18),COLOR,LAYER
      COMMON /PLTDAT/ SKIP3(2),XMIN
      COMMON /SYSTEM/ BUFSIZ,NOUT
      COMMON /DRWDAT/ JSET,SKIP7(14),PEDGE
      EQUIVALENCE     (IBEGIN(1),LINES),(IBEGIN(2),IGDPT)
      DATA    KBAR  , KT3,KQ4/ 2HBR,2HT3,2HQ4 /
      DATA    SUB   / 4HCONT , 4HOR           /
C
      B2  = B1 - 2*BUFSIZ
      B3  = B2 - BUFSIZ
      LOPCOR  = OPCOR/5
      ID  = 1
      ERR = 0
      IRR = 0
      NCNTR = IABS(NCNTR)
C
C     COLOR = 0 IS NO COLOR CONTOUR,
C     COLOR = 1 TO  31 IS DRAW CONTOUR LINES IN COLOR.
C     COLOR =-1 TO -31 ID COLOR FILL ELEMENTS BY STRESS
C
C     THIS IS THE CODE FOR THE COLOR BAR SCALE
C     AT THE TOP OF THE PLOT
C
      IF (COLOR .EQ. 0) GO TO 40
      CALL LINE (0.0,0.0,0.0,0.0,32,-1)
      ICOLOR = IABS(COLOR)
      RCOLOR = 535.0/ICOLOR
C              535.0 IS BASED ON 1000X1000 PLOT SCREEN COORDINATE FRAME
      DO 30 IB = 1,ICOLOR
      PEN   = IB + 31
      XB(1) = 368.14 + RCOLOR*(IB-1)
      XB(2) = 959.67
      XB(3) = XB(1) + RCOLOR
      XB(4) = XB(2)
      XB(5) = XB(3)
      XB(6) = 977.51
      XB(7) = XB(1)
      XB(8) = XB(6)
      IK    = 0
      IK1   = 1
      IK2   = 2
      IK3   = 3
      IK4   = 4
      DO 20 II = 1,4
      IK1 = IK1 + IK
      IK2 = IK2 + IK
      IK3 = IK3 + IK
      IK4 = IK4 + IK
      IK  = 2
      IF (II .EQ. 4) PEN = 0
      IF (II .NE. 4) GO TO 10
      IK1 = 7
      IK2 = 8
      IK3 = 1
      IK4 = 2
   10 CALL LINE (XB(IK1),XB(IK2),XB(IK3),XB(IK4),PEN,0)
   20 CONTINUE
   30 CONTINUE
      CALL LINE (0.0,0.0,0.0,0.0,PEN,+1)
   40 ISAV = LOPCOR + ID
      IVAL = LOPCOR + ISAV
      ICEN = LOPCOR + IVAL
      LOPCOR= LOPCOR- 1
      PEN = PPEN
      IF (ICNTVL.GT.9 .AND. ICNTVL.LT.14 .AND. PEDGE.NE.1) GO TO 50
      CALL CLOSE (PARM,2)
      IF (ICNTVL.LE.9 .OR. ICNTVL.GT.13) CALL CREATE (GPLST,X,U,DEFORM,
     1    CONMIN,CONMAX,Z(IVAL),Z(ICEN),LOPCOR,B1,B2)
      IF (ISET .NE. JSET) CALL ORDER (GPLST,Z(IVAL),Z(ISAV),Z(ICEN),
     1    Z(ID),LOPCOR,B1,B2,B3)
      ISET = JSET
   50 IF (ICNTVL.GT.9 .AND. ICNTVL.LT.14)
     1    CALL DISPLA (GPLST,X,U,DD,PEN,DEFORM,LABL,PT,B1)
      IF (ICNTVL.GT.9 .AND. ICNTVL.LT.14) GO TO 420
      IF (CONMIN .EQ. CONMAX) GO TO 470
      IF (COLOR .LT. 0) CALL CLOSE (EST,2)
      CALL GOPEN (SCR1,GPLST(B1),1)
      CALL CLOSE (SCR1,2)
      CALL GOPEN (SORT,GPLST(B2),2)
      CALL GOPEN (STRESS,GPLST(B1),0)
C
C     BUFFERS ASSIGNEMENT HERE -
C     B1 IS USED BY STRESS (SCRATCH1/301), AND BY SCR1 (SCRATCH4/304)
C     FOR SHORT PERIODS OF TIME ONLY
C     B2 IS USED BY SORT (SCRATCH2/302)
C     B3 IS USED BY EST (ELEST/103) AND BY SCR1 (SCRATCH4/304)
C
      NCNTR = MIN0(NCNTR,50)
      IF (CNTR(1) .NE. CNTR(2)) GO TO 90
C
C     IF INTERVALS SPECIFIED, DEFINE CONTOUR VALUES
C
      DELTA = (CONMAX-CONMIN)/FLOAT(NCNTR-1)
      CNTR(1) = CONMIN
      J = NCNTR - 1
      DO 80 I = 2,J
      CNTR(I) = CNTR(I-1) + DELTA
   80 CONTINUE
      CNTR(NCNTR) = CONMAX
   90 CALL LINE (0.,0.,0.,0.,PEN,-1)
      DO 100 I = 1,NCNTR
  100 LABL(I) = 3
C
C     READ AND STORE CONTOUR VALUES AND CENTROIDS
C
      ELID   = 0
      LOPCOX = LOPCOR + 1
      DO 110 I = 1,LOPCOX
      IS = ISAV + I - 1
      IZ(IS) = 0
  110 CONTINUE
      IF (COLOR .GE. 0) GO TO 130
      CALL GOPEN (EST,GPLST(B3),2)
      CALL BCKREC (EST)
      IMHERE = 120
  120 CALL READ (*280,*270,EST,ESYM,1,0,M)
      IRR = 0
      CALL FREAD (EST,NGPPE,1,0)
  130 CALL FWDREC (*415,SORT)
  140 CALL READ (*415,*415,SORT,IFLAG,1,0,M)
      IF (IFLAG .EQ.  0) GO TO 415
      IF (IFLAG .EQ. -2) GO TO 130
      CALL FREAD (SORT,IBEGIN,2,0)
      CALL READ  (*415,*150,SORT,IZ(ID),LINES,1,I)
  150 IREAD = 0
      NEL = 0
      DO 170 I = 1,LINES
      IC = ICEN + 2*(I-1)
      IV = IVAL + I - 1
      ID1= ID   + I - 1
      IS = ISAV + I - 1
      DO 160 J = 1,LOPCOR
      JS = ISAV + J - 1
      JV = IVAL + J - 1
      JC = ICEN + 2*(J-1)
      IF (IZ(JS)  .EQ. 0)  GO TO 170
      IF (IZ(ID1) .NE. IZ(JS)) GO TO 160
      Z(IV  ) = Z(JV)
      Z(IC  ) = Z(JC)
      Z(IC+1) = Z(JC+1)
      IZ(IS ) = IZ(ID1)
      NEL = NEL + 1
      GO TO 170
  160 CONTINUE
  170 CONTINUE
      IF (ELID .GT. 0) GO TO 190
  180 CALL READ (*290,*290,STRESS,ESSYM,1,0,M)
  190 CALL READ (*290,*180,STRESS,ELID,1,0,M)
      IF (ELID .EQ. 0) GO TO 180
      CALL FREAD (STRESS,V,1,0)
      CALL FREAD (STRESS,PT,2,0)
      DO 250 I = 1,LINES
      ID1 = ID  + I - 1
      IS = ISAV + I - 1
      IV = IVAL + I - 1
      IC = ICEN + 2*I - 2
      IF (IZ(ID1) .NE. ELID) GO TO 250
      IF (IZ(IS)  .EQ. ELID) GO TO 250
      Z(IV  ) = V
      Z(IC  ) = PT(1)
      Z(IC+1) = PT(2)
      IZ(IS ) = ELID
      IF (COLOR .GE. 0) GO TO 240
      IMHERE = 200
      ASSIGN 206 TO IRTN
  195 JRR = 0
  200 OFFSET = 0
      IF (ESYM .EQ. KBAR) OFFSET = 6
      IF (ESYM.EQ.KT3 .OR. ESYM.EQ.KQ4) OFFSET = 1
  201 CALL READ (*204,*205,EST,ELMID,1,0,M)
      IF (ELMID .EQ. 0) GO TO 203
      CALL FREAD (EST,0,-1,0)
      CALL FREAD (EST,GPTS,NGPPE,0)
      IF (OFFSET .NE. 0) CALL FREAD (EST,0,-OFFSET,0)
      IF (ELMID .EQ. ELID) GO TO 210
      GO TO 201
C
  203 JRR = JRR + 1
      IF (JRR .LE. 1) CALL BCKREC (EST)
      IMHERE = 203
      ASSIGN 120 TO IRTN
      CALL READ (*204,*204,EST,ESYM,1,0,M)
      CALL FREAD (EST,NGPPE,1,0)
      GO TO 200
C
  204 ERR = ERR + 1
      IF (ERR .GT. 3) GO TO 285
      CALL REWIND (EST)
      CALL SKPREC (EST,1)
      GO TO IRTN, (120,205,206)
C
  205 IMHERE = 205
      ASSIGN 205 TO IRTN
  206 CALL READ (*204,*205,EST,ESYM,1,0,M)
      CALL FREAD (EST,NGPPE,1,0)
      GO TO 195
C
C     START TO CONTOUR FILL HERE
C
  210 RCOLOR = ICOLOR
      RCNTRL = NCNTR
      DO 230 IK = 1,NCNTR
      PEN = 32 + (1.0-(RCNTRL-IK+1)/RCNTRL)*RCOLOR
      IK1 = IK + 1
      IF (IK .EQ. NCNTR) IK1 = IK
      IF (V.LT.CNTR(IK) .OR. V.GT.CNTR(IK1)) GO TO 230
      DO 220 J = 1,NGPPE
      K  = J + 1
      IG = GPTS(J)
      IG = IABS(GPLST(IG))
      IF (J .EQ. NGPPE) K = 1
      IG1 = GPTS(K)
      IG1 = IABS(GPLST(IG1))
      IF (J .EQ. NGPPE) PEN = 0
      CALL LINE (X(2,IG),X(3,IG),X(2,IG1),X(3,IG1),PEN,0)
  220 CONTINUE
      GO TO 240
  230 CONTINUE
  240 NEL = NEL + 1
      GO TO 260
  250 CONTINUE
  260 IF (NEL .GE. LINES) GO TO 300
      GO TO 190
C
  270 CALL BCKREC (EST)
      IRR = IRR + 1
      IF (IRR .LT. 3) GO TO 120
C
C     END OF FILE ON EST
C
  280 ERR = ERR + 1
      IF (ERR .GT. 3) GO TO 285
      CALL REWIND (EST)
      CALL SKPREC (EST,1)
      GO TO 120
  285 WRITE  (NOUT,286) UIM,ELID,IMHERE,ERR,IRR,NGPPE
  286 FORMAT (A29,', CONTOUR FAILED TO LOCATE ELMENT ID =',I8, /5X,
     2        'IMHERE =',I5, 5X,'ERR,IRR,NGPPE =',3I8)
      GO TO 190
C
C     END OF FILE ON STRESS
C
  290 CALL REWIND (STRESS)
      CALL FWDREC (*415,STRESS)
      IF (IREAD .EQ. 1) GO TO 140
      IREAD = 1
      GO TO 180
C
C     END DATA SEARCH
C
  300 L  = LINES
      IS = LINES + ISAV
      IZ(IS) = 0
      IF (LINES .GT. 3) GO TO 310
      XMID   = Z(ICEN+4)
      YMID   = Z(ICEN+5)
      CENVAL = Z(IVAL+2)
      L = 1
      GO TO 350
  310 IG = IABS(GPLST(IGDPT))
      IF (DEFORM .NE. 0) GO TO 320
      XMID = X(2,IG)
      YMID = X(3,IG)
      GO TO 330
  320 XMID = U(1,IG)
      YMID = U(2,IG)
  330 SUM1 = 0.0
      SUM2 = 0.0
      DO 340 I = 1,LINES
      IV = IVAL + I - 1
      IC = ICEN + 2*I - 2
      S  = SQRT((XMID-Z(IC))**2 + (YMID-Z(IC+1))**2)
      SUM1 = SUM1 + Z(IV) * S
  340 SUM2 = SUM2 + S
      CENVAL = SUM1/SUM2
  350 IV = IVAL + LINES
      IC = ICEN + 2*LINES
      Z(IV  ) = Z(IVAL)
      Z(IC  ) = Z(ICEN)
      Z(IC+1) = Z(ICEN+1)
C
C     PLOT CONTOURS.
C
      IF (COLOR .LT. 0) GO TO 140
      RCOLOR = ICOLOR
      RCNTRL = NCNTR
C
      CALL CLOSE (EST,2)
      CALL GOPEN (SCR1,GPLST(B3),3)
C
      DO 410 I = 1,NCNTR
      IF (COLOR .NE. 0) PEN = 1 + (1.0-(RCNTRL-I+1)/RCNTRL)*RCOLOR
      DO 400 J = 1,L
      PT(1) = XMIN - 1.0
      PT(3) = PT(1)
      PT(5) = PT(1)
      JC    = ICEN + 2*J - 2
      JV    = IVAL + J - 1
      D     = (Z(JV) - Z(JV+1))
      IF (ABS(Z(JV)-CNTR(I)).GT.ABS(D) .OR. ABS(Z(JV+1)-CNTR(I))
     1    .GT.ABS(D)) GO TO 360
      IF (D .EQ. 0.0) D = 1.0
      PT(1) = Z(JC  ) + (Z(JC+2)-Z(JC  ))*(Z(JV)-CNTR(I))/D
      PT(2) = Z(JC+1) + (Z(JC+3)-Z(JC+1))*(Z(JV)-CNTR(I))/D
  360 D = Z(JV+1) - CENVAL
      IF (ABS(Z(JV+1)-CNTR(I)).GT.ABS(D) .OR. ABS(CENVAL-CNTR(I))
     1    .GT.ABS(D)) GO TO 370
      IF (D .EQ. 0.0) D = 1.0
      PT(3) = Z(JC+2) + (XMID-Z(JC+2))*(Z(JV+1)-CNTR(I))/D
      PT(4) = Z(JC+3) + (YMID-Z(JC+3))*(Z(JV+1)-CNTR(I))/D
  370 D = CENVAL - Z(JV)
      IF (ABS(CENVAL-CNTR(I)).GT.ABS(D) .OR.
     1   ABS(Z(JV)-CNTR(I)) .GT. ABS(D)) GO TO 380
      IF (D .EQ. 0.0) D = 1.0
      PT(5) = XMID + (Z(JC  )-XMID)*(CENVAL-CNTR(I))/D
      PT(6) = YMID + (Z(JC+1)-YMID)*(CENVAL-CNTR(I))/D
  380 PT(7) = PT(1)
      PT(8) = PT(2)
      DO 390 K = 1,5,2
      IF (PT(K).LT.XMIN .OR. PT(K+2).LT.XMIN) GO TO 390
      CALL LINE (PT(K),PT(K+1),PT(K+2),PT(K+3),PEN,0)
      LABL(I) = LABL(I) + 1
      IF (LABL(I) .NE. 4) GO TO 390
      LABL(I) = 0
      CALL WRITE (SCR1,I,1,0)
      CALL WRITE (SCR1,PT(K),2,0)
  390 CONTINUE
  400 CONTINUE
  410 CONTINUE
C
      CALL CLOSE (SCR1,2)
      CALL GOPEN (EST,GPLST(B3),2)
      GO TO 140
C
  415 CALL CLOSE (SORT,1)
      CALL CLOSE (STRESS,1)
      CALL CLOSE (SCR1,1)
C     IF (COLOR .LT. 0) CALL CLOSE (EST,1)
C     IF (COLOR .GE. 0) CALL GOPEN (EST,GPLST(B3),2)
  420 CALL LINE (0.,0.,0.,0.,PEN,+1)
      IF (COLOR .EQ. 0) GO TO 430
      CALL TYPFLT (0.0,0.0,0,0,0,-1)
      CALL TYPFLT (368.14,990.0,1,CNTR(1),-8,0)
      CENTER = (CNTR(1)+CNTR(NCNTR))/2.0
      CALL TYPFLT (585.90,990.0,1,CENTER,-8,0)
      CALL TYPFLT (796.3,990.0,1,CNTR(NCNTR),-8,0)
      CALL TYPFLT (0.0,0.0,0,0,0,+1)
      IF (COLOR .LT. 0) GO TO 460
  430 CALL GOPEN (SCR1,GPLST(B1),0)
      IF (COLOR .EQ. 0) CALL TYPINT (0.,0.,0,0,0,-1)
  440 CALL READ (*450,*450,SCR1,I,1,0,M)
      CALL FREAD (SCR1,PT,2,0)
      IF (COLOR .EQ. 0) CALL TYPINT (PT(1),PT(2),1,I,1,0)
      GO TO 440
  450 IF (COLOR .EQ. 0) CALL TYPINT (0.,0.,0,0,0,+1)
      CALL CLOSE (SCR1,1)
  460 CALL PLTOPR
  470 IF ((ICNTVL.GT.9 .AND. ICNTVL.LT.14) .AND. PEDGE.NE.1) RETURN
      CALL GOPEN (PARM,GPLST(B2),2)
      RETURN
      END

      SUBROUTINE CFBSOR (LL,UL,BX,XX,IOPT)
C
      INTEGER         UL,BX,XX,MCB(7)
      COMMON /ZZZZZZ/ IZ(1)
      COMMON /GFBSX / JFL(7), JFU(7),JFB(7),JFX(7),JX,JPREC,JSIGN
      COMMON /FBSX  / MFL(7),MFLT(7),MFB(7),MFX(7),MX,MPREC,MSIGN
      COMMON /SYSTEM/ IDUM(54),IPREC
C
      NZ = KORSZ(IZ)
      MCB(1) = IABS(BX)
      CALL RDTRL (MCB)
      IF (IOPT .EQ. 1) GO TO 100
C
C     SYMETRIC FBS
C
      MFL(1) = LL
      CALL RDTRL (MFL)
      DO 10 I = 1,7
      MFB(I) = MCB(I)
      MFX(I) = MCB(I)
   10 CONTINUE
      MFX(1) = XX
      MX     = NZ
      MFX(5) = MAX0(MFL(5),MFB(5))
      MPREC  = IPREC
      MSIGN  = +1
      IF (BX .LT. 0) MSIGN = -1
      CALL FBS (IZ,IZ)
      CALL WRTTRL (MFX)
   20 RETURN
C
C     UNSYMETRIC FBS
C
  100 JFL(1) = LL
      CALL RDTRL (JFL)
      JFU(1) = UL
      CALL RDTRL (JFU)
      DO 110 I = 1,7
      JFB(I) = MCB(I)
      JFX(I) = MCB(I)
  110 CONTINUE
      JFX(1) = XX
      JX     = NZ
      JPREC  = IPREC
      JFX(5) = MAX0(JFL(5),JFB(5))
      JSIGN  = +1
      IF (BX .LT. 0) JSIGN = -1
      CALL GFBS (IZ,IZ)
      CALL WRTTRL (JFX)
      GO TO 20
      END

      SUBROUTINE HDCOEF(X,Y,Z,XXX,JXX,NS,CCC,LZ)
C
C
C     THIS SUBROUTINE DETERMINES EQUATION OF LINES AND PLANES.
C
C
      INTEGER   ZCOEF1,ZCOEF,IBCOEF(5)
      DIMENSION CCC(1),XXX(1),X(1),Y(1),Z(1),COE(8)
      COMMON/ZZZZZZ/RZ(1)
      COMMON/HDPTRS/XDUM,XCC,XASOLV,YASOLV,ZASOLV,X1SKT,Y1SKT,Z1SKT,
     1              ZCOEF1,ZCOEF
      COMMON/GO3/L0,L1,L00,L01,L2,L3,L4,L5,L6,L7,L8,L9,L10,L11,L12,L13
      DATA EPSI / 1.0E-5 /
      LE=0
      JA=L13+(JXX-1)*LZ
      JF=L12+(JXX-1)*5
      I=0
      J=1
   10 CONTINUE
C
C
C     SEARCH FOR MATCHING COORDINATES.
C
C
      I=I+1
      T=X(I+1)-X(I)
      S=Y(I+1)-Y(I)
      U=Z(I+1)-Z(I)
      IF (ABS(T) .GT. EPSI)  GO TO 20
      IF (ABS(S) .GT. EPSI)  GO TO 20
      IF (ABS(U) .GT. EPSI)  GO TO 20
C
C
C     MATCH FOUND.....PROCEED IF LIST IS NOT EXHAUSTED.
C
C
      I=I+2
   20 CONTINUE
      IF(I.GT.NS)GO TO 70
C
C
C     DETERMINE EQUATION OF LINE-SEGMENTS.
C
C
      T=X(I+1)-X(I)
      T1=Y(I+1)-Y(I)
      IF ((ABS(T1) .LT. EPSI) .AND. (ABS(T) .LT. EPSI))  GO TO 10
      IF (ABS(T) .GT. EPSI)  GO TO 30
   29 CONTINUE
      CCC(J+JA)=0
      CCC(J+1+JA)=1
      CCC(J+2+JA)=-X(I)
      GO TO 40
   30 CONTINUE
      CCC(J+JA)=1
      E=(Y(I+1)-Y(I))/(X(I+1)-X(I))
      IF(ABS(E).GT.100000.)GO TO 29
      F=(E*X(I))-Y(I)
      CCC(J+1+JA)=-E
      CCC(J+2+JA)=F
   40 CONTINUE
      IF (ABS(CCC(J+JA)) .GT. EPSI)  GO TO 50
      CCC(J+3+JA)=Y(I)
      CCC(J+4+JA)=Y(I+1)
      GO TO 60
   50 CONTINUE
      CCC(J+3+JA)=X(I)
      CCC(J+4+JA)=X(I+1)
   60 CONTINUE
      J=J+5
      RZ(ZCOEF1+LE)=Z(I)
      RZ(ZCOEF+LE)=Z(I+1)
      LE=LE+1
      IF(LE.GT.3)GO TO 10
      IBCOEF(LE)=I
      GO TO 10
   70 CONTINUE
C
C
C     DETERMINE EQUATION OF PLANE.
C
      J=(J-1)/5
      XXX(JF+5)=J
      IF(NS.LE.3)GO TO 120
      K1=1
      K2=2
      K3=3
      A1=X(K3)-X(K1)
      B1=Y(K3)-Y(K1)
      C1=Z(K3)-Z(K1)
      A2=X(K2)-X(K1)
      B2=Y(K2)-Y(K1)
      C2=Z(K2)-Z(K1)
      COE(1)=B1*C2-B2*C1
      COE(2)=C1*A2-C2*A1
      COE(3)=A1*B2-A2*B1
      COE(4)=COE(1)*X(1)+COE(2)*Y(1)+COE(3)*Z(1)
      COE(4)=-COE(4)
      DO 110 J=1,4
  110 XXX(JF+J)=COE(J)
      IF (ABS(COE(3)) .GT. EPSI)  GO TO 140
      J=1
      DO 25 K=1,LE
      JAPJ=JA+J
      CCC(JAPJ)=RZ(ZCOEF1-1+K)
      CCC(JAPJ+1)=RZ(ZCOEF-1+K)
      J=J+5
   25 CONTINUE
      IF (ABS(COE(1)) .GT. EPSI)  I=1
      IF (ABS(COE(2)) .GT. EPSI)  I=2
      P=COE(I)
      IF (ABS(P) .LT. EPSI)  P = EPSI
      DO 26 K=1,4
      JFPK=JF+K
   26 XXX(JFPK)=XXX(JFPK)/P
      GO TO 140
  120 CONTINUE
      XXX(JF+5)=1
      DO 130 IX=1,2
  130 XXX(JF+IX)=Z(IX)
      XXX(JF+3)=0
  140 CONTINUE
      RETURN
      END

      SUBROUTINE UPCASE (BYTE,N)
C
C     THIS ROUTINE CHANGES ALL LOWER CASE CHARACTERS INTO UPPER CASE.
C     IT ALSO CONVERTS BCD INPUT CODE TO EBCDIC FOR IBM MACHINE
C
      LOGICAL         FLAG
      INTEGER         TAB(20),   FFFLAG
      CHARACTER*1     BYTE(1),  BK1,      LA,       LZ,       IL,
     1                IC,       IP,       LC(256)
      CHARACTER*56    KC(5)
      COMMON /MACHIN/ MACHX
      COMMON /UPCASX/ FLAG,     ID,       IA,       IZ
      COMMON /XECHOX/ FFFLAG
      EQUIVALENCE     (KC(1),LC(1))
C
C                     TAB = UPPER CASE 'A' TO LOWER CASE 'a' SPAN
C
      DATA            TAB / +32, -64, +32, +3968, +32, +32, +32, +32 ,
     1                      +32, +32, +32, +32,   +32, +32, +32, +32 ,
     2                      +32, +32, +32, +32     /
      DATA            BK1,      LA,       LZ,       IL,       IC     /
     1                ' ',      'A',      'Z',      '(',      ','    /
      DATA            IP /      '%'       /
C
C     TAB IS DECIMAL VALUE BETWEEN UPPER CASE 'A' AND LOWER CASE 'a'
C     TAB IS POSITIVE IF LOWER CASE 'a' COMES AFTER UPPER CASE 'A' IN
C     MACHINE ASCII CHARACTER SET; OTHERWISE TAB IS NEGATIVE.
C
C     THE FOLLOWING KC TABLE MUST BE PUNCHED IN EBCDIC CODE (FOR IBM
C     ONLY)                          =======    ===========
C
      DATA            KC /
     1   '                                                        ',
     2   '                   .)(+ +          $*)  -/         ,(%  ',
     3 '           =''''=  ABCDEFGHI       JKLMNOPQR        STUVWX',
     4   'YZ                       ABCDEFGHI       JKLMNOPQR      ',
     5   '  STUVWXYZ      0123456789      WRITTEN BY G.CHAN/UNISYS'/
C
      IF (MACHX .EQ. 2) GO TO 30
      IF (FLAG) GO TO 10
      FLAG =.TRUE.
      ID = TAB(MACHX)
      IA = ICHAR(LA) + ID
      IZ = ICHAR(LZ) + ID
C
 10   DO 20 I = 1,N
      IF (BYTE(I) .EQ. BK1) GO TO 20
      J = ICHAR(BYTE(I))
      IF (J.LT.IA .OR. J.GT.IZ) GO TO 20
      BYTE(I) = CHAR(J-ID)
 20   CONTINUE
      RETURN
C
C     IBM MACHINE ONLY, WHICH USES EBCDIC CODE
C
 30   DO 40 I = 1,N
      J = ICHAR(BYTE(I))
 40   BYTE(I) = LC(J+1)
C
C     THE % SIGN MAY BE CHANGED TO ( IN BCD-EBCDIC CONVERSION,
C     CHANGE IT BACK TO %
C
      IF (FFFLAG.NE.1234 .OR. N.LT.5) RETURN
      DO 50 I = 5,N
      IF (BYTE(I).EQ.IL .AND. BYTE(I+1).EQ.IL .AND. (BYTE(I-1).EQ.IC
     1   .OR. BYTE(I-1).EQ.BK1)) BYTE(I) = IP
 50   CONTINUE
      RETURN
      END

      SUBROUTINE SHFORS (NUMPX,ELID,IGRID,THIKNS,G,EPSCSI,QVECI,IDR)
C
C     TO CALCULATE SHELL ELEMENT FORCES FOR A 2-DL FORMULATION BASE.
C
C
C     INPUT :
C           NUMPX  - NUMBER OF EVALUATION POINTS
C           ELID   - ELEMENT ID
C           IGRID  - ARRAY IF EXTERNAL GRID IDS
C           THIKNS - EVALUATION POINT THICKNESSES
C           G      - 6X6 STRESS-STRAIN MATRIX
C           EPSCSI - CORRECTED STRAINS AT EVALUATION POINTS
C           QVECI  - CALCULATED SHEAR FORCES READY FOR OUTPUT
C           IDR    - REORDERING ARRAY BASED ON EXTERNAL GRID POINT ID'S
C          /OUTREQ/- OUTPUT REQUEST LOGICAL FLAGS
C
C     OUTPUT:
C            FORCES ARE PLACED AT THE PROPER LOCATION IN /SDR2X7/.
C
C
C     THE FORCE RESULTANT OUTPUT DATA BLOCK, UAI CODE
C
C     ADDRESS    DESCRIPTIONS
C
C        1       ELID
C     ------------------------------------------------
C        2       GRID POINT NUMBER OR 'CNTR'
C      3 - 10    FORCES AT ELEMENT CENTER POINT
C     ---------- ABOVE DATA REPEATED 3 TIMES
C                FOR GRID POINTS
C
C
C     THE FORCE RESULTANT OUTPUT DATA BLOCK AT ELEMETN CENTER, COSMIC
C
C     ADDRESS    DESCRIPTIONS
C
C        1       ELID
C     ------------------------------------------------
C      2 - 9     FORCES AT ELEMENT CENTER POINT
C
C
      LOGICAL         GRIDS,VONMS,LAYER,STRCUR,STSREQ,STNREQ,FORREQ
     1,               GRIDSS,VONMSS,LAYERS,COSMIC
      INTEGER         IGRID(1),NFORS(1),IDR(1),ELID
      REAL            THIKNS(1),G(6,6),EPSCSI(6,1),QVECI(2,1),
     1                THICK,THICK2,T3OV12,DFORCE(8),GT(6,6)
      COMMON /SDR2X7/ DUM71(100),STRES(100),FORSUL(200),STRIN(100)
      COMMON /OUTREQ/ STSREQ,STNREQ,FORREQ,STRCUR,GRIDS,VONMS,LAYER
     1,               GRIDSS,VONMSS,LAYERS
      EQUIVALENCE     (NFORS(1),FORSUL(1))
      DATA    COSMIC/ .TRUE. /
C
C
C     ELEMENT CENTER POINT COMPUTAION ONLY FOR COSMIC
C     IE. CALLER SHOULD PASS 1 IN NUMPX FOR COSMIC, 4 FOR UAI
C
      NUMP = NUMPX
      IF (COSMIC) NUMP = 1
C
      NFORS(1)  = ELID
C
C     START THE LOOP ON EVALUATION POINTS
C
      NUMP1 = NUMP - 1
      DO 280 INPLAN = 1,NUMP
      THICK  = THIKNS(INPLAN)
      THICK2 = THICK*THICK
      T3OV12 = THICK2*THICK/12.0
C
      IFORCE = 1
      IF (COSMIC) GO TO 250
C
      IFORCE = (INPLAN-1)*9 + 2
      IF (.NOT.(GRIDS .AND. GRIDSS) .OR. INPLAN.LE.1) GO TO 230
      DO 200 INPTMP = 1,NUMP1
      IF (IDR(INPTMP) .EQ. IGRID(INPLAN)) GO TO 220
  200 CONTINUE
  220 CONTINUE
      IFORCE = INPTMP*9 + 2
      NFORS(IFORCE) = IGRID(INPLAN)
      GO TO 240
  230 NFORS(IFORCE) = INPLAN - 1
  240 IF (INPLAN .EQ. 1) NFORS(IFORCE) = IGRID(INPLAN)
C
C     MODIFY [G], THEN CALCULATE FORCES AND MOMENTS
C
  250 DO 260 IG = 1,3
      DO 260 JG = 1,3
      GT(IG  ,JG  ) = THICK *G(IG  ,JG  )
      GT(IG+3,JG  ) = THICK2*G(IG+3,JG  )
      GT(IG  ,JG+3) = THICK2*G(IG  ,JG+3)
      GT(IG+3,JG+3) = T3OV12*G(IG+3,JG+3)
  260 CONTINUE
      CALL GMMATS (GT,6,6,0, EPSCSI(1,INPLAN),6,1,0, DFORCE(1))
C
C     OUTPUT QX AND QY (WE HAVE CALCULATED QY AND QX)
C
      DFORCE(7) = QVECI(2,INPLAN)
      DFORCE(8) = QVECI(1,INPLAN)
C
C     SHIP OUT
C
      DO 270 IFOR = 1,8
      FORSUL(IFORCE+IFOR) = DFORCE(IFOR)
  270 CONTINUE
  280 CONTINUE
C
      RETURN
      END

      SUBROUTINE OUTPT2
C
C     COPY DATA BLOCK(S) ONTO FORTRAN UNIT.
C
C     CALL TO THIS MODULE IS
C
C     OUTPUT2    IN1,IN2,IN3,IN4,IN5/ /V,N,P1/V,N,P2/V,N,P3/
C                                      V,N,P4/V,N,P5/V,N,P6 $
C
C             P1 = 0, NO ACTION TAKEN BEFORE WRITE
C                     (DEFAULT P1=0)
C                =+N, SKIP FORWARD N DATA BLOCKS BEFORE WRITE
C                =-1, BEFORE WRITE, FORTRAN TAPE IS REWOUND AND A
C                     HEADER RECORD (RECORD NUMBER 0) ADDED TO TAPE
C                =-3, THE NAMES OF ALL DATA BLOCKS ON FORTRAN TAPE
C                     ARE PRINTED AND WRITE OCCURS AT THE END OF TAPE
C                =-9, WRITE A NULL FILE, ENDFILE AND REWIND FORTRAN
C                     TAPE.
C
C             P2 =    THE FORTRAN UNIT NO. ON WHICH THE DATA BLOCKS WILL
C                     BE WRITTEN. (DEFAULT P2=11).
C
C             P3 =    TAPE ID CODE FOR FORTRAN TAPE, AN ALPHANUMERIC
C                     VARIABLE WHOSE VALUE WILL BE WRITTEN ON A FORTRAN
C                     TAPE.
C                     THE WRITING OF THIS ITEM IS DEPENDENT ON THE
C                     VALUE OF P1 AS FOLLOWS.
C                          *P1*             *TAPE ID WRITTEN*
C                           +N                     NO
C                            0                     NO
C                           -1                    YES
C                           -3                     NO (WARNING CHECK)
C                    (DEFAULT P3 = XXXXXXXX).
C
C             P4 = 0, FORTRAN WRITTEN RECORD SIZE IS UNLIMITTED
C                     (DEFAULT FOR ALL MACHINES, EXECPT IBM)
C                =-N, MAXIMUM FORTRAN WRITTEN RECORD SIZE IS N TIMES
C                     THE SYSTEM BUFFER SIZE, N*BUFFSIZE
C                = N, MAXIMUM FORTRAN WRITTEN RECORD SIZE IS N WORDS.
C                -    IN ALL CASES, THE MAXIMUM FORTRAN WRITTEN RECORD
C                     SIZE SHOLD BE .GE. BUFFSIZE, AND .LE. AVAILABLE
C                     CORE
C                IBM, IF P4=0, AND SINCE IBM CAN NOT HANDLE UNLIMITED
C                     RECORD SIZE, RECORD SIZE P4 OF 1024 WORDS IS USED
C
C             P5 = 0  FOR NON-SPARSE, AND NON-ZERO FOR SPARSE MATRIX
C                     OUTPUT
C                = 0, KEY-WORD RECORD CONTAINS EFFECTIVELY ONE SINGLE
C                     WORD OF DATA (THIS IS THE ORIGINAL COSMIC/OUTPT2)
C                = NOT 0, KEY-WORD RECORD CONTAINS 2 WORDS, THUS ALLOW
C                     SPARSE MATRIX TO BE COPIED OUT.
C                     FIRST KEY WORD:
C                        >0, DEFINES THE LENGTH OF NEXT DATA RECORD
C                        =0, END-OF-FILE
C                        <0, END-OF-RECORD WITH ANOTHER RECORD TO FOLLOW
C                     SECOND KEY WORD:
C                        =0, TABLE DATA, OR P5 SPARSE MATRIX OPTION NOT
C                            REQUESTED
C                        >0, ROW-BASE FOR NEXT RECORD. FOR EXAMPLE:
C                            KEYS = 10,200 INDICATE NEXT DATA RECORD IS
C                            FOR ROW(200+1) THRU ROW(200+10)
C                            i.e. (ROW(KEY2+J),J=1,KEY1)
C
C             P6 = BLANK (DEFAULT)
C                = *MSC*,    OUTPUT2 WILL ISSUE RECORDS IN MSC/OUTPUT2
C                            FORMAT WHICH IS SLIGHTLY DIFFERENT FROM
C                            COSMIC/OUTPUT2.
C                            (P5 OPTION IS NOT AVAILABLE)
C
C     NOTES ABOUT P5
C             (1) P5 IS IGNORED IN TABLE DATA
C             (2) POSSIBLY, NON-ZERO ROW ELEMENT MAY START AT 2ND HALF
C                 OF A COMPLEX WORD
C             (3) UP TO 3 ZEROS MAY BE IMBEDDED IN NON-ZERO STRING
C             (4) THE CHOICE OF 2 KEY WORDS IN ONE KEY RECORD OVER 2 KEY
C                 WORDS IN TWO RECORDS (AS IN MSC/NASTRAN), IS NOT TO
C                 MAKE THE ORIGINAL COSMIC OUTPT2/INPTT2 OBSOLETE.
C                 (i.e. WE DON'T FOLLOW OTHER PEOPLE BLINDLY SO TO MAKE
C                 OURSELVES OBSOLETE)
C             (5) ALTHOUGH OUTPT2 ALWAYS WRITES 2 KEY WORDS OUT IN A
C                 RECORD. ONE MAY CHOOSE TO READ BACK ONE OR BOTH KEYS.
C
C     REVISED  11/90 BY G.CHAN/UNISYS TO INCLUDE P4 AND P5 PARAMETERS
C     LAST REVISED  2/93 BY G.CHAN    TO INCLUDE P6 PARAMETER
C
      IMPLICIT INTEGER (A-Z)
      LOGICAL         SPARSE,DP
      CHARACTER*6     MT,MATRIX,TABLE
      DIMENSION       DX(3),TRL(8),NAME(2),SUBNAM(2),INP(3),NAMEX(2),
     1                IDHDR(7),IDHDRX(7),P3X(2),TAPCOD(2)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25
CWKBNB
      CHARACTER*80    DSNAMES
      COMMON /DSNAME/ DSNAMES(80)
CWKBNE
      COMMON /XMSSG / UFM,UWM,UIM,SFM
      COMMON /BLANK / P1,P2,P3(2),P4,P5,P6(2)
     1       /SYSTEM/ BUFFSZ,NOUT,DUM6(6),NLPP,DUM2(2),LINE,DUM(2),D(3)
     2       /ZZZZZZ/ X(1)
     3       /MACHIN/ MACH
      COMMON /UNPAKX/ ITYPE,IROW,NROW,INCR
      DATA    SUBNAM/ 4HOUTP, 4HT2  /, MATRIX,TABLE /'MATRIX',' TABLE'/
      DATA    INP   / 1HT, 1H1, 1H2 /, MSC   / 4HMSC   /
      DATA    ZERO  , MONE,MTWO,MTRE,MNIN    / 0,-1,-2,-3,-9 /
      DATA    IDHDR / 4HNAST,4HRAN ,4HFORT,4H TAP,4HE ID,4H COD,4HE - /
CWKBI
      DATA    IFIRST/0/
C
C     CHECK P2 AND P4 PARAMETERS
C
CWKBI 3/95 SPR94016      
      LCOR   = KORSZ(X) - BUFFSZ           
      IF (P2 .GE. 11 .AND. P2 .LE. 21 ) GO TO 20
      J = 11
      WRITE  (NOUT,10) UWM,P2,J,INP(I)
   10 FORMAT (A25,' FROM OUTPUT2 MODULE. UNACCEPTABLE FORTRAN UNIT',I3,
     1       ' WAS CHANGED TO',I3,' (INP',A1,1H))
      P2 = J
   20 IF (P4) 25,30,35
   25 LREC = -P4*BUFFSZ
      GO TO 40
   30 LREC = LCOR
      IF (MACH  .EQ.   2) LREC = 1024
      IF (P6(1) .EQ. MSC) LREC = 2*BUFFSZ
      GO TO 40
   35 LREC = P4
   40 IF (LREC .GT.   LCOR) LREC = LCOR
      IF (LREC .LT. BUFFSZ) LREC = BUFFSZ
      IF (P4 .NE. 0) WRITE (NOUT,50) UIM,LREC
   50 FORMAT (A29,' 4116, MAXIMUM FORTRAN RECORD SIZE USED IN OUTPUT2 ',
     1        'WAS',I8,' WORDS')
      P4 = LREC
CWKBNB
      IF ( IFIRST .NE. 0 ) GO TO 51
      CLOSE ( UNIT=P2 )
      OPEN ( UNIT=P2, FILE=DSNAMES(P2), FORM='UNFORMATTED',
     1       STATUS='UNKNOWN' )
      IFIRST = 1
51    CONTINUE
CWKBNE
      IF (P6(1) .EQ. MSC) CALL OUTMSC (*1000,*420)
C
      SPARSE = .FALSE.
      IF (P5 .NE. 0) SPARSE = .TRUE.
      ENDFIL = 0
      ENDREC = 0
CWKBD 3/95 SPR94016      LCOR   = KORSZ(X) - BUFFSZ           
      ICRQ   =-LCOR
      IF (LCOR .LE. 0) GO TO 890
      INBUF  = LCOR + 1
      TAPCOD(1) = P3(1)
      TAPCOD(2) = P3(2)
      OUT = P2
      IF (P1 .EQ. MNIN) GO TO 410
      IF (P1.LT.MTRE .OR. P1.EQ.MTWO) GO TO 810
C
      IF (P1 .EQ. MTRE) GO TO 500
      IF (P1 .LE. ZERO) GO TO 80
C
      I = 1
   60 READ (OUT) KEY
      KEYX = 2
      IF (KEY .NE. KEYX) GO TO 900
      READ (OUT) NAMEX
      READ (OUT) KEY
      IF (KEY .GE. 0) GO TO 920
      ASSIGN 70 TO RET
      NSKIP = 1
      GO TO 700
   70 I = I + 1
      IF (I .LE. P1) GO TO 60
C
   80 IF (P1 .NE. MONE) GO TO 90
C
C     REWIND OUTPUT TAPE. (P1 = -1)
C
      REWIND OUT
      KEY = 3
      WRITE (OUT) KEY,ZERO
      WRITE (OUT) D
      KEY = 7
      WRITE (OUT) KEY,ZERO
      WRITE (OUT) IDHDR
      KEY = 2
      WRITE (OUT) KEY,ZERO
      WRITE (OUT) P3
      ENDREC = ENDREC - 1
      WRITE (OUT) ENDREC,ZERO
      WRITE (OUT) ENDFIL,ZERO
      ENDREC = 0
C
   90 DO 400 I = 1,5
      INPUT  = 100 + I
      TRL(1) = INPUT
      CALL RDTRL (TRL)
      IF (TRL(1) .LE. 0) GO TO 400
      CALL FNAME (INPUT,NAME)
C
C     OPEN INPUT DATA BLOCK TO READ WITH REWIND.
C
      CALL OPEN (*800,INPUT,X(INBUF),0)
      CALL SKPREC (INPUT,1)
      TRL(8) = 1
      CALL RECTYP (INPUT,IREC1)
      IF (IREC1 .NE. 0) GO TO 100
      TRL(8) = 0
      CALL READ (*100,*100,INPUT,X(1),1,1,NF)
      CALL RECTYP (INPUT,IREC2)
      IF (IREC2 .EQ. 0) GO TO 100
      TRL(8) = 2
  100 CALL REWIND (INPUT)
      KEY = 2
      WRITE (OUT) KEY,ZERO
      WRITE (OUT) NAME
      ENDREC = ENDREC - 1
      WRITE (OUT) ENDREC,ZERO
      KEY = 8
      WRITE (OUT) KEY,ZERO
      WRITE (OUT) TRL
      ENDREC = ENDREC - 1
      WRITE (OUT) ENDREC,ZERO
      INDEX = 0
C
C     COPY CONTENTS OF INPUT DATA BLOCK ONTO FILE.
C     (OR THE HEADER RECORD OF A MATRIX DATA BLOCK)
C
C     COMMENTS FROM G.CHAN/UNISYS  2/93
C     THE WRITES IN LOOP 110 AND 120 SEEM DATA TYPE (S.P. OR D.P.)
C     INCENSITIVE. THE D.P. DATA IN KELM, MELM AND BELM TABLES SHOULD
C     WORK OK.
C
  110 CALL READ (*310,*120,INPUT,X(1),LREC,0,NF)
      WRITE (OUT) LREC,ZERO
      WRITE (OUT) (X(L),L=1,LREC)
      GO TO 110
C
  120 WRITE (OUT) NF,ZERO
      WRITE (OUT) (X(L),L=1,NF)
      ENDREC = ENDREC - 1
      WRITE (OUT) ENDREC,ZERO
      IF (TRL(8) .EQ. 0) GO TO 110
      IF (TRL(8) .EQ. 1) GO TO 130
      IF (INDEX  .GT. 0) GO TO 130
      INDEX = 1
      GO TO 110
C
C     COPY STRING FORMATTED MATRIX
C
  130 IF (TRL(8).EQ.2 .AND. INDEX.EQ.2) GO TO 140
      INDEX = 2
      NWDS  = TRL(5)
      DP    = .FALSE.
      IF (NWDS.EQ.2 .OR. NWDS.EQ. 4) DP = .TRUE.
      DSP   = 1
      IF (DP) DSP = 2
      IF (NWDS .EQ. 3) NWDS = 2
C         NWDS=1,SP  -  =2,DP,CS  -  =4,CDP
C
      INCR = 1
      NWDS = TRL(3)*NWDS
C
C     CHECK FOR NULL MATRIX
C
      IF (TRL(2).EQ.0 .OR. TRL(3).EQ.0) GO TO 310
C
C     NWDS HAS NUMBER WORDS NEEDED PER COLUMN
C
      ICRQ = NWDS - LCOR
      IF (NWDS .GT. LCOR) GO TO 890
      ITYPE = TRL(5)
      IROW  = 1
      NROW  = TRL(3)
      NCOL  = TRL(2)
      IF (TRL(8) .EQ. 2) NCOL = 1
  140 DO 300 L = 1,NCOL
      CALL UNPACK (*180,INPUT,X)
      IF (SPARSE) GO TO 200
  150 DO 160 KB = 1,NWDS,LREC
      KE = KB + LREC - 1
      IF (KE .GT. NWDS) KE = NWDS
      KBE = KE - KB + 1
      WRITE (OUT) KBE,ZERO
      WRITE (OUT) (X(K),K=KB,KE)
  160 CONTINUE
C
  170 ENDREC = ENDREC - 1
      WRITE (OUT) ENDREC,ZERO
      GO TO 300
  180 IF (SPARSE) GO TO 170
      DO 190 K = 1,NWDS
      X(K) = 0
  190 CONTINUE
      GO TO 150
C
C     SPARSE MASTRIX OUT
C
  200 J12 = -1
      DO 260 J = 1,NWDS,DSP
      IF (J12  .GE.  +1) GO TO 220
      IF (X(J) .NE. 0.0) GO TO 210
      IF (DP) IF (X(J+1)) 210,260,210
      GO TO 260
  210 J12 = +1
      K2  = J - 1
      GO TO 260
  220 IF (X(J) .NE. 0.0) GO TO 260
      IF (DP) IF (X(J+1)) 260,230,260
  230 IF (J12 .EQ. -1) CALL MESAGE (-37,0,SUBNAM)
      J12 = J12 + 1
C
C     ALLOW UP TO 3 IMBEDDED ZEROS
C
      IF (J12 .LE. 3) GO TO 260
      IF (X(J-1).NE.0.0 .OR. X(J-2).NE. 0.0) GO TO 260
      J12 = -1
      K1  = J - K2
      IF (K1 .GT. LREC) GO TO 240
      WRITE (OUT) K1,K2
      WRITE (OUT) (X(K2+K),K=1,K1)
      GO TO 260
  240 KE = J
      KB = K2 + 1
      DO 250 KK = KB,KE,LREC
      K2 = KK - 1
      K1 = K2 + LREC
      IF (K1 .GT. KE) K1 = KE
      WRITE (OUT) K1,K2
      WRITE (OUT) (X(K2+K),K=1,K1)
  250 CONTINUE
  260 CONTINUE
C
      IF (J12 .EQ. -1) GO TO 290
      J12 = -1
      K1  = NWDS - K2
      IF (K1 .GE. LREC) GO TO 270
      WRITE (OUT) K1,K2
      WRITE (OUT) (X(K2+K),K=1,K1)
      GO TO 290
  270 KE = NWDS
      KB = K2 + 1
      DO 280 KK = KB,KE,LREC
      K2 = KK - 1
      K1 = K2 + LREC
      IF (K1 .GT. KE) K1 = KE
      WRITE (OUT) K1,K2
      WRITE (OUT) (X(K2+K),K=1,K1)
  280 CONTINUE
C
  290 ENDREC = ENDREC - 1
      WRITE (OUT) ENDREC,ZERO
C
  300 CONTINUE
C
      IF (TRL(8) .EQ. 2) GO TO 110
C
C     CLOSE INPUT DATA BLOCK WITH REWIND
C
  310 CALL CLOSE (INPUT,1)
C
      WRITE (OUT) ENDFIL,ZERO
      ENDREC = 0
      CALL PAGE2 (-4)
      MT = MATRIX
      IF (TRL(8) .EQ. 0) MT = TABLE
      WRITE  (NOUT,320) UIM,MT,NAME,OUT,(TRL(II),II=2,7)
  320 FORMAT (A29,' 4114, ',A6,' DATA BLOCK ',2A4,
     1       ' WRITTEN ON FORTRAN UNIT',I4, /5X,'TRAILR =',5I6,I9)
      IF (SPARSE .AND. TRL(8).NE.0) WRITE (NOUT,330)
  330 FORMAT (1H+,55X,'(SPARSE MATRIX)')
C
  400 CONTINUE
      GO TO 1000
C
C     FINAL CALL TO OUTPUT2. (P1 = -9)
C
  410 WRITE (OUT) ENDFIL,ZERO
  420 ENDREC = 0
      ENDFILE OUT
      REWIND OUT
      WRITE  (NOUT,430) UIM
  430 FORMAT (A29,'. OUTPUT2 MODULE WROTE AN E-O-F RECORD, A SYSTEM ',
     1       'E-O-F MARK, AND REWOUND THE OUTPUT TAPE. (P1=-9)')
      GO TO 1000
C
C     OBTAIN LIST OF DATA BLOCKS ON FORTRAN TAPE.  (P1 = -3)
C
  500 REWIND OUT
      READ (OUT) KEY
      KEYX = 3
      IF (KEY .NE. KEYX) GO TO 900
      READ (OUT) DX
      READ (OUT) KEY
      KEYX = 7
      IF (KEY .NE. KEYX) GO TO 900
      READ (OUT) IDHDRX
      DO 510 KF = 1,7
      IF (IDHDRX(KF) .NE. IDHDR(KF)) GO TO 830
  510 CONTINUE
      READ (OUT) KEY
      KEYX = 2
      IF (KEY .NE. KEYX) GO TO 900
      READ (OUT) P3X
      IF (P3X(1).NE.P3(1) .OR. P3X(2).NE.P3(2)) GO TO 850
  520 ASSIGN 530 TO RET
      NSKIP = 1
      GO TO 700
  530 KF = 0
  540 CALL PAGE1
      LINE = LINE + 8
      WRITE  (NOUT,550) OUT
  550 FORMAT (1H0, 50X, 30HFILE CONTENTS ON FORTRAN UNIT , I2,
     1            /51X, 32(1H-), ///54X, 4HFILE, 18X, 4HNAME/1H0)
  560 READ (OUT) KEY
      IF (KEY) 870,600,570
  570 READ (OUT) NAMEX
      ASSIGN 580 TO RET
      NSKIP = 1
      GO TO 700
  580 KF   = KF + 1
      LINE = LINE + 1
      WRITE  (NOUT,590) KF,NAMEX
  590 FORMAT (53X,I5,18X,2A4)
      IF (LINE-NLPP) 560,540,540
  600 ASSIGN 90 TO RET
      NSKIP = -(KF+1)
      GO TO 700
C
C     SIMULATION OF SKPFIL (OUT,NSKIP)
C
  700 IF (NSKIP) 720,710,730
  710 GO TO RET, (70,90,530,580)
  720 REWIND OUT
C
C     NSKIP IS THE NEGATIVE OF THE NUMBER OF FILES TO BE SKIPPED
C
      NSKIP = -NSKIP
  730 DO 770 NS = 1,NSKIP
  740 READ (OUT) KEY
      IF (KEY) 740,760,750
  750 CONTINUE
C     ICRQ = KEY - LCOR
C     IF (KEY .GT. LCOR) GO TO 9917
      READ (OUT) L
      GO TO 740
  760 CONTINUE
  770 CONTINUE
      GO TO 710
C
C
C     ERRORS
C
  800 MM = -1
      GO TO 950
C
  810 WRITE  (NOUT,820) UFM,P1
  820 FORMAT (A23,' 4120, MODULE OUTPUT2 - ILLEGAL VALUE FOR FIRST ',
     1       'PARAMETER =',I20)
      LINE = LINE + 2
      GO TO 940
  830 WRITE  (NOUT,840) UFM,(IDHDRX(KF),KF=1,7)
  840 FORMAT (A23,' 4130, MODULE OUTPUT2 - ILLEGAL TAPE CODE HEADER = ',
     1        7A4)
      LINE = LINE + 2
      GO TO 940
  850 WRITE  (NOUT,860) UWM,P3X,P3
  860 FORMAT (A25,' 4131, FORTRAN TAPE ID CODE -',2A4,'- DOES NOT MATCH'
     1,       ' THIRD OUTPUT2 DMAP PARAMETER -',2A4,2H-.)
      LINE = LINE + 2
      GO TO 520
  870 WRITE  (NOUT,880) SFM
  880 FORMAT (A25,' 4115, MODULE OUTPUT2 - SHORT RECORD.')
      LINE = LINE + 2
      GO TO 940
  890 MM = -8
      INPUT = ICRQ
      GO TO 950
  900 WRITE  (NOUT,930) SFM,KEY
      WRITE  (NOUT,910) KEYX
  910 FORMAT (10X,17HEXPECTED VALUE = ,I10,1H.)
      LINE = LINE + 3
      GO TO 940
  920 WRITE  (NOUT,930) SFM,KEY
  930 FORMAT (A25,' 2190, ILLEGAL VALUE FOR KEY =',I10,1H.)
      LINE = LINE + 2
      GO TO 940
C
  940 MM = -37
  950 CALL MESAGE (MM,INPUT,SUBNAM)
C
 1000 RETURN
      END

      SUBROUTINE SDR1B (IPVECT,IM1,IM2,IOUT,MAJOR,SUB1,SUB2,IUSET,
     1                  IOPT,IOUT1)
C
      INTEGER NAME(2),CORE(7),SYSBUF,IPV1(7)
      COMMON /SYSTEM/ SYSBUF
      COMMON /ZZZZZZ/ KORE(1)
      COMMON /PATX  / NZ,NSUB1,NSUB2,NSUB3,IUSET1
      COMMON /PARMEG/ IA(7),IA11(7),IA12(7),IB11(7),IB12(7),NZ1,IRULE
      COMMON /UNPAKX/ ITU1,IIU1,JJU1,INCR1
      COMMON /PACKX / ITP1,ITP2,IIP1,JJP1,INCR
      EQUIVALENCE     (CORE(1),KORE(1))
      DATA    NAME  / 4HSDR1,4HB   /
C
C
      NZ  = KORSZ(CORE)
      NZ1 = NZ
      IUSET1 = IUSET
      DO 10 I = 2,7
      IA11(I) = 0
      IA12(I) = 0
      IA(I)   = 0
   10 CONTINUE
      IA11(1) = IM1
      IF (IM1 .EQ. 0) GO TO 20
      CALL RDTRL (IA11)
   20 IA12(1) = IM2
      CALL RDTRL (IA12)
      IF (IA11(1).LT.0 .AND. IA12(1).LT.0) RETURN
      CALL CALCV (IPVECT,MAJOR,SUB1,SUB2,CORE)
      IF (IOPT .NE. 0) GO TO 60
      IF (IA12(1) .LE. 0) IA12(1) = 0
   30 IB11(1) = 0
      IB12(1) = 0
      IA(3) = NSUB1 + NSUB2 + NSUB3
      IA(2) = MAX0(IA11(2),IA12(2))
      IA(4) = 2
      IF (IM2 .EQ. 0) IA12(5) = IA11(5)
      IPREC = MIN0(1-MOD(IA11(5),2),1-MOD(IA12(5),2))
      ITYPE = 1
      IF (IA11(5).GT.2 .OR. IA12(5).GT.2) ITYPE = 3
      IA(5) = IPREC + ITYPE
   40 IRULE = 0
      IA(1) = IOUT
      IPV1(1) = IPVECT
      CALL RDTRL (IPV1)
      CORE(1) = 0
      CORE(2) = 1
      CORE(3) = IA(2)
      CORE(4) = 2
      CORE(5) = 1
      CORE(6) = 0
      CORE(7) = 0
      CALL MERGE (CORE,IPV1,CORE)
      CALL WRTTRL (IA)
      RETURN
C
C     EXPAND YS
C
   60 NZ = NZ - SYSBUF
      CALL OPEN (*130,IM2,CORE(NZ+1),0)
      NZ = NZ - SYSBUF
      CALL OPEN (*150,IOUT1,CORE(NZ+1),1)
      CALL FNAME (IM2,CORE)
      CALL WRITE (IOUT1,CORE,2,1)
      IA(1) = IM2
      CALL RDTRL (IA)
      NOYS  = IA(2)
      IA(2) = 0
      IA(1) = IOUT1
      IA(6) = 0
      IA(7) = 0
      CALL FWDREC (*130,IM2)
      NLOAD = IA11(2)
      ITU1  = IA(5)
      INCR  = 1
      ITP1  = ITU1
      ITP2  = ITP1
      INCR1 = 1
      DO 100 I = 1,NLOAD
      IF (I .GT. NOYS) GO TO 81
      IIU1 = 0
      CALL UNPACK (*80,IM2,CORE)
      IIP1 = IIU1
      JJP1 = JJU1
   81 CALL PACK( CORE,IOUT1,IA)
      GO TO 100
   80 CORE(1) = 0
      CORE(2) = 0
      CORE(3) = 0
      CORE(4) = 0
      IIP1 = 1
      JJP1 = 1
      GO TO 81
  100 CONTINUE
      CALL CLOSE (IOUT1,1)
      CALL CLOSE (IM2,1)
      CALL WRTTRL (IA)
      IA12(1) = IOUT1
      CALL RDTRL (IA12)
      GO TO 30
C
C
      ENTRY SDR1C (IPVECT,IM1,IOUT)
C     =============================
C
C     EXPAND ROWS OF IM1 TO D SET SIZE
C
      DO 120 I = 1,7
      IA12(I) = 0
      IB11(I) = 0
      IB12(I) = 0
  120 CONTINUE
      IA11(1) = IM1
      CALL RDTRL (IA11)
      IA(1) = IM1
      CALL RDTRL (IA)
      IA(3) = NSUB1 + NSUB2 + NSUB3
      GO TO 40
C
C     ERROR MESAGES
C
  130 IP1 = -1
      IP2 = IM2
  140 CALL MESAGE (IP1,IP2,NAME)
  150 IP1 = -1
      IP2 = IOUT1
      GO TO 140
      END

      SUBROUTINE MTRXI (FILE,NAME,ITEM,DUMBUF,ITEST)
C
C     COPIES MATRIX ITEM OF SUBSTRUCTURE NAME FROM THE SOF TO THE
C     NASTRAN FILE
C     ITEST VALUES RETURNED ARE
C        1 - NORMAL RETURN
C        2 - ITEM PSEUDO-EXISTS ONLY ON THE SOF
C        3 - ITEM DOES NOT EXIST ON THE SOF
C        4 - NAME DOES NOT EXIT
C        5 - ITEM IS NOT ONE OF THE ALLOWABLE MATRIX ITEMS
C        6 - THE NASTRAN FILE HAS BEEN PURGED
C
      EXTERNAL        RSHIFT, ANDF
      INTEGER         RSHIFT, ANDF, TRAIL(7), FILE, BUF(1), EOF,
     1                NMSBR(2), NAME(2), OLDBUF, BLKSIZ
      COMMON /MACHIN/ MACH, IHALF, JHALF
      COMMON /SOF   / DITDUM(6), IO, IOPBN, IOLBN, IOMODE
      COMMON /SYS   / BLKSIZ
      COMMON /ZZZZZZ/ NSTRN
      EQUIVALENCE     (BUF(1), NSTRN)
      DATA    NMSBR / 4HMTRX,4HI   /
      DATA    IRD   / 1 /,   IDLE  / 0 /,  IFETCH / -1 /
C
C     CHECK IF ITEM IS ONE OF THE FOLLOWING ALLOWABLE NAMES.
C     KMTX, MMTX, PVEC, POVE, UPRT, HORG, UVEC, QVEC, PAPP, POAP, LMTX
C
      CALL CHKOPN (NMSBR(1))
      ITM = ITTYPE(ITEM)
      IF (ITM .NE. 1) GO TO 1030
C
C     MAKE SURE BUFFER IS DOUBLE WORD ALIGNED, OPEN NASTRAN FILE, AND
C     ADUST SOF BUFFER TO COINCIDE WITH GINO
C     ALSO DETERMINE PLACEMENT OF MATRIX NAME IN FIRST BUFFER
C
      IDISP = LOCFX(BUF(IO-2)) - LOCFX(NSTRN)
      IF (ANDF(IDISP,1) .NE. 0) IO = IO + 1
      IOPT = 1
      CALL OPEN (*1000,FILE,BUF(IO-2),IOPT)
      OLDBUF = IO
C
      IN = 4
      IF (MACH .GT. 2) GO TO 40
      IN = 7
CIBMD 6/93 IF (BUF(IO-2) .EQ. FILE) GO TO 40
CIBMD 6/93 IO = IO + 1
CIBMD 6/93 IF (BUF(IO-2) .NE. FILE) GO TO 1010
C
C     OPEN ITEM TO READ AND FETCH FIRST BLOCK FROM SOF
C
   40 CONTINUE
      CALL SFETCH (NAME(1),ITEM,IFETCH,ITEST)
      IF (ITEST .NE. 1) GO TO 1050
C
C     INSERT CORRECT MATRIX NAME INTO BUFFER
C
      CALL FNAME (FILE,BUF(IO+IN))
C
C     WRITE BLOCK ON NASTRAN FILE
C
      ASSIGN 50 TO IJUMP
      EOF = 0
   50 IF (BUF(IO+1) .LE. 0) GO TO 90
      CALL WRTBLK (FILE,EOF)
C
C     READ NEXT SOF BLOCK
C
   60 CALL FNXT (IOPBN,INXT)
      IF (MOD(IOPBN,2) .EQ. 1) GO TO 70
      NEXT = ANDF(RSHIFT(BUF(INXT),IHALF),JHALF)
      GO TO 80
   70 NEXT = ANDF(BUF(INXT),JHALF)
   80 IF (NEXT .EQ. 0) GO TO 1020
      IOPBN = NEXT
      IOLBN = IOLBN + 1
      CALL SOFIO (IRD,IOPBN,BUF(IO-2))
      GO TO IJUMP, (50,100)
C
C     LAST DATA BLOCK HAS BEEN READ FROM SOF
C
   90 ITRAIL = BUF(IO+1)
      BUF(IO+1) = IOLBN
      IF (ITRAIL .GE. 0) GO TO 97
      TRAIL(1) = FILE
      DO 95 I = 2,7
      TRAIL(I) = BUF(IO+BLKSIZ-7+I)
   95 CONTINUE
      CALL WRTTRL (TRAIL)
   97 EOF = 1
      CALL WRTBLK (FILE,EOF)
      CALL CLOSE (FILE,1)
      IF (ITRAIL .NE. 0) GO TO 120
C
C     TRAILER IS STORED ON NEXT SOF BLOCK - READ IT
C
      ASSIGN 100 TO IJUMP
      GO TO 60
C
C     WRITE TRAILER OF NASTRAN DATA BLOCK
C
  100 TRAIL(1) = FILE
      DO 110 I = 2,7
  110 TRAIL(I) = BUF(IO+BLKSIZ-7+I)
      CALL WRTTRL (TRAIL)
  120 ITEST = 1
      IO = OLDBUF
      RETURN
C
C     ERROR RETURNS
C
C
C     NASTRAN FILE PURGED
C
 1000 ITEST = 6
      IOMODE = IDLE
      RETURN
C
C     BUFFER ALIGNMENT ERROR
C
CIBMD 6/93 1010 CALL SOFCLS
CIBMD 6/93 CALL MESAGE (-8,0,NMSBR)
C
C     SOF CHAINING ERROR
C
 1020 CALL ERRMKN (19,9)
      RETURN
C
C     INVALID ITEM NAME
C
 1030 ITEST = 5
      RETURN
C
C     ERROR IN SFETCH CALL
C
 1050 CALL CLOSE (FILE,1)
      IO = OLDBUF
      RETURN
C
      END

      SUBROUTINE SEMINT (DEBUG1)
C
C     SEMINT IS THE EXECUTION MONITOR FOR THE PREFACE.
C     UMF IS NO LONGER SUPPORTED.
C
C     FOR DEBUG PURPOSE, PRINT OUT GOES TO UNIT 6, NOT OUTTAP
C
      INTEGER         AXIC,AXIF,OUTTAP,PLOTF,HICORE,DEBUG1
      CHARACTER       UFM*23,UWM*25,UIM*29,SUBR(13)*6
      COMMON /XMSSG / UFM,UWM,UIM
      COMMON /IFPX1 / NCDS,T1(2,370)
      COMMON /MACHIN/ MACH,DUMMY4(4)
      COMMON /SYSTEM/ SYSTEM,OUTTAP,NOGO,INTAP,DUMM15(15),PLOTF,
     1                DUMM6(6),AXIC,DUMMY3(3),HICORE,DUMMY6(6),
     2                AXIF,DUMM30(30),ISUBS,ISY70(7),ISY77
      COMMON /XECHOX/ ECHO(4)
      COMMON /XXREAD/ INFLAG,INSAVE
      DATA     BCD1 , BCD2,  BCD3,  BCD4  ,BCD5  ,BCD6,  BCD7   /
     1         4HXCSA,4HIFP1,4HXSOR,4HXGPI,4HGNFI,4HTTIO,4HTTLP /
      DATA     BCD8 , BCD9,  BCD10 ,BCD11                       /
     1         4HTTOT,4HSOLI,4HFLUI,1HD                         /
      DATA     SUBR / 'NASCAR','GNFIAT','TMTSIO','TMTSLP','XCSA  ',
     1                'TMTSOT','ASDMAP','IFP1  ','XSORT2','IFP   ',
     2                'IFP3  ','XGPI  ','BANDIT'/
C
C
      INSAVE = INTAP
C
C     READ AND PROCESS THE NASTRAN CARD (IF PRESENT).
C
!hgs disable nascar
      iby = 0
      if(iby .eq. 0) then
      IF (DEBUG1 .GT. 0) WRITE (6,10) SUBR(1)
   10 FORMAT (/,' -LINK1 DEBUG- SEMINT CALLING ',A6,' NEXT',/)
      CALL NASCAR
      endif
C
C     DEFINE OPEN CORE FOR UNIVAC, VAX, AND UNIX
C
      IF (MACH.EQ.3 .OR. MACH.GE.5) CALL DEFCOR
C
C     GENERATE INITIAL FILE TABLES.
C     COMPUTE NASTRAN TIMING CONSTANTS.
C     READ EXECUTIVE CONTROL DECK AND SAVE NOGO FLAG.
C     READ CASE CONTROL DECK, SORT BULK DATA AND EXECUTE
C     INPUT FILE PROCESSOR UNLESS BULK DATA IS MISSING.
C     IF CONICAL SHELL PROBLEM, EXECUTE IFP3.
C
      CALL CONMSG (BCD5,1,1)
      IF (DEBUG1 .GT. 0) WRITE (6,10) SUBR(2)
      CALL GNFIAT
C
C     CALL THE TIME TEST ROUTINES TO COMPUTE THE NASTRAN
C     TIMING CONSTANTS AND INITIALIZE COMMON /NTIME/
C
C     GENERATE THE I/O TIMES AND
C     CPU TIMES FOR VARIOUS TYPES OF LOOPS
C
      CALL CONMSG (BCD6,1,0)
      IF (DEBUG1 .GT. 0) WRITE (6,10) SUBR(3)
      CALL TMTSIO (*2000,DEBUG1)
      CALL CONMSG (BCD7,1,0)
      IF (DEBUG1 .GT. 0) WRITE (6,10) SUBR(4)
      CALL TMTSLP
C
C     PROCESS EXECUTIVE CONTROL CARDS
C
 2000 CALL CONMSG (BCD1,1,1)
      IF (DEBUG1 .GT. 0) WRITE (6,10) SUBR(5)
      CALL XCSA
C
C     OUTPUT THE COMMON /NTIME/ ENTRIES IF DIAG 35 IS TURNED ON
C
      CALL SSWTCH (35,L35)
      IF (L35 .EQ. 0) GO TO 3000
      CALL CONMSG (BCD8,1,0)
      IF (DEBUG1 .GT. 0) WRITE (6,10) SUBR(6)
      CALL TMTSOT
C
C     PROCESS SUBSTRUCTURING DMAP
C
 3000 NOGOX = NOGO
      NOGO  = 0
      IF (DEBUG1.GT.0 .AND. ISUBS.NE.0) WRITE (6,10) SUBR(7)
      IF (ISUBS .NE. 0) CALL ASDMAP
C
C     PROCESS CASE CONTROL CARDS
C
      CALL CONMSG (BCD2,1,1)
      IF (DEBUG1 .GT. 0) WRITE (6,10) SUBR(8)
      CALL IFP1
      NOGO1 = NOGO
      IF (NOGO .EQ. -9) NOGO = 1
      IF (NOGO .LT.  0) NOGO = 0
      KAXIF = 0
C
C     REVERT TO OLD XSORT TO PROCESS BULKDATA CARDS IF DIAG 42 IS
C     TURNED ON,  OTHERWISE, USE XSORT2 FOR SPEED AND EFFICIENCY
C
      CALL CONMSG (BCD3,1,0)
      CALL SSWTCH (42,L42)
      IF (DEBUG1 .GT. 0) WRITE (6,10) SUBR(9)
      IF (L42  .EQ.  1) CALL XSORT
      IF (L42  .EQ.  0) CALL XSORT2
      IF (NOGO .EQ. -2) GO TO 4000
C
C     INPUT FILE PROCESSOR(S) TO CHECK EACH BULKDATA CARD
C
      IF (DEBUG1 .GT. 0) WRITE (6,10) SUBR(10)
      CALL IFP
      IF (DEBUG1.GT.0 .AND. AXIC.NE.0) WRITE (6,10) SUBR(11)
      IF (AXIC .NE. 0) CALL IFP3
C
C     SET KAXIF AS IFP4 WILL MODIFY AXIF
C
      KAXIF = AXIF
      IF (KAXIF.EQ.1 .OR. KAXIF.EQ.3) CALL IFP4
      IF (KAXIF.EQ.2 .OR. KAXIF.EQ.3) CALL IFP5
C
C     SUPPRESS NOGO FLAG IF USER REQUESTS UNDEFORMED STRUCTURE PLOT VIA
C     NASTRAN PLOTOPT CARD
C
 4000 IF (NOGO .EQ. -2) NOGO = 0
      IF (NOGO.EQ.0 .AND. NOGO1.LT.0) NOGO = NOGO1
      IF (NOGO.GE.1 .AND. NOGO1.LT.0) NOGO = -9
      IF (NOGO1 .EQ. 0) NOGO1 = NOGO
C
C     NOGO FLAG CONDITIONS
C     NOGOX.NE. 0, FATAL ERROR IN EXECUTIVE CONTROL
C     NOGO .EQ.-9, FATAL ERROR IN BULKDATA AND IN PLOT COMMANDS
C     NOGO .EQ. 0, NO FATAL ERROR DETECTED IN ENTIRE INPOUT DECK
C     NOGO .GT. 0, FATAL ERROR IN BULKDATA, NO ERROR IN PLOT COMMANDS
C     NOGO .LT. 0, NO ERROR IN BULKDATA, FATAL ERROR IN PLOT COMMANDS
C
      IF (NOGOX .NE. 0) GO TO 5500
      IF (NOGO) 4100,4300,4200
 4100 IF (NOGO.EQ.-9 .AND. PLOTF.NE.3) GO TO 5500
      IF (PLOTF .LE. 1) GO TO 4200
      NOGO = 0
      GO TO 4300
 4200 NOGO = 1
C
C     EXECUTE GENERAL PROBLEM INITIALIZATION IF DATA PERMITS.
C
 4300 IF (NOGO .NE. 0) CALL MESAGE (-61,0,0)
      CALL CONMSG (BCD4,1,0)
      IF (DEBUG1 .GT. 0) WRITE (6,10) SUBR(12)
      CALL XGPI
C
C     CALL BANDIT TO GENERATE GRID-POINT RE-SEQUENCE CARDS IF DATA
C     PERMITS
C
      IF (NOGO.NE.0 .AND. NOGO1.LT.0) NOGO = -9
      IF (NOGO.EQ.0 .AND. NOGO1.NE.0) NOGO = NOGO1
      IF (ISY77.LT.0 .OR. NOGO .NE.0) GO TO 5100
      IF (AXIC.NE.0  .OR. KAXIF.EQ.1 .OR. KAXIF.EQ.3) GO TO 5000
      IF (DEBUG1 .GT.  0) WRITE (6,10) SUBR(13)
      CALL BANDIT
      GO TO 5100
 5000 WRITE (OUTTAP,6100) UIM
      BCDX = BCD10
      IF (AXIC .NE. 0) BCDX = BCD9
      WRITE (OUTTAP,6200) BCDX,BCD11
      WRITE (OUTTAP,6300)
C
C     TERMINATE NASTRAN IF LINK 1 ONLY IS REQUESTED BY USER
C
 5100 IF (ISY77 .EQ. -2) CALL PEXIT
C
C     EXIT ACCORDING TO PLOT OPTION REQUEST
C     SET PLOTF TO NEGATIVE ONLY IF JOB IS TO BE TERMINATED AFTER PLOTS
C     IN LINK2
C
      J = PLOTF + 1
      IF (NOGO .EQ. 0) GO TO (5800,5800,5700,5700,5800,5800), J
      IF (NOGO .GT. 0) GO TO (5300,5300,5600,5600,5600,5600), J
      IF (NOGO .LT. 0) GO TO (5500,5500,5500,5600,5600,5200), J
C                      PLOTF =   0,   1,   2,   3,   4,   5
C
 5200 IF (NOGO+9) 5800,5500,5800
 5300 IF (PLOTF .GT. 1) WRITE (OUTTAP,5400)
 5400 FORMAT ('0*** ATTEMPT TO PLOT UNDEFORMED MODEL IS ABANDONED DUE',
     1        ' TO FATAL ERROR IN BULK DATA')
 5500 CALL MESAGE (-61,0,0)
 5600 WRITE  (OUTTAP,5650) UWM
 5650 FORMAT (A25,' - FATAL ERRORS ENCOUNTERED IN USER INPUT DECK,',
     1       /5X,'HOWEVER, NASTRAN WILL ATTEMPT TO PLOT THE UNDEFORMED',
     2       ' STRUCTURE AS REQUESTED BY USER')
 5700 PLOTF = -PLOTF
 5800 RETURN
C
 6100 FORMAT (A29,' - GRID-POINT RESEQUENCING PROCESSOR BANDIT IS NOT',
     1       ' USED DUE TO')
 6200 FORMAT (5X,'THE PRESENCE OF AXISYMMETRIC ',A4,A1,' DATA')
 6300 FORMAT (1H0,10X,'**NO ERRORS FOUND - EXECUTE NASTRAN PROGRAM**')
C
      END

      SUBROUTINE INVTR (*,X,DX)
C
C     INVTR WILL INVERT A LOWER OR UPPER TRIANGULAR MATRIX
C
C
C     FILEA    =  MATRIX CONTROL BLOCK FOR THE INPUT FILE A
C     FILEB    =  MATRIX CONTROL BLOCK FOR THE OUTPUT MATRIX B
C     SCRFIL   =  SCRATCH FILE (NEEDED ONLY FOR AN UPPER TRIANGLE)
C     NX       =  NUMBER OF CELLS OF CORE AVAILABLE AT X
C     PREC     =  DESIRED PRECISION OF ARITHMETIC OPERATIONS
C     X        =  BLOCK OF AVAILABLE CORE
C     DX       =  SAME BLOCK AS X, BUT TYPED DOUBLE PRECISION
C
      INTEGER         RD,RDREW,WRT,WRTREW,REW,NOREW,EOFNRW,RC,TRA2,
     1                CORE,EOL,OUTBUF,TYPEA,TYPEB,PREC,TYPEAR,
     2                FORMA,SYSBUF,BAKSKP,FORSKP,CMPLX,TRA,TRA1,SCRFIL,
     3                FILEA,FILEB,T
      DOUBLE PRECISION DX(1),DA(2),DTEMP
      DIMENSION       X(1),NAME(2),T(7)
      COMMON /TYPE  / PRC(2),NWDS(4),RC(10)
      COMMON /SYSTEM/ SYSBUF
C     COMMON /DESCRP/ LENGTH,MAJOR(1)
      COMMON /ZNTPKX/ A(4),II,EOL
      COMMON /INVTRX/ FILEA(7),FILEB(7),SCRFIL,NX,PREC
      COMMON /NAMES / RD,RDREW,WRT,WRTREW,REW,NOREW,EOFNRW
      COMMON /PACKX / IT1,IT2,IY,JY ,INCRY
      COMMON /UNPAKX/ ITX1,IX,JX ,INCRX
      EQUIVALENCE     (A(1),DA(1)),(FILEA(3),NROW),(FILEA(4),FORMA),
     1                (FILEA(5),TYPEA),(FILEB(5),TYPEB)
      DATA    NAME  / 4HINVT,4HR     /, T /7*0/
C
C     INITIALIZE
C
      TYPEAR = RC(TYPEA)
      TYPEAR = RC(TYPEAR) + PREC - 1
      INCR   = NWDS(TYPEAR)
      IT1    = TYPEAR
      IT2    = TYPEB
      ITX1   = TYPEAR
      INCRX  = 1
      INCRY  = 1
      FILEB(2) = 0
      FILEB(6) = 0
      FILEB(7) = 0
      IOBUF = NX - SYSBUF
      CMPLX = RC(TYPEAR)
      CORE  = IOBUF - 1
      CALL GOPEN (FILEB,X(IOBUF),1)
      CALL CLOSE (FILEB,NOREW)
      IF (FORMA .EQ. 5) GO TO 500
      IF (FORMA .NE. 4) GO TO 1000
C
C     INVERT A LOWER TRIANGULAR MATRIX
C
      BAKSKP = NROW
      FORSKP = 1
      GO TO (1,2,3,4), TYPEAR
    1 ASSIGN 50  TO TRA
      ASSIGN 110 TO TRA1
      GO TO  5
    2 ASSIGN 60  TO TRA
      ASSIGN 120 TO TRA1
      GO TO  5
    3 ASSIGN 70  TO TRA
      ASSIGN 130 TO TRA1
      GO TO  5
    4 ASSIGN 80  TO TRA
      ASSIGN 140 TO TRA1
    5 CONTINUE
C
C     ALLOCATE CORE STORAGE
C
      CALL GOPEN (FILEA,X(IOBUF),0)
      J = 1
C
C     SOLVE QUADRATIC FOR K
C
   10 M  = NROW - J + 1
      L  = 2*M + 1
      K  = M
      IF (L*L .LE. 8/INCR*CORE) GO TO 20
      A1 = L*L - 8/INCR*CORE
      K  = SQRT(A1)
      K  = K + 1
      K  = (L-K)/2
      IF (K .LE. 0) GO TO 1040
C
C     GENERATE COLUMNS J THROUGH J+K OF THE IDENTITY MATRIX (STORE
C     ONLY THE LOWER TRIANGLE IN CORE)
C
   20 L = (M*K-(K*(K-1))/2)*INCR
      DO 30 I = 1,L
   30 X(I) = 0.
      L = 1
      IF (PREC .EQ. 2) GO TO 41
      DO 40 I = 1,K
      X(L) = 1.
   40 L = L + (M-I+1)*INCR
      GO TO 44
   41 DO 42 I = 1,K
      DX(L) = 1.D0
   42 L = L + (M-I+1)*CMPLX
   44 CONTINUE
C
C     READ MATRIX A ONE ELEMENT AT A TIME, ADDING IN TERMS TO THE
C     IDENTITY MATRIX
C
      L  = 1
      LL = 1
C
C     II =  COLUMN INDEX
C     M  =  HEIGTH OF TRAPAZOID
C     K  =  LENGTH OF TRAPAZOID
C
      DO 200 I = J,NROW
      CALL INTPK (*1050,FILEA,0,TYPEAR,0)
   45 IF (EOL) 1050,46,1050
   46 CALL ZNTPKI
      IF (I .NE. II) GO TO 45
      L1 = 0
      DO 90 I1 = 1,LL
      IN1 = (L-1)*CMPLX + 1 + L1
      GO TO TRA, (50,60,70,80)
   50 X(IN1) = X(IN1)/A(1)
      GO TO 90
   60 DX(IN1) = DX(IN1)/DA(1)
      GO TO 90
   70 TEMP     = (A(1)*X(IN1  ) + A(2)*X(IN1+1))/(A(1)*A(1) + A(2)*A(2))
      X(IN1+1) = (A(1)*X(IN1+1) - A(2)*X(IN1  ))/(A(1)*A(1) + A(2)*A(2))
      X(IN1)   = TEMP
      GO TO 90
   80 DTEMP    = (DA(1)*DX(IN1  ) +DA(2)*DX(IN1+1))/(DA(1)**2 +DA(2)**2)
      DX(IN1+1)= (DA(1)*DX(IN1+1) -DA(2)*DX(IN1  ))/(DA(1)**2 +DA(2)**2)
      DX(IN1)  = DTEMP
   90 L1 = L1 + (M-I1)*CMPLX
  100 IF (EOL .EQ. 1) GO TO 190
      CALL ZNTPKI
      L1 = 0
      DO 150 I1 = 1,LL
      IN2 = (L-1)*CMPLX + 1+ L1
      IN1 = IN2 + (II-I)*CMPLX
      GO TO TRA1, (110,120,130,140)
  110 X(IN1) = X(IN1) - A(1)*X(IN2)
      GO TO 150
  120 DX(IN1) = DX(IN1) - DA(1)*DX(IN2)
      GO TO 150
  130 X(IN1  ) = X(IN1  ) - A(1)*X(IN2  ) + A(2)*X(IN2+1)
      X(IN1+1) = X(IN1+1) - A(1)*X(IN2+1) - A(2)*X(IN2  )
      GO TO 150
  140 DX(IN1  ) = DX(IN1  ) - DA(1)*DX(IN2  ) + DA(2)*DX(IN2+1)
      DX(IN1+1) = DX(IN1+1) - DA(1)*DX(IN2+1) - DA(2)*DX(IN2  )
  150 L1 = L1 + (M-I1)*CMPLX
      GO TO 100
  190 LL = LL + 1
      IF (LL .GT. K) LL = K
      L = L + 1
  200 CONTINUE
      FORSKP = FORSKP + K
      BAKSKP = BAKSKP - K
      I1 = REW
      IF (BAKSKP .LT. FORSKP) I1 = NOREW
      CALL CLOSE (FILEA ,I1)
      CALL GOPEN (FILEB,X(IOBUF),WRT)
      L  = 1
      IY = J
      JY = NROW
      DO 205 I = 1,K
      CALL PACK (X(L),FILEB,FILEB)
      IY = IY + 1
  205 L  = L  + (M-I+1)*INCR
      CALL CLOSE (FILEB,NOREW)
      J  = J + K
      IF (J .LE. NROW) GO TO 206
      CALL GOPEN (FILEB,X(IOBUF),WRT)
      CALL CLOSE (FILEB,REW)
      RETURN
C
  206 CONTINUE
      CALL GOPEN (FILEA,X(IOBUF),RD)
      IF (FORSKP .GT. BAKSKP) GO TO 220
      CALL SKPREC (FILEA,FORSKP)
      GO TO 10
  220 CALL SKPREC (FILEA,-BAKSKP)
      GO TO 10
C
C     INVERT UPPER TRIANGULAR MATRIX
C
  500 GO TO (510,520,530,540), TYPEAR
  510 ASSIGN 600 TO TRA
      ASSIGN 700 TO TRA1
      ASSIGN 770 TO TRA2
      GO TO  550
  520 ASSIGN 610 TO TRA
      ASSIGN 710 TO TRA1
      ASSIGN 780 TO TRA2
      GO TO  550
  530 ASSIGN 610 TO TRA
      ASSIGN 720 TO TRA1
      ASSIGN 790 TO TRA2
      GO TO  550
  540 ASSIGN 630 TO TRA
      ASSIGN 730 TO TRA1
      ASSIGN 800 TO TRA2
C
C     REWRITE UPPER TRIANGULAR MATRIX ON SCRATCH FILE
C
  550 INBUF  = IOBUF
      FORSKP = NROW + 1
      BAKSKP = 0
      OUTBUF = INBUF - SYSBUF
      IF (OUTBUF .LT. NROW+1) GO TO 1040
      CALL GOPEN (FILEA,X(IOBUF),0)
C
C     POSITION FILE AT LAST RECORD
C
      CALL SKPREC (FILEA,NROW)
C
C     REWRITE THE INPUT MATRIX ON A SCRATCH FILE WITH THE RECORDS
C     WRITTEN IN THE REVERSE ORDER AND THE COLUMNS INVERTED
C
      CALL GOPEN (SCRFIL,X(OUTBUF),1)
      IT2 = TYPEAR
      DO 645 I = 1,NROW
      IX = 1
      JX = 0
      CALL BCKREC (FILEA)
      CALL UNPACK (*1050,FILEA,X)
      CALL BCKREC (FILEA)
      KK = JX - IX + 1
      K  = KK/2
      IF (K .EQ. 0) GO TO 641
      KK = KK + 1
      DO 640 J = 1,K
      L  = KK - J
      GO TO TRA, (600,610,630)
  600 TEMP = X(J)
      X(J) = X(L)
      X(L) = TEMP
      GO TO 640
  610 DTEMP = DX(J)
      DX(J) = DX(L)
      DX(L) = DTEMP
      GO TO 640
  630 DTEMP = DX(J)
      DX(J) = DX(L)
      DX(L) = DTEMP
      DTEMP = DX(J+1)
      DX(J+1) = DX(L+1)
      DX(L+1) = DTEMP
  640 CONTINUE
  641 CONTINUE
      IY = NROW - JX + 1
      JY = NROW - IX + 1
      CALL PACK (X,SCRFIL,T)
  645 CONTINUE
      IT1 = TYPEAR
      IT2 = TYPEB
      CALL CLOSE (FILEA,REW)
      CALL CLOSE (SCRFIL,EOFNRW)
      CALL GOPEN (SCRFIL,X(IOBUF),0)
      CALL SKPREC (SCRFIL,NROW)
      CALL CLOSE (SCRFIL,NOREW)
C
C     ALLOCATE CORE
C
      J  = 0
  650 M  = J + 1
      CALL GOPEN (SCRFIL,X(IOBUF),RD)
      K  = NROW - J
      IF (K*M+K*(K-1)/2 .LT. CORE/INCR) GO TO 652
      A1 = (2*M-1)**2 + 8*CORE/INCR
      K  = SQRT(A1)
      K  = (-(2*M-1)+K)/2
      IF (K .LE. 0) GO TO 1040
  652 BAKSKP = BAKSKP + K
      FORSKP = FORSKP - K
C
C     POSITION SCRATCH FILE
C
      IF (FORSKP .GT. BAKSKP) GO TO 660
      CALL REWIND (SCRFIL)
      CALL SKPREC (SCRFIL,FORSKP)
      GO TO 665
  660 CALL SKPREC (SCRFIL,-BAKSKP)
  665 CONTINUE
C
C     GENERATE UPPER TRIANGLE OF THE IDENTITY MATRIX
C
      LEND = (M*K+K*(K-1)/2)*INCR
      DO 670 I = 1,LEND
  670 X(I) = 0.
      L = M
      IF (PREC .EQ. 2) GO TO 676
      DO 675 I = 1,K
      X(L) = 1.
  675 L = L + (I+M)*INCR
      GO TO 680
  676 DO 678 I = 1,K
      DX(L) = 1.D0
  678 L = L + (I+M)*CMPLX
  680 CONTINUE
C
C     READ UPPER TRIANGLE ONE ELEMENT AT A TIME, ADDING IN
C     APPROPIATE TERMS TO THE IDENTITY MATRIX
C
      IF (PREC .EQ. 2) LEND = LEND/2
      J = J + K
      L = 1
      DO 901 JJ = 1,J
      CALL INTPK (*1050,SCRFIL,0,TYPEAR,0)
      CALL ZNTPKI
      I = NROW - II + 1
      IF (I .NE. J-JJ+1) GO TO 1050
      L1 = 0
      DO 750 I1 = 1,L
      IN1 = LEND - L*CMPLX - L1 + 1
      GO TO TRA1, (700,710,720,730)
  700 X(IN1) = X(IN1)/A(1)
      GO TO 740
  710 DX(IN1) = DX(IN1)/DA(1)
      GO TO 740
  720 TEMP   = (A(1)*X(IN1  ) + A(2)*X(IN1+1))/(A(1)*A(1) + A(2)*A(2))
      IN2    = IN1 + 1
      X(IN2) = (A(1)*X(IN1+1) - A(2)*X(IN1  ))/(A(1)*A(1) + A(2)*A(2))
      X(IN1) = TEMP
      GO TO 740
  730 DTEMP  = (DA(1)*DX(IN1  ) + DA(2)*DX(IN1+1))/(DA(1)**2 + DA(2)**2)
      IN2    = IN1 + 1
      DX(IN2)= (DA(1)*DX(IN1+1) - DA(2)*DX(IN1  ))/(DA(1)**2 + DA(2)**2)
      DX(IN1)= DTEMP
  740 CONTINUE
  750 L1 = L1 + (M+K-1-I1)*CMPLX
  760 IF (EOL .EQ. 1) GO TO 901
      CALL ZNTPKI
      L1 = 0
      I  = J - JJ - NROW + II
      DO 900 I1 = 1,L
      IN2 = LEND - L*CMPLX - L1 + 1
      IN1 = IN2 - I*CMPLX
      GO TO TRA2, (770,780,790,800)
  770 X(IN1) = X(IN1) - A(1)*X(IN2)
      GO TO 810
  780 DX(IN1) = DX(IN1) - DA(1)*DX(IN2)
      GO TO 810
  790 X(IN1  ) = X(IN1  ) - A(1)*X(IN2  ) + A(2)*X(IN2+1)
      X(IN1+1) = X(IN1+1) - A(1)*X(IN2+1) - A(2)*X(IN2  )
      GO TO 810
  800 DX(IN1  ) = DX(IN1  ) - DA(1)*DX(IN2  ) + DA(2)*DX(IN2+1)
      DX(IN1+1) = DX(IN1+1) - DA(1)*DX(IN2+1) - DA(2)*DX(IN2  )
  810 L1 = L1 + (M+K-1-I1)*CMPLX
  900 CONTINUE
      GO TO 760
  901 L = L + 1
      CALL CLOSE (SCRFIL,NOREW)
      CALL GOPEN (FILEB,X(IOBUF),WRT)
      L = J - K + 1
      LL= 1
      DO 910 I = 1,K
      IY = 1
      JY = L
      CALL PACK (X(LL),FILEB,FILEB)
      L = L + 1
  910 LL = LL + (M+I-1)*INCR
      CALL CLOSE (FILEB,NOREW)
      IF (J .LT. NROW) GO TO 650
      CALL GOPEN (FILEB,X(IOBUF),WRT)
      CALL CLOSE (FILEB,REW)
      CALL GOPEN (SCRFIL,X(IOBUF),RD)
      CALL CLOSE (SCRFIL,REW)
      GO TO 2000
C
 1000 NO = -7
      GO TO 1100
 1040 NO = -8
      GO TO 1100
 1050 RETURN 1
 1100 CALL MESAGE (NO,0,NAME)
C
 2000 RETURN
      END

      SUBROUTINE RBMG1
C*****
C RBMG1 PARTITIONS KAA INTO KLL, KLR AND KRR AND MAA SIMILARLY.
C*****
C
      INTEGER       USET  ,UA    ,UL    ,UR    ,SCR1
      COMMON/BITPOS/UM    ,UO    ,UR    ,USG   ,USB   ,UL    ,UA
     1             ,UF    ,US    ,UN    ,UG    ,UE    ,UP
C*****
C     INPUT DATA FILES
C*****
      DATA USET,KAA,MAA/101,102,103/
C*****
C     OUTPUT DATA FILES
C*****
      DATA  KLL,KLR,KRR,MLL,MLR,MRR/201,202,203,204,205,206/
C*****
C     SCRATCH DATA FILES
C*****
      DATA SCR1/301/
C*****
C     PARTITION  KAA INTO KLL,KLR, AND KRR
C     PARTITION  MAA INTO MLL,MLR, AND MRR
C*****
      CALL UPART(USET,SCR1,UA,UL,UR)
      CALL MPART(KAA,KLL,0,KLR,KRR)
      CALL MPART(MAA,MLL,0,MLR,MRR)
      RETURN
      END

      SUBROUTINE PLAMAT
C THIS ROUTINE RETURNS GP ROTATED FOR PLA3 AND PLA4
C
      DIMENSION X(27)
      COMMON /MATIN / MATID,INFLAG,ELTEMP,PLAARG,SINTH,COSTH
      COMMON /MATOUT/ G11,G12,G13,G22,G23,G33 , DUMMY(14)
      COMMON /PLAGP / GP(9) , MIDGP , ELID
C
C  TEST TO SEE IF INCOMING MATERIAL ID IS EQUAL TO MATERIAL ID IN
C  PLAGP.  IF NOT USE REGULAR CALL TO MAT TO GET GP
C
      IF( MIDGP .NE. MATID ) GO TO 10
C
C                           T
C  TRANSFORM G   ,  G  =   U  *  G   * U
C             P      P            P
C
      X(1)  = COSTH**2
      X(2)  = SINTH**2
      X(3)  = COSTH * SINTH
      X(4)  = X(2)
      X(5)  = X(1)
      X(6)  = -X(3)
      X(7)  = 2.0 * X(6)
      X(8)  = -X(7)
      X(9)  = X(1) - X(2)
      CALL GMMATS(GP(1),3,3,0,X( 1),3,3,0,X(19))
      CALL GMMATS(X( 1),3,3,1,X(19),3,3,0,X(10))
      G11 = X(10)
      G12 = X(11)
      G13 = X(12)
      G22 = X(14)
      G23 = X(15)
      G33 = X(18)
      RETURN
   10 INFLAG = 2
      CALL MAT (ELID)
      RETURN
      END

      SUBROUTINE FINDER( NAM , SUBNO , COMNO )
C
C
C     THIS SUBROUTINE READS THE TABLE OF CONTENTS OF SUBSTRUCTURES
C     BEING COMBINED ( SCRATCH FILE SCTOC ) AND FOR ANY GIVEN
C     BASIC SUBSTRUCTURE NAME ( NAM ) RETURNS THE ID NUMBER OF THE
C     PSEUDO-STRUCTURE CONTAINING IT ( SUBNO ) AND ITS POSITION IN
C     THE COMPONENT LIST FOR THAT STRUCTURE ( COMNO ).  IF A NAME
C     DOES NOT APPEAR IN THE SCTOC AN ERROR MESSAGE IS ISSUED.
C
      INTEGER SCTOC,BUF4,ID(3),SUBNO,COMNO,NAM(2),CNAM(2),OUTT
      LOGICAL TOCOPN
      COMMON/CMB001/ SCR1,SCR2,SCBDAT,SCSFIL,SCCONN,SCMCON,
     1               SCTOC,GEOM4,CASECC
      COMMON/ZZZZZZ/ Z(1)
      COMMON/CMB002/ BUF1,BUF2,BUF3,BUF4,BUF5,SCORE,LCORE,INPT,OUTT
      COMMON/CMB003/ COMBO(7,5),CONSET,IAUTO,TOLER,NPSUB,CONECT,TRAN,
     1               MCON,RESTCT(7,7),ISORT,ORIGIN(7,3),IPRINT,TOCOPN
      COMMON/CMBFND/ INAM(2),IERR
C
C     OPEN SCTOC FILE
C
      IERR = 0
      IF(.NOT.TOCOPN)CALL OPEN(*2001,SCTOC,Z(BUF4),0)
      CALL REWIND( SCTOC )
C
      DO 1 I=1,NPSUB
      CALL READ(*2001,*2002,SCTOC,ID,3,0,NNN)
      NCOM = ID(3)
      DO 2 J=1,NCOM
      IEOR = 0
      IF( J .EQ. NCOM ) IEOR = 1
      CALL READ(*2001,*2002,SCTOC,CNAM,2,IEOR,NNN)
      IF( NAM(1).EQ.CNAM(1) .AND. NAM(2).EQ.CNAM(2) ) GO TO 11
2     CONTINUE
1     CONTINUE
C
C     IERR = 1 MEANS THAT THE SUBSTRUCTURE NAME IS NOT IN THE TOC
C
      IERR = 1
      RETURN
11    SUBNO = I
      INAM(1) = ID(1)
      INAM(2) = ID(2)
      COMNO = J
      IF( .NOT. TOCOPN ) CALL CLOSE( SCTOC , 1 )
2001  CONTINUE
2002  CONTINUE
      RETURN
      END

      SUBROUTINE SSWTCH (NBIT,L)
C
C     PURPOSE OF THIS ROUTINE IS TO SET L = 1 IF SENSE SWITCH BIT IS
C     ON, OTHERWISE L = 0.
C
C     SENSE SWITCH DEFINITION
C      1 = DUMP CORE WHEN SUBROUTINE DUMP OR PDUMP(NO ARGUMENTS) IS
C          CALLED
C      2 = DUMP FIAT TABLE AFTER ALLOCATION
C      3 = DUMP DATA POOL DICTIONARY AFTER ALLOCATION
C      4 = DUMP OSCAR FILE AT END OF XGPI
C      5 = CONSOLE MESSAGE DESIRED (BEGIN)
C      6 = CONSOLE MESSAGE DESIRED (END)
C      7 = EIGENVALUE EXTRACTION DIAGNOSTICS
C          (DETERMINANT AND INVERSE POWER)
C      8 = TRACES NPTP ON 1108
C      9 = TURNS ON PRINTER PLOTTER FOR ANY XYPLOT REQUESTS
C     10 = USES ALTERNATE ALGORITHUM FOR NON LINEAR LOADS SEE SPR 153
C     11 = ACTIVE ROW AND COLUMN TIME PRINTS
C     12 = CONPLEX EIGENVALUE EXTRACTION DIAGNOSTICS
C          (INVERSE POWER)
C     28 = PUNCHES OUT LINK SPECIFICATION TABLE - DECK XBSBD
C     29 = PROCESS LINK SPECIFICATION UPDATE DECK
C     30 = PUNCHES OUT ALTERS TO XSEM-S FOR SWITCHES 1-15
C     31 = PRINT LINK SPECIFICATION TABLE
C
      EXTERNAL        LSHIFT,RSHIFT,ANDF
      INTEGER         SWITCH,ANDF,RSHIFT,RENTER
      COMMON /SYSTEM/ XSYS(78),SWITCH(3)
      COMMON /XLINK / LXLINK,MAXLNK
      COMMON /SEM   / DUMMY(3),NS(1)
      DATA    RENTER/ 4HREEN /
C
      L = 0
      IF (IRET .EQ.  1) RETURN
      IF (NBIT .GT. 31) GO TO 10
      IF (ANDF(LSHIFT(1,NBIT-1),SWITCH(1)) .NE. 0) L = 1
      RETURN
C
   10 NBIT2 = NBIT - 31
      IF (ANDF(LSHIFT(1,NBIT2-1),SWITCH(2)) .NE. 0) L = 1
      RETURN
C
C
      ENTRY PRESSW (NBIT,L)
C     =====================
C
C     PRESSW IS CALLED ONLY BY BGNSYS AND XCSA TO SETUP DIAGNOSTIC BITS
C     FOR A PARTICULAR LINK.
C     BITS  0 THRU 47 ARE USED FOR 48 DIAGNOSTICS
C     BITS 49 THRU 63 ARE RESERVED FOR 15 LINK NOS.
C     NBIT HERE (INPUT) CONTAINS BCD WORD NSXX WHERE XX IS LINK NO.
C
      IRET = 0
      IF (NBIT .EQ. RENTER) RETURN
      IF (SWITCH(3)+SWITCH(2) .EQ. 0) IRET = 1
      I = 32 - MAXLNK
      IF (RSHIFT(SWITCH(2),I) .EQ. 0) GO TO 40
      DO 20 I = 1,MAXLNK
      IF (NBIT .EQ. NS(I)) GO TO 30
   20 CONTINUE
      I = 0
      IF (NBIT .EQ. NS (16)) I = 5
      IF (NBIT .EQ. NS (17)) I = 8
      IF (NBIT .EQ. NS (18)) I = 13
      IF (NBIT .EQ. NS (19)) I = 6
      IF (NBIT .EQ. NS (20)) I = 2
      IF (NBIT .EQ. NS (21)) I = 9
      IF (NBIT .EQ. NS (22)) I = 11
      IF (NBIT .EQ. NS (23)) I = 15
      IF (I .NE. 0) GO TO 30
      GO TO 40
   30 NBIT2 = I + 31 - MAXLNK
      IF (ANDF(LSHIFT(1,NBIT2),SWITCH(2)) .EQ. 0) IRET = 1
   40 IF (IRET .EQ. 0) SWITCH(1) = SWITCH(3)
      RETURN
      END

      SUBROUTINE TRLG
C
C     THIS IS THE MODULE DRIVER FOR  TRLG(TRANSIENT LOAD GENERATOR)
C
C     INPUTS(14)
C       CASEXX      CASECONTROL
C       USETD
C       DLT         DYNAMIC LOAD TABLE
C       SLT         STATIC  LOAD TABLE
C       BGPDT       BASIC GRID POINT DEFINITION TABLE
C       SIL         SCALAR INDEX LIST
C       CSTM        COORDINATE SYSTEMS
C       TRL         TRANSIENT RESPONSE LIST
C       DIT         DIRECT INPUT TABELS
C       GMD
C       GOD
C       PHIDH
C       EST
C       MGG         MASS MATRIX FOR GRAVITY LOADS
C       MPT
C     OUTPUTS(6)
C       PPO
C       PSO
C       PDO
C       PD
C       PH
C       TOL
C     PARAMETERS
C      IP1 = -1     IF (AP = AD)
C      NCOL.LE.0    NO CONTINUE MODE (TO = 0.0)
C      NCOL.GT.0    CONTINUE MODE (TO = LAST TIME)
C
C     SCRATCHES (9)
C
      INTEGER  CASEXX,USETD,DLT,SLT,BGPDT,SIL,CSTM,TRL,DIT,GMD,GOD,
     1         PHIDH,PPO,PSO,PDO,PD,PH,TOL,SCR1,SCR2,SCR3,SCR4,SCR5,
     2         SCR6,SCR7,AP,AS,AD,AH,TMLDTB,FCT,FCO,SCR8,EST,SCR9,MCB(7)
C
      COMMON /BLANK/ IP1,NCOL
C
      DATA  CASEXX,USETD,DLT,SLT,BGPDT,SIL,CSTM,TRL,DIT,GMD,GOD,PHIDH/
     1      101   , 102 ,103,104,105  ,106,107 ,108,109,110,111,112  /
      DATA  EST,MGG,MPT /
     1      113,114,115 /
      DATA  PPO,PSO,PDO,PD ,PH ,TOL /
     1      201,202,203,204,205,206 /
      DATA  SCR1,SCR2,SCR3,SCR4,SCR5,SCR6,SCR7,SCR8,SCR9 /
     1      301 ,302 ,303 ,304 ,305, 306 ,307 ,308 ,309  /
C
C     FORM AP MATRIX AND EXTRACT LOAD TABLES
C
      AP = SCR1
      TMLDTB = SCR2
      CALL TRLGA (CASEXX,USETD,DLT,SLT,BGPDT,SIL,CSTM,AP,TMLDTB,ITRL,
     1            SCR3,SCR4,SCR5,EST,SCR6,MGG,SCR7,MPT)
C
C     REDUCE TRANSFORMATION MATRIX
C
      AS = SCR3
      AD = SCR4
      AH = SCR5
      MCB(1) = AP
      CALL RDTRL (MCB)
      IF (MCB(2) .LE. 0) GO TO 10
      CALL TRLGB (USETD,AP,GMD,GOD,PHIDH,AS,AD,AH,IP1,SCR6,SCR7,SCR8,
     1            SCR9)
C
C     PRODUCE TIME FUNCTION MATRIX
C
   10 CONTINUE
      FCT = SCR6
      FCO = SCR7
      CALL  TRLGC (TMLDTB,TRL,DIT,ITRL,FCT,FCO,TOL,IP2)
      IF (MCB(2) .LE. 0) GO TO 20
      IF (IP2  .EQ.  -1) FCO = FCT
C
C     COMPUTE LOAD FACTORS
C
      CALL TRLGD (FCT,FCO,AP,AS,AD,AH,PPO,PSO,PDO,PD,PH,IP1,SCR2,IP2)
   20 CONTINUE
      RETURN
      END

      SUBROUTINE DBMDMP
C********************************************************************
C     DBMDMP - DUMPS THE IN MEMORY DATA BASE DIRECTORY
C********************************************************************
      INCLUDE 'DSIOF.COM'
      COMMON / ZZZZZZ / MEM(4)
      COMMON / SYSTEM / ISYSBF, IWR
      WRITE ( IWR, 900 ) IDBBAS, IDBFRE, IDBDIR, INDBAS, INDCLR, INDCBP
     &,                  NBLOCK, LENALC, IOCODE, IFILEX, NAME,   MAXALC
     &,                  MAXBLK, MAXDSK, IDBLEN, IDBADR, IBASBF, INDDIR
     &,                  NUMOPN, NUMCLS, NUMWRI, NUMREA, LENOPC
900   FORMAT(/,' CONTENTS OF / DBM / FOLLOW:'
     &,/,' IDBBAS =',I8,' IDBFRE =',I8,' IDBDIR =',I8,' INDBAS =',I8
     &,/,' INDCLR =',I8,' INDCBP =',I8,' NBLOCK =',I8,' LENALC =',I8
     &,/,' IOCODE =',I8,' IFILEX =',I8,' NAME   =',I8,' MAXALC =',I8
     &,/,' MAXBLK =',I8,' MAXDSK =',I8,' IDBLEN =',I8,' IDBADR =',I8
     &,/,' IBASBF =',I8,' INDDIR =',I8,' NUMOPN =',I8,' NUMCLS =',I8
     &,/,' NUMWRI =',I8,' NUMREA -',I8,' LENOPC =',I8 )
      WRITE ( IWR, 901 )
901   FORMAT(/,' CONTENTS OF FCB FOLLOW:',/)
      DO 10 I = 1, 80
      WRITE ( IWR, 902 ) I, ( FCB(K,I),K=1,15)
902   FORMAT(I3,'-',I3,I7,4I5,I12,I2,4I7,2A4,I4)
10    CONTINUE
      CALL DBMDIA
C      WRITE ( IWR, 906 )
C      WRITE ( IWR, 907 )
      NEXT = IDBFRE
      ITOTAL = 0
      ITOTBK = 0
      ICNT = 0
      IF ( NEXT .EQ. 0 ) GO TO 40
30    ICNT = ICNT + 1
      IF ( NEXT .EQ. 0 ) GO TO 50
      IVAL = NEXT
      IVALP= MEM(NEXT)
      IVALN= MEM(NEXT+1)
      IF ( MEM(NEXT  ) .EQ. 0 ) IVALP = 0
      IF ( MEM(NEXT+1) .EQ. 0 ) IVALN = 0
      ITOTAL = ITOTAL + MEM(NEXT+2)
      ITOTBK = ITOTBK + 1
C      WRITE ( IWR, 908 ) ICNT,IVAL,IVALP,IVALN,MEM(NEXT+2)
      NEXT = MEM( NEXT+1 )
      GO TO 30
40    CONTINUE
C      WRITE( IWR, 909 )
      GO TO 60
50    CONTINUE
C     WRITE( IWR, 910 ) ITOTAL, ITOTBK
60    CONTINUE
700   RETURN
906   FORMAT(///,31X,' DUMP OF FREE CHAIN',/
     &,13X,' ( BLOCK ADDRESSES IN BYTES,  BLOCK LENGTHS IN WORDS )',/)
907   FORMAT(10X,
     &'  BLOCK NO    BLOCK ADDRESS  PREV. BLOCK   NEXT BLOCK    LENGTH')
908   FORMAT( I17,I20,I13,I13,I10)
909   FORMAT(//' *************** NO FREE SPACE REMAINS **************')
910   FORMAT(///,' TOTAL FREE SPACE IN WORDS            =',I10
     &,/,        ' NUMBER OF BLOCKS IN FREE SPACE CHAIN =',I10)
      END

      SUBROUTINE XYOUT (IOPT,BUF,RBUF)
C
C     THIS SUBROUTINE IS CALLED BY XYTRAN AND OUTPUTS TO PRINTER AND
C     PUNCH
C
      EXTERNAL        LSHIFT,RSHIFT
      LOGICAL         PRINT,PUNCH
      INTEGER         BUF(300),NAMES(44),TYPE(6),PLT(2),IMTD(6),
     1                ITYPE(4),RSHIFT
      REAL            RBUF(300)
      COMMON /MACHIN/ MACH,IHALF
      COMMON /BLANK / ICOM1,DUM(4),ICARD
      COMMON /SYSTEM/ SYSBUF,L,D1(6),MAXLNS,D2(2),LINE,D3(78),LPCH
      COMMON /OUTPUT/ IHEAD(96)
      DATA    NAMES / 4HDISP ,4HLACE ,4HMENT ,4H     ,
     1                4HVELO ,4HCITY ,4H     ,4H     ,
     2                4HACCE ,4HLERA ,4HTION ,4H     ,
     3                4HS P  ,4HC F  ,4H     ,4H     ,
     4                4HLOAD ,4H     ,4H     ,4H     ,
     5                4HELEM ,4HENT- ,4HSTRE ,4HSS   ,
     6                4HELEM ,4HENT- ,4HFORC ,4HE    ,
     7                4HS-DI ,4HSPLA ,4HCEME ,4HNT   ,
     8                4HS-VE ,4HLOCI ,4HTY   ,4H     ,
     9                4HS-AC ,4HCELE ,4HRATI ,4HON   ,
     O                4HNONL ,4HINEA ,4HR-FO ,4HRCE                  /
      DATA    TYPE  / 4HWHOL ,4HE    ,4HUPPE ,4HR    ,4HLOWE ,4HR    /
      DATA    IRAND / 4HRAND /
      DATA    IVG   / 4HVG   /
      DATA    PLT   / 4HNAST ,4HPLT  /
      DATA    IMTD  / 4HFILM ,1H     ,4HTABL ,1HE    ,4HDRUM ,1H     /
      DATA    ITYPE / 4HWITH ,4H     ,
     1                4HWITH ,4HOUT  /
C
      IF (ICOM1 .EQ. IVG) GO TO 86
C
C     BRANCH ON OPTION
C
      IF (IOPT) 10,90,90
C
C     PRINT XY-OUTPUT SUMMARY
C
C
C     FILL OUT HEADING
C
   10 DO 20 I = 1,96
   20 IHEAD(I) = BUF(I+50)
      CALL PAGE1
      WRITE (L,150)
      IF (ICOM1 .EQ. IRAND) GO TO 30
      WRITE (L,170)BUF(1)
      GO TO 40
   30 WRITE (L,160) RBUF(1)
      WRITE (L,161) RBUF(42)
   40 ITEMPV = 4*BUF(6) - 3
C
C     PRINT TYPE OF PLOT
C
      IF (BUF(245)-2) 41,42,43
   41 WRITE (L,460)
      GO TO 45
   42 WRITE (L,470)
      GO TO 45
   43 WRITE (L,480)
C
C     PRINT DATA TYPE AND CURVE
C
   45 ICOMP = BUF(5)
      IF (BUF(6).NE.6 .AND. BUF(6).NE.7) ICOMP = BUF(5) - 2
      IF (BUF(7)) 70,60,50
   50 WRITE (L,200) NAMES(ITEMPV),NAMES(ITEMPV+1),NAMES(ITEMPV+2),
     1              NAMES(ITEMPV+3),BUF(4),ICOMP
      ITEMP = 3
      GO TO 72
   60 WRITE (L,180) NAMES(ITEMPV),NAMES(ITEMPV+1),NAMES(ITEMPV+2),
     1              NAMES(ITEMPV+3),BUF(4),ICOMP
      ITEMP = 1
      GO TO 72
   70 WRITE (L,190) NAMES(ITEMPV),NAMES(ITEMPV+1),NAMES(ITEMPV+2),
     1              NAMES(ITEMPV+3),BUF(4),ICOMP
      ITEMP  = 5
   72 ICOUNT = ICARD + 1
      WRITE (L,210)
      IF (BUF(288) .GT. 0) WRITE (L,230)
      IF (BUF(290) .GT. 0) WRITE (L,240) ICOUNT
C
C     PLOTTER INFORMATION
C
      IF (BUF(289) .LE. 0) GO TO 84
      WRITE (L,220)
      J = RSHIFT(BUF(284),IHALF)
      MODEL = BUF(284) - LSHIFT(J,IHALF) - 100
      M = 1
      IF (MODEL .LT. 0) M = 3
C
C   . NASPLOT...
C
      K = 2*IABS(MODEL) - 1
      WRITE (L,380) PLT(1),PLT(2),IMTD(K),IMTD(K+1),ITYPE(M),ITYPE(M+1)
      IF (BUF(283) .LE. 0) BUF(283) = 1
C
C     WRITE CSCALE DATA OUT
C
      WRITE (L,490) RBUF(282)
      IF (IABS(MODEL)-2) 81,82,82
C
C   . CAMERA, DENSITY...
C
   81 IF (BUF(287) .GE. 3) WRITE (L,410)
      IF (BUF(287) .EQ. 2) WRITE (L,430)
      IF (BUF(287) .LE. 1) WRITE (L,420)
      WRITE (L,450) BUF(283)
      GO TO 83
C
C   . PAPER SIZE
C     (THE LOGIC HERE IS SIMILAR TO THAT IN SUBROUTINE PLTSET)
C
   82 IF (IABS(MODEL) .EQ. 2) GO TO 822
C
C   . DRUM PLOTTERS
C
      IF (RBUF(285) .LE. 0.0) RBUF(285) = 30.0
      IF (RBUF(286) .LE. 0.0) RBUF(286) = 30.0
      GO TO 824
C
C   . TABLE PLOTTERS
C
  822 IF (RBUF(285) .LE.  0.0) RBUF(285) = 11.0
      IF (RBUF(285) .GT. 30.0) RBUF(285) = 30.0
      IF (RBUF(286) .LE.  0.0) RBUF(286) = 8.5
  824 IF (RBUF(286) .GT. 30.0) RBUF(286) = 30.0
      WRITE (L,390) RBUF(285),RBUF(286)
C
C   . PEN SIZE
C
      WRITE (L,440) BUF(283)
   83 WRITE (L,250) BUF(3),TYPE(ITEMP),TYPE(ITEMP+1),BUF(2)
C
C  .  PAPER PLOT
C
   84 IF (BUF(289).GT.0 .AND. BUF(289).NE.2) GO TO 85
      WRITE (L,400) BUF(281)
C
   85 CONTINUE
      WRITE (L,260) (BUF(J),J=147,174),(BUF(J),J=179,206),
     1              (BUF(J),J=211,238)
      WRITE (L,270)
      WRITE (L,290) RBUF( 11),RBUF( 12)
      WRITE (L,300) RBUF(293),RBUF(294)
      WRITE (L,310) RBUF(295),RBUF(296)
      WRITE (L,280) RBUF(291),RBUF(292)
      WRITE (L,300) RBUF(297),RBUF(298)
      WRITE (L,310) RBUF(299),RBUF(300)
      WRITE (L,320)
      IF (BUF(288) .GT. 0) WRITE (L,330)
   86 ITEMPV = 4*BUF(6) - 3
      IF (BUF(7)) 89,88,87
   87 ITEMP = 3
      GO TO 891
   88 ITEMP = 1
      GO TO 891
   89 ITEMP = 5
  891 IPRINT= 0
      ID    = BUF(4)
      ICOMP = BUF(5)
      IF (BUF(6).NE.6 .AND. BUF(6).NE.7) ICOMP = BUF(5) - 2
      PRINT = .FALSE.
      PUNCH = .FALSE.
      IF (BUF(290) .GT. 0) PUNCH = .TRUE.
      IF (BUF(288) .GT. 0) PRINT = .TRUE.
      IF (.NOT.PRINT) RETURN
      LINE = MAXLNS + 1
      RETURN
C
C     PRINT AND OR PUNCH OUTPUT
C
   90 IPRINT = IPRINT + 1
      IF (.NOT.PUNCH) GO TO 100
      ICARD = ICARD + 1
      WRITE (LPCH,370) IPRINT,RBUF(1),RBUF(2),ICARD
  100 IF (.NOT.PRINT) RETURN
      IF (LINE .LT. MAXLNS) GO TO 110
      CALL PAGE1
      WRITE (L,340) NAMES(ITEMPV),NAMES(ITEMPV+1),NAMES(ITEMPV+2),
     1              NAMES(ITEMPV+3),ID,ICOMP,TYPE(ITEMP),TYPE(ITEMP+1)
  110 LINE = LINE + 1
      IF (.NOT.PUNCH) GO TO 120
      WRITE (L,350) IPRINT,RBUF(1),RBUF(2),ICARD
      RETURN
  120 WRITE (L,350) IPRINT,RBUF(1),RBUF(2)
      RETURN
C
  150 FORMAT (///44X,33HX Y - O U T P U T   S U M M A R Y)
  160 FORMAT (//5X,24HROOT MEAN SQUARE VALUE =,1P,E15.6)
  161 FORMAT (6X,38HFREQUENCY OF ZERO CROSSINGS (N ZERO) =,1P,E15.6)
  170 FORMAT (//5X,7HSUBCASE,I10)
  180 FORMAT (6X,4A4,5HCURVE,I9,1H(,I2,1H))
  190 FORMAT (6X,4A4,5HCURVE,I9,4H(--,,I2,1H))
  200 FORMAT (6X,4A4,5HCURVE,I9,1H(,I2,4H,--))
  210 FORMAT (1H )
  220 FORMAT (6X,44HXY-PAIRS WITHIN FRAME LIMITS WILL BE PLOTTED)
  230 FORMAT (6X,46HXY-PAIRS BETWEEN XMIN AND XMAX WILL BE PRINTED)
  240 FORMAT (6X,64HXY-PAIRS BETWEEN XMIN AND XMAX WILL BE PUNCHED BIGIN
     1NING ON CARD,I8)
  250 FORMAT (//5X,13HTHIS IS CURVE,I4,4H OF ,A4,A2,5HFRAME,I5)
  260 FORMAT (//5X,14HCURVE  TITLE =,28A4,/6X,14HX-AXIS TITLE =,28A4,
     1        /6X,14HY-AXIS TITLE =,28A4)
  270 FORMAT (/////5X,62HTHE FOLLOWING INFORMATION IS FOR THE ABOVE DEFI
     1NED CURVE ONLY. )
  280 FORMAT (//5X,36HWITHIN THE X-LIMITS OF ALL DATA (X =,1P,E14.6,
     1        8H TO  X =,1P,E14.6,1H))
  290 FORMAT (///6X,36HWITHIN THE FRAME X-LIMITS       (X =,1P,E14.6,
     1        8H TO  X =,1P,E14.6,1H))
  300 FORMAT (//30X,22HTHE SMALLEST Y-VALUE =,1P,E14.6,7H AT X =,E15.6)
  310 FORMAT (//30X,22HTHE LARGEST  Y-VALUE =,1P,E14.6,7H AT X =,E15.6,
     1        //)
  320 FORMAT (//45X,27HE N D   O F   S U M M A R Y)
  330 FORMAT (//25X,69HP R I N T E D   D A T A   F O R   T H I S   C U R
     1 V E   F O L L O W S)
  340 FORMAT (//5X,4A4,12HCURVE   ID =,I9,5X,11HCOMPONENT =,I3,5X,A4,A2,
     1        5HFRAME,///27X,12HPRINT NUMBER,10X,7HX-VALUE,14X,
     2        7HY-VALUE,14X,11HCARD NUMBER  )
  350 FORMAT (28X,I7,1P,E25.6,E21.6,10X,I8)
  370 FORMAT (I10,10X,1P,2E20.6,12X,I8)
  380 FORMAT (6X,21HPLOTTER SPECIFIED IS ,3A4,A1,9H PLOTTER ,2A4,
     1        18HTYPING CAPABILITY.)
  390 FORMAT (6X,11HPAPER SIZE ,F5.2,3H X ,F5.2,18H INCHES SPECIFIED.)
  400 FORMAT (6X,38HTHIS CURVE WILL BE PAPER-PLOTTED FRAME,I5)
  410 FORMAT (6X,36HCAMERA 3 USED. (PAPER AND 35MM FILM))
  420 FORMAT (6X,26HCAMERA 2 USED. (35MM FILM))
  430 FORMAT (6X,22HCAMERA 1 USED. (PAPER))
  440 FORMAT (6X,9HPENSIZE =,I3)
  450 FORMAT (6X,9HDENSITY =,I3)
  460 FORMAT (6X,8HRESPONSE)
  470 FORMAT (6X,38HPOWER-SPECTRAL-DENSITY-FUNCTION (PSDF))
  480 FORMAT (6X,15HAUTOCORRELATION)
  490 FORMAT (6X,9HCSCALE = ,F5.2)
      END 

      SUBROUTINE QUAD4S
C
C     FORMS STIFFNESS AND MASS MATRICES FOR THE QUAD4 PLATE ELEMENT
C
C     SINGLE PRECISION VERSION
C
C
C     EST  LISTING
C
C     WORD       TYPE         DESCRIPTION
C     --------------------------------------------------------------
C       1          I    ELEMENT ID, EID
C       2 THRU 5   I    SILS, GRIDS 1 THRU 4
C       6 THRU 9   R    MEMBRANE THICKNESSES T AT GRIDS 1 THRU 4
C      10          R    MATERIAL PROPERTY ORIENTATION ANGLE, THETA
C               OR I    COORD. SYSTEM ID (SEE TM ON CQUAD4 CARD)
C      11          I    TYPE FLAG FOR WORD 10
C      12          R    GRID ZOFF  (OFFSET)
C      13          I    MATERIAL ID FOR MEMBRANE, MID1
C      14          R    ELEMENT THICKNESS, T (MEMBRANE, UNIFORMED)
C      15          I    MATERIAL ID FOR BENDING, MID2
C      16          R    BENDING INERTIA FACTOR, I
C      17          I    MATERIAL ID FOR TRANSVERSE SHEAR, MID3
C      18          R    TRANSV. SHEAR CORRECTION FACTOR TS/T
C      19          R    NON-STRUCTURAL MASS, NSM
C      20 THRU 21  R    Z1, Z2  (STRESS FIBRE DISTANCES)
C      22          I    MATERIAL ID FOR MEMBRANE-BENDING COUPLING, MID4
C      23          R    MATERIAL ANGLE OF ROTATION, THETA
C               OR I    COORD. SYSTEM ID (SEE MCSID ON PSHELL CARD)
C      24          I    TYPE FLAG FOR WORD 23
C      25          I    INTEGRATION ORDER
C      26          R    STRESS ANGLE OF ROTATION, THETA
C               OR I    COORD. SYSTEM ID (SEE SCSID ON PSHELL CARD)
C      27          I    TYPE FLAG FOR WORD 26
C      28          R    ZOFF1 (OFFSET)  OVERRIDDEN BY EST(12)
C      29 THRU 44  I/R  CID,X,Y,Z - GRIDS 1 THRU 4
C      45          R    ELEMENT TEMPERATURE
C
C
      LOGICAL         HEAT,MEMBRN,BENDNG,SHRFLX,MBCOUP,NORPTH,BADJAC,
     1                ANIS,NOCSUB,NOGO
      INTEGER         NEST(45),IEGPDT(4,4),CPMASS,FLAGS,NOUT,ELTYPE,
     1                ELID,ESTID,SIL(4),KSIL(4),KCID(4),DICT(9),
     2                IGPDT(4,4),IGPTH(4),NAM(2),MID(4),TYPE,NECPT(4),
     3                ROWFLG,NOTRAN(4),HSIL(8),HORDER(8)
      REAL            TSFACT,EPSI,EPST,EPS,GPTH(4),MATOUT,EGPDT(4,4),
     1                GSUBE,BGPDM(3,4),GPNORM(4,4),BGPDT(4,4),ADAMP,
     2                MATSET,NSM,EPNORM(4,4),KHEAT,HTCP,SINMAT,COSMAT,
     3                ECPT(4),SAVE(20)
      REAL            AMGG(1),AKGG,DGPTH(4),BMAT1(384),XYBMAT(96),ZETA,
     1                MOMINR,VOL,VOLI,TH,AREA,AREA2,DETJ,PTINT(2),
     2                EPS1,XI,ETA,ZTA,HZTA,THK,XMASSO,V(3,3),
     3                COEFF,XMTMP(16),XMASS(16),TMPMAS(9),JACOB(3,3),
     4                TMPSHP(4),TMPTHK(4),DSHPTP(8),PSITRN(9),PHI(9),
     5                SHP(4),DSHP(8),TGRID(4,4),COLSTF(144),TRANS(36),
     6                TRANS1(36),COLTMP(144),AVGTHK,TEMP
      REAL            AA,BB,CC,X31,Y31,X42,Y42,EXI,EXJ,UGPDM(3,4),
     1                CENT(3),CENTE(3),TBM(9),TEB(9),TEM(9),TUB(9),
     2                TUM(9),TEU(9),TBG(9),GGE(9),GGU(9)
      REAL            RHO,TS,TSI,REALI,RHOX,THETAM,XM,YM,U(9),A,B,
     1                ASPECT,THLEN,XA(4),YB(4),GT(9),GI(36),ENORX,ENORY,
     2                GNORX,GNORY,NUNORX,NUNORY,DSUB,DSUB4,PSIINX,
     3                PSIINY,TSMFX,TSMFY,CURVTR(3,4),CURVE(3),SINEAX,
     4                SINEAY,W1,PI,TWOPI,RADDEG,DEGRAD,HTFLX(12),DETERM,
     5                HTCAP(16),HTCON(16),DVOL,DHEAT,WEITC,BTERMS(32)
      REAL            ZC(4),UEV,ANGLEI,EDGEL,EDGSHR,UNV,VNT(3,4),ASPCTX,
     1                ASPCTY,GFOUR(10,10),DFOUR(7,7),BFOUR(240),CSUBB4,
     2                CSUBX,CSUBY,CSUBT,CSUBTX,CSUBTY,SFCTR1,SFCTR2,
     3                SFCTX1,SFCTX2,SFCTY1,SFCTY2,OFFSET,CONST
CWKBD 2/94 SPR93020      REAL            EIX,EIY,TGX,TGY
CWKBI 2/94 SPR 93020
      REAL            DNUX, DNUY
CWKBNB 11/93 SPR 93020
      REAL            VD1(3), VD2(3), VKN(3), VKS(3)
     1,               V12(3), V41(3), VP12(3),VIS(3), VJS(3)
CWKBNE 11/93 SPR 93020
      
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG / UFM,UWM,UIM,SFM
C
C     ICORE = FIRST WORD OF OPEN CORE
C     JCORE = NEXT AVAILABLE LOCATION IN OPEN CORE.
C     NCORE = CURRENT LAST AVAILABLE LOCATION IN OPEN CORE
C
      COMMON /EMGPRM/ ICORE,JCORE,NCORE,ICSTM,NCSTM,IMAT,NMAT,IHMAT,
     1                NHMAT,IDIT,NDIT,ICONG,NCONG,LCONG,ANYCON,FLAGS(3),
     2                PRECIS,ERROR,HEAT,CPMASS,LCSTM,LMAT,LHMAT,
     3                KFLAGS(3),L38
      COMMON /EMGEST/ EST(45)
      COMMON /EMGDIC/ ELTYPE,LDICT,NLOCS,ELID,ESTID
      COMMON /SYSTEM/ SYS(100)
      COMMON /MATIN / MATID,INFLAG,ELTEMP,DUMMY,SINMAT,COSMAT
      COMMON /MATOUT/ MATOUT(25)
      COMMON /HMTOUT/ KHEAT(7),TYPE
CZZ   COMMON /ZZEMGX/ AKGG(1)
      COMMON /ZZZZZZ/ AKGG(1)
      COMMON /Q4DT  / DETJ,HZTA,PSITRN,NNODE,BADJAC,N1
      COMMON /TERMS / MEMBRN,BENDNG,SHRFLX,MBCOUP,NORPTH
      COMMON /Q4COMS/ ANGLEI(4),EDGSHR(3,4),EDGEL(4),UNV(3,4),
     1                UEV(3,4),ROWFLG,IORDER(4)
      COMMON /CONDAS/ PI,TWOPI,RADDEG,DEGRAD
      COMMON /COMJAC/ XI,ETA,ZETA,DETERM,DUM2,LTYPFL
      COMMON /CJACOB/ TH,VI(3),VJ(3),VN(3)
      COMMON /TRPLM / NDOF,IBOT,IPTX1,IPTX2,IPTY1,IPTY2
      EQUIVALENCE     (SYS(01)   ,SYSBUF  ), (SYS(02) ,NOUT      ),
     1                (SYS(03)   ,NOGO    ), (SYS(55) ,IPREC     )
C     EQUIVALENCE     (SYS(48)   ,ICSUB4  ), (SYS(49) ,ICSUBB    ),
C    1                (SYS(50)   ,ICSUBT  ), (SYS(75) ,ICSUB8    )
      EQUIVALENCE     (FLAGS(1)  ,KGG1    ), (FLAGS(2),MGG1      ),
     1                (ADAMP     ,DICT(5) ), (IGPTH(1),GPTH(1)   ),
     2                (EST(1)    ,NEST(1) ), (INT     ,NEST(25)  ),
     3                (BGPDT(1,1),EST(29) ), (GPTH(1) ,EST(6)    ),
     4                (ELTH      ,EST(14) ), (SIL(1)  ,NEST(2)   ),
     5                (ZOFF      ,EST(12) ), (ZOFF1   ,EST(28)   ),
     6                (AMGG(1)   ,AKGG(1) ), (NECPT(1),ECPT(1)   ),
     7                (HTCP      ,KHEAT(4)), (HTFLX(1),TMPMAS(1) ),
     8                (HTCAP(1)  ,XMASS(1)), (HTCON(1),XMTMP(1)  ),
     9                (NSM       ,EST(19) ), (MATSET  ,MATOUT(25)),
     O                (IEGPDT(1,1),EGPDT(1,1)),
     1                (IGPDT(1,1) ,BGPDT(1,1))
      DATA    EPS1  / 1.0E-7 /
      DATA    CONST / 0.57735026918962/
      DATA    NAM   / 4HQUAD,4H4S     /
C
      ELID   = NEST(1)
      LTYPFL = 1
      OFFSET = ZOFF
      IF (ZOFF .EQ. 0.0) OFFSET = ZOFF1
C
C     CHECK FOR SUFFICIENT OPEN CORE FOR ELEMENT STIFFNESS
C
      JCORED = JCORE
      NCORED = NCORE- 1
      IF (JCORED+576.LE.NCORED .OR. HEAT .OR. KGG1.EQ.0) GO TO 10
      GO TO 1730
C
C     COPY THE SILS AND BGPDT DATA INTO SAVE ARRAY SINCE THE DATA
C     WILL BE REORDERED BASED ON INCREASING SILS.
C
   10 J = 1
      DO 15 I = 1,20
      SAVE(I) = EST(I+J)
      IF (I .EQ. 4) J = 24
   15 CONTINUE
C
      NNODE = 4
      N1    = 4
      NODESQ= NNODE*NNODE
      NDOF  = NNODE*6
      NDOF3 = NNODE*3
      ND2   = NDOF*2
      ND3   = NDOF*3
      ND4   = NDOF*4
      ND5   = NDOF*5
      ND6   = NDOF*6
      ND7   = NDOF*7
C
C     FILL IN ARRAY GGU WITH THE COORDINATES OF GRID POINTS
C     1, 2 AND 4. THIS ARRAY WILL BE USED LATER TO DEFINE
C     THE USER COORDINATE SYSTEM WHILE CALCULATING
C     TRANSFORMATIONS INVOLVING THIS COORDINATE SYSTEM.
C
      DO 20 I = 1,3
      II = (I-1)*3
      IJ = I
      IF (IJ .EQ. 3) IJ = 4
      DO 20 J = 1,3
      JJ = J + 1
   20 GGU(II+J) = BGPDT(JJ,IJ)
CWKBD 11/93 SPR93020      CALL BETRNS (TUB,GGU,0,ELID)
CWKBNB 11/93 SPR93020
C    ADD FROM SHEAR ELEMENT
C
C    COMPUTE DIAGONAL VECTORS
C
      DO 21 I = 1,3
      II=I+1
      VD1(I) = BGPDT(II,3) - BGPDT(II,1)
   21 VD2(I) = BGPDT(II,4) - BGPDT(II,2)
C
C    COMPUTE THE NORMAL VECTOR VKN, NORMALIZE, AND COMPUTE THE PROJECTED
C    AREA, PA
C
      VKN(1) = VD1(2)*VD2(3) - VD1(3)*VD2(2)
      VKN(2) = VD1(3)*VD2(1) - VD1(1)*VD2(3)
      VKN(3) = VD1(1)*VD2(2) - VD1(2)*VD2(1)
      VKL = SQRT( VKN(1)**2 + VKN(2)**2 + VKN(3)**2 )
      IF ( VKL .EQ. 0. ) WRITE( NOUT, 2070 ) NEST(1)
2070  FORMAT(//,' ILLEGAL GEOMETRY FOR QUAD4 ELEMENT, ID=',I10 )
      VKS(1) = VKN(1)/VKL
      VKS(2) = VKN(2)/VKL
      VKS(3) = VKN(3)/VKL
CWKBR 9/94      PA = VKL/2.D0           
      PA = VKL/2.0     
C
C  COMPUTE SIDES -12- AND -41-
      DO 25 I = 1,3
      II = I + 1
      V12(I) = BGPDT(II,2) - BGPDT(II,1)
      V41(I) = BGPDT(II,1) - BGPDT(II,4)
25    CONTINUE
C
C  COMPUTE DOT PRODUCT, V12DK, OR V12 AND VK, THE VECTORS VP12, VI, VJ
C
      V12DK   = V12(1)*VKS(1) + V12(2)*VKS(2) + V12(3)*VKS(3)
      VP12(1) = V12(1) - V12DK*VKS(1)
      VP12(2) = V12(2) - V12DK*VKS(2)
      VP12(3) = V12(3) - V12DK*VKS(3)
      VP12L   = SQRT( VP12(1)**2 + VP12(2)**2 + VP12(3)**2 )
      IF ( VP12L .EQ. 0. ) WRITE( NOUT, 2070 ) NEST(1)
      VIS(1) = VP12(1) / VP12L
      VIS(2) = VP12(2) / VP12L
      VIS(3) = VP12(3) / VP12L
      VJS(1) = VKS(2)*VIS(3) - VKS(3)*VIS(2)
      VJS(2) = VKS(3)*VIS(1) - VKS(1)*VIS(3)
      VJS(3) = VKS(1)*VIS(2) - VKS(2)*VIS(1)
C
C   NORMALIZE J FOR GOOD MEASURE
C
      VJL = SQRT( VJS(1)**2 + VJS(2)**2 + VJS(3)**2 )
      IF ( VJL .EQ. 0. ) WRITE ( NOUT, 2070 ) NEST(1)
      VJS(1) = VJS(1) / VJL
      VJS(2) = VJS(2) / VJL
      VJS(3) = VJS(3) / VJL
      DO 29 I = 1,3
      TUB(I)   = VIS(I)
      TUB(I+3) = VJS(I)
      TUB(I+6) = VKS(I)
29    CONTINUE
CWKBNE 11/93 SPR93020
C
C     STORE INCOMING BGPDT FOR LUMPED MASS AND ELEMENT C.S.
C
      DO 30 I = 1,3
      I1 = I + 1
      DO 30 J = 1,4
   30 BGPDM(I,J) = BGPDT(I1,J)
C
C     TRANSFORM BGPDM FROM BASIC TO USER C.S.
C
      DO 40 I = 1,3
      IP = (I-1)*3
      DO 40 J = 1,4
      UGPDM(I,J) = 0.0
      DO 40 K = 1,3
      KK = IP + K
   40 UGPDM(I,J) = UGPDM(I,J) + TUB(KK)*((BGPDM(K,J)) - GGU(K))
C
C
C     THE ORIGIN OF THE ELEMENT C.S. IS IN THE MIDDLE OF THE ELEMENT
C
      DO 50 J = 1,3
      CENT(J) = 0.0
      DO 50 I = 1,4
   50 CENT(J) = CENT(J) + UGPDM(J,I)/NNODE
C
C     STORE THE CORNER NODE DIFF. IN THE USER C.S.
C
      X31 = UGPDM(1,3) - UGPDM(1,1)
      Y31 = UGPDM(2,3) - UGPDM(2,1)
      X42 = UGPDM(1,4) - UGPDM(1,2)
      Y42 = UGPDM(2,4) - UGPDM(2,2)
      AA  = SQRT(X31*X31 + Y31*Y31)
      BB  = SQRT(X42*X42 + Y42*Y42)
      IF (AA.EQ.0.0 .OR. BB.EQ.0.0) GO TO 1700
C
C     NORMALIZE XIJ'S
C
      X31 = X31/AA
      Y31 = Y31/AA
      X42 = X42/BB
      Y42 = Y42/BB
      EXI = X31 - X42
      EXJ = Y31 - Y42
C
C     STORE GGE ARRAY, THE OFFSET BETWEEN ELEMENT C.S. AND USER C.S.
C
      GGE(1) = CENT(1)
      GGE(2) = CENT(2)
      GGE(3) = CENT(3)
C
      GGE(4) = GGE(1) + EXI
      GGE(5) = GGE(2) + EXJ
      GGE(6) = GGE(3)
C
      GGE(7) = GGE(1) - EXJ
      GGE(8) = GGE(2) + EXI
      GGE(9) = GGE(3)
C
C     THE ARRAY IORDER STORES THE ELEMENT NODE ID IN
C     INCREASING SIL ORDER.
C
C     IORDER(1) = NODE WITH LOWEST  SIL NUMBER
C     IORDER(4) = NODE WITH HIGHEST SIL NUMBER
C
C     ELEMENT NODE NUMBER IS THE INTEGER FROM THE NODE
C     LIST  G1,G2,G3,G4 .  THAT IS, THE 'I' PART
C     OF THE 'GI' AS THEY ARE LISTED ON THE CONNECTIVITY
C     BULK DATA CARD DESCRIPTION.
C
      DO 60 I = 1,4
      IORDER(I) = 0
      HORDER(I) = 0
      KSIL(I) = SIL(I)
      HSIL(I) = SIL(I)
   60 CONTINUE
C
      DO 80 I = 1,4
      ITEMP = 1
      ISIL  = KSIL(1)
      DO 70 J = 2,4
      IF (ISIL .LE. KSIL(J)) GO TO 70
      ITEMP = J
      ISIL  = KSIL(J)
   70 CONTINUE
      IORDER(I) = ITEMP
      HORDER(I) = ITEMP
      KSIL(ITEMP) = 99999999
   80 CONTINUE
C
C     ADJUST EST DATA
C
C     USE THE POINTERS IN IORDER TO COMPLETELY REORDER THE
C     GEOMETRY DATA INTO INCREASING SIL ORDER.
C     DON'T WORRY!! IORDER ALSO KEEPS TRACK OF WHICH SHAPE
C     FUNCTIONS GO WITH WHICH GEOMETRIC PARAMETERS!
C
      DO 100 I = 1,4
      KSIL(I) = SIL(I)
      TMPTHK(I) = GPTH(I)
      KCID(I) = IGPDT(1,I)
      DO 90 J = 2,4
      TGRID(J,I) = BGPDT(J,I)
   90 CONTINUE
  100 CONTINUE
      DO 120 I = 1,4
      IPOINT = IORDER(I)
      SIL(I) = KSIL(IPOINT)
      GPTH(I)= TMPTHK(IPOINT)
      IGPDT(1,I) = KCID(IPOINT)
      DO 110 J = 2,4
      BGPDT(J,I) = TGRID(J,IPOINT)
  110 CONTINUE
  120 CONTINUE
C
C     COMPUTE NODE NORMALS
C
      CALL Q4NRMS (BGPDT,GPNORM,IORDER,IFLAG)
      IF (IFLAG .EQ. 0) GO TO 130
      GO TO 1700
C
C     DETERMINE NODAL THICKNESSES
C
  130 AVGTHK = 0.0
      DO 160 I = 1,NNODE
      IORD = IORDER(I)
      DO 140 IC = 1,3
  140 CURVTR(IC,IORD) = GPNORM(IC+1,I)
C
      IF (GPTH(I) .EQ. 0.0) GPTH(I) = ELTH
      IF (NEST(13).EQ.0 .AND. ELTH.EQ.0.) GPTH(I) = 1.0E-14
      IF (GPTH(I) .GT. 0.0) GO TO 150
      WRITE (NOUT,2010) UFM,ELID
      NOGO =.TRUE.
      GO TO 1710
  150 DGPTH(I) = GPTH(I)
      AVGTHK = AVGTHK + DGPTH(I)/NNODE
  160 CONTINUE
C
C     NEST(13) = MID1 ID FOR MEMBRANE
C     NEST(15) = MID2 ID FOR BENDING
C     NEST(17) = MID3 ID FOR TRANSVERSE SHEAR
C     NEST(22) = MID4 ID FOR MEMBRANE-BENDING COUPLING
C                MID4 MUST BE BLANK UNLESS MID1 AND MID2 ARE NON-ZERO
C                MID4 ID MUST NOT EQUAL MID1 OR MID2 ID
C     (WHEN LAYER COMPOSITE IS USED, MID ID IS RAISED TO ID*100000000)
C      EST(14) = MEMBRANE THICKNESS, T
C      EST(16) = BENDING STIFFNESS PARAMETER, 12I/T**3
C      EST(18) = TRNASVERSE SHEAR  PARAMETER, TS/T
C
C     0.8333333 = 5.0/6.0
C
      MOMINR = 0.0
      TSFACT = .8333333
      NOCSUB = .FALSE.
      IF (NEST(15) .NE.  0) MOMINR = EST(16)
      IF (NEST(17) .NE.  0) TS = EST(18)
      IF ( EST(18) .EQ. 0.) TS = .8333333
C
C     FIX FOR LAMINATED COMPOSITE WITH MEMBRANE BEHAVIOUR ONLY.
C     REQUIRED TO PREVENT ZERO DIVIDE ERRORS.
C
      IF (NEST(15).EQ.0 .AND. NEST(13).GT.100000000) TS = .8333333
C
C     SET LOGICAL NOCSUB IF EITHER MOMINR OR TS ARE NOT DEFAULT
C     VALUES. THIS WILL BE USED TO OVERRIDE ALL CSUBB COMPUTATIONS.
C     I.E. DEFAULT VALUES OF UNITY ARE USED.
C
      EPSI = ABS(MOMINR - 1.0)
      EPST = ABS(TS  - TSFACT)
      EPS  = .05
C     NOCSUB = EPSI.GT.EPS .OR. EPST.GT.EPS
      IF (NEST(13) .GT. 100000000) NOCSUB = .FALSE.
C
C     THE COORDINATES OF THE ELEMENT GRID POINTS HAVE TO BE
C     TRANSFORMED FROM THE BASIC C.S. TO THE ELEMENT C.S.
C
C     SET IDENTT FLAG TO 1 IF TEB IS AN IDENTITY MATRIX
C
      CALL BETRNS (TEU,GGE,0,ELID)
      CALL GMMATS (TEU,3,3,0,TUB ,3,3,0,TEB  )
      CALL GMMATS (TUB,3,3,1,CENT,3,1,0,CENTE)
      IDENTT = 0
      IF (TEB(1).EQ.1.0 .AND. TEB(5).EQ.1.0 .AND. TEB(9).EQ.1.0 .AND.
     1    TEB(2).EQ.0.0 .AND. TEB(3).EQ.0.0 .AND. TEB(4).EQ.0.0 .AND.
     2    TEB(6).EQ.0.0 .AND. TEB(7).EQ.0.0 .AND. TEB(8).EQ.0.0
     3    ) IDENTT = 1
      IP = -3
      DO 170 II = 2,4
      IP = IP + 3
      DO 170 J = 1,NNODE
      EPNORM(II,J) = 0.0
      EGPDT(II,J)  = 0.0
      DO 170 K = 1,3
      KK = IP + K
      K1 = K + 1
      CC = BGPDT(K1,J) - GGU(K) - CENTE(K)
      EPNORM(II,J) = EPNORM(II,J) + TEB(KK)*GPNORM(K1,J)
  170 EGPDT(II,J)  = EGPDT(II,J)  + (TEB(KK)*CC)
C
C     BEGIN INITIALIZING MATERIAL VARIABLES
C
C     SET INFLAG = 12 SO THAT SUBROUTINE MAT WILL SEARCH FOR-
C     ISOTROPIC MATERIAL PROPERTIES AMONG THE MAT1 CARDS,
C     ORTHOTROPIC MATERIAL PROPERTIES AMONG THE MAT8 CARDS, AND
C     ANISOTROPIC MATERIAL PROPERTIES AMONG THE MAT2 CARDS.
C
      INFLAG = 12
      RHO    = 0.0
      ELTEMP = EST(45)
      MID(1) = NEST(13)
      MID(2) = NEST(15)
      MID(3) = NEST(17)
      MID(4) = NEST(22)
      MEMBRN = MID(1).GT.0
      BENDNG = MID(2).GT.0 .AND. MOMINR.GT.0.0
      SHRFLX = MID(3).GT.0
      MBCOUP = MID(4).GT.0
C
C     FIGURE OUT PATH OF THE TRIPLE MULTIPLY AND THE NO. OF ROWS
C     IN B-MATRIX
C
C     NORPTH = MID(1).EQ.MID(2).AND.MID(1).EQ.MID(3).AND.MID(4).EQ.0
C    1        .AND. ABS(MOMINR-1.0).LE.EPS1
      NORPTH = .FALSE.
C
C     DETERMINE FACTORS TO BE USED IN CSUBB CALCULATIONS
C
C     IF (.NOT.BENDNG) GO TO 290
      DO 210 I = 1,4
      DO 200 J = 1,NNODE
      JO = IORDER(J)
      IF (I .NE. JO) GO TO 200
      XA(I) = EGPDT(2,J)
      YB(I) = EGPDT(3,J)
      ZC(I) = EGPDT(4,J)
      VNT(1,I) = EPNORM(2,J)
      VNT(2,I) = EPNORM(3,J)
      VNT(3,I) = EPNORM(4,J)
  200 CONTINUE
  210 CONTINUE
C
      A = 0.5*ABS(XA(2)+XA(3)-XA(1)-XA(4))
      B = 0.5*ABS(YB(4)+YB(3)-YB(1)-YB(2))
      IF (A .GT. B) ASPECT = B/A
      IF (A .LE. B) ASPECT = A/B
      THLEN = AVGTHK/A
      IF (A .LT. B) THLEN = AVGTHK/B
C
C     TORSION-RELATED SHEAR CORRECTION FOR 4-NODE-
C     PRELIMINARY FACTORS
C
      ASPCTX = A/B
      ASPCTY = B/A
      CSUBB4 = 1.6
C     IF (ICSUBB .NE. 0) CSUBB4 = SYS(49)
      CSUBT  = 71.0*ASPECT*(1.60/CSUBB4)*(1.0+415.0*ASPECT*THLEN**2)
      CSUBTX = CSUBT*ASPCTX**2
      CSUBTY = CSUBT*ASPCTY**2
C
      I  = 2
      J  = 2
      JJ = 3
      SINEAX = 0.0
      SINEAY = 0.0
  220 CALL SAXB (CURVTR(1,I-1),CURVTR(1,I),CURVE)
      CC = CURVE(1)*CURVE(1) + CURVE(2)*CURVE(2) + CURVE(3)*CURVE(3)
      IF (CC .LT. EPS1) GO TO 230
      CC = 0.5*SQRT(CC)
  230 SINEAX = SINEAX + CC
      IF (I .NE. 2) GO TO 240
      I  = 4
      GO TO 220
C
  240 CALL SAXB (CURVTR(1,J),CURVTR(1,JJ),CURVE)
      CC = CURVE(1)*CURVE(1) + CURVE(2)*CURVE(2) + CURVE(3)*CURVE(3)
      IF (CC .LT. EPS1) GO TO 250
      CC = 0.5*SQRT(CC)
  250 SINEAY = SINEAY + CC
      IF (J .NE. 2) GO TO 260
      J  = 1
      JJ = 4
      GO TO 240
  260 CC = 28.0
      SINEAX =CC*SINEAX + 1.0
      SINEAY =CC*SINEAY + 1.0
      IF (SINEAX .GT. SINEAY) SINEAY = SINEAX
      IF (SINEAY .GT. SINEAX) SINEAX = SINEAY
C
C     IRREGULAR 4-NODE CODE-  GEOMETRIC VARIABLES
C
C     CALCULATE AND NORMALIZE- UNIT EDGE VECTORS,UNIT NORMAL VECTORS
C
      DO 270 I = 1,4
      J = I + 1
      IF (J .EQ. 5) J = 1
      UEV(1,I) = XA(J) - XA(I)
      UEV(2,I) = YB(J) - YB(I)
      UEV(3,I) = ZC(J) - ZC(I)
      UNV(1,I) = (VNT(1,J) + VNT(1,I))*0.50
      UNV(2,I) = (VNT(2,J) + VNT(2,I))*0.50
      UNV(3,I) = (VNT(3,J) + VNT(3,I))*0.50
      CC = UEV(1,I)**2 + UEV(2,I)**2 + UEV(3,I)**2
      IF (CC .EQ.  0.0) GO TO 1700
      IF (CC .GE. EPS1) CC = SQRT(CC)
      EDGEL(I) = CC
      UEV(1,I) = UEV(1,I)/CC
      UEV(2,I) = UEV(2,I)/CC
      UEV(3,I) = UEV(3,I)/CC
      CC = UNV(1,I)**2 + UNV(2,I)**2 + UNV(3,I)**2
      IF (CC .EQ.  0.0) GO TO 1700
      IF (CC .GE. EPS1) CC = SQRT(CC)
      UNV(1,I) = UNV(1,I)/CC
      UNV(2,I) = UNV(2,I)/CC
      UNV(3,I) = UNV(3,I)/CC
  270 CONTINUE
C
C     CALCULATE INTERNAL NODAL ANGLES
C
      DO 280 I = 1,4
      J = I - 1
      IF (J .EQ. 0) J = 4
      ANGLEI(I) =-UEV(1,I)*UEV(1,J)-UEV(2,I)*UEV(2,J)-UEV(3,I)*UEV(3,J)
      IF (ABS(ANGLEI(I)) .LT. EPS1) ANGLEI(I) = 0.0
  280 CONTINUE
C 290 CONTINUE
C
C     SET THE INTEGRATION POINTS
C
      PTINT(1)  = -CONST
      PTINT(2)  =  CONST
C     JZTA = 2
C     IF (.NOT.BENDNG) PTINTZ(1) = 0.0
C     IF (.NOT.BENDNG) JZTA = 1
      IF (HEAT) GO TO 1790
C
C     TRIPLE LOOP TO SAVE THE LAST 2 ROWS OF B-MATRIX AT 2X2X2
C     INTEGRATION POINTS FOR LATER MANIPULATION.
C
      IF (KGG1 .EQ. 0) GO TO 400
C     IF (.NOT.BENDNG) GO TO 360
      I  = 1
      KPT= 1
C
      DO 350 IXSI = 1,2
      XI = PTINT(IXSI)
C
      DO 350 IETA = 1,2
      ETA = PTINT(IETA)
C
      CALL Q4SHPS (XI,ETA,SHP,DSHP)
C
C     IRREGULAR 4-NODE CODE-  CALCULATION OF NODAL EDGE SHEARS
C                             AT THIS INTEGRATION POINT
C
      DO 310 IJ = 1,4
      II = IJ - 1
      IF (II .EQ. 0) II = 4
      IK = IJ + 1
      IF (IK .EQ. 5) IK = 1
      AA = SHP(IJ)
      BB = SHP(IK)
C
      DO 300 IS = 1,3
      EDGSHR(IS,IJ)=(UEV(IS,IJ) + ANGLEI(IJ)*UEV(IS,II))*AA/
     1              (1.0-ANGLEI(IJ)*ANGLEI(IJ))
     2             +(UEV(IS,IJ) + ANGLEI(IK)*UEV(IS,IK))*BB/
     3              (1.0-ANGLEI(IK)*ANGLEI(IK))
  300 CONTINUE
  310 CONTINUE
C
C     SORT THE SHAPE FUNCTIONS AND THEIR DERIVATIVES INTO SIL ORDER.
C
      DO 320 IS = 1,4
      TMPSHP(IS  ) =  SHP(IS  )
      DSHPTP(IS  ) = DSHP(IS  )
  320 DSHPTP(IS+4) = DSHP(IS+4)
      DO 330 IS = 1,4
      KK = IORDER(IS)
      SHP (IS  ) = TMPSHP(KK  )
      DSHP(IS  ) = DSHPTP(KK  )
  330 DSHP(IS+4) = DSHPTP(KK+4)
C
      DO 340 IZTA = 1,2
      ZTA = PTINT(IZTA)
C
C     COMPUTE THE JACOBIAN AT THIS GAUSS POINT,
C     ITS INVERSE AND ITS DETERMINANT.
C
      HZTA = ZTA/2.0
      CALL JACOBS (ELID,SHP,DSHP,DGPTH,EGPDT,EPNORM,JACOB)
      IF (BADJAC) GO TO 1710
C
C     COMPUTE PSI TRANSPOSE X JACOBIAN INVERSE.
C     HERE IS THE PLACE WHERE THE INVERSE JACOBIAN IS FLAGED TO BE
C     TRANSPOSED BECAUSE OF OPPOSITE MATRIX LOADING CONVENTION
C     BETWEEN INVER AND GMMAT.
C
      CALL GMMATS (PSITRN,3,3,0,JACOB,3,3,1,PHI)
C
C     CALL Q4BMGS TO GET B MATRIX
C     SET THE ROW FLAG TO 1. IT SIGNALS SAVING THE LAST 2 ROWS.
C
      ROWFLG = 1
      CALL Q4BMGS (DSHP,DGPTH,EGPDT,EPNORM,PHI,BMAT1(KPT))
  340 KPT = KPT + ND2
  350 CONTINUE
C
C     IN PLANE SHEAR REDUCTION
C
C     IF (.NOT.MEMBRN) GO TO 400
C 360 CONTINUE
      XI  = 0.0
      ETA = 0.0
      KPT = 1
      KPNT= ND2
C     IF (NORPTH) KPNT = NDOF
C
      CALL Q4SHPS (XI,ETA,SHP,DSHP)
C
C     SORT THE SHAPE FUNCTIONS AND THEIR DERIVATIVES INTO SIL ORDER.
C
      DO 370 I = 1,4
      TMPSHP(I  ) =  SHP(I  )
      DSHPTP(I  ) = DSHP(I  )
  370 DSHPTP(I+4) = DSHP(I+4)
      DO 380 I = 1,4
      KK = IORDER(I)
      SHP (I  ) = TMPSHP(KK  )
      DSHP(I  ) = DSHPTP(KK  )
  380 DSHP(I+4) = DSHPTP(KK+4)
C
C     DO 390 IZTA = 1,JZTA
      DO 390 IZTA = 1,2
      ZTA  = PTINT(IZTA)
      HZTA = ZTA/2.0
      CALL JACOBS (ELID,SHP,DSHP,DGPTH,EGPDT,EPNORM,JACOB)
      IF (BADJAC) GO TO 1710
C
      CALL GMMATS (PSITRN,3,3,0,JACOB,3,3,1,PHI)
C
C     CALL Q4BMGS TO GET B-MATRIX
C     SET THE ROW FLAG TO 2. IT WILL SAVE THE 3RD ROW OF B-MATRIX AT
C     THE TWO INTEGRATION POINTS.
C
      ROWFLG = 2
      CALL Q4BMGS (DSHP,DGPTH,EGPDT,EPNORM,PHI,XYBMAT(KPT))
  390 KPT = KPT + KPNT
C
C     SET THE ARRAY OF LENGTH 4 TO BE USED IN CALLING TRANSS.
C     NOTE THAT THE FIRST WORD IS THE COORDINATE SYSTEM ID WHICH
C     WILL BE SET IN POSITION LATER.
C
  400 DO 410 IEC = 2,4
  410 ECPT(IEC) = 0.0
C
C     FETCH MATERIAL PROPERTIES
C
C
C     EACH MATERIAL PROPERTY MATRIX G HAS TO BE TRANSFORMED FROM
C     THE MATERIAL COORDINATE SYSTEM TO THE ELEMENT COORDINATE
C     SYSTEM. THESE STEPS ARE TO BE FOLLOWED-
C
C     1- IF MCSID HAS BEEN SPECIFIED, SUBROUTINE TRANSS IS CALLED
C        TO CALCULATE TBM-MATRIX (MATERIAL TO BASIC TRANSFORMATION).
C        TBM-MATRIX IS THEN PREMULTIPLIED BY TEB-MATRIX TO OBTAIN
C        TEM-MATRIX.
C        THEN USING THE PROJECTION OF X-AXIS, AN ANGLE IS CALCULATED
C        UPON WHICH STEP 2 IS TAKEN.
C
C     2- IF THETAM HAS BEEN SPECIFIED, SUBROUTINE ANGTRS IS CALLED
C        TO CALCULATE TEM-MATRIX (MATERIAL TO ELEMENT TRANSFORMATION).
C
C                         T
C     3-           G  =  U   G   U
C                   E         M
C
C
      IF (NEST(11) .EQ. 0) GO TO 470
      MCSID = NEST(10)
C
C     CALCULATE TEM-MATRIX USING MCSID
C
  420 IF (MCSID .GT. 0) GO TO 440
      DO 430 I = 1,9
  430 TEM(I) = TEB(I)
      GO TO 450
  440 NECPT(1) = MCSID
      CALL TRANSS (ECPT,TBM)
C
C     MULTIPLY TEB AND TBM MATRICES
C
      CALL GMMATS (TEB,3,3,0,TBM,3,3,0,TEM)
C
C     CALCULATE THETAM FROM THE PROJECTION OF THE X-AXIS OF THE
C     MATERIAL C.S. ON TO THE XY PLANE OF THE ELEMENT C.S.
C
  450 CONTINUE
      XM = TEM(1)
      YM = TEM(4)
      IF (ABS(XM).GT.EPS1 .OR. ABS(YM).GT.EPS1) GO TO 460
      NEST(2) = MCSID
      J = 231
      GO TO 1720
  460 THETAM = ATAN2(YM,XM)
      GO TO 480
C
C     CALCULATE TEM-MATRIX USING THETAM
C
  470 THETAM = EST(10)*DEGRAD
      IF (THETAM .EQ. 0.0) GO TO 490
  480 CALL ANGTRS (THETAM,1,TUM)
      CALL GMMATS (TEU,3,3,0,TUM,3,3,0,TEM)
      GO TO 510
C
C     DEFAULT IS CHOSEN, LOOK FOR VALUES OF MCSID AND/OR THETAM
C     ON THE PSHELL CARD.
C
  490 IF (NEST(24) .EQ. 0) GO TO 500
      MCSID = NEST(23)
      GO TO 420
C
  500 THETAM = EST(23)*DEGRAD
      GO TO 480
C
  510 CONTINUE
      IF (HEAT) GO TO 1810
C
      DO 600 M = 1,36
  600 GI(M)  = 0.0
      SINMAT = 0.0
      COSMAT = 0.0
      IGOBK  = 0
C
C     BEGIN M-LOOP TO FETCH PROPERTIES FOR EACH MATERIAL ID
C
      M = 0
  610 M = M + 1
      IF (M .GT. 4) GO TO 790
      IF (M.EQ.4 .AND. IGOBK.EQ.1) GO TO 800
      MATID = MID(M)
      IF (MATID.EQ.0 .AND. M.NE.3) GO TO 610
      IF (MATID.EQ.0 .AND. M.EQ.3 .AND. .NOT.BENDNG) GO TO 610
      IF (MATID.EQ.0 .AND. M.EQ.3 .AND. BENDNG) MATID = MID(2)
C
      IF (M-1) 640,630,620
  620 IF (MATID.EQ.MID(M-1) .AND. IGOBK.EQ.0) GO TO 640
  630 CALL MAT (ELID)
  640 CONTINUE
C
      IF (MEMBRN .AND. M.EQ.1) RHO=MATOUT(7)
      RHOX = RHO
      IF (RHO .EQ. 0.0) RHOX = 1.0
      IF (KGG1 .EQ.  0) GO TO 610
C
      IF (MEMBRN .AND. M.NE.1 .OR. .NOT.MEMBRN .AND. M.NE.2) GO TO 650
      GSUBE = MATOUT(12)
      IF (MATSET .EQ. 8.) GSUBE = MATOUT(16)
  650 CONTINUE
C
      IF (M.EQ.2 .AND. NORPTH) GO TO 670
      COEFF  = 1.0
      LPOINT = (M-1)*9 + 1
C
      CALL Q4GMGS (M,COEFF,GI(LPOINT))
C
CWKBDB 11/93 SPR93020
C      IF (M .GT. 0) GO TO 670
C      IF (.NOT.SHRFLX .AND. BENDNG) GO TO 660
C      NEST(2) = MATID
C      J = 232
C      GO TO 1720
C
C  660 M = -M
C 11/93 ALREADY DELETED 670 IF (.NOT.BENDNG) GO TO 760
C  670 CONTINUE
C      MTYPE = IFIX(MATSET+.05) - 2
C      IF (NOCSUB) GO TO 760
C      GO TO (760,680,720,760), M
C
C  680 IF (MTYPE) 690,700,710
C  690 ENORX = MATOUT(16)
C      ENORY = MATOUT(16)
C      GO TO 760
C  700 ENORX = MATOUT(1)
C      ENORY = MATOUT(4)
C      GO TO 760
C  710 ENORX = MATOUT(1)
C      ENORY = MATOUT(3)
C      GO TO 760
C
C  720 IF (MTYPE) 730,740,750
C  730 GNORX = MATOUT(6)
C      GNORY = MATOUT(6)
C      GO TO 760
C
C  740 GNORX = MATOUT(1)
C      GNORY = MATOUT(4)
C      GO TO 760
C
C  750 GNORX = MATOUT(6)
C      GNORY = MATOUT(5)
C      IF (GNORX .EQ. 0.0) GNORX = MATOUT(4)
C      IF (GNORY .EQ. 0.0) GNORY = MATOUT(4)
C  760 CONTINUE
CWKBDE 11/93 SPR93020
C
C
C     IF (MATSET .EQ. 1.0) GO TO 610
      IF (M .EQ. 3) GO TO 770
      U(1) = TEM(1)*TEM(1)
      U(2) = TEM(4)*TEM(4)
      U(3) = TEM(1)*TEM(4)
      U(4) = TEM(2)*TEM(2)
      U(5) = TEM(5)*TEM(5)
      U(6) = TEM(2)*TEM(5)
      U(7) = TEM(1)*TEM(2)*2.0
      U(8) = TEM(4)*TEM(5)*2.0
      U(9) = TEM(1)*TEM(5) + TEM(2)*TEM(4)
      L = 3
      GO TO 780
C
  770 U(1) = TEM(5)*TEM(9) + TEM(6)*TEM(8)
      U(2) = TEM(2)*TEM(9) + TEM(8)*TEM(3)
      U(3) = TEM(4)*TEM(9) + TEM(7)*TEM(6)
      U(4) = TEM(1)*TEM(9) + TEM(3)*TEM(7)
      L=2
C
  780 CALL GMMATS (U(1),L,L,1,GI(LPOINT),L,L,0,GT(1))
      CALL GMMATS (GT(1),L,L,0,U(1),L,L,0,GI(LPOINT))
CWKBNB 11/93 SPR93020
      IF (M .GT. 0) GO TO 670
      IF (.NOT.SHRFLX .AND. BENDNG) GO TO 660
      NEST(2) = MATID
      J = 232
      GO TO 1720
  660 M = -M
  670 CONTINUE
      MTYPE = IFIX(MATSET+.05) - 2
      IF (NOCSUB) GO TO 760
      GO TO (760,680,720,760), M
CWKBNE 11/93 SPR93020
CWKBNB 2/94 SPR93020
  680 IF ( MTYPE ) 690, 700, 710
  690 ENORX = MATOUT(16)
      ENORY = MATOUT(16)
      DNUX  = GI( LPOINT+1 ) / GI( LPOINT )
      DNUY  = GI( LPOINT+3 ) / GI( LPOINT+4 )
      GO TO 760
  700 ENORX = MATOUT(1)
      ENORY = MATOUT(4)
      DNUX  = GI( LPOINT+1 ) / GI( LPOINT )
      DNUY  = GI( LPOINT+3 ) / GI( LPOINT+4 )
      GO TO 760
  710 ENORX = MATOUT(1)
      ENORY = MATOUT(3)
      DNUX  = GI( LPOINT+1 ) / GI( LPOINT )
      DNUY  = GI( LPOINT+3 ) / GI( LPOINT+4 )
      GO TO 760
  720 IF ( MTYPE ) 730, 740, 750
  730 GNORX = MATOUT(6)
      GNORY = MATOUT(6)
      GO TO 760
  740 GNORX = MATOUT(1)
      GNORY = MATOUT(4)
      GO TO 760
  750 GNORX = MATOUT(6)
      GNORY = MATOUT(5)
CWKBDB 9/94
C      IF ( GNORX .EQ. 0.0D0 ) GNORX = MATOUT(4)
C      IF ( GNORY .EQ. 0.0D0 ) GNORY = MATOUT(4)
CWKBDE 9/94      
CWKBNB 9/94
      IF ( GNORX .EQ. 0.0 ) GNORX = MATOUT(4)
      IF ( GNORY .EQ. 0.0 ) GNORY = MATOUT(4)
CWKBNE 9/94  
  760 CONTINUE
CWKBNE 2/94 SPR93020
      GO TO 610
C
C     END OF M-LOOP
C
  790 CONTINUE
      IF (MID(3) .LT. 100000000) GO TO 800
      IF (GI(19).NE.0.0 .OR. GI(20).NE.0.0 .OR. GI(21).NE.0.0 .OR.
     1    GI(22).NE.0.0) GO TO 800
      IGOBK = 1
      M = 2
      MID(3) = MID(2)
      GO TO 610
  800 CONTINUE
C
      NOCSUB = ENORX.EQ.0.0 .OR. ENORY.EQ.0.0 .OR.
     1         GNORX.EQ.0.0 .OR. GNORY.EQ.0.0 .OR.
     2         MOMINR.EQ.0.0
C
      MATTYP = IFIX(MATSET+.05)
C
C     IF MGG1 IS NON-ZERO AND RHO IS GREATER THAN 0.0,
C     THEN COMPUTE THE MASS MATRIX.
C
      IF (MGG1 .EQ. 0) GO TO 810
      IF (JCORED+144 .LE. NCORED) GO TO 810
      GO TO 1730
  810 CONTINUE
C
      LIMIT = JCORED + NDOF*NDOF
      DO 820 I = JCORED,LIMIT
  820 AKGG(I)  = 0.0
      DO 830 I = 1,NODESQ
      XMASS(I) = 0.0
  830 XMTMP(I) = 0.0
      AREA = 0.0
      VOL  = 0.0
C
C
C     HERE BEGINS THE TRIPLE LOOP ON STATEMENTS 1310 AND 1300 TO
C     GAUSS INTEGRATE FOR THE ELEMENT MASS AND STIFFNESS MATRICES.
C     -----------------------------------------------------------
C
      DO 1310 IXSI = 1,2
      XI = PTINT(IXSI)
      DO 1310 IETA = 1,2
      ETA = PTINT(IETA)
      CALL Q4SHPS (XI,ETA,SHP,DSHP)
C
C     SORT THE SHAPE FUNCTIONS AND THEIR DERIVATIVES INTO SIL ORDER.
C
      DO 900 I = 1,4
      TMPSHP(I  ) =  SHP(I  )
      DSHPTP(I  ) = DSHP(I  )
  900 DSHPTP(I+4) = DSHP(I+4)
      DO 910 I = 1,4
      KK = IORDER(I)
      SHP (I  ) = TMPSHP(KK  )
      DSHP(I  ) = DSHPTP(KK  )
  910 DSHP(I+4) = DSHPTP(KK+4)
      CALL GMMATS (SHP,1,NNODE,0,DGPTH,1,NNODE,1,THK)
      REALI = MOMINR*THK*THK*THK/12.0
C     REALI =        THK*THK*THK/12.0
      TSI   = TS*THK
C
C     SKIP MASS CALCULATIONS IF NOT REQUESTED
C
      IF (NSM  .NE. 0.) GO TO 920
      IF (MGG1 .EQ. 0 ) GO TO 1020
      IF (RHO  .EQ. 0.) GO TO 1020
      IF (RHO  .GT. 0.) GO TO 920
      WRITE (NOUT,2030) UWM,RHO,MID(1),NEST(1)
C     NOGO =.TRUE.
C     GO TO 1710
  920 CONTINUE
C
C     COMPUTE S AND T VECTORS AT THE MID-SURFACE
C     FOR MASS CALCULATIONS ONLY.
C
      DO 930 I = 1,2
      IPOINT = 4*(I-1)
      DO 930 J = 1,3
      V(I,J) = 0.0
      DO 930 K = 1,NNODE
      KTEMP = K + IPOINT
      JTEMP = J + 1
      V(I,J)= V(I,J) + DSHP(KTEMP)*BGPDT(JTEMP,K)
  930 CONTINUE
C
C     COMPUTE S CROSS T AT THE MID-SURFACE FOR MASS CALCULATIONS.
C
      V(3,1) = V(1,2)*V(2,3) - V(2,2)*V(1,3)
      V(3,2) = V(1,3)*V(2,1) - V(2,3)*V(1,1)
      V(3,3) = V(1,1)*V(2,2) - V(2,1)*V(1,2)
      AREA2  = V(3,1)*V(3,1) + V(3,2)*V(3,2) + V(3,3)*V(3,3)
C
C     AREA2 = NORM OF S CROSS T IS THE AREA OF THE ELEMENT
C     AS COMPUTED AT THIS GAUSS POINT.
C
CWKBR spr 93015  IF (AREA2 .LT. EPS1) GO TO 1700
      IF ( AREA2 .LE. 0.0 ) GO TO 1700
C
      AREA2 = SQRT(AREA2)
      AREA  = AREA + AREA2
      VOLI  = AREA2*THK
      VOL   = VOL + VOLI
C
      IF (MGG1   .EQ. 0) GO TO 1020
      IF (CPMASS .GT. 0) GO TO 1000
      I4 = 1
      DO 960 J4 = 1,NNODE
      XMASS(I4) = XMASS(I4) + VOLI*RHOX*SHP(J4)
  960 I4 = I4 + NNODE + 1
      GO TO 1020
C
C     COMPUTE CONSISTENT MASS MATRIX
C
C     COMPUTE THE CONTRIBUTION TO THE MASS MATRIX
C     FROM THIS INTEGRATION POINT.
C
 1000 CALL GMMATS (SHP,1,NNODE,1,SHP,1,NNODE,0,XMTMP)
C
C     ADD MASS CONTRIBUTION FROM THIS INTEGRATION POINT
C     TO THE ELEMENT MASS MATRIX.
C
      DO 1010 I = 1,NODESQ
 1010 XMASS(I) = XMASS(I) + VOLI*RHOX*XMTMP(I)
C
 1020 IF (KGG1 .EQ. 0) GO TO 1330
C
C     BEGIN STIFFNESS COMPUTATIONS
C
C     SET DEFAULT VALUES OF CSUBB FACTORS
C
      SFCTY1 = 1.0
      SFCTY2 = 1.0
      SFCTX1 = 1.0
      SFCTX2 = 1.0
      TSMFX  = 1.0
      TSMFY  = 1.0
      IF (NOCSUB) GO TO 1090
      IF (.NOT.BENDNG) GO TO 1090
C      NUNORX = MOMINR*ENORX/(2.0*GNORX) - 1.0
C      NUNORY = MOMINR*ENORY/(2.0*GNORY) - 1.0
CWKBNB 2/94 SPR93020
      NUNORX = MOMINR*ENORX/(2.0*GNORX) - 1.0
      NUNORY = MOMINR*ENORY/(2.0*GNORY) - 1.0
CWKBNE 2/94 SPR93020
C
C     NOTE- THE ABOVE EXPRESSIONS FOR NUNORX AND NUNORY WERE MODIFIED
C           BY G.CHAN/UNISYS    1988
C
CWKBDB 2/94 SPR93020
C      EIX = MOMINR*ENORX
C      EIY = MOMINR*ENORY
C      TGX = 2.0*GNORX
C      TGY = 2.0*GNORY
C      NUNORX = EIX/TGX - 1.0
C      NUNORY = EIY/TGY - 1.0
C      IF (EIX .GT. TGX) NUNORX = 1.0 - TGX/EIX
C      IF (EIY .GT. TGY) NUNORY = 1.0 - TGY/EIY
CWKBDE 2/94 SPR93020
      IF (NUNORX .GT. 0.999999) NUNORX = 0.999999
      IF (NUNORY .GT. 0.999999) NUNORY = 0.999999
CWKBNB 2/94 SPR93020
      IF ( NUNORX .LE. 0. ) NUNORX = DNUX
      IF ( NUNORY .LE. 0. ) NUNORY = DNUY
CWKBNE 2/94 SPR93020
C     IF (NUNORX .GT. .49) NUNORX = 0.49
C     IF (NUNORY .GT. .49) NUNORY = 0.49
      CC = ASPECT
C
C     NOTE- THE FOLLOWING 2 FORMULATIONS WERE PUT IN ON 4/30/85 IN
C           CONJUNCTION WITH THE OUT-OF-PLANE SHEAR CORRECTION A LA
C           HUGHES. THE FLEXIBLE SOLUTION PROVIDES MORE ACCURATE
C           RESULTS FOR PLATES, ALTHOUGH IT MIGHT CONVERGE SLOWLY.
C           THE STIFFER SOLUTION (COMMENTED OUT) IS O.K. FOR PLATES
C           AND SHOULD HAVE A BETTER CONVERGENCE.
C
C           THEY WERE MODIFIED ON 5/3/85
C
C
C     4-NODE CSUBB FORMULATION AS OF 5/3/85 (FLEXIBLE SOLUTION)
C     REPLACES THE ONE COMMENTED OUT IMMEDIATELY ABOVE
C
      W1 = 1.0 + 4400.0*THLEN*THLEN*THLEN*THLEN
      IF (CC .LT. 0.2) GO TO 1030
      DSUB4 = (18.375-11.875*CC)*W1
      GO TO 1040
 1030 DSUB4 = (159.85*CC-15.97)*W1
C
C     4-NODE CSUBB FORMULATION AS OF 5/3/85 (STIFFER SOLUTION)
C
C     W1 = 1.0 + 2.5*THLEN + 1.04*THLEN**5
C     IF (CC .LT. 0.2) GO TO 1030
C     DSUB4 = 18.0*W1
C     GO TO 1040
C1030 DSUB4 = (179.85*CC-17.97)*W1
 1040 IF (DSUB4 .LT.   0.01) DSUB4 = 0.01
      IF (DSUB4 .GT. 2000.0) DSUB4 = 2000.0
      DSUB  = DSUB4
      COEFT = CONST
      AX    = A
      IF (ETA .LT. 0.0) AX = A + COEFT*(XA(2)-XA(1)-A)
      IF (ETA .GT. 0.0) AX = A + COEFT*(XA(3)-XA(4)-A)
      PSIINX = 20.0*DSUB*REALI*SINEAX*(1.0+ASPECT*ASPECT)/
     1         (TSI*(1.0-NUNORX)*AX*AX)
      DSUB  = DSUB4
      COEFT = CONST
      BY    = B
      IF (XI .LT. 0.0) BY = B + COEFT*(YB(4)-YB(1)-B)
      IF (XI .GT. 0.0) BY = B + COEFT*(YB(3)-YB(2)-B)
      PSIINY = 20.0*DSUB*REALI*SINEAY*(1.0+ASPECT*ASPECT)/
     1         (TSI*(1.0-NUNORY)*BY*BY)
      IF (.NOT.SHRFLX) GO TO 1050
      TSMFX = PSIINX/(1.0+PSIINX)
      TSMFY = PSIINY/(1.0+PSIINY)
      GO TO 1060
 1050 TSMFX = PSIINX
      TSMFY = PSIINY
      GO TO 1060
C
 1060 CONTINUE
      IF (TSMFX .LE. 0.0) TSMFX = EPS1
      IF (TSMFY .LE. 0.0) TSMFY = EPS1
C
C     FILL IN THE 7X7 MATERIAL PROPERTY MATRIX D FOR NORPTH
C
      IF (.NOT.NORPTH) GO TO 1090
      DO 1070 IG = 1,7
      DO 1070 JG = 1,7
 1070 DFOUR(IG,JG) = 0.0
C
      DO 1080 IG = 1,3
      IG1 = (IG-1)*3
      DO 1080 JG = 1,3
      JG1 = JG + IG1
 1080 DFOUR(IG,JG) = GI(JG1)
      GO TO 1150
C
C     FILL IN THE 10X10 G-MATRIX WHEN MID4 IS NOT PRESENT
C
 1090 DO 1100 IG = 1,10
      DO 1100 JG = 1,10
 1100 GFOUR(IG,JG) = 0.0
      IF (MBCOUP) GO TO 1150
C
      IF (.NOT.MEMBRN) GO TO 1120
      DO 1110 IG = 1,3
      IG1 = (IG-1)*3
      DO 1110 JG = 1,3
      JG1 = JG + IG1
 1110 GFOUR(IG,JG) = GI(JG1)
C
 1120 IF (.NOT.BENDNG) GO TO 1250
      DO 1130 IG = 4,6
      IG2 = (IG-2)*3
      DO 1130 JG = 4,6
      JG2 = JG + IG2
 1130 GFOUR(IG,JG) = GI(JG2)*MOMINR
C
      IF (.NOT.MEMBRN) GO TO 1150
      DO 1140 IG = 1,3
      IG1 = (IG-1)*3
      KG  = IG + 3
      DO 1140 JG = 1,3
      JG1 = JG + IG1
      LG  = JG + 3
      GFOUR(IG,LG) = GI(JG1)
 1140 GFOUR(KG,JG) = GI(JG1)
 1150 CONTINUE
C
C     IRREGULAR 4-NODE CODE-  CALCULATION OF NODAL EDGE SHEARS
C                             AT THIS INTEGRATION POINT
C
      DO 1210 IJ = 1,4
      II = IJ - 1
      IF (II .EQ. 0) II = 4
      IK = IJ + 1
      IF (IK .EQ. 5) IK = 1
C
      DO 1160 IR = 1,4
      IF (IJ .NE. IORDER(IR)) GO TO 1160
      IOJ = IR
      GO TO 1170
 1160 CONTINUE
 1170 DO 1180 IR = 1,4
      IF (IK .NE. IORDER(IR)) GO TO 1180
      IOK = IR
      GO TO 1190
 1180 CONTINUE
 1190 AA = SHP(IOJ)
      BB = SHP(IOK)
C
      DO 1200 IS = 1,3
      EDGSHR(IS,IJ) = (UEV(IS,IJ)+ANGLEI(IJ)*UEV(IS,II))*AA/
     1                (1.0-ANGLEI(IJ)*ANGLEI(IJ))
     2              + (UEV(IS,IJ)+ANGLEI(IK)*UEV(IS,IK))*BB/
     3                (1.0-ANGLEI(IK)*ANGLEI(IK))
 1200 CONTINUE
 1210 CONTINUE
C
C     TORSION-RELATED SHEAR CORRECTION FOR 4-NODE-
C     SET-UP OF EXPANDED SHEAR MATERIAL PROPERTY MATRICES (G OR D)
C
      CSUBX  = 20.0*REALI/(TSI*(1.0-NUNORX)*A*A)
      CSUBY  = 20.0*REALI/(TSI*(1.0-NUNORY)*B*B)
      SFCTR1 = CSUBB4*CSUBX
      SFCTR2 = CSUBTX*CSUBX
      IF (.NOT.SHRFLX) GO TO 1220
      SFCTR1 = SFCTR1/(1.0+SFCTR1)
      SFCTR2 = SFCTR2/(1.0+SFCTR2)
 1220 CONTINUE
      SFCTX1 = SFCTR1 + SFCTR2
      SFCTX2 = SFCTR1 - SFCTR2
      SFCTR1 = CSUBB4*CSUBY
      SFCTR2 = CSUBTY*CSUBY
      IF (.NOT.SHRFLX) GO TO 1230
      SFCTR1 = SFCTR1/(1.0+SFCTR1)
      SFCTR2 = SFCTR2/(1.0+SFCTR2)
 1230 CONTINUE
      SFCTY1 = SFCTR1 + SFCTR2
      SFCTY2 = SFCTR1 - SFCTR2
C
C     FILL IN THE EXPANDED MATERIAL PROPERTY MATRIX
C
      IF (NORPTH) GO TO 1240
      GFOUR( 7, 7) = 0.25*SFCTY1*TS*GI(19)
      GFOUR( 8, 8) = 0.25*SFCTY1*TS*GI(19)
      GFOUR( 8, 7) = 0.25*SFCTY2*TS*GI(19)
      GFOUR( 7, 8) = GFOUR(8,7)
      GFOUR( 9, 9) = 0.25*SFCTX1*TS*GI(22)
      GFOUR(10,10) = 0.25*SFCTX1*TS*GI(22)
      GFOUR(10, 9) = 0.25*SFCTX2*TS*GI(22)
      GFOUR( 9,10) = GFOUR(10,9)
      GFOUR( 7, 9) = SQRT(TSMFX*TSMFY)*TS*GI(20)
      GFOUR( 9, 7) = GFOUR(7,9)
      GO TO 1250
C
 1240 DFOUR(4,4) = 0.25*SFCTY1*TS*GI(19)
      DFOUR(5,5) = 0.25*SFCTY1*TS*GI(19)
      DFOUR(5,4) = 0.25*SFCTY2*TS*GI(19)
      DFOUR(4,5) = DFOUR(5,4)
      DFOUR(6,6) = 0.25*SFCTX1*TS*GI(22)
      DFOUR(7,7) = 0.25*SFCTX1*TS*GI(22)
      DFOUR(7,6) = 0.25*SFCTX2*TS*GI(22)
      DFOUR(6,7) = DFOUR(7,6)
      DFOUR(4,6) = SQRT(TSMFX*TSMFY)*TS*GI(20)
      DFOUR(6,4) = DFOUR(4,6)
 1250 CONTINUE
C
C     DO 1300 IZTA = 1,JZTA
      DO 1300 IZTA = 1,2
      ZTA  = PTINT(IZTA)
      IBOT = (IZTA-1)*ND2
C
      HZTA = ZTA/2.0
C
C     TORSION-RELATED SHEAR CORRECTION FOR 4-NODE-
C     SET-UP OF POINTERS TO THE SAVED B-MATRIX
C
      IPTX1 = ((IXSI-1)*2+IETA-1)*2*ND2 + IBOT
      IPTX2 = ((IXSI-1)*2+2-IETA)*2*ND2 + IBOT
      IPTY1 = ((IXSI-1)*2+IETA-1)*2*ND2 + IBOT
      IPTY2 = ((2-IXSI)*2+IETA-1)*2*ND2 + IBOT
C     IF (NORPTH) IBOT = IBOT/2
C
C     FILL IN THE 10X10 G-MATRIX IF MID4 IS PRESENT
C
      IF (.NOT.MBCOUP) GO TO 1290
      DO 1260 IG = 1,3
      IG1 = (IG-1)*3
      DO 1260 JG = 1,3
      JG1 = JG  + IG1
      JG4 = JG1 + 27
 1260 GFOUR(IG,JG) = GI(JG1)
C
      DO 1270 IG = 4,6
      IG2 = (IG-2)*3
      DO 1270 JG = 4,6
      JG2 = JG  + IG2
      JG4 = JG2 + 18
 1270 GFOUR(IG,JG) = GI(JG2)*MOMINR
C
      DO 1280 IG = 1,3
      IG4 = (IG+8)*3
      KG  = IG + 3
      DO 1280 JG = 1,3
      JG4 = JG  + IG4
      JG1 = JG4 - 27
      LG  = JG  + 3
      GFOUR(IG,LG) =-GI(JG4)*ZTA*6.0+GI(JG1)
 1280 GFOUR(KG,JG) =-GI(JG4)*ZTA*6.0+GI(JG1)
 1290 CONTINUE
C
C     COMPUTE THE JACOBIAN AT THIS GAUSS POINT,
C     ITS INVERSE AND ITS DETERMINANT.
C
      CALL JACOBS (ELID,SHP,DSHP,DGPTH,EGPDT,EPNORM,JACOB)
      IF (BADJAC) GO TO 1710
C
C     COMPUTE PSI TRANSPOSE X JACOBIAN INVERSE.
C     HERE IS THE PLACE WHERE THE INVERSE JACOBIAN IS FLAGED TO BE
C     TRANSPOSED BECAUSE OF OPPOSITE MATRIX LOADING CONVENTION
C     BETWEEN INVER AND GMMAT.
C
      CALL GMMATS (PSITRN,3,3,0,JACOB,3,3,1,PHI)
C
C     CALL Q4BMGS TO GET B-MATRIX.  SET THE ROW FLAG TO 3.
C     IT WILL RETURN THE FIRST 6 ROWS OF B-MATRIX.
C
      ROWFLG = 3
      CALL Q4BMGS (DSHP,DGPTH,EGPDT,EPNORM,PHI,BFOUR(1))
C
C     SET-UP OF B-MATRIX AND TRIPLE MULTIPLY
C
      CALL TRPLMS (GFOUR,DFOUR,BFOUR,BMAT1,XYBMAT,MATTYP,JCORED,DETJ)
 1300 CONTINUE
 1310 CONTINUE
C
C     EQUALIZE THE OFF-DIAGONAL TERMS TO GUARANTEE PERFECT SYMMETRIC
C     MATRIX IF NO DAMPING INVOLVED
C
      IF (GSUBE .NE. 0.0) GO TO 1330
      IJ = JCORED - 1
      NDOFM1 = NDOF - 1
      DO 1320 II = 1,NDOFM1
      IP1 = II + 1
      IM1 =(II-1)*NDOF + IJ
      DO 1320 JJ = IP1,NDOF
      I = IM1 + JJ
      J = (JJ-1)*NDOF + II + IJ
      TEMP = (AKGG(I) + AKGG(J))*.5
      IF (ABS(TEMP) .LT. 1.0E-17) TEMP = 0.0
      AKGG(I) = TEMP
      AKGG(J) = TEMP
 1320 CONTINUE
C
C     END OF STIFFNESS LOOP
C
C     ADD NON-STRUCTURAL MASS
C
 1330 CONTINUE
      IF (MGG1 .EQ. 0) GO TO 1410
      IF (RHO.EQ.0.0 .AND. NSM.EQ.0.0) GO TO 1410
C     IF (CPMASS .GT. 0) GO TO 1410
      IF (NSM  .EQ. 0.0) GO TO 1410
      IF (VOL.EQ.0. .OR. RHOX.EQ.0.) WRITE (NOUT,2060) SFM,ELID,AREA,
     1                               VOL,RHOX,MGG1,KGG1
      FACTOR = (VOL*RHO+NSM*AREA)/(VOL*RHOX)
      DO 1400 I = 1,NODESQ
 1400 XMASS(I) = XMASS(I)*FACTOR
 1410 CONTINUE
C
C     PICK UP THE GLOBAL TO BASIC TRANSFORMATIONS FROM THE CSTM.
C
      DO 1412 I = 1,36
 1412 TRANS(I) = 0.0
C     DO 1414 I = 2,8
C1414 TRANS1(I) = 0.0
C     TRANS1(1) = 1.0
C     TRANS1(5) = 1.0
C     TRANS1(9) = 1.0
C
      DO 1450 I = 1,NNODE
      NOTRAN(I) = 0
      IPOINT = 9*(I-1) + 1
      IF (IGPDT(1,I) .LE. 0) GO TO 1420
      IGPTH(1) = IGPDT(1,I)
      GPTH(2)  = BGPDT(2,I)
      GPTH(3)  = BGPDT(3,I)
      GPTH(4)  = BGPDT(4,I)
C
C     NOTE THAT THE 6X6 TRANSFORMATION WHICH WILL BE USED LATER
C     IN THE TRIPLE MULTIPLICATION TO TRANSFORM THE ELEMENT
C     STIFFNESS MATRIX FROM BASIC TO GLOBAL COORDINATES, IS BUILT
C     UPON THE 3X3 TRANSFORMATION FROM GLOBAL TO BASIC TBG-MATRIX.
C     THIS IS DUE TO THE DIFFERENCE IN TRANSFORMATION OF ARRAYS
C     AND MATRICES.
C
      CALL TRANSS (GPTH,TBG)
      CALL GMMATS (TEB,3,3,0,TBG,3,3,0,TRANS(IPOINT))
      GO TO 1450
C
 1420 IF (IDENTT.NE.1 .OR. OFFSET.NE.0.0) GO TO 1430
      NOTRAN(I) = 1
      GO TO 1450
C
 1430 DO 1440 J = 1,9
 1440 TRANS(IPOINT+J-1) = TEB(J)
 1450 CONTINUE
C
C
C     HERE WE SHIP OUT THE STIFFNESS AND DAMPING MATRICES.
C     ---------------------------------------------------
C
      IF (KGG1 .EQ. 0) GO TO 1600
C
C     SET UP I-LOOP TO DUMP OUT BASIC TO GLOBAL TRANSFORMED, NODAL
C     PARTITIONED (6 D.O.F. PER NODE) COLUMNS OF THE ELEMENT STIFFNESS.
C
C     THIS MEANS WE ARE SENDING TO EMGOUT 6 COLUMNS OF THE ELEMENT
C     STIFFNESS MATRIX AT TIME.  EACH BUNCH OF 6 COLUMNS CORRESPOND
C     TO ONE PARTICULAR NODE OF THE ELEMENT. FOR THE MASS MATRIX, WE
C     ONLY SEND 3 COLUMNS PER NODE TO EMGOUT SINCE THE OTHER 3 D.O.F.
C     ARE ZERO ANYWAY.  THE CODE WORD (DICT(4)) TELLS EMGOUT WHICH
C     COLUMNS ARE THE NON ZERO ONES THAT WE ARE SENDING. (SEE SECTION
C     6.8.3.5.1 OF THE PROGRAMMER MANUAL)
C
C
      DICT(1) = ESTID
      DICT(2) = 1
      DICT(3) = NDOF
      DICT(4) = 63
      NPART   = NDOF*6
      DO 1560 I = 1,NNODE
      IBEGIN = 6*(I-1) + JCORED - 1
C
C     DUMP AN UNTRANSFORMED NODAL COLUMN PARTITION.
C
      DO 1500 J = 1,NDOF
      KPOINT = NDOF*(J-1) + IBEGIN
      LPOINT = 6*(J-1)
      DO 1500 K = 1,6
 1500 COLSTF(LPOINT+K) = AKGG(KPOINT+K)
      IF (NOTRAN(I) .EQ. 1) GO TO 1515
C
C     THIS COLUMN PARTITION NEEDS TO BE TRANSFORMED TO GLOBAL
C     COORDINATES. (SEE PAGE 2.3-43 OF THE PROGRAMMER)
C
C     LOAD THE 6X6 TRANSFORMATION
C
      CALL TLDRS (OFFSET,I,TRANS,TRANS1)
C
C     TRANSFORM THE NODAL COLUMN PARTITION.
C
      CALL GMMATS (COLSTF,NDOF,6,0,TRANS1,6,6,0,COLTMP)
      DO 1510 II = 1,NPART
 1510 COLSTF(II) = COLTMP(II)
C
C     NOW TRANSFORM THE ROWS OF THIS PARTITION.
C
 1515 DO 1530 M = 1,NNODE
      IF (NOTRAN(M) .EQ. 1) GO TO 1530
      MPOINT = 36*(M-1) + 1
C
C     LOAD THE 6X6 TRANSFORMATION
C
      CALL TLDRS (OFFSET,M,TRANS,TRANS1)
C
C     TRANSFORM THE 6 ROWS FOR THIS SUBPARTITION
C
      CALL GMMATS (TRANS1,6,6,1,COLSTF(MPOINT),6,6,0,COLTMP)
      IIPNT = MPOINT - 1
      DO 1520 II = 1,36
 1520 COLSTF(IIPNT+II) = COLTMP(II)
 1530 CONTINUE
C
C     HERE WE MUST CHANGE FROM THE ROW LOADING CONVENTION
C     FOR GMMATS TO THE COLUMN LOADING CONVENTION FOR EMGOUT.
C
      DO 1550 II = 1,6
      IPOINT = NDOF*(II-1)
      DO 1550 JJ = 1,NDOF
      JPOINT = 6*(JJ-1)
      COLTMP(IPOINT+JJ) = COLSTF(JPOINT+II)
 1550 CONTINUE
C
C     DUMP THE TRANSFORMED NODAL COLUMN PARTITION
C
      IEOE = 0
      IF (I .EQ. NNODE) IEOE = 1
      ADAMP = GSUBE
C
C     INTEGER 1 IN THE NEXT TO LAST FORMAL PARAMETER OF
C     EMGOUT MEANS WE ARE SENDING STIFFNESS DATA.
C
      CALL EMGOUT (COLTMP,COLTMP,NPART,IEOE,DICT,1,IPREC)
 1560 CONTINUE
C
C
C     HERE WE SHIP OUT THE MASS MATRIX.
C     --------------------------------
C
 1600 IF (MGG1 .EQ. 0) GO TO 1710
C
      NDOF  = NNODE*3
      NPART = NDOF*3
      DICT(3) = NDOF
      DICT(4) = 7
      ADAMP = 0.0
C
C     SET UP I-LOOP TO PROCESS AND DUMP THE NODAL COLUMN PARTITIONS.
C
      DO 1690 I = 1,NNODE
      DO 1610 IJK = 1,NPART
 1610 AMGG(JCORED-1+IJK) = 0.0
C
C     SET UP J-LOOP TO LOAD THE UNTRANSFORMED NODAL COLUMN PARTITION.
C
      DO 1620 J = 1,NNODE
      IPOINT = 9*(J-1) + JCORED
      JPOINT = IPOINT  + 4
      KPOINT = IPOINT  + 8
      IFROM  = NNODE*(J-1) + I
      XMASSO = XMASS(IFROM)
      AMGG(IPOINT) = XMASSO
      AMGG(JPOINT) = XMASSO
      AMGG(KPOINT) = XMASSO
 1620 CONTINUE
      IF (NOTRAN(I) .EQ. 1) GO TO 1670
C
C     THIS COLUMN PARTITION NEEDS TO BE TRANSFORMED
C     TO GLOBAL COORDINATES.
C
      DO 1640 M = 1,NNODE
      MPOINT = 9*(M-1) + JCORED
      CALL GMMATS (AMGG(MPOINT),3,3,0,TRANS(9*I-8),3,3,0,TMPMAS)
      IICORE = MPOINT - 1
      DO 1630 K = 1,9
 1630 AMGG(IICORE+K) = TMPMAS(K)
 1640 CONTINUE
C
C     SET UP M-LOOP TO TRANSFORM THE NODAL ROW PARTITIONS
C     OF THIS NODAL COLUMN PARTITION.
C
      DO 1660 M = 1,NNODE
      MPOINT = 9*(M-1) + JCORED
C
C     TRANSFORM THE 3 ROWS FOR THIS SUBPARTITION.  THIS IS CORRECT
C     (3 ROWS).  REMEMBER THAT FOR THE MASS MATIIX FOR THIS ELEMENT
C     THERE ARE NO MASS MOMENT OF INERTIA TERMS.  THIS GIVES THREE
C     ROWS OF ZERO TERMS INTERSPERSED BETWEEN 3 ROWS OF NONZERO
C     TRANSLATIONAL MASS TERMS FOR EACH NODE.
C
      CALL GMMATS (TRANS(9*M-8),3,3,1,AMGG(MPOINT),3,3,0,TMPMAS)
      IICORE = MPOINT - 1
      DO 1650 K = 1,9
 1650 AMGG(IICORE+K) = TMPMAS(K)
 1660 CONTINUE
C
C     HERE WE MUST CHANGE FROM THE ROW LOADING CONVENTION
C     FOR GMMATS TO THE COLUMN LOADING CONVENTION FOR EMGOUT.
C
 1670 DO 1680 II = 1,3
      IPOINT = NDOF*(II-1)
      DO 1680 JJ = 1,NDOF
      JPOINT = 3*(JJ-1) + JCORED - 1
 1680 COLTMP(IPOINT+JJ) = AMGG(JPOINT+II)
C
C     DUMP THIS TRANSFORMED MASS NODAL COLUMN PARTITION.
C
      IEOE = 0
      IF (I .EQ. NNODE) IEOE = 1
C
C     INTEGER 2 IN THE NEXT TO LAST FORMAL PARAMETER OF
C     EMGOUT MEANS WE ARE SENDING MASS DATA.
C
      CALL EMGOUT (COLTMP,COLTMP,NPART,IEOE,DICT,2,IPREC)
 1690 CONTINUE
      GO TO 1710
C
 1700 J = 230
      GO TO 1720
C
 1710 CONTINUE
      RETURN
C
 1720 CALL MESAGE (30,J,NEST)
      IF (L38 .EQ. 1) CALL MESAGE (-61,0,0)
      NOGO = .TRUE.
      GO TO 1710
 1730 CALL MESAGE (-30,234,NAM)
C
C
C     HEAT FLOW OPTION STARTS HERE.
C
C     WE NEED TO RESTORE THE ORIGIANL ORDER OF SILS AND BGPDT DATA
C
 1790 J = 1
      DO 1800 I = 1,20
      EST(I+J) = SAVE(I)
      IF (I .EQ. 4) J = 24
 1800 CONTINUE
C
      INFLAG = 2
      COSMAT = 1.0
      SINMAT = 0.0
      MATID  = NEST(13)
      CALL HMAT (ELID)
      GI(1) = KHEAT(1)
      GI(2) = KHEAT(2)
      GI(3) = GI(2)
      GI(4) = KHEAT(3)
      ANIS  = TYPE.NE.4 .AND. TYPE.NE.-1
C     OMMENT . ANIS = .FALSE. MEANS ISOTROPIC THERMAL CONDUCTIVITY.
      IF (ANIS) GO TO 400
      GO TO 1820
 1810 CONTINUE
      TEM(3) = TEM(4)
      TEM(4) = TEM(5)
      CALL GMMATS (TEM,2,2,0,GI,2,2,0,GT)
      CALL GMMATS (GT,2,2,0,TEM,2,2,1,GI)
 1820 CONTINUE
      DO 1830 I = 1,16
      HTCON(I) = 0.0
      HTCAP(I) = 0.0
 1830 CONTINUE
      DO 1840 I = 5,8
      HSIL(I) = 0
 1840 HORDER(I) = 0
C
      DO 1890 IXSI = 1,2
      XI = PTINT(IXSI)
      DO 1890 IETA = 1,2
      ETA = PTINT(IETA)
C
      DO 1870 IZTA = 1,2
      ZETA = PTINT(IZTA)
C
      CALL TERMSS (NNODE,DGPTH,EPNORM,EGPDT,HORDER,HSIL,BTERMS)
      DVOL = DETERM
C
      DO 1850 I = 1,4
 1850 ECPT(I) = GI(I)*DVOL
      WEITC = DVOL*HTCP
C
      IP = 1
      DO 1860 I = 1,NNODE
      IDN = I + NNODE
      HTFLX(IP+1) = ECPT(3)*BTERMS(I) + ECPT(4)*BTERMS(IDN)
      HTFLX(IP  ) = ECPT(1)*BTERMS(I) + ECPT(2)*BTERMS(IDN)
 1860 IP = IP + 2
      CALL GMMATS (BTERMS,2,NNODE,-1,HTFLX,NNODE,2,1,HTCON)
C
 1870 CONTINUE
      IF (HTCP .EQ. 0.0) GO TO 1890
      IP = 0
      DO 1880 I = 1,NNODE
      DHEAT = WEITC*SHP(I)
      DO 1880 J = 1,NNODE
      IP = IP + 1
      HTCAP(IP) = HTCAP(IP) + DHEAT*SHP(J)
 1880 CONTINUE
 1890 CONTINUE
      DICT(1) = ESTID
      DICT(2) = 1
      DICT(3) = NNODE
      DICT(4) = 1
      IF (HTCP .EQ. 0.0) GO TO 1900
      ADAMP = 1.0
      CALL EMGOUT (HTCAP,HTCAP,NODESQ,1,DICT,3,IPREC)
 1900 CONTINUE
      ADAMP = 0.0
      CALL EMGOUT (HTCON,HTCON,NODESQ,1,DICT,1,IPREC)
      GO TO 1710
C
 2010 FORMAT (A23,', THE ELEMENT THICKNESS FOR QUAD4 EID =',I9,
     1       ' IS NOT COMPLETELY DEFINED.')
 2030 FORMAT (A25,', RHO = ',1PD12.4,' IS ILLEGAL FROM MATERIAL ID =',
     1       I9,' FOR QUAD4 EID =',I9)
 2060 FORMAT (A25,', ZERO VOLUME OR DENSITY FOR QUAD4 ELEMENT ID =',I9,
     1       ', AREA,VOL,RHO=',3E12.3, /70X,'MGG1,KGG1=',2I8)
      END

      SUBROUTINE GP4
C
C     GP4  PERFORMS THE FOLLOWING FUNCTIONS--
C       1. READS CASECC AND MAKES ANALYSIS OF SUBCASE LOGIC
C       2. PROCESSES RIGID ELEMENTS AND ALL OTHER CONSTRAINT DATA (MPC,
C          SPC, OMIT, SUPORT, ASET, ETC.)
C       3. BUILDS THE USET FOR THE CURRENT SUBCASE
C       4. CALLS GP4SP TO EXAMINE GRID POINT SINGULARITIES
C       5. BUILDS THE RGT MATRIX AND YS VECTOR FOR CURRENT SUBCASE
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        LSHIFT ,RSHIFT ,ANDF   ,ORF    ,COMPLF
      DIMENSION       BUF(20),MPC(2) ,OMIT(2),SUPORT(2)      ,SPC(2) ,
     1                MPCADD(2)      ,SPC1(2),SPCADD(2)      ,MASK(6),
     2                NAME(2),MCB(7) ,MCBUST(7)      ,MCBYS(7)       ,
     3                OMITX1(2)      ,ASET(2),ASET1(2)       ,MAK(4) ,
     4                SPCD(2),CTYPE(18)
      REAL            RZ(1)  ,BUFR(2)
      CHARACTER       UFM*23
CWKBI 3/95 NCL94002
      CHARACTER       UWM*25 ,UIM*29
CWKBR 3/95 NCL94002      COMMON /XMSSG / UFM  
      COMMON /XMSSG / UFM    ,UWM    ,UIM
      COMMON /MACHIN/ MACH   ,IHALF  ,JHALF
      COMMON /BITPOS/ UM     ,UO     ,UR     ,USG    ,USB    ,UL     ,
     1                UA     ,UF     ,US     ,UN     ,UG
      COMMON /BLANK / LUSET  ,MPCF1  ,MPCF2  ,SINGLE ,OMIT1  ,REACT  ,
     1                NSKIP  ,REPEAT ,NOSETS ,NOL    ,NOA    ,IDSUB  ,
     2                IAUTSP
      COMMON /GP4FIL/ GEOMP  ,BGPDT  ,CSTM   ,RGT    ,SCR1
      COMMON /GP4PRM/ BUF    ,BUF1   ,BUF2   ,BUF3   ,BUF4   ,KNKL1  ,
     1                MASK16 ,NOGO   ,GPOINT ,KN
      COMMON /GP4SPX/ MSKUM  ,MSKUO  ,MSKUR  ,MSKUS  ,MSKUL  ,MSKSNG ,
     1                SPCSET ,MPCSET ,NAUTO  ,IOGPST
      COMMON /NAMES / RD     ,RDREW  ,WRT    ,WRTREW ,CLSREW
      COMMON /PACKX / ITA1   ,ITB1   ,II1    ,JJ1    ,INCR1
      COMMON /SYSTEM/ KSYSTM(65)
      COMMON /TWO   / TWO(32)
      COMMON /UNPAKX/ ITB    ,II     ,JJ     ,INCR
      COMMON /ZBLPKX/ X(4)   ,IX
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE     (KSYSTM( 1),SYSBUF), (KSYSTM( 2),OUTTAP ),
     1                (KSYSTM(27),IAXIC ), (KSYSTM(38),IAXIF  ),
     2                (Z(1)      ,RZ(1) ), (BUF(1)    ,BUFR(1)),
     3                (UGSET     ,USGSET), (IB6       ,BUF(6) )
      DATA    OMIT  / 5001,   50/,
     1        SUPORT/ 5601,   56/,
     2        SPC   / 5501,   55/,
     3        SPC1  / 5481,   58/,
     4        SPCADD/ 5491,   59/,
     5        OMITX1/ 4951,   63/,
     6        ASET  / 5561,   76/,
     7        ASET1 / 5571,   77/,
     8        SPCD  / 5110,   51/,
     9        MPC   / 4901,   49/,
     O        MPCADD/ 4891,   60/
      DATA    NAME  / 4HGP4  ,4H    /
      DATA    MSET  / 4H M   /,   SG/4H SG   /, R/ 4H R  /
      DATA    YS    , USET   /202    ,203    /
      DATA    SCR2           /302            /
      DATA    MPCAX1, MPCAX2 /101    ,102    /
      DATA    CASECC, EQEXIN ,GPDT   /101    ,103  ,104  /
      DATA    CTYPE / 4HMPC , 4H    ,
     1                4HOMIT, 4H    ,
     2                4HOMIT, 4H1   ,
     3                4HSUPO, 4HRT  ,
     4                4HSPC1, 4H    ,
     5                4HSPC , 4H    ,
     6                4HSPCD, 4H    ,
     7                4HASET, 4H    ,
     8                4HASET, 4H1   /
      DATA    IZ2,IZ3,IZ5,IZ16,IZ138/ 2, 3, 5, 16, 138   /
C
C     PERFORM GENERAL INITIALIZATION
C
CWKBI 3/95 NCL94002
      CALL SSWTCH ( 51, L51 )
      GEOMP  = 102
      BGPDT  = 105
      CSTM   = 106
      RGT    = 201
      SCR1   = 301
      NAUTO  = 0
      IOGPST = -1
      BUF1   = KORSZ(Z) - SYSBUF - 2
      BUF2   = BUF1 - SYSBUF
      BUF3   = BUF2 - SYSBUF
      BUF4   = BUF3 - SYSBUF
      ICRQ   = LUSET- BUF4
      INSUFF = 10
      IF (LUSET .GE. BUF4) GO TO 2430
      MASK16 = JHALF
      MASK15 = JHALF/2
      N23    = 2
      MSKUM  = TWO(UM )
      MSKUO  = TWO(UO )
      MSKUR  = TWO(UR )
      MSKUSG = TWO(USG)
      MSKUSB = TWO(USB)
      MSKUL  = TWO(UL )
      MSKUA  = TWO(UA )
      MSKUF  = TWO(UF )
      MSKUS  = TWO(US )
      MSKUN  = TWO(UN )
      MSKUG  = TWO(UG )
      MSKUNG = ORF(MSKUN,MSKUG)
      MSKFNG = ORF(MSKUF,MSKUNG)
      MSKSNG = ORF(MSKUS,MSKUNG)
      MASK(1)= ORF(MSKUM,MSKUG)
      MASK(2)= ORF(MSKUO,MSKFNG)
      MASK(3)= ORF(MSKUR,ORF(MSKUA,MSKFNG))
      MASK(4)= ORF(MSKUSG,MSKSNG)
      MASK(5)= ORF(MSKUSB,MSKSNG)
      MASK(6)= ORF(MSKUL,ORF(MSKUA,MSKFNG))
      MAK(1) = ORF(MSKUM,MSKUL)
      MAK(2) = ORF(MSKUS,MSKUL)
      MAK(3) = ORF(MSKUO,MSKUL)
      MAK(4) = ORF(MSKUR,MSKUL)
      CALL MAKMCB (MCBYS,YS,0,2,1)
      CALL MAKMCB (MCBUST,USET,LUSET,0,0)
      MULTI  = -1
      USGSET = -1
      SINGLE = -1
      OMIT1  = -1
      NOSETS = -1
      ASETX  = -1
      REACT  = -1
      NOYS   =  0
      NOGEOM =  0
      NOL    = -1
      NOA    = +1
      NOGO   =  0
      NOGOOF =  0
      DUP    =  0
      IFLAG  =  0
      FLAG   =  0
      MSKCK  = COMPLF(LSHIFT(COMPLF(0),20))
      RIGID  =  0
      SPCOLD = -1
      MPCOLD = -1
      L21    =  0
      L22    =  0
      MCB(1) = GEOMP
      CALL RDTRL (MCB(1))
      IF (MCB(1) .LT. 0) GO TO 20
C
C     BIT ASSIGNMENTS FOR RIGID ELEMENTS -
C     CRIGD1 - 53       CRROD    - 65       CRBE1 - 68
C     CRIGD2 - 54       CRBAR    - 66       CRBE2 - 69
C     CRIGD3 - 83       CRTRPLT  - 67       CRBE3 - 70
C     CRIGDR - 82       CRSPLINE - 71
C
      IF (ANDF(MCB(5),TWO(21)) .EQ. TWO(21)) RIGID = 1
      IF (ANDF(MCB(5),TWO(22)) .EQ. TWO(22)) RIGID = 1
      IF (ANDF(MCB(7),TWO(19)) .EQ. TWO(19)) RIGID = 1
      IF (ANDF(MCB(7),TWO(18)) .EQ. TWO(18)) RIGID = 1
      I = MCB(6)
      DO 10 J = 17,23
      IF (ANDF(I,TWO(J)) .EQ. TWO(J)) RIGID = 1
   10 CONTINUE
      CALL MAKMCB (MCB,RGT,0,2,1)
C
C     SUBCASE LOGIC -- NSKIP IS 0 (SET BY PARAM MODULE) IF FIRST
C     SUBCASE. OTHERWISE NSKIP IS THE NO. OF RECORDS TO SKIP ON CASE
C     CONTROL DATA BLOCK TO REACH THE LAST SUBCASE. GP4 SETS THE
C     FOLLOWING PARAMETERS -
C     (1) MPCF1 = +1 (DO NOT PURGE OR EQUIV MCE DATA BLOCKS) = -1 (PURGE
C                 AND EQUIV TO TAKE).
C     (2) MPCF2 = +1 (EXECUTE MCE1 AND MCE2) = -1 (DO NOT EXECUTE)
C     (3) REPEAT= +1 (MORE SUBCASES AFTER THIS ONE) = -1 (LAST SUBCASE).
C     (4) NSKIP = NO. OF RECORDS TO SKIP ON CASE CONTROL TO REACH THE
C                 CURRENT SUBCASE (FOR MODULES IN REMAINDER OF LOOP).
C
   20 REPEAT= -1
      MPCF1 = -1
      MPCF2 = -1
      NSKP1 =  1
      FILE  = CASECC
      CALL GOPEN (CASECC,Z(BUF1),0)
      IF (NSKIP .GT. 1) CALL SKPREC (CASECC,NSKIP-1)
      CALL FREAD (CASECC,Z,36,1)
      IF (NSKIP .GT. 0) GO TO 30
C
C     FIRST SUBCASE - INITIALIZE.
C
      MPCSET = Z(IZ2)
      SPCSET = Z(IZ3)
      NSKIP  = 1
      GO TO 50
C
C     SUBSEQUENT SUBCASE - POSITION CASE CONTROL AND INITIALIZE.
C
   30 MPCOLD = Z(IZ2)
      SPCOLD = Z(IZ3)
   40 NSKIP  = NSKIP + 1
      CALL FREAD (CASECC,Z,36,1)
      IF (Z(IZ16) .NE. 0) GO TO 40
      IF (Z(IZ2).EQ.MPCOLD .AND. Z(IZ3).EQ.SPCOLD) GO TO 40
      MPCSET = Z(IZ2)
      SPCSET = Z(IZ3)
C
C     LOOK AHEAD TO END OF CURRENT SUBCASE AND SET PARAMETERS.
C
   50 CALL READ (*60,*2420,CASECC,Z,138,1,FLAG)
C
C     CHECK FOR SYMMETRY
C
      IF (Z(IZ16) .NE. 0) GO TO 50
C
C     CHECK FOR BUCKLING OR DIFFERENTIAL STIFFNESS
C
      IF (Z(IZ5).NE.0 .OR. Z(IZ138).NE.0) GO TO 60
      IF (Z(IZ2).EQ.MPCSET .AND. Z(IZ3).EQ.SPCSET) GO TO 110
      REPEAT = 1
C
C     CHECK TO SEE IF MPC SET IS SELECTED OR IF RIGID ELEMENTS EXIST
C
   60 IF (MPCSET.EQ.0 .AND. RIGID.EQ.0) GO TO 70
      MPCF1 = 1
      MPCF2 = 1
      IF (NSKIP  .EQ.      1) GO TO 70
      IF (MPCSET .EQ. MPCOLD) MPCF2 = -1
   70 CALL CLOSE (CASECC,CLSREW)
      ASSIGN 120 TO RET
C
C     READ EQEXIN INTO CORE
C
   80 FILE = EQEXIN
      CALL GOPEN (EQEXIN,Z(BUF1),0)
      CALL READ  (*2410,*90,EQEXIN,Z,BUF4,1,KN)
      INSUFF = 80
      ICRQ   = BUF4
      GO TO 2430
   90 CALL READ  (*2410,*2420,EQEXIN,Z(KN+1),KN,1,FLAG)
      CALL CLOSE (EQEXIN, CLSREW)
      KM  = 2*KN
      KN2 = KN/2
C
C     FORM ARRAY OF SORTED SIL VALUES STARTING AT Z(KM+1)
C
      DO 100 I = 1, KN2
      J = 2*(I-1) + 2 + KN
      Z(KM+I) = Z(J)/10
  100 CONTINUE
      CALL SORT (0,0,1,1,Z(KM+1),KN2)
      Z(KM+KN2+1) = LUSET + 1
      KNKL1 = KM + KN2 + 2
C
C     SET DIAG-S 21 AND 22 FOR DEGREE-OF-FREEDOM PRINTER LATER.
C
      CALL SSWTCH (21,L21)
      CALL SSWTCH (22,L22)
      GO TO RET, (120,1930,1660)
C
  110 NSKP1 = NSKP1 + 1
      GO TO 50
C
C     OPEN INPUT DATA FILE
C
  120 FILE = GEOMP
      CALL PRELOC (*130,Z(BUF1),GEOMP)
      NOGEOM = 1
C
C     CHECK TO SEE IF MPC SET IS SELECTED OR IF RIGID ELEMENTS EXIST
C
      IF (MPCSET.EQ.0 .AND. RIGID.EQ.0) GO TO 130
C
C     OPEN RGT FILE
C
      FILE = RGT
      CALL GOPEN (RGT,Z(BUF3),1)
C
C     IF RIGID ELEMENTS EXIST, GENERATE THEIR COEFFICIENTS
C
      NOGOO = NOGO
      NOGO  = 0
      IF (RIGID .EQ. 1) CALL CRIGGP (N23)
      IF (NOGO  .NE. 0) GO TO 2540
      NOGO = NOGOO
C
C     OPEN SCRATCH DATA FILE
C
  130 FILE = SCR1
      CALL OPEN (*2400,SCR1,Z(BUF2),WRTREW)
C
C     CHECK TO SEE IF GEOMP FILE EXISTS
C
      IF (NOGEOM .EQ. 0) GO TO 790
C
C     CHECK TO SEE IF MPC SET IS SELECTED OR IF RIGID ELEMENTS EXIST
C
      IF (MPCSET.EQ.0 .AND. RIGID.EQ.0) GO TO 610
      IF (MPCSET .NE. 0) GO TO 140
C
C     NO MPC SET IS SELECTED
C
      MULTI = 0
      IMPC  = KNKL1
      I = IMPC
      J = BUF3 - 1
      GO TO 370
C
C     IF MPC SET IS SELECTED, DETERMINE IF SET IS ON MPCADD CARD.
C     IF NOT, SIMULATE AN MPCADD SET LIST WITH ONE SET = MPCSET.
C
  140 IMPCAD = KNKL1
      NMPCAD = KNKL1
      IMPC   = IMPCAD + 2
      I      = IMPCAD
      Z(I)   = MPCSET
      Z(I+1) = 0
      FILE   = GEOMP
      CALL LOCATE (*200,Z(BUF1),MPCADD,FLAG)
  150 CALL READ (*2410,*200,GEOMP,ID,1,0,FLAG)
      IF (ID .EQ. MPCSET) GO TO 170
  160 CALL FREAD (GEOMP,BUF,1,0)
      IF (BUF(1) .NE. -1) GO TO 160
      GO TO 150
  170 CALL READ (*2410,*190,GEOMP,BUF,1,0,FLAG)
      IF (BUF(1) .EQ. -1) GO TO 180
      Z(I  ) = BUF(1)
      Z(I+1) = 0
      I  = I + 2
      GO TO 170
  180 CALL FWDREC (*2410,GEOMP)
  190 IMPC   = I
      NMPCAD = I - 2
C
C     READ MPC CARDS. FOR EACH EQUATION WHOSE SET ID MATCHES A SET ID
C     IN THE MPCADD SET LIST, CONVERT THE GRID POINT AND COMPONENT NO.
C     (OR SCALAR NO.) TO A SIL VALUE. COMPUTE THE ROW AND COLUMN NO.
C     FOR THE POINT AND SAVE THIS ALONG WITH ITS VALUE.
C
  200 CALL LOCATE (*320,Z(BUF1),MPC,FLAG)
      J = BUF3 - 1
      I = IMPC
      MULTI = 0
      ASSIGN 260  TO RET
      ASSIGN 2460 TO RET1
      ASSIGN 250  TO RET2
      ASSIGN 270  TO RET3
  210 CALL READ (*2410,*320,GEOMP,ID,1,0,FLAG)
      DO 220 K = IMPCAD,NMPCAD,2
      IF (Z(K) .EQ. ID) GO TO 240
  220 CONTINUE
  230 CALL FREAD (GEOMP,BUF,3,0)
      IF (BUF(1) .NE. -1) GO TO 230
      GO TO 210
  240 MULTI = MULTI + 1
      Z(K+1)= 1
      IFL   = 0
  250 CALL FREAD (GEOMP,BUF,3,0)
      IF (BUF(1) .EQ. -1) GO TO 310
      GPOINT = BUF(1)
      GO TO 2100
  260 INDEX = 1
      ICOMP = BUF(2)
      GO TO 2300
  270 IF (ICOMP .NE. 0) GPOINT = GPOINT + ICOMP - 1
      IF (IFL .EQ. 0) SILD = GPOINT
      IF (N23 .EQ. 3) GO TO 300
      IF (GPOINT .GT. MASK15) GO TO 290
      Z(I  ) = ORF(LSHIFT(GPOINT,IHALF),SILD)
      Z(I+1) = BUF(3)
  280 I = I + N23
      INSUFF = 236
      IF (I .GE. J) GO TO 2430
      IFL = 1
      GO TO 250
C
C     GPOINT IS TOO BIG TO BE PACKED INTO HALF A WORD.  ABANDON COL.
C     AND ROW PACKING LOGIC, AND DO IT OVER AGAIN WITHOUT PACKING.
C
  290 N23 = 3
      CALL REWIND (GEOMP)
      CALL FWDREC (*2410,GEOMP)
      GO TO 200
  300 Z(I  ) = GPOINT
      Z(I+1) = SILD
      Z(I+2) = BUF(3)
      GO TO 280
C
C     SAVE A LIST OF DEPENDENT SIL VALUES
C
  310 Z(J)= SILD
      J   = J - 1
      GO TO 210
C
C     DETERMINE IF ALL MPC SETS IN MPCADD SET LIST HAVE BEEN INPUT
C
  320 IF (NOGO .NE. 0) GO TO 2540
      NOGOO = NOGO
      NOGO  = 0
      IGOTCH= 0
      DO 350 K = IMPCAD,NMPCAD,2
      IF (Z(K+1) .NE. 0) GO TO 340
      NOGO  = -1
      IF (Z(K).EQ.200000000 .AND. IAXIF.NE.0) GO TO 350
      IF (IAXIC .EQ. 0) GO TO 330
      IF (Z(K).EQ.MPCAX1 .OR. Z(K).EQ.MPCAX2) GO TO 350
      IF (Z(K) .EQ. 200000000) GO TO 350
  330 NOGO  = +1
      BUF(1)= Z(K)
      BUF(2)= 0
      CALL MESAGE (30,47,BUF)
      GO TO 350
  340 IGOTCH= 1
  350 CONTINUE
      IF (NOGO .EQ. 0) GO TO 370
      IF (NOGO.EQ.-1 .AND. IGOTCH.EQ.1) GO TO 360
      MPCSET=  0
      MULTI = -1
      MPCF1 = -1
      MPCF2 = -1
      IF (NOGO.EQ.-1 .AND. NOGOO.EQ.0) NOGO = 0
      GO TO 600
  360 CONTINUE
      IF (NOGO.EQ.-1 .AND. NOGOO.EQ.0) NOGO = 0
C
C     CHECK TO SEE IF RIGID ELEMENTS EXIST
C
  370 IF (RIGID .EQ. 0) GO TO 470
C
C     EXPAND THE DEPENDENT SET BY APPENDING RIGID ELEMENT
C     DATA TO MPC DATA
C
      CALL GOPEN  (RGT,Z(BUF3),0)
      CALL SKPREC (RGT,1)
      I1   = BUF3 - I
      CALL READ (*2410,*380,RGT,Z(I),I1,1,NRIGID)
      INSUFF = 3020
      GO TO 2430
  380 J = J - NRIGID
      MULTI = MULTI + NRIGID
      CALL SKPREC (RGT,-2)
      CALL READ (*2410,*410,RGT,Z(I),I1,1,FLAG)
      INSUFF = 3030
      I2 = I1
  390 CALL BCKREC (RGT)
      CALL READ (*2410,*400,RGT,Z(I),-I2,0,FLAG)
      CALL READ (*2410,*400,RGT,Z(I), I1,0,FLAG)
      I2 = I2 + I1
      GO TO 390
  400 FLAG = I2 + FLAG
      GO TO 440
C
C     RE-CODE COLUMN-ROW PACKED WORD IF NECESSARY FOR DATA JUST BROUGHT
C     IN FROM RIGID ELEMENTS
C     THEN READ THE LAST RECORD FROM RGT
C
  410 IF (N23 .EQ. 3) GO TO 430
      I1 = I - 1
      I2 = I1
      I3 = I1 + FLAG
  420 Z(I2+1) = ORF(LSHIFT(Z(I1+1),IHALF),Z(I1+2))
      Z(I2+2) = Z(I1+3)
      I1 = I1 + 3
      I2 = I2 + 2
      IF (I1 .LT. I3) GO TO 420
      FLAG = I2 - I + 1
C
  430 INSUFF = 3050
  440 I3 = I + FLAG
      IF (I3 .LT. J)  GO TO 460
      WRITE  (OUTTAP,450) I,I3,J,FLAG,BUF3,NRIGID,N23
  450 FORMAT ('  GP4/3060 I,I3,J,FLAG,BUF3,NRIGID,N23 =',7I7)
      ICRQ = I - J
      GO TO 2430
  460 I  = I3
      CALL READ  (*2410,*2420,RGT,Z(J+1),NRIGID,1,FLAG)
      CALL CLOSE (RGT,CLSREW)
      CALL GOPEN (RGT,Z(BUF3),1)
C
C     SORT THE LIST OF DEPENDENT SIL VALUES
C     THUS FORMING THE UM SUBSET
C
  470 II = J + 1
      M  = BUF3 - II
      NNX= BUF3 - 1
      IF (M .EQ. 1) GO TO 510
      CALL SORT (0,0,1,1,Z(II),M)
C
C     CHECK FOR DEPENDENT COMPONENT ERRORS IN MPC/RIGID ELEMENT DATA
C
      JJ   = NNX - 1
      NOLD = 0
      JXX  = 0
      DO 490 J = II,JJ
      IF (Z(J) .EQ. NOLD) GO TO 490
      IF (Z(J).NE.Z(J+1)) GO TO 490
      NOLD = Z(J)
      NOGO = 1
      JXX  = JXX + 1
      IF (JXX .GT. 50) GO TO 490
      CALL PAGE2 (2)
      WRITE  (OUTTAP,480) UFM,Z(J)
  480 FORMAT (A23,' 2423, DEPENDENT COMPONENT SPECIFIED MORE THAN ONCE',
     1       ' ON MPC CARDS AND/OR IN RIGID ELEMENTS.  SIL =',I9)
  490 CONTINUE
      IF (JXX .GT. 50) WRITE (OUTTAP,500)
  500 FORMAT (//12X,12H... AND MORE,/)
  510 IF (NOGO .NE. 0) GO TO 2540
      CALL WRITE (SCR1,Z(II),M,1)
C
C     SORT THE LIST OF CODED COL AND ROW NOS (OR UNCODED NOS)
C     THEN BLDPK EACH COL THUS FORMING THE RG MATRIX
C
      N   = I - IMPC
      NMPC= I - N23
      J   = IMPC
      IF (N23 .EQ. 3) CALL SORT2K (0,0,3,1,Z(J),N)
      IF (N23 .EQ. 2) CALL SORT   (0,0,2,1,Z(J),N)
C
C     CHECK FOR INDEPENDENT COMPONENT ERRORS IN MPC DATA
C
      KJ   = J + N - 2*N23
      NOLD = 0
      NOGO = 0
      DO 540 KK = J,KJ,N23
      IF (Z(KK) .EQ.      NOLD) GO TO 540
      IF (Z(KK) .NE. Z(KK+N23)) GO TO 540
      IF (N23.EQ.3 .AND. Z(KK+1).NE.Z(KK+N23+1)) GO TO 540
      NOLD = Z(KK)
      NOGO = 1
      JJ   = NOLD
      IF (N23 .EQ. 2) JJ = RSHIFT(NOLD,IHALF)
      CALL PAGE2 (-2)
      WRITE  (OUTTAP,530) UFM,JJ
  530 FORMAT (A23,' 3180, INDEPENDENT COMPONENT SPECIFIED MORE THAN ',
     1       'ONCE IN AN MPC RELATIONSHIP.   SIL =',I6)
  540 CONTINUE
      IF (NOGO .NE. 0) GO TO 2540
      NCOL= 1
      M   = BUF3 - I
      N231= N23  - 1
  550 CALL BLDPK (1,1,RGT,0,0)
  560 IF (J .GT. NMPC) GO TO 590
      JJ = Z(J)
      IF (N23 .EQ. 2) JJ = RSHIFT(Z(J),IHALF)
      IF (JJ .GT. NCOL) GO TO 590
      IX = Z(J+1)
      IF (N23 .EQ. 2) IX = ANDF(Z(J),MASK16)
      X(1) = Z(J+N231)
      DO 570 NN1 = II,NNX
      IF (IX .EQ. Z(NN1)) GO TO 580
  570 CONTINUE
      GO TO 2540
  580 IX = NN1 - II + 1
      CALL ZBLPKI
      J  = J + N23
      GO TO 560
  590 CALL BLDPKN (RGT,0,MCB)
      NCOL = NCOL + 1
      IF (NCOL .LE. LUSET) GO TO 550
      MCB(3) = MULTI
      CALL WRTTRL (MCB)
  600 CALL CLOSE (RGT,CLSREW)
C
C     READ OMIT CARDS (IF PRESENT).
C
  610 I = KNKL1
      CALL LOCATE (*650,Z(BUF1),OMIT,FLAG)
      ASSIGN 630  TO RET
      ASSIGN 2470 TO RET1
      ASSIGN 620  TO RET2
      ASSIGN 640  TO RET3
      OMIT1 = 1
  620 CALL READ (*2410,*650,GEOMP,BUF,2,0,FLAG)
      GPOINT= BUF(1)
      GO TO 2100
  630 INDEX = 3
      ICOMP = BUF(2)
      GO TO 2300
  640 IF (ICOMP .NE. 0) GPOINT = GPOINT + ICOMP - 1
      Z(I)= GPOINT
      I   = I + 1
      IF (I .LE. BUF3) GO TO 620
      ICRQ = I - BUF3
      INSUFF = 345
      GO TO 2430
C
C     READ OMIT1 CARDS (IF PRESENT).
C
  650 IF (NOGO .NE. 0) GO TO 2540
      CALL LOCATE (*720,Z(BUF1),OMITX1,FLAG)
      OMIT1 = 1
      ASSIGN 680  TO RET
      ASSIGN 2470 TO RET1
      ASSIGN 670  TO RET2
      ASSIGN 690  TO RET3
  660 CALL READ (*2410,*720,GEOMP,BUF,1,0,FLAG)
      IF (BUF(1) .NE. 0) CALL SCALEX (1,BUF(1),BUF(8))
  670 CALL READ (*2410,*720,GEOMP,BUF(2),1,0,FLAG)
      IF (BUF(2) .EQ. -1)  GO TO 660
      GPOINT = BUF(2)
      GO TO 2100
  680 INDEX = 5
      ICOMP = BUF(1)
      GO TO 2300
  690 IF (ICOMP .NE. 0) GO TO 700
      Z(I) = GPOINT
      I    = I + 1
      GO TO 670
  700 GPOINT = GPOINT - 1
      DO 710 IJK = 1,6
      IF (BUF(IJK+7) .EQ. 0) GO TO 670
      Z(I) = GPOINT+BUF(IJK+7)
      I    = I + 1
  710 CONTINUE
      GO TO 670
  720 IF (OMIT1 .NE. 1) GO TO 730
      IF (NOGO  .NE. 0) GO TO 2540
C
C     SORT OMIT AND OMIT1 DATA AND WRITE IT ON SCR1.
C
      N = I - KNKL1
      I = KNKL1
      CALL SORT (0,0,1,1,Z(I),N)
      CALL WRITE (SCR1,Z(I),N,1)
C
C     READ SUPORT CARDS (IF PRESENT)
C
  730 CALL LOCATE (*780,Z(BUF1),SUPORT,FLAG)
      REACT = 1
      I = KNKL1
      ASSIGN 750  TO RET
      ASSIGN 2480 TO RET1
      ASSIGN 740  TO RET2
      ASSIGN 760  TO RET3
  740 CALL READ (*2410,*770,GEOMP,BUF,2,0,FLAG)
      GPOINT = BUF(1)
      GO TO 2100
  750 INDEX = 7
      ICOMP = BUF(2)
      GO TO 2300
  760 IF (ICOMP .NE. 0) GPOINT = GPOINT + ICOMP - 1
      Z(I) = GPOINT
      I    = I + 1
      IF (I .LT. BUF3) GO TO 740
      ICRQ   = I - BUF3
      INSUFF = 445
      GO TO 2430
  770 IF (NOGO .NE. 0) GO TO 2540
      N = I - KNKL1
      I = KNKL1
      CALL SORT (0,0,1,1,Z(I),N)
      CALL WRITE (SCR1,Z(I),N,1)
C
C     READ THE GPDT AND EXTRACT CONSTRAINED POINTS (IF ANY)
C
  780 CALL CLOSE (GEOMP,CLSREW)
  790 FILE = GPDT
      ASSIGN 810 TO RET
      CALL GOPEN (GPDT,Z(BUF1),0)
  800 CALL READ (*2400,*820,GPDT,BUF,7,0,FLAG)
      IF (BUF(7) .EQ. 0) GO TO 800
      J = BUF(1) + KM
      BUF(1) = Z(J)
      CALL SCALEX (BUF,BUF(7),BUF(8))
      GO TO 2200
  810 CALL WRITE (SCR1,BUF(8),N,0)
      UGSET = 1
      GO TO 800
  820 IF (UGSET .GT. 0) CALL WRITE (SCR1,0,0,1)
      CALL CLOSE (GPDT,CLSREW)
      FILE = GEOMP
      IF (NOGEOM .EQ. 0) GO TO 830
      CALL PRELOC (*2400,Z(BUF1),GEOMP)
      GO TO 840
  830 IF (MPCSET .NE. 0) CALL MESAGE (30,47,MPCSET)
      IF (SPCSET .NE. 0) CALL MESAGE (30,53,SPCSET)
      IF (MPCSET.NE.0 .OR. SPCSET.NE.0) NOGO = +1
      GO TO 1280
C
C     IF SPC SET IS SELECTED, READ SPCADD CARDS (IF PRESENT).
C     DETERMINE IF SET ID IS ON SPCADD CARD.
C     IF NOT, SIMULATE AN SPCADD SET LIST WITH ONE SET = SPCSET.
C
  840 IF (SPCSET .EQ. 0) GO TO 1150
      ISPCAD = KNKL1
      NSPCAD = KNKL1
      ISPC   = ISPCAD + 2
      I      = ISPCAD
      Z(I  ) = SPCSET
      Z(I+1) = 0
      CALL LOCATE (*900,Z(BUF1),SPCADD,FLAG)
  850 CALL READ (*2410,*900,GEOMP,ID,1,0,FLAG)
      IF (ID .EQ. SPCSET) GO TO 870
  860 CALL FREAD (GEOMP,ID,1,0)
      IF (ID .NE. -1) GO TO 860
      GO TO 850
  870 CALL READ (*2410,*890,GEOMP,BUF,1,0,FLAG)
      IF (BUF(1) .EQ. -1) GO TO 880
      Z(I  ) = BUF(1)
      Z(I+1) = 0
      I      = I + 2
      GO TO 870
  880 CALL FWDREC (*2410,GEOMP)
  890 ISPC   = I
      NSPCAD = I - 2
C
C     READ SPC1 AND SPC CARDS.
C     FOR EACH SET ID WHICH IS IN THE SPCADD SET LIST,
C     CONVERT THE GRID POINT NO. AND COMPONENT VALUE (OR SCALAR NO.)
C     TO AN SIL VALUE. SAVE A LIST IN CORE OF SIL VALUES AND
C     ENFORCED DISPLACEMENT (ON SPC1 CARDS, ENF. DISPL. = 0.)
C
  900 I = ISPC
      GO TO 1010
C
C     SPC1 PROCESSING EXECUTES AFTER SPC PROCESSING
C
  910 IF (NOGO .NE. 0) GO TO 2540
      CALL LOCATE (*1130,Z(BUF1),SPC1,FLAG)
      ASSIGN 970  TO RET
      ASSIGN 2490 TO RET1
      ASSIGN 960  TO RET2
      ASSIGN 980  TO RET3
  920 CALL READ (*2410,*1130,GEOMP,ID,1,0,FLAG)
      DO 930 K = ISPCAD,NSPCAD,2
      IF (Z(K) .EQ. ID) GO TO 950
  930 CONTINUE
  940 CALL FREAD (GEOMP,BUF,1,0)
      IF (BUF(1) .NE. -1) GO TO 940
      GO TO 920
  950 Z(K+1) = 1
      CALL FREAD (GEOMP,BUF,1,0)
      SINGLE = 1
      IF (BUF(1) .NE. 0) CALL SCALEX (1,BUF(1),BUF(8))
  960 CALL READ (*2410,*920,GEOMP,BUF(2),1,0,FLAG)
      IF (BUF(2) .LT. 0) GO TO 920
      GPOINT = BUF(2)
      GO TO 2100
  970 INDEX = 9
      ICOMP = BUF(1)
      GO TO 2300
  980 IF (ICOMP .NE. 0) GO TO 990
      Z(I  ) = GPOINT
      Z(I+1) = 0
      I      = I + 2
      GO TO 960
  990 GPOINT = GPOINT - 1
      DO 1000 IJK = 1,6
      IF (BUF(IJK+7) .EQ. 0) GO TO 960
      Z(I  ) = GPOINT+BUF(IJK+7)
      Z(I+1) = 0
      I      = I + 2
 1000 CONTINUE
      GO TO 960
C
C     PROCESSING OF SPC CARDS EXECUTES FIRST.
C
 1010 CALL LOCATE (*910,Z(BUF1),SPC,FLAG)
      ASSIGN 1050  TO RET
      ASSIGN 2530 TO RET1
      ASSIGN 1020  TO RET2
      ASSIGN 1060  TO RET3
 1020 CALL READ (*2410,*1090,GEOMP,BUF,4,0,FLAG)
      DO 1030 K = ISPCAD,NSPCAD,2
      IF (Z(K) .EQ. BUF(1)) GO TO 1040
 1030 CONTINUE
      GO TO 1020
 1040 SINGLE = 1
      Z(K+1) = 1
      GPOINT = BUF(2)
      GO TO 2100
 1050 INDEX = 11
      ICOMP = BUF(3)
      GO TO 2300
 1060 IF (ICOMP .NE. 0) GO TO 1070
      Z(I  ) = GPOINT
      Z(I+1) = BUF(4)
      I      = I+2
      GO TO 1020
 1070 CALL SCALEX (GPOINT,BUF(3),BUF(8))
      DO 1080 IJK = 1,6
      IF (BUF(IJK+7) .EQ. 0) GO TO 1020
      Z(I  ) = BUF(IJK+7)
      Z(I+1) = BUF(4)
      I      = I + 2
 1080 CONTINUE
      GO TO 1020
 1090 IF (NOGO .NE. 0) GO TO 2540
      N = I - ISPC
      IF (N .LE. 2) GO TO 910
C
C     CHECK FOR DUPLICATELY DEFINED ENFORCED DISPLACEMENTS ON SPC CARDS
C
      CALL SORT (0,0,2,1,Z(ISPC),N)
      N    = N - 2
      NOLD = 0
      DO 1110 K = 1,N,2
      IF (Z(ISPC+K-1) .EQ. NOLD) GO TO 1110
      IF (Z(ISPC+K-1) .NE. Z(ISPC+K+1)) GO TO 1110
      IF (Z(ISPC+K).EQ.0 .AND. Z(ISPC+K+2).EQ.0) GO TO 1110
      NOLD = Z(ISPC+K-1)
      NOGO = 1
      CALL PAGE2 (3)
      WRITE  (OUTTAP,1100) UFM,NOLD
 1100 FORMAT (A23,' 3147, ENFORCED DISPLACEMENT ON SPC CARDS SPECIFIED',
     1     ' MORE THAN ONCE', /5X,'FOR THE SAME COMPONENT.  SIL VALUE ='
     2,    I10)
 1110 CONTINUE
      IF (NOGO .NE. 0) GO TO 2540
      GO TO 910
C
C     FLUID PROBLEM AND NO SPC-S AT ALL.
C
 1120 SPCSET = 0
      GO TO 840
 1130 NSPC = I - 2
      ICRQ = NSPC - BUF3
      INSUFF = 740
      IF (ICRQ .GT. 0) GO TO 2430
C
C     DETERMINE IF ALL SPC SETS IN SPCADD SET LIST HAVE BEEN DEFINED
C
      IF (NOGO .NE. 0) GO TO 2540
      DO 1140 K = ISPCAD,NSPCAD,2
      IF (Z(K+1) .NE. 0) GO TO 1140
      IF (IAXIF.NE.0 .AND. Z(K).EQ.200000000) GO TO 1120
      NOGO   = 1
      BUF(1) = Z(K)
      BUF(2) = 0
      CALL MESAGE (30,53,BUF)
 1140 CONTINUE
      IF (NOGO .NE. 0) GO TO 2540
C
C     SORT THE SPC LIST AND WRITE IT ON SCR1
C
      N = NSPC - ISPC + 2
      CALL SORT  (0,0,2,1,Z(ISPC),N)
      CALL WRITE (SCR1,Z(ISPC),N,1)
C
C     READ ASET CARDS (IF PRESENT)
C
 1150 I = KNKL1
      CALL LOCATE (*1190,Z(BUF1),ASET,FLAG)
      ASSIGN 1170 TO RET
      ASSIGN 2470 TO RET1
      ASSIGN 1160 TO RET2
      ASSIGN 1180 TO RET3
      ASETX = 1
 1160 CALL READ (*2410,*1190,GEOMP,BUF,2,0,FLAG)
      GPOINT = BUF(1)
      GO TO 2100
 1170 INDEX = 15
      ICOMP = BUF(2)
      GO TO 2300
 1180 IF (ICOMP .NE. 0) GPOINT = GPOINT + ICOMP - 1
      Z(I) = GPOINT
      I    = I + 1
      IF (I .LE. BUF3) GO TO 1160
      ICRQ = I - BUF3
      INSUFF = 1445
      GO TO 2430
C
C     READ ASET1 CARDS (IF PRESENT)
C
 1190 IF (NOGO .NE. 0) GO TO 2540
      CALL LOCATE (*1260,Z(BUF1),ASET1,FLAG)
      ASETX = 1
      ASSIGN 1220 TO RET
      ASSIGN 2470 TO RET1
      ASSIGN 1210 TO RET2
      ASSIGN 1230 TO RET3
 1200 CALL READ (*2410,*1260,GEOMP,BUF,1,0,FLAG)
      IF (BUF(1) .NE. 0) CALL SCALEX (1,BUF(1),BUF(8))
 1210 CALL READ (*2410,*1260,GEOMP,BUF(2),1,0,FLAG)
      IF (BUF(2) .EQ. -1) GO TO 1200
      GPOINT = BUF(2)
      GO TO 2100
 1220 INDEX = 17
      ICOMP = BUF(1)
      GO TO 2300
 1230 IF (ICOMP .NE. 0) GO TO 1240
      Z(I) = GPOINT
      I    = I + 1
      GO TO 1210
 1240 GPOINT = GPOINT - 1
      DO 1250 IJK = 1,6
      IF (BUF(IJK+7) .EQ. 0) GO TO 1210
      Z(I) = GPOINT + BUF(IJK+7)
      I    = I + 1
 1250 CONTINUE
      GO TO  1210
 1260 IF (ASETX .NE. 1) GO TO 1270
      IF (NOGO  .NE. 0) GO TO 2540
C
C     SORT ASET AND ASET1 DATA AND WRITE IT ON SCR1
C
      N = I - KNKL1
      I = KNKL1
      CALL SORT  (0,0,1,1,Z(I),N)
      CALL WRITE (SCR1,Z(I),N,1)
 1270 CALL CLOSE (GEOMP,CLSREW)
 1280 CALL CLOSE (SCR1,CLSREW)
C
C     FORM THE BASIC USET BY READING EACH OF THE SUBSETS AND
C     TURNING ON THE APPROPRIATE BIT IN THE APPROPRIATE WORD
C
      FILE = SCR1
      CALL OPEN (*2400,SCR1,Z(BUF2),RDREW)
      DO 1290 K = 1,LUSET
 1290 Z(K)   = 0
      BUF(1) = MULTI
      BUF(2) = OMIT1
      BUF(3) = REACT
      BUF(4) = USGSET
      BUF(5) = SINGLE
      BUF(6) = ASETX
      ICOUNT = 0
      DO 1360 K = 1,6
      IF (BUF(K) .LT. 0) GO TO 1360
      IF (K .LT. 5) ICOUNT = ICOUNT + 1
      GO TO (1300,1310,1300,1300,1300,1310), K
 1300 MCBUST(5) = ORF(MCBUST(5),MASK(K))
      NOSETS = 1
      IF (K .EQ. 5) GO TO 1350
 1310 CALL READ (*2410,*1360,SCR1,J,1,0,FLAG)
      IF (K .EQ. 2) GO TO 1340
      IF (K .EQ. 6) GO TO 1330
      IF (ANDF(Z(J),MASK(K)) .NE. MASK(K)) GO TO 1340
      DUP = 1
      IF (IFLAG .NE. 0) GO TO 1320
      FILE = USET
      CALL OPEN (*2400,USET,Z(BUF1),WRTREW)
      IFLAG  = 1
      FILE   = SCR1
 1320 BUF(1) = J
      BUF(2) = K
      CALL WRITE (USET,BUF(1),2,0)
      GO TO 1340
 1330 IF (ANDF(Z(J),MSKUA) .NE. 0) GO TO 1310
 1340 Z(J) = ORF(Z(J),MASK(K))
      GO TO 1310
 1350 CALL READ (*2410,*1360,SCR1,BUF(7),2,0,FLAG)
      J    = BUF(7)
      Z(J) = ORF(Z(J),MASK(K))
      GO TO 1350
 1360 CONTINUE
      IF (DUP .EQ. 0) GO TO 1370
      CALL WRITE (USET,0,0,1)
      CALL CLOSE (USET,CLSREW)
 1370 CALL CLOSE (SCR1,CLSREW)
C
C     THE FOLLOWING CONVENTION WILL BE USED WITH REGARD TO DEGREES OF
C     FREEDOM NOT SPECIFICALLY INCLUDED OR OMITTED-
C       1. IF ASET OR ASET1 CARDS ARE PRESENT, UNSPECIFIED DEGREES OF
C          FREEDOM WILL BE OMITTED.
C       2. IF ASET OR ASET1 CARDS ARE NOT PRESENT AND OMIT OR OMIT1
C          CARDS ARE PRESENT, UNSPECIFIED DEGREES OF FREEDOM WILL BE
C          INCLUDED IN THE ANALYSIS SET.
C       3. IF NO ASET, ASET1, OMIT, OR OMIT 1 CARDS ARE PRESENT ALL
C          UNSPECIFIED DEGREES OF FREEDOM WILL BE INCLUDED IN THE
C          ANALYSIS SET.
C       4. IF BOTH ASET OR ASET1 CARDS AND OMIT OR OMIT1 CARDS ARE
C          SUPPLIED, UNSPECIFIED DEGREES OF FREEDOM WILL BE OMITTED.
C
      MSKRST = MASK(2)
      IF (ASETX .GT. 0) GO TO 1380
      MSKRST = MASK(6)
      IMSK   = 0
 1380 DO 1390 K = 1, LUSET
      IF (ANDF(MSKCK,Z(K)) .NE. 0) GO TO 1390
      IMSK = MSKRST
      Z(K) = ORF(Z(K),MSKRST)
 1390 CONTINUE
      IF (IMSK .EQ. MASK(6)) ASETX = 1
      IF (IMSK .EQ. MASK(2)) OMIT1 = 1
C
C     CALL SUBROUTINE GP4SP TO EXAMINE GRID POINT SINGULARITIES
C
      CALL GP4SP (BUF2,BUF3,BUF4)
C
C     TURN ON CERTAIN FLAGS IF THERE ARE OMIT OR ASET
C     DEGREES OF FREEDOM
C
      OMIT1 = -1
      DO 1400 K = 1,LUSET
      IF (ANDF(Z(K),MSKUO) .EQ. 0) GO TO 1400
      MCBUST(5) = ORF(MCBUST(5),MASK(2))
      NOSETS = 1
      OMIT1  = 1
      GO TO 1410
 1400 CONTINUE
 1410 DO 1420 K = 1,LUSET
      IF (ANDF(Z(K),MSKUA) .EQ. 0) GO TO 1420
      MCBUST(5) = ORF(MCBUST(5),MASK(6))
      NOL = 1
      GO TO 1430
 1420 CONTINUE
C
 1430 CALL OPEN (*2400,SCR1,Z(BUF2),RDREW)
      CALL SKPREC (SCR1,ICOUNT)
C
C     OPEN YS FILE. WRITE SPCSET IN YS HEADER.
C     IF NO USB SET (FROM SPC AND SPC1 CARDS), WRITE NULL COLUMN
C     FOR YS VECTOR. IF USB SET IS PRESENT, BUILD THE YS VECTOR.
C
      FILE = SCR1
      CALL OPEN (*1440,YS,Z(BUF3),WRTREW)
      NOYS = 1
      CALL FNAME (YS,BUF)
      BUF(3) = SPCSET
      CALL WRITE (YS,BUF,3,1)
 1440 IX = 0
      II = 1
      IF (SINGLE .GT. 0) GO TO 1450
      IF (NAUTO.GT.0 .OR. USGSET.GT.0) SINGLE = 1
      IF (NOYS .NE. 0) CALL BLDPK (1,1,YS,0,0)
      GO TO 1490
 1450 IF (NOYS .NE. 0) CALL BLDPK (1,1,YS,0,0)
 1460 CALL READ (*2410,*1490,SCR1,BUF,2,0,FLAG)
      J = BUF(1)
      IF (BUF(2) .EQ. 0) GO TO 1460
      DO 1470 K = II,J
      IF (ANDF(Z(K),MSKUS) .NE. 0) IX = IX + 1
 1470 CONTINUE
      II   = J + 1
      X(1) = BUF(2)
      IF (NOYS   .NE. 0) GO TO 1480
      IF (NOGOOF .NE. 0) GO TO 1460
      NOGO   = 1
      NOGOOF = 1
      CALL MESAGE (30,132,BUF)
      GO TO 1460
 1480 CALL ZBLPKI
      GO TO 1460
 1490 IF (NOYS .NE. 0) CALL BLDPKN (YS,0,MCBYS)
      IF (II .GT. LUSET) GO TO 1510
      DO 1500 K = II,LUSET
      IF (ANDF(Z(K),MSKUS) .NE. 0) IX = IX + 1
 1500 CONTINUE
 1510 MCBYS(3) = IX
      IF (NOYS .EQ. 0) GO TO 1520
      CALL WRTTRL (MCBYS)
      CALL CLOSE (YS,CLSREW)
 1520 CALL CLOSE (SCR1,CLSREW)
C
      IF (L21+L22.GT.0 .OR. IDSUB.GT.0) CALL GP4PRT (BUF1)
      IF (NAUTO .EQ. 0) GO TO 1540
C
C     CHANGE AUTO SPC FLAGS TO BOUNDARY SPC FLAGS
C
      J = 0
      DO 1530 K = 1,LUSET
      IF (ANDF(Z(K),MSKUS) .EQ. 0) GO TO 1530
      IF (ANDF(Z(K),MSKUSG).NE.0 .OR.  ANDF(Z(K),MSKUSB).NE.0)
     1    GO TO 1530
      Z(K) = MASK(5)
      J = 1
 1530 CONTINUE
      IF (J .EQ. 1) MCBUST(5) = ORF(MCBUST(5),MASK(5))
C
 1540 FILE = USET
      IF (DUP .EQ. 0) GO TO 1570
      CALL OPEN (*2400,USET,Z(BUF1),RDREW)
      FILE = SCR1
      CALL OPEN (*2400,SCR1,Z(BUF2),WRTREW)
      FILE = USET
 1550 CALL READ  (*1560,*1560,USET,BUF(1),2,0,FLAG)
      CALL WRITE (SCR1,BUF(1),2,0)
      GO TO 1550
 1560 CALL WRITE (SCR1,0,0,1)
      CALL CLOSE (USET,CLSREW)
 1570 CALL OPEN  (*2400,USET,Z(BUF1),WRTREW)
      CALL FNAME (USET,BUF)
      BUF(3) = SPCSET
      BUF(4) = MPCSET
      CALL WRITE (USET,BUF,4,1)
      CALL WRITE (USET,Z(1),LUSET,1)
      IF (NOL .EQ. 1) MCBUST(5)= ORF(MCBUST(5),MASK(6))
C
C     SEPARATE TRAILER WORD 4 INTO TWO PARTS
C
      MCBUST(4) = RSHIFT(MCBUST(5),IHALF)
      MCBUST(5) = ANDF(MCBUST(5),COMPLF(LSHIFT(MCBUST(4),IHALF)))
      CALL WRTTRL (MCBUST)
      CALL CLOSE (USET,CLSREW)
C
C     PROCESS USET FOR CONSISTENCY OF DISPLACEMENT SET DEFINITIONS.
C     EACH POINT IN USET MAY BELONG TO AT MOST ONE DEPENDENT SUBSET.
C
      FLAG    = 0
      MASK(1) = MSKUM
      MASK(2) = MSKUS
      MASK(3) = MSKUO
      MASK(4) = MSKUR
      MSKUMS  = ORF(MSKUM,MSKUS)
      MSKUOR  = ORF(MSKUO,MSKUR)
      BUF( 1) = ORF(MSKUS,MSKUOR)
      BUF( 2) = ORF(MSKUM,MSKUOR)
      BUF( 3) = ORF(MSKUR,MSKUMS)
      BUF(4)  = ORF(MSKUO,MSKUMS)
      MSKALL  = ORF(MSKUMS,MSKUOR)
      MSKAL   = ORF(MSKALL,MSKUL)
      DO 1620 I = 1,LUSET
      IUSET = Z(I)
      IDEPN = ANDF(MSKAL,IUSET)
      DO 1580 IK = 1,4
      IF (ANDF(MAK(IK),IDEPN) .EQ. MAK(IK)) GO TO 1600
 1580 CONTINUE
      IDEPN = ANDF(IUSET,MSKALL)
      IF (IDEPN .EQ. 0) GO TO 1620
      DO 1590 J = 1,4
      MSK1 = MASK(J)
      MSK2 = BUF( J)
      IF (ANDF(IDEPN,MSK1) .EQ. 0) GO TO 1590
      IF (ANDF(IDEPN,MSK2) .NE. 0) GO TO 1600
 1590 CONTINUE
      GO TO 1620
 1600 IF (FLAG.NE.0 .OR. IFLAG.NE.0) GO TO 1610
      FILE = SCR1
      CALL OPEN (*2400,SCR1,Z(BUF1),WRTREW)
 1610 BUF(5) = I
      BUF(6) = IDEPN
      FLAG   = 1
      CALL WRITE (SCR1,BUF(5),2,0)
 1620 CONTINUE
 1630 IF (MPCF1.GT.0 .OR. SINGLE.GT.0 .OR. OMIT1.GT.0 .OR.
     1    REACT.GT.0) NOSETS = 1
      IF (MPCF1.EQ.-1 .AND. SINGLE.EQ.-1 .AND. OMIT1.EQ.-1) NOA = -1
      IF (ANDF(MSKUA,MCBUST(5)).NE.0 .OR. OMIT1.LT.0) GO TO 1650
      CALL PAGE2 (2)
      WRITE  (OUTTAP,1640) UFM
 1640 FORMAT (A23,' 2403, INVALID TO HAVE AN O-SET WITH A NULL A-SET.')
      NOGO = 1
 1650 CONTINUE
      IF (NOGO .NE. 0) GO TO 2540
      IF (IFLAG.NE.0 .OR. FLAG.NE.0) GO TO 1920
C
C     RECOMPUTE YS MATRIX TO ACCOUNT FOR SPCD CARDS
C
C
      IF (NOYS.EQ.0 .OR . NOGEOM.EQ.0) GO TO 1910
C     BRING EQEXIN,SIL,AND USET BACK INTO CORE
C
      ASSIGN 1660 TO RET
      GO TO 80
 1660 CALL GOPEN (USET,Z(BUF1),0)
      FILE = USET
      CALL READ (*2410,*1670,USET,Z(KNKL1),BUF4-KNKL1,1,LUSET)
      ICRQ = BUF4
      INSUFF = 9711
      GO TO 2430
 1670 CALL CLOSE (USET,1)
C
C     CONVERT USET POINTERS INTO SILA VALUES
C
      M  = KNKL1
      N  = KNKL1 + LUSET - 1
      IX = 0
      DO 1690 I = M,N
      IF (ANDF(Z(I),MSKUS) .NE. 0) GO TO 1680
      Z(I) = 0
      GO TO 1690
 1680 IX  = IX + 1
      Z(I)= IX
 1690 CONTINUE
C
C     POSITION CASECC
C
      FILE  = CASECC
      ILOAD = N + 1
      ICRQ  = N + 2*NSKP1 + 1 - BUF4
      INSUFF = 977
      IF (ICRQ .GT. 0) GO TO 2430
      CALL GOPEN  (CASECC,Z(BUF1),0)
      CALL SKPREC (CASECC,NSKIP-1)
      DO 1710 I = 1,NSKP1
 1700 CALL FREAD (CASECC,BUF,16,1)
      IF (BUF(16) .NE. 0) GO TO 1700
      K      = ILOAD + 2*(I-1)
      Z(K  ) = BUF(4)
      Z(K+1) = 0
 1710 CONTINUE
      CALL CLOSE (CASECC,CLSREW)
C
C     CONVERT SPCD CARD TO SILA + VALUE AND WRITE ON SCR2
C
      CALL GOPEN (SCR2,Z(BUF2),1)
      FILE = GEOMP
      CALL PRELOC (*2400,Z(BUF1),GEOMP)
      CALL LOCATE (*1830,Z(BUF1),SPCD,FLAG)
      NN    = 2*NSKP1 + ILOAD - 2
      IOLD  = 0
      IRECN = 0
 1720 CALL READ (*2410,*1820,GEOMP,BUF,4,0,FLAG)
      DO 1730 I = ILOAD,NN,2
      IF (BUF(1) .EQ. Z(I)) GO TO 1740
 1730 CONTINUE
C
C     GO ON TO NEXT SET
C
      GO TO 1720
C
 1740 IF (BUF(1) .EQ. IOLD) GO TO 1760
      IF (IOLD .NE. 0) CALL WRITE (SCR2,0,0,1)
      IOLD  = BUF(1)
      IRECN = IRECN + 1
      DO 1750 I = ILOAD,NN,2
      IF (IOLD .EQ. Z(I)) Z(I+1) = IRECN
 1750 CONTINUE
 1760 GPOINT = BUF(2)
      ASSIGN 1770  TO RET
      ASSIGN 2530 TO RET1
      ASSIGN 1720  TO RET2
      ASSIGN 1780 TO RET3
      GO TO 2100
C
C     FOUND SIL
C
 1770 INDEX = 13
      ICOMP = BUF(3)
      GO TO 2300
 1780 IF (ICOMP .NE. 0) GO TO 1790
      M = KNKL1 + GPOINT - 1
      IF (Z(M) .EQ. 0) GO TO 1810
      MCB(1) = Z(M)
      MCB(2) = BUF(4)
      CALL WRITE (SCR2,MCB,2,0)
      GO TO 1720
C
C     BREAK UP COMPONENTS
C
 1790 CALL SCALEX (GPOINT,BUF(3),BUF(8))
      DO 1800 I = 1,6
      IF (BUF(I+7) .EQ. 0) GO TO 1720
      M = KNKL1 + BUF(I+7) - 1
      IF (Z(M) .EQ. 0) GO TO 1810
      MCB(1) = Z(M)
      MCB(2) = BUF(4)
      CALL WRITE (SCR2,MCB,2,0)
 1800 CONTINUE
      GO TO 1720
 1810 N      = 108
      BUF(1) = BUF(2)
      BUF(2) = BUF(I+7) - GPOINT
      GO TO 2520
C
C     END OF SPCD-S
C
 1820 IF (NOGO .NE. 0) GO TO 2540
      CALL WRITE (SCR2,0,0,1)
 1830 CALL CLOSE (GEOMP,1)
      CALL CLOSE (SCR2,1)
      IF (SINGLE .LT. 0) GO TO 1910
C
C     BRING IN OLD YS
C
      N = 2*NSKP1
      DO 1840 I = 1,N
      K = ILOAD + I - 1
 1840 Z(I) = Z(K)
      IOYS = N
      INYS = IOYS + IX
      ICRQ = INYS + IX - BUF4
      INSUFF = 988
      IF (ICRQ .GT. 0) GO TO 2430
      MCB(1) = YS
      CALL RDTRL (MCB)
      MCB(2) = 0
      MCB(6) = 0
      MCB(7) = 0
      CALL GOPEN (YS,Z(BUF1),0)
      ITB  = MCB(5)
      ITA1 = ITB
      ITB1 = ITB
      INCR = 1
      INCR1= 1
      II   = 1
      II1  = 1
      JJ   = MCB(3)
      JJ1  = JJ
      DO 1850 I = 1,IX
      RZ(IOYS+I) = 0.0
 1850 CONTINUE
      CALL UNPACK (*1860,YS,RZ(IOYS+1))
 1860 CALL CLOSE (YS,CLSREW)
      CALL GOPEN (YS,Z(BUF1),1)
      CALL GOPEN (SCR2,Z(BUF2),0)
      FILE = SCR2
      DO 1900 I = 1,N,2
C
C     COPY OLD YS TO NEW YS
C
      DO 1870 K = 1,IX
      RZ(INYS+K) = RZ(IOYS+K)
 1870 CONTINUE
      IF (Z(I+1) .EQ. 0) GO TO 1890
C
C     POSITION SCR2
C
      CALL SKPREC (SCR2,Z(I+1)-1)
 1880 CALL READ (*2410,*1890,SCR2,BUF,2,0,FLAG)
      K = BUF(1) + INYS
      RZ(K) = BUFR(2)
      GO TO 1880
C
C     PUT OUT COLUMN
C
 1890 CALL PACK (RZ(INYS+1),YS,MCB)
      CALL REWIND (SCR2)
      CALL FWDREC (*2410,SCR2)
 1900 CONTINUE
      CALL CLOSE  (YS,1)
      CALL WRTTRL (MCB)
      CALL CLOSE  (SCR2,1)
 1910 IF (NOGO .NE. 0) GO TO 2540
      IF (FLAG .NE. 0) GO TO 1920
      IF (IOGPST .EQ. 1) CALL MESAGE (17,IAUTSP,0)
      RETURN
C
C     INCONSISTENT DISPLACEMENT SET DEFINITIONS--
C     READ EQEXIN AND SIL INTO CORE. FOR EACH INCONSISTANT DEFINITION,
C     LOOK UP EXTERNAL NUMBER AND QUEUE MESSAGE.
C
 1920 CALL WRITE (SCR1,0,0,1)
      CALL CLOSE (SCR1,CLSREW)
      ASSIGN 1930 TO RET
      GO TO 80
 1930 CALL OPEN (*2400,SCR1,Z(BUF1),RDREW)
      ISIL = KM + 1
      NEQX = KN - 1
      Z(KNKL1) = LUSET + 1
 1940 CALL READ (*2080,*2080,SCR1,BUF(5),2,0,IFLG)
      DO 1950 I = ISIL,KNKL1
      IF (Z(I+1) .GT. BUF(5)) GO TO 1960
 1950 CONTINUE
 1960 INTRNL = I - KM
      KOMP = BUF(5) - Z(I) + 1
      IF (Z(I+1)-Z(I) .EQ. 1) KOMP = 0
      DO 1970 J = 1,NEQX,2
      IF (Z(J+1) .EQ. INTRNL) GO TO 1980
 1970 CONTINUE
 1980 IF (DUP .EQ. 0) GO TO 2070
      IF (IFLAG.EQ.0) GO TO 2070
      CALL PAGE2 (2)
      GO TO (1990,1940,2010,2030), IB6
 1990 IF (KOMP .EQ. 0) GO TO 2000
      NOGO = 1
      WRITE (OUTTAP,2050) UFM,Z(J),KOMP,MSET
      GO TO 1940
 2000 WRITE (OUTTAP,2060) UFM,Z(J),MSET
      NOGO = 1
      GO TO 1940
 2010 IF (KOMP .EQ. 0) GO TO 2020
      WRITE (OUTTAP,2050) UFM,Z(J),KOMP,R
      NOGO = 1
      GO TO 1940
 2020 WRITE (OUTTAP,2060) UFM,Z(J),R
      NOGO = 1
      GO TO 1940
 2030 IF (KOMP .EQ. 0) GO TO 2040
      WRITE (OUTTAP,2050) UFM,Z(J),KOMP,SG
      NOGO = 1
      GO TO 1940
 2040 WRITE (OUTTAP,2060) UFM,Z(J),SG
      NOGO = 1
      GO TO 1940
 2050 FORMAT (A23,' 2152, GRID POINT',I9,' COMPONENT',I3,
     1       ' DUPLICATELY DEFINED IN THE ',A4,5H SET.)
 2060 FORMAT (A23,' 2153, SCALAR POINT',I9,' DUPLICATELY DEFINED IN ',
     1       'THE ',A4,5H SET.)
 2070 BUF(7) = Z(J)
      BUF(8) = KOMP
      IF (ANDF(BUF(6),MSKUM) .NE. 0) BUF(8)= BUF(8) + 10
      IF (ANDF(BUF(6),MSKUS) .NE. 0) BUF(8)= BUF(8) + 100
      IF (ANDF(BUF(6),MSKUO) .NE. 0) BUF(8)= BUF(8) + 1000
      IF (ANDF(BUF(6),MSKUR) .NE. 0) BUF(8)= BUF(8) + 10000
      IF (ANDF(BUF(6),MSKUL) .NE. 0) BUF(8)= BUF(8) + 100000
      CALL MESAGE (30,101,BUF(7))
      GO TO 1940
 2080 IF (DUP   .EQ. 0) GO TO 2090
      IF (IFLAG .EQ. 0) GO TO 2090
      IFLAG = 0
      IF (FLAG .NE. 0) GO TO 1940
      CALL CLOSE (SCR1,CLSREW)
      GO TO 1630
 2090 CALL CLOSE (SCR1,CLSREW)
      GO TO 2540
C
C
C     INTERNAL SUBROUTINE TO PERFORM BINARY SEARCH IN EQEXIN
C     AND CONVERT THE EXTERNAL NUMBER TO A SIL VALUE AND A
C     CORRESPONDING TYPE CODE
C
 2100 KLO = 0
      KHI = KN2
      LASTK = 0
 2110 K = (KLO+KHI+1)/2
      IF (LASTK .EQ. K) GO TO 2150
      LASTK = K
      IF (GPOINT-Z(2*K-1)) 2120,2140,2130
 2120 KHI = K
      GO TO 2110
 2130 KLO = K
      GO TO 2110
 2140 K = 2*K + KN
      IPOINT = GPOINT
      GPOINT = Z(K)/10
      ICODE  = Z(K) - 10*GPOINT
      GO TO RET, (260,630,680,750,970,1050,1770,1170,1220)
 2150 GO TO RET1, (2460,2470,2480,2490,2530)
C
C
C     INTERNAL SUBROUTINE TO SORT THE SCALAR COMPONENTS
C
 2200 DO 2210 II = 1,6
      IF (BUF(II+7) .EQ. 0) GO TO 2220
 2210 CONTINUE
      II = 7
 2220 N  = II - 1
      IF (N .EQ. 0) GO TO RET, (810)
      DO 2240 II = 1,N
      IJK = LUSET + 1
      DO 2230 JJ = II,N
      IF (BUF(JJ+7) .GE. IJK) GO TO 2230
      IJK = BUF(JJ+7)
      JJX = JJ
 2230 CONTINUE
      BUF(JJX+7) = BUF(II+7)
 2240 BUF(II +7) = IJK
      GO TO RET, (810)
C
C     CHECK TO SEE IF GRID AND SCALAR POINTS HAVE BEEN PROPERLY USED
C     ON CONSTRAINT CARDS
C
 2300 IF (ICODE .EQ. 2) GO TO 2320
C
C     GRID POINTS ARE CHECKED HERE
C
      IF (ICOMP .GT. 0) GO TO 2350
      NOGO = 1
      CALL PAGE2 (2)
      WRITE  (OUTTAP,2310) UFM,IPOINT,CTYPE(INDEX),CTYPE(INDEX+1)
 2310 FORMAT (A23,' 3145, COMPONENT 0 (OR BLANK) SPECIFIED FOR GRID ',
     1       'POINT',I9,4H ON ,2A4,6HCARDS.)
      GO TO 2340
C
C     SCALAR POINTS ARE CHECKED HERE
C
 2320 IF (ICOMP .LE. 1) GO TO 2350
      NOGO = 1
      CALL PAGE2 (2)
      WRITE  (OUTTAP,2330) UFM,IPOINT,CTYPE(INDEX),CTYPE(INDEX+1)
 2330 FORMAT (A23,' 3146, ILLEGAL COMPONENT SPECIFIED FOR SCALAR POINT',
     1        I9,4H ON ,2A4,6HCARDS.)
 2340 GO TO RET2, (250,620,670,740,960,1020,1720,1160,1210)
 2350 GO TO RET3, (270,640,690,760,980,1060,1780,1180,1230)
C
C
C     FATAL ERROR MESSAGES
C
 2400 J = -1
      GO TO 2450
 2410 J = -2
      GO TO 2450
 2420 J = -3
      GO TO 2450
 2430 J = -8
      WRITE  (OUTTAP,2440) INSUFF
 2440 FORMAT (/33X,'GP4 INSUFFICIENT CORE AT ',I5)
      FILE = ICRQ
 2450 CALL MESAGE (J,FILE,NAME)
 2460 BUF(1) = GPOINT
      BUF(2) = MPCSET
      N = 48
      GPOINT = 1
      GO TO 2520
 2470 BUF(1) = GPOINT
      GPOINT = 1
      N = 49
      GO TO 2510
 2480 BUF(1) = GPOINT
      GPOINT = 1
      N = 50
      GO TO 2510
 2490 N = 51
 2500 BUF(1) = GPOINT
      BUF(2) = SPCSET
      GPOINT = 1
CWKBNB 3/95 NCL94002
      IF ( L51 .EQ. 0 ) GO TO 2520
      WRITE ( OUTTAP, 9001 ) UWM, 2051, BUF(1), SPCSET
9001  FORMAT( A25,I5,' UNDEFINED GRID POINT ',I6,' IN SINGLE-POINT'
     &,' CONSTRAINT SET ',I8)
      GO TO 2521
CWKBNE 3/95 NCL94002
 2510 BUF(2) = 0
 2520 NOGO   = 1
      CALL MESAGE (30,N,BUF)
CWKBI  3/95 NCL94002
 2521 CONTINUE
      GO TO RET2, (250,620,670,740,960,1020,1720,1160,1210)
 2530 N = 52
      GO TO 2500
 2540 IF (L21+L22.GT.0 .OR. IDSUB.GT.0) CALL GP4PRT (-BUF4)
      J = -37
      GO TO 2450
      END

      SUBROUTINE ALG08
C
      REAL LOSS,LAMI,LAMIP1,LAMIM1
C
      DIMENSION XX1(21),DLADM(21),DSDM(21),DRVWDM(21),DL(21),DSDL(21),DP
     1HIDL(21),FX1(21),FX2(21),VVOLD(21),AFUN(20),BFUN(20),HS(20),XM2(20
     2),VMMAX(21),DVMDVM(20),TEIP1(21),TBIP1(21)
C
      COMMON /UD300C/ NSTNS,NSTRMS,NMAX,NFORCE,NBL,NCASE,NSPLIT,NREAD,
     1NPUNCH,NPAGE,NSET1,NSET2,ISTAG,ICASE,IFAILO,IPASS,I,IVFAIL,IFFAIL,
     2NMIX,NTRANS,NPLOT,ILOSS,LNCT,ITUB,IMID,IFAIL,ITER,LOG1,LOG2,LOG3,
     3LOG4,LOG5,LOG6,IPRINT,NMANY,NSTPLT,NEQN,NSPEC(30),NWORK(30),
     4NLOSS(30),NDATA(30),NTERP(30),NMACH(30),NL1(30),NL2(30),NDIMEN(30)
     5,IS1(30),IS2(30),IS3(30),NEVAL(30),NDIFF(4),NDEL(30),NLITER(30),
     6NM(2),NRAD(2),NCURVE(30),NWHICH(30),NOUT1(30),NOUT2(30),NOUT3(30),
     7NBLADE(30),DM(11,5,2),WFRAC(11,5,2),R(21,30),XL(21,30),X(21,30),
     8H(21,30),S(21,30),VM(21,30),VW(21,30),TBETA(21,30),DIFF(15,4),
     9FDHUB(15,4),FDMID(15,4),FDTIP(15,4),TERAD(5,2),DATAC(100),
     1DATA1(100),DATA2(100),DATA3(100),DATA4(100),DATA5(100),DATA6(100),
     2DATA7(100),DATA8(100),DATA9(100),FLOW(10),SPEED(30),SPDFAC(10),
     3BBLOCK(30),BDIST(30),WBLOCK(30),WWBL(30),XSTN(150),RSTN(150),
     4DELF(30),DELC(100),DELTA(100),TITLE(18),DRDM2(30),RIM1(30),
     5XIM1(30),WORK(21),LOSS(21),TANEPS(21),XI(21),VV(21),DELW(21),
     6LAMI(21),LAMIM1(21),LAMIP1(21),PHI(21),CR(21),GAMA(21),SPPG(21),
     7CPPG(21),HKEEP(21),SKEEP(21),VWKEEP(21),DELH(30),DELT(30),VISK,
     8SHAPE,SCLFAC,EJ,G,TOLNCE,XSCALE,PSCALE,PLOW,RLOW,XMMAX,RCONST,
     9FM2,HMIN,C1,PI,CONTR,CONMX
C
      ITMAX=20
      LPMAX=10
      K=1
      IF(I.EQ.ISTAG)K=2
      XN=SPEED(I)*SPDFAC(ICASE)*PI/(30.0*SCLFAC)
      IF(I.EQ.1)GO TO 234
      DO 100 J=1,NSTRMS
      LAMIM1(J)=LAMI(J)
      LAMI(J)=LAMIP1(J)
100   LAMIP1(J)=1.0
      IF(I.EQ.NSTNS)GO TO 234
      IF(NDATA(I+1).EQ.0)GO TO 210
      L1=NDIMEN(I+1)+1
      GO TO(110,130,150,170),L1
110   DO 120 J=1,NSTRMS
120   XX1(J)=R(J,I+1)
      GO TO 190
130   DO 140 J=1,NSTRMS
140   XX1(J)=R(J,I+1)/R(NSTRMS,I+1)
      GO TO 190
150   DO 160 J=1,NSTRMS
160   XX1(J)=XL(J,I+1)
      GO TO 190
170   DO 180 J=1,NSTRMS
180   XX1(J)=XL(J,I+1)/XL(NSTRMS,I+1)
190   L1=IS2(I+1)
      CALL ALG01(DATAC(L1),DATA4(L1),NDATA(I+1),XX1,XX1,X1,NSTRMS,NTERP
     1(I+1),0)
      DO 200 J=1,NSTRMS
200   LAMIP1(J)=1.0-XX1(J)
210   DO 220 J=1,NSTRMS
      X1=SQRT((R(J,I+1)-R(J,I))**2+(X(J,I+1)-X(J,I))**2)
      X2=SQRT((R(J,I)-RIM1(J))**2+(X(J,I)-XIM1(J))**2)
      X3=ATAN2(R(J,I+1)-R(J,I),X(J,I+1)-X(J,I))
      X4=ATAN2(R(J,I)-RIM1(J),X(J,I)-XIM1(J))
      PHI(J)=(X3+X4)/2.0
      CR(J)=(X3-X4)/(X1+X2)*2.0
      DSDM(J)=0.0
      DRVWDM(J)=0.0
      DLADM(J)=((LAMIP1(J)-LAMI(J))/X1+(LAMI(J)-LAMIM1(J))/X2)/2.0
      IF(IPASS.EQ.1)GO TO 220
      DSDM(J)=((S(J,I+1)-S(J,I))/X1+(S(J,I)-S(J,I-1))/X2)/2.0*G*EJ
      DRVWDM(J)=((R(J,I+1)*VW(J,I+1)-R(J,I)*VW(J,I))/X1+(R(J,I)*VW(J,I)-
     1RIM1(J)*VW(J,I-1))/X2)/(2.0*R(J,I))
220   CONTINUE
      IF(IPASS.EQ.1.OR.NDATA(I).EQ.0.OR.NEQN.EQ.1.OR.NWORK(I).NE.0.OR.NW
     1ORK(I+1).EQ.0)GO TO 390
      L1=NDIMEN(I)+1
      GO TO(221,223,225,227),L1
221   DO 222 J=1,NSTRMS
222   TEIP1(J)=R(J,I)
      GO TO 229
223   DO 224 J=1,NSTRMS
224   TEIP1(J)=R(J,I)/R(NSTRMS,I)
      GO TO 229
225   DO 226 J=1,NSTRMS
226   TEIP1(J)=XL(J,I)
      GO TO 229
227   DO 228 J=1,NSTRMS
228   TEIP1(J)=XL(J,I)/XL(NSTRMS,I)
229   L1=IS2(I)
      CALL ALG01(DATAC(L1),DATA3(L1),NDATA(I),TEIP1,TEIP1,X1,NSTRMS,NTE
     1RP(I),0)
      X1=SPEED(I+1)*SPDFAC(ICASE)*PI/(30.0*SCLFAC)
      DO 230 J=1,NSTRMS
      TEIP1(J)=TAN(TEIP1(J)/C1)
230   TBIP1(J)=(VW(J,I)-X1*R(J,I))/VM(J,I)
      GO TO 390
234   DO 240 J=1,NSTRMS
      DLADM(J)=0.0
      DSDM(J)=0.0
      DRVWDM(J)=0.0
240   CR(J)=0.0
      IF(I.EQ.1)GO TO 244
      DO 246 J=1,NSTRMS
246   PHI(J)=ATAN2(R(J,I)-RIM1(J),X(J,I)-XIM1(J))
      GO TO 390
244   DO 260 J=1,NSTRMS
260   PHI(J)=ATAN2(R(J,2)-R(J,1),X(J,2)-X(J,1))
      DO 270 J=1,NSTRMS
      XI(J)=H(J,1)
      LAMI(J)=1.0
270   LAMIP1(J)=1.0
      IF(NDATA(2).EQ.0)GO TO 390
      L2=NDIMEN(2)+1
      GO TO(290,310,330,350),L2
290   DO 300 J=1,NSTRMS
300   XX1(J)=R(J,2)
      GO TO 370
310   DO 320 J=1,NSTRMS
320   XX1(J)=R(J,2)/R(NSTRMS,2)
      GO TO 370
330   DO 340 J=1,NSTRMS
340   XX1(J)=XL(J,2)
      GO TO 370
350   DO 360 J=1,NSTRMS
360   XX1(J)=XL(J,2)/XL(NSTRMS,2)
370   L1=IS2(2)
      CALL ALG01(DATAC(L1),DATA4(L1),NDATA(2),XX1,XX1,X1,NSTRMS,NTERP(2
     1),0)
      DO 380 J=1,NSTRMS
380   LAMIP1(J)=1.0-XX1(J)
390   CALL ALG01(R(1,I),X(1,I),NSTRMS,R(1,I),X1,GAMA,NSTRMS,0,1)
      DO 400 J=1,NSTRMS
      GAMA(J)=ATAN(GAMA(J))
      SPPG(J)=GAMA(J)+PHI(J)
      CPPG(J)=COS(SPPG(J))
      SPPG(J)=SIN(SPPG(J))
400   VV(J)=VM(J,I)
      DO 410 J=1,ITUB
      DL(J)=XL(J+1,I)-XL(J,I)
      DSDL(J)=(S(J+1,I)-S(J,I))/DL(J)*G*EJ
410   DPHIDL(J)=(PHI(J+1)-PHI(J))/DL(J)
      IF(I.EQ.1.OR.NWORK(I).GE.5)GO TO 430
      DO 420 J=1,ITUB
      DVMDVM(J)=0.0
      FX1(J)=(VW(J+1,I)+VW(J,I))/(R(J+1,I)+R(J,I))*(R(J+1,I)*VW(J+1,I)-R
     1(J,I)*VW(J,I))/DL(J)
420   FX2(J)=(H(J+1,I)-H(J,I))/DL(J)*G*EJ
      DO 426 J=1,NSTRMS
      X1=ALG8(H(J,I),S(J,I))
      X1=(2.0/ALG9(H(J,I),S(J,I),1.0)-VW(J,I)**2*(X1-1.0))/(X1+1.0)
      IF(X1.GT.1.0)GO TO 426
      IF(IPASS.LE.NFORCE)GO TO 424
      CALL ALG03(LNCT,1)
      WRITE(LOG2,422)IPASS,I,J,X1
422   FORMAT(5X,4HPASS,I3,9H  STATION,I3,12H  STREAMLINE,I3,40H  LIMITIN
     1G MERIDIONAL VELOCITY SQUARED =,E12.5)
424   X1=6250000.0
      IF(IFAILO.EQ.0)IFAILO=I
426   VMMAX(J)=SQRT(X1)
      GO TO 450
430   DO 440 J=1,ITUB
      FX1(J)=(TBETA(J+1,I)+TBETA(J,I))/(R(J+1,I)+R(J,I))*(R(J+1,I)*TBETA
     1(J+1,I)-R(J,I)*TBETA(J,I))/DL(J)
440   FX2(J)=(XI(J+1)-XI(J))/DL(J)*G*EJ
      DO 446 J=1,NSTRMS
      X1=XI(J)+(XN*R(J,I))**2/(2.0*G*EJ)
      X1=1.0/(ALG9(X1,S(J,I),1.0)*(1.0+(ALG8(X1,S(J,I))-1.0)*(1.0+TBETA(
     1J,I)**2)/2.0))
      IF(X1.GT.1.0)GO TO 446
      IF(IPASS.LE.NFORCE)GO TO 442
      CALL ALG03(LNCT,1)
      WRITE(LOG2,422)IPASS,I,J,X1
442   X1=6250000.0
      IF(IFAILO.EQ.0)IFAILO=I
446   VMMAX(J)=SQRT(X1)
450   VMAX=0.0
      VMIN=1.05*VMMAX(IMID)
      ITER=0
460   ITER=ITER+1
      IFAIL=0
      ICONF1=0
      DO 470 J=1,NSTRMS
470   VVOLD(J)=VV(J)
      IF(I.EQ.1.OR.NWORK(I).GE.5)GO TO 810
      DO 580 J=1,ITUB
      X1=(H(J,I)+H(J+1,I))/2.0-(((VVOLD(J)+VVOLD(J+1))/2.0)**2+((VW(J,I)
     1+VW(J+1,I))/2.0)**2)/(2.0*G*EJ)
      IF(X1.GE.HMIN)GO TO 520
      IF(IPASS.LE.NFORCE)GO TO 510
      IF(LNCT.LT.NPAGE)GO TO 480
      WRITE(LOG2,500)
      LNCT=1
480   LNCT=LNCT+1
      WRITE(LOG2,490)IPASS,I,ITER,J,X1
490   FORMAT(5X,4HPASS,I3,9H  STATION,I3,11H  ITERATION,I3,12H  STREAMTU
     1BE,I3,53H  STATIC ENTHALPY BELOW LIMIT IN MOMENTUM EQUATION AT,E13
     2.5)
500   FORMAT(1H1)
510   IFAIL=1
      X1=HMIN
520   X2=(S(J,I)+S(J+1,I))/2.0
      X6=ALG8(X1,X2)
      X7=ALG7(X1,X2)
      X1=ALG9(X1,X2,((VVOLD(J)+VVOLD(J+1))/2.0)**2)
      XQ=X1
      IF(X1.LE.0.9801)GO TO 560
      IF(IPASS.LE.NFORCE)GO TO 550
      IF(LNCT.LT.NPAGE)GO TO 530
      WRITE(LOG2,500)
      LNCT=1
530   LNCT=LNCT+1
      X1=SQRT(X1)
      WRITE(LOG2,540)IPASS,I,ITER,J,X1
540   FORMAT(5X,4HPASS,I3,9H  STATION,I3,11H  ITERATION,I3,12H  STREAMTU
     1BE,I3,39H  MERIDIONAL MACH NUMBER ABOVE LIMIT AT,E13.5)
550   IFAIL=1
      X1=0.9801
560   X2=(CPPG(J)+CPPG(J+1))/2.0
      X3=(SPPG(J)+SPPG(J+1))/2.0
      AFUN(J)=-2.0/(1.0-X1)*((1.0-X2*X2*XQ)*(CR(J)+CR(J+1))/(2.0*X2)-X3/
     1X2*DPHIDL(J)-X3*(SIN((PHI(J)+PHI(J+1))/2.0)/(R(J,I)+R(J+1,I))*2.0*
     2(1.0+X1*((VW(J,I)+VW(J+1,I))/(VVOLD(J)+VVOLD(J+1)))**2)+(DLADM(J)+
     3DLADM(J+1))/(LAMI(J)+LAMI(J+1))))
      BFUN(J)=2.0*(FX2(J)-X7*DSDL(J)-FX1(J))
      IF(I.EQ.NSTNS.OR.IPASS.EQ.1)GO TO 580
      IF(NEQN.EQ.1.OR.NDATA(I).EQ.0.OR.(NWORK(I).EQ.0.AND.NWORK(I+1).EQ.
     10))GO TO 570
      IF(NWORK(I).EQ.0)GO TO 564
      X4=(TBETA(J,I)+TBETA(J+1,I))/2.0
      X5=(TANEPS(J)+TANEPS(J+1))/2.0
562   BFUN(J)=BFUN(J)+2.0*(X7*(DSDM(J)+DSDM(J+1))/2.0*(X3*(1.0/(1.0+X4*X
     14)+X6*X1/(1.0-X1))-X5*X4/(1.0+X4*X4))-(VVOLD(J)+VVOLD(J+1))*.25*(D
     2RVWDM(J)+DRVWDM(J+1))*(X5-X3*X1/(1.0-X1)*X4))
      GO TO 580
564   X4=(TBIP1(J)+TBIP1(J+1))*0.5
      X5=(TEIP1(J)+TEIP1(J+1))*0.5
      GO TO 562
570   BFUN(J)=BFUN(J)+X7*(DSDM(J)+DSDM(J+1))*X3*(1.0-X1*(X6-1.0))/(1.0-X
     11)
580   CONTINUE
      VV(IMID)=VVOLD(IMID)**2
      J=IMID
      JINC=1
590   JOLD=J
      J=J+JINC
      JJ=JOLD
      IF(JINC.EQ.-1)JJ=J
      IF(ABS(AFUN(JJ)).LE.1.0E-5) GO TO 660
      X1=-AFUN(JJ)*(XL(J,I)-XL(JOLD,I))
      IF(X1.LE.88.0)GO TO 630
      IF(IPASS.LE.NFORCE)GO TO 620
      IF(LNCT.LT.NPAGE)GO TO 600
      WRITE(LOG2,500)
      LNCT=1
600   LNCT=LNCT+1
      WRITE(LOG2,610)IPASS,I,ITER,JJ,X1
610   FORMAT(5X,4HPASS,I3,9H  STATION,I3,11H  ITERATION,I3,12H  STREAMTU
     1BE,I3,43H  MOMENTUM EQUATION EXPONENT ABOVE LIMIT AT,E13.5)
620   IFAIL=1
      X1=88.0
630   X1=EXP(X1)
      VV(J)=VV(JOLD)*X1+(1.0-X1)*BFUN(JJ)/AFUN(JJ)
640   IF(J.EQ.K)GO TO 670
      IF(J.EQ.NSTRMS)GO TO 650
      GO TO 590
650   J=IMID
      JINC=-1
      GO TO 590
660   VV(J)=VV(JOLD)+BFUN(JJ)*(XL(J,I)-XL(JOLD,I))
      GO TO 640
670   DO 710 J=K,NSTRMS
      IF(VV(J).LE.4.0*VVOLD(IMID)**2)GO TO 676
      IFAIL=1
      IF(IPASS.LE.NFORCE)GO TO 674
      CALL ALG03(LNCT,1)
      WRITE(LOG2,672)IPASS,I,ITER,J
672   FORMAT(5X,4HPASS,I3,9H  STATION,I3,11H  ITERATION,I3,12H  STREAMLI
     1NE,I3,50H  MERIDIONAL VELOCITY GREATER THAN TWICE MID VALUE)
674   VV(J)=4.0*VVOLD(IMID)**2
676   IF(VV(J).GE.1.0)GO TO 702
      IF(IPASS.LE.NFORCE)GO TO 700
      IF(LNCT.LT.NPAGE)GO TO 680
      WRITE(LOG2,500)
      LNCT=1
680   LNCT=LNCT+1
      WRITE(LOG2,690)IPASS,I,ITER,J,VV(J)
690   FORMAT(5X,4HPASS,I3,9H  STATION,I3,11H  ITERATION,I3,12H  STREAMLI
     1NE,I3,46H  (MERIDIONAL VELOCITY) SQUARED BELOW LIMIT AT,E13.5)
700   VV(J)=1.0
      IFAIL=1
      GO TO 710
702   VV(J)=SQRT(VV(J))
      IF(VV(J).LE.VMMAX(J))GO TO 710
      IFAIL=1
      IF(IPASS.LE.NFORCE)GO TO 708
      CALL ALG03(LNCT,1)
      WRITE(LOG2,706)IPASS,I,ITER,J,VV(J),VMMAX(J)
706   FORMAT(5X,4HPASS,I3,9H  STATION,I3,11H  ITERATION,I3,12H  STREAMLI
     1NE,I3,44H  MERIDIONAL VELOCITY ABOVE SOUND SPEED  VM=,F8.2,3H A=,F
     28.2)
708   VV(J)=VMMAX(J)
710   CONTINUE
      X1=0.0
      DO 712 J=K,ITUB
712   X1=X1+(XL(J+1,I)-XL(J,I))*ABS((VV(J+1)+VV(J))/(VVOLD(J+1)+VVOLD(J)
     1)-1.0)
      X1=X1/(XL(NSTRMS,I)-XL(K,I))
      X2=0.1
      IF(X1.LT.0.2)X2=EXP(-11.52*X1)
      DO 715 J=K,NSTRMS
715   VV(J)=VVOLD(J)+X2*(VV(J)-VVOLD(J))
      IF(NLOSS(I).EQ.1.AND.NL2(I).EQ.0)CALL ALG07
      DO 800 J=1,ITUB
      HS(J)=(H(J,I)+H(J+1,I))/2.0-(((VV(J)+VV(J+1))/2.0)**2+((VW(J,I)+VW
     1(J+1,I))/2.0)**2)/(2.0*G*EJ)
      IF(HS(J).GE.HMIN)GO TO 800
      IF(IPASS.LE.NFORCE)GO TO 790
      IF(LNCT.LT.NPAGE)GO TO 770
      WRITE(LOG2,500)
      LNCT=1
770   LNCT=LNCT+1
      WRITE(LOG2,780)IPASS,I,ITER,J,HS(J)
780   FORMAT(5X,4HPASS,I3,9H  STATION,I3,11H  ITERATION,I3,12H  STREAMTU
     1BE,I3,55H  STATIC ENTHALPY BELOW LIMIT IN CONTINUITY EQUATION AT,E
     213.5)
790   IFAIL=1
      HS(J)=HMIN
800   XM2(J)=ALG9(HS(J),(S(J,I)+S(J+1,I))/2.0,((VV(J)+VV(J+1))/2.0)**2)
      GO TO 1100
810   J=IMID
      JINC=1
820   LOOP=1
      JOLD=J
      J=J+JINC
      JJ=JOLD
      IF(JINC.EQ.-1)JJ=J
830   VOLD=VV(J)
      VAV=(VOLD+VV(JOLD))/2.0
      IFAIE=0
      ICONF2=0
      X2=(TBETA(J,I)+TBETA(JOLD,I))/2.0
      X1=(XI(J)+XI(JOLD))/2.0+((XN*(R(J,I)+R(JOLD,I))/2.0)**2-VAV**2*(1.
     10+X2*X2))/(2.0*G*EJ)
      IF(X1.GE.HMIN)GO TO 870
      IF(IPASS.LE.NFORCE)GO TO 860
      IF(LNCT.LT.NPAGE)GO TO 840
      WRITE(LOG2,500)
      LNCT=1
840   LNCT=LNCT+1
      WRITE(LOG2,850)IPASS,I,ITER,JJ,LOOP,X1
850   FORMAT(5X,4HPASS,I3,9H  STATION,I3,11H  ITERATION,I3,12H  STREAMTU
     1BE,I3,6H  LOOP,I3,43H  STATIC H IN MOMENTUM EQUN. BELOW LIMIT AT,E
     213.5)
860   IFAIE=1
      ICONF2 = 1
      X1=HMIN
870   X3=(S(J,I)+S(JOLD,I))/2.0
      X6=ALG8(X1,X3)
      X7=ALG7(X1,X3)
      X1=ALG9(X1,X3,VAV*VAV)
      IF(X1.LE.0.9801)GO TO 910
      IF(IPASS.LE.NFORCE)GO TO 900
      IF(LNCT.LT.NPAGE)GO TO 880
      WRITE(LOG2,500)
      LNCT=1
880   LNCT=LNCT+1
      X1=SQRT(X1)
      WRITE(LOG2,890)IPASS,I,ITER,JJ,LOOP,X1
890   FORMAT(5X,4HPASS,I3,9H  STATION,I3,11H  ITERATION,I3,12H  STREAMTU
     1BE,I3,6H  LOOP,I3,39H  MERIDIONAL MACH NUMBER ABOVE LIMIT AT,E13.5
     2)
900   IFAIE=1
      ICONF2=1
      X1=0.9801
910   X4=(SPPG(J)+SPPG(JOLD))/2.0
      X5=(CPPG(J)+CPPG(JOLD))/2.0
      X9=(R(J,I)+R(JOLD,I))*0.5
      X10=SIN((PHI(J)+PHI(JOLD))*0.5)
      X11=(1.0-X5*X5*X1)*(CR(J)+CR(JOLD))*0.5/X5-X4/X5*DPHIDL(JJ)-X4*(X1
     10/X9*(1.0+X1*(X2+XN*X9/VAV)**2)+(DLADM(J)+DLADM(JOLD))/(LAMI(J)+LA
     2MI(JOLD)))
      DV2DL=FX2(JJ)-X7*DSDL(JJ)-2.0*XN*VAV*X2*COS((GAMA(J)+GAMA(JOLD))*0
     1.5)+VAV*VAV*(X11/(1.0-X1)-FX1(JJ))
      X12=1.0/(1.0+X2*X2)
      DVMDVM(JJ)=X12*((X7*DSDL(JJ)-FX2(JJ))/VAV**2-FX1(JJ)+X11/(1.0-X1))
      IF(I.EQ.1.OR.I.EQ.NSTNS.OR.IPASS.EQ.1)GO TO 920
      IF(NEQN.EQ.1)GO TO 914
      X8=(TANEPS(J)+TANEPS(JOLD))*0.5
      X5=0.5*(DSDM(J)+DSDM(JOLD))*X7*(X4*(X12+X6*X1/(1.0-X1))-X8*X2*X12)
      DV2DL=DV2DL+X5-VAV*(DRVWDM(J)+DRVWDM(JOLD))*0.5*(X8-X4*X1*X2/(1.0-
     1X1))
      DVMDVM(JJ)=DVMDVM(JJ)-X5*X12/VAV**2
      GO TO 920
914   X5=0.5*(DSDM(J)+DSDM(JOLD))*X7*X4*(1.0-X1*(X6-1.0))/(1.0-X1)
      DV2DL=DV2DL+X5
      DVMDVM(JJ)=DVMDVM(JJ)-X5*X12/VAV**2
920   DV2DL=DV2DL*2.0*X12
      X1=VV(JOLD)**2+DV2DL*(XL(J,I)-XL(JOLD,I))
      IF(X1.LE.9.0*VVOLD(IMID)**2)GO TO 938
      ICONF2=1
      IFAIE=1
      IF(IPASS.LE.NFORCE)GO TO 936
      CALL ALG03(LNCT,1)
      X1=SQRT(X1)
      X2=3.0*VVOLD(IMID)
      WRITE(LOG2,934)IPASS,I,ITER,J,LOOP,X1,X2
934   FORMAT(5X,4HPASS,I3,9H  STATION,I3,11H  ITERATION,I3,12H  STREAMLI
     1NE,I3,6H  LOOP,I3,33H  MERIDIONAL VELOCITY ABOVE LIMIT,E13.5,9H  L
     2IMIT =,E13.5)
936   X1=9.0*VVOLD(IMID)**2
938   IF(X1.GE.1.0)GO TO 950
      IF(IPASS.LE.NFORCE)GO TO 944
      IF(LNCT.LT.NPAGE)GO TO 930
      WRITE(LOG2,500)
      LNCT=1
930   LNCT=LNCT+1
      WRITE(LOG2,940)IPASS,I,ITER,J ,LOOP,X1
940   FORMAT(5X,4HPASS,I3,9H  STATION,I3,11H  ITERATION,I3,12H  STREAMLI
     1NE,I3,6H  LOOP,I3,46H  (MERIDIONAL VELOCITY) SQUARED BELOW LIMIT A
     2T,E13.5)
944   X1=1.0
      IFAIE=1
      ICONF2=1
950   VV(J)=SQRT(X1)
      IF(VV(J).LE.VMMAX(J))GO TO 958
      IFAIE=1
      ICONF2=1
      IF(IPASS.LE.NFORCE)GO TO 956
      CALL ALG03(LNCT,1)
      WRITE(LOG2,706)IPASS,I,ITER,J,VV(J),VMMAX(J)
956   VV(J)=VMMAX(J)
958   IF(ABS(VV(J)/VOLD-1.0).LE.TOLNCE*0.2)GO TO 990
      IF(LOOP.GE.LPMAX)GO TO 960
      LOOP=LOOP+1
      GO TO 830
960   ICONF2=1
      IF(IPASS.LE.NFORCE)GO TO 990
      IF(LNCT.LT.NPAGE)GO TO 970
      WRITE(LOG2,500)
      LNCT=1
970   LNCT=LNCT+1
      WRITE(LOG2,980)IPASS,I,ITER,J,VV(J),VOLD
980   FORMAT(5X,4HPASS,I3,9H  STATION,I3,11H  ITERATION,I3,12H  STREAMLI
     1NE,I3,38H  MERIDIONAL VELOCITY UNCONVERGED  VM=,E13.6,9H VM(OLD)=,
     2E13.6)
990   IF(IFAIE.EQ.1)IFAIL=1
      IF(ICONF2.EQ.1)ICONF1=1
      IF(J.EQ.NSTRMS)GO TO 1000
      IF(J.EQ.1)GO TO 1010
      GO TO 820
1000  J=IMID
      JINC=-1
      GO TO 820
1010  IF(I.EQ.1)GO TO 1014
      IF(NLOSS(I).EQ.2.OR.(NLOSS(I).EQ.1.AND.NL2(I).EQ.0))CALL ALG07
1014  DO 1090 J=1,ITUB
      X1=((VV(J)+VV(J+1))/2.0)**2*(1.0+((TBETA(J,I)+TBETA(J+1,I))/2.0)**
     12)
      HS(J)=(XI(J)+XI(J+1))/2.0+((XN*(R(J,I)+R(J+1,I))/2.0)**2-X1)/(2.0*
     1G*EJ)
      IF(HS(J).GE.HMIN)GO TO 1080
      IF(IPASS.LE.NFORCE)GO TO 1070
      IF(LNCT.LT.NPAGE)GO TO 1060
      WRITE(LOG2,500)
      LNCT=1
1060  LNCT=LNCT+1
      WRITE(LOG2,780)IPASS,I,ITER,J,HS(J)
1070  IFAIL=1
      HS(J)=HMIN
1080  XM2(J)=ALG9(HS(J),(S(J,I)+S(J+1,I))/2.0,X1)
      IF(I.EQ.1.OR.NLOSS(I).NE.1.OR.NL2(I).NE.0)GO TO 1090
      X1=(S(J,I)+S(J+1,I))/2.0
      X2=ALG4(HS(J),X1)
      X4=ALG8(HS(J),X1)
      X3=(XI(J)+XI(J))/2.0+(XN*((R(J,I)+R(J+1,I))/2.0))**2/(2.0*G*EJ)
      X3=ALG4(X3,X1)
      XM2(J)=XM2(J)*(1.0+X4*(LOSS(J)+LOSS(J+1))/2.0*X2/(X3*(1.0+(LOSS(J)
     1+LOSS(J+1))/2.0*(1.0-X2/X3))))
1090  CONTINUE
1100  DELW(1)=0.0
      DWDV=0.0
      X2=BBLOCK(I)*BDIST(I)
      X3=BBLOCK(I)*(1.0-BDIST(I))*2.0/XL(NSTRMS,I)
      DO 1200 J=1,ITUB
      X1=DL(J)*(R(J+1,I)+R(J,I))*ALG5(HS(J),(S(J,I)+S(J+1,I))/2.0)*(VV(J
     1)+VV(J+1))*(CPPG(J)+CPPG(J+1))*PI/(4.0*SCLFAC**2)
      X1=X1*((LAMI(J)+LAMI(J+1))/2.0-WWBL(I)-X2-X3*(XL(J,I)+XL(J+1,I)))
      DELW(J+1)=DELW(J)+X1
      X4=0.0
      IF(J.GE.IMID)GO TO 1130
      L1=J
1110  X4=X4+DVMDVM(L1)
      IF(L1.GE.IMID-1)GO TO 1120
      L1=L1+1
      GO TO 1110
1120  X4=X4/FLOAT(IMID-J)
      GO TO 1200
1130  L1=IMID+1
1140  X4=X4+DVMDVM(L1)
      IF(L1.GE.J)GO TO 1150
      L1=L1+1
      GO TO 1140
1150  X4=X4/FLOAT(J-IMID+1)
1200  DWDV=DWDV+X1*(1.0-XM2(J))*2.0/((VV(J)+VV(J+1))*(1.0-((XL(J,I)+XL(J
     1+1,I))*0.5-XL(IMID,I))*X4))
      W=DELW(NSTRMS)
      FM2=DWDV/W*VV(IMID)
      DO 1210 J=2,NSTRMS
1210  DELW(J)=DELW(J)/W
      IF(DWDV.LE.0.0)GO TO 1280
      IF(NMACH(I).EQ.1)GO TO 1330
      IF(W.LT.FLOW(ICASE).AND.ICONF1.EQ.0)VMAX=VV(IMID)
1220  DV=(FLOW(ICASE)-W)/DWDV
      IF(DV.LT.-0.1*VV(IMID))DV=-0.1*VV(IMID)
      IF(DV.GT. 0.1*VV(IMID))DV= 0.1*VV(IMID)
1230  IF(IPASS.EQ.1.OR.(I.NE.1.AND.NWORK(I).LE.4))GO TO 1234
      IF(VV(IMID)+DV.LT.VMIN)GO TO 1232
      DV=(VMIN-VV(IMID))*0.5
1232  IF(VV(IMID)+DV.GT.VMAX)GO TO 1234
      DV=(VMAX-VV(IMID))*0.5
1234  DO 1270 J=K,NSTRMS
      VV(J)=VV(J)+DV
      IF(VV(J).LE.VMMAX(J))GO TO 1238
      IFAIL=1
      VV(J)=VMMAX(J)
1238  IF(VV(J).GE.1.0)GO TO 1270
      IF(IPASS.LE.NFORCE)GO TO 1260
      IF(LNCT.LT.NPAGE)GO TO 1240
      WRITE(LOG2,500)
      LNCT=1
1240  LNCT=LNCT+1
      WRITE(LOG2,1250)IPASS,I,ITER,J,VV(J)
1250  FORMAT(5X,4HPASS,I3,9H  STATION,I3,11H  ITERATION,I3,12H  STREAMLI
     1NE,I3,50H  MERIDIONAL VELOCITY BELOW LIMIT IN CONTINUITY AT,E13.5)
1260  VV(J)=1.0
      IFAIL=1
1270  CONTINUE
      GO TO 1340
1280  IF(NMACH(I).EQ.0)GO TO 1290
      IF(W.LT.FLOW(ICASE).AND.ICONF1.EQ.0)VMIN=VV(IMID)
      GO TO 1220
1290  IF(VV(IMID).LT.VMIN.AND.ICONF1.EQ.0)VMIN=VV(IMID)
      DV=-.1*VV(IMID)
1300  IFAIL=1
      IF(IPASS.LE.NFORCE)GO TO 1230
      IF(LNCT.LT.NPAGE)GO TO 1310
      WRITE(LOG2,500)
      LNCT=1
1310  LNCT=LNCT+1
      WRITE(LOG2,1320)IPASS,I,ITER
1320  FORMAT(5X,4HPASS,I3,9H  STATION,I3,11H  ITERATION,I3,43H  OTHER CO
     1NTINUITY EQUATION BRANCH REQUIRED)
      GO TO 1230
1330  IF(VV(IMID).GT.VMAX.AND.ICONF1.EQ.0)VMAX=VV(IMID)
      DV=0.1*VV(IMID)
      GO TO 1300
1340  X1=TOLNCE/5.0
      IF(NEVAL(I).GT.0)X1=X1/2.0
      IF(ABS(W/FLOW(ICASE)-1.0).GT.X1)GO TO 1354
      DO 1350 J=K,NSTRMS
      IF(ABS(VV(J)/VVOLD(J)-1.0).GT.X1)GO TO 1354
1350  CONTINUE
      GO TO 1390
1354  IF(ITER.GE.ITMAX)GO TO 1360
      IF(I.EQ.1)GO TO 460
      IF((NLOSS(I).EQ.1.AND.NL2(I).EQ.0).OR.(NWORK(I).GE.5.AND.NLOSS(I).
     1EQ.2))CALL ALG07
      GO TO 460
1360  IF(IPASS.LE.NFORCE)GO TO 1390
      IF(LNCT.LT.NPAGE)GO TO 1370
      WRITE(LOG2,500)
      LNCT=1
1370  LNCT=LNCT+1
      X1=W/FLOW(ICASE)
      X2=VV(K)/VVOLD(K)
      X3=VV(IMID)/VVOLD(IMID)
      X4=VV(NSTRMS)/VVOLD(NSTRMS)
      WRITE(LOG2,1380)IPASS,I,X1,X2,X3,X4
1380  FORMAT(5X,4HPASS,I3,9H  STATION,I3,49H  MOMENTUM AND/OR CONTINUITY
     1 UNCONVERGED W/WSPEC=,F8.5,16H VM/VM(OLD) HUB=,F8.5,5H MID=,F8.5,5
     2H TIP=,F8.5)
1390  IF(IFAIL.NE.0.AND.IFAILO.EQ.0)IFAILO=I
      DO 1400 J=1,NSTRMS
1400  VM(J,I)=VV(J)
      IF(I.NE.1)GO TO 1420
      DO 1410 J=1,NSTRMS
1410  VW(J,1)=VV(J)*TBETA(J,1)
      GO TO 1480
1420  IF(NMIX.NE.1)GO TO 1440
      DO 1430 J=1,NSTRMS
      S(J,I-1)=SKEEP(J)
      H(J,I-1)=HKEEP(J)
1430  VW(J,I-1)=VWKEEP(J)
1440  IF(NWORK(I).GE.5)GO TO 1460
      TBETA(1,I)=0.0
      DO 1450 J=K,NSTRMS
1450  TBETA(J,I)=(VW(J,I)-XN*R(J,I))/VV(J)
      GO TO 1480
1460  DO 1470 J=1,NSTRMS
      VW(J,I)=VV(J)*TBETA(J,I)+XN*R(J,I)
1470  H(J,I)=XI(J)+XN*R(J,I)*VW(J,I)/(G*EJ)
1480  CONTINUE
      RETURN
      END

      SUBROUTINE FEER2 (IRET)
C
C     FEER2 INITIALIZES THEN CALLS  SDCOMP
C
      INTEGER            FILEA     ,FILEL    ,FILEU    ,SR1FLE   ,
     1                   SR2FLE    ,SR3FLE   ,SR4FLE   ,SR5FLE   ,
     2                   SR6FLE    ,SR7FLE   ,SR8FLE   ,RDP      ,
     3                   UPRTRI    ,PREC
      DOUBLE PRECISION   DET       ,DETC     ,MINDD
C
      COMMON   /OPINV /  MCBLT(7)  ,MCBSMA(7)
      COMMON   /SFACT /  FILEA(7)  ,FILEL(7) ,FILEU(7) ,ISR1FL   ,
     1                   ISR2FL    ,NZ       ,DET      ,DETC     ,
     2                   POWER     ,ISR3FL   ,MINDD    ,ICHL
      COMMON   /FEERXX/  DUMM(12)  ,IFSET
      COMMON   /FEERCX/  IFKAA(7)  ,IFMAA(7) ,IFLELM(7),IFLVEC(7),
     1                   SR1FLE    ,SR2FLE   ,SR3FLE   ,SR4FLE   ,
     2                   SR5FLE    ,SR6FLE   ,SR7FLE   ,SR8FLE   ,
     3                   DMPFLE    ,NORD     ,XLMBDA   ,NEIG     ,
     4                   MORD      ,IBK      ,CRITF    ,NORTHO   ,
     5                   IFLRVA    ,IFLRVC
      COMMON   /ZZZZZZ/  Z(1)
      COMMON   /NAMES /  IJ(8)     ,RDP      ,IK(5)    ,LOWTRI   ,
     1                   UPRTRI
      COMMON   /SYSTEM/  KSYSTM(54),PREC
C
      IRET     = 0
C
      FILEA(1) = IFLELM(1)
      FILEL(1) = IFLVEC(1)
      FILEU(1) = SR3FLE
      ISR1FL   = SR4FLE
      ISR2FL   = SR5FLE
      ISR3FL   = SR6FLE
      ICHL     = 0
      IF (IBK.EQ.1 .OR. IFSET.EQ.1) ICHL = 1
      FILEA(2) = IFKAA(2)
      FILEA(3) = IFKAA(3)
      FILEA(4) = IFKAA(4)
      FILEA(5) = PREC
      FILEA(6) = 0
      FILEA(7) = 0
      FILEL(5) = PREC
C
C     SYMMETRIC DECOMPOSITION
C
      NZ = KORSZ(Z)
      CALL SDCOMP (*30,Z,Z,Z)
   10 FILEL(3) = FILEL(2)
      FILEL(4) = LOWTRI
      CALL WRTTRL (FILEL)
      DO 20 I = 1,7
   20 MCBLT(I) = FILEL(I)
      RETURN
C
   30 IRET = 1
      GO TO 10
      END

      FUNCTION MAPFNS (I)
C
C     THIS FUNCTION PROVIDES ENTRIES FOR VARIOUS FUNCTIONS
C     ON THE VAX VERSION OF NASTRAN
C     (THIS ROUTINE WAS PREVIOUSLY CALLED 'VAXFNS')
C
      INTEGER AND, ANDF, COMPLF, ORF, RSHIFT, XORF
      COMMON /MACHIN/ M(3), LQRO
C
      MAPFNS = 0
      RETURN
C
      ENTRY AND (I,J)
C     ==============
      AND = IAND(I,J)
      RETURN
C
      ENTRY ANDF (I,J)
C     ================
      ANDF = IAND(I,J)
      RETURN
C
      ENTRY COMPLF (I)
C     ================
      COMPLF = NOT(I)
      RETURN
C
      ENTRY LOCFX (I)
C     ===============
      K = LQRO/1000
      LOCFX = LOC(I)/K
      RETURN
C
      ENTRY LSHIFT (I,J)
C     ==================
      LSHIFT = ISHFT(I,J)
      RETURN
C
      ENTRY ORF (I,J)
C     ===============
      ORF = IOR (I,J)
      RETURN
C
      ENTRY RSHIFT (I,J)
C     ==================
      RSHIFT = ISHFT(I,-J)
      RETURN
C
      ENTRY XORF (I,J)
C     ================
      XORF = IEOR (I,J)
      RETURN
C
      END

      SUBROUTINE DUMMY
C
C     NOTE:
C     THIS DUMMY.MIS ROUTINE CONTAINS 4 MACHINE VERSIONS (IBM,CDC,VAX,
C     AND UNIVAC). MOVE THIS SUBROUTINE TO THE MDS GROUP AND
C     REPLACE ALL THE 'C+' BY 2 SPACES IF MACHINE IS IBM, OR
C     REPLACE ALL THE 'C-' BY 2 SPACES IF MACHINE IS CDC, OR
C     REPLACE ALL THE 'C=' BY 2 SPACES IF MACHINE IS VAX, AND UNIX, OR
C     REPLACE ALL THE 'C*' BY 2 SPACES IF MACHINE IS UNIVAC
C     REPLACE ALL THE 'C.' BY 2 SPACES IF MACHINE TYPE IS 1, AND 11-20
C
C ****
C     IBM VERSION
C
C     THIS SUBROUTINE PROVIDES ENTRIES FOR THE DUMMY ROUTINES
C     USED BY OTHER COMPUTER MACHINES, AND ARE REFERENCED IN
C     VARIOUS NASTRAN LINKS
C
C     THIS SUBROUTINE INCLUDES ALSO SOME DUMMY ROUTINES NOT YET
C     WRITTEN
C
C     THIS ROUTINE SHOULD BE MOVED TO NASTRAN MACHINE-DEPENDENT
C     SECTION (MDS)
C ****
C
C+    DIMENSION       N(1)
C+    CHARACTER*8     NAME
C
C+    COMMON /MACHIN/ MACH
C+    COMMON /SYSTEM/ ISYSBF, NOUT
C
C+    IF (MACH .EQ. 2) GO TO 250
C+    WRITE  (NOUT,20) MACH
C+ 20 FORMAT (/,' MACH =',I7)
C+    NAME = 'DUMMY'
C+    GO TO 100
C
C ****
C     ROUTINES USED ONLY IN UNIVAC MACHINE
C ****
C
C
C+    ENTRY NTRAN (I,J,K)
C+    NAME = 'NTRAN'
C+    GO TO 100
C
C+    ENTRY CONTIN
C+    NAME = 'CONTIN'
C+    GO TO 100
C
C+    ENTRY FACIL (I,J)
C+    NAME = 'FACIL'
C+    GO TO 100
C
C+    ENTRY FACSF (I)
C+    NAME = 'FACSF'
C+    GO TO 100
C
C+    ENTRY UNVOPN (I)
C+    NAME = 'UNVOPN'
C+    GO TO 100
C
C+    ENTRY UNVCLS (I)
C+    NAME = 'UNVCLS'
C+    GO TO 100
C
C+    ENTRY ADDCRD (I,J)
C+    NAME = 'ADDCRD'
C+    GO TO 100
C
C ****
C     ROUTINES USED BY UNIVAC AND IBM
C ****
C
C     ENTRY RETURN
C     GO TO 250
C
C+    ENTRY MSGUNI
C+    IF (MACH .EQ. 2) GO TO 250
C+    NAME = 'MSGUNI'
C+    GO TO 100
C
C+    ENTRY XEOT (I,J,K,L)
C+    IF (MACH .EQ. 2) GO TO 250
C+    NAME = 'XEOT'
C+    GO TO 100
C
C     ENTRY TPSWIT (I,J,K,L)
C     NAME = 'TPSWIT'
C     GO TO 100
C
C ****
C     ROUTINES USED ONLY IN IBM MACHINE
C ****
C
C     ENTRY UMFTRN (I)
C     NAME = 'UMFTRN'
C     GO TO 100
C
C     ENTRY TAPSWI (I,J,K,L)
C     NAME = 'TAPSWI'
C     GO TO 100
C
C     ENTRY SOFIOI
C     NAME = 'SOFIOI'
C     GO TO 100
C
C     ENTRY SEARCH (I)
C     NAME = 'SEARCH'
C     GO TO 100
C
C ... NEXT THREE ARE SYSTEM ROUTINES THAT OPEN FILE DYNAMICALLY WITHOUT
C     THE USE OF JCL. THESE ROUTINES ARE COMMONLY 'LOCAL INSTALLED'.
C
C     IQADDN CHECKS WHETHER A FILE EXISTS OR NOT
C     QQDCBF BUILDS AN ATTRIBUTE LIST BY DDNAME
C     QQGETF ALLOCATES FILE IN TSO OR BATCH
C
C     ENTRY IQZDDN (I)
C     NAME = 'IQZDDN'
C     GO TO 100
C
C     ENTRY QQDCBF (I,J,K,L,M,N)
C     NAME = 'QQDCBF'
C     GO TO 100
C
C     ENTRY QQGETF (I,J,K)
C     NAME = 'QQGETF'
C     GO TO 100
C
C ****
C     ROUTINE USED ONLY BY IBM AND VAX
C ****
C
C     ENTRY SOFIOF
C     NAME = 'SOFIOF'
C     GO TO 100
C
C     THE FOLLOWING THREE ARE FUNCTIONS FOR QUAD WORD OPERATIONS
C                                           (REAL*16)
C     ENTRY QABS (I)
C     NAME = 'QABS'
C     GO TO 100
C
C     ENTRY SNGLQ (I)
C     NAME = 'SNGLQ'
C     GO TO 100
C
C     ENTRY DBLEQ (I)
C     NAME = 'DBLEQ'
C     GO TO 100
C
C     ENTRY QSQRT (I)
C     NAME = 'QSQRT'
C     GO TO 100
C
C     ENTRY QLOG (I)
C     NAME = 'QLOG'
C     GO TO 100
C
C     ENTRY QEXTD (I)
C     NAME = 'QEXTD'
C     GO TO 100
C
C ****
C     ROUTINE USED BY UNIVAC AND VAX
C ****
C
C+    ENTRY DEFCOR
C+    NAME = 'DEFCOR'
C+    GO TO 100
C
C ****
C     ROUTINES USED BY ALL MACHINES, EXCEPT VAX
C ****
C
C     ENTRY GPERR
C     NAME = 'GPERR'
C     GO TO 100
C
C     ENTRY PDUMP
C     GO TO 250
C
C     ENTRY MPY1
C     NAME = 'MPY1'
C     GO TO 100
C
C     ENTRY MPY2NT
C     NAME = 'MPY2NT'
C     GO TO 100
C
C     ENTRY MPY2T
C     NAME = 'MPY2T'
C     GO TO 100
C
C ****
C     ROUTINES USED ONLY IN CDC MACHINE
C ****
C
C+    ENTRY LINK (I,J,K)
C+    NAME = 'LINK'
C+    GO TO 100
C
C+    ENTRY REMARK (I)
C+    NAME = 'REMARK'
C+    GO TO 100
C
C+    ENTRY CDCBUG (I,J,K,L)
C+    NAME = 'CDCBUG'
C+    GO TO 100
C
C+    ENTRY CDCOPN (I)
C+    NAME = 'CDCOPN'
C+    GO TO 100
C
C+    ENTRY CDCCLS (I)
C+    NAME = 'CDCCLS'
C+    GO TO 100
C
C+    ENTRY CDCKSZ (I)
C+    NAME = 'CDCKSZ'
C+    GO TO 100
C
C+    ENTRY PF (I,J,K)
C+    NAME = 'PF'
C+    GO TO 100
C
C+    ENTRY ISWAP (I)
C+    NAME = 'ISWAP'
C+    GO TO 100
C
C ****
C     ROUTINES USED ONLY IN VAX MACHINE
C ****
C
C+    ENTRY VAXEND
C+    NAME = 'VAXEND'
C+    GO TO 100
C
C+    ENTRY VAXERR (L)
C+    WRITE (NOUT,50) L
C+ 50 FORMAT (/,' *** GINO ERROR AT LOC',I5)
C+    GO TO 220
C
C+    ENTRY VAXSCH
C+    NAME = 'VAXSCH'
C+    GO TO 100
C
C+    ENTRY VAXBRK
C+    NAME = 'VAXBRK'
C+    GO TO 100
C
C+    ENTRY MPY1V (I,J,K)
C+    NAME = 'MPY1V'
C+    GO TO 100
C
C+    ENTRY MPY2NV (I,J,K)
C+    NAME = 'MPY2NV'
C+    GO TO 100
C
C+    ENTRY MPY2TV (I,J,K)
C+    NAME = 'MPY2TV'
C+    GO TO 100
C
C ****
C     ROUTINES THAT PERFORM NO PARTICULAR FUNCTIONS, BUT THEY
C     ARE STILL CALLED BY NASTRAN
C ****
C
C+    ENTRY UNLOAD (I)
C     CALLED BY INPTT1
C+    GO TO 250
C
C ****
C     THE FOLLOWING ROUTINES SEEM TO BE NO LONGER USED IN NASTRAN
C ****
C
C+    ENTRY JIDINT (I)
C+    NAME = 'JIDINT'
C+    GO TO 100
C
C+    ENTRY OPMESG
C+    NAME = 'OPMESG'
C+    GO TO 100
C
C     ENTRY PDUM1,PDUM2,...,PDUM9 HAD BEEN REPLACED BY PDUMI
C     ENTRY QDMM3, SQDM31, AND SQDM32 ARE NOW OBSOLETE
C
C+    ENTRY SEMTRN
C+    NAME = 'SEMTRN'
C+    GO TO 100
C
C ****
C     DUMMY ROUTINES REFERENCED ONLY IN LINK 2, ALL MACHINES
C ****
C
C+    ENTRY PDUMI (*,*,*,I,J,K,L,M,N,O)
C+    NAME = 'PDUMI'
C+    GO TO 100
C
C ****
C     DUMMY ROUTINES REFERENCED ONLY IN LINK 5, ALL MACHINES
C ****
C
C+    ENTRY PLBAR1 (I,J)
C+    NAME = 'PLBAR1'
C+    GO TO 100
C
C+    ENTRY PLOADX
C+    NAME = 'PLOADX'
C+    GO TO 100
C
C+    ENTRY ERRTRC (NAM)
C     ==================
C     ERROR TRACEBACK
C
C+    GO TO 220
C
C+100 WRITE  (NOUT,150) NAME
C+150 FORMAT ('0*** SYSTEM FATAL ERROR  ---  JOB TERMINATED',
C+   1        ' DUE TO CALL TO DUMMY SUBROUTINE.  ENTRY NAME IS ', A8)
C+    GO TO 220
C
C ****
C     TO FORCE A SYSTEM FATAL ERROR FOR TRACEBACK
C ****
C
C+220 WRITE  (NOUT,230)
C+230 FORMAT ('0*** ERROR TRACEBACK IN SYSTEM LOG FILE')
C+    I = 987654321
C+    N(I) = 1
C+250 RETURN
C
C
C     SUBROUTINE DUMMY
C
C ****
C     CDC VERSION
C
C     THIS SUBROUTINE PROVIDES ENTRIES FOR THE DUMMY ROUTINES
C     USED BY OTHER COMPUTER MACHINES, AND ARE REFERENCED IN
C     VARIOUS NASTRAN LINKS
C
C     THIS SUBROUTINE INCLUDES ALSO SOME DUMMY ROUTINES NOT YET
C     WRITTEN
C
C     THIS ROUTINE SHOULD BE MOVED TO NASTRAN MACHINE-DEPENDENT
C     SECTION (MDS)
C ****
C
C-    CHARACTER*8     NAME
C
C-    COMMON /MACHIN/ MACH
C-    COMMON /SYSTEM/ ISYSBF, NOUT
C
C-    IF (MACH .EQ. 4) GO TO 250
C-    WRITE  (NOUT,20) MACH
C- 20 FORMAT (/,' MACH =',I7)
C-    NAME = 'DUMMY'
C-    GO TO 100
C
C ****
C     ROUTINES USED ONLY IN UNIVAC MACHINE
C ****
C
C-    ENTRY NTRAN (I,J,K)
C-    NAME = 'NTRAN'
C-    GO TO 100
C
C-    ENTRY CONTIN
C-    NAME = 'CONTIN'
C-    GO TO 100
C
C-    ENTRY FACIL (I,J)
C-    NAME = 'FACIL'
C-    GO TO 100
C
C-    ENTRY FACSF (I)
C-    NAME = 'FACSF'
C-    GO TO 100
C
C-    ENTRY UNVOPN (I)
C-    NAME = 'UNVOPN'
C-    GO TO 100
C
C-    ENTRY UNVCLS (I)
C-    NAME = 'UNVCLS'
C-    GO TO 100
C
C-    ENTRY ADDCRD (I,J)
C-    NAME = 'ADDCRD'
C-    GO TO 100
C
C ****
C     ROUTINES USED BY UNIVAC AND IBM
C ****
C
C-    ENTRY RETURN
C-    GO TO 250
C
C-    ENTRY MSGUNI
C-    IF (MACH .EQ. 2) GO TO 250
C-    NAME = 'MSGUNI'
C-    GO TO 100
C
C-    ENTRY XEOT (I,J,K,L)
C-    IF (MACH .EQ. 2) GO TO 250
C-    NAME = 'XEOT'
C-    GO TO 100
C
C-    ENTRY TPSWIT (I,J,K,L)
C-    NAME = 'TPSWIT'
C-    GO TO 100
C
C ****
C     ROUTINES USED ONLY IN IBM MACHINE
C ****
C
C-    ENTRY UMFTRN (I)
C-    NAME = 'UMFTRN'
C-    GO TO 100
C
C-    ENTRY TAPWSI (I,J,K,L)
C-    NAME = 'TAPSWI'
C-    GO TO 100
C
C-    ENTRY SEARCH (I)
C-    NAME = 'SEARCH'
C-    GO TO 100
C
C-    ENTRY SOFIOI
C-    NAME = 'SOFIOI'
C-    GO TO 100
C
C-    ENTRY IQZDDN (I)
C-    NAME = 'IQZDDN'
C-    GO TO 100
C
C-    ENTRY QQDCBF (I,J,K,L,M,N)
C-    NAME = 'QQDCBF'
C-    GO TO 100
C
C-    ENTRY QQGETF (I,J,K)
C-    NAME = 'QQGETF'
C-    GO TO 100
C
C ****
C     ROUTINE USED ONLY BY IBM AND VAX
C ****
C
C-    ENTRY SOFIOF
C-    NAME = 'SOFIOF'
C-    GO TO 100
C
C     THE FOLLOWING THREE ARE FUNCTIONS FOR QUAD WORD OPERATIONS
C                                           (REAL*16)
C-    ENTRY QABS (I)
C-    NAME = 'QABS'
C-    GO TO 100
C
C-    ENTRY SNGLQ (I)
C-    NAME = 'SNGLQ'
C-    GO TO 100
C
C-    ENTRY DBLEQ (I)
C-    NAME = 'DBLEQ'
C-    GO TO 100
C
C-    ENTRY QSQRT (I)
C-    NAME = 'QSQRT'
C-    GO TO 100
C
C-    ENTRY QLOG (I)
C-    NAME = 'QLOG'
C-    GO TO 100
C
C-    ENTRY QEXTD (I)
C-    NAME = 'QEXTD'
C-    GO TO 100
C
C ****
C     ROUTINE USED BY UNIVAC AND VAX
C ****
C
C-    ENTRY DEFCOR
C-    NAME = 'DEFCOR'
C-    GO TO 100
C
C ****
C     ROUTINES USEDS BY ALL MACHINES, EXCEPT VAX
C ****
C
C     ENTRY GPERR (I,J)
C     NAME = 'GPERR'
C     GO TO 100
C
C     ENTRY PDUMP
C     NAME = 'PDUMP'
C     GO TO 250
C
C     ENTRY MPY1
C     NAME = 'MPY1'
C     GO TO 100
C
C     ENTRY MPY2NT
C     NAME = 'MPY2NT'
C     GO TO 100
C
C     ENTRY MPY2T
C     NAME = 'MPY2T'
C     GO TO 100
C
C ****
C     ROUTINES USED ONLY IN CDC MACHINE
C ****
C
C     ENTRY LINK (I,J,K)
C     NAME = 'LINK'
C     GO TO 100
C
C     ENTRY REMARK (I)
C     NAME = 'REMARK'
C     GO TO 100
C
C     ENTRY CDCBUG (I,J,K,L)
C     NAME = 'CDCBUG'
C     GO TO 100
C
C     ENTRY CDCOPN (I)
C     NAME = 'CDCOPN'
C     GO TO 100
C
C     ENTRY CDCCLS (I)
C     NAME = 'CDCCLS'
C     GO TO 100
C
C     ENTRY PF (I,J,K)
C     NAME = 'PF'
C     GO TO 100
C
C     ENTRY ISWAP (I)
C     NAME = 'ISWAP'
C     GO TO 100
C
C-    ENTRY CDCKSZ (I)
C-    ENCODE (20,30,A) I
C- 30 FORMAT ('OPEN CORE =',I7,2X)
C-    CALL REMARK (A)
C-    GO TO 250
C
C ****
C     ROUTINES USED ONLY IN VAX MACHINE
C ****
C
C-    ENTRY VAXEND
C-    NAME = 'VAXEND'
C-    GO TO 100
C
C-    ENTRY VAXERR (L)
C-    WRITE  (NOUT,50) L
C- 50 FORMAT (/,' *** GINO ERROR AT LOC',I5)
C-    GO TO 220
C
C-    ENTRY VAXSCH
C-    NAME = 'VAXSCH'
C-    GO TO 100
C
C-    ENTRY VAXBRK
C-    NAME = 'VAXBRK'
C-    GO TO 100
C
C-    ENTRY MPY1V (I,J,K)
C-    NAME = 'MPY1V'
C-    GO TO 100
C
C-    ENTRY MPY2NV (I,J,K)
C-    NAME = 'MPY2NV'
C-    GO TO 100
C
C-    ENTRY MPY2TV (I,J,K)
C-    NAME = 'MPY2TV'
C-    GO TO 100
C
C ****
C     ROUTINES THAT PERFORM NO PARTICULAR FUNCTIONS, BUT THEY
C     ARE STILL CALLED BY NASTRAN
C ****
C
C-    ENTRY UNLOAD (I)
C     CALLED BY INPTT1
C-    GO TO 250
C
C ****
C     THE FOLLOWING ROUTINES SEEM TO BE NO LONGER USED IN NASTRAN
C ****
C
C-    ENTRY JIDINT (I)
C-    NAME = 'JIDINT'
C-    GO TO 100
C
C-    ENTRY OPMESG
C-    NAME = 'OPMESG'
C-    GO TO 100
C
C     ENTRY PDUM1,PDUM2,...,PDUM9 HAD BEEN REPLACED BY PDUMI
C     ENTRY QDMM3, SQDM31, AND SQDM32 ARE NOW OBSOLETE
C
C-    ENTRY SEMTRN
C-    NAME = 'SEMTRN'
C-    GO TO 100
C
C ****
C     DUMMY ROUTINES REFERENCED ONLY IN LINK 2, ALL MACHINES
C ****
C
C-    ENTRY PDUMI (*,*,*,I,J,K,L,M,N,O)
C-    NAME = 'PDUMI'
C-    GO TO 100
C
C ****
C     DUMMY ROUTINES REFERENCED ONLY IN LINK 5, ALL MACHINES
C ****
C
C-    ENTRY PLBAR1 (I,J)
C-    NAME = 'PLBAR1'
C-    GO TO 100
C
C-    ENTRY PLOADX
C-    NAME = 'PLOADX'
C-    GO TO 100
C
C-    ENTRY ERRTRC (NAM)
C     ==================
C     ERROR TRACEBACK
C
C-    GO TO 220
C
C-100 WRITE  (NOUT,150) NAME
C-150 FORMAT ('0*** SYSTEM FATAL ERROR  ---  JOB TERMINATED',
C-   1        ' DUE TO CALL TO DUMMY SUBROUTINE.  ENTRY NAME IS ', A8)
C-    GO TO 220
C
C ****
C     TO FORCE A SYSTEM FATAL ERROR FOR TRACEBACK
C ****
C
C-220 WRITE  (NOUT,230)
C-230 FORMAT ('0*** ERROR TRACEBACK IN SYSTEM LOG FILE')
C-    I =-3
C-    READ (I) J,K,M,N,O
C-250 RETURN
C
C
C     SUBROUTINE DUMMY
C
C ****
C     VAX VERSION  (MODIFIED FOR DEC/ULTRIX)
C
C     THIS SUBROUTINE PROVIDES ENTRIES FOR THE DUMMY ROUTINES
C     USED BY OTHER COMPUTER MACHINES, AND ARE REFERENCED IN
C     VARIOUS NASTRAN LINKS
C
C     THIS SUBROUTINE INCLUDES ALSO SOME DUMMY ROUTINES NOT YET
C     WRITTEN
C
C     THIS ROUTINE SHOULD BE MOVED TO NASTRAN MACHINE-DEPENDENT
C     SECTION (MDS)
C ****
C
      DIMENSION       N(1)
      CHARACTER*8     NAME
C
      COMMON /MACHIN/ MACH
      COMMON /SYSTEM/ ISYSBF, NOUT
C
      IF (MACH .EQ. 6) GO TO 250
      WRITE  (NOUT,20) MACH
   20 FORMAT (/,' MACH =',I7)
      NAME = 'DUMMY'
      GO TO 100
C
C ****
C     ROUTINES USED ONLY IN UNIVAC MACHINE
C ****
C
      ENTRY ZCORSZ (I)
      NAME = 'ZCORSZ'
      GO TO 100
C
      ENTRY MVBITS (I1,I2,I3,I4,I5)
      NAME = 'MVBITS'
      GO TO 100
C
      ENTRY CODKEY (CODE,KEY)
      NAME = 'CODKEY'
      GO TO 100
C
      ENTRY KCONEQ
      NAME = 'KCONEQ'
      GO TO 100
C
!hgs      ENTRY FNXTVQ (V1,V2,V3,V4,V5,ZB,I)
!hgs      NAME = 'FNXTVQ'
!hgs      GO TO 100
C
      ENTRY NTRAN (I,J,K)
      NAME = 'NTRAN'
      GO TO 100
C
      ENTRY CONTIN
      NAME = 'CONTIN'
      GO TO 100
C
      ENTRY FACIL (I,J)
      NAME = 'FACIL'
      GO TO 100
C
      ENTRY FACSF (I)
      NAME = 'FACSF'
      GO TO 100
C
      ENTRY UNVOPN (I)
      NAME = 'UNVOPN'
      GO TO 100
C
      ENTRY UNVCLS (I)
      NAME = 'UNVCLS'
      GO TO 100
C
      ENTRY ADDCRD (I,J)
      NAME = 'ADDCRD'
      GO TO 100
C
C ****
C     ROUTINES USED BY UNIVAC AND IBM
C ****
C
      ENTRY RETURN
      GO TO 250
C
      ENTRY MSGUNI
      IF (MACH .EQ. 2) GO TO 250
      NAME = 'MSGUNI'
      GO TO 100
C
      ENTRY XEOT (I,J,K,L)
      IF (MACH .EQ. 2) GO TO 250
      NAME = 'XEOT'
      GO TO 100
C
      ENTRY TPSWIT (I,J,K,L)
      NAME = 'TPSWIT'
      GO TO 100
C
C ****
C     ROUTINES USED ONLY IN IBM MACHINE
C ****
C
      ENTRY UMFTRN (I)
      NAME = 'UMFTRN'
      GO TO 100
C
      ENTRY TAPSWI (I,J,K,L)
      NAME = 'TAPSWI'
      GO TO 100
C
      ENTRY SEARCH (I)
      NAME = 'SEARCH'
      GO TO 100
C
      ENTRY SOFIOI
      NAME = 'SOFIOI'
      GO TO 100
C
      ENTRY IQZDDN (I)
      NAME = 'IQZDDN'
      GO TO 100
C
      ENTRY QQDCBF (I,J,K,L,M,N)
      NAME = 'QQDCBF'
      GO TO 100
C
      ENTRY QQGETF (I,J,K)
      NAME = 'QQGETF'
      GO TO 100
C
C ****
C     ROUTINE USED ONLY BY IBM AND VAX
C ****
C
C     ENTRY SOFIOF
C     NAME = 'SOFIOF'
C     GO TO 100
C
C     THE FOLLOWING THREE ARE FUNCTIONS FOR QUAD WORD OPERATIONS
C                                           (REAL*16)
      ENTRY QABS (I)
      NAME = 'QABS'
      GO TO 100
C
      ENTRY SNGLQ (I)
      NAME = 'SNGLQ'
      GO TO 100
C
      ENTRY DBLEQ (I)
      NAME = 'DBLEQ'
      GO TO 100
C
      ENTRY QSQRT (I)
      NAME = 'QSQRT'
      GO TO 100
C
      ENTRY QLOG (I)
      NAME = 'QLOG'
      GO TO 100
C
      ENTRY QEXTD (I)
      NAME = 'QEXTD'
      GO TO 100
C
C ****
C     ROUTINE USED BY UNIVAC AND VAX
C ****
C
C     ENTRY DEFCOR
C     NAME = 'DEFCOR'
C     GO TO 100
C
C ****
C     ROUTINES USED BY ALL MACHINES, EXCEPT VAX
C ****
C
      ENTRY GPERR (I,J)
      NAME = 'GPERR'
      GO TO 100
C
      ENTRY PDUMP
      GO TO 250
C
      ENTRY MPY1
      NAME = 'MPY1'
      GO TO 100
C
      ENTRY MPY2NT
      NAME = 'MPY2NT'
      GO TO 100
C
      ENTRY MPY2T
      NAME = 'MPY2T'
      GO TO 100
C
C ****
C     ROUTINES USED ONLY IN CDC MACHINE
C ****
C
      ENTRY LINK (I,J,K)
      NAME = 'LINK'
      GO TO 100
C
      ENTRY REMARK (I)
      NAME = 'REMARK'
      GO TO 100
C
      ENTRY CDCBUG (I,J,K,L)
      NAME = 'CDCBUG'
      GO TO 100
C
      ENTRY CDCOPN (I)
      NAME = 'CDCOPN'
      GO TO 100
C
      ENTRY CDCCLS (I)
      NAME = 'CDCCLS'
      GO TO 100
C
      ENTRY CDCKSZ (I)
      NAME = 'CDCKSZ'
      GO TO 100
C
      ENTRY PF (I,J,K)
      NAME = 'PF'
      GO TO 100
C
      ENTRY ISWAP (I)
      NAME = 'ISWAP'
      GO TO 100
C
C ****
C     ROUTINES USED ONLY IN VAX MACHINE
C ****
C
      ENTRY VAXEND
      NAME = 'VAXEND'
      GO TO 100
C
      ENTRY VAXERR (L)
      WRITE  (NOUT,50) L
   50 FORMAT (/,' *** GINO ERROR AT LOC',I5)
      GO TO 220
C
C     ENTRY VAXSCH
C     NAME = 'VAXSCH'
C     GO TO 100
C
      ENTRY VAXBRK
      NAME = 'VAXBRK'
      GO TO 100
C
C     ENTRY MPY1V (I,J,K)
C     NAME = 'MPY1V'
C     GO TO 100
C
C     ENTRY MPY2NV (I,J,K)
C     NAME = 'MPY2NV'
C     GO TO 100
C
C     ENTRY MPY2TV (I,J,K)
C     NAME = 'MPY2TV'
C     GO TO 100
C
C ****
C     ROUTINES THAT PERFORM NO PARTICULAR FUNCTIONS, BUT THEY
C     ARE STILL CALLED BY NASTRAN
C ****
C
      ENTRY UNLOAD (I)
C     CALLED BY INPTT1
      GO TO 250
C
C ****
C     THE FOLLOWING ROUTINES SEEM TO BE NO LONGER USED IN NASTRAN
C ****
C
      ENTRY JIDINT (I)
      NAME = 'JIDINT'
      GO TO 100
C
      ENTRY OPMESG
      NAME = 'OPMESG'
      GO TO 100
C
C     ENTRY PDUM1,PDUM2,...,PDUM9 HAD BEEN REPLACED BY PDUMI
C     ENTRY QDMM3, SQDM31, AND SQDM32 ARE NOW OBSOLETE
C
      ENTRY SEMTRN
      NAME = 'SEMTRN'
      GO TO 100
C
C ****
C     DUMMY ROUTINES REFERENCED ONLY IN LINK 2, ALL MACHINES
C ****
C
      ENTRY PDUMI (*,*,*,I,J,K,L,M,N,O)
      NAME = 'PDUMI'
      GO TO 100
C
C ****
C     DUMMY ROUTINES REFERENCED ONLY IN LINK 5, ALL MACHINES
C ****
C
!HGS      ENTRY PLBAR1 (I,J)
!HGS      NAME = 'PLBAR1'
!HGS      GO TO 100
C
!HGS      ENTRY PLOADX
!HGS      NAME = 'PLOADX'
!HGS      GO TO 100
C
CWKBD ENTRY ERRTRC (NAM)
C     ==================
C     ERROR TRACEBACK
C
CWKBD GO TO 220
C
  100 WRITE  (NOUT,150) NAME
  150 FORMAT ('0*** SYSTEM FATAL ERROR  ---  JOB TERMINATED',
     1        ' DUE TO CALL TO DUMMY SUBROUTINE.  ENTRY NAME IS ', A8)
      GO TO 220
C
C ****
C     TO FORCE A SYSTEM FATAL ERROR FOR TRACEBACK (VAX ONLY, NOT UNIX)
C ****
C
  220 IF (MACH .NE. 5) GO TO 240
      WRITE  (NOUT,230)
  230 FORMAT ('0*** ERROR TRACEBACK IN SYSTEM LOG FILE')
      I = 987654321
      N(I) = 0
  240 STOP
  250 RETURN
C
C
C     SUBROUTINE DUMMY
C
C ****
C     UNIVAC  VERSION
C
C     THIS SUBROUTINE PROVIDES ENTRIES FOR THE DUMMY ROUTINES
C     USED BY OTHER COMPUTER MACHINES, AND ARE REFERENCED IN
C     VARIOUS NASTRAN LINKS
C
C     THIS SUBROUTINE INCLUDES ALSO SOME DUMMY ROUTINES NOT YET
C     WRITTEN
C
C     THIS ROUTINE SHOULD BE MOVED TO NASTRAN MACHINE-DEPENDENT
C     SECTION (MDS)
C ****
C
C*    CHARACTER*8     NAME
C
C*    COMMON /MACHIN/ MACH
C*    COMMON /SYSTEM/ ISYSBF, NOUT
C
C*    IF (MACH .EQ. 3) GO TO 250
C*    WRITE  (NOUT,20) MACH
C* 20 FORMAT (/,' MACH =',I7)
C*    NAME = 'DUMMY'
C*    GO TO 100
C
C ****
C     ROUTINES USED ONLY IN UNIVAC MACHINE
C ****
C
C     ENTRY NTRAN (I,J,K)
C     NAME = 'NTRAN'
C     GO TO 100
C
C     ENTRY CONTIN
C     NAME = 'CONTIN'
C     GO TO 100
C
C     ENTRY FACIL (I,J)
C     NAME = 'FACIL'
C     GO TO 100
C
C     ENTRY FACSF (I)
C     NAME = 'FACSF'
C     GO TO 100
C
C     ENTRY UNVOPN (I)
C     NAME = 'UNVOPN'
C     GO TO 100
C
C     ENTRY UNVCLS (I)
C     NAME = 'UNVCLS'
C     GO TO 100
C
C     ENTRY ADDCRD (I,J)
C     NAME = 'ADDCRD'
C     GO TO 100
C
C ****
C     ROUTINES USED BY UNIVAC AND IBM
C ****
C
C*    ENTRY RETURN
C*    GO TO 250
C
C     ENTRY MSGUNI
C     IF (MACH .EQ. 2) GO TO 250
C     NAME = 'MSGUNI'
C     GO TO 100
C
C     ENTRY XEOT (I,J,K,L)
C     IF (MACH .EQ. 2) GO TO 250
C     NAME = 'XEOT'
C     GO TO 100
C
C     ENTRY TPSWIT (I,J,K,L)
C     NAME = 'TPSWIT'
C     GO TO 100
C
C ****
C     ROUTINES USED ONLY IN IBM MACHINE
C ****
C
C*    ENTRY UMFTRN (I)
C*    NAME = 'UMFTRN'
C*    GO TO 100
C
C*    ENTRY TAPSWI (I,J,K,L)
C*    NAME = 'TAPWSI'
C*    GO TO 100
C
C*    ENTRY SEARCH (I)
C*    NAME = 'SEARCH'
C*    GO TO 100
C
C*    ENTRY SOFIOI
C*    NAME = 'SOFIOI'
C*    GO TO 100
C
C*    ENTRY IQZDDN (I)
C*    NAME = 'IQZDDN'
C*    GO TO 100
C
C*    ENTRY QQDCBF (I,J,K,L,M,N)
C*    NAME = 'QQDCBF'
C*    GO TO 100
C
C*    ENTRY QQGETF (I,J,K)
C*    NAME = 'QQGETF'
C*    GO TO 100
C
C ****
C     ROUTINE USED ONLY BY IBM AND VAX
C ****
C
C*    ENTRY SOFIOF
C*    NAME = 'SOFIOF'
C*    GO TO 100
C
C     THE FOLLOWING THREE ARE FUNCTIONS FOR QUAD WORD OPERATIONS
C                                           (REAL*16)
C*    ENTRY QABS (I)
C*    NAME = 'QABS'
C*    GO TO 100
C
C*    ENTRY SNGLQ (I)
C*    NAME = 'SNGLQ'
C*    GO TO 100
C
C*    ENTRY DBLEQ (I)
C*    NAME = 'DBLEQ'
C*    GO TO 100
C
C*    ENTRY QSQRT (I)
C*    NAME = 'QSQRT'
C*    GO TO 100
C
C*    ENTRY QLOG (I)
C*    NAME = 'QLOG'
C*    GO TO 100
C
C*    ENTRY QEXTD (I)
C*    NAME = 'QEXTD'
C*    GO TO 100
C
C ****
C     ROUTINE USED BY UNIVAC AND VAX
C ****
C
C     ENTRY DEFCOR
C     NAME = 'DEFCOR'
C     GO TO 100
C
C ****
C     ROUTINES USED BY ALL MACHINES, EXCEPT VAX
C ****
C
C     ENTRY GPERR (I,J)
C     NAME = 'GPERR'
C     GO TO 100
C
C     ENTRY PDUMP
C     GO TO 250
C
C     ENTRY MPY1
C     NAME = 'MPY1'
C     GO TO 100
C
C     ENTRY MPY2NT
C     NAME = 'MPY2NT'
C     GO TO 100
C
C     ENTRY MPY2T
C     NAME = 'MPY2T'
C     GO TO 100
C
C ****
C     ROUTINES USED ONLY IN CDC MACHINE
C ****
C
C*    ENTRY LINK (I,J,K)
C*    NAME = 'LINK'
C*    GO TO 100
C
C*    ENTRY REMARK (I)
C*    NAME = 'REMARK'
C*    GO TO 100
C
C*    ENTRY CDCBUG (I,J,K,L)
C*    NAME = 'CDCBUG'
C*    GO TO 100
C
C*    ENTRY CDCOPN (I)
C*    NAME = 'CDCOPN'
C*    GO TO 100
C
C*    ENTRY CDCCLS (I)
C*    NAME = 'CDCCLS'
C*    GO TO 100
C
C*    ENTRY CDCKSZ (I)
C*    NAME = 'CDCKSZ'
C*    GO TO 100
C
C*    ENTRY PF (I,J,K)
C*    NAME = 'PF'
C*    GO TO 100
C
C*    ENTRY ISWAP (I)
C*    NAME = 'ISWAP'
C*    GO TO 100
C
C ****
C     ROUTINES USED ONLY IN VAX MACHINE
C ****
C
C*    ENTRY VAXEND
C*    NAME = 'VAXEND'
C*    GO TO 100
C
C*    ENTRY VAXERR (L)
C*    WRITE  (NOUT,50) L
C* 50 FORMAT (/,' *** GINO ERROR AT LOC',I5)
C*    GO TO 220
C
C*    ENTRY VAXSCH
C*    NAME = 'VAXSCH'
C*    GO TO 100
C
C*    ENTRY VAXBRK
C*    NAME = 'VAXBRK'
C*    GO TO 100
C
C*    ENTRY MPY1V (I,J,K)
C*    NAME = 'MPY1V'
C*    GO TO 100
C
C*    ENTRY MPY2NV (I,J,K)
C*    NAME = 'MPY2NV'
C*    GO TO 100
C
C*    ENTRY MPY2TV (I,J,K)
C*    NAME = 'MPY2TV'
C*    GO TO 100
C
C ****
C     ROUTINES THAT PERFORM NO PARTICULAR FUNCTIONS, BUT THEY
C     ARE STILL CALLED BY NASTRAN
C ****
C
C*    ENTRY UNLOAD (I)
C     CALLED BY INPTT1
C*    GO TO 250
C
C ****
C     THE FOLLOWING ROUTINES SEEM TO BE NO LONGER USED IN NASTRAN
C ****
C
C*    ENTRY JIDINT (I)
C*    NAME = 'JIDINT'
C*    GO TO 100
C
C*    ENTRY OPMESG
C*    NAME = 'OPMESG'
C*    GO TO 100
C
C     ENTRY PDUM1,PDUM2,...,PDUM9 HAD BEEN REPLACED BY PDUMI
C     ENTRY QDMM3, SQDM31, AND SQDM32 ARE NOW OBSOLETE
C
C*    ENTRY SEMTRN
C*    NAME = 'SEMTRN'
C*    GO TO 100
C
C ****
C     DUMMY ROUTINES REFERENCED ONLY IN LINK 2, ALL MACHINES
C ****
C
C*    ENTRY PDUMI (*,*,*,I,J,K,L,M,N,O)
C*    NAME = 'PDUMI'
C*    GO TO 100
C
C ****
C     DUMMY ROUTINES REFERENCED ONLY IN LINK 5, ALL MACHINES
C ****
C
C*    ENTRY PLBAR1 (I,J)
C*    NAME = 'PLBAR1'
C*    GO TO 100
C
C*    ENTRY PLOADX
C*    NAME = 'PLOADX'
C*    GO TO 100
C
C*    ENTRY ERRTRC (NAM)
C     ==================
C     ERROR TRACEBACK
C
C*    GO TO 220
C
C*100 WRITE  (NOUT,150) NAME
C*150 FORMAT ('0*** SYSTEM FATAL ERROR  ---  JOB TERMINATED',
C*   1        ' DUE TO CALL TO DUMMY SUBROUTINE.  ENTRY NAME IS ', A8)
C*    GO TO 220
C
C ****
C     TO FORCE A SYSTEM FATAL ERROR FOR TRACEBACK
C ****
C
C*220 WRITE  (NOUT,230)
C*230 FORMAT ('0*** ERROR TRACEBACK IN SYSTEM LOG FILE')
C*    X =-1.0
C*    X = SQRT(X)
C*250 RETURN
C
C
C     SUBROUTINE DUMMY
C
C ****
C     MACHINES 1, AND 6 THRU 20 VERSION
C
C     THIS SUBROUTINE PROVIDES ENTRIES FOR THE DUMMY ROUTINES
C     USED BY OTHER COMPUTER MACHINES, AND ARE REFERENCED IN
C     VARIOUS NASTRAN LINKS
C
C     THIS SUBROUTINE INCLUDES ALSO SOME DUMMY ROUTINES NOT YET
C     WRITTEN
C
C     THIS ROUTINE SHOULD BE MOVED TO NASTRAN MACHINE-DEPENDENT
C     SECTION (MDS)
C ****
C
C.    DIMENSION       N(1)
C.    CHARACTER*8     NAME
C
C.    COMMON /MACHIN/ MACH
C.    COMMON /SYSTEM/ ISYSBF, NOUT
C
C.    IF (MACH.EQ.1 .AND. MACH.GE.6) GO TO RETURN
C.    WRITE  (NOUT,150) NAME,MACH
C.150 FORMAT ('0*** SYSTEM FATAL ERROR  ---  JOB TERMINATED', /5X,
C.   1       'SUBROUTINE DUMMY FOR MACHINE TYPE',I4,' IS NOT AVAILABLE')
C.    I = 987654321
C.    N(I) = 0
C.    STOP
C
      END

      SUBROUTINE FRMLTD (IFILE,DZ,DY,ZM)
C
C     FEER MATRIX TRANSPOSE MULTIPLY  (DOUBLE PREC)
C               T
C     DY = IFILE * DZ        WHERE DZ IS A VECTOR ALREADY IN CORE
C                            IFILE IS A GINO MATIRX FILE
C
C     LAST REVISED  11/91, BY C.CHAN/UNISYS
C     ADDITION OF A NEW TRANSPOSE MULTIPLY METHOD WHICH IS MORE
C     EFFECIENT, AND IS ALREADY GOOD FOR VECTORIZATION
C
CDB   LOGICAL          DEBUG
      DOUBLE PRECISION DZ(1)    ,DY(1)    ,ZM(1)    ,DP     ,DSUM
      DIMENSION        IFILE(7) ,IDP(2)   ,NAM(2)
      COMMON  /UNPAKX/ ITYP     ,IP       ,NP       ,INCR
      COMMON  /SYSTEM/ IBUF     ,NOUT
      COMMON  /FEERXX/ DUM18(18),NZM
      COMMON  /ZZZZZZ/ IZ(1)
      EQUIVALENCE      (DP,IDP(1))
      DATA     NAM   / 4HFRML   ,4HTD    /
CDB   DATA     DEBUG , ITER     ,MAX     / .FALSE.  ,0      ,4       /
C
CDB   IF (.NOT.DEBUG) GO TO 20
C     ITER = ITER + 1
C     IF (ITER .GT. MAX) DEBUG = .FALSE.
C     IF (DEBUG) WRITE (NOUT,10) NZM,IFILE(5)
C  10 FORMAT ('  .... IN FRMLTD DEBUG.   NZM,IFILE(5) =',2I8)
C  20 CONTINUE
      N    = IFILE(2)
      IFL  = IFILE(1)
      IF (IFILE(7) .LT. 0) IFL = -IFILE(7)
      CALL REWIND (IFL)
      CALL SKPREC (IFL,1)
      IF (IFILE(7) .LT. 0) GO TO 50
      ITYP = IFILE(5)
C
C     NASTRAN ORIGIANL METHOD
C
      INCR  = 1
      DO 40 I = 1,N
      DY(I) = 0.0D+0
      IP    = 0
      CALL UNPACK (*40,IFL,ZM(1))
      DSUM  = 0.0D+0
      II    = 0
      DO 30 J = IP,NP
      II    = II + 1
   30 DSUM  = DSUM + ZM(II)*DZ(J)
      DY(I) = DSUM
   40 CONTINUE
      GO TO 200
C
C     NEW METHOD, READ ONLY AND NO UNPACK
C
C     UNLIKE FRMLTX, IFL WAS UNPACKED FORWARD BY UNPSCR
C
   50 NREC = 0
      NWDS = IFILE(5)
CDB   N20  = N - 20
C     IF (DEBUG) WRITE (NOUT,60) NWDS,NZM
C  60 FORMAT ('  /@60   NWDS,NZM =',2I8)
      LL2  = 0
      NEXT = 1
      DO 140 I = 1,N
      IF (NEXT .LT. LL2) GO TO 100
      NREC = NREC + 1
CDB   IF (DEBUG) WRITE (NOUT,70) NREC,I
C  70 FORMAT ('  ...READING RECORD',I5,'.  I =',I7)
      CALL READ (*150,*80,IFL,ZM,NZM,1,LL)
      CALL MESAGE (-8,0,NAM)
   80 LL2  = LL/NWDS
CDB   IF (DEBUG) WRITE (NOUT,90) LL,NREC,LL2
C  90 FORMAT (1X,I10,' WORDS READ FROM RECORD NO.',I5,'   LL2 =',I10)
      NEXT = 1
  100 DP   = ZM(NEXT)
      II   = IDP(1)
      JJ   = IDP(2)
CDB   IF (DEBUG .AND. (I.LT.20 .OR. I.GT.N20)) WRITE (NOUT,110) I,II,JJ,
C     1                                                         NEXT
C 110 FORMAT ('   @110  I,II,JJ,NEXT =',4I8)
      IF (II .EQ. JJ) GO TO 130
      DSUM = 0.0D+0
      LL   = NEXT
      DO 120 J = II,JJ
      LL   = LL + 1
  120 DSUM = DSUM + ZM(LL)*DZ(J)
      DY(I)= DSUM
      GO TO 140
  130 DY(I)= ZM(NEXT+1)*DZ(II)
  140 NEXT = NEXT + JJ - II + 2
      GO TO 200
C
  150 J = IFILE(4)/10
      WRITE  (NOUT,160) NREC,I,N,J
  160 FORMAT ('0*** TRY TO READ RECORD',I5,'.   I,N,IFILE(4) =',2I7,I5)
      CALL MESAGE (-2,IFL,NAM)
C
  200 RETURN
      END

      SUBROUTINE CMTRCE (IERTAB,IWDS,ITOMNY)
C
C     THIS ROUTINE TRACES BACK IMPROPER CONNECTIONS FINDING
C     GIRD POINT IDS FOR INTERNAL POINT  NUMBERS
C
      INTEGER COMBO,IERTAB(1),Z,OF,IOUT(6),NAM(2)
C
      COMMON /CMB003/ COMBO(7,5)
      COMMON /ZZZZZZ/ Z(1)
      COMMON /SYSTEM/ JUNK,OF,IJUNK(6),NLPP,IJ2(2),LINE
      DATA    NHEQSS/ 4HEQSS /
C
      CALL SORT(0,0,4,2,IERTAB(1),IWDS)
      IB = 1
      CALL PAGE1
      WRITE(OF,2000)
      WRITE(OF,2100)
      NLINE = NLINE + 5
C
   50 IPS = IERTAB(IB+1)
      NAM(1) = COMBO(IPS,1)
      NAM(2) = COMBO(IPS,2)
      CALL SFETCH(NAM,NHEQSS,1,ITEST)
      CALL SUREAD(Z(1),-1,NOUT,ITEST)
      IPT = NOUT
C
C     READ EQSS FOR EACH COMPONENT
C
      NCOMP = 3
      NCOMP = Z(NCOMP)
      IST = IPT + NCOMP + 2
      Z(IPT+1) = IST
      DO 100 I=1,NCOMP
      CALL SUREAD(Z(IST),-1,NOUT,ITEST)
      Z(IPT+1+I) = NOUT + IST
      CALL SORT(0,0,3,2,Z(IST),NOUT)
      IST = IST + NOUT
  100 CONTINUE
      DO 300 I=IB,IWDS,4
      IF( IERTAB(I+1) .NE. IPS ) GO TO 1000
      DO 220 J=1,2
      IP = IERTAB(I+1+J)
      DO 210 JJ=1,NCOMP
      II = Z(IPT+JJ)
      NWDS = Z(IPT+JJ+1) - Z(IPT+JJ)
      CALL BISLOC(*210,IP,Z(II+1),3,NWDS/3,ILOC)
      IOUT(3*J) = Z(II+ILOC-1)
      IOUT(3*J-2) = Z(2*JJ+3)
      IOUT(3*J-1) = Z(2*JJ+4)
      GO TO 220
  210 CONTINUE
  220 CONTINUE
      LINE = LINE + 1
      IF( LINE .LE. NLPP ) GO TO 230
      CALL PAGE1
      WRITE(OF,2100)
      LINE = LINE + 2
  230 CONTINUE
      WRITE(OF,2200) IERTAB(I),IOUT
  300 CONTINUE
      GO TO 1100
C
C     GET NEXT PSEUDOSTRUCUTRE
C
 1000 IB = I
      GO TO 50
 1100 IF( ITOMNY .EQ. 0 ) RETURN
      WRITE(OF,2300)
      RETURN
 2000 FORMAT(/1X,
     1 61HTHE FOLLOWING CONNECTIONS HAVE BEEN FOUND TO BE INCONSISTANT.,
     2 /1X,57HATTEMPTS HAVE BEEN MADE TO CONNECT INTERNAL POINTS WITHIN,
     3 /1X,57HTHE SAME PSEUDOSTRUCTURE DUE TO SPLIT DEGREES OF FREEDOM.,
     4 /1X,79HTHESE ERRORS MUST BE RESOLVED BY THE USER VIA RELES DATA O
     5R MANUAL CONNECTIONS. /)
 2100 FORMAT(5X,3HDOF,5X,12HSUBSTRUCTURE,5X,8H GRID ID,5X,
     1   12HSUBSTRUCTURE,5X,8H GRID ID   /)
 2200 FORMAT(6X,I1,10X,2A4,5X,I8,9X,2A4,5X,I8)
 2300 FORMAT(/5X,93HTHE NUMBER OF FATAL MESSAGES EXCEEDED THE AVAILABLE
     1STORAGE. SOME MESSAGES HAVE BEEN DELETED. )
      END

      SUBROUTINE ALG18 (BETA1,BETA2,I1,I2,FACT,X0,Y0,S0,XR,Y1,X1,Y2,RDI
     1US,S,C1)
C
      DIMENSION S(80)
C
      DELX=XR/FLOAT(I2-I1)
      XX=X0
      I3=I1+1
      IF (BETA1.EQ.BETA2) GO TO 20
      Y1=-COS(BETA1/C1)/(SIN(BETA1/C1)-SIN(BETA2/C1))
      X1=SIN(BETA1/C1)/(SIN(BETA1/C1)-SIN(BETA2/C1))
      Y2=TAN((BETA1+BETA2)/(2.0*C1))
      RDIUS=ABS(1.0/(SIN(BETA1/C1)-SIN(BETA2/C1)))
      Y2=Y2*FACT+Y0
      Y1=Y1*FACT+Y0
      X1=X1*FACT+X0
      RDIUS=RDIUS*FACT
      DO 10 J=I3,I2
      XX=XX+DELX
      PHI1=ATAN(-1./SQRT(RDIUS**2-(XX-X1)**2)*(XX-X1))
      IF ((BETA1-BETA2).LT.0.0) PHI1=-PHI1
      PHI2=ABS(BETA1/C1-PHI1)
10    S(J)=RDIUS*PHI2+S0
      RETURN
20    AM=TAN(BETA1/C1)
      DO 30 J=I3,I2
      XX=XX+DELX
30    S(J)=(XX-X0)*SQRT(AM*AM+1.0)+S0
      Y2=AM*(XX-X0)+Y0
      RETURN
      END

      SUBROUTINE CREATE (GPLST,X,U,DEFORM,CONMIN,CONMAX,ELMTID,STORE,
     1                   LCOR,B1,B2)
C
      INTEGER         GPLST(1),DEFORM,LAYER,IDUMMY(2),EST,PRNT,SCR1,
     1                OES1,STRESS,B1,B2,WHERE,DIRECT,SUB,ESTSYM(7),
     2                SKIPWD(20),ELID,ESYM,GPTS(12),ELMTID(100),
     3                MSG1(20),ERR(2),OFFSET
      REAL            X(3,1),U(2,1),STORE(202)
      DIMENSION       ISYM(14),ITYPE(14),PT(2,5),THIRD(2),C(2,4),
     1                CENTRD(2)
      COMMON /BLANK / SKIP(12),EST,SKIP1(7),PRNT,SKI(2),OES1,SCR1,SCR2,
     1                NEW
      COMMON /XXPARM/ SKIP4(157),NCNTR,CNTR(50),ICNTVL,WHERE,DIRECT,SUB,
     1                FLAG,VALUE,SKP20(20),LAYER
      EQUIVALENCE     (NEW,NEWOES), (KQ4,ISYM(13)), (KT3,ISYM(14))
      DATA   NTYPES / 14  /
      DATA   ISYM   / 2HSH,2HT1,2HTB,2HTP,2HTM,2HQP,2HQM,2HT2,2HQ2,2HQ1,
     1                2HM1,2HM2,2HQ4,2HT3/,    KBAR/2HBR/
      DATA   ITYPE  / 4, 6, 7, 8, 9, 15, 16, 17, 18, 19, 62, 63, 64, 83/
      DATA   ESTSYM / 7*0 /
      DATA   SKIPWD /-5,-6,-7,-1,-2,-3,-4,-5,-6,4*0,0,-1,-2,-5,-6,-7,0 /
      DATA   NMSG1  , MSG1/20,4H(48H,4H NO ,4HSTRE,4HSS C,4HALCU,4HLATI,
     1       4HON F , 4HOUND,4H FOR,4H ELE,4HMENT,4H NUM,4HBER ,4H,I8,,
     2       4H19H  , 4H- EL,4HEMEN,4HT IG,4HNORE,4HD.)                /
C
      TWOPI  = 8.0*ATAN(1.0)
      IRDEST = 0
      CALL GOPEN (SCR1,GPLST(B1),1)
      STRESS = OES1
      IF ((ICNTVL.GE.4 .AND. ICNTVL.LE.9) .AND. DIRECT.EQ.2)
     1    STRESS = NEWOES
      IF (STRESS.EQ.OES1 .AND. (ICNTVL.EQ.6 .OR. ICNTVL.EQ.8 .OR.
     1    ICNTVL.EQ.9)) GO TO 130
      IF (STRESS .EQ. OES1) SKIPWD(7) = -3
      CALL OPEN (*130,STRESS,GPLST(B2),0)
      CONMIN = 0.0
      CONMAX = 0.0
      IEOR   = 0
C
C     CREATE A LIST OF ELEMENTS TYPES TO BE PLOTTED IN THIS SET
C
      JTJ  = 1
      K    = 1
      KEST = 0
      CALL READ (*135,*135,EST,ESYM,1,0,M)
      IF (ICNTVL .EQ. 20) GO TO 7
C
C     ELIMINATE ALL BUT MAXSHEAR FOR CSHEAR ELEMENT
C
    3 IF (ESYM.EQ.ISYM(1) .AND. ICNTVL.NE.3) GO TO 7
C
C     ELIMINATE MID STRESS FOR TRIA1, QUAD1, TRPLT, OR QDPLT
C
      IF ((ESYM.EQ.ISYM(2) .OR. ESYM.EQ.ISYM(10) .OR. ESYM.EQ.ISYM(4)
     1   .OR. ESYM.EQ.ISYM(6)) .AND. WHERE.EQ.3) GO TO 7
C
C     ELIMINATE Z2 AND AVER STRESS FOR CTRMEM, CQDMEM, MEM1, MEM2
C
      IF ((ESYM.EQ.ISYM(5) .OR. ESYM.EQ.ISYM(7) .OR. ESYM.EQ.ISYM(11)
     1   .OR. ESYM.EQ.ISYM(12)) .AND. (WHERE.EQ.-1 .OR. WHERE.EQ.3))
     2    GO TO 7
C
C     ELIMINATE Z1, Z2 AND MAX FOR TRIA2 OR TRBSC ELEMENTS
C
      IF ((ESYM.EQ.ISYM(8) .OR. ESYM.EQ.ISYM(3)) .AND.
     1   (IABS(WHERE).EQ.1 .OR. WHERE.EQ.2)) GO TO 7
      DO 5 I = 1,NTYPES
      IF (ESYM .EQ. ISYM(I)) GO TO 6
    5 CONTINUE
      GO TO 7
    6 ESTSYM(K) = I
      K = K + 1
    7 CALL FREAD (EST,NGPPE,1,0)
C
    8 OFFSET = 0
      IF (ESYM .EQ. KBAR) OFFSET = 6
      IF (ESYM.EQ.KT3 .OR. ESYM.EQ.KQ4) OFFSET = 1
C
C     FLUSH TO NEXT SYMBOL
C
    9 CALL FREAD (EST,ELID,1,0)
      IF (ELID .EQ. 0) GO TO (11,25), JTJ
      J = 1 + NGPPE + OFFSET
      CALL FREAD (EST,0,-J,0)
      GO TO 9
C
C     READ NEXT SYMBOL
C
   11 CALL READ (*12,*12,EST,ESYM,1,0,M)
      GO TO 3
C
C     LOOP BACK UNTIL ALL EST SYMBOLS ARE IN CORE
C
   12 K = K - 1
      CALL BCKREC (EST)
      JTJ = 2
C
C     NOTE THAT THE ASSUMPTION THAT STRESS AND EST FILES ARE ORDERED IN
C     THE SAME WAY IS NO LONGER NECESSARY
C
   15 IF (IEOR .EQ. 0) CALL FWDREC (*125,STRESS)
      IF (ICNTVL .NE. 20) GO TO 20
      CALL FWDREC (*125,STRESS)
      GO TO 25
   20 CALL READ  (*125,*120,STRESS,IDUMMY,2,0,M)
      CALL FREAD (STRESS,IELTYP,1,0)
      CALL FREAD (STRESS,ISUB,1,0)
      CALL FREAD (STRESS,DETAIL,1,0)
      CALL FREAD (STRESS,EIGEN,1,0)
      EIGEN = SQRT(ABS(EIGEN))/TWOPI
      CALL FREAD (STRESS,0,-3,0)
      CALL FREAD (STRESS,NWDS,1,1)
      IF (SUB.GT.0 .AND. ISUB.NE.SUB) GO TO 50
      IF (FLAG.EQ.1.0 .AND. DETAIL.NE.VALUE) GO TO 50
      IF (FLAG.EQ.2.0 .AND. ABS(EIGEN-VALUE).GT.1.0E-5) GO TO 50
      IEOR = 0
      DO 22 I = 1,K
      J = ESTSYM(I)
      IF (J .EQ. 0) GO TO 22
      IF (IELTYP .EQ. ITYPE(J)) GO TO 25
   22 CONTINUE
      GO TO 50
C
C     YES, WE DO WANT THIS ELEMENT TYPES STRESS DATA.  FIND THIS TYPES
C     ELEMENTS IN THE EST
C
   25 CALL READ (*905,*905,EST,ESYM,1,0,M)
      IRDEST = 1
      CALL FREAD (EST,NGPPE,1,0)
      IF (ICNTVL.EQ.20 .OR. ESYM.EQ.ISYM(J)) GO TO 27
C
C     FLUSH THE FILE UNTIL FOUND
C
      GO TO 8
C
   27 CALL WRITE (SCR1,ESYM,1,0)
      KEST = KEST + 1
      MEM  = 0
      IF (IELTYP.EQ.9  .OR. IELTYP.EQ.16 .OR. IELTYP.EQ.15 .OR.
     1    IELTYP.EQ.62 .OR. IELTYP.EQ.63) MEM = 1
C         TRMEM(9), QDMEM(16), QDPLT(15), QDMEM1(62), QDMEM2(63)
C
      IWDS = SKIPWD(ICNTVL)
      IF (ICNTVL .GT. 13) GO TO 29
      IF (MEM .EQ. 1) IWDS = IWDS + 1
      IF (WHERE.EQ.-1 .AND. MEM.NE.1) IWDS = IWDS - 8
      NWDS = -NWDS - IWDS + 2
      IF (IABS(WHERE).NE.1 .AND. MEM.NE.1) NWDS = NWDS + 8
      IF (WHERE.EQ.-1 .AND. MEM.EQ.1) GO TO 50
      IF (IELTYP.EQ.4 .AND. ICNTVL.NE.3) GO TO 50
C         SHEAR(4)
C
   29 IS = 0
C
C     READ STRESS FILE
C
   30 IS = IS + 1
      CALL READ (*58,*58,STRESS,ELMTID(IS),1,0,M)
      IF (ICNTVL.LE.9 .OR. ICNTVL.EQ.20) GO TO 35
      CALL FREAD (STRESS,NLAYER,1,0)
      LAYTOT = NLAYER*11
      LAYSKP = -((LAYER-1)*10+2)
      CALL FREAD (STRESS,0,LAYSKP,0)
   35 IF (IELTYP .NE. 4) GO TO 40
C
C     MAXIMUM SHEAR FOR CSHEAR ELEMENT
C
      CALL FREAD (STRESS,STORE(IS),1,0)
      CALL FREAD (STRESS,0,-2,0)
      IF (IS .EQ. LCOR) GO TO 60
      GO TO 30
   40 CALL FREAD (STRESS,0,IWDS,0)
      CALL FREAD (STRESS,STORE(IS),1,0)
      IF (ICNTVL.LE.9 .OR. ICNTVL.EQ.20) GO TO 41
      NLFIN = -(LAYTOT-1+LAYSKP+IWDS)
      CALL FREAD (STRESS,0,NLFIN,0)
      GO TO 30
   41 IF (ICNTVL .LT. 20) GO TO 42
      CALL FREAD (STRESS,0,-1,0)
      GO TO 30
   42 IF (IABS(WHERE).EQ.1 .OR. MEM.EQ.1) GO TO 45
      CALL FREAD (STRESS,0,-7,0)
      CALL FREAD (STRESS,CONTUR,1,0)
   45 CALL FREAD (STRESS,0,NWDS,0)
      IF (MEM.EQ.1 .AND. IS.GE.LCOR) GO TO 60
      IF (MEM   .EQ. 1) GO TO 30
      IF (WHERE .EQ. 2) STORE(IS) = AMAX1(STORE(IS),CONTUR)
      IF (WHERE .EQ. 3) STORE(IS) = (STORE(IS)+CONTUR)/2.0
      IF (IS .GE. LCOR) GO TO 60
      GO TO 30
C
C     SKIP THIS TYPE
C
   50 CALL FWDREC (*125,STRESS)
      GO TO 20
C
C     END OF RECORD ON STRESS FILE
C
   58 IEOR = 1
      IS   = IS - 1
C
C     STORE STRESS VALUES WITH ELEMENT ID.S
C
   60 CALL FREAD (EST,ELID,1,0)
      IF (ELID .EQ. 0) GO TO 90
      CALL FREAD (EST,0,-1,0)
      CALL FREAD (EST,GPTS,NGPPE+OFFSET,0)
C
C     THE VERY NEXT LINE WAS ACCIDENTALLY DROPPED IN 88 VERSION
C
      IF (ELID .GT. ELMTID(IS)/10) GO TO 100
      DO 65 IST = 1,IS
      IF (ELID .EQ. ELMTID(IST)/10) GO TO 70
   65 CONTINUE
      ERR(1) = 1
      ERR(2) = ELID
      CALL WRTPRT (PRNT,ERR,MSG1,NMSG1)
      GO TO 60
C
C     FIND ELEMENTS CENTROID
C
   70 DO 75 I = 1,NGPPE
      IG = GPTS(I)
      IG = IABS(GPLST(IG))
      IF (DEFORM .NE. 0) GO TO 74
      PT(1,I) = X(2,IG)
      PT(2,I) = X(3,IG)
      GO TO 75
   74 PT(1,I) = U(1,IG)
      PT(2,I) = U(2,IG)
   75 CONTINUE
      THIRD(1) = PT(1,3)
      THIRD(2) = PT(2,3)
      INDEX = 1
      PT(1,NGPPE+1) = PT(1,1)
      PT(2,NGPPE+1) = PT(2,1)
      IF (NGPPE .LT. 4) GO TO 80
      INDEX = 4
      CALL CENTRE (*90,PT(1,1),PT(2,1),PT(1,2),PT(2,2),PT(1,3),PT(2,3),
     1             PT(1,4),PT(2,4),CENTRD)
      THIRD(1) = CENTRD(1)
      THIRD(2) = CENTRD(2)
   80 DO 85 I = 1,INDEX
      CALL CENTRE (*90,PT(1,I),PT(2,I),PT(1,I+1),PT(2,I+1),(THIRD(1)+
     1            PT(1,I+1))*.5,(THIRD(2)+PT(2,I+1))*.5,
     2            (THIRD(1)+PT(1,I))*.5,(THIRD(2)+PT(2,I))*.5,CENTRD)
      C(1,I) = CENTRD(1)
      C(2,I) = CENTRD(2)
   85 CONTINUE
      IF (NGPPE .LT. 4) GO TO 90
      CALL CENTRE (*90,C(1,1),C(2,1),C(1,2),C(2,2),C(1,3),C(2,3),C(1,4),
     1            C(2,4),CENTRD)
   90 CALL WRITE (SCR1,ELID,1,0)
      IF (ELID .NE. 0) GO TO 91
  905 IF (KEST .EQ. K) GO TO 120
      CALL BCKREC (EST)
      IRDEST = 0
      GO TO 15
   91 CONTINUE
      CALL WRITE (SCR1,STORE(IST),1,0)
      CALL WRITE (SCR1,CENTRD,2,0)
      IF (CONMIN.NE.0.0 .OR. CONMAX.NE.0.0) GO TO 92
      CONMIN = STORE(IST)
      CONMAX = CONMIN
      GO TO 60
   92 CONMIN = AMIN1(CONMIN,STORE(IST))
      CONMAX = AMAX1(CONMAX,STORE(IST))
      GO TO 60
C
C     REFILL STRESS STORAGE AREA
C
  100 IS = 0
      IF (IEOR .EQ. 0) GO TO 30
      ERR(1) = 1
      ERR(2) = ELID
      CALL WRTPRT (PRNT,ERR,MSG1,NMSG1)
      GO TO 60
  120 IF (STRESS .EQ. NEWOES) GO TO 126
      CALL READ  (*125,*125,OES1,0,-3,0,M)
      CALL FREAD (OES1,ISUB,1,0)
      CALL FREAD (OES1,DETAIL,1,0)
      CALL FREAD (OES1,EIGEN,1,1)
      EIGEN = SQRT(ABS(EIGEN))/TWOPI
      IF (ISUB .NE. SUB) GO TO 125
      IF (FLAG.EQ.1.0 .AND. DETAIL.NE.VALUE) GO TO 125
      IF (FLAG.EQ.2.0 .AND. ABS(EIGEN-VALUE).GT.1.0E-5) GO TO 125
      CALL FWDREC (*125,OES1)
      GO TO 120
  125 CALL BCKREC (STRESS)
  126 CALL CLOSE (STRESS,2)
  130 CALL WRITE (SCR1,0,0,1)
      CALL CLOSE (SCR1,1)
      IF (IRDEST) 140,140,135
  135 CALL BCKREC (EST)
  140 CONTINUE
      RETURN
      END

      BLOCK DATA TABFBD
CTABFBD
C TABFTX - BLOCK DATA PROGRAM FOR MODULE TABPRT
C
      INTEGER HX, RE
C
      INTEGER HX01(32)
      INTEGER HX02(32)
      INTEGER HX03(32)
      INTEGER HX04(32)
      INTEGER HX05(32)
      INTEGER HX06(32)
      INTEGER HX07(32)
      INTEGER HX08(32)
      INTEGER HX09(32)
      INTEGER HX10(32)
      INTEGER HX11(32)
      INTEGER HX12(32)
      INTEGER HX13(32)
      INTEGER HX14(32)
      INTEGER HX15(32)
      INTEGER HX16(32)
      INTEGER HX17(32)
      INTEGER HX18(32)
      INTEGER HX19(32)
      INTEGER HX20(32)
      INTEGER HX21(32)
      INTEGER HX22(32)
C
      COMMON /TABFTX/ LA,NA(2,21)  ,  HX(32,40)  , RE(21)
C
      EQUIVALENCE (HX01(1),HX(1, 1))
      EQUIVALENCE (HX02(1),HX(1, 2))
      EQUIVALENCE (HX03(1),HX(1, 3))
      EQUIVALENCE (HX04(1),HX(1, 4))
      EQUIVALENCE (HX05(1),HX(1, 5))
      EQUIVALENCE (HX06(1),HX(1, 6))
      EQUIVALENCE (HX07(1),HX(1, 7))
      EQUIVALENCE (HX08(1),HX(1, 8))
      EQUIVALENCE (HX09(1),HX(1, 9))
      EQUIVALENCE (HX10(1),HX(1,10))
      EQUIVALENCE (HX11(1),HX(1,11))
      EQUIVALENCE (HX12(1),HX(1,12))
      EQUIVALENCE (HX13(1),HX(1,13))
      EQUIVALENCE (HX14(1),HX(1,14))
      EQUIVALENCE (HX15(1),HX(1,15))
      EQUIVALENCE (HX16(1),HX(1,16))
      EQUIVALENCE (HX17(1),HX(1,17))
      EQUIVALENCE (HX18(1),HX(1,18))
      EQUIVALENCE (HX19(1),HX(1,19))
      EQUIVALENCE (HX20(1),HX(1,20))
      EQUIVALENCE (HX21(1),HX(1,21))
      EQUIVALENCE (HX22(1),HX(1,22))
C
C-----------------------------------------------------------------------
C
      DATA LA / 9 /
      DATA RE /1,1,1,1,1,1,1,0,1,1
     1        ,1,1,1,1,1,1,1,1,1,1
     2        ,1                    /
C
      DATA NA / 4HBGPD,4HT     ,  4HGPL ,4H      ,  4HCSTM,4H
     4        , 4HGPLD,4H      ,  4HEQEX,4HIN    ,  4HEQDY,4HN
     7        , 4HGPDT,4H      ,  4HGPTT,4H      ,  4HGPCT,4H
     X        , 4H*10*,4H****  ,  4H*11*,4H****  ,  4H*12*,4H****
     3        , 4H*13*,4H****  ,  4H*14*,4H****  ,  4H*15*,4H****
     6        , 4H*16*,4H****  ,  4H*17*,4H****  ,  4H*18*,4H****
     9        , 4H*19*,4H****  ,  4H*20*,4H****  ,  4H*21*,4H****
     Z        /
C
C
      DATA HX01/4H    ,4H    ,4H    ,4H    ,4H    ,4H    ,4H    ,4H
     1         ,4H    ,4H    ,4H    ,4H    ,4H    ,4H    ,4H    ,4H
     2         ,4H    ,4H    ,4H    ,4H    ,4H    ,4H    ,4H    ,4H
     3         ,4H    ,4H    ,4H    ,4H    ,4H    ,4H    ,4H    ,4H    /
C
      DATA HX02/4H    ,4H    ,4H    ,4H    ,4H    ,4H    ,4H    ,4H
     1         ,4H    ,4HFORM,4HATTE,4HD LI,4HST O,4HF TA,4HBLE ,4HDATA
     2         ,4H BLO,4HCK  ,4H****,4H****,4H    ,4H( RE,4HCORD,4H****
     3         ,4H  ) ,4H    ,4H    ,4H    ,4H    ,4H    ,4H    ,4H    /
C
      DATA HX03/4H    ,4H    ,4H    ,4H    ,4HINTE,4HRNAL,4H    ,4H COO
     1         ,4HRDIN,4HATE ,4H    ,4H    ,4H    ,4H COO,4HRDIN,4HATES
     2         ,4H IN ,4HBASI,4HC CO,4HORDI,4HNATE,4H SYS,4HTEM ,4H
     3         ,4H    ,4H    ,4H    ,4H    ,4H    ,4H    ,4H    ,4H    /
C
      DATA HX04/4H    ,4H    ,4H    ,4H    ,4H   I,4HD   ,4H    ,4H SYS
     1         ,4HTEM ,4HID  ,4H    ,4H    ,4H   X,4H    ,4H    ,4H
     2         ,4H    ,4H   Y,4H    ,4H    ,4H    ,4H    ,4H   Z,4H
     3         ,4H    ,4H    ,4H    ,4H    ,4H    ,4H    ,4H    ,4H    /
C
      DATA HX05/4H    ,4H  IN,4HTERN,4HAL  ,4H    ,4H EXT,4HERNA,4HL GR
     1         ,4HID  ,4H    ,4H EXT,4HERNA,4HL GR,4HID  ,4H    ,4H EXT
     2         ,4HERNA,4HL GR,4HID  ,4H    ,4H EXT,4HERNA,4HL GR,4HID
     3         ,4H    ,4H EXT,4HERNA,4HL GR,4HID  ,4H    ,4H    ,4H    /
C
      DATA HX06/4H    ,4H    ,4H ID ,4H    ,4H    ,4H OR ,4HSCAL,4HAR I
     1         ,4HD   ,4H    ,4H OR ,4HSCAL,4HAR I,4HD   ,4H    ,4H OR
     2         ,4HSCAL,4HAR I,4HD   ,4H    ,4H OR ,4HSCAL,4HAR I,4HD
     3         ,4H    ,4H OR ,4HSCAL,4HAR I,4HD   ,4H    ,4H    ,4H    /
C
      DATA HX07/4H    ,4H  IN,4HTERN,4HAL  ,4H    ,4H   E,4HXTER,4HNAL
     1         ,4HGRID,4H   S,4HEQUE,4HNCE ,4H    ,4H    ,4HEXTE,4HRNAL
     2         ,4H GRI,4HD   ,4HSEQU,4HENCE,4H    ,4H    ,4H EXT,4HERNA
     3         ,4HL GR,4HID  ,4H SEQ,4HUENC,4HE   ,4H    ,4H    ,4H    /
C
      DATA HX08/4H    ,4H    ,4H ID ,4H    ,4H    ,4H   O,4HR SC,4HALAR
     1         ,4H ID ,4H    ,4HNUMB,4HER  ,4H    ,4H    ,4HOR S,4HCALA
     2         ,4HR ID,4H    ,4H NUM,4HBER ,4H    ,4H    ,4H OR ,4HSCAL
     3         ,4HAR I,4HD   ,4H  NU,4HMBER,4H    ,4H    ,4H    ,4H    /
C
      DATA HX09/4H    ,4H    ,4H    ,4H    ,4H    ,4H    ,4H    ,4H
     1         ,4H    ,4H    ,4H    ,4H    ,4H    ,4H    ,4H    ,4H
     2         ,4H    ,4H    ,4H    ,4H    ,4H    ,4H    ,4H    ,4H
     3         ,4H    ,4H    ,4H    ,4H    ,4H    ,4H    ,4H    ,4H    /
C
      DATA HX10/4H    ,4H    ,4H    ,4H  N ,4H    ,4H   I,4HD   ,4H
     1         ,4HTYPE,4H    ,4H    ,4H R(I,4H,1) ,4H    ,4H    ,4H
     2         ,4H R(I,4H,2) ,4H    ,4H    ,4H    ,4H R(I,4H,3) ,4H
     3         ,4H    ,4H    ,4H    ,4H    ,4H    ,4HT(I),4H    ,4H    /
C
      DATA HX11/4H   E,4HXTER,4HNAL ,4H    ,4HEXTE,4HRNAL,4H GRI,4HD
     1         ,4HINTE,4HRNAL,4H    ,4H EXT,4HERNA,4HL GR,4HID  ,4H INT
     2         ,4HERNA,4HL   ,4H  EX,4HTERN,4HAL G,4HRID ,4H  IN,4HTERN
     3         ,4HAL  ,4H   E,4HXTER,4HNAL ,4HGRID,4H   I,4HNTER,4HNAL /
C
      DATA HX12/4H   S,4HORT ,4HID  ,4H    ,4HOR S,4HCALA,4HR ID,4H
     1         ,4H NUM,4HBER ,4H    ,4H OR ,4HSCAL,4HAR I,4HD   ,4H  NU
     2         ,4HMBER,4H    ,4H  OR,4H SCA,4HLAR ,4HID  ,4H   N,4HUMBE
     3         ,4HR   ,4H   O,4HR SC,4HALAR,4H ID ,4H    ,4HNUMB,4HER  /
C
      DATA HX13/4H   I,4HNTER,4HNAL ,4H    ,4H    ,4HCOOR,4HDINA,4HTE
     1         ,4H    ,4H    ,4H COO,4HRDIN,4HATES,4H IN ,4HDEFI,4HNING
     2         ,4H COO,4HRDIN,4HATE ,4HSYST,4HEM  ,4H    ,4H  DI,4HSPLA
     3         ,4HCEME,4HNT C,4HOOR-,4H    ,4HCONS,4HTRAI,4HNT  ,4H    /
C
      DATA HX14/4H    ,4H  ID,4H    ,4H    ,4H    ,4HSYST,4HEM  ,4H
     1         ,4H    ,4H    ,4H  X ,4H    ,4H    ,4H    ,4H    ,4HY
     2         ,4H    ,4H    ,4H    ,4H Z  ,4H    ,4H    ,4H  DI,4HNATE
     3         ,4H SYS,4HTEM ,4HID  ,4H    ,4H   C,4HODE ,4H    ,4H    /
C
      DATA HX15/4H   I,4HTERN,4HAL  ,4H    ,4H   T,4HEMPE,4HRATU,4HRE
     1         ,4H    ,4H    ,4HDEFA,4HULT ,4HTEMP,4HERAT,4HURE ,4H
     2         ,4H    ,4H   R,4HECOR,4HD NU,4HMBER,4H FOR,4H    ,4H
     3         ,4H    ,4H    ,4H    ,4H    ,4H    ,4H    ,4H    ,4H    /
C
      DATA HX16/4H    ,4HINDE,4HX   ,4H    ,4H    ,4H SET,4H ID ,4H
     1         ,4H    ,4H    ,4H    ,4H  OR,4H FLA,4HG   ,4H    ,4H
     2         ,4H    ,4H ADD,4HITIO,4HNAL ,4HTEMP,4H. DA,4HTA  ,4H
     3         ,4H    ,4H    ,4H    ,4H    ,4H    ,4H    ,4H    ,4H    /
C
      DATA HX17/4H  SU,4HBSEQ,4HUENT,4H REC,4HORDS,4H OF ,4H G P,4H T T
     1         ,4H  TE,4HMPER,4HATUR,4HE DA,4HTA A,4HRE L,4HISTE,4HD UN
     2         ,4HDER ,4HSET ,4HID A,4HND E,4HLEME,4HNT T,4HYPE ,4HBY E
     3         ,4HLEME,4HNT I,4HD   ,4H    ,4H    ,4H    ,4H    ,4H    /
C
      DATA HX18/4H   R,4HECOR,4HD NU,4HMBER,4H   T,4HEMPE,4HRATU,4HRE S
     1         ,4HET I,4HD   ,4H    ,4H    ,4H    ,4H    ,4H    ,4H
     2         ,4H    ,4H    ,4H    ,4H    ,4H    ,4H    ,4H    ,4H
     3         ,4H    ,4H    ,4H    ,4H    ,4H    ,4H    ,4H    ,4H    /
C
      DATA HX19/4H    ,4H    ,4H    ,4H  F ,4HO R ,4HM A ,4HT T ,4HE D
     1         ,4H  L ,4HI S ,4HT   ,4HO F ,4H  T ,4HA B ,4HL E ,4H  D
     2         ,4HA T ,4HA   ,4HB L ,4HO C ,4HK   ,4HG P ,4HC T ,4H
     3         ,4H    ,4H    ,4H    ,4H    ,4H    ,4H    ,4H    ,4H    /
C
      DATA HX20/4H  RE,4HCORD,4H    ,4HPIVO,4HT  C,4HONNE,4HCTIN,4HG
     1         ,4H    ,4H    ,4H    ,4H    ,4H SOR,4HTED ,4HLIST,4H OF
     2         ,4H S I,4H L  ,4HNUMB,4HERS ,4HOF C,4HONNE,4HCTED,4H POI
     3         ,4HNTS ,4H    ,4H    ,4H    ,4H    ,4H    ,4H    ,4H    /
C
      DATA HX21/4H  NU,4HMBER,4H    ,4HS I ,4HL   ,4H NUM,4HBER ,4H
     1         ,4H( 1 ,4H)   ,4H  ( ,4H2 ) ,4H    ,4H( 3 ,4H)   ,4H  (
     2         ,4H4 ) ,4H    ,4H( 5 ,4H)   ,4H  ( ,4H6 ) ,4H    ,4H( 7
     3         ,4H)   ,4H  ( ,4H8 ) ,4H    ,4H( 9 ,4H)   ,4H ( 1,4H0 ) /
C
      DATA HX22/4H   S,4HORT ,4HID  ,4H    ,4HOR S,4HCALA,4HR ID,4H   C
     1         ,4HODED,4H SIL,4H    ,4H OR ,4HSCAL,4HAR I,4HD   ,4HCODE
     2         ,4HD SI,4HL   ,4H  OR,4H SCA,4HLAR ,4HID  ,4H COD,4HED S
     3         ,4HIL  ,4H   O,4HR SC,4HALAR,4H ID ,4H  CO,4HDED ,4HSIL /
C
      END

      SUBROUTINE Q4BMGS (DSHP,GPTH,BGPDT,GPNORM,PHI,BMATRX)
C
C     THIS ROUTINE ASSEMBLES PORTIONS OF B-MATRIX FOR QUAD4
C
      LOGICAL         MEMBRN,BENDNG,SHRFLX,MBCOUP,NORPTH,BADJ
      INTEGER         ROWFLG
      REAL            GPNORM(4,1),BGPDT(4,1)
      REAL            BMATRX(1),PSITRN(9),BBAR(120),ATRANS(6),PHI(9),
     1                DSHP(1),GPTH(1),DERIV,THICK ,HZTA,TERM,DETJ,
     2                UEV,UNV,ANGLEI,EDGEL,EDGSHR,BB1,BB2,BB3,
     3                BSBAR1(6),BSBAR(48),TEE(9)
      COMMON /Q4DT  / DETJ,HZTA,PSITRN,NNODE,BADJ,N1
      COMMON /TERMS / MEMBRN,BENDNG,SHRFLX,MBCOUP,NORPTH
      COMMON /Q4COMS/ ANGLEI(4),EDGSHR(3,4),EDGEL(4),UNV(3,4),
     1                UEV(3,4),ROWFLG,IORDER(4)
C*****
C     INITIALIZE
C*****
      NDOF=NNODE*6
      NDOF3=NNODE*3
      ND2=NDOF*2
      ND3=NDOF*3
      ND4=NDOF*4
      ND5=NDOF*5
      ND6=NDOF*6
C
C     SET THE SIZE OF B-MATRIX BASED ON THE ROW FLAG.
C     ROWFLG = 1      OUT OF PLANE SHEAR (LAST 2 ROWS)   ND2
C     ROWFLG = 2      IN-PLANE SHEAR (THIRD  ROW)        NDOF
C     ROWFLG = 3      THE FIRST SIX (THREE) ROWS         ND6 (ND3)
C
      NN = ND6
      IF (NORPTH) NN = ND3
      IF (ROWFLG .EQ. 1) NN = ND2
      IF (ROWFLG .EQ. 2) NN = ND2
C*****
C     SET UP TERMS TO BE FILLED IN B-MATRIX
C*****
      DO 50 K=1,NNODE
      KPOINT=6*(K-1)
      THICK=GPTH(K)
C
C     COMPUTE THE TERMS WHICH GO IN THE FIRST 6(3) ROWS.
C
      IF (ROWFLG .EQ. 1) GO TO 20
      ATRANS(1)=-PSITRN(2)*GPNORM(4,K)+PSITRN(3)*GPNORM(3,K)
      ATRANS(2)= PSITRN(1)*GPNORM(4,K)-PSITRN(3)*GPNORM(2,K)
      ATRANS(3)=-PSITRN(1)*GPNORM(3,K)+PSITRN(2)*GPNORM(2,K)
      ATRANS(4)=-PSITRN(5)*GPNORM(4,K)+PSITRN(6)*GPNORM(3,K)
      ATRANS(5)= PSITRN(4)*GPNORM(4,K)-PSITRN(6)*GPNORM(2,K)
      ATRANS(6)=-PSITRN(4)*GPNORM(3,K)+PSITRN(5)*GPNORM(2,K)
C
      DO 10 I=1,2
      IPOINT=ND3*(I-1)
      ITOT =IPOINT+KPOINT
      DERIV=DSHP(N1*(I-1)+K)
      BBAR(     1+ITOT)=DERIV*PSITRN(1)
      BBAR(     2+ITOT)=DERIV*PSITRN(2)
      BBAR(     3+ITOT)=DERIV*PSITRN(3)
      BBAR(NDOF+1+ITOT)=DERIV*PSITRN(4)
      BBAR(NDOF+2+ITOT)=DERIV*PSITRN(5)
      BBAR(NDOF+3+ITOT)=DERIV*PSITRN(6)
      TERM=HZTA*THICK*DERIV
      BBAR(     4+ITOT)=TERM*ATRANS(1)
      BBAR(     5+ITOT)=TERM*ATRANS(2)
      BBAR(     6+ITOT)=TERM*ATRANS(3)
      BBAR(NDOF+4+ITOT)=TERM*ATRANS(4)
      BBAR(NDOF+5+ITOT)=TERM*ATRANS(5)
      BBAR(NDOF+6+ITOT)=TERM*ATRANS(6)
   10 CONTINUE
      GO TO 50
C
C     COMPUTE THE TERMS WHICH GO IN THE LAST 2 ROWS.
C
   20 IF (.NOT.BENDNG) RETURN
      TEE(1)= 0.0
      TEE(2)=-GPNORM(4,K)
      TEE(3)= GPNORM(3,K)
      TEE(4)=-TEE(2)
      TEE(5)= 0.0
      TEE(6)=-GPNORM(2,K)
      TEE(7)=-TEE(3)
      TEE(8)=-TEE(6)
      TEE(9)= 0.0
C
      KP1=KPOINT*2
      KP2=KP1+7
      J=IORDER(K)
      I=J-1
      IF (I .EQ. 0) I=4
C
      IB=0
   30 IB=IB+1
      BB1=-UNV(IB,J)*EDGSHR(1,J)/EDGEL(J)
     1    +UNV(IB,I)*EDGSHR(1,I)/EDGEL(I)
      BB2=-UNV(IB,J)*EDGSHR(2,J)/EDGEL(J)
     1    +UNV(IB,I)*EDGSHR(2,I)/EDGEL(I)
      BB3=-UNV(IB,J)*EDGSHR(3,J)/EDGEL(J)
     1    +UNV(IB,I)*EDGSHR(3,I)/EDGEL(I)
      BSBAR(KP1+IB  )=PSITRN(1)*BB1+PSITRN(2)*BB2+PSITRN(3)*BB3
      BSBAR(KP1+IB+3)=PSITRN(4)*BB1+PSITRN(5)*BB2+PSITRN(6)*BB3
      IF (IB.LT.3) GO TO 30
C
      IB=0
   40 IB=IB+1
      BB1=-(UEV(IB,J)*EDGSHR(1,J)+UEV(IB,I)*EDGSHR(1,I))*0.5
      BB2=-(UEV(IB,J)*EDGSHR(2,J)+UEV(IB,I)*EDGSHR(2,I))*0.5
      BB3=-(UEV(IB,J)*EDGSHR(3,J)+UEV(IB,I)*EDGSHR(3,I))*0.5
      BSBAR1(IB  )=PSITRN(1)*BB1+PSITRN(2)*BB2+PSITRN(3)*BB3
      BSBAR1(IB+3)=PSITRN(4)*BB1+PSITRN(5)*BB2+PSITRN(6)*BB3
      IF (IB .LT. 3) GO TO 40
      CALL GMMATS (BSBAR1,2,3,0,TEE,3,3,0,BSBAR(KP2))
   50 CONTINUE
C
C*****
C     FILL IN B-MATRIX FOR THE NORMAL PATH
C*****
C
      IF (.NOT.NORPTH) GO TO 200
      GO TO (140,120,100), ROWFLG
C
C     ROWFLG = 3       FIRST THREE ROWS
C
  100 DO 110 KBAR=1,NDOF
      BMATRX(KBAR     )=PHI(1)*BBAR(KBAR     )+PHI(2)*BBAR(KBAR+ND3 )
      BMATRX(KBAR+NDOF)=PHI(4)*BBAR(KBAR+NDOF)+PHI(5)*BBAR(KBAR+ND4 )
      BMATRX(KBAR+ND2 )=PHI(4)*BBAR(KBAR     )+PHI(1)*BBAR(KBAR+NDOF)
     1                 +PHI(5)*BBAR(KBAR+ND3 )+PHI(2)*BBAR(KBAR+ND4 )
  110 CONTINUE
      GO TO 300
C
C     ROWFLG = 2       IN-PLANE SHEAR (3RD ROW)
C
  120 DO 130 KBAR=1,NDOF
      BMATRX(KBAR)=PHI(4)*BBAR(KBAR    )+PHI(1)*BBAR(KBAR+NDOF)
     1            +PHI(5)*BBAR(KBAR+ND3)+PHI(2)*BBAR(KBAR+ND4 )
  130 CONTINUE
      GO TO 300
C
C     ROWFLG = 1       OUT-OF-PLANE SHEAR (LAST 2 ROWS)
C
  140 DO 150 KBAR=1,NDOF
      IBAR=((KBAR-1)/3)*3+KBAR
      BMATRX(KBAR+NDOF)=BSBAR(IBAR  )
      BMATRX(KBAR     )=BSBAR(IBAR+3)
  150 CONTINUE
      GO TO 300
C
C*****
C     FILL IN B-MATRIX FOR THE MIDI PATH
C*****
C
  200 DO 210 IJI=1,NN
  210 BMATRX(IJI)=0.0E0
      GO TO (280,260,220), ROWFLG
C
C     ROWFLG = 3       FIRST SIX ROWS
C
  220 IF (.NOT.MEMBRN) GO TO 240
      DO 230 KA=1,NNODE
      KK=(KA-1)*6
      DO 230 M=1,3
      BMATRX(M+KK     )=PHI(1)*BBAR(M+KK     )+PHI(2)*BBAR(M+KK+ND3)
      BMATRX(M+KK+NDOF)=PHI(4)*BBAR(M+KK+NDOF)+PHI(5)*BBAR(M+KK+ND4)
  230 CONTINUE
C
  240 IF (.NOT.BENDNG) GO TO 300
      DO 250 KA=1,NNODE
      KK=(KA-1)*6
      DO 250 N=4,6
      BMATRX(N+KK+ND3)=PHI(1)*BBAR(N+KK     )+PHI(2)*BBAR(N+KK+ND3)
      BMATRX(N+KK+ND4)=PHI(4)*BBAR(N+KK+NDOF)+PHI(5)*BBAR(N+KK+ND4)
  250 CONTINUE
      GO TO 300
C
C     ROWFLG = 2       IN-PLANE SHEAR (3RD AND 6TH ROWS)
C
  260 DO 270 KA=1,NNODE
      KK=(KA-1)*6
      DO 270 M=1,3
      N=3+M
      BMATRX(M+KK     )=PHI(4)*BBAR(M+KK    )+PHI(1)*BBAR(M+KK+NDOF)
     1                 +PHI(5)*BBAR(M+KK+ND3)+PHI(2)*BBAR(M+KK+ND4 )
      BMATRX(N+KK+NDOF)=PHI(4)*BBAR(N+KK    )+PHI(1)*BBAR(N+KK+NDOF)
     1                 +PHI(5)*BBAR(N+KK+ND3)+PHI(2)*BBAR(N+KK+ND4 )
  270 CONTINUE
      GO TO 300
C
C     ROWFLG = 1       OUT-OF-PLANE SHEAR (LAST 2 ROWS)
C
  280 DO 290 KA=1,NNODE
      KK=(KA-1)*6
      DO 290 M=1,3
      N=3+M
      KKK=KK*2
      BMATRX(M+KK+NDOF)=BSBAR(M+KKK  )
      BMATRX(N+KK+NDOF)=BSBAR(M+KKK+6)
      BMATRX(M+KK     )=BSBAR(N+KKK  )
      BMATRX(N+KK     )=BSBAR(N+KKK+6)
  290 CONTINUE
C
  300 CONTINUE
      RETURN
      END

      SUBROUTINE STPBG(BM,GM,NS,BLOC,D,CA,NSIZE)
C     MAKES MATRICES BM AND GM FOR EACH STRIP
      DIMENSION NSIZE(1),CA(1),D(1),BLOC(1),BM(4,4,NS),GM(4,3,NS)
      DO 100 N=1,NS
      DO 10 I=1,4
      DO 10 J=1,4
   10 BM(I,J,N)=0.0
      DO 15 I=1,4
      DO 15 J=1,3
   15 GM(I,J,N)=0.0
      BM(1,1,N)=  BLOC(N)
      BM(2,2,N)= -BLOC(N)*BLOC(N)
      GM(1,1,N)=-1.0/BLOC(N)
      GM(2,2,N)= 1.0
      IF(NSIZE(N).EQ.2) GO TO 50
C         CONTROL SURFACE CASE
      E= CA(N) + D(N) - 1.5*BLOC(N)
      BM(3,3,N)=E*BLOC(N)
      BM(3,4,N)= BM(2,2,N)
      GM(3,3,N)= 1.0
      GM(4,3,N)= -E/BLOC(N)
   50 CONTINUE
  100 CONTINUE
      RETURN
      END

      SUBROUTINE AMGB1S (INPUT,FMAT,XYZB,INDEX,RADII,WFACT,NLINE)
C
C     COMPUTE F(INVERSE) AND WFACT FOR THIS STREAMLINE
C
      LOGICAL         TSONIC,DEBUG
      INTEGER         SLN
      REAL            MINMAC,MAXMAC,MACH
      DIMENSION       FMAT(NSTNS,NSTNS),XYZB(3,NSTNS),INDEX(1),RADII(1),
     1                TBL(3,3)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /SYSTEM/ SYSBUF,IOUT
      COMMON /AMGMN / MCB(7),NROW,DUM(2),REFC,SIGMA,RFREQ
      COMMON /CONDAS/ PI,TWOPI,RADEG,DEGRA,S4PISO
      COMMON /BAMG1L/ IREF,MINMAC,MAXMAC,NLINES,NSTNS,REFSTG,REFCRD,
     1                REFMAC,REFDEN,REFVEL,REFFLO,SLN,NSTNSX,STAGER,
     2                CHORD,RADIUS,BSPACE,MACH,DEN,VEL,FLOWA,AMACH,
     3                REDF,BLSPC,AMACHR,TSONIC,XSIGN
      COMMON /AMGBUG/ DEBUG
C
C     READ STREAMLINE DATA
C
      NSTNS3 = 3*NSTNS
      CALL FREAD (INPUT,SLN,10,0)
      CALL FREAD (INPUT,XYZB,NSTNS3,0)
      IF (DEBUG) CALL BUG1 ('ACPT-SLN  ',11,SLN,10)
      IF (DEBUG) CALL BUG1 ('XYZB      ',12,XYZB,NSTNS3)
C
C     COMPUTE PARAMETERS
C
      AMACH  = MACH  *COS(DEGRA*(FLOWA-STAGER))
      AMACHR = REFMAC*COS(DEGRA*(REFFLO-REFSTG))
      IF (DEBUG) CALL BUG1 ('AMACH     ',13,AMACH,1)
      IF (DEBUG) CALL BUG1 ('AMACHR    ',14,AMACHR,1)
C
C     (1) COMPUTE BASIC TO LOCAL TRANSFORMATION
C         XYZB ARRAY CONTAINS X,Y,Z COORDINATES IN BASIC SYSTEM
C         FOR ALL NODES ON THE STREAMLINE LEADING EDGE TO TRAILING EDGE
C     (2) TRANSFORM BASIC X,Y,Z ON STREAMLINE TO LOCAL X,Y,Z-S
C     (3) COMPUTE FMAT(NSTNS X NSTNS)
C     (4) COMPUTE FMAT(INVERS) - USE -
C         CALL INVERS(NSTNS,FMAT,NSTNS,DUM1,0,DETERM,ISING,INDEX)
C     (5) COMPUTE WFACT FOR THIS STREAMLINE - NOTE - ALL RADIUS HAVE
C         ALREADY BEEN STORED IN ARRAY RADII FOR ALL STREAMLINES
C
      XA =  XYZB(1,1)
      YA =  XYZB(2,1)
      ZA =  XYZB(3,1)
      XB =  XYZB(1,NSTNS)
      YB =  XYZB(2,NSTNS)
      ZB =  XYZB(3,NSTNS)
C
C     EVALUATE  TBL  ROW 2
C
      XBA = XB - XA
      YBA = YB - YA
      ZBA = ZB - ZA
      AL2SQ = XBA**2 + YBA**2
      AL2 = SQRT(AL2SQ)
      AL1SQ = AL2SQ  + ZBA**2
      AL1=  SQRT(AL1SQ)
      TBL(2,1) =-XSIGN*(YBA/AL2)
      TBL(2,2) = XSIGN*(XBA/AL2)
      TBL(2,3) = 0.0
C
C     EVAL  TBL  ROW 1
C
      TBL(1,1) = XBA/AL1
      TBL(1,2) = YBA/AL1
      TBL(1,3) = ZBA/AL1
C
C     EVALUATE TBL  ROW 3
C
      TBL(3,1) =-TBL(1,3)*(XBA/AL2)
      TBL(3,2) =-TBL(1,3)*(YBA/AL2)
      TBL(3,3) = AL2/AL1
      FMAT(1,1)= 1.0
      PIC =  PI/CHORD
      CH2 = 2.0/CHORD
      DO 40 I = 2,NSTNS
      X = TBL(1,1)*(XYZB(1,I)-XYZB(1,1))
     1  + TBL(1,2)*(XYZB(2,I)-XYZB(2,1))
     2  + TBL(1,3)*(XYZB(3,I)-XYZB(3,1))
      FMAT(1,I) = 0.0
      FMAT(I,1) = 1.0
      FMAT(I,2) = CH2*X
      DO 30 J = 3,NSTNS
      AN  = J - 2
      ARG = PIC*AN*X
  30  FMAT(I,J) = SIN(ARG)
  40  CONTINUE
      IF (DEBUG) CALL BUG1 ('FMAT      ',50,FMAT,NSTNS*NSTNS)
      ISING = -1
      CALL INVERS (NSTNS,FMAT,NSTNS,DUM1,0,DETERM,ISING,INDEX)
      IF (DEBUG) CALL BUG1 ('FMAT-INV  ',60,FMAT,NSTNS*NSTNS)
      IF (ISING .EQ. 2) GO TO 80
      K = NLINE + 1
      L = K - 2
      IF (NLINE .EQ.      1) L = 1
      IF (NLINE .EQ. NLINES) K = NLINES
C
C     COMPUT WFACT FOR THIS STREAMLINE
C
      WFACT = (DEN/REFDEN)*(VEL/REFVEL)**2 *
     1        ((AMACH*REFMAC)/(MACH*AMACHR))**2 *
     2        (RADII(K) - RADII(L))*0.5
      IF (DEBUG) CALL BUG1 ('WFACT     ',70,WFACT,1)
      RETURN
C
C     ERROR MESSAGE, SINGULAR MATRIX
C
   80 WRITE  (IOUT,90) UFM,SLN
   90 FORMAT (A23,' -AMG MODULE- SINGULAR MATRIX IN ROUTINE AMGB1S FOR',
     1     ' STREAML2, SLN =',I3, /39X,'CHECK STREAML2 BULK DATA CARD.')
      CALL MESAGE (-61,0,0)
      RETURN
      END

      SUBROUTINE CINVP3
C
C     SUBROUTINE CINVP3, THE MAIN LINK OF CINVPR, SOLVES FOR THE
C     EIGENVALUES AND EIGENVECTORS OF (LAMBDA**2*M + LAMBDA*B*K)
C
C     TYPE DECLARATIONS
C
      INTEGER            COMFLG    ,REAL     ,END      ,FILEK
      INTEGER            FILEB     ,FILELM   ,SCRFIL
      INTEGER            SWITCH    ,CDP      ,FILEL    ,SR1FIL   ,
     1                   FILEU     ,SR3FIL   ,SR4FIL   ,SR8FIL   ,
     2                   SR9FIL    ,SYSBUF   ,NAME(2)  ,FILEVC   ,
     3                   TIMED     ,TIMEIT   ,SQR      ,FILE(7)  ,
     4                   SR2FIL    ,S11FIL   ,T1       ,T2
      REAL               MAXMOD
      DOUBLE PRECISION   DZ(1)     ,LMBDA    ,PLUS1(2)
      DOUBLE PRECISION   LAMBDA    ,ALN(2)   ,ALNM1(2) ,ETA(2)   ,
     1                   ETANM1(2) ,H2N(2)   ,H2NM1(2) ,LAM1     ,
     2                   LM1NM1(2) ,LAM2(2)  ,LM2NM1(2),CON1(2)  ,
     3                   CON2(2)   ,CN(2)    ,DELTA(2) ,XYZ(2)
      COMMON   /SYSTEM/  SYSBUF    ,NOUT
      COMMON   /CINVPX/  FILEK(7)  ,FILEM(7) ,FILEB(7) ,FILELM(7),
     1                   FILEVC(7) ,DUDXX    ,SCRFIL(11)         ,
     2                   NOREG     ,EPS
      COMMON   /CINFBX/  FILEL(7)  ,FILEU(7)
      COMMON   /CINVXX/  LAMBDA(2) ,SWITCH   ,COMFLG   ,LMBDA(2) ,
     1                   ITERTO    ,TIMED    ,NOCHNG   ,RZERO    ,
     2                   IND       ,IVECT    ,IREG     ,REAL     ,
     3                   LEFT      ,NORTHO   ,NOROOT   ,NZERO    ,
     4                   LAM1(2)   ,MAXMOD   ,NODES    ,NOEST    ,
     5                   ISTART    ,IND1     ,ITER     ,ISYM
      COMMON   /NAMES /  RD        ,RDREW    ,WRT      ,WRTREW   ,
     1                   REW       ,NOREW    ,EOFNRW   ,RSP      ,
     2                   RDP       ,CSP      ,CDP      ,SQR
      COMMON   /CDCMPX/  XXYY(20)  ,IOFFF
      COMMON   /ZZZZZZ/  Z(1)
      EQUIVALENCE        (FILEK(2),NCOL)     ,(SCRFIL(1),SR1FIL) ,
     1                   (SCRFIL(2),SR2FIL)  ,(SCRFIL(3),SR3FIL) ,
     2                   (SCRFIL(4),SR4FIL)  ,
     4                   (SCRFIL(8),SR8FIL)  ,(SCRFIL(9),SR9FIL) ,
     5                   (DZ(1),Z(1))        ,(SCRFIL(11),S11FIL)
      DATA      NAME  /  4HCINV,4HP3   /
      DATA      PLUS1 /  +1.D0 ,0.D0   /
C
C     DEFINITION OF LOCAL PARAMETERS
C
C     ITER     =
C     IRAPID   =
C     IEP2     =
C     NCOUNT   =
C     IEPCNT   =
C     SWITCH   =
C     A        =
C     EP1      =
C     EP2      =
C     EP3      =
C     GAMMA    =
C     II1      =    POINTER TO U(N)
C     II2      =    POINTER TO U(N-1) OR DELTA U(N)
C     JJ1      =    POINTER TO F(N)
C     JJ2      =    POINTER TO DELTA F(N-1)
C     JJ3      =    POINTER TO F(N-1) OR DELTA F(N)
C     JJ4      =
C     JJ5      =
C     KK1      =    POINTER TO V(N)
C     KK2      =    POINTER TO V(N-1)
C
   10 CONTINUE
      TIMEIT= 0
      NZ    = KORSZ(Z)
      NCOL2 = NCOL  + NCOL
      NCOL4 = NCOL2 + NCOL2
C
C     INITIALIZE
C
      CN(1)  = 0.0D0
      CN(2)  = 0.0D0
      XYZ(1) = 0.0D0
      XYZ(2) = 0.0D0
      H2N(1) = 0.0D0
      H2N(2) = 0.0D0
      LAM2(1)= 0.0D0
      LAM2(2)= 0.0D0
      LAM1(1)= 0.0D0
      LAM1(2)= 0.0D0
      ITER   = 0
      CALL KLOCK(T1)
      IRAPID = 0
      IEP2   = 0
   20 NCOUNT = 0
      IEPCNT = 0
      IF (SWITCH .EQ. 1) GO TO 30
      FILEL(1) = SR3FIL
      FILEU(1) = SR4FIL
      GO TO 40
   30 FILEL(1) = SR8FIL
      FILEU(1) = SR9FIL
   40 FILEL(5) = CDP
      FILEL(3) = FILEK(3)
      FILEU(7) = IOFFF
      FILE(4)  = SQR
      FILE(5)  = CDP
C
C     SET CONVERGENCE CRITERIA
C
      A   = .1
      CALL SSWTCH (12,IDIAG)
      EP1 = .001
      EP2 = .02
      EP3 = .05
      GAMMA = .01
C
C     INITILIZE POINTERS TO VECTORS
C
      II1 = 1
      II2 = II1 + NCOL2
      JJ1 = II2 + NCOL2
      JJ2 = JJ1 + NCOL2
      JJ3 = JJ2 + NCOL2
      JJ5 = JJ3 + NCOL2
      KK1 = JJ5 + NCOL2
      KK2 = KK1 + NCOL2
      KK3 = KK2 + NCOL2
      KK4 = KK3 + NCOL2
      KK5 = KK4 + NCOL2
      KK6 = KK5 + NCOL2
      LL1 = KK6 + NCOL2
      LL2 = LL1 + NCOL2
      END = (LL2 + NCOL2)*2
      IOBUF = NZ - SYSBUF + 1
      IBUF1 = IOBUF - SYSBUF
      IBUF2 = IBUF1 - SYSBUF
      IBUF3 = IBUF2 - SYSBUF
C     IBUF4 = IBUF3 - SYSBUF
C     IBUF5 = IBUF4 - SYSBUF
C     IBUF6 = IBUF5 - SYSBUF
C     IF (END .GE. IBUF6) GO TO 240
C     NZZ = IBUF6 - END
      IF (END .GE. IBUF3) GO TO 600
      NZZ = IBUF3 - END
C     IFILE = FILEL(1)
C     CALL OPEN (*610,FILEL,Z(IBUF4),0)
C     IFILE = FILEU(1)
C     CALL OPEN (*610,FILEU,Z(IBUF5),0)
C     IFILE = FILEM(1)
C     CALL OPEN (*610,FILEM,Z(IBUF6),0)
C
C     GENERATE A STARTING VECTOR
C
C     FORM U0
C
      IF (LEFT .EQ. 1) GO TO 500
      LAM1(1) = 0.0D0
      LAM1(2) = 0.0D0
      GO TO 70
   50 LAM1(1) = 0.0D0
      LAM1(2) = 0.0D0
      IF (NORTHO .EQ. 0) GO TO 70
C
C     TEST FOR INSUFFICIENT TIME
C
      CALL KLOCK  (ICURNT)
      CALL TMTOGO (IIJJKK)
      NAVG = (ICURNT-ISTART)/NORTHO
      IF (IIJJKK .GE. 2*NAVG) GO TO 70
   60 COMFLG = 8
      GO TO 490
   70 CONTINUE
      IF (IVECT .EQ. 1) GO TO 90
      K = IABS (IND)
      DO 80 I = 1,NCOL2,2
      DZ(I) = (MOD(K,13)+1)*(1+5*I/NCOL)
      K = K + 1
      DZ(I+1) = 0.D0
   80 DZ(I  ) = 1.D0/DZ(I)
      CALL CNORM1 (DZ(II1),NCOL)
C
C     FORM V0 = LAMBDA*U0
C
      GO TO 110
C
C     USE PREVIOUSLY STORED VECTOR FOR STARTING VECTOR
C
   90 IFILE = FILEVC(1)
      CALL GOPEN  (FILEVC,Z(IOBUF),RD)
      CALL BCKREC (FILEVC(1))
      IN1 = 1
      IF (COMFLG .NE. 1) GO TO 100
      IN1 = JJ5
      CALL BCKREC (FILEVC(1))
  100 CALL FREAD  (FILEVC,DZ(IN1),NCOL4,1)
      IF (COMFLG .EQ. 1) GO TO 140
      CALL BCKREC (FILEVC(1))
      CALL CLOSE  (FILEVC(1),NOREW)
      IVECT = 0
  110 CONTINUE
      DO 120 IU = 1,NCOL2,2
      J = KK1 + IU - 1
      DZ(J  ) = DZ(IU)*LAMBDA(1) - DZ(IU+1)*LAMBDA(2)
  120 DZ(J+1) = DZ(IU)*LAMBDA(2) + DZ(IU+1)*LAMBDA(1)
      IF (NORTHO .EQ. 0) GO TO 150
      CALL ORTHO (DZ(II1),DZ(KK1),DZ(KK2),DZ(KK3),DZ(KK4),DZ(KK5),
     1            DZ(KK6),NZZ,Z(IOBUF),Z(IBUF1),Z(IBUF2),Z(IBUF3))
      IF (FILEB(1) .NE. 0) GO TO 150
      DO 130 IU = 1,NCOL2,2
      J = KK1 + IU - 1
      DZ(J  ) = DZ(IU)*LAMBDA(1) - DZ(IU+1)*LAMBDA(2)
  130 DZ(J+1) = DZ(IU)*LAMBDA(2) + DZ(IU+1)*LAMBDA(1)
      GO TO 150
C
C     PICK UP LAST ITERATED VECTOR FOR A STARTING VECTOR
C
  140 CALL FREAD  (FILEVC,DZ,NCOL4,1)
      CALL SKPREC (FILEVC,-2)
      CALL CLOSE  (FILEVC(1),NOREW)
      GO TO 110
  150 CONTINUE
      CALL CM TIM U (DZ(II1),DZ(JJ1),0,Z(IOBUF))
      IF (FILEB(1) .EQ. 0) GO TO 160
      FILE(1) = FILEB(1)
      CALL CM TIM U (DZ(II1),DZ(KK2),FILE,Z(IBUF1))
      CON1(1) = 2.0D0*LAMBDA(1)
      CON1(2) = 2.0D0*LAMBDA(2)
      CALL CDIVID (PLUS1,CON2,CON1,2)
      CON2(1) = -CON2(1)
      CON2(2) = -CON2(2)
      CALL CSUB (DZ(JJ1),DZ(KK2),DZ(JJ1),PLUS1,CON2)
  160 CONTINUE
      CALL CX TRN Y (DZ(II1),DZ(JJ1),ALN(1))
      CALL CSQRTX (ALN(1),ALN(1))
C
C     COMPUTE THE R.H.S. OF THE SYSTEM OF EQUATIONS
C
  170 FILE(1) = SR2FIL
      IF (SWITCH .EQ. 1) FILE(1) = S11FIL
      CALL CM TIM U (DZ(II1),DZ(LL1),FILE(1),Z(IOBUF))
      CALL CM TIM U (DZ(KK1),DZ(LL2),0      ,Z(IOBUF))
      CALL CSUB (DZ(LL1),DZ(LL2),DZ(LL2),PLUS1(1),PLUS1(1))
C
C     SHIFT POINTERS
C
      II  = II1
      II1 = II2
      II2 = II
      II  = JJ1
      JJ1 = JJ2
      JJ2 = JJ3
      JJ3 = II
C
C     SAVE THE N-1 VECTOR
C
      IF (SWITCH .NE. 0) GO TO 190
      IXX = JJ5 + NCOL2 - 1
      IXZ = II2
      DO 180 I = JJ5,IXX
      DZ(I) = DZ(IXZ)
  180 IXZ = IXZ + 1
  190 CONTINUE
      CALL TMTOGO (IXX)
      IF (IXX .LE. 0) GO TO 60
C
C     SHIFT PARAMETERS
C
      ALNM1(1)  = ALN(1)
      ALNM1(2)  = ALN(2)
      ETANM1(1) = XYZ(1)
      ETANM1(2) = XYZ(2)
      H2NM1(1)  = H2N(1)
      H2NM1(2)  = H2N(2)
      LM1NM1(1) = LAM1(1)
      LM1NM1(2) = LAM1(2)
      LM2NM1(1) = LAM2(1)
      LM2NM1(2) = LAM2(2)
C
C     CALL CINFBS TO MAKE ONE ITERATION
C
      CALL CINFBS (DZ(LL2),DZ(II1),Z(IOBUF))
      ITERTO = ITERTO + 1
      ITER   = ITER + 1
      IEPCNT = IEPCNT + 1
      CALL CNORM (DZ(II1),CN(1),DZ(II2))
C
      IF (IDIAG .EQ. 0) GO TO 210
      KKKK = II1 + NCOL2 - 1
      WRITE  (NOUT,200) ITERTO,ITER,CN,TIMED,TIMEIT,(DZ(KX),KX=II1,KKKK)
  200 FORMAT (15H ITERTO =        ,I5,10H ITER =     ,I5,' CN =    ',
     1        2D15.5,10H TIMED =    ,I5,10H TIMEIT=       ,I5,
     2        //,20H ITERATER VECTOR      , //,(10D12.4))
  210 CONTINUE
C
C     COMPUTE V(N)BAR
C
      CON1(1) =-CN(1)/(CN(1)**2 + CN(2)**2)
      CON1(2) = CN(2)/(CN(1)**2 + CN(2)**2)
      CALL CSUB (DZ(II1),DZ(II2),DZ(KK1),LAMBDA,CON1)
      IF (NORTHO .EQ. 0) GO TO 220
C
C     ORTHOGONALIZE CURRENT ITERANT WITH RESPECT TO VECTORS FOUND IN
C     THE CURRENT AND PREVIOUS REGIONS
C
      CALL ORTHO (DZ(II1),DZ(KK1),DZ(KK2),DZ(KK3),DZ(KK4),DZ(KK5),
     1            DZ(KK6),NZZ,Z(IOBUF),Z(IBUF1),Z(IBUF2),Z(IBUF3))
  220 CONTINUE
      IF (FILEB(1) .NE. 0) GO TO 230
C
C     COMPUTE V(N)
C
      CALL CSUB (DZ(II1),DZ(II2),DZ(KK1),LAMBDA,CON1(1))
  230 CONTINUE
C
C     BEGIN TESTING CONVERGENCE CRITERIA
C
C     COMPUTE F(N)
C
      CALL CM TIM U (DZ(II1),DZ(JJ1),0,Z(IOBUF))
      IF (FILEB(1) .EQ. 0) GO TO 240
      FILE(1) = FILEB(1)
      CALL CM TIM U (DZ(II1),DZ(KK2),FILE,Z(IBUF1))
      CON1(1) = 2.0D0*LAMBDA(1)
      CON1(2) = 2.0D0*LAMBDA(2)
      CALL CDIVID (PLUS1,CON2,CON1,2)
      CON2(1) = -CON2(1)
      CON2(2) = -CON2(2)
      CALL CSUB (DZ(JJ1),DZ(KK2),DZ(JJ1),PLUS1,CON2)
  240 CONTINUE
C
C     COMPUTE ALPHA(N)
C
      CALL CX TRN Y (DZ(II1),DZ(JJ1),ALN(1))
      CALL CSQRTX (ALN(1),ALN(1))
C
C     COMPUTE DELTA U(N)
C
      CON1(1) = ALN(1)/(ALN(1)**2 + ALN(2)**2)
      CON1(2) =-ALN(2)/(ALN(1)**2 + ALN(2)**2)
      CON2(1) = ALNM1(1)/(ALNM1(1)**2 + ALNM1(2)**2)
      CON2(2) =-ALNM1(2)/(ALNM1(1)**2 + ALNM1(2)**2)
      CALL CSUB (DZ(II1),DZ(II2),DZ(II2),CON1(1),CON2(1))
C
C     COMPUTE DELTA F(N)
C
      CALL CSUB (DZ(JJ1),DZ(JJ3),DZ(JJ3),CON1(1),CON2(1))
      CON1(1) = CN(1)*ALN(1) - CN(2)*ALN(2)
      CON1(2) = CN(2)*ALN(1) + CN(1)*ALN(2)
      LAM1(1) = (ALNM1(1)*CON1(1) + ALNM1(2)*CON1(2))/(CON1(1)**2 +
     1          CON1(2)**2)
      LAM1(2) = (ALNM1(2)*CON1(1) - ALNM1(1)*CON1(2))/(CON1(1)**2 +
     1          CON1(2)**2)
      IF (IRAPID .EQ. 1) GO TO 410
      CALL CX TRN Y (DZ(II2),DZ(JJ3),ETA(1))
      CALL CSQRTX (ETA(1),XYZ(1))
C
      IF (IDIAG .EQ. 0) GO TO 260
      WRITE  (NOUT,250) LAM1,XYZ,ALN
  250 FORMAT (12H LAMBDA =    ,2D15.5,12H  ETA =        ,2D15.5,
     1        12H ALPHA =     ,2D15.5)
  260 CONTINUE
      IF (ITER .EQ. 1) GO TO 170
C
C     RAPID CONVERGENCE TEST
C
C     IF (ETA.GE.A*EPS*GAMMA*(1.+LAMBDA/LAM1)
C
      CON1(1) = (LAMBDA(1)*LAM1(1) + LAMBDA(2)*LAM1(2))/(LAM1(1)**2 +
     1          LAM1(2)**2)
      CON1(2) = (LAMBDA(2)*LAM1(1) - LAMBDA(1)*LAM1(2))/(LAM1(1)**2 +
     1          LAM1(2)**2)
      IF (DSQRT(XYZ(1)**2+XYZ(2)**2).GE. A*EPS*GAMMA*DSQRT(1.+CON1(1)**2
     1         + CON1(1)**2+CON1(2)**2)) GO TO 280
  270 IRAPID = 1
      GO TO 170
  280 CONTINUE
      IF (DSQRT(ETANM1(1)**2+ETANM1(2)**2) .GE. 1.E-06) GO TO 290
      IF (DSQRT(XYZ(1)**2+XYZ(2)**2)-1.01*DSQRT(ETANM1(1)**2+
     1    ETANM1(2)**2)) 290,290,270
C
C     EPSILON 2 TEST
C
  290 IF (IEP2 .EQ. 1) GO TO 310
      CALL CX TRN Y (DZ(II2),DZ(JJ2),CON1(1))
      CON2(1) = CON1(1)*LAM1(1) - CON1(2)*LAM1(2)
      CON1(2) = CON1(1)*LAM1(2) + CON1(2)*LAM1(1)
      CON1(1) = CON2(1)
      LAM2(1) = (CON1(1)*ETA(1) + CON1(2)*ETA(2))/(ETA(1)**2 +ETA(2)**2)
      LAM2(2) = (CON1(2)*ETA(1) - CON1(1)*ETA(2))/(ETA(1)**2 +ETA(2)**2)
      CON1(1) = LAM2(1) - LM2NM1(1)
      CON1(2) = LAM2(2) - LM2NM1(2)
      H2N(1)  = (CON1(1)*LAMBDA(1) + CON1(2)*LAMBDA(2))/(LAMBDA(1)**2 +
     1          LAMBDA(2)**2)
      H2N(2)  = (CON1(2)*LAMBDA(1) - CON1(1)*LAMBDA(2))/(LAMBDA(1)**2 +
     1          LAMBDA(2)**2)
      IF (ITER .LT. 4) GO TO 310
      IF (EP2 .GT. DSQRT(H2N(1)**2 + H2N(2)**2).AND.
     1   DSQRT(H2N(1)**2+H2N(2)**2) .GT. DSQRT(H2NM1(1)**2+H2NM1(2)**2))
     1   GO TO 300
      GO TO 310
  300 IEP2 = 1
      LAM2(1) = LM2NM1(1)
      LAM2(2) = LM2NM1(2)
  310 CON1(1) = 1. - (LAM2(1)*LAM1(1) + LAM2(2)*LAM1(2))/(LAM1(1)**2 +
     1          LAM1(2)**2)
      CON1(2) = (LAM2(2)*LAM1(1) - LAM2(1)*LAM1(2))/(LAM1(1)**2 +
     1          LAM1(2)**2)
      CON2(1) = CON1(1)*CON1(1) - CON1(2)*CON1(2)
      CON1(2) = 2.*CON1(2)*CON1(1)
      CON1(1) = CON2(1)
      CON1(1) = DMIN1(DSQRT(CON1(1)**2+CON1(2)**2),10.0D0)
      DELTA(1)= ETA(1)/CON1(1)
      DELTA(2)= ETA(2)/CON1(1)
C
      IF (IDIAG .EQ. 0) GO TO 330
      WRITE  (NOUT,320)LAM2,H2N,DELTA
  320 FORMAT (12H  LAMBDA =      ,2D15.5,     12H  H2N =     ,2D15.5,
     1        12H DELTA =      ,2D15.5)
  330 CONTINUE
C
C     VECTOR CONVERGENCE TEST
C
      IF (DSQRT(DELTA(1)**2+DELTA(2)**2).LE. (A*EPS)**2) GO TO 410
      IF (ITER .LE. 3) GO TO 170
C
C     EPSILON 1 TEST
C
      IF (IEPCNT .GE. 100) GO TO 520
      IF (IEPCNT .GE.  10) GO TO 340
      IF (DSQRT((LAM1(1)-LM1NM1(1))**2+(LAM1(2)-LM1NM1(2))**2)
     1   /DSQRT((LAMBDA(1) + DABS(LAM1(1)))**2+(LAMBDA(2) +DABS(LAM1(2))
     2    )**2) .GE. EP1) GO TO 170
      IEPCNT = 0
  340 CONTINUE
C
C     SHIFT DECISION
C
      CALL KLOCK (T2)
      TIMEIT = T2-T1
      IF (IDIAG .EQ. 0) GO TO 360
      WRITE  (NOUT,350) T2,T1,TIMEIT
  350 FORMAT (3I15)
  360 CONTINUE
      K = DLOG(DSQRT(DELTA(1)**2+DELTA(2)**2)/(A*EPS)**2)/DABS(DLOG(
     1    DSQRT(LAM1(1)**2+LAM1(2)**2)/DSQRT(LAM2(1)**2+LAM2(2)**2)))+1.
      K = K/2
      IF (IDIAG .EQ. 0) GO TO 380
      WRITE  (NOUT,370) K
  370 FORMAT (I5)
  380 CONTINUE
      IR1 = FLOAT(K-3)*FLOAT(TIMEIT)/FLOAT(ITER)
      IF (TIMED .GE. IR1) GO TO 170
      LAMBDA(1) = LAMBDA(1) + LAM1(1)
      LAMBDA(2) = LAMBDA(2) + LAM1(2)
C
C     STORE THE LAST VECTOR BEFORE A SHIFT FOR USE AS A STARTING VECTOR
C
      IF (SWITCH .EQ. 1) GO TO 390
      IN1 = II1
      GO TO 400
  390 IN1 = JJ5
  400 IFILE = FILEVC(1)
      CALL GOPEN (IFILE,Z(IOBUF),WRT)
      CALL WRITE (IFILE,DZ(IN1),NCOL4,1)
      IVECT  = 1
      COMFLG = 1
C
C     STORE  THE CURRENT VECTOR ON THE EIGENVECTOR FILE SO IT CAN BE
C     USED AS THE STARTING VECTOR
C
      CALL WRITE (IFILE,DZ(II1),NCOL4,1)
      CALL CLOSE (IFILE,EOFNRW)
      GO TO 490
C
C     M  RAPID CONVERGENCE MAKE SURE LAMD1 PASSES EP1 TEST
C
  410 CONTINUE
      IF (DSQRT((LAM1(1)-LM1NM1(1))**2+(LAM1(2)-LM1NM1(2))**2)
     1   /DSQRT((LAMBDA(1) + DABS(LAM1(1)))**2+(LAMBDA(2) +DABS(LAM1(2))
     2   )**2) .GE. EP1) GO TO 170
C
C     CONVERGENCE ACHIEVED, NORMALIZE THE VECTOR
C
C     STORE THE EIGENVECTOR AND EIGENVALUE ON THE OUTPUT FILES
C
      CALL CNORM1 (DZ(II1),NCOL)
      LAM1(1) = LAM1(1) + LAMBDA(1)
      LAM1(2) = LAM1(2) + LAMBDA(2)
      INU = II1 + NCOL2 - 1
      IF (IDIAG .EQ. 0) GO TO 430
      WRITE  (NOUT,420) LAM1,(DZ(I),I=II1,INU)
  420 FORMAT (1H1, 20H CONVERGENCE           ,//,' LAMBDA = ',2D15.5,
     1        //,(10D12.4))
  430 CONTINUE
      IFILE = FILEVC(1)
      CALL GOPEN (IFILE,Z(IOBUF),WRT)
      CALL WRITE (IFILE,DZ(II1),NCOL4,1)
      CALL CLOSE (IFILE,EOFNRW)
      IFILE = FILELM(1)
      CALL GOPEN (IFILE,Z(IOBUF),WRT)
      CALL WRITE (IFILE,LAM1(1),4,1)
      CALL CLOSE (IFILE,EOFNRW)
      NORTHO = NORTHO + 1
      NOROOT = NOROOT + 1
      IEP2   = 0
      IRAPID = 0
      NOCHNG = 0
      COMFLG = 0
      IF (SWITCH .EQ. 0) GO TO 440
      SWITCH = 0
      LAMBDA(1) = LMBDA(1)
      LAMBDA(2) = LMBDA(2)
      GO TO 450
  440 CONTINUE
      IVECT = 0
      IF (ITER .LE. 5) GO TO 460
  450 IN1   = JJ5
      IFILE = FILEVC(1)
      CALL GOPEN (IFILE,Z(IOBUF),WRT)
      CALL WRITE (IFILE,DZ(IN1),NCOL4,1)
      CALL CLOSE (IFILE,EOFNRW)
      IVECT = 1
  460 ITER  = 0
C
C     COMPUTE PSEUDO LEFT VECTOR
C
      CALL CM TIM U (DZ(II1),DZ(JJ3),0,Z(IOBUF))
      IF (FILEB(1) .EQ. 0) GO TO 470
      CALL CMTIMU (DZ(II1),DZ(JJ2),FILEB,Z(IBUF1))
      CON1(1) = 2.0D0*LAM1(1)
      CON1(2) = 2.0D0*LAM1(2)
      CON2(1) =-1.0D0
      CON2(2) = 0.0D0
      CALL CSUB (DZ(JJ3),DZ(JJ2),DZ(JJ3),CON1,CON2)
  470 IF (ISYM .EQ. 1) GO TO 480
C
C     LEFT = RIGHT FINISH JOB
C
      CALL CX TRN Y (DZ(II1),DZ(JJ3),CON1)
      CALL CDIVID (DZ(II1),DZ(JJ3),CON1,NCOL2)
C
C     PUT SCALED VECTOR ON LEFT VECTOR FILE
C
  480 IFILE = SCRFIL(10)
      CALL GOPEN (IFILE,Z(IBUF1),WRT)
      CALL WRITE (IFILE,DZ(JJ3),NCOL4,1)
      CALL CLOSE (IFILE,EOFNRW)
      LEFT = 1
      IF (ISYM .EQ. 0) GO TO 10
C
C 490 CALL CLOSE (FILEL,1)
C     CALL CLOSE (FILEU,1)
C     CALL CLOSE (FILEM,1)
  490 RETURN
C
C     RETURN TO MAIN DRIVER TO COMPUTE THE LEFT EIGENVECTOR
C
C
C     ENTRY POINT UPON RETURNING FROM OBTAINING THE LEFT VECTOR
C
  500 LEFT = 0
      IF (NODES  .LE. NOROOT) GO TO 550
      IF (NOROOT .GE.3*NOEST) GO TO 540
      AAA = DSQRT((LAMBDA(1) - LAM1(1))**2 + (LAMBDA(2)-LAM1(2))**2)
      IF (AAA .LE. RZERO) GO TO 570
      IF (IREG .EQ.    0) GO TO 510
      IF (IND) 510,510,530
  510 IF (NODES .LE. NOROOT) GO TO 550
      IF (LAM1(1)**2+LAM1(2)**2 .GE. MAXMOD) GO TO 560
C
C     GET NEW STARTING  POINT
C
  520 COMFLG = 0
      IND    =-IND
      GO TO 490
C
C     GENERATE NEW ARBITRARY STARTING VECTOR
C
  530 IND   =-(IND+1)
      IVECT = 0
      IF (IND .EQ. -13) IND = -1
      GO TO 50
C
C     3*NOEST FOUND
C
  540 COMFLG = 4
      GO TO 490
C
C     ALL ROOTS IN PROBLEM FOUND
C
C     COMFLG = 5
C     GO TO 176
C
C     NO. DES. ROOTS FOUND IN REGION OF CONVERGENCE OUTSIDE REGION
C
  550 COMFLG = 6
      GO TO 490
C
C     ONE OR MORE ROOTS OUTSIDE REGION
C
  560 COMFLG = 7
      GO TO 490
C
C     FOUND ROOT OUTSIDE REGION OF CURRENT START POINT
C
  570 IND  = IABS(IND)
      IREG = 1
      IF (EPS*RZERO/DSQRT((LAM1(1)-LAMBDA(1))**2+(LAM1(2)-LAMBDA(2))**2)
     1   .LT. EP3) GO TO 20
C
C     CURRENT SHIFT POINT IS TOO CLOSE TO AN EIGENVALUE
C
      IF (COMFLG .NE. 2) GO TO 580
      COMFLG = 9
      GOT O 490
  580 LAMBDA(1) = LAMBDA(1) + .02*RZERO
      LAMBDA(2) = LAMBDA(2) + .02*RZERO
      COMFLG = 2
      GO TO 490
C
C     ERROR EXITS
C
  600 J = -8
      GO TO 620
C 610 J = -1
  620 CALL MESAGE (J,IFILE,NAME)
      RETURN
      END

      SUBROUTINE TA1C
C
C     TA1C READS GENERAL ELEMENTS FROM THE ECT AND BUILDS THE GEI.
C     FOR EACH GENERAL ELEMENT, THE UI AND UD LISTS ARE CONVERTED TO
C     SIL NOS. AND SORTED ON SIL NO. THE ELEMENTS OF THE Z AND S
C     MATRICES ARE WRITTEN IN INTERNAL SORT (I.E., ROW AND COL NOS
C     CORRESPOND TO POSITION IN THE SORTED UI AND UD LISTS.
C
C
      INTEGER         GENL  ,ECT   ,EPT   ,BGPDT ,SIL   ,GPTT  ,CSTM  ,
     1                EST   ,GPECT ,GEI   ,ECPT  ,GPCT  ,SCR1  ,SCR2  ,
     2                SCR3  ,SCR4  ,Z     ,SYSBUF,BUF1  ,BUF2  ,BUF3  ,
     3                FILE  ,FLAG  ,GENEL ,RD    ,RDREW ,WRT   ,WRTREW,
     4                CLSREW,SILNO ,BUF   ,HALF
      DIMENSION       NAM(2),BUF(10)      ,GENEL(2)
      COMMON /BLANK / LUSET ,NOSIMP,NOSUP ,NOGENL,GENL  ,COMPS
      COMMON /TA1COM/ NSIL  ,ECT   ,EPT   ,BGPDT ,SIL   ,GPTT  ,CSTM  ,
     1                MPT   ,EST   ,GEI   ,GPECT ,ECPT  ,GPCT  ,MPTX  ,
     2                PCOMPS,EPTX  ,SCR1  ,SCR2  ,SCR3  ,SCR4
      COMMON /TAC1AX/ BUF1  ,BUF2  ,BUF3  ,IUI   ,NUI   ,IUD   ,NUD   ,
     1                IZ    ,NOGO  ,IDGENL
      COMMON /ZZZZZZ/ Z(1)
      COMMON /SYSTEM/ SYSBUF,DUM38(38)    ,NBPW
      COMMON /SETUP / NFILE(6)
      COMMON /NAMES / RD    ,RDREW ,WRT   ,WRTREW,CLSREW
      DATA    GENEL / 4301  ,43  / ,NAM /  4HTA1C,4H    /
      DATA    HALF  / 65536      /
C
C     ADD MORE BITS TO HALF IF MACHINE WORD IS LARGER THAN 32
C
      IF (NBPW .GE. 36) HALF = 4*HALF
      IF (NBPW .GT. 36) HALF = 4*HALF
C
C     SET BUFFER POINTERS, ETC.
C
      BUF1 = KORSZ(Z) - SYSBUF - 2
      BUF2 = BUF1 - SYSBUF
      BUF3 = BUF2 - SYSBUF
      NOGO = 0
      NOGENL = 0
C
C     READ THE SIL INTO CORE
C
      FILE = SIL
      CALL OPEN (*2001,SIL,Z(BUF1),RDREW)
      CALL FWDREC (*2002,SIL)
      CALL READ (*2002,*1011,SIL,Z,BUF2,1,NSIL)
      CALL MESAGE (-8,0,NAM)
 1011 CALL CLOSE (SIL,CLSREW)
C
C     OPEN THE GEI. WRITE HEADER RECORD.
C
      FILE = GEI
      CALL OPEN (*2001,GEI,Z(BUF2),WRTREW)
      CALL FNAME (GEI,BUF)
      CALL WRITE (GEI,BUF,2,1)
C
C     OPEN THE ECT. READ ELEMENT ID.
C
      FILE = ECT
      CALL PRELOC (*2001,Z(BUF1),ECT)
      CALL LOCATE (*2006,Z(BUF1),GENEL,FLAG)
 1031 CALL READ (*2002,*1150,ECT,BUF,1,0,FLAG)
      IDGENL = BUF(1)
      NOGENL = NOGENL + 1
C
C     READ THE UI LIST. STORE POSITION IN UI LIST, SIL NO.,
C     INTERNAL GRID NO., AND COMPONENT CODE.
C
      IUI = NSIL + 1
      I = IUI
      J = 1
 1041 CALL READ (*2002,*2003,ECT,Z(I+2),2,0,FLAG)
      IF (Z(I+2) .EQ. -1) GO TO 1042
      Z(I) = J
      K = Z(I+2)
      Z(I+1) = Z(K)
      IF (Z(I+3) .NE. 0) Z(I+1) = Z(I+1) + Z(I+3) - 1
      I = I + 4
      J = J + 1
      GO TO 1041
 1042 NUI   = I - 4
      NBRUI = J - 1
      NWDUI = 4*NBRUI
C
C     READ THE UD LIST (IF PRESENT). STORE POSITION IN UD LIST, SIL NO.,
C     INTERNAL GRID NO., AND COMPONENT CODE.
C
      IUD = I
      J = 1
 1051 CALL READ (*2002,*2003,ECT,Z(I+2),2,0,FLAG)
      IF (Z(I+2) .EQ. -1) GO TO 1052
      Z(I) = J
      K = Z(I+2)
      Z(I+1) = Z(K)
      IF (Z(I+3) .NE. 0) Z(I+1) = Z(I+1) + Z(I+3) - 1
      I = I + 4
      J = J + 1
      GO TO 1051
 1052 NUD   = I - 4
      NBRUD = J - 1
      NWDUD = 4*NBRUD
      IZ = I
C
C     SORT UI AND UD LISTS ON SIL NO.
C     STORE INTERNAL POSITION IN UI AND UD LISTS.
C     WRITE ELEMENT ID, NO. OF UI-S, NO. OF UD-S.
C     WRITE SIL NOS. FOR UI LIST AND SIL NOS. FOR UD LIST.
C
      CALL SORTI (0,0,4,2,Z(IUI),NWDUI)
      BUF(2) = NBRUI
      BUF(3) = NBRUD
      CALL WRITE (GEI,BUF,3,0)
      K = 1
      DO 1061 I = IUI,NUI,4
      SILNO  = Z(I+1)
      Z(I+1) = K
      CALL WRITE (GEI,SILNO,1,0)
 1061 K = K + 1
      IF (NBRUD .EQ. 0) GO TO 1070
      CALL SORTI (0,0,4,2,Z(IUD),NWDUD)
      K = 1
      DO 1062 I = IUD,NUD,4
      SILNO  = Z(I+1)
      Z(I+1) = K
      CALL WRITE (GEI,SILNO,1,0)
 1062 K = K + 1
C
C     SORT UI LIST ON EXTERNAL POSITION.
C
 1070 CALL SORTI (0,0,4,1,Z(IUI),NWDUI)
C
C     DETERMINE IF CORE WILL HOLD THE FULL Z OR K MATRIX
C
      NCORE  = BUF2 - IZ
      NWDZ   = NBRUI**2
      NOCORE = 0
      IF (NWDZ .GT. NCORE) NOCORE = 1
C
C     READ INDICATOR OF INPUT OF Z OR K MATRIX
C
      CALL READ (*2002,*2003,ECT,IJK,1,0,FLAG)
      CALL WRITE (GEI,IJK,1,0)
      KOZ = 0
      IF (IJK .EQ. 2) KOZ = 1
C
C     READ THE ELEMENTS OF THE Z OR K MATRIX.
C     CONVERT FROM EXTERNAL ROW AND COL NOS. TO INTERNAL ROW AND COL
C     NOS.  IF CORE WILL HOLD Z OR K, STORE THE ELEMENTS IN CORE
C     OTHERWISE, WRITE CODED ROW/COL NOS AND ELEMENTS ON SCRATCH FILE.
C
      IF (NOCORE .NE. 0) CALL OPEN (*2001,SCR4,Z(BUF3),WRTREW)
      DO 1094 I = IUI,NUI,4
      INTROW = Z(I+1)
      KROW = IZ + (INTROW-1)*NBRUI - 1
      DO 1094 J = I,NUI,4
      INTCOL = Z(J+1)
      KCOL = IZ + (INTCOL-1)*NBRUI - 1
      CALL READ (*2002,*2003,ECT,BUF(3),1,0,FLAG)
      IF (NOCORE .NE. 0) GO TO 1092
      K    = KROW + INTCOL
      Z(K) = BUF(3)
      K    = KCOL + INTROW
      Z(K) = BUF(3)
      GO TO 1093
 1092 M = 3
      BUF(1) = INTCOL
      BUF(2) = INTROW
      IF (INTROW .EQ. INTCOL) GO TO 1095
      BUF(4) = INTROW
      BUF(5) = INTCOL
      BUF(6) =BUF(3)
      M = 6
 1095 CALL WRITE (SCR4,BUF,M,0)
 1093 CONTINUE
 1094 CONTINUE
      IF (NOCORE .NE. 0) CALL CLOSE (SCR4,CLSREW)
C
C     IF Z OR K MATRIX IS IN CORE,WRITE IT OUT
C     OTHERWISE,SORT THE MATRIX AND THEN WRITE IT.
C
      IF (NOCORE .EQ. 0) GO TO  1103
      CALL OPEN (*2001,SCR4,Z(BUF3),RDREW)
      NFILE(1) = SCR1
      NFILE(2) = SCR2
      NFILE(3) = SCR3
      CALL SORTI (SCR4,0,3,2,Z(IZ),NCORE-SYSBUF)
      CALL CLOSE (SCR4,CLSREW)
      IF (NFILE(6) .EQ. NFILE(1)) NFILE(1) = SCR4
      IF (NFILE(6) .EQ. NFILE(2)) NFILE(2) = SCR4
      IF (NFILE(6) .EQ. NFILE(3)) NFILE(3) = SCR4
      JFILE = NFILE(6)
      CALL OPEN (*2001, JFILE, Z(BUF3), RDREW)
      CALL SORTI (JFILE, 0, 3, -1, Z(IZ), NCORE-SYSBUF)
      CALL CLOSE (JFILE, CLSREW)
      CALL OPEN  (*2001,NFILE(6),Z(BUF3),RDREW)
 1101 CALL READ  (*2002,*1102,NFILE(6),BUF,3,0,FLAG)
      CALL WRITE (GEI,BUF(3),1,0)
      GO TO 1101
 1102 CALL CLOSE (NFILE(6),CLSREW)
      GO TO 1110
 1103 CALL WRITE (GEI,Z(IZ),NWDZ,0)
C
C     READ FLAG WORD FOR S MATRIX.
C     IF S MATRIX NOT PRESENT, BUT UD IS PRESENT,
C     EXECUTE TA1CA TO COMPUTE AND WRITE S MATRIX.
C     IF S MATRIX AND UD BOTH NOT PRESENT, CLOSE GEI RECORD AND LOOP
C     BACK
C
 1110 CALL READ (*2002,*2003,ECT,BUF,1,0,FLAG)
      IF (BUF(1) .NE. 0) GO TO 1120
      IF (NBRUD  .EQ. 0) GO TO 1111
      CALL SORTI (0,0,4,2,Z(IUI),NWDUI)
      CALL TA1CA (KOZ)
 1111 CALL WRITE (GEI,0,0,1)
      GO TO 1031
C
C     S MATRIX IS PRESENT.
C     DETERMINE IF CORE WILL HOLD THE FULL S MATRIX
C
 1120 NWDS = NBRUD*NBRUI
      CALL SORTI (0,0,4,1,Z(IUD),NWDUD)
      NOCORE = 0
      IF (NWDS .GT. NCORE) NOCORE = 1
C
C     READ THE ELEMENTS OF THE S MATRIX.
C     CONVERT FROM EXTERNAL ROW AND COL NOS TO INTERNAL ROW AND COL NOS.
C     IF CORE WILL HOLD S, STORE THE ELEMENTS IN CORE.
C     OTHERWISE, WRITE CODED ROW/COL NOS AND ELEMENTS ON SCRATCH FILE.
C
      IF (NOCORE .NE. 0) CALL OPEN (*2001,SCR4,Z(BUF3),WRTREW)
      DO 1133 I = IUI,NUI,4
      INTROW = Z(I+1)
      KROW   = IZ + (INTROW-1)*NBRUD - 1
      DO 1132 J = IUD,NUD,4
      INTCOL = Z(J+1)
      K = KROW + INTCOL
      CALL READ (*2002,*2003,ECT,BUF(3),1,0,FLAG)
      IF (NOCORE .NE. 0) GO TO 1131
      Z(K) = BUF(3)
      GO TO 1132
 1131 BUF(1) = INTROW
      BUF(2) = INTCOL
      CALL WRITE (SCR4,BUF,3,1)
 1132 CONTINUE
 1133 CONTINUE
      IF (NOCORE .NE. 0) CALL CLOSE (SCR4,CLSREW)
C
C     IF S MATRIX IS IN CORE, WRITE IT OUT.
C     OTHERWISE, SORT THE MATRIX AND THEN WRITE IT.
C
      IF (NOCORE .EQ. 0) GO TO 1142
      CALL OPEN (*2001,SCR4,Z(BUF3),RDREW)
      NFILE(1) = SCR1
      NFILE(2) = SCR2
      NFILE(3) = SCR3
      CALL SORTI (SCR4,0,3,2,Z(IZ),NCORE-SYSBUF)
      CALL CLOSE (SCR4,CLSREW)
      IF (NFILE(6) .EQ. NFILE(1)) NFILE(1) = SCR4
      IF (NFILE(6) .EQ. NFILE(2)) NFILE(2) = SCR4
      IF (NFILE(6) .EQ. NFILE(3)) NFILE(3) = SCR4
      JFILE = NFILE(6)
      CALL OPEN (*2001, JFILE, Z(BUF3), RDREW)
      CALL SORTI (JFILE, 0, 3, -1, Z(IZ), NCORE-SYSBUF)
      CALL CLOSE (JFILE, CLSREW)
      CALL OPEN  (*2001,NFILE(6),Z(BUF3),RDREW)
 1141 CALL READ  (*2002,*1143,NFILE(6),BUF,3,0,FILE)
      CALL WRITE (GEI,BUF(3),1,0)
      GO TO 1141
 1142 CALL WRITE (GEI,Z(IZ),NWDS,0)
 1143 CALL WRITE (GEI,0,0,1)
      GO TO 1031
C
C     HERE WHEN NO MORE GENERAL ELEMENTS
C
 1150 CALL CLOSE (ECT,CLSREW)
      CALL CLOSE (GEI,CLSREW)
      BUF(1) = GEI
      BUF(2) = NOGENL
      CALL WRTTRL (BUF)
      IF (NOGO .NE. 0) CALL MESAGE (-61,0,NAM)
      RETURN
C
C     FATAL ERRORS
C
 2001 N = -1
      GO TO 2005
 2002 N = -2
      GO TO 2005
 2003 N = -3
 2005 CALL MESAGE (N,FILE,NAM)
 2006 CALL MESAGE (-30,63,BUF)
      RETURN
      END

      SUBROUTINE PARTN1
C
C     THIS IS THE DMAP MODULE PARTN WHICH PARTITIONS A MATRIX -A- INTO
C     FOUR PARTITIONS, SOME OR ALL OF WHICH MAY BE PURGED.
C
C
C                             **                  **
C                             *       I            *
C                             *  A11  I    A12     *
C          **   **            *       I            *
C          *     *            * ------+----------- *
C          *  A  *  BECOMES   *       I            *
C          *     *            *       I            *
C          **   **            *  A21  I    A22     *
C                             *       I            *
C                             **                  **
C
C
C     BASED ON ROW PARTITION MATRIX -RP- AND COLUMN PARTITION MATRIX
C     -CP-
C
C     DMAP SEQUENCE.
C
C     PARTN A,CP,RP/A11,A21,A12,A22/V,Y,SYM/V,Y,TYPE/V,Y,F11/V,Y,F21/
C                                   V,Y,F12/V,Y,F22 $
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        RSHIFT,ANDF
      LOGICAL         CPHERE,RPHERE,CPNULL,RPNULL
      DIMENSION       MCB(7,4),BLOCK(80),SUBR(2),AIJ(4),BUFFS(5),
     1                HEAD(2),MCBA(7),REFUS(3)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25,SWM*27
      COMMON /XMSSG / UFM,UWM,UIM,SFM,SWM
      COMMON /MAHCIN/ MACHX
      COMMON /ZNTPKX/ ELEM(4),ROW,EOL
      COMMON /NAMES / RD,RDREW,WRT,WRTREW,CLSREW,CLS
      COMMON /SYSTEM/ SYSBUF,OUTPT,XXX(37),NBPW
      COMMON /PRTMRG/ CPSIZE,RPSIZE,CPONES,RPONES,CPNULL,RPNULL,CPHERE,
     1                RPHERE,ICP,NCP,IRP,NRP
      COMMON /ZZZZZZ/ Z(1)
      COMMON /BLANK / SYM,TYPE,FORM(4),CPCOL,RPCOL,IREQCL
      DATA    SUBR  / 4HPART,4HN1    /, A,CP,RP /101,102,103/,
     1        AIJ   / 201,202,203,204/
      DATA    NAFORM/ 4HFORM /, NATYPE/ 4HTYPE /, REFUS/2*3H   ,3HREF /
      DATA    EOR   / 1      /
C
      CORE = KORSZ(Z)
      BUFFS(1) = CORE - SYSBUF - 2
      DO 10 I = 2,5
      BUFFS(I) = BUFFS(I-1) - SYSBUF - 2
   10 CONTINUE
      CORE = BUFFS(5) - 1
      IF (CORE .LT. 10) CALL MESAGE (-8,0,SUBR)
C
C     OPEN MATRIX TO BE PARTITIONED.  IF PURGED RETURN IS MADE
C
      BUFF = BUFFS(5)
      CALL OPEN (*425,A,Z(BUFF),RDREW)
      CALL SKPREC (A,1)
      MCBA(1) = A
      CALL RDTRL (MCBA)
      INFORM = MCBA(4)
C
C     CALL TO PARTN2 WILL PROCESS -CP- AND -RP- INTO BIT STRINGS AND
C     DETERMINE SIZES OF THE PARTITIONS.
C
      BUFF = BUFFS(4)
      CALL PARTN2 (CP,RP,CORE,Z(BUFF))
C
C     IF RPSIZE OR CPSIZE ARE 0 THEY ARE SET EQUAL TO THE RESPECTIVE
C     SIZE OF A
C
      IF (CPSIZE .EQ. 0) CPSIZE = MCBA(2)
      IF (RPSIZE .EQ. 0) RPSIZE = MCBA(3)
C
C     MATRIX COMPATIBILITY CHECKS
C
      IF (RPSIZE.EQ.MCBA(3) .AND. CPSIZE.EQ.MCBA(2)) GO TO 40
      WRITE  (OUTPT,30) SWM,MCBA(3),MCBA(2),RPSIZE,CPSIZE
   30 FORMAT (A27,' 2166, MATRIX TO BE PARTITIONED IS OF SIZE',I10,
     1       ' ROWS BY',I10,' COLUMNS.', /5X,'ROW PARTITION SIZE IS',
     2       I10,' COLUMN PARTITION SIZE IS',I10,' (INCOMPATIBLE).')
C
C     PREPARE OUTPUT DATA BLOCKS AS REQUIRED.
C
   40 CPZERO = MCBA(2) - CPONES
      RPZERO = MCBA(3) - RPONES
C
C     CHECK OF TYPE PARAMETER
C
      NTYPE = MCBA(5)
      IF (NTYPE .EQ. TYPE) GO TO 60
      IF (TYPE  .EQ.    0) GO TO 54
      IF (TYPE.LT.0 .OR. TYPE.GT.4) GO TO 52
      WRITE  (OUTPT,50) SWM,NATYPE,TYPE,REFUS(1),SUBR,NTYPE
   50 FORMAT (A27,' 2163, REQUESTED VALUE OF ',A4,I10,2X,A3,
     1        'USED BY ',2A4,'. LOGICAL CHOICE IS',I10)
      NTYPE = TYPE
      GO TO 60
   52 WRITE (OUTPT,50) SWM,NATYPE,TYPE,REFUS(3),SUBR,NTYPE
   54 TYPE = NTYPE
C
   60 DO 140 I = 1,4
      FILE = AIJ(I)
      MCB(1,I) = 0
      COLS = CPZERO
      ROWS = RPZERO
      IF (I.EQ.3 .OR. I.EQ.4) COLS = CPONES
      IF (I.EQ.2 .OR. I.EQ.4) ROWS = RPONES
C
C     IF ROWS OR COLS EQUAL ZERO NOTHING IS WRITTEN ON THIS PARTITION
C
      IF (ROWS.EQ.0 .OR. COLS.EQ.0) GO TO 140
      BUFF = BUFFS(I)
      CALL OPEN (*140,FILE,Z(BUFF),WRTREW)
      CALL FNAME (FILE,HEAD)
      CALL WRITE (FILE,HEAD,2,EOR)
C
C     CHECK OF THE FORM PARAMETER
C
      NFORM = FORM(I)
      IF (NFORM.LT.1 .OR. NFORM.GT.8) GO TO 110
      GO TO (70,130,100,70,70,70,100,70), NFORM
C
C     FORM IMPLIES SQUARE
C
   70 IF (ROWS .EQ. COLS) GO TO 130
   80 WRITE  (OUTPT,90) SWM,HEAD,NFORM,ROWS,COLS
   90 FORMAT (A27,' 2168, THE FORM PARAMETER AS GIVEN TO THE PARTITION',
     1        'ING MODULE FOR SUB-PARTITION ',2A4, /5X,'IS INCONSISTANT'
     2,       ' WITH ITS SIZE.  FORM =',I9,' SIZE =',I9,' ROWS BY',I9,
     3        ' COLUMNS.')
      GO TO 130
C
C     DIAGONAL OR ROW MATRIX
C
  100 IF (COLS .EQ. 1) GO TO 130
      GO TO 80
C
C     NO FORM SPECIFIED THUS IT IS SQUARE IF ROWS = COLS OR RECTANGULAR
C     OTHERWISE.
C
  110 NFORM = 2
      IF (ROWS .EQ. COLS) NFORM = 1
      IF (SYM.LT.0 .AND. INFORM.EQ.6 .AND. NFORM.EQ.1 .AND.
     1   (I.EQ.1 .OR. I.EQ.4)) NFORM = 6
      IF (FORM(I) .EQ. 0) GO TO 128
      JJ = 1
      IF (FORM(I).LT.1 .OR. FORM(I).GT.8) JJ = 3
      WRITE (OUTPT,50) SWM,NAFORM,FORM(I),REFUS(JJ),SUBR,NFORM
      IF (JJ .NE. 3) NFORM = FORM(I)
  128 FORM(I) = NFORM
C
C     TRAILER INITIALIZATION.  BLDPKN WILL SET MCB(2) AND MCB(6) LATER.
C
  130 CALL MAKMCB (MCB(1,I),FILE,ROWS,NFORM,NTYPE)
  140 CONTINUE
C
C     ROW PARTITIONING BIT STRING IS AT THIS POINT CONVERTED TO A CORE
C     VECTOR ONE WORD PER BIT.  EACH WORD CONTAINS THE ROW NUMBER OF THE
C     PARTITION TO WHICH THE ELEMENT OF -A- IS TO BE MOVED TO.  IF THE
C     NUMBER IS NEGATIVE THE ELEMENT IS MOVED TO THE LOWER PARTITIONS
C     AND IF THE NUMBER IS POSITIVE THE ELEMENT IS MOVED TO THE UPPER
C     PARTITION
C
      IZ = NRP + 1
      NZ = IZ  + RPSIZE - 1
      IF (NZ+NBPW .GT. CORE) CALL MESAGE (-8,0,SUBR)
      IF (.NOT.RPNULL .AND. RPONES.NE.0) GO TO 160
      K  = 0
      DO 150 I = IZ,NZ
      K  = K + 1
      Z(I) = K
  150 CONTINUE
      GO TO 210
  160 JZ   = IZ - 1
      ZERO = 0
      ONES = 0
C
C     NOTE THIS LOGIC WORKS ON CRAY WITH 48 OF 64 BIT INTEGER WORD
C
      DO 200 I = IRP,NRP
      DO 190 J = 1,NBPW
      SHIFT = NBPW - J
      BIT   = RSHIFT(Z(I),SHIFT)
      JZ    = JZ + 1
      IF (ANDF(BIT,1)) 180,170,180
  170 ZERO  = ZERO + 1
      Z(JZ) = ZERO
      GO TO 190
  180 ONES  = ONES - 1
      Z(JZ) = ONES
  190 CONTINUE
  200 CONTINUE
C
C     LOOP ON ALL THE COLUMNS OF -A-.
C
  210 IZM1  = IZ - 1
      DO 400 I = 1,CPSIZE
      IF (CPNULL) GO TO 220
      IL1   = I - 1
      BITWD = IL1/NBPW + ICP
      SHIFT = NBPW - MOD(IL1,NBPW) - 1
      BIT   = RSHIFT(Z(BITWD),SHIFT)
      IF (ANDF(BIT,1)) 230,220,230
C
C     ZERO-S COLUMN (LEFT PARTITIONS A11 AND A21)
C
  220 IFILE  = 1
      IBLOCK = 1
      GO TO 240
C
C     ONE-S COLUMN (RIGHT PARTITIONS A12 AND A22)
C
  230 IFILE  = 3
      IBLOCK = 41
      GO TO 240
C
C     START COLUMNS OF THE 2 AIJ PARTITIONS.
C
  240 KFILE  = IFILE
      KBLOCK = IBLOCK
      M = 0
      DO 270 J = 1,2
      IF (MCB(1,KFILE)) 260,260,250
  250 CALL BLDPK (NTYPE,MCB(5,KFILE),MCB(1,KFILE),BLOCK(KBLOCK),1)
      M = 1
  260 KFILE  = KFILE + 1
      KBLOCK = KBLOCK + 20
  270 CONTINUE
      IF (M) 280,390,280
C
C     START THE I-TH COLUMN OF THE MATRIX BEING PARTITIONED -A-.
C
  280 CALL INTPK (*350,A,0,NTYPE,0)
C
C     LOOP ON NON-ZEROS OF THE COLUMN
C
  290 IF (EOL) 300,300,350
C
C     PICK UP A NON-ZERO ELEMENT
C
  300 CALL ZNTPKI
C
C     DETERMINE ROW POSITION AND FILE DESTINATION.
C
      L = IZM1 + ROW
      IF (Z(L)) 320,310,310
C
C     ZERO-S ROW PARTITION.
C
  310 JROW   = Z(L)
      KFILE  = IFILE
      KBLOCK = IBLOCK
      GO TO 330
C
C     ONE-S ROW PARTITION.
C
  320 JROW   = -Z(L)
      KFILE  = IFILE  + 1
      KBLOCK = IBLOCK + 20
C
C     OUTPUT THE ELEMENT.
C
  330 IF (MCB(1,KFILE)) 290,290,340
  340 CALL BLDPKI (ELEM,JROW,MCB(1,KFILE),BLOCK(KBLOCK))
      GO TO 290
C
C     COMPLETE COLUMNS OF THE 2 AIJ PARTITIONS BEING WORKED ON.
C
  350 KFILE  = IFILE
      KBLOCK = IBLOCK
      DO 380 J = 1,2
      IF (MCB(1,KFILE)) 370,370,360
  360 CALL BLDPKN (MCB(1,KFILE),BLOCK(KBLOCK),MCB(1,KFILE))
  370 KFILE  = KFILE  + 1
      KBLOCK = KBLOCK + 20
  380 CONTINUE
      GO TO 400
C
C     COLUMN NOT BEING OUTPUT TO ANY PARTITIONS AT ALL THUS SKIP IT.
C
  390 CALL SKPREC (A,1)
C
  400 CONTINUE
C
C     WRAP UP.
C
      CALL CLOSE (A,CLSREW)
      DO 420 I = 1,4
      IF (MCB(1,I)) 420,420,410
  410 CALL WRTTRL (MCB(1,I))
      CALL CLOSE (MCB(1,I),CLSREW)
  420 CONTINUE
  425 RETURN
      END

      SUBROUTINE RCOVC
C
C     RCOVC COMPUTES REACTION FORCES AND GENERATES OUTPUT DATA BLOCKS
C     FOR DISPLACEMENTS, APPLIED LOADS, AND REACTION FORCES.
C
      LOGICAL         INCORE     ,UFLAG      ,PFLAG      ,NON0       ,
     1                QFLAG      ,END        ,ONCE       ,COMPLX     ,
     2                SUPRES     ,KEEP
      INTEGER         DRY        ,STEP       ,FSS        ,RFNO       ,
     1                UINMS      ,UA         ,RSS        ,SYSBUF     ,
     2                UTYPO      ,SOF2       ,SOF3       ,BUF1       ,
     3                BUF2       ,CASESS     ,SOF1       ,OUGV1      ,
     4                OPG1       ,OQG1       ,SCR1       ,EQSS       ,
     5                SOLN       ,ENERGY     ,PVEC       ,UVEC       ,
     6                NAME(2)    ,CASECC(2)  ,SRD        ,PG         ,
     7                SUBSTR(4)  ,IZ(2)      ,RC         ,FILE       ,
     8                QA         ,PA         ,NAMEF(2)   ,IDBUF(146) ,
     9                DISP(3)    ,OLOAD(3)   ,SPCF(3)    ,DOFS(32)   ,
     O                BUF3       ,NFWD(3)    ,COMPS(3)   ,BUF(1)     ,
     1                ACCE(3)    ,VELO(3)    ,BUF4       ,SCR2       ,
     2                SCR6       ,SCR7       ,SCR8       ,SCR3
      DIMENSION       MCBA(7)    ,RBUF(1)    ,RDBUF(7)   ,DATA(12)
      CHARACTER       UFM*23     ,UWM*25     ,UIM*29     ,SFM*25     ,
     1                SWM*27
      COMMON /XMSSG / UFM        ,UWM        ,UIM        ,SFM        ,
     1                SWM
      COMMON /BLANK / DRY        ,LOOP       ,STEP       ,FSS(2)     ,
     1                RFNO       ,NEIGV      ,LUI        ,UINMS(2,5) ,
     2                NOSORT     ,UTHRES     ,PTHRES     ,QTHRES
      COMMON /RCOVCR/ ICORE      ,LCORE      ,BUF1       ,BUF2       ,
     1                BUF3       ,BUF4       ,SOF1       ,SOF2       ,
     2                SOF3
      COMMON /RCOVCM/ MRECVR     ,UA         ,PA         ,QA         ,
     1                IOPT       ,RSS(2)     ,ENERGY     ,UIMPRO     ,
     2                RANGE(2)   ,IREQ       ,LREQ       ,LBASIC
      COMMON /SYSTEM/ SYSBUF     ,NOUT
      COMMON /NAMES / RD         ,RDREW      ,WRT        ,WRTREW     ,
     1                REW        ,NOREW
      COMMON /UNPAKX/ UTYPO      ,IRU        ,NRU        ,INCU
      COMMON /CONDAS/ PHI        ,TWOPHI     ,RADDEG
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE     (BUF(1)    ,Z(1))
      EQUIVALENCE     (Z(1)      ,IZ(1)),    (BUF(1)     ,RBUF(1))   ,
     1                (IDBUF(1)  ,RDBUF(1))
      DATA    CASESS, OUGV1      ,OPG1       ,OQG1       ,SCR1       ,
     1        PG    , SCR3       ,SCR6       ,SCR7       ,SCR8       ,
     2        SCR2  /
     3        101   , 201        ,202        ,203        ,301        ,
     4        105   , 303        ,306        ,307        ,308        ,
     5        302   /
      DATA    SRD   / 1          /
      DATA    EQSS  , SOLN       ,UVEC       ,PVEC       /
     1        4HEQSS, 4HSOLN     ,4HUVEC     ,4HPVEC     /
      DATA    NAME               ,CASECC                 ,SUBSTR     /
     2        4HRCOV, 4HC        ,4HCASE     ,4HCC       ,4HSUBS     ,
     3        4HTRUC, 4HTURE     ,4H         /
      DATA    COMPS /
     1        4HCOMP, 4HONEN     ,4HT        /
C
C     INITIALIZE
C
      IF (DRY .LT. 0) RETURN
      SOF1 = KORSZ(Z) - LREQ - SYSBUF + 1
      SOF2 = SOF1 - SYSBUF - 1
      SOF3 = SOF2 - SYSBUF
      BUF1 = SOF3 - SYSBUF
      BUF2 = BUF1 - SYSBUF
      BUF3 = BUF2 - SYSBUF
      BUF4 = BUF3 - SYSBUF
      LCORE= BUF4 - 1
      IF (LCORE .LE. 0) GO TO 6313
      CALL SOFOPN (Z(SOF1),Z(SOF2),Z(SOF3))
C
C     ================================================
C     THIS CARD SHOULD BE ADDED WHEN SDR3 IS FIXED
C
C     IF (RFNO .EQ. 9) NOSORT = 1
C
C     ================================================
      PA = 0
      QA = 0
      UFLAG = .FALSE.
      PFLAG = .FALSE.
      QFLAG = .FALSE.
C
C     CHECK OUTPUT REQUESTS ON CASESS
C
      CALL GOPEN (CASESS,Z(BUF1),RDREW)
      NCCREC = 1
      FILE   = CASESS
  110 CALL FREAD (CASESS,Z,2,1)
      NCCREC = NCCREC + 1
      IF (IZ(1).NE.CASECC(1) .OR. IZ(2).NE.CASECC(2)) GO TO 110
  120 CALL READ (*130,*9003,CASESS,IDBUF,35,1,I)
      IF (IDBUF(17) .NE. 0) PFLAG = .TRUE.
      IF (IDBUF(20) .NE. 0) UFLAG = .TRUE.
      IF (IDBUF(29).NE.0 .AND. RFNO.GE.8) UFLAG = .TRUE.
      IF (IDBUF(32).NE.0 .AND. RFNO.GE.8) UFLAG = .TRUE.
      IF (IDBUF(35) .NE. 0) QFLAG = .TRUE.
      IF (PFLAG .AND. UFLAG .AND. QFLAG) GO TO 130
      GO TO 120
  130 CALL CLOSE (CASESS,REW)
C
      IF (BUF(IREQ  ) .EQ. 1) UFLAG = .TRUE.
      IF (BUF(IREQ+1) .EQ. 1) PFLAG = .TRUE.
      IF (BUF(IREQ+2) .EQ. 1) QFLAG = .TRUE.
      IF (ENERGY .EQ. 0) GO TO 135
      UFLAG = .TRUE.
      IF (RFNO.GE.3 .AND. RFNO.LE.8) PFLAG = .TRUE.
      IF (RFNO.GE.3 .AND. RFNO.LE.8) QFLAG = .TRUE.
  135 CONTINUE
C
      IF (.NOT.(UFLAG .OR. PFLAG .OR. QFLAG)) GO TO 900
C
C     COMPUTE THE APPLIED STATIC LOADS FOR THE REQUESTED SUBSTRUCTURE
C     IF WE ARE PRINTING THE SOLUTION SUBSTRUCTURE CHECK IF THE LOADS
C     ARE ON A GINO FILE.
C
      IF (RFNO .EQ. 3) PFLAG = .FALSE.
      IF (.NOT.PFLAG .AND. (.NOT.QFLAG .OR. RFNO .EQ. 3)) GO TO 150
      IF (RSS(1).NE.FSS(1) .OR. RSS(2).NE.FSS(2)) GO TO 140
      PA = PG
      MCBA(1) = PG
      CALL RDTRL (MCBA)
      IF (MCBA(1) .GT. 0) GO TO 150
  140 PA = SCR3
      CALL RCOVSL (RSS,PVEC,0,SCR6,SCR7,SCR8,PA,Z(1),Z(1),SOF3-1,
     1            .FALSE.,RFNO)
      IF (PA .LE. 0) PFLAG = .FALSE.
C
C     GET THE DISPLACEMENT VECTOR AND IF RIGID FORMAT 8 THEN
C     CALCULATE THE VELOCITIES AND ACCELERATIONS.
C
  150 IF (.NOT.UFLAG .AND. .NOT.QFLAG) GO TO 170
      MCBA(1) = UA
      CALL RDTRL (MCBA)
      IF (MCBA(1) .GT. 0) GO TO 160
      UA = SCR2
      CALL MTRXI (UA,RSS,UVEC,0,RC)
      IF (RC .EQ. 1) GO TO 160
  155 UA = 0
      WRITE (NOUT,63190) SWM,RSS
      UFLAG = .FALSE.
      QFLAG = .FALSE.
      ENERGY = 0
C
  160 IF (RFNO.NE.8 .OR. .NOT.(UFLAG.OR.QFLAG)) GO TO 170
      CALL RCOVVA (UA,0,SCR1,0,0,0,RSS,Z(1),Z(1),Z(1))
      IF (UA .LE. 0) GO TO 155
      UA = SCR1
C
C     COMPUTE THE SPCF REACTIONS IF OUTPUT REQUESTS WERE SPECIFIED
C
  170 IF (QFLAG) CALL RCOVQV
      IF (QA .LE. 0) QFLAG = .FALSE.
C
C     OUTPUT PROCESSING
C
C
C     IF IOPT IS EQUAL TO ONE THEN THE OUTPUT WILL BE SORTED BY SUBCASE
C     IF EQUAL TO TWO IT WILL BE SORTED BY SUBSTRUCTURE
C
      NP = BUF(IREQ+3)
      NS = BUF(IREQ+4)
C
C     FIND THE LENGTH AND TYPE OF THE VECTORS TO BE OUTPUT
C
      CALL SOFTRL (RSS,UVEC,MCBA)
      NMODES = MCBA(2)
      NSTEPS = MCBA(2)
      IF (RFNO .EQ. 9) NSTEPS = NSTEPS/3
      COMPLX = .FALSE.
      IF (MCBA(5) .GE. 3) COMPLX = .TRUE.
      NWORD = 1
      IF (COMPLX) NWORD = 2
C
C     PERFORM GENERAL INITIALIZATION OF OFP ID RECORD
C
      IDBUF( 3) = 0
      IDBUF( 6) = 0
      IDBUF( 7) = 0
      IDBUF( 8) = 0
      IDBUF(10) = 8
      IF (COMPLX) IDBUF(10) = 14
      DO 370 I = 11,50
  370 IDBUF(I) = 0
C
C     INITALIZE THE UNPACK COMMON BLOCK
C
      UTYPO = 1
      IF (COMPLX) UTYPO = 3
      IRU   = 1
      NRU   = MCBA(3)
      INCU  = 1
C
C     ALLOCATE OPEN CORE
C
      ISETS = 1
      LSETS = 100
      IVECT = ISETS + LSETS
      ISIL  = IVECT + (NRU*NWORD)
      IEQSS = ISIL  + NP
      IF (IEQSS+2 .GT. LCORE) GO TO 6313
C
C
C                          OPEN CORE DIAGRAM FOR /RCOVCX/
C
C                       +----------------------------------+
C          Z(ISETS)     I                                  I
C                       I     CASECC SET INFORMATION       I
C                       I                                  I
C                       +----------------------------------+
C          Z(IVECT)     I                                  I
C                       I     VECTOR TO BE PRINTED         I
C                       I                                  I
C                       +----------------------------------+
C          Z(ISIL )     I                                  I
C                       I     SCALAR INDEX LIST FROM EQSS  I
C                       I                                  I
C                       +----------------------------------+
C          Z(IEQSS)     I                                  I
C                       I     EQSS DATA IN TRIPLES OF      I
C                       I        (1) EXTERNAL GRID ID      I
C                       I        (2) INTERNAL POINT INDEX  I
C                       I        (3) COMPONENT CODE        I
C                       I     DATA FOR EACH BASIC SUB-     I
C                       I     STRUCTURE TERMINATED BY      I
C                       I     THREE (-1)S                  I
C                       I                                  I
C                       I     NOTE  EQSS DATA MAY NOT BE   I
C                       I     IN CORE IF SPILL LOGIC       I
C                       I     INVOKED.                     I
C                       I                                  I
C                       +----------------------------------+
C          Z(ISEQ)      I                                  I
C                       I     SYMMETRY SEQUENCE            I
C                       I                                  I
C                       +----------------------------------+
C          Z(ICOMB)     I                                  I
C                       I     VECTOR CONTRIBUTING TO THE   I
C                       I     LINEAR COMBINATION FOR THE   I
C                       I     SYMMETRY SEQUENCE            I
C                       I                                  I
C                       +----------------------------------+
C
C     READ SIL FROM EQSS INTO OPEN CORE AT ISIL
C
      CALL SFETCH (RSS,EQSS,SRD,RC)
      N = NS + 1
      CALL SJUMP (N)
      DO 470 I = 1,NP
      CALL SUREAD (Z(ISIL+I-1),1,NWDS,RC)
  470 CALL SUREAD (J,1,NWDS,RC)
C
C     READ EQSS DATA INTO OPEN CORE AT IEQSS IF IT WILL FIT.  IF IOPT
C     EQUALS 2, READ ONLY ONE GROUP AND PRCESS ONE BASIC SUBSTRUCTURE
C     A TIME.
C
      INCORE = .FALSE.
      NEQSS  = IEQSS + 2
      CALL SFETCH (RSS,EQSS,SRD,RC)
      N = 1
      CALL SJUMP (N)
      NSS = NS
      IF (IOPT .EQ. 2) NSS = 1
      ISS = 0
C
C     TOP OF LOOP OVER BASIC SUBSTRUCTURES WHEN PROCESSING ONE AT A TIME
C
  475 ISS = ISS + 1
      K   = LCORE - IEQSS + 1
      J   = IEQSS
      ITEM= EQSS
      DO 480 I = 1,NSS
      CALL SUREAD (Z(J),K,NWDS,RC)
      IF (RC .EQ. 3) GO TO 6107
      IF (RC .NE. 2) GO TO 490
      J = J + NWDS
      IF (J+3 .GT. LCORE) GO TO 490
      IZ(J  ) = -1
      IZ(J+1) = -1
      IZ(J+2) = -1
      J       = J + 3
      NEQSS   = J - 1
      K       = K - NWDS - 3
      IF (K .LE. 0) GO TO 490
  480 CONTINUE
      INCORE  = .TRUE.
      GO TO 491
C
C     EQSS WILL NOT FIT IN CORE
C
  490 NEQSS = IEQSS + 2
  491 ISEQ  = NEQSS + 1
C
C     WRITE HEADER RECORDS ON OUTPUT DATA BLOCKS AND POSITION BOTH
C     INPUT AND OUTPUT DATA BLOCKS AFTER THE HEADER RECORD
C
      DO 497 I = 1,3
      GO TO (495,492,493), I
C
C     CHECK DISPLACEMENT VECTOR
C
  495 IF (.NOT.UFLAG) GO TO 497
      IN   = UA
      IOUT = OUGV1
      GO TO 494
C
C     CHECK LOAD VECTOR
C
  492 IF (.NOT.PFLAG) GO TO 497
      IN   = PA
      IOUT = OPG1
      GO TO 494
C
C     CHECK READTIONS VECTOR
C
  493 IF (.NOT.QFLAG) GO TO 497
      IN   = QA
      IOUT = OQG1
C
C     POSITION FILES
C
  494 CALL GOPEN (IN,Z(BUF1),RDREW)
      CALL CLOSE (IN,NOREW)
      IF (ISS .GT. 1) GO TO 497
      CALL OPEN (*496,IOUT,Z(BUF2),WRTREW)
      CALL FNAME (IOUT,NAMEF)
      CALL WRITE (IOUT,NAMEF,2,1)
      CALL CLOSE (IOUT,NOREW)
      GO TO 497
C
C     OUTPUT FILE PURGED - TURN OFF REQUEST FLAG
C
  496 WRITE (NOUT,63140) SWM,IOUT
      IF (IOUT .EQ. OUGV1) UFLAG = .FALSE.
      IF (IOUT .EQ. OPG1 ) PFLAG = .FALSE.
      IF (IOUT .EQ. OQG1 ) QFLAG = .FALSE.
  497 CONTINUE
C
C     SETUP FOR LOOP OVER SUBCASES
C
      ISC = 0
      DO 510 I = 1,3
  510 NFWD(I) = 0
C
C     POSITION CASESS TO FIRST CASECC SUBCASE
C
      FILE = CASESS
      CALL OPEN (*9001,CASESS,Z(BUF3),RDREW)
      DO 530 I = 1,NCCREC
  530 CALL FWDREC (*9002,CASESS)
      END = .FALSE.
C
C     TOP OF LOOP OVER SUBCASES
C
  540 ISC   = ISC + 1
      ITYPE = 1
      IF (END) GO TO 596
C
C     READ OUTPUT REQUESTS FROM CASECC RECORD
C
      CALL READ  (*545,*9003,CASESS,0,-3,0,NWDS)
      CALL FREAD (CASESS,LID  ,1  ,0)
      CALL FREAD (CASESS,0    ,-12,0)
      CALL FREAD (CASESS,OLOAD,3  ,0)
      CALL FREAD (CASESS,DISP ,3  ,0)
      CALL FREAD (CASESS,0    ,-6 ,0)
      CALL FREAD (CASESS,ACCE ,3  ,0)
      CALL FREAD (CASESS,VELO ,3  ,0)
      CALL FREAD (CASESS,SPCF ,3  ,0)
      CALL FREAD (CASESS,0    ,-1 ,0)
C
C     SET OUTPUT TYPE AND MEDIA - IF NO REQUEST IN CASE CONTROL
C     THE DEFAULT VALUES ARE REAL AND PRINTER
C
      IFORM = 1
      IF (COMPLX)  IFORM = 2
      IF (DISP(2)  .EQ. 0) DISP(2) = 1
      IF (DISP(3)  .EQ. 0) DISP(3) = IFORM
      IF (DISP(3)  .LT. 0) NOSORT  = 1
      IF (OLOAD(2) .EQ. 0) OLOAD(2)= 1
      IF (OLOAD(3) .EQ. 0) OLOAD(3)= IFORM
      IF (OLOAD(3) .LT. 0) NOSORT  = 1
      IF (SPCF(2)  .EQ. 0) SPCF(2) = 1
      IF (SPCF(3)  .EQ. 0) SPCF(3) = IFORM
      IF (SPCF(3)  .LT. 0) NOSORT  = 1
      IF (VELO(2)  .EQ. 0) VELO(2) = 1
      IF (VELO(3)  .EQ. 0) VELO(3) = IFORM
      IF (VELO(3)  .LT. 0) NOSORT  = 1
      IF (ACCE(2)  .EQ. 0) ACCE(2) = 1
      IF (ACCE(3)  .EQ. 0) ACCE(3) = IFORM
      IF (ACCE(3)  .LT. 0) NOSORT  = 1
      GO TO 548
C
C     END OF CASE CONTROL RECORDS - CHECK IF THIS IS REALLY THE END
C
  545 END = .TRUE.
      IF (RFNO .LE. 2) GO TO 860
      IF (RFNO.EQ.3 .AND. ISC.GT.NMODES) GO TO 860
      IF (RFNO.GE.8 .AND. ISC.GT.NSTEPS) GO TO 860
      GO TO 596
C
C     READ TITLE, SUBTITLE, AND LABEL.  WILL REPLACE RIGHTMOST WORDS OF
C     SUBTITLE WITH BASIC SUBSTRUCTURE NAME
C
  548 CALL FREAD (CASESS,IDBUF(51),96,0)
      DO 550 I = 1,3
      IDBUF(I+101) = SUBSTR(I)
  550 IDBUF(I+133) = COMPS(I)
      IDBUF(  105) = SUBSTR(4)
      IDBUF(  106) = RSS(1)
      IDBUF(  107) = RSS(2)
C
C     READ SYMMETRY SEQUENCE AND SET INFORMATION
C
      NWDS =-1
      IZ(ISETS  ) = 0
      IZ(ISETS+1) = 0
      CALL FREAD (CASESS,0,-31,0)
      CALL FREAD (CASESS,LCC,1,0)
      LSKIP = 167 - LCC
      CALL FREAD (CASESS,0,LSKIP,0)
      CALL READ (*9002,*590,CASESS,LSEQ,1,0,N)
      IF (NEQSS+LSEQ .GT. LCORE) GO TO 6313
      IF (LSEQ .GT. 0)CALL READ (*9002,*590,CASESS,Z(ISEQ),LSEQ,0,N)
      ICOMB = ISEQ + LSEQ
      IF (ICOMB+NRU .GT. LCORE) GO TO 6313
      CALL READ (*9002,*590,CASESS,Z(ISETS),LSETS,0,NWDS)
      K = LSETS
C
C     MUST EXPAND SETS PORTION OF OPEN CORE
C
  560 N = LCORE - NEQSS
      IF (N .GT. 0) GO TO 570
      IF (.NOT. INCORE) GO TO 6313
      INCORE = .FALSE.
      NEQSS  = IEQSS + 2
      GO TO 560
  570 DO 575 I = ISIL,NEQSS
  575 IZ(LCORE-I+1) = IZ(NEQSS-I+1)
      IVECT = IVECT + N
      ISIL  = ISIL  + N
      IEQSS = IEQSS + N
      NEQSS = NEQSS + N
      CALL READ (*9002,*580,CASESS,Z(ISETS+LSETS),N,0,NWDS)
      K     = K + N
      GO TO 560
  580 NWDS  = K + NWDS
  590 NSETS = ISETS + NWDS
C
C     PROCESS OUTPUT ITYPE
C
  596 ONCE  = .FALSE.
      JEQSS = IEQSS - 3
      ISKIP = 0
      IF (ITYPE.EQ.1 .AND. .NOT.UFLAG) GO TO 855
      IF (ITYPE.EQ.2 .AND. .NOT.PFLAG) GO TO 855
      IF (ITYPE.EQ.3 .AND. .NOT.QFLAG) GO TO 855
      IF (ITYPE.EQ.4 .AND. .NOT.UFLAG) GO TO 855
      IF (ITYPE.EQ.5 .AND. .NOT.UFLAG) GO TO 855
C
C     FOR EACH BASIC SUBSTRUCTURE CURRENTLY BEING PROCESSED, CONSTRUCT
C     ONE OFP ID AND DATA RECORD PAIR.  THE BASIC LOOP IS ABOVE THE
C     VECTOR PROCESSING BECAUSE OUTPUT REQUESTS CAN CHANGE FOR EACH
C     BASIC
C
      DO 840 JS = 1,NSS
      JSS  = ISS  + JS - 1
      NREQ = IREQ + (JSS-1)*LBASIC + 5
      KPOINT = BUF(NREQ+12)
C
C     STATICS
C
      IF (RFNO .GT. 2) GO TO 603
      IF (JS   .GT. 1) GO TO 598
      IAPPRO   = 1
      IDBUF(4) = ISC
      IDBUF(5) = LID
      GO TO 598
C
C     FOR NORMAL MODES GET MODE NUMBER, EIGENVALUE AND FREQUENCY
C
  603 IF (RFNO .NE. 3) GO TO 612
      IF (JS   .GT. 1) GO TO 598
      CALL SFETCH (FSS,SOLN,SRD,RC)
      N = 1
      CALL SJUMP (N)
      J = ISC - 1
      IF (J .EQ. 0) GO TO 611
      DO 597 I = 1,J
  597 CALL SUREAD (MCBA(1),7,NWDS,RC)
  611 CONTINUE
      CALL SUREAD (MODE,1,NWDS,RC)
      CALL SUREAD (I,1,NWDS,RC)
      CALL SUREAD (EIGEN ,1,NWDS,RC)
      CALL SUREAD (EIGENI,1,NWDS,RC)
      CALL SUREAD (VALUE,1,NWDS,RC)
C
      IAPPRO = 2
      IF (COMPLX) IAPPRO = 9
      IDBUF(4) = ISC
      IDBUF(5) = MODE
      RDBUF(6) = EIGEN
      RDBUF(7) = 0.0
      IF (COMPLX) RDBUF(7) = EIGENI
      GO TO 598
C
C     FOR DYNAMICS GET THE TIME OR FREQUENCY
C
  612 IF (RFNO.NE.8 .AND. RFNO.NE.9) GO TO 598
      IF (JS .GT. 1) GO TO 598
      CALL SFETCH (FSS,SOLN,SRD,RC)
      N = 1
      CALL SJUMP (N)
      J = ISC - 1
      IF (J .EQ. 0) GO TO 614
      DO 613 I = 1,J
  613 CALL SUREAD (MCBA(1),1,NWDS,RC)
  614 CONTINUE
      CALL SUREAD (VALUE,1,NWDS,RC)
C
      IAPPRO = 5
      IF (RFNO .EQ. 9) IAPPRO = 6
      IDBUF(4) = ISC
      RDBUF(5) = VALUE
      IDBUF(8) = LID
C
C     GET SUBCASE OR MODE REQUEST
C
  598 IF (RFNO .GT. 2) GO TO 599
      ISUB = ISC
      ILOC = 5
      GO TO 600
  599 IF (RFNO .NE. 3) GO TO 607
      ISUB = MODE
      ILOC = 6
      GO TO 600
  607 ISUB = ISC
      ILOC = 11
  600 ISET = BUF(NREQ+ILOC)
      IF (ISET .LT. 0) GO TO 608
      IF (ISET .EQ. 0) GO TO 835
C
C     FIND THE REQUESTED SET
C
      JSET = ISETS
  601 CONTINUE
      IF (ISET .EQ. IZ(JSET)) GO TO 602
      JSET = JSET + IZ(JSET+1) + 2
      IF (JSET .LT. NSETS) GO TO 601
C
C     SET NOT FOUND, ISSUE WARNING AND PRINT ALL INSTEAD.
C
      WRITE (NOUT,63650) UWM,ISET
      BUF(NREQ+ILOC) = -1
      GO TO 608
C
C     FIND IF CURRENT SUBCASE OR MODE IS IN REQUESTED SET
C
  602 NEXT = 1
      KSET = IZ(JSET+1)
      CALL SETFND (*835,IZ(JSET+2),KSET,ISUB,NEXT)
C
C     SO FAR SO GOOD - IF NORMAL MODES OR DYNAMICS PROBLEM CHECK IF
C     EIGEN VALUE, TIME OR FREQUENCY IS IN REQUESTED RANGE
C
  608 CONTINUE
      IF (RFNO .LT. 3) GO TO 609
      IF (VALUE .LT. RBUF(NREQ+7)) GO TO 835
      IF (VALUE .GT. RBUF(NREQ+8)) GO TO 835
C
  609 GO TO (615,640,650,652,654), ITYPE
C
C     PROCESS DISPLACEMENT REQUESTS
C
  615 IOPST = DISP(1)
      IF (BUF(NREQ+2) .GT. -2) IOPST = BUF(NREQ+2)
      IF (IOPST.EQ.0 .AND. LSEQ.EQ.0) GO TO 835
      IF (ONCE) GO TO 705
      ONCE  = .TRUE.
C
      IDC   = DISP(2)
      IFORM = IABS(DISP(3))
      IDBUF(2) = 1
      IF (RFNO .EQ. 3) IDBUF(2) = 7
      THRESH = UTHRES
      SUPRES = .FALSE.
      IN   = UA
      IOUT = OUGV1
      GO TO 660
C
C     PROCESS OLOAD REQUESTS
C
  640 IOPST = OLOAD(1)
      IF (BUF(NREQ+3) .GT. -2) IOPST = BUF(NREQ+3)
      IF (IOPST.EQ.0 .AND. LSEQ.EQ.0) GO TO 835
      IF (ONCE) GO TO 705
      ONCE = .TRUE.
C
      IDC    = OLOAD(2)
      IFORM  = IABS(OLOAD(3))
      THRESH = PTHRES
      SUPRES = .TRUE.
      IDBUF(2) = 2
      IN   = PA
      IOUT = OPG1
      GO TO 660
C
C     PROCESS SPCFORCE (ACTUALLY, ALL REACTIONS) REQUESTS
C
  650 IOPST = SPCF(1)
      IF (BUF(NREQ+4) .GT. -2 ) IOPST = BUF(NREQ+4)
      IF (IOPST.EQ.0 .AND. LSEQ.EQ.0) GO TO 835
      IF (ONCE) GO TO 705
      ONCE = .TRUE.
C
      IDC    = SPCF(2)
      IFORM  = IABS(SPCF(3))
      THRESH = QTHRES
      SUPRES = .TRUE.
      IDBUF(2) = 3
      IN   = QA
      IOUT = OQG1
      GO TO 660
C
C     PROCESS VELOCITY REQUESTS
C
  652 IOPST = VELO(1)
      IF (BUF(NREQ+9) .GT. -2) IOPST = BUF(NREQ+9)
      IF (IOPST.EQ.0 .AND. LSEQ.EQ.0) GO TO 835
      IF (ONCE) GO TO 705
      ONCE = .TRUE.
C
      IDC   = VELO(2)
      IFORM = IABS(VELO(3))
      IDBUF(2) = 10
      THRESH = UTHRES
      SUPRES = .FALSE.
      IN   = UA
      IOUT = OUGV1
      GO TO 660
C
C     PROCESS ACCELERATION REQUESTS
C
  654 IOPST = ACCE(1)
      IF (BUF(NREQ+10) .GT. -2) IOPST = BUF(NREQ+10)
      IF (IOPST.EQ.0 .AND. LSEQ.EQ.0) GO TO 835
      IF (ONCE) GO TO 705
      ONCE = .TRUE.
C
      IDC   = ACCE(2)
      IFORM = IABS(ACCE(3))
      IDBUF(2) = 11
      THRESH = UTHRES
      SUPRES = .FALSE.
      IN   = UA
      IOUT = OUGV1
C
C     OPEN FILES AND UNPACK VECTOR TO BE PRINTED
C
  660 FILE = IN
      CALL GOPEN (IN,Z(BUF1),RD)
      CALL GOPEN (IOUT,Z(BUF2),WRT)
      IT  = ITYPE
      IF (ITYPE .GT. 3) IT = 1
      IF (LSEQ .GT. 0) GO TO 664
      N   = NFWD(IT)
      IF (N .LE. 0) GO TO 663
      DO 662 I = 1,N
  662 CALL FWDREC (*9002,IN)
      NFWD(IT) = 0
  663 CALL UNPACK (*673,IN,Z(IVECT))
      GO TO 675
C
C     FORM LINEAR COMBINATION FOR SYMMETRY SEQUENCE
C
  664 N = NFWD(IT) - LSEQ
      IF (N) 665,669,667
  665 N = -N
      DO 666 I = 1,N
  666 CALL BCKREC(IN)
      GO TO 669
  667 DO 668 I = 1,N
  668 CALL FWDREC (*9002,IN)
  669 DO 670 I = 1,NRU
  670 Z(IVECT+I-1) = 0.0E0
      DO 672 I = 1,LSEQ
      CALL UNPACK (*672,IN,Z(ICOMB))
      DO 671 J = 1,NRU
  671 Z(IVECT+J-1) = Z(IVECT+J-1) + Z(ISEQ+I-1)*Z(ICOMB+J-1)
  672 CONTINUE
      NFWD(IT) = 0
      GO TO 675
  673 N = NRU*NWORD
      DO 674 I = 1,N
  674 Z(IVECT+I-1) = 0.0
C
C     IF EQSS DATA NOT IN CORE, POSITION THE SOF
C
  675 IF (INCORE) GO TO 705
      CALL SFETCH (RSS,EQSS,SRD,RC)
      NSKIP = ISS + ISKIP
      CALL SJUMP (NSKIP)
      JEQSS = IEQSS
C
C     INSERT SUBSTRUCTURE NAME IN IDREC WRITE IT OUT
C
  705 IDBUF(1) = IDC + 10*IAPPRO
      IF (COMPLX .AND. JS.EQ.1) IDBUF(2) = IDBUF(2) + 1000
      IDBUF(  9) = IFORM
      IDBUF(138) = BUF(NREQ)
      IDBUF(139) = BUF(NREQ+1)
      KEEP = .FALSE.
C
C     FIND THE REQUESTED OUTPUT SET
C
      NEXT  = 1
      JSET  = ISETS
      NJSET = JSET + 1
      IF (IOPST .LT. 0) GO TO 730
  710 IF (IOPST .EQ. IZ(JSET)) GO TO 730
      JSET  = JSET + IZ(JSET+1) + 2
      IF (JSET .LT. NSETS) GO TO 710
C
C     SET NOT FOUND. ISSUE A WARNING AND PRINT ALL INSTEAD
C
      WRITE (NOUT,63650) UWM,IOPST
      I = ITYPE + 1
      IF (ITYPE .GT. 3) I = I + 4
      BUF(NREQ+I) = -1
      IOPST = -1
C
C     FOR EACH GRID POINT ID IN EQSS FOR THE CURRENT SUBSTRUCTURE WHICH
C     IS A MEMBER OF THE REQUESTED OUTPUT SET, WRITE A LINE OF OUTPUT
C
  730 IF (INCORE) GO TO 780
      CALL SUREAD (Z(JEQSS),3,NWDS,RC)
      IF (RC .NE. 1) GO TO 830
      GO TO 790
  780 JEQSS = JEQSS + 3
      IF (IZ(JEQSS) .GT. 0) GO TO 790
      GO TO 830
C
  790 IF (IOPST .LT. 0) GO TO 800
      IF (NEXT .GT. IZ(JSET+1)) GO TO 830
      KSET = IZ(JSET+1)
      KID  = IZ(JEQSS )
      CALL SETFND (*730,IZ(JSET+2),KSET,KID,NEXT)
C
C     WRITE A LINE OF OUTPUT
C
  800 ICODE = IZ(JEQSS+2)
      CALL DECODE (ICODE,DOFS(1),N)
      DOFS(N+1) = -1
      JSIL = IZ(JEQSS+1) + ISIL - 1
      K    = 0
      NON0 = .FALSE.
      DO 820 I = 1,6
      IF (DOFS(K+1)+1 .NE. I) GO TO 815
      J = IVECT + (IZ(JSIL)-1)*NWORD + K*NWORD
      K = K + 1
      DATA(I) = Z(J)
      IF (COMPLX) GO TO 805
      IF (SUPRES .AND. DATA(I).EQ.0.0) GO TO 815
      IF (ABS(DATA(I)) .LT. THRESH) GO TO 815
      NON0 = .TRUE.
      GO TO 820
  805 DATA(6+I) = Z(J+1)
      IF (IFORM.NE.3 .OR. DATA(I)+DATA(6+I).EQ.0.0) GO TO 810
      DATA(I)   = SQRT(Z(J)**2 + Z(J+1)**2)
      DATA(6+I) = ATAN2(Z(J+1),Z(J))*RADDEG
      IF (DATA(6+I) .LT. -.000005) DATA(6+I) = DATA(6+I) + 360.0
  810 IF (SUPRES .AND. DATA(I)+DATA(6+I).EQ.0.0) GO TO 815
      IF (ABS(DATA(I)).LT.THRESH .AND. ABS(DATA(6+I)).LT.THRESH)
     1    GO TO 815
      NON0 = .TRUE.
      GO TO 820
  815 DATA(  I) = 0.0
      DATA(6+I) = 0.0
  820 CONTINUE
      IF (.NOT.NON0) GO TO 825
      IF (.NOT. KEEP) CALL WRITE (IOUT,IDBUF,146,1)
      CALL WRITE (IOUT,10*IZ(JEQSS)+IDC,1,0)
      CALL WRITE (IOUT,KPOINT,1,0)
      CALL WRITE (IOUT,DATA,6*NWORD,0)
      KEEP = .TRUE.
  825 CONTINUE
      IF (NEXT.LE.IZ(JSET+1) .OR. IOPST.LT.0) GO TO 730
C
C     IF NO DATA WAS WRITTEN FOR THIS BASIC BACKREC THE OFP FILE
C     OVER THE PREVIOUSLY WRITTEN ID RECORD
C
830   IF (KEEP) CALL WRITE (IOUT,0,0,1)
      IF (IZ(JEQSS).LT.0 .OR. (.NOT.INCORE .AND. RC.NE.1)) GO TO 840
C
C     NO MORE OUTPUT FOR THIS BASIC - SKIP EQSS DATA
C
  835 CONTINUE
      IF (INCORE) GO TO 836
      IF (ONCE  ) GO TO 837
      ISKIP = ISKIP + 1
      GO TO 840
  837 N = 1
      CALL SJUMP (N)
      GO TO 840
  836 JEQSS = JEQSS + 3
      IF (IZ(JEQSS) .GT. 0) GO TO 836
  840 CONTINUE
C
C     GO BACK AND DO ANOTHER OUTPUT TYPE
C
      CALL CLOSE (IN,NOREW)
      CALL CLOSE (IOUT,NOREW)
  855 IF (ONCE) GO TO 856
      IT = ITYPE
      IF (ITYPE .GT. 3) IT = 1
      NFWD(IT) = NFWD(IT) + 1
  856 ITYPE = ITYPE + 1
      IF (ITYPE .LE. 3) GO TO 596
      IF (ITYPE.LE.5 .AND. RFNO.GE.8) GO TO 596
      IF (.NOT.END) GO TO 540
      IF (RFNO.EQ.3 .AND. ISC.LT.NMODES) GO TO 540
      IF (RFNO.GE.8 .AND. ISC.LT.NSTEPS) GO TO 540
C
C     ALL SUBCASES PROCESSED,  IF IOPT EQ 2, GO BACK AND PROCESS
C     NEXT BASIC SUBSTRUCTURE
C
  860 CALL CLOSE (CASESS,REW)
      IF (IOPT.EQ.1 .OR. ISS.EQ.NS) GO TO 870
      CALL SFETCH (RSS,EQSS,SRD,RC)
      N = ISS + 1
      CALL SJUMP (N)
      GO TO 475
C
C     WRITE TRAILERS AND EOF ON OUTPUT DATA BLOCKS
C
  870 DO 880 I = 2,7
  880 MCBA(I) = 1
      IF (.NOT.UFLAG) GO TO 885
      CALL GOPEN (OUGV1,Z(BUF1),WRT)
      CALL CLOSE (OUGV1,REW)
      MCBA(1) = OUGV1
      CALL WRTTRL (MCBA)
  885 IF (.NOT.PFLAG) GO TO 890
      CALL GOPEN (OPG1,Z(BUF1),WRT)
      CALL CLOSE (OPG1,REW)
      MCBA(1) = OPG1
      CALL WRTTRL (MCBA)
  890 IF (.NOT.QFLAG) GO TO 900
      CALL GOPEN (OQG1,Z(BUF1),WRT)
      CALL CLOSE (OQG1,REW)
      MCBA(1) = OQG1
      CALL WRTTRL (MCBA)
C
C     NORMAL MODULE TERMINATION
C
  900 CALL SOFCLS
      RETURN
C
C     ERROR PROCESSING
C
 6107 N = 7
      CALL SMSG (N,ITEM,RSS)
      GO TO 9200
 6313 WRITE (NOUT,63130) SWM,RSS
      GO TO 9200
 9001 N = 1
      GO TO 9100
 9002 N = 2
      GO TO 9100
 9003 N = 3
      GO TO 9100
 9100 CALL MESAGE (N,FILE,NAME)
 9200 CALL SOFCLS
      DO 9201 I = 101,111
 9201 CALL CLOSE (I,REW)
      DO 9202 I = 201,203
 9202 CALL CLOSE (I,REW)
      DO 9203 I = 301,308
 9203 CALL CLOSE(I,REW)
      RETURN
C
C     DIAGNOSTICS FORMAT STATEMENTS
C
63130 FORMAT (A27,' 6313, INSUFFICIENT CORE FOR RCOVR MODULE WHILE ',
     1       'TRYING TO PROCESS', /34X,'PRINTOUT DATA BLOCKS FOR ',
     2       'SUBSTRUCTURE',2A4)
63140 FORMAT (A27,' 6314, OUTPUT REQUEST CANNOT BE HONORED.', /34X,
     1       'RCOVR MODULE OUTPUT DATA BLOCK',I4,' IS PURGED.')
63190 FORMAT (A27,' 6319, DISPLACEMENT MATRIX FOR SUBSTRUCTURE ',2A4,
     1       ' MISSING.' /5X,'DISPLACEMENT OUTPUT REQUESTS CANNOT BE ',
     2       'HONORED.  SPCFORCE OUTPUT REQUESTS CANNOT BE HONORED UN',
     3       'LESS THE', /5X,'REACTIONS HAVE BEEN PREVIOUSLY COMPUTED.')
63650 FORMAT (A25,' 6365, REQUESTED OUTPUT SET ID',I6,' IS NOT DECLARED'
     1,      ' IN CASE CONTROL, ALL OUTPUT WILL BE PRODUCED.')
      END

      SUBROUTINE IFP1PC (I81,ICONT,POCARD,ORG,PORG)
C
C     SUBROUTINE TO PERFORM FIRST-LEVEL CHECKING OF STRUCTURE PLOTTER
C     CONTROL CARD FORMAT.
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        RSHIFT,COMPLF
      LOGICAL         FLAG(3),BIT64
      INTEGER         CASE(400),CTYPE(21),IDVPR(3),CAMERA(5),ORIGIN(11),
     1                AXES(3),MAXES(3),CNTUR(20),SETPR(33),SETP2(12),
     2                COORD(25),LBLPR(5),PLTPR(28),NAST(2),POCARD(1),
     3                CORE(1),COREY(401)
      CHARACTER       UFM*23,UWM*25
      COMMON /XMSSG / UFM,UWM
      COMMON /SYSTEM/ ISYS,NOUT,NOGO,SKP(16),PLTOPT,SYS21,ILINK,
     1                SKP63(63),INTRA
      COMMON /XIFP1 / BLANK,BIT64
      COMMON /ZZZZZZ/ COREX(1)
      EQUIVALENCE     (PROJ,CTYPE(11)), (DEFO,IDVPR( 1)),
     1                (SYMM,PLTPR(13)), (ANTI,PLTPR(14)),
     2                (MAGN,CNTUR(13)), (THRU,PLTPR(22)),
     3                (POIN,LBLPR( 2)), (CORE(1),COREY(401)),
     4                (COREX(1),COREY(1),CASE(1)), (HIDD,PLTPR(24))
      DATA    CTYPE / 4HPLOT, 4HORTH, 4HPERS, 4HSTER, 4HAXES, 4HVIEW,
     1                4HMAXI, 4HCSCA, 4HFIND, 4HCONT, 4HPROJ, 4HOCUL,
     2                4HCAME, 4HPAPE, 4HPEN , 4HPTIT, 4HSCAL, 4HORIG,
     3                4HVANT, 4HSET , 4HREGI/
      DATA    CAMERA/ 4HFILM, 4HPAPE, 4HBOTH, 4HBLAN, 4HFRAM/
      DATA    AXES  / 4HX   , 4HY   , 4HZ   /
      DATA    MAXES / 4HMX  , 4HMY  , 4HMZ  /
      DATA    CNTUR / 4HMAJP, 4HMINP, 4HMAXS, 4HXNOR, 4HYNOR, 4HZNOR,
     1                4HXYSH, 4HXZSH, 4HYZSH, 4HXDIS, 4HYDIS, 4HZDIS,
     2                4HMAGN, 4HNRM1, 4HNRM2, 4HSH12, 4HSH1Z, 4HSH2Z,
     3                4HBDSH, 4HSTRA/
      DATA    SETPR / 4HINCL, 4HEXCL, 4HEXCE, 4HELEM, 4HGRID, 4HALL ,
     1                4HAERO, 4HAXIF, 4HBAR , 4HCONE, 4HCONR, 4HHEXA,
     2                4HFLUI, 4HIHEX, 4HPLOT, 4HQDME, 4HQDPL, 4HQUAD,
     3                4HROD , 4HSHEA, 4HSLOT, 4HTETR, 4HTORD, 4HTRAP,
     4                4HTRBS, 4HTRIA, 4HTRME, 4HTRPL, 4HTUBE, 4HTWIS,
     5                4HVISC, 4HWEDG, 4HHBDY/
      DATA    SETP2 / 4HAX  , 4HRG  , 4H1   , 4H2   , 4H3   , 4H4   ,
     1                4HD2  , 4HD3  , 4HD4  , 4HM   , 4HM1  , 4HM2  /
      DATA    PLTPR / 4HSET , 4HSTAT, 4HMODA, 4HCMOD, 4HFREQ, 4HTRAN,
     1                4HCONT, 4HRANG, 4HTIME, 4HPHAS, 4HMAGN, 4HORIG,
     2                4HSYMM, 4HANTI, 4HPEN , 4HDENS, 4HSYMB, 4HLABE,
     3                4HSHAP, 4HVECT, 4HOUTL, 4HTHRU, 4HMAXI, 4HHIDD,
     4                4HSHRI, 4HNOFI, 4HFILL, 4HOFFS/
      DATA    IDVPR / 4HDEFO, 4HVELO, 4HACCE/
      DATA    COORD / 4HYX  , 4HZX  , 4HZY  , 4HXY  , 4HXZ  , 4HYZ  ,
     1                4HX   , 4HY   , 4HZ   ,
     2                4HXYZ , 4HRXY , 4HRXZ , 4HRYZ , 4HR   , 4HRN  ,
     3                4HXN  , 4HYN  , 4HZN  , 4HXYN , 4HXZN , 4HYZN ,
     4                4HXYZN, 4HRXYN, 4HRXZN, 4HRYZN  /
      DATA    LBLPR / 4HGRID, 4HPOIN, 4HELEM, 4HBOTH, 4HEPID/
      DATA    TER   / 4HTER /, PLAN / 4HPLAN/, SEPA / 4HSEPA/
      DATA    LAG   / 4HLAG /, NAST / 4HSC  , 4HCALC/,ILNK  / 4HNS01/
C
C
C     INITIALIZE
C
      IF (INTRA.LE.1 .AND. ILINK.EQ.ILNK) GO TO 15
      DO 5 I = 1,200
    5 CORE(I)= POCARD(I)
   15 ALLON  = COMPLF(0)
      EOR    = RSHIFT(ALLON,1)
      ISPLOT = 0
      IWRD   = I81
C
C     BRANCH FOR CONTINUATION CARD
C                                  SET   PLOT  FIND
      IF (ICONT .NE. 0) GO TO (10, 2111, 2210, 1067), ICONT
C
      IF (CORE(IWRD)) 9800,350,20
   10 IF (CORE(IWRD) .LE.   0) GO TO 320
   20 IF (CORE(IWRD) .EQ. EOR) GO TO 350
      MODE = CORE(IWRD)
      IWRD = IWRD + 1
C
C     BRANCH FOR CARD TYPE
C
  100 IWORD = CORE(IWRD)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWORD,0)
      DO 300 I = 1,20
      IF (IWORD .EQ. CTYPE(I))
     1   GO TO (400,  500,  500,  500,  600,  700,  800,  900, 1000,
     2         1100, 1200, 1300, 1400,  320,  320,  320, 1800, 1900,
     3         2000, 2100), I
C
C    1         PLOT  ORTH  PERS  STER  AXES  VIEW  MAXI  CSCA  FIND
C    2         CONT  PROJ  OCUL  CAME  PAPE   PEN  PTIT  SCAL  ORIG
C    3         VANT   SET
C
  300 CONTINUE
      GO TO 9802
  320 IF (MODE .LE. 0) GO TO 330
      IWRD = IWRD + 2
      MODE = MODE - 1
      GO TO 320
  330 IF (CORE(IWRD)) 335,340,340
  335 IF (CORE(IWRD) .EQ. -4) IWRD = IWRD + 1
      IWRD = IWRD + 2
      GO TO 330
  340 IF (CORE(IWRD).EQ.0 .OR. CORE(IWRD).EQ.EOR) GO TO 350
      MODE = CORE(IWRD)
      IWRD = IWRD + 1
      GO TO 320
  350 ICONT = 0
      IF (CORE(IWRD) .EQ. 0) ICONT = 1
      GO TO 9998
C
C     BRANCH TO PLOT OR PLOTTER
C
  400 IWORD = CORE(IWRD+1)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWORD,0)
      IF (IWORD .EQ. TER) GO TO 410
      ISPLOT = 1
      GO TO 2200
C
C     PLOTTER CARD
C
  410 IWORD = CORE(IWRD+2)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWORD,0)
      IF (IWORD.EQ.NAST(1) .OR. IWORD.EQ.NAST(2)) GO TO 9804
      GO TO 320
C
C     PROJECTION CARD
C
  500 IWRD  = IWRD + 2
      MODE  = MODE - 1
      IWORD = CORE(IWRD)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWORD,0)
      IF (IWORD .EQ. PROJ) GO TO 510
      ASSIGN 510 TO IRTN
      IPRM = PROJ
      GO TO 9806
  510 IWRD = IWRD + 2
      MODE = MODE - 1
      IF (MODE) 330,330,100
C
C     AXES CARD
C
  600 IWRD = IWRD + 2
      MODE = MODE - 1
      IWORD = CORE(IWRD)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWORD,0)
      IF (CORE(IWRD).EQ.ALLON .OR. IWORD.EQ.BLANK) GO TO 600
      DO 605 J = 1,3
  605 FLAG(J) = .FALSE.
      I = 0
      GO TO 607
  606 IWORD = CORE(IWRD)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWORD,0)
  607 IF (CORE(IWRD).EQ.ALLON .OR. IWORD.EQ.BLANK) GO TO 610
      DO 608 J = 1,3
      IF (IWORD.EQ.AXES(J) .OR. IWORD.EQ.MAXES(J)) FLAG(J) = .TRUE.
  608 CONTINUE
      I = I + 1
  610 IWRD = IWRD + 2
      MODE = MODE - 1
      IF (I .LT. 3) GO TO 606
C
      ASSIGN 320 TO IRTN
      IF (.NOT.FLAG(1) .OR. .NOT.FLAG(2) .OR. .NOT.FLAG(3)) GO TO 9810
  620 IWORD = CORE(IWRD)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWORD,0)
      IF (IWORD.EQ.SYMM .OR. IWORD.EQ.ANTI) GO TO 630
      IF (CORE(IWRD).EQ.0 .OR. CORE(IWRD).EQ.EOR) GO TO 350
      IF (CORE(IWRD).NE.ALLON .AND. IWORD.NE.BLANK) GO TO 100
      IWRD = IWRD + 2
      MODE = MODE - 1
      IF (MODE) 9812,9812,620
  630 IWRD = IWRD + 2
      MODE = MODE - 1
      IF (MODE) 330,330,100
C
C     VIEW COMMAND
C
  700 NREAL = 3
      NOPT  = 0
      GO TO 1310
C
C     MAXIMUM DEFORMATION CARD
C
  800 NREAL = 1
      NOPT  = 0
      IWORD = CORE(IWRD+2)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWORD,0)
      IF (IWORD .EQ. DEFO) GO TO 1310
      ASSIGN 320 TO IRTN
      IPRM = CORE(IWRD+2)
      GO TO 9808
C
C     CSCALE CARD
C
  900 ASSIGN 320 TO IRTN
  910 IWRD = IWRD + 2
      MODE = MODE - 1
      IF (MODE) 930,930,920
  920 IWORD = CORE(IWRD)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWORD,0)
      IF (CORE(IWRD).EQ.ALLON .OR. IWORD.EQ.BLANK) GO TO 910
      GO TO 9812
  930 IF (CORE(IWRD)+1) 960,940,9816
  940 WRITE  (NOUT,950)
  950 FORMAT (/5X,'REAL VALUE, NOT INTEGER, IS NOW USED FOR CSCALE')
      GO TO 9816
C
  960 NREAL = 1
      NOPT  = 0
      GO TO 1700
C
C     FIND COMMAND
C
 1000 IWRD = IWRD + 2
      MODE = MODE - 1
 1005 IF (CORE(IWRD).EQ.0 .OR. CORE(IWRD).EQ.EOR) GO TO 1080
      ASSIGN 1070 TO IRTN
      IF (MODE) 9812,9812,1006
 1006 IWORD = CORE(IWRD)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWORD,0)
      IF (CORE(IWRD).EQ.ALLON .OR. IWORD.EQ.BLANK) GO TO 1000
      DO 1008 I = 17,21
      ITYPE = I - 16
      IF (IWORD .EQ. CTYPE(I))
     1    GO TO (1020, 1030, 1040, 1030, 1050), ITYPE
C                SCAL  ORIG  VANT   SET  REGI
C
 1008 CONTINUE
      IPRM = CORE(IWRD)
      GO TO 9808
C
 1020 NREAL = 1
 1021 IWRD  = IWRD + 2
      MODE  = MODE - 1
      IF (MODE .LE. 0) GO TO 1061
      IWORD = CORE(IWRD)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWORD,0)
      IF (CORE(IWRD).EQ.ALLON .OR. IWORD.EQ.BLANK) GO TO 1021
      GO TO 1005
C
 1030 IPRM = CORE(IWRD)
      ASSIGN 1005 TO IRTN
 1031 IWRD = IWRD + 2
      MODE = MODE - 1
      IF (MODE) 1033,1033,1032
 1032 IWORD = CORE(IWRD)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWORD,0)
      IF (CORE(IWRD).EQ.ALLON .OR. IWORD.EQ.BLANK) GO TO 1031
      GO TO 9814
 1033 INTEG = 1
      IF (CORE(IWRD) .EQ. EOR) GO TO 9814
      IF (CORE(IWRD) .EQ.  -1) INTEG = 0
      IF (CORE(IWRD) .EQ.  -4) IWRD  = IWRD + 1
      IF (ITYPE .NE. 2) GO TO 1034
      FORG = CORE(IWRD+1)
      ORG  = ORG + 1
      ORIGIN(ORG) = FORG
 1034 IWRD = IWRD + 2
      IF (PORG .GE. 0) GO TO 1066
      PORG  = 0
      PORG1 = FORG
      GO TO 1066
C
 1040 IWRD = IWRD + 2
      MODE = MODE - 1
      ASSIGN 1070 TO IRTN
      IF (MODE) 1041,1041,1042
 1041 IPRM = POIN
      GO TO 9806
 1042 IWORD = CORE(IWRD)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWORD,0)
      IF (IWORD .EQ. POIN) GO TO 1000
      IPRM = CORE(IWRD)
      GO TO 9808
C
 1050 NREAL = 4
 1060 IWRD  = IWRD + 2
      MODE  = MODE - 1
      IF (MODE .LE. 0) GO TO 1062
      IWORD = CORE(IWRD)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWORD,0)
      IF (CORE(IWRD).EQ.ALLON .OR. IWORD.EQ.BLANK) GO TO 1060
      GO TO 9818
 1061 IF (CORE(IWRD).EQ.0 .OR. CORE(IWRD).EQ.EOR) GO TO 1080
 1062 INTEG = 0
      ASSIGN 1005 TO IRTN
      DO 1065 I = 1,NREAL
      IF (CORE(IWRD) .EQ. -1) INTEG = 1
      IF (CORE(IWRD) .EQ. -4) IWRD  = IWRD + 1
      IWRD = IWRD + 2
 1065 CONTINUE
 1066 IF (INTEG) 1067,1067,9816
 1067 IF (CORE(IWRD).EQ.0 .OR. CORE(IWRD).EQ.EOR) GO TO 1080
      MODE = CORE(IWRD)
      IWRD = IWRD + 1
      GO TO 1005
C
 1070 IF (CORE(IWRD).EQ.0 .OR. CORE(IWRD).EQ.EOR) GO TO 1080
      IWRD = IWRD + 1
      GO TO 1070
 1080 ICONT = 0
      IF (CORE(IWRD) .EQ. 0) ICONT = 4
      GO TO 9998
C
C     CONTOUR
C
 1100 IWRD = IWRD + 2
      MODE = MODE - 1
      ASSIGN 320 TO IRTN
 1105 IF (CORE(IWRD).EQ.0 .OR. CORE(IWRD).EQ.EOR) GO TO 350
      IWORD = CORE(IWRD)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWORD,0)
      IF (CORE(IWRD).EQ.ALLON .OR. IWORD.EQ.BLANK) GO TO 1110
      DO 1108 I = 1,20
      IF (IWORD .EQ. CNTUR(I)) GO TO 320
 1108 CONTINUE
      IPRM = CORE(IWRD)
      GO TO 9808
 1110 IWRD = IWRD + 2
      MODE = MODE - 1
      IF (MODE) 9812,9812,1105
C
C     PROJECTION PLANE SEPARATION
C
 1200 IWRD = IWRD + 2
      MODE = MODE - 1
      ASSIGN 320 TO IRTN
      IF (MODE) 1210,1210,1220
 1210 IPRM = PLAN
      GO TO 9806
 1220 IWORD = CORE(IWRD)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWORD,0)
      IF (IWORD .NE. PLAN) GO TO 1231
      IWORD = CORE(IWRD+2)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWORD,0)
      IF (IWORD .EQ. SEPA) GO TO 1240
 1231 IPRM = CORE(IWRD)
      GO TO 9808
 1240 NREAL = 1
      NOPT  = 0
      GO TO 1310
C
C     OCULAR SEPARATION
C
 1300 NREAL = 1
      NOPT  = 0
      IWORD = CORE(IWRD+2)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWORD,0)
      IF (IWORD .EQ. SEPA) GO TO 1310
      ASSIGN 320 TO IRTN
      IPRM = CORE(IWRD+2)
      GO TO 9808
C
 1310 IWRD = IWRD + 2
      MODE = MODE - 1
      IF (MODE) 1700,1700,1310
C
C     CAMERA
C
 1400 IWRD = IWRD + 2
      MODE = MODE - 1
      IF (MODE .LE. 0) GO TO 1420
      IWORD = CORE(IWRD)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWORD,0)
      IF (CORE(IWRD).EQ.ALLON .OR. IWORD.EQ.BLANK ) GO TO 1400
      IF (CORE(IWRD).EQ.EOR   .OR. CORE(IWRD).EQ.0) GO TO 9820
      DO 1410 I = 1,4
      IF (IWORD .EQ. CAMERA(I)) GO TO 1415
 1410 CONTINUE
      IPRM = CORE(IWRD)
      ASSIGN 320 TO IRTN
      GO TO 9808
 1415 IWRD = IWRD + 2
      MODE = MODE - 1
      IF (MODE .LE. 0) GO TO 1420
      IWORD = CORE(IWRD)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWORD,0)
      IF (CORE(IWRD).EQ.ALLON .OR. IWORD.EQ.BLANK) GO TO 1415
      I = I + 1
      IF (IWORD.EQ.CAMERA(4) .OR. IWORD.EQ.CAMERA(5)) GO TO 1415
      ASSIGN 320 TO IRTN
      IF (I-4) 100,9812,100
 1420 IF (CORE(IWRD).EQ.EOR .OR. CORE(IWRD).EQ.0) IF (I-3) 350,350,9820
      ASSIGN 320 TO IRTN
      IF (CORE(IWRD)+1) 9816,1430,9816
 1430 IWRD = IWRD + 2
      GO TO 10
C
C     TEST FOR REAL VALUES
C
 1700 IRO = 0
      NRO = NREAL
 1710 INTEG = 0
      ASSIGN 320 TO IRTN
      DO 1720 I = 1,NRO
      IF (CORE(IWRD).GE.0 .OR. CORE(IWRD).LT.-4) IF (IRO) 9818,9818,1712
 1712 IF (CORE(IWRD) .EQ. -1) INTEG = 1
      IF (CORE(IWRD) .EQ. -4) IWRD  = IWRD + 1
      IWRD = IWRD + 2
 1720 CONTINUE
      IF (INTEG .EQ. 0) GO TO 1730
      ASSIGN 1730 TO IRTN
      GO TO 9816
 1730 IF (CORE(IWRD)) 1740,350,20
 1740 IF (IRO.EQ.1 .OR. NOPT.EQ.0) GO TO 9812
      IRO = 1
      NRO = NOPT
      GO TO 1710
C
C     SCALE
C
 1800 NREAL = 1
      NOPT  = 1
      GO TO 1310
C
C     ORIGIN
C
 1900 NREAL = 3
      NOPT  = 0
 1905 IWRD  = IWRD + 2
      MODE  = MODE - 1
      IF (MODE) 1907,1907,1906
 1906 IWORD = CORE(IWRD)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWORD,0)
      IF (CORE(IWRD).EQ.ALLON .OR. IWORD.EQ.BLANK) GO TO 1905
 1907 IF (CORE(IWRD) .EQ. -1) GO TO 1910
      IPRM = CTYPE(18)
      ASSIGN 320 TO IRTN
      GO TO 9814
 1910 IF (CORE(IWRD) .EQ. -4) IWRD = IWRD + 1
      IWRD = IWRD + 2
      ASSIGN 320 TO IRTN
      IF (CORE(IWRD) .EQ. EOR) GO TO 9818
      IF (CORE(IWRD) .LT. 0) GO TO 1700
      MODE  = CORE(IWRD)
      IWRD  = IWRD + 1
      IWORD = CORE(IWRD)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWORD,0)
      IF (CORE(IWRD).EQ.ALLON .OR. IWORD.EQ.BLANK) GO TO 1310
      GO TO 9812
C
C     VANTAGE POINT
C
 2000 NREAL = 3
      NOPT  = 1
      IWORD = CORE(IWRD+2)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWORD,0)
      IF (IWORD .EQ. POIN) GO TO 1310
      ASSIGN 320 TO IRTN
      IPRM = CORE(IWRD+2)
      GO TO 9808
C
C     SET DEFINITION CARD
C
 2100 NINT = 0
      NTHRU= 0
 2105 IWRD = IWRD + 2
      MODE = MODE - 1
      IF (MODE) 2106,2106,2108
 2106 IF (CORE(IWRD) .EQ. -1) GO TO 2110
      ASSIGN 2107 TO IRTN
      GO TO 9816
 2107 IF (CORE(IWRD) .EQ. -4) IWRD = IWRD + 1
      GO TO 2110
 2108 IWORD = CORE(IWRD)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWORD,0)
      IF (CORE(IWRD).EQ.ALLON .OR. IWORD.EQ.BLANK) GO TO 2105
      IPRM = CTYPE(20)
      ASSIGN 2120 TO IRTN
      GO TO 9814
C
 2110 IWRD  = IWRD + 2
      NREAL = 0
 2111 IF (CORE(IWRD)) 2112,2113,2114
 2112 NINT  = NINT + 1
      IF (CORE(IWRD).EQ.-1 .OR. NREAL.NE.0) GO TO 2110
      ASSIGN 2110 TO IRTN
      GO TO 9816
 2113 ICONT = 2
      NTHRU = 0
      GO TO 9998
 2114 IF (CORE(IWRD) .NE. EOR) GO TO 2115
      ICONT = 0
      GO TO 9998
 2115 MODE  = CORE(IWRD)
      IWRD  = IWRD + 1
 2120 IWORD = CORE(IWRD)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWORD,0)
      IF (CORE(IWRD).NE.ALLON .AND. IWORD.NE.BLANK) GO TO 2121
      IWRD  = IWRD + 2
      MODE  = MODE - 1
      IF (MODE) 2111,2111,2120
 2121 IWORD = CORE(IWRD)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWORD,0)
      IF (IWORD .NE. THRU) GO TO 2130
      NTHRU = NTHRU + 1
      IF (CORE(IWRD-3).EQ.-1 .AND. CORE(IWRD+2).EQ.-1) GO TO 2122
      ASSIGN 2123 TO IRTN
      NREAL = 1
      GO TO 9822
 2122 IF (NTHRU .EQ. 1) GO TO 2123
      IF (NINT.GE.2 .AND. CORE(IWRD-2).GT.CORE(IWRD-4)) GO TO 2123
      ASSIGN 2123 TO IRTN
      GO TO 9824
 2123 NINT = 0
      IWRD = IWRD + 2
      MODE = MODE - 1
      IF (MODE) 2111,2111,2130
 2130 IF (CORE(IWRD) .EQ.   0) GO TO 2113
      IF (CORE(IWRD) .EQ. EOR) GO TO 2114
      IWORD = CORE(IWRD)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWORD,0)
      IF (CORE(IWRD).EQ.ALLON .OR. IWORD.EQ.BLANK) GO TO 2135
      DO 2132 I = 1,33
      IF (IWORD .EQ. SETPR(I))
     1   GO TO (2135, 2135, 2135, 2135, 2138, 2135, 2135, 2142, 2135,
     2          2135, 2135, 2143, 2144, 2145, 2135, 2146, 2135, 2143,
     3          2135, 2135, 2147, 2135, 2135, 2148, 2135, 2149, 2135,
     4          2135, 2135, 2135, 2135, 2135, 2135), I
C
C    1          INCL  EXCL  EXCE  ELEM  GRID   ALL  AERO  AXIF   BAR
C    2          CONE  CONR  HEXA  FLUI  IHEX  PLOT  QDME  QDPL  QUAD
C    3           ROD  SHEA  SLOT  TETR  TORD  TRAP  TRBS  TRIA  TRME
C    4          TRPL  TUBE  TWIS VISCX  WEDG  HBDY
C
 2132 CONTINUE
      ASSIGN 2135 TO IRTN
      IPRM = CORE(IWRD)
      GO TO 9808
 2135 IWRD = IWRD + 2
      MODE = MODE - 1
      IF (MODE .LE. 0) GO TO 2136
      IWORD = CORE(IWRD)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWORD,0)
      IF (CORE(IWRD).EQ.ALLON .OR. IWORD.EQ.BLANK) GO TO 2135
      GO TO 2130
 2136 NTHRU = 0
      GO TO 2111
C
 2138 IWRD = IWRD + 2
      MODE = MODE - 1
      IF (MODE) 2139,2139,2140
 2139 ASSIGN 2136 TO IRTN
      IPRM = POIN
      GO TO 9806
 2140 IWORD = CORE(IWRD)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWORD,0)
      IF (IWORD .EQ. POIN) GO TO 2135
      ASSIGN 2130 TO IRTN
      IPRM = CORE(IWRD)
      GO TO 9808
C
 2142 ISTT = 4
      ISTB = 6
      GO TO 2150
C
 2143 ISTT = 3
      ISTB = 6
      GO TO 2150
C
 2144 ISTT = 7
      ISTB = 9
      GO TO 2150
C
 2145 ISTT = 3
      ISTB = 5
      GO TO 2150
C
 2146 ISTT = 10
      ISTB = 12
      GO TO 2150
C
 2147 ISTT = 5
      ISTB = 6
      GO TO 2150
C
 2148 ISTT = 1
      ISTB = 2
      GO TO 2150
C
 2149 ISTT = 1
      ISTB = 5
C
 2150 IWORD = CORE(IWRD+1)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWORD,0)
      DO 2155 I = ISTT,ISTB
      IF (IWORD .EQ. SETP2(I)) GO TO 2135
 2155 CONTINUE
      ASSIGN 2135 TO IRTN
      IPRM = CORE(IWRD)
      GO TO 9808
C
C     PLOT COMMAND CARD
C
 2200 IWRD = IWRD + 2
      MODE = MODE - 1
 2202 IF (CORE(IWRD).EQ.0 .OR. CORE(IWRD).EQ.EOR) GO TO 2215
      IWORD = CORE(IWRD)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWORD,0)
      IF (CORE(IWRD).EQ.ALLON .OR. IWORD.EQ.BLANK) GO TO 2207
      DO 2205 I = 1,28
      IF (IWORD .EQ. PLTPR(I))
     1    GO TO (2208, 2220, 2220, 2220, 2230, 2230, 2207, 2250, 2250,
     2           2260, 2207, 2208, 2280, 2280, 2208, 2208, 2208, 2290,
     3           2207, 2281, 2207, 2248, 2240, 2207, 2245, 2207, 2207,
     4           2208), I
C
C    1            SET  STAT  MODA  CMOD  FREQ  TRAN  CONT  RANG  TIME
C    2           PHAS  MAGN  ORIG  SYMM  ANTI   PEN  DENS  SYMB  LABE
C    3           SHAP  VECT  OUTL  THRU  MAXI  HIDD  SHRI  NOFI  FILL
C    4           OFFS
C
 2205 CONTINUE
      ASSIGN 2207 TO IRTN
      IPRM = CORE(IWRD)
      GO TO 9808
C
 2207 IWRD = IWRD + 2
      MODE = MODE - 1
      IF (MODE) 2210,2210,2202
C
 2208 IPRM = CORE (IWRD)
      ASSIGN 2202 TO IRTN
 2209 IWRD = IWRD + 2
      MODE = MODE - 1
      IF (MODE .LE. 0) GO TO 2210
      IWORD = CORE(IWRD)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWORD,0)
      IF (CORE(IWRD).EQ.ALLON .OR. IWORD.EQ.BLANK) GO TO 2209
      GO TO 9814
C
 2210 IF (CORE(IWRD) .GE. 0) GO TO 2215
      IF (I .NE. 12) GO TO 2214
      PORG = CORE(IWRD+1)
      IF (ORG .LE. 0) GO TO 9830
      DO 2213 I = 1,ORG
      IF (PORG .EQ. ORIGIN(I)) GO TO 2214
 2213 CONTINUE
      GO TO 9830
 2214 IWRD = IWRD + 2
      GO TO 2210
C
 2215 IF (CORE(IWRD) .NE. 0) GO TO 2216
      ICONT = 3
      GO TO 9998
 2216 IF (CORE(IWRD) .NE. EOR) GO TO 2217
      ICONT = 0
      GO TO 9998
 2217 MODE = CORE(IWRD)
      IWRD = IWRD + 1
      GO TO 2202
C
 2220 IPR1 = CORE(IWRD  )
      IPR2 = CORE(IWRD+1)
      IWRD = IWRD + 2
      MODE = MODE - 1
      IF (MODE) 2222,2222,2223
 2222 IPRM = DEFO
      ASSIGN 2210 TO IRTN
      GO TO 9806
 2223 IWORD = CORE(IWRD)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWORD,0)
      DO 2225 I = 1,3
C                                     DEFO  VELO  ACCE
      IF (IWORD .EQ. IDVPR(I)) GO TO (2207, 9826, 9826), I
 2225 CONTINUE
      ASSIGN 2207 TO IRTN
      IPRM = CORE(IWRD)
      GO TO 9808
C
 2230 IWRD = IWRD + 2
      MODE = MODE - 1
      IF (MODE) 2231,2231,2232
 2231 ASSIGN 2210 TO IRTN
      IPRM = DEFO
      GO TO 9806
C
 2232 IWORD = CORE(IWRD)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWORD,0)
      DO 2235 I = 1,3
      IF (IWORD .EQ. IDVPR(I)) GO TO 2207
 2235 CONTINUE
      ASSIGN 2207 TO IRTN
      IPRM = CORE(IWRD)
      GO TO 9808
C
 2250 NREAL = 2
      ASSIGN 2202 TO IRTN
 2251 IWRD = IWRD + 2
      MODE = MODE - 1
      IF (MODE .LE. 0) GO TO 2252
      IWORD = CORE(IWRD)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWORD,0)
      IF (CORE(IWRD).EQ.ALLON .OR. IWORD.EQ.BLANK) GO TO 2251
      GO TO 9818
 2252 INTEG = 0
      DO 2255 I = 1,NREAL
      IF (CORE(IWRD) .GE.  0) GO TO 2257
      IF (CORE(IWRD) .EQ. -1) INTEG = 1
      IF (CORE(IWRD) .EQ. -4) IWRD  = IWRD + 1
      IWRD = IWRD + 2
 2255 CONTINUE
      IF (INTEG) 2210,2210,2256
 2256 ASSIGN 2210 TO IRTN
      GO TO 9816
 2257 ASSIGN 2215 TO IRTN
      GO TO 9818
C
 2260 IWRD = IWRD + 2
      MODE = MODE - 1
      NREAL= 1
      IF (MODE) 2261,2261,2262
 2261 ASSIGN 2210 TO IRTN
      IPRM = LAG
      GO TO 9806
 2262 IWORD = CORE(IWRD)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWORD,0)
      IF (IWORD .EQ. LAG) GO TO 2251
      ASSIGN 2251 TO IRTN
      IPRM = CORE(IWRD)
      GO TO 9808
C
 2280 NCRD = 9
      ICRD = 1
      IVC  = 0
      GO TO 2282
 2281 NCRD = 25
      ICRD = 4
      IVC  = 1
 2282 ASSIGN 2210 TO IRTN
      IAX  = 0
 2283 IWRD = IWRD + 2
      MODE = MODE - 1
      IF (MODE) 9810,9810,2284
 2284 IWORD = CORE(IWRD)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWORD,0)
      IF (CORE(IWRD).EQ.ALLON .OR. IWORD.EQ.BLANK) GO TO 2283
      DO 2285 I = ICRD,NCRD
      IF (IWORD .EQ. COORD(I)) GO TO 2286
 2285 CONTINUE
      IF (IAX) 9810,9810,2202
 2286 IWRD = IWRD + 2
      MODE = MODE - 1
      IF (MODE) 2215,2215,2287
 2287 IF (IVC) 2288,2288,2202
 2288 IF (IAX) 2289,2289,2202
 2289 IAX = 1
      GO TO 2284
C
 2290 IWRD = IWRD + 2
      MODE = MODE - 1
      IF (MODE) 2210,2210,2291
 2291 IWORD = CORE(IWRD)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWORD,0)
      IF (CORE(IWRD).EQ.ALLON .OR. IWORD.EQ.BLANK) GO TO 2290
      DO 2292 I = 1,5
      IF (IWORD .EQ. LBLPR(I)) GO TO (2290, 2207, 2207, 2207, 2207), I
C                                     GRID  POIN  ELEM  BOTH  EPID
 2292 CONTINUE
      GO TO 2202
C
 2240 IWRD  = IWRD + 2
      MODE  = MODE - 1
      IF (MODE) 2241,2241,2242
 2241 ASSIGN 2210 TO IRTN
      GO TO 9812
 2242 IWORD = CORE(IWRD)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWORD,0)
      IF (IWORD .EQ. DEFO) GO TO 2243
      ASSIGN 2243 TO IRTN
      IPRM  = CORE(IWRD)
      GO TO 9808
 2243 NREAL = 1
      GO TO 2251
C
 2245 IWRD  = IWRD + 2
      IWORD = CORE(IWRD)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWORD,0)
      IF (IWORD .EQ. HIDD) GO TO 2207
      MODE  = MODE - 1
      IF (MODE) 2241,2210,2210
C
 2248 IF (CORE(IWRD-3).EQ.-1 .AND. CORE(IWRD+2).EQ.-1) GO TO 2207
      ASSIGN 2207 TO IRTN
      GO TO 9822
C
C     SET UP ERROR MESSAGE
C
 9800 ASSIGN 9900 TO IERR
      MSGNO = 348
      GO TO 9890
 9802 ASSIGN 9902 TO IERR
      MSGNO = 349
      GO TO 9890
 9804 ASSIGN 9904 TO IERR
      MSGNO = 350
      GO TO 9895
 9806 ASSIGN 9906 TO IERR
      MSGNO = 351
      GO TO 9890
 9808 ASSIGN 9908 TO IERR
      MSGNO = 351
      GO TO 9890
 9810 ASSIGN 9910 TO IERR
      MSGNO = 352
      GO TO 9890
 9812 ASSIGN 9912 TO IERR
      MSGNO = 353
      GO TO 9890
 9814 ASSIGN 9914 TO IERR
      MSGNO = 354
      GO TO 9895
 9816 ASSIGN 9916 TO IERR
      MSGNO = 355
      GO TO 9890
 9818 ASSIGN 9918 TO IERR
      MSGNO = 356
      GO TO 9890
 9820 ASSIGN 9920 TO IERR
      MSGNO = 357
      GO TO 9895
 9822 ASSIGN 9922 TO IERR
      MSGNO = 358
      GO TO 9890
 9824 ASSIGN 9924 TO IERR
      MSGNO = 359
      GO TO 9890
 9826 ASSIGN 9926 TO IERR
      MSGNO = 360
      GO TO 9890
 9828 ASSIGN 9928 TO IERR
      MSGNO = 361
      GO TO 9895
 9830 ASSIGN 9930 TO IERR
      MSGNO = 362
      GO TO 9895
C
 9890 CALL PAGE2 (2)
      WRITE  (NOUT,9891) UFM,MSGNO
 9891 FORMAT (A23,I4)
      IF (PLTOPT .LE. 2) NOGO = 1
      GO TO 9898
 9895 CALL PAGE2 (2)
      WRITE  (NOUT,9896) UWM,MSGNO
 9896 FORMAT (A25,I4)
C
 9898 GO TO IERR, (9900,9902,9904,9906,9908,9910,9912,9914,9916,9918,
     1             9920,9922,9924,9926,9928,9930)
C
 9900 WRITE  (NOUT,9901)
 9901 FORMAT (5X,'FIRST CHARACTER ON CARD IS NUMERIC. INCORRECT FORMAT',
     1       ' OR INCORRECT CONTINUATION ON PREVIOUS CARD')
      GO TO 320
C
 9902 WRITE  (NOUT,9903) CORE(IWRD)
 9903 FORMAT (5X,'PLOT COMMAND ',A4,' NOT RECOGNIZED.  CHECK SPELLING ',
     1       'AND FORMAT ON THIS CARD AND CONTINUATION ON PREVIOUS ONE')
      GO TO 320
 9904 WRITE  (NOUT,9905)
 9905 FORMAT (1H+,30X,' - ONLY NASTRAN GENERAL PURPOSE PLOTTER IS ',
     1       'SUPPORTED')
      GO TO 320
C
 9906 WRITE  (NOUT,9907) IPRM
 9907 FORMAT (1H+,30X,' - KEYWORD ',A4,' NOT FOUND')
      GO TO IRTN, (320,1070,2110,2136,2210,510)
C
 9908 WRITE  (NOUT,9909) IPRM
 9909 FORMAT (1H+,30X,' - KEYWORD ',A4,' NOT RECOGNIZED')
      GO TO IRTN, (320,1070,2130,2135,2202,2207,2243,2251)
C
 9910 WRITE  (NOUT,9911)
 9911 FORMAT (1H+,30X,' - COORDINATE AXES INCORRECTLY DEFINED')
      GO TO IRTN, (320,2210)
C
 9912 WRITE  (NOUT,9913)
 9913 FORMAT (1H+,30X,' - INCORRECT FORMAT')
      GO TO IRTN, (320,1070,2210)
C
 9914 WRITE  (NOUT,9915) IPRM
 9915 FORMAT (1H+,30X,3H - ,A4,' IDENTIFICATION NUMBER NOT DEFINED')
      GO TO IRTN, (320,1005,1910,2120,2202)
C
 9916 WRITE  (NOUT,9917)
 9917 FORMAT (1H+,30X,' - DATA TYPE IS INCORRECT')
      GO TO IRTN, (1005,1730,2107,2110,2210,320)
C
 9918 WRITE  (NOUT,9919)
 9919 FORMAT (1H+,30X,' - ONE OR MORE REQUIRED REAL VALUES MISSING')
      GO TO IRTN, (320,1005,2202,2215)
C
 9920 WRITE  (NOUT,9921)
 9921 FORMAT (1H+,30X,' - CAMERA OPTION NOT SPECIFIED')
      GO TO 320
C
 9922 WRITE  (NOUT,9923)
 9923 FORMAT (1H+,30X,' - THRU MUST BE PRECEDED AND FOLLOWED BY INTEGER'
     1,      ' VALUES')
      GO TO IRTN, (2123,2207)
C
 9924 WRITE  (NOUT,9925)
 9925 FORMAT (1H+,30X,' - THRU RANGE OVERLAPS RANGE OF PREVIOUS THRU')
      GO TO 2123
C
 9926 WRITE  (NOUT,9927) IPR1,IPR2
 9927 FORMAT (1H+,30X,' - ONLY DEFORMATION VALID WITH ',2A4)
      GO TO 2207
C
 9928 WRITE  (NOUT,9929) FORG,PORG
 9929 FORMAT (1H+,30X,' - A NEW ORIGIN',I8,' WAS DEFINED IN A FIND ',
     1        'CARD, BUT IT IS NOT USED BY THE IMMEDIATE PLOT CARD',
     2        /5X,'(ORIGIN',I8,' WILL BE USED FOR THIS PLOT)',/)
      GO TO 9999
C
 9930 WRITE  (NOUT,9931) PORG
 9931 FORMAT (1H+,30X,' - ORIGIN',I8,' IS UNDEFINED')
      GO TO 2207
C
 9998 IF (ISPLOT.EQ.0 .OR. PORG.EQ.-1) RETURN
      IF (PORG .EQ. 0) PORG = PORG1
      IF (FORG.NE.0 .AND. FORG.NE.PORG) GO TO 9828
 9999 FORG = 0
      PORG = 0
      RETURN
      END

      SUBROUTINE MRED2N
C
C     THIS SUBROUTINE CALCULATES THE K MATRIX FOR THE MRED2 MODULE.
C
      INTEGER         DRY,GBUF1,GBUF2,SBUF1,SBUF2,SBUF3,OTFILE,PREC,
     1                TYPIN,TYPOUT,HK,DBLKOR
      DOUBLE PRECISION DZ
      DIMENSION       ITRLR1(7),ITRLR2(7),MODNAM(2),RZ(1),DZ(1)
      COMMON /BLANK / IDUM1,DRY,IDUM2,GBUF1,GBUF2,IDUM3,SBUF1,SBUF2,
     1                SBUF3,INFILE(12),OTFILE(6),ISCR(10),KORLEN,KORBGN,
     2                IDUM4(14),NMODES,IDUM6(2),LSTZWD
      COMMON /ZZZZZZ/ Z(1)
      COMMON /CONDAS/ IDUM5(4),FORPI2
      COMMON /MPY3TL/ ITRLRA(7),ITRLRB(7),ITRLRE(7),ITRLRC(7),JSCR(3),
     1                LKORE,ICODE,PREC,DUMMY(13)
      COMMON /PACKX / TYPIN,TYPOUT,IROW,NROW,INCR
      EQUIVALENCE     (LAMAMR,INFILE(2)),(RZ(1),Z(1)),(DZ(1),Z(1)),
     1                (HK,ISCR(2)),(KMW2,ISCR(5)),(K,ISCR(3))
      DATA    MODNAM/ 4HMRED,4H2N  /
C
C                    2
C     FORM KMW2 = M W  MATRIX
C                  I I
C
      IF (DRY .EQ. -2) RETURN
      IF (KORBGN+7+NMODES .GE. KORLEN) GO TO 75
      IFILE = LAMAMR
      CALL GOPEN  (LAMAMR,Z(GBUF1),0)
      CALL FWDREC (*70,LAMAMR)
      IFORM = 3
      ITYPE = 1
      CALL MAKMCB (ITRLR1,KMW2,NMODES,IFORM,ITYPE)
      TYPIN = 1
      TYPOUT= 1
      IROW  = 1
      NROW  = NMODES
      INCR  = 1
      CALL GOPEN (KMW2,Z(GBUF2),1)
      DO 20 I = 1,NMODES
      CALL READ (*60,*70,LAMAMR,Z(KORBGN),7,0,NWDSRD)
      DO 10 J = 1,NMODES
      RZ(KORBGN+7+J-1) = 0.0
      IF (J .EQ. I)
     1    RZ(KORBGN+7+J-1) = FORPI2*RZ(KORBGN+5)*(RZ(KORBGN+4)**2)
   10 CONTINUE
   20 CALL PACK (Z(KORBGN+7),KMW2,ITRLR1)
      CALL CLOSE (LAMAMR,1)
      CALL CLOSE (KMW2,1)
      CALL WRTTRL (ITRLR1)
C
C     FORM K MATRIX
C
C                      T
C                       **      **
C        ** **   **  ** * .    0 * **  **
C        *   *   *    * *  .     * *    *                  2
C        * K * = * HK * *   K    * * HK *     WHERE K = M W
C        *   *   *    * *    .   * *    *                I I
C        ** **   **  ** * 0   .  * **  **
C                       **      **
C
      ITRLR2(1) = HK
      CALL RDTRL (ITRLR2)
      DO 30 I = 1,7
      ITRLRA(I) = ITRLR2(I)
      ITRLRB(I) = ITRLR1(I)
   30 ITRLRE(I) = 0
      IPRC = 1
      ITYP = 0
      IF ((ITRLRA(5) .EQ. 2) .OR. (ITRLRA(5) .EQ. 4)) IPRC = 2
      IF ((ITRLRB(5) .EQ. 2) .OR. (ITRLRB(5) .EQ. 4)) IPRC = 2
      IF (ITRLRA(5) .GE. 3) ITYP = 2
      IF (ITRLRB(5) .GE. 3) ITYP = 2
      ITYPE = IPRC + ITYP
      IFORM = 6
      CALL MAKMCB (ITRLRC,K,ITRLR2(3),IFORM,ITYPE)
      JSCR(1) = ISCR(8)
      JSCR(2) = ISCR(6)
      JSCR(3) = ISCR(2)
      ICODE   = 0
      PREC    = 0
      DBLKOR  = (KORBGN/2) + 1
      LKORE   = LSTZWD - (2*DBLKOR - 1)
      CALL SOFCLS
      CALL MPY3DR (DZ(DBLKOR))
      CALL WRTTRL (ITRLRC)
      CALL SOFOPN (Z(SBUF1),Z(SBUF2),Z(SBUF3))
      RETURN
C
C     PROCESS SYSTEM FATAL ERRORS
C
   60 IMSG = -2
      GO TO 80
   70 IMSG = -3
      GO TO 80
   75 IMSG = -8
      IFILE = 0
   80 CALL SOFCLS
      CALL MESAGE (IMSG,IFILE,MODNAM)
      RETURN
      END

      SUBROUTINE LSPLIN(NI,XYI,ND,XYD,KY,KD,KT,DZ,DTX,DTY,DTOR,
     *           G,NCORE,ISNG)
      LOGICAL IKT
      LOGICAL BNONE,BONE
      LOGICAL SPEC
      LOGICAL OXR,OYR
      LOGICAL BOTH
      LOGICAL STWO,SONE,NETHR
      INTEGER SIZE
C
      DIMENSION XYI(1),XYD(1),G(1),NAME(2)
      DATA NAME/4HLSPL,4HIN  /
      SPEC = .FALSE.
      BONE = .FALSE.
      BNONE = .FALSE.
      SONE = .FALSE.
      STWO = .FALSE.
      OXR = .FALSE.
      OYR = .FALSE.
      BOTH = .FALSE.
      IKT = .FALSE.
      NETHR = .TRUE.
      EY = FLOAT(KY)
C
C     KY EFFECTS RIGID BODY ROWS AND COLUMNS OF A AND ROWS OF B
C
C     DTX AND DTY EFFECT ROWS AND COLUMNS OF A AND ROWS OF B
C
C     KD EFFECTS COLUMNS OF B
C
C     SPEC GUARDS AGAINST SINGULAR MATRIX FOR ROTATIONS WITHOUT Y
C     CONSTRAINED
C
      IF(KD .EQ. 0) BNONE = .TRUE.
      IF(KD .EQ. 1) BONE = .TRUE.
      IF(KY.EQ.-1) SONE = .TRUE.
      IF(KY.EQ.1) STWO = .TRUE.
      IF(KT.EQ.1) IKT = .TRUE.
      IF(DTX.LT.0.0) OXR = .TRUE.
      IF(DTY.LT.0.0) OYR = .TRUE.
      IF(OXR.AND.OYR) BOTH = .TRUE.
      IF(.NOT.OXR.AND..NOT.OYR) NETHR = .FALSE.
      DTOR2 =  DTOR/2.0
      NSC = 3
      IF(KY.EQ.1) NSC = 2
      IF(KY.EQ.-1) NSC = 1
      SIZE = 3
      IF(OXR) SIZE = SIZE-1
      IF(OYR) SIZE = SIZE-1
      IF(OYR.AND. KY.GT.-1) GO TO 5
      GO TO 7
    5 TEMP = XYI(1)
      SPEC = .TRUE.
      NII = 2*NI
      DO 6 I = 1,NII,2
      IF(XYI(I) .NE. TEMP) SPEC = .FALSE.
    6 CONTINUE
    7 CONTINUE
      NCA = SIZE*NI + NSC
      IF(SPEC) NCA = NCA -1
      NCA2= 2*NCA
      NCB = (KD+1) * ND
      NCC = SIZE*NI
C
C     CORE NEEDED
C                A         G        INVERS
      NEEDED =NCA*NCA+  NCB*NCC  +    3*NCA
C                                   B
      IF(IKT) NEEDED = NEEDED +  NCB*NCA
C                                        C
      IF(.NOT.IKT) NEEDED = NEEDED +  NCC*NCA
      IF(NEEDED .GT.NCORE) CALL MESAGE(-8,0,NAME)
      IS= NCORE -3*NCA-1
      IG= 1
C
C     IF KT = 1  COMPUTE  B THEN A  THEN  C IN THE SPACE OF A
C
C     IF KT = 0 COMPUTE  C THEN A  THEN  B IN THE SPACE OF A
C
      IF(IKT) GO TO 100
C
C     FILL IN C MATRIX
C
      IC = NCB * NCC
      MP = IC +1
   10 DO 30 I = 1,NCC
      DO 20 J = 1,NCA
      IC = IC +1
      G(IC) = 0.0
      IF(I.EQ.J) G(IC) = 1.0
   20 CONTINUE
   30 CONTINUE
      IF(IKT) GO TO 300
      NC = NCC
      IA =  IC
      GO TO 200
C
C     B MATRIX
C
  100 IB =  NCB * NCC
      MP = IB + 1
  110 NJ = 2*ND
      NII= 2*NI
      DO 130 J=1,NJ,2
      DO 120 I=1,NII,2
      YM = XYD(J+1) - XYI(I+1)
      AYM= ABS(YM)
      AYMD = AYM*DTOR2
      YP =(XYD(J+1) + XYI(I+1))
      AYP= ABS(YP) * EY
      AYPD = AYP*DTOR2
      IB= IB +1
      G(IB) =    AYM**3/12.0  -  XYD(J)*XYI(I)*AYMD
     *           + AYP**3/12.0 - XYD(J)*XYI(I)*AYPD
      IF(BNONE) GO TO 111
      G(IB+NCA) = AYM*YM/4.0  + AYP*YP/4.0
      IF(BONE) GO TO 111
      G(IB+NCA2)=  XYI(I)*AYMD  + XYI(I)*AYPD
  111 IF(BOTH) GO TO 120
      IF(OXR) GO TO 113
      IB=IB+1
      G(IB) =    -AYM*YM/4.0  + AYP*YP/4.0
      IF(BNONE) GO TO 112
      G(IB+NCA) = -AYM/2.0 + AYP/2.0
      IF(BONE) GO TO 112
      G(IB+NCA2) = 0.0
  112 IF(OYR) GO TO 120
  113 IB = IB +1
      G(IB)=   XYD(J)*AYMD   + XYD(J)*AYPD
      IF(BNONE) GO TO 120
      G(IB+NCA)  =  0.0
      IF(BONE) GO TO 120
      G(IB+NCA2) =  -AYMD   - AYPD
  120 CONTINUE
      IB = IB +1
      IF(SONE) GO TO 123
      G(IB) = 1.0
      IF(BNONE) GO TO 121
      G(IB+NCA) = 0.0
      IF(BONE) GO TO 121
      G(IB+NCA2) = 0.0
  121 IF(STWO) GO TO 122
      IB = IB +1
      G(IB) = XYD(J+1)
      IF(BNONE) GO TO 122
      G(IB+NCA) = 1.0
      IF(BONE) GO TO 122
      G(IB+NCA2) = 0.0
  122 IF(SPEC) GO TO 128
      IB = IB +1
      G(IB) =-XYD(J)
      IF(BNONE) GO TO 128
      G(IB+NCA) = 0.0
      IF(BONE) GO TO 128
      G(IB+NCA2) = 1.0
      GO TO 128
  123 G(IB) = XYD(J+1)
      IF(BNONE) GO TO 128
      G(IB+NCA) = 1.0
      IF(BONE) GO TO 128
      G(IB+NCA2) = 0.0
  128 IB = IB + KD*NCA
  130 CONTINUE
      IF(.NOT.IKT) GO TO 400
      IA = IB
      NC = NCB
C
C     A MATRIX
C
  200 NII= 2*NI
      K = IA
C
C     ZERO A
C
      II = K+1
      IK = II + NCA*NCA
      DO 210 I = II,IK
  210 G(I) = 0.0
      II = 0
      DO 240 I = 1,NII,2
      DO 230 J = I,NII,2
      K = K+1
      YP   =(XYI(I+1) + XYI(J+1))
      AYP  = ABS(YP) * EY
      AYPD = AYP*DTOR2
      YM   = XYI(I+1) - XYI(J+1)
      AYM  = ABS(YM)
      AYMD = AYM*DTOR2
      G(K)       = AYM**3/12.0 - XYI(I)*XYI(J)*AYMD
     *              + AYP**3/12.0 - XYI(I)*XYI(J)*AYPD
      IF(I.EQ.J) G(K) = G(K) + DZ
      IF(BOTH) GO TO 230
      IF(OXR) GO TO 212
      G(K+NCA)  = AYM*YM/4.0  + AYP*YP/4.0
      IF(OYR) GO TO 214
      G(K+NCA2)  = XYI(I)*AYMD  + XYI(I)*AYPD
      K = K+1
      G(K)  =    -AYM*YM/4.0  + AYP*YP/4.0
      G(K+NCA)  = -AYM/2.0 + AYP/2.0
      IF(I.EQ.J) G(K+NCA) = G(K+NCA) + DTX
      G(K+NCA2)  = 0.0
      K = K+1
      G(K)       = XYI(J)*AYMD  + XYI(J)*AYPD
      G(K+NCA)   = 0.0
      G(K+NCA2) = -AYMD  - AYPD
      IF(I.EQ.J) G(K+NCA2) = G(K+NCA2) + DTY
      GO TO 230
  212 G(K+NCA) = XYI(I)*AYMD  + XYI(I)*AYPD
      K = K+1
      G(K) = XYI(J)*AYMD  + XYI(J)*AYPD
      G(K+NCA) = -AYMD   - AYPD
      IF(I.EQ.J) G(K+NCA) = G(K+NCA) + DTY
      GO TO 230
  214 K = K+1
      G(K)  =    -AYM*YM/4.0  + AYP*YP/4.0
      G(K+NCA)  = -AYM/2.0 + AYP/2.0
      IF(I.EQ.J) G(K+NCA) = G(K+NCA) + DTX
  230 CONTINUE
      K = K+1
      IF(SONE) GO TO 234
      G(K) = 1.0
      IF(BOTH) GO TO 231
      G(K+NCA) = 0.0
      IF(NETHR) GO TO 231
      G(K+NCA2) = 0.0
  231 IF(STWO) GO TO 232
      K = K+1
      G(K) = XYI(I+1)
      IF(BOTH) GO TO 232
      IF(OXR) G(K+NCA) = 0.0
      IF(OYR) G(K+NCA)  = 1.0
      IF(NETHR) GO TO 232
      G(K+NCA) = 1.0
      G(K+NCA2) = 0.0
  232 IF(SPEC) GO TO 238
      K = K+1
      G(K) = -XYI(I)
      IF(BOTH) GO TO 238
      IF(OXR) G( K+NCA) = 1.0
      IF(OYR) G( K+NCA) = 0.0
      IF(NETHR) GO TO 238
      G( K+NCA) = 0.0
      G( K+NCA2) = 1.0
      GO TO 238
  234 G(K) = XYI(I+1)
      IF(BOTH) GO TO 238
      IF(OXR) G( K+NCA) = 0.0
      IF(OYR) G( K+NCA) = 1.0
      IF(NETHR) GO TO 238
      G( K+NCA) = 1.0
      G( K+NCA2) = 0.0
  238 II = II+1
      K = K + SIZE*II + (SIZE-1)*NCA
  240 CONTINUE
C
C     LOWER TRIANGLE IF A STORED TRANSPOSE INTO UPPER TRIANGLE
C
      K = IA
      DO 260 I = 1,NCA
      DO 250 J = I,NCA
      K = K+1
      KK = K + (NCA-1)*(J-I)
      G(KK) = G(K)
  250 CONTINUE
      K = K+I
  260 CONTINUE
C
C     CALL  INVERSE   A-1 C  OR  A-1 B
C
C     REPLACE CALLS TO INVAER WITH CALLS TO INVERS.
C     NO NEED TO COMPUTE DETERMINANT SINCE IT IS NOT USED SUBSEQUENTLY.
      ISNG = -1
      CALL INVERS(NCA,G(IA+1),NCA,G(MP),NC,DET,ISNG,G(IS))
      IF(ISNG.EQ.2) GO TO 1000
C
C     ADJUST INDEXES TO A AND A-1 RESULT
C
      IB = IA
      ICB= IB+1
      IF(.NOT.IKT) GO TO 110
      IC = IA
      ICC = IC +1
      GO TO 10
  300 CALL GMMATS(G(MP),NCB,NCA,0,G(ICC),NCC,NCA,1,G(IG))
      GO TO 1000
  400 CALL GMMATS(G(MP),NCC,NCA,0,G(ICB),NCB,NCA,1,G(IG))
 1000 RETURN
      END

      SUBROUTINE GPTLBL (GPLST,X,U,DEFORM,BUF)
C
      INTEGER         GPLST(1),DEFORM,EXGPID,REW,GP,GPT,GPX,BUF
      REAL            X(3,1),U(2,1)
      COMMON /BLANK / NGP,SKP1(9),SKP2(5),EXGPID
      COMMON /PLTDAT/ SKPPLT(20),SKPA(3),CNTX
      DATA    INPREW, REW / 0,1 /
C
      CALL GOPEN (EXGPID,GPLST(BUF),INPREW)
      CALL TYPINT (0,0,0,0,0,-1)
      DO 120 GP = 1,NGP
      CALL FREAD (EXGPID,GPT,1,0)
      CALL FREAD (EXGPID,GPX,1,0)
      GPX = GPLST(GPX)
C
C     IF THE GRID POINT INDEX IS 0 (NOT IN SET) OR NEGATIVE (EXCLUDED),
C     NEVER PUT A LABEL AT THAT GRID POINT.
C
      IF (GPX .LE. 0) GO TO 120
C
C     TYPE THE GRID POINT ID
C
      IF (DEFORM .NE. 0) GO TO 111
      XX = X(2,GPX)
      YY = X(3,GPX)
      GO TO 112
  111 XX = U(1,GPX)
      YY = U(2,GPX)
  112 CALL TYPINT (XX+CNTX,YY,1,GPT,0,0)
  120 CONTINUE
C
      CALL CLOSE (EXGPID,REW)
      CALL TYPINT (0,0,0,0,0,1)
      RETURN
      END

      SUBROUTINE IFP4
C
C     HYDROELASTIC PREFACE ROUTINE
C
C     THIS PREFACE MODULE OPERATES ON FLUID RELATED INPUT DATA WHICH
C     EXISTS AT THIS POINT IN THE FORM OF CARD IMAGES ON THE AXIC DATA
C     BLOCK.
C
C     7/12/73 NO AXIAL SYMMETRY FIRST FIVE WORDS OF BNDFL NO WRITTEN
C
C     THE FOLLOWING LIST GIVES THE CARD IMAGES IFP4 WILL LOOK FOR ON THE
C     AXIC DATA BLOCK, THE CARD IMAGES IFP4 WILL GENERATE OR MODIFY, AND
C     THE DATA BLOCKS ONTO WHICH THE GENERATED OR MODIFIED CARD IMAGES
C     WILL BE PLACED.
C
C     IFP4 INPUT         IFP4 OUTPUT        DATA BLOCK
C     CARD IMAGE         CARD IMAGE         EFFECTED
C     -----------        -----------        ----------
C       AXIF               -NONE-             -NONE-
C       BDYLIST            -DATA-             MATPOOL
C       CFLUID2            CFLUID2            GEOM2
C       CFLUID3            CFLUID3            GEOM2
C       CFLUID4            CFLUID4            GEOM2
C       FLSYM              -DATA-             MATPOOL
C       FREEPT             SPOINT             GEOM2
C                          MPC                GEOM4
C       FSLIST             CFSMASS            GEOM2
C                          SPC                GEOM4
C       GRIDB              GRID               GEOM1
C       PRESPT             SPOINT             GEOM2
C                          MPC                GEOM4
C       RINGFL             GRID               GEOM1
C                          SEQGP              GEOM1
C       DMIAX              DMIG               MATPOOL
C
C     SOME OF THE ABOVE OUTPUT CARD IMAGES ARE A FUNCTION OF SEVERAL
C     INPUT CARD IMAGES
C
      LOGICAL         HARMS    ,ANYGB    ,END      ,ANY      ,G1EOF    ,
     1                G2EOF    ,G4EOF    ,SET102   ,PRESS    ,BIT      ,
     2                NOGO     ,MATEOF   ,ANYGRD   ,BIT2
      INTEGER         AXIF(2)  ,BDYLST(2),CFLUID(6),FLSYM(2) ,FREEPT(2),
     1                FSLST(2) ,GRIDB(2) ,PRESPT(2),RINGFL(2),CFSMAS(2),
     2                MPC(2)   ,MPCADD(2),TYPE(2)  ,SPOINT(2),CORD(8)  ,
     3                SPC(2)   ,SPCADD(2),SPC1(2)  ,NCORD(4) ,GEOM1    ,
     4                SUBR(2)  ,BUF(10)  ,LAST(10) ,AXIC     ,GEOM2    ,
     5                CARD(10) ,FILE     ,MATPOL   ,GEOM4    ,SEQGP(2) ,
     6                SCRT1    ,ENTRYS   ,CORSYS   ,SPACE    ,CORE     ,
     7                SCRT2    ,SYSBUF   ,OUTPUT   ,FLAG     ,EOR      ,
     8                CSF      ,RD       ,RDREW    ,WRT      ,WRTREW   ,
     9                CLS      ,CLSREW   ,SAVEID(5),MONES(4) ,DMIG(2)  ,
     O                BUF1     ,BUF2     ,BUF3     ,BUF4     ,BUF5     ,
     1                WORDS    ,BNDFL(2) ,TRAIL(7) ,Z        ,POINT    ,
     2                DMIAX(2) ,MSG1(2)  ,MSG2(2)  ,GRID(2)
      REAL            RBUF(10) ,RCARD(10),RZ(4)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /SYSTEM/ SYSBUF   ,OUTPUT   ,NOGO     ,DUM34(34),IAXIF
      COMMON /NAMES / RD       ,RDREW    ,WRT      ,WRTREW   ,CLSREW   ,
     1                CLS
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE     (Z(1),RZ(1)), (BUF(1),RBUF(1)), (CARD(1),RCARD(1))
     1,               (CORE,ICORE), (RHOB,IRHOB), (BD,IBD)
      DATA    AXIF  / 8815  ,88    /
      DATA    BDYLST/ 8915  ,89    /
      DATA    CFLUID/ 7815  ,78    , 7915  ,79   , 8015  ,80 /
      DATA    FLSYM / 9115  ,91    /
      DATA    FREEPT/ 9015  ,90    /
      DATA    FSLST / 8215  ,82    /
      DATA    GRIDB / 8115  ,81    /
      DATA    PRESPT/ 8415  ,84    /
      DATA    RINGFL/ 8315  ,83    /
      DATA    CFSMAS/ 2508  ,25    /
      DATA    BNDFL / 9614  ,96    /
      DATA    MPC   / 4901  ,49    /
      DATA    SPC   / 5501  ,55    /
      DATA    SPC1  / 5481  ,58    /
      DATA    MPCADD/ 4891  ,60    /
      DATA    SPCADD/ 5491  ,59    /
      DATA    SPOINT/ 5551  ,49    /
      DATA    GRID  / 4501  ,45    /
      DATA    SEQGP / 5301  ,53    /
      DATA    DMIAX / 214   ,2     /
      DATA    DMIG  / 114   ,1     /
      DATA    CORD   /1701  ,17    , 1901  ,19   , 2001 ,20  ,2201 ,22 /
      DATA    NCORD / 6     ,6     , 13    ,13   /
      DATA    MONES / -1    ,-1    , -1    ,-1   /
      DATA    SUBR  / 4HIFP4,4H    /
      DATA    DEGRAD/ 1.7453292519943E-02/, MINUS1/ -1 /
      DATA    GEOM1 , GEOM2,GEOM4  / 201,208,210  /
      DATA    AXIC  , MATPOL,EOR   / 215,214,1    /
C
C     NOTE  SCRATCH2 IN IFP4 IS EQUIVALENCED TO THE -FORCE- DATA BLOCK
C
      DATA    SCRT1 , SCRT2 , NOEOR /  301,213,0  /
      DATA    MSG1  / 4HIFP4, 4HBEGN/, MSG2       / 4HIFP4, 4HEND  /
C
C     DEFINE CORE AND BUFFER POINTERS
C
      CALL CONMSG (MSG1,2,0)
      ICORE = KORSZ(Z)
      BUF1  = ICORE- SYSBUF - 2
      BUF2  = BUF1 - SYSBUF - 2
      BUF3  = BUF2 - SYSBUF - 2
      BUF4  = BUF3 - SYSBUF - 2
      BUF5  = BUF4 - SYSBUF - 2
      ICORE = BUF5 - 1
      ICRQ  = 100  - ICORE
      IF (ICORE .LT. 100) GO TO 2370
C
C     OPEN AXIC DATA BLOCK (IF NAME NOT IN FIST RETURN - NO MESSAGE)
C
      CALL PRELOC (*2300,Z(BUF1),AXIC)
C
C     PICK UP AXIF CARD. (IF AXIF CARD NOT PRESENT - RETURN NO MESSAGE)
C
      CALL LOCATE (*2300,Z(BUF1),AXIF,FLAG)
      CALL READ (*2320,*30,AXIC,Z(1),ICORE,EOR,WORDS)
      WRITE  (OUTPUT,10) UFM
   10 FORMAT (A23,' 4031, INSUFFICIENT CORE TO READ DATA ON AXIF CARD.')
      WRITE  (OUTPUT,20) ICORE
   20 FORMAT (5X,'ADDITIONAL CORE NEEDED =',I8,' WORDS.')
      GO TO 2310
C
C     DATA OF AXIF CARD IS NOW STORED
C
   30 CSF   = Z(1)
      G     = RZ(2)
      DRHO  = RZ(3)
      J     = 3
      IDRHO = Z(J)
      BD    = RZ(4)
      NOSYM = Z(J+2)
      IN    = 6
      NN    = WORDS - 1
      NI    = NN
      J     = NN - IN + 1
      HARMS = .FALSE.
      IF (J .GE. 1) HARMS =.TRUE.
      IF (.NOT.HARMS) GO TO 100
C
C     CONVERT USER INPUT LIST OF HARMONIC NUMBERS TO A LIST OF INDICES.
C
      IF (J .EQ. 1) GO TO 40
      CALL SORT (0,0,1,1,Z(IN),J)
   40 II = NN + 1
      NI = NN
      DO 70 I = IN,NN
      ITEMP = 2*Z(I)
      IF (NOSYM) 50,60,50
   50 IF (Z(I) .EQ. 0) GO TO 60
      NI = NI + 1
      Z(NI) = ITEMP + 1
   60 NI = NI + 1
      Z(NI) = ITEMP + 2
   70 CONTINUE
      N  = NI - II + 1
C
C     SET MAXIMUM HARMONIC+1 FOR USE BY SDR2C AND VDRB
C
      IAXIF = Z(NN) + 1
C
C     BEGIN GEOM1 PROCESSING
C     **********************
C
C     OPEN GEOM1 AND FIND CORD1C, CORD1S, CORD2C, OR CORD2S CARD IMAGE
C     WITH COORDINATE SYSTEM ID = CSF OF AXIF CARD. THEN NOTE TYPE
C     (CYLINDRICAL OR SPHERICAL, 2 OR 3 RESPECTIVELY)
C
  100 FILE = GEOM1
C
C     BEFORE CALLING PRELOC ON GEOM1 CHECK FOR DATA ON GEOM1
C
      TRAIL(1) = GEOM1
      CALL RDTRL (TRAIL)
      DO 110 I = 2,7
      IF (TRAIL(I)) 120,110,120
  110 CONTINUE
      GO TO 150
  120 CALL PRELOC (*2360,Z(BUF2),GEOM1)
      DO 140 I = 1,4
      I2 = 2*I
      CALL LOCATE (*140,Z(BUF2),CORD(I2-1),FLAG)
      NSIZE = NCORD(I)
  130 CALL READ (*2340,*140,GEOM1,Z(NI+1),NSIZE,NOEOR,FLAG)
      IF (Z(NI+1) .EQ. CSF) GO TO 170
      GO TO 130
  140 CONTINUE
C
C     FALL THROUGH LOOP IMPLIES COORDINATE SYSTEM WAS NOT FOUND
C
  150 NOGO = .TRUE.
      WRITE  (OUTPUT,160) UFM,CSF
  160 FORMAT (A23,' 4033, COORDINATE SYSTEM ID =',I20,' AS SPECIFIED ',
     1       'ON AXIF CARD IS NOT PRESENT', /5X,' AMONG ANY OF CORD1C,',
     2       ' CORD1S, CORD2C, OR CORD2S CARD TYPES.', /5X,
     3       ' CYLINDRICAL TYPE ASSUMED FOR CONTINUING DATA CHECK.')
      CORSYS = 2
      GO TO 180
  170 CORSYS = Z(NI+2)
  180 CALL CLOSE (GEOM1,CLSREW)
C
C     READ INTO CORE FROM AXIC ALL GRIDB CARD IMAGES (5 WORDS / IMAGE)
C
      ANYGB  = .FALSE.
      IGRIDB = NI + 1
      NGRIDB = NI
      CALL LOCATE (*210,Z(BUF1),GRIDB,FLAG)
      ANYGB = .TRUE.
      SPACE = CORE- NI
      CALL READ (*2320,*200,AXIC,Z(IGRIDB),SPACE,EOR,NWORDS)
      NOGO = .TRUE.
      WRITE  (OUTPUT,190) UFM
  190 FORMAT (A23,' 4034, INSUFFICIENT CORE TO HOLD GRIDB CARD IMAGES.')
      WRITE (OUTPUT,20) SPACE
      ANYGB = .FALSE.
      GO TO 210
  200 NGRIDB = NI + NWORDS
C
C     IF ANY GRIDB IMAGES ARE PRESENT A BOUNDARY LIST IS FORMED IN CORE.
C
  210 IBDYL = NGRIDB + 1
      NBDYL = NGRIDB
      IF (.NOT.ANYGB) GO TO 520
      CALL LOCATE (*520,Z(BUF1),BDYLST,FLAG)
  220 CALL READ (*2320,*330,AXIC,RHOB,1,NOEOR,FLAG)
      IF (IRHOB .NE. 1) GO TO 250
      IF (IDRHO .NE. 1) GO TO 240
      NOGO = .TRUE.
      WRITE  (OUTPUT,230) UFM
  230 FORMAT (A23,' 4035, THE FLUID DENSITY HAS NOT BEEN SPECIFIED ON ',
     1        'A BDYLIST CARD AND', /5X,'THERE IS NO DEFAULT FLUID ',
     2        'DENSITY SPECIFIED ON THE AXIF CARD.')
      RHOB = 1.0
      GO TO 250
  240 RHOB = DRHO
  250 END  = .FALSE.
      IDFPRE = 0
  260 CALL READ (*2320,*2330,AXIC,IDF,1,NOEOR,FLAG)
      IF (IDF .NE. 0) GO TO 270
      IDFPRE = -1
      GO TO 260
  270 CALL READ (*2320,*2330,AXIC,IDFAFT,1,NOEOR,FLAG)
C
C     NOTE.......  ON INPUT   ID=0 IMPLIES AXIS
C                             ID=-1 IMPLIES END OF CARD
C
C
C     NOTE.......  ON OUTPUT  ID=0 IMPLIES UNDEFINED ID
C                             ID=-1 IMPLIES AXIS
C
      IF (IDFAFT .EQ. -1) GO TO 280
      IF (IDFAFT .EQ.  0) IDFAFT = -1
      GO TO 290
  280 IDFAFT = 0
      END = .TRUE.
C
C     DO NOT PUT OUT ENTRY WHEN IDF = AXIS
C
  290 IF (IDF .EQ. -1) GO TO 320
      IF (NBDYL+7 .LE. CORE) GO TO 310
      WRITE  (OUTPUT,300) UFM
  300 FORMAT (A23,' 4036, INSUFFICIENT CORE TO BUILD BOUNDARY LIST ',
     1       'TABLE.')
      ICRQ = NBDYL + 7 - CORE
      GO TO 2370
  310 Z(NBDYL +1) = IDF
      Z(NBDYL +2) = 1
      Z(NBDYL +3) = 1
      Z(NBDYL +4) = 1
      Z(NBDYL +5) = IDFPRE
      Z(NBDYL +6) = IDFAFT
      RZ(NBDYL+7) = RHOB
      NBDYL = NBDYL + 7
C
C     ROTATE THE ID-S
C
  320 IDFPRE = IDF
      IDF = IDFAFT
      IF (.NOT.END) GO TO 270
      GO TO 220
C
C     SORT ENTRIES ON FIRST WORD OF EACH ENTRY.
C
  330 CALL SORT (0,0,7,1,Z(IBDYL),NBDYL-IBDYL+1)
      ENTRYS = (NBDYL-IBDYL+1)/7
C
C     PASS THE RINGFL IMAGES INSERTING X1, X2, AND X3 IN THE APPROPRIATE
C     BDYLIST ENTRY.
C
      CALL LOCATE (*490,Z(BUF1),RINGFL,FLAG)
  340 CALL READ (*2320,*490,AXIC,BUF,4,NOEOR,FLAG)
      IF (CORSYS  .NE.  3) GO TO 360
      IF (RBUF(3) .NE. 0.) GO TO 360
      NOGO = .TRUE.
      WRITE  (OUTPUT,350) UFM,BUF(1)
  350 FORMAT (A23,' 5003, ZERO X2 VALUE ON RINGFL CARD WITH SPHERICAL ',
     1       'COORDINATES.  FLUID POINT ID =',I10)
  360 IF (BUF(CORSYS+1)) 370,410,370
  370 NOGO = .TRUE.
      IF (CORSYS .EQ. 3) GO TO 390
      WRITE  (OUTPUT,380) UFM,BUF(1)
  380 FORMAT (A23,'4042, COORDINATE SYSTEM IS CYLINDRICAL BUT RINGFL ',
     1       'CARD ID =',I20,' HAS A NON-ZERO X2 VALUE.')
      GO TO 410
  390 WRITE  (OUTPUT,400) UFM,BUF(1)
  400 FORMAT (A23,' 4043, COORDINATE SYSTEM IS SPHERICAL BUT RINGFL ',
     1       'CARD ID =',I20,' HAS A NON-ZERO X3 VALUE.')
  410 CALL BISLOC(*340,BUF(1),Z(IBDYL),7,ENTRYS,JPOINT)
      NTEMP = IBDYL + JPOINT - 1
      IF (Z(NTEMP+1) .EQ. 1) GO TO 430
      NOGO = .TRUE.
      WRITE  (OUTPUT,420) UFM,BUF(1)
  420 FORMAT (A23,' 4038, RINGFL CARD HAS ID =',I20,' WHICH HAS BEEN ',
     1       'USED.')
      GO TO 340
C
C     CHECK TO GET RANGE OF BDYLIST HAVING THIS SAME ID.
C     THEN FILL IN X1, X2, AND X3 IN THOSE ENTRIES.
C
  430 NLIST = NTEMP
  440 NTEMP = NTEMP - 7
      IF (NTEMP .LT. IBDYL) GO TO 450
      IF (Z(NTEMP) .EQ. Z(NTEMP+7)) GO TO 440
  450 ILIST = NTEMP + 7
      NTEMP = NLIST
  460 NTEMP = NTEMP + 7
      IF (NTEMP .GT. NBDYL) GO TO 470
      IF (Z(NTEMP) .EQ. Z(NTEMP-7)) GO TO 460
  470 NLIST = NTEMP - 1
      DO 480 I = ILIST,NLIST,7
      Z(I+1) = BUF(2)
      Z(I+2) = BUF(3)
      Z(I+3) = BUF(4)
  480 CONTINUE
      GO TO 340
C
C     CHECK TO SEE THAT X1, X2, AND X3 WERE FOUND FOR ALL ENTRIES.
C
  490 DO 510 I = IBDYL,NBDYL,7
      IF (Z(I+1) .NE. 1) GO TO 510
      NOGO = .TRUE.
      WRITE  (OUTPUT,500) UFM,Z(I)
  500 FORMAT (A23,' 4040, ID =',I20,' APPEARS ON A BDYLIST CARD, BUT ',
     1       'NO RINGFL CARD IS PRESENT WITH THE SAME ID.')
  510 CONTINUE
C
C     OPEN GEOM1, OPEN SCRATCH1, COPY HEADER REC FROM GEOM1 TO SCRATCH1
C
  520 CALL IFP4C (GEOM1,SCRT1,Z(BUF2),Z(BUF3),G1EOF)
C
C     COPY ALL DATA UP TO FIRST GRID CARD IMAGE.
C
      CALL IFP4B (GEOM1,SCRT1,ANY,Z(NBDYL+1),CORE-NBDYL,GRID,G1EOF)
      ANYGRD = ANY
      IF (.NOT.ANYGB) GO TO 1040
      IF (NBDYL .LT. IBDYL) GO TO 1040
C
C     CREATE AND MERGE WITH GRIDS FROM GEOM1, GRIDS FROM GRIDB IMAGES.
C
      FILE = GEOM1
      IF (.NOT.ANY) GO TO 540
      CALL READ (*2340,*530,GEOM1,LAST,8,NOEOR,FLAG)
      CALL IFP4E (LAST(1))
      GO TO 540
  530 ANY = .FALSE.
  540 DO 600 I = IGRIDB,NGRIDB,5
      CARD(1) = Z(I)
      CALL IFP4E (CARD(1))
      CARD(2) = CSF
      KID = Z(I+4)
      CALL BISLOC (*560,KID,Z(IBDYL),7,ENTRYS,POINT)
      NTEMP   = IBDYL + POINT - 1
      CARD(3) = Z(NTEMP+1)
      CARD(4) = Z(NTEMP+2)
      CARD(5) = Z(NTEMP+3)
      CARD(CORSYS+2) = Z(I+1)
      CARD(6) = Z(I+2)
      CARD(7) = Z(I+3)
      CARD(8) = 0
C
C     MERGE CARD IN
C
      IF (.NOT.ANY) GO TO 590
  550 IF (LAST(1) .GT. CARD(1)) GO TO 590
      CALL WRITE (SCRT1, LAST, 8, NOEOR)
      CALL READ (*2340,*580,GEOM1,LAST,8,NOEOR,FLAG)
      CALL IFP4E (LAST(1))
      GO TO 550
  560 NOGO = .TRUE.
      WRITE  (OUTPUT,570) UFM,Z(I),Z(I+4)
  570 FORMAT (A23,' 4057, GRIDB CARD WITH ID =',I10,' HAS A REFERENCE ',
     1       'IDF =',I10,/5X,'WHICH DOES NOT APPEAR IN A BOUNDARY LIST')
      GO TO 600
  580 ANY = .FALSE.
  590 CALL WRITE (SCRT1,CARD,8,NOEOR)
  600 CONTINUE
C
      IF (.NOT.ANY) GO TO 620
  610 CALL WRITE (SCRT1,LAST,8,NOEOR)
      CALL READ (*2340,*620,GEOM1,LAST,8,NOEOR,FLAG)
      CALL IFP4E (LAST(1))
      GO TO 610
C
C     FURTHER ALTERATIONS TO BOUNDARY LIST TABLE AT THIS TIME.
C     RADIAL LOCATION (RJ) AND VERTICAL LOCATION (ZJ)
C
  620 NRING = NGRIDB
      IF (.NOT.HARMS) GO TO 1200
      DO 640 I = IBDYL,NBDYL,7
      IF (CORSYS .EQ. 3) GO TO 630
      Z(I+2) = Z(I+3)
      GO TO 640
C
  630 ANGLE = RZ(I+2)*DEGRAD
      TEMP  = RZ(I+1)
      RZ(I+1) = TEMP*SIN(ANGLE)
      RZ(I+2) = TEMP*COS(ANGLE)
  640 CONTINUE
C
C     LENGTH AND ASSOCIATED ANGLE COMPONENTS OF A CONICAL SECTION. L,C,S
C
      IF (NOGO) GO TO 780
      DO 770 I = IBDYL,NBDYL,7
      RJ = RZ(I+1)
      ZJ = RZ(I+2)
C
C     FIND R   , Z     AND  R   , Z     (RJL1,ZJL1,RJP1,ZJP1)
C           J-1   J-1        J+1   J+1
C
      IF (Z(I+4)) 650,660,670
C
C     SECONDARY ID IS AXIS
C
  650 RJL1 = 0
      ZJL1 = ZJ
      GO TO 680
C
C     SECONDARY ID IS NOT AVAILABLE
C
  660 RJL1 = RJ
      ZJL1 = ZJ
      GO TO 680
C
C     FIND SECONDARY ID ENTRY
C
  670 KID = Z(I+4)
      CALL BISLOC (*2380,KID,Z(IBDYL),7,ENTRYS,POINT)
      NTEMP = IBDYL + POINT - 1
      RJL1  = RZ(NTEMP+1)
      ZJL1  = RZ(NTEMP+2)
C
C     SECONDARY ID ON PLUS SIDE
C
  680 IF (Z(I+5)) 690,700,710
C
C     SECONDARY ID IS AXIS
C
  690 RJP1 = 0
      ZJP1 = ZJ
      GO TO 720
C
C     SECONDARY ID IS NOT AVAILABLE
C
  700 RJP1 = RJ
      ZJP1 = ZJ
      GO TO 720
C
C     FIND SECONDARY ID ENTRY
C
  710 KID = Z(I+5)
      CALL BISLOC (*2380,KID,Z(IBDYL),7,ENTRYS,POINT)
      NTEMP = IBDYL + POINT - 1
      RJP1  = RZ(NTEMP+1)
      ZJP1  = RZ(NTEMP+2)
C
C     COMPUTE AND INSERT L,C,S.
C
  720 IF (RJ .NE. 0.0) GO TO 740
      NOGO = .TRUE.
      WRITE  (OUTPUT,730) UFM,Z(I)
  730 FORMAT (A23,' 4044, RINGFL CARD ID =',I20,' HAS SPECIFIED A ',
     1       'ZERO RADIAL LOCATION.')
      GO TO 770
C
  740 TEMP1 = RJP1 - RJ
      TEMP2 = 0.25/RJ
      R = 0.5*(RJP1-RJL1+TEMP2*(TEMP1*TEMP1-(RJL1-RJ)**2))
      ZZ= 0.5*(ZJL1-ZJP1+TEMP2*(TEMP1*(ZJ-ZJP1)-(RJ-RJL1)*(ZJL1-ZJ)))
      RZ(I+3) = SQRT(R*R + ZZ*ZZ)
      IF (RZ(I+3) .NE. 0.0) GO TO 760
      NOGO = .TRUE.
      WRITE  (OUTPUT,750) UFM,Z(I)
  750 FORMAT (A23,' 4045, THE BOUNDARY LIST ENTRY FOR ID =',I9,
     1       ' HAS A ZERO CROSS-SECTION LENGTH.')
      GO TO 770
C
  760 RZ(I+4) = ZZ/RZ(I+3)
      RZ(I+5) =  R/RZ(I+3)
  770 CONTINUE
C
C     SORT GRIDB IMAGES TO BE IN SORT ON RID AND PHI WITHIN EACH RID
C
  780 NTEMP = NGRIDB - IGRIDB + 1
      CALL SORT (0,0,5,-2,Z(IGRIDB),NTEMP)
      CALL SORT (0,0,5,-5,Z(IGRIDB),NTEMP)
C
C     THE BOUNDARY FLUID DATA IS ADDED TO THE MATPOOL DATA BLOCK AS 1
C     LOCATE RECORD CONTAINING THE FOLLOWING.
C
C     1-3   LOCATE CODE  9614,96,0
C     4     CDF
C     5     G
C     6     DRHO
C     7     BD
C     8     NOSYM
C     9     M
C     10    S1
C     11    S2
C     12    N = NUMBER OF INDICES FOLLOWING
C     12+1  THRU  12+N  THE INDICES
C     13+N TO THE EOR IS THE BOUNDARY FLUID DATA
C
C
      FILE  = MATPOL
      INAME = NBDYL + 1
      NNAME = NBDYL
      CALL IFP4C (MATPOL,SCRT2,Z(BUF4),Z(BUF5),MATEOF)
      IF (MATEOF) GO TO 930
C
C     IF ANY DMIAX CARDS ARE PRESENT THEN THEY ARE MERGED IN FRONT OF
C     DMIG CARDS IN THE DMIG RECORD.  FILE NAMES MAY NOT BE THE SAME ON
C     BOTH DMIG AND DMIAX CARDS.
C
      CALL IFP4F (DMIAX(2),MATPOL,BIT)
      CALL IFP4F (DMIG(2) ,MATPOL,BIT2)
C
C     LOCATE DMIAX CARDS, COPY THEM TO SCRT2 AS DMIG CARDS AND KEEP
C     LIST OF THEIR FILE NAMES.
C
      IF (.NOT.BIT .AND. .NOT.BIT2) GO TO 900
      CALL CLOSE (MATPOL,CLSREW)
      CALL PRELOC (*2360,Z(BUF4),MATPOL)
C
C     WRITE DMIG HEADER.
C
      BUF(1) = DMIG(1)
      BUF(2) = DMIG(2)
      BUF(3) = 120
      CALL WRITE (SCRT2,BUF,3,NOEOR)
      IF (.NOT.BIT) GO TO 850
      CALL LOCATE (*850,Z(BUF4),DMIAX,FLAG)
      ASSIGN 800 TO IRETRN
C
C     READ 9 WORD HEADER
C
  790 GO TO IRETRN(800,860)
  800 CALL READ (*2340,*850,MATPOL,BUF,9,NOEOR,FLAG)
C
C     SAVE NAME
C
      Z(INAME  ) = BUF(1)
      Z(INAME+1) = BUF(2)
      NNAME = NNAME + 2
      ICRQ  = NNAME + 2 - ICORE
      IF (ICRQ .GT. 0) GO TO 2370
  810 CALL WRITE (SCRT2,BUF,9,NOEOR)
C
C     COPY THE COLUMN DATA.  FIRST THE COLUMN INDEX.
C
  820 CALL READ (*2340,*2350,MATPOL,BUF,2,NOEOR,FLAG)
      CALL WRITE (SCRT2,BUF,2,NOEOR)
      IF (BUF(1)) 790,830,830
C
C     TERMS OF COLUMN
C
  830 CALL READ (*2340,*2350,MATPOL,BUF,2,NOEOR,FLAG)
      CALL WRITE (SCRT2,BUF,2,NOEOR)
      IF (BUF(1)) 820,840,840
  840 CALL READ (*2340,*2350,MATPOL,BUF,1,NOEOR,FLAG)
      CALL WRITE (SCRT2,BUF,1,NOEOR)
      GO TO 830
C
C     DMIAX-S ALL COPIED.  NOW COPY ANY DMIG-S.
C
  850 IF (.NOT.BIT2) GO TO 890
      CALL LOCATE (*890,Z(BUF4),DMIG,FLAG)
      ASSIGN 860 TO IRETRN
C
C     READ HEADER
C
  860 CALL READ (*2320,*890,MATPOL,BUF,9,NOEOR,FLAG)
C
C     CHECK THE NAME FOR BEING THE SAME AS ONE ON A DMIAX CARD
C
      DO 880 I = INAME,NNAME,2
      IF (BUF(1) .NE. Z(I  )) GO TO 880
      IF (BUF(2) .NE. Z(I+1)) GO TO 880
C
C     ERROR FOR NAME DOES MATCH THAT OF A DMIAX NAME
C
      NOGO = .TRUE.
      WRITE  (OUTPUT,870) UFM,BUF(1),BUF(2)
  870 FORMAT (A23,' 4062, DMIG BULK DATA CARD SPECIFIES DATA BLOCK ',
     1       2A4,' WHICH ALSO APPEARS ON A DMIAX CARD.')
  880 CONTINUE
C
C     COPY THE COLUMN DATA
C
      GO TO 810
C
C     WRITE THE END OF RECORD FOR DMIG CARDS
C
  890 CALL WRITE (SCRT2,0,0,EOR)
C
C     TURN ON BIT FOR DMIG CARD TYPE
C
      CALL IFP4G  (DMIG(2),MATPOL)
      CALL REWIND (MATPOL)
      CALL FWDREC (*2340,MATPOL)
C
C     COPY EVERYTHING ON MATPOL TO SCRT2, EXCEPT FOR DMIG, DMIAX, AND
C     THE 2**31-1 RECORD.
C
  900 CALL READ (*930,*2350,MATPOL,BUF,3,NOEOR,FLAG)
C     2147483647  = 2**31-1
      ITWO31  =  2147483647
      IF (BUF(1).NE.ITWO31.AND.(BUF(1).NE.DMIG(1).OR.BUF(2).NE.DMIG(2))
     1   .AND.(BUF(1).NE.DMIAX(1).OR.BUF(2).NE.DMIAX(2))) GO TO 910
      CALL FWDREC (*2340,MATPOL)
      GO TO 900
  910 CALL READ  (*2340,*920,MATPOL,Z(NBDYL+1),CORE-NBDYL,NOEOR,FLAG)
      CALL WRITE (SCRT2,Z(NBDYL+1),CORE-NBDYL,NOEOR)
      GO TO 900
  920 CALL WRITE (SCRT2,Z(NBDYL+1),FLAG,EOR)
      GO TO 900
  930 MATEOF = .TRUE.
      CALL IFP4B (MATPOL,SCRT2,ANY,Z(NBDYL+1),CORE-NBDYL,BNDFL,MATEOF)
      CARD(1) = 0
      CARD(2) = 0
      CARD(3) = 0
      CARD(4) = N
      CALL LOCATE (*940,Z(BUF1),FLSYM,FLAG)
      CALL READ (*2320,*2330,AXIC,CARD,3,EOR,FLAG)
  940 CONTINUE
      CALL WRITE (SCRT2,Z(1),5,NOEOR)
      CALL WRITE (SCRT2,CARD,4,NOEOR)
      CALL WRITE (SCRT2,Z(II),N,NOEOR)
C
C     OUTPUT ENTRIES TO MATPOOL DATA BLOCK.(TEMPORARILY ON SCRT2)
C
      JGRIDB = IGRIDB
      JSAVE  = 0
      DO 1030 I = IBDYL,NBDYL,7
C
C     POSSIBILITY OF 2 FLUID ID-S HAVING SAME VALUE
C
      IF (JSAVE .NE. 0) JGRIDB = JSAVE
      JSAVE = 0
      IF (Z(I) .EQ. Z(I+7)) JSAVE = JGRIDB
C
C     IF RHO FOR A FLUID POINT IS ZERO WE DO NOT PUT OUT FLUID
C     DATA AND CONNECTED POINTS.
C
      IF (RZ(I+6)) 950,960,950
  950 CALL WRITE (SCRT2,Z(I),7,NOEOR)
C
C     APPEND GRIDB POINTS WITH THEIR ANGLES.
C
  960 IF (JGRIDB .GT. NGRIDB) GO TO 1010
      IF (Z(JGRIDB+4) - Z(I)) 970,980,1010
  970 JGRIDB = JGRIDB + 5
      GO TO 960
C
C     APPEND THE POINT
C
  980 IF (RZ(I+6)) 990,1000,990
  990 CALL WRITE (SCRT2,Z(JGRIDB),2,NOEOR)
 1000 JGRIDB = JGRIDB + 5
      GO TO 960
C
C     COMPLETE THE ENTRY
C
 1010 IF (RZ(I+6)) 1020,1030,1020
 1020 CALL WRITE (SCRT2,MONES,2,NOEOR)
 1030 CONTINUE
C
C     COMPLETE RECORD.
C
      CALL WRITE (SCRT2,0,0,EOR)
      CALL IFP4B (MATPOL,SCRT2,ANY,Z(NGRIDB+1),CORE-NGRIDB,MONES,MATEOF)
C
C  READ ALL RINGFL CARD IMAGES INTO CORE
C
 1040 IF (ANYGB) GO TO 1060
      IF (.NOT.ANYGRD) GO TO 1060
C
C     COPY GRID CARDS NOT COPIED AS A RESULT OF THE ABSENCE OF GRIDB
C     CARDS.
C
      FILE = GEOM1
 1050 CALL READ (*2340,*1060,GEOM1,CARD,8,NOEOR,FLAG)
      CALL WRITE (SCRT1,CARD,8,NOEOR)
      GO TO 1050
 1060 IRING = NGRIDB + 1
      NRING = NGRIDB
      CALL LOCATE (*1090,Z(BUF1),RINGFL,FLAG)
      CALL READ (*2320,*1080,AXIC,Z(IRING),CORE-IRING,NOEOR,FLAG)
      WRITE  (OUTPUT,1070) UFM
 1070 FORMAT (A23,' 4047, INSUFFICIENT CORE TO HOLD RINGFL IMAGES.')
      ICRQ = CORE - IRING
      WRITE (OUTPUT,20) ICRQ
      GO TO 2310
 1080 NRING = IRING + FLAG - 1
C
C     OUTPUT HARMONIC GRID CARDS.
C
 1090 IF (NRING .LT. IRING) GO TO 1150
C
C     SORT RINGFL IDS
C
      CALL SORT (0,0,4,1,Z(IRING),FLAG)
      CARD(2)  = 0
      RCARD(5) = 0.0
C
C     CARD(6) = -1 AS A FLAG TO TELL GP1 THIS IS A ONE DEGREE OF
C     FREEDOM POINT.
C
      CARD(6) = -1
      CARD(7) = 0
      CARD(8) = 0
      DO 1140 I = II,NI
      INDEX = Z(I)*500000
      DO 1130 K = IRING,NRING,4
C
C     CALL IFP4E TO CHECK ID RANGE 1 TO 99999
C
      CALL IFP4E (Z(K))
      IF (K .EQ. IRING) GO TO 1100
      IF (Z(K) .NE. ZTEMP) GO TO 1100
      NOGO = .TRUE.
      WRITE (OUTPUT,420) UFM,Z(K)
 1100 ZTEMP   = Z(K)
      CARD(1) = Z(K) + INDEX
      IF (CORSYS .EQ. 3) GO TO 1110
      CARD(3) = Z(K+1)
      CARD(4) = Z(K+3)
      GO TO 1120
 1110 ANGLE = RZ(K+2)*DEGRAD
      RCARD(3) = RZ(K+1)*SIN(ANGLE)
      RCARD(4) = RZ(K+1)*COS(ANGLE)
      IF (RCARD(3) .NE. 0.0) GO TO 1120
      NOGO = .TRUE.
      WRITE (OUTPUT,350) UFM,Z(K)
      GO TO 1140
 1120 CALL WRITE (SCRT1,CARD,8,NOEOR)
 1130 CONTINUE
 1140 CONTINUE
C
C     COMPLETE GRID CARD RECORD.
C
 1150 CALL WRITE (SCRT1,0,0,EOR)
C
C     CREATE AND OUTPUT SEQGP CARDS ONTO SCRT1.  COPY GEOM1 TO SCRT1 UP
C     TO AND INCLUDING SEQGP 3-WORD HEADER.
C
      IF (NRING .LT. IRING) GO TO 1210
      CALL IFP4B (GEOM1,SCRT1,ANY,Z(NRING+1),CORE-NRING,SEQGP,G1EOF)
C
C     COPY ALL SEQGP CARDS OVER ALSO (ID-S MUST BE OF CORRECT VALUE).
C
      FILE = GEOM1
      IF (.NOT.ANY) GO TO 1170
 1160 CALL READ (*2340,*1170,GEOM1,CARD,2,NOEOR,FLAG)
      CALL IFP4E (CARD(1))
      CALL WRITE (SCRT1,CARD,2,NOEOR)
      GO TO 1160
C
C     NOW OUTPUT SEQGP CARDS FOR HARMONICS OF EACH RINGFL.
C
 1170 DO 1190 I = II,NI
      INDEX = Z(I)*500000
      NTEMP = Z(I) - 1
      DO 1180 K = IRING,NRING,4
      CARD(1) = Z(K) + INDEX
      CARD(2) = Z(K)*1000 + NTEMP
      CALL WRITE (SCRT1,CARD,2,NOEOR)
 1180 CONTINUE
 1190 CONTINUE
 1200 CALL WRITE (SCRT1,0,0,EOR)
C
C     COPY BALANCE OF GEOM1 TO SCRT1 (IF ANY MORE, WRAP UP, AND COPY
C     BACK)
C
 1210 CALL IFP4B(GEOM1,SCRT1,ANY,Z(NRING+1),CORE-NRING,MONES,G1EOF)
C
C     IF THERE ARE NO HARMONICS THEN ONLY GRID CARDS ARE CREATED FROM
C     GRIDB CARDS.
C
C     IF (.NOT. HARMS) GO TO 2300
C === IF (.NOT. HARMS) SHOULD NOT GO TO 2300 HERE === G.CHAN/UNISYS 86
C
C     END OF GEOM1 PROCESSING
C
C     BEGIN GEOM2 PROCESSING
C     **********************
C
C     OPEN GEOM2, AND SCRT1. COPY HEADER FROM GEOM2 TO SCRT1.
C
      CALL IFP4C (GEOM2,SCRT1,Z(BUF2),Z(BUF3),G2EOF)
C
C     PROCESS CFLUID2, CFLUID3, AND CFLUID4 CARDS.
C
      DO 1410 I = 1,3
      I2 = 2*I
      CALL LOCATE (*1410,Z(BUF1),CFLUID(I2-1),FLAG)
C
C     COPY DATA FROM GEOM2 TO SCRT1 UP TO POINT WHERE CFLUID CARDS GO
C     AND WRITE 3-WORD RECORD ID.
C
      CALL IFP4B (GEOM2,SCRT1,ANY,Z(NI+1),CORE-NI,CFLUID(2*I-1),G2EOF)
 1300 CALL READ (*2320,*1400,AXIC,CARD,I+4,NOEOR,FLAG)
      IF (CARD(I+3) .NE. 1) GO TO 1330
      IF (IDRHO     .NE. 1) GO TO 1320
      NOGO = .TRUE.
      WRITE  (OUTPUT,1310) UFM,CARD(1)
 1310 FORMAT (A23,' 4058, THE FLUID DENSITY HAS NOT BEEN SPECIFIED ON ',
     1       'A CFLUID CARD WITH ID =',I10, /5X,
     2       'AND THERE IS NO DEFAULT ON THE AXIF CARD.')
 1320 RCARD(I+3) = DRHO
 1330 IF (CARD(I+4) .NE. 1) GO TO 1360
      IF (IBD .NE. 1) GO TO 1350
      NOGO = .TRUE.
      WRITE  (OUTPUT,1340) UFM,CARD(1)
 1340 FORMAT (A23,' 4059, THE FLUID BULK MODULUS HAS NOT BEEN SPECIFIED'
     1,      ' ON A CFLUID CARD WITH ID =',I10, /5X,'AND THERE IS NO ',
     2       'DEFAULT ON THE AXIF CARD.')
 1350 RCARD(I+4) = BD
C
C     OUTPUT N IMAGES.
C
 1360 NTEMP = I+2
      DO 1370 K = 1,NTEMP
 1370 SAVEID(K) = CARD(K)
C
      DO 1390 K = II,NI
      CARD(1) = SAVEID(1)*1000 + Z(K)
      INDEX   = 500000*Z(K)
      DO 1380 L = 2,NTEMP
      CARD(L) = SAVEID(L) + INDEX
 1380 CONTINUE
      CARD(NTEMP+3) = (Z(K)-1)/2
      CALL WRITE (SCRT1,CARD,NTEMP+3,NOEOR)
 1390 CONTINUE
      GO TO 1300
C
C     END OF CFLUID DATA
C
 1400 CALL WRITE (SCRT1,0,0,EOR)
 1410 CONTINUE
C
C     CONSTRUCTION OF FSLIST TABLE IN CORE 3-WORDS/ENTRY
C
      IFSLST = NI + 1
      NFSLST = NI
      CALL LOCATE (*1600,Z(BUF1),FSLST,FLAG)
 1420 CALL READ (*2320,*1490,AXIC,RHOB,1,NOEOR,FLAG)
      IF (IRHOB .NE. 1) GO TO 1450
      IF (IDRHO .NE. 1) GO TO 1440
      NOGO = .TRUE.
      WRITE  (OUTPUT,1430) UFM
 1430 FORMAT (A23,' 4048, THE FLUID DENSITY HAS NOT BEEN SPECIFIED ON ',
     1       'AN FSLIST CARD AND', /5X,'THERE IS NO DEFAULT FLUID ',
     2       'DENSITY SPECIFIED ON THE AXIF CARD.')
      RHOB = 1.0
      GO TO 1450
 1440 RHOB = DRHO
 1450 CALL READ (*2320,*2330,AXIC,IDF,1,NOEOR,FLAG)
      IF (IDF .EQ. 0) IDF = -1
 1460 CALL READ (*2320,*2330,AXIC,IDFAFT,1,NOEOR,FLAG)
      IF (IDFAFT .EQ. -1) IDFAFT = -2
      IF (IDFAFT .EQ.  0) IDFAFT = -1
      IF (NFSLST+3 .LE. CORE) GO TO 1480
      WRITE  (OUTPUT,1470) UFM
 1470 FORMAT (A23,' 4049, INSUFFICIENT CORE TO BUILD FREE SURFACE ',
     1       'LIST TABLE.')
      ICRQ = NFSLST + 3 - CORE
      WRITE (OUTPUT,20) ICRQ
      GO TO 2310
 1480 Z(NFSLST+1) = IDF
      Z(NFSLST+2) = IDFAFT
      RZ(NFSLST+3)= RHOB
      NFSLST = NFSLST + 3
      IF (IDFAFT .EQ. -2) GO TO 1420
      IDF = IDFAFT
      GO TO 1460
C
C     TABLE IS COMPLETE. COPY GEOM2 DATA TO SCRT1 UP TO CFSMASS RECORD
C     SLOT
C
 1490 IF (NFSLST .GT. IFSLST) GO TO 1510
      NOGO = .TRUE.
      WRITE  (OUTPUT,1500) UFM
 1500 FORMAT (A23,' 4050, FSLIST CARD HAS INSUFFICIENT IDF DATA, OR ',
     1       'FSLIST DATA MISSING.')
      GO TO 1600
 1510 CALL IFP4B(GEOM2,SCRT1,ANY,Z(NFSLST+1),CORE-NFSLST,CFSMAS,G2EOF)
      ENTRYS =(NFSLST-IFSLST+1)/3
      K = 0
      DO 1530 I = IFSLST,NFSLST,3
      IF (Z(I+1) .EQ. -2) GO TO 1530
      K = K + 1000000
      RCARD(4) = RZ(I+2)*G
      DO 1520 L = II,NI
      INDEX = 500000*Z(L)
      CARD(1) = K + Z(L)
      CARD(2) = Z(I) + INDEX
      IF (Z(I) .LE. 0) CARD(2) = Z(I+1) + INDEX
      CARD(3) = Z(I+1) + INDEX
      IF (Z(I+1) .LE. 0) CARD(3) = Z(I) + INDEX
      CARD(5) = (Z(L)-1)/2
      CALL WRITE (SCRT1,CARD,5,NOEOR)
 1520 CONTINUE
 1530 CONTINUE
      CALL WRITE (SCRT1,0,0,EOR)
C
C     BEGIN GEOM4 PROCESSING
C     **********************
C
C     OPEN GEOM4 AND SCRT2 AND COPY HEADER RECORD FROM GEOM4 TO SCRT2.
C
 1600 CALL IFP4C (GEOM4,SCRT2,Z(BUF4),Z(BUF5),G4EOF)
C
C     COPY ALL DATA ON GEOM4 TO SCRT2 UP TO AND INCLUDING 3-WORD RECORD
C     HEADER OF MPC-RECORD.
C
      CALL IFP4B (GEOM4,SCRT2,ANY,Z(NFSLST+1),CORE-NFSLST,MPC,G4EOF)
C
C     COPY ANY MPC IMAGES HAVING A SET ID .LT. 103 TO SCRT2. ERROR
C     MESSAGE IF ANY HAVE ID = 102.  MAINTAIN A LIST OF SETID-S LESS
C     THAN 102.
C
      IMPC = NFSLST + 1
      NMPC = NFSLST
      IDLAST = 0
      FILE = GEOM4
      SET 102 = .FALSE.
      IF (.NOT.ANY) GO TO 1650
C
C     PICK UP SET ID
C
 1610 CALL READ (*2340,*1650,GEOM4,ID,1,NOEOR,FLAG)
      IF (ID .GT. 102) GO TO 1660
      IF (ID .NE. 102) GO TO 1630
      NOGO = .TRUE.
      WRITE  (OUTPUT,1620) UFM
 1620 FORMAT (A23,' 4051, AN MPC CARD HAS A SET ID SPECIFIED = 102. ',
     1       ' SET 102 IS ILLEGAL WHEN FLUID DATA IS PRESENT.')
 1630 CALL WRITE (SCRT2,ID,1,NOEOR)
C
C     ADD ID TO LIST IF NOT IN LIST
C
      IF (ID .EQ. IDLAST) GO TO 1640
      NMPC = NMPC + 1
      Z(NMPC) = ID
C
C     3 WORD GROUPS
C
 1640 CALL READ (*2340,*2350,GEOM4,CARD,3,NOEOR,FLAG)
      CALL WRITE (SCRT2,CARD,3,NOEOR)
      IF (CARD(1) .EQ. -1) GO TO 1610
      GO TO 1640
C
C     NOW POSITIONED TO OUTPUT MPC CARDS FOR SET 102
C
 1650 ID = 0
C
C     IF G FROM AXIF CARD IS NON-ZERO FREEPT DATA IS NOW PROCESSED.
C
 1660 ISPNT = NMPC + 1
      NSPNT = NMPC
      PRESS = .FALSE.
      IF (G .EQ. 0.0) GO TO 1780
C
C     IF THERE IS NO FREE SURFACE LIST, FREEPT CARDS ARE NOT USED.
C
      IF (NFSLST .LT. IFSLST) GO TO 1780
      CALL SORT (0,0,3,1,Z(IFSLST),NFSLST-IFSLST+1)
      CALL LOCATE (*1780,Z(BUF1),FREEPT,FLAG)
C
C     PICK UP A 3-WORD FREEPT OR PRESPT IMAGE (IDF,IDP,PHI)
C
 1670 CALL READ (*2320,*1770,AXIC,CARD,3,NOEOR,FLAG)
C
C     START MPC CARD
C
      ANGLE = RCARD(3)*DEGRAD
      IDF   = CARD(1)
      CARD(1) = 102
      CARD(3) = 0
      IF (PRESS) GO TO 1700
C
C     LOOK UP RHOB IN FSLIST TABLE
C
      CALL BISLOC (*1680,IDF,Z(IFSLST),3,ENTRYS,POINT)
      NTEMP = IFSLST + POINT + 1
      RCARD(4) = -ABS(RZ(NTEMP)*G)
      GO TO 1710
 1680 NOGO = .TRUE.
      WRITE  (OUTPUT,1690) UFM,IDF
 1690 FORMAT (A23,' 4052, IDF =',I10,' ON A FREEPT CARD DOES NOT ',
     1       'APPEAR ON ANY FSLIST CARD.')
      GO TO 1710
 1700 RCARD(4) = -1.0
 1710 CALL WRITE (SCRT2,CARD,4,NOEOR)
      SET102 = .TRUE.
C
C     ADD SPOINT TO CORE LIST
C
      IF (NSPNT+1 .LE. CORE) GO TO 1730
      WRITE  (OUTPUT,1720) UFM
 1720 FORMAT (A23,' 4053, INSUFFICIENT CORE TO PERFORM OPERATIONS ',
     1       'REQUIRED AS A RESULT OF FREEPT OR PRESPT DATA CARDS')
      ICRQ = NSPNT + 1 - CORE
      WRITE (OUTPUT,20) ICRQ
      GO TO 2310
 1730 NSPNT = NSPNT + 1
      Z(NSPNT) = CARD(2)
      CARD(2)  = 0
C
C     HARMONIC COEFFICIENT DATA
C
      DO 1760 I = II,NI
      CARD(1) = 500000*Z(I) + IDF
      NN = (Z(I)-1)/2
      IF (MOD(Z(I),2) .EQ. 0) GO TO 1740
      RCARD(3) = SIN(FLOAT(NN)*ANGLE)
      GO TO 1750
 1740 RCARD(3) = COS(FLOAT(NN)*ANGLE)
 1750 CALL WRITE (SCRT2,CARD,3,NOEOR)
 1760 CONTINUE
      CALL WRITE (SCRT2,MONES,3,NOEOR)
      GO TO 1670
C
C     CREATE MPC CARDS AND SPOINTS AS A RESULT OF PRESPT DATA.
C
 1770 IF (PRESS) GO TO 1790
 1780 CALL LOCATE (*1790,Z(BUF1),PRESPT,FLAG)
      PRESS = .TRUE.
      GO TO 1670
C
C     ANY SPOINTS IN CORE ARE AT THIS TIME OUTPUT TO GEOM2.
C
 1790 IF (NSPNT .LT. ISPNT) GO TO 1830
C
C     COPY DATA FROM GEOM2 TO SCRT1 UP TO AND INCLUDING THE 3-WORD
C     RECORD HEADER FOR SPOINTS
C
      FILE = GEOM2
      CALL IFP4B (GEOM2,SCRT1,ANY,Z(NSPNT+1),CORE-NSPNT,SPOINT,G2EOF)
      IF (.NOT.ANY) GO TO 1820
 1800 CALL READ (*2340,*1810,GEOM2,Z(NSPNT+1),CORE-NSPNT,NOEOR,FLAG)
      CALL WRITE (SCRT1,Z(NSPNT+1),CORE-NSPNT,NOEOR)
      GO TO 1800
 1810 CALL WRITE (SCRT1,Z(NSPNT+1),FLAG,NOEOR)
 1820 CALL WRITE (SCRT1,Z(ISPNT),NSPNT-ISPNT+1,EOR)
C
C     COPY BALANCE OF GEOM2 TO SCRT1,CLOSE THEM, AND SWITCH DESIGNATIONS
C
 1830 CALL IFP4B (GEOM2,SCRT1,ANY,Z(NMPC+1),CORE-NMPC,-1,G2EOF)
C
C     END OF GEOM2 PROCESSING
C     ***********************
C
C     COPY BALANCE OF MPC IMAGES ON GEOM4 TO SCRT2, COMPLETE LIST OF MPC
C     SETS.
C
      FILE = GEOM4
      IF (ID .EQ. 0) GO TO 1930
      GO TO 1910
C
C     3-WORD GROUPS
C
 1900 CALL READ (*2340,*2350,GEOM4,CARD,3,NOEOR,FLAG)
      CALL WRITE (SCRT2,CARD,3,NOEOR)
      IF (CARD(1) .NE. -1) GO TO 1900
      CALL READ (*2340,*1930,GEOM4,ID,1,NOEOR,FLAG)
 1910 IF (ID .EQ. IDLAST) GO TO 1920
C
C     ADD ID TO LIST
C
      IDLAST = ID
      NMPC   = NMPC + 1
      Z(NMPC)= ID
 1920 CALL WRITE (SCRT2,ID,1,NOEOR)
      GO TO 1900
 1930 CALL WRITE (SCRT2,0,0,EOR)
      TYPE(1) = MPCADD(1)
      TYPE(2) = MPCADD(2)
C
C     GENERATION OF MPCADD OR SPCADD CARDS FROM USER ID-S.  FIRST
C     OUTPUT MANDATORY MPCADD OR SPCADD.
C
 1940 CALL IFP4F (TYPE(2),GEOM4,BIT)
      IF (.NOT.SET102 .AND. NMPC.LT.IMPC .AND. .NOT.BIT) GO TO 2020
      CALL IFP4B (GEOM4,SCRT2,ANY,Z(NMPC+1),CORE-NMPC,TYPE,G4EOF)
      IF (.NOT. SET102) GO TO 1950
      CARD(1) = 200000000
      CARD(2) = 102
      CARD(3) = -1
      CALL WRITE (SCRT2,CARD,3,NOEOR)
C
C     NOW FROM USER ID-S
C
 1950 IF (NMPC .LT. IMPC) GO TO 1980
      DO 1970 I = IMPC,NMPC
      CARD(1) = Z(I) + 200000000
      CARD(2) = Z(I)
      NN = 3
      IF (.NOT.SET102) GO TO 1960
      CARD(3) = 102
      NN = 4
 1960 CARD(NN) = -1
      CALL WRITE (SCRT2,CARD,NN,NOEOR)
 1970 CONTINUE
C
C     IF USER MPCADD OR SPCADD CARDS ARE PRESENT, NOW CHANGE THEIR ID-S
C     AND ADD THE 102 SET IF IT EXISTS.
C
 1980 IF (.NOT.ANY) GO TO 2010
 1990 CALL READ (*2340,*2010,GEOM4,ID,1,NOEOR,FLAG)
      ID = ID + 200000000
      CALL WRITE (SCRT2,ID,1,NOEOR)
      IF (SET102) CALL WRITE (SCRT2,102,1,NOEOR)
 2000 CALL READ  (*2340,*2350,GEOM4,ID,1,NOEOR,FLAG)
      CALL WRITE (SCRT2,ID,1,NOEOR)
      IF (ID .EQ. -1) GO TO 1990
      GO TO 2000
C
 2010 CALL WRITE (SCRT2,0,0,EOR)
 2020 IF (TYPE(1) .EQ. SPCADD(1)) GO TO 2270
C
C     START LIST OF SPC AND SPC1 ID-S
C
      ISPC = NFSLST + 1
      NSPC = NFSLST
      SET102 = .FALSE.
      IDLAST = 0
C
C     CHECK BIT FOR SPC CARDS
C
      CALL IFP4F (SPC(2),GEOM4,BIT)
      IF (.NOT.BIT) GO TO 2080
C
C     COPY GEOM4 TO SCRT2 UP TO SPC CARDS
C
      CALL IFP4B (GEOM4,SCRT2,ANY,Z(ISPC),CORE-ISPC,SPC,G4EOF)
C
C     COPY SPC IMAGES KEEPING LIST OF ID-S.
C
 2030 CALL READ (*2340,*2070,GEOM4,ID,1,NOEOR,FLAG)
      IF (ID .EQ. IDLAST) GO TO 2060
      IF (ID .NE.    102) GO TO 2050
      NOGO = .TRUE.
      WRITE  (OUTPUT,2040) UFM
 2040 FORMAT (A23,' 4055, SET ID = 102 MAY NOT BE USED FOR SPC CARDS ',
     1       'WHEN USING THE HYDROELASTIC-FLUID ELEMENTS.')
      GO TO 2060
 2050 NSPC = NSPC + 1
      Z(NSPC) = ID
      IDLAST  = ID
 2060 CALL WRITE (SCRT2,ID,1,NOEOR)
      CALL READ  (*2340,*2350,GEOM4,CARD,3,NOEOR,FLAG)
      CALL WRITE (SCRT2,CARD,3,NOEOR)
      GO TO 2030
 2070 CALL WRITE (SCRT2,0,0,EOR)
C
C     CHECK FOR ANY SPC1 IMAGES
C
 2080 CALL IFP4F (SPC1(2),GEOM4,BIT)
      IF (.NOT.BIT .AND. G.NE.0.0) GO TO 2260
C
C     COPY FROM GEOM4 TO SCRT2 UP TO SPC1 DATA.
C
      CALL IFP4B(GEOM4,SCRT2,ANY,Z(NSPC+1),CORE-NSPC-2,SPC1,G4EOF)
C
C     COPY SPC1-S UP TO SETID .GE. 103.  SET 102 IS ILLEGAL FOR USER.
C
      IF (.NOT.BIT) GO TO 2150
 2090 CALL READ (*2340,*2150,GEOM4,ID,1,NOEOR,FLAG)
      IF (ID. LT. 102) GO TO 2100
      IF (ID .NE. 102) GO TO 2160
      NOGO = .TRUE.
      WRITE (OUTPUT,2040) UFM
C
C     ADD ID TO LIST IF NOT YET IN LIST
C
 2100 IF (NSPC .LT. ISPC) GO TO 2120
      DO 2110 I = ISPC,NSPC
      IF (ID .EQ. Z(I)) GO TO 2130
 2110 CONTINUE
C
C     ADD ID TO LIST
C
 2120 NSPC = NSPC + 1
      Z(NSPC) = ID
 2130 CALL WRITE (SCRT2,ID,1,NOEOR)
      CALL READ  (*2340,*2350,GEOM4,ID,1,NOEOR,FLAG)
      CALL WRITE (SCRT2,ID,1,NOEOR)
 2140 CALL READ  (*2340,*2350,GEOM4,ID,1,NOEOR,FLAG)
      CALL WRITE (SCRT2,ID,1,NOEOR)
      IF (ID .EQ. -1) GO TO 2090
      GO TO 2140
C
C     IF G IS ZERO AND THERE ARE FSLST ENTRIES, GENERATE SPC1-S NOW.
C
 2150 ID = 0
 2160 IF (G.NE.0.0 .OR. NFSLST.LT.IFSLST) GO TO 2190
C
C     GENERATION OF HARMONIC SPC1-S
C
      DO 2180 I = IFSLST,NFSLST,3
      IF (Z(I) .EQ. -1) GO TO 2180
      CARD(1) = 102
      CARD(2) = 0
      CALL WRITE (SCRT2,CARD,2,NOEOR)
      DO 2170 J = II,NI
      CALL WRITE (SCRT2,Z(I)+500000*Z(J),1,NOEOR)
 2170 CONTINUE
      CALL WRITE (SCRT2,MINUS1,1,NOEOR)
 2180 CONTINUE
      SET102 = .TRUE.
C
C     COMPLETE COPYING OF SPC1 CARDS TO SCRT2 WITH SETID-S .GE. 103
C
 2190 IF (ID .EQ. 0) GO TO 2250
C
C     ADD ID TO LIST IF NOT YET IN
C
      IF (NSPC .LT. ISPC) GO TO 2220
 2200 DO 2210 I = ISPC,NSPC
      IF (ID .EQ. Z(I)) GO TO 2230
 2210 CONTINUE
C
C     ID NOT IN LIST, THUS ADD IT.
C
 2220 NSPC = NSPC + 1
      Z(NSPC) = ID
C
C     CONTINUE COPYING DATA TO NEXT ID
C
 2230 CALL WRITE (SCRT2,ID,1,NOEOR)
 2240 CALL READ  (*2340,*2350,GEOM4,ID,1,NOEOR,FLAG)
      CALL WRITE (SCRT2,ID,1,NOEOR)
      IF (ID .NE. -1) GO TO 2240
      CALL READ  (*2340,*2250,GEOM4,ID,1,NOEOR,FLAG)
      GO TO 2200
C
C     END OF SPC1 CARD IMAGES.
C
 2250 CALL WRITE (SCRT2,0,0,EOR)
C
C     SORT LIST OF SPC AND SPC1 ID-S
C
      CALL SORT (0,0,1,1,Z(ISPC),NSPC-ISPC+1)
C
C     SPCADD WORK (USE MPCADD LOGIC)
C
 2260 TYPE(1) = SPCADD(1)
      TYPE(2) = SPCADD(2)
      IMPC = ISPC
      NMPC = NSPC
      GO TO 1940
C
C     ALL PROCESSING COMPLETE ON GEOM4
C
 2270 CALL IFP4B (GEOM4,SCRT2,ANY,Z(1),CORE,MONES,G4EOF)
C
C     END OF GEOM4 PROCESSING
C     ***********************
C
C     AXIC FILE NOT IN FIST OR AXIF CARD IS MISSING, THUS DO NOTHING.
C
 2300 CALL CLOSE  (AXIC,CLSREW)
      CALL CONMSG (MSG2,2,0)
      RETURN
C
C     FATAL ERROR NO MORE PROCESSING POSSIBLE
C
 2310 NOGO = .TRUE.
      GO TO 2300
C
C     END OF FILE ON AXIC
C
 2320 FILE = AXIC
      GO TO 2340
C
C     END OF RECORD ON AXIC
C
 2330 FILE = AXIC
      GO TO 2350
C
C     END OF FILE OR END OF RECORD ON -FILE-, OR FILE NOT IN FIST.
C
 2340 IER = -2
      GO TO 2390
 2350 IER = -3
      GO TO 2390
 2360 IER = -1
      GO TO 2390
 2370 IER = -8
      FILE = ICRQ
      GO TO 2390
 2380 IER = -37
 2390 CALL MESAGE (IER,FILE,SUBR)
      RETURN
      END

      SUBROUTINE WPLT10 (A,OPT)
C
C     TO WRITE PLOTTER COMMANDS FOR NASTRAN GENERAL PURPOSE PLOTTER
C     REF - NASTRAN PROGRAMMER'S MANUAL P.3.4-111
C
C     REVISED  9/1990 BY G.CHAN/UNISYS
C     SEE SGINO FOR IMPLEMENTATION OF PLT1 FILE
C
C     INPUT -
C        OPT = 0 IF ARRAY A IS A PLOT COMMAND.
C        OPT = 1 IF CURRENT SERIES OF PLOT COMMANDS IS TO BE TERMINATED
C
C     OUTPUT -
C       A(1) = PLOT MODE DIGIT
C       A(2) = CONTROL DIGIT
C       A(3) = X1 = X-COORDINATE
C       A(4) = Y1 = Y-COORDINATE
C       A(5) = X2 = X-COORDINATE
C       A(6) = Y2 = Y-COORDINATE
C
C     A PLT2 FILE PLOTTER COMMAND IS OF THE FOLLOWING FORMAT
C
C         MC1111122222333334444400000000
C            WHERE M = MODE            1 BYTE
C                  C = CONTROL         1 BYTE
C                  1 = DIGIT OF X1     5 BYTES
C                  2 = ..... .. Y1     5 BYTES
C                  3 = ..... .. X2     5 BYTES
C                  4 = ..... .. Y2     5 BYTES
C                  0 = ZERO            8 BYTES
C                              ---------------
C                              TOTAL  30 BYTES
C
C     SEE SGINO FOR PLT1 FILE PLOTTER COMMAND FORMAT
C
C     /PLTDAT/
C     EDGE = SIZE OF THE BORDERS (X,Y) IN PLOTTER UNITS,    REAL - INPUT
C     PLOT = GINO FILE NAME OF THE PLOT TAPE TO BE WRITTEN,  BCD - INPUT
C     MAXCHR = PLOT TAPE BUFFER SIZE (NUMBER OF CHARACTERS), INT - INPUT
C              (AN INTEGER MULTIPLE OF THE NUMBER OF CHARACTERS
C              PER WORD ON THE COMPUTER ON WHICH THE PLOT TAPE IS
C              BEING READ)
C
      IMPLICIT INTEGER (A-Z)
      REAL             EDGE
      INTEGER          A(6),C(30),TEN(5),ZERO(30)
      COMMON /PLTDAT/  SKPPLT(8),EDGE(12),SKPA(10),PLOT,MAXCHR
      EQUIVALENCE      (C1,C(1))
      DATA    NCHR  ,  TEN,PZERO / 0, 10000, 1000, 100, 10, 1, +0 /,
     1        PLT2  ,  NC,ZERO,C / 4HPLT2,   30,   30*0,    30*0  /
C
      IF (PLOT .EQ. PLT2) GO TO 100
C
C     PLT1 FILE - NON BYTE PACKING LOGIC
C     A FORMAT OF (5(2I3,4I5)) IS COMPOSED IN SGINO
C     =============================================
C
      NC = 6
      IF (OPT .NE. 0) GO TO 40
C
C     SET UP THE MODE AND CONTROL CHARACTERS IN THE COMMAND.
C
      C1   = A(1)
      C(2) = A(2)
C
      I3   = IFIX(EDGE(1) + .1)
      I4   = IFIX(EDGE(2) + .1)
      C(3) = A(3) + I3
      C(4) = A(4) + I4
      C(5) = A(5)
      C(6) = A(6)
      IF (C1.EQ.4 .OR. C1.EQ.14) GO TO 20
      C(5) = A(5) + I3
      C(6) = A(6) + I4
   20 CALL SWRITE (PLOT,C,NC,0)
      GO TO 200
C
C     TERMINATE A SET OF PLOT COMMANDS
C     SEND A RECORD OF ALL ZERO-S TO SWRITE
C
   40 CALL SWRITE (PLOT,ZERO,NC,0)
      CALL SWRITE (PLOT,0,0,1)
      GO TO 200
C
C     PLT2 FILE - WITH BYTE PACKING LOGIC
C     A FORMAT OF (10(180A4)) IS COMPOSED IN SGINO
C     ============================================
C
  100 IF (OPT .NE. 0) GO TO 140
C
C     SET UP THE MODE + CONTROL CHARACTERS IN THE COMMAND.
C
      C1   = A(1)
      C(2) = A(2)
C
C     SEPARATE THE DECIMAL DIGITS OF THE X + Y COORDINATES.
C
      DO 110 J = 1,4
      I = 1
      IF (J.EQ.2 .OR. J.EQ.4) I = 2
      N = A(J+2)
      IF (J.LT.3 .OR. (C1.NE.4 .AND. C1.NE.14)) N = N + IFIX(EDGE(I)+.1)
      K = 5*(J-1)
      DO 110 I = 1,5
      M = N/TEN(I)
C
C   . M MAY BE A -0 (UNIVAC), SET IT TO +0 FOR SURE
C
      IF (M .EQ. 0) M = PZERO
      C(K+3) = M
      K = K + 1
      N = N - M*TEN(I)
  110 CONTINUE
C
      CALL SWRITE (PLOT,C,NC,0)
      NCHR = NCHR + NC
      IF (NCHR .EQ. MAXCHR) NCHR = 0
      GO TO 200
C
C     TERMINATE A SET OF PLOT COMMANDS (FILL THE RECORD WITH ZERO-S).
C
  140 IF (NCHR .EQ. 0) GO TO 160
  150 CALL SWRITE (PLOT,ZERO,NC,0)
      NCHR = NCHR + NC
      IF (NCHR .NE. MAXCHR) GO TO 150
      NCHR = 0
  160 CALL SWRITE (PLOT,0,0,1)
C
  200 RETURN
      END

      SUBROUTINE RBMG2
C
      INTEGER          SCR1,    SCR2,    SCR3,    SCR4
      DOUBLE PRECISION DET(2)
      COMMON /BLANK /  JPOWR,   DETRM
      COMMON /SFACT /  QQ(29)
      EQUIVALENCE      (QQ(25), DET(1)), (QQ(29), IPWR)
      DATA    KLL   ,  LLL,     SCR1,    SCR2,    SCR3,    SCR4  /
     1        101   ,  201,     301,     302,     303,     304   /
C
C     DECOMPOSE KLL INTO LLL
C
      CALL FACTOR (KLL,LLL,SCR1,SCR2,SCR3,SCR4)
      JPOWR = IPWR
      DETRM = DET(1)
      RETURN
      END

      SUBROUTINE BUG (NAME,LOC,BUF,NWDS)
C
C     THIS ROUTINE PRINTS NAME,LOC, AND CONTENT OF BUF ARRAY
C     E.G.   CALL BUG ('SUBR ABC',105,CORE(1),120)
C     LIMITED TO 5000 LINES EACH CALL,  14 VALUES PER LINE
C
C     (THIS ROUTINE REPLACES THE OLD ONE IN NASTRAN)
C     WRITTEN BY G.CHAN/SPERRY     MARCH 1986
C
      REAL            BUF(1),   NAME(3)
      CHARACTER*4     A(28),    XLOC,     BLANK
      CHARACTER*8     B(14),    ZERO,     ERR
      COMMON /SYSTEM/ IBUF,     NOUT
      EQUIVALENCE     (A(1),B(1))
      DATA    LINE,   NWPL,     LIMIT              /
     1        0,      14,       5000               /
      DATA    ZERO,   BLANK,    XLOC,     ERR      /
     1        ' 00 ', '    ',   'LOC',    '(ERR)'  /
C
      CALL SSWTCH (20,L)
      IF (L .EQ. 0) RETURN
      GO TO 5
C
      ENTRY BUG1 (NAME,LOC,BUF,NWDS)
C     ==============================
C
 5    IF (NWDS .LT. 0) RETURN
      L = 2
      I = 0
      CALL A42K8 (NAME(1),NAME(2),B(1))
      CALL INT2K8 (*20,LOC,A(3))
      A(4) = A(3)
      A(3) = XLOC
C
 10   IF (I .GE. NWDS) GO TO 60
 15   I = I + 1
      L = L + 1
      J = NUMTYP(BUF(I)) + 1
      GO TO (  25, 30,  35, 40), J
C            ZERO,INT,REAL,BCD
 20   B(L) = ERR
      GO TO 55
 25   B(L) = ZERO
      GO TO 55
 30   CALL INT2K8 (*20,BUF(I),B(L))
      GO TO 55
 35   CALL FP2K8  (*20,BUF(I),B(L))
      GO TO 55
 40   CALL A42K8 (BUF(I),BUF(I+1),B(L))
      IF (NUMTYP(BUF(I+1)) .NE. 3) GO TO 45
      I = I + 1
      GO TO 50
 45   A(L*2) = BLANK
 50   IF (I .GE. NWDS) GO TO 60
 55   IF (L .LT. NWPL) GO TO 10
 60   IF (L .GT. 0) WRITE (NOUT,65) (B(J),J=1,L)
 65   FORMAT (2X,14(A8,1X))
      LINE = LINE + 1
      IF (LINE .GT. LIMIT) GO TO 70
      L = 0
      IF (I .LT. NWDS) GO TO 15
      RETURN
C
 70   WRITE  (NOUT,75) LIMIT
 75   FORMAT (/2X,'PRINT LINES IN BUG EXCEEDS LIMIT OF',I6)
      RETURN
      END

      SUBROUTINE AMGT1T (NLINE,NL,ACPT,NSTNS,C3T,C4T)
C
C     GENERATE CONSTANTS C3T AND C4T FOR
C     STREAMLINE NL OF SWEPT TURBOPROP BLADE.
C
      REAL       L1,L2,L3
      INTEGER    ACPT,FILE,NAME(2)
      DIMENSION  PN(3),P1(3),FN(3),F1(3),S1(3),SN(3),DATA(3)
      DATA FILE/ 102 /, NAME / 4HAMGT,4H1T  /
C
C     INPUT VARIABLES -
C     NLINE      TOTAL NO. OF STREAMLINES
C     NL         PRESENT STEAMLINE
C     ACPT       SCRATCH UNIT WITH BASIC COORDINATES OF NODES
C     NSTNS      TOTAL NO. OF STATIONS
C
C     OUTPUT VARIABLES -
C     C3T        CONSTANTS USED BY SUB. AND SUP. AERODYNAMIC ROUTINES
C     C4T        USED IN DEFINING DATA BLOCK AJJ
C
C     LOCAL VARIABLES -
C     PN         COORDINATES TRAILING EDGE PREVIOUS STREAMLINE
C     P1         COORDINATES LEADING EDGE PREVIOUS STREAMLINE
C     FN         COORDINATES TRAILING EDGE NEXT STREAMLINE
C     F1         COORDINATES LEADING EDGE NEXT STREAMLINE
C     S1         COORDINATES OF LEADING EDGE OF CURRENT STREAMLINE
C     SN         COORDINATES OF TRAILING EDGE OF CURRENT STREAMLINE
C
C     EXTRACT LEADING COORDINATES OF CURRENT STREAMLINE
C
      CALL FREAD (ACPT,DATA,3,0)
      DO 1 I = 1,3
   1  S1(I) = DATA(I)
C
C     SKIP TO TRAILING EDGE COORDINATES OF CURRENT STREAMLINE
C
      NSKIP = (2-NSTNS)*3
      CALL READ (*905,*900,ACPT,DATA,NSKIP,0,MM)
      CALL FREAD (ACPT,DATA,3,0)
      DO 2 I = 1,3
  2   SN(I) = DATA(I)
C
C     EXTRACT COORDINATES FOR PREVIOUS--P-FOR FIRST STREAMLINE
C
      IF (NL .NE. 1) GO TO 10
      DO 5 I = 1,3
      PN(I) = SN(I)
  5   P1(I) = S1(I)
C
C     NOW COORDINATES FOR NEXT -F- FOR LAST STREAMLINE
C
 10   IF (NL .NE. NLINE) GO TO 15
      DO 12 I = 1,3
      FN(I) = SN(I)
 12   F1(I) = S1(I)
      GO TO 50
C
C     NOW COORDINATES FOR NEXT -F- FOR ALL OTHER STREAMLINES
C
C     SKIP FIRST 10 WORDS OF NEXT STREAMLINE
C
 15   CALL READ (*905,*900,ACPT,DATA,-10,0,MM)
      CALL FREAD (ACPT,DATA,3,0)
      F1(1) = DATA(1)
      F1(2) = DATA(2)
      F1(3) = DATA(3)
C
C     COMPUTE SKIP TO TRAILING EDGE COORDINATES
C
      NSKIP = (2-NSTNS)*3
      CALL READ (*905,*900,ACPT,DATA,NSKIP,0,MM)
      CALL FREAD (ACPT,DATA,3,0)
      FN(1) = DATA(1)
      FN(2) = DATA(2)
      FN(3) = DATA(3)
 50   A1 = SN(1) - S1(1)
      B1 = SN(2) - S1(2)
      C1 = SN(3) - S1(3)
C
      A2 = FN(1) - P1(1)
      B2 = FN(2) - P1(2)
      C2 = FN(3) - P1(3)
C
      A3 = PN(1) - F1(1)
      B3 = PN(2) - F1(2)
      C3 = PN(3) - F1(3)
C
      A4 = B2*C1 - B1*C2
      B4 = C2*A1 - C1*A2
      C4 = A2*B1 - A1*B2
C
      A5 = B1*C3 - B3*C1
      B5 = C1*A3 - C3*A1
      C5 = A1*B3 - A3*B1
C
      L1 = SQRT(A1**2 + B1**2 + C1**2)
      L2 = SQRT(A4**2 + B4**2 + C4**2)
      L3 = SQRT(A5**2 + B5**2 + C5**2)
C
      A6 = 0.5*(A4/L2 + A5/L3)
      B6 = 0.5*(B4/L2 + B5/L3)
      C6 = 0.5*(C4/L2 + C5/L3)
C
      A7 = (B1*C6 - B6*C1)/L1
      B7 = (C1*A6 - C6*A1)/L1
      C7 = (A1*B6 - A6*B1)/L1
C
      A8 = F1(1) - P1(1)
      B8 = F1(2) - P1(2)
      C8 = F1(3) - P1(3)
C
      A9 = FN(1) - PN(1)
      B9 = FN(2) - PN(2)
      C9 = FN(3) - PN(3)
C
      W1 = A7*A8 + B7*B8 + C7*C8
      W2 = A7*A9 + B7*B9 + C7*C9
C
      C3T = (W2-W1)/(2.0*L1)
      C4T = W1/2.0
C
      IF (NL .EQ. NLINE) RETURN
C
C     RETURN TO START OF RECORD
C
      CALL BCKREC (ACPT)
C
C     COMPUTE SKIP TO NEXT STREAMLINE AT EXIT FROM THIS ROUTINE
C
      NSKIP = -6 - (10+3*NSTNS)*NL
      CALL READ (*905,*900,ACPT,DATA,NSKIP,0,MM)
C
C     SET PREVIOUS COORDINATES -P- TO PRESENT STREAMLINE COORDINATES
C
      DO 800 I = 1,3
      PN(I) = SN(I)
 800  P1(I) = S1(I)
      RETURN
C
C     E-O-R    ENCOUNTERED
 900  IP1 = -3
      GO TO 999
C
C     E-O-F    ENCOUNTERED
C
 905  IP1 = -2
 999  CALL MESAGE (IP1,FILE,NAME)
      RETURN
      END

      SUBROUTINE TRD1A2 (CASEXX, TRL, IC, NLFTP, NGROUP, MODA1)
C
C     THIS ROUTINE BUILDS THE INITIAL CONDITIONS TABLE, PUTS TSTEP STUFF
C      IN CORE AND EXTRACTS THE NLFTP POINTER
C
C     THIS ROUTINE IS SUITABLE FOR DOUBLE PRECISION OPERATION
C
      DOUBLE PRECISION   Z
C
      INTEGER            SYSBUF    ,CASEXX   ,TRL      ,
     1                   IZ(160)     ,MCB(7)   ,FILE     ,NAME(2)  ,
     1                   INTRL(2)
C
      REAL               RZ(3)
C
      COMMON   /SYSTEM/  SYSBUF
      COMMON   /PACKX /  IT1       ,IT2      ,II       ,JJ       ,
     1                   INCR
      COMMON   /ZZZZZZ /  Z(1)
C
      EQUIVALENCE        (Z(1)     ,RZ(1)    ,IZ(1)    )
C
      DATA               NAME                ,INTRL              /
     1                   4HTRD1    ,4HA2     ,4HTRL    ,4HTRD    /
C
C     IDENTIFICATION VARIABLES
C
C     NGROUP        NUMBER OF CHANGES OF TIME STEP
C
C     ITSTEP        SELECTED TSTEP ID
C
C     NLFTP         SELECTED NON-LINEAR LOAD ID
C
C     ICP           SELECTED INITIAL CONDITION ID
C
C     LUD           LENGTH OF INITIAL CONDITION--D SET
C
C     IGROUP        POINTER TO TSTEP STUFF
C
C ----------------------------------------------------------------------
C
C     INITIALIZE
C
      IT1 = 2
      IT2 = 2
      II=1
      INCR =1
      NZ = KORSZ (Z)
      NX=NZ
C
C     PICK UP AND STORE CASECC POINTERS
C
      IBUF1 = NZ -SYSBUF +1
      CALL GOPEN(CASEXX,IZ(IBUF1),0)
      CALL FREAD(CASEXX,IZ,166,1)
      CALL CLOSE(CASEXX,1)
      ITSTEP = IZ(38)
      ICP    = IZ(9)
      NLFTP  = IZ(160)
      IF(ICP .NE. 0 .AND. MODA1 .EQ. 1) GO TO 920
C
C     BUILD INITIAL CONDITION FILE
C
      CALL GOPEN(IC,IZ(IBUF1),1)
      IBUF2 = IBUF1-SYSBUF
      NZ = NZ - 2*SYSBUF
      ICRQ = -NZ
      IF(ICRQ.GT.0) GO TO 980
      FILE =TRL
      CALL OPEN(*900,TRL,IZ(IBUF2),0)
      CALL READ(*910,*10,TRL,IZ(1),NZ,0,IFLAG)
      ICRQ = NZ
      GO TO 980
   10 LUD = IZ(IFLAG)
      JJ  = LUD
      ICRQ = 4*LUD + 1 - NZ
      IF(ICRQ.GT.0) GO TO 980
      L = IZ(3)
      ITRL = L
C
C     ZERO I. C.
C
      IVEL = (IBUF2 - 2*LUD - 1)/2
      IDISP = IVEL - 2*LUD
      DO 20 I =1,LUD
      K = IVEL +I
      Z(K) = 0.0D0
      K = IDISP +I
      Z(K) = 0.0D0
   20 CONTINUE
      CALL MAKMCB (MCB, IC, LUD, 2, 2)
      IF ( ICP .EQ. 0) GO TO 80
      IF(  IZ(3) .EQ. 0) GO TO 40
      IFLAG = IFLAG-1
      DO 30  I= 4,IFLAG
      IF ( IZ(I) .EQ. ICP) GO TO 50
   30 CONTINUE
   40 ITSTEP = ICP
      GO TO 940
   50 K =I-4
      L = IFLAG -I
      CALL SKPREC(TRL,K)
   70 CALL READ(*910,*80,TRL,IZ(1),3,0,IFLAG)
      K = IZ(1) +IDISP
      Z(K) = Z(K) + RZ(2)
      K = IZ(1) + IVEL
      Z(K) = Z(K) + RZ(3)
      GO TO 70
   80 CALL PACK(Z(IDISP+1),IC,MCB)
      CALL PACK(Z(IVEL +1),IC,MCB)
      CALL CLOSE(IC,1)
      CALL WRTTRL(MCB)
      CALL SKPREC(TRL,L)
C
C     BRING TSTEP STUFF INTO CORE
C
  100 ITRL = ITRL +1
      CALL READ(*940,*110,TRL,IZ(1),NZ,0,IFLAG)
      ICRQ = NZ
      GO TO 980
  110 IF ( IZ(1) .NE. ITSTEP) GO TO 100
C
C     TSTEP CARD FOUND
C
      CALL CLOSE(TRL,1)
      NGROUP =(IFLAG-1)/3
C
C     MOVE TSTEP STUFF TO BOTTOM OF CORE
C
      NZ = NX - IFLAG +1
      IGROUP = NZ+1
      DO 120 I=2,IFLAG
      K = IGROUP +I-2
      IZ(K) = IZ(I)
  120 CONTINUE
      RETURN
C
C     ERROR MESSAGES
C
  900 IP1=-1
  901 CALL MESAGE(IP1,FILE,NAME)
      RETURN
  910 IP1=-2
      GO TO 901
  920 IP1 = -51
      FILE = ICP
      GO TO 901
  940 CALL MESAGE(-31,ITSTEP,INTRL)
      RETURN
  980 IP1 = -8
      FILE = ICRQ
      GO TO 901
      END

      SUBROUTINE TLODT1 (TREAL,TINT)
C
C     THERMAL LOAD VECTOR FOR TRPLT1 (HIGHER ORDER PLATE BENDING ELEMENT
C
C     ECPT ENTRIES
C     AS IN STIFFNESS ROUTINE KTRPL1
C
      LOGICAL         NOGO,NOTS,UNIBEN,UNITEM
      INTEGER         XPOWER(20),YPOWER(20),XTHK(10),YTHK(10),PT(3),
     1                QT(3),SIL(6),SIL1,TINT(6)
      REAL            IVECT,JVECT,KVECT
      DIMENSION       F(10,10),XC(6),YC(6),ZC(6),QQQ(20,20),QQINV(360),
     1                TS1(60),TS2(60),IEST(42),TREAL(6),TRAND(9),DD(3),
     2                ICS(6),GE1(9),NAM(2)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /SSGWRK/ X,Y,Z,DISTA,DISTB,DISTC,A1,A2,A3,B1,B2,B3,G1(3),
     1                D(3),E(18),IVECT(3),JVECT(3),KVECT(3),CC(10),G(9),
     2                PTEM(20),PTELE(18),PTGLB(36),PSUB(3),PSUBT(6),
     3                PSUBT1(6),TS6(40),NAME(2),INDEX(20,3),NL(6),TL(3),
     4                BALOTR(36)
      COMMON /SYSTEM/ SYSBUF,IOUT
      COMMON /TRIMEX/ EST(100)
      COMMON /ZZZZZZ/ PG(1)
C
C     INPUT AND OUTPUT BLOCKS FOR SUBROUTINE MAT
C
      COMMON /MATIN / MATID,MATFLG,ELTEMP,PLA34,SINTH,COSTH
      COMMON /MATOUT/ EM(6),RHOY,ALF(3),TREF,GSUBE,SIGTY,SIGCY,SIGSY,
     1                RJ11,RJ12,RJ22
C
C     EQUIVALENCE IECPT WITH ECPT IN COMMON BLOCK /SMA1ET/ SINCE ECPT IS
C     A MIXED INTEGER AND REAL ARRAY
C
      EQUIVALENCE     (THK1,TMEM1),(THK2,TMEM3),(THK3,TMEM5),
     1                (A,DISTA),(B,DISTB),(C,DISTC),(IEST(1),EST(1)),
     2                (C1,CC(1)),(C2,CC(2)),(C3,CC(3)),(C4,CC(4)),
     3                (C5,CC(5)),(C6,CC(6)),(C7,CC(7)),(C8,CC(8)),
     4                (C9,CC(9)),(C10,CC(10)),(D(1),D1),(D(2),D2),
     5                (D(3),D3),(DD(1),D(1))
      DATA    BLANK , NAM  / 4H    , 4HTRPL, 4HT1    /
      DATA    XPOWER/ 0,1,0,2,1,0,3,2,1,0,4,3,2,1,0,5,3,2,1,0/
      DATA    YPOWER/ 0,0,1,0,1,2,0,1,2,3,0,1,2,3,4,0,2,3,4,5/
      DATA    XTHK  / 0,1,0,2,1,0,3,2,1,0 /
      DATA    YTHK  / 0,0,1,0,1,2,0,1,2,3 /
      DATA    PT    / 0,1,0 /,  QT / 0,0,1/
      DATA    DEGRA / 0.0174532925 /
C
C
      NOTS  = .FALSE.
      IDELE = IEST(1)
      DO 109 I = 1,6
      NL(I) = IEST(I+1)
  109 CONTINUE
      THETAM = EST(8)
      MATID1 = IEST(9)
      TMEM1  = (EST(10)*12.0)**0.333333333333
      TMEM3  = (EST(11)*12.0)**0.333333333333
      TMEM5  = (EST(12)*12.0)**0.333333333333
      TSHR1  = EST(14)
      TSHR3  = EST(15)
      TSHR5  = EST(16)
      J      = 0
      DO 120 I = 24,44,4
      J      = J + 1
      ICS(J) = IEST(I)
      XC(J)  = EST(I+1)
      YC(J)  = EST(I+2)
      ZC(J)  = EST(I+3)
  120 CONTINUE
      TEMP1  = TREAL(1)
      TEMP3  = TREAL(1)
      TEMP5  = TREAL(1)
      T1PRIM =-TREAL(2)
      T3PRIM =-TREAL(2)
      T5PRIM =-TREAL(2)
C
C     IF TMEM3 OR TMEM5 EQUAL TO ZERO OR BLANK,THEY WILL BE SET EQUAL TO
C     SO ALSO FOR TEMP3 AND TEMP5
C
      IF (TMEM3.EQ.0.0 .OR. TMEM3 .EQ.BLANK) TMEM3  = TMEM1
      IF (TMEM5.EQ.0.0 .OR. TMEM5 .EQ.BLANK) TMEM5  = TMEM1
      IF (TEMP3.EQ.0.0 .OR. TEMP3 .EQ.BLANK) TEMP3  = TEMP1
      IF (TEMP5.EQ.0.0 .OR. TEMP5 .EQ.BLANK) TEMP5  = TEMP1
      IF (T3PRIM.EQ..0 .OR. T3PRIM.EQ.BLANK) T3PRIM = T1PRIM
      IF (T5PRIM.EQ..0 .OR. T5PRIM.EQ.BLANK) T5PRIM = T1PRIM
      IF (TSHR3.EQ.0.0 .OR. TSHR3 .EQ.BLANK) TSHR3  = TSHR1
      IF (TSHR5.EQ.0.0 .OR. TSHR5 .EQ.BLANK) TSHR5  = TSHR1
      ELTEMP = EST(48)
      AVTHK  = (TMEM1+TMEM3+TMEM5)/3.0
      AVINER = AVTHK**3/12.0
      IF (TSHR1 .EQ. 0.0) NOTS = .TRUE.
      THETA1 = THETAM*DEGRA
      SINTH  = SIN(THETA1)
      COSTH  = COS(THETA1)
      IF (ABS(SINTH) .LE. 1.0E-06) SINTH = 0.0
C
C     EVALUATE MATERIAL PROPERTIES
C
      MATFLG = 2
      MATID = MATID1
      CALL MAT (IDELE)
C
      G(1) = EM(1)
      G(2) = EM(2)
      G(3) = EM(3)
      G(4) = EM(2)
      G(5) = EM(4)
      G(6) = EM(5)
      G(7) = EM(3)
      G(8) = EM(5)
      G(9) = EM(6)
C
C     IF TINT(6).NE.1,G1 IS G AND T1PRIME IS ALPHA TIMES T1PRIME
C     IF TINT(6).EQ.1,G1 IS G TIMES ALPHA AND T1PRIME IS T1PRIME
C
      IF (TINT(6) .NE. 1) GO TO 147
C
C     G1 IS G TIMES ALPHA
C
      CALL GMMATS (G,3,3,0, ALF,3,1,0, G1)
      GO TO 149
  147 CONTINUE
      DO 148 I = 1,9
  148 GE1(I) = G(I)*AVINER
C
C     NO NEED TO COMPUTE DETERMINANT SINCE IT IS NOT USED SUBSEQUENTLY.
C
      ISING = -1
      CALL INVERS (3,GE1(1),3,TS1(1),0,DETERM,ISING,INDEX)
      IF (ISING .EQ. 2) GO TO 901
      CALL GMMATS (GE1,3,3,0, TREAL(2),3,1,0, TL(1))
C
C     CALCULATIONS FOR THE TRIANGLE
C
  149 CALL TRIF (XC,YC,ZC,IVECT,JVECT,KVECT,A,B,C,IEST(1),NAM )
C
C     FILL E-MATRIX
C
      DO 177 I = 1,18
  177 E( I) = 0.0
      E( 1) = KVECT(1)
      E( 4) = KVECT(2)
      E( 7) = KVECT(3)
      E(11) = IVECT(1)
      E(14) = IVECT(2)
      E(17) = IVECT(3)
      E(12) = JVECT(1)
      E(15) = JVECT(2)
      E(18) = JVECT(3)
C
C     EVALUATE CONSTANTS D1,D2,D3 IN THE LINEAR EQUATION FOR TEMPERATURE
C     GRADIENT VARIATION OVER THE ELEMENT
C
      CALL AF (F,10,A,B,C,D1,D2,D3,THK1,THK2,THK3,1)
      UNITEM = .FALSE.
      IF (ABS(D2).LE.1.0E-06 .AND. ABS(D3).LE.1.0E-06) UNITEM =.TRUE.
C
      DISTAB = DISTA + DISTB
      A1   = (THK1*DISTA+THK2*DISTB)/DISTAB
      A2   = (THK2-THK1)/DISTAB
      A3   = (THK3-A1)/DISTC
      A1SQ = A1*A1
      A2SQ = A2*A2
      A3SQ = A3*A3
      C1   = A1SQ*A1
      C2   = 3.0*A1SQ*A2
      C3   = 3.0*A1SQ*A3
      C4   = 3.0*A1*A2SQ
      C5   = 6.0*A1*A2*A3
      C6   = 3.0*A3SQ*A1
      C7   = A2SQ*A2
      C8   = 3.0*A2SQ*A3
      C9   = 3.0*A2*A3SQ
      C10  = A3*A3SQ
      CALL AF (F,10,A,B,C,B1,B2,B3,TSHR1,TSHR3,TSHR5,1)
      UNIBEN =.FALSE.
      IF (ABS(A2).LE.1.0E-06 .AND. ABS(A3).LE.1.0E-06) UNIBEN =.TRUE.
C
C     COMPUTE THE AREA INTEGRATION FUNCTION F
C
      CALL AF (F,10,A,B,C,0,0,0,0,0,0,-1)
C
C     CALCULATIONS FOR QMATRIX (QQQ) AND ITS INVERSE
C
      DO 110 I = 1,400
  110 QQQ(I,1) = 0.0
      DO 115 I = 1,6
      I1 = (I-1)*3 + 1
      I2 = (I-1)*3 + 2
      I3 = (I-1)*3 + 3
      QQQ(I1, 1) = 1.0
      QQQ(I1, 2) = XC(I)
      QQQ(I1, 3) = YC(I)
      QQQ(I1, 4) = XC(I)*XC(I)
      QQQ(I1, 5) = XC(I)*YC(I)
      QQQ(I1, 6) = YC(I)*YC(I)
      QQQ(I1, 7) = QQQ(I1, 4)*XC(I)
      QQQ(I1, 8) = QQQ(I1, 4)*YC(I)
      QQQ(I1, 9) = QQQ(I1, 5)*YC(I)
      QQQ(I1,10) = QQQ(I1, 6)*YC(I)
      QQQ(I1,11) = QQQ(I1, 7)*XC(I)
      QQQ(I1,12) = QQQ(I1, 7)*YC(I)
      QQQ(I1,13) = QQQ(I1, 8)*YC(I)
      QQQ(I1,14) = QQQ(I1, 9)*YC(I)
      QQQ(I1,15) = QQQ(I1,10)*YC(I)
      QQQ(I1,16) = QQQ(I1,11)*XC(I)
      QQQ(I1,17) = QQQ(I1,12)*YC(I)
      QQQ(I1,18) = QQQ(I1,13)*YC(I)
      QQQ(I1,19) = QQQ(I1,14)*YC(I)
      QQQ(I1,20) = QQQ(I1,15)*YC(I)
      QQQ(I2, 3) = 1.0
      QQQ(I2, 5) = XC(I)
      QQQ(I2, 6) = YC(I)*2.0
      QQQ(I2, 8) = QQQ(I1, 4)
      QQQ(I2, 9) = QQQ(I1, 5)*2.0
      QQQ(I2,10) = QQQ(I1, 6)*3.0
      QQQ(I2,12) = QQQ(I1, 7)
      QQQ(I2,13) = QQQ(I1, 8)*2.0
      QQQ(I2,14) = QQQ(I1, 9)*3.0
      QQQ(I2,15) = QQQ(I1,10)*4.0
      QQQ(I2,17) = QQQ(I1,12)*2.0
      QQQ(I2,18) = QQQ(I1,13)*3.0
      QQQ(I2,19) = QQQ(I1,14)*4.0
      QQQ(I2,20) = QQQ(I1,15)*5.0
      QQQ(I3, 2) =-1.0
      QQQ(I3, 4) =-2.0*XC(I)
      QQQ(I3, 5) =-YC(I)
      QQQ(I3, 7) =-QQQ(I1, 4)*3.0
      QQQ(I3, 8) =-QQQ(I1, 5)*2.0
      QQQ(I3, 9) =-QQQ(I1, 6)
      QQQ(I3,11) =-QQQ(I1, 7)*4.0
      QQQ(I3,12) =-QQQ(I1, 8)*3.0
      QQQ(I3,13) =-QQQ(I1, 9)*2.0
      QQQ(I3,14) =-QQQ(I1,10)
      QQQ(I3,16) =-QQQ(I1,11)*5.0
      QQQ(I3,17) =-QQQ(I1,13)*3.0
      QQQ(I3,18) =-QQQ(I1,14)*2.0
      QQQ(I3,19) =-QQQ(I1,15)
C
C     IF NO TRANSVERSE SHEAR GO TO 113
C
      IF (NOTS) GO TO 115
      X = XC(I)
      Y = YC(I)
      CALL TLODT3 (TS6,NOTS)
      DO 113 JJ = 1,20
      QQQ(I2,JJ) = QQQ(I2,JJ) - TS6(20+JJ)
      QQQ(I3,JJ) = QQQ(I3,JJ) + TS6(   JJ)
  113 CONTINUE
  115 CONTINUE
C
      QQQ(19,16) = 5.0*A**4*C
      QQQ(19,17) = 3.0*A**2*C**3 - 2.0*A**4*C
      QQQ(19,18) =-2.0*A*C**4 + 3.0*A**3*C**2
      QQQ(19,19) = C**5 - 4.0*A**2*C**3
      QQQ(19,20) = 5.0*A*C**4
      QQQ(20,16) = 5.0*B**4*C
      QQQ(20,17) = 3.0*B**2*C**3 - 2.0*B**4*C
      QQQ(20,18) = 2.0*B*C**4 - 3.0*B**3*C**2
      QQQ(20,19) = C**5 - 4.0*B**2*C**3
      QQQ(20,20) =-5.0*B*C**4
C
C     FOURTH ARGUMENT IS A DUMMY LOCATION FOR INVERSE AND HENCE TS1(1)
C     IS U
C
C     AGAIN SET ISING = -1
C
      ISING = -1
      CALL  INVERS (20,QQQ,20,TS1(1),0,DETERM,ISING,INDEX)
C
C     ISING EQUAL TO 2 IMPLIES THAT QQQ IS SINGULAR
C
C     FIRST 18 COLUMNS OF QQQ INVERSE IS THE QQQINV FOR USE IN STIFFNESS
C     MATRIX CALCULATIONS
C
      DO 152 I = 1,20
      DO 152 J = 1,18
      IJ = (I-1)*18 + J
      QQINV (IJ) = QQQ(I,J)
  152 CONTINUE
C
      DO 220 I = 1,20
      MX   = XPOWER(I)
      RMX  = MX
      NX   = YPOWER(I)
      RNX  = NX
      RMNX = RMX*RNX
      RMX1 = RMX*(RMX-1.0D0)
      RNX1 = RNX*(RNX-1.0D0)
      PTEMP= 0.0
      MX01 = MX - 1
      MX1  = MX + 1
      NX01 = NX - 1
      NX1  = NX + 1
      DO 215 K = 1,10
      MX01X= MX01+ XTHK(K)
      NX1Y = NX1 + YTHK(K)
      MX1X = MX1 + XTHK(K)
      NX01Y= NX01+ YTHK(K)
      MXX  = MX  + XTHK(K)
      NXY  = NX  + YTHK(K)
      IF (TINT(6) .NE. 1) GO TO 213
      DO 212 L = 1,3
      MX01XP= MX01X+ PT(L)
      NX1YQ = NX1Y + QT(L)
      MX1XP = MX1X + PT(L)
      NX01YQ= NX01Y+ QT(L)
      MXXP  = MXX  + PT(L)
      NXYQ  = NXY  + QT(L)
      IF (MX01XP.GT.0 .AND. NX1YQ.GT.0)
     1    PTEMP = PTEMP+CC(K)*DD(L)*G1(1)*RMX1*F(MX01XP,NX1YQ)
      IF (MX1XP.GT.0 .AND. NX01YQ.GT.0)
     1    PTEMP = PTEMP+CC(K)*DD(L)*G1(2)*RNX1*F(MX1XP,NX01YQ)
      IF (MXXP.GT.0 .AND. NXYQ.GT.0)
     1    PTEMP = PTEMP+CC(K)*DD(L)*G1(3)*RMNX*F(MXXP,NXYQ)
      IF (UNITEM) GO TO 213
  212 CONTINUE
C
  213 IF (TINT(6) .EQ. 1) GO TO 214
      IF (MX01X .GT. 0) PTEMP = PTEMP + CC(K)*RMX1*(TL(1)*G(1)
     1                        + TL(2)*G(2) + TL(3)*G(3))*F(MX01X,NX1Y)
      IF (NX01Y .GT. 0) PTEMP = PTEMP + CC(K)*RNX1*(TL(1)*G(4)
     1                        + TL(2)*G(5) + TL(3)*G(6))*F(MX1X,NX01Y)
      IF (MXX.GT.0 .AND. NXY.GT.0) PTEMP = PTEMP + CC(K)*RMNX*
     1                   (TL(1)*G(7)+TL(2)*G(8)+TL(3)*G(9))*F(MXX,NXY)
  214 IF (UNIBEN) GO TO 216
  215 CONTINUE
C
  216 PTEM(I) = PTEMP/12.0
  220 CONTINUE
C
C     IF NO TRANSVERSE SHEAR GO TO 230
C
C     IF TSHR EQUAL TO ZERO OR MATID3 EQUAL TO ZERO, SKIP THESE
C     CALCULATIONS
C
      IF (NOTS) GO TO 230
C
      CALL TLODT2 (TS1,TS2)
      DO 226 I = 1,20
      PTEM(I) = PTEM(I) + TS2(I)
  226 CONTINUE
C
C     (QQQINV) TRANSPOSE (KTR3)  (QQQINV)
C
  230 CALL  GMMATS (QQINV,20,18,+1, PTEM,20,1,0, PTELE)
C
C     LOCATE THE TRANSFORMATION MATRICES FROM BASIC TO LOCAL (THAT IS
C     COORDINATE AT ANY GRID POINT IN WHICH DISPLACEMENT AND STRESSES
C     ARE R - NOT NEEDED IF FIELD 7 IN GRID CARD IS ZERO)
C
      DO 301 I = 1,36
      PTGLB(I) = 0.0
  301 CONTINUE
      DO 302 I = 1,6
      SIL(I) = I
  302 CONTINUE
      DO 380 I = 1,6
      DO 310 II = 1,36
      BALOTR(II) = 0.0D0
  310 CONTINUE
      SIL1 = SIL(I)
      DO 304 K = 1,3
      K1 = (SIL1-1)*3 + K
      PSUB(K) = PTELE(K1)
  304 CONTINUE
      CALL GMMATS (E,6,3,0, PSUB,3,1,0, PSUBT)
C
C     TRANSFORM THE PSUBT(6) FROM BASIC TO DISPLACEMENT COORDINATES
C
      IF (NL(I).EQ.0 .OR. ICS(I).EQ.0) GO TO 330
      JJ = 4*I + 20
      CALL TRANSS (IEST(JJ),TRAND)
      DO 320 JJ = 1,3
      L = 6*(JJ-1) + 1
      M = 3*(JJ-1) + 1
      BALOTR(L   ) = TRAND(M  )
      BALOTR(L+1 ) = TRAND(M+1)
      BALOTR(L+2 ) = TRAND(M+2)
      BALOTR(L+21) = TRAND(M  )
      BALOTR(L+22) = TRAND(M+1)
      BALOTR(L+23) = TRAND(M+2)
  320 CONTINUE
      CALL GMMATS (BALOTR(1),6,6,1, PSUBT,6,1,0, PSUBT1)
      DO 350 K = 1,6
      PSUBT(K) = PSUBT1(K)
  350 CONTINUE
C
C     INSERT PTGLB IN PG
C
  330 DO 370 II = 1,6
      I1 = (I-1)*6 + II
      I2 = IEST(I+1) + II - 1
      PTGLB(I1) = PSUBT(II)
      PG(I2) = PG(I2) + PSUBT(II)
  370 CONTINUE
  380 CONTINUE
      GO TO 999
C
  901 WRITE  (IOUT,905) UFM,IEST(1)
  905 FORMAT (A23,' 2412, A SINGULAR MATERIAL MATRIX FOR ELEMENT ID =',
     1       I9,' HAS BEEN DETECTED BY SUBROUTINE TLODT1', /26X,'WHILE',
     2       ' TRYING TO COMPUTE THERMAL LOADS WITH TEMPP2 CARD DATA.')
      NOGO=.TRUE.
  999 RETURN
      END

      SUBROUTINE DPD1
C
C     DPD1 GENERATES THE GRID POINT LIST-DYNAMICS (GPLD),
C     USET-DYNAMICS (USETD), AND THE SCALAR INDEX LIST-DYNAMICS(SILD).
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        ANDF  ,ORF
      LOGICAL         NODYN ,FIRST
      DIMENSION       BUF(24)  ,EPOINT(2) ,SEQEP(2)     ,MCB(7)       ,
     1                NAM(2)   ,LOADS(32) ,DLOAD(2)     ,FREQ1(2)     ,
     2                FREQ(2)  ,NOLIN(21) ,TIC(2)       ,
     3                TSTEP(2) ,TF(2)     ,PSD(2)       ,MSG(3)       ,
     4                EIGR(2)  ,EIGB(2)   ,EIGC(2)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /BLANK / LUSET ,LUSETD,NOTFL ,NODLT ,NOPSDL,NOFRL ,NONLFT,
     1                NOTRL ,NOEED ,NOSDT ,NBREP
      COMMON /NAMES / RD    ,RDREW ,WRT   ,WRTREW,CLSREW
      COMMON /DPDCOM/ DPOOL ,GPL   ,SIL   ,USET  ,GPLD  ,SILD  ,USETD ,
     1                DLT   ,FRL   ,NLFT  ,TFL   ,TRL   ,PSDL  ,EED   ,
     2                SCR1  ,SCR2  ,SCR3  ,SCR4  ,BUF   ,BUF1  ,BUF2  ,
     3                BUF3  ,BUF4  ,EPOINT,SEQEP ,L     ,KN    ,NEQDYN,
     4                LOADS ,DLOAD ,FREQ1 ,FREQ  ,NOLIN ,NOGO  ,
     5                MSG   ,TIC   ,TSTEP ,TF    ,PSD   ,EIGR  ,EIGB  ,
     6                EIGC  ,MCB   ,NAM   ,EQDYN ,SDT   ,INEQ
      COMMON /BITPOS/ UM    ,UO    ,UR    ,USG   ,USB   ,UL    ,UA    ,
     1                UF    ,US    ,UN    ,UG    ,UE    ,UP    ,UNE   ,
     2                UFE   ,UD
      COMMON /ZZZZZZ/ Z(1)
      COMMON /TWO   / TWO(32)
      COMMON /SYSTEM/ SYSBUF,IOUT  ,KS(37),NBPW
      EQUIVALENCE     (MSG(2),NGRID)
C
C
C     SET NODYN FLAG TO TRUE IF NO DYNAMIC
C
      NODYN  = .FALSE.
      BUF(1) =  DPOOL
      CALL RDTRL (BUF)
      IF (BUF(1) .NE. DPOOL) NODYN = .TRUE.
C
C     COMPUTE MAXIMUM EPOINT SIZE ALLOWED BY A COMPUTER WORD
C
      FIRST = .TRUE.
      IF (NODYN) GO TO 1020
      IMAX = 100000000
      IF (NBPW .EQ. 32) IMAX =  2147493
      IF (NBPW .EQ. 36) IMAX = 34359738
C         2147493=2**31/1000   34359738=2**35/1000
      MAXZ = IMAX
      MULT = 1000
C
C     READ SECOND RECORD OF THE GPL INTO CORE. CREATE TABLE OF TRIPLES -
C     EXTERNAL GRID NO., SEQ. NO., AND INTERNAL GRID NO.
C
C     SEQ.NO.= EXTERNAL GIRD NO. * MULT, OR RESEQUENCED GRID PT. NO.
C     (A MULTIFICATION FACTOR WAS SAVED IN GPL HEADER RECORD BY GP1,
C      MULT = 10,100,OR 1000,  AND BY SGEN, MULT = 1000)
C
 1020 FILE = GPL
      IF (LUSET .EQ. 0) GO TO 1023
      CALL OPEN (*1023,GPL,Z(BUF1),RDREW)
      CALL READ (*2002,*2001,GPL,Z(1),3,1,FALG)
      CALL FWDREC (*2002,GPL)
      I = 3
      MULT = Z(I)
      IMAX = (IMAX/MULT)*1000
      MAXZ = IMAX
      IGPL = 1
      J = 1
      I = IGPL
 1021 CALL READ (*2002,*1022,GPL,Z(I),2,0,FLAG)
      Z(I+2) = J
      I = I + 3
      J = J + 1
      GO TO 1021
 1022 NGPL = I - 3
      CALL CLOSE (GPL,CLSREW)
      GO TO 1030
C
C     INITIALIZE FOR CASE WHERE NO GRID OR SCALAR PTS EXIST.
C
 1023 I = 1
      IGPL  = 1
      LUSET = 0
C
C     READ EXTRA POINTS (IF ANY). ADD TO TABLE IN CORE.
C     SET INTERNAL GRID NO. OF EXTRA PTS = 0.
C
 1030 IF (NODYN) GO TO 1047
      FILE = DPOOL
      CALL PRELOC (*2001,Z(BUF1),DPOOL)
      IEP  = I
      NOEP = 0
      CALL LOCATE (*1045,Z(BUF1),EPOINT,FLAG)
      NOEP = 1
 1031 CALL READ (*2002,*1032,DPOOL,Z(I),1,0,FLAG)
      IF (Z(I) .GT. MAXZ) MAXZ = Z(I)
      Z(I+1) = MULT*Z(I)
      Z(I+2) = 0
      I = I + 3
      GO TO 1031
 1032 NEP  = I - 3
      NGPL = NEP
C
C     ONE OR MORE EPOINT WITH VERY LARGE EXTERNAL ID
C     FATAL IF MULTIPLIER IS 10
C     IF MULT IS 1000 OR 100, TRY TO SHRINK THE GRID POINT SEQ. NO. BY
C     10 OR 100 IF POSSIBLE, AND RESET MULT.
C     IF IT IS NOT POSSIBLE, WE HAVE A FATAL CONDITION 2140C
C
      IF (MAXZ .EQ. IMAX) GO TO 1040
      J = 0
      IF (MULT .EQ.   10) GO TO 1037
      MULT = 100
      IF (MAXZ .GT. 10*IMAX) MULT = 10
      IMAX = (IMAX/MULT)*1000
      J = 1000/MULT
      DO 1035 I = IGPL,NEP,3
      IF (MOD(Z(I+1),J) .NE. 0) GO TO 1037
      Z(I+1) = Z(I+1)/J
 1035 CONTINUE
      GO TO 1040
 1037 WRITE  (IOUT,1038) UFM
 1038 FORMAT (A23,' 2140C, ONE OR MORE EPOINTS WITH  EXTERNAL ID TOO ',
     1       'LARGE.')
      IF (J .NE. 0) WRITE (IOUT,1039)
 1039 FORMAT (/5X,'SUGGESTION - RE-RUN NASTRAN JOB WITH ALL THE EPOINT',
     1        ' EXTERNAL ID''S SMALLER THAN THE LARGEST GRID POINT ID',
     2        /5X,'OR, REDUCE THE SEQID LEVEL IF SEQGP CARDS WERE USED',
     3        '.  I.E. FROM XXX.X.X TO XXX.X OR XXX')
      CALL CLOSE (DPOOL,CLSREW)
      CALL MESAGE (-37,0,NAM)
C
C     IF EXTRA POINTS PRESENT, READ SEQEP DATA (IF ANY).
C     REPLACE OLD SEQ NO WITH NEW SEQ NO.
C
 1040 CALL LOCATE (*1045,Z(BUF1),SEQEP,FLAG)
      N1 = I
      N2 = N1 + 1
      IFAIL = 0
 2010 CALL READ (*2002,*2020,DPOOL,Z(N2),BUF1-1,1,FLAG)
      IFAIL = IFAIL + 1
      GO TO 2010
 2020 IF (IFAIL .EQ. 0) GO TO 2060
      NWDS = (IFAIL-1)*(BUF1-1) + FLAG
      WRITE  (IOUT,2040) UFM,NWDS
 2040 FORMAT (A23,' 3139, UNABLE TO PROCESS SEQEP DATA IN SUBROUTINE ',
     1       'DPD1 DUE TO INSUFFICIENT CORE.', //5X,
     2       'ADDITIONAL CORE REQUIRED =',I10,7H  WORDS)
      CALL MESAGE (-61,0,0)
C
C     CHECK FOR MULTIPLE REFERENCES TO EXTRA POINT ID NOS. AND
C     SEQUENCE ID NOS. ON SEQEP CARDS
C
 2060 K  = N2
      KK = N2 + FLAG - 1
      JJ = KK - 2
 2080 DO 2285 I = K,JJ,2
      IF (Z(I).LT.0 .OR. I.GE.KK) GO TO 2275
      II = I + 2
      IFAIL = 0
      DO 2270 J = II,KK,2
      IF (Z(I) .NE. Z(J)) GO TO 2270
      IF (IFAIL .NE.   0) GO TO 2260
      IFAIL = 1
      NOGO  = 1
      IF (K .NE. N2) GO TO 2110
      WRITE  (IOUT,2100) UFM,Z(I)
 2100 FORMAT (A23,' 3140, MULTIPLE REFERENCES TO EXTRA POINT ID NO.',I9,
     1       ' ON SEQEP CARDS.')
      GO TO 2260
 2110 IDSEQ1 = Z(I)/1000
      IRMNDR = Z(I) - 1000*IDSEQ1
      IF (IRMNDR.NE.0 .AND. MULT.GE.10) GO TO 2140
      WRITE  (IOUT,2120) UFM,IDSEQ1
 2120 FORMAT (A23,' 3141, MULTIPLE REFERENCES TO SEQUENCE ID NO.',I6,6X,
     1       'ON SEQEP CARDS.')
      GO TO 2260
 2140 IDSEQ2 = IRMNDR/100
      IRMNDR = IRMNDR - 100*IDSEQ2
      IF (IRMNDR.NE.0 .AND. MULT.GE.100) GO TO 2180
      WRITE  (IOUT,2160) UFM,IDSEQ1,IDSEQ2
 2160 FORMAT (A23,' 3141, MULTIPLE REFERENCES TO SEQUENCE ID NO.',I6,
     1       1H.,I1,6X,'ON SEQEP CARDS.')
      GO TO 2260
 2180 IDSEQ3 = IRMNDR/10
      IRMNDR = IRMNDR - 10*IDSEQ3
      IF (IRMNDR .NE. 0) GO TO 2220
      WRITE  (IOUT,2200) UFM,IDSEQ1,IDSEQ2,IDSEQ3
 2200 FORMAT (A23,' 3141, MULTIPLE REFERENCES TO SEQUENCE ID NO.',I6,
     1        1H.,I1,1H.,I1,4X,'ON SEQEP CARDS.')
      GO TO 2260
 2220 WRITE  (IOUT,2240) UFM,IDSEQ1,IDSEQ2,IDSEQ3,IRMNDR
 2240 FORMAT (A23,' 3141, MULTIPLE REFERENCES TO SEQUENCE ID NO.',I6,
     1        1H.,I1,1H.,I1,1H.,I1,'  ON SEQEP CARDS.')
 2260 Z(J) = -Z(J)
 2270 CONTINUE
C
 2275 IF (JJ.LT.KK .OR. MULT.EQ.1 .OR. MULT.EQ.1000) GO TO 2285
      L = Z(I)
      IF (MULT   .EQ.   10) GO TO 2280
      IF (MOD(L,10) .NE. 0) GO TO 2276
      Z(I) = L / 10
      GO TO 2285
 2276 IF (.NOT.FIRST) GO TO 2285
      FIRST = .FALSE.
      NOGO  = 1
      WRITE  (IOUT,2277) UFM
 2277 FORMAT (A23,' 2140B, ILLEGAL DATA IN SEQEP CARD, POSSIBLY CAUSED',
     1       ' BY LARGE GRID OR SCALAR POINTS')
      GO TO 2285
 2280 IF (MOD(L,100) .NE. 0) GO TO 2276
      Z(I) = L / 100
 2285 CONTINUE
C
      IF (K .NE. N2) GO TO 2290
      JJ = KK
      K  = K + 1
      GO TO 2080
C
 2290 DO 2300 I = N2,KK,2
      IF (Z(I) .LT. 0) Z(I) = -Z(I)
 2300 CONTINUE
      IF (NOGO .EQ. 1) GO TO 2400
C
C     CHECK TO SEE IF ANY SEQUENCE ID NO. ON SEQEP CARDS IS THE SAME
C     AS AN EXTRA POINT ID NO. THAT HAS NOT BEEN RESEQUENCED
C
      DO 2390 I = K,KK,2
      IF (Z(I) .LT. 0) GO TO 2390
      IDSEQ1 = Z(I) / MULT
      IRMNDR = Z(I) - MULT*IDSEQ1
      IF (IRMNDR .NE. 0) GO TO 2390
      DO 2320 J = N2,KK,2
      IF (IDSEQ1 .EQ. Z(J)) GO TO 2390
 2320 CONTINUE
      DO 2340 J = 1,N1,3
      IF (IDSEQ1 .EQ. Z(J)) GO TO 2360
 2340 CONTINUE
      GO TO 2390
 2360 NOGO = 1
      WRITE  (IOUT,2380) UFM,IDSEQ1
 2380 FORMAT (A23,' 3142, SEQUENCE ID NO.',I6,
     1       '  ON SEQEP CARDS IS THE SAME AS AN ', /5X,
     2       'EXTRA POINT ID NO. THAT HAS NOT BEEN RESEQUENCED.')
 2390 CONTINUE
 2400 CONTINUE
      I = -1
 1043 I = I + 2
      IF (I .GT. FLAG) GO TO 1045
      BUF(1) = Z(N2+I-1)
      BUF(2) = Z(N2+I  )
      DO 1041 J = IEP,NEP,3
      IF (Z(J) .EQ. BUF(1)) GO TO 1042
 1041 CONTINUE
 1044 BUF(2) = 0
      CALL MESAGE (30,64,BUF)
      NOGO = 1
      GO TO 1043
 1042 IF (Z(J+2) .NE. 0) GO TO 1044
      Z(J+1) = BUF(2)
      GO TO 1043
 1045 CALL CLOSE (DPOOL,CLSREW)
 1047 IF (LUSET+NOEP .EQ. 0) GO TO 2004
C
C     IF EXTRA POINTS PRESENT, SORT THE GPL ON SEQ NO.
C     REPLACE SEQ NO WITH INTERNAL GRID NO FOR DYNAMICS.
C
      N = NGPL + 2
      IF (NOEP .NE. 0) CALL SORT (0,0,3,2,Z,N)
      I   = 2
      Z(I)= 1
      IF (NGPL .EQ. 1) GO TO 1060
      DO 1052 I = 4,NGPL,3
 1052 Z(I+1) = Z(I-2) + 1
C
C     WRITE THE GPLD.
C
 1060 FILE = GPLD
      CALL OPEN  (*2001,GPLD,Z(BUF1),WRTREW)
      CALL FNAME (GPLD,BUF)
      CALL WRITE (GPLD,BUF,2,1)
      DO 1061 I = IGPL,NGPL,3
 1061 CALL WRITE (GPLD,Z(I),1,0)
      CALL WRITE (GPLD,0,0,1)
      CALL CLOSE (GPLD,CLSREW)
      MCB(1) = GPLD
      MCB(2) = N/3
      CALL WRTTRL (MCB)
      KN= MCB(2)
C
C     OPEN SILD AND USETD. WRITE HEADER RECORDS.
C     OPEN SIL  AND USET.  SKIP  HEADER RECORD.
C     READ SIL INTO CORE.
C
      FILE = SILD
      CALL OPEN  (*2001,SILD,Z(BUF1),WRTREW)
      CALL FNAME (SILD,BUF)
      CALL WRITE (SILD,BUF,2,1)
      IF (LUSET .EQ. 0) GO TO 1082
      FILE = SIL
      CALL OPEN (*2001,SIL,Z(BUF2),RDREW)
      CALL FWDREC (*2002,SIL)
      ISIL = NGPL + 3
      CALL READ (*2002,*1081,SIL,Z(ISIL),BUF3-ISIL,1,N)
      CALL MESAGE (-8,0,NAM)
 1081 CALL CLOSE  (SIL,CLSREW)
      NSIL = ISIL + N
      Z(NSIL)= LUSET + 1
 1082 FILE = USETD
      CALL OPEN  (*2001,USETD,Z(BUF3),WRTREW)
      CALL FNAME (USETD,BUF)
      CALL WRITE (USETD,BUF,2,1)
      IF (LUSET .EQ. 0) GO TO 1100
      FILE = USET
      CALL OPEN (*2001,USET,Z(BUF2),RDREW)
      CALL FWDREC (*2002,USET)
C
C     INITIALIZE DISPLACEMENT SET BIT MASKS.
C
 1100 I = IGPL
      J = ISIL - 1
      NBREP = 0
      BUF(10) = 1
      DO 1101 K = 2,7
 1101 MCB(K) = 0
      MSKUA  = TWO(UA)
      MSKUN  = TWO(UN)
      MSKUF  = TWO(UF)
      MSKUE  = TWO(UE)
      MSKUP  = TWO(UP)
      MSKUD  = TWO(UD)
      MSKUNE = TWO(UNE)
      MSKUFE = TWO(UFE)
      MUSETD = ORF(MSKUE,ORF(MSKUNE,ORF(MSKUFE,ORF(MSKUD,MSKUP))))
C
C     TEST FOR CURRENT POINT IN G-SET OR IN P-SET (EXTRA POINT).
C
 1110 IF (Z(I+2) .EQ. 0) GO TO 1130
C
C     POINT IS IN G-SET - READ USET MASKS BELONGING TO POINT.
C     TURN ON APPROPRIATE BITS FOR P-SET. WRITE MASKS ON USETD.
C
      J = J + 1
      M = Z(J+1) - Z(J)
      CALL READ (*2002,*2003,USET,BUF,M,0,FLAG)
      DO 1121 K = 1,M
      KSW = ORF(BUF(K),MSKUP)
      IF (ANDF(KSW,MSKUA) .NE. 0) KSW = ORF(KSW,MSKUD )
      IF (ANDF(KSW,MSKUN) .NE. 0) KSW = ORF(KSW,MSKUNE)
      IF (ANDF(KSW,MSKUF) .NE. 0) KSW = ORF(KSW,MSKUFE)
      MCB(5) = ORF(MCB(5),KSW)
 1121 BUF(K) = KSW
      CALL WRITE (USETD,BUF,M,0)
      GO TO 1140
C
C     POINT IS AN EXTRA POINT - WRITE MASK ON USETD.
C
 1130 CALL WRITE (USETD,MUSETD,1,0)
      MCB(5) = ORF(MCB(5),MUSETD)
      M = 1
C
C     REPLACE INTERNAL DYNAMICS NO. WITH SILD NO. WRITE SILD ENTRY.
C     REPLACE INTERNAL STATICS NO. WITH SIL NO.
C
 1140 Z(I+1) = BUF(10)
      CALL WRITE (SILD,Z(I+1),1,0)
      IF (Z(I+2) .EQ. 0) GO TO 1141
      Z(I+2) = Z(J)
      GO TO 1150
 1141 NBREP = NBREP + 1
C
C     TEST FOR COMPLETION.
C
 1150 BUF(10) = BUF(10) + M
      I = I + 3
      IF (I .LE. NGPL) GO TO 1110
C
C     WRITE SECOND RECORD OF SILD (PAIRS OF SIL NO., SILD NO.)
C
      CALL WRITE (SILD,0,0,1)
      CALL WRITE (USETD,0,0,1)
      DO 1088 I = IGPL,NGPL,3
      IF (Z(I+2) .EQ. 0) GO TO 1088
      BUF(1) = Z(I+2)
      BUF(2) = Z(I+1)
      CALL WRITE (SILD,BUF,2,0)
 1088 CONTINUE
C
C     CLOSE FILES AND WRITE TRAILERS.
C
      CALL CLOSE (SILD ,CLSREW)
      CALL CLOSE (USETD,CLSREW)
      MCB(1) = SILD
      LUSETD = LUSET + NBREP
      MCB(2) = LUSETD
      MCB(3) = NBREP
      CALL WRTTRL (MCB)
      MCB(1) = USETD
      CALL WRTTRL (MCB)
      MCB(5) = 0
      CALL CLOSE (USET,CLSREW)
C
C     REPLACE SIL NO. IN TABLE WITH CODED SILD NO.
C     THEN SORT TABLE ON EXTERNAL GRID NO.
C
      Z(NGPL+4) = LUSETD + 1
      DO 1091 I = IGPL,NGPL,3
      J = 1
      IF (Z(I+4)-Z(I+1) .NE. 1) GO TO 1091
      J = 2
      IF (Z(I+2) .EQ. 0) J = 3
 1091 Z(I+2) = 10*Z(I+1) + J
      CALL SORT (0,0,3,1,Z(IGPL),NGPL-IGPL+3)
C
C     WRITE EQDYN DATA BLOCK. FIRST RECORD IS PAIRS OF EXTERNAL GRID NO,
C     SILD NO. SECOND RECORD IS PAIRS OF EXTERNAL GRID NO., CODED SILD
C     NO.
C
      FILE = EQDYN
      CALL OPEN  (*2001,EQDYN,Z(BUF1),WRTREW)
      CALL FNAME (EQDYN,BUF)
      CALL WRITE (EQDYN,BUF,2,1)
      DO 1094 I = IGPL,NGPL,3
 1094 CALL WRITE (EQDYN,Z(I),2,0)
      CALL WRITE (EQDYN,0,0,1)
      DO 1095 I = IGPL,NGPL,3
      BUF(1) = Z(I  )
      BUF(2) = Z(I+2)
 1095 CALL WRITE (EQDYN,BUF,2,0)
      CALL WRITE (EQDYN,0,0,1)
      CALL CLOSE (EQDYN,CLSREW)
      MCB(1) = EQDYN
      MCB(2) = KN
      CALL WRTTRL (MCB)
      NEQDYN = 2*KN - 1
      IF (NBREP .EQ. 0) NBREP = -1
      RETURN
C
C     FATAL FILE ERRORS
C
 2001 N = -1
      GO TO 2005
 2002 N = -2
      GO TO 2005
 2003 N = -3
      GO TO 2005
 2004 N = -30
      FILE = 109
 2005 CALL MESAGE (N,FILE,NAM)
      RETURN
      END

      SUBROUTINE SHSTSS (NUMPX,ELID,IGRID,THIKNS,Z12,G,EPSCSI,STEMP,
     1                   TBAR,G2ALFB,BENDNG,IDR)
C
C     TO CALCULATE SHELL ELEMENT STRESSES FOR A 2-D FORMULATION BASE.
C     COMPOSITE LAYER STRESSES ARE NOT CALCULATED IN THIS ROUTINE.
C
C
C     INPUT :
C           NUMPX  - NUMBER OF EVALUATION POINTS
C           ELID   - ELEMENT ID
C           IGRID  - ARRAY IF EXTERNAL GRID IDS
C           THIKNS - EVALUATION POINT THICKNESSES
C           Z12    - EVALUATION POINT FIBER DISTANCES
C           G      - 6X6 STRESS-STRAIN MATRIX
C           EPSCSI - CORRECTED STRAINS AT EVALUATION POINTS
C           STEMP  - TEMPERATURE DATA FOR STRESS RECOVERY
C           TBAR   - AVERAGE ELEMENT TEMPERATURE
C           G2ALFB - MATRIX USED IN RECORRECTING OF STRESSES
C           BENDNG - INDICATES THE PRESENCE OF BENDING BEHAVIOR
C           IDR    - REORDERING ARRAY BASED ON EXTERNAL GRID POINT ID'S
C          /TMPDAT/- TEMPERATURE-RELATED LOGICAL FLAGS
C          /OUTREQ/- OUTPUT REQUEST LOGICAL FLAGS
C
C     OUTPUT:
C           STRESSES ARE PLACED AT THE PROPER LOCATION IN /SDR2X7/.
C
C
C     THE STRESS OUTPUT DATA BLOCK (UAI CODE)
C
C     ADDRESS    DESCRIPTIONS
C
C        1       ELID
C     -------------------------------------------------------
C        2       'CNTR'
C        3       LOWER FIBER DISTANCE
C      4 - 10    STRESSES FOR LOWER POINTS AT ELEMENT CENTER POINT
C       11       UPER  FIBER DISTANCE
C     12 - 18    STRESSES FOR UPPER POINTS AT ELEMENT CENTER POINT
C       19       FIRST GRID POINT NUMBER
C     20 - 35    REPEAT  3 TO 18 ABOVE FOR FIRST  GRID POINT
C     36 - 52    REPAET 19 TO 36 ABOVE FOR SECOND GRID POINT
C     53 - 69    REPAET 19 TO 36 ABOVE FOR THIRD  GRID POINT
C
C
C     THE STRESS OUTPUT DATA BLOCK AT ELEMENT CENTER ONLY, COSMIC
C
C     ADDRESS    DESCRIPTIONS
C
C        1       ELID
C     -------------------------------------------------------
C        2       LOWER FIBER DISTANCE
C      3 -  9    STRESSES FOR LOWER POINTS AT ELEMENT CENTER POINT
C       10       UPER  FIBER DISTANCE
C     11 - 17    STRESSES FOR UPPER POINTS AT ELEMENT CENTER POINT
C
C
      LOGICAL         GRIDS, VONMS, LAYER, STRCUR,BENDNG,STSREQ,STNREQ,
     1                GRIDSS,VONMSS,LAYERS,FORREQ,TEMPER,TEMPP1,TEMPP2,
     2                COSMIC
      INTEGER         IGRID(1),NSTRES(1),IDR(1),ELID
      REAL            STEMP(2)
      REAL            THIKNS(1),Z12(2,1),G(6,6),EPSCSI(6,1),G2ALFB(3,1),
     1                S1MAT(3,3),S2MAT(3,3),SIGMA(3),EPSS,SIGMAP(4),
     2                THICK,T3OV12,FIBER,CONST,TBAR,TPRIME,TSUBI
      COMMON /SDR2X7/ DUM71(100),STRES(100),FORSUL(200),STRIN(100)
      COMMON /TMPDAT/ TEMPER,TEMPP1,TEMPP2
      COMMON /OUTREQ/ STSREQ,STNREQ,FORREQ,STRCUR,GRIDS,VONMS,LAYER
     1,               GRIDSS,VONMSS,LAYERS
      EQUIVALENCE     (NSTRES(1),STRES(1))
      DATA    COSMIC, EPSS  / .TRUE., 1.0E-11 /
C
C
C     ELEMENT CENTER POINT COMPUTAION ONLY FOR COSMIC,
C     I.E. THE CALLER SHOULD PASS 1 IN NUMPX FOR COSMIC, 4 FOR UAI
C
      NUMP = NUMPX
      IF (COSMIC) NUMP = 1
C
      NSTRES(1) = ELID
C
C     START THE LOOP ON EVALUATION POINTS
C
      NUMP1 = NUMP - 1
      DO 300 INPLAN = 1,NUMP
      THICK  = THIKNS(INPLAN)
      T3OV12 = THICK*THICK*THICK/12.0
C
      ISTRES = 1
      IF (COSMIC) GO TO 140
C
      ISTRES = (INPLAN-1)*17 + 2
      NSTRES(ISTRES) = INPLAN - 1
      IF (.NOT.GRIDS .OR. INPLAN.LE.1) GO TO 130
      DO 100 INPTMP = 1,NUMP1
      IF (IDR(INPTMP) .EQ. IGRID(INPLAN)) GO TO 120
  100 CONTINUE
      CALL ERRTRC ('SHSTSS  ',100)
  120 ISTRES = INPTMP*17 + 2
      NSTRES(ISTRES) = IGRID(INPLAN)
  130 IF (INPLAN .EQ. 1) NSTRES(ISTRES) = IGRID(INPLAN)
C
C
C     START THE LOOP ON FIBERS
C
  140 DO 280 IZ = 1,2
      FIBER = Z12(IZ,INPLAN)
      STRES(ISTRES+1) = FIBER
      CONST = 12.0*FIBER/THICK
C
C     CREATE [S1] AND [S2]
C
      DO 150 I = 1,3
      DO 150 J = 1,3
      S1MAT(I,J) = G(I  ,J  ) - CONST*G(I,J+3)
      S2MAT(I,J) = G(I+3,J+3) - CONST*G(I,J+3)
  150 CONTINUE
C
C     EVALUATE STRESSES AT THIS FIBER DISTANCE
C
      DO 170 I = 1,3
      SIGMA(I) = 0.0
      DO 160 J = 1,3
      SIGMA(I) = SIGMA(I) + S1MAT(I,J)*EPSCSI(J  ,INPLAN)
     1         - FIBER    * S2MAT(I,J)*EPSCSI(J+3,INPLAN)
  160 CONTINUE
  170 CONTINUE
C
C     IF TEMPERATURES ARE PRESENT, RECORRECT STRESSES FOR THERMAL
C     STRESSES RESULTING FROM TEMPERATURE VALUES AT FIBER DISTANCES.
C
      IF (.NOT.TEMPER .OR. .NOT.BENDNG) GO TO 250
      IF (.NOT.TEMPP1) GO TO 180
      TPRIME = STEMP(2   )
      TSUBI  = STEMP(2+IZ)
      IF (ABS(TSUBI) .LT. EPSS) GO TO 250
      TSUBI  = TSUBI - TPRIME*FIBER
      GO TO 220
C
  180 IF (.NOT.TEMPP2) GO TO 250
      TSUBI = STEMP(4+IZ)
      IF (ABS(TSUBI) .LT. EPSS) GO TO 250
      DO 200 IST = 1,3
      SIGMA(IST) = SIGMA(IST) - STEMP(IST+1)*FIBER/T3OV12
  200 CONTINUE
C
  220 TSUBI = TSUBI - TBAR
      DO 230 ITS = 1,3
      SIGMA(ITS) = SIGMA(ITS) - TSUBI*G2ALFB(ITS,INPLAN)
  230 CONTINUE
C
C     CLEANUP AND SHIP CORRECTED STRESSES
C
  250 DO 260 ITS = 1,3
      IF (ABS(SIGMA(ITS)) .LE. EPSS) SIGMA(ITS) = 0.0
      STRES(ISTRES+1+ITS) = SIGMA(ITS)
  260 CONTINUE
C
C     CALCULATE PRINCIPAL STRESSES
C
      CALL SHPSTS (SIGMA,VONMS,SIGMAP)
      STRES(ISTRES+5) = SIGMAP(1)
      STRES(ISTRES+6) = SIGMAP(2)
      STRES(ISTRES+7) = SIGMAP(3)
      STRES(ISTRES+8) = SIGMAP(4)
C
      ISTRES = ISTRES + 8
  280 CONTINUE
  300 CONTINUE
C
      RETURN
      END

      SUBROUTINE CMCKDF
C
C     THIS SUBROUTINE DETERMINES WHETHER ALL (TRANSFORMED) LOCAL
C     COORDINATE SYSTEMS SPECIFIED AT A GIVEN CONNECTION ARE COMPATABLE
C
      LOGICAL         FIRST,FERROR
      INTEGER         SCCSTM,SCSFIL,SCCONN,SCORE,BUF2,ECPT1,IST(7),
     1                CE(9),CSTMID(7),COMBO,IDPSUB(7),NAM(2),OUTT
      DIMENSION       ECPT(4),CSTM(7,9),TT(9),IZ(1)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /CMB001/ SCR1,SCR2,SCBDAT,SCSFIL,SCCONN,SCMCON,SCTOC,
     1                GEOM4,CASECC,SCCSTM,SCR3
      COMMON /CMB002/ BUF1,BUF2,BUF3,BUF4,BUF5,SCORE,LCORE,INTP,OUTT
      COMMON /CMB003/ COMBO(7,5),CONSET,IAUTO,TOLER,NPSUB,CONECT,TRAN,
     1                MCON,RESTCT(7,7),ISORT,ORIGIN(7,3),IPRINT
      COMMON /ZZZZZZ/ Z(1)
      COMMON /BLANK / STEP,IDRY
      EQUIVALENCE     (IZ(1),Z(1)), (ECPT1,ECPT(1))
      DATA    NAM   / 4HCMCK,4HDF  /
C
      DO 10 I = 2,4
      ECPT(I) = 0.0
   10 CONTINUE
      FERROR  = .TRUE.
C
C     READ CSTM INTO OPEN CORE
C
      IFILE = SCCSTM
      ICSTM = SCORE
      LLCO  = LCORE
      CALL OPEN (*300,SCCSTM,Z(BUF2),0)
      CALL READ (*20,*20,SCCSTM,Z(ICSTM),LLCO,1,NW)
      GO TO 320
   20 LLCO = LLCO - NW
      CALL CLOSE (SCCSTM,1)
      IF (NW .EQ. 0) GO TO 350
      CALL PRETRS (Z(ICSTM),NW)
C
C     READ ALL BGSS FILES INTO OPEN CORE
C
      IBGSS = SCORE + NW
      IFILE = SCSFIL
      CALL OPEN (*300,SCSFIL,Z(BUF2),0)
      JJ = 0
      DO 50 I = 1,NPSUB
      IST(I) = IBGSS + JJ
      NCSUB  = COMBO(I,5) + 1
      DO 30 J = 1,NCSUB
      CALL FWDREC (*310,SCSFIL)
   30 CONTINUE
      CALL READ (*300,*40,SCSFIL,Z(IBGSS+JJ),LLCO,1,NN)
      GO TO 320
   40 LLCO = LLCO - NN
      JJ   = JJ + NN + 1
      CALL SKPFIL (SCSFIL,1)
   50 CONTINUE
      CALL CLOSE (SCSFIL,1)
C
C     BEGIN READING CONNECTION ENTRIES
C
      IFILE = SCCONN
      CALL OPEN (*300,SCCONN,Z(BUF2),0)
   60 CALL READ (*230,*70,SCCONN,CE,10,1,NN)
      GO TO 320
   70 NPT = 0
      DO 80 I = 1,NPSUB
C
C     CE(3)...CE(NN) ARE INTERNAL POINT NO.
C
      IF (CE(I+2) .EQ. 0) GO TO 80
      NPT = NPT + 1
      LOC = IST(I) + (CE(I+2)-1)*4
      CSTMID(NPT) = IZ(LOC)
      IDPSUB(NPT) = I
   80 CONTINUE
C
C     CHECK FOR NO CSTMS THIS ENTRY
C
      ISUM = 0
      DO 90 I = 1,NPT
      ISUM = ISUM + CSTMID(I)
   90 CONTINUE
      IF (ISUM .EQ. 0) GO TO 60
C
C     GET CSTM MATRICES AND LOAD INTO CSTM ARRAY
C
      DO 130 I = 1,NPT
      ECPT1 = CSTMID(I)
      IF (ECPT1 .EQ. 0) GO TO 110
      CALL TRANSS (ECPT,TT)
      DO 100 J = 1,9
      CSTM(I,J) = TT(J)
  100 CONTINUE
      GO TO 130
  110 DO 120 J = 1,9
      CSTM(I,J) = 0.0
  120 CONTINUE
      CSTM(I,1) = 1.0
      CSTM(I,5) = 1.0
      CSTM(I,9) = 1.0
  130 CONTINUE
C
C     COMPARE EACH MATRIX AGAINST OTHERS
C
      NPTM1 = NPT - 1
      DO 220 I = 1,NPTM1
      FIRST = .TRUE.
      J = I + 1
      DO 210 K  = J,NPT
      DO 140 KK = 1,9
      IF (ABS(CSTM(I,KK)-CSTM(K,KK)) .LT. 1.E-3) GO TO 140
      GO TO 150
  140 CONTINUE
      GO TO 210
  150 IF (.NOT.FERROR) GO TO 170
      FERROR = .FALSE.
      WRITE  (OUTT,160) UFM
  160 FORMAT (A23,' 6528, INCOMPATABLE LOCAL COORDINATE SYSTEMS HAVE ',
     1        'BEEN FOUND.', /5X,'CONNECTION OF POINTS IS IMPOSSIBLE',
C    2        ', SUMMARY FOLLOWS.', /5X,'(LOCAL COORDINATE SYSTEMS ARE',
C    3        ' THE TRNASFORMED OVERALL STSTEM GENERATED BY COMB1,',
C    4        /5X,'SEE PROGRM. MANUAL P 4.128-7, 9TH STEP)', //,
C    5        ' *** SUGGESTION - YOUR SUBSTRUCTURING PROBLEM MAY ',
C    6        'REQUIRE THE ''GTRAN'' CARD(S) ***',/)
C
     2        '. (SUGGESTION - USE ''GTRAN'' CARD(S))', /5X,
     3        'SUMMARY IN TERMS OF THE JUST-FORMED INTERNAL DOF AND ',
     4        'INTERNAL COORD. SYSTEM ID''S PER', /5X,
     5        'THE EQSS AND BGSS FOLLOWS.',/)
  170 IF (.NOT.FIRST) GO TO 190
      FIRST = .FALSE.
      ISUB  = IDPSUB(I) + 2
      WRITE  (OUTT,180) CSTMID(I),CSTM(I,1),CSTM(I,4),CSTM(I,7),
     1                  IDPSUB(I),CSTM(I,2),CSTM(I,5),CSTM(I,8),
     2                  CE(ISUB) ,CSTM(I,3),CSTM(I,6),CSTM(I,9)
  180 FORMAT (/1X,76(1H*),/,' THE FOLLOWING MISMATCHED LOCAL COORDINATE'
     1,      ' SYSTEMS (CSTM) HAVE BEEN FOUND FOR', //,
     2       ' LOCAL COORDINATE SYSTEM ID NO.',I9,8X,3E9.2, /,
     3       ' PSEUDOSTRUCTURE ID NO.',I5,20X,3E9.2, /,
     4       ' INTERNAL POINT NO.',I9,20X,3E9.2)
      IDRY  = -2
  190 ISUB  = IDPSUB(K) + 2
      WRITE  (OUTT,200) CSTMID(K),CSTM(K,1),CSTM(K,4),CSTM(K,7),
     1                  IDPSUB(K),CSTM(K,2),CSTM(K,5),CSTM(K,8),
     2                  CE(ISUB), CSTM(K,3),CSTM(K,6),CSTM(K,9)
  200 FORMAT (/12X,'AND',7X,'LOCAL COORDINATE SYSTEM ID NO.',I9,8X,
     1        3E9.2, /22X,'PSEUDOSTRUCTURE ID NO.',I5,20X,3E9.2,
     2        /22X,'INTERNAL POINT NO.',I9,20X,3E9.2)
  210 CONTINUE
  220 CONTINUE
      GO TO 60
C
  230 CALL CLOSE (SCCONN,1)
      GO TO 350
C
  300 IMSG = -1
      GO TO 330
  310 IMSG = -2
      GO TO 330
  320 IMSG = -8
  330 CALL MESAGE (IMSG,IFILE,NAM)
C
  350 RETURN
      END

      SUBROUTINE RAND7 (IFILE,NFILE,PSDL,DIT,ICOUP,NFREQ,NPSDL,NTAU,
     1                  LTAB,CASECC,XYCDB)
C
C     STORES STUFF IN CORE FOR LATER RANDOM ANALSIS
C
      INTEGER ITLIST(7),PSDL,FILE,SYSBUF,DIT,NAME(2),CASECC,
     1        IFILE(1),XYCDB,IPSDL(6)
      REAL    Z(1)
C
      COMMON /SYSTEM/ SYSBUF
      COMMON /ZZZZZZ/ IZ(1)
C
      EQUIVALENCE (Z(1),IZ(1))
C
      DATA NAME  /4HRAND,1H7/
      DATA ITLIST/2,  55,25,1,  56,26,5 /
C *****
C     IDENTIFICATION OF VARIABLES
C *****
C     IFILE    ARRAY OF INPUT FILES
C     NFILE    LENGTH OF IFILE ARRAY
C     PSDL     POWER SPECTRAL DENSITY LISTS FROM DPD
C     DIT      DIRECT INPUT TABLES
C     ICOUP    COUPLED,UNCOUPLED, OR NOGO FLAG
C     NFREQ    NUMBER OF FRENQUICIES
C     NPSDL    NUMBER OF PSDL  SETS
C     NTAU     NUMBER OF TAUS
C     LTAB     LENGTH OF DATA FOR TAB ROUTINE
C     CASECC   CASECONTROL FILE
C     SYSBUF   LENGTH OF ONE GINO BUFFER
C     NTABL    NUMBER OF UNIQUE TABLE ID-S
C     ITABL    POINTER TO LIST OF TABLE ID-S
C
C
C     BUILD FREQUENCY LIST
C
      ICOUP = 0
      LCORE = KORSZ(IZ)
      IBUF1 = LCORE-SYSBUF
C
C     XYCDB MUST BE PRESENT
C
      FILE = XYCDB
      CALL OPEN (*700,XYCDB,IZ(IBUF1),0)
      CALL CLOSE (XYCDB,1)
      LCORE = IBUF1-1
C
C     EXTRACT  SET NO FROM CASECC
C
      CALL GOPEN (CASECC,IZ(IBUF1),0)
      CALL FREAD (CASECC,IZ,166,1)
      I163  = 163
      IRAND = IZ(I163)
      CALL CLOSE (CASECC,1)
      IF (IRAND .EQ. 0) GO TO 700
C
C     FIND DATA FILE
C
      DO 10 I = 1,NFILE
      FILE = IFILE(I)
      CALL OPEN (*10,FILE,IZ(IBUF1),0)
      CALL SKPREC (FILE,1)
      CALL FREAD (FILE,IZ,10,1)
      I10 = 10
      LEN = IZ(I10)-1
      NFREQ = 0
C
C     EXTRACT FREQUENCIES
C
    5 CALL READ (*910,*30,FILE,F,1,0,J)
      CALL FREAD (FILE,IZ,-LEN,0)
      NFREQ = NFREQ +1
      Z(NFREQ) = F
      GO TO  5
   30 CALL CLOSE (FILE,1)
      GO TO 40
   10 CONTINUE
C
C     NO DATA FILES--EXIT
C
  700 ICOUP = -1
      GO TO 90
C
C     BRING IN PSDL CARDS
C
   40 LCORE = LCORE -NFREQ
      FILE  = PSDL
      CALL OPEN (*700,PSDL,Z(IBUF1),0)
      L = NFREQ+1
      NPSDL = 0
      ITAU  =-1
      CALL READ (*910,*41,PSDL,IZ(NFREQ+1),LCORE,0,J)
      GO TO 980
   41 K = NFREQ +3
      IF (J .EQ. 2) GO TO 45
      J = K+J-1
C
C     DETERMINE RECORD THAT RANDOM TAU-S ARE IN
C
      DO 42 I = K,J
      IF (IZ(I) .EQ. IRAND) GO TO 43
   42 CONTINUE
      ITAU = -1
      GO TO 45
C
C     FOUND RANDT CARDS
C
   43 ITAU = I-K
C
C     FIND SELECTED PSDL CARDS
C
   45 CALL READ (*910,*47,PSDL,IPSDL(1),6,0,J)
      IF (IPSDL(1) .NE. IRAND) GO TO 45
      NPSDL   = NPSDL+1
      IZ(L  ) = IPSDL(2)
      IZ(L+1) = IPSDL(3)
      IZ(L+2) = IPSDL(4)
      IZ(L+3) = IPSDL(5)
      IZ(L+4) = IPSDL(6)
      L = L+5
      GO TO 45
   47 IF (NPSDL .NE. 0) GO TO 48
C
C     UNABLE TO FIND SELECTED PSDL CARDS
C
      CALL CLOSE (PSDL,1)
      GO TO 700
C
C     POSITION TAPE FOR TAUS
C
   48 IF (ITAU .LE. 0) GO TO 49
      CALL SKPREC (PSDL,ITAU)
   49 LCORE = LCORE-NPSDL*5
C
C     EXTRACT LIST OF TABLES  AND CHECK FOR COUPLED SYSTEM
C
      JJ = NFREQ +1
      K  = NFREQ +5*NPSDL
      NTABL = 0
      ITABL = IBUF1-1
      DO 60  I = JJ,K,5
      IF (IZ(I) .EQ. IZ(I+1)) GO TO 61
C
C     COUPLED
C
      ICOUP =1
   61 IF (NTABL .EQ. 0) GO TO 62
      DO 63 J=1,NTABL
      L = ITABL +J
      IF (IZ(L) .EQ. IZ(I+4)) GO TO 60
   63 CONTINUE
C
C     STORE TABLE ID
C
   62 NTABL = NTABL +1
      IZ(ITABL) = IZ(I+4)
      ITABL = ITABL -1
   60 CONTINUE
      IZ(ITABL) = NTABL
C
C     BRING IN  TAU-S
C
      NTAU  = 0
      LCORE = LCORE- NTABL-1
      IF(ITAU .EQ. -1) GO TO 70
      CALL READ (*70,*70,PSDL,Z(K+1),LCORE,0,NTAU)
      GO TO 980
   70 CALL CLOSE (PSDL,1)
C
C     SETUP FOR TABLES
C
      LCORE = LCORE -NTAU
      LTAB  = 0
      IF(NTABL .EQ. 0) GO TO 90
      L =  K +NTAU+1
      CALL PRETAB (DIT,IZ(L),Z(L),IZ(IBUF1),LCORE,LTAB,IZ(ITABL),ITLIST
     1 (1))
   90 RETURN
C
C     FILE ERRORS
C
  901 CALL MESAGE (IP1,FILE,NAME)
  910 IP1 =-2
      GO TO 901
  980 IP1= -8
      GO TO 901
      END

      SUBROUTINE COMECT (ELE,MAX)
C
C     REVISED  10/1990 BY G.CHAN/UNISYS
C              TO INCLUDE OFFSET DATA FOR CBAR, CTRIA3 AND CQUAD4 IN
C              THE ECT2 DATA BLOCK
C              (6 COORDINATE VALUES FOR THE BAR, AND 1 OFFSET VALUE
C              FOR EACH OF THE TWO PLATES, ARE ADDED AFTER THE GRID
C              DATA)
C
      INTEGER         IDREC(3),ELE(1),ELID(2),TYPE,IHX2(20),IHX3(32),
     1                ECT1,ECT2,BUFSIZ,B1,B2,GP(32),OUTREW,REW,M1(18),
     2                NAME(2),ERR(5),EPT,PID,IX(1),PCOMP(12)
      REAL            OFFSET(1)
      COMMON /BLANK / SKP1(12),ECT1,SKP2(7),MERR,SKP3(10),ECT2
      COMMON /SYSTEM/ BUFSIZ
      COMMON /ZZZZZZ/ X(1)
      COMMON /GPTA1 / NEL,LAST,INCR,NE(1)
      EQUIVALENCE     (OFFSET(1),GP(1)), (IX(1),X(1))
      DATA    NAME  / 4H COM,4HECT /,  OUTREW,REW,INREW / 1, 1, 0 /
      DATA    PCOMP / 5502,25,2, 5602,14,2, 5702,13,2, 5802,17,17 /
C                     PCOMP      PCOMP1     PCOMP2     PSHELL
      DATA    NM1   / 18    /,
     1        M1    / 4H(33X, 4H,2A4, 4H,18H, 4HIGNO, 4HRING, 4H ELE,
     2                4HMENT, 4H (2A, 4H4,32, 4HH) W, 4HITH , 4HMORE,
     3                4H THA, 4HN 32, 4H CON, 4HNECT, 4HIONS, 4H.)  /,
     4        ILXX  / 2HXX /
      DATA    IHX2  / 1,1,3,3,5,5,7,7,1,3,5,7,13,13,15,15,17,17,19,19/
      DATA    IHX3  / 1,1,4,4,4,7,7,7,10,10,10,1,1,4,7,10,21,24,27,30,
     1                21,21,24,24,24,27,27,27,30,30,30,21            /
C
      B1 = KORSZ(X) - (3*BUFSIZ+2)
      B2 = B1 + BUFSIZ + 3
      ERR(1) = 4
      ERR(2) = NAME(1)
      ERR(3) = NAME(2)
C
C     IF EPT FILE IS PRESENT, AND ANY OF THE PSHELL, PCOMP, PCOMP1 AND
C     PCOMP2 CARDS IS ALSO PRESENT, CREATE A TABLE OF PROPERTY ID AND
C     OFFSET DATA, TO BE USE LATER BY CTRIA3 OR CQURD4 ELEMENTS
C
      JCOMP = B1
      EPT = 104
      CALL OPEN (*40,EPT,X(B1),INREW)
      CALL READ (*30,*30,EPT,IX,2,1,M)
      CALL CLOSE (EPT,REW)
      CALL PRELOC (*40,X(B1),EPT)
      N = 1
      DO 20 I = 1,12,3
      IDREC(1) = PCOMP(I)
      IDREC(2) = IDREC(1)/100
      CALL LOCATE (*20,X(B1),IDREC,J)
      K = PCOMP(I+1)
      J = PCOMP(I+2)
   10 CALL READ (*20,*20,EPT,X,K,0,M)
      IF (X(J) .EQ. 0.0) GO TO 10
      JCOMP = JCOMP - 2
      IX(JCOMP ) = IX(1)
      X(JCOMP+1) =  X(J)
      GO TO 10
   20 N = N + 1
   30 CALL CLOSE (EPT,REW)
      KCOMP = B1 - 1
C
C     CONSTRUCT A LIST OF INDICES IN THE ECT FOR USE WITH GPECT IN THE
C     PLOT MODULE BY CONTOUR PLOTTING
C
   40 CALL GOPEN (ECT1,X(B1),INREW)
      DO 50 J = 1,MAX
   50 ELE(J) = 0
      I = 1
   60 CALL READ (*130,*80,ECT1,IDREC,3,0,M)
      DO 70 J = 1,NEL
      IDX = (J-1)*INCR
      IF (NE(IDX+4) .EQ. IDREC(1)) GO TO 100
   70 CONTINUE
      CALL SKPREC (ECT1,1)
      GO TO 60
   80 CALL MESAGE (-3,ECT1,NAME)
   90 CALL MESAGE (-2,ECT1,NAME)
  100 LECT = NE(IDX+6) - 1
  110 CALL READ (*90,*60,ECT1,ELE(I),1,0,M)
      CALL FREAD (ECT1,0,-LECT,0)
      I = I + 1
      IF (I .GT. MAX) CALL MESAGE (-8,0,NAME)
      GO TO 110
C
  120 CALL MESAGE (-1,ECT1,NAME)
C
  130 LELE = I - 1
      CALL CLOSE (ECT1,REW)
C
      CALL PRELOC (*120,X(B1),ECT1)
      CALL GOPEN (ECT2,X(B2),OUTREW)
      DO 290 N = 1,NEL
      IDX = (N-1)*INCR
C
C     IF SCALAR CONNECTION POSSIBLE FOR ELEMENT THEN SKIP IT
C
      IF (NE(IDX+11) .NE. 0) GO TO 290
C
C     SKIP DUMMY ELEMENTS AND POINT ELEMENTS
C
      IF (NE(IDX+10)-1  .LE. 0) GO TO 290
      IF (NE(IDX+16) .EQ. ILXX) GO TO 290
      CALL LOCATE (*290,X(B1),NE(IDX+4),I)
      NGPEL = NE(IDX+10)
      IF (NGPEL .GT. 32) GO TO 270
C
      CALL WRITE (ECT2,N,1,0)
      CALL WRITE (ECT2,NGPEL,1,0)
  140 CALL READ (*280,*280,ECT1,ELID,1,0,I)
C
C     FIND THIS ELEMENTS POINTER IN THE ECT
C
      DO 150 I = 1,LELE
      IF (ELE(I) .EQ. ELID(1)) GO TO 160
  150 CONTINUE
      CALL MESAGE (-37,0,NAME)
  160 ELID(2) = I
C
C     DETERMINE NUMBER ENTRIES FOR SKIPPING TO GRID ENTRIES
C
      I = NE(IDX+13) - 2
      IF (N .EQ. 52) GO TO 190
C              CHBDY
C
      IF (N.EQ.64 .OR. N.EQ.83) GO TO 240
C           CQUAD4        CTRIA3
      IF (I) 120,180,170
C
  170 CALL FREAD (ECT1,0,-I,0)
  180 CALL FREAD (ECT1,GP,NGPEL,0)
      IF (N .EQ. 34) GO TO 230
C               CBAR
C
      CALL FREAD (ECT1,0,-(NE(IDX+6)-NGPEL-I-1),0)
      GO TO 200
C
C     SPECIAL HANDLING FOR CHBDY
C     IF TYPE IS NEGATIVE, SAVE TYPE FLAG AFTER GRIDS.
C
  190 CALL FREAD (ECT1,0,-1,0)
      CALL FREAD (ECT1,TYPE,1,0)
      CALL FREAD (ECT1,GP,8,0)
      CALL FREAD (ECT1,0,-(NE(IDX+6)-NGPEL-I-1),0)
      IF (TYPE .LT. 0) GO TO 140
      IF (TYPE .EQ. 6) TYPE = 3
      GP(9) = TYPE
      GO TO 220
C
C     SPCIAL HANDLING OF IHEX2 AND IHEX3 WITH ZERO GRIDS
C
  200 IF (N.NE.66 .AND. N.NE.67) GO TO 220
      DO 210 J = 1,NGPEL
      IF (GP(J) .NE. 0) GO TO 210
      K = IHX3(J)
      IF (N .EQ. 66) K = IHX2(J)
      GP(J) = GP(K)
  210 CONTINUE
C
  220 CALL WRITE (ECT2,ELID,2,0)
      CALL WRITE (ECT2,GP,NGPEL,0)
      GO TO 140
C
C     SPECIAL HANDLING OF THOSE ELEMENTS HAVING GRID OFFSET.
C     ADD THESE OFFSET DATA AFTER THE GRID POINTS
C
C     (1) CBAR ELEMENT, 2 OFFSET VECTORS (6 VALUES)
C
  230 CALL WRITE (ECT2,ELID,2,0)
      CALL WRITE (ECT2,GP,NGPEL,0)
      CALL FREAD (ECT1,0,-6,0)
      CALL FREAD (ECT1,OFFSET,6,0)
      CALL WRITE (ECT2,OFFSET,6,0)
      GO TO 140
C
C     (2) CTRIA3 AND CQUAD4 ELEMENTS, ONE OFFSET DATA NORMAL TO PLATE.
C         OFFSET DATA COULD BE ON ELEMENT CARD OR ON PSHELL OR PCOMPI
C         CARDS
C
  240 CALL FREAD (ECT1,PID,1,0)
      CALL FREAD (ECT1,GP,NGPEL,0)
      CALL WRITE (ECT2,ELID,2,0)
      CALL WRITE (ECT2,GP,NGPEL,0)
      J = 5
      IF (N .EQ. 64) J = 6
      CALL FREAD (ECT1,0,-J,0)
      CALL FREAD (ECT1,OFFSET,1,0)
      IF (OFFSET(1) .NE. 0.0) GO TO 260
      IF (JCOMP     .EQ.  B1) GO TO 260
      DO 250 I = JCOMP,KCOMP,2
      IF (IX(I) .NE. PID) GO TO 250
      OFFSET(1) = X(I+1)
      GO TO 260
  250 CONTINUE
  260 CALL WRITE (ECT2,OFFSET,1,0)
      GO TO 140
C
C     ELEMENT TYPE WITH MORE THAN 32 CONNECTIONS
C
  270 ERR(4) = NE(IDX+1)
      ERR(5) = NE(IDX+2)
      CALL WRTPRT (MERR,ERR,M1,NM1)
      CALL SKPREC (ECT1,1)
      GO TO 290
C
  280 CALL WRITE (ECT2,0,0,1)
  290 CONTINUE
C
      CALL CLSTAB (ECT2,REW)
      CALL CLOSE  (ECT1,REW)
      RETURN
      END

      FUNCTION IDIST (NS,ML,MAXLEV,IG,IC,IDEG,IDIS,IW,ICC,JG)
C
C     THIS ROUTINE IS USED ONLY IN BANDIT MODULE
C
C     THIS FUNCTION HAS AS ITS VALUE THE MAXIMUM DISTANCE OF ANY NODE
C     IN COMPONENT IC(NS) FROM THE NODE NS.
C     THE DISTANCE OF EACH NODE IN THIS COMPONENT IS STORED IN THE ARRAY
C     IDIS.
C     THE MAXIMUM NUMBER OF NODES AT THE SAME DISTANCE FROM NS IS
C     STORED IN ML.
C
C     INTEGER          BUNPK
      DIMENSION        IC(1),    IDEG(1),  IDIS(1),  IW(1),    ICC(1),
     1                 IG(1),    JG(1)
      COMMON /BANDS /  NN
C
      ICN = IC(NS)
      NNC = ICC(ICN+1) - ICC(ICN)
      DO 50 I = 1,NN
      IF (IC(I)-IC(NS)) 50,40,50
   40 IDIS(I) = 0
   50 CONTINUE
      LL = 1
      L  = 0
      KI = 0
      KO = 1
      ML = 0
      IW(1) = NS
      IDIS(NS) = -1
  130 KI = KI + 1
      IF (KI-LL) 135,132,135
  132 L  = L + 1
      LL = KO + 1
      K  = KO - KI + 1
      IF (K-ML) 135,135,133
  133 ML = K
      IF (ML-MAXLEV) 135,135,220
  135 II = IW(KI)
      N  = IDEG(II)
      IF (N) 140,215,140
  140 CALL BUNPAK (IG,II,N,JG)
      DO 200 I = 1,N
      IA = JG(I)
      IF (IDIS(IA)) 200,150,200
  150 IDIS(IA) = L
      KO = KO + 1
      IW(KO) = IA
  200 CONTINUE
      IF (KO-NNC) 130,205,205
  205 IDIST = L
      IDIS(NS) = 0
      K = KO - LL + 1
      IF (K-ML) 206,206,207
  207 ML = K
  206 CONTINUE
      RETURN
C
  215 L = 0
      GO TO 205
  220 IDIST = 1
      RETURN
      END

      SUBROUTINE ONETWO(*,IX,X,DX,ITERMM)
C*******
C     PROGRAM TO SOLVE A MATRIX OF ORDER ONE OR TWO FOR DECOMP
C*******
      DOUBLE PRECISION DX(6),DET,MINDIA,DZ  ,DA
      INTEGER SYSBUF,RDP,DUM
      INTEGER TYPEL
      INTEGER SCRFLG,JPOSL,BBAR,CBCNT,R,BBBAR1
     1 ,BBBAR,SR2FL ,SR2FIL
      INTEGER RD,WRT,REW,EOFNRW
      DIMENSION SUB(2),X(1),IX(1)
C
      COMMON /SYSTEM/SYSBUF
      COMMON /DCOMPX/IFILA(7),IFILL(7),IFILU(7),DUM(3),DET,POWER,
     1 NX,MINDIA
      COMMON /NAMES/ RD,RDREW,WRT,WRTREW,REW,NOREW,EOFNRW ,RSP,RDP
      COMMON /ZBLPKX/DZ(2),JJ
      COMMON /PACKX/ITYPE1,ITYPE2,IY,JY,INCRY
      COMMON /UNPAKX/ITYPEX,IXY,JXY,INCRX
C
      EQUIVALENCE (IFILA(2),NCOL),(IFILL(5),TYPEL),(SR2FIL,DUM(2))
C
      DATA SUB/4HONET,4HWO  /
C
C ----------------------------------------------------------------------
C
      IBUF1 = NX-SYSBUF
      IBUF2 = IBUF1-SYSBUF
      IBUF3 = IBUF2-SYSBUF
      IFILE = IFILU(1)
      CALL CLOSE(DUM(2),REW)
      IF(ITERMM.EQ.1)IFILE = DUM(2)
      CALL GOPEN(IFILE,IX(IBUF3),1)
      CALL GOPEN(IFILA,IX(IBUF1),0)
      ITYPEX = RDP
      ITYPE1 = RDP
      ITYPE2 = TYPEL
      INCRX = 1
      INCRY = 1
      IF(NCOL .EQ. 2)GO TO 100
      IF( NCOL .NE. 1)GO TO 5000
C*******
C     SOLVE A (1X1)
C*******
      IXY = 1
      JXY = 1
      CALL UNPACK(*5060,IFILA(1),DX)
      DET = DX(1)
      MINDIA = DABS(DX(1))
      IY = 1
      JY = 1
      CALL PACK(DX,IFILE,IFILU)
      DX(1) = 0.D0
      CALL PACK(DX,IFILL(1),IFILL)
      IF(ITERMM.EQ.0)GO TO 90
      CALL CLOSE(IFILE,EOFNRW)
      GO TO 95
   90 CALL CLOSE(IFILE,REW)
   95 CALL CLOSE(IFILA(1),REW)
      CALL CLOSE(IFILL(1),REW)
      RETURN
  100 IXY = 1
C*******
C     SOLVE A (2X2)
C*******
      JXY = 2
      CALL UNPACK(*5060,IFILA(1),DX)
      CALL UNPACK(*5060,IFILA(1),DX(3))
      A = 1.
      IF(DABS(DX(1)) .GE. DABS(DX(2)))GO TO 150
C*******
C     PERFORM INTERCHANGE
C*******
      DET = DX(1)
      DX(1) = DX(2)
      DX(2) = DET
      DET = DX(3)
      DX(3) = DX(4)
      DX(4) = DET
      A = -1.
  150 CONTINUE
      DX(2) = DX(2)/DX(1)
      DX(4) = DX(4)-DX(2)*DX(3)
      DET = DX(4)*DX(1)*A
      IF(DX(1) .EQ. 0.D0 .OR. DX(4) .EQ. 0.D0)GO TO 5060
      MINDIA = DMIN1 (DABS(DX(1)),DABS(DX(4)))
      IY = 1
      JY = 2
      DX(5) = 0.0D0
      IF(A.LT.0.0)  DX(5) = 1.0D0
      DX(6) = DX(2)
      CALL PACK(DX(5),IFILL(1),IFILL)
      DX(6) = 0.
      JY = 1
      CALL PACK(DX(6),IFILL(1),IFILL)
      IF(ITERMM .EQ. 1)GO TO 160
      DX(2) = DX(3)
      DX(3) = DX(4)
      DX(4) = DX(2)
      JY = 2
      CALL PACK(DX(3),IFILE,IFILU)
      IY = 2
      CALL PACK(DX,IFILE,IFILU)
      GO TO 90
  160 JY = 1
      CALL PACK(DX,IFILE,IFILU)
      JY=2
      CALL PACK(DX(3),IFILE,IFILU)
      CALL CLOSE(IFILE,EOFNRW)
      GO TO 95
      ENTRY FINWRT(ITERM,SCRFLG,SR2FL,JPOSL,I1SP,BBAR,I1,CBCNT,
     1IPAK,R,BBBAR1,BBBAR,I6SP,I4,I4SP,IX,DX,X,LCOL)
      IBUF1 = NX-SYSBUF
      IBUF2 = IBUF1-SYSBUF
      IBUF3 = IBUF2-SYSBUF
      CALL CLOSE(IFILA(1),REW)
      CALL GOPEN(SR2FIL,IX(IBUF1),WRT)
      CALL CLOSE(SR2FIL,EOFNRW)
      K=0
      CALL GOPEN(IFILL,IX(IBUF2),WRT)
      IF(SCRFLG.EQ.0)GO TO 2005
      CALL GOPEN(SR2FL,IX(IBUF3),RD)
 2005 LL = 0
 2010 JPOSL = JPOSL+1
      CALL BLDPK(RDP,TYPEL,IFILL(1),0,0)
      IN1 = I1SP+K
      JJ = JPOSL
      DZ(1) = IX(IN1)
      CALL ZBLPKI
      KK = 0
      IEND = MIN0(BBAR,NCOL-JJ)
      IF(IEND .EQ. 0)GO TO 2030
      IN1 = I1+LL*BBAR
 2020 JJ = JJ+1
      IN2 = IN1+KK
      DZ(1) =DX(IN2)
      CALL ZBLPKI
      KK = KK+1
      IF(KK-IEND)2020,2030,5050
 2030 IF(CBCNT.EQ.0)GO TO 2050
C*******
C     PACK ACTIVE ROW ELEMENTS ALSO
C*******
      KK = 0
 2035 IN1 = I6SP + KK
      IN2 = I4 + IX(IN1)*BBBAR + K
      DZ(1) = DX(IN2)
      IF(DZ(1) .EQ. 0.D0)GO TO 2040
      IN1 = I4SP + IX(IN1)
      JJ = IX(IN1)
      CALL ZBLPKI
 2040 KK = KK + 1
      IF(KK .LT. CBCNT)GO TO 2035
 2050 CALL BLDPKN(IFILL(1),0,IFILL)
      LL = LL + 1
      K = K + 1
      IF(K.EQ.LCOL)GO TO 2080
      IF(K-R+1)2010,2060,2070
 2060 IF(R-BBBAR1)2070,2010,5050
 2070 LL =LL-1
      IN1 = I1+LL*BBAR
      CALL FREAD(SR2FL,DX(IN1),2*BBAR,0)
      GO TO 2010
 2080 CALL CLOSE(IFILL(1),REW)
      IF(SCRFLG.GT.0)CALL CLOSE(SR2FL,REW)
      IF(ITERM .NE. 0)RETURN
C*******
C     RE-WRITE THE UPPER TRIANGLE WITH THE RECORDS IN THE REVERSE ORDER
C*******
      INCRX = 1
      INCRY = 1
      ITYPE1 = TYPEL
      ITYPE2 = TYPEL
      ITYPEX = TYPEL
      IFILU(2) = 0
      IFILU(6) = 0
      IFILU(7) = 0
      CALL GOPEN(SR2FIL,IX(IBUF1),RD)
      CALL GOPEN(IFILU,IX(IBUF2),1)
      DO 2300 I = 1,NCOL
      IXY = 0
      CALL BCKREC(SR2FIL)
      CALL UNPACK(*5060,SR2FIL,IX)
      CALL BCKREC(SR2FIL)
      KK = JXY-IXY+1
      K = KK/2
      KK = KK + 1
      IF(TYPEL .EQ. 1)GO TO 2095
      DO 2090 J = 1,K
      L = KK-J
      DA = DX(J)
      DX(J) = DX(L)
 2090 DX(L) = DA
      GO TO 2100
 2095 DO 2097 J = 1,K
      L = KK-J
      A    = X(J)
      X(J) = X(L)
 2097 X(L) = A
 2100 IY = NCOL-JXY+1
      JY = NCOL-IXY+1
      CALL PACK(IX,IFILU(1),IFILU)
 2300 CONTINUE
      CALL CLOSE(IFILU(1),REW)
      CALL CLOSE(SR2FIL,REW)
      RETURN
 5000 NO = -8
      GO TO 5500
 5050 NO = -25
      GO TO 5500
 5060 RETURN 1
 5500 CALL MESAGE(NO,0,SUB)
      RETURN
      END

      SUBROUTINE PLTSET
C
C     COMMENTS FROM G.C. -
C     THE DRIVER FOR DMAP MODULE PLTSET IS DPLTST
C     THIS ROUTINE HAS NOTHING TO DO WITH DPLTST.  IT IS CALLED ONLY
C     BY PARAM (IN MODULE PLOT), XYPLOT, AND SEEMAT
C
C
      LOGICAL         TAPBIT
      INTEGER         CHRWRD,PBFSIZ,PBUFSZ,PDATA,PLTDAT,PLTYPE,
     1                PLOTER,PLT1,PLT2,PLTNUM,OFFSCL
      REAL            XYMAX(2),CNTCHR(2),XYSIZE(2)
      CHARACTER       UFM*23,UWM*25,UIM*29
      COMMON /XMSSG / UFM,UWM,UIM
      COMMON /BLANK / SKP4(4),PLTNUM
      COMMON /XXPARM/ PBUFSZ,SKPARM(6),PAPSIZ(2),SKP235(226),OFFSCL
      COMMON /PLTDAT/ MODEL,PLOTER,REG(2,2),AXYMAX(2),XYEDGE(11),CHRSCL,
     1                PDATA(20),PLTDAT(20,1)
      COMMON /MACHIN/ MACH
      COMMON /SYSTEM/ KSYSTM(65)
      EQUIVALENCE     (PDATA(1),XYMAX(1)) ,  (PDATA(3),CNTSIN)  ,
     1                (PDATA(4),CNTCHR(1)),  (PDATA(10),PLTYPE) ,
     2                (PDATA(12),PBFSIZ)  ,  (NOUT  ,KSYSTM( 2)),
     3                (CHRWRD,KSYSTM(41)) ,  (ITRACK,KSYSTM(59))
      DATA    XYSIZE/ 11.0, 8.5 /,  PLT1,PLT2 / 4HPLT1, 4HPLT2  /
C
C     INITIALIZE -PDATA-
C
      DO 100 I = 1,20
      PDATA(I) = PLTDAT(I,PLOTER)
  100 CONTINUE
C
C     PLT2 FILE WAS HARD CODED INTO THE 11TH WORD OF PLTDAT(11,PLOTER)
C     BY PLOTBD. IF USER REQUESTS PLT1 FILE, WE MUST MAKE A SWITCH HERE
C
      IF (.NOT.TAPBIT(PLT2) .AND. TAPBIT(PLT1)) PDATA(11) = PLT1
      IF (PLTNUM.EQ.0 .AND. OFFSCL.EQ.0) WRITE (NOUT,110) UIM,PDATA(11)
  110 FORMAT (A29,', PLOT FILE GOES TO ',A4)
C
      IF (OFFSCL .EQ. 0) OFFSCL = 1
C
C     SCALE THE CHARACTURE SIZE BEFORE SETTING BORDERS
C
      CNTCHR(1) = CHRSCL*CNTCHR(1)
      CNTCHR(2) = CHRSCL*CNTCHR(2)
      PBUFSZ    = PBFSIZ/CHRWRD
C
C     FOR UNIVAC 9 TRACK CALCOMP PLOT TAPES QUARTER WORD MODE WILL
C     BE USED LIMITING THE NUMBER OF CHARACTERS PER WORD TO 4
C     ITRACK = 2 FOR 9 TRACK TAPES - OTHERWISE 1 FOR 7 TRACK TAPES
C     THE DEFAULT IS FOR 7 TRACK TAPES
C
C     IF (MACH.EQ.3 .AND. ITRACK.EQ.2) PBUFSZ = PBFSIZ/4
C
C     SINCE GENERAL PLOTTER IS THE ONLY ONE SUPPORTED BY NASTRAN, THE
C     PLOT BUFFER FOR UNIVAC MUST BE 500 WORDS FOR BOTH FORTRAN V AND
C     ASCII FORTRAN. (SEE PROG. MANUAL PAGE 6.10-15)
C
      IF (MACH .EQ. 3) PBUFSZ = PBFSIZ/6
C
      PLTYPE = MODEL
C
C     INITIALIZE PAPER SIZE AND BORDERS
C
      DO 130 I = 1,2
      IF (IABS(PLTYPE)-2) 121,125,124
  121 IF (PLTYPE) 122,122,123
C
C     CRT PLOTTERS
C
  122 AXYMAX(I) = XYMAX(I) - CNTCHR(I)
      XYEDGE(I) = CNTCHR(I)*.5
      GO TO 129
  123 AXYMAX(I) = XYMAX(I)
      XYEDGE(I) = 0.
      GO TO 129
C
C     DRUM PLOTTERS
C
  124 IF (PAPSIZ(I) .LE. 0.0) PAPSIZ(I) = XYMAX(I)/CNTSIN
      GO TO (127,126), I
C
C     TABLE PLOTTERS
C
  125 IF (PAPSIZ(I) .LE. 0.0) PAPSIZ(I) = XYSIZE(I)
C
  126 IF (CNTSIN*PAPSIZ(I) .GT. XYMAX(I)) PAPSIZ(I) = XYMAX(I)/CNTSIN
  127 AXYMAX(I) = CNTSIN*PAPSIZ(I) - CNTSIN
      XYEDGE(I) = CNTSIN*.5
  129 REG(I,1)  = 0.
      REG(I,2)  = AXYMAX(I)
  130 CONTINUE
C
      RETURN
      END

      SUBROUTINE DDRMM2 (*,*,*,*)
C
C     PERFORMS SORT2 TYPE PROCESSING FOR MODULE DDRMM.
C
      LOGICAL         SORT2    ,COL1     ,FRSTID   ,IDOUT    ,TRNSNT  ,
     1                LMINOR   ,ANYXY
      INTEGER         BUF1     ,BUF2     ,BUF3     ,BUF4     ,BUF5    ,
     1                BUF6     ,BUFF     ,EOR      ,RD       ,RDREW   ,
     2                WRT      ,WRTREW   ,CLS      ,CLSREW   ,ELEM    ,
     3                IA(4)    ,SETS     ,ENTRYS   ,SYSBUF   ,OUTPT   ,
     4                PASSES   ,OUTFIL   ,FILE     ,DHSIZE   ,FILNAM  ,
     5                SETID    ,FORM     ,DEVICE   ,PHASE    ,SCRT    ,
     6                SCRT1    ,SCRT2    ,SCRT3    ,SCRT4    ,SCRT5   ,
     7                SCRT6    ,SCRT7    ,TYPOUT   ,DVAMID(3),BUF(150),
     8                Z(1)     ,UVSOL    ,BUFA(75) ,BUFB(75) ,COMPLX  ,
     9                SUBCAS   ,SAVDAT   ,SAVPOS   ,BUFSAV  ,ELWORK(300)
      REAL            RIDREC(1),LAMBDA
      CHARACTER       UFM*23   ,UWM*25   ,UIM*29   ,SFM*25   ,SWM*27
      COMMON /XMSSG / UFM      ,UWM      ,UIM      ,SFM      ,SWM
      COMMON /STDATA/ LMINOR   ,NSTXTR   ,NPOS     ,SAVDAT(75)        ,
     1                SAVPOS(25)         ,BUFSAV(10)
      COMMON /SYSTEM/ SYSBUF   ,OUTPT
      COMMON /NAMES / RD       ,RDREW    ,WRT      ,WRTREW   ,CLSREW  ,
     1                CLS
      COMMON /ZBLPKX/ A(4)     ,IROW
      COMMON /ZNTPKX/ AOUT(4)  ,IROWO    ,IEOL     ,IEOR
      COMMON /GPTA1 / NELEM    ,LAST     ,INCR     ,ELEM(1)
      COMMON /ZZZZZZ/ RZ(1)
      COMMON /MPYADX/ MCBA(7)  ,MCBB(7)  ,MCBC(7)  ,MCBD(7)  ,LZ      ,
     1                ITFLAG   ,ISINAB   ,ISINC    ,IPREC    ,ISCRT
      COMMON /CLSTRS/ COMPLX(1)
      COMMON /DDRMC1/ IDREC(146),BUFF(6) ,PASSES   ,OUTFIL   ,JFILE   ,
     1                MCB(7)   ,ENTRYS   ,SETS(5,3),INFILE   ,LAMBDA  ,
     2                FILE     ,SORT2    ,COL1     ,FRSTID   ,NCORE   ,
     3                NSOLS    ,DHSIZE   ,FILNAM(2),RBUF(150),IDOUT   ,
     4                ICC      ,NCC      ,ILIST    ,NLIST    ,NWDS    ,
     5                SETID    ,TRNSNT   ,I1       ,I2       ,PHASE   ,
     6                ITYPE1   ,ITYPE2   ,NPTSF    ,LSF      ,NWDSF   ,
     7                SCRT(7)  ,IERROR   ,ITEMP    ,DEVICE   ,FORM    ,
     8                ISTLST   ,LSTLST   ,UVSOL    ,NLAMBS   ,NWORDS  ,
     9                OMEGA    ,IPASS    ,SUBCAS
      COMMON /CONDAS/ PI       ,TWOPI
      EQUIVALENCE    (SCRT1,SCRT(1)), (SCRT2,SCRT(2)), (SCRT3,SCRT(3)),
     1               (SCRT4,SCRT(4)), (SCRT5,SCRT(5)), (SCRT6,SCRT(6)),
     2               (SCRT7,SCRT(7)), (BUF1 ,BUFF(1)), (BUF2 ,BUFF(2)),
     3               (BUF3 ,BUFF(3)), (BUF4 ,BUFF(4)), (BUF5 ,BUFF(5)),
     4               (BUF6 ,BUFF(6)), (A(1) ,  IA(1)), (Z(1) ,  RZ(1)),
     5               (BUF(1),RBUF(1),BUFA(1)), (BUFB(1),BUF(76)),
     6               (IDREC(1),RIDREC(1))
C
      DATA    EOR  , NOEOR / 1, 0 /, DVAMID / 2001, 2010, 2011 /
C
C     FORMATION OF DATA-MATRIX AND SUBSEQUENT MULTIPLICATION BY SAME OF
C     THE SOLUTION MATRIX (TRNNSPOSED), AND ULTIMATE OUTPUT OF TRANSIENT
C     OR FREQUENCY SOLUTIONS.
C
      IPASS  = 1
      IOMEGA = NLIST  + 1
      NOMEGA = IOMEGA - 1
      MINOR  = 0
   20 COL1   = .TRUE.
      FRSTID = .TRUE.
      SETID  = SETS(1,IPASS)
      DEVICE = SETS(2,IPASS)
      FORM   = SETS(3,IPASS)
      ISTLST = SETS(4,IPASS)
      LSTLST = SETS(5,IPASS)
C
C     GET LIST OF XYPLOT REQUESTED IDS FOR CURRENT SUBCASE AND
C     OUTFIL TYPE.
C
      GO TO (22,23,24,25), JFILE
C
C     DISPLACEMENT, VELOCITY, ACCELERATION
C
   22 IXYTYP = IPASS
      GO TO 26
C
C     SPCF
C
   23 IXYTYP = 4
      GO TO 26
C
C     STRESS
C
   24 IXYTYP = 6
      GO TO 26
C
C     FORCE
C
   25 IXYTYP = 7
      GO TO 26
C
   26 IXY  = NOMEGA + 1
      CALL DDRMMP (*480,Z(IXY),BUF3-IXY,LXY,IXYTYP,SUBCAS,Z(BUF3),ANYXY)
      IF (.NOT.ANYXY .AND. SETID.EQ.0) GO TO 400
      NXY  = IXY + LXY - 1
      IERROR = 23
      FILE = SCRT4
      CALL OPEN (*450,SCRT4,Z(BUF3),WRTREW)
      FILE = SCRT5
      CALL OPEN (*450,SCRT5,Z(BUF2),WRTREW)
      CALL FNAME (SCRT5,FILNAM)
      CALL WRITE (SCRT5,FILNAM,2,EOR)
C
C     LOGIC TO BUILD SORT-2 FORMAT DATA MATRIX.
C
C     EACH COLUMN WRITTEN HERE ENCOMPASSES ALL EIGENVALUES FOR
C     ONE COMPONENT OF ONE ID.  THE NUMBER OF COLUMNS THUS EQUALS
C     THE SUM OF ALL COMPONENTS OF ALL REQUESTED ID-S.
C
C     READ AN OFP-ID RECORD AND SET PARAMETERS.
C     (ON ENTRY TO THIS PROCESSOR ONE ID-RECORD IS AT HAND)
C
      FILE   = INFILE
      IERROR = 19
      MCB(1) = SCRT5
      MCB(2) = 0
      MCB(3) = NLAMBS
      MCB(4) = 2
      MCB(5) = 1
      MCB(6) = 0
      MCB(7) = 0
      IF (IPASS.EQ.1 .AND. FRSTID) GO TO 50
   40 CALL READ (*160,*160,INFILE,IDREC,146,EOR,NWDS)
C
C     OFP-ID RECORD IS WRITTEN TO THE MAP FILE ONLY ON CHANGE OF
C     MINOR ID.
C
   50 MAJOR = MOD(IDREC(2),1000)
      IF (MAJOR .NE. ITYPE1) GO TO 420
      IDVICE = DEVICE
      ID   = IDREC(5)/10
      IF (SETID) 80,65,60
   60 NEXT = 1
      CALL SETFND (*65,Z(ISTLST),LSTLST,ID,NEXT)
      GO TO 80
   65 IF (.NOT.ANYXY) GO TO 70
      CALL BISLOC (*70,ID,Z(IXY),1,LXY,JP)
      IDVICE = 0
      GO TO 80
C
C     ID IS NOT TO BE OUTPUT THUS SKIP UPCOMING OFP-DATA-RECORD.
C
   70 CALL FWDREC (*460,INFILE)
      GO TO 40
C
C     ID IS TO BE OUTPUT THUS CONTINUE.
C
   80 NUMWDS = NLAMBS*IDREC(10)
      IDATA  = NXY + 1
      NDATA  = IDATA + NUMWDS - 1
      IF (NDATA .LT. BUF3) GO TO 100
C
C     INSUFFICIENT CORE
C
      INSUF = NDATA - BUF3
      WRITE  (OUTPT,90) UWM,INFILE,INSUF
   90 FORMAT (A25,' 2337.  (DDRMM2-2)  DATA BLOCK',I5,' CAN NOT BE ',
     1       'PROCESSED DUE TO', /5X,'A CORE INSUFFICIENCY OF APPROXI',
     2       'MATELY',I11,' DECIMAL WORDS.')
      GO TO 440
  100 IF (.NOT.FRSTID) GO TO 110
C
C     VERY FIRST ID RECORD,  THUS SET MINOR ID.
C
      FRSTID = .FALSE.
      GO TO 120
  110 IF (IDREC(3) .EQ. MINOR) GO TO 130
C
C     CHANGE IN MINOR ID, I.E. NEW ELEMENT TYPE.  COMPLETE CURRENT
C     RECORD OF MAP AND OUTPUT ANOTHER ID-RECORD.
C
      CALL WRITE (SCRT4,0,0,EOR)
  120 CALL WRITE (SCRT4,IDREC,146,EOR)
      MINOR = IDREC(3)
C
C     SAME TYPE OF DATA THUS CONTINUE ON.
C
  130 LENTRY = IDREC(10)
      I1 = NWORDS + 1
      I2 = LENTRY
C
C     READ AND OUTPUT ONE FULL OFP-DATA RECORD.
C
      CALL READ (*460,*470,INFILE,Z(IDATA),NUMWDS,EOR,NWDS)
      DO 150 I = I1,I2
C
C     START NEW COLUMN
C
      CALL BLDPK (1,1,SCRT5,0,0)
      IROW  = 0
      JDATA = IDATA + I - 1
      KDATA = NDATA - LENTRY + I
      DO 140 J = JDATA,KDATA,LENTRY
      IROW = IROW + 1
      A(1) = RZ(J)
C
C     ELIMINATE INTEGERS
C
C     OLD LOGIC -
C     IF (MACH.NE.5 .AND. IABS(IA(1)).LT.100000000) A(1) = 0.0
C     IF (MACH.EQ.5 .AND. (IA(1).LE.127 .AND. IA(1).GE.1)) A(1) = 0.0
C     OLD LOGIC SHOULD INCLUDE ALPHA MACHINE (MACH=21)
C
C     NEW LOGIC, BY G.CHAN/UNISYS  8/91 -
      IF (NUMTYP(IA(1)) .LE. 1) A(1) = 0.0
C
      CALL ZBLPKI
  140 CONTINUE
C
C     COMPLETE COLUMN
C
      CALL BLDPKN (SCRT5,0,MCB)
  150 CONTINUE
C
C     OUTPUT TO MAP THE ID PLUS ANY OTHER DATA NECESSARY.
C
      BUF(1) = 10*ID + IDVICE
      IF (NWORDS .EQ. 2) BUF(2) = Z(IDATA+1)
      NSTXTR = 0
      IF (ITYPE1.NE.5 .OR. SAVDAT(MINOR).EQ.0) GO TO 155
      NPOS   = SAVDAT(MINOR)/100
      NSTXTR = SAVDAT(MINOR) - NPOS * 100
      DO 151 I = 1,NSTXTR
      J = SAVPOS(NPOS+I-1)
  151 BUF(I+1) = Z(IDATA+J-1)
  155 CALL WRITE (SCRT4,BUF,NWORDS+NSTXTR,NOEOR)
C
C     GO FOR NEXT ID.
C
      GO TO 40
C
C     END OF FILE ON INFILE.  MAP AND DATA MATRIX NOW COMPLETE.
C
  160 CALL WRTTRL (MCB)
      CALL CLOSE (SCRT5,CLSREW)
      CALL CLOSE (INFILE,CLSREW)
      CALL WRITE (SCRT4,0,0,EOR)
      CALL CLOSE (SCRT4,CLSREW)
C
C     SOLUTION MATRIX MAY BE FOUND BASED ON SORT-2 INFILE.
C
C     SOLVE,
C                               T
C        (MODAL SOLUTION MATRIX)     X      (DATA MATRIX)
C          NLAMBS X NSOLUTIONS             NLAMBS X NCOMPS
C        =======================           ===============
C
C     RESULTANT MATRIX IS NSOLUTIONS BY NCOMPS IN SIZE.
C
C
C     MATRIX MULTIPLY SETUP AND CALL.
C
      MCBA(1) = UVSOL
      IF (TRNSNT) MCBA(1) = SCRT(IPASS)
      CALL RDTRL (MCBA)
      MCBB(1) = SCRT5
      CALL RDTRL (MCBB)
      MCBC(1) = 0
      MCBD(1) = SCRT6
      MCBD(2) = 0
      MCBD(3) = NSOLS
      MCBD(4) = 2
      MCBD(5) = 1
      MCBD(6) = 0
      MCBD(7) = 0
      IF (.NOT.TRNSNT) MCBD(5) = 3
      ITFLAG  = 1
      NXY1    = NXY + 1
      IF (MOD(NXY1,2) .EQ. 0) NXY1 = NXY1 + 1
      LZ      = KORSZ(Z(NXY1))
      ISINAB  = 1
      ISINC   = 1
      IPREC   = 1
      ISCRT   = SCRT7
      CALL MPYAD (Z(NXY1),Z(NXY1),Z(NXY1))
      MCBD(1) = SCRT6
      CALL WRTTRL (MCBD)
C
C     PRODUCT MATRIX IS NOW OUTPUT USING THE MAP ON SCRT4.
C     EACH COLUMN OF SCRT6 CONTAINS ALL THE TIME OR FREQUENCY STEP
C     VALUES FOR ONE COMPONENT OF ONE ID.
C
C     THUS A NUMBER OF COLUMNS ENCOMPASSING THE COMPONENTS OF ONE ID
C     MUST FIT IN CORE.
C
      IERROR = 20
      FILE = OUTFIL
      CALL OPEN (*450,OUTFIL,Z(BUF1),WRT)
      FILE = SCRT4
      CALL OPEN (*450,SCRT4,Z(BUF2),RDREW)
      FILE = SCRT6
      CALL OPEN (*450,SCRT6,Z(BUF3),RDREW)
      CALL FWDREC (*460,SCRT6)
C
C     READ AN OFP-ID-RECORD FROM THE MAP, AND ALLOCATE SPACE NEEDED
C     FOR SOLUTION DATA.
C
      FILE = SCRT4
  170 CALL READ (*400,*470,SCRT4,IDREC,146,EOR,NWDS)
      MINOR = IDREC(3)
C
C
C     SET DISPLACEMENT, VELOCITY, OR ACCELERATION OFP MAJOR-ID IF
C     INFILE IS MODAL DISPLACEMETNS = EIGENVECTORS...
C
      IF (ITYPE1 .NE. 7) GO TO 175
      IDREC(2) = DVAMID(IPASS)
  175 IF (.NOT.TRNSNT) IDREC(2) = IDREC(2) + 1000
C
C     RESET APPROACH CODE FROM EIGENVALUE TO TRANSIENT OR FREQUENCY
C
      IAPP = 5
      IF (TRNSNT) IAPP = 6
      IDREC(1) = 10*IAPP + DEVICE
      LENTRY = IDREC(10) - NWORDS
      NCOLS = LENTRY
      IF (.NOT.TRNSNT) LENTRY = LENTRY + LENTRY
C
C     IF FREQUENCY RESPONSE PROBLEM AND THIS IS THE VELOCITY OR
C     ACCELERATION PASS THEN MOVE DOWN ANY XY LIST OF POINTS AND
C     ADD AN OMEGA TABLE.  SOMETIMES THE MOVEDOWN OF THE XY LIST IS
C     REDUNDANT.
C
C     XY LIST IS MOVED FROM BOTTOM UP INCASE XY LIST IS LONGER THAN
C     THE OMEGA LIST WILL BE.
C
      IF (TRNSNT .OR. IPASS.EQ.1) GO TO 177
      NOMEGA = IOMEGA + NSOLS - 1
      IF (LXY .EQ. 0) GO TO 177
      JXY = NXY
      KXY = NOMEGA + LXY
      DO 176 I = 1,LXY
      Z(KXY) = Z(JXY)
      JXY = JXY - 1
      KXY = KXY - 1
  176 CONTINUE
C
  177 IXY = NOMEGA + 1
      NXY = IXY + LXY - 1
      IDATA = NXY + 1
      NDATA = IDATA + LENTRY*NSOLS - 1
      TYPOUT= 3
      IF (TRNSNT) TYPOUT = 1
C
C     FILL TITLE, SUBTITLE, AND LABEL FROM CASECC FOR THIS SUBCASE.
C
      DO 178 I = 1,96
      IDREC(I+50) = Z(ICC+I+37)
  178 CONTINUE
      IDREC(4) = SUBCAS
C
C     CHECK FOR SUFFICIENT CORE.
C
      IF (NDATA .LT. BUF3) GO TO 190
      INSUF = NDATA - BUF3
      WRITE  (OUTPT,180) UWM,OUTFIL,INSUF
  180 FORMAT (A25,' 2338.  (DDRMM2-3)  DATA BLOCK',I5,
     1       ' MAY NOT BE FULLY COMPLETED DUE TO A CORE INSUFFICIENCY',
     2       /5X,'OF APPROXIMATELY',I11,' DECIMAL WORDS.')
      GO TO 440
C
C     LOOP ON ID-S AVAILABLE FROM THE MAP
C
C
C     COMPUTE OMEGAS IF NECESSARY
C     (NOTE, VELOCITY PASS MAY NOT ALWAYS OCCUR)
C
  190 IF (TRNSNT .OR. IPASS.EQ.1) GO TO 195
      JLIST = IOMEGA - 1
      DO 193 I = ILIST,NLIST
      JLIST = JLIST + 1
      RZ(JLIST) = RZ(I)*TWOPI
  193 CONTINUE
      IF (IPASS .EQ. 2) GO TO 195
      DO 194 I = IOMEGA,NOMEGA
      RZ(I) = -RZ(I)**2
  194 CONTINUE
C
  195 CALL READ (*460,*170,SCRT4,BUF,NWORDS,NOEOR,NWDS)
      LMINOR = .TRUE.
      IF (ITYPE1.NE.5 .OR. SAVDAT(MINOR).EQ.0)  GO TO 196
      NPOS   = SAVDAT(MINOR)/100
      NSTXTR = SAVDAT(MINOR) - NPOS*100
      CALL READ (*460,*470,SCRT4,BUFSAV(1),NSTXTR,NOEOR,NWDS)
      LMINOR = .FALSE.
  196 CONTINUE
C
C     PREPARE AND OUTPUT THE OFP-ID-RECORD AFTER FIRST ENTRY IS COMBINED
C     AS IN THE CASE OF A FREQUENCY COMPLEX PROBLEM.
C
      IDOUT = .FALSE.
      IDREC(5) = BUF(1)
C
C     SET STRESS OR FORCE COMPLEX DATA PTRS IF NECESSARY.
C
      IF (TRNSNT) GO TO 220
      IF (ITYPE1 .EQ. 4) GO TO 200
      IF (ITYPE1 .EQ. 5) GO TO 210
      GO TO 220
C
C     FORCES ASSUMED
C
  200 IELEM = (IDREC(3)-1)*INCR
      LSF   = ELEM(IELEM+19)
      NPTSF = ELEM(IELEM+21)
      GO TO 220
C
C     STRESSES ASSUMED
C
  210 IELEM = (IDREC(3)-1)*INCR
      LSF   = ELEM(IELEM+18)
      NPTSF = ELEM(IELEM+20)
      GO TO 220
C
C     UNPACK DATA FOR ALL COMPONENTS AND ALL SOLUTION STEPS
C     FOR THIS ID.  (NCOLS COLUMNS ARE NEEDED)
C
C
C     ZERO THE DATA SPACE
C
  220 DO 230 I = IDATA,NDATA
      Z(I) = 0
  230 CONTINUE
C
C     UNPACK NOW-ZERO TERMS.
C
      JDATA = IDATA - LENTRY
      DO 270 I = 1,NCOLS
      CALL INTPK (*260,SCRT6,0,TYPOUT,0)
C
C     COLUMN I HAS ONE OR MORE NON-ZEROES AVAILABLE.
C
  240 CALL ZNTPKI
      ITEMP = JDATA + IROWO*LENTRY
      IF (.NOT.TRNSNT) GO TO (246,247,248), IPASS
C
C     TRANSIENT OUTPUTS
C
      RZ(ITEMP) = AOUT(1)
      IF (IEOL) 240,240,260
C
C    DISPLACEMENTS, AND SPCFS (FREQ RESPONSE)
C
  246 RZ(ITEMP) = AOUT(1)
      ITEMP     = ITEMP + NCOLS
      RZ(ITEMP) = AOUT(2)
      IF (IEOL) 240,240,260
C
C     VELOCITIES  (FREQ RESPONSE)
C
  247 KLIST     = IOMEGA + IROWO - 1
      RZ(ITEMP) =-RZ(KLIST)*AOUT(2)
      ITEMP     = ITEMP + NCOLS
      RZ(ITEMP) = RZ(KLIST)*AOUT(1)
      IF (IEOL) 240,240,260
C
C     ACCELERATIONS (FREQ RESPONSE)
C
  248 KLIST     = IOMEGA + IROWO - 1
      RZ(ITEMP) = RZ(KLIST)*AOUT(1)
      ITEMP     = ITEMP + NCOLS
      RZ(ITEMP) = RZ(KLIST)*AOUT(2)
      IF (IEOL) 240,240,260
  260 JDATA = JDATA + 1
  270 CONTINUE
C
C     OUTPUT LINES OF DATA COMBINING THEM FOR COMPLEX REAL/IMAGINARY OR
C     MAG/PHASE OFP FORMATS IF NECESSARY.
C
      JLIST = ILIST - 1
      DO 390 I = IDATA,NDATA,LENTRY
      JWORDS = NWORDS
      IJ = I + NCOLS - 1
      DO 280 J = I,IJ
      JWORDS = JWORDS + 1
      BUF(JWORDS) = Z(J)
      IF (TRNSNT) GO TO 280
      ITEMP = J + NCOLS
      BUF(JWORDS+75) = Z(ITEMP)
  280 CONTINUE
C
C     IF TRANSIENT, ENTRY IS NOW READY FOR OUTPUT.
C
      IF (TRNSNT)  GO TO 365
C
C     MAP COMPLEX OUTPUTS TOGETHER PER -COMPLX- ARRAY.
C
      IF (ITYPE1.EQ.4 .OR. ITYPE1.EQ.5) GO TO 300
C
C     POINT DATA
C
      DO 290 K = 3,8
      IF (FORM .EQ. 3) CALL MAGPHA (BUFA(K),BUFB(K))
      BUFA(K+6) = BUFB(K)
  290 CONTINUE
      JWORDS = 14
      GO TO 370
C
C     ELEMENT STRESS OR FORCE DATA.
C
  300 IOUT = 0
      L = NPTSF
      IF (LMINOR)  GO TO 310
      DO 305 K = 1,NSTXTR
      J = SAVPOS(NPOS+K-1)
  305 BUF(J) = BUFSAV(K)
  310 NPT = COMPLX(L)
      IF (NPT) 320,350,340
  320 NPT = -NPT
      IF (FORM .NE. 3) GO TO 340
C
C     COMPUTE MAGNITUDE/PHASE
C
      CALL MAGPHA (BUFA(NPT),BUFB(NPT))
  330 IOUT = IOUT + 1
      ELWORK(IOUT) = BUFA(NPT)
      L = L + 1
      GO TO 310
  340 IF (NPT .LE. LSF) GO TO 330
      NPT  = NPT - LSF
      IOUT = IOUT + 1
      ELWORK(IOUT) = BUFB(NPT)
      L = L + 1
      GO TO 310
C
C     MOVE OUTPUT DATA
C
  350 DO 360 L = 1,IOUT
      BUF(L) = ELWORK(L)
  360 CONTINUE
      JWORDS = IOUT
      GO TO 370
  365 CONTINUE
      IF (LMINOR)  GO TO 370
      DO 366 K = 1,NSTXTR
      J = SAVPOS(NPOS+K-1)
  366 BUF(J) = BUFSAV(K)
C
C     CALL DDRMMS TO RECOMPUTE SOME ELEMENT STRESS QUANTITIES
C     IN TRANSIENT PROBLEMS ONLY.
C
  370 IF (TRNSNT .AND. ITYPE1.EQ.5) CALL DDRMMS (BUF,IDREC(3),BUF4,BUF5)
      IF (IDOUT) GO TO 380
      IDREC( 9) = FORM
      IDREC(10) = JWORDS
      CALL WRITE (OUTFIL,IDREC,146,EOR)
      IDOUT = .TRUE.
  380 JLIST = JLIST + 1
      RBUF(1) = RZ(JLIST)
      CALL WRITE (OUTFIL,BUF,JWORDS,NOEOR)
  390 CONTINUE
      CALL WRITE (OUTFIL,0,0,EOR)
C
C     GO FOR NEXT OUTPUT ID
C
      GO TO 190
C
C  END OF DATA ON MAP FILE (SCRT4).
C
  400 CALL CLOSE (OUTFIL,CLS)
      CALL CLOSE (INFILE,CLSREW)
      CALL CLOSE (SCRT4,CLSREW)
      CALL CLOSE (SCRT6,CLSREW)
      IPASS = IPASS + 1
      IF (IPASS .GT. PASSES) GO TO 410
C
C     PREPARE FOR ANOTHER PASS
C
      FILE = INFILE
      CALL OPEN (*450,INFILE,Z(BUF1),RDREW)
      CALL FWDREC (*460,INFILE)
      GO TO 20
  410 RETURN
C
C     CHANGE IN MAJOR OFP-ID DETECTED ON -INFILE-.
C
  420 WRITE  (OUTPT,430) SWM,INFILE
  430 FORMAT (A27,' 2339.  (DDRMM2-1) A CHANGE IN WORD 2 OF THE OFP-ID',
     1       ' RECORDS OF DATA BLOCK',I5, /5X,'HAS BEEN DETECTED. ',
     2       ' POOCESSING OF THIS DATA BLOCK HAS BEEN TERMINATED.')
  440 IPASS = 3
      GO TO 400
C
C     UNDEFINED FILE.
C
  450 RETURN 1
C
C     END OF FILE
C
  460 RETURN 2
C
C     END OF RECORD.
C
  470 RETURN 3
C
C     INSUFFICIENT CORE
C
  480 RETURN 4
      END

      SUBROUTINE IFPPAR
C
C     SUBROUTINE TO TEST FOR PARAM CARD PARAMETERS REQUIRED BY VARIOUS
C     RIGID FORMATS.
C
      LOGICAL         ABORT,HFREQ,LFREQ,LMODE,NODJE,P1,P2,P3,PTOT,
     1                CTYPE,KINDX,NSEGS,LTEST,QUEUE
      INTEGER         RF,APP,HFRE,CTYP,QUE,APPR(4)
      CHARACTER       UFM*23,UWM*25
      COMMON /XMSSG / UFM,UWM
      COMMON /SYSTEM/ N1,NOUT,ABORT,N2(17),IAPP,N3(3),RF
      COMMON /IFPDTA/ IDTA(509),NPARAM
      COMMON /ZZZZZZ/ IBUFF(1)
      DATA    APPR  / 4HDMAP,   4HDISP, 4HHEAT,   4HAERO        /
      DATA    HFRE  / 4HHFRE /, LFRE /  4HLFRE /, LMOD  /4HLMOD /
      DATA    NODJ  / 4HNODJ /, IP1  /  4HP1   /, IP2   /4HP2   /
      DATA    IP3   / 4HP3   /, QUE  /  4HQ                     /
      DATA    CTYP  / 4HCTYP /, KIND /  4HKIND /, NSEG  /4HNSEG /
      DATA    HFREQ / .FALSE./, LFREQ/  .FALSE./, LMODE /.FALSE./
      DATA    NODJE / .FALSE./, CTYPE/  .FALSE./, KINDX /.FALSE./
      DATA    NSEGS / .FALSE./, P1   /  .FALSE./, P    2/.FALSE./
      DATA    QUEUE / .FALSE./, P3   /  .FALSE.                 /
C
      APP = IABS(IAPP)
C
C     NO PARAMS REQD FOR HEAT APPROACH,
C     DMAPS DISP 1 THRU 9, DISP 13, AND DISP 16 THRU 19, AND
C     AERO RF 9
C
      IF (APP.EQ.1 .OR.  APP.EQ.3) GO TO 9999
      IF (APP.EQ.2 .AND. (RF.LE.9 .OR. RF.EQ.13 .OR. RF.GE.16))
     1    GO TO 9999
      IF (APP.EQ.4 .AND.  RF.EQ.9) GO TO 9999
C
C     FATAL ERROR IF NO PARAMS ENTERED AS REQUIRED
C
      IF (NPARAM .EQ. 0) GO TO 9800
C
C     LOOP TO TEST PARAMS IN PVT FOR PRESENCE OF REQUIRED ONES.
C
      IPM = 1
  500 IPN = 2*N1 + IPM
C
      IF (RF .GE. 14) GO TO 1000
      IF (IBUFF(IPN) .EQ. HFRE) HFREQ = .TRUE.
      IF (IBUFF(IPN) .EQ. LFRE) LFREQ = .TRUE.
      IF (IBUFF(IPN).EQ.LMOD .AND. IBUFF(IPN+2).NE.0) LMODE = .TRUE.
C
      IF (APP .NE. 4) GO TO 2000
      IF (IBUFF(IPN).EQ.NODJ .AND. IBUFF(IPN+2).NE.0) NODJE = .TRUE.
      IF (IBUFF(IPN) .EQ. IP1) P1 = .TRUE.
      IF (IBUFF(IPN) .EQ. IP2) P2 = .TRUE.
      IF (IBUFF(IPN) .EQ. IP3) P3 = .TRUE.
      IF (IBUFF(IPN).EQ.QUE  .AND. IBUFF(IPN+2).NE.0) QUEUE = .TRUE.
      GO TO 2000
C
 1000 IF (IBUFF(IPN).EQ.CTYP .AND. IBUFF(IPN+2).NE.0) CTYPE = .TRUE.
      IF (IBUFF(IPN).EQ.NSEG .AND. IBUFF(IPN+2).NE.0) NSEGS = .TRUE.
      IF (IBUFF(IPN).EQ.KIND .AND. IBUFF(IPN+2).NE.0) KINDX = .TRUE.
C
 2000 IPM = IPM + 4
      IF (IBUFF(IPN+2).GE.3 .AND. IBUFF(IPN+2).LE.5) IPM = IPM + 1
      IF (IBUFF(IPN+2) .GE. 6) IPM = IPM + 3
      IF (IPM .LT. NPARAM) GO TO 500
C
C     TEST TO VERIFY THAT ALL REQUIRED PARAMS ARE PRESENT
C
      IF (RF.EQ.14 .OR. RF.EQ.15) GO TO 4000
      IF (LMODE .AND.  .NOT.(HFREQ.OR.LFREQ)) GO TO 3000
      IF (HFREQ .AND. LFREQ .AND. .NOT.LMODE) GO TO 3000
C
C     SOMETING AMISS - - IS AN LMODES, HFREQ, OR LFREQ MISSING
C
      IF (.NOT.(LMODE .OR. (HFREQ .AND. LFREQ))) GO TO 9810
C
C     IS LMODES PRESENT WITH HFREQ AND/OR LFREQ
C
      IF (LMODE .AND. (HFREQ .OR. LFREQ)) GO TO 9820
C
 3000 IF (APP .NE. 4) GO TO 9999
C
C     TEST FOR CORRECT NODJE SETUP FOR AERO RF 10 AND 11
C
      PTOT = P1 .AND. P2 .AND. P3
      IF (NODJE .AND. PTOT) GO TO 3500
      IF (NODJE .AND. .NOT.PTOT) GO TO 9830
      IF ((P1.OR.P2.OR.P3) .AND. .NOT.NODJE) GO TO 9840
C
C     TEST FOR Q REQUIRED BY AERO RF 11
C
 3500 IF (RF .EQ. 10) GO TO 9999
      IF (QUEUE) GO TO 9999
      GO TO 9870
C
C     TEST FOR CTYPE, NSEGS, OR KINDEX REQD BY DISP RF 14 AND 15.
C
 4000 LTEST = CTYPE .AND. NSEGS
      IF (.NOT.LTEST) GO TO 9850
 4100 IF (RF .EQ. 14) GO TO 9999
C
      IF (KINDX) GO TO 9999
      GO TO 9860
C
C     SET UP ERROR MESSAGE
C
 9800 ASSIGN 9900 TO IERR
      MSGNO = 340
      GO TO  9890
 9810 ASSIGN 9910 TO IERR
      MSGNO = 341
      GO TO  9890
 9820 ASSIGN 9920 TO IERR
      MSGNO = 342
      GO TO  9895
 9830 ASSIGN 9930 TO IERR
      MSGNO = 343
      GO TO  9890
 9840 ASSIGN 9940 TO IERR
      MSGNO = 344
      GO TO  9895
 9850 ASSIGN 9950 TO IERR
      MSGNO = 345
      GO TO  9890
 9860 ASSIGN 9960 TO IERR
      MSGNO = 346
      GO TO  9890
 9870 ASSIGN 9970 TO IERR
      MSGNO = 347
C
 9890 CALL PAGE2 (3)
      WRITE  (NOUT,9891) UFM,MSGNO
 9891 FORMAT (A23,I4)
      ABORT = .TRUE.
      GO TO 9898
 9895 CALL PAGE2 (3)
      WRITE  (NOUT,9896) UWM,MSGNO
 9896 FORMAT (A25,I4)
 9898 GO TO IERR, (9900,9910,9920,9930,9940,9950,9960,9970)
C
 9900 WRITE  (NOUT,9905) APPR(APP),RF
 9905 FORMAT (' PARAM CARDS REQUIRED BY ',A4,' RIGID FORMAT',I3,
     1        ' NOT FOUND IN BULK DATA.')
      GO TO 9999
C
 9910 WRITE  (NOUT,9915) APPR(APP),RF
 9915 FORMAT (' LMODES OR HFREQ/LFREQ PARAM REQUIRED BY ',A4,
     1        ' RIGID FORMAT',I3,' NOT IN BULK DATA OR TURNED OFF.')
      GO TO 3000
C
 9920 WRITE  (NOUT,9925)
 9925 FORMAT (' LMODES PARAM FOUND IN BULK DATA WITH HFREQ OR LFREQ.',
     X        '  LMODES TAKES PRECEDENCE.')
      GO TO 3000
C
 9930 WRITE  (NOUT,9935) RF
 9935 FORMAT (' NODJE PARAM SPECIFIED FOR AERO RIGID FORMAT',I3,
     1        ' BUT P1, P2, OR P3 OMITTED.')
      GO TO 3500
C
 9940 WRITE  (NOUT,9945)
 9945 FORMAT (' P1, P2, OR P3 PARAM FOUND IN BULK DATA BUT NODJE ',
     1        'MISSING OR TURNED OFF.')
      GO TO 3500
C
 9950 WRITE  (NOUT,9955) RF
 9955 FORMAT (' CTYPE OR NSEGS PARAM REQUIRED BY DISPLACEMENT RIGID ',
     1        'FORMAT',I3,' MISSING OR INCORRECT.')
      GO TO 4100
C
 9960 WRITE  (NOUT,9965)
 9965 FORMAT (' KINDEX PARAM REQUIRED BY DISPLACEMENT RIGID FORMAT 15',
     1        ' MISSING OR TURNED OFF.')
      GO TO 9999
C
 9970 WRITE  (NOUT,9975)
 9975 FORMAT (' DYNAMIC PRESSURE (Q) PARAM REQUIRED BY AERO RIGID FORM',
     1        'AT 11 NOT IN BULK DATA.')
C
 9999 RETURN
      END

      SUBROUTINE RCOVR3
C
C     THE RCOVR3 MODULE RECOVERS DATA FOR SUBSTRUCTURE PHASE 3.
C
C     DISPLACEMENTS AND REACTIONS ARE COPIED FROM THE SOF TO GINO FILES.
C     FOR NORMAL MODES, LAMA IS CREATED FROM THE SOLN ITEM.
C     FOR STATICS, THE LOADS AND ENFORCED DISPLACEMENTS ARE FACTORED
C     AND COMBINED TO CORRESPOND WITH THE PHASE 2 SOLUTION SUBCASES.
C
C     JANUARY 1974
C
      LOGICAL         FIRST
      INTEGER         RFNO     ,TRL      ,SYSBUF   ,TITLES   ,OTYPP    ,
     1                OTYPUN   ,IZ(10)   ,PG       ,PS       ,PO       ,
     2                YS       ,UAS      ,QAS      ,PGS      ,PSS      ,
     3                POS      ,YSS      ,LAMA     ,IVEC(4)  ,OVEC(4)  ,
     4                SOLN     ,UVEC     ,QVEC     ,INITM(3) ,OUTDB(3) ,
     5                SUBR(2)  ,SRD      ,HERE     ,BUF1     ,BUF2     ,
     6                BUF3     ,BUF4     ,RC       ,FSS(2)   ,FILE     ,
     7                SCR1     ,SCR2     ,SCR3
      DIMENSION       MCBTRL(7)
      CHARACTER       UFM*23   ,UWM*25   ,UIM*29   ,SFM*25
      COMMON /XMSSG / UFM      ,UWM      ,UIM      ,SFM
      COMMON /BLANK / RFNO     ,NAME(2)  ,NOUE     ,TRL(7)   ,HERE(6)  ,
     1                IBUF(3)
      COMMON /SYSTEM/ SYSBUF   ,NOUT
      COMMON /NAMES / RD       ,RDREW    ,WRT      ,WRTREW   ,REW      ,
     1                NOREW
      COMMON /OUTPUT/ TITLES(1)
      COMMON /PACKX / ITYPP    ,OTYPP    ,IROWP    ,NROWP    ,INCP
      COMMON /UNPAKX/ OTYPUN   ,IROWUN   ,NROWUN   ,INCUN
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE     (PG  ,IVEC(1) )    ,(PGS ,OVEC(1) )    ,
     1                (PS  ,IVEC(2) )    ,(PSS ,OVEC(2) )    ,
     2                (PO  ,IVEC(3) )    ,(POS ,OVEC(3) )    ,
     3                (YS  ,IVEC(4) )    ,(YSS ,OVEC(4) )    ,
     4                (SOLN,INITM(1))    ,(LAMA,OUTDB(1))    ,
     5                (UVEC,INITM(2))    ,(UAS ,OUTDB(2))    ,
     6                (QVEC,INITM(3))    ,(QAS ,OUTDB(3))    ,
     7                (Z(1),IZ(1))
      DATA     PG   , PS  ,PO  ,YS  ,UAS ,QAS ,PGS ,PSS ,POS ,YSS ,LAMA/
     1         101  , 102 ,103 ,104 ,201 ,202 ,203 ,204 ,205 ,206 ,207 /
      DATA     SCR1 , SCR2,SCR3     /
     1         301  , 302 ,303      /
      DATA     SOLN , UVEC  , QVEC   ,IBLANK  /
     1        4HSOLN, 4HUVEC, 4HQVEC ,4H      /
      DATA     SUBR         , SRD    /
     1        4HRCOV, 4HR3  , 1      /
C
C     INITIALIZATION
C
      LCORE = KORSZ(Z)
      BUF1  = LCORE - SYSBUF + 1
      BUF2  = BUF1  - SYSBUF - 1
      BUF3  = BUF2  - SYSBUF
      BUF4  = BUF3  - SYSBUF
      LCORE = BUF4  - 1
      IF (LCORE .LE. 0) CALL MESAGE (-8,0,SUBR)
      NOGO  = 0
      ITYPP = 1
      OTYPP = 1
      IROWP = 1
      INCP  = 1
      OTYPUN= 1
      IROWUN= 1
      INCUN = 1
      FIRST = .FALSE.
      CALL SOFOPN (Z(BUF1),Z(BUF2),Z(BUF3))
      DO 10 I = 1,6
      HERE(I) = 0
   10 CONTINUE
C
C     CHECK DATA
C
C     NO EXTRA POINTS
C
      IF (NOUE .NE. -1) GO TO 6372
C
C     SUBSTRUCTURE NAME
C
      CALL FDSUB (NAME,RC)
      IF (RC .EQ. -1) CALL SMSG (-2,IBLANK,NAME)
C
C     PAIRS OF INPUT ITEMS AND OUTPUT BLOCKS
C
      CALL SFETCH (NAME,SOLN,SRD,RC)
      IF (RC .NE. 1) CALL SMSG (2-RC,SOLN,NAME)
      IF (RFNO.EQ.1 .OR. RFNO.EQ.2) GO TO 15
      TRL(1) = OUTDB(1)
      CALL RDTRL (TRL)
      IF (TRL(1) .GT. 0) GO TO 15
      CALL MESAGE (1,OUTDB(1),SUBR)
      NOGO = 1
   15 DO 30 I = 2,3
      IF (I.EQ.1 .AND. (RFNO.EQ.1 .OR. RFNO.EQ.2)) GO TO 30
      CALL SOFTRL (NAME,INITM(I),MCBTRL)
      RC = MCBTRL(1)
      IF (RC .NE. 1) GO TO 30
      TRL(1) = OUTDB(I)
      CALL RDTRL (TRL)
      IF (TRL(1) .GT. 0) GO TO 20
      CALL MESAGE (1,OUTDB(I),SUBR)
      NOGO = 1
      GO TO 30
   20 HERE(I-1) = 1
   30 CONTINUE
C
C     PAIRS OF DATA BLOCKS
C
      IF (RFNO.EQ.3 .OR. RFNO.EQ.8) GO TO 60
      DO 50 I = 1,4
      TRL(1) = IVEC(I)
      CALL RDTRL (TRL)
      IF (TRL(1) .LT. 0)  GO TO 50
      IF (I.EQ.4 .AND. TRL(6).EQ.0) GO TO 50
      TRL(1) = OVEC(I)
      CALL RDTRL (TRL)
      IF (TRL(1) .GT. 0) GO TO 40
      CALL MESAGE (1,OVEC(I),SUBR)
      NOGO = 1
      GO TO 50
   40 HERE(I+2) = 1
   50 CONTINUE
C
C     TERMINATE IF THERE WERE ERRORS
C
   60 IF (NOGO .NE. 0) GO TO 9037
C
C     COPY DISPLACEMENTS AND REACTIONS FROM SOF TO GINO FILES
C
      IF (HERE(1) .EQ. 1) CALL MTRXI (UAS,NAME,UVEC,Z(BUF4),RC)
      IF (HERE(2) .EQ. 1) CALL MTRXI (QAS,NAME,QVEC,Z(BUF4),RC)
C
C     BRANCH ON RIGID FORMAT NUMBER
C
      IF (RFNO .EQ. 3) GO TO 140
C
C     RIGID FORMAT  1 -- STATIC
C     RIGID FORMAT  2 -- INERTIAL RELIEF
C     RIGID FORMAT  8 -- FREQUENCY RESPONSE
C     RIGID FORMAT  9 -- TRANSIENT RESPONSE
C     *************************************
C
C     FETCH SOLN ITEM AND PROCESS GROUP 0 DATA
C
      CALL SFETCH (NAME,SOLN,SRD,RC)
      IF (RC .NE. 1) CALL SMSG (2-RC,SOLN,NAME)
      CALL SUREAD (FSS,2,N,RC)
      WRITE (NOUT,63210) UIM,FSS,NAME
      CALL SUREAD (IBUF,3,N,RC)
      IF (IBUF(1) .NE. RFNO) GO TO 6322
      IF (IBUF(2) .NE. 1) GO TO 6324
      NC = IBUF(3)
C
C     WRITE NULL REACTIONS MATRIX TO PREVENT ERROR 3007 IN UMERGE
C
      IF (HERE(2) .EQ. 1) GO TO 80
      NROWP = 1
      CALL MAKMCB (TRL,QAS,1,2,1)
      CALL GOPEN (QAS,Z(BUF4),WRTREW)
      DO 70 I = 1,NC
      CALL PACK (0,QAS,TRL)
   70 CONTINUE
      CALL CLOSE (QAS,REW)
      CALL WRTTRL (TRL)
C
C     COPY FREQUENCIES ONTO PPF OR TIME STEPS ONTO TOL
C
   80 IF (RFNO .LT. 8) GO TO 120
      J = 1
      CALL SJUMP (J)
      FILE = LAMA
      CALL OPEN (*9001,LAMA,Z(BUF4),WRTREW)
      CALL FNAME (LAMA,IBUF)
      CALL WRITE (LAMA,IBUF,2,0)
   90 CALL SUREAD (Z,LCORE,N,RC)
      CALL WRITE (LAMA,Z,N,0)
      IF (RC .EQ. 1) GO TO 90
      CALL WRITE (LAMA,0,0,1)
C
C     WRITE NULL DYNAMIC LOADS MATRIX ONTO PPF
C
      CALL MAKMCB (TRL,LAMA,1,2,1)
      IF (RFNO .EQ. 9) GO TO 110
      DO 100 I = 1,NC
      CALL PACK (0,LAMA,TRL)
  100 CONTINUE
  110 CALL WRTTRL (TRL)
      CALL CLOSE (LAMA,REW)
C
C     FOR EACH SUBCASE READ FROM THE SOLN, FORM A COMBINED VECTOR FROM
C     THE VECTORS OF THE APPLIED LOADS OR ENFORCED DISPLACEMENTS DATA
C     BLOCKS
C
  120 LCORE = BUF3 - 1
      DO 130 I = 1,4
      IF (HERE(I+2) .EQ. 0) GO TO 130
      CALL RCOVSL (NAME,0,IVEC(I),SCR1,SCR2,SCR3,OVEC(I),Z,Z,LCORE,
     1             FIRST,RFNO)
      IF (OVEC(I) .NE. 0) FIRST= .TRUE.
  130 CONTINUE
      GO TO 5000
C
C     RIGID FORMAT  3 -- NORMAL MODES
C     *******************************
C
C     WRITE NULL REACTIONS MATRIX TO PREVENT ERROR 3007 IN UMERGE
C
  140 IF (HERE(2) .EQ. 1) GO TO 150
      NROWP = 1
      CALL MAKMCB (TRL,QAS,1,2,1)
      CALL GOPEN (QAS,Z(BUF4),WRTREW)
      CALL PACK (0,QAS,TRL)
      CALL CLOSE (QAS,REW)
      CALL WRTTRL (TRL)
C
C     GENERATE OFP ID RECORD FOR LAMA
C
  150 IF (LCORE .LT. 146) GO TO 9008
      CALL GOPEN (LAMA,Z(BUF4),WRTREW)
      DO 160 I = 3,50
      IZ(I) = 0
  160 CONTINUE
      IZ( 1) = 21
      IZ( 2) = 6
      IZ(10) = 7
      DO 170 I = 1,96
      IZ(I+50) = TITLES(I)
  170 CONTINUE
      CALL WRITE (LAMA,Z,146,1)
C
C     GET SOLN ITEM AND CHECK GROUP 0 DATA
C
      CALL SFETCH (NAME,SOLN,SRD,RC)
      IF (RC .NE. 1) CALL SMSG (2-RC,SOLN,NAME)
      CALL SUREAD (FSS,2,N,RC)
      WRITE (NOUT,63210) UIM,FSS,NAME
      CALL SUREAD (IBUF,-1,N,RC)
      IF (IBUF(1) .NE. RFNO) GO TO 6322
      NEIGV = IBUF(2)
      IF (NEIGV .GT. 0) GO TO 180
C
C     NO EIGENVALUES.  WRITE ZERO TRAILER TO INDICATE LAMA IS PURGED
C
      CALL CLOSE (LAMA,REW)
      CALL MAKMCB (TRL,LAMA,0,0,0)
      CALL WRTTRL (TRL)
      GO TO 6323
C
C     COPY SOLN GROUP 1 TO LAMA RECORD 2 AND WRITE NON-ZERO TRAILER
C
  180 CALL SUREAD (Z,LCORE,N,RC)
      CALL WRITE (LAMA,Z,N,0)
      IF (RC .EQ. 1) GO TO 180
      CALL WRITE (LAMA,0,0,1)
      CALL CLOSE (LAMA,REW)
      CALL MAKMCB (TRL,LAMA,0,0,0)
      TRL(2) = 1
      CALL WRTTRL (TRL)
C
C     NORMAL MODULE EXITS
C
 5000 CALL SOFCLS
      RETURN
C
C     ABNORMAL MODULE EXITS
C
 6372 WRITE (NOUT,63720) UFM
      GO TO 9061
 9001 N = -1
      GO TO 9200
 6322 WRITE (NOUT,63220) SFM,IBUF(1),RFNO
      GO TO 9061
 6323 WRITE (NOUT,63230) UWM
      GO TO 9300
 6324 WRITE (NOUT,63240) UFM,NAME
      GO TO 9061
 9008 N = -8
      GO TO 9200
 9037 N = -37
      GO TO 9200
 9061 N = -61
 9200 CALL SOFCLS
      CALL MESAGE (N,FILE,SUBR)
 9300 CALL SOFCLS
      RETURN
C
C     FORMAT STATEMENTS FOR DIAGNOSTIC MESSAGES
C
63210 FORMAT (A29,' 6321, SUBSTRUCTURE PHASE 3 RECOVER FOR FINAL SOLUT',
     1       'ION STRUCTURE ',2A4, /35X,' AND BASIC SUBSTRUCTURE ',2A4)
63220 FORMAT (A25,' 6322, SOLN HAS INCORRECT RIGID FORMAT NUMBER.',/32X,
     1       'PHASE 2 RIGID FORMAT WAS',I3,' AND PHASE 3 IS',I3)
63230 FORMAT (A25,' 6323, NO EIGENVALUES FOR THIS SOLUTION')
63240 FORMAT (A23,' 6324, PHASE 3 RECOVER ATTEMPTED FOR NON-BASIC ',
     1       'SUBSTRUCTURE ',2A4)
63720 FORMAT (A23,' 6372, NO EXTRA POINTS ALLOWED IN PHASE 3 ',
     1       'SUBSTRUCTURING.')
      END

      SUBROUTINE MACHCK (*)
C
C     NEW MACHINE COMPATIBILITY CHECK
C     THIS ROUTINE IS CALLED ONCE ONLY BY XSEM01 IF DEBUG FLAG IS ON
C
C     FOR LINK1 DEBUG PURPOSE, PRINT OUT GOES TO UNIT 6, NOT NOUT
C
C     WRITTEN BY G.CHAN/UNISYS  5/1991
C
C     NEXT LINE IS NEEDED FOR HP WORKSTATION. THE $ STARTS ON COLUMN 1
C
C  $MIXED_FORMATS
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        LSHIFT,RSHIFT
      INTEGER         AR(5)
      REAL            XX
      COMPLEX         E,D,F
      CHARACTER       L21(5)*1,L2*8,RV*8
      CHARACTER       UFM*23,UWM*25,UIM*29,UIMX*29
      COMMON /XMSSG / UFM,UWM,UIM
      COMMON /SEM   / MASK
      COMMON /SYSTEM/ SYSBUF,NOUT,NOGO,DUMM1(11),DATE(3),DUMM2(13),
     1                HICORE,TIMEW,DUMM3(62),SPERLK
      COMMON /MACHIN/ MACHX,IJHALF(2),LQRO,MCHNAM
      COMMON /LHPWX / LOWPW,HIGHPW
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE     (S,Z(1))
      EQUIVALENCE     (L21(1),L2),(XX,IX)
      DATA    I,J,K / 4HABCD, 4H1234, 4HA3CD  /,
     1        D,E   / (1.0,-2.0), (-3.0,4.0)  /,
     2        L1,BT / 4HWORD, 4HBYTE          /,
     3        IA,IR / 4HA   , 4HR             /,
     4        L2,RV / 'NATURAL ', 'REVERSED'  /,
     5        AS,DS / 3H AS,  3HDES           /
      DATA    UIMX  / '0*** USER INFORMATION MESSAGE' /
C
      NOGO = 0
      IF (UIMX .EQ. UIM) GO TO 20
      NOGO = 1
      WRITE  (6,10)
   10 FORMAT (/,' -LINK1 DEBUG- SEMDBD DATA BLOCK NOT LOADED CORRECTLY')
C
C     CALL BTSTRP TO INITIALIZE MACHINE CONSTANTS
C
   20 WRITE  (6,30)
   30 FORMAT (/,' -LINK1 DEBUG- MACHCK CALLING BTSTRP NEXT')
      CALL BTSTRP
C
      WRITE  (6,40)
   40 FORMAT ( ' -LINK1 DEBUG-  CHARACTER, SHIFT AND COMPLEX CHECKS')
      L  = KHRFN1(I,2,J,3)
      IF (L .EQ. K) GO TO 60
      NOGO = 2
      WRITE  (6,50) I,J,K,L
   50 FORMAT (' * KHRFN1 ERROR   I,J,K,L =',4(1X,A4))
   60 I  = 128
      J  = LSHIFT(I,2)
      K  = RSHIFT(I,2)
      IF (J.EQ.512 .AND. K.EQ.32) GO TO 80
      NOGO = 3
      WRITE  (6,70)
   70 FORMAT (' * LSHIFT AND/OR RSHIFT ERROR')
C
C     JUMP TO 100 IF MACHINE DOES NOT HAVE ISHFT FUNCTION
C
   80 J  = ISHFT(I,+2)
      K  = ISHFT(I,-2)
      IF (J.EQ.512 .AND. K.EQ.32) GO TO 110
      NOGO = 4
      IF (J .NE. 512) WRITE (6,90)
      IF (K .NE.  32) WRITE (6,100)
   90 FORMAT (' * ISHFT(+) NOT SAME AS LSHIFT')
  100 FORMAT (' * ISHFT(-) NOT SAME AS RSHIFT')
C
C     CHECK ISHFT IS ZERO-FILL
C
  110 I  = -1
      J  = ISHFT(I,-1)
      K  = ISHFT(I,+1)
      IF (J.GT.0 .AND. MOD(K,2).EQ.0) GO TO 130
      NOGO = 5
      WRITE  (6,120)
  120 FORMAT (' * SYSTEM ISHFT IS NOT ZERO-FILL')
C
C     CHECK K2B SUBROUTINE
C
  130 CALL K2B (L21,AR,5)
      IF (AR(2).EQ.IA .AND. AR(5).EQ.IR) GO TO 150
      NOGO = 6
      WRITE  (6,140) AR(2),AR(5)
  140 FORMAT (' * K2B ERROR   A,R ==',2A4)
C
C     COMPLEX NUMBER CHECK
C
  150 F  = D*E
      DR = REAL (D)
      DI = AIMAG(D)
      ER = REAL (E)
      EI = AIMAG(E)
      A  = DR*ER - DI*EI
      B  = DR*EI + DI*ER
      IF (ABS(A-REAL(F)).LE..01 .AND. ABS(B-AIMAG(F)).LE..01) GO TO 170
      NOGO = 7
      WRITE  (6,160)
  160 FORMAT (' * COMPLEX ERROR')
  170 IF (MASK .EQ. 65535) GO TO 190
      NOGO = 8
      WRITE  (6,180)
  180 FORMAT (' * LABEL COMMON /SEM/ ERROR')
  190 IF (SPERLK.EQ.1 .OR. SPERLK.EQ.0) GO TO 210
      NOGO = 9
      WRITE  (6,200)
  200 FORMAT (' * LABEL COMMON /SYSTEM/ ERROR')
  210 IF (NOGO .EQ. 0) WRITE (6,220)
  220 FORMAT ('  OK')
C
C     LOGICAL 'AND' AND 'OR' CHECK.
C     SYSTEM MAY NAME THESE FUNCTIONS - 'IAND', 'IOR', OR 'AND', 'OR'
C     IF UNSATISFIED EXTERNALS OCCUR, FIX THEM HERE AND IN MAPFNS.MDS
C
      WRITE  (6,230)
  230 FORMAT ('  LOGICAL "AND" AND "OR" CHECK.  IF ERROR OCCURS, ',
     1        'SEE MACHCK')
      K  = IAND(I,J)
      K  =  IOR(I,J)
      WRITE (6,220)
C
C     CHECK DATE AND TIME, ALREADY SAVED IN /SYSTEM/ BY NASTRN OR NAST01
C
C     TIME IS SYSTEM CPU TIME, COMMONLY IN 1/60 SECONDS ACCURCY
C     IF UNSATISFIED EXTERNALS OCCUR, FIX THEM IN TDATE, KLOCK, WALTIM,
C     CPUTIM, AND/OR SECNDS(IN MAPFNS) SUBROUTINES
C
      WRITE  (6,240)
  240 FORMAT ('  DATE AND TIME CHECKS.  IF ERROR OCCURS, SEE MACHCK')
      I  = TIMEW/3600
      J  = (TIMEW-I*3600)/60
      K  = TIMEW - I*3600 - J*60
      WRITE  (6,250) DATE,I,J,K
  250 FORMAT (' -MONTH/DAY/YEAR = ',I2,1H/,I2,1H/,I2, 3X,
     1        ' -HOUR:MIN:SEC = ',I2,':',I2,':',I2)
      IF (DATE(1).GT.12 .OR. DATE(3).GT.1000) WRITE (6,260)
  260 FORMAT (' * SYSTEM DATE SHOULD BE IN mm,dd,yy',
     1       ' ORDER  <===')
C
      R  = MOD(LQRO,100)/10
      IF (R .GT. 1) L1 = BT
      IF (MOD(LQRO,10) .EQ. 1) L2 = RV
      WRITE  (6,270) MACHX,MCHNAM,L1,L2,SYSBUF,LQRO
  270 FORMAT (/,' -MACHINE =',I3,2H, ,A4,', RECL BY ',A4,
     1       'S, BCD WORD IN ',A8,' ORDER,', /3X,'SYSBUF =',I7,
     2       ' WORDS,  LQRO =',I7)
C
C     OPEN A DIRECT FILE, FORTRAN UNIT 41, AND TEST FOR RECORD LENGTH
C
      I  = SYSBUF - 3
      IF (MACHX.EQ.3 .OR. MACHX.GE.5) I = SYSBUF - 4
      I  = I*R
      OPEN  (UNIT=41,ACCESS='DIRECT',RECL=I,STATUS='SCRATCH',ERR=310)
      WRITE (41,REC=1,ERR=280) (Z(J),J=1,I)
      GO TO 300
  280 IF (R .GT. 1) GO TO 300
      NOGO = 10
      WRITE  (6,290) R
  290 FORMAT (' * FORTRAN I/O RECORD LENGTH IN BTSTRP MAY BE IN ERROR.',
     1       5X,'R =',I4)
  300 CLOSE  (UNIT=41)
C
C     CHECK OPEN CORE IN MEMORY                          ** NEW, NEXT 28
C
  310 J  = 11
      I  = LOCFX(Z(J))
      J  = LOCFX(Z(1))
      K  = AS
      IF (I .LT. J) K = DS
      WRITE  (6,320) K,J,I
  320 FORMAT (' * SYSTEM MEMORY IN ',A3,'CENDING ORDER',I15,'==>',I12)
C
C     CHECK WHETHER NUMTYP.MIS IS SET UP FOR THIS CURRENT MACHINE
C
      K  = 123
      IF (NUMTYP(K) .NE. 1) NOGO = 11
C
C     CHECK /SOFPTR/ LOCATION WITH RESPECT TO /ZZZZZZ/ LOCATION HERE IF
C     AND ONLY IF CURRENT NASTRAN VERSION STILL USES /SOFPTR/, AND
C     SET K = 1
C                  K J          I           I          J K
C               ---+-+----------+   OR   ---+----------+-+
C                    ASCENDING                 DECENDING
C
      K  = 0
      IF (K .NE. 1) GO TO 340
C
      K  = LOCFX(S)
      IF (I.GT.J .AND. K.GT.J) WRITE (6,330)
      IF (I.LT.J .AND. K.LT.J) WRITE (6,330)
  330 FORMAT (' * COMMONS /SOFPTR/ AND /ZZZZZZ/ POSITIONS SHOULD BE ',
     1        'REVERSED IN OPNCOR.MDS')
C
C     CHECK S.P. NUMERIC RANGE
C
  340 IF (10.0**(LOWPW+1).GE.0.0 .AND. 10.0**(HIGHPW-1).GT.10.0**36)
     1    GO TO 360
      NOGO = 12
      WRITE  (6,350) LOWPW,HIGHPW
  350 FORMAT (' * MACHINE NUMERIC RANGE, 10.**',I3,' THRU 10.**',I2,
     1        ' SET BY BTSTRP, EXCEEDS MACHINE LIMIT.')
C
C     CHECK FORTRAN MIXED FORMAT WRITE USED IN SUBOURINTE OFPPNT OF THE
C     OFP MODULE.
C     DEC/ULTRIX FORTRAN 3.0 (1992) FAILS ON THIS TEST.
C
  360 IX = 123456
      WRITE  (6,370,ERR=380) XX
  370 FORMAT (/,I10)
  380 WRITE  (6,390)
  390 FORMAT (' IF 123456 IS NOT PRINTED ON ABOVE LINE, MIXED FORMAT ',
     1        'PRINT OUT IS NOT', /1X,
     2        'ALLOWED, AND NASTRAN OFP MODULE MAY NOT WORK PROPERLY')
C
C     CHECK OPEN CORE
C
      J  = 5000
      Z(J) = 1
      Z(HICORE) = 2
C
      IF (NOGO .NE. 0) GO TO 410
      WRITE  (6,400) UIM
  400 FORMAT (A29,', MACHINE COMPATIBILITY CHECK ROUTINE FINDS NO ',
     1        /5X,'SIGNIFICANT SYSTEM ERROR')
      RETURN 1
C
  410 WRITE  (6,420) UIM,NOGO
  420 FORMAT (A29,' * ERROR IN MACHCK.  NOGO =',I3)
      CALL MESAGE (-61,0,0)
      RETURN
      END

      SUBROUTINE AMGBFS (SKJ,EE,DELX,NC,NBA,XIS2,XIS1,A0,A0P,NSBE)
C
C     BUILD SKJ CALL BFSMAT THEN SHUFFEL AND DEAL
C
      INTEGER         SKJ,NAME(2),TSKJ,SYSBUF,SCR1,SCR2,ECORE
      DIMENSION       EE(1),DELX(1),NC(1),NBA(1),XIS2(1),XIS1(1),A0(1),
     1                A0P(1),NSBE(1)
      COMMON /AMGMN / MCB(7),NROW,ND,NE,REFC,FMACH,RFK,TSKJ(7),ISK,NSK
      COMMON /DLBDY / NJ1,NK1,NP,NB,NTP,NBZ,NBY,NTZ,NTY,NT0,NTZS,NTYS,
     1                INC,INS,INB,INAS,IZIN,IYIN,INBEA1,INBEA2,INSBEA,
     2                IZB,IYB,IAVR,IARB,INFL,IXLE,IXTE,INT121,INT122,
     3                IZS,IYS,ICS,IEE,ISG,ICG,IXIJ,IX,IDELX,IXIC,IXLAM,
     4                IA0,IXIS1,IXIS2,IA0P,IRIA,INASB,IFLA1,IFLA2,ITH1A,
     5                ITH2A,ECORE,NEXT,SCR1,SCR2,SCR3,SCR4,SCR5
      COMMON /SYSTEM/ SYSBUF
      COMMON /ZBLPKX/ A(4),IIS
      COMMON /ZZZZZZ/ Z(1)
      DATA    NAME  / 4HAMGB,4HFS  /
      DATA    NHBFS , NHG,NHA      / 4HBFS ,4HG   ,4HA   /
C
      NSB   = NTYS + NTZS
      NZY2  = NSB*2
      NT02  = NT0*2
      NTP2  = NTP*2
      LENGTH= NT0 + NSB
      ISL   = ISK - 1
      II    = ISK + LENGTH
      NN    = NSK + NZY2 + NTP2
      IBUF2 = ECORE
      IF (NSB .EQ. 0) GO TO 40
      IBUF2 = ECORE - SYSBUF
C
C     CALL BFSMAT
C     SCR1 HAS NTZS + NTYS ROWS WITH NTO*2 THEN NTZS+NTYS*2 TERMS
C     ROWS ARE Z FOR Z , Y THEN Z FOR ZY , AND Y FOR Y
C
      CALL GOPEN (SCR1,Z(IBUF2),1)
      ICORR = NEXT
      IF (NEXT+LENGTH*4 .GT. IBUF2) GO TO 998
      CALL BFSMAT (ND,NE,NB,NP,NTP,LENGTH,NT0,SCR1,JF,JL,Z(INAS),FMACH,
     1             Z(IYB),Z(IZB),Z(IYS),Z(IZS),Z(IX),DELX,EE,Z(IXIC),
     2             Z(ISG),Z(ICG),Z(IARB),Z(IRIA),Z(INBEA1),Z(INBEA2),
     3             Z(INASB),Z(INB),NC,Z(ICORR),Z(IAVR),REFC,A0,XIS1,
     4             XIS2,RFK,NSBE,NT0)
      CALL WRITE  (SCR1,0,0,1)
      CALL CLOSE  (SCR1,1)
      CALL DMPFIL (SCR1,Z(NEXT),IBUF2-NEXT)
      CALL GOPEN  (SCR1,Z(IBUF2),0)
      NCORE = NT0*NZY2*2
      IF (NCORE+NEXT .GT. IBUF2) GO TO 998
      CALL ZEROC  (Z(NEXT),NCORE)
      I    = NEXT
      IZBF = 1
      DO 30 J = 1,NSB
      CALL FREAD (SCR1,Z(I),NT02,0)
      CALL FREAD (SCR1,Z(I),-NZY2,0)
      I = I + NT02
      IF (JF .EQ. 0) GO TO 20
      IF (J.LT.JF .OR. J.GT.JL) GO TO 20
      IZBF = -IZBF
      IF (IZBF .LT. 0) GO TO 30
      I = I + NT02
   20 I = I + NT02
   30 CONTINUE
      CALL BCKREC (SCR1)
C
C     BUILD NT0 COLUMNS OF SKJ
C
   40 IF (NT0 .EQ. 0) GO TO 100
      IBF  = NEXT - 2
      K    = 1
      KS   = 1
      NBXR = NC(K)
      DO 70 I = 1,NT0
      CALL BLDPK (3,3,SKJ,0,0)
      IF (I .GT. NTP) GO TO 45
      A(1) = 2.0*EE(KS)*DELX(I)
      A(2) = 0.0
      IIS  = ISL + (I-1)*2 + 1
      CALL ZBLPKI
      A(1) = (EE(KS)*DELX(I)**2)/2.0
      IIS  = IIS + 1
      CALL ZBLPKI
      IF (I .EQ.    NTP) GO TO 45
      IF (I .EQ. NBA(K)) K = K + 1
      IF (I .EQ.   NBXR) GO TO 44
      GO TO 45
   44 KS   = KS + 1
      NBXR = NBXR + NC(K)
   45 IF (NSB .EQ. 0) GO TO 60
      IBF  = IBF + 2
      DO 50 J = 1,NZY2
      L    = (J-1)*NT02
      A(1) = Z(IBF+L  )
      A(2) = Z(IBF+L+1)
      IIS  = ISL + NTP2 + J
      CALL ZBLPKI
   50 CONTINUE
   60 CALL BLDPKN (SKJ,0,TSKJ)
   70 CONTINUE
C
C     SLENDER BODY ONLY PART OF SKJ  BFS * G
C
  100 IF (NSB .EQ. 0) GO TO 900
      NCORE = NZY2*NSB*4 + NSB*NSB*2
      IF (NCORE+NEXT .GT. IBUF2) GO TO 998
      CALL ZEROC (Z(NEXT),NCORE)
      I    = NEXT
      IZBF = 1
      DO 130 J = 1,NSB
      CALL FREAD (SCR1,Z(I),-NT02,0)
      CALL FREAD (SCR1,Z(I), NZY2,0)
      I = I + NZY2
      IF (JF .EQ. 0) GO TO 120
      IF (J.LT.JF .OR. J.GT.JL) GO TO 120
      IZBF = -IZBF
      IF (IZBF .LT. 0) GO TO 130
      I = I + NZY2
  120 I = I + NZY2
  130 CONTINUE
C
C     BFS AT NEXT  G AT IG
C
      IG   = I
      IA   = IG + NSB*NSB*2
      NFYB = NB + 1 - NBY
      IROW = IG
      RFKOC= 2.0*RFK/REFC
      IBZY = 0
      P5   = .5
      IF (NTZS .EQ. 0) GO TO 170
      NFSE = 1
      NLSE = 0
      NFB  = 1
      NBX  = NBZ
  141 DO 160 IB = NFB,NBX
      NLSE = NLSE + NSBE(IB)
      DO 150 IT = NFSE,NLSE
      DX   = XIS2(IT) - XIS1(IT)
      A02P = 2.0/A0(IT)*A0P(IT)
      IF (NFSE .EQ. NLSE) GO TO 148
      IF (IT   .NE. NFSE) GO TO 142
      X2 = P5*(XIS2(IT+1) + XIS1(IT+1))
      X1 = P5*(XIS2(IT  ) + XIS1(IT  ))
      Z(IROW  ) = (-1.0/(X2-X1))*DX
      Z(IROW+2) = -Z(IROW)*(A0(IT)/A0(IT+1))**2
      GO TO 148
  142 IF (IT .EQ. NLSE) GO TO 145
      X1 = P5*(XIS2(IT-1) + XIS1(IT-1))
      X2 = P5*(XIS2(IT  ) + XIS1(IT  ))
      X3 = P5*(XIS2(IT+1) + XIS1(IT+1))
      Z(IROW-2) = (1.0/(X3-X1) - 1.0/(X2-X1))*DX*(A0(IT)/A0(IT-1))**2
      Z(IROW)   = (1.0/(X2-X1) - 1.0/(X3-X2))*DX
      Z(IROW+2) = (1.0/(X3-X2) - 1.0/(X3-X1))*DX*(A0(IT)/A0(IT+1))**2
      GO TO 148
  145 X1 = P5*(XIS2(IT-1) + XIS1(IT-1))
      X2 = P5*(XIS2(IT  ) + XIS1(IT  ))
      Z(IROW  ) = (1.0/(X2-X1))*DX
      Z(IROW-2) =-Z(IROW)*(A0(IT)/A0(IT-1))**2
  148 Z(IROW  ) = Z(IROW) + DX*A02P
      Z(IROW+1) = DX*RFKOC
      IROW = IROW + NZY2 + 2
  150 CONTINUE
      NFSE = NFSE + NSBE(IB)
  160 CONTINUE
  170 IF (IBZY .EQ. 1) GO TO 200
      IBZY = 1
      IF (NTYS .EQ. 0) GO TO 200
      NFB  = NFYB
      NBX  = NB
      NFSE = 1
      NLSE = 0
      NL   = NFYB - 1
      IF (NL .EQ. 0) GO TO 141
      DO 172 J = 1,NL
      NLSE = NLSE + NSBE(J)
      NFSE = NFSE + NSBE(J)
  172 CONTINUE
      GO TO 141
C
C     MULTIPLY BFS * G
C
  200 CALL BUG (NHBFS ,200,Z(NEXT),NZY2*NZY2)
      CALL BUG (NHG   ,200,Z(IG),NSB*NSB*2)
      CALL GMMATC (Z(NEXT),NZY2,NSB,0,Z(IG),NSB,NSB,0,Z(IA))
      CALL BUG (NHA   ,200,Z(IA),NZY2*NSB*2)
      IROW = IA - 2
      DO 220 I = 1,NSB
      CALL BLDPK (3,3,SKJ,0,0)
      IROW = IROW + 2
      K    = IROW
      DO 210 J = 1,NZY2
      A(1) = Z(K  )
      A(2) = Z(K+1)
      IIS  = ISL + NTP2 + J
      CALL ZBLPKI
      K    = K + NZY2
  210 CONTINUE
      CALL BLDPKN (SKJ,0,TSKJ)
  220 CONTINUE
  900 ISK  = II
      NSK  = NN
      CALL CLOSE (SCR1,1)
 1000 RETURN
C
C     ERROR MESSAGES
C
  998 CALL MESAGE (-8,0,NAME)
      GO TO 1000
      END

      SUBROUTINE MCE1B
C
C     MCE1B DECOMPOSES RM INTO LOWER AND UPPER TRIANGULAR FACTORS
C
      INTEGER USET  , RG    ,GM    ,SCR1  ,SCR2  ,SCR3  ,RM    ,RN   ,
     1        A     , UX    ,SCRX1 ,SCRX2 ,SCRX3 ,NAM(2),U
      DOUBLE PRECISION DET  ,MINDIA
      COMMON /BLANK / USET  ,RG    ,GM    ,SCR1  ,SCR2  ,SCR3  ,RM    ,
     1                RN    ,L     ,U     ,MCB(7)
      COMMON /DCOMPX/ A(7)  ,LX(7) ,UX(7) ,SCRX1 ,SCRX2 ,SCRX3 ,DET   ,
     1                POWER ,NZ    ,MINDIA
      COMMON /ZZZZZZ/ Z(1)
      DATA    NAM   / 4HMCE1,4HB   /
C
C     INITIALIZE MATRIX CONTROL BLOCKS
C
      NZ    = KORSZ(Z)
      A(1)  = RM
      CALL RDTRL (A)
      LX(1) = L
      LX(3) = A(3)
      LX(4) = 4
      LX(5) = A(5)
      UX(1) = U
      UX(3) = A(3)
      UX(4) = 5
      UX(5) = A(5)
      SCRX1 = SCR1
      SCRX2 = SCR2
      SCRX3 = SCR3
C
C     PERFORM DECOMPOSITION
C
      CALL DECOMP (*40,Z,Z,Z)
C
C     WRITE TRAILERS
C
      CALL WRTTRL (LX)
      CALL WRTTRL (UX)
      RETURN
C
C     FATAL ERROR MESSAGE FOR SINGULAR MATRIX
C
   40 CALL MESAGE (-5,RM,NAM)
      RETURN
      END

      SUBROUTINE CINVPR (EED,METHOD,NFOUND)
C
C     GIVEN REAL OR COMPLEX MATRICIES, CINVPR WILL SOLVE FOR ALL OF
C     THE EIGENVALUES AND EIGENVECTORS WITHIN A SPECIFIED REGION
C
C     DEFINITION OF INPUT AND OUTPUT PARAMETERS
C
C     FILEK(7) = MATRIX CONTROL BLOCK FOR THE INPUT STIFFNESS MATRIX K
C     FILEM(7) = MATRIX CONTROL BLOCK FOR THE INPUT MASS MATRIX M
C     FILEB(7) = MATRIX CONTROL BLOCK FOR THE INPUT DAMPING MATRIX B
C     FILELM(7)= MATRIX CONTROL BLOCK FOR THE OUTPUT EIGENVALUES
C     FILEVC(7)= MATRIX CONTROL BLOCK FOR THE OUTPUT EIGENVECTORS
C     DMPFIL   = FILE CONTAINING THE EIGENVALUE SUMMARY
C     SR1FIL-  = SCRATCH FILES USED INTERNALLY
C     SR0FIL
C     EPS      = CONVERGENCE CRITERIA
C     NOREG    = NUMBER OF REGIONS INPUT
C     REG(1,I) = X1 FOR REGION I
C     REG(2,I) = Y1 FOR REGION I
C     REG(3,I) = X2 FOR REGION I
C     REG(4,I) = Y2 FOR REGION I
C     REG(5,I) = L1 FOR REGION I
C     REG(6,I) = NO. OF DESIRED  ROOTS FOR REGION I
C     REG(7,I) = NO. OF ESTIMATED ROOTS IN REGION I
C
C
      LOGICAL          NOLEFT
      INTEGER          METHOD    ,EED      ,EIGC(2)  ,PHIDLI  ,
     1                 SWITCH    ,SCRFIL   ,IHEAD(10),IREG(7,1)
      INTEGER          NAME(2)   ,FILELM   ,FILEVC   ,
     1                 REAL      ,RDP      ,TYPEK    ,TYPEM    ,
     2                 TYPEB     ,COMFLG   ,IZ(1)    ,DMPFIL   ,
     3                 TIMED     ,FILEK    ,T1       ,T2       ,
     4                 FILEB     ,FILEM
      REAL             L         ,L1       ,MAXMOD
      DOUBLE PRECISION LAM1      ,DZ(1)    ,MINDIA
      DOUBLE PRECISION LAMBDA    ,LMBDA    ,DTEMP(2)
      CHARACTER        UFM*23
      COMMON /XMSSG /  UFM
      COMMON /CDCMPX/  IDUM(30)  ,MINDIA
      COMMON /CINVPX/  FILEK(7)  ,FILEM(7) ,FILEB(7) ,FILELM(7),
     1                 FILEVC(7) ,DMPFIL   ,SCRFIL(11),NOREG   ,
     2                 EPS       ,REG(7,10),PHIDLI
      COMMON /NAMES /  RD        ,RDREW    ,WRT       ,WRTREW  ,
     1                 REW       ,NOREW    ,EOFNRW    ,RSP     ,
     1                 RDP
      COMMON /SYSTEM/  KSYSTM(65)
      COMMON /ZZZZZZ/  Z(1)
      COMMON /OUTPUT/  HEAD(1)
      COMMON /CINVXX/  LAMBDA(2) ,SWITCH   ,COMFLG    ,LMBDA(2),
     1                 ITER      ,TIMED    ,NOCHNG    ,RZERO   ,
     2                 IND       ,IVECT    ,KREG      ,REAL    ,
     3                 LEFT      ,NORTHO   ,NOROOT    ,NZERO   ,
     4                 LAM1(2)   ,MAXMOD   ,NODES     ,NOEST   ,
     5                 ISTART    ,IND1     ,ITERX     ,ISYM
      EQUIVALENCE      (KSYSTM(1),ISYS )   ,(IREG(1,1),REG(1,1))
      EQUIVALENCE      (FILEK(5) ,TYPEK)   ,(FILEM(5),TYPEM)   ,
     1                 (FILEB(5) ,TYPEB)   ,(IZ(1),Z(1))
      EQUIVALENCE      (ANODES   ,NODES)   ,(ANOEST,NOEST)     ,
     1                 (Z(1)     ,DZ(1))   ,(KSYSTM(2),NOUT )
      DATA     IHEAD/  0,1009,2,7*0 /
      DATA     EIGC /  207,2        /
      DATA     NAME /  4HCINV,4HPR  /
      DATA     SIGN /  1.0          /
C
C     DEFINITION OF INTERNAL PARAMETERS
C
C     REAL     = 0 - ALL MATRICIES ARE REAL
C                1 - AT LEAST ONE MATRIX IS COMPLEX
C     NSHIFT   = NO. OF SHIFT POINTS IN A REGION
C     NODES    = NO. OF DESIRED ROOTS IN A REGION
C     NOEST    = NO. OF ESTIMATED ROOTS IN A REGION
C     SHIFT    = INDEX OF THE CURRENT SHIFT POINT
C     ISHIFT   = INDEX OF THE CURRENT SHIFT POINT
C     IMIN     = LOWEST INDEX OF THE COMPLETED SHIFT POINTS
C     IMAX     = HIGHEST INDEX OF COMPLETED SHIFT POINTS
C
C     FILE ALLOCATION
C
C     SR1FIL CONTAINS (LAMBDA**2*M + LAMBDA*B + K)
C     SR2FIL CONTAINS -(B+LAMBDA*M)
C     SR3FIL CONTAINS THE LOWER TRIANGLE OF THE DECOMPOSED DYNAMIC MTRX
C     SR4FIL CONTAINS THE UPPER TRIANGLE OF THE DECOMPOSED DYNAMIC MTRX
C     SR5FIL IS USED AS A SCRATCH FOR CDCOMP
C     SR6FIL IS USED AS A SCRATCH FOR CDCOMP
C     SR7FIL IS USED AS A SCRATCH FOR CDCOMP
C     SR8FIL CONTAINS THE LOWER TRIANGLE L
C     SR9FIL CONTAINS THE UPPER TRIANGLE U
C     SR0FIL CONTAINS THE LEFT EIGENVECTORS
C     S11FIL CONTAINS  -(B + LAMBDA*M)
C
C     DEFINITION OF INTERNAL PARAMETERS
C
C     IND      = AN INDEX FOR GENERATING VARIOUS STARTING VECTORS
C     ITER     = TOTAL NUMBER OF ITERATIONS
C     NODCMP   = TOTAL NUMBER OF DECOMPOSITIONS
C     NOSTRT   = NUMBER OF STARTING POINTS USED
C     NOMOVS   = NUMBER OF TIMES A STARTING POINT HAD TO BE MOVED
C     RZERO    = DISTANCE FROM THE STARTING POINT TO THE CORNER OF THE
C                PARALELOGRAM
C     NOCHNG   = COUNT OF THE NUMBER OF MOVES WHILE LOOKING FOR ONE ROO
C     COMFLG   = 0 -
C              = 1 -
C              = 2 -
C              = 3 -
C              = 4 -
C              = 5 -
C              = 6 -
C     SWITCH   =
C     IVECT    =
C     KREG     = 0-NO VECTORS FOUND IN SEARCH AREA YET
C                1- A VECTOR HAS BEEN FOUND IN THE SEARCH AREA
C     ISING    = SINGULARITY FLAG
C     ITERM    = REASON FOR TERMINATING
C              = 1 - 2SINGULARITIES IN A ROW
C              = 2 - 4 MOVES WHILE TRACKING ONE ROOT
C              = 3 - ALL REGIONS COMPLETED
C              = 4 - 3*NOEST FOUND
C              = 5 - ALL ROOTS FOUND
C              = 8 - 200 ITERATIONS WITH ONE MOVE WITHOUR CONVERGING
C     TIMED    = TIME TOO FORM AND DECOMPOSE THE DYNAMIC MATRIX
C     LEFT     = 1 - DECOMPOSE MATRIX FOR THE COMPUTATION OF THE LEFT
C                EIGENVECTORS
C
      CALL SSWTCH (12,IDIAG)
      IND1 = 0
      NZ   = KORSZ(Z)
      CALL KLOCK (ISTART)
      IBUF = NZ - ISYS - 2
      IFILE= FILELM(1)
      CALL OPEN  (*500,FILELM,Z(IBUF),WRTREW)
      CALL CLOSE (FILELM,REW)
      IFILE = FILEVC (1)
      CALL OPEN  (*500,FILEVC,Z(IBUF),WRTREW)
      CALL CLOSE (FILEVC,REW)
      CALL GOPEN (DMPFIL,Z(IBUF),WRTREW)
      CALL CLOSE (DMPFIL,EOFNRW)
      IFILE = SCRFIL(10)
      CALL OPEN (*500,IFILE,Z(IBUF),WRTREW)
      CALL CLOSE (IFILE,REW)
      NOLEFT = .FALSE.
      IZ(1)  = 204
      CALL RDTRL (IZ)
      IF (IZ(1) .LT. 0) NOLEFT = .TRUE.
      NORTHO = 0
      NROW   = 2*FILEK(3)
      NROW2  = 2*NROW
      ISYM   = 1
      IF (FILEK(1).NE.0 .AND. FILEK(4).NE.6) GO TO 2
      IF (FILEM(1).NE.0 .AND. FILEM(4).NE.6) GO TO 2
      IF (FILEB(1).NE.0 .AND. FILEB(4).NE.6) GO TO 2
      ISYM = 0
    2 CONTINUE
C
C     PICK UP REGION PARAMETERS
C
      CALL PRELOC (*500,Z(IBUF),EED)
      CALL LOCATE (*500,Z(IBUF),EIGC(1),FLAG)
    6 CALL FREAD (EED,IREG,10,0)
      IF (METHOD.EQ.IREG(1,1) .OR. METHOD.EQ.-1) GO TO 8
    7 CALL FREAD (EED,IREG,7,0)
      IF (IREG(6,1) .NE. -1) GO TO 7
      GO TO 6
    8 JREG = 1
      EPS  = .0001
      IF (REG(1,2) .NE. 0.) EPS = REG(1,2)
   11 CALL FREAD (EED,IREG(1,JREG),7,0)
      IF (IREG(6,JREG) .EQ. -1) GO TO 9
      JREG = JREG + 1
      IF (JREG .GT. 10) GO TO 9
      GO TO 11
    9 CALL CLOSE (EED,REW)
      NOREG = JREG - 1
      JREG  = 0
C
C     PICK UP PARAMETERS FOR REGION I
C
    5 JREG   = JREG + 1
      ITER   = 0
      NODCMP = 0
      NOSTRT = 0
      NOMOVS = 0
      X1     = REG(1,JREG)
      Y1     = REG(2,JREG)
      X2     = REG(3,JREG)
      Y2     = REG(4,JREG)
      L      = REG(5,JREG)
      ANOEST = REG(6,JREG)
      ANODES = REG(7,JREG)
      IF (NODES.EQ. 0) NODES = 3*NOEST
      NSHIFT = SQRT((X1-X2)**2+(Y1-Y2)**2)/L + 1.
      L1     = L*.5
      NOROOT = 0
C
C
C     FIND SHIFT POINT CLOSEST TO THE ORIGIN
C
      R = SQRT((X1-X2)**2 + (Y1-Y2)**2)
      IF (R) 10,10,15
   10 WRITE  (NOUT,12) UFM
   12 FORMAT (A23,' 2366, REGION IMPROPERLY DEFINED ON EIGC CARD.')
      CALL MESAGE (-61,0,0)
   15 CONTINUE
      D = (FLOAT(NSHIFT)*L-R)/2.0
      XX = X1 + D*(X1-X2)/R
      X2 = X2 + D*(X2-X1)/R
      X1 = XX
      YY = Y1 + D*(Y1-Y2)/R
      Y2 = Y2 + D*(Y2-Y1)/R
      Y1 = YY
      IF (IDIAG .EQ. 0) GO TO 7000
      WRITE  (NOUT,1000) X1,Y1,X2,Y2,L1,NODES,NOEST,NSHIFT
 1000 FORMAT (1H1,5F10.2,3I5)
 7000 CONTINUE
      DELTX = (X1-X2)/FLOAT(NSHIFT)
      DELTY = (Y1-Y2)/FLOAT(NSHIFT)
      XX    = X2 + DELTX/2.
      YY    = Y2 + DELTY/2.
      RANGE = XX**2  + YY**2
      N     = NSHIFT - 1
      SHIFT = 1.
      IF (DELTX .NE. 0.) GO TO 20
      ANUM1 = L1
      ANUM2 = 0.
      GO TO 25
   20 SLOPE = DELTY/DELTX
      ARG   = SQRT(1.+SLOPE**2)
      ANUM1 = SLOPE*L1/ARG
      ANUM2 = L1/ARG
   25 CONTINUE
      IF (N .EQ. 0) GO TO 40
      DO 30 I = 1,N
      XX    = XX + DELTX
      YY    = YY + DELTY
      RANG  = XX**2 + YY**2
      IF (RANG .GE. RANGE) GO TO 40
      RANGE = RANG
   30 SHIFT = I + 1
C
C     COMPUTE COORDINATES OF CORNERS OF THE REGION
C
   40 XL2   = X2 + ANUM1
      YL2   = Y2 - ANUM2
      IMIN  = SHIFT
      IMAX  = SHIFT
C
C     FIND THE MAXIMUM MODULUS OF THE SEARCH REGION
C
      MAXMOD = XL2**2 + YL2**2
      XX     = X2 - ANUM1
      YY     = Y2 + ANUM2
      MAXMOD = AMAX1(MAXMOD,XX**2+YY**2)
      XX     = X1 + ANUM1
      YY     = Y1 - ANUM2
      MAXMOD = AMAX1(MAXMOD,XX**2+YY**2)
      XX     = X1 - ANUM1
      YY     = Y1 + ANUM2
      MAXMOD = AMAX1(MAXMOD,XX**2+YY**2)
C
C     INITIALIZE
C
      IND    = 0
      LEFT   = 0
   45 ISHIFT = SHIFT
C
C     EVALUATE THE VALUE OF LAMBDA IN THE CENTER OF THE CURRENT SEARCH
C     REGION
C
      LAMBDA(1) = X2 + (SHIFT-.5)*DELTX
      LAMBDA(2) = Y2 + (SHIFT-.5)*DELTY
      IF (LAMBDA(2) .EQ. 0.0D0) LAMBDA(2) = .01*DELTY
C
C     COMPUTE DISTANCE TO FARTHEST CORNER OF THE SQUARE SEARCH REGION
C
      XX = XL2 + SHIFT*DELTX
      YY = YL2 + SHIFT*DELTY
      RZERO = (LAMBDA(1)-XX)**2 + (LAMBDA(2)-YY)**2
      RZERO = SQRT(RZERO)*1.05
      IF (IDIAG .EQ. 0) GO TO 7001
      WRITE  (NOUT,1216)RZERO
 1216 FORMAT (//,10H RZERO =     ,F10.4)
 7001 CONTINUE
      NOSTRT = NOSTRT + 1
      COMFLG = 0
   61 LMBDA(1) = LAMBDA(1)
      LMBDA(2) = LAMBDA(2)
      NOCHNG = 0
      SWITCH = 0
      IVECT  = 0
      KREG   = 0
      IND    = IND + 1
      IF (IABS (IND) .EQ. 13) IND = 1
      ISING  = 0
      GO TO 100
   80 ISING  = 0
      SWITCH = 1
  100 IF (NOCHNG .GE. 4) GO TO 220
      NOCHNG = NOCHNG + 1
      CALL KLOCK (T1)
C
C     CALL IN ADD LINK TO FORM (LAMBDA**2*M + LAMBDA*B + K)
C
      CALL CINVP1
C
C     CALL IN CD COMP TO DECOMPOSE THE MATRIX
C
      IF (IDIAG .EQ. 0) GO TO 7002
      WRITE  (NOUT,1001) LAMBDA
 1001 FORMAT (10H1LAMBDA =   ,2D15.5)
 7002 CONTINUE
      NODCMP = NODCMP + 1
      CALL CINVP2 (*110)
      CALL KLOCK (T2)
      GO TO 120
  110 IF (ISING .EQ. 1) GO TO 210
C
C     SINGULAR MATRIX. INCREMENT LAMBDA AND TRY ONCE MORE
C
      ISING = 1
      LAMBDA(1) = LAMBDA(1) + .02*RZERO
      LAMBDA(2) = LAMBDA(2) + .02*RZERO
      GO TO 100
C
C     DETERMINE THE TIME REQUIRED TO FORM AND DECOMPOSE THE DYNAMIC
C     MATRIX
C
  120 TIMED = T2 - T1
      IF (TIMED .EQ. 0) TIMED = 1
C
C     CALL IN MAIN LINK TO ITERATE FOR EIGENVALUES
C
  121 CALL CINVP3
      IF (LEFT   .EQ. 1) GO TO 130
      IF (COMFLG .EQ. 2) GO TO 125
      IF (COMFLG .EQ. 1) GO TO 80
      GO TO 140
  125 NOMOVS = NOMOVS + 1
      GO TO 61
C
C     CALL IN LINK TO COMPUTE THE LEFT EIGENVECTOR
C
  130 DTEMP(1)  = LAMBDA(1)
      DTEMP(2)  = LAMBDA(2)
      LAMBDA(1) = LAM1(1)
      LAMBDA(2) = LAM1(2)
  131 SWITCH    = -1
      CALL CINVP1
C
C     DECOMPOSE THE DYNAMIC MATRIX AT THE EIGENVALUE TO OBTAIN THE LEFT
C     EIGENVECTOR BY THE DETERMINATE METHOD
C
      IF (IDIAG .EQ. 0) GO TO 132
      WRITE (NOUT,1001) LAMBDA
  132 CALL CINVP2 (*138)
C
C     BUILD LOAD FOR FBS
C
      D1 = NROW/2
      D2 = NORTHO
      DO 133 I = 1,NROW,2
      K  = (I+1)/2
      DZ(I) = SIGN*MINDIA/(1.D0+(1.D0-FLOAT(K)/D1)*D2)
  133 DZ(I+1) = 0.0D0
      SIGN = -SIGN
      CALL CDIFBS (DZ(1),Z(IBUF))
      LAMBDA(1) = DTEMP(1)
      LAMBDA(2) = DTEMP(2)
      SWITCH = 0
C
C     NORMALIZE AND STORE THE LEFT EIGENVECTOR
C
      CALL CNORM1 (DZ(1),FILEK(2))
      IF (IDIAG .EQ. 0) GO TO 135
      WRITE  (NOUT,134) (DZ(I),I=1,NROW)
  134 FORMAT (///,15H LEFT VECTOR   ,//,(10D12.4))
  135 CONTINUE
      IF (NOLEFT .OR. ISYM.EQ.0) GO TO 136
      IFILE = PHIDLI
      CALL OPEN  (*500,IFILE,Z(IBUF),WRT)
      CALL WRITE (IFILE,DZ(1),NROW2,1)
      CALL CLOSE (IFILE,NOREW)
  136 IFILE = SCRFIL(10)
      CALL GOPEN (IFILE,Z(IBUF),RD)
      CALL BCKREC (IFILE)
      CALL FREAD (IFILE,DZ(NROW+2),NROW2,1)
      CALL BCKREC (IFILE)
      CALL CLOSE (IFILE,NOREW)
C
C     COMPUTE REAL LEFT VECTOR SCALED
C
      CALL CX TRN Y (DZ(1),DZ(NROW+2),DTEMP)
      CALL CDIVID (DZ(1),DZ(1),DTEMP,NROW)
      CALL OPEN (*500,IFILE,Z(IBUF),WRT)
      CALL WRITE (IFILE,DZ(1),NROW2,1)
      CALL CLOSE (IFILE,REW)
      GO TO 121
  138 LAMBDA(1) = 1.01*LAMBDA(1)
      LAMBDA(2) = 1.01*LAMBDA(2)
      GO TO 131
  140 IF (COMFLG .GE. 3) GO TO 200
      IF (COMFLG .EQ. 0) GO TO 160
      IF (IDIAG  .EQ. 0) GO TO 150
      WRITE  (NOUT,145) NOREG,JREG
  145 FORMAT (2I10)
  150 IF (NOREG .EQ. JREG) RETURN
      GO TO 5
C
C     FIND NEXT SHIFT POINT WHICH IS CLOSEST TO THE ORIGIN
C
  160 IF (IMIN .NE. 1) GO TO 170
      IF (IMAX .EQ. NSHIFT) GO TO 250
  165 SHIFT = SHIFT + 1.
      IMAX  = IMAX  + 1
      LAMBDA(1) = LMBDA(1) + DELTX
      LAMBDA(2) = LMBDA(2) + DELTY
      GO TO 45
  170 IF (IMAX .NE. NSHIFT) GO TO 180
  175 SHIFT = SHIFT - 1.
      IMIN  = IMIN  - 1
      LAMBDA(1) = LMBDA(1) - DELTX
      LAMBDA(2) = LMBDA(2) - DELTY
      GO TO 45
  180 XX   = LMBDA(1) - DELTX
      YY   = LMBDA(2) - DELTY
      RANG = XX**2 + YY**2
      XX   = LMBDA(1) + DELTX
      YY   = LMBDA(2) + DELTY
      RANGE= XX**2 + YY**2
      IF (RANGE-RANG) 175,175,165
  200 ITERM = COMFLG
      GO TO 260
C
C     SINGULARITY ENCOUNTERED TWICE IN A ROW
C
  210 ITERM = 1
      GO TO 260
C
C     4 MOVES WHILE TRACKING ONE ROOT
C
  220 ITERM = 2
      GO TO 260
C
C     REGIONS COMPLETED
C
  250 ITERM = 3
C
C     SET UP THE SUMMARY FILE
C
  260 IFILE = DMPFIL
      CALL OPEN  (*500,DMPFIL,Z(IBUF),WRT)
      CALL WRITE (DMPFIL,IHEAD(1),10,0)
      I       = 0
      IZ(I+2) = NORTHO
      IZ(I+3) = NOSTRT
      IZ(I+4) = NOMOVS
      IZ(I+5) = NODCMP
      IZ(I+6) = ITER
      IZ(I+7) = ITERM
      DO 270 I = 8,12
 270  IZ(I) = 0
      I = 2
      CALL WRITE (DMPFIL,IZ(I),40,0)
      CALL WRITE (DMPFIL,HEAD(1),96,1)
      CALL WRITE (DMPFIL,IZ(1),0,1)
      CALL CLOSE (DMPFIL,EOFNRW)
C
C     WRITE DUMMY TRAILER
      IXX = FILEK(1)
      FILEK(1) = DMPFIL
      CALL WRTTRL (FILEK(1))
      FILEK(1) = IXX
      NFOUND = NORTHO
      IF (IDIAG .EQ. 0) GO TO 350
      J = 12
      WRITE  (NOUT,300)(IZ(I),I=1,J)
  300 FORMAT (///,12I10)
  350 CONTINUE
      IF (ITERM .EQ. 5) RETURN
      GO TO 150
C
  500 CALL MESAGE (-1,IFILE,NAME)
      RETURN
      END

      SUBROUTINE DPD5
C
C     DPD5 ASSEMBLEMS
C     (1) THE EIGENVALUE EXTRACTION DATA BLOCK (EED), AND
C     (2) THE TRANSFER FUNCTION LIST (TFL).
C
C     REVISED  9/1989, BY G.C./UNISYS
C     NO COLUMN AND ROW WORD PACKING IN TFL FILE FOR MACHINES WITH 32
C     BIT WORD SIZE, OR LESS
C
      EXTERNAL        ANDF  ,ORF   ,LSHIFT
      LOGICAL         PACK
      INTEGER         GPL   ,SIL   ,USET  ,USETD ,GPLD  ,SILD  ,DPOOL  ,
     1                DLT   ,FRL   ,TFL   ,TRL   ,PSDL  ,EED   ,SCR1   ,
     2                SCR2  ,SCR3  ,SCR4  ,BUF   ,BUF1  ,BUF2  ,BUF3   ,
     3                BUF4  ,FLAG  ,FILE  ,EPOINT,SEQEP ,Z     ,LOADS  ,
     4                ORF   ,DLOAD ,FREQ1 ,FREQ  ,TIC   ,TSTEP ,TF     ,
     5                PSD   ,EIGR  ,EIGB  ,EIGC  ,NGRID ,EQDYN ,SDT    ,
     6                UA    ,UD    ,EIGP  ,ANDF  ,TWO
      INTEGER         IMSG(2)
      DIMENSION       BUF(24)   ,EPOINT(2)    ,SEQEP(2)     ,MCB(7)    ,
     1                NAM(2)    ,LOADS(32)    ,DLOAD(2)     ,FREQ1(2)  ,
     2                FREQ(2)   ,ZZ(1)        ,BUFR(20)     ,NOLIN(21) ,
     3                TIC(2)    ,TSTEP(2)     ,TF(2)        ,PSD(2)    ,
     4                MSG(3)    ,EIGR(2)      ,EIGB(2)      ,EIGC(2)   ,
     5                EIGP(2)
      COMMON /MACHIN/ MACH  ,IHALF ,JHALF
      COMMON /BLANK / LUSET ,LUSETD,NOTFL ,NODLT ,NOPSDL,NOFRL ,NONLFT ,
     1                NOTRL ,NOEED ,NOSDT ,NOUE
      COMMON /NAMES / RD    ,RDREW ,WRT   ,WRTREW,CLSREW
      COMMON /DPDCOM/ DPOOL ,GPL   ,SIL   ,USET  ,GPLD  ,SILD  ,USETD  ,
     1                DLT   ,FRL   ,NLFT  ,TFL   ,TRL   ,PSDL  ,EED    ,
     2                SCR1  ,SCR2  ,SCR3  ,SCR4  ,BUF   ,BUF1  ,BUF2   ,
     3                BUF3  ,BUF4  ,EPOINT,SEQEP ,L     ,KN    ,NEQDYN ,
     4                LOADS ,DLOAD ,FREQ1 ,FREQ  ,NOLIN ,NOGO  ,
     5                MSG   ,TIC   ,TSTEP ,TF    ,PSD   ,EIGR  ,EIGB   ,
     6                EIGC  ,MCB   ,NAM   ,EQDYN ,SDT   ,INEQ
      COMMON /BITPOS/ UM    ,UO    ,UR    ,USG   ,USB   ,UL    ,UA     ,
     1                UF    ,US    ,UN    ,UG    ,UE    ,UP    ,UNE    ,
     2                UFE   ,UD
      COMMON /SETUP / IFILE(6)
      COMMON /ZZZZZZ/ Z(1)
      COMMON /TWO   / TWO(32)
      COMMON /SYSTEM/ IBUF  ,NOUT
      EQUIVALENCE     (Z(1) ,ZZ(1)), (BUF(1) ,BUFR(1)), (MSG(2),NGRID)
      DATA    EIGP  / 257   ,4/
C
C     (1) PROCESS EDD
C     ===============
C
C     OPEN EED AND WRITE HEADER.
C     INITIALIZE TO LOOP THROUGH EIG CARDS.
C
C     OPEN DYNAMICS POOL.
C
      FILE = DPOOL
      CALL PRELOC (*310,Z(BUF1),DPOOL)
C
      FILE = EED
      CALL OPEN (*170,EED,Z(BUF2),WRTREW)
      FILE = DPOOL
      CALL FNAME (EED,BUF)
      CALL WRITE (EED,BUF,2,1)
      IN = 0
      DO 20 J = 2,7
   20 MCB(J) = 0
      L = 12
      MSG(1) = 75
C
C     LOCATE EIGB CARDS IN DYNAMICS POOL. IF PRESENT, TURN NOEED FLAG
C     OFF, WRITE ID ON EED AND TURN ON TRAILER BIT.
C
      CALL LOCATE (*30,Z(BUF1),EIGB,FLAG)
      NOEED = 1
      CALL WRITE (EED,EIGB,2,0)
      CALL WRITE (EED,0,1,0)
      J = (EIGB(2)-1)/16
      K =  EIGB(2) - 16*J
      MCB(J+2) = ORF(MCB(J+2),TWO(K+16))
      ASSIGN 23 TO NBACK
      L = 12
      MASK = TWO(UA)
C
C     READ EIGB CARDS. IF GRID NO. IS PRESENT, CONVERT TO SIL VALUE.
C     WRITE DATA ON EED.
C
   22 CALL READ (*320,*24,DPOOL,BUF,18,0,FLAG)
      GO TO 120
   23 CALL WRITE (EED,BUF,12,0)
      CALL WRITE (EED,BUF(14),6,0)
      GO TO 22
   24 CALL WRITE (EED,0,0,1)
C
C     LOCATE EIGC CARDS IN DYNAMICS POOL. IF PRESENT, TURN OFF NOEED
C     FLAG, WRITE ID ON EED AND TURN ON TRL BIT.
C
   30 CALL LOCATE (*80,Z(BUF1),EIGC,FLAG)
      NOEED = 1
      CALL WRITE (EED,EIGC,2,0)
      CALL WRITE (EED,0,1,0)
      J = (EIGC(2)-1)/16
      K =  EIGC(2) - 16*J
      MCB(J+2) = ORF(MCB(J+2),TWO(K+16))
      ASSIGN 50 TO NBACK
      L = 6
      MASK = TWO(UD)
C
C     READ EIGC CARDS. IF GRID NO. IS PRESENT, CONVERT TO SIL VALUE.
C     WRITE DATA ON EED.
C
   40 CALL READ (*320,*70,DPOOL,BUF,10,0,FLAG)
      GO TO 120
   50 CALL WRITE (EED,BUF,7,0)
      CALL WRITE (EED,BUF(8),3,0)
   60 CALL READ  (*320,*320,DPOOL,BUF,7,0,FLAG)
      CALL WRITE (EED,BUF,7,0)
      IF (BUF(1) .NE. -1) GO TO 60
      GO TO 40
   70 CALL WRITE (EED,0,0,1)
C
C     LOCATE EIGP CARDS. IF PRESENT, TURN NOEED FLAG OFF,
C     WRITE ID ON EED AND TURN ON TRAILER BIT. COPY DATA ON EED.
C
   80 CALL LOCATE (*89,Z(BUF1),EIGP,FLAG)
      NOEED = 1
      CALL WRITE (EED,EIGP,2,0)
      CALL WRITE (EED,0,1,0)
      J = (EIGP(2)-1)/16
      K =  EIGP(2) - 16*J
      MCB(J+2) = ORF(MCB(J+2),TWO(K+16))
   81 CALL READ  (*320,*82,DPOOL,BUF,4,0,FLAG)
      CALL WRITE (EED,BUF,4,0)
      GO TO 81
   82 CALL WRITE (EED,0,0,1)
C
C     LOCATE EIGR CARDS IN DYNAMICS POOL. IF PRESENT, TURN OFF NOEED
C     FLAG, WRITE ID ON EED AND TURN ON TRL BIT.
C
   89 CALL LOCATE (*160,Z(BUF1),EIGR,FLAG)
      NOEED = 1
      CALL WRITE (EED,EIGR,2,0)
      CALL WRITE (EED,0,1,0)
      J = (EIGR(2)-1)/16
      K =  EIGR(2) - 16*J
      MCB(J+2) = ORF(MCB(J+2),TWO(K+16))
      ASSIGN 100 TO NBACK
      L = 12
      MASK = TWO(UA)
C
C     READ EIGR CARDS. IF GRID NO. IS PRESENT, CONVERT TO SIL VALUE.
C     WRITE DATA ON EED.
C
   90 CALL READ (*320,*110,DPOOL,BUF,18,0,FLAG)
      GO TO 120
  100 CALL WRITE (EED,BUF,12,0)
      CALL WRITE (EED,BUF(14),6,0)
      GO TO 90
  110 CALL WRITE (EED,0,0,1)
      GO TO 160
C
C     CODE TO CONVERT GRID NO. AND COMPOIENT CODE TO SIL NO.
C     SIL NO. IS IN A SET FOR EIGR, EIGB - IN D SET FOR EIGC.
C     WRITE DATA ON EED.
C
  120 IF (BUF(L) .EQ. 0) GO TO NBACK, (23,50,100)
      IF (IN .NE. 0) GO TO 140
      FILE = USETD
      CALL OPEN (*310,USETD,Z(BUF3),RDREW)
      CALL FWDREC (*320,USETD)
      IUSETD = NEQDYN+2
      CALL READ (*320,*130,USETD,Z(IUSETD),BUF3-IUSETD,1,N)
      CALL MESAGE (-8,0,NAM)
  130 CALL CLOSE (USETD,CLSREW)
      IN = 1
  140 IMSG(1) = BUF(1)
      IMSG(2) = BUF(L)
      CALL DPDAA
      NUSETD = IUSETD + BUF(L) - 1
      BUF(L) = 0
      DO 150 J = IUSETD,NUSETD
      IF (ANDF(Z(J),MASK) .NE. 0) BUF(L)= BUF(L) + 1
  150 CONTINUE
      IF (ANDF(Z(NUSETD),MASK) .NE. 0) GO TO NBACK, (23,50,100)
      NOGO = 1
      CALL MESAGE (30,107,IMSG)
      GO TO NBACK, (23,50,100)
C
C     COMPLETE EIG CARD PROCESSING.
C
  160 CONTINUE
      CALL CLOSE (EED,CLSREW)
      MCB(1) = EED
      CALL WRTTRL (MCB)
C
C
C     (2) PRECESS TFL FILE
C     ====================
C
C     SELECT PACK OR NO-PACK LOGIC
C
  170 PACK = .TRUE.
      I45 = 4
      I23 = 3
      IF (IHALF .GT. 16) GO TO 175
      PACK = .FALSE.
      I45 = 5
      I23 = 2
  175 CONTINUE
C
C     OPEN TFL. WRITE HEADER. INITIALIZE TO READ TF CARDS.
C
      DO 180 J = 2,7
  180 MCB(J) = 0
      CALL LOCATE (*300,Z(BUF1),TF,FLAG)
      NOTFL = 0
      FILE  = TFL
      CALL OPEN (*300,TFL,Z(BUF2),WRTREW)
      CALL FNAME (TFL,BUF)
      CALL WRITE (TFL,BUF,2,1)
      MSG(1) = 68
      L   = 2
      ID  = 0
      ITFL= NEQDYN + 2
      I   = ITFL
      ISW = 0
      LAST= 0
C
C     READ FIXED SECTION OF TF CARD. CONVERT GRID POINT AND COMP. TO
C     SIL NO. TEST FOR NEW TRANSFER FUNCTION SET.
C
  190 CALL READ (*320,*200,DPOOL,BUF,6,0,FLAG)
      MSG(3) = BUF(1)
      CALL DPDAA
      IROW = BUF(2)
      IF (BUF(1) .EQ. ID) GO TO 250
      NOTFL = NOTFL + 1
      IF (ID .NE. 0) GO TO 210
      ID = BUF(1)
      GO TO 250
C
C     SORT TRANSFER EQUATIONS AND WRITE ON TFL ONE RECORD PER TRANSFER
C     FUNCTION SET. FIRST WORD OF RECORD IS SETID.
C
  200 LAST = 1
  210 CALL WRITE (TFL,ID,1,0)
      IF (ISW .EQ. 0) GO TO 220
      CALL WRITE (SCR1,0,0,1)
      CALL CLOSE (SCR1,CLSREW)
      CALL OPEN  (*310,SCR1,Z(BUF2),RDREW)
      IFILE(1) = SCR2
      IFILE(2) = SCR3
      IFILE(3) = SCR4
      N = BUF3 - ITFL
      IF (     PACK) CALL SORTI  (SCR1,TFL,4,1,Z(ITFL),N)
      IF (.NOT.PACK) CALL SORTI2 (SCR1,TFL,5,1,Z(ITFL),N)
      CALL CLOSE  (SCR1,CLSREW)
      GO TO 230
  220 N = I - ITFL
      IF (     PACK) CALL SORTI  (0,0,4,1,Z(ITFL),N)
      IF (.NOT.PACK) CALL SORTI2 (0,0,5,1,Z(ITFL),N)
      CALL WRITE  (TFL,Z(ITFL),N,1)
  230 I  = ITFL
      ID = BUF(1)
      ISW= 0
      IF (LAST .NE. 0) GO TO 290
      GO TO 250
C
C     READ GRID POINT, COMP AND VALUES. CONVERT POINT AND COMP. TO SIL
C     NO. STORE IN CORE. IF SPILL, WRITE ON SCR1.
C
  240 CALL READ (*320,*310,DPOOL,BUF(2),5,0,FLAG)
      IF (BUF(2) .EQ. -1) GO TO 190
      CALL DPDAA
C
C     INTEGER PACKING LOGIC (MACHINES WITH 36 BITS WORDS, OR MORE) -
C     PACK COLN AND ROW INTO ONE WORD IF BOTH CAN BE STORED IN HALF WORD
C     THEN FOLLOWED BY 3 COEFFICIENTS, TOTALLY 4 WORDS
C
C     NON-INTEGER PACKING LOGIC (MACHINES WITH 32 BITS WORDS) -
C     THE COLUMN AND ROW ARE NOT PACKED, AND THEREFORE NOT BOUNED TO
C     65536 SIZE LIMIT. 1ST WORD IS COLUMN, 2ND WORD IS ROW, THEN
C     FOLLOWED BY 3 COEFFICIENTS, TOTALLY 5 WORDS
C     THE SUBROUTINE SORTI2 IS USED WHEN SORTING TFL BY 2 KEY WORDS
C
  250 IF (.NOT.PACK) GO TO 252
      IF (BUF(2).GE.JHALF .OR. IROW.GE.JHALF) GO TO 340
      BUF(3) = LSHIFT(BUF(2),IHALF)
      BUF(3) = ORF(BUF(3),IROW)
      GO TO 255
  252 BUF(3) = IROW
  255 IF (ISW .NE. 0) GO TO 280
      IF (I+I45 .GT. BUF3) GO TO 270
      DO 260 J = I23,6
      Z(I) = BUF(J)
  260 I = I + 1
      GO TO 240
  270 ISW = 1
      FILE= SCR1
      CALL OPEN (*310,SCR1,Z(BUF3),WRTREW)
      N = I - ITFL
      CALL WRITE (SCR1,Z(ITFL),N,0)
  280 CALL WRITE (SCR1,BUF(I23),I45,0)
      GO TO 240
C
C     HERE WHEN ALL TRANSFER FUNCTION SETS COMPLETE.
C     CLOSE FILE AND WRITE TRAILER.
C
  290 CALL CLOSE (TFL,CLSREW)
      MCB(2) = NOTFL
      MCB(1) = TFL
      CALL WRTTRL (MCB)
  300 CALL CLOSE  (DPOOL,CLSREW)
      RETURN
C
C     FATAL ERRORS
C
  310 N = -1
      GO TO 330
  320 N = -2
  330 CALL MESAGE (N,FILE,NAM)
  340 WRITE  (NOUT,350) IHALF,BUF(2),IROW
  350 FORMAT ('0*** COLUMN OR ROW SIL NO. EXCEEDS',I3,' BITS WORD ',
     1        'PACKING LIMIT',2I9)
      CALL MESAGE (-37,NAM,NAM)
      RETURN
      END

      SUBROUTINE GNFIST (FILENM,FISTNM,MODNO)
C
      EXTERNAL        ANDF
      INTEGER         ANDF,FIAT,FILENM(2),FIST,FISTNM,FISTX,OSCAR
      COMMON /XFIST / FIST(2)
      COMMON /XFIAT / FIAT(3)
      COMMON /XDPL  / IDPL(3)
      COMMON /OSCENT/ OSCAR(7)
      COMMON /IPURGE/ IPVAL(5)
      COMMON /ISOSGN/ ISVAL(34)
      COMMON /IXSFA / IXVAL(5)
      COMMON /SYSTEM/ SKIP(23),ICFIAT
      DATA    MASK1 / 65535 /,  MASK  / 32767 /
C             MASK1 = O177777   MASK  = O77777
C
      DO 1 K = 1,5
      IPVAL(K) = 0
      IXVAL(K) = 0
    1 CONTINUE
      DO 2 K = 5,34
      ISVAL(K) = 0
    2 CONTINUE
C
      ISVAL(1) = 3
      ISVAL(2) = 3
      ISVAL(3) = 1
      ISVAL(4) = 2
C
      IXVAL(3) = 10
C
      IF (FILENM(1).EQ.0 .AND. FILENM(2).EQ.0) RETURN
C
C     SEARCH FIAT FOR MATCHING FILE
C
      LFIAT = FIAT(3)
      K = 5
      DO 10 J = 1,LFIAT
      IF (FILENM(1).EQ.FIAT(K) .AND. FILENM(2).EQ.FIAT(K+1)) GO TO 30
   10 K = K + ICFIAT
C
C     FILE NOT IN FIAT - IF INPUT FILE ASSUME PURGED
C
      IF (FISTNM.GT.100 .AND. FISTNM.LT.200) GO TO 40
C
C     MUST CALL IN FILE ALLOCATOR
C
   20 CALL XSFA (MODNO)
      MODNO = -MODNO
      RETURN
C
C     IF FILE POINTER = 77777 NO ENTRY IS MADE IN FIST
C
   30 IF (ANDF(FIAT(K-1),MASK) .EQ. MASK) RETURN
      IF (FISTNM.LE.100 .OR. FISTNM.GE.300) GO TO 170
      IF (FISTNM .GE. 200) GO TO 120
C
C
C     INPUT FILE
C     ==========
C
C     SEE IF IT EXISTS
C
      IF (FIAT(K+2).NE.0 .OR. FIAT(K+3).NE.0 .OR. FIAT(K+4).NE.0)
     1    GO TO 170
      IF (ICFIAT.EQ.11 .AND. (FIAT(K+7).NE.0 .OR. FIAT(K+8).NE.0 .OR.
     1    FIAT(K+9).NE.0)) GO TO 170
C
C     INPUT FILE NOT GENERATED ACCORDING TO FIAT - CHECK DPL
C
   40 I1 = OSCAR(7)*3 + 5
      J1 = IDPL(3) *3 + 1
      L  = FIAT(3) *ICFIAT - 2
      DO 50 J = 4,J1,3
      IF (IDPL(J).EQ.FILENM(1) .AND. IDPL(J+1).EQ.FILENM(2)) GO TO 60
   50 CONTINUE
      RETURN
C
C     FILE IN DPL - ZERO FIAT ENTRY SO FILE ALLOCATOR WILL UNPOOL IT.
C     DO THIS FOR OTHER LIKE I/P FILES IN OSCAR ENTRY.
C
   60 DO 110 I = 8,I1,3
      IF (OSCAR(I) .EQ. 0) GO TO 110
C
C     SEARCH FIAT
C
      DO 70 K = 4,L,ICFIAT
      IF (OSCAR(I).EQ.FIAT(K+1) .AND. OSCAR(I+1).EQ.FIAT(K+2)) GO TO 80
   70 CONTINUE
C
C     FILE NOT IN FIAT - CHECK NEXT INPUT FILE
C
      GO TO 110
C
C     FILE IN FIAT - CHECK DPL IF FIAT TRAILER IS ZERO
C
   80 IF (FIAT(K+3).NE.0 .OR. FIAT(K+4).NE.0 .OR. FIAT(K+5).NE.0 .OR.
     1    ANDF(MASK,FIAT(K)).EQ.MASK) GO TO 110
      IF (ICFIAT.EQ.11 .AND. (FIAT(K+8).NE.0 .OR. FIAT(K+9).NE.0 .OR.
     1    FIAT(K+10).NE.0)) GO TO 110
      DO 90 J = 4,J1,3
      IF (IDPL(J).EQ.FIAT(K+1) .AND. IDPL(J+1).EQ.FIAT(K+2)) GO TO 100
   90 CONTINUE
      GO TO 110
C
C     FILE IS IN DPL - ZERO OUT FIAT ENTRY
C
  100 FIAT(K) = ANDF(MASK1,FIAT(K))
      IF (ANDF(MASK,FIAT(K)) .EQ. MASK) FIAT(K) = 0
      FIAT(K+1) = 0
      FIAT(K+2) = 0
  110 CONTINUE
C
C     CALL FILE ALLOCATOR AND UNPOOL FILES
C
      GO TO 20
C
C
C     OUTPUT FILE
C     ===========
C
C     SEARCH DPL FOR FILE NAME
C
  120 J1 = IDPL(3)*3 + 1
      DO 130 M = 4,J1,3
      IF (IDPL(M).EQ.FILENM(1) .AND. IDPL(M+1).EQ.FILENM(2)) GO TO 140
  130 CONTINUE
      GO TO 170
C
C     FILE NAME IS IN DPL - PURGE IT AND ALL EQUIV FILE FROM DPL
C
  140 IDPL(M  ) = 0
      IDPL(M+1) = 0
      L = IDPL(M+2)
      DO 150 J = 4,J1,3
      IF (J.EQ.M .OR. L.NE.IDPL(J+2)) GO TO 150
      IDPL(J  ) = 0
      IDPL(J+1) = 0
      IDPL(J+2) = 0
  150 CONTINUE
C
C     IF THIS IS LAST FILE ON POOL TAPE, DECREASE FILE COUNT IN DPL
C
      IF (ANDF(L,MASK) .NE. IDPL(1)-1) GO TO 160
      IDPL(  1) = IDPL(1) - 1
      IDPL(M+2) = 0
C
C     IF DELETED FILES ARE AT END OF DPL, DECREMENT ENTRY COUNT
C
  160 IF (IDPL(J1).NE.0 .OR. IDPL(J1+1).NE.0 .OR. IDPL(J1+2).NE.0)
     1    GO TO 170
      IDPL(3) = IDPL(3) - 1
      J1 = IDPL(3)*3 + 1
      GO TO 160
C
C     CHECK FOR FIST TABLE OVERFLOW
C
  170 IF (FIST(1) .LE. FIST(2)) CALL MESAGE (-20,IABS(MODNO),FILENM)
      FIST(2) = FIST(2)   + 1
      FISTX   = FIST(2)*2 + 1
      FIST(FISTX  ) = FISTNM
      FIST(FISTX+1) = K - 2
      IF (FISTNM .LT. 300) RETURN
C
C     ZERO TRAILER FOR SCRATCH FILE
C
      FIAT(K+2) = 0
      FIAT(K+3) = 0
      FIAT(K+4) = 0
      IF (ICFIAT .EQ. 8) GO TO 180
      FIAT(K+7) = 0
      FIAT(K+8) = 0
      FIAT(K+9) = 0
  180 RETURN
      END

      SUBROUTINE GRAVL2(NVECT,FILD,PG)
C
      INTEGER PG(7),SYSBUF,FILD,SIL
      INTEGER NAME(2)
C
      COMMON /BLANK/NROWSP
      COMMON /SYSTEM/ SYSBUF
      COMMON  /ZNTPKX/ A(4),LL,IEOL
      COMMON /ZBLPKX/ B(4),II
      COMMON /ZZZZZZ/ CORE(1)
      COMMON  /LOADX/ N(2),BGPDT,OLD,CSTM,SIL,ISTL,NN(8),MASS
C
      DATA NAME/4HGRAV,4HL2  /
C
C ----------------------------------------------------------------------
C
      LCORE=KORSZ(CORE)
      NZ = LCORE
      LCORE=LCORE-SYSBUF
      CALL OPEN(*170,PG(1),CORE(LCORE+1),0)
      CALL SKPFIL (PG,1)
      CALL SKPFIL (PG,-1)
      CALL CLOSE (PG,2)
      CALL OPEN(*170,PG(1),CORE(LCORE+1),3)
      LCORE = LCORE-SYSBUF
      CALL GOPEN(FILD,CORE(LCORE+1),0)
      LCORE=LCORE-SYSBUF
      CALL GOPEN( SIL,CORE(LCORE+1),0)
      IBUF=LCORE
      ISIL=0
      DO 160 ILOOP=1,NVECT
   50 CALL READ(*210,*130,SIL,ISIL1,1,0,FLAG)
      IF(ISIL1) 50,60,60
   60 ASSIGN 100 TO IOUT
      CALL BLDPK(1,1,PG(1),0,0)
      CALL INTPK(*150,FILD,0,1,0)
   70 CALL READ(*210,*130,SIL,ISIL2,1,0,FLAG)
      IF(ISIL2) 70,80,80
   80 IF (ISIL2-ISIL1-1) 140,90,140
   90 GO TO IOUT,(100,150)
  100 IF (IEOL.NE.0) GO TO 150
      CALL ZNTPKI
      IF (LL-ISIL1) 120,90,70
  120 B(1)=A(1)
      II=LL
      CALL ZBLPKI
      GO TO 90
  130 ASSIGN 150 TO IOUT
      IF(NROWSP-ISIL1) 140,150,140
  140 ISIL1 = 999999
      GO TO 90
  150 CALL REWIND(SIL)
      CALL BLDPKN(PG(1),0,PG)
      CALL SKPREC(SIL,1)
      ISIL=0
  160 CONTINUE
      CALL CLOSE (SIL,1)
      CALL CLOSE (FILD,1)
      CALL WRTTRL (PG)
      CALL CLOSE (PG,1)
      RETURN
C
  170 IPM=PG(1)
      CALL MESAGE (-1,IPM,NAME)
C
  210 CALL MESAGE (-3,SIL,NAME)
      RETURN
C
      END

      SUBROUTINE HDSTUS (OJ,TMJ,XXX,TGM,RV,RVI,TGI,ZM,NNO,II,H,IM,JXT,
     1                   ZJ,NC,ZMI,CCC,LZ)
C
C     THIS SUBROUTINE DETERMINES THE VISIBILITY OF AN ARBITRARY POINT
C     BY DRAWING A LINE FROM THE POINT IN QUESTION TO INFINITY AND
C     COUNTING THE NUMBER OF TIMES IT CROSSES THE BOUNDARIES OF A
C     RELEVANT ELEMENT.
C
      DIMENSION    CCC(1),XXX(1),ZMI(1),TGM(1),RV(1),RVI(1),TGI(1),
     1             ZM(1),NNO(1),H(8)
      COMMON /GO3/ L0,L1,L00,L01,L2,L3,L4,L5,L6,L7,L8,L9,L10,L11,L12,L13
C
      GGK = .015
      EI  = 0
      IM  = 0
   10 CONTINUE
      IF (EI .GE. 1.) GO TO 70
      EI  = EI + .2
      D   = EI*OJ - TMJ
      DO 60 JO = 1,II
      GGK = .015
      I   = 0
      JG  = NNO(L4+JO)
      JS  = L13 + (JG-1)*LZ
      JT  = L12 + (JG-1)*5
C
C     PRELIMINARY CHECK TO SEE IF THE POINT IS OUTSIDE THE BOUNDARY
C     BOXES IN THE X,Y,Z DIMENSIONS.
C
      IF (TMJ.GE.RV(L7+JG) .OR. TMJ.LE.RVI(L8+JG)) GO TO 60
      IF (OJ.GE.TGI(L6+JG) .OR. OJ.LE.TGM(L5+JG) ) GO TO 60
      IF (ZJ .GE. ZM(L2+JG)) GO TO 60
      VX  = XXX(4+JT)
      VX1 = XXX(2+JT)*TMJ
      VX2 = XXX(1+JT)*OJ
      ZS  =-(VX+VX1+VX2)/XXX(3+JT)
      IF (ABS(ZJ-ZS) .LT. GGK) GO TO 60
      IF (ZJ .GE. ZS) GO TO 60
      NS  = XXX(5+JT)
      IB  = NS*5
      IF (H(8) .EQ. 1.) GO TO 25
      DO 20 J = 1,IB,5
      GGK = .015
      NSUB= J + 1 + JS
      IF (ABS(CCC(NSUB)) .GE. 100.) GGK = ALOG10(ABS(CCC(NSUB)))
      VE  = OJ
      IF (CCC(J+JS) .EQ. 0.) VE = TMJ
      S   = VE - CCC(J+3+JS)
      S1  = VE - CCC(J+4+JS)
      YG  = TMJ
      IF (CCC(J+JS) .NE. 0.) GO TO 15
      DY  =-CCC(J+2+JS)/CCC(J+1+JS)
      YG  = OJ
      GO TO 16
   15 CONTINUE
      DY  =-CCC(J+2+JS) - CCC(J+1+JS)*OJ
   16 CONTINUE
      IF (ABS(YG-DY).LT.GGK .AND. S*S1.LE.0.) GO TO 60
   20 CONTINUE
   25 CONTINUE
C
C     THE FOLLOWING CODE COUNTS THE INTERSECTIONS OF BOUNDARIES
C     OF A GIVEN ELEMENT WITH THE INFINITE LINE AND CHECKS,IF INSIDE
C     OF THE BOUNDARY, WHETHER OR NOT THE POINT IS BEHIND OR IN FRONT
C     OF THE ELEMENT.
C
      DO 40 J = 1,IB,5
      T  =-CCC(J+2+JS)  + CCC(J+JS)*D
      R  = EI*CCC(J+JS) + CCC(J+1+JS)
      IF (R .EQ. 0.) GO TO 40
      T  = T/R
      IF (T .LT. OJ) GO TO 40
      IF (CCC(J+JS) .NE. 0.) GO TO 30
      T  = EI*T - D
   30 CONTINUE
      S  = T - CCC(J+3+JS)
      S1 = T - CCC(J+4+JS)
      IF (S.EQ.0. .OR. S1.EQ.0.) GO TO 10
      IF (S*S1 .GE. 0.) GO TO 40
      I  = I + 1
   40 CONTINUE
      IF (MOD(I,2) .EQ. 0) GO TO 60
      IM = 1
      GO TO 70
   60 CONTINUE
      IM = 0
   70 CONTINUE
      RETURN
      END

      SUBROUTINE SANORM (*,A)
      DIMENSION  A(3)
C
C     VECTOR NORMALIZATION AND VECTOR LENGTH
C
      XL=A(1)*A(1) + A(2)*A(2) + A(3)*A(3)
      IF (XL .LE. 0.0) RETURN 1
      XL   = SQRT(XL)
      A(1) = A(1)/XL
      A(2) = A(2)/XL
      A(3) = A(3)/XL
      RETURN
      END

      SUBROUTINE DTSHLS
C
C     ECPT ENTRIES
C
C     ECPT( 1) = ELEMENT ID                                    INTEGER
C     ECPT( 2) = SCALAR INDEX NUMBER FOR GRID POINT 1          INTEGER
C     ECPT( 3) = SCALAR INDEX NUMBER FOR GRID POINT 2          INTEGER
C     ECPT( 4) = SCALAR INDEX NUMBER FOR GRID POINT 3          INTEGER
C     ECPT( 5) = SCALAR INDEX NUMBER FOR GRID POINT 4          INTEGER
C     ECPT( 6) = SCALAR INDEX NUMBER FOR GRID POINT 5          INTEGER
C     ECPT( 7) = SCALAR INDEX NUMBER FOR GRID POINT 6          INTEGER
C     ECPT( 8) = THETA                                         REAL
C     ECPT( 9) = MATERIAL  ID 1                                INTEGER
C     ECPT(10) = THICKNESS T1 AT GRID POINT G1
C     ECPT(11) = THICKNESS T3 AT GRID POINT G3
C     ECPT(12) = THICKNESS T5 AT GRID POINT G5
C     ECPT(13) = MATERIAL  ID 2                                INTEGER
C     ECPT(14) = THICKNESS TBEND1 FOR BENDING AT GRID POINT G1
C     ECPT(15) = THICKNESS TBEND3 FOR BENDING AT GRID POINT G3
C     ECPT(16) = THICKNESS TBEND5 FOR BENDING AT GRID POINT G5
C     ECPT(17) = MATERIAL  ID 3                                INTEGER
C     ECPT(18) = THICKNESS TSHR1 FOR TRANSVERSE SHEAR AT GRID POINT G1
C     ECPT(19) = THICKNESS TSHR3 FOR TRANSVERSE SHEAR AT GRID POINT G3
C     ECPT(20) = THICKNESS TSHR5 FOR TRANSVERSE SHEAR AT GRID POINT G5
C     ECPT(21) = NON-STRUCTURAL MASS                           REAL
C     ECPT(22) = DISTANCE Z11 FOR STRESS CALCULATION  AT GRID POINT G1
C     ECPT(23) = DISTANCE Z21 FOR STRESS CALCULATION  AT GRID POINT G1
C     ECPT(24) = DISTANCE Z13 FOR STRESS CALCULATION  AT GRID POINT G3
C     ECPT(25) = DISTANCE Z23 FOR STRESS CALCULATION  AT GRID POINT G3
C     ECPT(26) = DISTANCE Z15 FOR STRESS CALCULATION  AT GRID POINT G5
C     ECPT(27) = DISTANCE Z25 FOR STRESS CALCULATION  AT GRID POINT G5
C
C     X1,Y1,Z1 FOR ALL SIX POINTS ARE  IN NASTRAN BASIC SYSTEM
C
C     ECPT(28) = COORDINATE SYSTEM ID FOR GRID A               INTEGER
C     ECPT(29) = COORDINATE X1                                 REAL
C     ECPT(30) = COORDINATE Y1                                 REAL
C     ECPT(31) = COORDINATE Z1                                 REAL
C     ECPT(32) = COORDINATE SYSTEM ID FOR GRID B               INTEGER
C     ECPT(33) = COORDINATE X1                                 REAL
C     ECPT(34) = COORDINATE Y1                                 REAL
C     ECPT(35) = COORDINATE Z1                                 REAL
C     ECPT(36) = COORDINATE SYSTEM ID FOR GRID C               INTEGER
C     ECPT(37) = COORDINATE X1                                 REAL
C     ECPT(38) = COORDINATE Y1                                 REAL
C     ECPT(39) = COORDINATE Z1                                 REAL
C     ECPT(40) = COORDINATE SYSTEM ID FOR GRID D               INTEGER
C     ECPT(41) = COORDINATE X1                                 REAL
C     ECPT(42) = COORDINATE Y1                                 REAL
C     ECPT(43) = COORDINATE Z1                                 REAL
C     ECPT(44) = COORDINATE SYSTEM ID FOR GRID E               INTEGER
C     ECPT(45) = COORDINATE X1                                 REAL
C     ECPT(46) = COORDINATE Y1                                 REAL
C     ECPT(47) = COORDINATE Z1                                 REAL
C     ECPT(48) = COORDINATE SYSTEM ID FOR GRID F               INTEGER
C     ECPT(49) = COORDINATE X1                                 REAL
C     ECPT(50) = COORDINATE Y1                                 REAL
C     ECPT(51) = COORDINATE Z1                                 REAL
C     EST (52) = ELEMENT  TEMPERATURE
C     EST (53) = ENFORCED ELEMENT DEFORMATION (NOT USED)
C     EST (54) = LOADING  TEMPERATURE
C     EST (55) TO EST (90) = GLOBAL DISPLACEMENT VECTOR
C                REPLACES ECPT(65) TO ECPT(100) DESCRIBED BELOW
C     ECPT(65) = U1-DISP FOR X1
C     ECPT(66) = V1-DISP FOR Y1
C     ECPT(67) = W1-DISP FOR Z1
C     ECPT(68) = ALFA1-ROTATION FOR X1
C     ECPT(69) = BETA1-ROTATION FOR Y1
C     ECPT(70) = GAMA1-ROTATION FOR Z1
C     ECPT(71) = U2-DISP FOR X2
C     ECPT(72) = V2-DISP FOR Y2
C     ECPT(73) = W2-DISP FOR Z2
C     ECPT(74) = ALFA2-ROTATION FOR X2
C     ECPT(75) = BETA2-ROTATION FOR Y2
C     ECPT(76) = GAMA2-ROTATION FOR Z2
C     ECPT(77) = U3-DISP FOR X3
C     ECPT(78) = V3-DISP FOR Y3
C     ECPT(79) = W3-DISP FOR Z3
C     ECPT(80) = ALFA3-ROTATION FOR X3
C     ECPT(81) = BETA3-ROTATION FOR Y3
C     ECPT(82) = GAMA3-ROTATION FOR Z3
C     ECPT(83) = U4-DISP FOR X4
C     ECPT(84) = V4-DISP FOR Y4
C     ECPT(85) = W4-DISP FOR Z4
C     ECPT(86) = ALFA4-ROTATION FOR X4
C     ECPT(87) = BETA4-ROTATION FOR Y4
C     ECPT(88) = GAMA4-ROTATION FOR Z4
C     ECPT(89) = U5-DISP FOR X5
C     ECPT(90) = V5-DISP FOR Y5
C     ECPT(91) = W5-DISP FOR Z5
C     ECPT(92) = ALFA5-ROTATION FOR X5
C     ECPT(93) = BETA5-ROTATION FOR Y5
C     ECPT(94) = GAMA5-ROTATION FOR Z5
C     ECPT(95) = U6-DISP FOR X6
C     ECPT(96) = V6-DISP FOR Y6
C     ECPT(97) = W6-DISP FOR Z6
C     ECPT(98) = ALFA6-ROTATION FOR X6
C     ECPT(99) = BETA6-ROTATION FOR Y6
C     ECPT(100)= GAMA6-ROTATION FOR Z6
C
C     RK AND SK ARE EXPONENTS IN THICKNESS VARIATION
C
      LOGICAL          NOTS,UNIMEM,UNIBEN,NOGO
      INTEGER          RK(3),SK(3),RL(3),SL(3),XU(32),YU(32),XV(32),
     1                 YV(32),XW(32),YW(32),SIL(6),SIL1,SIL2,
     2                 RR,RR0,RR1,SS,SS0,SS1
      REAL             J11,J12,J22,NSM,IVECT(3),JVECT(3),KVECT(3),XC(6),
     1                 YC(6),ZC(6),F(18,18)
      REAL             TRAND(9),BALOTR(36),KSUB(36),KSUBT(36)
      REAL             D334,D132,D232,RMX,RNX,RMNX,RMX1,RNX1,RMY,RNY,
     1                 RMNY,RMY1,RNY1,X,Y,QQQ(20,20),CMT(1296),
     2                 CTM(36,36),CMS(900),CM1(30,30),CAB(3),CSUB(5,5),
     3                 CSUBT(6,5),C1,C2,C3,C4,C5,C6,C7,C8,C9,C10,
     4                 H4,H5,H6,SB1,SB2,SB3,SB4,SB5,SB6,SB7,SB8,SB9,
     5                 RIX,RIY,RJX,RJY,RKX,RKY,RLX,RLY,EE(30),Q(6,6),
     6                 QQQINV(360),QKS(960),KSHL(1024),MSHL(1024)
      REAL             SB10,SB11,SB12,SB13,SB14,SB15,SB16,SB17,SB18,SB19
     1,                SB20,SB21,SB22,SB23,SB24,SB25,SB26,SB27,SB28,SB29
     2,                SB30,SB31,SB32,SB33,SB34,SB35,SB36,SB37,SB38,SB39
     3,                SB40,CC(10),ST
      DOUBLE PRECISION KSUBD(36)
      DIMENSION        IND(6,3),EL(3),FL(3),GL(3),NAME(2),INDEX(20,3),
     1                 ICS(6),IEST(100),NL(6),SIGX(3),SIGY(3),SIGXY(3),
     2                 ES(6),STRESS(3),STR(3),VEC(3),PH1OUT(250),
     3                 TM(3,12),EMOD(9),TMMM(36),TRANS(9),EPH1(6),
     4                 EE1(6),NSIL(6),TI(1)
      CHARACTER        UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG /  UFM,UWM,UIM,SFM
      COMMON /SYSTEM/  IBUF,IOUTPT
      COMMON /DS1AET/  EST(100)
      COMMON /DS1AAA/  NPVT,ICSTM,NCSTM
      COMMON /DS1ADP/  F
      COMMON /MATIN /  MATID,MATFLG,ELTEMP,PLA34,SINTH,COSTH
      COMMON /MATOUT/  EM(6),RHOY,ALF(3),TREF,GSUBE,SIGTY,SIGCY,SIGSY,
     1                 RJ11,RJ12,RJ22
      EQUIVALENCE      (C1,CC(1)),(C2,CC(2)),(C3,CC(3)),(C4,CC(4)),
     1                 (C5,CC(5)),(C6,CC(6)),(C7,CC(7)),(C8,CC(8)),
     2                 (C9,CC(9)),(C10,CC(10)),
     3                 (NSIL(1),PH1OUT(2)),(TM(1,1),TMMM(1)),(A,DISTA),
     4                 (B,DISTB),(C,DISTC),(IEST(1),EST(1)),
     5                 (CM1(1,1),CMS(1)),(THK1,TBEND1),(THK2,TBEND3),
     6                 (THK3,TBEND5),(CMT(1025),QQQINV(1)),
     7                 (CTM(1,1),CMT(1),KSHL(1),MSHL(1),QQQ(1,1)),
     8                 (CMT(437),PH1OUT(1)),(CMT(687),INDEX(1,1)),
     9                 (CMT(747),IND(1,1)),(TI(1),EST(65))
      DATA    RK    /  0,1,0 /, RL / 0,1,0 /, SK / 0,0,1 /, SL / 0,0,1/,
     1        XU    /  0,1,0,2,1,0,26*0    /, YU / 0,0,1,0,1,2,26*0   /,
     2        XV    /  6*0,0,1,0,2,1,0,20*0/, YV /6*0,0,0,1,0,1,2,20*0/,
     3        XW    /  12*0,0,1,0,2,1,0,3,2,1,0,4,3,2,1,0,5,3,2,1,0   /,
     4        YW    /  12*0,0,0,1,0,1,2,0,1,2,3,0,1,2,3,4,0,2,3,4,5   /,
     5        BLANK ,  NAME / 4H    ,4HDTSH,4HLD    /,
     6        DEGRA /  0.0174532925 /
C
      NOTS   =.FALSE.
      IDELE  = IEST(1)
      DO 10 I = 1,6
      NL(I)  = IEST(I+1)
   10 CONTINUE
      THETAM = EST(8)
      MATID1 = IEST(9)
      TMEM1  = EST(10)
      TMEM3  = EST(11)
      TMEM5  = EST(12)
      MATID2 = IEST(13)
      TBEND1 = (EST(14)*12.0)**0.333333333333
      TBEND3 = (EST(15)*12.0)**0.333333333333
      TBEND5 = (EST(16)*12.0)**0.333333333333
      MATID3 = IEST(17)
      TSHR1  = EST(18)
      TSHR3  = EST(19)
      TSHR5  = EST(20)
      NSM    = EST(21)
      J      = 0
      DO 20 I = 28,48,4
      J      = J + 1
      ICS(J) = IEST(I)
      XC(J)  = EST(I+1)
      YC(J)  = EST(I+2)
      ZC(J)  = EST(I+3)
   20 CONTINUE
C
C     IF TMEM3 OR TMEM5 EQUAL TO ZERO OR BLANK, THEY WILL BE
C     SET EQUAL TO TMEM1 SO ALSO FOR TSHR3,TSHR5,TBEND3 AND TBEND5
C
      IF (TMEM3.EQ.0.0 .OR. TMEM3.EQ.BLANK) TMEM3 = TMEM1
      IF (TMEM5.EQ.0.0 .OR. TMEM5.EQ.BLANK) TMEM5 = TMEM1
      IF (TSHR3.EQ.0.0 .OR. TSHR3.EQ.BLANK) TSHR3 = TSHR1
      IF (TSHR5.EQ.0.0 .OR. TSHR5.EQ.BLANK) TSHR5 = TSHR1
      TSHR   = (TSHR1+TSHR3+TSHR5)/3.0
      IF (TSHR1 .EQ. 0.0) NOTS =.TRUE.
      IF (TBEND3.EQ.0.0 .OR. TBEND3.EQ.BLANK) TBEND3 = TBEND1
      IF (TBEND5.EQ.0.0 .OR. TBEND5.EQ.BLANK) TBEND5 = TBEND1
      ELTEMP = EST(52)
      THETA1 = THETAM*DEGRA
      SINTH  = SIN(THETA1)
      COSTH  = COS(THETA1)
      IF (ABS(SINTH) .LE. 1.0E-06) SINTH = 0.0
C
C     EVALUTE MATERIAL PROPERTIES
C
      MATFLG = 2
      MATID  = MATID1
      IF (MATID1 .LE. 0) GO TO 670
      CALL MAT (IDELE)
C
      MATFLG = 2
      MATID  = MATID2
      CALL MAT (IDELE)
      D13    = EM(3)
      D23    = EM(5)
      D33    = EM(6)
      J11    = 0.0
      J12    = 0.0
      J22    = 0.0
      IF (NOTS) GO TO 30
      MATFLG = 3
      MATID  = MATID3
      CALL MAT (IDELE)
      J11    = 1.0/(RJ11*TSHR)
      J12    = 0.0
      J22    = 1.0/(RJ22*TSHR)
   30 CONTINUE
C
C     CALCULATIONS FOR THE TRIANGLE
C
      CALL TRIF (XC,YC,ZC,IVECT,JVECT,KVECT,A,B,C,IEST(1),NAME)
C
C     CALCULATIONS FOR QMATRIX (QQQ) AND ITS INVERSE
C
      DO 40 I = 1,20
      DO 40 J = 1,20
   40 QQQ(I,J) = 0.0
      DO 50 I = 1,6
      I1 = (I-1)*3 + 1
      I2 = (I-1)*3 + 2
      I3 = (I-1)*3 + 3
      QQQ(I1, 1) = 1.0
      QQQ(I1, 2) = XC(I)
      QQQ(I1, 3) = YC(I)
      QQQ(I1, 4) = XC(I)*XC(I)
      QQQ(I1, 5) = XC(I)*YC(I)
      QQQ(I1, 6) = YC(I)*YC(I)
      QQQ(I1, 7) = QQQ(I1, 4)*XC(I)
      QQQ(I1, 8) = QQQ(I1, 4)*YC(I)
      QQQ(I1, 9) = QQQ(I1, 5)*YC(I)
      QQQ(I1,10) = QQQ(I1, 6)*YC(I)
      QQQ(I1,11) = QQQ(I1, 7)*XC(I)
      QQQ(I1,12) = QQQ(I1, 7)*YC(I)
      QQQ(I1,13) = QQQ(I1, 8)*YC(I)
      QQQ(I1,14) = QQQ(I1, 9)*YC(I)
      QQQ(I1,15) = QQQ(I1,10)*YC(I)
      QQQ(I1,16) = QQQ(I1,11)*XC(I)
      QQQ(I1,17) = QQQ(I1,12)*YC(I)
      QQQ(I1,18) = QQQ(I1,13)*YC(I)
      QQQ(I1,19) = QQQ(I1,14)*YC(I)
      QQQ(I1,20) = QQQ(I1,15)*YC(I)
      QQQ(I2, 3) = 1.0
      QQQ(I2, 5) = XC(I)
      QQQ(I2, 6) = YC(I)*2.0
      QQQ(I2, 8) = QQQ(I1, 4)
      QQQ(I2, 9) = QQQ(I1, 5)*2.0
      QQQ(I2,10) = QQQ(I1, 6)*3.0
      QQQ(I2,12) = QQQ(I1, 7)
      QQQ(I2,13) = QQQ(I1, 8)*2.0
      QQQ(I2,14) = QQQ(I1, 9)*3.0
      QQQ(I2,15) = QQQ(I1,10)*4.0
      QQQ(I2,17) = QQQ(I1,12)*2.0
      QQQ(I2,18) = QQQ(I1,13)*3.0
      QQQ(I2,19) = QQQ(I1,14)*4.0
      QQQ(I2,20) = QQQ(I1,15)*5.0
      QQQ(I3, 2) =-1.0
      QQQ(I3, 4) =-2.0*XC(I)
      QQQ(I3, 5) =-YC(I)
      QQQ(I3, 7) =-QQQ(I1, 4)*3.0
      QQQ(I3, 8) =-QQQ(I1, 5)*2.0
      QQQ(I3, 9) =-QQQ(I1, 6)
      QQQ(I3,11) =-QQQ(I1, 7)*4.0
      QQQ(I3,12) =-QQQ(I1, 8)*3.0
      QQQ(I3,13) =-QQQ(I1, 9)*2.0
      QQQ(I3,14) =-QQQ(I1,10)
      QQQ(I3,16) =-QQQ(I1,11)*5.0
      QQQ(I3,17) =-QQQ(I1,13)*3.0
      QQQ(I3,18) =-QQQ(I1,14)*2.0
      QQQ(I3,19) =-QQQ(I1,15)
   50 CONTINUE
      QQQ(19,16) = 5.0*A**4*C
      QQQ(19,17) = 3.0*A**2*C**3 - 2.0*A**4*C
      QQQ(19,18) =-2.0*A*C**4 + 3.0*A**3*C**2
      QQQ(19,19) = C**5 - 4.0*A**2*C**3
      QQQ(19,20) = 5.0*A*C**4
      QQQ(20,16) = 5.0*B**4*C
      QQQ(20,17) = 3.0*B**2*C**3 - 2.0*B**4*C
      QQQ(20,18) = 2.0*B*C**4 - 3.0*B**3*C**2
      QQQ(20,19) = C**5 - 4.0*B**2*C**3
      QQQ(20,20) =-5.0*B*C**4
      DO 60 I = 1,6
      I1 = (I-1)*3 + 1
      DO 60 J = 1,6
      Q(I,J) = QQQ(I1,J)
   60 CONTINUE
C
C     NO NEED TO COMPUTE DETERMINANT SINCE IT IS NOT USED SUBSEQUENTLY.
C
      ISING = -1
      CALL INVERS (6,Q,6,QQQINV(1),0,DETERM,ISING,IND)
      IF (ISING .EQ. 2) GO TO 660
C
C     FOURTH ARGUMENT IS A DUMMY LOCATION FOR INVERSE AND HENCE TS1(1)
C     IS U
C
C     AGAIN RESET ISING TO -1
C
      ISING = -1
      CALL INVERS (20,QQQ,20,QQQINV(1),0,DETERM,ISING,INDEX)
C
C     ISING EQUAL TO 2 IMPLIES THAT QQQ IS SINGULAR
C
      IF (ISING .EQ. 2) GO TO 660
C
C     FIRST 18 COLUMNS OF QQQ INVERSE IS THE QQQINV FOR USE IN STIFFNESS
C     MA CALCULATIONS
C
      DO 70 I = 1,20
      DO 70 J = 1,18
      IJ = (I-1)*18 + J
      QQQINV(IJ) = QQQ(I,J)
   70 CONTINUE
C
C     START EXECUTION FOR STIFFNESS MATRIX CALCULATION
C
C     CM IS STIFFNESS MATRIX IN ELEMENT COORDINATES
C
C     OBTAIN MEMBRANE STRESSES
C
C     RELEVANT PORTION OF STRESS ROUTINE OF TRIM6 IS CODED HERE
C
C     TRANSFORMATION MATRIX BETWEEN ELEMENT AND BASIC COORDINATES
C
      ES(1) = IVECT(1)
      ES(2) = JVECT(1)
      ES(3) = IVECT(2)
      ES(4) = JVECT(2)
      ES(5) = IVECT(3)
      ES(6) = JVECT(3)
      DO 90 I = 1,9
      BALOTR(I) = 0.0
   90 CONTINUE
C
      DO 100 I = 1,7
      PH1OUT(I) = EST(I)
  100 CONTINUE
      PH1OUT( 8) = EST(10)
      PH1OUT( 9) = EST(11)
      PH1OUT(10) = EST(12)
      PH1OUT(11) = TREF
      EMOD(1) = EM(1)
      EMOD(2) = EM(2)
      EMOD(3) = EM(3)
      EMOD(4) = EM(2)
      EMOD(5) = EM(4)
      EMOD(6) = EM(5)
      EMOD(7) = EM(3)
      EMOD(8) = EM(5)
      EMOD(9) = EM(6)
C
      CALL GMMATS (EMOD,3,3,0,ALF(1),3,1,0,PH1OUT(228))
      DO 210 JJ = 1,3
      J = 2*JJ - 1
      X = XC(J)
      Y = YC(J)
      DO 110 I = 1,36
      TMMM(I) = 0.0
  110 CONTINUE
C
C     TM MATRIX IS THE PRODUCT OF B AND Q INVERSE MATRICES
C
      DO 120 J = 1,6
      J1 = (J-1)*2 + 1
      J2 = J1 + 1
      TM(1,J1) = Q(2,J) + 2.0*X*Q(4,J) + Y*Q(5,J)
      TM(2,J2) = Q(3,J) + X*Q(5,J) + 2.0*Y*Q(6,J)
      TM(3,J1) = TM(2,J2)
      TM(3,J2) = TM(1,J1)
  120 CONTINUE
C
C     ZERO STRESS VECTOR STORAGE
C
      DO 130 I = 1,3
      STRESS(I) = 0.0
  130 CONTINUE
C
      DO 180 II = 1,6
      IJ1 = (JJ-1)*54 + (II-1)*9 + 12
      IF (ICS(II) .EQ. 0) GO TO 140
      CALL TRANSS (IEST(4*II+24),TRANS)
      CALL GMMATS (ES,3,2,+1,TRANS,3,3,0,EE1)
      GO TO 160
  140 CONTINUE
      DO 150 I = 1,3
      DO 150 J = 1,2
      I1 = (I-1)*2 + J
      J1 = (J-1)*3 + I
      EE1(J1) = ES(I1)
  150 CONTINUE
  160 CONTINUE
      MZ = (II-1)*6 + 1
      CALL GMMATS (EMOD,3,3,0,TMMM(MZ),2,3,+1,EPH1)
      CALL GMMATS (EPH1,3,2,0,EE1,2,3,0,PH1OUT(IJ1))
C
C     POINTER TO I-TH SIL IN PH1OUT
C
      NPOINT = 55 + (II-1)*6
C
C     POINTER TO  3X3 S SUB I MATRIX
C
      NPT1 = 12 + (II-1)*9 + (JJ-1)*54
C
      CALL GMMATS (PH1OUT(NPT1),3,3,0,EST(NPOINT),3,1,0,VEC(1))
      DO 170 J = 1,3
      STRESS(J) = STRESS(J) + VEC(J)
      STR(J) = STRESS(J)
  170 CONTINUE
  180 CONTINUE
      IF (IEST(54) .EQ. -1) GO TO 200
      TEM = EST(54) - PH1OUT(11)
      DO 190 I = 1,3
      STRESS(I) = STRESS(I) - PH1OUT(227+I)*TEM
      STR(I) = STRESS(I)
  190 CONTINUE
  200 CONTINUE
      SIGX(JJ)  = STRESS(1)
      SIGY(JJ)  = STRESS(2)
      SIGXY(JJ) = STRESS(3)
  210 CONTINUE
C
C     EL, FL, GL ARE COEFFICIENTS IN LINEAR VARIATION OF SIGX, SIGY,
C     SIGXY RESPECTIVELY OVER THE ELEMENT
C
C
      EL(1) = (SIGX(1)*A + SIGX(2)*B)/(A+B)
      EL(2) = (SIGX(2) - SIGX(1))/(A+B)
      EL(3) = (SIGX(3) - EL(1))/C
      FL(1) = (SIGY(1)*A + SIGY(2)*B)/(A+B)
      FL(2) = (SIGY(2) - SIGY(1))/(A+B)
      FL(3) = (SIGY(3) - FL(1))/C
      GL(1) = (SIGXY(1)*A + SIGXY(2)*B)/(A+B)
      GL(2) = (SIGXY(2) - SIGXY(1))/(A+B)
      GL(3) = (SIGXY(3) - GL(1))/C
C
C     EVALUATE THE CONSTANTS C1,C2,AND C3 IN THE LINEAR EQUATION FOR
C     THICKNESS VARIATION
C
      CALL AF (F,18,A,B,C,CAB1,CAB2,CAB3,TMEM1,TMEM3,TMEM5,0)
      CAB(1) = CAB1
      CAB(2) = CAB2
      CAB(3) = CAB3
      UNIMEM =.FALSE.
      UNIBEN =.FALSE.
C
      D334 = D33*4.0
      D132 = D13*2.0
      D232 = D23*2.0
C
C     A1,A2,A3 ARE THE COEFFICIENTS OF LINEAR EQUATION FOR VARIATION
C     OF BENDING THICKNESSES
C
      CALL AF (F,18,A,B,C,A1,A2,A3,THK1,THK2,THK3,0)
      IF (ABS(CAB2).LE.1.E-6 .AND. ABS(CAB3).LE.1.E-6) UNIMEM =.TRUE.
      IF (ABS(A2).LE.1.0E-06 .AND. ABS(A3).LE.1.0E-06) UNIBEN =.TRUE.
      A1SQ = A1*A1
      A2SQ = A2*A2
      A3SQ = A3*A3
      C1   = A1SQ*A1
      C2   = 3.0*A1SQ*A2
      C3   = 3.0*A1SQ*A3
      C4   = 3.0*A1*A2SQ
      C5   = 6.0*A1*A2*A3
      C6   = 3.0*A3SQ*A1
      C7   = A2SQ*A2
      C8   = 3.0*A2SQ*A3
      C9   = 3.0*A2*A3SQ
      C10  = A3*A3SQ
      H4   = Q(4,1)*ZC(1) + Q(4,2)*ZC(2) + Q(4,3)*ZC(3) + Q(4,4)*ZC(4) +
     1       Q(4,5)*ZC(5) + Q(4,6)*ZC(6)
      H5   = Q(5,1)*ZC(1) + Q(5,2)*ZC(2) + Q(5,3)*ZC(3) + Q(5,4)*ZC(4) +
     1       Q(5,5)*ZC(5) + Q(5,6)*ZC(6)
      H6   = Q(6,1)*ZC(1) + Q(6,2)*ZC(2) + Q(6,3)*ZC(3) + Q(6,4)*ZC(4) +
     1       Q(6,5)*ZC(5) + Q(6,6)*ZC(6)
      H4   = H4*2.0
      H6   = H6*2.0
C
C     H5 IS MULTIPLIED BY 2.0, SO THAT EXY=DU/DY + DV/DX - ZXY*W
C
      H5   = H5*2.0
C
      DO 260 I = 1,32
      IX   = XU(I)
      RIX  = IX
      JX   = YU(I)
      RJX  = JX
      KX   = XV(I)
      RKX  = KX
      LX   = YV(I)
      RLX  = LX
      MX   = XW(I)
      RMX  = MX
      NX   = YW(I)
      RNX  = NX
      RMNX = RMX*RNX
      RMX1 = RMX*(RMX-1.0)
      RNX1 = RNX*(RNX-1.0)
C
      DO 250 J = I,32
      IJ   = (I-1)*32 + J
      JI   = (J-1)*32 + I
      IY   = XU(J)
      RIY  = IY
      JY   = YU(J)
      RJY  = JY
      KY   = XV(J)
      RKY  = KY
      LY   = YV(J)
      RLY  = LY
      MY   = XW(J)
      RMY  = MY
      NY   = YW(J)
      RNY  = NY
      RMNY = RMY*RNY
      RMY1 = RMY*(RMY-1.0)
      RNY1 = RNY*(RNY-1.0)
      ST   = 0.0
      DO 230 K = 1,3
      DO 220 L = 1,3
      RR    = RK(K) + RL(L)
      RR0   = RK(K) + RL(L) - 1
      RR1   = RK(K) + RL(L) + 1
      SS    = SK(K) + SL(L)
      SS0   = SK(K) + SL(L) - 1
      SS1   = SK(K) + SL(L) + 1
      MM    = MX + MY
      MMRR0 = MM + RR0
      MMRR1 = MM + RR1
      NN    = NX + NY
      NNSS1 = NN + SS1
      NNSS0 = NN + SS0
      MMRR  = MM + RR
      NNSS  = NN + SS
      KK    = KX + KY
      KKRR0 = KK + RR0
      LL    = LX + LY
      LLSS1 = LL + SS1
      II    = IX + IY
      JJ    = JX + JY
      IIRR1 = II + RR1
      JJSS0 = JJ + SS0
      KI    = KX + IY
      KIRR  = KI + RR
      LJ    = LX + JY
      LJSS  = LJ + SS
      IK    = IX + KY
      IKRR  = IK + RR
      JL    = JX + LY
      JLSS  = JL + SS
      KM    = KX + MY
      KMRR  = KM + RR
      LN    = LX + NY
      LNSS1 = LN + SS1
      IM    = IX + MY
      IMRR1 = IM + RR1
      JN    = JX + NY
      JNSS  = JN + SS
      KKRR  = KK + RR
      LLSS  = LL + SS
      KIRR1 = KI + RR1
      LJSS0 = LJ + SS0
      MK    = MX + KY
      MKRR  = MK + RR
      NLSS1 = NX + LY + SS1
      MI    = MX + IY
      MIRR1 = MI + RR1
      NJ    = NX + JY
      NJSS  = NJ + SS
      IKRR0 = IK + RR0
      JLSS1 = JL + SS1
      IIRR  = II + RR
      JJSS  = JJ + SS
      IKRR1 = IK + RR1
      JLSS0 = JL + SS0
      LNSS1 = LN + SS1
      KIRR0 = KI + RR0
      LJSS1 = LJ + SS1
      SB1   = 0.0
      SB2   = 0.0
      SB3   = 0.0
      SB4   = 0.0
      SB5   = 0.0
      SB6   = 0.0
      SB7   = 0.0
      SB8   = 0.0
      SB9   = 0.0
      SB10  = 0.0
      SB11  = 0.0
      SB12  = 0.0
      SB13  = 0.0
      SB14  = 0.0
      SB15  = 0.0
      SB16  = 0.0
      SB17  = 0.0
      SB18  = 0.0
      SB19  = 0.0
      SB20  = 0.0
      SB21  = 0.0
      SB22  = 0.0
      SB23  = 0.0
      SB24  = 0.0
      SB25  = 0.0
      SB26  = 0.0
      SB27  = 0.0
      SB28  = 0.0
      SB29  = 0.0
      SB30  = 0.0
      SB31  = 0.0
      SB32  = 0.0
      SB33  = 0.0
      SB34  = 0.0
      SB35  = 0.0
      SB36  = 0.0
      SB37  = 0.0
      SB38  = 0.0
      SB39  = 0.0
      SB40  = 0.0
      IF (MMRR0 .GT. 0) SB1 = CAB(K)*EL(L)*RMX*RMY*F(MMRR0,NNSS1)
      IF (NNSS0 .GT. 0) SB2 = CAB(K)*FL(L)*RNX*RNY*F(MMRR1,NNSS0)
      IF (MMRR.GT.0 .AND. NNSS.GT.0) SB3 = CAB(K)*GL(L)*RNX*RMY*
     1                                     F(MMRR,NNSS)
      IF (MMRR.GT.0 .AND. NNSS.GT.0) SB4 = CAB(K)*GL(L)*RMX*RNY*
     1                                     F(MMRR,NNSS)
      IF (KKRR0 .GT. 0) SB5 = CAB(K)*EL(L)*RKX*RKY*F(KKRR0,LLSS1)
      IF (JJSS0 .GT. 0) SB6 = CAB(K)*EL(L)*RJX*RJY*F(IIRR1,JJSS0)
      IF (KIRR.GT.0 .AND. LJSS.GT.0) SB7 = CAB(K)*EL(L)*RKX*RJY*
     1                                     F(KIRR,LJSS)
      IF (IKRR.GT.0 .AND. JLSS.GT.0) SB8 = CAB(K)*EL(L)*RJX*RKY*
     1                                     F(IKRR,JLSS)
      IF (KIRR.GT.0 .AND. LJSS.GT.0) SB9 = CAB(K)*EL(L)*RKX*RJY*
     1                                     F(KIRR,LJSS)
      IF (KKRR0 .GT. 0) SB10 = CAB(K)*EL(L)*RKX*RKY*F(KKRR0,LLSS1)
      IF (KMRR  .GT. 0) SB11 = CAB(K)*EL(L)*RKX*H5*F(KMRR,LNSS1)
      IF (JJSS0 .GT. 0) SB12 = CAB(K)*EL(L)*RJX*RJY*F(IIRR1,JJSS0)
      IF (IKRR.GT.0 .AND. JLSS.GT.0) SB13 = CAB(K)*EL(L)*RJX*RKY*
     1                                      F(IKRR,JLSS)
      IF (JNSS  .GT. 0) SB14 = CAB(K)*EL(L)*RJX*H5*F(IMRR1,JNSS)
      IF (KKRR0 .GT. 0) SB15 = CAB(K)*FL(L)*RKX*RKY*F(KKRR0,LLSS1)
      IF (KIRR.GT.0 .AND. LJSS.GT.0) SB16 = CAB(K)*FL(L)*RKX*RJY*
     1                                      F(KIRR,LJSS)
      IF (JJSS0 .GT. 0) SB17 = CAB(K)*FL(L)*RJX*RJY*F(IIRR1,JJSS0)
      IF (IKRR.GT.0 .AND. JLSS.GT.0) SB18 = CAB(K)*FL(L)*RJX*RKY*
     1                                      F(IKRR,JLSS)
      IF (KIRR.GT.0 .AND. LJSS.GT.0) SB19 = CAB(K)*FL(L)*RKX*RJY*
     1                                      F(KIRR,LJSS)
      IF (KKRR0 .GT. 0) SB20 = CAB(K)*FL(L)*RKX*RKY*F(KKRR0,LLSS1)
      IF (KMRR  .GT. 0) SB21 = CAB(K)*FL(L)*RKX*H5*F(KMRR,LNSS1)
      IF (JJSS0 .GT. 0) SB22 = CAB(K)*FL(L)*RJX*RJY*F(IIRR1,JJSS0)
      IF (IKRR.GT.0 .AND. JLSS.GT.0) SB23 = CAB(K)*FL(L)*RJX*RKY*
     1                                      F(IKRR,JLSS)
      IF (JNSS  .GT. 0) SB24 = CAB(K)*FL(L)*RJX*H5*F(IMRR1,JNSS)
      IF (KKRR.GT.0 .AND. LLSS.GT.0) SB25 = CAB(K)*GL(L)*RLX*RKY*
     1                                      F(KKRR,LLSS)
      IF (KKRR.GT.0 .AND. LLSS.GT.0) SB26 = CAB(K)*GL(L)*RKX*RLY*
     1                                      F(KKRR,LLSS)
      IF (LJSS0 .GT. 0) SB27 = CAB(K)*GL(L)*RLX*RJY*F(KIRR1,LJSS0)
      IF (JLSS0 .GT. 0) SB28 = CAB(K)*GL(L)*RJX*RLY*F(IKRR1,JLSS0)
      IF (MKRR  .GT. 0) SB29 = CAB(K)*GL(L)*RKY*H6*F(MKRR,NLSS1)
      IF (KMRR  .GT. 0) SB30 = CAB(K)*GL(L)*RKX*H6*F(KMRR,LNSS1)
      IF (NJSS  .GT. 0) SB31 = CAB(K)*GL(L)*RJY*H6*F(MIRR1,NJSS)
      IF (JNSS  .GT. 0) SB32 = CAB(K)*GL(L)*RJX*H6*F(IMRR1,JNSS)
      IF (IKRR0 .GT. 0) SB33 = CAB(K)*GL(L)*RIX*RKY*F(IKRR0,JLSS1)
      IF (KIRR0 .GT. 0) SB34 = CAB(K)*GL(L)*RKX*RIY*F(KIRR0,LJSS1)
      IF (IIRR.GT.0 .AND. JJSS.GT.0) SB35 = CAB(K)*GL(L)*RIX*RJY*
     1                                      F(IIRR,JJSS)
      IF (IIRR.GT.0 .AND. JJSS.GT.0) SB36 = CAB(K)*GL(L)*RJX*RIY*
     1                                      F(IIRR,JJSS)
      IF (MKRR  .GT. 0) SB37 = CAB(K)*GL(L)*RKY*H4*F(MKRR,NLSS1)
      IF (KMRR  .GT. 0) SB38 = CAB(K)*GL(L)*RKX*H4*F(KMRR,LNSS1)
      IF (NJSS  .GT. 0) SB39 = CAB(K)*GL(L)*RJY*H4*F(MIRR1,NJSS)
      IF (JNSS  .GT. 0) SB40 = CAB(K)*GL(L)*RJX*H4*F(IMRR1,JNSS)
      ST = ST + SB1 + SB2 + SB3 + SB4 +
     1     0.25*(SB5+SB6-SB7-SB8) + (SB9+SB10-SB11-SB12-SB13+SB14) +
     2     0.25*(SB15-SB16+SB17-SB18) + (-SB19-SB20+SB21+SB22+SB23-SB24)
     3   + 0.5*(SB25+SB26-SB27-SB28-SB29-SB30+SB31+SB32) +
     4     0.5*(-SB33-SB34+SB35+SB36+SB37+SB38-SB39-SB40)
  220 CONTINUE
      IF (UNIMEM) GO TO 240
  230 CONTINUE
  240 CONTINUE
      KSHL(IJ) = ST
      KSHL(JI) = KSHL(IJ)
  250 CONTINUE
  260 CONTINUE
C
C     IF NO TRANSVERSE SHEAR GO TO 230
C
C     IF TSHR EQUAL TO ZERO OR MATID3 EQUAL TO ZERO , SKIP THESE
C     CALCULATION
C
      IF (NOTS) GO TO 270
C
C     CURRENTLY, TRANSVERSE SHEAR CALCULATIONS ARE NOT CODED FOR SHELL
C     ELEMENT WHEN IT IS CODED, CALL THE ROUTINE HERE
C
  270 CONTINUE
      CALL GMMATS (Q,6,6,0,KSHL(1),6,32,0,QKS(1))
      CALL GMMATS (Q,6,6,0,KSHL(193),6,32,0,QKS(193))
      CALL GMMATS (QQQINV,20,18,+1,KSHL(385),20,32,0,QKS(385))
      DO 290 I = 1,30
      DO 280 J = 1,6
      IJ = (I-1)*32 + J
      JI = (I-1)*6  + J
      KSHL(    JI) = QKS(  IJ)
      KSHL(180+JI) = QKS(6+IJ)
  280 CONTINUE
  290 CONTINUE
      DO 310 I = 1,30
      DO 300 J = 1,20
      IJ = (I-1)*32 + J + 12
      JI = (I-1)*20 + J + 360
      KSHL(JI) = QKS(IJ)
  300 CONTINUE
  310 CONTINUE
      CALL GMMATS (KSHL(  1),30,6 ,0,Q,6,6,1 ,QKS(  1))
      CALL GMMATS (KSHL(181),30,6 ,0,Q,6,6,1 ,QKS(181))
      CALL GMMATS (KSHL(361),30,20,0,QQQINV,20,18,0,QKS(361))
      DO 330 I = 1,30
      DO 320 J = 1,6
      IJ = (I-1)*30 + J
      JI = (I-1)*6  + J
      CMS(IJ  ) = QKS(JI    )
      CMS(IJ+6) = QKS(JI+180)
  320 CONTINUE
  330 CONTINUE
      DO 350 I = 1,30
      DO 340 J = 1,18
      IJ = (I-1)*30 + J + 12
      JI = (I-1)*18 + J + 360
      CMS(IJ) = QKS(JI)
  340 CONTINUE
  350 CONTINUE
      DO 360 I = 1,30
      EE(I) = 0.0D0
  360 CONTINUE
      EE( 1) = IVECT(1)
      EE( 2) = JVECT(1)
      EE( 3) = KVECT(1)
      EE( 6) = IVECT(2)
      EE( 7) = JVECT(2)
      EE( 8) = KVECT(2)
      EE(11) = IVECT(3)
      EE(12) = JVECT(3)
      EE(13) = KVECT(3)
      EE(19) = IVECT(1)
      EE(20) = JVECT(1)
      EE(24) = IVECT(2)
      EE(25) = JVECT(2)
      EE(29) = IVECT(3)
      EE(30) = JVECT(3)
      DO 390 K = 1,6
      DO 380 I = 1,2
      K1 = 6*(I-1) + K
      I1 = 5*(K-1) + I
      DO 370 J = 1,30
      CTM (I1,J) = CM1(K1,J)
  370 CONTINUE
  380 CONTINUE
  390 CONTINUE
      DO 420 K = 1,6
      DO 410 I = 1,3
      I2 = 5*(K-1)  + I + 2
      K2 = 12 + (K-1)*3 + I
      DO 400 J = 1,30
      CTM (I2,J) = CM1(K2,J)
  400 CONTINUE
  410 CONTINUE
  420 CONTINUE
      DO 450 K = 1,6
      DO 440 I = 1,2
      K1 = 6*(I-1) + K
      I1 = 5*(K-1) + I
      DO 430 J = 1,30
      CM1(J,I1) = CTM (J,K1)
  430 CONTINUE
  440 CONTINUE
  450 CONTINUE
      DO 480 K = 1,6
      DO 470 I = 1,3
      I2 = 5*(K-1)  + I + 2
      K2 = 12 + (K-1)*3 + I
      DO 460 J = 1,30
      CM1(J,I2) = CTM(J,K2)
  460 CONTINUE
  470 CONTINUE
  480 CONTINUE
C
C     LOCATE THE TRANSFORMATION MATRICES FROM BASIC TO LOCAL (THAT IS
C     COORDINATE AT ANY GRID POINT IN WHICH DISPLACEMENT AND STRESSES
C     ARE R
C     - NOT NEEDED IF FIELD 7 IN GRID CARD IS ZERO)
C
C     TRANSFORM STIFFNESS MATRIX FROM ELEMENT COORDINATES TO BASIC
C     COORDINATE
C
C     TRANSFORM STIFFNESS MATRIX FROM BASIC COORDINATES TO GLOBAL (DISP)
C     COORDINATES
C
C     INSERT THE 6X6 SUBMATRIX  INTO KGG MATRIX
C
      DO 490 I = 1,1296
      CMT(I) = 0.0
  490 CONTINUE
      DO 500 I = 1,6
      SIL(I) = I
  500 CONTINUE
      DO 510 I = 1,6
      IF (NPVT .NE. IEST(I+1)) GO TO 510
      NPIVOT = I
      GO TO  520
  510 CONTINUE
      NOGO = .TRUE.
      WRITE (IOUTPT,720) SFM,IEST(1)
      RETURN
C
  520 CONTINUE
      I    = NPIVOT
      SIL1 = SIL(NPIVOT)
      DO 650 J = 1,6
      SIL2 = SIL(J)
      DO 530 II = 1,36
      BALOTR(II) = 0.0
      KSUB(II)   = 0.0
  530 CONTINUE
      DO 550 K = 1,5
      K1 = (SIL1-1)*5 + K
      DO 540 L = 1,5
      L1 = (SIL2-1)*5 + L
      CSUB(K,L) = CM1(K1,L1)
  540 CONTINUE
  550 CONTINUE
      CALL GMMATS (EE,6,5,0,CSUB,5,5,0,CSUBT)
      CALL GMMATS (CSUBT,6,5,0,EE,6,5,+1,KSUBT)
      DO 560 K = 1,6
      DO 560 L = 1,6
      K1 = (K-1)*6 + L
      L1 = (L-1)*6 + K
      KSUB(L1) = KSUBT(K1)
  560 CONTINUE
C
C     TRANSFORM THE KSUB(36) FROM BASIC TO DISPLACEMENT COORDINATES
C
      IF (NL(SIL1).EQ.0 .OR. ICS(SIL1).EQ.0) GO TO 590
      CALL TRANSS (IEST(4*SIL1+24),TRAND)
      DO 570 JJ = 1,3
      L = 6*(JJ-1) + 1
      M = 3*(JJ-1) + 1
      BALOTR(L   ) = TRAND(M  )
      BALOTR(L+1 ) = TRAND(M+1)
      BALOTR(L+2 ) = TRAND(M+2)
      BALOTR(L+21) = TRAND(M  )
      BALOTR(L+22) = TRAND(M+1)
      BALOTR(L+23) = TRAND(M+2)
  570 CONTINUE
      CALL GMMATS (BALOTR(1),6,6,1,KSUB(1),6,6,0,KSUBT)
      DO 580 K = 1,36
      KSUB(K) = KSUBT(K)
  580 CONTINUE
  590 CONTINUE
      IF (NL(SIL2).EQ.0 .OR. ICS(SIL2).EQ.0) GO TO 630
      IF (J .EQ. I) GO TO 610
      CALL TRANSS (IEST(4*SIL2+24),TRAND)
      DO 600 JJ = 1,3
      L = 6*(JJ-1) + 1
      M = 3*(JJ-1) + 1
      BALOTR(L   ) = TRAND(M  )
      BALOTR(L+1 ) = TRAND(M+1)
      BALOTR(L+2 ) = TRAND(M+2)
      BALOTR(L+21) = TRAND(M  )
      BALOTR(L+22) = TRAND(M+1)
      BALOTR(L+23) = TRAND(M+2)
  600 CONTINUE
  610 CONTINUE
      CALL GMMATS (KSUB(1),6,6,0,BALOTR(1),6,6,0,KSUBT)
      DO 620 K = 1,36
      KSUB(K) = KSUBT(K)
  620 CONTINUE
  630 CONTINUE
      DO 640 IJK = 1,36
  640 KSUBD(IJK) = DBLE(KSUB(IJK))
      CALL DS1B (KSUBD(1),IEST(J+1))
  650 CONTINUE
      GO TO 730
  660 CONTINUE
      NOGO =.TRUE.
      WRITE (IOUTPT,700) UFM,IEST(1)
      RETURN
C
  670 CONTINUE
      NOGO =.TRUE.
      WRITE (IOUTPT,710) UFM,IEST(1)
      RETURN
C
  700 FORMAT (A23,' 2416, MATRIX RELATING GENERALIZED PARAMETERS AND ',
     1       'GRID POINT DISPLACEMENTS IS SINGULAR.', /26X,
     2       'CHECK COORDINATES OF ELEMENT  TRSHL WITH ID =',I9,1H.)
  710 FORMAT (A23,' 2418, MATERIAL ID FOR MEMBRANE EFFECTS IS LESS ',
     1       'THAN OR EQUAL TO ZERO FOR TRSHL ELEMENT WITH ID =',I9,1H.)
  720 FORMAT (A25,' 2419, PIVOT POINT IS NOT EQUAL TO TRSHL ELEMENT ',
     1       'GRID POINTS FOR ELEMENT ID =',I9,1H.)
  730 CONTINUE
      RETURN
      END

      SUBROUTINE DLKAPM (ARG,BLKAPM)
C
C     SUBROUTINE FOR COMPUTING LOGARITHMIC DERIVATIVE OF KAPPA MINUS
C
      COMPLEX         BLKAPM,AI,C1,D1,D2,C1TEST,ARG,E1,ALP0,ALP,ALN
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /SYSTEM/ SYSBUF,IBBOUT
      COMMON /BLK1  / SCRK,SPS,SNS,DSTR,AI,PI,DEL,SIGMA,BETA,RES
C
      C1   =-AI/2.0*(SPS-SNS)
      PI2  = 2.0*PI
      S1   = SPS/(DSTR**2)
      S2   = SNS/DSTR
      GAM0 = SPS*DEL - SIGMA
      C2Q  = GAM0/DSTR - SCRK
      C3Q  = GAM0/DSTR + SCRK
      NN   = 0
      CSEC = C2Q*C3Q
      IF (CSEC .LT. 0.0) NN = 1
      T1   = GAM0*S1
      T2   = S2*SQRT(ABS(CSEC))
      IF (C2Q.LT.0.0 .AND. C3Q.LT.0.0) T2 =-T2
      IF (NN .EQ. 0) ALP0 = T1 + T2
      IF (NN .EQ. 1) ALP0 = CMPLX(T1,T2)
      C1   = C1 + 1.0/(ARG-ALP0)
      A1   = PI2/(SPS-SNS)
      A2   =-A1
      B1   = GAM0/(SPS-SNS)
      C1TEST = 0.0
      DO 20 I = 1,200
      R    = I
      GAMP = PI2*R + GAM0
      GAMN =-PI2*R + GAM0
      C2P  = GAMP/DSTR - SCRK
      C2Q  = GAMP/DSTR + SCRK
      C2N  = GAMN/DSTR - SCRK
      C3Q  = GAMN/DSTR + SCRK
      NN   = 0
      CSEC = C2P*C2Q
      IF (CSEC .LT. 0.0) NN = 1
      T1   = GAMP*S1
      T2   = S2*SQRT(ABS(CSEC))
      IF (C2P.LT.0.0 .AND. C2Q.LT.0.0) T2 =-T2
      IF (NN .EQ. 0) ALP = T1 + T2
      IF (NN .EQ. 1) ALP = CMPLX(T1,T2)
      NN   = 0
      CSEC = C2N*C3Q
      IF (CSEC .LT. 0.0) NN = 1
      T1   = GAMN*S1
      T2   = S2*SQRT(ABS(CSEC))
      IF (C2N.LT.0.0 .AND. C3Q.LT.0.0) T2 =-T2
      IF (NN .EQ. 0) ALN = T1 + T2
      IF (NN .EQ. 1) ALN = CMPLX(T1,T2)
      E1   = A1*R + B1 - ARG
      D1   = (ALP-A1*R-B1)/E1
      D2   = D1/E1
      C1   = C1 + 1.0/(1.0+D1)*D2
      E1   = A2*R + B1 - ARG
      D1   = (ALN-A2*R-B1)/E1
      D2   = D1/E1
      C1   = C1 + 1.0/(1.0+D1)*D2
      IF (CABS((C1-C1TEST)/C1) .LT. 0.0006) GO TO 50
      C1TEST = C1
   20 CONTINUE
      GO TO 70
   50 CONTINUE
      E1   = ARG - B1
      B    = PI/A1
      C1   = C1 - 1.0/E1 + B*CCOS(B*E1)/(CSIN(B*E1))
      BLKAPM = C1
      RETURN
C
   70 WRITE  (IBBOUT,80) UFM
   80 FORMAT (A23,' - AMG MODULE -SUBROUTINE DLKAPM')
      CALL MESAGE (-61,0,0)
      RETURN
      END

      SUBROUTINE FNDSET (GPID,X,IBUF,N)
C
C     GPID = GRID POINT TABLE FOR THIS SET
C
C     N  = 0 INPUT
C     FNDSET READS THE COORDINATES OF THE GRID POINTS IN THIS SET.
C     IF THE GRID POINT TABLE VALUE IS ZERO THE CORRESPONDING GRID
C     POINT IS NOT USED IN THIS SET AND ITS VALUES SKIPPED, OTHERWISE
C     THE XYZ COORDINDATE VALUES ARE READ FROM BGPDT AND PACKED INTO
C     X SPACE. TOTALLY THERE ARE NGPSET GRID DATA SAVED IN X.
C     CORE NEEDED FOR X = 3*NGPSET (PROVIDED BY CALLING ROUTINE)
C
C     N  = 1 INPUT/OUTPUT
C     FNDSET POSITIONS THE STRESS FILE TO THE SUBCASE/VALUE LAST
C     PROCESSED
C
      INTEGER         GPID(1),BGPDT,OES1,REW,SUBC
      REAL            X(3,1),U(3)
      COMMON /BLANK / NGP,SKP11(4),NGPSET,SKP12(4),SKP21(4),BGPDT,
     1                SKP22(8),OES1
      COMMON /NAMES / NIREW,INPREW,SKPN1(2),REW,NOREW
      COMMON /XXPARM/ SKPP(211),SUBC,FLAG,DATA
      EQUIVALENCE     (U(1),INSUB)
      DATA    TWOPI / 0.0 /
C
      IF (N .NE. 0) GO TO 30
      CALL GOPEN (BGPDT,GPID(IBUF),INPREW)
      J = 1
      DO 20 I = 1,NGP
      IF (GPID(I) .NE. 0) GO TO 10
      CALL FREAD (BGPDT,0,-4,0)
      GO TO 20
   10 CALL FREAD (BGPDT,0,-1,0)
      CALL FREAD (BGPDT,X(1,J),3,0)
      J = J + 1
   20 CONTINUE
      CALL CLOSE (BGPDT,REW)
      GO TO 110
C
C     POSITION OES1
C
   30 IF (TWOPI .LT. 6.2) TWOPI = 8.0*ATAN(1.0)
      CALL GOPEN (OES1,GPID(IBUF),INPREW)
   40 CALL READ  (*90,*90,OES1,J,1,0,I)
      CALL FREAD (OES1,0,-2,0)
      CALL FREAD (OES1,U,3,0)
      IF (SUBC .NE. INSUB) GO TO 70
      IF (FLAG-1.0) 100,60,50
   50 J = J/10
C
C     REAL EIGENVALUE ANALYSIS - CONVERT TO FREQUENCY
C
      IF (J .EQ. 2) U(3) = SQRT(ABS(U(3)))/TWOPI
      IF (DATA-U(3) .GT. 1.0E-6) GO TO 70
      GO TO 100
   60 IF (DATA-U(2)) 70,100,70
C
C     WRONG CASE
C
   70 CALL FWDREC (*90,OES1)
      CALL FWDREC (*90,OES1)
      GO TO 40
   90 N = N + 1
  100 CALL BCKREC (OES1)
      CALL CLOSE  (OES1,NOREW)
C
  110 RETURN
      END

      FUNCTION AREA (G,I,J,K)
C
C     THIS ROUTINE IS CALLED BY SFAREA WHICH IS CALLED BY EMGFIN TO
C     COMPUTE THE SURFACE AREAS OF THE SOLID ELEMENTS
C
      DIMENSION  G(1)
      AREA = 0.5*SQRT(
     1 ((G(J+2)-G(I+2))*(G(K+3)-G(I+3))-(G(J+3)-G(I+3))*(G(K+2)-G(I+2)))
     2 **2
     3+((G(J+3)-G(I+3))*(G(K+1)-G(I+1))-(G(J+1)-G(I+1))*(G(K+3)-G(I+3)))
     4 **2
     5+((G(J+1)-G(I+1))*(G(K+2)-G(I+2))-(G(J+2)-G(I+2))*(G(K+1)-G(I+1)))
     6 **2)
      RETURN
      END

      SUBROUTINE FRD2F (MHH,BHH,KHH,FRL,FRQSET,NLOAD,NFREQ,PH,UHV)
C
C     ROUTINE  SOLVES DIRECTLY FOR UNCOUPLED MODAL FORMULATION
C
      INTEGER BHH,FRL,FRQSET,PH,UHV,SYSBUF,FILE,MCB(7)
      INTEGER NAME(2)
C
      COMMON /SYSTEM/ SYSBUF
      COMMON /ZBLPKX/ B(4),JJ
      COMMON /ZNTPKX/A(4),II,IEOL,IEOR
      COMMON  /ZZZZZZ/ CORE(1)
C
      DATA NAME /4HFRD2,4HF   /
C
C ----------------------------------------------------------------------
C
      IBUF1 = KORSZ(CORE) -SYSBUF +1
C
C     PICK UP FREQUENCY LIST
C
      CALL GOPEN(FRL,CORE(IBUF1),0)
      CALL SKPREC(FRL,FRQSET-1)
      IF(IBUF1-1 .LT. NFREQ) GO TO 170
      CALL FREAD(FRL,CORE,NFREQ,1)
      CALL CLOSE( FRL, 1 )
C
C     BRING IN  MODAL MATRICES
C
      IMHH = NFREQ
      MCB(1) = MHH
      CALL RDTRL(MCB)
      LHSET =MCB(2)
      IF(IBUF1-1 .LT. NFREQ+3*LHSET) GO TO 170
      IBHH = IMHH+LHSET
      IKHH = IBHH+LHSET
C
C     BRING IN MHH
C
      MATNAM = MHH
      ASSIGN 30 TO IRET
      IPNT  = IMHH
      GO TO 110
C
C     BRING  IN  BHH
C
   30 MATNAM = BHH
      ASSIGN 40 TO IRET
      IPNT  = IBHH
      GO TO 110
C
C     BRING IN KHH
C
   40 MATNAM =  KHH
      ASSIGN 50 TO IRET
      IPNT = IKHH
      GO TO 110
C
C     READY LOADS
C
   50 CALL GOPEN(PH,CORE(IBUF1),0)
C
C     READY SOLUTIONS
C
      IBUF2 = IBUF1-SYSBUF
      CALL GOPEN(UHV,CORE(IBUF2),1)
      CALL MAKMCB(MCB,UHV,LHSET,2,3)
C
C     COMPUTE  SOLUTIONS
C
      DO 100 I=1,NLOAD
      DO 90 J=1,NFREQ
C
C     PICK  UP  FREQ
C
      W = CORE(J)
      W2 = -W*W
      CALL BLDPK(3,3,UHV,0,0)
      CALL INTPK(*80,PH,0,3,0)
   60 IF( IEOL)  80,70,80
   70 CALL ZNTPKI
C
C     COMPUTE  REAL AND COMPLEX PARTS OF DENOMINATOR
C
      IK = IKHH +II
      IB = IBHH +II
      IM = IMHH +II
      RDEM = W2*CORE(IM) + CORE(IK)
      CDEM = CORE(IB)* W
      DEM = RDEM*RDEM+CDEM*CDEM
      IF(DEM .NE. 0.0) GO TO 71
      CALL MESAGE(5,J,NAME)
      B(1) = 0.0
      B(2) = 0.0
      GO TO 72
   71 CONTINUE
C
C     COMPUTE REAL AND COMPLEX PHI-S
C
      B(1) = (A(1)*RDEM+A(2)*CDEM)/DEM
      B(2) = (A(2)*RDEM-A(1)*CDEM)/DEM
   72 JJ = II
      CALL  ZBLPKI
      GO TO 60
C
C     END  COLUMN
C
   80 CALL BLDPKN(UHV,0,MCB)
   90 CONTINUE
  100 CONTINUE
      CALL CLOSE(UHV,1)
      CALL CLOSE(PH,1)
      CALL WRTTRL(MCB)
      RETURN
C
C     INTERNAL SUBROUTINE TO BRING IN  H MATRICES
C
  110 FILE =MATNAM
      CALL OPEN(*132,MATNAM,CORE(IBUF1),0)
      CALL SKPREC(MATNAM,1)
      DO 130 I=1,LHSET
      IPNT =IPNT +1
      CALL INTPK(*120,MATNAM,0,1,0)
      CALL ZNTPKI
      IF( II .NE. I  .OR. IEOL .NE. 1) GO TO 180
      CORE(IPNT) = A(1)
      GO TO 130
C
C     NULL COLUMN
C
  120 CORE(IPNT) = 0.0
  130 CONTINUE
      CALL CLOSE(MATNAM,1)
  131 GO TO IRET,(30,40,50)
C
C      ZERO CORE FOR PURGED MATRIX
C
  132 DO 133 I = 1 , LHSET
      IPNT = IPNT+1
      CORE(IPNT) = 0.0
  133 CONTINUE
      GO TO 131
C
C     ERROR MESAGES
C
  150 CALL MESAGE(IP1,FILE,NAME)
  170 IP1 = -8
      GO TO 150
  180 IP1 = -7
      GO TO 150
      END

      SUBROUTINE STPAX1
C
C     THIS ROUTINE IS PHASE I OF STRESS DATA RECOVERY FOR THE AXI-
C     SYMMETRIC WITH A TRAPEZOIDAL CROSS SECTION
C
C
C     ECPT (01) = ELEMENT ID                                I
C     ECPT (02) = SIL A                                     I
C     ECPT (03) = SIL B                                     I
C     ECPT (04) = SIL C                                     I
C     ECPT (05) = SIL D
C     ECPT (06) = MATERIAL ORIENTATION ANGLE(DEGREES)       R
C     ECPT (08) = MATERIAL ID                               I
C     ECPT (09) TO ECPT (22) FOR PHI
C     ECPT (23) = COOR. SYS. FOR GRID POINT A               I
C     ECPT (24) = X-COOR. OF GRID POINT A (IN BASIC COOR)   R
C     ECPT (25) = Z-COOR. OF GRID POINT A (IN BASIC COOR)   R
C     ECPT (26) = 0.0
C     ECPT (27) = COOR. SYS. FOR GRID POINT B
C     ECPT (28) = X-COOR. OF GRID POINT B (IN BASIC COOR)   R
C     ECPT (29) = Z-COOR. OF GRID POINT B (IN BASIC COOR)   R
C     ECPT (30) = 0.0
C     ECPT (31) = COOR. SYS. FOR GRID POINT C               I
C     ECPT (32) = X-COOR. FOR GRID POINT C                  R
C     ECPT (33) = Z-COOR. FOR GRID POINT C                  R
C     ECPT (34) = 0.0
C     ECPT (35) = COOR. SYS. FOR GRID POINT D               I
C     ECPT (36) = X-COOR FOR GRID POINT D                   R
C     ECPT (37) = Z-COOR FOR GRID POINT D                   R
C     ECPT (38) = 0.0
C     ECPT (39) = EL. TEMPERATURE FOR MATERIAL PROP         R
C
C     ANY GROUP OF STATEMENTS PREFACED BY AN IF STATEMENT CONTAINING
C     ...KSYS78 OR LSYS78 ...  INDICATES CODING NECESSARY FOR THIS
C     ELEMENT*S PIEZOELECTRIC CAPABILITY
C
C     KSYS78 = 0   ELASTIC, NON-PIEZOELECTRIC MATERIAL
C     KSYS78 = 1   ELECTRICAL-ELASTIC COUPLED, PIEZOELETRIC MATERIAL
C     KSYS78 = 2   ELASTIC ONLY, PIEZOELECTRIC MATERIAL
C     LSYS78 = .TRUE. IF KSYS78 = 0, OR 2
C
      LOGICAL         PZMAT,LSYS78
      INTEGER         SP(50)
      DIMENSION       IECPT(40),DELINT(12),TEO(45),ACURL(208),
     1                ICS(4),D1(48),D2(16),ACURP1(48),ACURP2(16),
     2                GABABQ(12,12),GBP(4,4),ALFB(6),EE(63),WJP(3,4)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
C
C     ECPT COMMON BLOCK
C
      COMMON /SDR2X5/ ECPT(39),DUM5(61),IDEL,IGP(4),TZ,SEL(360),TS(06),
     1                AK(144),PHI(14),AKPH2(16),AKUPH(48),SELP1(120),
     2                SELP2(180),SELP3(60)
      COMMON /SDR2X6/ D(144),E1(36),WJ(6,12),R(5),Z(5)
     1
C
C     INPUT AND OUTPUT BLOCKS FOR SUBROUTINE MAT
C
      COMMON /MATIN / MATIDC,MATFLG,ELTEMP,STRESS,SINTH,COSTH
      COMMON /MATOUT/ E(3),ANU(3),RHO,G(3),ALF(3),TZERO,GSUBE,MOSKP(9),
     1                SETMAT
      COMMON /MATPZ / PZOUT(51)
C     COMMON /MATPZ / CE11,CE12,CE13,CE14,CE15,CE16,CE22,CE23,CE24,CE25,
C                     CE26,CE33,CE34,CE35,CE36,CE44,CE45,CE46,CE55,CE56,
C                     CE66,E11,E12,E13,E14,E15,E16,E21,E22,E23,E24,E25,
C                     E26,E31,E32,E33,E34,E35,E36,EPS11,EPS12,EPS13,
C                     EPS22,EPS23,EPS33,RHO,A1,A2,A12,TREF,GE
      COMMON /SYSTEM/ IBUF,IOUT,DUM75(75),KSYS78
      COMMON /CONDAS/ CONSTS(5)
      EQUIVALENCE     (CONSTS(1),PI),(CONSTS(2),TWOPI),
     1                (CONSTS(4),DEGRAD),(ACURL(1),AK(1)),
     2                (IECPT(1),ECPT(1)),(R(1),R1),(R(2),R2),
     3                (R(3),R3),(R(4),R4),(Z(1),Z1),
     4                (Z(2),Z2),(Z(3),Z3),(Z(4),Z4),
     5                (ACURP1(1),ACURL(145)),(ACURP2(1),ACURL(193))
C
      LSYS78 = .FALSE.
      IF (KSYS78.EQ.0 .OR. KSYS78.EQ.2) LSYS78 = .TRUE.
C
C     START EXECUTION
C
C     STORE ECPT PARAMETERS IN LOCAL VARIABLES
C
      IDEL   = IECPT( 1)
      IGP(1) = IECPT( 2)
      IGP(2) = IECPT( 3)
      IGP(3) = IECPT( 4)
      IGP(4) = IECPT( 5)
      MATID  = IECPT( 8)
      ICS(1) = IECPT(23)
      ICS(2) = IECPT(27)
      ICS(3) = IECPT(31)
      R(1)   =  ECPT(24)
      D(1)   =  ECPT(26)
      Z(1)   =  ECPT(25)
      R(2)   =  ECPT(28)
      Z(2)   =  ECPT(29)
      D(2)   =  ECPT(30)
      R(3)   =  ECPT(32)
      Z(3)   =  ECPT(33)
      D(3)   =  ECPT(34)
      ICS(4) = IECPT(35)
      Z(4)   =  ECPT(37)
      D(4)   =  ECPT(38)
      R(4)   =  ECPT(36)
      TEMPE  =  ECPT(39)
      DGAMA  =  ECPT( 6)
C
C     TEST THE VALIDITY OF THE GRID POINT COORDINATES
C
      DO 200 I = 1,4
      IF (R(I) .LE. 0.0) GO TO 910
      IF (D(I) .NE. 0.0) GO TO 910
  200 CONTINUE
C
C     COMPUTE THE ELEMENT COORDINATES
C
      ZMIN = AMIN1(Z1,Z2,Z3,Z4)
      Z1   = Z1 - ZMIN
      Z2   = Z2 - ZMIN
      Z3   = Z3 - ZMIN
      Z4   = Z4 - ZMIN
      RMIN = AMIN1(R1,R2,R3,R4)
      RMAX = AMAX1(R1,R2,R3,R4)
      IF (RMAX/RMIN .LE. 10.) GO TO 206
C
C     RATIO OF RADII IS TOO LARGE FOR GAUSS QUADRATURE FOR IP=-1
C
      IDEL1 = IDEL/1000
      WRITE  (IOUT,205) UFM,IDEL1
  205 FORMAT (A23,', TRAPAX ELEMENT',I9,' HAS A MAXIMUM TO MINIMUM ',
     1       'RADIUS RATIO EXCEEDING 10.', /5X,'ACCURACY OF NUMERICAL',
     2       ' INTEGRATION WOULD BE IN DOUBT.')
      GO TO 910
  206 CONTINUE
C
C     FORM THE TRANSFORMMATION MATRIX(12X12) FROM FIELD COOR, TO GRID
C     POINT DEGREES OF FREEDOM
C
      DO 300 I = 1,144
  300 GABABQ( I, 1) = 0.0
      GABABQ( 1, 1) = 1.0
      GABABQ( 2, 1) = R1
      GABABQ( 3, 1) = Z1
      GABABQ( 4, 1) = R1*Z1
      GABABQ( 5, 2) = 1.0
      GABABQ( 6, 2) = R1
      GABABQ( 7, 2) = Z1
      GABABQ( 8, 2) = GABABQ(4,1)
      GABABQ( 9, 3) = 1.0
      GABABQ(10, 3) = R1
      GABABQ(11, 3) = Z1
      GABABQ(12, 3) = GABABQ(4,1)
      GABABQ( 1, 4) = 1.0
      GABABQ( 2, 4) = R2
      GABABQ( 3, 4) = Z2
      GABABQ( 4, 4) = R2*Z2
      GABABQ( 5, 5) = 1.0
      GABABQ( 6, 5) = R2
      GABABQ( 7, 5) = Z2
      GABABQ( 8, 5) = GABABQ(4,4)
      GABABQ( 9, 6) = 1.0
      GABABQ(10, 6) = R2
      GABABQ(11, 6) = Z2
      GABABQ(12, 6) = GABABQ(4,4)
      GABABQ( 1, 7) = 1.0
      GABABQ( 2, 7) = R3
      GABABQ( 3, 7) = Z3
      GABABQ( 4, 7) = R3*Z3
      GABABQ( 5, 8) = 1.0
      GABABQ( 6, 8) = R3
      GABABQ( 7, 8) = Z3
      GABABQ( 8, 8) = GABABQ(4,7)
      GABABQ( 9, 9) = 1.0
      GABABQ(10, 9) = R3
      GABABQ(11, 9) = Z3
      GABABQ(12, 9) = GABABQ(4,7)
      GABABQ( 1,10) = 1.0
      GABABQ( 2,10) = R4
      GABABQ( 3,10) = Z4
      GABABQ( 4,10) = R4*Z4
      GABABQ( 5,11) = 1.0
      GABABQ( 6,11) = R4
      GABABQ( 7,11) = Z4
      GABABQ( 8,11) = GABABQ(4,10)
      GABABQ( 9,12) = 1.0
      GABABQ(10,12) = R4
      GABABQ(11,12) = Z4
      GABABQ(12,12) = GABABQ(4,10)
C
      IF (LSYS78) GO TO 305
      GBP(1,1) = 1.0
      GBP(2,1) = R(1)
      GBP(3,1) = Z(1)
      GBP(4,1) = R(1)*Z(1)
      GBP(1,2) = 1.0
      GBP(2,2) = R(2)
      GBP(3,2) = Z(2)
      GBP(4,2) = R(2)*Z(2)
      GBP(1,3) = 1.0
      GBP(2,3) = R(3)
      GBP(3,3) = Z(3)
      GBP(4,3) = R(3)*Z(3)
      GBP(1,4) = 1.0
      GBP(2,4) = R(4)
      GBP(3,4) = Z(4)
      GBP(4,4) = R(4)*Z(4)
  305 CONTINUE
C
C     NO NEED TO COMPUTE DETERMINANT SINCE IT IS NOT USED SUBSEQUENTLY.
C
      ISING = -1
      CALL INVERS (12,GABABQ,12,D(10),0,D(11),ISING,SP)
      IF (ISING .EQ. 2) GO TO 920
C
      IF (KSYS78 .EQ. 1) CALL INVERS (4,GBP,4,D(10),0,D(11),ISING,SP)
      IF (ISING  .EQ. 2) GO TO 920
C
C     MODIFY THE TRANSFORMATION MATRIX IF ELEMENT IS A CORE ELEMENT
C
C     CALCULATE THE INTEGRAL VALUES IN ARRAY DELINT
C
C       DELINT(1) = (-1,0)
C       DELINT(02)= (-1,1)
C       DELINT(03)= (-1,2)
C       DELINT(04)= ( 0,0)
C       DELINT(05)= ( 0,1)
C       DELINT(06)= ( 0,2)
C       DELINT(07)= ( 1,0)
C       DELINT(08)= ( 1,1)
C       DELINT(09)= ( 1,2)
C       DELINT(10)= ( 2,0)
C       DELINT(11)= ( 2,1)
C       DELINT(12)= ( 3,0)
C
      I1 = 0
      DO 400 I = 1,4
      IP = I - 2
      DO 350 J = 1,3
      IQ = J - 1
      I1 = I1 + 1
      IF (I1 .NE. 12) GO TO 340
      IP = 3
      IQ = 0
  340 CONTINUE
      DELINT(I1) = RZINTS(IP,IQ,R,Z,4)
  350 CONTINUE
  400 CONTINUE
C
C     LOCATE THE MATERIAL PROPERTIES IN THE MAT1 OR MAT3
C
      MATIDC = MATID
      MATFLG = 7
      IF (KSYS78 .GT. 0) MATFLG = 9
      ELTEMP = TEMPE
      DGAMR  = DGAMA*DEGRAD
      SINTH  = SIN(DGAMR)
      COSTH  = COS(DGAMR)
      COSG   = COSTH
      SING   = SINTH
      CALL MAT (IDEL)
      PZMAT  = .FALSE.
      IF (SETMAT.EQ.4. .OR. SETMAT.EQ.5.) PZMAT = .TRUE.
      IF (PZMAT) GO TO 410
      KSAVE  = KSYS78
      KSYS78 = 0
      LSYS78 = .TRUE.
      GO TO 420
  410 RHO    = PZOUT(46)
      ALF(1) = PZOUT(47)
      ALF(2) = PZOUT(48)
      ALF(3) = PZOUT(49)
      TZERO  = PZOUT(50)
      GSUBE  = PZOUT(51)
  420 CONTINUE
      IF (SETMAT .EQ. 2.0) GO TO 915
      TZ = TZERO
      IF (KSYS78 .GT. 0) GO TO 500
C
C     SET MATERIAL PROPERTIES IN DOUBLE PRECISION VARIABLES
C
      ER  = E(1)
      ET  = E(2)
      EZ  = E(3)
      VRO = ANU(1)
      VOZ = ANU(2)
      VZR = ANU(3)
      GOR = G(1)
      GZO = G(2)
      GRZ = G(3)
      VOR = VRO*ET/ER
      VZO = VOZ*EZ/ET
      VRZ = VZR*ER/EZ
      DEL = 1.0/(1.0 - VRO*VOR - VOZ*VZO - VZR*VRZ - VRO*VOZ*VZR -
     1           VRZ*VOR*VZO)
C
C     COMPUTE ELASTIC CONSTANTS MATRIX FROM MATERIAL TO ELEMENT AXIS
C
  500 CONTINUE
      DO 510 I = 1,45
  510 TEO (I) = 0.0
C
      IF (KSYS78 .GT. 0) GO TO 520
      TEO ( 1) = ER*(1.0 - VOZ*VZO)*DEL
      TEO ( 2) = ER*(VZR + VZO*VOR)*DEL
      TEO ( 3) = EZ*(1.0 - VRO*VOR)*DEL
      TEO ( 4) = ER*(VOR + VZR*VOZ)*DEL
      TEO ( 5) = ET*(VZO + VRO*VZR)*DEL
      TEO ( 6) = ET*(1.0 - VRZ*VZR)*DEL
      TEO (10) = GRZ
      TEO (15) = GOR
      TEO (21) = GZO
      GO TO 530
  520 CONTINUE
C
C     PIEZOELECTRIC MATERIAL PROPERTIES STORED IN TEO(22-39)
C     DIELECTRIC MATERIAL PROPERTIES STORED IN TEO(40-45)
C     TEO(22-39) CONTAINS E-TRANSPOSE
C
      TEO( 1) = PZOUT( 1)
      TEO( 2) = PZOUT( 2)
      TEO( 3) = PZOUT( 7)
      TEO( 4) = PZOUT( 3)
      TEO( 5) = PZOUT( 8)
      TEO( 6) = PZOUT(12)
      TEO( 7) = PZOUT( 4)
      TEO( 8) = PZOUT( 9)
      TEO( 9) = PZOUT(13)
      TEO(10) = PZOUT(16)
      TEO(11) = PZOUT( 5)
      TEO(12) = PZOUT(10)
      TEO(13) = PZOUT(14)
      TEO(14) = PZOUT(17)
      TEO(15) = PZOUT(19)
      TEO(16) = PZOUT( 6)
      TEO(17) = PZOUT(11)
      TEO(18) = PZOUT(15)
      TEO(19) = PZOUT(18)
      TEO(20) = PZOUT(20)
      TEO(21) = PZOUT(21)
C
      IF (KSYS78 .EQ. 2) GO TO 530
      TEO(22) = PZOUT(22)
      TEO(23) = PZOUT(28)
      TEO(24) = PZOUT(34)
      TEO(25) = PZOUT(23)
      TEO(26) = PZOUT(29)
      TEO(27) = PZOUT(35)
      TEO(28) = PZOUT(24)
      TEO(29) = PZOUT(30)
      TEO(30) = PZOUT(36)
      TEO(31) = PZOUT(25)
      TEO(32) = PZOUT(31)
      TEO(33) = PZOUT(37)
      TEO(34) = PZOUT(26)
      TEO(35) = PZOUT(32)
      TEO(36) = PZOUT(38)
      TEO(37) = PZOUT(27)
      TEO(38) = PZOUT(33)
      TEO(39) = PZOUT(39)
      TEO(40) =-PZOUT(40)
      TEO(41) =-PZOUT(41)
      TEO(42) =-PZOUT(42)
      TEO(43) =-PZOUT(43)
      TEO(44) =-PZOUT(44)
      TEO(45) =-PZOUT(45)
  530 CONTINUE
C
      C2   = COSG*COSG
      C4   = C2*C2
      S2   = SING*SING
      S4   = S2*S2
      C2S2 = C2*S2
      C3   = COSG*C2
      S3   = SING*S2
      CS2  = COSG*S2
      SC2  = SING*C2
      CS   = COSG*SING
C
      EE( 1) = TEO(1)*C4 + TEO(3)*S4 + 2.0*C2S2 * (TEO(2) + 2.0
     1       * TEO(10))
      EE( 2) = TEO(2)*(C4+S4) + C2S2 * (TEO(1)+TEO(3)-4.0*TEO(10))
      EE( 3) = TEO(1)*S4 + 2.0*C2S2 * (TEO(2)+2.0*TEO(10))
     3       +  TEO(3)*C4
      EE( 4) = TEO(4)*C2 + TEO(5)*S2
      EE( 5) = TEO(4)*S2 + TEO(5)*C2
      EE( 6) = TEO(6)
      EE( 7) = COSG*SING*S2 * (TEO(2)-TEO(3)+2.0*TEO(10))
     7       + SING*COSG*C2 * (TEO(1)-TEO(2)-2.0*TEO(10))
      EE( 8) = SING*COSG*C2 * (TEO(2)-TEO(3)+2.0*TEO(10))
     8       + COSG*SING*S2 * (TEO(1)-TEO(2)-2.0*TEO(10))
      EE( 9) = SING*COSG * (TEO(4) - TEO(5))
      EE(10) = C2S2 * (TEO(1)-2.0*TEO(2)+TEO(3)) + TEO(10)*(C2-S2)**2
      EE(12) = 0.0
      EE(13) = 0.0
      EE(15) = TEO(15)*C2 + TEO(21)*S2
      EE(20) = COSG*SING * (TEO(15) - TEO(21))
      EE(21) = TEO(15)*S2 + TEO(21)*C2
C
      IF (LSYS78) GO TO 540
C
C     PIEZOELECTRIC MATERIAL PROPERTIES IN ELEMENT COORDINATES
C
      EE(37) = C3*TEO(22) - S3*TEO(26) + CS2*(TEO(25)+2.0*TEO(32)) -
     7         SC2*(TEO(23)+2.0*TEO(31))
      EE(38) = C3*TEO(23) + S3*TEO(25) + CS2*(TEO(26)-2.0*TEO(31)) +
     8         SC2*(TEO(22)-2.0*TEO(32))
      EE(39) = S2*TEO(27) + C2*TEO(24) - 2.0*CS*TEO(33)
      EE(40) = C3*TEO(25) - S3*TEO(23) + CS2*(TEO(22)-2.0*TEO(32)) -
     O         SC2*(TEO(26)-2.0*TEO(31))
      EE(41) = C3*TEO(26) + S3*TEO(22) + CS2*(TEO(23)+2.0*TEO(31)) +
     1         SC2*( TEO(25)+2.0*TEO(32))
      EE(42) = S2*TEO(24) + C2*TEO(27) + 2.0*CS*TEO(33)
      EE(43) = COSG*TEO(28) - SING*TEO(29)
      EE(44) = COSG*TEO(29) + SING*TEO(28)
      EE(45) = TEO(30)
      EE(46) = C3*TEO(31) + S3*TEO(32) - CS2*(TEO(23)-TEO(26)+TEO(31)) +
     6         SC2*(-TEO(32)-TEO(25)+TEO(22))
      EE(47) = C3*TEO(32) - S3*TEO(31) - CS2*(TEO(25)-TEO(22)+TEO(32)) +
     7         SC2*(TEO(23)+TEO(31)-TEO(26))
      EE(48) = (C2-S2)*TEO(33) + CS*(TEO(24)-TEO(27))
      EE(49) = C2*TEO(34) + S2*TEO(38) - CS*(TEO(35)+TEO(37))
      EE(50) = C2*TEO(35) - S2*TEO(37) + CS*(TEO(34)-TEO(38))
      EE(51) = COSG*TEO(36) - SING*TEO(39)
      EE(52) = C2*TEO(37) - S2*TEO(35) - CS*(TEO(38)-TEO(34))
      EE(53) = C2*TEO(38) + S2*TEO(34) + CS*(TEO(35)+TEO(37))
      EE(54) = COSG*TEO(39) + SING*TEO(36)
C
C     DIELECTRIC MATERIAL PROPERTIES IN ELEMENT COORDINTES
C
      EE(55) = S2*TEO(43) - 2.0*CS*TEO(41) + C2*TEO(40)
      EE(56) = (C2-S2)*TEO(41) - CS*(TEO(43)-TEO(40))
      EE(57) =-SING*TEO(44) + COSG*TEO(42)
      EE(59) = C2*TEO(43) + 2.0*CS*TEO(41) + S2*TEO(40)
      EE(60) = COSG*TEO(44) + SING*TEO(42)
      EE(63) = TEO(45)
  540 CONTINUE
C
C     COMPUTE HARMONIC COEFFICIENT
C
      IECPT(1) = IECPT(1) - (IECPT(1)/1000)*1000 - 1
      AJHO  = IECPT(1)
      AJJHO = AJHO*AJHO
C
C     FORM THE ELEMENT STIFFNESS MATRIX IN FIELD SYSTEM
C
      ACURL ( 1) = (EE(6) + AJJHO * EE(15)) * DELINT(1)
      ACURL ( 2) = (EE(4) + EE(6) + AJJHO * EE(15)) * DELINT(4)
      ACURL ( 3) = (EE(6) + AJJHO * EE(15)) * DELINT(2)
     1           +  EE(9) * DELINT (4)
      ACURL ( 4) = (EE(4) + EE(6) + AJJHO * EE(15))* DELINT(5)
     1           +  EE(9) * DELINT(7)
      ACURL ( 5) = AJHO * (EE(6) + EE(15)) * DELINT(1)
      ACURL ( 6) = AJHO * EE(6) * DELINT(4)
      ACURL ( 7) = AJHO * (EE(6) + EE(15))* DELINT(2) - AJHO * EE(20)
     1           * DELINT(4)
      ACURL ( 8) = AJHO * EE(6) * DELINT(5) - AJHO * EE(20) * DELINT(7)
      ACURL ( 9) = AJJHO * EE(20) * DELINT(1)
      ACURL (10) = DELINT(4) * (EE(9) + AJJHO*EE(20))
      ACURL (11) = DELINT(4) * EE(5) + AJJHO * DELINT(2) * EE(20)
      ACURL (12) = DELINT(7) * EE(5) + DELINT(5)*(EE(9)+AJJHO*EE(20))
      ACURL (14) = (EE(1) + 2.0 * EE(4) + EE(6) + AJJHO * EE(15))
     1           * DELINT(7)
      ACURL (15) = (EE(4) + EE(6) + AJJHO * EE(15)) * DELINT(5)
     1           + (EE(7) + EE(9)) * DELINT(7)
      ACURL (16) = (EE(1) + 2.0 * EE(4) + AJJHO * EE(15) + EE(6))
     1           * DELINT(8) + (EE(7) + EE(9)) * DELINT(10)
      ACURL (17) = AJHO * (EE(4) + EE(6) + EE(15)) * DELINT(4)
      ACURL (18) = AJHO * (EE(4) + EE(6)) * DELINT(7)
      ACURL (19) = AJHO * (EE(4) + EE(6) + EE(15)) * DELINT(5) - AJHO
     1           * EE(20) * DELINT(7)
      ACURL (20) = AJHO * (EE(4) + EE(6)) * DELINT(8) - AJHO * EE(20)
     1           * DELINT(10)
      ACURL (21) = AJJHO * EE(20) * DELINT(4)
      ACURL (22) = DELINT(7) * (EE(7) + EE(9) + AJJHO*EE(20))
      ACURL (23) = DELINT(7)*(EE(2)+EE(5))+AJJHO*DELINT(5)*EE(20)
      ACURL (24) = DELINT(10)*(EE(2)+EE(5))+DELINT(8)*(EE(7)+EE(9)) +
     1             DELINT(8)*AJJHO*EE(20)
      ACURL (27) = (EE(6) + AJJHO * EE(15)) * DELINT(3) + 2.0
     1           * EE(9) * DELINT(5) + EE(10) * DELINT (7)
      ACURL (28) = (EE(4) + EE(6) + AJJHO * EE(15)) * DELINT(6)
     1           + EE(10) * DELINT(10) + (EE(7) + 2.0 * EE(9))
     2           * DELINT (8)
      ACURL (29) = AJHO * (EE(6) + EE(15)) * DELINT(2) + AJHO
     1           * EE(9) * DELINT(4)
      ACURL (30) = AJHO * EE(6) * DELINT(5) + AJHO * EE(9) * DELINT(7)
      ACURL (31) = AJHO * (EE(6) + EE(15)) * DELINT(3) + AJHO * (EE(9)
     1           - EE(20)) * DELINT(5)
      ACURL (32) = AJHO * (EE(9) - EE(20))* DELINT(8) + AJHO
     1           * EE(6) * DELINT(6)
      ACURL (33) = AJJHO * EE(20) * DELINT(2)
      ACURL (34) = DELINT(7)*EE(10) + DELINT(5)*(EE(9) + AJJHO*EE(20))
      ACURL (35) = DELINT(7)*EE(8) + DELINT(5)*EE(5) + AJJHO*DELINT(3)
     1           * EE(20)
      ACURL (36) = DELINT(10)*EE(8)+DELINT(8)*(EE(5)+EE(10)) +
     1             DELINT(6)*(EE(9)+AJJHO*EE(20))
      ACURL (40) = (EE(1) + 2.0 * EE(4) + EE(6) + AJJHO * EE(15))
     1           * DELINT(9) + (2.0 * EE(7) + 2.0 * EE(9))
     2           * DELINT(11)+ EE(10) * DELINT(12)
      ACURL (41) = AJHO * (EE(4) + EE(6) + EE(15)) * DELINT(5)
     1           + AJHO * EE(9) * DELINT(7)
      ACURL (42) = AJHO * (EE(4) + EE(6)) * DELINT(8) + AJHO * EE(9)
     1           * DELINT(10)
      ACURL (43) = AJHO * (EE(4) + EE(6) + EE(15))* DELINT(6)
     1           + AJHO * (EE(9) - EE(20)) * DELINT(8)
      ACURL (44) = AJHO * (EE(4) + EE(6)) * DELINT(9) + AJHO
     1           * (EE(9) - EE(20)) * DELINT(11)
      ACURL (45) = AJJHO * EE(20) * DELINT(5)
      ACURL (46) = DELINT(8)*(EE(7) + EE(9) + AJJHO*EE(20)) + DELINT(10)
     1           * EE(10)
      ACURL (47) = DELINT(8)*(EE(2) + EE(5)) + DELINT(10)*EE(8) +
     1             AJJHO*DELINT(6)*EE(20)
      ACURL (48) = DELINT(11)*(EE(2)+EE(5)+EE(10)) + DELINT(12)*EE(8) +
     1             DELINT(9)*(EE(7)+EE(9)+AJJHO*EE(20))
      ACURL (53) = (EE(15) + AJJHO * EE(6)) * DELINT(1)
      ACURL (54) = AJJHO * EE(6) * DELINT(4)
      ACURL (55) = (EE(15) + AJJHO * EE(6)) * DELINT(2) - EE(20)
     1           * DELINT(4)
      ACURL (56) = AJJHO * EE(6) * DELINT(5) - EE(20) * DELINT(7)
      ACURL (57) = AJHO * EE(20) * DELINT(1)
      ACURL (58) = AJHO*DELINT(4)*(EE(9)+EE(20))
      ACURL (59) = AJHO*(DELINT(4)*EE(5) + DELINT(2)*EE(20))
      ACURL (60) = AJHO*(DELINT(7)*EE(5)+DELINT(5)*(EE(9)+EE(20)))
      ACURL (66) = AJJHO * EE(6) * DELINT(7)
      ACURL (67) = AJJHO * EE(6) * DELINT(5)
      ACURL (68) = AJJHO * EE(6) * DELINT(8)
      ACURL (69) = 0.0
      ACURL (70) = AJHO*DELINT(7)*EE(9)
      ACURL (71) = AJHO*DELINT(7)*EE(5)
      ACURL (72) = AJHO*(DELINT(10)*EE(5)+DELINT(8)*EE(9))
      ACURL (79) = (EE(15) + AJJHO * EE(6)) * DELINT(3) - 2.0
     1           * EE(20) * DELINT(5) + EE(21) * DELINT(7)
      ACURL (80) = AJJHO * EE(6) * DELINT(6) - EE(20) * DELINT(8)
     1           + EE(21) * DELINT(10)
      ACURL (81) = AJHO * (EE(20) * DELINT(2) - EE(21) * DELINT(4))
      ACURL (82) = AJHO*(DELINT(5)*(EE(9)+EE(20))-DELINT(7)*EE(21))
      ACURL (83) = AJHO*(DELINT(5)*(EE(5)-EE(21))+DELINT(3)*EE(20))
      ACURL (84) = AJHO*(DELINT(8)*(EE(5)-EE(21))+DELINT(6)*(EE(9) +
     1             EE(20)))
      ACURL (92) = EE(21) * DELINT(12) + AJJHO * EE(6) * DELINT(9)
      ACURL (93) =-AJHO * EE(21) * DELINT(7)
      ACURL (94) = AJHO*(DELINT(8)*EE(9)-DELINT(10)*EE(21))
      ACURL (95) = AJHO* DELINT(8) * (EE(5)-EE(21))
      ACURL (96) = AJHO*(DELINT(11)*(EE(5)-EE(21))+DELINT(9)*EE(9))
      ACURL (105) = AJJHO * EE(21) * DELINT(1)
      ACURL (106) = AJJHO*DELINT(4)*EE(21)
      ACURL (107) = AJJHO*DELINT(2)*EE(21)
      ACURL (108) = AJJHO*DELINT(5)*EE(21)
      ACURL (118) = DELINT(7)*(EE(10)+AJJHO*EE(21))
      ACURL (119) = DELINT(7)*EE(8)+AJJHO*DELINT(5)*EE(21)
      ACURL (120) = DELINT(10)*EE(8)+DELINT(8)*(EE(10)+AJJHO*EE(21))
      ACURL (131) = DELINT(7)*EE(3)+AJJHO*DELINT(3)*EE(21)
      ACURL (132) = DELINT(10)*EE(3)+DELINT(8)*EE(8)+AJJHO*DELINT(6)*
     1              EE(21)
      ACURL (144) = DELINT(12)*EE(3) + 2.0*DELINT(11)*EE(8) +
     1              DELINT(9)*(EE(10)+AJJHO*EE(21))
C
      IF (LSYS78) GO TO 550
      ACURL(145) = DELINT(1)*AJHO*(AJHO*EE(51)-EE(45))
      ACURL(146) = DELINT(4)*(EE(43)+AJHO*(AJHO*EE(51)-EE(49)-EE(45)))
      ACURL(147) = DELINT(2)*AJHO*(AJHO*EE(51)-EE(45))+DELINT(4)*
     7             (EE(44)-AJHO*EE(50))
      ACURL(148) = DELINT(5)*(EE(43)+AJHO*(AJHO*EE(51)-EE(49)-EE(45)))
     8           + DELINT(7)*(EE(44)-AJHO*EE(50))
      ACURL(149) = DELINT(4)*AJHO*(AJHO*EE(51)-EE(45)-EE(39))
      ACURL(150) = DELINT(7)*(EE(43)+EE(37)+AJHO*(AJHO*EE(51)-EE(49)
     O           - EE(45)-EE(39)))
      ACURL(151) = DELINT(5)*AJHO*(AJHO*EE(51)-EE(45)-EE(39))+DELINT(7)
     1           * (EE(44)+EE(38)-AJHO*EE(50))
      ACURL(152) = DELINT(8)*(EE(43)+EE(37)+AJHO*(AJHO*EE(51)-EE(49)-
     2             EE(45)-EE(39)))+DELINT(10)*(EE(44)+EE(38)-AJHO*
     2             EE(50))
      ACURL(153) = DELINT(2)*AJHO*(AJHO*EE(51)-EE(45))-DELINT(4)*AJHO
     3           * EE(48)
      ACURL(154) = DELINT(5)*(EE(43)+AJHO*(AJHO*EE(51)-EE(49)-EE(45)))
     4           + DELINT(7)*(EE(46)-AJHO*EE(48))
      ACURL(155) = DELINT(3)*AJHO*(AJHO*EE(51)-EE(45))+DELINT(5)*
     5             (EE(44)-AJHO*(EE(50)+EE(48)))+DELINT(7)*EE(47)
      ACURL(156) = DELINT(6)*(EE(43)+AJHO*(AJHO*EE(51)-EE(49)-EE(45)))
     6           + DELINT(8)*(EE(46)+EE(44)-AJHO*(EE(50)+EE(48)))+
     6             DELINT(10)*EE(47)
      ACURL(157) = DELINT(5)*AJHO*(AJHO*EE(51)-EE(45)-EE(39))-DELINT(7)
     7           * AJHO*EE(48)
      ACURL(158) = DELINT(8)*(EE(43)+EE(47)+AJHO*(AJHO*EE(51)-EE(49)-
     8             EE(45)-EE(39)))-DELINT(10)*(EE(46)-AJHO*EE(48))
      ACURL(159) = DELINT(6)*AJHO*(AJHO*EE(51)-EE(45)-EE(39))+DELINT(8)
     9           * (EE(44)+EE(38)-AJHO*(EE(50)+EE(48)))+DELINT(10)*
     9             EE(47)
      ACURL(160) = DELINT(9)*(EE(43)+EE(37)+AJHO*(AJHO*EE(51)-EE(49)-
     O             EE(45)-EE(39)))+DELINT(11)*(EE(46)+EE(44)+EE(38)-
     O             AJHO*(EE(50)+EE(48)))+DELINT(12)*EE(47)
      ACURL(161) = DELINT(1)*AJHO*(EE(51)-AJHO*EE(45))
      ACURL(162) = DELINT(4)*(-EE(49)+AJHO*(EE(51)+EE(43)-AJHO*EE(45)))
      ACURL(163) = DELINT(2)*AJHO*(EE(51)-AJHO*EE(45))+DELINT(4)*
     3             (AJHO*EE(44)-EE(50))
      ACURL(164) = DELINT(5)*(-EE(49)+AJHO*(EE(51)+EE(43)-AJHO*EE(51)))
     4           + DELINT(7)*(AJHO*EE(44)-EE(50))
      ACURL(165) =-DELINT(4)*AJJHO*EE(45)
      ACURL(166) = DELINT(7)*AJHO*(EE(43)-AJHO*EE(45))
      ACURL(167) = DELINT(7)*AJHO*EE(44)-DELINT(5)*AJJHO*EE(45)
      ACURL(168) = DELINT(8)*AJHO*(EE(43)-AJHO*EE(45))+DELINT(10)*
     8             AJHO*EE(44)
      ACURL(169) = DELINT(2)*AJHO*(EE(51)-AJHO*EE(45))-DELINT(4)*AJHO*
     9             EE(54)
      ACURL(170) = DELINT(5)*(-EE(49)+AJHO*(EE(51)+EE(43)-AJHO*EE(45)))
     O           + DELINT(7)*(EE(52)-AJHO*EE(54))
      ACURL(171) = DELINT(3)*AJHO*(EE(51)-AJHO*EE(45))+DELINT(5)*
     1             (AJHO*(EE(44)-EE(54))-EE(50))+DELINT(7)*EE(53)
      ACURL(172) = DELINT(6)*(-EE(49)+AJHO*(EE(51)+EE(43)-AJHO*EE(45)))
     2           + DELINT(8)*(EE(52)-EE(50)+AJHO*(EE(44)-EE(54)))
     2           + DELINT(10)*EE(53)
      ACURL(173) =-DELINT(5)*AJJHO*EE(45)-DELINT(7)*AJHO*EE(54)
      ACURL(174) = DELINT(8)*AJHO*(EE(43)-AJHO*EE(45))+DELINT(10)*
     4             (EE(54)-AJHO*EE(54))
      ACURL(175) =-DELINT(6)*AJJHO*EE(45)+DELINT(8)*AJHO*(EE(44)-
     5             EE(54))+DELINT(10)*EE(53)
      ACURL(176) = DELINT(9)*AJHO*(EE(43)-AJHO*EE(45))+DELINT(11)*
     6             (EE(52)+AJHO*(EE(44)-EE(54)))+DELINT(12)*EE(53)
      ACURL(177) = DELINT(1)*AJJHO*EE(54)
      ACURL(178) = DELINT(4)*AJHO*(AJHO*EE(54)-EE(52))
      ACURL(179) = DELINT(2)*AJJHO*EE(54)-DELINT(4)*AJHO*EE(53)
      ACURL(180) = DELINT(5)*AJHO*(AJHO*EE(54)-EE(52))-DELINT(7)*AJHO
     O           * EE(53)
      ACURL(181) = DELINT(4)*AJHO*(AJHO*EE(54)-EE(48))
      ACURL(182) = DELINT(7)*(EE(46)+AJHO*(AJHO*EE(54)-EE(52)-EE(48)))
      ACURL(183) = DELINT(5)*AJHO*(AJHO*EE(54)-EE(48))+DELINT(7)*
     3             (EE(47)-AJHO*EE(53))
      ACURL(184) = DELINT(8)*(EE(46)+AJHO*(AJHO*EE(54)-EE(52)-EE(48)))
     4           + DELINT(10)*(EE(47)-AJHO*EE(53))
      ACURL(185) = DELINT(2)*AJJHO*EE(54)-DELINT(4)*AJHO*EE(42)
      ACURL(186) = DELINT(5)*AJHO*(AJHO*EE(54)-EE(52))+DELINT(7)*(EE(40)
     6           - AJHO*EE(42))
      ACURL(187) = DELINT(3)*AJJHO*EE(54)-DELINT(5)*AJHO*(EE(53)+EE(42))
     7           + DELINT(7)*EE(41)
      ACURL(188) = DELINT(6)*AJHO*(AJHO*EE(54)-EE(52))+DELINT(8)*
     8             (EE(40)-AJHO*(EE(53)+EE(42)))+DELINT(10)*EE(41)
      ACURL(189) =-DELINT(5)*AJHO*EE(48)+DELINT(4)*AJJHO*EE(54)
     9           - DELINT(7)*AJHO*EE(42)
      ACURL(190) = DELINT(8)*(EE(46)-AJHO*EE(48))+DELINT(7)*AJHO*
     O             (AJHO*EE(54)-EE(52))+DELINT(10)*(EE(40)-AJHO*EE(42))
      ACURL(191) =-DELINT(6)*AJHO*EE(48)+DELINT(5)*AJJHO*EE(54)+
     1             DELINT(8)*(EE(47)-AJHO*EE(42))-DELINT(7)*AJHO*EE(53)
     1           + DELINT(10)*EE(41)
      ACURL(192) = DELINT(9)*(EE(46)-AJHO*EE(48))+DELINT(8)*AJHO*
     2             (AJHO*EE(54)-EE(52))+DELINT(11)*(EE(47)+EE(40)-
     2             AJHO*EE(42))-DELINT(10)*AJHO*EE(53)+DELINT(12)*EE(41)
C
      ACURL(193) = DELINT(1)*AJJHO*EE(63)
      ACURL(194) = DELINT(4)*AJHO*(AJHO*EE(63)-EE(57))
      ACURL(195) = DELINT(2)*AJJHO*EE(63)-DELINT(4)*AJHO*EE(60)
      ACURL(196) = DELINT(5)*AJHO*(AJHO*EE(63)-EE(57))-DELINT(7)*
     6             AJHO*EE(60)
      ACURL(197) = DELINT(4)*AJHO*(AJHO*EE(63)-EE(57))
      ACURL(198) = DELINT(7)*(AJJHO*EE(63)-2.0*AJHO*EE(57)+EE(55))
      ACURL(199) = DELINT(5)*AJHO*(AJHO*EE(63)-EE(57))+DELINT(7)*(EE(56)
     9           - AJHO*EE(60))
      ACURL(200) = DELINT(8)*(AJJHO*EE(63)-2.0*AJHO*EE(57)+EE(55))
     O           + DELINT(10)*(EE(56)-AJHO*EE(60))
      ACURL(201) = DELINT(2)*AJJHO*EE(63)-DELINT(4)*AJHO*EE(60)
      ACURL(202) = DELINT(5)*AJHO*(AJHO*EE(63)-EE(57))+DELINT(7)*
     2             (EE(56)-AJHO*EE(60))
      ACURL(203) = DELINT(3)*AJJHO*EE(63)-DELINT(5)*2.0*AJHO*EE(60)
     3           + DELINT(7)*EE(59)
      ACURL(204) = DELINT(6)*AJHO*(AJHO*EE(63)-EE(57))+DELINT(8)*
     4             (EE(56)-2.0*AJHO*EE(60))+DELINT(10)*EE(59)
      ACURL(205) = DELINT(5)*AJHO*(AJHO*EE(63)-EE(57))-DELINT(7)*
     5             AJHO*EE(60)
      ACURL(206) = DELINT(8)*(AJJHO*EE(63)-2.0*EE(57)+EE(55))+DELINT(10)
     6           * (EE(56)-AJHO*EE(60))
      ACURL(207) = DELINT(6)*AJHO*(AJHO*EE(63)-EE(57))+DELINT(8)*(EE(56)
     7           - 2.0*AJHO*EE(60))+DELINT(10)*EE(59)
      ACURL(208) = DELINT(9)*(AJJHO*EE(63)-2.0*AJHO*EE(57)+EE(55))+
     8             2.0*DELINT(11)*(EE(56)-AJHO*EE(60))+DELINT(12)*EE(59)
  550 CONTINUE
C
C     TRANSFORM THE ELEMENT STIFFNESS MATRIX FROM FIELD SYSTEM
C     TO GRID POINT DEGREES OF FREEDOM
C
C     EXPAND ACURL INTO (12X12)
C
      DO 610 IB = 2,12
      IC = 13*IB - 25
      I  = IC
      DO 605 J = IB,12
      IC = IC + 12
      I  = I + 1
  605 ACURL(IC) = ACURL(I)
  610 CONTINUE
C
      DGAMA = PI
      IF (AJHO .EQ. 0.0) DGAMA = TWOPI
      DO 630 I = 1,144
  630 ACURL(I) = ACURL(I)*DGAMA
C
      IF (LSYS78) GO TO 638
      DO 632 I = 145,208
  632 ACURL(I) = ACURL(I)*DGAMA
  638 CONTINUE
C
      CALL GMMATS (GABABQ,12,12,1, ACURL, 12,12,0, D )
      CALL GMMATS (     D,12,12,0, GABABQ,12,12,0, AK)
C
      IF (LSYS78) GO TO 639
      CALL GMMATS (GABABQ,12,12,1, ACURP1,12,4,0, D1)
      CALL GMMATS (D1,12,4,0, GBP,4,4,0, AKUPH)
      CALL GMMATS (GBP,4,4,1, ACURP2,4,4,0, D2)
      CALL GMMATS (D2,4,4,0, GBP,4,4,0, AKPH2)
  639 CONTINUE
C
C     ********** COORDINATE SYSTEM NOT POSSIBLE ***********************
C     *** WITH RINGAX.  THE FOLLOWING CODE WILL IMPLEMENT IT  *********
C     IF FOLLOWING CODE IS IMPLEMENTED MUST BE MODIFIED FOR PIEZO-
C     ELECTRIC
C
C     ZERO OUT THE AKI MATRIX
C
C.    DO 700 I = 1,144
C.    AKI(I) = 0.0
C.700 CONTINUE
C.    DO 800 I = 1,4
C.    CALL TRANSS (ICS(I),D(1))
C.    K = 39 * (I-1) + 1
C.    DO 800 J = 1, 3
C.    KK = K + 12*(J-1)
C.    JJ = 3*(J-1) + 1
C.    AKI (KK  ) = D (JJ  )
C.    AKI (KK+1) = D (JJ+1)
C.    AKI (KK+2) = D (JJ+2)
C.800 CONTINUE
C
C     TRANSFORM THE STIFFNESS MATRIX FROM BASIC TO LOCAL COORDINATES
C
C.    CALL GMMATS (AKI(1),12,12,1, AK(1),12,12,0, D(1))
C.    CALL GMMATS (D(1),12,12,0, AKI(1),12,12,0, AK(1))
C
C     COMPUTE THE FIFTH GRID POINT
C
      R(5) = (R1 + R2 + R3 + R4)/4.0
      Z(5) = (Z1 + Z2 + Z3 + Z4)/4.0
C
C     FORM WJ MATRIX
C
      DO 9001 IKI = 1,5
      DO 1000 I = 1,72
 1000 WJ(I, 1) = 0.0
      RSUM     = R(IKI)
      ZSUM     = Z(IKI)
      ZDR      = ZSUM/RSUM
      WJ(1, 2) = 1.0
      WJ(1, 4) = ZSUM
      WJ(2,11) = 1.0
      WJ(2,12) = RSUM
      WJ(3, 1) = 1.0/RSUM
      WJ(3, 2) = 1.0
      WJ(3, 3) = ZDR
      WJ(3, 4) = ZSUM
      WJ(3, 5) = AJHO/RSUM
      WJ(3, 6) = AJHO
      WJ(3, 7) = AJHO*ZDR
      WJ(3, 8) = AJHO*ZSUM
      WJ(4, 3) = 1.0
      WJ(4, 4) = RSUM
      WJ(4,10) = 1.0
      WJ(4,12) = ZSUM
      WJ(5, 1) =-AJHO/RSUM
      WJ(5, 2) =-AJHO
      WJ(5, 3) =-AJHO*ZDR
      WJ(5, 4) =-AJHO*ZSUM
      WJ(5, 5) =-1.0/RSUM
      WJ(5, 7) =-ZDR
      WJ(6, 7) = 1.0
      WJ(6, 8) = RSUM
      WJ(6, 9) =-AJHO/RSUM
      WJ(6,10) =-AJHO
      WJ(6,11) =-AJHO*ZDR
      WJ(6,12) =-AJHO*ZSUM
C
      IF (LSYS78) GO TO 1060
C
C     FORM WJP MATRIX
C
      DO 1050 I = 1,3
      DO 1050 J = 1,4
 1050 WJP(I,J) = 0.0
C
      WJP(1,2) = 1.0
      WJP(1,4) = ZSUM
      WJP(2,3) = 1.0
      WJP(2,4) = RSUM
      WJP(3,1) =-AJHO/RSUM
      WJP(3,2) =-AJHO
      WJP(3,3) =-AJHO*ZDR
      WJP(3,4) =-AJHO*ZSUM
 1060 CONTINUE
C
C     EXPAND EE(21) INTO E1(36)
C
      DO 1065 I = 1,36
 1065 E1( I) = 0.0
      E1( 1) = EE( 1)
      E1( 2) = EE( 2)
      E1( 3) = EE( 4)
      E1( 4) = EE( 7)
      E1( 7) = EE( 2)
      E1( 8) = EE( 3)
      E1( 9) = EE( 5)
      E1(10) = EE( 8)
      E1(13) = EE( 4)
      E1(14) = EE( 5)
      E1(15) = EE( 6)
      E1(16) = EE( 9)
      E1(19) = EE( 7)
      E1(20) = EE( 8)
      E1(21) = EE( 9)
      E1(22) = EE(10)
      E1(29) = EE(15)
      E1(36) = EE(21)
C
C     COMPUTE THE STRESS MATRICES
C
      K = 72*(IKI-1) + 1
      CALL GMMATS (WJ,12,6,1, GABABQ,12,12,0, D(1))
      CALL GMMATS (E1(1),6,6,0, D(1),6,12,0, SEL(K))
C
      IF (LSYS78) GO TO 1070
      KP1 = 24*(IKI-1) + 1
      CALL GMMATS (WJP,4,3,1, GBP,4,4,0, D2(1))
      CALL GMMATS (EE(37),6,3,0, D2(1),3,4,0, SELP1(KP1))
      KP2 = 36*(IKI-1) + 1
      CALL GMMATS (EE(37),6,3,1, D(1),6,12,0, SELP2(KP2))
      KP3 = 12*(IKI-1) + 1
      CALL GMMATS (EE(55),3,3,0, D2(1),3,4,0, SELP3(KP3))
 1070 CONTINUE
C
C     ** COORDINATE SYSTEMS NOT POSSIBLE WITH RINGAX *******************
C     ** THE FOLLOWING CODE WILL IMPLEMENT IT **************************
C     ** NOTE THAT WJ IS SEL(K) IN FOLLOWING GMMATS ********************
C
C     ** IF FOLLOWING CODE IS IMPLEMENTED MUST BE MODIFIED FOR PIEZO-
C     ELECTRIC TRANSFORM THE STRESS MATRIX FROM BASIC TO LOCAL
C     COORDINATES
C..   CALL GMMATS (WJ,6,12,0, AKI(1),12,12,0, SEL(K) )
C
C
 9001 CONTINUE
C
C     COMPUTE THE THERMAL STRAIN
C
      ALFB(1) = ALF(1)
      ALFB(2) = ALF(3)
      ALFB(3) = ALF(2)
      ALFB(4) = 0.0
      ALFB(5) = 0.0
      ALFB(6) = 0.0
C
C     COMPUTE THE THERMAL STRESS
C
      TS(1) = EE(1)*ALFB(1) + EE(2)*ALFB(2) + EE(4)*ALFB(3)
      TS(2) = EE(2)*ALFB(1) + EE(3)*ALFB(2) + EE(5)*ALFB(3)
      TS(3) = EE(4)*ALFB(1) + EE(5)*ALFB(2) + EE(6)*ALFB(3)
      TS(4) = EE(7)*ALFB(1) + EE(8)*ALFB(2) + EE(9)*ALFB(3)
      TS(5) = 0.0
      TS(6) = 0.0
C
C     SAVE ECPT(9) TO ECP(22)
C
      DO 9006 IKI = 1,14
      PHI (IKI) = ECPT(8+IKI)
 9006 CONTINUE
      GO TO 940
C
C     SET FATAL ERROR FLAG AND ALLOWING ERROR MESSAGES TO ACCUMLATE
C
  910 I = 37
       GO TO 930
  915 I = 126
       GO TO 930
  920 I = 26
  930 CALL MESAGE (-30,I,IDEL)
  940 IF (.NOT.PZMAT) KSYS78 = KSAVE
      RETURN
      END

      SUBROUTINE OPT2B (IPR,PR,PL,RR)
C
      INTEGER         COUNT,IPR(1),OUTTAP,SYSBUF,IY(1)
      REAL            PL(1),PR(1),RR(1),Y(1),Z(8)
      CHARACTER       UFM*23,UWM*25
      COMMON /XMSSG / UFM,UWM
      COMMON /BLANK / SKP1(2),COUNT,SKP2(6),NWDSP,
     1                SKP3(6),NPRW,NKLW,NTOTL,CONV
      COMMON /ZZZZZZ/ CORE(1)
      COMMON /SYSTEM/ SYSBUF,OUTTAP
      EQUIVALENCE     (CORE(1),Z(1),MAX), (EPS,Z(2)), (GAMA,Z(3)),
     1                (IPRNT,Z(7)), (IY(1),Y(1),Z(8))
C     EQUIVALENT ARE  (IPR,PR)
C
      NMES = 0
      CH   = 1.0
C
      DO 100 NP = 1,NPRW,NWDSP
      ALPH= PR(NP+4)
      I   = 1
      ICP = NTOTL - 4
    3 ICP = ICP+4
      IF (IY(ICP) .LE.  0) GO  TO 5
      IF (IY(ICP) .NE. NP) GO  TO 3
C
C     SPECIAL HANDLING OF TRIM6
C
    4 ALPH = Y(ICP+I)
C
    5 IF (ALPH) 70,40,10
C
C     POSITIVE ALPHA, CALCULATE PNEW
C
   10 IRR = (NP+NWDSP)/NWDSP
      IF (ABS(GAMA-1.0) .LT. 1.0E-4) CH = 0.25*RR(IRR) + 0.75
      PNEW = PR(NP+3)*((ALPH/(ALPH+(1.0-ALPH)*GAMA))**CH)
      IF (IPR(NP+5) .EQ. 0) GO TO 30
C
C     COMPARE TO LIMIT DATA
C
      KPL  = IPR(NP+5)
      DELP = PNEW/PR(NP+2)
      IF (DELP .LT. PL(KPL)) GO TO 20
      KPL = KPL + 1
      IF (DELP.LE.PL(KPL) .OR. PL(KPL).EQ.0) GO TO 30
C
C     RECALCULATE ALPHA, PNEW  BASED ON THE LIMIT
C
   20 PNEW = PR(NP+2)*PL(KPL)
      ALPH =-PNEW*GAMA/(PNEW*(1.0-GAMA)-PR(NP+3))
C
   30 PR(NP+4) = ALPH
      IF (NP .EQ. IY(ICP)) Y(ICP+I) = ALPH
      GO TO 80
C
C     ZERO STRESS INPUT, CHANGE ALPH TO 0.0001
C
   40 IF (IPRNT.EQ.0 .OR. NMES.GE.100) GO TO 60
      NMES = NMES + 1
      CALL PAGE2 (-2)
      WRITE  (OUTTAP,50) UWM,IPR(NP)
   50 FORMAT (A25,' 2303, FULLY-STRESSED DESIGN DETECTED ZERO STRESS ',
     1       'FOR PROPERTY',I9, /5X,'CHECK PROPERTY CARD OR UNLOADED ',
     2       'ELEMENT(S)')
   60 ALPH = 1.0E-4
      GO TO 10
C
C     NO CHANGE IN ALPH (-1.0 DETECTED)
C
   70 ALPH = -1.0E0
      IF (NP .EQ. IY(ICP)) GO TO 30
C
   80 IF (NP .NE. IY(ICP)) GO TO 100
      I = I + 1
      IF (I .LE. 3) GO TO 4
      ICP = ICP + 4
C
  100 CONTINUE
C
      RETURN
      END

      SUBROUTINE FBSI3 (BLOCK, Y, MEM, DMEM, IBUFF)
C
C     FBSI3 EXECUTES THE FORWARD/BACKWARD PASS FOR FBSI IN CSP
C
      INTEGER          BLOCK(8), DBL, BUF(2), SUBNAM, BEGN, END
      INTEGER          IBUFF(2), DBU, DBB, DBC
      INTEGER          RD, RDREW, WRT, WRTREW, REW, MEM(2)
      REAL             L, DMEM(2)
      COMPLEX          Y(1), YJK, SUM, ZERO, LJJ
      CHARACTER        UFM*23, UWM*25, UIM*29, SFM*25
      COMMON /NAMES /  RD, RDREW, WRT, WRTREW, REW
      COMMON /XMSSG /  UFM, UWM, UIM, SFM
      COMMON /ZZZZZZ/  L(2)
      COMMON /SYSTEM/  SYSBUF, NOUT
      COMMON /FBSX  /  DBL(7), DBU(7), DBB(7), DBC(7)
      COMMON /FBSM  /  NVEC  , NVECSZ, NWDS  , LASIND, IPOS(7)
      DATA             ZERO / (0.0, 0.0 )    /
      DATA    SUBNAM, BEGN, END / 4HFBS4, 4HBEGN, 4HEND /
C
      NCOL   = DBL(2)
      BUF(1) = SUBNAM
      BUF(2) = BEGN
      IOPEN  = 0
      CALL CONMSG (BUF,2,0)
      LAST   = NVEC * NVECSZ
      NIDLT  = 1
      LCOL   = IPOS( 1 )
      DO 1000 J = 1,LCOL
C      PRINT *,' FORWARD, PROCESSING COLUMN J=',J
      J1 = J - 1
C
C CHECK IF THIS ROW VALUE IS ZERO FOR ALL RIGHT HAND VECTORS
C
      DO 10 K = J,LAST,NVECSZ
      IF (Y(K) .NE. ZERO) GO TO 100
10    CONTINUE
C
C ALL VALUES FOR THIS ROW ARE ZERO, SKIP TO NEXT ROW OF RIGHT HAND VECTORS
C
      IF ( NIDLT .GE. LASIND ) GO TO 1005
      KCOL   = MEM( NIDLT )
      IF ( KCOL .NE. J ) GO TO 7001
40    NROWS  = MEM( NIDLT+1 )
      NIDLT  = NIDLT + NROWS*NWDS + 4
      IF ( NIDLT .GE. LASIND ) GO TO 1005
      KCOL = MEM( NIDLT )
      IF ( KCOL .NE. J ) GO TO 1000
      GO TO 40
C
C     GET 1ST STRING FOR COLUMN AND SAVE DIAGONAL ELEMENT
C
100   CONTINUE
      KCOL   = MEM( NIDLT )
      IF ( KCOL .NE. J ) GO TO 7001
      NROWS  = MEM( NIDLT + 1 )    
      IROW   = MEM( NIDLT + NROWS*NWDS + 2 )
      INDXI  = NIDLT + 2
      INDXL  = INDXI + NROWS*2 - 1
      LJJ   = 1.0 / CMPLX( DMEM( INDXI ), DMEM( INDXI+1 ) )
      IF (NROWS .EQ. 1) GO TO 600
      INDXI = INDXI + 2
      IROW  = IROW + 1
C
C     PROCESS CURRENT STRING IN TRIANGULAR FACTOR AGAINST EACH
C     LOAD VECTOR IN CORE -- Y(I,K) = Y(I,K) + L(I,J)*Y(J,K)
C
300   DO 500 K   = 1, LAST, NVECSZ
      YJK        = Y( J1+K )
      IF ( YJK .EQ. ZERO ) GO TO 500
      IYROW      = IROW + K - 1
      DO 400 IJ  = INDXI, INDXL, 2
      Y( IYROW ) = Y( IYROW ) + CMPLX( DMEM(IJ), DMEM(IJ+1) ) * YJK
400   IYROW      = IYROW + 1
500   CONTINUE
C
C     GET NEXT STRING IN TRIANGULAR FACTOR
C
600   CONTINUE
      NIDLT  = NIDLT + 4 + NROWS*NWDS
      IF ( NIDLT .GE. LASIND ) GO TO 800
      KCOL   = MEM( NIDLT )
      IF ( KCOL .NE. J ) GO TO 800
      NROWS  = MEM( NIDLT + 1 )
      IROW   = MEM( NIDLT + NROWS*NWDS + 2 )
      INDXI  = NIDLT + 2
      INDXL  = INDXI + NROWS*2 - 1
      GO TO 300
C
C     END-OF-COLUMN ON TRIANGULAR FACTOR -- DIVIDE BY DIAGONAL
C
800   DO 900 K = J,LAST,NVECSZ
      Y(K) = Y(K)*LJJ
900   CONTINUE
C
1000  CONTINUE
1005  CONTINUE
      IF ( LCOL .EQ. NCOL ) GO TO 2005
      IFCOL = LCOL + 1
      CALL GOPEN  ( DBL, IBUFF, RDREW ) 
C
C POSITION FILE TO APPROPRIATE COLUMN TO BE READ 
C
      CALL DSSPOS ( DBL, IPOS(2), IPOS(3), IPOS(4) )
      DO 2000 J = IFCOL, NCOL
      J1 = J - 1
C
C CHECK IF THIS ROW VALUE IS ZERO FOR ALL RIGHT HAND VECTORS
C
      DO 1010 K = J,LAST,NVECSZ
      IF (Y(K) .NE. ZERO) GO TO 1100
1010  CONTINUE
C
C ALL VALUES FOR THIS ROW ARE ZERO, SKIP TO NEXT ROW OF RIGHT HAND VECTORS
C
      CALL SKPREC ( DBL, 1 )
      GO TO 2000
C
C     GET 1ST STRING FOR COLUMN AND SAVE DIAGONAL ELEMENT
C
1100  CONTINUE
      BLOCK(8) = -1
      CALL GETSTR ( *7002, BLOCK )
      IF (BLOCK(4) .NE. J) GO TO 7002
      IROW  = BLOCK(4)  
      INDXI = BLOCK(5)
      NROWS = BLOCK(6)
      INDXL = INDXI + NROWS*2 - 1  
1200  CONTINUE
      LJJ   = 1.0 / CMPLX( L( INDXI ), L( INDXI+1 ) )
      IF (NROWS .EQ. 1) GO TO 1600
      INDXI = INDXI + 2
      IROW  = IROW + 1
C
C     PROCESS CURRENT STRING IN TRIANGULAR FACTOR AGAINST EACH
C     LOAD VECTOR IN CORE -- Y(I,K) = Y(I,K) + L(I,J)*Y(J,K)
C
1300  DO 1500 K   = 1, LAST, NVECSZ
      YJK        = Y( J1+K )
      IF ( YJK .EQ. ZERO ) GO TO 1500
      IYROW      = IROW + K - 1
      DO 1400 IJ  = INDXI, INDXL, 2
      Y( IYROW ) = Y( IYROW ) + CMPLX( L(IJ), L(IJ+1) ) * YJK
1400  IYROW      = IYROW + 1
1500  CONTINUE
C
C     GET NEXT STRING IN TRIANGULAR FACTOR
C
1600  CONTINUE
      CALL ENDGET ( BLOCK )
      CALL GETSTR ( *1800, BLOCK )
      IROW  = BLOCK(4)  
      INDXI = BLOCK(5)
      NROWS = BLOCK(6)
      INDXL = INDXI + NROWS*2 - 1  
      GO TO 1300
C
C     END-OF-COLUMN ON TRIANGULAR FACTOR -- DIVIDE BY DIAGONAL
C
1800  DO 1900 K = J,LAST,NVECSZ
      Y(K) = Y(K)*LJJ
1900  CONTINUE
2000  CONTINUE
2005  CONTINUE
      IF ( NCOL  .EQ. 1 ) GO TO 7000    
      J = NCOL - 1   
      IF ( LCOL .EQ. NCOL ) GO TO 3000
C
C     INITIALIZE FOR BACKWARD PASS BY SKIPPING THE NTH COLUMN
C
      CALL BCKREC (BLOCK)
C
C     GET A STRING IN CURRENT COLUMN. IF THIS STRING INCLUDES DIAGONAL,
C     ADJUST STRING TO SKIP IT.
C
2200  J1 = J - 1
      BLOCK(8) = -1
2300  CALL GETSTB (*2900,BLOCK)
      IROW  = BLOCK( 4 )
      NROWS = BLOCK( 6 )
      IF (IROW-NROWS .EQ. J1) NROWS = NROWS - 1
      IF (NROWS .EQ. 0) GO TO 2800
      INDXI = BLOCK( 5 )
C
C     PROCESS CURRENT STRING IN TRIANGULAR FACTOR AGAINST EACH
C     LOAD VECTOR IN CORE -- Y(J,K) = Y(J,K) + L(J,I)*Y(I,K)
C
      DO 2700 K = 1,LAST,NVECSZ
      JI  = INDXI + 2
      IK  = IROW  + K
      SUM = (0.0, 0.0)
      DO 2600 II = 1,NROWS
      JI = JI - 2
      IK = IK - 1
      SUM = SUM + CMPLX( L(JI),L(JI+1) ) * Y(IK)
2600  CONTINUE
      Y(J1+K) = Y(J1+K) + SUM
2700  CONTINUE
C
C     TERMINATE CURRENT STRING AND GET NEXT STRING
C
2800  CONTINUE
      CALL ENDGTB (BLOCK)
      GO TO 2300
C
C     END-OF-COLUMN -- TEST FOR COMPLETION
C
2900  IF (J .EQ. 1) GO TO 7000
      J = J - 1
      IF ( J .EQ. LCOL ) GO TO 3010
      GO TO 2200
C
3000  CONTINUE
C
C     INITIALIZE FOR BACKWARD PASS BY SKIPPING THE NTH COLUMN
C
3005  CONTINUE
      NIDLT = NIDLT - 1          
      NROWS = MEM( NIDLT )
      NIDLT = NIDLT - NROWS*NWDS - 3
      KCOL  = MEM( NIDLT )
      IF ( KCOL .EQ. NCOL ) GO TO 3005
      NIDLT = NIDLT + NROWS*NWDS + 4
3010  CONTINUE
C
C     GET A STRING IN CURRENT COLUMN. IF THIS STRING INCLUDES DIAGONAL,
C     ADJUST STRING TO SKIP IT.
C
3200  J1 = J - 1
C      print *,' processing column in backward step, j=',j
3250  NIDLT = NIDLT - 1
      IF ( NIDLT .LE. 1 ) GO TO 3900
      NROWS = MEM( NIDLT )
      IROW  = MEM( NIDLT-1 )
      NIDLT = NIDLT - NROWS*NWDS - 3
      KCOL  = MEM( NIDLT )
3260  CONTINUE     
      IF ( KCOL .NE. J ) GO TO 3900
      INDXI = NIDLT + NROWS*2
      IROW  = IROW + NROWS - 1
      IF ( (IROW-NROWS) .EQ. J1 ) NROWS = NROWS - 1   
C
C     PROCESS CURRENT STRING IN TRIANGULAR FACTOR AGAINST EACH
C     LOAD VECTOR IN CORE -- Y(J,K) = Y(J,K) + L(J,I)*Y(I,K)
C
      DO 3700 K = 1,LAST,NVECSZ
      JI  = INDXI + 2
      IK  = IROW  + K
      SUM = 0.0
      DO 3600 II = 1,NROWS
      JI = JI - 2
      IK = IK - 1
      SUM = SUM + CMPLX( DMEM(JI),DMEM(JI+1) ) * Y(IK)
3600  CONTINUE
      Y(J1+K) = Y(J1+K) + SUM
3700  CONTINUE
C
C     TERMINATE CURRENT STRING AND GET NEXT STRING
C
      GO TO 3250
C
C     END-OF-COLUMN -- TEST FOR COMPLETION
C
3900  IF (J .EQ. 1) GO TO 7000
      J  = J - 1
      J1 = J - 1
      GO TO 3260
C
7000  BUF(2) = END
      CALL CONMSG (BUF,2,0)
      CALL CLOSE ( DBL, REW )
      RETURN
C
C     FATAL ERROR MESSAGE
C
7001  CONTINUE
7002  CONTINUE
      WRITE  (NOUT,9001) SFM,SUBNAM
9001  FORMAT (A25,' 2149, SUBROUTINE ',A4,/5X,'FIRST ELEMENT OF A COLU',
     1      'MN OF LOWER TRIANGULAR MATRIX IS NOT THE DIAGONAL ELEMENT')
      CALL MESAGE (-61,0,0)
      RETURN
      END

      SUBROUTINE MMA302 ( ZI, ZD )
C
C     MMA302 PERFORMS THE MATRIX OPERATION USING METHOD 30 AND 
C       REAL DOUBLE PRECISION
C
C       (+/-)A(T & NT) * B (+/-)C = D
C     
C     MMA302 USES METHOD 30 WHICH IS AS FOLLOWS:
C       1.  THIS IS FOR "A" NON-TRANSPOSED AND TRANSPOSED
C       2.  CALL 'MMARM1' TO PACK AS MANY COLUMNS OF "A" INTO MEMORY 
C           AS POSSIBLE LEAVING SPACE FOR ONE COLUMN OF "B" AND "D".
C       3.  INITIALIZE EACH COLUMN OF "D" WITH THE DATA FROM "C".
C       4.  USE UNPACK TO READ MATRICES "B" AND "C".
C
      INTEGER           ZI(2)      ,T
      INTEGER           TYPEI      ,TYPEP    ,TYPEU ,SIGNAB, SIGNC
      INTEGER           RD         ,RDREW    ,WRT   ,WRTREW, CLSREW,CLS
      INTEGER           OFILE      ,FILEA    ,FILEB ,FILEC , FILED
      DOUBLE PRECISION  ZD(2)      ,DTEMP
      INCLUDE           'MMACOM.COM'
      COMMON / NAMES  / RD         ,RDREW    ,WRT   ,WRTREW, CLSREW,CLS
      COMMON / TYPE   / IPRC(2)    ,NWORDS(4),IRC(4)
      COMMON / MPYADX / FILEA(7)   ,FILEB(7) ,FILEC(7)    
     1,                 FILED(7)   ,NZ       ,T     ,SIGNAB,SIGNC ,PREC1 
     2,                 SCRTCH     ,TIME
      COMMON / SYSTEM / KSYSTM(152)
      COMMON / UNPAKX / TYPEU      ,IUROW1   ,IUROWN, INCRU
      COMMON / PACKX  / TYPEI      ,TYPEP    ,IPROW1, IPROWN , INCRP
      EQUIVALENCE       (KSYSTM( 1),SYSBUF)  , (KSYSTM( 2),IWR   ) 
      EQUIVALENCE       (FILEA(2)  ,NAC   )  , (FILEA(3)  ,NAR   )
     1,                 (FILEA(4)  ,NAFORM)  , (FILEA(5)  ,NATYPE)
     2,                 (FILEA(6)  ,NANZWD)  , (FILEA(7)  ,NADENS)
      EQUIVALENCE       (FILEB(2)  ,NBC   )  , (FILEB(3)  ,NBR   )
     1,                 (FILEB(4)  ,NBFORM)  , (FILEB(5)  ,NBTYPE)
     2,                 (FILEB(6)  ,NBNZWD)  , (FILEB(7)  ,NBDENS)
      EQUIVALENCE       (FILEC(2)  ,NCC   )  , (FILEC(3)  ,NCR   )
     1,                 (FILEC(4)  ,NCFORM)  , (FILEC(5)  ,NCTYPE)
     2,                 (FILEC(6)  ,NCNZWD)  , (FILEC(7)  ,NCDENS)
      EQUIVALENCE       (FILED(2)  ,NDC   )  , (FILED(3)  ,NDR   )
     1,                 (FILED(4)  ,NDFORM)  , (FILED(5)  ,NDTYPE)
     2,                 (FILED(6)  ,NDNZWD)  , (FILED(7)  ,NDDENS)
C
C
C   OPEN CORE ALLOCATION AS FOLLOWS:
C     Z( 1        ) = ARRAY FOR ONE COLUMN OF "B" MATRIX
C     Z( IDX      ) = ARRAY FOR ONE COLUMN OF "D" MATRIX
C     Z( IAX      ) = ARRAY FOR MULTIPLE COLUMNS OF "A" MATRIX
C        THROUGH
C     Z( LASMEM   )
C     Z( IBUF4    ) = BUFFER FOR "D" FILE
C     Z( IBUF3    ) = BUFFER FOR "C" FILE
C     Z( IBUF2    ) = BUFFER FOR "B" FILE 
C     Z( IBUF1    ) = BUFFER FOR "A" FILE
C     Z( NZ       ) = END OF OPEN CORE THAT IS AVAILABLE
C
C PROCESS ALL OF THE COLUMNS OF "B";  ADD "C" DATA ON FIRST PASS
      DO 60000 II = 1, NBC
C      PRINT *,' PROCESSING B MATRIX COLUMN II=',II
      IUROW1 = -1
      TYPEU  = NDTYPE 
      CALL UNPACK ( *930, FILEB, ZD( 1 ) )
      IROWB1 = IUROW1
      IROWBN = IUROWN
      GO TO 940
930   IROWB1 = 0
      IROWBN = 0
      IF ( IFILE .NE. 0 ) GO TO 940
      IPROWN = 1
      CALL PACK ( 0.0D0, OFILE, FILED )
      IPROWN = NDR
      GO TO 60000
940   CONTINUE
      IF ( IFILE .EQ. 0 ) GO TO 950            
      IUROW1 = 1
      IUROWN = NDR
      TYPEU  = NDTYPE 
      IF ( IPASS .EQ. 1 ) TYPEU = NDTYPE * SIGNC
      CALL UNPACK (*950, IFILE, ZD( IDX2+1 ) )
      GO TO 980
950   CONTINUE
      DO 970 J = 1, NDR
      ZD( IDX2+J ) = 0
970   CONTINUE
980   CONTINUE
C
C CHECK IF COLUMN OF "B" IS NULL
C
      INDXA  = IAX
      IF ( IROWB1 .EQ. 0 ) GO TO 50000
      IF ( T .NE. 0 ) GO TO 5000
C      
C "A" NON-TRANSPOSE CASE    ( A * B  +  C )      
C
C DOUBLE PRECISION
1000  CONTINUE
      DO 1500 I = 1, NCOLPP
      INDXAL = ZI( INDXA+1 ) + IAX - 1
      ICOLA  = IBROW+I
      IF ( ICOLA .LT. IROWB1 .OR. ICOLA .GT. IROWBN ) GO TO 1450
      IBROWI = ICOLA - IROWB1 + 1
      DTEMP  = ZD( IBROWI )
      IF ( DTEMP .EQ. 0.0D0 ) GO TO 1450
      IF ( ICOLA .NE. IABS( ZI( INDXA ) ) ) GO TO 70001
      INDXA  = INDXA+2
1100  CONTINUE
      IF ( INDXA .GE. INDXAL ) GO TO 1450
      IROWA1 = ZI( INDXA )
      NTMS   = ZI( INDXA+1 )
      IROWAN = IROWA1 + NTMS - 1
      INDXAV = ( ( INDXA+3 ) / 2 ) - IROWA1
      DO 1400 K = IROWA1, IROWAN
C
C         D = C + A*B
C      
C      PRINT *,' K,D,A,B=',K,ZD(IDX2+K),ZD(INDXAV+K),ZD(IBROWI)
      ZD( IDX2+K ) = ZD( IDX2+K ) +  ZD( INDXAV+K ) * DTEMP
1400  CONTINUE
      INDXA  = INDXA + 2 + NTMS*2
      GO TO 1100
1450  INDXA  = INDXAL
1500  CONTINUE
      GO TO 50000
C
C  TRANSPOSE CASE ( A(T) * B + C )
C
5000  CONTINUE      
C DOUBLE PRECISION
10000 CONTINUE
      INDXB  = 1 - IROWB1
      IDXX   = IDX2 + IBROW 
      DO 15000 I = 1, NCOLPP
      ICOLA  = IBROW + I 
      IF ( ICOLA .NE. IABS( ZI( INDXA ) ) ) GO TO 70001
      INDXAL = ZI( INDXA+1 ) + IAX - 1
      INDXA  = INDXA+2
11000 CONTINUE
      IF ( INDXA .GE. INDXAL ) GO TO 14500
      IROWA1 = ZI( INDXA )
      NTMS   = ZI( INDXA+1 )
      IROWAN = IROWA1 + NTMS - 1
      IROW1  = MAX0( IROWA1, IROWB1 )
      IROWN  = MIN0( IROWAN, IROWBN )
      IF ( IROWN .LT. IROW1 ) GO TO 14100
      INDXAV = ( ( INDXA + 3 ) / 2 ) - IROWA1
C
C         D = C + A*B
C      
      DTEMP = 0.0
      DO 14000 K = IROW1, IROWN
      DTEMP = DTEMP +  ZD( INDXAV+K ) * ZD( INDXB+K ) 
14000 CONTINUE
      ZD( IDXX+I ) = ZD( IDXX+I ) +  DTEMP 
14100 CONTINUE
      INDXA  = INDXA + 2 + NTMS*2
      GO TO 11000
14500 INDXA  = INDXAL
15000 CONTINUE
      GO TO 50000
C END OF PROCESSING THIS COLUMN FOR THIS PASS
50000 CONTINUE
C  NOW SAVE COLUMN 
      CALL PACK ( ZD( IDX2+1 ), OFILE, FILED )
60000 CONTINUE
      GO TO 70000
70001 CONTINUE
      WRITE ( IWR, 90001 ) ICOLA, ZI( INDXA ), IAX, INDXA
90001 FORMAT(' UNEXPECTED COLUMN FOUND IN PROCESSING MATRIX A'
     &,/,' COLUMN EXPECTED:',I6
     &,/,' COLUMN FOUND   :',I6
     &,/,' IAX =',I7,'  INDXA=',I7 )
      CALL MESAGE ( -61, 0, 0 )
70000 RETURN
      END

      SUBROUTINE MATPRT (*,*,A,OPTION,COLUMN)
C
C     MATPRT AND PRTMAT ARE CALLED ONLY BY INTPRT
C
      REAL            A(1)
      INTEGER         OPTION,COLUMN(1),FILE,TYPE,BUFSIZ,COUNT,
     1                UTYPE,UI,UJ,UINC,RSP,RDP,CSP,CDP,REW
      COMMON /SYSTEM/ BUFSIZ,MO,SKP1(6),MAXLIN,SKP2(2),COUNT
      COMMON /UNPAKX/ UTYPE,UI,UJ,UINC
      COMMON /XXMPRT/ MCB(7)
C
C     MCB = MATRIX CONTROL BLOCK.
C     A   = ARRAY OF BUFSIZ + I (REAL) OR 2I (COMPLEX) LOCATIONS.
C     OPTION IS AS DESCRIBED IN -VECPRT-.
C     RETURN 1 ... PRINT MATRIX TITLE + COLUMN IDENTIFIER.
C     RETURN 2 ... PRINT COLUMN IDENTIFIER ONLY.
C                  (PRTMAT = RETURN ENTRY POINT)
C     COLUMN = CURRENT COLUMN NUMBER
C
      EQUIVALENCE (FILE,MCB(1)), (J,MCB(2)), (I,MCB(3)), (TYPE,MCB(5))
      DATA        RSP,RDP,CSP,CDP,REW,INPREW / 1,2,3,4,1,0 /
C
      IF (I.LE.0 .OR. J.LE.0)  GO TO 150
      UTYPE = TYPE
      IF (TYPE .EQ. RDP) UTYPE = RSP
      IF (TYPE .EQ. CDP) UTYPE = CSP
      UI   = 1
      UJ   = I
      UINC = 1
      CALL GOPEN (FILE,A,INPREW)
      COUNT = MAXLIN
C
      COLUMN(1) = 0
  110 COLUMN(1) = COLUMN(1) + 1
      CALL UNPACK (*140,FILE,A(BUFSIZ+1))
      CALL VECPRT (*120,*130,UTYPE,I,A(BUFSIZ+1),OPTION)
      GO TO 140
  120 RETURN 1
  130 RETURN 2
C
C
      ENTRY PRTMAT (*,*,COLUMN)
C     =========================
C
      CALL PRTVEC (*120,*130)
  140 IF (COLUMN(1) .NE. J) GO TO 110
C
      CALL CLOSE (FILE,REW)
  150 RETURN
      END

      SUBROUTINE T3SETS (IERR,SIL,JGPDT,ELTH,GPTH,DGPTH,EGPDT,GPNORM,
     1           EPNORM,IORDER,TEB,TUB,CENT,AVGTHK,LX,LY,EDGLEN,ELID)
C
C     SINGLE PRECISION ROUTINE TO DO THE SET-UP FOR TRIA3 ELEMENTS
C
C
C     INPUT :
C           SIL    - ARRAY OF SIL NUMBERS
C           JGPDT  - BGPDT DATA (INTEGER ARRAY)
C           ELTH   - ELEMENT THICKNESS FROM EPT
C           GPTH   - GRID POINT THICKNESS DATA
C           ELID   - ELEMENT ID
C     OUTPUT:
C           IERR   - ERROR FLAG
C           SIL    - ARRAY OF SIL NUMBERS       (REARRANGED)
C           JGPDT  - BGPDT DATA (INTEGER ARRAY) (REARRANGED)
C           GPTH   - GRID POINT THICKNESS DATA  (REARRANGED)
C           DGPTH  - GRID POINT THICKNESS DATA  (HIGH PREC)
C           EGPDT  - BGPDT DATA IN ELEMENT COORD. SYSTEM
C           GPNORM - GRID POINT NORMALS
C           EPNORM - GRID POINT NORMALS IN ELEMENT COORD .SYSTEM
C           IORDER - ARRAY OF ORDER INDICATORS FOR REARRANGED DATA
C           TEB    - TRANSFORMATION FROM ELEMENT TO BASIC COORD. SYSTEM
C           TUB    - TRANSFORMATION FROM USER TO BASIC COORD. SYSTEM
C           CENT   - LOCATION OF THE CENTER OF THE ELEMENT
C           AVGTHK - AVERAGE THICKNESS OF THE ELEMENT
C           LX     - DIMENSION OF ELEMENT ALONG X-AXIS
C           LY     - DIMENSION OF ELEMENT ALONG Y-AXIS
C           EDGLEN - EDGE LENGTHS
C
C
      INTEGER          IGPDT(4,3),JGPDT(4,3),IGRID(4,3),SIL(3),
     1                 IORDER(3),KSIL(3),ELID
      REAL             BGPDT(4,3),GPTH(3),TMPTHK(3)
      REAL             CENT(3),EGPDT(4,3),GGU(9),TEB(9),TUB(9),CC,
     1                 DGPTH(3),GPNORM(4,3),EPNORM(4,3),AVGTHK,LX,LY,
     2                 AREA2,LENGTH,SMALL,X(3),Y(3),Z(3),EDG12(3),
     3                 EDG23(3),EDG13(3),EDGLEN(3),AXIS(3,3)
      EQUIVALENCE      (IGPDT(1,1),BGPDT(1,1))
C
C
C     INITIALIZE
C
      IERR  = 0
      NNODE = 3
C
      DO 100 I = 1,NNODE
      DO 100 J = 1,4
      IGPDT(J,I) = JGPDT(J,I)
  100 CONTINUE
C
C     SET UP THE USER COORDINATE SYSTEM
C
      DO 120 I = 1,3
      II = (I-1)*3
      DO 120 J = 1,3
      GGU(II+J) = BGPDT(J+1,I)
  120 CONTINUE
      CALL BETRNS (TUB,GGU,0,ELID)
C
C     SET UP THE ELEMENT COORDINATE SYSTEM
C
C     1. SET UP THE EDGE VECTORS AND THEIR LENGTHS
C
      DO 140 I = 1,NNODE
      X(I) = BGPDT(2,I)
      Y(I) = BGPDT(3,I)
      Z(I) = BGPDT(4,I)
  140 CONTINUE
C
      CENT(1) = (X(1)+X(2)+X(3))/3.0
      CENT(2) = (Y(1)+Y(2)+Y(3))/3.0
      CENT(3) = (Z(1)+Z(2)+Z(3))/3.0
C
      EDG12(1) = X(2) - X(1)
      EDG12(2) = Y(2) - Y(1)
      EDG12(3) = Z(2) - Z(1)
      EDGLEN(1)= EDG12(1)**2 + EDG12(2)**2 + EDG12(3)**2
      IF (EDGLEN(1) .EQ. 0.0) GO TO 380
      EDGLEN(1) = SQRT(EDGLEN(1))
C
      EDG23(1) = X(3) - X(2)
      EDG23(2) = Y(3) - Y(2)
      EDG23(3) = Z(3) - Z(2)
      EDGLEN(2)= EDG23(1)**2 + EDG23(2)**2 + EDG23(3)**2
      IF (EDGLEN(2) .EQ. 0.0) GO TO 380
      EDGLEN(2) = SQRT(EDGLEN(2))
C
      EDG13(1) = X(3) - X(1)
      EDG13(2) = Y(3) - Y(1)
      EDG13(3) = Z(3) - Z(1)
      EDGLEN(3)= EDG13(1)**2 + EDG13(2)**2 + EDG13(3)**2
      IF (EDGLEN(3) .EQ. 0.0) GO TO 380
      EDGLEN(3) = SQRT(EDGLEN(3))
C
C     2. FIND THE SMALLEST EDGE LENGTH
C
      SMALL = EDGLEN(1)
      NODEI = 3
      NODEJ = 1
      NODEK = 2
C
      IF (EDGLEN(2) .GE. SMALL) GO TO 160
      SMALL = EDGLEN(2)
      NODEI = 1
      NODEJ = 2
      NODEK = 3
  160 IF (EDGLEN(3) .GE. SMALL) GO TO 180
      SMALL = EDGLEN(3)
      NODEI = 2
      NODEJ = 1
      NODEK = 3
C
C     3. ESTABLISH AXIS 3 AND NORMALIZE IT
C
  180 CALL SAXB (EDG12,EDG13,AXIS(1,3))
C
      LENGTH = SQRT(AXIS(1,3)**2 + AXIS(2,3)**2 + AXIS(3,3)**2)
      AXIS(1,3) = AXIS(1,3)/LENGTH
      AXIS(2,3) = AXIS(2,3)/LENGTH
      AXIS(3,3) = AXIS(3,3)/LENGTH
      AREA2     = LENGTH
C
C     4. ESTABLISH AXES 1 AND 2 AND NORMALIZE THEM
C
      AXIS(1,1) = (X(NODEJ)+X(NODEK))/2.0 - X(NODEI)
      AXIS(2,1) = (Y(NODEJ)+Y(NODEK))/2.0 - Y(NODEI)
      AXIS(3,1) = (Z(NODEJ)+Z(NODEK))/2.0 - Z(NODEI)
C
      LENGTH = SQRT(AXIS(1,1)**2 + AXIS(2,1)**2 + AXIS(3,1)**2)
      AXIS(1,1) = AXIS(1,1)/LENGTH
      AXIS(2,1) = AXIS(2,1)/LENGTH
      AXIS(3,1) = AXIS(3,1)/LENGTH
C
      CALL SAXB (AXIS(1,3),AXIS(1,1),AXIS(1,2))
C
      DO 200 I = 1,3
      TEB(I  ) = AXIS(I,1)
      TEB(I+3) = AXIS(I,2)
      TEB(I+6) = AXIS(I,3)
  200 CONTINUE
C
      LX = LENGTH
      LY = AREA2/LX
C
C
C     THE ELEMENT COORDINATE SYSTEM IS NOW READY
C
C     THE ARRAY IORDER STORES THE ELEMENT NODE ID IN INCREASING SIL
C     ORDER.
C
C     IORDER(1) = NODE WITH LOWEST  SIL NUMBER
C     IORDER(3) = NODE WITH HIGHEST SIL NUMBER
C
C     ELEMENT NODE NUMBER IS THE INTEGER FROM THE NODE LIST  G1,G2,....
C     THAT IS, THE 'I' PART OF THE 'GI' AS THEY ARE LISTED ON THE
C     CONNECTION BULK DATA CARD DESCRIPTION.
C
      DO 220 I = 1,NNODE
      KSIL(I) = SIL(I)
  220 CONTINUE
C
      DO 260 I = 1,NNODE
      ITEMP = 1
      ISIL = KSIL(1)
      DO 240 J = 2,NNODE
      IF (ISIL .LE. KSIL(J)) GO TO 240
      ITEMP = J
      ISIL = KSIL(J)
  240 CONTINUE
      IORDER(I) = ITEMP
      KSIL(ITEMP) = 99999999
  260 CONTINUE
C
C     USE THE POINTERS IN IORDER TO COMPLETELY REORDER THE GEOMETRY DATA
C     INTO INCREASING SIL ORDER.
C
      DO 280 I = 1,NNODE
      KSIL(I) = SIL(I)
      TMPTHK(I) = GPTH(I)
      DO 280 J = 1,4
      IGRID(J,I) = IGPDT(J,I)
  280 CONTINUE
      DO 300 I = 1,NNODE
      IPOINT = IORDER(I)
      SIL(I) = KSIL(IPOINT)
      GPTH(I)= TMPTHK(IPOINT)
      DO 300 J = 1,4
      IGPDT(J,I) = IGRID(J,IPOINT)
      JGPDT(J,I) = IGPDT(J,I)
  300 CONTINUE
C
C     THE COORDINATES OF THE ELEMENT GRID POINTS MUST BE TRANSFORMED
C     FROM THE BASIC COORD. SYSTEM TO THE ELEMENT COORD. SYSTEM
C
      DO 320 I = 1,3
      IP = (I-1)*3
      DO 320 J = 1,NNODE
      EGPDT(I+1,J) = 0.0
      DO 320 K = 1,3
      CC = BGPDT((K+1),J) - CENT(K)
      EGPDT(I+1,J) = EGPDT(I+1,J) + TEB(IP+K)*CC
  320 CONTINUE
C
C     SET NODAL NORMALS
C
      DO 340 I = 1,NNODE
      EPNORM(1,I) = 0.0
      EPNORM(2,I) = 0.0
      EPNORM(3,I) = 0.0
      EPNORM(4,I) = 1.0
      GPNORM(1,I) = 0.0
      GPNORM(2,I) = TEB(7)
      GPNORM(3,I) = TEB(8)
      GPNORM(4,I) = TEB(9)
  340 CONTINUE
C
C     SET NODAL THICKNESSES
C
      AVGTHK = 0.0
      DO 370 I = 1,NNODE
      IF (GPTH(I)) 380,350,360
  350 IF (ELTH .LE. 0.0) GO TO 380
      GPTH(I) = ELTH
  360 DGPTH(I) = GPTH(I)
      AVGTHK = AVGTHK + DGPTH(I)/NNODE
  370 CONTINUE
      GO TO 400
C
  380 IERR = 1
  400 RETURN
      END

        SUBROUTINE DSGNOP
      INCLUDE 'DSIOF.COM'
      INCLUDE 'GINOX.COM'
      INCLUDE 'XNSTRN.COM'
        CHARACTER*4     CBUFF( 3 )
        EQUIVALENCE     (CBUFF,IBASE)
        IDSN    = IFILEX
        IF ( IOCODE .GE. 2 ) GO TO 10
        IF ( IOCODE .NE. 1 ) GO TO 30
        CALL DSRLSE
        GO TO 30
   10   INEXT   = IAND( MDSFCB( 3, IDSN ), MASKH2 )
        IF ( INEXT .EQ. 0 ) GO TO 30
        ITEST =  FCB( 6, IDSN )
        IF ( NBLOCK .LE. ITEST ) GO TO 30
        IDSN    = INEXT
        GO TO 10
   30   IOP = MOD ( IOCODE,2 )
        MDSFCB( 2,IFILEX ) = IDSN
        MDSFCB( 1,IDSN )   = IOR( MDSFCB( 1,IDSN ), MASKH2 )
   40   CONTINUE
        CALL DSOPEN( MDSNAM( IDSN ), IDSN, IOCODE)
        RETURN
        END

      SUBROUTINE MPY3NU (IZ)
C
C     CALCULATES NEXT TIME USED FOR INDIVIDUAL COLUMNS OF B OR FOR ROWS
C     CORRESPONDING TO NON-ZERO TERMS IN COLUMN OF A.
C
      INTEGER         ZPNTRS
      DIMENSION       IZ(1),NAME(2)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /SYSTEM/ SYSBUF,NOUT
      COMMON /MPY3CP/ ITRL,ICORE,N,NCB,DUM1(4),ZPNTRS(22),LAEND,
     1                DUM2(8),J,ID,NTBU
      EQUIVALENCE     (IPOINT,ZPNTRS(3)),(IACOLS,ZPNTRS(5))
      DATA    NAME  / 4HMPY3,4HNU   /
C
C     CALCULATION BY SEARCH THROUGH ROW OF A IN QUESTION.
C
      LP = IPOINT + ID - 1
      L1 = IZ(LP)
      IF (L1 .EQ.   0) GO TO 60
      IF (ID .EQ. NCB) GO TO 20
      LL = ID + 1
      DO 10 L = LL,NCB
      LP = LP + 1
      IF (IZ(LP) .EQ. 0) GO TO 10
      L2 = IZ(LP) - 1
      GO TO 30
   10 CONTINUE
   20 L2  = LAEND
   30 LAC = IACOLS + L1 - 2
      DO 40 L = L1,L2
      LAC = LAC + 1
      IF (J .LT. IZ(LAC)) GO TO 50
   40 CONTINUE
      NTBU = 99999999
      GO TO 80
   50 NTBU = IZ(LAC)
      GO TO 80
C
C    ERROR MESSAGE.
C
   60 WRITE  (NOUT,70) UFM
   70 FORMAT (A23,' 6557, UNEXPECTED NULL COLUMN OF A(T) ENCOUNTERED.')
      CALL MESAGE (-37,0,NAME)
C
   80 RETURN
      END

      SUBROUTINE MAPSET(X1,Y1,X2,Y2,KI1,KJ1,KI2,KJ2,L)
C
C     POINT 1 IS LOWER LEFT CORNER OF FRAME
C     POINT 2 IS UPPER RIGHT CORNER OF FRAME
C     I,J ARE IN PLOTTER UNITS
C     X,Y ARE IN PHYSICAL UNITS
C     L IS OUTPUT FLAG, 1=I,J ARE INTEGER, 2=I,J ARE REAL
C
      EQUIVALENCE (I1,ZI1),(J1,ZJ1),(I2,ZI2),(J2,ZJ2)
      EQUIVALENCE (I,ZI),(J,ZJ)
C
      I1=KI1
      J1=KJ1
      I2=KI2
      J2=KJ2
      LL=L
C
      IF(L.EQ.2) GO TO 100
      A=FLOAT(I2-I1)/(X2-X1)
      B=FLOAT(I1)-A*X1
      C=FLOAT(J2-J1)/(Y2-Y1)
      D=FLOAT(J1)-C*Y1
      RETURN
  100 A=(ZI2-ZI1)/(X2-X1)
      B=ZI1-A*X1
      C=(ZJ2-ZJ1)/(Y2-Y1)
      D=ZJ1-C*Y1
      RETURN
C
C
C***********************************************************************
C
      ENTRY MAP(X,Y,KI,KJ)
      IF(LL.EQ.2) GO TO 200
      I=A*X+B+0.5
      J=C*Y+D+0.5
      GO TO 300
  200 ZI=A*X+B
      ZJ=C*Y+D
  300 KI=I
      KJ=J
      RETURN
C
      END

      SUBROUTINE MERGE (IRP,ICP,CORE)
C
C     MERGE WILL PUT UP TO 4 MATRICES, IA11,IA21,IA12,IA22, TOGETHER
C     INTO NAMEA -- THIS ROUTINE IS THE INVERSE OF PARTN
C
C     THE ARGUMENTS ARE EXACTLY THE SAME IN MEANING AND OPTION AS FOR
C     PARTITION
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        RSHIFT,ANDF
      DIMENSION       IRP(1),ICP(1),A11(4),B11(4),
     1                CORE(1),BLOCK(40),NAME(2)
      COMMON /PARMEG/ NAMEA,NCOLA,NROWA,IFORMA,ITYPA,IA(2),
     1                IA11(7,4),LCARE,RULE
      COMMON /SYSTEM/ SYSBUF,NOUT
      COMMON /TWO   / TWO1(32)
      COMMON /ZBLPKX/ IC11(4),II
      DATA    NAME  / 4HMERG,4HE    /
C
C     CHECK FILES
C
      LCORE = IABS(LCARE)
      K = NAMEA
      DO 15 I = 1,4
      IF (K .EQ. 0) GO TO 15
      DO 10 J = I,4
      IF (IA11(1,J) .EQ. K) GO TO 440
   10 CONTINUE
   15 K = IA11(1,I)
C
C     PICK UP PARAMETERS AND INITIALIZE
C
      IREW  = 0
      IF (LCARE .LT. 0) IREW = 2
      NCOLA1= NCOLA
      NCOLA = 0
      IA(1) = 0
      IA(2) = 0
      ISTOR = 0
      IOTP  = ITYPA
      NMAT  = 0
      DO 30 I = 1,4
      IF (IA11(1,I) .LE. 0) GO TO 30
CWKBD 2/94 SPR93025 IF (IA11(5,I) .NE. ITYPA) IOTP = 4
      NMAT = NMAT + 1
      DO 20 J = 2,5
      IF (IA11(J,I) .EQ. 0) GO TO 460
   20 CONTINUE
   30 CONTINUE
      NTYPA = IOTP
      IF (NTYPA .EQ. 3) NTYPA = 2
      IBUF   = LCORE - SYSBUF + 1
      IBUFCP = IBUF - NROWA
      IF (IBUFCP) 420,420,40
   40 LCORE = IBUFCP - 1
      CALL RULER (RULE,ICP,ZCPCT,OCPCT,CORE(IBUFCP),NROWA,CORE(IBUF),1)
      IF (IRP(1).EQ.ICP(1) .AND. IRP(1).NE.0) GO TO 60
      IBUFRP = IBUFCP - (NCOLA1+31)/32
      IF (IBUFRP) 420,420,50
   50 CALL RULER (RULE,IRP,ZRPCT,ORPCT,CORE(IBUFRP),NCOLA1,CORE(IBUF),0)
      LCORE = IBUFRP - 1
      GO TO 70
   60 ISTOR = 1
C
C     OPEN INPUT FILES
C
   70 IF (LCORE-NMAT*SYSBUF .LT. 0) GO TO 420
      DO 100 I = 1,4
      IF (IA11(1,I)) 90,100,80
   80 LCORE = LCORE - SYSBUF
      CALL OPEN (*90,IA11(1,I),CORE(LCORE+1),IREW)
      CALL SKPREC (IA11(1,I),1)
      GO TO 100
   90 IA11(1,I) = 0
  100 CONTINUE
C
C     OPEN OUTPUT FILE
C
      CALL GOPEN (NAMEA,CORE(IBUF),1)
C
C     FIX POINTERS -- SORT ON ABS VALUE
C
      K = IBUFCP - 1
      L = IBUFCP
      DO 120 I = 1,NROWA
      K = K + 1
      IF (CORE(K)) 110,120,120
  110 CORE(L) = I
      L = L + 1
  120 CONTINUE
      M = L - 1
      K = IBUFCP
      DO 160 I = 1,NROWA
  130 IF (CORE(K)-I) 150,160,140
  140 CORE(L) = I
      L = L + 1
      GO TO 160
  150 IF (K .EQ. M) GO TO 140
      K = K + 1
      GO TO 130
  160 CONTINUE
C
C     LOOP ON COLUMNS OF OUTPUT
C
      KM = 0
      L2 = IBUFCP
      L3 = IBUFCP + ZCPCT
      DO 390 LOOP = 1,NCOLA1
      CALL BLDPK (IOTP,ITYPA,NAMEA,0,0)
      IF (ISTOR .EQ. 1) GO TO 190
      J  = (LOOP-1)/32 + IBUFRP
      KM = KM + 1
      IF (KM .GT. 32) KM = 1
      ITEMP = ANDF(CORE(J),TWO1(KM))
      IF (KM .EQ. 1) ITEMP = RSHIFT(ANDF(CORE(J),TWO1(KM)),1)
      IF (ITEMP .NE. 0) GO TO 180
C
C     IA11 AND IA21 BEING USED
C
  170 L1 = 0
      IF (L2 .EQ. L3-1) GO TO 200
      L2 = L2 + 1
      GO TO 200
C
C     IA12 AND IA22 BEING USED
C
  180 L1 = 2
      L3 = L3 + 1
      GO TO 200
C
C     USE ROW STORE
C
  190 IF (CORE(L2) .EQ. LOOP) GO TO 170
      IF (CORE(L3) .EQ. LOOP) GO TO 180
      GO TO 460
C
C     BEGIN ON SUBMATRICES
C
  200 IO = 0
      DO 220 J = 1,2
      K = L1 + J
      IF (IA11(1,K)) 210,220,210
  210 M = 20*J - 19
      CALL INTPK (*220,IA11(1,K),BLOCK(M),IOTP,1)
      IO = IO + J
  220 CONTINUE
      IF (IO) 230,380,230
C
C     PICK UP NON ZERO
C
  230 IEOL = 0
      JEOL = 0
      IPOS = 9999999
      JPOS = 9999999
      IAZ  = 1
      IBZ  = 1
      NAM1 = IA11(1,L1+1)
      NAM2 = IA11(1,L1+2)
      IF (IO-2) 240,280,240
  240 IAZ  = 0
  250 IF (IEOL) 370,260,370
  260 CALL INTPKI (A11(1),I,NAM1,BLOCK(1),IEOL)
      K    = IBUFCP + I - 1
      IPOS = CORE(K)
      IF (IO .EQ. 1) GO TO 310
      IO   = 1
  280 IBZ  = 0
  290 IF (JEOL) 340,300,340
  300 CALL INTPKI (B11(1),J,NAM2,BLOCK(21),JEOL)
      K = IBUFCP + ZCPCT + J - 1
      JPOS = CORE(K)
  310 IF (IPOS-JPOS) 350,320,320
C
C     PUT IN B11
C
  320 DO 330 M = 1,NTYPA
  330 IC11(M) = B11(M)
      II = JPOS
      CALL ZBLPKI
      GO TO 290
  340 JPOS = 9999999
      IBZ  = 1
      IF (IAZ+IBZ .EQ. 2) GO TO 380
  350 DO 360 M = 1,NTYPA
  360 IC11(M) = A11(M)
      II = IPOS
      CALL ZBLPKI
      GO TO 250
  370 IAZ  = 1
      IPOS = 9999999
      IF (IAZ+IBZ .NE. 2) GO TO 320
C
C     OUTPUT COLUMN
C
  380 CALL BLDPKN (NAMEA,0,NAMEA)
C
  390 CONTINUE
C
C     DONE -- CLOSE OPEN MATRICES
C
      DO 400 I = 1,4
      IF (IA11(1,I) .GT. 0) CALL CLOSE (IA11(1,I),1)
  400 CONTINUE
      CALL CLOSE (NAMEA,1)
      GO TO 500
C
  420 MN = -8
      GO TO 480
  440 WRITE  (NOUT,450) K
  450 FORMAT ('0*** SYSTEM OR USER ERROR, DUPLICATE GINO FILES AS ',
     1        'DETECTED BY MERGE ROUTINE - ',I5)
      NM = -37
      GO  TO 480
  460 MN = -7
  480 CALL MESAGE (MN,0,NAME)
C
  500 RETURN
      END

      SUBROUTINE HESS1 (KDD,MDD,LAMD,PHID,OEIGS,NFOUND,NVECD,BDD,SCR1,
     1                  SCR2,SCR3,SCR4,SCR5,SCR6,SCR7,EED,METHOD)
C
C     SUBROUTINE HESS1 TRANSFORMS THE  PROBLEM
C         PSQ M  + P B  + K   INTO   PSQ I  + MINV K
C
C     THREE CASES ARE AVAILABLE
C         1    BDB = 0   MDD  NOT IDENTITY
C              AMAT=     MINVERSE K  (MINUS ADDED IN CORE)
C                        OUTPUT   P = CSQRT COMPUTED  PS
C                        OUTPUT VEC = COMPUTED VECTOR
C
C         2    BDD = 0   MDD  IDENTITY
C              AMAT=     KDD
C                        OUTPUT AS IN CASE 1
C
C         3    BDD NOT  ZERO   MDD  NOT  IDENTITY
C              AMAT=  1    1    1
C                     1  0 1-I  1
C                     1----------
C                     1 -1 1 -1 1
C                     1M  K1M  B1
C                     1    1    1
C                     OUTPUT  P   = COMPUTED  P
C                     OUTPUT  VEC = FIRST HALF OF COMPUTED VECTOR
C
C     CORE  LAYOUT (FOR ALLMAT) IS AS FOLLOWS)
C
C     CONTENTS                SIZE              POINTER   TYPE  NAME
C     --------                ----              -------   ----  ----
C     INPUT MATRIX--VECTORS   2*NROW*NROW        IA       COMP  A
C     EIGENVALUES             2*NROW             IL       COMP  LAMBDA
C     H MATRIX                2*NROW*NROW        IH       COMP  H
C     HL MATRIX               2*NROW*NROW        IHL      COMP  HL
C     VECTOR STORAGE          2*NROW             IV       COMP  VEC
C     MULTPLIERS              2*NROW             IM       COMP  MULT
C     INTH                    NROW               INTH     INT   INTH
C     INT                     NROW               INT      LOG   INT
C
C     BUFFER                  SYSBUF             IBUF1    INT   BUFFER
C
C
C     VARIABLE  DEFINITION
C
C     ID   0  MEANS  IDENTY MASS MATRIX
C     IBDD 0  MEANS  NULL B MATRIX
C     AMAT    FINAL  A MATRIX GINO NAME
C     NROW    ORDER  OF PROBLEM
C
C
C
      INTEGER         PHID,OEIGS,BDD,SCR1,SCR2,SCR3,SCR4,SCR5,SCR6,SCR7,
     1                IZ(8),MCB(7),SYSBUF,NAME(2),FILE,IHEAD(10),EED,
     2                AMAT,EIGC(2),POIN
      DOUBLE PRECISION D1,D2,D3,D4,D5,DZ(1),TEMP(2)
      COMPLEX         CZ(1),TZ
      CHARACTER       UFM*23,UWM*25
      COMMON /XMSSG / UFM,UWM
      COMMON /UNPAKX/ ITC,II,JJ,INCR
      COMMON /ZZZZZZ/ Z(1)
      COMMON /CDCMPX/ DUM32(32),IB
      COMMON /SYSTEM/ KSYSTM(65)
      COMMON /OUTPUT/ HEAD(1)
      EQUIVALENCE     (KSYSTM( 1),SYSBUF), (KSYSTM(2),MOUT ),
     1                (KSYSTM(55),IPREC ), (Z(1),DZ(1),IZ(1),CZ(1))
      DATA    NAME  / 4HHESS,4H1        /
      DATA    IHEAD / 0,1009,4,7*0      /
      DATA    EIGC  , POIN/ 207,2,4HPOIN/
      DATA    IZ0   / 0   /
C
C     DETERMINE  IF MASS MATRIX IS IDENTITY
C
      MCB(1) = MDD
      CALL RDTRL (MCB)
      ID = 0
      IF (MCB(4) .EQ. 8) ID = 1
      NROW  = MCB(2)
      AMAT  = KDD
      IF (ID .NE. 0) GO TO 10
C
C     DECOMPOSE  MASS MATRIX
C
      IB = 0
      CALL CFACTR (MDD,SCR1,SCR2,SCR3,SCR4,SCR5,IOPT)
C
C     SOLVE FOR AMATRIX
C
      CALL CFBSOR (SCR1,SCR2,KDD,SCR3,IOPT)
C
C     DETERMINE IF  B MATRIX IS NULL
C
      AMAT = SCR3
   10 IBDD = 0
      MCB(1) = BDD
      CALL RDTRL (MCB)
      IF (MCB(1).LE.0 .OR. MCB(6).EQ.0) GO TO 30
C
C     FORM  M-1  B
C
      IBDD  = 1
      IMAT1 = BDD
      IMAT2 = KDD
      IF (ID .NE. 0) GO TO 20
C
C     - AS OF APRIL 1985 -
C     THE UPPER AND LOWER TRIANGULAR MATRICES IN SCR1 AND SCR2 WERE
C     MYSTERIOUSLY DESTROYED HERE. MUST CALL CFACTR TO RE-GENERATE THEM
C
C     - AS OF JUNE 1991 -
C     TRY WITHOUT 2ND CALL TO CFACTR, AND MAKE SURE SCR1 AND SCR2 ARE
C     STILL GINO UNITS 301 AND 302
C
      IB = 0
      CALL CFACTR (MDD,SCR1,SCR2,SCR3,SCR4,SCR5,IOPT)
C
      CALL CFBSOR (SCR1,SCR2,BDD,SCR4,IOPT)
      IMAT1 = SCR4
      IMAT2 = SCR3
   20 CALL HESS2 (NROW,SCR5,SCR6)
C
C     IDENTITY ON SCR5  MERGE VECTOR ON SCR6
C
      CALL MERGED (0,SCR5,IMAT2,IMAT1,SCR7,SCR6,SCR6,0,0)
      AMAT = SCR7
      NROW = 2*NROW
C
C     ALLOCATE  CORE FOR  ALLMAT
C
   30 IA  = 1
      IL  = IA + 2*NROW*NROW
      IH  = IL + 2*NROW
      IHL = IH + 2*NROW*NROW
      IV  = IHL+ 2*NROW*NROW
      IM  = IV + 2*NROW
      INTH= IM + 2*NROW
      INT = INTH + NROW
      NZ  =  KORSZ(IZ)
      IBUF1 = NZ - SYSBUF + 1
      IF (IH+SYSBUF .GT. NZ) CALL MESAGE (-8,0,NAME)
C
C     PROCESS EIGC CARD
C
      FILE = EED
      CALL PRELOC (*900,IZ(IBUF1-1),EED)
      CALL LOCATE (*900,IZ(IBUF1-1),EIGC,IFLAG)
   50 CALL FREAD (EED,IZ,10,0)
      IF (METHOD.EQ.IZ(1) .OR. METHOD.EQ.-1) GO TO 70
C
C     SKIP REMAINDER OF EIGC CARD
C
   60 CALL FREAD (EED,IZ,7,0)
      IF (IZ(6) .NE. -1) GO TO 60
      GO TO 50
C
C     EIGC  CARD  FOUND
C
   70 INORM = 0
      IF (IZ(4)  .NE. POIN) INORM = 1
      ISIL  = IZ(6)
      EPSI  = 1.0E-6
      IF (Z(IZ0+8) .NE. 0.0) EPSI = Z(IZ0+8)
C
C     PROCESS  REGION  DEFINITION
C
      CALL FREAD (EED,IZ,7,0)
      ALPH1 = Z(1)
      ALPH2 = Z(IZ0+3)
      W1    = Z(IZ0+2)
      W2    = Z(IZ0+4)
      NVECD = IZ(7)
      IF (NVECD .GT. 0) GO TO 95
C
C     ---- SET DEFAULT TO ONE SOLUTION VECTOR ----
C
      NVECD = 1
      WRITE  (MOUT,90) UWM
   90 FORMAT (A25,' 2357, ONE VECTOR (DEFAULT) WILL BE COMPUTED IN THE',
     1       ' COMPLEX REGION.')
   95 CALL CLOSE (EED,1)
      NVECD = MAX0(NVECD,1)
C
C     BRING IN  TERMS OF MATRIX
C
      CALL GOPEN (AMAT,IZ(IBUF1),0)
      ITC  =-3
      II   = 1
      JJ   = NROW
      INCR = 1
      DO 100 I = IA,IL
      Z(I) = 0.0
  100 CONTINUE
      J = IA
      DO 120 I = 1,NROW
      CALL UNPACK (*110,AMAT,Z(J))
  110 J = J + 2*NROW
  120 CONTINUE
      CALL CLOSE (AMAT,1)
C
C     DO IT
C
      NCOUNT = NVECD
      CALL ALLMAT (Z(IA),Z(IL),Z(IH),Z(IHL),Z(IV),Z(IM),Z(INTH),Z(INT),
     1             NROW,NCOUNT,IOPT1)
      NFOUND = NCOUNT/IPREC
      FILE   = LAMD
      CALL OPEN (*900,LAMD,IZ(IBUF1),1)
      DO 230 I = 1,NROW
      J  = IA + NROW*NROW + I - 1
      IF (IBDD .NE. 0) GO TO 210
C
C     PUT OUT COMPLEX SQUARE ROOT
C
      TZ = CSQRT(CZ(J))
      IF (AIMAG(TZ) .LT. 0.0) TZ = -TZ
      TEMP(1) = REAL(TZ)
      TEMP(2) = AIMAG(TZ)
      GO TO 220
C
C     NON-ZERO  B
C
  210 CONTINUE
      TEMP(1) = REAL(CZ(J))
      TEMP(2) = AIMAG(CZ(J))
  220 CALL WRITE (LAMD,TEMP,4,1)
  230 CONTINUE
      CALL CLOSE (LAMD,1)
C
C     PUT OUT  EIGENVECTORS
C
      FILE = PHID
      CALL OPEN (*900,PHID,IZ(IBUF1),1)
      J    = NROW*NROW + NROW
      K    = IA - 1
      NOUT = NROW*2
      IF (IBDD .NE. 0) NOUT = NOUT/2
      DO 370 M = 1,NVECD
      D1 = 0.0
      DO 310 I = 1,NOUT,2
      II = J + I
      JJ = K + I
      DZ(II  ) = Z(JJ  )
      DZ(II+1) = Z(JJ+1)
      D2 = DZ(II)*DZ(II) + DZ(II+1)*DZ(II+1)
      IF (D2 .LT. D1) GO TO 310
      D3 = DZ(II  )
      D4 = DZ(II+1)
      D1 = D2
  310 CONTINUE
      IF (INORM .EQ. 0) GO TO 350
  320 DO 330 I = 1,NOUT,2
      JJ = J + I
      D5 = (DZ(JJ)*D3 + DZ(JJ+1)*D4)/D1
      DZ(JJ+1) = (D3*DZ(JJ+1) - D4*DZ(JJ))/D1
      DZ(JJ  ) = D5
  330 CONTINUE
      GO TO 360
  350 JJ = 2*ISIL + J
      D2 = DZ(JJ)*DZ(JJ) + DZ(JJ-1)*DZ(JJ-1)
      IF (D2.EQ.0.0D0 .OR. D1/D2.GT.1.0D6) GO TO 320
      D3 = DZ(JJ-1)
      D4 = DZ(JJ  )
      D1 = D2
      GO TO 320
  360 CONTINUE
      CALL WRITE (PHID,DZ(J+1),NOUT*2,1)
      K  = K + NROW*2
  370 CONTINUE
      CALL CLOSE (PHID,1)
C
C     PUT OUT OEIGS
C
      CALL GOPEN (OEIGS,IZ(IBUF1),1)
      CALL WRITE (OEIGS,IHEAD,10,0)
      IZ(1) = NFOUND
      IZ(2) = NVECD
      IZ(3) = 0
      IZ(4) = 0
      IZ(5) = 0
      IZ(6) = 0
      IZ(7) = 0
      IZ(8) = 1
      CALL WRITE (OEIGS,IZ,40,0)
      CALL WRITE (OEIGS,HEAD,96,1)
      CALL CLOSE (OEIGS,1)
      MCB(1) = OEIGS
      MCB(2) = NFOUND
      MCB(3) = NVECD
      CALL WRTTRL (MCB)
      RETURN
C
C     ERROR MESSAGES
C
  900 IP1 =-1
      CALL MESAGE (IP1,FILE,NAME)
      RETURN
C
      END

      SUBROUTINE DUMOD2
C
C*****
C
C     DUMMY DECK FOR MODULE DUMMOD2 - SEE USER'S MANUAL SECTION 5.6.
C                                     FOR MODULE PROPERTIES, CHECK
C                                     SUBROUTINE XMPLDD OR USE DIAG 31.
C
C*****
C
      COMPLEX PARM9
C
      DOUBLE PRECISION PARM8,PARM10
C
      INTEGER PARM1,PARM2,PARM3,PARM4,PARM7
C     INTEGER INFILE(8),OUTFIL(8),SCRFIL(10)
C
      COMMON /BLANK/ PARM1,PARM2,PARM3,PARM4,PARM5,PARM6,
     1               PARM7(2),PARM8,PARM9,PARM10(2)
      COMMON /ZZZZZZ/ X(1)
C
C     DATA INFILE /101,102,103,104,105,106,107,108/
C     DATA OUTFIL /201,202,203,204,205,206,207,208/
C     DATA SCRFIL /301,302,303,304,305,306,307,308,309,310/
C
      RETURN
      END

      SUBROUTINE SQDPL1
C
C     PHASE I OF STRESS DATA RECOVERY FOR TRI OR QUAD PLATE.
C
C     OUTPUTS FROM THIS PHASE FOR USE IN PHASE II ARE THE FOLLOWING.
C
C     1) ELEMENT ID
C     2) 4 SILS
C     3) I
C     4) Z1 AND Z2
C     5) 4  5X6 S-SUB-I ARRAYS
C     6) 3X1 S SUB T MATRIX
C     THUS, 131 WORDS FOR QUAD-PLATE
C
C     ECPT LISTS AS OF AUGUST 4, 1967
C
C                 DEFINITION                   DEFINITION
C       ECPT      BSC.BEND.TRI.-----TYPE       QUAD.PLT.---------TYPE
C     --------   --------------------------    -------------------------
C     ECPT( 1) = ELEMENT ID         INTEGER ** ELEMENT           INTEGER
C     ECPT( 2) = GRID PT. A         INTEGER ** GRID PT.A         INTEGER
C     ECPT( 3) = GRID PT. B         INTEGER ** GRID PT.B         INTEGER
C     ECPT( 4) = GRID PT. C         INTEGER ** GRID PT.C         INTEGER
C     ECPT( 5) = THETA              REAL    ** GRID PT.D         INTEGER
C     ECPT( 6) = MAT ID 1           INTEGER ** THETA             REAL
C     ECPT( 7) = I  MOM. OF INERT.  REAL    ** MAT ID 1          INTEGER
C     ECPT( 8) = MAT ID 2           INTEGER ** I  MOM. OF INERT. REAL
C     ECPT( 9) = T2                 REAL    ** MAT ID 2          INTEGER
C     ECPT(10) = NON-STRUCT. MASS   REAL    ** T2                REAL
C     ECPT(11) = Z1                 REAL    ** NON-STRUCT. MASS  REAL
C     ECPT(12) = Z2                 REAL    ** Z1                REAL
C     ECPT(13) = COORD. SYS. ID 1   INTEGER ** Z2                REAL
C     ECPT(14) = X1                 REAL    ** COORD. SYS. ID 1  INTEGER
C     ECPT(15) = Y1                 REAL    ** X1                REAL
C     ECPT(16) = Z1                 REAL    ** Y1                REAL
C     ECPT(17) = COORD. SYS. ID 2   INTEGER ** Z1                REAL
C     ECPT(18) = X2                 REAL    ** COORD. SYS. ID 2  INTEGER
C     ECPT(19) = Y2                 REAL    ** X2                REAL
C     ECPT(20) = Z2                 REAL    ** Y2                REAL
C     ECPT(21) = COORD. SYS. ID 3   INTEGER ** Z2                REAL
C     ECPT(22) = X3                 REAL    ** COORD. SYS. ID 3  INTEGER
C     ECPT(23) = Y3                 REAL    ** X3                REAL
C     ECPT(24) = Z3                 REAL    ** Y3                REAL
C     ECPT(25) = ELEMENT TEMP       REAL    ** Z3                REAL
C     ECPT(26) =                            ** COORD. SYS. ID 4  INTEGER
C     ECPT(27) =                            ** X4                REAL
C     ECPT(28) =                            ** Y4                REAL
C     ECPT(29) =                            ** Z4                REAL
C     ECPT(30) =                            ** ELEMENT TEMP      REAL
C
      INTEGER         SUBSCA,SUBSCB,SUBSCC
      REAL            IVECT,JVECT,KVECT,D(9)
      DIMENSION       NECPT(100),M(12),VQ1(3),VQ2(3),VQ3(3),VQ4(3),
     1                REQUIV(10)
      COMMON /CONDAS/ CONSTS(5)
      COMMON /SDR2X5/ ECPT(100),PH1OUT(128),ST(3)
      COMMON /SDR2X6/ A(45),TEMP15(15),PROD15(15),T(9),TITE(18),V(25),
     1                D1(3),D2(3),SPDUM1(18),U1,U2,SINANG,COSANG,
     2                SSUM(60),R(2,5),XSUBB,XSUBC,YSUBC,E(18),TEMP,
     3                VV1(2),VV2(2),H,A1(3),NPOINT,SPDUM2(5),IVECT(3),
     4                JVECT(3),KVECT(3),SPDUM3(15),THETA,NSUBC,
     5                SPDUM4(1),SUBSCA,SUBSCB,SUBSCC,SPDUM5(2),XC,YC,
     6                SPDUM6(5)
      COMMON /MATIN / MATID,INFLAG,ELTEMP,STRESS,SINTH,COSTH
      COMMON /MATOUT/ G11,G12,G13,G22,G23,G33,RHO,ALPHA(3)
      EQUIVALENCE     (CONSTS(4),DEGRA),(ECPT(1),NECPT(1)),
     1                (VQ1(1),ECPT(15)),(VQ2(1),ECPT(19)),
     2                (VQ3(1),ECPT(23)),(VQ4(1),ECPT(27)),
     3                (REQUIV(1),R(1,1))
      DATA    M     / 2,4,1,  3,1,2,  4,2,3,  1,3,4 /
C
      IDSAVE = NECPT(7)
      EYE    = ECPT(8)
      THETA  = ECPT(6)*DEGRA
      SINANG = SIN(THETA)
      COSANG = COS(THETA)
C
C     FORMATION OF THE R-MATRIX CONTAINING COORDINATES OF THE
C     SUB TRIANGLES. (2X5) FOR QUADRILATERAL PLATE.
C     FORMATION ALSO OF THE I,J, AND K VECTORS USED IN THE E-MATRIX.
C
C     ZERO OUT R-MATRIX
C
      DO 10 I = 1,10
   10 REQUIV(I) = 0.0
C
C     SHIFT ECPT UP TO MATCH STRBS1 FOR CERTAIN VARIABLES.
C
      DO 30 I = 6,12
   30 ECPT(I) = ECPT(I+1)
C
      DO 40 I = 1,3
      D1(I) = VQ3(I) - VQ1(I)
      D2(I) = VQ4(I) - VQ2(I)
   40 A1(I) = VQ2(I) - VQ1(I)
C
C     NON-NORMALIZED K-VECTOR = D1 CROSS D2
C
      KVECT(1) = D1(2)*D2(3) - D2(2)*D1(3)
      KVECT(2) = D1(3)*D2(1) - D2(3)*D1(1)
      KVECT(3) = D1(1)*D2(2) - D2(1)*D1(2)
C
C     NORMALIZE K-VECTOR
C
      TEMP = SQRT(KVECT(1)**2 + KVECT(2)**2 + KVECT(3)**2)
      DO 50 I = 1,3
   50 KVECT(I) = KVECT(I)/TEMP
C
C     COMPUTE H = (A1 DOT KVECT)/2
C
      TEMP = (A1(1)*KVECT(1) + A1(2)*KVECT(2) + A1(3)*KVECT(3))/2.0
C
C     I-VECTOR =(A1) - H*(KVECT)    NON-NORMALIZED
C
      DO 60 I = 1,3
   60 IVECT(I) = A1(I) - TEMP*KVECT(I)
C
C     NORMALIZE I-VECTOR
C
      TEMP =  SQRT(IVECT(1)**2 + IVECT(2)**2 + IVECT(3)**2)
      DO 70 I = 1,3
   70 IVECT(I) = IVECT(I)/TEMP
C
C     J-VECTOR = K X I  VECTORS
C
      JVECT(1) = KVECT(2)*IVECT(3) - IVECT(2)*KVECT(3)
      JVECT(2) = KVECT(3)*IVECT(1) - IVECT(3)*KVECT(1)
      JVECT(3) = KVECT(1)*IVECT(2) - IVECT(1)*KVECT(2)
C
C     NORMALIZE J VECTOR TO MAKE SURE
C
      TEMP =  SQRT(JVECT(1)**2 + JVECT(2)**2 + JVECT(3)**2)
      DO 80 I = 1,3
   80 JVECT(I) = JVECT(I)/TEMP
C
C     X3 GOES INTO R(1,3) = D1 DOT IVECT
C
      R(1,3) = D1(1)*IVECT(1) + D1(2)*IVECT(2) + D1(3)*IVECT(3)
C
C     X2 GOES INTO R(1,2) AND Y3 GOES INTO R(2,3)
C
      R(1,2) = A1(1)*IVECT(1) + A1(2)*IVECT(2) + A1(3)*IVECT(3)
      R(2,3) = D1(1)*JVECT(1) + D1(2)*JVECT(2) + D1(3)*JVECT(3)
C
C     X4 GOES INTO R(1,4) AND Y4 GOES INTO R(2,4)
C
      R(1,4) = D2(1)*IVECT(1) + D2(2)*IVECT(2) + D2(3)*IVECT(3) + R(1,2)
      R(2,4) = D2(1)*JVECT(1) + D2(2)*JVECT(2) + D2(3)*JVECT(3)
C
C     STRESS CALCULATION POINT WHICH IS THE DIAGONALS INTERSECTION.
C
      FTEMP  = R(1,3)*R(2,4) + R(2,3)*(R(1,2)-R(1,4))
      IF (FTEMP .EQ. 0.0) CALL MESAGE (-30,26,ECPT(1))
      R(1,5) = R(1,2)*R(1,3)*R(2,4)/FTEMP
      R(2,5) = R(1,2)*R(2,3)*R(2,4)/FTEMP
C
C     CHECK OF 4 POINTS FOR ANGLE GREATER THAN OR EQUAL TO 180 DEGREES.
C
      IF (R(2,3).LE.0.0 .OR. R(2,4).LE.0.0) GO TO 90
      TEMP = R(1,2) - (R(1,2)-R(1,3))*R(2,4)/R(2,3)
      IF (R(1,4) .GE. TEMP) GO TO 90
      TEMP = R(2,3)*R(1,4)/R(2,4)
      IF (R(1,3) .GT. TEMP) GO TO 100
   90 CALL MESAGE (-30,35,ECPT(1))
C
C     SET UP THE M-MATRIX FOR MAPPING TRIANGLES, IN DATA STATEMENT
C
C     COMPUTE SUB-TRIANGLE COORDINATES
C     CALL BASIC BENDING ROUTINE FOR ALL SUB-TRIANGLES.
C
  100 ELTEMP = ECPT(30)
      DO 110 I = 1,60
  110 SSUM(I) = 0.0
C
      DO 160 J = 1,4
      KM     = 3*J - 3
      SUBSCA = M(KM+1)
      SUBSCB = M(KM+2)
      SUBSCC = M(KM+3)
C
      DO 120 I = 1,2
      VV1(I) = R(I,SUBSCB) - R(I,SUBSCA)
  120 VV2(I) = R(I,SUBSCC) - R(I,SUBSCA)
      XSUBB  = SQRT(VV1(1)**2 + VV1(2)**2)
      U1     = VV1(1)/XSUBB
      U2     = VV1(2)/XSUBB
      XSUBC  = U1*VV2(1) + VV2(2)*U2
      YSUBC  = U1*VV2(2) - VV2(1)*U2
C
      XC    = SQRT((R(1,SUBSCA)-R(1,5))**2 + (R(2,SUBSCA)-R(2,5))**2)
      YC    = 0.0
C
      SINTH = SINANG*U1 - COSANG*U2
      COSTH = COSANG*U1 + SINANG*U2
      IF (ABS(SINTH) .LT. 1.0E-06) SINTH = 0.0
C
C     AT THIS POINT, XSUBB, XSUBC, YSUBC ARE AT HAND FOR
C     TRIANGLE -J-
C
      CALL STRBS1 (1)
C
C     RETURNING FROM STRBS1 THE FOLLOWING QUANTITIES ARE AT HAND.
C
C       S   , S   , S   , EACH 5X3.   45 WORDS STORED IN A( 1)...A(45)
C        A     B     C
C
C
C     SET UP OF T-MATRIX
C
      T(1) = 1.0
      T(2) = 0.0
      T(3) = 0.0
      T(4) = 0.0
      T(5) = U1
      T(6) = U2
      T(7) = 0.0
      T(8) =-U2
      T(9) = U1
C
C     SET UP V-MATRIX PER FMMS 51-A
C
      V( 1) = U1*U1*0.25
      V( 2) = U2*U2*0.25
      V(11) = U1*U2*0.25
      V( 3) =-V(11)*2.0
      V( 4) = 0.0
      V( 5) = 0.0
      V( 6) = V(2)
      V( 7) = V(1)
      V( 8) =-V(3)
      V( 9) = 0.0
      V(10) = 0.0
      V(12) =-V(11)
      V(13) = V(1) - V(2)
      V(14) = 0.0
      V(15) = 0.0
      V(16) = 0.0
      V(17) = 0.0
      V(18) = 0.0
      V(19) = U1*0.25
      V(20) =-U2*0.25
      V(21) = 0.0
      V(22) = 0.0
      V(23) = 0.0
      V(24) =-V(20)
      V(25) = V(19)
C
C     ADD IN S , S , S   TO THE 4 5X3 SSUM MATRICES
C             A   B   C
C
      DO 150 I = 1,3
      CALL GMMATS (V,5,5,0, A(15*I-14),5,3,0, TEMP15)
      CALL GMMATS (TEMP15,5,3,0, T,3,3,0, PROD15)
C
C     POINTER TO SSUM MATRIX
C
      NPOINT = KM + I
      NPOINT = 15*M(NPOINT) - 15
      DO 140 K = 1,15
      NSUBC = NPOINT + K
  140 SSUM(NSUBC) = SSUM(NSUBC) + PROD15(K)
  150 CONTINUE
C
  160 CONTINUE
C
C     FILL E-MATRIX
C
      DO 170 I = 1,18
  170 E( I) = 0.0
      E( 1) = KVECT(1)
      E( 4) = KVECT(2)
      E( 7) = KVECT(3)
      E(11) = IVECT(1)
      E(14) = IVECT(2)
      E(17) = IVECT(3)
      E(12) = JVECT(1)
      E(15) = JVECT(2)
      E(18) = JVECT(3)
C
      DO 210 I = 1,4
C
C     DO WE NEED TRANSFORMATION T
C                                I
      NSUBC = 4*I + 10
      IF (NECPT(NSUBC) .EQ. 0) GO TO 180
      CALL TRANSS (NECPT(NSUBC),T)
      CALL GMMATS (T,3,3,1, E( 1),3,3,0, TITE( 1))
      CALL GMMATS (T,3,3,1, E(10),3,3,0, TITE(10))
      GO TO 200
C
  180 DO 190 K = 1,18
  190 TITE(K) = E(K)
C
  200 CALL GMMATS (SSUM(15*I-14),5,3,0, TITE,6,3,1, PH1OUT(30*I-21))
C
  210 CONTINUE
C
C     I,Z1,Z2,ELEM ID, 4 SILS FOR PHASE 2
C
      PH1OUT(1) = ECPT( 1)
      PH1OUT(2) = ECPT( 2)
      PH1OUT(3) = ECPT( 3)
      PH1OUT(4) = ECPT( 4)
      PH1OUT(5) = ECPT( 5)
      PH1OUT(6) = ECPT( 7)
      PH1OUT(7) = ECPT(11)
      PH1OUT(8) = ECPT(12)
C
C     GET S SUB T MATRIX
C
      MATID   = IDSAVE
      ECPT(8) = EYE
      STRESS  = 0
      SINTH   = SINANG
      COSTH   = COSANG
      INFLAG  = 2
      CALL MAT (ECPT(1))
      D(1) = G11*ECPT(8)
      D(2) = G12*ECPT(8)
      D(3) = G13*ECPT(8)
      D(4) = D(2)
      D(5) = G22*ECPT(8)
      D(6) = G23*ECPT(8)
      D(7) = D(3)
      D(8) = D(6)
      D(9) = G33*ECPT(8)
      CALL GMMATS (D(1),3,3,0, ALPHA(1),3,1,0, ST(1))
C
C     ALL PHASE ONE COMPLETE
C
      RETURN
      END

      SUBROUTINE CF2ORT (SUCESS,MAXITS,TEN2MT,NZERO,IORTHO,
     2                   VR,VL,V1,V1L,V2,V2L,ZB)
C*******
C     CF2ORT IS A DOUBLE-PRECISION ROUTINE (CREATED FOR USE BY
C     THE COMPLEX FEER METHOD) WHICH PERFORMS THE
C     REORTHOGONALIZATION ALGORITHM
C*******
C     DEFINITION OF INPUT AND OUTPUT PARAMETERS
C*******
C     SUCESS   = LOGICAL INDICATOR FOR SUCCESSFUL REORTHOGONALIZATION
C                (OUTPUT)
C     MAXITS   = MAXIMUM NUMBER OF ALLOWED ITERATIONS (INPUT)
C     TEN2MT   = CONVERGENCE CRITERION
C     NZERO    = NUMBER OF ORTHOGONAL VECTOR PAIRS IN PRIOR
C                NEIGHBORHOODS INCLUDING RESTART
C     IORTHO   = NUMBER OF EXISTING ORTHOGONAL VECTOR PAIRS
C                IN CURRENT NEIGHBORHOOD
C     VR       = RIGHT-HANDED VECTOR TO BE REORTHOGONALIZED
C     VL       = LEFT -HANDED VECTOR TO BE REORTHOGONALIZED
C     V1,V1L,  = WORKING SPACE FOR FOUR VECTORS (V1L MUST
C     V2,V2L     FOLLOW V1 IN CORE)
C     ZB       = WORKING SPACE FOR ONE GINO BUFFER
C*******
      DOUBLE PRECISION  VR(1)    ,VL(1)    ,V1(1)    ,V1L(1)
     2                 ,V2(1)    ,V2L(1)   ,CRITF    ,OTEST(4)
     3                 ,A(2)
      LOGICAL           SUCESS   ,QPR      ,SKIP
      INTEGER           ZB(1)
      COMMON  /FEERAA/  DUMAA(42),ISCR7
      COMMON  /FEERXC/  DUMXC(7) ,IDIAG    ,XCDUM(3) ,NORD2
     2                 ,XCDUM2(9),QPR      ,XCDUM3(5),NUMORT
      COMMON  /UNPAKX/  IPRC     ,II       ,NN       ,INCR
      COMMON  /NAMES /  RD       ,RDREW    ,WRT      ,WRTREW
     2                 ,REW      ,NOREW    ,EOFNRW
      COMMON  /SYSTEM/  KSYS     ,NOUT
      MORTHO = NZERO+IORTHO
      IF (MORTHO.LE.0) GO TO 500
      IF (QPR) WRITE (NOUT,700)
      NUMORT = NUMORT + 1
      K = 0
      SUCESS = .FALSE.
      NN = NORD2
      CRITF = 100.D0*DBLE(TEN2MT)**2
      DO 5  I = 1,NORD2
      V2 (I) = VR(I)
    5 V2L(I) = VL(I)
      CALL GOPEN (ISCR7,ZB(1),RDREW)
    8 DO 9  I = 1,4
    9 OTEST(I) = 0.D0
      LL = 2
C*******
C     ENTER LOOP
C*******
      DO 40  I = 1,MORTHO
      IF (I.EQ.NZERO+1) LL = 0
      IF (QPR) WRITE (NOUT,701) I
C     VALUES ARE UNPACKED INTO BOTH V1 AND V1L
      CALL UNPACK(*10,ISCR7,V1(1))
      IF (.NOT.QPR) GO TO 20
      WRITE (NOUT,702) (V1 (J),J=1,NORD2)
      WRITE (NOUT,702) (V1L(J),J=1,NORD2)
      GO TO 20
   10 IF (IDIAG.NE.0) WRITE (NOUT,710) I
      GO TO 40
C*******
C     OBTAIN RIGHT-HAND INNER-PRODUCT TERM
C*******
   20 CALL CFNOR2 (VR(1),V1L(1),NORD2,1,A(1))
C*******
C     SUBTRACT OFF RIGHT-HAND INNER-PRODUCT TERM
C*******
      DO 25  J = 1,NORD2,2
      L = J+1
      V2(J) = V2(J) - A(1)*V1(J) + A(2)*V1(L)
   25 V2(L) = V2(L) - A(1)*V1(L) - A(2)*V1(J)
C*******
C     COMPUTE MAXIMUM RIGHT-HAND SQUARED-ERROR
C*******
      A(1) = A(1)**2+A(2)**2
      IF (OTEST(LL+1).LT.A(1)) OTEST(LL+1) = A(1)
C*******
C     OBTAIN LEFT-HAND INNER-PRODUCT TERM
C*******
      CALL CFNOR2 (VL(1),V1(1),NORD2,1,A(1))
C*******
C     SUBTRACT OFF LEFT-HAND INNER-PRODUCT TERM
C*******
      DO 30  J = 1,NORD2,2
      L = J+1
      V2L(J) = V2L(J) - A(1)*V1L(J) + A(2)*V1L(L)
   30 V2L(L) = V2L(L) - A(1)*V1L(L) - A(2)*V1L(J)
C*******
C     COMPUTE MAXIMUM LEFT-HAND SQUARED-ERROR
C*******
      A(1) = A(1)**2+A(2)**2
      IF (OTEST(LL+2).LT.A(1)) OTEST(LL+2) = A(1)
   40 CONTINUE
      DO 50  I = 1,NORD2
      VR(I) = V2 (I)
   50 VL(I) = V2L(I)
      SKIP = .FALSE.
      IF (.NOT.QPR) GO TO 91
      WRITE (NOUT,702) (VR(I),I=1,NORD2)
      WRITE (NOUT,702) (VL(I),I=1,NORD2)
C*******
C     TEST FOR CONVERGENCE
C*******
   91 IF (IDIAG.NE.0) WRITE (NOUT,703) K,CRITF,OTEST
      IF (OTEST(1).LE.CRITF .AND. OTEST(2).LE.CRITF .AND.
     2    OTEST(3).LE.CRITF .AND. OTEST(4).LE.CRITF) GO TO 450
      IF (SKIP) GO TO 92
      IF (K.NE.1.AND.K.NE.3.AND.K.NE.5) GO TO 92
      IF (IDIAG.NE.0) WRITE (NOUT,720)
      CRITF = 100.D0*CRITF
      SKIP = .TRUE.
      GO TO 91
   92 K = K + 1
      IF (K.GT.MAXITS) GO TO 95
      CALL CLOSE (ISCR7,EOFNRW)
      CALL GOPEN (ISCR7,ZB(1),RDREW)
      GO TO 8
   95 CALL CLOSE (ISCR7,NOREW)
      GO TO 600
  450 CALL CLOSE (ISCR7,NOREW)
  500 SUCESS = .TRUE.
  600 RETURN
  700 FORMAT(1H0,//26H BEGIN REORTHOGONALIZATION,//)
  701 FORMAT(1H ,13HUNPACK VECTOR,I4)
  702 FORMAT(3H --,32(4H----),/(1H ,4D25.16))
  703 FORMAT(32H   REORTHOGONALIZATION ITERATION,I3,
     2 9X,14HTARGET VALUE =,D12.4,4X,8HERRORS =,4D12.4)
  710 FORMAT(18H ORTHOGONAL VECTOR,I4,
     2 39H IS NULL IN REORTHOGONALIZATION ROUTINE)
  720 FORMAT(52H   REORTHOGONALIZATION TOLERANCE TEMPORARILY RELAXED)
      END

      SUBROUTINE FEER
C
C     DRIVER FOR THE FEER (FAST EIGENVALUE EXTRACTION ROUTINE) METHOD.
C     THIS ROUTINE WAS CALLED FCNTL BEFORE
C
C     GIVEN A REAL SYMETRIC MATRIX, FEER WILL SOLVE FOR THE EIGENVALUES
C     AND EIGENVECTORS AROUND THE CENTER OF INTEREST
C
C     DEFINITION OF INPUT AND OUTPUT PARAMETERS
C
C     IFKAA(7) = 101, MATRIX GINO BLOCK FOR THE INPUT STIFFNESS MATRIX K
C     IFMAA(7) = 102, MATRIX GINO BLOCK FOR THE INPUT MASS MATRIX M
C     IFLELM(7)= 201, MATRIX GINO BLOCK FOR THE OUTPUT EIGENVALUES
C     IFLVEC(7)= 202, MATRIX GINO BLOCK FOR THE OUTPUT EIGENVECTORS
C            ? = 203
C     DMPFLE   = 204, EIGENVALUE SUMMARY FILE
C     SR1FLE-SR8FLE = 301-308, SCRATCH FILES REQUIRED INTERNALLY
C     XLMBDA   =  INPUT, CENTER OF RANGE OF INTEREST.
C                 (USER SPECIFIED SHIFT)
C     NEIG     =  NUMBER OF DESIRED EIGENVALUES AROUND THE CENTER
C                 OF INTEREST. (EIGENVALUES SPECIFIED BY USER)
C     NORD     =  PROBLEM SIZE (SET INTERNALLY USING THE DIMENSION OF
C                 THE STIFFNESS MATRIX)
C     MORD     =  ORDER OF THE REDUCED PROBLEM (SET INTERNALLY)
C     NORTHO   =  NO. OF ORTHOGONAL VECTORS IN PRESENT SET (INCLUDE
C                 PREVISOUSLY COMPUTED VECTORS)
C     EPXM     =  ZERO MASS CRITERIA TO DETERMINE RANK
C     EPX      =  ORTHOGONALITY CONVERGENCE CRITERIA
C     IBK      =  BUCKLING OPTION INDICATOR (SET INTERNALLY)
C     CRITF    =  THE USER SPECIFIED (OR DEFAULT) DESIRED THEORETICAL
C                 ACCURACY OF THE EIGENVALUES EXPRESSED AS A PERCENTAGE
C     LAMBDA   =  VALUE OF THE SHIFT ACTUALLY USED (D.P.)
C     CNDFLG   =  TERMINATION INDICATOR
C     ITER     =  NO. OF STARTING POINTS USED
C     IOPTF    =  SPECIFIED SHIFT OPTION INDICATOR, SET INTERNALLY
C     NOCHNG   =  THEORETICAL ERROR PARAMETER
C     IFSET    =  INTERNALLY COMPUTED SHIFT INDICTOR
C     NONUL    =  NO. OF VETOR ITERATIONS
C     MRANK    =  MATRIX RANK OF THE PROBLEM
C     IND,LMBDA,IDAIG = NOT ACTIVEATED
C
C     EIGENVALUES AND EIGENVECTORS WILL BE STORED ON THE ACTUAL SR1FLE
C     AND SR2FLE. THE SELECTION OF ACCURATE EIGENVALUES AND VECTORS WILL
C     PUT THEM ON IFLELM AND IFLVEC IN THE CORRECT SEQUENCE AT THE END
C     OF PROCESSING
C
C     IFLELM        CONTAINS (K+LAMBDA*M) OR KAA
C     IFLVEC        CONTAINS THE LOWER TRIANGLE L OR C
C     SR4FLE        IS USED AS SCRATCH IN SDCOMP
C     SR5FLE        IS USED AS SCRATCH IN SDCOMP
C     SR6FLE        IS USED AS SCRATCH IN SDCOMP
C     SR7FLE        CONTAINS THE VECTORS WHICH ARE USED TO ORTHOGONALIZE
C     SR8FLE        CONTAINS THE CONTITIONED MAA MATRIX
C     IFLRVA = 301
C     IFLRVC = 302
C     MCBLT         LOWER TRAINGULAR MATRIX L CONTROL BLOCK
C     MCBSMA        CONTITIONED MASTRIX M CONTROL BLOCK
C     MCBVEC        ORTHOGONAL VECTOR FILE CONTROL BLOCK
C     MCBRM         TRIAL VECTOR V OR C(INVERSE-TRANSPOSE)*V CONTROL
C                   BLOCK
C
      INTEGER          SYSBUF    ,CNDFLG   ,SR8FLE   ,NAME(3)  ,
     1                 DMPFLE    ,IZ(12)   ,TIMED    ,STURM    ,
     2                 T1        ,T2       ,T3       ,TIMET    ,
     3                 MCB(7)    ,ICR(2)   ,JCR(2)
      DOUBLE PRECISION LAMBDA    ,LMBDA    ,DZ(1)    ,DRSN     ,
     1                 DRSM      ,EPXM     ,SCALE    ,DSM
      DIMENSION        TMT(4)    ,TML(4)
      CHARACTER        UFM*23    ,UWM*25   ,UIM*29
      COMMON  /XMSSG / UFM       ,UWM      ,UIM
      COMMON  /BLANK / IPROB(2)  ,NUMMOD   ,ICASE
      COMMON  /FEERCX/ IFKAA(7)  ,IFMAA(7) ,IFLELM(7),IFLVEC(7),
     1                 SR1FLE    ,SR2FLE   ,SR3FLE   ,SR4FLE   ,
     2                 SR5FLE    ,SR6FLE   ,SR7FLE   ,SR8FLE   ,
     3                 DMPFLE    ,NORD     ,XLMBDA   ,NEIG     ,
     4                 MORD      ,IBK      ,CRITF    ,NORTHO   ,
     5                 IFLRVA    ,IFLRVC
      COMMON  /FEERXX/ LAMBDA    ,CNDFLG   ,ITER     ,TIMED    ,
     1                 L16       ,IOPTF    ,EPX      ,NOCHNG   ,
     2                 IND       ,LMBDA    ,IFSET    ,NZERO    ,
     3                 NONUL     ,IDIAG    ,MRANK    ,ISTART   ,
     4                 NZ3
      COMMON  /REIGKR/ OPTION(2)
      COMMON  /ZZZZZZ/ Z(1)
      COMMON  /NTIME / LNTIME    ,TCONS(15)
      COMMON  /OPINV / MCBLT(7)  ,MCBSMA(7),MCBVEC(7),MCBRM(7)
      COMMON  /SYSTEM/ KSYSTM(65)
      COMMON  /PACKX / ITP1      ,ITP2     ,IIP      ,NNP      ,
     1                 INCRP
      COMMON  /UNPAKX/ IPRC      ,II       ,NN       ,INCR
      COMMON  /NAMES / RD        ,RDREW    ,WRT      ,WRTREW   ,
     1                 REW       ,NOREW    ,EOFNRW
      COMMON  /STURMX/ STURM     ,SHFTPT   ,KEEP(2)
      EQUIVALENCE      (IZ(1),Z(1),DZ(1))  ,(KSYSTM( 1),SYSBUF),
     1                 (KSYSTM(2),    IO)  ,(KSYSTM(55),IPREC ),
     2                 (TCONS(8) ,TMT(1))  ,(TCONS(12) ,TML(4)),
     3                 (KSYSTM(40), NBPW)
      DATA     NAME  / 4HFEER,2*2H   /     ,IBEGN/ 4HBEGN   /
      DATA     IEND  / 4HEND         /     ,MODE / 4HMODE   /
      DATA     I1,I2 , I3,I4,I0      /  1H1,1H2,1H3,1H4,1H  /
      DATA     ICR   / 4HPASS,4HFAIL /, JCR/4HFREQ,4HBUCK   /
C
C     SET PRECISION DIGITS TO 12, ALL MACHINES (NEW 1/92)
C
      IT  = 12
      EPX = 10.**(2-IT)
      DSM = 10.0D0**(-2*IT/3)
      NAME(3)  = IBEGN
      CALL CONMSG (NAME,3,0)
      CALL FEERDD
C
C     INITIALIZE FEERCX
C     DEFINITION OF INTERNAL PARAMETERS
C
      IBK   = 0
      IF (IPROB(1) .NE. MODE) IBK = 1
      IOPTF = IBK
      TIMED = 0
      TIMET = 0
      CALL SSWTCH (16,L16)
      IF (L16 .EQ. 1) WRITE (IO,10)
   10 FORMAT (//,' *** DIAG16 - ALL TERMS USED ARE DESCRIBED IN ',
     1       'PROGRAMMER MANUAL  P. 4.48-19I THRU K',/)
      LAMBDA = -XLMBDA
      IF (IBK    .EQ.   0) GO TO 40
      IF (XLMBDA .EQ. 0.0) GO TO 30
      CALL PAGE2 (3)
      WRITE  (IO,20) UWM
   20 FORMAT (A25,' 2388', /5X,'USER SPECIFIED RANGE NOT USED FOR FEER',
     1       ' BUCKLING. THE ROOTS OF LOWEST MAGNITUDE ARE OBTAINED')
   30 LAMBDA = 0.0D+0
   40 IFSET  = 0
      IF (XLMBDA.EQ.0. .AND. IBK.EQ.0) IFSET = 1
      IF (IFSET .EQ. 1) IOPTF = 1
      CNDFLG = 0
      NODCMP = 0
      CALL RDTRL (IFKAA(1))
      CALL RDTRL (IFMAA(1))
      IFK   = IFKAA(1)
      IFM   = IFMAA(1)
      IPRC  = IPREC
      NORD  = IFKAA(2)
      INCR  = 1
      INCRP = INCR
      ITP1  = IPRC
      ITP2  = IPRC
      NZ    = KORSZ(Z)
      IBUF1 = NZ    - SYSBUF
      IBUF2 = IBUF1 - SYSBUF
      NTOT  = IPRC*(5*NORD+1) + 4*SYSBUF - NZ
      IF (NTOT .GT. 0) CALL MESAGE (-8,NTOT,NAME)
      CALL KLOCK (ISTART)
      MRANK = 0
      CALL GOPEN  (IFM,Z(IBUF1),RDREW)
      CALL MAKMCB (MCB,SR8FLE,NORD,6,IPRC)
      CALL GOPEN  (SR8FLE,Z(IBUF2),WRTREW)
      MCB(2) = 0
      MCB(6) = 0
      IF (IPRC .EQ. 2) GO TO 90
      DO 80 J = 1,NORD
      II = 0
      CALL UNPACK (*60,IFM,Z(1))
      NT = NN - II + 1
      EPXM = 0.0D+0
      IF (II.LE.J .AND. NN.GE.J) EPXM = Z(J-II+1)*DSM
      NTZ = 0
      DO 50 JJ = 1,NT
      IF (ABS(Z(JJ)) .GT. EPXM) GO TO 50
      Z(JJ) = 0.
      NTZ   = NTZ + 1
   50 CONTINUE
      IF (NTZ .LT. NT) MRANK = MRANK + 1
      GO TO 70
   60 II  = 1
      NN  = 1
      NT  = 1
      Z(1)= 0.
   70 IIP = II
      NNP = NN
      CALL PACK (Z(1),SR8FLE,MCB(1))
   80 CONTINUE
      GO TO 140
   90 DO 130 J = 1,NORD
      II = 0
      CALL UNPACK (*110,IFM,DZ(1))
      NT = NN - II + 1
      EPXM = 0.0D+0
      IF (II.LE.J .AND. NN.GE.J) EPXM = DZ(J-II+1)*DSM
      NTZ = 0
      DO 100 JJ = 1,NT
      IF (DABS(DZ(JJ)) .GT. EPXM) GO TO 100
      DZ(JJ) = 0.0D+0
      NTZ = NTZ + 1
  100 CONTINUE
      IF (NTZ .LT. NT) MRANK = MRANK + 1
      GO TO 120
  110 II = 1
      NN = 1
      NT = 1
      DZ(1) = 0.0D+0
  120 IIP = II
      NNP = NN
      CALL PACK (DZ(1),SR8FLE,MCB(1))
  130 CONTINUE
  140 CALL WRTTRL (MCB)
      MORD = 2*(NEIG-NORTHO) + 10
      MRK  = MRANK - NORTHO
      NZERO= NORTHO
      IF (MORD .GT.   MRK) MORD = MRK
      IF (NEIG .LE. MRANK) GO TO 160
      CALL PAGE2 (3)
      WRITE  (IO,150) UWM
  150 FORMAT (A25,' 2385', /5X,'DESIRED NUMBER OF EIGENVALUES EXCEED ',
     1       'THE EXISTING NUMBER, ALL EIGENSOLUTIONS WILL BE SOUGHT.')
  160 CALL CLOSE (SR8FLE,NOREW)
      CALL CLOSE (IFM,REW)
      DO 170 I = 1,7
      MCBSMA(I) = MCB(I)
  170 IFMAA(I)  = MCBSMA(I)
      IFM = IFMAA(1)
      IF (IBK .EQ. 0) GO TO 180
C
C     SET UP TO DECOMPOSE KAA
C
      IFLELM(1) = IFKAA(1)
      GO TO 210
  180 IF (IFSET .EQ. 0) GO TO 200
C
C     CALCULATE INITIAL SHIFT
C
      CALL GOPEN (IFK,Z(IBUF1),RDREW)
      CALL GOPEN (IFM,Z(IBUF2),RDREW)
      CALL FRMAX (IFK,IFM,NORD,IPRC,DRSN,DRSM)
      CALL CLOSE (IFK,REW)
      CALL CLOSE (IFM,REW)
      SCALE  = DBLE(FLOAT(NORD))*10.0D0**(-IT)*DRSM
      LAMBDA = 10.0D0**(-IT/3)*DRSN
      IF (LAMBDA .LT. SCALE) LAMBDA = SCALE
C
C     CALL IN ADD LINK TO FORM  (K+LAMBDA*M)
C
  200 NAME(2) = I1
      CALL CONMSG (NAME,3,0)
      CALL FEER1
      NAME(3) = IEND
      CALL CONMSG (NAME,3,0)
C
C     CALL IN SDCOMP TO DECOMPOSE THIS MATRIX
C
  210 NODCMP  = NODCMP + 1
      SHFTPT  = DABS(LAMBDA)
      NAME(2) = I2
      NAME(3) = IBEGN
      CALL CONMSG (NAME,3,0)
      CALL FEER2 (ISING)
      NAME(3) = IEND
      CALL CONMSG (NAME,3,0)
      IK = IBK   + 1
      IJ = ISING + 1
      IF (ISING.NE.1 .AND. L16.EQ.0) GO TO 230
      CALL PAGE2 (4)
      WRITE  (IO,220) JCR(IK),NORD,MRANK,MORD,NORTHO,NEIG,NZERO,XLMBDA,
     1                LAMBDA,ICR(IJ)
  220 FORMAT ('0*** DIAG 16 OUTPUT FOR FEER ANALYSIS, OPTION =',A4, /5X,
     1       'ORDER =',I5,',  MAX RANK =',I5,',  REDUCED ORDER =',I5,
     2       ',  ORTH VCT =',I5,',  NEIG =',I4,',  NZERO =',I4, /5X,
     3       'USER SHIFT =',1P,E16.8,',  INTERNAL SHIFT =',D16.8,
     4       ',  SINGULARITY CHECK ',A4)
  230 IF (ISING .EQ. 0) GO TO 300
C
C     SINGULAR MATRIX. ADJUST LAMBDA
C
      IF (IBK .EQ. 1) GO TO 500
      CNDFLG = CNDFLG + 1
      IF (NODCMP .EQ. 3) GO TO 520
      LAMBDA = 100.0D0*LAMBDA
      GO TO 200
C
C     DETERMINE THE TIME REQUIRED TO COMPLETE FEER PROCESS
C
  300 CALL TMTOGO (T1)
      XM  = MORD
      XMP = NORTHO
      XN  = NORD
      XI  = IFSET
      IFL = MCBLT(1)
      CALL GOPEN (IFL,Z(IBUF1),RDREW)
      NTMS = 0
      DO 310 I = 1,NORD
      II = 0
      CALL UNPACK (*310,IFL,Z(1))
      NTMS = NTMS + NN - II + 1
  310 CONTINUE
      CALL CLOSE (IFL,REW)
      XT = NTMS
      SP = (XT*(1.-XI)*(XM+XMP)+2.*XM) + XN*(2.+XI)*.5*(3.*XM**2+2.*XMP)
     1   + (16.+11.*XI*.5)*XN*XM + 14.*XM**2
C
C     OBTAIN TRIDIAGONAL REDUCTION
C
      NAME(2) = I3
      NAME(3) = IBEGN
      CALL CONMSG (NAME,3,0)
      CALL FEER3
      NAME(3) = IEND
      CALL CONMSG (NAME,3,0)
      IF (CNDFLG .NE. 3) GO TO 330
      CALL PAGE2 (3)
      WRITE  (IO,320) UWM
  320 FORMAT (A25,' 2389', /5X,'PROBLEM SIZE REDUCED - NO MORE TRIAL ',
     1       'VECTORS CAN BE OBTAINED.')
  330 IF (MORD .EQ. 0) GO TO 350
      CALL TMTOGO (T2)
      TIMET = T3 - T1
C
C     OBTAIN EIGENVALUES AND EIGENVECTORS
C
      NAME(2) = I4
      NAME(3) = IBEGN
      CALL CONMSG (NAME,3,0)
      CALL FEER4 (IT)
      NAME(3) = IEND
      CALL CONMSG (NAME,3,0)
      CALL TMTOGO (T3)
      IF (L16 .NE. 0) WRITE (IO,340) T1,T2,T3,SP
  340 FORMAT (' FEER COMPLETE,  T1,T2,T3 =',3I9,',  SP = ',1P,E16.8)
      IF (CNDFLG .NE. 4) GO TO 370
  350 WRITE  (IO,360) UFM
  360 FORMAT (A23,' 2391, PROGRAM LOGIC ERROR IN FEER')
      GO TO 540
  370 IF (MORD+NZERO .GE. NEIG) GO TO 390
      NPR = NEIG - MORD - NZERO
      CALL PAGE2 (3)
      WRITE  (IO,380) UWM,NPR,NEIG
  380 FORMAT (A25,' 2390', /4X,I5,' FEWER ACCURATE EIGENSOLUTIONS THAN',
     1       ' THE',I5,' REQUESTED HAVE BEEN FOUND.')
      CNDFLG = 1
      GO TO 420
  390 IF (MORD+NZERO .EQ. NEIG) GO TO 420
      NPR = MORD + NZERO - NEIG
      CALL PAGE2 (3)
      WRITE  (IO,400) UIM,NPR,NEIG
  400 FORMAT (A29,' 2392', /4X,I5,' MORE ACCURATE EIGENSOLUTIONS THAN ',
     1       'THE',I5,' REQUESTED HAVE BEEN FOUND.')
      IF (L16 .EQ. 0) WRITE (IO,410)
  410 FORMAT (5X,'USE DIAG 16 TO DETERMINE ERROR BOUNDS')
  420 CALL GOPEN (DMPFLE,Z(IBUF1),WRTREW)
C
C    SET IZ(1) TO 2 (FOR INVPWR) THEN IZ(7) TO 1 (POINTS TO FEER METHOD)
C
      IZ(1) = 2
      IZ(2) = MORD + NZERO
      IZ(3) = ITER
      IZ(4) = 0
      IZ(5) = NODCMP
      IZ(6) = NONUL
      IZ(7) = 1
      IZ(8) = CNDFLG
      IZ(9) = 0
      IZ(10)= 0
      IZ(11)= 0
      IZ(12)= 0
      CALL WRITE (DMPFLE,IZ,12,1)
      CALL CLOSE (DMPFLE,REW)
      CRITF = XN*10.0**(-IT)
      NAME(2) = I0
      CALL CONMSG (NAME,3,0)
      RETURN
C
  500 WRITE  (IO,510) UFM
  510 FORMAT (A23,' 2436, SINGULAR MATRIX IN FEER BUCKLING SOLUTION.')
      GO TO 540
  520 WRITE  (IO,530) UFM
  530 FORMAT (A23,' 2386', /5X,'STIFFNESS MATRIX SINGULARITY CANNOT BE',
     1       ' REMOVED BY SHIFTING.')
  540 CALL MESAGE (-37,0,NAME)
      RETURN
      END

      SUBROUTINE BOUND (FBREC,AFE,NAFE,KGE,NKGE)
C
C     COMPUTES AREA FACTOR AND GRAVITIONAL STIFFNESS MATRICES FOR A FACE
C     OF A INDIVIDUAL FLUID ELEMENT
C
      LOGICAL         ERROR    ,GRAV
      INTEGER         GF1      ,GF2      ,GF3      ,GF4      ,FBREC(12),
     1                GS1      ,GS2      ,GS3      ,GS4      ,GRID(3,4),
     2                GSI      ,GSJ      ,IZ(1)    ,LOCSOF(4),LOCTOF(3),
     3                LOCFOS(4),FLEDGE(2,4)        ,FEDGE(2,4)         ,
     4                STEDGE(2,3)
      REAL            Z
      DOUBLE PRECISION          AFE(48)  ,KGE(144) ,IN(3)    ,JN(3)    ,
     1                KN(3)    ,R12(3)   ,R13(3)   ,R14(3)   ,R24(3)   ,
     2                H        ,NN       ,KS(3)    ,MAG      ,X3       ,
     3                Y3       ,Y4       ,S(48)    ,X4       ,AKJ(3,4) ,
     4                AA       ,BB       ,CC       ,A        ,ZZ       ,
     5                DVMAG    ,RHOXG    ,Y(3)     ,E(3,2)   ,KII(144) ,
     6                KTWO(2,2),KIK(9)   ,T(3,3)   ,KTEMP(2,3)         ,
     7                TFST(3,3),Z1       ,X1       ,DHALF    ,C1       ,
     8                ST(3,4)  ,Z2       ,Y1       ,EPS(2)   ,C2       ,
     9                FL(3,4)  ,Z3       ,X2       ,DLB      ,C3       ,
     O                TR(3,3)  ,Z4       ,Y2       ,DUB      ,D1       ,
     1                P(2,7)   ,SS(9)    ,AA2      ,NN1      ,D2       ,
     2                C(4,7)   ,EPSLON   ,FDET     ,ZZ1      ,DZ       ,
     3                F(3,7)   ,NX       ,AKJCON   ,DD       ,AEPS     ,
     4                PT(3,4)  ,TRIA     ,EPSO10   ,AFLEL    ,LEPS     ,
     5                VTEMP(3) ,KSB(3)   ,NZ       ,KIDENT(3),FACTII   ,
     6                CONII    ,FII      ,DPOLY    ,ASTRIA   ,ASTREL   ,
     7                AFLSTR   ,DADOTB   ,DAPOLY
      CHARACTER       UFM*23   ,UWM*25
      COMMON /XMSSG / UFM      ,UWM
C
C     OPEN CORE
C
      COMMON /ZZZZZZ/ Z(1)
C
C     CORE POINTERS
C
      COMMON /FLBPTR/ ERROR    ,ICORE    ,LCORE    ,IBGPDT   ,NBGPDT   ,
     1                ISIL     ,NSIL     ,IGRAV    ,NGRAV
C
C     MATERIAL PROPERTIES
C
      COMMON /MATIN / MATID    ,INFLAG
      COMMON /MATOUT/ DUM(3)   ,RHO
C
C     MODULE PARAMETERS
C
      COMMON /BLANK / NOGRAV
C
C     NASTRAN PARAMETERS
C
      COMMON /SYSTEM/ SYSBUF   ,NOUT
      EQUIVALENCE     (TFST(1,1),IN(1))  ,(X1,FL(1,1))  ,(X2,FL(1,2))  ,
     1                (TFST(1,2),JN(1))  ,(Y1,FL(2,1))  ,(Y2,FL(2,2))  ,
     2                (TFST(1,3),KN(1))  ,(Z1,FL(3,1))  ,(Z2,FL(3,2))  ,
     3                (SS(1),BB)         ,(X3,FL(1,3))  ,(X4,FL(1,4))  ,
     4                (SS(2),CC)         ,(Y3,FL(2,3))  ,(Y4,FL(2,4))  ,
     5                (SS(3),ZZ)         ,(Z3,FL(3,3))  ,(Z4,FL(3,4))  ,
     6                (SS(4),NN)         ,(SS(5),NN1)   ,(SS(6),ZZ1 )  ,
     7                (EPS(1),AEPS)      ,(EPS(2),LEPS) ,(FII,BB    )  ,
     8                (FACTII,CC)        ,(CONII,AKJCON),(Z(1),IZ(1))
C
C     GRID POINTS TO BE USED IN SUBDIVIDING QUADS INTO TRIANGLES
C
      DATA    GRID  /  1     ,2     ,3   ,
     1                 2     ,3     ,4   ,
     2                 3     ,4     ,1   ,
     3                 4     ,1     ,2   /
C
      DATA    DZ, D1,  D2, DHALF / 0.D0,  1.D0, 2.D0, .5D0 /
      DATA    EPSLON,  EPSO10    / 1.D-3, 1.D-4            /
      DATA    DLB   ,  DUB       /-1.D-3, 1.001D0          /
      DATA    X1, X2,  Y1, Y2, Z1, Z2, Z3, Z4 / 8*0.D0     /
C
      DATA    FEDGE /  1,2, 2,3, 3,4, 4,1 /
      DATA    STEDGE/  1,2, 2,3, 3,1      /
      DATA    KIDENT/  0.D0, 0.D0, 1.D0   /
C
C
C     DETERMINE SIZES OF MATRIX PARTITIONS
C
      NGRIDS = 4
      IF (FBREC( 6) .LT. 0) NGRIDS = 3
      NGRIDF = 4
      IF (FBREC(12) .LT. 0) NGRIDF = 3
C
      NROW = 3*NGRIDS
      NAFE = NROW*NGRIDF*2
      NKGE = 0
C
C     OBTAIN MATERIAL PROPERTY AND GRAVITY DATA IF GRAV ID IS
C     PRESENT
C
      GRAV   = .FALSE.
      IF (FBREC(7) .EQ. 0) GO TO 600
      INFLAG = 11
      MATID  = FBREC(8)
      CALL MAT (FBREC(1))
C
      IF (NGRAV .EQ. 0) GO TO 8013
      LGRAV = IGRAV + NGRAV - 1
      DO 200 I = IGRAV,LGRAV,6
      IF (IZ(I) .EQ. FBREC(7)) GO TO 400
  200 CONTINUE
C
      GO TO 8013
C
  400 G     = SQRT(Z(I+3)**2 + Z(I+4)**2 + Z(I+5)**2)
      G     = G*Z(I+2)
      RHOXG = DBLE(RHO)*DBLE(G)
      NKGE  = NROW*NROW*2
      NOGRAV= 1
      GRAV  = .TRUE.
C
C     NORMILIZE THE GRAVITY VECTOR
C
      E(1,2) = DBLE(Z(I+3))
      E(2,2) = DBLE(Z(I+4))
      E(3,2) = DBLE(Z(I+5))
      CALL DNORM (E(1,2),MAG)
      IF (IZ(I+1) .EQ. 0) GO TO 600
C
C     TRANSFORM GRAVITY VECTOR TO BASIC
C
      J = IZ(IBGPDT)
      IZ(IBGPDT) = IZ(I+1)
      CALL TRANSD (IZ(IBGPDT),TR)
      IZ(IBGPDT) = J
      CALL GMMATD (TR,3,3,0,E(1,2),3,1,0,VTEMP)
      DO 500 J = 1,3
  500 E(J,2) = VTEMP(J)
C
C
C     COMPUTE NEW COORDINATES FOR FLUID FACE BASED ON FLUID COORDINATE
C     SYSTEM - PERFORM THIS ONLY IF THE FLUID FACE HAS CHANGED
C     THESE COMPUTATIONS INCLUDE --
C
C        IN,JN,KN  - NORMAL VECTORS TO DEFINE FLUID COORDINATE SYSTEM
C        X2,X3,X4  - X COORDINATES OF GRID POINTS IN NEW SYSTEM
C                    ( X1 = 0 )
C        Y3,Y4       Y COORDINATES OF GRID POINTS IN NEW SYSTEM
C                    ( Y1,Y2 = 0 )
C
C     NORMAL (UNIT) VECTORS STORED *COLUMN-WISE* IN U --
C           I IN U(L,1), J IN U(L,2), K IN U(L,3), L= 1,3
C        TRANSFORMED FLUID COORDINATES STORED IN FL
C
C
C     LOCATE GRID POINTS COORDINATES FOR THE FLUID GRID POINTS IN THE
C     BGPDT TABLE
C
  600 GF1 = IBGPDT + (FBREC( 9)-1)*4
      GF2 = IBGPDT + (FBREC(10)-1)*4
      GF3 = IBGPDT + (FBREC(11)-1)*4
      GF4 = -1
      IF (NGRIDF .EQ. 4) GF4 = IBGPDT + (FBREC(12)-1)*4
C
      IF (NGRIDF .EQ. 4) GO TO 700
C
C     TRIANGULAR FLUID FACE
C
      DO 660 I = 1,3
      R12(I) = Z(GF2+I) - Z(GF1+I)
      IN(I)  = R12(I)
  660 R13(I) = Z(GF3+I) - Z(GF1+I)
C
      CALL DNORM (IN,MAG)
      X2 = MAG
C
      CALL DAXB  (R12,R13,KN)
      CALL DNORM (KN,MAG)
C
      CALL DAXB (KN,IN,JN)
C
      X3 = R13(1)*IN(1) + R13(2)*IN(2) + R13(3)*IN(3)
      Y3 = R13(1)*JN(1) + R13(2)*JN(2) + R13(3)*JN(3)
      GO TO 1000
C
C     QUADRATIC FLUID FACE
C
  700 DO 800 I = 1,3
      R12(I) = Z(GF2+I) - Z(GF1+I)
      R13(I) = Z(GF3+I) - Z(GF1+I)
      R14(I) = Z(GF4+I) - Z(GF1+I)
  800 R24(I) = Z(GF4+I) - Z(GF2+I)
C
      CALL DAXB  (R13,R24,KN)
      CALL DNORM (KN,MAG)
C
      H = R12(1)*KN(1) + R12(2)*KN(2) + R12(3)*KN(3)
C
      DO 900 I = 1,3
  900 IN(I) = R12(I) - H*KN(I)
      CALL DNORM (IN,MAG)
C
      X2 = MAG
C
      CALL DAXB (KN,IN,JN)
C
      X3 = R13(1)*IN(1) + R13(2)*IN(2) + R13(3)*IN(3)
      X4 = R14(1)*IN(1) + R14(2)*IN(2) + R14(3)*IN(3)
      Y3 = R13(1)*JN(1) + R13(2)*JN(2) + R13(3)*JN(3)
      Y4 = R14(1)*JN(1) + R14(2)*JN(2) + R14(3)*JN(3)
C
C     VARIOUS CALCULATIONS DEPENDENT ON FLUID FACE
C
C     INDICES FOR CORNERS OF FLUID ELEMENT
C
 1000 DO 1010 N = 1,2
      DO 1010 J = 1,NGRIDF
 1010 FLEDGE(N,J) = FEDGE(N,J)
      FLEDGE(2,NGRIDF) = 1
C
C     SET UP FOR FLUID TRIANGLE
C
      C1 = (D1 - FL(1,3)/FL(1,2))/FL(2,3)
      C2 = FL(1,3)/(FL(1,2)*FL(2,3))
      DO 1020 N = 1,3
      R12(N) = FL(N,2) - FL(N,1)
 1020 R13(N) = FL(N,3) - FL(N,1)
      CALL DAXB (R12,R13,VTEMP)
C
      IF (NGRIDF .EQ. 3) GO TO 1040
C
C     SET UP FOR FLUID QUADRANGLE
C
      C1  = FL(2,3) - FL(2,4)
      C2  = FL(1,2)*FL(2,4)
      C3  = FL(1,2) - FL(1,3) + FL(1,4)
      AA  =-FL(1,2)*C1
      AA2 = D2*AA
C
      DO 1030 N = 1,3
      R13(N) = FL(N,3) - FL(N,1)
 1030 R24(N) = FL(N,4) - FL(N,2)
      CALL DAXB (R13, R24,VTEMP)
 1040 AFLEL = DVMAG(VTEMP,DZ)
C
C     ZERO OUT AREA FACTOR MATRIX
C     AND AREA COMMON TO FLUID AND STRUCTURE ELEMENTS (AFLSTR)
C
      DO 1042 I = 1,48
      AFE(I) = DZ
 1042 S(I) = 0.0D0
      DO 1044 I = 1,144
 1044 KGE(I) = 0.0D0
      AFLSTR = 0.0
C
C     DETERMINE NUMBER OF STRUCTURAL TRIANGLES TO BE USED, ITRIA
C     AND CUMULATIVE AREA CONSTANT, TRIA
C        ITRIA= 4, TRIA= .5 WHEN STRUCTURE ELEMENT IS QUADRANGLE
C        ITRIA= 1, TRIA= 1. WHEN STRUCTURE ELEMENT IS TRIANGLE
C
      ITRIA = 1
      TRIA  = D1
      IF (NGRIDS .EQ. 3) GO TO 1050
      ITRIA = 4
      TRIA  = DHALF
C
C     TRANSFORM STRUCTURE COORDINATES TO FLUID COORDINATE SYSTEM
C
 1050 GS1 = IBGPDT + (FBREC(3)-1)*4
      GS2 = IBGPDT + (FBREC(4)-1)*4
      GS3 = IBGPDT + (FBREC(5)-1)*4
      GS4 = -1
      IF (NGRIDS .EQ. 4) GS4 = IBGPDT + (FBREC(6)-1)*4
C
      DO 1060 N = 1,3
      PT(N,1) = Z(GS1+N) - Z(GF1+N)
      PT(N,2) = Z(GS2+N) - Z(GF1+N)
      PT(N,3) = Z(GS3+N) - Z(GF1+N)
      PT(N,4) = DZ
      IF (NGRIDS .EQ. 4) PT(N,4) = Z(GS4+N) - Z(GF1+N)
      DO 1060 K = 1,4
      ST(N,K) = DZ
 1060 CONTINUE
C
      DO 1070 K = 1,NGRIDS
      DO 1070 N = 1,3
      DO 1070 M = 1,3
 1070 ST(N,K) =  ST(N,K) + PT(M,K)*TFST(M,N)
      DO 1075 N = 1,2
      R12(N) = ST(N,2) - ST(N,1)
      R13(N) = ST(N,3) - ST(N,1)
      IF (NGRIDS .EQ. 4) R24(N) = ST(N,4) - ST(N,2)
 1075 CONTINUE
      CALL DAXB (R12,R13,VTEMP)
      IF (NGRIDS .EQ. 4) CALL DAXB (R12,R24,VTEMP)
      ASTREL = DVMAG(VTEMP,DZ)
      AEPS   = DHALF*DMIN1(AFLEL,ASTREL)
      LEPS   = DZ
      IF (AEPS .GT. DZ) LEPS = EPSLON*DSQRT(AEPS)
      AEPS   = EPSLON*AEPS
C
C     LOCATE STRUCTURE ELEMENT GRIDS RELATIVE TO FLUID SURFACE
C     LOCSOF FLAGS STRUCTURE ON FLUID:
C            1= INSIDE, -1= OUTSIDE, 0= ON FLUID EDGE
C
      CALL LOCPT (NGRIDS,ST,NGRIDF,FL,FLEDGE,KIDENT,EPS,LOCSOF)
C
C
C     LOOP THRU (INCREMENTAL) STRUCTURAL TRIANGLES (ITRIA IS 1 OR 4)
C
      DO 2500 IT = 1,ITRIA
C
C     LOCATE COORDINATES OF CURRENT TRIANGLE
C
      GS1 = GRID(1,IT)
      GS2 = GRID(2,IT)
      GS3 = GRID(3,IT)
C
      LOCTOF(1) = LOCSOF(GS1)
      LOCTOF(2) = LOCSOF(GS2)
      LOCTOF(3) = LOCSOF(GS3)
C
C     TRANSFER COORDINATES OF CURRENT STRUCTURE TRIANGLE TO CONTIGUOUS
C     ARRAY, AND DO VARIOUS CALCULATIONS DEPENDENT ON THEM
C
      DO 1100 N = 1,3
      TR(N,1) = ST(N,GS1)
      TR(N,2) = ST(N,GS2)
      TR(N,3) = ST(N,GS3)
      R12(N)  = TR(N,2) - TR(N,1)
 1100 R13(N)  = TR(N,3) - TR(N,1)
C
C     OBTAIN KS, UNIT VECTOR NORMAL TO (XY) PLANE OF CURRENT STRUCTURAL
C     TRIANGLE (IN SYSTEM LOCAL TO FLUID ELEMENT)
C
      CALL DAXB (R12,R13,KS)
      ASTRIA = DVMAG(KS,DZ)
      CALL DNORM (KS,MAG)
C
C     OBTAIN KSB, UNIT VECTOR NORMAL TO (XY) PLANE OF CURRENT STRUCTURE
C     TRIANGLE (IN NASTRAN BASIC COORD SYSTEM)
C
      DO 1150 N = 1,3
      R12(N) = PT(N,GS2) - PT(N,GS1)
      R13(N) = PT(N,GS3) - PT(N,GS1)
 1150 CONTINUE
C
      CALL DAXB  (R12,R13,KSB)
      CALL DNORM (KSB,MAG)
C
C     CALCULATE EPSLON FUNCTIONS FOR SIGNIFICANCE TESTING
C
      LEPS = DZ
      AEPS = DHALF*DMIN1(AFLEL,ASTRIA)*EPSLON
      IF (AEPS .GT. DZ)  LEPS = DSQRT(AEPS)
C
C     DETERMINE POINTS DESCRIBING AREA POLYGON COMMON TO BOTH FLUID
C     ELEMENT AND (INCREMENTAL) STRUCTURAL TRIANGLE
C
C        POLYGON POINTS IN   P(2,I)    I .LE. 7
C        FLUID POINTS IN     FL(3,J)   J .LE. 4
C        TRIANGLE POINTS IN  TR(3,K)   K=1,3
C
C     DETERMINE POINTS DESCRIBING POLYGON OF COMMON AREA
C
C
C     LOCATE FLUID ELEMENT POINTS RELATIVE TO BOUNDRY OF THIS STRUCTURAL
C     TRIANGLE
C
      CALL LOCPT (NGRIDF,FL,3,TR,STEDGE,KS,EPS,LOCFOS)
      DO 1240 J = 1,NGRIDF
      IF (LOCFOS(J) .LT. 0) GO TO 1300
 1240 CONTINUE
C
C     FLUID ELEMENT IS COMMON AREA POLYGON WHEN NO FLUID POINTS ARE
C     OUTSIDE BOUNDRY OF THIS STRUCTURAL TRIANGLE
C
      NPOLY = NGRIDF
      DO 1250 N = 1,2
      DO 1250 J = 1,NGRIDF
 1250 P(N,J) = FL(N,J)
      GO TO 2000
C
C     CALL POLYPT TO DETERMINE POINTS DESCRIBING THE COMMON AREA POLYGON
C
 1300 CALL POLYPT (LOCTOF,STEDGE,TR,NGRIDF,FLEDGE,FL,LOCFOS,EPS,NPOLY,P)
C
C     SKIP TO NEXT (INCREMENTAL) STRUCTURAL TRIANGLE WHEN THIS TRIANGLE
C     IS DISJOINT FROM FLUID ELEMENT
C
      IF (NPOLY .LT. 3) GO TO 2500
C
C     AREA OF COMMON POLYGON AND HALVED WHEN OVERLAPPING (INCREMENTAL)
C     STRUCTURE TRIANGLES USED CUMULATIVE AREA OF FLUID/STRUCTURAL
C     ELEMENT OVERLAP
C
 2000 A = TRIA*DAPOLY(NPOLY,P)
      AFLSTR = AFLSTR + A
C
C     TERMS FOR LOAD FACTORS
C
      SS(1) =  TR(1,1)*TR(2,2)
      SS(2) = -TR(1,1)*TR(2,3)
      SS(3) =  TR(1,2)*TR(2,3)
      SS(4) = -TR(1,2)*TR(2,1)
      SS(5) =  TR(1,3)*TR(2,1)
      SS(6) = -TR(1,3)*TR(2,2)
      FDET  =  DZ
      DO 2005 M = 1,6
 2005 FDET  =  FDET  + SS(M)
      SS(1) =  SS(1) + SS(4)
      SS(2) =  SS(2) + SS(5)
      SS(3) =  SS(3) + SS(6)
      SS(4) =  TR(2,2) - TR(2,3)
      SS(5) =  TR(2,3) - TR(2,1)
      SS(6) =  TR(2,1) - TR(2,2)
      SS(7) =  TR(1,3) - TR(1,2)
      SS(8) =  TR(1,1) - TR(1,3)
      SS(9) =  TR(1,2) - TR(1,1)
C
C     GET LOAD DISTRIBUTION FACTORS, F(K,I)
C     - FROM -
C         I -- AREA POLYGON POINT -- P(N,I)
C         K -- STRUCTURE TRIANGLE POINT -- TR(N,K)
C
      DO 2010 I = 1,NPOLY
      F(1,I) = P(1,I)*SS(4) + P(2,I)*SS(7) + SS(3)
      F(2,I) = P(1,I)*SS(5) + P(2,I)*SS(8) + SS(2)
 2010 F(3,I) = P(1,I)*SS(6) + P(2,I)*SS(9) + SS(1)
C
C     GET PRESSURE DISTRIBUTION FACTORS, C(J,I)
C     - FROM -
C         I -- AREA POLYGON POINT  -- P(N,I)
C         J -- FLUID ELEMENT POINT -- FL(N,J)
C
      IF (NGRIDF .EQ. 4) GO TO 2030
C
C     FLUID ELEMENT IS TRIANGLE
C
      DO 2020 I = 1,NPOLY
      BB     = P(1,I)/FL(1,2)
      C(1,I) = D1 - BB - P(2,I)*C1
      C(2,I) = BB - P(2,I)*C2
 2020 C(3,I) = P(2,I)/FL(2,3)
      GO TO 2100
C
C     FLUID ELEMENT IS QUADRANGLE
C
 2030 DO 2050 I = 1,NPOLY
      BB = P(1,I)*C1 - C2 + P(2,I)*C3
      CC = P(1,I)*FL(2,4) - P(2,I)*FL(1,4)
      IF (BB.EQ.DZ .OR. DABS(AA).GT.DABS(BB*EPSLON)) GO TO 2040
      ZZ = -CC/BB
      GO TO 2045
C
 2040 DD = DSQRT(BB*BB - D2*AA2*CC)
      ZZ = (DD-BB)/AA2
      IF (ZZ.GT.DLB .AND. ZZ.LT.DUB) GO TO 2045
      ZZ = (-DD-BB)/AA2
C
 2045 NN = P(2,I)/(FL(2,4) + ZZ*C1)
      IF (NN.LE.DLB .OR. NN.GE.DUB) GO TO 8005
C
      ZZ1 = D1 - ZZ
      NN1 = D1 - NN
      C(1,I) = ZZ1*NN1
      C(2,I) = ZZ *NN1
      C(3,I) = ZZ *NN
 2050 C(4,I) = ZZ1*NN
C
C     CALCULATE AREA TERMS FOR THIS STRUCTURAL TRIANGLE AND INSERT IN
C     MATRIX
C
 2100 DPOLY  = NPOLY
      AKJCON = A/(FDET*DPOLY)
      DPOLY  = NPOLY - 1
      FACTII = D1/DPOLY
C
      DO 2120 J = 1,NGRIDF
      JLOC = 3*NGRIDS*(J-1)
C
      DO 2120 K = 1,3
      LOC = JLOC + 3*(GRID(K,IT)-1)
C
      AKJ(K,J) = DZ
      DO 2110 I = 1,NPOLY
 2110 AKJ(K,J) = AKJ(K,J) + F(K,I)*C(J,I)
      AKJ(K,J) = AKJCON*AKJ(K,J)
C
      DO 2119 N = 1,3
 2119 S(LOC+N) = S(LOC+N) + AKJ(K,J)*KSB(N)
 2120 CONTINUE
C
      IF (.NOT. GRAV) GO TO 2500
C
C     CALCULATE GRAVITATIONAL STIFFNESS TERMS FOR THIS TRIANGLE
C     AND INSERT INTO MATRIX
C
      DO 2210 N = 1,3
 2210 E(N,1) = DZ
      CALL DAXB (E(1,2),KSB,Y)
      MAG = DADOTB(Y,Y)
      IF (MAG .GT. DZ) MAG = DSQRT(MAG)
      IF (MAG .LT. EPSO10) GO TO 2220
C
      CALL DAXB  (E(1,2),Y,E)
      CALL DNORM (E,MAG)
C
 2220 NX = 0.D0
      NZ = 0.D0
      DO 2230 N = 1,3
      NX = NX + E(N,1)*KSB(N)
 2230 NZ = NZ + E(N,2)*KSB(N)
      CONII = RHOXG*AKJCON/(D2*FDET)
      KTWO(1,1) = DZ
C
      KTWO(2,1) = NX
      KTWO(1,2) = KTWO(2,1)
      KTWO(2,2) = NZ
      CALL GMMATD (E,2,3,1, KTWO,2,2,0, KTEMP)
      CALL GMMATD (KTEMP,3,2,0, E,2,3,0, KIK )
C
      DO 2250 KK1 = 1,3
      K1LOC = 9*NGRIDS*(GRID(KK1,IT)-1)
C
      DO 2250 KK2 = 1,3
      LOC = K1LOC + 9*(GRID(KK2,IT)-1)
C
      H = 0.D0
      DO 2240 I1 = 1,NPOLY
      DO 2240 I2 = 1,NPOLY
      FII = F(KK1,I1)*F(KK2,I2)
      IF (I1 .NE. I2) FII= FACTII*FII
 2240 H = H + FII
C
      DO 2249 N = 1,9
      KGE(LOC+N) = KGE(LOC+N) - KIK(N)*H*CONII
 2249 CONTINUE
C
 2250 CONTINUE
C
C     END OF (INCREMENTAL) STRUCTURAL TRIANGLE LOOP
C
 2500 CONTINUE
C
C     WARNING MESSAGE WHEN FLUID AND STRUCTURE ELEMENTS ARE DISJOINT
C
      IF (AFLSTR .LE. DZ) GO TO 8014
C
C     TRANSFORM THE AREA AND STIFFNESS MATRICES TO GLOBAL COORDINATES IF
C     REQUIRED
C
      DO 2610 IROW = 1,NGRIDS
      GSI = IBGPDT + (FBREC(IROW+2)-1)*4
      CALL TRANSD (Z(GSI),T)
C
C     AREA FACTOR MATRIX
C
      JLOC = 3*(IROW-1)
C
      DO 2530 ICOL = 1,NGRIDF
      ILOC = 3*NGRIDS*(ICOL-1) + JLOC
C
      IF (IZ(GSI) .EQ. 0) GO TO 2510
      CALL GMMATD (T,3,3,1,S(ILOC+1),3,1,0,AFE(ILOC+1))
      GO TO 2530
C
 2510 DO 2520 I = 1,3
 2520 AFE(ILOC+I) = S(ILOC+I)
C
 2530 CONTINUE
      IF (.NOT.GRAV) GO TO 2610
C
C     GRAVITATIONAL STIFFNESS MATRIX
C
      JLOC = 9*(IROW-1)
C
      DO 2600 ICOL = 1,NGRIDS
      ILOC = 9*NGRIDS*(ICOL-1) + JLOC
C
      IF (IZ(GSI) .EQ. 0) GO TO 2540
      CALL GMMATD (T,3,3,1, KGE(ILOC+1),3,3,0, KIK)
      GO TO 2570
C
 2540 KLOC = ILOC
      DO 2550 I = 1,9
 2550 KIK(I) = KGE(KLOC+I)
C
 2570 GSJ = IBGPDT + (FBREC(ICOL+2)-1)*4
      IF (IZ(GSJ) .EQ. 0) GO TO 2580
      CALL TRANSD (Z(GSJ),T)
      CALL GMMATD (KIK,3,3,0, T,3,3,0, KII(ILOC+1))
      GO TO 2600
C
 2580 KLOC = ILOC
      DO 2590 I = 1,9
 2590 KII(KLOC+I) = KIK(I)
 2600 CONTINUE
 2610 CONTINUE
C
C     REARANGE THE STORAGE OF THE GRAVITATIONAL STIFFNESS MATRIX
C     TO COLUMNWISE FOR THE USE WITH THE ASSEMBLER
C
      IF (.NOT.GRAV) RETURN
C
      DO 2630 ICOL = 1,NGRIDS
      JLOC = 9*NGRIDS*(ICOL-1)
C
      DO 2630 IROW = 1,NGRIDS
      ILOC = JLOC + 9*(IROW-1)
      KLOC = JLOC + 3*(IROW-1)
C
      DO 2620 I = 1,3
      KGE(KLOC+1) = KII(ILOC+1)
      KGE(KLOC+2) = KII(ILOC+4)
      KGE(KLOC+3) = KII(ILOC+7)
      KLOC = KLOC + 3*NGRIDS
 2620 ILOC = ILOC + 1
 2630 CONTINUE
      RETURN
C
C     ERROR CONDITIONS
C
 8005 WRITE (NOUT,9005) UFM,FBREC(2)
      ERROR = .TRUE.
      GO TO 9000
 8013 WRITE (NOUT,9013) UFM,FBREC(1),FBREC(7)
      ERROR = .TRUE.
      GO TO 9000
 8014 WRITE (NOUT,9014) UWM,FBREC(1),FBREC(2)
 9000 RETURN
C
 9005 FORMAT (A23,' 8005. BAD GEOMETRY DEFINED FOR STRUCTURAL ELEMENT ',
     1       I8)
C
 9013 FORMAT (A23,' 8013, FLUID ELEMENT',I9,' ON A CFLSTR CARD ',
     1       'REFERENCES UNDEFINED GRAVITY ID',I9)
C
 9014 FORMAT (A25,' 8014, FLUID ELEMENT',I9,' AND STRUCTURE ELEMENT',I9,
     1       ' ARE DISJOINT. CHECK CFLSTR CARDS.')
      END

        SUBROUTINE GETSTR ( *, BLOCK )
      INCLUDE 'DSIOF.COM'
      INCLUDE 'XNSTRN.COM'
        INTEGER BLOCK( 15 )
        IRETRN = 0
        NAME   = BLOCK( 1 )
        CALL DSGEFL
        IF ( BLOCK( 8 ) .NE. -1 ) GO TO 100
10      IF ( ( INDCLR-INDBAS+1 ) .GT. LCW ) CALL DSMSG( 113 )
        ID = IAND( IBASE( INDCLR ), MASKQ1 )
        IF ( ID .EQ. IDSSB ) GO TO 30
        IF ( ID .EQ. IDSEB ) GO TO 20
        CALL DSMSG ( 110 )
20      CALL DSRDNB
        GO TO 10
30      ID = IAND( IBASE( INDCBP+1 ), MASKQ1 )
        IF ( ID .EQ. IDSCH ) GO TO 40
        CALL DSMSG1( BLOCK )
        CALL DSMSG( 111 )
40      CONTINUE
        INDCBP = INDCBP + 1
        CALL DSPRCL( BLOCK )
        INDCBP = INDCBP + 2
        BLOCK( 8 ) = 0
100     ID = IAND( IBASE( INDCBP ), MASKQ1 )
        INDCBP = INDCBP + 1
        IF ( ID .EQ. IDSSH ) GO TO 130
        IF ( ID .EQ. IDSSD ) GO TO 100
        IF ( ID .EQ. IDSCT ) GO TO 120
        IF ( ID .EQ. IDSSE ) GO TO 110
        IF ( ID .EQ. IDSRT ) GO TO 110
        CALL DSMSG ( 112 )
110     CALL DSRDNB
        INDCBP = INDCBP + 1
        GO TO 100
120     CALL DSSKRC
        BLOCK( 6 ) = 0
        BLOCK( 8 ) = 1
        IRETRN     = 1
        GO TO 7000
130     BLOCK( 4 ) = IBASE( INDCBP )
        BLOCK( 6 ) = IAND( IBASE( INDCBP-1 ), MASKH2 )
        INDCBP     = INDCBP + 1
        BLOCK( 5 ) = ( INDCBP-1 ) / BLOCK( 14 ) + 1
7000    CALL DSSDCB
        IF ( IRETRN .EQ. 1 ) RETURN 1
        RETURN
        END

      SUBROUTINE TRAPAX
C
C     THIS SUBROUTINE CALCULATES THE STIFFNESS AND MASS MATRICES FOR THE
C     ASSYMETRIC RING ELEMENT WITH A TRAPEZOIDAL CROSS SECTION
C
C     SINGLE PRECISION VERSION
C
C     ECPT FOR THE TRAPAX ELEMENT
C
C     ECPT ( 1) = ELEMENT ID                                I
C     ECPT ( 2) = SIL A                                     I
C     ECPT ( 3) = SIL B                                     I
C     ECPT ( 4) = SIL C                                     I
C     ECPT ( 5) = SIL D
C     ECPT ( 6) = MATERIAL ORIENTATION ANGLE(DEGREES)       R
C     ECPT ( 8) = MATERIAL ID                               I
C     ECPT ( 9) TO ECPT (22) FOR PHI
C     ECPT (23) = COOR. SYS. FOR GRID POINT A               I
C     ECPT (24) = X-COOR. OF GRID POINT A (IN BASIC COOR)   R
C     ECPT (25) = Z-COOR. OF GRID POINT A (IN BASIC COOR)   R
C     ECPT (26) = 0.0
C     ECPT (27) = COOR. SYS. FOR GRID POINT B
C     ECPT (28) = X-COOR. OF GRID POINT B (IN BASIC COOR)   R
C     ECPT (29) = Z-COOR. OF GRID POINT B (IN BASIC COOR)   R
C     ECPT (30) = 0.0
C     ECPT (31) = COOR. SYS. FOR GRID POINT C               I
C     ECPT (32) = X-COOR. FOR GRID POINT C                  R
C     ECPT (33) = Z-COOR. FOR GRID POINT C                  R
C     ECPT (34) = 0.0
C     ECPT (35) = COOR. SYS. FOR GRID POINT D               I
C     ECPT (36) = X-COOR FOR GRID POINT D                   R
C     ECPT (37) = Z-COOR FOR GRID POINT D                   R
C     ECPT (38) = 0.0
C     ECPT (39) = EL. TEMPERATURE FOR MATERIAL PROP         R
C
C     ANY GROUP OF STATEMENTS PREFACED BY AN IF STATEMENT CONTAINING
C     ...KSYS78 OR LSYS78 ...  INDICATES CODING NECESSARY FOR THIS
C     ELEMENT*S PIEZOELECTRIC CAPABILITY
C
C     KSYS78 = 0   ELASTIC, NON-PIEZOELECTRIC MATERIAL
C     KSYS78 = 1   ELECTRICAL-ELASTIC COUPLED, PIEZOELETRIC MATERIAL
C     KSYS78 = 2   ELASTIC ONLY, PIEZOELECTRIC MATERIAL
C     LSYS78 = .TRUE. IF KSYS78 = 0, OR 2
C
      LOGICAL         PZMAT,LSYS78,IHEAT,NOGO
      INTEGER         ELID,ESTID,DICT(14),IPART(4)
      REAL            BMASS(12,12),BMBSS(144)
      REAL            ECPT(20),R(4),Z(4),DELINT(12),EE(63),TEO(45),
     1                SP(36),GB(12,12),GBP(4,4)
      DIMENSION       ACURL(208),D(144),AK(144),AKJ(256),ICS(4),
     1                IECPT(39),D1(48),D2(16),ACURP1(48),ACURP2(16),
     2                AKUPH(48),AKPH2(16)
C     DIMENSION       AKT(27)
      COMMON /SYSTEM/ KSYSTM(77),KSYS78,KDUM2(2),IHEAT
      COMMON /EMGPRM/ DUM(15),ISMB(3),IPREC,NOGO,HEAT,ICMBAR
      COMMON /EMGDIC/ IDM,LDICT,NGRIDS,ELID,ESTID
      COMMON /EMGEST/ IDEL,IGP(4),DGAMA,GAM,MATID,IPHI(13),CSDAT(16),
     1                TEMPE
      COMMON /CONDAS/ PI,TWOPI,XQ,DEGRAD
      COMMON /MATIN / MATIDC,MATFLG,ELTEMP,STRESS,SINTH,COSTH
      COMMON /MATOUT/ E(3),ANU(3),RHO,G(3),ALF(3),TZERO,GSUBE,MOSKP(9),
     1                SETMAT
      COMMON /MATPZ / PZOUT(51)
C     COMMON /MATPZ / CE11,CE12,CE13,CE14,CE15,CE16,CE22,CE23,CE24,CE25,
C                     CE26,CE33,CE34,CE35,CE36,CE44,CE45,CE46,CE55,CE56,
C                     CE66,E11,E12,E13,E14,E15,E16,E21,E22,E23,E24,E25,
C                     E26,E31,E32,E33,E34,E35,E36,EPS11,EPS12,EPS13,
C                     EPS22,
      EQUIVALENCE     (KSYSTM(2),IOUT),(ECPT(1),IECPT(1),IDEL),
     1                (BMASS(1,1),ACURL(1),BMBSS(1)),(DICT5,DICT(5)),
     2                (ACURP1(1),ACURL(145)),(ACURP2(1),ACURL(193))
      DATA    IDEL2 , JAX /    0,   4HTRAP  /
C
      LSYS78 = .FALSE.
      IF (KSYS78.EQ.0 .OR. KSYS78.EQ.2) LSYS78 = .TRUE.
      IDEL1 = IDEL/1000
      ISORT = 0
      MASOR = 0
C
C     IF STIFFNESS MATRIX NOT NEEDED GO CALCULATE MASS MATRIX
C
      DO 50 I = 1,4
      ICS(I) = IECPT(4*I+19)
      R(I) = ECPT(4*I+20)
      Z(I) = ECPT(4*I+21)
   50 D(I) = ECPT(4*I+22)
C
C     TEST THE VALIDITY OF THE GRID POINT COORDINATES
C     NOTE THAT INTEGRATION ROUTINE FAILS FOR R = 0.0
C
      DO 200 I = 1,4
      IF (R(I) .LE. 0.) GO TO 7770
      IF (D(I) .NE. 0.) GO TO 7770
  200 CONTINUE
C
C     COMPUTE THE ELEMENT COORDINATES
C
      ZMIN = AMIN1(Z(1),Z(2),Z(3),Z(4))
      DO 120 I = 1,4
  120 Z(I) = Z(I) - ZMIN
C
C     FATAL IF RATIO OF RADII IS TO LARGE FOR GUASS QUADRATURE
C
      RMIN = AMIN1(R(1),R(2),R(3),R(4))
      RMAX = AMAX1(R(1),R(2),R(3),R(4))
      IF (RMIN .EQ. 0.0) GO TO 206
      IF (RMAX/RMIN .GT. 10.) GO TO 7760
C
  206 IF (R(1).GE.R(2) .OR. R(4).GE.R(3) .OR. Z(4).LE.Z(1)) GO TO 7770
      IF (ABS(Z(1)-Z(2)) .GT. .001) GO TO 7770
      IF (ABS(Z(3)-Z(4)) .GT. .001) GO TO 7770
      D(5) = (R(1)+R(4))/2.
      D(6) = (R(2)+R(3))/2.
      IF (D(5) .EQ. 0.0) GO TO 210
      IF (ABS((R(1)-R(4))/D(5)) .GT. .005) GO TO 210
      R(1) = D(5)
      R(4) = D(5)
  210 CONTINUE
      IF (D(6) .EQ. 0.0) GO TO 220
      IF (ABS((R(2)-R(3))/D(6)) .GT. .005) GO TO 220
      R(2) = D(6)
      R(3) = D(6)
  220 CONTINUE
C
C     FORM THE TRANSFORMMATION MATRIX(12X12) FROM FIELD COOR, TO GRID
C     POINT DEGREES OF FREEDOM
C
      DO 300 I = 1,144
  300 GB( I, 1) = 0.
      GB( 1, 1) = 1.
      GB( 2, 1) = R(1)
      GB( 3, 1) = Z(1)
      GB( 4, 1) = R(1)*Z(1)
      GB( 5, 2) = 1.
      GB( 6, 2) = R(1)
      GB( 7, 2) = Z(1)
      GB( 8, 2) = GB(4,1)
      GB( 9, 3) = 1.
      GB(10, 3) = R(1)
      GB(11, 3) = Z(1)
      GB(12, 3) = GB(4,1)
      GB( 1, 4) = 1.
      GB( 2, 4) = R(2)
      GB( 3, 4) = Z(2)
      GB( 4, 4) = R(2)*Z(2)
      GB( 5, 5) = 1.
      GB( 6, 5) = R(2)
      GB( 7, 5) = Z(2)
      GB( 8, 5) = GB(4,4)
      GB( 9, 6) = 1.
      GB(10, 6) = R(2)
      GB(11, 6) = Z(2)
      GB(12, 6) = GB(4,4)
      GB( 1, 7) = 1.
      GB( 2, 7) = R(3)
      GB( 3, 7) = Z(3)
      GB( 4, 7) = R(3)*Z(3)
      GB( 5, 8) = 1.
      GB( 6, 8) = R(3)
      GB( 7, 8) = Z(3)
      GB( 8, 8) = GB(4,7)
      GB( 9, 9) = 1.
      GB(10, 9) = R(3)
      GB(11, 9) = Z(3)
      GB(12, 9) = GB(4,7)
      GB( 1,10) = 1.
      GB( 2,10) = R(4)
      GB( 3,10) = Z(4)
      GB( 4,10) = R(4)*Z(4)
      GB( 5,11) = 1.
      GB( 6,11) = R(4)
      GB( 7,11) = Z(4)
      GB( 8,11) = GB(4,10)
      GB( 9,12) = 1.
      GB(10,12) = R(4)
      GB(11,12) = Z(4)
      GB(12,12) = GB(4,10)
C
      IF (LSYS78) GO TO 305
      GBP(1,1) = 1.0
      GBP(2,1) = R(1)
      GBP(3,1) = Z(1)
      GBP(4,1) = R(1)*Z(1)
      GBP(1,2) = 1.0
      GBP(2,2) = R(2)
      GBP(3,2) = Z(2)
      GBP(4,2) = R(2)*Z(2)
      GBP(1,3) = 1.0
      GBP(2,3) = R(3)
      GBP(3,3) = Z(3)
      GBP(4,3) = R(3)*Z(3)
      GBP(1,4) = 1.0
      GBP(2,4) = R(4)
      GBP(3,4) = Z(4)
      GBP(4,4) = R(4)*Z(4)
  305 CONTINUE
C
      IF (ISMB(1) .EQ. 0) GO TO 800
C
C     NO NEED TO COMPUTE DETERMINANT SINCE IT IS NOT USED SUBSEQUENTLY
C
      ISING = -1
      CALL INVERS (12,GB,12,D(10),0,D(11),ISING,SP)
      IF (ISING .EQ. 2) GO TO 7790
C
      IF (KSYS78 .EQ. 1) CALL INVERS (4,GBP,4,D(10),0,D(11),ISING,SP)
      IF (ISING  .EQ. 2) GOTO 7790
      IF (NOGO) RETURN
C
C     DELINT(01) = (-1,0)
C     DELINT(02) = (-1,1)
C     DELINT(03) = (-1,2)
C     DELINT(04) = ( 0,0)
C     DELINT(05) = ( 0,1)
C     DELINT(06) = ( 0,2)
C     DELINT(07) = ( 1,0)
C     DELINT(08) = ( 1,1)
C     DELINT(09) = ( 1,2)
C     DELINT(10) = ( 2,0)
C     DELINT(11) = ( 2,1)
C     DELINT(12) = ( 3,0)
C
      I1 = 0
      DO 400 I = 1,4
      IP = I - 2
      DO 350 J = 1,3
      IQ = J - 1
      I1 = I1 + 1
      IF (I1 .NE. 12)  GO TO 340
      IP = 3
      IQ = 0
  340 CONTINUE
      DELINT(I1) = RZINTS(IP,IQ,R,Z,4)
  350 CONTINUE
  400 CONTINUE
C
C     LOCATE THE MATERIAL PROPERTIES IN THE MAT1 OR MAT3
C
      MATIDC = MATID
      MATFLG = 7
      IF (KSYS78 .GT. 0) MATFLG = 9
      ELTEMP = TEMPE
C
      GAMR   = DGAMA*DEGRAD
      COSG   = COS(GAMR)
      SING   = SIN(GAMR)
      SINTH  = SING
      COSTH  = COSG
      CALL MAT (IDEL)
      PZMAT  = .FALSE.
      IF (SETMAT.EQ.4. .OR. SETMAT.EQ.5.) PZMAT = .TRUE.
      IF (PZMAT) GO TO 410
      KSAVE  = KSYS78
      KSYS78 = 0
      LSYS78 = .TRUE.
      GO TO 420
  410 RHO    = PZOUT(46)
      ALF(1) = PZOUT(47)
      ALF(2) = PZOUT(48)
      ALF(3) = PZOUT(49)
      TZERO  = PZOUT(50)
      GSUBE  = PZOUT(51)
  420 CONTINUE
C
      IF (SETMAT .EQ. 2.) GO TO 7780
CWKBI SPR94002 5/94
      DICT5 = GSUBE
      IF (KSYS78 .GT.  0) GO TO 500
      V   = ANU(1)*E(2)/E(1)
      VZ  = ANU(2)*E(3)/E(2)
      VR  = ANU(3)*E(1)/E(3)
      DEL = 1./(1. - V*ANU(1)  - VZ *ANU(2)- VR*ANU(3) - ANU(1)*ANU(2)*
     1      ANU(3) - V*VZ*VR )
C
C     COMPUTE ELASTIC CONSTANTS MATRIX FROM MATERIAL TO ELEMENT AXIS
C
  500 CONTINUE
      DO 510 I = 1,45
  510 TEO(I) = 0.
C
      IF (KSYS78 .GT. 0) GO TO 520
      TEO( 1) = E(1)*(1. - ANU(2)*VZ)*DEL
      TEO( 2) = E(1)*(ANU(3) + VZ*V)*DEL
      TEO( 3) = E(3)*(1. - ANU(1)*V)*DEL
      TEO( 4) = E(1)*(V  + ANU(3)*ANU(2))*DEL
      TEO( 5) = E(2)*(VZ + ANU(1)*ANU(3))*DEL
      TEO( 6) = E(2)*(1. - VR*ANU(3))*DEL
      TEO(10) = G(3)
      TEO(15) = G(1)
      TEO(21) = G(2)
      GO TO 530
  520 CONTINUE
C
C     PIEZOELECTRIC MATERIAL PROPERTIES STORED IN TEO(22-39)
C     DIELECTRIC MATERIAL PROPERTIES STORED IN TEO(40-45)
C     TEO(22-39) CONTAINS E-TRANSPOSE
C
      TEO( 1) = PZOUT( 1)
      TEO( 2) = PZOUT( 2)
      TEO( 3) = PZOUT( 7)
      TEO( 4) = PZOUT( 3)
      TEO( 5) = PZOUT( 8)
      TEO( 6) = PZOUT(12)
      TEO( 7) = PZOUT( 4)
      TEO( 8) = PZOUT( 9)
      TEO( 9) = PZOUT(13)
      TEO(10) = PZOUT(16)
      TEO(11) = PZOUT( 5)
      TEO(12) = PZOUT(10)
      TEO(13) = PZOUT(14)
      TEO(14) = PZOUT(17)
      TEO(15) = PZOUT(19)
      TEO(16) = PZOUT( 6)
      TEO(17) = PZOUT(11)
      TEO(18) = PZOUT(15)
      TEO(19) = PZOUT(18)
      TEO(20) = PZOUT(20)
      TEO(21) = PZOUT(21)
      IF (KSYS78 .EQ. 2) GO TO 530
      TEO(22) = PZOUT(22)
      TEO(23) = PZOUT(28)
      TEO(24) = PZOUT(34)
      TEO(25) = PZOUT(23)
      TEO(26) = PZOUT(29)
      TEO(27) = PZOUT(35)
      TEO(28) = PZOUT(24)
      TEO(29) = PZOUT(30)
      TEO(30) = PZOUT(36)
      TEO(31) = PZOUT(25)
      TEO(32) = PZOUT(31)
      TEO(33) = PZOUT(37)
      TEO(34) = PZOUT(26)
      TEO(35) = PZOUT(32)
      TEO(36) = PZOUT(38)
      TEO(37) = PZOUT(27)
      TEO(38) = PZOUT(33)
      TEO(39) = PZOUT(39)
      TEO(40) =-PZOUT(40)
      TEO(41) =-PZOUT(41)
      TEO(42) =-PZOUT(42)
      TEO(43) =-PZOUT(43)
      TEO(44) =-PZOUT(44)
      TEO(45) =-PZOUT(45)
  530 CONTINUE
C
C     MATRIX EG STORED AS FOLLOWS IN EE
C       1
C      2  3
C      4  5  6
C      7  8  9 10
C     11 12 13 14 15
C     16 17 18 19 20 21
C
      C2  = COSG*COSG
      S2  = SING*SING
      C4  = C2*C2
      S4  = S2*S2
      C2S2= C2*S2
      C3  = COSG*C2
      S3  = SING*S2
      CS2 = COSG*S2
      SC2 = SING*C2
      CS  = COSG*SING
C
      EE( 1) = TEO(1)*C4 + TEO(3)*S4 + 2.*C2S2*(TEO(2)+2.*TEO(10))
      EE( 2) = TEO(2)*(C4+S4) + C2S2*(TEO(1)+TEO(3)-4.0D0*TEO(10))
      EE( 3) = TEO(1)*S4 + 2.*C2S2*(TEO(2) + 2.*TEO(10))
     3       + TEO(3)*C4
      EE( 4) = TEO(4)*C2 + TEO(5)*S2
      EE( 5) = TEO(4)*S2 + TEO(5)*C2
      EE( 6) = TEO(6)
      EE( 7) = COSG*SING*S2*(TEO(2)-TEO(3)+2.*TEO(10))
     7       + SING*COSG*C2*(TEO(1)-TEO(2)-2.*TEO(10))
      EE( 8) = SING*COSG*C2*(TEO(2)-TEO(3)+2.*TEO(10))
     8       + COSG*SING*S2*(TEO(1)-TEO(2)-2.*TEO(10))
      EE( 9) = SING*COSG*(TEO(4) - TEO(5))
      EE(10) = C2S2*(TEO(1) - 2.*TEO(2) + TEO(3)) + TEO(10)*(C2-S2)**2
      EE(11) = 0.
      EE(12) = 0.
      EE(13) = 0.
      EE(14) = 0.
      EE(15) = TEO(15)*C2 + TEO(21)*S2
      EE(20) = COSG*SING*(TEO(15) - TEO(21))
      EE(21) = TEO(15)*S2 + TEO(21)*C2
C
      IF (LSYS78) GO TO 540
C
C     PIEZOELECTRIC MATERIAL PROPERTIES IN ELEMENT COORDINATES
C
      EE(37) = C3*TEO(22) - S3*TEO(26) + CS2*(TEO(25)+2.0*TEO(32)) -
     7         SC2*(TEO(23)+2.0*TEO(31))
      EE(38) = C3*TEO(23) + S3*TEO(25) + CS2*(TEO(26)-2.0*TEO(31)) +
     8         SC2*(TEO(22)-2.0*TEO(32))
      EE(39) = S2*TEO(27) + C2*TEO(24) - 2.0*CS*TEO(33)
      EE(40) = C3*TEO(25) - S3*TEO(23) + CS2*(TEO(22)-2.0*TEO(32)) -
     O         SC2*(TEO(26)-2.0*TEO(31))
      EE(41) = C3*TEO(26) + S3*TEO(22) + CS2*(TEO(23)+2.0*TEO(31)) +
     1         SC2*( TEO(25)+2.0*TEO(32))
      EE(42) = S2*TEO(24) + C2*TEO(27) + 2.0*CS*TEO(33)
      EE(43) = COSG*TEO(28) - SING*TEO(29)
      EE(44) = COSG*TEO(29) + SING*TEO(28)
      EE(45) = TEO(30)
      EE(46) = C3*TEO(31) + S3*TEO(32) - CS2*(TEO(23)-TEO(26)+TEO(31)) +
     6         SC2*(-TEO(32)-TEO(25)+TEO(22))
      EE(47) = C3*TEO(32) - S3*TEO(31) - CS2*(TEO(25)-TEO(22)+TEO(32)) +
     7         SC2*(TEO(23)+TEO(31)-TEO(26))
      EE(48) = (C2-S2)*TEO(33) + CS*(TEO(24)-TEO(27))
      EE(49) = C2*TEO(34) + S2*TEO(38) - CS*(TEO(35)+TEO(37))
      EE(50) = C2*TEO(35) - S2*TEO(37) + CS*(TEO(34)-TEO(38))
      EE(51) = COSG*TEO(36) - SING*TEO(39)
      EE(52) = C2*TEO(37) - S2*TEO(35) - CS*(TEO(38)-TEO(34))
      EE(53) = C2*TEO(38) + S2*TEO(34) + CS*(TEO(35)+TEO(37))
      EE(54) = COSG*TEO(39) + SING*TEO(36)
C
C     DIELECTRIC MATERIAL PROPERTIES IN ELEMENT COORDINTES
C
      EE(55) = S2*TEO(43) - 2.0*CS*TEO(41) + C2*TEO(40)
      EE(56) = (C2-S2)*TEO(41) - CS*(TEO(43)-TEO(40))
      EE(57) =-SING*TEO(44) + COSG*TEO(42)
      EE(59) = C2*TEO(43) + 2.0*CS*TEO(41) + S2*TEO(40)
      EE(60) = COSG*TEO(44) + SING*TEO(42)
      EE(63) = TEO(45)
  540 CONTINUE
C
C     COMPUTE HARMONIC COEFFICIENT
C
      MJHO  = MOD(IECPT(1),1000) - 1
      AJHO  = MJHO
      AJJHO = AJHO*AJHO
C
C     FORM THE ELEMENT STIFFNESS MATRIX IN FIELD SYSTEM
C
      ACURL( 1) = (EE(6) + AJJHO*EE(15))*DELINT(1)
      ACURL( 2) = (EE(4) + EE(6) + AJJHO*EE(15))*DELINT(4)
      ACURL( 3) = (EE(6) + AJJHO*EE(15))*DELINT(2) + EE(9)*DELINT(4)
      ACURL( 4) = (EE(4) + EE(6) + AJJHO*EE(15))*DELINT(5)
     4          + EE(9)* DELINT(7)
      ACURL( 5) = AJHO*(EE(6) + EE(15))*DELINT(1)
      ACURL( 6) = AJHO*EE(6)*DELINT(4)
      ACURL( 7) = AJHO*(EE(6) +EE(15))*DELINT(2) -AJHO*EE(20)*DELINT(4)
      ACURL( 8) = AJHO*EE(6)*DELINT(5) - AJHO*EE(20)*DELINT(7)
      ACURL( 9) = AJJHO*EE(20)*DELINT(1)
      ACURL(10) = DELINT(4)*(EE(9) + AJJHO*EE(20))
      ACURL(11) = DELINT(4)*EE(5) + AJJHO*DELINT(2)*EE(20)
      ACURL(12) = DELINT(7)*EE(5) + DELINT(5)*(EE(9)+AJJHO*EE(20))
      ACURL(14) = (EE(1) + 2.*EE(4) + EE(6) + AJJHO*EE(15))*DELINT(7)
      ACURL(15) = (EE(4) + EE(6) + AJJHO*EE(15))*DELINT(5) + (EE(7)
     5          + EE(9))*DELINT(7)
      ACURL(16) = (EE(1) + 2.*EE(4) + AJJHO*EE(15) + EE(6))*DELINT(8)
     6          + (EE(7) + EE(9))*DELINT(10)
      ACURL(17) = AJHO*(EE(4) + EE(6) + EE(15))*DELINT(4)
      ACURL(18) = AJHO*(EE(4) + EE(6))*DELINT(7)
      ACURL(19) = AJHO*(EE(4) + EE(6) + EE(15))*DELINT(5) - AJHO*EE(20)
     9          * DELINT(7)
      ACURL(20) = AJHO*(EE(4) + EE(6))*DELINT(8) -AJHO*EE(20)*DELINT(10)
      ACURL(21) = AJJHO*EE(20)*DELINT(4)
      ACURL(22) = DELINT(7)*(EE(7) + EE(9) + AJJHO*EE(20))
      ACURL(23) = DELINT(7)*(EE(2) + EE(5)) + AJJHO*DELINT(5)*EE(20)
      ACURL(24) = DELINT(10)*(EE(2) + EE(5)) + DELINT(8)*(EE(7)+EE(9))
     4          + DELINT(8)*AJJHO*EE(20)
      ACURL(27) = (EE(6) + AJJHO*EE(15))*DELINT(3) + 2.*EE(9)*DELINT(5)
     7          + EE(10)*DELINT(7)
      ACURL(28) = (EE(4) + EE(6) + AJJHO*EE(15))*DELINT(6)
     8          + EE(10)*DELINT(10) + (EE(7) + 2.*EE(9))*DELINT(8)
      ACURL(29) = AJHO*(EE(6) + EE(15))*DELINT(2) + AJHO*EE(9)*DELINT(4)
      ACURL(30) = AJHO*EE(6)*DELINT(5) + AJHO*EE(9)*DELINT(7)
      ACURL(31) = AJHO*(EE(6) + EE(15))*DELINT(3) + AJHO*(EE(9)
     1          - EE(20))*DELINT(5)
      ACURL(32) = AJHO*(EE(9) - EE(20))*DELINT(8) + AJHO*EE(6)*DELINT(6)
      ACURL(33) = AJJHO*EE(20)*DELINT(2)
      ACURL(34) = DELINT(7)*EE(10) + DELINT(5)*(EE(9) + AJJHO*EE(20))
      ACURL(35) = DELINT(7)*EE(8) + DELINT(5)*EE(5) + AJJHO*DELINT(3)
     5          * EE(20)
      ACURL(36) = DELINT(10)*EE(8) + DELINT(8)*(EE(5) + EE(10))
     6          + DELINT(6)*(EE(9) + AJJHO*EE(20))
      ACURL(40) = (EE(1) + 2.*EE(4) + EE(6)  + AJJHO*EE(15))*DELINT(9)
     O          + (2.*EE(7) + 2.*EE(9))*DELINT(11) + EE(10)*DELINT(12)
      ACURL(41) = AJHO*(EE(4) + EE(6) + EE(15))*DELINT(5)
     1          + AJHO*EE(9)*DELINT(7)
      ACURL(42) = AJHO*(EE(4) + EE(6))*DELINT(8) + AJHO*EE(9)*DELINT(10)
      ACURL(43) = AJHO*(EE(4) + EE(6) + EE(15))*DELINT(6)
     3          + AJHO*(EE(9) - EE(20))*DELINT(8)
      ACURL(44) = AJHO*(EE(4) + EE(6))*DELINT(9) + AJHO*(EE(9) - EE(20))
     4          * DELINT(11)
      ACURL(45) = AJJHO*EE(20)*DELINT(5)
      ACURL(46) = DELINT(8)*(EE(7) + EE(9) + AJJHO*EE(20)) + DELINT(10)
     6          * EE(10)
      ACURL(47) = DELINT(8)*(EE(2) + EE(5)) + DELINT(10)*EE(8)
     7          + AJJHO*DELINT(6)*EE(20)
      ACURL(48) = DELINT(11)*(EE(2) + EE(5) + EE(10)) + DELINT(12)*EE(8)
     8          + DELINT(9)*(EE(7) + EE(9) + AJJHO*EE(20))
      ACURL(53) = (EE(15) + AJJHO*EE(6))*DELINT(1)
      ACURL(54) = AJJHO*EE(6)*DELINT(4)
      ACURL(55) = (EE(15) + AJJHO*EE(6))*DELINT(2) - EE(20)*DELINT(4)
      ACURL(56) = AJJHO*EE(6)*DELINT(5) - EE(20)*DELINT(7)
      ACURL(57) = AJHO*EE(20)*DELINT(1)
      ACURL(58) = AJHO*DELINT(4)*(EE(9) + EE(20))
      ACURL(59) = AJHO*(DELINT(4)*EE(5) + DELINT(2)*EE(20))
      ACURL(60) = AJHO*(DELINT(7)*EE(5) + DELINT(5)*(EE(9) + EE(20)))
      ACURL(66) = AJJHO*EE(6)*DELINT(7)
      ACURL(67) = AJJHO*EE(6)*DELINT(5)
      ACURL(68) = AJJHO*EE(6)*DELINT(8)
      ACURL(69) = 0.
      ACURL(70) = AJHO*DELINT(7)*EE(9)
      ACURL(71) = AJHO*DELINT(7)*EE(5)
      ACURL(72) = AJHO*(DELINT(10)*EE(5) + DELINT(8)*EE(9))
      ACURL(79) = (EE(15) + AJJHO*EE(6))*DELINT(3) - 2.*EE(20)*DELINT(5)
     9          + EE(21)*DELINT(7)
      ACURL(80) = AJJHO*EE(6)*DELINT(6) - EE(20)*DELINT(8)
     O          + EE(21)*DELINT(10)
      ACURL(81) = AJHO*(EE(20)*DELINT(2) - EE(21)*DELINT(4))
      ACURL(82) = AJHO*(DELINT(5)*(EE(9) + EE(20)) - DELINT(7)*EE(21))
      ACURL(83) = AJHO*(DELINT(5)*(EE(5) - EE(21)) + DELINT(3)*EE(20))
      ACURL(84) = AJHO*(DELINT(8)*(EE(5) - EE(21)) + DELINT(6)*(EE(9)
     4          + EE(20)))
      ACURL(92) = EE(21)*DELINT(12) + AJJHO*EE(6)*DELINT(9)
      ACURL(93) =-AJHO*EE(21)*DELINT(7)
      ACURL(94) = AJHO*(DELINT(8)*EE(9) - DELINT(10)*EE(21))
      ACURL(95) = AJHO*DELINT(8)*(EE(5) - EE(21))
      ACURL(96) = AJHO*(DELINT(11)*(EE(5) - EE(21)) + DELINT(9)*EE(9))
      ACURL(105) = AJJHO*EE(21)*DELINT(1)
      ACURL(106) = AJJHO*DELINT(4)*EE(21)
      ACURL(107) = AJJHO*DELINT(2)*EE(21)
      ACURL(108) = AJJHO*DELINT(5)*EE(21)
      ACURL(118) = DELINT(7)*(EE(10) + AJJHO*EE(21))
      ACURL(119) = DELINT(7)*EE(8) + AJJHO*DELINT(5)*EE(21)
      ACURL(120) = DELINT(10)*EE(8) + DELINT(8)*(EE(10) + AJJHO*EE(21))
      ACURL(131) = DELINT(7)*EE(3) + AJJHO*DELINT(3)*EE(21)
      ACURL(132) = DELINT(10)*EE(3) + DELINT(8)*EE(8) + AJJHO*DELINT(6)
     2           * EE(21)
      ACURL(144) = DELINT(12)*EE(3) + 2.*DELINT(11)*EE(8) + DELINT(9)
     4           * (EE(10) + AJJHO*EE(21))
C
      IF (LSYS78) GO TO 550
      ACURL(145) = DELINT(1)*AJHO*(AJHO*EE(51) - EE(45))
      ACURL(146) = DELINT(4)*(EE(43) + AJHO*(AJHO*EE(51) - EE(49)
     6           - EE(45)))
      ACURL(147) = DELINT(2)*AJHO*(AJHO*EE(51) - EE(45)) + DELINT(4)
     7           * (EE(44) - AJHO*EE(50))
      ACURL(148) = DELINT(5)*(EE(43) + AJHO*(AJHO*EE(51) - EE(49)
     8           - EE(45))) + DELINT(7)*(EE(44) - AJHO*EE(50))
      ACURL(149) = DELINT(4)*AJHO*(AJHO*EE(51) - EE(45) - EE(39))
      ACURL(150) = DELINT(7)*(EE(43) + EE(37) + AJHO*(AJHO*EE(51)
     O           - EE(49) - EE(45) - EE(39)))
      ACURL(151) = DELINT(5)*AJHO*(AJHO*EE(51) - EE(45) - EE(39))
     1           + DELINT(7)*(EE(44) + EE(38) - AJHO*EE(50))
      ACURL(152) = DELINT(8)*(EE(43) + EE(37) + AJHO*(AJHO*EE(51)
     2           - EE(49) - EE(45) - EE(39))) + DELINT(10)*(EE(44)
     2           + EE(38) - AJHO*EE(50))
      ACURL(153) = DELINT(2)*AJHO*(AJHO*EE(51) - EE(45)) - DELINT(4)
     3           * AJHO*EE(48)
      ACURL(154) = DELINT(5)*(EE(43) + AJHO*(AJHO*EE(51) - EE(49)
     4           - EE(45))) + DELINT(7)*(EE(46) - AJHO*EE(48))
      ACURL(155) = DELINT(3)*AJHO*(AJHO*EE(51) - EE(45)) + DELINT(5)
     1           * (EE(44) - AJHO*(EE(50) + EE(48))) + DELINT(7)*EE(47)
      ACURL(156) = DELINT(6)*(EE(43) + AJHO*(AJHO*EE(51) - EE(49)
     6           - EE(45))) + DELINT(8)*(EE(46) + EE(44) - AJHO*(EE(50)
     6           + EE(48))) + DELINT(10)*EE(47)
      ACURL(157) = DELINT(5)*AJHO*(AJHO*EE(51) - EE(45) - EE(39))
     7           - DELINT(7)*AJHO*EE(48)
      ACURL(158) = DELINT(8)*(EE(43) + EE(47) + AJHO*(AJHO*EE(51)
     8           - EE(49) - EE(45) - EE(39))) - DELINT(10)*(EE(46)
     8           - AJHO*EE(48))
      ACURL(159) = DELINT(6)*AJHO*(AJHO*EE(51) - EE(45) - EE(39))
     9           + DELINT(8)*(EE(44) + EE(38) - AJHO*(EE(50) + EE(48)))
     9           + DELINT(10)*EE(47)
      ACURL(160) = DELINT(9)*(EE(43) + EE(37) + AJHO*(AJHO*EE(51)
     O           - EE(49) - EE(45) - EE(39))) + DELINT(11)*(EE(46)
     O           + EE(44) + EE(38) - AJHO*(EE(50) + EE(48)))
     O           + DELINT(12)*EE(47)
      ACURL(161) = DELINT(1)*AJHO*(EE(51) - AJHO*EE(45))
      ACURL(162) = DELINT(4)*(-EE(49) + AJHO*(EE(51) + EE(43)
     2           - AJHO*EE(45)))
      ACURL(163) = DELINT(2)*AJHO*(EE(51) - AJHO*EE(45)) + DELINT(4)
     3           * (AJHO*EE(44) - EE(50))
      ACURL(164) = DELINT(5)*(-EE(49) + AJHO*(EE(51) + EE(43) - AJHO
     4           * EE(51))) + DELINT(7)*(AJHO*EE(44) - EE(50))
      ACURL(165) =-DELINT(4)*AJJHO*EE(45)
      ACURL(166) = DELINT(7)*AJHO*(EE(43) - AJHO*EE(45))
      ACURL(167) = DELINT(7)*AJHO*EE(44) - DELINT(5)*AJJHO*EE(45)
      ACURL(168) = DELINT(8)*AJHO*(EE(43) - AJHO*EE(45)) + DELINT(10)
     8           * AJHO*EE(44)
      ACURL(169) = DELINT(2)*AJHO*(EE(51) - AJHO*EE(45)) - DELINT(4)
     9           * AJHO*EE(54)
      ACURL(170) = DELINT(5)*(-EE(49) + AJHO*(EE(51) + EE(43) - AJHO
     O           * EE(45))) + DELINT(7)*(EE(52) - AJHO*EE(54))
      ACURL(171) = DELINT(3)*AJHO*(EE(51) - AJHO*EE(45)) + DELINT(5)
     1           * (AJHO*(EE(44) - EE(54)) - EE(50)) + DELINT(7)*EE(53)
      ACURL(172) = DELINT(6)*(-EE(49) + AJHO*(EE(51) + EE(43) - AJHO
     2           * EE(45))) + DELINT(8)*(EE(52) - EE(50) + AJHO
     2           * (EE(44) - EE(54))) + DELINT(10)*EE(53)
      ACURL(173) =-DELINT(5)*AJJHO*EE(45) - DELINT(7)*AJHO*EE(54)
      ACURL(174) = DELINT(8)*AJHO*(EE(43) - AJHO*EE(45)) + DELINT(10)
     4           * (EE(54) - AJHO*EE(54))
      ACURL(175) =-DELINT(6)*AJJHO*EE(45) + DELINT(8)*AJHO*(EE(44)
     5           - EE(54)) + DELINT(10)*EE(53)
      ACURL(176) = DELINT(9)*AJHO*(EE(43) - AJHO*EE(45)) + DELINT(11)
     6           * (EE(52) + AJHO*(EE(44) - EE(54))) + DELINT(12)*EE(53)
      ACURL(177) = DELINT(1)*AJJHO*EE(54)
      ACURL(178) = DELINT(4)*AJHO*(AJHO*EE(54) - EE(52))
      ACURL(179) = DELINT(2)*AJJHO*EE(54) - DELINT(4)*AJHO*EE(53)
      ACURL(180) = DELINT(5)*AJHO*(AJHO*EE(54) - EE(52)) - DELINT(7)
     O           * AJHO*EE(53)
      ACURL(181) = DELINT(4)*AJHO*(AJHO*EE(54) - EE(48))
      ACURL(182) = DELINT(7)*(EE(46) + AJHO*(AJHO*EE(54) - EE(52)
     2           - EE(48)))
      ACURL(183) = DELINT(5)*AJHO*(AJHO*EE(54) - EE(48)) + DELINT(7)
     3           * (EE(47)-AJHO*EE(53))
      ACURL(184) = DELINT(8)*(EE(46) + AJHO*(AJHO*EE(54) - EE(52)
     4           - EE(48))) + DELINT(10)*(EE(47) - AJHO*EE(53))
      ACURL(185) = DELINT(2)*AJJHO*EE(54) - DELINT(4)*AJHO*EE(42)
      ACURL(186) = DELINT(5)*AJHO*(AJHO*EE(54) - EE(52)) + DELINT(7)
     6           * (EE(40) - AJHO*EE(42))
      ACURL(187) = DELINT(3)*AJJHO*EE(54) - DELINT(5)*AJHO*(EE(53)
     7           + EE(42)) + DELINT(7)*EE(41)
      ACURL(188) = DELINT(6)*AJHO*(AJHO*EE(54) - EE(52)) + DELINT(8)
     8           * (EE(40) - AJHO*(EE(53) + EE(42))) + DELINT(10)*EE(41)
      ACURL(189) =-DELINT(5)*AJHO*EE(48) + DELINT(4)*AJJHO*EE(54)
     9           - DELINT(7)*AJHO*EE(42)
      ACURL(190) = DELINT(8)*(EE(46) - AJHO*EE(48)) + DELINT(7)*AJHO
     O           * (AJHO*EE(54) - EE(52)) + DELINT(10)*(EE(40)
     O           - AJHO*EE(42))
      ACURL(191) =-DELINT(6)*AJHO*EE(48) + DELINT(5)*AJJHO*EE(54)
     1           + DELINT(8)*(EE(47) - AJHO*EE(42)) - DELINT(7)*AJHO
     1           * EE(53) + DELINT(10)*EE(41)
      ACURL(192) = DELINT(9)*(EE(46) - AJHO*EE(48)) + DELINT(8)*AJHO
     2           * (AJHO*EE(54) - EE(52)) + DELINT(11)*(EE(47) + EE(40)
     2           - AJHO*EE(42)) - DELINT(10)*AJHO*EE(53) + DELINT(12)
     2           * EE(41)
      ACURL(193) = DELINT(1)*AJJHO*EE(63)
      ACURL(194) = DELINT(4)*AJHO*(AJHO*EE(63) - EE(57))
      ACURL(195) = DELINT(2)*AJJHO*EE(63) - DELINT(4)*AJHO*EE(60)
      ACURL(196) = DELINT(5)*AJHO*(AJHO*EE(63) - EE(57)) - DELINT(7)
     6           * AJHO*EE(60)
      ACURL(197) = DELINT(4)*AJHO*(AJHO*EE(63) - EE(57))
      ACURL(198) = DELINT(7)*(AJJHO*EE(63) - 2.0*AJHO*EE(57) + EE(55))
      ACURL(199) = DELINT(5)*AJHO*(AJHO*EE(63) - EE(57)) + DELINT(7)
     9           * (EE(56) - AJHO*EE(60))
      ACURL(200) = DELINT(8)*(AJJHO*EE(63) - 2.0*AJHO*EE(57) + EE(55))
     O           + DELINT(10)*(EE(56) - AJHO*EE(60))
      ACURL(201) = DELINT(2)*AJJHO*EE(63) - DELINT(4)*AJHO*EE(60)
      ACURL(202) = DELINT(5)*AJHO*(AJHO*EE(63) - EE(57)) + DELINT(7)
     2           * (EE(56) - AJHO*EE(60))
      ACURL(203) = DELINT(3)*AJJHO*EE(63) - DELINT(5)*2.0*AJHO*EE(60)
     3           + DELINT(7)*EE(59)
      ACURL(204) = DELINT(6)*AJHO*(AJHO*EE(63) - EE(57)) + DELINT(8)
     4           * (EE(56) - 2.0*AJHO*EE(60)) + DELINT(10)*EE(59)
      ACURL(205) = DELINT(5)*AJHO*(AJHO*EE(63) - EE(57)) - DELINT(7)
     5           * AJHO*EE(60)
      ACURL(206) = DELINT(8)*(AJJHO*EE(63) - 2.0*EE(57) + EE(55))
     6           + DELINT(10)*(EE(56) - AJHO*EE(60))
      ACURL(207) = DELINT(6)*AJHO*(AJHO*EE(63) - EE(57)) + DELINT(8)
     7           * (EE(56) - 2.0*AJHO*EE(60)) + DELINT(10)*EE(59)
      ACURL(208) = DELINT(9)*(AJJHO*EE(63) - 2.0*AJHO*EE(57) + EE(55))
     8           + 2.0*DELINT(11)*(EE(56) - AJHO*EE(60)) + DELINT(12)
     8           * EE(59)
  550 CONTINUE
C
C     TRANSFORM THE ELEMENT STIFFNESS MATRIX FROM FIELD SYSTEM
C     TO GRID POINT DEGREES OF FREEDOM
C
C     EXPAND ACURL INTO (12X12)
C
      DO 610 IB = 2,12
      IC = 13*IB - 25
      I  = IC
      DO 605 J = IB,12
      IC = IC + 12
      I  = I  + 1
  605 ACURL(IC) = ACURL(I)
  610 CONTINUE
C
      DGAMA = PI
      IF (AJHO .EQ. 0.) DGAMA = TWOPI
      DO 630 I = 1,144
      ACURL(I) = ACURL(I)*DGAMA
  630 CONTINUE
C
      IF (LSYS78) GO TO 638
      DO 632 I = 145,208
  632 ACURL(I) = ACURL(I)*DGAMA
  638 CONTINUE
C
      CALL GMMATS (GB,12,12,1, ACURL,12,12,0, D )
      CALL GMMATS (D ,12,12,0, GB   ,12,12,0, AK)
C
      IF (LSYS78) GO TO 639
      CALL GMMATS (GB,12,12,1, ACURP1,12,4,0, D1)
      CALL GMMATS (D1,12,4,0, GBP,4,4,0, AKUPH)
      CALL GMMATS (GBP,4,4,1, ACURP2,4,4,0, D2)
      CALL GMMATS (D2,4,4,0, GBP,4,4,0, AKPH2)
  639 CONTINUE
C
      DO 640 I = 1,256
  640 AKJ(I) = 0.
      GO TO 655
C
C     COORDINATE SYSTEMS NOT POSSIBLE WITH RINGAX  CODE BELOW COULD
C     IMPLEMENT IT.
C
C     IF FOLLOWING CODE IS IMPLEMENTED MUST BE MODIFIED FOR
C     PIEZOELECTRIC
C
C     DO 650 I = 1,4
C     IF (ICS(I) .EQ. 0) GOTO 650
C     K = 9*(I-1) + 1
C     CALL TRANSS (ICS(I),D(K))
C 650 CONTINUE
C
C     SELECT THE APPROPRIATE SUB MATRIX FOR TRANSFORMATION
C
C     DO 690 IPP = 1,4
C     IR1 = 3*(IPP-1) + 1
C     IAPP= 9*(IPP-1) + 1
C     DO 680 I = 1,4
C     IC1 = 3*(I-1) + 1
C     IRC = (IR1-1)*12 + IC1
C     AKT(1) = AK(IRC   )
C     AKT(2) = AK(IRC+ 1)
C     AKT(3) = AK(IRC+ 2)
C     AKT(4) = AK(IRC+12)
C     AKT(5) = AK(IRC+13)
C     AKT(6) = AK(IRC+14)
C     AKT(7) = AK(IRC+24)
C     AKT(8) = AK(IRC+25)
C     AKT(9) = AK(IRC+26)
C
C     MORE COORDINATE SYSTEM CHANGE CODE
C
C     TRANSFORM THE STIFFNESS  SUB MATRICES  AS NECESSARY
C
C     IAKT = 1
C     IF (ICS(IPP) .EQ. 0) GO TO 660
C     CALL GMMATS (D(IAPP),3,3,1, AKT(1),3,3,0, AKT(10))
C     IAKT = 10
C     IF (ICS(I).EQ.0 .AND. ICS(IPP).EQ.0) GO TO 680
C 660 IF (ICS(I) .EQ.0) GO TO 670
C     IAI = 9*(I-1) + 1
C     CALL GMMATS (AKT(IAKT),3,3,0, D(IAI),3,3,0, AKT(IAKT+9))
C     IAKT = IAKT + 9
C
C     REPLACE THE TRANSFORMED MATRICES IN ORIGINAL MATRIX
C
C 670 AK(IRC   ) = AKT(IAKT  )
C     AK(IRC+ 1) = AKT(IAKT+1)
C     AK(IRC+ 2) = AKT(IAKT+2)
C     AK(IRC+12) = AKT(IAKT+3)
C     AK(IRC+13) = AKT(IAKT+4)
C     AK(IRC+14) = AKT(IAKT+5)
C     AK(IRC+24) = AKT(IAKT+6)
C     AK(IRC+25) = AKT(IAKT+7)
C     AK(IRC+26) = AKT(IAKT+8)
C
C 680 CONTINUE
C 690 CONTINUE
C
C     CREATE AN ARRAY POINTING TO THE GRIDS ACCORDING TO INCREASING
C     SIL VALUE
C
  655 CONTINUE
C
      ASSIGN 780 TO K OR M
  700 CONTINUE
      DO 705 I = 1,4
      IPART(I) = IECPT(I+1)
  705 CONTINUE
      I = -4
  710 J = 0
      DO 715 KK = 1,4
      IF (IPART(KK) .LT. J) GO TO 715
      J = IPART(KK)
      L = KK
  715 CONTINUE
      IPART(L) = I
      I = I + 1
      IF (I .LT. 0) GO TO 710
      DO 720 I = 1,4
      IPART(I) = -IPART(I)
  720 CONTINUE
      ISORT = 1
      GO TO K OR M, (780,880)
C
C     REARRANGE  AK  INTO AKJ BY INCREASING SIL VALUE
C     NOTE AKJ ALREADY INITALIZED TO ZERO
C
  780 DO 770 I = 1,4
      IT = IPART(I)
      DO 760 J = 1,4
      JT = IPART(J)
      DO 750 K = 1,3
      DO 740 L = 1,3
      IKJ = (IT-1)*64 + (JT-1)*4 + (K-1)*16 + L
      IF (MASOR .EQ. 1) IKJ = (IT-1)*36 + (JT-1)*3 + (K-1)*12 + L
      IK  = (I-1)*36 + (J-1) *3 +(K-1)*12 + L
      AKJ(IKJ) = AK(IK)
C
      IF (MASOR .EQ. 1) GO TO 740
      IF (LSYS78) GO TO 740
      IKJA = IKJ - L + 4
      IKA  = (IK-L)/3 + 1
      IKJB = (JT-1)*64 + 48 + (IT-1)*4 + K
      IKJC = (IT-1)*64 + 52 + (JT-1)*4
      IKC  = (I-1)*4 + J
      AKJ(IKJA) = AKUPH(IKA)
      AKJ(IKJB) = AKUPH(IKA)
      AKJ(IKJC) = AKPH2(IKC)
  740 CONTINUE
  750 CONTINUE
  760 CONTINUE
  770 CONTINUE
      IF (MASOR .EQ. 1) GO TO 895
C
C     SET UP CONSTANTS AND OUTPUT AKJ
C
      DICT(1) = ESTID
      DICT(2) = 1
      DICT(3) = 16
      DICT(4) = 15
CWKBD SPR94002 5/94      DICT5   =  GSUBE
      IP      = IPREC
      CALL EMGOUT (AKJ,AKJ,256,1,DICT,1,IP)
C
C    COME HERE TO CALCULATE THE MASS  MATRIX. THIS ROUTINE WILL
C    CALCULATE EITHER THE CONSISTENT OR LUMPED MASS MATRICES
C    DEPENDING ON THE PARAMETER ICM BAR
C
C
C     IF STIFFNESS MATRIX NOT NEEDED WE HAVE ALL WE NEED FOR THE
C     MASS MATRIX CALCULATIONS
  800 IF (ISMB(2).EQ.0 .AND. .NOT.PZMAT) KSYS78 = KSAVE
      IF (ISMB(2) .EQ. 0) RETURN
      IF (ICMBAR  .LT. 0) GO TO 820
      I1 = 0
      DO 810 I = 1,3
      IP = I
      DO 810 J = 1,3
      IQ = J - 1
      I1 = I1 + 1
      DELINT(I1) = RZINTS(IP,IQ,R,Z,4)
  810 CONTINUE
C
  820 IF (ISMB(1) .NE. 0) GO TO 830
      MATIDC = MATID
      MATFLG = 7
      IF (KSYS78 .GT. 0) MATFLG = 9
      ELTEMP = TEMPE
      GAMR   = DGAMA*DEGRAD
      COSTH  = COS(GAMR)
      SINTH  = SIN(GAMR)
      CALL MAT (IDEL)
      IF (KSYS78 .GT.  0) RHO = PZOUT(46)
      IF (SETMAT .EQ. 2.) GO TO 7780
C
C     COMPUTE THE HARMONIC COEFFICIENT
C
  830 MJHO = MOD(IECPT(1),1000) - 1
      AJHO = MJHO
      RHOD = RHO*PI
      IF (AJHO  .EQ. 0.) RHOD = 2.*RHOD
      IF (ICMBAR .LT. 0) GO TO 900
C
C     COMPUTE THE CONSISTENT MASS MATRIX IN FIELD COORDINATES
C
      DO 840 I = 1,144
  840 BMASS( I, 1) = 0.
      BMASS( 1, 1) = DELINT(1)
      BMASS( 1, 2) = DELINT(4)
      BMASS( 1, 3) = DELINT(2)
      BMASS( 1, 4) = DELINT(5)
      BMASS( 2, 2) = DELINT(7)
      BMASS( 2, 3) = DELINT(5)
      BMASS( 2, 4) = DELINT(8)
      BMASS( 3, 3) = DELINT(3)
      BMASS( 3, 4) = DELINT(6)
      BMASS( 4, 4) = DELINT(9)
      BMASS( 5, 5) = DELINT(1)
      BMASS( 5, 6) = DELINT(4)
      BMASS( 5, 7) = DELINT(2)
      BMASS( 5, 8) = DELINT(5)
      BMASS( 6, 6) = DELINT(7)
      BMASS( 6, 7) = DELINT(5)
      BMASS( 6, 8) = DELINT(8)
      BMASS( 7, 7) = DELINT(3)
      BMASS( 7, 8) = DELINT(6)
      BMASS( 8, 8) = DELINT(9)
      BMASS( 9, 9) = DELINT(1)
      BMASS( 9,10) = DELINT(4)
      BMASS( 9,11) = DELINT(2)
      BMASS( 9,12) = DELINT(5)
      BMASS(10,10) = DELINT(7)
      BMASS(10,11) = DELINT(5)
      BMASS(10,12) = DELINT(8)
      BMASS(11,11) = DELINT(3)
      BMASS(11,12) = DELINT(6)
      BMASS(12,12) = DELINT(9)
      DO 860 IB = 2,12
      IC = 13*IB - 25
      I  = IC
      DO 850 J = IB,12
      IC = IC + 12
      I  = I + 1
  850 BMBSS(I) = BMBSS(IC)
  860 CONTINUE
      DO 870 I = 1,144
  870 BMBSS(I) = BMBSS(I)*RHOD
C
C     TRANSFORM THE ELEMENT MASS MATRIX FROM FIELD COORDINATES TO
C     GRID  POINT DEGREES  OF FREEDOM
C
      CALL GMMATS (GB,12,12,1, BMASS,12,12,0, D)
      CALL GMMATS (D ,12,12,0, GB,12,12,0, AK)
      DO 875 I = 1,256
  875 AKJ(I) = 0.
      IF (ISORT .EQ. 1) GO TO 880
      ASSIGN 880 TO K OR M
      GO TO  700
C
C     REARRANGE AK INTO AKJ BY INCREASING SIL VALUE
C
  880 MASOR = 1
      GO TO 780
C
  895 DICT(1) = ESTID
      DICT(2) = 1
      DICT(3) = 12
      DICT(4) =  7
CWKBD SPR94002 5/94      DICT5   =  0.
      IP      = IPREC
C
      CALL EMGOUT (AKJ,AKJ,144,1,DICT,2,IP)
      GO TO 940
C
C
C     LUMPED MASS CALCULATIONS HANDLED HERE
C
  900 AR = (R(1)*(Z(2)-Z(4)) + R(2)*(Z(3)-Z(1)) + R(3)*(Z(4)-Z(2)) +
     1      R(4)*(Z(1)-Z(3)))/2.
      AKJ(1) = RHOD*(R(1) + R(2) + R(3) + R(4))/4.*AR
      AKJ(1) = AKJ(1)/4.0
      DO 920 I = 2,12
  920 AKJ(I) = AKJ(1)
C
      DICT(1) = ESTID
      DICT(2) = 2
      DICT(3) = 12
      DICT(4) = 7
CWKBD SPR94002 5/94      DICT5   = 0.
      IP      = IPREC
C
      CALL EMGOUT (AKJ,AKJ,12,1,DICT,2,IP)
  940 IF (.NOT.PZMAT) KSYS78 = KSAVE
      RETURN
C
C     SET FATAL ERROR FLAG AND ALLOWING ERROR MESSAGES TO ACCUMULATE
C
 7760 I = 218
      GO TO 7800
 7770 I = 37
      GO TO 7800
C
C     MAT2 NOT LEGAL
C
 7780 I = 126
      GO TO 7800
 7790 I =  26
 7800 IF (IDEL1 .EQ. IDEL2) GO TO 7810
      IDEL2  = IDEL1
      ICS(1) = IDEL1
      ICS(2) = JAX
      CALL MESAGE (30,I,ICS)
 7810 NOGO = .TRUE.
      GO TO 940
      END

      SUBROUTINE FEER1
C
C     FEER1 INITIALIZES AND CALLS SUBROUTINE ADD FOR FEER
C
      INTEGER           FILEA     ,FILEB    ,FILEC    ,FILEK    ,
     1                  FILEM     ,SCR1     ,TYPALP   ,TYPBTA   ,
     2                  SQR       ,RDP
      DOUBLE PRECISION  LAMBDA    ,DALPHA   ,DBETA
      COMMON   /FEERCX/ FILEK(7)  ,FILEM(7) ,SCR1
      COMMON   /FEERXX/ LAMBDA
      COMMON   /SADDX / NOMAT     ,NZ       ,FILEA(7) ,TYPALP   ,
     1                  DALPHA(2) ,FILEB(7) ,TYPBTA   ,DBETA(2) ,
     2                  DUM(36)   ,FILEC(7)
      COMMON   /ZZZZZZ/ Z(1)
      COMMON   /NAMES / IJ(8)     ,RDP      ,IK(2)    ,SQR
      COMMON   /SYSTEM/ KSYSTM(56)
      EQUIVALENCE       (KSYSTM(55),IPREC)
C
C     SET UP CALL TO ADD
C
      DO 10  I = 1,7
      FILEA(I) = FILEM(I)
   10 FILEB(I) = FILEK(I)
      DALPHA(1)= LAMBDA
      DBETA(1) = 1.0D+0
      TYPALP   = IPREC
      TYPBTA   = IPREC
      NZ       = KORSZ(Z)
      FILEC(1) = SCR1
      FILEC(2) = FILEK(2)
      FILEC(3) = FILEK(3)
      FILEC(4) = SQR
      FILEC(5) = IPREC
      NOMAT    = 2
      IF (FILEB(1) .EQ. 0) NOMAT = 1
      CALL SADD (Z,Z)
      CALL WRTTRL (FILEC)
      RETURN
      END

      SUBROUTINE DBAR
C
C     THIS ROUTINE COMPUTES THE 2 6X6 DIFFERENTIAL STIFFNESS MATRICES
C     K(NPVT,NPVT) AND K(NPVT,J) FOR A BEAM HAVING END POINTS OF SIL
C     NOS. NPVT AND J.
C
C     ECPT FOR THE BEAM
C
C     ECPT( 1)  -  IELID          ELEMENT ID. NO.
C     ECPT( 2)  -  ISILNO(2)      SCALAR INDEX NOS.
C     ECPT( 3)  -   ...
C     ECPT( 4)  -  SMALLV(3)      REFERENCE VECTOR
C     ECPT( 5)  -   ...
C     ECPT( 6)  -   ...
C     ECPT( 7)  -  IGSUB0         OPTION FOR DEFINING REFERENCE NUMBER.
C     ECPT( 8)  -  IPINFL(2)      PIN FLAGS
C     ECPT( 9)  -   ...
C     ECPT(10)  -  ZA(3)          OFFSET VECTOR AT POINT A
C     ECPT(11)  -   ...
C     ECPT(12)  -   ...
C     ECPT(13)  -  ZB(3)          OFFSET VECTOR AT POINT B
C     ECPT(14)  -   ...
C     ECPT(15)  -   ...
C     ECPT(16)  -  GEF(4)         ECCENTRICITIES FOR FORCE
C     ECPT(17)  -   ...
C     ECPT(18)  -   ...
C     ECPT(19)  -   ...
C     ECPT(20)  -  IMATID         MATERIAL ID.
C     ECPT(21)  -  A              CROSS-SECTIONAL AREA
C     ECPT(22)  -  C1             STRESS COEFFICIENTS
C     ECPT(23)  -  C2                    ...
C     ECPT(24)  -  I1             AREA MOMENTS OF INERTIA
C     ECPT(25)  -  I2                    ...
C     ECPT(26)  -  I3                    ...
C     ECPT(27)  -  FJ             TORSIONAL CONSTANT
C     ECPT(28)  -  FMU            NON-STRUCTURAL MASS
C     ECPT(29)  -  K1             AREA FACTORS FOR SHEAR
C     ECPT(30)  -  K2                    ...
C     ECPT(31)  -  C3 (D1)        STRESS COEFFICIENTS
C     ECPT(32)  -  C4 (D2)               ...
C     ECPT(33)  -  B1             WIDTHS FOR FORCE
C     ECPT(34)  -  B2                    ...
C     ECPT(35)  -  HS1            DEPTHS FOR FORCE
C     ECPT(36)  -  HS2                   ...
C     ECPT(37)  -  HT1                   ...
C     ECPT(38)  -  HT2                   ...
C     ECPT(39)  -  MCSIDA         COOR. SYS. ID. FOR GRID PT. A
C     ECPT(40)  -  GPA(3)         BASIC COORDINATES FOR PT. A
C     ECPT(41)  -   ...                  ...
C     ECPT(42)  -   ...                  ...
C     ECPT(43)  -  MCSIDB         COOR. SYS. ID. FOR GRID PT. B
C     ECPT(44)  -  GPB(3)         BASIC COORDINATES FOR PT. B
C     ECPT(45)  -   ...                  ...
C     ECPT(46)  -   ...                  ...
C     ECPT(47)  -  ELTEMP         ELEMENT TEMPERATURE
C     ECPT(48)  -  ELDEF          ELEMENT DEFORMATION
C     ECPT(49)  -  TEMPER         ELEMENT LOADING TEMPERATURE
C     ECPT(50)  -  UAS(1)                ...
C     ECPT(51)  -  UAS(2)                ...
C     ECPT(52)  -  UAS(3)         SINGLE PRECISION DISPLACEMENTS
C     ECPT(53)  -  UAS(4)               FOR GRID POINT A
C     ECPT(54)  -  UAS(5)                ...
C     ECPT(55)  -  UAS(6)                ...
C     ECPT(56)  -  UBS(1)                ...
C     ECPT(57)  -  UBS(2)                ...
C     ECPT(58)  -  UBS(3)         SINGLE PRECISION DISPLACEMENTS
C     ECPT(59)  -  UBS(4)               FOR GRID POINT B
C     ECPT(60)  -  UBS(5)                ...
C     ECPT(61)  -  UBS(6)                ...
C
      LOGICAL          ABASIC,BBASIC,BASIC,AOFSET,BOFSET,OFFSET
      REAL             K1,K2,I1,I2
      DOUBLE PRECISION TA(18),TB(9),SMALV0(6),DELA,DELB,KE,KEP,VECI,
     1                 VECJ,VECK,FL,FLL,EI1,EI2,GAK1,GAK2,RRV1,RRV2,
     2                 SK1,SK2,SK3,SK4,TERM1,TERM2,TERM3,TERM4,L,LSQ,
     3                 LCUBE,DP(8)
      DOUBLE PRECISION E,DA,ALPHA,T SUB 0,SA(72),SB(36),UA(6),UB(6),
     1                 DPVECA(6),DPVECB(6),FX,VY,VZ,MAY,MAZ,MBY,MBZ,
     2                 KD(144),KC(12,12),TERM5,TERM6,TERM7,TERM8,TERM9,
     3                 TERM10,TERM11,KES(144),KDP(144),DFJ
      DIMENSION        VECI(3),VECJ(3),VECK(3),ECPT(100),IECPT(100),
     1                 IPIN(10),IZ(1)
      COMMON /ZZZZZZ/  Z(1)
      COMMON /DS1AAA/  NPVT,ICSTM,NCSTM,DUMCL(32),NOGO
      COMMON /DS1AET/  IELID,ISILNO(2),SMALLV(3),IGSUB0,IPINFL(2),ZA(3),
     1                 ZB(3),GEF(4),IMATID,A,DUMMY1,DUMMY2,I1,I2,DUMMY3,
     2                 FJ,FMU,K1,K2,DUM2(8),MCSIDA,GPA(3),MCSIDB,GPB(3),
     3                 TEMPEL,ELDEF,TEMPER,UAS(6),UBS(6),DUM3(38)
      COMMON /DS1ADP/  KE(144),KEP(144),DELA(6),DELB(6)
      COMMON /MATIN /  MATIDC,MATFLG,ELTEMP,STRESS,SINTH,COSTH
      COMMON /MATOUT/  E S,G S,NU,RHO,ALPHA S,T SUB 0 S,GSUBE,SIGT,
     1                 SIGC,SIGS
      EQUIVALENCE      (IELID,ECPT(1),IECPT(1)),(IZ(1),Z(1)),
     1                 (TA(10),TB(1)),(ECPT(71),DP(1)),(KC(1,1),KD(1)),
     2                 (SA(37),SB(1))
C
C     DETERMINE WHICH SIL IS THE PIVOT POINT.
C
C     IPVT = 0
      IPVT = 1
      IF (ISILNO(1) .EQ. NPVT) GO TO 20
      IPVT = 2
      IF (ISILNO(2) .NE. NPVT) CALL MESAGE (-30,34,IECPT(1))
C
C     JCSIDA IS AN INDEX WHICH POINTS TO THE COOR. SYS. ID. OF POINT A.
C     JOFSTA IS AN INDEX WHICH POINTS TO THE OFFSET VECTOR FOR POINT A.
C     SIMILARY FOR JCSIDB AND JOFSTB AND POINT B.
C
   20 JCSIDA = 39
      JCSIDB = 43
      JOFSTA = 10
      JOFSTB = 13
      JPINA  = 8
      JPINB  = 9
      ICSIDA = IECPT(JCSIDA)
      ICSIDB = IECPT(JCSIDB)
C
C     NORMALIZE THE REFERENCE VECTOR WHICH LIES IN THE FIRST PRINCIPAL
C     AXIS PLANE  (FMMS - 36 P. 4)
C     WE STORE SMALLV IN SMALV0 SO THAT ARITHMETIC WILL BE DOUBLE
C     PRECISION
C
      DO 50 I = 1,3
   50 SMALV0(I) = SMALLV(I)
      FL = DSQRT(SMALV0(1)**2 + SMALV0(2)**2 + SMALV0(3)**2)
      IF (FL .LE. 0.0D0) GO TO 700
      DO 60 I = 1,3
   60 SMALV0(I) = SMALV0(I)/FL
C
C     DETERMINE IF POINT A AND B ARE IN BASIC COORDINATES OR NOT.
C
      ABASIC = .TRUE.
      BBASIC = .TRUE.
      IF (ICSIDA .NE. 0) ABASIC = .FALSE.
      IF (ICSIDB .NE. 0) BBASIC = .FALSE.
C
C     COMPUTE THE TRANSFORMATION MATRICES TA AND TB IF NECESSARY
C
      IF (.NOT.ABASIC) CALL TRANSD (ECPT(JCSIDA),TA)
      IF (.NOT.BBASIC) CALL TRANSD (ECPT(JCSIDB),TB)
C
C     DETERMINE IF WE HAVE NON-ZERO OFFSET VECTORS.
C
      AOFSET = .TRUE.
      J = JOFSTA - 1
      DO 70 I = 1,3
      J = J + 1
      IF (ECPT(J) .NE. 0.0) GO TO 80
   70 CONTINUE
      AOFSET = .FALSE.
   80 BOFSET = .TRUE.
      J = JOFSTB - 1
      DO 90 I = 1,3
      J = J + 1
      IF (ECPT(J) .NE. 0.0) GO TO 100
   90 CONTINUE
      BOFSET = .FALSE.
C
C     FORM THE CENTER AXIS OF THE BEAM WITHOUT OFFSETS.
C     FIRST WE STORE THE COORDINATES IN THE ARRAY DP SO THAT ALL
C     ARITHMETIC WILL BE DOUBLE PRECISION.
C
  100 DP(1)   = ECPT(JCSIDA+1)
      DP(2)   = ECPT(JCSIDA+2)
      DP(3)   = ECPT(JCSIDA+3)
      DP(4)   = ECPT(JCSIDB+1)
      DP(5)   = ECPT(JCSIDB+2)
      DP(6)   = ECPT(JCSIDB+3)
      VECI(1) = DP(1) - DP(4)
      VECI(2) = DP(2) - DP(5)
      VECI(3) = DP(3) - DP(6)
C
C     TRANSFORM THE OFFSET VECTORS IF NECESSARY
C
      IF (.NOT.AOFSET .AND. .NOT.BOFSET) GO TO 150
C
C     TRANSFORM THE OFFSET VECTOR FOR POINT A IF NECESSARY.
C
      IDELA = 1
      J = JOFSTA - 1
      DO 110 I = 1,3
      J = J + 1
  110 DELA(I) = ECPT(J)
      IF (ABASIC) GO TO 120
      IDELA = 4
      CALL GMMATD (TA,3,3,0, DELA(1),3,1,0, DELA(4))
C
C     TRANSFORM THE OFFSET VECTOR FOR POINT B IF NECESSARY
C
  120 IDELB = 1
      J = JOFSTB - 1
      DO 130 I = 1,3
      J = J + 1
  130 DELB(I) = ECPT(J)
      IF (BBASIC) GO TO 140
      IDELB = 4
      CALL GMMATD (TB,3,3,0, DELB(1),3,1,0, DELB(4))
C
C     SINCE THERE WAS AT LEAST ONE NON-ZERO OFFSET VECTOR RECOMPUTE VECI
C
  140 VECI(1) = VECI(1) + DELA(IDELA  ) - DELB(IDELB  )
      VECI(2) = VECI(2) + DELA(IDELA+1) - DELB(IDELB+1)
      VECI(3) = VECI(3) + DELA(IDELA+2) - DELB(IDELB+2)
C
C     COMPUTE THE LENGTH OF THE BIG V (VECI) VECTOR AND NORMALIZE
C
  150 FL = DSQRT(VECI(1)**2 + VECI(2)**2 + VECI(3)**2)
      IF (FL .EQ. 0.0D0) GO TO 700
      DO 160 I = 1,3
  160 VECI(I) = VECI(I)/FL
C
C     COMPUTE THE SMALL V SUB 0 VECTOR, SMALV0.  ***CHECK THIS LOGIC***
C
      ITA = 1
      ISV = 1
      IF (MCSIDA.EQ.0 .OR. IGSUB0.EQ.0) GO TO 180
      IF (JCSIDA .NE. 39) ITA = 10
      ISV = 4
      CALL GMMATD (TA(ITA),3,3,0, SMALV0(1),3,1,0, SMALV0(4))
C
C     COMPUTE THE K VECTOR, VECK = VECI X SMALV0, AND NORMALIZE
C
  180 VECK(1) =  VECI(2)*SMALV0(ISV+2) - VECI(3)*SMALV0(ISV+1)
      VECK(2) =  VECI(3)*SMALV0(ISV  ) - VECI(1)*SMALV0(ISV+2)
      VECK(3) =  VECI(1)*SMALV0(ISV+1) - VECI(2)*SMALV0(ISV  )
      FLL = DSQRT(VECK(1)**2 + VECK(2)**2 + VECK(3)**2)
      IF (FLL .EQ. 0.0D0) GO TO 700
      VECK(1) =  VECK(1)/FLL
      VECK(2) =  VECK(2)/FLL
      VECK(3) =  VECK(3)/FLL
C
C     COMPUTE THE J VECTOR, VECJ = VECK X VECI, AND NORMALIZE
C
      VECJ(1) =  VECK(2)*VECI(3) - VECK(3)*VECI(2)
      VECJ(2) =  VECK(3)*VECI(1) - VECK(1)*VECI(3)
      VECJ(3) =  VECK(1)*VECI(2) - VECK(2)*VECI(1)
      FLL = DSQRT(VECJ(1)**2 + VECJ(2)**2 + VECJ(3)**2)
      IF (FLL .EQ. 0.0D0) GO TO 700
      VECJ(1) =  VECJ(1)/FLL
      VECJ(2) =  VECJ(2)/FLL
      VECJ(3) =  VECJ(3)/FLL
C
C     SEARCH THE MATERIAL PROPERTIES TABLE FOR E,G AND THE DAMPING
C     CONSTANT.
C
      MATIDC = IMATID
      MATFLG = 1
      ELTEMP = TEMPEL
      CALL MAT (IECPT(1))
C
C     COMPUTE THE RECIPROCALS OF RV1 AND RV2 (CALLING THEM RRV1 AND
C     RRV2)
C
      L = FL
      LSQ = L**2
      LCUBE = LSQ*L
C
C     STORE ECPT AND MPT VARIABLES IN DOUBLE PRECISION LOCATIONS.
C
      DP(1) = E S
      DP(2) = G S
      DP(3) = I1
      DP(4) = I2
      DP(5) = A
      EI1   = DP(1)*DP(3)
      EI2   = DP(1)*DP(4)
      IF (K1 .EQ. 0.0) GO TO 210
      DP(6) = K1
      GAK1  = DP(2)*DP(5)*DP(6)
      RRV1  = (12.0D0*EI1*GAK1)/(GAK1*LCUBE+12.0D0*L*EI1)
      GO TO 220
  210 RRV1  = 12.0D0*EI1/LCUBE
  220 IF (K2 .EQ. 0.0) GO TO 230
      DP(7) = K2
      GAK2  = DP(2)*DP(5)*DP(7)
      RRV2  = (12.0D0*EI2*GAK2)/(GAK2*LCUBE+12.0D0*L*EI2)
      GO TO 240
  230 RRV2  = 12.0D0*EI2/LCUBE
C
C     COMPUTE THE -SMALL- K-S, SK1, SK2, SK3 AND SK4
C
  240 SK1 = 0.25D0*RRV1*LSQ + EI1/L
      SK2 = 0.25D0*RRV2*LSQ + EI2/L
      SK3 = 0.25D0*RRV1*LSQ - EI1/L
      SK4 = 0.25D0*RRV2*LSQ - EI2/L
C
C     COMPUTE THE TERMS THAT WILL BE NEEDED FOR THE 12 X 12 MATRIX KE
C
      TERM1 = DP(5)*DP(1)/L
      TERM2 = 0.5D0*L*RRV1
      TERM3 = 0.5D0*L*RRV2
      DP(8) = FJ
      TERM4 = DP(2)*DP(8)/L
C
C     CONSTRUCT THE 12 X 12 MATRIX KE
C
      DO 250 I = 1,144
  250 KE(  I) =  0.0D0
      KE(  1) =  TERM1
      KE(  7) = -TERM1
      KE( 14) =  RRV1
      KE( 18) = -TERM2
      KE( 20) = -RRV1
      KE( 24) = -TERM2
      KE( 27) =  RRV2
      KE( 29) =  TERM3
      KE( 33) = -RRV2
      KE( 35) =  TERM3
      KE( 40) =  TERM4
      KE( 46) = -TERM4
      KE( 51) =  TERM3
      KE( 53) =  SK2
      KE( 57) = -TERM3
      KE( 59) =  SK4
      KE( 62) = -TERM2
      KE( 66) =  SK1
      KE( 68) =  TERM2
      KE( 72) =  SK3
      KE( 73) = -TERM1
      KE( 79) =  TERM1
      KE( 86) = -RRV1
      KE( 90) =  TERM2
      KE( 92) =  RRV1
      KE( 96) =  TERM2
      KE( 99) = -RRV2
      KE(101) = -TERM3
      KE(105) =  RRV2
      KE(107) = -TERM3
      KE(112) = -TERM4
      KE(118) =  TERM4
      KE(123) =  TERM3
      KE(125) =  SK4
      KE(129) = -TERM3
      KE(131) =  SK2
      KE(134) = -TERM2
      KE(138) =  SK3
      KE(140) =  TERM2
      KE(144) =  SK1
C
C     DETERMINE IF THERE ARE NON-ZERO PIN FLAGS.
C
      KA = IECPT(JPINA)
      KB = IECPT(JPINB)
      IF (KA.EQ.0 .AND. KB.EQ.0) GO TO 325
C
C     SAVE THE KE (UNPINNED) MATRIX IN KES.
C
      DO 255 I = 1,144
  255 KES(I) = KE(I)
C
C     SET UP THE IPIN ARRAY
C
      DO 260 I = 1,5
      IPIN(I  ) = MOD(KA,10)
      IPIN(I+5) = MOD(KB,10) + 6
      IF (IPIN(I+5) .EQ. 6) IPIN(I+5) = 0
      KA = KA/10
  260 KB = KB/10
C
C     ALTER KE MATRIX DUE TO PIN FLAGS.
C
      DO 320 I = 1,10
      IF (IPIN(I) .EQ. 0) GO TO 320
      II = 13*IPIN(I) - 12
      IF (KE(II) .NE. 0.0D0) GO TO 280
      IL = IPIN(I)
      II = II - IL
      DO 270 J = 1,12
      II = II + 1
      KE(II) = 0.0D0
      KE(IL) = 0.0D0
      IL = IL + 12
  270 CONTINUE
      GO TO 320
  280 DO 300 J = 1,12
      JI  = 12*(J-1) + IPIN(I)
      IJ  = 12*(IPIN(I)-1) + J
      DO 290 LL = 1,12
      JLL = 12*(J-1) + LL
      ILL = 12*(IPIN(I)-1) + LL
      KEP(JLL) = KE(JLL) - (KE(ILL)/KE(II))*KE(JI)
  290 CONTINUE
      KEP(IJ) = 0.0D0
      KEP(JI) = 0.0D0
  300 CONTINUE
      DO 310 K = 1,144
  310 KE(K) = KEP(K)
  320 CONTINUE
C
C            E
C     STORE K   IN KEP(1),...,KEP(36) AND
C            AA
C
C            E
C     STORE K   IN KEP(37),...,KEP(72)
C            AB
C
  325 J = 0
      DO 340 I = 1,72,12
      LOW = I
      LIM = LOW + 5
      DO 330 K = LOW,LIM
      J = J + 1
      KEP(J   ) = KE(K  )
  330 KEP(J+36) = KE(K+6)
  340 CONTINUE
C
C                                                            T
C     STORE VECI, VECJ, VECK IN KE(1),...,KE(9) FORMING THE A  MATRIX.
C
      KE(1) = VECI(1)
      KE(2) = VECI(2)
      KE(3) = VECI(3)
      KE(4) = VECJ(1)
      KE(5) = VECJ(2)
      KE(6) = VECJ(3)
      KE(7) = VECK(1)
      KE(8) = VECK(2)
      KE(9) = VECK(3)
C
C     SET POINTERS SO THAT WE WILL BE WORKING WITH POINT A.
C
      BASIC  = ABASIC
      JCSID  = JCSIDA
      OFFSET = AOFSET
      JOFSET = JOFSTA
      IWBEG  = 0
      IKEL   = 1
      IAB    = 1
C
C     ZERO OUT THE ARRAY WHERE THE 3 X 3 MATRIX H AND THE W  AND W
C     6 X 6 MATRICES WILL RESIDE.                          A      B
C
      DO 360 I = 28,108
  360 KE(I) = 0.0D0
C
C     SET UP THE -G- MATRIX.  IG POINTS TO THE BEGINNING OF THE G MATRIX
C     G = AT X TI
C
  365 IG = 1
      IF (BASIC) GO TO 370
      CALL TRANSD (ECPT(JCSID),KE(10))
      CALL GMMATD (KE(1),3,3,0, KE(10),3,3,0, KE(19))
      IG = 19
C
C     IF THERE IS A NON-ZERO OFFSET FOR THE POINT, SET UP THE D 3 X 3
C     MATRIX.
C
  370 IF (.NOT.OFFSET) GO TO 380
      KE(10) =  0.0D0
      KE(11) =  ECPT(JOFSET+2)
      KE(12) = -ECPT(JOFSET+1)
      KE(13) = -KE(11)
      KE(14) =  0.0D0
      KE(15) =  ECPT(JOFSET)
      KE(16) = -KE(12)
      KE(17) = -KE(15)
      KE(18) =  0.0D0
C
C     FORM THE 3 X 3 PRODUCT H = G X D, I.E., KE(28) = KE(IG) X KE(10)
C
      CALL GMMATD (KE(IG),3,3,0, KE(10),3,3,0, KE(28))
C
C
C     FORM THE W  MATRIX OR THE W  MATRIX IN KE(37) OR KE(73) DEPENDING
C               A                B
C     UPON WHICH POINT - A OR B - IS UNDER CONSIDERATION.  G WILL BE
C     STORED IN THE UPPER LEFT AND LOWER RIGHT CORNERS.  H, IF NON-ZERO,
C     WILL BE STORED IN THE UPPER RIGHT CORNER.
C
  380 KE(IWBEG+37) = KE(IG  )
      KE(IWBEG+38) = KE(IG+1)
      KE(IWBEG+39) = KE(IG+2)
      KE(IWBEG+43) = KE(IG+3)
      KE(IWBEG+44) = KE(IG+4)
      KE(IWBEG+45) = KE(IG+5)
      KE(IWBEG+49) = KE(IG+6)
      KE(IWBEG+50) = KE(IG+7)
      KE(IWBEG+51) = KE(IG+8)
      KE(IWBEG+58) = KE(IG  )
      KE(IWBEG+59) = KE(IG+1)
      KE(IWBEG+60) = KE(IG+2)
      KE(IWBEG+64) = KE(IG+3)
      KE(IWBEG+65) = KE(IG+4)
      KE(IWBEG+66) = KE(IG+5)
      KE(IWBEG+70) = KE(IG+6)
      KE(IWBEG+71) = KE(IG+7)
      KE(IWBEG+72) = KE(IG+8)
      IF (.NOT.OFFSET) GO TO 390
      KE(IWBEG+40) = KE(28)
      KE(IWBEG+41) = KE(29)
      KE(IWBEG+42) = KE(30)
      KE(IWBEG+46) = KE(31)
      KE(IWBEG+47) = KE(32)
      KE(IWBEG+48) = KE(33)
      KE(IWBEG+52) = KE(34)
      KE(IWBEG+53) = KE(35)
      KE(IWBEG+54) = KE(36)
C
C                                 E                     E
C     COMPUTE THE PRODUCT S   =  K   X  W   OR  S   =  K    X  W
C                          A      AA     A       B      AB      B
C     WHERE
C                  T                           T
C           W  =  T   X  C  X  E   AND  W  =  T   X  C   X  E
C            A     EB     A     A        B     EB     B      B
C
C     W AT KE(37) AND W AT KE(73) WILL BE USED AGAIN BEFORE FINAL STEPS.
C      A               B
C
  390 CALL GMMATD (KEP(IKEL),6,6,0, KE(IWBEG+37),6,6,0, SA(IAB))
C
C     IF THE POINT UNDER CONSIDERATION IS POINT B WE ARE FINISHED. IF
C     NOT, SET UP POINTS AND INDICATORS FOR WORKING WITH POINT B.
C
      IF (IWBEG .EQ. 36) GO TO 500
      BASIC  = BBASIC
      JCSID  = JCSIDB
      OFFSET = BOFSET
      JOFSET = JOFSTB
      IWBEG  = 36
      IKEL   = 37
      IAB    = 37
      DO 400 I = 28,36
  400 KE(I)  = 0.0D0
      GO TO 365
C
C     BEGIN DIFFERENTIAL STIFFNESS PORTION OF THIS ROUTINE.
C
C     STORE DISPLACEMENT VECTORS IN DOUBLE PRECISION LOCATIONS
C
  500 DO 510 I = 1,6
      UA(I) = ECPT(I+49)
  510 UB(I) = ECPT(I+55)
C
C     COMPUTE  S  X  U   AND  S  X  U
C               A     A        B     B
C
      CALL GMMATD (SA(1),6,6,0, UA,6,1,0, DPVECA)
      CALL GMMATD (SB(1),6,6,0, UB,6,1,0, DPVECB)
C
C     COMPUTE THE NEEDED COMPONENTS OF THE FORCE VECTOR.
C
      FX  = DPVECA(1) + DPVECB(1)
      VY  = DPVECA(2) + DPVECB(2)
      VZ  = DPVECA(3) + DPVECB(3)
      MAY = DPVECA(5) + DPVECB(5)
      MAZ = DPVECA(6) + DPVECB(6)
      MBZ = -MAZ - VY*L
      MBY = -MAY + VZ*L
      E   = E S
      FX  = FX - E*ELDEF/L
      IF (IECPT(49) .EQ. -1) GO TO 520
      ALPHA = ALPHAS
      TSUB0 = TSUB0S
      DP(1) = TEMPER
      FX  = FX - A*ALPHA*E*(DP(1)-TSUB0)
C
C     ZERO OUT THE KD (KC) MATRIX
C
  520 DO 530 I = 1,144
  530 KD(I) = 0.0D0
C
C     FORM THE ELEMENT DIFFERENTIAL STIFFNESS MATRIX (UPPER HALF)
C
      TERM1  = 6.0D0*FX/(5.0D0*L)
      TERM2  = -MAY/L
      TERM3  = FX/10.0D0
      TERM4  = -MBY/L
      TERM5  = -MAZ/L
      TERM6  = -MBZ/L
      DFJ    = I1 + I2
      DA     = A
      TERM7  = DFJ*FX/(L*DA)
      TERM8  = L*VY/6.0D0
      TERM9  = L*VZ/6.0D0
      TERM10 = 2.0D0*L*FX/15.0D0
      TERM11 = L*FX/30.0D0
      KC( 2, 2) =  TERM1
      KC( 2, 4) =  TERM2
      KC( 2, 6) = -TERM3
      KC( 2, 8) = -TERM1
      KC( 2,10) =  TERM4
      KC( 2,12) = -TERM3
      KC( 3, 3) =  TERM1
      KC( 3, 4) =  TERM5
      KC( 3, 5) =  TERM3
      KC( 3, 9) = -TERM1
      KC( 3,10) =  TERM6
      KC( 3,11) =  TERM3
      KC( 4, 4) =  TERM7
      KC( 4, 5) = -TERM8
      KC( 4, 6) = -TERM9
      KC( 4, 8) = -TERM2
      KC( 4, 9) = -TERM5
      KC( 4,10) = -TERM7
      KC( 4,11) =  TERM8
      KC( 4,12) =  TERM9
      KC( 5, 5) =  TERM10
      KC( 5, 9) = -TERM3
      KC( 5,10) =  TERM8
      KC( 5,11) = -TERM11
      KC( 6, 6) =  TERM10
      KC( 6, 8) =  TERM3
      KC( 6,10) =  TERM9
      KC( 6,12) = -TERM11
      KC( 8, 8) =  TERM1
      KC( 8,10) = -TERM4
      KC( 8,12) =  TERM3
      KC( 9, 9) =  TERM1
      KC( 9,10) = -TERM6
      KC( 9,11) = -TERM3
      KC(10,10) =  TERM7
      KC(10,11) = -TERM8
      KC(10,12) = -TERM9
      KC(11,11) =  TERM10
      KC(12,12) =  TERM10
C
C     STORE THE UPPER HALF IN THE LOWER HALF.
C
      DO 550 I = 2,10
      LOW = I + 1
      DO 540 J = LOW,12
      KC(J,I) = KC(I,J)
  540 CONTINUE
  550 CONTINUE
C
C     IF THERE PIN FLAGS, ALTER THE KD MATRIX
C
      IF (KA.EQ.0 .AND. KB.EQ.0) GO TO 620
C
C     ALTER KD DUE TO PIN FLAGS.
C
      DO 610 J = 1,10
      IF (IPIN(J) .EQ. 0) GO TO 610
      JJ = 12*(IPIN(J)-1) + IPIN(J)
      IF (KES(JJ) .EQ. 0.0D0) GO TO 605
      DO 590 I = 1,12
      JI = 12*(IPIN(J)-1) + I
      IJ = 12*(I-1) + IPIN(J)
      DO 580 L1 = 1,12
      IL = 12*(I-1) + L1
      LJ = 12*(L1-1) + IPIN(J)
      KDP(IL) = KD(IL) - KES(LJ)*KD(JI)/KES(JJ) - KES(JI)*KD(LJ)/KES(JJ)
     2        + KES(LJ)* KES(JI)*KD(JJ)/KES(JJ)**2
  580 CONTINUE
  590 CONTINUE
      DO 600 KK = 1,144
  600 KD(KK) = KDP(KK)
C
C     ZERO OUT THE IPIN(J) TH ROW AND COLUMN OF KD.
C
  605 J1 = JJ - IPIN(J)
      J2 = IPIN(J)
      DO 608 KK = 1,12
      J1 = J1 + 1
      KD(J1) = 0.0D0
      KD(J2) = 0.0D0
  608 J2 = J2 + 12
  610 CONTINUE
C
C            D
C     STORE K        AT KEP(1),...,KEP(36)  AND
C            NPVT,A
C
C            D
C           K        AT KEP(37),...,KEP(72)
C            NPVT,B
C
C
  620 J = 0
      IF (IPVT .EQ. 2) GO TO 625
      ILOW = 1
      ILIM = 72
      GO TO 628
  625 ILOW = 73
      ILIM = 144
  628 DO 640 I = ILOW,ILIM,12
      LOW  = I
      LIM  = LOW +5
      DO 630 K = LOW,LIM
      J = J + 1
      KEP(J   ) = KD(K  )
  630 KEP(J+36) = KD(K+6)
  640 CONTINUE
C
C     COMPUTE THE FINAL 2 6X6 DIFFERENTIAL STIFFNESS MATRICES FOR THIS
C     BEAM.
C
      IWLEFT = 37
      IF (IPVT .EQ. 2) IWLEFT = 73
      I = 1
      IKDE = 1
      IWRGHT = 37
  650 CALL GMMATD (KE(IWLEFT),6,6,1, KEP(IKDE),6,6,0, KEP(73))
      CALL GMMATD (KEP(73),6,6,0, KE(IWRGHT),6,6,0, KEP(109))
      CALL DS1B (KEP(109),ISILNO(I))
      IF (I .EQ. 2) RETURN
      I = 2
      IKDE = 37
      IWRGHT = 73
      GO TO 650
C
C     FATAL ERROR
C
  700 CALL MESAGE (30,26,IECPT(1))
C
C     SET FLAG FOR FATAL ERROR WHILE ALLOWING ERROR MESSAGES TO
C     ACCUMULATE
C
      NOGO = 1
      RETURN
      END

      SUBROUTINE DELSCR
C
C     THIS SUBROUTINE IS CALLED AT THE BEGINNING OF EACH FUNCTIONAL
C     MODULE TO PHYSICALLY DELETE ALL SCRATCH FILES USED BY A
C     PREVIOUS FUNCTIONAL MODULE
C
      INTEGER*2       IUNIT
C
      COMMON /DSUNIT/ IUNIT(220)
      COMMON /XFIST / IFIST(2)
      COMMON /XPFIST/ IPFIST
      INCLUDE 'DSIOF.COM'
C
      DATA MASK / 32767 /
C
      NFILES = IFIST(2) - IPFIST
      IF (NFILES .EQ. 0) RETURN
      ISTR = IPFIST + 1
      IEND = IFIST(2)
      DO 100 I = ISTR, IEND
      IFILE = IFIST(2*I+1)
      IF (IFILE.LT.301 .OR. IFILE.GT.320) GO TO 100
      IFILEX = 0
      CALL GETURN (IFILE)
      IF (IFILEX .EQ. MASK) GO TO 100
      CALL DBMMGR ( 7 )
  100 CONTINUE
      RETURN
      END

      SUBROUTINE CMRD2C (ITER)
C
C     THIS SUBROUTINE PERFORMS THE GUYAN REDUCTION ON THE STRUCTURE
C     POINTS FOR THE CMRED2 MODULE.
C
C     INPUT  DATA
C     GINO - KII    - KII PARTITION MATRIX
C            KIB    - KIB KIB PARTITION MATRIX
C     SOF  - GIMS   - G TRANSFORMATION MATRIX FOR BOUNDARY POINTS OF
C                      ORIGINAL SUBSTRUCTURE
C
C     OUTPUT DATA
C     SOF  - LMTX   - LII PARTITION MATRIX
C            GIMS   - G TRANSFORMATION MATRIX FOR BOUNDARY POINTS OF
C                    ORIGINAL SUBSTRUCTURE
C
C     PARAMETERS
C     INPUT- GBUF   - GINO BUFFER
C            ISCR   - SCRATCH FILE NUMBER ARRAY
C            KORLEN - LENGTH OF OPEN CORE
C            KORBGN - BEGINNING ADDRESS OF OPEN CORE
C            OLDNAM - NAME OF SUBSTRUCTURE BEGING REDUCED
C            RSAVE  - DECOMPOSITION SAVE FLAG
C     OTHERS-KII    - KII PARTITION MATRIX FILE NUMBER
C            LII    - LII PARTITION MATRIX FILE NUMBER
C            SYMTRY - KII SYMMETRY FLAG
C
      LOGICAL         RSAVE,RESTOR,SYMTRY
      INTEGER         DRY,SBUF1,SBUF2,SBUF3,OLDNAM,Z,POWER,CHLSKY,UIITC,
     1                SCR,POWERC,B,BBAR,U,GIBT,PREC,SIGN,UGFBS,GIBFBS,
     2                PREC1,ATRLR,ATTRLR,GIB,UII,DBLKOR,UPPER,HIM
      DOUBLE PRECISION DETR,DETI,MINDIA,DET,MINDC,DZ
      DIMENSION       ITRLR(7),MODNAM(2),ITMLST(3),DZ(1)
      CHARACTER       UFM*23,UWM*25
      COMMON /XMSSG / UFM,UWM
      COMMON /BLANK / IDUM1,DRY,IDUM4(4),SBUF1,SBUF2,SBUF3,IDUM3(11),
     1                OTFILE(6),ISCR(11),KORLEN,KORBGN,OLDNAM(2),
     2                IDUM2(8),RSAVE,IDUM6(4),LSTZWD
      COMMON /ZZZZZZ/ Z(1)
      COMMON /SFACT / KIIT(7),LIIT(7),ISCRQ(7),ISCRA,ISCRB,NZSF,
     1                DETR,DETI,POWER,ISCRC,MINDIA,CHLSKY
      COMMON /CDCMPX/ KIITC(7),LIITC(7),UIITC(7),SCR(3),DET(2),POWERC,
     1                NX,MINDC,B,BBAR
      COMMON /FBSX  / LIIFBS(7),U(7),KIBT(7),GIBT(7),NZFBS,PREC,SIGN
      COMMON /GFBSX / LIGFBS(7),UGFBS(7),KIGFBS(7),GIBFBS(7),NZGFBS,
     1                PREC1,ISIGN
      COMMON /TRNSPX/ ATRLR(7),ATTRLR(7),LCORE,NSCRTH,ISCRTH(8)
      COMMON /SYSTEM/ IDUM5,IPRNTR
      EQUIVALENCE     (KIB,ISCR(2)),(KBI,ISCR(3)),(KII,ISCR(4)),
     1                (LII,ISCR(8)),(UII,ISCR(9)),(HIM,ISCR(10)),
     2                (GIB,ISCR(11)),(DZ(1),Z(1))
      DATA    MODNAM/ 4HCMRD,4H2C  /
      DATA    LOWER , UPPER /4,5   /
      DATA    ITMLST/ 4HLMTX,4HGIMS,4HHORG/
C
C     PREFORM GUYAN REDUCTION
C
      IF (DRY .EQ. -2) GO TO 130
      RESTOR = .FALSE.
C
C     TRANSPOSE KII, KBI
C
      IF (ITER .EQ. 1) GO TO 8
      IF (SYMTRY) GO TO 37
    1 DBLKOR = (KORBGN/2) + 1
      LCORE  = LSTZWD - ((2*DBLKOR)-1)
      NSCRTH = 5
      DO 2 I = 1,NSCRTH
    2 ISCRTH(I) = ISCR(4+I)
      DO 6 I = 1,2
      ITRLR(1) = KII
      IF (I .EQ. 2) ITRLR(1) = KBI
      CALL RDTRL (ITRLR)
      DO 4 J = 1,7
      ATRLR(J) = ITRLR(J)
    4 ATTRLR(J) = ITRLR(J)
      ATTRLR(2) = ITRLR(3)
      ATTRLR(3) = ITRLR(2)
      CALL TRNSP (DZ(DBLKOR))
    6 CALL WRTTRL (ATTRLR)
      IF (RESTOR) CALL SOFOPN (Z(SBUF1),Z(SBUF2),Z(SBUF3))
      IF (RESTOR) GO TO 39
      RESTOR = .TRUE.
      CALL SOFCLS
      GO TO 16
C
C     DECOMPOSE INTERIOR STIFFNESS MATRIX
C        (SYMMETRIC)
C
C                                 T
C        **   **   **   ** **   **
C        *     *   *     * *     *
C        * KII * = * LII * * LII *
C        *     *   *     * *     *
C        **   **   **   ** **   **
C
    8 CALL SOFCLS
      KIIT(1) = KII
      CALL RDTRL (KIIT)
      IF (KIIT(4) .NE. 6) GO TO 12
      SYMTRY = .TRUE.
      IPRC = 1
      ITYP = 0
      IF (KIIT(5).EQ.2 .OR. KIIT(5).EQ.4) IPRC = 2
      IF (KIIT(5) .GE. 3) ITYP = 2
      ITYPE = IPRC + ITYP
      CALL MAKMCB (LIIT,LII,KIIT(3),LOWER,ITYPE)
      ISCRQ(1) = ISCR(5)
      ISCRA  = ISCR(6)
      ISCRB  = ISCR(7)
      ISCRC  = ISCR(9)
      CHLSKY = 0
      POWER  = 1
      DBLKOR = (KORBGN/2) + 1
      NZSF   = LSTZWD - ((2*DBLKOR)-1)
      CALL SDCOMP (*40,DZ(DBLKOR),DZ(DBLKOR),DZ(DBLKOR))
      CALL WRTTRL (LIIT)
      GO TO 18
C
C     DECOMPOSE INTERIOR STIFFNESS MATRIX
C        (UNSYMMETRIC)
C
C        **   **   **   ** **   **
C        *     *   *     * *     *
C        * KII * = * LII * * UII *
C        *     *   *     * *     *
C        **   **   **   ** **   **
C
   12 SYMTRY = .FALSE.
   16 KIITC(1) = KII
      CALL RDTRL (KIITC)
      ITYP = 0
      IPRC = 1
      IF (KIITC(5).EQ.2 .OR. KIITC(5).EQ.4) IPRC = 2
      IF (KIITC(5) .GE. 3) ITYP = 2
      ITYPE = IPRC + ITYP
      CALL MAKMCB (LIITC,LII,KIITC(3),LOWER,ITYPE)
      CALL MAKMCB (UIITC,UII,KIITC(3),UPPER,ITYPE)
      SCR(1) = ISCR(5)
      SCR(2) = ISCR(6)
      SCR(3) = ISCR(7)
      B      = 0
      BBAR   = 0
      DBLKOR = (KORBGN/2) + 1
      NX = LSTZWD - ((2*DBLKOR)-1)
      CALL CDCOMP (*42,DZ(DBLKOR),DZ(DBLKOR),DZ(DBLKOR))
      CALL WRTTRL (LIITC)
      CALL WRTTRL (UIITC)
C
C     SAVE LII AS LMTX ON SOF
C
   18 IF (ITER.EQ.2 .OR. .NOT.RSAVE) GO TO 20
      CALL SOFOPN (Z(SBUF1),Z(SBUF2),Z(SBUF3))
      IFILE = LII
      CALL MTRXO (LII,OLDNAM,ITMLST(1),0,ITEST)
      ITEM = ITMLST(1)
      IF (ITEST .NE. 3) GO TO 70
      CALL SOFCLS
C
C     SOLVE STRUCTURE REDUCTION TRANSFORMATION MATRIX
C        (SYMMETRIC)
C
C                       T
C        **   ** **   ** **   **    **   **
C        *     * *     * *     *    *     *
C        * LII * * LII * * GIB * = -* KIB *
C        *     * *     * *     *    *     *
C        **   ** **   ** **   **    **   **
C
   20 IF (.NOT.SYMTRY) GO TO 32
      KIBT(1) = KIB
      IF (ITER .EQ. 2) KIBT(1) = KBI
      CALL RDTRL (KIBT)
      DO 30 I = 1,7
   30 LIIFBS(I) = LIIT(I)
      IPRC = 1
      ITYP = 0
      IF (KIBT(5).EQ.2 .OR. KIBT(5).EQ.4) IPRC = 2
      IF (LIIT(5).EQ.2 .OR. LIIT(5).EQ.4) IPRC = 2
      IF (KIBT(5) .GE. 3) ITYP = 2
      IF (LIIT(5) .GE. 3) ITYP = 2
      ITYPE = IPRC + ITYP
      CALL MAKMCB (GIBT,GIB,KIBT(3),KIBT(4),ITYPE)
      NZFBS = LSTZWD - ((2*DBLKOR)-1)
      PREC  = KIBT(5) - 2
      SIGN  = -1
      CALL FBS (DZ(DBLKOR),DZ(DBLKOR))
      CALL WRTTRL (GIBT)
      GO TO 36
C
C     SOLVE STRUCTURE REDUCTION TRANSFORMATION MATRIX
C        (UNSYMMETRIC)
C
C        **   ** **   ** **   **    **   **
C        *     * *     * *     *    *     *
C        * LII * * UII * * GIB * = -* KIB *
C        *     * *     * *     *    *     *
C        **   ** **   ** **   **    **   **
C
   32 KIGFBS(1) = KIB
      IF (ITER .EQ. 2) KIGFBS(1) = KBI
      CALL RDTRL (KIGFBS)
      DO 34 I = 1,7
      LIGFBS(I) = LIITC(I)
   34 UGFBS(I)  = UIITC(I)
      IPRC = 1
      ITYP = 0
      IF (KIGFBS(5).EQ.2 .OR. KIGFBS(5).EQ.4) IPRC = 2
      IF (LIITC(5) .EQ.2 .OR. LIITC(5) .EQ.4) IPRC = 2
      IF (UIITC(5) .EQ.2 .OR. UIITC(5) .EQ.4) IPRC = 2
      IF (KIGFBS(5) .GE. 3) ITYP = 2
      IF (LIITC(5)  .GE. 3) ITYP = 2
      IF (UIITC(5)  .GE. 3) ITYP = 2
      ITYPE = IPRC + ITYP
      CALL MAKMCB (GIBFBS,GIB,KIGFBS(3),KIGFBS(4),ITYPE)
      NZGFBS = LSTZWD - ((2*DBLKOR)-1)
      PREC1  = IPRC
      ISIGN  = -1
      CALL GFBS (DZ(DBLKOR),DZ(DBLKOR))
      CALL WRTTRL (GIBFBS)
C
C     SAVE GIB AS GIMS ON SOF
C
   36 IF (RESTOR) GO TO 1
      IF (ITER .EQ. 2) GO TO 39
      CALL SOFOPN (Z(SBUF1),Z(SBUF2),Z(SBUF3))
      IFILE = GIB
      CALL MTRXO (GIB,OLDNAM,ITMLST(2),0,ITEST)
      ITEM = ITMLST(2)
      IF (ITEST .NE. 3) GO TO 70
      GO TO 39
C
C     KII SYMMETRIC, GIBBAR = GIB
C
   37 ITEM = ITMLST(2)
      CALL MTRXI (GIBBAR,OLDNAM,ITEM,0,ITEST)
      IF (ITEST .NE. 1) GO TO 70
   39 CONTINUE
      GO TO 130
C
C     PROCESS SYSTEM FATAL ERRORS
C
   40 WRITE (IPRNTR,903) UWM,OLDNAM
      GO TO 44
   42 WRITE (IPRNTR,904) UWM,OLDNAM
   44 IMSG  = -37
      IFILE = 0
      CALL SOFCLS
      CALL MESAGE (IMSG,IFILE,MODNAM)
      GO TO 130
C
C     PROCESS MODULE FATAL ERRORS
C
   70 GO TO (80,82,84,90,100,120), ITEST
   80 WRITE (IPRNTR,900) UFM,MODNAM,ITEM,OLDNAM
      DRY = -2
      GO TO 130
C
   82 WRITE (IPRNTR,902) UFM,MODNAM,ITEM,OLDNAM
      DRY = -2
      GO TO 130
C
   84 IMSG = -1
      GO TO 110
   90 IMSG = -2
      GO TO 110
  100 IMSG = -3
  110 CALL SMSG (IMSG,ITEM,OLDNAM)
      GO TO 130
C
  120 WRITE (IPRNTR,901) UFM,MODNAM,ITEM,OLDNAM
      DRY = -2
  130 RETURN
C
  900 FORMAT (A23,' 6211, MODULE ',2A4,' - ITEM ',A4,
     1       ' OF SUBSTRUCTURE ',2A4,' HAS ALREADY BEEN WRITTEN.')
  901 FORMAT (A23,' 6632, MODULE ',2A4,' - NASTRAN MATRIX FILE FOR I/O',
     1       ' OF SOF ITEM ',A4,', SUBSTRUCTURE ',2A4,', IS PURGED.')
  902 FORMAT (A23,' 6215, MODULE ',2A4,' - ITEM ',A4,
     1       ' OF SUBSTRUCTURE ',2A4,' PSEUDO-EXISTS ONLY.')
  903 FORMAT (A25,' 6311, SDCOMP DECOMPOSITION FAILED ON KII MATRIX ',
     1       'FOR SUBSTRUCTURE ',2A4)
  904 FORMAT (A23,' 6635, CDCOMP DECOMPOSITION FAILED ON KII MATRIX ',
     1       'FOR SUBSTRUCTURE ',2A4)
C
      END

      SUBROUTINE RCOVEM (NOEXCL,NROWE)
C
C     THIS SUBROUTINE CALCULATES THE ENERGIES ON THE MODAL COORDINATES
C     THAT WERE EXCLUDED FROM THE MODAL REDUCTION PROCESSING
C
      LOGICAL         NOEXCL
      INTEGER         RSS        ,RC         ,RULE       ,SOF1       ,
     1                SOF2       ,SOF3       ,BUF1       ,BUF2       ,
     2                Z          ,QA         ,PA         ,SCR3       ,
     3                SCR4       ,SCR5       ,SCR6       ,SCR7       ,
     4                SCR8       ,PHIS       ,SOLN       ,TYPA       ,
     5                TYPB       ,TFLAG      ,SIGNAB     ,SIGNC      ,
     6                BUF3       ,RSP        ,CSP        ,NAME(2)    ,
     7                RFNO
      REAL            RZ(5)
      COMPLEX         SC         ,CZ(2)      ,SC2        ,DKDC       ,
     1                DKSC
      CHARACTER       UFM*23     ,UWM*25
      COMMON /XMSSG / UFM        ,UWM
      COMMON /BLANK / DRY        ,LOOP       ,STEP       ,FSS(2)     ,
     1                RFNO       ,NEIGV      ,LUI        ,UINMS(2,5) ,
     2                NOSORT     ,UTHRES     ,PTHRES     ,QTHRES
      COMMON /RCOVCR/ ICORE      ,LCORE      ,BUF1       ,BUF2       ,
     1                BUF3       ,BUF4       ,SOF1       ,SOF2       ,
     2                SOF3
      COMMON /RCOVCM/ MRECVR     ,UA         ,PA         ,QA         ,
     1                IOPT       ,RSS(2)     ,ENERGY     ,UIMPRO     ,
     2                RANGE(2)   ,IREQ       ,LREQ       ,LBASIC
      COMMON /CONDAS/ PHI        ,TWOPHI
      COMMON /SYSTEM/ SYSBUF     ,NOUT
      COMMON /ZZZZZZ/ Z(1)
      COMMON /PACKX / ITINP      ,ITOUTP     ,IRP        ,NRP        ,
     1                INCRP
      COMMON /UNPAKX/ ITINU      ,IRU        ,NRU        ,INCRU
      COMMON /NAMES / RD         ,RDREW      ,WRT        ,WRTREW     ,
     1                REW        ,NOREW      ,EOFNRW     ,RSP        ,
     2                RDP        ,CSP        ,CDP        ,SQUARE     ,
     3                RECT
      COMMON /PARMEG/ MCBP(7)    ,MCBP11(7)  ,MCBP21(7)  ,MCBP12(7)  ,
     1                MCBP22(7)  ,MRGZ       ,RULE
      COMMON /SADDX / NOMAT      ,LCOREZ     ,MCBAA(7)   ,TYPA       ,
     1                ALPHA      ,ALP(3)     ,MCBBB(7)   ,TYPB       ,
     2                BETA       ,BET(3)     ,DUM(36)    ,MCBXX(7)
      COMMON /MPYADX/ MCBA(7)    ,MCBB(7)    ,MCBC(7)    ,MCBD(7)    ,
     1                MPYZ       ,TFLAG      ,SIGNAB     ,SIGNC      ,
     2                MPREC      ,MSCR
      EQUIVALENCE     (Z(1),RZ(1),CZ(1))     ,(CZ(2),SC)
      DATA    LAMS  , PHIS,SOLN  /4HLAMS,4HPHIS,4HSOLN /
      DATA    SCR3  , SCR4,SCR5,SCR6,SCR7,SCR8 /303,304,305,306,307,308/
      DATA    NAME  / 4HRCOV,4HEM   /
C
C     INITILIZE
C
      LCOREZ = KORSZ(Z)
C
C     FROM THE LAST GROUP ON LAMS CREATE A PARTITIONING VECTOR TO
C     DIFFERENTIATE THE INCLUDED AND EXCLUDED MODES
C
      NROWE = 0
      ITEM  = LAMS
      CALL SFETCH (RSS,LAMS,1,RC)
      IF (RC .NE. 1) GO TO 6000
      N = 2
      CALL SJUMP (N)
      IF (N .LT. 0) GO TO 6200
      I = 0
C
   10 CALL SUREAD (ICODE,1,N,RC)
      IF (RC .NE. 1) GO TO 20
      I = I + 1
      IF (I .GT. BUF1) GO TO 9008
      RZ(I) = 1.0
      IF (ICODE .EQ. 1) GO TO 10
      RZ(I) = 0.0
      NROWE = NROWE + 1
      GO TO 10
C
   20 CONTINUE
      IF (NROWE .EQ. 0) GO TO 900
      IF (QA+PA .EQ. 0) GO TO 9200
      ITINP  = RSP
      ITOUTP = RSP
      IRP   = 1
      NRP   = I
      INCRP = 1
      CALL MAKMCB (MCBA,SCR8,NRP,RECT,RSP)
      CALL GOPEN  (SCR8,Z(BUF1),WRTREW)
      CALL PACK   (RZ(1),SCR8,MCBA)
      CALL CLOSE  (SCR8,REW)
      CALL WRTTRL (MCBA)
C
C     PARTITION THE EIGENVECTOR TO GET THE EXCLUDED MODES OUT
C
      ITEM = PHIS
      CALL MTRXI (SCR7,RSS,PHIS,0,RC)
      IF (RC .NE. 1) GO TO 6000
      RULE = 0
      MCBP(1) = SCR7
      CALL RDTRL (MCBP)
      IF (MCBP(2) .NE. NRP) GO TO 6372
      CALL MAKMCB (MCBP11,SCR6,MCBP(3),RECT,MCBP(5))
      MCBP11(2) = NROWE
      MCBP21(1) = 0
      MCBP12(1) = 0
      MCBP22(1) = 0
C
C     SETUP NULL COLUMN PARTITONING VECTOR
C
      CALL MAKMCB (MCBB,0,MCBP(3),RECT,RSP)
      MCBB(2) = 1
      MRGZ = LCOREZ
      CALL SOFCLS
C
      CALL PARTN (MCBA,MCBB,Z(1))
C
      CALL WRTTRL (MCBP11)
C
C     IF BOTH LOADS AND SINGLE POINT CONSTRAINT FORCES EXIST, ADD
C     THEM TOGETHER
C
      IRH = QA + PA
      IF (QA.EQ.0 .OR. PA.EQ.0) GO TO 100
      NOMAT = 2
      TYPA  = 1
      ALPHA = 1.0
      MCBAA(1) = QA
      CALL RDTRL (MCBAA)
      TYPB = 1
      BETA = 1.0
      MCBBB(1) = PA
      CALL RDTRL (MCBBB)
      CALL MAKMCB (MCBXX,SCR7,MCBAA(3),RECT,MCBAA(5))
      MCBXX(2) = MCBAA(2)
C
      CALL SADD (Z(1),Z(1))
C
      CALL WRTTRL (MCBXX)
      IRH = SCR7
C
C     MULTIPLY   PK = QK(T)*(PA + QA)
C
  100 DO 110 I = 1,7
  110 MCBA(I) = MCBP11(I)
      MCBB(I) = IRH
      CALL RDTRL (MCBB)
      MCBC(1) = 0
      MPYZ   = LCOREZ
      TFLAG  = 1
      SIGNAB = 1
      SIGNC  = 1
      MPREC  = 0
      MSCR   = SCR8
      CALL MAKMCB (MCBD,SCR5,NROWE,RECT,MCBA(5))
C
      CALL MPYAD (Z(1),Z(1),Z(1))
C
C     READ MODAL MASS AND TWOPHI*FREQUENCY FOR EACH OF THE EXCLUDED
C     MODES MODES FROM LAMS
C     IF MODE WAS EXCLUDED BECAUSE OF NON-PARTICIPATION, SET ITS
C     FREQUENCY TO ZERO
C
      CALL SOFOPN (Z(SOF1),Z(SOF2),Z(SOF3))
      ITEM = LAMS
      CALL SFETCH (RSS,LAMS,1,RC)
      IF (RC .NE. 1) GO TO 6000
      N = 1
      CALL SJUMP (N)
      IF (N .LE. 0) GO TO 6200
      IMODE = 8
      CALL SUREAD (Z(IMODE),-1,N,RC)
      IF (RC .NE. 2) GO TO 6100
      NMODE = IMODE + N - 1
      IF (NMODE .GT. BUF3) GO TO 9008
      ICODE = NMODE + 1
      CALL SUREAD (Z(ICODE),-1,N,RC)
      IF (RC.NE.2 .AND. RC.NE.3) GO TO 6100
      NCODE = ICODE + N - 1
      IF (NCODE .GT. BUF3) GO TO 9008
C
      I1 = IMODE - 7
      I2 = IMODE - 2
      DO 250 I = ICODE,NCODE
      I1 = I1 + 7
      IF (Z(I) .EQ. 1) GO TO 250
      I2 = I2 + 2
      RZ(I2) = RZ(I1+3)
      IF (Z(I).EQ.2 .OR. RZ(I2).LE.0.001) RZ(I2) = 0.0
      RZ(I2+1) = RZ(I1+5)
  250 CONTINUE
      NMODE = I2 + 1
C
C     POSITION SOLN ITEM TO SOLUTION DATA
C
      ITEM = SOLN
      CALL SFETCH (RSS,SOLN,1,RC)
      IF (RC .NE. 1) GO TO 6000
      N = 1
      CALL SJUMP (N)
      IF (N .LT. 0) GO TO 6200
C
C     SET UP TO LOOP OVER COLUMNS
C
      NCOL  = MCBD(2)
      NWORD = 1
      IF (MCBD(5) .GE. 3) NWORD = 2
      IVEC1 = (NMODE/2)*2 + 3
      ICVEC1= IVEC1/2 + 1
      IVEC2 = IVEC1 + (NROWE*NWORD/2) * 2 + 1
      IF (IVEC2+NROWE .GT. BUF3) GO TO 9008
C
      CALL GOPEN (SCR5,Z(BUF1),RDREW)
      CALL GOPEN (SCR3,Z(BUF2),WRTREW)
      CALL GOPEN (SCR4,Z(BUF3),WRTREW)
      CALL MAKMCB (MCBA,SCR3,NROWE,RECT,RSP)
      CALL MAKMCB (MCBB,SCR4,NROWE,RECT,RSP)
C
      ITINU = RSP
      IF (MCBD(5) .GE. 3) ITINU = CSP
      IRU = 1
      NRU = NROWE
      INCRU = 1
      NRP = NROWE
C
C     LOOP OVER EACH SOLUTION STEP
C
      DO 700 ICOL = 1,NCOL
C
C     GET FREQUENCY OR POLE FROM SOLN ITEM FOR THIS STEP
C
      IF (RFNO .GT. 3) GO TO 310
      CALL SUREAD (RZ(1),7,N,RC)
      IF (RC .NE. 1) GO TO 6100
      IF (MCBD(5) .GE. 3) GO TO 300
      FREQ = RZ(5)
      S2   = -(TWOPHI*FREQ)**2
      GO TO 320
C
  300 SC  = CZ(2)
      SC2 = SC*SC
      GO TO 320
C
  310 CALL SUREAD (RZ(1),1,N,RC)
      IF (RC .NE. 1) GO TO 6100
      SC  = TWOPHI*RZ(1)*(0.0,1.0)
      SC2 = SC*SC
C
C     UNPACK THE NEXT COLUMN
C
  320 CALL UNPACK (*330,SCR5,RZ(IVEC1))
      GO TO 350
  330 DO 340 I = 1,NROWE
      J = I - 1
      RZ(IVEC1+J) = 0.0
  340 RZ(IVEC2+J) = 0.0
      GO TO 600
C
  350 IF (MCBD(5) .GE. 3) GO TO 500
C
C     CALCULATE ENERGIES FOR REAL MATRICIES
C
      IM = IMODE - 2
      DO 410 I = 1,NROWE
      IM = IM + 2
      J  = I - 1
      IF (RZ(IM).EQ.0.0 .OR. (TWOPHI*FREQ).GT.RZ(IM)) GO TO 400
      WK2 = RZ(IM)**2
C
      DKD =-S2*RZ(IVEC1+J)/(RZ(IM+1)*WK2**2*(1.0 + S2/WK2))
      DKS = RZ(IVEC1+J)/(RZ(IM+1)*WK2)
C
      RZ(IVEC2+J) = .5*RZ(IM+1)*WK2*ABS((2.0*DKS+DKD)*DKD)
      RZ(IVEC1+J) = ABS(S2/WK2)*RZ(IVEC2+J)
      GO TO 410
C
  400 RZ(IVEC1+J) = 0.0
      RZ(IVEC2+J) = 0.0
C
  410 CONTINUE
      GO TO 600
C
C     CALCULATE ENERGIES FOR COMPLEX VECTORS
C
  500 IM = IMODE - 2
      DO 520 I = 1,NROWE
      IM = IM + 2
      J  = I - 1
      IF (RZ(IM).EQ.0.0 .OR. AIMAG(SC).GT.RZ(IM)) GO TO 510
      WK2 = RZ(IM)**2
C
      DKDC =-SC2*CZ(ICVEC1+J)/(RZ(IM+1)*WK2**2*(1.0+SC2/WK2))
      DKSC = CZ(ICVEC1+J)/(RZ(IM+1)*WK2)
C
      RZ(IVEC2+J) = .5*RZ(IM+1)*WK2*CABS((2.0*DKSC+DKDC)*DKDC)
      RZ(IVEC1+J) = CABS(SC**2/WK2)*RZ(IVEC2+J)
      GO TO 520
C
  510 RZ(IVEC1+J) = 0.0
      RZ(IVEC2+J) = 0.0
C
  520 CONTINUE
C
C     PACK OUT THE KENETIC AND POTENTIAL ENERGIES
C
  600 CALL PACK (RZ(IVEC1),SCR3,MCBA)
      CALL PACK (RZ(IVEC2),SCR4,MCBB)
C
  700 CONTINUE
C
      CALL CLOSE (SCR5,REW)
      CALL CLOSE (SCR3,REW)
      CALL CLOSE (SCR4,REW)
      CALL WRTTRL (MCBA)
      CALL WRTTRL (MCBB)
C
C     NORMAL RETURN
C
      RETURN
C
C     NO EXECLUDED MODES EXIST
C
  900 NOEXCL = .TRUE.
      RETURN
C
C     ERRORS
C
 6000 CALL SMSG (RC-2,ITEM,RSS)
      GO TO 9200
 6100 CALL SMSG (RC+4,ITEM,RSS)
      GO TO 9200
 6200 CALL SMSG (7,ITEM,RSS)
      GO TO 9200
 6372 WRITE (NOUT,6373) UWM,RSS
      GO TO 9200
 9008 CALL MESAGE (8,0,NAME)
 9200 WRITE (NOUT,6371) UWM,RSS
      NOEXCL = .TRUE.
      CALL CLOSE (SCR3,REW)
      CALL CLOSE (SCR4,REW)
      CALL CLOSE (SCR5,REW)
      RETURN
C
C     FORMAT STATEMENTS
C
 6371 FORMAT (A25,' 6371, CALCULATIONS FOR EXCLUDED MODE ENERGIES FOR',
     1       ' SUBSTRUCTURE ',2A4,' ABORTED.')
 6373 FORMAT (A25,' 6372, THE PHIS AND LAMS ITEMS ARE INCONSISTANT FOR',
     2       ' SUBSTRUCTURE ',2A4)
      END

      SUBROUTINE ITMPRT (NAME,ITEM,NZ,IOPT)
C
C     WILL PRINT SOF ITEM - USING  E15.7,I10, OR ALPHA FORMAT
C
      INTEGER         SYSBUF,OTPE,TWO1,RC
      REAL            SUBS(3),ITM,ITEM,NAME,LODS,LOAP
      DIMENSION       ICORE(4),NAME(2)
      CHARACTER*1     CCORE(2000)
      CHARACTER       UFM*23,UWM*25
      COMMON /MACHIN/ MACHX
      COMMON /XMSSG / UFM,UWM
      COMMON /SYSTEM/ SYSBUF,OTPE,INX(6),NLPP,INX1(2),LINE,INX2(26)
      COMMON /ZZZZZZ/ CORE(1)
      COMMON /TWO   / TWO1(32)
      COMMON /OUTPUT/ HEAD1(96),HEAD2(96)
      EQUIVALENCE     (CCORE,CORE)
      EQUIVALENCE     (ICORE(1),CORE(1))
      DATA    OPAREN, CPAREN,EC,EC1,EC2,INTGC,ALPHC,ALPHC1,CONT,UNED,D/
     1        4H(1X , 4H)   ,4H,1P,,4HE13.,4H6   ,4H,I13,4H,9X,,4HA4  ,
     2        4HCONT, 4HINUE,4HD   /
      DATA    BLANK , SUBS,ITM/4H    ,4HSUBS,4HTRUC,4HTURE,4HITEM/
      DATA    EQSS  / 4HEQSS/, BGSS/4HBGSS/, CSTM/4HCSTM /,
     1        PLTS  / 4HPLTS/, LODS/4HLODS/, LOAP/4HLOAP /
C
C
C     TEST FOR FORMATED TABLE PRINT
C
      IF (IOPT .NE. 2) GO TO 5
      IF (ITEM .EQ. EQSS) GO TO 2000
      IF (ITEM .EQ. BGSS) GO TO 2100
      IF (ITEM .EQ. CSTM) GO TO 2200
      IF (ITEM .EQ. PLTS) GO TO 2300
      IF (ITEM .EQ. LODS) GO TO 2400
      IF (ITEM .EQ. LOAP) GO TO 2500
    5 CONTINUE
C
C     PERFORM UNFORMATED DUMP OF TABLE
C
      CALL SFETCH (NAME,ITEM,1,RC)
      IF (RC .NE. 1) GO TO 190
      DO 10 I = 1,96
   10 HEAD2(I) = BLANK
      DO 15 I = 1,3
   15 HEAD2( I) = SUBS(I)
      HEAD2( 5) = NAME(1)
      HEAD2( 6) = NAME(2)
      HEAD2( 8) = ITM
      HEAD2(10) = ITEM
      CALL PAGE
      HEAD2(12) = CONT
      HEAD2(13) = UNED
      HEAD2(14) = D
      INUM = NZ/2 - 1
      NS   = INUM + 1
      LLEN = 0
      CORE(1) = OPAREN
      IREC = 0
   20 WRITE (OTPE,30)IREC
      IREC = IREC + 1
   30 FORMAT ('0GROUP NO.',I4)
      LINE = LINE + 2
      IF (LINE .GE. NLPP) CALL PAGE
      IX   = INUM
      NRED = 0
      NP   = INUM - 1
      IV   = 4
   40 IX   = IX + 1
      IOUT = 4
      NRED = NRED + 1
      NP   = NP + 1
      CALL SUREAD (CORE(IX),1,FLAG,RC)
      IF (RC-2) 45,160,170
   45 I  = NUMTYP(CORE(IX)) + 1
      IF (I.EQ.1 .AND. IV.NE.4) I = IV
      IV = I
      GO TO (140,140,100,120), I
C
C     REAL NUMBER  (1)
C
  100 IOUT = 1
      IF (LLEN+13 .GT. 132) GO TO 160
  110 CORE(NRED+1) = EC
      CORE(NRED+2) = EC1
      CORE(NRED+3) = EC2
      NRED = NRED + 2
  111 LLEN = LLEN + 13
      GO TO 40
C
C     ALPHA   (2)
C
  120 IOUT = 2
      IF (LLEN+6 .GT. 132) GO TO 160
  130 CORE(NRED+1) = ALPHC
      CORE(NRED+2) = ALPHC1
      NRED = NRED + 1
      GO TO 111
C
C     INTEGER  (3)
C
  140 IOUT = 3
      IF (LLEN+13 .GT. 132) GO TO 160
  150 ICORE(NRED+1) = INTGC
      GO TO 111
C
C     BUFFER FULL - END RECORD   PRINT LINE
C
  160 CORE(NRED+1) = CPAREN
      IF (NRED .EQ. 1) WRITE (OTPE,161)
      IF (NRED .EQ. 1) GO TO 162
  161 FORMAT ('0END OF GROUP - NULL GROUP')
      IF ( MACHX.EQ.2 .OR. MACHX.EQ.5 )
     & WRITE  (OTPE,CORE) (ICORE(I),I=NS,NP)
      IF ( MACHX.NE.2 .AND. MACHX.NE.5 )
     & CALL WRTFMT (ICORE(NS), NP-NS+1, CCORE)
  162 LINE = LINE + 1
      IF (LINE .GE. NLPP) CALL PAGE
      LLEN = 0
      NRED = 1
      NP   = INUM
      CORE(INUM+1) = CORE(IX)
      IX   = INUM + 1
      GO TO (110,130,150,20), IOUT
C
C     END OF ITEM
C
  170 WRITE  (OTPE,180)
  180 FORMAT ('0END OF ITEM')
  190 RETURN
C
C     PERFORM FORMATED LISTING OF TABLE
C
C     EQSS TABLE
C
 2000 CALL SFETCH (NAME,ITEM,1,RC)
      IF (RC .NE. 1) RETURN
      CALL SUREAD (CORE(1),4,NOUT,RC)
      IF (RC .NE. 1) GO TO 3000
      NSUB = ICORE(3)
      CALL SUREAD (CORE(1),NZ,NOUT,RC)
      IF (RC .NE. 2) GO TO 3000
      IST  = 1  + NOUT
      LEFT = NZ - NOUT
      DO 2010 I = 1,NSUB
      CALL SUREAD (CORE(IST),LEFT,NOUT,RC)
      IF (RC.NE.2 .AND. RC.NE.3) GO TO 3000
      ICOMP = 1 + 2*(I-1)
      CALL CMIWRT (1,NAME,CORE(ICOMP),IST,NOUT,CORE,ICORE)
 2010 CONTINUE
      CALL SUREAD (CORE(IST),LEFT,NOUT,RC)
      IF (RC.NE.2 .AND. RC.NE.3) GO TO 3000
      CALL CMIWRT (8,NAME,0,IST,NOUT,CORE,ICORE)
      RETURN
C
C     BGSS TABLE
C
 2100 CALL SFETCH (NAME,ITEM,1,RC)
      IF (RC .NE. 1) RETURN
      NGRD = 1
      CALL SJUMP (NGRD)
      IF (NGRD .LT. 0) GO TO 3000
      IST = 1
      CALL SUREAD (CORE(IST),NZ,NOUT,RC)
      IF (RC.NE.2 .AND. RC.NE.3) GO TO 3000
      CALL CMIWRT (2,NAME,NAME,IST,NOUT,CORE,ICORE)
      RETURN
C
C     CSTM TABLE
C
 2200 CALL SFETCH (NAME,ITEM,1,RC)
      IF (RC .NE. 1) RETURN
      NGRD = 1
      CALL SJUMP (NGRD)
      IF (NGRD .LT. 0) GO TO 3000
      IST = 1
      CALL SUREAD (CORE(IST),NZ,NOUT,RC)
      IF (RC.NE.2 .OR. RC.NE.3) GO TO 3000
      CALL CMIWRT (3,NAME,NAME,IST,NOUT,CORE,ICORE)
      RETURN
C
C     PLTS TABLE
C
 2300 CALL SFETCH (NAME,ITEM,1,RC)
      IF (RC .NE. 1) RETURN
      CALL SUREAD (CORE(1),3,NOUT,RC)
      IF (RC .NE. 1) GO TO 3000
      IST = 1
      CALL SUREAD (CORE(IST),NZ,NOUT,RC)
      IF (RC.NE.2 .AND. RC.NE.3) GO TO 3000
      CALL CMIWRT (4,NAME,NAME,IST,NOUT,CORE,ICORE)
      RETURN
C
C     LODS TABLE
C
 2400 ICODE = 5
C
 2410 CALL SFETCH (NAME,ITEM,1,RC)
      IF (RC .NE. 1) RETURN
      CALL SUREAD (CORE(1),4,NOUT,RC)
      IF (RC .NE. 1) GO TO 3000
      NSUB = ICORE(4)
      CALL SUREAD (CORE(1),NZ,NOUT,RC)
      IF (RC .NE. 2) GO TO 3000
      IST  = 1  + NOUT
      LEFT = NZ - NOUT
      DO 2420 I = 1,NSUB
      CALL SUREAD (CORE(IST),LEFT,NOUT,RC)
      IF (RC.NE.2 .AND. RC.NE.3) GO TO 3000
      ICOMP = 1 + 2*(I-1)
      CALL CMIWRT (ICODE,NAME,CORE(ICOMP),IST,NOUT,CORE,ICORE)
      ICODE = 6
 2420 CONTINUE
      RETURN
C
C     LOAP TABLE
C
 2500 ICODE = 7
      GO TO 2410
C
C     INSUFFICIENT CORE OR ILLEGAL ITEM FORMAT - FORCE PHYSICAL DUMP
C
 3000 WRITE  (OTPE,3010) UWM,ITEM,NAME
 3010 FORMAT (A25,' 6231, INSUFFICIENT CORE AVAILABLE OR ILLEGAL ITEM ',
     1       'FORMAT REQUIRES AN UNFORMATED', /31X,
     2       'DUMP TO BE PERFORM FOR ITEM ',A4,' OF SUBSTRUCTURE ',2A4)
      GO TO 5
      END

      SUBROUTINE MSOLID (ITYPE)
C
C     THIS ROUTINE CALCULATES THE MASS MATRICES FOR THE SOLID ELEMENTS,
C
C          I =     ELEMENT
C          ***     *******
C          1       CTETRA
C          2       CWEDGE
C          3       CHEXA1
C          4       CHEXA2
C
C     A SERIES OF 6 BY 6 DIAGONAL MATRICES ARE CALUCLATED, ONE PER
C     CONNECTED GRID POINT
C
C     ECPT        TETRA          WEDGE          HEXA
C     -------------------------------------------------
C     ECPT( 1) =  EL ID          EL ID          EL ID
C     ECPT( 2) =  MAT-ID         MAT-ID         MAT-ID
C     ECPT( 3) =  GRID-1         GRID-1         GRID-1
C     ECPT( 4) =  GRID-2         GRID-2         GRID-2
C     ECPT( 5) =  GRID-3         GRID-3         GRID-3
C     ECPT( 6) =  GRID-4         GRID-4         GRID-4
C     ECPT( 7) =  CSID-1         GRID-5         GRID-5
C     ECPT( 8) =  X1             GRID-6         GRID-6
C     ECPT( 9) =  Y1             CSID-1         GRID-7
C     ECPT(10) =  Z1             X1             GRID-8
C     ECPT(11) =  CSID-2         Y1             CSID-1
C     ECPT(12) =  X2             Z1             X1
C     ECPT(13) =  Y2             CSID-2         Y1
C     ECPT(14) =  Z2             X2             Z1
C     ECPT(15) =  CSID-3         Y2             CSID-2
C     ECPT(16) =  X3             Z2             X2
C     ECPT(17) =  Y3             CSID-3         Y2
C     ECPT(18) =  Z3             X3             Z2
C     ECPT(19) =  CSID-4         Y3             CSID-3
C     ECPT(20) =  X4             Z3             X3
C     ECPT(21) =  Y4             CSID-4         Y3
C     ECPT(22) =  Z4             X4             Z3
C     ECPT(23) =  EL-TEM         Y4             CSID-4
C     ECPT(24)                   Z4             X4
C     ECPT(25)                   CSID-5         Y4
C     ECPT(26)                   X5             Z4
C     ECPT(27)                   Y5             CSID-5
C     ECPT(28)                   Z5             X5
C     ECPT(29)                   CSID-6         Y5
C     ECPT(30)                   X6             Z5
C     ECPT(31)                   Y6             CSID-6
C     ECPT(32)                   Z6             X6
C     ECPT(33)                   ELTEMP         Y6
C     ECPT(34)                                  Z6
C     ECPT(35)                                  CSID-7
C     ECPT(36)                                  X7
C     ECPT(37)                                  Y7
C     ECPT(38)
C     ECPT(39)                                  CSID-8
C     ECPT(40)                                  X8
C     ECPT(41)                                  Y8
C     ECPT(42)                                  Z8
C     ECPT(43)                                  EL-TEMP
C
      LOGICAL          HEAT
      INTEGER          M(14,4),NECPT(100)
      DOUBLE PRECISION PTMASS,EMASS,R(3,3),MGE(36)
      COMMON /SMA2HT/  HEAT
      COMMON /SMA2ET/  ECPT(100)
      COMMON /MATIN /  MATIDC,MATFLG,ELTEMP,STRESS,SINTH,COSTH
      COMMON /MATOUT/  RHO
      COMMON /HMTOUT/  CP
      COMMON /SMA2DP/  PTMASS,EMASS,R,MGE,NPTS,NEL,MFIRST,KPT,NROW,JLOC,
     1                 ITEST,J1,M1,ILOC(4)
      COMMON /SMA2CL/  DUM1(2),NPVT
      COMMON /SMA2IO/  DUM2(10),IFMGG,DUMXX(1),IFBGG
      EQUIVALENCE      (ECPT(1),NECPT(1))
      DATA    M( 1,1), M( 1,2),M( 1,3),M( 1,4) / 1   ,2   ,3   ,4 /
      DATA    M( 2,1), M( 2,2),M( 2,3),M( 2,4) / 1   ,2   ,3   ,6 /
      DATA    M( 3,1), M( 3,2),M( 3,3),M( 3,4) / 1   ,2   ,6   ,5 /
      DATA    M( 4,1), M( 4,2),M( 4,3),M( 4,4) / 1   ,4   ,5   ,6 /
      DATA    M( 5,1), M( 5,2),M( 5,3),M( 5,4) / 1   ,2   ,3   ,6 /
      DATA    M( 6,1), M( 6,2),M( 6,3),M( 6,4) / 1   ,3   ,4   ,8 /
      DATA    M( 7,1), M( 7,2),M( 7,3),M( 7,4) / 1   ,3   ,8   ,6 /
      DATA    M( 8,1), M( 8,2),M( 8,3),M( 8,4) / 1   ,5   ,6   ,8 /
      DATA    M( 9,1), M( 9,2),M( 9,3),M( 9,4) / 3   ,6   ,7   ,8 /
      DATA    M(10,1), M(10,2),M(10,3),M(10,4) / 2   ,3   ,4   ,7 /
      DATA    M(11,1), M(11,2),M(11,3),M(11,4) / 1   ,2   ,4   ,5 /
      DATA    M(12,1), M(12,2),M(12,3),M(12,4) / 2   ,4   ,5   ,7 /
      DATA    M(13,1), M(13,2),M(13,3),M(13,4) / 2   ,5   ,6   ,7 /
      DATA    M(14,1), M(14,2),M(14,3),M(14,4) / 4   ,5   ,7   ,8 /
C
C     SET THE ELEMENT PARAMETERS ACCORDING TO THE TYPE
C                               NPTS = NO. OF CONNECTED POINTS
C                               NEL  = NO. OF SUBELEMENTS
C                               MFIRST=POSITION OF FIRST ROW OF MAPPING
C                                       MATRIX
C
      GO TO (100,110,120,130), ITYPE
  100 NPTS  = 4
      NEL   = 1
      MFIRST= 1
      GO TO 140
  110 NPTS  = 6
      NEL   = 3
      MFIRST= 2
      GO TO 140
  120 NPTS  = 8
      NEL   = 5
      MFIRST= 5
      GO TO 140
  130 NPTS  = 8
      NEL   = 10
      MFIRST= 5
  140 CONTINUE
C
C     FETCH THE MATERIAL ID AND THE DENSITY, RHO
C
      MATIDC = NECPT(2)
      MATFLG = 4
      NTEMP  = 5*NPTS + 3
      ELTEMP = ECPT(NTEMP)
      IF (.NOT.HEAT) CALL MAT (ECPT(1))
      IF (HEAT) CALL HMAT (ECPT)
      IF (HEAT) RHO = CP
      IF (RHO .EQ. 0.0) GO TO 1200
C
C     ZERO OUT POINT MASS
C
      PTMASS = 0.0D0
C
C     LOOP ON SUBELEMENTS
C
      DO 1000 ME = 1,NEL
      NROW = MFIRST + ME - 1
C
C     SET UP POINTERS TO LOCATION VECTORS AND TEST IF ELEMENT IS
C     CONNECTED
C
      ITEST = 0
      DO 300 I = 1,4
      KPT = M(NROW,I)
      IF (NECPT(KPT+2) .NE. NPVT) GO TO 250
      ITEST = 1
C
C     THE LOCATION OF THE VECTOR DATA IN THE ECPT IS
C
  250 ILOC(I) = 4*KPT + NPTS
  300 CONTINUE
      IF (ITEST .EQ. 0) GO TO 1000
C
C     CALCULATE DIFFERENCE VECTORS FROM THE FIRST VECTOR
C
      DO 500 I = 2,4
      DO 400 J = 1,3
      JLOC = ILOC(I) + J - 1
      J1   = ILOC(1) + J - 1
  400 R(I-1,J) = ECPT(JLOC) - ECPT(J1)
  500 CONTINUE
C
C     THE MASS ON EACH POINT DUE TO THE TETRAHEDRON IS
C     (NEGATIVE VALUE OF RHO IS ALLOWED)
C
      EMASS = RHO/24.D0*DABS((R(3,1)*(R(1,2)*R(2,3) - R(1,3)*R(2,2))
     1                      + R(3,2)*(R(1,3)*R(2,1) - R(1,1)*R(2,3))
     2                      + R(3,3)*(R(1,1)*R(2,2) - R(1,2)*R(2,1))))
      IF (ITYPE.NE.4) GO TO 600
      EMASS = EMASS/2.0D0
C
C     THE MASS IS NOW ADDED TO THE APPROPRIATE POINT
C
  600 PTMASS = PTMASS + EMASS
 1000 CONTINUE
C
C     THE MASSES ARE EXPANDED AND INSERTED
C
      IF (HEAT) GO TO 1150
      DO 1100 I = 1,36
 1100 MGE(I) = 0.0D0
      M1     =-1
      MGE(1) = PTMASS
      MGE(8) = MGE(1)
      MGE(15)= MGE(1)
      CALL SMA2B (MGE(1),NPVT,M1,IFMGG,0.0D0)
      GO TO 1200
 1150 CALL SMA2B (PTMASS,NPVT,NPVT,IFBGG,0.0D0)
C
C     ALL DONE
C
 1200 RETURN
      END

      SUBROUTINE XOSGEN
C
C     THE PURPOSE OF THIS ROUTINE IS TO GENERATE THE OSCAR ARRAY.
C
C          ... DESCRIPTION OF PROGRAM VARIABLES ...
C     IENDF  = FLAG SIGNALING END OF DMAP SEQUENCE.
C     LDEF   = SCRATCH USED IN SCANNING LBLTBL TABLE.
C     LBLTOP = TOP OF LBLTBL ARRAY.
C     LBLBOT = BOTTOM OF LBLTBL ARRAY.
C     LSTLBL = POINTER TO LAST LABEL ENTRY MADE IN LBLTBL.
C     LSTPAR = POINTER TO LAST PARAMETER NAME ENTRY MADE IN LBLTBL.
C     NAMTBL = NAME CONVERSION TABLE FOR TYPE E NAMES.
C     IEXFLG = FLAG INDICATING LAST OSCAR ENTRY WAS EXIT.
C     IOSPNT = POINTER TO NEXT AVAILABLE WORD IN OSCAR ENTRY.
C     NOSPNT = POINTER TO DATA BLOCK NAME COUNT IN OSCAR ENTRY.
C     NTYPEE = TABLE CONTAINING TYPE E DMAP NAMES
C     IPRCFO = POINTER TO LAST TYPE F OR O OSCAR ENTRY.
C     NDIAG1 = NAME OF THE DIAGNOSTIC O/P PROCESSOR
C     ITYPE  = TABLE FOR TRANSLATING TYPE CODES TO WORD LENGTH
C     VARFLG = FLAG INDICATING VARIABLE FOUND IN EQUIV OR PURGE
C              INSTRUCTION.
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        LSHIFT,RSHIFT,ANDF,ORF
      LOGICAL         SKIP
      DIMENSION       PRECHK(2),XDMAP(2),DECLAR(3),FPARAM(3),
     1                DMPCRD(1),NSKIP(5,2),CDCOMP(3),NAMTBL(12),
     2                ITYPE(6),MED(1),LBLTBL(1),OSCAR(1),OS(5)
      COMMON /XFIAT / FIAT(3)
      COMMON /SYSTEM/ BUFSZ,OPTAPE,NOGO,DUM(20),ICFIAT,JUNK(54),
     1                ISWTCH(3),ICPFLG
      COMMON /MODDMP/ IFLG(6),NAMOPT(26)
      COMMON /XGPIC / ICOLD,ISLSH,IEQUL,NBLANK,NXEQUI,
     1                NMED,NSOL,NDMAP,NESTM1,NESTM2,NEXIT,
     2                NBEGIN,NEND,NJUMP,NCOND,NREPT,NTYPEE(9),
     3                MASKHI,MASKLO,ISGNON,NOSGN,IALLON,MASKS(1)
      COMMON /ZZZZZZ/ CORE(1)
      COMMON /XGPI2 / LMPL,MPLPNT,MPL(1)
CWKBR COMMON /XGPI3 / PVT(2)
      COMMON /XGPI3 / PVT(200)
      COMMON /XGPI4 / IRTURN,INSERT,ISEQN,DMPCNT,
     1                IDMPNT,DMPPNT,BCDCNT,LENGTH,ICRDTP,ICHAR,NEWCRD,
     2                MODIDX,LDMAP,ISAVDW,DMAP(1)
      COMMON /XGPI5 / IAPP,START,ALTER(2),SOL,SUBSET,IFLAG,IESTIM,
     1                ICFTOP,ICFPNT,LCTLFL,ICTLFL(1)
      COMMON /XGPI6 / MEDTP,FNMTP,CNMTP,MEDPNT,LMED,IPLUS,DIAG14,DIAG17,
     1                DIAG4,DIAG25,IFIRST,IBUFF(20)
      COMMON /XGPI7 / FPNT,LFILE,FILE(1)
      COMMON /XGPID / ICST,IUNST,IMST,IHAPP,IDSAPP,IDMAPP,
     1                ISAVE,ITAPE,IAPPND,INTGR,LOSGN
      COMMON /XGPIE / NSCR
      COMMON /XVPS  / VPS(2)
CWKBR COMMON /XCEITB/ CEITBL(2)
      COMMON /XCEITB/ CEITBL(42)
      COMMON /XOLDPT/ XX(4),SEQNO
      COMMON /AUTOCM/ PREFLG,NNAMES,PRENAM(100)
      COMMON /AUTOSM/ NWORDS,SAVNAM(100)
      COMMON /PASSER/ ISTOPF,MODNAM
C
C     EQUIVALENCE     (NTYPEE(1),NTIME ), (NTYPEE(2),NSAVE )
C    1                (NTYPEE(3),NOUTPT), (NTYPEE(4),NCHKPT)
C    2                (NTYPEE(5),NPURGE), (NTYPEE(6),NEQUIV)
C    3                (NTYPEE(7),NCPW  ), (NTYPEE(8),NBPC  )
C    4                (NTYPEE(9),NWPC  )
      EQUIVALENCE     (NAMTBL(9),NXPURG)
      EQUIVALENCE     (OSCAR (1),DMPCRD(1),LBLTBL(1),MED(1),OS(5)),
     1                (CORE(1),OS(1),LOSCAR), (OS(2),OSPRC),
     2                (OS(3),OSBOT), (OS(4),OSPNT)
C
      DATA    XCHK  / 4HXCHK/
      DATA    ITYPE / 1,1,2,2,2,4/
      DATA    IPRCFO/ 0     /, IENDF / 0/
      DATA    NFILE / 4HFILE/
      DATA    NVPS  / 4HVPS /
      DATA    PRECHK/ 4HPREC,  4HHK  /,XDMAP / 4HXDMA, 4HP     /
      DATA    NCEIT1/ 4HCEIT/, NCEIT2/ 4HBL  /
      DATA    NLBLT1/ 4HLBLT/, NLBLT2/ 4HBL  /
      DATA    DECLAR/ 4HBEGI,  4HLABE, 4HFILE/
      DATA    FPARAM/ 4HTAPE,  4HAPPE, 4HSAVE/
      DATA    NAMTBL/ 4HXTIM,  4HE   , 4HXSAV, 4HE   , 4HXUOP, 4H    ,
     1                4HXCHK,  4H    , 4HXPUR, 4HGE  , 4HXEQU, 4HIV  /
      DATA    NSKIP / 10*0 /, CDCOMP / 4HCOMP, 4HON  , 4HOFF   /
C
C     INITIALIZE
C
      IFIRST = 0
      OSBOT  = 1
      NWORDS = 0
      LOOKUP = 0
      PREFLG = 0
      IVREPT = 0
      ILEVEL = 0
      SKIP   =.FALSE.
      OSPNT  = OSBOT
      OSCAR(OSBOT  ) = 0
      OSCAR(OSBOT+1) = 1
C
C     FOR RESTART ALLOW CHECKPOINT AND JUMP ENTRIES TO BE INSERTED IN
C     OSCAR BY XGPI.
C
      IF (START .EQ. ICST) GO TO 10
      OSCAR(OSBOT+1) = 3
C
C     ALLOCATE 50 WORDS IN OPEN CORE FOR LBLTBL AND SET LBLTBL
C     PARAMETERS.
C
   10 LBLBOT = LOSCAR
      LBLTOP = LOSCAR - 50
      LOSCAR = LBLTOP - 1
      LSTLBL = LBLTOP - 4
      LSTPAR = LBLBOT + 1
C
C     INITIALIZE DMPCRD ARRAY FOR RIGID FORMAT
C
      ICRDTP = LOSCAR
C
C     ****************************************
C     PREPARE TO PROCESS NEXT DMAP INSTRUCTION
C     ****************************************
C
  100 DMPCNT = DMPCNT + 1
      IF (IAPP .EQ. IDMAPP) GO TO 110
      MEDPNT = MED(MEDTP+1)*(DMPCNT - 1) + MEDTP + 2
      IF (MED(MEDTP).LT.DMPCNT .AND. IAPP.NE.IDMAPP) GO TO 2390
  110 NEWCRD =-1
      INSERT = 0
C
C     SEE IF DMAP INSTRUCTION IS TO BE DELETED OR INSERTED
C
      IF (ALTER(1).EQ.0 .OR. ALTER(1).GT.DMPCNT) GO TO 130
      IF (ALTER(1).LE.DMPCNT .AND. ALTER(2).GE.DMPCNT) GO TO 150
      IF (ALTER(2) .EQ. 0) GO TO 120
C
C     JUST FINISHED DELETING, SET INSERT AND ALTER FOR INSERTING
C
      ALTER(1) = ALTER(2)
      ALTER(2) = 0
  120 IF (ALTER(1) .NE. DMPCNT-1) GO TO 130
      INSERT = 1
      DMPCNT = DMPCNT - 1
      GO TO 160
C
C     GET NEXT DMAP INSTRUCTION
C     FOR RIGID FORMAT SEE IF OSCAR ENTRY IS PART OF SUBSET
C
  130 IF (IAPP .EQ. IDMAPP) GO TO 160
      I = MED(MEDTP+1)
      DO 140 J = 1,I
      K = MEDPNT + J -1
      IF (MED(K) .NE. 0) GO TO 160
  140 CONTINUE
C
C     SET INSERT FLAG TO NO PRINT
C
  150 INSERT = -2
      GO TO 310
C
C     CHECK FOR CONDITIONAL COMPILATION END
C
  160 IF (ILEVEL .LE. 0) GO TO 190
      DO 170 I = 1,ILEVEL
      IF (IABS(NSKIP(I,1)) .LT. 99999) NSKIP(I,1) = NSKIP(I,1) - 1
  170 CONTINUE
      IF (NSKIP(ILEVEL,1) .EQ. -1) GO TO 180
      IF (SKIP) INSERT = INSERT - 2
      GO TO 190
  180 SKIP   =.FALSE.
      ILEVEL = ILEVEL - 1
C
  190 IF (LOOKUP.NE.1 .OR. PREFLG.EQ.0) GO TO 200
      PREFLG = -PREFLG
      CALL AUTOCK (OSPNT)
  200 MODNAM = 1
      LOOKUP = 0
      CALL XSCNDM
      MODNAM = 0
      GO TO (2120,210,2120,100,2060), IRTURN
  210 IF (.NOT.SKIP) GO TO 220
C
C     CHECK LABELS EVEN IF CONDITIONAL COMPILATION
C
      IF (DMAP(DMPPNT) .EQ. DECLAR(2)) GO TO 1270
      GO TO 310
C
C     FIND MPL ENTRY AND BRANCH ON TYPE
C
  220 MPLPNT = 1
      MODIDX = 1
      IF (DMAP(DMPPNT).EQ.PRECHK(1) .AND. DMAP(DMPPNT+1).EQ.PRECHK(2))
     1    GO TO 1490
      IF (DMAP(DMPPNT).EQ.XDMAP(1)  .AND. DMAP(DMPPNT+1).EQ.XDMAP(2))
     1    GO TO 1570
      IF (DMAP(DMPPNT).EQ.CDCOMP(1) .AND. (DMAP(DMPPNT+1).EQ.CDCOMP(2)
     1    .OR. DMAP(DMPPNT+1).EQ.CDCOMP(3))) GO TO 1740
  230 IF (MPL(MPLPNT+1).EQ.DMAP(DMPPNT) .AND. MPL(MPLPNT+2).EQ.
     1    DMAP(DMPPNT+1)) GO TO 240
C
C     CHECK FOR ERROR IN MPL TABLE
C
      IF (MPL(MPLPNT).LT.1 .OR. MPL(MPLPNT).GT.LMPL) GO TO 2140
      MPLPNT = MPL(MPLPNT) + MPLPNT
      MODIDX = 1 + MODIDX
      IF (MPLPNT-LMPL) 230,2130,2130
C
C     GET FORMAT TYPE FROM MPL AND BRANCH
C
  240 I = MPL(MPLPNT + 3)
      IF (I.LT.1 .OR. I.GT.5) GO TO 2140
      GO TO (400,400,500,800,1200), I
C
C     *****************************************************
C     RETURN HERE AFTER DMAP INSTRUCTION HAS BEEN PROCESSED
C     *****************************************************
C
C     CHECK FOR FATAL ERROR
C
  300 IF (NOGO .EQ. 2) GO TO 2060
C
C     CHECK FOR END OF DMAP SEQUENCE.
C
      IF (IENDF .NE. 0) GO TO 1900
C
C     CHECK FOR $ ENTRY IN DMAP AND GET NEXT DMAP INSTRUCTION
C
  310 CALL XSCNDM
      GO TO (320,320,320,100,2060), IRTURN
  320 IF (NOGO.EQ.0 .AND. INSERT.GE.0) GO TO 2160
      GO TO 310
C
C     ********************************************
C     GENERATE OSCAR ENTRY WITH TYPE F OR O FORMAT
C     ********************************************
C
C     GENERATE LINK HEADER SECTION
C
  400 CALL XLNKHD
      IPRCFO = OSPNT
C
C     GENERATE I/P FILE SECTION
C
      CALL XIPFL
      GO TO (410,2100), IRTURN
C
C     SAVE POINTER TO O/P FILE SECTION
C
  410 J = OSPNT + OSCAR(OSPNT)
C
C     GENERATE O/P FILE SECTION
C
      CALL XOPFL
      GO TO (420,2110), IRTURN
C
C     NUMBER OF SCRATCH FILES TO OSCAR
C
  420 I = OSPNT + OSCAR(OSPNT)
      OSCAR(I) = MPL(MPLPNT)
C
C     INCREMENT OSCAR WORD COUNT AND MPLPNT
C
      OSCAR(OSPNT) = 1 + OSCAR(OSPNT)
      MPLPNT = 1 + MPLPNT
C
C     GENERATE PARAMETER SECTION
C
      CALL XPARAM
      GO TO (430,2060), IRTURN
C
C     CONTINUE COMPILATION
C     ZERO INTERNAL CHECKPOINT FLAG IN OSCAR ENTRY FOR TYPE F ENTRY
C
  430 IF (ANDF(OSCAR(OSPNT+2),MASKHI) .EQ. 2) GO TO 440
      I = OSPNT + OSCAR(OSPNT)
      OSCAR(I) = 0
      OSCAR(OSPNT) = 1 + OSCAR(OSPNT)
  440 CONTINUE
      IF (NWORDS .EQ. 0) GO TO 450
      CALL AUTOSV
      NWORDS = 0
  450 IF (PREFLG.EQ.0 .OR. ISTOPF.EQ.0) GO TO 460
      CALL AUTOCK (ISTOPF)
  460 CONTINUE
      GO TO 300
C
C     ***************************************
C     GENERATE OSCAR ENTRY WITH TYPE C FORMAT
C     ***************************************
C
C     GENERATE LINK HEADER SECTION
C
  500 CALL XLNKHD
C
C     UPDATE OSCAR ENTRY WORD COUNT TO INCLUDE VALUE SECTION.
C
      OSCAR(OSPNT) = 7
C
C     CHECK FOR END CARD
C
      IF (OSCAR(OSPNT+3) .NE. NEND) GO TO 510
      OSCAR(OSPNT+3) = NEXIT
      IENDF = 1
C
C     SET EXECUTE FLAG IN OSCAR FOR END
C
      OSCAR(OSPNT+5) = ORF(ISGNON,OSCAR(OSPNT+5))
C
C     GET NEXT ENTRY IN DMAP
C
  510 CALL XSCNDM
      GO TO (2160,520,630,630,2060), IRTURN
C
C     IF NEXT DMAP ENTRY IS BCD IT SHOULD BE LABEL NAME FOR BRANCH
C     DMAP INSTRUCTION.
C
  520 IF (OSCAR(OSPNT+3) .EQ. NEXIT) GO TO 2160
C
C     SEARCH LABEL TABLE FOR LABEL NAME
C
      IF (LSTLBL .LT. LBLTOP) GO TO 540
      DO 530 J = LBLTOP,LSTLBL,4
      IF (DMAP(DMPPNT).EQ.LBLTBL(J) .AND. DMAP(DMPPNT+1).EQ.LBLTBL(J+1))
     1    GO TO 550
  530 CONTINUE
C
C     NAME NOT FOUND IN TABLE
C
  540 LDEF = 0
      GO TO 560
C
C     NOW SEE IF LABEL HAS BEEN REFERENCED
C
  550 IF (LBLTBL(J+3) .EQ. 0) GO TO 580
      LDEF = LBLTBL(J+2)
C
C     MAKE NEW ENTRY IN LABEL TABLE, CHECK FOR TABLE OVERFLOW
C
  560 ASSIGN 570 TO IRTURN
      IF (LSTLBL+8 .GE. LSTPAR) GO TO 2220
  570 LSTLBL = LSTLBL + 4
      J = LSTLBL
      LBLTBL(J  ) = DMAP(DMPPNT  )
      LBLTBL(J+1) = DMAP(DMPPNT+1)
      LBLTBL(J+2) = LDEF
  580 LBLTBL(J+3) = OSPNT
C
C     GET NEXT ENTRY FROM DMAP, ENTRY IS $ FOR JUMP,NAME FOR COND,
C     VALUE FOR REPT.
C
      CALL XSCNDM
      GO TO (2160,600,720,590,2060), IRTURN
C
C     DMAP INSTRUCTION IS JUMP
C
  590 OSCAR(OSPNT+6) = 0
      IF (OSCAR(OSPNT+3) .EQ. NJUMP) GO TO 300
      GO TO 2160
C
C     COND DMAP INSTRUCTION, ENTER PARAMETER NAME IN LABEL TABLE.
C
  600 IF (OSCAR(OSPNT+3) .NE. NREPT) GO TO 610
      IVREPT =  1
      GO TO 640
  610 IF (OSCAR(OSPNT+3) .NE. NCOND) GO TO 2160
      ASSIGN 620 TO IRTURN
      IF (LSTPAR-8 .LE. LSTLBL) GO TO 2220
  620 LSTPAR = LSTPAR - 4
      LBLTBL(LSTPAR  ) = DMAP(DMPPNT  )
      LBLTBL(LSTPAR+1) = DMAP(DMPPNT+1)
      LBLTBL(LSTPAR+2) = OSPNT + 6
      LBLTBL(LSTPAR+3) = OSPNT
      GO TO 300
C
C     EXIT DMAP INSTRUCTION, SET EXECUTE FLAG AND OSCAR VALUE SECTION.
C
  630 IF (OSCAR(OSPNT+3) .NE. NEXIT) GO TO 2160
      IF (DMAP(DMPPNT) .NE. INTGR) DMAP(DMPPNT+1) = 0
      DMAP(DMPPNT  ) = INTGR
      DMAP(DMPPNT+2) = RSHIFT(IALLON,1)
C
C     ENTER LOOP COUNT IN CEITBL FOR REPT AND EXIT INSTRUCTIONS
C
  640 CEITBL(2) = CEITBL(2) + 4
      IF (CEITBL(2) .GT. CEITBL(1)) GO TO 2280
C
C     I = POINTER TO LOOP COUNT IN CEITBL ENTRY
C
      I = CEITBL(2) - 2
      IF (IVREPT .EQ. 0) GO TO 700
C
C     PROCESS VARIABLE REPT INSTRUCTION - FIND PARAM IN VPS
C
      KDH = 3
  650 IF (DMAP(DMPPNT).EQ.VPS(KDH) .AND. DMAP(DMPPNT+1).EQ.VPS(KDH+1))
     1    GO TO 660
      KDH = KDH + ANDF(VPS(KDH+2),MASKHI) + 3
      IF (KDH - VPS(2)) 650,670,670
C
C     PARAMETER FOUND
C
  660 IF (ANDF(RSHIFT(VPS(KDH+2),16),15) .NE. 1) GO TO 2210
      CEITBL(I) = LSHIFT(KDH,16)
      CEITBL(I) = ORF(CEITBL(I),ISGNON)
      GO TO 710
C
C     CHECK PVT FOR PARAMETER
C
  670 KDH = 3
  680 LENGTH = ANDF(PVT(KDH+2),NOSGN)
      LENGTH = ITYPE(LENGTH)
      IF (DMAP(DMPPNT).EQ.PVT(KDH) .AND. DMAP(DMPPNT+1).EQ.PVT(KDH+1))
     1    GO TO 690
      KDH = KDH + LENGTH + 3
      IF (KDH - PVT(2)) 680,2200,2200
  690 IF (LENGTH .NE. ITYPE(1)) GO TO 2210
      CEITBL(I) = LSHIFT(PVT(KDH+3),16)
      GO TO 710
  700 CEITBL(I) = LSHIFT(DMAP(DMPPNT+1),16)
C
C     FIRST WORD OF CEITBL ENTRY CONTAINS OSCAR RECORD NUMBERS OF
C     BEGINNING AND END OF LOOP
C
  710 CEITBL(I-1) = ISEQN
      IVREPT = 0
C
C     OSCAR VALUE SECTION CONTAINS POINTER TO LOOP COUNT IN CEITBL ENTRY
C
      OSCAR(OSPNT+6) = I
      GO TO 300
C
C     REPT DMAP INSTRUCTION, COUNT TO VALUE SECTION.
C
  720 IF (OSCAR(OSPNT+3) .EQ. NREPT) GO TO 640
      GO TO 2160
C
C     ***************************************
C     GENERATE OSCAR ENTRY WITH TYPE E FORMAT
C     ***************************************
C
C     PREFIX MODULE NAME WITH AN X
C
  800 DO 810 I = 1,6
      IF (NTYPEE(I) .EQ. DMAP(DMPPNT)) GO TO 820
  810 CONTINUE
  820 I = 2*I - 1
      DMAP(DMPPNT  ) = NAMTBL(I  )
      DMAP(DMPPNT+1) = NAMTBL(I+1)
C
C     GENERATE LINK HEADER FOR OSCAR
C
      IF (I.EQ.9 .OR. I.EQ.11) LOOKUP = 1
      OS2B4 = OSPRC
      CALL XLNKHD
C
C     BRANCH ON DMAP NAME AND GENERATE VALUE/OUTPUT SECTION OF OSCAR
C
      I = (I+1)/2
      GO TO (830,860,990,990,990,990), I
C
C     EXTIME ENTRY, CHECK ESTIM IN CONTROL FILE
C
  830 OSCAR(OSPNT+5) = ANDF(OSCAR(OSPNT+5),NOSGN)
      IF (IESTIM .EQ. 0) GO TO 300
C
C     GET TIME SEGMENT NAME
C
      CALL XSCNDM
      GO TO (2370,840,2370,2370,2060), IRTURN
  840 I = IESTIM + ICTLFL(IESTIM) - 1
      J = IESTIM + 1
      DO 850 K = J,I,2
      IF (DMAP(DMPPNT).EQ.ICTLFL(K) .AND. DMAP(DMPPNT+1).EQ.ICTLFL(K+1))
     1    OSCAR(OSPNT+5) = ORF(OSCAR(OSPNT+5),ISGNON)
  850 CONTINUE
      GO TO 300
C
C     XSAVE ENTRY, ENTER POINTERS IN VALUE SECTION OF OSCAR.
C
  860 I = OSPNT + OSCAR(OSPNT)
      OSCAR(I) = 0
      K = I - 1
C
C     GET PARAMETER NAME FROM DMAP.
C
  870 CALL XSCNDM
      GO TO (2260,880,2260,930,2060), IRTURN
C
C     FIND PARAMETER IN VPS AND ENTER POINTER TO VALUE IN OSCAR.
C
  880 K = K + 2
      OSCAR(I  ) = OSCAR(I) + 1
      OSCAR(K  ) = 0
      OSCAR(K+1) = 0
      J = 3
  890 IF (VPS(J).EQ.DMAP(DMPPNT) .AND. VPS(J+1).EQ.DMAP(DMPPNT+1))
     1    GO TO 900
      L = ANDF(VPS(J+2),MASKHI)
      J = J + L + 3
      IF (J .LT. VPS(2)) GO TO 890
C
C     PARAMETER NOT IN VPS - ERROR
C
      GO TO 2270
C
C     PARAMETER FOUND IN VPS
C
  900 OSCAR(K) = J + 3
C
C     SEE IF PARAMETER WAS ALREADY SAVED
C
      J  = I + 1
      J1 = K - 2
      IF (J1 .LT. J) GO TO 870
      DO 910 L = J,J1,2
      IF (OSCAR(L) .EQ. OSCAR(K)) GO TO 920
  910 CONTINUE
      GO TO 870
C
C     PARAMETER DUPLICATED
C
  920 K = K - 2
      OSCAR(I) = OSCAR(I) - 1
      GO TO 2150
C
C
C     END OF SAVE PARAMETER NAME LIST, INCREMENT OSCAR WORD COUNT.
C
  930 OSCAR(OSPNT) = OSCAR(OSPNT) + 2*OSCAR(I) + 1
C
C     GET PARAMETER VALUE DISPLACEMENT IN COMMON FROM PRECEDING
C     OSCAR ENTRY.
C
      IOSDAV = OSPRC
      IF (OSCAR(OSPRC+3) .EQ. XCHK) OSPRC = OS2B4
      IF (ANDF(OSCAR(OSPRC+2),MASKHI) .GT. 2) GO TO 2420
C
C     J = OSCAR POINTER TO BEGINNING OF PARAMETER SECTION.
C
      J = OSPRC + 6 + 3*OSCAR(OSPRC+6) + 1
      IF (ANDF(OSCAR(OSPRC+2),MASKHI) .EQ. 1) J = J + 1 + 3*OSCAR(J)
      J = J + 1
C
C     N1 = PARAMETER COUNT,N2=PARAMETER DISPLACEMENT IN COMMON,
C     N3 = OSCAR POINTER TO PARAMETER ENTRIES IN PRECEDING OSCAR ENTRY.
C
      N3 = J + 1
      N1 = OSCAR(J)
      N2 = 1
C
C     SCAN PARAMETER LIST OF PRECEDING OSCAR ENTRY
C
      DO 980 M = 1,N1
      L = ANDF(OSCAR(N3),NOSGN)
      IF (OSCAR(N3) .GT. 0) GO TO 970
      N3 = N3 + 1
C
C     VARIABLE PARAMETER, COMPARE VPS POINTER WITH XSAVE VPS POINTERS.
C
      I1 = I + 1
      DO 940 K1 = I1,K,2
      IF (OSCAR(K1) .EQ. L) GO TO 950
  940 CONTINUE
      GO TO 960
  950 OSCAR(K1+1) = N2
  960 L = ANDF(VPS(L-1),MASKHI)
      GO TO 980
C
C     CONSTANT PARAMETER, INCREMENT N2, N3
C
  970 N3 = N3 + L + 1
  980 N2 = N2 + L
C
C     PARAMETER SECTION SCANNED, CHECK EXSAVE PARAMETER LIST FOR
C     PARAMETERS NOT FOUND IN PRECEDING OSCAR.
C
      GO TO 2290
C
C     XUOP,XCHK,XPURGE,OR XEQUIV OSCAR ENTRY - GENERATE FILE NAME LIST.
C
  990 NOSPNT = OSPNT + OSCAR(OSPNT)
      IPRIME = 1
      IOSPNT = NOSPNT + 1
      OSCAR(NOSPNT) = 0
C
C     GET NEXT ENTRY FROM DMAP CARD
C
 1000 CALL XSCNDM
      GO TO (1040,1010,2160,1080,2060), IRTURN
C
C     DMAP ENTRY IS DATA BLOCK NAME, STORE IN OSCAR
C
 1010 OSCAR(IOSPNT  ) = DMAP(DMPPNT  )
      OSCAR(IOSPNT+1) = DMAP(DMPPNT+1)
C
C     MAKE SURE FILE IS NOT BLANK
C
      IF (OSCAR(IOSPNT) .EQ. NBLANK) GO TO 1000
C
C     FOR CHKPNT - MAKE SURE FILE IS NOT OUTPUT BY USER I/P PROCESSOR
C
      IF (OSCAR(OSPNT+3) .NE. NAMTBL(7)) GO TO 1030
      M = FIAT(3)*ICFIAT - 2
      DO 1020 J = 4,M,ICFIAT
      IF (OSCAR(IOSPNT).EQ.FIAT(J+1) .AND. OSCAR(IOSPNT+1).EQ.FIAT(J+2))
     1    GO TO 2400
 1020 CONTINUE
 1030 IOSPNT = IOSPNT + 2
      OSCAR(NOSPNT) = 1 + OSCAR(NOSPNT)
C
C     INSERT EXTRA WORD INTO OSCAR FOR EACH PRIMARY DATA BLOCK IN
C     EQUIV STATEMENT
C
      IF (OSCAR(OSPNT+3).NE.NAMTBL(11) .OR. OSCAR(OSPNT+4).NE.NAMTBL(12)
     1   ) GO TO 1000
      IF (IPRIME .EQ. 0) GO TO 1000
      OSCAR(IOSPNT) = 0
      IOSPNT = IOSPNT + 1
      IPRIME = 0
      GO TO 1000
C
C     DMAP ENTRY IS OPERATOR, CHECK FOR / OPERATOR
C
 1040 IF ((DMAP(DMPPNT+1).NE.ISLSH) .OR. (OSCAR(OSPNT+3).NE.NXEQUI .AND.
     1     OSCAR(OSPNT+3).NE.NXPURG)) GO TO 2160
C
C     OSCAR ENTRY IS XEQUIV OR XPURGE
C
      VARFLG = 0
      IF (OSCAR(OSPNT+3) .EQ. NXPURG) GO TO 1050
      IF (OSCAR(NOSPNT)  .LT. 2     ) GO TO 2160
C
C     GET PARAMETER NAME AND ENTER INTO LBLTBL
C
 1050 CALL XSCNDM
      GO TO (1110,1060,2160,2160,2060), IRTURN
 1060 VARFLG = 1
      IF (DMAP(DMPPNT) .EQ. NBLANK) GO TO 1100
      ASSIGN 1070 TO IRTURN
      IF (LSTPAR-8 .LE. LSTLBL) GO TO 2220
 1070 LSTPAR = LSTPAR - 4
      LBLTBL(LSTPAR  ) = DMAP(DMPPNT  )
      LBLTBL(LSTPAR+1) = DMAP(DMPPNT+1)
      LBLTBL(LSTPAR+2) = IOSPNT
      LBLTBL(LSTPAR+3) = OSPNT
      IDLHSS = 2*OSCAR(NOSPNT)+OSCAR(OSPNT) + 2
      IF (OSCAR(OSPNT+3) .EQ. NAMTBL(11)) IDLHSS = IDLHSS + 1
      OSCAR(OSPNT) = IDLHSS
C
C     CHECK FOR POSSIBILITY OF ANOTHER DATA BLOCK NAME LIST.
C
      CALL XSCNDM
      GO TO (990,2160,2160,300,2060), IRTURN
C
C     END OF DMAP INSTRUCTION, INCREMENT OSCAR WORD COUNT IF NOT XEQUIV
C     OR XPURGE.
C
 1080 IF (OSCAR(OSPNT+3).NE.NXEQUI .AND. OSCAR(OSPNT+3).NE.NXPURG)
     1    GO TO 1090
      OSCAR(IOSPNT) = -1
      IDLHSS = 2*OSCAR(NOSPNT) + OSCAR(OSPNT) + 2
      IF (OSCAR(OSPNT+3) .EQ. NAMTBL(11)) IDLHSS = IDLHSS + 1
      OSCAR(OSPNT) = IDLHSS
      GO TO 300
 1090 OSCAR(OSPNT) = 2*OSCAR(NOSPNT) + OSCAR(OSPNT) + 1
C
C     ELIMINATE ENTRY IF NOTHING CHECKPOINTED.
C
      IF (OSCAR(NOSPNT) .EQ. 0) OSBOT = OSPRC
      GO TO 300
 1100 CALL XSCNDM
      GO TO (1110,2160,2160,2160,2060), IRTURN
 1110 IF ((DMAP(DMPPNT+1).NE.ISLSH) .OR. (OSCAR(OSPNT+3).NE.NXEQUI .AND.
     1     OSCAR(OSPNT+3).NE.NXPURG)) GO TO 2160
      OSCAR(IOSPNT) = -1
      IDLHSS = 2*OSCAR(NOSPNT) + OSCAR(OSPNT) + 2
      IF (OSCAR(OSPNT+3) .EQ. NAMTBL(11)) IDLHSS = IDLHSS + 1
      OSCAR(OSPNT) = IDLHSS
      GO TO 990
C
C     *******************************
C     DMAP INSTRUCTION IS DECLARATIVE
C     *******************************
C
C     PUT DUMMY ENTRY IN OSCAR FOR DIAGNOSTIC USE.
C
 1200 J = OSBOT  + OSCAR(OSBOT)
      OSCAR(J+3) = DMAP(DMPPNT)
      OSCAR(J+4) = DMAP(DMPPNT+1)
      OSCAR(J+5) = DMPCNT
      CALL XLNKHD
C
C     NOW PROCESS INSTRUCTION
C
      DO 1210 J = 1,3
      IF (DMAP(DMPPNT) .EQ. DECLAR(J)) GO TO (1220,1270,1350), J
 1210 CONTINUE
C
C     BEGIN DECLARATIVE - PREPARE TO PROCESS NEXT DMAP INSTRUCTION
C
 1220 INDEX = 1
 1230 IF (IFIRST .GT. 0) GO TO 1250
      IF (DIAG14.EQ.0 .AND. DIAG17.EQ.0) GO TO 1250
      IFIRST = 1
      CALL XGPIMW (5,18,DMPCNT,IBUFF)
 1240 IF (START .NE. ICST) CALL XGPIMW (10,0,0,0)
 1250 IF (INDEX .GT.    1) GO TO 300
 1260 CALL XSCNDM
      GO TO (1260,1260,1260,300,2060), IRTURN
C
C     LABEL DECLARATIVE - GET LABEL NAME
C
 1270 CALL XSCNDM
      GO TO (2170,1280,2170,2170,2060), IRTURN
C
C     CHECK IF LABEL IS FOR CONDITIONAL COMPILATION
C
 1280 CONTINUE
      IF (DMAP(DMPPNT).NE.NSKIP(ILEVEL,1) .OR. DMAP(DMPPNT+1).NE.
     1    NSKIP(ILEVEL,2)) GO TO 1290
      ILEVEL = ILEVEL - 1
      SKIP   = .FALSE.
      GO TO 300
 1290 IF (SKIP) GO TO 300
C
C     SCAN LABEL TABLE FOR LABEL NAME
C
      IF (LSTLBL .LT. LBLTOP) GO TO 1310
      DO 1300 J = LBLTOP,LSTLBL,4
      IF (DMAP(DMPPNT).EQ.LBLTBL(J) .AND. DMAP(DMPPNT+1).EQ.LBLTBL(J+1))
     1    GO TO 1340
 1300 CONTINUE
C
C     NAME NOT IN LABEL TABLE, MAKE NEW ENTRY
C
 1310 ASSIGN 1320 TO IRTURN
      IF (LSTLBL+8 .GE. LSTPAR) GO TO 2220
 1320 LSTLBL = LSTLBL + 4
      J = LSTLBL
      LBLTBL(J  ) = DMAP(DMPPNT  )
      LBLTBL(J+1) = DMAP(DMPPNT+1)
      LBLTBL(J+3) = 0
 1330 LBLTBL(J+2) = ISEQN + 1
      GO TO 300
C
C     LABEL NAME FOUND IN LABEL TABLE, DEF ENTRY SHOULD BE ZERO
C
 1340 IF (LBLTBL(J+2)) 2250,1330,2250
C
C     FILE DECLARATIVE
C     SET FILE NAME FLAG
C     DO NOT PROCESS FILE DECLARATION WHEN EXECUTE FLAG IS OFF ON
C     MODIFIED RESTART.
C
 1350 IF (START.EQ.IMST .AND. OSCAR(OSPNT+5).GE.0) GO TO 1260
 1360 I = 1
 1370 CALL XSCNDM
      GO TO (1380,1410,2170,300,2060), IRTURN
C
C     DELIMITER ENCOUNTERED
C
 1380 IF (DMAP(DMPPNT+1) .EQ. ISLSH) GO TO 1390
      IF (DMAP(DMPPNT+1) .EQ. IEQUL) GO TO 1400
      GO TO 2170
C
C     DELIMITER IS /, TEST FILE NAME FLAG
C
 1390 IF (I .NE. 0) GO TO 2170
      GO TO 1360
C
C     DELIMITER IS =, TURN OFF FILE NAME FLAG
C
 1400 I = 0
      GO TO 1370
C
C     NAME ENCOUNTERED - TEST FILE NAME FLAG
C
 1410 IF (I .EQ. 0) GO TO 1430
C
C     FILE NAME - ENTER IN FILE TABLE
C
      FPNT = FPNT + 3
      IF (FPNT .GT. LFILE-2) GO TO 2410
      FILE(FPNT  ) = DMAP(DMPPNT  )
      FILE(FPNT+1) = DMAP(DMPPNT+1)
C
C     PUT FILE NAME INTO LABEL TABLE FOR DMAP XREF
C
      ASSIGN 1420 TO IRTURN
      IF (LSTLBL+8 .GE. LSTPAR) GO TO 2220
 1420 LSTLBL = LSTLBL + 4
      LBLTBL(LSTLBL  ) = FILE(FPNT  )
      LBLTBL(LSTLBL+1) = FILE(FPNT+1)
      LBLTBL(LSTLBL+2) = ISEQN
      LBLTBL(LSTLBL+3) = -1
      GO TO 1370
C
C     FILE PARAMETER FOUND - ENTER APPROPRIATE CODE IN FILE TABLE
C
 1430 DO 1440 J = 1,3
      IF (DMAP(DMPPNT) .EQ. FPARAM(J)) GO TO (1450,1460,1470), J
 1440 CONTINUE
      GO TO 2160
C
C     TAPE PARAM
C
 1450 FCODE = ITAPE
      GO TO 1480
C
C     APPEND PARAM
C
 1460 FCODE = IAPPND
      GO TO 1480
C
C     SAVE PARAM
C
 1470 FCODE = ISAVE
C
C     PUT CODE IN FILE TABLE
C
 1480 FILE(FPNT+2) = ORF(FILE(FPNT+2),FCODE)
      GO TO 1370
C
C     PROCESS PRECHK CARD
C
 1490 INDEX = 3
      CALL XSCNDM
      GO TO (2160,1500,2160,2160,2160), IRTURN
C
C     TEST FOR  ALL  OPTION OR BLANK
C
 1500 IF (DMAP(DMPPNT) .EQ. NBLANK) GO TO 1490
      PREFLG = 1
      NNAMES = 0
      IF (DMAP(DMPPNT) .EQ. NAMOPT(23)) GO TO 1520
      IF (DMAP(DMPPNT) .EQ.      NEND ) GO TO 1550
C
C     LIST HAS BEEN FOUND, STORE IN /AUTOCM/
C
 1510 NNAMES = NNAMES + 1
      IF (NNAMES .GT. 50) GO TO 2180
      PRENAM(2*NNAMES-1) = DMAP(DMPPNT  )
      PRENAM(2*NNAMES  ) = DMAP(DMPPNT+1)
      CALL XSCNDM
      GO TO (2160,1510,2160,1560,2060), IRTURN
C
C     ALL  OPTION FOUND, LOOK FOR  EXCEPT
C
 1520 CALL XSCNDM
      GO TO (2160,1530,2160,1530,2060), IRTURN
 1530 IF (DMAP(DMPPNT).EQ.NAMOPT(25) .AND. DMAP(DMPPNT+1).EQ.NAMOPT(26))
     1    GO TO 1540
      PREFLG = 2
      GO TO 1560
 1540 PREFLG = 3
      CALL XSCNDM
      GO TO (2160,1510,2160,1560,2060), IRTURN
 1550 PREFLG = 0
 1560 IF (ICPFLG .NE. 0) GO TO 1240
      PREFLG = 0
      GO TO 300
C
C     PROCESS XDMAP INSTRUCTION
C
 1570 IOLD = DIAG14
 1580 CALL XSCNDM
      GO TO (2160,1610,2160,1590,2060), IRTURN
 1590 INDEX = 2
      IF (IOLD.EQ.0 .OR. IFIRST.EQ.0) GO TO 1230
      IF (START .NE. ICST) WRITE (OPTAPE,1600) IPLUS,IPLUS
 1600 FORMAT (A1,2X,A1)
      GO TO 300
 1610 IF (DMAP(DMPPNT) .EQ. NBLANK) GO TO 1580
C
C     HAVE LOCATED AN XDMAP OPTION
C
      DO 1620 K = 1,22,2
      IF (DMAP(DMPPNT).EQ.NAMOPT(K) .AND. DMAP(DMPPNT+1).EQ.NAMOPT(K+1))
     1    GO TO 1630
 1620 CONTINUE
      GO TO 2190
 1630 KK = K/2 + 1
      GO TO (1580,1640,1710,1660,1650,1680,1690,1700,1580,1670,1580), KK
 1640 IFLG(1) = 0
      GO TO 1580
 1650 IF (DIAG14 .EQ. 1) GO TO 1580
      IFLG(3) = 0
      DIAG14  = 0
      GO TO 1580
 1660 IF (DIAG14 .EQ. 1) GO TO 1580
      IFLG(3) = 1
      DIAG14  = 2
      GO TO 1580
 1670 IF (DIAG4 .EQ. 1) GO TO 1580
      IFLG(6) = 1
      DIAG4   = 1
      GO TO 1580
 1680 IF (DIAG17 .EQ. 1) GO TO 1580
      IFLG(4) = 1
      DIAG17  = 2
      GO TO 1580
 1690 IF (DIAG17 .EQ. 1) GO TO 1580
      IFLG(4) = 0
      DIAG17  = 0
      GO TO 1580
 1700 IF (DIAG25 .EQ. 1) GO TO 1580
      IFLG(5) = 1
      DIAG25  = 1
      GO TO 1580
C
C     CODE TO PROCESS  ERR  OPTION
C
 1710 CALL XSCNDM
      GO TO (1720,2160,2160,2160,2060), IRTURN
 1720 IF (DMAP(DMPPNT+1) .NE. IEQUL) GO TO 2160
      CALL XSCNDM
      GO TO (2160,2160,1730,2160,2060), IRTURN
 1730 IFLG(2) = DMAP(DMPPNT+1)
      IF (IFLG(2).LT.0 .OR. IFLG(2).GT.2) GO TO 2190
      GO TO 1580
C
C     PROCESS CONDCOMP INSTRUCTION
C
 1740 IF (ILEVEL .GE. 5) GO TO 2160
      ION = 0
      IF (DMAP(DMPPNT+1) .EQ. CDCOMP(2)) ION = 1
      CALL XSCNDM
      GO TO (2160,1750,1760,2160,2060), IRTURN
C
C     LABEL SPECIFIED FOR END
C
 1750 NSKIP(ILEVEL+1,1) = DMAP(DMPPNT  )
      NSKIP(ILEVEL+1,2) = DMAP(DMPPNT+1)
      GO TO 1770
C
C     INSTRUCTION COUNT GIVEN FOR END
C
 1760 CONTINUE
      IF (DMAP(DMPPNT+1) .LT. 0) GO TO 2160
      NSKIP(ILEVEL+1,1) = DMAP(DMPPNT+1)
C
C     GET LABEL AND LOOK FOR IT IN PVT
C
 1770 CALL XSCNDM
      GO TO (2160,1780,2160,2160,2060), IRTURN
 1780 ILEVEL = ILEVEL + 1
      KDH = 3
 1790 LENGTH = ANDF(PVT(KDH+2),NOSGN)
      LENGTH = ITYPE(LENGTH)
      IF (DMAP(DMPPNT).EQ.PVT(KDH) .AND. DMAP(DMPPNT+1).EQ.PVT(KDH+1))
     1    GO TO 1810
      KDH = KDH + LENGTH + 3
      IF (KDH - PVT(2)) 1790,1800,1800
C
C     PARAMETER NOT FOUND - ASSUME FALSE VALUE
C
 1800 IF (ION .EQ. 0) GO TO 300
      GO TO 1820
C
C     CHECK IF VALUE IS FALSE
C
 1810 PVT(KDH+2) = ORF(PVT(KDH+2),ISGNON)
      IF (ANDF(PVT(KDH+2),NOSGN) .NE.  1) GO TO 2160
      IF (PVT(KDH+3).LT.0 .AND. ION.EQ.1) GO TO 300
      IF (PVT(KDH+3).GE.0 .AND. ION.EQ.0) GO TO 300
 1820 SKIP = .TRUE.
      GO TO 300
C
C     ***********************************************************
C     DMAP INSTRUCTIONS ALL PROCESSED - PREPARE OSCAR FOR PHASE 2
C     ***********************************************************
C
C     CHECK FOR DISCREPENCY BETWEEN RIGID FORMAT AND MED TABLE.
C
 1900 IF (MED(MEDTP).NE.DMPCNT .AND. IAPP.NE.IDMAPP) GO TO 2390
C
C     USE LBLTBL PARAMETER NAMES TO UPDATE VALUE SECTIONS OF TYPE C AND
C     E OSCAR ENTRIES.
C
 1910 IF (LSTPAR .GE. LBLBOT) GO TO 1990
C
C     FIND PARAMETER NAME IN VPS
C
      K = 3
 1920 IF (LBLTBL(LSTPAR).EQ.VPS(K) .AND. LBLTBL(LSTPAR+1).EQ.VPS(K+1))
     1    GO TO 1930
      K = K + ANDF(VPS(K+2),MASKHI) + 3
      IF (K - VPS(2)) 1920,1950,1950
C
C     NAME FOUND IN VPS, VPS POINTER TO OSCAR VALUE SECTION.
C
 1930 I = LBLTBL(LSTPAR+2)
      OSCAR(I) = K + 3
C
C     GET NEXT ENTRY FROM LBLTBL
C
 1940 LSTPAR = LSTPAR + 4
      GO TO 1910
C
C     SEARCH PVT TABLE FOR PARAMETER. IF FOUND ENTER PARAMETER IN VPS.
C
 1950 K1 = 3
 1960 LENGTH = ANDF(PVT(K1+2),NOSGN)
      LENGTH = ITYPE(LENGTH)
      IF (LBLTBL(LSTPAR).EQ.PVT(K1) .AND. LBLTBL(LSTPAR+1).EQ.PVT(K1+1))
     1    GO TO 1970
      K1 = K1 + LENGTH + 3
      IF (K1-PVT(2)) 1960,2310,2310
 1970 K = VPS(2) + 1
      PVT(K1+2) = ORF(PVT(K1+2),ISGNON)
      VPS(2) = K + 2 + LENGTH
      IF (VPS(2) .GE. VPS(1)) GO TO 2380
      K2 = LENGTH + 3
      DO 1980 M = 1,K2
      J  = K  + M - 1
      J1 = K1 + M - 1
 1980 VPS(J) = PVT(J1)
      GO TO 1930
C
C     USE LBLTBL ENTRIES TO LOAD SEQUENCE NOS. INTO VALUE SECTION OF
C     TYPE C OSCAR ENTRIES.
C
 1990 LBLERR = 0
      LSTLSV = LSTLBL
 2000 IF (LSTLBL .LT. LBLTOP) GO TO 2050
      IF (LBLTBL(LSTLBL+2) .EQ. 0) GO TO 2330
C
C     IGNORE FILE NAMES IN LBLTBL USED FOR XREF
C
 2010 IF (LBLTBL(LSTLBL+3)) 2040,2360,2020
 2020 I = LBLTBL(LSTLBL+3) + 6
      IF (OSCAR(I-3).EQ.NCOND .OR. OSCAR(I-3).EQ.NJUMP) GO TO 2030
      J = OSCAR(I)
C
C     LABEL NAME TO WORDS 3 AND 4 OF CEITBL ENTRY
C
      CEITBL(J+1) = LBLTBL(LSTLBL  )
      CEITBL(J+2) = LBLTBL(LSTLBL+1)
C
C     OSCAR RECORD NO. OF BEGIN LOOP TO FIRST WORD OF CEITBL ENTRY
C
      CEITBL(J-1) = ORF(LSHIFT(LBLTBL(LSTLBL+2),16),CEITBL(J-1))
 2030 OSCAR(I)    = ORF(LSHIFT(LBLTBL(LSTLBL+2),16),OSCAR(I))
C
C     GET NEXT LBLTBL ENTRY.
C
 2040 LSTLBL = LSTLBL - 4
      GO TO 2000
C
C     NORMAL RETURN -     DUMP LBLTBL ONTO SCRATCH FOR DMAP XREF
C                         THEN DELETE LBLTBL AND DMPCRD ARRARYS
C                         FROM OPEN CORE
C
 2050 LSTLBL = LSTLSV
 2060 LOSCAR = LBLBOT
      IDPBUF = KORSZ(OSCAR) - 2*BUFSZ
      CALL CLOSE (NSCR,1)
      LSTLBL = LSTLBL - LBLTOP + 4
      IF (LSTLBL .LT. 0) LSTLBL = 0
      RETURN
C
C     DIAGNOSTIC MESSAGES -
C
C     DMAP INPUT FILE ERROR
C
 2100 CALL XGPIDG (-10,OSPNT,0,0)
      GO TO 410
C
C     DMAP OUTPUT FILE ERROR
C
 2110 CALL XGPIDG (-11,OSPNT,0,0)
      GO TO 420
C
C     NO MACRO INSTRUCTION NAME ON DMAP CARD.
C
 2120 CALL XGPIDG (12,0,DMPCNT,0)
      GO TO 300
C
C     NO MPL ENTRY FOR THIS DMAP MACRO INSTRUCTION
C
 2130 CALL XGPIDG (13,0,DMPPNT,DMPCNT)
      GO TO 300
C
C     MPL TABLE INCORRECT
C
 2140 CALL XGPIDG (49,0,0,0)
      GO TO 2500
C
C     DUPLICATE PARAMETER NAMES (WARNING)
C
 2150 CALL XGPIDG (-2,OSPNT,DMAP(DMPPNT),DMAP(DMPPNT+1))
      GO TO 870
C
C     DMAP FORMAT ERROR
C
 2160 CALL XGPIDG (16,OSPNT,0,0)
      GO TO 300
 2170 J = OSBOT + OSCAR(OSBOT) + 6
      CALL XGPIDG (16,J,0,0)
      GO TO 300
C
C     PRECHK NAME LIST OVERFLOW
C
 2180 CALL XGPIDG (55,0,0,0)
      GO TO 2500
C
C     ILLEGAL OPTION ON XDMAP CARD
C
 2190 CALL XGPIDG (56,0,0,0)
      GO TO 300
C
C     VARIABLE REPT INSTRUCTION ERRORS
C
 2200 CALL XGPIDG (58,0,0,0)
      GO TO 300
 2210 CALL XGPIDG (57,0,0,0)
      GO TO 300
C
C     LBLTBL OVERFLOWED - ALLOCATE 50 MORE WORDS FOR IT.
C
 2220 ICRDTP = ICRDTP - 50
      IF (ICRDTP .LT. OSCAR(OSBOT)+OSBOT) GO TO 2240
      LOSCAR = LOSCAR - 50
C
C     MOVE LABEL NAME PORTION OF LBLTBL
C
      JX = LSTLBL + 3
      DO 2230 IX = LBLTOP,JX
      IY = IX - 50
 2230 LBLTBL(IY) = LBLTBL(IX)
      LBLTOP = LBLTOP - 50
      LSTLBL = LSTLBL - 50
      GO TO IRTURN, (570,620,1070,1320,1420)
C
C     LABEL TABLE OVERFLOW, DISCONTINUE COMPILATION
C
 2240 CALL XGPIDG (14,NLBLT1,NLBLT2,DMPCNT)
      GO TO 2500
C
C     LABEL IS MULTIPLY DEFINED
C
 2250 CALL XGPIDG (19,DMPCNT,DMPPNT,0)
      GO TO 300
C
C     ILLEGAL CHARACTERS IN DMAP SAVE PARAMETER NAME LIST
C
 2260 CALL XGPIDG (20,OSPNT,OSCAR(I)+1,0)
      GO TO 870
C
C     XSAVE PARAMETER NAME NOT ON PRECEDING DMAP CARD
C
 2270 CALL XGPIDG (21,OSPNT,DMAP(DMPPNT),DMAP(DMPPNT+1))
      GO TO 870
C
C     CEITBL OVERFLOW, DISCONTINUE COMPILATION
C
 2280 CALL XGPIDG (14,NCEIT1,NCEIT2,DMPCNT)
      GO TO 2500
C
C     CHECK FOR XSAVE PARAMETERS NOT ON PRECEDING DMAP CARD
C
 2290 I1 = I + 2
      K  = K + 1
      DO 2300 K1 = I1,K,2
      IF (OSCAR(K1).GT.0 .OR. OSCAR(K1-1).EQ.0) GO TO 2300
      J = OSCAR(K1-1)
      CALL XGPIDG (21,OSPNT,VPS(J-3),VPS(J-2))
 2300 CONTINUE
      GO TO 300
C
C     PARAMETER NOT DEFINED FOR USE IN COND, PURGE OR EQUIV INSTRUCTIONS
C
 2310 CALL XGPIDG (25,LBLTBL(LSTPAR+3),LBLTBL(LSTPAR),LBLTBL(LSTPAR+1))
      GO TO 1940
C
C     LABEL NOT DEFINED
C
 2320 CALL XGPIDG (26,LBLTBL(LSTLBL+3),LBLTBL(LSTLBL),LBLTBL(LSTLBL+1))
      NOGO = 1
      GO TO 2040
C
C     CHECK FOR LABEL DEFINED
C
 2330 DO 2340 J = LBLTOP,LSTLBL,4
      IF (LBLTBL(J).EQ.LBLTBL(LSTLBL) .AND. LBLTBL(J+1).EQ.
     1    LBLTBL(LSTLBL+1) .AND. LBLTBL(J+2).GT.0) GO TO 2350
 2340 CONTINUE
      GO TO 2320
 2350 LBLTBL(LSTLBL+2) = LBLTBL(J+2)
      GO TO 2010
C
C     LABEL NOT REFERENCED - WARNING ONLY
C
 2360 CALL XGPIDG (-27,LBLTBL(LSTLBL+2),LBLTBL(LSTLBL),LBLTBL(LSTLBL+1))
      GO TO 2040
C
C     TIME SEGMENT NAME INCORRECT - WARNING ONLY
C
 2370 CALL XGPIDG (-17,OSPNT,0,0)
      GO TO 300
C
C     VPS TABLE OVERFLOWED
C
 2380 CALL XGPIDG (14,NVPS,NBLANK,0)
      GO TO 2500
C
C     DMAP SEQUENCE DOES NOT CORRESPOND TO MED TABLE
C
 2390 CALL XGPIDG (39,0,0,0)
      GO TO 2500
C
C     WARNING - CANNOT CHECKPOINT USER INPUT
C
 2400 CALL XGPIDG (-48,OSPNT,OSCAR(IOSPNT),OSCAR(IOSPNT+1))
      GO TO 1030
C
C     OVERFLOWED FILE TABLE
C
 2410 CALL XGPIDG (14,NFILE,NBLANK,0)
      GO TO 2500
C
C     SAVE OUT OF POSITION
C
 2420 CALL XGPIDG (61,OSPNT,0,0)
      OSPNT = IOSDAV
      OSPRC = OS2B4
      GO TO 300
C
C     RETURN WHEN XGPI HAS BEEN DISASTERED.
C
 2500 NOGO = 2
      RETURN
      END

      SUBROUTINE DIHEX (TYPE)
C
C     THIS ROUTINE PROCESSES IHEX1, IHEX2, AND IHEX3 ELEMENT DATA TO
C     PRODUCE THE DIFFERENTIAL STIFFNESS MATRIX
C
C           TYPE = 1    IHEX1
C           TYPE = 2    IHEX2
C           TYPE = 3    IHEX3
C
C     THE EST ENTRIES ARE
C
C     NAME  ----------INDEX----------   DESCRIPTION
C            IHEX1    IHEX2    IHEX3
C
C     EID        1        1        1    ELEMENT ID NO.
C     SIL      2-9     2-21     2-33    SCALAR INDEX LIST
C     MID       10       22       34    MATERIAL ID NO.
C     CID       11       23       35    MATERIAL COORD. SYSTEM ID NO.
C     NIP       12       24       36    NO. INTEGRATION POINTS PER EDGE
C     MAXAR     13       25       37    MAX ASPECT RATIO
C     ALFA      14       26       38    MAX ANGLE FOR NORMALS
C     BETA      15       27       39    MAX ANGLE FOR MIDSIDE POINTS
C     BGPDT  16-47   28-107   40-167    BASIC GRID POINT DATA
C     GPT    48-55  108-127  168-199    GRID POINT TEMPERATURES
C     DEF       56      128      200    NOT USED
C     GPTLD  57-64  129-148  201-232    GRID POINT TEMPERATURE LOADS
C     UGV    65-88  149-208  233-328    GLOBAL DISPLACEMENT VECTOR
C
      LOGICAL          ANIS       ,RECT       ,TDEP       ,DIAG       ,
     1                 MTDEP
      INTEGER          HEAT       ,EID        ,SIL(1)     ,IB(46)     ,
     1                 TYPE       ,JZ(1)      ,CID        ,IEST(1)    ,
     2                 BCORD      ,BGPDT      ,GPT        ,NC(8)      ,
     4                 UFM(6)     ,ELNO(3)    ,IWORK(1)   ,OTPT
      REAL             NU         ,MAXAR      ,DMAXAR(3)  ,DALFA(3)   ,
     1                 DBETA(2)   ,EVEC(3,12) ,WORK(66)   ,VN(3,2)
      DOUBLE PRECISION SK         ,SV         ,Z(1)       ,JACOB(3,3) ,
     1                 DETJ       ,S(4)       ,H(4)       ,GAUSS(8)   ,
     2                 SFACT      ,PART(3,3)  ,E1         ,E2         ,
     3                 E3         ,TF(3,3)    ,TK(3,3)    ,SIG(6)     ,
     4                 SX         ,SY         ,SZ         ,SXY        ,
     5                 SYZ        ,SZX        ,STR(18)    ,C(3,3)
      DOUBLE PRECISION GMAT(36)    ,STORE(18)  ,DALPHA(6)
      DIMENSION        IGRID(128) ,GRID(128)
      COMMON /MATIN/   MID        ,INFLAG     ,TEMP
      COMMON /MATOUT/  E          ,G          ,NU         ,RHO        ,
     1                 TALPHA     ,TREF       ,CDAMP      ,SPACE(18)  ,
     3                 MTDEP
      COMMON /MATISO/  BUFM6(46)
      COMMON /DS1AAA/  NPVT       ,DUM6(6)    ,I6X6K      ,DUM12(12)  ,
     1                 JMAX       ,DUM2(2)    ,NROWSC
      COMMON /ZZZZZZ/  ZS(1)
      COMMON /DS1ADP/  ISIL(32)   ,SK(6,6)    ,WORK       ,STR
      COMMON /DS1AET/  EST(328)
      COMMON /SYSTEM/  SYSBUF,OTPT,NOGO,SYS(6),MTEMP
      EQUIVALENCE      (Z(1),JZ(1),ZS(1))    ,(EID,EST(1),IEST(1))   ,
     1                 (SIL(1),EST(2))       ,(WORK(1),IWORK(1))     ,
     2                 (SIG(1),SX)           ,(SIG(2),SY)            ,
     3                 (SIG(3),SZ)           ,(SIG(4),SXY)           ,
     4                 (SIG(5),SYZ)          ,(SIG(6),SZX)
      EQUIVALENCE      (WORK(1),EVEC(1,1))   ,(WORK(37),VN(1,1))     ,
     1                 (WORK(43),NC(1))
      EQUIVALENCE      (WORK(1),JACOB(1,1))  ,(WORK(19),H(1))        ,
     1                 (WORK(27),S(1))       ,(WORK(35),PART(1,1))   ,
     2                 (WORK(53),SIG(1))     ,(WORK(1),C(1,1))
      EQUIVALENCE      (WORK(1),TF(1,1))     ,(WORK(35),TK(1,1))
      EQUIVALENCE      (IB(1),BUFM6(1))      ,(GRID(1),IGRID(1))
      DATA    KGG   /  101 /, MGG   / -1     /
      DATA    DMAXAR,  DALFA, DBETA / 5.0    ,10.0      ,15.0        ,
     2                                45.0    ,45.0      ,45.0        ,
     3                                         45.0      ,45.0        /
      DATA    DTOR  ,  GAUSS  /    0.017453292519943E0,
     1                             0.577350269189626D0,
     2                             0.555555555555556D0,
     3                             0.774596669241483D0,
     4                             0.888888888888889D0,
     5                             0.347854845137454D0,
     6                             0.861136311594053D0,
     7                             0.652145154862546D0,
     8                             0.339981043584856D0/
      DATA    UFM          /4H0***,4H USE,4HR FA,4HTAL ,4HMESS,4HAGE /
      DATA    IHEX , ELNO  /4HIHEX,4H ELE,4HMENT,4H NO./
      DATA    NERR1        / 2141 /
C
      HEAT = 0
C
C     FOR DOUBLE PRECISION, OPEN CORE POINTERS MUST BE MODIFIED
C
      IZS = 1 + 2*(I6X6K + JMAX*NROWSC)
      NZS = IZS + 10655
      IZ  = IZS/2 + 1
      NZ  = NZS/2 + 1
      IPREC = 2
C
C     ALLOCATE LARGE ARRAYS IN OPEN CORE
C
      NGP = 12*TYPE - 4
      DO 5 I = 1,NGP
      IF (SIL(I) .EQ. NPVT) GO TO 7
    5 CONTINUE
      NOGO= 1
    7 IGP = I
      IF (HEAT .EQ. 1) GO TO 30
      NGG = 3*NGP
      IF (KGG .LE. 0) GO TO 10
      IK  = IZ + 3*NGG
      NK  = IK - 1 + (NGG+1)*NGG/2
      GO TO 20
   10 IK  = IZ
      NK  = IK + 3*NGG - 1
      IM  = NK + 1
      NM  =(NGP+1)*NGP/2 + NK
      GO TO 40
   20 NM  = NK
      IF (MGG .LE. 0) GO TO 40
      IM  = NK + 1
      NM  = NK + (NGP+1)*NGP/2
      GO TO 40
   30 IK  = IZ + 17
      NK  = IK - 1 + NGP**2
      IM  = NK + 1
      NM  = IM - 1 + NGP**2
      NGG = NGP
   40 IN  = NM + 1
      IG  = IN + NGP
      IX  = IG + 3*NGP
      ND  = NM + 9*NGP
      ID  = ND + 1
      ND  = ID + NGG - 1
      IF (ND .LE. NZ) GO TO 100
      WRITE (OTPT,7100) UFM,NERR1,IHEX,TYPE,ELNO,EID
      NOGO = 1
C
C     OPEN CORE MAP
C     =============
C
C     DOUBLE PRECISION  Z(1)
C     COMMON  /ZZZZZZ/  Z
C
C     NGG = ORDER OF ELEMENT MATRIX
C
C     INDEX      STIFFNESS             MASS                HEAT
C                AND MASS              ONLY              TRANSFER
C
C     IZ    NGG BY 3 PARTITION  NGG BY 3 PARTITION  FOUR WORD COORDINATE
C           OF MATRIX           OF MATRIX           VECTOR.  INPUT TO
C                                                   TRANSD
C
C     IZ+2                                          TRANSFORMED THERMAL
C                                                   CONDUCTANCE MATRIX
C
C     IT                                            MATERIAL TRANSFOR-
C                                                   MATION MATRIX
C
C     IK    SYMMETRIC HALF OF   SAME AS IZ          FULL CONDUCTANCE
C           STIFFNESS
C
C     IM    SYMMETRIC HALF OF   SYMMETRIC HALF OF   FULL CAPACITANCE
C           MASS                MASS
C
C     IN    --------------------SHAPE FUNCTIONS-------------------------
C
C     IG    --------------------D(SHAPE)/D(GREEK)-----------------------
C
C     IX    --------------------D(SHAPE)/D(BASIC XYZ)-------------------
C
C     ID    DISPLACEMENT
C           VECTOR IN BASIC
C           COORDINATES
C
C
C     CHECK GEOMETRY.  THE FOLLOWING CHECKS ARE MADE
C           1.  ASPECT RATIO
C           2.  ANGLES BETWEEN NORMALS OF SUB-TRIANGLES ON EACH FACE
C           3.  ANGLES BETWEEN VECTORS BETWEEN POINTS ALONG EACH EDGE
C           4.  REVERSE SEQUENCING
C           5.  DUPLICATE COORDINATE VALUES
C
C     FETCH EPT DATA, COMPUTE EST POINTERS
C
  100 MID  = 10 + 12*(TYPE-1)
      CID  = IEST(MID+1)
      NIP  = IEST(MID+2)
      MAXAR= EST(MID+3)
      ALFA = EST(MID+4)
      BETA = EST(MID+5)
      BGPDT= MID + 6
      GPT  = BGPDT + 4*NGP
      MID  = IEST(MID)
      IF (NIP.LT.2 .OR. NIP.GT.4) NIP = TYPE/2 + 2
      IF (MAXAR .LE. 0.0) MAXAR = DMAXAR(TYPE)
      IF (ALFA  .LT. 0.0) ALFA  = DALFA(TYPE)
      IF (BETA  .LT. 0.0) BETA  = DBETA(TYPE-1)
      ALFA = COS(DTOR*ALFA)
      BETA = COS(DTOR*BETA)
C
C     TRANSFORM DISPLACEMENT VECTOR TO BASIC COORDINATES
C
      DO 104 I = 1,NGP
      M  = BGPDT + 4*I - 4
      N  = ID + 3*I - 3
      J  = GPT + 2*NGP + 3*(I-1) + 1
      IF (IEST(M) .EQ. 0) GO TO 102
      CALL TRANSD (EST(M) ,Z(IZ))
      DO 101 L = 1,3
  101 Z(IK+L-1) = DBLE(EST(J+L-1)*0.25)
      CALL GMMATD (Z(IZ),3,3,0,Z(IK),3,1,0,Z(N))
      GO TO 104
  102 DO 103 L = 1,3
  103 Z(N+L-1) = DBLE(EST(J+L-1)*0.25)
  104 CONTINUE
C
C     REARRANGE BGPDT
C
      DO 110 I = 1,NGP
  110 IGRID(I) = IEST(BGPDT+4*I-4)
      BCORD = GPT - 3
      DO 120 I = 2,NGP
      DO 120 J = 1,3
      K = BGPDT + 4*(NGP-I) + 4 - J
      BCORD = BCORD - 1
      EST(BCORD) = EST(K)
  120 CONTINUE
      DO 130 I = 2,NGP
  130 IEST(BGPDT+I-1) = IGRID(I)
C
C     INITIALIZE FOR NUMERICAL INTEGRATION
C
C
C     ABSCISSAE AND WEIGHT COEFFICIENTS FOR GAUSSIAN QUADRATURE
C
      I = NIP - 1
      GO TO (510,520,530), I
  510 H(1) = 1.0
      S(1) = GAUSS(1)
      H(2) = 1.0
      S(2) =-GAUSS(1)
      GO TO 540
  520 H(1) = GAUSS(2)
      S(1) = GAUSS(3)
      H(2) = GAUSS(4)
      S(2) = 0.0
      H(3) = GAUSS(2)
      S(3) =-GAUSS(3)
      GO TO 540
  530 H(1) = GAUSS(5)
      S(1) = GAUSS(6)
      H(2) = GAUSS(7)
      S(2) = GAUSS(8)
      H(3) = GAUSS(7)
      S(3) =-GAUSS(8)
      H(4) = GAUSS(5)
      S(4) =-GAUSS(6)
C
C     GENERATE TABLE OF EQUIVALENTS IN SIL ARRAY SO MATRIX WILL BE
C     ORDERED ACCORDING TO INCREASING SIL NUMBERS
C
  540 DO 550 I = 1,NGP
      ISIL(I) = SIL(I)
  550 SIL(I) = I
C
C     NOW SIL(I) = PARTITION NUMBER OF ELEMENT GRID POINT I
C
C     ZERO OUT OPEN CORE FOR MATRIX SUMMATION
C
      DO 580 I = IK,NM
  580 Z(I) = 0.0
C
C     FETCH MATERIAL PROPERTIES
C
C     THIS SECTION OF CODE MUST BE UPDATED WHEN GENERAL ANISOTROPIC
C     MATERIAL IS ADDED.
C
C     TEST FOR ANISOTROPIC MATERIAL
C
      ANIS = .FALSE.
C
C     TEST FOR RECTANGULAR COORDINATE SYSTEM IN WHICH THE ANISOTROPIC
C     MATERIAL IS DEFINED
C
      RECT = .TRUE.
C
C     CHECK FOR TEMPERATURE DEPENDENCE
C
      TDEP = .TRUE.
      DO 610 I = 2,NGP
      IF (EST(GPT) .NE. EST(GPT+I-1)) GO TO 630
  610 CONTINUE
      TDEP = .FALSE.
  630 TEMP = EST(GPT)
      INFLAG = 10
      CALL MAT (EID)
      IF (.NOT.MTDEP) TDEP = .FALSE.
      IF (IB(46) .EQ. 6) ANIS = .TRUE.
      TREF = BUFM6(44)
C
      IF (KGG .LE. 0) GO TO 1000
C
C     IF ISOTROPIC, TEMPERATURE INDEPENDENT MATERIAL, COMPUTE CONSTANTS
C
      IF (TDEP) GO TO 1000
      IF (ANIS) GO TO 800
      IF (IB(46) .NE. 0) GO TO 640
      WRITE (OTPT,7300) UFM,MID,EID
      NOGO = 1
      RETURN
C
  640 E1 = BUFM6(1)
      E2 = BUFM6(2)
      E3 = BUFM6(22)
      TALPHA = BUFM6(38)
      GO TO 1000
C
C     IF MATERIAL IS ANISOTROPIC, DEFINED IN A RECTANGULAR COORDINATE
C     SYSTEM, AND NOT TEMPERATURE DEPENDENT, TRANSFORM IT TO BASIC
C     SYSTEM
C
  800 DO 810 IJK = 1,36
  810 GMAT(IJK) = BUFM6(IJK)
C
C     CODE TO TRANSFORM GENERAL ANISOTROPIC MATERIAL PROPERTIES TO
C     BASIC COORDINATE SYSTEM MUST BE ADDED HERE.
C
C     ALL SET TO BEGIN INTEGRATION LOOPS.  DO IT.
C
 1000 DO 2000 I = 1,NIP
      DO 2000 J = 1,NIP
      DO 2000 K = 1,NIP
C
C     GENERATE SHAPE FUNCTIONS AND JACOBIAN MATRIX INVERSE
C
      CALL IHEXSD (TYPE,Z(IN),Z(IG),JACOB,DETJ,EID,S(I),S(J),S(K),
     1             EST(BCORD))
      IF (DETJ .NE. 0.0) GO TO 1010
C
C     BAD ELEMENT IF FALL HERE.  JACOBIAN MATRIX WAS SINGULAR.
C
      NOGO = 1
      RETURN
C
 1010 SFACT = H(I)*H(J)*H(K)*DETJ
      IF (KGG .LE. 0) GO TO 1015
C
C     STIFFNESS
C
C     COMPUTE STRAIN-DISPLACEMENT RELATIONS
C
C     MUST REVERSE CALLING ORDER SINCE MATRICES ARE STORED BY COLUMNS
C
      CALL GMMATD (Z(IG),NGP,3,0,JACOB,3,3,0,Z(IX))
C
C     IF MATERIAL IS TEMPERATURE DEPENDENT, MUST COMPUTE TEMPERATURE
C     AT THIS INTEGRATION POINT AND FETCH MATERIAL PROPERTIES AGAIN
C
 1015 IF (.NOT.TDEP) GO TO 1030
      TEMP = 0.0
      DO 1020 L = 1,NGP
 1020 TEMP = TEMP + Z(IN+L-1)*EST(GPT+L-1)
      CALL MAT (EID)
      IF (KGG .LE. 0) GO TO 1100
      IF (ANIS) GO TO 1040
      IF (IB(46) .NE. 0 ) GO TO 1025
      WRITE (OTPT,7300) UFM,MID,EID
      NOGO = 1
      RETURN
C
 1025 E1 = BUFM6(1)
      E2 = BUFM6(2)
      E3 = BUFM6(22)
      TALPHA = BUFM6(38)
      GO TO 1100
 1030 IF (KGG .LE. 0) GO TO 1100
C
C     IF MATERIAL IS ANISOTROPIC AND NOT DEFINED IN RECTANGULAR COOR-
C     DINATE SYSTEM, MUST TRANSFORM TO BASIC COORDINATE SYSTEM AT THIS
C     INTEGRATION POINT
C
C     THIS CODE MUST BE COMPLETED WHEN GENERAL ANISOTROPIC MATERIAL IS
C     ADDED
C
      IF (.NOT.ANIS) GO TO 1100
      IF (RECT) GO TO 1100
 1040 CONTINUE
C
C     INSERT GLOBAL TO BASIC TRANSFORMATION OPERATIONS HERE FOR
C     ANISOTROPIC MATERIAL MATRIX
C
      DO 1041 IJK = 1,36
 1041 GMAT(IJK) = BUFM6(IJK)
C
C     MATERIAL HAS BEEN EVALUATED FOR THIS INTEGRATION POINT WHEN
C     FALL HERE.
C
 1100 CONTINUE
C
C     COMPUTE STRESSES FOR DIFFERENTIAL STIFFNESS MATRIX
C
C     THERMAL EFFECTS
C
      IF (IEST(GPT+NGP+1) .EQ. -1) GO TO 1120
C
C     COMPUTE LOADING TEMPERATURE AT THIS POINT
C
      TEMP = 0.0
      DO 1110 L = 1,NGP
 1110 TEMP = TEMP + Z(IN+L-1)*EST(GPT+NGP+L)
      TEMP = 0.25*(TEMP-TREF)
      IF (ANIS) GO TO 1115
      SIG(1) =-TALPHA*(E1+2.0*E2)*TEMP
      SIG(2) = SIG(1)
      SIG(3) = SIG(1)
      SIG(4) = 0.0
      SIG(5) = 0.0
      SIG(6) = 0.0
      GO TO 1140
C
C     ANISOTROPIC
C
 1115 DO 1116 IJK = 1,6
 1116 DALPHA(IJK) = BUFM6(IJK+37)
C
      CALL GMMATD (GMAT(1),6,6,0,DALPHA(1),6,1,0,SIG)
      DO 1117 IJK = 1,6
 1117 SIG(IJK) = -SIG(IJK)*TEMP
      GO TO 1140
 1120 DO 1130 L = 1,6
 1130 SIG(L) = 0.0
C
C     DISPLACEMENT EFFECTS, COMPUTE STRESS MATRIX AND MULTIPLY BY DISPL.
C
 1140 STR(12) = 0.0
      STR(13) = 0.0
      STR(17) = 0.0
      DO 1150 L = 1,NGP
      II = IX + 3*L - 4
      IF (ANIS) GO TO 1141
      STR( 1) = E1*Z(II+1)
      STR( 2) = E2*Z(II+2)
      STR( 3) = E2*Z(II+3)
      STR( 4) = E2*Z(II+1)
      STR( 5) = E1*Z(II+2)
      STR( 6) = E2*Z(II+3)
      STR( 7) = E2*Z(II+1)
      STR( 8) = E2*Z(II+2)
      STR( 9) = E1*Z(II+3)
      STR(10) = E3*Z(II+2)
      STR(11) = E3*Z(II+1)
      STR(14) = E3*Z(II+3)
      STR(15) = E3*Z(II+2)
      STR(16) = E3*Z(II+3)
      STR(18) = E3*Z(II+1)
      GO TO 1145
C
C     ANISOTROPIC
C
 1141 DO 1142 IJK = 1,18
 1142 STORE(IJK) = 0.D0
      STORE( 1) = Z(II+1)
      STORE( 5) = Z(II+2)
      STORE( 9) = Z(II+3)
      STORE(10) = Z(II+2)
      STORE(11) = Z(II+1)
      STORE(14) = Z(II+3)
      STORE(15) = Z(II+2)
      STORE(16) = Z(II+3)
      STORE(18) = Z(II+1)
C
      CALL GMMATD (GMAT(1),6,6,0,STORE(1),6,3,0,STR(1))
C
 1145 CONTINUE
      CALL GMMATD (STR,6,3,-2,Z(ID+3*L-3),3,1,0,SIG)
 1150 CONTINUE
      SV = SX
      SX = SX + SY
      SY = SY + SZ
      SZ = SZ + SV
C
C     NOW BEGIN LOOPS OVER GRID POINTS ALONG ROWS AND COLUMNS
C
      DO 1400 N = 1,NGP
      DO 1400 M = N,NGP
      IF (N.EQ.IGP .OR. M.EQ.IGP) GO TO 1170
      GO TO 1400
 1170 CONTINUE
C
C     COMPUTE PARTITION FOR POINTWISE ROW M AND COLUMN N
C
      IF (KGG .LE. 0) GO TO 1300
      IF (.NOT.ANIS ) GO TO 1200
C
C     MUST ADD CODE TO COMPUTE THE CONTRIBUTION TO THE STIFFNESS MATRIX
C     FOR ANISOTROPIC MATERIAL HERE
C     =================================================================
C
 1200 IF (SIL(M) .GE. SIL(N)) GO TO 1210
C
C     MUST COMPUTE TRANSPOSE OF THIS PARTITION FOR SUMMATION IN ELEMENT
C     MATRIX
C
      MZ = IX + (N-1)*3
      NZ = IX + (M-1)*3
      GO TO 1220
 1210 MZ = IX + (M-1)*3
      NZ = IX + (N-1)*3
C
C     DIFFERENTIAL STIFFNESS
C
 1220 DO 1223 L = 1,3
      DO 1223 INC = 1,3
 1223 C(L,INC)  = Z(MZ+INC-1)*Z(NZ+L-1)
      PART(1,1) = SX*C(2,2) + SYZ*(C(2,3) + C(3,2)) + SZ*C(3,3)
      PART(2,2) = SY*C(3,3) + SZX*(C(3,1) + C(1,3)) + SX*C(1,1)
      PART(3,3) = SZ*C(1,1) + SXY*(C(1,2) + C(2,1)) + SY*C(2,2)
      PART(2,1) =-SX*C(2,1) + SXY*C(3,3) - SYZ*C(1,3) - SZX*C(2,3)
      PART(3,1) =-SZ*C(3,1) - SXY*C(3,2) - SYZ*C(2,1) + SZX*C(2,2)
      PART(1,2) =-SX*C(1,2) + SXY*C(3,3) - SYZ*C(3,1) - SZX*C(3,2)
      PART(3,2) =-SY*C(3,2) - SXY*C(3,1) + SYZ*C(1,1) - SZX*C(1,2)
      PART(1,3) =-SZ*C(1,3) - SXY*C(2,3) - SYZ*C(1,2) + SZX*C(2,2)
      PART(2,3) =-SY*C(2,3) - SXY*C(1,3) + SYZ*C(1,1) - SZX*C(2,1)
C
C     ADD STIFFNESS PARTITION TO ELEMENT MATRIX
C
C     COMPUTE INDEX INTO OPEN CORE WHERE PART(1,1) IS TO BE ADDED.
C
      IF (SIL(M)-SIL(N)) 1230,1240,1250
 1230 MZ = SIL(N)
      NZ = SIL(M)
      DIAG = .FALSE.
      GO TO 1260
 1240 MZ = SIL(M)
      NZ = SIL(N)
      DIAG = .TRUE.
      GO TO 1260
 1250 MZ = SIL(M)
      NZ = SIL(N)
      DIAG = .FALSE.
C
C     COLUMN NUMBER
C
 1260 L = (NZ-1)*3 + 1
C
C     INCREMENT BETWEEN COLUMNS
C
      INC = NGG - L
C
C     FIRST WORD OF COLUMN
C
      L = IK + ((L-1)*L)/2 + (INC+1)*(L-1)
C
C     WORD IN COLUMN FOR THIS ROW
C
      L = L + 3*(MZ-NZ)
C
C     ADD PARTITION
C
      DO 1280 NZ = 1,3
      DO 1270 MZ = 1,3
      IF (DIAG .AND. MZ.LT.NZ) GO TO 1270
      Z(L+MZ-1) = Z(L+MZ-1) + PART(MZ,NZ)*SFACT
 1270 CONTINUE
      L   = L + INC
      INC = INC - 1
 1280 CONTINUE
 1300 IF (MGG .LE. 0) GO TO 1400
 1400 CONTINUE
 2000 CONTINUE
C
C     END OF INTEGRATION LOOPS
C
C
C     LOOK FOR NON-BASIC COORDINATE SYSTEM
C
      DO 2003 I = 1,NGP
      IF (IEST(BGPDT+I-1) .NE. 0) GO TO 2005
 2003 CONTINUE
      GO TO 2061
C
C     RESTORE GRID POINT DATA TO ORIGINAL FORM FOR DOING TRANSFORM
C     TO GLOBAL COORDINATES
C
C     FIRST, TRANSFER IT TO OPEN CORE AT IN
C
 2005 K = (IN-1)*2 + 1
      J = NGP*4
      DO 2010 I = 1,J
 2010 GRID(I) = EST(BGPDT+I-1)
C
C     NOW MOVE IT BACK AND REARRANGE IT
C
      DO 2020 I = 1,NGP
      IEST(BGPDT+4*I-4) = IGRID(I)
      DO 2020 J = 1,3
      EST(BGPDT+4*I-4+J) = GRID(NGP+3*I+J-3)
 2020 CONTINUE
C
C     FETCH GLOBAL TO BASIC TRANSFORMATION MATRICES
C
      DO 2025 I = 1,NGP
      J = IN + (I-1)*9
      CALL TRANSD (EST(BGPDT+4*I-4),Z(J))
 2025 CONTINUE
C
C     TRANSFORM STIFFNESS TO GLOBAL COORDINATES
C
      DO 2060 I = 1,NGP
C
C     COLUMN INDICES
C
      K   = (I-1)*3 + 1
      INC = NGG - K + 1
      L   = IK + ((K-1)*K)/2 + INC*(K-1)
      M   = L + INC
      N   = M + INC - 1
C
C     TRANSFORMATION MATRIX INDEX
C
      NZ  = IN + (I-1)*9
C
C     TERMS ON DIAGONAL PARTITION
C
      CALL TKTZTK (TK,Z,NZ,L,M,N)
C
C     OFF-DIAGONAL PARTITIONS
C
      L   = L + 3
      M   = M + 2
      N   = N + 1
      IRP = I + 1
      IF (IRP .GT. NGP) GO TO 2060
      DO 2050 J = IRP,NGP
      NZ  = IN + 9*(J-1)
      DO 2030 K = 1,3
      TK(K,1) = 0.0
      TK(K,2) = 0.0
      TK(K,3) = 0.0
      DO 2030 MZ = 1,3
      TK(K,1) = TK(K,1) + Z(L+MZ-1)*Z(NZ+3*MZ+K-4)
      TK(K,2) = TK(K,2) + Z(M+MZ-1)*Z(NZ+3*MZ+K-4)
      TK(K,3) = TK(K,3) + Z(N+MZ-1)*Z(NZ+3*MZ+K-4)
 2030 CONTINUE
      MZ = IN + 9*(I-1)
      DO 2040 K = 1,3
      Z(L+K-1) = 0.0
      Z(M+K-1) = 0.0
      Z(N+K-1) = 0.0
      DO 2040 II = 1,3
      Z(L+K-1) = Z(L+K-1) + TK(K,II)*Z(MZ+3*II-3)
      Z(M+K-1) = Z(M+K-1) + TK(K,II)*Z(MZ+3*II-2)
      Z(N+K-1) = Z(N+K-1) + TK(K,II)*Z(MZ+3*II-1)
 2040 CONTINUE
      L = L + 3
      M = M + 3
      N = N + 3
 2050 CONTINUE
 2060 CONTINUE
C
C     BUILD STIFFNESS PARTITIONS AND PASS TO EMGOUT
C
 2061 DO 2065 I = 1,36
 2065 SK(I,1) = 0.0D0
      I = IGP
      DO 2090 J = 1,3
C
C     COLUMN NUMBER
C
      K = (I-1)*3 + J
C
C     NUMBER OF TERMS TO FETCH TO COMPLETE THIS COLUMN IN PARTITION
C
      L = K - 1
      IF (L .EQ. 0) GO TO 2075
C
C     FETCH TERMS AND LOAD INTO J-TH COLUMN OF PARTITION
C
      N   = IK + L
      INC = NGG - 1
      DO 2070 M = 1,L
      Z(IZ+NGG*J-NGG+M-1) = Z(N)
      N   = N + INC
      INC = INC - 1
 2070 CONTINUE
C
C     FILL OUT PARTITION WITH COLUMNS OF STIFFNESS MATRIX
C
C     COMPUTE INDEX IN OPEN CORE OF FIRST TERM OF COLUMN K
C
 2075 N = IK + ((K-1)*K)/2 + (NGG-K+1)*(K-1)
C
C     INSERT THIS COLUMN IN PARTITION
C
      DO 2080 M = K,NGG
      Z(IZ+NGG*J-NGG+M-1) = Z(N)
      N = N + 1
 2080 CONTINUE
 2090 CONTINUE
      DO 2100 I = 1,NGP
      J = (I-1)*3 + IZ - 1
      DO 2095 M = 1,3
      DO 2095 N = 1,3
      K = J + N + (M-1)*NGG
 2095 SK(N,M) = Z(K)
      CALL DS1B (SK,ISIL(I))
 2100 CONTINUE
C
C     ALL DONE, NO ERRORS
C
      RETURN
C
C
 7100 FORMAT (6A4,I4,2H, ,A4,I1,3A4,I9,' INSUFFICIENT CORE TO COMPUTE',
     1       ' ELEMENT MATRIX')
 7300 FORMAT (6A4,'4005. AN ILLEGAL VALUE OF -NU- HAS BEEN SPECIFIED ',
     1       'UNDER MATERIAL ID =',I10,17H FOR ELEMENT ID =,I10)
C
      END

        SUBROUTINE DSBLPK ( BLOCK )
      INCLUDE 'DSIOF.COM'
      INCLUDE 'PAKBLK.COM'
      INCLUDE 'XNSTRN.COM'
      INTEGER           BLOCK(15)
      BLOCK( 1 ) = NAME
      BLOCK( 2 ) = ITYPO
      IF ( ITRAIL .EQ. -1 ) GO TO 10
      BLOCK( 3 ) = 0
      GO TO 20
10    BLOCK( 3 ) = 1
20    CONTINUE
      BLOCK( 4 ) = 0
      BLOCK( 7 ) = 0
      BLOCK( 8 ) = -1
      BLOCK(10 ) = 0
      BLOCK(12 ) = BLOCK( 12 )  + 1
      BLOCK(13 ) = ITYPI
      CALL PUTSTR( BLOCK )
      IFLAG =  FCB( 8, IFILEX )
      IF ( IFLAG .NE. 0 ) GO TO 700
      BLOCK( 12 ) = 1
      FCB( 8, IFILEX ) = 1
      IBASE( INDCLR + 2 ) = 1
      GO TO 700
700   RETURN
      END

      DOUBLE PRECISION FUNCTION DKL (NP,I,L,R,Z)
C-----
C   THIS ROUTINE CALCULATES THE DOUBLE PRECISION  DELTA(IJ)  INTEGRALS
C FOR AXISYMMETRIC SOLIDS IN SMA1, EMG.
C
C   INPUT
C     NP = NUMBER OF POINTS (3 OR 4)
C     I,L= THE INTEGRAL DESIRED (I SERIES STARTS WITH -1)
C     R  = RADIUS ARRAY (NP LONG)
C     Z  = Z-CORD ARRAY (NP LONG)
C
C   OUTPUT
C     DKL = DESIRED INTEGRAL
C
C-----
      INTEGER NAM(2)
      DOUBLE PRECISION A         ,AJ       ,AR
     1,       BETA
     2,       DR       ,DZ       ,DFACT    ,DZJ      ,DL1
     3,       EPS
     4,       FACT
     5,       GKL
     6,       ONE
     7,       PR
     8,       RA       ,RB       ,R(1)     ,RAK      ,RBK
     9,       TWO      ,THREE
     *,       ZA       ,ZB       ,ZERO     ,Z(1)
C
      DATA EPS / .01D0 /
      DATA ZERO,ONE,TWO,THREE / 0.0D0, 1.0D0, 2.0D0, 3.0D0 /
      DATA NAM / 4HDKL , 1H  /
C
      DKL = ZERO
      L1 = L+1
      L2 = L + 2
      DL1 = L1
      K  = I+1
C
C  . LOOP ON NUMBER OF POINTS...
      IF (R(1).LE.ZERO) GO TO 300
       DO 200 M = 1,NP
      J = M+1
      IF (M.EQ.NP) J = 1
      RA = R(M)
      RB = R(J)
      ZA = Z(M)
      ZB = Z(J)
      DR = RB-RA
      DZ = ZB-ZA
C
C  . TEST IF RADIUS IS .LE. 0 (DRIVER SHOULD FIND THIS)...
      IF (RB.LE.ZERO) GO TO 300
      GKL = ZERO
      PR = RA+RB
      AR = PR / TWO
C
C  . CHECK FOR APPROXIMATION, DR/AVE(R)...
      IF ( DABS ( DR/AR ) .LT. EPS ) GO TO 70
C
      A = ZA*DR - RA*DZ
      BETA = A/DR
C
C  . CHECK FOR BETA .EQ. 0 CASE...
      IF (DABS (BETA / AR ) .GT. EPS ) GO TO 10
C
      IF (DZ.EQ.ZERO) GO TO 200
      LK = L + K + 1
      AR = LK
      GKL = (DZ/DR)**L1 * (RA**LK-RB**LK) / (DL1*AR)
       GO TO 200
C
C  . GENERAL CASE...
   10 RAK = RA**K
      RBK = RB**K
      IF ( K ) 300,20,30
C
C  . GENERAL CASE, K.EQ.0, CONSTANT TERM...
   20 GKL = DLOG (RA/RB) / DL1
       GO TO 40
C
C  . GENERAL CASE, CONSTANT TERM...
   30 AR = K * L1
      GKL = (RAK - RBK) / AR
C
C  . GENERAL CASE, SUMMATION...
   40 IF (DZ.EQ.ZERO) GO TO 65
      LFACT = 1
C  . CALCULATE FACTORIAL (L+1)...
       DO 50 J = 2,L
   50 LFACT = LFACT * J
      FACTL = LFACT
      JFACT = 1
      AJ  = ONE
      DZJ = ONE
      LMJF= LFACT * L1
       DO 60 J = 1,L1
      JFACT = JFACT * J
C  . CALCULATE (L+1-J) FACTORIAL IN LMJF...
      LMJF = LMJF / (L2-J)
      FACT = FACTL / FLOAT (JFACT*LMJF)
      DFACT = K + J
      DFACT = FACT / DFACT
      AJ  = AJ * A
      RAK = RAK * RA
      RBK = RBK * RB
      DZJ = DZJ * DZ
   60 GKL = GKL + (DFACT * DZJ * (RAK-RBK)) / AJ
C-----
   65 GKL = GKL * BETA**L1
       GO TO 200
C
C  . APPROXIMATE CODE...
   70 CONTINUE
      IF (DR.EQ.ZERO) GO TO 200
      DZJ = L1 * L2
      RBK = ZB**L1
      J = K - 1
      GKL = -DR * AR**J * RBK / DL1
C
      IF (DZ.EQ.ZERO) GO TO 200
      GKL = GKL + (( (TWO*RA+RB) / THREE)**J * DR * DABS(ZA**L2-RBK*ZB))
     1               / (DZJ * DZ)
C
  200 DKL = DKL + GKL
C-----
C
C  . ALL DONE
C
  210 CONTINUE
      RETURN
C
C  . ERROR...
C
  300 CALL MESAGE (-7,K,NAM)
       GO TO 210
      END

      SUBROUTINE GFSMA
C
C     MODULE GFSMA  ( GENERAL FLUID / STRUCTURE MATRIX ASSEMBLER )
C
C
C     DMAP CALL
C
C        GFSMA  AXY,AFRY,KYY,DKAA,DKFRFR,KAA,MAA,GM,GO,USETS,USETF,
C               PHIA,PHIX,LAMA/KMAT,MMAT,GIA,POUT,HC/V,N,NOGRAV/
C               V,N,NOFREE/V,Y,KCOMP/V,Y,COMPTYP/V,N,FORM/V,Y,LMODES $
C
C     INPUT DATA BLOCKS
C
C        AXY    - STRUCTURE / FLUID AREA MATRIX
C        AFRY   - FREE SURFACE AREA MATRIX
C        KYY    - FLUID STIFFNESS MATRIX
C        DKAA   - STRUCTURE GRAVITY STIFFNESS MATRIX
C        DKFRFR - FREE SURFACE GRAVITY STIFFNESS MATRIX
C        KAA    - REDUCED STRUCTURE STIFFNESS MATRIX
C        MAA    - REDUCED STRUCTURE MASS MATRIX
C        GM     - MULTIPOINT CONSTRAINT TRANSFORMATION MATRIX
C        GO     - OMIT POINT TRANSFORMATION MATRIX
C        USETS  - STRUCTURE ONLY SET DEFINITION TABLE
C        USETF  - FLUID AND STRUCTURE SET DEFINITION TABLE
C        PHIA   - SOLUTION EIGENVECTORS  A - SET
C        PHIX   - SOLUTION EIGENVECTORS  X - SET
C        LAMA   - SOLUTION EIGENVALUE TABLE
C
C     OUTPUT DATA BLOCKS
C
C        KMAT   - COMBINATION FLUID / STRUCTURE STIFFNESS MATRIX
C        MMAT   - COMBINATION FLUID / STRUCTURE MASS MATRIX
C        GIA    - PRESSURE TRANSFORMATION MATRIX
C        POUT   - PARTITIONING VECTOR FOR MODAL DISPLACEMENTS
C        HC     - CONSTRAINT TRANSFORMATION MATRIX FOR INCOMPRESSIBLE
C                 APPROACH
C
C     PARAMETERS
C
C        NOGRAV  - GRAVITY FLAG  (-1 FOR NO GRAVITY)
C        NOFREE  - FREE SURFACE FLAG  (-1 FOR NO FREE SURFACE)
C        KCOMP   - COMPRESSIBILITY FACTOR  (DEFAULT = 1.0)
C        COMPTYP - TYPE OF COMPRESSIBLILITY COMPUTATIONS
C                       -1  STRUCTURE AND FREE SURFACE ARE COUPLED
C                           WITH A SPRING TO RESIST VOLUME CHANGE
C                        1  PURE INCOMPRESSIBLE - CONSTRAINT EQUATION
C                           IS GENERATED TO RESTRICT VOLUME CHANGE
C        FORM    - TYPE OF FORMULATION TO BE USED
C                       -1  DIRECT FORMULATION
C                        1  MODAL FORMULATION
C        LMODES  - NUMBER OF MODES USED IN MODAL FORMULATION
C                  ( -1 IF ALL STRUCTURE MODES ARE TO BE USED (
C
      INTEGER       FORM     ,COMPTP
C
C     MODULE PARAMETERS
C
      COMMON /BLANK/     NOGRAV   ,NOFREE   ,KCOMP   ,COMPTP
     1                  ,FORM     ,LMODES
C
C     LOCAL VARIABLES FOR GFSMOD AND GFSMO2
C
      COMMON /GFSMOX/    DUMMY(38)
C***********************************************************************
C
      IF(FORM .GT. 0) GO TO 10
C
C     DIRECT FORMULATION
C
      CALL GFSDIR
      GO TO 100
C
C     MODAL FORMULATION
C
   10 CALL GFSMOD
      CALL GFSMO2
C
C     MODULE COMPLETION
C
  100 CONTINUE
      RETURN
      END

      FUNCTION NUMTYP ( IVALUE )
C
      CHARACTER * 2  BYTE(4)
      CHARACTER * 8  WORD

C
      EQUIVALENCE    ( BYTE, WORD )
C
C      WRITE(6,40646) IVALUE
40646 FORMAT(' NUMTYP,IVALUE=',Z9)
      IF ( IVALUE .EQ. 0 ) GO TO 200
      WRITE ( WORD, 2000 ) IVALUE
      IF ( BYTE(1) .EQ. '  ' ) GO TO 210
      IF ( BYTE(1) .EQ. '00' ) GO TO 210
      IF ((BYTE(1) .EQ. '07'.OR. BYTE(1) .EQ. ' 7') .AND.
     &     BYTE(2) .EQ. 'FF' .AND.
     &     BYTE(3) .EQ. 'FF' .AND.
     &     BYTE(4) .EQ. 'FF' )  GO TO 210
      IF ( BYTE(1) .EQ. '7F' .AND.
     &     BYTE(2) .EQ. 'FF' .AND.
     &     BYTE(3) .EQ. 'FF' .AND.
     &     BYTE(4) .EQ. 'FF' )  GO TO 210

      IF ( BYTE(1) .EQ. 'FF' ) GO TO 210
      DO 100 I = 1, 4
      IF ( BYTE(I) .LT. '1F' .OR. BYTE(I) .GT. '5E' ) GO TO 220
100   CONTINUE
      GO TO 230
C
C     VALUE IS ZERO
C
200   NUMTYP = 0
      GO TO 700
C
C     VALUE IS INTEGER
C
210   NUMTYP = 1
      GO TO 700
C
C     VALUE IS REAL
C
220   NUMTYP = 2
      GO TO 700
C
C     VALUE IS ALPHA
C
230   NUMTYP = 3
C
700   CONTINUE
      RETURN
C*****
2000  FORMAT(Z8)
C*****
      END

      SUBROUTINE CFE2MY (TPOSE,Y,X,FILE,BUF)
C*******
C     CFE2MY FORMS THE COMPLEX DOUBLE PRECISION MATRIX
C     PRODUCT X = M*Y FOR THE COMPLEX FEER METHOD
C*******
C     DEFINITION OF INPUT AND OUTPUT PARAMETERS
C*******
C     TPOSE    = .FALSE. --- USE MATRIX M
C              = .TRUE.  --- USE MATRIX M-TRANSPOSE
C     Y        = INPUT  VECTOR
C     X        = OUTPUT VECTOR
C     FILE     = INPUT MATRIX CONTROL BLOCK FOR THE
C                REQUIRED MATRIX
C     BUF      = INPUT REQUIRED GINO BUFFER
C*******
      DOUBLE PRECISION  X(1)     ,Y(1)     ,DA
      INTEGER           FILE(7)  ,BUF(1)   ,EOL      ,DIAG
      LOGICAL           TPOSE(1)
      COMMON  /NAMES /  RD       ,RDREW    ,WRT      ,WRTREW
     2                 ,REW      ,NOREW    ,EOFNRW   ,RSP
     3                 ,RDP      ,CSP      ,CDP      ,SQR
     4                 ,RECT     ,DIAG     ,LOWTRI   ,UPRTRI
     5                 ,SYM      ,ROW      ,IDENTY
      COMMON  /ZNTPKX/  DA(2)    ,II       ,EOL
      NCOL2 = FILE(2)+FILE(2)
      IF (FILE(4).EQ.IDENTY) GO TO 50
      CALL GOPEN (FILE(1),BUF(1),RDREW)
      DO 10  I = 1,NCOL2
   10 X(I) = 0.D0
      IF (FILE(4).EQ.DIAG) GO TO 40
      IF (TPOSE(1)) GO TO 31
C*******
C     GENERAL MATRIX*VECTOR PRODUCT
C*******
      DO 30  I = 1,NCOL2,2
      J = I+1
      IF (Y(I).EQ.0.D0.AND.Y(J).EQ.0.D0) GO TO 25
      CALL INTPK(*30,FILE(1),0,CDP,0)
   22 CALL ZNTPKI
      JJ = II+II
      II = JJ-1
      X(II) = X(II) + DA(1)*Y(I) - DA(2)*Y(J)
      X(JJ) = X(JJ) + DA(1)*Y(J) + DA(2)*Y(I)
      IF (EOL) 30,22,30
   25 CALL SKPREC (FILE(1),1)
   30 CONTINUE
      GO TO 80
C*******
C     GENERAL MATRIX-TRANSPOSE*VECTOR PRODUCT
C*******
   31 DO 36  I = 1,NCOL2,2
      J = I+1
      CALL INTPK(*36,FILE(1),0,CDP,0)
   32 CALL ZNTPKI
      JJ = II+II
      II = JJ-1
      X(I) = X(I) + DA(1)*Y(II) - DA(2)*Y(JJ)
      X(J) = X(J) + DA(1)*Y(JJ) + DA(2)*Y(II)
      IF (EOL) 36,32,36
   36 CONTINUE
      GO TO 80
C*******
C     MATRIX IS DIAGONAL
C*******
  40  CALL INTPK(*80,FILE(1),0,CDP,0)
   45 CALL ZNTPKI
      JJ = II+II
      II = JJ-1
      X(II) = DA(1)*Y(II) - DA(2)*Y(JJ)
      X(JJ) = DA(1)*Y(JJ) + DA(2)*Y(II)
      IF (EOL) 80,45,80
C*******
C     MATRIX IS IDENTITY
C*******
   50 DO 55  I = 1,NCOL2
   55 X(I) = Y(I)
      GO TO 90
   80 CALL CLOSE (FILE(1),REW)
   90 RETURN
      END

      SUBROUTINE SUBA
C
C     UNSTEADY FLOW ANAYSIS OF A SUPERSONIC CASCADE
C
C     LIFT AND MOMENT COEFICIENT
C
      DIMENSION       PRES1(21),PRES2(21),PRES3(21),PRES4(21),QRES4(21),
     1                SBKDE1(201),SBKDE2(201),SUMSV1(201),SUMSV2(201),
     2                SVKL1(201),SVKL2(201),XLSV1(21),XLSV2(21),
     3                XLSV3(21),XLSV4(21)
      COMPLEX         SBKDE1,SBKDE2,F4,F4S,AM4,F5S,F6S,AM4TST,SUM3,SUM4,
     1                AM5TT,AM6,SUMSV1,SUMSV2,SVKL1,SVKL2,F5,F5T,AM5,
     2                AM5T,AI,A,B,BSYCON,ALP,F1,AM1,ALN,BLKAPM,BKDEL3,
     3                F1S,C1,C2P,C2N,C2,AMTEST,FT2,BLAM1,FT3,AM2,SUM1,
     4                SUM2,F2,BLAM2,FT2T,C1T,FT3T,F2P,AM2P,SUM1T,SUM2T,
     5                C1P,C1N,BKDEL1,BKDEL2,BLKAP1,ARG,ARG2,FT3TST,BC,
     6                BC2,BC3,BC4,BC5,CA1,CA2,CA3,CA4,CLIFT,CMOMT,
     7                PRES1,PRES2,PRES3,PRES4,QRES4,FQA,FQB,T1,T2,T3,T4,
     8                GUSAMP,FQ7,CEXP3,CEXP4,CEXP5,CONST,C1A,C2A
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /SYSTEM/ SYSBUF,IBBOUT
      COMMON /BLK1  / SCRK,SPS,SNS,DSTR,AI,PI,DEL,SIGMA,BETA,RES
      COMMON /BLK2  / BSYCON
      COMMON /BLK3  / SBKDE1,SBKDE2,F4,F4S,AM4,F5S,F6S,AM4TST,SUM3,SUM4,
     1                AM5TT,AM6,SUMSV1,SUMSV2,SVKL1,SVKL2,F5,F5T,AM5,
     2                AM5T,A,B,ALP,F1,AM1,ALN,BLKAPM,BKDEL3,F1S,C1,C2P,
     3                C2N,C2,AMTEST,FT2,BLAM1,FT3,AM2,SUM1,SUM2,F2,
     4                BLAM2,FT2T,C1T,FT3T,F2P,AM2P,SUM1T,SUM2T,C1P,C1N,
     5                BKDEL1,BKDEL2,BLKAP1,ARG,ARG2,FT3TST,BC,BC2,BC3,
     6                BC4,BC5,CA1,CA2,CA3,CA4,CLIFT,CMOMT,PRES1,PRES2,
     7                PRES3,PRES4,QRES4,FQA,FQB,FQ7
      COMMON /BLK4  / I,R,Y,A1,B1,C4,C5,GL,I6,I7,JL,NL,RI,RT,R5,SN,SP,
     1                XL,Y1,AMU,GAM,IDX,INX,NL2,RL1,RL2,RQ1,RQ2,XL1,
     2                ALP1,ALP2,GAMN,GAMP,INER,IOUT,REDF,STAG,STEP,
     3                AMACH,BETNN,BETNP,BKAP1,XLSV1,XLSV2,XLSV3,XLSV4,
     4                ALPAMP,AMOAXS,GUSAMP,DISAMP,PITAXS,PITCOR
C
      S1   = SPS - SNS
      S2   = SPS*DEL - SIGMA
      S3   = SPS/(DSTR**2)
      S4   = SNS/DSTR
      S0   = 2.0 - SPS + SNS
      T1   = CEXP(-AI*SIGMA)
      T2   = CEXP(AI*SIGMA)
      A1   = 2.0*PI/S1
      B1   = S2/S1
      GAM  = S2
      C1P  = GAM/DSTR - SCRK
      C1N  = GAM/DSTR + SCRK
      ALP  = GAM*S3 + S4*CSQRT(C1P)*CSQRT(C1N)
      BC   = -B1/ALP*BSYCON/SIN(PI*B1/A1)
      T3   = ALP - DEL
      F1   = (ALP-AMU)/T3*AI*SNS/(BETA*(GAM-ALP*SPS))
      ARG2 = DEL
      CALL AKAPM (ARG2,BKDEL1)
      ARG  = DEL - GL
      CALL AKAPM  (ARG,BKDEL2)
      CALL DLKAPM (ARG2,BLKAP1)
      INX  = 0
      CALL DRKAPM (ALP,INX,BLKAPM)
      F1   = F1*BKDEL1/BLKAPM*(-T3/(T3+GL)*A*AI*BKDEL2/BKDEL1 +
     1       B*BLKAP1+B/T3)
      F1S  = F1
      NL   = 10
      RL1  = NL - 1
      CEXP3 = CEXP(-AI*T3/RL1*S1)
      PRES1(1) = F1S
      NNL1 = NL - 1
      DO 453 JL = 1,NNL1
      PRES1(JL+1) = PRES1(JL)*CEXP3
  453 CONTINUE
      F1   = F1*AI/T3*(CEXP(-AI*T3*S1)-1.0)
      AM1  = F1/(AI*T3)-F1S/(AI*T3)*S1*CEXP(-AI*T3*S1)
      AMTEST = 0.0
      FQB  = BKDEL1/(BETA*BC)*CEXP(AI*S2/2.0)*
     1      (-A*AI*BKDEL2/BKDEL1+B*BLKAP1)
      DO 20 I = 1,200
      R    = I
      GAMP = 2.0*PI*R + S2
      GAMN =-2.0*PI*R + S2
      C1P  = (GAMP/DSTR) - SCRK
      C2P  = (GAMP/DSTR) + SCRK
      ALP  = GAMP*S3 + S4*CSQRT(C1P)*CSQRT(C2P)
      T3   = ALP - DEL
      IDX  = I
      CALL DRKAPM (ALP,IDX,BLKAPM)
      C1   = (ALP-AMU)/T3*AI*SNS/(BETA*(GAMP-ALP*SPS))*BKDEL1/
     1       (BLKAPM)*(-T3/(T3+GL)*A*AI*BKDEL2/BKDEL1+B*BLKAP1+B/T3)
      C1N  = (GAMN/DSTR) - SCRK
      C2N  = (GAMN/DSTR) + SCRK
      ALN  = GAMN*S3 + S4*CSQRT(C1N)*CSQRT(C2N)
      T4   = ALN - DEL
      IDX  =-I
      CALL DRKAPM (ALN,IDX,BLKAPM)
      C2   = (ALN-AMU)/T4*AI*SNS/(BETA*(GAMN-ALN*SPS))*BKDEL1/
     1       (BLKAPM)*(-T4/(T4+GL)*A*AI*BKDEL2/BKDEL1+B*BLKAP1+B/T4)
      F1   = F1+C1*AI/T3*(CEXP(-AI*T3*S1)-1.0)+C2*AI/
     1       T4*(CEXP(-AI*T4*S1)-1.0)
      AM1  = AM1+C1/(AI*T3)*(-S1*CEXP(-AI*T3*S1)+AI/
     1       T3*(CEXP(-AI*T3*S1)-1.0))+C2/(AI*T4)*
     2       (-S1*CEXP(-AI*T4*S1)+AI/T4*(CEXP(-AI*T4*S1)-1.0))
      C2A  = C2
      C1A  = C1
      AA   = S1/RL1
      CEXP3 = CEXP(-AI*T3*AA)
      CEXP4 = CEXP(-AI*T4*AA)
      TEMP  = 2.0*PI*R
      CEXP5 = CEXP(AI*(SIGMA-SNS*DEL)/S1*AA)
      CONST = 4.0*FQB/TEMP
      PRES1(1) = PRES1(1) + C1 + C2
      DO 454 JL = 1,NNL1
      CONST = CONST*CEXP5
      C1A   = C1A*CEXP3
      C2A   = C2A*CEXP4
      PRES1(JL+1) = PRES1(JL+1) + C1A + C2A
      PRES1(JL+1) = PRES1(JL+1) + CONST*SIN(TEMP*JL/RL1)
  454 CONTINUE
      IF (CABS((AM1-AMTEST)/AM1) .LT. 0.0005) GO TO 45
      AMTEST = AM1
   20 CONTINUE
      GO TO 9992
 9992 WRITE  (IBBOUT,3005) UFM
 3005 FORMAT (A23,' FROM AMG MODULE. AM1 LOOP IN SUBROUTINE SUBA DID ',
     1        'NOT CONVERGE.')
      CALL MESAGE (-61,0,0)
   45 CONTINUE
      AA    = S1/RL1
      CEXP3 = CEXP(AI*(SIGMA-SNS*DEL)/RL1)
      CONST = FQB
      TEMP  = 2.0*AA/(SPS-SNS)
      PRES1(1) = PRES1(1) - FQB
      DO 4541 JL = 1,NNL1
      CONST = CONST*CEXP3
      PRES1(JL+1) = PRES1(JL+1) - CONST*(1.0-JL*TEMP)
 4541 CONTINUE
      Y    = 0.0
      Y1   = SNS
      ARG  = DEL - GL
      CALL ALAMDA (ARG,Y,BLAM1)
      CALL ALAMDA (ARG,Y1,BLAM2)
      CALL AKAPPA (ARG,BKAP1)
      FT2  = A*AI*(DEL-GL-AMU)*BLAM1/BKAP1
      FT2T = A*AI*(DEL-GL-AMU)*BLAM2/BKAP1
      ARG  = DEL
      CALL ALAMDA (ARG,Y,BLAM1)
      CALL ALAMDA (ARG,Y1,BLAM2)
      CALL AKAPPA (ARG,BKAP1)
      GAM  = SQRT(DEL**2-SCRK**2)
      S5   = SIN(SNS*GAM)
      S6   = COS(SNS*GAM)
      C1   =-1.0/(BETA*GAM*S5)
      C1T  = C1*(AI*SPS*T2*S6-SNS*DEL/GAM*T2*S5)-BLAM2/BKAP1*DEL/GAM*(S5
     1       +GAM*SNS*S6)/(GAM*S5)
      C1   = C1*(ARG/GAM*SNS*S5+AI*SPS*T2)-BLAM1/BKAP1*DEL/(GAM*S5)*(S5/
     1       GAM+SNS*S6)
      FT3  =-B*(BLAM1/BKAP1+(DEL-AMU)*C1)
      FT3T =-B*(BLAM2/BKAP1+(DEL-AMU)*C1T)
      IF (GL .EQ. 0.0) GO TO 50
      F2   = FT2*(CEXP(2.0*AI*GL)-CEXP(AI*GL*S1))/(AI*GL)+
     1       FT3*S0+B*AI*(DEL-AMU)*BLAM1/BKAP1*(4.0-S1**2)/2.0
      AM2  = FT2*(2.0*CEXP(2.0*AI*GL)/(AI*GL)-S1/(AI*GL)*CEXP(GL*AI*S1)+
     1       (CEXP(2.0*AI*GL)-CEXP(AI*S1*GL))/GL**2)+FT3*(4.0-S1**2)/2.0
     2       +B*AI*(DEL-AMU)*BLAM1/BKAP1*(8.0-S1**3)/3.0
      F2P  = FT2T*T1*CEXP(AI*GL*SNS)/(AI*GL)*(CEXP(2.0*AI*GL)-
     1       CEXP(AI*GL*S1))+FT3T*T1*S0+B*AI*(DEL-AMU)*T1*BLAM2/
     2       BKAP1*(S0**2/2.0+SPS*S0)
      AM2P = FT2T*T1*(CEXP(AI*GL*SPS)/(AI*GL)*S0*CEXP(AI*GL*S0)+
     1       CEXP(AI*GL*SPS)/(GL**2)*(CEXP(AI*GL*S0)-1.0))+
     2       FT3T*T1*S0**2/2.0+B*AI*(DEL-AMU)*T1*BLAM2/BKAP1*(S0**3/3.0+
     3       SPS*S0**2/2.0)
      GO TO 55
   50 CONTINUE
      F2   = FT2*S0+FT3*S0+B*AI*(DEL-AMU)*BLAM1/BKAP1*(4.-S1**2)/2.
      AM2  = FT2*(4.0-S1**2)/2.0+FT3*(4.0-S1**2)/2.0+B*AI*(DEL-AMU)*
     1       BLAM1/BKAP1*(8.0-S1**3)/3.0
      F2P  = FT2T*T1*S0+FT3T*T1*S0+B*AI*(DEL-AMU)*T1*BLAM2/BKAP1*(S0**2
     1       /2.0+SPS*S0)
      AM2P = FT2T*T1*S0**2/2.0+FT3T*T1*S0**2/2.0+B*AI*(DEL-AMU)*T1*BLAM2
     1       /BKAP1*(S0**3/3.0+SPS*S0**2/2.0)
   55 CONTINUE
      NL2  = 20
      RL2  = NL2 - 1
      AA   = SPS - SNS
      CONST = B*AI*(DEL-AMU)*BLAM1/BKAP1
      TEMP = S0/RL2
      C1A  = AI*GL
      CEXP3 = CEXP(C1A*AA)
      CEXP4 = CEXP(C1A*TEMP)
      DO 455 JL = 1,NL2
      XL = AA + TEMP*(JL-1)
      PRES2(JL) = FT2*CEXP3 + FT3+CONST*XL
      CEXP3 = CEXP3*CEXP4
  455 CONTINUE
      CALL SUBBB
      RETURN
      END

      SUBROUTINE GPTSYM (GPLST,X,U,SYM,DEFORM)
C
      INTEGER GPLST(1),SYM(2),DEFORM
      REAL    X(3,1),U(2,1)
      COMMON /BLANK/ NGP
C
      CALL SYMBOL (0,0,0,-1)
C
C     IF THE GRID POINT INDEX IS 0 (NOT IN SET) OR NEGATIVE (EXCLUDED),
C     NEVER PUT A SYMBOL AT THAT GRID POINT.
C
      DO 110 I = 1,NGP
      J  = GPLST(I)
      IF (J .LE. 0) GO TO 110
      IF (DEFORM .NE. 0) GO TO 105
      XX = X(2,J)
      YY = X(3,J)
      GO TO 106
  105 XX = U(1,J)
      YY = U(2,J)
  106 CALL SYMBOL (XX,YY,SYM,0)
  110 CONTINUE
C
      CALL SYMBOL (0,0,0,1)
      RETURN
      END

      SUBROUTINE SADD (Z,DZ)
C
C     TO COMPUTE MATRIX SUM WITH MULTIPLIERS
C         ACCEPTS 1 TO 5 MATRIX BLOCKS PASSED ON VIA /SADDX/
C     COMMON BLOCK /SADDX/ NOMAT,LCORE,MCBS(60),MC(7)
C         NOMAT - NUMBER OF MATRICES INPUT
C         LCORE - LENGTH OF Z ARRAY (OPEN CORE)
C         MCBS  - MATRIX CONTROL BLOCKS AND MULTIPLIERS
C                 (12 WORDS/MATRIX)
C
C                 1 - FILE NAME            7 - NOT USED
C                 2 - NUMBER OF COLUMN     8 - TYPE OF MULTIPLIER
C                 3 - NUMBER OF ROW        9 - MULTIPLIER   *  LENGTH
C                 4 - FORM OF MATRIX      10 - MULTIPLIER   *  DEPENDS
C                 5 - TYPE OF MATRIX      11 - MULTIPLIER   *  ON THE
C                 6 - MAXIMUM NUMBER OF   12 - MULTIPLIER   *  TYPE
C                     NON-ZERO ELEMENTS
C
C         MC    - MATRIX CONTROL BLOCK OF THE OUTPUT
C
      INTEGER          END    ,EOL    ,HOP    ,NAME(2),ONE    ,PRC    ,
     1                 PREC   ,RC     ,SYSBUF ,TYPE   ,TYPIN  ,TYPOUT
      REAL             AMCB(1),ALPH(1),Z(1)
      DOUBLE PRECISION DA(2)  ,DALPH(10)      ,DMCB(1),DZ(1)
      COMMON /PACKX /  TYPIN  ,TYPOUT ,ONE    ,N      ,INCR
      COMMON /SADDX /  NOMAT  ,LCORE  ,MCBS(60)       ,MC(7)
      COMMON /SYSTEM/  SYSBUF ,NOUT
      COMMON /TYPE  /  PRC(2) ,NWDS(4),RC(4)
      COMMON /ZNTPKX/  A(4)   ,II     ,EOL
      EQUIVALENCE      (AMCB(1),MCBS(9)),(ALPH(1),DALPH(1)),
     1                 (DA(1) ,A(1))  ,(DMCB(1),MCBS(9)),
     2                 (NTYPE ,MC(5)) ,(NROW,   MC(3))
      DATA    NAME  /  4HSADD ,4H    /
C
C
      END   = (NOMAT-1)*12 + 1
      PREC  = -NOMAT*2
      TYPE  = -NOMAT*2
C
C     DETERMINE PRECISION TO BE USED FOR CALCULATIONS
C
C     NOTE - PRC ARRAY IS DIMENSIONED ONLY TO 2
C            PRC(1) = 1, PRC(2) = 2, AND
C            PRC(3) = NWDS(1) = 1, PRC(4) = NWDS(2) = 2
C            WHERE 1 MEANS S.P., 2 D.P.
C          - RC ARRAY = 1,1,2,2, WHERE 1 MEANS REAL, 2 COMPLEX
C
      DO 20 I = 1,END,12
      IF (MCBS(I) .NE. 0) GO TO 10
      PREC  = PREC + 2
      TYPE  = TYPE + 2
      GO TO 20
   10 J     = MCBS(I+4)
      PREC  = PREC  + PRC(J)
      TYPE  = TYPE  + RC(J)
      J     = MCBS(I+7)
      PREC  = PREC  + PRC(J)
      TYPE  = TYPE  + RC(J)
   20 CONTINUE
      TYPIN = 1
      IF (TYPE .GT. 0) TYPIN = 3
      IF (PREC .GT. 0) TYPIN = TYPIN + 1
      NUM = NROW*NWDS(TYPIN)
      IF (LCORE .LT. (NOMAT+1)*SYSBUF+NUM+1) CALL MESAGE (-8,0,NAME)
C
C     MOVE AND CONVERT MULTIPLIERS
C
      IF (PREC .GT. 0) GO TO 60
C
C     SINGLE PRECISION
C
      J = 1
      DO 50 I = 1,END,12
      K = MCBS(I+7)
      IF (PRC(K) .EQ. 2) GO TO 30
      ALPH(J  ) = AMCB(I  )
      ALPH(J+1) = AMCB(I+1)
      GO TO 40
   30 K = I/2 + 1
      ALPH(J  ) = DMCB(K  )
      ALPH(J+1) = DMCB(K+1)
   40 J = J + 1
      IF (TYPE .GT. 0) J = J + 1
   50 CONTINUE
      IF (TYPE .LE. 0) ALPH(J+1) = 0.0
      GO TO 100
C
C     DOUBLE PRECISION
C
   60 J = 1
      DO 90 I = 1,END,12
      K = MCBS(I+7)
      IF (PRC(K) .EQ. 2) GO TO 70
      DALPH(J  ) = AMCB(I  )
      DALPH(J+1) = AMCB(I+1)
      GO TO 80
   70 K = I/2 + 1
      DALPH(J  ) = DMCB(K  )
      DALPH(J+1) = DMCB(K+1)
   80 J = J + 1
      IF (TYPE .GT. 0) J = J + 1
   90 CONTINUE
      IF (TYPE .LE. 0) DALPH(J+1) = 0.0D+0
C
  100 GO TO (110,120,130,140), TYPIN
  110 ASSIGN 300 TO HOP
      GO TO  150
  120 ASSIGN 350 TO HOP
      GO TO  150
  130 ASSIGN 400 TO HOP
      GO TO  150
  140 ASSIGN 450 TO HOP
C
C     OPEN AND ASSIGN FILES
C
  150 IBUF = LCORE
      DO 160 I = 1,END,12
      IBUF = IBUF - SYSBUF
      IF (MCBS(I) .EQ. 0) GO TO 160
      CALL GOPEN (MCBS(I),Z(IBUF),0)
  160 CONTINUE
      IBUF = IBUF - SYSBUF
      CALL GOPEN (MC,Z(IBUF),1)
C
C     SETUP PACK PARAMETERS
C
      ONE    = 1
      N      = NROW
      TYPOUT = NTYPE
      INCR   = 1
      NCOL1  = MC(2)
      MC(2)  = 0
      MC(6)  = 0
      MC(7)  = 0
C
C     ADD MATRICES
C
      DO 1000 I = 1,NCOL1
C
C     CLEAR CORE
C
      DO 210 J = 1,NUM
  210 Z(J) = 0.0
C
      ONE = N
      N   = 1
      DO 900 J = 1,NOMAT
      K   = 12*(J-1) + 1
      IF (MCBS(K  ) .EQ. 0) GO TO 900
      IF (MCBS(K+1) .LT. I) GO TO 900
      CALL INTPK (*900,MCBS(K),0,TYPIN,0)
C
C     READ IN NON ZERO ELEMENT
C
  220 CALL ZNTPKI
      IF (II .GT. NROW) GO TO 500
      ONE = MIN0(ONE,II)
      N   = MAX0(N  ,II)
      GO TO HOP, (300,350,400,450)
  300 Z(II) = Z(II) + ALPH(J)*A(1)
      GO TO 500
  350 DZ(II) = DZ(II) + DALPH(J)*DA(1)
      GO TO 500
  400 II = II + II - 1
      JJ = J  + J  - 1
      Z(II  ) = Z(II)  +  ALPH(JJ)*A(1) - ALPH(JJ+1)*A(2)
      Z(II+1) = Z(II+1)+  ALPH(JJ)*A(2) + ALPH(JJ+1)*A(1)
      GO TO 500
  450 II = II + II - 1
      JJ = J  + J  - 1
      DZ(II  ) = DZ(II  ) + DALPH(JJ)*DA(1) - DALPH(JJ+1)*DA(2)
      DZ(II+1) = DZ(II+1) + DALPH(JJ)*DA(2) + DALPH(JJ+1)*DA(1)
  500 IF (EOL .EQ. 0) GO TO 220
  900 CONTINUE
C
C     END OF COLUMN
C
      ONE = MIN0(ONE,N)
      LL  = (ONE-1)*NWDS(TYPIN) + 1
      CALL PACK (Z(LL),MC(1),MC)
 1000 CONTINUE
C
C     DONE - CLOSE FILES AND RETURN
C
      DO 1010 I = 1,END,12
      IF (MCBS(I) .NE. 0) CALL CLOSE (MCBS(I),1)
 1010 CONTINUE
      CALL CLOSE (MC,1)
      RETURN
      END

      SUBROUTINE DSINQR ( DSN, ISTAT, ISIZE )
C        DSINQR DETERMINES THE EXISTANCE OF A FILE:
C            DSN   ( INPUT  )   FILE NAME
C            ISTAT ( OUTPUT )   =0, IF NOT EXIST; =1, IF EXIST
C            ISIZE ( OUTPUT )   = FILE SIZE IN GINO BLOCKS
C
      LOGICAL       AVAIL
      CHARACTER*(*) DSN
      INQUIRE( FILE=DSN, EXIST=AVAIL, NEXTREC = NREC )
      ISTAT = 0
      IF ( AVAIL ) ISTAT = 1
      ISIZE = NREC - 1
      RETURN
      END

      SUBROUTINE TRLGC (TMLDTB,TRL,DIT,ITRL,FCT,FCO,TOL,IFLAG)
C
C     THE PURPOSE OF THIS SUBROUTINE IS TO PRODUCE A MATRIX OF FUNCTIONS
C     OF TIME.  EACH COLUMN IS A TIME STEP (AS DEFINE BY TRL) AND EACH
C     TERM IN A COLUMN CORRESPONDS TO A UNIQUE FUNCTION OF TIME (EITHER
C     BY TABLE FROM TLOAD, TIME DELAY, OR QVECT)
C
C     INPUTS (3)
C         TMLDTB - TABLE SHOWING TIME DEPENDANT DATA
C         TRL    - TIME STEP LIST
C         DIT    - DIRECT INPUT TABLES
C         ITRL   - SELECTED TRL SET NUMBER FROM CASECC
C
C     OUTPUTS(3)
C         FCT    - TIME FUNCTIONS AT ALL TIMES
C         FCO    - TIME FUNCTIONS AT OUTPUT TIMES
C         IFLAG  - -1 IMPLIES ALL TIMES OUTPUT (I.E. FCO = FCT)
C         TOL    - TABLE OF OUTPUT TIMES
C
C     THE FORMAT OF THE  TMLDTB TABLE IS AS FOLLOWS
C         REC NO.  WORD  DESCRIPTION
C         0        1-2   TABLE NAME
C         1        1     TERM NUMBER
C                  2     TLOAD ID
C                  3     TLOAD TYPE(1,2)
C                  4     TAU ( FROM DELAY CARDS--REAL)
C                  5     TID (TABLES FROM TLOAD1 CARD)
C                  5     T1   CONSTANTS FROM TLOAD 2 CARDS
C                  6     T2
C                  7     F
C                  8     P
C                  9     C
C                  10    B
C                  11    QVECT POINTER INTO SECOND RECORD
C
C         WORDS  1 THRU 11 ARE REPEATED FOR EACH UNIQUE TIME FUNCTION
C
C         2        1    I1   QVECT TABLE ID'S
C                  2    I2
C                  3    I3
C                  4    V1   QVECT ORIENTATION VECTORS
C                  5    V2
C                  6    V3
C                  7    V4
C                  8    V5
C                  9    V6
C
C     CORE LAYOUT IS AS FOLLOWS $                                POINT
C     ========================================  ===============  =====
C     TERM DESCRIPTORS (11 WORDS PER TERM)      11*NTERM WORDS   ITERM
C     QVECT STUFF      (9  WORDS PER QVECT)     9*NQVECT WORDS   IQVECT
C     TRL   STUFF      (3 WORDS PER GROUP)      3*NGROUP WORDS+1 TGROUP
C     TABLE LIST       (1 WORD  PER UNIQUETAB)  NTAB WORDS+1     ITAB
C     TABLE DATA        PRETAB STORED           LTAB WORDS       ILTAB
C     TERM VALUES                               NTERM WORDS      IVS
C
C     3    BUFFERS      FCT                                      IBUF1
C                       FCO                                      IBUF2
C                       TOL                                      IBUF3
C
      LOGICAL         DEC
      INTEGER         TMLDTB,TRL,FCT,FCO,TOL,MCB(7),MCB1(7),NAME(2),
     1                SYSBUF,DIT,FILE,ITLIST(13),IZ(1)
      COMMON /BLANK / DUMMY,NCONT
      COMMON /MACHIN/ MACH
      COMMON /ZZZZZZ/ Z(1)
      COMMON /ZBLPKX/ ZA(4),II1
      COMMON /SYSTEM/ SYSBUF
      COMMON /PACKX / IT1,IT2,II,JJ,INCR
      COMMON /CONDAS/ CONSTS(5)
      EQUIVALENCE     (Z(1),IZ(1)),(CONSTS(2),TWOPI),(CONSTS(4),DEGRA)
      DATA    NAME  / 4HTRLG,4HC   /
      DATA    ITLIST/ 4,1105,11,1,1205,12,2,1305,13,3,1405,14,4 /
C
      DEC    = MACH.EQ.5 .OR. MACH.EQ.6 .OR. MACH.EQ.21
      NOLOAD = 0
      MCB(1) = TMLDTB
      CALL RDTRL (MCB)
      IF (MCB(2) .LE. 0) NOLOAD = -1
      MCB(2) = 100
      IGROUP = 1
      IFLAG  =-1
      NZ     = KORSZ(Z)
      IBUF1  = NZ    - SYSBUF
      IBUF2  = IBUF1 - SYSBUF
      IBUF3  = IBUF2 - SYSBUF
      NZ     = IBUF3 - 1
      IF (NZ .LE. 0) CALL MESAGE (-8,0,NAME)
C
C     BRING IN  TIME DATA
C
      IF (NOLOAD .NE. 0) GO TO 30
      ITERM = 1
      LREC  = 11
      FILE  = TMLDTB
      CALL GOPEN (TMLDTB,IZ(IBUF1),0)
      CALL READ (*290,*10,TMLDTB,IZ(ITERM),NZ,0,ILEN)
      CALL MESAGE (-8,0,NAME)
   10 NTERM = ILEN/LREC
      IQVEC = ITERM + ILEN
      NZ    = NZ - ILEN
C
C     BRING IN  QVECT DATA
C
      CALL READ (*290,*20,TMLDTB,IZ(IQVEC),NZ,0,ILEN)
      CALL MESAGE (-8,0,NAME)
   20 NQVECT = ILEN/9
      IGROUP = IQVEC + ILEN
      NZ     = NZ - ILEN
      CALL CLOSE (TMLDTB,1)
C
C     FIND TRL STUFF FOR CORE
C
   30 FILE = TRL
      CALL OPEN (*310,TRL,IZ(IBUF1),0)
      CALL FREAD (TRL,IZ(IGROUP),3,1)
      CALL SKPREC (TRL,IZ(IGROUP+2))
   40 CALL READ (*291,*50,TRL,IZ(IGROUP),NZ,0,ILEN)
      CALL MESAGE (-8,0,NAME)
   50 IF (IZ(IGROUP) .NE. ITRL) GO TO 40
      NGROUP = (ILEN-1)/3
      ITAB   = IGROUP + ILEN
      NZ     = NZ - ILEN
      CALL CLOSE (TRL,1)
      IF (NOLOAD .NE. 0) GO TO 122
C
C     BUILD LIST OF UNIQUE TABLES
C
      NTABL = 1
      K     = ITAB + NTABL
      IZ(K) = 0
      DO 120 I = 1,NTERM
      K = ITERM + LREC*(I-1) + 4
      IF (IZ(K-2) .NE. 3) GO TO 60
      ITID = IZ(K)
      ASSIGN  60  TO IRET
      GO TO 90
   60 K = ITERM + LREC*(I-1) + 10
      IF (IZ(K) .EQ. 0) GO TO 120
C
C     LOOK AT QVECT  TABLE  ID S
C
      IQ   = (IZ(K)-1)*9 + IQVEC
      ITID = IZ(IQ)
      ASSIGN 70  TO IRET
      GO TO 90
   70 ITID = IZ(IQ+1)
      ASSIGN 80 TO IRET
      GO TO 90
   80 ITID = IZ(IQ+2)
      ASSIGN 120 TO IRET
C
C     SEARCH TABLE LIST
C
   90 L = NUMTYP(ITID)
      IF (DEC .AND. ITID.GT.16000 .AND. ITID.LE.99999999) L = 1
      IF (ITID.LE.0 .OR. L.NE.1) GO TO 110
      DO 100 L = 1,NTABL
      K =  ITAB + L
      IF (IZ(K) .EQ. ITID) GO TO 110
  100 CONTINUE
C
C     NEW TABLE
C
      NTABL = NTABL + 1
      K     = ITAB  + NTABL
      IZ(K) = ITID
  110 GO TO IRET, (60,70,80,120)
  120 CONTINUE
      IZ(ITAB) = NTABL
      ILTAB = ITAB + NTABL + 1
      NZ    = NZ - NTABL - 1
C
C     BRING IN TABLE STUFF
C
      LTAB = 0
      IF (NTABL .EQ. 1) GO TO 121
      CALL PRETAB (DIT,IZ(ILTAB),IZ(ILTAB),IZ(IBUF1),NZ,LTAB,IZ(ITAB),
     1             ITLIST)
  121 CONTINUE
      NZ  = NZ - LTAB
      IVS = ILTAB + LTAB
      IF (NZ .LT. NTERM) CALL MESAGE (-8,0,NAME)
C
C     SET UP FOR PACK
C
      IT1 = 1
      IT2 = 1
      II  = 1
      JJ  = NTERM
      INCR= 1
      CALL MAKMCB (MCB, FCT,NTERM,2,IT2)
      CALL MAKMCB (MCB1,FCO,NTERM,2,IT2)
C
C     OPEN OUTPUT FILES
C
      CALL GOPEN (FCT,IZ(IBUF1),1)
  122 CONTINUE
      FILE = TOL
      TO   = 0.0
      IF (NCONT .LE. 2) GO TO 123
C
C     BRING BACK LAST TIME FOR CONTINUE MODE
C
      CALL OPEN  (*310,TOL,IZ(IBUF2),0)
      CALL FREAD (TOL,TO,-NCONT-1,0)
      CALL FREAD (TOL,TO,1,1)
      CALL CLOSE (TOL,1)
  123 CONTINUE
      CALL OPEN  (*310,TOL,IZ(IBUF2),1)
      CALL FNAME (TOL,ZA)
      CALL WRITE (TOL,ZA,2,0)
      IF (NOLOAD .NE. 0) GO TO 150
C
C     DETERMINE IF ALL TIME STEPS OUTPUT
C
      DO 130 I = 1,NGROUP
      K =  IGROUP + (I-1)*3 + 3
      IF (IZ(K) .NE. 1) GO TO 140
  130 CONTINUE
      IFLAG = -1
      GO TO 150
  140 IFLAG = 1
      CALL GOPEN (FCO,IZ(IBUF3),1)
  150 CONTINUE
      T   = TO
      IST = -1
      DO 280 I = 1,NGROUP
C
C     PICK UP  TIME CONSTANTS
C
      K = IGROUP + (I-1)*3 + 1
      NSTEP  = IZ(K)
      IF (I .EQ. NGROUP) NSTEP = NSTEP + 1
      NOUT   = IZ(K+2)
      DELTAT =  Z(K+1)
      IF (I .EQ. 1) NSTEP = NSTEP + 1
      DO 270 J = 1,NSTEP
      IF (NOLOAD .NE. 0) GO TO 231
      DO  230 L = 1,NTERM
      IP = ITERM + (L-1)*LREC
      M  = IZ(IP+2) - 2
      GO TO (160,170), M
C
C     TLOAD1  CARD
C
  160 TT = T - Z(IP+3)
      CALL TAB (IZ(IP+4),TT,FT)
      GO TO 200
C
C     TLOAD2  CARD2
C
  170 TT   = T - Z(IP+3) - Z(IP+4)
      ZRAD = Z(IP+7)*DEGRA
      IF (TT .EQ. 0.0) GO TO 180
      IF (TT.LT. 0.0 .OR. TT.GT.Z(IP+5)-Z(IP+4)) GO TO 190
      FT = TT**Z(IP+9)*EXP(Z(IP+8)*TT)*COS(TWOPI*Z(IP+6)*TT + ZRAD)
      GO TO 200
C
C     TT = 0.0  TRY  LIMITS OF EXPRESSION
C
  180 IF (Z(IP+ 9) .NE. 0.0) GO TO 190
      FT = COS(ZRAD)
      GO TO 200
C
C     FT = 0.0
C
  190 FT = 0.0
C
C     NOW TRY FOR  QVECT  STUFF
C
  200 IF (IZ(IP+10) .EQ. 0) GO TO 220
C
C     EVALUATE  QVECT FUNCTION
C
      IQ = (IZ(IP+10)-1)*9 + IQVEC
      TT = T - Z(IP+3)
C
C     CHECK FOR CONSTANT FLUX VALUE (FLOATING POINT).
C     IF TIME DEPENDENT, CALL TABLE LOOKUP.
C
      IQ1 = IZ(IQ)
      Q1  = Z(IQ)
      LX  = NUMTYP(IQ1)
      IF (DEC .AND. IQ1.GT.16000 .AND. IQ1.LE.99999999) LX = 1
      IF (IQ1.LE.0 .OR. LX.NE.1) GO TO 202
      CALL TAB (IQ1,TT,Q1)
  202 IQ2 = IZ(IQ+1)
      Q2  = Z(IQ+1)
      LX  = NUMTYP(IQ2)
      IF (DEC .AND. IQ2.GT.16000 .AND. IQ2.LE.99999999) LX = 1
      IF (IQ2.LE.0 .OR. LX.NE.1) GO TO 204
      CALL TAB (IQ2,TT,Q2)
  204 IQ3 = IZ(IQ+2)
      Q3  = Z(IQ+2)
      LX  = NUMTYP(IQ3)
      IF (DEC .AND. IQ3.GT.16000 .AND. IQ3.LE.99999999) LX = 1
      IF (IQ3.LE.0 .OR. LX.NE.1) GO TO 206
      CALL TAB (IQ3,TT,Q3)
  206 IF (Z(IQ+6).NE.0.0 .OR. Z(IQ+6).NE.0.0 .OR. Z(IQ+7).NE.0.0 .OR.
     1    Z(IQ+8).NE.0.0) GO TO 210
C
C     V2 = 0
C
      RT = Q1*Z(IQ+3) + Q2*Z(IQ+4) + Q3*Z(IQ+5)
      IF (RT .GT. 0.0) RT = 0.0
      FT = -RT*FT
      GO TO 220
C
C     V2   0
C
  210 FT = SQRT((Q1*Z(IQ+3) + Q2*Z(IQ+4) + Q3*Z(IQ+5))**2 +
     1          (Q1*Z(IQ+6) + Q2*Z(IQ+7) + Q3*Z(IQ+8))**2)*FT
      GO TO 220
C
C     PUT IN FT
C
  220 M    = IVS + L - 1
      Z(M) = FT
  230 CONTINUE
C
C     COLUMN BUILT
C
      CALL PACK (Z(IVS),FCT,MCB)
  231 CONTINUE
      IF (I.EQ.NGROUP .AND. J.EQ.NSTEP-1) GO TO 240
      IF (J.EQ.1 .OR. J.EQ.NSTEP) GO TO 240
      IF (MOD(J+IST,NOUT) .NE. 0) GO TO 260
C
C     OUTPUT TIME
C
  240 CALL WRITE (TOL,T,1,0)
      IF (IFLAG .EQ. -1) GO TO 250
      CALL PACK (Z(IVS),FCO,MCB1)
  250 IF (J .EQ. NSTEP) DELTAT = Z(K+4)
  260 T = T + DELTAT
  270 CONTINUE
      IST = 0
  280 CONTINUE
C
C     ALL OUTPUT
C
      CALL WRITE (TOL,0,0,1)
      CALL CLOSE (TOL,1)
      IF (NOLOAD .NE. 0) GO TO 281
      CALL CLOSE (FCT,1)
      CALL WRTTRL (MCB)
      IF (IFLAG .EQ. -1) GO TO 281
      CALL CLOSE (FCO,1)
      CALL WRTTRL (MCB1)
  281 CONTINUE
      MCB(1) = TOL
      CALL WRTTRL (MCB)
      RETURN
C
C     ERROR MESSAGES
C
  290 IP1 = -2
  300 CALL MESAGE (IP1,FILE,NAME)
      RETURN
  310 IP1 = -1
      GO TO 300
C
C     NO PROPER TSTEP CARD FOUND
C
  291 CALL MESAGE (-31,ITRL,NAME)
      RETURN
      END

      SUBROUTINE CINFBS (DX,DY,IOBUF)
C
C     CINVFB DOES THE FORWARD AND BACKWARD PASS FOR COMPLEX INVERSE POWE
C
      INTEGER            NAME(2)   ,TYPEAR   ,CDP      ,IOBUF(1) ,EOL
      DOUBLE PRECISION   DX(1)     ,DY(1)    ,DA       ,DTEMP
C     COMMON   /DESCRP/  LENGTH    ,MAJOR
      COMMON   /NAMES /  RD        ,RDREW    ,WRT      ,WRTREW   ,
     1                   REW       ,NOREW    ,EOFNRW   ,RSP      ,
     2                   RDP       ,CSP      ,CDP
      COMMON   /ZNTPKX/  DA(2)     ,II       ,EOL
      COMMON   /CINFBX/  IFILL(7)  ,IFILU(7)
      EQUIVALENCE        (IFILL(3),NROW)
      DATA      NAME  /  4HCINF, 4HBS   /
C
C     TRANSFER THE LOAD VECTOR TO THE SOLUTION VECTOR
C
      TYPEAR = CDP
      NROW2  = NROW + NROW
      DO 10 I = 1,NROW2
   10 DY(I) = DX(I)
C
C     BEGIN FORWARD PASS
C
C     CALL GOPEN (IFILL(1),IOBUF,RDREW)
      J = 1
  100 CALL INTPK (*200,IFILL(1),0,TYPEAR,0)
  110 IF (EOL) 3010,120,3010
  120 CALL ZNTPKI
      IF (J-II) 184,130,110
C
C     PERFORM THE REQUIRED ROW INTERCHANGE
C
  130 IN1 = (J+IFIX(SNGL(DA(1))))*2 - 1
      DTEMP     = DY(2*J-1)
      DY(2*J-1) = DY(IN1)
      DY(IN1)   = DTEMP
      DTEMP     = DY(2*J)
      DY(2*J)   = DY(IN1+1)
      DY(IN1+1) = DTEMP
  160 IF (EOL) 200,170,200
  170 CALL ZNTPKI
  184 DY(2*II-1) = DY(2*II-1) - DY(2*J-1)*DA(1) + DY(2*J)*DA(2)
      DY(2*II  ) = DY(2*II  ) - DY(2*J-1)*DA(2) - DY(2*J)*DA(1)
      GO TO 160
  200 J = J + 1
      IF (J .LT. NROW) GO TO 100
      CALL REWIND (IFILL(1))
C
C     BEGIN BACKWARD PASS
C
      IOFF = IFILU(7) - 1
      J = NROW
  210 CALL INTPK (*3020,IFILU(1),0,TYPEAR,0)
      IF (EOL) 3020,230,3020
  230 CALL ZNTPKI
      I = NROW - II + 1
      IF (I .NE. J) GO TO 275
C
C     DIVIDE BY THE DIAGONAL
C
      DTEMP     = (DY(2*I-1)*DA(1)+DY(2*I)*DA(2))/(DA(1)**2+DA(2)**2)
      DY(2*I  ) = (DY(2*I)*DA(1)-DY(2*I-1)*DA(2))/(DA(1)**2+DA(2)**2)
      DY(2*I-1) = DTEMP
C
C     SUBTRACT OFF REMAINING TERMS
C
  255 IF (I .GT. J) GO TO 230
      IF (EOL) 300,270,300
  270 CALL ZNTPKI
      I = NROW - II + 1
  275 IN1 = I
      IN2 = J
      IF (I .LT. J) GO TO 279
      K   = IN1
      IN1 = IN2 - IOFF
      IN2 = K
  279 IN1 = IN1 + IN1 - 1
      IN2 = IN2 + IN2 - 1
      DY(IN1  ) = DY(IN1  ) - DY(IN2)*DA(1) + DY(IN2+1)*DA(2)
      DY(IN1+1) = DY(IN1+1) - DY(IN2)*DA(2) - DY(IN2+1)*DA(1)
      GO TO 255
  300 J = J - 1
      IF (J .GT. 0) GO TO 210
      CALL REWIND (IFILU(1))
      RETURN
C
 3010 IFILE = IFILL(1)
      GO TO 3040
 3020 IFILE = IFILU(1)
 3040 CALL MESAGE (-5,IFILE,NAME)
      RETURN
      END

      SUBROUTINE RETBLK (IBL)
C
C     RETURNS BLOCK I AND ALL BLOCKS LINKED TO IT TO THE LIST OF FREE
C     BLOCKS IN THE SUPERBLOCK TO WHICH BLOCK I BELONGS   IF SOME OF
C     THE BLOCKS THAT ARE LINKED TO BLOCK I DO NOT BELONG TO THE SAME
C     SUPERBLOCK, THEY ARE RETURNED TO THE FREE LIST OF THEIR OWN
C     RESPECTIVE SUPERBLOCKS.
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        LSHIFT,RSHIFT,ANDF,ORF
      LOGICAL         DITUP,NXTUP,REPEAT
      DIMENSION       NMSBR(2)
      COMMON /MACHIN/ MACH,IHALF,JHALF
      COMMON /ZZZZZZ/ BUF(1)
      COMMON /SOF   / DIT,DITPBN,DITLBN,DITSIZ,DITNSB,DITBL,
     1                IODUM(8),MDIDUM(4),
     2                NXT,NXTPBN,NXTLBN,NXTTSZ,NXTFSZ(10),NXTCUR,
     3                DITUP,MDIUP,NXTUP
      COMMON /SYS   / BLKSIZ,DIRSIZ,SUPSIZ,AVBLKS
      COMMON /SOFCOM/ NFILES,FILNAM(10),FILSIZ(10)
      DATA    IRD   , IWRT/ 1,2   /
      DATA    INDSBR/ 13 /, NMSBR /4HRETB,4HLK  /
C
      CALL CHKOPN (NMSBR(1))
      I = IBL
      IF (I .LE. 0) GO TO 500
      LMASK = LSHIFT(JHALF,IHALF)
C
C     COMPUTE THE NUMBER OF THE FILE TO WHICH BLOCK I BELONGS,
C     THE INDEX OF BLOCK I WITHIN THAT FILE, THE NUMBER WITHIN THE
C     FILE OF THE SUPERBLOCK TO WHICH BLOCK I BELONGS, AND THE LOGICAL
C     BLOCK NUMBER OVER THE SYSTEM OF THAT SUPERBLOCK.
C
    5 LEFT = I
      DO 7 L = 1,NFILES
      IF (LEFT .GT. FILSIZ(L)) GO TO 6
      FILNUM = L
      GO TO 10
    6 LEFT = LEFT - FILSIZ(L)
    7 CONTINUE
      GO TO 500
   10 FILIND = LEFT
      FILSUP = (FILIND-1)/SUPSIZ
      IF (FILIND-1 .EQ. FILSUP*SUPSIZ) GO TO 20
      FILSUP = FILSUP + 1
   20 ILBN = 0
      MAX  = FILNUM - 1
      IF (MAX .LT. 1) GO TO 28
      DO 25 L = 1,MAX
      ILBN = ILBN + NXTFSZ(L)
   25 CONTINUE
   28 ILBN = ILBN + FILSUP
      IF (ILBN .EQ. NXTLBN) GO TO 60
C
C     THE DESIRED BLOCK OF THE ARRAY NXT IS NOT IN CORE.
C
      IF (NXTLBN .EQ. 0) GO TO 30
C
C     THE IN CORE BUFFER SHARED BY THE DIT AND THE ARRAY NXT IS NOW
C     OCCUPIED BY A BLOCK OF NXT.  IF THAT BLOCK HAS BEEN UPDATED,
C     MUST WRITE IT OUT BEFORE READING IN THE NEW BLOCK.
C
      IF (.NOT.NXTUP) GO TO 50
      CALL SOFIO (IWRT,NXTPBN,BUF(NXT-2))
      NXTUP = .FALSE.
      GO TO 50
C
C     THE IN CORE BUFFER SHARED BY THE DIT AND THE ARRAY NXT IS NOW
C     OCCUPIED BY A BLOCK OF THE DIT.  IF THAT BLOCK HAS BEEN UPDATED,
C     MUST WRITE IT OUT BEFORE READING IN THE NEW BLOCK.
C
   30 IF (.NOT.DITUP) GO TO 40
      CALL SOFIO (IWRT,DITPBN,BUF(DIT-2))
      DITUP  = .FALSE.
   40 DITPBN = 0
      DITLBN = 0
C
C     READ IN THE DESIRED BLOCK OF NXT.
C
   50 NXTLBN = ILBN
      NXTPBN = 0
      MAX = FILNUM - 1
      IF (MAX .LT. 1) GO TO 58
      DO 55 L = 1,MAX
      NXTPBN = NXTPBN + FILSIZ(L)
   55 CONTINUE
   58 NXTPBN = NXTPBN + (FILSUP-1)*SUPSIZ + 2
      CALL SOFIO (IRD,NXTPBN,BUF(NXT-2))
C
C     THE DESIRED BLOCK OF NXT IS IN CORE.
C
   60 BTFREE = ANDF(BUF(NXT+1),JHALF)
      TPFREE = RSHIFT(BUF(NXT+1),IHALF)
      IF (BTFREE .EQ. 0) GO TO 90
C
C     CHECK IF BLOCK I IS ALREADY IN THE LIST OF FREE BLOCKS.
C
      J = TPFREE
   70 IF (J .EQ. I) GO TO 220
      IF (J .EQ. 0) GO TO 90
      IND = (J-NXTPBN+2)/2 + 1
      IF (MOD(J,2) .EQ. 1) GO TO 80
      J = RSHIFT(BUF(NXT+IND),IHALF)
      GO TO 70
   80 J = ANDF(BUF(NXT+IND),JHALF)
      GO TO 70
C
C     BLOCK I IS NOT IN THE LIST OF FREE BLOCKS.
C     SET TPFREE TO I
C
   90 BUF(NXT+1) = LSHIFT(I,IHALF)
C
C     EXAMINE THE BLOCKS THAT ARE LINKED TO BLOCK I.
C
      REPEAT = .FALSE.
      IF (FILSUP .NE. NXTFSZ(FILNUM)) GO TO 123
      LSTBLK = NXTPBN + FILSIZ(FILNUM) - (FILSUP-1)*SUPSIZ - 2
      GO TO 126
  123 LSTBLK = NXTPBN + SUPSIZ - 1
  126 AVBLKS = AVBLKS + 1
      IND = (I-NXTPBN+2)/2 + 1
      IF (MOD(I,2) .EQ. 1) GO TO 130
      ISV = RSHIFT(BUF(NXT+IND),IHALF)
      GO TO 140
  130 ISV = ANDF(BUF(NXT+IND),JHALF)
  140 IF (ISV .EQ. 0) GO TO 160
      IF (ISV.LT.NXTPBN .OR. ISV.GT.LSTBLK) GO TO 150
      I = ISV
      GO TO 126
  150 REPEAT = .TRUE.
C
C     ALL THE BLOCKS IN THIS SUPERBLOCK HAVE BEEN FOUND.
C     SET POINTER OF I TO VALUE OF OLD TPFREE.
C
  160 IF (MOD(I,2) .EQ. 1) GO TO 170
      BUF(NXT+IND) = ORF(ANDF(BUF(NXT+IND),JHALF),LSHIFT(TPFREE,IHALF))
      GO TO 180
  170 BUF(NXT+IND) = ORF(ANDF(BUF(NXT+IND),LMASK),TPFREE)
  180 IF(BTFREE .EQ. 0) BTFREE = I
C
C     SET BTFREE TO LAST BLOCK IN CHAIN.
C
      BUF(NXT+1) = ORF(ANDF(BUF(NXT+1),LMASK),BTFREE)
      NXTUP = .TRUE.
      IF (.NOT. REPEAT) GO TO 220
C
C     ISV BELONGS TO A DIFFERENT SUPERBLOCK, REPEAT
C     SUBROUTINE FOR BLOCK ISV.
C
      I = ISV
      GO TO 5
C
C     NO MORE BLOCKS LINKED TO BLOCK I, RETURN.
C
  220 CONTINUE
      RETURN
C
C     ERROR MESSAGE.
C
  500 CALL ERRMKN (INDSBR,2)
      RETURN
      END

      SUBROUTINE EQMCKA (IP,BGPDT,CSTM,EQEXIN,D,ISCALR)
C
C     ROUTINE FORMS D MATRIX (ACCTUALLY D TRANSPOSE)
C
      INTEGER         BGPDT,FILE,CSTM,EQEXIN,D,SYSBUF,IZ(1),MCB(7),
     1                NAME(2)
      REAL            TR(3,3),TI(3,3),DD(6,6),R(3)
      DIMENSION       TT(3,3)
C
      COMMON /SYSTEM/ SYSBUF
      COMMON /PACKX / IT1,IT2,II,JJ,INCR
      COMMON /ZZZZZZ/ Z(1)
C
      EQUIVALENCE     (IZ(1),Z(1))
C
      DATA    IZ2   , IZ3,IZ4,IZ5  / 2,3,4,5 /
      DATA    NAME  / 4HEQMC,4HKA  /
C
C     CONVERT  EXTERNAL IP TO INTERNAL IP
C
      IBUF = KORSZ(Z)-SYSBUF+1
      FILE = EQEXIN
      CALL GOPEN (EQEXIN,Z(IBUF),0)
      CALL READ  (*220,*10,EQEXIN,IZ(1),IBUF-1,0,IFLAG)
      GO TO 240
   10 CALL CLOSE (EQEXIN,1)
      DO 20 I = 1,IFLAG,2
      IF (IZ(I) .EQ.IP) GO TO 40
   20 CONTINUE
      CALL MESAGE (41,IP,NAME)
      IP = 0
      GO TO 50
   30 CALL MESAGE (41,IP,NAME)
C
C     SCALAR POINT
C
      GO TO 60
   40 IP = IZ(I+1)
C
C     FIND RZERO FOR  IP
C
   50 FILE = BGPDT
      R(1) = 0.0
      R(2) = 0.0
      R(3) = 0.0
      CALL GOPEN (BGPDT,Z(IBUF),0)
      IF (IP .EQ. 0) GO TO 70
      I= (IP-1)*4
      CALL FREAD (BGPDT,Z,-I,0)
      CALL FREAD (BGPDT,I, 1,0)
      IF (I .EQ. -1) GO TO 30
      CALL FREAD (BGPDT,R,3,0)
   60 CALL REWIND (BGPDT)
      CALL SKPREC (BGPDT,1)
C
C     SET UP TO WRITE D
C
   70 IBUF1 = IBUF-SYSBUF
      NZ = IBUF1-5
C
C     BRING IN CSTM
C
      FILE = CSTM
      CALL OPEN   (*90,CSTM,Z(IBUF1),0)
      CALL FWDREC (*220,CSTM)
      CALL READ   (*220,*80,CSTM,Z(IZ5),NZ,0,NCSTM)
      GO TO 240
   80 CALL CLOSE  (CSTM,1)
      CALL PRETRS (Z(IZ5),NCSTM)
   90 CALL GOPEN  (D,Z(IBUF1),1)
      CALL MAKMCB (MCB,D,6,2,1)
      ISCALR = 0
      II     = 1
      JJ     = 6
      IT1    = 1
      IT2    = 1
      INCR   = 1
C
C     EXAMINE BGPDT
C
  100 CALL READ (*220,*190,BGPDT,Z(1),4,0,IFLAG)
      IF (IZ(1) .EQ. -1) GO TO 170
C
C     COMPUTE  TR
C
      ISCALR  = 1
      TR(1,1) = 0.0
      TR(2,2) = 0.0
      TR(3,3) = 0.0
      TR(2,1) = Z(IZ4) -R(3)
      TR(1,2) =-TR(2,1)
      TR(3,1) = R(2)- Z(IZ3)
      TR(1,3) =-TR(3,1)
      TR(3,2) = Z(IZ2)-R(1)
      TR(2,3) =-TR(3,2)
      DO 110 I = 1,3
      DO 110 J = 1,3
      TI(I,J) = 0.0
      IF (I .EQ. J) TI(I,J) = 1.0
  110 CONTINUE
      IF (IZ(1) .EQ. 0) GO TO 130
      CALL TRANSS (IZ(1),TI)
      CALL GMMATS (TI,3,3,1,TR,3,3,0,TT)
      DO 120 I = 1,3
      DO 120 J = 1,3
  120 TR(I,J) = TT(I,J)
C
C     MOVE STUFF INTO  DD
C
  130 DO 150 I = 1,6
      DO 150 J = 1,3
      IF (I .GT. 3) GO TO 140
      DD(I  ,J  ) = TI(J,I)
      DD(I+3,J+3) = DD(I,J)
      GO TO 150
  140 DD(I,J) = TR(I-3,J)
      DD(J,I) = 0.0
  150 CONTINUE
      DO 160 I = 1,6
      CALL PACK (DD(1,I),D,MCB)
  160 CONTINUE
      GO TO 100
C
C     SCALAR POINT
C
  170 DO 180 I = 1,6
  180 DD(I,1) = 0.0
      CALL PACK (DD,D,MCB)
      GO TO 100
C
C     END BGPDT
C
  190 CALL CLOSE  (BGPDT,1)
      CALL CLOSE  (D,1)
      CALL WRTTRL (MCB)
      RETURN
C
C     ERROR MESAGES
C
  210 CALL MESAGE (IP1,FILE,NAME)
  220 IP1 = -2
      GO TO 210
  240 IP1 = -8
      GO TO 210
      END

      SUBROUTINE ALG04(H,S,VW,R1,R2,X1,X2,VM,EPS,SCLFAC,G,EJ,HMIN,VMIN,
     1PSMID,NSTRMS,LOG2,LNCT,IFAIL)
C
      DIMENSION H(1),S(1),VW(1),R1(1),R2(1),X1(1),X2(1),VM(1)
      DIMENSION VZUP(21),VZDN(21),PSDN(21),HUP(21),VWUP(21),SUP(21),RMID
     1(20),DELR(20),PSUP(21),HSUP(21),VWFUN(21),VZFUN(21),SDN(21),HSDN(2
     21),VWDN(21),HDN(21),XX1(21),XX2(21),R(21)
C
      DO 80 J=1,NSTRMS
80    R(J)=(R1(J)+R2(J))*0.5
      Q1=R(NSTRMS)-R(1)
      Q2=VM(1)
      DO 90 J=2,NSTRMS
      IF(R(J)-R(J-1).LT.Q1)Q1=R(J)-R(J-1)
      IF(VM(J).LT.Q2)Q2=VM(J)
90    CONTINUE
      DELZ=Q2*Q1**2/(EPS*SCLFAC)*0.25
      Q1=(X2(1)+X2(NSTRMS)-X1(1)-X1(NSTRMS))*0.5
      ISTEP=Q1/DELZ+1.0
      DELZ=Q1/FLOAT(ISTEP)
      VM2=VMIN**2
      ITUB=NSTRMS-1
      IMID=NSTRMS/2+1
      DO 110 J=1,NSTRMS
      PSUP(J)=PSMID
      HUP(J)=H(J)
      VWUP(J)=VW(J)
110   SUP(J)=S(J)
      DO 120 J=1,ITUB
      RMID(J)=(R(J)+R(J+1))*0.5
120   DELR(J)=R(J+1)-R(J)
      IFAIL=0
      KSTEP=1
130   CALL ALG29(VWUP,R,XX2,NSTRMS)
      DO 150 J=1,NSTRMS
150   VWFUN(J)=EPS/R(J)*(XX2(J)-VWUP(J)/R(J))*SCLFAC
      IF(KSTEP.GT.1)GO TO 280
      JSTEP=1
      J1=IMID
190   J2=J1+JSTEP
      JJ=J1
      IF(JSTEP.EQ.-1)JJ=J2
      Q1=((VWUP(J1)+VWUP(J2))*0.5)**2/RMID(JJ)
      Q1=DELR(JJ)*Q1*FLOAT(JSTEP)
      X3=(SUP(J1)+SUP(J2))*0.5
      K=1
200   Q2=ALG2(X3,(PSUP(J1)+PSUP(J2))*0.5)
      IF(Q2.GE.HMIN)GO TO 210
      IFAIL=1
      GO TO 600
210   Q2=ALG5(Q2,X3)/G
      X4=PSUP(J2)
      PSUP(J2)=PSUP(J1)+Q1*Q2
      IF(ABS(X4/PSUP(J2)-1.0).LE.1.0E-5)GO TO 220
      K=K+1
      IF(K.LE.10)GO TO 200
      IFAIL=2
      GO TO 600
220   IF(J2.EQ.1)GO TO 240
      IF(J2.EQ.NSTRMS)GO TO 230
      J1=J2
      GO TO 190
230   JSTEP=-1
      J1=IMID
      GO TO 190
240   DO 260 J=1,NSTRMS
      HSUP(J)=ALG2(SUP(J),PSUP(J))
      IF(HSUP(J).GE.HMIN)GO TO 250
      IFAIL=3
      GO TO 600
250   Q1=2.0*G*EJ*(HUP(J)-HSUP(J))-VWUP(J)**2
      IF(Q1.GE.VM2)GO TO 260
      IFAIL=4
      GO TO 600
260   VZUP(J)=SQRT(Q1)
      FLOW=0.0
      DO 270 J=1,ITUB
270   FLOW=FLOW+(R(J+1)**2-R(J)**2)*(VZUP(J)+VZUP(J+1))*ALG5((HSUP(J)+HS
     1UP(J+1))*0.5,(SUP(J)+SUP(J+1))*0.5)
280   CALL ALG29(HSUP,R,XX2,NSTRMS)
      DO 300 J=1,NSTRMS
300   HDN(J)=HUP(J)+DELZ/VZUP(J)*EPS/R(J)*XX2(J)*SCLFAC
      DO 310 J=1,NSTRMS
310   VWDN(J)=VWUP(J)+DELZ/VZUP(J)*VWFUN(J)
      CALL ALG29(VZUP,R,VZFUN,NSTRMS)
      DO 330 J=1,NSTRMS
      VZFUN(J)=DELZ*EPS*SCLFAC*VZFUN(J)/R(J)
      SDN(J)=SUP(J)
330   PSDN(J)=PSUP(J)
      KK=1
340   J1=IMID
      JSTEP=1
350   J2=J1+JSTEP
      JJ=J1
      IF(JSTEP.EQ.-1)JJ=J2
      Q1=((VWDN(J1)+VWDN(J2))*0.5)**2/RMID(JJ)
      Q1=DELR(JJ)*Q1*FLOAT(JSTEP)
      X3=(SDN(J1)+SDN(J2))*0.5
      K=1
360   Q2=ALG2(X3,(PSDN(J1)+PSDN(J2))*0.5)
      IF(Q2.GE.HMIN)GO TO 370
      IFAIL=5
      GO TO 600
370   Q2=ALG5(Q2,X3)/G
      X4=PSDN(J2)
      PSDN(J2)=PSDN(J1)+Q1*Q2
      IF(ABS(X4/PSDN(J2)-1.0).LE.1.0E-5)GO TO 380
      K=K+1
      IF(K.LE.10)GO TO 360
      IFAIL=6
      GO TO 600
380   IF(J2.EQ.1)GO TO 400
      IF(J2.EQ.NSTRMS)GO TO 390
      J1=J2
      GO TO 350
390   J1=IMID
      JSTEP=-1
      GO TO 350
400   DO 410 J=1,NSTRMS
      VZDN(J)=VZUP(J)+(VZFUN(J)-(PSDN(J)-PSUP(J))/ALG5(HSUP(J),SUP(J))*G
     1)/VZUP(J)
      HSDN(J)=HDN(J)-(VZDN(J)**2+VWDN(J)**2)/(2.0*G*EJ)
      IF(HSDN(J).GE.HMIN)GO TO 410
      IFAIL=7
      GO TO 600
410   SDN(J)=ALG3(PSDN(J),HSDN(J))
      XX1(1)=0.0
      DO 420 J=1,ITUB
420   XX1(J+1)=XX1(J)+(R(J+1)**2-R(J)**2)*(VZDN(J+1)+VZDN(J))*ALG5((HSDN
     1(J)+HSDN(J+1))*0.5,(SDN(J)+SDN(J+1))*0.5)
      Q1=XX1(NSTRMS)
      IF(ABS(Q1/FLOW-1.0).LE.1.0E-5.AND.KK.GT.1)GO TO 450
      IF(KK.LE.15)GO TO 430
      IFAIL=8
      GO TO 600
430   Q2=ALG9(HSDN(IMID),SDN(IMID),VZDN(IMID)**2)
      Q1=(Q1-FLOW)*PSDN(IMID)*Q2/(FLOW*(1.0-Q2))
      DO 440 J=1,NSTRMS
440   PSDN(J)=PSDN(J)+Q1
      KK=KK+1
      GO TO 340
450   IF(KSTEP.EQ.ISTEP)GO TO 510
      DO 500 J=1,NSTRMS
      PSUP(J)=PSDN(J)
      HSUP(J)=HSDN(J)
      VZUP(J)=VZDN(J)
      VWUP(J)=VWDN(J)
      HUP(J)=HDN(J)
500   SUP(J)=SDN(J)
      KSTEP=KSTEP+1
      GO TO 130
510   DO 520 J=1,NSTRMS
      H(J)=HDN(J)
      S(J)=SDN(J)
520   VW(J)=VWDN(J)
      RETURN
600   CALL ALG03(LNCT,1)
      WRITE(LOG2,610)IFAIL
610   FORMAT(5X,30HMIXING CALCULATION FAILURE NO.,I2)
      RETURN
      END

      SUBROUTINE CX TRN Y (X,Y,ALPHA)
C*******
C     CX TRN Y FORMS THE DOT PRODUCT X TRANSPOSE * Y = ALPHA WHERE
C     X AND Y ARE COMPLEX
C*******
      COMMON   /CINVPX/  AAA       ,NCOL
      DOUBLE PRECISION   X(1)      ,Y(1)     ,ALPHA(2)
      NCOL2 = NCOL+NCOL
      ALPHA(1) = 0.D0
      ALPHA(2) = 0.D0
      DO 10 I = 1,NCOL2,2
      ALPHA(1) = ALPHA(1)+X(I)*Y(I)-X(I+1)*Y(I+1)
   10 ALPHA(2) = ALPHA(2)+X(I)*Y(I+1)+X(I+1)*Y(I)
      RETURN
      END

      SUBROUTINE MRED1D
C
C     THIS SUBROUTINE GENERATES THE EEDX DATA BLOCK USING THE EED DATA
C     BLOCK FORMAT FROM THE EIGR OR EIGC AND EIGP BULK DATA FOR THE
C     MRED1 MODULE.
C
C     INPUT  DATA
C     GINO - DYNAMICS - EIGC DATA
C                       EIGP DATA
C                       EIGR DATA
C
C     OUTPUT DATA
C     GINO - EEDX     - EIGC DATA
C                       EIGP DATA
C                       EIGR DATA
C
C     PARAMETERS
C     INPUT  - DNAMIC - DYNAMICS DATA BLOCK INPUT FILE NUMBER
C              GBUF1  - GINO BUFFER
C              EEDX   - EEDX DATA BLOCK OUTPUT FILE NUMBER
C              KORBGN - BEGINNING ADDRESS OF OPEN CORE
C              IEIG   - EIGENVALUE EXTRACTION SET IDENTIFICATION NUMBER
C     OUTPUT - DRY    - MODULE OPERATION FLAG
C     OTHERS - EIGTYP - EIG CARD TYPE PROCESSING FLAG
C                     = 1, PROCESS EIGC DATA
C                     = 2, PROCESS EIGP DATA
C                     = 3, PROCESS EIGR DATA
C              EIGCP  - EIGC AND EIGP DATA ERROR FLAG
C                     = 0, NO EIGC, EIGP DATA - NO ERROR
C                     = 1, EIGC DATA ONLY - NO ERROR
C                     = 2, EIGP DATA ONLY - ERROR
C                     = 3, EIGC AND EIGP DATA - NO ERROR
C              EIGTRL - EEDX TRAILER
C              EIGCPR - DUMMY EIG(C,P,R) ARRAY
C              EIG    - ARRAY OF EIG(C,P,R) CARD TYPES AND HEADER
C                       INFORMATION
C              KORBGN - BEGINNING ADDRESS OF OPEN CORE
C              NWDS2R - NUMBER OF EIG(C,P,R) WORDS TO READ ON DYNAMIC
C                       DATA FILE
C
      EXTERNAL        ORF
      LOGICAL         USRMOD
      INTEGER         ORF,OLDNAM,DRY,TYPE,GBUF1,GBUF2,Z,DNAMIC,
     1                EIG(3,3),EIGCPR(3),EEDX,EIGTRL(7),EIGTYP,EIGCP
      DIMENSION       MODNAM(2),LETR(3)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /BLANK / OLDNAM(2),DRY,IDUM1(3),TYPE(2),IDUM5,GBUF1,GBUF2,
     1                IDUM2(3),KORLEN,IDUM7(4),IEIG,IDUM3(6),KORBGN,
     2                IDUM6(12),USRMOD
      COMMON /ZZZZZZ/ Z(1)
      COMMON /TWO   / ITWO(32)
      COMMON /SYSTEM/ IDUM4,IPRNTR
      DATA    DNAMIC, EIG,EEDX/103,207,2,0,257,4,0,307,3,0,202/
      DATA    MODNAM, LETR /4HMRED,4H1D  ,1HC,1HP,1HR/
      DATA    KOMPLX, KREAL/4HCOMP,4HREAL/
C
C     OPEN DYNAMICS, EEDX DATA BLOCKS
C
      IF (DRY .EQ. -2) RETURN
      IF (USRMOD) GO TO 175
      CALL PRELOC (*180,Z(GBUF1),DNAMIC)
      CALL GOPEN (EEDX,Z(GBUF2),1)
C
C     SET PROCESSING FLAGS
C
      EIGTYP = 0
      EIGCP  = 0
      EIGTRL(1) = EEDX
      DO 10 I = 2,7
   10 EIGTRL(I) = 0
C
C     INCREMENT EIG PROCESSING FLAG
C     EIGTYP .EQ. 1, PROCESS EIGC DATA
C     EIGTYP .EQ. 2, PROCESS EIGP DATA
C     EIGTYP .EQ. 3, PROCESS EIGR DATA
C
   20 EIGTYP = EIGTYP + 1
      IF (EIGTYP .EQ. 4) GO TO 170
C
C     SELECT EIG MODE
C
      IF (TYPE(1).EQ.KREAL  .AND. EIGTYP.LT.3) GO TO 20
      IF (TYPE(1).EQ.KOMPLX .AND. EIGTYP.EQ.3) GO TO 20
      DO 30 I = 1,3
   30 EIGCPR(I) = EIG(I,EIGTYP)
C
C     LOCATE EIG(C,P,R) DATA CARD
C
      CALL LOCATE (*20,Z(GBUF1),EIGCPR,ITEST)
C
C     SET UP EEDX DATA RECORD
C
      DO 40 I = 1,3
   40 Z(KORBGN+I-1) = EIGCPR(I)
C
C     FIND CORRECT EIG(C,P,R) DATA CARD
C
      GO TO (50,60,70), EIGTYP
   50 NWDS2R = 10
      GO TO 80
   60 NWDS2R = 4
      GO TO 80
   70 NWDS2R = 18
   80 CALL READ (*190,*200,DNAMIC,Z(KORBGN+3),NWDS2R,0,NOWDSR)
      IF (Z(KORBGN+3) .EQ. IEIG) GO TO 100
      GO TO (90,80,80), EIGTYP
C
C     READ REST OF EIGC DATA
C
   90 CALL READ (*190,*200,DNAMIC,Z(KORBGN+3),7,0,NOWDSR)
      IF (Z(KORBGN+3) .EQ. -1) GO TO 80
      GO TO 90
C
C     SELECT EIG PROCESSING MODE
C
  100 GO TO (110,140,150), EIGTYP
C
C     WRITE EIGC DATA ONTO EEDX DATA BLOCK
C
  110 CALL WRITE (EEDX,Z(KORBGN),13,0)
      EIGTRL(2) = ORF(EIGTRL(2),16384)
      EIGCP = EIGCP + 1
  120 CALL READ (*190,*200,DNAMIC,Z(KORBGN),7,0,NOWDSR)
      IF (Z(KORBGN) .EQ. -1) GO TO 130
      CALL WRITE (EEDX,Z(KORBGN),7,0)
      GO TO 120
  130 CALL WRITE (EEDX,Z(KORBGN),7,1)
      GO TO 20
C
C     WRITE EIGP DATA ONTO EEDX DATA BLOCK
C
  140 CALL WRITE (EEDX,Z(KORBGN),7,1)
      EIGCP = EIGCP + 2
      EIGTRL(2) = ORF(EIGTRL(2),4096)
      GO TO 20
C
C     WRITE EIGR DATA ONTO EEDX DATA BLOCK
C
  150 CALL WRITE (EEDX,Z(KORBGN),21,1)
      EIGTRL(2) = ORF(EIGTRL(2),8192)
      GO TO 20
C
C     CLOSE DYNAMICS, EEDX DATA BLOCKS
C
  170 CALL CLOSE (DNAMIC,1)
      CALL CLOSE (EEDX,1)
C
C     TEST FOR EIG CARD ERRORS
C
      IF (EIGTRL(2) .EQ. 0) GO TO 230
      IF (EIGCP .EQ. 2) GO TO 240
C
C     WRITE EEDX DATA BLOCK TRAILER
C
      CALL WRTTRL (EIGTRL)
  175 CONTINUE
      RETURN
C
C     PROCESS SYSTEM FATAL ERRORS
C
  180 IMSG = -1
      GO TO 220
  190 IMSG = -2
      IF (EIGTYP .EQ. 2) GO TO 20
      GO TO 210
  200 IMSG = -3
      IF (EIGTYP .EQ. 2) GO TO 20
  210 WRITE (IPRNTR,900) UFM,LETR(EIGTYP),IEIG,OLDNAM
  220 CALL SOFCLS
      CALL MESAGE (IMSG,DNAMIC,MODNAM)
      RETURN
C
C     PROCESS MODULE FATAL ERRORS
C
  230 WRITE (IPRNTR,901) UFM,IEIG,OLDNAM
      GO TO 250
  240 WRITE (IPRNTR,902) UFM,IEIG,OLDNAM
  250 DRY = -2
      RETURN
C
  900 FORMAT (A23,' 6627, NO EIG',A1,' DATA CARD ',
     1       'SPECIFIED FOR SET ID',I9,', SUBSTRUCTURE ',2A4,1H.)
  901 FORMAT (A23,' 6628, NO EIGC OR EIGR CARD SPECIFIED FOR SET ID',I9,
     1       ', SUBSTRUCTURE ',2A4,1H.)
  902 FORMAT (A23,' 6629, NO EIGC DATA CARD SPECIFHIED WITH EIGP DATA ',
     1       'CARD SET ID',I9,', SUBSTRUCTURE ',2A4,1H.)
C
      END

      SUBROUTINE IFP1F (*,IWORD,II)
C
C     FINDS FIRST 4 NON-BLANK CHARACTERS
C
      DIMENSION       CORE(1),COREY(401)
      COMMON /ZZZZZZ/ COREX(1)
      COMMON /IFP1A / SKIP1(4),NCPW4,SKIP2(4),IZZZBB,SKIP3(3),IBEN
      EQUIVALENCE     (COREX(1),COREY(1)), (CORE(1),COREY(401))
C
      IWORD = IZZZBB
      L  = 1
      II = 0
      DO 10 I = 1,18
      DO 10 J = 1,NCPW4
      K = KHRFN1(IZZZBB,1,CORE(I),J)
      IF (K .EQ. IBEN) GO TO 10
      IF (II .EQ. 0) II = I
      IWORD = KHRFN1(IWORD,L,K,1)
      L = L + 1
      IF (L .GT. NCPW4) GO TO 20
 10   CONTINUE
      RETURN 1
 20   RETURN
      END

      SUBROUTINE RSETUP (LVL,LVLS1,LVLS2,NACUM,IDIM)
C
C     THIS ROUTINE IS USED ONLY IN BANDIT MODULE
C
C     SETUP COMPUTES THE REVERSE LEVELING INFO FROM LVLS2 AND STORES
C     IT INTO LVLS2.  NACUM(I) IS INITIALIZED TO NODES/ITH LEVEL FOR
C     NODES ON THE PSEUDO-DIAMETER OF THE GRAPH.  LVL IS INITIALIZED TO
C     NON-ZERO FOR NODES ON THE PSEUDO-DIAM AND NODES IN A DIFFERENT
C     COMPONENT OF THE GRAPH.
C
      DIMENSION        NACUM(1), LVL(1),   LVLS1(1), LVLS2(1)
      COMMON /BANDB /  DUM3B(3), NGRID
      COMMON /BANDG /  N,        IDPTH
C
C     IDIM=NUMBER OF LEVELS IN A GIVEN COMPONENT.
C     NACUM IS DIMENSIONED TO IDIM IN SIZE
C
C     DIMENSION EXCEEDED  . . .  STOP JOB.
C
      IF (IDPTH.LE.IDIM)  GO TO 20
      NGRID=-3
      RETURN
C
   20 DO 30 I=1,IDPTH
   30 NACUM(I)=0
      DO 140 I=1,N
      LVL(I)=1
      LVLS2(I)=IDPTH+1-LVLS2(I)
      ITEMP=LVLS2(I)
      IF (ITEMP.GT.IDPTH) GO TO 140
      IF (ITEMP.NE.LVLS1(I)) GO TO 100
      NACUM(ITEMP)=NACUM(ITEMP)+1
      GO TO 140
  100 LVL(I)=0
  140 CONTINUE
      RETURN
      END

      SUBROUTINE SUBPH1
C
C     THIS MODULE PERFORMS THE PHASE 1 CONVERSION OF NASTRAN DATA BLOCK
C     TABLES TO THEIR EQUIVALENT SOF ITEMS
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        LSHIFT,ANDF,ORF
      LOGICAL         LAST
      INTEGER         BUF(10),TEMP(10),TYPE,SUB1(2),ICODE(32),MCB(7),
     1                LTYPE1(5),LTYPE2(5),LTYPE3(5)
      REAL            RZ(12)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG / UFM,UWM,UIM,SFM
      COMMON /SYSTEM/ BSIZE,OUT
      COMMON /BLANK / DRY,NAME(2),PSET,PITM
      COMMON /TWO   / TWO(32)
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE     (RZ(1),Z(1))
      DATA    CASE  , EQEX,USET,BGPD,CSTM,GPSE,ELSE,SCRT/
     1        101   , 102 ,103 ,104 ,105 ,106 ,107 ,301 /
      DATA    EQSS  / 4HEQSS/,ICSTM/4HCSTM/,LODS /4HLODS/,PLTS/4HPLTS/,
     1        BGSS  / 4HBGSS/
      DATA    IUA   / 25    /, SUB1/4HSUBP,4HH1   /
      DATA    LTYPE1/ 4HEXTE,4HRNAL,4H STA,4HTIC ,4HLOAD/
      DATA    LTYPE2/ 4H    ,4H    ,4HTHER,4HMAL ,4HLOAD/
      DATA    LTYPE3/ 4H ELE,4HMENT,4H DEF,4HORMA,4HTION/
      DATA    LOAP  , PAPP  /4HLOAP,4HPAPP/,  I0 / 0    /
C
      MUA = TWO(IUA)
C
C     INITIALLIZE CORE, ETC
C
      IF (DRY .EQ. 0) RETURN
      NC = KORSZ(Z(1))
      B1 = NC - BSIZE + 1
C
C     OPEN SCRATCH FILE TO WRITE CONVERTED DATA
C
      B2   =  B1  - BSIZE
      B3   =  B2  - BSIZE
      BUF1 =  B3  - BSIZE
      BUF2 =  BUF1- BSIZE
      NZ   =  BUF2- 1
C
C     TEST FOR CORE
C
      IF (NZ .LE. 0) GO TO 4010
C
      CALL SOFOPN (Z(B1),Z(B2),Z(B3))
C
C     EQSS GENERATION
C
      FILE = USET
      CALL OPEN (*5001,USET,Z(BUF1),0)
      CALL FWDREC (*5001,USET)
C
C     READ USET INTO CORE
C
      CALL READ (*5001,*20,USET,Z(1),NZ,0,NU)
C
C     RAN OUT OF CORE
C
      CALL CLOSE (USET,1)
      GO TO 4010
C
 20   CALL CLOSE (USET,1)
C
C     FLAG ELEMENTS IN UA SET  (SET OTHERS TO ZERO)
C
      DO 40 I = 1,NU
      IF (ANDF(MUA,Z(I)) .EQ. 0) GO TO 30
      Z(I) = 1
      GO TO 40
 30   Z(I) = 0
 40   CONTINUE
C
C     READ  SECOND RECORD OF EQEXIN - CONTAINS  G AND SIL PAIRS
C
      FILE = EQEX
      CALL OPEN (*5001,EQEX,Z(BUF1),0)
      CALL FWDREC (*5001,EQEX)
      CALL FWDREC (*5001,EQEX)
C
C     OPEN SCRATCH FILE TO WRITE CONVERTED DATA
C
      CALL OPEN (*5001,SCRT,Z(BUF2),1)
C
C     LOOP ON GRID POINTS
C
      K = 0
      I = 0
C
 50   CALL READ (*5001,*110,EQEX,BUF,2,0,NWDS)
      C = 0
      I = I + 1
      ISIL = BUF(2)/10
      TYPE = BUF(2) - 10*ISIL
      IF (TYPE-2) 60,80,4020
C
C     GRID POINT, DETERMINE UA COMPONENTS, PUT IN BINARY FORM
C
 60   DO 70 J = 1,6
      IU = ISIL + J - 1
      IF (Z(IU) .EQ. 0) GO TO 70
      C  = ORF(C,LSHIFT(1,J-1))
 70   CONTINUE
      GO TO 90
C
C     SCALAR POINT
C
 80   IF (Z(ISIL) .NE. 0) C = 1
C
C     WRITE OUT G AND C
C
 90   IF (C .EQ. 0) GO TO 100
      BUF(2) = C
      CALL WRITE (SCRT,BUF,2,0)
      K = K + 1
 100  CONTINUE
      GO TO 50
C
 110  MCB(1) = EQEX
      CALL RDTRL (MCB)
      NPTS = MCB(2)
      CALL REWIND (EQEX)
      CALL CLOSE (SCRT,1)
      IF (NPTS*2 .GT. NZ) GO TO 4010
C
C     READ FIRST RECORD OF EQEXIN - GET G AND IOLD
C     READ SCRATCH - GET G AND C
C     BUILD TABLE IN CORE
C
      FILE = EQEX
      CALL FWDREC (*5001,EQEX)
      FILE = SCRT
      CALL OPEN (*5001,SCRT,Z(BUF2),0)
C
C     SET CORE TO ZERO
C
      DO 150 I = 1,NPTS
      IZP = 2*I
      Z(IZP  ) = 0
      Z(IZP-1) = 0
 150  CONTINUE
      NNEW = K
C
C     LOOP ON POINTS IN SCRATCH FILE, STORE C IN ITH WORD OF ENTRY
C     POSITION OF ENTRY IS THE INTERNAL SEQUENCE
C
      IF (K .LE. 0) GO TO 210
      DO 200 I = 1,K
      FILE = SCRT
      CALL READ (*5001,*210,SCRT,BUF,2,0,NWDS)
      FILE = EQEX
 180  CALL READ (*5001,*210,EQEX,TEMP,2,0,NWDS)
      IF (BUF(1)-TEMP(1)) 5001,190,180
 190  IZP = 2*TEMP(2)
      Z(IZP) = BUF(2)
 200  CONTINUE
C
C     CORE TABLE IS COMPLETE, FILL IN FIRST ENTRIES
C
 210  CALL CLOSE (SCRT,1)
      CALL REWIND (EQEX)
      K = 0
      DO 300 I = 1,NPTS
      IF (Z(2*I) .EQ. 0) GO TO 300
      K = K + 1
      Z(2*I-1) = K
 300  CONTINUE
C
C     CORE NOW CONTAINS NEW IP VALUES AND C IN OLD IP POSITIONS
C
      FILE = EQSS
C
C     CHECK IF SUBSTRUCTURE EXISTS ALREADY
C
      CALL FWDREC (*5001,EQEX)
      CALL SETLVL (NAME,0,TEMP,ITEST,0)
      IF (ITEST .NE. 1) WRITE (OUT,6325) UWM,NAME
      ITEST = 3
      CALL SFETCH (NAME,EQSS,2,ITEST)
      IF (ITEST .EQ. 3) GO TO 340
      WRITE (OUT,6326) UWM,NAME,EQSS
      GO TO 1000
 340  BUF(1) = NAME(1)
      BUF(2) = NAME(2)
      BUF(3) = 1
      BUF(4) = NNEW
      BUF(5) = NAME(1)
      BUF(6) = NAME(2)
C
      CALL SUWRT (BUF,6,2)
C
C     PROCESS EQSS OUTPUT-  G, IP, C - SORTED ON G
C
      DO 400 I = 1,NPTS
C
      CALL READ (*5001,*400,EQEX,TEMP,2,0,NWDS)
C
      IPT = TEMP(2)*2 - 1
      IF (Z(IPT) .EQ. 0) GO TO 400
      TEMP(2) = Z(IPT  )
      TEMP(3) = Z(IPT+1)
      CALL SUWRT (TEMP,3,1)
 400  CONTINUE
      CALL SUWRT (TEMP,0,2)
C
C     BUILD SIL TABLE BY COUNTING C VALUES
C
      NC = 0
      IS = 1
      DO 500 I = 1,NPTS
      IPT = 2*I - 1
C
      IF (Z(IPT) .EQ. 0) GO TO 500
      IS = IS + NC
      Z(IPT) = IS
C
      CALL SUWRT (Z(IPT),2,1)
C
C     CALCULATE NUMBER OF COMPONENTS FOR NEXT STEP
C
      KCODE = Z(IPT+1)
      CALL DECODE (KCODE,ICODE,NC)
 500  CONTINUE
      CALL SUWRT (0,0,2)
      CALL SUWRT (TEMP,0,3)
 1000 CALL CLOSE (EQEX,1)
C
C     BGSS GENERATION
C
      FILE = BGPD
      CALL OPEN (*5001,BGPD,Z(BUF1),0)
      CALL FWDREC (*5001,BGPD)
      ITEST = 3
      CALL SFETCH (NAME,BGSS,2,ITEST)
      IF (ITEST .EQ. 3) GO TO 1100
      WRITE (OUT,6326) UWM,NAME,BGSS
      GO TO 2000
 1100 CONTINUE
C
      BUF(1) = NAME(1)
      BUF(2) = NAME(2)
      BUF(3) = NNEW
      CALL SUWRT (BUF,3,2)
      DO 1200 I = 1,NPTS
      CALL READ (*5001,*1200,BGPD,BUF,4,0,NWDS)
C
      IF (Z(2*I-1) .EQ. 0) GO TO 1200
C
      CALL SUWRT (BUF,4,1)
 1200 CONTINUE
      CALL SUWRT (0,0,2)
      CALL SUWRT (BUF,0,3)
 2000 CALL CLOSE (BGPD,1)
C
C
C     CSTM GENERATION
C
C
      CALL OPEN (*2500,CSTM,Z(BUF1),0)
C
C     CSTM EXISTS
C
      CALL FWDREC (*5001,CSTM)
      ITEST = 3
      CALL SFETCH (NAME,ICSTM,2,ITEST)
      IF (ITEST .EQ. 3) GO TO 2100
      WRITE (OUT,6326) UWM,NAME,ICSTM
      GO TO 2400
C
 2100 BUF(1) = NAME(1)
      BUF(2) = NAME(2)
      CALL SUWRT (BUF,2,2)
C
C     BLAST COPY
C
      CALL READ (*5001,*2200,CSTM,Z(1),NZ,1,NWDS)
      GO TO 4010
 2200 CALL SUWRT (Z(1),NWDS,2)
      CALL SUWRT (0,0,3)
 2400 CALL CLOSE (CSTM,1)
C
C     LODS GENERATION
C
 2500 NLOD = 0
C
      CALL GOPEN (CASE,Z(BUF1),0)
C
      ICASE = 0
C
 2600 CALL READ (*2800,*2800,CASE,Z(1),9,1,NWDS)
      ICASE = ICASE + 1
      IF (Z(I0+4) .EQ. 0) GO TO 2610
      WRITE (OUT,6327) UIM,NAME,ICASE,LTYPE1,Z(I0+4)
      Z(NLOD+10) = Z(I0+4)
      GO TO 2700
 2610 IF (Z(I0+7) .EQ. 0) GO TO 2620
      WRITE (OUT,6327) UIM,NAME,ICASE,LTYPE2,Z(I0+7)
      Z(NLOD+10) = Z(I0+7)
      GO TO 2700
 2620 IF (Z(I0+6) .EQ. 0) GO TO 2630
      WRITE (OUT,6327) UIM,NAME,ICASE,LTYPE3,Z(I0+6)
      Z(NLOD+10) = Z(I0+6)
      GO TO 2700
 2630 Z(NLOD+10) = 0
 2700 NLOD = NLOD + 1
      GO TO 2600
 2800 ITEST = 3
      LITM  = LODS
      IF (PITM .EQ. PAPP) LITM = LOAP
      CALL SFETCH (NAME,LITM,2,ITEST)
      IF (ITEST .EQ. 3) GO TO 2810
      WRITE (OUT,6326) UWM,NAME,LITM
      GO TO 2900
 2810 Z(   1) = NAME(1)
      Z(I0+2) = NAME(2)
      Z(I0+3) = NLOD
      Z(I0+4) = 1
      Z(I0+5) = NAME(1)
      Z(I0+6) = NAME(2)
      CALL SUWRT (Z(1),6,2)
      CALL SUWRT (NLOD,1,1)
      CALL SUWRT (Z(I0+10),NLOD,2)
      CALL SUWRT (Z(1),0,3)
 2900 CALL CLOSE (CASE,1)
C
C     PLOT SET DATA (PLTS) GENERATION
C
      IF (PSET .LE. 0) GO TO 4000
      FILE = BGPD
      CALL GOPEN (BGPD,Z(BUF1),0)
C
      ITEST = 3
      CALL SFETCH (NAME,PLTS,2,ITEST)
      IF (ITEST .EQ. 3) GO TO 3010
      WRITE (OUT,6326) UWM,NAME,PLTS
      CALL CLOSE (BGPD,1)
      GO TO 4000
C
 3010 BUF(1) = NAME(1)
      BUF(2) = NAME(2)
      BUF(3) = 1
      BUF(4) = NAME(1)
      BUF(5) = NAME(2)
      CALL SUWRT (BUF,5,1)
      DO 3012 I = 1,11
 3012 Z(I) = 0
      RZ( 4) = 1.0
      RZ( 8) = 1.0
      RZ(12) = 1.0
      CALL SUWRT (Z,12,2)
C
      CALL READ (*5001,*3020,BGPD,Z(1),NZ,0,NWDS)
      GO TO 4010
 3020 CALL SUWRT (Z,NWDS,2)
      CALL CLOSE (BGPD,1)
      FILE = EQEX
      CALL GOPEN (EQEX,Z(BUF1),0)
      CALL READ (*5001,*3030,EQEX,Z,NZ,1,NWDS)
      GO TO 4010
 3030 CALL SUWRT (Z,NWDS,2)
      CALL CLOSE (EQEX,1)
      FILE = GPSE
      LAST = .FALSE.
      CALL OPEN (*3500,GPSE,Z(BUF1),0)
C
      CALL FWDREC (*3500,GPSE)
C
      CALL READ (*5001,*3050,GPSE,Z(1),NZ,0,NSETS)
      GO TO 4010
C
C     FIND PLOT SET ID
C
 3050 IF (NSETS .EQ. 0) GO TO 3500
C
      DO 3060 I = 1,NSETS
      IF (Z(I) .EQ. PSET) GO TO 3070
 3060 CONTINUE
      GO TO 3500
 3070 IREC = I - 1
C
 3075 IF (IREC .EQ. 0) GO TO 3090
C
C     POSITION FILE TO SELECTED SET
C
      DO 3080 I = 1,IREC
      CALL FWDREC (*3500,FILE)
 3080 CONTINUE
 3090 CALL READ (*3500,*3100,FILE,Z(1),NZ,0,NWDS)
      GO TO 4010
 3100 CALL SUWRT (Z(1),NWDS,2)
      CALL CLOSE (FILE,1)
      IF (LAST) GO TO 3300
      LAST = .TRUE.
      FILE = ELSE
      CALL OPEN (*3500,ELSE,Z(BUF1),0)
      CALL FWDREC (*3500,ELSE)
      GO TO 3075
C
C     FINISHED
C
 3300 CALL SUWRT (Z(1),0,3)
      GO TO 4000
 3500 CALL CLOSE (FILE,1)
      WRITE  (OUT,3510) UWM,PSET
 3510 FORMAT (A25,' 6050, REQUESTED PLOT SET NO.',I8,
     1       ' HAS NOT BEEN DEFINED')
C
 4000 CALL SOFCLS
      WRITE  (OUT,6361) UIM,NAME
 6361 FORMAT (A29,' 6361, PHASE 1 SUCCESSFULLY EXECUTED FOR ',
     1       'SUBSTRUCTURE ',2A4)
      RETURN
C
C     INSUFFICIENT CORE
C
 4010 WRITE  (OUT,4015) UFM,NZ
 4015 FORMAT (A23,' 6011, INSUFFICIENT CORE TO LOAD TABLES', /5X,
     1       'IN MODULE SUBPH1, CORE =',1I8)
      DRY = -2
      GO TO 6000
C
C     BAD GRID POINT TYPE (IE AXISYMMETRIC OR)
C
 4020 WRITE  (OUT,4035) UFM,BUF(1)
 4035 FORMAT (A23,' 6013 , ILLEGAL TYPE OF POINT DEFINED FOR ',
     1       'SUBSTRUCTURE ANALYSIS.', /5X,'POINT NUMBER =',I9)
      GO TO 6000
C
C     BAD FILE
C
 5001 WRITE  (OUT,5005) SFM,FILE
 5005 FORMAT (A25,' 6012, FILE =',I4,' IS PURGED OR NULL AND IS ',
     1       'REQUIRED IN PHASE 1 SUBSTRUCTURE ANALYSIS.')
C
 6000 CALL SOFCLS
      CALL MESAGE (-61,0,SUB1)
      RETURN
C
C
 6325 FORMAT (A25,' 6325, SUBSTRUCTURE PHASE 1, BASIC SUBSTRUCTURE ',
     1       2A4,' ALREADY EXISTS ON SOF.', /32X,
     2       'ITEMS WHICH ALREADY EXIST WILL NOT BE REGENERATED.')
 6326 FORMAT (A25,' 6326, SUBSTRUCTURE ',2A4,', ITEM ',A4,
     1       ' ALREADY EXISTS ON SOF.')
 6327 FORMAT (A29,' 6327, SUBSTRUCTURE ',2A4,' SUBCASE',I9,
     1       ' IS IDENTIFIED BY', /36X,5A4,' SET',I9,' IN LODS ITEM.',
     2       /36X,'REFER TO THIS NUMBER ON LOADC CARDS.')
      END

      SUBROUTINE OPEN(*,NAMFIL,BUFF,OP)
C******
C
C OPEN IS AN INTERMEDIARY TO ENTRY POINT QOPEN IN SUBROUTINE GINO.
C THE MAIN TASK OF OPEN IS TO INSURE THAT DATA BLOCKS WHICH WERE
C WRITTEN AND CLOSED OFF THE LOAD POINT HAVE AN END-OF-FILE BEFORE
C THEY ARE READ.
C
C******
      INTEGER BUFF(1), OP, XOP, XNAME
      COMMON /SYSTEM/ ISYSTM(157)
      INCLUDE 'DSIOF.COM'
C
C
C TEST FOR CONDITION IN WHICH END-OF-FILE IS TO BE WRITTEN
C
      DATA INIT / 0 /
      IF ( INIT .NE. 0 ) GO TO 5
      CALL DSIODD
      INIT = 1
   5  CONTINUE
      XNAME = NAMFIL
      IFILEX = 0
      CALL GETURN( XNAME )
      IF(IFILEX.EQ.0)RETURN 1
   10 IF( OP.EQ.1 .OR. OP.EQ.3 ) GO TO 80
      IF( NBLOCK+NLR .GT. 7 ) GO TO 12
   11 IF( OP .EQ. -2 ) RETURN
      GO TO 80
   12 IF( IPRVOP .EQ. 0 ) GO TO 11
C
C DATA BLOCK WAS PREVIOUSLY OPENED TO WRITE AND IS NOW OFF LOAD POINT.
C WRITE AN END-OF-FILE. IF SPECIAL CALL, RETURN
C
      CALL QOPEN(*88,NAMFIL,BUFF,3)
      CALL EOF( NAMFIL )
      XOP = 2
      IF( OP .EQ. -2 ) XOP = 1
      CALL CLOSE( NAMFIL, XOP )
      IF( OP .EQ. -2 ) RETURN
C
C NOW OPEN ACCORDING TO OP. IF NECESSARY, POSITION PRIOR TO EOF
C
      LASNAM = 0
      CALL GETURN( NAMFIL )
      CALL QOPEN(*88,NAMFIL,BUFF,OP)
      IF( OP .EQ. 2 ) CALL BCKREC( NAMFIL )
      RETURN
C
C NORMAL OPEN CALL
C
   80 CALL QOPEN(*88,NAMFIL,BUFF,OP)
CWKBNB NCL93007 11/94
C SET THE COUNT FOR THE TOTAL NUMBER OF STRINGS AND TERMS
C TO ZERO IF FILE IS BEING OPENED FOR WRITE
      IF ( OP .NE. 1 ) GO TO 70
      FCB( 16, IFILEX ) = 0
      FCB( 17, IFILEX ) = 0
   70 CONTINUE
CWKBNE NCL93007 11/94
      RETURN
   88 RETURN 1
      END

      SUBROUTINE ATEIG(M,A,RR,RI,IANA,IA,B,RRA,RRI)
C
C     ..................................................................
C
C        SUBROUTINE ATEIG
C
C        PURPOSE
C           COMPUTE THE EIGENVALUES OF A REAL ALMOST TRIANGULAR MATRIX
C
C        USAGE
C           CALL ATEIG(M,A,RR,RI,IANA,IA)
C
C        DESCRIPTION OF THE PARAMETERS
C           M      ORDER OF THE MATRIX
C           A      THE INPUT MATRIX, M BY M
C           RR     VECTOR CONTAINING THE REAL PARTS OF THE EIGENVALUES
C                  ON RETURN
C           RI     VECTOR CONTAINING THE IMAGINARY PARTS OF THE EIGEN-
C                  VALUES ON RETURN
C           IANA   VECTOR WHOSE DIMENSION MUST BE GREATER THAN OR EQUAL
C                  TO M, CONTAINING ON RETURN INDICATIONS ABOUT THE WAY
C                  THE EIGENVALUES APPEARED (SEE MATH. DESCRIPTION)
C           IA     SIZE OF THE FIRST DIMENSION ASSIGNED TO THE ARRAY A
C                  IN THE CALLING PROGRAM WHEN THE MATRIX IS IN DOUBLE
C                  SUBSCRIPTED DATA STORAGE MODE.
C                  IA=M WHEN THE MATRIX IS IN SSP VECTOR STORAGE MODE.
C
C        REMARKS
C           THE ORIGINAL MATRIX IS DESTROYED
C           THE DIMENSION OF RR AND RI MUST BE GREATER OR EQUAL TO M
C
C        SUBROUTINES AND FUNCTION SUBPROGRAMS REQUIRED
C           NONE
C
C        METHOD
C           QR DOUBLE ITERATION
C
C        REFERENCES
C           J.G.F. FRANCIS - THE QR TRANSFORMATION---THE COMPUTER
C           JOURNAL, VOL. 4, NO. 3, OCTOBER 1961, VOL. 4, NO. 4, JANUARY
C           1962.  J. H. WILKINSON - THE ALGEBRAIC EIGENVALUE PROBLEM -
C           CLARENDON PRESS, OXFORD, 1965.
C
C     ..................................................................
C
      DIMENSION IANA(1)
      DIMENSION RRA(1),RRI(1),B(1)
      DOUBLE PRECISION A(1),RR(1),RI(1),PRR(2),PRI(2)
      DOUBLE PRECISION ALPHA,CAP,D,DELTA,EPS,ETA,E10,E6,E7,G1,G2,G3
      DOUBLE PRECISION PAN,PAN1,PSI1,PSI2,R,RMOD,S,T,U,V
      INTEGER P,P1,Q
C
      E7=1.0E-8
      E6=1.0E-6
      E10=1.0E-10
      DELTA=0.5
      MAXIT=30
C
C        INITIALIZATION
C
      N=M
   20 N1=N-1
      IN=N1*IA
      NN=IN+N
      IF(N1) 30,1300,30
   30 NP=N+1
C
C        ITERATION COUNTER
C
      IT=0
C
C        ROOTS OF THE 2ND ORDER MAIN SUBMATRIX AT THE PREVIOUS
C        ITERATION
C
      DO 40 I=1,2
      PRR(I)=0.0
   40 PRI(I)=0.0
C
C        LAST TWO SUBDIAGONAL ELEMENTS AT THE PREVIOUS ITERATION
C
      PAN=0.0
      PAN1=0.0
C
C        ORIGIN SHIFT
C
      R=0.0
      S=0.0
C
C        ROOTS OF THE LOWER MAIN 2 BY 2 SUBMATRIX
C
      N2=N1-1
      IN1=IN-IA
      NN1=IN1+N
      N1N=IN+N1
      N1N1=IN1+N1
   60 T=A(N1N1)-A(NN)
      U=T*T
      V=4.0D0*A(N1N)*A(NN1)
      IF (DABS(V)-U*E7) 100,100,65
   65 T=U+V
      IF (DABS(T)-DMAX1(U,DABS(V))*E6) 67,67,68
   67 T=0.0
68    U=(A(N1N1)+A(NN))/2.0D0
      V=DSQRT(DABS(T))/2.0D0
      IF(T)140,70,70
   70 IF(U) 80,75,75
   75 RR(N1)=U+V
      RR(N)=U-V
      GO TO 130
   80 RR(N1)=U-V
      RR(N)=U+V
      GO TO 130
  100 IF(T)120,110,110
  110 RR(N1)=A(N1N1)
      RR(N)=A(NN)
      GO TO 130
  120 RR(N1)=A(NN)
      RR(N)=A(N1N1)
  130 RI(N)=0.0
      RI(N1)=0.0
      GO TO 160
  140 RR(N1)=U
      RR(N)=U
      RI(N1)=V
      RI(N)=-V
  160 IF(N2)1280,1280,180
C
C        TESTS OF CONVERGENCE
C
  180 N1N2=N1N1-IA
      RMOD=RR(N1)*RR(N1)+RI(N1)*RI(N1)
      EPS=E10*DSQRT(RMOD)
      IF(DABS(A(N1N2))-EPS)1280,1280,240
240   IF(DABS(A(NN1))-E10*DABS(A(NN))) 1300,1300,250
250   IF(DABS(PAN1-A(N1N2))-DABS(A(N1N2))*E6) 1240,1240,260
260   IF(DABS(PAN-A(NN1))-DABS(A(NN1))*E6) 1240,1240,300
  300 IF(IT-MAXIT) 320,1240,1240
C
C        COMPUTE THE SHIFT
C
  320 J=1
      DO 360 I=1,2
      K=NP-I
      IF(DABS(RR(K)-PRR(I))+DABS(RI(K)-PRI(I))-DELTA*(DABS(RR(K))
     *   +DABS(RI(K)))) 340,360,360
  340 J=J+I
  360 CONTINUE
      GO TO (440,460,460,480),J
  440 R=0.0
      S=0.0
      GO TO 500
  460 J=N+2-J
      R=RR(J)*RR(J)
      S=RR(J)+RR(J)
      GO TO 500
  480 R=RR(N)*RR(N1)-RI(N)*RI(N1)
      S=RR(N)+RR(N1)
C
C        SAVE THE LAST TWO SUBDIAGONAL TERMS AND THE ROOTS OF THE
C        SUBMATRIX BEFORE ITERATION
C
  500 PAN=A(NN1)
      PAN1=A(N1N2)
      DO 520 I=1,2
      K=NP-I
      PRR(I)=RR(K)
  520 PRI(I)=RI(K)
C
C        SEARCH FOR A PARTITION OF THE MATRIX, DEFINED BY P AND Q
C
      P=N2
      IPI = N1N2
      DO 580 J=2,N2
      IPI = IPI - IA - 1
      IF(DABS(A(IPI))-EPS) 600,600,530
  530 IPIP=IPI+IA
      IPIP2=IPIP+IA
      D=A(IPIP)*(A(IPIP)-S)+A(IPIP2)*A(IPIP+1)+R
      IF(D)540,560,540
540   IF(DABS(A(IPI)*A(IPIP+1))*(DABS(A(IPIP)+A(IPIP2+1)-S)+
     * DABS(A(IPIP2+2)))-DABS(D)*EPS) 620,620,560
  560 P=N1-J
  580 CONTINUE
  600 Q=P
      GO TO 680
  620 P1=P-1
      Q = P
      DO 660 I = 1,P1
      IPI = IPI - IA - 1
      IF(DABS(A(IPI))-EPS) 680,680,660
  660 Q=Q-1
C
C        QR DOUBLE ITERATION
C
  680 II=(P-1)*IA+P
      DO 1220 I=P,N1
      II1=II-IA
      IIP=II+IA
      IF(I-P)720,700,720
  700 IPI=II+1
      IPIP=IIP+1
C
C        INITIALIZATION OF THE TRANSFORMATION
C
      G1=A(II)*(A(II)-S)+A(IIP)*A(IPI)+R
      G2=A(IPI)*(A(IPIP)+A(II)-S)
      G3=A(IPI)*A(IPIP+1)
      A(IPI+1)=0.0
      GO TO 780
  720 G1=A(II1)
      G2=A(II1+1)
      IF(I-N2)740,740,760
  740 G3=A(II1+2)
      GO TO 780
  760 G3=0.0
780   CAP=DSQRT(G1*G1+G2*G2+G3*G3)
      IF(CAP)800,860,800
  800 IF(G1)820,840,840
  820 CAP=-CAP
  840 T=G1+CAP
      PSI1=G2/T
      PSI2=G3/T
      ALPHA=2.0D0/(1.0D0+PSI1*PSI1+PSI2*PSI2)
      GO TO 880
  860 ALPHA=2.0
      PSI1=0.0
      PSI2=0.0
  880 IF(I-Q)900,960,900
  900 IF(I-P)920,940,920
  920 A(II1)=-CAP
      GO TO 960
  940 A(II1)=-A(II1)
C
C        ROW OPERATION
C
  960 IJ=II
      DO 1040 J=I,N
      T=PSI1*A(IJ+1)
      IF(I-N1)980,1000,1000
  980 IP2J=IJ+2
      T=T+PSI2*A(IP2J)
 1000 ETA=ALPHA*(T+A(IJ))
      A(IJ)=A(IJ)-ETA
      A(IJ+1)=A(IJ+1)-PSI1*ETA
      IF(I-N1)1020,1040,1040
 1020 A(IP2J)=A(IP2J)-PSI2*ETA
 1040 IJ=IJ+IA
C
C        COLUMN OPERATION
C
      IF(I-N1)1080,1060,1060
 1060 K=N
      GO TO 1100
 1080 K=I+2
 1100 IP=IIP-I
      DO 1180 J=Q,K
      JIP=IP+J
      JI=JIP-IA
      T=PSI1*A(JIP)
      IF(I-N1)1120,1140,1140
 1120 JIP2=JIP+IA
      T=T+PSI2*A(JIP2)
 1140 ETA=ALPHA*(T+A(JI))
      A(JI)=A(JI)-ETA
      A(JIP)=A(JIP)-ETA*PSI1
      IF(I-N1)1160,1180,1180
 1160 A(JIP2)=A(JIP2)-ETA*PSI2
 1180 CONTINUE
      IF(I-N2)1200,1220,1220
 1200 JI=II+3
      JIP=JI+IA
      JIP2=JIP+IA
      ETA=ALPHA*PSI2*A(JIP2)
      A(JI)=-ETA
      A(JIP)=-ETA*PSI1
      A(JIP2)=A(JIP2)-ETA*PSI2
 1220 II=IIP+1
      IT=IT+1
      GO TO 60
C
C        END OF ITERATION
C
1240  IF(DABS(A(NN1))-DABS(A(N1N2))) 1300,1280,1280
C
C        TWO EIGENVALUES HAVE BEEN FOUND
C
 1280 IANA(N)=0
      IANA(N1)=2
      N=N2
      IF(N2)1400,1400,20
C
C        ONE EIGENVALUE HAS BEEN FOUND
C
 1300 RR(N)=A(NN)
      RI(N)=0.0
      IANA(N)=1
      IF(N1)1400,1400,1320
 1320 N=N1
      GO TO 20
1400  CONTINUE
      K=0
      DO 1410 I=1,M
      RRA(I)=RR(I)
      RRI(I)=RI(I)
      DO 1420 J=1,M
      K=K+1
      B(K)=A(K)
1420  CONTINUE
1410  CONTINUE
      RETURN
      END

      SUBROUTINE DPZY(   KB,IZ,I,J1,J2,IFIRST,ILAST,YB,ZB,
     1          AVR,ARB,TH1A,TH2A,NT121,NT122,NBARAY,NCARAY,
     * NZYKB,DPZ,DPY)
C   ***   GENERATES ROWS OF THE SUBMATRICES  DPZ  AND DPY  USING
C         SUBROUTINE  SUBP
      INTEGER Z
      COMPLEX SUM,DPZ(1),DPY(1)
      DIMENSION YB(1),ZB(1),AVR(1),ARB(1),TH1A(1),TH2A(1),NT121(1)
      DIMENSION NT122(1),NBARAY(1),NCARAY(1)
      COMMON /DLBDY/ NJ1,NK1,NP,NB,NTP,NBZ,NBY,NTZ,NTY,NT0,NTZS,NTYS,
     *   INC,INS,INB,INAS,IZIN,IYIN,INBEA1,INBEA2,INSBEA,IZB,IYB,
     *   IAVR,IARB,INFL,IXLE,IXTE,INT121,INT122,IZS,IYS,ICS,IEE,ISG,
     *   ICG,IXIJ,IA,IDELX,IXIC,IXLAM,IA0,IXIS1,IXIS2,IA0P,IRIA
     *  ,INASB,IFLA1,IFLA2,ITH1A,ITH2A,
     *   ECORE,NEXT,SCR1,SCR2,SCR3,SCR4,SCR5
      COMMON /ZZZZZZ / Z(1)
      PI   = 3.1415926
      IX1    = 1
      IZ   = IZ+1
C  IZ  IS THE BODY-ELEMENT NUMBER FOR BODY  KB  --  IZ RUNS FROM  1
C  THROUGH  NBE-SUB-KB
      IX2 = NT122(KB)
      IF (IZ.GE.IFIRST.AND.IZ.LE.ILAST)  IX2=NT121(KB)
      DO  100  IX=IX1,IX2
      L    = 1
      KSP = 0
C  L IS THE PANEL NUMBER ASSOCIATED WITH SENDING   POINT  J
      LS   = 1
C  LS IS THE STRIP NUMBER ASSOCIATED WITH SENDING   POINT  J
      NBXS = NBARAY(L)
      NC1  = NCARAY(L)
      NBCUM= NC1
      IXP1 = IX+1
      IF (IXP1.GT.IX2)  IXP1=IX1
      IXM1 = IX-1
      IF (IXM1.EQ.0)   IXM1=IX2
      IF (IZ.GE.IFIRST.AND.IZ.LE.ILAST)  GO TO  30
      THETA= TH2A(IX)
      THP1 = TH2A(IXP1)
      THM1 = TH2A(IXM1)
      GO TO  40
   30 CONTINUE
      THETA = TH1A(IX)
      THP1 = TH1A(IXP1)
      THM1 = TH1A(IXM1)
   40 CONTINUE
      IF (IX.EQ.IX1)  THM1=THM1-2.0*PI
      IF (IX.EQ.IX2)  THP1=THP1+2.0*PI
      DELTH= 0.5*(THP1 - THM1)
      YREC = YB(KB)+AVR(KB)*COS(THETA)
      ZREC = ZB(KB)+AVR(KB)*ARB(KB)*SIN(THETA)
      RHO  = SQRT(1.0+(ARB(KB)**2 - 1.0) * (COS(THETA))**2)
      SGR  = -ARB(KB)*COS(THETA)/RHO
      CGR  = SIN(THETA)/RHO
      SMULT= SIN(THETA) * RHO / PI
      CMULT= COS(THETA) * RHO / PI
      DO  90  J=J1,J2
      CALL SUBPB(I,L,LS,J,SGR,CGR,YREC,ZREC,SUM,Z(IXIC),Z(IDELX),Z(IEE)
     * ,Z(IXLAM),Z(ISG),Z(ICG),Z(IYS),Z(IZS),Z(INAS),Z(INASB+KSP),
     * Z(IAVR),Z(IZB),Z(IYB),Z(IARB),Z(IXLE),Z(IXTE),Z(IA),NB)
      GO TO  (50,50,60),  NZYKB
   50 CONTINUE
      DPZ(J) = DPZ(J) + SUM * SMULT * DELTH
      IF (NZYKB.EQ.1)  GO TO 70
   60 CONTINUE
      DPY(J) = DPY(J) + SUM * CMULT * DELTH
   70 CONTINUE
      IF (J.EQ.J2)  GO TO  90
      IF (J.LT.NBXS)   GO TO  80
      KSP = KSP + Z(INAS+L-1)
      L    = L+1
      NC1  = NCARAY(L)
      NBXS = NBARAY(L)
   80 CONTINUE
      IF (J.LT.NBCUM)  GO TO  90
      LS   = LS+1
      NBCUM= NBCUM+NC1
   90 CONTINUE
  100 CONTINUE
      RETURN
      END

      SUBROUTINE SJUMP (N)
C
C     JUMP OVER N GROUPS WITHIN AN ITEM WHEN IN READ MODE.  N WILL BE
C     RETURNED AS -1 IF THE END OF ITEM IS REACHED BEFORE JUMPING OVER
C     N GROUPS.
C
      EXTERNAL        ANDF,RSHIFT
      INTEGER         ANDF,RSHIFT,BUF,EOG,EOI,BLKSIZ,DIRSIZ,NMSBR(2)
      COMMON /MACHIN/ MACH,IHALF,JHALF
      COMMON /ZZZZZZ/ BUF(1)
      COMMON /SOF   / DITDUM(6),IO,IOPBN,IOLBN,IOMODE,IOPTR,IOSIND,
     1                IOITCD,IOBLK
      COMMON /SYS   / BLKSIZ,DIRSIZ
      DATA    IRD   / 1   /
      DATA    EOG   , EOI /  4H$EOG ,4H$EOI       /
      DATA    INDSBR/ 17  /, NMSBR  /4HSJUM,4HP   /
C
      CALL CHKOPN (NMSBR(1))
      IF (N .LE. 0) RETURN
      ICOUNT = 0
      IF (IOMODE .EQ. IRD) GO TO 20
      N = -2
      RETURN
C
C     SEARCH THROUGH SOF FOR END OF ITEM AND END OF GROUP.
C
   10 IOPTR = IOPTR + 1
   20 IF (IOPTR .GT. BLKSIZ+IO) GO TO 50
   30 IF (BUF(IOPTR) .NE.  EOI) GO TO 40
      N = -1
      RETURN
C
   40 IF (BUF(IOPTR) .NE. EOG) GO TO 10
      ICOUNT = ICOUNT + 1
      IF (ICOUNT .NE. N) GO TO 10
      IOPTR = IOPTR + 1
      RETURN
C
C     REACHED END OF BLOCK.  REPLACE THE BLOCK CURRENTLY IN CORE BY ITS
C     LINK BLOCK.
C
   50 CALL FNXT (IOPBN,INXT)
      IF (MOD(IOPBN,2) .EQ. 1) GO TO 60
      NEXT = ANDF(RSHIFT(BUF(INXT),IHALF),JHALF)
      GO TO 70
   60 NEXT = ANDF(BUF(INXT),JHALF)
   70 IF (NEXT .EQ. 0) GO TO 510
      IOPBN = NEXT
      IOLBN = IOLBN + 1
      CALL SOFIO (IRD,IOPBN,BUF(IO-2))
      IOPTR = IO + 1
      GO TO 30
  510 CALL ERRMKN (INDSBR,9)
      RETURN
      END

      SUBROUTINE GIGGKS
C
C     THIS SUBROUTINE READS THE SPLINE CARDS AND DETERMINES THE
C     POINTS IN THE G AND K S
C
      INTEGER         BUFF,BUFF1,SYSBUF,BUFF2,EQT(7),
     1                SCARD(5),CCARD(5),SS1(3),LS2(3),CAERO(3),SET1(3),
     2                ST2(3),NS(2),GKSET,TRL(7),TYPE,OUT,SPL3(3),
     3                ATAB(2),PCSTM,PBGPT,PRCP,PTCP,PTE,PRE,CTYP,
     4                SPLINE,USETA,CSTM,BAGPDT,SILA,ECTA,GM,GO,SCR1,
     5                SCR2,SCR3,SCR4,SCR5,NS1,NS2,KSIZE,GSIZE,GTKA
      DIMENSION       C(18),X1B(3),X4B(3),TEMP(3),TEMP1(6),X1E(3),
     1                X4E(3),CB(18),B(6),Z(28)
      DIMENSION       SET2(8),CRARD(16)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG / UFM,UWM,UIM,SFM
      COMMON /SYSTEM/ SYSBUF,OUT
      COMMON /GICOM / SPLINE,USETA,CSTM,BAGPDT,SILA,ECTA ,GM,GO,GTKA,
     1                KSIZE,GSIZE,SCR1,SCR2,SCR3,SCR4,SCR5
      COMMON /CONDAS/ DUM(3),DEGRA
      COMMON /ZZZZZZ/ IZ(1)
C
C     CHANGE IN EQUIV FOR SIZE OF SCARD OR CCARD
C
      EQUIVALENCE    (IZ(1),Z(1),SCARD(1),SET2(1)),(Z(28),NKSET)
      EQUIVALENCE    (Z(11),CCARD(1),CRARD(1))    ,(Z(27),NGSET),
     1               (SET2(3),SP1), (SET2(4),SP2) ,(SET2(5),CH1),
     2               (SET2(6),CH2), (SET2(7),Z1 ) ,(SET2(8),Z2 )
      DATA       C / 18*0.0      /,  SET1   / 3502,35,999/
      DATA     SS1 / 3302,33, 6  /,  LS2    / 3402,34,10 /,
     1         ST2 / 3602,36, 8  /,  CAERO  / 3002,30,16 /
      DATA    SPL3 / 4901,49, 1  /,  ATAB   / 200 ,2     /
      DATA      NS / 4HGIGG,  4HKS          /,IZ2 /2     /
C     DATA    IECT / 3002,46     /
C
C     INITILIZE
C
      CALL SSWTCH (18,I18)
      NWDS = KORSZ(IZ)
      NOGO = 0
      NS1  = 0
      NS2  = 0
      NS3  = 0
C
C     BUFF  HAS SPLINE
C     BUFF1 HAS CSTM,BGPT,EQAERO,SILA,SCR1
C     BUFF2 HAS SCR2
C
      BUFF  = NWDS - SYSBUF - 1
      BUFF1 = BUFF - SYSBUF - 1
      BUFF2 = BUFF1- SYSBUF
C
C     PROCESS SET CARDS AND WRITE G LISTS ON SCR2
C
      IFIL = SCR2
      CALL OPEN (*999,SCR2,IZ(BUFF2+1),1)
      IFIL = SPLINE
      CALL PRELOC (*999,IZ(BUFF+1),SPLINE)
C
C     SET1 CARDS
C
      CALL LOCATE (*340,IZ(BUFF+1),SET1,IDUM)
      N   = 1
      NCO = BUFF2 - N
      CALL READ (*998,*310,SPLINE,IZ(N),NCO,1,NWR)
      GO TO 993
  310 I  = N - 1
      N1 = 0
      ASSIGN 335 TO TYPE
  320 I = I + 1
      IF (IZ(I) .EQ. -1) GO TO 330
      IF (I    .EQ. NWR) GO TO 990
      N1 = N1 + 1
      GO TO 320
  330 IF (N1 .LT. 2) GO TO 9971
      CALL WRITE (SCR2,IZ(N),N1,1)
  335 IF (I .EQ. NWR) GO TO 340
      N  = I + 1
      N1 = 0
      GO TO 320
C
C     SET 2 CARDS
C
  340 CALL LOCATE (*490,IZ(BUFF+1),ST2,IDUM)
C
C     READ IN BAGPDT AND CSTM
C
      N = LS2(3) + CAERO(3) + 1
      TRL(1) = CSTM
      CALL RDTRL (TRL)
      IF (TRL(1) .LT. 0) TRL(3) = 0
      NCSTM = (TRL(3)+1)*14
      PCSTM = BUFF2 - NCSTM
      TRL(1)= BAGPDT
      CALL RDTRL (TRL)
      NBG   = (TRL(2)-TRL(3))*4
      PBGPT = PCSTM - NBG
      IF (PBGPT .LT. N+150) GO TO 993
C
C     READ IN CSTM AT PCSTM + 14 ADD BASIC COORD SYSTEM
C
      IZ(PCSTM  ) = 0
      IZ(PCSTM+1) = 1
      DO 5 I = 2,13
      Z(PCSTM+I) = 0.0
    5 CONTINUE
      Z(PCSTM+5 ) = 1.0
      Z(PCSTM+9 ) = 1.0
      Z(PCSTM+13) = 1.0
      IF (NCSTM .EQ. 14) GO TO 7
      IFIL = CSTM
      CALL GOPEN (CSTM,IZ(BUFF1+1),0)
      CALL READ  (*998,*998,CSTM,IZ(PCSTM+14),NCSTM-14,1,NWR)
      CALL CLOSE (CSTM,1)
    7 CONTINUE
C
C     READ IN BAGPDT AT PBGPT
C
      IFIL = BAGPDT
      CALL GOPEN (BAGPDT,IZ(BUFF1+1),0)
      CALL READ  (*998,*998,BAGPDT,IZ(PBGPT),NBG,1,NWR)
      CALL CLOSE (BAGPDT,1)
C
C     READ IN SET2 CARDS WITH CAERO1 APPENDED
C
      IFIL = SPLINE
      LCA  = 0
      ASSIGN 350 TO TYPE
  350 CALL READ (*998,*490,SPLINE,IZ(1),N-1,0,NWR)
      N1 = 1
      IF (CCARD(1) .EQ. LCA) GO TO 4001
      LCA= CCARD(1)
      K  = PCSTM
      J  = PCSTM + NCSTM - 1
      IF (CCARD(3) .EQ. 0) GO TO 371
      DO 360 I = K,J,14
      IF (CCARD(3) .EQ. IZ(I)) GO TO 370
  360 CONTINUE
      GO TO 990
  370 PRCP = I + 2
      PTCP = I + 5
      CTYP = IZ(I+1)
C
C     LOCATE POINTS 1 AND 4 AS INPUT
C
      GO TO (371,372,373), CTYP
  371 X1B(1) = CRARD(9)
      X1B(2) = CRARD(10)
      X1B(3) = CRARD(11)
      X4B(1) = CRARD(13)
      X4B(2) = CRARD(14)
      X4B(3) = CRARD(15)
      IF (CCARD(3) .EQ. 0) GO TO 390
      GO TO 374
  372 X1B(1) = CRARD( 9)*COS(CRARD(10)*DEGRA)
      X1B(2) = CRARD( 9)*SIN(CRARD(10)*DEGRA)
      X1B(3) = CRARD(11)
      X4B(1) = CRARD(13)*COS(CRARD(14)*DEGRA)
      X4B(2) = CRARD(13)*SIN(CRARD(14)*DEGRA)
      X4B(3) = CRARD(15)
      GO TO 374
  373 X1B(1) = CRARD( 9)*SIN(CRARD(10)*DEGRA)*COS(CRARD(11)*DEGRA)
      X1B(2) = CRARD( 9)*SIN(CRARD(10)*DEGRA)*SIN(CRARD(11)*DEGRA)
      X1B(3) = CRARD( 9)*COS(CRARD(10)*DEGRA)
      X4B(1) = CRARD(13)*SIN(CRARD(14)*DEGRA)*COS(CRARD(15)*DEGRA)
      X4B(2) = CRARD(13)*SIN(CRARD(14)*DEGRA)*SIN(CRARD(15)*DEGRA)
      X4B(3) = CRARD(13)*COS(CRARD(14)*DEGRA)
  374 CALL GMMATS (Z(PTCP),3,3,0, X1B,3,1,0, TEMP)
      X1B(1) = TEMP(1) + Z(PRCP  )
      X1B(2) = TEMP(2) + Z(PRCP+1)
      X1B(3) = TEMP(3) + Z(PRCP+2)
      CALL GMMATS (Z(PTCP),3,3,0, X4B,3,1,0, TEMP)
      X4B(1) = TEMP(1) + Z(PRCP  )
      X4B(2) = TEMP(2) + Z(PRCP+1)
      X4B(3) = TEMP(3) + Z(PRCP+2)
  390 IF (CCARD(2) .EQ. 0) GO TO 399
C
C     FIND ELEMENT COORDINATE SYSTEM
C
      DO 391 I = K,J,14
      IF (CCARD(2) .EQ. IZ(I)) GO TO 392
  391 CONTINUE
      GO TO 990
  392 PRE = I + 2
      PTE = I + 5
      X1B(1) = X1B(1) - Z(PRE  )
      X1B(2) = X1B(2) - Z(PRE+1)
      X1B(3) = X1B(3) - Z(PRE+2)
      X4B(1) = X4B(1) - Z(PRE  )
      X4B(2) = X4B(2) - Z(PRE+1)
      X4B(3) = X4B(3) - Z(PRE+2)
      CALL GMMATS (Z(PTE),3,3,1, X1B(1),3,1,0, X1E)
      CALL GMMATS (Z(PTE),3,3,1, X4B(1),3,1,0, X4E)
      GO TO 400
  399 X1E(1) = X1B(1)
      X1E(2) = X1B(2)
      X4E(1) = X4B(1)
      X4E(2) = X4B(2)
  400 X2E = X1E(1) + CRARD(12)
      Y2E = X1E(2)
      X3E = X4E(1) + CRARD(16)
      Y3E = X4E(2)
C
C     FIND PRISM POINTS
C
 4001 CONTINUE
      PX1 = (1.0-SP1)*(1.0-CH1)*X1E(1) + (1.0-SP1)*CH1*X2E +
     1      SP1*CH1*X3E + SP1*(1.0-CH1)*X4E(1)
      PX2 = (1.0-SP1)*(1.0-CH2)*X1E(1) + (1.0-SP1)*CH2*X2E +
     1      SP1*CH2*X3E + SP1*(1.0-CH2)*X4E(1)
      PX3 = (1.0-SP2)*(1.0-CH2)*X1E(1) + (1.0-SP2)*CH2*X2E +
     1      SP2*CH2*X3E + SP2*(1.0-CH2)*X4E(1)
      PX4 = (1.0-SP2)*(1.0-CH1)*X1E(1) + (1.0-SP2)*CH1*X2E +
     1      SP2*CH1*X3E + SP2*(1.0-CH1)*X4E(1)
C
C     CHECK FOR BAD GEOMETRY
C
      IF (PX1.GT.PX2 .OR. PX4.GT.PX3) GO TO 997
      PY1 = (1.0-SP1)*(1.0-CH1)*X1E(2) + (1.0-SP1)*CH1*Y2E +
     1      SP1*CH1*Y3E + SP1*(1.0-CH1)*X4E(2)
      PY2 = (1.0-SP1)*(1.0-CH2)*X1E(2) + (1.0-SP1)*CH2*Y2E +
     1      SP1*CH2*Y3E + SP1*(1.0-CH2)*X4E(2)
      PY3 = (1.0-SP2)*(1.0-CH2)*X1E(2) + (1.0-SP2)*CH2*Y2E +
     1      SP2*CH2*Y3E + SP2*(1.0-CH2)*X4E(2)
      PY4 = (1.0-SP2)*(1.0-CH1)*X1E(2) + (1.0-SP2)*CH1*Y2E +
     1      SP2*CH1*Y3E + SP2*(1.0-CH1)*X4E(2)
C
C     BUILD PRISM INEQUALITY MATRICES
C
      C(1) = PY1 - PY2
      C(2) = PX2 - PX1
      C(4) = PY2 - PY3
      C(5) = PX3 - PX2
      C(7) = PY3 - PY4
      C(8) = PX4 - PX3
      C(10)= PY4 - PY1
      C(11)= PX1 - PX4
      C(15)= 0.0
      C(18)= 0.0
      B(1) = PX2*PY1 - PX1*PY2
      B(2) = PX3*PY2 - PX2*PY3
      B(3) = PX4*PY3 - PX3*PY4
      B(4) = PX1*PY4 - PX4*PY1
      NR   = 4
      IF (Z1 .EQ. 0.0) GO TO 401
      C(15)=-1.0
      B(5) =-Z1
      NR   = 5
  401 IF (Z2 .EQ. 0.0) GO TO 404
      IF (Z1 .EQ. 0.0) GO TO 403
      C(18)= 1.0
      B(6) = Z2
      NR   = 6
      GO TO 404
  403 C(15)= 1.0
      B(5) = Z2
      NR   = 5
C
C     CONVERT TO BASIC
C
  404 IF (CCARD(2) .EQ. 0) GO TO 406
      CALL GMMATS (C,NR,3,0, Z(PTE),3,3,1, CB)
      CALL GMMATS (Z(PTE),3,3,1, Z(PRE),3,1,0, TEMP)
      CALL GMMATS (C,NR,3,0, TEMP,3,1,0, TEMP1)
      B(1) = B(1) + TEMP1(1)
      B(2) = B(2) + TEMP1(2)
      B(3) = B(3) + TEMP1(3)
      B(4) = B(4) + TEMP1(4)
      IF (NR .EQ. 4) GO TO 405
      B(5) = B(5) + TEMP1(5)
      IF (NR .EQ. 5) GO TO 405
      B(6) = B(6) + TEMP1(6)
      GO TO 405
  406 DO 407 I = 1,18
  407 CB(I) = C(I)
  405 CONTINUE
C
C     FINALLY TEST ALL GRID POINTS TO SEE IF THEY ARE IN PRISM
C
      KK = PBGPT
      KKK= KK + NBG - 1
      DO 440 K = KK,KKK,4
      IF (IZ(K) .EQ. -1) GO TO 440
      JJ = 0
      DO 430 I = 1,NR
      SUM = 0.0
      DO 420 J = 1,3
      JJ  = JJ + 1
      SUM = SUM + CB(JJ)*Z(K+J)
  420 CONTINUE
      IF (SUM .LT. B(I)) GO TO 440
  430 CONTINUE
C
C     FOUND ONE
C
      N1 = N1 + 1
      IZ(N1) = (K-PBGPT)/4 + 1
  440 CONTINUE
      IF (N1  .LT. 2) GO TO 997
      IF (I18 .EQ. 0) GO TO 446
      WRITE  (OUT,445) (IZ(II),II=1,N1)
  445 FORMAT (5H0SET2 ,I8,2X,(/,10I9))
  446 CONTINUE
      CALL WRITE (SCR2,IZ(1),N1,1)
      GO TO 350
  490 CALL CLOSE (SCR2,1)
      CALL OPEN  (*999,SCR2,IZ(BUFF2+1),0)
      NEQ = KSIZE*3
      EQT(1) = SILA
      CALL RDTRL (EQT)
      NSIL = EQT(2)
      IEQ  = BUFF2 - NEQ - NSIL
C
C     INITIAL CORE CHECK  PLUS FUDGE FACTOR
C
      IF (IEQ-150 .LT. 0) GO TO 993
C
C     READ SPLINE FOR K POINT POINTERS
C
C     READ SILA
C
      CALL LOCATE (*990,IZ(BUFF+1),ATAB,IDUM)
      CALL READ (*998,*11,SPLINE,IZ(IEQ),NEQ+1,0,NWR)
      GO TO 990
   11 NEQ  = NWR
      IFIL = SILA
      CALL GOPEN (SILA,IZ(BUFF1+1),0)
      CALL READ  (*998,*998,SILA,IZ(IEQ+NEQ),NSIL,1,NWR)
      CALL CLOSE (SILA,1)
      IFIL  = SPLINE
      TRL(1)= SCR1
      MAX   = 0
      CALL GOPEN (SCR1,IZ(BUFF1+1),1)
C
C     N = LENGTH OF LONGEST SPLINE CARD + CAERO1 CARD + 3
C     N  POINTS TO 1 ST LOCATION OF CORE AVAILABLE SEE EQIV
C
      N   = LS2(3) + CAERO(3) + 3
      NCO = IEQ - N
C
C     READ SPLINE1 CARDS
C
      CALL LOCATE (*100,IZ(BUFF+1),SS1,IDUM)
      ASSIGN 10 TO TYPE
      NR = LS2(3) + CAERO(3)
   10 CALL READ (*998,*100,SPLINE,IZ(1),NR,0,NWR)
      NS1 = NS1 + 1
      ASSIGN 30 TO GKSET
      GO TO 300
C
C     G AND K SET ARE IN CORE SORTED  BY INTERNAL NUMBERS
C     A SECOND SET OF G   ARE SORTED  BY SIL NUMBERS
C     A SECOND SET OF K   ARE IN CORE BY K NUMBER
C     NK POINTS TO K SET
C     N1 IS FIRST LOCATION OF OPEN CORE
C     NGSET IS THE NUMBER OF G  NKSET FOR K
C
   30 IF (NOGO .EQ. 1) GO TO 10
C
C     WRITE ALL SPLINE1 DATA ON SCR1 AS PROCESSED
C     ID OF SPLINE1 = 1
C
      IZ(IZ2) = 1
      NW  = N1 - 1
      MAX = MAX0(MAX,NW)
      CALL WRITE (SCR1,IZ(1),NW,1)
      GO TO 10
C
C     END OF SPLINE1 CARDS
C
C     READ SPLINE2 CARDS
C
  100 CALL LOCATE (*190,IZ(BUFF+1),LS2,IDUM)
      ASSIGN 110 TO TYPE
      NR = LS2(3) + CAERO(3)
  110 CALL READ (*998,*190,SPLINE,IZ(1),NR,0,NWR)
      NS2 = NS2 + 1
      ASSIGN 120 TO GKSET
      GO TO 300
C
C     ID OF SPLINE2 = 2
C
  120 IF (NOGO .EQ. 1) GO TO 110
      IZ(IZ2) = 2
      NW  = N1 - 1
      MAX = MAX0(MAX,NW)
      CALL WRITE (SCR1,IZ(1),NW,1)
      GO TO 110
C
C     END OF SPLINE2 CARDS
C
  190 CALL CLOSE (SCR1,1)
      CALL CLOSE (SCR2,1)
      CALL GOPEN (SCR3,IZ(BUFF1+1),1)
C
C     SPLINE 3 CARDS TO SCR3
C
      CALL LOCATE (*290,IZ(BUFF+1),SPL3,IDUM)
      CALL READ (*998,*200,SPLINE,IZ,IEQ,0,NS3)
      GO TO 993
  200 N = NS3 + 1
C
C     CONVERT AERO IDS TO K COLUMN NUMBERS, BUILD A LIST OF SPLINE CARD
C     POINTERS, SORT ON K COLUMNS, PROCESS CARDS IN SORTED ORDER GET
C     G POINTS TO SILS
C
      N1 = 1
      NW = IEQ - 1
      ASSIGN 240 TO TYPE
      I = N
  210 K = IZ(N1+3)
      DO 220 J = 1,NEQ,3
      IF (K .EQ. IZ(NW+J)) GO TO 230
  220 CONTINUE
      GO TO 992
  230 IZ(N1+3) = IZ(NW+J+2)
      IZ(I   ) = N1
      IZ(I +1) = IZ(N1+3)
      I  = I+2
  240 N1 = N1 + IZ(N1) + 1
      IF (N1 .GE. NS3) GO TO 250
      GO TO 210
  250 NW  = I - N
      NS3 = NW/2
      IF (NS3 .EQ. 0) GO TO 1001
      IF (NS3 .EQ. 1) GO TO 255
      CALL SORT (0,0,2,2,IZ(N),NW)
C
C     PROCESS BY SORTED ORDER
C
  255 N  = N - 1
      J  = IEQ + NEQ - 1
      JJ = 5
      DO 280 I = 1,NW,2
      N1 = IZ(N+I)
      JJJ= IZ(N1) - CAERO(3)
      DO 260 K = JJ,JJJ,3
      L  = IZ(N1+K)
      IZ(N1+K) = IZ(J+L)
  260 CONTINUE
      CALL WRITE (SCR3,IZ(N1+1),IZ(N1),1)
  280 CONTINUE
  290 CALL CLOSE (SPLINE,1)
      CALL CLOSE (SCR3,1)
      CALL DMPFIL (SCR1,Z,NWDS)
      CALL DMPFIL (SCR3,Z,NWDS)
      TRL(2) = MAX
      TRL(3) = NS1 + NS2
      CALL WRTTRL (TRL)
      IF (NOGO .EQ. 1) GO TO 1001
      IF (NS1.EQ.0 .AND. NS2.EQ.0 .AND. NS3.EQ.0) GO TO 990
      GO TO 1000
C
C     SET 1 CARDS
C     SET 2 CARDS
C
  300 NGSET = 0
      IFIL  = SCR2
  301 CALL READ (*996,*996,SCR2,IZ(N),1,0,NWR)
      IF (SCARD(5) .EQ. IZ(N)) GO TO 305
      CALL FWDREC (*998,SCR2)
      GO TO 301
  305 CALL READ (*998,*306,SCR2,IZ(N),NCO,1,NWR)
      GO TO 993
  306 CALL REWIND (SCR2)
      IFIL  = SPLINE
      NGSET = NWR
      N1 = N+NGSET
      CALL SORT (0,0,1,1,IZ(N),NGSET)
C
C     GET K SET
C
      NK   = N1 -1
      NKSET= 0
      NMIN = SCARD(3)
      NMAX = SCARD(4)
      NCORD= CCARD(5)
      IFRST= CCARD(1)
      IF (NMIN .GT. NMAX) GO TO 990
      J1 = NCORD*CCARD(4) + IFRST - 1
      IF (NMIN.LT.IFRST .OR. NMAX.GT.J1) GO TO 990
      J1 = (NMIN-IFRST)/NCORD + 1
      I1 = (NMIN-IFRST) - NCORD*(J1-1) + 1
      JL = (NMAX-IFRST)/NCORD + 1
      IL = (NMAX-IFRST) - NCORD*(JL-1) + 1
      DO 530 J = J1,JL
      DO 520 I = I1,IL
      IZ(N1) = IFRST + (I-1) + NCORD*(J-1)
      N1 = N1 + 1
      NKSET = NKSET + 1
  520 CONTINUE
  530 CONTINUE
C
C     MAKE A LIST OF SIL NUMBERS   FOR G SET
C
      NW = NGSET
      J = IEQ + NEQ - 1
      DO 610 I = 1,NW
      K = IZ(N+I-1)
      IZ(N1) = IZ(K+J)
      N1 = N1 + 1
  610 CONTINUE
C
C     FIND INTERNAL K POINT NUMBER  FOR BGPT PLUS K NUMBER
C
      JJ = 1
      NW = IEQ - 1
      DO 560 I = 1,NKSET
      DO 540 J = JJ,NEQ,3
      IF (IZ(NK+I) .EQ. IZ(NW+J)) GO TO 550
  540 CONTINUE
      GO TO 991
  550 JJ = J
      IZ(NK+I) = IZ(NW+J+1)
      IZ(N1  ) = IZ(NW+J+2)
      N1 = N1 + 1
  560 CONTINUE
      GO TO GKSET, (30,120)
C
C     ERROR MESSAGES
C
  999 CALL MESAGE (-1,IFIL,NS)
  998 CALL MESAGE (-3,IFIL,NS)
  993 CALL MESAGE (-8,0,NS)
  990 CALL MESAGE (-7,0,NS)
 9971 SCARD(1) = IZ(N)
  997 WRITE  (OUT,9970) UWM,SCARD(5),SCARD(1)
 9970 FORMAT (A25,' 2257, SET',I9,' REFERENCED ON SPLINE CARD',I9,
     1       ' IS EMPTY.')
      GO TO 901
  996 WRITE  (OUT,9960) UFM,SCARD(5),SCARD(1)
 9960 FORMAT (A23,' 2258, SET',I9,' REFERENCED ON SPLINE CARD',I9,
     2       ' NOT FOUND OR IT IS EMPTY.')
      CALL REWIND (SCR2)
      GO TO 900
  991 WRITE  (OUT,9910) SFM,IZ(NK+I-1),CCARD(1)
 9910 FORMAT (A25,' 2259, POINT ASSIGNED TO BOX',I9,' FOR CAER01',I9,
     1       ' NOT IN EQAERO.')
      GO TO 900
  992 WRITE (OUT,9910) K,IZ(N1+2)
      GO TO 900
 1001 CALL MESAGE (-61,0,NS)
  900 NOGO = 1
  901 GO TO TYPE, (10,100,240,335,350)
 1000 RETURN
      END

      SUBROUTINE DSSPOS( FILE, KCBLK, KCLR, KCBP )
C
C DSSPOS REPOSITIONS THE "FILE" TO BLOCK "KCBLK" WITH THE CURRENT
C LOGICAL RECORD POINTER SET TO "KCLR" AND THE CURRENT BUFFER
C POINTER SET TO "KCBP"
C
      INCLUDE 'DSIOF.COM'
      INCLUDE 'XNSTRN.COM'
      INTEGER    FILE
      NAME  = FILE
      CALL DSGEFL
      ICBLK  = FCB( 4, IFILEX )
      IF ( ICBLK .EQ. KCBLK ) GO TO 10
      NBLOCK = KCBLK
      CALL DBMMGR( 6 )
10    CONTINUE
      INDCLR = KCLR + INDBAS - 1
      INDCBP = KCBP + INDBAS - 1
      CALL DSSDCB
      RETURN
      END

      SUBROUTINE EANDM (ITYPE,IDO,NEXTZ,LCORE,NBDYS,ALL,NELOUT)
C
C     COMPUTES ADDITIONAL LOAD IN ZIEKIEWICZ PAPER DUE TO SPECIFIED
C     MAGNETIC FIELD OR CURRENT LOOP
C
C     ITYPE = 20  SPCFLD
C     ITYPE = 21  CEMLOOP
C     ITYPE = 22  GEMLOOP
C     ITYPE = 23  MDIPOLE
C     ITYPE = 24  REMFLUX
C     IDO   = NUMBER OF CARDS OF PRESENT TYPE
C     NEXTZ = NEXT AVAILABLE POINTER INTO OPEN CORE
C     LAST AVAILABLE POINTER INTO OPEN CORE
C     *** ALL CEMLOOP, SPCFLD, GEMLOOP, AND MDIPOLE CARDS WERE COMBINED
C     INTO ONE SPCFLD-TYPE CARD WITH 3*NROWSP WORDS-HCX, HCY, HCZ AT
C     EACH POINT AND IS INDICATED BY ITYPE =-20. THESE 3*NROWSP WORDS
C     ARE WRITTEN TO HCFLDS FOR LATER USE. THE OTHER CARDS ARE STILL ON
C     SLT FOR USE IN THE NUMERICAL INTEGRATION.
C
      LOGICAL         DONE
      INTEGER         FILE,BUF1,SYSBUF,EST,SLT,ELTYPE,ESTWDS,OUTPT,SCR6,
     1                HCFLDS,MCB(7),REMFLS,MCB1(7),MCB2(7)
      DIMENSION       IZ(1),NAM(2),NECPT(1),NAME(2)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /BLANK / NROWSP
      COMMON /SYSTEM/ KSYSTM(64)
      COMMON /EMECPT/ ECPT(200)
      COMMON /PACKX / ITA,ITB,II,JJ,INCUR
      COMMON /ZBLPKX/ A(4),IROW
      COMMON /ZZZZZZ/ Z(1)
      COMMON /GPTA1 / NELEMS,LAST,INCR,NE(1)
      EQUIVALENCE     (KSYSTM(1),SYSBUF),(KSYSTM(2),OUTPT),(Z(1),IZ(1)),
     1                (KSYSTM(56),ITHRML),(ECPT(1),NECPT(1))
      DATA    NAM   / 4HEAND,4HM              /
      DATA    EST   , SLT, HCFLDS,REMFLS,SCR6 /
     1        105   , 205, 304,   305,   306  /
      DATA    MCB   / 304, 0, 0, 2, 1, 0, 0   /
      DATA    MCB1  / 305, 0, 0, 2, 1, 0, 0   /
      DATA    DONE  / .FALSE.                 /
C
C     CHECK IF THERMAL FORMULATION
C
      IF (ITHRML .EQ. 0) RETURN
C
C     READ A CARD TYPE FROM SLT. TYPE=-20 IS THE COMBINATION HC FOR ALL
C     CARD TYPES EXCEPT REMFLUX AND SIGNIFIES END OF A SUBCASE. READ AND
C     PACK IT. SAME FOR TYPE = 24(REMFLUX). FOR TYPES 20-24, COMPUTE
C     LOAD = INTEGRAL(GRAD(NI)*MU*HC)*D(VOL). WE WILL USE NUMERICAL
C     INTEGRATION FOR ITYPE=24-REMFLUX-ONLY ONE CARD GIVING FLUX IN
C     EACH ELEMENT COMPUTE INTEGRAL(GRAD NI*BR)*D(VOL)
C
      BUF1  = LCORE - SYSBUF + 1
      ICORE = BUF1  - 1
      IF (NEXTZ .GT. BUF1) GO TO 420
C
      IF (ITYPE.NE.-20 .AND. ITYPE.NE.24) GO TO 40
      IF (IDO .NE. 1) GO TO 300
C
C     END OF SUBCASE-WRAP UP SCR6 AND CALL HCCOM TO COMBINE CENTROID
C     RESULTS IF NOT REMFLUX, CALL HCCOM NOW.IF REMFLUX, WAIT UNTIL
C     KCOUNT IS SET.
C
      CALL CLOSE (SCR6,1)
      IF (ITYPE.EQ.-20) CALL HCCOM (ITYPE,LCORE,ICORE,NEXTZ,KCOUNT)
      JJ = NROWSP
C
C     ITYPE=-20 OR +24--END OF SUBCASE. IF +24, WRITE ZEROS TO HCFLDS
C     AND HCCENS AND REMFLUX VECTOR TO REMFLS. THEN CONTINUE ON TO
C     COMPUTE LOADS. IF ITYPE=-20, WRITE ZRROS TO REMFLS, GRID POINT
C     HC VALUES TO HCFLDS AND CENTROIDAL VALUES TO HCCENS (ALREADY DONE
C     IN HCCOM). FOR ITYPE=-20, NO FURTHER PROCESSING IS DONE SINCE
C     LOADS HAVE ALREADY BEEN COMPUTED.
C
      ITA = 1
      ITB = 1
      II  = 1
      JJ  = 3*NROWSP
      INCUR  = 1
      MCB(3) = JJ
      MCB2(1)= EST
      CALL RDTRL (MCB2)
      NEL = MCB2(2)
      JJ1 = 3*NEL
      MCB1(3)= JJ1
C
C     READ IN THE ONE SPCFLD OR REMFLUX-TYPE CARD
C
      NWORDS = 3*NROWSP
      IF (ITYPE .NE. 24) GO TO 10
      NWORDS = 3*NEL
      JJ  = NWORDS
      JJ1 = 3*NROWSP
   10 ISTART = NEXTZ
      IF (NEXTZ+NWORDS-1 .GT. ICORE) GO TO 420
      CALL FREAD (SLT,Z(NEXTZ),NWORDS,0)
C
C     CREATE A ZERO VECTOR FOR EITHER REMFLS OR HCFLDS(WHICHEVER IS NOT
C     USED IN THIS SET ID-REMEMBER THAT SPCFLD AND REMFLUX CANNOT HAVE
C     THE SAME SET ID
C
C     PACK THE 3*NROWSP HC FIELD OUT TO BE USED LATER BY EMFLD. HCFLDS
C     WILL CONTAIN ONE COLUMN PER CASE CONTROL SIMPLE SELECTION
C     (SIMPLE LOADS ON LOAD CARDS ARE INCLUDED). COMBIN WILL COMBINE
C     FOR LOAD BULK DATA CARDS AND PUT LOADS IN ORDER OF SELECTION ONTO
C     HCFL (SAME HOLDS FOR 3*NEL WORDS OF REMFLS)
C
      IF (ITYPE .EQ. 24) GO TO 20
      CALL PACK (Z(NEXTZ),HCFLDS,MCB)
      CALL WRTTRL (MCB)
      JJ = JJ1
      CALL BLDPK  (1,1,REMFLS,0,0)
      CALL BLDPKN (REMFLS,0,MCB1)
      CALL WRTTRL (MCB1)
      GO TO 30
   20 CALL PACK(Z (NEXTZ),REMFLS,MCB1)
      CALL WRTTRL (MCB1)
      JJ = JJ1
      CALL BLDPK  (1,1,HCFLDS,0,0)
      CALL BLDPKN (HCFLDS,0,MCB)
      CALL WRTTRL (MCB)
C
C     RETURN JJ TO VALUE EXPECTED IN EXTERN
C
   30 JJ = NROWSP
      IF (ITYPE .EQ. -20) RETURN
C
C     GET INFO FROM EST
C
   40 FILE = EST
      CALL GOPEN (EST,Z(BUF1),0)
      NCOUNT = 0
      IF (.NOT.DONE) KCOUNT = 0
C
C     READ IN ALL CARDS OF THIS TYPE FOR THIS SUBCASE. NO NEED TO READ
C     IN THE ONE REMFLUX CARD SINCE IT WAS DONE ABOVE.
C
      IJK = ITYPE - 19
      GO TO (50,60,70,80,100), IJK
   50 IWORDS = 3*NROWSP
      IF (IDO .NE. 1) GO TO 300
      GO TO 90
   60 IWORDS = 12
      GO TO 90
   70 IWORDS = 48
      GO TO 90
   80 IWORDS = 9
   90 NWORDS = IWORDS*IDO
      IF (NEXTZ+NWORDS-1 .GT. ICORE) GO TO 420
      CALL FREAD (SLT,Z(NEXTZ),NWORDS,0)
      ISTART = NEXTZ
C
  100 CALL READ (*260,*410,EST,ELTYPE,1,0,IFLAG)
      IDX = (ELTYPE-1)*INCR
      ESTWDS = NE(IDX+12)
      NGRIDS = NE(IDX+10)
      NAME(1)= NE(IDX+1)
      NAME(2)= NE(IDX+2)
C
  120 CALL READ (*400,*100,EST,ECPT,ESTWDS,0,IFLAG)
      NCOUNT = NCOUNT + 1
      IF (DONE) GO TO 130
      IF (ELTYPE .LT. 65) KCOUNT = KCOUNT + 3
      IF (ELTYPE .EQ. 65) KCOUNT = KCOUNT + 27
      IF (ELTYPE.EQ.66 .OR. ELTYPE.EQ.67) KCOUNT = KCOUNT + 63
      IF (ELTYPE .EQ. 80) KCOUNT = KCOUNT + 27
C
  130 IF (ELTYPE .GT. 80) GO TO 230
      GO TO (200,230,200,230,230,210,230,230,210,200,
     1       230,230,230,230,230,210,210,210,210,230,
     2       230,230,230,230,230,230,230,230,230,230,
     3       230,230,230,200,230,210,210,230,220,220,
     4       220,220,230,230,230,230,230,230,230,230,
     5       230,230,230,230,230,230,230,230,230,230,
     6       230,230,230,230,220,220,220,230,230,230,
     7       230,230,230,230,230,230,230,230,230,210), ELTYPE
C
  200 CALL EM1D (ELTYPE,ISTART,ITYPE,NCOUNT,IDO,IWORDS,NBDYS,ALL,NELOUT)
      GO TO 120
  210 CALL EM2D (ELTYPE,ISTART,ITYPE,NCOUNT,IDO,IWORDS,NBDYS,ALL,NELOUT)
      GO TO 120
  220 CALL EM3D (ELTYPE,ISTART,ITYPE,NCOUNT,IDO,IWORDS,NBDYS,ALL,NELOUT)
      GO TO 120
C
  230 WRITE  (OUTPT,240) UFM,NAME
  240 FORMAT (A23,', ELEMENT TYPE ',2A4,' WAS USED IN AN E AND M ',
     1       'PROBLEM. NOT A LEGAL TYPE')
  250 CALL MESAGE (-61,0,0)
C
C     DONE
C
  260 CALL CLOSE (EST,1)
      IF (ITYPE .EQ. 24) GO TO 270
      CALL WRITE (SCR6,0,0,1)
      GO TO 280
  270 CALL HCCOM (ITYPE,LCORE,ICORE,NEXTZ,KCOUNT)
      JJ = NROWSP
  280 DONE =.TRUE.
      RETURN
C
C     FATAL ERROR MESSAGES
C
  300 WRITE  (OUTPT,310) UFM,NAM
  310 FORMAT (A23,', LOGIC ERROR IN SUBROUTINE ',2A4,
     1       '. ONLY ONE SPCFLD OR REMFLUX SHOULD NOW EXIST')
      GO TO 250
C
  400 N = -2
      GO TO 430
  410 N = -3
      GO TO 430
  420 N = -8
      FILE = 0
  430 CALL MESAGE (N,FILE,NAM)
      RETURN
      END

        SUBROUTINE DSGNWR
        COMMON /SYSTEM/ ISYBUF, IWR
      INCLUDE 'XNSTRN.COM'
      INCLUDE 'GINOX.COM'
      INCLUDE 'DSIOF.COM'
        CHARACTER*4     CBUFF(3)
        EQUIVALENCE     (CBUFF,IBASE)
        IDSN   = MDSFCB( 2,IFILEX )
        IDSNR  = IDSN
   10   ISTRB  = FCB( 5,IDSNR  )
        IF ( NBLOCK .GE. ISTRB ) GO TO 20
        INEXT  = MDSFCB( 3,IDSNR  ) / MULQ2
        GO TO 40
   20   IALLOC = FCB( 7, IDSNR )
        IF ( NBLOCK .LE. ( IALLOC+ISTRB-1 ) ) GO TO 50
        IF ( IDSN .EQ. 8 ) CALL DSMSG( 9 )
        INEXT  = IAND( MDSFCB( 3,IDSNR ), MASKH2 )
        IF ( INEXT .NE. 0 ) GO TO 40
        MAXPR1 = MAXPRI + 1
        DO 30 I = MAXPR1, MAXFCB
        IAVAIL = MDSFCB( 3,I )
        IF ( IAVAIL .NE. 0 ) GO TO 30
        IFIRST = IALLOC + ISTRB
        IALLOC = 20000000
        FCB( 5,I ) = IFIRST
        FCB( 6,I ) = IFIRST-1
        MDSFCB( 3,I ) = IDSNR * MULQ2
        INEXT  = I
        MDSFCB( 3,IDSNR ) = IOR( MDSFCB( 3,IDSNR ), I )
        GO TO 40
   30   CONTINUE
   40   IDSNR  = INEXT
        IF ( IDSNR .GE. 1 .AND. IDSNR .LE. MAXDSN ) GO TO 10
        CALL DSMSG ( 122 )
   50   IF ( IDSN .EQ. IDSNR ) GO TO 60
        CALL DSCLOS( IDSN )
        MDSFCB( 1,IDSN ) = IAND( MDSFCB( 1,IDSN ), MASKH1 )
        IDSN   = IDSNR
        MDSFCB( 1,IDSN )   =  IOR( MDSFCB( 1,IDSN ), MASKH2 )
        MDSFCB( 2,IFILEX ) = IDSN
        CALL DSMSG( 8 )
        IDEVIC = 0
        DO 55 KK = 1, NUMDEV
        MDSNAM(IDSN)(1:2) = DEV(KK)
        ISAVE = IOP
        IOP = 0
        CALL DSOPEN( MDSNAM( IDSN ), IDSN, IOP )
        IOP = ISAVE
        CBUFF( INDBAS ) = MDSNAM( IDSN )
        CALL DSWRIT( IDSN, IBASE( INDBAS+3 ), NBUFF, IOBLK, ICCER )
        IF ( ICCER .EQ. 0 ) GO TO 60
        CALL DSCLOS (IDSN)
   55   CONTINUE
   57   WRITE ( IWR, 901 )
  901   FORMAT(///,' NO MORE DISK SPACE AVAILABLE, JOB ABORTED.')
        CALL DSMSG( 122 )
   60   IOBLK  = NBLOCK - ISTRB + 1
        CALL DSWRIT( IDSN, IBASE( INDBAS+3 ), NBUFF, IOBLK, ICCER )
        IF ( ICCER .NE. 0 ) GO TO 70
        LASBLK = FCB( 6,IDSN )
        IF ( LASBLK .GE. NBLOCK ) GO TO 7000
        FCB( 6,IDSN ) = FCB( 6,IDSN ) + 1
        GO TO 7000
   70   IF ( ICCER .NE. 28 ) CALL DSMSG( 101 )
        IF ( IDSN .LE. 21 .AND. IDSN .NE. 8 .AND. IDSN .NE. 9) GO TO 80
C ALLOW XPDT TO EXTEND (IDSN=9)---NOTE IDSN=8 IS THE NPTP
        ITEST = INDEX( MDSNAM(8), 'ZAP' )
        IF ( IDSN .EQ. 8  .AND. ITEST .EQ. 0 ) GO TO 80
        FCB( 7,IFILEX ) = FCB( 6,IFILEX )
        IDSNR = IDSN
        GO TO 10
   80   WRITE ( IWR, 902 )
  902   FORMAT(///,' NO MORE DISK SPACE AVAILABLE IN DEFAULT DIRECTORY',
     &             ' FOR PERMANENT FILES',/,' JOB ABORTED')
        CALL DSMSG( 122 )
 7000   RETURN
        END

      SUBROUTINE MERGE1
C
C     THIS IS THE DMAP MODULE MERGE WHICH MERGES 1 TO 4 PARTITIONS
C     A11, A21, A12, A22, INTO A SINGLE MATRIX -A-.
C
C          **                  **           **                  **
C          *       I            *           *                    *
C          *  A11  I    A12     *           *                    *
C          *       I            *           *                    *
C          * ------+----------- *  BECOMES  *          A         *
C          *       I            *           *                    *
C          *       I            *           *                    *
C          *  A21  I    A22     *           *                    *
C          *       I            *           *                    *
C          **                  **           **                  **
C
C     BASED ON THE ZEROS AND NON-ZEROS IN THE ROW PARTITIONING VECTOR
C     -RP- AND THE COLUMN PARTITIONING VECTOR -CP-.
C
C     DMAP CALLING SEQUENCE.
C
C     MERGE  A11,A21,A12,A22,CP,RP/ A /V,Y,SYM  /V,Y,TYPE/V,Y,FORM/
C                                      V,Y,CPCOL/V,Y,RPCOL  $
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        RSHIFT  ,ANDF
      LOGICAL         CPNULL  ,RPNULL   ,CPHERE   ,RPHERE   ,ONLY    ,
     1                PASS
      DIMENSION       SUBR(2) ,HEAD(2)  ,AIJ(4)   ,MCB(7,4) ,MCBA(7) ,
     1                ELEM1(4),ELEM2(4 ),REFUS(3) ,BLOCK(80)
      CHARACTER       UFM*23  ,UWM*25   ,UIM*29   ,SFM*25   ,SWM*27
      COMMON /XMSSG / UFM     ,UWM      ,UIM      ,SFM      ,SWM
      COMMON /SYSTEM/ SYSBUF  ,OUTPT    ,XXX(37)  ,NBPW
      COMMON /NAMES / RD      ,RDREW    ,WRT      ,WRTREW   ,CLSREW  ,
     1                CLS
      COMMON /ZBLPKX/ ELEM(4) ,ROW
      COMMON /PRTMRG/ CPSIZE  ,RPSIZE   ,CPONES   ,RPONES   ,CPNULL  ,
     1                RPNULL  ,CPHERE   ,RPHERE   ,ICP      ,NCP     ,
     2                IRP     ,NRP
      COMMON /ZZZZZZ/ Z(1)
      COMMON /BLANK / SYM     ,TYPE     ,FORM     ,CPCOL    ,RPCOL   ,
     1                DUMFOR(3)         ,IREQCL
      DATA    SUBR  / 4HMERG  ,4HE1   /, EOR    / 1      /
      DATA    AIJ   / 101,102 ,103,104/, CP,RP  / 105,106/     ,A /201/
      DATA    NAFORM/ 4HFORM /,NATYPE /  4HTYPE /,REFUS/2*3H   ,3HREF /
C
C     OPEN MATRICES TO BE MERGED.  IF ALL ARE PURGED, RETURN IS MADE.
C
      CORE = KORSZ(Z)
      M = 0
      DO 20 I = 1,4
      KFILE = AIJ(I)
      MCB(1,I) = KFILE
      CALL RDTRL (MCB(1,I))
      IF (MCB(1,I)) 20,20,10
   10 BUFF = CORE - SYSBUF - 2
      CORE = BUFF - 1
      IF (CORE .LT. 10) CALL MESAGE (-8,0,SUBR)
      CALL OPEN (*20,KFILE,Z(BUFF),RDREW)
      CALL SKPREC (KFILE,1)
      M = 1
   20 CONTINUE
      IF (M .EQ. 0) RETURN
      BUFF = CORE - SYSBUF - 2
      CORE = BUFF - 1
      IF (CORE .LT. 10) CALL MESAGE (-8,0,SUBR)
      CALL OPEN (*440,A,Z(BUFF),WRTREW)
      CALL CLOSE (A,CLSREW)
C
C     CALL TO PARTN2 WILL PROCESS -CP- AND -RP- INTO BIT STRINGS AND
C     DETERMINE SIZES OF PARTITIONS REQUIRED.
C
C     STANDARDISE BLANK COMMON FOR PARTN2 CALLS FROM MERGE1-PARTN1
C
      DUMFOR(2) = CPCOL
      DUMFOR(3) = RPCOL
      CALL PARTN2 (CP,RP,CORE,Z(BUFF))
      CPCOL = DUMFOR(2)
      RPCOL = DUMFOR(3)
C
C     IF CPSIZE OR RPSIZE IS 0 AS A RESULT OF A NULL VECTOR (PURGED
C     VECTOR) THERE SIZE IS ESTIMATED HERE FROM THEIR RESPECTIVE
C     PARTITIONS.
C
      IF (CPSIZE .NE. 0) GO TO 24
      IF (MCB(1,1)) 25,25,23
   23 CPSIZE = MCB(2,1)
      GO TO 24
C
   25 IF (MCB(1,2)) 24,24,26
   26 CPSIZE = MCB(2,2)
      GO TO 24
C
   24 IF (RPSIZE .NE. 0) GO TO 29
      IF (MCB(1,1)) 21,21,22
   22 RPSIZE = MCB(3,1)
      GO TO 29
C
   21 IF (MCB(1,3)) 29,29,27
   27 RPSIZE = MCB(3,3)
C
C     MATRIX COMPATIBILITY CHECKS.
C
   29 CPZERO = CPSIZE - CPONES
      RPZERO = RPSIZE - RPONES
      IPR    = 1
      IRLCX  = 0
      DO 70 I = 1,4
      IF (MCB(1,I)) 70,70,30
   30 COLS = MCB(2,I)
      ROWS = MCB(3,I)
      ICOL = CPZERO
      IROW = RPZERO
      IF (MCB(5,I).EQ.2 .OR. MCB(5,I).EQ.4) IPR   = 2
      IF (MCB(5,I).EQ.3 .OR. MCB(5,I).EQ.4) IRLCX = 2
      IF (I.EQ.3 .OR. I.EQ.4) ICOL = CPONES
      IF (I.EQ.2 .OR. I.EQ.4) IROW = RPONES
      IF (ICOL) 70,70,40
   40 IF (IROW) 70,70,50
C
C     CHECK PARTITION SIZE WITH PARTITIONING VECTOR DEMANDS.
C
   50 IF (ROWS.EQ.IROW .AND. COLS.EQ.ICOL) GO TO 70
      WRITE  (OUTPT,60) SWM,AIJ(I),ROWS,COLS,IROW,ICOL
   60 FORMAT (A27,' 2161, PARTITION FILE',I4,' IS OF SIZE',I10,
     1       ' ROWS BY',I10,' COLUMNS.', /5X,'PARTITIONING VECTORS ',
     2       'INDICATE THAT THIS PARTITION SHOULD BE OF SIZE',I10,
     3       ' ROWS BY',I10,' COLUMNS FOR A SUCCESSFUL MERGE.')
   70 CONTINUE
C
C     CHECK OF FORM VALUE.
C
      NFORM = FORM
      IF (NFORM.LT.1 .OR. NFORM.GT.8) GO TO 120
      GO TO (80,140,110,80,80,80,110,80), NFORM
C
C     FORM = SQUARE
C
   80 IF (CPSIZE .EQ. RPSIZE) GO TO 140
   90 WRITE  (OUTPT,100) SWM,NFORM,RPSIZE,CPSIZE
  100 FORMAT (A27,' 2162, THE FORM PARAMETER AS GIVEN TO THE MERGE ',
     1       'MODULE IS INCONSISTANT WITH THE SIZE OF THE', /5X,
     2       'MERGED MATRIX, HOWEVER IT HAS BEEN USED.  FORM =',I9,
     3       ' SIZE =',I10,' ROWS BY',I10,' COLUMNS.')
      GO TO 140
  110 IF (CPSIZE .EQ. 1) GO TO 140
      GO TO 90
  120 NFORM = 2
      IF (ROWS.NE.COLS .AND. CPSIZE.NE.RPSIZE) GO TO 122
      NFORM = 1
      IF (SYM .LT. 0) NFORM= 6
  122 IF (FORM.EQ.0 .OR. FORM.EQ.NFORM) GO TO 132
      WRITE  (OUTPT,130) SWM,NAFORM,FORM,REFUS(3),SUBR,NFORM
  130 FORMAT (A27,' 2163, REQUESTED VALUE OF ',A4,I10,2X,A3,'USED BY ',
     1        2A4,'. LOGICAL CHOICE IS',I10)
  132 FORM = NFORM
C
C     CHECK PARAMETER -TYPE-
C
  140 NTYPE =   IRLCX + IPR
      IF (NTYPE .EQ. TYPE) GO TO 160
      IF (TYPE  .EQ.    0) GO TO 154
      IF (TYPE.LT.0 .OR. TYPE.GT.4) GO TO 152
      WRITE (OUTPT,130) SWM,NATYPE,TYPE,REFUS(1),SUBR,NTYPE
      NTYPE = TYPE
      GO TO 160
  152 WRITE (OUTPT,130) SWM,NATYPE,TYPE,REFUS(3),SUBR,NTYPE
  154 TYPE = NTYPE
C
C     THE ROW PARTITIONING BIT STRING IS AT THIS POINT CONVERTED TO A
C     CORE VECTOR ONE WORD PER BIT.  EACH WORD CONATINS THE ACTUAL ROW
C     POSITION THE SUB-PARTITON ELEMENT WILL OCCUPY IN THE MERGED
C     MATRIX.
C
  160 IZ = NRP + 1
      NZ = IZ + RPSIZE - 1
      IF (NZ .GT. CORE) CALL MESAGE (-8,0,SUBR)
      IF (.NOT.RPNULL .AND. RPONES.NE.0) GO TO 180
      K = 0
      DO 170 I = IZ,NZ
      K = K + 1
      Z(I) = K
  170 CONTINUE
      GO TO 240
  180 K = 0
      ZERO = IZ - 1
      ONES = ZERO + RPZERO
      DO 230 I = IRP,NRP
      DO 220 J = 1,NBPW
      SHIFT = NBPW - J
      BIT   = RSHIFT(Z(I),SHIFT)
      K = K + 1
      IF (K -  RPSIZE) 190,190,240
  190 IF (ANDF(BIT,1)) 210,200,210
  200 ZERO = ZERO + 1
      Z(ZERO) = K
      GO TO 220
  210 ONES = ONES + 1
      Z(ONES) = K
  220 CONTINUE
  230 CONTINUE
C
C     OPEN OUTPUT FILE AND FILL MCB.
C
  240 CALL OPEN (*440,A,Z(BUFF),WRTREW)
      CALL FNAME (A,HEAD)
      CALL WRITE (A,HEAD,2,EOR)
      CALL MAKMCB (MCBA,A,RPSIZE,NFORM,NTYPE)
C
C     MERGE OPERATIONS.  LOOPING ON OUTPUT COLUMNS OF -A-.
C
      I1 = IZ - 1
      I2 = I1 + RPZERO
      DO 430 I = 1,CPSIZE
C
C     START A COLUMN OUT ON -A-
C
      CALL BLDPK (NTYPE,NTYPE,A,0,0)
      IF (CPNULL) GO TO 250
      IL1   = I - 1
      BITWD = IL1/NBPW + ICP
      SHIFT = NBPW - MOD(IL1,NBPW) - 1
      BIT   = RSHIFT(Z(BITWD),SHIFT)
      IF (ANDF(BIT,1)) 260,250,260
C
C     ZERO-S COLUMN (LEFT PARTITONS A11 AND A21 USED THIS PASS)
C
  250 IFILE  = 1
      IBLOCK = 1
      GO TO 270
C
C     ONE-S COLUMN (RIGHT PARTITIONS A12 AND A22 USED THIS PASS)
C
  260 IFILE  = 3
      IBLOCK = 41
      GO TO 270
C
C     START UNPACKING COLUMN OF EACH PARTITION BEING USED THIS PASS.
C
  270 KFILE  = IFILE
      KBLOCK = IBLOCK
      MPART  = 0
      DO 300 J = 1,2
      IF (MCB(1,KFILE)) 290,290,280
  280 CALL INTPK (*290,MCB(1,KFILE),BLOCK(KBLOCK),NTYPE,1)
      MPART  = MPART  + J
  290 KFILE  = KFILE  + 1
      KBLOCK = KBLOCK + 20
  300 CONTINUE
      IF (MPART) 420,420,310
C
C     UNPACK NON-ZEROS FROM EACH OF THE TWO PARTITIONS AS NEEDED UNTIL
C     BOTH PARTITIONS HAVE THIS COLUMN EXHAUSED.
C
  310 EOL1  = 1
      EOL2  = 1
      NAM1  = MCB(1,IFILE)
      NAM2  = MCB(1,IFILE+1)
      IBLOC1= IBLOCK
      IBLOC2= IBLOCK + 20
      IF (MPART.EQ.1 .OR. MPART.EQ.3) EOL1 = 0
      IF (MPART .GT. 1) EOL2 = 0
      PASS = .FALSE.
      ONLY = .FALSE.
      IF (EOL1) 320,320,340
  320 IF (EOL2) 350,350,330
  330 ONLY = .TRUE.
      GO TO 350
  340 ONLY = .TRUE.
      GO TO 360
C
C     UNPACK A NON-ZERO FROM THE ZEROS PARTITION
C
  350 CALL INTPKI (ELEM1,IROW1,NAM1,BLOCK(IBLOC1),EOL1)
C
C     SET OUTPUT ROW POSITION
C
      JROW  = I1 + IROW1
      IPOS1 = Z(JROW)
      IF (ONLY) GO TO 380
      IF (PASS) GO TO 370
C
C     UNPACK A NON-ZERO FROM THE ONE-S PARTITION
C
  360 CALL INTPKI (ELEM2,IROW2,NAM2,BLOCK(IBLOC2),EOL2)
C
C     SET OUTPUT ROW POSITION
C
      JROW  = I2 + IROW2
      IPOS2 = Z(JROW)
      IF (ONLY) GO TO 400
      PASS  = .TRUE.
C
C     OK COMING HERE MEANS THERE IS ONE ELEMENT FORM EACH PARTITION
C     AVAILABLE FOR OUTPUT.  THUS OUTPUT THE ONE WITH THE LOWEST
C     OUTPUT ROW NUMBER.
C
  370 IF (IPOS2 .LT. IPOS1) GO TO 400
C
C     OUTPUT ELEMENT FROM ZERO-S PARTITION.
C
  380 ROW     = IPOS1
      ELEM(1) = ELEM1(1)
      ELEM(2) = ELEM1(2)
      ELEM(3) = ELEM1(3)
      ELEM(4) = ELEM1(4)
      CALL ZBLPKI
      IF (EOL1) 350,350,390
  390 IF (ONLY) GO TO 420
      ONLY = .TRUE.
      GO TO 400
C
C     OUTPUT ELEMENT FROM ONES-PARTITION.
C
  400 ROW     = IPOS2
      ELEM(1) = ELEM2(1)
      ELEM(2) = ELEM2(2)
      ELEM(3) = ELEM2(3)
      ELEM(4) = ELEM2(4)
      CALL ZBLPKI
      IF (EOL2) 360,360,410
  410 IF (ONLY) GO TO 420
      ONLY = .TRUE.
      GO TO 380
C
C     COMPLETE THE COLUMN BEING OUTPUT
C
  420 CALL BLDPKN (A,0,MCBA)
  430 CONTINUE
C
C     MERGE IS COMPLETE.  WRAP UP.
C
      CALL CLOSE (A,CLSREW)
      CALL WRTTRL (MCBA)
  440 DO 460 I = 1,4
      IF (MCB(1,I)) 460,460,450
  450 CALL CLOSE (MCB(1,I),CLSREW)
  460 CONTINUE
      RETURN
C
      END

        SUBROUTINE WRTBLK ( FILE, IEND )
      INCLUDE 'DSIOF.COM'
      INCLUDE 'XNSTRN.COM'
        INTEGER FILE
        NAME = FILE
        CALL DSGEFL
C        PRINT *,' WRTBLK,NAME,IFILEX,INDBAS=',NAME,IFILEX,INDBAS
C        WRITE(6,40646)(IBASE(INDBAS+K),K=0,7)
40646   FORMAT(' WRTBLK,BUFFER=',8(1X,Z8))
        CALL DBMMGR( 8 )
        INDCLR = IBASE( INDBAS+4 )
        NBLOCK = IBASE( INDBAS+3 )
        IBASE( INDBAS+1 ) = IBASE( INDBAS+4 )
        IBASE( INDBAS+2 ) = IBASE( INDBAS+4 )
        FCB( 3,IFILEX ) = INDCLR
        FCB( 4,IFILEX ) = NBLOCK
C       INNN = FCB(12, IFILEX)
C       PRINT *,' WRTBLK-2,IFILEX,INNN=',IFILEX,INNN
C       WRITE(6,40646)(IBASE(INNN+K),K=0,7)
        IF ( IEND .EQ. 1 ) GO TO 700
        CALL DBMMGR( 4 )
700     RETURN
        END

      SUBROUTINE PRTPRM
C
C     PRINTS NASTRAN PARAMETERS
C
C  $MIXED_FORMATS
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL         LSHIFT,RSHIFT
      LOGICAL          KICKK
      REAL             WAL(32)
      DOUBLE PRECISION DAL(2)
      DIMENSION        BT(26),KT(26),K1(32),K2(32),K3(32),K4(32),
     1                 K5(32),K6(32),NAME(2),VAL(2)
      COMMON /MACHIN/  MACHX
      COMMON /BLANK /  IC,B1,B2
      COMMON /XVPS  /  V(2)
      COMMON /SYSTEM/  NB,NOUT,JUNK1(6),LNMAX,JUNK2(2),LN
      COMMON /OUTPUT/  DUMHED(96),H1(32),H2(32),H3(32)
      EQUIVALENCE      (V(2),L), (DAL(1),VAL(1),WAL(1))
      DATA    XXXX  /  4HXXXX   /,   OO/27/
      DATA    KT    /  5,6,4,5,6,5,3,4,3,5,7,6,6,6,6,5,0,0,0,4,3,2,
     1                 7,5,4,1  /
      DATA    K1    /  32*4H    /
      DATA    K2    /  7*4H    ,4HC O ,4HN T ,4HE N ,4HT S ,4H  O ,
     1                 4HF     ,4HP A ,4HR A ,4HM E ,4HT E ,4HR   ,
     2                 4HT A   ,4HB L ,4HE   ,11*4H        /
      DATA    K3    /  32*4H    /
      DATA    K4    /  32*4H    /
      DATA    K5    /  32*4H    /
      DATA    K6    /  32*4H    /
      DATA    BT    /  4HSTAT,4HINER,4HMODE,4HDIFF,4HBUCK,4HPLA ,4HDIRC,
     1                 4HDIRF,4HDIRT,4HMDLC,4HMDLF,4HMDLT,4HNMDS,4HCYCS,
     2                 4HCYCM,4HASTA,4HDDRM,4HFVDA,4HMVDA,4HHSTA,4HHNLI,
     3                 4HHTRD,4HBLAD,4HFLUT,4HAERO,4HDMAP/
C
C
      IF (IC .NE. 0) GO TO 550
      DO 10 M = 1,32
      H1(M) = K1(M)
      H2(M) = K2(M)
   10 H3(M) = K3(M)
      CALL PAGE
      I = 3
      IF (I .GT. L) GO TO 510
      KICKK = .FALSE.
      IF (B1.NE.XXXX .OR. B2.NE.XXXX) KICKK = .TRUE.
      IF (KICKK) GO TO 180
C
   20 IF (I .GT. L) GO TO 7820
      ASSIGN 30 TO R
      GO TO 300
   30 I = I + NW + 3
      IF (LN .GE. LNMAX) CALL PAGE
      GO TO (40,60,80,100,120,150), TYPE
   40 WRITE  (NOUT,50) NAME(1),NAME(2),VAL(1)
   50 FORMAT (20X,2A4,10X,I10)
      GO TO  170
   60 WRITE  (NOUT,70) NAME(1),NAME(2),WAL(1)
   70 FORMAT (20X,2A4,10X,1P,E14.6)
      GO TO  170
   80 WRITE  (NOUT,90) NAME(1),NAME(2),VAL(1),VAL(2)
   90 FORMAT (20X,2A4,10X,2A4)
      GO TO  170
  100 WRITE  (NOUT,110) NAME(1),NAME(2),DAL(1)
  110 FORMAT (20X,2A4,10X,1P,D24.16)
      GO TO  170
  120 WRITE  (NOUT,130) NAME(1),NAME(2),WAL(1),WAL(2)
  130 FORMAT (20X,2A4,10X,1H(,1P,2E14.6,1H))
      IF (MACHX .EQ. 5) WRITE (NOUT,140,ERR=170) DAL(1)
  140 FORMAT (1H+,69X,'OR',D24.16)
      GO TO  170
  150 WRITE  (NOUT,160) NAME(1),NAME(2),DAL(1),DAL(2)
  160 FORMAT (20X,2A4,10X,1H(,1P,2D24.16,1H))
  170 IF (KICKK) GO TO 200
      LN = LN + 2
      GO TO 20
C
  180 IF (I .GT. L) GO TO 530
      IF (V(I).NE.B1 .OR. V(I+1).NE.B2) GO TO 210
      ASSIGN 190 TO R
      GO TO 300
  190 GO TO (40,60,80,100,120,150), TYPE
  200 GO TO 7820
  210 I = I + V(I+2) + 3
      GO TO 180
C
  300 NAME(1) = V(I  )
      NAME(2) = V(I+1)
      NW = V(I+2)
      DO 310 M = 1,NW
      MI = M + I
  310 VAL(M) = V(MI+2)
      M = NUMTYP(VAL(1)) + 1
      GO TO ( 320, 490, 320, 480), M
C            ZERO,INTG,REAL, BCD
C
  320 IF (NW .GT. 1) GO TO 330
      TYPE = 2
      GO TO 500
  330 IF (NW .LT. 4) GO TO 340
      TYPE = 6
      GO TO 500
C
C     THE 7094 AND 6600 SHOULD BE CORRECT
C     THE 360 AND 1108 CAN STILL HAVE SOME MISTAKES
C     VAX IS OK, OTHER UNIX MACHINES FOLLOW VAX              ** MACHX **
C     MACHINES ABOVE 12 NEED TO BE SET CORRECTLY IN NEXT GO TO STATEMENT
C
C            DUMMY  360  1108  6600   VAX  ULTRIX   SUN   AIX     HP
C             S/G   MAC  CRAY  CNVX   NEC  FUJISU    DG  AMDL  PRIME
C             486  DUMMY
C            ----  ----- ----  ----  ----  ------  ----  ----  -----
  340 GO TO ( 420,  430,  440,  450,  350,    350,  350,  350,   350,
     1        350,  350,  410,  350,  350,    350,  350,  350,   350,
     2        350,  350), MACHX
C
C     ****** NEED TEST FOR RDP VS CSP.  I ASSUME CSP FOR NOW.
C
  350 GO TO 430
C
C     ****** OH MY GOSH, HOW CAN I SOLVE THIS PROBLEM FOR THE VAX
C
  410 IF (RSHIFT(VAL(2),48) .EQ. 0) GO TO 470
      GO TO 460
  420 IF (MACHX.EQ.1 .AND. IABS(RSHIFT(VAL(1),27)).EQ.
     1    OO+IABS(RSHIFT(VAL(2),27))) GO TO 470
      GO TO 460
  430 IF (RSHIFT(LSHIFT(VAL(2),9),28).EQ.0 .AND. VAL(2).NE.0) GO TO 470
      GO TO 460
  440 IF (RSHIFT(LSHIFT(VAL(1),9),35).EQ.1 .AND. RSHIFT(LSHIFT(VAL(2),9)
     1   ,35).EQ.1) GO TO 460
      IF (VAL(2) .EQ. 0) GO TO 460
      GO TO 470
  450 IF (IABS(RSHIFT(VAL(1),48)) .EQ. 48+IABS(RSHIFT(VAL(2),48)))
     1    GO TO 470
  460 TYPE = 5
      GO TO 500
  470 TYPE = 4
      GO TO 500
  480 TYPE = 3
      GO TO 500
  490 TYPE = 1
  500 GO TO R, (30,190)
C
  510 WRITE  (NOUT,520)
  520 FORMAT (1H0,19X,'NO PARAMETERS EXIST')
      LN = LN + 2
      GO TO 7820
  530 WRITE  (NOUT,540) B1,B2
  540 FORMAT (1H0,19X,'PARAMETER NAMED ',2A4,' IS NOT IN VPS.')
      LN = LN + 2
      GO TO 7820
C
  550 DO 560 M = 1,32
      H1(M) = K4(M)
      H2(M) = K5(M)
  560 H3(M) = K6(M)
      CALL PAGE
      KICK = IABS(IC)
      DO 570 M = 1,26
      IF (B1 .NE. BT(M)) GO TO 570
      MM = M
      GO TO 590
  570 CONTINUE
      LN = LN + 2
      WRITE  (NOUT,580) B1,B2
  580 FORMAT ('0SECOND PRTPARM PARAMETER VALUE -',2A4,'- IMPROPER.')
      GO TO 7810
  590 IF (KICK.GT.KT(MM) .AND. MM.LE.26) GO TO 600
      LN = LN + 5
      GO TO ( 700, 800, 900,1000,1100,1200,1300,1400,1500,1600,
     1       1700,1800,1900,2000,2100,2200,2300,2400,2500,3000,
     2       3100,3200,3600,3700,3800,4100), MM
  600 WRITE  (NOUT,610) KICK
  610 FORMAT ('0PRTPARM DIAGNOSTIC',I20,' NOT IN TABLE.')
      LN = LN + 2
      GO TO 7810
C
C     DISPLACEMENT APPROACH - RIGID FORMAT 1
C
  700 GO TO (710,720,730,740,750), KICK
  710 WRITE (NOUT,4200)
      GO TO 7800
  720 WRITE (NOUT,4210)
      GO TO 7800
  730 WRITE (NOUT,4220)
      GO TO 7800
  740 WRITE (NOUT,4230)
      GO TO 7800
  750 WRITE (NOUT,4240)
      GO TO 7800
C
C     DISPLACEMENT APPROACH - RIGID FORMAT 2
C
  800 GO TO (810,820,830,840,850,860), KICK
  810 WRITE (NOUT,4300)
      GO TO 7800
  820 WRITE (NOUT,4310)
      GO TO 7800
  830 WRITE (NOUT,4320)
      GO TO 7800
  840 WRITE (NOUT,4330)
      GO TO 7800
  850 WRITE (NOUT,4340)
      GO TO 7800
  860 WRITE (NOUT,4350)
      GO TO 7800
C
C     DISPLACEMENT APPROACH - RIGID FORMAT 3
C
  900 GO TO (910,920,930,940), KICK
  910 WRITE (NOUT,4400)
      GO TO 7800
  920 WRITE (NOUT,4410)
      GO TO 7800
  930 WRITE (NOUT,4420)
      GO TO 7800
  940 WRITE (NOUT,4430)
      GO TO 7800
C
C     DISPLACEMENT APPROACH - RIGID FORMAT 4
C
 1000 GO TO (1010,1020,1030,1040,1050), KICK
 1010 WRITE (NOUT,4500)
      GO TO 7800
 1020 WRITE (NOUT,4510)
      GO TO 7800
 1030 WRITE (NOUT,4520)
      GO TO 7800
 1040 WRITE (NOUT,4530)
      GO TO 7800
 1050 WRITE (NOUT,4540)
      GO TO 7800
C
C     DISPLACEMENT APPROACH - RIGID FORMAT 5
C
 1100 GO TO (1110,1120,1130,1140,1150,1160), KICK
 1110 WRITE (NOUT,4600)
      GO TO 7800
 1120 WRITE (NOUT,4610)
      GO TO 7800
 1130 WRITE (NOUT,4620)
      GO TO 7800
 1140 WRITE (NOUT,4630)
      GO TO 7800
 1150 WRITE (NOUT,4640)
      GO TO 7800
 1160 WRITE (NOUT,4650)
      GO TO 7800
C
C     DISPLACEMENT APPROACH - RIGID FORMAT 6
C
 1200 GO TO (1210,1220,1230,1240,1250), KICK
 1210 WRITE (NOUT,4700)
      GO TO 7800
 1220 WRITE (NOUT,4710)
      GO TO 7800
 1230 WRITE (NOUT,4720)
      GO TO 7800
 1240 WRITE (NOUT,4730)
      GO TO 7800
 1250 WRITE (NOUT,4740)
      GO TO 7800
C
C     DISPLACEMENT APPROACH - RIGID FORMAT 7
C
 1300 GO TO (1310,1320,1330), KICK
 1310 WRITE (NOUT,4800)
      GO TO 7800
 1320 WRITE (NOUT,4810)
      GO TO 7800
 1330 WRITE (NOUT,4820)
      GO TO 7800
C
C     DISPLACEMENT APPROACH - RIGID FORMAT 8
C
 1400 GO TO (1410,1420,1430,1440), KICK
 1410 WRITE (NOUT,4900)
      GO TO 7800
 1420 WRITE (NOUT,4910)
      GO TO 7800
 1430 WRITE (NOUT,4920)
      GO TO 7800
 1440 WRITE (NOUT,4930)
      GO TO 7800
C
C     DISPLACEMENT APPROACH - RIGID FORMAT 9
C
 1500 GO TO (1510,1520,1530), KICK
 1510 WRITE (NOUT,5000)
      GO TO 7800
 1520 WRITE (NOUT,5010)
      GO TO 7800
 1530 WRITE (NOUT,5020)
      GO TO 7800
C
C     DISPLACEMENT APPROACH - RIGID FORMAT 10
C
 1600 GO TO (1610,1620,1630,1640,1650), KICK
 1610 WRITE (NOUT,5100)
      GO TO 7800
 1620 WRITE (NOUT,5110)
      GO TO 7800
 1630 WRITE (NOUT,5120)
      GO TO 7800
 1640 WRITE (NOUT,5130)
      GO TO 7800
 1650 WRITE (NOUT,5140)
      GO TO 7800
C
C     DISPLACEMENT APPROACH - RIGID FORMAT 11
C
 1700 GO TO (1710,1720,1730,1740,1750,1760,1770), KICK
 1710 WRITE (NOUT,5200)
      GO TO 7800
 1720 WRITE (NOUT,5210)
      GO TO 7800
 1730 WRITE (NOUT,5220)
      GO TO 7800
 1740 WRITE (NOUT,5230)
      GO TO 7800
 1750 WRITE (NOUT,5240)
      GO TO 7800
 1760 WRITE (NOUT,5250)
      GO TO 7800
 1770 WRITE (NOUT,5260)
      GO TO 7800
C
C     DISPLACEMENT APPROACH - RIGID FORMAT 12
C
 1800 GO TO (1810,1820,1830,1840,1850,1860), KICK
 1810 WRITE (NOUT,5300)
      GO TO 7800
 1820 WRITE (NOUT,5310)
      GO TO 7800
 1830 WRITE (NOUT,5320)
      GO TO 7800
 1840 WRITE (NOUT,5330)
      GO TO 7800
 1850 WRITE (NOUT,5340)
      GO TO 7800
 1860 WRITE (NOUT,5350)
      GO TO 7800
C
C     DISPLACEMENT APPROACH - RIGID FORMAT 13
C
 1900 GO TO (1910,1920,1930,1940,1950,1960), KICK
 1910 WRITE (NOUT,5400)
      GO TO 7800
 1920 WRITE (NOUT,5410)
      GO TO 7800
 1930 WRITE (NOUT,5420)
      GO TO 7800
 1940 WRITE (NOUT,5430)
      GO TO 7800
 1950 WRITE (NOUT,5440)
      GO TO 7800
 1960 WRITE (NOUT,5450)
      GO TO 7800
C
C     DISPLACEMENT APPROACH - RIGID FORMAT 14
C
 2000 GO TO (2010,2020,2030,2040,2050,2060), KICK
 2010 WRITE (NOUT,5500)
      GO TO 7800
 2020 WRITE (NOUT,5510)
      GO TO 7800
 2030 WRITE (NOUT,5520)
      GO TO 7800
 2040 WRITE (NOUT,5530)
      GO TO 7800
 2050 WRITE (NOUT,5540)
      GO TO 7800
 2060 WRITE (NOUT,5550)
      GO TO 7800
C
C     DISPLACEMENT APPROACH - RIGID FORMAT 15
C
 2100 GO TO (2110,2120,2130,2140,2150,2160), KICK
 2110 WRITE (NOUT,5600)
      GO TO 7800
 2120 WRITE (NOUT,5610)
      GO TO 7800
 2130 WRITE (NOUT,5620)
      GO TO 7800
 2140 WRITE (NOUT,5630)
      GO TO 7800
 2150 WRITE (NOUT,5640)
      GO TO 7800
 2160 WRITE (NOUT,5650)
      GO TO 7800
C
C     DISPLACEMENT APPROACH - RIGID FORMAT 16
C
 2200 GO TO (2210,2220,2230,2240,2250), KICK
 2210 WRITE (NOUT,5700)
      GO TO 7800
 2220 WRITE (NOUT,5710)
      GO TO 7800
 2230 WRITE (NOUT,5720)
      GO TO 7800
 2240 WRITE (NOUT,5730)
      GO TO 7800
 2250 WRITE (NOUT,5740)
      GO TO 7800
C
C     DISPLACEMENT APPROACH - RIGID FORMAT 17
C
 2300 CONTINUE
      GO TO 7800
C
C     DISPLACEMENT APPROACH - RIGID FORMAT 18
C
 2400 CONTINUE
      GO TO 7800
C
C     DISPLACEMENT APPROACH - RIGID FORMAT 19
C
 2500 CONTINUE
      GO TO 7800
C
C     HEAT APPROACH - RIGID FORMAT 1
C
 3000 GO TO (3010,3020,3030,3040), KICK
 3010 WRITE (NOUT,6600)
      GO TO 7800
 3020 WRITE (NOUT,6610)
      GO TO 7800
 3030 WRITE (NOUT,6620)
      GO TO 7800
 3040 WRITE (NOUT,6630)
      GO TO 7800
C
C     HEAT APPROACH - RIGID FORMAT 3
C
 3100 GO TO (3110,3120,3130), KICK
 3110 WRITE (NOUT,6700)
      GO TO 7800
 3120 WRITE (NOUT,6710)
      GO TO 7800
 3130 WRITE (NOUT,6720)
      GO TO 7800
C
C     HEAT APPROACH - RIGID FORMAT 9
C
 3200 GO TO (3210,3220), KICK
 3210 WRITE (NOUT,6800)
      GO TO 7800
 3220 WRITE (NOUT,6810)
      GO TO 7800
C
C     AERO APPROACH - RIGID FORMAT 9
C
 3600 GO TO (3610,3620,3630,3640,3650,3660,3670), KICK
 3610 WRITE (NOUT,7200)
      GO TO 7800
 3620 WRITE (NOUT,7210)
      GO TO 7800
 3630 WRITE (NOUT,7220)
      GO TO 7800
 3640 WRITE (NOUT,7230)
      GO TO 7800
 3650 WRITE (NOUT,7240)
      GO TO 7800
 3660 WRITE (NOUT,7250)
      GO TO 7800
 3670 WRITE (NOUT,7260)
      GO TO 7800
C
C     AERO APPROACH - RIGID FORMAT 10
C
 3700 GO TO (3710,3720,3730,3740,3750), KICK
 3710 WRITE (NOUT,7300)
      GO TO 7800
 3720 WRITE (NOUT,7310)
      GO TO 7800
 3730 WRITE (NOUT,7320)
      GO TO 7800
 3740 WRITE (NOUT,7330)
      GO TO 7800
 3750 WRITE (NOUT,7340)
      GO TO 7800
C
C     AERO APPROACH - RIGID FORMAT 11
C
 3800 GO TO (3810,3820,3830,3840), KICK
 3810 WRITE (NOUT,7400)
      GO TO 7800
 3820 WRITE (NOUT,7410)
      GO TO 7800
 3830 WRITE (NOUT,7420)
      GO TO 7800
 3840 WRITE (NOUT,7430)
      GO TO 7800
C
C     DMAP APPROACH
C
 4100 WRITE (NOUT,7700) KICK
      GO TO 7800
C
C     DISPLACEMENT APPROACH - RIGID FORMAT 1
C
 4200 FORMAT (//////,' STATIC ANALYSIS ERROR NO.1  ATTEMPT TO EXECUTE ',
     1       'MORE THAN 360 LOOPS.')
 4210 FORMAT (//////,' STATIC ANALYSIS ERROR NO.2  MASS MATRIX REQUIRED'
     1,      ' FOR WEIGHT AND BALANCE CALCULATIONS.')
 4220 FORMAT (//////,' STATIC ANALYSIS ERROR NO.3  NO INDEPENDENT ',
     1       'DEGREES OF FREEDOM HAVE BEEN DEFINED.')
 4230 FORMAT (//////,' STATIC ANALYSIS ERROR NO.4  NO ELEMENTS HAVE ',
     1       'BEEN DEFINED.')
 4240 FORMAT (//////,' STATIC ANALYSIS ERROR NO.5  A LOOPING PROBLEM ',
     1       'RUN ON A NON-LOOPING SUBSET.')
C
C     DISPLACEMENT APPROACH - RIGID FORMAT 2
C
 4300 FORMAT (//////,' INERTIA RELIEF ERROR NO.1  MASS MATRIX REQUIRED',
     1       ' FOR CALCULATION OF INERTIA LOADS.')
 4310 FORMAT (//////,' INERTIA RELIEF ERROR NO.2  ATTEMPT TO EXECUTE ',
     1       'MORE THAN 360 LOOPS.')
 4320 FORMAT (//////,' INERTIA RELIEF ERROR NO.3  NO INDEPENDENT ',
     1       'DEGREES OF FREEDOM HAVE BEEN DEFINED.')
 4330 FORMAT (//////,' INERTIA RELIEF ERROR NO.4  FREE BODY SUPPORTS ',
     1       'ARE REQUIRED.')
 4340 FORMAT (//////,' INERTIA RELIEF ERROR NO.5  A LOOPING PROBLEM ',
     1       'RUN ON A NON-LOOPING SUBSET.')
 4350 FORMAT (//////,' INERTIA RELIEF ERROR NO.6  NO STRUCTURAL ',
     1       'ELEMENTS HAVE BEEN DEFINED.')
C
C     DISPLACEMENT APPROACH - RIGID FORMAT 3
C
 4400 FORMAT (//////,' NORMAL MODES ERROR NO.1  MASS MATRIX REQUIRED ',
     1       'FOR REAL EIGENVALUE ANALYSIS.')
 4410 FORMAT (//////,' NORMAL MODES ERROR NO.2  EIGENVALUE EXTRACTION ',
     1       'DATA REQUIRED FOR REAL EIGENVALUE ANALYSIS.')
 4420 FORMAT (//////,' NORMAL MODES ERROR NO.3  NO INDEPENDENT DEGREES',
     1       ' OF FREEDOM HAVE BEEN DEFINED.')
 4430 FORMAT (//////,' NORMAL MODES ERROR NO.4  NO STRUCTURAL ELEMENTS',
     1       ' HAVE BEEN DEFINED.')
C
C     DISPLACEMENT APPROACH - RIGID FORMAT 4
C
 4500 FORMAT (//////,' DIFFERENTIAL STIFFNESS ERROR NO.1  NO STRUCTURAL'
     1,      ' ELEMENTS HAVE BEEN DEFINED.')
 4510 FORMAT (//////,' DIFFERENTIAL STIFFNESS ERROR NO.2  FREE BODY ',
     1       'SUPPORTS NOT ALLOWED.')
 4520 FORMAT (//////,' DIFFERENTIAL STIFFNESS ERROR NO.3  NO GRID POINT'
     1,      ' DATA IS SPECIFIED.')
 4530 FORMAT (//////,' DIFFERENTIAL STIFFNESS ERROR NO.4  MASS MATRIX ',
     1       'REQUIRED FOR WEIGHT AND BALANCE CALCULATIONS.')
 4540 FORMAT (//////,' DIFFERENTIAL STIFFNESS ERROR NO.5  NO ',
     1       'INDEPENDENT DEGREES OF FREEDOM HAVE BEEN DEFINED.')
C
C     DISPLACEMENT APPROACH - RIGID FORMAT 5
C
 4600 FORMAT (//////,' BUCKLING ANALYSIS ERROR NO.1  NO STRUCTURAL ',
     1       'ELEMENTS HAVE BEEN DEFINED.')
 4610 FORMAT (//////,' BUCKLING ANALYSIS ERROR NO.2  FREE BODY SUPPORTS'
     1,      ' NOT ALLOWED.')
 4620 FORMAT (//////,' BUCKLING ANALYSIS ERROR NO.3  EIGENVALUE ',
     1       'EXTRACTION DATA REQUIRED FOR REAL EIGENVALUE ANALYSIS.')
 4630 FORMAT (//////,' BUCKLING ANALYSIS ERROR NO.4  NO EIGENVALUES ',
     1       'FOUND.')
 4640 FORMAT (//////,' BUCKLING ANALYSIS ERROR NO.5  MASS MATRIX ',
     1       'REQUIRED FOR WEIGHT AND BALANCE CALCULATIONS.')
 4650 FORMAT (//////,' BUCKLING ANALYSIS ERROR NO.6  NO INDEPENDENT ',
     1       'DEGREES OF FREEDOM HAVE BEEN DEFINED.')
C
C     DISPLACEMENT APPROACH - RIGID FORMAT 6
C
 4700 FORMAT (//////,' PIECEWISE LINEAR ERROR NO.1  NO NONLINEAR ',
     1       'ELEMENTS HAVE BEEN DEFINED.')
 4710 FORMAT (//////,' PIECEWISE LINEAR ERROR NO.2  ATTEMPT TO EXECUTE',
     1       ' MORE THAN 360 LOOPS.')
 4720 FORMAT (//////,' PIECEWISE LINEAR ERROR NO.3  MASS MATRIX ',
     1       'REQUIRED FOR WEIGHT AND BALANCE CALCULATIONS.')
 4730 FORMAT (//////,' PIECEWISE LINEAR ERROR NO.4  NO ELEMENTS HAVE ',
     1       'BEEN DEFINED.')
 4740 FORMAT (//////,' PIECEWISE LINEAR ERROR NO.5  STIFFNESS MATRIX ',
     1       'SINGULAR DUE TO MATERIAL PLASTICITY.')
C
C     DISPLACEMENT APPROACH - RIGID FORMAT 7
C
 4800 FORMAT (//////,' DIRECT COMPLEX EIGENVALUE ERROR NO.1  ',
     1       'EIGENVALUE EXTRACTION DATA REQUIRED FOR COMPLEX ',
     2       'EIGENVALUE ANALYSIS.')
 4810 FORMAT (//////,' DIRECT COMPLEX EIGENVALUE ERROR NO.2  ATTEMPT ',
     1       'TO EXECUTE MORE THAN 100 LOOPS.')
 4820 FORMAT (//////,' DIRECT COMPLEX EIGENVALUE ERROR NO.3  MASS ',
     1       'MATRIX REQUIRED FOR WEIGHT AND BALANCE CALCULATIONS.')
C
C     DISPLACEMENT APPROACH - RIGID FORMAT 8
C
 4900 FORMAT (//////,' DIRECT FREQUENCY RESPONSE ERROR NO.1  FREQUENCY',
     1       ' RESPONSE LIST REQUIRED FOR FREQUENCY RESPONSE ',
     2       'CALCULATIONS.')
 4910 FORMAT (//////,' DIRECT FREQUENCY RESPONSE ERROR NO.2  DYNAMIC ',
     1       'LOADS TABLE REQUIRED FOR FREQUENCY RESPONSE CALCULATIONS')
 4920 FORMAT (//////,' DIRECT FREQUENCY RESPONSE ERROR NO.3  ATTEMPT ',
     1       'TO EXECUTE MORE THAN 100 LOOPS.')
 4930 FORMAT (//////,' DIRECT FREQUENCY RESPONSE ERROR NO.4  MASS ',
     1       'MATRIX REQUIRED FOR WEIGHT AND BALANCE CALCULATIONS.')
C
C     DISPLACEMENT APPROACH - RIGID FORMAT 9
C
 5000 FORMAT (//////,' DIRECT TRANSIENT RESPONSE ERROR NO.1  TRANSIENT',
     1       ' RESPONSE LIST REQUIRED FOR TRANSIENT RESPONSE ',
     2       'CALCULATIONS.')
 5010 FORMAT (//////,' DIRECT TRANSIENT RESPONSE ERROR NO.2  ATTEMPT ',
     1       'TO EXECUTE MORE THAN 100 LOOPS.')
 5020 FORMAT (//////,' DIRECT TRANSIENT RESPONSE ERROR NO.3  MASS ',
     1       'MATRIX REQUIRED FOR WEIGHT AND BALANCE CALCULATIONS.')
C
C     DISPLACEMENT APPROACH - RIGID FORMAT 10
C
 5100 FORMAT (//////,' MODAL COMPLEX EIGENVALUE ERROR NO.1  MASS MATRIX'
     1,      ' REQUIRED FOR MODAL FORMULATION.')
 5110 FORMAT (//////,' MODAL COMPLEX EIGENVALUE ERROR NO.2  EIGENVALUE',
     1       ' EXTRACTION DATA REQUIRED FOR REAL EIGENVALUE ANALYSIS.')
 5120 FORMAT (//////,' MODAL COMPLEX EIGENVALUE ERROR NO.3  ATTEMPT TO',
     1       ' EXECUTE MORE THAN 100 LOOPS.')
 5130 FORMAT (//////,' MODAL COMPLEX EIGENVALUE ERROR NO.4  REAL ',
     1       'EIGENVALUES REQUIRED FOR MODAL FORMULATION.')
 5140 FORMAT (//////,' MODAL COMPLEX EIGENVALUE ERROR NO.5  NO ',
     1       'STRUCTURAL ELEMENTS HAVE BEEN DEFINED.')
C
C     DISPLACEMENT APPROACH - RIGID FORMAT 11
C
 5200 FORMAT (//////,' MODAL FREQUENCY RESPONSE ERROR NO.1  MASS MATRIX'
     1,      ' REQUIRED FOR MODAL FORMULATION.')
 5210 FORMAT (//////,' MODAL FREQUENCY RESPONSE ERROR NO.2  EIGENVALUE',
     1       ' EXTRACTION DATA REQUIRED FOR REAL EIGENVALUE ANALYSIS.')
 5220 FORMAT (//////,' MODAL FREQUENCY RESPONSE ERROR NO.3  ATTEMPT TO',
     1       ' EXECUTE MORE THAN 100 LOOPS.')
 5230 FORMAT (//////,' MODAL FREQUENCY RESPONSE ERROR NO.4  REAL ',
     1       'EIGENVALUES REQUIRED FOR MODAL FORMULATION.')
 5240 FORMAT (//////,' MODAL FREQUENCY RESPONSE ERROR NO.5  FREQUENCY ',
     1       'RESPONSE LIST REQUIRED FOR FREQUENCY RESPONSE ',
     2       'CALCULATIONS.')
 5250 FORMAT (//////,' MODAL FREQUENCY RESPONSE ERROR NO.6  DYNAMIC ',
     1       'LOADS TABLE REQUIRED FOR FREQUENCY RESPONSE CALCULATIONS')
 5260 FORMAT (//////,' MODAL FREQUENCY RESPONSE ERROR NO.7  NO ',
     1       'STRUCTURAL ELEMENTS HAVE BEEN DEFINED.')
C
C     DISPLACEMENT APPROACH - RIGID FORMAT 12
C
 5300 FORMAT (//////,' MODAL TRANSIENT RESPONSE ERROR NO.1  MASS MATRIX'
     1,      ' REQUIRED FOR MODAL FORMULATION.')
 5310 FORMAT (//////,' MODAL TRANSIENT RESPONSE ERROR NO.2 EIGENVALUE ',
     1       'EXTRACTION DATA REQUIRED FOR REAL EIGENVALUE ANALYSIS.')
 5320 FORMAT (//////,' MODAL TRANSIENT RESPONSE ERROR NO.3 ATTEMPT TO ',
     1       'EXECUTE MORE THAN 100 LOOPS.')
 5330 FORMAT (//////,' MODAL TRANSIENT RESPONSE ERROR NO.4 REAL ',
     1       'EIGENVALUES REQUIRED FOR MODAL FORMULATION.')
 5340 FORMAT (//////,' MODAL TRANSIENT RESPONSE ERROR NO.5 TRANSIENT ',
     1       'RESPONSE LIST REQUIRED FOR TRANSIENT RESPONSE ',
     2       'CALCULATIONS.')
 5350 FORMAT (//////,' MODAL TRANSIENT RESPONSE ERROR NO.6 NO ',
     1       'STRUCTURAL ELEMENTS HAVE BEEN DEFINED.')
C
C     DISPLACEMENT APPROACH - RIGID FORMAT 13
C
 5400 FORMAT (//////,' NORMAL MODES WITH DIFFERENTIAL STIFFNESS ERROR ',
     1       'NO.1  NO STRUCTURAL ELEMENTS HAVE BEEN DEFINED.')
 5410 FORMAT (//////,' NORMAL MODES WITH DIFFERENTIAL STIFFNESS ERROR ',
     1       'NO.2  FREE BODY SUPPORTS NOT ALLOWED.')
 5420 FORMAT (//////,' NORMAL MODES WITH DIFFERENTIAL STIFFNESS ERROR ',
     1       'NO.3  EIGENVALUE EXTRACTION DATA REQUIRED FOR REAL ',
     2       'EIGENVALUE ANALYSIS.')
 5430 FORMAT (//////,' NORMAL MODES WITH DIFFERENTIAL STIFFNESS ERROR ',
     1       'NO.4  NO EIGENVALUE FOUND.')
 5440 FORMAT (//////,' NORMAL MODES WITH DIFFERENTIAL STIFFNESS ERROR ',
     1       'NO. 5  MASS MATRIX REQUIRED FOR REAL EIGENVALUE ANALYSIS')
 5450 FORMAT (//////,' NORMAL MODES WITH DIFFERENTIAL STIFFNESS ERROR ',
     1       'NO. 6  NO INDEPENDENT DEGREES OF FREEDOM HAVE BEEN ',
     2       'DEFINED.')
C
C     DISPLACEMENT APPROACH - RIGID FORMAT 14
C
 5500 FORMAT (//////,' STATICS WITH CYCLIC TRANSFORMATION ERROR NO. 1 ',
     1       ' ATTEMPT TO EXECUTE MORE THAN 360 LOOPS.')
 5510 FORMAT (//////,' STATICS WITH CYCLIC TRANSFORMATION ERROR NO. 2  '
     1,      'MASS MATRIX REQUIRED FOR WEIGHT AND BALANCE CALCULATIONS')
 5520 FORMAT (//////,' STATICS WITH CYCLIC TRANSFORMATION ERROR NO. 3 ',
     1       ' NO INDEPENDENT DEGREES OF FREEDOM HAVE BEEN DEFINED.')
 5530 FORMAT (//////,' STATICS WITH CYCLIC TRANSFORMATION ERROR NO. 4 ',
     1       ' NO ELEMENTS HAVE BEEN DEFINED.')
 5540 FORMAT (//////,' STATICS WITH CYCLIC TRANSFORMATION ERROR NO. 5 ',
     1       ' CYCLIC TRANSFORMATION DATA ERROR.')
 5550 FORMAT (//////,' STATICS WITH CYCLIC TRANSFORMATION ERROR NO. 6 ',
     1       ' FREE BODY SUPPORTS NOT ALLOWED.')
C
C     DISPLACEMENT APPROACH - RIGID FORMAT 15
C
 5600 FORMAT (//////,' NORMAL MODES WITH CYCLIC TRANSFORMATION ERROR ',
     1       'NO. 1  MASS MATRIX REQUIRED FOR REAL EIGENVALUE ANALYSIS')
 5610 FORMAT (//////,' NORMAL MODES WITH CYCLIC TRANSFORMATION ERROR ',
     1       'NO. 2  EIGENVALUE EXTRACTION DATA REQUIRED FOR REAL ',
     2       'EIGENVALUE ANALYSIS.')
 5620 FORMAT (//////,' NORMAL MODES WITH CYCLIC TRANSFORMATION ERROR ',
     1       'NO. 3  NO INDEPENDENT DEGREES OF FREEDOM HAVE BEEN ',
     2       'DEFINED.')
 5630 FORMAT (//////,' NORMAL MODES WITH CYCLIC TRANSFORMATION ERROR ',
     1       'NO. 4  FREE BODY SUPPORTS NOT ALLOWED.')
 5640 FORMAT (//////,' NORMAL MODES WITH CYCLIC TRANSFORMATION ERROR ',
     1       'NO. 5  CYCLIC TRANSFORMATION DATA ERROR.')
 5650 FORMAT (//////,' NORMAL MODES WITH CYCLIC TRANSFORMATION ERROR ',
     1       'NO. 6  NO STRUCTURAL ELEMENTS HAVE BEEN DEFINED.')
C
C     DISPLACEMENT APPROACH - RIGID FORMAT 16
C
 5700 FORMAT (//////,' AEROTHERMOELASTIC ERROR NO. 1  NO STRUCTURAL ',
     1       'ELEMENTS HAVE BEEN DEFINED.')
 5710 FORMAT (//////,' AEROTHERMOELASTIC ERROR NO. 2  FREE BODY ',
     1       'SUPPORTS NOT ALLOWED.')
 5720 FORMAT (//////,' AEROTHERMOELASTIC ERROR NO. 3  NO GRID POINT ',
     1       'DATA IS SPECIFIED.')
 5730 FORMAT (//////,' AEROTHERMOELASTIC ERROR NO. 4  MASS MATRIX ',
     1       'REQUIRED FOR WEIGHT AND BALANCE CALCULATIONS.')
 5740 FORMAT (//////,' AEROTHERMOELASTIC ERROR NO. 5  NO INDEPENDENT ',
     1       'DEGREES OF FREEDOM HAVE BEEN DEFINED.')
C
C     DISPLACEMENT APPROACH - RIGID FORMAT 17
C
C5800 FORMAT (//)
C
C     DISPLACEMENT APPROACH - RIGID FORMAT 18
C
C5900 FORMAT (//)
C
C     DISPLACEMENT APPROACH - RIGID FORMAT 19
C
C6000 FORMAT (//)
C
C
C     HEAT APPROACH - RIGID FORMAT 1
C
 6600 FORMAT (//////,' STATIC HEAT TRANSFER ERROR NO. 1  ATTEMPT TO ',
     1       'EXECUTE MORE THAN 100 LOOPS.')
 6610 FORMAT (//////,' STATIC HEAT TRANSFER ERROR NO. 2  LOOPING ',
     1       'PROBLEM RUN ON A NON-LOOPING SUBSET.')
 6620 FORMAT (//////,' STATIC HEAT TRANSFER ERROR NO. 3  NO INDEPENDENT'
     1,      ' DEGREES OF FREEDOM HAVE BEEN DEFINED.')
 6630 FORMAT (//////,' STATIC HEAT TRANSFER ERROR NO. 4  NO ELEMENTS ',
     1       'HAVE BEEN DEFINED.')
C
C     HEAT APPROACH - RIGID FORMAT 3
C
 6700 FORMAT (//////,' NONLINEAR STATIC HEAT TRANSFER ERROR NO. 1  NO ',
     1       'INDEPENDENT DEGREES OF FREEDOM HAVE BEEN DEFINED.')
 6710 FORMAT (//////,' NONLINEAR STATIC HEAT TRANSFER ERROR NO. 2  NO ',
     1       'SIMPLE STRUCTURAL ELEMENTS.')
 6720 FORMAT (//////,' NONLINEAR STATIC HEAT TRANSFER ERROR NO. 3  ',
     1       'STIFFNESS MATRIX SINGULAR.')
C
C     HEAT APPROACH - RIGID FORMAT 9
C
 6800 FORMAT (//////,' TRANSIENT HEAT TRANSFER ERROR NO. 1  TRANSIENT ',
     1       'RESPONSE LIST REQUIRED FOR TRANSIENT RESPONSE ',
     2       'CALCULATIONS.')
 6810 FORMAT (//////,' TRANSIENT HEAT TRANSFER ERROR NO. 2  ATTEMPT ',
     1       'TO EXECUTE MORE THAN 100 LOOPS.')
C
C     AERO APPROACH - RIGID FORMAT 9
C
 7200 FORMAT (//////,' BLADE FLUTTER ANALYSIS ERROR NO. 1  MASS MATRIX',
     1       ' REQUIRED FOR MODAL FORMULATION.')
 7210 FORMAT (//////,' BLADE FLUTTER ANALYSIS ERROR NO. 2  EIGENVALUE ',
     1       'EXTRACTION DATA REQUIRED FOR REAL EIGENVALUE ANALYSIS.')
 7220 FORMAT (//////,' BLADE FLUTTER ANALYSIS ERROR NO. 3  ATTEMPT TO ',
     1       'EXECUTE MORE THAN 100 LOOPS.')
 7230 FORMAT (//////,' BLADE FLUTTER ANALYSIS ERROR NO. 4  REAL ',
     1       'EIGENVALUES REQUIRED FOR MODAL FORMULATION.')
 7240 FORMAT (//////,' BLADE FLUTTER ANALYSIS ERROR NO. 5  NO GRID ',
     1       'POINT DATA IS SPECIFIED OR NO STRUCTURAL ELEMENTS HAVE ',
     2       'BEEN DEFINED.')
 7250 FORMAT (//////,' BLADE FLUTTER ANALYSIS ERROR NO. 6  FREE BODY ',
     1       'SUPPORTS NOT ALLOWED.')
 7260 FORMAT (//////,' BLADE FLUTTER ANALYSIS ERROR NO. 7  CYCLIC ',
     1       'TRANSFORMATION DATA ERROR.')
C
C     AERO APPROACH - RIGID FORMAT 10
C
 7300 FORMAT (//////,' MODAL FLUTTER ANALYSIS ERROR NO. 1  MASS MATRIX',
     1       ' REQUIRED FOR MODAL FORMULATION.')
 7310 FORMAT (//////,' MODAL FLUTTER ANALYSIS ERROR NO. 2  EIGENVALUE ',
     1       'EXTRACTION DATA REQUIRED FOR REAL EIGENVALUE ANALYSIS.')
 7320 FORMAT (//////,' MODAL FLUTTER ANALYSIS ERROR NO. 3  ATTEMPT TO ',
     1       'EXECUTE MORE THAN 100 LOOPS.')
 7330 FORMAT (//////,' MODAL FLUTTER ANALYSIS ERROR NO. 4  REAL ',
     1       'EIGENVALUES REQUIRED FOR MODAL FORMULATION.')
 7340 FORMAT (//////,' MODAL FLUTTER ANALYSIS ERROR NO. 5  NO GRID ',
     1       'POINT DATA IS SPECIFIED OR NO STRUCTURAL ELEMENTS HAVE ',
     2       'BEEN DEFINED.')
C
C    AERO APPROACH - RIGID FORMAT 11
C
 7400 FORMAT (//////,' MODAL AEROELASTIC RESPONSE ERROR NO. 1  MASS ',
     1       'MATRIX REQUIRED FOR MODAL FORMULATION.')
 7410 FORMAT (//////,' MODAL AEROELASTIC RESPONSE ERROR NO. 2  ',
     1       'EIGENVALUE EXTRACTION DATA REQUIRED FOR REAL EIGENVALUE ',
     2       'ANALYSIS.')
 7420 FORMAT (//////,' MODAL AEROELASTIC RESPONSE ERROR NO. 3  NO GRID',
     1       ' POINT DATA IS SPECIFIED OR NO STRUCTURAL ELEMENTS HAVE ',
     2       'BEEN DEFINED.')
 7430 FORMAT (//////,' MODAL AEROELASTIC RESPONSE ERROR NO. 4  REAL ',
     1       'EIGENVALUES REQUIRED FOR MODAL FORMULATION.')
C
C     DMAP APPROACH
C
 7700 FORMAT (//////,10X,'DMAP ERROR',3X,I20)
 7800 IF (IC .GE. 0) RETURN
C
 7810 CONTINUE
      CALL MESAGE (-61,0,0)
C
 7820 RETURN
C
      END

      SUBROUTINE TIMAL3
C
C     ASSEMBLY LANGUAGE ROUTINE FOR TIMTS3
C
C     NOTES FROM G.CHAN/UNISYS, 10/1989
C     THIS ROUTINE IS NOT USED IN NASTRAN. IF IT IS ACTIVATED, MAKE SURE
C     THE EQUIVALENCE OF A=B=C=D=AC=BC=CC=DC=AD=BD=CD=DD IS REMOVED
C
      REAL             B(1),  C(1),  D(1)
      DOUBLE PRECISION AD(2), BD(1), CD(1), DD(1)
      COMPLEX          AC(1), BC(1), CC(1), DC(1)
C
      COMMON /BLANK /  N,M
      COMMON /ZZZZZZ/  A(1)
C
      EQUIVALENCE     (A(1),AC(1),AD(1), B(1),BC(1),BD(1),
     1                 C(1),CC(1),CD(1), D(1),DC(1),DD(1))
C
C
      ENTRY TMTRSP
C     ============
C     REAL SINGLE PRECISION - TIGHT LOOP
C
      DO 100 I = 1,N
      DO 110 J = 1,M
      D(J) = A(J)*B(J) + C(J)
  110 CONTINUE
  100 CONTINUE
      GO TO 999
C
C
      ENTRY TMMRSP
C     ============
C     REAL SINGLE PRECISION - MEDIUM LOOP
C
      DO 200 I = 1,N
      DO 210 J = 1,M
      D(J) = A(I)*B(J) + C(J)
  210 CONTINUE
  200 CONTINUE
      GO TO 999
C
C
      ENTRY TMLRSP
C     ============
C     REAL SINGLE PRECISION - LOOSE LOOP
C
      DO 300 I = 1,N
      DO 310 J = 1,M
      L = I+J-1
      D(J) = A(I)*B(L) + C(J)
  310 CONTINUE
  300 CONTINUE
      GO TO 999
C
C
      ENTRY TMTRDP
C     ============
C     REAL DOUBLE PRECISION - TIGHT LOOP
C
      DO 120 I = 1,N
      DO 130 J = 1,M
      DD(J) = AD(J)*BD(J) + CD(J)
  130 CONTINUE
  120 CONTINUE
      GO TO 999
C
C
      ENTRY TMMRDP
C     ============
C     REAL DOUBLE PRECISION - MEDIUM LOOP
C
      DO 220 I = 1,N
      DO 230 J = 1,M
      DD(J) = AD(I)*BD(J) + CD(J)
  230 CONTINUE
  220 CONTINUE
      GO TO 999
C
C
      ENTRY TMLRDP
C     ============
C     REAL DOUBLE PRECISION - LOOSE LOOP
C
      DO 320 I = 1,N
      DO 330 J = 1,M
      L = I + J - 1
      DD(J) = AD(I)*BD(L) + CD(J)
  330 CONTINUE
  320 CONTINUE
      GO TO 999
C
C
      ENTRY TMTCSP
C     ============
C     COMPLEX SINGLE PRECISION - TIGHT LOOP
C
      DO 410 I = 1,N
      DO 420 J = 1,M
      DC(J) = AC(J)*BC(J) + CC(J)
  420 CONTINUE
  410 CONTINUE
      GO TO 999
C
C
      ENTRY TMMCSP
C     ============
C     COMPLEX SINGLE PRECISION - MEDIUM LOOP
C
      DO 430 I = 1,N
      DO 440 J = 1,M
      DC(J) = AC(I)*BC(J) + CC(J)
  440 CONTINUE
  430 CONTINUE
      GO TO 999
C
C
      ENTRY TMLCSP
C     ============
C     COMPLEX SINGLE PRECISION - LOOSE LOOP
C
      DO 450 I = 1,N
      DO 460 J = 1,M
      L = I + J - 1
      DC(J) = AC(I)*BC(L) + CC(J)
  460 CONTINUE
  450 CONTINUE
      GO TO 999
C
C
      ENTRY TMTCDP
C     ============
C     COMPLEX DOUBLE PRECISION - TIGHT LOOP
C
      DO 160 I = 1,N
      DO 170 J = 1,M
C
C     D(J) AND D(J+1) CALCULATIONS WERE REVERSED
C     IN ORDER TO COUNTERACT THE ITERATIVE BUILD UP
C
      DD(J+1) = AD(J) * BD(J  ) - AD(J+1) * BD(J+1) + CD(J  )
      DD(J  ) = AD(J) * BD(J+1) + AD(J+1) * BD(J  ) + CD(J+1)
  170 CONTINUE
  160 CONTINUE
      GO TO 999
C
C
      ENTRY TMMCDP
C     ============
C     COMPLEX DOUBLE PRECISION - MEDIUM LOOP
C
      DO 260 I = 1,N
      DO 270 J = 1,M
      DD(J  ) = AD(I)*BD(J  ) - AD(I+1)*BD(J+1) + CD(J  )
      DD(J+1) = AD(I)*BD(J+1) + AD(I+1)*BD(J  ) + CD(J+1)
  270 CONTINUE
  260 CONTINUE
      GO TO 999
C
C
      ENTRY TMLCDP
C     ============
C     COMPLEX DOUBLE PRECISION - LOOSE LOOP
C
      DO 360 I = 1,N
      DO 370 J = 1,M
      L = I + J - 1
      DD(J  ) = AD(I)*BD(L  ) - AD(I+1)*BD(L+1) + CD(J  )
      DD(J+1) = AD(I)*BD(L+1) + AD(I+1)*BD(L  ) + CD(J+1)
  370 CONTINUE
  360 CONTINUE
C
  999 RETURN
      END

      SUBROUTINE DQUAD (ITYPE)
C
C     THIS ROUTINE GENERATES THE FOLLOWING
C
C     FOUR 6X6 DIFFERENTIAL STIFFNESS MATRICES FOR ONE PIVOT POINT OF
C     A QUADRILATERAL
C
C
C     CALLS FROM THIS ROUTINE ARE MADE TO
C           DTRBSC - BASIC BENDING TRI. ROUTINE.
C           DTRMEM - TRIANGULAR MEMBRANE ROUTINE
C           TRANSD - SUPPLIES 3X3 TRANSFORMATIONS
C           GMMATD - GENERAL MATRIX MULITPLY AND TRANSPOSE ROUTINE
C           DS1B   - INSERTION ROUTINE
C
C
C        ITYPE    = 1             2                       4
C     ECPT INDEX    QUAD1         QUAD2        TRMEM      QUAD4
C     **********    *******       *******      *******    ********
C          1        EL. ID.       EL. ID.      EL. ID.    EL. ID
C          2        SIL1          SIL1         SIL1       SIL1
C          3        SIL2          SIL2         SIL2       SIL2
C          4        SIL3          SIL3         SIL3       SIL3
C          5        SIL4          SIL4         THETA      SIL4
C          6        THETA         THETA        MAT. ID.   MEM.T1
C          7        MAT. ID. 1    MAT. ID.     T          MEM.T2
C          8        T1            T            NSM        MEM.T3
C          9        MAT. ID. 2    NSM          CID1       MEM.T4
C         10        INERTIA I     CID1         X1         THETA
C         11        MAT ID  3     X1           Y1         FLAG FOR 10
C         12        T2            Y1           Z1         GRD OFFSET
C         13        NSM           Z1           CID2       MAT. ID 1
C         14        Z1            CID2         X2         THICKNESS
C         15        Z2            X2           Y2         MAT. ID 2
C         16        CID1          Y2           Z2         INERTIA I
C         17        X1            Z2           CID3       MAT. ID 3
C         18        Y1            CID3         X3         TS/T
C         19        Z1            X3           Y3         NSM
C         20        CID2          Y3           Z3         Z1
C         21        X2            Z3           EL TEMP    Z2
C         22        Y2            CID4         EL DEFORM  MAT. ID 4
C         23        Z2            X4           LOAD TEMP  THETA
C         24        CID3          Y4           U1         FLAG FOR 23
C         25        X3            Z4           V1         INTEGRATION
C         26        Y3            EL TEMP      W1         STRESS ANGLE
C         27        Z3            EL DEFORM    U2         FLAG FOR 26
C         28        CID4          LOAD TEMP    V2         ZOFF1
C         29        X4            U1           W2         CID1
C         30        Y4            V1           U3         X1
C         31        Z4            W1           V3         Y1
C         32        EL TEMP       U2           W3         Z1
C         33        EL DEFORM     V2                      CID2
C         34        LOAD TEMP     W2                      X2
C         35        U1            U3                      Y2
C         36        V1            V3                      Z2
C         37        W1            W3                      CID3
C         38        U2            U4                      X3
C         39        V2            V4                      Y3
C         40        W2            W4                      Z3
C         41        U3                                    CID4
C         42        V3                                    X4
C         43        W3                                    Y4
C         44        U4                                    Z4
C         45        V4                                    EL TEMP
C         46        W4
C         47
C         48                                              U1
C         49                                              V1
C         50                                              W1
C         51                                              U2
C         52                                              V2
C         53                                              W2
C         54                                              U3
C         55                                              V3
C         56                                              W3
C         57                                              U4
C         58                                              V4
C         59                                              W4
C
      INTEGER         SUBSCA        ,SUBSCB        ,SUBSCC
      DOUBLE PRECISION
     1                KOUT          ,TITE          ,DPDUM        ,
     2                TJTE          ,DPDUM2        ,IVECT        ,
     3                D1            ,JVECT         ,D2           ,
     4                KVECT         ,A1            ,KSUM         ,
     5                T             ,XSUBB         ,V            ,
     6                XSUBC         ,VV            ,YSUBC        ,
     7                PROD9         ,TEMP          ,TEMP9        ,
     8                U1            ,H             ,U2           ,
     9                E             ,A             ,TEMP18       ,
     O                REQUIV        ,R             ,SIGXY        ,
     1                SIGX          ,SIGY
      DIMENSION       M(12)         ,NECPT(100)    ,REQUIV(8)    ,
     1                VQ1(3),VQ2(3) ,VQ3(3),VQ4(3) ,A(1)
      CHARACTER       UFM*23        ,UWM*25        ,UIM*29       ,
     1                SFM*25
      COMMON /XMSSG / UFM           ,UWM           ,UIM          ,
     1                SFM
      COMMON /CONDAS/ CONSTS(5)
      COMMON /SYSTEM/ IBUFF         ,NOUT          ,NOGO
      COMMON /MATIN / MATID         ,INFLAG        ,ELTEMP       ,
     1                STRESS        ,SINTH         ,COSTH
      COMMON /MATOUT/ G11           ,G12           ,G13          ,
     1                G22           ,G23           ,G33          ,
     2                RHO           ,ALPHA1        ,ALPHA2       ,
     3                ALP12         ,T SUB 0       ,G SUB E      ,
     4                SIGTEN        ,SIGCOM        ,SIGSHE       ,
     5                G2X211        ,G2X212        ,G2X222
      COMMON /DS1AAA/ NPVT          ,ICSTM         ,NCSTM
      COMMON /DS1AET/ ECPT(100)
      COMMON /DS1ADP/ KOUT(36)      ,TITE(18)      ,TJTE(18)     ,
     1                TEMP18(18)    ,D1(3)         ,D2(3)        ,
     2                A1(3)         ,V(2)          ,VV(2)        ,
     3                PROD9(9)      ,TEMP9(9)      ,H            ,
     4                U1            ,U2            ,DPDUM(1)     ,
     5                TEMP          ,DPDUM2(43)    ,E(18)        ,
     6                SIGX          ,SIGY          ,SIGXY        ,
     7                XSUBB         ,XSUBC         ,YSUBC        ,
     8                KSUM(36)      ,T(9)          ,IVECT(3)     ,
     9                JVECT(3)      ,KVECT(3)      ,R(2,4)       ,
     O                SP1(2)        ,THETA         ,SINANG       ,
     1                COSANG        ,KM            ,NBEGIN       ,
     2                JNOT          ,NPIVOT        ,NSUBC        ,
     3                ISING         ,SUBSCA        ,SUBSCB       ,
     4                SUBSCC        ,NPOINT        ,IPVT
      EQUIVALENCE     (CONSTS(4),DEGRA) , (NECPT(1),ECPT(1))     ,
     2                (REQUIV(1),R(1,1)), (VQ1(1),ECPT(17))      ,
     4                (VQ2(1),ECPT(21)) , (VQ3(1),ECPT(25))      ,
     6                (VQ4(1),ECPT(29)) , (A(1),KOUT(1))
      DATA     M   /  2, 4, 1,   3, 1, 2,   4, 2, 3,   1, 3, 4   /
C
C
C     IF ITYPE = 2, QUAD2 EST DATA IS MOVED AND STORED IN QUAD1 FORMAT
C     IF ITYPE = 4, QUAD4 EST DATA IS MOVED AND STORED IN QUAD1 FORMAT
C
      IF (ITYPE .EQ. 4) GO TO 15
      IF (ITYPE .NE. 2) GO TO 20
C
      DO 10 I = 10,40
      NPOINT = 50 - I
   10 ECPT(NPOINT+6) = ECPT(NPOINT)
C
      ECPT( 9) = ECPT(7)
      ECPT(10) =(ECPT(8)**3.0)/12.0
      ECPT(11) = ECPT(7)
      ECPT(12) = ECPT(8)
      GO TO 20
C
C     QUAD4
C
C     IF NECPT(11)=0, ECPT(10) IS THE MATERIAL PROPERTY ORIENTAION
C     ANGLE THETA. IF IT IS NOT, NECPT(10) IS MATERIAL COORDINATE
C     SYSTEM ID. IN THIS CASE, WE CAN NOT CONTINUE
C
   15 IF (NECPT(11) .NE. 0) GO TO 350
      ECPT(6) = ECPT(10)
      ECPT(7) = ECPT(13)
      ECPT(8) = ECPT(14)
      ECPT(9) = ECPT(15)
      ECPT(10)= ECPT(16)
      ECPT(11)= ECPT(17)
      ECPT(12)= ECPT(14)
      DO 17 I = 16,46
   17 ECPT(I) = ECPT(I+13)
   20 IF (ECPT(8) .EQ. 0.0) RETURN
C
C     CALL BUG (4HQDET,5,ECPT,52-6*ITYPE)
C
C     DETERMINE PIVOT POINT NUMBER
C
      DO 30 I = 1,4
      IF (NPVT .NE. NECPT(I+1)) GO TO 30
      NPIVOT = I
      GO TO 40
   30 CONTINUE
      RETURN
C
   40 THETA  = ECPT(6)*DEGRA
      SINANG = SIN(THETA)
      COSANG = COS(THETA)
C
      IF (NPIVOT-2) 50,50,60
   50 JNOT = NPIVOT + 2
      GO TO 70
   60 JNOT = NPIVOT - 2
C
C     FORMATION OF THE R-MATRIX CONTAINING COORDINATES OF THE
C     SUB TRIANGLES.  (2X4) FOR QUADRILATERAL PLATE...
C     FORMATION ALSO OF THE I,J, AND K VECTORS USED IN THE E-MATRIX.
C
C     ZERO OUT R-MATRIX
C
   70 DO 80 I = 1,8
   80 REQUIV(I) = 0.0D0
C
      DO 90 I = 1,3
      D1(I) = DBLE(VQ3(I)) - DBLE(VQ1(I))
      D2(I) = DBLE(VQ4(I)) - DBLE(VQ2(I))
   90 A1(I) = DBLE(VQ2(I)) - DBLE(VQ1(I))
C
C     NON-NORMALIZED K-VECTOR = D1 CROSS D2
C
      KVECT(1) = D1(2)*D2(3) - D2(2)*D1(3)
      KVECT(2) = D1(3)*D2(1) - D2(3)*D1(1)
      KVECT(3) = D1(1)*D2(2) - D2(1)*D1(2)
C
C     NORMALIZE K-VECTOR
C
      TEMP = DSQRT(KVECT(1)**2 + KVECT(2)**2 + KVECT(3)**2)
      IF (TEMP .EQ. 0.0D0) CALL MESAGE (-30,26,ECPT(1))
      DO 100 I = 1,3
  100 KVECT(I) = KVECT(I)/TEMP
C
C     COMPUTE H = (A1 DOT KVECT) / 2
C
      TEMP = (A1(1)*KVECT(1) + A1(2)*KVECT(2) + A1(3)*KVECT(3))/2.0D0
C
C     I-VECTOR =(A1) - H*(KVECT)    NON-NORMALIZED
C
      DO 110 I = 1,3
  110 IVECT(I) = A1(I) - TEMP*KVECT(I)
C
C     NORMALIZE I-VECTOR
C
      TEMP = DSQRT(IVECT(1)**2 + IVECT(2)**2 + IVECT(3)**2)
      IF (TEMP .EQ. 0.0D0) CALL MESAGE (-30,26,ECPT(1))
      DO 120 I = 1,3
  120 IVECT(I) = IVECT(I)/TEMP
C
C     J-VECTOR = K CROSS I, AND X3 CALCULATION
C
      JVECT(1) = KVECT(2)*IVECT(3) - IVECT(2)*KVECT(3)
      JVECT(2) = KVECT(3)*IVECT(1) - IVECT(3)*KVECT(1)
      JVECT(3) = KVECT(1)*IVECT(2) - IVECT(1)*KVECT(2)
C
C     NORMALIZE J VECTOR TO MAKE SURE
C
      TEMP =  DSQRT(JVECT(1)**2 + JVECT(2)**2 + JVECT(3)**2)
      IF (TEMP .EQ. 0.0D0) CALL MESAGE (-30,26,ECPT(1))
      DO 130 I = 1,3
  130 JVECT(I) = JVECT(I)/TEMP
C
C     X3 GOES INTO R(1,3) = D1 DOT IVECT
C
      R(1,3) = D1(1)*IVECT(1) + D1(2)*IVECT(2) + D1(3)*IVECT(3)
C
C     X2 GOES INTO R(1,2) AND Y3 GOES INTO R(2,3)
C
      R(1,2) = A1(1)*IVECT(1) + A1(2)*IVECT(2) + A1(3)*IVECT(3)
      R(2,3) = D1(1)*JVECT(1) + D1(2)*JVECT(2) + D1(3)*JVECT(3)
C
C     X4 GOES INTO R(1,4) AND Y4 GOES INTO R(2,4)
C
      R(1,4) = D2(1)*IVECT(1) + D2(2)*IVECT(2) + D2(3)*IVECT(3) + R(1,2)
      R(2,4) = D2(1)*JVECT(1) + D2(2)*JVECT(2) + D2(3)*JVECT(3)
C
C     AT THIS POINT, THE COORDINATES OF THE PLATE IN THE ELEMENT
C     SYSTEM ARE STORED IN THE R-MATRIX WHERE THE COLUMN DENOTES THE
C     POINT AND THE ROW DENOTES THE X OR Y COORDINATE FOR ROW 1 OR
C     ROW 2 RESPECTIVELY.
C
C     SET UP THE M-MATRIX FOR MAPPING TRIANGLES, IN DATA STATEMENT.
C
C     COMPUTE SUB-TRIANGLE COORDINATES
C
C     ZERO OUT KSUM MATRICES
C
      DO 150 I = 1,36
  150 KSUM(I) = 0.0D0
C
      ELTEMP = ECPT(32)
C
C     MOVE ECPT INTO POSITIONS 51-93
C
      DO 160 I = 1,46
  160 ECPT(I+50) = ECPT(I)
C
C     MOVE MISCELLANEOUS VARIABLES INTO TRMEM FORMAT
C
      ECPT( 6) = ECPT( 7)
      ECPT( 7) = ECPT( 8)
      ECPT(21) = ECPT(32)
      ECPT(22) = ECPT(33)
      ECPT(23) = ECPT(34)
C
      DO 240 J = 1,4
      IF (J .EQ. JNOT) GO TO 240
      KM   = 3*J - 3
      IPVT = 0
      DO 190 I = 1,3
      NPOINT = KM+I
      NSUBC  = M(NPOINT)
      IF (NSUBC .EQ. NPIVOT) IPVT = I
      NECPT(I+1) = NECPT(NSUBC+51)
      DO 170 K = 1,4
      NPOINT = 4*(NSUBC-1) + K + 65
      SUBSCA = 4*(I-1) + K + 8
      ECPT(SUBSCA) = ECPT(NPOINT)
  170 CONTINUE
      DO 180 K = 1,3
      NPOINT = 3*(NSUBC-1) + K + 84
      SUBSCA = 3*(I-1) + K + 23
      ECPT(SUBSCA) = ECPT(NPOINT)
  180 CONTINUE
  190 CONTINUE
      IF (IPVT .EQ. 0) GO TO 240
C
      SUBSCA = M(KM+1)
      SUBSCB = M(KM+2)
      SUBSCC = M(KM+3)
C
      DO 200 I = 1,2
      V(I)  = R(I,SUBSCB) - R(I,SUBSCA)
  200 VV(I) = R(I,SUBSCC) - R(I,SUBSCA)
      XSUBB = DSQRT(V(1)**2 + V(2)**2)
      U1    = V(1)/XSUBB
      U2    = V(2)/XSUBB
      XSUBC = U1*VV(1) + U2*VV(2)
      YSUBC = U1*VV(2) - U2*VV(1)
C
C     SET UP OF T-MATRIX
C
      T(1) = 1.0D0
      T(2) = 0.0D0
      T(3) = 0.0D0
      T(4) = 0.0D0
      T(5) = U1
      T(6) = U2
      T(7) = 0.0D0
      T(8) =-U2
      T(9) = U1
C
      SINTH = SINANG*U1 - COSANG*U2
      COSTH = COSANG*U1 + SINANG*U2
      IF (ABS(SINTH) .LT. 1.0E-06) SINTH = 0.0
C
C     AT THIS POINT, XSUBB, XSUBC, YSUBC ARE AT HAND FOR TRIANGLE -J-
C
      CALL DTRMEM (3)
      CALL DTRBSC (2,IPVT)
C
C     NOW WE HAVE AT HAND  K   I=NPIVOT,J=1,2,3   THREE 6X6 MATRICES
C                           IJ
C                                STORED AT  A(1) THROUGH A(27)
C
C     MAP THE THE 3X3 S FOR THE PIVOT ROW INTO THE SUMMATION ARRAYS
C
      DO 230 I = 1,3
      NPOINT = 9*I - 8
C
      CALL GMMATD (T,3,3,1, A(NPOINT),3,3,0, TEMP9)
      CALL GMMATD (TEMP9,3,3,0, T,3,3,0, PROD9)
C
C     ADD THIS PRODUCT IN NOW.
C
      NPOINT = KM + I
      NPOINT = 9*M(NPOINT) - 9
      DO 220 K = 1,9
      NPOINT = NPOINT + 1
  220 KSUM(NPOINT) = KSUM(NPOINT) + PROD9(K)/2.0D0
  230 CONTINUE
C
  240 CONTINUE
C
C     CALL BUG (4HQDKD,220,KSUM,72)
C
C     FILL E-MATRIX
C
      DO 250 I = 1,18
  250 E(I)  = 0.0D0
      E( 1) = KVECT(1)
      E( 4) = KVECT(2)
      E( 7) = KVECT(3)
      E(11) = IVECT(1)
      E(14) = IVECT(2)
      E(17) = IVECT(3)
      E(12) = JVECT(1)
      E(15) = JVECT(2)
      E(18) = JVECT(3)
C
C              T
C     FORM   T   E      STORE IN TITE-MATRIX (6X3)
C             I
C
      IF (NECPT(4*NPIVOT + 62) .EQ. 0) GO TO 260
      CALL TRANSD (NECPT(4*NPIVOT+62),T)
      CALL GMMATD (T,3,3,1, E( 1),3,3,0, TITE( 1))
      CALL GMMATD (T,3,3,1, E(10),3,3,0, TITE(10))
      GO TO 290
C
  260 DO 270 K = 1,18
  270 TITE(K) = E(K)
C
C     RESTORE ECPT FOR CKECKOUT
C
      DO 280 K = 1,46
  280 ECPT(K) = ECPT(K+50)
C
  290 DO 330 J = 1,4
C
C     TRANSFORMATIONS AND INSERTION
C
      IF (NECPT(4*J+62) .EQ. 0) GO TO 300
      CALL TRANSD (NECPT(4*J+62),T)
      CALL GMMATD (T,3,3,1, E(1),3,3,0,  TJTE( 1))
      CALL GMMATD (T,3,3,1, E(10),3,3,0, TJTE(10))
      GO TO 320
C
  300 DO 310 K = 1,18
  310 TJTE(K) = E(K)
  320 CALL GMMATD (KSUM(9*J-8),3,3,0, TJTE,6,3,1, TEMP18(1))
      CALL GMMATD (TITE(1),6,3,0, TEMP18(1),3,6,0, KOUT(1))
      CALL DS1B (KOUT,NECPT(J+51))
  330 CONTINUE
      RETURN
C
C     COULD NOT CONTINUE
C
  350 WRITE  (NOUT,360) SFM
  360 FORMAT (A25,', DEFFICIENT SOURCE CODE IN DQUAD TO HANDLE CQUAD4 ',
     1       'ELEMENT WITH MATERIAL', /5X,
     2       'PROPERTY COORD. SYSTEM. ANGLE MUST BE SPECIFIED')
      NOGO = 1
      RETURN
      END

      SUBROUTINE PLA1
C
C     THIS FUNCTIONAL MODULE IS THE FIRST OF FOUR FUNCTIONAL MODULES
C     UNIQUE TO THE PIECE-WISE LINEAR ANALYSIS (DISPLACEMENT METHOD)
C     RIGID FORMAT
C
C
C     PLA1   CSTM,MPT,ECPT,GPCT,DIT,CASECC,EST /KGGL,ECPTNL,ESTL,ESTNL/
C            V,N,KGGLPG/V,N,NPLALIM/V,N,ECPTNLPG/V,N,PLSETNO/
C            V,N,NONLSTR/V,N,PLFACT/ $
C
C     THE OUTPUT DATA BLOCKS AND PARAMETERS ARE DEFINED AS FOLLOWS -
C
C     KGGL   IS THE STIFFNESS MATRIX OF LINEAR (NON-STRESS DEPENDENT)
C            ELEMENTS
C     ECPTNL IS A SUBSET OF THE ECPT WHICH CONTAINS ECPT PLUS STRESS
C            INFORMATION FOR THE NON-LINEAR (STRESS DEPENDENT) ELEMENTS
C     ESTL,  A SUBSET OF THE EST, CONTAINS ALL LINEAR ELEMENTS
C     ESTNL, THE COMPLEMENT OF THE ESTL, CONTAINS INFORMATION FOR THE
C            NON-LINEAR ELEMENTS
C
C     PARAMETER NAMES BELOW ARE FORTRAN VARIABLE NAMES RATHER THAN DMAP
C     PARAMETER NAMES
C
C     KGGLPG IS THE PURGE FLAG FOR THE KGGL AND ESTL DATA BLOCKS.  IT IS
C            SET = -1 (PURGE=YES) IF ALL ELEMENTS ARE STRESS DEPENDENT
C     NPLALP IS THE NUMBER OF PASSES THAT WILL BE MADE THRU THE PLA LOOP
C     KICKOF IS SET = -1 (KICK THE USER OFF THE MACHINE = YES) IF THE
C            DIT IS PURGED OR ALL ELEMENTS ARE NON-STRESS DEPENDENT
C     PLASET IS THE SET NUMBER ON THE PLFACT CARD THAT IS OBTAINED FROM
C            THE FIRST RECORD OF CASECC
C     NONLST IS THE FLAG SUCH THAT IF IT IS A -1 THE USER DOES NOT WISH
C            TO OUTPUT HIS NON-LINEAR STRESSES.  HENCE PLA3 WILL NOT BE
C            CALLED
C     PLFACT IS THE FIRST PIECE-WISE LINEAR FACTOR TO BE USED FROM
C            PLASET
C
      LOGICAL          PHASE1,ALL,HEAT
      INTEGER          BUFR1,BUFR2,BUFR3,BUFR4,BUFSZ,IZ(1),EOR,CLSRW,
     1                 CLSNRW,OUTRW,FROWIC,TNROWS,CSTM,DIT,ECPT,GPCT,
     2                 ECPTNL,ESTL,ESTNL,PLAARY(90),FILE,TRAIL,PLASET,
     3                 PLANOS(2),SETNO,OUTFIL,IECPT(100),ESTLTR(7),
     4                 ESTNLT(7),YESSD,EST,CASECC
      DOUBLE PRECISION DZ(1),DPDUM,DPWORD
      DIMENSION        NAME(2),INPVT(2)
      CHARACTER        UFM*23,UWM*25
      COMMON /XMSSG /  UFM,UWM
      COMMON /BLANK /  KGGLPG,NPLALP,KICKOF,PLASET,NONLST,PLFACT(2)
      COMMON /SYSTEM/  BUFSZ,ISYSPT,ISP1(37),NBPW,ISP2(14),IPREC
      COMMON /SMA1IO/  CSTM,MPT,DIT,BUFR1,ECPT,BUFR2,GPCT,BUFR3,BUFR4,
     1                 ITYPE,KGGL,ESTNL,ECPTNL,DUM1,ESTL,DUM2,INRW,
     2                 OUTRW,CLSNRW,CLSRW,NEOR,EOR,MCBKGG(7),TRAIL(7)
      COMMON /ZZZZZZ/  Z(1)
      COMMON /SMA1BK/  ICSTM,NCSTM,IGPCT,NGPCT,IPOINT,NPOINT,I6X6K,
     1                 DUM4,DUM5,DUM6
      COMMON /SMA1CL/  IOPT4,DUM7,NPVT,LEFT,FROWIC,LROWIC,NROWSC,
     1                 TNROWS,JMAX,NLINKS,LINK(10),DUM8,DUM9,NOGO
      COMMON /GPTA1 /  NELEMS,LAST,INCR,NE(1)
      COMMON /SMA1ET/  XECPT(100)
      COMMON /SMA1DP/  DPDUM(300)
      COMMON /SMA1HT/  HEAT
      COMMON /ZBLPKX/  DPWORD,LLLLLL(2),INDEX
      COMMON /MATIN /  MATID,INFLAG,FILLER(4)
      COMMON /MATOUT/  INDSTR,YYYYYY(19)
      EQUIVALENCE      (Z(1),IZ(1),DZ(1)) ,(IECPT(1),XECPT(1)),
     1                 (MCBKGG(1),ESTLTR(1)), (TRAIL(1),ESTNLT(1)),
     2                 (TRAIL(2),NNLEL), (ESTLTR(2),NLEL),
     3                 (FNN,NN), (INDSTR,E)
      DATA             CASECC,JSTSET,JPLSET,JSYM /106,23,164,200 /
      DATA             NAME  / 4HPLA1,4H    /, HMPT  / 4HMPT     /
      DATA             PLANOS/ 1103, 11     /
      DATA             PLAARY/ 1,  0,  1,  0,  0,    1,  0,  0,  1,  1,
     1                         0,  0,  0,  0,  0,    1,  1,  1,  1,  0,
     2                         0,  0,  0,  0,  0,    0,  0,  0,  0,  0,
     3                         0,  0,  0,  1,  0,    0,  0,  0,  0,  0,
     4                         0,  0,  0,  0,  0,    0,  0,  0,  0,  0,
     5                         0,  0,  0,  0,  0,    0,  0,  0,  0,  0,
     6                      30*0 /
C
C     IF THE DIT HAS BEEN PURGED, WE CANNOT PROCEED FURTHER
C
      IPR = IPREC
      CALL DELSET
      TRAIL(1) = DIT
      CALL RDTRL (TRAIL)
      IF (TRAIL(1) .LT. 0) CALL MESAGE (-1,DIT,NAME)
C
C     INITIALIZE HEAT PARAMETER
C
      HEAT = .FALSE.
C
C     INITIALIZE MODULE PARAMETERS AND SET IOPT4 = 0, SO THAT ELEMENT
C     ROUTINES WILL NOT CALCULATE STRUCTURAL DAMPING MATRICES.
C
      KGGLPG =-1
      NPLALP = 1
      KICKOF =-1
      PLASET =-1
      NONLST = 1
      PLFACT(1) = 1.0
      IOPT4  = 0
      ESTNL  = 204
      EST    = 107
      PHASE1 = .TRUE.
      ASSIGN 290 TO NOSD
C
C     SET UP BUFFERS AND INITIALIZE FILE TRAILERS.
C
      IZMAX = KORSZ (Z)
      BUFR1 = IZMAX - BUFSZ
      BUFR2 = BUFR1 - BUFSZ
      BUFR3 = BUFR2 - BUFSZ
      BUFR4 = BUFR3 - BUFSZ
      LEFT  = BUFR4 - 1
      CALL MAKMCB (MCBKGG,KGGL,0,6,IPR)
      CALL MAKMCB (TRAIL,ECPTNL,0,0,0)
C
C     CHECK PLAARY SIZE
C
      IF (NELEMS .GT. 90) WRITE (ISYSPT,1) UWM
    1 FORMAT (A25,' 2151, -PLAARY- ARRAY IS SMALLER THAN MAXIMUM ',
     1       'NUMBER OF ELEMENT TYPES.')
C
C     OPEN THE KGGL FILE FOR OUTPUT
C
      CALL GOPEN (KGGL,Z(BUFR1),1)
C
C     ATTEMPT TO READ THE CSTM INTO CORE
C
      ICSTM = 0
      NCSTM = 0
      FILE  = CSTM
      CALL OPEN (*20,CSTM,Z(BUFR2),INRW)
      CALL FWDREC (*870,CSTM)
      CALL READ (*870,*10,CSTM,Z(ICSTM+1),LEFT,EOR,NCSTM)
C
C     INSUFFICIENT CORE - CALL MESAGE
C
      CALL MESAGE (-8,0,NAME)
   10 LEFT = LEFT - NCSTM
      CALL CLOSE (CSTM,CLSRW)
C
C     CALL PRETRD TO SET UP FUTURE CALLS TO TRANSD.
C
      CALL PRETRD (Z(ICSTM+1),NCSTM)
      CALL PRETRS (Z(ICSTM+1),NCSTM)
C
C     CALL PREMAT TO READ THE MPT AND THE DIT AND TO SET UP FUTURE CALLS
C     TO SUBROUTINE MAT.  NOTE NEGATIVE ISGN FOR DIT TO TRIGGER PLA FLAG
C     IN MAT.
C
   20 IMAT  = NCSTM
      CALL PREMAT (IZ(IMAT+1),Z(IMAT+1),Z(BUFR2-3),LEFT,MUSED,MPT,-DIT)
      LEFT  = LEFT  - MUSED
      IGPCT = NCSTM + MUSED
C
C     OPEN THE INPUT FILES ECPT AND GPCT AND THE OUTPUT FILE ECPTNL.
C
      CALL GOPEN (ECPT,  Z(BUFR2),0)
      CALL GOPEN (GPCT,  Z(BUFR3),0)
      CALL GOPEN (ECPTNL,Z(BUFR4),1)
      ILEFT = LEFT
C
C     BEGIN MAIN LOOP FOR PROCESSING THE ECPT.
C
   30 CALL READ (*650,*630,GPCT,INPVT(1),2,NEOR,IFLAG)
      NGPCT = INPVT(2)
      LEFT  = ILEFT - 2*NGPCT
      IF (LEFT .LE. 0) CALL MESAGE (-8,0,NAME)
      CALL FREAD (GPCT,IZ(IGPCT+1),NGPCT,EOR)
C
C     FROWIC IS THE FIRST ROW IN CORE (1 .LE. FROWIC .LE. 6)
C
      FROWIC = 1
      IPOINT = IGPCT  + NGPCT
      NPOINT = NGPCT
      I6X6K  = IPOINT + NPOINT
C
C     MAKE I6X6K A DOUBLE PRECISION INDEX (I6X6K POINTS TO THE 0TH
C     LOCATION OF THE 6 X 6 SUBMATRIX OF KGGL IN CORE)
C
      I6X6K = (I6X6K-1)/2 + 2
C
C     CONSTRUCT THE POINTER TABLE WHICH WILL ENABLE SUBROUTINE SMA1B TO
C     ADD THE ELEMENT STIFFNESS MATRICES TO KGGL.
C
      IZ(IPOINT+1) = 1
      I1 = 1
      I  = IGPCT
      J  = IPOINT + 1
   40 I1 = I1 + 1
      IF (I1 .GT. NGPCT) GO TO 50
      I  = I + 1
      J  = J + 1
      INC= 6
      IF (IZ(I) .LT. 0) INC = 1
      IZ(J) = IZ(J-1) + INC
      GO TO 40
C
C     JMAX = THE NO. OF COLUMNS OF KGGL THAT WILL BE GENERATED WITH THE
C     CURRENT PIVOT POINT.
C
   50 INC   = 5
      ILAST = IGPCT  + NGPCT
      JLAST = IPOINT + NPOINT
      IF (IZ(ILAST) .LT. 0) INC = 0
      JMAX  = IZ(JLAST) + INC
C
C     TNROWS = TOTAL NO. OF ROWS OF THE MATRIX TO BE GENERATED
C
      TNROWS = 6
      IF (INPVT(1) .LT. 0) TNROWS = 1
      IF (2*TNROWS*JMAX .LT. LEFT) GO TO 70
C
C     THE WHOLE SUBMATRIX CANNOT FIT IN CORE
C
      IF (TNROWS .EQ. 1) CALL MESAGE (-8,0,NAME)
      NROWSC = 3
      PLAARY(39) = NAME(1)
   60 PLAARY(40) = NPVT
      CALL MESAGE (30,85,PLAARY(39))
      IF (2*NROWSC*JMAX .LT. LEFT) GO TO 80
      NROWSC = NROWSC - 1
      IF (NROWSC .EQ. 0) CALL MESAGE (-8,0,NAME)
      GO TO 60
   70 NROWSC = TNROWS
   80 FROWIC = 1
      LROWIC = FROWIC + NROWSC - 1
C
C     ZERO OUT THE KGGL SUBMATRIX IN CORE.
C
      LOW = I6X6K + 1
      LIM = I6X6K + JMAX*NROWSC
      DO 90 I = LOW,LIM
   90 DZ(I) = 0.0D0
C
C     INITIALIZE THE LINK VECTOR TO -1
C
      DO 100 I = 1,NLINKS
  100 LINK(I) = -1
      LINCOR  =  1
      FILE = ECPT
C
C     TURN FIRST PASS, FIRST ELEMENT READ ON THE CURRENT PASS OF THE
C     ECPT RECORD, AND PIVOT POINT WRITTEN INDICATORS ON.
C
      IPASS  = 1
      NPVTWR = 0
  110 IFIRST = 1
C
C     READ THE FIRST WORD OF THE ECPT RECORD, THE PIVOT POINT, INTO NPVT
C
      CALL FREAD (ECPT,NPVT,1,NEOR)
C
C     READ THE NEXT ELEMENT TYPE INTO ITYPE, AND READ THE PRESCRIBED NO.
C     OF WORDS INTO THE XECPT ARRAY.
C
  120 CALL READ (*870,*520,ECPT,ITYPE,1,NEOR,IFLAG)
      IDX = (ITYPE-1)*INCR
      NN  = NE(IDX+12)
      CALL FREAD (ECPT,XECPT,NN,NEOR)
      ITEMP = NE(IDX+22)
      IF (IPASS .NE. 1) GO TO 290
C
C     THIS IS THE FIRST PASS.  IF THE ELEMENT IS IN THE PLA SET, CALL
C     THE MAT ROUTINE TO FIND OUT IF ANY OF THE MATERIAL PROPERTIES IS
C     STRESS DEPENDENT.
C
C
C              CROD      CBEAM     CTUBE     CSHEAR    CTWIST    CTRIA1
C                 1        2         3          4         5         6
C              CTRBSC    CTRPLT    CTRMEM    CONROD    ELAS1     ELAS2
C               7           8         9        10        11        12
C              ELAS3     ELAS4     CQDPLT    CQDMEM    CTRIA2    CQUAD2
C               13        14         15        16        17        18
C              CQUAD1    CDAMP1    CDAMP2    CDAMP3    CDAMP4    CVISC
C               19        20        21         22        23        24
C              MASS1     CMASS2    CMASS3    CMASS4    CONM1     CONM2
C                25        26        27        28        29        30
C              PLOTEL    REACT     QUAD3     CBAR      CCONE
C                31        32        33       34         35
      IF (ITYPE .GT. 35) GO TO 120
      GO TO (130,890,150,290,290,160,290,290,170,130,
     1       290,290,290,290,290,180,190,200,210,120,
     2       120,120,120,120,120,120,120,120,120,120,
     3       120,890,890,220,290), ITYPE
C
C     ROD
C
  130 MATID = IECPT(4)
      ASSIGN 140 TO YESSD
      GO TO 230
  140 XECPT(18) = 0.0
      XECPT(19) = 0.0
      INFLAG = 1
      CALL MAT (IECPT(1))
      XECPT(20) = E
      IF (PHASE1) GO TO 145
      XECPT(21) = 0.0
      NWDS = 21
      GO TO 765
  145 NWDS = 20
      GO TO 260
C
C     TUBE
C
  150 MATID = IECPT(4)
      ASSIGN 155 TO YESSD
      GO TO 230
  155 XECPT(17) = 0.0
      XECPT(18) = 0.0
      INFLAG = 1
      CALL MAT (IECPT(1))
      XECPT(19) = E
      IF (PHASE1) GO TO 157
      XECPT(20) = 0.0
      NWDS = 20
      GO TO 765
  157 NWDS = 19
      GO TO 260
C
C     TRIA1
C
  160 MATID = IECPT(6)
      ASSIGN 165 TO YESSD
      GO TO 230
  165 DO 166 I = 28,33
  166 XECPT(I) = 0.0
      INFLAG = 1
      CALL MAT (IECPT(1))
      XECPT(30) = E
      IF (PHASE1) GO TO 168
      DO 167 I = 34,38
  167 XECPT(I) = 0.0
      NWDS = 38
      GO TO 765
  168 NWDS = 33
      GO TO 260
C
C     TRMEM
C
  170 MATID = IECPT(6)
      ASSIGN 175 TO YESSD
      GO TO 230
  175 DO 176 I = 22,27
  176 XECPT(I) = 0.0
      INFLAG = 1
      CALL MAT (IECPT(1))
      XECPT(24) = E
      NWDS = 27
      IF (PHASE1) GO TO 260
      GO TO 765
C
C     QDMEM
C
  180 MATID = IECPT(7)
      ASSIGN 185 TO YESSD
      GO TO 230
  185 DO 186 I = 27,32
  186 XECPT(I) = 0.0
      INFLAG = 1
      CALL MAT (IECPT(1))
      XECPT(29) = E
      NWDS = 32
      IF (PHASE1) GO TO 260
      GO TO 765
C
C     TRIA2
C
  190 MATID = IECPT(6)
      ASSIGN 195 TO YESSD
      GO TO 230
  195 DO 196 I = 22,27
  196 XECPT(I) = 0.0
      INFLAG = 1
      CALL MAT (IECPT(1))
      XECPT(24) = E
      IF (PHASE1) GO TO 198
      DO 197 I = 28,32
  197 XECPT(I) = 0.0
      NWDS = 32
      GO TO 765
  198 NWDS = 27
      GO TO 260
C
C     QUAD2
C
  200 MATID = IECPT(7)
      ASSIGN 205 TO YESSD
      GO TO 230
  205 DO 206 I = 27,32
  206 XECPT(I) = 0.0
      INFLAG = 1
      CALL MAT (IECPT(1))
      XECPT(29) = E
      IF (PHASE1) GO TO 208
      DO 207 I = 33,37
  207 XECPT(I) = 0.0
      NWDS = 37
      GO TO 765
  208 NWDS = 32
      GO TO 260
C
C     QUAD1
C
  210 MATID = IECPT(7)
      ASSIGN 215 TO YESSD
      GO TO 230
  215 DO 216 I = 33,38
  216 XECPT(I) =0.0
      INFLAG = 1
      CALL MAT (IECPT(1))
      XECPT(35) = E
      IF (PHASE1) GO TO 218
      DO 217 I = 39,43
  217 XECPT(I) = 0.0
      NWDS = 43
      GO TO 765
  218 NWDS = 38
      GO TO 260
C
C     BAR - IF COORDINATE 1 OF EITHER PT. A OR PT. B IS PINNED THE
C           ELEMENT IS TREATED AS LINEAR (NON-STRESS DEPENDENT)
C
  220 IF (IECPT(8).EQ.0 .AND. IECPT(9).EQ.0) GO TO 224
      KA = IECPT(8)
      KB = IECPT(9)
  222 IF (MOD(KA,10).EQ.1 .OR. MOD(KB,10).EQ.1) GO TO 290
      KA = KA/10
      KB = KB/10
      IF (KA.LE.0 .AND. KB.LE.0) GO TO 224
      GO TO 222
  224 MATID = IECPT(16)
      ASSIGN 226 TO YESSD
      GO TO 230
  226 XECPT(43) = 0.0
      XECPT(44) = 0.0
      INFLAG = 1
      CALL MAT (IECPT(1))
      XECPT(45) = E
      IF (PHASE1) GO TO 228
      DO 227 I = 46,50
  227 XECPT(I) = 0.0
      NWDS = 50
      GO TO 765
  228 NWDS = 45
      GO TO 260
C
C     TEST TO SEE IF ELEMENT IS STRESS DEPENDENT.
C
  230 INFLAG = 5
      CALL MAT (IECPT(1))
      IF (INDSTR) 240,240,250
  240 GO TO NOSD,  (290,820)
  250 GO TO YESSD, (140,155,165,175,185,195,205,215,226)
C
C     WRITE AN ENTRY ONTO ECPTNL
C
  260 IF (NPVTWR) 270,270,280
  270 NPVTWR = 1
      CALL WRITE (ECPTNL,NPVT,1,NEOR)
      KICKOF = 1
  280 CALL WRITE (ECPTNL,ITYPE,1,NEOR)
      CALL WRITE (ECPTNL,XECPT,NWDS,NEOR)
      NNLEL = NNLEL + 1
      GO TO 120
C
C     IF THIS IS THE 1ST ELEMENT READ ON THE CURRENT PASS OF THE ECPT,
C     CHECK TO SEE IF THIS ELEMENT IS IN A LINK THAT HAS ALREADY BEEN
C     PROCESSED.
C
  290 KGGLPG = 1
      IF (IFIRST .EQ. 1) GO TO 300
C
C     THIS IS NOT THE FIRST PASS.  IF ITYPE(TH) ELEMENT ROUTINE IS IN
C     CORE, PROCESS IT.
C
      IF (ITEMP .EQ. LINCOR) GO TO 310
C
C     THE ITYPE(TH) ELEMENT ROUTINE IS NOT IN CORE.  IF THIS ELEMENT
C     ROUTINE IS IN A LINK THAT ALREADY HAS BEEN PROCESSED READ THE NEXT
C     ELEMENT.
C
      IF (LINK(ITEMP) .EQ. 1) GO TO 120
C
C     SET A TO BE PROCESSED LATER FLAG FOR THE LINK IN WHICH THE ELEMENT
C     RESIDES
C
      LINK(ITEMP) = 0
      GO TO 120
C
C     SINCE THIS IS THE FIRST ELEMENT TYPE TO BE PROCESSED ON THIS PASS
C     OF THE ECPT RECORD, A CHECK MUST BE MADE TO SEE IF THIS ELEMENT
C     IS IN A LINK THAT HAS ALREADY BEEN PROCESSED.  IF IT IS SUCH AN
C     ELEMENT, WE KEEP IFIRST = 1 AND READ THE NEXT ELEMENT.
C
  300 IF (LINK(ITEMP) .EQ. 1) GO TO 120
C
C     SET THE CURRENT LINK IN CORE = ITEMP AND IFIRST = 0
C
      LINCOR = ITEMP
      IFIRST = 0
C
C     CALL THE PROPER ELEMENT ROUTINE.
C
C            CROD  CBEAM  CTUBE  CSHEAR  CTWIST  CTRIA1  CTRBSC
C              1     2      3       4       5       6       7
C          CTRPLT  CTRMEM  CONROD  ELAS1  ELAS2  ELAS3  ELAS4
C             8       9      10      11     12     13     14
C          CQDPLT  CQDMEM  CTRIA2  CQUAD2 CQUAD1  CDAMP1  CDAMP2
C            15      16      17      18      19     20      21
C          CDAMP3  CDAMP4  CVISC  CMASS1  CMASS2  CMASS3  CMASS4
C            22      23      24     25      26      27      28
C           CONM1  CONM2   PLOTEL REACT   QUAD3   CBAR    CCONE
C             29     30      31     32      33     34       35
  310 IF (ITYPE .GT. 35) GO TO 120
      GO TO (320,890,340,350,360,370,380,390,400,320,
     1       410,420,430,440,450,460,470,480,490,120,
     2       120,120,120,120,120,120,120,120,120,120,
     3       120,890,890,500,510), ITYPE
  320 CALL KROD
      GO TO 120
  340 CALL KTUBE
      GO TO 120
  350 CALL KPANEL (4)
      GO TO 120
  360 CALL KPANEL (5)
      GO TO 120
  370 CALL KTRIQD (1)
      GO TO 120
  380 CALL KTRBSC (0)
      GO TO 120
  390 CALL KTRPLT
      GO TO 120
  400 CALL KTRMEM (0)
      GO TO 120
  410 CALL KELAS (1)
      GO TO 120
  420 CALL KELAS (2)
      GO TO 120
  430 CALL KELAS (3)
      GO TO 120
  440 CALL KELAS (4)
      GO TO 120
  450 CALL KQDPLT
      GO TO 120
  460 CALL KQDMEM
      GO TO 120
  470 CALL KTRIQD (2)
      GO TO 120
  480 CALL KTRIQD (4)
      GO TO 120
  490 CALL KTRIQD (3)
      GO TO 120
  500 CALL KBAR
      GO TO 120
  510 IF (NBPW .LE. 32) CALL KCONED
      IF (NBPW .GT. 32) CALL KCONES
      GO TO 120
C
C     AN END OF LOGICAL RECORD HAS BEEN HIT ON THE ECPT.  IF NPVTWR = 0,
C     THE PIVOT POINT HAS NOT BEEN WRITTEN ON ECPTNL AND NO ELEMENTS IN
C     THE CURRENT ECPT RECORD ARE PLASTIC.
C
  520 IF (IPASS .NE. 1) GO TO 550
      IF (NPVTWR) 530,530,540
  530 CALL WRITE (ECPTNL,-NPVT,1,EOR)
      GO TO 550
  540 CALL WRITE (ECPTNL,0,0,EOR)
  550 IPASS = 2
      LINK(LINCOR) = 1
      DO 560 I = 1,NLINKS
      IF (LINK(I) .EQ. 0) GO TO 570
  560 CONTINUE
      GO TO 580
C
C     SINCE AT LEAST ONE LINK HAS NOT BEEN PROCESSED THE ECPT FILE MUST
C     BE BACKSPACED
C
  570 CALL BCKREC (ECPT)
      GO TO 110
C
C     WRITE THE NO. OF ROWS IN CORE UNTO THE KGGL FILE USING ZBLPKI.
C
  580 I1  = 0
  590 I2  = 0
      IBEG = I6X6K + I1*JMAX
      CALL BLDPK (2,IPR,KGGL,0,0)
  600 I2  = I2 + 1
      IF (I2 .GT. NGPCT) GO TO 620
      JJ  = IGPCT + I2
      INDEX = IABS(IZ(JJ)) - 1
      LIM = 6
      IF (IZ(JJ) .LT. 0) LIM = 1
      JJJ = IPOINT + I2
      KKK = IBEG + IZ(JJJ) - 1
      I3  = 0
  610 I3  = I3 + 1
      IF (I3 .GT. LIM) GO TO 600
      INDEX = INDEX + 1
      KKK = KKK + 1
      DPWORD = DZ(KKK)
      IF (DPWORD .NE. 0.0D0) CALL ZBLPKI
      GO TO 610
  620 CALL BLDPKN (KGGL,0,MCBKGG)
      I1  = I1 + 1
      IF (I1 .LT. NROWSC) GO TO 590
C
C     IF LROWIC = TNROWS, PROCESSING OF THE CURRENT ECPT RECORD HAS BEEN
C     COMPLETED.
C
      IF (LROWIC .EQ. TNROWS) GO TO 30
      CALL BCKREC (ECPT)
      FROWIC = FROWIC + NROWSC
      LROWIC = LROWIC + NROWSC
      IPASS  = 2
      GO TO 110
C
C     NO ELEMENTS ARE CONNECTED TO THE PIVOT POINT.  OUTPUT ZERO
C     COLUMN(S).  ALSO, WRITE NEGATIVE PIVOT POINT ON ECPTNL.
C
  630 LIM = 6
      IF (INPVT(1) .LT. 0) LIM = 1
      DO 640 I = 1,LIM
      CALL BLDPK (2,IPR,KGGL,0,0)
  640 CALL BLDPKN (KGGL,0,MCBKGG)
      CALL SKPREC (ECPT,1)
      CALL WRITE (ECPTNL,-IABS(INPVT(1)),1,EOR)
      GO TO 30
C
C     ECPT PROCESSING HAS BEEN COMPLETED SINCE AN EOF HAS BEEN READ ON
C     GPCT.
C
  650 CALL CLOSE (GPCT,CLSRW)
      CALL CLOSE (ECPT,CLSRW)
      CALL CLOSE (KGGL,CLSRW)
      CALL CLOSE (ECPTNL,CLSRW)
      IF (KICKOF   .EQ. -1) GO TO 865
      IF (MCBKGG(6) .NE. 0) GO TO 654
      DO 652 I = 2,7
  652 MCBKGG(I) = 0
      GO TO 656
  654 MCBKGG(3) = MCBKGG(2)
  656 CALL WRTTRL (MCBKGG)
      CALL WRTTRL (TRAIL)
C
C     BEGIN EST PROCESSING
C
      LEFT = BUFR4 - 1
      ICC  = NCSTM +  MUSED
      ALL  = .FALSE.
      PHASE1 = .FALSE.
C
C     READ THE FIRST RECORD OF CASECC INTO CORE.
C
      FILE = CASECC
      CALL GOPEN (CASECC,Z(BUFR1),0)
      CALL READ (*870,*658,CASECC,IZ(ICC+1),LEFT,EOR,NCC)
      CALL MESAGE (-8,0,NAME)
  658 IPLSET = ICC + JPLSET
      PLASET = IZ(IPLSET)
      ISTSET = ICC + JSTSET
      IF (IZ(ISTSET)) 660,670,680
  660 ALL = .TRUE.
      GO TO 705
  670 NONLST = -1
      GO TO 705
C
C     THE USER HAS REQUESTED A PROPER SUBSET OF HIS SET OF ELEMENTS FOR
C     WHICH HE WANTS STRESS OUTPUT.  FIND THE SET IN OPEN CORE AND
C     DETERMINE ZERO POINTER AND LENGTH OF THE SET.
C
  680 ISYM = ICC + JSYM
      ISETNO = ISYM + IZ(ISYM) + 1
      LSET = IZ(ISETNO+1)
  690 ISET = ISETNO + 2
      NSET = IZ(ISETNO+1) + ISET - 1
      IF (IZ(ISETNO) .EQ. IZ(ISTSET)) GO TO 700
      ISETNO = NSET + 1
      IF (ISETNO .LT. NCC) GO TO 690
      ALL = .TRUE.
  700 IZ(NSET+1) = 2**14 + 1
  705 CALL CLOSE (CASECC,CLSRW)
      IF (PLASET .NE. -1) GO TO 706
      JJ = 1
      PLFACT(1) = 1.0
      GO TO 731
  706 CONTINUE
C
C     SEARCH THE MPT FOR THE PLA SET
C
      FILE = MPT
      CALL PRELOC (*860,Z(BUFR1-3),MPT)
      CALL LOCATE (*895,Z(BUFR1-3),PLANOS,IFLAG)
C
C     READ A PLA SET NO.
C
  710 CALL READ (*895,*895,MPT,SETNO,1,NEOR,IFLAG)
      JJ = 0
  720 CALL READ (*895,*895,MPT,NN,1,NEOR,IFLAG)
      IF (NN .EQ. -1) GO TO 730
      JJ = JJ + 1
      IF (JJ .EQ. 1) PLFACT(1) = FNN
      GO TO 720
  730 IF (SETNO .NE. PLASET) GO TO 710
      NPLALP = JJ
      PLFACT(2) = 0.0
      CALL CLOSE (MPT,CLSRW)
  731 CONTINUE
C
C     PROCESS THE EST
C
      ESTLTR(1) = ESTL
      ESTNLT(1) = ESTNL
      DO 740 I = 2,7
      ESTLTR(I) = 0
  740 ESTNLT(I) = 0
      ASSIGN 820 TO NOSD
      CALL GOPEN (  EST,Z(BUFR1),0)
      CALL GOPEN ( ESTL,Z(BUFR2),1)
      CALL GOPEN (ESTNL,Z(BUFR3),1)
      FILE = EST
C
C     READ THE ELEMENT TYPE.  IF THE ELEMENT TYPE IS ADMISSIBLE TO
C     PIECEWISE LINEAR ANALYSIS, WRITE IT TWICE.  OTHERWISE GO TO NEXT
C     RECORD.
C
  750 CALL READ (*850,*880,EST,ITYPE,1,NEOR,IFLAG)
      IF (PLAARY(ITYPE) .EQ. 1) GO TO 755
      CALL SKPREC (EST,1)
      GO TO 750
  755 CALL WRITE (ESTL, ITYPE,1,NEOR)
      CALL WRITE (ESTNL,ITYPE,1,NEOR)
C
C     READ THE EST ENTRY
C
  760 IDX  = (ITYPE-1)*INCR
      NWDS = NE(IDX+12)
      CALL READ (*870,*840,EST,XECPT,NWDS,NEOR,IFLAG)
      IF (PLAARY(ITYPE) .EQ. 0) GO TO 820
      IF (ITYPE .GT. 38) GO TO 820
C              CROD      CBEAM     CTUBE     CSHEAR    CTWIST
C                1         2         3         4         5
      GO TO (   130,      820,      150,      820,      820,
C              CTRIA1    CTRBSC    CTRPLT    CTRMEM    CONROD
C                6         7         8          9       10
     1          160,      820,      820,      170,      130,
C              CELAS1    CELAS2    CELAS3    CELAS4    CQDPLT
C                11        12        13        14        15
     2          820,      820,      820,      820,      820,
C              CQDMEM    CTRIA2    CQUAD2    CQUAD1    CDAMP1
C                16        17        18        19        20
     3          180,      190,      200,      210,      820,
C              CDAMP2    CDAMP3    CDAMP4    CVISC     CMASS1
C                21        22        23        24        25
     4          820,      820,      820,      820,      820,
C              CMASS2    CMASS3    CMASS4    CONM1     CONM2
C                26        27        28        29        30
     5          820,      820,      820,      820,      820,
C              PLOTEL    REACT     QUAD3     CBAR      CCONE
C                31        32        33        34        35
     6          820,      820,      820,      220,      820,
C              CTRIARG   CTRAPRG   CTORDRG
C                36        37        38
     7          820,      820,      820), ITYPE
C
C     THE ELEMENT IS STRESS DEPENDENT.  DETERMINE IF STRESS OUTPUT IS
C     REQUESTED.
C     AN EXAMPLE... IF WE HAVE IN CASE CONTROL
C     SET 5 = 1,2,3,98THRU100,4THRU15,81,18,82,90,92
C     THEN THE WORDS IN CASE CONTROL ARE...
C       IZ(ISETNO) = 5,12,1,2,3,4,-15,18,81,82,90,92,98,-100 = IZ(NSET)
C
  765 IF (ALL) GO TO 800
      IF (NONLST .EQ. -1) GO TO 760
      IELID = IECPT(1)
      I = ISET
  770 IF (I    .GT. NSET) GO TO 760
      IF (IZ(I+1) .LT. 0) GO TO 780
      IF (IELID .EQ. IZ(I)) GO TO 800
      IF (IELID .LT. IZ(I)) GO TO 760
      I = I + 1
      GO TO 790
  780 IF (IELID.GE.IZ(I) .AND. IELID.LE.IABS(IZ(I+1))) GO TO 800
      IF (IELID .LT. IZ(I)) GO TO 760
      I = I + 2
  790 IF (IZ(I) .GT. 0) GO TO 770
      ALL = .TRUE.
      LLLLLL(1) = IZ(ISTSET)
      LLLLLL(2) = IZ(I)
      CALL MESAGE (30,92,LLLLLL)
  800 OUTFIL = ESTNL
      NNLEL  = NNLEL + 1
      GO TO 830
  820 OUTFIL = ESTL
      NLEL   = NLEL + 1
  830 CALL WRITE (OUTFIL,XECPT,NWDS,NEOR)
      GO TO 760
  840 CALL WRITE (ESTL,0,0,EOR)
      CALL WRITE (ESTNL,0,0,EOR)
      GO TO 750
C
C     WRAP UP ROUTINE
C
  850 CALL CLOSE  (EST,CLSRW)
      CALL CLOSE  (ESTL,CLSRW)
      CALL CLOSE  (ESTNL,CLSRW)
      CALL WRTTRL (ESTLTR)
      CALL WRTTRL (ESTNLT)
  865 RETURN
C
C     FATAL ERRORS
C
  860 CALL MESAGE (-1,FILE,NAME)
  870 CALL MESAGE (-2,FILE,NAME)
  880 CALL MESAGE (-3,FILE,NAME)
  890 CALL MESAGE (-30,87,ITYPE)
C
C     UNABLE TO FIND PLFACT CARD IN THE MPT WHICH WAS CHOSEN BY THE USER
C     IN CASECC.
C
  895 TRAIL(1) = HMPT
      TRAIL(2) = NAME(1)
      CALL MESAGE (-32,PLASET,TRAIL)
      RETURN
      END

      SUBROUTINE MODAC1(CASECC,TOL,TOL1,CASEZZ,CASEYY)
C
C     MODAC1 REDUCES THE NUMBER OF ENTRIES ON TOL TO THE TIMES
C         SPECIFIED BY THE OFREQ SET IN CASECC
C
C     CORE IS        OUT AS FOLLOWS ON RETURN
C
C         CONTENTS            LENGTH  TYPE   POINTER
C         --------            ------  ----   -------
C         NEW TIMES           NFN      R     IFN
C         KEEP REMOVE         NFO      I     IKR
C
C
C
C
C
C
C
C
C
C
C
C
C
      INTEGER SYSBUF,CASECC,TOL,NAME(2),TOL1,FILE,IHD(2),MCB(7),IBUF(6)
      INTEGER CASEZZ,CASEYY,FLAG
      REAL  Z(1)
      COMMON /SYSTEM/ SYSBUF
      COMMON /MODAC3/ NFO,NFN,NZ, ID
      COMMON /ZZZZZZ/ IZ(1)
      EQUIVALENCE   ( Z(1), IZ(1) )
      DATA NAME /4HMODA,4HC1  /
C
C     BRING  IN  CASECC
C
      LW = 6
      IF(ID .EQ. 4) LW = 7
      IBUF1 = NZ -SYSBUF+1
      IBUF2 = IBUF1-SYSBUF
      IBUF3 = IBUF2 -SYSBUF
      CALL GOPEN(CASECC,IZ(IBUF1),0)
      FILE = CASECC
      CALL READ(*900,*10,CASECC,IZ,IBUF2-1,0,IVEC)
      CALL MESAGE(-8,0,NAME)
   10 CONTINUE
      ICC = 0
      CALL CLOSE(CASECC, 1)
      IFROUT =145
      ILSYM = 200
      IVEC  = IVEC+1
      ILIST = IVEC
      IF(ID .EQ. 5) GO TO 600
C
C     BRING IN OLD TIME/FREQ  LIST
C
      FILE = TOL
      CALL OPEN(*900,TOL,IZ(IBUF1),0)
      I = ILIST
      M = 3
      IX= 2
      NFO = NFO + I
      IF(ID .EQ. 2 .OR. ID .EQ. 4) GO TO 25
   20 CALL READ(*910,*30,TOL,IBUF,M,0,FLAG)
      IZ(I) =IBUF(M)
      IZ(I+1)= 0
      I =  I + IX
      M =1
      GO TO 20
   25 CALL FWDREC(*910,TOL)
      CALL FWDREC(*910,TOL)
   26 CALL READ(*910,*30,TOL,IBUF,LW,0,FLAG)
      IZ(I) = IBUF(4)
C     REIG SHOULD BE ON CYCLES
      IF(ID .EQ. 4) IZ(I) = IBUF(5)
      IZ(I+1) = 0
      I = I+2
      IF(I.EQ.NFO) GO TO 30
      GO TO 26
   30 CALL CLOSE(TOL,1)
      NLIST = I -IX
C
C     MATCH LIST OF  SELECTED VALUES WITH TIME LIST IN CORE
C
   35 CONTINUE
      IX = ICC + IFROUT
      IFSET = IZ(IX)
      IF ( IFSET  .LE. 0)  GO TO  70
      IX = ICC +ILSYM
      ISETNF = IX + IZ(IX)+1
   40 ISETF  = ISETNF +2
      NSETF  =IZ(ISETNF+1) + ISETF-1
      IF( IZ(ISETNF).EQ. IFSET) GO TO 80
      ISETNF = NSETF +1
      IF ( ISETNF .LT. IVEC) GO TO 40
      IFSET = -1
   70 DO  75 J = ILIST,NLIST,2
   75 IZ(J+1) = 1
      GO TO 200
   80 DO 100 I = ISETF,NSETF
      K = 0
      DIFF = 1.E25
      REAL = Z(I)
      DO 90  J = ILIST,NLIST,2
      IF (IZ(J+1) .NE. 0) GO TO 90
      DIFF1 =  ABS(Z(J) - REAL)
      IF( DIFF1 .GE. DIFF) GO TO 90
      DIFF = DIFF1
      K = J
   90 CONTINUE
      IF ( K .NE. 0)  IZ(K+1) = 1
  100 CONTINUE
C
C     SELECTED FREQUENCIES MARKED FOR OUTPUT
C
  200 NFO =(NLIST - ILIST +2)/2
C
C     MOVE NEW FREQ  TO UPPER
C
      K=1
      DO 300 I= ILIST,NLIST,2
      IF( IZ(I+1).EQ. 0) GO TO 300
      Z(K) = Z(I)
      K = K +1
  300 CONTINUE
      NFN = K-1
      DO 400  I = ILIST,NLIST,2
      IZ(K) = IZ(I+1)
      K = K+1
  400 CONTINUE
      IF(ID .EQ. 5) RETURN
      FILE =TOL1
      CALL OPEN(*800,TOL1,IZ(IBUF1),1)
      CALL FNAME(TOL1,IHD)
      CALL WRITE(TOL1,IHD,2,0)
      IF(ID .EQ. 2 .OR. ID .EQ. 4) GO TO 402
      CALL WRITE(TOL1,Z,NFN,1)
  401 CONTINUE
      CALL CLOSE(TOL1,1)
      MCB(1)= TOL1
      MCB(2)= NFN
      CALL WRTTRL(MCB )
      IF(ID .EQ. 2) GO TO 500
  800 RETURN
C
C     COPY OVER CLAMA STUFF
C
  402 CALL WRITE(TOL1,0,0,1)
      K = NFN + NFO + 1
      NZX  = IBUF3 -K
      FILE = TOL
      CALL GOPEN(TOL,IZ(IBUF2),0)
      CALL READ(*910,*920,TOL,IZ(K),146,1,FLAG)
      CALL WRITE(TOL1,IZ(K),146,1)
      M = NFN+1
      N = M+NFO -1
      DO 410 I = M,N
      CALL READ(*910,*920,TOL,IZ(K),LW,0,FLAG)
      IF(IZ(I) .EQ. 0) GO TO 410
      CALL WRITE(TOL1,IZ(K),LW,0)
  410 CONTINUE
      CALL CLOSE(TOL,1)
      CALL WRITE(TOL1,0,0,1)
      GO TO 401
C
C      COPY OVER CASECC
C
  500 CALL GOPEN(CASECC,IZ(IBUF1),0)
      CALL GOPEN(CASEZZ,IZ(IBUF2),1)
      M = NFN +1
      N = M+NFO-1
      DO 510 I = M,N
      CALL READ(*511,*520,CASECC,IZ(K),NZX,0,FLAG)
  520 IF(IZ(I) .EQ. 0) GO TO 510
      CALL WRITE(CASEZZ,IZ(K),FLAG,1)
  510 CONTINUE
  511 CALL CLOSE(CASECC,1)
      CALL CLOSE(CASEZZ,1)
      MCB(1) = CASECC
      CALL RDTRL(MCB)
      MCB(1) = CASEZZ
      CALL WRTTRL(MCB)
      RETURN
C
C     STATIC ANALYSIS
C
  600 CONTINUE
      R = 1.0
      NFO = NFO+ILIST
      NLIST = NFO-2
      DO 610 I = ILIST,NFO,2
      Z(I) = R
      IZ(I+1) = 0
      R = R+1.
  610 CONTINUE
C
C     COPY EDT
C
      CALL OPEN(*670,TOL,IZ(IBUF1),0)
      CALL OPEN(*670,TOL1,IZ(IBUF2),1)
      FILE = TOL
      CALL FNAME(TOL1,IHD)
      CALL WRITE(TOL1,IHD,2,0)
  620 CALL READ(*630,*920,TOL,IZ(NFO+2),NZ,0,FLAG)
      CALL WRITE(TOL1,IZ(NFO+2),FLAG,1)
      GO TO 620
  630 CALL CLOSE(TOL,1)
      CALL CLOSE(TOL1,1)
      MCB(1) = TOL
      CALL RDTRL(MCB)
      MCB(1) = TOL1
      CALL WRTTRL(MCB)
  670 GO TO 35
C
C     ERROR MESSAGES
C
  900 IP1=-1
  901 CALL MESAGE(IP1,FILE,NAME)
  910 IP1=-2
      GO TO 901
  920 IP1=-3
      GO TO 901
      END

      SUBROUTINE FNDLVL (NAME,NEWNM)
C
C     THIS SUBROUTINE LOOKS FOR A LOWER LEVEL SUBSTRUCTUE TO THE
C     SUBSTRUCTURE NAME.  IF NAME DOES HAVE A LOWER LEVEL SUBSTRUCTURE,
C     THE NAME OF ONE OF THESE LOWER LEVEL SUBSTRUCTURES WILL BE
C     RETURNED IN NEWNM.  IF NAME DOES NOT HAVE A LOWER LEVEL
C     SUBSTRUCTURE, NAME WILL BE RETURNED IN NEWNM.  IF NAME IS NOT
C     KNOWN TO THE SYSTEM, BLANKS WILL BE RETURNED IN NEWNM.
C
      EXTERNAL        RSHIFT,ANDF
      INTEGER         RSHIFT,ANDF,BUF
      DIMENSION       NAME(2),NEWNM(2),NMSBR(2)
      COMMON /ZZZZZZ/ BUF(1)
      DATA    LL    / 2 /
      DATA    IEMPTY/ 4H     /, NMSBR / 4HFNDL,4HVL   /
C
C     CHECK IF NAME EXISTS
C
      CALL CHKOPN (NMSBR(1))
      CALL FDSUB (NAME(1),K)
      IF(K .NE. -1) GO TO 10
      NEWNM(1) = IEMPTY
      NEWNM(2) = IEMPTY
      RETURN
C
C     FIND THE LOWER LEVEL SUBSTRUCTURE
C
   10 CALL FMDI (K,IMDI)
      ILL = ANDF(RSHIFT(BUF(IMDI+LL),20),1023)
      IF(ILL .EQ. 0) GO TO 20
C
C     NAME DOES HAVE A LOWER LEVEL SUBSTRUCTURE
C
      CALL FDIT (ILL,JDIT)
      NEWNM(1) = BUF(JDIT)
      NEWNM(2) = BUF(JDIT+1)
      RETURN
C
C     NAME DOES NOT HAVE A LOWER LEVEL SUBSTRUCTURE
C
   20 NEWNM(1) = NAME(1)
      NEWNM(2) = NAME(2)
      RETURN
      END

      SUBROUTINE READ4 (LAMA,PHI,SCR1,EPS,MASS)
C
C     READ4 WILL TEST FOR CLOSE AND EQUAL ROOTS AND MAKE SURE THE
C     CORRESPONDING VECTORS ARE ORTHOGONAL
C
      INTEGER          NAME(2)   ,PHI(7)   ,RSP      ,PHI1(7)
      INTEGER          RDREW     ,WRTREW
CWKBI ALPHA-OSF 9/94      
      INTEGER          SCR1
      DOUBLE PRECISION DZ(1)
      CHARACTER        UFM*23    ,UWM*25
      COMMON /XMSSG /  UFM       ,UWM
      COMMON /ZZZZZZ/  Z(1)
      COMMON /SYSTEM/  KSYSTM(65)
      COMMON /NAMES /  RD        ,RDREW    ,WRT      ,WRTREW   ,
     1                 REW       ,NOREW    ,EOFNRW   ,RSP
      COMMON /UNPAKX/  ITYPE     ,IUNPAK   ,JUNPAK   ,INCR
      COMMON /PACKX /  ITYPA     ,ITYPB    ,IPAK     ,JPAK     ,
     1                 INCRX
      EQUIVALENCE      (KSYSTM(1),ISYS)    ,(KSYSTM(2),IOUT)   ,
     1                 (DZ(1),Z(1))
      DATA    NAME  /  4HREAD,4H4   /
C
      NCOL  = PHI(2)
      NROW  = PHI(3)
      NZ    = KORSZ(Z)
      IBUF  = NZ - ISYS
      IBUF1 = IBUF - ISYS
      IBUF2 = IBUF1 - ISYS
      ICLOS = 0
      IDID  = 0
      IPR   = PHI(5)
      RMULT = .01
      ITYPE = RSP
      IUNPAK= 1
      JUNPAK= NROW
      INCR  = 1
      ITYPA = RSP
      ITYPB = RSP
      IPAK  = 1
      JPAK  = NROW
      INCRX = 1
      EPSI  = EPS
      IF (EPS .LE. 0.) EPSI = .0001
      NZ = NZ - ISYS - ISYS - 1 - ISYS
      CALL MAKMCB (PHI1,SCR1,NROW,2,RSP)
      IFILE = LAMA
      CALL GOPEN (LAMA,Z(IBUF),0)
      CALL READ (*170,*10,LAMA,Z(1),NZ,1,N)
      GO TO 180
   10 CALL CLOSE (LAMA,REW)
C
C     REJECT ALL BUT VALUES FOR WHICH VECTORS EXIST
C
      N  = PHI(2)
      NZ = NZ -N
      IF (NZ .LT. NROW) GO TO 180
      IFILE = PHI(1)
      CALL GOPEN (PHI,Z(IBUF),0)
      IPOS = 1
      I    = 1
      EPS1 = RMULT
   20 CONTINUE
      IF (ABS(Z(I))+ABS(Z(I+1)) .LT. EPS1) GO TO 1111
      IF (Z(I+1) .EQ. 0.0) GO TO 110
      IF (ABS(1.0-Z(I)/Z(I+1)) .GT. EPS1) GO TO 100
 1111 IF (ICLOS .NE. 0) GO TO 110
      ICLOS = I
      GO TO 110
   30 NUM  = I - ICLOS + 1
      EPS1 = RMULT
C
C     NUM   = NUMBER OF CLOSE ROOTS IN THIS GROUP
C     ICLOS = THE INDEX OF THE FIRST CLOSE ROOT
C
      IF (IDID .EQ. 1) GO TO 40
      IDID  = 1
      IFILE = SCR1
      CALL GOPEN (SCR1,Z(IBUF1),WRTREW)
   40 II = N + 1
   50 IF (IPOS .EQ. ICLOS) GO TO 70
      IFILE = PHI(1)
      CALL UNPACK (*190,PHI,Z(II))
      CALL PACK (Z(II),SCR1,PHI1)
      IPOS = IPOS + 1
      GO TO 50
   70 CONTINUE
C
C     CHECK FOR CORE OVERFLOW
C     EIGENVALUES + EIGENVECTORS + GEN. MASS + ACCUM.
C
      KORE = II + NUM*NROW + NUM*NUM + N + N + 3
      IF (KORE .GT. NZ) GO TO 160
      DO 80 J = 1,NUM
      CALL UNPACK (*190,PHI,Z(II))
      IPOS = IPOS + 1
      II   = II + NROW
      IF (II+NROW .GE. NZ) GO TO 180
   80 CONTINUE
      IJ = II + N + N + 3
      II = II/2 + 1
      CALL ORTCK (Z(N+1),MASS,Z(IBUF2),NUM,NROW,Z(IJ),DZ(II),EPSI)
      II = N + 1
      DO 90 J = 1,NUM
      CALL PACK (Z(II),SCR1,PHI1)
   90 II = II + NROW
      ICLOS = 0
  100 IF (ICLOS .NE. 0) GO TO 30
  110 I = I + 1
      IF (I     .LT.   N) GO TO 20
      IF (ICLOS .NE.   0) GO TO 30
      IF (IDID  .EQ.   0) GO TO 150
      IF (IPOS .GT. NCOL) GO TO 121
      DO 120 I = IPOS,NCOL
      CALL UNPACK (*190,PHI,Z)
      CALL PACK (Z(1),SCR1,PHI1)
  120 CONTINUE
  121 CALL WRTTRL (PHI1)
C
C     COPY VECTORS FROM SCR1 TO PHI
C
      CALL CLOSE (PHI,REW)
      CALL CLOSE (SCR1,REW)
      CALL GOPEN (PHI,Z(IBUF),1)
      CALL GOPEN (SCR1,Z(IBUF1),RDREW )
      CALL MAKMCB (PHI,PHI,NROW,2,IPR)
      ITYPB = IPR
      DO 140 I = 1,N
      CALL UNPACK (*190,SCR1,Z)
      CALL PACK (Z,PHI,PHI)
  140 CONTINUE
      CALL WRTTRL (PHI)
      CALL CLOSE (SCR1,REW)
  150 CALL CLOSE (PHI,REW)
      RETURN
C
  160 EPS2 = EPS1/10.
      WRITE  (IOUT,165) UWM,NUM,I,EPS1,EPS2
  165 FORMAT (A25,' 3142, INSUFFICIENT CORE STORAGE FOR EIGENVECTORS ',
     1       'ASSOCIATED WITH',I4,' MULTIPLE EIGENVALUES STARTING WITH',
     2       /28X,'MODE NUMBER',I4,' USING CURRENT MULTIPLE ROOT ',
     3       'CRITERIA. CRITERIA REDUCED FROM ',1P,E12.5,' TO ',E12.5)
      EPS1 = EPS2
      I = ICLOS
      GO TO 20
  170 NO = -2
      GO TO 200
  180 NO = -8
      GO TO 200
  190 NO = -7
  200 CALL MESAGE (NO,IFILE,NAME)
      RETURN
      END

      SUBROUTINE INSERT(NCOL,NROW,NDOF,NGRID,JCORE,Z,DZ,TEMP,DTEMP,IPR)
C
C INSERT INSERTS MATRIX PARTITONS INTO OPEN CORE FOR IS2D8
C
      DIMENSION Z(1),TEMP(9)
      DOUBLE PRECISION DZ(1),DTEMP(9)
C
      IS1=NGRID*NDOF**2
C
C COMPUTE STARTING POINTS INTO OPEN CORE FOR THIS PARTITION AND ITS TRAN
C
      IZ1=IS1*(NROW-1)+NDOF*(NCOL-1)+JCORE-1
      IZ2=IS1*(NCOL-1)+NDOF*(NROW-1)+JCORE-1
C
C IZ1 GETS TEMP,  IZ2 GETS THE TRANSPOSE
C
      I1=IZ1
      I2=IZ2
C
      IF (IPR.EQ.2) GO TO 20
C
      IF(NDOF.EQ.1)GO TO 10
C
C 3 X 3 PARTITION
C I1 GETS TEMP. I2 GETS THE TRANSPOSE
C IF I1=I2, THEN HALF OF THE ENTRIES WILL BE DUPLICATED
C THAT-S OK SINCE THERE ARE NO ADDITIONS
C
      Z(I1+1)=TEMP(1)
      Z(I2+1)=TEMP(1)
      Z(I1+2)=TEMP(2)
      Z(I2+25)=TEMP(2)
      Z(I1+3)=TEMP(3)
      Z(I2+49)=TEMP(3)
      Z(I1+25)=TEMP(4)
      Z(I2+2)=TEMP(4)
      Z(I1+26)=TEMP(5)
      Z(I2+26)=TEMP(5)
      Z(I1+27)=TEMP(6)
      Z(I2+50)=TEMP(6)
      Z(I1+49)=TEMP(7)
      Z(I2+3)=TEMP(7)
      Z(I1+50)=TEMP(8)
      Z(I2+27)=TEMP(8)
      Z(I1+51)=TEMP(9)
      Z(I2+51)=TEMP(9)
      GO TO 100
C
C 1 X 1 PARTITION
C
   10 Z(I1+1)=TEMP(1)
      Z(I2+1)=TEMP(1)
      GO TO 100
C
C
C DO THE SAME IN DOUBLE PRECISION
C
   20 IF (NDOF.EQ.1) GO TO 30
C
      DZ(I1+ 1)=DTEMP(1)
      DZ(I2+ 1)=DTEMP(1)
      DZ(I1+ 2)=DTEMP(2)
      DZ(I2+25)=DTEMP(2)
      DZ(I1+ 3)=DTEMP(3)
      DZ(I2+49)=DTEMP(3)
      DZ(I1+25)=DTEMP(4)
      DZ(I2+ 2)=DTEMP(4)
      DZ(I1+26)=DTEMP(5)
      DZ(I2+26)=DTEMP(5)
      DZ(I1+27)=DTEMP(6)
      DZ(I2+50)=DTEMP(6)
      DZ(I1+49)=DTEMP(7)
      DZ(I2+ 3)=DTEMP(7)
      DZ(I1+50)=DTEMP(8)
      DZ(I2+27)=DTEMP(8)
      DZ(I1+51)=DTEMP(9)
      DZ(I2+51)=DTEMP(9)
      GO TO 100
C
   30 DZ(I1+1)=DTEMP(1)
      DZ(I2+1)=DTEMP(1)
C
  100 RETURN
      END

      SUBROUTINE FORNAM ( IELT, ISCAN, NAME )
      COMMON / SYSTEM / ISYSBF, NOUT
      CHARACTER*12    NAME
      NAME= ' '
      IF ( IELT .NE. 1 .AND. IELT .NE. 3 .AND. IELT .NE. 10 ) GO TO 10
C ROD, TUBE, CONROD
      IF ( ISCAN .EQ. 2 ) NAME='AXIAL'
      IF ( ISCAN .EQ. 4 ) NAME='TORQUE'
      GO TO 7000
10    IF ( IELT .NE. 4 .AND. IELT .NE. 5 ) GO TO 20
C SHEAR, TWIST
      IF ( ISCAN .EQ. 2 ) NAME='FORCE-1'
      IF ( ISCAN .EQ. 3 ) NAME='FORCE-2'
      GO TO 7000
20    IF ( IELT .NE. 6  .AND. IELT .NE. 17 .AND. IELT .NE. 19 .AND.
     &     IELT .NE. 18 .AND. IELT .NE. 7  .AND. IELT .NE. 8  .AND.
     &     IELT .NE. 15 ) GO TO 30
C TRIA1, TRIA2, QUAD1, QUAD2, TRBSC, TRPLT, QDPLT
      IF ( ISCAN .EQ. 2 ) NAME='MOMENT-X'
      IF ( ISCAN .EQ. 3 ) NAME='MOMENT-Y'
      IF ( ISCAN .EQ. 5 ) NAME='SHEAR-X'
      IF ( ISCAN .EQ. 6 ) NAME='SHEAR-Y'
      IF ( ISCAN .EQ. 4 ) NAME='TWIST'
      GO TO 7000
30    IF ( IELT .NE. 9 .AND. IELT .NE. 16 .AND. IELT .NE. 62 .AND.
     &     IELT .NE. 63 ) GO TO 40
C TRMEM, QDMEM, QDMEM1, QDMEM2
      IF ( ISCAN .EQ. 3 .OR. ISCAN .EQ. 4 ) NAME='FORCE-12'
      IF ( ISCAN .EQ. 5 .OR. ISCAN .EQ. 6 ) NAME='FORCE-23'
      IF ( ISCAN .EQ. 7 .OR. ISCAN .EQ. 8 ) NAME='FORCE-34'
      IF ( ISCAN .EQ. 2 .OR. ISCAN .EQ. 9 ) NAME='FORCE-41'
      IF ( ISCAN .EQ. 10) NAME='KICK ON1'
      IF ( ISCAN .EQ. 12) NAME='KICK ON2'
      IF ( ISCAN .EQ. 14) NAME='KICK ON3'
      IF ( ISCAN .EQ. 16) NAME='KICK ON4'
      IF ( ISCAN .EQ. 11) NAME='SHEAR-XY'
      IF ( ISCAN .EQ. 13) NAME='SHEAR-YZ'
      IF ( ISCAN .EQ. 15) NAME='SHEAR-ZX'
      IF ( ISCAN .EQ. 17) NAME='SHEAR'
      GO TO 7000
40    IF ( IELT .NE. 11 .AND. IELT .NE. 12 .AND. IELT .NE. 13 .AND.
     &     IELT .NE. 80 ) GO TO 50
C ELAS1, ELAS2, ELAS3, IS2D8
      IF ( ISCAN .EQ. 2 ) NAME='CIRCUM'
      IF ( ISCAN .EQ. 4 .AND. ISCAN .EQ. 9 ) NAME='FORCE-1'
      IF ( ISCAN .EQ. 3 .AND. ISCAN .EQ. 6 ) NAME='FORCE-2'
      IF ( ISCAN .EQ. 5 .AND. ISCAN .EQ. 8 ) NAME='FORCE-3'
      IF ( ISCAN .EQ. 2 .AND. ISCAN .EQ. 7 ) NAME='FORCE-4'
      GO TO 7000
50    IF ( IELT .NE. 34 .AND. IELT .NE. 81 ) GO TO 60
C BAR, ELBOW
      IF ( ISCAN .EQ. 5 .OR. ISCAN .EQ. 6 ) NAME='SHEAR'
      IF ( ISCAN .EQ. 2 .OR. ISCAN .EQ. 3 ) NAME='MOMENT-A'
      IF ( ISCAN .EQ. 4 .OR. ISCAN .EQ. 5 ) NAME='MOMENT-B'
      IF ( ISCAN .EQ. 8 ) NAME='AXIAL'  
      IF ( ISCAN .EQ. 9 ) NAME='TORQUE'
      GO TO 7000
60    IF ( IELT .NE. 35 ) GO TO 70
C CONEAX
      IF ( ISCAN .EQ. 3 ) NAME='MOMENT-U'
      IF ( ISCAN .EQ. 4 ) NAME='MOMENT-V'
      IF ( ISCAN .EQ. 6 ) NAME='SHEAR-XY'
      IF ( ISCAN .EQ. 7 ) NAME='SHEAR-YZ'
      GO TO 7000
70    IF ( IELT .NE. 36 ) GO TO 80
C TRIARG
      KSCAN = MOD ( ISCAN, 3 )
      IF ( KSCAN .EQ. 2 ) NAME='RADIAL'
      IF ( KSCAN .EQ. 3 ) NAME='CIRCUM'
      IF ( KSCAN .EQ. 1 ) NAME='AXIAL'
      GO TO 7000
80    IF ( IELT .NE. 37 ) GO TO 90
C TRAPRG
      KSCAN = MOD( ISCAN, 3 )
      IF ( KSCAN .EQ. 2 ) NAME='RADIAL'
      IF ( KSCAN .EQ. 3 ) NAME='CIRCUM'
      IF ( KSCAN .EQ. 1 ) NAME='AXIAL'
      GO TO 7000
90    IF ( IELT .NE. 38 ) GO TO 120
C TORDRG
      KSCAN = MOD( ISCAN, 6 )
      IF ( KSCAN .EQ. 2 ) NAME='RADIAL'
      IF ( KSCAN .EQ. 3 ) NAME='CIRCUM'
      IF ( KSCAN .EQ. 4 ) NAME='AXIAL'
      IF ( KSCAN .EQ. 5 ) NAME='MOMENT'
      IF ( KSCAN .EQ. 1 ) NAME='CURV'
      GO TO 7000
120   IF ( IELT .NE. 70 .AND. IELT .NE. 71 ) GO TO 130
C TRIAAX, TRAPAX
      KSCAN = MOD ( ISCAN, 4 )
      IF ( KSCAN .EQ. 3 ) NAME='RADIAL'
      IF ( KSCAN .EQ. 0 ) NAME='CIRCUM'
      IF ( KSCAN .EQ. 1 ) NAME='AXIAL' 
      GO TO 7000
130   IF ( IELT .NE. 64 .AND. IELT .NE. 83 ) GO TO 150
C QUAD4, TRIA3 
      IF ( ISCAN .EQ. 2 .OR. ISCAN .EQ. 3 ) NAME='FX+FY'
      IF ( ISCAN .EQ. 4                   ) NAME='FXY'
      IF ( ISCAN .EQ. 5 .OR. ISCAN .EQ. 6 ) NAME='MX+MY'
      IF ( ISCAN .EQ. 7                   ) NAME='MXY'
      IF ( ISCAN .EQ. 8 .OR. ISCAN .EQ. 9 ) NAME='VX+VY'
      GO TO 7000
150   WRITE ( NOUT, 901 ) IELT 
901   FORMAT(//' SCAN MODULE PROCESSING UNKNOWN ELEMENT NUMBER '
     &       ,I8,//)
      CALL MESAGE( -61,0,0)
7000  RETURN
      END

      SUBROUTINE SSG3
C
C     DMAP FOR STATIC SOLUTION GENERATOR 3
C
C     SSG3   LLL,KLL,PL,LOO,KOOB,PO /ULV,UOV,RULV,RUOV/ V,N,OMIT/
C            V,Y,IRES/V,N,SKIP/V,N,EPSI $
C
      INTEGER        LLL,KLL,PL,LOO,PO,ULV,UOV,SR1,SR2,OMIT,RULV,RUOV
      COMMON /BLANK/ OMIT,IRES,NSKIP,EPSI
      DATA    LLL  , KLL,  PL, LOO, KOOB, PO, ULV, UOV, RULV, RUOV /
     1        101  , 102, 103, 104, 105, 106, 201, 202, 203 , 204  /
      DATA    SR1  , SR2  /
     1        301  , 302  /
C
      CALL SSG3A (KLL,LLL,PL,ULV,SR1,SR2,0,RULV)
      IF (OMIT .GE. 0) CALL SSG3A (KOOB,LOO,PO,UOV,SR1,SR2,0,RUOV)
      RETURN
      END

      SUBROUTINE IFP
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        ORF,ANDF
      LOGICAL         BADFOR,BADDAT,ABORT,EOFFLG,CF,CL,IAX,LHARM
      INTEGER         FNM(2,16),II(16),IFLE(16),STATUS(16),IBLKDA(2),
     1                JR(20),IEND(3),ITRL(7),IFPNA1(2),NM(2),KAP(4),
     2                AP(12),KKL(40),IFPNA2(2),OOO(5),MENTRY(40),
     3                NAME(2),INAM(2),ITYPE(2),NENTRY(80),ITYPE1(2),
     4                ITYPE2(2)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG / UFM,UWM,UIM,SFM
      COMMON /BLANK / ENDARA(40)
      COMMON /SYSTEM/ N1,NOUT,ABORT,N2(17),IAPP,N3(5),AXICCC,JUNK(10),
     1                AXIFCC,DUM(30),ISUBS
      COMMON /TWO   / TWO(32)
      COMMON /IFPDTA/ ID,N,K,KX,KY,I(100),M(100),MF(100),M1(100),
     1                M1F(100),KN,BADDAT,BADFOR,NOPEN,NPARAM,IAX,NAX,
     2                IAXF,NAXF,LHARM,KNT,KSLOT1,KSLOT2,KSLOT3,KSLOT4,
     3                KSLOT5,GC(7),LL(6)
      COMMON /ZZZZZZ/ IBUFF(1)
C
C     NCDS    = LENGTH OF T1
C     NCDSMX  = NO. OF CARD NAMES IN NASTRAN
C     T3(1,K) = THE GINO OUTPUT FILE NUMBER
C     T3(2,K) = THE APPROACH ACCEPTANCE FLAG
C     T4(1,K) = THE CONICAL SHELL PROBLEM FLAG
C     T4(2,K) = USED AS INTERNAL STORAGE WITHIN IFP
C     T5(1,K) = THE MIN NO. OF WORDS ALLOWED PER CARD
C               (MINUS MEANS OPEN-ENDED CARD)
C     T5(2,K) = THE MAX NO. OF WORDS ALLOWED PER CARD
C     T6(1,K) = THE FORMAT CHECK POINTER INTO F( )
C     T6(2,K) = FIELD 2 UNIQUENESS CHECK FLAG
C     T7(1,K) = LOCATE CODE
C     T7(2,K) = TRAILER BIT POSITION
C     F(T6(1,K)) = THE START OF THE FORMAT ACCEPTANCE STRING
C
C     T1(1,K),T1(2,K) = THE BCD CARD NAMES
C
      COMMON /IFPX0 / LBD,LCC,IB(18)
      COMMON /IFPX1 / NCDS,T1(2,370)
      COMMON /IFPX2 / T3(2,370)
      COMMON /IFPX3 / T4(2,370)
      COMMON /IFPX4 / T5(2,370)
      COMMON /IFPX5 / T6(2,370)
      COMMON /IFPX6 / T7(2,370)
      COMMON /IFPX7 / F(1469)
      EQUIVALENCE     (N3(3),IUMFED), (N2(9),LINE)
      DATA    NCDSMX/ 359 /
      DATA    NFLS  / 16  /
      DATA    FNM(1, 1),FNM(2, 1) / 4HGEOM,4H1   /
      DATA    FNM(1, 2),FNM(2, 2) / 4HEPT ,4H    /
      DATA    FNM(1, 3),FNM(2, 3) / 4HMPT ,4H    /
      DATA    FNM(1, 4),FNM(2, 4) / 4HEDT ,4H    /
      DATA    FNM(1, 5),FNM(2, 5) / 4HDIT ,4H    /
      DATA    FNM(1, 6),FNM(2, 6) / 4HPVT ,4H    /
      DATA    FNM(1, 7),FNM(2, 7) / 4HDYNA,4HMICS/
      DATA    FNM(1, 8),FNM(2, 8) / 4HGEOM,4H2   /
      DATA    FNM(1, 9),FNM(2, 9) / 4HGEOM,4H3   /
      DATA    FNM(1,10),FNM(2,10) / 4HGEOM,4H4   /
      DATA    FNM(1,11),FNM(2,11) / 4HGEOM,4H5   /
      DATA    FNM(1,12),FNM(2,12) / 4HPOOL,4H    /
      DATA    FNM(1,13),FNM(2,13) / 4HFORC,4HE   /
      DATA    FNM(1,14),FNM(2,14) / 4HMATP,4HOOL /
      DATA    FNM(1,15),FNM(2,15) / 4HAXIC,4H    /
      DATA    FNM(1,16),FNM(2,16) / 4HIFPF,4HILE /
      DATA    IFLE   / 201,202,203,204,205,4HNPTP,207,208,209,210,211,
     1                 4HPOOL ,213,214,215,216   /
      DATA    IEND   , EOFZ   /3*2147483647,4HZZZZ    /
      DATA    KKL    / 48, 49, 50, 67, 71, 75, 68, 72, 76, 11,
     1                 10*0  ,
     2                 45, 46, 44, 41,250,260, 39, 42,121, 34,
     3                 37, 43, 31, 7*0/
      DATA    IBLKDA / 4HBULK, 4HDATA /,  OOO    / 1HA,1HB,1HC,1HD,1HE/
      DATA    BLANK  / 1H   /, KAP    / 0,-1,1,-1/
      DATA    IFPNA1 / 4HIFP ,4HBEGN/, IFPNA2/ 4HIFP ,4HEND /
      DATA    IPARM  , IVARY /4H1PAR , 4H1VAR/
      DATA    ICOUNT , JCOUNT, KCOUNT/ 3*0   /
      DATA    IT1K   , IT2K  , JT1K  ,JT2K   , KT1K  ,KT2K /
     &        1H , 1H , 1H , 1H , 1H , 1H   /
      DATA    AP     / 4HDMAP,4H     , 4H    ,
     1                 4HDISP,4HLACE , 4HMENT,
     2                 4HHEAT,4H     , 4H    ,
     3                 4HAERO,4H     , 4H    /
      DATA    MENTRY / 3001  , 3701  ,  3901 ,  1201 ,   401,
     1                  801  , 1301  ,   501 ,   901 ,  5201, 10*0,
     2                  202  ,  302  ,   402 ,   502 ,  2202,
     3                 5302  ,  802  ,  1002 ,  2102 ,  1302,
     4                 1402  , 1702  ,  1802 ,   7*0 /
      DATA    NAME   / 4HIFP , 4H    /
      DATA    NENTRY / 4HCROD, 4H    , 4HCTUB, 4HE   , 4HCVIS, 4HC   ,
     1                 4HCMAS, 4HS3  , 4HCDAM, 4HP3  , 4HCELA, 4HS3  ,
     2                 4HCMAS, 4HS4  , 4HCDAM, 4HP4  , 4HCELA, 4HS4  ,
     3                 4HPLOT, 4HEL  , 20*0  ,
     4                 4HPDAM, 4HP   , 4HPELA, 4HS   , 4HPMAS, 4HS   ,
     5                 4HPQDM, 4HEM  , 4HPQDM, 4HEM1 , 4HPQDM, 4HEM2 ,
     6                 4HPQUA, 4HD2  , 4HPSHE, 4HAR  , 4HPTOR, 4HDRG ,
     7                 4HPTRI, 4HA2  , 4HPTRM, 4HEM  , 4HPTWI, 4HST  ,
     8                 4HPVIS, 4HC   , 14*0  /
      DATA    ITYPE1 / 4HELEM, 4HENT /
      DATA    ITYPE2 / 4HPROP, 4HERTY/
C
C     ============================================================
C     REMEMBER TO CHECK FOR THE LONGEST LINK IN OVERLAY STRUCTURE.
C     ============================================================
C
C     INITIALIZE COMMON BLOCKS CIFS1P, 2P, 3P, 4P, AND CIFS5P
C
      CALL CIFSDD
C
      DO 10 J = 1,16
      STATUS(J) = 1
   10 CONTINUE
      STATUS( 6) = 3
      STATUS(12) = 3
      LM     = 100
      CURFIL = 0
      KICK   = 0
      IPVS   = 0
      EOFFLG = .FALSE.
      BADDAT = .FALSE.
      BADFOR = .FALSE.
      NPARAM = 0
      KN     = 0
      IAX    = .FALSE.
      NAX    =-1
      IAXF   = 0
      NAXF   =-1
      LHARM  = .TRUE.
      KSLOT1 = 0
      KSLOT2 = 0
      KSLOT3 = 0
      KSLOT4 = 0
      KSLOT5 = 0
      CALL CONMSG (IFPNA1,2,0)
      IAP    = IABS(IAPP)
      JAP    = KAP(IAP)
      KNT    =-1
      IAXIC  = AXICCC
      IAXIF  = AXIFCC
      AXICCC = 0
      AXIFCC = 0
      DO 20 J = 1,NFLS
   20 II(J)  = 0
      DO 30 J = 1,40
      ENDARA(J) = 0
   30 CONTINUE
      NOPEN = KORSZ(IBUFF) - 3*N1
      CALL SSWTCH (42,L42)
      IF (NOPEN .GE. 0) GO TO 100
      CALL PAGE2 (2)
      WRITE  (NOUT,40) SFM
   40 FORMAT (A25,' 303, NO OPEN CORE FOR IFP.')
      ABORT =.TRUE.
      RETURN
C
C     OPEN NPTP AND LOCATE BULK DATA
C
  100 KFIL = IFLE(6)
      CALL OPEN (*130,KFIL,IBUFF(N1+1),0)
  110 CALL SKPFIL (KFIL,1)
      CALL READ (*1390,*160,KFIL,JR,2,1,KDUM)
      IF (JR(1).EQ.IBLKDA(1) .AND. JR(2).EQ.IBLKDA(2)) GO TO 180
      KICK = KICK + 1
      IF (KICK .LT. 5) GO TO 110
      CALL PAGE2 (2)
      WRITE  (NOUT,120) SFM,JR(1),JR(2)
  120 FORMAT (A25,' 304, IFP NOT READING NPTP. FILE BEING READ = ',2A4)
      GO TO 150
  130 CALL PAGE2 (2)
      WRITE  (NOUT,140) SFM,KFIL
  140 FORMAT (A25,' 305, IFP CANNOT OPEN GINO FILE',I10)
  150 ABORT =.TRUE.
      GO TO 1850
  160 CALL PAGE2 (2)
      WRITE  (NOUT,170) SFM
  170 FORMAT (A25,' 306, READ LOGICAL RECORD ERROR')
      GO TO 150
  180 CALL READ (*1380,*160,IFLE(6),JR,20,1,KDUM)
      KNT = KNT + 1
C
C     CHECK FOR 1PARM OR 1VARY CARDS
C
      IF (JR(1).EQ.IPARM .OR. JR(1).EQ.IVARY) CALL IFPPVC (*190,IPVS,JR)
      IF (L42 .EQ. 0) CALL RCARD2 (M1,M1F,NW,JR)
      IF (L42 .NE. 0) CALL RCARD  (M1,M1F,NW,JR)
      IF (M1(1).EQ.0 .AND. M1(2).EQ.0) GO TO 1430
      GO TO 220
  190 CALL CLOSE (IFLE(6),1)
      GO TO 1900
C
C     READ AND DECODE ONE PHYSICAL CARD
C
  200 IF (EOFFLG) GO TO 1410
      CALL READ (*1460,*160,IFLE(6),JR,20,1,KDUM)
      KNT = KNT + 1
      IF (L42 .EQ. 0) CALL RCARD2 (M1,M1F,NW,JR)
      IF (L42 .NE. 0) CALL RCARD  (M1,M1F,NW,JR)
      IF (M1(1).EQ.0 .AND. M1(2).EQ.0) GO TO 200
  210 IF (EOFFLG) GO TO 1460
C
C     IDENTIFY CARD NAME
C
  220 DO 230 J = 1,NCDSMX
      K = J
      IF (M1(1).EQ.T1(1,K) .AND. M1(2).EQ.T1(2,K)) GO TO 280
  230 CONTINUE
      IF (KT1K.NE.T1(1,K) .OR. KT2K.NE.T1(2,K)) GO TO 240
      KCOUNT = KCOUNT + 1
      IF (KCOUNT-7) 250,270,200
  240 KT1K = T1(1,K)
      KT2K = T1(2,K)
  250 CALL PAGE2 (2)
      WRITE  (NOUT,260) UFM,M1(1),M1(2)
  260 FORMAT (A23,' 307, ILLEGAL NAME FOR BULK DATA CARD ',2A4 )
      ABORT =.TRUE.
      GO TO 200
  270 CALL PAGE2 (3)
      WRITE  (NOUT,1150)
      GO TO 200
  280 KCOUNT = 0
      CL =.FALSE.
      CF =.TRUE.
      KX = K  - 100
      KY = KX - 100
C
C     CHECK APPROACH ACCEPTABILITY
C
      IF (T3(2,K)*JAP+1) 300,320,340
  300 WRITE  (NOUT,310) UFM,T1(1,K),T1(2,K),AP(3*IAP-2),AP(3*IAP-1),
     1                  AP(3*IAP)
  310 FORMAT (A23,' 308, CARD ',2A4,' NOT ALLOWED IN ',3A4,' APPROACH.')
      CALL PAGE2 (2)
      ABORT =.TRUE.
      GO TO 340
  320 WRITE  (NOUT,330) UWM,T1(1,K),T1(2,K),AP(3*IAP-2),AP(3*IAP-1),
     1                  AP(3*IAP)
  330 FORMAT (A25,' 309, CARD ',2A4,' IMPROPER IN ',3A4,' APPROACH.')
      CALL PAGE2(2)
  340 IF (.NOT.IAX .OR. T4(1,K).GE.0) GO TO 400
      CALL PAGE2 (2)
      WRITE  (NOUT,350) UFM,T1(1,K),T1(2,K)
  350 FORMAT (A23,' 310, CARD ',2A4,' NOT ALLOWED IN SAME DECK WITH ',
     1       'AXIC CARD.')
      ABORT =.TRUE.
C
C     ESTABLISH PROPER OUTPUT FILES FOR THIS CARD
C
  400 INDX = T3(1,K)
      IF (INDX.EQ.CURFIL .OR. INDX.EQ.6) GO TO 420
      IF (CURFIL.EQ.0 .OR. STATUS(CURFIL).EQ.1) GO TO 410
      CALL CLOSE (IFLE(CURFIL),2)
      STATUS(CURFIL) = 3
  410 KFIL = IFLE(INDX)
      CALL OPEN (*130,KFIL,IBUFF,STATUS(INDX))
      CURFIL = INDX
      STATUS(CURFIL) = -STATUS(CURFIL)
      IF (STATUS(CURFIL) .NE. -1) GO TO 420
      CALL WRITE (IFLE(CURFIL),FNM(1,CURFIL),2,1)
      II(CURFIL) = 1
      STATUS(CURFIL) = -3
  420 ID = M1(3)
  430 JF = NW - 2
      DO 440 L = JF,LM
  440 M(L) = 0
      DO 450 L = 1,JF
  450 M(L) = M1(L+2)
C
C     TEST UNIQUENESS OF FIELD 2 IF APPLICABLE
C
      IF (M1(1).EQ.0 .AND. M1(2).EQ.0 .OR.CF .OR. T6(2,K).NE.1)
     1    GO TO 480
      IF (ID .EQ. M(1)) GO TO 460
      ID = M(1)
      GO TO 480
  460 KNT1 = KNT + 1
      CALL PAGE2 (2)
      WRITE  (NOUT,470) UFM,T1(1,K),T1(2,K),M(1),KNT1
  470 FORMAT (A23,' 311, NON-UNIQUE FIELD 2 ON BULK DATA CARD ',2A4,I8,
     1        10X,'H SORTED CARD COUNT =',I7)
      ABORT =.TRUE.
  480 DO 490 L = 1,LM
  490 MF(L) = 0
      LF = 0
      DO 500 L = 1,JF
C
C     =========================================
C     THIS SHOULD BE CHANGED WHEN RCARD CHANGES
C
      IF (M1F(L+1) .LT. 0) GO TO 540
C     ========================================
      LF = LF + 1
  500 MF(L) = M1F(L+1)
      GO TO 540
  510 IF (EOFFLG) GO TO 1420
C
C     READ ANOTHER CARD (TO BE PROCESSED NEXT)
C
      KNT = KNT + 1
      CALL READ (*550,*160,IFLE(6),JR,20,1,KDUM)
      IF (L42 .EQ. 0) CALL RCARD2 (M1,M1F,NW,JR)
      IF (L42 .NE. 0) CALL RCARD  (M1,M1F,NW,JR)
      IF (M1(1).NE.0  .OR. M1(2).NE.0) GO TO 580
C
C     CHECK FOR TOO MANY CONTINUATIONS
C
      IF (T6(1,K).LT.0 .AND. LF.GT.4) GO TO 600
      IF (JF+NW-2-LM .GT. 0) GO TO 560
      K1 = NW - 2
      DO 520 L = 1,K1
      K2 = JF + L
  520 M(K2) = M1(L+2)
      JF = JF + NW - 2
      DO 530 L = 1,K1
C
C     =========================================
C     THIS SHOULD BE CHANGED WHEN RCARD CHANGES
C
      IF (M1F(L+1) .LT. 0) GO TO 540
C     =========================================
      LF = LF + 1
  530 MF(LF) = M1F(L+1)
  540 MF(LF+1) = -32767
      GO TO 510
  550 EOFFLG =.TRUE.
      M1(1)  = EOFZ
      M1(2)  = EOFZ
      GO TO 590
  560 WRITE  (NOUT,570) UFM,T1(1,K),T1(2,K),M(1),KNT
  570 FORMAT (A23,' 312, TOO MANY CONTINUATIONS FOR BULK DATA CARD ',
     1        2A4,I8,6X,'SORTED CARD COUNT =',I7)
      CALL PAGE2 (2)
      ABORT =.TRUE.
      GO TO 510
  580 IF (M1(1).EQ.T1(1,K) .AND. M1(2).EQ.T1(2,K)) GO TO 600
  590 CL =.TRUE.
  600 IF (.NOT.CF .OR. T6(2,K).EQ.2) GO TO 610
      KKK = T3(1,K)
      II(KKK) = II(KKK) + 1
      CF =.FALSE.
      IF (KKK.EQ.6 .OR. KKK.EQ.12) GO TO 640
      ITRL(1) = T7(1,K)
      ITRL(2) = T7(2,K)
      ITRL(3) = K
      CALL WRITE (IFLE(CURFIL),ITRL,3,0)
C
C     CHECK FOR MIN-MAX NO. OF WORDS
C
  610 IF (T5(1,K) .LT. 0) GO TO 640
      L = JF
      IF (T5(1,K)-L) 630,690,650
  620 L = L + 4
  630 IF (T5(2,K)-L) 650,690,620
  640 L =-T5(1,K)
      IF (JF.GE.L .AND. JF.LE.T5(2,K)) GO TO 690
  650 WRITE  (NOUT,660) UFM,T1(1,K),T1(2,K),M(1),KNT
  660 FORMAT (A23,' 313, ILLEGAL NUMBER OF WORDS ON BULK DATA CARD ',
     1        2A4,I8,6X,'SORTED CARD COUNT =',I7)
      WRITE  (NOUT,670) T5(1,K),T5(2,K),K,L,JF
  670 FORMAT ('   T5(1&2,K),K,L,JF =',5I4)
      CALL PAGE2 (2)
      ABORT =.TRUE.
      IF (T6(1,K)) 710,680,680
  680 IF (.NOT.CL) GO TO 430
      IF (T6(2,K) .EQ. 2) GO TO 210
      CALL WRITE (IFLE(CURFIL),M,0,1)
      IF (T4(2,K) .GT. 0) GO TO 210
      II(KKK) = II(KKK) - 1
      CALL BCKREC (IFLE(CURFIL))
      GO TO 210
C
C     CHECK FOR PROPER FORMAT
C
  690 IF (T6(1,K) .LT. 0) GO TO 710
      L  = T6(1,K)
      L1 = 0
      DO 700 K1 = 1,LF
      L1 = L1 + 1
      IF (MF(K1) .EQ. 3) L1 = L1 + 1
      K2 = L + K1 - 1
      IF (F(K2).EQ.MF(K1) .OR. F(K2).EQ.5) GO TO 700
      IF (MF(K1).EQ.1    .AND. M(L1).EQ.0) GO TO 700
      IF (MF(K1).NE.0 .OR. F(K2).NE.1 .AND. F(K2).NE.2) GO TO 1350
  700 CONTINUE
  710 N = 0
      BADDAT =.FALSE.
      BADFOR =.FALSE.
      IF (IPVS .NE. 0) CALL IFPMDC
C
C     CALL SECONDARY ROUTINE TO EXAMINE EACH TYPE OF CARD
C
      KB = (K-1)/20 + 1
      IF (KB .GT. 18) GO TO 1060
      GO TO ( 810, 820, 830, 840, 850, 860, 870, 880, 890, 900,
     1        910, 920, 930, 940, 950, 960, 970, 980), KB
  810 KB = K
      GO TO (1030,1030,1050,1010,1010,1010,1010,1010,1010,1010,
     1       1010,1030,1030,1010,1010,1010,1030,1010,1010,1010), KB
  820 KB = K - 20
      GO TO (1010,1010,1010,1010,1010,1010,1010,1030,1010,1010,
     1       1010,1050,1010,1010,1010,1010,1010,1010,1010,1010), KB
  830 KB = K - 40
      GO TO (1010,1010,1010,1010,1010,1010,1010,1010,1010,1010,
     1       1050,1010,1010,1010,1010,1010,1010,1010,1010,1010), KB
  840 KB = K - 60
      GO TO (1010,1010,1010,1010,1010,1010,1010,1010,1010,1010,
     1       1010,1010,1010,1010,1010,1010,1010,1010,1040,1040), KB
  850 KB = K - 80
      GO TO (1010,1030,1030,1030,1020,1020,1020,1050,1020,1040,
     1       1040,1030,1020,1020,1020,1020,1020,1040,1050,1050), KB
  860 KB = K - 100
      GO TO (1050,1040,1050,1040,1040,1050,1050,1050,1050,1050,
     1       1050,1050,1050,1050,1050,1050,1050,1050,1020,1020), KB
  870 KB = K - 120
      GO TO (1010,1040,1030,1040,1010,1030,1010,1010,1010,1010,
     1       1030,1030,1020,1020,1010,1010,1010,1030,1030,1020), KB
  880 KB = K - 140
      GO TO (1020,1010,1030,1030,1030,1030,1030,1030,1030,1030,
     1       1030,1030,1030,1030,1030,1030,1030,1010,1050,1050), KB
  890 KB = K - 160
      GO TO (1050,1020,1050,1050,1050,1010,1050,1050,1050,1050,
     1       1050,1050,1050,1050,1050,1050,1050,1050,1010,1010), KB
  900 KB = K - 180
      GO TO (1010,1030,1030,1030,1030,1050,1050,1020,1040,1010,
     1       1020,1020,1050,1050,1040,1040,1060,1050,1040,1020), KB
  910 KB = K - 200
      GO TO (1040,1040,1040,1040,1040,1040,1040,1040,1040,1040,
     1       1040,1040,1040,1040,1010,1030,1040,1040,1040,1040), KB
  920 KB = K - 220
      GO TO (1040,1040,1010,1010,1010,1010,1010,1010,1010,1010,
     1       1010,1010,1010,1010,1010,1010,1010,1010,1040,1010), KB
  930 KB = K - 240
      GO TO (1010,1040,1010,1030,1050,1050,1050,1050,1010,1010,
     1       1050,1050,1050,1050,1050,1010,1010,1010,1010,1010), KB
  940 KB = K - 260
      GO TO (1020,1020,1050,1050,1050,1050,1050,1010,1050,1050,
     1       1050,1050,1030,1030,1050,1050,1050,1050,1030,1020), KB
  950 KB = K - 280
      GO TO (1020,1020,1020,1030,1030,1030,1030,1030,1010,1030,
     1       1010,1010,1010,1010,1040,1040,1030,1030,1010,1010), KB
  960 KB = K - 300
      GO TO (1050,1050,1050,1050,1050,1050,1050,1050,1050,1050,
     1       1050,1050,1050,1050,1010,1010,1010,1010,1010,1010), KB
  970 KB = K - 320
      GO TO (1040,1040,1040,1040,1040,1040,1040,1040,1030,1030,
     1       1010,1030,1040,1040,1040,1040,1010,1050,1050,1010), KB
  980 KB = K - 340
      GO TO (1010,1010,1010,1010,1030,1030,1030,1030,1030,1030,
     1       1030,1030,1030,1020,1060,1010,1010,1010,1010,1060), KB
 1010 CALL IFS1P (*1360,*680,*1100)
      GO TO 1230
 1020 CALL IFS2P (*1360,*680,*1100)
      GO TO 1230
 1030 CALL IFS3P (*1360,*680,*1100)
      GO TO 1230
 1040 CALL IFS4P (*1360,*680,*1100)
      GO TO 1230
 1050 CALL IFS5P (*1360,*680,*1100)
      GO TO 1230
 1060 CALL PAGE2 (2)
      WRITE  (NOUT,1070) SFM,K
 1070 FORMAT (A25,' 314, INVALID CALL FROM IFP.  K =',I10)
      ABORT =.TRUE.
      GO TO 1850
C
 1100 IF (.NOT.BADFOR) GO TO 1160
      IF (IT1K.NE.T1(1,K) .OR. IT2K.NE.T1(2,K)) GO TO 1110
      ICOUNT = ICOUNT + 1
      IF (ICOUNT-7) 1120,1140,1170
 1110 IT1K = T1(1,K)
      IT2K = T1(2,K)
 1120 CALL PAGE2 (2)
      IF (ID .EQ. 0) ID = M(1)
      WRITE  (NOUT,1130) UFM,T1(1,K),T1(2,K),ID,KNT
 1130 FORMAT (A23,' 315, FORMAT ERROR ON BULK DATA CARD ',2A4,I8,17X,
     1       'SORTED CARD COUNT =',I7)
      GO TO 1170
 1140 CALL PAGE2 (3)
      WRITE  (NOUT,1150)
 1150 FORMAT (31X,'.', /29X,'MORE', /31X,'.')
      GO TO 1170
 1160 IF (.NOT.BADDAT) ICOUNT = 0
 1170 IF (.NOT.BADDAT) GO TO 1220
      IF (JT1K.NE.T1(1,K) .OR. JT2K.NE.T1(2,K)) GO TO 1180
      JCOUNT = JCOUNT + 1
      IF (JCOUNT-7) 1190,1210,1230
 1180 JT1K = T1(1,K)
      JT2K = T1(2,K)
 1190 CALL PAGE2 (2)
      IF (ID .EQ. 0) ID = M(1)
      WRITE  (NOUT,1200) UFM,T1(1,K),T1(2,K),ID,KNT
 1200 FORMAT (A23,' 316, ILLEGAL DATA ON BULK DATA CARD ',2A4,I8,17X,
     1       'SORTED CARD COUNT =',I7)
      GO TO 1230
 1210 CALL PAGE2 (3)
      WRITE (NOUT,1150)
      GO TO 1230
 1220 IF (.NOT.BADFOR) JCOUNT = 0
 1230 IF (.NOT.BADFOR .AND. .NOT.BADDAT) GO TO 1300
      N = 0
      ABORT =.TRUE.
      GO TO 1340
C
C     WRITE OUT CARD DATA ON APPROPRIATE IFP OUTPUT FILE
C
 1300 IF (N .EQ. 0) GO TO 1340
      T4(2,K) = T4(2,K) + N
      DO 1310 L = 1,40
      IF (K .EQ. KKL(L)) GO TO 1320
 1310 CONTINUE
      GO TO 1330
 1320 CALL WRITE (IFLE(CURFIL),I,N,0)
      GO TO 1340
 1330 CONTINUE
      IF (INDX.NE.6 .AND. .NOT.ABORT .OR. INDX.EQ.15)
     1   CALL WRITE (IFLE(CURFIL),I,N,0)
 1340 IF (KN .EQ. 0) GO TO 680
      KN = 0
      GO TO 430
 1350 BADFOR =.TRUE.
 1360 IF (.NOT.BADFOR) GO TO 1370
      CALL PAGE2 (2)
      WRITE (NOUT,1130) UFM,T1(1,K),T1(2,K),M(1),KNT
      ABORT = .TRUE.
 1370 IF (.NOT.BADDAT) GO TO 1380
      CALL PAGE2 (2)
      WRITE (NOUT,1200) UFM,T1(1,K),T1(2,K),M(1),KNT
      ABORT =.TRUE.
      GO TO 680
 1380 IF (IAPP  .EQ. 1) GO TO 1850
      IF (ISUBS .NE. 0) GO TO 1850
 1390 WRITE  (NOUT,1400) SFM
 1400 FORMAT (A25,' 319, IFP READING EOF ON NPTP.')
      CALL PAGE2 (2)
      ABORT =.TRUE.
      GO TO 1850
 1410 KERROR = 1410
      GO TO 1440
 1420 KERROR = 1420
      GO TO 1440
 1430 KERROR = 1430
 1440 CALL PAGE2 (6)
      WRITE  (NOUT,1450) SFM,KERROR,(JR(L),L=1,20),KNT
 1450 FORMAT (A25,' 320, IFP ERROR',I5, /5X,'LAST CARD PROCESSED IS -',
     1        20A4,1H-, /5X,'SORTED CARD COUNT =',I7)
      ABORT =.TRUE.
      GO TO 1850
 1460 IF (CURFIL .NE. 0) CALL CLOSE (IFLE(CURFIL),2)
      DO 1470 L = 1,NFLS
      IF (L.EQ.6 .OR. L.EQ.12 .OR. STATUS(L).EQ.1) GO TO 1470
      KFIL = IFLE(L)
      CALL OPEN  (*130,KFIL,IBUFF,3)
      CALL WRITE (IFLE(L),IEND,3,1)
      II(L) = II(L) + 1
      CALL CLOSE (IFLE(L),1)
 1470 CONTINUE
C
C     CHECK TO SEE IF ALL MULTI-ENTRY CARD DATA (CROD, CTUBE, ETC.)
C     ARE SORTED ON THEIR ELEMENT/PROPERTY IDS
C
      DO 1480 L = 1,40
      IF (ENDARA(L) .LT. 0) GO TO 1490
 1480 CONTINUE
C
C     EITHER NO MULTI-ENTRY CARD DATA EXIST OR, IF THEY DO,
C     THEY ARE ALL SORTED ON THEIR ELEMENT/PROPERTY IDS
C
      GO TO 1700
C
C     NOT ALL MULTI-ENTRY CARD DATA ARE SORTED ON THEIR
C     ELEMENT/PROPERTY IDS.
C
C     CLOSE SCRATCH FILE (FILE 6) AT CURRENT POSITION WITHOUT REWIND
C     AND WITHOUT END-OF-FILE.
C
 1490 CALL CLOSE (IFLE(6),2)
C
C     READ DATA FROM GEOM2/EPT FILE, SORT ALL MULTI-ENTRY CARD DATA ON
C     THEIR ELEMENT/PROPERTY IDS AND WRITE THE RESULTING DATA ON
C     SCRATCH FILE (FILE 16)
C
C     NOTE.  GEOM2 IS IFLE(8) AND EPT IS IFLE(2)
C
      DO 1690 NNN = 1,2
      IF (NNN .EQ. 2) GO TO 1500
      IFILE   = IFLE(8)
      INAM(1) = FNM(1,8)
      INAM(2) = FNM(2,8)
      ITYPE(1)= ITYPE1(1)
      ITYPE(2)= ITYPE1(2)
      JMIN    = 1
      JMAX    = 20
      GO TO 1510
 1500 IFILE   = IFLE(2)
      INAM(1) = FNM(1,2)
      INAM(2) = FNM(2,2)
      ITYPE(1)= ITYPE2(1)
      ITYPE(2)= ITYPE2(2)
      JMIN    = 21
      JMAX    = 40
 1510 DO 1520 L = JMIN,JMAX
      IF (ENDARA(L) .LT. 0) GO TO 1530
 1520 CONTINUE
      GO TO 1690
 1530 ILEFT = NOPEN - NPARAM - 2
      ISTRT = 2*N1  + NPARAM + 2
      CALL GOPEN (IFILE,IBUFF,0)
      KFIL = IFLE(16)
      CALL OPEN  (*130,IFLE(16),IBUFF(N1+1),1)
      CALL WRITE (IFLE(16),INAM,2,1)
      INDEX = JMIN
 1540 CALL READ (*1680,*1670,IFILE,IBUFF(ISTRT),3,0,IFLAG)
      CALL WRITE (IFLE(16),IBUFF(ISTRT),3,0)
      IF (INDEX .GT. JMAX) GO TO 1560
      DO 1550 L = JMIN,JMAX
      IF (IBUFF(ISTRT).EQ.MENTRY(L) .AND. ENDARA(L).LT.0) GO TO 1580
 1550 CONTINUE
 1560 CALL READ  (*1660,*1570,IFILE,IBUFF(ISTRT),ILEFT,0,IFLAG)
      CALL WRITE (IFLE(16),IBUFF(ISTRT),ILEFT,0)
      GO TO 1560
 1570 CALL WRITE (IFLE(16),IBUFF(ISTRT),IFLAG,1)
      GO TO 1540
 1580 INDEX = INDEX + 1
      CALL PAGE2 (3)
      WRITE  (NOUT,1590) UIM,NENTRY(2*L-1),NENTRY(2*L),ITYPE
 1590 FORMAT (A29,' 334, ',2A4,' MULTI-ENTRY CARD DATA ARE NOT SORTED ',
     1       'ON THEIR ',2A4,' IDS.', /5X,
     2       'SUBROUTINE IFP WILL SORT THE DATA.')
      IFAIL = 0
 1600 CALL READ (*1660,*1610,IFILE,IBUFF(ISTRT),ILEFT,0,IFLAG)
      IFAIL = IFAIL + 1
      GO TO 1600
 1610 IF (IFAIL .EQ. 0) GO TO 1630
      NWDS = (IFAIL-1)*ILEFT + IFLAG
      CALL PAGE2 (4)
      WRITE  (NOUT,1620) UFM,NENTRY(2*L-1),NENTRY(2*L),NWDS
 1620 FORMAT (A23,' 333, UNABLE TO SORT ',2A4,' MULTI-ENTRY CARD DATA ',
     1       'IN SUBROUTINE IFP DUE TO INSUFFICIENT CORE.', /5X,
     3       'ADDITIONAL CORE REQUIRED =',I10,7H  WORDS)
      CALL MESAGE (-61,0,0)
 1630 NWDS = 4
      IF (L.EQ.10 .OR. L.EQ.33) NWDS = 3
      IF (L.EQ.21 .OR. L.EQ.23) NWDS = 2
      CALL SORT  (0,0,NWDS,1,IBUFF(ISTRT),IFLAG)
      CALL WRITE (IFLE(16),IBUFF(ISTRT),IFLAG,1)
C
C     CHECK SORTED MULTI-ENTRY CARD DATA FOR NON-UNIQUE
C     ELEMENT/PROPERTY IDS
C
      IREPT = -10000000
      NIDSM1= IFLAG/NWDS - 1
      DO 1650 KK = 1,NIDSM1
      EID   = IBUFF(ISTRT+KK*NWDS)
      EIDM1 = IBUFF(ISTRT+KK*NWDS-NWDS)
      IF (EID .NE. EIDM1) GO TO 1650
      IF (EID .EQ. IREPT) GO TO 1650
      IREPT = EID
      ABORT = .TRUE.
      CALL PAGE2 (2)
      WRITE  (NOUT,1640) UFM,ITYPE,EID,NENTRY(2*L-1),NENTRY(2*L)
 1640 FORMAT (A23,' 335, NON-UNIQUE ',2A4,' ID',I9,' ENCOUNTERED IN ',
     1        2A4,' MULTI-ENTRY CARD DATA.')
 1650 CONTINUE
      GO TO 1540
 1660 CALL MESAGE (-2,IFILE,NAME)
 1670 CALL MESAGE (-3,IFILE,NAME)
 1680 CALL CLOSE  (IFILE,1)
      CALL CLOSE  (IFLE(16),1)
C
C     COPY DATA BACK FROM SCRATCH FILE (FILE 16) TO GEOM2/EPT FILE
C
      KFIL = IFLE(16)
      CALL OPEN (*130,IFLE(16),IBUFF,0)
      KFIL = IFILE
      CALL OPEN (*130,IFILE,IBUFF(N1+1),1)
      CALL CPYFIL (IFLE(16),IFILE,IBUFF(ISTRT),ILEFT,IFLAG)
      CALL CLOSE (IFLE(16),1)
      CALL CLOSE (IFILE,1)
 1690 CONTINUE
C
C     RE-OPEN SCRATCH FILE (FILE 6) TO WRITE WITHOUT REWIND
C
      KFIL = IFLE(6)
      CALL OPEN (*130,IFLE(6),IBUFF(N1+1),3)
C
C     WRITE TRAILERS
C
 1700 DO 1740 J = 1,NFLS
      IF (J.EQ.6 .OR. J.EQ.12) GO TO 1740
      DO 1710 L = 2,7
 1710 ITRL(L) = 0
      ITRL(1) = IFLE(J)
      IF (II(J).LE.2 .OR. ABORT) GO TO 1730
      DO 1720 L = 1,NCDSMX
      IF (T3(1,L).NE.J .OR. T4(2,L).LE.0) GO TO 1720
      KT721 = ANDF(T7(2,L),511)
      K1 = (KT721-1)/16 + 2
      K2 = KT721 - (K1-2)*16 + 16
      ITRL(K1) = ORF(ITRL(K1),TWO(K2))
 1720 CONTINUE
 1730 CALL WRTTRL (ITRL)
 1740 CONTINUE
C
C     WRITE PARAM CARDS ON NPTP
C
      KFIL = IFLE(16)
      CALL IFPPAR
      IF (NPARAM.LE.0 .OR. ABORT) GO TO 1850
      CALL OPEN (*130,KFIL,IBUFF,1)
      ITRL(1) = KFIL
      ITRL(2) = NPARAM
      CALL WRTTRL (ITRL(1))
      CALL WRITE (KFIL,FNM(1,6),2,1)
      CALL WRITE (KFIL,IBUFF(2*N1+1),NPARAM,1)
      IPM   = 1
      IPN   = 2*N1 + IPM
      GO TO 1840
 1800 IPN   = 2*N1 + IPM
      NM(1) = IBUFF(IPN  )
      NM(2) = IBUFF(IPN+1)
      JPM   = 1
 1810 JPN   = 2*N1 + JPM
      IF (NM(1).NE.IBUFF(JPN) .OR. NM(2).NE.IBUFF(JPN+1)) GO TO 1830
      CALL PAGE2 (2)
      WRITE  (NOUT,1820) UFM,NM(1),NM(2)
 1820 FORMAT (A23,' 321, NON-UNIQUE PARAM NAME - ',2A4,1H-)
      ABORT =.TRUE.
 1830 JPM   = JPM + 4
      IF (IBUFF(JPN+2) .GT. 2) JPM = JPM + 1
      IF (IBUFF(JPN+2) .GT. 5) JPM = JPM + 2
      IF (JPM .LT. IPM) GO TO 1810
 1840 IPM = IPM + 4
      IF (IBUFF(IPN+2) .GT. 2) IPM = IPM + 1
      IF (IBUFF(IPN+2) .GT. 5) IPM = IPM + 2
      IF (IPM .LT. NPARAM) GO TO 1800
      CALL EOF (KFIL)
      CALL CLOSE (KFIL,1)
 1850 CALL CLOSE (IFLE(6),1)
C
C     CHECK FOR PROPERTY ID UNIQUENESS IN EPT FILE AND PROPERTY ID
C     SPECIFIED IN GEOM2 ELEMENTS
C
      CALL SSWTCH (34,JJ1)
      IF (JJ1 .EQ. 1) GO TO 1900
      KFIL = IFLE(2)
      ITRL(1) = KFIL
      CALL RDTRL (ITRL)
      J = ITRL(2) + ITRL(3) + ITRL(4) + ITRL(5) + ITRL(6) + ITRL(7)
      JJ1 = 1
      IF (ITRL(1).LT.0 .OR. J.EQ.0) GO TO 1860
      JJ1 = 0
      CALL OPEN (*130,KFIL,IBUFF,0)
 1860 KFIL = IFLE(8)
      ITRL(1) = KFIL
      CALL RDTRL (ITRL)
      J = ITRL(2) + ITRL(3) + ITRL(4) + ITRL(5) + ITRL(6) + ITRL(7)
      IF (ITRL(1).LT.0 .OR. J.EQ.0) GO TO 1880
      CALL OPEN (*130,KFIL,IBUFF(N1+1),0)
      JJ = N1*2 + 1
      CALL PIDCK (IFLE(2),KFIL,JJ1,IBUFF(JJ))
      CALL CLOSE (KFIL,1)
      IF (JJ1) 1880,1870,1890
 1870 IF (IBUFF(JJ) .EQ. 0) GO TO 1880
      JJ1 = JJ + IBUFF(JJ) + 1
C
C     CHECK FOR MATERIAL ID UNIQUENESS IN MPT FILE
C     AND MATERIAL ID SPECIFIED IN PROPERTY CARDS
C
      KFIL = IFLE(3)
      ITRL(1) = KFIL
      CALL RDTRL (ITRL)
      J = ITRL(2) + ITRL(3) + ITRL(4) + ITRL(5) + ITRL(6) + ITRL(7)
      IBUFF(JJ1) = 1
      IF (ITRL(1).LT.0 .OR. J.EQ.0) IBUFF(JJ1) = 0
      IF (IBUFF(JJ1) .EQ. 1) CALL OPEN (*130,KFIL,IBUFF(N1+1),0)
      CALL MATCK (KFIL,IFLE(2),IBUFF(JJ),IBUFF(JJ1))
      IF (IBUFF(JJ1) .NE. 0) CALL CLOSE (KFIL,1)
 1880 CALL CLOSE (IFLE(2),1)
C
C     CHECK COORDINATE ID'S AND THEIR REFERENCES FROM
C     OTHER BULK DATA CARDS
C
 1890 JJ = NOPEN + N1 - 2
C                + N1 - 2 = 2*N1 - (N1+2)
      CALL CIDCK (IBUFF(N1+2),IBUFF,JJ)
 1900 CONTINUE
C
C     CHECK FOR ERRORS IN AXISYMMETRIC DATA
C
      IF (IAX) AXICCC = 1
      AXIFCC = IAXF
      IF (AXICCC.LE.0 .OR. AXIFCC.LE.0) GO TO 1920
      AXICCC = 0
      AXIFCC = 0
      ABORT  = .TRUE.
      CALL PAGE2 (2)
      WRITE (NOUT,1910) UFM
 1910 FORMAT (A23,' 337, BOTH AXIC AND AXIF CARDS USED IN BULK DATA.')
      GO TO 1980
 1920 IF (AXICCC .LE. 0) GO TO 1950
      IF (IAXIC  .GT. 0) GO TO 1980
      AXICCC = 0
C
C     SUPPRESS ABORT IF IT IS A UMFEDIT RUN
C
 1930 IF (IUMFED .NE. 0) GO TO 1980
      ABORT = .TRUE.
      CALL PAGE2 (2)
      WRITE (NOUT,1940) UFM
 1940 FORMAT (A23,' 338, AXISYMMETRIC CARD REQUIRED IN CASE CONTROL')
      GO TO 1980
 1950 IF (AXIFCC .LE. 0) GO TO 1960
      IF (IAXIF.GT.0 .OR. AXIFCC.EQ.2) GO TO 1980
      AXIFCC = 0
      GO TO 1930
 1960 IF (IAXIC.LE.0 .AND. IAXIF.LE.0) GO TO 1980
      AXICCC = 0
      AXIFCC = 0
C
C     SUPPRESS ABORT IF IT IS A UMFEDIT RUN
C
      IF (IUMFED .NE. 0) GO TO 1980
      ABORT = .TRUE.
      CALL PAGE2 (2)
      WRITE  (NOUT,1970) UFM
 1970 FORMAT (A23,' 339, ILLEGAL USE OF AXISYMMETRIC CARD IN CASE ',
     1       'CONTROL DECK.')
C
 1980 IF (IAPP .GE. 0) GO TO 1990
C
C     CHECK CERTAIN RESTART FLAGS BASED ON BULK DATA
C
      MN = LBD + 1
C
C     TURN ON TEMPMX$ IF MATERIALS USE TEMPS
C
      IF (T4(2,91)+T4(2,102)+T4(2,189) .EQ. 0) GO TO 1990
      IF (ANDF(IB(1),TWO(28)).EQ.0 .AND. ANDF(IB(5),TWO(32)).EQ.0 .AND.
     1    ANDF(IB(4),TWO( 6)).EQ.0 .AND. ANDF(IB(3),TWO(32)).EQ.0 .AND.
     2    ANDF(IB(4),TWO( 2)).EQ.0 .AND. ANDF(IB(4),TWO( 3)).EQ.0 .AND.
     3    ANDF(IB(4),TWO( 4)).EQ.0 ) GO TO 1990
      IB(MN) = ORF(IB(MN),TWO(19))
 1990 CALL CONMSG (IFPNA2,2,0)
C
      CALL SSWTCH (27,L27)
      IF (L27 .EQ. 0) GO TO 2060
      CALL PAGE1
      LINE = LINE + 8
      WRITE  (NOUT,2000)
 2000 FORMAT ('0DIAG 27 DUMP OF IFP TABLES AFTER IFP PROCESSING',     /,
     1        1H0,6X,6HIFX1BD,9X,6HIFX2BD,7X,6HIFX3BD,2X,6HIFX4BD,3X,
     2               6HIFX5BD,6X,6HIFX6BD                            ,/,
     3        1H ,5X,8(1H-),2X,17(1H-),2X,6(1H-),2X,6(1H-),2X,8(1H-),
     4            2X,12(1H-)                                         ,/,
     5        1H ,1X,3H(A),3X,3H(B),5X,3H(C),3X,3H(D),5X,3H(E),2X,3H(N),
     6            5X,3H(F),   3H(G),3X,3H(H),1X,3H(I),3X,3H(J),5X,3H(K),
     7            4X,3H(L),3X,3H(M),4X,3H(O),3X,4HFLAG               ,/
     8        1H0 )
 2010 FORMAT (1H ,I4,1X,2A4,I4,1X,1H(,2A4,1H),I3,I5,I4,
     1            I4,I4,I6,I3,I7,I8,16X,
     2            I1,I1,A1,I1,4X,I2)
      DO 2050 J = 1,NCDSMX
      ID = T3(1,J)
      IF (ID .LE. 0) GO TO 2020
      LF = FNM(1,ID)
      LM = FNM(2,ID)
      GO TO 2030
 2020 CONTINUE
      LF = BLANK
      LM = BLANK
 2030 CONTINUE
      N  = J
      K  = N/90 + MIN0(1,MOD(N,90))
      N  = N - 90*(K-1)
      KX = N/30 + MIN0(1,MOD(N,30))
      N  = N - 30*(KX-1)
      KY = N/6  + MIN0(1,MOD(N, 6))
      L  = N - 6*(KY-1)
      IFLAG = 0
      IF (EJECT(1) .EQ. 0) GO TO 2040
      WRITE (NOUT,2000)
      LINE = LINE + 8
 2040 CONTINUE
      LINE = LINE + 1
      WRITE (NOUT,2010) J,T1(1,J),T1(2,J),
     1                    T3(1,J),LF,LM,T3(2,J),
     2                    T4(1,J),T4(2,J),
     3                    T5(1,J),T5(2,J),
     4                    T6(1,J),T6(2,J),
     5                    T7(1,J),T7(2,J),
     6                    K,KX,OOO(KY),L,IFLAG
 2050 CONTINUE
C
 2060 RETURN
      END

      SUBROUTINE FERSWS(V1,V3,VB)         
C
C  The original to this subroutine was FRSW.  It has been modified
C  to read the matrix data from memory and after this data is exhausted
C  then to read the remaining data from the file.
C
      REAL              V1(1)     ,V3(1)     ,VB(1)  ,
     1                  XL(1)     ,XLJJ      ,V3J
      REAL              ZERO      ,SUM
      REAL              DCORE(1)
      INTEGER           IBLK(20)
      COMMON / ZZZZZZ / ICORE(1)  
      COMMON  /OPINV /  MCBLT(7) ,MCBSMA(7)
      COMMON  /SYSTEM/  KSYSTM(65)
      COMMON  /FEERIM/  NIDSMA, NIDLT    , NIDORV  , NLTLI
     1,                 NSMALI, IBFSMA   , IBFLT
     2,                 IBFORV, SMAPOS(7), LTPOS(7)
      EQUIVALENCE       (KSYSTM(02),IO)
      EQUIVALENCE       ( DCORE(1),ICORE(1), XL(1) )   
      DATA              ZERO / 0.0 /
C
      NROW    = MCBLT(2)
      CALL FERLTS(MCBSMA(1),V1(1),V3(1),VB(1))
C   FORWARD SWEEP DIRECTLY ON V3
      ICROW = 1
      IF ( NIDLT .EQ. 0 ) GO TO 1005
      ILROW = LTPOS( 1 )
      MEM   = NIDLT
      DO 190 J = 1,NROW
      ICROW = J
      IF ( ICROW .GT. ILROW ) GO TO 1000
  140 ICOL  = ICORE(MEM)
      IF ( ICOL .NE. J ) GO TO 180
      JI    = MEM + 2
      NTMS  = ICORE(MEM+1)
      NTMSS = NTMS
      IK    = ICORE(MEM + 2 + NTMS)
      IF(IK .NE. J) GO TO 150
      NTMS  = NTMS - 1
      XLJJ  = DCORE(JI)
      JI    = JI + 1
      IK    = IK + 1
  150 IF(NTMS .EQ. 0) GO TO 170
      V3J   = V3(J)
      DO 160 II = 1,NTMS
      V3(IK)= V3(IK) + DCORE(JI) * V3J
      IK    = IK + 1
      JI    = JI + 1
  160 CONTINUE
  170 MEM   = MEM + NTMSS + 4
      GO TO 140
  180 V3(J) = V3(J) / XLJJ
  190 CONTINUE
      GO TO 2000
 1000 CONTINUE
C POSITION FILE TO APPROPRIATE COLUMN 
      CALL DSSPOS ( MCBLT, LTPOS(2), LTPOS(3), LTPOS(4) )
      GO TO 1008
 1005 CONTINUE
      CALL REWIND ( MCBLT )
      CALL SKPREC ( MCBLT, 1 )
 1008 CONTINUE
      IBLK( 1 ) = MCBLT( 1 )
C
C CONTINUE WITH FORWARD SWEEP
C   
      DO 1090 J = ICROW, NROW
      IBLK( 8 ) = -1
 1030 CALL GETSTR ( *1070, IBLK )
      IK   = IBLK( 4 )
      JI   = IBLK( 5 )
      NTMS = IBLK( 6 )
      IF ( IK .NE. J ) GO TO 1040
      NTMS = NTMS - 1
      XLJJ = XL( JI )
      JI   = JI + 1
      IK   = IK + 1
 1040 IF ( NTMS .EQ. 0 ) GO TO 1060
      V3J  = V3( J )
      IF ( V3J .EQ. ZERO ) GO TO 1060
      DO 1050 II = 1, NTMS
      V3( IK ) = V3( IK ) + XL(JI)*V3J
      IK   = IK + 1
      JI   = JI + 1
 1050 CONTINUE
 1060 CALL ENDGET ( IBLK )
      GO TO 1030
 1070 CONTINUE
      V3( J ) = V3( J ) / XLJJ
 1090 CONTINUE
 2000 CONTINUE
C
C     BACKWARD SUBSTITUTION OMIT DIAGONAL
C
      ICROW = NROW
      IF ( J .EQ. 1 ) RETURN
      IF ( ILROW .EQ. NROW .AND. NIDLT .NE. 0 ) GO TO 3000
      J     = NROW
 2090 IBLK( 8 ) = -1
 2100 CALL GETSTB ( *2130, IBLK )
      IK    = IBLK( 4 )
      JI    = IBLK( 5 )
      NTMS  = IBLK( 6 )
      IF ( IK-NTMS+1 .EQ. J ) NTMS = NTMS - 1
      IF ( NTMS .EQ. 0 ) GO TO 2120
      SU    = ZERO
      DO 2110 II = 1, NTMS
      SUM   = SUM + XL(JI) * V3(IK)
      JI    = JI - 1
      IK    = IK - 1
 2110 CONTINUE
      V3( J ) = V3( J ) + SUM
 2120 CALL ENDGTB ( IBLK )
      GO TO 2100
 2130 IF ( J .EQ. 1 ) GO TO 7000
      J = J - 1
      IF ( J .LE. ILROW ) GO TO 3000
      GO TO 2090
C  CONTINUE BACKWARD SUBSTITUTION USING DATA FROM MEMORY
 3000 CONTINUE
      MEM = MEM - NTMSS - 4
 3200 CONTINUE
 3210 ICOL = ICORE(MEM)
      IF ( ICOL .NE. J ) GO TO 3240
      NTMS  = ICORE(MEM+1)
      NTMSS = NTMS
      JI    = MEM + 1 + NTMS
      IK    = ICORE( MEM + 2 + NTMS ) + NTMS - 1
      IF( IK-NTMS+1 .EQ. J) NTMS = NTMS - 1
      IF( NTMS .EQ. 0 ) GO TO 3230
      V3J   = V3( J )
      DO 3220 II = 1,NTMS
      V3J   = V3J + DCORE(JI) * V3(IK)
      JI    = JI-1
      IK    = IK-1
 3220 CONTINUE
      V3(J) = V3J
 3230 IF ( MEM .EQ. NIDLT ) GO TO 3250
      NTMSNX= ICORE(MEM-1)
      MEM   = MEM - NTMSNX - 4
      GO TO 3210
 3240 IF ( J .EQ. 1 )  GO TO 3250
      J     = J-1
      GO TO 3200
 3250 CONTINUE
 7000 CONTINUE
      RETURN
      END

      SUBROUTINE DS1A
C
C     THIS ROUTINE GENERATES THE MATRIX KGGD WHICH IS THE SECOND ORDER
C     APPROXIMATION TO THE STIFFNESS MATRIX KGG.
C
      INTEGER          EOR,CLSRW,OUTRW,FROWIC,CSTM,DIT,ECPTDS,GPCT,
     1                 BUFFR1,BUFFR2,BUFFR3,FILE,BAR,BEAM,ITYPI(20)
      DOUBLE PRECISION DZ(1),DPWORD,DDDDDD
      DIMENSION        NDUM(9),IZ(1),INPVT(2),NAME(2),MCBKGG(7)
      CHARACTER        UFM*23
      COMMON /XMSSG /  UFM
      COMMON /BLANK /  ICOM
      COMMON /SYSTEM/  KSYSTM(100)
      COMMON /ZZZZZZ/  Z(1)
      COMMON /DS1ADP/  DDDDDD(300)
      COMMON /DS1AET/  ECPT(112)
      COMMON /DS1AAA/  NPVT,ICSTM,NCSTM,IGPCT,NGPCT,IPOINT,NPOINT,
     1                 I6X6K,N6X6K,CSTM,MPT,DIT,ECPTDS,GPCT,KGGD,
     2                 INRW,OUTRW,EOR,NEOR,CLSRW,JMAX,FROWIC,LROWIC,
     3                 NROWSC,NLINKS,LINK(10),NOGO
      COMMON /GPTA1 /  NELEMS,LAST,INCR,NE(1)
      COMMON /ZBLPKX/  DPWORD,DUM(2),INDEX
      COMMON /CONDAS/  PI,TWOPI,RADEG,DEGRA,S4PISQ
      EQUIVALENCE      (KSYSTM( 1),   ISYS), (KSYSTM( 2),IOUTPT),
     1                 (KSYSTM(46),NDUM(1)), (KSYSTM(55), IPREC)
      EQUIVALENCE      (Z(1),IZ(1),DZ(1))
      DATA    NAME  /  4HDS1A,4H    /, BAR,BEAM / 4HBAR ,4HBEAM /
C
C     DEFINE VARIABLES IN COMMON /DS1AAA/
C
      CSTM  = 106
      MPT   = 107
      DIT   = 110
      ECPTDS= 301
      GPCT  = 109
      KGGD  = 201
      INRW  = 0
      OUTRW = 1
      EOR   = 1
      NEOR  = 0
      CLSRW = 1
      NLINKS= 10
      NOGO  = 0
      IITYP = 0
      J     = 26
      NE(J) = BAR
      CALL SSWTCH (38,L38)
C
C     DETERMINE SIZE OF VARIABLE CORE, AND SET UP BUFFERS
C
      IPR = IPREC
      CALL DELSET
      IZMAX  = KORSZ(Z)
      BUFFR1 = IZMAX  - ISYS
      BUFFR2 = BUFFR1 - ISYS
      BUFFR3 = BUFFR2 - ISYS
      LEFTT  = BUFFR3 - 1
C
C     READ THE CSTM INTO CORE
C
      IFILE = CSTM
      NCSTM = 0
      ICSTM = 0
      CALL OPEN (*2,CSTM,Z(BUFFR1),INRW)
      CALL FWDREC (*9020,CSTM)
      CALL READ (*9030,*1,CSTM,Z(ICSTM+1),LEFTT,EOR,NCSTM)
      CALL MESAGE (-8,0,NAME)
    1 LEFTT = LEFTT - NCSTM
C
C     PRETRD SETS UP SUBSEQUENT CALLS TO TRANSD.
C
      CALL PRETRS (Z(ICSTM+1),NCSTM)
      CALL PRETRD (Z(ICSTM+1),NCSTM)
      CALL CLOSE  (CSTM,CLSRW)
    2 IMAT1 = NCSTM
C
C     CALL PREMAT TO READ MPT AND DIT INTO CORE.
C
      CALL PREMAT (Z(IMAT1+1),Z(IMAT1+1),Z(BUFFR1),LEFTT,MATCR,MPT,DIT)
      LEFTT = LEFTT - MATCR
      IGPCT = NCSTM + MATCR
C
C     OPEN KGGD, ECPTDS AND GPCT
C
      CALL GOPEN  (KGGD,Z(BUFFR1),OUTRW)
      CALL MAKMCB (MCBKGG,KGGD,0,6,IPR)
      CALL GOPEN  (ECPTDS,Z(BUFFR2),INRW)
      CALL GOPEN  (GPCT,Z(BUFFR3),INRW)
C
C     READ THE FIRST TWO WORDS OF NEXT GPCT RECORD INTO INPVT(1).
C     INPVT(1) IS THE PIVOT POINT.  INPVT(1) .GT. 0 IMPLIES THE PIVOT
C     POINT IS A GRID POINT.  INPVT(1) .LT. 0 IMPLIES THE PIVOT POINT IS
C     A SCALAR POINT.  INPVT(2) IS THE NUMBER OF WORDS IN THE REMAINDER
C     OF THIS RECORD OF THE GPCT.
C
   10 FILE = GPCT
      CALL READ (*1000,*700,GPCT,INPVT(1),2,NEOR,IFLAG)
      NGPCT = INPVT(2)
      CALL FREAD (GPCT,IZ(IGPCT+1),NGPCT,EOR)
      IF (INPVT(1) .LT. 0) GO TO 700
C
C     FROWIC IS THE FIRST ROW IN CORE. (1 .LE. FROWIC .LE. 6)
C
      FROWIC = 1
C
C     DECREMENT THE AMOUNT OF CORE REMAINING.
C
      LEFT   = LEFTT - 2*NGPCT
      IF (LEFT .LE. 0) CALL MESAGE (-8,0,NAME)
      IPOINT = IGPCT + NGPCT
      NPOINT = NGPCT
      I6X6K  = IPOINT + NPOINT
      I6X6K  = (I6X6K - 1)/2 + 2
C
C     CONSTRUCT THE POINTER TABLE, WHICH WILL ENABLE SUBROUTINE DS1B TO
C     INSERT THE 6 X 6 MATRICES INTO KGGD.
C
      IZ(IPOINT+1) = 1
      I1 = 1
      I  = IGPCT
      J  = IPOINT + 1
   30 I1 = I1 + 1
      IF (I1 .GT. NGPCT) GO TO 40
      I  = I + 1
      J  = J + 1
      INC= 6
      IF (IZ(I) .LT. 0) INC = 1
      IZ(J) = IZ(J-1) + INC
      GO TO 30
C
C     JMAX = NO. OF COLUMNS OF KGGD THAT WILL BE GENERATED WITH THE
C     CURRENT GRID POINT.
C
   40 INC   = 5
      ILAST = IGPCT  + NGPCT
      JLAST = IPOINT + NPOINT
      IF (IZ(ILAST) .LT. 0) INC = 0
      JMAX  = IZ(JLAST) + INC
C
C     IF 2*6*JMAX .LT. LEFT THERE ARE NO SPILL LOGIC PROBLEMS FOR
C     KGGD SINCE THE WHOLE DOUBLE PRECISION SUBMATRIX OF ORDER 6 X JMAX
C     CAN FIT IN CORE.
C
      ITEMP = 6*JMAX
      IF (2*ITEMP .LT. LEFT) GO TO 80
      NAME(2) = INPVT(1)
      CALL MESAGE (30,85,NAME)
      NROWSC = 3
   70 IF (2*NROWSC*JMAX .LT. LEFT) GO TO 90
      NROWSC = NROWSC - 1
      IF (NROWSC .EQ. 0) CALL MESAGE (-8,0,NAME)
      GO TO 70
   80 NROWSC = 6
C
C     LROWIC IS THE LAST ROW IN CORE. (1 .LE. LROWIC .LE. 6)
C
   90 LROWIC = FROWIC + NROWSC - 1
C
C     ZERO OUT THE KGGD SUBMATRIX IN CORE.
C
  100 LOW = I6X6K + 1
      LIM = I6X6K + JMAX*NROWSC
      DO 115 I = LOW,LIM
  115 DZ(I) = 0.0D0
C
C     INITIALIZE THE LINK VECTOR TO -1.
C
      DO 140 I = 1,NLINKS
  140 LINK(I) = -1
C
C     TURN FIRST PASS INDICATOR ON.
C
  150 IFIRST = 1
C
C     READ THE 1ST WORD OF THE ECPT RECORD, THE PIVOT POINT, INTO NPVT.
C     IF NPVT .LT. 0, THE REMAINDER OF THE ECPT RECORD IS NULL SO THAT
C     1 OR 6 NULL COLUMNS MUST BE GENERATED
C
      FILE = ECPTDS
      CALL FREAD (ECPTDS,NPVT,1,NEOR)
      IF (NPVT .LT. 0) GO TO 700
C
C     READ THE NEXT ELEMENT TYPE INTO THE CELL ITYPE.
C
  160 CALL READ (*9020,*500,ECPTDS,ITYPE,1,NEOR,IFLAG)
C
C     READ THE ECPT ENTRY FOR THE CURRENT TYPE INTO THE ECPT ARRAY. THE
C     NUMBER OF WORDS TO BE READ WILL BE NWORDS(ITYPE).
C
      IP = IPREC
      IF (IP .NE. 1) IP = 0
      JTYP  = 2*ITYPE - IP
      NFREE = 3
      IF (ITYPE.EQ.2 .OR. ITYPE.EQ.35. OR. ITYPE.EQ.75) NFREE = 6
C               BEAM             CONEAX           TRSHL
      IF (ITYPE.GE.53 .AND. ITYPE.LE.61) NFREE = MOD(NDUM(ITYPE-52),10)
C                DUM1              DUM9
      IDX = (ITYPE-1)*INCR
      NWORDS = NE(IDX+12) + 2 + NFREE*NE(IDX+10)
      IF (ITYPE.GE.65 .AND. ITYPE.LE.67) NWORDS = NWORDS + NE(IDX+10) -1
C               IHEX1             IHEX3
      IF (ITYPE .EQ. 80) NWORDS = NWORDS + NE(IDX+10)
C                 IS2D8
      IF (ITYPE .EQ. 35) NWORDS = NWORDS + 1
C                CONEAX
      IF (NE(IDX+12) .LE. 0) CALL MESAGE (-61,0,NAME)
      CALL FREAD (ECPTDS,ECPT,NWORDS,NEOR)
      ITEMP = NE(IDX+24)
C
C     IF THIS IS THE 1ST ELEMENT READ ON THE CURRENT PASS OF THE ECPT
C     CHECK TO SEE IF THIS ELEMENT IS IN A LINK THAT HAS ALREADY BEEN
C     PROCESSED.
C
      IF (IFIRST .EQ. 1) GO TO 170
C
C     THIS IS NOT THE FIRST PASS.  IF ITYPE(TH) ELEMENT ROUTINE IS IN
C     CORE, PROCESS IT.
C
      IF (ITEMP .EQ. LINCOR) GO TO 171
C
C     THE ITYPE(TH) ELEMENT ROUTINE IS NOT IN CORE.  IF THIS ELEMENT
C     ROUTINE IS IN A LINK THAT ALREADY HAS BEEN PROCESSED READ THE NEXT
C     ELEMENT.
C
      IF (LINK(ITEMP) .EQ. 1) GO TO 160
C
C     SET A TO BE PROCESSED LATER FLAG FOR THE LINK IN WHICH THE ELEMENT
C     RESIDES
C
      LINK(ITEMP) = 0
      GO TO 160
C
C     SINCE THIS IS THE FIRST ELEMENT TYPE TO BE PROCESSED ON THIS PASS
C     OF THE ECPT RECORD, A CHECK MUST BE MADE TO SEE IF THIS ELEMENT
C     IS IN A LINK THAT HAS ALREADY BEEN PROCESSED.  IF IT IS SUCH AN
C     ELEMENT, WE KEEP IFIRST = 1 AND READ THE NEXT ELEMENT.
C
  170 IF (LINK(ITEMP) .EQ. 1) GO TO 160
C
C     SET THE CURRENT LINK IN CORE = ITEMP AND IFIRST = 0
C
      LINCOR = ITEMP
      IFIRST = 0
C
C     CALL THE PROPER ELEMENT ROUTINE.
C
  171 IF (ITYPE.LE.0 .OR. ITYPE.GT.NELEMS) CALL MESAGE (-7,0,NAME)
C
C     IF DIAG 38 IS ON, ECHO TYPE OF ELEMENT BEING PROCESSED
C
      IF (L38   .EQ. 0) GO TO 180
      IF (IITYP .EQ. 0) GO TO 175
      DO 173 II = 1,IITYP
      IF (ITYPE .EQ. ITYPI(II)) GO TO 180
  173 CONTINUE
      IF (IITYP .GE. 20) GO TO 180
  175 IITYP = IITYP + 1
      ITYPI(IITYP) = ITYPE
      WRITE  (IOUTPT,177) NE(IDX+1),NE(IDX+2),ITYPE
  177 FORMAT ('0*** DS1 MODULE PROCESSING ',2A4,' ELEMENTS (ELEM.TYPE',
     1        I4,1H))
C
  180 LOCAL = JTYP - 100
      IF (LOCAL) 181,181,182
  181 GO TO (
C
C        1-CROD       2-CBEAM      3-CTUBE      4-CSHEAR     5-CTWIST
     O   210,  210,   220,  220,   230,  230,   240,  240,  9040, 9040,
C
C        6-CTRIA1     7-CTRBSC     8-CTRPLT     9-CTRMEM     10-CONROD
     1   260,  260,  9040, 9040,  9040, 9040,   250,  250,   210,  210,
C
C        11-CELAS1    12-CELAS2    13-CELAS3    14-CELAS4    15-CQDPLT
     2  9040, 9040,  9040, 9040,  9040, 9040,  9040, 9040,  9040, 9040,
C
C        16-CQDMEM    17-CTRIA2    18-CQUAD2    19-CQUAD1    20-CDAMP1
     3   280,  280,   270,  270,   300,  300,   290,  290,  9040, 9040,
C
C        21-CDAMP2    22-CDAMP3    23-CDAMP4    24-CVISC     25-CMASS1
     4  9040, 9040,  9040, 9040,  9040, 9040,  9040, 9040,  9040, 9040,
C
C        26-CMASS2    27-CMASS3    28-CMASS4    29-CONM1     30-CONM2
     5  9040, 9040,  9040, 9040,  9040, 9040,  9040, 9040,  9040, 9040,
C
C        31-PLOTEL    32-X         33-X         34-CBAR      35-CCONEAX
     6  9040, 9040,  9040, 9040,  9040, 9040,  9040, 9040,   370,  370,
C
C        36-CTRIARG   37-CTRAPRG   38-CTORDRG   39-CTETRA    40-CWEDGE
     7  9040, 9040,  9040, 9040,  9040, 9040,  9040, 9040,  9040, 9040,
C
C        41-CHEXA1    42-CHEXA2    43-CFLUID2   44-CFLUID3   45-CFLUID4
     8  9040, 9040,  9040, 9040,  9040, 9040,  9040, 9040,  9040, 9040,
C
C        46-CFLMASS   47-CAXIF2    48-CAXIF3    49-CAXIF4    50-CSLOT3
     9  9040, 9040,  9040, 9040,  9040, 9040,  9040, 9040,  9040, 9040
C
     X   ), JTYP
C
  182 GO TO (
C
C        51-CSLOT4    52-CHBDY     53-CDUM1     54-CDUM2     55-CDUM3
     X  9040, 9040,  9040, 9040,   321,  321,   322,  322,   323,  323,
C
C        56-CDUM4     57-CDUM5     58-CDUM6     59-CDUM7     60-CDUM8
     A   324,  324,   325,  325,   326,  326,   327,  327,   328,  328,
C
C        61-CDUM9     62-CQDMEM1   63-CQDMEM2   64-CQUAD4    65-CIHEX1
     B   329,  329,  9040, 9040,  9040, 9040,   305,  305,   310,  310,
C
C        66-CIHEX2    67-CIHEX3    68-CQUADTS   69-CTRIATS   70-CTRIAAX
     C   310,  310,   310,  310,   311,  311,   312,  312,  9040, 9040,
C
C        71-CTRAPAX   72-CAERO1    73-CTRIM6    74-CTRPLT1   75-CTRSHL
     D  9040, 9040,  9040, 9040,  9040, 9040,  9040, 9040,   313,  314,
C
C        76-CFHEX1    77-CFHEX2    78-CFTETRA   79-CFWEDGE   80-CIS2D8
     E  9040, 9040,  9040, 9040,  9040, 9040,  9040, 9040,   315,  315,
C
C        81-CELBOW    82-FTUBE     83-CTRIA3    84-CPSE2     85-CPSE3
     F  9040, 9040,  9040, 9040,   275,  275,   380,  380,   385,  385,
C
C        86-CPSE4
     G   390,  390
C
     X   ), LOCAL
C
C     ROD
C
  210 CALL DROD
      GO TO 160
C
C     BAR
C
  220 CALL DBAR
      GO TO 160
C
C     TUBE
C
  230 TEMP = ECPT(5) - ECPT(6)
      A  = TEMP*ECPT(6)*PI
      FJ = .25*A*(TEMP**2 + ECPT(6)**2)
      C  = .5*ECPT(5)
      M  = 26
      DO 235 I = 1,18
      M = M - 1
  235 ECPT(M) = ECPT(M-1)
      GO TO 210
C
C     SHEAR
C
  240 CALL DSHEAR
      GO TO 160
C
C     TRMEM
C
  250 CALL DTRMEM (0)
      GO TO 160
C
C     TRIA1
C
  260 CALL DTRIA (1)
      GO TO 160
C
C     TRIA2
C
  270 CALL DTRIA (2)
      GO TO 160
C
C     TRIA3
C
  275 CALL DTRIA (3)
      GO TO 160
C
C     QDMEM
C
  280 CALL DQDMEM
      GO TO 160
C
C     QUAD1
C
  290 CALL DQUAD (1)
      GO TO 160
C
C     QUAD2
C
  300 CALL DQUAD (2)
      GO TO 160
C
C     QUAD4
C
  305 CALL DQUAD (4)
      GO TO 160
C
C     IHEX1,IHEX2,IHEX3
C
  310 CALL DIHEX (ITYPE-64)
      GO TO 160
C
C     QUADTS
C
  311 CONTINUE
      GO TO 160
C
C    TRIATS
C
  312 CONTINUE
      GO TO 160
  313 CALL DTSHLS
      GO TO 160
  314 CALL DTSHLD
      GO TO 160
  315 CALL DIS2D8
      GO TO 160
C
C     DUMMY ELEMENTS
C
  321 CALL DDUM1
      GO TO 160
  322 CALL DDUM2
      GO TO 160
  323 CALL DDUM3
      GO TO 160
  324 CALL DDUM4
      GO TO 160
  325 CALL DDUM5
      GO TO 160
  326 CALL DDUM6
      GO TO 160
  327 CALL DDUM7
      GO TO 160
  328 CALL DDUM8
      GO TO 160
  329 CALL DDUM9
      GO TO 160
C
C     CONE
C
  370 CALL DCONE
      GO TO 160
C
C     PRESSURE STIFFNESS ELEMENTS
C
  380 CALL DPSE2
      GO TO 160
  385 CALL DPSE3
      GO TO 160
  390 CALL DPSE4
      GO TO 160
C
C     AT STATEMENT NO. 500 WE HAVE HIT AN EOR ON THE ECPT FILE.  SEARCH
C     THE LINK VECTOR TO DETERMINE IF THERE ARE LINKS TO BE PROCESSED.
C
  500 LINK(LINCOR) = 1
      DO  510 I = 1,NLINKS
      IF (LINK(I) .EQ. 0) GO TO 520
  510 CONTINUE
      GO TO 525
C
C     SINCE AT LEAST ONE LINK HAS NOT BEEN PROCESSED THE ECPT FILE MUST
C     BE BACKSPACED.
C
  520 CALL BCKREC (ECPTDS)
      GO TO 150
C
C     CHECK NOGO FLAG. IF NOGO=1, SKIP BLDPK AND PROCESS ANOTHER RECORD
C     FROM THE GPCT TABLE
C
  525 IF (NOGO .EQ. 1) GO TO 10
C
C     AT THIS POINT BLDPK THE NUMBER OF ROWS IN CORE UNTO THE KGG FILE.
C
      IFILE = KGGD
      I1 = 0
  540 I2 = 0
      IBEG = I6X6K + I1*JMAX
      CALL BLDPK (2,IPR,IFILE,0,0)
  550 I2 = I2 + 1
      IF (I2 .GT. NGPCT) GO TO 570
      JJ = IGPCT + I2
      INDEX = IABS(IZ(JJ)) - 1
      LIM = 6
      IF (IZ(JJ) .LT. 0) LIM = 1
      JJJ = IPOINT + I2
      KKK = IBEG + IZ(JJJ) - 1
      I3  = 0
  560 I3  = I3 + 1
      IF (I3 .GT. LIM) GO TO 550
      INDEX = INDEX + 1
      KKK = KKK + 1
      DPWORD = DZ(KKK)
      IF (DPWORD .NE. 0.0D0) CALL ZBLPKI
      GO TO 560
  570 CALL BLDPKN (IFILE,0,MCBKGG)
      I1 = I1 + 1
      IF (I1 .LT. NROWSC) GO TO 540
C
C     TEST TO SEE IF THE LAST ROW IN CORE, LROWIC, = THE TOTAL NO. OF
C     ROWS TO BE COMPUTED = 6.  IF IT IS, WE ARE DONE.  IF NOT, THE
C     ECPTDS MUST BE BACKSPACED.
C
      IF (LROWIC .EQ. 6) GO TO 10
      CALL BCKREC (ECPTDS)
      FROWIC = FROWIC + NROWSC
      LROWIC = LROWIC + NROWSC
      GO TO 100
  700 IF (NOGO .EQ. 1) GO TO 10
C
C     HERE WE HAVE A PIVOT POINT WITH NO ELEMENTS CONNECTED, SO THAT
C     NULL COLUMNS MUST BE OUTPUT ON THE KGGD FILE.
C
      FILE = ECPTDS
      LIM  = 6
      IF (INPVT(1) .LT. 0) LIM = 1
      DO 710 I = 1,LIM
      CALL BLDPK  (2,IPR,KGGD,0,0)
  710 CALL BLDPKN (KGGD,0,MCBKGG)
      CALL FWDREC (*9020,ECPTDS)
      GO TO 10
C
C     CHECK NOGO FLAG. IF NOGO=1, TERMINATE EXECUTION
C
 1000 IF (NOGO .EQ. 1) CALL MESAGE (-61,0,0)
C
C     WRAP UP BEFORE RETURN
C
      CALL CLOSE (ECPTDS,CLSRW)
      CALL CLOSE (GPCT,CLSRW)
      CALL CLOSE (KGGD,CLSRW)
      MCBKGG(3) = MCBKGG(2)
      IF (MCBKGG(6) .EQ. 0) GO TO 9050
      CALL WRTTRL (MCBKGG)
      J = 26
      NE(J) = BEAM
      RETURN
C
C     ERROR RETURNS
C
 9020 CALL MESAGE (-2,FILE,NAME)
 9030 CALL MESAGE (-3,FILE,NAME)
 9040 CALL MESAGE (-7,FILE,NAME)
 9050 WRITE  (IOUTPT,9060) UFM
 9060 FORMAT (A23,' 2402, NULL DIFFERENTIAL STIFFNESS MATRIX ',
     1        'GENERATED IN SUBROUTINE DS1A.')
      CALL MESAGE (-61,0,0)
      RETURN
      END

      SUBROUTINE EXIO2
C
C     EXIO2 COPIES SUBSTRUCTURE ITEMS BETWEEN THE SOF AND AN EXTERNAL
C     TAPE USING FORTRAN FORMATTED IO.  THE TAPE COULD HAVE BEEN CREATED
C     OR COULD BE READ ON A DIFFERENT BRAND OF COMPUTER.
C
C
      LOGICAL         UNIVAC
      INTEGER         DRY      ,XBLK     ,UNAME    ,POS      ,
     1                UNIT     ,FORT     ,NUM(32)  ,SOFIN    ,
     2                SOFOUT   ,REWI     ,EQF
      CHARACTER       UFM*23   ,UWM*25
      COMMON /XMSSG / UFM      ,UWM
      COMMON /BLANK / DRY      ,XBLK     ,DEVICE(2),UNAME(2) ,
     1                FORMT(2) ,MODE(2)  ,POS(2)   ,DATYPE(2),
     2                NAMES(10),UNIT     ,UNIVAC   ,LBUF     ,
     3                IADD
      COMMON /SYSTEM/ SYSBUF   ,NOUT     ,X1(36)   ,NBPC     ,
     1                NBPW     ,NCPW
      DATA    FORT  , SOFIN    ,SOFOUT   ,REWI     ,EQF      /
     1        4HFORT, 4HSOFI   ,4HSOFO   ,4HREWI   ,4HEOF    /
      DATA    NUM   /
     1        2H1   , 2H2      ,2H3      ,2H4      ,2H5      ,
     2        2H6   , 2H7      ,2H8      ,2H9      ,2H10     ,
     3        2H11  , 2H12     ,2H13     ,2H14     ,2H15     ,
     4        2H16  , 2H17     ,2H18     ,2H19     ,2H20     ,
     5        2H21  , 2H22     ,2H23     ,2H24     ,2H25     ,
     6        2H26  , 2H27     ,2H28     ,2H29     ,2H30     ,
     7        2H31  , 2H32     /
C
C     INITIALIZE
C
      NOGO = 0
C
C     DECODE FORTRAN UNIT
C
      IF (UNAME(1) .NE. FORT) GO TO 20
      DO 10 I = 1,32
      UNIT = I
      IF (UNAME(2) .EQ. NUM(UNIT)) GO TO 30
   10 CONTINUE
   20 NOGO = 1
      CALL PAGE2 (-2)
      WRITE (NOUT,6356) UWM,UNAME
C
C     DECODE MODE OF OPERATION
C
   30 IOMODE = 0
      IF (MODE(1) .EQ. SOFOUT) IOMODE = 1
      IF (MODE(1) .EQ. SOFIN ) IOMODE = 2
      IF (IOMODE  .GT.      0) GO TO 40
      NOGO = 1
      CALL PAGE2 (-2)
      WRITE (NOUT,6338) UWM,MODE
C
C     IF ERRORS THEN QUIT
C
   40 IF (NOGO .EQ. 0) GO TO 50
      DRY = -2
      GO TO 300
C
C     SET POSITION AND UNIVAC FLAGS
C
   50 UNIVAC = .TRUE.
      IF (XBLK .LE. 0) XBLK = 3960
      XBLK = XBLK - MOD(XBLK,132)
      LBUF = XBLK/NCPW
      IF (MOD(XBLK,NCPW) .NE. 0) LBUF = LBUF + 1
      IADD = 2
      IF (POS(1) .EQ. REWI) IADD = 1
      IF (POS(1) .EQ.  EQF) IADD = 3
C
C     BRANCH ON MODE OF OPERATION
C
      GO TO (100,200), IOMODE
C
C     SOFOUT
C
  100 CALL EXO2
      GO TO 300
C
C     SOFIN
C
  200 CALL EXI2
C
C     NORMAL MODULE COMPLETION
C
  300 RETURN
C
C     MESSAGE TEXT
C
 6338 FORMAT (A25,' 6338, ',2A4,' IS AN INVALID MODE PARAMETER FOR ',
     1       'MODULE EXIO')
 6356 FORMAT (A25,' 6356, ',2A4,' IS AN INVALID UNIT FOR MODULE EXIO,',
     1       ' EXTERNAL FORMAT')
      END

      SUBROUTINE INCORE(A,N,B,CX,IX)
C
C     IN-CORE DECOMPOSITION OF SQUARE, COMPLEX, NXN MATRIX,A.
C     AX = B.
C     CX = X
C     IX = NUMBER OF B VECTORS SPECIFIED.
C
      COMPLEX A(N,N), B(IX,N), CX(IX,N), CMAX, SCRCH
      COMPLEX T1,T2,T3
      COMPLEX CSUM
C
C
      IF(N.EQ.2) GO TO 500
      IF(N.EQ.1) GO TO 600
      NM1 = N-1
C
C     PIVOT MAYBE.
C
      DO 150 J=1,NM1
      CMAX = A(J,J)
      JP1 = J + 1
      JMAX = J
      DO 100 JJ= JP1,N
      IF(CABS(A(J,JJ)).LE.CABS(CMAX)) GO TO 100
      CMAX = A(J,JJ)
      IROW = JJ
      JMAX = JJ
  100 CONTINUE
C
C     IROW = ROW WITH LARGEST ELEMENT IN COLUMN J.
C     MOVE PIVOT ROW TO TOP OF ELIMINATION
C
      AMAX = CABS(CMAX)
      IF(AMAX.EQ.0.) GO TO 150
      IF(JMAX.EQ.J) GO TO 120
      DO 110 JJ= J,N
      SCRCH = A(JJ,J)
      A(JJ,J) = A(JJ,IROW)
      A(JJ,IROW) = SCRCH
  110 CONTINUE
C
C     INTERCHANGE B VECTOR
C
      DO 115 JJ = 1,IX
      SCRCH = B(JJ,J)
      B(JJ,J) = B(JJ,IROW)
      B(JJ,IROW) = SCRCH
  115 CONTINUE
C
C     ELIMINATE COLUMN
C
  120 CONTINUE
      A(J,J) = (1.0,0.0) / A(J,J)
      T1 = A(J,J)
      DO 140 I=JP1,N
      T2 = A(I,J)
      IF(CABS(T2).LT.(1.0E-19)) GO TO 140
      T2 = -T2*T1
      A(I,J) = T2
      DO 130 L = JP1,N
      T3 = A(J,L)
      IF(CABS(T3).LT.(1.0E-19)) GO TO 130
      A(I,L) = A(I,L) + T3*T2
  130 CONTINUE
  140 CONTINUE
C
C     HANDLE B ELIMINATION.
C
      DO 141 JJ = 1,IX
      B(JJ,J) = B(JJ,J) * T1
  141 CONTINUE
      DO 145 JJ = 1,IX
      DO 145 K=JP1,N
      B(JJ,K) = B(JJ,K) - B(JJ,J)*A(J,K)
  145 CONTINUE
  150 CONTINUE
C
C     BACKWARD PASS.
C
      DO 185 JJ = 1,IX
      CX(JJ,N) = B(JJ,N)/A(N,N)
  185 CONTINUE
      DO 210 JJ = 1,IX
      I = N
  190 CONTINUE
      CSUM = (0.,0.)
      K = I-1
      DO 200 J=I,N
      CSUM = CSUM + CX(JJ,J)*A(J,K)
  200 CONTINUE
      CX(JJ, K)    = B(JJ, K)    + CSUM
      IF(I.LE.2) GO TO 210
      I = I-1
      GO TO 190
  210 CONTINUE
      RETURN
  500 CONTINUE
      DO 510 I = 1,IX
      CX(I ,2) = (B(I ,2)-(B(I ,1)*A(1,2)/A(1,1)))/(A(2,2)-(A(2,1)
     +  *A(1,2)/A(1,1)))
      CX(I ,1) = B(I ,1)/A(1,1)-A(2,1)*CX(I ,2)/A(1,1)
  510 CONTINUE
      RETURN
  600 CONTINUE
      DO 610 I=1,IX
      CX(I ,1) = B(I ,1)/A(1,1)
  610 CONTINUE
      RETURN
      END

      SUBROUTINE TIPE (X,Y,XYD,CHR,N,OPT)
C
C     (X,Y) = STARTING OR ENDING POINT OF THE LINE TO BE TYPED (ALWAYS
C             LEFT-TO-RIGHT OR TOP-TO-BOTTOM.
C     XYD   = +/-1 IF X = STARTING OR ENDING POINT OF THE LINE.
C           = +/-2 IF Y = STARTING OR ENDING POINT OF THE LINE.
C     CHR   = CHARACTERS TO BE TYPED.
C     N     = NUMBER OF CHARACTERS.
C     OPT   = -1 TO INITIATE  THE TYPING MODE.
C           = +1 TO TERMINATE THE TYPING MODE.
C           =  0 TO TYPE A LINE.
C
      INTEGER         XYD,CHR(1),OPT,PLOTER,CHAR,C(80),BLANK,LSTCHR,
     1                CHARX,D
      REAL            XY(2,2)
      COMMON /PLTDAT/ MODEL,PLOTER,SKPPLT(18),SKPA(3),CNTCHR(2)
      COMMON /CHAR94/ CHAR(60)
      DATA    BLANK , LSTCHR / 48,47 /
C
      IF (OPT .NE. 0)  GO TO 150
C
C     OPT = 0.
C
      D = MAX0(IABS(XYD),1)
      S = CNTCHR(D)
      IF (XYD.EQ.-1 .OR. XYD.EQ.2) S = -S
      XY(1,1) = X
      XY(2,1) = Y
      XY(1,2) = XY(1,1)
      XY(2,2) = XY(2,1)
C
C     PRINT A MAXIMUM OF 80 CHARACTERS AT A TIME.
C
      DO 130 J = 1,N,80
      IF (XYD .LT. 0) GO TO 105
      L1 = J
      L2 = L1 + 79
      IF (L2 .GT. N) L2 = N
      GO TO 106
  105 L2 = N  - J + 1
      L1 = L2 - 79
      IF (L1 .LE. 0) L1 = 1
C
  106 NC = 0
      DO 120 L = L1,L2
      CHARX = CHR(L)
      DO 110 I = 1,LSTCHR
      IF (CHARX .EQ. CHAR(I)) GO TO 111
  110 CONTINUE
      I  = BLANK
  111 NC = NC + 1
      C(NC) = I
  120 CONTINUE
C
C     TYPE THE -NC- CHARACTERS JUST PROCESSED.
C
      XY(D,2) = XY(D,1) + S*FLOAT(L1-1)
      CALL TYPE10 (XY(1,2),XY(2,2),XYD,C,NC,0)
      GO TO 130
  130 CONTINUE
      GO TO 200
C
C     OPT = +/-1
C
  150 CALL TYPE10 (0,0,0,0,0,OPT)
      GO TO 200
  200 RETURN
      END

      SUBROUTINE CDETM (METHOD,EED,MDD,BDD,KDD,LAMA,PHID,OCEIGS,NFOUND,
     1                  SCR1,SCR2,SCR3,SCR4,SCR5,SCR6,SCR7,SCR8)
C
C     SOLVES COMPLEX EIGENVALUE PROBLEM BY DETERMINANT METHOD
C
      INTEGER          EED,BDD,PHID,OCEIGS,SCR1,SCR2,SCR3,SCR4,SCR5,
     1                 SCR6,SCR7,SYSBUF,IZ(1),FA,FL,FU,SR1,SR2,SR3,POWR,
     2                 IPOLE(2),EIGC(2),IHEAD(50),POIN,DRETN,IPS(3),
     3                 IPDET(3),FILE,NAME(2),SCR8,OTPE,ILUSP(2),
     4                 ISCR2(7),ISP(2)
      REAL             LU
      DOUBLE PRECISION ZD(1),D1,D2,D3,D4,D5,D6,MINDA,RL,PR,DT1,PI,DR,DI,
     1                 PSR(3),PSI(3),DSR(3),DSI(3),PKR(3),PKI(3),
     2                 DETR(3),DETI(3),DT2,DT3,D7,D8,PTR,PTI,D9,D10,
     3                 HK1R,HK1I,HKR,HKI,LAMDKR,LAMDKI,DELTKR,DELTKI,
     4                 GKR,GKI,ROOTR,ROOTI,LAMK1R,LAMK1I,HKP1R,HKP1I,
     5                 H1BAR,H2BAR,H3BAR,TEST,AMCB(2),BMCB(2),CMCB(2),
     6                 DPI,D2PI,RADDEG,DEGRAD,D4PISQ,
     7                 DDISTX,DDIST2,ZZ,ZDKM1,ZDK
      COMMON /MACHIN/  MACH
      COMMON /SYSTEM/  KSYSTM(65)
      COMMON /ZZZZZZ/  Z(1)
      COMMON /CONDAD/  DPI,D2PI,RADDEG,DEGRAD,D4PISQ
      COMMON /OUTPUT/  HEAD(1)
      COMMON /MSGX  /  NMSGX,MAXGX
      COMMON /SADDX /  NOMAT,LCADD,MCBA(12),MCBB(12),MCBC(12),MCBD(12),
     1                 MCBE(12),MC(7)
      COMMON /CDCMPX/  FA(7),FL(7),FU(7),SR1,SR2,SR3,DR,DI,POWR,NX,
     1                 MINDA,IB
      EQUIVALENCE      (KSYSTM(1),SYSBUF), (KSYSTM(2),OTPE),
     1                 (AMCB(1),MCBA(9)), (BMCB(1),MCBB(9)),
     2                 (CMCB(1),MCBC(9)), (Z(1),IZ(1),ZD(1))
      DATA    IPOLE ,  EIGC,  IHEAD,        POIN,   NAME            /
     1        257,4 ,  207,2, 0,1009,1,47*0, 4HPOIN, 4HCDET, 4HM     /
      DATA    NIT,IM1, SIGN, NUMINT, IZ2,IZ3, IZ4,IZ5, IZ6,IZ7, IZ8 /
     1        20, 1,   -1.0, 4,      2,  3,   4,  5,   6,  7,   8   /
C
C     DEFINITION OF VARIABLES
C
C     METHOD   SELECT SET OF POLES AND EIGC CARDS
C     EED      EIGENVALUE EXTRACTION DATA BLOCK
C     MDD      MASS MATRIX      - DIRECT OR MODAL
C     BDD      DAMPING MATRIX   - DIRECT OR MODAL
C     KDD      STIFFNESS MATRIX - DIRECT OR MODAL
C     LAMA     EIGENVALUE FILE
C     PHID     EIGENVECTOR FILE
C     OEIGS    EIGENVALUE SUMMARY FILE
C     NFOUND   TOTAL NUMBER OF EIGENVALUES FOUND IN ALL REGIONS
C     SCR      SCRATCHES
C     IPOLE    LOCATE WORDS FOR POLES
C     EIGC     LOCATE WORDS FOR EIGC CARDS
C     EPSI     CONVERGENCE CRITERION
C     IBUF     POINTER TO BUFFER
C     NPOLE    NUMBER OF POLES TO BE USED
C     IPOLES   POINTER TO START OF POLES - 4 WORDS PER POLE ID,X,Y,MUL
C     NREGN    NUMBER OF REGIONS
C     IREG1    POINTER TO WORDS DESCRIBING REGIONS
C     INORM    NORMALIZATION METHOD - 1 = MAX,  0 = POINT
C     ISIL     POINTER FOR NORM IF  NORM = 0
C     NE       ESTIMATED NUMBER OF ROOTS IN REGION
C     ND       DESIRED NUMBER OF ROOTS
C     LREGN    LENGTH OF BLOCK DESCRIBING REGION
C     NPASS    NUMBER OF PASSES THROUGH STARTING POINTS
C     NCHANG   NUMBER OF CHANGES OF CONVERGENCE CRITERIA
C     NMOVES   NUMBER OF STARTING POINT MOVES
C     NDCOMP   NUMBER OF DECOMPOSITIONS
C     NFAIL    NUMBER OF FAILURES TO INTERATE TO A ROOT
C     NOUTSD   NUMBER OF PREDICTIONS OUTSIDE REGION
C     ITERM    REASON FOR TERMINATION  0 - FOUND REQUESTED NUMBER
C                                      1 - NO MORE IN REGIONS
C     IRGP     POINTER FOR CURRENT REGION
C     ICNT     NUMBER OF INTERATIONS
C     NIT      MAXIMUM NUMBER OF INTERATIONS/ROOT
C     NUMINT   MAXIMUM NUMBER OF CONVERGENCE  CHANGES
C     NROW     ORDER OF PROBLEM
C     ICMPX    SWITCH IF ROOTS FOUND ARE COMPLEX CONJUGATE -0  NOT-1
C     ISPNT    POINTER TO CURRENT 3 STARTING POINTS
C     PS       SORTED 3 STARTING POINTS
C     DS       SORTED 3 DET OF STARTING POINTS
C     IPS      POWERS OF STARTING POINTS
C     P        TRIAL EIGENVALUE
C     D        SCALED SWEPT DETERMINANT AT P
C     IFPASS   FLAG TO SIGNAL ROOT FROUND ON PASS 1, 0 IF NOT
C     IPOINT   NUMBER OF STARTING POINTS USED IN CURRENT REGION
C     ILUSP    INDEX TO LAST USED STARTING POINT (1ST OF 3) IN EACH
C              SUBRGN
C     NSBRGN   NUMBER OF SUBREGIONS IN PROBLEM THIS REGION
C     NSBDON   FLAG MARKING COMPLETED SUBREGION
C     ISP      POINTS NEAREST AND NEXT NEAREST THE ORIGIN
C
C     STRUCTURE OF REGION
C
C     A1,B1,A2,B2,XL,NE,ND,NF,POINTER TO NEXT REGION (ZERO IF LAST),RL,
C     X  (12  WORDS)
C
C     STARTING POINTS  8NE + 8 WORDS  - D.P. COMPLEX
C     DETERMINANTS     8NE + 8 WORDS    D.P. COMPLEX
C     SCALE FACTORS    4NE + 4 WORDS    2 INTEGERS PER STARTING POINT
C
C     ROOTS   4ND WORDS                 D.P. COMPLEX
C
C
C     DEFINE EPSI (CONVERGENCE CRITERION)
C
      EPSI = 1.0E-16
      IF (MACH.EQ.5 .OR. MACH.EQ.21) EPSI = 1.0E-12
C
      LC   = KORSZ(Z)
      IBUF = LC - SYSBUF - 1
      LC   = (IBUF/2)*2 - 1
      NOSING = 1
      CALL SSWTCH (7,IPRT)
      ISING = 0
      FA(1) = KDD
      CALL RDTRL (FA(1))
      IF (FA(1) .LE. 0) GO TO 1
      IDD = KDD
      GO TO 9
    1 FA(1) = MDD
      CALL RDTRL (FA(1))
      IF (FA(1) .LE. 0) GO TO 2
      IDD = MDD
      GO TO 9
    2 FA(1) = BDD
      CALL RDTRL (FA(1))
      IF (FA(1) .LE. 0) GO TO 990
      IDD   = BDD
    9 FA(1) =-SCR2
      FA(5) = 4
      FL(1) = IDD
      CALL RDTRL (FL(1))
      FL(4) = 4
      FL(5) = 4
      FU(1) = IDD
      CALL RDTRL (FU(1))
      FU(4) = 5
      FU(5) = 4
      SR1   = SCR3
      SR2   = SCR4
      SR3   = SCR5
      FL(1) = SCR6
      FU(1) = SCR7
      DO 10 I = 1,7
      MCBA(I) = 0
      MCBB(I) = 0
      MCBC(I) = 0
      MC(I)   = 0
   10 CONTINUE
      MCBA(1) = KDD
      MCBB(1) = BDD
      MCBC(1) = MDD
      CALL RDTRL (MCBA(1))
      CALL RDTRL (MCBB(1))
      CALL RDTRL (MCBC(1))
C
C     MUST HAVE  B OR M MATRICES
C
      IF (MCBB(1) .LT. 0) MCBB(1) = 0
      IF (MCBC(1) .LT. 0) MCBC(1) = 0
      IF (MCBB(1)+MCBC(1) .EQ. 0) GO TO 990
      NROW  = MAX0(MCBA(3),MCBB(3),MCBC(3))
      ICMPX = 0
      IF (MCBA(5).GT.2 .OR. MCBB(5).GT.2 .OR. MCBC(5).GT.2) ICMPX = 1
      AMCB(1) = 1.0D0
      AMCB(2) = 0.D0
      MC(2)   = MCBA(2)
      MC(3)   = MCBA(3)
      MC(4)   = MCBA(4)
      MC(5)   = 4
      MCBA(8) = 4
      MCBC(8) = 4
      MCBB(8) = 4
      NOMAT   = 3
      MC(1)   = SCR2
      NDESRD  = 0
C
C     PICK UP AND STORE ANY POLES
C
      FILE = EED
      CALL PRELOC (*950,IZ(IBUF),EED)
      NPOLE = 0
      CALL LOCATE (*40,IZ(IBUF),IPOLE(1),IFLAG)
C
C     FOUND POLE CARDS
C
   20 LC = LC - 4
   30 CALL READ (*970,*40,EED,IZ(LC),4,0,IFLAG)
      IF (IZ(LC) .NE. METHOD) GO TO 30
      NPOLE = NPOLE + 1
      GO TO 20
   40 IPOLES = LC + 4
C
C     STORE REGIONS
C
      NREGN = 0
      CALL LOCATE (*990,IZ(IBUF),EIGC(1),IFLAG)
   50 CALL READ (*970,*990,EED,IZ(1),10,0,IFLAG)
      IF (METHOD.EQ.IZ(1) .OR. METHOD.EQ.-1) GO TO 70
C
C     SKIP REMAINDER OF EIGC CARD
C
   60 CALL READ (*970,*990,EED,IZ(1),7,0,IFLAG)
      IF (IZ(IZ6) .NE. -1) GO TO 60
      GO TO 50
C
C     EIGC CARD FOUND - ALLOCATE CORE + BUILD UP REGIONS
C
   70 INORM = 0
      IF (IZ(IZ4) .NE. POIN) INORM = 1
      ISIL = IZ(IZ6)
      IF (Z(IZ8) .NE. 0.0) EPSI = Z(IZ8)
C
C     PROCESS EACH REGION DEFINITION
C
   80 CALL READ (*970,*980,EED,Z(1),7,0,IFLAG)
      IF (IZ(IZ7) .LT. 0) GO TO 130
      NREGN = NREGN + 1
      ALPH1 = Z(  1)
      W1    = Z(IZ2)
      ALPH2 = Z(IZ3)
      W2    = Z(IZ4)
      XL    = Z(IZ5)
      NE    = IZ(IZ6)
      ND    = IZ(IZ7)
      IF (ND .EQ. 0) ND = 3*NE
      LREGN = 20*NE + 4*ND + 32
      NDESRD = NDESRD + ND
      IF (NREGN .EQ.1) GO TO 90
      IZ(LC+8) = LC - LREGN
   90 LC = LC - LREGN
      IF (LC    .LE. 0) GO TO 1000
      IF (NREGN .NE. 1) GO TO 100
      IREG1 = LC
C
C     ZERO REGION
C
  100 K = LC - 1
      DO 110 I = 1,LREGN
      K = K + 1
      IF (I .EQ. 9) GO TO 110
      IZ(K) = 0
  110 CONTINUE
C
C     STORE CONSTANTS
      Z(LC  ) = ALPH1
      Z(LC+1) = W1
      Z(LC+2) = ALPH2
      Z(LC+3) = W2
      Z(LC+4) = XL
      IZ(LC+5)= NE
      IZ(LC+6)= ND
C
C     DISTRIBUTE  STARTING POINTS
C
      D1 = ALPH2 - ALPH1
      D2 = W2 - W1
      RL = DSQRT(D1*D1+D2*D2)
      Z(LC+9) = RL
      D1 = D1/RL
      D2 = D2/RL
      J  = (LC+1)/2 + 6
      D3 = RL/FLOAT(4*NE +4)
      ZD(J  ) = D1*D3 + ALPH1
      ZD(J+1) = D2*D3 + W1
      K  = 2*NE + 1
      D3 = RL/FLOAT(K+1)
      D1 = D1*D3
      D2 = D2*D3
      DO 120 I = 1,K
      J  = J + 2
      ZD(J  ) = ZD(J-2) + D1
      ZD(J+1) = ZD(J-1) + D2
  120 CONTINUE
      GO TO 80
  130 LCADD = LC - 1
      NX = LCADD
      IZ(LC+8) = 0
      CALL CLOSE (EED,1)
      IF (LC-4*NROW .LE. 0) GO TO 1000
C
C     INITIALIZE CUMULATIVE POINTERS
      IFAIL  = 0
      NFOUND = 0
      NPASS  =-1
      NCHANG = 0
      NMOVES = 0
      NDCOMP = 0
      NFAIL  = 0
      NOUTSD = 0
      ITERM  = 1
      IFPASS = 1
C
C     RETURN HERE TO SEARCH ALL REGIONS AGAIN
C
  140 NPASS = NPASS + 1
      IF (IFPASS .EQ. 0) GO TO 690
      IFPASS = 0
      IRGP   = IREG1
C
C     FIND REGION WHICH LACKS ROOTS
C
      DO 160 I = 1,NREGN
      IF (IZ(IRGP+6) .GT. IZ(IRGP+7)) GO TO 170
      IRGP = IZ(IRGP+8)
  160 CONTINUE
C
C     ALL REGIONS HAVE ENOUGH ROOTS - EXIT
C
      GO TO 710
C
C     PICK UP REGION POINTERS AND PARAMETERS
C
  170 ALPH1 =  Z(IRGP  )
      W1    =  Z(IRGP+1)
      ALPH2 =  Z(IRGP+2)
      W2    =  Z(IRGP+3)
      XL    =  Z(IRGP+4)
      NE    = IZ(IRGP+5)
      ND    = IZ(IRGP+6)
      NF    = IZ(IRGP+7)
      RL    = Z(IRGP+9)
      XVR   = (ALPH2-ALPH1)/RL
      YVR   = (W2-W1)/RL
      IPOINT= 0
      ISPNT = (IRGP+1)/2 + 4
C
C     FIND POINTS CLOSEST TO AND NEXT CLOSEST TO ORIGIN THUS DIVIDING
C     REGION INTO TWO SUBREGIONS
C
      ISPT1 = (IRGP+13)/2
      LSPT  =  ISPT1 + 2*(2*NE+2) - 2
      DDISTX= 0.
      NXORG = 0
      NRORG = ISPT1
      DDIST2= ZD(ISPT1)*ZD(ISPT1) + ZD(ISPT1+1)*ZD(ISPT1+1)
      ISPT2 = ISPT1 + 2
      DO 173 I = ISPT2,LSPT,2
      ZZ = ZD(I)*ZD(I) + ZD(I+1)*ZD(I+1)
      IF (ZZ .GT. DDIST2) GO TO 175
      NXORG  = NRORG
      NRORG  = I
      DDISTX = DDIST2
      DDIST2 = ZZ
  173 CONTINUE
  175 IF (ZZ .GT. DDISTX) GO TO 178
  177 NXORG  = I
      DDISTX = ZZ
      GO TO 179
  178 IF (NXORG) 177,179,177
C
C     CALCULATE THE NUMBER OR SUBREGIONS, NSBRGN. THERE MUST BE AT LEAST
C     3 POINTS EACH SIDE OF BISECTOR IN ORDER TO HAVE 2 SUBREGIONS.
C          ISPT2+2 .LE. (NRORG+NXORG)/2 .LE. LSPT-4
C
  179 CONTINUE
      IF (2*(ISPT2+2).LE.NRORG+NXORG .AND. NRORG+NXORG.LE.(LSPT-4)*2)
     1    GO TO 185
C
C     ONLY ONE SUBREGION
C     FIND FIRST UNEVALUATED POINT
C
      NSBRGN = 1
      K = IRGP + 16*NE + 32
      L = 2*NE
      DO 180 J = 1,L
      IF (IZ(K) .EQ. 0) GO TO 196
      K = K + 2
      IPOINT = IPOINT + 1
      ISPNT  = ISPNT  + 2
  180 CONTINUE
C
C     ALL TRIED  GO TO BEGINNING
C
      IPOINT = 0
      ISPNT  = (IRGP+1)/2 + 4
      GO TO 196
C
C     TWO SUBREGIONS EXIST. DETERMINE STARTING POINTS FOR EACH
C
  185 NSBRGN = 2
      NSBDON = 0
      ISP(1) = NRORG
      IF (NRORG .LT. NXORG) ISP(1) = NXORG
      ISP(2) = NRORG + NXORG - ISP(1)
      KREG   = 2
      ILUSP(1) = ISP(1)
      ILUSP(2) = ISP(2) - 2
      GO TO 192
C
C     RETURN HERE TO GET NEW STARTING POINT (OR NEW REGION IF NECESSARY)
C     DETINES  ISPNT
C
  190 IF (NSBRGN .EQ. 1) GO TO 196
      IF (NSBDON-1) 192,195,1945
C
C     CHANGE SUBREGIONS
C
  192 KREG = 3 - KREG
      GO TO (194,195), KREG
C
C     PROCESS FIRST SUBREGION
C
  194 ISPNT = ILUSP(1)
      LS    = ISP  (2)
      ALOC1 = ZD(LS  )
      WLOC1 = ZD(LS+1)
      ILUSP(1) = ILUSP(1) + 2
      IF (ISPNT+4 .EQ. LSPT) GO TO 1942
      PR = .45*ZD(ISPNT+4) + .55*ZD(ISPNT+6) - ALOC1
      PI = .45*ZD(ISPNT+5) + .55*ZD(ISPNT+7) - WLOC1
 1940 IPOINT = (ISPNT -ISPT1)/2 + 1
      GO TO 220
C
C     PROCESS LAST SET OF STARTING IN FIRST SUBREGION
C
 1942 NSBDON = NSBDON + 1
      PR = .45*ZD(ISPNT+4) + .55*ALPH1 - ALOC1
      PI = .45*ZD(ISPNT+5) + .55*W1    - WLOC1
      GO TO 1940
C
C     SUBREGION 2 IS COMPLETE.  IS SUBREGION 1 FINISHED AS WELL
C
 1945 IF (NSBDON .EQ. 3) GO TO 680
      GO TO 194
C
C     PROCESS SUBREGION 2
C
  195 ISPNT = ILUSP(2) - 2
      ILUSP(2) = ILUSP(2) - 2
      LS    = ISP(1)
      ALOC1 = ZD(LS)
      WLOC1 = ZD(LS+1)
      IF (ISPNT .EQ. ISPT1) GO TO 1952
      PR = -(.45*ZD(ISPNT-2) + .55*ZD(ISPNT  )) + ALOC1
      PI = -(.45*ZD(ISPNT-1) + .55*ZD(ISPNT+1)) + WLOC1
      GO TO 1940
C
C     LAST SET OF STARTING POINTS IN SUBREGION2 TO PROCESS
C
 1952 NSBDON = NSBDON + 2
      PR = -(.45*ZD(ISPT1  ) + .55*ZD(ISPNT  )) + ALOC1
      PI = -(.45*ZD(ISPT1+1) + .55*ZD(ISPNT+1)) + WLOC1
      GO TO 1940
C
C     ONLY ONE SUBREGION PROCESS FROM END TO END
C
  196 IPOINT = IPOINT + 1
      ISPNT  = ISPNT+2
      IF (IPOINT .GT. 2*NE) GO TO 680
C
C     FIND OUT IF ANY DETERMINT EVALUATIONS ARE NECESSARY
C
C     COMPUTE LOCAL SEARCH REGION DESCRITIONS
C
      ALOC1 = ALPH1
      WLOC1 = W1
      IF (IPOINT .EQ. 2*NE) GO TO 210
      PR = .45*ZD(ISPNT+4) + .55*ZD(ISPNT+6) - ALOC1
      PI = .45*ZD(ISPNT+5) + .55*ZD(ISPNT+7) - WLOC1
      GO TO 220
  210 PR = ALPH2 - ALOC1
      PI = W2 - WLOC1
  220 RLL= DSQRT(PR*PR+PI*PI)
      K  = IRGP + 16*NE + 24 + 2*IPOINT
      I  = 1
      ISING = 0
  230 K  = K + 2
      IF (IZ(K) .NE. 0) GO TO 250
C
C     EVALUATE DETERMINANT
C
      J  = ISPNT + 2*I - 2
      PR = ZD(J  )
      PI = ZD(J+1)
      ASSIGN 240 TO DRETN
      GO TO 810
  240 IZ(K  ) = 1
      IZ(K+1) = POWR
      M = 4*NE + 2 + ISPNT + 2*I
      ZD(M  ) = DR
      ZD(M+1) = DI
  250 I = I + 1
      IF (I .LE. 3) GO TO 230
      IF (ISING.EQ.3 .AND. NPASS.EQ.0) GO TO 701
C
C     SORT STARTING POINTS BY MAGNITUDE OF DET
C
  260 CALL KLOCK (ITIME1)
      K = ISPNT + 4*NE + 4
      L = IRGP + 16*NE + 26 + 2*IPOINT
      CALL CDETM2 (ZD(ISPNT),ZD(K),IZ(L),PSR(1),PSI(1),DSR(1),DSI(1),
     1             IPS(1))
C
C     LOAD STARTING POINTS INTO TRAIL EIGENVALUES
C
      DO 270 I = 1,3
      PKR(I)  = PSR(I)
      PKI(I)  = PSI(I)
      DETR(I) = DSR(I)
      DETI(I) = DSI(I)
      IPDET(I)= IPS(I)
  270 CONTINUE
      DT2 = 1.0D38
C
C     START INTERATION LOOP
C
      ICNT = 1
  280 HK1R = PKR(2) - PKR(1)
      HK1I = PKI(2) - PKI(1)
      HKR  = PKR(3) - PKR(2)
      HKI  = PKI(3) - PKI(2)
      IF (HKR.EQ.0.0D0 .AND. HKI.EQ.0.0D0) GO TO 550
      D1     = HK1R*HK1R + HK1I*HK1I
      LAMDKR = (HKR*HK1R + HKI*HK1I)/D1
      LAMDKI = (HKI*HK1R - HKR*HK1I)/D1
      DELTKR = 1.0D0 + LAMDKR
      DELTKI = LAMDKI
C
C     COMPUTE GK
C
      D1 = LAMDKR*LAMDKR - LAMDKI*LAMDKI
      D2 = 2.0*LAMDKR*LAMDKI
      D3 = D1*DETR(1) - D2*DETI(1)
      D4 = D2*DETR(1) + D1*DETI(1)
      D1 = DELTKR*DELTKR - DELTKI*DELTKI
      D2 = 2.0*DELTKR*DELTKI
      D5 =-D1*DETR(2) + D2*DETI(2)
      D6 =-D2*DETR(2) - D1*DETI(2)
      CALL CSUMM (D3,D4,IPDET(1),D5,D6,IPDET(2),D1,D2,ID1)
      D3 = LAMDKR + DELTKR
      D4 = LAMDKI + DELTKI
      D5 = D3*DETR(3) - D4*DETI(3)
      D6 = D4*DETR(3) + D3*DETI(3)
      CALL CSUMM (D1,D2,ID1,D5,D6,IPDET(3),GKR,GKI,IGK)
C
C     COMPUTE TERM UNDER RADICAL IN EQ. 11
C
      D1 = DETR(1)*LAMDKR - DETI(1)*LAMDKI
      D2 = DETI(1)*LAMDKR + DETR(1)*LAMDKI
      D3 =-DETR(2)*DELTKR + DETI(2)*DELTKI
      D4 =-DETI(2)*DELTKR - DETR(2)*DELTKI
      CALL CSUMM (D1,D2,IPDET(1),D3,D4,IPDET(2),D5,D6,ID1)
      CALL CSUMM (D5,D6,ID1,DETR(3),DETI(3),IPDET(3),D1,D2,ID2)
      D3 = DELTKR*LAMDKR - DELTKI *LAMDKI
      D4 = DELTKI*LAMDKR + DELTKR *LAMDKI
      D5 = D1*D3 - D2*D4
      D6 = D2*D3 + D1*D4
      D1 =-4.0*(DETR(3)*D5 - DETI(3)*D6)
      D2 =-4.0*(DETI(3)*D5 + DETR(3)*D6)
C
C     COMPUTE  GK*GK
C
      D3 = GKR*GKR - GKI*GKI
      D4 = 2.0*GKR*GKI
      CALL CSUMM  (D3,D4,2*IGK,D1,D2,IPDET(3)+ID2,D5,D6,ID1)
      CALL CSQRTN (D5,D6,ID1,ROOTR,ROOTI,IROOT)
      CALL CSUMM  (GKR,GKI,IGK,ROOTR,ROOTI,IROOT,D9,D10,ID3)
      CALL CSUMM  (GKR,GKI,IGK,-ROOTR,-ROOTI,IROOT,D7,D8,ID4)
      IF (ICNT .EQ. 1) GO TO 290
      D1  = D9
      D2  = D10
      ID1 = ID3
      D5  = D9*D9 + D10*D10
      D6  = D7*D7 + D8*D8
      IF (D5 .GE. D6) GO TO 310
      D1  = D7
      D2  = D8
      ID1 = ID4
      GO TO 310
C
C     COMPUTE  NUMERATOR  EQ. 11
C
  290 D1 = D9
      D2 = D10
      ID1= ID3
      M  = 2
      GO TO 310
  300 D1 = D7
      D2 = D8
      ID1= ID4
      M  = 1
  310 D3 =-2.0*(DETR(3)*DELTKR - DETI(3)*DELTKI)
      D4 =-2.0*(DETI(3)*DELTKR + DETR(3)*DELTKI)
      D5 = D1*D1 + D2*D2
      D6 = 10.0**(IPDET(3) - ID1)
      LAMK1R = D6*(D3*D1 + D4*D2)/D5
      LAMK1I = D6*(D4*D1 - D3*D2)/D5
      HKP1R  = LAMK1R*HKR - LAMK1I*HKI
      HKP1I  = LAMK1I*HKR + LAMK1R*HKI
      PR = PKR(3) + HKP1R
      PI = PKI(3) + HKP1I
      IF (ICNT .NE. 1) GO TO 370
      DT3 = 0.0D0
      DO 330 I = 1,3
      DT3 = DT3+DSQRT((PKR(I)-PR)**2 + (PKI(I)-PI)**2)
  330 CONTINUE
      IF (DT3 .GT. DT2) GO TO 340
      PTR = PR
      PTI = PI
      DT2 = DT3
  340 IF (M .EQ. 2) GO TO 300
      PR  = PTR
      PI  = PTI
C
C     DO RANGE CHECKS
C
C
C     COMPUTE U VECTOR
C
  370 XU = PR - ALPH1
      YU = PI - W1
      LU = SQRT(XU*XU + YU*YU)
      IF (LU .EQ. 0.0) GO TO 380
      XU = XU/LU
      YU = YU/LU
      X  = LU*(XU*XVR + YU*YVR)
      Y  = LU*(YU*XVR - XU*YVR)
      IF (ABS(Y).GT.XL/2.0 .OR. X.LT.0.0 .OR. X.GT.RL) GO TO 400
C
C     SEE IF POINT IS IN LOCAL REGION
C
  380 XU = PR - ALOC1
      YU = PI - WLOC1
      LU = SQRT(XU*XU + YU*YU)
      IF (LU .EQ. 0.0) GO TO 390
      XU = XU/LU
      YU = YU/LU
      Y  = LU*(YU*XVR-XU*YVR)
      X  = LU*(XU*XVR+YU*YVR)
      IF (ABS(Y).GT.XL/2.0 .OR. X.LT.0.0 .OR. X.GT.RLL) GO TO 190
C
C     TRY FOR CONVERGENCE
C
  390 ASSIGN 450 TO DRETN
      GO TO 810
C
C     PREDICTED OUTSIDE BIG REGION
C
  400 NOUTSD = NOUTSD + 1
      GO TO 190
C
C     BEGIN CONVERGENCE TESTS
C
  450 IF (ICNT .LE. 2) GO TO 520
      H1BAR = DSQRT(HK1R*HK1R + HK1I*HK1I)
      H2BAR = DSQRT(HKR*HKR + HKI*HKI)
      H3BAR = DSQRT(HKP1R*HKP1R + HKP1I*HKP1I)
  460 TEST  = EPSI*RL
      IF (H1BAR .GT. TEST*1.0E7) GO TO 480
      IF (H2BAR .GT. TEST*1.0E4) GO TO 480
      IF (H3BAR .GT.      H2BAR) GO TO 470
      IF (H3BAR .GT.       TEST) GO TO 480
      GO TO 550
  470 IF (H2BAR .LE.  1.0E-7*RL) GO TO 550
  480 ICNT = ICNT + 1
      IF (ICNT-NIT) 530,500,490
  490 IFAIL = 1
      NFAIL = NFAIL + 1
      GO TO 190
  500 IF (NCHANG.LT.NUMINT .AND. IFAIL.EQ.1) GO TO 510
      GO TO 490
  510 EPSI   = EPSI*10.0
      NCHANG = NCHANG + 1
      GO TO 460
C
C     CONTINUE INTERATIONS
C
  520 ICNT = ICNT + 1
  530 DO 540 I = 1,2
      PKR(I)  = PKR(I+1)
      PKI(I)  = PKI(I+1)
      IPDET(I)= IPDET(I+1)
      DETR(I) = DETR(I+1)
      DETI(I) = DETI(I+1)
  540 CONTINUE
      PKR(3)  = PR
      PKI(3)  = PI
      DETR(3) = DR
      DETI(3) = DI
      IPDET(3)= POWR
      GO TO 280
C
C     ACCEPT CURRENT EIGENVALUE
C
  550 FILE   = LAMA
      NFOUND = NFOUND + 1
      IFPASS = 1
      IF (NFOUND .GT. 1) IM1 = 3
      CALL OPEN (*950,LAMA,IZ(IBUF),IM1)
      ZD(1  ) = PR
      ZD(IZ2) = PI
      CALL WRITE (LAMA,ZD(1),4,1)
      CALL CLOSE (LAMA,2)
C
C     BUILD LOAD FOR FBS
C
      IF (MINDA .EQ. 0.0D0) MINDA = 1.0D-8
      SIGN =-SIGN
      D1   = NROW
      D2   = NFOUND
      J    = 2*NROW
      DO 560 I = 1,J,2
      K    = (I+1)/2
      ZD(I  ) = SIGN*MINDA/(1.0D0+(1.0D0-FLOAT(K)/D1)*D2)
      ZD(I+1) = 0.0D0
  560 CONTINUE
      ISCR2(1) = SR2
      ISCR2(7) = FU(7)
      CALL CDTFBS (ZD(1),ZD(J+1),IZ(IBUF),ISCR2,NROW)
C
C     NORMALIZE
C
      D1 = 0.0D0
      DO 570 I = 1,J,2
      D2 = ZD(I)*ZD(I) + ZD(I+1)*ZD(I+1)
      IF (D2 .LT. D1) GO TO 570
      D3 = ZD(I  )
      D4 = ZD(I+1)
      D1 = D2
  570 CONTINUE
      IF (INORM .EQ. 0) GO TO 600
  580 DO 590 I = 1,J,2
      D5 = (ZD(I)*D3  + ZD(I+1)*D4)/D1
      ZD(I+1) = (D3*ZD(I+1) - D4*ZD(I))/D1
      ZD(I  ) = D5
  590 CONTINUE
      GO TO 610
  600 JJ = 2*ISIL
      D2 = ZD(JJ)*ZD(JJ) + ZD(JJ-1)*ZD(JJ-1)
      IF (D2.EQ.0.0D0 .OR. D1/D2.GT.1.0D6) GO TO 580
      D3 = ZD(JJ-1)
      D4 = ZD(JJ  )
      D1 = D2
      GO TO 580
C
C     WRITE OUT NORMALIZED VECTOR
C
  610 FILE = PHID
      CALL OPEN  (*950,PHID,IZ(IBUF),IM1)
      CALL WRITE (PHID,ZD(1),4*NROW,1)
      CALL CLOSE (PHID,2)
C
C     STORE ACCEPTED VALUE
C
      IZ(IRGP+7) = IZ(IRGP+7) + 1
      NF = NF + 1
      J  = (IRGP+1)/2 + 2*NF + 10*NE + 14
      ZD(J  ) = PR
      ZD(J+1) = PI
      IFAIL   = 0
C
C     CHECK FOR STARTING POINT MOVES
C
      J   = IREG1
      I   = 1
  620 DT1 = 200.0*EPSI*EPSI*Z(J+9)
      M   = 2*IZ(J+5) + 2
      K   = (J+1)/2 + 5
      L   = 1
  630 K   = K + 2
      KKK = J + 16*IZ(J+5) + 26 + 2*L
      IF (DSQRT((ZD(K)-PI)**2+(ZD(K-1)-PR)**2) .GE. DT1) GO TO 650
C
C     SHIFT STARTING POINT
C
      D2  = 1000.0*EPSI*EPSI*Z(J+9)
      ZD(K-1) = DSIGN((Z(J+2)-Z(J  ))/Z(J+9)*D2+ZD(K-1),ZD(K-1))
      ZD(K  ) = DSIGN((Z(J+3)-Z(J+1))/Z(J+9)*D2+ZD(K  ),ZD(K  ))
      NMOVES  = NMOVES + 1
C
C     IF  DETERMINANT EVALUATED - REEVALUATE FOR SHIFT
C
      IF (IZ(KKK) .EQ. 0) GO TO 670
      DT2 = PR
      DT3 = PI
      PR  = ZD(K-1)
      PI  = ZD(K  )
      ASSIGN 640 TO DRETN
      GO TO 810
  640 PR = DT2
      PI = DT3
      KK = K + 4*IZ(J+5) + 4
      ZD(KK  ) = DI
      ZD(KK-1) = DR
      IZ(KKK+1)= POWR
      GO TO 660
C
C     SWEEP ACCEPTED VALUE FROM STORED  DETM-S
C
  650 KK = K + 4*IZ(J+5) + 4
      D2 = ZD(K-1) - PR
      D3 = ZD(K  ) - PI
      D4 = D2*D2 + D3*D3
      D5 = (ZD(KK-1)*D2 + ZD(KK)*D3)/D4
      ZD(KK  ) = (ZD(KK)*D2 - ZD(KK-1)*D3)/D4
      ZD(KK-1) = D5
C
C     SWEEP CONJUGATES S
C
      IF (ICMPX.EQ.1 .OR. DABS(PI).LT.1000.0*Z(J+9)*EPSI) GO TO 660
      D3 = ZD(K) + PI
      D4 = D2*D2 + D3*D3
      D5 = (ZD(KK-1)*D2 + ZD(KK)*D3)/D4
      ZD(KK) = (ZD(KK)*D2 - ZD(KK-1)*D3)/D4
      ZD(KK-1) = D5
  660 ZDKM1 = ZD (KK-1)
      ZDK   = ZD (KK  )
      IZK   = IZ (KKK+1)
      CALL CDETM3 (ZDKM1,ZDK,IZK)
      ZD(KK-1) = ZDKM1
      ZD(KK  ) = ZDK
      IZ(KKK+1)= IZK
  670 L = L + 1
      IF (L .LE. M) GO TO 630
      J = IZ(J+8)
      I = I + 1
      IF (I .LE. NREGN) GO TO 620
      CALL KLOCK  (ITIME2)
      CALL TMTOGO (ITLEFT)
      IF (2*(ITIME2-ITIME1).GT.ITLEFT .AND. NFOUND.NE.NDESRD) GO TO 700
      IF (NF .LT. ND) GO TO 260
C
C     FIND NEXT REGION LACKING ROOTS
C
  680 IF (IZ(IRGP+8) .EQ. 0) GO TO 140
      IRGP = IZ(IRGP+8)
      IF (IZ(IRGP+6) .GT. IZ(IRGP+7)) GO TO 170
      GO TO 680
  690 ITERM = 2
      GO TO 710
C
C     INSUFFICIENT TIME
C
  700 IF (NMSGX .GE. MAXGX) NMSGX = MAXGX - 1
      CALL MESAGE (45,NDESRD-NFOUND,NAME)
      ITERM = 3
      GO TO 710
C
C     SINGULAR MATRIX
C
  701 ITERM = 4
      GO TO 710
C
C     END OF ROUTINE  PUT OUT SUMMARY
C
  710 CALL GOPEN (OCEIGS,IZ(IBUF),1)
      CALL WRITE (OCEIGS,IHEAD(1),10,0)
      IZ(  1) = NFOUND
      IZ(IZ2) = NPASS
      IZ(IZ3) = NCHANG
      IZ(IZ4) = NMOVES
      IZ(IZ5) = NDCOMP
      IZ(IZ6) = NFAIL
      IZ(IZ7) = NOUTSD
      IZ(IZ8) = ITERM
      CALL WRITE (OCEIGS,IZ(1),40,0)
      CALL WRITE (OCEIGS,HEAD(1),96,1)
      IHEAD(3) = 3
      IHEAD(10)= 6
      CALL WRITE (OCEIGS,IHEAD,50,0)
      CALL WRITE (OCEIGS,HEAD,96,1)
      J  = IREG1
      DO 800 I = 1,NREGN
      NE = IZ(J+5)
      K  = (J+1)/2+6
      KK = 4*NE + 4
      KD = J + 27 + 16*NE
      NE = 2*NE + 2
      DO 790 L = 1,NE
      IZ(1)  = L
      Z(IZ2) = ZD(K  )
      Z(IZ3) = ZD(K+1)
      M  = K  + KK
      KD = KD + 2
      IZ(IZ6) = IZ(KD)
C
C     CONVERT TO MAGNITUDE AND PHASE  SCALE ON MAGNITIDE
C     PHASE IN DEGRESS BETWEEN 0 AND 360
C
      D1 = DSQRT(ZD(M)*ZD(M) + ZD(M+1)*ZD(M+1))
      IF (D1 .EQ.  0.0D0) GO TO 760
  720 IF (D1 .GT. 10.0D0) GO TO 740
  730 IF (D1 .LT.  1.0D0) GO TO 750
      GO TO 770
  740 D1 = D1*0.1D0
      IZ(IZ6) = IZ(IZ6) + 1
      GO TO 720
  750 D1 = D1*10.0D0
      IZ(IZ6) = IZ(IZ6) - 1
      GO TO 730
C
C     NOT  EVALUATED
C
  760 Z(IZ4) = 0.0
      Z(IZ5) = 0.0
      GO TO 780
  770 Z(IZ4) = D1
C
C     COMPUTE PHASE
C
      Z(IZ5) = DATAN2(ZD(M+1),ZD(M))*RADDEG
C
C     DETERMINE QUADRANT
C
      IF (Z(IZ5) .LT. 0.) Z(IZ5) = Z(IZ5) + 360.0
  780 CONTINUE
      CALL WRITE (OCEIGS,IZ(1),6,0)
      K = K + 2
  790 CONTINUE
      J = IZ(J+8)
  800 CONTINUE
      CALL CLOSE (OCEIGS,1)
      FA(1) = OCEIGS
      CALL WRTTRL (FA(1))
      RETURN
C
C     INTERNAL SUBROUTINE TO EVALUATE DR,DI AT PR,PI
C
  810 NDCOMP = NDCOMP + 1
C
C     SET UP FOR ADD
C
      BMCB(1) = PR
      BMCB(2) = PI
      CMCB(1) = PR*PR - PI*PI
      CMCB(2) = 2.*PR*PI
      CALL SADD (Z(1),Z(1))
      FA(1) = -IABS(FA(1))
      IF (NOSING .EQ. 0) GO TO 821
      ISAVE = SR2
      SR2   = SCR8
      SCR8  = ISAVE
  821 CALL TMTOGO (KK)
      IF (KK .LE. 0) GO TO 700
      IB = 0
      CALL CDCOMP (*930,Z(1),Z(1),Z(1))
      NOSING = 1
      IF (IPRT .NE. 0) WRITE (OTPE,831) PR,PI,DR,DI,POWR
  831 FORMAT (10X,4D16.7,I8)
C
C     SCALE DETERMINANT BY POLES AND EIGENVALUES PREVIOUSLY FOUND
C
      ID1 = IREG1
      DO 880 ID = 1,NREGN
      ID2 = IZ(ID1+5)
      KK  = IZ(ID1+7)
      IF (KK .EQ. 0) GO TO 870
      KD = 14 + 10*ID2 + (ID1+1)/2
      DO 860 LL = 1,KK
      KD = KD + 2
      D1 = PR - ZD(KD  )
      D2 = PI - ZD(KD+1)
      D3 = D1*D1  + D2*D2
      D4 = (DR*D1 + DI*D2)/D3
      D5 = (DI*D1 - DR*D2)/D3
      DR = D4
      DI = D5
      IF (ICMPX .EQ. 1) GO TO 850
C
C     SWEEP COMPLEX CONJUGATE ROOTS
C
      IF (DABS(ZD(KD+1)) .LT. 1000.0*Z(ID1+9)*EPSI) GO TO 850
      D2 = PI + ZD(KD+1)
      D3 = D1*D1  + D2*D2
      D4 = (DR*D1 + DI*D2)/D3
      D5 = (DI*D1 - DR*D2)/D3
      DR = D4
      DI = D5
  850 CALL CDETM3 (DR,DI,POWR)
  860 CONTINUE
  870 ID1 = IZ(ID1+8)
  880 CONTINUE
C
C     SWEEP POLES
C
      IF (NPOLE .EQ. 0) GO TO 940
      ID1 = IPOLES
      DO 900 ID = 1,NPOLE
      D1 = PR - Z(ID1+1)
      D2 = PI - Z(ID1+2)
      D3 = 1.0D0
      D4 = 0.0D0
      KD = IZ(ID1+3)
      DO 890 ID2 = 1,KD
      D5 = D1*D3 - D2*D4
      D6 = D2*D3 + D1*D4
      D3 = D5
      D4 = D6
  890 CONTINUE
      D1 = D3*D3  + D4*D4
      D2 = (DR*D3 + DI*D4)/D1
      D5 = (DI*D3 - DR*D4)/D1
      DR = D2
      DI = D5
      ID1= ID1 + 4
C
C     SCALE AGAIN
C
      CALL CDETM3 (DR,DI,POWR)
  900 CONTINUE
      GO TO 940
C
C     SINGLULAR MATRIX
C
  930 DR    = 0.0D0
      DI    = 0.0D0
      POWR  = 0
      ISING = ISING + 1
      MINDA = 1.0E-11
      IF (NOSING .EQ. 0) GO TO 940
      NOSING= 0
      ISAVE = SR2
      SR2   = SCR8
      SCR8  = ISAVE
C
C     RETURN
C
  940 IF (IPRT .NE. 0) WRITE (OTPE,831) PR,PI,DR,DI,POWR
      GO TO DRETN, (240,450,640)
C
C     ERROR  MESAGES
C
  950 IP1 = -1
  960 CALL MESAGE (IP1,FILE,NAME)
  970 IP1 = -2
      GO TO 960
  980 IP1 = -3
      GO TO 960
  990 IP1 = -7
      GO TO 960
 1000 IP1 = -8
      GO TO 960
      END

      SUBROUTINE STRI31
C
C     ROUTINE TO RECOVER CTRIA3 ELEMENT FORCES, STRAINS, AND STRESSES.
C     PHASE 1.
C
C     WAS NAMED T3ST1D/S IN UAI CODE
C
C                 EST  LISTING
C
C        WORD     TYP       DESCRIPTION
C     ----------------------------------------------------------------
C     ECT:
C         1        I   ELEMENT ID, EID
C         2-4      I   SIL LIST, GRIDS 1,2,3
C         5-7      R   MEMBRANE THICKNESSES T, AT GRIDS 1,2,3
C         8        R   MATERIAL PROPERTY ORIENTAION ANGLE, THETA
C               OR I   COORD. SYSTEM ID (SEE TM ON CTRIA3 CARD)
C         9        I   TYPE FLAG FOR WORD 8
C        10        R   GRID OFFSET, ZOFF
C    EPT:
C        11        I   MATERIAL ID FOR MEMBRANE, MID1
C        12        R   ELEMENT THICKNESS,T (MEMBRANE, UNIFORMED)
C        13        I   MATERIAL ID FOR BENDING, MID2
C        14        R   MOMENT OF INERTIA FACTOR, I (BENDING)
C        15        I   MATERIAL ID FOR TRANSVERSE SHEAR, MID3
C        16        R   TRANSV. SHEAR CORRECTION FACTOR, TS/T
C        17        R   NON-STRUCTURAL MASS, NSM
C        18-19     R   STRESS FIBER DISTANCES, Z1,Z2
C        20        I   MATERIAL ID FOR MEMBRANE-BENDING COUPLING, MID4
C        21        R   MATERIAL ANGLE OF ROTATION, THETA
C               OR I   COORD. SYSTEM ID (SEE MCSID ON PSHELL CARD)
C                      (DEFAULT FOR WORD 8)
C        22        I   TYPE FLAG FOR WORD 21 (DEFAULT FOR WORD 9)
C        23        I   INTEGRATION ORDER FLAG
C        24        R   STRESS ANGLE OF RATATION, THETA
C               OR I   COORD. SYSTEM ID (SEE SCSID ON PSHELL CARD)
C        25        I   TYPE FLAG FOR WORD 24
C        26        R   OFFSET, ZOFF1 (DEFAULT FOR WORD 10)
C    BGPDT:
C        27-38   I/R   CID,X,Y,Z  FOR GRIDS 1,2,3
C    ETT:
C        39        I   ELEMENT TEMPERATURE
C
C
C     ****************        RESIDES IN COMMON BLOCK SDR2X5 (AFTER EST)
C     PH1OUT DATA BLOCK       TOTAL NO. OF WORDS = 713
C     ****************
C
C     PH1OUT( 1)    = ELID, ELEMENT ID
C     PH1OUT( 2- 4) = SIL NUMBERS
C     PH1OUT( 5- 7) = ARRAY IORDER
C     PH1OUT( 8)    = TSUB0, REFERENCE TEMP.
C     PH1OUT( 9-10) = Z1 & Z2, FIBER DISTANCES
C     PH1OUT(11)    = ID OF THE ORIGINAL PCOMPI PROPERTY ENTRY
C     PH1OUT(12)    = DUMMY WORD (FOR ALLIGNMENT)
C
C     PH1RST( 1)    = AVGTHK, AVERAGE THICKNESS
C     PH1RST( 2)    = MOMINR, MOMENT OF INER. FACTOR
C     PH1RST( 3-38) = 6X6 MATERIAL PROPERTY MATRIX (NO SHEAR)
C     PH1RST(39-41) = THERMAL EXPANSION COEFFICIENTS FOR MEMBRANE
C     PH1RST(42-44) = THERMAL EXPANSION COEFFICIENTS FOR BENDING
C     PH1RST(45-47) = CORNER NODE THICKNESSES
C     PH1RST(48)    = OFFSET OF ELEMENT FROM GP PLANE
C     PH1RST(49-57) = 3X3 USER-TO-MATERIAL COORD. TRNASF. MATRIX UEM
C     PH1RST(58-66) = 3X3 ELEM-TO-STRESS/STRAIN TRANSF. TENSOR TES
C     PH1RST(67-93) = THREE 3X3 GLOBAL-TO-ELEM COORD. TRANSFORMATION
C                     NODAL MATRICES TEG, ONE FOR EACH NODE
C
C     THE FOLLOWING IS REPEATED FOR EACH EVALUATION POINT (4 TIMES, AT
C     THE CENTER OF THE ELEMENT AND AT 3 STANDARD TRIANGULAR POINTS).
C     THE CHOICE OF THE FINAL STRESS/FORCE OUTPUT POINTS IS MADE AT THE
C     SUBCASE LEVEL (PHASE 2).
C
C              1             ELEMENT THICKNESS AT THIS POINT
C            2 - 5           OUT-OF-PLANE-SHEAR-FORCE/STRAIN MATRIX
C            6 - 8           ELEMENT SHAPE FUNCTION VALUES
C          8+1 - 8+8*NDOF    STRAIN RECOVERY MATRIX
C
C
C     *****************      RESIDES IN COMMON BLOCK SDR2X6
C     IELOUT DATA BLOCK      CONTAINS DATA FOR GPSRN
C     *****************      (TOTAL NO OF WORDS =  77)
C
C              1             ELEMENT ID
C              2             AVERAGE THICKNESS
C
C     THE FOLLOWING IS REPEATED FOR EACH NODE.
C
C         WORD  1            SIL NUMBER
C         WORD  2-10         [TSB] FOR Z1
C         WORD 11-19         [TSB] FOR Z2
C         WORD 20-22         NORMAL VECTOR IN BASIC COORD. SYSTEM
C         WORD 23-25         GRID COORDS   IN BASIC COORD. SYSTEM
C
C
      LOGICAL         MEMBRN,BENDNG,SHRFLX,MBCOUP,NORPTH,
     1                SHEART,NOALFA,USERST
      INTEGER         NPHI(100),NEST(39),SIL(3),SILO,IGPDT(4,3),ELID,
     1                NECPT(4),MID(4),PIDO,SCSID,FLAGS,HUNMEG,ITHERM,
     2                NAME(2),INDEX(2,3),SYSBUF,NOUT,NOGO,PREC
      REAL            RELOUT(300),GPTH(3),BGPDT(4,3),ECPT(4),
     1                KHEAT,HTCP,TSUB0,GSUBE,ELTEMP,Z1O,Z2O
      REAL            PH1RST,DGPTH(3),TH,AVGTHK,GPNORM(4,3),
     1                EPNORM(4,3),EGPDT(4,3),CENTE(3),OFFSET,ALPHA(6),
     2                GI(36),RHO,JOG,JOK,K11,K22,ZZ(4),AIC(18),
     3                EGNOR(4),TSS,LX,LY,EDGLEN(3),MOMINR,TS,REALI,TSI,
     4                TEU(9),TES(9),TEB(9),TBG(9),TUS(9),TEM(9),TSB(9),
     5                TSM(9),TUB(9),TUM(9),THETAM,THETAS,UEM(9),VEM(4),
     6                DETERM,BDUM(3),SHPT(3),BTERMS(6),BMAT1(486),
     7                BMATRX(162),BMTRX(36),DRKCE(33)
      COMMON /SYSTEM/ SYSBUF,NOUT,NOGO,IDUM(51),PREC,ITHERM
      COMMON /SDR2X5/ EST(100),
     1                ELID,SILO(3),IORDER(3),TSUB0,Z1O,Z2O,PIDO,IDUMAL,
     1                PH1RST(701)
      COMMON /SDR2X6/ IELOUT(300)
      COMMON /MATIN / MATID,INFLAG,ELTEMP,DUMMY,SINMAT,COSMAT
      COMMON /HMTOUT/ KHEAT(7),TYPE
      COMMON /TERMS / MEMBRN,BENDNG,SHRFLX,MBCOUP,NORPTH
      EQUIVALENCE     (EST( 1),NEST(1) ), (EST( 2),SIL(1)),
     1                (EST( 5),GPTH(1) ), (EST(10),ZOFF  ),
     2                (EST(12),ELTH    ), (EST(23),INT   ),
     3                (EST(26),ZOFF1   ), (EST(39),TEMPEL),
     4                (EST(27),BGPDT(1,1), IGPDT(1,1))
      EQUIVALENCE     (NPHI( 1),ELID   ), (NPHI (27),DRKCE(1) ),
     1                (NECPT(1),ECPT(1)), (IELOUT(1),RELOUT(1)),
     2                (HTCP,KHEAT(4))
      DATA    HUNMEG, ISTART / 100000000, 93 /,  EPS / 1.0E-17 /
      DATA    NAME  / 4HTRIA , 4H3           /
C
C     INITIALIZE
C
      NNODE  = 3
      MOMINR = 0.0
      TS     = 0.0
      ELTEMP = TEMPEL
      ELID   = NEST(1)
      Z1O    = EST(18)
      Z2O    = EST(19)
      PIDO   = NEST(11) - HUNMEG
      MCSID  = NEST(21)
      SCSID  = NEST(24)
      FLAGS  = NEST(25)
      USERST = SCSID.LT.0 .AND. FLAGS.EQ.1
      NOALFA = .FALSE.
      SHEART = .TRUE.
      OFFSET = ZOFF
      IF (ZOFF .EQ. 0.0) OFFSET = ZOFF1
C
C     START FILLING IN THE DATA BLOCKS
C
      IELOUT(1) = ELID
      DO 20 I = 1,3
      IELOUT(3+(I-1)*25) = SIL(I)
      DO 10 J = 1,3
      RELOUT(25*I+J-1) = BGPDT(J+1,I)
   10 CONTINUE
   20 CONTINUE
C
C     SET UP THE ELEMENT FORMULATION
C
      CALL T3SETS (IERR,SIL,IGPDT,ELTH,GPTH,DGPTH,EGPDT,GPNORM,EPNORM,
     1             IORDER,TEB,TUB,CENTE,AVGTHK,LX,LY,EDGLEN,ELID)
      IF (IERR .NE. 0) GO TO 600
      CALL GMMATS (TEB,3,3,0, TUB,3,3,1, TEU)
      DO 30 I = 1,3
      SILO(I) = SIL(I)
   30 CONTINUE
C
C     SET THE NUMBER OF DOF'S
C
      NNOD2 = NNODE*NNODE
      NDOF  = NNODE*6
      NPART = NDOF*NDOF
      ND2   = NDOF*2
      ND6   = NDOF*6
      ND7   = NDOF*7
      ND8   = NDOF*8
      ND9   = NDOF*9
C
C     PASS THE LOCATION OF THE ELEMENT CENTER FOR TRANSFORMATIONS.
C
      DO 40 IEC = 2,4
      ECPT(IEC) = CENTE(IEC-1)
   40 CONTINUE
C
C     STRESS TRANSFORMATIONS
C
      IF (.NOT.USERST) GO TO 50
      EST (24) = 0.0
      NEST(25) = 0
   50 CALL SHCSGS (*620,NEST(25),NEST(24),EST(24),NEST(25),NEST(24),
     1             EST(24),NECPT,TUB,SCSID,THETAS,TUS)
      CALL GMMATS (TEU,3,3,0, TUS,3,3,0, TES)
C
C     OBTAIN MATERIAL INFORMATION
C
C     SET MATERIAL FLAGS
C     0.83333333 = 5.0/6.0
C
      IF (NEST(13) .NE.   0) MOMINR = EST(14)
      IF (NEST(13) .NE.   0) TS = EST(16)
      IF ( EST(16) .EQ. 0.0) TS = 0.83333333
      IF (NEST(13).EQ.0 .AND. NEST(11).GT.HUNMEG) TS = 0.83333333
C
      MID(1) = NEST(11)
      MID(2) = NEST(13)
      MID(3) = NEST(15)
      MID(4) = NEST(20)
C
      MEMBRN = MID(1).GT.0
      BENDNG = MID(2).GT.0 .AND. MOMINR.GT.0.0
      SHRFLX = MID(3).GT.0
      MBCOUP = MID(4).GT.0
      NORPTH = .FALSE.
C
C     SET UP TRANSFORMATION MATRIX FROM MATERIAL TO ELEMENT COORD. SYSTM
C
      CALL SHCSGS (*610,NEST(9),NEST(8),NEST(8),NEST(21),NEST(20),
     1             NEST(20),NECPT,TUB,MCSID,THETAM,TUM)
C
C     BRANCH ON FORMULATION TYPE, HEAT
C
      IF (ITHERM .NE. 0) GO TO 500
C
C     FETCH MATERIAL PROPERTIES
C
      CALL GMMATS (TEU,3,3,0, TUM,3,3,0, TEM)
      CALL GMMATS (TES,3,3,1, TEM,3,3,0, TSM)
      CALL SHGMGS (*630,ELID,TSM,MID,TS,NOALFA,GI,RHO,GSUBE,TSUB0,
     1             EGNOR,ALPHA)
C
C     TURN OFF THE COUPLING FLAG WHEN MID4 IS PRESENT WITH ALL
C     CALCULATED ZERO TERMS.
C
      IF (.NOT.MBCOUP) GO TO 70
      DO 60 I = 28,36
      IF (ABS(GI(I)) .GT. EPS) GO TO 70
   60 CONTINUE
      MBCOUP = .FALSE.
   70 CONTINUE
C
C     CONTINUE FILLING IN THE DATA BLOCKS
C
      PH1RST( 1) = AVGTHK
      PH1RST( 2) = MOMINR
      PH1RST(48) = OFFSET
      RELOUT( 2) = AVGTHK
C
C     PUT NORMALS IN IELOUT, GRID THICKNESS IN PH1OUT
C
      DO 80 I = 1,NNODE
      IO  = IORDER(I)
      IOP = (IO-1)*25 + 21
      RELOUT(IOP+1) = GPNORM(2,I)
      RELOUT(IOP+2) = GPNORM(3,I)
      RELOUT(IOP+3) = GPNORM(4,I)
      PH1RST(44+IO) = DGPTH(I)
   80 CONTINUE
C
C     CALCULATE [TSB] AND STORE IT IN IELOUT.
C
      CALL GMMATS (TES,3,3,1, TEB,3,3,0, TSB)
      ND25 = NNODE*25
      DO 100 IP2 = 3,ND25,25
      DO 90 IX = 1,9
      RELOUT(IP2+IX  ) = TSB(IX)
      RELOUT(IP2+IX+9) = TSB(IX)
   90 CONTINUE
  100 CONTINUE
C
C     STORE ALPHA IN PH1RST(39-44)
C
      DO 110 IALF = 1,6
      PH1RST(38+IALF) = ALPHA(IALF)
  110 CONTINUE
C
C     STORE UEM IN PH1RST(49-57)
C     STORE TES IN PH1RST(58-66)
C
      CALL SHSTTS (TEM,UEM,VEM)
      DO 120 LL = 1,9
      PH1RST(48+LL) = UEM(LL)
      PH1RST(57+LL) = TES(LL)
  120 CONTINUE
C
C     STORE THE 6X6 [G] IN PH1RST
C
      DO 130 IG = 3,38
      PH1RST(IG) = 0.0
  130 CONTINUE
C
      IF (.NOT.MEMBRN) GO TO 160
      DO 150 IG = 1,3
      IG1 = (IG-1)*6 + 2
      IG2 = (IG-1)*3
      DO 140 JG = 1,3
      PH1RST(IG1+JG) = GI(IG2+JG)
  140 CONTINUE
  150 CONTINUE
C
  160 IF (.NOT.BENDNG) GO TO 210
      DO 180 IG = 1,3
      IG1 = (IG-1)*6 + 23
      IG2 = (IG-1)*3 +  9
      DO 170 JG = 1,3
      PH1RST(IG1+JG) = GI(IG2+JG)*MOMINR
  170 CONTINUE
  180 CONTINUE
C
      IF (.NOT.MBCOUP) GO TO 210
      DO 200 IG = 1,3
      IG3 = (IG-1)*3
      IG1 =  IG3 +  5
      IG2 =  IG3 + 27
      IG3 =  IG3 + 20
      DO 190 JG = 1,3
      PH1RST(IG1+JG) = GI(IG2+JG)
      PH1RST(IG3+JG) = GI(IG2+JG)
  190 CONTINUE
  200 CONTINUE
  210 CONTINUE
C
C     CALCULATE [TEG] FOR EACH NODE AND STORE IT IN PH1RST
C
      DO 220 I = 1,NNODE
      IP = 67 + (I-1)*9
      CALL TRANSS (IGPDT(1,I),TBG)
      CALL GMMATS (TEB,3,3,0, TBG,3,3,0, PH1RST(IP))
  220 CONTINUE
C
C     GET THE GEOMETRY CORRECTION TERMS
C
      IF (.NOT.BENDNG) GO TO 230
      CALL T3GEMS (IERR,EGPDT,IORDER,GI(10),GI(19),LX,LY,EDGLEN,SHRFLX,
     1             AIC,JOG,JOK,K11,K22)
      IF (IERR .NE. 0) GO TO 600
C
C     REDUCED INTEGRATION
C
  230 IF (INT .NE. 0) GO TO 260
C
C     DETERMINE THE AVERAGE [B] FOR OUT-OF-PLANE SHEAR
C
      DO 240 IPT = 1,3
      KPT = (IPT-1)*ND9 + 1
      CALL T3BMGS (IERR,SHEART,IPT,IORDER,EGPDT,DGPTH,AIC,TH,DETJAC,
     1             SHPT,BTERMS,BMAT1(KPT))
      IF (IERR .NE. 0) GO TO 600
  240 CONTINUE
C
      DO 250 I = 1,NDOF
      BMTRX(I     ) = BMAT1(I+ND6) +BMAT1(I+ND6+ND9) +BMAT1(I+ND6+2*ND9)
      BMTRX(I+NDOF) = BMAT1(I+ND7) +BMAT1(I+ND7+ND9) +BMAT1(I+ND7+2*ND9)
  250 CONTINUE
C
C     STRAIN/STRESS EVALUATION LOOP
C
C     PRESET THE PH1RST COUNTER TO THE START OF THE REPEATED SECTION
C     WHICH WILL NOW BE FILLED.
C
  260 ICOUNT =  ISTART
C
      DO 400 IPT = 4,7
C
      CALL T3BMGS (IERR,SHEART,IPT,IORDER,EGPDT,DGPTH,AIC,TH,DETJAC,
     1             SHPT,BTERMS,BMATRX)
      IF (IERR .NE. 0) GO TO 600
C
      IF (INT .NE. 0) GO TO 310
      DO 300 IX = 1,NDOF
      BMATRX(IX+ND6) = BMTRX(IX     )
      BMATRX(IX+ND7) = BMTRX(IX+NDOF)
  300 CONTINUE
C
C     FINISH FILLING IN THE DATA BLOCKS
C
C     STORE THICKNESS
C
  310 PH1RST(ICOUNT+1) = TH
C
C     STORE [G3]
C
      IF (.NOT.BENDNG) GO TO 330
      REALI = MOMINR*TH*TH*TH/12.0
      TSI   = TS*TH
      TSS   = 1.0/(2.0*12.0*REALI)
C
      ZZ(1) = (JOG/TSI)* GI(22) + TSS*JOK*K22
      ZZ(2) =-(JOG/TSI)*(GI(20) + GI(21))/2.0
      ZZ(3) = ZZ(2)
      ZZ(4) = (JOG/TSI)* GI(19) + TSS*JOK*K11
C
      CALL INVERS (2,ZZ,2,BDUM,0,DETERM,ISING,INDEX)
      IF (ISING .NE. 1) GO TO 600
C
      DO 320 IG = 1,4
      PH1RST(ICOUNT+1+IG) = ZZ(IG)
  320 CONTINUE
      GO TO 350
C
  330 DO 340 IG = 1,4
      PH1RST(ICOUNT+1+IG) = 0.0
  340 CONTINUE
C
C     STORE SHAPE FUNCTION VALUES
C
  350 DO 360 I = 1,NNODE
      PH1RST(ICOUNT+5+I) = SHPT(I)
  360 CONTINUE
C
C     STORE THE STRAIN RECOVERY MATRIX
C
      DO 370 IPH = 1,ND8
      PH1RST(ICOUNT+8+IPH) = BMATRX(IPH)
  370 CONTINUE
C
C     END OF THE EVALUATION LOOP
C
C     INCREMENT THE PH1RST COUNTER
C
      ICOUNT = ICOUNT + 8 + 8*NDOF
C
  400 CONTINUE
      GO TO 700
C
C
C     BEGINNING OF HEAT FORCE RECOVERY
C
  500 CONTINUE
C
C     SET UP FOR THE UNIVERSAL PHASE 2 HEAT RECOVERY
C
      NPHI(22) = 2
      NPHI(23) = NNODE
      NPHI(24) = NAME(1)
      NPHI(25) = NAME(2)
C
      SHEART = .FALSE.
      IPT = 4
      CALL T3BMGS (IERR,SHEART,IPT,IORDER,EGPDT,DGPTH,AIC,TH,DETJAC,
     1             SHPT,BTERMS,BMATRX)
      IF (IERR .NE. 0) GO TO 600
C
      MATID  = NEST(11)
      INFLAG = 2
      THETAS = THETAS - THETAM
      SINMAT = SIN(THETAS)
      COSMAT = COS(THETAS)
      CALL HMAT (ELID)
C
      DRKCE(1) = KHEAT(1)
      DRKCE(2) = KHEAT(2)
      DRKCE(3) = KHEAT(2)
      DRKCE(4) = KHEAT(3)
C
      TES(3) = TES(4)
      TES(4) = TES(5)
      CALL GMMATS (TES,2,2,1, BTERMS,2,NNODE,0, DRKCE(10))
C
      GO TO 700
C
C
C     FATAL ERRORS
C
C     CTRIA3 ELEMENT HAS ILLEGAL GEOMETRY OR CONNECTIONS
C
  600 J = 224
      GO TO 640
C
C     THE X-AXIS OF THE MATERIAL COORDINATE SYSTEM HAS NO PROJECTION
C     ON THE PLANE OF THE CTRIA3 ELEMENT
C
  610 J = 225
      NEST(2) = MCSID
      GO TO 640
C
C     THE X-AXIS OF THE STRESS COORDINATE SYSTEM ID HAS NO PROJECTION
C     ON THE PLANE OF THE CTRIA3 ELEMENT
C
  620 J = 227
      NEST(2) = SCSID
      GO TO 640
C
C     ILLEGAL DATA DETECTED ON MATERIAL ID REFERENCED BY CTRIA3 ELEMENT
C     FOR MID3 APPLICATION
C
  630 J = 226
      NEST(2) = MID(3)
C
  640 CALL MESAGE (30,J,NEST(1))
      NOGO = 1
C
  700 CONTINUE
      RETURN
      END

      SUBROUTINE DDAMPG
C
C     DDAMPG  MP,PVW/PG/V,N,NMODES/V,N,NDIR $
C
C     MP IS MGG*PHIG, PVW IS (PF)*SSDV*OMEGA, PARTICIPATION FACTORS X
C     SHOCK SPECTRUM DESIGN VALUES X RADIAN FREQUENCIES.
C     MP IS (NXM).  IF PVW IS A VECTOR (MX1), WE WANT TO MULTIPLY THE
C     ITH. TERM INTO THE ITH. COLUMN OF MP.  PG IS THEN NXM.
C     IF PVW IS A MATRIX (MXL), WE REPEAT THE PREVIOUS COMPUTATION FOR
C     EACH OF THE L VECTORS, MAKING PG (NX(MXL)).
C     NMODES IS NUMBER OF MODES. NDIR IS NUMBER OF SHOCK DIRECTIONS
C
      INTEGER         MP,PVW,PG,BUF1,BUF2,BUF3,FILE
      DIMENSION       NAM(2),MCB(7)
      COMMON /UNPAKX/ JOUT,III,NNN,JNCR
      COMMON /PACKX / IIN,IOUT,II,NN,INCR
      COMMON /SYSTEM/ IBUF(80)
      COMMON /BLANK / NMODES,NDIR
      COMMON /ZZZZZZ/ Z(1)
      DATA    MP,PVW, PG /101,102,201/
      DATA    NAM   / 4HDDAM,4HPG    /
C
C     SET UP OPEN CORE AND BUFFERS
C
      LCORE = KORSZ(Z)
      BUF1  = LCORE - IBUF(1) + 1
      BUF2  = BUF1 - IBUF(1)
      BUF3  = BUF2 - IBUF(1)
      LCORE = BUF3 - 1
      IF (LCORE .LE. 0) GO TO 1008
C
C     PICK UP ROW AND COLUMN STATISTICS AND SET PACK/UNPACK PARAMETERS
C
      MCB(1) = MP
      CALL RDTRL (MCB)
      NCOLMP = MCB(2)
      NMODES = NCOLMP
      NROWMP = MCB(3)
      MCB(1) = PVW
      CALL RDTRL (MCB)
      NCOLPV = MCB(2)
      NDIR   = NCOLPV
      NROWPV = MCB(3)
      MCB4   = MCB(4)
      MCB5   = MCB(5)
C
C
      IF (LCORE .LT. NROWPV+NROWMP) GO TO 1008
      IF (NCOLMP .NE. NROWPV) GO TO 1007
      MCB(1) = PG
      MCB(2) = 0
      MCB(3) = NROWMP
      MCB(4) = MCB4
      MCB(5) = MCB5
      MCB(6) = 0
      MCB(7) = 0
C
      JOUT = 1
      IIN  = 1
      IOUT = 1
      II   = 1
      III  = 1
      NN   = NROWMP
      INCR = 1
      JNCR = 1
C
      CALL GOPEN (MP,Z(BUF1),0)
      CALL GOPEN (PVW,Z(BUF2),0)
      CALL GOPEN (PG,Z(BUF3),1)
C
      DO 130 IJK = 1,NCOLPV
      NNN = NROWPV
      CALL UNPACK (*20,PVW,Z(1))
      GO TO 60
C
C     NULL COLUMN FOR PVW-WRITE OUT NCOLMP ZERO COLUMNS OF LENGTH NROWMP
C
   20 DO 30 K = 1,NROWMP
   30 Z(K) = 0.
      DO 56 K = 1,NCOLMP
      CALL PACK (Z,PG,MCB)
   56 CONTINUE
      GO TO 125
C
   60 DO 120 J = 1,NCOLMP
      NNN = NROWMP
      CALL UNPACK (*80,MP,Z(NROWPV+1))
      GO TO 100
C
   80 DO 90 K = 1,NROWMP
      Z(NROWPV+K) = 0.
   90 CONTINUE
      GO TO 115
C
  100 DO 110 K = 1,NROWMP
      ISUB = NROWPV + K
      Z(ISUB) = Z(ISUB)*Z(J)
  110 CONTINUE
  115 CALL PACK (Z(NROWPV+1),PG,MCB)
  120 CONTINUE
  125 CALL REWIND (MP)
      FILE = MP
      CALL FWDREC (*1002,MP)
  130 CONTINUE
C
      CALL WRTTRL (MCB)
      CALL CLOSE (MP,1)
      CALL CLOSE (PVW,1)
      CALL CLOSE (PG,1)
C
      RETURN
C
C     FATAL ERRORS
C
 1002 N = -2
      GO TO 1010
 1007 N = -7
      GO TO 1010
 1008 N = -8
      FILE = 0
 1010 CALL MESAGE (N,FILE,NAM)
      RETURN
      END

      SUBROUTINE USRMSG (I)
C
C     USRMSG WILL PRINT THE INDICATED USER LEVEL ERROR MESSAGE
C
      INTEGER         A,B,C,D,E,F,UO,UM,US,UR,UL,L,P1,P2,OUTTAP,BLANK,
     1                BCD(5)
      DIMENSION       ITYPE(6),LIST(10),ICRIGD(4),NAME(2)
      CHARACTER       QUAD4*6,TRIA3*6,INTER*8,EXTER*8,EXIN*8
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25,SWM*27
      COMMON /XMSSG / UFM,UWM,UIM,SFM,SWM
      COMMON /SYSTEM/ SYSBUF,OUTTAP
      COMMON /MACHIN/ MACH
      COMMON /MSGX  / N,M,MSG(4,1)
      DATA    BLANK / 3H   /, LIMIT / 234  /, I2015 / 0       /
      DATA    BCD   / 4H  UM, 4H  US, 4H  UO, 4HUAUR, 4HUAUL        /
      DATA    ITYPE / 4HDARE, 4HA   , 4HDELA, 4HY   , 4HDPHA, 4HSE  /
      DATA    ICRIGD/ 1H1   , 1H2   , 1H3   , 1HR                   /
      DATA    LIST  / 15, 41, 79,103, 117, 137, 199, 211, 212, 215  /
      DATA    AX,RG / 2HAX,  2HRG   / , NAME  / 4HUSRM,4HSG   /
      DATA    INTER / 'INTERNAL'    / , EXTER / 'EXTERNAL'    /
      DATA    QUAD4 , TRIA3 / 'CQUAD4', 'CTRIA3'   /
C
C
      L  = MSG(2,I)
      P1 = MSG(3,I)
      P2 = MSG(4,I)
      IF (L.LE.0 .OR. L.GT.LIMIT) GO TO 9000
      DO 800 J = 1,10
      IF (L .EQ. LIST(J)) GO TO 810
  800 CONTINUE
      J = 2
      IF (L .EQ. 92) J = 4
      IF (L .NE. 15) GO TO 820
      J = 3
      IF (I2015 .GT.  4) J = 1
      IF (I2015 .GE. 31) J = 0
      GO TO 820
  810 J = 3
  820 CALL PAGE2 (J)
      LOCAL = L - 120
      IF (LOCAL .GT. 0) GO TO 830
      GO TO (01,002,003,004,005,006,007,008,009,010,011,012,013,014,015,
     1      016,017,018,019,020,021,022,023,024,025,026,027,028,029,030,
     2      031,032,033,034,035,036,037,038,039,040,041,042,043,044,045,
     3      046,047,048,049,050,051,052,053,054,055,056,057,058,059,060,
     4      061,062,063,064,065,066,067,068,069,070,071,072,073,074,075,
     5      076,077,078,079,080,081,082,083,084,085,086,087,088,089,090,
     6      091,092,093,094,095,096,097,098,099,100,101,102,103,104,105,
     7      106,107,108,109,110,111,112,113,114,115,116,117,118,119,120
     8      ),  L
  830 GO TO(121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,
     9      136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,
     *      151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,
     A      166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,
     B      181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,
     C      196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,
     D      211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,
     E      226,227,228,229,230,231,232,233,234),  LOCAL
    1 WRITE (OUTTAP,1010) UFM,P1
      GO TO 5500
    2 WRITE (OUTTAP,1020) SFM,P1
      GO TO 5500
    3 WRITE (OUTTAP,1030) UFM,P2,P1
      GO TO 5500
    4 WRITE (OUTTAP,1040) UFM,P2,P1
      GO TO 5500
    5 WRITE (OUTTAP,1050) SFM
      GO TO 5500
    6 WRITE (OUTTAP,1060) UFM,P1,P2
      GO TO 5500
    7 WRITE (OUTTAP,1070) UFM,P1,P2
      GO TO 5500
    8 WRITE (OUTTAP,1080) UFM,P1,P2
      GO TO 5500
    9 WRITE (OUTTAP,1090) UFM,P1,P2
      GO TO 5500
   10 WRITE (OUTTAP,1100) UFM,P1,P2
      GO TO 5500
   11 WRITE (OUTTAP,1110) UFM,P1,P2
      GO TO 5500
   12 WRITE (OUTTAP,1120) UFM,P1
      GO TO 5500
   13 WRITE (OUTTAP,1130) UWM
      GO TO 5600
   14 WRITE (OUTTAP,1140) UFM
      GO TO 5500
   15 I2015 = I2015 + 1
      IF (I2015 .EQ. 30) WRITE (OUTTAP,1152)
      IF (I2015 .GE. 30) GO TO 5600
      IF (I2015 .EQ.  4) WRITE (OUTTAP,1153)
      EXIN = INTER
      IF (P2 .NE. 0) EXIN = EXTER
      IF (P2 .NE. 0) P1 = P2
      IF (I2015 .LE. 3) WRITE (OUTTAP,1150) UWM,EXIN,P1
      IF (I2015 .GT. 3) WRITE (OUTTAP,1151) UWM,EXIN,P1
      GO TO 5600
   16 WRITE (OUTTAP,1160) UFM
      GO TO 5500
   17 WRITE (OUTTAP,1170) UFM,P1
      GO TO 5500
   18 WRITE (OUTTAP,1180) UFM,P1
      GO TO 5500
   19 WRITE (OUTTAP,1190) UFM,P1
      GO TO 5500
   20 WRITE (OUTTAP,1200) UFM,P1
      GO TO 5500
   21 WRITE (OUTTAP,1210) UFM
      GO TO 5500
   22 WRITE (OUTTAP,1220) UFM
      GO TO 5500
   23 WRITE (OUTTAP,1230) UFM,P1
      GO TO 5500
   24 WRITE (OUTTAP,1240)
      GO TO 5600
   25 WRITE (OUTTAP,1250) UFM,P1
      GO TO 5500
   26 WRITE (OUTTAP,1260) UFM,P1
      GO TO 5500
   27 WRITE (OUTTAP,1270) UFM,P1,P2
      GO TO 5500
   28 WRITE (OUTTAP,1280) UFM,P1
      GO TO 5500
   29 WRITE (OUTTAP,1290) UFM,P1
      GO TO 5500
   30 WRITE (OUTTAP,1300) UFM
      GO TO 5500
   31 WRITE (OUTTAP,1310) UFM,P1
      GO TO 5500
   32 WRITE (OUTTAP,1320) UFM,P1
      GO TO 5500
   33 WRITE (OUTTAP,1330) UFM,P1
      GO TO 5500
   34 WRITE (OUTTAP,1340) SFM,P1
      GO TO 5500
   35 WRITE (OUTTAP,1350) UFM,P1
      GO TO 5500
   36 WRITE (OUTTAP,1360) UFM,P1
      GO TO 5500
   37 WRITE (OUTTAP,1370) UFM,P1
      GO TO 5500
   38 WRITE (OUTTAP,1380) SFM,P1
      GO TO 5500
   39 WRITE (OUTTAP,1390) UFM,P2,P1
      GO TO 5500
   40 WRITE (OUTTAP,1400) UFM,P1
      GO TO 5500
   41 WRITE (OUTTAP,1410) UFM,P1
      GO TO 5500
   42 WRITE (OUTTAP,1420) UFM,P2,P1
      GO TO 5500
   43 WRITE (OUTTAP,1430) UFM,P1
      GO TO 5500
   44 WRITE (OUTTAP,1440) UFM,P1
      GO TO 5500
   45 WRITE (OUTTAP,1450) UFM,P1
      GO TO 5500
   46 WRITE (OUTTAP,1460) UFM,P1
      GO TO 5500
   47 WRITE (OUTTAP,1470) UFM,P1
      GO TO 5500
   48 WRITE (OUTTAP,1480) UFM,P1,P2
      GO TO 5500
   49 WRITE (OUTTAP,1490) UFM,P1
      GO TO 5500
   50 WRITE (OUTTAP,1500) UFM,P1
      GO TO 5500
   51 WRITE (OUTTAP,1510) UFM,P1,P2
      GO TO 5500
   52 WRITE (OUTTAP,1520) UFM,P1,P2
      GO TO 5500
   53 WRITE (OUTTAP,1530) UFM,P1
      GO TO 5500
   54 WRITE (OUTTAP,1540) UFM,P1,P2
      GO TO 5500
   55 WRITE (OUTTAP,1550) SFM
      GO TO 5500
   56 WRITE (OUTTAP,1560) UFM,P1
      GO TO 5500
   57 WRITE (OUTTAP,1570) UFM,P1
      GO TO 5500
   58 WRITE (OUTTAP,1580) UWM,P1
      GO TO 5600
   59 WRITE (OUTTAP,1590) UFM,P2,P1
      GO TO 5500
   60 WRITE (OUTTAP,1600) UFM,P2,P1
      GO TO 5500
   61 WRITE (OUTTAP,1610) UFM,P2,P1
      GO TO 5500
   62 WRITE (OUTTAP,1620) UFM,P2,P1
      GO TO 5500
   63 WRITE (OUTTAP,1630) UFM
      GO TO 5500
   64 WRITE (OUTTAP,1640) UFM,P1
      GO TO 5500
   65 WRITE (OUTTAP,1650) UFM,P1
      GO TO 5500
   66 WRITE (OUTTAP,1660) UFM,P1
      GO TO 5500
C*****
C     DETERMINE NONLINEAR LOAD TYPE AND NONLINEAR LOAD SET ID
C*****
   67 LDTYPE = P2 / 100000000
      LDSET  = P2 - 100000000*LDTYPE
      WRITE (OUTTAP,1670) UFM,P1,LDTYPE,LDSET
      GO TO 5500
   68 WRITE (OUTTAP,1680) UFM,P1,P2
      GO TO 5500
   69 WRITE (OUTTAP,1690) UFM,P1,P2
      GO TO 5500
   70 WRITE (OUTTAP,1700) UFM,P1,P2
      GO TO 5500
C*****
C     DETERMINE TYPE OF UNDEFINED SET (DAREA, DELAY OR DPHASE)
C*****
   71 INDEX = P2 / 100000000
      P2    = P2 - 100000000*INDEX
      INDEX = 2*INDEX - 1
      WRITE (OUTTAP,1710) UFM,P1,ITYPE(INDEX),ITYPE(INDEX+1),P2
      GO TO 5500
   72 WRITE (OUTTAP,1720) SWM,P1,P2
      GO TO 5600
   73 WRITE (OUTTAP,1730) UIM,P1,P2
      GO TO 5500
   74 WRITE (OUTTAP,1740) UFM,P1
      GO TO 5500
   75 WRITE (OUTTAP,1750) UFM,P1,P2
      GO TO 5500
   76 WRITE (OUTTAP,1760) UWM
      GO TO 5600
   77 WRITE (OUTTAP,1770) UWM
      GO TO 5600
   78 WRITE (OUTTAP,1780) UWM
      GO TO 5600
   79 WRITE (OUTTAP,1790) UWM
      GO TO 5600
   80 WRITE (OUTTAP,1800) UWM
      GO TO 5600
   81 WRITE (OUTTAP,1810) UFM
      GO TO 5500
   82 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
   83 WRITE (OUTTAP,1830) UFM
      GO TO 5500
   84 WRITE (OUTTAP,1840) UFM,P1
      GO TO 5500
   85 WRITE (OUTTAP,1850) UIM,P1,P2
      GO TO 5600
   86 WRITE (OUTTAP,1860) UIM,P1
      GO TO 5600
   87 WRITE (OUTTAP,1870) SFM
      GO TO 5500
   88 WRITE (OUTTAP,1880) UFM,P1
      GO TO 5500
   89 WRITE (OUTTAP,1890) UFM,P1
      GO TO 5500
   90 WRITE (OUTTAP,1900) SFM,P1
      GO TO 5500
   91 WRITE (OUTTAP,1910) SFM,P1
      GO TO 5500
   92 WRITE (OUTTAP,1920) SWM,P1,P2
      GO TO 5600
   93 WRITE (OUTTAP,1930) UFM,P1,P2
      GO TO 5500
   94 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
   95 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
   96 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
   97 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
   98 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
   99 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  100 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  101 J = P2/10
      A = P2 - 10*J
      K = BLANK
      IF (A .NE. 0) K = A
      JA = J/10
      B  = J - 10*JA
      UM = BLANK
      IF (B .NE. 0) UM = BCD(1)
      JB = JA/10
      C  = JA - 10*JB
      US = BLANK
      IF (C .NE. 0) US = BCD(2)
      JC = JB/10
      D  = JB - 10*JC
      UO = BLANK
      IF (D .NE. 0) UO = BCD(3)
      JD = JC/10
      E  = JC - 10*JD
      UR = BLANK
      IF (E .NE. 0) UR = BCD(4)
      JF = JD/10
      F  = JD - 10*JF
      UL = BLANK
      IF (F .NE. 0) UL = BCD(5)
      IF (A .EQ. 0) WRITE (OUTTAP,2011) UFM,P1,UM,US,UO,UR,UL
      IF (A .NE. 0) WRITE (OUTTAP,2010) UFM,P1,K,UM,US,UO,UR,UL
      GO TO 5500
  102 WRITE (OUTTAP,2020) UWM,P2,P1
      GO TO 5600
  103 WRITE (OUTTAP,2030) SFM
      GO TO 5500
  104 WRITE (OUTTAP,2040) UFM,P1
      GO TO 5500
  105 WRITE (OUTTAP,2050) UFM,P1,P2
      GO TO 5500
  106 WRITE (OUTTAP,2060) UFM,P1
      GO TO 5500
  107 WRITE (OUTTAP,2070) UFM,P1,P2
      GO TO 5500
  108 WRITE (OUTTAP,2080) UFM,P1,P2
      GO TO 5500
  109 WRITE (OUTTAP,2090) UFM
      GO TO 5500
  110 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  111 WRITE (OUTTAP,2110) UWM,P1
      GO TO 5600
  112 WRITE (OUTTAP,2120) UFM,P1
      GO TO 5500
  113 WRITE (OUTTAP,2130) UFM,P1
      GO TO 5500
  114 WRITE (OUTTAP,2140) UFM,P1
      GO TO 5500
  115 WRITE (OUTTAP,2150) UFM,P1,P2
      GO TO 5500
  116 WRITE (OUTTAP,2160) SFM,P2,P1
      GO TO 5500
  117 WRITE (OUTTAP,2170) UFM,P1
      GO TO 5500
  118 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  119 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  120 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  121 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  122 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  123 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  124 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  125 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  126 WRITE (OUTTAP,2260) UFM,P1
      GO TO 5500
  127 WRITE (OUTTAP,2270) SFM,P1
      GO TO 5500
  128 WRITE (OUTTAP,2280) SFM,P1
      GO TO 5500
  129 WRITE (OUTTAP,2290) SFM,P1
      GO TO 5500
  130 WRITE (OUTTAP,2300) UFM
      GO TO 5500
  131 WRITE (OUTTAP,2131) UFM,P1
      GO TO 5500
  132 WRITE (OUTTAP,2132) UFM
      GO TO 5500
  133 WRITE (OUTTAP,2133) UFM,P1
      GO TO 5500
  134 WRITE (OUTTAP,2134) UFM,P1
      GO TO 5500
  135 WRITE (OUTTAP,2135) UFM,P1,P2
      GO TO 5500
  136 WRITE (OUTTAP,2136) UFM,P1
      GO TO 5500
  137 WRITE (OUTTAP,2137) UFM,P1,P2
      GO TO 5500
  138 WRITE (OUTTAP,2138) UFM,P1
      GO TO 5500
  139 WRITE (OUTTAP,2139) UFM,P1,P2
      GO TO 5500
  140 WRITE (OUTTAP,2400) UFM,P1
      GO TO 5500
  141 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  142 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  143 WRITE (OUTTAP,2143) UFM,P1
      GO TO 5600
  144 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  145 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  146 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  147 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  148 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  149 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  150 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  151 INDEX = P2 / 100000000
      P2    = P2 - INDEX*100000000
      WRITE (OUTTAP,2510) UFM,P1,ICRIGD(INDEX),P2
      GO TO 5500
  152 WRITE (OUTTAP,2520) UFM
      GO TO 5500
  153 WRITE (OUTTAP,2530) UFM
      GO TO 5500
  154 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  155 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  156 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  157 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  158 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  159 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  160 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  161 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  162 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  163 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  164 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  165 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  166 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  167 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  168 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  169 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  170 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  171 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  172 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  173 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  174 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  175 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  176 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  177 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  178 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  179 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  180 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  181 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  182 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  183 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  184 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  185 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  186 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  187 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  188 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  189 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  190 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  191 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  192 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  193 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  194 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  195 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  196 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  197 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  198 WRITE (OUTTAP,2980) UFM,P1
      GO TO 5500
  199 WRITE (OUTTAP,2990) SFM,P1,P2
      GO TO 5500
  200 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  201 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  202 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  203 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  204 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  205 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  206 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  207 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  208 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  209 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  210 WRITE (OUTTAP,5000) L,P1,P2
      GO TO 5600
  211 WRITE (OUTTAP,3211) UFM,P1
      GO TO 5500
  212 WRITE (OUTTAP,3212) UFM,P1
      GO TO 5500
  213 WRITE (OUTTAP,3213) UFM,P1
      GO TO 5500
  214 WRITE (OUTTAP,3214) UFM,P2,P2,P1
      GO TO 5500
  215 WRITE (OUTTAP,3215) UFM,P1,P2
      GO TO 5500
  216 WRITE (OUTTAP,3216) UFM,P2,P2,P1
      GO TO 5500
  217 WRITE (OUTTAP,3217) UFM,P1
      GO TO 5500
  218 WRITE (OUTTAP,3218) UFM,P2,AX,P1
      GO TO 5500
  219 WRITE (OUTTAP,3219) UFM
      GO TO 5500
  220 WRITE (OUTTAP,3220) UIM,P1,P2
      GO TO 5600
  221 WRITE (OUTTAP,3218) UFM,P2,RG,P1
      GO TO 5500
  222 WRITE (OUTTAP,3222) UWM,P1,P2
      GO TO 5600
  223 WRITE (OUTTAP,3223) SFM,TRIA3,P1
      GO TO 5500
  224 WRITE (OUTTAP,3224) UFM,TRIA3,P1
      GO TO 5500
  225 WRITE (OUTTAP,3225) UFM,P2,TRIA3,P1
      GO TO 5500
  226 WRITE (OUTTAP,3226) UFM,P2,TRIA3,P1
      GO TO 5500
  227 WRITE (OUTTAP,3227) UFM,P2,TRIA3,P1
      GO TO 5500
  228 WRITE (OUTTAP,3228) SFM,TRIA3
      GO TO 5500
  229 WRITE (OUTTAP,3223) SFM,QUAD4,P1
      GO TO 5500
  230 WRITE (OUTTAP,3224) UFM,QUAD4,P1
      GO TO 5500
  231 WRITE (OUTTAP,3225) UFM,P2,QUAD4,P1
      GO TO 5500
  232 WRITE (OUTTAP,3226) UFM,P2,QUAD4,P1
      GO TO 5500
  233 WRITE (OUTTAP,3227) UFM,P2,QUAD4,P1
      GO TO 5500
  234 WRITE (OUTTAP,3228) SFM,QUAD4
      GO TO 5500
C
C
 1010 FORMAT (A23,' 2001, SEQGP CARD REFERENCES UNDEFINED GRID POINT',
     1       I9)
 1020 FORMAT (A25,' 2002, GRID POINT',I9,' NOT IN EQEXIN')
 1030 FORMAT (A23,' 2003, COORDINATE SYSTEM',I9,
     1       ' REFERENCES UNDEFINED GRID POINT',I9)
 1040 FORMAT (A23,' 2004, COORDINATE SYSTEM',I9,
     1       ' REFERENCES UNDEFINED COORDINATE SYSTEM',I9)
 1050 FORMAT (A25,' 2005, INCONSISTENT COORDINATE SYSTEM DEFINITION')
 1060 FORMAT (A23,' 2006, INTERNAL GRID POINT',I9,
     1       ' REFERENCES UNDEFINED COORDINATE SYSTEM',I9)
 1070 FORMAT (A23,' 2007, ELEMENT',I12,' REFERENCES UNDEFINED GRID ',
     1       'POINT',I12)
 1080 FORMAT (A23,' 2008, LOAD SET',I9,
     1       ' REFERENCES UNDEFINED GRID POINT',I9)
 1090 FORMAT (A23,' 2009, TEMP SET',I9,' REFERENCES UNDEFINED GRID ',
     1       'POINT',I9)
 1100 FORMAT (A23,' 2010, ELEMENT',I9,' REFERENCES UNDEFINED PROPERTY',
     1       I9)
 1110 FORMAT (A23,' 2011, NO PROPERTY CARD FOR ELEMENT TYPE - C',2A4)
 1120 FORMAT (A23,' 2012, GRID POINT',I9,' SAME AS SCALAR POINT')
 1130 FORMAT (A25,' 2013, NO STRUCTURAL ELEMENTS EXIST')
 1140 FORMAT (A23,' 2014, LOGIC ERROR IN ECPT CONSTRUCTION')
 1150 FORMAT (A25,' 2015, EITHER NO ELEMENTS CONNECTED TO ',A8,' GRID',
     1       ' POINT',I9, /5X,'OR IT IS CONNECTED TO A RIGID ELEMENT ',
     2       'OR A GENERAL ELEMENT.')
 1151 FORMAT (A25,' 2015, ',A8,' GRID PT.',I9,' NOT CONNECTED')
 1152 FORMAT (11X,':', /11X,':', /7X,'AND MORE')
 1153 FORMAT (1X)
 1160 FORMAT (A23,' 2016, NO MATERIAL PROPERTIES EXIST')
 1170 FORMAT (A23,' 2017, MATS1 CARD REFERENCES UNDEFINED MAT1',I9,
     1       ' CARD')
 1180 FORMAT (A23,' 2018, MATS2 CARD REFERENCES UNDEFINED MAT2',I9,
     1       ' CARD')
 1190 FORMAT (A23,' 2019, MATT1 CARD REFERENCES UNDEFINED MAT1',I9,
     1       ' CARD')
 1200 FORMAT (A23,' 2020, MATT2 CARD REFERENCES UNDEFINED MAT2',I9,
     1       ' CARD')
 1210 FORMAT (A23,' 2021, BAD GMMAT- CALLING SEQUENCE')
 1220 FORMAT (A23,' 2022, SMA-B SCALAR POINT INSERTION LOGIC ERROR')
 1230 FORMAT (A23,' 2023, DETCK UNABLE TO FIND PIVOT POINT',I9,
     1       ' IN GPCT')
 1240 FORMAT ('0*** UNDEFINED MESSAGE 2024')
 1250 FORMAT (A23,' 2025, UNDEFINED COORDINATE SYSTEM',I9)
 1260 FORMAT (A23,' 2026,ELEMENT',I9,' GEOMETRY YIELDS UNREASONABLE ',
     1       'MATRIX')
 1270 FORMAT (A23,' 2027,ELEMENT',I9,' HAS INTERIOR ANGLE GREATER THAN',
     1       ' 180 DEG. AT GRID POINT',I9)
 1280 FORMAT (A23,' 2028, SMA3A ERROR NO.',I9)
 1290 FORMAT (A23,' 2029, UNDEFINED TEMPERATURE SET',I9)
 1300 FORMAT (A23,' 2030, BAD GPTT')
 1310 FORMAT (A23,' 2031, ELEMENT',I9,' UNACCEPTABLE GEOMETRY')
 1320 FORMAT (A23,' 2032, ELEMENT',I9,' UNACCEPTABLE GEOMETRY')
 1330 FORMAT (A23,' 2033, SINGULAR H-MATRIX FOR ELEMENT',I9)
 1340 FORMAT (A25,' 2034, ELEMENT',I9,' SIL-S DO NOT MATCH PIVOT')
 1350 FORMAT (A23,' 2035, QUADRILATERAL',I9,
     1       ' INTERIOR ANGLE GREATER THAN 180 DEG.')
 1360 FORMAT (A23,' 2036, SINGULAR MATRIX FOR ELEMENT',I9)
 1370 FORMAT (A23,' 2037, BAD ELEMENT',I9,' GEOMETRY')
 1380 FORMAT (A25,' 2038, SINGULAR MATRIX FOR ELEMENT',I9)
 1390 FORMAT (A23,' 2039, ZERO SLANT LENGTH FOR HARMONIC',I9,
     1       ' OF CCONEAX',I9)
 1400 FORMAT (A23,' 2040, SINGULAR MATRIX FOR ELEMENT',I9)
 1410 FORMAT (A23,' 2041, A MATT1, MATT2, MATT3, OR MATS1 CARD REFER',
     1       'ENCES TABLE NUMBER',I9,' WHICH IS NOT DEFINED ON', /5X,
     2       'A TABLEM1, TABLEM2, TABLEM3, TABLEM4, OR TABLES1 CARD.')
 1420 FORMAT (A23,' 2042, MISSING MATERIAL TABLE',I9,' FOR ELEMENT',I9)
 1430 FORMAT (A23,' 2043, MISSING MATERIAL TABLE',I9)
 1440 FORMAT (A23,' 2044, UNDEFINED TEMPERATURE SET',I9)
 1450 FORMAT (A23,' 2045, TEMPERATURE UNDEFINED AT GRID POINT WITH ',
     1       'INTERNAL INDEX',I9)
 1460 FORMAT (A23,' 2046, UNDEFINED ELEMENT DEFORMATION SET',I9)
 1470 FORMAT (A23,' 2047, UNDEFINED MULTI-POINT CONSTRAINT SET',I9)
 1480 FORMAT (A23,' 2048, UNDEFINED GRID POINT',I9,
     1       ' IN MULTI-POINT CONSTRAINT SET',I9)
 1490 FORMAT (A23,' 2049, UNDEFINED GRID POINT',I9,
     1       ' REFERENCED ON AN ASET, ASET1, OMIT OR OMIT1 CARD.')
 1500 FORMAT (A23,' 2050, UNDEFINED GRID POINT',I9,
     1       ' HAS A SUPPORT COORDINATE')
 1510 FORMAT (A23,' 2051, UNDEFINED GRID POINT',I9,
     1       ' IN SINGLE-POINT CONSTRAINT SET',I9)
 1520 FORMAT (A23,' 2052, UNDEFINED GRID POINT',I9,
     1       ' IN SINGLE-POINT CONSTRAINT SET',I9)
 1530 FORMAT (A23,' 2053, UNDEFINED SINGLE-POINT CONSTRAINT SET',I9)
 1540 FORMAT (A23,' 2054, SUPER ELEMENT',I9,
     1       ' REFERENCES UNDEFINED SIMPLE ELEMENT',I9)
 1550 FORMAT (A25,' 2055')
 1560 FORMAT (A23,' 2056, UNDEFINED SUPER ELEMENT',I9,' PROPERTIES')
 1570 FORMAT (A23,' 2057, IRRATIONAL SUPER ELEMENT',I9,' TOPOLOGY')
 1580 FORMAT (A25,' 2058, ELEMENT',I9,' CONTRIBUTES TO THE DAMPING ',
     1       'MATRIX WHICH IS PURGED.  IT WILL BE IGNORED.')
 1590 FORMAT (A23,' 2059, UNDEFINED GRID POINT',I9,
     1       ' ON SE--BFE CARD FOR SUPER ELEMENT',I9)
 1600 FORMAT (A23,' 2060, UNDEFINED GRID POINT',I9,
     1       ' ON QDSEP CARD FOR SUPER ELEMENT',I9)
 1610 FORMAT (A23,' 2061, UNDEFINED GRID POINT',I9,' ON GENERAL ',
     1       'ELEMENT',I9)
 1620 FORMAT (A23,' 2062, UNDEFINED SUPER ELEMENT PROPERTY',I9,
     1       ' FOR SUPER ELEMENT',I9)
 1630 FORMAT (A23,' 2063, TA1C LOGIC ERROR')
 1640 FORMAT (A23,' 2064, UNDEFINED EXTRA POINT',I9,
     1       ' REFERENCED ON SEQEP CARD')
 1650 FORMAT (A23,' 2065, UNDEFINED GRID POINT',I9,' ON DMIG CARD')
 1660 FORMAT (A23,' 2066, UNDEFINED GRID POINT',I9,
     1       ' ON RLOAD- OR TLOAD- CARD')
 1670 FORMAT (A23,' 2067, UNDEFINED GRID POINT',I9,' IN NONLINEAR ',
     1       '(NOLIN',I1,') LOAD SET',I9)
 1680 FORMAT (A23,' 2068, UNDEFINED GRID POINT',I9,
     1       ' IN TRANSFER FUNCTION SET',I9)
 1690 FORMAT (A23,' 2069, UNDEFINED GRID POINT',I9,
     1       ' IN TRANSIENT INITIAL CONDITION SET',I9)
 1700 FORMAT (A23,' 2070, REQUESTED DMIG MATRIX ',2A4,' IS UNDEFINED.')
 1710 FORMAT (A23,' 2071, DYNAMIC LOAD SET',I9,' REFERENCES UNDEFINED ',
     1       2A4,' SET',I9)
 1720 FORMAT (A27,' 2072, CARD TYPE',I9,' NOT FOUND ON DATA BLOCK. ',
     1       ' BIT POSITION =',I4)
 1730 FORMAT (A29,' 2073, MPYAD METHOD',I9,' NO. PASSES =',I8)
 1740 FORMAT (A23,' 2074, UNDEFINED TRANSFER FUNCTION SET',I9)
 1750 FORMAT (A23,' 2075, IMPROPER KEYWORD ',2A4,
     1       ' FOR APPROACH PARAMETER IN DMAP INSTRUCTION.')
 1760 FORMAT (A25,' 2076, SDR2 OUTPUT DATA BLOCK NO. 1 IS PURGED')
 1770 FORMAT (A25,' 2077, SDR2 OUTPUT DATA BLOCK NO. 2 IS PURGED')
 1780 FORMAT (A25,' 2078, SDR2 OUTPUT DATA BLOCK NO. 3 IS PURGED')
 1790 FORMAT (A25,' 2079, SDR2 FINDS THE -EDT-, -EST-, OR -GPTT- ',
     1       'PURGED OR INADEQUATE AND IS THUS NOT PROCESSING', /5X,
     2       'ANY REQUESTS FOR STRESSES OR FORCES.')
 1800 FORMAT (A25,' 2080, SDR2 OUTPUT DATA BLOCK NO. 6 IS PURGED')
 1810 FORMAT (A23,' 2081, DIFFERENTIAL STIFFNESS CAPABILITY NOT ',
     1       'DEFINED FOR ANY OF THE ELEMENT TYPES IN THE PROBLEM.')
 1830 FORMAT (A23,' 2083, NULL DISPLACEMENT VECTOR')
 1840 FORMAT (A23,' 2084, DSMG2 LOGIC ERROR',I9)
 1850 FORMAT (A29,' 2085, ',A4,' SPILL, NPVT',I9)
 1860 FORMAT (A29,' 2086, SMA2 SPILL, NPVT',I9)
 1870 FORMAT (A25,' 2087, ECPT CONTAINS BAD DATA')
 1880 FORMAT (A23,' 2088, DUPLICATE TABLE ID',I9)
 1890 FORMAT (A23,' 2089, TABLE',I9,' UNDEFINED')
 1900 FORMAT (A25,' 2090, TABLE DICTIONARY ENTRY',I9,' MISSING')
 1910 FORMAT (A25,' 2091, PLA3, BAD ESTNL ELEMENT ID',I9)
 1920 FORMAT (A27,' 2092, SDR2 FINDS A SYMMETRY SEQUENCE LENGTH =',I20,
     1       /5X,'AND AN INSUFFICIENT NUMBER OF VECTORS AVAILABLE=',I21,
     2       ' WHILE ATTEMPTING TO COMPUTE STRESSES AND FORCES.', /5X,
     3       'ALL FURTHER STRESS AND FORCE COMPUTATION TERMINATED.')
 1930 FORMAT (A23,' 2093, NOLIN CARD FROM NOLIN SET',I9,
     1       ' REFERENCES GRID POINT',I9,' UD SET.')
 2010 FORMAT (A23,' 2101A, GRID POINT',I9,' COMPONENT',I2,
     1       ' ILLEGALLY DEFINED IN SETS',5(2X,A4))
 2011 FORMAT (A23,' 2101B, SCALAR POINT',I9,' ILLEGALLY DEFINED IN ',
     1       'SETS',5(2X,A4))
 2020 FORMAT (A25,' 2102, LEFT HAND MATRIX ROW POSITION',I9,
     1       ' OUT OF RANGE - IGNORED')
 2030 FORMAT (A25,' 2103, SUBROUTINE MAT WAS CALLED WITH INFLAG=2, THE',
     1       ' SINE OF THE ANGLE X', /5X,' MATERIAL ORIENTATION ANGLE,',
     2       ' NON-ZERO, BUT SIN(X)**2+COS(X)**2 DIFFERED FROM 1 IN ',
     3       'ABSOLUTE VALUE BY MORE THAN .0001')
 2040 FORMAT (A23,' 2104, UNDEFINED COORDINATE SYSTEM',I9)
 2050 FORMAT (A23,' 2105, PLOAD2 CARD FROM LOAD SET',I9,
     1       ' REFERENCES MISSING OR NON-2-D ELEMENT',I9)
 2060 FORMAT (A23,' 2106, LOAD CARD DEFINES NON-UNIQUE LOAD SET',I9)
 2070 FORMAT (A23,' 2107, EIG- CARD FROM SET',I9,
     1       ' REFERENCES DEPENDENT COORDINATE OF GRID POINT',I9)
 2080 FORMAT (A23,' 2108, SPCD ON A POINT NOT IN S SET. GRID',I9,
     1       ' COMP.',I9)
 2090 FORMAT (A23,' 2109, NO GRID, SCALAR OR EXTRA POINTS DEFINED')
 2110 FORMAT (A25,' 2111, BAR',I9,' COUPLED BENDING INERTIA SET TO 0.0',
     1       ' IN DIFFERENTIAL STIFFNESS')
 2120 FORMAT (A23,' 2112, UNDEFINED TABLE',I9)
 2130 FORMAT (A23,' 2113, MATERIAL',I9,', A NON-MAT1 TYPE, IS NOT ',
     1       'ALLOWED TO BE STRESS-DEPENDENT')
 2131 FORMAT (A23,' 2131, NON-SCALAR ELEMENT',I9,
     1       ' REFERENCES A SCALAR POINT.')
 2132 FORMAT (A23,' 2132, NON-ZERO SINGLE POINT CONSTRAINT VALUE ',
     1       'SPECIFIED BUT DATA BLOCK YS IS PURGED.')
 2133 FORMAT (A23,' 2133, INITIAL CONDITION IN SET',I9,
     1       ' SPECIFIED FOR POINT NOT IN ANALYSIS SET.')
 2134 FORMAT (A23,' 2134, LOAD SET',I9,' DEFINED FOR BOTH GRAVITY AND ',
     1       'NON-GRAVITY LOADS.')
 2135 FORMAT (A23,' 2135, DLOAD CARD',I9,' HAS A DUPLICATE SET ID FOR ',
     1       'SET ID',I9)
 2136 FORMAT (A23,' 2136, SET ID',I9,' HAS BEEN DUPLICATED ON A DLOAD,',
     1       ' RLOAD1,2 OR TLOAD1,2 CARD.')
 2137 FORMAT (A23,' 2137, PROGRAM RESTRICTION FOR MODULE ',A4,
     1       '.  ONLY 360 LOAD SET ID-S.', /5X,
     2       'ALLOWED.  DATA CONTAINS',I9,' LOAD SET ID-S.')
 2138 FORMAT (A23,' 2138, ELEMENT ID NO.',I9,' IS TOO LARGE')
 2139 FORMAT (A23,' 2139, ELEMENT',I9,' IN DEFORM SET',I9,
     1       ' IS UNDEFINED.')
 2140 FORMAT (A23,' 2114, MATT3 CARD REFERENCES UNDEFINED MAT3',I9,
     1       ' CARD')
 2143 FORMAT (A23,' 2143, SINGULAR JACOBIAN MATRIX FOR ISOPARAMETRIC ',
     1       'ELEMENT NO.',I9)
 2150 FORMAT (A23,' 2115, TABLE',I9,' (TYPE',I9,') ILLEGAL WITH STRESS',
     1       '-DEPENDENT MATERIAL')
 2160 FORMAT (A25,' 2116, MATID',I9,' TABLEID',I9)
 2170 FORMAT (A23,' 2117, TEMPERATURE DEPENDENT MATERIAL PROPERTIES ',
     1       'ARE NOT PERMISSIBLE', /5X,'IN A PIECEWISE LINEAR ',
     2       'ANALYSIS PROBLEM.  TEMPERATURE SET =',I9)
 2260 FORMAT (A23,' 2126, UNDEFINED MATERIAL FOR ELEMENT',I9)
 2270 FORMAT (A25,' 2127, PLA2 INPUT DATA BLOCK NO.',I9,' IS PURGED.')
 2280 FORMAT (A25,' 2128, PLA2 OUTPUT DATA BLOCK NO.',I9,' IS PURGED.')
 2290 FORMAT (A25,' 2129, PLA2, ZERO VECTOR ON APPENDED DATA BLOCK NO.',
     1       I9)
 2300 FORMAT (A23,' 2130, ZERO INCREMENTAL DISPLACEMENT VECTOR INPUT ',
     1       'TO MODULE PLA2.')
 2400 FORMAT (A23,' 2140, GRID OR SCALAR POINT ID',I9,', EXCEEDING MAX',
     1       ' OF 2140000, COULD BE FATAL')
 2510 FORMAT (A23,' 2192, UNDEFINED GRID POINT',I9,' IN RIGD',A1,
     1       ' ELEMENT',I9)
 2520 FORMAT (A23,' 2193, A REDUNDANT SET OF RIGID BODY MODES WAS ',
     1       'SPECIFIED FOR THE GENERAL ELEMENT')
 2530 FORMAT (A23,' 2194, A MATRIX D IS SINGULAR IN SUBROUTINE TA1CA')
 2980 FORMAT (A23,' 2198, INPUT DATA BLOCK',I9,' HAS BEEN PURGED.')
 2990 FORMAT (A25,' 2199, SUMMARY', /5X,'ONE OR MORE OF THE ABOVE ',
     1       'FATAL ERRORS WAS ENCOUNTERED IN SUBROUTINE ',2A4)
 3211 FORMAT (A23,' 2355, GRID POINT COORDINATES OF ELEMENT',I9,
     1       ' ARE IN ERROR.', /5X,
     2       'ONE OR MORE OF THE R-COORDINATES ARE ZERO OR NEGATIVE.')
 3212 FORMAT (A23,' 2364, GRID POINT COORDINATES OF ELEMENT',I9,
     1       ' ARE IN ERROR.', /5X,
     2       'ONE OR MORE OF THE THETA-COORDINATES ARE NONZERO.')
 3213 FORMAT (A23,' 2213, MATERIAL ID',I9,' NOT UNIQUELY DEFINED.')
 3214 FORMAT (A23,' 2214, MATT',I1,' CARD REFERENCES UNDEFINED MAT',I1,
     1       I9,' CARD')
 3215 FORMAT (A23,' 2215, UNDEFINED MATERIAL ID',I9,
     1       ' WAS REFERENCED BY PROPERTY CARD ID',I9)
 3216 FORMAT (A23,' 2216, MATPZT',I1,' CARD REFERENCES UNDEFINED MATPZ',
     1       I1,I9,' CARD')
 3217 FORMAT (A23,' 2217, MATPZ1 ID',I9,' HAS SINGULAR SE MATRIX.')
 3218 FORMAT (A23,' 2218, ',A4,A2,' ELEMENT',I9,
     1       ' HAS A MAXIMUM TO MINIMUM RADIUS RATIO EXCEEDING 10.',/5X,
     2       'ACCURACY OF NUMERICAL INTEGRATION WOULD BE IN DOUBT.')
 3219 FORMAT (A23,' 2219, MAT6 CARDS REQUIRE REPROCESSING. RE-SUBMIT ',
     1       'JOB WITH THE FOLLOWING DMAP ALTER (AFTER GP1)', //10X,
     2       'ANISOP  GEOM1,EPT,BGPDT,EQEXIN,MPT/MPTA/S,N,ISOP $', /10X,
     3       'EQUIV   MPTA,MPT/ISOP $',/)
 3220 FORMAT (A29,' 2220, NO APPLICABLE ELEMENT OR SUBCASE DURING OUT',
     1       'PUT SCAN', /5X,'EITHER NO VALUES OUTSIDE MAX-MIN RANGE ',
     2       'OR NOT IN SET SPECIFIED FOR ',2A4)
 3222 FORMAT (A25,' 2222, METHOD OF NORMALIZATION ON ',A4,' CARD NOT ',
     1       'SPECIFIED. DEFAULT OF ''',A4,''' WILL BE USED')
 3223 FORMAT (A25,' 3223 NO PCOMP, PCOMP1 OR PCOMP2 PROPERTY DATA ',
     1       'FOUND FOR ',A6,' ELEMENT ID =',I9)
 3224 FORMAT (A23,' 2224, ',A6,' ELEMENT ID =',I9,
     1       ' HAS ILLEGAL GEOMETRY OR CONNECTIONS')
 3225 FORMAT (A23,' 2225, THE X-AXIS OF THE MATERIAL COORDINATE SYSTEM',
     1       ' ID =',I9,' HAS NO PROJECTION ON TO THE PLANE OF THE',
     2       /5X,A6,' ELEMENT ID =',I9)
 3226 FORMAT (A23,' 2226, ILLEGAL DATA DETECTED ON MATERIAL ID =',I9,
     1       ' REFERENCED BY ',A6,' ELEMENT ID =',I9, /5X,
     2       'FOR MID3 APPLICATION')
 3227 FORMAT (A23,' 2228, THE X-AXIS OF THE STRESS COORDINATE SYSTEM ',
     1       'ID =',I9,' HAS NO PROJECTION ON TO THE PLANE OF THE', /5X,
     2       A6,' ELEMENT ID =',I9)
 3228 FORMAT (A25,' 3008, INSUFFICIENT MEMORY IS AVAIL ABLE FOR ',A6,
     1       ' ELEMENTS GENERATION.  RE-RUN JOB WITH AN ADDITIONAL',
     2       /5X,'2000 WORDS OF MEMORY')
C
 5000 FORMAT ('0*** UNASSIGNED MESSAGE (L=',I3,'), P1=',I20,', P2=',I9)
C
C     MESSAGE IS FATAL.
C     IF DIAG 1 IS ON, AND MACHINE IS VAX AND UNIX, CALL ERROR TRACEBACK
C
 5500 IF (MACH .LE. 4) GO TO 5600
      CALL SSWTCH (1,J)
      IF (J .EQ. 1) CALL ERRTRC ('USRWRT  ',L)
 5600 RETURN
C
C     ILLEGAL INPUT TO SUBROUTINE
C
 9000 WRITE  (OUTTAP,9001) L
 9001 FORMAT ('0IMPROPER USRMSG NO.',I20)
      CALL MESAGE (-7,0,NAME)
      RETURN
      END

      SUBROUTINE PTINTR (A,AA,B,BB,S,K,EPS)
C
C     RETURNS DOUBLE PRECISION VALUES OF X,Y COORDINATES (S) OF
C         POINT OF INTERSECTION (IF ANY) OF LINE SEGMENTS
C         FROM A TO AA AND B TO BB
C           A .NE. AA  AND  B .NE. BB
C     K IS CONDITION FLAG RETURNED --
C         K = 1   LINES INTERSECT AT S
C         K = 0   LINES INTERSECT AT S, AN ENDPOINT OF ONE LINE SEGMENT
C         K =-1   LINES DO NOT INTERSECT
C
      DOUBLE PRECISION A(2),AA(2),B(2),BB(2),P(2),S(2)
      DOUBLE PRECISION AX,AY,BX,BY,AAA,PA,PAA,BBB,PB,PBB
      DOUBLE PRECISION EPS(2),D
      DOUBLE PRECISION DIST,X,Y,U,V
C
C     EPS ARRAY FOR SIGNIFICANCE TESTING
C         EPS(1) IS AREA, ANGLE LIMIT
C         EPS(2) IS LENGTH LIMIT
C
C
C     DOUBLE PRECISION FUNCTION FOR DISTANCE BETWEEN 2 POINTS
C
      DIST(X,Y,U,V) = (X-U)**2 +(Y-V)**2
C
      X    = 0.D0
      Y    = X
      U    = X
      V    = X
      P(1) = 0.D0
      P(2) = 0.D0
      S(1) = 0.D0
      S(2) = 0.D0
C
      K  =-1
C
      AX = AA(1) - A(1)
      AY = AA(2) - A(2)
      BX = BB(1) - B(1)
      BY = BB(2) - B(2)
C
      AAA= AX**2 + AY**2
      BBB= BX**2 + BY**2
      D  = BX*AY - AX*BY
C
C     IS EITHER LINE TOO SHORT?
C
      IF (AAA.LE.EPS(1) .OR. BBB.LE.EPS(1)) RETURN
C
C     ARE A AND B PARALLEL?
C
      IF (DABS(D) .GT. EPS(1)) GO TO 80
C
C     A AND B ARE PARALLEL -- ARE THEY SAME LINE?
C
      P(1) = B(1)
      P(2) = B(2)
      IF (DIST(B(1),B(2), A(1), A(2)) .LE. EPS(1) .OR.
     1    DIST(B(1),B(2),AA(1),AA(2)) .LE. EPS(1)) GO TO 100
      P(1) = BB(1)
      P(2) = BB(2)
      IF (DIST(BB(1),BB(2), A(1), A(2)) .LE. EPS(1) .OR.
     1    DIST(BB(1),BB(2),AA(1),AA(2)) .LE. EPS(1)) GO TO 100
C
C     A PARALLEL TO B AND NOT SAME LINE
C
      RETURN
C
C     IS A PARALLEL TO Y AXIS?
C
   80 IF (DABS(AX) .GT. EPS(2)) GO TO 90
      P(1) = A(1)
      P(2) = B(2) + (P(1)-B(1))*BY/BX
      GO TO 100
   90 P(1) = ((B(2)-A(2))*AX*BX + A(1)*AY*BX-B(1)*AX*BY)/D
      P(2) =  A(2) + (P(1)-A(1))*AY/AX
C
  100 AAA = AAA + EPS(1)
      BBB = BBB + EPS(1)
      PA  = DIST(P(1),P(2), A(1), A(2))
      PB  = DIST(P(1),P(2), B(1), B(2))
      PAA = DIST(P(1),P(2),AA(1),AA(2))
      PBB = DIST(P(1),P(2),BB(1),BB(2))
C
C     POINT OF INTERSECTION NOT ON EITHER SEGMENT
C
      IF (PA.GT.AAA .OR. PAA.GT.AAA .OR. PB.GT.BBB .OR. PBB.GT.BBB)
     1    RETURN
C
C     LINES INTERSECT AT P
C
      K    = 1
      S(1) = P(1)
      S(2) = P(2)
C
C     LINES INTERSECT AT P, AN ENDPOINT OF ONE SEGMENT
C
      IF ((PA.LT.EPS(2) .OR. PAA.LT.EPS(2)) .OR.
     1    (PB.LT.EPS(2) .OR. PBB.LT.EPS(2))) K= 0
      RETURN
      END

      SUBROUTINE QRITER1 (VAL,O,LOC,QR)
C
C     ORTEGA-KAISER QR ITERATION FOR A LARGE TRIDIAGONAL MATRIX
C
      INTEGER          LOC(1),QR,SYSBUF,MSG(10)
      REAL             LFREQ
      REAL             VAL(1),O(1),SHIFT,ZERO,ONE,ONES,EPSI,G,R,S,T,U,
     1                 DLMDAS
      CHARACTER*5      BELOW,ABOVE,BELABV
      CHARACTER        UFM*23,UWM*25,UIM*29
      COMMON /XMSSG /  UFM,UWM,UIM
CWKBR 2/94 SPR93027      COMMON /SYSTEM/  SYSBUF,NOUT  
      COMMON /SYSTEM/  SYSBUF,NOUT, IDUM(52), IPREC  
      COMMON /GIVN  /  IDUM0(100),N,LFREQ,IDUM3,IDUM4,HFREQ,LAMA,NV,
     1                 NE,IDUM9,NFOUND,IDUM11,IDUM12,IDUM13,NEVER,MAX
      COMMON /REIGKR/  IOPTN
      COMMON /MGIVXX/  DLMDAS
      DATA    EPSI  ,  ZERO,ONE,MSG/ 1.0D-10, 0.0D+0, 1.0D+0, 53,9*0 /
      DATA    MGIV  ,  BELOW,ABOVE / 4HMGIV, 'BELOW', 'ABOVE'        /
C
C     VAL    = DIAGONAL TERMS OF THE TRIDIAGONAL.
C              REORDERED EIGENVALUES UPON RETURN.
C     O      = SQUARE OF THE OFF-DIAGIONAL TERMS OF THE TRIDIAGONAL.
C     LOC    = ORIGINAL LOCATIONS OF THE REORDERED EIGENVALUES.
C     QR     = 1 MEANS  VAL= EIGENVALUES--JUST REORDER THEM
C     N      = ORDER OF THE PROBLEM = ALSO NO. OF FREQ. EXTRACTED
C     MAX    = MAXIMUM NUMBER OF ITERATIONS
C     SHIFT  = SHIFT FACTOR (SMALLEST DIAGONAL TERM
C     LFREQ  , HFREQ = FREQ. RANGE OF INTEREST IF NV IS ZERO
C     NV     = NUMBER OF EIGENVECTORS TO BE COMPUTED, SAVED AND OUTPUT.
C              IF NV IS ZERO (INPUT), AND LFREQ-HFREQ ARE PRESENT, NV IS
C              SET TO BE NO. OF MODES WITHIN THE FREQ. RANGE (OUTPUT)
C     NE     = NO. OF EIGENVALUES (INCLUDING RIGID MODES) TO BE PRINTED.
C              ALL, IF NE IS NOT SPECIFIED.
C              IF NE .LT. NV, NE IS SET EQUAL TO NV
C
      MAX = 100*N
      IF (NV .GT.  N) NV = N
      IF (NE .EQ.  0) NE = N
      IF (NE .LT. NV) NE = NV
C
C     IS THIS AN ORDERING ONLY CALL
C
      NEVER = 0
      IF (QR .NE. 0) GO TO 150
C
C     SEARCH FOR A DECOUPLED SUBMATRIX.
C
      M2 = N
  100 M2M1 = M2 - 1
      DO 101 K = 1,M2M1
      M1 = M2 - K
      IF (O(M1) .NE. ZERO) GO TO 102
  101 CONTINUE
C
C     ALL OFF-DIAGONAL TERMS ARE ZEROS, JOB DONE. GO TO 150
C     THE DIAGONALS CONTAIN THE EIGENVALUES.
C
      GO TO 150
C
C     DECOUPLED SUBMATRIX
C
  102 M2M1 = M1
      M2   = M1 + 1
      IF (M2M1 .EQ. 1) GO TO 105
      DO 103 K = 2,M2M1
      M1 = M2 - K
      IF (O(M1) .EQ. ZERO) GO TO 104
  103 CONTINUE
      GO TO 105
  104 M1 = M1 + 1
  105 MM = M1
C
C     Q-R ITERATION FOR THE DECOUPLED SUBMATRIX
C
  110 DO 135 ITER = 1,MAX
      IF (ABS(VAL(M2))+O(M2M1) .EQ. ABS(VAL(M2))) GO TO 140
      DO 111 K = M1,M2M1
      IF (VAL(K) .NE. VAL(K+1)) GO TO 115
  111 CONTINUE
      SHIFT = ZERO
      GO TO 120
C
C     FIND THE SMALLEST DIAGONAL TERM = SHIFT
C
  115 SHIFT = VAL(M2)
      DO 116 I = M1,M2M1
      IF (ABS(VAL(I)) .LT. ABS(SHIFT)) SHIFT = VAL(I)
  116 CONTINUE
C
C     REDUCE ALL TERMS BY SHIFT
C
      DO 117  I = M1,M2
      VAL(I) = VAL(I) - SHIFT
  117 CONTINUE
C
C     Q-R ITERATION
C
  120 R = VAL(M1)**2
      S = O(M1)/(R+O(M1))
      T = ZERO
      U = S*(VAL(M1) + VAL(M1+1))
      VAL(M1) = VAL(M1) + U
      IF (M1 .EQ. M2M1) GO TO 125
      M1P1 = M1 + 1
      DO 123 I = M1P1,M2M1
      G = VAL(I) - U
      R = (ONE-T)*O(I-1)
      ONES = ONE - S
      IF (ABS(ONES) .GT. EPSI) R = G*G/ONES
      R = R + O(I)
      O(I-1) = S*R
      IF (O(I-1) .EQ. ZERO) MM = I
      T = S
C
C     IBM MAY FLAG AN EXPONENT UNDERFLOW ON NEXT LINE.
C     IT IS PERFECTLY OK SINCE O(I) SHOULD BE APPROACHING ZERO.
C
      S = O(I)/R
      U = S*(G + VAL(I+1))
      VAL(I) = U + G
  123 CONTINUE
C
  125 VAL(M2) = VAL(M2) - U
      R = (ONE-T)*O(M2M1)
      ONES = ONE - S
      IF (ABS(ONES) .GT. EPSI) R = VAL(M2)**2/ONES
      O(M2M1) = S*R
C
C     SHIFT BACK
C
      IF (SHIFT .EQ. ZERO) GO TO 133
      DO 130 I = M1,M2
      VAL(I) = VAL(I) + SHIFT
  130 CONTINUE
  133 M1 = MM
  135 CONTINUE
C
C     TOO MANY ITERATIONS
C
C
C     THE ACCURACY OF EIGENVALUE  XXXXX  IS IN DOUBT--QRITER FAILED TO
C     CONVERGE IN  XX  ITERATIONS
C
      NEVER = NEVER + 1
      CALL MESAGE (MSG(1),VAL(M2),MAX)
C
C     CONVERGENCE ACHIEVED
C
  140 IF (M1 .EQ. M2M1) GO TO 145
      M2   = M2M1
      M2M1 = M2 -1
      GO TO 110
  145 IF (M1 .LE. 2) GO TO 150
      M2 = M1 - 1
      GO TO 100
  150 IF (N .EQ. 1) GO TO 205
C
C     REORDER EIGENVALUES ALGEBRAICALLY IN ASCENDING ORDER
C
      IF (IOPTN .NE. MGIV) GO TO 155
C
C     FOR MGIV METHOD, RECOMPUTE LAMBDA
C
      DO 153 K = 1,N
      VAL(K) = (1.0/VAL(K)) - DLMDAS
  153 CONTINUE
  155 CONTINUE
      DO 190 K = 1,N
      DO 160 M = 1,N
      IF (VAL(M) .NE. -10000.0) GO TO 170
  160 CONTINUE
  170 IF (M .EQ. N) GO TO 185
      MP1 = M + 1
      DO 180 I = MP1,N
      IF (VAL(I) .EQ. -10000.0) GO TO 180
      IF (VAL(M) .GT. VAL(I)) M = I
  180 CONTINUE
  185 O(K)   = VAL(M)
      VAL(M) =-10000.0
      LOC(K) = M
  190 CONTINUE
      DO 195 I = 1,N
      VAL(I) = O(I)
  195 CONTINUE
C
C     IF RIGID MODES WERE FOUND BEFORE, REPLACE RIGID FREQ. BY ZERO
C
      IF (NFOUND .EQ. 0) GO TO 205
      DO 200 I = 1,NFOUND
      VAL(I) = ZERO
  200 CONTINUE
C
C     OUTPUT OPTION CHECK - BY FREQ. RANGE OR BY NO. OF FREQ.
C     REQUESTED
C
  205 IB    = 1
      IF (NV .NE. 0) GO TO 225
      IF (LFREQ .LE. 0.0) GO TO 225
C
C     LOCATE PONTER THAT POINTS TO EIGENVALUE ABOVE OR EQUAL THE
C     LOWEST LFREQ. AS REQUESTED.
C
      DO 215 I = 1,N
      IF (VAL(I) .GE. LFREQ) GO TO 220
  215 CONTINUE
      I  = 0
  220 IB = I
C
C     OPEN LAMA FOR OUTPUT
C     PUT EIGENVALUES ON LAMA FOLLOWED BY ORDER FOUND
C
CWKBR 2/94 SPR93027  225 IBUF1 = (KORSZ(O)-SYSBUF+1)/2   
  225 IBUF1 = (KORSZ(O)-SYSBUF+1)/IPREC  
      CALL GOPEN (LAMA,O(IBUF1),1)
      NN = 0
      IF (IB .EQ. 0) GO TO 240
      DO 230 I = IB,N
      VALX = VAL(I)
      IF (NV.NE.0 .AND.    I.GT.   NE) GO TO 240
      IF (NV.EQ.0 .AND. VALX.GT.HFREQ) GO TO 240
      CALL WRITE (LAMA,VALX,1,0)
      NN = NN + 1
  230 CONTINUE
C
  240 CONTINUE
C
C     IF FREQ. RANGE IS REQUESTED, AND ALL FREQ. FOUND ARE OUTSIDE THE
C     RANGE, OUTPUT AT LEAST ONE FREQ.
C
      IF (NN .GT. 0) GO TO 260
      IF (IB .EQ. 0) BELABV = BELOW
      IF (IB .NE. 0) BELABV = ABOVE
      WRITE (NOUT,250) UIM,BELABV
  250 FORMAT (A29,', ALL ROOTS FOUND WERE ',A5,' FREQ. RANGE SPECIFIED',
     1       /5X,'HOWEVER, ONE EIGENVALUE OUTSIDE THIS FREQ. RANGE WAS',
     2       ' SAVED AND PRINTED')
      NN = 1
      IF (IB .NE. 0) IB = N
      IF (IB .EQ. 0) IB = 1
      CALL WRITE (LAMA,VAL(IB),1,0)
  260 CALL WRITE (LAMA,0,0,1)
      CALL WRITE (LAMA,LOC(IB),NN,1)
      CALL CLOSE (LAMA,1)
      MSG(2) = LAMA
      MSG(3) = NN
      CALL WRTTRL (MSG(2))
C
C     IF FREQ. DOES NOT START FROM FIRST FUNDAMENTAL MODE, ADJUST VAL
C     AND LOC TABLES SO THAT WILVEC WILL PICK UP FREQUENCIES CORRECTLY
C
      IF (IB .LE. 1) GO TO 280
      J = 1
      DO 270 I = IB,N
      VAL(J) = VAL(I)
      LOC(J) = LOC(I)
  270 J = J + 1
C
  280 IF (NV.EQ.0 .AND. IB.GT.1 .AND. NN.LT.NFOUND .AND. VAL(1).LE.ZERO)
     1    NFOUND = 0
      IF (NV .EQ. 0) NV = NN
      RETURN
      END

      SUBROUTINE FVRST1
C
C
C    1. ENTRY POINT - FVRST1
C
C    2. PURPOSE -  THIS MODULE IS USED FOR FORCED VIBRATION RESPONSE
C                  ANALYSIS OF ROTATING CYCLIC STRUCTURES.
C                  FVRSTR1 GENERATES DATA BLOCKS FRLX, B1GG, M1GG,
C                  M2GG, BASEXG AND PDZERO. IT ALSO COMPUTES PARAMETERS
C                  FKMAX AND NOBASEX.
C
C    3. DMAP CALLING SEQUENCE -
C
C         FVRSTR1  CASECC,BGPDT,CSTM,DIT,FRL,MGG,, / FRLX,B1GG,M1GG,
C                  M2GG,BASEXG,PDZERO,, /V,N,NOMGG/V,Y,CYCIO/V,Y,NSEGS/
C                  V,Y,KMAX/V,N,FKMAX/V,Y,BXTID=-1/V,Y,BXPTID=-1/
C                  V,Y,BYTID=-1/V,Y,BYPTID=-1/V,Y,BZTID=-1/
C                  V,Y,BZPTID=-1/V,N,NOBASEX/V,N,NOFREQ/V,N,OMEGA  $
C
C    4. INPUT DATA BLOCKS -
C
C         CASECC - CASE CONTROL
C         BGPDT  - BASIC GRID POINT DEFINITION TABLE.
C         CSTM   - COORDINATE SYSTEM TRANSFORMATION MATRICES.
C         DIT    - DIRECT INPUT TABLES.
C         FRL    - FREQUENCY RESPONSE LIST. (FREQUENCIES IN RADIANS)
C         MGG    - GLOBAL MASS MATRIX (G-SET).
C
C         NOTE   - (1) ALL INPUT DATA BLOCKS CAN BE PURGED IF ONLY
C                      PARAMETERS FKMAX AND NOBASEX ARE TO BE COMPUTED.
C                  (2) CASECC, DIT AND FRL CAN BE PURGED IF FRLX AND
C                      BASEXG ARE PURGED.
C
C    5. OUTPUT DATA BLOCKS -
C
C         FRLX    - FREQUENCY RESPONSE LIST (MODIFIED).
C         B1GG    - CORIOLIS ACCELERATION COEFFICIENT MATRIX (G-SET).
C         M1GG    - CENTRIPETAL ACCELERATION COEFFICIENT MATRIX (G-SET).
C         M2GG    - BASE ACCELERATION COEFFICIENT MATRIX (G-SET).
C         BASEXG  - BASE ACCELERATION MATRIX (G-SET).
C         PDZERO  - LOAD MODIFICATION MATRIX IN BASE ACCELERATION
C                   PROBLEMS.
C
C         NOTE    - (1) ALL OUTPUT DATA BLOCKS CAN BE PURGED IF
C                       PARAMETER NOMGG =-1.
C                   (2) B1GG AND M1GG CAN BE PURGED IF NOMGG =-1 OR
C                       IF OMEGA = 0.0.
C                   (3) FRLX AND PDZERO CAN BE PURGED IF OMEGA = 0.0.
C                   (4) FRLX, PDZERO, M2GG AND BASEXG CAN BE PURGED
C                       IF NOMGG =-1 OR NOFREQ =-1 OR CYCIO =+1 OR IF
C                       ALL PARAMETERS BXTID = BXPTID = BYTID =-1.
C
C    6. PARAMETERS -
C
C        (A) NOMGG   - INPUT-INTEGER-NO DEFAULT.  MASS MATRIX WAS NOT
C                      GENERATED IF NOMGG =-1.
C        (B) CYCIO   - INPUT-INTEGER-NO DEFAULT.  THE INTEGER VALUE
C                      OF THIS PARAMETER SPECIFIES THE FORM OF THE INPUT
C                      AND OUTPUT DATA FOR CYCLIC STRUCTURES. A VALUE
C                      OF +1 IS USED TO SPECIFY PHYSICAL SEGMENT REPRE-
C                      SENTATION AND A VALUE OF -1 FOR CYCLIC TRANSFOR-
C                      MATION REPRESENTATION.
C        (C) NSEGS   - INPUT-INTEGER-NO DEFAULT.  THE NUMBER OF
C                      IDENTICAL SEGMENTS IN THE STRUCTURAL MODEL.
C        (D) KMAX    - INPUT-INTEGER-NO DEFAULT.  THE INTEGER VALUE
C                      OF THIS PARAMETER SPECIFIES THE MAXIMUM VALUE
C                      OF THE HARMONIC INDEX.THE MAXIMUM VALUE OF
C                      KMAX IS NSEGS/2.
C        (E) FKMAX   - OUTPUT-INTEGER-NO DEFAULT.  FUNCTION OF KMAX.
C        (F) BXTID   - INPUT -INTEGER-DEFAULTS.  THE VALUES OF THESE
C        (G) BYTID     PARAMETERS DEFINE THE SET IDENTIFICATION NUMBERS
C        (H) BZTID     OF THE TABLEDI BULK DATA CARDS WHICH DEFINE THE
C        (I) BXPTID    COMPONENTS OF THE BASE ACCELERATION VECTOR. THE
C        (J) BYPTID    TABLES REFERED TO BY BXTID, BYTID AND BZTID
C        (K) BZPTID    DEFINE MAGNITUDE(LT-2) AND THE TABLES REFERED TO
C                      BY BXPTID, BYPTID AND BZPTID DEFINE PHASE(DEGREE)
C                      THE DEFAULT VALUES ARE -1 WHICH MEANS THAT THE
C                      RESPECTIVE TERMS ARE IGNORED.
C        (L) NOBASEX - OUTPUT-INTEGER-NO DEFAULT.  NOBASEX =-1 IF DATA
C                      BLOCK BASEXG IS NOT GENERATED.
C        (M) NOFREQ  - INPUT-INTEGER-NO DEFAULT. NOFREQ =-1 IF FREQUENCY
C                      WAS NOT SELECTED IN THE CASE CONTROL DECK.
C        (N) OMEGA   - INPUT-REAL-NO DEFAULT.  ROTATIONAL SPEED OF THE
C                      STRUCTURE IN RADIANS. OMEGA = 2*PI*RPS.
C
C    7. METHOD -  SEE FUNCTIONAL MODULE DESCRIPTION.
C
C    8. SUBROUTINES - FVRST1 CALLS ROUTINES FVRS1A, FVRS1B, FVRS1C,
C                     FVRS1D, FVRS1E, GMMATD, PRETRD, TRANSD, PRETAB,
C                     TAB AND OTHER STANDARD NASTRAN UTILITY ROUTINES.
C                     GINO ROUTINES.
C
C    9. DESIGN REQUIREMENTS -
C
C         (1) OPEN CORE IS DEFINED AT /ZZFVR1/.
C         (2) NO SCRATCH FILES ARE USED.
C         (3) FVRST1 RESIDES IN LINKNS07
C         (4) OPEN CORE FOR 5 BUFFERS PLUS 14*NCSTM  PLUS NTYPE*NROW OF
C             MGG IS REQUIRED.
C
C          NOTE - (1) NTYPE = 1 IF MGG IS REAL SP
C                     NTYPE = 2 IF MGG IS REAL DP
C
C   10. DIAGNOSTIC MESSAGES -
C
C         THE FOLLOWING MESSAGES MAY BE ISSUED - 3001,3002,3003,3008
C                                                AND 3031.
C
C
      LOGICAL         MODFRL
      INTEGER         CASECC,BGPDT,CSTM,DIT,FRL,FRLX,B1GG,BASEXG,PDZERO,
     1                CYCIO,FKMAX,BXTID,BXPTID,BYTID,BYPTID,BZTID,
     2                BZPTID,ITLIST(13),ITID(6),FRQSET,CASE(14)
      DOUBLE PRECISION Z,A(3,3),B(3,3),C(3,3),ROW(3),TA(3,3),AVGM,
     1                DPI,DTWOPI,DRADEG,DDEGRA,D4PISQ
      DIMENSION       MCBB1(7),MCBM1(7),MCBM2(7),MCB(7),COORD(4),
     1                MODNAM(3),ZS(1),IZ(1),MCB1(7),MCB2(7),ROW2(3)
      COMMON /BLANK / NOMGG,CYCIO,NSEGS,KMAX,FKMAX,BXTID,BXPTID,
     1                BYTID,BYPTID,BZTID,BZPTID,NOBASX,NOFREQ,OMEGA
      COMMON /ZZZZZZ/ Z(1)
      COMMON /SYSTEM/ NBUF,NOUT,NERR
      COMMON /UNPAKX/ IN1,NF1,NL1,INCR
      COMMON /PACKX / IN,IOUT,NF,NL,INCR1
      COMMON /CONDAD/ DPI,DTWOPI,DRADEG,DDEGRA,D4PISQ
      EQUIVALENCE     (COORD(1),NCRD),(Z(1),ZS(1)),(Z(1),IZ(1)),
     1                (MCB(1),MCB1(1)),(MCBM1(1),MCB2(1)),
     2                (ITID(1),BXTID)
      DATA    CASECC, BGPDT, CSTM, DIT, FRL, MGG     /
     1        101,    102,   103,  104, 105, 106     /
      DATA    FRLX, B1GG, M1GG, M2GG, BASEXG, PDZERO /
     1        201,  202,  203,  204,  205   , 206    /
      DATA    MODNAM / 4HFRL ,  4HFVRS,4HTR1         /
      DATA    ITLIST / 4,  1105,11,1, 1205,12,2, 1305,13,3, 1405,14,4 /
C     LOCATE  CODES FOR -  TABLED1    TABLED2    TABLED3    TABLED4
C
C     CALCULATE PARAMETERS
C
C     TEST TO SEE IF BASEXG IS TO BE GENERATED.
C
      NOBASX = -1
      IF (NOMGG.EQ.-1 .OR.  CYCIO.NE.-1 .OR. NOFREQ.EQ.-1) GO TO 10
      IF (BXTID.EQ.-1 .AND. BYTID.EQ.-1 .AND. BZTID.EQ.-1) GO TO 10
      NOBASX =  1
  10  CONTINUE
C
      IF (CYCIO .NE. -1) GO TO 25
C
C     DETERMINE FKMAX
C
      IF (MOD(NSEGS,2) .NE. 0) GO TO 23
      IF (KMAX .EQ. NSEGS/2) GO TO 24
  23  FKMAX = 2*KMAX + 1
      GO TO 25
  24  FKMAX = NSEGS
C
C     TEST TO SEE IF ANY DATA BLOCKS ARE TO BE GENERATED.
C
  25  IF (NOMGG .EQ. -1) GO TO 1000
      IF (OMEGA.EQ.0.0 .AND. (CYCIO.NE.-1 .OR. NOFREQ.EQ.-1) .AND.
     1   (BXTID.EQ.-1 .AND. BYTID.EQ.-1 .AND. BZTID.EQ.-1)) GO TO 1000
C
C     TEST TRAILER OF MGG TO SEE IF PURGED
C
      MCB(1) = MGG
      CALL RDTRL (MCB)
      NFILE = MGG
      IF (MCB(1) .LE. 0) GO TO 902
C
C     COLUMN COUNT FOR MGG READ CHECK
C
      NCOLC = MCB(2)
      NROWC = MCB(3)
      NFORM = MCB(4)
      NTYPE = MCB(5)
C
      NZ = KORSZ(Z)
C
C     ALLOCATE BUFFERS
C
C     MGG,CSTM (IBUF1 IS NBUF+1 LONG)
C
      IBUF1 = NZ - NBUF
C
C     BGPDT
C
      IBUF2 = IBUF1 - NBUF
C
C     B1GG
C
      IBUF3 = IBUF2 - NBUF
C
C     M1GG
C
      IBUF4 = IBUF3 - NBUF
C
C     M2GG
C
      IBUF5 = IBUF4 - NBUF
      IF (OMEGA .EQ. 0.0) IBUF5 = IBUF3
C
C     CALCULATE LENGTH OF OPEN CORE
C
      NZ = IBUF5 - 1
C
C     PROCESS CSTM DATA BLOCK
C
      NFILE  = CSTM
      MCB(1) = CSTM
      CALL RDTRL (MCB)
      IF (MCB(1) .LE. 0) GO TO 61
C
C     NO. OF COORDINATE SYSTEMS
C
      NCSYM = MCB(3)
      LCSTM = 14*NCSYM
C
C     CSTM TABLE
C
      ICSTM = IBUF5 - LCSTM
      NZ    = ICSTM - 1
C
C     CORE FOR ENOUGH CORE FOR CSTM
C
      IF (NZ .LT. 0) GO TO 901
C
C     CORE CHECK FULL COLUMN OF MGG READ ASSUMED
C
      IF (NZ-NTYPE*NROWC .LT. 0) GO TO 901
      CALL GOPEN (CSTM,ZS(IBUF1),0)
      CALL READ (*903,*904,CSTM,ZS(ICSTM),LCSTM,1,NWDS)
      CALL PRETRD (ZS(ICSTM),LCSTM)
      CALL CLOSE (CSTM,1)
      GO TO 64
C
C     CORE CHECK NO CSTM
C
  61  IF (NZ-NTYPE*NROWC .LT. 0) GO TO 901
  64  CONTINUE
C
C     BGPDT TABLE
C
      MCB(1) = BGPDT
      CALL RDTRL (MCB)
      NFILE = BGPDT
      IF (MCB(1) .LE. 0) GO TO 902
C
C     NO. OF GRID POINTS AND SCALAR POINTS READ CHECK FOR BGPDT
C
      NGRID = MCB(2)
      CALL GOPEN (BGPDT,ZS(IBUF2),0)
C
C     OPEN MGG AND OUTPUT MATRICES
C
      CALL GOPEN (MGG,ZS(IBUF1),0)
      IF (OMEGA .EQ. 0.0) GO TO 65
      CALL GOPEN (B1GG,ZS(IBUF3),1)
      MCBB1(1) = B1GG
      MCBB1(2) = 0
      MCBB1(3) = NROWC
      MCBB1(4) = 1
      MCBB1(5) = NTYPE
      MCBB1(6) = 0
      MCBB1(7) = 0
      CALL GOPEN (M1GG,ZS(IBUF4),1)
      MCBM1(1) = M1GG
      MCBM1(2) = 0
      MCBM1(3) = NROWC
      MCBM1(4) = NFORM
      MCBM1(5) = NTYPE
      MCBM1(6) = 0
      MCBM1(7) = 0
  65  IF (NOBASX .EQ. -1) GO TO 66
      CALL GOPEN (M2GG,ZS(IBUF5),1)
      MCBM2(1) = M2GG
      MCBM2(2) = 0
      MCBM2(3) = NROWC
      MCBM2(4) = 1
      MCBM2(5) = NTYPE
      MCBM2(6) = 0
      MCBM2(7) = 0
C
C     SET UP PACK AND UNPACK TERMS
C
  66  IN1  = NTYPE
      IN   = 2
      IOUT = NTYPE
      INCR = 1
      INCR1= 1
C
C     READ INTERNAL SORT BGPDT PICK UP CID,X,Y,Z
C
      NDOF = 0
  70  CALL READ (*903,*800,BGPDT,COORD,4,0,M)
      NDOF = NDOF + 1
      IF (NCRD .NE. -1) GO TO 79
C
C     SCALAR POINT-UNPACK ONE COL OF MGG
C     SAVE DIAGONAL TERM
C
      NF1  = 0
      CALL UNPACK (*76,MGG,Z)
      NROW = NDOF - NF1 + 1
      NTERM= NL1 - NF1 + 1
      IF (NROW.LT.1 .OR. NROW.GT.NTERM) GO TO 76
      IF (NTYPE .EQ. 1) ROW(1) = ZS(NROW)
      IF (NTYPE .EQ. 2) ROW(1) = Z(NROW)
      NF = NDOF
      NL = NDOF
      GO TO 77
C
C     OUT OF RANGE OF NON-ZERO BAND
C
  76  ROW(1) = 0.0
      NF = 1
      NL = 1
C
C     NOW PUT DIAGONAL ELEMENT INTO OUTPUT MATRICES
C
  77  IF (OMEGA .EQ. 0.0) GO TO 78
      CALL PACK (ROW,M1GG,MCBM1)
      CALL PACK (ROW,B1GG,MCBB1)
  78  IF (NOBASX .EQ. -1) GO TO 70
      CALL PACK (ROW,M2GG,MCBM2)
      GO TO 70
C
C     UNPACK 3 COL OF MGG AND SAVE DIAGONAL TERMS
C
  79  DO 80 I = 1,3
      DO 80 J = 1,3
  80  A(I,J) = 0.0
      DO 100 I = 1,3
      NF1 = 0
      CALL UNPACK (*95,MGG,Z)
C
C     LOCATE DIAGONAL ELEMENT IN COL-NROW
C
      NROW  = NDOF - NF1 + I
      NTERM = NL1  - NF1 + 1
      IF (NROW.LT.1 .OR. NROW.GT.NTERM) GO TO 95
      IF (NTYPE .EQ. 1) A(I,I) = ZS(NROW)
      IF (NTYPE .EQ. 2) A(I,I) = Z(NROW)
      GO TO 100
C
C     OUT OF RANGE OF NON-ZERO ELEMENT BAND
C
  95  A(I,I) = 0.0
 100  CONTINUE
C
C     NOW TRANSFORM FROM LOCAL(GLOBAL) TO BASIC
C
      IF (NCRD .NE. 0) GO TO 150
C
C     ALREADY IN BASIC COORDINATES
C
      AVGM = (A(1,1) + A(2,2) + A(3,3))/3.0
      GO TO 161
C
C     SELECT TRANSFORMATION MATRIX-TA
C
 150  CALL TRANSD (COORD,TA)
      CALL GMMATD (TA,3,3,0,A,3,3,0,B)
      CALL GMMATD (B,3,3,0,TA,3,3,1,C)
C
C     C-IS NOW IN BASIC COORDINATES-ROW,WISE
C
      AVGM = (C(1,1) + C(2,2) + C(3,3))/3.0
C
 161  IF (OMEGA .EQ. 0.0) GO TO 307
C
C     PROCESS M1GG
C
      DO 162 I = 1,3
      DO 162 J = 1,3
 162  A(I,J) = 0.0
      A(2,2) = AVGM
      A(3,3) = AVGM
      IF (NCRD .NE. 0) GO TO 170
      DO 165 I = 1,3
      DO 165 J = 1,3
 165  C(I,J) = A(I,J)
      GO TO 180
C
C     TRANSFORM TO GLOBAL(LOCAL) FROM BASIC
C
 170  CALL GMMATD (TA,3,3,1,A,3,3,0,B)
      CALL GMMATD (B,3,3,0,TA,3,3,0,C)
C
C     C- IS NOW M1-11 ROW WISE
C
 180  DO 200 I = 1,3
      DO 190 K = 1,3
 190  ROW(K) = C(I,K)
      NF = NDOF
      NL = NDOF + 2
      CALL PACK (ROW,M1GG,MCBM1)
 200  CONTINUE
C
C     WRITE OUT 3 NULL COLUMNS
C
      ROW(1) = 0.0
      DO 205 K = 1,3
      NF = 1
      NL = 1
      CALL PACK (ROW,M1GG,MCBM1)
 205  CONTINUE
C
C     NOW TAKE CARE OF B1GG
C
      IF (NCRD .NE. 0) GO TO 240
      DO 210 I = 1,3
      DO 210 J = 1,3
 210  C(I,J) = 0.0
      C(3,2) =-AVGM
      C(2,3) = AVGM
      GO TO 250
 240  DO 245 I = 1,3
      DO245 J = 1,3
 245  A(I,J) = 0.0
      A(3,2) =-AVGM
      A(2,3) = AVGM
C
C     TRANSFORM TO GLOBAL(LOCAL) FROM BASIC
C
      CALL GMMATD (TA,3,3,1,A,3,3,0,B)
      CALL GMMATD (B,3,3,0,TA,3,3,0,C)
C
C     C-IS NOW B1-11 ROW WISE
C
 250  CONTINUE
      DO 300 I = 1,3
      DO 265 K = 1,3
 265  ROW(K) = C(I,K)
      NF = NDOF
      NL = NDOF + 2
      CALL PACK (ROW,B1GG,MCBB1)
 300  CONTINUE
C
C     WRITE OUT 3 NULL COLUMNS
C
      ROW(1) = 0.0
      DO 305 I = 1,3
      NF = 1
      NL = 1
      CALL PACK (ROW,B1GG,MCBB1)
 305  CONTINUE
 307  IF (NOBASX .EQ. -1) GO TO 407
C
C     NOW PROCESS M2GG
C
      IF (NCRD .NE. 0) GOT O 340
      DO 310 I = 1,3
      DO 310 J = 1,3
 310  C(I,J) = 0.0
      C(1,1) = AVGM
      C(2,2) = AVGM
      C(3,3) = AVGM
      C(3,2) = AVGM
      C(2,3) =-AVGM
      GO TO 350
 340  DO 345 I = 1,3
      DO 345 J = 1,3
 345  A(I,J) = 0.0
      A(1,1) = AVGM
      A(2,2) = AVGM
      A(3,3) = AVGM
      A(3,2) = AVGM
      A(2,3) =-AVGM
C
C     TRANSFORM TO GLOBAL(LOCAL) FROM BASIC
C
      CALL GMMATD (TA,3,3,1,A,3,3,0,C)
C
C     C-IS NOW M2-11 ROW WISE
C
 350  CONTINUE
      DO 400 I = 1,3
      DO 365 K = 1,3
 365  ROW(K) = C(I,K)
      NF = NDOF
      NL = NDOF + 2
      CALL PACK (ROW,M2GG,MCBM2)
 400  CONTINUE
C
C     WRITE OUT 3 NULL COLUMNS
C
      ROW(1) = 0.0
      DO 405 I = 1,3
      NF = 1
      NL = 1
      CALL PACK (ROW,M2GG,MCBM2)
 405  CONTINUE
C
C     SPACE DOWN 3 COL IN MGG
C
 407  CONTINUE
      NDOF  = NDOF + 5
      NFILE = MGG
      CALL FWDREC (*903,MGG)
      CALL FWDREC (*903,MGG)
      CALL FWDREC (*903,MGG)
      NFILE = BGPDT
      GO TO 70
C
C     FINISH PROCESSING
C
 800  CALL CLOSE (MGG,1)
      IF (NOBASX .EQ. -1) GO TO 802
      CALL CLOSE (M2GG,1)
      CALL WRTTRL (MCBM2)
 802  IF (OMEGA .EQ. 0.0) GO TO 805
      CALL CLOSE (B1GG,1)
      CALL CLOSE (M1GG,1)
      CALL WRTTRL (MCBB1)
      CALL WRTTRL (MCBM1)
 805  CALL CLOSE (BGPDT,1)
C
C     BEGIN PROCESSING OF FRLX, PDZERO AND BASEXG DATA BLOCKS.
C
C
C     TEST TO SEE IF BASEXG IS TO BE GENERATED.
C
      IF (NOBASX .EQ. -1) GO TO 1000
C
C     RE-ESTABLISH LENGTH OF OPEN CORE FOR PHASE II PROCESSING
C
      NZ = IBUF3 - 1
C
C     PROCESS FRL, FRLX AND PDZERO
C
      MODFRL = .TRUE.
      IF (OMEGA.EQ.0.0 .OR. BYTID.EQ.-1 .AND. BZTID.EQ.-1)
     1    MODFRL = .FALSE.
C
      NFILE = FRL
      MCB1(1) = FRL
      CALL RDTRL (MCB1)
      NFSETS = MCB1(2)
      IFRL = 1
      CALL OPEN (*902,FRL,ZS(IBUF1),0)
C
C     READ HEADER RECORD
C
      CALL READ (*903,*810,FRL,IZ(IFRL),NZ,1,NWRDS)
      GO TO 901
C
C     OPEN CASECC
C
 810  NFILE = CASECC
      CALL GOPEN (CASECC,ZS(IBUF2),0)
C
C     READ RECORD 1, WORD 14 (FREQUENCY SET ID)
C
      CALL READ (*903,*904,CASECC,CASE,14,0,DUMMY)
      FRQSET = CASE(14)
      CALL CLOSE (CASECC,1)
C
C     CHECK WHAT LOGICAL RECORD FRQSET IS IN FRL.
C
      MM = 0
      II = IFRL + 2
      DO 840 I = II,NWRDS
      MM = MM + 1
      IF (IZ(I) .EQ. FRQSET) GO TO 850
 840  CONTINUE
C
C     FREQUENCY SET NOT FOUND.
C
      GO TO 905
C
C     MM IS LOGICAL RECORD NO. IN FRL FOR FRQSET.
C
 850  IF (.NOT.MODFRL) GO TO 852
      CALL  OPEN (*902,FRLX,ZS(IBUF2),1)
      CALL WRITE (FRLX,IZ(IFRL),NWRDS,1)
      CALL GOPEN (PDZERO,ZS(IBUF3),1)
      MCB2(1) = PDZERO
      MCB2(2) = 0
      MCB2(3) = 0
      MCB2(4) = 1
      MCB2(5) = 1
      MCB2(6) = 0
      MCB2(7) = 0
      IN      = 1
      IOUT    = 1
      INCR1   = 1
      ROW2(1) = 0.0
      ROW2(2) = 1.0
      ROW2(3) = 0.0
 852  IFRL    = 1
      NFS     = 0
      NFSX    = 0
      NFILE   = FRL
      DO 859 I = 1,NFSETS
      CALL READ (*903,*853,FRL,ZS(IFRL),NZ,1,M)
      GO TO 901
 853  IF (I .EQ. MM) NFS = M
      IF (.NOT.MODFRL .AND.I.EQ.MM) GO TO 865
      IF (.NOT.MODFRL) GO TO 859
      IF (I  .NE.  MM) GO TO 858
C
C     SET POINTERS FOR SORT INDEX ,   FRLX AND PDZERO ARRAYS.
C
      INDEX = IFR L + NFS
      IFRLX = INDEX + 3*NFS
      IPDZ  = IFRLX + 3*NFS
C
C     RESET IFRL POINTER TO CONTINUE READING FRL RECORDS.
C
      IFRL  = IFRLX
C
C     CHECK CORE REQUIRED FOR EXPANDED FREQUENCY LIST AND SORT INDEX
C
      NZ = NZ - (IPDZ + 3*NFS) + 1
      IF (NZ .LT. 0) GO TO 901
C
      LL = IFRLX - 1
      KKK= IPDZ  - 1
      DO 857 II = 1,NFS
      IF (ZS(II) .EQ. 0.0) GO TO 856
      DO 854 KK = 1,3
      KKK = KKK + 1
      ZS(KKK) = ROW2(KK)
 854  CONTINUE
      ZS(LL+1) = ABS(ZS(II)-OMEGA)
      ZS(LL+2) = ZS(II)
      ZS(LL+3) = ABS(ZS(II)+OMEGA)
      LL = LL + 3
      GO TO 857
 856  ZS(LL+1) = 0.0
      ZS(LL+2) = ABS(OMEGA)
      KKK = KKK + 1
      ZS(KKK) = ROW2(2)
      KKK = KKK + 1
      ZS(KKK) = ROW2(1)
      LL  = LL + 2
 857  CONTINUE
C
C     COMPUTE THE EXPANDED NUMBER OF FREQUIENCES, NFSX.
C
      NFSX = LL - IFRLX + 1
C
C     SORT EXPANDED W'S AND GET INDEX FOR SORTING BASE TABLE.
C
      CALL FVRS1E (ZS(IFRLX),IZ(INDEX),NFSX)
      CALL WRITE (FRLX,ZS(IFRLX),NFSX,1)
      GO TO 859
 858  CALL WRITE (FRLX,ZS(IFRL),M,1)
 859  CONTINUE
      IF (.NOT.MODFRL) GO TO 865
C
C      FRLX IS A COPY OF FRL WITH THE SELECTED FREQUENCY SET, FRQSET,
C      EXPANDED.
C
      CALL CLOSE (FRLX,1)
      MCB1(1) = FRLX
      CALL WRTTRL (MCB1)
C
C     SORT PDZERO BY INDEX JUST AS WAS DONE FOR FRLX
C     USE WORK   AT ZS(IFRLX)
C         INDEX  AT ZS(INDEX)   ALL NFSX LONG
C         PDZERO AT ZS(IPDZ)
C
      DO 860 KK = 1,NFSX
      LOC = IZ(INDEX+KK-1)
 860  ZS(IFRLX+KK-1) = ZS(IPDZ+LOC-1)
C
C     NOW OUTPUT NFSX * FKMAX COLUMNS FOR PDZERO
C
      KKK = 0
      DO 862 KK = 1,FKMAX
      DO 861 JJ = 1,NFSX
      KKK = KKK + 1
      NF  = KKK
      NL  = KKK
      CALL PACK (ZS(IFRLX+JJ-1),PDZERO,MCB2)
 861  CONTINUE
 862  CONTINUE
      CALL CLOSE (PDZERO,1)
      MCB2(3) = MCB2(2)
      CALL WRTTRL (MCB2)
 865  CALL CLOSE (FRL,1)
C
C     RE-ESTABLISH OPEN CORE FOR PHASE III AND
C     RESET POINTER TO ORIGINAL FREQUIENCIES.
C
      IFRL = 1
      NZ   = IBUF1 - (NFS+NFSX) - 1
C
C     NFS  = THE ORIGINAL NUMBER OF FREQUIENCES
C     NFSX = THE EXPANDED NUMBER OF FREQUIENCES.
C
C     GENERATE BASE ACCELERATION MATRIX BASEXG.
C
C
C     BUILD A LIST OF UNIQUE TABLE IDS FOR PRETAB.
C     INITIALIZE THE TABLE WITH A ZERO ENTRY.
C
      ITAB = NFS + NFSX + 1
      NTABL=1
      K = ITAB + NTABL
      IZ(K) = 0
C
C     WE HAVE A LIST OF TABLE ID'S TO CONSIDER
C     WE WANT ONLY A UNIQUE LIST OF TABLE ID'S GIVEN TO PRETAB
C
      DO 872 I = 1,6
      IITID = ITID(I)
C
C     SEARCH EXISTING LIST OF TABLE ID'S TO SEE IF IITID IS ALREADY IN
C     LIST
C
      IF (IITID.LE.0 .OR. IITID.GT.9999999) GO TO 872
      DO 871 L = 1,NTABL
      LL = ITAB + L
      IF (IZ(LL) .EQ. IITID) GO TO 872
 871  CONTINUE
C
C     IITID WAS NOT AMONG EXISTING TABLE ID'S IN LIST,
C     IT'S A NEW TABLE ID,ADD IT TO LIST AND UPDATE LENGHT OF LIST
C
      NTABL = NTABL + 1
      K = ITAB + NTABL
      IZ(K) = IITID
 872  CONTINUE
C
C     ALL TABLE ID'S HAVE BEEN PROCESSED,NOW PRETAB CAN BE CALLED
C     NTABL IS THE NUMBER OF TID'S IN THE LIST.
C
      IZ(ITAB) = NTABL
C
C     ILTAB IS THE NEXT AVAILABLE LOCATION OF OPEN CORE FOR PRETAB.
C
      ILTAB = ITAB + NTABL + 1
C
C     COMPUTE LENGTH OF OPEN CORE AVAILABLE TO PRETAB.
C
      NZTAB = NZ - NTABL - 1
      LTAB  = 0
      CALL PRETAB (DIT,ZS(ILTAB),IZ(ILTAB),ZS(IBUF1),NZTAB,LTAB,
     1             IZ(ITAB),ITLIST)
C
C     COMPUTE LENGTH OF OPEN CORE AFTER PRETAB AND NEXT AVAILABLE LOC.
C
      NZ   = NZ - LTAB
      NEXT = ILTAB + LTAB
C
C     ALLOCATE COMPLEX ARRAYS FOR BASEXG. START ON DOUBLE WORD BOUNDARY.
C
      IF (MOD(NEXT,2) .EQ. 0) NEXT = NEXT + 1
C
C     DEFINE NFSX IF MODFRL IS FALSE.
C
      IF (.NOT.MODFRL) NFSX = NFS
C
      N1 = NEXT
      N2 = N1 + (3*NFSX)*2
      N3 = N2 + (3*NFSX)*2
      NT = N3 +    NROWC*2 - 1
      IF (NZ .LT. NT) GO TO 901
      CALL FVRS1A (ZS(N1),ZS(N2),ZS(N3),ZS(IFRL),ZS(IBUF1),ZS(INDEX),
     1             MODFRL,BASEXG,NROWC,NFS,NFSX,FKMAX,OMEGA)
      GO TO 1000
C
C     ERROR PROCESSING
C
C     NOT ENOUGH CORE (ERROR 3008)
C
 901  IP1 = -8
      GO TO 999
C
C     DATA SET NOT IN FIST (ERROR 3001)
C
 902  IP1 = -1
      GO TO 999
C
C     EOF ENCOUNTERED (ERROR 3002)
C
 903  IP1 = -2
      GO TO 999
C
C     EOL ENCOUNTERED (ERROR 3003)
C
 904  IP1 = -3
      GO TO 999
C
C     FREQUENCY SET NOT FOUND IN FRL (ERROR 3031)
C
 905  CALL MESAGE (-31,FRQSET,MODNAM)
      GO TO 1000
 999  CALL MESAGE (IP1,NFILE,MODNAM(2))
 1000 RETURN
      END

      SUBROUTINE WAVEY (IG,ILD,NEW,NC,IC,KACT,MAXB,MAXW,AVERW,SUMW,
     1                  RMS,BRMS,JG)
C
C     THIS ROUTINE IS USED ONLY IN BANDIT MODULE
C
C     COMPUTE WAVEFRONT AND ACTIVE COLUMN DATA -
C     MAXIMUM WAVEFRONT, AVERAGE WAVEFRONT, SUM OF ROW WAVEFRONTS,
C     SUM OF SQUARES OF ROW WAVEFRONTS, RMS WAVEFRONT, AND BANDWIDTH,
C     RMS BANDWIDTH, AND MINIMUM NODAL DEGREE.
C     DIAGONAL TERMS ARE INCLUDED.
C
C     IG     = CONNECTION TABLE
C     ILD(I) = NEW LABEL FOR NODE WITH ORIGINAL INTERNAL LABEL I
C     NEW(I) = INTERNAL LABEL CORRESPONDING TO NEW LABEL I
C              NEW AND ILD ARE INVERSES OF EACH OTHER
C     NC     = COMPONENT ID
C              IF NC.LE.0, USE ALL COMPONENTS.
C     IC(I)  = COMPONENT INDEX FOR ORIGINAL NODE I.
C     KACT(I)= LIST OF ACTIVE COLUMN FLAGS (UPDATED FOR EACH ROW)
C            = 1 IF COL I IS ACTIVE AT GIVEN ROW
C     MAXB   = BANDWIDTH
C     MAXW   = MAXIMUM WAVEFRONT
C     AVERW  = AVERAGE WAVEFRONT
C     SUMW   = SUM OF ROW WAVEFRONTS
C     SUMSQ  = SUM OF SQUARES OF ROW WAVEFRONTS
C     BSUMSQ = SUM OF SQUARES OF ROW BANDWIDTHS
C     RMS    = RMS WAVEFRONT
C     BRMS   = RMS BANDWIDTH
C     JG     = SCRATCH SPACE FOR BUNPAK
C     NN     = NUMBER OF NODES
C     MM     = MAX NODAL DEGREE
C     MINDEG = MINIMUM NODAL DEGREE
C
C     INPUT  - IG,ILD,NN,MM,NC,IC.
C     OUTPUT - NEW,KACT,MAXW,AVERW,SUMW,RMS,MAXB,BRMS,MINDEG
C
      INTEGER          SUMW
      DOUBLE PRECISION SUMSQ,    BSUMSQ
      DIMENSION        IC(1),    ILD(1),   NEW(1),   KACT(1),  IG(1),
     1                 JG(1)
      COMMON /BANDS /  NN,       MM,       DUM6S(6), MINDEG
C
C     INITIALIZE WAVEFRONT DATA.
C
      MAXB  = 0
      MAXW  = 0
      SUMW  = 0
      SUMSQ = 0.D0
      BSUMSQ= 0.D0
      AVERW = 0.
      RMS   = 0.
      MINDEG= MIN0(MINDEG,MM)
      IF (NN*MM .LE. 0) RETURN
C
C     INITIALIZE NEW, THE INVERSE OF ILD
C
      IF (NC .GT. 0) GO TO 8
      DO 5 I = 1,NN
      K = ILD(I)
      IF (K .LE. 0) GO TO 5
      NEW(K) = I
    5 CONTINUE
C
C     INITIALIZE ACTIVE COLUMN FLAGS (1 FOR ACTIVE)
C
    8 DO 10 I = 1,NN
   10 KACT(I) = 0
C
C     COMPUTE WAVEFRONT DATA.
C
      IWAVE = 1
      KT = 0
      DO 40 I = 1,NN
C
C     COMPUTE NUMBER OF ACTIVE COLUMNS FOR ROW I
C
      K = NEW(I)
      IF (NC) 18,18,15
   15 IF (K .LE. 0) GO TO 40
      IF (NC-IC(K)) 40,18,40
   18 KT = KT + 1
      CALL BUNPAK(IG,K,MM,JG)
      IB = 0
      DO 20 J = 1,MM
      L = JG(J)
      IF (L .EQ. 0) GO TO 30
      M  = ILD(L)
      IB = MAX0(IB,I-M)
      IF (M .LE. I) GO TO 20
      IF (KACT(M) .EQ. 1) GO TO 20
      IWAVE = IWAVE + 1
      KACT(M) = 1
   20 CONTINUE
      GO TO 35
   30 CONTINUE
      MINDEG = MIN0(MINDEG,J-1)
   35 CONTINUE
C
C     IB1 = ROW BANDWIDTH FOR ROW I (DIAGONAL INCLUDED)
C
      IB1 = IB + 1
      MAXB = MAX0(MAXB,IB1)
      IF (KACT(I) .EQ. 1) IWAVE = IWAVE - 1
C
C     IWAVE = CURRENT NUMBER OF ACTIVE COLUMNS FOR ROW I
C             (DIAGONAL INCLUDED)
C
      MAXW  = MAX0(MAXW,IWAVE)
      SUMW  = SUMW + IWAVE
      WAVE  = FLOAT(IWAVE)
      SUMSQ = SUMSQ + WAVE*WAVE
      WAVE  = FLOAT(IB1)
      BSUMSQ= BSUMSQ + WAVE*WAVE
C
   40 CONTINUE
C
      ANN   = FLOAT(KT)
      AVERW = FLOAT(SUMW)/ANN
      RMS   = SQRT(SNGL( SUMSQ)/ANN)
      BRMS  = SQRT(SNGL(BSUMSQ)/ANN)
      RETURN
      END

      SUBROUTINE SMP1
C
C     SMP1 PARTITIONS KFF INTO KAAB,KOAB AND KOOB
C     GO IS SOLVED FROM THE EQUATION KOOB*GO = -KOAB
C     KAA IS THEN COMPUTED FROM THE EQUATION KAA = KAAB + KOAB(T)*GO
C     IF ANY OF THE MATRICES MFF, BFF OR K4FF IS PRESENT, THEN
C     PARTITIONS ARE MADE AND THE EQUATION
C     XAA = XAAB + GO(T)*XOAB + XOAB(T)*GO + GO(T)*XOOB*GO
C     IS EVALUATED WHERE X = M OR B OR K4
C
      INTEGER         MCB(7), USET,   SCR1,   SCR2,    SCR3,
     1                SCR4,   SCR5,   SCR6,   SCR7,    UF,
     2                UA,     GO,     FF(3),  AAB,     OAB,
     3                OOB,    AA(3),  BAA,    IOAB(3), IOOB(3),
     4                UO,     BFF
      COMMON /BITPOS/ UM,     UO,     UR,     USG,     USB,    UL,
     1                UA,     UF,     US,     UN,      UG,     UE,
     2                UP
      EQUIVALENCE     (FF(3),MFF), (FF(2),BFF), (FF(1),K4FF),
     1                (AA(3),MAA), (AA(2),BAA), (AA(1),K4AA),
     2                (IOOB(3),OOB), (IOAB(3),OAB), (AAB,SCR5),
     3                (IOOB(1),SCR6), (IOAB(1),SCR7)
      DATA            USET,   KFF,    MFF,    BFF,     K4FF  /
     1                101,    102,    103,    104,     105   /
      DATA            GO,     KAA,    KOOB,   LOO,     MAA   /
     1                201,    202,    203,    204,     205   /
      DATA            OOB,    OAB,    BAA,    K4AA           /
     1                206,    207,    208,    209            /
      DATA            SCR1,   SCR2,   SCR3,   SCR4,    SCR5  /
     1                301,    302,    303,    304,     305   /
      DATA            SCR6,   SCR7,   IOOB(2),IOAB(2)        /
     1                306,    307,    306,    307            /
C
C     MATRIX NAME EQUIVALENCES NOT REFERENCED
C
C     EQUIVALENCED    (AAB,   MAAB,   BAAB,   K4AAB,  SCR5)
C                     (OOB,   MOOB,   BOOB,   K4OOB,  SCR6)
C                     (OAB,   MOAB,   BOAB,   K4OAB,  SCR7)
C
C     PARTITION KFF INTO KAAB,KOAB, AND KOOB
C
      CALL UPART (USET,SCR1,UF,UA,UO)
      CALL MPART (KFF,AAB,IOAB,0,KOOB)
C
C     DECOMPOSE KOOB INTO LOO
C
      CALL FACTOR (KOOB,LOO,SCR2,SCR3,SCR4,SCR6)
C
C     SOLVE KOOB*GO = -KOAB FOR GO
C     THEN COMPUTE  KAA = KAAB + KOAB(T)*GO
C
      CALL SOLVER (LOO,GO,IOAB,AAB,KAA,0,0,SCR4)
C
      DO 40 I = 1,3
C
C                     K4FF
C     TEST TO SEE IF   BFF  IS PRESENT
C                      MFF
C
      MCB(1) = FF(I)
      CALL RDTRL (MCB)
      IF (MCB(1) .LT. 0) GO TO 40
C
C         K4FF                              K4AAB, K4OAB, K4OOB
C     IF   BFF IS PRESENT, PARTITION INTO    BAAB,  BOAB,  BOOB
C          MFF                               MAAB,  MOAB,  MOOB
C
C     THEN COMPUTE  K4AA, BAA, MAA  RESPECTIVELY
C
      CALL MPART (FF(I),AAB,IOAB(I),0,IOOB(I))
      CALL ELIM  (AAB,IOAB(I),IOOB(I),GO,AA(I),SCR2,SCR3,SCR4)
   40 CONTINUE
C
      RETURN
      END

      SUBROUTINE GPSTGS
C
C     THIS SUBROUTINE GENERATES THE GRID POINT SINGULARITY TABLE
C     BY EXAMINING THE TRANSLATIONAL AND ROTATIONAL 3 X 3
C     SUBMATRICES ALONG THE LEADING DIAGONAL OF THE INPUT
C     STIFFNESS MATRIX
C
      DIMENSION   IARRAY(8), ISUBNM(2)
C
      INTEGER     GPST     , TTLWDS
C
      REAL        B(9), FL(3), D
      REAL        M(3), R(3) , TEMP, FM, FR, DET, CONST, DTOL
C
      COMMON /GPSTGX/ GPST , IGPST, NPVT, NSING , IBUF2
      COMMON /GPSTGY/ D(18)
      COMMON /SYSTEM/ ISYS(69)    , TOLEL
      COMMON /ZZZZZZ/ IZ(1)
C
      EQUIVALENCE (IORDER, IARRAY(1)), (NWDS, IARRAY(2))
C
      DATA ISUBNM / 4HGPST,4HG   /
C
      DTOL = TOLEL
C
C AT THIS POINT, BOTH TRANSLATIONAL AND ROTATIONAL DIAGONAL 3X3 S ARE
C STORED IN THE D ARRAY.  HENCE WE PROCESS THEM.
C
      IP = NPVT - 1
      ASSIGN 470 TO IGOTO
      ASSIGN 20 TO IBACK
      DO 10 I = 1,9
   10 B(I) = D(I)
      GO TO 90
   20 DO 30 I = 1,9
   30 B(I) = D(I+9)
C
C INSURE THE SYMMETRY OF THE B MATRIX
C
      IF (B(2) .NE. 0.0 .AND. B(4) .NE. 0.0) GO TO 40
      B(2) = 0.0
      B(4) = 0.0
      GO TO 50
   40 TEMP = (B(2) + B(4)) / 2.0
      B(2) = TEMP
      B(4) = TEMP
   50 IF (B(3) .NE. 0.0 .AND. B(7) .NE. 0.0) GO TO 60
      B(3) = 0.0
      B(7) = 0.0
      GO TO 70
   60 TEMP = (B(3) + B(7)) / 2.0
      B(3) = TEMP
      B(7) = TEMP
   70 IF (B(6) .NE. 0.0 .AND. B(8) .NE. 0.0) GO TO 80
      B(6) = 0.0
      B(8) = 0.0
      GO TO 90
   80 TEMP = (B(6) + B(8)) / 2.0
C
C SCALE THE MATRIX BY DIVIDING EACH ELEMENT OF B BY THE LARGEST ELEMENT.
C IF THE LARGEST ELEMENT IS NON-POSITIVE, THE SINGULARITY IS OF ORDER 3.
C
   90 TEMP = B(1)
      DO 100 I = 2,9
      IF (B(I) .GT. TEMP) TEMP = B(I)
  100 CONTINUE
      IF (TEMP .LE. 0.0) GO TO 430
      DO 110 I = 1,9
  110 B(I) = B(I) / TEMP
C
C FIND THE SQUARES OF THE MAGNITUDES OF THE VECTORS OF THE ROWS OF THE
C B MATRIX.
C
      IORDER = 0
      J = 0
      DO 120 I = 1,9,3
      J = J + 1
      FL(J) = B(I)**2 + B(I+1)**2 + B(I+2)**2
      IF (FL(J) .EQ. 0.0) IORDER = IORDER + 1
  120 CONTINUE
      IF (IORDER .EQ. 2)  GO TO 410
      IF (IORDER .EQ. 0)  GO TO 260
C
C AT THIS POINT ONE AND ONLY ONE FL(I) IS ZERO.
C
      DO 130 I = 1,3
      ISAVE = I
      IF (FL(I) .EQ. 0. 0) GO TO (140,150,160), ISAVE
  130 CONTINUE
      CALL MESAGE (-30,26,ISUBNM)
  140 FM = B(5) * B(9)  -  B(6) * B(8)
      FR = SQRT( (B(5)**2  +  B(6)**2)  *  (B(8)**2  +  B(9)**2) )
      GO TO 170
  150 FM = B(1) * B(9)  -  B(3) * B(7)
      FR = SQRT( (B(1)**2  +  B(3)**2)  *  (B(7)**2  +  B(9)**2) )
      GO TO 170
  160 FM = B(1) * B(5)  -  B(2) * B(4)
      FR = SQRT( (B(1)**2  +  B(2)**2)  *  (B(4)**2  +  B(5)**2) )
  170 IF ( FM   .EQ. 0.0 ) GO TO 180
      IF ( FR   .LE. 0.0 ) GO TO 250
      IF ( FM/FR .GE. DTOL ) GO TO 250
C
C HERE WE HAVE THAT THE ORDER OF THE SINGULARITY IS 2.
C
  180 IORDER = 2
      NWDS   = 0
      TTLWDS  = 2
      GO TO (190,200,210), ISAVE
  190 K1   = 5
      K2   = 9
      INC1 = 1
      INC2 = 3
      INC3 = 2
      GO TO 220
  200 K1   = 1
      K2   = 9
      INC1 = 2
      INC2 = 3
      INC3 = 1
      GO TO 220
  210 K1   = 1
      K2   = 5
      INC1 = 3
      INC2 = 2
      INC3 = 1
  220 IF (B(K1) .LE. 0.0  .AND.  B(K2) .LE. 0.0) GO TO 430
      IF (B(K1) .LE. 0.0) GO TO 230
      NWDS      = 2
      TTLWDS     = 4
      IARRAY(3) = IP + INC1
      IARRAY(4) = IP + INC2
      IPOINT    = 5
      GO TO 240
  230 IPOINT = 3
  240 IF (B(K2) .LE. 0.0) GO TO 440
      NWDS = NWDS + 2
      TTLWDS = TTLWDS + 2
      IARRAY(IPOINT)   = IP + INC1
      IARRAY(IPOINT+1) = IP + INC3
      GO TO 440
C
C AT THIS POINT WE HAVE THAT ONE AND ONLY ONE FL IS ZERO BUT THAT ORDER
C OF THE SINGULARITY IS 1.
C
  250 IORDER    = 1
      NWDS      = 1
      TTLWDS    = 3
      IARRAY(3) = IP + ISAVE
      GO TO 440
C
C AT STATEMENT NO. 260, WE HAVE THAT ALL THE FL(I) ARE .GT. 0.0, SO
C THAT THE DETERMINANT, DET, OF B MUST BE COMPUTED.
C
  260 DET = B(1) * ( B(5)*B(9) - B(6)*B(8) )
     1    - B(2) * ( B(4)*B(9) - B(6)*B(7) )
     2    + B(3) * ( B(4)*B(8) - B(5)*B(7) )
      CONST = 0.05*DTOL * FL(1) * FL(2) * FL(3)
      IF (DET .GT. CONST) GO TO 460
C
C COMPUTE M(I) AND R(I)
C
      M(1) = B(5) * B(9) - B(6) * B(8)
      M(2) = B(1) * B(9) - B(3) * B(7)
      M(3) = B(1) * B(5) - B(2) * B(4)
      R(1) = SQRT ( B(5)**2 + B(6)**2 ) * SQRT ( B(8)**2 + B(9)**2 )
      R(2) = SQRT ( B(1)**2 + B(3)**2 ) * SQRT ( B(7)**2 + B(9)**2 )
      R(3) = SQRT ( B(1)**2 + B(2)**2 ) * SQRT ( B(4)**2 + B(5)**2 )
C
C FIND I1,J1,K1 SUCH THAT M(I1)/R(I1) .GE. M(J1)/R(J1) .GE. M(K1)/R(K1)
C
      I1 = 1
      J1 = 2
      K1 = 3
      IF (M(1)*R(2).GE.M(2)*R(1)) GO TO 270
      I1 = 2
      J1 = 1
  270 IF (M(I1)*R(K1).GE.M(K1)*R(I1)) GO TO 280
      ITEMP = I1
      I1    = K1
      K1    = ITEMP
  280 IF (M(J1)*R(K1).GE.M(K1)*R(J1)) GO TO 290
      ITEMP = J1
      J1    = K1
      K1    = ITEMP
  290 IF (M(I1).GE.R(I1)*DTOL) GO TO 400
C
C HERE THE SINGULARITY IS OF ORDER 2.
C
      NWDS   = 0
      TTLWDS = 2
      IORDER = 2
C
C FIND II, JJ, KK SUCH THAT B(II) .GE. B(JJ) .GE. B(KK)
C
      II = 1
      JJ = 5
      KK = 9
      IF (B(1) .GE. B(5)) GO TO 300
      II = 5
      JJ = 1
  300 IF (B(II) .GE. B(KK)) GO TO 310
      ITEMP = II
      II    = KK
      KK    = ITEMP
  310 IF (B(JJ) .GE. B(KK)) GO TO 320
      ITEMP = JJ
      JJ    = KK
      KK    = ITEMP
  320 LL    = II
      KOUNT = 0
      IPOINT= 3
  330 IF (B(LL) .LE. 0.0) GO TO 440
      NWDS   = NWDS + 2
      TTLWDS = TTLWDS + 2
      IF (LL - 5) 340,350,360
  340 INC1 = 2
      INC2 = 3
      GO TO 370
  350 INC1 = 1
      INC2 = 3
      GO TO 370
  360 INC1 = 1
      INC2 = 2
  370 IARRAY(IPOINT)   = IP + INC1
      IARRAY(IPOINT+1) = IP + INC2
      IPOINT = IPOINT + 2
      KOUNT  = KOUNT  + 1
      IF (KOUNT - 2) 380,390,440
  380 LL = JJ
      GO TO 330
  390 LL = KK
      GO TO 330
C
C AT THIS POINT THE SINGULARITY IS OF ORDER 1.
C
  400 IORDER = 1
      NWDS   = 1
      TTLWDS = 3
      IARRAY(3) = IP + I1
      IF (M(J1).LT.R(J1)*DTOL) GO TO 440
      NWDS   = 2
      TTLWDS = 4
      IARRAY(4) = IP + J1
      IF (M(K1).LT.R(K1)*DTOL) GO TO 440
      NWDS   = 3
      TTLWDS = 5
      IARRAY(5) = IP + K1
      GO TO 440
C
C AT THIS POINT 2 ROWS OF THE B MATRIX ARE IDENTICALLY ZERO.
C
  410 NWDS   = 2
      TTLWDS = 4
      IPOINT = 2
      DO 420 I = 1,3
      IF (FL(I) .NE. 0.0) GO TO 420
      IPOINT = IPOINT + 1
      IARRAY(IPOINT) = IP + I
  420 CONTINUE
      GO TO 440
C
C THE SINGULARITY IS OF ORDER 3
C
  430 IORDER = 3
      NWDS   = 3
      TTLWDS = 5
      IARRAY(3) = IP + 1
      IARRAY(4) = IP + 2
      IARRAY(5) = IP + 3
C
C WRITE IARRAY ON THE GPST FILE.
C
  440 IF (IGPST.EQ.1) GO TO 450
      IGPST = 1
      CALL GOPEN (GPST,IZ(IBUF2),1)
  450 NSING = NSING + 1
      CALL WRITE (GPST,IARRAY,TTLWDS,0)
  460 GO TO IGOTO, (470,480)
  470 ASSIGN 480 TO IGOTO
      IP = IP + 3
      GO TO IBACK, (20,430)
  480 CONTINUE
      RETURN
      END

      SUBROUTINE RFORCE (LCORE)
C
C     COMPUTES STATIC LOADS DUE TO ROTATING COORDINATE SYSTEMS
C
      EXTERNAL        RSHIFT,ANDF
      LOGICAL         NONSHL,CUPMAS
      INTEGER         FILE,SLT,BGPDT,OLD,ICARD(6),SYSBUF,NAME(2),
     1                STRTMN,ANDF,RSHIFT
      REAL            MT(3,3),MTR(3,3),MR(3,3)
      DIMENSION       CARD(6),RA(4),WB(3),WG(3),RI(4),XM(6,6),IY(7)
      DIMENSION       ISYSTM(175)
      COMMON /MACHIN/ MACH,IHALF,JHALF
      COMMON /CONDAS/ PI,TWOPHI,RADEG,DEGRA,S4PISQ
      COMMON /UNPAKX/ IT1,II,JJ,INCR
      COMMON /XCSTM / TI(3,3)
      COMMON /TRANX / IX(5),TO(3,3)
      COMMON /ZZZZZZ/ Z(1)
      COMMON /SYSTEM/ SYSBUF,DUMY(25),MN
      COMMON /ZNTPKX/ A(4),IROW,IEOL,IEOR
      COMMON /LOADX / LC,SLT,BGPDT,OLD,NN(11),MGG
      EQUIVALENCE     (ICARD(1),CARD(1)), (IR,RI(1)), (IRA,RA(1))
      EQUIVALENCE     (SYSBUF  ,ISYSTM(1))
      DATA    NAME  / 4HRFOR,4HCE  /
C
C     DEFINITION OF VARIABLES
C
C     SLT      STATIC LOAD TABLE
C     BGPDT    BASIC GRID POINT DEFINITION TABLE
C     MGG      MASS  MATRIX
C     FILE     FILE NAME FOR ERROR MESAGES
C     CARD     CARD IMAGE OF RFORCE CARD
C     RA       BGPDT ENTRY FOR AXIAL GRID POINT
C     WB       OMEGA-S IN BASIC COORDINATES
C     II       SIL OF CURRENT  POINT
C     IT1      UNPACK TYPE(REAL)
C     INCR     INCREMENT( TO ROW STORE COLUMNS)
C     RI       BGPDT ENTRY FOR CURRENT GRID POINT
C     WG       OMEGA-S IN GLOBAL COORDINANTS AT CURRENT GRID POINT
C     XM       6X6 DIAGONAL PARTION OF MGG
C     MT       3X3 PARTITION OF  MGG
C     MR       3X3 PARTITION OF  MGG
C     MTR      3X3 PARTITION OF  MGG
C     OLD      CURRENT POSITION OF BGPDT  0 IMPLIES BEGINNING
C
C
C     BRING IN CARD IMAGE
C
      CALL FREAD (SLT,CARD,6,0)
C
C     FIND LOCATION OF AXIAL GRID POINT
C
      DO 10 I = 1,3
      RA(I+1) = 0.0
   10 CONTINUE
      IF (ICARD(1) .EQ. 0) GO TO 30
      CALL FNDPNT (RA(1),ICARD(1))
C
C     CHECK FOR GRID POINT
C
      IF (IRA .NE. -1) GO TO 30
      DO 20 I = 1,3
      RA(I+1) = 0.0
   20 CONTINUE
   30 CALL REWIND (BGPDT)
      CALL SKPREC (BGPDT,1)
C
C     CONVERT WI'S TO BASIC COORDINANTS
C
      DO 40 I = 4,6
      WB(I-3) = CARD(I)*TWOPHI*CARD(3)
   40 CONTINUE
      IF (ICARD(2) .EQ. 0) GO TO 60
      CALL FDCSTM (ICARD(2))
      CALL MPYL (TO,WB,3,3,1,WG)
      DO 50 I = 1,3
      WB(I) = WG(I)
   50 CONTINUE
C
C     OPEN MASS MATRIX
C
   60 CONTINUE
      J   = LCORE - SYSBUF
      IF (J .GT. 0) GO TO 65
      ICRRQD = IABS(J) + 1
      CALL MESAGE (-8, ICRRQD, NAME)
   65 CALL GOPEN (MGG,Z(J),0)
      IT1 = 1
C
C     TEST FOR COUPLED MASS
C
      IY(1) = MGG
      CALL RDTRL (IY)
      CUPMAS = .FALSE.
      IF (IY(6) .EQ. 1) GO TO 90
      IF (IY(6) .GT. 6) CUPMAS = .TRUE.
      IF (CUPMAS) GO TO 90
      INCR = 0
      NCOL = IY(2)
      DO 70 I = 1,NCOL
      II = 0
      CALL UNPACK (*70,MGG,A)
      IF (JJ-II .GT. 6) CUPMAS = .TRUE.
      IF (CUPMAS) GO TO 80
   70 CONTINUE
   80 CALL REWIND (MGG)
      CALL SKPREC (MGG,1)
   90 II = 1
      INCR = 6
C
C     TEST FOR CONICAL SHELL PROBLEM
C
      NONSHL = .TRUE.
      IF (MN .EQ. 0) GO TO 100
      NONSHL = .FALSE.
      NHARMS = MN
      NRINGS = ISYSTM(161)
      IY(1)  = BGPDT
      CALL RDTRL (IY)
      STRTMN = IY(2) - NHARMS*NRINGS
      IPTAX  = 0
      KOUNTM = 0
C
C     BRING IN BGPDT
C
  100 FILE = BGPDT
      CALL READ (*410,*330,BGPDT,RI(1),4,0,IFLAG)
C
C     TEST FOR CONICAL SHELL PROCESSING
C
      IF (NONSHL) GO TO 120
      IPTAX = IPTAX + 1
      IF (IPTAX .LT. STRTMN) GO TO 110
      KOUNTM = KOUNTM + 1
      IF (KOUNTM .LE. NRINGS) GO TO 240
      GO TO 330
C
  110 IF (IR .NE. -1) CALL SKPREC (MGG,6)
C
C     CHECK FOR SCALAR POINT
C
  120 CONTINUE
      IF (IR .NE. -1) GO TO 130
      CALL SKPREC (MGG,1)
      II = II + 1
      GO TO 100
C
C     TEST FOR COUPLED MASS PROCESSING
C
  130 IF (CUPMAS) GO TO 250
C
C     CONVERT WB'S TO GLOBAL COORDINATES AT RI
C
      DO 140 I = 1, 3
  140 WG(I) = WB(I)
      IF (IR .EQ. 0) GO TO 150
      CALL BASGLB (WB(1),WG(1),RI(2),IR)
C
C     BRING IN  6X6  ON DIAGONAL OF MASS MATRIX
C
  150 JJ = II + 5
      DO 160 J = 1,6
      DO 160 I = 1,6
      XM(I,J) = 0.0
  160 CONTINUE
      DO 170 I = 1,6
      CALL UNPACK (*170,MGG,XM(I,1))
  170 CONTINUE
C
C     MOVE  6X6 TO PARTITIONS
C
      DO 180 I = 1,3
      DO 180 J = 1,3
      MT(J,I) = XM(J,I)
      MR(J,I) = XM(J+3,I+3)
      MTR(J,I)= XM(J+3,I)
  180 CONTINUE
C
C     COMPUTE WBX(RI-RA)
C
      DO 190 I = 1,3
      XM(I,1) = RI(I+1) - RA(I+1)
  190 CONTINUE
      CALL CROSS (WB(1),XM(1,1),XM(1,3))
      DO 200 I = 1,3
      XM(I,1) = XM(I,3)
  200 CONTINUE
      IF (IR .EQ. 0) GO TO 210
      CALL MPYL (TI(1,1),XM(1,1),3,3,1,XM(1,3))
  210 CONTINUE
C
C     COMPUTE MOMENTS
C
      CALL MPYL  (MR(1,1),WG(1),3,3,1,XM(1,1))
      CALL CROSS (XM(1,1),WG(1),XM(1,2))
      CALL MPYLT (MTR(1,1),XM(1,3),3,3,1,XM(1,1))
      CALL CROSS (XM(1,1),WG,XM(1,4))
      J = II + 2
      DO 220 I = 1,3
      J = J + 1
      Z(J) = Z(J) + XM(I,2) + XM(I,4)
  220 CONTINUE
C
C     COMPUTE FORCES
C
      CALL MPYL  (MTR(1,1),WG(1),3,3,1,XM(1,1))
      CALL CROSS (XM(1,1),WG(1),XM(1,2))
      CALL MPYL  (MT(1,1),XM(1,3),3,3,1,XM(1,1))
      CALL CROSS (XM(1,1),WG,XM(1,4))
      J = II - 1
      DO 230 I = 1,3
      J = J + 1
      Z(J) = Z(J) + XM(I,4) + XM(I,2)
  230 CONTINUE
C
C     BUMP  II
C
      II  = II + 6
      GO TO 100
C
C     CONICAL SHELL PROCESSING
C     COMPUTE A = R*WB**2
C
  240 XM(2,3) = 0.0
      XM(3,3) = 0.0
      XM(1,3) = RI(2)*WB(2)*WB(2)
      GO TO 290
C
C     COUPLED MASS PROCESSING
C     COMPUTE -WB*(WB*(RI - RA))
C
  250 DO 260 I = 1, 3
  260 XM(I,1) = RI(I+1) - RA(I+1)
      CALL CROSS (WB(1),XM(1,1),XM(1,3))
      CALL CROSS (XM(1,3),WB(1),XM(1,1))
      IF (IR .EQ. 0) GO TO 270
      CALL BASGLB (XM(1,1),XM(1,3),RI(2),IR)
      GO TO 290
  270 DO 280 I = 1, 3
  280 XM(I,3) = XM(I,1)
C
C     COMPUTE F = M*A
C
  290 I1 = 1
      DO 320 I = 1, 3
      CALL INTPK (*320,MGG,0,I1,0)
      IF (XM(I,3) .EQ. 0.0) GO TO 310
  300 CALL ZNTPKI
      Z(IROW) = Z(IROW) + A(1)*XM(I,3)
      IF (IEOL .NE. 1) GO TO 300
      GO TO 320
  310 CALL SKPREC (MGG,1)
  320 CONTINUE
      CALL SKPREC (MGG,3)
      GO TO 100
C
C     EOR IN BGPDT
C
  330 CALL CLOSE  (MGG,1)
      CALL REWIND (BGPDT)
      OLD = 0
      CALL SKPREC (BGPDT,1)
      RETURN
C
C     FILE ERRORS
C
  400 CALL MESAGE (IP1,FILE,NAME(1))
  410 IP1 = -2
      GO TO 400
      END

      SUBROUTINE PKROD
C
C     THIS ROUTINE COMPUTES THE TWO 6 X 6 MATRICES  K(NPVT,NPVT) AND
C     K(NPVT,J) FOR A ROD HAVING END POINTS NUMBERED NPVT AND J.
C
C     ECPT FOR THE ROD
C     ================                                              CARD
C                                                      TYPE  TABLE  TYPE
C     ECPT( 1)ELEMENT ID.                                I    ECT   CROD
C     ECPT( 2)SCALAR INDEX NUMBER FOR GRID POINT A       I    ECT   CROD
C     ECPT( 3)SCALAR INDEX NUMBER FOR GRID POINT B       I    ECT   CROD
C     ECPT( 4)MATERIAL ID.                               I    EPT   PROD
C     ECPT( 5)AREA  (A)                                  R    EPT   PROD
C     ECPT( 6)POLAR MOMENT OF INERTIA (J)                R    EPT   PROD
C     ECPT( 7) TORSIONAL STRESS COEFF (C)                R    EPT   PROD
C     ECPT( 8) NON-STRUCTRAL MASS (MU)                   R    EPT   PROD
C     ECPT( 9) COOR. SYS. ID. NO. FOR GRID POINT A       I   BGPDT  GRID
C     ECPT(10) X-COORDINATE OF GRID PT. A (IN BASIC COOR)R   BGPDT
C     ECPT(11) Y-COORDINATE OF GRID PT. A (IN BASIC COOR)R   BGPDT
C     ECPT(12) Z-COORDINATE OF GRID PT. A (IN BASIC COOR)R   BGPDT
C     ECPT(13) COOR. SYS. ID. NO. FOR GRID POINT B       I   BGPDT
C     ECPT(14) X-COORDINATE OF GRID PT. B (IN BASIC COOR)R   BGPDT
C     ECPT(15) Y-COORDINATE OF GRID PT. B (IN BASIC COOR)R   BGPDT
C     ECPT(16) Z-COORDINATE OF GRID PT. B (IN BASIC COOR)R   BGPDT
C     ECPT(17) ELEMENT TEMPERATURE
C     ECPT(18) PREVIOUS STRAIN VALUE, ONCE REMOVED (EPSIN1)
C     ECPT(19) PREVIOUS STRAIN VALUE (EPSIN2)
C     ECPT(20) PREVIOUSLY COMPUTED VALUE OF MODULUS OF ELASTICITY, ESTAR
C     ECPT(21) DISPLACEMENT COORDINATES FOR GRID POINT A
C     ECPT(22)                   . . .
C     ECPT(23)                   . . .
C     ECPT(24) DISPLACEMENT COORDINATES FOR GRID POINT B
C     ECPT(25)                   . . .
C     ECPT(26)                   . . .
C
      DOUBLE PRECISION D(18),X,Y,Z,XL,XN(3),UA(6),UB(6),TA(9),TB(9),E,G,
     1                 DIFF(3),DPTERM,EPSIN1,EPSIN2,DEPS1,DEPS2,EPS1,
     2                 EPS2,GAMMA,GAMMAS,SIGMA1,SIGMA2,DSCL,DSCR,KE(36)
      DIMENSION        IECPT(200)
C
C     PLA42 PARAMETERS COMMUNICATION BLOCK
      COMMON /PLA42C/  NPVT,G NEW,G OLD,DUMCL(146),NOGO
     1
C
C     ECPT COMMON BLOCK
      COMMON /PLA42E/  ECPT(100)
C
C     PLA42 LOCAL VARIABLE (SCRATCH) BLOCK
      COMMON /PLA42D/  D,X,Y,Z,XL,XN,UA,UB,TA,TB,DIFF,DPTERM,EPSIN1,
     1                 EPSIN2,DEPS1,DEPS2,EPS1,EPS2,GAMMA,GAMMAS,
     2                 SIGMA1,SIGMA2,DSCL,DSCR,E,G,KE
C
C     INPUT AND OUTPUT BLOCKS FOR SUBROUTINE MAT
      COMMON /MATIN /  MATIDC,MATFLG,TEMDUM,PLAARG,MATDUM(2)
      COMMON /MATOUT/  E SUB 0,G SUB 0,DUMMAT(18)
      EQUIVALENCE      (IECPT(1),ECPT(1)) ,(PLAANS,ESUB0)
C
C     BEGIN EXECUTION
C
      IND = 0
      IF (IECPT(2) .EQ. NPVT) GO TO 10
      IF (IECPT(3) .NE. NPVT) CALL MESAGE (-30,34,IECPT(1))
      IND = 1
      ITEMP = IECPT(2)
      IECPT(2) = IECPT(3)
      IECPT(3) = ITEMP
      KA  = 13
      KB  =  9
      IDISPA = 23
      IDISPB = 20
      GO TO 20
   10 KA  =  9
      KB  = 13
      IDISPA = 20
      IDISPB = 23
C
C     AT THIS POINT KA POINTS TO THE COOR. SYS. ID. OF THE PIVOT GRID
C     POINT. SIMILARLY FOR KB AND THE NON-PIVOT GRID POINT.
C     NOW COMPUTE THE LENGTH OF THE ROD.
C
C     WE STORE THE COORDINATES IN THE D ARRAY SO THAT ALL ARITHMETIC
C     WILL BE DOUBLE PRECISION
C
   20 D(1) = ECPT(KA+1)
      D(2) = ECPT(KA+2)
      D(3) = ECPT(KA+3)
      D(4) = ECPT(KB+1)
      D(5) = ECPT(KB+2)
      D(6) = ECPT(KB+3)
      X    = D(1) - D(4)
      Y    = D(2) - D(5)
      Z    = D(3) - D(6)
      XL = DSQRT(X**2 + Y**2 + Z**2)
      IF (XL .NE. 0.0D0) GO TO 25
      CALL MESAGE (30,26,IECPT(1))
C
C     SET FLAG FOR FATAL ERROR WHILE ALLOWING ERROR MESSAGES TO
C     ACCUMULATE
C
      NOGO = 1
      RETURN
C
C     CALCULATE A NORMALIZED DIRECTION VECTOR IN BASIC COORDINATES.
C
   25 XN(1) = X/XL
      XN(2) = Y/XL
      XN(3) = Z/XL
C
C     STORE DISPLACEMENT VECTORS IN DOUBLE PRECISION LOCATIONS
C
      UA(1) = ECPT(IDISPA+1)
      UA(2) = ECPT(IDISPA+2)
      UA(3) = ECPT(IDISPA+3)
      UB(1) = ECPT(IDISPB+1)
      UB(2) = ECPT(IDISPB+2)
      UB(3) = ECPT(IDISPB+3)
C
C
C     COMPUTE THE DIFFERENCE VECTOR DIFF =  T  * U   -  T  * U
C                                            A    A      B    B
C
      IBASEA = 0
      IF (IECPT(KA) .EQ. 0) GO TO 30
      CALL TRANSD (ECPT(KA),TA)
      IBASEA = 3
      CALL GMMATD (TA,3,3,0, UA(1),3,1,0, UA(4))
   30 IBASEB = 0
      IF (IECPT(KB) .EQ. 0) GO TO 40
      CALL TRANSD (ECPT(KB),TB)
      IBASEB = 3
      CALL GMMATD (TB,3,3,0, UB(1),3,1,0, UB(4))
   40 DIFF(1) = UA(IBASEA+1) - UB(IBASEB+1)
      DIFF(2) = UA(IBASEA+2) - UB(IBASEB+2)
      DIFF(3) = UA(IBASEA+3) - UB(IBASEB+3)
C
C     COMPUTE DOT PRODUCT XN . DIFF
C
      CALL GMMATD (XN,3,1,1, DIFF,3,1,0, DPTERM)
C
C     COMPUTE INCREMENT OF STRAIN
C
      DEPS1  = DPTERM/XL
      EPSIN1 = ECPT(18)
      EPSIN2 = ECPT(19)
      DEPS2  = EPSIN2 - EPSIN1
C
C     COMPUTE CURRENT STRAIN AND ESTIMATED NEXT STRAIN
C
      EPS1   = EPSIN2 + DEPS1
      GAMMA  = G NEW
      GAMMAS = G OLD
      EPS2   = EPS1 + GAMMA*DEPS1
C
C     CALL MAT ROUTINE TWICE TO GET SIGMA1 AND SIGMA2 AS A FUNCTION OF
C     EPS1 AND EPS2
C
      MATIDC = IECPT(4)
      MATFLG = 6
      PLAARG = EPS1
      CALL MAT (IECPT(1))
      SIGMA1 = PLAANS
      PLAARG = EPS2
      CALL MAT (IECPT(1))
      SIGMA2 = PLAANS
C
C     ON THE FIRST PASS, I.E. WHEN ECPT(19) = 0.0, SIGMA1 = E  * EPS1
C                                                            0
C
      IF (ECPT(19) .NE. 0.0) GO TO 41
      MATFLG = 1
      CALL MAT (IECPT(1))
      D(2)   = E SUB 0
      SIGMA1 = D(2)*EPS1
C
C     FOR STIFFNESS MATRIX GENERATION, COMPUTE THE NEW MATERIAL
C     PROPERTIES
C
   41 IF (EPS1 .EQ. EPS2) GO TO 42
      E = (SIGMA2-SIGMA1)/(EPS2-EPS1)
      GO TO 44
   42 E = ECPT(20)
C
C     CALL MAT ROUTINE TO GET ELASTIC MODULI.  STORE IN D.P. LOCATIONS.
C
   44 MATFLG = 1
      CALL MAT (IECPT(1))
      D(2) = E SUB 0
      D(4) = GSUB0
C
C     SET UP STIFFNESS MATRIX CONSTANTS IN DSCL AND DSCR
C
      G    = E*D(4)/D(2)
      D(1) = ECPT(5)
      D(3) = ECPT(6)
      DSCL = D(1)*E/XL
      DSCR = D(3)*G/XL
C
C     SET UP THE -N- MATRIX AND STORE AT D(1)
C
      D(1) = XN(1)*XN(1)
      D(2) = XN(1)*XN(2)
      D(3) = XN(1)*XN(3)
      D(4) = D(2)
      D(5) = XN(2)*XN(2)
      D(6) = XN(2)*XN(3)
      D(7) = D(3)
      D(8) = D(6)
      D(9) = XN(3)*XN(3)
C
C     ZERO OUT THE 6X6 WHICH WILL BE USED FOR STORAGE OF
C     KGG(NPVT,NONPVT), NONPVT = NPVT,J
C
      DO 50 I = 1,36
   50 KE(I) = 0.0D0
      NONPVT = 2
      K2 = 1
C
C     IF PIVOT GRID POINT IS IN BASIC COORDINATES, GO TO 70
C
      IF (IECPT(KA) .EQ. 0) GO TO 70
      CALL GMMATD (TA(1),3,3,1, D(1),3,3,0, D(10))
      CALL GMMATD (D(10),3,3,0, TA(1),3,3,0, D(1))
C
C     AT THIS POINT D(1) CONTAINS THE MATRIX PRODUCT TAT*N*TA
C     AND D(10) CONTAINS THE MATRIX PRODUCT TAT*N.
C
      ASSIGN 100 TO IRETRN
      GO TO  80
   70 ASSIGN 90 TO IRETRN
C
C     FILL THE KE MATRIX
C
   80 KE( 1) = DSCL*D(K2  )
      KE( 2) = DSCL*D(K2+1)
      KE( 3) = DSCL*D(K2+2)
      KE( 7) = DSCL*D(K2+3)
      KE( 8) = DSCL*D(K2+4)
      KE( 9) = DSCL*D(K2+5)
      KE(13) = DSCL*D(K2+6)
      KE(14) = DSCL*D(K2+7)
      KE(15) = DSCL*D(K2+8)
      KE(22) = DSCR*D(K2  )
      KE(23) = DSCR*D(K2+1)
      KE(24) = DSCR*D(K2+2)
      KE(28) = DSCR*D(K2+3)
      KE(29) = DSCR*D(K2+4)
      KE(30) = DSCR*D(K2+5)
      KE(34) = DSCR*D(K2+6)
      KE(35) = DSCR*D(K2+7)
      KE(36) = DSCR*D(K2+8)
      CALL PLA4B (KE,IECPT(NONPVT))
C
C     RETURN FROM FILL CODE W/ IRETRN =  90 IMPLIES G.P. A WAS IN BASIC
C       .     .    .     .      .     = 100 IMPLIES G.P. A WAS NOT BASIC
C       .     .    .     .      .     = 140 IMPLIES THE K(NPVT,NONPVT)
C                                       HAS BEEN COMPUTED AND INSERTED
C                                       AND HENCE WE ARE FINISHED.
C
      GO TO IRETRN, (90,100,140)
   90 K1 = 1
      K2 = 10
      GO TO 110
  100 K1 = 10
      K2 = 1
  110 NONPVT = 3
C
C     IF NON-PIVOT GRID POINT IS IN BASIC COORDINATES, GO TO 120
C
      IF (IECPT(KB) .EQ. 0) GO TO 120
C
C     RECALL THAT D(K1) CONTAINS TAT*N.
C
      CALL GMMATD (D(K1),3,3,0, TB(1),3,3,0, D(K2))
C
C     AT THIS POINT D(K2) CONTAINS TAT*N*TB.
C
      GO TO 130
  120 K2 = K1
  130 ASSIGN 140 TO IRETRN
C
C     SET CONSTANTS NEGATIVE TO PROPERLY COMPUTE K(NPVT,NONPVT)
C
      DSCR = -DSCR
      DSCL = -DSCL
      GO TO 80
C
C     A TRANSFER TO STATEMENT NO. 140 IMPLIES KGGNL CALCULATIONS HAVE
C     BEEN COMPLETED.  UPDATE ECPT ARRAY.
C
  140 IF (IND .EQ. 0) GO TO 150
      ITEMP    = IECPT(2)
      IECPT(2) = IECPT(3)
      IECPT(3) = ITEMP
  150 ECPT(18) = ECPT(19)
      ECPT(19) = EPS1
      ECPT(20) = E
      RETURN
      END

        SUBROUTINE GETSTB ( *, BLOCK )
      INCLUDE 'DSIOF.COM'
      INCLUDE 'XNSTRN.COM'
        INTEGER BLOCK( 15 )
        IRETRN = 0
        NAME   = BLOCK( 1 )
        CALL DSGEFL
        IF ( BLOCK( 8 ) .NE. -1 ) GO TO 100
        IF ( ( INDCLR-INDBAS ) .GT. 5 ) GO TO 10
        CALL DSRDPB
10      INDCBP = INDCBP - 1
        ID = IAND( IBASE( INDCBP ), MASKQ1 )
        IF ( ID .NE. IDSRT ) CALL DSMSG( 114 )
        INDCBP = INDCBP - 2
        ID     = IAND( IBASE( INDCBP ), MASKQ1 )
        IF ( ID .NE. IDSCT ) CALL DSMSG ( 115 )
        CALL DSPRCL( BLOCK )
        BLOCK( 8 ) = 0
100     INDCBP = INDCBP - 2
        IF ( ( INDCBP-INDBAS ) .GT. 5 ) GO TO 110
        CALL DSRDPB
        INDCBP = INDCBP + 1
        GO TO 100
110     ID = IAND( IBASE( INDCBP ), MASKQ1 )
        IF ( ID .EQ. IDSCH ) GO TO 130
        IF ( ID .EQ. IDSST ) GO TO 120
        IF ( ID .EQ. IDSSH ) GO TO 100
        IF ( ID .EQ. IDSRT ) GO TO 100
        IF ( ID .EQ. IDSSD ) GO TO 100
        IF ( ID .EQ. IDSSE ) GO TO 100
CWKBNB 1/94
        ID = IAND( IBASE( INDCBP+1 ), MASKQ1 )
        IF ( ID .NE. IDSSD ) GO TO 116
        INDCBP = INDCBP + 1
        GO TO 100
CWKBNE 1/94
CWKBR 1/94  CALL DSMSG ( 116 )
116     CALL DSMSG ( 116 )
120     BLOCK( 4 ) = IBASE( INDCBP+1 )
        BLOCK( 6 ) = IAND( IBASE( INDCBP ), MASKH2 )
        IDIV   = MIN0( 2, BLOCK( 11 ) )
        BLOCK( 5 ) = INDCBP-1
        IF ( BLOCK( 2 ) .EQ. 2 ) BLOCK( 5 ) = ( INDCBP-1 ) / IDIV
        IF ( BLOCK( 2 ) .EQ. 3 ) BLOCK( 5 ) =   INDCBP-2
        IF ( BLOCK( 2 ) .EQ. 4 ) BLOCK( 5 ) = ( INDCBP-3 ) / IDIV
        GO TO 7000
130     INDCBP = INDCBP - 1
        INDCLR = INDCBP
        BLOCK( 8 ) = 1
        IRETRN = 1
7000    CALL DSSDCB
        IF ( IRETRN .EQ. 1 ) RETURN 1
        RETURN
        END

      SUBROUTINE PLOAD4 (IBUF5,IDO,JOPEN)
C
C     TO GENERATE PLOAD4 PRESSURE LOAD FOR QUAD4 AND TRIA3 ELEMENTS.
C
C     BOTH ELEMENT TYPES MAY BE PRESENT, OR ONLY ONE OF THE TWO IS
C     PRESENT.
C
C     THIS ROUTINE IS CALLED ONLY BY EXTERN IN SSG1 MODULE, LINK5
C
C     THIS ROUTINE  CALLS PLOD4D OR PLOD4S TO COMPUTE LOAD FOR QUAD4
C     ELEMENTS, AND CALLS T3PL4D OR T3PL4S TO COMPUTE LOAD FOR TRIA3
C
C     IN OVERLAY TREE, THIS ROUTINE SHOULD BE IN PARALLELED WITH FPONT
C     ROUTINE, AND FOLLOWED BY PLOD4D/S AND T3PL4D/S. I.E.
C
C                   ( FPONT
C            EXTERN (        ( PLOD4D  (/ZZSSA1/
C                   ( PLOAD4 ( PLOD4S
C                            ( T3PL4D
C                            ( T3PL4S
C
      LOGICAL         ALLIN,DEBUG
      INTEGER         IZ(1),NAME(2),FILE,SLT,EST,QUAD4,TRIA3,T3,Q4
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /ZZZZZZ/ CORE(1)
      COMMON /LOADX / LCARE,SLT,IDUM(5),EST
      COMMON /SYSTEM/ IBUF,NOUT,JDUM(52),IPREC
      COMMON /PINDEX/ IEST(45),ISLT(11)
      COMMON /GPTA1 / NELEM,LAST,INCR,IELEM(1)
      EQUIVALENCE     (CORE(1),IZ(1))
      DATA    QUAD4 , TRIA3 , NAME          /
     1        64    , 83    , 4HPLOA,4HD4   /
      DATA    DEBUG / .FALSE. /
C
C
C     T3 AND Q4 KEEP TRACK OF THE PRESENCE OF THE CTRIA3 AND CQUAD4
C     ELEMENTS
C
      T3    = 0
      Q4    = 0
      LCORE = IBUF5 - IBUF
      IDO11 = IDO*11
      ALLIN = .FALSE.
      IF (IDO11 .GT. LCORE) GO TO 400
      IF (DEBUG) WRITE (NOUT,300)
  300 FORMAT (/,' * PLOAD4 IS CALLED FOR ONE LOAD CASE')
C
C     OPEN CORE IS BIG ENOUGH TO HOLD ALL PLOAD4 DATA.
C     READ THEM ALL INTO CORE
C     (BAD NEWS - OPEN CORE AT THIS TIME IS NOT AVAILABLE)
C
      IF (.NOT.ALLIN) GO TO 400
C
      ALLIN = .TRUE.
      FILE  = SLT
      IMHERE= 350
      CALL READ (*620,*630,SLT,CORE,IDO11,0,FLAG)
C
C     OPEN CORE NOT LARGE ENOUGH TO HOLD ALL PLOAD4 DATA
C
  400 IF (JOPEN .EQ. 1) GO TO 415
      JOPEN = 1
      FILE  = EST
      CALL OPEN  (*610,EST,CORE(IBUF5),0)
      CALL FWDREC (*620,EST)
      FILE = EST
  410 CALL READ (*430,*560,EST,IELTYP,1,0,FLAG)
  415 IF (IELTYP .EQ. QUAD4) GO TO 440
      IF (IELTYP .EQ. TRIA3) GO TO 445
  420 CALL FWDREC (*430,EST)
      GO TO 410
  430 IF (T3+Q4 .NE. 0) GO TO 560
      WRITE  (NOUT,435) UFM
  435 FORMAT (A23,', PLOAD4 PRESSURE LOAD IS USED WITHOUT THE PRESENCE',
     1       ' OF QUAD4 OR TRIA3 ELEMENT')
      IMHERE = 435
      GO TO 620
C
  440 IF (Q4 .GE. 1) GO TO 420
      Q4 = 1
      IF (DEBUG) WRITE (NOUT,441) T3
  441 FORMAT (/,'   QUAD4 ELEM FOUND. SETTING Q4 TO 1.  T3 =',I3)
      GO TO 450
  445 IF (T3 .EQ. 1) GO TO 420
      T3 = 1
      IF (DEBUG) WRITE (NOUT,446) Q4
  446 FORMAT (/,'   TRIA3 ELEM FOUND. SETTING T3 TO 1.  Q4 =',I3)
  450 J  = INCR*(IELTYP-1)
      NWORDS = IELEM(J+12)
      IEST(1)= 0
C
      FILE = SLT
      IB   = 0
      IMHERE = 550
      DO 550 J = 1,IDO
      IF (ALLIN) GO TO 460
      JSAVE = J
      IF (J.EQ.1 .AND. T3+Q4.GE.2) GO TO 470
      CALL READ (*620,*630,SLT,ISLT,11,0,FLAG)
      GO TO 470
  460 DO 465 I = 1,11
  465 ISLT(I) = IZ(I+IB)
      IB = IB + 11
  470 IF (ISLT(1)-IEST(1)) 550,490,480
  480 CALL READ (*560,*560,EST,IEST,NWORDS,0,FLAG)
      GO TO 470
C
  490 IF (IELTYP .EQ. TRIA3) GO TO 520
C
C     PLOAD4 FOR QUAD4 ELEMENT
C
      IF (DEBUG) WRITE (NOUT,500) IEST(1)
  500 FORMAT (' ==> PROCESS PLOAD4 FOR QUAD ELEM',I8)
      GO TO (505,510), IPREC
  505 CALL PLOD4S
      GO TO 550
  510 CALL PLOD4D
      GO TO 550
C
C     PLOAD4 FOR TRIA3 ELEMENT
C     SET ISLT(1) TO NEGATIVE FOR PLOAD4/TRIA3 COMPUTATION
C
  520 IF (DEBUG) WRITE (NOUT,525) IEST(1)
  525 FORMAT (' ==> PROCESS PLOAD4 FOR TRIA3 ELEM',I8)
      ISLT(1) = -IABS(ISLT(1))
      GO TO (530,540), IPREC
  530 CALL T3PL4S
      GO TO 550
  540 CALL T3PL4D
C
  550 CONTINUE
C
  560 IF (T3+Q4 .GE. 2) GO TO 580
C
C     JUST FINISHED EITHER QUAD4 OR TRIA3 ELEMENT. BACKSPACE EST FILE,
C     AND BACKSPACE SLT FILE IF SLT DATA ARE NOT ALREADY IN CORE.
C     REPEAT PLOAD4 (LOAD TYPE 25) COMPUTAION FOR THE OTHER ELEMENT
C     (TRIA3 OR QUAD4) WHICH WE HAVE NOT YET PROCESSED IN THE FIRST
C     PASS. MUST STEP OVER OTHER LOADS THAT MIGHT BE PRESENT
C
      CALL BCKREC (EST)
      Q4    = Q4 + 1
      JSAVE = 0
      IF (ALLIN) GO TO 410
C
      CALL BCKREC (SLT)
      IMHERE = 570
  570 CALL READ (*620,*630,SLT,I,1,0,FLAG)
      IF (I .NE. 25) GO TO 570
      IMHERE = 573
      CALL READ (*620,*630,SLT,I,1,0,FLAG)
      IF (I .NE. IDO) GO TO 570
      IMHERE = 575
      CALL READ (*620,*630,SLT,ISLT,6,0,FLAG)
      IF (ISLT(6) .NE. -1) GO TO 570
      IMHERE = 577
      CALL READ (*620,*630,SLT,ISLT(7),5,0,FLAG)
      IF (ISLT(7) .NE. 0) GO TO 570
      JSAVE = 1
      GO TO 410
C
  580 IF (JOPEN .EQ. 1) CALL CLOSE (EST,1)
      JOPEN = 0
      IF (ALLIN .OR. JSAVE.GE.IDO) GO TO 600
      IMHERE = 590
      J = (IDO-JSAVE)*11
      CALL READ (*640,*640,SLT,0,-J,0,FLAG)
  600 RETURN
C
  610 J = -1
      GO TO 650
  620 J = -2
      GO TO 650
  630 J = -3
      GO TO 650
  640 J = 1
  650 WRITE  (NOUT,660) IMHERE,T3,Q4,IDO,JSAVE
  660 FORMAT ('   IMHERE =',I5,'   T3,Q4 =',2I3,'   IDO,JSAVE =',2I5)
      CALL MESAGE (J,FILE,NAME(1))
      GO TO 600
      END

      SUBROUTINE DLOOP (X,Y,MPY,END)
C*******
C     DLOOP IMPROVES THE EFFICIENCY OF AN INNER DCOMP LOOP
C*******
      DOUBLE PRECISION   X(1)      ,Y(1)     ,MPY
C*******
C     DDLOOP IMPROVES THE EFFICIENCY OF THE ACTIVE ROW LOOP
C*******
      DOUBLE PRECISION   A         ,B(1)     ,C(1)
      DOUBLE PRECISION XX(1),YY(1)
      INTEGER            END
      DO 10 I = 1,END
   10 X(I) = X(I)+MPY*Y(I)
      RETURN
C*******************************
      ENTRY DDLOOP (A,B,C,ENDD)
      DO 20 I = 1,ENDD
   20 A = A-B(I)*C(I)
      RETURN
C************
C     ENTRY FOR ANOTHER LOOP
C***********
      ENTRY XLOOP(XX,YY,NN)
      DO 105 I = 1,NN
  105 XX(I) = YY(I)
      RETURN
      END

      INTEGER FUNCTION KHRFN4 (WORD)
C
C     REVERSE BYTES FOR SORTING (USED MAINLY BY THE VAX MACHINE)
C
      INTEGER      WORD(1),  W1,    W2
      CHARACTER*1  C1(4),    C2(4)
      EQUIVALENCE (C1(1),W1),(C2(1),W2)
C
      W1=WORD(1)
      C2(1)=C1(4)
      C2(2)=C1(3)
      C2(3)=C1(2)
      C2(4)=C1(1)
      KHRFN4=W2
      RETURN
C
C     CDC VERSION
C     ===========
C
C     CHARACTER*1 WORD(10),C2(10)
C
C     C2(1)=WORD(4)
C     C2(2)=WORD(3)
C     C2(3)=WORD(2)
C     C2(4)=WORD(1)
C     DO 10 J=5,10
C 10  C2(J)=WORD(J)
C     KHRFN4=ISWAP(C2)
C
      END

      SUBROUTINE SYMBOL (X,Y,SYMX,OPT)
C
C     (X,Y) = POINT AT WHICH THE SYMBOLS ARE TO BE TYPED.
C     SYMX  = SYMBOLS TO BE TYPED.
C     OPT   = -1 TO INITIATE  THE TYPING MODE.
C           = +1 TO TERMINATE THE TYPING MODE.
C           =  0 TO TYPE THE SYMBOL.
C
      INTEGER SYM,SYMX(2),OPT,PLOTER,SYMBL
      COMMON /PLTDAT/ MODEL,PLOTER
      COMMON /SYMBLS/ NSYM, SYMBL(20,2)
C
      IF (OPT .EQ. 0) GO TO 110
      CALL TIPE (0,0,0,0,0,OPT)
      GO TO 200
C
  110 DO 150 I = 1,2
      IF (SYMX(I) .LE. 0) GO TO 150
      SYM = SYMX(I) - NSYM*((SYMX(I)-1)/NSYM)
      SYM = SYMBL(SYM,PLOTER)
      CALL TYPE10 (X,Y,0,SYM,0,0)
      GO TO 150
  150 CONTINUE
C
  200 RETURN
      END

      SUBROUTINE Q4SHPS (XI,ETA, SHP, SSHP)
C     &    ENTRY Q4SHPD (DI,ETD,DSHP,DSSHP)
C
C*****
C     COMPUTES SHAPE FUNCTIONS AND THEIR DERIVATIVES
C     FOR THE QUAD4 ELEMENT
C*****
C
      REAL             XI,ETA, SHP(4), SSHP(8),CLC(2,4)
      DOUBLE PRECISION DI,ETD,DSHP(4),DSSHP(8),DLD(2,4)
      DATA   CLC /-1.0  ,-1.0  ,1.0  ,-1.0  ,1.0  ,1.0  ,-1.0  ,1.0  /
      DATA   DLD /-1.0D0,-1.0D0,1.0D0,-1.0D0,1.0D0,1.0D0,-1.0D0,1.0D0/
C
C     SINGLE PRECISION -
C
      DO 10 I=1,4
      SHP (I  ) = 0.25 * (1.0+XI *CLC(1,I)) * (1.0+ETA*CLC(2,I))
      SSHP(I  ) = 0.25 * (1.0+ETA*CLC(2,I)) * CLC(1,I)
      SSHP(I+4) = 0.25 * (1.0+XI *CLC(1,I)) * CLC(2,I)
   10 CONTINUE
      RETURN
C
      ENTRY Q4SHPD (DI,ETD,DSHP,DSSHP)
C     ================================
C
C     DOUBLE PRECISION -
C
      DO 20 I=1,4
      DSHP (I  ) = .25D0 * (1.D0+DI *DLD(1,I)) * (1.D0+ETD*DLD(2,I))
      DSSHP(I  ) = .25D0 * (1.D0+ETD*DLD(2,I)) * DLD(1,I)
      DSSHP(I+4) = .25D0 * (1.D0+DI *DLD(1,I)) * DLD(2,I)
   20 CONTINUE
      RETURN
      END

      SUBROUTINE REMFLX (NGRIDS)
C
C     CHECK FOR REMFLUX IN MAGNETIC FIELD PROBLEMS WHEN COMPUTING
C     PROLATE SPHEROIDAL COEFFICIENTS
C
      LOGICAL         REMFL,HITONE
      INTEGER         REMFLD,SCR1,BUF1,BUF3,BUF2,HEST,MCB(7),FILE,
     1                POINTR(6,19),IPOINT(32),DIT,DITFIL,ELTYPE,ESTWDS
      DIMENSION       NAM(2),REM(3),ECPT(200),NECPT(200),IZ(1),G(3,3),
     1                IWORK(3,3)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /GPTA1 / NELEMS,LAST,INCR,NE(1)
      COMMON /MATIN / MATID,INFLAG,ELTEMP,STRESS,SINTH,COSTH
      COMMON /HMTOUT/ XMAT(6)
      COMMON /HMATDD/ IIHMAT,NNHMAT,MPTFIL,DITFIL
      COMMON /UNPAKX/ JOUT,II,NN,JNCR
      COMMON /SYSTEM/ IBUF,IOUT
      COMMON /ZZZZZZ/ Z(1)
      COMMON /BIOT  / DUM(10),BUF1,REMFL,LCORE
      EQUIVALENCE     (Z(1),IZ(1)),(ECPT(1),NECPT(1))
      DATA    REMFLD, HEST,MPT,DIT, SCR1/
     1        107   , 108 ,109,110, 301 /
      DATA    NAM   / 4HREMF  ,4HLX     /
C
C                   TYPE  ISIL   MID   ITH NGRIDS ITEMP
C
      DATA    POINTR/ 1,    2,    4,    0,    2,    17,
     1                3,    2,    4,    0,    2,    16,
     2                6,    2,    6,    5,    3,    27,
     3                9,    2,    6,    5,    3,    21,
     4               10,    2,    4,    0,    2,    17,
     5               16,    2,    7,    6,    4,    26,
     6               17,    2,    6,    5,    3,    21,
     7               18,    2,    7,    6,    4,    26,
     8               19,    2,    7,    6,    4,    32,
     9               34,    2,   16,    0,    2,    42,
     O               36,    2,    6,    5,    3,    19,
     1               37,    2,    7,    6,    4,    24,
     2               39,    3,    2,    0,    4,    23,
     3               40,    3,    2,    0,    6,    33,
     4               41,    3,    2,    0,    8,    43,
     5               42,    3,    2,    0,    8,    43,
     6               65,    2,   10,    0,    8,    48,
     7               66,    2,   22,    0,   20,   108,
     8               67,    2,   34,    0,   32,   168  /
C
      REMFL  = .FALSE.
      MCB(1) = REMFLD
      CALL RDTRL (MCB)
C
C     CHECK FOR ANY REMFLUX
C
      IF (MCB(6) .EQ. 0) RETURN
C
C     TOO BAD
C
      REMFL  = .TRUE.
      NCOL   = MCB(2)
      NROW   = MCB(3)
      NCOUNT = NROW/3
C
C     BRING IN MATERIALS SINCE H=B/MU
C
      IIHMAT = NGRIDS
      NNHMAT = LCORE
      MPTFIL = MPT
      DITFIL = DIT
      CALL PREHMA (Z)
      NEXTZ  = NNHMAT + 1
C
      BUF2   = BUF1 - IBUF
      BUF3   = BUF2 - IBUF
C
C     SET UP POINTERS
C     IHC = START OF RESULTS HC = B/MU
C     IREM= REMFL COLUMN
C     ICT = COUNTER FOR NUMBER OF ELEMENTS AT EACH PROLATE GRID (FOR
C     AVERAGING
C
      IHC  = NEXTZ
      IREM = IHC + 3*NGRIDS
      ICT  = IREM + NROW
      IF (BUF3 .LT. ICT+NGRIDS) GO TO 1008
C
      CALL GOPEN (SCR1,Z(BUF1),1)
      CALL GOPEN (REMFLD,Z(BUF2),0)
      CALL GOPEN (HEST,Z(BUF3),0)
C
      II = 1
      NN = NROW
      JNCR = 1
      JOUT = 1
      JCOUNT = 0
C
    3 DO 5 I = 1,NGRIDS
    5 IZ(ICT+I) = 0
      N3 = 3*NGRIDS
      DO 6 I = 1,N3
    6 Z(IHC+I) = 0.
C
C     UNPACK A COULMN OF REMFLD
C
      JCOUNT = JCOUNT + 1
      CALL UNPACK (*20,REMFLD,Z(IREM+1))
      GO TO 40
C
C     ZERO COLUMN
C
   20 DO 30 I = 1,N3
   30 Z(IHC+I) = 0.
      GO TO 130
C
C     SINCE THE ELEMENT DATA DO NOT CHANGE WITH REMFLD COLIMN, THIS IS
C     NOT NECESSARILY THE BEST KIND OF LOOPING. BUT OTHER WAYS WOULD
C     NEED MORE CORE AND IF THERE IS MORE THAN ONE REMFLUX CASE, IT
C     WOULD BE A SURPRISE
C
   40 FILE  = HEST
      KOUNT = 0
   45 CALL READ (*100,*1003,HEST,ELTYPE,1,0,IFLAG)
      IDX   = (ELTYPE-1)*INCR
      ESTWDS= NE(IDX+12)
C
C     PICK UP ELEMENT TYPE INFO
C
      DO 50 I = 1,19
      JEL = I
      IF (ELTYPE-POINTR(1,I)) 500,60,50
   50 CONTINUE
      GO TO 500
C
   60 ISIL  = POINTR(2,JEL)
      IMID  = POINTR(3,JEL)
      ITH   = POINTR(4,JEL)
      IGRIDS= POINTR(5,JEL)
      ITEMP = POINTR(6,JEL)
C
   65 CALL READ (*1002,*45,HEST,ECPT,ESTWDS,0,IFLAG)
C
C     PICK UP REMFLUX FOR THIS ELEMENT
C
      KOUNT = KOUNT + 1
      NHIT  = 0
      HITONE= .FALSE.
      DO 650 I = 1,IGRIDS
  650 IPOINT(I) = 0
      DO 68 I = 1,NGRIDS
      DO 66 J = 1,IGRIDS
      IPT = NECPT(ISIL+J-1)
      IF (IPT .EQ. IZ(I)) GO TO 67
   66 CONTINUE
      GO TO 68
C
C     MATCH
C
   67 HITONE = .TRUE.
      NHIT   = NHIT + 1
      IZ(ICT+I) = IZ(ICT+I) + 1
      IPOINT(J) = I
      IF (NHIT .EQ. IGRIDS) GO TO 69
   68 CONTINUE
      IF (.NOT.HITONE) GO TO 65
   69 CONTINUE
C
      ISUB   = IREM + 3*(KOUNT-1)
      REM(1) = Z(ISUB+1)
      REM(2) = Z(ISUB+2)
      REM(3) = Z(ISUB+3)
C
C     PICK UP MATERIALS
C
      MATID  = NECPT(IMID)
      ELTEMP = ECPT(ITEMP)
      INFLAG = 3
      SINTH  = 0.
      COSTH  = 0.
      CALL HMAT (NECPT(1))
      G(1,1) = XMAT(1)
      G(1,2) = XMAT(2)
      G(1,3) = XMAT(3)
      G(2,1) = XMAT(2)
      G(2,2) = XMAT(4)
      G(2,3) = XMAT(5)
      G(3,1) = XMAT(3)
      G(3,2) = XMAT(5)
      G(3,3) = XMAT(6)
C
C     FOR COMMENTS ON MATERIALS SEE EM2D
C
      IF (ITH .EQ. 0) GO TO 80
      ANGLE = ECPT(ITH)*0.017453293
      IF (XMAT(3).EQ.0. .AND. XMAT(5).EQ.0.) GO TO 70
      GO TO 80
   70 IF (ABS(ANGLE) .LE. .0001) GO TO 80
      S   = SIN(ANGLE)
      C   = COS(ANGLE)
      CSQ = C*C
      SSQ = S*S
      CS  = C*S
      X2  = 2.*CS*XMAT(2)
      G(1,1) = CSQ*XMAT(1) - X2 + SSQ*XMAT(4)
      G(1,2) = CS*(XMAT(1) - XMAT(4)) + (CSQ-SSQ)*XMAT(2)
      G(2,2) = SSQ*XMAT(1) + X2 + CSQ*XMAT(4)
      G(2,1) = G(1,2)
      G(3,3) = XMAT(6)
      G(1,3) = 0.
      G(2,3) = 0.
      G(3,1) = 0.
      G(3,2) = 0.
C
C     SINCE MAT5 INFO FOR TRAPRG,TRIARG IS GIVEN IN X-Y ORDER,
C     INETRCHANGE YA AND Z
C
      TEMP   = G(2,2)
      G(2,2) = G(3,3)
      G(3,3) = TEMP
      TEMP   = G(1,2)
      G(1,2) = G(1,3)
      G(1,3) = TEMP
      G(2,1) = G(1,2)
      G(3,1) = G(1,3)
C
C     SOLVE MU*H = B
C
   80 CALL INVERS (3,G,3,REM,1,DET,ISING,IWORK)
      IF (ISING .EQ. 2) GO TO 510
C
C     REM NOW HAS HC- CHECK POINTER LIST TO SEE WHICH GRIDS ARE ON THE
C     SPHEROID AND ADD REMFLUX T THOSE ALREADY ACCUMULATED
C
      DO 90 I = 1,IGRIDS
      IF (IPOINT(I) .EQ. 0) GO TO 90
      ISUB = IHC + 3*(IPOINT(I)-1)
      DO 85 J = 1,3
      Z(ISUB+J) = Z(ISUB+J) + REM(J)
   85 CONTINUE
   90 CONTINUE
C
C     GO BACK FOR ANOTHER ELEMEENT
C
      GO TO 65
C
C     DONE WITH ALL TYPES-AVERAGE THE RESULTS BY NUMBER OF ELEMENTS AT
C     EACH
C
  100 DO 120 I = 1,NGRIDS
      DEN = FLOAT(IZ(ICT+I))
      IF (DEN .EQ. 0.) GO TO 120
      ISUB = 3*(I-1) + IHC
      DO 110 J = 1,3
      Z(ISUB+J) = Z(ISUB+J)/DEN
  110 CONTINUE
  120 CONTINUE
C
C     WRITE RESULTS TO SCR1
C
  130 CALL WRITE (SCR1,Z(IHC+1),3*NGRIDS,1)
C
C     GO BACK FOR ANOTHER REMFLD RECORD
C
      IF (JCOUNT .EQ. NCOL) GO TO 140
      CALL REWIND (HEST)
      CALL FWDREC (*1002,HEST)
      GO TO 3
C
C     DONE
C
  140 CALL CLOSE (SCR1,1)
      MCB(1) = SCR1
      MCB(2) = NCOL
      MCB(3) = 3*NGRIDS
      DO 150 I = 4,7
  150 MCB(I) = 0
      CALL WRTTRL (MCB)
      CALL CLOSE (HEST,1)
      CALL CLOSE (REMFLD,1)
      RETURN
C
  500 WRITE  (IOUT,501) UFM
  501 FORMAT (A23,', ILLEGAL ELEMENT TYPE IN REMFLX')
      GO TO  1061
  510 WRITE  (IOUT,511) UFM,MATID
  511 FORMAT (A23,', MATERIAL',I9,' IS SINGULAR IN REMFLX')
      GO TO  1061
C
 1002 N = -2
      GO TO 1010
 1003 N = -3
      GO TO 1010
 1008 N = -8
      FILE = 0
 1010 CALL MESAGE (N,FILE,NAM)
 1061 CALL MESAGE (-61,0,0)
      RETURN
      END

      SUBROUTINE ALG19 (LOG1,LOG2,LOG3,LOG5,NLINES,NSPEC,KPTS,RSTA,
     1                  XSTA,R,ZR,B1,B2,TC,PI,C1,NBLADE,CCORD,BLOCK,
     2                  ALPB,EPSLON,IFANGS,IPUNCH,NAERO)
C
      DIMENSION       IDATA(24),RDATA(6),KPTS(1),RSTA(21,10),
     1                XSTA(21,10),R(10,21),ZR(1),B1(1),B2(1),TC(1),
     2                CCORD(1),BLOCK(10,21),ALPB(10,21),EPSLON(10,21),
     3                NR(10),NTERP(10),NMACH(10),NLOSS(10),NL1(10),
     4                NL2(10),NEVAL(10),NCURVE(10),NLITER(10),NDEL(10),
     5                RR(21,10),XLOSS(21,10),RTE(5),DM(11,5),
     6                DVFRAC(11,5),RDTE(21),DELTAD(21),AC(21),F137B(8),
     7                F137S(5),F142TC(7),F161D(8,5),F195M(8,2),F164XB(8)
     8,               F172K(7),NOUT1(10),NOUT2(10),SOL(21),DEV(10,21),
     9                DEVV(10,5),DX(10),X(10),DOO(5),IFANGS(1),
     O                NOUT3(10),NBLAD(10)
      COMMON /UD3PRT/ IPRTC
      DATA    F137B / 0.0,10.0,20.0,30.0,40.0,50.0,60.0,70.0/
      DATA    F137S / 0.4,0.8,1.2,1.6,2.0/
      DATA    F142TC/ 0.0,0.02,0.04,0.06,0.08,0.10,0.12/
      DATA    F161D / 0.0,0.009,0.17,0.29,0.42,0.59,0.79,1.05,0.0,0.12,
     1                0.30,0.51,0.75,1.05,1.47,2.07,0.0,0.16,0.33,0.61,
     2                0.95,1.42,2.12,3.07,0.0,0.17,0.40,0.72,1.11,1.71,
     3                2.62,3.95,0.0,0.2,0.44,0.78,1.21,1.90,3.01,4.75/
      DATA    F195M / 0.17,0.173,0.179,0.189,0.206,0.232,0.269,0.310,
     1                0.25,0.255,0.261,0.268,0.278,0.292,0.312,0.342 /
      DATA    F164XB/ 0.965,0.945,0.921,0.890,0.850,0.782,0.679,0.550/
      DATA    F172K / 0.0,0.160,0.331,0.521,0.74,1.0,1.300/
C
      LMAX   = 60
      CALL FREAD (LOG1,IDATA,6,1)
      NRAD   = IDATA(1)
      NDPTS  = IDATA(2)
      NDATR  = IDATA(3)
      NSWITC = IDATA(4)
      NLE    = IDATA(5)
      NTE    = IDATA(6)
      CALL FREAD (LOG1,RDATA,2,1)
      XKSHPE = RDATA(1)
      SPEED  = RDATA(2)
      CALL FREAD (LOG1,IDATA,3,1)
      NOUT1(NLE) = IDATA(1)
      NOUT2(NLE) = IDATA(2)
      NOUT3(NLE) = IDATA(3)
      IF (IPRTC .EQ. 1) WRITE (LOG2,20) NRAD,NDPTS,NDATR,NSWITC,NLE,NTE,
     1       XKSHPE,SPEED,NLE,NOUT1(NLE),NOUT2(NLE),NOUT3(NLE)
   20 FORMAT (1H1,9X,'DATA INTERFACING ROUTINE - DEVIATION CALCULATIONS'
     1,      ' AND DATA FORMATTING', /10X,69(1H*), /10X,5HINPUT, /10X,
     2       5(1H*), //10X,6HNRAD =,I3,9H  NDPTS =,I3,9H  NDATR =,I3,
     3       11H  NSWITCH =,I2,7H  NLE =,I2,7H  NTE =,I3, //10X,
     4       8HXKSHPE =,F7.4,9H  SPEED =,F9.1, //10X,'AT LEADING EDGE ',
     5       '(STATION,I3,9H) NOUT1 =',I2,9H  NOUT2 =,I2,9H  NOUT3 =,I2)
      LNCT = 10
      K    = NLE + 1
      DO 80 I = K,NTE
      CALL FREAD (LOG1,IDATA,14,1)
      NR(I)     = IDATA(1)
      NTERP(I)  = IDATA(2)
      NMACH(I)  = IDATA(3)
      NLOSS(I)  = IDATA(4)
      NL1(I)    = IDATA(5)
      NL2(I)    = IDATA(6)
      NEVAL(I)  = IDATA(7)
      NCURVE(I) = IDATA(8)
      NLITER(I) = IDATA(9)
      NDEL(I)   = IDATA(10)
      NOUT1(I)  = IDATA(11)
      NOUT2(I)  = IDATA(12)
      NOUT3(I)  = IDATA(13)
      NBLAD(I)  = IDATA(14)
      IF (LNCT+6+NR(I) .LE. LMAX) GO TO 50
      IF (IPRTC .NE. 0) WRITE (LOG2,40)
   40 FORMAT (1H1)
      LNCT = 1
   50 LNCT = LNCT + 6 + NR(I)
      IF (IPRTC .EQ. 1) WRITE (LOG2,60) I,NR(I),NTERP(I),NMACH(I),
     1       NLOSS(I),NL1(I),NL2(I),NEVAL(I),NCURVE(I),NLITER(I),
     2       NDEL(I),NOUT1(I),NOUT2(I),NOUT3(I),NBLAD(I)
   60 FORMAT (/10X,7HSTATION,I3,7H   NR =,I3,9H  NTERP =,I2,9H  NMACH =,
     1       I2,9H  NLOSS =,I2,7H  NL1 =,I3,7H  NL2 =,I3,9H  NEVAL =,I2,
     2       8HNCURVE =,I2,10H  NLITER =,I3,8H  NDEL =,I2, /22X,
     3       7HNOUT1 =,I2,9H  NOUT2 =,I2,9H  NOUT3 =,I2,9H  NBLAD =,I3)
      L1 = NR(I)
      DO 70 J = 1,L1
      CALL FREAD (LOG1,RDATA,2,1)
      RR(J,I)    = RDATA(1)
   70 XLOSS(J,I) = RDATA(2)
   80 IF (IPRTC .EQ. 1) WRITE (LOG2,90) (RR(J,I),XLOSS(J,I),J=1,L1)
   90 FORMAT (/14X,6HRADIUS,6X,15HLOSS DESCRIPTOR,//,(F20.4,F17.6))
      IF (LNCT+7+NDPTS .LE. LMAX) GO TO 100
      IF (IPRTC .NE. 0) WRITE (LOG2,40)
      LNCT = 1
  100 LNCT = LNCT + 2
      IF (IPRTC .EQ. 1) WRITE (LOG2,110) NRAD
  110 FORMAT (/10X,28HDEVIATION FRACTION CURVES AT,I2,6H RADII)
      DO 140 K = 1,NRAD
      IF (LNCT+5+NDPTS .LE. LMAX) GO TO 120
      IF (IPRTC .NE. 0) WRITE (LOG2,40)
      LNCT = 1
  120 LNCT = LNCT + 5 + NDPTS
      CALL FREAD (LOG1,RTE(K),1,1)
      DO 130 J = 1,NDPTS
      CALL FREAD (LOG1,RDATA,2,1)
      DM(J,K)     = RDATA(1)
  130 DVFRAC(J,K) = RDATA(2)
  140 IF (IPRTC .EQ. 1) WRITE (LOG2,150) RTE(K),(DM(J,K),DVFRAC(J,K),
     1       J=1,NDPTS)
  150 FORMAT (/10X,5HRTE =,F8.4, //15X,2HDM,10X,6HDVFRAC, //,
     1       (F20.5,F13.5))
      DO 160 J = 1,NDATR
      CALL FREAD (LOG1,RDATA,3,1)
      RDTE(J)   = RDATA(1)
      DELTAD(J) = RDATA(2)
  160 AC(J)     = RDATA(3)
      IF (LNCT+3+NDATR .LE. LMAX) GO TO 170
      IF (IPRTC .NE. 0) WRITE (LOG2,40)
      LNCT = 1
  170 LNCT = LNCT + 3 + NDATR
      IF (IPRTC .EQ. 1) WRITE (LOG2,180) (RDTE(J),DELTAD(J),AC(J),
     1       J=1,NDATR)
  180 FORMAT (/15X,4HRDTE,6X,6HDELTAD,9X,2HAC,//,(F20.4,F11.3,F13.4))
      IF (LNCT+6+NLINES .LE. LMAX) GO TO 190
      IF (IPRTC .NE. 0) WRITE (LOG2,40)
      LNCT = 1
  190 LNCT = LNCT + 6 + NLINES
      IF (IPRTC .EQ. 1) WRITE (LOG2,200)
  200 FORMAT (/10X,7HRESULTS, /,10X,7(1H*))
      IF (IPRTC .EQ. 1) WRITE (LOG2,210)
  210 FORMAT (/5X,10HSTREAMLINE,5X,5HBETA1,6X,5HBETA2,5X,6HCAMBER,7X,
     1       3HT/C,8X,3HA/C,6X,8HSOLIDITY,4X,11HADDIT. DEVN,4X,
     2       15HTOTAL DEVIATION,/)
      DO 290 J = 1,NLINES
      XJ = J
      CALL ALG15 (ZR,B1,NSPEC,XJ,BETA1,1,0)
      CALL ALG15 (ZR,B2,NSPEC,XJ,BETA2,1,0)
      CALL ALG15 (ZR,TC,NSPEC,XJ,THICK,1,0)
      Q = 1.0
      IF (SPEED .GT. 0.0) Q = -1.0
      CAMBER = (BETA1-BETA2)*Q
      SOLID  = CCORD(J)*FLOAT(NBLADE)/(PI*(R(NLE,J)+R(NTE,J)))
      BETA1  = BETA1*Q
      CALL ALG15 (F137B,F195M(1,NSWITC),8,BETA1,XMS,1,0)
      CALL ALG15 (F137B,F164XB,8,BETA1,XB,1,0)
      CALL ALG15 (F142TC,F172K,7,THICK,XKDT,1,0)
      DO 220 K = 1,5
  220 CALL ALG15 (F137B,F161D(1,K),8,BETA1,DOO(K),1,0)
      CALL ALG15 (F137S,DOO,5,SOLID,DO,1,1)
      CALL ALG15 (RDTE,DELTAD,NDATR,R(NTE,J),DADD,1,0)
      CALL ALG15 (RDTE,AC,NDATR,R(NTE,J),AONC,1,0)
      SOL(J) = SOLID
      DEV(NTE,J) = (DADD+DO*XKSHPE*XKDT+CAMBER*SOLID**(-XB)*
     1             (XMS+0.5*(AONC-0.5)))*Q
      BETA2  = BETA2*Q
      DO 230 I = NLE,NTE
  230 CALL ALG15 (RSTA(1,I),XSTA(1,I),KPTS(I),R(I,J),X(I),1,0)
      DX(NLE) = 0.0
      K = NLE + 1
      DO 240 I = K,NTE
  240 DX(I) = DX(I-1) + SQRT((X(I)-X(I-1))**2+(R(I,J)-R(I-1,J))**2)
      X1 = DX(NTE)
      DO 250 I = K,NTE
  250 DX(I) = DX(I)/X1
      L2 = NTE - NLE - 1
      K  = NLE + 1
      DO 260 L1 = 1,NRAD
  260 CALL ALG15 (DM(1,L1),DVFRAC(1,L1),NDPTS,DX(K),DEVV(K,L1),L2,0)
      KK = NTE - 1
      DO 280 I  = K,KK
      DO 270 L1 = 1,NRAD
  270 DOO(L1) = DEVV(I,L1)
      CALL ALG15 (RTE,DOO,NRAD,R(NTE,J),DEVFR,1,0)
  280 DEV(I,J) = DEV(NTE,J)*DEVFR
  290 IF (IPRTC .EQ. 1) WRITE (LOG2,300) J,BETA1,BETA2,CAMBER,THICK,
     1       AONC,SOLID,DADD,DEV(NTE,J)
  300 FORMAT (I11,F14.3,2F11.3,2F11.4,F12.5,F14.4,F17.4)
      IF (IFANGS(NLE) .EQ. 0) GO TO 340
      IF (NAERO .EQ. 0) GO TO 330
      IDATA(1)  = NLINES
      IDATA(2)  = 0
      IDATA(3)  = 0
      IDATA(4)  = 0
      IDATA(5)  = 0
      IDATA(6)  = 0
      IDATA(7)  = 0
      IDATA(8)  = 0
      IDATA(9)  = 0
      IDATA(10) = 0
      IDATA(11) = 0
      IDATA(12) = 0
      IDATA(13) = NOUT1(NLE)
      IDATA(14) = NOUT2(NLE)
      IDATA(15) = NOUT3(NLE)
      IDATA(16) = 0
      CALL WRITE (LOG5,IDATA,16,1)
      CALL WRITE (LOG5,0.0,1,1)
  310 FORMAT (I3,11(2X,1H0),3I3,3H  0, /,4H 0.0)
      DO 315 J = 1,NLINES
      RDATA(1) = R(NLE,J)
      RDATA(2) = ALPB(NLE,J)
      RDATA(3) = 0.0
      RDATA(4) = EPSLON(NLE,J)
      RDATA(5) = 0.0
      RDATA(6) = 0.0
      CALL WRITE (LOG5,RDATA,6,1)
      RDATA(1) = 0.0
      RDATA(2) = 0.0
      RDATA(3) = 0.0
      RDATA(4) = 0.0
  315 CALL WRITE (LOG5,RDATA,4,1)
  320 FORMAT (2F12.7,12X,F12.7,24X,/,4H 0.0,44X)
      IF (IPUNCH .EQ. 0) GO TO 340
  330 WRITE (LOG3,310) NLINES,NOUT1(NLE),NOUT2(NLE),NOUT3(NLE)
      WRITE (LOG3,320) (R(NLE,J),ALPB(NLE,J),EPSLON(NLE,J),J=1,NLINES)
  340 DO 370 I = K,NTE
      DO 350 J = 1,NLINES
  350 RDTE(J) = R(I,J)
      CALL ALG15 (RR(1,I),XLOSS(1,I),NR(I),RDTE,DELTAD,NLINES,0)
      NX = LOG5
      IF (NAERO .EQ. 0) NX = LOG3
      IF (NX .EQ. LOG3) GO TO 360
      IDATA(1)  = NLINES
      IDATA(2)  = NTERP(I)
      IDATA(3)  = 0
      IDATA(4)  = NMACH(I)
      IDATA(5)  = 6
      IDATA(6)  = NLOSS(I)
      IDATA(7)  = NL1(I)
      IDATA(8)  = NL2(I)
      IDATA(9)  = NEVAL(I)
      IDATA(10) = NCURVE(I)
      IDATA(11) = NLITER(I)
      IDATA(12) = NDEL(I)
      IDATA(13) = NOUT1(I)
      IDATA(14) = NOUT2(I)
      IDATA(15) = NOUT3(I)
      IDATA(16) = NBLAD(I)
      CALL WRITE (LOG5,IDATA,16,1)
      CALL WRITE (LOG5,SPEED,1,1)
      DO 355 J = 1,NLINES
      RDATA(1) = R(I,J)
      RDATA(2) = ALPB(I,J)
      RDATA(3) = DELTAD(J)
      RDATA(4) = EPSLON(I,J)
      RDATA(5) = BLOCK(I,J)
      RDATA(6) = SOL(J)
      CALL WRITE (LOG5,RDATA,6,1)
      RDATA(1) = DEV(I,J)
      RDATA(2) = 0.0
      RDATA(3) = 0.0
      RDATA(4) = 0.0
  355 CALL WRITE (LOG5,RDATA,4,1)
      GO TO 365
  360 WRITE (NX,380) NLINES,NTERP(I),NMACH(I),NLOSS(I),NL1(I),NL2(I),
     1       NEVAL(I),NCURVE(I),NLITER(I),NDEL(I),NOUT1(I),NOUT2(I),
     2       NOUT3(I),NBLAD(I),SPEED,(R(I,J),ALPB(I,J),DELTAD(J),
     3       EPSLON(I,J),BLOCK(I,J),SOL(J),DEV(I,J),J=1,NLINES)
  365 IF (NX .EQ. LOG3) GO TO 370
      NX = LOG3
      IF (NAERO.NE.0 .AND. IPUNCH.NE.0) GO TO 360
  370 CONTINUE
  380 FORMAT (2I3,3H  0,I3,3H  6,11I3, /,F12.3,/,(6F12.7, /,F12.7,36X))
      RETURN
      END

      SUBROUTINE RBMG4
C*****
C RBMG4 COMPUTES MR FROM THE MATRIX EQUATION
C      MR = MRR + DM(T) * MLR + MLR(T) * DM + DM(T) * MLL * DM
C*****
      INTEGER SCR1,SCR2,DM
      INTEGER SCR3
C*****
C     INPUT DATA FILES
C*****
      DATA DM,MLL,MLR,MRR/101,102,103,104/
C*****
C     OUTPUT DATA FILES
C*****
      DATA MR/201/
C*****
C     SCRATCH DATA FILES
C*****
      DATA SCR1,SCR2,SCR3/301,302,303/
C*****
C     COMPUTE MR
C*****
      CALL ELIM(MRR,MLR,MLL,DM,MR,SCR1,SCR2,SCR3)
      RETURN
      END

      SUBROUTINE GI
C
      EXTERNAL        ANDF
      LOGICAL         MULTI,SINGLE,OMIT
      INTEGER         ANDF,TWO1,IA(7)
      INTEGER         UM,UO,UR,USG,USB,UL,UA,UF,US,UN,UG
      INTEGER         SPLINE,USETA,CSTM,BAGPDT,SILA,ECTA,GM,GO,SCR1,
     1                SCR2,SCR3,SCR4,SCR5,KSIZE,GSIZE,GTKA
      COMMON /GICOM / SPLINE,USETA,CSTM,BAGPDT,SILA,ECTA,GM,GO,GTKA,
     1                KSIZE,GSIZE,SCR1,SCR2,SCR3,SCR4,SCR5
      COMMON /BITPOS/ UM,UO,UR,USG,USB,UL,UA,UF,US,UN,UG
      COMMON /TWO   / TWO1(32)
      COMMON /BLANK / NK,NG
      DATA    SINGLE/ .TRUE./, MULTI /.TRUE./, OMIT /.TRUE./
      DATA       IA / 7*0  /
C
      SPLINE = 101
      USETA  = 102
      CSTM   = 103
      BAGPDT = 104
      SILA   = 105
      ECTA   = 106
      GM     = 107
      GO     = 108
      GTKA   = 201
      KSIZE  = NK
      GSIZE  = NG
      IF (GSIZE .GT. 0) GO TO 5
      IA(1)  = SILA
      CALL RDTRL (IA)
      GSIZE  = IA(3)
    5 CONTINUE
      SCR1   = 301
      SCR2   = 302
      SCR3   = 303
      SCR4   = 304
      SCR5   = 305
      CALL GIGGKS
      IA(1)  = USETA
      CALL RDTRL (IA)
      IF (ANDF(IA(5),TWO1(UM)) .EQ. 0) MULTI  = .FALSE.
      IF (ANDF(IA(5),TWO1(US)) .EQ. 0) SINGLE = .FALSE.
      IF (ANDF(IA(5),TWO1(UO)) .EQ. 0) OMIT   = .FALSE.
      IF (MULTI .OR. SINGLE .OR. OMIT) GO TO 10
      SCR2 = GTKA
   10 CALL GIGTKG
      CALL GIPSST
      IF (MULTI .OR. SINGLE .OR. OMIT) GO TO 20
      GO TO 30
   20 CALL GIGTKA (MULTI,SINGLE,OMIT)
   30 RETURN
      END

      SUBROUTINE STEP (U2,U1,U0,P,IBUF)
C
C     STEP WILL INTEGRATE FORWARD ONE TIME STEP
C
C     THIS ROUTINE IS SUITABLE FOR SINGLE PRECISION OPERATION
C
      INTEGER         FILE(7)  ,SQR     ,RSP     ,DUM     ,IBUF(1)
      DIMENSION       U2(1)    ,U1(1)   ,U0(1)   ,P(1)
      COMMON /TRDXX / DUM(21)  ,ISCR1   ,ISCR2   ,ISCR3   ,ISCR4   ,
     1                ISCR5    ,ISCR6   ,IOPEN   ,ISYM
      COMMON /NAMES / DUMM(7)  ,RSP     ,DUMN(3) ,SQR
      COMMON /INFBSX/ IFIL(7)  ,IFILU(7)
C
      FILE(1) = ISCR1
      FILE(2) = DUM(2)
      FILE(4) = SQR
C
C     TELL MATVEC/INTFBS FILES ARE OPEN
C
      IOPEN = 1
C
C     FORM R.H.S. OF THE INTEGRATION EQUATION
C
      CALL MATVEC (U1(1),P(1),FILE,IBUF)
      FILE(1) = ISCR4
      CALL MATVEC (U0(1),P(1),FILE,IBUF)
C
C     CALL INTFBS/FBSINT TO DO THE FORWARD/BACKWARD PASS
C
      IFIL(1)  = ISCR2
      IFILU(1) = ISCR3
      CALL RDTRL (IFIL)
      CALL RDTRL (IFILU)
      IFIL(5)  = RSP
      IFIL(3)  = DUM(2)
      IF (ISYM .EQ. 1) CALL INTFBS (P(1),U2(1),IBUF)
      IF (ISYM .EQ. 0) CALL FBSINT (P(1),U2(1))
      IOPEN = 0
      RETURN
      END

      SUBROUTINE SOFTOC
C
C     SOF TABLE OF CONTENTS ROUTINE
C
C
C     THE CURRENT SUBSTRUCTURE TYPE BIT POSITIONS ARE -
C
C        NO BIT - BASIC SUBSTRUCTURE (EXCEPT IMAGE BIT)
C        BIT 30 - IMAGE SUBSTRUCTURE
C            29 - COMBINED SUBSTRUCTURE
C            28 - GUYAN REDUCTUION SUBSTRUCTURE
C            27 - MODAL REDUCTION SUBSTRUCTURE
C            26 - COMPLEX MODAL REDUCTION SUBSTRUCTURE
C
C     TO ADD A NEW SUBSTRUCTURE TYPE BIT THE FOLLOWING UPDATES ARE
C     REQUIRED.
C
C        1) INCREASE THE DEMENSION OF TYPE.
C        2) INCREASE THE VALUE OF NTYPE IN THE DATA STATEMENT.
C        3) ADD A NEW BCD TYPE VALUE TO THE DATA STATEMENT.
C
C
C     THIS ROUTINE IS CURRENTLY CODED TO HANDLE UP TO 27 SOF ITEMS
C     AUTOMATICALLY.
C     TO INCREASE THIS TO 40 ITEMS PERFORM THE FOLLOWING UPDATES.
C
C        1) CHANGE THE DIMENSION OF HDR TO (40,4)
C        2) CHANGE THE DIMENSION OF ITM TO (40)
C        3) CHANGE THE VALUE OF MAXITM IN THE DATA STATEMENT TO 40
C        4) CHANGE THE INNER GROUPS ON FORMAT 80 TO 39(A1,1X),A1
C        5) CHANGE THE INNER GROUP ON FORMAT 100 TO 39(A1,1X),A1
C
      EXTERNAL        LSHIFT,RSHIFT,ANDF
      INTEGER         AVBLKS,BLANK,DITNSB,BUF,SSNAME(2),ANDF,SS,PS,CS,
     1                HL,RSHIFT,DIRSIZ,SOFSIZ,DITSIZ,NUM(10),BLKSIZ,
     2                HIBLK,FILSIZ,TYPE(5),ITM(27),HDR(27,4)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25,SWM*27
      COMMON /XMSSG / UFM,UWM,UIM,SFM,SWM
      COMMON /MACHIN/ MACH,IHALF
      COMMON /ZZZZZZ/ BUF(1)
      COMMON /SOF   / DIT,DITPBN,DITLBN,DITSIZ,DITNSB,DITBL
      COMMON /SYS   / BLKSIZ,DIRSIZ,SUPSIZ,AVBLKS,HIBLK,IFRST
      COMMON /SOFCOM/ NFILES,FILNAM(10),FILSIZ(10)
      COMMON /SYSTEM/ SYSBUF,NOUT,Z1(6),NLPP,Y(2),LINE,Z2(26),NBPC,NBPW
      COMMON /ITEMDT/ NITEM,ITEM(7,1)
      DATA    TYPE  / 2HB , 2HC , 2HR , 2HM , 2HCM /
      DATA    NUM   / 1H1, 1H2, 1H3, 1H4, 1H5, 1H6 ,1H7, 1H8, 1H9, 1H0 /
      DATA    BLANK / 4H     /
      DATA    IMAGE / 4HI    /
      DATA    NTYPE / 6      /
      DATA    MAXITM/ 27     /
C
      NITM = NITEM
      IF (NITM .LE. MAXITM) GO TO 10
      NITM = MAXITM
      WRITE  (NOUT,6237) SWM,MAXITM
 6237 FORMAT (A27,' 6237, THE SOFTOC ROUTINE CAN HANDLE ONLY',I4,
     1       ' ITEMS.', /34X,'ADDITIONAL ITEMS WILL NOT BE SHOWN')
C
C     SET UP HEADINGS AND MASKS
C
   10 NSHFT = 0
      DO 30 I = 1,4
      DO 20 J = 1,NITM
   20 HDR(J,I) = KLSHFT(ITEM(1,J),NSHFT/NBPC)
      K = NITM + 1
      IF (K .GT. MAXITM) GO TO 30
      DO 22 J = K,MAXITM
   22 HDR(J,I) = BLANK
   30 NSHFT = NSHFT + NBPC
C
      LINE  = NLPP + 1
      M0009 = 1023
      M1019 = LSHIFT(1023,10)
      M2029 = LSHIFT(1023,20)
      IMASK = LSHIFT(1,30)
C
C     LOOP THROUGH DIT
C
      DO 110 JMKN = 1,DITSIZ,2
      I = (JMKN-1)/2 + 1
      CALL FDIT (I,K)
      SSNAME(1) = BUF(K  )
      SSNAME(2) = BUF(K+1)
      IF (SSNAME(1).EQ.BLANK .AND. SSNAME(2).EQ.BLANK) GO TO 110
      CALL FMDI (I,K)
C
C     TEST TYPE BITS IN MDI
C
      DO 40 IT = 2,NTYPE
      IBIT = ANDF(BUF(K+1),LSHIFT(1,31-IT))
      IF (IBIT .NE. 0) GO TO 50
   40 CONTINUE
      IT = 1
   50 IS = ANDF(BUF(K+1),IMASK)
      IM = BLANK
      IF (IS .NE. 0) IM = IMAGE
      SS = RSHIFT(ANDF(BUF(K+1),M1019),10)
      PS = ANDF(BUF(K+1),M0009)
      LL = RSHIFT(ANDF(BUF(K+2),M2029),20)
      CS = RSHIFT(ANDF(BUF(K+2),M1019),10)
      HL = ANDF(BUF(K+2),M0009)
C
C     LOOP THROUGH MDI ENTRY FOR THIS SUBSTRUCTURE DETERMINING THE
C     SIZE OF EACH EXISTING ITEM.
C
      DO 70 J = 1,NITM
      JJ = J + IFRST - 1
      IF (BUF(K+JJ) .EQ. 0) GO TO 60
      INUM = RSHIFT(BUF(K+JJ),IHALF)*BLKSIZ
      INUM = ALOG10(FLOAT(INUM)) + .3
      ITM(J) = NUM(INUM)
      IF (IS.NE.0 .AND. ITEM(4,J).EQ.0) ITM(J) = NUM(10)
      IF (PS.NE.0 .AND. IS.EQ.0 .AND. ITEM(5,J).EQ.0) ITM(J) = NUM(10)
      GO TO 70
   60 ITM(J) = BLANK
   70 CONTINUE
C
      LINE = LINE + 1
      IF (LINE .LE. NLPP) GO TO 90
      CALL PAGE1
      LINE = LINE + 9 - 4
      WRITE  (NOUT,80) HDR
   80 FORMAT (//,26X,90HS U B S T R U C T U R E   O P E R A T I N G   F
     1I L E   T A B L E   O F   C O N T E N T S , //,
     1 1H ,51X,26(A1,2X),A1,/1H ,51X,26(A1,2X),A1,/1H ,51X,26(A1,2X),A1,
     2 /,1H ,4X,12HSUBSTRUCTURE,35X,26(A1,2X),A1, /1H ,4X,3HNO.,3X,4HNAM
     3E,4X,4HTYPE,3X,2HSS,3X,2HPS,3X,2HLL,3X,2HCS,3X,2HHL,4X,80(1H-)/)
C
   90 WRITE  (NOUT,100) I,SSNAME,IM,TYPE(IT),SS,PS,LL,CS,HL,
     1                  (ITM(L),L=1,NITM)
  100 FORMAT (2X,I6,2X,2A4,2X,A1,A2,5(1X,I4),4X,26(A1,2X),A1)
  110 CONTINUE
C
C     PRINT SOF SPACE UTILIZATION MESSAGE
C
      LINE = LINE + 8
      IF (LINE .GT. NLPP) CALL PAGE1
      K    = SOFSIZ(K)
      NBLK = 0
      DO 115 I = 1,NFILES
  115 NBLK = NBLK + FILSIZ(I)
      IPER = (AVBLKS*100)/NBLK
      WRITE  (NOUT,120) K,AVBLKS,IPER,HIBLK
  120 FORMAT (//,51X,80HSIZE OF ITEM IS GIVEN IN POWERS OF TEN   (0 INDI
     1CATES DATA IS STORED IN PRIMARY) ,/,
     2        26H0*** UNUSED SPACE ON SOF = ,I9,7H WORDS.  ,/,
     3        22X,                   4HOR = ,I9,8H BLOCKS. ,/,
     4        22X,                   4HOR = ,I9,9H PERCENT.,/,
     5        26H0*** HIGHEST BLOCK USED  = ,I9)
      LINE = NLPP
      RETURN
      END

      SUBROUTINE PREFIX (IPREFX,NAME)
C
      EXTERNAL        LSHIFT,RSHIFT,ORF
      INTEGER         NAME(2),RSHIFT,ORF,RWORD
      COMMON /SYSTEM/ JUNK(38),NBPC,NBPW,NCPW
      DATA    IBLNK / 4H     /
C
      IBLANK = IBLNK
C
C     THIS ROUTINE PREFIXES THE TWO WORD VARIABLE 'NAME' WITH THE SINGLE
C     CHARACTER PREFIX 'IPREFX'.
C
C     SET RIGHT HAND PORTION OF WORDS TO ZERO.
C
      LWORD  = LSHIFT( RSHIFT( NAME(1),NBPW-4*NBPC ) , NBPW-4*NBPC )
      RWORD  = LSHIFT( RSHIFT( NAME(2),NBPW-4*NBPC ) , NBPW-4*NBPC )
      IPREFX = LSHIFT( RSHIFT( IPREFX,NBPW-NBPC ) , NBPW-NBPC )
      IBLANK = RSHIFT( LSHIFT( IBLANK,4*NBPC ) , 4*NBPC )
C
C     MOVE RIGHT WORD ONE CHARACTER AND PREFIX WITH LAST CHARACTER
C     OF LEFT WORD.
C
      RWORD = ORF( LSHIFT( LWORD,3*NBPC ) , RSHIFT( RWORD,NBPC ) )
      RWORD = LSHIFT( RSHIFT( RWORD  ,NBPW-4*NBPC ) , NBPW-4*NBPC )
      RWORD = ORF( RWORD , IBLANK )
C
C     MOVE LEFT WORD ONE CHARACTER TO RIGHT AND PREFIX WITH INPUT
C     VALUE.
C
      LWORD = ORF( IPREFX , RSHIFT( LWORD,NBPC))
      LWORD = LSHIFT( RSHIFT( LWORD  ,NBPW-4*NBPC ) , NBPW-4*NBPC )
      LWORD = ORF( LWORD , IBLANK )
C
      NAME(1) = LWORD
      NAME(2) = RWORD
      RETURN
      END

      SUBROUTINE FA1KE (SCR1,KFREQ,BREF,RHO,RREF,FLOOP,NLOOP)
C
      INTEGER         SCR1,MHH,KHH,FLOOP,SYSBUF,MOUT,NAME(2)
      INTEGER         BUF1,TRL(7),FSAVE
C
      REAL            KFREQ,K2B2
C
      COMPLEX         CZ(1)
C
      COMMON /SYSTEM/ SYSBUF
      COMMON /ZZZZZZ/ Z(1)
      COMMON /UNPAKX/ IOUT,INN,NNN,INCR1
C
      EQUIVALENCE     (Z(1),CZ(1))
C
      DATA NAME /4HFA1K,4HE   /
      DATA KHH  /101/, MHH /103/ , MOUT /203/ , FSAVE /201/
C
C     INITILIZE ON FIRST LOOP
C
      IF(FLOOP .GT. 1) GO TO 100
      NCORE = KORSZ(Z)
      TRL(1)= KHH
      CALL RDTRL(TRL)
      N  = TRL(3)
      NN = N*N
      N2 = N*2
      IM = NN * 2
C
C       LOC     SIZE     USE
C
C     IAM1K     N*N*2    A-1 K
C     IKC       N*N*2    K   SCRATCH FOR ALLMAT
C     IMS       N*N*2    M + Q   LAMBDA FOR ALLMAT
C     IPM       N*N*2    M   HELD IN CORE
C     IPK       N*N*2    K   BETWEEN LOOPS
C
      IAM1K = 1
      IKC = IAM1K + IM
      IMS = IKC + IM
      ICP = IMS + IM
      IF(IM*5+SYSBUF.GT.NCORE) CALL MESAGE(-8,0,NAME)
      IPM = NCORE - IM
      IPK = IPM - IM
      NCORE= IPK -1
      BUF1 = NCORE - SYSBUF
      IOUT = 3
      INN  = 1
      NNN  = N
      INCR1= 1
C
C     PUT MHH AND KHH IN CORE
C
      IFL = KHH
      JI  = IPK
   10 CALL GOPEN(IFL,Z(BUF1),0)
      DO 20 I=1,N
      CALL UNPACK(*15,IFL,Z(JI))
      GO TO 16
   15 CALL ZEROC(Z(JI),N2)
   16 JI = JI + N2
   20 CONTINUE
      CALL CLOSE(IFL,1)
      IF(IFL.EQ.MHH) GO TO 40
      IFL = MHH
      JI  = IPM
      GO TO 10
C
C     WRITE A HEADER ON MOUT
C
   40 CALL GOPEN(MOUT,Z(BUF1),1)
      CALL CLOSE(MOUT,2)
C
C              2  2
C     SOLVE   K /B  MHH + (RHO*RREF)/2.0 QHH     KHH
C
  100 K2B2 = (KFREQ*KFREQ) /(BREF*BREF)
      RR2  = (RHO*RREF) / 2.0
      IOUT = 3
      INN  = 1
      NNN  = N
      INCR1= 1
      DO 105 I=1,IKC
  105 Z(I) = 0.0
      JI = IMS
      CALL GOPEN(SCR1,Z(BUF1),0)
      DO 110 I=1,N
      CALL UNPACK(*115,SCR1,Z(JI))
  115 JI = JI+N2
  110 CONTINUE
      CALL CLOSE(SCR1,1)
      ICK = IKC -1
      IKP = IPK -1
      IMP = IPM -1
      ISM = IMS -1
      J   = NN*2
      DO 120 I=1,J
      Z(I+ISM) = Z(I+ISM) * RR2 + Z(I+IMP) * K2B2
      Z(I+ICK) = - Z(I+IKP)
  120 CONTINUE
      CALL INCORE(Z(IMS),N,Z(IKC),Z(IAM1K),N)
C
C     GET EIGENVALUES FROM ALLMAT
C
      IM = IMS + N2
      IN = IM + N2
      L  = 0
      CALL ALLMAT(Z(IAM1K),Z(IMS),Z(IKC),0,0,Z(IM),0,Z(IN),N,L,0)
C
C     WRITE OUT EIGENVALUES ON MOUT
C
      IM = IMS/2
      NL = 2*L
      DO 130 I = 1,L
      IF(CZ(I+IM).NE.(0.0,0.0))CZ(I+IM) = CSQRT(CZ(I+IM))
      IF(AIMAG(CZ(I+IM)) .LT. 0.0) CZ(I+IM) = - CZ(I+IM)
  130 CONTINUE
      CALL GOPEN(MOUT,Z(BUF1),3)
      CALL WRITE(MOUT,Z(IMS),NL,1)
      IF(FLOOP.GE.NLOOP) GO TO 200
      CALL CLOSE(MOUT,3)
      RETURN
C
C     LAST LOOP BUILD FSAVE
C
  200 CALL CLOSE(MOUT,1)
      IBUF2 = BUF1 - SYSBUF
      CALL GOPEN(MOUT,Z(BUF1),0)
      CALL GOPEN(FSAVE,Z(IBUF2),0)
      CALL SKPREC(FSAVE,3)
      CALL CLOSE(FSAVE,2)
      CALL GOPEN(FSAVE,Z(IBUF2),3)
  210 CALL READ(*230,*220,MOUT,Z(1),IBUF2,1,NWR)
  220 CALL WRITE(FSAVE,Z(1),NWR,1)
      GO TO 210
  230 CALL CLOSE(MOUT,1)
      CALL CLOSE(FSAVE,1)
      TRL(1) = FSAVE
      TRL(2) = NLOOP
      TRL(7) = L
      CALL WRTTRL(TRL)
      RETURN
      END

        SUBROUTINE DSGEFL
      INCLUDE 'DSIOF.COM'
      INCLUDE 'XNSTRN.COM'
        INTEGER*2         IUNIT
        COMMON / DSUNIT / IUNIT(220)
        IF ( NAME .GE. 101 .AND. NAME .LE. 320 ) GO TO 10
        CALL GETURN ( NAME )
        GO TO 20
   10   IFILEX = IUNIT( NAME-100 )
   20   IF ( IFILEX .NE. 0 ) GO TO 30
        IF ( IRETRN .EQ. 77 ) GO TO 50
        CALL DSMSG ( 107 )
   30   IOBUF =  FCB( 2, IFILEX )
        IF ( IOBUF .EQ. 0 ) GO TO 40
        IPRVOP = FCB( 1,IFILEX )
        IF ( IPRVOP .EQ. 2 ) IPRVOP = 0
        INDBAS = IOBUF
        INDCBP = INDBAS + IBASE( INDBAS+1 ) - 1
        INDCLR = INDBAS + IBASE( INDBAS+2 ) - 1
        NBLOCK = FCB( 4, IFILEX )
        LCW    = IBASE( INDBAS+4 )
        LASNAM = NAME
        GO TO 50
   40   IFILEX = 0
   50   CONTINUE
        RETURN
        END

      SUBROUTINE STPAX3 ( AGAIN)
      INTEGER IFORCE(25), ISTRES(100), ELEMID, IBLOCK(62,14)
     1,       ICLOCK(62,14),CANGLE
C
      REAL    SAVEF(75), SAVES(75)
C
      LOGICAL AGAIN
C
      COMMON /SDR2X7/ DUM(100),STRESS(100),FORCE(25)
     1,               SKIP(729),BLOCK(62,14),CLOCK(62,14)
C
C SCRATCH BLOCK
      COMMON /SDR2X8/ DISP(59),NANGLE,ELEMID,UNU(94),KANGLE,KLEMID
      COMMON /ISAVE / ISAVEF(75),ISAVES(75)
C
      COMMON /SDR2DE/ DUM5(33), IPART
C
      COMMON /SDR2X4/ DUM4(51),KTYPE
C
C
      EQUIVALENCE ( ISTRES(1), STRESS(1)), ( IFORCE(1), FORCE(1))
     1,            (IBLOCK(1,1), BLOCK(1,1))
     2,            (ICLOCK(1,1),CLOCK(1,1)),(ISAVEF(1),SAVEF(1))
     3,            (ISAVES(1),SAVES(1)),(NANGLE,CANGLE)
C
      IF ( AGAIN ) GO TO 10
      AGAIN = .TRUE.
      KANGLE = 0
   10 NANGLE = KANGLE
      ELEMID = KLEMID
      NANGLE = NANGLE + 1
      KANGLE = NANGLE
C
C
C  BRANCH TO INSERT STRESSES AND FORCES INTO FORCE AND STRESS OR
C                                            SAVEF AND SAVES
C
C    KTYPE=1 - REAL OUTPUT FROM BLOCK IS TRANSFERED TO CLOCK, THEN
C              STORED IN FORCE AND STRESS, NOTHING IN SAVEF AND SAVES
C    KTYPE=2 - COMPLEX OUTPUT
C    IPART=1 - IMAGINARY PART OF COMPLEX OUTPUT FROM BLOCK, STORED
C              IN SAVEF AND SAVES
C    IPART=2 - REAL PART OF COMPLEX OUTPUT FROM CLOCK STORED IN
C              FORCE AND STRESS
C
      IF(KTYPE.EQ.2) GO TO 19
      DO 15 I=1,62
      DO 15 J=1,14
   15 CLOCK(I,J) = BLOCK(I,J)
   19 CONTINUE
C
C  OUTPUT FORCES FOR THIS ANGLE
      IFORCE(1)=ELEMID
      FORCE(2) = CLOCK(1,CANGLE)
      DO 20 I=1,16
      FORCE(2+I) = CLOCK(46+I,CANGLE)
   20 CONTINUE
C
C OUTPUT STRESSES
      ISTRES  (1) = ELEMID
      STRESS(2) = CLOCK(1,CANGLE)
      DO 30 I=1,45
      STRESS(2+I) = CLOCK(I+1,CANGLE)
   30 CONTINUE
C
      IF(KTYPE.EQ.2) GO TO 40
      IF(CANGLE .EQ. 14) GO TO 100
      IF(ICLOCK(1,CANGLE+1) .EQ. 1) GO TO 100
      GO TO 70
C
   40 CONTINUE
C
C  OUTPUT FORCES FOR THIS ANGLE
      ISAVEF(1)=ELEMID
      SAVEF(2) = BLOCK (1,NANGLE)
      DO 50 I=1,16
      SAVEF (2+I) = BLOCK (46+I, NANGLE)
   50 CONTINUE
C
C OUTPUT STRESSES
      ISAVES(1) = ELEMID
      SAVES(2) = BLOCK(1,NANGLE)
      DO 60 I=1,45
      SAVES(2+I) = BLOCK(I+1,NANGLE)
   60 CONTINUE
C
      IF (NANGLE .EQ. 14) GO TO 100
      IF (IBLOCK(1,NANGLE+1) .EQ. 1)  GO TO 100
   70 CONTINUE
C
      RETURN
  100 AGAIN = .FALSE.
      RETURN
      END

      SUBROUTINE XSEM00
C **********************************************************************
C THE PURPOSE OF THIS ROUTINE IS TO EXECUTE THE PREFACE AND THEN TO
C EXECUTE MODULES ACCORDING TO THE DMAP.  THE DMAP IS READ FROM THE
C OSCAR.  FOR EACH MODULE TO BE EXECUTED, THE FIST AND XVPS ARE SETUP.
C
CWKBD 5/95
C     INTEGER ORF
      INTEGER ANDF ,DATABF,ERRFLG,FIST  ,FISTNM,FSTRST,OPNTR
     1       ,PARML,PARAM ,PARMN ,POOL  ,RSHIFT,SCRTCH
     2       ,VPS  ,VPARML,TYPECD,VPSX  ,WORDB ,WORDE
     3       ,PLOTF,EXIT  ,SYSBUF,SUBNAM(2)
      INTEGER EQUIV(2), PURGE(2), XEQU, XPUR, XSAV, YCHK
CWKBI 5/95
      CHARACTER*4   WORDC
C
      LOGICAL LVAX
C
      DIMENSION SCRTCH(3),WORDB(4),WORDE(2),NUMBR(10)
C
      COMMON/MACHIN/MACH
      COMMON/SEM   /MASK  ,MASK2 ,MASK3 ,LINKNM(15)
     1
     F      /SYSTEM/SYSBUF,XX(20),LINKNO,XXX(16),NBPC,NBPW,NCPW,XXXX(53)
     F             ,ISPERLNK
     G
     H      /XLINK /LXLINK,MAXLNK,MXLINK(1)
     1
     2      /XFIST /FIST(2)
     3
     4      /XPFIST/FSTRST
     5
     6      /OSCENT/INOSCR(200)
     7
     8      /ZZZZZZ/DATABF(1)
     9
     A      /BLANK /PARAM(100)
     B
     C      /XVPS  /VPS(1)
     D
     E      /MSGX  /NMSG
C
      EQUIVALENCE (XX(1),NOUT),
     1            (xx(3),nin) ! input file number
      EQUIVALENCE (XX(19),PLOTF)
      equivalence (xx(17),itmbgn)
CWKBI 5/95
      EQUIVALENCE ( WORDC, WORDB )
C
      DATA POOL /4HPOOL/
     3,    SCRTCH  /4HSCRA,4HTCH0,4HTCH0/
     4,    NUMBR   /1H1,1H2,1H3,1H4,1H5,1H6,1H7,1H8,1H9,1H0 /
     5,    WORDB   /4HSEM1,4HBEGN,4H    ,4H    /
     5,    WORDE   /4HBEGN,4HEND /
     6,    IBLNK   /4H    /
     6,    MODX    /   215/
     7,    EXIT    /4HEXIT/
      DATA SUBNAM  /4HXSEM,2H00/
      DATA EQUIV, PURGE /4HEQUI, 4HV   , 4HPURG, 4HE   /
      DATA XEQU , XPUR  /4HXEQU, 4HXPUR/
      DATA XSAV , YCHK  /4HXSAV, 4HXCHK/
!     Set varables
      integer error_id
	  integer nin, nout
      character(80) proj,ft05,ft06,output,infile
C*****
C INITIALIZE MACHINE DEPENDENT CONSTANTS
      CALL BTSTRP
!----------------------------------------------------------------------
! hgs 12/06/2104 - The NASA delivery uses redirected input and out put
!                  so these files are not explicitly opened. I need
!                  to change the stdin and stdout to allow the use of
!                  GDB in the script file. Therefore the following mod-
!                  ifications explicitly open the stdin and stdout files
!                  using the FTN5 and FTN6 ENV set by the script.
!
c
c     open inout and output files
c
      call getenv('PROJ',proj)
	  call getenv('FT05',ft05)
	  call getenv('FT06',ft06)
	  output = trim(proj)//'/'//trim(ft06)
	  error_id = 0
  101 continue
      ifile = nout
      open(nout,file=output,form='formatted',
     1status='unknown',iostat=ierr,err=102)
      go to 103
  102 continue
      error_id = -2
      go to 104
  103 continue
      ifile = nin
	  infile = trim(proj)//'/'//trim(ft05)
      open(nin,file=infile,form='formatted'
     1    ,status='unknown', iostat =ierr,err=106)
      go to 105
  106 continue
      error_id = -1
  104 continue
c
c     open error
c
      write(nout,*) 'Error in opening file =',ifile,' IOSTAT = ',ierr
	  select case(error_id)
	  case(-1)
	    write(nout,'(a)') 'File name: ',infile
	  case(-2)
	    write(nout,'(a)') 'File name: ',output
	  end select
      call pexit ! close down and exit with ierror
	  return
c
 105  continue
      LVAX = MACH.EQ.5
C*****
C EXECUTE PREFACE
C*****
      KSCR= LSHIFT(1,NBPW-4*NBPC)
      CALL TDATE(XX(14))
      CALL CONMSG(WORDB,2,1)
      CALL SEMINT ( 0 )
      ISPERLNK = 1
      WORDB(2) = WORDE(2)
      CALL CONMSG ( WORDB,2,1)
      IPLOT = PLOTF
      IF (PLOTF .LT. 0) PLOTF=1
      IBUF1 = KORSZ(DATABF)-SYSBUF
      GO TO 20
C*****
C RETURN HERE AFTER MODULE HAS EXECUTED
C*****
   10 IF (INOSCR(4).EQ.XSAV.OR.INOSCR(4).EQ.YCHK) GO TO 20
      WORDB(4) = WORDE(2)
C      CALL CONMSG(WORDB,4,0)
      CALL CONMSG(WORDB,4,222222)
   20 IF(NMSG .GT. 0) CALL MSGWRT
      CALL OPEN(*270,POOL,DATABF(IBUF1),2)
C*****
C READ THE OSCAR ENTRY
C*****
   30 CALL READ(*280,*40,POOL,INOSCR,200,1,ERRFLG)
      GO TO 290
   40 IF (INOSCR(6))50,30,30
C*****
C TRY AGAIN IF EXECUTE FLAG IS OFF
C*****
   50 CALL CLOSE(POOL,2)
      TYPECD= ANDF(INOSCR(3),MASK)
C*****
C NOW DETERMINE TYPE OF OSCAR FORMAT
C*****
      IF(TYPECD .GT. 2)  GO TO 200
C*****
C*****
C NOW PROCESSING TYPE O AND F
C*****
   60 MODNO= INOSCR(2)
      FIST(2)= FSTRST
      OPNTR = 7
      ASSIGN 110 TO MM
      FISTNM=101
C*****
C PROCESS FILES IN OSCAR ENTRY.
C*****
   70 J=INOSCR(OPNTR)
      OPNTR=OPNTR+1
      IF(J.EQ.0) GO TO 100
      DO 90 I=1,J
      CALL GNFIST(INOSCR(OPNTR),FISTNM,MODNO)
      IF(MODNO) 60,260,80
   80 OPNTR= OPNTR+ 3
   90 FISTNM=FISTNM+1
  100 GO TO MM,(110,120)
C*****
C SETUP TO PROCESS OUTPUT FILES
C*****
  110 IF(TYPECD.EQ.2) GO TO 120
      ASSIGN 120 TO MM
      FISTNM=201
      GO TO 70
C*****
C PROCESS SCRATCH FILES
C*****
  120 J1= INOSCR(OPNTR)
      IF(J1.EQ.0) GO TO 140
      FISTNM= 301
      SCRTCH(2) = SCRTCH(3)
      LL = 1
      L  = 0
      DO 130 J=1,J1
      L = L + 1
      IF ( L .EQ. 10 ) SCRTCH(2) = KHRFN1(SCRTCH(2),3,NUMBR(LL),1)
      SCRTCH(2) = KHRFN1(SCRTCH(2),4,NUMBR(L),1)
      CALL GNFIST(SCRTCH,FISTNM,MODNO)
      IF ( L .NE. 10 ) GO TO 125
      L  = 0
      LL = LL + 1
  125 IF(MODNO) 60,260,130
  130 FISTNM=FISTNM+1
  140 OPNTR=OPNTR+1
C*****
C NOW PROCESS PARAMETER LIST IN OSCAR
C  PARMN = NO. OF PARAMETERS TO PROCESS
C*****
      PARMN=INOSCR(OPNTR)
      IF(PARMN .EQ. 0)  GO TO 200
      II=1
      OPNTR= OPNTR+ 1
      DO 190 J2=1,PARMN
      IF(INOSCR(OPNTR))170,150,150
C*****
C NOW PROCESS CONSTANT PARAMETER
C*****
  150 PARML=INOSCR(OPNTR)
      OPNTR=OPNTR+1
      DO 160 J3=1,PARML
      PARAM(II)=INOSCR(OPNTR)
      II=II+1
  160 OPNTR=OPNTR+1
      GO TO 190
C*****
C MOVE VARIABLE INTO COMMON VIA VPS TABLE
C*****
  170 VPSX= ANDF(INOSCR(OPNTR),MASK3)
      OPNTR=OPNTR+1
      VPARML=VPS(VPSX-1)
      DO 180 J5=1,VPARML
      PARAM(II)=VPS(VPSX)
      II=II+1
  180 VPSX=VPSX+1
  190 CONTINUE
  200 MODX = RSHIFT(INOSCR(3),16)
C*****
C MODULE IS IN THIS LINK
C PRINT TIME MODULE BEGAN EXECUTION IF FUNCTIONAL MODULE
C*****
  245 WORDB(2) = INOSCR(4)
      WORDB(3) = INOSCR(5)
      IF (INOSCR(4).NE.XEQU.AND.INOSCR(4).NE.XPUR) GO TO 250
      IF (INOSCR(4).NE.XEQU) GO TO 248
      WORDB(2) = EQUIV(1)
      WORDB(3) = EQUIV(2)
      GO TO 250
  248 WORDB(2) = PURGE(1)
      WORDB(3) = PURGE(2)
  250 CALL TMTOGO (KTIME)
      IF (KTIME.LE.0.AND.WORDB(2).NE.EXIT)
     *   CALL MESAGE (-50, 0, WORDB(2))
      IF (INOSCR(4).EQ.XSAV.OR.INOSCR(4).EQ.YCHK) GO TO 1000
      WORDB(1) = IBLNK
      WORDB(4) = WORDE(1)
C
C     EXTRACT DMAP SEQUENCE NUMBER
C
      IDIN  = ANDF(INOSCR(6),MASK)
CWKBIB 5/95
      WRITE( WORDC, 251 ) IDIN
251   FORMAT( I4 )
CWKBIE 5/95
CWKBDB 5/95
C      DO 251  I =1,4
C      ICHR  = IDIN -(IDIN/10)*10 +1
C      L = NBPW-NBPC
C      IF (.NOT.LVAX)  WORDB(1) =
C     *    ORF(RSHIFT(WORDB(1),NBPC),LSHIFT(RSHIFT(NUMBR(ICHR),L),L))
C      IF (LVAX)  WORDB(1)=KHRFN1(WORDB(1),5-I,NUMBR(ICHR),1)
C      IDIN = IDIN/10
C      IF(IDIN .EQ. 0)  GO TO 252
C  251 CONTINUE
CWKBDE 5/95
  252 CONTINUE
C      CALL CONMSG(WORDB,4,0)
      CALL CONMSG(WORDB,4,111111)
      GO TO 1000
C*****
C                   E R R O R   M E S S A G E S
C*****
C MODULE REQUIREMENTS EXCEED AVAILABLE FILES
  260 INOSCR(6) = ANDF(INOSCR(6),MASK)
      CALL MESAGE(-18,INOSCR(6),INOSCR(4))
C
C UNEXPECTED ALTERNATE RETURN TAKEN WHILE ATTEMPTING TO OPEN POOL TAPE.
  270 CONTINUE
      KODE = 270
      GO TO 990
C
C OSCAR FILE POSITIONED INCORRECTLY - HIT EOF.
  280 CONTINUE
      KODE = 280
      GO TO 990
C
C OSCAR RECORD TOO LARGE FOR /OSCENT/
  290 CONTINUE
      KODE = 290
      GO TO 990
C
C LINK SPECIFICATIONS INCORRECT FOR THIS MODULE.
  940 CONTINUE
      WRITE (NOUT,945) WORDB,MODX
  945 FORMAT (/1X,4A4,I9)
      KODE = 940
      GO TO 990
C
C
  990 CONTINUE
      WRITE(NOUT,991) KODE
  991 FORMAT(64H0*** SYSTEM FATAL MESSAGE 1006, LINK DRIVER LOGIC ERROR
     *- CODE =,I4)
      CALL MESAGE(-37,0,SUBNAM)
C**********************************************************************
C EXECUTE MODULE
 1000 CALL SSWTCH ( 2, LDIAG )
C     IF ( LDIAG .NE. 0 .AND. MODX .GT. 14 ) CALL DBMDIA
      IF ( MODX .GE.  1  .AND. MODX .LE. 10 ) GO TO
     1( 940,  940, 2003,  940, 2005, 2006, 2007, 2008, 2009, 2010),MODX
      MODX = MODX - 10
      IF ( MODX .GE.  1  .AND. MODX .LE. 10 ) GO TO
     1(2011, 2012, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020),MODX
      MODX = MODX - 10
      IF ( MODX .GE.  1  .AND. MODX .LE. 10 ) GO TO
     1(2021, 2022, 2023, 2024, 2025, 2026, 2027, 2028, 2029, 2030),MODX
      MODX = MODX - 10
      IF ( MODX .GE.  1  .AND. MODX .LE. 10 ) GO TO
     1(2031, 2032, 2033, 2034, 2035, 2036, 2037, 2038, 2039, 2040),MODX
      MODX = MODX - 10
      IF ( MODX .GE.  1  .AND. MODX .LE. 10 ) GO TO
     1(2041, 2042, 2043, 2044, 2045, 2046, 2047, 2048, 2049, 2050),MODX
      MODX = MODX - 10
      IF ( MODX .GE.  1  .AND. MODX .LE. 10 ) GO TO
     1(2051, 2052, 2053, 2054, 2055, 2056, 2057, 2058, 2059, 2060),MODX
      MODX = MODX - 10
      IF ( MODX .GE.  1  .AND. MODX .LE. 10 ) GO TO
     1(2061, 2062, 2063, 2064, 2065, 2066, 2067, 2068, 2069, 2070),MODX
      MODX = MODX - 10
      IF ( MODX .GE.  1  .AND. MODX .LE. 10 ) GO TO
     1(2071, 2072, 2073, 2074, 2075, 2076, 2077, 2078, 2079, 2080),MODX
      MODX = MODX - 10
      IF ( MODX .GE.  1  .AND. MODX .LE. 10 ) GO TO
     1(2081, 2082, 2083, 2084, 2085, 2086, 2087, 2088, 2089, 2090),MODX
      MODX = MODX - 10
      IF ( MODX .GE.  1  .AND. MODX .LE. 10 ) GO TO
     1(2091, 2092, 2093, 2094, 2095, 2096, 2097, 2098, 2099, 2100),MODX
      MODX = MODX - 10
      IF ( MODX .GE.  1  .AND. MODX .LE. 10 ) GO TO
     1(2101, 2102, 2103, 2104, 2105, 2106, 2107, 2108, 2109, 2110),MODX
      MODX = MODX - 10
      IF ( MODX .GE.  1  .AND. MODX .LE. 10 ) GO TO
     1(2111, 2112, 2113, 2114, 2115, 2116, 2117, 2118, 2119, 2120),MODX
      MODX = MODX - 10
      IF ( MODX .GE.  1  .AND. MODX .LE. 10 ) GO TO
     1(2121, 2122, 2123, 2124, 2125, 2126, 2127, 2128, 2129, 2130),MODX
      MODX = MODX - 10
      IF ( MODX .GE.  1  .AND. MODX .LE. 10 ) GO TO
     1(2131, 2132, 2133, 2134, 2135, 2136, 2137, 2138, 2139, 2140),MODX
      MODX = MODX - 10
      IF ( MODX .GE.  1  .AND. MODX .LE. 10 ) GO TO
     1(2141, 2142, 2143, 2144, 2145, 2146, 2147, 2148, 2149, 2150),MODX
      MODX = MODX - 10
      IF ( MODX .GE.  1  .AND. MODX .LE. 10 ) GO TO
     1(2151, 2152, 2153, 2154, 2155, 2156, 2157, 2158, 2159, 2160),MODX
      MODX = MODX - 10
      IF ( MODX .GE.  1  .AND. MODX .LE. 10 ) GO TO
     1(2161, 2162, 2163, 2164, 2165, 2166, 2167, 2168, 2169, 2170),MODX
      MODX = MODX - 10
      IF ( MODX .GE.  1  .AND. MODX .LE. 10 ) GO TO
     1(2171, 2172, 2173, 2174, 2175, 2176, 2177, 2178, 2179, 2180),MODX
      MODX = MODX - 10
      IF ( MODX .GE.  1  .AND. MODX .LE. 10 ) GO TO
     1(2181, 2182, 2183, 2184, 2185, 2186, 2187, 2188, 2189, 2190),MODX
      MODX = MODX - 10
      IF ( MODX .GE.  1  .AND. MODX .LE. 10 ) GO TO
     1(2191, 2192, 2193, 2194, 2195, 2196, 2197, 2198, 2199, 2200),MODX
      MODX = MODX - 10
      IF ( MODX .GE.  1  .AND. MODX .LE. 10 ) GO TO
     1(2201, 2202, 2203, 2204, 2205, 2206, 2207, 2208, 2209, 2210),MODX
      MODX = MODX - 10
      IF ( MODX .GE.  1  .AND. MODX .LE.  7 ) GO TO
     1(2211, 2212, 2213, 2214, 2215, 2216, 2217), MODX
      GO TO 940
 2003 CALL XCHK
      GO TO 10
 2005 CALL XCEI
      GO TO 10
 2006 CALL XCEI
      GO TO 10
 2007 CALL XCEI
      GO TO 10
 2008 CALL XSAVE
      GO TO 10
 2009 CALL XPURGE
      GO TO 10
 2010 CALL XEQUIV
      GO TO 10
 2011 CALL XCEI
      GO TO 10
 2012 CALL XCEI
      GO TO 10
 2013 CALL XCEI
      GO TO 10
 2014 CALL DADD
      GO TO 10
 2015 CALL DADD5
      GO TO 10
 2016 CALL AMG
      GO TO 10
 2017 CALL AMP
      GO TO 10
 2018 CALL APD
      GO TO 10
 2019 CALL BMG
      GO TO 10
 2020 CALL CASE
      GO TO 10
 2021 CALL CYCT1
      GO TO 10
 2022 CALL CYCT2
      GO TO 10
 2023 CALL CEAD
      GO TO 10
 2024 CALL CURV
      GO TO 10
 2025 CONTINUE
      GO TO 10
 2026 CALL DDR
      GO TO 10
 2027 CALL DDR1
      GO TO 10
 2028 CALL DDR2
      GO TO 10
 2029 CALL DDRMM
      GO TO 10
 2030 CALL DDCOMP
      GO TO 10
 2031 CALL DIAGON
      GO TO 10
 2032 CALL DPD
      GO TO 10
 2033 CALL DSCHK
      GO TO 10
 2034 CALL DSMG1
      GO TO 10
 2035 CALL DSMG2
      GO TO 10
 2036 CONTINUE
      GO TO 10
 2037 CALL DUMOD1
      GO TO 10
 2038 CALL DUMOD2
      GO TO 10
 2039 CALL DUMOD3
      GO TO 10
 2040 CALL DUMOD4
      GO TO 10
 2041 CONTINUE
      GO TO 10
 2042 CALL EMA1
      GO TO 10
C         SET LINKNO TO FLAG SUBROUTINE SMA1B TO CALL EMG1B
 2043 LINKNO = LINKNM(8)
      CALL EMG
      LINKNO = LINKNM(1)
      GO TO 10
 2044 CALL FA1
      GO TO 10
 2045 CALL FA2
      GO TO 10
 2046 CALL DFBS
      GO TO 10
 2047 CALL FRLG
      GO TO 10
 2048 CALL FRRD
      GO TO 10
 2049 CONTINUE
      GO TO 10
 2050 CALL GI
      GO TO 10
 2051 CALL GKAD
      GO TO 10
 2052 CALL GKAM
      GO TO 10
 2053 CALL GP1
      GO TO 10
 2054 CALL GP2
      GO TO 10
 2055 CALL GP3
      GO TO 10
 2056 CALL GP4
      GO TO 10
 2057 CALL GPCYC
      GO TO 10
 2058 CALL GPFDR
      GO TO 10
 2059 CALL DUMOD5
      GO TO 10
 2060 CALL GPWG
      GO TO 10
 2061 CONTINUE
      GO TO 10
 2062 CALL INPUT
      GO TO 10
 2063 CALL INPTT1
      GO TO 10
 2064 CALL INPTT2
      GO TO 10
 2065 CALL INPTT3
      GO TO 10
 2066 CALL INPTT4
      GO TO 10
 2067 CALL MATGEN
      GO TO 10
 2068 CALL MATGPR
      GO TO 10
 2069 CALL MATPRN
      GO TO 10
 2070 CALL PRTINT
      GO TO 10
 2071 CALL MCE1
      GO TO 10
 2072 CALL MCE2
      GO TO 10
 2073 CALL MERGE1
      GO TO 10
 2074 CONTINUE
      GO TO 10
 2075 CALL MODA
      GO TO 10
 2076 CALL MODACC
      GO TO 10
 2077 CALL MODB
      GO TO 10
 2078 CALL MODC
      GO TO 10
 2079 CALL DMPYAD
      GO TO 10
 2080 CALL MTRXIN
      GO TO 10
 2081 CALL OFP
      GO TO 10
 2082 CALL OPTPR1
      GO TO 10
 2083 CALL OPTPR2
      GO TO 10
 2084 CONTINUE
      GO TO 10
 2085 CALL OUTPT
      GO TO 10
 2086 CALL OUTPT1
      GO TO 10
 2087 CALL OUTPT2
      GO TO 10
 2088 CALL OUTPT3
      GO TO 10
 2089 CALL OUTPT4
      GO TO 10
 2090 CALL QPARAM
      GO TO 10
 2091 CALL PARAML
      GO TO 10
 2092 CALL QPARMR
      GO TO 10
 2093 CALL PARTN1
      GO TO 10
 2094 CONTINUE
      GO TO 10
 2095 CALL MRED1
      GO TO 10
 2096 CALL MRED2
      GO TO 10
 2097 CALL CMRD2
      GO TO 10
 2098 CALL PLA1
      GO TO 10
 2099 CALL PLA2
      GO TO 10
 2100 CALL PLA3
      GO TO 10
 2101 CALL PLA4
      GO TO 10
 2102 CONTINUE
      GO TO 10
 2103 CALL DPLOT
      GO TO 10
 2104 CALL DPLTST
      GO TO 10
 2105 CALL PLTTRA
      GO TO 10
 2106 CALL PRTMSG
      GO TO 10
 2107 CALL PRTPRM
      GO TO 10
 2108 CALL RANDOM
      GO TO 10
 2109 CALL RBMG1
      GO TO 10
 2110 CALL RBMG2
      GO TO 10
 2111 CALL RBMG3
      GO TO 10
 2112 CALL RBMG4
      GO TO 10
 2113 CONTINUE
      GO TO 10
 2114 CALL REIG
      GO TO 10
 2115 CALL RMG
      GO TO 10
 2116 CALL SCALAR
      GO TO 10
 2117 CALL SCE1
      GO TO 10
 2118 CALL SDR1
      GO TO 10
 2119 CALL SDR2
      GO TO 10
 2120 CALL SDR3
      GO TO 10
 2121 CALL SDRHT
      GO TO 10
 2122 CALL SEEMAT
      GO TO 10
 2123 CONTINUE
      GO TO 10
 2124 CALL SETVAL
      GO TO 10
 2125 CALL SMA1
      GO TO 10
 2126 CALL SMA2
      GO TO 10
 2127 CALL SMA3
      GO TO 10
 2128 CALL SMP1
      GO TO 10
 2129 CALL SMP2
      GO TO 10
 2130 CALL SMPYAD
      GO TO 10
 2131 CALL SOLVE
      GO TO 10
 2132 CONTINUE
      GO TO 10
 2133 CALL SSG1
      GO TO 10
 2134 CALL SSG2
      GO TO 10
 2135 CALL SSG3
      GO TO 10
 2136 CALL SSG4
      GO TO 10
 2137 CALL SSGHT
      GO TO 10
 2138 CALL TA1
      GO TO 10
 2139 CALL TABPCH
      GO TO 10
 2140 CONTINUE
      GO TO 10
 2141 CALL TABFMT
      GO TO 10
 2142 CALL TABPT
      GO TO 10
 2143 CONTINUE
      GO TO 10
 2144 CALL TIMTST
      GO TO 10
 2145 CALL TRD
      GO TO 10
 2146 CALL TRHT
      GO TO 10
 2147 CALL TRLG
      GO TO 10
 2148 CALL DTRANP
      GO TO 10
 2149 CALL DUMERG
      GO TO 10
 2150 CALL DUPART
      GO TO 10
 2151 CALL VDR
      GO TO 10
 2152 CALL VEC
      GO TO 10
 2153 CONTINUE
      GO TO 10
 2154 CALL XYPLOT
      GO TO 10
 2155 CALL XYPRPT
      GO TO 10
 2156 CALL XYTRAN
      GO TO 10
 2157 CONTINUE
      GO TO 10
 2158 CALL COMB1
      GO TO 10
 2159 CALL COMB2
      GO TO 10
 2160 CALL EXIO
      GO TO 10
 2161 CALL RCOVR
      GO TO 10
 2162 CALL EMFLD
      GO TO 10
 2163 CONTINUE
      GO TO 10
 2164 CALL RCOVR3
      GO TO 10
 2165 CALL REDUCE
      GO TO 10
 2166 CALL SGEN
      GO TO 10
 2167 CALL SOFI
      GO TO 10
 2168 CALL SOFO
      GO TO 10
 2169 CALL SOFUT
      GO TO 10
 2170 CALL SUBPH1
      GO TO 10
 2171 CALL PLTMRG
      GO TO 10
 2172 CONTINUE
      GO TO 10
 2173 CALL COPY
      GO TO 10
 2174 CALL SWITCH
      GO TO 10
 2175 CALL MPY3
      GO TO 10
 2176 CALL DDCMPS
      GO TO 10
 2177 CALL LODAPP
      GO TO 10
 2178 CALL GPSTGN
      GO TO 10
 2179 CALL EQMCK
      GO TO 10
 2180 CALL ADR
      GO TO 10
 2181 CALL FRRD2
      GO TO 10
 2182 CALL GUST
      GO TO 10
 2183 CALL IFT
      GO TO 10
 2184 CALL LAMX
      GO TO 10
 2185 CALL EMA
      GO TO 10
 2186 CALL ANISOP
      GO TO 10
 2187 CONTINUE
      GO TO 10
 2188 CALL GENCOS
      GO TO 10
 2189 CALL DDAMAT
      GO TO 10
 2190 CALL DDAMPG
      GO TO 10
 2191 CALL NRLSUM
      GO TO 10
 2192 CALL GENPAR
      GO TO 10
 2193 CALL CASEGE
      GO TO 10
 2194 CALL DESVEL
      GO TO 10
 2195 CALL PROLAT
      GO TO 10
 2196 CALL MAGBDY
      GO TO 10
 2197 CALL COMUGV
      GO TO 10
 2198 CALL FLBMG
      GO TO 10
 2199 CALL GFSMA
      GO TO 10
 2200 CALL TRAIL
      GO TO 10
 2201 CALL SCAN
      GO TO 10
 2202 CONTINUE
      GO TO 10
 2203 CALL PTHBDY
      GO TO 10
 2204 CALL VARIAN
      GO TO 10
 2205 CALL FVRST1
      GO TO 10
 2206 CALL FVRST2
      GO TO 10
 2207 CALL ALG
      GO TO 10
 2208 CALL APDB
      GO TO 10
 2209 CALL PROMPT
      GO TO 10
 2210 CALL OLPLOT
      GO TO 10
 2211 CALL INPTT5
      GO TO 10
 2212 CALL OUTPT5
      GO TO 10
 2213 CONTINUE
      GO TO 10
 2214 CALL QPARMD
      GO TO 10
 2215 CALL GINOFL
      GO TO 10
 2216 CALL DBASE
      GO TO 10
 2217 CALL NORMAL
      GO TO 10
      END

      SUBROUTINE STRAP2 (TI)
C
C
C*****
C THIS ROUTINE IS PHASE II OF STRESS DATA RECOVERY FOR THE TRAPEZOIDAL
C CROSS SECTION RING
C*****
C
C
C
      DIMENSION          TI(4)
      DIMENSION          DUM3(225)
      DIMENSION          STRES(100),    FORCE(25)
      DIMENSION          ISTRES(100),   IFORCE(25)
C
C
C SDR2 VARIABLE CORE
C
      COMMON   /ZZZZZZ/  ZZ(1)
C
C
C SDR2 BLOCK FOR POINTERS AND LOADING TEMPERATURES
C
      COMMON   /SDR2X4/
     1                   DUM1(33)
     2,                  ICSTM,    NCSTM,    IVEC,     IVECN
     3,                  TEMPLD,   ELDEFM
C
C
C SDR2 INPUT AND OUTPUT BLOCK
C
      COMMON   /SDR2X7/
     1                   IDEL,     IGP(4),   TZ
     2,                  SEL(240), TS(4),    AK(144)
C
C
C SCRATCH BLOCK
C
      COMMON   /SDR2X8/
     1                   DISP(12), EFORC(12),ESTRES(20)
C
C
      EQUIVALENCE (DUM3(1) , IDEL)
      EQUIVALENCE  (DUM3(101) , STRES(1) , ISTRES(1))
      EQUIVALENCE  (DUM3(201) , FORCE(1) , IFORCE(1))
      EQUIVALENCE (LDTEMP, TEMPLD)
C
C
C INITIALIZE COUNTERS
C
      NDOF  = 3
      NUMPT = 4
      N = NDOF * NUMPT
      NSP   = 5
      NCOMP =  4
      NS = NSP * NCOMP
C
C
C LOCATE THE DISPLACEMENTS
C
      K = 0
      DO 100 I = 1,NUMPT
      ILOC = IVEC + IGP(I) - 2
      DO 100 J = 1,NDOF
      ILOC = ILOC + 1
      K = K + 1
      DISP(K) = ZZ(ILOC)
  100 CONTINUE
C
C
C COMPUTE THE GRID POINT FORCES
C
      CALL GMMATS ( AK(1) , N, N, 0, DISP(1) , N, 1, 0, EFORC(1) )
C
C
C COMPUTE THE STRESSES
C
      CALL GMMATS ( SEL(1), NS, N, 0, DISP(1) , N, 1, 0, ESTRES(1) )
C
C
C COMPUTE THERMAL STRESS IF THERMAL LOAD EXISTS
C AND SUBTRACT FROM APPARENT STRESS
C
      IF (LDTEMP .EQ. (-1)) GO TO 300
C
      K = 0
      DO 200 I = 1,NSP
      DT = TI(I) - TZ
      IF (I.EQ.5) DT = (TI(1)+TI(2)+TI(3)+TI(4)) / 4.0E0  -  TZ
      DO 200 J = 1,NCOMP
      K = K + 1
      ESTRES(K) = ESTRES(K) - DT * TS(J)
  200 CONTINUE
C
  300 CONTINUE
C
C
C STORE RESULTS FOR OUTPUT PRINT
C
      K = 0
      J = 1
      ISTRES(1)   = IDEL
      DO 400 KK = 1,NSP
      DO 400 I = 1,NCOMP
      J = J + 1
      K = K + 1
      STRES(J) = ESTRES(K)
  400 CONTINUE
C
C
      K = 0
      J = 1
      IFORCE(1)   = IDEL
      DO 500 I = 1,NUMPT
      DO 500 KK= 1,NDOF
      J = J + 1
      K = K + 1
      FORCE(J) = EFORC(K)
  500 CONTINUE
C
      RETURN
      END

      SUBROUTINE FBSF (ZS,ZD)
C
C     GIVEN A LOWER TRIANGULAR FACTOR WITH DIAGONAL SUPERIMPOSED, AND
C     WRITTEN WITH TRAILING STRING DEFINITION WORDS, FBS WILL PERFORM
C     THE FORWARD-BACKWARD SUBSTITUTION NECESSARY TO SOLVE A LINEAR
C     SYSTEM OF EQUATIONS.
C
C     OPEN CORE IS DEFINED AS FOLLOWS
C
C     ZS(   1         ) - FIRST RIGHT HAND VECTOR ON FILE DBB
C                         (SIZE = NCOL*NWDS)
C                         NCOL = NUMBER OF COLUMNS (ROWS) IN LOWER  
C                                TRIANGULAR MATRIX
C                         NWDS = 1, IF MATRICES ARE REAL SINGLE
C                              = 2, IF MATRICES ARE REAL DOUBLE OR 
C                                COMPLEX SINGLE
C                              = 4, IF MATRICES ARE COMPLEX DOUBLE
C     ZS( NCOL*NWDS+1 ) - NEXT RIGHT HAND VECTOR
C         .
C         .               ( "KN" RIGHT HAND VECTORS WILL BE LOADED INTO 
C         .               MEMORY)
C         .
C     ZS( BUF1        ) - BUFFER FOR FILE WITH RIGHT HAND VECTORS
C                         AND FOR SOLUTION VECTORS
C     ZS( BUF2        ) - BUFFER FOR FILE WITH TRIANGULAR MATRIX
C
      IMPLICIT INTEGER (A-Z)
      LOGICAL         IDENT
      INTEGER         SUBNAM(2) ,BLOCK(15),BEGN     ,END
      REAL            ZS(1)    ,XS(4)    ,YS(4)
      DOUBLE  PRECISION          ZD(1)    ,XD       ,YD
      CHARACTER       UFM*23    ,UWM*25   ,UIM*29
      COMMON /LOGOUT/ LOUT
      COMMON /XMSSG / UFM       ,UWM      ,UIM
      COMMON /FBSX  / DBL(7)    ,DBU(7)   ,DBB(7)   ,DBX(7)   ,LCORE   ,
     1                PREC      ,SIGN     ,SCRX
      COMMON /SYSTEM/ SYSBUF    ,NOUT     ,SKIP(91) ,KSYS94
      COMMON /NAMES / RD        ,RDREW    ,WRT      ,WRTREW   ,REW     ,
     1                NOREW     ,EOFNRW   ,RSP      ,RDP      ,CSP     ,
     2                CDP
      COMMON /TYPE  / PRC(2)    ,WORDS(4) ,RLCMPX(4)
      COMMON /PACKX / ITYPE1    ,ITYPE2   ,I1       ,J1       ,INCR1
      COMMON /UNPAKX/ ITYPE3    ,I2       ,J2       ,INCR2
      COMMON /ZNTPKX/ XD(2)     ,IX       ,EOL
      COMMON /ZBLPKX/ YD(2)     ,IY
      EQUIVALENCE     (DBL(2),NL),   (DBB(5),TYPEB), (DBX(5),TYPEX),
     1                (XD(1),XS(1)), (YD(1),YS(1))
      DATA    SUBNAM/ 4HFBSF,4H    /  
      DATA    BEGN  / 4HBEGN/
      DATA    END   / 4HEND /
C
C     GENERAL INITIALIZATION
C
      BUF2   = LCORE - SYSBUF
      BUF1   = BUF2  - SYSBUF
      RC     = RLCMPX(TYPEB)
      TYPEL  = DBL(5)
      WDS    = WORDS(TYPEL)
      NWDS   = WDS*NL
      NBRLOD = DBB(2)
      IDENT  = .FALSE.
      IF (DBB(4) .EQ. 8) IDENT = .TRUE.
      IF (IDENT) NBRLOD = NL
      SWITCH = 1
      IF (TYPEL.EQ.RSP .AND. RC.EQ.2) SWITCH = 2
      IF (TYPEL.EQ.RDP .AND. RC.EQ.2) SWITCH = 3
      DBL1   = DBL(1)
      NNN    = BUF1 - 1
      NVECS  = NNN/NWDS
      IF (NVECS .EQ. 0) CALL MESAGE (-8,NWDS-NNN,SUBNAM)
      IF (SWITCH .NE. 1) NVECS = NVECS/2
      NPASS  = (NBRLOD+NVECS-1)/NVECS
      SUBNAM(2) = BEGN
      CALL CONMSG (SUBNAM,2,0)
   40 NPASS  = (NBRLOD+NVECS-1)/NVECS
      IF ( NPASS .EQ. 1 ) GO TO 50
      NEED = NWDS*NBRLOD + 2*SYSBUF
      WRITE ( LOUT, 9001 ) NPASS, NEED
9001  FORMAT(I4,' PASSES REQUIRED, OPEN CORE NEEDS TO BE ',I7
     &,' TO ELIMINATE THIS')
   50 CONTINUE
      I2     = 1
      J2     = NL
      INCR2  = 1
      I1     = 1
      J1     = NL
      INCR1  = 1
      ITYPE1 = TYPEL
      ITYPE2 = TYPEX
      ITYPE3 = SIGN*TYPEL
      DBX(2) = 0
      DBX(6) = 0
      DBX(7) = 0
      NNNDBL = NNN/2
      NTERMS = RLCMPX(TYPEL)*NL
      K1     = 1
      OPRD   = RDREW
      OPWRT  = WRTREW
      BLOCK(1) = DBL(1)
C
C     OPEN LOWER TRIANGULAR FACTOR FILE (DBL1)
C
      CALL GOPEN (DBL1,ZS(BUF2),RDREW)
C
C     OPEN RIGHT HAND VECTORS FILE (DBB) AND COMPUTE EXTENT OF THIS PASS
C
  100 KN    = MIN0(K1+NVECS-1,NBRLOD)
      LAST  = (KN-K1+1)*NWDS
      OPCLS = NOREW
      IF (KN .EQ. NBRLOD) OPCLS = REW
      IF (IDENT) GO TO 280
      CALL GOPEN (DBB,ZS(BUF1),OPRD)
      GO TO (140,180,230), SWITCH
C
C     NORMAL CASE - FILL CORE WITH RIGHT HAND VECTORS
C
  140 DO 170 L = 1,LAST,NWDS
      CALL UNPACK (*150,DBB,ZS(L))
      GO TO 170
  150 LN = L + NWDS - 1
      DO 160 LL = L,LN
  160 ZS(LL) = 0.
  170 CONTINUE
      GO TO 390
C
C     SPECIAL CASE - FACTOR IS RSP AND VECTORS ARE CSP
C
  180 LAST = 2*(KN-K1+1)*NWDS
      L = 0
      DO 190 K = 1,NNNDBL
  190 ZD(K) = 0.0D+0
      DO 220 K = K1,KN
      ICSPSG = CSP*SIGN
      CALL INTPK (*210,DBB,0,ICSPSG,0)
  200 CALL ZNTPKI
      ZS(L+IX   ) = XS(1)
      ZS(L+IX+NL) = XS(2)
      IF (EOL .EQ. 0) GO TO 200
  210 L = L + 2*NL
  220 CONTINUE
      GO TO 390
C
C     SPECIAL CASE - FACTOR IS RDP AND VECTORS ARE CDP
C
  230 LAST = 2*(KN-K1+1)*NWDS
      L = 0
      DO 240 K = 1,NNNDBL
  240 ZD(K) = 0.0D+0
      DO 270 K = K1,KN
      ICDPSG = CDP*SIGN
      CALL INTPK (*260,DBB,0,ICDPSG,0)
  250 CALL ZNTPKI
      ZD(L+IX   ) = XD(1)
      ZD(L+IX+NL) = XD(2)
      IF (EOL .EQ. 0) GO TO 250
  260 L = L + 2*NL
  270 CONTINUE
      GO TO 390
C
C     SPECIAL CASE - GENERATE IDENTITY MATRIX
C
  280 DO 290 K = 1,NNNDBL
  290 ZD(K) = 0.0D+0
      L = 0
      GO TO (300,320,340,360), TYPEL
  300 DO 310 K = K1,KN
      ZS(L+K) = 1.0
  310 L = L + NTERMS
      GO TO 400
  320 DO 330 K = K1,KN
      ZD(L+K) = 1.0D+0
  330 L = L + NTERMS
      GO TO 400
  340 DO 350 K = K1,KN
      ZS(L+2*K-1) = 1.0
  350 L = L + NTERMS
      GO TO 400
  360 DO 370 K = K1,KN
      ZD(L+2*K-1) = 1.0D+0
  370 L = L + NTERMS
      GO TO 400
C
C    CLOSE RIGHT HAND VECTORS FILE (DBB).
C    START FORWARD-BACKWARD SUBSTITUTION ON RIGHT HAND VECTORS NOW IN CORE
C
  390 CALL CLOSE  (DBB,OPCLS)
  400 CALL REWIND (DBL1)
      CALL FWDREC (*610,DBL1)
C
      J = TYPEL 
      GO TO (410,420,430,440), J
  410 CALL FBS1 (BLOCK,ZS,ZS(LAST),NWDS)
      GO TO 500
  420 CALL FBS2 (BLOCK,ZS,ZS(LAST),NWDS)
      GO TO 500
  430 CALL FBS3 (BLOCK,ZS,ZS(LAST),NWDS)
      GO TO 500
  440 CALL FBS4 (BLOCK,ZS,ZS(LAST),NWDS)
      GO TO 500
C
C     OPEN AND PACK SOLUTION VECTORS ONTO OUTPUT FILE (DBX)
C
  500 CALL GOPEN (DBX,ZS(BUF1),OPWRT)
      GO TO (510,530,560), SWITCH
C
C     NORMAL CASE - CALL PACK
C
  510 DO 520 L = 1,LAST,NWDS
      CALL PACK (ZS(L),DBX,DBX)
  520 CONTINUE
      GO TO 600
C
C     SPECIAL CASE - FACTOR IS RSP AND VECTORS ARE CSP, CALL BLDPK
C
  530 L = 0
      DO 550 K = K1,KN
      CALL BLDPK (CSP,TYPEX,DBX,0,0)
      DO 540 I = 1,NL
      YS(1) = ZS(L+I   )
      YS(2) = ZS(L+I+NL)
      IY = I
      CALL ZBLPKI
  540 CONTINUE
      CALL BLDPKN (DBX,0,DBX)
      L = L + 2*NL
  550 CONTINUE
      GO TO 600
C
C     SPECIAL CASE - FACTOR IS RDP AND VECTORS ARE CDP, CALL BLDPK
C
  560 L = 0
      DO 580 K = K1,KN
      CALL BLDPK (CDP,TYPEX,DBX,0,0)
      DO 570 I = 1,NL
      YD(1) = ZD(L+I   )
      YD(2) = ZD(L+I+NL)
      IY = I
      CALL ZBLPKI
  570 CONTINUE
      CALL BLDPKN (DBX,0,DBX)
      L = L + 2*NL
  580 CONTINUE
C
C     CLOSE OUTPUT FILE, AND TEST FOR MORE PASSES
C
  600 CALL CLOSE (DBX,OPCLS)
      IF (KN .EQ. NBRLOD) GO TO 620
      K1   = KN + 1
      OPRD = RD
      OPWRT= WRT
      GO TO 100
C
C     ERROR
C
  610 CALL MESAGE (-2,DBL1,SUBNAM)
C
C     JOB DONE. CLOSE TRIANGULAR FACTOR FILE.
C
  620 CALL CLOSE (DBL1,REW)
      SUBNAM(2) = END
      CALL CONMSG (SUBNAM,2,0)
      RETURN
      END

      SUBROUTINE TORDRS
C
C     THIS SUBROUTINE COMPUTES THE STIFFNESS MATRIX AND THE MASS MATRIX
C     FOR AN AXI-SYMMETRIC TORDIDAL THIN SHELL RING
C
C     SINGLE PRECISION VERSION
C
C     THIS ROUTINE USES SUBROUTINES ROMBSK  DMATRX
C
C
C*****
C
C                        ECPT FOR THE TOROIDAL RING
C
C                                                       TYPE
C ECPT( 1) ELEMENT IDENTIFICATION                         I
C ECPT( 2) SCALAR INDEX NO. FOR GRID POINT A              I
C ECPT( 3) SCALAR INDEX NO. FOR GRID POINT B              I
C ECPT( 4) ANGLE OF CURVATURE AT GRID POINT A             R
C ECPT( 5) ANGLE OF CURVATURE AT GRID POINT B(NOT USED)   R
C ECPT( 6) MATERIAL ORIENTATION (NOT USED)                R
C ECPT( 7) MATERIAL IDENTIFICATION                        I
C ECPT( 8) MEMBRANE THICKNESS                             R
C ECPT( 9) FLEXURE THICKNESS                              R
C ECPT(10) COOR. SYS. ID. FOR GRID POINT A                I
C ECPT(11) X-COOR. OF GRID POINT A (IN BASIC COOR.)       R
C ECPT(12) Y-COOR. OF GRID POINT A (IN BASIC COOR.)       R
C ECPT(13) Z-COOR. OF GRID POINT A (IN BASIC COOR.)       R
C ECPT(14) COOR. SYS. ID. FOR GRID POINT B                I
C ECPT(15) X-COOR. OF GRID POINT B (IN BASIC COOR.)       R
C ECPT(16) Y-COOR. OF GRID POINT B (IN BASIC COOR.)       R
C ECPT(17) Z-COOR. OF GRID POINT B (IN BASIC COOR.)       R
C ECPT(18) EL. TEMPERATURE FOR MATERIAL PROPERTIES        R
C
C*****
C
      DOUBLE PRECISION CONSTD
      DIMENSION  IECPT(18),        ICS(2)
      DIMENSION
     X   AM(144),GAMBQF(72),GAMBQM(48),EE(4),AK(144),GAMRS(144),AKI(36),
     X ECPT(9),DELINT(66),D(144),R(2),Z(2),KOUT(144),GAMBQ(144)
      REAL KOUT,AKM(36),MOUT(144)
      INTEGER  DICT (9),ELID,ESTID
      LOGICAL  NOGO,HEAT
C
C
      COMMON /CONDAD/ CONSTD(5)
C
      COMMON   /MATIN/
     1                   MATIDC        ,MATFLG
     2,                  ELTEMP        ,STRESS
     3,                  SINTH         ,COSTH
      COMMON   /MATOUT/
     1                   E(3)          ,ANU(3)
     2,                  RHO           ,G(3)
     3,                  ALF(3)        ,TZERO,    GSUBE
      COMMON  /SYSTEM/ KSYSTM(55),HEAT
C
      COMMON  /EMGPRM/ DUM(15), ISMB(3),IPREC,NOGO,IHEAT
      COMMON  /EMGDIC/ IDM, LDICT,NGRIDS, ELID,ESTID
C
      COMMON  /EMGEST/ IDEL,IGP(2),ALPH(2),OM,MATID,TM,TF,ICS1,
     X                 R1,D1,Z1,ICS2,R2,D2,Z2,TEMPE
C
      EQUIVALENCE (DICT5,DICT(5))
      EQUIVALENCE (IECPT(1),ECPT(1),IDEL)
      EQUIVALENCE ( CONSTD(2) , TWOPI  )
      EQUIVALENCE ( CONSTD(4) , DEGRAD )
      EQUIVALENCE        (A1, ALPH(1)), (A2, ALPH(2))
      EQUIVALENCE        (GAMBQF(1), GAMBQ(1))
      EQUIVALENCE        (GAMBQM(1), GAMBQ(73))
      EQUIVALENCE        (DELINT(1), GAMBQ(1))
      EQUIVALENCE        (GAMRS(1),  GAMBQ(1))
C
C
C ----------------------------------------------------------------------
C
C     SET UP THE DICT ARRAY
C
      IPR= IPREC
      DICT(1) = ESTID
      DICT(3) = 12
      DICT(4) = 63
      ICS(1)= IECPT(10)
      ICS(2)= IECPT(14)
      R(1) = R1
      R(2) = R2
      Z(1) = Z1
      Z(2) = Z2
C
C
C TEST THE VALIDITY OF THE GRID POINT COORDINATES
C
      IF (R1 .LT. 0. .OR. R2 .LT. 0.) GO TO 7770
      IF (D1 .NE. 0. .OR. D2 .NE. 0.) GO TO 7770
C
C
C DETERMINE IF ELEMENT IS A TOROIDAL, CONICAL OR CYLINDRICAL RING
C
      ITORD = 0
      IF (ABS(A1-A2) .LE. 1.E-6) ITORD =1
      IF (ITORD .EQ. 1 .AND.ABS(A1 - 90.) .LE. 1.E-5) ITORD=-1
C
C
C COMPUTE THE ELEMENT COORDINATES
C
      A1 = A1 * DEGRAD
      A2 = A2 * DEGRAD
      PHIB = A2 - A1
      SINA1 = SIN(A1)
      COSA1 = COS(A1)
      SINA2 = SIN(A2)
      COSA2 = COS(A2)
C
      IF (ITORD .NE. 0) GO TO 100
C
C FOR THE TOROIDAL RING
C
      RP = SQRT((R2-R1)**2  + (Z2-Z1)**2)/(2.*SIN(PHIB/2.))
      S  = PHIB * RP
      GO TO 110
C
C  FOR THE CONICAL OR CYLINDRICAL RING
C
  100 RP = 0.
      S = SQRT((R2-R1)**2 + (Z2-Z1)**2)
C
C  COMPUTE THE BASIC AND REQUIRED INTEGRALS
C
C  SET UP THE ARRAY OF CONSTANTS FOR ROMBER INTEGRATION ROUTINE
C
  110 D(21) = 0.
      D(22) = RP
      D(23) = R1
      D(24) = COSA1
      D(25) = SINA1
C
C COMPUTE CONSTANTS NEEDED FOR INTEGRAL CALCULATIONS
C
      D(30) = R1 - RP * SINA1
      D(31) = RP * COSA1
      D(32) = RP * SINA1
      D(33) = COSA1 ** 2
      D(34) = SINA1 * COSA1
      D(35) = SINA1 ** 2
      D(36) = 0.5 - D(35)
C
C START LOOP  FOR CALCULATIONS OF INTEGRALS
C
      DO  260 JP1=1,11
      J = JP1 - 1
      K = (J * 6) + 1
      DJP1 = JP1
C
C TEST FOR ELEMENT SHAPE
C
      IF (ITORD) 240,120,170
C
C THE TOROIDAL RING BASIC INTEGRALS WILL BE COMPUTED IN
C LOCATIONS D(1),...,D(6)
C
  120 D(20) = (RP** JP1)
C
C COMPUTE I(J,1)
C
      D(1) = D(20) * (PHIB ** JP1) / DJP1
C
C COMPUTE I(J,2)
C
      D(2) = (PHIB**(JP1+1))/ (DJP1 + 1.)
      D(10)= 1.
      DO  130 I=1,20
      IP = JP1 + 2 * I + 1
      D(11) = 2 * I + 1
      D(10)= D(10)*D(11)*(D(11)-1.)
      D(12)= (-1.)**I * PHIB**IP/((DJP1+D(11))*D(10))
      D(13)= ABS(D(12)/D(2))
      D(2) = D(2)+ D(12)
      IF (D(13) .LE. 1.E-10) GO TO 140
  130 CONTINUE
      GO TO 7780
  140 D(2) = D(20)*D(2)
C
C COMPUTE I(J,3)
C
      D(3) = (PHIB ** JP1) / DJP1
      D(10) = 1.
      DO 150 I=1,20
      IP = JP1 + 2 * I
      D(11) = 2 * I
      D(10) = D(10)*D(11)*(D(11)-1.)
      D(12) = (-1.)**I  * PHIB**IP/((DJP1+D(11)) *D(10))
      D(13) = ABS(D(12)/D(3))
      D(3)  =  D(3) + D(12)
      IF (D(13).LE. 1.E-10) GO TO 160
  150 CONTINUE
      GO TO 7780
  160 CONTINUE
      D(3) = D(20) * D(3)
      D(26) = DJP1
C
C COMPUTE I(J,4)
C
      CALL ROMBSK( PHIB,D(10),IP,D(4),1,D(21))
      IF (IP .GE. 15) CALL MESAGE (30,26,IDEL)
      D(4) = D(20) * D(4)
C
C COMPUTE I(J,5)
C
      CALL ROMBSK (PHIB,D(10),IP,D(5),2,D(21))
      IF (IP .GE. 15) CALL MESAGE (30,26,IDEL)
      D(5) = D(20) * D(5)
C
C COMPUTE I(J,6)
C
      CALL ROMBSK (PHIB,D(10),IP,D(6),3,D(21))
      IF (IP .GE. 15) CALL MESAGE (30,26,IDEL)
      D(6) = D(20) * D(6)
C
C THE TOROIDAL RING REQUIRED INTEGRALS
C
      DELINT(K  ) = D(30) * D(1) + D(31) * D(2) + D(32) * D(3)
      DELINT(K+1) = COSA1 * D(2) + SINA1 * D(3)
      DELINT(K+2) = D(33) * D(4) + D(34) * D(5) + D(35) * D(6)
      DELINT(K+3) = COSA1 * D(3) - SINA1 * D(2)
      DELINT(K+4) = D(34) * (D(6)-D(4))  + D(36) * D(5)
      DELINT(K+5) = D(33) * D(6) - D(34) * D(5) + D(35) * D(4)
      GO TO 250
C
C THE CONICAL RING BASIC INTEGRALS WILL BE COMPUTED IN
C LOCATIONS D(1) AND D(2)
C
C
C COMPUTE I(J,1)
C
  170 D(1) = (S **JP1)/DJP1
      IF (J-1) 180,190,200
C
C   COMPUTE  I(0,2)
C
  180 D(2) = ALOG((R1 + S*COSA1)/R1)/COSA1
      GO TO 230
C
C    COMPUTE I(1,2)
C
  190 D(2) = (S-(R1/COSA1)*ALOG((R1+S*COSA1)/R1))/COSA1
      GO TO 230
C
C    COMPUTE I(J,2) WHERE J .GT.1
C
  200 D(2) =1./DJP1
      D(10)=  -S*COSA1/R1
      DO  210 I= 1,1000
      D(11) = JP1 + I
      D(12) = (D(10) ** I) / D(11)
      D(2) = D(2) + D(12)
      IF (D(12).LT. 1.E-4) GO TO 220
  210 CONTINUE
      GO TO 7780
  220 D(2)=  ((S**JP1)/R1)* D(2)
C
C THE CONICAL RING REQUIRED INTEGRALS
C
  230 DELINT(K  ) = R1*D(1) + COSA1*(S**(JP1+1)/(DJP1+1.))
      DELINT(K+1) = SINA1 * D(1)
      DELINT(K+2) = D(35) * D(2)
      DELINT(K+3) = COSA1 * D(1)
      DELINT(K+4) = D(34) * D(2)
      DELINT(K+5) = D(33) * D(2)
      GO TO 250
C
C THE CYLINDRICAL RING BASIC INTEGRALS WILL BE COMPUTED IN
C LOCATIONS D(1) AND D(2)
C
C
C COMPUTE I(J,1)
C
  240 D(1) = (S**JP1)/DJP1
C
C COMPUTE I(J,2)
C
      D(2) = D(1) / R1
C
C THE CYLINDRICAL RING REQUIRED INTEGRALS
C
      DELINT(K  ) =  R1*D(1) + COSA1*(S**(JP1+1)/(DJP1+1.))
      DELINT(K+1) = SINA1 * D(1)
      DELINT(K+2) = D(35) * D(2)
      DELINT(K+3) = 0.
      DELINT(K+4) = 0.
      DELINT(K+5) = 0.
C
  250 CONTINUE
C
  260 CONTINUE
C
C   IF STIFFNESS MATRIX NOT REQUIRED  GO TO MASS ROUTINE
C
C
C
C LOCATE THE MATERIAL PROPERTIES IN THE MAT1 OR MAT3 TABLE
C
      MATIDC = MATID
      MATFLG = 7
      ELTEMP = TEMPE
      CALL MAT(IDEL)
C
C
C SET MATERIAL PROPERTIES IN LOCAL VARIABLES
C
      EP = E(1)
      ET = E(2)
      VPT= ANU(1)
      VTP= VPT * ET / EP
      DEL = 1. - VPT*VTP
      DICT5 = G SUBE
C
C
C GENERATE THE ELASTIC CONSTANTS MATRIX(2X2)
C
      EE(1) = EP / DEL
      EE(2) = ET * VPT / DEL
      EE(3) = EE(2)
      EE(4) = ET / DEL
C
C
C FORM THE STIFFNESS MATRIX IN FIELD COORDINATES
C
C COMPUTE CONSTANTS NEEDED IN DMATRX SUBROUTINE
C
      D(1) = EP / ET
      D(7) = 0.
      IF (ITORD .EQ. 0) D(7) = 1./RP
      D(2) = D(1) * D(7)
      D(3) = D(2) * D(7)
      D(4) = VPT * D(7)
      D(5) =(EP * TM / (D(1) - VPT**2)) * TWOPI
      D(6) = (EP*TF**3)/(12.*(D(1)-VPT**2))*TWOPI
C
C CALL THE DMATRIX SUBROUTINE TO COMPUTE THE STIFFNESS MATRIX (10X10)
C
C NOTE THE DOUBLE SUBSCRIPTING USED IN DMATRIX SUBROUTINE IS
C COMPATIBLE WITH THE CALLING PROGRAM. THE DELINT ARRAY OF INTEGRALS
C IS A (11X6) SINGLY SUBSCRIPTED ARRAY (STORED ROWWISE) IN THE CALLING
C PROGRAM AND IT IS A (6X11) DOUBLY SUBSCRIPTED ARRAY (STORED
C COLUMNWISE) IN DMATRX ROUTINE.
C
      IF (ISMB(1) .EQ.  0) GO TO 270
      CALL DMATRS(AK(1),VPT,D(1),D(2),D(3),D(4),D(5),D(6),DELINT(1))
  270 IF (ISMB(2) .EQ. 0)  GO TO 279
      DO 275 I=1,100
  275 AM(I) = 0.
      AM(  1) = DELINT( 1)
      AM(  2) = DELINT( 7)
      AM(  3) = DELINT(13)
      AM(  4) = DELINT(19)
      AM( 11) = DELINT( 7)
      AM( 12) = DELINT(13)
      AM( 13) = DELINT(19)
      AM( 14) = DELINT(25)
      AM( 21) = DELINT(13)
      AM( 22) = DELINT(19)
      AM( 23) = DELINT(25)
      AM( 24) = DELINT(31)
      AM( 31) = DELINT(19)
      AM( 32) = DELINT(25)
      AM( 33) = DELINT(31)
      AM( 34) = DELINT(37)
      AM( 45) = DELINT( 1)
      AM( 46) = DELINT( 7)
      AM( 47) = DELINT(13)
      AM( 48) = DELINT(19)
      AM( 49) = DELINT(25)
      AM( 50) = DELINT(31)
      AM( 55) = DELINT( 7)
      AM( 56) = DELINT(13)
      AM( 57) = DELINT(19)
      AM( 58) = DELINT(25)
      AM( 59) = DELINT(31)
      AM( 60) = DELINT(37)
      AM( 65) = DELINT(13)
      AM( 66) = DELINT(19)
      AM( 67) = DELINT(25)
      AM( 68) = DELINT(31)
      AM( 69) = DELINT(37)
      AM( 70) = DELINT(43)
      AM( 75) = DELINT(19)
      AM( 76) = DELINT(25)
      AM( 77) = DELINT(31)
      AM( 78) = DELINT(37)
      AM( 79) = DELINT(43)
      AM( 80) = DELINT(49)
      AM( 85) = DELINT(25)
      AM( 86) = DELINT(31)
      AM( 87) = DELINT(37)
      AM( 88) = DELINT(43)
      AM( 89) = DELINT(49)
      AM( 90) = DELINT(55)
      AM( 95) = DELINT(31)
      AM( 96) = DELINT(37)
      AM( 97) = DELINT(43)
      AM( 98) = DELINT(49)
      AM( 99) = DELINT(55)
      AM(100) = DELINT(61)
C
      D(1) = TWO PI * RHO * TM
      DO  278  I=1,100
  278 AM(I)= D(1) * AM(I)
  279 CONTINUE
C
C
C
C FORM THE TRANSFORMATION MATRIX(10X12) FROM FIELD COORDINATES TO GRID
C POINT DEGREES OF FREEDOM
C
      DO 280 I=1,72
  280 GAMBQF(I)=0.
      D(1) = S
      D(2) = S ** 2
      D(3) = S ** 3
      D(4) = S ** 4
      D(5) = S ** 5
      GAMBQF(3) = 1.
      GAMBQF(16)= 1.
      GAMBQF(30)= .5
      GAMBQF(39)=-10./D(3)
      GAMBQF(40)= -6./D(2)
      GAMBQF(42)= -1.5/D(1)
      GAMBQF(45) = -GAMBQF(39)
      GAMBQF(46) = -4./D(2)
      GAMBQF(48) =  .5/D(1)
      GAMBQF(51) = 15./D(4)
      GAMBQF(52) =  8./D(3)
      GAMBQF(54) = 1.5/D(2)
      GAMBQF(57) = -GAMBQF(51)
      GAMBQF(58) =  7./D(3)
      GAMBQF(60) = -1./D(2)
      GAMBQF(63) = -6./D(5)
      GAMBQF(64) = -3./D(4)
      GAMBQF(66) = -.5/D(3)
      GAMBQF(69) = -GAMBQF(63)
      GAMBQF(70) =  GAMBQF(64)
      GAMBQF(72) = -GAMBQF(66)
      DO 290 I=1,48
  290 GAMBQM(I) = 0.
      GAMBQM(1) = 1.
      GAMBQM(17)= 1.
      GAMBQM(25)=  -3./D(2)
      GAMBQM(29) = -2./D(1)
      GAMBQM(31)= -GAMBQM(25)
      GAMBQM(35) = -1./D(1)
      GAMBQM(37) = 2./D(3)
      GAMBQM(41) = 1./D(2)
      GAMBQM(43) = -GAMBQM(37)
      GAMBQM(47) =  GAMBQM(41)
C
C
C TRANSFORM THE STIFFNESS MATRIX TO GRID POINT DEGREES OF FREEDOM
C
      IF(ISMB(1).EQ. 0) GO TO 295
      CALL GMMATS(GAMBQ(1),10,12,1, AK(1),10,10,0,  D(1))
      CALL GMMATS(D(1),12,10,0,GAMBQ(1),10,12,0, AK(1))
  295 IF (ISMB(2).EQ.0)  GO TO 299
C     REARRANGE GAMBQ FOR MASS MATRIX CALCULATIONS
      DO 296 I=1,72
296   D(I+48) = GAMBQ(I)
      DO 297 I=1,48
297   D(I) = GAMBQ(I+72)
      DO 298 I=1,120
 298  GAMBQ(I)=D(I)
      CALL GMMATS(GAMBQ(1),10,12,1, AM(1),10,10,0, D(1))
      CALL GMMATS (D(1),12,10,0 ,GAMBQ(1),10,12,0, AM(1))
C
  299 CONTINUE
C
C
C FORM THE TRANSFORMATION MATRIX (12X12) FROM ELEMENT TO BASIC
C COORDINATES
C
      DO 300 I=1,144
  300 GAMRS(I)=0.
      GAMRS( 1) =  COSA1
      GAMRS( 3) = -SINA1
      GAMRS(25) =  SINA1
      GAMRS(27) =  COSA1
      GAMRS(40) = -1.
      GAMRS(53) =  1.
      GAMRS(66) =  1.
      GAMRS(79) =  COSA2
      GAMRS(81) = -SINA2
      GAMRS(103)=  SINA2
      GAMRS(105)=  COSA2
      GAMRS(118) = -1.
      GAMRS(131) = 1.
      GAMRS(144) = 1.
C
C
C TRANSFORM THE STIFFNESS MATRIX FROM ELEMENT TO BASIC COORDINATES
C
      IF (ISMB(1).EQ.0)  GO TO 310
      CALL GMMATS (GAMRS(1),12,12,1,  AK(1),12,12,0,  D(1))
      CALL GMMATS (D(1),12,12,0,  GAMRS(1),12,12,0,  AK(1))
  310 IF (ISMB(2) .EQ.0)  GO TO 315
      CALL GMMATS (GAMRS(1),12,12,1, AM(1),12,12,0, D(1))
      CALL GMMATS (D(1),12,12,0, GAMRS(1),12,12,0, AM(1))
  315 CONTINUE
C
C
C LOCATE THE TRANSFORMATION MATRICES FROM BASIC TO LOCAL COORDINATES
C FOR THE TWO GRID POINTS AND EXPAND TO (6X6)
C THE TWO MATRICES WILL BE STORED IN D(1),...,D(36) AND D(37),...,D(72)
C RESPECTIVELY
C
      DO 320 I =1,72
  320 D(I) = 0.
      DO 350 I =1,2
      IF (ICS(I).EQ. 0) GO TO 350
      K = 36 * (I - 1)
      CALL TRANSS(ICS(I),D(73))
      DO 340 J=1,3
      KK = K + 6 * (J-1) + 1
      KL = 3 * (J-1) + 73
      KJ = K + 6 * (J+2) + J + 3
      D(KK  ) = D(KL  )
      D(KK+1) = D(KL+1)
      D(KK+2) = D(KL+2)
      D(KJ) = 1.
  340 CONTINUE
  350 CONTINUE
C
C  DIVIDE THE STIFFNESS MATRIX INTO 4 SUBMATRICES WHICH CAN THEN BE
C  TRANSFORMED FROM BASIC TO LOCAL COORDINATES THEN REINSERTED IN THE
C  STIFFNESS MATRIX IN INCREASING SIL ORDER
C
      DO 500 IP =1,2
      IPP = IP
      IF (IGP(1) .LT. IGP(2)) GO TO 400
      IPP = 3 - IP
  400 IR = 72 * (IPP-1)
      IAPP = 36* (IPP-1) +1
      DO 490 JI=1,2
      I= JI
      IF (IP .EQ. IPP ) GO TO 405
      I = 3-JI
C
C   PLACE THE APPROPRIATE SUBMATRIX INTO A (6X6) MATRIX
C
  405 IC =  6 *(I-1)
      K  = 0
      DO  410 II=1,6
      KL = IR + 12 *(II-1) +IC
      DO 410  IJ =1,6
      K = K+1
      KK = KL+ IJ
      AKI(K) = AK(KK)
      AKM(K) = AM(KK)
  410 CONTINUE
C
C   TRANSFORM FROM BASIC TO LOCAL  COORDINATES
C
      IF (ICS(IPP) .EQ. 0) GO TO 430
      IF (ISMB(1) .EQ. 0 ) GO TO 425
      CALL GMMATS (D(IAPP),6,6,1, AKI(1),6,6,0,  D(73))
      DO  420 J=1,36
  420 AKI(J)= D(J+72)
  425 IF (ISMB(2) .EQ. 0) GO TO 430
      CALL  GMMATS (D(IAPP),6,6,1, AKM(1),6,6,0, D(73))
      DO 428 J=1,36
  428 AKM(I) = D(J+72)
C
  430 IF (ICS(I) .EQ. 0) GO TO 450
      IAI =  36*(I-1) +1
      IF (ISMB(1) .EQ. 0) GO TO 445
      CALL GMMATS(AKI(1),6,6,0, D(IAI),6,6,0, D(73))
      DO 440 J=1,36
  440 AKI(J) =  D(J+72)
  445 IF (ISMB(2) .EQ. 0) GO TO 450
      CALL GMMATS(AKM(1),6,6,0, D(IAI),6,6,0, D(73))
      DO 448 J=1,36
  448 AKM(J) =D(J+72)
C
C    REINSERT INTO OVERALL STIFFNESS MATRIX ACCORDING TO INCREASING SIL
C
  450 DO 460 II = 1,6
      DO 460 JJ = 1,6
      KI = (II-1)*6 + JJ
      IOUT=  (IP-1)* 72 + (JI-1)*6  + (II-1)*12 + JJ
      KOUT(IOUT) = AKI(KI)
  460 MOUT(IOUT) = AKM(KI)
  490 CONTINUE
  500 CONTINUE
C
C     OUTPUT THE MATRIX BY EMGOUT
C
      DICT(2) = 1
      IF (ISMB(1) .EQ.0) GO TO 550
      CALL EMGOUT(KOUT,KOUT,144,1,DICT,1,IPR)
C
  550 IF (ISMB(2) .EQ.0) GO TO 600
      CALL EMGOUT(MOUT,MOUT,144,1,DICT,2,IPR)
C
  600 RETURN
C
C
C
C  SET FLAG FOR FATAL ERROR WHILE ALLOWING ERROR MESSAGES TO ACCUMULATE
C
 7770 CALL MESAGE (30,37,IDEL)
 7777 NOGO = .TRUE.
      RETURN
 7780 CALL MESAGE(30,26,IDEL)
      GO TO 7777
C
      END

      DOUBLE PRECISION FUNCTION DADOTB( A, B )
      DOUBLE PRECISION A(3), B(3)
C*****
C  DOUBLE PRECISION VERSION
C
C  DOT PRODUCT  A . B
C*****
      DADOTB = A(1)*B(1) + A(2)*B(2) + A(3)*B(3)
      RETURN
      END

      SUBROUTINE ETRBMD
C
C     BASIC BENDING TRIANGLE ELEMENT ROUTINE
C     DOUBLE PRECISION VERSION
C
C     THIS SUBROUTINE CALCULATES THE COUPLED MASS MATRIX FOR THE BASIC
C     BENDING TRIANGLE.
C
C     ECPT LIST FOR BASIC BENDING TRIANGLE             NAME IN
C                                                      THIS
C     ECPT                                             ROUTINE   TYPE
C     ******************************************************************
C     ECPT( 1) = ELEMENT ID                            NECPT(1)  INTEGER
C     ECPT( 2) = GRID POINT A                          NGRID(1)  INTEGER
C     ECPT( 3) = GRID POINT B                          NGRID(2)  INTEGER
C     ECPT( 4) = GRID POINT C                          NGRID(3)  INTEGER
C     ECPT( 5) = THETA = ANGLE OF MATERIAL             ANGLE     REAL
C     ECPT( 6) = MATERIAL ID 1                         MATID1    INTEGER
C     ECPT( 7) = I = MOMENT OF INERTIA                 EYE       REAL
C     ECPT( 8) = MATERIAL ID 2                         MATID2    INTEGER
C     ECPT( 9) = T2                                    T2        REAL
C     ECPT(10) = NON-STRUCTURAL-MASS                   FMU       REAL
C     ECPT(11) = Z1                                    Z11       REAL
C     ECPT(12) = Z2                                    Z22       REAL
C     ECPT(13) = COORD. SYSTEM ID 1                    NECPT(13) INTEGER
C     ECPT(14) = X1                                    X1        REAL
C     ECPT(15) = Y1                                    Y1        REAL
C     ECPT(16) = Z1                                    Z1        REAL
C     ECPT(17) = COORD. SYSTEM ID 2                    NECPT(17) INTEGER
C     ECPT(18) = X2                                    X2        REAL
C     ECPT(19) = Y2                                    Y2        REAL
C     ECPT(20) = Z2                                    Z2        REAL
C     ECPT(21) = COORD. SYSTEM ID 3                    NECPT(21) INTEGER
C     ECPT(22) = X3                                    X3        REAL
C     ECPT(23) = Y3                                    Y3        REAL
C     ECPT(24) = Z3                                    Z3        REAL
C     ECPT(25) = ELEMENT TEMPERATURE                   ELTEMP    REAL
C
      LOGICAL          NOGO
      INTEGER          NECPT(26)
      REAL             ECPT(26)
      DOUBLE PRECISION D(9),G(9),G2X2(4),J2X2(4),S(18),HYQ(6),SIIJ(7,7),
     1                 MBARAA(9),MAR(18),MRR(36),A,PROD9,TEMP9,XSUBB,
     2                 XSUBC,YSUBC,BFACT,E,AOUT,DETERM,TEMP,XCSQ,YCSQ,
     3                 XBSQ,XCYC,YPRODJ,FJ,FJ2,AIJ,BIJ,XPRODI,FI,FIJ,
     4                 SIZERO
      COMMON /EMGPRM/  DUM(15),ISMB(3),IPREC,NOGO
      COMMON /MATIN /  MATID,INFLAG,ELTEMP,STRESS,SINTH,COSTH
      COMMON /MATOUT/  G11,G12,G13,G22,G23,G33,RHO,ALPHA1,ALPHA2,ALP12,
     1                 T SUB 0,G SUB E,SIGTEN,SIGCOM,SIGSHE,
     2                 G2X211,G2X212,G2X222,SPACE(2)
      COMMON /EMGEST/  IELID,NGRID(3),ANGLE,MATID1,EYE,MATID2,T2,FMU,
     1                 Z11,Z22,DUMMY1,X1,Y1,Z1,DUMMY2,X2,Y2,Z2,DUMMY3,
     2                 X3,Y3,Z3,DUMB(76)
      COMMON /EMGTRX/  A(225),PROD9(9),TEMP9(9),XSUBB,XSUBC,YSUBC,
     1                 BFACT,E(18),AOUT(324)
      EQUIVALENCE      (IELID,ECPT(1),NECPT(1)),(J2X2(1),A(14)),
     1                 (D(1),G(1),A(1),SIIJ(1,1)),(G2X2(1),A(10)),
     2                 (HYQ(1),A(50)),(MBARAA(1),A(136)),
     3                 (MAR(1),A(145)),(MRR(1),A(163)),(S(1),A(82))
C
C     SETTING UP G MATRIX
C     BEFORE THIS SUBROUTINE CAN FUNCTION SEVERAL TERMS MUST BE DEFINED
C     SEE ETRBKD.
C
C     POSSIBLE ERROR SOURCE FIX.  MAY REQUIRE LOADER CHANGE.
C     IF (ISMB(1) .EQ. 0)  CALL ETRBKD (1)
C
      INFLAG = 2
      MATID  = MATID1
      CALL MAT (ECPT(1))
C
C     FILL G-MATRIX WITH OUTPUT FROM MAT ROUTINE
C
      G(1) = G11
      G(2) = G12
      G(3) = G13
      G(4) = G12
      G(5) = G22
      G(6) = G23
      G(7) = G13
      G(8) = G23
      G(9) = G33
C
      DO 350 I = 1,9
  350 D(I) = G(I)*DBLE(EYE)
C
C     F1LL  (HBAR) MATRIX STORING AT A(100). . .A(135)
C
      XCSQ = XSUBC**2
      YCSQ = YSUBC**2
      XBSQ = XSUBB**2
      XCYC = XSUBC*YSUBC
C
      DO 380 I = 100,135
  380 A(I) = 0.
C
      A(100) = XBSQ
      A(103) = XBSQ*XSUBB
      A(107) = XSUBB
      A(112) =-2.*XSUBB
      A(115) =-3.*XBSQ
      A(118) = XCSQ
      A(119) = XCYC
      A(120) = YCSQ
      A(121) = XCSQ*XSUBC
      A(122) = YCSQ*XSUBC
      A(123) = YCSQ*YSUBC
      A(125) = XSUBC
      A(126) = YSUBC*2.0D0
      A(128) = XCYC *2.0D0
      A(129) = YCSQ *3.0D0
      A(130) =-2.0D0*XSUBC
      A(131) =-YSUBC
      A(133) =-3.0D0*XCSQ
      A(134) =-YCSQ
C
      IF (T2 .EQ. 0.) GO TO 410
C
C     ALL OF THE FOLLOWING OPERATIONS THROUGH STATEMENT LABEL 110
C     ARE NECESSARY IF T2 IS NON-ZERO.
C
C     GET THE G2X2 MATRIX
C
      MATID  = MATID2
      INFLAG = 3
      CALL MAT (ECPT(1))
      IF (G2X211.EQ.0.0 .AND. G2X212.EQ.0.0 .AND. G2X222.EQ.0.0)
     1    GO TO 410
C
      G2X2(1) = DBLE(G2X211)*DBLE(T2)
      G2X2(2) = DBLE(G2X212)*DBLE(T2)
      G2X2(4) = DBLE(G2X222)*DBLE(T2)
C
      DETERM  = G2X2(1)*G2X2(4) - G2X2(3)*G2X2(2)
      J2X2(1) = G2X2(4)/DETERM
      J2X2(2) =-G2X2(2)/DETERM
      J2X2(3) = J2X2(2)
      J2X2(4) = G2X2(1)/DETERM
C
C     (H  ) IS PARTITIONED INTO A LEFT AND RIGHT PORTION AND ONLY THE
C       YQ  RIGHT PORTION IS COMPUTED AND USED AS A  (2X3). THE LEFT
C           2X3 PORTION IS NULL.  THE RIGHT PORTION WILL BE STORED AT
C           A(50)...A(55) UNTIL NOT NEEDED ANY FURTHER.
C
      TEMP   =  2.*D(2) + 4.*D(9)
      HYQ(1) = -6.*(J2X2(1)*D(1) + J2X2(2)*D(3))
      HYQ(2) = -J2X2(1)*TEMP -  6.*J2X2(2)*D(6)
      HYQ(3) = -6.*(J2X2(1)*D(6) + J2X2(2)*D(5))
      HYQ(4) = -6.*(J2X2(2)*D(1) + J2X2(4)*D(3))
      HYQ(5) = -J2X2(2)*TEMP  - 6.*J2X2(4)*D(6)
      HYQ(6) = -6.*(J2X2(2)*D(6) + J2X2(4)*D(5))
C
C     ADD TO 6 OF THE (HBAR) ELEMENTS THE RESULT OF (H  )(H  )
C                                                    UY   YQ
C     THE PRODUCT IS FORMED DIRECTLY IN THE ADDITION PROCESS BELOW.
C     NO (H  ) MATRIX IS ACTUALLY COMPUTED DIRECTLY.
C          UY
C
C     THE FOLLOWING IS THEN STEP 6 PAGE 8, FMMS-66
C
      DO 400 I = 1,3
      A(I+102) = A(I+102) + XSUBB*HYQ(I)
  400 A(I+120) = A(I+120) + XSUBC*HYQ(I) + YSUBC*HYQ(I+3)
C
C     THIS ENDS ADDED COMPUTATION FOR CASE OF T2 NOT ZERO
C
  410 CONTINUE
C
C     AT THIS POINT INVERT  (H) WHICH IS STORED AT A(100). . .A(135)
C     STORE INVERSE BACK IN A(100). . A(135)
C     NO NEED TO COMPUTE DETERMINANT SINCE IT IS NOT USED SUBSEQUENTLY.
C
      ISING = -1
      CALL INVERD (6,A(100),6, A(136),0,DETERM,ISING,A(142))
C
C     CHECK TO SEE IF H WAS SINGULAR
C
      IF (ISING .EQ. 2) GO TO 600
C
C     ISING = 2 IMPLIES SINGULAR MATRIX THUS ERROR CONDITION.
C
C     CHUNK OUT INTEGRAL VALUES I   USED IN REFERENCED M MATRICES
C                                IJ                    SEE P.9, FMMS-66
C
C     THE CALCULATION FOR  (I  ) ARE AS FOLLOWS
C                            IJ
C                                                           ***
C         A1  = XSUBB * YSUBC**(J+1) / ((J+1)*(J+2))           *
C           0J                                                 *
C                                                              *
C         B   = XSUBC * YSUBC**(J+1) / (J+2)                   *
C           0J                                                 ** J=0,6
C                                                              *
C         A   = A1   + B                                       *
C           0J    0J    0J                                     *
C                                                              *
C         I   = MU * A1                                        *
C           0J         0J                                   ***
C
C                                                           ***
C         A1  = I * XSUBB * A      /(I+J+2)                    *
C           IJ               I-1,J                             *
C                                                              *
C         B   = XSUBC**(I+1) * YSUBC**(J+1) /((I+1)*(I+J+2))   *  I=1,6
C           IJ                                                 ** J=0,6
C                                                              *
C         A   = A1   + B                                       *
C           IJ    IJ    IJ                                     *
C                                                              *
C         I     MU * A1                                        *
C           IJ=        IJ                                      *
C                                                           ***
C      NOTE.. LOOPS FOR PROGRAM BEGIN AT 1 INSTEAD OF 0
C                                      I.E.  I = 1,7
C                                            J = 1,7
C
      DO 440 J = 1,7
      YPRODJ = YSUBC**J
      FJ  = J
      FJ2 = J + 1
      AIJ = XSUBB*YPRODJ/(FJ*FJ2)
      BIJ = XSUBC*YPRODJ/FJ2
      SIIJ(1,J) = FMU*AIJ
      AIJ = AIJ + BIJ
      IF (J .EQ. 7) GO TO 440
      K   = 8 - J
      DO 430 I = 2,K
      XPRODI = XSUBC**I
      FI  = I
      FIJ = I + J
      AIJ = (FI-1.)*XSUBB*AIJ/FIJ
      BIJ = XPRODI*YPRODJ/(FI*FIJ)
      SIIJ(I,J) = FMU*AIJ
  430 AIJ = AIJ + BIJ
C
  440 CONTINUE
      SIZERO = SIIJ(1,1)/3.
C
C     CHUNK IN NUMBERS FOR (M-BAR-AA) 3X3 MATRIX AS PER MS-48, PP. 6-10
C
C                    (M  )         3X6 MATRIX
C                      AR
C
C                    (M  )         6X6 MATRIX
C                      RR
C
C     (M-BAR-AA) MATRIX
C
      MBARAA(1) =  SIIJ(1,1)
      MBARAA(2) =  SIIJ(1,2)
      MBARAA(3) = -SIIJ(2,1)
      MBARAA(4) =  SIIJ(1,2)
      MBARAA(5) =  SIIJ(1,3)
      MBARAA(6) = -SIIJ(2,2)
      MBARAA(7) = -SIIJ(2,1)
      MBARAA(8) = -SIIJ(2,2)
      MBARAA(9) =  SIIJ(3,1)
C
C     (M  ) MATRIX
C       AR
C
      MAR( 1) = SIIJ(3,1)
      MAR( 2) = SIIJ(2,2)
      MAR( 3) = SIIJ(1,3)
      MAR( 4) = SIIJ(4,1)
      MAR( 5) = SIIJ(2,3)
      MAR( 6) = SIIJ(1,4)
      MAR( 7) = SIIJ(3,2)
      MAR( 8) = SIIJ(2,3)
      MAR( 9) = SIIJ(1,4)
      MAR(10) = SIIJ(4,2)
      MAR(11) = SIIJ(2,4)
      MAR(12) = SIIJ(1,5)
      MAR(13) =-SIIJ(4,1)
      MAR(14) =-SIIJ(3,2)
      MAR(15) =-SIIJ(2,3)
      MAR(16) =-SIIJ(5,1)
      MAR(17) =-SIIJ(3,3)
      MAR(18) =-SIIJ(2,4)
C
C     (M  ) MATRIX  A 6X6 SYMMETRIC MATRIX
C       RR
C
      MRR( 1) = SIIJ(5,1)
      MRR( 2) = SIIJ(4,2)
      MRR( 3) = SIIJ(3,3)
      MRR( 4) = SIIJ(6,1)
      MRR( 5) = SIIJ(4,3)
      MRR( 6) = SIIJ(3,4)
      MRR( 7) = MRR(2)
      MRR( 8) = SIIJ(3,3)
      MRR( 9) = SIIJ(2,4)
      MRR(10) = SIIJ(5,2)
      MRR(11) = SIIJ(3,4)
      MRR(12) = SIIJ(2,5)
      MRR(13) = MRR(3)
      MRR(14) = MRR(9)
      MRR(15) = SIIJ(1,5)
      MRR(16) = SIIJ(4,3)
      MRR(17) = SIIJ(2,5)
      MRR(18) = SIIJ(1,6)
      MRR(19) = MRR( 4)
      MRR(20) = MRR(10)
      MRR(21) = MRR(16)
      MRR(22) = SIIJ(7,1)
      MRR(23) = SIIJ(5,3)
      MRR(24) = SIIJ(4,4)
      MRR(25) = MRR( 5)
      MRR(26) = MRR(11)
      MRR(27) = MRR(17)
      MRR(28) = MRR(23)
      MRR(29) = SIIJ(3,5)
      MRR(30) = SIIJ(2,6)
      MRR(31) = MRR( 6)
      MRR(32) = MRR(12)
      MRR(33) = MRR(18)
      MRR(34) = MRR(24)
      MRR(35) = MRR(30)
      MRR(36) = SIIJ(1,7)
C
      IF (T2 .EQ. 0.) GO TO 445
C
      MAR( 4) = MAR( 4) + HYQ(1)*SIIJ(2,1) + HYQ(4)*SIIJ(1,2)
      MAR( 5) = MAR( 5) + HYQ(2)*SIIJ(2,1) + HYQ(5)*SIIJ(1,2)
      MAR( 6) = MAR( 6) + HYQ(3)*SIIJ(2,1) + HYQ(6)*SIIJ(1,2)
      MAR(10) = MAR(10) + HYQ(1)*SIIJ(2,2) + HYQ(4)*SIIJ(1,3)
      MAR(11) = MAR(11) + HYQ(2)*SIIJ(2,2) + HYQ(5)*SIIJ(1,3)
      MAR(12) = MAR(12) + HYQ(3)*SIIJ(2,2) + HYQ(6)*SIIJ(1,3)
      MAR(16) = MAR(16) - HYQ(1)*SIIJ(3,1) - HYQ(4)*SIIJ(2,2)
      MAR(17) = MAR(17) - HYQ(2)*SIIJ(3,1) - HYQ(5)*SIIJ(2,2)
      MAR(18) = MAR(18) - HYQ(3)*SIIJ(3,1) - HYQ(6)*SIIJ(2,2)
      MRR( 4) = MRR( 4) + HYQ(1)*SIIJ(4,1) + HYQ(4)*SIIJ(3,2)
      MRR( 5) = MRR( 5) + HYQ(2)*SIIJ(4,1) + HYQ(5)*SIIJ(3,2)
      MRR( 6) = MRR( 6) + HYQ(3)*SIIJ(4,1) + HYQ(6)*SIIJ(3,2)
      MRR(10) = MRR(10) + HYQ(1)*SIIJ(3,2) + HYQ(4)*SIIJ(2,3)
      MRR(11) = MRR(11) + HYQ(2)*SIIJ(3,2) + HYQ(5)*SIIJ(2,3)
      MRR(12) = MRR(12) + HYQ(3)*SIIJ(3,2) + HYQ(6)*SIIJ(2,3)
      MRR(16) = MRR(16) + HYQ(1)*SIIJ(2,3) + HYQ(4)*SIIJ(1,4)
      MRR(17) = MRR(17) + HYQ(2)*SIIJ(2,3) + HYQ(5)*SIIJ(1,4)
      MRR(18) = MRR(18) + HYQ(3)*SIIJ(2,3) + HYQ(6)*SIIJ(1,4)
      MRR(19) = MRR( 4)
      MRR(20) = MRR(10)
      MRR(21) = MRR(16)
      MRR(22) = MRR(22) + HYQ(1)*(HYQ(1)*SIIJ(3,1) + 2.0D0*(SIIJ(5,1) +
     1          HYQ(4)*SIIJ(2,2))) + HYQ(4)*(2.0D0*SIIJ(4,2) +
     2          HYQ(4)*SIIJ(1,3))
      MRR(23) = MRR(23) + HYQ(2)*SIIJ(5,1) + HYQ(5)*SIIJ(4,2) +
     1          HYQ(1)*(SIIJ(3,3) + HYQ(2)*SIIJ(3,1) + HYQ(5)*SIIJ(2,2))
     2        + HYQ(4)*(SIIJ(2,4) + HYQ(2)*SIIJ(2,2) + HYQ(5)*SIIJ(1,3))
      MRR(24) = MRR(24) + HYQ(3)*SIIJ(5,1) + HYQ(6)*SIIJ(4,2) +
     1          HYQ(1)*(SIIJ(2,4) + HYQ(3)*SIIJ(3,1) + HYQ(6)*SIIJ(2,2))
     2        + HYQ(4)*(SIIJ(1,5) + HYQ(3)*SIIJ(2,2) + HYQ(6)*SIIJ(1,3))
      MRR(25) = MRR( 5)
      MRR(26) = MRR(11)
      MRR(27) = MRR(17)
      MRR(28) = MRR(23)
      MRR(29) = MRR(29) + HYQ(2)*(HYQ(2)*SIIJ(3,1) + 2.0D0*(SIIJ(3,3) +
     1          HYQ(5)*SIIJ(2,2))) + HYQ(5)*(2.0D0*SIIJ(2,4) +
     2          HYQ(5)*SIIJ(1,3))
      MRR(30) = MRR(30) + HYQ(3)*SIIJ(3,3) + HYQ(6)*SIIJ(2,4) +
     1          HYQ(2)*(SIIJ(2,4) + HYQ(3)*SIIJ(3,1) + HYQ(6)*SIIJ(2,2))
     2        + HYQ(5)*(SIIJ(1,5) + HYQ(3)*SIIJ(2,2) + HYQ(6)*SIIJ(1,3))
      MRR(31) = MRR( 6)
      MRR(32) = MRR(12)
      MRR(33) = MRR(18)
      MRR(34) = MRR(24)
      MRR(35) = MRR(30)
      MRR(36) = MRR(36) + HYQ(3)*(HYQ(3)*SIIJ(3,1) + 2.0D0*(SIIJ(2,4) +
     1          HYQ(6)*SIIJ(2,2))) + HYQ(6)*(2.0D0*SIIJ(1,5) +
     2          HYQ(6)*SIIJ(1,3))
C
C     FILL S-MATRIX EQUIVALENCED TO A(82)  (S IS  6X3 )
C
  445 S( 1) = 1.
      S( 2) = 0.
      S( 3) =-XSUBB
      S( 4) = 0.
      S( 5) = 1.
      S( 6) = 0.
      S( 7) = 0.
      S( 8) = 0.
      S( 9) = 1.
      S(10) = 1.
      S(11) = YSUBC
      S(12) =-XSUBC
      S(13) = 0.
      S(14) = 1.
      S(15) = 0.
      S(16) = 0.
      S(17) = 0.
      S(18) = 1.
C
C     CAN NOW COMPUTE 9 (3X3) MASS MATRICES (FMMS-66, PAGES 10-11)
C
C                -1 T           -1
C     ( M ) = ( H  )  ( M  ) ( H  )
C                        RR
C
C              PARTITION (M)
C                                           ///       ///
C                                           /     *     /
C                                           / MBB * MBC /
C                                           /     *     /
C                                ( M )  =   / ********* /
C                                           /     *     /
C                                           / MCB * MCC /
C                                           /     *     /
C                                           ///       ///
C                                                       4 (3X3) MATRICES
C                        -1
C     ( M  ) = ( M  ) ( H  )
C        AI       AR
C
C              PARTITION (M  )              ///                 ///
C                          AI               /          *          /
C                               ( M  )  =   / M-BAR-AB * M-BAR-AC /
C                                  AI       /          *          /
C                                           ///                 ///
C                                                       2 (3X3) MATRICES
C                               T            T
C     ( MAB )  = (M-BAR-AB) - (S ) (MBB) - (S ) (MCB)
C                               B            C
C
C                               T            T
C     ( MAC )  = (M-BAR-AC) - (S ) (MBC) - (S ) (MCC)
C                               B            C
C
C                               T     T      T      T
C     ( MAA )  = (M-BAR-AA) - (S ) (M  ) - (S ) (MAC )
C                               B    AB      C
C
C                           - (M-BAR-AB) (S ) - (M-BAR-AC) (S )
C                                          B                 C
C
C                    T
C     ( MBA )  = (MAB )
C
C                    T
C     ( MCA )  = (MAC )
C
C     CHOOSE APPROPRIATE BLOCK OF A-ARRAY FOR STORAGE
C
C     (3X3)    STORED IN      (3X3)     STORED IN     (3X3)    STORED IN
C     (MAA)   A( 1... 9)      (MAB)   A(10)...8)      (MAC)   A(19...27)
C     (MBA)   A(28...36)      (MBB)   A(37)...45)     (MBC)   A(46...54)
C     (MCA)   A(55...63)      (MCB)   A(64...72)      (MCC)   A(73...81)
C
C       -1
C     (H  ) IS STORED AT A(100...135)
C     (S)   EQUIVALENCED A( 81... 99)
C     WORKING STORAGE IS A(181...216)
C     (M-BAR-AB) STORED UNTIL NO LONGER NEEDED IN A(163...171)
C     (M-BAR-AC) STORED UNTIL NO LONGER NEEDED IN A(172...180)
C
C                     -1 T          -1
C     COMPUTE (M) = (H  )  ((M  ) (H  ))
C                       RR
C
      CALL GMMATD (MRR(1), 6,6,0, A(100), 6,6,0, A(37))
      CALL GMMATD (A(100), 6,6,1, A(37),  6,6,0, A(1))
C
C     CREATE PARTITION OF 4 (3X3)
C
      DO 470 I = 1,3
      A(I+36) = A(I   )
      A(I+39) = A(I+ 6)
      A(I+42) = A(I+12)
C
      A(I+45) = A(I+ 3)
      A(I+48) = A(I+ 9)
      A(I+51) = A(I+15)
C
      A(I+63) = A(I+18)
      A(I+66) = A(I+24)
      A(I+69) = A(I+30)
C
      A(I+72) = A(I+21)
      A(I+75) = A(I+27)
  470 A(I+78) = A(I+33)
C
C     COMPUTE             -1
C         (M  ) = (M  ) (H  )  AND  PARTITION INTO 2 (3X3)  (M-BAR-AB)
C           AI      AR                                  AND (M-BAR-AC)
C
      CALL GMMATD (MAR(1), 3,6,0, A(100), 6,6,0, A(181))
      DO 480 I = 1,3
      A(I+162) = A(I+180)
      A(I+165) = A(I+186)
      A(I+168) = A(I+192)
C
      A(I+171) = A(I+183)
      A(I+174) = A(I+189)
  480 A(I+177) = A(I+195)
C
C     COMPUTE (MAB)
C
      CALL GMMATD (S(1), 3,3,1, A(37), 3,3,0,  A(181))
      CALL GMMATD (S(10), 3,3,1, A(64), 3,3,0, A(190))
      DO 490 I = 1,9
  490 A(I+9) = A(I+162) - A(I+180) - A(I+189)
C
C     COMPUTE (MAC)
C
      CALL GMMATD (S(1) , 3,3,1, A(46), 3,3,0, A(181))
      CALL GMMATD (S(10), 3,3,1, A(73), 3,3,0, A(190))
      DO 500 I = 1,9
  500 A(I+18) = A(I+171) - A(I+180) - A(I+189)
C
C     COMPUTE (MAA)
C
      CALL GMMATD (S(1) , 3,3,1, A(10), 3,3,1, A(181))
      CALL GMMATD (S(10), 3,3,1, A(19), 3,3,1, A(190))
      CALL GMMATD (A(163),3,3,0, S(1) , 3,3,0, A(199))
      CALL GMMATD (A(172),3,3,0, S(10), 3,3,0, A(208))
      DO 510 I = 1,9
  510 A(I) = MBARAA(I) - A(I+180) - A(I+189) - A(I+198) - A(I+207)
C
C     COMPUTE (MBA) AND (MCA)
C
      DO 520 I = 1,3
      NPT = 3*I + 7
      A(I+27) = A(NPT  )
      A(I+30) = A(NPT+1)
      A(I+33) = A(NPT+2)
C
      A(I+54) = A(NPT+ 9)
      A(I+57) = A(NPT+10)
  520 A(I+60) = A(NPT+11)
C
      DO 550 I = 1,136
  550 AOUT(I) = A(I)
      RETURN
C
C     ERROR EXITS
C
  600 CALL MESAGE (30,33,ECPT(1))
      NOGO = .TRUE.
      RETURN
      END

      SUBROUTINE DRWCHR (X,Y,XYD,CHR,NN,OPT)
C
C     (X,Y)  = STARTING OR ENDING POINT OF THE LINE TO BE TYPED (ALWAYS
C              LEFT-TO-RIGHT OR TOP-TO-BOTTOM)
C     XYD    = (+/-)1 IF X = STARTING OR ENDING POINT OF THE LINE
C            = (+/-)2 IF Y = STARTING OR ENDING POINT OF THE LINE
C     CHR    = CHARACTERS TO BE DRAWN
C     NN     = NUMBER OF CHARACTERS
C     OPT    = -1 TO INITIATE  THE TYPING MODE
C            = +1 TO TERMINATE THE TYPING MODE
C            =  0 TO TYPE A LINE
C     CSCALE = SCALE FOR CHARACTER SIZE (REAL)
C
      INTEGER         XYD,CHR(1),OPT,CHRIND,XYCHR,D
      REAL            SAVE(2,2),XY(2,2),XYC(2,2),CSCALE
      COMMON /PLTDAT/ SKPLT(2),REG(2,2),XYMAX(2),EDGE(11),CSCALE,
     1                SKPA(3),CNTCHR(2)
      COMMON /CHRDRW/ LSTIND,CHRIND(60),XYCHR(2,1)
      DATA    LSTCHR/ 48 /
C
      IF (OPT .EQ. 0) GO TO 100
      CALL LINE (0,0,0,0,0,OPT)
      GO TO 200
C
  100 N = NN
      IF (N .LE. 0) N = 1
      D = MAX0(IABS(XYD),1)
      S = CNTCHR(D)
      IF (XYD.EQ.-1 .OR. XYD.EQ.2) S = -S
      XYC(1,1) = 3.0*CSCALE
      XYC(2,1) = 3.0*CSCALE
      XY(1,1)  = X - XYC(1,1)
      XY(2,1)  = Y - XYC(2,1)
      XY(1,2)  = XY(1,1)
      XY(2,2)  = XY(2,1)
      DO 110 I = 1,2
      SAVE(I,1)= REG(I,1)
      REG(I,1) = AMAX1(-EDGE(I),REG(I,1)-XYC(I,1))
      SAVE(I,2)= REG(I,2)
      REG(I,2) = AMIN1(XYMAX(I)+EDGE(I),REG(I,2)+XYC(I,1))
  110 CONTINUE
C
C     TYPE THE LINE.
C
      DO 125 J = 1,N
      XY(D,2)  = XY(D,1) + S*FLOAT(J-1)
C
C     MAKE SURE EACH CHARACTER IS A VALID CHARACTER.
C
      I = J
      IF (XYD .LT. 0) I = N - J + 1
      K = CHR(I)
      IF (NN.NE.0 .AND. K.GE.LSTCHR) GO TO 125
      IF (K .GT. LSTIND) GO TO 125
C
C     DRAW THE CHARACTER.
C
  120 N1 = CHRIND(K)
      IF (N1 .GT. 0) GO TO 121
      K  = -N1
      GO TO 120
  121 N2 = CHRIND(K+1)
      IF (N2 .GT. 0) GO TO 122
      K  = K + 1
      GO TO 121
C
  122 N2 = N2 - 1
      DO 124 L = N1,N2
      DO 123 I = 1,2
      XYC(I,1) = XYC(I,2)
      XYC(I,2) = XY(I,2) + CSCALE*FLOAT(IABS(XYCHR(I,L)))
  123 CONTINUE
      IF (L.EQ.N1 .OR. XYCHR(1,L).LT.0 .OR. XYCHR(2,L).LT.0) GO TO 124
      CALL LINE (XYC(1,1),XYC(2,1),XYC(1,2),XYC(2,2),1,0)
  124 CONTINUE
  125 CONTINUE
C
      DO 190 I = 1,2
      REG(I,1) = SAVE(I,1)
      REG(I,2) = SAVE(I,2)
  190 CONTINUE
C
  200 RETURN
      END

      SUBROUTINE TRIDI1 (D,O,C,A,B,AA)
C
C     MODIFIED GIVENS REAL SYMMETRIC TRIDIAGONALIZATION
C     THIS ROUTINE IS CALLED ONLY BY VALVEC
C
      INTEGER          SAVEMR,ENTRY,RSTRT,ROW,XENTRY,FILCOR,ROT,ROW1,
     1                 ROW2,ROWP1,ROWP2,SYSBUF,MCB(7),COUNT
      REAL             D(1),O(1),C(1),AA(1),B(1)
      DIMENSION        VVCOM(150),A(2)
      CHARACTER        UFM*23
      COMMON /XMSSG /  UFM
      COMMON /GIVN  /  TITLE(1),MO,MD,MR1,M1,M2,M3,M4,SAVEMR,T10,ENTRY,
     1                 T12(5),RSTRT,ROW,T19,XENTRY
      COMMON /SYSTEM/  SYSBUF,NOUT,IDUMMY(52),IPREC
      COMMON /PACKX /  IT1,IT2,II,JJ,INCR
      COMMON /UNPAKX/  IT3,III,JJJ,INCR1
      EQUIVALENCE      (VVCOM(1),TITLE(1)), (N,VVCOM(101))
      DATA    COUNT ,  MAX,MCB / 0, 10, 7*0/
C
C
C     DEFINITION OF VARIABLES
C
C     D       = LOCATION OF DIAGIONAL
C     O       = LOCATION OF OFF DIAGONAL
C     C       = LOCATION OF COSINES
C     A       = REST OF OPEN CORE
C     B       = O**2
C     SAVEMR
C     RSTRT
C     ROW
C     XENTRY
C     FILCOR
C     ROT
C     ROW1
C     ROW2
C     MO      = RESTART DATA - SINES AND COSINES
C     MD      = INPUT  MATRIX
C     MR1     = RESTART TAPE
C     M1      = SCRATCH TAPE
C     M2
C     M3
C     M4
C     MR2
C     MIDIN
C     COUNT   = NUMBER OF ROWS ROTATED
C     MAX     = NUMBER OF ROWS TO ROTATE BEFORE CHECKPOINTING
C
C
C     INITIALIZATION
C
      NZ   = KORSZ(A)
      IBUF1= NZ - SYSBUF + 1
      IBUF2= IBUF1 - SYSBUF
      NZ   = NZ - 2*SYSBUF
      NZZ  = NZ/IPREC
      NZSQ = SQRT(FLOAT((NZZ-1)*2))
      IM1  = 1
      NM1  = N - 1
      NM2  = N - 2
      M3   = 305
      MSS  = MR1
      MS1  = M1
      MS2  = M2
      MS3  = M3
      MS4  = M4
C
C     INITIALIZE  TRANSFORMATION ROUTINES
C
      MIDIN= N
      MR   = MR1
C
C     START AT THE BEGINNING
C
      ROW = 0
C
C     OPEN MD
C
      CALL GOPEN (MD,A(IBUF1),0)
      CALL GOPEN (MR,A(IBUF2),1)
C
C     SET UP FOR UNPACK
C
      IT3  = 1
      III  = 1
      JJJ  = N
      INCR1= 1
      CALL UNPACK (*102,MD,D)
C
C     COPY REST OF MD ONTO MR
C
  103 CONTINUE
      IT1 = 1
      IT2 = 1
      INCR= 1
      K   = N - 1
      DO 105 I = 1,K
      III = 0
      CALL UNPACK (*107,MD,A)
      II = III
      JJ = JJJ
  106 CALL PACK (A,MR,MCB)
      GO TO 105
  107 II = 1
      JJ = 1
      A(1) = 0.0
      A(2) = 0.0
      GO TO 106
  105 CONTINUE
      III = 1
      JJJ = N
      II  = 1
      JJ  = N
      GO TO 104
  102 DO 101 I = 1,N
      D(I) = 0.0
  101 CONTINUE
      GO TO 103
C
C     END OF MATRIX MD
C
  104 CALL WRITE (MR,ROW,1,1)
C
C     ATTACH DIAGONALS
C
      CALL PACK  (D,MR,MCB)
      CALL CLOSE (MD,1)
      CALL CLOSE (MR,1)
      MS = MR
      CALL GOPEN (MS,A(IBUF1),0)
C
C     TRIDIAGONALIZATION PROCEDURE UNTIL THE MATRIX FITS IN CORE
C
  200 ROW  = ROW + 1
      ROWP1= ROW + 1
      ROWP2= ROW + 2
      IT3  = 1
      III  = ROWP1
      CALL UNPACK (*201,MS,O(ROWP1))
      GO TO 203
  201 DO 202 I = ROWP1,N
      O(I) = 0.0
  202 CONTINUE
C
C     FIND SINES AND COSINES
C
  203 CALL SINC0S1 (ROW,ROT, D,O,C)
      CALL GOPEN (MO,A(IBUF2),IM1)
      IM1 = 3
      II  = ROWP2
      IT1 = 1
      IT2 = 1
      CALL PACK (D(ROWP2),MO,MCB)
      CALL CLOSE (MO,2)
C
C     WILL THE REST OF MATRIX FIT IN CORE
C
      IF ((N-ROWP1)*(N-ROWP1+1)/2+1 .LE. NZZ) GO TO 225
C
C         (N-ROWP1)*(N-ROWP1  )     < (NZZ-1)*2
C                   (N-ROWP1  )     < SQRT((NZZ-1)*2) (=NZSQ)
C                    N              < NZSQ + ROWP1
C                    N-NZSQ         < ROWP1
C                    N-NZSQ         = NUMBER OF ROTAIONS NEEDED
C
C     NO-- MUST REST OF MATRIX BE ROTATED
C
      IF (ROT .EQ. 0) GO TO 215
      COUNT = COUNT + 1
      IF (COUNT .EQ. MAX) COUNT = 0
C
C     ROTATE THE REST OF THE MATRIX
C
      MIDOUT = ROWP1 + (N-ROWP1+3)/4
      ROW1   = ROWP2
      CALL GOPEN (MS3,A(IBUF2),1)
C
C     HERE THRU 217 WILL BE VERY TIME COMSUMING. THE ROTATION IS ONE
C     ROW AT A TIME. COMPUTE HOW MANY ROTATIONS NEEDED. IF TOO MANY,
C     ISSUE A USER FATAL MESSAGE AND GET OUT
C
      I = N - NZSQ
      IF (I .LE. 25) GO TO 205
      J = (N*N - NZSQ*NZSQ)*IPREC
      WRITE  (NOUT,204) UFM,N,N,I,J
  204 FORMAT (A23,' FROM GIVENS EIGENSOLVER - EXCESSIVE CPU TIME IS ',
     1       'NEEDED FOR TRIDIAGONALIZE THE DYNAMIC', /5X,
     2       'MATRIX, WHICH IS',I6,' BY',I6, 15X,1H(,I6,' LOOPS)', /5X,
     3       'RERUN JOB WITH',I8,' ADDITIONAL CORE WORDS, OR USE FEER,',
     4       ' OR OTHER METHOD')
      CALL MESAGE (-61,0,0)
C
C     FILL CORE WITH AS MUCH OF MATRIX AS POSSIBLE--UP TO ROW -ROW2-
C
  205 ROW2 = FILCOR(MSS,MS2,IPREC,ROW1,MIDIN,N,A,NZ,A(IBUF1))
C
C     ROTATE ROWS ROW1 TO ROW2
C
      CALL ROTATE1 (AA,ROW,ROW1,ROW2,O,D,C)
C
C     EMPTY THE ROTATED ROWS ONTO MS3 AND MS4
C
      CALL EMPCOR (MS3,MS4,IPREC,IPREC,ROW1,MIDOUT,ROW2,N,A,A(IBUF2))
      ROW1 = ROW2 + 1
      IF (ROW2 .LT. N) GO TO 205
C
C     SWITCH TAPES
C
      MS  = MS1
      MS1 = MS3
      MS3 = MS
      MS  = MS2
      MS2 = MS4
      MS4 = MS
      MSS = MS1
      MIDIN = MIDOUT
  215 DO 216 I = ROWP1,N
      D(I) =  O(I)
  216 CONTINUE
      MS = MSS
      IF (ROW .GT. MIDIN) GO TO 217
      IF (ROT .EQ.     0) GO TO 200
  218 CALL GOPEN (MS,A(IBUF1),0)
      GO TO 200
  217 MS = MS2
      GO TO 218
C
C     TRIDIAGONALIZATION PROCEDURE WHEN MATRIX FITS IN CORE
C
C
C     FILL CORE WITH THE REST OF THE MATRIX
C
  225 ROW2 = FILCOR(MSS,MS2,IPREC,ROWP2,MIDIN,N,A,NZ,A(IBUF1))
      NA = 1
      CALL GOPEN (MO,A(IBUF2),3)
      GO TO 235
  230 ROW   = ROW + 1
      ROWP1 = ROW + 1
      ROWP2 = ROW + 2
  232 DO 233 I = ROWP1,N
      O(I) = AA(NA)
      NA   = NA + 1
  233 CONTINUE
  234 CALL SINC0S1 (ROW,ROT, D,O,C)
C
C     WRITE SINES ON MO
C
      II  = ROWP2
      IT1 = 1
      IT2 = 1
      CALL PACK (D(ROWP2),MO,MCB)
  235 IF (ROT .EQ. 0) GO TO 236
      ROW1  = ROWP2
      CALL ROTATE1 (AA(NA),ROW,ROW1,ROW2,O,D,C)
  236 DO 237 I = ROWP1,N
      D(I) = O(I)
  237 CONTINUE
      IF (ROW .NE. NM2) GO TO 230
C
C     ALL DONE.
C
      D(N) = AA(NA)
      O(N-1) = O(N)
      O(N  ) = 0.0
      CALL CLOSE (MO,3)
      DO 261 I = 1,N
      C(I) = D(I)
      B(I) = O(I)**2
  261 CONTINUE
      XENTRY = -ENTRY
      RSTRT  = 0
      SAVEMR = 0
      RETURN
      END

      SUBROUTINE CMMCON (NCE)
C
C     THIS SUBROUTINE DETERMINES WHETHER MORE THAN ONE CONNECTION ENTRY
C     HAS BEEN SPECIFIED FOR A GIVEN IP NUMBER.
C
      LOGICAL         MCON
      INTEGER         SCCONN,BUF1,Z,SCORE,SCMCON,BUF3,AAA(2)
      COMMON /CMB001/ SCR1,SCR2,SCBDAT,SCSFIL,SCCONN,SCMCON
      COMMON /CMB002/ BUF1,BUF2,BUF3,JUNK(2),SCORE,LCORE,INPT,OUTT
      COMMON /CMB003/ JUNK2(38),NPSUB,JUNK3(2),MCON
      COMMON /ZZZZZZ/ Z(1)
      DATA    AAA   / 4HCMMC,4HON   /
C
C     READ CONNECTION ENTRIES INTO OPEN CORE
C
      NWD   = 2 + NPSUB
      MCON  = .TRUE.
      IFILE = SCCONN
      CALL OPEN (*700,SCCONN,Z(BUF1),0)
      J   = 0
      NCE = 0
   90 CALL READ (*200,*100,SCCONN,Z(SCORE+J),10,1,NNN)
  100 NCE = NCE + 1
      Z(SCORE+J) = NCE
      J = J + NWD
      GO TO 90
  200 CALL CLOSE (SCCONN,1)
C
C     SWEEP THROUGH CONNECTION ENTRIES AND DETERMINE THOSE THAT
C     REPRESENT MULTIPLE CONNECTIONS.
C
      MCON  = .FALSE.
      NCEM1 = NCE - 1
C
      DO 500 K = 1,NCEM1
      DO 400 I = 1,NPSUB
      IST = SCORE + I + (K-1)*NWD + 1
      IF (Z(IST) .EQ. 0) GO TO 400
      DO 300 J = 1,NCE
      IF (K .EQ. J) GO TO 300
      ISUB = SCORE + 1 + I + (J-1)*NWD
      IF (Z(IST) .NE. Z(ISUB)) GO TO 300
      ILOC = I + 1
      Z(IST -ILOC) = -1*IABS(Z(IST -ILOC))
      Z(ISUB-ILOC) = -1*IABS(Z(ISUB-ILOC))
      MCON = .TRUE.
  300 CONTINUE
  400 CONTINUE
  500 CONTINUE
C
      IF (.NOT.MCON) RETURN
C
C     GENERATE OUTPUT FILE OF CONNECTION ENTRY IDS
C
      IFILE = SCMCON
      CALL OPEN (*700,SCMCON,Z(BUF1),1)
      DO 600 I = 1,NCE
      LOC = SCORE + (I-1)*NWD
      IF (Z(LOC) .LT. 0) CALL WRITE (SCMCON,IABS(Z(LOC)),1,0)
  600 CONTINUE
      CALL WRITE (SCMCON,0,0,1)
      CALL CLOSE (SCMCON,1)
      RETURN
C
  700 CALL MESAGE (-1,IFILE,AAA)
      RETURN
      END

      SUBROUTINE QPARAM
C
C     PARAM PERFORMS THE FOLLOWING OPERATIONS ON PARAMETERS--
C      1. OUT = IN1 .AND. IN2
C      2. OUT = IN1 .OR . IN2
C      3. OUT = IN1   +   IN2
C      4. OUT = IN1   -   IN2
C      5. OUT = IN1   *   IN2
C      6. OUT = IN1   /   IN2
C      7. OUT = .NOT. IN1
C      8. OUT = IN1  .IMP. IN2
C      9. STORE VALUE OF OUT IN VPS.
C     10. OUT = VALUE OF PRECISION CELL FROM /SYSTEM/
C     11. OUT = CURRENT TIME
C     12. OUT = TIME TO GO
C     13. OUT = SYSTEM(IN1) = IN2
C     14. OUT = SYSTEM(25) WITH BITS IN1 THRU IN2 TURNED ON OR OFF.
C     15. OUT = SYSTEM CELL IN1.
C     16. SAVE AND RESTORES SENSE SWITCHES
C     17. SETS SENSE SWITCHES
C     18. SAVE AND RESTORES SYSTEM CELLS
C     19. OUT = -1 IF IN1 .EQ. IN2, OUT = +1 OTHERWISE.
C     20. OUT = -1 IF IN1 .GT. IN2, OUT = +1 OTHERWISE.
C     21. OUT = -1 IF IN1 .LT. IN2, OUT = +1 OTHERWISE.
C     22. OUT = -1 IF IN1 .LE. IN2, OUT = +1 OTHERWISE.
C     23. OUT = -1 IF IN1 .GE. IN2, OUT = +1 OTHERWISE.
C     24. OUT = -1 IF IN1 .NE. IN2, OUT = +1 OTHERWISE.
C     25. UNDEFINED.
C     26. UNDEFINED.
C     27. UNDEFINED.
C     28. UNDEFINED.
C     29. UNDEFINED.
C     30. UNDEFINED.
C
      EXTERNAL        LSHIFT,ORF,ANDF
      INTEGER         SWITCH,OFF,ORF,XORF,OP,OPCODE,OUT,OUTTAP,ANDF,VPS,
     1                OSCAR
      DIMENSION       OPCODE(30),SWITCH(2)
      CHARACTER       UFM*23,UWM*25
      COMMON /XMSSG / UFM,UWM
      COMMON /BLANK / OP(2),OUT,IN1,IN2
      COMMON /SYSTEM/ KSYSTM(80)
      COMMON /OSCENT/ OSCAR(16)
      COMMON /XVPS  / VPS(1)
      EQUIVALENCE     (KSYSTM( 2),OUTTAP),(KSYSTM(23),LSYSTM),
     1                (KSYSTM(55),IPREC ),(KSYSTM(79),SWITCH(1))
      DATA    OPCODE/ 4HAND ,4HOR  ,4HADD ,4HSUB ,4HMPY
     1              , 4HDIV ,4HNOT ,4HIMPL,4HNOP ,4HPREC
     2              , 4HKLOC,4HTMTO,4HSYST,4HDIAG,4HSYSR
     3              , 4HSSSR,4HSSST,4HSTSR,4HEQ  ,4HGT
     4              , 4HLT  ,4HLE  ,4HGE  ,4HNE  ,4H****
     5              , 4H****,4H****,4H****,4H****,4H****
     Z              /
      DATA    OFF   / 4HOFF /
C
C     BRANCH ON OPERATION CODE.
C
      DO 5 I = 1,30
      IF (OP(1) .EQ. OPCODE(I)) GO TO (
     1     10, 20, 30, 40, 50, 60, 70, 80, 90,100,
     2    110,120,130,140,150,160,170,180,190,200,
     3    210,220,230,240,250,260,270,280,290,300), I
    5 CONTINUE
      GO TO 990
C
C     .AND.
C
   10 OUT = -1
      IF (IN1.GE.0 .OR. IN2.GE.0) OUT = +1
      GO TO 900
C
C     .OR.
C
   20 OUT = +1
      IF (IN1.LT.0 .OR . IN2.LT.0) OUT = -1
      GO TO 900
C
C     ADD
C
   30 OUT = IN1 + IN2
      GO TO 900
C
C     SUB
C
   40 OUT = IN1 - IN2
      GO TO 900
C
C     MPY
C
   50 OUT = IN1*IN2
      GO TO 900
C
C     DIV
C
   60 OUT = IN1/IN2
      GO TO 900
C
C     NOT
C
   70 OUT = -IN1
      GO TO 900
C
C     IMPLY
C
   80 OUT = +1
      IF (IN1.GE.0 .OR. IN2.LT.0) OUT = -1
      GO TO 900
C
C     NOP
C
   90 GO TO 900
C
C     PROVIDE PRECISION FROM /SYSTEM/.
C
  100 OUT = IPREC
      GO TO 900
C
C     PROVIDE CURRENT TIME
C
  110 CALL KLOCK (OUT)
      GO TO 900
C
C     PROVIDE TIME-TO-GO
C
  120 CALL TMTOGO (OUT)
      GO TO 900
C
C     MODIFY SYSTEM CELL.
C
  130 OUT = IN2
      KSYSTM(IN1) = IN2
      IF (IN1.LE.0 .OR. IN1.GT.LSYSTM) WRITE (OUTTAP,135) UWM,IN1
  135 FORMAT (A25,' 2317, PARAM HAS STORED OUTSIDE DEFINED RANGE OF ',
     1       'COMMON BLOCK /SYSTEM/.', /32X,'INDEX VALUE =',I20)
      GO TO 900
C
C     TURN DIAG SWITCH ON OR OFF.
C
  140 IF (IN2 .LT. IN1) IN2 = IN1
      DO 145 I = IN1,IN2
      IF (I .GT. 31) GO TO 142
      OUT = LSHIFT(1,I-1)
      SWITCH(1) = ORF(SWITCH(1),OUT)
      IF (OP(2) .EQ. OFF) SWITCH(1) = SWITCH(1) - OUT
      GO TO 145
  142 OUT = I - 31
      OUT = LSHIFT(1,OUT-1)
      SWITCH(2) = ORF(SWITCH(2),OUT)
      IF (OP(2) .EQ. OFF) SWITCH(2) = SWITCH(2) - OUT
      OUT = OUT + 31
  145 CONTINUE
      OUT = SWITCH(1)
      IF (I .GT. 31) OUT = SWITCH(2)
      GO TO 900
C
C     RETURN VALUE OF IN1-TH WORD OF /SYSTEM/.
C
  150 OUT = KSYSTM(IN1)
      GO TO 900
C
C     SAVE OR RESTORE SSWITCH WORD
C
  160 IF (IN1 .LT.  0) GO TO 165
      IF (IN1 .GT. 31) GO TO 161
      OUT = SWITCH(1)
      GO TO 900
  161 CONTINUE
      OUT = SWITCH(2)
      GO TO 900
  165 IF (IABS(IN1) .GT. 31) GO TO 166
      SWITCH(1) = OUT
      GO TO 900
  166 SWITCH(2) = OUT
      GO TO 900
C
C     TURN SSWITCH ON OR OFF
C
  170 IF (OUT .EQ. 0) GO TO 900
      IF (OUT .GT. 0) GO TO 175
      IF (IABS(OUT) .GT. 31) GO TO 171
      MASK = LSHIFT(1,IABS(OUT)-1)
      SWITCH(1) = XORF(MASK,ORF(MASK,SWITCH(1)))
      GO TO 900
  171 CONTINUE
      OUT  = OUT + 31
      MASK = LSHIFT(1,IABS(OUT)-1)
      SWITCH(2) = XORF(MASK,ORF(MASK,SWITCH(2)))
      OUT  = OUT - 31
      GO TO 900
  175 CONTINUE
      IF (OUT .GT. 31) GO TO 176
      SWITCH(1) = ORF(LSHIFT(1,OUT-1),SWITCH(1))
      GO TO 900
  176 CONTINUE
      OUT = OUT - 31
      SWITCH(2) = ORF(LSHIFT(1,OUT-1),SWITCH(2))
      OUT = OUT + 31
      GO TO 900
C
C     SAVE OR RESTORE A CELL OF SYSTEM
C
C     SAVE
C
  180 CONTINUE
      IF (IN1 .LT. 0) GO TO 185
      OUT = KSYSTM(IN1)
      GO TO 900
C
C     RESTORE
C
  185 IN1 = IABS(IN1)
      KSYSTM(IN1) = OUT
      GO TO 900
C
C     ARITHMETIC RELATIONAL OPERATORS.
C
  190 IF (IN1-IN2) 191,192,191
  191 OUT = +1
      GO TO 900
  192 OUT = -1
      GO TO 900
  200 IF (IN1-IN2) 191,191,192
  210 IF (IN1-IN2) 192,191,191
  220 IF (IN1-IN2) 192,192,191
  230 IF (IN1-IN2) 191,192,192
  240 IF (IN1-IN2) 192,191,192
C
C     UNDEFINED.
C
  250 GO TO 900
C
C     UNDEFINED.
C
  260 GO TO 900
C
C     UNDEFINED.
C
  270 GO TO 900
C
C     UNDEFINED.
C
  280 GO TO 900
C
C     UNDEFINED.
C
  290 GO TO 900
C
C     UNDEFINED.
C
  300 GO TO 900
C
C     SAVE OUT IN THE VPS.
C
  900 I = ANDF(OSCAR(16),65535)
      VPS(I) = OUT
      RETURN
C
C     OPERATION CODE NOT DEFINED-- WRITE MESSAGE.
C
  990 WRITE  (OUTTAP,998) UFM,OP(1),OP(2)
  998 FORMAT (A23,' 2024, OPERATION CODE ',2A4,' NOT DEFINED FOR ',
     1       'MODULE PARAM.')
      CALL MESAGE (-61,0,0)
      RETURN
      END

      SUBROUTINE MESAGE (NO,PARM,NAME)
C
C     MESAGE IS USED TO QUEUE NON-FATAL MESSAGES DURING THE EXECUTION
C     OF A MODULE, AND EXITS IF MESSAGE IS FATAL
C
C     REVISED 1/92 BY G.CHAN/UNISYS.
C     IF MESSAGE IS FATAL AND DIAG 1 IS ON -
C
C     IBM, CDC AND UNIVAC - PRINT THE MESSAGE(S), GIVE A CORE DUMP AND
C     CALL PEXIT
C
C     VAX OR UNIX (MACHINE TYPE .GE. 5) - IF LAST MESSAGE IS NOT INSUFF.
C     CORE OR INSUFFICIENT TIME, AND FATAL ERROR IS NOT IN LINK 1, PRINT
C     ONLY THE MESSAGE NO(S). AND GIVE AN ERROR TRACEBACK. NO CORE DUMP.
C     TO MAKE SURE THAT THE CURRENT MODULE (WHICH CALLS FATAL MESSAGE)
C     IS UTILL IN CORE, THE MESSAGE PRINTOUT MODULE CAN NOT BE CALLED,
C     AND THEREFORE THE TEXT(S) OF THE MESSAGE(S) CAN NOT BE PRINTED.
C
      INTEGER         PARM,NAME(2)
      COMMON /SYSTEM/ IBUF,NOUT,DUM(19),LINKNO
      COMMON /MACHIN/ MACH
      COMMON /MSGX  / N,M,MSG(4,1)
      DATA    LINK1 / 4HNS01 /
C
C     N        =  CURRENT NUMBER OF MESSAGES STORED
C     M        =  MAXIMUM NUMBER POSSIBLE
C     MSG(4,I) =  STORAGE SPACE FOR THE MESSAGE PARAMETERS
C
      N = N + 1
      IF (N .LE. M) GO TO 10
      N = M
      IF (NO .GT. 0) GO TO 120
C
   10 MSG(1,N) = NO
      MSG(2,N) = PARM
      MSG(3,N) = NAME(1)
      MSG(4,N) = NAME(2)
      IF (NO .GT. 0) GO TO 120
C
C     MESSAGE IS FATAL, TERMINATE RUN
C
      CALL SSWTCH (1,J)
      IF (J    .EQ. 0) GO TO 110
      IF (MACH .EQ. 5) GO TO 20
C
C     ALL NON-VAX MACHINES
C
      GO TO 110
C
C     VAX, UNIX (MACHINE TYPE 5 AND HIGHER)
C
   20 IF (LINKNO .EQ. LINK1) GO TO 110
      I  = IABS(MSG(1,N))
      IF (I.EQ.8  .OR. I.EQ.119 .OR. I.EQ.45 .OR. I.EQ.50) GO TO 110
C             INSUFF. CORE             INSUFFICIENT TIME
C
      IF (I .NE. 30) GO TO 30
      J  = MSG(2,N)
C
C     INSUFFECIENT CORE
      IF (J.EQ.142 .OR. J.EQ.289 .OR. J.EQ.296 .OR. J.EQ.253 .OR.
     1    J.EQ.365) GO TO 110
C
C     INSUFFECIENT TIME
      IF (J.EQ.234 .OR. J.EQ.228) GO TO 110
C
   30 WRITE (NOUT,40) N
   40 FORMAT ('0*** DUE TO SYSTEM ERROR-TRACEBACK, THE TEXT(S) OF THE ',
     1        'FOLLOWING',I3,' MSG NO(S). CAN NOT BE PRINTED')
      DO 90 K = 1,N
      I = MSG(1,K)
      IF (IABS(I) .EQ. 30) GO TO 50
      J = 3000 + IABS(I)
      GO TO 60
   50 I = MSG(2,K)
      J = 2000 + IABS(I)
   60 WRITE  (NOUT,70) I,J
   70 FORMAT (5X,'ERROR',I4,' (or ',I5,1H))
      IF (I.NE.30 .AND. MSG(2,K).GT.100 .AND. MSG(2,K).LT.400)
     1    WRITE (NOUT,80) MSG(2,K)
   80 FORMAT (1H+,30X,'GINO UNIT=',I4)
   90 CONTINUE
      WRITE  (NOUT,100)
  100 FORMAT (/5X,'(SEE MESSAGES IN USER MANUAL SECTIONS 6.4 AND 6.5,',
     1        ' AND IGNORE ANY COMPUTER FATAL MESSAGE HEREAFTER ',
     2        'OR IN THE LOG FILE)')
C
C     FORCE A SYSTEM FATAL ERROR FOR TRACEBACK
C
      CALL ERRTRC ('MESAGE  ',105)
C
  110 CALL MSGWRT
      CALL PEXIT
  120 RETURN
      END

      SUBROUTINE TETRA (TEMPS,PG,IOPT)
C
C     ELEMENT THERMAL LOAD GENERATOR FOR THE TETRAHEDRON SOLID ELEMENT
C
C     LOOKING DOWN ON THIS ELEMENT, GRIDS 1,2,3 ARE THE BASE AND MUST BE
C     LABELED COUNTERCLOCKWISE. GRID 4 MUST BE ABOVE THE PLANE FORMED BY
C     GRIDS 1,2,3 AND CLOSEST TO THIS OBSERVER.
C
C     ECPT FOR THE TETRAHEDRON SOLID ELEMENT
C
C     ECPT( 1) = ELEMENT ID
C     ECPT( 4) = SIL GRID POINT 3
C     ECPT( 5) = SIL GRID POINT 4
C     ECPT( 2) = MATERIAL ID (MAT1 MATERIAL TYPE)
C     ECPT( 3) = SIL GRID POINT 1
C     ECPT( 4) = SIL GRID POINT 2
C     ECPT( 5) = SIL GRID POINT 3
C     ECPT( 6) = SIL GRID POINT 4
C     ECPT( 7) = COORD SYS ID GRID PT 1
C     ECPT( 8) = X1
C     ECPT( 9) = Y1
C     ECPT(10) = Z1
C     ECPT(11) = COORD SYS ID GRID PT 2
C     ECPT(12) = X2
C     ECPT(13) = Y2
C     ECPT(14) = Z2
C     ECPT(15) = COORD SYS ID GRID PT 3
C     ECPT(16) = X3
C     ECPT(17) = Y3
C     ECPT(18) = Z3
C     ECPT(19) = COORD SYS ID GRID PT 4
C     ECPT(20) = X4
C     ECPT(21) = Y4
C     ECPT(22) = Z4
C     ECPT(23) = ELEMENT TEMPERATURE
C
      INTEGER         NECPT(2) ,OUT
      REAL            TEMPS(4) ,PG(6)   ,P(6)    ,C(72)    ,G(36)    ,
     1                H(16)    ,CTG(18) ,NU      ,ALFA(6)  ,TEMP(12)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /SYSTEM/ SYSBUF   ,OUT
      COMMON /TRIMEX/ ECPT(23)
      COMMON /MATIN / MATID    ,INFLAG  ,ELTEMP
      COMMON /MATOUT/ E        ,GG      ,NU      ,RHO       ,ALPHA   ,
     1                TSUB0    ,GSUBE   ,SIGT    ,SIGC      ,SIGS
      EQUIVALENCE     (NECPT(1),ECPT(1))
C
C     FILL THE 4 X 4 H MATRIX.
C
      H( 1) = 1.0
      H( 2) = ECPT( 8)
      H( 3) = ECPT( 9)
      H( 4) = ECPT(10)
      H( 5) = 1.0
      H( 6) = ECPT(12)
      H( 7) = ECPT(13)
      H( 8) = ECPT(14)
      H( 9) = 1.0
      H(10) = ECPT(16)
      H(11) = ECPT(17)
      H(12) = ECPT(18)
      H(13) = 1.0
      H(14) = ECPT(20)
      H(15) = ECPT(21)
      H(16) = ECPT(22)
C
C     INVERT H AND GET THE DETERMINANT
C
      ISING = 0
C
      CALL INVERS (4,H(1),4,DUM,0,HDETER,ISING,TEMP(1))
C
C     IF THE MATRIX IS SINGULAR TETRAHEDRON IS BAD
C
      HDETER = ABS(HDETER)
      IF (ISING .NE. 2) GO TO 200
      WRITE  (OUT,150) UFM,NECPT(1)
  150 FORMAT (A23,' 4002, MODULE SSG1 DETECTS BAD OR REVERSE GEOMETRY ',
     1       'FOR ELEMENT ID =',I9)
      GO TO 900
C
C     GET THE MATERIAL DATA AND FILL THE 6X6 G MATERIAL STRESS-STRAIN
C     MATRIX.
C
  200 INFLAG = 1
      MATID  = NECPT(2)
      ELTEMP = ECPT(23)
      CALL MAT (NECPT(1))
      DO 210 I = 1,36
  210 G(I)  = 0.0
      TEMP1 = (1.0+NU)*(1.0-2.0*NU)
      IF (TEMP1 .NE. 0.0) GO TO 240
      WRITE  (OUT,230) UFM,MATID,ECPT(1)
  230 FORMAT (A23,' 4003, AN ILLEGAL VALUE OF -NU- HAS BEEN SPECIFIED ',
     1       'UNDER MATERIAL ID =',I9,' FOR ELEMENT ID =',I9)
      GO TO 900
  240 G( 1) = E*(1.0-NU)/TEMP1
      G( 8) = G(1)
      G(15) = G(1)
      G( 2) = E*NU/TEMP1
      G( 3) = G(2)
      G( 7) = G(2)
      G( 9) = G(2)
      G(13) = G(2)
      G(14) = G(2)
      G(22) = GG
      G(29) = GG
      G(36) = GG
C
C     FILL 4 C-MATRICES. (6X3) EACH.
C
      DO 400 I = 1,72
  400 C(I) = 0.0
      DO 500 I = 1,4
      J = 18*I - 18
      C(J+ 1) = H(I+ 4)
      C(J+ 5) = H(I+ 8)
      C(J+ 9) = H(I+12)
      C(J+11) = H(I+12)
      C(J+12) = H(I+ 8)
      C(J+13) = H(I+12)
      C(J+15) = H(I+ 4)
      C(J+16) = H(I+ 8)
      C(J+17) = H(I+ 4)
  500 CONTINUE
C
C     DIVIDE DETERMINANT BY 6.0, AND BY AN ADDITIONAL 2.0 IF A SUB-TETRA
C     FOR THE HEXA-10 ELEMENT.
C
      IF (IOPT) 602,601,602
  601 HDETER = HDETER/6.0
      GO TO 610
  602 HDETER = HDETER/12.0
C
C     INTRODUCE TBAR AND ALPHA
C
  610 HDETER = HDETER*(0.25*(TEMPS(1)+TEMPS(2)+TEMPS(3)+TEMPS(4))-TSUB0)
     1         *ALPHA
C
C     FILL ALPHA VECTOR
C
      ALFA(1) = HDETER
      ALFA(2) = HDETER
      ALFA(3) = HDETER
      ALFA(4) = 0.0
      ALFA(5) = 0.0
      ALFA(6) = 0.0
C
C     LOOP FOR THE FOUR GRID POINTS
C
      DO 800 I = 1,4
      CALL GMMATS (C(18*I-17),6,3,1, G(1),6,6,0, CTG(1))
      CALL GMMATS (CTG(1),3,6,0, ALFA(1),6,1,0, P(1))
C
C     TRANSFORM TO GLOBAL
C
      P(4) = 0.0
      P(5) = 0.0
      P(6) = 0.0
      K    = 4*I + 3
      IF (NECPT(K) .NE. 0) CALL BASGLB (P(1),P(1),NECPT(K+1),NECPT(K))
C
C     INSERT LOAD VECTOR FOR GRID POINT
C
      L = NECPT(I+2) - 1
      DO 790 J = 1,3
      L = L + 1
      PG(L) = PG(L) + P(J)
  790 CONTINUE
  800 CONTINUE
      RETURN
C
  900 CALL MESAGE (-61,0,0)
      RETURN
      END

      SUBROUTINE FTUBE
C
C     THIS IS THE FLUID TUBE ELEMENT IN HEAT TRANSFER.
C     IT COMPUTES AND OUTPUTS THE CONDUCTIVITY AND/OR CAPACITY MATRICES
C     OF THE ELEMENT.
C
C     - SINGLE AND DOUBLE PRECISION VERSION -
C
C     EST ENTRY FOR -FTUBE- ELEMENT.
C     ==============================
C
C     EST( 1) = ELEMENT ID
C     EST( 2) = SIL-A
C     EST( 3) = SIL-B
C     EST( 4) = HEAT CAPACITY/UNIT VOLUME = RHO C
C     EST( 5) = VOLUME FLOW RATE = VDOT         P
C     EST( 6) = DIAMETER AT A
C     EST( 7) = DIAMETER AT B = DIAMETER AT A IF NOT DEFINED.
C     EST( 8) = CSID-A  NOT USED
C     EST( 9) = XA
C     EST(10) = YA
C     EST(11) = ZA
C     EST(12) = CSID-B  NOT USED
C     EST(13) = XB
C     EST(14) = YB
C     EST(15) = ZB
C     EST(16) = AVG TEMP OF ELEMENT.  NOT USED.
C
C
      LOGICAL          HEAT     ,ERROR
      INTEGER          DICT(7)  ,ESTID    ,IEST(1)
      REAL             RK(4)    ,ID1      ,ID2      ,DICT5
      DOUBLE PRECISION K(4)     ,LENGTH
      CHARACTER        UFM*23   ,UWM*25   ,UIM*29
      COMMON /XMSSG /  UFM      ,UWM      ,UIM
      COMMON /SYSTEM/  SYSBUF   ,IOUTPT
      COMMON /EMGPRM/  DUM15(15),KMB(3)   ,IPREC    ,ERROR    ,HEAT
      COMMON /EMGDIC/  DMMM(4)  ,ESTID
      COMMON /EMGEST/  EST(16)
      COMMON /CONDAS/  PI
      EQUIVALENCE      (IEST(1) , EST(1)) ,(RK(1)   , K(1))   ,
     1                 (DICT(5) , DICT5 )
C
      IF (.NOT.HEAT) GO TO 240
      DICT(1) = ESTID
      DICT(2) = 1
      DICT(3) = 2
      DICT(4) = 1
      DICT5   = 0.0
      IF (KMB(1) .EQ. 0) GO TO 170
C
C     CONDUCTIVITY
C
      RHOCP = EST(4)
      VDOT  = EST(5)
C
C     STORE CONDUCTIVITY BY COLUMNS
C
      K(1) = DBLE(RHOCP*VDOT)
C
      K(2) = -K(1)
      K(3) = 0.0D0
      K(4) = 0.0D0
C
C     OUTPUT VIA EMGOUT THE FULL MATRIX IN GLOBAL, UNSYMETRIC
C
      IFIL = 1
      ISZE = 4
      ASSIGN 170 TO IRTN
      IF (IPREC .EQ. 2) GO TO 160
  150 RK(1) = SNGL(K(1))
      RK(2) = SNGL(K(2))
      RK(3) = SNGL(K(3))
      RK(4) = SNGL(K(4))
  160 CALL EMGOUT (RK(1),K(1),ISZE,1,DICT,IFIL,IPREC)
      GO TO IRTN, (170,240)
C
C     CAPACITY MATRIX
C
  170 IF (KMB(3) .EQ. 0) GO TO 240
      RHOCP = EST( 4)
      VDOT  = EST( 5)
      ID1   = EST( 6)
      IF (EST(7)) 190,180,190
  180 ID2 = ID1
      GO TO 200
  190 ID2   = EST( 7)
  200 XA    = EST( 9)
      YA    = EST(10)
      ZA    = EST(11)
      XB    = EST(13)
      YB    = EST(14)
      ZB    = EST(15)
      LENGTH = DBLE((XB-XA))**2 + DBLE((YB-YA))**2 + DBLE((ZB-ZA))**2
      IF (LENGTH .GT. 0.0D0) GO TO 220
      LENGTH = DSQRT(LENGTH)
      WRITE  (IOUTPT,210) UIM,IEST(1)
  210 FORMAT (A29,' FROM ELEMENT FTUBE -', /5X,'ELEMENT WITH ID =',I9,
     1       ' HAS A ZERO LENGTH.')
      ERROR = .TRUE.
C
C     FILL AND OUTPUT CAPACITY MATRIX BY COLUMNS IN GLOBAL, SYMMETRIC.
C
  220 K(1) = (DBLE(RHOCP*PI*(ID1+ID2)))**2*LENGTH/32.0D0
      K(2) = 0.0D0
      K(3) = 0.0D0
      K(4) = K(1)
      DICT(2) = 2
      IFIL = 3
      ISZE = 2
      ASSIGN 240 TO IRTN
      IF (IPREC-1) 240,150,160
C
  240 RETURN
      END

      SUBROUTINE PSTAMG (INPUT,AJJL,SKJ)
C
C     DRIVER FOR PISTON THEORY
C
      INTEGER         SYSBUF,AJJL,SKJ,NAME(2),IZ(1)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /ZZZZZZ/ Z(1)
      COMMON /SYSTEM/ SYSBUF,IOUT
      COMMON /PACKX / ITI,ITO,II,NN,INCR
      COMMON /AMGMN / MCB(7),NROW,ND,NE,REFC,FMACH,RFK,TSKJ(7),ISK,NSK
      COMMON /PSTONC/ NNJ,NMACH,NTHRY,NTHICK,NALPHA,NXIS,NTAUS,NSTRIP,
     1                SECLAM
      EQUIVALENCE     (Z(1),IZ(1))
      DATA    NHACPT, NHCOMM,NAME /4HACPT,4HCOMM,4HPSTA,4HMG  /
C
      ICORE = KORSZ(IZ) - 4*SYSBUF
C
C     BRING IN DATA AND ALLOCATE CORE
C
      CALL FREAD (INPUT,NNJ,9,0)
      IDEL = 1
      IB   = IDEL + NSTRIP
      ICA  = IB  + NSTRIP
      IPALP= ICA + NSTRIP
C
C     READ FIXED ARRAYS
C
      NW = 3*NSTRIP
      CALL FREAD (INPUT,Z,NW,0)
C
C     READ ALPHA ARRAY AND STUFF  AT END (INTEGRALS OR TAUS)
C
      IEND = 0
      DO 20 I = 1,NMACH
      CALL FREAD (INPUT,RM,1,0)
      IF (RM .NE. FMACH) GO TO 10
      IEND = 1
      CALL FREAD (INPUT,Z(IPALP),NALPHA,0)
      GO TO 20
   10 CALL FREAD (INPUT,Z,-NALPHA,0)
   20 CONTINUE
      IF (IEND .EQ. 0) GO TO 50
      IPT = IPALP + NALPHA
      CALL READ (*30,*30,INPUT,Z(IPT),ICORE,1,N)
   30 NT = IPT + N
      CALL BUG (NHACPT,30,Z,NT)
      CALL BUG (NHCOMM,30,NNJ,9)
C
C     OUTPUT SKJ
C
      RM  = 1.0
      ITI = 1
      ITO = 3
      II  = ISK
      NSK = NSK + 1
      NN  = NSK
      DO 40 I = 1,NNJ
      CALL PACK (RM,SKJ,TSKJ)
      II  = II + 1
      IF (I .EQ. NNJ) GO TO 40
      NN  = NN + 1
   40 CONTINUE
      ISK = II
      NSK = NN
      ITI = 3
      ITO = 3
      CALL PSTA (Z(IDEL),Z(IB),Z(ICA),Z(IPALP),Z(IPT),AJJL)
      NROW = NROW + NNJ
      GO TO 70
C
C     ERROR MESSAGE
C
   50 WRITE  (IOUT,60) UFM,FMACH
   60 FORMAT (A23,' 2428, MACH NUMBER ',F10.5,' WAS NOT FOUND IN ',
     1       'PISTON THEORY ALPHA ARRAY.')
      CALL MESAGE (-61,0,NAME)
C
   70 RETURN
      END

      SUBROUTINE SUBCC
C
C     THIS ROUTINE WAS ORIGINALLY CALLED SUBD
C
      COMPLEX         GUSAMP,SBKDE1,SBKDE2,
     1                F4,F4S,AM4,F5S,F6S,AM4TST,SUM3,SUM4,AM5TT,AM6,
     2                SUMSV1,SUMSV2,SVKL1,SVKL2,F5,F5T,AM5,AM5T,
     3                AI,A,B,BSYCON,ALP,F1,AM1,ALN,BLKAPM,BKDEL3,F1S,C1,
     4                C2P,C2N,
     5                C2,AMTEST,FT2,BLAM1,FT3,AM2,SUM1,SUM2,F2,BLAM2,
     6                FT2T,C1T,FT3T,F2P,AM2P,SUM1T,SUM2T,
     7                C1P,C1N,BKDEL1,BKDEL2,BLKAP1,ARG,ARG2,FT3TST,
     8                BC,BC2,BC3,BC4,BC5,CA1,CA2,CA3,CA4,
     9                CLIFT,CMOMT,PRES1,PRES2,PRES3,PRES4,QRES4,FQ7,
     O                FQA,FQB,SS,T1,T2,T3,T4,CONST,CONST2,CONST3,CONST4,
     1                CONST5,CONST6,C1A,C2A,CEXP1,CEXP2,CEXP1A,CEXP2A
      DIMENSION       PRES1(21),PRES2(21),PRES3(21),PRES4(21),QRES4(21),
     1                SBKDE1(201),SBKDE2(201),
     2                SUMSV1(201),SUMSV2(201),SVKL1(201),SVKL2(201),
     3                XLSV1(21),XLSV2(21),XLSV3(21),XLSV4(21)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /SYSTEM/ SYSBUF,IBBOUT
      COMMON /BLK1  / SCRK,SPS,SNS,DSTR,AI,PI,DEL,SIGMA,BETA,RES
      COMMON /BLK2  / BSYCON
      COMMON /BLK3  / SBKDE1,SBKDE2,F4,F4S,AM4,F5S,F6S,AM4TST,SUM3,SUM4,
     1                AM5TT,AM6,SUMSV1,SUMSV2,SVKL1,SVKL2,F5,F5T,AM5,
     2                AM5T,A,B,ALP,F1,AM1,ALN,BLKAPM,BKDEL3,F1S,C1,C2P,
     3                C2N,C2,AMTEST,FT2,BLAM1,FT3,AM2,SUM1,SUM2,F2,
     4                BLAM2,FT2T,C1T,FT3T,F2P,AM2P,SUM1T,SUM2T,C1P,C1N,
     5                BKDEL1,BKDEL2,BLKAP1,ARG,ARG2,FT3TST,BC,BC2,BC3,
     6                BC4,BC5,CA1,CA2,CA3,CA4,CLIFT,CMOMT,PRES1,PRES2,
     7                PRES3,PRES4,QRES4,FQA,FQB,FQ7
      COMMON /BLK4  / I,R,Y,A1,B1,C4,C5,GL,I6,I7,JL,NL,RI,RT,R5,SN,SP,
     1                XL,Y1,AMU,GAM,IDX,INX,NL2,RL1,RL2,RQ1,RQ2,XL1,
     2                ALP1,ALP2,GAMN,GAMP,INER,IOUT,REDF,STAG,STEP,
     3                AMACH,BETNN,BETNP,BKAP1,XLSV1,XLSV2,XLSV3,XLSV4,
     4                ALPAMP,AMOAXS,GUSAMP,DISAMP,PITAXS,PITCOR
C
      AM6 = 0.0
      F5  = 0.0
      AM5 = 0.0
      S1  = SPS + SNS
      S2  = SIGMA - SPS*DEL
      S3  = SPS/(DSTR**2)
      S4  = SNS/DSTR
      S5  = DEL*SNS + SIGMA
      SS  = CEXP(-AI*SIGMA)
      DO 150 IOUT = 1,200
      IF (IOUT .GT. I7) GO TO 240
      R5  = IOUT - 1
      RQ1 = SQRT((R5*PI/SNS)**2+SCRK**2)
      RQ2 =-RQ1
      C4  = (RQ1*S1+S2)/(2.0*PI)
      C5  = (RQ2*S1+S2)/(2.0*PI)
      BC2 = BC/(2.0*SVKL1(IOUT))*CEXP(-AI*(-S2)*(SPS+3.0*SNS)/
     1      (2.0*S1))/(2.0*PI*AI)
      BC3 = BC2*SVKL1(IOUT)/SVKL2(IOUT)
      BC4 = BC/(2.0*SVKL1(IOUT))*CEXP(AI*(-S2)*(SNS-SPS)/
     1      (2.0*S1))/(2.0*PI*AI)
      BC5 = BC4*SVKL1(IOUT)/SVKL2(IOUT)
      F5T = 0.0
      AM5T= 0.0
      AM5TT = 0.0
      DO 10 JL = 1,NL
      QRES4(JL) = 0.0
   10 CONTINUE
      DO 100 INER = 1,200
      R    = INER - 1
      GAMP = 2.0*PI*R - S2
      GAMN =-2.0*PI*R - S2
      C1P  = (GAMP/DSTR) - SCRK
      C2P  = (GAMP/DSTR) + SCRK
      ALP  = GAMP*S3 - S4*CSQRT(C1P)*CSQRT(C2P)
      BKDEL3 = SBKDE1(INER)
      IF (INER .LE. I6) GO TO 20
      CALL AKAPM (ALP,BKDEL3)
      SBKDE1(INER) = BKDEL3
   20 CONTINUE
      T1   = ALP*SPS-GAMP
      T2   = ALP*DSTR**2-GAMP*SPS
      SUM1 = SUMSV1(IOUT)*CEXP(AI*T1)*BKDEL3*T1/
     1       (T2*SVKL1(IOUT)*(ALP-RQ1))
      SUM3 = SUMSV2(IOUT)*CEXP(AI*T1)*BKDEL3*T1/
     1       (T2*SVKL2(IOUT)*(ALP-RQ2))
      IF (INER .EQ. 1) GO TO 40
      C1N  = (GAMN/DSTR) - SCRK
      C2N  = (GAMN/DSTR) + SCRK
      ALN  = GAMN*S3 - S4*CSQRT(C1N)*CSQRT(C2N)
      BKDEL3 = SBKDE2(INER)
      IF (INER .LE. I6) GO TO 30
      CALL AKAPM (ALN,BKDEL3)
      SBKDE2(INER) = BKDEL3
   30 CONTINUE
      T1   = ALN*SPS - GAMN
      T2   = ALN*DSTR**2 - GAMN*SPS
      SUM2 = SUMSV1(IOUT)*CEXP(AI*T1)*BKDEL3*T1/
     1       (T2*SVKL1(IOUT)*(ALN-RQ1))
      SUM4 = SUMSV2(IOUT)*CEXP(AI*T1)*BKDEL3*T1/
     1       (T2*SVKL2(IOUT)*(ALN-RQ2))
   40 CONTINUE
      IF (INER .EQ. 1) SUM2 = 0.0
      IF (INER .EQ. 1) SUM4 = 0.0
      C1P = CEXP(-AI*(ALP-DEL)*SPS)
      C2P = CEXP(-AI*(ALP-DEL)*SNS)
      C1N = CEXP(-AI*(ALN-DEL)*SPS)
      C2N = CEXP(-AI*(ALN-DEL)*SNS)
      F5T = F5T + (SUM1+SUM3)*AI*SS/(ALP-DEL)*(C1P-C2P) +
     1      (SUM2+SUM4)*SS*AI/(ALN-DEL)*(C1N-C2N)
      AM5T= AM5T + (SUM1+SUM3)*SS*(AI*SPS*C1P/(ALP-DEL) - AI*SNS*C2P/
     1      (ALP-DEL) + 1.0/((ALP-DEL)**2)*(C1P-C2P) + AI*(2.0-SPS)/
     2      (ALP-DEL)*(C1P-C2P)) + (SUM2+SUM4)*SS*(AI*SPS*C1N/(ALN-DEL)
     3    - AI*SNS*C2N/(ALN-DEL) + 1.0/((ALN-DEL)**2)*(C1N-C2N) +
     4      AI*(2.0-SPS)/(ALN-DEL)*(C1N-C2N))
      TEMP  = (SPS-SNS)/RL1
      CONST = (SUM1+SUM3)*SS
      CONST2= (SUM2+SUM4)*SS
      C1A   =-AI*(ALP-DEL)
      C2A   =-AI*(ALN-DEL)
      CEXP1 = CEXP(C1A*SNS)
      CEXP2 = CEXP(C2A*SNS)
      CEXP1A= CEXP(C1A*TEMP)
      CEXP2A= CEXP(C2A*TEMP)
      DO 50 JL = 1,NL
      QRES4(JL) = QRES4(JL) - (CONST*CEXP1+CONST2*CEXP2)
      CEXP1 = CEXP1*CEXP1A
      CEXP2 = CEXP2*CEXP2A
   50 CONTINUE
      BETNP = ( 2.0*R*PI-S5)/S1
      BETNN = (-2.0*R*PI-S5)/S1
      C1P   = CEXP(-2.0*PI*R*AI*SNS/S1)
      C2P   = CEXP(-2.0*PI*R*AI*SPS/S1)
      C1N   = CEXP(2.0*PI*R*AI*SNS/S1)
      C2N   = CEXP(2.0*PI*R*AI*SPS/S1)
      T1    = CEXP(-AI*BETNP*SPS)
      T2    = CEXP(-AI*BETNP*SNS)
      T3    = CEXP(-AI*BETNN*SPS)
      T4    = CEXP(-AI*BETNN*SNS)
      CA1   = AI*SS/BETNP*(T1-T2)
      CA2   = AI*SS/BETNN*(T3-T4)
      CA3   = SS*(AI*SPS/BETNP*T1 - AI*SNS*T2/BETNP+(T1-T2)/
     1        BETNP**2 + (2.0-SPS)*AI/BETNP*(T1-T2))
      CA4   = SS*(AI*SPS*T3/BETNN - AI*SNS*T4/BETNN+(T3-T4)/
     1        BETNN**2 + (2.0-SPS)*AI/BETNN*(T3-T4))
      IF (INER .GT. 1) GO TO 70
      F5T   = F5T - SUMSV1(IOUT)*(BC2*C1P-BC4*C2P)/(R-C4)*CA1 -
     1        SUMSV2(IOUT)*(BC3*C1P-BC5*C2P)/(R-C5)*CA1
      AM5T  = AM5T - SUMSV1(IOUT)*(BC2*C1P-BC4*C2P)/(R-C4)*CA3 -
     1        SUMSV2(IOUT)*(BC3*C1P-BC5*C2P)/(R-C5)*CA3
      TEMP  = (SPS-SNS)/RL1
      CONST = SS*SUMSV1(IOUT)*(BC2*C1P-BC4*C2P)/(R-C4)
      CONST2= SS*SUMSV2(IOUT)*(BC3*C1P-BC5*C2P)/(R-C5)
      C1A   =-AI*BETNP
      CEXP1 = CEXP(C1A*SNS)
      CEXP1A= CEXP(C1A*TEMP)
      DO 60 JL = 1,NL
      QRES4(JL) = QRES4(JL)+CONST*CEXP1+CONST2*CEXP1
      CEXP1 = CEXP1*CEXP1A
   60 CONTINUE
      GO TO 90
   70 CONTINUE
      F5T = F5T - SUMSV1(IOUT)*((BC2*C1P-BC4*C2P)/(R-C4)*CA1 -
     1      (BC2*C1N-BC4*C2N)/(R+C4)*CA2) - SUMSV2(IOUT)*
     2      ((BC3*C1P-BC5*C2P)/(R-C5)*CA1-(BC3*C1N-BC5*C2N)/(R+C5)*CA2)
      AM5T= AM5T - SUMSV1(IOUT)*((BC2*C1P-BC4*C2P)/(R-C4)*CA3-(BC2*C1N-
     1      BC4*C2N)/(R+C4)*CA4)-SUMSV2(IOUT)*((BC3*C1P-BC5*C2P)/
     2      (R-C5)*CA3-(BC3*C1N-BC5*C2N)/(R+C5)*CA4)
      TEMP   = (SPS-SNS)/RL1
      CONST  = (BC2*C1P-BC4*C2P)/(R-C4)
      CONST2 = (BC2*C1N-BC4*C2N)/(R+C4)
      CONST3 = (BC3*C1P-BC5*C2P)/(R-C5)
      CONST4 = (BC3*C1N-BC5*C2N)/(R+C5)
      CONST5 = SS*SUMSV1(IOUT)
      CONST6 = SS*SUMSV2(IOUT)
      C1A    =-AI*BETNP
      C2A    =-AI*BETNN
      CEXP1  = CEXP(C1A*SNS)
      CEXP2  = CEXP(C2A*SNS)
      CEXP1A = CEXP(C1A*TEMP)
      CEXP2A = CEXP(C2A*TEMP)
      DO 80 JL = 1,NL
      QRES4(JL) = QRES4(JL) + CONST5*(CONST*CEXP1-CONST2*CEXP2) +
     1            CONST6*(CONST3*CEXP1-CONST4*CEXP2)
      CEXP1  = CEXP1*CEXP1A
      CEXP2  = CEXP2*CEXP2A
   80 CONTINUE
   90 CONTINUE
      IF (CABS((AM5TT-AM5T)/AM5T) .LT. 0.001) GO TO 110
      AM5TT  = AM5T
  100 CONTINUE
      GO TO 200
  110 CONTINUE
      IF (INER  .LE.  I6) GO TO 120
      I6 = INER
  120 CONTINUE
      F5  = F5  + F5T
      AM5 = AM5 + AM5T
      DO 130 JL = 1,NL
      PRES4(JL) = PRES4(JL) + QRES4(JL)
  130 CONTINUE
      ALP1 = (2.0*PI*C4-DEL*SNS-SIGMA)/S1
      ALP2 = (2.0*PI*C5-DEL*SNS-SIGMA)/S1
      T1   = 1.0 - CEXP(-2.0*PI*AI*C4)
      T2   = 1.0 - CEXP(-2.0*PI*AI*C5)
      C1P  = CEXP(-2.0*PI*AI*C4*SNS/S1)/(T1)
      C2P  = CEXP( 2.0*PI*AI*C4*SNS/S1)/(T1)
      C1N  = CEXP(-2.0*PI*AI*C5*SNS/S1)/(T2)
      C2N  = CEXP( 2.0*PI*AI*C5*SNS/S1)/(T2)
      T1   = CEXP(-AI*SPS*ALP1)
      T2   = CEXP(-AI*SNS*ALP1)
      T3   = CEXP(-AI*SPS*ALP2)
      T4   = CEXP(-AI*SNS*ALP2)
      CA1  = AI*SS/ALP1*(T1-T2)
      CA2  = AI*SS/ALP2*(T3-T4)
      CA3  = SS*(AI*SPS*T1/ALP1 - AI*SNS*T2/ALP1 + (T1-T2)/
     1       ALP1**2 + (2.0-SPS)*AI/ALP1*(T1-T2))
      CA4  = SS*(AI*SPS*T3/ALP2 - AI*SNS*T4/ALP2 + (T3-T4)/
     1       ALP2**2 + (2.0-SPS)*AI/ALP2*(T3-T4))
      F5   = F5 - 2.0*PI*AI*SUMSV1(IOUT)*(BC2*C1P-BC4*C2P)*CA1 - 2.0*PI*
     1       AI*SUMSV2(IOUT)*(BC3*C1N-BC5*C2N)*CA2
      AM5  = AM5 - 2.0*PI*AI*SUMSV1(IOUT)*(BC2*C1P-BC4*C2P)*CA3 - 2.0*
     1       PI*AI*SUMSV2(IOUT)*(BC3*C1N-BC5*C2N)*CA4
      TEMP = (SPS-SNS)/RL1
      CONST  = SS*2.0*PI*AI
      CONST2 = CONST*SUMSV1(IOUT)*(BC2*C1P-BC4*C2P)
      CONST3 = CONST*SUMSV2(IOUT)*(BC3*C1N-BC5*C2N)
      C1A    =-AI*ALP1
      C2A    =-AI*ALP2
      CEXP1  = CEXP(C1A*SNS)
      CEXP2  = CEXP(C2A*SNS)
      CEXP1A = CEXP(C1A*TEMP)
      CEXP2A = CEXP(C2A*TEMP)
      DO 140 JL = 1,NL
      PRES4(JL) = PRES4(JL)+CONST2*CEXP1+CONST3*CEXP2
      CEXP1  = CEXP1*CEXP1A
      CEXP2  = CEXP2*CEXP2A
  140 CONTINUE
      IF (CABS((AM5-AM6)/AM5) .LT. 0.0009) GO TO 160
      AM6 = AM5
  150 CONTINUE
      GO TO 220
  160 CONTINUE
      CLIFT = F1 + F2 - F2P + F4 + F5
      CMOMT = AM1 + AM2 - AM2P + AM4 + AM5 - AMOAXS*CLIFT
      GO TO 270
C
  200 WRITE  (IBBOUT,210) UFM
  210 FORMAT (A23,' - AMG MODULE -SUBROUTINE SUBCC.  AM5T LOOP DID NOT',
     1       ' CONVERGE.')
      GO TO 260
  220 WRITE  (IBBOUT,230) UFM
  230 FORMAT (A23,' - AMG MODULE -SUBROUTINE SUBCC.  AM5 LOOP DID NOT',
     1       ' CONVERGE.')
      GO TO 260
  240 WRITE  (IBBOUT,250) UFM,I7
  250 FORMAT (A23,' - AMG MODULE -SUBROUTINE SUBCC.  OUTER LOOP OF AM5',
     1       ' EXCEEDED I7 (',I6,1H))
  260 CALL MESAGE (-61,0,0)
  270 CONTINUE
      RETURN
      END

      SUBROUTINE NA1 2 IF (*,A,N,B,INT)
C
C     VAX, IBM AND UNIVAC VERSION (CHARACTER FUNCTION PROCESSING)
C     ===========================
C
      COMMON /XREADX/NOUT
      INTEGER        A(1)
      CHARACTER*1    BK,    PT,    TJ,   T(24), C(1), NUM(10)
      CHARACTER*12   TEMP,  NEXT,  BLNK
      EQUIVALENCE    (TEMP,T(1)), (NEXT,T(13)), (I,XI)
      DATA           BK,    PT,    BLNK  / ' ', '.', '            ' /
      DATA           NUM / '0','1','2','3','4','5','6','7','8','9'  /
C
C     ARRAY A, IN NA1 BCD WORDS (OR C IN CHARACTERS), IS DECODED TO
C     AN INTEGER OR TO A F.P. NUMBER IN B.
C     INT SHOULD BE SET TO +1 IF CALLER IS EXPECTING B TO BE AN INTEGER,
C     OR SET TO -1 IF B IS TO BE A F.P. NUMBER.   SET INT TO ZERO IF
C     CALLER IS NOT SURE.  IN THIS LAST CASE, INT WILL BE SET TO +1 OR
C     -1 BY NA12IF/NK12IF ACCORDING TO THE INPUT DATA TYPE.
C     THESE ROUTINES HANDLE UP TO 12 DIGITS INPUT DATA (N .LE. 12)
C     (NO SYSTEM ENCODE/DECODE FUNCTIONS ARE USED)
C
C     ENTRY POINTS   NA1 2 IF  (BCD-INTEGER/FP VERSION)
C                    NK1 2 IF  (CHARACTER-INTEGER/FP VERSION)
C
C     WRITTEN BY G.CHAN/SPERRY IN AUG. 1985
C     PARTICULARLY FOR XREAD ROUTINE, IN SUPPORT OF ITS NEW FREE-FIELD
C     INPUT FORMAT.  THIS SUBROUTINE IS MACHINE INDEPENDENT
C
      IF (N .GT. 12) GO TO 150
      CALL B2K (A,TEMP,N)
      GO TO 20
C
      ENTRY NK1 2 IF (*,C,N,B,INT)
C     ****************************
C
      IF (N .GT. 12) GO TO 150
      DO 15 I=1,N
 15   T(I)=C(I)
C
 20   IF (INT .GE. 1) GO TO 110
 25   NT=1
      K =24
      J =N
      NEXT=BLNK
      DO 50 I=1,12
      IF (I    .GT.  N) GO TO 30
      TJ=T(J)
      IF (TJ .EQ. BK) GO TO 50
      IF (TJ .EQ. PT) NT=NT-2
      T(K)=TJ
      GO TO 40
 30   T(K)=BK
 40   K=K-1
 50   J=J-1
C
      IF (NT.LT.-1 .OR. INT*NT.LT.0) GO TO 170
      IF (INT .EQ. 0) INT=NT
      IF (INT) 60,170,80
 60   READ (NEXT,70) B
 70   FORMAT (F12.0)
      RETURN
 80   READ (NEXT,90) I
 90   FORMAT (I12)
 100  B=XI
      RETURN
C
C     QUICK WAY TO GET THE INTEGER
C
 110  I=0
      J=0
 120  J=J+1
      IF (J .GT. N) GO TO 100
      TJ=T(J)
      IF (TJ .EQ. BK) GO TO 120
      DO 130 K=1,10
      IF (TJ .EQ. NUM(K)) GO TO 140
 130  CONTINUE
      GO TO 25
 140  I=I*10 + K-1
      GO TO 120
C
 150  B=0.
      WRITE (NOUT,160) N
 160  FORMAT (5X,'*** N.GT.12/NA12IF',I6)
 170  RETURN 1
      END

      SUBROUTINE MRED1E
C
C     THIS SUBROUTINE GENERATES THE RIGID BODY MATRIX DMX IF FREEBODY
C     MODES ARE REQUESTED FOR THE MRED1 MODULE.
C
C     INPUT DATA
C     SOF -    BGSS   - BASIC GRID POINT IDENTIFICATION TABLE
C              EQSS   - SUBSTRUCTURE EQUIVALENCE TABLE
C              CSTM   - COORDINATE SYSTEM TRANSFORMATION MATRIX
C
C     OUTPUT DATA
C     GINO -   SCR1   - SCRATCH FILE HOLDING UNTRANSPOSED DMX MATRIX
C              DMR    - RIGID BODY MATRIX
C
C     PARAMETERS
C     INPUT  - DRY    - MODULE OPERATION FLAG
C              RGRID  - FREEBODY MODES FLAGS
C                       RGRID(1) .EQ. INTERNAL GRID POINT IDENTIFICATION
C                                     NUMBER (SET IN MRED1C)
C                       RGRID(2) .EQ. NUMBER OF THE CONTRIBUTING
C                                     SUBSTRUCTURE (SET IN MRED1)
C              KORBGN - BEGINNING ADDRESS OF OPEN CORE
C              KORLEN - LENGTH OF OPEN CORE
C              RGRID0 - FREE BODY MODE BASIC COORDINATES
C     OTHERS - NBGSS  - NUMBER OF INTERNAL GRID IDENTIFICATION POINTS
C              LOCBGS - BEGINNING ADDRESS OF BGSS DATA
C              LOCSTM - BEGINNING ADDRESS OF CSTM DATA
C              LOCSIL - BEGINNING ADDRESS OF SIL DATA
C              SMALD  - MATRIX OF COORDINATE LOCATION DIFFERENCES (3X3)
C              TI     - MATRIX OF COORDINATE TRANSFORMATIONS (3X3)
C              BIGD   - PARTITIONED MATRIX OF TRANSFORMATIONS (6X6)
C
C                                                  T
C              TTD    - TEMPORARY MATRIX HOLDING (T SMALD) (3X3)
C              KOMPNT - ARRAY HOLDING DECODED SIL COMPONENTS
C
      INTEGER         OLDNAM,DRY,GBUF1,GBUF2,RGRID,RNAME,Z,TYPIN,TYPPCK,
     1                TYPUNP,SCR1,DMR,TITTD,TIIJD1,TTDIJD,ZEROIJ,TIIJD2,
     2                DMRNAM
      DIMENSION       MODNAM(2),ITRLR(7),TI(9),SMALD(9),BIGD(36),TTD(9),
     1                KOMPNT(32),RZ(1),DMRNAM(2)
      COMMON /BLANK / OLDNAM(2),DRY,IDUM1(6),GBUF1,GBUF2,IDUM2(3),
     1                KORLEN,IDUM3(6),RGRID(2),RNAME(2),IDUM4,KORBGN,
     2                NCSUBS,IDUM5(3),NSIL,IDUM6(4),RGRID0(3)
      COMMON /ZZZZZZ/ Z(1)
      COMMON /PACKX / TYPIN,TYPPCK,IROWP,LROWP,INCRP
      COMMON /UNPAKX/ TYPUNP,IROWUP,LROWUP,INCRUP
      EQUIVALENCE     (RZ(1),Z(1))
      DATA    MODNAM/ 4HMRED,4H1E   /
      DATA    NHBGSS, NHCSTM,NHEQSS /4HBGSS,4HCSTM,4HEQSS/
      DATA    SCR1  , DMR /301,204  /
C
C     TEST FOR MODULE ERRORS
C
      IF (DRY .EQ. -2) GO TO 190
C
C     TEST FOR FREEBODY MODES REQUEST
C
      IF (RGRID(1) .EQ. -1) GO TO 190
C
C     READ BGSS DATA
C
      IT = 1
      CALL SFETCH (OLDNAM,NHBGSS,1,ITEST)
      IF (ITEST .EQ. 3) GO TO 240
      IF (ITEST .EQ. 4) GO TO 250
      IF (ITEST .EQ. 5) GO TO 260
      CALL SUREAD (Z(KORBGN),-1,NWDSRD,ITEST)
C
C     EXTRACT SUBSTRUCTURE IP DATA
C
      NBGSS  = Z(KORBGN+2)
      LOCBGS = KORBGN
      CALL SUREAD (Z(KORBGN),-2,NWDSRD,ITEST)
      KORBGN = KORBGN + NWDSRD
C
C     READ CSTM DATA
C
      LOCSTM = KORBGN
      IF (KORLEN .LE. LOCSTM) GO TO 200
      IT = 2
      CALL SFETCH (OLDNAM,NHCSTM,1,ITEST)
      IF (ITEST .EQ. 3) GO TO 30
      IF (ITEST .EQ. 4) GO TO 250
      IF (ITEST .EQ. 5) GO TO 260
      CALL SUREAD (Z(LOCSTM),-2,NWDSRD,ITEST)
      CALL PRETRS (Z(LOCSTM+3),NWDSRD-4)
C
C     CHECK FOR BASIC COORDINATES
C
   30 DO 40 I = 1, 3
   40 RGRID0(I) = 0.0
      IF (RGRID(1) .EQ. 0) GO TO 60
C
C     EXTRACT FREEBODY BASIC COORDINATES
C
      LOCRGR = LOCBGS + (4*(RGRID(1)-1))
      DO 50 I = 1,3
   50 RGRID0(I) = RZ(LOCRGR+I)
C
C     OPEN SCRATCH FILE
C
   60 IFILE = SCR1
      ITRLR(1) = IFILE
      CALL OPEN (*210,SCR1,Z(GBUF2),1)
      TYPIN = 1
      TYPPCK= 1
      IROWP = 1
      LROWP = 6
      INCRP = 1
C
C     OPEN EQSS FILE AND CHECK OPEN CORE LENGTH
C
      IT = 3
      CALL SFETCH (OLDNAM,NHEQSS,1,ITEST)
      IF (ITEST .EQ. 3) GO TO 240
      IF (ITEST .EQ. 4) GO TO 250
      IF (ITEST .EQ. 5) GO TO 260
      LOCSIL = LOCSTM + NWDSRD
      CALL SUREAD (Z(LOCSIL),-1,NWDSRD,ITEST)
      IF (KORLEN .LE. LOCSIL) GO TO 240
C
C     READ UP TO SIL DATA
C
      IF (KORLEN .LE. 2*NSIL) GO TO 240
      DO 70 I = 1,NCSUBS
      CALL SUREAD (Z(LOCSIL),-1,NWDSRD,ITEST)
      IF (KORLEN .LE. LOCSIL+NWDSRD) GO TO 240
   70 CONTINUE
C
C     GENERATE SMALD MATRIX (3X3)
C
C                **                               **
C                *                                 *
C                *    0.0      DELTA(Z)  -DELTA(Y) *
C                *                                 *
C        SMALD = * -DELTA(Z)     0.0      DELTA(X) *
C                *                                 *
C                *  DELTA(Y)  -DELTA(X)     0.0    *
C                *                                 *
C                **                               **
C
      DO 140 I = 1,NBGSS
      II       = 4*(I-1)
      SMALD(1) = 0.0
      SMALD(2) = RZ(LOCBGS+II+3) - RGRID0(3)
      SMALD(3) =-RZ(LOCBGS+II+2) + RGRID0(2)
      SMALD(4) =-SMALD(2)
      SMALD(5) = 0.0
      SMALD(6) = RZ(LOCBGS+II+1) - RGRID0(1)
      SMALD(7) =-SMALD(3)
      SMALD(8) =-SMALD(6)
      SMALD(9) = 0.0
C
C     SELECT TI, TTD MATRIX GENERATION
C
      IF (Z(LOCBGS+II)) 120,85,80
C
C     GENERATE TI, TTD MATRICES (3X3)
C     (CID .GT. 0)
C
 80   CALL TRANSS (Z(LOCBGS+II),TI)
      CALL GMMATS (TI,3,3,0,SMALD,3,3,1,TTD)
      GO TO 95
C
C     GENERATE TI, TTD MATRICES (3X3)
C     (CID .EQ. 0)
C
   85 DO 90 J = 1,3
      DO 90 K = 1,3
      L = K + 3*(J-1)
      TI(L) = 0.0
      IF (J .EQ. K) TI(L) = 1.0
   90 TTD(L) = SMALD(L)
C
C     GENERATE BIGD MATRIX (6X6)
C
C               **            **
C               *    .         *
C               *  T .  T      *
C               * T  . T SMALD *
C               *    .         *
C        BIGD = *..............*
C               *    .         *
C               *    .    T    *
C               * 0  .  T      *
C               *    .         *
C               **            **
C
   95 DO 100 J = 1,3
      DO 100 K = 1,3
      TITTD  = K + 3*(J-1)
      TIIJD1 = K + 6*(J-1)
      TTDIJD = TIIJD1 + 3
      ZEROIJ = TIIJD1 + 18
      TIIJD2 = TIIJD1 + 21
      BIGD(TIIJD1) = TI(TITTD)
      BIGD(TTDIJD) = TTD(TITTD)
      BIGD(ZEROIJ) = 0.0
  100 BIGD(TIIJD2) = TI(TITTD)
C
C     EXTRACT ROWS OF BIGD CORRESPONDING TO ACTIVE SIL COMPONENTS
C
      CALL SUREAD (Z(LOCSIL),2,NWDSRD,ITEST)
      ICODE = Z(LOCSIL+1)
      CALL DECODE (ICODE,KOMPNT,NWDSD)
      DO 110 J = 1,NWDSD
      IROWD = 1 + 6*KOMPNT(J)
  110 CALL PACK (BIGD(IROWD),SCR1,ITRLR)
      GO TO 140
C
C     SCALAR POINT ADDS NULL COLUMN TO BIGD
C     (CID .LT. 0)
C
  120 DO 130 J = 1,6
  130 BIGD(J) = 0.0
      IROWP = 1
      CALL PACK (BIGD(1),SCR1,ITRLR)
  140 CONTINUE
      CALL CLOSE (SCR1,1)
      ITRLR(3) = LROWP
C
C     READ SCR1 INTO TRANSPOSED FORM
C
      CALL OPEN (*210,SCR1,Z(GBUF1),0)
      TYPUNP = 1
      IROWUP = 1
      LROWUP = 6
      INCRUP = ITRLR(2)
      KOLMNS = ITRLR(2)
      KORBGN = LOCBGS
      IF (KORLEN .LE. KORBGN+LROWP*KOLMNS) GO TO 240
      DO 170 I = 1,KOLMNS
      CALL UNPACK (*150,SCR1,Z(KORBGN))
      GO TO 170
  150 J = KORBGN
      DO 160 K = 1,6
      RZ(J) = 0.0
  160 J = J + INCRUP
  170 KORBGN = KORBGN + 1
      CALL CLOSE (SCR1,1)
C
C     PLACE TRANSPOSED BIGD ONTO DMR OUTPUT FILE
C
      IFILE  = DMR
      CALL OPEN (*210,DMR,Z(GBUF2),1)
      CALL FNAME (DMR,DMRNAM)
      CALL WRITE (DMR,DMRNAM,2,1)
      LOCDMR = LOCBGS
      LROWP  = KOLMNS
      IFORM  = 2
      CALL MAKMCB (ITRLR,DMR,LROWP,IFORM,TYPIN)
      DO 180 I = 1,6
      CALL PACK (Z(LOCDMR),DMR,ITRLR)
  180 LOCDMR = LOCDMR + KOLMNS
      CALL CLOSE (DMR,1)
      CALL WRTTRL (ITRLR)
  190 RETURN
C
C     PROCESS SYSTEM FATAL ERRORS
C
  200 IMSG  =-8
      IFILE = 0
      GO TO 230
  210 IMSG = -1
  230 CALL SOFCLS
      CALL MESAGE (IMSG,IFILE,MODNAM)
      GO TO 190
C
C     PROCESS MODULE FATAL ERRORS
C
  240 IMSG = -1
      GO TO 270
  250 IMSG = -2
      GO TO 270
  260 IMSG = -3
  270 IF (IT-2) 280,290,300
  280 CALL SMSG (IMSG,NHBGSS,OLDNAM)
      GO TO 190
C
  290 CALL SMSG (IMSG,NHCSTM,OLDNAM)
      GO TO 190
C
  300 CALL SMSG (IMSG,NHEQSS,OLDNAM)
      GO TO 190
C
      END

      SUBROUTINE LOADSU
C
C     LOADSU SETS UP LOAD INFOTMATION FOR PROLAT FROM NSLT.
C     Z(IST)IS THE STARTING POINT FOR OPEN CORE,Z(MCORE) IS THE LAST
C     AVAILABLE WORD, NTOT IS THE NUMBER OF WORDS PUT INTO OPEN CORE
C     BY THIS ROUTINE. LOAD IS THE LOAD ID.
C
      LOGICAL         REMFL
      INTEGER         SUBCAS,BUF2,SCR1,FILE,HEST,BGPDT
      DIMENSION       NWORDS(19),MCB(7),IZ(1),L(2),ZL(2),NAM(2)
      CHARACTER       UFM*23,UWM*25
      COMMON /XMSSG / UFM,UWM
      COMMON /ZZZZZZ/ Z(1)
      COMMON /SYSTEM/ SYSBUF,IOUT
      COMMON /BIOT  / NG1,NG2,IST,SUBCAS,X1,Y1,Z1,X2,Y2,Z2,BUF2,REMFL,
     1                MCORE,LOAD,NSLT,SCR1,HEST,NTOT
      EQUIVALENCE     (Z(1),IZ(1)),(L(1),ZL(1))
      DATA    NAM   / 4HLOAD,4HSU  /
      DATA    NWORDS/ 6,6,4,4,6,6,2,5,5,6,6,7,12,10,10,19,38,7,5/
C
      BGPDT  = 103
      MCB(1) = BGPDT
      CALL RDTRL (MCB)
      NROWSP = MCB(2)
      MCB(1) = HEST
      CALL RDTRL (MCB)
      NEL    = MCB(2)
      NSIMP  = 0
      FILE   = NSLT
      CALL OPEN (*1001,NSLT,Z(BUF2),0)
      CALL READ (*1002,*10,NSLT,Z(IST+1),MCORE,0,IWORDS)
      GO TO 1008
   10 NLOADS = IWORDS-2
C
C     CHECK LOAD SELECTION AGAINST SIMPLE LOAD ID-S
C
      IF (NLOADS .EQ. 0) GO TO 35
      DO 20 I = 1,NLOADS
      IF (IZ(IST+2+I) .EQ. LOAD) GO TO 80
   20 CONTINUE
C
C     NOT A SIMPLE LOAD-MUST BEA LOAD COMBINATION. SKIP NLOADS RECORDS
C     AND SEARCH FOR PROPER LOAD ID
C
      DO 30 I = 1,NLOADS
      CALL FWDREC (*1002,NSLT)
   30 CONTINUE
C
C     READ 2 WORDS AT A TIME -1,-1 SIGNIFIES END OF LOAD CARD
C
   35 ILOAD = IST + IWORDS
   40 CALL READ (*1002,*500,NSLT,L,2,0,IFLAG)
      IF (L(1) .EQ. LOAD) GO TO 60
C
C     NO MATCH-SKIP TO -1-S
C
   50 CALL FREAD (NSLT,L,2,0)
      IF (L(1).EQ.-1 .AND. L(2).EQ.-1) GO TO 40
      GO TO 50
C
C     MATCH
C
   60 ALLS  = ZL(2)
   70 CALL FREAD (NSLT,L,2,0)
      IF (L(1).EQ.-1 .AND. L(2).EQ.-1) GO TO 90
      NSIMP = NSIMP + 1
      IF (ILOAD+2*NSIMP .GT. MCORE) GO TO 1008
      ISUB  = 2*NSIMP - 1
      Z(ILOAD+ISUB) = ZL(1)
      IZ(ILOAD+ISUB+1) = L(2)
      GO TO 70
C
C     WE HAVE NSIMP SIMPLE LOADS. FOR ONE LOAD,SET PROPER PARAMETERS
C
   80 NSIMP = 1
      ALLS  = 1.
      ILOAD = IST + IWORDS
      Z(ILOAD+1) = 1.
      IZ(ILOAD+2) = LOAD
C
C     FOR EACH SIMPLE LOAD, FIND PROPER LOAD ID AND THEN POSITION TO
C     PROPER LOAD RECORD IN NSLT
C
   90 NTOT  = 0
      ISIMP = ILOAD + 2*NSIMP
      DO 270 NS = 1,NSIMP
C
      ISUB   = ILOAD + 2*NS - 1
      FACTOR = Z(ISUB)
      ID     = IZ(ISUB+1)
      NCARDS = 0
      CALL REWIND (NSLT)
      I = 1
      IF (NLOADS .EQ. 0) GO TO 110
      DO 100 I = 1,NLOADS
      IF (ID .EQ. IZ(IST+2+I)) GO TO 110
  100 CONTINUE
      GO TO 499
C
  110 DO 120 J = 1,I
      CALL FWDREC (*1002,NSLT)
  120 CONTINUE
C
  125 CALL READ  (*1002,*260,NSLT,NOBLD,1,0,IFLAG)
      CALL FREAD (NSLT,IDO,1,0)
      IF (ISIMP+2 .GT. MCORE) GO TO 1008
      IZ(ISIMP+1) = NOBLD
      IZ(ISIMP+2) = IDO
      ISIMP = ISIMP + 2
      NTOT  = NTOT + 2
C
C     SKIP NOBLD=-20. IF NOBLD=24(REMFLUX), STORE ONLY NOBLD AND IDO,
C     BUT SKIP REMFLUX INFO ON NSLT
C
      IF (NOBLD .EQ. -20) GO TO 250
      IF (NOBLD .LE.  19) GO TO 245
      KTYPE = NOBLD - 19
      GO TO (126,127,128,129,130), KTYPE
  126 MWORDS = 3*NROWSP
      GO TO 140
  127 MWORDS = 12
      GO TO 140
  128 MWORDS = 48
      GO TO 140
  129 MWORDS = 9
      GO TO 140
  130 MWORDS = 3*NEL
      MWORDS = -MWORDS
      GO TO 141
C
  140 IF(ISIMP+MWORDS*IDO .GT. MCORE) GO TO 1008
      NTOT = NTOT + MWORDS*IDO
  141 DO 240 J = 1,IDO
C
C     NCARDS TELLS HOW MANY SIMPLE LOAD CARDS HAVE THE PRESENT FACTOR
C     APPLIED TO IT
C
      NCARDS = NCARDS + 1
      CALL FREAD (NSLT,Z(ISIMP+1),MWORDS,0)
      IF (NOBLD .NE. 24) ISIMP = ISIMP + MWORDS
  240 CONTINUE
C
C     DONE WITH CARDS OF PRESENT TYPE-GET ANOTHER TYPE
C
      GO TO 125
C
C     TYPE=-20    SKIP IT
C
  250 CALL FREAD (NSLT,Z,-(3*NROWSP),0)
      GO TO 125
C
C     NOT A MAGNETICS TYPE OF LOAD. - SKIP IT
C
  245 WRITE  (IOUT,246) UWM,LOAD
  246 FORMAT (A25,', IN FUNCTIONAL MODULE PROLATE, LOAD SET',I8, /5X,
     1       'CONTAINS A NONMAGNETIC LOAD TYPE. IT WILL BE IGNORED.')
      DO 247 I = 1,IDO
      CALL FREAD (NSLT,Z,-NWORDS(NOBLD),0)
  247 CONTINUE
C
C     EOR ON NSLT-DONE WITH THIS SIMPLE LOAD-GET ANOTHER SIMPLE LOAD
C
C     SUBSTITUTE IN OPEN CORE NCARDS FOR THE SIMPLE LOAD ID. WE NO
C     LONGER NEED THE ID, BUT WE MUST SAVE NCARDS
C
  260 CONTINUE
      IZ(ISUB+1) = NCARDS
C
  270 CONTINUE
C
C     DONE
C
C     STORE ALL THIS INFO BACK AT Z(IST) AS FOLLOWS
C
C     ALLS,NSIMP,(LOAD FACTOR,NCARDS) FOR EACH SIMPLE LOAD ID,
C     ALL LOAD INFO FOR EACH SIMPLE LOAD STARTING WITH NOBLD AND IDO
C
      Z(IST+1)  = ALLS
      IZ(IST+2) = NSIMP
      NS2   = 2*NSIMP
      DO 280 I = 1,NS2
  280 Z(IST+2+I) = Z(ILOAD+I)
      ISUB1 = IST + NS2 + 2
      ISUB2 = ILOAD + 2*NSIMP
      DO 290 I = 1,NTOT
  290 Z(ISUB1+I) = Z(ISUB2+I)
      NTOT = NTOT + 2*NSIMP + 2
      CALL CLOSE (NSLT,1)
      RETURN
C
  499 LOAD = ID
  500 WRITE  (IOUT,501) UFM,LOAD
  501 FORMAT (A23,', CANNOT FIND LOAD',I8,' ON NSLT IN BIOTSV')
      CALL MESAGE (-61,0,0)
C
 1001 N =-1
      GO TO 1010
 1002 N =-2
      GO TO 1010
 1008 N =-8
      FILE = 0
 1010 CALL MESAGE (N,FILE,NAM)
      RETURN
      END

      SUBROUTINE TRD1A (CASEXX,TRL,IC,NLFTP,NGROUP,MODA1)
C
C     THIS ROUTINE BUILDS THE INITIAL CONDITIONS TABLE, PUTS TSTEP STUFF
C     IN CORE AND EXTRACTS THE NLFTP POINTER
C
C     THIS ROUTINE IS SUITABLE FOR SINGLE PRECISION OPERATION
C
      INTEGER            SYSBUF    ,CASEXX   ,TRL      ,INTRL(2) ,
     1                   IZ(160)   ,MCB(7)   ,FILE     ,NAME(2)
C
      COMMON   /SYSTEM/  SYSBUF
      COMMON   /PACKX /  IT1       ,IT2      ,II       ,JJ       ,
     1                   INCR
      COMMON   /ZZZZZZ / Z(1)
C
      EQUIVALENCE        (Z(1)     ,IZ(1))
C
      DATA               NAME                ,INTRL              /
     1                   4HTRD1    ,4HA      ,4HTRL    ,4HTRD    /
C
C     IDENTIFICATION VARIABLES
C
C     NGROUP        NUMBER OF CHANGES OF TIME STEP
C
C     ITSTEP        SELECTED TSTEP ID
C
C     NLFTP         SELECTED NON-LINEAR LOAD ID
C
C     ICP           SELECTED INITIAL CONDITION ID
C
C     LUD           LENGTH OF INITIAL CONDITION--D SET
C
C     IGROUP        POINTER TO TSTEP STUFF
C
C
C
C     INITIALIZE
C
      IT1 = 1
      IT2 = 1
      II  = 1
      INCR= 1
      NZ  = KORSZ (Z)
      NX  = NZ
C
C     PICK UP AND STORE CASECC POINTERS
C
      IBUF1 = NZ -SYSBUF +1
      CALL GOPEN (CASEXX,IZ(IBUF1),0)
      CALL FREAD (CASEXX,IZ,166,1)
      CALL CLOSE (CASEXX,1)
      ITSTEP = IZ(38)
      ICP    = IZ(9)
      NLFTP  = IZ(160)
      IF (ICP.NE.0 .AND. MODA1.EQ.1) GO TO 920
C
C     BUILD INITIAL CONDITION FILE
C
      CALL GOPEN (IC,IZ(IBUF1),1)
      IBUF2 = IBUF1-SYSBUF
      NZ    = NZ - 2*SYSBUF
      ICRQ  =-NZ
      IF (ICRQ .GT. 0) GO TO 980
      FILE = TRL
      CALL OPEN (*900,TRL,IZ(IBUF2),0)
      CALL READ (*910,*10,TRL,IZ(1),NZ,0,IFLAG)
      ICRQ = NZ
      GO TO 980
   10 LUD  = IZ(IFLAG)
      JJ   = LUD
      ICRQ = 2*LUD - NZ
      IF (ICRQ .GT. 0) GO TO 980
      L    = IZ(3)
      ITRL = L
C
C     ZERO I. C.
C
      IVEL  = IBUF2- LUD-1
      IDISP = IVEL -LUD
      DO 20 I = 1,LUD
      K = IVEL +I
      Z(K) = 0.0
      K = IDISP +I
      Z(K) = 0.0
   20 CONTINUE
      CALL MAKMCB (MCB,IC,LUD,2,1)
      IF (ICP   .EQ. 0) GO TO 80
      IF (IZ(3) .EQ. 0) GO TO 40
      IFLAG = IFLAG-1
      DO 30 I = 4,IFLAG
      IF (IZ(I) .EQ. ICP) GO TO 50
   30 CONTINUE
   40 ITSTEP = ICP
      GO TO 940
   50 K = I-4
      L = IFLAG -I
      CALL SKPREC (TRL,K)
   70 CALL READ (*910,*80,TRL,IZ(1),3,0,IFLAG)
      K    = IZ(1) +IDISP
      I2   = 2
      Z(K) = Z(K) + Z(I2)
      K    = IZ(1) + IVEL
      Z(K) = Z(K) + Z(I2+1)
      GO TO 70
   80 CALL PACK (Z(IDISP+1),IC,MCB)
      CALL PACK (Z(IVEL +1),IC,MCB)
      CALL CLOSE (IC,1)
      CALL WRTTRL (MCB)
      CALL SKPREC (TRL,L)
C
C     BRING TSTEP STUFF INTO CORE
C
  100 ITRL = ITRL +1
      CALL READ (*940,*110,TRL,IZ(1),NZ,0,IFLAG)
      ICRQ = NZ
      GO TO 980
  110 IF (IZ(1) .NE. ITSTEP) GO TO 100
C
C     TSTEP CARD FOUND
C
      CALL CLOSE (TRL,1)
      NGROUP = (IFLAG-1)/3
C
C     MOVE TSTEP STUFF TO BOTTOM OF CORE
C
      NZ = NX - IFLAG +1
      IGROUP = NZ+1
      DO 120 I = 2,IFLAG
      K = IGROUP +I-2
      IZ(K) = IZ(I)
  120 CONTINUE
      RETURN
C
C     ERROR MESSAGES
C
  900 IP1 = -1
  901 CALL MESAGE (IP1,FILE,NAME)
      RETURN
  910 IP1 = -2
      GO TO 901
  920 IP1  = -51
      FILE = ICP
      GO TO 901
  940 CALL MESAGE (-31,ITSTEP,INTRL)
      RETURN
  980 IP1 = -8
      FILE = ICRQ
      GO TO 901
      END

      SUBROUTINE SUBI (DA,DZB,DYB,DAR,DETA,DZETA,DCGAM,DSGAM,DEE,DXI,TL,
     1                 DETAI,DZETAI,DCGAMI,DSGAMI,DEEI,DTLAMI,DMUY,DMUZ,
     2                 INFL,IOUTFL)
C
C     COMPUTES THE IMAGE POINT COORDINATES INSIDE ASSOCIATED BODIES AND
C     THE  MU-Z  MU-Y  ELEMENTS USED IN SUBROUTINE FWMW
C
      EPS   = 0.1*DEE
      DMUY  = 0.0
      DMUZ  = 0.0
      IGO   = 1
      PSQR  = SQRT(((DETA-DYB)*DAR)**2 + (DZETA-DZB)**2)
      COSTH = (DETA -DYB)*DAR/PSQR
      SINTH = (DZETA-DZB)/PSQR
      CT2   = COSTH*COSTH
      ST2   = SINTH*SINTH
      CT3   = COSTH*CT2
      ST3   = SINTH*ST2
      YCBAR = DA*(1.0-DAR*DAR)*CT3 + DYB
      ZCBAR = DA*(DAR*DAR-1.0)*ST3/DAR + DZB
      PAREN = ST2 + DAR*DAR*CT2
      PAR3  = PAREN*PAREN**2
      ABAR  = DA*SQRT(PAR3)/DAR
      ABAR2 = ABAR*ABAR
      IF (INFL .NE. 0)  GO TO  300
      ETA1  = DETA  - DEE*DCGAM
      ETA2  = DETA  + DEE*DCGAM
      ZETA1 = DZETA - DEE*DSGAM
      ZETA2 = DZETA + DEE*DSGAM
      RHO12 = (ETA1 - YCBAR)**2 + (ZETA1-ZCBAR)**2
      RHO22 = (ETA2 - YCBAR)**2 + (ZETA2-ZCBAR)**2
      ETAI1 = YCBAR + (ETA1-YCBAR)*ABAR2/RHO12
      ETAI2 = YCBAR + (ETA2-YCBAR)*ABAR2/RHO22
      ZETI1 = ZCBAR + (ZETA1-ZCBAR)*ABAR2/RHO12
      ZETI2 = ZCBAR + (ZETA2-ZCBAR)*ABAR2/RHO22
      DEEI  = SQRT((ETAI2-ETAI1)**2 + (ZETI2-ZETI1)**2)/2.0
      DETAI = (ETAI1 + ETAI2)/2.0
      DZETAI= (ZETI1 + ZETI2)/2.0
      DCGAMI=-(ETAI2 - ETAI1)/(2.0*DEEI)
      DSGAMI=-(ZETI2 - ZETI1)/(2.0*DEEI)
      DXI1  = DXI  - DEE*TL
      DXI2  = DXI  + DEE*TL
      DELXI = DXI1 - DXI2
      DTLAMI= DELXI/(2.0*DEEI)
      IF (ABS(DAR-1.0) .LE. 0.0001)  GO TO  420
      GO TO 301
  300 CONTINUE
      RHO2  = (DETA-YCBAR)**2 + (DZETA-ZCBAR)**2
      RHO4  = RHO2*RHO2
      DETAI = YCBAR + (DETA -YCBAR)*ABAR2/RHO2
      DZETAI= ZCBAR + (DZETA-ZCBAR)*ABAR2/RHO2
  301 CONTINUE
      GO TO (302,303,304), IGO
  302 CONTINUE
      XETAI = DETAI
      XZETAI= DZETAI
      GO TO 307
  303 CONTINUE
      XETAI = ETAI1
      XZETAI= ZETI1
      GO TO  307
  304 CONTINUE
      XETAI = ETAI2
      XZETAI= ZETI2
  307 CONTINUE
      IF (DAR .LT. 1.0) GO TO  310
      DYBM  = DYB - EPS
      DYBP  = DYB + EPS
      IF (DETA .GE.DYB .AND. XETAI .LT.DYBM) GO TO  325
      IF (DETA .LE.DYB .AND. XETAI .GT.DYBP) GO TO  325
      GO TO  320
  310 CONTINUE
      DZBM  = DZB - EPS
      DZBP  = DZB + EPS
      IF (DZETA.GE.DZB .AND. XZETAI.LT.DZBM) GO TO  325
      IF (DZETA.LE.DZB .AND. XZETAI.GT.DZBP) GO TO  325
  320 CONTINUE
      PART1 = ((XETAI  - DYB)/DA)**2
      PART2 = ((XZETAI - DZB)/(DA*DAR))**2
      TEDIF = PART1 + PART2 - 1.0
      IF (INFL  .EQ.   0) GO TO  400
      IF (TEDIF .LE. EPS) GO TO  330
  325 CONTINUE
      IOUTFL = 0
      GO TO  500
  330 CONTINUE
      IOUTFL = 1
      TRM1 = (DETA-YCBAR)**2 - (DZETA-ZCBAR)**2
      TRM2 = 2.0*(DETA-YCBAR)*(DZETA-ZCBAR)
      DMUY = -(-DSGAM*TRM1 + DCGAM*TRM2)*ABAR2/RHO4
      DMUZ = -(-DSGAM*TRM2 - DCGAM*TRM1)*ABAR2/RHO4
      GO TO 500
  400 CONTINUE
      IF (TEDIF .GT. EPS) GO TO 325
      IF (IGO   .EQ.   3) GO TO 420
      IGO  = IGO + 1
      GO TO 301
  420 CONTINUE
      IOUTFL = 1
  500 CONTINUE
      RETURN
      END

      SUBROUTINE AMPB1(IPVCT,NOH,NOE)
C
C     THIS ROUTINE BUILDS A PARTITIONING VECTOR WHICH WILL APPEND NOE
C       TERM(OR COLUMNS)
C
      INTEGER SYSBUF,MCB(7)
C
      COMMON  /ZBLPKX/A(4),II
      COMMON /SYSTEM/SYSBUF
      COMMON /ZZZZZZ/ Z(1)
C
C-----------------------------------------------------------------------
C
      IBUF1=KORSZ(Z)-SYSBUF+1
      CALL GOPEN(IPVCT,Z(IBUF1),1)
      CALL MAKMCB(MCB,IPVCT,NOH+NOE,2,1)
      CALL BLDPK(1,1,IPVCT,0,0)
      II=NOH
      DO 10 I=1,NOE
      A(1)=1.0
      II=II+1
      CALL ZBLPKI
   10 CONTINUE
      CALL BLDPKN(IPVCT,0,MCB)
      CALL CLOSE(IPVCT,1)
      CALL WRTTRL(MCB)
      RETURN
      END

      SUBROUTINE SHSTNS (NUMPX,ELID,IGRID,Z12,EPSLNI,BENDNG,IDR)
C
C     TO CALCULATE SHELL ELEMENT STRAINS FOR A 2-D FORMULATION BASE.
C     COMPOSITE LAYER STRAINS ARE NOT CALCULATED IN THIS ROUTINE.
C
C
C     INPUT :
C           NUMPX  - NUMBER OF EVALUATION POINTS
C           ELID   - ELEMENT ID
C           IGRID  - ARRAY IF EXTERNAL GRID IDS
C           Z12    - EVALUATION POINT FIBER DISTANCES
C           EPSLNI - CORRECTED STRAINS AT EVALUATION POINTS
C           BENDNG - INDICATES THE PRESENCE OF BENDING BEHAVIOR
C           IDR    - REORDERING ARRAY BASED ON EXTERNAL GRID POINT ID'S
C          /OUTREQ/- OUTPUT REQUEST LOGICAL FLAGS
C
C     OUTPUT:
C           STRAINS ARE PLACED AT THE PROPER LOCATION IN /SDR2X7/.
C
C
C     THE STRAIN OUTPUT DATA BLOCK, UAI CODE
C
C     ADDRESS    DESCRIPTIONS
C
C        1       ELID
C     --------------------------------------------------------------
C        2       GRID POINT NUMBER OR 'CNTR'
C      3 - 10    STRAINS FOR LOWER POINTS OR MEMBRANE STRAINS
C     11 - 18    STRAINS FOR UPPER POINTS OR BENDING CURVATURES
C     ---------- ABOVE DATA REPEATED 3 TIMES
C                FOR GRID POINTS
C
C
C     THE STRAIN OUTPUT DATA BLOCK, AT ELEMENT CENTER ONLY, COSMIC
C
C     ADDRESS    DESCRIPTIONS
C
C        1       ELID
C     --------------------------------------------------------------
C        2       LOWER FIBER DISTANCE
C      3 -  9    STRAINS FOR LOWER POINTS OR MEMBRANE STRAINS
C       10       UPPER FIBER DISTANCE
C     11 - 17    STRAINS FOR UPPER POINTS OR BENDING CURVATURES
C     ---------- ABOVE DATA REPEATED 3 TIMES
C                FOR GRID POINTS
C
C
      LOGICAL         BENDNG,STSREQ,STNREQ,FORREQ,STRCUR,
     1                GRIDS,VONMS,LAYER,GRIDSS,VONMSS,LAYERS,COSMIC
      INTEGER         IGRID(1),NSTRIN(1),IDR(1),ELID
CWKBI NCL93012 3/94
      INTEGER         NSTRES(1)
      REAL            Z12(2,1),EPSLNI(6,1),EPSIL(3),EPSS,FIBER,EPSILP(4)
      COMMON /SDR2X7/ DUM71(100),STRES(100),FORSUL(200),STRIN(100)
      COMMON /OUTREQ/ STSREQ,STNREQ,FORREQ,STRCUR,GRIDS,VONMS,LAYER
     1,               GRIDSS,VONMSS,LAYERS
      EQUIVALENCE     (NSTRIN(1),STRIN(1))
CWKBI NCL93012 3/94
      EQUIVALENCE     (NSTRES(1), STRES(1))
CWKBNB 7/94 SPR94004
      LOGICAL         OSTRAI
      COMMON / BLANK/ APP(2), SORT2, IDUM(2), COMPS, SKP(4), OSTRAI
     &,               SK2(39), MIDVE
CWKBNE 7/94 SPR94004
      DATA    COSMIC, EPSS / .TRUE., 1.0E-17 /
C
C
C     ELEMENT ENTER COMPUATION ONLY FOR COSMIC
C     I.E. CALLER SHOULD PASS 1 IN NUMPX FOR COSMIC, 4 FOR UAI
C
      NUMP = NUMPX
      IF (COSMIC) NUMP = 1
C
      NSTRIN(1) = ELID
C
C     START THE LOOP ON EVALUATION POINTS
C
      NUMP1 = NUMP - 1
      DO 250 INPLAN = 1,NUMP
C
      ISTRIN = 1
      IF (COSMIC) GO TO 140
C
      ISTRIN = (INPLAN-1)*17 + 2
      NSTRIN(ISTRIN) = INPLAN - 1
      IF (.NOT.GRIDSS .OR. INPLAN.LE.1) GO TO 130
      DO 100 INPTMP = 1,NUMP1
      IF (IDR(INPTMP) .EQ. IGRID(INPLAN)) GO TO 120
  100 CONTINUE
      CALL ERRTRC ('SHSTNS  ',100)
  120 ISTRIN = INPTMP*17 + 2
      NSTRIN(ISTRIN) = IGRID(INPLAN)
  130 IF (INPLAN .EQ. 1) NSTRIN(ISTRIN) = IGRID(INPLAN)
C
C     START THE LOOP ON FIBERS
C
  140 DO 240 IZ = 1,2
      IF (.NOT.STRCUR) GO TO 190
C
C     IF STRAIN/CURVATURE IS REQUESTED, SIMPLY OUTPUT THE AVAILABLE
C     STRAINS.
C
      STRIN(ISTRIN+1) = 0.0
      DO 150 I = 1,3
      EPSIL(I) = 0.0
  150 CONTINUE
CWKBI 7/94 SPR94004
      IF ( OSTRAI .AND. IZ .EQ. 2 ) GO TO 171
      IF (IZ .NE. 1) GO TO 170
      DO 160 I = 1,3
      EPSIL(I) = EPSLNI(I,INPLAN)
  160 CONTINUE
CWKBI 7/94 SPR94004
      IF ( OSTRAI .AND. IZ .EQ. 1 ) GO TO 220
  170 IF (.NOT.BENDNG .OR. IZ.NE.2) GO TO 190
CWKBI 7/94 SPR94004
  171 CONTINUE
      DO 180 I = 1,3
      EPSIL(I) = EPSLNI(I+3,INPLAN)
  180 CONTINUE
      GO TO 220
C
C     IF FIBER STRAINS ARE REQUESTED, EVALUATE STRAINS AT THIS FIBER
C     DISTANCE
C
  190 FIBER = Z12(IZ,INPLAN)
      STRIN(ISTRIN+1) = FIBER
      DO 200 I = 1,3
      EPSIL(I) = EPSLNI(I,INPLAN) - EPSLNI(I+3,INPLAN)*FIBER
  200 CONTINUE
C
C     CLEANUP AND SHIP CALCULATED STRAINS
C
  220 DO 230 ITS = 1,3
      IF (ABS(EPSIL(ITS)) .LE. EPSS) EPSIL(ITS) = 0.0
CWKBR NCL93012 3/94      STRIN(ISTRIN+1+ITS) = EPSIL(ITS)  
      STRES(ISTRIN+1+ITS) = EPSIL(ITS) 
  230 CONTINUE
C
C     CALCULATE PRINCIPAL STRAINS
C
      CALL SHPSTS (EPSIL(1),VONMSS,EPSILP)
CWKBDB NCL93012 3/94
C      STRIN(ISTRIN+5) = EPSILP(1)
C      STRIN(ISTRIN+6) = EPSILP(2)
C      STRIN(ISTRIN+7) = EPSILP(3)
C      STRIN(ISTRIN+8) = EPSILP(4)
CWKBDE NCL93012 3/94
CWKBNB NCL93012 3/94
      NSTRES( ISTRIN+1 ) = 0
      IF ( IZ .EQ. 2 ) NSTRES( ISTRIN+1) = -1
      STRES(ISTRIN+5) = EPSILP(1)
      STRES(ISTRIN+6) = EPSILP(2)
      STRES(ISTRIN+7) = EPSILP(3)
      STRES(ISTRIN+8) = EPSILP(4) * 2.
CWKBNE NCL93012 3/94
C
      ISTRIN = ISTRIN + 8
  240 CONTINUE
  250 CONTINUE
C
      RETURN
      END

      SUBROUTINE CURV1
C*****
C  INITIALIZATION OVERLAY. ALL LOGIC INDEPENDENT OF PROCESSING
C  THE SUBCASE DATA ON OES1 IS HANDLED IN THIS INITIALIZATION
C  ROUTINE OF THE -CURV- MODULE
C
C     OPEN CORE MAP DURING -CURV1- EXECUTION.
C     =======================================
C       INITIAL               AFTER CURV1 RETURNS
C     +-----------+             +----------------+
C     I Z(IELTYP) I             I  Z(IELTYP)     I
C     I    .      I             I     .          I
C     I  ELEMENT  I             I  REDUCED       I
C     I  TYPES    I             I  ELEMENT-TYPES I
C     I  BEING    I             I  LIST          I
C     I  PLACED   I             I     .          I
C     I  IN SCR1  I             I  Z(NELTYP)     I
C     I    .      I             +----------------+
C     I Z(NELTYP) I             I  Z(IMCSID)     I
C     +-----------+             I     .          I
C     I Z(IMID)   I             I  MCSID LIST    I
C     I    .      I             I  OF MCSIDS     I
C     I MATID-    I             I  ACTUALLY      I
C     I MCSID-    I             I  REFERENCED    I
C     I FLAG-     I             I     .          I
C     I ENTRIES   I             I  Z(NMCSID)     I
C     I    .      I             +----------------+
C     I Z(NMID)   I             I  Z(ICSTM)      I
C     +-----------+             I     .          I
C     I Z(ISIL)   I             I  CSTMS IN      I
C     I    .      I             I  EXISTENCE     I
C     I SILS IN   I             I  FOR MCSIDS    I
C     I INTERNAL  I             I  IN ABOVE      I
C     I SORT      I             I  TABLE         I
C     I    .      I             I     .          I
C     I Z(NSIL)   I             I  Z(NCSTM)      I
C     +-----------+             +----------------+
C     I Z(IEXT)   I             I     .          I
C     I    .      I             I  AVAILABLE     I
C     I EXTERNAL  I             I  CORE          I
C     I IDS IN    I             I     .          I
C     I INTERNAL  I             I     .          I
C     I SORT      I             I     .          I
C     I    .      I             I     .          I
C     I Z(NEXT)   I             I     .          I
C     +-----------+             I     .          I
C     I   .       I             I     .          I
C     I AVAILABLE I             I     .          I
C     I CORE      I             I     .          I
C     I   .       I             I     .          I
C     I Z(JCORE)  I             I  Z(JCORE)      I
C     +-----------+             +----------------+
C     I Z(IBUF4)  I             I  Z(IBUF4)      I
C     I Z(IBUF3)  I             I  Z(IBUF3)      I
C     I Z(IBUF2)  I             I  Z(IBUF2)      I
C     I Z(IBUF1)  I             I  Z(IBUF1)      I
C     I GINO-BUFS I             I  GINO-BUFS     I
C     I Z(LCORE)  I             I  Z(LCORE)      I
C     +-----------+             +----------------+
C
C*****
      REAL               Z(1)     ,RBUF(100)
C
      INTEGER            CSTMS    ,SCR1     ,SCR2     ,SCR3
      INTEGER            SCR4     ,OES1M    ,OES1G    ,OES1     ,SCR5
      INTEGER            CSTM     ,EST      ,SIL      ,GPL
      INTEGER            ELTYPE   ,SUBCAS   ,FILE     ,ESTWDS
      INTEGER            EWORDS   ,OWORDS   ,DEPTS    ,CSTYPE
      INTEGER            DEVICE   ,OLDID    ,BUF      ,SBUF
      INTEGER            RD       ,RDREW    ,WRT      ,WRTREW
      INTEGER            CLS      ,CLSREW   ,EOR      ,SYSBUF
C
      INTEGER            MAT(6)   ,ELEM(5,4)
C
      LOGICAL            ANY      ,EOFOS1   ,FIRST    ,ANYOUT
      LOGICAL            FOES1G   ,STRAIN   ,ANY1M    ,ANY1G
C
      COMMON/BLANK /     IP1      ,IP2      ,ICMPLX   ,ZDUM(3)
C
      COMMON/SYSTEM/     SYSBUF   ,IOUTPT
C
      COMMON/NAMES /     RD       ,RDREW    ,WRT      ,WRTREW
     1                  ,CLSREW   ,CLS
C
      COMMON/ZZZZZZ/     IZ(1)
C
      COMMON/CURVC1/     LSBUF    ,SBUF(10)
C
      COMMON/CURVC2/     LBUF     ,BUF(100)
C
      COMMON/CURVC3/     VEC(3)   ,VMAX(3)  ,VMIN(3)  ,IDREC(146)
C
      COMMON/CURVTB/     IMID     ,NMID     ,LMID     ,NMIDS
     A                  ,IELTYP   ,NELTYP   ,JELTYP   ,ICSTM
     B                  ,NCSTM    ,CSTMS    ,LCSTM    ,IESTX
     C                  ,NESTX    ,IMCSID   ,NMCSID   ,LMCSID
     D                  ,MCSIDS   ,JMCSID   ,KMCSID   ,ISIL
     E                  ,NSIL     ,LSIL     ,JSIL     ,IOES1M
     F                  ,NOES1M   ,LOES1M   ,IDEP     ,NDEP
     G                  ,IINDEP   ,NINDEP   ,JINDEP   ,ISIGMA
     H                  ,NSIGMA   ,IGMAT    ,NGMAT    ,IEXT
     I                  ,NEXT     ,LEXT     ,SCR1     ,SCR2
     J                  ,SCR3     ,SCR4     ,OES1M    ,OES1G
     K                  ,OES1     ,MPT      ,CSTM     ,EST
     L                  ,SIL      ,GPL      ,JCORE    ,LCORE
     M                  ,IBUF1    ,IBUF2    ,IBUF3    ,IBUF4
     N                  ,I        ,J        ,K        ,L
     O                  ,K1       ,K2       ,IXYZ1    ,IXYZ2
     P                  ,LX1      ,LX2      ,ELTYPE   ,MCSID
     Q                  ,IDSCR1   ,IDOES1   ,NPTS     ,NPTS4
     R                  ,IWORDS   ,NWORDS   ,SUBCAS   ,KOUNT
     S                  ,ISIG1    ,ISIG2    ,LOC      ,FILE
      COMMON/CURVTB/     IMSG     ,NELEMS   ,IMATID   ,ICOMP
     1                  ,ESTWDS   ,EWORDS   ,JP       ,OWORDS
     2                  ,MATID    ,DEPTS    ,INDPTS   ,ICTYPE
     3                  ,IVMAT    ,ITRAN    ,CSTYPE   ,ISING
     4                  ,DEVICE   ,OLDID    ,ANY      ,EOFOS1
     5                  ,FIRST    ,ANYOUT   ,FOES1G   ,STRAIN
     6                  ,LOGERR   ,ANY1M    ,ANY1G    ,SCR5
C
      EQUIVALENCE        (Z(1),IZ(1)), (BUF(1),RBUF(1))
      EQUIVALENCE        (NOEOR,RDREW), (EOR,CLS)
C
      DATA MAT / 103,1,12,   203,2,17  /
C
C        - - - - - - - - CURV-MODULE ELEMENTS DATA - - - - - - - -
C
C                   ELEMENT   EST       CONNECT.  MATID     BGPDT
C                   TYPE      WORDS     POINTS    INDEX     INDEX
C                   =======   =======   =======   =======   =======
C  TRIA1
      DATA ELEM /   6        ,27       ,3        ,6        ,15
C  TRIA2
     *             ,17       ,21       ,3        ,6        ,9
C  QUAD1
     *             ,19       ,32       ,4        ,7        ,16
C  QUAD2
     *             ,18       ,26       ,4        ,7        ,10       /
C
C  IF EITHER OF THESE PARAMS IS EXCEEDED RESET AND RE-DIMENSION
C  SBUF OR BUF.
C
      LSBUF  = 10
      LBUF   = 100
      NELEMS = 4
      LOGERR = 37
C*****
C  INITIALIZATION OF CORE AND FLAGS
C*****
      FOES1G = .TRUE.
      IF (IP1.GT.0) FOES1G = .FALSE.
      ANY1M = .FALSE.
      ANY1G = .FALSE.
      LMCSID = 0
C
      LCORE = KORSZ( IZ(1) )
      DO 100 I = 1,LCORE
      IZ(I) = 0
  100 CONTINUE
      IBUF1 = LCORE - SYSBUF
      IBUF2 = IBUF1 - SYSBUF
      IBUF3 = IBUF2 - SYSBUF
      IBUF4 = IBUF3 - SYSBUF
C
C  SET FILE NUMBERS EXPLICITYLY.  ALL OVERLAYS REFERENCE /CURVTB/
C
      OES1  = 101
      MPT   = 102
      CSTM  = 103
      EST   = 104
      SIL   = 105
      GPL   = 106
      OES1M = 201
      OES1G = 202
      SCR1  = 301
      SCR2  = 302
      SCR3  = 303
      SCR4  = 304
      SCR5 = 305
      JCORE = IBUF4 - 1
      FILE = 0
      LOC = 300
      ICRQ =-IBUF4
      IF( IBUF4 ) 9008,9008,300
C*****
C  ALLOCATE TABLE OF ELEMENT TYPES PLACED ON ESTX(SCR1).  MAXIMUM
C  SIZE NOW AND REDUCED LATER TO ACTUAL SIZE.
C*****
  300 IELTYP = 1
      JELTYP = IELTYP
      NELTYP = NELEMS
C*****
C  CONSTRUCTION OF TABLE CONTAINING ENTRIES OF,
C
C     MID   = MATERIAL-ID
C     MCSID = MATERIAL-COORDINATE-SYSTEM-ID
C     FLAG  = REFERENCE-FLAG
C
C  ALL MAT1 AND MAT2 BULK DATA CARDS CONTAINING A NON-ZERO -MCSID-
C  RESULT IN AN ENTRY BEING ADDED TO THIS TABLE. TABLE IS THEN SORTED
C  ON -MID-.
C*****
      IMID = NELTYP + 1
      NMID = IMID - 1
C
C  OPEN MPT USING -PRELOC- FUNCTION.
C
      FILE = MPT
      LOC = 400
      CALL PRELOC(*9001,IZ(IBUF1),MPT)
C
C  PASS MAT1 AND MAT2 DATA IF ANY.
C
      DO 480 I = 1,6,3
      IWORDS = MAT(I+2)
      IF( IWORDS .GT. LBUF ) GO TO 9000
      CALL LOCATE(*480,IZ(IBUF1),MAT(I),IDUM)
  410 CALL READ(*9002,*480,MPT,BUF(1),IWORDS,NOEOR,NWORDS)
      IF( BUF(IWORDS) .LE. 0 ) GO TO 410
      ICRQ = NMID + 3 - JCORE
      IF( NMID+3 .GT. JCORE ) GO TO 9008
      IZ(NMID+1) = BUF(1)
      IZ(NMID+2) = BUF(IWORDS)
      IZ(NMID+3) = 0
      NMID = NMID + 3
      GO TO 410
C
C  EOR HIT READING MAT1 OR MAT2 CARDS
C
  480 CONTINUE
C
C  TABLE COMPLETE, THUS NOW SORT IT. IF TABLE IS EMPTY WE ARE THROUGH
C
      CALL CLOSE( MPT, CLSREW )
      LMID = NMID - IMID + 1
      NMIDS = LMID / 3
      LOC = 570
      IF (LMID) 9000, 950, 570
  570 CALL SORT( 0, 0, 3, 1, IZ(IMID), LMID )
C*****
C  LOAD LIST OF SILS INTO CORE, FOLLOWED BY LIST OF EXTERNAL IDS.
C  THIS IS REQUIRED ONLY IF OES1G IS TO BE FORMED.
C*****
      IF( .NOT. FOES1G ) GO TO 630
      FILE = SIL
      LOC = 580
      ISIL = NMID + 1
      CALL GOPEN( SIL, IZ(IBUF1), 0 )
      CALL READ(*9002,*580,SIL,IZ(ISIL),JCORE-ISIL,NOEOR,LSIL)
      ICRQ = JCORE - ISIL
      GO TO 9008
C
  580 NSIL = ISIL + LSIL - 1
      CALL CLOSE( SIL, CLSREW )
C
      FILE = GPL
      LOC = 590
      IEXT = NSIL + 1
      CALL GOPEN( GPL, IZ(IBUF1), 0 )
      CALL READ(*9002,*590,GPL,IZ(IEXT),JCORE-IEXT,NOEOR,LEXT)
      ICRQ = JCORE - IEXT
      GO TO 9008
C
  590 NEXT = IEXT + LEXT - 1
      CALL CLOSE( GPL, CLSREW )
      IF( LSIL .NE. LEXT ) GO TO 9000
C*****
C  EST IS NOW READ. ANY ELEMENTS IN THE EST WHOSE MATERIAL ID REFERENCES
C  A MAT1 OR MAT2 ENTRY WHICH CONTAINS A NON-ZERO MATERIAL-COORDINATE-
C  SYSTEM-ID, WILL BE PLACED IN AN ABBREVIATED EST ON SCRATCH1.
C
C  FORMAT OF EACH ELEMENT TYPE RECORD.
C
C         ELEMENT TYPE NUMBER
C         NUMBER OF WORDS PER EACH OF THE FOLLOWING ENTRIES.
C         NUMBER OF POINTS PER THIS ELEMENT TYPE.
C
C        * ELEMENT-ID
C       *  MCSID = MATERIAL-COORDINATE-SYSTEM-ID
C ENTRY*
C       *  EXTERNAL-GRID-IDS THIS ELEMENT CONNECTS (1 OR MORE)
C        * X,Y,Z BASIC COORDINATE SETS OF EACH CONNECTED POINT(1 OR MORE
C
C           ( ABOVE ELEMENT ENTRY REPEATS FOR EACH ELEMENT
C             REFERENCING A MAT1 OR MAT2 CARD HAVING A NON-ZERO MCSID.)
C
C*****
  630 LOC = 630
      FILE = SCR1
      CALL OPEN(*9001,SCR1,IZ(IBUF2),WRTREW)
      FILE = EST
      CALL GOPEN(  EST, IZ(IBUF1), 0 )
C
      OLDID = -99999998
C
C  READ ELEMENT TYPE OF NEXT EST RECORD AND DETERMINE IF IT IS
C  AMONG ELEMENT TYPES TO BE EVEN CONSIDERED.
C
  645 LOC = 645
      CALL READ(*800,*9003,EST,ELTYPE,1,NOEOR,NWORDS)
      DO 650 I = 1,NELEMS
      IF( ELTYPE .EQ. ELEM(1,I) ) GO TO 670
  650 CONTINUE
      CALL FWDREC(*9002,EST)
      GO TO 645
C
C  OK THIS  ELEMENT TYPE RECORD IS TO BE CONSIDERED.
C
  670 ESTWDS = ELEM(2,I)
      LOC = 670
      IF( ESTWDS .GT. LBUF ) GO TO 9000
      ANY    = .FALSE.
      NPTS   = ELEM(3,I)
      IMATID = ELEM(4,I)
      IXYZ1 = ELEM(5,I)
      IXYZ2 = IXYZ1 + 4*NPTS - 1
      K1 = 2 + NPTS
      LOC = 680
      IF( K1 .GT. LSBUF ) GO TO 9000
C
C  READ AN ELEMENT ENTRY AND CHECK TO DETERMINE IF IT IS TO BE USED.
C
  690 LOC = 690
      CALL READ(*9002,*780,EST,BUF(1),ESTWDS,NOEOR,NWORDS)
      MATID = BUF(IMATID)
      IF( MATID .EQ. OLDID ) GO TO 730
      CALL BISLOC(*690,MATID,IZ(IMID),3,NMIDS,JP)
      MCSID = IZ(IMID+JP)
      OLDID = MATID
      IZ(IMID+JP+1) = 7
C
C  DEVELOP AND OUTPUT ABBREVIATED ENTRY TO SCRATCH1.
C  (INITIALIZE RECORD WITH THREE-WORD-HEADER ENTRY.)
C
  730 IF( ANY ) GO TO 733
      SBUF(1) = ELTYPE
      SBUF(2) = 4*NPTS + 2
      SBUF(3) = NPTS
      CALL WRITE( SCR1, SBUF(1), 3, NOEOR )
      IZ(JELTYP) = ELTYPE
      JELTYP = JELTYP + 1
      ANY = .TRUE.
C
  733 SBUF(1) = BUF(1)
      SBUF(2) = MCSID
C
C  CONVERT SILS TO EXTERNAL-IDS IF OES1G IS TO BE BUILT
C
      IF( FOES1G ) GO TO 740
      DO 735 I=3,K1
      SBUF(I) = 0
  735 CONTINUE
      GO TO 760
C
  740 JSIL = 2
      LOC = 740
      DO 750 I = 3,K1
      CALL BISLOC(*9000,BUF(JSIL),IZ(ISIL),1,LSIL,JP)
      SBUF(I) = IZ(IEXT+JP-1)
      JSIL = JSIL + 1
  750 CONTINUE
C
C  OUTPUT THIS PORTION OF ENTRY AND THEN XYZ COMPONENTS OF CONNECTED
C  POINTS
C
  760 CALL WRITE( SCR1, SBUF(1), NPTS+2, NOEOR )
C
      DO 770 I = IXYZ1,IXYZ2,4
      CALL WRITE( SCR1, BUF(I+1), 3, NOEOR )
  770 CONTINUE
C
C  GO FOR NEXT ELEMENT OF THIS TYPE
C
      GO TO 690
C
C  END OF ENTRIES FUR CURRENT ELEMENT TYPE.
C
  780 LOC = 780
      IF( NWORDS .NE. 0 ) GO TO 9000
      IF( ANY ) CALL WRITE( SCR1, 0, 0, EOR )
      GO TO 645
C
C  END OF ALL ELEMENT TYPES IN EST
C
  800 CALL CLOSE(  EST, CLSREW )
      CALL CLOSE( SCR1, CLSREW )
C*****
C  REDUCTION OF MATERIAL-ID AND COORDINATE-SYSTEM-ID TO THOSE
C  ACTUALLY REFERENCED BY ELEMENTS BEING CONSIDERED.
C*****
      NELTYP = JELTYP - 1
C
C  RESORT MID-MCSID TABLE ON MCSID.
C
      CALL SORT( 0, 0, 3, 2, IZ(IMID), LMID )
      IMCSID = NELTYP + 1
      NMCSID = NELTYP
      LOC = 820
      OLDID = 0
      DO 840 I = IMID,NMID,3
      IF( IZ(I+2) ) 9000,840,820
C
C  ELIMINATE DUPLICATE MCSIDS.
C
  820 IF( IZ(I+1) .EQ. OLDID ) GO TO 840
      OLDID = IZ(I+1)
      NMCSID = NMCSID + 2
      IZ(NMCSID-1) = IZ(I+1)
      IZ(NMCSID  ) = 0
  840 CONTINUE
      LMCSID = NMCSID - IMCSID + 1
      MCSIDS = LMCSID / 2
C
C  IF TABLE IS NOW EMPTY THERE IS NOTHING MORE TO DO
C
      LOC = 860
      IF (LMCSID) 9000, 950, 860
C*****
C  COORDINATE SYSTEMS WHICH MAY BE REFERENCED ARE AT THIS TIME
C  PULLED INTO CORE FROM THE -CSTM- DATA BLOCK. (SILS AND EXTERNAL-IDS
C  TABLES IF IN CORE ARE NO LONGER REQUIRED.)
C*****
  860 ICSTM = NMCSID + 1
      NCSTM = NMCSID
      FILE = CSTM
      CALL GOPEN( CSTM, IZ(IBUF1), 0 )
  870 ICRQ = NCSTM + 14 - JCORE
      IF( NCSTM+14 .GT. JCORE ) GO TO 9008
  880 CALL READ(*9002,*900,CSTM,IZ(NCSTM+1),14,NOEOR,NWORDS)
      KID = IZ(NCSTM+1)
      CALL BISLOC (*880, KID, IZ(IMCSID), 2, MCSIDS, JP)
      NCSTM = NCSTM + 14
      GO TO 870
C
C  END OF COORDINATE SYSTEM DATA
C
  900 CALL CLOSE( CSTM, CLSREW )
      LCSTM = NCSTM - ICSTM + 1
      CSTMS = LCSTM / 14
      CALL SORT( 0, 0, 14, 1, Z(ICSTM), LCSTM )
      CALL PRETRS( IZ(ICSTM), LCSTM )
C*****
C  INITIALIZE INPUT AND OUTPUT FILE POSITIONS.
C*****
  950 CALL GOPEN (OES1, IZ(IBUF1), 0)
C
C  CHECK FOR STRAIN OPTION
C
      FILE = OES1
      LOC = 910
      CALL READ(*9002,*9003,OES1,IDREC(1),2,0,FLAG)
      I = IDREC(2)
      IF (I.NE.5.AND.I.NE.21.AND.I.NE.1005) GO TO 9000
      STRAIN = .FALSE.
      IF (I.EQ.21) STRAIN = .TRUE.
      ICMPLX = 0
      IF (I.EQ.1005) ICMPLX = 1
      CALL BCKREC (OES1)
C
      CALL CLOSE( OES1, CLS )
      EOFOS1 = .FALSE.
C
      CALL GOPEN( OES1M, IZ(IBUF1), 1 )
      CALL CLOSE( OES1M, CLS )
C
      IF( .NOT. FOES1G ) GO TO 5000
      CALL GOPEN( OES1G, IZ(IBUF1), 1 )
      CALL CLOSE( OES1G, CLS )
C*****
C  END OF INITIALIZATION
C*****
 5000 RETURN
C*****
C  ERROR CONDITION ENCOUNTERED.
C*****
 9000 IMSG = -LOGERR
      GO TO 5000
 9001 IMSG = -1
      GO TO 5000
 9002 IMSG = -2
      GO TO 5000
 9003 IMSG = -3
      GO TO 5000
 9008 IMSG = -8
      LCORE = ICRQ
      GO TO 5000
      END

        SUBROUTINE RDBLK ( *, FILE, IFIRST, LEFT )
      INCLUDE 'DSIOF.COM'
      INCLUDE 'XNSTRN.COM'
        INTEGER FILE
        NAME = FILE
        CALL    DSGEFL
C        PRINT *,' RDBLK,NAME,IFILEX,INDBAS=',NAME,IFILEX,INDBAS
C        WRITE(6,40646)(IBASE(INDBAS+K),K=1,8)
40646   FORMAT(' BUFFER=',8(1X,Z8))
        IF ( IPRVOP .NE. 0 ) CALL DSMSG( 4 )
        IF ( IFIRST .NE. 0 ) GO TO 10
        CALL DSRDNB
10      CALL DBMMGR( 9 )
C      WRITE(6,44771)(FCB(K,IFILEX),K=1,15)
44771 FORMAT(' RDBLK,FCB=',/,2(5I8,/),2I8,4X,2A4,4X,I8)
C      INNN = FCB( 12, IFILEX )
C       PRINT *,' RDBLK-2,IFILEX,INNN=',IFILEX,INNN
C       WRITE(6,40646)(IBASE(INNN+K),K=0,7)
        IBASE( INDBAS+1 ) = IBASE( INDBAS+4 )
        IBASE( INDBAS+2 ) = IBASE( INDBAS+4 )
        LEFT = NBUFF + 3 - LCW
        IF ( IBASE( INDBAS+LCW-2) .EQ. IDSEF ) RETURN 1
        RETURN
        END

      SUBROUTINE GINOFL
C
C     ROUTINE FOR GINOFILE MODULE
C
C     MODULE GINOFILE WILL CAPTURE ONE SCRATCH FILE (301 THRU 309) OF
C     PREVIOUS DAMP MODULE, AND MAKE IT A LEGITIMATE GINO FILE.
C     THE SCRATCH FILE CAN BE A TABLE DATA BLOCK OR A MATRIX DATA BLOCK.
C     USE DMAP ALTER TO PLACE THIS MODULE IMMEDIATELY AFTER ANY NASTRAN
C     EXECUTABLE DMAP MODULE WHOSE SCRATCH FILE IS TO BE CAPTURED
C
C     IT IS USER'S RESPONSIBILITY TO SEE THAT NO FIAT TABLE RE-
C     ARRANGEMENT BY MODULE XSFA BETWEEN THIS GINOFILE MODULE AND THE
C     PREVIOUS INTENDED MODULE
C
C     GINOFILE  /OUTFL/C,N,P1/C,N,P2/C,N,P3  $
C
C     INPUT   FILE = NONE
C     OUTPUT  FILE = OUTFL, ANY UNIQUE NAME
C     SCRATCH FILE = 301
C     PARAMETERS   -
C             P1   = SCRATCH FILE NUMBER, 301,302,303,...,309
C                    (NO DEFAULT)
C             P2   = ADDITIONAL NUMBER OF RECORDS IN P1 FILE TO BE
C                    SKIPPED (NOT INCLUDING HEADER RECORD, WHETHER IT
C                    EXISTS OR NOT, DEFAULT = 0)
C             P3   = NO. OF RECORDS TO BE COPIED TO OUTPUT FILE OUTFL,
C                    STARTING FROM THE P2+1 RECORD, OR UP TO EOF RECORD
C                    (DEFAULT JJ=999999)
C
C     THIS GINOFILE MODULE SHOULD BE MAPPED IN ALL LINKS EXCEPT LINK1
C
C     WRITTEN BY G.CHAN/UNISYS, MAY 1988
C     DEFINITELY THIS IS NOT AN ORDINARY JOB FOR AMATEUR OR SEASONNED
C     PROGRAMMERS, MY FRIENDS
C
C     THE TRICKY PART OF THIS PROGRAM IS THAT GINOFILE MODULE USES ONLY
C     ONE OUTPUT FILE AND ONE SCRATCH FILE, WHICH IS 301
C     THE PROBLEMS HERE ARE (1) HOW TO CAPTURE OTHER SCRATCH FILE OF THE
C     PREVIOUS DMAP MODULE, SAY 303, WHILE ONLY 301 IS AVAILABLE. AND
C     (2) HOW TO CAPTURE SCRATCH1 FILE WHILE THE ORIGINAL 301 GINO DATA,
C     SUCH AS TRAILER, UNIT NUMBER, FILE INDEX ETC. ARE GONE. (THE
C     ORIGINAL 301 GINO DATA HAS BEEN ZEROED OUT TO GIVE ROOM FOR THE
C     NEW SCRATCH1 BEING ASSIGNED TO GINOFILE MODULE).
C
      IMPLICIT INTEGER (A-Z)
      LOGICAL          DEBUG
      CHARACTER*6      TBMX,MXTB(2)
      DIMENSION        TRL(7),FN(2),NAME(2),TCHI(9)
      DIMENSION        ITRL(7)
C
      COMMON /PACKX /  ITYPEP, JTYPEP, IROWP, JROWP, INCRP
      COMMON /UNPAKX/  ITYPEU,         IROWU, JROWU, INCRU
      CHARACTER        UFM*23,UWM*25,UIM*29
      COMMON /XMSSG /  UFM,UWM,UIM
      COMMON /SYSTEM/  SYSBUF,NOUT,SKIP(21),ICFIAT
      COMMON /BLANK /  P1,P2,P3
      COMMON /XFIAT /  FIAT(3)
      COMMON /XFIST /  FIST(2)
      COMMON /XSORTX/  SAVE(6)
      COMMON /ZZZZZZ/  Z(1)
      EQUIVALENCE      (SCR,P1)
      DATA    NAME  /  4HGINO,4HFL  /,  SCRA, TCH / 4HSCRA, 4H     /
CWKBR DATA    BLANK /  4H           /,  IZ2 / 2   /,OUTFL  / 201   /
      DATA    IZ2 / 2   /,OUTFL  / 201   /
      DATA    TCHI  /  4HTCH1,4HTCH2 ,  4HTCH3,4HTCH4,4HTCH5,4HTCH6,
     1                 4HTCH7,4HTCH8 ,  4HTCH9    /
      DATA    MXTB  /  'MATRIX'      ,  'TABLE '  /,DEBUG  /.FALSE./
C
C     CHECK SCRATCH FILE PARAMETER
C
      IF (SCR.GT.300 .AND. SCR.LT.400) GO TO 20
      WRITE  (NOUT,10) UWM,SCR
   10 FORMAT (A25,', SCRATCH FILE PARAMETER ERROR. GINOFILE ABORTED AND'
     1,      ' NO OUTPUT GINO FILE CREATED', /5X,'FIRST PARAMETER =',I5)
      GO TO 300
   20 IF (SCR .LT. 310) GO TO 40
      WRITE  (NOUT,30) UFM
   30 FORMAT (A23,', GINOFILE IS PROGRAMMED TO PROCESS ONLY THE FIRST ',
     1       '9 SCRATCH FILES')
      CALL MESAGE (-61,0,0)
C
C     SETUP CORE, BUFFERS, AND GINO OUTPUT FILE NAME
C
   40 KORE  = KORSZ(Z(1))
      IBUF1 = KORE - SYSBUF - 1
      IBUF2 = IBUF1- SYSBUF
      KORE  = IBUF2- 1
      CALL FNAME (OUTFL,FN)
C
C     RECAPTURE SCRATCH FILE NUMBER, TRAILER, AND INDEX POINTER IN FIAT
C     AND FIST
C     NOTE -
C     IT IS HERE THAT SCRATCH FILE IS LIMITED FROM 301 THRU 309
C     SCRATCH FILES 310 AND HIGHER MAY NOT HAVE UNIQUE 8-LETTER NAMES
C     IN ALL COMPUTERS.
C
      INDEX = 0
      K   = FIAT(3)*ICFIAT - 2
      TCH = TCHI(SCR-300)
      DO 50 I = 4,K,ICFIAT
      IF (FIAT(I+1).EQ.SCRA .AND. FIAT(I+2).EQ.TCH) GO TO 70
   50 CONTINUE
      WRITE  (NOUT,60) UFM,SCR
   60 FORMAT (A23,', SCRATCH FILE',I4,' DOES NOT EXIST IN FIAT TABLE. ',
     1       'THIS ERROR MAY DUE TO', /5X,
     2       'USER ERROR, OR GINOFILE WAS PRECEDED BY XSFA MODULE')
      CALL MESAGE (-37,0,NAME)
   70 INDEX = I
      IF (DEBUG) WRITE (6,80) INDEX
   80 FORMAT (5X,'INDEX =',I6)
      IF (SCR .NE. 301) GO TO 90
C
C     IF SCRATCH FILE IS 301, THE TRAILER IN FIAT HAS BEEN INITIALIZED
C     TO ZEROS. MUST RECLAIM THE TRAILER FROM /XSORTX/, SAVED BY WRTTRL
C
C     THE LABEL COMMON /XSORTX/, DEFINED VIA SEMDBD AND AVAILABLE IN ALL
C     LINKS, IS ORIGNALLY USED ONLY BY XSORT2 ROUTINE WHICH WAS EXECUTED
C     IN EARLY LINK1. THUS IT IS SAFE TO SAVE THE SCRATCH 301 TRAILER IN
C     /XSORTX/. NOTE THE OTHER SCARTCH FILES 302 THRU 309 DO NOT HAVE
C     THIS PROBLEM
C
      FIAT(INDEX+ 3) = SAVE(1)
      FIAT(INDEX+ 4) = SAVE(2)
      FIAT(INDEX+ 5) = SAVE(3)
      IF (ICFIAT .EQ. 8) GO TO 90
      FIAT(INDEX+ 8) = SAVE(4)
      FIAT(INDEX+ 9) = SAVE(5)
      FIAT(INDEX+10) = SAVE(6)
C
C     LOCATE 301 IN FIST TABLE AND SWAP FIAT INDEX THAT POINTS TO THE
C     TARGET SCR FILE
C
   90 K = FIST(2)*2+2
      DO 100 I=3,K,2
      IF (FIST(I) .EQ. 301) GO TO 110
  100 CONTINUE
      CALL MESAGE (-37,0,NAME)
  110 FISTI  = I
      FISTI1 = FIST(I+1)
      FIST(I+1) = INDEX-1
      IF (DEBUG) WRITE (6,120) I,FIST(I),FIST(I+1),INDEX
  120 FORMAT (10X,' I,FIST(I),FIST(I+1),INDEX =',4I6)
C
C     NOW, WE CAN READ THE SCRATCH FILE TRAILER
C
      TRL(1) = 301
      CALL RDTRL (TRL(1))
      TRL(1) = SCR
      TBMX = MXTB(2)
      IF (TRL(7) .GT. 0) TBMX = MXTB(1)
      WRITE  (NOUT,130) UIM,TCH,TRL,TBMX,FN
  130 FORMAT (A29,' FROM GINOFILE MODULE', /5X,'TRAILER OF SCRA',A4,
     1       ' FILE IN PREVIOUS MODULE = (',I3,1H),5I5,I8,  /5X,A6,
     2       ' CONTENTS OF THIS FILE WILL BE TRANSFERRED TO GINO FILE ',
     3       2A4,/)
C
C     SWAP SCR AND SCRX (301) FILE
C     OPEN SCRS FILE, AND SKIP P2 RECORDS IF REQUESTED BY USER
C     (DEFAULT SKIP 1 HEADER RECORD IF IT EXISTS)
C
      TRL2  = TRL(2)
      FILE  = SCR
      SCRX  = 301
      CALL OPEN (*260,SCRX,Z(IBUF1),0)
      NWDS = TRL(5)
      IF (NWDS .EQ. 3) NWDS =2
      NWDS = TRL(3)*NWDS
      ITYPEU = TRL(5)
      IROWU  = 1
      JROWU  = TRL(3)
      INCRU  = 1
      ITYPEP = ITYPEU
      JTYPEP = ITYPEU
      IROWP  = 1
      JROWP  = TRL(3)
      INCRP  = 1
      ITRL(1) = OUTFL
      ITRL(2) = 0
      ITRL(3) = TRL(3)
      ITRL(4) = TRL(4)
      ITRL(5) = TRL(5)
      ITRL(6) = 0
      ITRL(7) = 0
      CALL RECTYP (SCRX, IRCTYP)
      IF (IRCTYP .EQ. 0) GO TO 135
      ICRQ = NWDS -KORE
      IF (ICRQ .LE. 0) GO TO 145
      CALL MESAGE (-8, SCRX, NAME)
  135 CALL READ (*250,*140,SCRX,Z,2,1,K)
CWKBR  140 IF (Z(1).NE.SCRA .OR. Z(IZ2).NE.TCH) CALL BCKREC (SCRX,1)
  140 IF (Z(1).NE.SCRA .OR. Z(IZ2).NE.TCH) CALL BCKREC (SCRX)
  145 NCOL = 0
      IF (P3 .LE. 0) P3 = 999999
      IF (P2 .LE. 0) GO TO 160
      DO 150 II=1,P2
  150 CALL FWDREC (*250,SCRX)
C
C     OPEN OUTPUT GINO FILE AND WRITE A HEADER RECORD
C
  160 FILE = OUTFL
      CALL OPEN  (*260,OUTFL,Z(IBUF2),1)
      CALL WRITE (OUTFL,FN,2,1)
  162 CALL RECTYP (SCRX, IRCTYP)
      IF (IRCTYP .EQ. 0) GO TO 170
C
C     PROCESS STRING-FORMATED RECORD HERE
C
      CALL UNPACK (*164, SCRX, Z)
      GO TO 168
  164 DO 166 L = 1, NWDS
      Z(L) = 0
  166 CONTINUE
  168 CALL PACK (Z, OUTFL, ITRL)
      GO TO 185
C
C     COPY SCRATCH FILE DATA DIRECTLY TO OUTPUT FILE
C
  170 CALL READ  (*190,*180,SCRX,Z,KORE,0,K)
      CALL WRITE (OUTFL,Z,KORE,0)
      GO TO 170
  180 CALL WRITE (OUTFL,Z,K,1)
  185 NCOL = NCOL + 1
      IF (NCOL .LT. P3) GO TO 162
C
C     ALL DONE, CLOSE ALL FILES, WRITE TRAILER, AND ISSUE FRIENDLY
C     MESSAGES
C
  190 CALL CLOSE (SCRX ,1)
      CALL CLOSE (OUTFL,1)
      TRL(1) = OUTFL
      TRL(2) = NCOL
      IF (NCOL .GT. ITRL(2)) CALL WRTTRL (TRL)
      IF (NCOL .EQ. ITRL(2)) CALL WRTTRL (ITRL)
      WRITE  (NOUT,200) UIM,TCH,FN
  200 FORMAT (A29,', DATA TRANSFER FROM PREVIOUS SCRA',A4,' FILE TO ',
     1        2A4,' IS ACCOMPLISHED')
      IF (P2 .GT.      0) WRITE (NOUT,210) TCH,P2
      IF (P3 .LT. 999999) WRITE (NOUT,220) P3
  210 FORMAT (5X,'FIRST',I5,' RECORDS IN SCRA',A4,' FILE WERE SKIPPED ',
     1       'BEFORE DATA TRANSFER')
  220 FORMAT (5X,'LAST RECORD COPIED WAS RECORD NO.',I5)
      WRITE  (NOUT,230) FN,TRL
  230 FORMAT (5X,'TRAILER OF THE NEW GINO FILE ',2A4,'  = (',I3,1H),
     1        5I5,I8)
C
C     IF SCRATCH FILE CONTAINS MATRIX DATA, CHECK NO. OF COLUMNS
C
      IF (TBMX.EQ.MXTB(1) .AND. NCOL.NE.TRL2 .AND.
     1   (P2.EQ.0 .AND. P3.EQ.999999)) WRITE (NOUT,240) UIM,TCH,FN
  240 FORMAT (A29,', POSSIBLE ERROR IN GINOFILE WAS DETECTED', /5X,
     1       'NUMBERS OF COLUMNS IN INPUT FILE SCAR',A4,
     2       ' AND OUTPUT FILE ',2A4,' DISAGREE',//)
C
C     RESET FIST ORIGINAL INDEX FOR SCRATCH FILE 301
C
      FIST(FISTI+1) = FISTI1
      GO TO 300
C
C     ERRORS
C
  250 K =-2
      GO TO 270
  260 K = -1
  270 CALL MESAGE (K,FILE,NAME)
C
  300 RETURN
      END

      SUBROUTINE KQDPLT
C
C     THIS ROUTINE GENERATES THE FOLLOWING
C
C     4-6X6 STIFFNESS MATRICES WITH RESPECT TO ONE PIVOT POINT OF A
C     QUADRILATERAL PLATE ELEMENT.
C
C     REF.  FMMS-44   JULY  18, 1967   TRI.BENDING ELEMENT STIFF.
C           FMMS-48   AUGUST 1, 1967   QUAD. BENDING ELEMENT STIFF.
C
C     CALLS FROM THIS ROUTINE ARE MADE TO
C           KTRBSC - BASIC BENDING TRI. ROUTINE.
C           TRANSD - SUPPLIES 3X3 TRANSFORMATIONS
C           SMA1B  - INSERTION ROUTINE
C           GMMATD - GENERAL MATRIX MULITPLY AND TRANSPOSE ROUTINE
C           MESAGE - ERROR MESSAGE WRITER
C
      INTEGER          SUBSCA,SUBSCB,SUBSCC
      DOUBLE PRECISION KOUT,TITE,DPDUM1,TJTE,DPDUM2,IVECT,D1,JVECT,D2,
     1                 KVECT,A1,KSUM,T,XSUBB,V,XSUBC,VV,YSUBC,PROD9,
     2                 TEMP,TEMP9,U1,H,U2,E,A,TEMP18,REQUIV,R
      DIMENSION        M(12),NECPT(100),REQUIV(8),VQ1(3),VQ2(3),VQ3(3),
     1                 VQ4(3),A(1)
      COMMON /CONDAS/  CONSTS(5)
      COMMON /MATIN /  MATID,INFLAG,ELTEMP,STRESS,SINTH,COSTH
      COMMON /MATOUT/  G11,G12,G13,G22,G23,G33,RHO,ALPHA1,ALPHA2,ALP12,
     1                 T SUB 0, G SUB E, SIGTEN, SIGCOM, SIGSHE,
     2                 G2X211, G2X212, G2X222
      COMMON /SMA1IO/  DUM1(10),IFKGG,DUM2(1),IF4GG,DUM3(23)
      COMMON /SMA1CL/  IOPT4,K4GGSW,NPVT,DUMCL(7),LINK(10),IDETCK,DODET,
     1                 NOGO
      COMMON /SMA1ET/  ECPT(100)
      COMMON /SMA1DP/  KOUT(36),TITE(18),TJTE(18),TEMP18(18),DPDUM1(54),
     1                 IVECT(3),JVECT(3),KVECT(3),D1(3),D2(3),A1(3),
     2                 T(9),V(2),VV(2),H,U1,U2,R(2,4),KSUM(36),
     3                 DPDUM2(3),PROD9(9),TEMP9(9),XSUBB,XSUBC,YSUBC,
     4                 E(18),TEMP,SP1(28),SP2(2),KM,NBEGIN,JNOT,NPIVOT,
     5                 THETA,NSUBC,ISING,SUBSCA,SUBSCB,SUBSCC,SINANG,
     6                 COSANG,NPOINT
      EQUIVALENCE      (CONSTS(4),DEGRA),(NECPT(1),ECPT(1)),
     1                 (R(1,1),REQUIV(1)),(VQ1(1),ECPT(15)),
     2                 (VQ2(1),ECPT(19)),(VQ3(1),ECPT(23)),
     3                 (VQ4(1),ECPT(27)),(A(1),KOUT(1))
      DATA     M    /  2,4,1, 3,1,2, 4,2,3, 1,3,4 /
C
C
C     ECPT LISTS AS OF AUGUST 4, 1967
C
C                 DEFINITION                   DEFINITION
C       ECPT      BSC.BEND.TRI.-----TYPE       QUAD.PLT.---------TYPE
C     ******************************************************************
C     ECPT( 1) = ELEMENT ID         INTEGER ** ELEMENT           INTEGER
C     ECPT( 2) = GRID PT. A         INTEGER ** GRID PT.A         INTEGER
C     ECPT( 3) = GRID PT. B         INTEGER ** GRID PT.B         INTEGER
C     ECPT( 4) = GRID PT. C         INTEGER ** GRID PT.C         INTEGER
C     ECPT( 5) = THETA              REAL    ** GRID PT.D         INTEGER
C     ECPT( 6) = MAT ID 1           INTEGER ** THETA             REAL
C     ECPT( 7) = I  MOM. OF INERT.  REAL    ** MAT ID 1          INTEGER
C     ECPT( 8) = MAT ID 2           INTEGER ** I  MOM. OF INERT. REAL
C     ECPT( 9) = T2                 REAL    ** MAT ID 2          INTEGER
C     ECPT(10) = NON-STRUCT. MASS   REAL    ** T2                REAL
C     ECPT(11) = Z1                 REAL    ** NON-STRUCT. MASS  REAL
C     ECPT(12) = Z2                 REAL    ** Z1                REAL
C     ECPT(13) = COORD. SYS. ID 1   INTEGER ** Z2                REAL
C     ECPT(14) = X1                 REAL    ** COORD. SYS. ID 1  INTEGER
C     ECPT(15) = Y1                 REAL    ** X1                REAL
C     ECPT(16) = Z1                 REAL    ** Y1                REAL
C     ECPT(17) = COORD. SYS. ID 2   INTEGER ** Z1                REAL
C     ECPT(18) = X2                 REAL    ** COORD. SYS. ID 2  INTEGER
C     ECPT(19) = Y2                 REAL    ** X2                REAL
C     ECPT(20) = Z2                 REAL    ** Y2                REAL
C     ECPT(21) = COORD. SYS. ID 3   INTEGER ** Z2                REAL
C     ECPT(22) = X3                 REAL    ** COORD. SYS. ID 3  INTEGER
C     ECPT(23) = Y3                 REAL    ** X3                REAL
C     ECPT(24) = Z3                 REAL    ** Y3                REAL
C     ECPT(25) = ELEMENT TEMP       REAL    ** Z3                REAL
C     ECPT(26) =                            ** COORD. SYS. ID 4  INTEGER
C     ECPT(27) =                            ** X4                REAL
C     ECPT(28) =                            ** Y4                REAL
C     ECPT(29) =                            ** Z4                REAL
C     ECPT(30) =                            ** ELEMENT TEMP      REAL
C
C     DETERMINE PIVOT POINT NUMBER
C
      DO 10 I = 1,4
      IF (NPVT .NE. NECPT(I+1)) GO TO 10
      NPIVOT = I
      GO TO 20
   10 CONTINUE
C
C     FALL THRU ABOVE LOOP IMPLIES ERROR CONDITION
C
      CALL MESAGE (-30,34,ECPT(1))
C
   20 THETA  = ECPT(6)*DEGRA
      SINANG = SIN(THETA)
      COSANG = COS(THETA)
C
      IF (NPIVOT-2) 30,30,40
   30 JNOT = NPIVOT + 2
      GO TO 50
   40 JNOT = NPIVOT - 2
C
C     FORMATION OF THE R-MATRIX CONTAINING COORDINATES OF THE
C     SUB TRIANGLES.  (2X4) FOR QUADRILATERAL PLATE...
C     FORMATION ALSO OF THE I,J, AND K VECTORS USED IN THE E-MATRIX.
C
C     ZERO OUT R-MATRIX
C
   50 DO 60 I = 1,8
   60 REQUIV(I) = 0.0D0
C
C     SHIFT ECPT UP TO MATCH KTRBSC FOR CERTAIN VARIABLES.
C
      DO 80 I = 6,12
   80 ECPT(I) = ECPT(I+1)
C
      DO 90 I = 1,3
      D1(I) = DBLE(VQ3(I)) - DBLE(VQ1(I))
      D2(I) = DBLE(VQ4(I)) - DBLE(VQ2(I))
   90 A1(I) = DBLE(VQ2(I)) - DBLE(VQ1(I))
C
C     NON-NORMALIZED K-VECTOR = D1 CROSS D2
C
      KVECT(1) = D1(2)*D2(3) - D2(2)*D1(3)
      KVECT(2) = D1(3)*D2(1) - D2(3)*D1(1)
      KVECT(3) = D1(1)*D2(2) - D2(1)*D1(2)
C
C     NORMALIZE K-VECTOR
C
      TEMP = DSQRT(KVECT(1)**2 + KVECT(2)**2 + KVECT(3)**2)
      IF (TEMP .EQ. 0.0D0) GO TO 330
      DO 100 I = 1,3
  100 KVECT(I) = KVECT(I)/TEMP
C
C     COMPUTE H = (A1 DOT KVECT)/2
C
      TEMP = (A1(1)*KVECT(1) + A1(2)*KVECT(2) + A1(3)*KVECT(3))/2.0D0
C
C     I-VECTOR =(A1) - H*(KVECT)    NON-NORMALIZED
C
      DO 110 I = 1,3
  110 IVECT(I) = A1(I) - TEMP*KVECT(I)
C
C     NORMALIZE I-VECTOR
C
      TEMP = DSQRT(IVECT(1)**2 + IVECT(2)**2 + IVECT(3)**2)
      IF (TEMP .EQ. 0.0D0) GO TO 330
      DO 120 I = 1,3
  120 IVECT(I) = IVECT(I)/TEMP
C
C     J-VECTOR = K CROSS I, AND X3 CALCULATION
C
      JVECT(1) = KVECT(2)*IVECT(3) - IVECT(2)*KVECT(3)
      JVECT(2) = KVECT(3)*IVECT(1) - IVECT(3)*KVECT(1)
      JVECT(3) = KVECT(1)*IVECT(2) - IVECT(1)*KVECT(2)
C
C     NORMALIZE J VECTOR TO MAKE SURE
C
      TEMP = DSQRT(JVECT(1)**2 + JVECT(2)**2 + JVECT(3)**2)
      IF (TEMP .EQ. 0.0D0) GO TO 330
      DO 130 I = 1,3
  130 JVECT(I) = JVECT(I)/TEMP
C
C     X3 GOES INTO R(1,3) = D1 DOT IVECT
C
      R(1,3) = D1(1)*IVECT(1) + D1(2)*IVECT(2) + D1(3)*IVECT(3)
C
C     X2 GOES INTO R(1,2) AND Y3 GOES INTO R(2,3)
C
      R(1,2) = A1(1)*IVECT(1) + A1(2)*IVECT(2) + A1(3)*IVECT(3)
      R(2,3) = D1(1)*JVECT(1) + D1(2)*JVECT(2) + D1(3)*JVECT(3)
C
C     X4 GOES INTO R(1,4) AND Y4 GOES INTO R(2,4)
C
      R(1,4) = D2(1)*IVECT(1) + D2(2)*IVECT(2) + D2(3)*IVECT(3) + R(1,2)
      R(2,4) = D2(1)*JVECT(1) + D2(2)*JVECT(2) + D2(3)*JVECT(3)
C
C     CHECK OF 4 POINTS FOR ANGLE GREATER THAN OR EQUAL TO 180 DEGREES.
C
      IF (R(2,3).LE.0.0D0 .OR. R(2,4).LE.0.0D0) GO TO 140
      TEMP = R(1,2) - (R(1,2) - R(1,3))*R(2,4)/R(2,3)
      IF (R(1,4) .GE. TEMP) GO TO 140
      TEMP = R(2,3)*R(1,4)/R(2,4)
      IF (R(1,3) .GT. TEMP) GO TO 150
  140 CALL MESAGE (30,35,ECPT(1))
C
C     SET FLAG FOR FATAL ERROR WHILE ALLOWING ERROR MESSAGES TO
C     ACCUMULATE
C
      NOGO = 1
      RETURN
C
C 140 AT 140 THE COORDINATES OF THE PLATE IN THE ELEMENT
C     SYSTEM ARE STORED IN THE R-MATRIX WHERE THE COLUMN DENOTES THE
C     POINT AND THE ROW DENOTES THE X OR Y COORDINATE FOR ROW 1 OR
C     ROW 2 RESPECTIVELY.
C
C     ******************************************************************
C
C     SET UP THE M-MATRIX FOR MAPPING TRIANGLES, IN DATA STATEMENT.
C
C     ******************************************************************
C
C     COMPUTE SUB-TRIANGLE COORDINATES
C
C     ZERO OUT KSUM MATRICES
C
  150 DO 160 I = 1,36
  160 KSUM(I) = 0.0D0
      ELTEMP  = ECPT(30)
C
      DO 220 J = 1,4
      IF (J .EQ. JNOT) GO TO 220
      KM = 3*J - 3
      SUBSCA = M(KM+1)
      SUBSCB = M(KM+2)
      SUBSCC = M(KM+3)
C
      DO 170 I = 1,2
      V(I)  = R(I,SUBSCB) - R(I,SUBSCA)
  170 VV(I) = R(I,SUBSCC) - R(I,SUBSCA)
      XSUBB = DSQRT(V(1)**2 + V(2)**2)
      U1    = V(1)/XSUBB
      U2    = V(2)/XSUBB
      XSUBC = U1*VV(1) + U2*VV(2)
      YSUBC = U1*VV(2) - U2*VV(1)
C
      SINTH = SINANG*U1 - COSANG*U2
      COSTH = COSANG*U1 + SINANG*U2
      IF (ABS(SINTH) .LT. 1.0E-06) SINTH = 0.0E0
C
C     AT THIS POINT, XSUBB, XSUBC, YSUBC ARE AT HAND FOR
C     TRIANGLE -J-
C
      CALL KTRBSC (1)
      IF (NOGO .EQ. 1) RETURN
C
C                         U
C     NOW HAVE AT HAND  K    I,J, =1,2,3.   9-3X3 MATRICES STORED AT
C                        IJ                 A(1) THROUGH A(81).
C
C     MAP THE 3 3X3-S FOR THE PIVOT ROW INTO THE SUMMATION ARRAYS...
C
C     SET UP OF T-MATRIX
C
      T(1) = 1.0D0
      T(2) = 0.0D0
      T(3) = 0.0D0
      T(4) = 0.0D0
      T(5) = U1
      T(6) = U2
      T(7) = 0.0D0
      T(8) =-U2
      T(9) = U1
C
C
C     FIND WHICH POINT OF THE SUBTRIANGLE IS ALSO THE PIVOT OF THE
C     QUADRILATERAL...
C
      DO 180 I = 1,3
      NPOINT = KM + I
      IF (M(NPOINT) .NE. NPIVOT) GO TO 180
      NBEGIN = 27*I - 27
      GO TO 190
  180 CONTINUE
C
  190 DO 210 I = 1,3
C
      NPOINT = NBEGIN + 9*I - 8
C
      CALL GMMATD (T,3,3,1, A(NPOINT),3,3,0, TEMP9)
      CALL GMMATD (TEMP9,3,3,0, T,3,3,0, PROD9)
C
C     ADD THIS PRODUCT IN NOW.
C
      NPOINT = KM + I
      NPOINT = 9*M(NPOINT) - 9
      DO 200 K = 1,9
      NPOINT = NPOINT + 1
  200 KSUM(NPOINT) = KSUM(NPOINT) + PROD9(K)/2.0D0
  210 CONTINUE
C
  220 CONTINUE
C
C     FILL E-MATRIX
C
      DO 230 I = 1,18
  230 E( I) = 0.0D0
      E( 1) = KVECT(1)
      E( 4) = KVECT(2)
      E( 7) = KVECT(3)
      E(11) = IVECT(1)
      E(14) = IVECT(2)
      E(17) = IVECT(3)
      E(12) = JVECT(1)
      E(15) = JVECT(2)
      E(18) = JVECT(3)
C
C              T
C     FORM   T   E      STORE IN TITE-MATRIX (6X3)
C             I
      IF (NECPT(4*NPIVOT+10) .EQ. 0) GO TO 240
      CALL TRANSD (NECPT(4*NPIVOT+10),T)
      CALL GMMATD (T,3,3,1, E( 1),3,3,0, TITE( 1))
      CALL GMMATD (T,3,3,1, E(10),3,3,0, TITE(10))
C
      GO TO 260
  240 DO 250 K = 1,18
  250 TITE(K) = E(K)
C
  260 DO 320 J = 1,4
C
C     TRANSFORMATIONS AND INSERTION
C
      IF (NECPT(4*J+10) .EQ. 0) GO TO 270
      CALL TRANSD (NECPT(4*J+10),T)
      CALL GMMATD (T,3,3,1,  E(1),3,3,0, TJTE(1) )
      CALL GMMATD (T,3,3,1, E(10),3,3,0, TJTE(10))
      GO TO 290
  270 DO 280 K = 1,18
  280 TJTE(K) = E(K)
  290 CALL GMMATD (KSUM(9*J-8),3,3,0, TJTE,6,3,1, TEMP18(1))
      CALL GMMATD (TITE(1),6,3,0, TEMP18(1),3,6,0, KOUT(1))
      CALL SMA1B (KOUT(1),NECPT(J+1),-1,IFKGG,0.0D0)
      TEMP = GSUBE
      IF (IOPT4) 300,320,300
  300 IF (GSUBE) 310,320,310
  310 CALL SMA1B (KOUT(1),NECPT(J+1),-1,IF4GG,TEMP)
      K4GGSW = 1
C
  320 CONTINUE
      RETURN
C
  330 CALL MESAGE (30,26,ECPT(1))
C
C     SET FLAG FOR FATAL ERROR WHILE ALLOWING ERROR MESSAGES TO
C     ACCUMULATE
C
      NOGO = 1
      RETURN
      END

      SUBROUTINE SAXIF2 (IOPT,IPART,BRANCH,EIGEN)
C
C     THIS ROUTINE CALCULATES FLUID VELOCITIES DUE TO HARMONIC
C     PRESSURES IN AN AXISYMMETRIC FLUID
C
C     THE OPTIONS FOR IOPT ARE
C         IOPT    ELEMENT
C           0     CAXIF2
C           1     CAXIF3
C           2     CAXIF4
C     IPART-  FIRST = 1,   SECOND = 2
C     BRANCH-  SDR2 PROCESS CODE WORD
C
      INTEGER         SIL       ,BRANCH
      DIMENSION       EIGEN(3)
      COMMON /CONDAS/ CONSTS(5)
      COMMON /ZZZZZZ/ ZZ(1)
      COMMON /SDR2X4/ DUMY(35)  ,IVEC
      COMMON /SDR2X7/ IDE       ,SIL(4)   ,SV(95)    ,ID1      ,
     1                VELR(11)  ,ID2      ,VELI(11)
      EQUIVALENCE     (CONSTS(2),TWOPI)
C
C
      IF (IPART .EQ. 2) GO TO 20
      DO 10 I = 1,11
      VELR(I) = 0.0
   10 VELI(I) = 0.0
   20 X = 1.0
      Y = 0.0
      IF (BRANCH .EQ. 2) X = SQRT(ABS(EIGEN(2)))
      IF (BRANCH .EQ. 5) X = TWOPI*EIGEN(1)
      IF (X .NE. 0.0) X = 1.0/X
      IF (BRANCH .NE. 9) GO TO 30
      EM = EIGEN(2)**2 + EIGEN(3)**2
      IF (EM .EQ. 0.0) GO TO 30
      X = EIGEN(2)/EM
      Y =-EIGEN(3)/EM
   30 IF (IPART .NE. 2) GO TO 40
      EM = X
      X  =-Y
      Y  = EM
   40 ID1= IDE
      ID2= IDE
      KC = IOPT + 2
      KR = 3 + 2*KC
      IF (IOPT .EQ. 0) KR = 6
      DO 80 I = 1,KC
      K = IVEC + SIL(I) - 1
      IF (X .EQ. 0.0) GO TO 65
C
      DO 60 J = 1,KR
      IJ = KC*(J-1) + I
      VELR(J) = SV(IJ)*ZZ(K)*X + VELR(J)
   60 CONTINUE
   65 CONTINUE
      IF (Y .EQ. 0.0) GO TO 80
C
      DO 70 J = 1,KR
      IJ = KC*(J-1) + I
      VELI(J) = SV(IJ)*ZZ(K)*Y + VELI(J)
   70 CONTINUE
   80 CONTINUE
      RETURN
      END

      SUBROUTINE XFLORD
C
C     THE PURPOSE OF THIS ROUTINE IS TO COMPUTE THE LTU (LAST TIME USED)
C     VALUE AND THE NTU (NEXT TIME USED) VALUE FOR THE INPUT AND OUTPUT
C     FILE SECTIONS OF THE OSCAR ENTRIES.
C
C          ... DESCRIPTION OF PROGRAM VARIABLES ...
C     LPTOP  = POINTER/SEQUENCE NUMBER OF FIRST ENTRY IN A DMAP LOOP.
C     LPBOT  = LAST ENTRY IN A LOOP.
C     IOPNT  = POINTER TO FILE NAME IN I/O SECTION OF OSCAR ENTRY.
C     LPORD  = POINTER TO IORDNL TABLE ENTRY CORRESPONDING TO LPTOP.
C     IORDNO = FILE ORDINAL NUMBER
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        LSHIFT,RSHIFT,ANDF,ORF,COMPLF
      DIMENSION       PTDIC(1),XNAM(12),ITMP(1),IORDNL(1800),ICPDPL(1),
     1                OSCAR(2),OS(5)
      COMMON /SYSTEM/ BUFSZ,OPTAPE,NOGO,DUM1(20),ICFIAT,DUM2(57),ICPFLG
      COMMON /XGPI4 / IRTURN,INSERT,ISEQN,DMPCNT,
     1                IDMPNT,DMPPNT,BCDCNT,LENGTH,ICRDTP,ICHAR,NEWCRD,
     2                MODIDX,LDMAP,ISAVDW,DMAP(1)
      COMMON /XGPIC / ICOLD,ISLSH,IEQUL,NBLANK,NXEQUI,
     1                NDIAG,NSOL,NDMAP,NESTM1,NESTM2,NEXIT,
     2                NBEGIN,NEND,NJUMP,NCOND,NREPT,NTIME,NSAVE,NOUTPT,
     3                NCHKPT,NPURGE,NEQUIV,
     4                NCPW,NBPC,NWPC,
     5                MASKHI,MASKLO,ISGNON,NOSGN,IALLON,MASKS(1)
      COMMON /ZZZZZZ/ CORE(1)
      COMMON /XGPI2 / LMPL,MPLPNT,MPL(1)
      COMMON /XDPL  / DPL(3)
      COMMON /XGPI5 / IAPP,START,ALTER(2),SOL,SUBSET,IFLAG,
     1                IESTIM,ICFTOP,ICFPNT,LCTLFL,ICTLFL(1)
      COMMON /XGPI6 / MEDTP,DUM5(5),DIAG14
      COMMON /XGPI7 / FPNT,LFILE,FILE(1)
      COMMON /XGPI8 / ICPTOP,ICPBOT,LCPDPL
      COMMON /XFIAT / IFIAT(3)
      COMMON /XFIST / IFIST(1)
      COMMON /XGPID / ICST,IUNST,IMST,IHAPP,IDSAPP,IDMAPP,
     1                ISAVE,ITAPE,IAPPND,INTGR,LOSGN,NOFLGS
      COMMON /XOLDPT/ PTDTOP,PTDBOT,LPTDIC,NRLFL,SEQNO
      COMMON /TWO   / TWO(4)
      EQUIVALENCE     (CORE(1),LOSCAR  , OS(1)),
     1                (OSPRC  ,OS(2)  ), (OSBOT   ,OS(3)),
     2                (OSPNT  ,OS(4)  ), (OSCAR(1),OS(5),PTDIC(1)),
     3                (DMAP(1),ITMP(1)), (OSCAR(1),ICPDPL(1)),
     4                (LMPL   ,LORDNL ), (MPLPNT,IORBOT),
     5                (DPL(1) ,NDPFIL ), (DPL(2),MAXDPL),
     6                (DPL(3) ,LSTDPL ), (TWO(4),REUSE )
      DATA    NORDN1/ 4HIORD/,  NORDN2/ 4HNL  /,
     1        NXVPS / 4HXVPS/,  NCPDP1/ 4HICPD/, NCPDP2/4HPL  /,
     2        XNAM  / 4HXTIM ,  4HE   , 4HXSAV , 4HE   ,
     3                4HXUOP ,  4H    , 4HXCHK , 4H    ,
     4                4HXPUR ,  4HGE  , 4HXEQU , 4HIV  /
      DATA    NTHPAS/ 0     /,  DLYERR/ 0     /
C
      OR(I,J)  = ORF(I,J)
      AND(I,J) = ANDF(I,J)
      COMPL(L) = COMPLF(L)
C
C     USE AREA IN OPEN CORE BETWEEN PTDIC AND MED ARRAYS FOR STORING
C     MISSING FILE DATA
C
      IFLAG  = 0
      ICPTOP = PTDBOT + 3
      ICPBOT = ICPTOP - 3
      LCPDPL = MEDTP  - ICPTOP
      IF (START .EQ. IMST) DLYERR = 1
      IRENTR = AND(MASKHI,SEQNO)
      IDMPCT = RSHIFT(SEQNO,16)
C
C     PREPARE FOR NTH PASS THRU OSCAR
C     *******************************
C
   10 IF (NOGO .GT. 1) GO TO 960
      OSPNT = 1
      OSPRC = OSPNT
      IORBOT= 0
      IFEQ  = 0
C
C     INCREMENT NUMBER OF PASSES MADE THRU OSCAR
C
      NTHPAS = 1 + NTHPAS
C
C     ENTER DPL FILE NAMES IN IORDNL TABLE
C
      I = LSTDPL*3 + 1
      IDPL = I
      IF (LSTDPL .EQ. 0) GO TO 30
      DO 20 K = 4,I,3
      IORBOT = IORBOT + 4
      IORDNL(IORBOT  ) = DPL(K  )
      IORDNL(IORBOT+1) = DPL(K+1)
      IORDNL(IORBOT+2) = 0
   20 IORDNL(IORBOT+3) = 0
C
C     ENTER FIAT NAMES IN IORDNL TABLE
C
   30 I = IFIAT(3)*ICFIAT - 2
      DO 40 K = 4,I,ICFIAT
      IF (IFIAT(K+1) .EQ. 0) GO TO 40
      IORBOT = IORBOT + 4
      IFIAT(K) = OR(LSHIFT(IORBOT,16),AND(IFIAT(K),ORF(MASKHI,LOSGN)))
      IORDNL(IORBOT  ) = IFIAT(K+1)
      IORDNL(IORBOT+1) = IFIAT(K+2)
      IORDNL(IORBOT+2) = 0
      IORDNL(IORBOT+3) = 0
   40 CONTINUE
C
C     FOR UNMODIFIED RESTART BEGIN OSCAR PROCESSING AT RE-ENTRY POINT IF
C     THIS IS FIRST PASS THRU OSCAR
C
      IF (NTHPAS .GT. 1) GO TO 60
      IF (START.NE.IUNST . OR. IRENTR.EQ.0) GO TO 60
      DO 50 J = 1,IRENTR
      IF (OSCAR(OSPNT+1) .GE. IRENTR) GO TO 60
      OSPRC = OSPNT
      OSPNT = OSPNT + OSCAR(OSPNT)
   50 CONTINUE
C
C     GET NEXT OSCAR ENTRY
C     ********************
C
C     BRANCH ON OSCAR ENTRY TYPE IF EXECUTE FLAG IS UP
C
   60 IF (OSCAR(OSPNT+5) .GE. 0) GO TO 70
      I = AND(OSCAR(OSPNT+2),MASKHI)
      LSTBOT = IORBOT
      GO TO (310,390,520,80), I
C
C     GET NEXT OSCAR ENTRY
C
   70 IF (OSPNT .GE. OSBOT) GO TO 650
      IF (OSCAR(OSPNT+5).LT.0 .AND. AND(OSCAR(OSPNT+2),MASKHI).LE.2)
     1    OSPRC = OSPNT
      OSPNT = OSPNT + OSCAR(OSPNT)
      GO TO 60
C
C     PROCESS TYPE E OSCAR ENTRY
C     **************************
C
C     BRANCH ON NAME
C
   80 DO 90 I = 1,11,2
      IF (OSCAR(OSPNT+3) .NE. XNAM(I)) GO TO 90
      J = (I+1)/2
      GO TO (70,70,100,100,70,190), J
   90 CONTINUE
C
C     ENTRY IS XUOP OR XCHK - MAKE SURE FILES HAVE BEEN DEFINED OR
C     PREPURGED.
C
  100 I1 = OSPNT + 7
      I2 = OSCAR(OSPNT+6)*2 + I1 - 2
      IOPNT = I1
  110 IF (IORBOT .LE. 0) GO TO 130
      DO 120 J = 4,IORBOT,4
      IF (OSCAR(IOPNT).NE.IORDNL(J) .OR. OSCAR(IOPNT+1).NE.IORDNL(J+1))
     1    GO TO 120
      IF (START.NE.IUNST .OR. J.GT.IDPL) GO TO 170
      NNFIND = -1
      CALL XFLDEF (OSCAR(IOPNT),OSCAR(IOPNT+1),NNFIND)
      GO TO 170
  120 CONTINUE
C
C     FILE NOT IN ORDNAL TABLE - SEE IF IT IS IN PREVIOUS PURGE OR
C     EQUIV ENTRY
C
  130 K1 = 2
      K1 = OSCAR(K1)
      K2 = OSCAR(OSPNT+1) - 1
      KK = 1
      DO 160 K = K1,K2
      IF (OSCAR(KK+3).NE.XNAM(9) .AND. OSCAR(KK+3).NE.XNAM(11))
     1    GO TO 160
C
C     PURGE OR EQUIV ENTRY FOUND - SEARCH FOR FILE NAME MATCH
C
      L1 = KK + 7
      L3 = KK + OSCAR(KK)
C
C     GET FIRST/NEXT FILE LIST
C
  140 L2 = OSCAR(L1-1)*2 + L1 - 2
      INCRLP = 2
      IF (OSCAR(KK+3) .NE. XNAM(11)) GO TO 145
      L2 = L2 + 1
      INCRLP = 3
  145 CONTINUE
      DO 150 L = L1,L2,INCRLP
      IF (OSCAR(L).EQ.OSCAR(IOPNT) .AND. OSCAR(L+1).EQ.OSCAR(IOPNT+1))
     1    GO TO 180
      IF (L .EQ. L1+INCRLP) GO TO 153
  150 CONTINUE
      GO TO 159
  153 L4 = L1 + INCRLP
      INCRLP = 2
      L4 = L4 + INCRLP
      DO 155 L = L4,L2,INCRLP
      IF (OSCAR(L).EQ.OSCAR(IOPNT) .AND. OSCAR(L+1).EQ.OSCAR(IOPNT+1))
     1    GO TO 180
  155 CONTINUE
  159 L1 = L2 + 4
      IF (L1 .LT. L3) GO TO 140
  160 KK = OSCAR(KK) + KK
C
C     FILE IS NOT PURGED OR DEFINED - SEE IF IT IS ON PROBLEM TAPE
C
      NOFIND = -1
      GO TO 450
C
C     FILE IS IN ORDNAL TABLE - ENTER RANGE
C
  170 IF (IORDNL(J+3)) 180,175,175
  175 IORDNL(J+3) = LSHIFT(OSCAR(OSPNT+1),16)
  180 IOPNT = IOPNT + 2
      IF (IOPNT .LE. I2) GO TO 110
      GO TO 70
C
C     PROCESS EQUIV INSTRUCTION
C
  190 L1 = OSPNT + 7
      NWDH = OSCAR(OSPNT) - 6
  230 NDATAB = OSCAR(L1-1)
      IPRIME = 0
      DO 195 KHR = 1,NDATAB
C
C     CHECK FOR DATA BLOCK IN IORDNL
C
      IF (IORBOT .LE. 0) GO TO 200
      DO 205 I = 4,IORBOT,4
      IF (IORDNL(I).NE.OSCAR(L1) .OR. IORDNL(I+1).NE.OSCAR(L1+1))
     1    GO TO 205
      IF (START.NE.IUNST .OR. I.GT.IDPL) GO TO 210
      NNFIND = -1
      CALL XFLDEF (OSCAR(L1),OSCAR(L1+1),NNFIND)
      GO TO 210
  205 CONTINUE
C
C     FILE NOT IN IORDNL, SEE IF ON PTDIC OR REGEN
C
  200 IF (START.EQ.ICST .OR. IPRIME.NE.0) GO TO 220
      NOFIND = 1
      CALL XFLDEF (OSCAR(L1),OSCAR(L1+1),NOFIND)
      IF (NOFIND) 10,215,220
  220 IF (DLYERR.NE.0 .OR. IPRIME.NE.0) GO TO 215
C
C     PRIMARY EQUIV FILE NOT DEFINED
C
      CALL XGPIDG (32,OSPNT,OSCAR(L1),OSCAR(L1+1))
      GO TO 210
C
C     PUT FILE IN IORDNL, FLAG FOURTH WORD FOR EQUIV
C
  215 IORBOT = IORBOT + 4
      IF (IORBOT - LORDNL) 225,780,780
  225 IORDNL(IORBOT  ) = OSCAR(L1)
      IORDNL(IORBOT+1) = OSCAR(L1+1)
      IORDNL(IORBOT+2) = 0
      IORDNL(IORBOT+3) = ISGNON
  210 IF (IPRIME .NE. 0) GO TO 211
      LSTUSE = AND(MASKHI,IORDNL(I+2))
      IF (LSTUSE .EQ. 0) GO TO 212
      NTU = OR(OSCAR(OSPNT+1),AND(IORDNL(I+2),ITAPE))
      OSCAR(LSTUSE) = OR(AND(OSCAR(LSTUSE),MASKLO),NTU)
  212 IORDNL(I+2) = OR(OSCAR(L1+2),AND(IORDNL(I+2),ITAPE))
      IORDNL(I+3) = LSHIFT(OSCAR(OSPNT+1),16)
      OSCAR(L1+2) = OR(AND(OSCAR(L1+2),MASKHI),LSHIFT(I,16))
  211 L1 = L1 + 2
      IF (IPRIME .EQ. 0) L1 = L1 + 1
      IPRIME = 1
  195 CONTINUE
      NWDH = NWDH - 2*NDATAB - 3
      IF (NWDH .LE. 0) GO TO 70
      L1 = L1 + 2
      GO TO 230
C
C     PROCESS TYPE F OSCAR ENTRY
C     **************************
C
C     SCAN OSCAR OUTPUT FILE SECTION,ENTER NAMES IN IORDNL TABLE.
C
  310 K = OSPNT + 6
      K = OSCAR(K)*3   + 2 + K
      I = OSCAR(K-1)*3 - 3 + K
      IOPNT = K
      ASSIGN 380 TO IRTURN
C
C     GET FIRST/NEXT FILE NAME FROM OSCAR
C
  320 IF (OSCAR(IOPNT) .EQ. 0) GO TO 380
C
C     SEE IF FILE NAME IS ALREADY IN ORDNAL TABLE
C
      IF (IORBOT .LE. 0) GO TO 340
      DO 330 K = 4,IORBOT,4
      IF (IORDNL(K).NE.OSCAR(IOPNT) .OR. IORDNL(K+1).NE.OSCAR(IOPNT+1))
     1    GO TO 330
      IF (START.NE.IUNST .OR. K.GT.IDPL) GO TO 345
      NNFIND = -1
      CALL XFLDEF (OSCAR(IOPNT),OSCAR(IOPNT+1),NNFIND)
      GO TO 345
  330 CONTINUE
      GO TO 340
  345 IF (IORDNL(K+3)) 346,820,820
  346 KXT = K
      GO TO 347
C
C     INCREMENT TO NEXT ORDNAL ENTRY AND ENTER FILE NAME AND LU POINTER.
C
  340 IORBOT = IORBOT + 4
      IF (IORBOT - LORDNL) 350,780,780
  350 IORDNL(IORBOT  ) = OSCAR(IOPNT  )
      IORDNL(IORBOT+1) = OSCAR(IOPNT+1)
C
C     SEE IF TAPE FLAG IS SET FOR THIS FILE
C
      KXT = IORBOT
  347 LSTUSE = IOPNT + 2
      IF (AND(OSCAR(OSPNT+2),MASKHI) .GT. 2) LSTUSE=0
      IF (FPNT .LT. 1) GO TO 370
      DO 360 K = 1,FPNT,3
      IF (OSCAR(IOPNT).EQ.FILE(K) .AND. OSCAR(IOPNT+1).EQ.FILE(K+1))
     1    LSTUSE = OR(LSTUSE,AND(FILE(K+2),ITAPE))
  360 CONTINUE
  370 IORDNL(KXT+2) = LSTUSE
      IORDNL(KXT+3) = LSHIFT(OSCAR(OSPNT+1),16)
C
C     IORDNL POINTER  TO OSCAR IF TYPE F OR O FORMAT
C
      IF (AND(OSCAR(OSPNT+2),MASKHI) .LE. 2)
     1    OSCAR(IOPNT+2) = OR(LSHIFT(KXT,16),AND(OSCAR(IOPNT+2),MASKHI))
      GO TO IRTURN, (380,510)
C
C     O/P FILE PROCESSED  -  INCREMENT TO NEXT O/P FILE
C
  380 IOPNT = IOPNT + 3
      IF (IOPNT .LE. I) GO TO 320
C
C     OUTPUT SECTION SCANNED, NOW SCAN INPUT FILE SECTION OF OSCAR.
C
C     PROCESS TYPE F OR O OSCAR ENTRY
C     *******************************
C
C     SCAN OSCAR INPUT FILE SECTION,ENTER RANGES IN IORDNL TABLE.
C
  390 K = OSPNT + 7
      I = OSCAR(K-1)*3 -3 + K
      IOPNT = K
C
C     GET FIRST/NEXT FILE NAME FROM OSCAR
C
  400 IF (OSCAR(IOPNT) .EQ. 0) GO TO 510
      NOFIND = 1
      ASSIGN 510 TO IRTURN
C
C     NOW SCAN IORDNAL TABLE FOR FILE NAME
C
      J1 = LSTBOT
      IF (J1 .LE. 0) GO TO 440
      DO 410 J = 4,J1,4
      IF (OSCAR(IOPNT).NE.IORDNL(J) .OR. OSCAR(IOPNT+1).NE.IORDNL(J+1))
     1    GO TO 410
      IF (START.NE.IUNST .OR. J.GT.IDPL) GO TO 420
      NNFIND = -1
      CALL XFLDEF (OSCAR(IOPNT),OSCAR(IOPNT+1),NNFIND)
      GO TO 420
  410 CONTINUE
      GO TO 440
C
C     FOUND FILE IN IORDNL TABLE - ENTER NTU AND TAPE FLAG INTO
C     OSCAR ENTRY POINTED TO BY IORDNL ENTRY
C
  420 LSTUSE = AND(MASKHI,IORDNL(J+2))
      IF (LSTUSE .EQ. 0) GO TO 430
      NTU = OR(OSCAR(OSPNT+1),AND(IORDNL(J+2),ITAPE))
      OSCAR(LSTUSE) = OR(AND(OSCAR(LSTUSE),MASKLO),NTU)
C
C     SET RANGE AND LASTUSE POINTER IN IORDNAL ENTRY
C
  430 NOFIND = -1
      IORDNL(J+2) = OR(IOPNT+2,AND(IORDNL(J+2),ITAPE))
      IORDNL(J+3) = LSHIFT(OSCAR(OSPNT+1),16)
C
C     LINK OSCAR I/P FILE TO IORDNL ENTRY
C
      OSCAR(IOPNT+2) = OR(AND(OSCAR(IOPNT+2),MASKHI),LSHIFT(J,16))
C
C     I/P FILE PROCESSED - MAKE SURE IT WAS DEFINED
C
  440 IF (NOFIND) 510,450,450
C
C     I/P FILE NOT DEFINED
C
  450 IF (START .EQ. ICOLD) GO TO 470
C
C     RESTART - SEE IF FILE IS ON PROBLEM TAPE OR CAN BE REGENERATED
C     BY RE-EXECUTING SOME MODULES.
C
      CALL XFLDEF (OSCAR(IOPNT),OSCAR(IOPNT+1),NOFIND)
      IF (NOFIND) 10,500,470
C
C     ERROR - FILE NOT DEFINED(PUT OUT MESSAGE AT END OF XFLORD)
C     SEE IF FILE IS ALREADY IN ICPDPL TABLE
C
  470 IF (DLYERR .NE.      0) GO TO 500
      IF (ICPBOT .LT. ICPTOP) GO TO 490
      DO 480 L = ICPTOP,ICPBOT,3
      IF (OSCAR(IOPNT).EQ.ICPDPL(L) .AND. OSCAR(IOPNT+1).EQ.ICPDPL(L+1))
     1    GO TO 500
  480 CONTINUE
C
C     ENTER FILE IN ICPDPL TABLE
C
  490 ICPBOT = ICPBOT + 3
      IF (ICPBOT+3-ICPTOP .GT. LCPDPL) GO TO 830
      ICPDPL(ICPBOT  ) = OSCAR(IOPNT  )
      ICPDPL(ICPBOT+1) = OSCAR(IOPNT+1)
      ICPDPL(ICPBOT+2) = -OSPNT
C
C     ENTER FILE IN ORDNAL TABLE IF NOT CHKPNT MODULE
C
  500 IF (OSCAR(OSPNT+3) .NE. XNAM(7)) GO TO 340
      GO TO 180
C
C     CHECK FOR ANOTHER I/P FILE
C
  510 IOPNT = IOPNT + 3
      IF (IOPNT .LE. I) GO TO 400
C
C     INPUT FILE SECTION SCANNED,GET NEXT OSCAR ENTRY.
C
      GO TO 70
C
C     PROCESS TYPE C OSCAR ENTRY
C     **************************
C
C     CHECK FOR LOOPING
C
  520 LPTOP = RSHIFT(OSCAR(OSPNT+6),16)
      IF ((NEXIT.EQ.OSCAR(OSPNT+3)) .OR. (OSCAR(OSPNT+1).LT.LPTOP))
     1     GO TO 70
C
C     FIND BEGINNING OF LOOP AND ADJUST IORDNL RANGES INSIDE LOOP.
C
      LPBOT = OSPNT
      I     = OSCAR(OSPNT+1)
      OSPNT = 1
      J1    = OSCAR(OSPNT+1)
      DO 530 J = J1,I
      IF (OSCAR(OSPNT+1) .EQ. LPTOP) GO TO 540
  530 OSPNT = OSCAR(OSPNT) + OSPNT
  540 LPTOP = OSPNT
C
C     LOOP TOP FOUND - IF UNMODIFIED RESTART,EXECUTE ALL MODULES INSIDE
C     LOOP.
C
      IF (OSCAR(LPTOP+5).LT.0 .OR. START.NE.IUNST) GO TO 570
C
C     MAKE SURE FIRST INSTRUCTION IN LOOP IS NOT CHKPNT
C
      IF (OSCAR(LPTOP+3).EQ.XNAM(7) .AND. OSCAR(LPTOP+4).EQ.XNAM(8))
     1    GO TO 790
C
C     EXECUTE FLAGS NOT ALL SET - SET FLAGS AND BEGIN OSCAR SCAN AGAIN
C
  550 J1 = OSCAR(LPTOP+1)
      DO 560 J = J1,I
      IF (OSCAR(OSPNT+3).EQ.XNAM(7) .AND. OSCAR(OSPNT+4).EQ.XNAM(8)
     1   .AND. ICPFLG.EQ.0) GO TO 560
      IF (OSCAR(OSPNT+5) .LT. 0) GO TO 560
      IF (IFLAG .EQ. 1) GO TO 5510
      IFLAG = 1
      CALL PAGE1
      CALL XGPIMW (11,IDMPCT,0,0)
 5510 CALL XGPIMW (4,0,0,OSCAR(OSPNT))
      OSCAR(OSPNT+5) = OR(ISGNON,OSCAR(OSPNT+5))
  560 OSPNT = OSCAR(OSPNT) + OSPNT
      GO TO 10
C
C     EXTEND RANGE OF FILES DEFINED OUTSIDE OF LOOP IF USED INSIDE LOOP
C     GET FIRST/NEXT OSCAR ENTRY INSIDE LOOP
C
  570 OSPNT = LPTOP
      J1 = OSCAR(LPTOP+1)
      J2 = OSCAR(LPBOT+1)
      DO 640 J = J1,J2
      IF (AND(OSCAR(OSPNT+2),MASKHI) .GT. 2) GO TO 640
C
C     GET FIRST/NEXT I/P FILE OF OSCAR ENTRY
C
      K1 = OSPNT + 7
      K2 = OSCAR(K1-1)*3 - 3 + K1
      DO 630 K = K1,K2,3
      IF (OSCAR(K) .EQ. 0) GO TO 630
C
C     SEE IF FILE SAVE IS ON
C
      IF (FPNT .LT. 1) GO TO 590
      DO 580 L = 1,FPNT,3
      IF (OSCAR(K).NE.FILE(L) .OR. OSCAR(K+1).NE.FILE(L+1)) GO TO 580
      IF (AND(ISAVE,FILE(L+2)) .EQ. ISAVE) GO TO 620
      GO TO 590
  580 CONTINUE
C
C     FILE SAVE FLAG NOT ON - SEE IF I/P FILE IS GENERATED INSIDE LOOP
C
  590 L1 = OSCAR(OSPNT+1)
C
C     GET FIRST/NEXT OSCAR ENTRY INSIDE LOOP
C
      N = LPTOP
      DO 610 L = J1,L1
      IF (AND(OSCAR(N+2),MASKHI).NE.1 .OR. OSCAR(N+5).GE.0) GO TO 610
C
C     GET FIRST/NEXT O/P FILE
C
      M1 = OSCAR(N +6)*3 + N + 8
      M2 = OSCAR(M1-1)*3 - 3 + M1
      DO 600 M = M1,M2,3
      IF (OSCAR(M) .EQ. 0) GO TO 600
      IF (OSCAR(M).EQ.OSCAR(K) .AND. OSCAR(M+1).EQ.OSCAR(K+1))
     1    GO TO 630
  600 CONTINUE
  610 N = OSCAR(N) + N
C
C     EXTEND I/P FILE RANGE TO END OF LOOP
C
  620 N = RSHIFT(OSCAR(K+2),16)
      IORDNL(N+3) = LSHIFT(I,16)
  630 CONTINUE
      IF (START .NE. IUNST) GO TO 640
C
C     FOR UNMODIFIED RESTART, MARK ALL OUTPUT FILES WITHIN THE
C     LOOP AND BEFORE THE RE-ENTRY POINT FOR REUSE
C
      KK1 = K1
      IF (OSCAR(KK1-6) .GE. IRENTR) GO TO 640
      IF (AND(OSCAR(KK1-5),MASKHI) .NE. 1) GO TO 640
      K1 = K2 + 4
      K2 = 3*OSCAR(K1-1) - 3 + K1
      DO 635 K = K1,K2,3
      IF (OSCAR(K) .EQ. 0) GO TO 635
      NOFIND = -1
      CALL XFLDEF (OSCAR(K),OSCAR(K+1),NOFIND)
  635 CONTINUE
  640 OSPNT = OSCAR(OSPNT) + OSPNT
C
C     LOOP SCANNED, GET NEXT OSCAR ENTRY AFTER LOOP ENTRIES
C
      OSPNT = LPBOT
      GO TO 70
C
C     OSCAR HAS BEEN PROCESSED
C     ************************
C
  650 IF (DLYERR .EQ. 0) GO TO 653
      DLYERR = 0
      GO TO 10
C
C     SET  NTU = LTU FOR LAST REFERENCE TO EACH FILE IN OSCAR.
C
  653 DO 660 I = 4,IORBOT,4
      LSTUSE = AND(IORDNL(I+2),MASKHI)
      IF (LSTUSE .EQ. 0) GO TO 660
      NTU = OR(AND(ITAPE,IORDNL(I+2)),RSHIFT(IORDNL(I+3),16))
      OSCAR(LSTUSE) = OR(NTU,AND(OSCAR(LSTUSE),MASKLO))
  660 CONTINUE
C
C     SEARCH FILE TABLE FOR FILES WITH APPEND OR SAVE FLAG UP
C
      IF (FPNT .LT. 1) GO TO 690
      DO 680 J = 1,FPNT,3
      IF (AND(FILE(J+2),IAPPND).EQ.0 .AND. AND(FILE(J+2),ISAVE).EQ.0)
     1    GO TO 680
C
C     FOR RESTART, MARK APPEND AND SAVE FILES FOR REUSE
C
      NOFIND = -1
      CALL XFLDEF (FILE(J),FILE(J+1),NOFIND)
      IF (AND(FILE(J+2),ISAVE) .NE. 0) GO TO 680
C
C     APPEND FLAG SET - FIND CORRESPONDING IORDNL ENTRY AND SET FLAG
C
      DO 670 I = 4,IORBOT,4
      IF (IORDNL(I).EQ.FILE(J) .AND. IORDNL(I+1).EQ.FILE(J+1))
     1    IORDNL(I+3) = OR(IAPPND,IORDNL(I+3))
  670 CONTINUE
  680 CONTINUE
C
C     STORE LTU IN OSCAR FILE ENTRIES
C
  690 OSPNT = 1
  700 IF (OSCAR(OSPNT+5).GE.0 .OR. AND(OSCAR(OSPNT+2),MASKHI).GT.2)
     1    GO TO 730
      K = OSPNT + 7
      J = 1
      IF (AND(OSCAR(OSPNT+2),MASKHI) .EQ. 1) J = 2
      DO 720 L = 1,J
C
      I = OSCAR(K-1)*3 - 3 + K
      DO 710 IOPNT = K,I,3
      IF (OSCAR(IOPNT) .EQ. 0) GO TO 710
      J1  = RSHIFT(OSCAR(IOPNT+2),16)
      LTU = AND(OSCAR(IOPNT+2),OR(LOSGN,MASKHI))
      OSCAR(IOPNT+2) = OR(LTU,IORDNL(J1+3))
  710 CONTINUE
  720 K  = I + 4
  730 IF (OSCAR(OSPNT+3) .NE. XNAM(11)) GO TO 735
      I  = OSCAR(OSPNT) - 6
      K  = OSPNT + 7
  733 J1 = RSHIFT(OSCAR(K+2),16)
      LTU= AND(OSCAR(K+2),OR(LOSGN,MASKHI))
      OSCAR(K+2) = OR(LTU,IORDNL(J1+3))
      I  = I - 2*OSCAR(K-1) - 3
      IF (I .LE. 0) GO TO 735
      K  = K + 2*OSCAR(K-1) + 3
      GO TO 733
  735 OSPNT = OSPNT + OSCAR(OSPNT)
      IF (OSPNT - OSBOT) 700,700,740
C
C     STORE LTU IN FIAT ENTRIES
C
  740 I = IFIAT(3)*ICFIAT - 2
      DO 770 K = 4,I,ICFIAT
      IF (IFIAT(K+1) .EQ. 0) GO TO 770
      J = RSHIFT(AND(IFIAT(K),MASKLO),16)
C
C     SEE IF FILE HAS BEEN REFERENCED
C
      IF (AND(IORDNL(J+3),COMPL(IAPPND)) .NE. 0) GO TO 760
C
C     FILE NOT USED - DROP IT FROM FIAT
C
      IFIAT(K) = AND(IFIAT(K),OR(MASKHI,LOSGN))
      K1 = K + 1
      K2 = K + ICFIAT - 3
      DO 750 KK = K1,K2
  750 IFIAT(KK) = 0
      GO TO 770
  760 LTU = AND(IFIAT(K),OR(OR(ISGNON,LOSGN),MASKHI))
      IFIAT(K) = OR(LTU,IORDNL(J+3))
  770 CONTINUE
      GO TO 840
C
C     ERROR MESSAGES
C     **************
C
C     IORDNL TABLE OVERFLOW
C
  780 CALL XGPIDG (14,NORDN1,NORDN2,AND(OSCAR(OSPNT+5),NOSGN))
      GO TO 960
C
C     CHKPNT IS FIRST INSTRUCTION IN LOOP
C
  790 CALL XGPIDG (47,LPTOP,0,0)
      OSCAR(LPTOP+5) = OR(OSCAR(LPTOP+5),ISGNON)
      GO TO 550
C
C     FILE APPEARS MORE THAN ONCE AS OUTPUT
C
C     SUPPRESS MESSAGE ONCE IF FILE IS INITIALLY UNDEFINED
C
  820 IF (ICPBOT .LT. ICPTOP) GO TO 8220
      DO 8210 II = ICPTOP,ICPBOT,3
      IF (OSCAR(IOPNT).NE.ICPDPL(II) .OR. OSCAR(IOPNT+1).NE.ICPDPL(II+1)
     1   ) GO TO 8210
      IF (ICPDPL(II+2) .GE. 0) GO TO 8220
      ICPDPL(II+2) = -ICPDPL(II+2)
      GO TO 346
 8210 CONTINUE
 8220 CALL XGPIDG (-45,OSPNT,OSCAR(IOPNT),OSCAR(IOPNT+1))
      GO TO 346
C
C     ICPDPL TABLE OVERFLOW
C
  830 CALL XGPIDG (14,NCPDP1,NCPDP2,0)
      GO TO 960
C
C     CHECK ICPDPL TABLE FOR UNDEFINED FILES
C
  840 IF (ICPBOT .LT. ICPTOP) GO TO 860
      DO 850 I = ICPTOP,ICPBOT,3
      CALL XGPIDG (-22,IABS(ICPDPL(I+2)),ICPDPL(I),ICPDPL(I+1))
  850 CONTINUE
C
C     IF DIAG 14 IS NOT ON, AND THERE ARE UNDEFINED FILES FROM USER'S
C     ALTER (DIAG14 IS SET TO 10 BY XGPI AT THIS TIME), SET DIAG14 TO 11
C     TO FLAG XGPI TO PRINT THE DMAP COMPILE LISTING.
C
C     IF DIAG 14 IS ON, THE DMAP LISTING IS ALREADY PRINTTED BY XSCNDM,
C     SHICH IS CALLED BY XOSGEN. XOSGEN IS CALLED BY XGPI BEFORE THIS
C     XFLORD IS CALLED (ALSO BY XGPI)
C
      IF (DIAG14 .EQ.  10) DIAG14 = 11
      IF (START .NE. ICST) GO TO 865
      GO TO 960
C
C     NO UNDEFINED FILES - CHECK FOR RESTART
C
  860 IF (START .EQ. ICST) GO TO 960
C
C     RESTART - USE LAST XVPS ENTRY IN PTDIC FOR RESTART.
C     EXCLUDE FIRST NXVPS ENTRY
C
  865 PTDTOP = PTDTOP + 3
      NOFIND = -1
      CALL XFLDEF (NXVPS,NBLANK,NOFIND)
      PTDTOP = PTDTOP - 3
C
C     OVERLAY PTDIC TABLE WITH ICPDPL TABLE
C
      ICPTOP = PTDTOP
      ICPBOT = ICPTOP - 3
      LCPDPL = LPTDIC
C
C     SCAN PTDIC FOR REUSE FLAGS
C
      DO 870 J = PTDTOP,PTDBOT,3
      IF (AND(PTDIC(J+2),REUSE) .EQ. 0) GO TO 870
C
C     REUSE FLAG UP - ENTER FILE IN ICPDPL
C
      ICPBOT = ICPBOT + 3
      ICPDPL(ICPBOT  ) = PTDIC(J  )
      ICPDPL(ICPBOT+1) = PTDIC(J+1)
      ICPDPL(ICPBOT+2) = PTDIC(J+2)
  870 CONTINUE
C
C     ORDER FILES IN ICPDPL BY REEL/FILE NUMBER
C
      IF (ICPBOT .LT. ICPTOP) GO TO 960
C
C     DO NOT DISTURB EXISTING ORDER
C
      IF (ICPBOT .EQ. ICPTOP) GO TO 900
      K = ICPTOP
  881 L = K
  882 IF (AND(ICPDPL(K+2),NOFLGS) .LE. AND(ICPDPL(K+5),NOFLGS))
     1    GO TO 890
C
C     SWITCH
C
      DO 891 M = 1,3
      J = K + M + 2
      ITMP(1) = ICPDPL(J)
      ICPDPL(J) = ICPDPL(J-3)
      ICPDPL(J-3) = ITMP(1)
  891 CONTINUE
      K = K - 3
      IF (K .GE. ICPTOP) GO TO 882
  890 K = L + 3
      IF (K .LT. ICPBOT) GO TO 881
  900 CONTINUE
C
C     ENTER PURGED FILE IN FIAT IF THERE IS NO POSSIBLE WAY TO GENERATE
C     FILE
C
      J1 = 2
      J1 = OSCAR(J1)
      J2 = OSCAR(OSBOT+1)
      DO 950 I = ICPTOP,ICPBOT,3
      IF (AND(ICPDPL(I+2),MASKHI) .NE. 0) GO TO 960
      OSPNT = 1
      DO 940 J = J1,J2
      IF (AND(MASKHI,OSCAR(OSPNT+2)).GT.2 .OR. OSCAR(OSPNT+5).GE.0)
     1    GO TO 940
C
C     SEE IF PURGED FILE IS IN I/P SECTION
C
      K1 = OSPNT + 7
      K2 = OSCAR(K1-1)*3 - 3 + K1
      DO 910 K = K1,K2,3
      IF (OSCAR(K).EQ.ICPDPL(I) .AND. OSCAR(K+1).EQ.ICPDPL(I+1))
     1    GO TO 930
  910 CONTINUE
C
C     PURGED FILE IS NOT IN I/P SECTION - SEARCH O/P SECTION FOR IT.
C
      IF (AND(MASKHI,OSCAR(OSPNT+2)) .NE. 1) GO TO 940
      K1 = OSCAR(OSPNT+6)*3  + OSPNT + 8
      K2 = OSCAR(K1-1)*3 - 3 + K1
      DO 920 K = K1,K2,3
      IF (OSCAR(K).EQ.ICPDPL(I) .AND. OSCAR(K+1).EQ.ICPDPL(I+1))
     1    GO TO 950
  920 CONTINUE
      GO TO 940
C
C     PURGED FILE FIRST USED AS INPUT - THEREFORE IT CANNOT BE GENERATED
C     ENTER PURGED FILE IN FIAT
C
  930 L = IFIAT(3)*ICFIAT + 4
      IFIAT(3  ) = IFIAT(3) + 1
      IFIAT(L  ) = OR(MASKHI,OSCAR(K+2))
      IFIAT(L+1) = OSCAR(K  )
      IFIAT(L+2) = OSCAR(K+1)
      GO TO 950
  940 OSPNT = OSCAR(OSPNT) + OSPNT
  950 CONTINUE
  960 RETURN
      END

      SUBROUTINE MBPLOT (NW1,ND1,NWN,NC21,NC2N,NC1,NCN,NDN)
C
C     SUBROUTINE TO PRINT A REPRESENTATION OF PLANFORM BEING CONSIDERED
C
      REAL            MACH
      DIMENSION       NW1(1),ND1(1),NWN(1),NC21(1),NC2N(1),NC1(1),
     1                NCN(1),NDN(1),PL(50)
      COMMON /SYSTEM/ SYS,N6
      COMMON /MBOXC / NJJ,CRANK1,CRANK2,CNTRL1,CNTRL2,NBOX,NPTS0,NPTS1,
     1                NPTS2,ASYM,GC,CR,MACH,BETA,EK,EKBAR,EKM,BOXL,BOXW,
     2                BOXA ,NCB,NSB,NSBD,NTOTE,KC,KC1,KC2,KCT,KC1T,KC2T
      DATA    BLANK , DIA, WG , FP , TP , WK  /
     1        1H    , 1H., 1HS, 1H1,1H2 , 1H, /
C
      NSBM  = MAX0(NSB,NSBD)
      NCBMX = MAX0(NCB,5   )
      WRITE  (N6,200) MACH,BOXW,BOXL
 200  FORMAT (1H1,29X,'GRAPHIC DISPLAY OF REGIONS ON MAIN SEMISPAN',
     1        /10X,11HMACH NUMBER ,F8.3,11X,9HBOX WIDTH ,F11.6 ,10X,
     2        10HBOX LENGTH ,F11.6, //)
      DO 3100 I = 1,NCBMX
      DO 1900 J = 1,NSBM
      PL(J) = BLANK
      IF (J .GT. NSB   ) GO TO 1500
      IF (I .GE. NW1(J)) GO TO 1100
      IF (I .LT. ND1(J)) GO TO 1900
      PL(J) = DIA
      GO TO 1900
 1100 IF (I .GT. NWN(J)) GO TO 1300
      IF (I.GE.NC21(J) .AND. I.LE.NC2N(J)) GO TO 1150
      IF (I.GE.NC1(J)  .AND. I.LE.NCN(J) ) GO TO 1200
      PL(J) = WG
      GO TO 1900
 1150 PL(J) = TP
      GO TO 1900
 1200 PL(J) = FP
      GO TO 1900
 1300 IF (I .GT. NDN(J)) GO TO 1900
      PL(J) = WK
      GO TO 1900
 1500 IF ((I.GE.ND1(J) .AND. I.LE.NDN(J)) .OR. (I.GE.NC1(J) .AND.
     1     I.LE.NCN(J))) PL(J) = DIA
      GO TO 1900
 1900 CONTINUE
C
      WRITE  (N6,2000) (PL(J),J=1,NSBM)
 2000 FORMAT (30X,50A1)
C
      IF (I .GT. 5) GO TO 3100
      GO TO (2100,2300,2500,2700,2900), I
 2100 WRITE  (N6,2200)
 2200 FORMAT (1H+,84X,9HS    MAIN )
      GO TO  3100
 2300 WRITE  (N6,2400)
 2400 FORMAT (1H+,84X,11H1    CNTRL1 )
      GO TO  3100
 2500 WRITE  (N6,2600)
 2600 FORMAT (1H+,84X,11H2    CNTRL2 )
      GO TO  3100
 2700 WRITE  (N6,2800)
 2800 FORMAT (1H+,84X,14H.    DIAPHRAGM )
      GO TO  3100
 2900 WRITE  (N6,3000)
 3000 FORMAT (1H+,84X,9H,    WAKE )
 3100 CONTINUE
      RETURN
      END

      SUBROUTINE KELAS (IJKLMN)
C*****
C THIS ROUTINE COMPUTES THE ELEMENT STIFFNESS AND STIFFNESS DAMPING
C 1 X 1 MATRICES FOR ELEMENTS ELAS1, ELAS2, ELAS3, ELAS4.
C*****
C
C
C
C              E C P T - S  F O R  E L A S  E L E M E N T S
C
C
C
C                  TYPE             TYPE           TYPE           TYPE
C         CELAS1           CELAS2         CELAS3         CELAS4
C ECPT(1) IELID     I      IELID     I    IELID      I   IELID      I
C ECPT(2) IGP1      I      K         R    IS1        I   K          R
C ECPT(3) IGP2      I      IGP1      I    IS2        I   IS1        I
C ECPT(4) IC1       I      IGP2      I    K          R   IS2        I
C ECPT(5) IC2       I      IC1       I    GSUBE      R
C ECPT(6) K         R      IC2       I    S          R
C ECPT(7) GSUBE     R      GSUBE     R
C ECPT(8) S         R      S         R
C
C
C
      DOUBLE PRECISION
     1                   KE
C
C
C
      DIMENSION
     1                   IECPT(5)
C
C
C
      COMMON   /SYSTEM/
     1                   ISYS
C
C SMA1 I/O PARAMETERS
C
      COMMON   /SMA1IO/
     1                   IFCSTM             ,IFMPT
     2,                  IFDIT              ,IDUM1
     3,                  IFECPT             ,IGECPT
     4,                  IFGPCT             ,IGGPCT
     5,                  IFGEI              ,IGGEI
     6,                  IFKGG              ,IGKGG
     7,                  IF4GG              ,IG4GG
     8,                  IFGPST             ,IGGPST
     9,                  INRW               ,OUTRW
     T,                  CLSNRW             ,CLSRW
     1,                  NEOR               ,EOR
     2,                  MCBKGG(7)          ,MCB4GG(7)
C
C SMA1 VARIABLE CORE BOOKKEEPING PARAMETERS
C
      COMMON   /SMA1BK/
     1                   ICSTM              ,NCSTM
     2,                  IGPCT              ,NGPCT
     3,                  IPOINT             ,NPOINT
     4,                  I6X6K              ,N6X6K
     5,                  I6X64              ,N6X64
C
C SMA1 PROGRAM CONTROL PARAMETERS
C
      COMMON   /SMA1CL/
     1                   IOPT4              ,K4GGSW
     2,                  NPVT               ,LEFT
     3,                  FROWIC             ,LROWIC
     4,                  NROWSC             ,TNROWS
     5,                  JMAX               ,NLINKS
     6,                  LINK(10)           ,IDETCK
     7,                  DODET              ,NOGO
C
C ECPT COMMON BLOCK
C
      COMMON   /SMA1ET/
     1                   ECPT(100)
C
C
C
      EQUIVALENCE
     1                   (IECPT(1),ECPT(1))
C
C
C
      DATA
     1                   ISCALR /0/
C
C
C
      IARG = IJKLMN
C
C MAKE THE ECPT-S FOR ALL ELAS ELEMENTS LOOK EXACTLY LIKE THE ECPT FOR
C ELAS1
C
      GO TO (50,10,30,40), IARG
C
C ELAS2
C
   10 SAVE = ECPT(2)
      DO 20 I = 3,6
   20 IECPT(I-1) = IECPT(I)
      ECPT(6) = SAVE
      GO TO 50
C
C ELAS3
C
   30 ECPT(7) = ECPT(5)
      ECPT(6)  = ECPT(4)
      IECPT(4) = 1
      IECPT(5) = 1
      GO TO 50
C
C ELAS4
C
   40 ECPT(6)  = ECPT(2)
      IECPT(2) = IECPT(3)
      IECPT(3) = IECPT(4)
      IECPT(4) = 1
      IECPT(5) = 1
C
C DETERMINE WHICH POINT IS THE PIVOT POINT AND SET APPROPRIATE POINTERS
C
   50 IND = 2
      IF (IECPT(2) .EQ. NPVT) GO TO 60
      IF (IECPT(3) .NE. NPVT) RETURN
      IPVT  = 3
      IPDOF = 5
      INPVT = 2
      INPDOF = 4
      IF (IECPT(2) .EQ. 0) IND = 1
      GO TO 80
C
C CHECK TO SEE IF BOTH POINTS MATCH THE PIVOT POINT.
C
   60 IF (IECPT(3) .NE. NPVT) GO TO 70
      IF (ISCALR .EQ. 0) GO TO 65
      ISCALR = 0
      RETURN
   65 ISCALR = 1
      IND = 4
   70 IPVT   = 2
      IPDOF  = 4
      INPVT  = 3
      INPDOF = 5
      IF (IECPT(3) .EQ. 0) IND = 1
   80 IF (IECPT(IPDOF)  .LE. 0) IECPT(IPDOF)  = 1
      IF (IECPT(INPDOF) .LE. 0) IECPT(INPDOF) = 1
C
C II AND JJ ARE THE ROW AND COLUMN INDICES OF THE MATRIX INTO WHICH THE
C SPRING AND SPRING DAMPING CONSTANTS WILL BE ADDED.
C
      II = IECPT(IPVT)  + IECPT(IPDOF)  - 1
      JJ = IECPT(INPVT) + IECPT(INPDOF) - 1
      KE = ECPT(6)
      INDEX = 6
      IFILE = IFKGG
   85 ASSIGN 100 TO IRETRN
      I = II
      J = II
   90 CALL SMA1B (KE,J,I,IFILE,0.0D0)
      IF (IND .EQ. 1) GO TO 130
      GO TO IRETRN, (100,110,120,130)
  100 ASSIGN 110 TO IRETRN
      KE = - KE
      J  =   JJ
      GO TO 90
  110 IF (IND .NE. 4) GO TO 130
      ASSIGN 120 TO IRETRN
      KE = ECPT(6)
      I = JJ
      GO TO 90
  120 ASSIGN 130 TO IRETRN
      KE = -KE
      J  = II
      GO TO 90
  130 IF (INDEX .EQ. 7)  RETURN
      IF (IOPT4 .EQ. 0  .OR.  IARG .EQ. 4) RETURN
C
C IF G SUB E IS NON-ZERO, SET PARAMETERS FOR K4GG INSERTION.
C
      IF (ECPT(7) .EQ. 0.0) RETURN
      K4GGSW = 1
      IFILE = IF4GG
      KE = ECPT(7) * ECPT(6)
      INDEX = 7
      GO TO 85
      END

      SUBROUTINE MTRIRG
C
C
C*****
C THIS ROUTINE COMPUTES THE   MASS    MATRIX FOR A AXI-SYMMETRIC RING
C WITH A TRIANGULAR CROSS SECTION
C*****
C
C
C                        ECPT FOR THE TRIANGULAR RING
C
C
C                                                      TYPE
C ECPT( 1) ELEMENT IDENTIFICATION                        I
C ECPT( 2) SCALAR INDEX NO. FOR GRID POINT A             I
C ECPT( 3) SCALAR INDEX NO. FOR GRID POINT B             I
C ECPT( 4) SCALAR INDEX NO. FOR GRID POINT C             I
C ECPT( 5) MATERIAL ORIENTATION ANGLE(DEGREES)           R
C ECPT( 6) MATERIAL IDENTIFICATION                       I
C ECPT( 7) COOR. SYS. ID. FOR GRID POINT A               I
C ECPT( 8) X-COOR. OF GRID POINT A (IN BASIC COOR.)      R
C ECPT( 9) Y-COOR. OF GRID POINT A (IN BASIC COOR.)      R
C ECPT(10) Z-COOR. OF GRID POINT A (IN BASIC COOR.)      R
C ECPT(11) COOR. SYS. ID. FOR GRID POINT B               I
C ECPT(12) X-COOR. OF GRID POINT B (IN BASIC COOR.)      R
C ECPT(13) Y-COOR. OF GRID POINT B (IN BASIC COOR.)      R
C ECPT(14) Z-COOR. OF GRID POINT B (IN BASIC COOR.)      R
C ECPT(15) COOR. SYS. ID. FOR GRID POINT C               I
C ECPT(16) X-COOR. OF GRID POINT C (IN BASIC COOR.)      R
C ECPT(17) Y-COOR. OF GRID POINT C (IN BASIC COOR.)      R
C ECPT(18) Z-COOR. OF GRID POINT C (IN BASIC COOR.)      R
C ECPT(19) EL. TEMPERATURE FOR MATERIAL PROPERTIES       R
C
C
      DOUBLE PRECISION CONSTD, D2PI
      DOUBLE PRECISION
     1                   D ,  GAMBQ,    R,   Z
     2,                            DELINT,   AK,  AKI
     3,                  AKT,  AM
      DOUBLE PRECISION   R1,  R2,  R3,  Z1,  Z2,  Z3,  ZMIN, DGAMA
     1,                  DR,  RH,  DZ,  ZH,  RA,  ZA,  AREA
     2,                  TWOPI,    RHOD,     DKI
C
      DIMENSION          IECPT(19)
      DIMENSION  AM(36)
C
      COMMON /CONDAD/ CONSTD(5)
      COMMON   /SMA2IO/
     1                   DUM1(10)
     2,                  IFMGG
     3,                  DUM2(25)
      COMMON   /SMA2CL/
     1                   DUM3(2)
     2,                  NPVT
     3,                  DUM4(7)
     4,                  LINK(10)           ,NOGO
      COMMON   /SMA2ET/
     1                   ECPT(19)
     2,                  DUM5(81)
      COMMON   /MATIN/
     1                   MATIDC             ,MATFLG
     2,                  ELTEMP             ,STRESS
     3,                  SINTH              ,COSTH
      COMMON   /MATOUT/
     1                   E(3)               ,ANU(3)
     2,                  RHO                ,G(3)
     3,                  ALF(3)             ,TZERO
      COMMON   /SMA2DP/
     1                   D(36) ,   GAMBQ(36),     R(3) ,    Z(3)
     2,                                      DELINT(8),     AK(36)
     3,                  AKI(36),  AKT(9)
     4,                  DGAMA,    ZMIN,     RHOD,     TWOPI
     5,                  DR,  RH,  DZ,  ZH,  RA,  ZA,  AREA
     8,                  IGP(3) , ICS(3) , SP(18)
     9,                  TEMPE
C
      EQUIVALENCE        (IECPT(1) , ECPT(1))
      EQUIVALENCE   (R(1),R1),     (R(2),R2),     (R(3),R3)
     1,             (Z(1),Z1),     (Z(2),Z2),     (Z(3),Z3)
      EQUIVALENCE  (AM(1) , AK(1))
      EQUIVALENCE ( CONSTD(2) , D2PI   )
C
C ----------------------------------------------------------------------
C
C STORE ECPT PARAMETERS IN LOCAL VARIABLES
C
      IDEL  = IECPT(1)
      IGP(1)= IECPT(2)
      IGP(2)= IECPT(3)
      IGP(3)= IECPT(4)
      MATID = IECPT(6)
      ICS(1)= IECPT(7)
      ICS(2)= IECPT(11)
      ICS(3)= IECPT(15)
      R(1)  = ECPT(8)
      D(1)  = ECPT(9)
      Z(1)  = ECPT(10)
      R(2)  = ECPT(12)
      D(2)  = ECPT(13)
      Z(2)  = ECPT(14)
      R(3)  = ECPT(16)
      D(3)  = ECPT(17)
      Z(3)  = ECPT(18)
      TEMPE = ECPT(19)
      DGAMA = ECPT(5)
C
C
C CHECK INTERNAL GRID POINTS FOR PIVOT POINT
C
      IPP = 0
      DO 100 I = 1,3
      IF (NPVT .EQ. IGP(I)) IPP = I
  100 CONTINUE
      IF (IPP .EQ. 0) CALL MESAGE (-30,34,IDEL)
C
C
C TEST THE VALIDITY OF THE GRID POINT COORDINATES
C
      IEROR1 = 0
      DO 200 I = 1,3
      IF (R(I).GT.0.0D0) GO TO 200
      IF (IEROR1.NE.0) GO TO 200
      CALL MESAGE (30, 211, IDEL)
      IEROR1 = 1
  200 CONTINUE
      IEROR2 = 0
      DO 210 I = 1, 3
      IF (D(I).EQ.0.0D0) GO TO 210
      IF (IEROR2.NE.0) GO TO 210
      CALL MESAGE (30, 212, IDEL)
      IEROR2 = 1
  210 CONTINUE
C
C
C COMPUTE THE ELEMENT COORDINATES
C
      IF (IEROR1.EQ.0.AND.IEROR2.EQ.0) GO TO 220
      NOGO = 2
      RETURN
  220 ZMIN = DMIN1 (Z1, Z2, Z3)
      Z1 = Z1 - ZMIN
      Z2 = Z2 - ZMIN
      Z3 = Z3 - ZMIN
C
C
C
C FORM THE TRANSFORMATION MATRIX (6X6) FROM FIELD COORDINATES TO GRID
C POINT DEGREES OF FREEDOM
C
      DO 300 I = 1,36
      GAMBQ(I) = 0.0D0
  300 CONTINUE
      GAMBQ( 1) = 1.0D0
      GAMBQ( 2) = R1
      GAMBQ( 3) = Z1
      GAMBQ(10) = 1.0D0
      GAMBQ(11) = R1
      GAMBQ(12) = Z1
      GAMBQ(13) = 1.0D0
      GAMBQ(14) = R2
      GAMBQ(15) = Z2
      GAMBQ(22) = 1.0D0
      GAMBQ(23) = R2
      GAMBQ(24) = Z2
      GAMBQ(25) = 1.0D0
      GAMBQ(26) = R3
      GAMBQ(27) = Z3
      GAMBQ(34) = 1.0D0
      GAMBQ(35) = R3
      GAMBQ(36) = Z3
C
C
C     NONEED TO COMPUTE DETERMINANT SINCE IT IS NOT USED SUBSEQUENTLY.
      ISING = -1
      CALL INVERD (6, GAMBQ(1),6 , D(10), 0, D(11) , ISING , SP)
C
      IF (ISING.EQ.2) GO TO 920
C
C
C
C CALCULATE THE INTEGRAL VALUES IN ARRAY DELINT WHERE THE ORDER IS
C INDICATED BY THE FOLLOWING TABLE
C
C              DELINT( 1) - ( 1,0)
C              DELINT( 2) - ( 1,1)
C              DELINT( 3) - ( 1,2)
C              DELINT( 4) - ( 2,0)
C              DELINT( 5) - ( 2,1)
C              DELINT( 6) - ( 0,2)
C              DELINT( 7) - ( 3,0)
C              DELINT( 8) - (-1,2)
C
C
C TEST FOR RELATIVE SMALL AREA OF INTEGRATION
C AND IF AREA IS SMALL THEN APPROXIMATE INTEGRALS
C
      DR = DMAX1 ( DABS(R1-R2) , DABS(R2-R3) , DABS(R3-R1) )
      RH = DMIN1 ( R1 , R2 , R3 ) / 10.0D0
      DZ = DMAX1 ( DABS(Z1-Z2) , DABS(Z2-Z3) , DABS(Z3-Z1) )
      ZH = DMIN1 ( Z1 , Z2 , Z3 ) / 10.0D0
      RA = (R1 + R2 + R3) / 3.0D0
      ZA = (Z1 + Z2 + Z3) / 3.0D0
      AREA =(R1*(Z2-Z3) + R2*(Z3-Z1) + R3*(Z1-Z2)) / 2.0D0
      KODE = 0
      IF (DABS( (R2-R1)/R2 ) .LT. 1.0D-5) KODE = 1
      IF ( DR .LE. RH  .OR.  DZ .LE. ZH ) KODE = -1
C
C
  310 CONTINUE
      I1 = 0
      DO 400 I = 1,3
      IP = I
      DO 350 J = 1,3
      IQ = J - 1
      IF (IP.EQ.2 .AND. IQ.EQ.2) IP = 0
      IF (IP.EQ.3 .AND. IQ.EQ.2) IP = -1
      IF (IP.EQ.3 .AND. IQ.EQ.1) GO TO 350
      I1 = I1 + 1
      IF (KODE) 320,330,340
  320 DELINT(I1) =((RA) ** IP)*((ZA) ** IQ) * AREA
      GO TO 350
  330 DELINT(I1) = DKI(1,3,1,2,1,3,IP,IQ,R,Z)
     1           + DKI(3,2,1,2,3,2,IP,IQ,R,Z)
      GO TO 350
  340 CONTINUE
      DELINT(I1) = DKI(1,3,3,2,1,3,IP,IQ,R,Z)
  350 CONTINUE
  400 CONTINUE
C
C
C TEST FOR EXCESSIVE ROUND-OFF ERROR IN INTEGRAL CALCULATIONS
C AND IF IT EXIST APPROXIMATE INTEGRALS
C
      IF (KODE .LT. 0) GO TO 500
      DO 450 I = 1,8
      IF (DELINT(I) .LT. 0.0D0) GO TO 475
  450 CONTINUE
      IF (DELINT(3) .LE. DELINT(6)) GO TO 475
      IF (DELINT(8) .GE. DELINT(3)) GO TO 475
      IF (DELINT(8) .GT. DELINT(6)) GO TO 475
      GO TO 500
  475 CONTINUE
      KODE = -1
      GO TO 310
  500 CONTINUE
C
C
C
C LOCATE THE MATERIAL PROPERTIES IN THE MAT1 OR MAT3 TABLE
C
      MATIDC = MATID
      MATFLG = 7
      ELTEMP = TEMPE
      CALL  MAT (IDEL)
C
C
C SET MATERIAL PROPERTIES IN DOUBLE PRECISION VARIABLES
C
      RHOD = RHO
C
C GENERATE THE CONSISTENT MASS MATRIX IN FIELD COORDINATES
C
      DO 600 I = 1,36
      AM(I) = 0.0D0
  600 CONTINUE
      TWOPI = D2PI * RHOD
      AM( 1)= TWOPI *       DELINT(1)
      AM( 2)= TWOPI *       DELINT(4)
      AM( 3)= TWOPI *       DELINT(2)
      AM( 7)= AM( 2)
      AM( 8)= TWOPI *       DELINT(7)
      AM( 9)= TWOPI *       DELINT(5)
      AM(13)= AM( 3)
      AM(14)= AM( 9)
      AM(15)= TWOPI *       DELINT(3)
      AM(22)= AM( 1)
      AM(23)= AM( 2)
      AM(24)= AM( 3)
      AM(28)= AM(23)
      AM(29)= AM( 8)
      AM(30)= AM( 9)
      AM(34)= AM(24)
      AM(35)= AM(30)
      AM(36)= AM(15)
C
C TRANSFORM THE ELEMENT   MASS    MATRIX FROM FIELD COORDINATES
C TO GRID POINT DEGREES OF FREEDOM
C
      CALL GMMATD (GAMBQ , 6, 6, 1, AK , 6, 6, 0, D )
      CALL GMMATD (D  , 6, 6, 0, GAMBQ , 6, 6, 0, AK)
C
C
C
C ZERO OUT THE (6X6) MATRIX USED AS INPUT TO THE INSERTION ROUTINE
C
      DO 700 I = 1,36
      AKI(I) = 0.0D0
  700 CONTINUE
C
C
C LOCATE THE TRANSFORMATION MATRICES FOR THE THREE GRID POINTS
C
      DO 800 I = 1,3
      IF (ICS(I) .EQ. 0) GO TO 800
      K = 9 * (I-1) + 1
      CALL TRANSD (ICS(I) , D(K))
  800 CONTINUE
C
C
C
C START THE LOOP FOR INSERTION OF THE THREE (6X6) MATRICES
C INTO THE MASTER MASS MATRIX
C
      IR1  = 2 * IPP - 1
      IAPP = 9 * (IPP-1) + 1
      DO 900 I = 1,3
C
C PLACE THE APPROIATE (2X2) SUBMATRIX OF THE MASS MATRIX
C IN A (3X3) MATRIX FOR TRANSFORMATION
C
      IC1 = 2 * I - 1
      IRC = (IR1 - 1) * 6 + IC1
      AKT(1) = AK(IRC)
      AKT(2) = 0.0D0
      AKT(3) = AK(IRC+1)
      AKT(4) = 0.0D0
      AKT(5) = 0.0D0
      AKT(6) = 0.0D0
      AKT(7) = AK(IRC+6)
      AKT(8) = 0.0D0
      AKT(9) = AK(IRC+7)
C
C TRANSFORM THE (3X3) MASS MATRIX
C
      IF (ICS(IPP) .EQ. 0) GO TO 820
      CALL GMMATD (D(IAPP) , 3, 3, 1, AKT(1) , 3, 3, 0, D(28) )
      DO 810 J = 1,9
      AKT(J) = D(J+27)
  810 CONTINUE
  820 CONTINUE
      IF (ICS(I) .EQ. 0) GO TO 840
      IAI = 9 * (I - 1) + 1
      CALL GMMATD (AKT(1) , 3, 3, 0, D(IAI) , 3, 3, 0, D(28) )
      DO 830 J = 1,9
      AKT(J) = D(J+27)
  830 CONTINUE
  840 CONTINUE
C
C PLACE THE TRANSFORMED (3X3) MATRIX INTO A (6X6) MATRIX FOR
C THE INSERTION ROUTINE
C
      J = 0
      DO 850 J1 = 1,18,6
      DO 850 J2 = 1,3
      J = J + 1
      K = J1 + J2 - 1
      AKI(K) = AKT(J)
  850 CONTINUE
C
C CALL THE INSERTION ROUTINE
C
      CALL SMA2B (AKI(1) , IGP(I), -1, IFMGG, 0.0D0)
  900 CONTINUE
      RETURN
C
C  SET FLAG FOR FATAL ERROR WHILE ALLOWING ERROR MESSAGES TO ACCUMULATE
C
  915 NOGO=1
      RETURN
  920 CALL MESAGE(30,37,IDEL)
      GO TO 915
C
      END

      SUBROUTINE ALG11
C
      REAL            LOSS,LAMI,LAMIP1,LAMIM1
      DIMENSION       XM(21),PPG(21),V(21),PT(21),PS(21),WT(21),PN(21),
     1                P1(21),DELTP(21,30),TS(21),SOLID(21),DELTB(21),
     2                TR(21,30),RMDV(21,6),IDATA(6),RDATA(6),NAME1(2),
     3                NAME2(2)
      COMMON /SYSTEM/ KSYSTM(90),LPUNCH
      COMMON /UD3PRT/ IPRTC,ISTRML,IPGEOM
      COMMON /ALGINO/ ISCR
      COMMON /UDSTR2/ NBLDES,STAG(21),CHORDD(21)
      COMMON /UDSIGN/ NSIGN
      COMMON /UD300C/ NSTNS,NSTRMS,NMAX,NFORCE,NBL,NCASE,NSPLIT,NREAD,
     1NPUNCH,NPAGE,NSET1,NSET2,ISTAG,ICASE,IFAILO,IPASS,I,IVFAIL,IFFAIL,
     2NMIX,NTRANS,NPLOT,ILOSS,LNCT,ITUB,IMID,IFAIL,ITER,LOG1,LOG2,LOG3,
     3LOG4,LOG5,LOG6,IPRINT,NMANY,NSTPLT,NEQN,NSPEC(30),NWORK(30),
     4NLOSS(30),NDATA(30),NTERP(30),NMACH(30),NL1(30),NL2(30),NDIMEN(30)
     5,IS1(30),IS2(30),IS3(30),NEVAL(30),NDIFF(4),NDEL(30),NLITER(30),
     6NM(2),NRAD(2),NCURVE(30),NWHICH(30),NOUT1(30),NOUT2(30),NOUT3(30),
     7NBLADE(30),DM(11,5,2),WFRAC(11,5,2),R(21,30),XL(21,30),X(21,30),
     8H(21,30),S(21,30),VM(21,30),VW(21,30),TBETA(21,30),DIFF(15,4),
     9FDHUB(15,4),FDMID(15,4),FDTIP(15,4),TERAD(5,2),DATAC(100),
     1DATA1(100),DATA2(100),DATA3(100),DATA4(100),DATA5(100),DATA6(100),
     2DATA7(100),DATA8(100),DATA9(100),FLOW(10),SPEED(30),SPDFAC(10),
     3BBLOCK(30),BDIST(30),WBLOCK(30),WWBL(30),XSTN(150),RSTN(150),
     4DELF(30),DELC(100),DELTA(100),TITLE(18),DRDM2(30),RIM1(30),
     5XIM1(30),WORK(21),LOSS(21),TANEPS(21),XI(21),VV(21),DELW(21),
     6LAMI(21),LAMIM1(21),LAMIP1(21),PHI(21),CR(21),GAMA(21),SPPG(21),
     7CPPG(21),HKEEP(21),SKEEP(21),VWKEEP(21),DELH(30),DELT(30),VISK,
     8SHAPE,SCLFAC,EJ,G,TOLNCE,XSCALE,PSCALE,PLOW,RLOW,XMMAX,RCONST,
     9FM2,HMIN,C1,PI,CONTR,CONMX
      EQUIVALENCE    (IDATA(1),RDATA(1))
      DATA    NAME1, NAME2 /4HPLOA,4HD2  ,4HTEMP,4H    /
C
      OPR   = 0.0
      OEFF  = 1.0
      PFAC  = 550.0
      ILAST = NSTNS
C
C     LOCATE COMPUTING STATION NUMBER AT THE BLADE LEADING EDGE AND
C     AT THE BLADE TRAILING EDGE.
C
      LEDGEB = 0
      ITRLEB = 0
      DO 10 IBLE = 1,NSTNS
      NOUT3S = NOUT3(IBLE)/10
      IF (NOUT3(IBLE).EQ.1 .OR. NOUT3S.EQ.1) LEDGEB = IBLE
      IF (NOUT3(IBLE).EQ.2 .OR. NOUT3S.EQ.2) ITRLEB = IBLE
   10 CONTINUE
      IF (IFAILO .NE. 0) ILAST = IFAILO
      DO 700 I = 1,ILAST
      CALL ALG03 (LNCT,7+NSTRMS)
      IF (IPRTC .EQ. 1) WRITE(LOG2,100) I
  100 FORMAT (//10X,'STATION',I3,'  FLOW-FIELD DESCRIPTION', /10X,
     1        34(1H*), //,'  STREAM      -----MESH-POINT COORDS------',
     2        3X,16(1H-),'V E L O C I T I E S,16(1H-)    RADIUS OF  ',
     3        'STREAMLINE   STATION',/,'  -LINE       RADIUS    X-COORD'
     4,       '    L-COORD   MERIDIONAL TANGENTIAL   AXIAL',6X,'RADIAL',
     5        4X,'TOTAL    CURVATURE SLOPE ANGLE LEAN ANGLE',/)
      CALL ALG01 (R(1,I),X(1,I),NSTRMS,R(1,I),X1,GAMA,NSTRMS,0,1)
      IF (I.NE.1 .AND. I.NE.NSTNS) GO TO 130
      L1 = 1
      L2 = 2
      IF (I .EQ. 1) GO TO 110
      L2 = NSTNS
      L1 = L2 - 1
  110 DO 120 J = 1,NSTRMS
      CR(J)  = 0.0
  120 PHI(J) = ATAN2(R(J,L2)-R(J,L1),X(J,L2)-X(J,L1))
      GO TO 150
  130 DO 140 J = 1,NSTRMS
      X1 = SQRT((R(J,I+1)-R(J,I))**2+(X(J,I+1)-X(J,I))**2)
      X2 = SQRT((R(J,I)-R(J,I-1))**2+(X(J,I)-X(J,I-1))**2)
      X3 = ATAN2(R(J,I+1)-R(J,I),X(J,I+1)-X(J,I))
      X4 = ATAN2(R(J,I)-R(J,I-1),X(J,I)-X(J,I-1))
      CR(J) = (X3-X4)/(X1+X2)*2.0
      IF (CR(J) .NE. 0.0) CR(J) = 1.0/CR(J)
  140 PHI(J) = (X3+X4)/2.0
  150 DO 160 J = 1,NSTRMS
      VA = VM(J,I)*COS(PHI(J))
      VR = VM(J,I)*SIN(PHI(J))
      FI = PHI(J)*C1
      GA = ATAN(GAMA(J))*C1
      PPG(J) = FI + GA
      V(J) = SQRT(VM(J,I)**2+VW(J,I)**2)
C
C     STORE RADIUS AT BLADE LEADING AND TRAILING EDGES, ALL STREAMLINES
C
      IF (ICASE.EQ.1 .AND. I.EQ.LEDGEB) RMDV(J,5) = R(J,I)
      IF (ICASE.EQ.1 .AND. I.EQ.ITRLEB) RMDV(J,6) = R(J,I)
  160 IF (IPRTC .EQ. 1) WRITE (LOG2,170) J,R(J,I),X(J,I),XL(J,I),
     1    VM(J,I),VW(J,I),VA,VR,V(J),CR(J),FI,GA
  170 FORMAT (I6,F14.4,2F11.4,5F11.2,1X,F10.2,2F11.3)
      CALL ALG03 (LNCT,NSTRMS+4)
      IF (IPRTC .EQ. 1) WRITE (LOG2,180)
  180 FORMAT (/8H  STREAM,7X,4HMACH,6X,4(1H-),9HPRESSURES,4(1H-),5X,
     1       17H---TEMPERATURES--,4X,8HSPECIFIC,4X,17H---ENTHALPIES----,
     2       4X,7HENTROPY,6X,4HFLOW,3X,11H(PHI+GAMMA), /,7H  -LINE,7X,
     3       6HNUMBER,5X,5HTOTAL,6X,6HSTATIC,5X,5HTOTAL,6X,6HSTATIC,5X,
     4       6HWEIGHT,5X,5HTOTAL,6X,6HSTATIC,16X,5HANGLE,/)
      DO 190 J = 1,NSTRMS
      DELTB(J) = 0.0
      HS = H(J,I) - V(J)**2/(2.0*G*EJ)
      IF (HS .LT. HMIN) HS = HMIN
      XM(J) = SQRT(ALG9(HS,S(J,I),V(J)**2))
      PT(J) = ALG4(H(J,I),S(J,I))
      PTINS = PT(J)/SCLFAC**2
      PS(J) = ALG4(HS,S(J,I))
      PSINS = PS(J)/SCLFAC**2
      TT    = ALG7(H(J,I),S(J,I))
      TS(J) = ALG7(HS,S(J,I))
      WT(J) = ALG5(HS,S(J,I))
      ALPHA = 0.0
      IF (I.NE.ISTAG .OR. J.NE.1) ALPHA = C1*ATAN(VW(J,I)/VM(J,I))
C
C     STORE DENSITY AT BLADE LEADING EDGE FOR ALL STREAMLINES
C
      IF (ICASE.EQ.1 .AND. I.EQ.LEDGEB) RMDV(J,2) = WT(J)
  190 IF (IPRTC .EQ. 1) WRITE (LOG2,200) J,XM(J),PTINS,PSINS,TT,TS(J),
     1    WT(J),H(J,I),HS,S(J,I),ALPHA,PPG(J)
  200 FORMAT (I6,F14.4,2F11.4,2F11.3,F12.6,F10.3,F11.3,F12.6,F10.3,
     1        F11.3)
      IF (I .NE. 1) GO TO 220
      P1BAR = 0.0
      H1BAR = 0.0
      P1(1) = PT(1)
      PN(1) = PT(1)
      DO 210 J = 1,ITUB
      P1(J+1) = PT(J+1)
      PN(J+1) = PT(J+1)
      X1    = (DELF(J+1)-DELF(J))/2.0
      P1BAR = P1BAR + X1*(PT(J)+PT(J+1))
  210 H1BAR = H1BAR + X1*(H(J,1)+H(J+1,1))
      HBAR  = H1BAR
      S1BAR = ALG3(P1BAR,H1BAR)
      PNBAR = P1BAR
      HNBAR = H1BAR
      SNBAR = S1BAR
      L1KEEP= 1
      GO TO 700
  220 IFLE  = 0
      IFTE  = 0
      IF (NWORK(I) .EQ. 0) GO TO 230
      IFTE  = 1
      IF (I.EQ.NSTNS .OR. NWORK(I+1).EQ.0 .OR. SPEED(I).EQ.SPEED(I+1))
     1    GO TO 240
      IFLE  = 1
      GO TO 240
  230 IF (I.EQ.NSTNS .OR. NWORK(I+1).EQ.0) GO TO 240
      IFLE  = 1
  240 IF (IFTE .EQ. 0) GO TO 500
      CALL ALG03 (LNCT,NSTRMS+8)
      XN    = SPEED(I)*SPDFAC(ICASE)
      XBLADE= 10.0
      IF (NBLADE(I) .NE. 0) XBLADE = ABS(FLOAT(NBLADE(I)))
      L1    = XBLADE
      IF (IPRTC .EQ. 1) WRITE (LOG2,250) I,XN,L1
  250 FORMAT (/10X,'STATION',I3,' IS WITHIN OR AT THE TRAILING EDGE OF',
     1        ' A BLADE ROTATING AT',F8.1,' RPM  NUMBER OF BLADES IN ',
     2        'ROW =',I3, /10X,109(1H*), //,'  STREAM      BLADE     ',
     2        'RELATIVE    RELATIVE   RELATIVE  DEVIATION    BLADE    ',
     3        '  LEAN    PRESS DIFF    LOSS     DIFFUSION   DELTA P',
     5        /,'  -LINE',7X,'SPEED     VELOCITY    MACH NO.  FLOW',
     6        ' ANGLE   ANGLE      ANGLE      ANGLE   ACROSS BLADE  ',
     7        'COEFF      FACTOR     ON Q',/)
      Q = 1.0
      IF (SPEED(I) .LT. 0.0) GO TO 290
      IF (SPEED(I) .GT. 0.0) GO TO 280
      IF (I .LT. 3) GO TO 290
      II = I - 1
  260 IF (SPEED(II) .NE. 0.0) GO TO 270
      IF (II .EQ. 2) GO TO 290
      II = II - 1
      GO TO 260
  270 IF (SPEED(II) .LT. 0.0) Q = -1.0
      GO TO 290
  280 Q  = -1.0
  290 L1 = NDIMEN(I) + 1
      GO TO (300,320,340,360), L1
  300 DO 310 J = 1,NSTRMS
  310 TANEPS(J) = R(J,I)
      GO TO 380
  320 DO 330 J = 1,NSTRMS
  330 TANEPS(J) = R(J,I)/R(NSTRMS,I)
      GO TO 380
  340 DO 350 J = 1,NSTRMS
  350 TANEPS(J) = XL(J,I)
      GO TO 380
  360 DO 370 J = 1,NSTRMS
  370 TANEPS(J) = XL(J,I)/XL(NSTRMS,I)
  380 L1 = IS2(I)
      IF (NWORK(I).EQ.5 .OR. NWORK(I).EQ.6) CALL ALG01 (DATAC(L1),
     1    DATA6(L1),NDATA(I),TANEPS,DELTB,X1,NSTRMS,NTERP(I),0)
      CALL ALG01 (DATAC(L1),DATA5(L1),NDATA(I),TANEPS,SOLID,X1,NSTRMS,
     1            NTERP(I),0)
      CALL ALG01 (DATAC(L1),DATA3(L1),NDATA(I),TANEPS,TANEPS,X1,NSTRMS,
     1            NTERP(I),0)
      L1 = I + NL1(I)
      L2 = L1
      IF (NLOSS(I).EQ.1 .OR. NLOSS(I).EQ.4 .OR. NWORK(I).EQ.7)
     1    L2 = I + NL2(I)
      XN = XN*PI/(30.0*SCLFAC)
      DO 430 J = 1,NSTRMS
      U  = XN*R(J,I)
      VR = SQRT(VM(J,I)**2+(VW(J,I)-U)**2)
      XMR  = XM(J)*VR/V(J)
      BETA = ATAN(TBETA(J,I))*C1
      BBETA= 0.0
      IF (NWORK(I).EQ.5 .OR. NWORK(I).EQ.6) BBETA = BETA - DELTB(J)
      DELTB(J) = DELTB(J)*Q
      DELP = 0.0
      IF (I.EQ.NSTNS .OR. NWORK(I+1).EQ.0 .OR. SPEED(I).NE.SPEED(I+1))
     1    GO TO 390
      X1 = SQRT((R(J,I+1)-R(J,I))**2+(X(J,I+1)-X(J,I))**2)
      X2 = SQRT((R(J,I)-R(J,I-1))**2+(X(J,I)-X(J,I-1))**2)
      X3 = XBLADE
      DELP = PI*R(J,I)*WT(J)/(SCLFAC**2*X3*G)*(TBETA(J,I)/
     1       (1.0+TBETA(J,I)**2)*TS(J)*G*EJ*((S(J,I+1)-S(J,I))/X1 +
     2       (S(J,I)-S(J,I-1))/X2)+VM(J,I)/R(J,I)*((R(J,I+1)*VW(J,I+1) -
     3       R(J,I)*VW(J,I))/X1+(R(J,I)*VW(J,I)-R(J,I-1)*VW(J,I-1))/X2))
      DELTP(J,I) = DELP
  390 HRI  = H(J,I) - (V(J)**2-VR**2)/(2.0*G*EJ)
      PRD  = ALG4(HRI,S(J,L1))
      PR   = ALG4(HRI,S(J,I))
      TR(J,I) = ALG7(HRI,S(J,I))
      PRL2 = PR
      PSL2 = PS(J)*SCLFAC**2
      IF (L2 .EQ. I) GO TO 400
      PRL2 = H(J,L2) - (VW(J,L2)**2 - (VW(J,L2) - XN*R(J,L2))**2)/
     1       (2.0*G*EJ)
      PRL2 = ALG4(PRL2,S(J,L2))
      PSL2 = H(J,L2) - (VW(J,L2)**2+VM(J,L2)**2)/(2.0*G*EJ)
      PSL2 = ALG4(PSL2,S(J,L2))
  400 COEF = (PRD-PR)/(PRL2-PSL2)
      DIF  = 0.0
      IF (SOLID(J) .EQ. 0.0) GO TO 410
      X2   = VW(J,L1) - XN*R(J,L1)
      X1   = SQRT(VM(J,L1)**2+X2**2)
      X3   = VW(J,I) - U
      DIF  = 1.0 - VR/X1 + (X2-X3)/(2.0*X1*SOLID(J))*Q
  410 PRL1 = PRL2
      PSL1 = PSL2
      IF (L2 .EQ. L1) GO TO 420
      PSL1 = H(J,L1) - (VW(J,L1)**2 + VM(J,L1)**2)/(2.0*G*EJ)
      PRL1 = PSL1 + (VM(J,L1)**2 + (VW(J,L1)-XN*R(J,L1))**2)/(2.0*G*EJ)
      PSL1 = ALG4(PSL1,S(J,L1))
      PRL1 = ALG4(PRL1,S(J,L1))
  420 DPQ  = (PS(J)-PSL1)/(PRL1-PSL1)
  430 IF (IPRTC .EQ. 1) WRITE (LOG2,434) J,U,VR,XMR,BETA,DELTB(J),BBETA,
     1    TANEPS(J),DELP,COEF,DIF,DPQ
  434 FORMAT (I6,F14.2,F11.2,F11.4,4F11.3,F11.4,F11.5,F10.4,F11.4)
      CALL ALG03 (LNCT,NSTRMS+5)
      PBAR = 0.0
      HBAR = 0.0
      DO 440 J = 1,ITUB
      X1   = (DELF(J+1)-DELF(J))/2.0
      PBAR = PBAR + X1*(PT(J)+PT(J+1))
  440 HBAR = HBAR + X1*(H(J,I)+H(J+1,I))
      RBAR1= PBAR/P1BAR
      DH1  = (HBAR-H1BAR)/H1BAR
      EFF1 = 0.0
      IF (HBAR .NE. H1BAR) EFF1 = (ALG2(S1BAR,PBAR)-H1BAR)/(HBAR-H1BAR)
      OPR  = RBAR1
      IF (EFF1 .NE. 0.0) OEFF = EFF1
      IF (L1 .EQ. L1KEEP) GO TO 460
      L1KEEP= L1
      PNBAR = 0.0
      HNBAR = 0.0
      DO 444 J = 1,NSTRMS
  444 PN(J) = ALG4(H(J,L1),S(J,L1))
      DO 450 J = 1,ITUB
      X1    = (DELF(J+1)-DELF(J))/2.0
      PNBAR = PNBAR + X1*(PN(J)+PN(J+1))
  450 HNBAR = HNBAR + X1*(H(J,L1)+H(J+1,L1))
      SNBAR = ALG3(PNBAR,HNBAR)
  460 EFFN  = 0.0
      IF (HNBAR .NE. HBAR) EFFN = (ALG2(SNBAR,PBAR)-HNBAR)/(HBAR-HNBAR)
      RBARN = PBAR/PNBAR
      DHN   = (HBAR-HNBAR)/HNBAR
      IF (IPRTC .EQ. 1) WRITE (LOG2,470) I,L1,I,I,L1,I,RBAR1,RBARN,EFF1,
     1    EFFN,DH1,DHN
  470 FORMAT (/,'  STREAM',7X,'INLET THROUGH STATION',I3,7X,'STATION',
     1       I3,' THROUGH STATION',I3,5X,'MEAN VALUES',6X,
     2       'INLET TO STA.',I2,'   STA.',I2,' TO STA.',I2, /,
     3       '  -LINE',6X,'PRESSURE  ISENTROPIC  DELTA H    PRESSURE  ',
     4       'ISENTROPIC  DELTA H     PRESSURE RATIO',F14.4,F19.4, /15X,
     5       'RATIO   EFFICIENCY  ON H1        RATIO   EFFICIENCY  ON ',
     6       'H1       ISEN EFFY',2F19.4, /80X,'DELTA H ON H1',F15.4,
     7       F19.4)
      DO 480 J = 1,NSTRMS
      RBAR1 = PT(J)/P1(J)
      EFF1  = 0.0
      IF (H(J,I) .NE. H(J,1)) EFF1 = (ALG2(S(J,1),PT(J))-H(J,1))/
     1                               (H(J,I)-H(J,1))
      DH1   = (H(J,I)-H(J,1))/H(J,1)
      RBARN = PT(J)/PN(J)
      EFFN  = 0.0
      IF (H(J,I) .NE. H(J,L1)) EFFN = (ALG2(S(J,L1),PT(J))-H(J,L1))/
     1                                (H(J,I)-H(J,L1))
      DHN = (H(J,I)-H(J,L1))/H(J,L1)
  480 IF (IPRTC .EQ. 1) WRITE (LOG2,490) J,RBAR1,EFF1,DH1,RBARN,EFFN,DHN
  490 FORMAT (I6,F14.4,F10.4,F11.4,F12.4,F10.4,F11.4)
  500 IF (IFLE .EQ. 0) GO TO 700
      CALL ALG03 (LNCT,NSTRMS+8)
      XN = SPEED(I+1)*SPDFAC(ICASE)
      IP = I + 1
      XBLADE = 10.0
      IF (NBLADE(IP) .NE. 0) XBLADE = ABS(FLOAT(NBLADE(IP)))
      L1 = XBLADE
      IF (IPRTC .EQ. 1) WRITE (LOG2,510) I,XN,L1
  510 FORMAT (/10X,'STATION',I3,' IS AT THE LEADING EDGE OF A BLADE ',
     1        'ROATING AT',F9.1,' RPM  NUMBER OF BLADES IN ROW =',I3,
     2        /10X,99(1H*), //,'  STREAM      BLADE     RELATIVE   ',
     3        'RELATIVE   RELATIVE  INCIDENCE    BLADE      LEAN    ',
     4        'PRESS DIFF', /,'  -LINE       SPEED     VELOCITY   MACH',
     5        ' NO.  FLOW ANGLE   ANGLE      ANGLE      ANGLE   ACROSS',
     6        ' BLADE',/)
      XN = XN*PI/(30.0*SCLFAC)
      Q  = 1.0
      IF (SPEED(IP) .LT. 0.0) GO TO 550
      IF (SPEED(IP) .GT. 0.0) GO TO 540
      IF (IP .LT. 3) GO TO 550
      II = IP - 1
  520 IF (SPEED(II) .NE. 0.0) GO TO 530
      IF (II .EQ. 2) GO TO 550
      II = II - 1
      GO TO 520
  530 IF (SPEED(II) .LT. 0.0) Q = -1.0
      GO TO 550
  540 Q = -1.0
  550 DO 560 J = 1,NSTRMS
      CR(J) = 0.0
  560 TANEPS(J) = 0.0
      IF (NWORK(I).NE.0 .OR. NDATA(I).EQ.0) GO TO 660
      L1 = NDIMEN(I) + 1
      GO TO (570,590,610,630), L1
  570 DO 580 J = 1,NSTRMS
  580 TANEPS(J) = R(J,I)
      GO TO 650
  590 DO 600 J = 1,NSTRMS
  600 TANEPS(J) = R(J,I)/R(NSTRMS,I)
      GO TO 650
  610 DO 620 J = 1,NSTRMS
  620 TANEPS(J) = XL(J,I)
      GO TO 650
  630 DO 640 J = 1,NSTRMS
  640 TANEPS(J) = XL(J,I)/XL(NSTRMS,I)
  650 L1 = IS2(I)
      CALL ALG01 (DATAC(L1),DATA1(L1),NDATA(I),TANEPS,CR,X1,NSTRMS,
     1            NTERP(I),0)
      CALL ALG01 (DATAC(L1),DATA3(L1),NDATA(I),TANEPS,TANEPS,X1,NSTRMS,
     1            NTERP(I),0)
  660 BBETA = 0.0
      DO 680 J = 1,NSTRMS
      U   = XN*R(J,I)
      VR  = SQRT(VM(J,I)**2 + (VW(J,I)-U)**2)
      XMR = XM(J)*VR/V(J)
      TR(J,I) = ALG7(H(J,I)-(V(J)**2-VR**2)/(2.0*G*EJ),S(J,I))
      BETA = ATAN((VW(J,I)-U)/VM(J,I))*C1
C
C     STORE REL. MACH, REL. VEL AND REL. FLOW ANGLE FOR ALL STREAMLINES
C     AT THE BLADE LEADING EDGE
C
      IF (ICASE.NE.1 .OR. I.NE.LEDGEB) GO TO 675
      RMDV(J,1) = XMR
      RMDV(J,3) = VR
      RMDV(J,4) = BETA
  675 CONTINUE
      DELTB(J) = 0.0
      IF (NWORK(I).NE.0 .OR. NDATA(I).EQ.0) GO TO 670
      BBETA = ATAN((TAN(CR(J)/C1)*(1.0-GAMA(J)*TAN(PHI(J))) -
     1        TAN(PHI(J))*TAN(TANEPS(J)/C1)*SQRT(1.0+GAMA(J)**2))*
     2        COS(PHI(J)))*C1
      DELTB(J) = (BETA-BBETA)*Q
  670 X1   = SQRT((R(J,I+1)-R(J,I))**2+(X(J,I+1)-X(J,I))**2)
      DELP = PI*R(J,I)*2.0*WT(J)/(SCLFAC**2*XBLADE*G)*(SIN(BETA/C1)*
     1       COS(BETA/C1)*G*EJ*TS(J)*(S(J,I+1)-S(J,I))/X1+VM(J,I)/
     2       (R(J,I)*X1)*(R(J,I+1)*VW(J,I+1)-R(J,I)*VW(J,I)))
      DELTP(J,I) = DELP
  680 IF (IPRTC .EQ. 1) WRITE (LOG2,690) J,U,VR,XMR,BETA,DELTB(J),BBETA,
     1    TANEPS(J),DELP
  690 FORMAT (I6,F14.2,F11.2,F11.4,4F11.3,F11.4)
  700 CONTINUE
      IF (NBL .EQ. 0) GO TO 770
      L1 = (ILAST-1)/10 + 1
      CALL ALG03 (LNCT,3+5*L1)
      IF (IPRTC .NE. 1) GO TO 770
      WRITE  (LOG2,710)
  710 FORMAT (/10X,'ANNULUS WALL BOUNDARY LAYER CALCULATION RESULTS',
     1        /10X,47(1H*))
      DO 720 K = 1,L1
      L2 = 10*(K-1) + 1
      L3 = L2 + 9
      IF (L3 .GT. ILAST) L3 = ILAST
      WRITE (LOG2,730) (I,I=L2,L3)
      WRITE (LOG2,740) (DELH(I),I=L2,L3)
      WRITE (LOG2,750) (DELT(I),I=L2,L3)
      WRITE (LOG2,760) (WWBL(I),I=L2,L3)
  720 CONTINUE
  730 FORMAT (/,' STATION NUMBER',14X,10I10)
  740 FORMAT (' HUB DISPLACEMENT THICKNESS',4X,10F10.5)
  750 FORMAT (' CASE DISPLACEMENT THICKNESS',3X,10F10.5)
  760 FORMAT (' BLOCKAGE AREA FRACTION',8X,10F10.5)
  770 CALL ALG03 (LNCT,4)
      IF (IPRTC.EQ.1 .AND. IVFAIL.EQ.0.AND.IFFAIL.EQ.0) WRITE (LOG2,780)
     1    ICASE,IPASS
      IF (IFAILO .NE. 0) WRITE (LOG2,790) ICASE,IPASS,IFAILO
      IF (IFAILO.EQ.0 .AND. (IVFAIL.NE.0.OR.IFFAIL.NE.0))
     1    WRITE (LOG2,800) ICASE,IPASS,IVFAIL,IFFAIL
  780 FORMAT (/10X,'POINT NO',I3,'   PASS',I3,'   THE CALCULATION IS ',
     1       'CONVERGED', /10X,52(1H*))
  790 FORMAT (/10X,'POINT NO',I3,'   PASS',I3,'   THE CALCULATION FAIL',
     1       'ED AT STATION',I3, /10X,60(1H*))
  800 FORMAT (/10X,'POINT NO',I3,'   PASS',I3,'   THE CALCULATION IS ',
     1       'NOT FULLY CONVERGED  IVFAIL =',I3,'  IFFAIL =',I3, /10X,
     2       88(1H*))
      POWER = FLOW(ICASE)*(HBAR-H1BAR)*EJ/PFAC
      IF (IPRTC .EQ. 1) WRITE (LOG2,810) SPDFAC(ICASE),FLOW(ICASE),OPR,
     1        OEFF,POWER
  810 FORMAT (10X,'SPEED FACTOR =',F10.3,'  FLOW =',F8.3,'  TOTAL PRES',
     1        'SURE RATIO =',F7.3,'  ISENTROPIC EFFICIENCY =',F6.4,
     2        '  POWER =',E11.4)
      IF (IPRTC .EQ. 0) WRITE (LOG2,815) ICASE,IPASS,SPDFAC(ICASE),
     1        FLOW(ICASE),OPR,OEFF,POWER
  815 FORMAT  (18H     FOR POINT NO.,I3,5H PASS,I3,15H - SPEED FACTOR,
     1        10X,1H=,F10.4 / 32X,4HFLOW,18X,1H=,F10.4, /
     2        32X,23HTOTAL PRESSURE RATIO  =,F10.4, /32X,'ISENTROPIC ',
     3        'EFFICIENCY =',F10.4, /32X,'POWER',17X,1H=,E10.4)
      IF (IFAILO .NE. 0) GO TO 920
      L1 = 2
  820 DO 830 I = L1,NSTNS
      NOUT3S = NOUT3(I)/10
      IF (NOUT3S .EQ. 0) NOUT3S = NOUT3(I)
      IF (NOUT3S.EQ.1 .OR. NOUT3S.EQ.3) GO TO 840
  830 CONTINUE
      GO TO 920
  840 L2 = I
      L3 = I + 1
      DO 850 I = L3,NSTNS
      NOUT3S = NOUT3(I)/10
      NOUT3T = NOUT3(I) - NOUT3S*10
      IF (NOUT3S .EQ. 0) NOUT3T = 1
      IF (NOUT3S .EQ. 0) NOUT3S = NOUT3(I)
      IF (NOUT3S.EQ.2 .OR. NOUT3S.EQ.3) GO TO 860
  850 CONTINUE
  860 L3 = I
      CALL ALG03 (LNCT,10)
      IF (IPRTC .EQ. 1) WRITE (LOG2,870) L2,L3
  870 FORMAT (/10X,'DATA FOR NASTRAN PROGRAM FOR BLADE BETWEEN STATIONS'
     1,      I3,' AND',I3, /10X,61(1H*),//)
      IF (NOUT3T .EQ. 2) GO TO 891
      IF (IPRTC  .EQ. 1) WRITE (LOG2,871)
  871 FORMAT (' NAME   CODE    DELTA P   ELEMENT',7X,
     1       'MESHPOINTS -  J   I',9X,'J   I',9X,'J   I',/)
      LNCT  = LNCT - 4
      IELEM = 0
      XSIGN =-FLOAT(NSIGN)
      L4    = L2 + 1
      IDATA(1) = NAME1(1)
      IDATA(2) = NAME1(2)
      IDATA(3) = 60
      DO 890 J = 1,ITUB
      DO 890 I = L4,L3
      CALL ALG03 (LNCT,2)
      IELEM = IELEM + 1
      L5 = I - 1
      L6 = J + 1
      IF (I .EQ. L3) GO TO 880
      PLOAD = XSIGN*((DELTP(J,L5)+DELTP(L6,L5)+DELTP(L6,I))/3.0)
      IF (NBLADE(I) .LT. 0) PLOAD = XSIGN*((DELTP(J,L5)+DELTP(J,I) +
     1    DELTP(L6,L5)+DELTP(L6,I))*0.25)
      IF (IPRTC .EQ. 1) WRITE (LOG2,900) PLOAD,IELEM,L6,L5,L6,I,J,L5
      RDATA(4) = PLOAD
      IDATA(5) = IELEM
      CALL WRITE (ISCR,IDATA,5,1)
      IELEM = IELEM + 1
      IF (NBLADE(I) .GE. 0) PLOAD = XSIGN*((DELTP(J,L5)+DELTP(L6,I)+
     1    DELTP(J,I))/3.0)
      IF (IPRTC .EQ. 1) WRITE (LOG2,900) PLOAD,IELEM,J,L5,L6,I,J,I
      RDATA(4) = PLOAD
      IDATA(5) = IELEM
      CALL WRITE (ISCR,IDATA,5,1)
      GO TO 890
  880 PLOAD    = XSIGN*((DELTP(J,L5)+DELTP(L6,L5))/3.0)
      IF (NBLADE(I) .LT. 0) PLOAD = PLOAD*0.75
      IF (IPRTC .EQ. 1) WRITE (LOG2,900) PLOAD,IELEM,J,L5,L6,L5,L6,I
      RDATA(4) = PLOAD
      IDATA(5) = IELEM
      CALL WRITE (ISCR,IDATA,5,1)
      IELEM    = IELEM + 1
      IF (NBLADE(I) .GE. 0) PLOAD = XSIGN*(DELTP(J,L5)/3.0)
      IF (IPRTC .EQ. 1) WRITE (LOG2,900) PLOAD,IELEM,J,L5,L6,I,J,I
      RDATA(4) = PLOAD
      IDATA(5) = IELEM
      CALL WRITE (ISCR,IDATA,5,1)
  890 CONTINUE
  900 FORMAT (' PLOAD2   60',F12.5,I7,14X,3(I10,I4))
      L1 = L3
  891 IF (NOUT3T .EQ. 1) GO TO 820
C
C     OUTPUT RELATIVE TOTAL TEMPERATURES AT NODES ON *TEMP* CARDS
C
      CALL ALG03 (LNCT,10)
      LNCT = LNCT - 6
      IF (IPRTC .EQ. 1) WRITE (LOG2,892)
  892 FORMAT (//,' NAME   CODE    DELTA T   NODE',10X,'MESHPOINTS -  ',
     1        'J   I   COORDINATES -   RADIAL       AXIAL',/)
      INODE = 1
      IDATA(1) = NAME2(1)
      IDATA(2) = NAME2(2)
      IDATA(3) = 70
      DO 894 J = 1,NSTRMS
      DO 894 I = L2,L3
      CALL ALG03(LNCT,1)
      IDATA(4) = INODE
      RDATA(5) = TR(J,I)
      CALL WRITE (ISCR,IDATA,5,1)
      IF (IPRTC .EQ. 1) WRITE (LOG2,912) TR(J,I),INODE,J,I,R(J,I),X(J,I)
  894 INODE = INODE + 1
  912 FORMAT (' TEMP     70',F12.5,I6,21X,2I4,16X,F10.4,2X,F10.4)
      GO TO 820
  920 CONTINUE
C
C     PUNCH STREAML2 BULK DATA CARDS FOR EACH STREAMLINE
C     CHANGE THE SIGN ON THE STAGGER AND FLOW ANGLES FOR STREAML2 CARDS.
C     THIS CHANGE IS NECESSARY BECAUSE OF THE AERODYNAMIC PROGRAMS IN
C     NASTRAN MODULE AMG THAT USE THESE ANGLES.
C
      IF (LEDGEB*ITRLEB .EQ. 0) GO TO 940
      IF (ISTRML.EQ.-1 .OR. ISTRML.EQ.1) GO TO 940
      WRITE (LOG2,931)
      NSTNSX = ITRLEB - LEDGEB + 1
      DO 930 ILEB = 1,NSTRMS
      RADIUS = (RMDV(ILEB,5)+RMDV(ILEB,6))/2.0
      BSPACE = (6.283185*RADIUS)/FLOAT(NBLDES)
      STAG(ILEB  ) = -1.0*STAG(ILEB  )
      RMDV(ILEB,4) = -1.0*RMDV(ILEB,4)
      WRITE (LPUNCH,932) ILEB,NSTNSX,STAG(ILEB),CHORDD(ILEB),RADIUS,
     1       BSPACE,RMDV(ILEB,1),RMDV(ILEB,2),ILEB,ILEB,RMDV(ILEB,3),
     2       RMDV(ILEB,4)
      WRITE (LOG2,933) ILEB,NSTNSX,STAG(ILEB),CHORDD(ILEB),RADIUS,
     1       BSPACE,RMDV(ILEB,1),RMDV(ILEB,2),RMDV(ILEB,3),RMDV(ILEB,4)
  930 CONTINUE
  931 FORMAT (//10X,47HNASTRAN - STREAML2 - COMPRESSOR BLADE BULK DATA,
     1       /10X,49(1H*), /,'  SLN  NSTNS  STAGGER    CHORD    RADIUS',
     2       '    BSPACE     MACH       DEN       VEL      FLOWA',/)
  932 FORMAT (8HSTREAML2,2I8,F8.3,3F8.5,2F8.6,5H+STRL,I2,5H+STRL,I2,
     1        F8.1,F8.3 )
  933 FORMAT (I5,I6,2X,F8.3,3(2X,F8.5),2(2X,F8.6),2X,F8.1,2X,F8.3)
  940 CONTINUE
      RETURN
      END

      SUBROUTINE DDRMM1 (*,*,*,*)
C
C     PERFORMS SORT1 TYPE PROCESSING FOR MODULE DDRMM.
C
      LOGICAL         SORT2    ,COL1     ,FRSTID   ,IDOUT    ,TRNSNT  ,
     1                ANYXY    ,LMINOR
      INTEGER         BUF1     ,BUF2     ,BUF3     ,BUF4     ,BUF5    ,
     1                BUF6     ,BUFF     ,EOR      ,RD       ,RDREW   ,
     2                WRT      ,WRTREW   ,CLS      ,CLSREW   ,ELEM    ,
     3                IA(4)    ,SETS     ,ENTRYS   ,SYSBUF   ,OUTPT   ,
     4                PASSES   ,OUTFIL   ,FILE     ,DHSIZE   ,FILNAM  ,
     5                SETID    ,FORM     ,DEVICE   ,PHASE    ,SCRT    ,
     6                SCRT1    ,SCRT2    ,SCRT3    ,SCRT4    ,SCRT5   ,
     7                SCRT6    ,SCRT7    ,DVAMID(3),BUF(150) ,Z(1)    ,
     8                UVSOL    ,SUBCAS   ,SAVDAT   ,SAVPOS   ,BUFSAV
      REAL            RIDREC(6),LAMBDA
      CHARACTER       UFM*23   ,UWM*25   ,UIM*29   ,SFM*25   ,SWM*27
      COMMON /XMSSG / UFM      ,UWM      ,UIM      ,SFM      ,SWM
      COMMON /STDATA/ LMINOR   ,NSTXTR   ,NPOS     ,SAVDAT(75)        ,
     1                SAVPOS(25)         ,BUFSAV(10)
      COMMON /SYSTEM/ SYSBUF   ,OUTPT
      COMMON /NAMES / RD       ,RDREW    ,WRT      ,WRTREW   ,CLSREW  ,
     1                CLS
      COMMON /ZBLPKX/ A(4)     ,IROW
      COMMON /ZNTPKX/ AOUT(4)  ,IROWO    ,IEOL     , IEOR
      COMMON /GPTA1 / NELEM    ,LAST     ,INCR     ,ELEM(1)
      COMMON /ZZZZZZ/ RZ(1)
      COMMON /MPYADX/ MCBA(7)  ,MCBB(7)  ,MCBC(7)  ,MCBD(7)  ,LZ      ,
     1                ITFLAG   ,ISINAB   ,ISINC    ,IPREC    ,ISCRT
      COMMON /DDRMC1/ IDREC(146),BUFF(6) ,PASSES   ,OUTFIL   ,JFILE   ,
     1                MCB(7)   ,ENTRYS   ,SETS(5,3),INFILE   ,LAMBDA  ,
     2                FILE     ,SORT2    ,COL1     ,FRSTID   ,NCORE   ,
     3                NSOLS    ,DHSIZE   ,FILNAM(2),RBUF(150),IDOUT   ,
     4                ICC      ,NCC      ,ILIST    ,NLIST    ,NWDS    ,
     5                SETID    ,TRNSNT   ,I1       ,I2       ,PHASE   ,
     6                ITYPE1   ,ITYPE2   ,NPTSF    ,LSF      ,NWDSF   ,
     7                SCRT(7)  ,IERROR   ,ITEMP    ,DEVICE   ,FORM    ,
     8                ISTLST   ,LSTLST   ,UVSOL    ,NLAMBS   ,NWORDS  ,
     9                OMEGA    ,IPASS    ,SUBCAS
      COMMON /CONDAS/ PI       ,TWOPI
      EQUIVALENCE     (SCRT1,SCRT(1)), (SCRT2,SCRT(2)), (SCRT3,SCRT(3)),
     1                (SCRT4,SCRT(4)), (SCRT5,SCRT(5)), (SCRT6,SCRT(6)),
     2                (SCRT7,SCRT(7)), (BUF1 ,BUFF(1)), (BUF2 ,BUFF(2)),
     3                (BUF3 ,BUFF(3)), (BUF4 ,BUFF(4)), (BUF5 ,BUFF(5)),
     4                (BUF6 ,BUFF(6)), (A(1) ,  IA(1)), (Z(1) ,  RZ(1)),
     5                (IDREC(1),RIDREC(1)), (BUF(1),RBUF(1))
      DATA    EOR   , NOEOR / 1, 0 /, DVAMID / 1, 10, 11 /
C
C     FORMATION OF DATA-MATRIX AND SUBSEQUENT MULTIPLY BY SOLUTION-
C     MATRIX AND ULTIMATE OUTPUT OF TRANSIENT OR FREQUENCY SOLUTIONS.
C
      IPASS  = 1
   20 COL1   = .TRUE.
      FRSTID = .TRUE.
      SETID  = SETS(1,IPASS)
      DEVICE = SETS(2,IPASS)
      FORM   = SETS(3,IPASS)
      ISTLST = SETS(4,IPASS)
      LSTLST = SETS(5,IPASS)
C
C     GET LIST OF XYPLOT REQUESTED IDS FOR CURRENT SUBCASE AND
C     OUTFIL TYPE.
C
      GO TO (22,23,24,25), JFILE
C
C     DISPLACEMENT, VELOCITY, ACCELERATION
C
   22 IXYTYP = IPASS
      GO TO 26
C
C     SPCF
C
   23 IXYTYP = 4
      GO TO 26
C
C     STRESS
C
   24 IXYTYP = 6
      GO TO 26
C
C     FORCE
C
   25 IXYTYP = 7
      GO TO 26
C
   26 IXY = NLIST + 1
      CALL DDRMMP (*380,Z(IXY),BUF3-IXY,LXY,IXYTYP,SUBCAS,Z(BUF3),ANYXY)
      IF (.NOT.ANYXY .AND. SETID.EQ.0) GO TO 280
      NXY = IXY + LXY - 1
C
C     INITIALIZE DATA MATRIX FILE(SCRT5), AND MAPPING TABLE FILE(SCRT4).
C
      IERROR = 22
      FILE = SCRT4
      CALL OPEN (*350,SCRT4,Z(BUF3),WRTREW)
      FILE = SCRT5
      CALL OPEN (*350,SCRT5,Z(BUF2),WRTREW)
      CALL FNAME (SCRT5,FILNAM)
      CALL WRITE (SCRT5,FILNAM,2,EOR)
C
C     GENERAL LOGIC TO BUILD SORT1 FORMAT DATA MATRIX.
C
C     EACH COLUMN WRITTEN HERE REPRESENTS ONE EIGENVALUE.
C
C          COMPONENTS FOR FIRST ID   *
C              .                      *
C              .                       *
C              .                        *
C          COMPONENTS FOR NEXT ID        * ONE COLUMN
C              .                        *  OF DATA FOR EACH EIGENVALUE.
C              .                       *
C              .                      *
C             ETC                    *
C     --------------------------------------------- EOR
C
C          IDENTICAL COMPONENTS ARE REPRESENTED IN EACH COLUMN.
C
C
C     READ AN OFP-ID-RECORD AND SET PARAMETERS.
C     (ON ENTRY TO THIS PROCESSOR THE FIRST ID RECORD IS AT HAND)
C
      FILE   = INFILE
      MCB(1) = SCRT5
      MCB(2) = 0
      MCB(3) = 0
      MCB(4) = 2
      MCB(5) = 1
      MCB(6) = 0
      MCB(7) = 0
      IF (IPASS.EQ.1 .AND. FRSTID) GO TO 50
   40 CALL READ (*130,*130,INFILE,IDREC,146,EOR,NWDS)
      MAJID = MOD(IDREC(2),1000)
      IF (MAJID .NE. ITYPE1) GO TO 310
C
C     IF FIRST COLUMN, OFP-ID RECORD IS WRITTEN AS IS TO MAP FILE.
C
   50 IF (.NOT. COL1) GO TO 60
      IF (.NOT.FRSTID .AND. RIDREC(6).NE.LAMBDA) GO TO 60
      CALL WRITE (SCRT4,IDREC,146,EOR)
   60 LENTRY = IDREC(10)
      I1 = NWORDS + 1
      I2 = LENTRY
      MINOR = IDREC(3)
C
C     IF SAME EIGENVALUE AS THAT OF LAST OFP-ID RECORD THEN CONTINUE.
C
      IF (FRSTID) GO TO 70
      IF (RIDREC(6) .EQ. LAMBDA) GO TO 80
C
C     NEW EIGENVALUE. COMPLETE CURRENT DATA MATRIX COLUMN AND START
C     NEW COLUMN. PASS ONE IS NOW COMPLETE.
C
      CALL BLDPKN (SCRT5,0,MCB)
      IF (COL1) IROW1 = IROW
      IF (IROW .NE. IROW1) GO TO 290
      COL1 = .FALSE.
C
C     START NEW COLUMN.
C
   70 CALL BLDPK (1,1,SCRT5,0,0)
      IROW   = 0
      FRSTID = .FALSE.
      LAMBDA = RIDREC(6)
C
C     READ A POINT OR ELEMENT ENTRY.
C
   80 CALL READ (*360,*120,INFILE,BUF,LENTRY,NOEOR,NWDS)
      ID = BUF(1)/10
C
C     CHECK FOR ID IN OUTPUT REQUEST LIST
C
      IDVICE = DEVICE
      IF (SETID) 100,95,90
C
C//// NEXT MAY NOT NEED TO BE INITIALIZED EVERY TIME.
C
   90 NEXT = 1
      CALL SETFND (*95,Z(ISTLST),LSTLST,ID,NEXT)
      GO TO 100
   95 IF (.NOT. ANYXY) GO TO 80
      CALL BISLOC (*80,ID,Z(IXY),1,LXY,JP)
      IDVICE = 0
C
C     THIS ID IS TO BE OUTPUT.
C
  100 IF (.NOT. COL1) GO TO 105
      BUF(1) = 10*ID + IDVICE
      CALL WRITE (SCRT4,BUF(1),NWORDS,NOEOR)
      NSTXTR = 0
      IF (ITYPE1.NE.5 .OR. SAVDAT(MINOR).EQ.0) GO TO 104
      NPOS   = SAVDAT(MINOR)/100
      NSTXTR = SAVDAT(MINOR) - NPOS*100
      DO 101 I = 1,NSTXTR
      J = SAVPOS(NPOS+I-1)
  101 BUFSAV(I) = BUF(J)
      CALL WRITE (SCRT4,BUFSAV(1),NSTXTR,NOEOR)
  104 CONTINUE
C
C     OUTPUT TO DATA MATRIX THE COMPONENTS OF THIS ENTRY.
C
  105 DO 110 I = I1,I2
      IROW = IROW + 1
      A(1) = RBUF(I)
C
C     GET RID OF INTEGERS.
C
C     OLD LOGIC -
C     IF (MACH.NE.5 .AND.  IABS(IA(1)) .LT.   100000000) A(1) = 0.0
C     IF (MACH.EQ.5 .AND. (IA(1).LE.127.AND.IA(1).GE.1)) A(1) = 0.0
C     OLD LOGIC SHOULD INCLUDE ALPHA MACHINE (MACH=21)
C
C     NEW LOGIC BY G.CHAN/UNISYS, 8/91 -
      IF (NUMTYP(IA(1)) .LE. 1) A(1) = 0.0
C
      CALL ZBLPKI
  110 CONTINUE
      GO TO 80
C
C     END OF CURRENT OFP-DATA RECORD ENCOUNTERED.
C     IF NEXT OFP-ID-RECORD INDICATES ANOTHER OFP-DATA RECORD FOR
C     THIS SAME EIGENVALUE (I.E. A CHANGE IN ELEMENT TYPE) THEN
C     FURTHER CONSTRUCTION OF THE DATA MATRIX COLUMN TAKES PLACE.
C
  120 IF (COL1) CALL WRITE (SCRT4,0,0,EOR)
      GO TO 40
C
C     END OF FILE ENCOUNTERED ON INFILE.
C     DATA MATRIX AND MAPING FILE ARE COMPLETE.
C
  130 CALL CLOSE (INFILE,CLSREW)
      CALL CLOSE (SCRT4 ,CLSREW)
C
C     COMPLETE LAST COLUMN OF DATA MATRIX WRITTEN.
C
      IF (COL1) IROW1 = IROW
      IF (IROW .NE. IROW1) GO TO 310
      CALL BLDPKN (SCRT5,0,MCB)
      MCB(3) = IROW
      CALL WRTTRL (MCB)
      CALL CLOSE (SCRT5,CLSREW)
C
C     TO GET SOLUTION MATRIX BASED ON SORT-1 INFILE.
C
C     SOLVE,
C              (DATA MATRIX)     X    (MODAL SOLUTION MATRIX)
C             NCOMPS X NLAMBS           NLAMBS X NSOLUTIONS
C             ===============         =======================
C
C     RESULTANT MATRIX IS NCOMPS BY NSOLUTIONS IN SIZE.
C
C
C     MATRIX MULTIPLY SETUP AND CALL.
C
      MCBA(1) = SCRT5
      CALL RDTRL (MCBA)
      MCBB(1) = UVSOL
      IF (TRNSNT) MCBB(1) = SCRT(IPASS)
      CALL RDTRL (MCBB)
      MCBC(1) = 0
      MCBD(1) = SCRT6
      MCBD(2) = 0
      MCBD(3) = IROW
      MCBD(4) = 2
      MCBD(5) = 1
      MCBD(6) = 0
      MCBD(7) = 0
      IF (.NOT.TRNSNT) MCBD(5) = 3
      NXY1    = NXY + 1
      IF (MOD(NXY1,2) .EQ. 0) NXY1 = NXY1 + 1
      LZ      = KORSZ(Z(NXY1))
      ITFLAG  = 0
      ISINAB  = 1
      ISINC   = 1
      IPREC   = 1
      ISCRT   = SCRT7
      CALL MPYAD (Z(NXY1),Z(NXY1),Z(NXY1))
      MCBD(1) = SCRT6
      CALL WRTTRL (MCBD)
C
C     PRODUCT MATRIX IS NOW OUTPUT, USING THE MAP ON SCRT4 FOR EACH
C     COLUMN.  (SORT-1)  PRODUCT MATRIX IS ON SCRATCH DATA BLOCK 6.
C
      IERROR = 10
      FILE = OUTFIL
      CALL OPEN (*350,OUTFIL,Z(BUF1),WRT)
      FILE = SCRT4
      CALL OPEN (*350,SCRT4,Z(BUF2),RDREW)
      FILE = SCRT6
      CALL OPEN (*350,SCRT6,Z(BUF3),RDREW)
      CALL FWDREC (*360,SCRT6)
      JLIST = ILIST
C
C     LOOP ON COLUMNS OF SCRT6.
C
  140 CALL DDRMMA (.TRUE.)
C
C     READ AN OFP-ID-RECORD FROM THE MAP.
C
      FILE = SCRT4
  150 CALL READ (*270,*370,SCRT4,IDREC,146,EOR,NWDS)
C
C     SET THE FREQUENCY OR TIME AND CLOBBER THE EIGENVALUE.
C
      RIDREC(5) = RZ(JLIST)
      RIDREC(6) = 0.0
      IDOUT = .FALSE.
      MINOR = IDREC(3)
C
C     SET NUMBER OF STRESS OR FORCE WORDS AND COMPLEX POINTERS IF
C     NECESSARY
C
      ITYPE2 = IDREC(3)
      IF (ITYPE1.EQ.3 .OR. ITYPE1.EQ.7) GO TO 200
      IELEM = (ITYPE2-1)*INCR
      IF (ITYPE1 .EQ. 4) GO TO 180
      IF (ITYPE1 .EQ. 5) GO TO 190
      WRITE  (OUTPT,170) SWM,ITYPE1,ITYPE2,INFILE
  170 FORMAT (A27,' 2334.  (DDRMM-3) ILLEGAL MAJOR OR MINOR OFP-ID ',
     1       'IDENTIFICATIONS =',2I10, /5X,'DETECTED IN DATA BLOCK',I5,
     2       '. PROCESSING OF SAID DATA BLOCK DISCONTINUED.')
      GO TO 340
C
C     FORCES ASSUMED.
C
  180 LSF   = ELEM(IELEM+19)
      NPTSF = ELEM(IELEM+21)
      NWDSF = LSF
      GO TO 220
C
C     STRESSES ASSUMED.
C
  190 LSF   = ELEM(IELEM+18)
      NPTSF = ELEM(IELEM+20)
      NWDSF = LSF
      GO TO 220
C
C     SPCF OR DISPLACEMENTS ASSUMED
C
  200 IF (.NOT.TRNSNT) GO TO 210
      NWDSF = 8
      GO TO 220
  210 NWDSF = 14
C
C     SET OMEGA IF THIS IS THE VELOCITY OR ACCELERATION PASS
C
      GO TO (220,211,212), IPASS
C
C     OMEGA FOR VELOCITY PASS
C
  211 OMEGA = TWOPI*RZ(JLIST)
      GO TO 220
C
C     OMEGA FOR ACCELERATION PASS
C
  212 OMEGA = -((TWOPI*RZ(JLIST))**2)
C
  220 LENTRY = IDREC(10)
      I1 = NWORDS + 1
      I2 = LENTRY
C
C
C     SET DISPLACEMENT, VELOCITY, OR ACCELERATION OFP MAJOR ID IF INFILE
C     IS MODAL DISPLACEMENTS.
C
      IF (ITYPE1 .NE. 7) GO TO 230
      IDREC(2) = DVAMID(IPASS)
  230 IF (.NOT.TRNSNT) IDREC(2) = IDREC(2) + 1000
C
C     RESET APPROACH CODE FROM EIGENVALUE TO TRANSIENT OR FREQUENCY
C
      IAPP = 5
      IF (TRNSNT) IAPP = 6
      IDREC(1) = 10*IAPP + DEVICE
C
C     FILL TITLE, SUBTITLE, AND LABEL FROM CASECC FOR THIS SUBCASE.
C
      DO 238 I = 1,96
      IDREC(I+50) = Z(ICC+I+37)
  238 CONTINUE
      IDREC(4) = SUBCAS
C
C     READ FIRST WORDS OF OUTPUT ENTRY FROM MAP.
C
  240 CALL READ (*360,*260,SCRT4,BUF,NWORDS,NOEOR,NWDS)
      LMINOR = .TRUE.
      IF (ITYPE1.NE.5 .OR. SAVDAT(MINOR).EQ.0) GO TO 241
      NPOS   = SAVDAT(MINOR)/100
      NSTXTR = SAVDAT(MINOR) - NPOS*100
      CALL READ (*360,*370,SCRT4,BUFSAV(1),NSTXTR,NOEOR,NWDS)
      LMINOR = .FALSE.
  241 CONTINUE
C
C     GET BALANCE USING UTILITY WHICH WILL COLLECT AND MAP TOGETHER
C     AS REQUIRED REAL OR COMPLEX, AND GENERATE MAGNITUDE/PHASE IF
C     REQUIRED.  (THIS ROUTINE WILL BUFFER DATA IN FROM SCRT6 AS IT
C     NEEDS IT.)
C
      CALL DDRMMA (.FALSE.)
C
C     CALL DDRMMS TO RECOMPUTE SOME ELEMENT STRESS QUANTITIES
C     IN TRANSIENT PROBLEMS ONLY.
C
      IF (TRNSNT .AND. ITYPE1.EQ.5) CALL DDRMMS (BUF,ITYPE2,BUF4,BUF5)
      IF (IDOUT) GO TO 250
      IDREC( 9) = FORM
      IDREC(10) = NWDSF
      CALL WRITE (OUTFIL,IDREC,146,EOR)
      IDOUT = .TRUE.
C
C     OUTPUT THE COMPLETED ENTRY TO OFP OUTFIL.
C
  250 CALL WRITE (OUTFIL,BUF,NWDSF,NOEOR)
      GO TO 240
C
C     END OF ENTRIES FOR ONE ID-REC HIT.  IF NO EOF ON MAP WITH
C     NEXT READ, THEN CONTINUE OUTPUT OF THIS SOLUTION COLUMN.
C
  260 CALL WRITE (OUTFIL,0,0,EOR)
      GO TO 150
C
C     END OF FILE ON MAP.  THUS START NEXT COLUMN IF REQUIRED.
C
  270 JLIST = JLIST + 1
      IF (JLIST .GT. NLIST) GO TO 280
      CALL REWIND (SCRT4)
      GO TO 140
C
C     ALL DATA OF SOLUTION PRODUCT MATRIX HAS NOW BEEN OUTPUT.
C
  280 CALL CLOSE (OUTFIL,CLS)
      CALL CLOSE (INFILE,CLSREW)
      CALL CLOSE (SCRT4,CLSREW)
      CALL CLOSE (SCRT6,CLSREW)
      IPASS = IPASS + 1
      IF (IPASS .GT. PASSES) GO TO 340
C
C     PREPARE FOR ANOTHER PASS
C
      FILE = INFILE
      CALL OPEN (*350,INFILE,Z(BUF1),RDREW)
      CALL FWDREC (*360,INFILE)
      GO TO 20
C
C     DATA INCONSISTENCY ON -INFILE-.
C
  290 WRITE  (OUTPT,300) SWM,INFILE
  300 FORMAT (A27,' 2335.  (DDRMM1-1) THE AMOUNT OF DATA IS NOT ',
     1       'CONSISTENT FOR EACH EIGENVALUE IN DATA BLOCK',I5, /5X,
     2       'PROCESSING OF THIS DATA BLOCK TERMINATED.')
      GO TO 330
C
C     CHANGE IN MAJOR OFP-ID DETECTED ON -INFILE-.
C
  310 WRITE  (OUTPT,320) SWM,INFILE
  320 FORMAT (A27,' 2336.  (DDRMM1-2) A CHANGE IN WORD 2 OF THE OFP-ID',
     1       ' RECORDS OF DATA BLOCK',I5, /5X,'HAS BEEN DETECTED. ',
     2       ' POOCESSING OF THIS DATA BLOCK HAS BEEN TERMINATED.')
  330 IPASS = 3
      GO TO 280
C
C     COMPLETION OF PASS FOR INPUT MODAL SOLUTION -FILE-.
C
  340 RETURN
C
C     UNDEFINED FILE.
C
  350 RETURN 1
C
C     END OF FILE HIT.
C
  360 RETURN 2
C
C     END OF RECORD HIT.
C
  370 RETURN 3
C
C     INSUFFICIENT CORE.
C
  380 RETURN 4
      END

      SUBROUTINE MFREE
C     THIS ROUTINE GENERATES MASS TERMS FOR THE INTERNALLY CREATED
C     ELEMENT WHICH DESCRIBES FREE SURFACE EFFECTS
C*****
C     THE ECPT DATA IS
C         NO.       DESCRIPTION
C         1         EL ID
C         2         SIL 1
C         3         SIL 2
C         4         GAMMA
C         5         N
C         6         0
C         7         R1
C         8         Z1
C         9         -
C         10        0
C         11        R2
C         12        Z2
C         13        -
      DOUBLE PRECISION   RP             ,RN
     1                  ,DR             ,CT
     2                  ,EM
C
      INTEGER    NECPT(100)
C
      COMMON /SMA2DP/    RP             ,RN
     1                  ,DR             ,CT
     2                  ,EM
      COMMON /SMA2IO/    IO(36)
C
      COMMON /SMA2CL/    DUM(2)        ,NPVT
C
      COMMON /SMA2ET/    ECPT(100)
      EQUIVALENCE   (NECPT(1),ECPT(1))
      IFILE = IO(11)
      IF (ECPT(4).EQ.0.0) GO TO 1100
      IF(NECPT(2).EQ. NECPT(3)) GO TO 500
      DR = ECPT(11) - ECPT(7)
      IF(NPVT .EQ.NECPT(2)) GO TO 20
      IF(NPVT .NE.NECPT(3)) GO TO 1000
C
      RP = ECPT(11)
      RN = ECPT(7)
      IP = NECPT(3)
      IN = NECPT(2)
C
      GO TO 50
C
   20 RP = ECPT(7)
      RN = ECPT(11)
      IP =NECPT(2)
      IN =NECPT(3)
   50 CT = (0.2617994D0/ECPT(4)) * DR
      IF( NECPT(5) .EQ. 0) CT = 2.0D0 * CT
      EM = CT * (3.0D0*RP +RN)
      CALL SMA2B (EM,IP,IP,IFILE,0.0D0)
      EM = CT * ( RP +RN)
      CALL SMA2B (EM,IN,IP,IFILE,0.0D0)
      GO TO 1100
C
C      CASE OF CENTER ELEMENT CONNECTED TO ONE POINT
C
  500 IF(NECPT(2).NE.NPVT) GO TO 1000
       CT = 1.5707963D0 / DBLE( ECPT(4) )
      RP = ECPT (7)
      IF( NECPT(5).LE. 0 ) GO TO 510
      RN =NECPT(5)
      CT  = CT/ (2.0D0*RN +2.0D0)
  510 EM = CT*RP**2
      IP = NPVT
      CALL SMA2B( EM,IP,IP,IFILE,0.0D0)
 1000 RETURN
 1100 RETURN
      END

      SUBROUTINE SHHMGD (*,ELID,MM,SIL,BGPDT,GPTH,ELTH,GPTEMP,FLAG,MID,
     1                   MFLAG,MCID,THETA,TEMP,NNODE,NSIL,DELTAP,HTCON,
     2                   HTCAP)
C
C     SHELL ELEMENT HEAT MATRIX GENERATOR FOR QUAD8 AND TRIA6 ELEMENTS
C
C          ********************************************************
C          *                                                      *
C          *  PRESENTLY COSMIC/NASTRAN DOES NOT USE THIS ROUTINE  *
C          *                                                      *
C          ********************************************************
C
C     PERFORMS ONE OF THE FOLLOWING FOR THE ISOPARAMETRIC SHELL ELEMENTS
C
C     FLAG =1  CALCULATE THE CONDUCTIVITY AND CAPACITY MATRICES.
C     FLAG =2  CALCULATE THE DELTA-LOAD VECTOR FOR NONLINEAR HEAT.
C
C     INPUT :
C           ELID  - ELEMENT ID
C           MM    - MAXIMUM NO. OF NODES FOR THE ELEMENT
C           SIL   - SIL ARRAY FROM CONNECTION
C           BGPDT - BGPDT ARRAY FROM BGPDT
C           GPTH  - GRID POINT THICKNESSES FROM CONNECTION
C           ELTH  - ELEMENT THICKNESS FROM PROPERTY
C           GPTEMP- GRID TEMPERATURES FROM GPTT
C           FLAG  - OPTION INDICATOR
C           MID   - MATERIAL ID
C           MFLAG - MATERIAL FLAG
C           MCID  - MATERIAL CID, IF MFLAG IS 1
C           THETA - MATERIAL ANGLE, IF MFLAG IS 0
C           TEMP  - TEMPERATURE VALUES (FOR NONLINEAR)
C     OUTPUT:
C           NSI L - REORDERED SIL ARRAY
C           DELTAP- DELTA-LOAD VECTOR
C           HTCON - CONDUCTIVITY MATRIX
C           HTCAP - CAPACITY MATRIX
C
      INTEGER          SIL(8),NSIL(8),ELID,FLAG,IORDER(8),IORDRN(8),
     1                 MMN(8),NECPT(4)
      REAL             TEMP(1),GPTEMP(1),BGPDT(4,8),GPTH(8),BGPDM(3,8),
     1                 ECPT(4),KHEAT
      DOUBLE PRECISION XI,ETA,WX,WE,THK,POINTX(6),POINTE(2),WEITX(6),
     1                 WEITE(2),WEITC,DETJ,SHP(10),VOLI,HTCON(1),
     2                 HTCAP(1),TMPR(8),HTFLX(24),BTERMS(32),TEB(9),
     3                 TUB(9),TBM(9),TEM(9),GT(4),GI(4),CENTE(3),AVGTHK,
     4                 EPS1,XM,YM,THETAM,PI,TWOPI,RADDEG,DEGRAD,
     5                 EGPDT(4,8),GPNORM(4,8),EPNORM(4,8),DGPTH(8),
     6                 TIE(9),DELTAP(1),TCE(63)
      COMMON /MATIN /  MATID,INFLAG,ELTEMP,DUMMY,SINMAT,COSMAT
      COMMON /HMTOUT/  KHEAT(6), HTCP
      COMMON /CONDAD/  PI,TWOPI,RADDEG,DEGRAD
      EQUIVALENCE      (ECPT(1),NECPT(1))
      DATA    EPS1  /  1.0D-11 /
C
C
C     DOUBLE PRECISON VERSION
C
C
C     BRANCH ON ELEMENT TYPE
C
      IF (MM .EQ. 6) GO TO 100
      IF (MM .EQ. 8) GO TO 200
      GO TO 3000
C
C     TRIA6
C     1.0D0/6.0D0 = 0.166666667D0
C     2.0D0/3.0D0 = 0.666666667D0
C
  100 INDX = 1
      NXI  = 3
      NETA = 1
      POINTX(1) = 0.166666667D0
      POINTX(2) = 0.166666667D0
      POINTX(3) = 0.666666667D0
      POINTX(4) = 0.166666667D0
      POINTX(5) = 0.666666667D0
      POINTX(6) = 0.166666667D0
C
      WEITX(1)  = 0.166666667D0
      WEITX(2)  = 0.166666667D0
      WEITX(3)  = 0.166666667D0
      WEITX(4)  = 0.166666667D0
      WEITX(5)  = 0.166666667D0
      WEITX(6)  = 0.166666667D0
      GO TO 300
C
C     QUAD8
C     -DSQRT(1.0D0/3.0D0) = -0.577350269D0
C
  200 INDX = 2
      NXI  = 2
      NETA = 2
      POINTX(1) =-0.577350269D0
      POINTX(2) =-POINTX(1)
      DO 210 I = 1,2
      POINTE(I) = POINTX(I)
      WEITX(I) = 1.0D0
  210 WEITE(I) = 1.0D0
C
C     SET UP THE ELEMENT VARIABLES
C
  300 CALL SHSETD (*3000,MM,SIL,BGPDT,BGPDT,GPTH,ELTH,GPTEMP,BGPDM,
     1             EGPDT,DGPTH,GPNORM,EPNORM,NNODE,MMN,NSIL,IORDER,
     2             IORDRN,TEB,TUB,CENTE,AVGTHK,TCE,ELID)
C
C     GET THE TEMPERATURE VECTOR FROM CORE
C
      DO 320 I = 1,MM
      TMPR(I) = 0.0D0
      II = NSIL(I)
      IF (II .EQ. 0) GO TO 320
      TMPR(I) = TEMP(II)
  320 CONTINUE
C
      NNODE2 = NNODE*NNODE
      DO 330 I = 1,NNODE2
      HTCON(I) = 0.0D0
  330 HTCAP(I) = 0.0D0
C
C     GET THE PROPERTIES
C
      MATID   = MID
      INFLAG  = 12
      ELTEMP  = 0.0
      ECPT(2) = 0.0
      ECPT(3) = 0.0
      ECPT(4) = 0.0
      DO 400 I = 1,NNODE
      ECPT(2) = ECPT(2) + BGPDT(2,I)
      ECPT(3) = ECPT(3) + BGPDT(3,I)
      ECPT(4) = ECPT(4) + BGPDT(4,I)
  400 ELTEMP  = ELTEMP  + GPTEMP(I)
      ELTEMP  = ELTEMP/NNODE
      ECPT(2) = ECPT(2)/NNODE
      ECPT(3) = ECPT(3)/NNODE
      ECPT(4) = ECPT(4)/NNODE
C
      IF (MFLAG .EQ. 0) GO TO 500
C
C     CALCULATE [TEM] USING MCID
C
      IF (MCID .GT. 0) GO TO 420
      DO 410 I = 1,9
  410 TEM(I) = TEB(I)
      GO TO 430
  420 NECPT(1) = MCID
      CALL TRANSD (ECPT,TBM)
      CALL GMMATD (TEB,3,3,0, TBM,3,3,0, TEM)
C
C     CALCULATE THETAM FROM THE PROJECTION OF THE X-AXIS OF THE MATERIAL
C     COORD. SYSTEM ON TO THE XY PLANE OF THE ELEMENT COORD. SYSTEM
C
  430 XM = TEM(1)
      YM = TEM(4)
      IF (DABS(XM).GT.EPS1 .OR. DABS(YM).GT.EPS1) GO TO 440
      GO TO 3000
  440 THETAM = DATAN2(YM,XM)
      GO TO 510
  500 THETAM = THETA*DEGRAD
  510 SINMAT = DSIN(THETAM)
      COSMAT = DCOS(THETAM)
C
      CALL HMAT (ELID)
C
      GI(1) = DBLE(KHEAT(1))
      GI(2) = DBLE(KHEAT(2))
      GI(3) = GI(2)
      GI(4) = DBLE(KHEAT(3))
C
C     IF NONLINEAR, GET THE UPDATED MATERIAL PROPERTIES
C
      IF (FLAG .EQ. 1) GO TO 1000
      ELTEMP = 0.0
      DO 900 I = 1,NNODE
  900 ELTEMP = ELTEMP + SNGL(TMPR(I))
      ELTEMP = ELTEMP/NNODE
C
      CALL HMAT (ELID)
C
      GI(1) = DBLE(KHEAT(1)) - GI(1)
      GI(2) = DBLE(KHEAT(2)) - GI(2)
      GI(3) = GI(2)
      GI(4) = DBLE(KHEAT(3)) - GI(4)
C
C     START THE TRIPLE LOOP
C
 1000 CONTINUE
      DO 2000 IXI = 1,NXI
      XI = POINTX(IXI)
      WX = WEITX(IXI)
C
      DO 1200 IETA = 1,NETA
      IF (NETA .EQ. 1) GO TO 1010
      ETA = POINTE(IETA)
      WE  = WEITE(IETA)
      GO TO 1020
 1010 ETA = POINTX(IXI+NXI)
      WE  = 1.0D0
 1020 CONTINUE
C
C     CALCULATE THE B TERMS
C
      IF (MM .EQ. 8) CALL SHTRMD (*3000,ELID,MM,NNODE,XI,ETA,DGPTH,
     1               EPNORM,EGPDT,IORDER,MMN,DETJ,THK,SHP,TIE,BTERMS)
      IF (MM .EQ. 6) CALL SHTRMD (*3000,ELID,MM,NNODE,XI,ETA,DGPTH,
     1               EPNORM,EGPDT,IORDRN,MMN,DETJ,THK,SHP,TIE,BTERMS)
C
      VOLI  = DETJ*WX*WE*THK*2.0D0
      WEITC = VOLI*HTCP
      DO 1030 I = 1,4
 1030 GT(I) = GI(I)*VOLI
C
      CALL GMMATD (GT,2,2,0, BTERMS,2,NNODE,0, HTFLX)
      CALL GMMATD (BTERMS,2,NNODE,-1, HTFLX,2,NNODE,0, HTCON)
C
      IF (WEITC .EQ. 0.0) GO TO 1200
      IP = 1
      DO 1060 I = 1,NNODE
      DO 1060 J = 1,NNODE
      HTCAP(IP) = HTCAP(IP) + SHP(I)*SHP(J)*WEITC
 1060 IP = IP + 1
C
 1200 CONTINUE
 2000 CONTINUE
C
C     RECOVER NONLINEAR DELTA-LOAD
C
      IF (FLAG .NE. 1)
     1    CALL GMMATD (HTCON,NNODE,NNODE,0, TMPR,NNODE,1,0, DELTAP(1))
      RETURN
C
C
      ENTRY SHHMGS (*,ELID,MM,SIL,BGPDT,GPTH,ELTH,GPTEMP,FLAG,MID,
     1                MFLAG,MCID,THETA,TEMP,NNODE,NSIL,DELTAP,HTCON,
     2                HTCAP)
C     =============================================================
C
C     SINGLE PRECISION VERSION
C
      RETURN
C
 3000 CONTINUE
      RETURN 1
      END

      SUBROUTINE FRD2D (IN,IO,IP)
C
      INTEGER         SYSBUF,MA(7),MB(7)
      COMMON /SYSTEM/ SYSBUF
      COMMON /UNPAKX/ IOUT,INN,MNN,INCR1
      COMMON /ZZZZZZ/ Z(1)
C
C     ADD IN TO END OF IO
C
      INCR1 = 1
      MA(1) = IN
      MB(1) = IO
      CALL RDTRL (MA)
      IOUT  = MA(5)
      NC    = KORSZ(Z)
      IB1   = NC  - SYSBUF
      IB2   = IB1 - SYSBUF
      CALL GOPEN (IN,Z(IB1),0)
      IF (IP .NE. 0) GO TO 10
      CALL GOPEN (IO,Z(IB2),1)
      CALL MAKMCB (MB,IO,MA(3),2,IOUT)
      GO TO 20
   10 CALL GOPEN (IO,Z(IB2),3)
      CALL RDTRL (MB)
   20 N = MA(2)
      CALL CYCT2B (IN,IO,N,Z,MB)
      CALL CLOSE  (IN,1)
      CALL CLOSE  (IO,3)
      CALL WRTTRL (MB)
      CALL DMPFIL (-IN,Z,NC)
      RETURN
      END

      SUBROUTINE SCONE2 (SORC)
C
C     PHASE II OF STRESS DATA RECOVERY
C
C     OUTPUTS FROM PHASE I ARE THE FOLLOWING (TOTAL OF 118 WORDS) -
C     1) ELEMENT ID
C     2 AND 3) SILS A AND B
C     4) S SUB T
C     5) N
C     6) I
C     7) Z1
C     8) Z2
C     9 THRU 22) PHI-S
C     23 THRU 118) TWO 8X6 S MATRICES
C
      LOGICAL         ZERO
      INTEGER         SIL(2),IFORCE(8),ISTRES(100),ELEMID,SORC,
     1                IBLOCK(9,14)
      REAL            NPHI,PHI(14),FORCE(7),S(96),STRESS(18),ZOFF(2),III
      COMMON /CONDAS/ CONSTS(5)
      COMMON /ZZZZZZ/ Z(1)
      COMMON /SDR2X4/ DUMMY(35),IVEC,DUM11(3)
      COMMON /SDR2X7/ COMMUN(225)
      COMMON /SDR2X8/ VEC(8),SUM(8),SIG(3),SIG1,SIG2,SIG12,TEMP,
     1                DELTA,THETA,NPOINT,ZOVERI,IPT,BLOCK(9,14),
     2                NELHAR,ELEMID,HARM,N,SINPHI,CONPHI,NPHI,NANGLE
      EQUIVALENCE     (CONSTS(4),DEGRA),(NELEM,COMMUN(1)),
     1                (SIL(1),COMMUN(2)),(III,COMMUN(6)),
     2                (ZOFF(1),COMMUN(7)),(PHI(1),COMMUN(9)),
     3                (S(1),COMMUN(23)),(IBLOCK(1,1),BLOCK(1,1)),
     4                (STRESS(1),COMMUN(101),ISTRES(1)),
     5                (FORCE (1),COMMUN(201),IFORCE(1))
      DATA    NELOLD/ -1 /
C
      DO 10 I = 1,8
   10 SUM(I) = 0.0
C
      ELEMID = NELEM/1000
      NELHAR = NELEM - ELEMID*1000
C
C     ZERO OUT BLOCK IF THIS IS FIRST CALL WITH HARMONIC = 0 FOR THIS
C     ELEMENT
C
      N = NELHAR - 1
      IF (N .NE. 0) GO TO 21
      IF (ELEMID .EQ. NELOLD) GO TO 21
      NELOLD = ELEMID
      DO 12 I = 2,9
      DO 12 J = 1,14
      BLOCK(I,J) = 0.0
   12 CONTINUE
C
C     INSERT ANGLES FOR OUTPUT INTO FIRST ROW OF BLOCK
C
      ZERO = .FALSE.
      J = 0
      DO 19 I = 1,14
      IF (PHI(I)) 17,15,17
   15 IF (ZERO) GO TO 19
      ZERO = .TRUE.
   17 J = J + 1
      BLOCK(1,J) = PHI(I)
   19 CONTINUE
      J = J + 1
      IF (J .LE. 14) IBLOCK(1,J) = 1
   21 HARM = N
C
      DO 30 I = 1,2
C
C     DISPLACEMENT VECTOR POINTER
C
      NPOINT = IVEC + SIL(I) - 1
C
      CALL GMMATS (S(48*I-47),8,6,0, Z(NPOINT),6,1,0, VEC(1))
C
      DO 25 J = 1,8
   25 SUM(J) = SUM(J) + VEC(J)
   30 CONTINUE
C
C     INSERT HARMONIC STRESSES AND FORCES INTO BLOCK FOR THIS HARMONIC
C
      DO 40 I = 1,14
      IF (IBLOCK(1,I) .EQ. 1) GO TO 50
      NPHI   = HARM*BLOCK(1,I)*DEGRA
      SINPHI = SIN(NPHI)
      CONPHI = COS(NPHI)
      GO TO (35,36), SORC
   35 BLOCK(2,I) = BLOCK(2,I) + SINPHI*SUM(1)
      BLOCK(3,I) = BLOCK(3,I) + SINPHI*SUM(2)
      BLOCK(4,I) = BLOCK(4,I) - CONPHI*SUM(3)
      BLOCK(5,I) = BLOCK(5,I) + SINPHI*SUM(4)
      BLOCK(6,I) = BLOCK(6,I) + SINPHI*SUM(5)
      BLOCK(7,I) = BLOCK(7,I) - CONPHI*SUM(6)
      BLOCK(8,I) = BLOCK(8,I) + SINPHI*SUM(7)
      BLOCK(9,I) = BLOCK(9,I) - CONPHI*SUM(8)
      GO TO 40
   36 BLOCK(2,I) = BLOCK(2,I) + CONPHI*SUM(1)
      BLOCK(3,I) = BLOCK(3,I) + CONPHI*SUM(2)
      BLOCK(4,I) = BLOCK(4,I) + SINPHI*SUM(3)
      BLOCK(5,I) = BLOCK(5,I) + CONPHI*SUM(4)
      BLOCK(6,I) = BLOCK(6,I) + CONPHI*SUM(5)
      BLOCK(7,I) = BLOCK(7,I) + SINPHI*SUM(6)
      BLOCK(8,I) = BLOCK(8,I) + CONPHI*SUM(7)
      BLOCK(9,I) = BLOCK(9,I) + SINPHI*SUM(8)
   40 CONTINUE
C
C     COPY FORCES INTO FORCE OUTPUT BLOCK
C
   50 IFORCE(1) = ELEMID
      IFORCE(2) = NELHAR
      FORCE (3) = SUM(4)
      FORCE (4) = SUM(5)
      FORCE (5) = SUM(6)
      FORCE (6) = SUM(7)
      FORCE (7) = SUM(8)
C
C     COMPUTE STRESSES AT Z1 AND Z2
C
      ISTRES(1) = ELEMID
      ISTRES(2) = NELHAR
C
      DO 70 I = 1,2
      ZOVERI = 0.0
      IF (III .NE. 0.0) ZOVERI = ZOFF(I)/III
C
      DO 60 J = 1,3
   60 SIG(J) = SUM(J) + SUM(J+3)*ZOVERI
C
      IPT = 8*I - 6
      STRESS(IPT+1) = ZOFF(I)
      STRESS(IPT+2) = SIG(1)
      STRESS(IPT+3) = SIG(2)
      STRESS(IPT+4) = SIG(3)
      ISTRES(IPT+5) = 1
      ISTRES(IPT+6) = 1
      ISTRES(IPT+7) = 1
      ISTRES(IPT+8) = 1
   70 CONTINUE
C
      RETURN
      END

      COMPLEX FUNCTION SUMPHI(IXR,IYR,ND1,NDN,CAPPHI,DSS,N,M,ASYM)
C
C     FUNCTION TO COMPUTE SUM OF CAPPHI-DELTA SOURCE STENGTH PRODUCT
C
      LOGICAL ASYM
      DIMENSION ND1(1),NDN(1)
      COMPLEX  CAPPHI(1),DSS(N,M)
C
      SUMPHI  =  ( 0.0 , 0.0 )
      IF ( IXR .EQ. 0 )   RETURN
      DO   400   I = 1 , IXR
      IXS  =  I - 1
      IP  =  IXR - IXS
      LTOT  =  2 * IP + 1
      IPHI  =  ( IP * ( IP + 1 ) ) / 2
      IYS  =  IYR - IXR + IXS
      DO   300   L = 1 , LTOT
      IF ( ASYM .AND. IYS .EQ. 0 )   GO TO  200
      J  =  IABS ( IYS ) + 1
      IF ( .NOT. ( I .GE. (ND1(J)) .AND. I .LE. NDN(J) ) )   GO TO 200
      S  =  1.0
      IF ( ASYM .AND. IYS .LT. 0 )   S  =  -S
      IJPHI  =  IPHI + 1 + IABS ( IYR - IYS )
      SUMPHI  =  SUMPHI + S * CAPPHI(IJPHI) * DSS(I,J)
 200  IYS  =  IYS + 1
 300  CONTINUE
 400  CONTINUE
      RETURN
      END

      SUBROUTINE MRED2O (NUS)
C
C     THIS SUBROUTINE FORMS THE M MATRIX FOR THE MRED2 MODULE.
C
      INTEGER         DRY,GBUF1,GBUF2,SBUF1,SBUF2,SBUF3,OTFILE,Z,
     1                TYPIN,TYPOUT,PREC,TYPEA,TYPEB,HK,GS,RPRTN,HM,
     2                GSZERO,DBLKOR
      DOUBLE PRECISION DZ
      DIMENSION       ITRLR1(7),ITRLR2(7),MODNAM(2),ISUB(4),
     1                RZ(1),BLOCK(11),DZ(1)
      COMMON /BLANK / IDUM1,DRY,IDUM2,GBUF1,GBUF2,IDUM3,SBUF1,SBUF2,
     1                SBUF3,INFILE(12),OTFILE(6),ISCR(10),KORLEN,KORBGN,
     2                IDUM5(14),NMODES,IDUM4(2),LSTZWD
      COMMON /ZZZZZZ/ Z(1)
      COMMON /MPY3TL/ ITRLRA(7),ITRLRB(7),ITRLRE(7),ITRLRC(7),JSCR(3),
     1                LKORE,ICODE,PREC,DUMMY(13)
      COMMON /PACKX / TYPIN,TYPOUT,IROW,NROW,INCR
      EQUIVALENCE     (LAMAMR,INFILE(2)),(GS,ISCR(7)),(DZ(1),Z(1)),
     1                (HK,ISCR(2)),(KMW2,ISCR(5)),(HM,ISCR(9)),
     2                (GSZERO,ISCR(10)),(M,ISCR(10)),(RPRTN,ISCR(8)),
     3                (RZ(1),Z(1)),(TYPEA,BLOCK(1)),(TYPEB,BLOCK(7))
      DATA    MODNAM/ 4HMRED,4H2O  /
C
C     FORM HM MATRIX
C
C        **  **   **  **   **          **
C        *    *   *    *   *    .   .   *
C        * HM * = * HK * + * GS . 0 . 0 *
C        *    *   *    *   *    .   .   *
C        **  **   **  **   **          **
C
      IF (DRY .EQ. -2) RETURN
      IF (NUS .EQ.  0) GO TO 60
C
C     GENERATE ROW PARTITION VECTOR
C
      ITRLR1(1) = HK
      CALL RDTRL (ITRLR1)
      ITRLR2(1) = GS
      CALL RDTRL (ITRLR2)
      TYPIN = 1
      TYPOUT= 1
      IROW  = 1
      NROW  = ITRLR1(2)
      INCR  = 1
      DO 40 I = 1,NROW
      RZ(KORBGN+I-1) = 0.0
      IF (I .GT. ITRLR2(2)) RZ(KORBGN+I-1) = 1.0
   40 CONTINUE
      IFORM = 7
      CALL MAKMCB (ITRLR2,RPRTN,NROW,IFORM,TYPIN)
      CALL GOPEN  (RPRTN,Z(GBUF1),1)
      CALL PACK   (Z(KORBGN),RPRTN,ITRLR2)
      CALL CLOSE  (RPRTN,1)
      CALL WRTTRL (ITRLR2)
C
C     MERGE GS, ZERO MATRICES
C
      ISUB(1) = ITRLR2(2)
      ISUB(2) = ITRLR1(2) - ITRLR2(2)
      CALL GMMERG (GSZERO,GS,0,0,0,RPRTN,0,ISUB,ITRLR2(5),Z(KORBGN),
     1             KORLEN)
C
C     FORM HM MATRIX
C
      ITRLR2(1) = GSZERO
      CALL RDTRL (ITRLR2)
      DO 50 I = 1,11
   50 BLOCK(I) = 0.0
      BLOCK(2) = 1.0
      BLOCK(8) = 1.0
      TYPEA = ITRLR1(5)
      TYPEB = ITRLR2(5)
      IOP   = 1
      CALL SOFCLS
      CALL SSG2C (HK,GSZERO,HM,IOP,BLOCK)
      GO TO 70
C
C     IF NO US POINTS
C
C        **  **   **  **
C        *    *   *    *
C        * HM * = * HK *
C        *    *   *    *
C        **  **   **  **
C
   60 HM = HK
      CALL SOFCLS
C
C     FORM KMW2 = M  MATRIX
C                  I
C
   70 IFILE = LAMAMR
      CALL GOPEN  (LAMAMR,Z(GBUF1),0)
      CALL FWDREC (*140,LAMAMR)
      IFORM = 3
      ITYPE = 1
      CALL MAKMCB (ITRLR1,KMW2,NMODES,IFORM,ITYPE)
      TYPIN = 1
      TYPOUT= 1
      IROW  = 1
      NROW  = NMODES
      INCR  = 1
      CALL GOPEN (KMW2,Z(GBUF2),1)
      DO 90 I = 1,NMODES
      CALL READ (*130,*140,LAMAMR,Z(KORBGN),7,0,NWDSRD)
      DO 80 J = 1,NMODES
      RZ(KORBGN+7+J-1) = 0.0
      IF (J .EQ. I) RZ(KORBGN+7+J-1) = RZ(KORBGN+5)
   80 CONTINUE
   90 CALL PACK  (Z(KORBGN+7),KMW2,ITRLR1)
      CALL CLOSE (LAMAMR,1)
      CALL CLOSE (KMW2,1)
      CALL WRTTRL (ITRLR1)
C
C     FORM M MATRIX
C
C                      T
C                **  ** **     ** **  **
C        ** **   *    * * .     * *    *
C        *   *   *    * *  .    * *    *
C        * M * = * HM * *   M   * * HM *     WHERE M = M
C        *   *   *    * *    .  * *    *                I
C        ** **   *    * *     . * *    *
C                **  ** **     ** **  **
C
      ITRLR1(1) = HM
      ITRLR2(1) = KMW2
      CALL RDTRL (ITRLR1)
      CALL RDTRL (ITRLR2)
      DO 100 I = 1,7
      ITRLRA(I) = ITRLR1(I)
      ITRLRB(I) = ITRLR2(I)
  100 ITRLRE(I) = 0
      IPRC = 1
      ITYP = 0
      IF ((ITRLRA(5) .EQ. 2) .OR. (ITRLRA(5) .EQ. 4)) IPRC = 2
      IF ((ITRLRB(5) .EQ. 2) .OR. (ITRLRB(5) .EQ. 4)) IPRC = 2
      IF (ITRLRA(5) .GE. 3) ITYP = 2
      IF (ITRLRB(5) .GE. 3) ITYP = 2
      ITYPE = IPRC + ITYP
      IFORM = 6
      CALL MAKMCB (ITRLRC,M,ITRLR1(3),IFORM,ITYPE)
      JSCR(1) = ISCR(7)
      JSCR(2) = ISCR(8)
      JSCR(3) = ISCR(6)
      ICODE   = 0
      PREC    = 0
      DBLKOR  = (KORBGN/2) + 1
      LKORE   = LSTZWD - (2*DBLKOR - 1)
      CALL MPY3DR (DZ(DBLKOR))
      CALL WRTTRL (ITRLRC)
      CALL SOFOPN (Z(SBUF1),Z(SBUF2),Z(SBUF3))
      RETURN
C
C     PROCESS SYSTEM FATAL ERRORS
C
  130 IMSG = -2
      GO TO 150
  140 IMSG = -3
  150 CALL SOFCLS
      CALL MESAGE (IMSG,IFILE,MODNAM)
      RETURN
      END

      SUBROUTINE DEGREE (IG,IDEG,JG)
C
C     THIS ROUTINE IS USED ONLY IN BANDIT MODULE
C
C     SET UP THE IDEG ARRAY CONTAINING THE DEGREE OF EACH NODE STORED
C     IN THE IG ARRAY.
C     IDEG(I)=DEGREE OF NODE I
C
C     INTEGER          BUNPK
      DIMENSION        IG(1),    JG(1),   IDEG(1)
      COMMON /BANDS /  NN,       MM
C
      DO 100 I=1,NN
      IDEG(I)=0
      CALL BUNPAK(IG,I,MM,JG)
      DO 80 J=1,MM
C     IF (BUNPK(IG,I,J)) 100,100,50
      IF (JG(J)) 100,100,50
   50 IDEG(I)=IDEG(I)+1
   80 CONTINUE
  100 CONTINUE
      RETURN
      END

      SUBROUTINE TABPRT (INAME1)
C
C     WILL PRINT TABLE - USING 1P,E13.6, I13, OR (9X,A4) FORMAT
C
C     ALL REAL NUMBERS ARE ASSUMED TO BE SINGLE PRECISION.
C
C     REVISED  3/91 BY G.CHAN/UNISYS
C     THREE PARAMETERS ARE ADDED - OP CODE (OP), RECORDD NO. (IRC), AND
C     WORD NO. (IWD)
C     THE DEFAULTS OF THESE PARAMETERS ARE - BLANK, 3, AND 3
C     OP CODE OPTIONS ARE 'PUREBCD', 'PUREFPN', AND 'PUREINT'
C
C     LAST REVISED, 12/92, BY G.CHAN/UNISYS, TO INCLUDE 3 SPECIAL TABLES
C     - KELM, MELM, BELM  - WHICH CONTAIN D.P. DATA WORDS IN 32- AND 36-
C     BIT WORD MACHINES.
C
C     IF OP CODE IS 'PUREBCD', RECORDS IRC AND THEREAFTER, AND BEGINNING
C     FROM WORD IWD OF EACH RECORD TO THE END OF THAT RECORD, ARE ALL
C     BCD  WORDS.
C     SIMILARILY FOR 'PUREINT' FOR INTEGER WORDS, AND 'PUREFPN' FOR
C     FLOATING POINT NUMBERS
C
C     THESE PARAMETER OPTIONS ARE NECESSARY BECAUSE IF THE PRINTED DATA
C     IS NOT OF STRING TYPE, SUBROUTINE NUMTYP IS CALLED TO FIND OUT
C     WHAT TYPE OF DATA IN EACH DATA WORD.  HOWEVER NUMTYP IS NOT 100
C     PERCENT FOOL-PROOF. ONCE IN A FEW THOUSANDS NUMTYP CAN NOT
C     DISTINGUISH A REAL NUMBER FROM A BCD WORD
C
C  $MIXED_FORMATS
C
      LOGICAL          DEC
      INTEGER          BLOCK(20),TYPES(4),FORMAT,FORMS(2),JPOINT,ROW,
     1                 TYPE,FLAG,RECF,STRNBR,SYSBUF,OTPE,PURE,BCD,FPN,
     2                 OP,NAME(2),ICORE(133)
      REAL             XNS(1),SP(3)
      DOUBLE PRECISION XND(1),DCORE(1)
      CHARACTER        UFM*23,UWM*25
CWKBI
      CHARACTER*1      CORE1(2000)
      COMMON /XMSSG /  UFM,UWM
      COMMON /BLANK /  OP(2),IRC,IWD
      COMMON /MACHIN/  MACH
      COMMON /SYSTEM/  SYSBUF,OTPE,INX(6),NLPP,INX1(2),LINE,DUM(42),IPRC
      COMMON /OUTPUT/  HEAD1(96),HEAD2(96)
      COMMON /ZZZZZZ/  CORE(1)
      EQUIVALENCE      (XND(1),CORE(1))
      EQUIVALENCE      (XNS(1),XND(1)),  (ICORE(1),CORE(1),DCORE(1)),
     1                 (BLOCK(2), TYPE   ), (BLOCK(3), FORMAT),
     2                 (BLOCK(4), ROW    ), (BLOCK(5), JPOINT),
     3                 (BLOCK(6), NTERMS ), (BLOCK(8), FLAG  )
CWKBI
      EQUIVALENCE      (CORE, CORE1)
      DATA    OPAREN,  CPAREN,EC,EC1,EC2,INTGC,ALPHC,ALPHC1,CONT,UNED /
     1        4H(1X ,  4H)   ,4H,1P,,4HE13.,2H6 ,4H,I13,4H,9X,,4HA4   ,
     2        4HCONT,  4HINUE   /  D/2HD  /, NAME  / 4HTABP,4HRT      /
      DATA    BLANK ,  TABL,EBB /  1H  ,4HTABL, 1HE     /
      DATA    TYPES /  3HRSP,3HRDP,3HCSP ,3HCDP/, FORMS / 3HYES ,2HNO /
      DATA    PURE  ,  BCD,FPN,INT /   4HPURE, 4HBCD , 4HFPN , 4HINT  /
      DATA    NSP   ,  SP / 3, 4HKELM, 4HMELM, 4HBELM   /
C
      NZ  = KORSZ(CORE) - SYSBUF
      IF (NZ .LE. 0) CALL MESAGE (-8,-NZ,NAME)
      DEC = MACH.EQ.5 .OR. MACH.EQ.6 .OR. MACH.EQ.10 .OR. MACH.EQ.21
      INAME = INAME1
      CALL OPEN (*190,INAME,CORE(NZ+1),0)
      DO 10 I = 1,96
   10 HEAD2(I) = BLANK
      HEAD2(1) = TABL
      HEAD2(2) = EBB
      CALL FNAME (INAME,HEAD2(3))
      CALL PAGE
      HEAD2(6) = CONT
      HEAD2(7) = UNED
      HEAD2(8) = D
      IF (IPRC.EQ.1 .OR. INAME.NE.101) GO TO 15
      CALL PAGE2 (-2)
      WRITE  (OTPE,13) UWM
   13 FORMAT (A25,', TABPRT MODULE ASSUMES ALL REAL DATA ARE IN S.P.,',
     1       ' D.P. DATA THEREFORE MAY BE PRINTED ERRONEOUSLY')
   15 INUM     = NZ/2 - 1
      INUM     = MAX0(INUM,133)
      NS       = INUM + 1
      LLEN     = 0
      CORE(1)  = OPAREN
      IREC     = 0
      IRCD     = 999999999
      IXXX     = 999999999
      IF (OP(1).NE.PURE .OR. OP(2).EQ.BLANK) GO TO 20
      IF (OP(2) .EQ. INT) JJ = 2
      IF (OP(2) .EQ. FPN) JJ = 3
      IF (OP(2) .EQ. BCD) JJ = 4
      IF (IRC .GT. 0) IRCD = IRC
      IF (IWD .GT. 0) IXXX = IWD + INUM
      IF (IRC .LE. 0) IRCD = 3
      IF (IWD .LE. 0) IXXX = 3 + INUM
   20 CALL PAGE2 (-2)
      IF (DEC .AND. IREC.EQ.0) WRITE (OTPE,25)
   25 FORMAT (4X,'(ALL INTEGERS EXCEEDING 16000 ARE PRINTED AS REAL ',
     1        'NUMBERS. ALL REAL NUMBERS OUTSIDE E-27 OR E+27 RANGE ',
     2        'ARE PRINTED AS INTEGERS)')
      WRITE  (OTPE,30) IREC
   30 FORMAT (/,' RECORD NO.',I6)
      IREC = IREC + 1
      DO 35 I  = 1,NSP
      IF (HEAD2(3) .NE. SP(I)) GO TO 35
      ICORE(1) = INAME
      CALL RDTRL (ICORE)
      IF (ICORE(2) .EQ. 2) GO TO 60
   35 CONTINUE
      IX   = INUM
      NRED = 0
      NP   = INUM - 1
      BLOCK(1) = INAME1
      CALL RECTYP (BLOCK,RECF)
      IF (RECF .NE. 0) GO TO 200
      JV   = 4
   40 IX   = IX + 1
      IOUT = 4
      NRED = NRED + 1
      NP   = NP + 1
      CALL READ (*170,*160,INAME,CORE(IX),1,0,IFLAG)
C
      IF (IREC.GT.IRCD .OR. IX.GT.IXXX) GO TO 50
      JJ = NUMTYP(ICORE(IX)) + 1
      IF (JJ.EQ.1 .AND. JV.NE.4) JJ = JV
      JV = JJ
   50 GO TO (140,140,100,120), JJ
C
C     TABLES KELM, MELM, AND BELM - D.P. DATA ONLY
C
   60 CALL READ (*170,*170,INAME,CORE(1),2,1,IFLAG)
      WRITE  (OTPE,65) ICORE(1),ICORE(2)
   65 FORMAT (10X,2A4)
   70 WRITE  (OTPE,30) IREC
      CALL READ (*170,*80,INAME,CORE(1),NZ,1,IFLAG)
      CALL MESAGE (-8,0,NAME)
   80 NP   = IFLAG/2
      JJ   = (NP+9)/10
      CALL PAGE2 (-JJ)
      IREC = IREC + 1
      WRITE  (OTPE,90,ERR=70) (DCORE(I),I=1,NP)
   90 FORMAT (1X,1P,10D13.6)
      GO TO 70
C
C     REAL NUMBER  (1)
C
  100 IOUT = 1
      IF (LLEN+13 .GT. 132) GO TO 160
  110 CORE(NRED+1) = EC
      CORE(NRED+2) = EC1
      CORE(NRED+3) = EC2
      NRED = NRED + 2
  115 LLEN = LLEN + 13
      GO TO 40
C
C     ALPHA  (2)
C
  120 IOUT = 2
      IF (LLEN+6 .GT. 132) GO TO 160
  130 CORE(NRED+1) = ALPHC
      CORE(NRED+2) = ALPHC1
      NRED = NRED + 1
      GO TO 115
C
C     INTEGER  (3)
C
  140 IOUT = 3
      IF (LLEN+13 .GT. 132) GO TO 160
  150 ICORE(NRED+1) = INTGC
      GO TO 115
C
C     BUFFER FULL- END RECORD AND PRINT THE LINE
C
C     PREVIOUSLY, THE FORMAT IS IN CORE, WHICH IS DIMENSIONED TO 1.
C     THIS MAY NOT WORK IN SOME MACHINES. THE FORMAT IS NOW SPECIFIED IN
C     ICORE, WHICH IS DIMENSIONED TO 133.
C     (CORE AND ICORE ARE EQUIVALENT)
C
  160 CORE(NRED+1) = CPAREN
      IF (NRED .GE. 133) CALL MESAGE (-37,0,NAME)
      CALL PAGE2 (-1)
      IF (NRED .EQ. 1) GO TO 165
      IF (MACH .NE. 2 .AND. MACH .NE. 5 ) GO TO 162
      WRITE (OTPE,ICORE,ERR=164) (CORE(I),I=NS,NP)
      GO TO 164
  162 CALL WRTFMT (ICORE(NS),NP-NS+1,CORE1)
  164 CONTINUE
      LLEN = 0
      NRED = 1
      NP   = INUM
C
C     FINISH SEMI-PROCESSED WORD.
C
      CORE(INUM+1) = CORE(IX)
      IX = INUM + 1
      GO TO (110,130,150,20), IOUT
C
  165 WRITE  (OTPE,166)
  166 FORMAT (' THIS RECORD IS NULL.')
C
C     GO TO 161 IS LOGICALLY UNSOUND. CHANG TO 164. (G.CHAN/UNISYS 1/93)
C     GO TO 161
CWKBR GO TO 164
      GO TO 162
C
  170 CALL CLOSE (INAME,1)
      CALL PAGE2 (-2)
      WRITE  (OTPE,180)
  180 FORMAT (//,' END OF FILE')
C
C     PRINT TRAILER FOR FILE
C
  190 ICORE(1) = INAME
      CALL RDTRL (ICORE)
      CALL PAGE2 (-2)
      WRITE  (OTPE,195) (ICORE(I),I=2,7)
  195 FORMAT ('0TRAILER WORD1 =',I8,' WORD2 =',I8,' WORD3 =',I8,
     1                ' WORD4 =',I8,' WORD5 =',I8,' WORD6 =',I8)
      RETURN
C
C
C     HERE IF STRING FORMATTED RECORD
C
  200 FLAG   =-1
      STRNBR = 1
      CALL GETSTR (*250,BLOCK)
      IFORM = FORMAT + 1
  205 CALL PAGE2 (-2)
      WRITE  (OTPE,206) STRNBR,ROW,TYPES(TYPE),FORMS(IFORM),NTERMS
  206 FORMAT ('0STRING NO.',I5,'   ROW POSITION=',I5,'   STRING TYPE=',
     1        A3,'   STRING TRAILERS=',A3,'   NUMBER OF TERMS=',I5)
      STRNBR = STRNBR + 1
      GO TO (210,220,230,240), TYPE
C
C     PRINT REAL SINGLE PRECISION STRING
C
  210 NPOINT = JPOINT + NTERMS - 1
      J = JPOINT
  211 N = MIN0(J+7,NPOINT)
      CALL PAGE2 (-1)
      WRITE  (OTPE,212) (XNS(I),I=J,N)
  212 FORMAT (1X,8(1P,E15.7))
      IF (N .EQ. NPOINT) GO TO 214
      J = N + 1
      GO TO 211
  214 CALL ENDGET (BLOCK)
      CALL GETSTR (*20,BLOCK)
      GO TO 205
C
C     PRINT STRING IN REAL DOUBLE PRECISION
C
  220 NPOINT = JPOINT + NTERMS - 1
      J = JPOINT
  221 N = MIN0(J+7,NPOINT)
      CALL PAGE2 (-1)
      WRITE  (OTPE,222) (XND(I),I=J,N)
  222 FORMAT (1X,8(1P,D15.7))
      IF (N .EQ. NPOINT) GO TO 224
      J = N + 1
      GO TO 221
  224 CALL ENDGET (BLOCK)
      CALL GETSTR (*20,BLOCK)
      GO TO 205
C
C     PRINT STRING IN COMPLEX SINGLE PRECISION
C
  230 NPOINT = JPOINT + 2*NTERMS - 1
      J = JPOINT
  231 N = MIN0(J+7,NPOINT)
      CALL PAGE2 (-1)
      WRITE  (OTPE,232) (XNS(I),I=J,N)
  232 FORMAT (1X,4(1P,E14.7,1P,E15.7,2H//))
      IF (N .EQ. NPOINT) GO TO 234
      J = N + 1
      GO TO 231
  234 CALL ENDGET (BLOCK)
      CALL GETSTR (*20,BLOCK)
      GO TO 205
C
C     PRINT STRING IN COMPLEX DOUBLE PRECISION
C
  240 NPOINT = JPOINT + 2*NTERMS - 1
      J = JPOINT
  241 N = MIN0(J+7,NPOINT)
      CALL PAGE2 (-1)
      WRITE  (OTPE,242) (XND(I),I=J,N)
  242 FORMAT (1X,4(1P,D14.7,1P,D15.7,2H//))
      IF (N .EQ. NPOINT) GO TO 244
      J = N + 1
      GO TO 241
  244 CALL ENDGET (BLOCK)
      CALL GETSTR (*20,BLOCK)
      GO TO 205
C
C     PRINT NULL COLUMN
C
  250 CALL PAGE2 (-1)
      WRITE  (OTPE,252)
  252 FORMAT (5X,'NULL COLUMN')
      GO TO 20
C
      END

      SUBROUTINE DSMG2
C*****
C THIS MODULE PERFORMS THE FOLLOWING MATRIX OPERATIONS...
C
C     KBAA  = KAA + BETA * KDAA
C     KBFS  = KFS + BETA * KDFS
C     KBSS  = KSS + BETA * KDSS
C     PBL   = BETA * PL
C     PBS   = BETA * PS
C     YBS   = BETA * YS
C     UBOOV = BETA * UOOV
C
C THE VALUE OF BETA LIES IN THE DIFFERENTIAL STIFFNESS COEFFICIENT SET
C NO. SPECIFIED BY THE INPUT PARAMETER DSCSET.  THE PARTICULAR VALUE OF
C BETA TO BE USED ON ANY PASS THROUGH THIS MODULE IS THE NDSKIP(TH)
C VALUE IN THE DSCSET SET.  IREPTD IS SET EQUAL TO -1 AFTER THE LAST
C BETA IN THE SET HAS BEEN ENCOUNTERED, THEREBY TERMINATING THE
C DIFFERENTIAL STIFFNESS RIGID FORMAT DMAP LOOP BEGINNING AT THE
C LABEL DSLOOP AND ENDING AT THE REPT DSLOOP,100$ STATEMENT.
C
C
C  DMAP CALL...
C
C
C     DSMG2    MPT,KAA,KDAA,KFS,KDFS,KSS,KDSS,PL,PS,YS,UOOV/KBAA,KBFS,
C              KBSS,PBL,PBS,YBS,UBOOV/V,N,NDSKIP/V,N,REPEATD/
C              V,N,DSCOSET/ $
C*****
      INTEGER
     1                   MPT                ,SETNO
     2,                  KAA                ,KDAA
     3,                  KFS                ,KDFS
     4,                  KSS                ,KDSS
     5,                  PL                 ,PS
     6,                  YS                 ,UOOV
     7,                  KBAA               ,KBFS
     8,                  KBSS               ,PBL
     9,                  PBS                ,YBS
     T,                  UBOOV              ,SYSBUF
     1,                  BUFFR1             ,BUFFR2
     2,                  FILE1              ,FILE2
     3,                  FILE3              ,CLSRW
     4,                  DSNOS              ,DSCSET
C
C
C
      DIMENSION
     1                   MCB(7)             ,DSNOS(2)
     2,                  NAME(2)            ,BLOCK(11)
     3,                  IBLOCK(11)
C
C
C
      EQUIVALENCE
     1                   (BLOCK(1),IBLOCK(1))
     2,                  (BETASP,IBETA)
C
C MODULE PARAMETERS
C
      COMMON /BLANK/
     1                   NDSKIP             ,IREPTD
     2,                  DSCSET
C
C SYSTEM COMMON
C
      COMMON   /SYSTEM/
     1                   SYSBUF
C
C
C
      COMMON   /ZZZZZZ/
     1                   Z(1)
C
C
C
      DATA
     1                   NAME(1)/4HDSMG/    ,NAME(2)/4H2   /
      DATA
     1                   MPT
     2,                  KAA                ,KDAA
     3,                  KFS                ,KDFS
     4,                  KSS                ,KDSS
     5,                  PL                 ,PS
     6,                  YS                 ,UOOV
     7,                  KBAA               ,KBFS
     8,                  KBSS               ,PBL
     9,                  PBS                ,YBS
     T,                  UBOOV /
     1                   101,102,103,104,105,106,107,108,109,110,
     2                   111,201,202,203,204,205,206,207 /
      DATA
     1                   CLSRW/1/
      DATA
     1                   NEOR,DSNOS(1),DSNOS(2) / 0,53,10/
C
C
C
      IZMAX  = KORSZ (Z)
      BUFFR1 = IZMAX  - SYSBUF
      BUFFR2 = BUFFR1 - SYSBUF
      LEFT   = BUFFR2 - 1
C
C TURN DIFFERENTIAL STIFFNESS LOOPING FLAG ON AND INCREMENT THE INDEX
C OF BETA.  NOTE THAT NDSKIP MUST BE SET TO ZERO IN THE MODULE
C PROPERTIES TABLE.
C
      IREPTD = 1
      NDSKIP = NDSKIP + 1
C
C CALL LOCATE TO FIND THE RECORD OF THE MPT WHERE THE DSFACT CARDS ARE.
C THIS IS DONE ONLY IF A D.S. COEFFICIENT SET NO. IS GIVEN.
C
      IF (DSCSET .NE. (-1)) GO TO 5
C
C THERE IS NO LOOPING.  TURN LOOPING INDICATOR OFF.
C SEE COMMENTS ABOVE FORTRAN STATEMENT NO. 70 RE THE 4 SCALAR MULTIPLI-
C CATIONS WHEN DSCSET = -1.
C
      IREPTD = -1
      GO TO 165
    5 CALL PRELOC(*1030,Z(BUFFR1),MPT)
      CALL LOCATE(*1035,Z(BUFFR1),DSNOS,IDUMMY)
C
C
C
   10 CALL READ(*1040,*1050,MPT,SETNO,1,NEOR,IDUMMY)
      IF (SETNO .EQ. DSCSET) GO TO 30
C
C READ ONE WORD AT A TIME UNTIL A -1 (END OF SET INDICATOR) IS READ.
C
      DO 20 I = 1,32000
      CALL READ(*1060,*1070,MPT,J,1,NEOR,IDUMMY)
      IF (J .EQ. (-1)) GO TO 10
   20 CONTINUE
      CALL MESAGE (-30,84,1)
C
C TEST TO SEE IF WORDS MUST BE SKIPPED.
C
   30 IF (NDSKIP .EQ. 1) GO TO 40
C
C SKIP NDSKIP - 1 WORDS
C
      CALL READ(*1080,*1090,MPT,0,-(NDSKIP-1),NEOR,IDUMMY)
C
C READ THE VALUE OF BETA
C
   40 CALL READ(*1100,*1110,MPT,BETASP,1,NEOR,IDUMMY)
      IF (IBETA .EQ. (-1)) CALL MESAGE (-30,84,2)
C
C IF THE NEXT WORD IS A -1, WE HAVE READ THE LAST BETA.  HENCE SET
C IREPTD = -1
C
      CALL READ(*1120,*1130,MPT,J,1,NEOR,IFLAG)
      IF (J .EQ. (-1)) IREPTD = -1
      CALL CLOSE (MPT,CLSRW)
C
C PERFORM THE 4 SCALAR MULTIPLICATIONS.  N.B.---IF DSCSET = -1, THAT IS,
C ONLY ONE BETA WILL BE USED AND THAT HAS AN ASSUMED VALUE OF 1.0, IT IS
C ASSUMED THAT EQUIVALENCES HAVE BEEN MADE BETWEEN PL AND PBL, PS AND
C PBS, YS AND YBS, AND UOOV AND UBOOV.
C
      IND = 0
      FILE1 = PL
      FILE2 = PBL
   70 MCB(1) = FILE1
      CALL RDTRL (MCB)
C
C A FATAL ERROR OCCURS IF PL IS PURGED.
C
      IF (MCB(1) .LT. 0  .AND.  IND .EQ. 0) CALL MESAGE (-1,FILE1,NAME)
C
C IF THE INPUT FILE IS NOT PURGED AND IS NOT PL, SKIP THE OPERATION.
C
      IF (MCB(1) .LT. 0) GO TO 130
C
C THE INPUT FILE IS NOT PURGED. IF THE OUTPUT FILE IS PURGED, A FATAL
C ERROR OCCURS.
C
      MCB(1) = FILE2
      CALL RDTRL (MCB)
      IF (MCB(1) .LT. 0) CALL MESAGE (-1,FILE2,NAME)
      IBLOCK(1) = 1
      BLOCK (2) = BETASP
      BLOCK (3) = 0.0
      BLOCK (4) = 0.0
      BLOCK (5) = 0.0
      BLOCK (6) = 0.0
      IBLOCK(7) = 1
      BLOCK (8) = 0.0
      BLOCK (9) = 0.0
      BLOCK(10) = 0.0
      BLOCK(11) = 0.0
      CALL SSG2C (FILE1,0,FILE2,0,BLOCK(1))
  130 IND = IND + 1
      GO TO (140,150,160,170), IND
  140 FILE1= PS
      FILE2 = PBS
      GO TO 70
  150 FILE1 = YS
      FILE2 = YBS
      GO TO 70
  160 FILE1 = UOOV
      FILE2 = UBOOV
      GO TO 70
C
C PERFORM MATRIX ADDITIONS
C
  165 BETASP= 1.0
  170 FILE1 = KAA
      FILE2 = KDAA
      FILE3 = KBAA
      IND   = 0
  180 IUNDEF= 0
      MCB(1)= FILE1
      CALL RDTRL (MCB(1))
      IF (MCB(1) .LT. 0)  IF (IND) 190,190,200
      GO TO 210
  190 CALL MESAGE (-1,FILE1,NAME)
  200 IUNDEF = 1
  210 MCB(1) = FILE2
      CALL RDTRL (MCB(1))
      IF (MCB(1) .LT. 0)  IF (IUNDEF) 260,260,220
      IF (IUNDEF .EQ. 1) CALL MESAGE (-30,84,15)
      IBLOCK(1) = 1
      BLOCK (2) = 1.0
      BLOCK (3) = 0.0
      BLOCK (4) = 0.0
      BLOCK (5) = 0.0
      BLOCK (6) = 0.0
      IBLOCK(7) = 1
      BLOCK (8) = BETASP
      BLOCK (9) = 0.0
      BLOCK(10) = 0.0
      BLOCK(11) = 0.0
      CALL SSG2C (FILE1,FILE2,FILE3,0,BLOCK(1))
  220 IND = IND + 1
      GO TO (230,240,250),IND
  230 FILE1 = KFS
      FILE2 = KDFS
      FILE3 = KBFS
      GO TO 180
  240 FILE1 = KSS
      FILE2 = KDSS
      FILE3 = KBSS
      GO TO 180
  250 RETURN
  260 CALL MESAGE (-1,FILE2,NAME )
 1030 I = 3
      GO TO 1099
 1035 I = 4
      GO TO 1099
 1040 I = 5
      GO TO 1099
 1050 I = 6
      GO TO 1099
 1060 I = 7
      GO TO 1099
 1070 I = 8
      GO TO 1099
 1080 I = 9
      GO TO 1099
 1090 I = 10
      GO TO 1099
 1100 I = 11
      GO TO 1099
 1110 I = 12
      GO TO 1099
 1120 I = 13
      GO TO 1099
 1130 I = 14
 1099 CALL MESAGE (-30,84,I)
      RETURN
      END

      SUBROUTINE XSORT
C
C     SORT READS BULK DATA CARDS FROM THE INPUT TAPE, ADJUSTS THE
C     FIELDS, PERFORMS AN ALPHA-NUMERIC SORT ON THE CARD IMAGES FROM
C     LEFT TO RIGHT, INSERTS CONTINUATION CARDS IN THEIR PROPER
C     POSITION, AND PLACES THE RESULTING SORTED IMAGES ON THE NEW
C     PROBLEM TAPE.
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        LSHIFT,RSHIFT,ANDF,ORF
      LOGICAL         DEC
      DIMENSION       HEADU(32),HEADS(32),HEADN(32),IBLKDA(2),CDCNT(3),
     1                BK(4),MK(4),IBUF1(20),IBUF2(20),IBUF3(2),
     2                KPARNT(2),IBUF1A(2),IBUF2A(2),NSORT(2),IIEND(2)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG / UFM,UWM,UIM,SFM
      COMMON /MACHIN/ MACH
      COMMON /SYSTEM/ IBUFSZ,OUTTAP,NOGO,INTAPE,D1(14),IECHO,D,IAPPRC,
     1                DUM1(2),IUEDIT,DUM44(44),ISUBS,DUM12(12),ICPFLG,
     2                DUM8(8),LPCH
      COMMON /OUTPUT/ DUM2(96),HEAD1(32),HEAD2(32),HEAD3(32)
      COMMON /ZZZZZZ/ SKIP1,BUF(1)
      COMMON /XSRTCM/ BIMSK1(6),BIMSK2(5),BIMSK3(4),BIMSK4(4),BIMSK5(2),
     1                BIMSK6,BKMSK1(8),BKMSK2,SHIFTS(4),
     2                ICON1,ICON2,STAR,PLUS,DOLLAR,STARL,SLASH,SFTM,
     3                MASK,BLANK,MKA,IS,MBIT4
      COMMON /STAPID/ KRAP(12),KUMF
      COMMON /XECHOX/ FFFLAG,ECHOU,ECHOS,ECHOP
      EQUIVALENCE     (BK(1),BKMSK1(5)),(MK(1),BIMSK2(2)),
     1                (MKB  ,BIMSK5(1)),(INF  ,BIMSK2(1)),
     2                (SFTA ,SHIFTS(2)),(MKD  ,BIMSK2(2)),
     3                (MKE  ,BIMSK5(2)),(MKC  ,BIMSK4(1))
      EQUIVALENCE     (BLANX,BKMSK1(8))
      DATA HEADU/10*4H    ,4H I N,4H P U,4H T  ,4H B U,4H L K,4H   D,
     1       4H A T,4H A  ,4H D E,4H C K,4H   E,4H C H,4H O  ,9*4H    /
      DATA HEADS/11*4H    ,4H S O,4H R T,4H E D,4H   B,4H U L,4H K  ,
     1       4H D A,4H T A,4H   E,4H C H,4H O  ,10*4H    /
      DATA HEADN/ 3*4H    ,4H    ,4H    ,4H    ,4H .  ,4H 1  ,4H..  ,
     1       4H 2  ,4H..  ,4H 3  ,4H..  ,4H 4  ,4H..  ,4H 5  ,4H..  ,
     2       4H 6  ,4H..  ,4H 7  ,4H..  ,4H 8  ,4H..  ,4H 9  ,4H..  ,
     3       4H10  ,4H.   ,5*4H    /
      DATA CDCNT/4HCARD,4HCOUN,4HT   /,NSORT/4HXSOR,4HT   /
C     DATA BK/4H000 ,4H00  ,4H0   ,4H    /
C     DATA (MK(I),I=1,4)/O777777007777,O777700007777,O770000007777,O0/
C     DATA MKA,MKB,INF,SFTA/O000000777777,O377777777777,O777777777777,6/
C     DATA MKC/O007777777777/,MKD/O777777007777/,MKE/O377777007777/
      DATA IEND1,IEND2/4HENDD,4HATA /
      DATA IEND3,IEND4/4HENDA,4HTA  /
      DATA IEND5,IEND6/4HEND ,4HDATA/
C     DATA STAR,PLUS,DOLLAR,STARL/4H000*,4H+000,4H$000,4H*000/
      DATA IBLKDA/4HBULK,4HDATA/, IPTP/4HOPTP/, NPTP/4HNPTP/
      DATA ITAPE1,ITAPE2,ITAPE3,ITAPE4,ITAPE5/301,302,303,304,305/
      DATA UMF/4HUMF /
      DATA IDUP,IOK/4HDUPL, 4HOK  /
C
C
C     XSORT MAY NOT WORK PROPERLY IN ALL UNIX MACHINES, WHICH FOLLOW
C     THE VAX LINE.
C
      DEC    = MACH.EQ.5 .OR. MACH.EQ.6 .OR. MACH.EQ.21
      IF (DEC .AND. LPCH.NE.77) WRITE (OUTTAP,5) UWM
    5 FORMAT (A25,', SWITCHING TO OLD XSORT VIA DIAG 42 HAS NOT BEEN ',
     1       'THOROUGHLY TESTED', /5X,'FOR THE UNIX MACHINES.')
C
C     INITIALIZE XSORT AND TURN ON FREE-FIELD FLAG FOR XREAD
C
      FFFLAG = 1234
      ECHOU  = 0
      ECHOS  = 0
      ECHOP  = 0
      IEND   = 0
      ISEQ   = 0
      ICCBRK = 0
      NOTSOR = 0
      OPTP   = IPTP
      KIN    = 0
      IRESTR = -IAPPRC
      IF (KUMF .LE. 0) GO TO 90
      KIN    = 1
      CALL OPEN (*50,UMF,BUF(1),2)
C
C     FIND PARTICULAR BULK DATA FILE ON UMF AS REQUESTED BY USER
C
   10 CALL READ (*30,*60,UMF,PID,1,1,IFLG)
      IF (KUMF-PID) 30,80,20
   20 CALL SKPFIL (UMF,1)
      GO TO 10
   30 WRITE  (OUTTAP,35) UFM,KUMF
   35 FORMAT (A23,' 201, REQUESTED BULK DATA DECK',I8,' NOT ON USER ',
     1       'MASTER FILE.')
      CALL PAGE2 (2)
      NOGO =-1
      CALL CLOSE (UMF,1)
      RETURN
C
   50 WRITE  (OUTTAP,55) SFM
   55 FORMAT (A25,' 202, UMF COULD NOT BE OPENED')
      GO TO  1800
   60 WRITE  (OUTTAP,65) SFM
   65 FORMAT (A25,' 203, ILLEGAL EOR ON UMF')
      GO TO  1800
   80 CALL CLOSE (UMF,2)
C
   90 CALL INITCO
      IF (IECHO .LT. 0) GO TO 110
      ECHOU = ANDF(IECHO,1)
      ECHOS = ANDF(IECHO,2)
      ECHOP = ANDF(IECHO,4)
      IF (ICPFLG .NE. 0) ECHOS = 1
  110 ASSIGN 1260 TO IBRANA
      ASSIGN 810  TO IBRANB
      ASSIGN 1220 TO IBRANF
C
C     SET ASSIGN GO TO SWITCHES FOR MACHINE CONFIGURATIONS
C     THE 8 BIT CHARACTER BYTE OF THE 360 WILL HOLD THE INTERNAL
C     CHARACTER CODE (MAX=37) WITHOUT USE OF THE 1ST BIT POSITION -
C     THE OTHER 3 MACHINES HAVE 6 BIT CHARACTERS THEREFORE A SHIFT RIGHT
C     OF ONE MUST BE DONE TO REMOVE A POSSIBLE BIT FROM THE SIGN
C     POSITION THE FOLLOWING ASSIGNS SET THOSE BRANCHES BASED ON MACHINE
C
      IF (MACH.EQ.2 .OR. DEC) GO TO 120
      ASSIGN 350  TO MX3
      ASSIGN 790  TO MY1
      ASSIGN 820  TO MY2
      ASSIGN 960  TO MY3
      ASSIGN 990  TO MY4
      ASSIGN 1030 TO MY5
      ASSIGN 840  TO MY6
      ASSIGN 730  TO MZ1
      LINF   = 0
      NSHIFT = 1
C
C     SET NSHIFT TO ZERO FOR UNIVAC ASCII VERSION ONLY (NOT FORTRAN 5)
C
      IF (MACH .EQ. 3) NSHIFT = 0
      GO TO 130
  120 CONTINUE
      ASSIGN 360  TO MX3
      ASSIGN 800  TO MY1
      ASSIGN 970  TO MY2
      ASSIGN 970  TO MY3
      ASSIGN 1040 TO MY4
      ASSIGN 1040 TO MY5
      ASSIGN 850  TO MY6
      ASSIGN 740  TO MZ1
      LINF = ORF(IS,1)
  130 CONTINUE
C
C     START WORKING SORT BUFFER BELOW GINO I/O BUFFERS
C
      II     = 5*IBUFSZ + 1
      IBUFBG = II + 42
      IBUFLG = KORSZ(BUF) - 21
      IF (IBUFLG-IBUFBG .LT. 210)
     1    CALL MESAGE (-8,IBUFBG+210-IBUFLG,NSORT)
      ITAPE  = ITAPE1
      JTAPE  = ITAPE2
C
C     OPEN ITAPE4 AND ITAPE5
C     (4 CONTAINS CONTINUATIONS, 5 CONTAINS ALTERS)
C
      NBUF3 = 3*IBUFSZ + 1
      CALL OPEN (*1700,ITAPE4,BUF(NBUF3),1)
      NBUF4 = 4*IBUFSZ + 1
      CALL OPEN (*1700,ITAPE5,BUF(NBUF4),1)
C
C     A BUFFER LINE IS 20 WORDS OF CARD IMAGE PLUS A 1 WORD POINTER TO
C     THE NEXT IMAGE IN THE SORT SEQUENCE - A ZERO POINTER INDICATES
C     THE LAST IMAGE (LARGEST IN SORT)
C     INITIALIZE WORKING BUFFER - 1ST LINE ZEROS, 2ND LINE ALL BITS
C
      K = II + 19
      DO 140 J = II,K
      BUF(J) = LINF
  140 BUF(J+ 21) = INF
      BUF(II+41) = 0
C
C     SET UP UNSORTED HEADING
C
      DO 150 J = 1,32
      HEAD1(J) = HEADU(J)
  150 HEAD3(J) = HEADN(J)
      HEAD2(4) = HEADN(1)
      ICCNT    = 0
      IF (ECHOU .EQ. 0) GO TO 160
      CALL PAGE
C
C     OPEN ITAPE (LOCATION FOR EACH SORTED CORE LOAD AS ITS FORCED TO
C     EMPTY
C
  160 CALL OPEN (*1700,ITAPE,BUF(1),1)
  170 BUF(II+20) = 1
      K    = II
      NCNT = 2
C
C     LOOP TO INPUT AND SORT CARD IMAGES - USES OPEN CORE FOR SORTED
C     IMAGES
C
      DO 550 N1 = IBUFBG,IBUFLG,21
      N2 = N1 + 19
      N3 = N2 + 1
  180 CALL XREAD (*1770,BUF(N1))
      ICCNT = ICCNT + 1
      IF (ECHOU .EQ. 0) GO TO 220
      CALL PAGE2 (-1)
      WRITE  (OUTTAP,200)(BUF(I),I=N1,N2)
  200 FORMAT (30X,20A4)
  210 FORMAT (13X,I8,1H-,8X,20A4)
C
C     IGNORE BLANK CARDS
C
  220 IF (BUF(N1).EQ.BLANX .AND. BUF(N1+1).EQ.BLANX) GO TO 180
C
C     LEFT ADJUST FIELD 1
C
      CALL XFADJ1 (BUF(N1),LSHIFT,0)
C
C     TEST FOR END OF INPUT DATA STREAM (ENDDATA)
C
      IIEND(1) = IEND1
      IIEND(2) = IEND2
      IF (BUF(N1).EQ.IEND1 .AND. BUF(N1+1).EQ.IEND2) GO TO 560
      IIEND(1) = IEND3
      IIEND(2) = IEND4
      IF (BUF(N1).EQ.IEND3 .AND. BUF(N1+1).EQ.IEND4) GO TO 560
      IIEND(1) = IEND5
      IIEND(2) = IEND6
      IF (BUF(N1).EQ.IEND5 .AND. BUF(N1+1).EQ.IEND6) GO TO 560
C
C     IS THIS A CONTINUATION, COMMENT, OR DELETE CARD
C
      IF (.NOT.DEC) TST = ANDF(MK(3),BUF(N1))
      IF (     DEC) TST = KHRFN1(BKMSK2,1,BUF(N1),1)
C
C     WRITE CONTINUATIONS ON ITAPE4
C
      IF (TST.EQ.STARL .OR. TST.EQ.PLUS) GO TO 530
C
C     IGNORE COMMENT CARDS
C
      IF (TST .EQ. DOLLAR) GO TO 180
C
C     WRITE DELETES ON ITAPE5
C
      IF (TST .EQ. SLASH) GO TO 540
C
C     IF A STAR IS FOUND IN FIELD 1, MOVE IT TO COLUMN 8
C
      NY  = 4
      DO 240 J = 1,2
      NX  = N1 + 2 - J
      TST = BUF(NX)
      DO 230 I = 1,NY
      IF (.NOT.DEC) PTST = ANDF(MKA,TST)
      IF (     DEC) PTST = KHRFN1(BKMSK2,4,TST,4)
      IF (PTST .NE. BK(1)) GO TO 250
      IF (.NOT.DEC) TST = RSHIFT(TST,SFTA)
      IF (     DEC) TST = KHRFN3(BKMSK2,TST,1,0)
  230 CONTINUE
  240 NY = 3
      GO TO 260
C
C     STARSW = 0 FOR A SINGLE FIELD CARD (NO STAR)
C            = 1 FOR A DOUBLE FIELD CARD (W/ STAR)
C
  250 STARSW = 0
      IF (PTST .NE. STAR) GO TO 260
      STARSW = 1
      IF (J.EQ.1 .AND. I.EQ.1) GO TO 260
      IF (DEC) GO TO 258
      BUF(NX  ) = ORF(ANDF(MK(I),BUF(NX)),BK(I))
      BUF(N1+1) = ORF(ANDF(MK(1),BUF(N1+1)),STAR)
      GO TO 260
  258 BUF(NX  ) = KHRFN1(BUF(NX),5-I,BK(I),5-I)
      BUF(N1+1) = KHRFN1(BUF(N1+1),4,STAR,4)
  260 CONTINUE
      CALL XFADJ (BUF(N1+2),STARSW,NY)
      CALL EXTINT (BUF(N1))
C
C
C     START SORT LOGIC
C
C     WITHOUT THE FOLLOWING CARD, XSORT WILL ASSUME SOME DEGREE OF SORT
C     EXISTS (I.E.,THE NEXT CARD WILL FOLLOW THE PREVIOUS CARD, MORE
C     OFTEN THAN NOT)
C     K  = II  (THIS CARD WILL FORCE SORT TO BEGINNING OF CHAIN)
C
      KP = 0
C
C     K TYPE SUBSCRIPTS REFER TO POSITIONS AND ITEMS IN THE SORTED
C     TABLE CURRENTLY BEING BUILT
C     N TYPE SUBSCRIPTS REFER TO ITEMS ABOUT THE NEWEST CARD IN
C
  270 FCNT = 1
      NI = 0
      KI = 0
      NX = N1
C
C     THE RIGHT SHIFT IN THE FOLLOWING CODE IS USED TO AVOID THE
C     NEGATIVE SIGN PROBLEM WHICH WOULD REVERSE THE SORT ORDER ON SOME
C     MACHINES.
C     (NOTE THAT THE SORT COMPARES CAN BE MADE BOTH WITH OR WITHOUT
C     THE SIGN SHIFT DEPENDING ON THE MACHINES CHARACTER CONFIG)
C
  300 KX = K
      GO TO 340
  330 IF (BUF(NX) .EQ. BUF(KX)) GO TO 400
      IF (BUF(NX) .EQ. BK(4)  ) GO TO 380
      IF (BUF(KX) .EQ. BK(4)  ) GO TO 370
  340 GO TO MX3, (350,360)
  350 IF (RSHIFT(BUF(NX),NSHIFT)-RSHIFT(BUF(KX),NSHIFT)) 380,400,370
  360 IF (DEC) GO TO 365
      IF (BUF(NX) .LT. BUF(KX)) GO TO 380
      IF (BUF(NX) .GT. BUF(KX)) GO TO 370
      GO TO 400
  365 IF (RSHIFT(KHRFN4(BUF(NX)),1)-RSHIFT(KHRFN4(BUF(KX)),1))
     1    380,366,370
  366 IF (RSHIFT(LSHIFT(KHRFN4(BUF(NX)),1),1)-
     1    RSHIFT(LSHIFT(KHRFN4(BUF(KX)),1),1)) 380,400,370
C
C     GO ON, LOOK AT NEXT ITEM IN THE SORTED TABLE
C
  370 KP = K
      K  = BUF(K+20)*21 + II
      IF (NX .EQ. N1) GO TO 300
      GO TO 270
C
C     CARD POSITION FOUND IN SORT, SET THE CHAINING POINTER
C
  380 IF (KP .EQ. 0) GO TO 390
      BUF(N3   ) = BUF(KP+20)
      BUF(KP+20) = NCNT
      K    = KP
      NCNT = NCNT + 1
      GO TO 550
  390 K = II
      GO TO 270
C
C     TWO FIELDS EQUAL - SLIDE TO NEXT FIELD ON CARD
C
  400 FCNT = FCNT + 1
      NX   = NX + 1
      KX   = KX + 1
      GO TO (1760,410,470,330,510,330,430,330,510,330,520,330,510,330,
     1        430,330,510,330,380), FCNT
  410 KTARSW = 0
      IF (.NOT.DEC) ITST = ANDF(MKA,BUF(K+1))
      IF (     DEC) ITST = KHRFN1(BKMSK2,4,BUF(K+1),4)
      IF (ITST .EQ. STAR) KTARSW = 1
      IF (STARSW .EQ. KTARSW) GO TO 340
C
C     IF ONE MEMBER OF THE 2ND FIELD HAS A STAR AND THE OTHER DOES NOT,
C     DELETE STARS FOR THE COMPARE
C
      IF (DEC) GO TO 415
      IN1 = RSHIFT(ANDF(MKD,BUF(NX)),1)
      IK2 = RSHIFT(ANDF(MKD,BUF(KX)),1)
      GO TO 418
  415 IN1 = RSHIFT(KHRFN4(KHRFN1(BUF(NX),4,BKMSK2,1)),1)
      IK2 = RSHIFT(KHRFN4(KHRFN1(BUF(KX),4,BKMSK2,1)),1)
  418 IF (IN1 .NE. IK2) GO TO 428
      IF (DEC) GO TO 420
      IN1 = ANDF(MKE,BUF(NX))
      IK2 = ANDF(MKE,BUF(KX))
      GO TO 425
  420 IN1 = RSHIFT(LSHIFT(KHRFN4(KHRFN1(BUF(NX),4,BKMSK2,1)),1),1)
      IK2 = RSHIFT(LSHIFT(KHRFN4(KHRFN1(BUF(KX),4,BKMSK2,1)),1),1)
  425 IF (IN1 .EQ. IK2) GO TO 400
  428 IF (IN1 .LT. IK2) GO TO 380
      GO TO 370
C
C     INCREMENT FIELD LOCATIONS IF FIELD TYPES DID NOT MATCH
C
  430 IF (NI-KI) 450,460,440
  440 NX = NX + NI
      NI = 0
      GO TO 460
  450 KX = KX + KI
      KI = 0
C
C     ADJUST FIELDS RIGHT OR LEFT AS REQUIRED
C
  460 CALL XFADJ (BUF(NX),STARSW,K1)
      CALL XFADJ (BUF(KX),KTARSW,K2)
      GO TO 480
  470 IF (STARSW .EQ. KTARSW) GO TO 330
      K1 = 0
      K2 = 0
      IF (DEC) GO TO 472
      IF (ANDF(MK(3),BUF(NX)) .NE. BKMSK1(4)) K1 = 1
      IF (ANDF(MK(3),BUF(KX)) .NE. BKMSK1(4)) K2 = 1
      GO TO 480
  472 IF (KHRFN1(BKMSK2,1,BUF(NX),1) .NE. BKMSK1(4)) K1 = 1
      IF (KHRFN1(BKMSK2,1,BUF(KX),1) .NE. BKMSK1(4)) K2 = 1
  480 IF (STARSW-KTARSW) 500,330,490
  490 NI = 2
      IF (K1+K2 .EQ. 2) GO TO 330
      NX = NX + 2
      NI = 0
      GO TO 330
  500 KI = 2
      IF (K1+K2 .EQ. 2) GO TO 330
      KX = KX + 2
      KI = 0
      GO TO 330
  510 IF (STARSW .NE. KTARSW) GO TO 430
      IF (STARSW .EQ.      0) GO TO 430
      GO TO 330
  520 IF (STARSW .EQ. KTARSW) GO TO 430
      GO TO 380
C
C     CONTINUATION CARD - PUT ON ITAPE4
C
  530 CALL WRITE (ITAPE4,BUF(N1),20,1)
      GO TO 180
C
C     BULK DATA DELETE CARD - PUT ON ITAPE5
C
C     TEST FOR EXTRANEOUS DATA IN FIELD 1 OF DELETE CARD
C     AND WRITE OUT TO SCRATCH FILE
C
  540 IF (.NOT.DEC) ITST1 = ANDF(BUF(N1),BIMSK1(6))
      IF (     DEC) ITST1 = ANDF(BUF(N1),BIMSK1(1))
      ITST2 = ANDF(BUF(N1+1),MBIT4)
      IBK3  = ANDF(BK(3),MBIT4)
      IBK4  = ANDF(BK(4),MBIT4)
      IF (ITST1.EQ.IBK3 .AND. ITST2.EQ.IBK4) GO TO 545
      CALL PAGE2 (2)
      WRITE  (OUTTAP,541) UFM
  541 FORMAT (A23,' 221, EXTRANEOUS DATA IN FIELD 1 OF BULK DATA ',
     1        'DELETE CARD.')
      NOGO = -2
  545 CALL XFADJ1 (BUF(N1+2),RSHIFT,0)
      CALL XBCDBI (BUF(N1+2))
      CALL XFADJ1 (BUF(N1+4),RSHIFT,0)
      CALL XBCDBI (BUF(N1+4))
      BUF(N1+4) = BUF(N1+5)
      CALL WRITE (ITAPE5,BUF(N1+3),2,1)
      GO TO 180
C
C     END OF BIG SORT LOOP
C
  550 CONTINUE
      GO TO 590
C
C
C     SET (ENDDATA) CARD FOUND FLAG
C
  560 IEND = -1
      IF (ECHOU .NE. 1) GO TO 572
      CALL PAGE2 (2)
      WRITE  (OUTTAP,570) ICCNT
  570 FORMAT (//24X,12HTOTAL COUNT=,I5)
  572 CONTINUE
C
C     TEST FOR COLD-START WITH NO BULK DATA
C
      IF (ICCNT.GT.1 .OR. IRESTR.GT.0 .OR. KUMF.GT.0) GO TO 590
      IF (IAPPRC .EQ. 1) GO TO 590
      IF (ISUBS  .NE. 0) GO TO 590
      CALL PAGE2 (2)
      WRITE  (OUTTAP,580) UFM
  580 FORMAT (A23,' 204, COLD START NO BULK DATA.')
      NOGO = -2
      RETURN
C
C
C     IF MODIFIED RESTART - TURN ON SORT ECHO
C
  590 CONTINUE
C
C     THIS SECTION UNCHAINS THE SORTED TABLE AND WRITES A CORE LOAD,
C     IN ITS ACTUAL ORDER, ONTO A MERGE SCRATCH TAPE.
C
      J = BUF(II+20)
      J1ST = J*21 + II
      KEEP = 1
  610 J  = J*21 + II
      J1 = BUF(J+20)
      IF (J1 .EQ. 0) GO TO 620
C
C     ITAPE IS PRIMARY CORE UNLOAD TAPE
C
      CALL WRITE (ITAPE,BUF(J),20,1)
      IF (J .LT. KEEP) NOTSOR = 1
      KEEP = J
      J    = J1
      GO TO 610
  620 ISEQ = ISEQ + 1
      IF (ISEQ .EQ. 2) GO TO 640
      IF (ISEQ .GT. 2) GO TO 650
      IF (IEND .NE. 0) GO TO 630
      ITAPE = ITAPE2
      CALL OPEN (*1700,ITAPE,BUF(IBUFSZ+1),1)
      GO TO 170
C
C     NO MERGING IS REQUIRED, ALL CARDS FIT WITHIN ONE WORKING BUFFER
C     LOAD
C
  630 KTAPE = ITAPE
      CALL CLOSE (KTAPE,1)
      GO TO 1260
C
C     SET UP 1ST MERGE
C
  640 CALL CLOSE (ITAPE,1)
      ITAPE = ITAPE1
      KOP   = 0
C
C     SET UP SUBSEQUENT MERGE TAPES
C
  650 IF (MOD(ISEQ,2) .EQ. 0) GO TO 660
      JTAPE = ITAPE3
      KTAPE = ITAPE2
      GO TO 670
  660 JTAPE = ITAPE2
      KTAPE = ITAPE3
  670 CALL CLOSE (ITAPE,1)
C
C     SPECIAL LOGIC TO AVOID MERGE IF NEW CORE LOAD FOLLOWS ALL PREVIOUS
C
      IF (KOP-1) 760,700,680
  680 DO 690 J = 1,18
  690 IBUF1(J) = IBUF2(J)
  700 DO 710 J = 1,18
      IF (BUF(J1ST) .NE. IBUF1(J)) GO TO 720
  710 J1ST = J1ST + 1
      GO TO 760
  720 GO TO MZ1, (730,740)
  730 IF (RSHIFT(BUF(J1ST),NSHIFT).LT.RSHIFT(IBUF1(J),NSHIFT)) GO TO 755
      GO TO 750
  740 IF (DEC) GO TO  745
      IF (BUF(J1ST) .LT. IBUF1(J)) GO TO 755
      GO TO 750
  745 IF (KHRFN4(BUF(J1ST)).LT.KHRFN4(IBUF1(J))) GO TO 755
  750 TRIAL = KTAPE
      KTAPE = JTAPE
      JTAPE = TRIAL
      ISEQ  = ISEQ - 1
      CALL OPEN (*1700,ITAPE,BUF(1),0)
      CALL OPEN (*1700,KTAPE,BUF(IBUFSZ+1),3)
      GO TO 1210
C
C     THIS SECTION PERFORMS A 2 TAPE ALPHANUMERIC MERGE
C     (ITAPE+JTAPE=KTAPE)
C     SAME BASIC LOGIC AS ORIGINAL SORT COMPARES (COMMENT CARDS OMITTED)
C
  755 NOTSOR = 1
  760 CALL OPEN (*1700,ITAPE,BUF(1),0)
  770 CALL OPEN (*1700,JTAPE,BUF(IBUFSZ+1),0)
      NBUF2 = 2*IBUFSZ + 1
      CALL OPEN (*1700,KTAPE,BUF(NBUF2),1)
      CCNT = 0
  780 CALL READ (*1190,*1710,JTAPE,IBUF2,20,1,IFLG)
      IF (MACH.EQ.2 .AND. (JTAPE.EQ.UMF .OR. JTAPE.EQ.IPTP))
     1    CALL UMFTRN (IBUF2)
      IF (MACH.EQ.3 .AND. KIN.EQ.1) CALL UMFFD (IBUF2)
      LDUP = 0
      IF (ITAPE .EQ. OPTP) CALL CRDFLG (IBUF2)
      KTARSW = 0
      IF (.NOT.DEC) ITST = ANDF(MKA,IBUF2(2))
      IF (     DEC) ITST = KHRFN1(BKMSK2,4,IBUF2(2),4)
      IF (ITST .EQ. STAR) KTARSW = 1
      GO TO MY1, (790,800)
  790 IBUF2A(1) = RSHIFT(IBUF2(1),NSHIFT)
      IBUF2A(2) = RSHIFT(IBUF2(2),NSHIFT)
  800 CALL READ (*1240,*1710,ITAPE,IBUF1,20,1,IFLG)
      IF (MACH.EQ.2 .AND. (ITAPE.EQ.UMF .OR. ITAPE.EQ.IPTP))
     1    CALL UMFTRN (IBUF1)
      IF (MACH.EQ.3 .AND. KIN.EQ.1) CALL UMFFD (IBUF1)
      STARSW = 0
      IF (.NOT.DEC) ITST = ANDF(MKA,IBUF1(2))
      IF (     DEC) ITST = KHRFN1(BKMSK2,4,IBUF1(2),4)
      IF (ITST .EQ. STAR) STARSW = 1
      GO TO IBRANB, (830,810)
  810 GO TO MY2, (820,970)
  820 IBUF1A(1) = RSHIFT(IBUF1(1),NSHIFT)
      IBUF1A(2) = RSHIFT(IBUF1(2),NSHIFT)
      GO TO 970
C
C     TEST IF CARD IS TO BE DELETED
C
  830 CCNT = CCNT + 1
      IF (.NOT.DEC) TST = ANDF(MK(3),IBUF1(1))
      IF (     DEC) TST = KHRFN1(BKMSK2,1,IBUF1(1),1)
      ICCFLG = -1
      IF (TST.EQ.PLUS .OR. TST.EQ.STARL) GO TO 860
      CALL EXTINT (IBUF1(1))
      GO TO MY6, (840,850)
  840 IBUF1A(1) = RSHIFT(IBUF1(1),NSHIFT)
      IBUF1A(2) = RSHIFT(IBUF1(2),NSHIFT)
  850 ICCFLG    = 0
      KPARNT(1) = IBUF1(1)
      KPARNT(2) = IBUF1(2)
  860 GO TO IBRANC, (870,880,900)
  870 CALL READ (*920,*1710,ITAPE5,IBUF3,2,1,IFLG)
      IF (IBUF3(1) .EQ. 0) GO TO 870
      ASSIGN 880 TO IBRANC
  880 IF (IBUF3(2) .NE.    0) GO TO 890
      IF (IBUF3(1) .NE. CCNT) GO TO 900
      ASSIGN 870 TO IBRANC
      GO TO 930
  890 IF (IBUF3(2) .EQ. CCNT) ASSIGN 870 TOIBRANC
      IF (IBUF3(1).LE.CCNT .AND. IBUF3(2).GE.CCNT) GO TO 930
C
C     REMOVE ANY UNDELETED CONTINUATION CARDS DURING RESTART MERGE
C
  900 IF (ICCFLG .EQ. 0) GO TO IBRANE, (970,1220)
      CALL WRITE (ITAPE4,IBUF1(1),20,1)
  910 GO TO IBRAND, (800,1210)
  920 ASSIGN 900 TO IBRANC
      CALL CLOSE (ITAPE5,1)
      GO TO 900
C
C     IF CONTINUATION WAS DELETED, FLAG PARENT
C
  930 IF (ICCFLG .EQ. 0) GO TO 940
      CALL CRDFLG (KPARNT)
      GO TO 910
  940 CALL CRDFLG (IBUF1)
      GO TO 910
  950 CALL READ (*1190,*1710,JTAPE,IBUF2,20,1,IFLG)
      IF (MACH.EQ.2 .AND. (JTAPE.EQ.UMF .OR. JTAPE.EQ.IPTP))
     1    CALL UMFTRN (IBUF2)
      IF (MACH.EQ.3 .AND. KIN.EQ.1) CALL UMFFD (IBUF2)
      IF (ITAPE .EQ. OPTP) CALL CRDFLG (IBUF2)
      KTARSW = 0
      IF (.NOT.DEC) ITST = ANDF(MKA,IBUF2(2))
      IF (     DEC) ITST = KHRFN1(BKMSK2,4,IBUF2(2),4)
      IF (ITST .EQ. STAR) KTARSW = 1
      GO TO MY3, (960,970)
  960 IBUF2A(1) = RSHIFT(IBUF2(1),NSHIFT)
      IBUF2A(2) = RSHIFT(IBUF2(2),NSHIFT)
  970 J  = 1
      J1 = 1
      J2 = 1
      NI = 0
      KI = 0
  980 GO TO MY4, (990,1040)
  990 IF (IBUF1A(J1)-IBUF2A(J2)) 1050,1070,1060
 1000 IF (STARSW .EQ. KTARSW) GO TO 980
      IF (DEC) GO TO 1005
      IN1 = RSHIFT(ANDF(MKD,IBUF1(J1)),1)
      IK2 = RSHIFT(ANDF(MKD,IBUF2(J2)),1)
      GO TO 1008
 1005 IN1 = RSHIFT(KHRFN4(KHRFN1(IBUF1(J1),4,BKMSK2,1)),1)
      IK2 = RSHIFT(KHRFN4(KHRFN1(IBUF2(J2),4,BKMSK2,1)),1)
 1008 IF (IN1 .NE. IK2) GO TO 1018
      IF (DEC) GO TO 1010
      IN1 = ANDF(MKE,IBUF1(J1))
      IK2 = ANDF(MKE,IBUF2(J2))
      GO TO 1015
 1010 IN1 = RSHIFT(LSHIFT(KHRFN4(KHRFN1(IBUF1(J1),4,BKMSK2,1)),1),1)
      IK2 = RSHIFT(LSHIFT(KHRFN4(KHRFN1(IBUF2(J2),4,BKMSK2,1)),1),1)
 1015 IF (IN1 .EQ. IK2) GO TO 1070
 1018 IF (IN1 .LT. IK2) GO TO 1050
      GO TO 1060
 1020 IF (IBUF1(J1) .EQ. IBUF2(J2)) GO TO 1070
      IF (IBUF1(J1) .EQ. BK(4)    ) GO TO 1050
      IF (IBUF2(J2) .EQ. BK(4)    ) GO TO 1060
      GO TO MY5, (1030,1040)
 1030 IF (RSHIFT(IBUF1(J1),1)-RSHIFT(IBUF2(J2),1)) 1050,1070,1060
 1040 IF (DEC) GO TO 1045
      IF (IBUF1(J1) .LT. IBUF2(J2)) GO TO 1050
      IF (IBUF1(J1) .GT. IBUF2(J2)) GO TO 1060
      GO TO 1070
 1045 IF (KHRFN4(IBUF1(J1))-KHRFN4(IBUF2(J2))) 1050,1070,1060
 1050 CALL WRITE (KTAPE,IBUF1,20,1)
      KOP = 1
      GO TO 800
 1060 CALL WRITE (KTAPE,IBUF2,20,1)
      KOP = 2
      GO TO 950
 1070 J  = J  + 1
      J1 = J1 + 1
      J2 = J2 + 1
      GO TO (1760,1000,1120,1020,1160,1020,1080,1020,1160,1020,1170,
     1       1020,1160,1020,1080,1020,1160,1020,1180), J
 1080 IF (NI-KI) 1100,1110,1090
 1090 J1 = J1 + NI
      NI = 0
      GO TO 1110
 1100 J2 = J2 + KI
      KI = 0
 1110 CALL XFADJ (IBUF1(J1),STARSW,K1)
      CALL XFADJ (IBUF2(J2),KTARSW,K2)
      GO TO 1130
 1120 IF (STARSW .EQ. KTARSW) GO TO 1020
      K1 = 0
      K2 = 0
      IF (DEC) GO TO 1122
      IF (ANDF(MK(3),IBUF1(J1)) .NE. BKMSK1(4)) K1 = 1
      IF (ANDF(MK(3),IBUF2(J2)) .NE. BKMSK1(4)) K2 = 1
      GO TO 1130
 1122 IF (KHRFN1(BKMSK2,1,IBUF1(J1),1) .NE. BKMSK1(4)) K1 = 1
      IF (KHRFN1(BKMSK2,1,IBUF2(J2),1) .NE. BKMSK1(4)) K2 = 1
 1130 IF (STARSW-KTARSW) 1150,1020,1140
 1140 NI = 2
      IF (K1+K2 .EQ. 2) GO TO 1020
      J1 = J1 + 2
      NI = 0
      GO TO 1020
 1150 KI = 2
      IF (K1+K2 .EQ. 2) GO TO 1020
      J2 = J2 + 2
      KI = 0
      GO TO 1020
 1160 IF (STARSW .NE. KTARSW) GO TO 1080
      IF (STARSW .EQ.      0) GO TO 1080
      GO TO 1020
C
C     DUPLICATE CARD
C
 1170 IF (STARSW .EQ. KTARSW) GO TO 1080
 1180 CALL WRITE (KTAPE,IBUF1,20,1)
      CALL WRITE (KTAPE,IBUF2,20,1)
      LDUP = -1
      GO TO 780
C
C     ONE OF TWO TAPES BEING MERGED IS EXHAUSTED, OTHER TAPE IS COPIED
C     ONTO THE MERGE TAPE
C
 1190 IF (ITAPE .NE. OPTP) GO TO 1200
      ASSIGN 1210 TO IBRAND
      ASSIGN 1220 TO IBRANE
      ASSIGN 830 TO IBRANF
      IF (CCNT .EQ. 0) GO TO 1210
 1200 IF (LDUP .LT. 0) GO TO 1210
      GO TO 1220
 1210 CALL READ (*1250,*1710,ITAPE,IBUF1,20,1,IFLG)
      IF (MACH.EQ.2 .AND. (ITAPE.EQ.UMF .OR. ITAPE.EQ.IPTP))
     1    CALL UMFTRN (IBUF1)
      IF (MACH.EQ.3 .AND. KIN.EQ.1) CALL UMFFD (IBUF1)
      GO TO IBRANF, (830,1220)
 1220 CALL WRITE (KTAPE,IBUF1,20,1)
      KOP = 1
      GO TO 1210
 1230 CALL READ (*1250,*1710,JTAPE,IBUF2,20,1,IFLG)
      IF (MACH.EQ.2 .AND. (JTAPE.EQ.UMF .OR. JTAPE.EQ.IPTP))
     1    CALL UMFTRN (IBUF2)
      IF (MACH.EQ.3 .AND. KIN.EQ.1) CALL UMFFD (IBUF2)
 1240 CALL WRITE (KTAPE,IBUF2,20,1)
      KOP = 2
      GO TO 1230
C
C     CLOSE TAPES ENVOLVED IN MERGE
C
 1249 CALL CLOSE (ITAPE,2)
      GO TO 1251
 1250 IF (IUEDIT .EQ.   1) GO TO 1249
      IF (ITAPE .EQ. OPTP) GO TO 1249
      CALL CLOSE (ITAPE,1)
 1251 CALL CLOSE (JTAPE,3)
      CALL CLOSE (KTAPE,3)
      GO TO IBRANA, (1260,1440)
C
C     WAS THIS THE FINAL MERGE (LAST CORE LOAD OF CARDS)
C
 1260 IF (IEND .EQ. 0) GO TO 160
      CALL PAGE2 (2)
      WRITE (OUTTAP,1660)
      CALL CLOSE (ITAPE5,1)
C
C     PROCESS DELETE CARDS (IF ANY)
C
      NBUF4 = 4*IBUFSZ + 1
      CALL OPEN (*1700,ITAPE5,BUF(NBUF4),0)
C
C     IF NOT RESTART - NO DELETES SHOULD EXIST
C
      IF (IRESTR.GT.0 .OR. KIN.GT.0) GO TO 1280
C
      CALL READ (*1440,*1710,ITAPE5,IBUF3,1,1,IFLG)
C
C     NOT RESTART AND DELETES DO EXIST - WARNING
C
      CALL CLOSE (ITAPE5,1)
      CALL PAGE2 (2)
      WRITE  (OUTTAP,1270) UWM
 1270 FORMAT (A25,' 205, COLD START,DELETE CARDS IGNORED.')
      GO TO 1440
C
C     FORM DELETE CARD LIST
C
 1280 IBUF3(1)  = INF
      BUF(II  ) = MKB
      BUF(II+1) = MKB
      DO 1320 J = II,IBUFLG,2
      CALL READ (*1330,*1710,ITAPE5,IBUF3,2,1,IFLG)
      DO 1290 I = II,J,2
      IF (IBUF3(1) .LE. BUF(I)) GO TO 1300
 1290 CONTINUE
C
C     PUSH DOWN LIST - MAKE DOUBLE WORD SLOT
C
 1300 KK = J + 2
      K1 = (J-I)/2 + 1
      DO 1310 K = 1,K1
      BUF(KK+1) = BUF(KK-1)
      BUF(KK  ) = BUF(KK-2)
 1310 KK = KK - 2
      BUF(I  ) = IBUF3(1)
 1320 BUF(I+1) = IBUF3(2)
C
C     IF DELETE CARD LIST WILL NOT FIT
C
      CALL MESAGE (-8,0,NSORT)
C
C     EOF ON ITAPE5, IF IBUF3(1)= INF, THERE ARE NO DELETE CARDS
C
 1330 IF (IBUF3(1) .EQ. INF) GO TO 1400
      J = J - 1
C
C     CHECK FOR AND ELIMINATE OVERLAPS AND REDUNDANCYS IN DELETES
C
      IMIN = 0
      DO 1380 I = II,J,2
      IF (BUF(I) .EQ. 0) GO TO 1380
      IF (BUF(I) .LT. BUF(I+1)) GO TO 1340
      BUF(I+1) = 0
      IF (BUF(I) .EQ. BUF(I+2)) GO TO 1350
      IF (IMIN .EQ. 0) GO TO 1380
      IF (BUF(I) .GT. BUF(IMAX)) GO TO 1370
      GO TO 1350
 1340 IF (IMIN .EQ. 0) GO TO 1360
      IF (BUF(I  ) .GT. BUF(IMAX)) GO TO 1360
      IF (BUF(I+1) .LT. BUF(IMAX)) GO TO 1350
      BUF(IMAX) = BUF(I+1)
 1350 BUF(I) = 0
      GO TO 1380
 1360 IMIN = I
      IMAX = I + 1
      GO TO 1380
 1370 IMIN = 0
 1380 CONTINUE
      CALL CLOSE (ITAPE5,1)
C
C     PUT OUT SORTED DELETE CARD LIST
C
      NBUF4 = 4*IBUFSZ + 1
      CALL OPEN (*1700,ITAPE5,BUF(NBUF4),1)
      DO 1390 I = II,J,2
      IF (BUF(I) .EQ. 0) GO TO 1390
      CALL WRITE (ITAPE5,BUF(I),2,1)
 1390 CONTINUE
 1400 CALL CLOSE (ITAPE5,1)
C
C     AT THIS POINT, IF THIS IS A RESTART, MERGE OPTP, FINAL KTAPE,
C     + DELETE
C
      ASSIGN 1440 TO IBRANA
      ASSIGN 830  TO IBRANB
      ASSIGN 870  TO IBRANC
      ASSIGN 800  TO IBRAND
      ASSIGN 970  TO IBRANE
      NBUF4 = 4*IBUFSZ + 1
      CALL OPEN (*1700,ITAPE5,BUF(NBUF4),0)
C
      IF (KIN .GT. 0) GO TO 1430
C
      CALL OPEN (*1740,OPTP,BUF(1),0)
 1410 CALL READ (*1730,*1710,OPTP,IBUF3,2,1,IFLG)
      IF (IBUF3(1).EQ.IBLKDA(1) .AND. IBUF3(2).EQ.IBLKDA(2)) GO TO 1420
      CALL SKPFIL (OPTP,+1)
      GO TO 1410
 1420 ITAPE = OPTP
      TRIAL = JTAPE
      JTAPE = KTAPE
      KTAPE = TRIAL
      IF (ICCNT .EQ. 1) GO TO 1440
      CALL WRITE (ITAPE4,MKB,20,1)
      GO TO 770
C
 1430 OPTP = UMF
      CALL OPEN (*50,UMF,BUF(1),2)
      GO TO 1420
C
C     PROCESS CONTINUATION CARDS (IF ANY)
C
 1440 CALL CLOSE (ITAPE4,1)
      NBUF3 = 3*IBUFSZ + 1
      CALL OPEN (*1700,ITAPE4,BUF(NBUF3),0)
      IF (ICCNT.EQ.1 .AND. (IRESTR.GT.0 .OR. KIN.GT.0)) KTAPE = OPTP
      IF (ICCNT.EQ.1 .AND. (IRESTR.GT.0 .OR. KIN.GT.0)) GO TO 1441
      NBUF2 = 2*IBUFSZ + 1
      CALL OPEN (*1700,KTAPE,BUF(NBUF2),0)
C
C     FORM CONTINUATION CARD DICTIONARY
C
 1441 CONTINUE
      IBUF1(1) = 0
      DO 1470 J = II,IBUFLG,4
      CALL READ (*1480,*1710,ITAPE4,IBUF1,20,1,IFLG)
      IF (MACH.EQ.2 .AND. IBUF1(1).NE.MKB) CALL UMFTRN (IBUF1)
      IF (MACH.EQ.3 .AND. KIN.EQ.1) CALL UMFFD (IBUF1)
      IF (IBUF1(1) .NE. MKB) GO TO 1460
      IF (J .EQ. II) GO TO 1450
      ICCBRK = J
 1450 BUF(J) = DOLLAR
      GO TO 1465
 1460 IF (.NOT.DEC) BUF(J) = ANDF(MKC,IBUF1(1))
      IF (     DEC) BUF(J) = KHRFN1(IBUF1(1),1,BKMSK2,1)
 1465 BUF(J+1) = IBUF1(2)
      IF (.NOT.DEC) BUF(J+2) = ANDF(MKC,IBUF1(19))
      IF (     DEC) BUF(J+2) = KHRFN1(IBUF1(19),1,BKMSK2,1)
      BUF(J+3) = IBUF1(20)
 1470 CONTINUE
C
C
C     CORE INSUFFICIENT TO ACCOMMODATE 4-WORD PER CARD DICTIONARY
C     OF CONTINUATION CARDS
C
      CALL MESAGE (-8,0,NSORT)
C
C     EOF ON ITAPE4, IF IBUF1(1)= 0, THERE ARE NO CONTINUATION CARDS
C
 1480 IF (IBUF1(1) .EQ. 0) GO TO 1510
      CALL REWIND (ITAPE4)
      JO = 1
      ICONLG = J - 1
C
C     CHECK AND SET FLAGS FOR DUPLICATE CONTINUATION CARDS
C
      K = ICONLG - 4
      IF (K .LE. II) GO TO 1510
      DO 1500 J = II,K,4
      IF (BUF(J) .EQ. IDUP) GO TO 1500
      INDEX = 0
      M = J + 4
      DO 1490 JJ = M,ICONLG,4
      IF (BUF(JJ ) .EQ. IDUP     ) GO TO 1490
      IF (BUF(J  ) .NE. BUF(JJ)  ) GO TO 1490
      IF (BUF(J+1) .NE. BUF(JJ+1)) GO TO 1490
      BUF(JJ) = IDUP
      INDEX = 1
 1490 CONTINUE
      IF (INDEX .EQ. 1) BUF(J) = IDUP
 1500 CONTINUE
C
C     SET UP AND PUT OUT SORTED HEADING
C
 1510 IF (NOTSOR .EQ. 0) GO TO 1515
      CALL PAGE2 (2)
      WRITE  (OUTTAP,1511) UIM
 1511 FORMAT (A29,' 207, BULK DATA NOT SORTED, XSORT WILL RE-ORDER ',
     1       'DECK.')
 1515 IF (ECHOS .EQ. 0) GO TO 1530
      DO 1520 J = 1,32
 1520 HEAD1(J) = HEADS(J)
      HEAD2(4) = CDCNT(1)
      HEAD3(4) = CDCNT(2)
      HEAD3(5) = CDCNT(3)
      CALL PAGE
      CCNT = 0
 1530 CALL CLOSE (ITAPE5,1)
      J = II
      NBUF4 = 4*IBUFSZ + 1
      CALL OPEN (*1750,NPTP,BUF(NBUF4),3)
      CALL WRITE (NPTP,IBLKDA,2,1)
      IF (IBUF1(1) .EQ. 0) GO TO 1630
C
C     MERGE CONTINUATION CARDS - PRODUCE DATA ON NPTP
C
 1540 CALL READ (*1640,*1710,KTAPE,IBUF1,20,1,IFLG)
      IF (ICCBRK .EQ. 0) GO TO 1550
      KPARNT(1) = IBUF1(1)
      KPARNT(2) = IBUF1(2)
 1550 CALL INTEXT (IBUF1(1))
      IF (MACH .EQ. 2) CALL UMFTRN (IBUF1)
      IF (MACH.EQ.3 .AND. KIN.EQ.1) CALL UMFFD (IBUF1)
      CALL WRITE (NPTP,IBUF1,20,1)
      IF (ECHOS .EQ. 0) GO TO 1551
      CALL PAGE2 (-1)
      CCNT = CCNT + 1
      CALL XPRETY (IBUF1)
      WRITE (OUTTAP,210) CCNT,IBUF1
C
C      PUNCH OUT DECK
C
 1551 IF (ECHOP .EQ. 0) GO TO 1554
      IF (ECHOS .NE. 0) GO TO 1552
      CALL XPRETY (IBUF1)
 1552 WRITE  (LPCH,1553) IBUF1
 1553 FORMAT (20A4)
 1554 CONTINUE
C
C     SEE IF PREVIOUS CARD HAS A CONTINUATION
C     IF CONTINUATION FIELD BLANK - CONTINUATION NOT POSSIBLE
C
      IF (IBUF1(19).EQ.BK(4) .AND. IBUF1(20).EQ.BK(4)) GO TO 1540
      IF (.NOT.DEC) TRIAL = ANDF(MKC,IBUF1(19))
      IF (     DEC) TRIAL = KHRFN1(IBUF1(19),1,BKMSK2,1)
      JN = 0
 1571 CONTINUE
C
      DO 1601 K = II,ICONLG,4
C
C     IGNORE DUPLICATE CONTINUATION CARDS
C
      IF (BUF(J) .EQ. IDUP) GO TO 1600
      IF (IBUF1(20) .NE. BUF(J+1)) GO TO 1600
      IF (.NOT.DEC) ITST = ANDF(MKC,BUF(J))
      IF (     DEC) ITST = KHRFN1(BUF(J),1,BKMSK2,1)
      IF (ITST .NE. TRIAL) GO TO 1600
C
C     A CONTINUATION EXISTS, HAS IT ALREADY BEEN USED
C
      IF (.NOT.DEC) ITST = ANDF(MK(3),BUF(J))
      IF (     DEC) ITST = KHRFN1(BKMSK2,1,BUF(J),1)
      IF (ITST .EQ. DOLLAR) GO TO 1610
      IF (J .GT. ICCBRK) GO TO 1580
      CALL CRDFLG (KPARNT)
 1580 IF (.NOT.DEC) BUF(J) = ORF(BUF(J),DOLLAR)
      IF (     DEC) BUF(J) = KHRFN1(BUF(J),1,DOLLAR,1)
      JN = (J-II)/4 + 1
      CALL XRECPS (JN,JO)
      CALL READ (*1720,*1710,ITAPE4,IBUF1,20,1,IFLG)
      IF (MACH .EQ. 2) CALL UMFTRN (IBUF1)
      IF (MACH.EQ.3 .AND. KIN.EQ.1) CALL UMFFD (IBUF1)
      CALL WRITE (NPTP,IBUF1,20,1)
      IF (ECHOS .EQ. 0) GO TO 1581
      CALL PAGE2 (-1)
      CCNT = CCNT+ 1
      WRITE (OUTTAP,210) CCNT,IBUF1
 1581 IF (ECHOP .EQ. 0) GO TO 1584
      WRITE (LPCH,1553) IBUF1
 1584 CONTINUE
      IF (.NOT.DEC) TRIAL = ANDF(MKC,IBUF1(19))
      IF (     DEC) TRIAL = KHRFN1(IBUF1(19),1,BKMSK2,1)
      IF (IBUF1(19).EQ.BK(4) .AND. IBUF1(20).EQ.BK(4)) GO TO 1540
      GO TO 1571
 1600 J = J + 4
      IF (J .GT. ICONLG) J = II
 1601 CONTINUE
      GO TO 1540
C
C     DUPLICATE PARENT - ERROR
C
 1610 NL = 0
      IF (ECHOS .NE. 0) GO TO 1612
      NL = 1
      WRITE (OUTTAP,200) IBUF1
 1612 NL = NL +2
      CALL PAGE2 (-NL)
      WRITE  (OUTTAP,1620) UFM
 1620 FORMAT (A23,' 208, PREVIOUS CARD IS A DUPLICATE PARENT.')
      NOGO = -1
      GO TO 1540
C
C     NO CONTINUATION CARDS
C
 1630 CALL READ (*1640,*1710,KTAPE,IBUF2,20,1,IFLG)
      IF (ICCNT .EQ. 1) GO TO 1631
      CALL INTEXT (IBUF2(1))
 1631 CONTINUE
      IF (MACH .EQ. 2) CALL UMFTRN (IBUF2)
      IF (MACH.EQ.3 .AND. KIN.EQ.1) CALL UMFFD (IBUF2)
      CALL WRITE (NPTP,IBUF2,20,1)
      IF (ECHOS .EQ. 0) GO TO 16311
      CALL PAGE2 (-1)
      CCNT = CCNT + 1
      CALL XPRETY (IBUF2)
      WRITE (OUTTAP,210) CCNT,IBUF2
16311 IF (ECHOP .EQ. 0) GO TO 1630
      IF (ECHOS .NE. 0) GO TO 1632
      CALL XPRETY (IBUF2)
 1632 WRITE (LPCH,1553) IBUF2
      GO TO 1630
C
C     CLOSE KTAPE AND WRITE (ENDDATA)
C
 1640 CALL CLOSE (KTAPE,2)
      CALL EOF   (NPTP)
      CALL CLOSE (NPTP,1)
      IF (ECHOS .EQ. 0) GO TO 1650
      CALL PAGE2 (-1)
      WRITE (OUTTAP,200) IIEND
 1650 IF (IBUF1(1) .EQ. 0) GO TO 1690
      CALL PAGE2 (2)
      WRITE  (OUTTAP,1660)
 1660 FORMAT (1H0)
C
C     IDENTIFY DUPLICATE OR PARENTLESS CONTINUATION CARDS
C
      NCNT = 0
      DO 1670 J = II,ICONLG,4
      IF (.NOT.DEC) ITST = ANDF(MK(3),BUF(J))
      IF (     DEC) ITST = KHRFN1(BKMSK2,1,BUF(J),1)
      IF (ITST .EQ. DOLLAR) GO TO 1670
C
C     CHECK FOR DUPLICATE CONTINUATION CARDS
C
      IF (BUF(J) .EQ. IDUP) GO TO 1666
C
C     CHECK FOR PARENTLESS CONTINUATION CARDS
C
      DO 1664 JJ = II,ICONLG,4
      IF (J .EQ. JJ) GO TO 1664
      IF (BUF(J).EQ.BUF(JJ+2) .AND. BUF(J+1).EQ.BUF(JJ+3)) GO TO 1668
 1664 CONTINUE
 1666 NCNT = NCNT + 1
      JN   = (J-II)/4 + 1
      CALL XRECPS (JN,JO)
      CALL READ (*1720,*1710,ITAPE4,IBUF2,20,1,IFLG)
      IF (MACH .EQ. 2) CALL UMFTRN (IBUF2)
      IF (MACH.EQ.3 .AND. KIN.EQ.1) CALL UMFFD (IBUF2)
      CALL PAGE2 (-1)
      WRITE (OUTTAP,200) IBUF2
      GO TO 1670
 1668 BUF(J) = IOK
 1670 CONTINUE
      IF (NCNT .EQ. 0) GO TO 1690
      CALL PAGE2 (3)
      WRITE  (OUTTAP,1680) UFM,NCNT
 1680 FORMAT (A23,' 209, PREVIOUS',I7,' CONTINUATION MNEMONICS HAVE NO',
     1       ' PARENTS AND/OR ARE DUPLICATES.',/)
      NOGO = -1
C
C     IDENTIFY THOSE CONTINUATION CARDS THAT ARE VALID, BUT YET CANNOT
C     BE PROCESSED BECAUSE OF ERRORS ON OTHER RELATED CONTINUATION CARDS
C
      NCNT = 0
      DO 1684 J = II,ICONLG,4
      IF (BUF(J) .NE. IOK) GO TO 1684
      NCNT = NCNT + 1
      JN   = (J-II)/4 + 1
      CALL XRECPS (JN,JO)
      CALL READ (*1720,*1710,ITAPE4,IBUF2,20,1,IFLG)
      IF (MACH .EQ. 2) CALL UMFTRN (IBUF2)
      IF (MACH.EQ.3 .AND. KIN.EQ.1) CALL UMFFD (IBUF2)
      CALL PAGE2 (-1)
      WRITE (OUTTAP,200) IBUF2
 1684 CONTINUE
      IF (NCNT .EQ. 0) GO TO 1690
      CALL PAGE2 (4)
      WRITE  (OUTTAP,1686) UFM,NCNT
 1686 FORMAT (A23,' 206, PREVIOUS',I7,' CONTINUATION CARDS, THOUGH ',
     1       'VALID, CANNOT BE PROCESSED', /5X,
     2       'BECAUSE OF ERRORS ON OTHER RELATED CONTINUATION CARDS.',/)
 1690 CALL CLOSE (ITAPE4,1)
C
C     REACTIVE DIAG 47 TO PRINT THE CONTENTS OF NTPT
C
      L47 = 0
      IF (L47 .EQ. 0) GO TO 1699
      CALL OPEN (*1750,NPTP,BUF(1),0)
 1691 CALL SKPFIL (NPTP,+1)
      CALL READ (*1697,*1697,NPTP,IBUF1(1),2,1,J)
      IF (IBUF1(1).NE.IBLKDA(1) .OR. IBUF1(2).NE.IBLKDA(2)) GO TO 1691
 1693 CALL READ (*1697,*1697,NPTP,IBUF1(1),20,1,J)
      WRITE  (OUTTAP,1695) (IBUF1(J),J=1,10),(IBUF1(J),J=17,20)
 1695 FORMAT (' ==NPTP==>',5(1X,2A4),'...',2(1X,2A4))
      GO TO 1693
 1697 CALL CLOSE (NPTP,1)
 1699 CONTINUE
C
C     DISABLE FREE-FIELD INPUT OPTION IN XREAD.
C
      FFFLAG = 0
      RETURN
C
C     ERROR MESSAGES
C
 1700 WRITE  (OUTTAP,1701) SFM
 1701 FORMAT (A25,' 210, SCRATCH COULD NOT BE OPENED')
      GO TO  1800
 1710 WRITE  (OUTTAP,1711) SFM
 1711 FORMAT (A25,' 211, ILLEGAL EOR ON SCRATCH')
      GO TO  1800
 1720 WRITE  (OUTTAP,1721) SFM
 1721 FORMAT (A25,' 212, ILLEGAL EOF ON ITAPE4')
      GO TO  1800
 1730 WRITE  (OUTTAP,1731) SFM
 1731 FORMAT (A25,' 213, ILLEGAL EOF ON OPTP')
      GO TO  1800
 1740 WRITE  (OUTTAP,1741) SFM
 1741 FORMAT (A25,' 214, OPTP COULD NOT BE OPENED')
      GO TO  1800
 1750 WRITE  (OUTTAP,1751) SFM
 1751 FORMAT (A25,' 215, NPTP COULD NOT BE OPENED')
      GO TO  1800
 1760 WRITE  (OUTTAP,1761) SFM
 1761 FORMAT (A25,' 216, ILLEGAL INDEX')
      GO TO  1800
 1770 WRITE  (OUTTAP,1771) SFM
 1771 FORMAT (A25,' 219, MISSING ENDDATA CARD.')
 1800 CALL PAGE2 (2)
      CALL MESAGE (-37,0,NSORT)
      RETURN
      END

      SUBROUTINE TA1CA(KOZ)
C*****
C THIS ROUTINE, CALLED BY SUBROUTINE TA1C, COMPUTES THE S MATRIX OF A
C GENERAL ELEMENT FROM INFORMATION IN THE CSTM AND BGPDT DATA BLOCKS.
C SEE FMMS-57 FOR EQUATIONS.
C*****
      DOUBLE PRECISION
     1                   V(3)               ,T(9)
     2,                  E(18)              ,D(42)
     3,                  S(6)               ,DET
     4,                  B(6)               ,INDEX(18)
     5,                  DD(30)             ,DL(25)
     6,                  DU(25)
C
C
C
      INTEGER
     1                   CSTM               ,BGPDT
     2,                  GEI                ,FILE
     3,                  CLSRW              ,EOR
     4,                  BUFR1              ,BUFR2
     5,                  BUFR3
C
C
C
      DIMENSION
     1                   NAME(2)            ,SSP(6)
     2,                  Z(1)
     3,                  LROW(5)            ,ICOL(6)
C
C
C
      COMMON   /TA1COM/
     1                   DUM3(3)            ,BGPDT
     2,                  DUM2(2)            ,CSTM
     3,                  DUM22(2)           ,GEI
C
C OPEN CORE
C
      COMMON   /ZZZZZZ/
     1                   IZ(1)
C
C
C
      COMMON   /NAMES /
     1                   DUMMY1             ,INRW
     2,                  DUMMY2             ,OUTRW
     3,                  CLSRW
C
C
C
      COMMON   /TAC1AX/
     1                   BUFR1              ,BUFR2
     2,                  BUFR3              ,IUI
     3,                  NUI                ,IUD
     4,                  NUD                ,IZZZ
     5,                  NOGO               ,IDGENL
C
C
C
      EQUIVALENCE
     1                   (Z(1),IZ(1))
C
C
C
      DATA     EOR,NEOR /1,0/
      DATA     NAME(1)/4HTA1C/ , NAME(2)/4HA   /
C
C INITIALIZE
C
      NCSTM = 0
      ICSTM = IZZZ
      LEFT  = BUFR3 - ICSTM
C
C ATTEMPT TO OPEN THE CSTM
C
      FILE = CSTM
      CALL OPEN(*20,CSTM,Z(BUFR3),INRW)
      CALL FWDREC(*9020,CSTM)
      CALL READ(*9020,*10,CSTM,Z(ICSTM+1),LEFT,EOR,NCSTM)
      CALL MESAGE (-8,0,NAME(1))
   10 CALL CLOSE (CSTM,CLSRW)
C
C PRETRD SETS UP SUBSEQUENT CALLS TO TRANSD
C
      CALL PRETRD (Z(ICSTM+1),NCSTM)
      LEFT = LEFT - NCSTM
C
C READ THE BGPDT INTO CORE
C
   20 IBGPDT = ICSTM + NCSTM
      FILE = BGPDT
      CALL OPEN(*9010,BGPDT,Z(BUFR3),INRW)
      CALL FWDREC(*9020,BGPDT)
      CALL READ(*9020,*30,BGPDT,Z(IBGPDT+1),LEFT,EOR,NBGPDT)
      CALL MESAGE (-8,0,NAME(1))
   30 CALL CLOSE (BGPDT,CLSRW)
C
C ZERO OUT THE E MATRIX
C
      DO 40 I = 1,18
   40 E(I) = 0.0D0
      E(1)  = 1.0D0
      E(8)  = 1.0D0
      E(15) = 1.0D0
      IND = 0
   50 IND = IND + 1
C*****
C IF IND = 1, THE D MATRIX IS FORMED IN THE DO 200 LOOP.
C IF IND = 2, THE S MATRIX IS FORMED AND OUTPUT A ROW AT A TIME IN THE
C DO LOOP.
C*****
      IF (IND - 2) 60,70,300
   60 CONTINUE
C
C     IF STIFFNESS IS INPUT,CALCULATE LIM
C
      IF (KOZ.EQ.1) GO TO 65
      LIM = 6
      LIMA = 6
      IBEG = IUD
      GO TO 80
   65 LIM = (NUD - IUD) / 4 + 1
      LIMA = LIM
      IBEG = IUD
      GO TO 80
   70 LIM = (NUI - IUI) / 4  +  1
      IBEG = IUI
      IROW = 37
   80 J = IBEG - 2
      I = 1
   85 CONTINUE
      IF (IND .EQ. 1) IROW = 6*I - 5
      J = J + 4
      JJ = IZ(J+1)
      K = IBGPDT + 4*(IZ(J) - 1)
C
C COMPUTE THE V VECTOR
C
      V(1) = 0.0D0
      V(2) = 0.0D0
      V(3) = 0.0D0
      KK = JJ
      IF (JJ .GT. 3) KK = JJ - 3
      IF (IZ(K+1) .EQ. 0) GO TO 120
      CALL TRANSD (IZ(K+1),T)
      GO TO (90,100,110), KK
   90 V(1) = T(1)
      V(2) = T(4)
      V(3) = T(7)
      GO TO 130
  100 V(1) = T(2)
      V(2) = T(5)
      V(3) = T(8)
      GO TO 130
  110 V(1) = T(3)
      V(2) = T(6)
      V(3) = T(9)
      GO TO 130
  120 V(KK) = 1.0D0
C
C FORM THE E MATRIX IF THE DEGREE OF FREEDOM IS A TRANSLATION.
C
  130 IF (JJ .GT. 3) GO TO 150
      E( 5) =  Z(K+4)
      E( 6) = -Z(K+3)
      E(10) = -Z(K+4)
      E(12) =  Z(K+2)
      E(16) =  Z(K+3)
      E(17) = -Z(K+2)
      IF (IZ(K+1) .EQ. 0) GO TO 140
      CALL GMMATD (V,3,1,1, E,3,6,0, D(IROW) )
      GO TO 180
  140 IEROW = 6*JJ - 5
      D(IROW  ) = E(IEROW  )
      D(IROW+1) = E(IEROW+1)
      D(IROW+2) = E(IEROW+2)
      D(IROW+3) = E(IEROW+3)
      D(IROW+4) = E(IEROW+4)
      D(IROW+5) = E(IEROW+5)
      GO TO 180
C
C THE DEGREE OF FREEDOM IS A ROTATION.
C
  150 LL = IROW
      DO 160 L = 1,6
      D(LL) = 0.0D0
  160 LL = LL + 1
      IF (IZ(K+1) .EQ. 0) GO TO 170
      D(IROW+3) = V(1)
      D(IROW+4) = V(2)
      D(IROW+5) = V(3)
      GO TO 180
  170 LL = IROW + JJ - 1
      D(LL) = 1.0D0
C
C IF IND = 2 FORM A ROW OF THE S MATRIX AND WRITE IT OUT.
C
  180 IF (IND .EQ. 1) GO TO 200
C
C     IF STIFFNESS MATRIX INPUT AND LESS THAN 6 RIGID BODY DEGREES OF
C     FREEDOM, BRANCH
C
      IF (KOZ.EQ.1.AND.LIMA.LT.6) GO TO 410
      CALL GMMATD (D(37),6,1,1, D(1),6,6,0, S(1) )
      DO 190 L = 1,6
  190 SSP(L) = S(L)
      CALL WRITE (GEI,SSP,6,NEOR)
  195 CONTINUE
  200 CONTINUE
      I = I + 1
      IF (I.LE.LIM) GO TO 85
      IF (IND .NE. 1) GO TO 300
C
C     IF STIFFNESS MATRIX WAS INPUT AND LESS THAN 6 RIGID BODY DEGREES
C     OF FREEDOM, BRANCH
C
      IF (KOZ.EQ.1.AND.LIM.LT.6) GO TO 310
C     NO NEED TO COMPUTE DETERMINANT SINCE IT IS NOT USED SUBSEQUENTLY.
      ISING = -1
      CALL INVERD (6,D(1),6,B(1),0,DET,ISING,INDEX(1))
      IF (ISING .EQ. 1) GO TO 50
      NOGO = 1
      CALL MESAGE (30,82,IDGENL)
      GO TO 300
  310 CONTINUE
C
C     SWITCH FROM ROW STORED TO COLUMN STORED
C
      DO 320 I=1,LIM
      DO 320 J=1,6
      INDXZ = I+(J-1)*LIM
  320 DD(INDXZ) = D(6*I+J-6)
C
C     DETERMINE RANK OF DD AND EXPRESS MATRIX OF MAXIMAL RANK AS A
C     PRODUCT OF TRIANGULAR FACTORS
C
      CALL DMFGR(DD,LIM,6,1.05E-05,IRANK,LROW,ICOL)
      IF (IRANK.EQ.LIM) GO TO 325
      NOGO = 1
      CALL MESAGE (30,152,IDGENL)
      GO TO 300
C
C     EXTRACT LOWER AND UPPER TRIANGULAR FACTORS, FORM PRODUCT,RESTORE
C     ROWS TO THEIR POSITION BEFORE FACTORIZATION AND INVERT. THEN
C     EXPAND MATRIX TO BE OF DIMENSION  6 BY IRANK
C
  325 IF (IRANK.EQ.1) GO TO 365
      DO 335 I=1,25
      DL(I) = 0.0D0
  335 DU(I) = 0.0D0
      DO 350 I=1,IRANK
      DO 350 J=1,IRANK
      IF (I.GT.J) GO TO 340
      IF (I.EQ.J) GO TO 330
      INDXZ = I+(J-1)*IRANK
      DL(INDXZ) = DD(I*IRANK+J-IRANK)
      GO TO 350
  330 INDXZ = I+(J-1)*IRANK
      DL(INDXZ) = 1.0D0
  340 INDXZ = I+(J-1)*IRANK
      DU(INDXZ) = DD(I*IRANK+J-IRANK)
  350 CONTINUE
      CALL GMMATD (DL(1),LIM,LIM,0,DU(1),LIM,LIM,0,DD)
      DO 360 I=1,LIM
      K = LROW(I)
      DO 360 J=1,LIM
      INDXZ = J+(K-1)*LIM
  360 D(INDXZ) = DD(I*LIM+J-LIM)
C     AGAIN NO NEED TO COMPUTE DETERMINANT
      ISING = -1
      CALL INVERD (LIM,D(1),LIM,B(1),0,DET,ISING,INDEX(1))
      IF (ISING.EQ.1) GO TO 370
      NOGO = 1
      CALL MESAGE (30,153,IDGENL)
      GO TO 300
  365 D(1) = 1.0D0/DD(1)
  370 K = LIM * LIM + 1
      J = LIM * 6
      DO 380  I = K,J
  380 D(I) = 0.0D0
      GO TO 50
  410 CONTINUE
C
C     REARRANGE COLUMNS TO AGREE WITH ORDER OF DD AFTER MATRIX FACTOR-
C     IZATION
C
      DO 420 L = 1,6
      LK = ICOL(L)
  420 B(L) = D(36+LK)
C
C     MULTIPLY DI BY THE EXPANDED INVERSE OF DD
C
      CALL GMMATD (B(1),1,6,0,D(1),6,LIMA,0,S(1))
C
C     WRITE OUT THIS ROW OF THE S MATRIX
C
      DO 430 L =1,LIMA
  430 SSP(L) = S(L)
      CALL WRITE (GEI,SSP,LIMA,NEOR)
      GO TO 195
  300 RETURN
C
C     ERROR MESSAGES
C
 9010 CALL MESAGE (-1,FILE,NAME(1))
 9020 CALL MESAGE (-1,FILE,NAME(1))
      RETURN
      END

      SUBROUTINE TRHT1C (NGROUP,UDVT,PD,RDD,ILOOP)
C
C     THIS ROUTINE  STEPS INTEGRATION PROCEDURE
C
      INTEGER          SYSBUF,   UDVT,     PD,       RDD,      IZ(1),
     1                 A,        FILE,     MCB(7),   PNL1,     RADLIN,
     2                 NAME(2),  IFN(7),   ITAB(4),  LL1(7)
      DOUBLE PRECISION DZ(1)
      CHARACTER        UFM*23,   UWM*25
      COMMON /XMSSG /  UFM,      UWM
      COMMON /BLANK /  BETA,     TABS,     NORAD,    RADLIN,   SIGMA
      COMMON /SYSTEM/  KSYSTM(63)
      COMMON /TRDXX /  KTRDXX(28)
      COMMON /ZZZZZZ/  Z(1)
      COMMON /PACKX /  IT1,      IT2,      II,       JJ,       INCR
      COMMON /TRHTX /  IK(7),    IB(7),    ICR1,     ICR2,     ICR3,
     1                 ICR4,     ICR5,     ISYM,     A,        ICR7
      COMMON /TRDD1 /  NLFT1,    DIT1,     NLFTP1,   NOUT,     ICOUNT,
     1                 ILOOP1,   MODA1,    NZ,       ICORE,    IU1,
     2                 IN2,      IPNL(7),  NMODES,   NSTEP,    PNL1,
     3                 IST,      IU1DUM,   DELTAT,   IFRST,    TABS1,
     4                 SIGMA1,   TIM1
      COMMON /UNPAKX/  IT3,      III,      JJJ,      INCR1
      COMMON /INFBSX/  ILL1(7),  IUL1(7)
      COMMON /FBSX  /  LL1
      EQUIVALENCE      (KSYSTM(1),SYSBUF), (KSYSTM(55),IPREC),
     1                 (KTRDXX(28),IOPEN), (Z(1),IZ(1),DZ(1)),
     2                 (ILL1(3),MROW),     (KSYSTM(2),NPRT)
      DATA    NAME  /  4HTRHT,  4H1C     /
C
C     SYMBOL TABLE
C
C     ICR1 IS LLL
C     ICR2 IS ULL
C     ICR5 IS INITIAL CONDITIONS
C     ICR6 IS THE  A  MATRIX
C
C     NROW     PROBLEM ORDER
C     NGROUP   NUMBER OF TRIPLES OF TIME STEPS
C     UDVT     DISPLACEMENTS AND VELOCITIES
C     PD       LOADS
C     RDD      RADIATION MATRIX
C     ILOOP    CURRENT TIME STEP GROUP
C     IBUF1    UDVT BUFFER
C     IBUF2    A    BUFFER
C     IBUF3    LLL  BUFFER
C     IBUF4    ULL  BUFFER
C     IBUF5    PD   BUFFER
C     IBUF6    PNL1 BUFFER
C     IBUF7    RDD  BUFFER
C     IBUF8    SCRATCH BUFFER(DIT,NLLOADS,SAVE STUFF ETC)
C     NZ       OPEN CORE
C     IST      OUTPUT FLAG
C     IU1,IU2  DISPLACMENT VECTOR POINTERS
C     IP1,IP2  LOAD VECTOR POINTERS
C     IN1,IN2  NON-LINEAR LOAD POINTERS
C     NOLIN    =0  MEAN NO NON-LINEAR LOADS
C     IPNT     POINTER FOR INTERNAL ZERO ROUTINE
C     FILE     FILE    FOR INTERNAL ZERO ROUTINE
C     NSTEP    NUMBER OF TIME STEPS
C     DELTAT   DELTA  T
C     NOUT     OUTPUT INCREMENT
C     H        1/ 2*DELTAT
C     ICOUNT   STEP COUNTER
C     ITLEFT   TIME LEFT
C     NORAD    =-1  NO RADIATION
C     RADLIN   =-1  NON LINEAR RADIATION
C     NLFTP1   NONLINEAR SET SELECTED BY THE USER
C     BETA,OMBETA,OPBETA  --USER BETA 1-BETA, 1+BETA
C     ISYM     0    UNSYMETRIC   1  SYMMETRIC
C     DELTA1   OLD DELTA  T
C
      ISCR5  = ICR5
      NOLOAD = 0
      NBUST  = 0
      MCB(1) = PD
      CALL RDTRL (MCB)
      IF (MCB(1) .LE. 0) NOLOAD = -1
      NROW   = IK(2)
      IT1    = 1
      IT2    = 1
      II     = 1
      JJ     = NROW
      INCR   = 1
      IT3    = 1
      III    = 1
      JJJ    = NROW
      INCR1  = 1
      TABS1  = TABS
      SIGMA1 = SIGMA
      NZ     = KORSZ(Z)
      IGROUP = NZ - 3*NGROUP + 1
      IBUF1  = IGROUP- SYSBUF
      IBUF2  = IBUF1 - SYSBUF
      IBUF3  = IBUF2 - SYSBUF
      IBUF4  = IBUF3 - SYSBUF
      IBUF5  = IBUF4 - SYSBUF
      IBUF6  = IBUF5 - SYSBUF
      IBUF7  = IBUF6 - SYSBUF
      IBUF8  = IBUF7 - SYSBUF
      NZ     = IBUF8 - 1
      ILOOP1 = ILOOP
      IST    = 0
      ILL1(1)= ICR1
      CALL RDTRL (ILL1)
      IFN(1) = ICR1
      CALL RDTRL (IFN)
      IU1    = 0
      IU2    = IU1 + NROW
      IP1    = IU2 + NROW
      IP2    = IP1 + NROW
      IUK    = IP2 + NROW
      NOLIN  = 0
      IF (NLFTP1.NE.0 .OR. NORAD.NE.-1) NOLIN = 1
      IF (NOLIN .EQ. 0) GO TO 10
      IN1    = IUK + NROW
      IN2    = IN1 + NROW
      NZ     = NZ - 7*NROW
      GO TO 20
C
C     NO NON-LINEAR EFFECTS
C
   10 NZ     = NZ - 4*NROW
      IN2    = IP2
   20 IF (NZ .LT. 0) CALL MESAGE (-8,0,NAME)
      ICORE  = IN2 + NROW
      IUL1(1)= ICR2
      CALL RDTRL (IUL1)
      OMBETA = 1.0 - BETA
      OPBETA = 1.0 + BETA
C
C     SET UP FOR CORE I/O
C
      IF (NLFTP1 .EQ. 0) GO TO 21
      IFRST  = 0
      CALL TRD1D
      IFRST  = 1
   21 ITAB(1) = A
      ITAB(2) = ILL1(1)
      ITAB(3) = IUL1(1)
      ITAB(4) = RDD
      ICOR = IN2 + NROW + 1
      NF   = 4
      CALL GOPEN (A,IZ(IBUF2),0)
      CALL REWIND (A)
      IF (NOLIN.EQ.0 .OR. RADLIN.NE.-1 .OR. NORAD.EQ.-1) GO TO 30
      CALL GOPEN (RDD,IZ(IBUF7),0)
      CALL REWIND (RDD)
   30 CONTINUE
      CALL GOPEN (ILL1,IZ(IBUF3),0)
      CALL REWIND (ILL1)
      IF (ISYM .EQ. 1) GO TO 31
      CALL GOPEN (IUL1,IZ(IBUF4),0)
      CALL REWIND (IUL1)
   31 CONTINUE
C
C     IS  THIS  A TIME  STEP CHANGE
C
      IF (ILOOP  .NE. 1) GO TO  280
      IF (NOLOAD .NE. 0) GO TO 33
      CALL GOPEN (PD,IZ(IBUF5),0)
      CALL FWDREC (*440,PD)
   33 CONTINUE
      IST = -1
      CALL GOPEN (ICR5,IZ(IBUF1),0)
C
      CALL FREAD(ICR5,IZ(IGROUP),3*NGROUP,1)
C
C     BRING IN  U0 AND UK
C
      CALL READ (*450,*35,ICR5,Z(IU1+1),NROW,1,NWDS)
      GO TO 40
C
C     SHORT VECTOR ENCOUNTERED
C
   35 K = NWDS + 1
      DO 38 L = K,NROW
      M = IU1 + L
      Z(M) = 0.0
   38 CONTINUE
   40 CONTINUE
      IF (NORAD .EQ. -1) GO TO 50
      CALL READ (*450,*45,ICR5,Z(IUK+1),NROW,1,NWDS)
      GO TO 410
C
C     SHORT VECTOR ENCOUNTERED
C
   45 K = NWDS + 1
      DO 48 L = K,NROW
      M = IUK + L
      Z(M) = 0.0
   48 CONTINUE
      GO TO 410
   50 CONTINUE
      CALL CLOSE (ICR5,1)
      NSTEP  = IZ(IGROUP) + 1
      DELTAT =  Z(IGROUP+1)
      NOUT   = IZ(IGROUP+2)
      H = 1.0/DELTAT
      CALL GOPEN (UDVT,IZ(IBUF1),1)
      CALL MAKMCB (MCB,UDVT,NROW,2,1)
      IF (NOLIN .EQ. 0) GO TO 60
      CALL GOPEN (PNL1,IZ(IBUF6),1)
      CALL MAKMCB (IPNL,PNL1,NROW,2,1)
C
C     LETS  GO
C
   60 ICOUNT = 1
C
C     TOP OF LOOP
C
   70 CALL TMTOGO (ITLEFT)
      IF (ITLEFT .LE. 0) GO TO 230
C
C     COMPUTE  NR
C
      IF (NORAD  .EQ. -1) GO TO 110
      IF (RADLIN .EQ. -1) GO TO 90
      DO 80 I = 1,NROW
      L = IN2 + I
      K = IUK + I
      Z(L) = Z(K)
   80 CONTINUE
      GO TO 130
C
C     NON-CONSTANT RADIATION
C
   90 DO 100 I = 1,NROW
      L = IU1 + I
      K = IUK + I
      M = IN2 + I
      J = IU2 + I
C
C     CHECK FOR UNSTABLE SOLUTION ABOUT TO CAUSE ARITHMETIC OVERFLOWS.
C
      IF (Z(L) .LT. 1.0E8) GO TO 98
      NBUST = NBUST + 1
      IF (NBUST .GT. 10) GO TO 94
      WRITE  (NPRT,92) UWM,Z(L),ICOUNT,I
   92 FORMAT (A25,' 3102, SUBROUTINE TRHT1C, UNSTABLE TEMP. VALUE OF',
     1       E20.8,' COMPUTED FOR TIME STEP',I5, /5X,
     2       'AT POINT NUMBER',I6,' IN THE ANALYSIS SET.')
      Z(L) = 1.0E6
      GO TO 98
   94 WRITE  (NPRT,96) UFM
   96 FORMAT (A23,' 3103, SUBROUTINE TRHT1C TERMINATING DUE TO ERROR ',
     1       'COUNT FOR MESSAGE 3102.')
      CALL MESAGE (-61,0,NAME)
C
   98 Z(J) = -(Z(L)+TABS)**4 + 4.0*(Z(K)+TABS)**3*Z(L)
      Z(M) = 0.0
  100 CONTINUE
      IOPEN  = 1
      IFN(1) = RDD
      CALL MATVEC (Z(IU2+1),Z(IN2+1),IFN,IZ(IBUF7))
      GO TO 130
  110 IF (NLFTP1 .EQ. 0) GO TO 140
      DO 120 I = 1,NROW
      M = IN2 + I
      Z(M) = 0.0
  120 CONTINUE
  130 IF (NLFTP1 .EQ. 0) GO TO 140
      TIM1 = TIM
      CALL TRD1D
  140 IF (ICOUNT .NE. 1 .OR. ILOOP .NE. 1) GO TO 160
      DO 150 I = 1,NROW
      K = IP1 + I
      Z(K) = 0.0
      IF (NOLIN .EQ. 0) GO TO 150
      L = IN2 + I
      M = IN1 + I
      Z(M) =  Z(L)
      Z(K) = -Z(L)
  150 CONTINUE
      IOPEN = 0
      CALL MATVEC (Z(IU1+1),Z(IP1+1),IK,Z(IBUF8))
C
C     BRING IN  NEXT P
C
  160 IF (NOLOAD .NE. 0) GO TO 165
      CALL UNPACK (*165,PD,Z(IP2+1))
      GO TO 170
  165 DO 167 I = 1,NROW
      K = IP2 + I
      Z(K) = 0.0
  167 CONTINUE
C
C     ADD ALL LOAD CONTRIBUTIONS
C
  170 CONTINUE
      DO 180 I = 1,NROW
      L = IP1 + I
      M = IP2 + I
      Z(L) = OMBETA*Z(L) + BETA*Z(M)
      IF (NOLIN .EQ. 0) GO TO 180
      M = IN1 + I
      J = IN2 + I
      Z(L) = Z(L) + OPBETA*Z(J) - BETA*Z(M)
  180 CONTINUE
C
C     MULTIPLY  IN  A MATRIX
C
      IOPEN  = 1
      IFN(1) = A
      CALL MATVEC (Z(IU1+1),Z(IP1+1),IFN,IZ(IBUF2))
C
C     SOLVE  FOR NEXT DISPLACEMENT
C
      IOPEN = 1
      IF (ISYM .EQ. 0) CALL INTFBS (Z(IP1+1),Z(IU2+1),IZ(IBUF4))
      IF (ISYM .NE. 1) GO TO 188
C
C     ABSORBED SUBROUTINE FBSINT   SEE ALSO EQUIV.   DATA.
C
      DO 182 I = 1,MROW
      Z(I+IU2) = Z(I+IP1)
  182 CONTINUE
C
C     FORWARD PASS
C
      CALL REWIND (ILL1)
      CALL FWDREC (*186,ILL1)
      IZ(IBUF4) = ILL1(1)
      LL1(1) = ILL1(1)
      CALL RDTRL (LL1)
      IF (IPREC .NE. 1) GO TO 184
      CALL FBS1 (IZ(IBUF4),Z(IU2+1),Z(IU2+1),MROW)
      GO TO 188
  184 CALL FBS21(IZ(IBUF4),Z(IU2+1),Z(IU2+1),MROW)
      GO TO 188
  186 CALL MESAGE (-2,ILL1,NAME)
C
C     ABSORBED SUBROUTINE FBSINT    SEE ALSO EQUIV.   DATA.
C
  188 CONTINUE
      IF (ICOUNT.EQ.1 .OR. ICOUNT.EQ.NSTEP .OR.
     1    MOD(ICOUNT+IST,NOUT).EQ.0) GO TO 200
C
C     ROTATE POINTERS
C
  190 J   = IP1
      IP1 = IP2
      IP2 = J
      J   = IU1
      IU1 = IU2
      IU2 = J
      J   = IN1
      IN1 = IN2
      IN2 = J
      TIM = TIM + DELTAT
      ICOUNT = ICOUNT + 1
      IF (ICOUNT-NSTEP) 70,220,230
C
C     IT  IS OUTPUT TIME
C
  200 CALL PACK (Z(IU1+1),UDVT,MCB)
C
C     COMPUTE  U DOT
C
      DO 210 I = 1,NROW
      L = IP1 + I
      M = IU1 + I
      J = IU2 + I
      Z(L) = (Z(J)-Z(M))*H
  210 CONTINUE
      CALL PACK (Z(IP1+1),UDVT,MCB)
C
C     PUT OUT ZERO ACCERERATION VECTOR FOR LATER MODULES
C
      CALL BLDPK (1,1,UDVT,0,0)
      CALL BLDPKN (UDVT,0,MCB)
      IF (NOLIN .EQ. 0) GO TO 190
      CALL PACK (Z(IN2+1),PNL1,IPNL)
      GO TO 190
C
C     END OF 1 GROUP
C
  220 IF (ILOOP .NE. NGROUP) GO TO 260
      GO TO 70
  230 J = 1
  240 CALL CLOSE (UDVT,J)
      CALL CLOSE (PD,J)
      CALL CLOSE (ILL1,1)
      CALL CLOSE (IUL1,1)
      CALL CLOSE (A,1)
      CALL WRTTRL (MCB)
      IF (NORAD .EQ. -1) GO TO 245
      CALL CLOSE (RDD,1)
  245 IF (NOLIN .EQ. 0) GO TO 250
      CALL CLOSE (PNL1,J)
      CALL WRTTRL (IPNL)
  250 CONTINUE
      RETURN
C
C     MORE GROUPS TO COME  SAVE STUFF
C
  260 J = 2
      CALL GOPEN (ISCR5,IZ(IBUF8),1)
      CALL WRITE (ISCR5,IZ(IGROUP),3*NGROUP,1)
      IF (NOLIN .NE. 0) CALL WRITE (ISCR5,IZ(IUK+1),NROW,1)
C
C     SAVE   UI -1
C
      CALL WRITE (ISCR5,Z(IU2+1),NROW,1)
C
C     SAVE   UI
C
      CALL WRITE (ISCR5,Z(IU1+1),NROW,1)
      IF (NOLIN .EQ. 0) GO TO 270
C
C     SAVE    NI - 1
C
      CALL WRITE (ISCR5,Z(IN2+1),NROW,1)
C
C     SAVE    NI
C
      CALL WRITE (ISCR5,Z(IN1+1),NROW,1)
  270 CONTINUE
      CALL CLOSE (ISCR5,1)
      GO TO 240
C
C     REENTRY FROM CHANGE OF TIME STEP
C
  280 CONTINUE
      CALL GOPEN (ISCR5,IZ(IBUF8),0)
      CALL FREAD (ISCR5,IZ(IGROUP),3*NGROUP,1)
      NEWGRP = IGROUP + (ILOOP-1)*3
      DELTA1 =  Z(NEWGRP-2)
      NSTEP  = IZ(NEWGRP)
      DELTAT = Z(NEWGRP+1)
      NOUT   = IZ(NEWGRP+2)
      CALL GOPEN (PD,IZ(IBUF5),2)
      H = 1.0/DELTAT
      CALL GOPEN (UDVT,IZ(IBUF1),3)
      MCB(1) = UDVT
      CALL RDTRL (MCB(1))
      IF (NOLIN .EQ. 0) GO TO 290
      CALL GOPEN (PNL1,IZ(IBUF6),3)
      IPNL(1) = PNL1
      CALL RDTRL (IPNL)
  290 CONTINUE
C
C     RESTORE  STUFF  SAVED
C
      IF (NOLIN .NE. 0) CALL FREAD (ISCR5,Z(IUK+1),NROW,1)
      CALL FREAD (ISCR5,Z(IU2+1),NROW,1)
      CALL FREAD (ISCR5,Z(IU1+1),NROW,1)
      IF (NOLIN .EQ. 0) GO TO 300
      CALL FREAD (ISCR5,Z(IN1+1),NROW,1)
      CALL FREAD (ISCR5,Z(IN2+1),NROW,1)
  300 CONTINUE
      CALL CLOSE (ISCR5,1)
C
C     COMPUTE  PBAR
C
      DO 310 I = 1,NROW
      L = IP1 + I
      Z(L) = 0.0
      IF (NOLIN .EQ. 0) GO TO 310
      M    = IN2 + I
      Z(L) =-Z(M)
  310 CONTINUE
      IOPEN = 0
      CALL MATVEC (Z(IU1+1),Z(IP1+1),IK,IZ(IBUF8))
      IF (IB(1) .EQ. 0) GO TO 330
      DO 320  I = 1,NROW
      L = IU2 + I
      M = IU1 + I
      Z(L) = (Z(M)-Z(L))/DELTA1
  320 CONTINUE
      IOPEN = 0
      CALL MATVEC (Z(IU2+1),Z(IP1+1),IB,IZ(IBUF8))
  330 CONTINUE
      IF (NOLIN .EQ. 0) GO TO 350
      H1 = 1.0 - DELTAT/DELTA1
      H2 = DELTAT/DELTA1
      DO 340 I = 1,NROW
      L  = IN1 + I
      M  = IN2 + I
      Z(L) = H2*Z(L) + H1*Z(M)
  340 CONTINUE
  350 ICOUNT = 0
      GO TO 70
C
C     CONSTANT RADIATION
C
  410 IF(RADLIN .EQ. -1) GO TO 50
      DO 420 I = 1,NROW
      L = IUK + I
      K = IN2 +I
      Z(L) = -(Z(L)+TABS)**4 + 4.0*(Z(L)+TABS)**3*Z(L)
      Z(K) = 0.0
  420 CONTINUE
      IOPEN = 1
      IFN(1) = RDD
      CALL MATVEC (Z(IUK+1),Z(IN2+1),IFN, IZ(IBUF7))
      DO 430 I = 1,NROW
      L = IUK + I
      M = IN2 + I
      Z(L) = Z(M)
  430 CONTINUE
      GO TO 50
C
C     I/O ERROR
C
  440 FILE = PD
      GO TO 460
  450 FILE = ICR5
  460 CALL MESAGE (-2,FILE,NAME)
      RETURN
      END

      SUBROUTINE PLTTRA
C
C     PLTTRA MODIFIES THE SIL AND BGPDT TABLES FOR THE PURPOSE OF
C     PLOTTING SPECIAL SCALAR GRID POINTS
C
C     INPUT  SIL  BGPDT  LUSET
C     OUTPUT SIP  BGPDP  LUSEP
C
C     SPECIAL SCALAR GRID POINTS
C     BGPDT(I,1)= 1  SIL(I+1)-SIL(I)=1
C     BGPDP(I,1)=-2  SIP(I+1)-SIP(I)=6
C
C     LUSET IS THE VALUE OF SIL(LAST+1) IF IT EXISTED
C     LUSEP IS THE VALUE OF SIP(LAST+1) IF IT EXISTED
C
      LOGICAL         LEOF
      INTEGER         SYSBUF,BUF1,BUF2,BUF3,BUF4,FILE,SIL,BGPDT,SIP,
     1                BGPDP,NAME(2),Z,PLT(2),FLAG,A,B,S1,S2,DELTA
      DIMENSION       A(4),B(2),MCB(7)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /BLANK / LUSET,LUSEP
      COMMON /SYSTEM/ SYSBUF,NOT
      COMMON /NAMES / RD,RDREW,WRT,WRTREW,CLSREW,CLS
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE     (A(3),B(1)),(FILE,MCB(1))
      DATA    BGPDT , SIL,BGPDP,SIP/ 101,102,201,202 /
      DATA    PLT   / 4HPLTT,4HRA  /,   MCB / 7*0    /
      DATA    LEOF  / .FALSE./
C
      NADD = 0
      NS   = 0
C
C     LOCATE STORAGE AREA FOR FILE BUFFERS
C
      NZ   = KORSZ(Z)
      BUF1 = NZ   - SYSBUF + 1
      BUF2 = BUF1 - SYSBUF
      BUF3 = BUF2 - SYSBUF
      BUF4 = BUF3 - SYSBUF
      IF (BUF4 .LE. 0) CALL MESAGE (-8,NZ,PLT)
C
C     READ TRAILER RECORDS OF INPUT FILES AND CHECK COMPATABILITY
C     OPEN AND FOREWARD SPACE LABEL RECORD OF INPUT FILES
C     OPEN AND WRITE LABEL RECORD OF OUTPUT FILES
C
      FILE = BGPDT
      CALL RDTRL (MCB)
      CALL FNAME (FILE,NAME)
      IF (FILE .LE. 0) GO TO 900
      CALL OPEN (*900, BGPDT, Z(BUF2), RDREW)
      CALL FWDREC (*1010,BGPDT)
C
      FILE = SIL
      CALL RDTRL (MCB)
      CALL FNAME (FILE,NAME)
      IF (FILE .LE. 0) GO TO 900
      IF (MCB(3) .NE. LUSET) GO TO 1130
      CALL OPEN (*900,SIL,Z(BUF1),RDREW)
      CALL FWDREC (*1010,SIL)
C
      FILE = SIP
      CALL FNAME (SIP,A)
      CALL OPEN  (*1000,SIP,Z(BUF3),WRTREW)
      CALL WRITE (SIP,A,2,1)
C
      FILE = BGPDP
      CALL OPEN  (*1000,BGPDP,Z(BUF4),WRTREW)
      CALL FNAME (BGPDP,B)
      CALL WRITE (BGPDP,B,2,1)
C
C     READ SIL(I)
C
      FILE = SIL
      CALL READ (*1010,*1020,SIL,S1,1,0,FLAG)
C
C     READ SIL(I+1)
C
   10 FILE = SIL
      CALL READ (*1010,*30,SIL,S2,1,0,FLAG)
C
C     READ BGPDT(I,J)
C
   15 FILE = BGPDT
      CALL READ (*1010,*1020,BGPDT,A,4,0,FLAG)
      DELTA = 0
      NS = NS + 1
C
C     CHECK IF SPECIAL SCALAR GRID POINT
C
      IF (A(1).LT.0 .OR. S2-S1.EQ.6) GO TO 20
      IF (S2-S1 .NE. 1) GO TO 1110
C
C     SPECIAL SCALAR GRID POINT
C
      DELTA = 5
      A(1)  =-2
   20 S1 = S1 + NADD
C
C     WRITE SIP AND BGPDP TABLE ENTRIES
C
      CALL WRITE (SIP,S1,1,0)
      CALL WRITE (BGPDP,A,4,0)
      NADD = NADD + DELTA
      IF (LEOF) GO TO 40
      S1 = S2
      GO TO 10
C
C     SIL(I) IS SIL(LAST)
C
   30 LEOF = .TRUE.
      S2   = LUSET + 1
      GO TO 15
   40 LUSEP = LUSET + NADD
C
C     CLOSE OUTPUT FILES AND WRITE TRAILER RECORDS
C
      CALL CLOSE (SIL  ,CLSREW)
      CALL CLOSE (BGPDT,CLSREW)
      CALL CLOSE (SIP  ,CLSREW)
      CALL CLOSE (BGPDP,CLSREW)
      MCB(1) = BGPDP
      MCB(3) = 0
      CALL WRTTRL (MCB)
      MCB(1) = SIP
      MCB(3) = LUSEP
      CALL WRTTRL (MCB)
      RETURN
C
  900 LUSEP = LUSET
      RETURN
C
C     ERROR DIAGNOSTICS
C
 1000 NDX = -1
      GO TO 1100
 1010 NDX = -2
      GO TO 1100
 1020 NDX = -3
 1100 CALL MESAGE (NDX,FILE,PLT)
      GO TO 1150
 1130 WRITE  (NOT,2001) UFM,LUSET,MCB(3)
 2001 FORMAT (A23,' 5011, FIRST PARAMETER',I6,' NE TRAILER RECORD ',
     1       'PARAMETER',I6)
      GO TO 1150
 1110 WRITE  (NOT,2002) UFM,NS
 2002 FORMAT (A23,' 5012, ENTRY',I6,' OF SIL TABLE INCOMPATIBLE WITH ',
     1       'NEXT ENTRY')
 1150 CALL MESAGE (-61,0,0)
      RETURN
      END

      SUBROUTINE PROCOM (PROCOS,PROCOF,CASECC,NCOEFS,NGRIDS)
C
C     PROCOM COMBINES PROCOF CASES FOR SUBCOM-S AND REPCASES
C
      INTEGER         PROCOF,CASECC,BUF1,BUF2,BUF3,FILE,PROCOS,INFO(7),
     1                IZ(1),NAM(2)
      COMMON /SYSTEM/ IBUF
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE     (Z(1),IZ(1))
      DATA    I166  , I16  ,NAM   / 166, 16, 4HPROC,4HOM  /
C
      LCORE = KORSZ(Z)
      BUF1  = LCORE - IBUF + 1
      BUF2  = BUF1  - IBUF
      BUF3  = BUF2  - IBUF
      LCORE = BUF3  - 1
      IF (LCORE.LT.NCOEFS .OR. LCORE.LT.NGRIDS) GO TO 108
      CALL GOPEN (PROCOS,Z(BUF1),0)
      CALL GOPEN (PROCOF,Z(BUF2),1)
C
C     CHECK EACH SUBCASE FOR REPCASE OR SUBCOM-IF NONE(JUST COPY SET OF
C     5 RECORDS FROM PROCOS TO PROCOF
C
      FILE = CASECC
      CALL GOPEN (CASECC,Z(BUF3),0)
   10 FILE = CASECC
      CALL READ (*90,*20,CASECC,Z(1),LCORE,0,IWORDS)
      GO TO 108
   20 IF (IZ(I16) .NE. 0) GO TO 30
C
C     NOT A SUBCOM - MIGHT BE REPCASE
C
   25 FILE = PROCOS
      CALL FREAD (PROCOS,Z,103,1)
      CALL WRITE (PROCOF,Z,103,1)
      CALL FREAD (PROCOS,Z,NCOEFS,1)
      CALL WRITE (PROCOF,Z,NCOEFS,1)
      CALL FREAD (PROCOS,Z,NCOEFS,1)
      CALL WRITE (PROCOF,Z,NCOEFS,1)
      CALL FREAD (PROCOS,Z,NGRIDS,1)
      CALL WRITE (PROCOF,Z,NGRIDS,1)
      CALL FREAD (PROCOS,Z,NGRIDS,1)
      CALL WRITE (PROCOF,Z,NGRIDS,1)
C
C     GO BACK FOR ANOTHER CASE CONTROL RECORD
C
      GO TO 10
C
C     REPCASE OR SUBCOM
C
   30 IF (IZ(I16) .GT. 0) GO TO 45
C
C     REPCASE
C
      DO 40 I = 1,5
      CALL BCKREC (PROCOS)
   40 CONTINUE
      GO TO 25
C
C     SUBCOM
C
   45 LCC  = IZ(I166)
      LSYM = IZ(LCC)
      DO 50 I = 1,LSYM
      DO 50 J = 1,5
      CALL BCKREC (PROCOS)
   50 CONTINUE
      NTOT = 2*(NCOEFS+NGRIDS)
      IF (IWORDS+2*NTOT .GT. LCORE) GO TO 108
      INEW = IWORDS + NTOT
      DO 60 I = 1,NTOT
   60 Z(INEW+I) = 0.
      DO 80 I = 1,LSYM
      COEF = Z(LCC+I)
      IF (COEF .EQ. 0.) GO TO 75
      CALL FREAD (PROCOS,INFO,103,1)
      CALL FREAD (PROCOS,Z(IWORDS+1),NCOEFS,1)
      CALL FREAD (PROCOS,Z(IWORDS+NCOEFS+1),NCOEFS,1)
      CALL FREAD (PROCOS,Z(IWORDS+2*NCOEFS+1),NGRIDS,1)
      CALL FREAD (PROCOS,Z(IWORDS+2*NCOEFS+NGRIDS+1),NGRIDS,1)
      DO 70 J = 1,NTOT
      Z(INEW+J) = Z(INEW+J) + COEF*Z(IWORDS+J)
   70 CONTINUE
      GO TO 80
   75 DO 76 K = 1,5
      CALL FWDREC (*102,PROCOS)
   76 CONTINUE
C
   80 CONTINUE
C
C     WRITE TO PROCOF- 1ST BE SURE THAT ISYM IS 0 TO ACCOUNT FOR
C     POSSIBLE SYMMETRY-ANTISYMMETRY COMBINATION
C
      INFO(6) = 0
      CALL WRITE (PROCOF,INFO,103,1)
      CALL WRITE (PROCOF,Z(INEW+1),NCOEFS,1)
      CALL WRITE (PROCOF,Z(INEW+NCOEFS+1),NCOEFS,1)
      CALL WRITE (PROCOF,Z(INEW+2*NCOEFS+1),NGRIDS,1)
      CALL WRITE (PROCOF,Z(INEW+2*NCOEFS+NGRIDS+1),NGRIDS,1)
C
C     GO BACK FOR ANOTHER SUBCASE
C
      GO TO 10
C
C     DONE
C
   90 CALL CLOSE (CASECC,1)
      CALL CLOSE (PROCOS,1)
      CALL CLOSE (PROCOF,1)
      INFO(1) = PROCOS
      CALL RDTRL (INFO)
      INFO(1) = PROCOF
      CALL WRTTRL (INFO)
      RETURN
C
  102 CALL MESAGE (-2,0,NAM)
  108 CALL MESAGE (-8,0,NAM)
      RETURN
      END

      SUBROUTINE BUNPAK (IG,I,NJ,JG)
C
C     THIS ROUTINE WORKS SIMILARLY AS BUNPK EXCEPT IT UNPACKS A WHOLE
C     (I-TH) ROW OF GRID NUMBERS (1 THRU NJ) FROM IG TABLE, AND SAVES
C     THE UNPACKED DATA IN JG ARRAY.
C     (BUNPK UNPACKS ONLY AN ELEMENT OF GRID NUMBER IN IG TABLE)
C
C     THIS ROUTINE GREATLY INCREASES BANDIT INTERNAL EFFICIENCY
C     WRITTEN BY G.CHAN/UNISYS,    MAY 1988
C
      IMPLICIT INTEGER (A-Z)
C
CDC   NEXT 2 LINES FOR CDC AND UNIVAC ONLY
C     EXTERNAL         ANDF,     RSHIFT
C     INTEGER          ANDF,     RSHIFT  ,IG(1)
C
C     NEXT LINE FOR IBM, VAX, AND MACHINES THAT HAVE INTEGER*2
      INTEGER*2        IG(1)
C
      INTEGER          JG(1),    NAM(2)
      COMMON /SYSTEM/  IBUF,     NOUT
      COMMON /BANDB /  NBIT,     DUM3B(3), IPASS,    NW
      COMMON /BANDS /  DUM4S(4), II1,      MAXDEG,   DUM4(4),  MASK
      DATA    NAM   /  4HUNPA  , 4HK       /
C
      IF (NJ .LE. MAXDEG) GO TO 20
      WRITE  (NOUT,10) NJ,MAXDEG
 10   FORMAT ('0 *** BUNPAK .GT. MAXDEG',2I7)
      CALL ERRTRC (NAM)
C
 20   IPASS = IPASS+NJ
      N1 = I
C
C     ********************************************
C     UNIVAC AND CDC MACHINES
C     ********************************************
C
C     DO 40 N=1,NJ,NW
C     N2 = IG(N1)
C     N3 = N+NW-1
C     DO 30 M=1,NW
C     JG(N3) = ANDF(N2,MASK)
C     IF (M .EQ. NW) GO TO 40
C     N2 = RSHIFT(N2,NBIT)
C  30 N3 = N3-1
C  40 N1 = N1+II1
C     RETURN
C
C     ********************************************
C     IBM AND VAX MACHINES
C     ********************************************
C
      DO 50 N=1,NJ
      JG(N) = IG(N1)
   50 N1 = N1+II1
      RETURN
      END

      SUBROUTINE PERPEC (X,STEREO)
C
      INTEGER          FVP,PRJECT,GP,STEREO
      REAL             X(3,1),MIN,MAX
      DOUBLE PRECISION DIAM,R
      COMMON /BLANK /  SKP(5),NGPSET
      COMMON /XXPARM/  SKPPLT(6),PENPAP(30),SCALX1,OBJMOD,SCALX2(3),
     1                 VIEW(15),FVP,R0,S0L,S0R,T0,D0,D02,D03,PRJECT,S0S
      COMMON /RSTXXX/  CSTM(3,3),MIN(3),MAX(3),D(3),AVER(3)
      DATA    RDIST /  29. /
C
C                               I====================I
C                         T     I                    I
C                         1     I     PROJECTION     I
C                         1     I                    I
C                         1     I       PLANE        I
C                         1     I                    I
C                         1     I====================I
C                         1    /                    /
C                         1   /                    /
C                         1  /   * OBSERVER       /
C                         1 /    1               /D0
C                         1/     1              /
C                         +--------------------/-----S
C                        /       1  /         /
C                       /      T01 /R0
C                      /         1/         /
C                     /----------+- - - - -/
C                    /    S0
C                   R
C
      IF (PRJECT .EQ. 1) GO TO 140
      IF (FVP    .EQ. 0) GO TO 110
      IF (PRJECT .EQ. 3) GO TO 100
C
C     PERSPECTIVE PROJECTION...FIND VANTAGE POINT
C
      R    = D(1)**2 + D(2)**2 + D(3)**2
      DIAM = DSQRT(R)
      R0   = 2.*DIAM + AVER(1)
      S0L  = AVER(2)
      T0   = DIAM + AVER(3)
      D0   = 1.5*DIAM
      GO TO 110
C
C     STEREO PROJECTION...FIND VANTAGE POINT
C
  100 R0  = RDIST + AVER(1)*OBJMOD
      S0L = AVER(2)*OBJMOD - S0S/2.
      S0R = AVER(2)*OBJMOD + S0S/2.
      T0  = AVER(3)*OBJMOD
      D0  = D03
      GO TO 140
C
  110 SCAL = 1.
      IF (PRJECT .EQ. 3) SCAL = OBJMOD
      SLR = S0L
      IF (STEREO .NE. 0) SLR = S0R
      DO 120 GP = 1,NGPSET
      R = D0/(R0-SCAL*X(1,GP))
      S = SLR + R*(SCAL*X(2,GP)-SLR)
      T = T0  + R*(SCAL*X(3,GP)-T0 )
      X(2,GP) = S
      X(3,GP) = T
      IF (PRJECT .EQ. 3) GO TO 120
      MIN(2) = AMIN1(MIN(2),S)
      MIN(3) = AMIN1(MIN(3),T)
      MAX(2) = AMAX1(MAX(2),S)
      MAX(3) = AMAX1(MAX(3),T)
  120 CONTINUE
      IF (PRJECT .EQ. 3) GO TO 140
C
C     FIND MINIMA + MAXIMA DIFFERENCES + AVERAGES
C
      DO 130 I = 2,3
      D(I) = MAX(I) - MIN(I)
      AVER(I) = (MAX(I)+MIN(I))/2.
  130 CONTINUE
C
  140 RETURN
      END

      SUBROUTINE SDCOMP ( *, ZI, ZR, ZD )
      INCLUDE 'SMCOMX.COM'
      COMMON / LOGOUT / LOUT
      CALL SSWTCH ( 44, I44 )
      IF ( I44 .NE. 0 ) GO TO 100
C
C CALL NEW SYMMETRIC DECOMPOSITION ROUTINE 12/95
C      
      CALL SMCOMP ( *710, ZI, ZR, ZD )
      IF ( IERROR .NE. 1 ) GO TO 700
      WRITE ( LOUT, 901 )
901   FORMAT(8X,'INSUFFICIENT OPEN CORE FOR NEW SYMMETRIC DECOMPOSITION'
     &,/,8X,'WILL SWITCH AND USE OLD METHOD.')
C
C OTHERWISE, CALL SYMMETRIC DECOMPOSITION OF RELEASE 94 AND EARLIER
C
100   CALL SDCOMPX( *710, ZI, ZR, ZD )
700   CONTINUE
      RETURN
710   CONTINUE
      RETURN 1
      END

      SUBROUTINE EMGSOC (ICORE,NCORE,HEAT)
C
C     THIS .MDS VERSION IS USED ONLY IN THE VIRTUAL MACHINES (IBM, VAX,
C     AND UNIX)
C     CDC & UNIVAC, NON-VIRTUAL MACHINES, SHOULD USE THE EMGSOC.MIS
C     VERSION
C
C     ICORE = RELATIVE ADDRESS OF FIRST WORD OF OPEN CORE.
C     NCORE = RELATIVE ADDRESS OF FINAL WORD OF OPEN CORE.
C
C     IFILE = GINO FILE WHOSE TRAILER BITS INDICATE ACTIVE COMMON GROUPS
C
C     BOUNDARY ALIGNMENT IS ASSURED BY THE FACT THAT ALL COMMON BLOCKS
C     START AT AN ODD ADDRESS.
C
      COMMON /MACHIN/ MACH
      COMMON /ZZEMGX/ IXXX
C
      NCORE = KORSZ(IXXX)
      ICORE = 3
      IF (MACH.EQ.3 .OR. MACH.EQ.4) STOP ' EMGSOC'
      RETURN
      END

      SUBROUTINE SUB(X,Y,A,B)
C*******
C     SUB WILL FORM Y = A*X - B*Y  WHERE A AND B ARE SCALAR MULTIPLIERS
C     FOR THE VECTORS X AND Y
C*******
      DOUBLE PRECISION   X(1)      ,Y(1)     ,A        ,B
      COMMON   /INVPWX/  XX        ,NCOL
      DO 10 I = 1,NCOL
   10 Y(I) = X(I)*A - Y(I)*B
      RETURN
      END

      SUBROUTINE MMA ( ZI, ZR, ZD )
C
C     MMA PERFORMS THE MATRIX OPERATION
C       (+/-)A    * B (+/-)C = D   OR
C       (+/-)A(T) * B (+/-)C = D
C
C     USING METHODS 10, 11, 20, 21, 30, 31, 32, 40, 41
C
C
C  IN REGARDS TO THE METHODS BELOW, WHEN MULTIPLE COLUMNS OF A MATRIX
C  ARE STORED AND READ BY GETSTR, THEN THE MATRIX IS STORED IN MEMORY IN 
C  COMPACT FORM.  SEE SUBROUTINES 'MMARM1,2,3,4' FOR A DESCRIPTION OF 
C  THIS COMPACT FORM.  WHEN ONLY A SINGLE COLUMN OF A MATRIX IS STORED 
C  AND IT IS BEING READ BY GETSTR, IT IS STORED IN COMPACT FORM IN MEMORY.  
C  SEE SUBROUTINES 'MMARC1,2,3,4' FOR A DESCRIPTION OF THIS FORM.
C
C   ------------------------------------------------------------------------
C   METHOD     METHOD OF READING MATRIX    MULTIPLE COLUMNS OF MATRIX STORED
C                 A        B       C           A         B        D
C   ------------------------------------------------------------------------
C     10        UNPACK  UNPACK   UNPACK       YES        NO       NO
C     11        UNPACK  GETSTR   UNPACK       YES        NO       NO
C     20        UNPACK  UNPACK   UNPACK       NO         YES      YES
C     21        GETSTR  UNPACK   UNPACK       NO         YES      YES
C     30        GETSTR  UNPACK   UNPACK       YES        NO       NO
C     31        GETSTR  GETSTR   UNPACK       YES        NO       NO   
C     32        GETSTR  GETSTR   GETSTR       YES        NO       NO   
C     40        UNPACK  GETSTR   UNPACK       NO         YES      YES
C     41        GETSTR  GETSTR   UNPACK       NO         YES      YES
C   ------------------------------------------------------------------------
C
C   TO DETERMINE WHICH METHOD TO USE, THE FOLLOWING RATIONAL IS USED.      
C   
C   1.  DETERMINE THE METHOD FOR READING MATRICES "A" AND "B".  THIS IS 
C       DETERMINED BY EXAMINING THE FOLLOWING PERCENTAGE:
C 
C            (MEMORY TO CONTAIN ENTIRE MATRIX) 
C            ------------------------------------  = PERCENTAGE
C            (MEMORY TO CONTAIN COMPACTED MATRIX)
C
C       IF THE PERCENTAGE IS .GE. THE VARIABLE "TESTPCT", THEN UNPACK IS
C       USED.  OTHERWISE, GETSTR IS USED.
C
C            NiSTOR (i=A or B) = 1, CALL UNPACK TO READ MATRIX
C                              = 2, CALL GETSTR TO READ MATRIX
C
C    2. THE RESULTS OF THE FIRST TEST WILL NARROW THE OPTIONS TO TWO
C       DIFFERENT METHODS AS FOLLOWS:
C
C                                  CANDIDATE METHOD
C                10     11     20     21     30     31     32     40     41
C       NASTOR =  1      1      1      2      2      2      2      1      2
C       NBSTOR =  1      2      1      1      1      2      2      2      2
C
C          FOR NASTOR = 1 AND NBSTOR = 1, METHODS 10 AND 20 ARE CONSIDERED
C          FOR NASTOR = 1 AND NBSTOR = 2, METHODS 11 AND 40 ARE CONSIDERED
C          FOR NASTOR = 2 AND NBSTOR = 1, METHODS 21 AND 30 ARE CONSIDERED
C          FOR NASOTR = 2 AND NBSTOR = 2, METHODS 31,32 AND 41 ARE CONSIDERED
C            (NOTE, METHOD 32 IS ONLY AVAILABLE WITH "A" TRANSPOSED)
C
C    3. LASTLY, DETERMINE THE ESTIMATED NUMBER OF PASSES FOR EACH OF THE
C       TWO CANDIDATE METHODS.  THE METHOD WITH THE FEWER NUMBER OF PASSES
C       IS CHOSEN.
C        
C       MPASSii (ii=10,11,20,21,30,31,32,40,41) = ESTIMATED NUMBER OF PASSES
C                                                 FOR METHOD ii.
C
C       NiTOTAL (i=A,B,C) = MEMORY WORDS TO CONTAIN ENTIRE FULL MATRIX 
C       NiPACK  (i=A,B,C) = MEMORY WORDS TO CONTAIN ENTIRE MATRIX IN COMPACT 
C                           FORM.
C       NWDD              = NUMBER OF WORDS FOR EACH ELEMENT OF THE "D" MATRIX 
C
C
C     THE FOLLOWING SUBROUTINES ARE CALLED FOR THE DIFFERENT METHODS AND
C     MATRIX "D" TYPES (RS,RD,CS,CD).
C
C          METHODS  MAIN      OTHER SUBROUTINES DEPENDING ON TYPE
C                 SUBROUTINE    RS     RD     CS     CD  
C            10     MMA1      MMA101 MMA102 MMA103 MMA104 
C            11     MMA1      MMA111 MMA112 MMA113 MMA114
C            20     MMA2      MMA201 MMA202 MMA203 MMA204 
C            21     MMA2      MMA211 MMA212 MMA213 MMA214
C            30     MMA3      MMA301 MMA302 MMA303 MMA304 
C            31     MMA3      MMA311 MMA312 MMA313 MMA314  
C            32     MMA3      MMA321 MMA322 MMA323 MMA324 (TRANSPOSE ONLY)
C            40     MMA4      MMA401 MMA402 MMA403 MMA404 
C            41     MMA4      MMA411 MMA412 MMA413 MMA414
C ---------------------------------------------------------------------------      
      INTEGER           NAMEA(2) ,NAMEB(2)  ,NAMEC(2) , NAMED(2)
      INTEGER           ZI(2)    ,PRNTYP(4) ,MODULE(3),PREC1
      INTEGER           BLK1(15) ,BLK2(15)  ,EOL      ,EOR
      INTEGER           SIGNAB   ,SIGNC     ,T        ,SCRTCH
      INTEGER           FILEA    ,FILEB     ,FILEC    ,FILED
      INTEGER           SYSBUF   ,TYPEI     ,TYPEP    ,TYPEU
      INTEGER           ISAVE(9)
      REAL              ZR(2)
      DOUBLE PRECISION  ZD(2)    ,AD(2)   , DD(2)   
      CHARACTER         UFM*23   ,UWM*25    ,UIM*29
      CHARACTER*6       UPMETH(2)
      CHARACTER*2       CT
      INCLUDE           'MMACOM.COM'
      COMMON / NAMES  / RD       ,RDREW     ,WRT     ,WRTREW,CLSREW,CLS
      COMMON / XMSSG  / UFM      ,UWM       ,UIM
      COMMON / LOGOUT / LOUT
      COMMON / MPYADX / FILEA(7) ,FILEB(7)  ,FILEC(7)    
     1,                 FILED(7) ,NZ        ,T       ,SIGNAB,SIGNC,PREC1 
     2,                 SCRTCH   ,TIME
      COMMON / SYSTEM / KSYSTM(152)
      COMMON / PACKX  / TYPEI    ,TYPEP     ,IROW1P  ,IROWNP, INCRP
      COMMON / UNPAKX / TYPEU    ,IROWU     ,IROWNU  ,INCRU
      COMMON / ZBLPKX / D(4)     ,IROWBK
      COMMON / ZNTPKX / A(4)     ,IROWIN    ,EOL     ,EOR
      EQUIVALENCE      (AD(1)     ,A(1)  ) , (DD(1)     ,D(1) )
      EQUIVALENCE      (KSYSTM( 1),SYSBUF) , (KSYSTM( 2),NOUT ) 
     1,                (KSYSTM(58),KSYS58) , (KSYSTM(40),NBPW )
     2,                (KSYSTM(55),IPREC )
      EQUIVALENCE      (FILEA(2)  ,NAC   ) , (FILEA(3)  ,NAR   )
     1,                (FILEA(4)  ,NAFORM) , (FILEA(5)  ,NATYPE)
     2,                (FILEA(6)  ,NANZWD) , (FILEA(7)  ,NADENS)
      EQUIVALENCE      (FILEB(2)  ,NBC   ) , (FILEB(3)  ,NBR   )
     1,                (FILEB(4)  ,NBFORM) , (FILEB(5)  ,NBTYPE)
     2,                (FILEB(6)  ,NBNZWD) , (FILEB(7)  ,NBDENS)
      EQUIVALENCE      (FILEC(2)  ,NCC   ) , (FILEC(3)  ,NCR   )
     1,                (FILEC(4)  ,NCFORM) , (FILEC(5)  ,NCTYPE)
     2,                (FILEC(6)  ,NCNZWD) , (FILEC(7)  ,NCDENS)
      EQUIVALENCE      (FILED(2)  ,NDC   ) , (FILED(3)  ,NDR   )
     1,                (FILED(4)  ,NDFORM) , (FILED(5)  ,NDTYPE)
     2,                (FILED(6)  ,NDNZWD) , (FILED(7)  ,NDDENS)
C
      DATA    MODULE / 4HMMA , 2*4H    /
      DATA    JBEGN  /  4HBEGN/, JEND  / 3HEND/
      DATA    UPMETH / 'UNPACK', 'STRING' /
      DATA PRNTYP / 2HRS, 2HRD, 2HCS, 2HCD /
      DATA TESTPCT / .8 /
      ISAVE( 1 ) = TYPEI
      ISAVE( 2 ) = TYPEP
      ISAVE( 3 ) = IROW1P
      ISAVE( 4 ) = IROWNP
      ISAVE( 5 ) = INCRP
      ISAVE( 6 ) = TYPEU
      ISAVE( 7 ) = IROWU
      ISAVE( 8 ) = IROWNU
      ISAVE( 9 ) = INCRU
      CALL SSWTCH ( 19, L19 )
      MODULE( 3 ) = JBEGN
      CALL CONMSG ( MODULE, 3, 0 )
      NDR = NAR
      NDC = NBC
      IF ( T   .NE. 0   ) NDR = NAC
      IF ( NDFORM .NE. 0 ) GO TO 50
      NDFORM = 2
      IF ( NDR .EQ. NDC ) NDFORM = 1
50    CONTINUE
      IF ( FILEA( 6 ) .EQ. 0 .OR. FILEB( 6 ) .EQ. 0 ) GO TO 5000
      IF ( SIGNAB     .EQ. 0 ) GO TO 5000
      IF ( T        .NE. 0   ) GO TO 100
      IF ( NAC      .NE. NBR ) GO TO 7001
      IF ( FILEC(1) .EQ. 0   ) GO TO 200
      IF ( NAR      .NE. NCR ) GO TO 7001
      IF ( NBC      .NE. NCC ) GO TO 7001
      GO TO 200
100   CONTINUE
      IF ( NAR      .NE. NBR ) GO TO 7001
      IF ( FILEC(1) .EQ. 0   ) GO TO 200
      IF ( NAC      .NE. NCR ) GO TO 7001
      IF ( NBC      .NE. NCC ) GO TO 7001
200   CONTINUE
      NWDC = 0
      CALL DSSIZE ( FILEA, NCOLS, NATERMS, NASTRGS, NWDA )
      CALL DSSIZE ( FILEB, NCOLS, NBTERMS, NBSTRGS, NWDB )
      IF ( FILEC( 1 ) .NE. 0 ) 
     &  CALL DSSIZE ( FILEC, NCOLS, NCTERMS, NCSTRGS, NWDC )
      NWDD    = MAX0 ( NWDA, NWDB, NWDC )
      NDTYPE  = 2
      IF ( NWDD .EQ. 4 ) NDTYPE = 4
      IF ( NWDD .EQ. 1 ) NDTYPE = 1
      IF ( NDTYPE .EQ. 1 .OR. NDTYPE .EQ. 4 ) GO TO 250
      ITEST1  = MIN0 ( NATYPE, NBTYPE, NCTYPE )
      ITEST2  = MAX0 ( NATYPE, NBTYPE, NCTYPE )
      NDTYPE  = 3
      IF ( ITEST2 .EQ. 3 .AND. 
     &  ( NATYPE.EQ.2 .OR. NBTYPE.EQ.2 .OR. NCTYPE.EQ.2 ) ) NDTYPE = 4
      IF ( ITEST2 .LE. 2 ) NDTYPE = 2
250   CONTINUE
      NATOTAL = NAC * NAR * NWDD
      NBTOTAL = NBC * NBR * NWDD
      IF ( FILEC(1) .NE. 0 ) NCTOTAL = NCC * NCR * NWDD
      NDTOTAL = NDC * NDR * NWDD
      NAPACK  = 2*NAC + 2*NASTRGS + NATERMS*NWDD
      NBPACK  = 2*NBC + 2*NBSTRGS + NBTERMS*NWDD   
      IF ( FILEC(1) .NE. 0 ) NCPACK  = 2*NDC + 2*NCSTRGS + NCTERMS*NWDD   
      DENSTYA = ( NADENS*1.) / 10000.
      DENSTYB = ( NBDENS*1.) / 10000.
      IF ( FILEC(1) .NE. 0 ) DENSTYC = ( NCDENS*1.) / 10000.
      NASTOR  = 2
      NBSTOR  = 2
      NCSTOR  = 2
      X = NATOTAL
      Y = NAPACK
      PERCNTA = Y / X
      X = NBTOTAL
      Y = NBPACK
      PERCNTB = Y / X
      IF ( FILEC( 1 ) .EQ. 0 ) GO TO 300
      X = NCTOTAL
      Y = NCPACK
      PERCNTC = Y / X
300   CONTINUE
      IF ( PERCNTA .GE. TESTPCT ) NASTOR = 1
      IF ( PERCNTB .GE. TESTPCT ) NBSTOR = 1 
      IF ( FILEC(1) .NE. 0 .AND. PERCNTC .GE. TESTPCT ) NCSTOR = 1 
      MEMAVL  = NZ - 4*SYSBUF
      MPASS10 = (NATOTAL / ( MEMAVL - (NBR + NDR)*NWDD       ) ) + 1
      MPASS11 = (NATOTAL / ( MEMAVL - NDR*NWDD - (NBPACK/NBC)) ) + 1
      MPASS20 = ((NBTOTAL + NDTOTAL) / (MEMAVL - NAR*NWDD    ) ) + 1
      MPASS21 = ((NBTOTAL + NDTOTAL) / (MEMAVL - (NAPACK/NAC)) ) + 1
      MPASS30 = (NAPACK  / ( MEMAVL - (NBR + NDR)*NWDD       ) ) + 1
      MPASS31 = (NAPACK  / ( MEMAVL - NDR*NWDD - (NBPACK/NBC)) ) + 1 
      MPASS32 = (NAPACK  / ( MEMAVL - (NCPACK/NDC) - (NBPACK/NBC)) ) + 1 
      MPASS40 = ((NBPACK + NDTOTAL) / (MEMAVL - NAR*NWDD     ) ) + 1
      MPASS41 = ((NBPACK + NDTOTAL) / (MEMAVL - (NAPACK/NAC) ) ) + 1
      IF ( NASTOR .EQ. 1 .AND. NBSTOR .EQ. 1 ) GO TO 1000
      IF ( NASTOR .EQ. 2 .AND. NBSTOR .EQ. 1 ) GO TO 1100
      IF ( NASTOR .EQ. 1 .AND. NBSTOR .EQ. 2 ) GO TO 1200
      IF ( NASTOR .EQ. 2 .AND. NBSTOR .EQ. 2 ) GO TO 1300
1000  CONTINUE   
C---------USE UNPACK FOR MATRICES "A" AND "B"  (CHOOSE METHOD 10 OR 20)
      METHOD = 10
      IF ( MPASS10 .EQ. 1       ) GO TO 2000
      IF ( MPASS10 .LE. MPASS20 ) GO TO 2000
      METHOD = 20
      GO TO 2000
1100  CONTINUE 
C---------USE GETSTR FOR MATRIX "A"; UNPACK FOR MATRIX "B"  
C         (CHOOSE METHOD 21 OR 30)
      METHOD = 21
      IF ( MPASS21 .EQ. 1       ) GO TO 2000
      IF ( MPASS21 .LE. MPASS30 ) GO TO 2000
      METHOD = 30
      GO TO 2000
1200  CONTINUE    
C---------USE UNPACK FOR MATRIX "A"; GETSTR FOR MATRIX "B" 
C         (CHOOSE METHOD 11 OR 40)
      METHOD = 11
      IF ( MPASS11 .EQ. 1       ) GO TO 2000
      IF ( MPASS11 .LE. MPASS40 ) GO TO 2000
      METHOD = 40
      GO TO 2000
1300  CONTINUE
C---------USE GETSTR FOR MATRICES "A" AND "B" (CHOOSE METHOD 31, 32 OR 41)
      METHOD = 31
      IF ( MPASS31 .EQ. 1       ) GO TO 1310
      IF ( MPASS31 .LE. MPASS41 ) GO TO 1310
      METHOD = 41
      GO TO 2000
1310  CONTINUE
      IF ( NCSTOR .EQ. 2 .AND. T .NE. 0 ) METHOD = 32
2000  CONTINUE
      IF(L19.EQ.0) GO TO 3000
      CALL FNAME ( FILEA, NAMEA )
      CALL FNAME ( FILEB, NAMEB )
      CALL FNAME ( FILEC, NAMEC )
      CALL FNAME ( FILED, NAMED )
      WRITE( LOUT,2001, IOSTAT=IERR )
     &         NAMEA, NAR, NAC, NATERMS, DENSTYA, PRNTYP( NATYPE )
     &,        NAMEB, NBR, NBC, NBTERMS, DENSTYB, PRNTYP( NBTYPE )
2001  FORMAT(
     & '  /-----------------------------------------------------------/'
     &,/
     &,'  /     MATRIX      ROWS   COLS     TERMS   DENS    TYPE      /'
     &,/
     &,'  /-----------------------------------------------------------/'
     &,/
     &,'     A- ',2A4,I8,I7,I10,F7.4, 5X, A2
     &,/
     &,'     B- ',2A4,I8,I7,I10,F7.4, 5X, A2 )
      IF (FILEC(1) .EQ. 0) GO TO 2010
      WRITE( LOUT,2002, IOSTAT=IERR )
     &        NAMEC, NCR, NCC, NCTERMS, DENSTYC, PRNTYP( NCTYPE )
2002  FORMAT(
     & '     C- ',2A4,I8,I7,I10, F7.4, 5X, A2 )
2010  WRITE( LOUT, 2003 ) NAMED, NDR, NDC, PRNTYP(NDTYPE)
2003  FORMAT('     D- ',2A4, I8, I7, 10X, 7X,   5X, A2 )
      WRITE( LOUT, 2004 ) SIGNAB, SIGNC, NZ, KSYS58
2004  FORMAT('     SIGNAB =',I2,'  SIGNC =',I2,'  MEMORY =',I10
     &,'  SYSTEM(58)=',I3 )
      WRITE( LOUT, 2005 ) UPMETH( NASTOR ), NATOTAL, NAPACK
     &,                   UPMETH( NBSTOR ), NBTOTAL, NBPACK  
      IF ( FILEC( 1 ) .NE. 0 ) 
     &WRITE( LOUT, 20051) UPMETH( NCSTOR ), NCTOTAL, NCPACK  
      WRITE( LOUT, 20052) T, METHOD, PRNTYP( NDTYPE )
2005  FORMAT(
     & '  /-----------------------------------------------------------/'
     &,/
     &,'  /    READ METHOD   MEMORY (FULL MATRIX)    MEMORY (STRINGS) /'
     &,/
     &,'  /-----------------------------------------------------------/'
     &,/
     &,'     A-  ',A6,I21,I21 
     &,/
     &,'     B-  ',A6,I21,I21 
     &)
20051 FORMAT(
     & '     C-  ',A6,I21,I21 )
20052 FORMAT(
     & '     T =',I2,'    SUGGESTED METHOD =',I2
     &,'    "D" MATRIX TYPE:',1X,A2)
      WRITE( LOUT, 2006 ) MPASS10,MPASS11,MPASS20,MPASS21,MPASS30
     &,                           MPASS31,MPASS32,MPASS40,MPASS41
2006  FORMAT(
     & '  /-----------------------------------------------------------/'
     &,/
     & '  /       ESTIMATED NUMBER OF PASSES REQUIRED PER METHOD      /'
     &,/
     &,'  /         10   11   20   21   30   31   32   40   41        /'
     &,/
     &,'  /-----------------------------------------------------------/' 
     &,/
     &,'         ',9I5  
     &,/
     &,'  /-----------------------------------------------------------/' 
     & )
3000  CONTINUE
      IF ( FILED( 1 ) .LT. 0 ) GO TO 7777
      IF (  KSYS58 .NE. 0 .AND. 
     &     (KSYS58 .GE.10 .AND. KSYS58 .LE. 11) .OR.
     &     (KSYS58 .GE.20 .AND. KSYS58 .LE. 21) .OR.
     &     (KSYS58 .GE.30 .AND. KSYS58 .LE. 31) .OR.
     &     (KSYS58 .GE.40 .AND. KSYS58 .LE. 41) )  METHOD = KSYS58
      IF ( KSYS58 .EQ. 32 .AND. T .NE. 0 ) METHOD = KSYS58
      IF ( METHOD .EQ. 10 ) NBSTOR = 1
      IF ( METHOD .EQ. 11 ) NBSTOR = 2
      IF ( METHOD .EQ. 20 ) NASTOR = 1
      IF ( METHOD .EQ. 21 ) NASTOR = 2
      IF ( METHOD .EQ. 30 ) NBSTOR = 1
      IF ( METHOD .EQ. 31 ) NBSTOR = 2     
      IF ( METHOD .EQ. 32 ) NBSTOR = 2     
      IF ( METHOD .EQ. 40 ) NASTOR = 1
      IF ( METHOD .EQ. 41 ) NASTOR = 2
      IF ( METHOD .EQ. 10 .OR. METHOD .EQ. 11 )  
     &     CALL MMA1 ( ZI, ZR, ZD, ZR, ZD )   
      IF ( METHOD .EQ. 20 .OR. METHOD .EQ. 21 )   
     &     CALL MMA2 ( ZI, ZR, ZD, ZR, ZD )   
      IF ( METHOD .GE. 30 .AND. METHOD .LE. 32 ) 
     &     CALL MMA3 ( ZI, ZR, ZD, ZR, ZD )   
      IF ( METHOD .EQ. 40 .OR. METHOD .EQ. 41 ) 
     &     CALL MMA4 ( ZI, ZR, ZD, ZR, ZD )   
      CT = 'NT'
      IF ( T .NE. 0 ) CT = 'T '
      WRITE ( LOUT, 2007 ) METHOD, CT, IPASS
2007  FORMAT('   METHOD USED = ',I2,A2,'  ACTUAL NUMBER OF PASSES =',I4)
      GO TO 7777
C
C "A" AND "B" MATRICES ARE NULL, MOVE "C" TO "D" IF "C" EXISTS
C
5000  CONTINUE
      IF ( FILED( 1 ) .LT. 0 ) GO TO 7777
      NDTYPE = NCTYPE
      WRITE ( LOUT, 9002 ) 
9002  FORMAT('       MMA - NULL MATRIX PRODUCT')
      IBUF1 = NZ    - SYSBUF
      IBUF2 = IBUF1 - SYSBUF
      IF ( FILEC( 1 ) .EQ. 0 ) GO TO 5900
      IF ( SIGNC      .EQ. 0 ) GO TO 5900
      IF ( SIGNC      .LT. 0 ) GO TO 5500
C
C USE CPYSTR TO COPY "C" TO "D"
C
      BLK1( 1 ) = FILEC( 1 )
      BLK2( 1 ) = FILED( 1 )
      CALL GOPEN ( FILEC, ZR( IBUF1 ), RDREW )
      CALL GOPEN ( FILED, ZR( IBUF2 ), WRTREW)
      DO 5200 I = 1, NCC
      CALL CPYSTR ( BLK1, BLK2, 0, 0 )
5200  CONTINUE
      CALL CLOSE ( FILED, CLSREW )
      CALL CLOSE ( FILEC, CLSREW )
      FILED( 2 ) = FILEC( 2 )
      FILED( 3 ) = FILEC( 3 )
      FILED( 4 ) = FILEC( 4 )
      FILED( 5 ) = FILEC( 5 )
      FILED( 6 ) = FILEC( 6 )
      FILED( 7 ) = FILEC( 7 )
      GO TO 7777
C
C USE INTPK/BLDPK TO COPY C TO D BECAUSE SIGNS CONFLICT
C
5500  CONTINUE
      FILED( 2 ) = 0
      FILED( 6 ) = 0
      FILED( 7 ) = 0
      CALL GOPEN ( FILEC, ZR( IBUF1 ), RDREW )
      CALL GOPEN ( FILED, ZR( IBUF2 ), WRTREW)
      DO 5600 I = 1, NCC
      CALL BLDPK ( NDTYPE, NDTYPE, FILED, BLK1, 1 )
      CALL INTPK ( *5550 , FILEC , 0, NDTYPE*SIGNC, 0 )
5510  CALL ZNTPKI
      CALL BLDPKI ( A, IROWIN, FILED, BLK1 )
      IF ( EOL .EQ. 0 ) GO TO 5510
5550  CALL BLDPKN ( FILED, BLK1, FILED )
5600  CONTINUE
      FILED( 3 ) = FILEC( 3 )
      FILED( 4 ) = FILEC( 4 )
      FILED( 5 ) = FILEC( 5 )
      CALL CLOSE ( FILEC, CLSREW )
      CALL CLOSE ( FILED, CLSREW )
      GO TO 7777
C
C CREATE NULL MATRIX BECAUSE "C" MATRIX IS NULL
C
5900  CONTINUE
      NDR = 0
      NDC = 0
      CALL GOPEN ( FILED, ZR( IBUF1 ) , WRTREW )
      NDC = NBC
      NDR = NAR
      IF ( NAR .EQ. NBC ) NDR = NAC
      DD( 1 ) = 0.0D0
      INCRP   = 1
      IROW1P  = 1
      IROWNP  = 1
      TYPEI   = PREC1
      IF ( TYPEI .EQ. 0 ) TYPEI = 1
      TYPEP   = TYPEI
      NUMC    = NDC
      FILED( 2 ) = 0
      FILED( 3 ) = NDR
      FILED( 5 ) = IPREC
      FILED( 6 ) = 0
      FILED( 7 ) = 0
      DO 5950 I = 1, NUMC
      CALL PACK ( DD, FILED, FILED )
5950  CONTINUE
      CALL CLOSE ( FILED, CLSREW )
      GO TO 7777
C MATRICES ARE INCOMPATIBLE FOR MULTIPLICATION
7001  CONTINUE
      WRITE ( NOUT, 9001 ) UFM
9001  FORMAT( A23, 
     &      ' MATRICES FOR MULTIPLICATION HAVE INCOMPATIBLE SIZES',/)
      CALL FNAME ( FILEA, NAMEA )
      CALL FNAME ( FILEB, NAMEB )
      CALL FNAME ( FILEC, NAMEC )
      CALL FNAME ( FILED, NAMED )
      WRITE( NOUT,2001, IOSTAT=IERR )
     &         NAMEA, NAR, NAC, NATERMS, DENSTYA, PRNTYP( NATYPE )
     &,        NAMEB, NBR, NBC, NBTERMS, DENSTYB, PRNTYP( NBTYPE )
      IF ( FILEC(1) .EQ. 0) GO TO 7002
      WRITE( NOUT,2002, IOSTAT=IERR )
     &         NAMEC, NCR, NCC, NCTERMS, DENSTYC, PRNTYP( NCTYPE )
7002  CALL MESAGE ( -61, 0, 0 )
7777  CONTINUE
      MODULE( 3 ) = JEND
      CALL CONMSG ( MODULE, 3, 0 )
      TYPEI  = ISAVE( 1 )
      TYPEP  = ISAVE( 2 )
      IROW1P = ISAVE( 3 )
      IROWNP = ISAVE( 4 )
      INCRP  = ISAVE( 5 )
      TYPEU  = ISAVE( 6 )
      IROWU  = ISAVE( 7 )
      IROWNU = ISAVE( 8 )
      INCRU  = ISAVE( 9 )
      RETURN
      END

      SUBROUTINE SHCSGD (*,CFLAG,CCSID,CTHETA,PFLAG,PCSID,PTHETA,
     1                   NECPT,TUBD,CSID,THETAD,TUMSD)
C
C     WITH ENTRY SHCSGS (*,CFLAG,CCSID,CTHETA,PFLAG,PCSID,PTHETA,
C    1                   NECPT,TUBS,CSID,THETAS,TUMSS)
C
C
C     'COORDINATE SYSTEM GENERATOR' ROUTINE FOR SHELL ELEMENTS.
C
C     THIS ROUTINE USES THE VALUES IN THE EST TABLE TO CREATE
C     APPROPRIATE MATERIAL/STRESS COORDINATE SYSTEM TRANSFORMATIONS.
C
C     INPUT:
C            CFLAG    - INDICATOR FLAG FROM CONNECTION
C            CCSID    - CSID  FROM CONNECTION
C            CTHETA   - ANGLE FROM CONNECTION
C            PFLAG    - INDICATOR FLAG FROM PROPERTY
C            PCSID    - CSID  FROM PROPERTY
C            PTHETA   - ANGLE FROM PROPERTY
C            NECPT    - ARRAY OF LENGTH 4, WORDS 2-4 ARE THE LOCATION
C                       WHERE THE TRANSFORMATION NEEDS TO BE CALCULATED
C            TUBD/S   - USER TO BASIC TRANSFORMATION
C     OUTPUT:
C            TUMSD/S  - USER TO MATERIAL/STRESS TRANSFORMATION
C            CSID     - CSID  USED FOR CALCULATIONS
C            THETAD/S - THETA USED FOR CALCULATIONS
C
C     NOTES:
C     1- IF CSID HAS BEEN SPECIFIED, SUBROUTINE TRANSD IS CALLED TO
C        CALCULATE [TBMS] (MATERIAL/STRESS TO BASIC TRANSFORMATION).
C        [TBMS] IS THEN PREMULTIPLIED BY [TUB] TO OBTAIN [TUMS].
C        THEN USING THE PROJECTION OF X-AXIS, AN ANGLE IS CALCULATED
C        UPON WHICH STEP 2 IS TAKEN.
C     2- IF THETA HAS BEEN SPECIFIED, INPLANE TRANSFORMATION IS USED TO
C        CALCULATE [TUMS] (MATERIAL/STRESS TO USER TRANSFORMATION).
C     3- IF THE CONNECTION VALUE IS LEFT BLANK, THE PROPERTY VALUE IS
C        USED.
C     4- NON-STANDARD RETURN IS TAKEN WHEN THE X-AXIS OF THE SPECIFIED
C        COORDINATE SYSTEM DOES NOT HAVE A PROJECTION ON THE X-Y PLANE
C        OF THE ELEMENT COORD. SYSTEM
C
C
      INTEGER          CSID,CCSID,PCSID,CFLAG,PFLAG,NECPT(4)
      REAL             TUBS(9),TUMSS(9),TBMSS(9),XMS,YMS,THETAS,EPS1S,
     1                 PIS,TWOPIS,RADDGS,DEGRDS,FLIPS
      DOUBLE PRECISION TUBD(9),TUMSD(9),TBMSD(9),XMD,YMD,THETAD,EPS1D,
     1                 PID,TWOPID,RADDGD,DEGRDD,FLIPD
      COMMON /CONDAS/  PIS,TWOPIS,RADDGS,DEGRDS
      COMMON /CONDAD/  PID,TWOPID,RADDGD,DEGRDD
      EQUIVALENCE      (TBMSS(1),TBMSD(1))
      DATA    EPS1D ,  EPS1S /1.0D-7, 1.0E-7 /
C
C
C     DOUBLE PRECISION VERSION
C
      FLIPD = 1.0D0
      IF (CFLAG .EQ. 0) GO TO 130
C
C     DETERMINE THETA FROM THE PROJECTION OF THE X-AXIS OF THE MATERIAL/
C     STRESS COORD. SYSTEM, DETERMINED BASED ON CCSID, ONTO THE XY-PLANE
C     OF THE ELEMENT COORD. SYSTEM.
C
      CSID = CCSID
      IF (CCSID .GT. 0) GO TO 110
C
C     [TUMS] = [TUB]
C
      DO 100 I = 1,9
      TUMSD(I) = TUBD(I)
 100  CONTINUE
      GO TO 120
C
C     [TUMS] = [TUB] [TBMS]
C
 110  NECPT(1) = CCSID
      CALL TRANSD (NECPT,TBMSD)
      CALL GMMATD (TUBD,3,3,0, TBMSD,3,3,0, TUMSD)
C
 120  XMD = TUMSD(1)
      YMD = TUMSD(4)
      IF (DABS(XMD).LE.EPS1D .AND. DABS(YMD).LE.EPS1D) RETURN 1
      THETAD = DATAN2(YMD,XMD)
      IF (TUMSD(9) .LT. 0.0D0) FLIPD = -1.0D0
      GO TO 190
C
 130  IF (CTHETA .EQ. 0.0) GO TO 140
C
C     DETERMINE THETA FROM CTHETA
C
      THETAD = DBLE(CTHETA)*DEGRDD
      GO TO 190
C
C     DEFAULT IS CHOSEN, LOOK FOR VALUES OF PCSID AND/OR PTHETA ON THE
C     PSHELL CARD.
C
 140  IF (PFLAG .EQ. 0) GO TO 180
C
C     DETERMINE THETA FROM THE PROJECTION OF THE X-AXIS OF THE MATERIAL/
C     STRESS COORD. SYSTEM, DETERMINED BASED ON PCSID, ONTO THE XY-PLANE
C     OF THE ELEMENT COORD. SYSTEM.
C
      CSID = PCSID
      IF (PCSID .GT. 0) GO TO 160
C
C     [TUMS] = [TUB]
C
      DO 150 I = 1,9
      TUMSD(I) = TUBD(I)
 150  CONTINUE
      GO TO 170
C
C     [TUMS] = [TUB] [TBMS]
C
 160  NECPT(1) = PCSID
      CALL TRANSD (NECPT,TBMSD)
      CALL GMMATD (TUBD,3,3,0, TBMSD,3,3,0, TUMSD)
C
 170  XMD = TUMSD(1)
      YMD = TUMSD(4)
      IF (DABS(XMD).LE.EPS1D .AND. DABS(YMD).LE.EPS1D) RETURN 1
      THETAD = DATAN2(YMD,XMD)
      IF (TUMSD(9) .LT. 0.0D0) FLIPD = -1.0D0
      GO TO 190
C
C     DETERMINE THETA FROM PTHETA
C
 180  THETAD = DBLE(PTHETA)*DEGRDD
C
C     IF THE Z-AXIS OF THE TARGET MATERIAL/STRESS COORD. SYSTEM WAS NOT
C     POINTING IN THE SAME GENERAL DIRECTION AS THE Z-AXIS OF THE USER
C     COORD. SYSTEM, FLIP THE Y- AND Z-AXES OF THE FINAL COORDINATE
C     SYSTEM TO ACCOUNT FOR IT.
C
 190  TUMSD(1) = DCOS(THETAD)
      TUMSD(2) =-FLIPD*DSIN(THETAD)
      TUMSD(3) = 0.0D0
      TUMSD(4) = DSIN(THETAD)
      TUMSD(5) = FLIPD*DCOS(THETAD)
      TUMSD(6) = 0.0D0
      TUMSD(7) = 0.0D0
      TUMSD(8) = 0.0D0
      TUMSD(9) = FLIPD
C
      RETURN
C
C
      ENTRY SHCSGS (*,CFLAG,CCSID,CTHETA,PFLAG,PCSID,PTHETA,
     1              NECPT,TUBS,CSID,THETAS,TUMSS)
C     ======================================================
C
C     SINGLE PRECISION VERSION
C
      FLIPS = 1.0
      IF (CFLAG .EQ. 0) GO TO 230
C
C     DETERMINE THETA FROM THE PROJECTION OF THE X-AXIS OF THE MATERIAL/
C     STRESS COORD. SYSTEM, DETERMINED BASED ON CCSID, ONTO THE XY-PLANE
C     OF THE ELEMENT COORD. SYSTEM.
C
      CSID = CCSID
      IF (CCSID .GT. 0) GO TO 210
C
C     [TUMS] = [TUB]
C
      DO 200 I = 1,9
      TUMSS(I) = TUBS(I)
 200  CONTINUE
      GO TO 220
C
C     [TUMS] = [TUB] [TBMS]
C
 210  NECPT(1) = CCSID
      CALL TRANSS (NECPT,TBMSS)
      CALL GMMATS (TUBS,3,3,0, TBMSS,3,3,0, TUMSS)
C
 220  XMS = TUMSS(1)
      YMS = TUMSS(4)
      IF (ABS(XMS).LE.EPS1S .AND. ABS(YMS).LE.EPS1S) RETURN 1
      THETAS = ATAN2(YMS,XMS)
      IF (TUMSS(9) .LT. 0.0) FLIPS = -1.0
      GO TO 290
C
 230  IF (CTHETA .EQ. 0.0) GO TO 240
C
C     DETERMINE THETA FROM CTHETA
C
      THETAS = CTHETA*DEGRDS
      GO TO 290
C
C     DEFAULT IS CHOSEN, LOOK FOR VALUES OF PCSID AND/OR PTHETA ON THE
C     PSHELL CARD.
C
 240  IF (PFLAG .EQ. 0) GO TO 280
C
C     DETERMINE THETA FROM THE PROJECTION OF THE X-AXIS OF THE MATERIAL/
C     STRESS COORD. SYSTEM, DETERMINED BASED ON PCSID, ONTO THE XY-PLANE
C     OF THE ELEMENT COORD. SYSTEM.
C
      CSID = PCSID
      IF (PCSID .GT. 0) GO TO 260
C
C     [TUMS] = [TUB]
C
      DO 250 I = 1,9
      TUMSS(I) = TUBS(I)
 250  CONTINUE
      GO TO 270
C
C     [TUMS] = [TUB] [TBMS]
C
 260  NECPT(1) = PCSID
      CALL TRANSS (NECPT,TBMSS)
      CALL GMMATS (TUBS,3,3,0, TBMSS,3,3,0, TUMSS)
C
 270  XMS = TUMSS(1)
      YMS = TUMSS(4)
      IF (ABS(XMS).LE.EPS1S .AND. ABS(YMS).LE.EPS1S) RETURN 1
      THETAS = ATAN2(YMS,XMS)
      IF (TUMSS(9) .LT. 0.0) FLIPS = -1.0
      GO TO 290
C
C     DETERMINE THETA FROM PTHETA
C
 280  THETAS = PTHETA*DEGRDS
C
C     IF THE Z-AXIS OF THE TARGET MATERIAL/STRESS COORD. SYSTEM WAS NOT
C     POINTING IN THE SAME GENERAL DIRECTION AS THE Z-AXIS OF THE USER
C     COORD. SYSTEM, FLIP THE Y- AND Z-AXES OF THE FINAL COORDINATE
C     SYSTEM TO ACCOUNT FOR IT.
C
 290  TUMSS(1) = COS(THETAS)
      TUMSS(2) =-FLIPS*SIN(THETAS)
      TUMSS(3) = 0.0
      TUMSS(4) = SIN(THETAS)
      TUMSS(5) = FLIPS*COS(THETAS)
      TUMSS(6) = 0.0
      TUMSS(7) = 0.0
      TUMSS(8) = 0.0
      TUMSS(9) = FLIPS
C
      RETURN
      END

      SUBROUTINE SWITCH
C
C     THE PURPOSE OF THIS MODULE IS TO INTERCHANGE THE NAMES OF THE
C     TWO INPUT FILES.  THIS IS ACCOMPLISHED BY THE DIRECT UPDATING
C     OF THE FIAT
C
      EXTERNAL        LSHIFT,RSHIFT,ANDF,ORF,COMPLF
      INTEGER         FILE1,FILE2,MODNAM(2),NAME(2),PSAVE1,PSAVE2,
     1                ANDF,ORF,RSHIFT,COMPLF,UNIT,UNIT1,UNIT2,UNT
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG / UFM,UWM,UIM,SFM
      COMMON /XFIAT / IFIAT(3)
      COMMON /XFIST / IFIST(2)
      COMMON /XPFIST/ IPFIST
      COMMON /BLANK / IPARAM
      COMMON /SYSTEM/ SYSBUF,NOUT,SKIP(21),ICFIAT
      DATA    FILE1 / 101/, FILE2 / 102/, MODNAM/ 4HSWIT,4HCH  /
C
      IF (IPARAM .GE. 0) RETURN
      MASK2 = 32767
      MASK3 = COMPLF(MASK2)
      MASK  = LSHIFT(1,30) - 1
      MASK  = LSHIFT(RSHIFT(MASK,16),16)
      MASK1 = COMPLF(MASK)
      NUNIQE= IFIAT(1)*ICFIAT + 3
      MXE   = IFIAT(2)*ICFIAT + 3
      LASTWD= IFIAT(3)*ICFIAT + 3
C
C     LOCATE FILE POINTERS IN THE FIST
C
      NWD    = 2*IPFIST   + 2
      NACENT = 2*IFIST(2) + 2
      NFILES = NACENT - NWD
      PSAVE1 = 0
      PSAVE2 = 0
      DO 10 I = 1,NFILES,2
      IF (IFIST(NWD+I).NE.FILE1 .AND. IFIST(NWD+I).NE.FILE2) GO TO 10
      IF (IFIST(NWD+I)-FILE1) 2,3,2
    2 IF (IFIST(NWD+I)-FILE2) 10,4,10
    3 PSAVE1 = IFIST(NWD+I+1) + 1
      GO TO 10
    4 PSAVE2 = IFIST(NWD+I+1) + 1
   10 CONTINUE
C
C     CHECK THAT FILES ARE IN FIST
C
      IF (PSAVE1 .EQ. 0) CALL MESAGE (-1,FILE1,MODNAM)
      IF (PSAVE2 .EQ. 0) CALL MESAGE (-1,FILE2,MODNAM)
C
C     SWITCH FILE NAMES IN FIAT
C
      NAME(1) = IFIAT(PSAVE1+1)
      NAME(2) = IFIAT(PSAVE1+2)
      UNIT1   = ANDF(MASK2,IFIAT(PSAVE1))
      UNIT2   = ANDF(MASK2,IFIAT(PSAVE2))
      NWD     = ICFIAT*IFIAT(3) - 2
      LTU1    = ANDF(MASK,IFIAT(PSAVE1))
      LTU2    = ANDF(MASK,IFIAT(PSAVE2))
      IFIAT(PSAVE1  ) = ORF(ANDF(IFIAT(PSAVE1),MASK2),LTU2)
      IFIAT(PSAVE1+1) = IFIAT(PSAVE2+1)
      IFIAT(PSAVE1+2) = IFIAT(PSAVE2+2)
      IFIAT(PSAVE2  ) = ORF(ANDF(IFIAT(PSAVE2),MASK2),LTU1)
      IFIAT(PSAVE2+1) = NAME(1)
      IFIAT(PSAVE2+2) = NAME(2)
C
C     SWITCH STACKED DATA BLOCKS
C
      DO 100 I = 4,NWD,ICFIAT
      IF (PSAVE1.EQ.I .OR. PSAVE2.EQ.I) GO TO 100
      UNIT = ANDF(MASK2,IFIAT(I))
      IF (UNIT.NE.UNIT1 .AND. UNIT.NE.UNIT2) GO TO 100
      IF (UNIT .EQ. UNIT1) UNT = UNIT2
      IF (UNIT .EQ. UNIT2) UNT = UNIT1
      IF (I   .GT. NUNIQE) GO TO 50
C
C     DATA BLOCK RESIDES IN UNIQUE PART OF FIAT
C     MOVE ENTRY TO BOTTOM
C
      IF (LASTWD+ICFIAT .LE. MXE) GO TO 30
      WRITE  (NOUT,20) SFM
   20 FORMAT (A25,' 1021, FIAT OVERFLOW')
      CALL MESAGE (-37,0,MODNAM)
   30 IFIAT(LASTWD+1) = ORF(ANDF(IFIAT(I),MASK3),UNT)
      DO 40 K = 2,ICFIAT
   40 IFIAT(LASTWD+K) = IFIAT(I+K-1)
      LASTWD   = LASTWD   + ICFIAT
      IFIAT(3) = IFIAT(3) + 1
C
C     CLEAR OLD ENTRY IN UNIQUE PART
C
      IFIAT(I) = ANDF(IFIAT(I),MASK2)
      J1 = I + 1
      J2 = I + ICFIAT - 1
      DO 45 K = J1,J2
   45 IFIAT(K) = 0
      GO TO 100
C
C     DATA BLOCK RESIDES IN NON-UNIQUE PORTION OF FIAT
C     SWITCH UNIT NUMBERS
C
   50 IFIAT(I) = ORF(ANDF(IFIAT(I),MASK3),UNT)
  100 CONTINUE
      RETURN
      END

      SUBROUTINE CFEER4
C
C     CFEER4 OBTAINS THE EIGENVALUES AND EIGENVECTORS FROM THE
C     REDUCED TRIDIAGONAL MATRIX FOR THE COMPLEX FEER METHOD
C
      LOGICAL           NO B     ,DECREM   ,QPR      ,LZ(1)     ,
     1                  DPMACH
      INTEGER           NAME(2)  ,IZ(1)    ,EOR
      INTEGER           WRTREW
      DOUBLE PRECISION  LAMBDA   ,EPS      ,DZ(1)    ,D(4)      ,
     1                  LAM1(2)
      DIMENSION         S(8)     ,DMP1(2)  ,ALAM(2)  ,DM(2)     ,
     1                  STATUS(2),ACCEPT(2),REJECT(2)
      CHARACTER         UFM*23   ,UWM*25   ,UIM*29
      COMMON  /XMSSG /  UFM      ,UWM      ,UIM
      COMMON  /FEERAA/  IKMB(21) ,ILAM(7)  ,IPHI(7)  ,IDMPFL    ,
     1                  ISCR(11) ,DUMAA(84),MCBVEC(7)
      COMMON  /FEERXC/  LAMBDA(2),SWDUM    ,MREDUC   ,NORD      ,
     1                  IDIAG    ,EPS      ,NORTHO   ,NORD2     ,
     2                  NORD4    ,NORDP1   ,NSWP(2)  ,NO B      ,
     3                  IT       ,TEN2MT   ,TENMHT   ,NSTART    ,
     4                  QPR      ,JREG     ,NOREG    ,NZERO     ,
     5                  TENMTT   ,MINOPN
      COMMON  /ZZZZZZ/  Z(1)
      COMMON  /UNPAKX/  IPRC     ,II       ,NN       ,INCR
      COMMON  /SYSTEM/  KSYSTM(65)
      COMMON  /NAMES /  RD       ,RDREW    ,WRT      ,WRTREW    ,
     1                  REW      ,NOREW    ,EOFNRW
      EQUIVALENCE       (KSYSTM(2 ),NOUT ) ,(NROW,MREDUC)       ,
     1                  (KSYSTM(55),IPREC) ,(D(1),S(1)  )       ,
     2                  (Z(1),IZ(1),LZ(1),DZ(1))
      DATA     NAME  /  4HCFEE,4HR4  /
      DATA     ACCEPT,  REJECT/4H  AC,4HCEPT,4H -RE,4HJECT      /
C
C     CORE ALLOCATION FOR ALLMAT
C
C     CONTENTS                SIZE             POINTER   TYPE   NAME
C     --------                ----             -------   ----   ----
C     INPUT MATRIX--VECTORS   2*NROW*NROW      IA        COMP   A
C     EIGENVALUES             2*NROW           IL        COMP   LAM
C     H  MATRIX               2*NROW*NROW      IH        COMP   H
C     HL MATRIX               2*NROW*NROW      IHL       COMP   HL
C     VECTOR STORAGE          2*NROW           IV        COMP   VEC
C     MULTIPLIERS             2*NROW           IM        COMP   MULT
C     INTH                    NROW             INTH      INTG   INTH
C     INTQ                    NROW             INTQ      LOGL   INTQ
C
C     CORE ALLOCATION AFTER ALLMAT IS FINISHED
C
C     ALLMAT OUTPUT EIGENVECTORS               IA
C     EIGENVALUES                              IL
C     ORDER OF EXTRACTION                      IH
C     THEORETICAL ERRORS                       IHL
C     NOT USED                                 IV,IM
C     STATUS OF SOLUTIONS                      INTH
C     DISTANCES FROM CENTER                    INTQ
C     VARIABLE PRECISION PHYSICAL EIGENVECTORS IV1
C     VARIABLE PRECISION ORTHOGONAL VECTORS    IV2
C
C     DEFINITION OF INTERNAL PARAMETERS
C
C     DMP1     = D-SUB-M-PLUS-1 = EXTRANEOUS OFF-DIAGONAL ELEMENT
C                OF REDUCED TRIDIAGONAL MATRIX, USED FOR COMPUTING
C                THEORETICAL ERRORS
C     DM       = FINAL OFF-DIAGONAL ELEMENT OF REDUCED TRIDIAGONAL
C                MATRIX
C     NO B     = LOGICAL INDICATOR FOR ABSENCE OF DAMPING MATRIX B
C     DECREM   = LOGICAL INDICATOR FOR DECREMENTED SIZE OF REDUCED
C                PROBLEM
C     NROW     = SIZE OF THE REDUCED PROBLEM (EQUIVALENT TO MREDUC)
C     RMS      = ROOT-MEAN-SQUARE OF EIGENVALUES, USED IN RIGID-BODY
C                ERROR TEST
C     NOTE.....SEE LISTING OF CFCNTL FOR ADDITIONAL DEFINITIONS
C
      IF (QPR) WRITE (NOUT,600)
      DPMACH = IPREC .EQ. 2
      NORD8  = 2*NORD4
      DECREM = .FALSE.
    4 NROW2  = 2*NROW
      NROWSQ = NROW*NROW2
C
C     ALLOCATE CORE FOR ALLMAT
C
      IA  = 1
      IL  = IA  + NROWSQ
      IH  = IL  + NROW2
      IHL = IH  + NROWSQ
      IV  = IHL + NROWSQ
      IM  = IV  + NROW2
      INTH= IM  + NROW2
      INTQ= INTH+ NROW
C
C     ALLOCATE CORE FOR PHYSICAL EIGENVECTORS (LEFT FOLLOWS RIGHT)
C
      IV1 = INTQ + NROW
      IV2 = IV1  + NORD8
      IF (DPMACH .AND. MOD(IV2,2).EQ.0) IV2 = IV2 + 1
      IV1X = IV1 - 1
C
C     TEST FOR INSUFFICIENT CORE
C
      NZ    = KORSZ(Z(1))
      IBUF1 = NZ    - KSYSTM(1)
      IBUF2 = IBUF1 - KSYSTM(1)
      IOPN  = IBUF2 - (IV2 + NORD8)
      IF (IDIAG .NE. 0) WRITE (NOUT,610) IOPN
      IF (IOPN  .LE. 0) CALL MESAGE (-8,0,NAME(1))
      IF (IOPN .LT. MINOPN) MINOPN = IOPN
      IF (NSWP(2)  .LT.  0) GO TO 209
C
C     CONSTRUCT REDUCED TRIDIAGONAL MATRIX
C
      DO 10 I = IA,IL
   10 Z(I) = 0.
      NROW22 = NROW2 + 2
      CALL GOPEN (ISCR(5),Z(IBUF1),RDREW)
      NW  = 4*IPREC
      EOR = 1
      M   = 0
      NROW1 = NROW - 1
C
C     ENTER LOOP
C
      DO 20 I = 1,NROW
      I1 = I - 1
      CALL READ (*420,*430,ISCR(5),S(1),NW,EOR,M)
      IF (QPR .AND. .NOT.DPMACH) WRITE (NOUT,620) I,(S(J),J=1,4)
      IF (QPR .AND.      DPMACH) WRITE (NOUT,630) I,(D(J),J=1,4)
C
C     ALLMAT ACCEPTS ONLY SINGLE PRECISION ARRAY
C
      J = IA + NROW22*I1
      IF (.NOT.DPMACH) GO TO 15
C
C     LOAD MAIN DIAGONAL ELEMENT
C
      Z(J  ) = D(3)
      Z(J+1) = D(4)
      IF (I .NE. NROW1) GO TO 12
C
C     SAVE LAST OFF-DIAGONAL ELEMENT
C
      DM(1) = D(1)
      DM(2) = D(2)
   12 IF (I .EQ. NROW) GO TO 20
C
C     LOAD OFF-DIAGONAL ELEMENTS
C
      Z(J+2) = D(1)
      Z(J+3) = D(2)
      J  = J + NROW2
      Z(J  ) = D(1)
      Z(J+1) = D(2)
      GO TO 20
C
C     LOAD MAIN DIAGONAL ELEMENT
C
   15 Z(J  ) = S(3)
      Z(J+1) = S(4)
      IF (I .NE. NROW1) GO TO 16
C
C     SAVE LAST OFF-DIAGONAL ELEMENT
C
      DM(1) = S(1)
      DM(2) = S(2)
   16 IF (I .EQ. NROW) GO TO 20
C
C     LOAD OFF-DIAGONAL ELEMENTS
C
      Z(J+2) = S(1)
      Z(J+3) = S(2)
      J  = J + NROW2
      Z(J  ) = S(1)
      Z(J+1) = S(2)
   20 CONTINUE
C
C     SAVE ERROR ELEMENT FROM TRIDIAGONAL MATRIX
C
      IF (.NOT.DPMACH) GO TO 25
      DMP1(1) = D(1)
      DMP1(2) = D(2)
      GO TO 26
   25 DMP1(1) = S(1)
      DMP1(2) = S(2)
   26 CONTINUE
      IF (QPR) WRITE (NOUT,640) (Z(I),I=1,NROWSQ)
      CALL CLOSE (ISCR(5),REW)
      IF (DECREM) GO TO 30
C
C     DECREMENT THE REDUCED PROBLEM SIZE IF THE ERROR ELEMENT IS NULL
C
      IF (DMP1(1).NE.0. .OR. DMP1(2).NE.0.) GO TO 30
      MREDUC = MREDUC - 1
      WRITE (NOUT,570) UWM,MREDUC
      IF (MREDUC .EQ. 0) GO TO 440
      IF (DM(1).NE.0. .OR. DM(2).NE.0.) GO TO 29
C
C     NEW ERROR ELEMENT IS ALSO NULL. RESTORE ORIGINAL REDUCED SIZE.
C
      MREDUC  = MREDUC + 1
      DMP1(1) = SNGL(EPS)
      WRITE (NOUT,590) UWM,MREDUC,DMP1
      GO TO 30
   29 DECREM = .TRUE.
      GO TO 4
C
   30 CALL ALLMAT (Z(IA),Z(IL),Z(IH),Z(IHL),Z(IV),Z(IM),Z(INTH),Z(INTQ),
     1             NROW,NROW,INIDUM)
C
C     --------------- SPECIAL PRINT -------------------------
C
      IF (.NOT.QPR) GO TO 4429
      WRITE  (NOUT,4408)
 4408 FORMAT (1H0,10X,15HALLMAT EXECUTED,/,1H0)
      J = IH - 1
      WRITE  (NOUT,4420) (Z(I),I=IL,J)
 4420 FORMAT (1H0,11HEIGENVALUES, //,(1H ,2E16.8))
      WRITE  (NOUT,4422)
 4422 FORMAT (1H0,12HEIGENVECTORS,//)
      DO 4428 I = 1,NROW
      L = IA + NROW2*(I-1)
      K = L  + NROW2 - 1
      WRITE (NOUT,4424) (Z(J),J=L,K)
C
C     CHECK NORMALITY
C
      SUMR = 0.
      SUMI = 0.
      DO 7760 J = L,K,2
      JJ   = J + 1
      SUMR = SUMR + Z(J)**2 - Z(JJ)**2
 7760 SUMI = SUMI + 2.*Z(J)*Z(JJ)
      WRITE  (NOUT,7770) SUMR,SUMI
 7770 FORMAT (//,35H SELF INNER-PRODUCT OF ABOVE VECTOR, /,1H ,6X,
     1        11HREAL PART =,E16.8,8X,16HIMAGINARY PART =,E16.8)
 4424 FORMAT (//,(1H ,6E16.8))
 4428 CONTINUE
 4429 CONTINUE
C     -------------------------------------------------------
C
C     NORMALIZE THE EIGENVECTORS OUTPUT FROM ALLMAT
C
      IF (QPR) WRITE (NOUT,4422)
      DO 36 I = 1,NROW
      L = IA + NROW2*(I-1)
      K = L  + NROW2 - 1
      SUMR = 0.
      SUMI = 0.
      DO 33 J = L,K,2
      JJ   = J + 1
      SUMR = SUMR + Z(J)**2 - Z(JJ)**2
   33 SUMI = SUMI + 2.*Z(J)*Z(JJ)
      RSQRT= SQRT(SQRT(SUMR**2 + SUMI**2))
      IF (RSQRT .GT. 0.) GO TO 34
      WRITE (NOUT,560) UWM,NAME
      GO TO 36
   34 THETA2= .5*ATAN2(SUMI,SUMR)
      SUMR  = RSQRT*COS(THETA2)
      SUMI  = RSQRT*SIN(THETA2)
      THETA2= 1./(SUMR**2 + SUMI**2)
      SUMR  = SUMR*THETA2
      SUMI  =-SUMI*THETA2
      DO 35 J = L,K,2
      JJ    = J + 1
      THETA2= Z(J)
      Z(J ) = SUMR*Z(J)   - SUMI*Z(JJ)
   35 Z(JJ) = SUMI*THETA2 + SUMR*Z(JJ)
C
C     -------------- SPECIAL PRINT --------------------------
C
      IF (.NOT.QPR) GO TO 36
      WRITE (NOUT,4424) (Z(J),J=L,K)
C
C     CHECK NORMALITY
C
      SUMR = 0.
      SUMI = 0.
      DO 1008 J = L,K,2
      JJ   = J + 1
      SUMR = SUMR + Z(J)**2 - Z(JJ)**2
 1008 SUMI = SUMI + 2.*Z(J)*Z(JJ)
      WRITE (NOUT,7770) SUMR,SUMI
C     -------------------------------------------------------
C
   36 CONTINUE
C
C     COMPUTE THEORETICAL EIGENVALUE ERRORS
C
      IF (QPR) WRITE (NOUT,650) DMP1
      IHL1 = IHL - 1
      DO 50 I = 1,NROW
      K = IL + 2*(I-1)
      DENOM = SQRT(Z(K)**2 + Z(K+1)**2)
      IF (DENOM .GT. 0.) GO TO 40
      WRITE (NOUT,550) UIM,I
      DENOM = 1.E-10
   40 DENOM = 1./DENOM
      K  = IA + NROW2*I - 2
      KK = K  + 1
      J  = IHL1 + I
      Z(J) = DENOM*SQRT((DMP1(1)*Z(K) - DMP1(2)*Z(KK))**2
     1     + (DMP1(1)*Z(KK) + DMP1(2)*Z(K))**2)
      IF (QPR) WRITE (NOUT,660) I,Z(J),Z(K),Z(KK),DENOM
   50 CONTINUE
C
C     RECOVER PHYSICAL EIGENVALUES
C
      RMS = 0.
      IF (NO B) GO TO 54
      ALAM(1) = LAMBDA(1)
      ALAM(2) = LAMBDA(2)
      GO TO 55
   54 ALAM(1) = LAMBDA(1)**2 - LAMBDA(2)**2
      ALAM(2) = 2.D0*LAMBDA(1)*LAMBDA(2)
   55 DO 70 I = 1,NROW
      K  = IL + 2*(I-1)
      KK = K  + 1
      DENOM = Z(K)**2 + Z(KK)**2
      IF (DENOM .EQ. 0.) DENOM = 1.E-20
      DENOM = 1./DENOM
      Z( K) = DENOM*Z( K) + ALAM(1)
      Z(KK) =-DENOM*Z(KK) + ALAM(2)
      IF (NO B) GO TO 60
      GO TO 70
C
C     DAMPING MATRIX ABSENT
C
   60 RSQRT  = SQRT(SQRT(Z(K)**2 + Z(KK)**2))
      THETA2 = .5*ATAN2(Z(KK),Z(K))
      Z( K)  = RSQRT*COS(THETA2)
      Z(KK)  = RSQRT*SIN(THETA2)
      IF (Z(KK) .GE. 0.) GO TO 70
      Z( K)  =-Z( K)
      Z(KK)  =-Z(KK)
C
C     COMPUTE RMS FOR RIGID-BODY ERROR TEST
C
   70 RMS = RMS + SQRT((Z(K)**2-Z(KK)**2)**2 + 4.*(Z(K)*Z(KK))**2)
      RMS = SQRT(RMS)/FLOAT(NROW)
      IF (QPR) WRITE (NOUT,800) RMS
      J  = IH - 1
      IF (QPR) WRITE (NOUT,4420) (Z(I),I=IL,J)
C
C     PERFORM RIGID-BODY ERROR TEST
C
      IF (RMS .LT. 1.E-20) RMS = 1.E-20
      RMS = 1./RMS
      DO 80 I = 1,NROW
      K = IL + 2*(I-1)
      J = IHL1 + I
      IF (RMS*SQRT(Z(K)**2+Z(K+1)**2) .LE. TENMTT) Z(J) = 0.
   80 CONTINUE
C
C     COMPUTE DISTANCES OF EIGENVALUES TO CENTER OF NEIGHBORHOOD
C
      ALAM(1) = LAMBDA(1)
      ALAM(2) = LAMBDA(2)
      JJ = INTQ - 1
      KK = IH   - 1
      LL = INTH - 1
      DO 90 I = 1,NROW
      J  = JJ + I
      K  = IL + 2*(I-1)
      Z(J) = SQRT((ALAM(1) - Z(K))**2 + (ALAM(2)-Z(K+1))**2)
C
C     LOAD ORDER OF EXTRACTION
C
      K = KK + I
      IZ(K) = I
C
C     LOAD STATUS OF EACH SOLUTION
C
      K = LL + I
      LZ(K) = .FALSE.
      J = IHL1 + I
      IF (Z(J) .LT. SNGL(EPS)) LZ(K) = .TRUE.
   90 CONTINUE
C
C     SORT EIGENVALUES ACCORDING TO DISTANCE FROM CURRENT CENTER
C
      IF (NROW .EQ. 1) GO TO 150
      LL = NROW - 1
      DO 140 I = 1,LL
      K  = JJ + I
      I1 = KK + I
      LLL= I  + 1
      DO 130 J = LLL,NROW
      L  = JJ + J
      IF (Z(K) .LT. Z(L)) GO TO 130
      UNIDUM = Z(L)
      Z(L)   = Z(K)
      Z(K)   = UNIDUM
      I2     = KK + J
      INIDUM = IZ(I1)
      IZ(I1) = IZ(I2)
      IZ(I2) = INIDUM
  130 CONTINUE
  140 CONTINUE
  150 LLL = IL - 1
      LL  = INTH - 1
      IF (IDIAG .EQ. 0) GO TO 170
C
C     PRINT OUT FULL SUMMARY FOR CURRENT NEIGHBORHOOD
C
      WRITE (NOUT,670) JREG,NOREG,ALAM
      WRITE (NOUT,680)
      WRITE (NOUT,690)
      DO 160 I = 1,NROW
      K   = KK  + I
      IZZ = 2*IZ(K) - 1
      J   = JJ  + I
      L   = LLL + IZZ
      L1  = L   + 1
      I1  = IHL1+ IZ(K)
      Z(I1) = 100.*Z(I1)
      I2  = LL  + IZ(K)
      STATUS(1) = ACCEPT(1)
      STATUS(2) = ACCEPT(2)
      IF (LZ(I2)) GO TO 160
      STATUS(1) = REJECT(1)
      STATUS(2) = REJECT(2)
  160 WRITE (NOUT,700) I,IZ(K),Z(J),Z(L),Z(L1),Z(I1),STATUS
C
C     DECREMENT COUNTERS SO THAT ONLY ACCEPTABLE SOLUTIONS ARE RETAINED
C
  170 MSAVE = NROW
      DO 180 I = 1,MSAVE
      I2 = LL + I
      IF (LZ(I2)) GO TO 180
      NROW   = NROW - 1
      NORTHO = NORTHO - 1
      IF (NROW .EQ. 0) GO TO 450
  180 CONTINUE
      NFOUND = NZERO + NROW
      IF (NROW .EQ. MSAVE) WRITE (NOUT,720) UIM,MSAVE
      IF (IDIAG.EQ.0 .OR. NROW.EQ.MSAVE) GO TO 200
C
C     PRINT OUT SUMMARY WITH REJECTED SOLUTIONS DELETED
C
      WRITE (NOUT,670) JREG,NOREG,ALAM
      WRITE (NOUT,730)
      WRITE (NOUT,690)
      M  = 0
      DO 190 I = 1,MSAVE
      K  = KK + I
      I2 = LL + IZ(K)
      IF (.NOT.LZ(I2)) GO TO 190
      M  = M + 1
      IZZ= 2*IZ(K) - 1
      J  = JJ  + I
      L  = LLL + IZZ
      L1 = L   + 1
      I1 = IHL1+ IZ(K)
      WRITE (NOUT,700) M,IZ(K),Z(J),Z(L),Z(L1),Z(I1),ACCEPT
  190 CONTINUE
  200 M = MSAVE - NROW
      IF (M .GT. 0) WRITE (NOUT,740) UIM,NROW,M
C
C     WRITE EIGENVALUES TO OUTPUT FILE
C
      CALL GOPEN (ILAM(1),Z(IBUF1),WRT)
      DO 210 I = 1,MSAVE
      K  = KK + I
      I2 = LL + IZ(K)
      IF (.NOT.LZ(I2)) GO TO 210
      IZZ = 2*IZ(K) - 1
      L   = LLL + IZZ
      LAM1(1) = DBLE(Z(L  ))
      LAM1(2) = DBLE(Z(L+1))
      CALL WRITE (ILAM(1),LAM1(1),4,1)
  210 CONTINUE
      CALL CLOSE (ILAM(1),EOFNRW)
      IF (JREG.LT.NOREG .AND. NFOUND.LT.NORD) GO TO 214
      IF (NZERO .EQ. 0) GO TO 214
C
C     IF THIS IS THE FINAL (BUT NOT THE FIRST) NEIGHBORHOOD, THEN
C     RE-WRITE THE EIGENVECTOR FILE PERTAINING TO ALL PRIOR
C     NEIGHBORHOODS (ELIMINATE LEFT-HAND VECTORS)
C
  209 IF (IDIAG .NE. 0) WRITE (NOUT,810) NZERO,NORTHO
      INIDUM = ISCR(10)
      CALL OPEN  (*455,ISCR(10),Z(IBUF2),WRTREW)
      CALL CLOSE (ISCR(10),REW)
      J = NORD2
      IF (NO B) J = 2*J
      INIDUM = IPHI(1)
      CALL OPEN (*455,IPHI(1),Z(IBUF1),0)
      DO 212 I = 1,NZERO
      CALL READ (*460,*211,IPHI(1),Z(IV2),NORD8+10,0,N3)
      GO TO 470
  211 CALL GOPEN (ISCR(10),Z(IBUF2),WRT)
      CALL WRITE (ISCR(10),Z(IV2),J,1)
  212 CALL CLOSE (ISCR(10),NOREW)
      CALL CLOSE (IPHI(1),NOREW)
      CALL OPEN  (*455,IPHI(1),Z(IBUF1),WRTREW)
      CALL CLOSE (IPHI(1),REW)
      INIDUM = ISCR(10)
      CALL OPEN  (*455,ISCR(10),Z(IBUF2),0)
      DO 213 I = 1,NZERO
      CALL READ  (*460,*206,ISCR(10),Z(IV2),J+10,0,N3)
      GO TO 470
  206 CALL GOPEN (IPHI(1),Z(IBUF1),WRT)
      CALL WRITE (IPHI(1),Z(IV2),J,1)
  213 CALL CLOSE (IPHI(1),EOFNRW)
      CALL CLOSE (ISCR(10),NOREW)
      IF(NSWP(2) .LT. 0) GO TO 500
C
C     RECOVER PHYSICAL EIGENVECTORS, PRINT, AND WRITE TO OUTPUT FILE
C
  214 IPRC = IPREC + 2
      II   = 1
      NN   = NORD2
      INCR = 1
      IA1  = IA - 1
      IF (QPR) WRITE (NOUT,750)
      ISHFT = NORD2*IPREC
      I1  = 0
C
C     ENTER LOOP
C
      DO 300 I = 1,MSAVE
      K  = KK + I
      I2 = LL + IZ(K)
      IF (.NOT. LZ(I2)) GO TO 300
      CALL GOPEN (ISCR(7),Z(IBUF2),RDREW)
      IF (NZERO .GT. 0) CALL SKPREC (ISCR(7),NZERO)
      DO 215 J = 1,NORD8
      M = IV1X + J
  215 Z(M) = 0.
C
C     SET POINTER TO ALLMAT OUTPUT VECTOR
C
      IB = IA1 + 2*MSAVE*(IZ(K)-1)
C
C     CYCLE THRU ALL ORTHOGONAL VECTORS
C
      DO 225 J = 1,MSAVE
C
C     NOTE.... Z(IV2) MAY BE LOADED DOUBLE-PRECISION....HIGHER DIGITS
C              ARE NOT USED
C     (HIGHER DIGITS MUST BE INCLUDED FOR THE D.P.MACHINES.  G.C/UNISYS)
C
      CALL UNPACK (*225,ISCR(7),Z(IV2))
      KR = IB + 2*J - 1
      KI = KR + 1
      DO 220 MM = 1,NORD2,2
      MR = IV2 + (MM-1)*IPREC
      MI = MR  + IPREC
      JR = IV1X+ MM
      JI = JR  + 1
      IF (.NOT.DPMACH) GO TO 216
      MRD = (MR+1)/2
      MID = MRD + 1
C
C     RECOVER RIGHT-HAND PHYSICAL EIGENVECTOR
C
      Z(JR) = Z(JR) + DZ(MRD)*Z(KR) - DZ(MID)*Z(KI)
      Z(JI) = Z(JI) + DZ(MID)*Z(KR) + DZ(MRD)*Z(KI)
      GO TO 217
  216 Z(JR) = Z(JR) + Z(MR)*Z(KR) - Z(MI)*Z(KI)
      Z(JI) = Z(JI) + Z(MI)*Z(KR) + Z(MR)*Z(KI)
  217 MR = MR + ISHFT
      MI = MR + IPREC
      JR = JR + NORD4
      JI = JR + 1
      IF (.NOT.DPMACH) GO TO 218
      MRD = (MR+1)/2
      MID = MRD + 1
C
C     RECOVER LEFT-HAND PHYSICAL EIGENVECTOR
C
      Z(JR) = Z(JR) + DZ(MRD)*Z(KR) - DZ(MID)*Z(KI)
      Z(JI) = Z(JI) + DZ(MID)*Z(KR) + DZ(MRD)*Z(KI)
      GO TO 220
  218 Z(JR) = Z(JR) + Z(MR)*Z(KR) - Z(MI)*Z(KI)
      Z(JI) = Z(JI) + Z(MI)*Z(KR) + Z(MR)*Z(KI)
  220 CONTINUE
  225 CONTINUE
      CALL CLOSE (ISCR(7),EOFNRW)
      IF (.NOT.QPR) GO TO 230
      I1  = I1 + 1
      IZZ = 2*IZ(K) - 1
      L   = LLL  + IZZ
      MM  = IV1X + NORD8
      WRITE (NOUT,760) I1,IZ(K),Z(L),Z(L+1),(Z(J),J=IV1,MM)
      WRITE (NOUT,770)
C
C     EXPAND PHYSICAL EIGENVECTORS TO DOUBLE PRECISION FOR OUTPUT
C
  230 LIM1 = IV1  + NORD2
      LIM2 = LIM1 + NORD4
      INIDUM = IV1X + NORD4
      DO 240 J = 1,NORD2
      KI  = LIM1 - J
      MI  = 2*KI - IV1X
      MR  = MI - 1
      MRD = (MR+1)/2
C
C     EXPAND RIGHT-HAND VECTOR
C
      Z(MI) = 0.
      Z(MR) = Z(KI)
      IF (DPMACH) DZ(MRD) = Z(KI)
      KI  = LIM2 - J
      MI  = 2*KI - INIDUM
      MR  = MI - 1
      MRD = (MR+1)/2
C
C     EXPAND LEFT -HAND VECTOR
C
      Z(MI) = 0.
      Z(MR) = Z(KI)
      IF (DPMACH) DZ(MRD) = Z(KI)
  240 CONTINUE
      IF (.NOT.QPR) GO TO 250
      WRITE (NOUT,770)
      LIM1 = IV1X + NORD4
      WRITE (NOUT,780) (Z(J),J=IV1,LIM1)
      WRITE (NOUT,770)
      LIM2 = LIM1 + NORD4
      LIM1 = LIM1 + 1
      WRITE (NOUT,780) (Z(J),J=LIM1,LIM2)
      WRITE (NOUT,770)
C
C     PERFORM SPECIAL NORMALIZATION OF VECTORS FOR OUTPUT
C
  250 CALL CNORM1 (Z(IV1),IKMB(2))
      IF (QPR) WRITE (NOUT,790)
      INIDUM = INIDUM + 1
      CALL CNORM1 (Z(INIDUM),IKMB(2))
      IF (QPR) WRITE (NOUT,790)
      CALL GOPEN (IPHI(1),Z(IBUF1),WRT)
      IF (JREG.LT.NOREG .AND. NFOUND.LT.NORD) GO TO 260
      J = NORD2
      IF (NO B) J = 2*J
      CALL WRITE (IPHI(1),Z(IV1),J,1)
      CALL CLOSE (IPHI(1),EOFNRW)
      GO TO 300
C
C     MUST USE NORD8 TO WRITE FULL RIGHT AND LEFT EIGENVECTORS
C
  260 CALL WRITE (IPHI(1),Z(IV1),NORD8,1)
      CALL CLOSE (IPHI(1),NOREW)
  300 CONTINUE
      GO TO 500
  420 WRITE (NOUT,530) NAME
      GO TO 500
  430 WRITE (NOUT,540) M,NAME
      GO TO 500
  440 WRITE (NOUT,580) UWM
      IF(NZERO.GT.0 .AND. JREG.EQ.NOREG) NSWP(2) = -1
      GO TO 500
  450 WRITE (NOUT,710) UWM,MSAVE
      GO TO 500
  455 CALL MESAGE (-1,INIDUM,NAME)
  460 CALL MESAGE (-2,INIDUM,NAME)
  470 CALL MESAGE (-8,INIDUM,NAME)
  500 RETURN
C
  530 FORMAT (27H UNEXPECTED EOF ENCOUNTERED,2X,2A4)
  540 FORMAT (22H UNEXPECTED WORD COUNT,I5,2X,2A4)
  550 FORMAT (A29,' 3152', //5X,'SUBROUTINE ALLMAT OUTPUT EIGENVALUE',
     1       I4,' IS NULL.',//)
  560 FORMAT (A25,' 3153', //5X,'ATTEMPT TO NORMALIZE NULL VECTOR IN ',
     1       'SUBROUTINE ',A4,A2,'. NO ACTION TAKEN.',//)
  570 FORMAT (A25,' 3154', //5X,'SIZE OF REDUCED PROBLEM DECREMENTED ',
     1       'ONCE (NOW',I6,') DUE TO NULL ERROR ELEMENT.',//)
  580 FORMAT (A25,' 3155', //5X,'REDUCED PROBLEM HAS VANISHED. NO ',
     1       'ROOTS FOUND.',//)
  590 FORMAT (A25,' 3156', //5X,'SIZE OF REDUCED PROBLEM RESTORED TO',
     1       I8,' BECAUSE NEXT ERROR ELEMENT WAS ALSO NULL.', /5X,
     3       'ERROR ELEMENT SET = ',2E16.8,//)
  600 FORMAT (1H0,//7H CFEER4,//)
  610 FORMAT (1H ,I10,36H SINGLE PRECISION WORDS OF OPEN CORE,
     1       29H NOT USED (SUBROUTINE CFEER4))
  620 FORMAT (4H ROW,I5,2(4X,2E16.8))
  630 FORMAT (4H ROW,I5,2(4X,2D16.8))
  640 FORMAT (1H0,26HREDUCED TRIDIAGONAL MATRIX, /(1H ,6E16.8))
  650 FORMAT (1H0,//30H THEORETICAL EIGENVALUE ERRORS,
     1       20X,18HD-SUB-M-PLUS-ONE =,2E16.8,/)
  660 FORMAT (1H ,I5,E16.8,20X,2E16.8,10X,E16.8)
  670 FORMAT (1H1,27X,39H*****  F E E R  *****  (FAST EIGENVALUE,
     1       27H EXTRACTION ROUTINE)  *****, //4X,
     2       24HSUMMARY FOR NEIGHBORHOOD,I3,3H OF,I3,1H.,10X,
     3       21HNEIGHBORHOOD CENTER =,2E16.8,/)
  680 FORMAT (4X,43HALL SOLUTIONS FOUND IN CURRENT NEIGHBORHOOD,
     1       12H ARE LISTED.,/)
  690 FORMAT (4X,7X,8HSOLUTION,7X,8HORDER OF,7X,8HDISTANCE,
     1       10X,10HEIGENVALUE,14X,11HTHEORETICAL, /4X,
     2       9X,6HNUMBER,5X,10HEXTRACTION,4X,11HFROM CENTER,
     3       6X,4HREAL,9X,9HIMAGINARY,9X,5HERROR,12X,6HSTATUS,/)
  700 FORMAT (4X,I12,I15,1P,E18.8,1P,3E15.7,7X,2A4)
  710 FORMAT (A25,' 3163', //5X,'ALL',I6,' SOLUTIONS HAVE FAILED ',
     1       'ACCURACY TEST. NO ROOTS FOUND.',//)
  720 FORMAT (A29,' 3164',//5X,'ALL',I6,' SOLUTIONS ARE ACCEPTABLE.',//)
  730 FORMAT (4X,37HREJECTED SOLUTIONS HAVE BEEN DELETED.,/)
  740 FORMAT (A29,' 3165', //4X,I6,' SOLUTIONS HAVE BEEN ACCEPTED AND',
     1       I4,' SOLUTIONS HAVE BEEN REJECTED.',//)
  750 FORMAT (1H1,27X,39H*****  F E E R  *****  (FAST EIGENVALUE,
     1       27H EXTRACTION ROUTINE)  *****,//
     2       42X,37HE I G E N V E C T O R   S U M M A R Y,//1H ,
     3       32(4H----),2H--)
  760 FORMAT (1H ,8HSOLUTION,I4,8X,16HEXTRACTION ORDER,I4,
     1       10X,10HEIGENVALUE,2X,1P,2E16.8, /(1H ,3(4X,1P,2E16.8)))
  770 FORMAT (3H --,32(4H----))
  780 FORMAT ((1H ,3(3X,2E16.8)))
  790 FORMAT (1H  ,12HAFTER CNORM1)
  800 FORMAT (1H  ,10X,5HRMS =,E16.8)
  810 FORMAT (1H  ,33HLEFT-HAND EIGENVECTORS ELIMINATED,20X,2I8)
      END

      SUBROUTINE OFP1A (LINE)
C
C     THIS ROUTINE WAS NAMED OFP1 BEFORE.
C
      INTEGER         L123(5),ID(50),OF(6)
      REAL            FID(50),RT(8,15),SECTN(2)
      COMMON /SYSTEM/ KSYS(80)
      COMMON /ZZZZZZ/ CORE(1)
      COMMON /OFP1ID/ ID22,M
      EQUIVALENCE     (KSYS(2),L), (KSYS(12),LINET), (KSYS(33),IFLAG),
     1                (KSYS(3),NOGO), (CORE(1),OF(1),L123(1)),
     2                (FID(1) ,ID(1), OF(6))
C
      DATA   RT/
     1 4HSING, 4HULAR, 4HITIE, 4HS EN, 4HCOUN, 4HTERE, 4HD.  , 4H    ,
     2 4H4 SH, 4HIFT , 4HPTS., 4HPER , 4HROOT, 4H EXC, 4HEEDE, 4HD.  ,
     3 4HALL , 4HEIGE, 4HNVAL, 4HUES , 4HFOUN, 4HD IN, 4H RAN, 4HGE. ,
     4 4H3X E, 4HST.R, 4HOOTS, 4H IN , 4HRANG, 4HE SP, 4HECIF, 4HIED.,
     5 4HNO M, 4HORE , 4HEIGE, 4HNVAL, 4HUES , 4HIN P, 4HROBL, 4HEM. ,
     6 4HNO. , 4HOF R, 4HOOTS, 4H DES, 4HIRED, 4H WER, 4HE FO, 4HUND.,
     7 4H1 OR, 4H MOR, 4HE RO, 4HOT O, 4HUTSI, 4HDE F, 4HR.RA, 4HNGE.,
     8 4HINSU, 4HFFIC, 4HIENT, 4H TIM, 4HE FO, 4HR NE, 4HXT R, 4HOOT.,
     9 4HUNAB, 4HLE T, 4HO CO, 4HNVER, 4HGE. , 4H    , 4H    , 4H    ,
     O 4HNORM, 4HAL T, 4HERMI, 4HNATI, 4HON  , 4H    , 4H    , 4H    ,
     1 4HEIGE, 4HNVAL, 4HUES , 4HOUTS, 4HIDE , 4HFREQ, 4H. RA, 4HNGE ,
     2 4HINSU, 4HFFIC, 4HIENT, 4H TIM, 4HE RE, 4HMAIN, 4HING , 4H    ,
     3 4HFEWE, 4HR TH, 4HAN R, 4HEQUE, 4HSTED, 4H ROO, 4HTS F, 4HOUND,
     4 4HROOT, 4HS FO, 4HUND , 4HWITH, 4H REQ, 4H. AC, 4HCURA, 4HCY  ,
     5 4HNO R, 4HOOTS ,4H FOU, 4HND, , 4HNONE, 4H PAS, 4HSED , 4HTEST/
      DATA     SECTN / 4H.3.3, 4H.7.3  /     , TWOPI /6.283185307    /
C
      LOCAL = LINE - 100
      IF (LOCAL) 2003,2003,2004
 2003 GO TO (1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,
     1 23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,
     2 44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,
     3 65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,
     4 86,87,88,89,90,91,92,93,94,95,96,97,98,99,100), LINE
 2004 GO TO (  101,102,103,104,105,106,107,108,109,110,111,112,113,114,
     1 115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,
     2 131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,
     3 147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,
     4 163,164,165,166,167,168,169,170,171,172,173,174), LOCAL
C
    1 WRITE (L,501)
      GO TO 1000
    2 WRITE (L,502)
      GO TO 1000
    3 WRITE (L,503)
      GO TO 1000
    4 WRITE (L,504)
      GO TO 1000
    5 WRITE (L,505)
      IF (ID22 .EQ. -999) GO TO 1000
      IF (ID22) 2053,2052,2051
 2051 WRITE (L,5050)
      WRITE (L,5051) ID22
      GO TO 2054
 2052 IF (.NOT.((M.GE.3 .AND. M.LE.7) .OR. M.EQ.10 .OR. M.EQ.13))
     1   GO TO 1000
      WRITE (L,5050)
      WRITE (L,5052)
      GO TO 2054
 2053 IF (M.NE.8 .AND. M.NE.12) GO TO 1000
      WRITE (L,5050)
      WRITE (L,5053)
 2054 WRITE (L,5054)
      LINET = LINET + 10
      ID22  =-999
      GO TO 1000
    6 WRITE (L,506) ID(5)
      GO TO 1000
    7 WRITE (L,507)
      GO TO 1000
    8 WRITE (L,508)
      GO TO 1000
    9 WRITE (L,509)
      GO TO 1000
   10 WRITE (L,510)
      GO TO 1000
   11 WRITE (L,511)
      GO TO 1000
   12 WRITE (L,512)
      GO TO 1000
   13 WRITE (L,513)
      GO TO 1000
   14 WRITE (L,514)
      GO TO 1000
   15 WRITE (L,515)
      GO TO 1000
   16 WRITE (L,516)
      GO TO 1000
   17 WRITE (L,517)
      GO TO 1000
   18 WRITE (L,518)
      GO TO 1000
   19 WRITE (L,519)
      GO TO 1000
   20 WRITE (L,520)
      GO TO 1000
   21 WRITE (L,521)
      GO TO 1000
   22 WRITE (L,522)
      GO TO 1000
   23 WRITE (L,523)
      GO TO 1000
   24 WRITE (L,524)
      GO TO 1000
   25 WRITE (L,525)
      GO TO 1000
   26 WRITE (L,526)
      GO TO 1000
   27 WRITE (L,527)
      GO TO 1000
   28 WRITE (L,528)
      GO TO 1000
   29 WRITE (L,529)
      GO TO 1000
C
C     PROCESS SPC AND MPC SET IDS PROPERLY TO ACCOUNT FOR AXISYMMETRIC
C     PROBLEMS
C
   30 DO 3010 J = 3,4
      IF (ID(J) .LT.  100000000) GO TO 3010
      ID(J) = ID(J) - 100000000
      IF (ID(J) .LT.  100000000) GO TO 3010
      ID(J) = ID(J) - 100000000
 3010 CONTINUE
      WRITE (L,530) ID(3),ID(4)
      LINET = LINET + 1
      GO TO 1000
   31 WRITE (L,531)
      GO TO 1000
   32 WRITE (L,532)
      GO TO 1000
   33 WRITE (L,533)
      GO TO 1000
   34 WRITE (L,534)
      GO TO 1000
   35 WRITE (L,535)
      GO TO 1000
   36 WRITE (L,536)
      GO TO 1000
   37 WRITE (L,537)
      GO TO 1000
   38 WRITE (L,538)
      GO TO 1000
   39 WRITE (L,539)
      GO TO 1000
   40 WRITE (L,540)
      GO TO 1000
   41 WRITE (L,541)
      GO TO 1000
   42 WRITE (L,542)
      GO TO 1000
   43 WRITE (L,543)
      GO TO 1000
   44 WRITE (L,544)
      GO TO 1000
   45 WRITE (L,545)
      GO TO 1000
   46 WRITE (L,546)
      GO TO 1000
   47 WRITE (L,547)
      GO TO 1000
   48 WRITE (L,548)
      GO TO 1000
   49 WRITE (L,549)
      GO TO 1000
   50 WRITE (L,550)
      GO TO 1000
   51 WRITE (L,551)
      GO TO 1000
   52 WRITE (L,552)
      GO TO 1000
   53 WRITE (L,553)
      GO TO 1000
   54 WRITE (L,554)
      GO TO 1000
   55 WRITE (L,555)
      GO TO 1000
   56 WRITE (L,556)
      GO TO 1000
   57 WRITE (L,557)
      GO TO 1000
   58 WRITE (L,558)
      GO TO 1000
   59 WRITE (L,559)
      GO TO 1000
   60 WRITE (L,560)
      GO TO 1000
   61 WRITE (L,561)
      GO TO 1000
   62 WRITE (L,562)
      GO TO 1000
   63 WRITE (L,563)
      GO TO 1000
   64 WRITE (L,564)
      GO TO 1000
   65 WRITE (L,565)
      GO TO 1000
   66 WRITE (L,566)
      GO TO 1000
   67 WRITE (L,567)
      GO TO 1000
   68 WRITE (L,568)
      GO TO 1000
   69 WRITE (L,569)
      GO TO 1000
   70 WRITE (L,570)
      GO TO 1000
   71 WRITE (L,571)
      GO TO 1000
   72 WRITE (L,572)
      GO TO 1000
   73 WRITE (L,573)
      GO TO 1000
   74 WRITE (L,574)
      GO TO 1000
   75 WRITE (L,575)
      GO TO 1000
   76 WRITE (L,576)
      GO TO 1000
   77 WRITE (L,577)
      GO TO 1000
   78 WRITE (L,578)
      GO TO 1000
   79 WRITE (L,579)
      GO TO 1000
   80 WRITE (L,580)
      GO TO 1000
   81 WRITE (L,581)
      GO TO 1000
   82 WRITE (L,582)
      GO TO 1000
   83 WRITE (L,583)
      GO TO 1000
   84 WRITE (L,584)
      GO TO 1000
   85 WRITE (L,585)
      GO TO 1000
   86 WRITE (L,586)
      GO TO 1000
   87 WRITE (L,587)
      GO TO 1000
   88 WRITE (L,588)
      GO TO 1000
   89 WRITE (L,589)
      GO TO 1000
   90 IF (ID(16) .EQ. 1) GO TO 905
      WRITE (L,590)
      GO TO 1000
  905 WRITE (L,5905)
      GO TO 1000
   91 WRITE (L,591) (ID(K),K=11,15),ID(17),FID(18),(ID(K),K=19,21)
      M = ID(17)
      IF (M .GE. 8) NOGO = 14
      IF (ID(16) .NE. 1) GO TO 911
      IF (M.EQ.2 .OR. M.GT.3) NOGO = 14
      IF (M .EQ. 0) M = 10
      IF (M .EQ. 1) M = 13
      IF (M .EQ. 3) M = 14
  911 IF (M .GT. 0) WRITE (L,5911) (RT(K,M),K=1,8),SECTN(1)
      ID22 = ID(22)
      GO TO 1000
   92 WRITE (L,592)
      GO TO 1000
   93 WRITE (L,593) (ID(K),K=11,17),FID(18),(ID(K),K=19,21)
      M = ID(17)
  933 IF (M .GE. 3) NOGO = 14
      IF (M .EQ. 1) M = 6
      IF (M .EQ. 2) M = 11
      IF (M .EQ. 3) M = 8
      IF (M .EQ. 4) M = 1
      GO TO 911
   94 WRITE (L,594)
      GO TO 1000
   95 WRITE (L,595)
      GO TO 1000
   96 WRITE (L,596)
      SECTN(1) = SECTN(2)
      GO TO 1000
   97 WRITE (L,597)
      GO TO 1000
   98 WRITE (L,598) (ID(K),K=11,18)
      M = ID(18)
      GO TO 933
   99 IF (ID(3) .EQ. 4) GO TO 1007
      WRITE (L,599) (ID(K),K=11,16)
      M = ID(16)
      IF (ID(17) .NE. 1) GO TO 911
      IF (M .GT. 2) NOGO = 14
      IF (M .EQ. 0) M = 10
      IF (M .EQ. 1) M = 13
      IF (M .EQ. 2) M = 15
      GO TO 911
C
C     ID(3)=2, ID(17)=0, METHOD IS COMPLEX INV
C     ID(3)=2, ID(17)=1, METHOD IS COMPLEX FEER
C     ID(3)=4, ID(17)=0, METHOD IS COMPLEX HESS
C
  100 SECTN(1) = SECTN(2)
      IF (ID(17) .EQ. 1) GO TO 1005
      IF (ID( 3) .EQ. 4) GO TO 1006
      WRITE (L,600)
      GO TO 1000
 1005 WRITE (L,6005)
      GO TO 1000
 1006 WRITE (L,6006)
      GO TO 1000
 1007 WRITE (L,6007) ID(11),ID(12),ID(18)
      M = ID(18)
      GO TO 933
  101 F = SQRT(ABS(FID(6)))/TWOPI
      WRITE (L,601) FID(6),F
      LINET = LINET + 1
      GO TO 1000
  102 F = SQRT(ABS(FID(6)))/TWOPI
      WRITE (L,602) FID(6),F
      LINET = LINET + 1
      GO TO 1000
  103 WRITE (L,603) FID(5)
      GO TO 1000
  104 CONTINUE
      WRITE (L,604) FID(5)
      GO TO 1000
  105 WRITE (L,605) FID(5)
      GO TO 1000
  106 CONTINUE
      WRITE (L,606) FID(5)
      GO TO 1000
  107 WRITE (L,607) ID(5)
      GO TO 1000
  108 WRITE (L,608) ID(5)
      GO TO 1000
  109 CYCFRQ = ABS(FID(7)) / TWOPI
      WRITE (L,609) FID(6),FID(7),CYCFRQ
      GO TO 1000
  110 CONTINUE
      CYCFRQ = ABS(FID(7)) / TWOPI
      WRITE (L,610) FID(6),FID(7),CYCFRQ
      GO TO 1000
  111 WRITE (L,611)
      GO TO 1000
  112 WRITE (L,612)
      GO TO 1000
  113 WRITE (L,613)
      GO TO 1000
  114 WRITE (L,614)
      GO TO 1000
  115 WRITE (L,615)
      GO TO 1000
  116 WRITE (L,616)
      GO TO 1000
  117 WRITE (L,617)
      GO TO 1000
  118 WRITE (L,618)
      GO TO 1000
  119 WRITE (L,619)
      GO TO 1000
  120 WRITE (L,620)
      GO TO 1000
  121 WRITE (L,621)
      GO TO 1000
  122 WRITE (L,622)
      GO TO 1000
  123 WRITE (L,623)
      GO TO 1000
  124 WRITE (L,624) ID(5)
      GO TO 1000
  125 WRITE (L,625)
      GO TO 1000
  126 WRITE (L,626)
      GO TO 1000
  127 WRITE (L,627)
      GO TO 1000
  128 WRITE (L,628)
      GO TO 1000
  129 WRITE (L,629)
      GO TO 1000
  130 WRITE (L,630)
      GO TO 1000
  131 WRITE (L,631)
      GO TO 1000
  132 WRITE (L,632)
      GO TO 1000
  133 WRITE (L,633)
      GO TO 1000
  134 WRITE (L,634)
      GO TO 1000
  135 WRITE (L,635)
      GO TO 1000
  136 WRITE (L,636)
      GO TO 1000
  137 WRITE (L,637)
      GO TO 1000
  138 WRITE (L,638)
      GO TO 1000
  139 WRITE (L,639)
      GO TO 1000
  140 WRITE (L,640)
      GO TO 1000
  141 CONTINUE
      GO TO 1000
  142 WRITE (L,642)
      GO TO 1000
  143 WRITE (L,643)
      GO TO 1000
  144 WRITE (L,644)
      GO TO 1000
  145 WRITE (L,645)
      GO TO 1000
  146 WRITE (L,646)
      GO TO 1000
  147 CONTINUE
      GO TO 1000
  148 WRITE (L,648)
      GO TO 1000
  149 WRITE (L,649)
      GO TO 1000
  150 WRITE (L,650)
      GO TO 1000
  151 WRITE (L,651)
      GO TO 1000
  152 WRITE (L,652)
      GO TO 1000
  153 WRITE (L,653)
      GO TO 1000
  154 WRITE (L,654)
      GO TO 1000
  155 WRITE (L,655)
      GO TO 1000
  156 WRITE (L,656)
      GO TO 1000
  157 WRITE (L,657)
      GO TO 1000
  158 WRITE (L,658)
      GO TO 1000
  159 WRITE (L,659)
      GO TO 1000
  160 WRITE (L,660)
      GO TO 1000
  161 WRITE (L,661)
      GO TO 1000
  162 WRITE (L,662)
      GO TO 1000
  163 WRITE (L,663)
      GO TO 1000
  164 WRITE (L,664)
      GO TO 1000
  165 WRITE (L,665)
      GO TO 1000
  166 WRITE (L,666)
      GO TO 1000
  167 WRITE (L,667)
      GO TO 1000
  168 WRITE (L,668)
      GO TO 1000
  169 WRITE (L,669)
      GO TO 1000
  170 WRITE (L,670)
      GO TO 1000
  171 WRITE (L,671)
      GO TO 1000
  172 WRITE (L,672)
      GO TO 1000
  173 WRITE (L,673)
      GO TO 1000
  174 WRITE (L,674)
 1000 CONTINUE
      RETURN
C
C
  501 FORMAT (45X,37HD I S P L A C E M E N T   V E C T O R)
  502 FORMAT (6X,16HPOINT ID.   TYPE,10X,2HT1,13X,2HT2,13X,2HT3,13X,
     1       2HR1,13X,2HR2,13X,2HR3)
  503 FORMAT (46X, 31HR E A L   E I G E N V A L U E S,/)
  504 FORMAT (3X, 4HMODE, 4X, 10HEXTRACTION, 7X, 10HEIGENVALUE, 12X,
     1       6HRADIAN, 14X, 6HCYCLIC, 2X, 2(9X, 11HGENERALIZED))
  505 FORMAT (4X,3HNO., 7X, 5HORDER, 30X, 9HFREQUENCY, 11X, 9HFREQUENCY,
     1       12X,4HMASS, 14X, 9HSTIFFNESS,/)
 5050 FORMAT (/37X,16(4H****), /37X,1H*,62X,1H*, /37X,1H*)
 5051 FORMAT (1H+,45X,'NASTRAN INFORMATION MESSAGE 3307, POTENTIALLY',
     1       9X,1H*, /37X,1H*,I10,' EIGENVALUE(S) AT LOW FREQ. END NOT',
     2       ' FOUND',11X,1H*)
 5052 FORMAT (1H+,39X,'NASTRAN INFORMATION MESSAGE 3308, LOWEST EIGEN',
     1       'VALUE FOUND',3X,1H*, /37X,1H*,2X,'AS INDICATED BY THE ',
     2       'STURM''S SEQUENCE OF THE DYNAMIC MATRIX',2X,1H*)
 5053 FORMAT (1H+,42X,'NASTRAN WARNING MESSAGE 3309, ALL LOWER EIGEN',
     1       'VALUES',6X,1H*, /37X,1H*, 5X,'NOT NECESSARY FOUND.',37X,
     2       1H*)
 5054 FORMAT (37X,1H*,62X,1H*, /37X,1H*,8X,
     1       43H(THIS MESSAGE CAN BE SUPPRESSED BY DIAG 37),11X,1H*,
     1       /37X,16(4H****),/)
  506 FORMAT (41X,39HR E A L   E I G E N V E C T O R   N O .,I11)
  507 FORMAT (7X,7HELEMENT,11X,5HAXIAL,37X,7HELEMENT,11X,5HAXIAL)
  508 FORMAT (9X,3HID.,13X,5HFORCE,10X,6HTORQUE,23X,3HID.,13X,5HFORCE,
     1       10X,6HTORQUE)
  509 FORMAT (12H0    ELEMENT,9X,17HBEND-MOMENT END-A,12X,17HBEND-MOMENT
     1 END-B,16X,9H- SHEAR -,15X,5HAXIAL)
  510 FORMAT (4X,9H   ID.   ,3(6X,7HPLANE 1,7X,7HPLANE 2,2X),7X,5HFORCE,
     1       9X,6HTORQUE)
  511 FORMAT (7X,7HELEMENT,11X,5HFORCE,10X,5HFORCE,22X,7HELEMENT,11X,
     1       5HFORCE,10X,5HFORCE)
  512 FORMAT (9X,3HID.,12X,7HPTS 1,3,8X,7HPTS 2,4,23X,3HID.,12X,
     1       7HPTS 1,3,8X,7HPTS 2,4)
  513 FORMAT (7X,7HELEMENT,10X,6HMOMENT,9X,6HMOMENT,22X,7HELEMENT,10X,
     1       6HMOMENT,9X,6HMOMENT)
  514 FORMAT (1H0,8X,7HELEMENT,2(11X,11HBEND-MOMENT),10X,12HTWIST-MOMENT
     1,      2(13X,5HSHEAR,4X))
  515 FORMAT (11X,3HID.,17X,1HX,21X,1HY,43X,1HX,21X,1HY)
  516 FORMAT (6X,3(7HELEMENT,9X,5HFORCE,12X),7HELEMENT,9X,5HFORCE)
  517 FORMAT (8X,3(3HID.,30X),3HID.)
  518 FORMAT (2(7X,7HELEMENT,7X,5HAXIAL,7X,6HSAFETY,6X,9HTORSIONAL,5X,
     1       6HSAFETY))
  519 FORMAT (2(9X,3HID.,8X,6HSTRESS,7X,6HMARGIN,8X,6HSTRESS,6X,
     1       6HMARGIN))
  520 FORMAT (2X,7HELEMENT,8X,3HSA1,12X,3HSA2,12X,3HSA3,15X,1HS,14X,
     1       6HSA-MAX,9X,6HSA-MIN,11X,6HM.S.-T)
  521 FORMAT (4X,3HID.,10X,3HSB1,12X,3HSB2,12X,3HSB3,30X,6HSB-MAX,9X,
     1       6HSB-MIN,11X,6HM.S.-C)
  522 FORMAT (2(9X,7HELEMENT,12X,3HMAX,12X,3HAVG,8X,6HSAFETY))
  523 FORMAT (2(11X,3HID.,13X,5HSHEAR,10X,5HSHEAR,7X,6HMARGIN))
  524 FORMAT (2(11X,3HID.,40X,6HMARGIN))
  525 FORMAT (2X,7HELEMENT,11X,32HSTRESSES IN ELEMENT COORD SYSTEM,12X,
     1       9HPRINCIPAL,11X,18HPRINCIPAL STRESSES,12X,3HMAX)
  526 FORMAT (4X,3HID.,11X,8HNORMAL-X,7X,8HNORMAL-Y,7X,8HSHEAR-XY,6X,
     1       12HSTRESS ANGLE,9X,5HMAJOR,10X,5HMINOR,10X,5HSHEAR)
  527 FORMAT (2X,7HELEMENT,6X,5HFIBRE,15X,'STRESSES IN ELEMENT COORD ',
     1       'SYSTEM',13X,'PRINCIPAL STRESSES (ZERO SHEAR)',12X,3HMAX)
  528 FORMAT (4X,3HID.,7X,8HDISTANCE,11X,8HNORMAL-X,7X,8HNORMAL-Y,6X,
     1       8HSHEAR-XY,7X,5HANGLE,9X,5HMAJOR,11X,5HMINOR,10X,5HSHEAR)
  529 FORMAT (6X,3(7HELEMENT,9X,6HSTRESS,11X),7HELEMENT,9X,6HSTRESS)
  530 FORMAT (30X,'G R I D   P O I N T   S I N G U L A R I T Y   ',
     1       'T A B L E',6X,3HSPC,I9,3X,3HMPC,I9)
  531 FORMAT (8X,5HPOINT,10X,11HSINGULARITY,18X,'LIST OF COORDINATE ',
     1       'COMBINATIONS THAT WILL REMOVE SINGULARITY')
  532 FORMAT (9X,3HID.,3X,4HTYPE,7X,5HORDER,7X,21HSTRONGEST COMBINATION,
     1       15X,18HWEAKER COMBINATION,17X,19HWEAKEST COMBINATION)
  533 FORMAT (53X,21HL O A D   V E C T O R)
  534 FORMAT (2X,7HELEMENT,8X,3HSA1,12X,3HSA2,12X,3HSA3,12X,3HSA4,11X,
     1       5HAXIAL,10X,6HSA-MAX,9X,17HSA-MIN     M.S.-T)
  535 FORMAT (4X,3HID.,10X,3HSB1,12X,3HSB2,12X,3HSB3,12X,3HSB4,11X,
     1       6HSTRESS,9X,6HSB-MAX,9X,17HSB-MIN     M.S.-C)
  536 FORMAT (43X,'F O R C E S   I N   R O D   E L E M E N T S',5X,
     1       '( C R O D )')
  537 FORMAT (33X,'F O R C E S   I N   B E A M   E L E M E N T S',8X,
     1       '( C B E A M )')
  538 FORMAT (27X,'F O R C E S   A C T I N G   O N   S H E A R   ',
     1       'P A N E L   E L E M E N T S   ( C S H E A R )')
  539 FORMAT (37X,'F O R C E S   I N   T W I S T   P A N E L S',6X,
     1       '( C T W I S T )')
  540 FORMAT (21X,'F O R C E S   I N   B A S I C   B E N D I N G   ',
     1       'T R I A N G L E S',7X,'( C T R B S C )')
  541 FORMAT (30X,'F O R C E S   I N   S C A L A R   S P R I N G S',8X,
     1       '( C E L A S 1 )')
  542 FORMAT (30X,'F O R C E S   I N   S C A L A R   S P R I N G S',8X,
     1       '( C E L A S 2 )')
  543 FORMAT (30X,'F O R C E S   I N   S C A L A R   S P R I N G S',8X,
     1       '( C E L A S 3 )')
  544 FORMAT (30X,'F O R C E S   I N   S C A L A R   S P R I N G S',8X,
     1       '( C E L A S 4 )')
  545 FORMAT (31X,'F O R C E S   O F   S I N G L E - P O I N T   ',
     1       'C O N S T R A I N T')
  546 FORMAT (43X,'F O R C E S   I N   R O D   E L E M E N T S',5X,
     1       '( C O N R O D )')
  547 FORMAT (33X,'F O R C E S   I N   B A R   E L E M E N T S',9X,
     1       '( C B A R )')
  548 FORMAT (17X,'F O R C E S   I N   B E N D I N G   Q U A D R I L A',
     1       ' T E R A L S',9X,'( C Q D P L T )')
  549 FORMAT (17X,'F O R C E S   I N   G E N E R A L   Q U A D R I L A',
     1       ' T E R A L   E L E M E N T S     ( C Q U A D 1 )')
  550 FORMAT (17X,'F O R C E S   I N   G E N E R A L   Q U A D R I L A',
     1       'T E R A L   E L E M E N T S     ( C Q U A D 2 )')
  551 FORMAT (21X,'F O R C E S   I N   G E N E R A L   T R I A N G U L',
     1       ' A R   E L E M E N T S',8X,'( C T R I A 1 )')
  552 FORMAT (21X,'F O R C E S   I N   G E N E R A L   T R I A N G U L',
     1       ' A R   E L E M E N T S',8X,'( C T R I A 2 )')
  553 FORMAT (27X,'F O R C E S   I N   B E N D I N G   T R I A N G L E',
     1       ' S       ( C T R P L T )')
  554 FORMAT (33X,'F O R C E S   I N   R O D   E L E M E N T S     ',
     1       '( C T U B E )')
  555 FORMAT (37X,'S T R E S S E S   I N   R O D   E L E M E N T S',6X,
     1       '( C R O D )')
  556 FORMAT (34X,'S T R E S S E S   I N   B E A M   E L E M E N T S',
     1       8X,'( C B E A M )')
  557 FORMAT (40X,'S T R E S S E S   I N   S H E A R   P A N E L S',6X,
     1       '( C S H E A R )')
  558 FORMAT (40X,'S T R E S S E S   I N   T W I S T   P A N E L S',7X,
     1       '( C T W I S T )')
  559 FORMAT (22X,'S T R E S S E S   I N   T R I A N G U L A R   ',
     1       'M E M B R A N E S      ( C T R M E M )')
  560 FORMAT (19X,'S T R E S S E S   I N   B A S I C   B E N D I N G  ',
     1       ' T R I A N G L E S',8X,'( C T R B S C )')
  561 FORMAT (30X,'S T R E S S E S   I N   S C A L A R   S P R I N G S',
     1       8X,'( C E L A S 1 )')
  562 FORMAT (30X,'S T R E S S E S   I N   S C A L A R   S P R I N G S',
     1       8X,'( C E L A S 2 )')
  563 FORMAT (30X,'S T R E S S E S   I N   S C A L A R   S P R I N G S',
     1       8X,'( C E L A S 3 )')
  564 FORMAT (33X,'S T R E S S E S   I N   B A R   E L E M E N T S',10X,
     1       '( C B A R )')
  565 FORMAT (37X,'S T R E S S E S   I N   R O D   E L E M E N T S',6X,
     1       '( C O N R O D )')
  566 FORMAT (21X,'S T R E S S E S   I N   Q U A D R I L A T E R A L  ',
     1       ' M E M B R A N E S      ( C Q D M E M )')
  567 FORMAT (18X,'S T R E S S E S   I N   B E N D I N G   Q U A D R I',
     1       ' L A T E R A L S',13X,'( C Q D P L T )')
  568 FORMAT (18X,'S T R E S S E S   I N   G E N E R A L   Q U A D R I',
     1       ' L A T E R A L   E L E M E N T S',6X,'( C Q U A D 1 )')
  569 FORMAT (18X,'S T R E S S E S   I N   G E N E R A L   Q U A D R I',
     1       ' L A T E R A L   E L E M E N T S',6X,'( C Q U A D 2 )')
  570 FORMAT (18X,'S T R E S S E S   I N   G E N E R A L   T R I A N G',
     1       ' U L A R   E L E M E N T S',7X,'( C T R I A 1 )')
  571 FORMAT (18X,'S T R E S S E S   I N   G E N E R A L   T R I A N G',
     1       ' U L A R   E L E M E N T S',7X,'( C T R I A 2 )')
  572 FORMAT (24X,'S T R E S S E S   I N   B E N D I N G   T R I A N G',
     1       ' L E S',8X,'( C T R P L T )')
  573 FORMAT (36X,'S T R E S S E S   I N   R O D   E L E M E N T S',6X,
     1       '( C T U B E )')
  574 FORMAT (20X,'S T R E S S E S   F O R   T H E   T R I A N G U L A',
     1       ' R   R I N G S',5X,'( C T R I A R G )')
  575 FORMAT (5X,3HEL ,13X,6HRADIAL,20X,15HCIRCUMFERENTIAL,20X,5HAXIAL,
     1       25X,5HSHEAR)
  576 FORMAT (5X,3HID ,15X,3H(X),25X,7H(THETA),25X,3H(Z),27X,4H(ZX))
  577 FORMAT (18X,'S T R E S S E S   F O R   T H E   T R A P E Z O I D',
     1       ' A L   R I N G S',5X,'( C T R A P R G )')
  578 FORMAT (5X,3HEL ,5X,6HSTRESS,15X,6HRADIAL,16X,15HCIRCUMFERENTIAL,
     1       16X,5HAXIAL,21X,5HSHEAR)
  579 FORMAT (5X,3HID ,6X,5HPOINT,17X,3H(X),21X,7H(THETA),21X,3H(Z),23X,
     1       4H(ZX))
  580 FORMAT (11X,'S T R E S S   R E S U L T A N T S   F O R   T H E  ',
     1       ' T O R O I D A L   R I N G S     ( C T O R D R G )')
  581 FORMAT (5X, 3HEL , 8H  STRESS, 15X, 17HMEMBRANE (FORCES), 26X,
     1       17HFLEXURE (MOMENTS), 23X, 5HSHEAR)
  582 FORMAT (5X,2HID,9H    POINT,8X,10HTANGENTIAL,10X,'CIRCUMFERENTIAL'
     1,      8X,10HTANGENTIAL,11X,15HCIRCUMFERENTIAL,10X,7H(FORCE))
  583 FORMAT (22X,'F O R C E S   F O R   T H E   T R I A N G U L A R  ',
     1       ' R I N G S     ( C T R I A R G )')
  584 FORMAT (5X,12HEL    CORNER,18X,6HRADIAL,26X,15HCIRCUMFERENTIAL,
     1       26X,5HAXIAL)
  585 FORMAT (5X,12HID     POINT,20X,3H(X),31X,7H(THETA),31X,3H(Z))
  586 FORMAT (21X,'F O R C E S   F O R   T H E   T R A P E Z O I D A L',
     1       '   R I N G S     ( C T R A P R G )')
  587 FORMAT (23X,'F O R C E S   F O R   T H E   T O R O I D A L   ',
     1       'R I N G S     ( C T O R D R G )')
  588 FORMAT (5X,12HEL    CORNER,9X,6HRADIAL,8X,15HCIRCUMFERENTIAL,7X,
     1       5HAXIAL,13X,6HMOMENT,9X,13HDIRECT STRAIN,7X,9HCURVATURE)
  589 FORMAT (5X,12HID     POINT,11X,3H(X),13X,7H(THETA),12X,3H(Z),15X,
     1       4H(ZX),14X,4H(XI),13X,7H(XI,XI))
  590 FORMAT (30X,'E I G E N V A L U E   A N A L Y S I S   S U M M A R',
     1       ' Y     (INVERSE POWER METHOD)')
 5905 FORMAT (30X,'E I G E N V A L U E   A N A L Y S I S   S U M M A R',
     1       ' Y',9X,'(FEER METHOD)')
  591 FORMAT (1H0, /1H0,39X,32HNUMBER OF EIGENVALUES EXTRACTED ,6(2H .),
     1       I10,/1H0,39X,30HNUMBER OF STARTING POINTS USED,7(2H .),I10,
     2       /1H0,39X,30HNUMBER OF STARTING POINT MOVES,7(2H .),I10,
     3       /1H0,39X,36HNUMBER OF TRIANGULAR DECOMPOSITIONS ,4(2H .),
     4       I10,/1H0,39X,34HTOTAL NUMBER OF VECTOR ITERATIONS ,5(2H .),
     4       I10,//1H0,39X,22HREASON FOR TERMINATION,11(2H .),I10,1H*,/,
     5       /1H0,39X,36HLARGEST OFF-DIAGONAL MODAL MASS TERM,4(2H .),
     6       E10.2, /1H0,77X,3(2H .),I10, /50X,9HMODE PAIR ,10(2H .),
     7       /78X,3(2H .),I10, /1H0,39X,'NUMBER OF OFF-DIAGONAL MODAL ',
     8       'MASS', /45X,23HTERMS FAILING CRITERION,8(2H .),I10)
 5911 FORMAT (/1H0,39X,3H(* ,8A4, /41X,'SEE NASTRAN U.M. VOL II, ',
     1       'SECTION 2',A4,1H))
  592 FORMAT (26X,'E I G E N V A L U E   A N A L Y S I S   S U M M A R',
     1       ' Y       (DETERMINANT METHOD)')
  593 FORMAT (1H0, /1H0,39X,32HNUMBER OF EIGENVALUES EXTRACTED ,6(2H .),
     1       I9,/1H0,39X,44HNUMBER OF PASSES THROUGH STARTING POINTS . .
     2,      I9,/1H0,39X,26HNUMBER OF CRITERIA CHANGES,9(2H .),I9,
     3       /1H0,39X,30HNUMBER OF STARTING POINT MOVES,7(2H .),I9,
     4       /1H0,39X,36HNUMBER OF TRIANGULAR DECOMPOSITIONS ,4(2H .),
     5       I9,/1H0,39X,44HNUMBER OF FAILURES TO ITERATE TO A ROOT  . .
     6,      I9, //1H0,39X,22HREASON FOR TERMINATION,11(2H .),I9,1H*,
     7       //,1H0,39X,36HLARGEST OFF-DIAGONAL MODAL MASS TERM,4(2H .),
     8       E9.2,/1H0,77X,3(2H .),I9,/50X, 9HMODE PAIR ,10(2H .), /78X,
     9       3(2H .),I9, /1H0,39X,33HNUMBER OF OFF-DIAGONAL MODAL MASS,
     O       /45X,23HTERMS FAILING CRITERION,8(2H .),I9)
  594 FORMAT (10X,14HSTARTING POINT,6X,6HLAMBDA,9X,'RADIAN FREQUENCY  ',
     1       '  CYCLIC FREQUENCY    DETERMINANT',9X,'SCALE FACTOR',/)
  595 FORMAT (1H0,40X,'S W E P T   D E T E R M I N A N T   F U N C T I',
     1       ' O N',/)
  596 FORMAT (20X,'C O M P L E X   E I G E N V A L U E   A N A L Y S I',
     1       ' S   S U M M A R Y     (DETERMINANT METHOD)')
  597 FORMAT (42X,5H- P -,35X,10H- DET(P) -, /10X,14HSTARTING POINT,10X,
     1       4HREAL,13X,4HIMAG,20X,9HMAGNITUDE,9X,5HPHASE,5X,
     2       12HSCALE FACTOR)
  598 FORMAT (1H0, /1H0,39X,32HNUMBER OF EIGENVALUES EXTRACTED ,6(2H .),
     1       I9,/1H0,39X,44HNUMBER OF PASSES THROUGH STARTING POINTS . .
     2,      I9,/1H0,39X,26HNUMBER OF CRITERIA CHANGES,9(2H .),I9,
     3       /1H0,39X,30HNUMBER OF STARTING POINT MOVES,7(2H .),I9,
     4       /1H0,39X,36HNUMBER OF TRIANGULAR DECOMPOSITIONS ,4(2H .),
     5       I9,/1H0,39X,44HNUMBER OF FAILURES TO ITERATE TO A ROOT  . .
     6,      I9,/1H0,39X,36HNUMBER OF PREDICTIONS OUTSIDE REGION,4(2H .)
     7,      I9,/1H0,/1H0,39X,22HREASON FOR TERMINATION,11(2H .),I9,1H*)
  599 FORMAT (1H0, /1H0, /1H0,35X,32HNUMBER OF EIGENVALUES EXTRACTED ,
     1       9(2H .),I9, /1H0,35X,30HNUMBER OF STARTING POINTS USED,
     2       10(2H .),I9, /1H0,35X,
     3       50HNUMBER OF STARTING POINT OR SHIFT POINT MOVES  . .,I9,
     4       /1H0,35X,42HTOTAL NUMBER OF TRIANGULAR DECOMPOSITIONS ,
     5       4(2H .),I9, /1H0,35X,34HTOTAL NUMBER OF VECTOR ITERATIONS ,
     6       8(2H .),I9, /1H0, /1H0,35X,22HREASON FOR TERMINATION,
     7       14(2H .),I9,1H*)
  600 FORMAT (19X,'C O M P L E X   E I G E N V A L U E   A N A L Y S I',
     1       ' S   S U M M A R Y   (INVERSE POWER METHOD)')
 6005 FORMAT (23X,'C O M P L E X   E I G E N V A L U E   A N A L Y S I',
     1       ' S   S U M M A R Y     (FEER METHOD)')
 6006 FORMAT (20X,'C O M P L E X   E I G E N V A L U E   A N A L Y S I',
     1       ' S   S U M M A R Y     (HESSENBERG METHOD)')
 6007 FORMAT (1H0, /1H0, /,1H0,35X,32HNUMBER OF EIGENVALUES EXTRACTED ,
     1       9(2H .),I9, /,1H0,35X,30HNUMBER OF EIGENVALUES DESIRED ,
     2       10(2H .),I9, /,1H0,35X,22HREASON FOR TERMINATION,14(2H .),
     3       I9,1H*)
  601 FORMAT (6X, 'EIGENVALUE =',E14.6,
     *        4X, '(CYCLIC FREQUENCY =', E14.6, ' HZ)'/)
  602 FORMAT (6X, 'EIGENVALUE =',E14.6,
     *        4X, '(CYCLIC FREQUENCY =', 1P,E14.6, ' HZ)'/)
  603 FORMAT (6X,11HFREQUENCY =,E14.6)
  604 FORMAT (6X,11HFREQUENCY =,1P,E14.6)
  605 FORMAT (6X,6HTIME =,E14.6)
  606 FORMAT (6X,6HTIME =,1P,E14.6)
  607 FORMAT (6X,10HPOINT-ID =,I8)
  608 FORMAT (6X,12HELEMENT-ID =,I8,/)
  609 FORMAT (6X,20HCOMPLEX EIGENVALUE =,E14.6,1H,,E14.6,
     *        4X, '(CYCLIC FREQUENCY =', E14.6, 'HZ)')
  610 FORMAT (6X,20HCOMPLEX EIGENVALUE =,1P,E14.6,1H,,1P,E14.6,
     *        4X, '(CYCLIC FREQUENCY =', 1P,E14.6, 'HZ)')
  611 FORMAT (6X,16HFREQUENCY   TYPE,10X,2HT1,13X,2HT2,13X,2HT3,13X,
     1       2HR1,13X,2HR2,13X,2HR3)
  612 FORMAT (6X,16H TIME       TYPE,10X,2HT1,13X,2HT2,13X,2HT3,13X,
     1       2HR1,13X,2HR2,13X,2HR3)
  613 FORMAT (48X,30HV E L O C I T Y    V E C T O R )
  614 FORMAT (44X,38HA C C E L E R A T I O N    V E C T O R )
  615 FORMAT (41X,45HN O N - L I N E A R - F O R C E   V E C T O R )
  616 FORMAT (40X,'C O M P L E X   E I G E N V A L U E   S U M M A R Y')
  617 FORMAT (1H0,16X,19HROOT     EXTRACTION,18X,10HEIGENVALUE,21X,
     1       9HFREQUENCY,14X,7HDAMPING)
  618 FORMAT (18X,3HNO.,8X,5HORDER,13X,6H(REAL),11X,6H(IMAG),16X,
     1       8H(CYCLES),12X,11HCOEFFICIENT)
  619 FORMAT (39X,'C O M P L E X   D I S P L A C E M E N T   V E C T O R
     1'      )
  620 FORMAT (43X,'C O M P L E X   V E L O C I T Y   V E C T O R')
  621 FORMAT (39X,'C O M P L E X   A C C E L E R A T I O N   V E C T O R
     1'      )
  622 FORMAT (25X,'C O M P L E X   F O R C E S   O F   S I N G L E   ',
     1       'P O I N T   C O N S T R A I N T')
  623 FORMAT (47X,'C O M P L E X   L O A D   V E C T O R')
  624 FORMAT (39X,'C O M P L E X   E I G E N V E C T O R   NO.',I11)
  625 FORMAT (58X,'(REAL/IMAGINARY)')
  626 FORMAT (57X,'(MAGNITUDE/PHASE)')
  627 FORMAT (27X,'C O M P L E X   S T R E S S E S   I N   B A R   E L',
     1       ' E M E N T S   ( C B A R )')
  628 FORMAT (23X,'C O M P L E X   S T R E S S E S   I N   S C A L A R',
     1       '   S P R I N G S   ( C E L A S 1 )')
  629 FORMAT (23X,'C O M P L E X   S T R E S S E S   I N   S C A L A R',
     1       '   S P R I N G S   ( C E L A S 2 )')
  630 FORMAT (23X,'C O M P L E X   S T R E S S E S   I N   S C A L A R',
     1       '   S P R I N G S   ( C E L A S 3 )')
  631 FORMAT (25X,'C O M P L E X   S T R E S S E S   I N   R O D   E L',
     1       ' E M E N T S   ( C O N R O D )')
  632 FORMAT (14X,'C O M P L E X   S T R E S S E S   I N   Q U A D R I',
     1       ' L A T E R A L   M E M B R A N E S   ( C Q D M E M )')
  633 FORMAT (16X,'C O M P L E X   S T R E S S E S   I N   B E N D I N',
     1       ' G   Q U A D R I L A T E R A L S   ( C Q D P L T )')
  634 FORMAT (6X,'C O M P L E X   S T R E S S E S   I N   G E N E R A L'
     1,      '   Q U A D R I L I A T E R A L   E L E M E N T S   ',
     2       '( C Q U A D 1)')
  635 FORMAT (6X,'C O M P L E X   S T R E S S E S   I N   G E N E R A L'
     1,      '   Q U A D R I L I A T E R A L   E L E M E N T S   ',
     2       '( C Q U A D 2 )')
  636 FORMAT (27X,'C O M P L E X   S T R E S S E S   I N   R O D   E L',
     1       ' E M E N T S   ( C R O D )')
  637 FORMAT (25X,'C O M P L E X   S T R E S S E S   I N   S H E A R  ',
     1       ' P A N E L S   ( C S H E A R )')
  638 FORMAT (14X,'C O M P L E X   S T R E S S E S   I N   B A S I C  ',
     1       ' B E N D I N G   T R I A N G L E S   ( C T R B S C )')
  639 FORMAT (10X,'C O M P L E X   S T R E S S E S   I N   G E N E R A',
     1       ' L   T R I A N G U L A R   E L E M E N T S   ',
     2       '( C T R I A 1 )')
  640 FORMAT (11X,'C O M P L E X   S T R E S S E S   I N   G E N E R A',
     1       ' L  T R I A N G U L A R   E L E M E N T S   ',
     2       '( C T R I A 2 )')
  642 FORMAT (17X,'C O M P L E X   S T R E S S E S   I N   T R I A N G',
     1       ' U L A R   M E M B R A N E S   ( C T R M E M )')
  643 FORMAT (20X,'C O M P L E X   S T R E S S E S   I N   B E N D I N',
     1       ' G   T R I A N G L E S   ( C T R P L T )')
  644 FORMAT (26X,'C O M P L E X   S T R E S S E S   I N   R O D   ',
     1       'E L E M E N T S   ( C T U B E )')
  645 FORMAT (25X,'C O M P L E X   S T R E S S E S   I N   T W I S T  ',
     1       ' P A N E L S   ( C T W I S T )')
  646 FORMAT (29X,'C O M P L E X   F O R C E S   I N   B A R   E L E M',
     1       ' E N T S   ( C B A R )')
  648 FORMAT (25X,'C O M P L E X   F O R C E S   I N   S C A L A R   ',
     1       'S P R I N G S   ( C E L A S 1 )')
  649 FORMAT (25X,'C O M P L E X   F O R C E S   I N   S C A L A R   ',
     1       'S P R I N G S   ( C E L A S 2 )')
  650 FORMAT (25X,'C O M P L E X   F O R C E S   I N   S C A L A R   ',
     1       'S P R I N G S   ( C E L A S 3 )')
  651 FORMAT (25X,'C O M P L E X   F O R C E S   I N   S C A L A R   ',
     1       'S P R I N G S   ( C E L A S 4 )')
  652 FORMAT (27X,'C O M P L E X   F O R C E S   I N   R O D   E L E M',
     1       ' E N T S   ( C O N R O D )')
  653 FORMAT (17X,'C O M P L E X   F O R C E S   I N   B E N D I N G  ',
     1       ' Q U A D R I L A T E R A L S   ( C Q D P L T )')
  654 FORMAT (9X,'C O M P L E X   F O R C E S   I N   G E N E R A L   ',
     1       'Q U A D R I L A T E R A L   E L E M E N T S   ',
     2       '( C Q U A D 1 )')
  655 FORMAT (9X,'C O M P L E X   F O R C E S   I N   G E N E R A L   ',
     1       'Q U A D R I L A T E R A L   E L E M E N T S   ',
     2       '( C Q U A D 2 )')
  656 FORMAT (29X,'C O M P L E X   F O R C E S   I N   R O D   E L E M',
     1       ' E N T S   ( C R O D )')
  657 FORMAT (7X,'C O M P L E X   F O R C E S   A C T I N G   O N   ',
     1       'S H E A R   P A N E L   E L E M E N T S   (C S H E A R)')
  658 FORMAT (16X,'C O M P L E X   F O R C E S   I N   B A S I C   B E',
     1       ' N D I N G   T R I A N G L E S   ( C T R B S C )')
  659 FORMAT (12X,'C O M P L E X   F O R C E S   I N   G E N E R A L  ',
     1       ' T R I A N G U L A R   E L E M E N T S   ( C T R I A 1 )')
  660 FORMAT (12X,'C O M P L E X   F O R C E S   I N   G E N E R A L  ',
     1       ' T R I A N G U L A R   E L E M E N T S   ( C T R I A 2 )')
  661 FORMAT (22X, 'C O M P L E X   F O R C E S   I N   B E N D I N G ',
     1       '  T R I A N G L E S   ( C T R P L T )')
  662 FORMAT (28X,'C O M P L E X   F O R C E S   I N   R O D   E L E M',
     1       ' E N T S   ( C T U B E )')
  663 FORMAT (27X,'C O M P L E X   F O R C E S   I N   T W I S T   P A',
     1       ' N E L S   ( C T W I S T )')
  664 FORMAT (12X,7HELEMENT,20X,4(8HLOCATION,7X ),6X,7HAVERAGE, /14X,
     1       3HID.,26X,1H1,14X,1H2,14X,1H3,14X,1H4,13X,12HAXIAL STRESS)
  665 FORMAT (17X,7HELEMENT,29X,5HAXIAL,39X,9HTORSIONAL, /19X,3HID.,30X,
     1       6HSTRESS,41X,6HSTRESS)
  666 FORMAT (17X,7HELEMENT,28X,7HMAXIMUM,39X,7HAVERAGE, /19X,3HID.,31X,
     1       5HSHEAR,41X,5HSHEAR)
  667 FORMAT (17X,7HELEMENT,29X,5HAXIAL,41X,6HTORQUE, /19X,3HID.,31X,
     1       5HFORCE)
  668 FORMAT (9H  ELEMENT,7X,5HFIBRE,37X,'- STRESSES IN ELEMENT COORDI',
     1       'NATE SYSTEM -', /4X,3HID.,8X,8HDISTANCE,18X,8HNORMAL-X,
     2       26X,8HNORMAL-Y,25X,8HSHEAR-XY)
  669 FORMAT (13X,7HELEMENT,33X,'- STRESSES IN ELEMENT COORDINATE SYST',
     1       'EM -', /15X,3HID.,18X,8HNORMAL-X,26X,8HNORMAL-Y,26X,
     2       8HSHEAR-XY)
  670 FORMAT (2(16X,7HELEMENT,35X), /2(18X,3HID.,20X,5HFORCE,12X))
  671 FORMAT (2(16X,7HELEMENT,35X), /2(18X,3HID.,19X,6HSTRESS,12X))
  672 FORMAT (17X,7HELEMENT,29X,5HFORCE,42X,5HFORCE)
  673 FORMAT (19X,3HID.,30X,7HPTS 1,3,40X,7HPTS 2,4)
  674 FORMAT (17X,7HELEMENT,28X,6HMOMENT,41X,6HMOMENT)
C
      END

      SUBROUTINE VDRA
C
C     VDRA PROCESSES THE CASE CONTROL AND XYCDB DATA BLOCKS. IF XYCDB
C     IS PURGED, NO ACTION IS TAKEN. OTHERWISE, OUTPUT REQUESTS IN
C     CASE CONTROL ARE COMPARED WITH XY REQUESTS IN XYCDB. FOR EACH
C     SUBCASE AND EACH REQUEST TYPE, CASE CONTROL IS MODIFIED TO REFLECT
C     THE UNION OF THE REQUESTS. THE NEW CASE CONTROL IS WRITTEN ON A
C     SCRATCH FILE AND THE POINTER TO CASE CONTROL SWITCHED.
C
      INTEGER         BUF   ,CASECC,XYCDB ,SCR1  ,SCR3  ,Z     ,APP   ,
     1                RD    ,RDREW ,WRT   ,WRTREW,CLSREW,SYSBUF,XSETNO,
     2                BUF1  ,BUF2  ,BUF3  ,SUBCSE,ANYNEW,FILE  ,DBNAME,
     3                SETNO ,ARG   ,SDR2  ,XSET0 ,VDRCOM,XYCDBF,VDRREQ,
     4                TRN   ,FORMAT,FRQ   ,SORT2
      DIMENSION       NAM(2),BUF(50)      ,MASKS(6)     ,CEI(2),FRQ(2),
     1                TRN(2),MODAL(2)     ,DIRECT(2)    ,VDRCOM(1)
      COMMON /VDRCOM/ VDRCOM,IDISP ,IVEL  ,IACC  ,ISPCF ,ILOADS,ISTR  ,
     1                IELF  ,IADISP,IAVEL ,IAACC ,IPNL  ,ITTL  ,ILSYM ,
     2                IFROUT,IDLOAD,CASECC,EQDYN ,USETD ,INFILE,OEIGS ,
     3                PP    ,XYCDB ,PNL   ,OUTFLE,OPNL1 ,SCR1  ,SCR3  ,
     4                BUF1  ,BUF2  ,BUF3  ,NAM   ,BUF   ,MASKS ,CEI   ,
     5                FRQ   ,TRN   ,DIRECT,XSET0 ,VDRREQ,MODAL
      COMMON /ZZZZZZ/ Z(1)
      COMMON /BLANK / APP(2),FORM(2),SORT2,OUTPUT,SDR2  ,IMODE
      COMMON /NAMES / RD    ,RDREW ,WRT   ,WRTREW,CLSREW
      COMMON /SYSTEM/ SYSBUF
C
C     SET BUFFER POINTERS AND PERFORM GENERAL INITIALIZATION.
C
      BUF1   = KORSZ(Z) - SYSBUF
      BUF2   = BUF1 - SYSBUF
      BUF3   = BUF2 - SYSBUF
      IXY    = 1
      LASTXY = 0
      ANYNEW = 0
      SDR2   =-1
      VDRREQ = 0
      XSETNO = XSET0
      IMSTR  = 1
      MASTER = 1
C
C     OPEN XYCDB. IF PURGED, RETURN.
C
      CALL OPEN (*1036,XYCDB,Z(BUF1),RDREW)
      FILE = XYCDB
      CALL FWDREC (*1036,XYCDB)
      CALL FWDREC (*1036,XYCDB)
C
C     READ FIRST LINE OF XYCDB. IF SUBCASE = 0 (MEANING DATA APPLIES
C     TO ALL SUBCASES), READ IN DATA FOR ZERO SUBCASE.
C
      LAST   = 0
      XYCDBF = XYCDB
      CALL READ (*1035,*1035,XYCDB,BUF,6,0,FLAG)
      SUBCSE = BUF(1)
      IF (SUBCSE .NE. 0) GO TO 1013
      I = IMSTR
 1011 Z(I  ) = BUF(2)
      Z(I+1) = BUF(3)
      I = I + 2
      CALL READ (*2002,*1012,XYCDB,BUF,6,0,FLAG)
      IF (BUF(1) .EQ. 0) GO TO 1011
      NMSTR = I - 2
      IXYSC = I
      GO TO 1019
C
C     HERE IF MASTER SUBCASE IS THE ONLY SUBCASE IN XYCDB.
C
 1012 NMSTR  = I - 2
      NXYSC  = NMSTR
      MASTER = 0
      LASTXY = 1
C
C     REDUCE LIST TO UNIQUE PAIRS
C
      IF (IMSTR .EQ. NMSTR) GO TO 1019
      NMSTR = NMSTR - 2
      J = IMSTR
      DO 1014 I = IMSTR,NMSTR,2
      IF (Z(I+2).EQ.Z(J) .AND. Z(I+3).EQ.Z(J+1)) GO TO 1014
      Z(J+2) = Z(I+2)
      Z(J+3) = Z(I+3)
      J = J + 2
 1014 CONTINUE
      NMSTR = J
      NXYSC = NMSTR
      GO TO 1019
C
C     HERE IF NO MASTER SUBCASE -- CREATE A DUMMY MASTER.
C
 1013 NMSTR = IMSTR
      IXYSC = IMSTR + 2
      Z(IMSTR  ) = 9999
      Z(IMSTR+1) = 0
C
C     OPEN CASE CONTROL AND SCRATCH FILE FOR MODIFIED CASE CONTROL
C
 1019 CALL GOPEN (CASECC,Z(BUF2),0)
      CALL GOPEN (SCR3,Z(BUF3),1)
C
C     READ DATA FOR ONE SUBCASE. STORE DATA BLOCK AND ID IN OPEN CORE.
C
 1020 IF (MASTER.EQ.0 .OR. LASTXY.NE.0) GO TO 1030
      SUBCSE = BUF(1)
      I = IXYSC
 1021 Z(I  ) = BUF(2)
      Z(I+1) = BUF(3)
      I = I + 2
      CALL READ (*1035,*1023,XYCDBF,BUF,6,0,FLAG)
      IF (BUF(1) .EQ. SUBCSE) GO TO 1021
      GO TO 1025
 1023 LASTXY = 1
C
C     COPY DATA FROM MASTER SUBCASE AFTER CURRENT SUBCASE.
C     THEN SORT DATA TOGETHER TO FORM SORTED UNION.
C
 1025 DO 1026 J = IMSTR,NMSTR,2
      Z(I  ) = Z(J  )
      Z(I+1) = Z(J+1)
      I = I + 2
 1026 CONTINUE
      N = I - IXYSC
      CALL SORT2K (0,0,2,1,Z(IXYSC),N)
C
C     REDUCE LIST TO UNIQUE PAIRS.
C
      NXYSC = I - 4
      J = IXYSC
      DO 1027 I = IXYSC,NXYSC,2
      IF (Z(I+2).EQ.Z(J) .AND. Z(I+3).EQ.Z(J+1)) GO TO 1027
      Z(J+2) = Z(I+2)
      Z(J+3) = Z(I+3)
      J = J + 2
 1027 CONTINUE
      NXYSC = J
C
C     READ A RECORD IN CASE CONTROL. SET POINTERS FOR XYCDB DATA TO
C     EITHER MASTER SUBCASE OR CURRENT SUBCASE IN CORE.
C
 1030 ICC = NXYSC + 1
      CALL READ (*1033,*1031,CASECC,Z(ICC+1),BUF3-ICC,1,NCC)
      CALL MESAGE (-8,0,NAM)
 1031 IF (MASTER.EQ.0 .OR. Z(ICC+1).NE.SUBCSE) GO TO 1032
      IXY = IXYSC
      NXY = NXYSC
      GO TO 1040
 1032 IXY = IMSTR
      NXY = NMSTR
      GO TO 1040
C
C     TERMINATE PROCESSING.
C
 1033 CONTINUE
 1035 CALL CLOSE (CASECC,CLSREW)
      CALL CLOSE (XYCDBF,CLSREW)
      CALL CLOSE (SCR3  ,CLSREW)
      IF (ANYNEW .NE. 0) CASECC = SCR3
      RETURN
C
 1036 VDRREQ = 1
      CALL CLOSE (XYCDB,CLSREW)
      RETURN
C
C     PICK UP POINTER TO CURRENT OUTPUT REQUEST.
C     DETERMINE IF XYCDB REQUEST EXISTS.
C
 1040 LOOP   = 1
 1041 DBNAME = LOOP
      IREQ   = ICC + VDRCOM(LOOP+1)
      SETNO  = Z(IREQ)
      DO 1042 J = IXY,NXY,2
      IF (Z(J) .EQ. DBNAME) GO TO 1043
 1042 CONTINUE
      GO TO 1095
 1043 IXYSET = J
      DO 1044 J = IXYSET,NXY,2
      IF (Z(J) .NE. DBNAME) GO TO 1045
 1044 CONTINUE
      NXYSET = NXY
      GO TO 1050
 1045 NXYSET = J - 2
C
C     BRANCH ON CASECC REQUEST-- NOTE, NO ACTION IF REQUEST = ALL.
C
 1050 IF (LOOP .GT. 7) GO TO 1051
      SDR2 = +1
      GO TO 1100
 1051 VDRREQ = 1
      SORT2  =+1
      IF (SETNO) 1098,1060,1070
C
C     HERE IF NO CASECC REQUEST.
C     BUILD XYCDB SET IN CASECC SET FORMAT. ADD SET TO
C     CASECC RECORD AND TURN ON CASECC REQUEST FOR SET.
C
 1060 XSETNO  = XSETNO + 1
      Z(IREQ) = XSETNO
      Z(IREQ+1) = 0
      FORMAT  = -2
      IF (APP(1) .EQ. TRN(1)) FORMAT = -1
      Z(IREQ+2) = FORMAT
      IX = ICC + NCC + 1
      Z(IX) = XSETNO
      JX = IX + 2
      Z(JX) = Z(IXYSET+1)
      IF (IXYSET .EQ. NXYSET) GO TO 1066
      IXYSET = IXYSET + 2
      N = 1
      DO 1065 J = IXYSET,NXYSET,2
      IF (Z(J+1)-Z(JX) .EQ. N) GO TO 1064
      IF (N .NE. 1) GO TO 1062
      JX = JX + 1
      Z(JX)= Z(J+1)
      GO TO 1065
 1062 Z(JX+1) = -Z(J-1)
      JX = JX + 2
      Z(JX) = Z(J+1)
      N = 1
      GO TO 1065
 1064 N = N + 1
 1065 CONTINUE
      IF (N .EQ. 1) GO TO 1066
      JX = JX + 1
      Z(JX  ) = -Z(NXYSET+1)
 1066 Z(IX+1) = JX - IX - 1
      NCC = NCC + Z(IX+1) + 2
      ANYNEW = 1
      GO TO 1100
C
C     HERE IF CASECC SET AND XYCDB SET EXIST.
C     FIRST, LOCATE CASECC SET.
C
 1070 ILIST = ICC + NCC + 3
      IX    = ICC + ILSYM
      ISETNO= IX  + Z(IX) + 1
 1071 ISET  = ISETNO + 2
      NSET  = Z(ISETNO+1) + ISET - 1
      IF (Z(ISETNO) .EQ. SETNO) GO TO 1080
      ISETNO = NSET + 1
      IF (ISETNO .LT. ILIST) GO TO 1071
      GO TO 1100
C
C     COMPARE EACH POINT IN XYCDB REQUEST WITH CASECC SET.
C     ADD ANY POINTS IN XYCDB NOT IN CASECC TO CASECC SET.
C
 1080 I = ISET
      J = IXYSET
      K = ILIST
      L = ISET
 1081 ARG = Z(J+1)
 1082 IF (I-NSET) 1083,1085,1088
 1083 IF (Z(I+1) .GT. 0) GO TO 1085
      N = 2
      IF (ARG-Z(I  )) 1088,1091,1084
 1084 IF (ARG+Z(I+1)) 1091,1087,1086
 1085 N = 1
      IF (ARG-Z(I  )) 1088,1087,1086
 1086 I = I + N
      GO TO 1082
 1087 I = I + N
      GO TO 1091
 1088 IF (L .EQ. I) GO TO 1090
      LN = I - 1
      LL = L
      DO 1089 L = LL,LN
      Z(K) = Z(L)
      K = K + 1
 1089 CONTINUE
      L = I
 1090 Z(K) = ARG
      K = K + 1
 1091 J = J + 2
      IF (J .LE. NXYSET) GO TO 1081
      N = K - ILIST
      IF (N .EQ.    0) GO TO 1100
      IF (L .GT. NSET) GO TO 1094
      DO 1092 LL = L,NSET
      Z(K) = Z(LL)
      K = K + 1
 1092 CONTINUE
      N = K - ILIST
C
C     IF NO NEW POINTS IN SET, CURRENT CASECC SET IS UNION.
C     OTHERWISE, NEW SET IS UNION. TURN ON REQUEST FOR IT AND
C     EXTEND END OF CASECC RECORD.
C
 1094 XSETNO    = XSETNO + 1
      Z(IREQ  ) = XSETNO
      Z(IREQ+1) = 10*SETNO + Z(IREQ+1)
      Z(IREQ+2) =-IABS(Z(IREQ+2))
      Z(ILIST-2)= XSETNO
      Z(ILIST-1)= N
      NCC       = NCC + N + 2
      ANYNEW    = 1
      GO TO 1100
C
C     HERE IF NO XYCDB REQUEST EXISTS.
C
 1095 IF (SETNO .EQ. 0) GO TO 1100
      IF (LOOP  .GT. 7) GO TO 1096
      SDR2 = 1
      GO TO 1100
 1096 VDRREQ = 1
      GO TO 1100
C
C     HERE IF CASECC SET = ALL AND XY REQUEST EXISTS - TURN SORT 2 ON.
C
 1098 Z(IREQ+2) = -IABS(Z(IREQ+2))
C
C     TEST FOR COMPLETION OF ALL CASECC REQUESTS FOR CURRENT SUBCASE.
C     WHEN COMPLETE, WRITE CURRENT SUBCASE ON SCRATCH FILE.
C
 1100 LOOP = LOOP + 1
      IF (LOOP .LE. 11) GO TO 1041
      CALL WRITE (SCR3,Z(ICC+1),NCC,1)
C
C     RETURN TO READ ANOTHER RECORD IN CASE CONTROL OR ANOTHER XYCDB
C     SUBCASE
C
      IF (MASTER .EQ. 0) GO TO 1030
      IF (SUBCSE .LE. Z(ICC+1)) GO TO 1020
      GO TO 1030
C
C     FATAL FILE ERROR
C
 2000 CALL MESAGE (N,FILE,NAM)
 2002 N = -2
      GO TO 2000
      END

      SUBROUTINE SOLID( TEMPS, PG, ITYPE )
C*****
C  ELEMENT THERMAL LOAD GENERATOR FOR THE WEDGE, HEXA1, AND HEXA2
C
C  ITYPE = 1 IMPLIES WEDGE - 3 TETRAHEDRONS
C
C  ITYPE = 2 IMPLIES HEXA(6-SIDED-SOLID) 5 TETRAHEDRONS
C
C  ITYPE = 3 IMPLIES HEXA(6-SIDED-SOLID) 10 TETRAHEDRONS
C
C*****
      INTEGER       NECPT(52)           ,M(13,4)
C
      REAL          TEMPS(8)           ,PG(6)              ,TMPS(4)
C
      COMMON/TRIMEX/ECPT(100)
C
      EQUIVALENCE( NECPT(1), ECPT(1) )
C*****
C
C  E C P T     TETRA          WEDGE          HEXA
C  -----------------------------------------------
C  ECPT( 1) =  EL ID          EL ID          EL ID
C  ECPT( 2) =  MAT-ID         MAT-ID         MAT-ID
C  ECPT( 3) =  GRID-1         GRID-1         GRID-1
C  ECPT( 4) =  GRID-2         GRID-2         GRID-2
C  ECPT( 5) =  GRID-3         GRID-3         GRID-3
C  ECPT( 6) =  GRID-4         GRID-4         GRID-4
C  ECPT( 7) =  CSID-1         GRID-5         GRID-5
C  ECPT( 8) =  X1             GRID-6         GRID-6
C  ECPT( 9) =  Y1             CSID-1         GRID-7
C  ECPT(10) =  Z1             X1             GRID-8
C  ECPT(11) =  CSID-2         Y1             CSID-1
C  ECPT(12) =  X2             Z1             X1
C  ECPT(13) =  Y2             CSID-2         Y1
C  ECPT(14) =  Z2             X2             Z1
C  ECPT(15) =  CSID-3         Y2             CSID-2
C  ECPT(16) =  X3             Z2             X2
C  ECPT(17) =  Y3             CSID-3         Y2
C  ECPT(18) =  Z3             X3             Z2
C  ECPT(19) =  CSID-4         Y3             CSID-3
C  ECPT(20) =  X4             Z3             X3
C  ECPT(21) =  Y4             CSID-4         Y3
C  ECPT(22) =  Z4             X4             Z3
C  ECPT(23) =  EL-TEM         Y4             CSID-4
C  ECPT(24)                   Z4             X4
C  ECPT(25)                   CSID-5         Y4
C  ECPT(26)                   X5             Z4
C  ECPT(27)                   Y5             CSID-5
C  ECPT(28)                   Z5             X5
C  ECPT(29)                   CSID-6         Y5
C  ECPT(30)                   X6             Z5
C  ECPT(31)                   Y6             CSID-6
C  ECPT(32)                   Z6             X6
C  ECPT(33)                   ELTEMP         Y6
C  ECPT(34)                                  Z6
C  ECPT(35)                                  CSID-7
C  ECPT(36)                                  X7
C  ECPT(37)                                  Y7
C  ECPT(38)
C  ECPT(39)                                  CSID-8
C  ECPT(40)                                  X8
C  ECPT(41)                                  Y8
C  ECPT(42)                                  Z8
C  ECPT(43)                                  EL-TEMP
C*****
C
C*****
C  MAP FOR WEDGE  M(I,J)  I=TETRAHEDRON, J=GRID POINT
C*****
      DATA M( 1,1),M( 1,2),M( 1,3),M( 1,4) / 1   ,2   ,3   ,6 /
      DATA M( 2,1),M( 2,2),M( 2,3),M( 2,4) / 1   ,2   ,6   ,5 /
      DATA M( 3,1),M( 3,2),M( 3,3),M( 3,4) / 1   ,4   ,5   ,6 /
C*****
C  MAP FOR HEXA-SOLID (5 OR 10 TETRAHEDRONS)
C*****
      DATA M( 4,1),M( 4,2),M( 4,3),M( 4,4) / 1   ,2   ,3   ,6 /
      DATA M( 5,1),M( 5,2),M( 5,3),M( 5,4) / 1   ,3   ,4   ,8 /
      DATA M( 6,1),M( 6,2),M( 6,3),M( 6,4) / 1   ,3   ,8   ,6 /
      DATA M( 7,1),M( 7,2),M( 7,3),M( 7,4) / 1   ,5   ,6   ,8 /
      DATA M( 8,1),M( 8,2),M( 8,3),M( 8,4) / 3   ,6   ,7   ,8 /
      DATA M( 9,1),M( 9,2),M( 9,3),M( 9,4) / 2   ,3   ,4   ,7 /
      DATA M(10,1),M(10,2),M(10,3),M(10,4) / 1   ,2   ,4   ,5 /
      DATA M(11,1),M(11,2),M(11,3),M(11,4) / 2   ,4   ,5   ,7 /
      DATA M(12,1),M(12,2),M(12,3),M(12,4) / 2   ,5   ,6   ,7 /
      DATA M(13,1),M(13,2),M(13,3),M(13,4) / 4   ,5   ,7   ,8 /
C*****
C  BRANCH ON ELEMENT TYPE
C*****
      GO TO(1000,2000,3000), ITYPE
C*****
C  COME HERE FOR WEDGE COMPUTATIONS.
C  KTETRA IS CALLED 3 TIMES BASED ON WEDGE MAPPING MATRIX.
C*****
 1000 ITET = 1
      NTET = 3
      ITEMP= 33
      NGRIDS = 6
      IOPT = 0
      GO TO 6000
C*****
C  COME HERE FOR 5-TETRAHEDRON 6-SIDED SOLID
C*****
 2000 ITET = 4
      NTET = 8
      ITEMP= 43
      NGRIDS = 8
      IOPT = 0
      GO TO 6000
C*****
C  COME HERE FOR 10-TETRAHEDRON 6-SIDED SOLID
C*****
 3000 ITET = 4
      NTET =13
      ITEMP= 43
      NGRIDS = 8
      IOPT = 1
      GO TO 6000
 6000 DO 6010 J = 1,50
      ECPT(J+50) = ECPT(J)
 6010 CONTINUE
C
C  FILL MAT ID AND EL TEMP
C
      NECPT(2) = NECPT(52)
      NECPT(23) = NECPT (ITEMP+50)
      DO 8000 I = ITET,NTET
C
C     FILL IN GRID SIL-S AND COORDINATE SETS
C
      DO 7030 J = 1,4
      KPOINT = M(I,J)
      TMPS(J) = TEMPS(KPOINT)
      NECPT(J+2) = NECPT(KPOINT+52)
      KPOINT = 4*KPOINT + NGRIDS - 3
      JPOINT = 4*J + 2
      NECPT(JPOINT+1) = NECPT(KPOINT+52)
      NECPT(JPOINT+2) = NECPT(KPOINT+53)
      NECPT(JPOINT+3) = NECPT(KPOINT+54)
      NECPT(JPOINT+4) = NECPT(KPOINT+55)
 7030 CONTINUE
      CALL TETRA( TMPS(1), PG(1), IOPT )
 8000 CONTINUE
C*****
C  ALL THROUGH
C*****
      RETURN
      END

      SUBROUTINE REWIND ( FILE )
      INCLUDE 'DSIOF.COM'
      INCLUDE 'XNSTRN.COM'
      INTEGER           FILE
      NAME   = FILE
      CALL DSGEFL
C CALL DBMMGR FOR REWIND SO TO SET BUFFER ADDRESS CORRECTLY
      CALL DBMMGR ( 3 )
      NBLOCK = FCB( 4, IFILEX )
      IF ( IPRVOP .EQ. 0 ) GO TO 30
C IF FILE OPEN FOR WRITE, THEN INITIAL BUFFER AND BLOCK NUMBER
      IBASE( INDBAS+3 ) = 1
      IBASE( INDBAS+4 ) = 6
CWKBNB NCL93007 11/94
C SET THE COUNTER FOR NUMBER OF STRINGS AND TERMS TO ZERO
      FCB( 16, IFILEX ) = 0
      FCB( 17, IFILEX ) = 0
CWKBNE NCL93007 11/94
30    INDCLR = INDBAS+5
      INDCBP = INDCLR
      CALL DSSDCB
      RETURN
      END

      SUBROUTINE SDR2D
C
C     SDR2D PERFORMS THE FINAL STRESS AND FORCE RECOVERY COMPUTATIONS.
C     CASE CONTROL AND THE DISPLACEMENT VECTOR FILE ARE PROCESSED IN
C     PARALLEL.  THE ESTA IS PASSED ONCE FOR EACH VECTOR IN UGV FOR
C     WHICH A STRESS OR FORCE OUTPUT REQUEST EXISTS.  THE ESTA IS HELD
C     COMPLETELY IN CORE IF POSSIBLE.  STRESS OUTPUT IS WRITTEN ON OES1.
C     FORCE OUTPUT IS WRITTEN ON OEF1.
C
      LOGICAL         AXIC     ,AXSINE   ,AXCOSI   ,EOFCC
C    1,               IDSTRS   ,IDFORC   ,ILOGIC(2)
      INTEGER         STRESX   ,FORCEX   ,UGVVEC   ,ESTAWD   ,ELTYPE  ,
     1                TLOAD    ,ELDEF    ,ELEMID   ,GPTT     ,OES1    ,
     2                OEF1     ,OEIGR    ,ESTA     ,EDT      ,ELESTA  ,
     3                KDEFRM(2),APP      ,SORT2    ,SPCF     ,DISPL   ,
     4                VEL      ,ACC      ,STRESS   ,FORCE    ,CSTM    ,
     5                CASECC   ,EQEXIN   ,SIL      ,BGPDT    ,PG      ,
     6                QG       ,UGV      ,PHIG     ,EIGR     ,OPG1    ,
     7                OQG1     ,OUGV1    ,OCB      ,BUF(50)  ,DTYPE   ,
     8                FILE     ,BUF1     ,BUF2     ,BUF3     ,BUF4    ,
     9                BUF5     ,BUF6     ,BUF7     ,SYMFLG   ,OUTFL   ,
     O                STA      ,REI      ,DS0      ,DS1      ,FRQ     ,
     1                TRN      ,BK0      ,BRANCH   ,SYSBUF   ,
     2                DATE     ,PLOTS    ,QTYPE2   ,EOL      ,BK1     ,
     3                TIME     ,SETNO    ,FSETNO   ,Z        ,RETX    ,
     4                FORMT    ,FLAG     ,EOF      ,CEI      ,PLA     ,
     5                BUFA     ,BUFB     ,OFILE    ,DEVICE   ,OEF1L   ,
     6                PUGV1    ,XSETNS   ,SDEST    ,BUF8     ,OES1L   ,
     7                OPTE     ,XSET0    ,XSETNF   ,FDEST    ,PCOMPS  ,
     8                SORC     ,TLOADS   ,TMPREC   ,ITR(7)   ,COMPS
      INTEGER         PCOMP(2) ,PCOMP1(2),PCOMP2(2),BUF0     ,BUFM1   ,
     1                NMES1L(2),NMEF1L(2)
      REAL            ZZ(1)    ,BUFR(2)
      CHARACTER       UFM*23   ,UWM*25
      COMMON /XMSSG / UFM      ,UWM
      COMMON /BLANK / APP(2)   ,SORT2    ,IDUM(2)  ,COMPS
      COMMON /SDR2C1/ IPCMP    ,NPCMP    ,IPCMP1   ,NPCMP1   ,IPCMP2  ,
     1                NPCMP2   ,NSTROP
      COMMON /SDR2X1/ IEIGEN   ,IELDEF   ,ITLOAD   ,ISYMFL   ,ILOADS  ,
     1                IDISPL   ,ISTR     ,IELF     ,IACC     ,IVEL    ,
     2                ISPCF    ,ITTL     ,ILSYM    ,IFROUT   ,ISLOAD  ,
     3                IDLOAD   ,ISORC
      COMMON /SDR2X2/ CASECC   ,CSTM     ,MPT      ,DIT      ,EQEXIN  ,
     1                SIL      ,GPTT     ,EDT      ,BGPDT    ,PG      ,
     2                QG       ,UGV      ,EST      ,PHIG     ,EIGR    ,
     3                OPG1     ,OQG1     ,OUGV1    ,OES1     ,OEF1    ,
     4                PUGV1    ,OEIGR    ,OPHIG    ,PPHIG    ,ESTA    ,
     5                GPTTA    ,HARMS    ,XYCDB    ,SCR3     ,PCOMPS  ,
     6                OES1L    ,OEF1L
      COMMON /SDR2X4/ NAM(2)   ,END      ,MSET     ,ICB(7)   ,OCB(7)  ,
     1                MCB(7)   ,DTYPE(8) ,ICSTM    ,NCSTM    ,IVEC    ,
     2                IVECN    ,TEMP     ,DEFORM   ,FILE     ,BUF1    ,
     3                BUF2     ,BUF3     ,BUF4     ,BUF5     ,ANY     ,
     4                ALL      ,TLOADS   ,ELDEF    ,SYMFLG   ,BRANCH  ,
     5                KTYPE    ,LOADS    ,SPCF     ,DISPL    ,VEL     ,
     6                ACC      ,STRESS   ,FORCE    ,KWDEST   ,KWDEDT  ,
     7                KWDGPT   ,KWDCC    ,NRIGDS   ,STA(2)   ,REI(2)  ,
     8                DS0(2)   ,DS1(2)   ,FRQ(2)   ,TRN(2)   ,BK0(2)  ,
     9                BK1(2)   ,CEI(2)   ,PLA(22)  ,NRINGS   ,NHARMS  ,
     O                AXIC     ,KNSET    ,ISOPL    ,STRSPT   ,DDRMM   ,
     1                ISOPL8
      COMMON /SDR2X7/ ELESTA(100)        ,BUFA(100),BUFB(4076)
      COMMON /SDR2X8/ ELWORK(300)
      COMMON /ZZZZZZ/ Z(1)
      COMMON /NAMES / RD       ,RDREW    ,WRT      ,WRTREW   ,CLSREW
      COMMON /SYSTEM/ SYSBUF   ,OPTE     ,NOGO     ,INTAP    ,MPCN    ,
     1                SPCN     ,METHOD   ,LOADNN   ,SYMM     ,STFTMP  ,
     2                PAGE     ,LINE     ,TLINE    ,MAXLIN   ,DATE(3) ,
     3                TIME     ,ECHO     ,PLOTS    ,DUM23(35),IHEAT
      COMMON /UNPAKX/ QTYPE2   ,I2       ,J2       ,INCR2
      COMMON /ZNTPKX/ XX(4)    ,IXX      ,EOL      ,EOR
      COMMON /ZBLPKX/ Y(4)     ,IY
      COMMON /SDR2DE/ BUF6     ,COEF     ,DEFTMP   ,DIFF     ,DIFF1   ,
     1                DEVICE   ,ESTAWD   ,ELEMID   ,ELTYPE   ,EOF     ,
     2                EOFCC    ,IREQX    ,FLAG     ,FN       ,FORCEX  ,
     3                FSETNO   ,FORMT    ,ICC      ,I        ,IEDT    ,
     4                ISETNO   ,ISETF    ,ISETS    ,IDEF     ,ISYMN   ,
     5                SDEST    ,IX       ,ISETNF   ,ISEQ     ,IRETRN  ,
     6                IRECX    ,ISAVE    ,FDEST    ,IPART    ,ILIST   ,
     7                IGPTTA   ,ICORE    ,IELEM    ,IESTA    ,BUF8    ,
     8                JFORC    ,JSTRS    ,JANY     ,JLIST    ,J       ,
     9                KTYPE1   ,KHI      ,KX       ,K        ,KLO     ,
     O                KN       ,KTYPEX   ,KFRQ     ,KCOUNT   ,LSYM    ,
     1                M        ,MIDVEC   ,NWDSA    ,NWDSTR   ,NLOGIC  ,
     2                NWDS     ,NDEF     ,N        ,N1       ,N2      ,
     3                NOTSET   ,NSETS    ,NSETF    ,NWORDS   ,NX      ,
     4                TGRID(4) ,NWDFOR   ,NGPTT    ,NESTA    ,NVECTS  ,
     5                NLIST    ,OFILE    ,OUTFL    ,RETX     ,SETNO   ,
     6                STRESX   ,SAVE     ,TLOAD    ,UGVVEC   ,IXSETS  ,
     7                NXSETS   ,IXSETF   ,NXSETF   ,XSETNS   ,XSETNF  ,
     8                SORC     ,TMPREC   ,BUF7     ,TGRD(33)
      EQUIVALENCE     (BUF(1),BUFR(1))   ,(Z(1),ZZ(1))
C    1,               (IDSTRS,ILOGIC(1)) ,(IDFORC,ILOGIC(2))
      DATA    BUF   / 50*0/, KDEFRM/104,1/, XSET0/100000000/
      DATA    NMES1L/ 4HOES1, 4HL   /    ,NMEF1L  / 4HOEF1, 4HL   /
      DATA    PCOMP /  5502,  55    /,
     1        PCOMP1/  5602,  56    /,
     2        PCOMP2/  5702,  57    /
C
C     PERFORM GENERAL INITIALIZATION
C
      BUFM1  = KORSZ(Z) - SYSBUF + 1
      BUF0   = BUFM1 - SYSBUF - 1
      BUF1   = BUF0  - SYSBUF - 1
      IF (COMPS .NE. -1) BUF1 = BUFM1
      BUF2   = BUF1  - SYSBUF - 1
      I2     = 1
      INCR2  = 1
      ICC    = 0
      ILIST  = 1
      NLIST  = 0
      JLIST  = 1
      KFRQ   = 0
      AXSINE = .FALSE.
      AXCOSI = .FALSE.
      SORC   = 0
C
C     READ TRAILER ON INPUT FILE. SET PARAMETERS.
C
      ICB(1) = UGV
      CALL RDTRL (ICB)
      IF (ICB(1) .NE. UGV) GO TO 770
      NVECTS = ICB(2)
      IF (ICB(5) .GT. 2) GO TO 10
C
C     REAL VECTOR.
C
      KTYPE  = 1
      QTYPE2 = 1
      KTYPE1 = 2
      NWDS   = 8
      KTYPEX = 0
      GO TO 20
C
C     COMPLEX VECTOR.
C
   10 KTYPE  = 2
      QTYPE2 = 3
      KTYPE1 = 3
      NWDS   = 14
      KTYPEX = 1000
C
C     OPEN CASE CONTROL AND SKIP HEADER. THEN BRANCH ON APPROACH.
C
   20 FILE  = CASECC
      CALL OPEN (*740,CASECC,Z(BUF1),RDREW)
      CALL FWDREC (*750,CASECC)
      EOFCC = .FALSE.
C
      GO TO (100, 30,100, 60, 70, 70,100, 60, 30,100), BRANCH
C            STA,REI,DS0,DS1,FRQ,TRN,BK0,BK1,CEI,PLA
C
C     EIGENVALUES - READ LIST OF MODE NOS. AND EIGENVALUES INTO CORE.
C     BUCKLING POSSIBLE HERE TOO
C
   30 FILE = EIGR
      CALL OPEN (*740,EIGR,Z(BUF2),RDREW)
      CALL FWDREC (*750,EIGR)
      CALL FWDREC (*750,EIGR)
      I = ILIST
      M = 8 - KTYPE
      ISKIP = 0
      INDEX = 2
      IF (APP(1) .NE. REI(1)) GO TO 40
C
C     CHECK TO SEE IF ALL GENERALIZED MASS VALUES ARE ZERO
C
   35 CALL READ (*750,*37,EIGR,BUF,M,0,FLAG)
      IF (BUF(6) .EQ. 0.0) GO TO 35
      INDEX = 0
   37 CALL SKPREC (EIGR,-1)
   40 CALL READ (*750,*50,EIGR,BUF(1),M,0,FLAG)
      IF (APP(1) .NE. REI(1)) GO TO 45
      IF (INDEX .EQ. 2) GO TO 45
C
C     MATCH CORRECT MODE NOS. AND EIGENVALUES WITH PROPER
C     FORCES AND STRESSES WHEN USING GIVENS METHOD WITH F1.GT.0.0
C
      IF (INDEX .EQ. 1) GO TO 45
      IF (BUF(6) .NE. 0.0) GO TO 43
      ISKIP  = ISKIP + 1
      GO TO 40
   43 INDEX  = 1
   45 Z(I  ) = BUF(1) - ISKIP
      Z(I+1) = BUF(3)
      Z(I+2) = BUF(4)
      I      = I + KTYPE1
      GO TO 40
   50 CALL CLOSE (EIGR,CLSREW)
      NLIST  = I - KTYPE1
      ICC    = I
      GO TO 100
C
C     DIFF. STIFF. PHASE 1 OR BUCKLING PHASE 1 - SKIP 1ST DATA RECORD ON
C     CC.
C
   60 CALL FWDREC (*750,CASECC)
      IF (APP(1) .EQ. BK1(1)) GO TO 30
      GO TO 100
C
C     FREQUENCY OR TRANSIENT RESPONSE - READ LIST INTO CORE.
C
   70 FILE = PG
      CALL OPEN (*740,FILE,Z(BUF2),RDREW)
      I  = ILIST
      M  = 3
      IX = 1
      IF (APP(1).EQ.FRQ(1) .OR. APP(1).EQ.TRN(1)) IX = 2
   80 CALL READ (*750,*90,FILE,BUF(1),M,0,FLAG)
      Z(I  ) = BUF(M)
      Z(I+1) = 0
      I = I + IX
      M = 1
      GO TO 80
   90 CALL CLOSE (FILE,CLSREW)
      NLIST = I - IX
      ICC   = I
C
C     ALLOCATE CORE FOR CASE CONTROL, EDT, GPTT, ESTA, VECTOR
C     BALANCE OF REQUIRED BUFFERS
C       BUF1 = CASECC     BUF5 = GPTT
C       BUF2 = VECTOR     BUF6 = EDT
C       BUF3 = OES1       BUF7 = EQEXIN
C       BUF4 = OEF1       BUF8 = ESTA
C     SOME OF THE ABOVE MAY NOT BE REQUIRED AND THUS WILL NOT BE
C     ALLOCATED..
C
  100 BUF3 = BUF2 - SYSBUF - 1
      IF (STRESS .EQ. 0) BUF3 = BUF2
      BUF4 = BUF3 - SYSBUF - 1
      IF (FORCE  .EQ. 0) BUF4 = BUF3
      BUF5 = BUF4 - SYSBUF - 1
      IF (TLOADS .EQ. 0) BUF5 = BUF4
      BUF6 = BUF5 - SYSBUF - 3
      IF (KWDEDT .EQ. 0) BUF6 = BUF5
      BUF7 = BUF6 - SYSBUF - 1
      IF (ISOPL .EQ. 0) BUF7 = BUF6
      BUF8 = BUF7 - SYSBUF - 1
C
C     IF COMPOSITE ELEMENTS ARE PRESENT, READ PCOMPS INTO CORE
C
      IF (COMPS .NE. -1) GO TO 109
      FILE   = PCOMPS
      N      = -1
      CALL PRELOC (*760,Z(BUF2),PCOMPS)
      IPCMP  = ICC + 1
      IPCMP1 = IPCMP
      IPCMP2 = IPCMP
      NPCMP  = 0
      NPCMP1 = 0
      NPCMP2 = 0
      N      = -2
C
      CALL LOCATE (*106,Z(BUF2),PCOMP,IDX)
      CALL READ (*760,*106,PCOMPS,Z(IPCMP),BUF2-IPCMP,1,NPCMP)
      CALL MESAGE (-8,0,NAM)
  106 IPCMP1 = IPCMP1 + NPCMP
      IPCMP2 = IPCMP1
C
      CALL LOCATE (*107,Z(BUF2),PCOMP1,IDX)
      CALL READ (*760,*107,PCOMPS,Z(IPCMP1),BUF2-IPCMP1,1,NPCMP1)
      CALL MESAGE (-8,0,NAM)
  107 IPCMP2 = IPCMP2 + NPCMP1
C
      CALL LOCATE (*108,Z(BUF2),PCOMP2,IDX)
      CALL READ (*760,*108,PCOMPS,Z(IPCMP2),BUF2-IPCMP2,1,NPCMP2)
      CALL MESAGE (-8,0,NAM)
  108 ICC = IPCMP2 + NPCMP2 - 1
C
      CALL CLOSE (PCOMPS,CLSREW)
C
C     IF ESTA FITS IN CORE BUF8 MAY BE BUF7 SINCE IT WILL ONLY BE USED
C     TO READ ESTA IN ONCE..
C
  109 IEDT   = ICC + KWDCC + 1
      IGPTTA = IEDT + KWDEDT
      ITR(1) = EQEXIN
      CALL RDTRL (ITR)
      NEQEX  = 2*ITR(2)
      IF (ISOPL8 .NE. 8) NEQEX = 0
      IEQEX  = IGPTTA + KWDGPT
      IVEC   = IEQEX + NEQEX
      IVECN  = IVEC + KTYPE*ICB(3) - 1
C
C     IF CONICAL SHELL DOUBLE VECTOR SPACE
C
      IF (AXIC .AND. KTYPE.EQ.1) IVECN = IVECN + ICB(3)*KTYPE
      IESTA  = IVECN + 1
      MIDVEC = (IVEC+IVECN)/2 + 1
      IF (AXIC .AND. KTYPE.EQ.1) MIDVEC = 0
      IF (AXIC .AND. KTYPE.EQ.1) IVECN  = IVECN - ICB(3)*KTYPE
      IF (KWDEST .LE. (BUF7-IESTA)) BUF8 = BUF7
C
C     OPEN ESTA
C
      FILE = ESTA
      CALL OPEN (*740,ESTA,Z(BUF8),RDREW)
C
C     REMAINING CORE
C
      ICORE = BUF8 - IESTA
      NESTA = 0
C
C     WILL ESTA FIT IN CORE
C
      IF (ICORE .LE. 0) CALL MESAGE (-8,0,NAM)
      IF (KWDEST .GT. ICORE) GO TO 140
C
C     ESTA WILL FIT. READ IT IN PLACING A ZERO WORD AT END OF EACH
C     RECORD.
C
      I = IESTA
  110 CALL READ (*130,*120,ESTA,Z(I),ICORE,1,NWORDS)
      CALL REWIND (ESTA)
      ICORE = BUF8 - IESTA
      GO TO 140
  120 I = I + NWORDS + 1
      Z(I-1) = 0
      ICORE = ICORE - NWORDS - 1
      GO TO 110
C
C     ALL ESTA NOW IN CORE
C
  130 NESTA = I - 1
      CALL CLOSE (ESTA,CLSREW)
      IF (NESTA .GT. IESTA) GO TO 140
      WRITE  (OPTE,135) UWM
  135 FORMAT (A25,' 3303, STRESSES OR FORCES REQUESTED FOR SET(S) ',
     1       'WHICH CONTAIN NO VALID ELEMENTS.')
      GO TO 640
C
C     OPEN INPUT FILE. SKIP HEADER RECORD.
C
  140 FILE  = UGV
      CALL OPEN (*740,UGV,Z(BUF2),RDREW)
      CALL FWDREC (*750,UGV)
C
C     IF ANY ISOPARAMETRIC ELEMENTS PRESENT, GET SECOND RECORD OF EQEXIN
C
      IF (ISOPL .EQ. 0) GO TO 148
      FILE = EQEXIN
      CALL OPEN (*740,EQEXIN,Z(BUF7),RDREW)
      CALL FWDREC (*750,EQEXIN)
      CALL FWDREC (*750,EQEXIN)
      ISOPL = EQEXIN
      IF (ISOPL8 .NE. 8) GO TO 145
      CALL FREAD (EQEXIN,Z(IEQEX),NEQEX,0)
      CALL BCKREC (EQEXIN)
  145 CONTINUE
C
C     IF ANY STRESS OUTPUT IS REQUESTED,
C     OPEN OES1 AND WRITE HEADER RECORD
C
  148 IF (STRESS .EQ. 0) GO TO 155
      FILE = OES1
      CALL OPEN (*151,OES1,Z(BUF3),WRTREW)
      CALL FNAME (OES1,OCB)
      DO 150 I = 1,3
  150 OCB(I+2) = DATE(I)
      OCB(6) = TIME
      OCB(7) = 1
      CALL WRITE (OES1,OCB,7,1)
      GO TO 155
  151 CALL MESAGE (1,OES1,NAM)
      STRESS = 0
C
C     IF ANY STRESS OR FORCE OUTPUT IS REQUESTED AND COMPOSITE ELEMENTS
C     ARE PRESENT, OPEN OES1L AND OEF1L AND WRITE HEADER RECORDS
C
  155 IF (COMPS.NE.-1 .OR. (STRESS.EQ.0 .AND. FORCE.EQ.0)) GO TO 160
      ILAYER = 0
      FILE   = OES1L
      CALL OPEN (*158,OES1L,Z(BUFM1),WRTREW)
      CALL WRITE (OES1L,NMES1L,2,1)
      FILE = OEF1L
      CALL OPEN (*158,OEF1L,Z(BUF0),WRTREW)
      CALL WRITE (OEF1L,NMEF1L,2,1)
      GO TO 160
  158 CALL MESAGE (1,FILE,NAM)
      STRESS = 0
      FORCE  = 0
C
C     IF ANY FORCE OUTPUT IS REQUESTED,
C     OPEN OEF1 AND WRITE HEADER RECORD
C
  160 IF (FORCE .EQ. 0) GO TO 180
      FILE = OEF1
      CALL OPEN (*171,OEF1,Z(BUF4),WRTREW)
      CALL FNAME (OEF1,OCB)
      DO 170 I = 1,3
  170 OCB(I+2) = DATE(I)
      OCB(6) = TIME
      OCB(7) = 1
      CALL WRITE (OEF1,OCB,7,1)
      GO TO 180
  171 CALL MESAGE (1,OEF1,NAM)
      FORCE = 0
  180 IF (STRESS.EQ.0 .AND. FORCE.EQ.0) GO TO 640
C
C     INITIALIZE UGV VEC, WHICH WILL BE THE NUMBER OF THE VECTOR WE
C     ARE NOW POSITIONED TO READ.
C
      UGVVEC = 1
      ISVVEC = IVEC
      ISVVCN = IVECN
      IFLAG  = 0
C
C     READ A RECORD IN CASE CONTROL. SET SYMMETRY FLAG.
C
  190 CALL READ (*610,*200,CASECC,Z(ICC+1),KWDCC+1,1,FLAG)
      CALL MESAGE (8,0,NAM)
      GO TO 640
  200 IX  = ICC + ISYMFL
      SYMFLG = Z(IX)
      NCC = ICC + FLAG
C
C     FOR CONICAL SHELL SET SORC FLAG
C
      IX = ICC + ISORC
      IF (IFLAG  .EQ. 1) SORC   = ISVSRC
      IF (SYMFLG .EQ. 0) SORC   = Z(IX)
      IF (SORC   .EQ. 1) AXSINE = .TRUE.
      IF (SORC   .EQ. 2) AXCOSI = .TRUE.
      IF (AXIC .AND. SYMFLG.EQ.0) ISVSRC = SORC
      IVEC  = ISVVEC
      IVECN = ISVVCN
      IFLAG = 0
      IF (AXIC .AND. AXSINE .AND. AXCOSI .AND. UGVVEC.EQ.3) IFLAG = 1
      IF (AXIC .AND. SORC.EQ.0) GO TO 620
C
C     DETERMINE IF OUTPUT REQUEST IS PRESENT.
C     IF NOT, TEST FOR RECORD SKIP ON UGV THEN GO TO END OF THIS
C     REQUEST. IF SO, SET POINTERS TO SET DEFINING REQUEST.
C
  210 IX = ICC + ISTR
      STRESX = Z(IX  )
      SDEST  = Z(IX+1)
      XSETNS = -1
      IX     = ICC + IELF
      FORCEX = Z(IX  )
      FDEST  = Z(IX+1)
      XSETNF = -1
      NSTROP = Z(ICC+183)
C
C     DEBUG PRINTOUT
C
C
      IF (COMPS.EQ.-1 .AND. NSTROP.GT.1) ILAYER = ILAYER + 1
      IF (STRESX) 240,240,220
  220 IX = ICC + ILSYM
      ISETNO = IX + Z(IX) + 1
  230 ISETS  = ISETNO + 2
      NSETS  = Z(ISETNO+1) + ISETS - 1
      IF (Z(ISETNO) .EQ. STRESX) GO TO 235
      ISETNO = NSETS + 1
      IF (ISETNO .LE. NCC) GO TO 230
      STRESX = -1
      GO TO 240
C
C     IF REQUIRED, LOCATE PRINT/PUNCH SUBSET FOR STRESSES
C
  235 IF (STRESX .LT. XSET0) GO TO 240
      XSETNS = SDEST/10
      SDEST  = SDEST - 10*XSETNS
      IF (XSETNS .EQ. 0) GO TO 240
      IXSTNS = IX + Z(IX) + 1
  236 IXSETS = IXSTNS + 2
      NXSETS = Z(IXSTNS+1) + IXSETS - 1
      IF (Z(IXSTNS) .EQ. STRESX) GO TO 240
      IXSTNS = NXSETS + 1
      IF (IXSTNS .LT. NCC) GO TO 236
      STRESX = -1
  240 IF (FORCEX) 270,270,250
  250 IX = ICC + ILSYM
      ISETNO = IX + Z(IX) + 1
  260 ISETF  = ISETNO + 2
      NSETF  = Z(ISETNO+1) + ISETF - 1
      IF (Z(ISETNO) .EQ. FORCEX) GO TO 265
      ISETNO = NSETF + 1
      IF (ISETNO .LE. NCC) GO TO 260
      FORCEX = -1
      GO TO 290
C
C     IF REQUIRED, LOCATE PRINT/PUNCH SUBSET FOR FORCES
C
  265 IF (FORCEX .LT. XSET0) GO TO 290
      XSETNF = FDEST/10
      FDEST  = FDEST - 10*XSETNF
      IF (XSETNF .EQ. 0) GO TO 290
      IXSTNF = IX + Z(IX) + 1
  266 IXSETF = IXSTNF + 2
      NXSETF = Z(IXSTNF+1) + IXSETF - 1
      IF (Z(IXSTNF) .EQ. FORCEX) GO TO 290
      IXSTNF = NXSETF + 1
      IF (IXSTNF .LT. NCC) GO TO 266
      FORCEX = -1
  270 IF (STRESX.NE.0 .OR. FORCEX.NE.0 .OR. AXIC) GO TO 290
C
C     NO REQUESTS THIS CC RECORD FOR STRESSES OR FORCES.
C     THUS SKIP CORRESPONDING UGV RECORD UNLESS SYMFLG IS ON, IN WHICH
C     CASE WE SKIP NO UGV RECORD SINCE THE SYMMETRY CASE HAS NO UGV
C     VECTOR, BUT IN FACT WOULD HAVE USED A SUMMATION OF THE IMMEDIATELY
C     PRECEEDING LSYM VECTORS.
C
C     IF END OF CC AND NO STRESS OR FORCE OUTPUT REQUEST WE ARE DONE
C
      IF (EOFCC ) GO TO 620
      IF (SYMFLG) 190,280,190
  280 CALL FWDREC (*750,UGV)
      UGV VEC = UGV VEC + 1
      GO TO 570
C
C     THERE IS A REQUEST FOR STRESSES AND OR FORCES
C     FIRST DETERMINE APPROPRIATE GPTT AND EDT RECORDS IF REQUIRED
C
  290 IX     = ICC + ITLOAD
      TLOADS = Z(IX)
      NGPTT  = 0
      IF (TLOADS .EQ. 0) GO TO 370
      FILE   = GPTT
      CALL CLOSE (GPTT,CLSREW)
      CALL OPEN (*740,GPTT,Z(BUF5),RDREW)
C
C     SKIP NAME
C
      CALL READ (*750,*751,GPTT,BUF,2,0,N)
C
C     PICK UP 3 WORDS OF SET INFORMATION
C
  295 CALL READ (*750,*751,GPTT,BUF,3,0,N)
      IF (BUF(1) .NE. TLOADS) GO TO 295
      DEFTMP = BUFR(2)
      TMPREC = BUF(3)
C
  370 IX    = ICC + IELDEF
      ELDEF = Z(IX)
      IF (ELDEF.EQ.0 .OR. KWDEDT.EQ.0) GO TO 430
      FILE  = EDT
      CALL PRELOC (*740,Z(BUF6),EDT)
      CALL LOCATE (*390,Z(BUF6),KDEFRM,FLAG)
      IDEF  = IEDT
      I     = IDEF
  380 CALL READ (*750,*390,EDT,BUF(1),3,0,FLAG)
      IF (BUF(1) .EQ. ELDEF) GO TO 410
      GO TO 380
  390 BUF(1) = ELDEF
      BUF(2) = 0
      CALL MESAGE (-30,46,BUF)
  400 CALL READ (*750,*420,EDT,BUF(1),3,0,FLAG)
      IF (BUF(1) .NE. ELDEF) GO TO 420
  410 Z(I  ) = BUF(2)
      Z(I+1) = BUF(3)
      I = I + 2
      IF (I .LT. IGPTTA) GO TO 400
      CALL MESAGE (-8,0,NAM)
  420 NDEF = I - 2
      CALL CLOSE (EDT,CLSREW)
C
C     UNPACK VECTOR INTO CORE
C
  430 COEF1 = 1.0
      IF (SYMFLG .EQ. 0) GO TO 490
C
C     SYMMETRY SEQUENCE-- BUILD VECTOR IN CORE.
C
      IX   = ICC + ILSYM
      LSYM = Z(IX)
C
C     IF SYMFLG IS NEGATIVE, THIS IS A REPEAT SUBCASE.  USE PRESENT
C     VECTOR IN CORE.
C
      IF (SYMFLG.LT.0 .AND. APP(1).EQ.STA(1)) GO TO 530
      IF (SYMFLG .LT. 0) GO TO 190
      DO 440 I = IVEC,IVECN
  440 ZZ(I) = 0.0
      IF (LSYM .GT. UGV VEC-1) GO TO 780
      LIMIT = LSYM
      IF (IFLAG .EQ. 1) LIMIT = 1
      DO 450 I = 1,LIMIT
  450 CALL BCKREC (UGV)
      ISYMN = IX + LSYM
      I = IX + 1
      IF (IFLAG .EQ. 1) I = I + 1
      J2 = ICB(3)
  460 COEF = ZZ(I)
      CALL INTPK (*480,UGV,0,QTYPE2,0)
  470 CALL ZNTPKI
      IX = IVEC + IXX - 1
      IF (KTYPE .EQ. 1) GO TO 471
      ZZ(IX+J2) = ZZ(IX+J2) + COEF*XX(1)
      ZZ(IX   ) = ZZ(IX)    + COEF*XX(2)
      GO TO 472
  471 CONTINUE
      ZZ(IX)= ZZ(IX) + COEF*XX(1)
  472 CONTINUE
      IF (EOL   .EQ. 0) GO TO 470
  480 IF (IFLAG .EQ. 1) GO TO 485
      I = I + 1
      IF (I .LE. ISYMN) GO TO 460
      GO TO 530
C
C     CONICAL SHELL BOTH CASE
C     2 VECTORS IN CORE -
C     2-ND VECTOR IS NOW IN CORE AT Z(IVEC) THRU Z(IVECN)...
C     GET 1-ST VECTOR AND PUT IT AT Z(IVECN+1) THRU Z(2*IVECN-MIDVEC+1)
C
C
  485 MIDVEC = IVEC
      IVEC   = IVECN + 1
      IVECN  = IVECN + (IVECN-MIDVEC+1)
      COEF1  = ZZ(ICC + ILSYM+1)
C
C     IF FALL HERE AND SORC=1 THE VECTOR IN CORE IS THE SINE VECTOR AND
C     IF SORC=2 THE VECTOR IN CORE IS THE COSINE VECTOR.  THUS THE FIRST
C     VECTOR WAS THE OTHER VECTOR RESPECTIVELY
C     BY THE WAY THE VECTOR IN CORE IS THE SECOND VECTOR.
C
      CALL BCKREC (UGV)
      CALL BCKREC (UGV)
C
C     NOT SYMMETRY-- UNPACK VECTOR.
C
  490 J2 = ICB(3)
      IF (IFLAG .EQ. 1) GO TO 515
      IF (UGVVEC .GT. NVECTS) GO TO 620
  515 DO 510 I = IVEC,IVECN
  510 ZZ(I) = 0.0
      CALL INTPK (*500,UGV,0,QTYPE2,0)
  491 CALL ZNTPKI
      IX = IVEC + IXX-1
      IF (KTYPE .EQ. 1) GO TO 492
      ZZ(IX   ) = COEF1*XX(2)
      ZZ(IX+J2) = COEF1*XX(1)
      GO TO 493
  492 CONTINUE
      ZZ(IX) = COEF1*XX(1)
  493 CONTINUE
      IF (EOL .EQ. 0) GO TO 491
  495 IF (APP(1) .NE. TRN(1)) GO TO 520
      CALL FWDREC (*520,UGV)
      UGVVEC = UGVVEC + 1
      CALL FWDREC (*520,UGV)
      UGVVEC = UGVVEC + 1
      GO TO 520
  500 CONTINUE
      GO TO 495
  520 IF (IFLAG .NE. 1) UGVVEC = UGVVEC + 1
      IF (IFLAG .EQ. 1) CALL SKPREC (UGV,1)
C
C     READY NOW TO SWEEP THROUGH THE ESTA ONCE.
C     SDR2E DOES ALL THE PROCESSING OF PHASE II ELEMENT COMPUTATIONS.
C     THE ESTA FILE, BE IT IN CORE OR NOT, IS SWEPT THRU ONCE FOR THE
C     FOLLOWING CALL.
C
  530 IF (IFLAG .EQ. 1) SORC = SORC + 1
      IF (SORC  .EQ. 3) SORC = 1
      CALL SDR2E (*640,IEQEX,NEQEX)
C
C     CONCLUDE PROCESSING OF THIS VECTOR
C     INITIALIZE FOR NEXT VECTOR
C     CANCEL THIS INITIALIZATION IN SOME CASES IF A REPEAT CASE.
C
  570 GO TO (580,581,620,581,590,582,620,581,581,580), BRANCH
C
  580 IF (.NOT.EOFCC) GO TO 190
      GO TO 589
  581 JLIST = JLIST + KTYPE1
      IF (.NOT.EOFCC) GO TO 190
      GO TO 589
C
C     TRANSIENT RESPONSE
C
  582 JLIST = JLIST + 2
      IF (JLIST.LE.NLIST .AND. .NOT.EOFCC) GO TO 190
      IF (JLIST.GT.NLIST  .OR. UGVVEC.GT.NVECTS) GO TO 620
      GO TO 490
C
C     PROCESS ANY REMAINING VECTORS WITH LAST CC RECORD
C
  589 IF (UGV VEC.LE.NVECTS .AND. SYMFLG.EQ.0) GO TO 210
      GO TO 620
C
C     FREQUENCY RESPONSE, PICK UP NEXT VECTOR UNLESS ALL FREQUENCIES
C     COMPLETED
C
  590 JLIST = JLIST + 2
      IF (JLIST.LE.NLIST .AND. UGV VEC.LE.NVECTS) GO TO 210
      KFRQ  = 0
      JLIST = ILIST
      DO 600 I = ILIST,NLIST,2
  600 Z(I+1) = 0
      IF (UGV VEC .LE. NVECTS) GO TO 190
      GO TO 620
C
C     EOF HIT ON CASECC FILE
C     PROCESS ANY MORE VECTORS USING LAST CASECC RECORD
C
  610 EOFCC = .TRUE.
      IF (NVECTS .GE. UGV VEC) GO TO 210
C
C     WRITE TRAILERS AND CLOSE ANY OPEN FILES
C
  620 OCB(2) = 63
      IF (STRESS .EQ. 0) GO TO 630
      OCB(1) = OES1
      CALL WRTTRL (OCB(1))
      IF (COMPS.NE.-1 .OR. ILAYER.EQ.0) GO TO 630
      OCB(1) = OES1L
      CALL WRTTRL (OCB(1))
  630 IF (FORCE .EQ. 0) GO TO 640
      OCB(1) = OEF1
      CALL WRTTRL (OCB(1))
      IF (COMPS.NE.-1 .OR. ILAYER.EQ.0) GO TO 640
      OCB(1) = OEF1L
      CALL WRTTRL (OCB(1))
  640 DO 730 I = 1,12
      GO TO (650,660,670,680,690,700,710,720,721,725,726,728), I
  650 FILE = OES1
      GO TO 730
  660 FILE = OEF1
      GO TO 730
  670 FILE = UGV
      GO TO 730
  680 FILE = CASECC
      GO TO 730
  690 FILE = EDT
      GO TO 730
  700 FILE = GPTT
      GO TO 730
  710 FILE = PG
      GO TO 730
  720 FILE = EIGR
      GO TO 730
  721 FILE = ESTA
      GO TO 730
  725 FILE=EQEXIN
      GO TO 730
  726 FILE = OES1L
      GO TO 730
  728 FILE = OEF1L
  730 CALL CLOSE (FILE,CLSREW)
      RETURN
C
  740 N = 1
      GO TO 760
  750 N = 2
      GO TO 760
  751 N = 3
      GO TO 760
  760 CALL MESAGE (N,FILE,NAM)
      GO TO 640
C
C     UGV FILE PURGED, CAN NOT PROCESS STRESSES OR FORCES
C
  770 CALL MESAGE (30,76,0)
      GO TO 640
  780 OCB(1) = LSYM
      OCB(2) = UGV VEC - 1
      CALL MESAGE (30,92,OCB(1))
      GO TO 620
      END

      SUBROUTINE FNDPLT (PLOTER, MODEL, PMODEL)
C
C     PLOTER = PLOTTER INDEX.
C     MODEL = MODEL INDEX.
C     PMODEL = PLOTTER MODEL ID.
C
C...  DATA FOR PLOTTER + MODEL RECOGNITION.
C
      INTEGER PLOTER, PMODEL(2), PLTTER(2,6), PLTMDL(2,6)
C
      DATA PLTMDL /
C       NASTRAN GENERAL PURPOSE PLOTTER
     1   1HM,1, 1HT,1, 1HD,1,
     2   1HM,0, 1HT,0, 1HD,0/
      DATA PLTTER /
     1   1,-1,  2,-2,  2,-3,
     2   1,+1,  2,+2,  2,+3/
C
C     FIND THE MODEL ID.
C
      N = -1
      N1 = PMODEL(2)
      DO 120 I = 1, 6
      IF (PMODEL(1).NE.PLTMDL(1,I))  GO TO 120
      IF (N.LE.0)  N=I
      IF (N1.EQ.PLTMDL(2,I)) N = I
  120 CONTINUE
C
C     SETUP THE PLOTTER + MODEL INDICES.
C
      I2 = PMODEL(2)
      IF (N.LT.0) I2 = 0
      N = IABS (N)
      DO 130 I = 1,2
      IF (PLTMDL(I,N).NE.0)  PMODEL(I)=PLTMDL(I,N)
  130 CONTINUE
      PLOTER = PLTTER(1,N)
      MODEL  = PLTTER(2,N)
C
      RETURN
      END

      SUBROUTINE GUST
C
C     THE PURPOSE OF THIS MODULE IS TO COMPUTE STATIONARY VERTICAL GUST
C         LOADS FOR USE IN AEROLASTIC ANALYSIS
C
C     DMAP CALLING SEQUENCE
C
C         GUST   CASECC,DLT,FRL,QHJL,,,ACPT,CSTMA,PHF1/PHF/V,N,NOGUST/
C                V,N,BOV/C,Y,MACH/C,Y,Q  $
C
C     GUST USES SEVEN SCRATCH FILES
      INTEGER CASECC,DLT,FRL,QHJL,ACPT,CSTMA,PHF1,PHF,SCR1,SCR2,SCR3,
     1  SCR4,SCR5,SCR6,SCR7,SYSBUF,NAME(2),DIT,IBLOCK(11)
      REAL XM(2),RBLOCK(11)
      COMMON /SYSTEM/SYSBUF
      COMMON /ZZZZZZ/ IZ(1)
      COMMON /BLANK/NOGUST,BOV,RMACH,Q
      EQUIVALENCE  (XM(1),NOGUST),(IBLOCK(1),RBLOCK(1))
      DATA CASECC,DLT,FRL,QHJL,ACPT,CSTMA,PHF1,PHF,SCR1,SCR2,SCR3,SCR4
     1   /  101  ,102,103,105 ,108 ,109  ,110 ,201,301 ,302 ,303 ,304 /
      DATA  DIT,SCR5,SCR6,SCR7 /
     1      104,305 ,306 ,307  /,NAME/4HGUST,1H /,RBLOCK /11*0.0/
C
C     GUST1  GENERATES A FREQUENCY FUNCTION TABLE(SCR1)
C                        FOL DATA BLOCK          (SCR2)
C                        A IMAGE OF GUST CARDS  SID,DLOAD,WG,X0,V(SCR4)
C                      AND SUPPLIES NFREQ,NLOAD,XO,V,NOGUST
C
      CALL GUST1(CASECC,DIT,DLT,FRL,SCR1,SCR2,SCR4,NFREQ,NLOAD,XO,V,
     1   NOGUST,SCR3)
      IF( NOGUST .LT. 0) RETURN
C
C     GUST2 COMPUTES WJ MATRIX(SCR3)
C
      CALL GUST2(SCR2,SCR3,ACPT,XO,V,CSTMA,QHJL)
C
C     SET UP FOR ADRI
C
      NZ = KORSZ(IZ)
      IBUF1 = NZ-SYSBUF+1
      XM(1) =BOV
      XM(2) = RMACH
      CALL GOPEN(SCR2,IZ(IBUF1),0)
      CALL BCKREC(SCR2)
      CALL FREAD(SCR2,IZ,-2,0)
      CALL FREAD(SCR2,IZ,NFREQ,1)
      CALL CLOSE(SCR2,1)
      NZ= NZ-NFREQ
C
C     ADRI INTERPOLATES ON QHJL PUTTING OUTPUT ON SCR2 (QHJK)
C
      CALL ADRI(IZ,NFREQ,NZ,QHJL,SCR2,SCR5,SCR6,SCR7,NROWJ,NCOLW,NOGO)
      IF( NOGO .EQ. 1) CALL MESAGE(-61,0,NAME)
C
C     GUST3  MULTIPLIES QHJK BY WJ ONTO SCR5
C             SCR5 IS MULTIPLIED BY LOAD FUNCTION,WG,AND Q ONTO
C             SCR6
C
      CALL GUST3(SCR2,SCR3,SCR1,SCR4,SCR5,SCR6,Q,NFREQ,NLOAD,NROWJ,NCOLW
     1)
C                QHJK  WJ  P    GUST POEL
C
C
C     SET UP TO ADD LOADS
C
      NOGUST=1
      IBLOCK(1) =1
      RBLOCK(2) =1.0
      IBLOCK(7) =1
      RBLOCK(8) =1.0
      CALL SSG2C(SCR6,PHF1,PHF,1,IBLOCK)
      RETURN
      END

      INTEGER FUNCTION FINDC (B,BBAR,N,IX,JX)
      INTEGER B,BBAR
      DIMENSION IX(1),JX(1)
C*******
C     PICK OUT PAIRS OF NUMBERS FOR ACTIVE ROWS
C*******
      ICC = 0
      J = 1
      DO 10 I=1,N
      IF (I-IX(I) .LE. BBAR) GO TO 10
      JX(J) = I+B-1
      JX(J+1) = IX(I)
      J = J+2
   10 CONTINUE
      J = J-1
      IF(J .EQ. 0) GO TO 31
      DO 30 K = 1,J,2
      IF((J-K-1)/2 .LT. ICC) GO TO 31
      IC = 0
      DO 20 L=K,J,2
      IF(JX(K) .LT. JX(L+1)) GO TO 20
      IC = IC+1
   20 CONTINUE
      ICC = MAX0(ICC,IC)
   30 CONTINUE
   31 FINDC = ICC
      RETURN
      END

      SUBROUTINE SELBO1
C
C     THIS ROUTINE IS PHASE 1 OF STRESS DATA RECOVERY FOR THE ELBOW
C     ELEMENT MUCH OF THE CODE WAS LIFTED FROM THE KELBOW SUBROUTINE
C
C     ECPT FOR THE ELBOW
C
C     ECPT( 1)  -  IELID          ELEMENT ID. NUMBER
C     ECPT( 2)  -  ISILNO(2)      * SCALAR INDEX NOS. OF THE GRID POINTS
C     ECPT( 3)  -    ...          *
C     ECPT( 4)  -  SMALLV(3)      $ REFERENCE VECTOR
C     ECPT( 5)  -    ...          $
C     ECPT( 6)  -    ...          $
C     ECPT( 7)  -  ICSSV          COOR. SYS. ID FOR SMALLV VECTOR
C     ECPT( 8)  -  IMATID         MATERIAL ID.
C     ECPT( 9)  -  A              CROSS-SECTIONAL AREA
C     ECPT(10)  -  I1             $ AREA MOMENTS OF INERTIA
C     ECPT(11)  -  I2             $
C     ECPT(12)  -  FJ             TORSIONAL CONSTANT
C     ECPT(13)  -  NSM            NON-STRUCTURAL MASS
C     ECPT(14)  -  FE             FORCE ELEM. DESCRIPTIONS, FORCE METHOD
C     ECPT(15)  -  R1             *STRESS RECOVERY COEFFICIENTS
C     ECPT(16)  -  T1             *  RI=RADIAL LOCATION
C     ECPT(17)  -  R2             *  TI=ANGULAR LOCATION
C     ECPT(18)  -  T2             *     OF STRESS RECOVERY POINTS
C     ECPT(19)  -  R3             *
C     ECPT(20)  -  T3             *
C     ECPT(21)  -  R4             *
C     ECPT(22)  -  T4             *
C     ECPT(23)  -  K1             $ AREA FACTOR FOR SHEAR
C     ECPT(24)  -  K2             $
C     ECPT(25)  -  C              STRESS INTENSIFICATION FACTOR
C     ECPT(26)  -  KX             * FLEXIBILITY CORRECTION FACTORS
C     ECPT(27)  -  KY             *
C     ECPT(28)  -  KZ             *
C     ECPT(29)  -  R              RADIUS OF CURVATURE
C     ECPT(30)  -  BETAR          ANGLE FROM GA TO GB
C     ECPT(31)  -  MCSIDA         COORD. SYS. ID. FOR GRID POINT A
C     ECPT(32)  -  GPA(3)         *BASIC COORD. FOR GRID POINT A
C     ECPT(33)  -   ...           *
C     ECPT(34)  -   ...           *
C     ECPT(35)  -  MCSIDB         COORD. SYS. ID. FOR GRID POINT B
C     ECPT(36)  -  GPB(3)         *BASIC COORD. FOR GRID POINT B
C     ECPT(37)  -   ...           *
C     ECPT(38)  -   ...           *
C     ECPT(39)  -  ELTEMP         AVG. ELEMENT TEMPERATURE
C
C
      LOGICAL         ABASIC,BBASIC,BASIC
      REAL            L,I1,I2,K1,K2,KE,KEP,NSM,HUT( 6),KEE(12,12),
     1                KX,KY,KZ
      DIMENSION       VECI(3),VECJ(3),VECK(3),ECPT(100),IECPT(100),
     1                TA(18),TB(9),SMALV0(6),DP(20),F(6,6),S(12,12),
     2                H(6,6),DF(6,6)
      COMMON /SDR2X5/ IELID,ISILNO(2),SMALLV(3),ICSSV,IMATID,A,I1,I2,
     1                FJ,NSM,FE,C1,C2,D1,D2,F1,F2,G1,G2,K1,K2,C,
     2                KX,KY,KZ,R,BETAR,MCSIDA,GPA(3),MCSIDB,GPB(3),
     3                TEMPEL,DUM3(61)
      COMMON /SDR2X5/ JELID,JSILNO(2),SA(36),SB(36),OUT(21),THERM(30)
      COMMON /SDR2X6/ KE(144),KEP(144),DELA(6),DELB(6)
      COMMON /MATIN / MATIDC,MATFLG,ELTEMP,STRESS,SINTH,COSTH
      COMMON /MATOUT/ E,G,NU,RHO,ALPHA,T SUB 0,GSUBE,SIGT,SIGC,SIGS
      EQUIVALENCE     (IELID,ECPT(1),IECPT(1)), (TA(10),TB(1)),
     1                (KEE(1,1),KE(1),S(1,1))
      DATA    DCR   / .017453292 /
C
      SID(X) = SIN(X*DCR)
      COD(X) = COS(X*DCR)
      DTR(X) = X*DCR
C
      X    = 1.0
      ISOP = -1
C
C     SET UP POINTERS TO COORD. SYSTEM IDS
C
      JCSIDA = 31
      JCSIDB = 35
      ICSIDA = IECPT(31)
      ICSIDB = IECPT(35)
C
C     DEFINE LOCATION OF END A, END B IN TERMS OF DP(1) THRU DP(6)
C
      DP(1) = ECPT(JCSIDA+1)
      DP(2) = ECPT(JCSIDA+2)
      DP(3) = ECPT(JCSIDA+3)
      DP(4) = ECPT(JCSIDB+1)
      DP(5) = ECPT(JCSIDB+2)
      DP(6) = ECPT(JCSIDB+3)
C
C     DEFINE COMPONENTS OF VECTOR FROM END A TO CENTER OF CURVATURE,C
C
      DP(7) = ECPT(4)
      DP(8) = ECPT(5)
      DP(9) = ECPT(6)
      FLD   = SQRT(DP(7)**2 + DP(8)**2 + DP(9)**2)
      DP(7) = DP(7)/FLD
      DP(8) = DP(8)/FLD
      DP(9) = DP(9)/FLD
C
C     DETERMINE IF POINT A AND B ARE IN BASIC COORDINATES
C
      ABASIC =.TRUE.
      BBASIC =.TRUE.
      IF (ICSIDA .NE. 0) ABASIC =.FALSE.
      IF (ICSIDB .NE. 0) BBASIC =.FALSE.
C
C     COMPUTE THE TRANSFORMATION MATRICES TA AND TB IF NECESSARY
C
      IF (ABASIC) GO TO 60
      CALL TRANSS (ECPT(JCSIDA),TA)
      CALL GMMATS (TA,3,3,0, DP(7),3,1,0, VECJ)
      CALL GMMATS (TA,3,3,0, DP(1),3,1,0, DP(14))
      DP(1) = DP(14)
      DP(2) = DP(15)
      DP(3) = DP(16)
      GO TO 61
   60 CONTINUE
      VECJ(1) = DP(7)
      VECJ(2) = DP(8)
      VECJ(3) = DP(9)
   61 IF (BBASIC) GO TO 62
      CALL TRANSS (ECPT(JCSIDB),TB)
      CALL GMMATS (TB,3,3,0, DP(4),3,1,0, DP(14))
      DP(4) = DP(14)
      DP(5) = DP(15)
      DP(6) = DP(16)
   62 CONTINUE
C
C     CONSTRUCT VECTOR FROM A TO B
C
      SMALV0(1) = DP(4) - DP(1)
      SMALV0(2) = DP(5) - DP(2)
      SMALV0(3) = DP(6) - DP(3)
      FLL       = SQRT(SMALV0(1)**2 + SMALV0(2)**2 + SMALV0(3)**2)
      SMALV0(1) = SMALV0(1)/FLL
      SMALV0(2) = SMALV0(2)/FLL
      SMALV0(3) = SMALV0(3)/FLL
C
C     COMPUTE THE K VECTOR VECK = SMALV0 X VECJ
C
      VECK(1) = SMALV0(2)*VECJ(3) - SMALV0(3)*VECJ(2)
      VECK(2) = SMALV0(3)*VECJ(1) - SMALV0(1)*VECJ(3)
      VECK(3) = SMALV0(1)*VECJ(2) - SMALV0(2)*VECJ(1)
      FLL     = SQRT(VECK(1)**2 + VECK(2)**2 + VECK(3)**2)
      VECK(1) = VECK(1)/FLL
      VECK(2) = VECK(2)/FLL
      VECK(3) = VECK(3)/FLL
C
C     COMPUTE THE I VECTOR  VECI = VECJ X VECK
C
      VECI(1) = VECJ(2)*VECK(3) - VECJ(3)*VECK(2)
      VECI(2) = VECJ(3)*VECK(1) - VECJ(1)*VECK(3)
      VECI(3) = VECJ(1)*VECK(2) - VECJ(2)*VECK(1)
      FLL     = SQRT(VECI(1)**2 + VECI(2)**2 + VECI(3)**2)
      VECI(1) = VECI(1)/FLL
      VECI(2) = VECI(2)/FLL
      VECI(3) = VECI(3)/FLL
C
C     SEARCH THE MATERIAL PROPERTIES TABLE FOR E,G AND THE DAMPING
C     CONSTANT.
C
      MATIDC = IMATID
      MATFLG = 1
      IF (ISOP .EQ. 3) MATFLG = 12
      ELTEMP = TEMPEL
      CALL MAT (IECPT(1))
      DAMPC = G SUB E
C
C     SET UP INTERMEDIATE VARIABLES FOR ELEMENT STIFFNESS MATRIX
C     CALCULATION
C
      IF (KX .LT. 1.0E-8) KX = 1.0
      IF (KY .LT. 1.0E-8) KY = 1.0
      IF (KZ .LT. 1.0E-8) KZ = 1.0
      FI1 = I1/KZ
      FI2 = I2/KY
      FJK = FJ/KX
C
C
C     THE FOLLOWING CODE WAS TAKEN FROM SAP4 BENDKS ROUTINE FOR A CURVED
C     PIPE ELEMENT
C
C
C     COMPUTE SECTION PROPERTY CONSTANTS
C
      T  = DTR(BETAR)
      RA = R/(A*E)
      RV1= K1*R/(2.*G*A)
      RV2= K2/K1*RV1
      RT = R/(G*FJK*2.)
      RB0= R/(E*FI2*2.)
      RB1= R/(E*FI1)
      R2 = R**2
C
C     COMPUTE COMMON TRIGONOMETRIC CONSTANTS
C
      ST  = SID(BETAR)
      CT  = COD(BETAR)
      S2T = SID(2.0*BETAR)
      C2T = COD(2.0*BETAR)
C
C     FORM THE NODE FLEXIBILITY MATRIX AT NODE J REFERENCED TO THE
C     LOCAL (X,Y,Z) COORDINATE SYSTEM AT NODE I.
C
C     X - DIRECTION  IN-PLANE TANGENT TO THE BEND AT NODE I AND
C                    DIRECTED TOWARD NODE J
C     Y - DIRECTION  IN-PLANE AND DIRECTED RADIALLY INWARD TO THE
C                    CENTER OF CURVATURE
C     Z - DIRECTION  OUT OF PLANE AND ORTHOGONAL TO X AND Y
C
      DO 50 I = 1,6
      DO 50 K = I,6
      F(I,K) = 0.0
   50 CONTINUE
C
C     A X I A L
C
      F(1,1) = F(1,1) + 0.25*RA*(2.0*T + S2T)
      F(2,2) = F(2,2) + 0.25*RA*(2.0*T - S2T)
C
C     N O T E   (COEFFICIENT CHANGE)
C
      F(1,2) = F(1,2) + 0.50*RA*ST**2
C
C     S H E A R
C
      F(1,1) = F(1,1) + 0.5*RV1*(2.0*T - S2T)
      F(2,2) = F(2,2) + 0.5*RV1*(2.0*T + S2T)
      F(3,3) = F(3,3) + 2.0*RV2*T
C
C     N O T E   (SIGN CHANGE)
C
      F(1,2) = F(1,2) - RV1*ST**2
C
C     T O R S I O N
C
      F(3,3) = F(3,3) + 0.5*RT*R2*(6.0*T+S2T-8.0*ST)
      F(4,4) = F(4,4) + 0.5*RT*   (2.0*T+S2T)
      F(5,5) = F(5,5) + 0.5*RT*   (2.0*T-S2T)
      F(3,4) = F(3,4) +     RT*R *(ST-T*CT)
      F(3,5) = F(3,5) +     RT*R *(2.0-2.0*CT-T*ST)
      F(4,5) = F(4,5) + 0.5*RT*   (1.0-C2T)
C
C     B E N D I N G
C
      F(1,1) = F(1,1) + 0.25*RB1*R2*(2.0*T*(2.0+C2T)-3.0*S2T)
      F(2,2) = F(2,2) + 0.25*RB1*R2*(2.0*T*(2.0-C2T)+3.0*S2T-8.0*ST)
      F(3,3) = F(3,3) + 0.50*RB0*R2*(2.0*T-S2T)
      F(4,4) = F(4,4) + 0.50*RB0*   (2.0*T-S2T)
      F(5,5) = F(5,5) + 0.50*RB0*   (2.0*T+S2T)
      F(6,6) = F(6,6) +      RB1*T
      F(1,2) = F(1,2) + 0.25*RB1*R2*(1.0+3.0*C2T+2.0*T*S2T-4.0*CT)
      F(1,6) = F(1,6) -      RB1*R *(ST-T*CT)
      F(2,6) = F(2,6) +      RB1*R *(T*ST+CT-1.0)
      F(3,4) = F(3,4) +      RB0*R *(ST-T*CT)
      F(3,5) = F(3,5) -      RB0*R *T*ST
      F(4,5) = F(4,5) - 0.50*RB0*   (1.0-C2T)
C
C
C     FORM SYMMETRICAL UPPER PART OF FLEX MATRIX
C
      DO 65 I = 1,6
      DO 65 K = I,6
      DF(K,I) = F(I,K)
      DF(I,K) = DF(K,I)
   65 CONTINUE
C
C
C     INVERT FLEX TO FORM STIFFNESS
C
      CALL INVERS (6,DF,6,DUM,0,DETERM,ISING,H)
      IF (ISING .EQ. 2) WRITE (6,4002) F
      IF (ISING .EQ. 2) CALL MESAGE (-30,38,ECPT(1))
 4002 FORMAT (35H ELBOW STIFFNESS MATRIX IS SINGULAR, /,(5X,6E13.5))
C
C
C     SET UP THE FORCE TRANSFORMATION RELATING REACTIONS AT NODE I
C     ACTING ON THE MEMBER END DUE TO UNIT LOADS APPLIED TO THE MEMBER
C     END AT NODE J.
C
      DO 100 I = 1,6
      DO 100 K = 1,6
      H(I,K) = 0.0
  100 CONTINUE
C
      DO 105 K = 1,6
      H(K,K) =-1.0
  105 CONTINUE
C
      H(4,3) =-(R*(1.0 - CT))
      H(5,3) = (R*ST)
      H(6,1) =-H(4,3)
      H(6,2) =-H(5,3)
C
C     FORM THE UPPER TRIANGULAR PORTION OF THE LOCAL ELEMENT STIFFNESS
C     MATRIX FOR THE BEND
C
      DO 110 K = 1,6
      DO 110 I = K,6
      S(K+6,I+6) = DF(K,I)
  110 CONTINUE
C
      DO 130 IR = 1,6
      DO 130 IC = 1,6
      S(IR,IC+6) = 0.0
      DO 120 IN = 1,6
      S(IR,IC+6) = S(IR,IC+6) + H(IR,IN)*DF(IN,IC)
  120 CONTINUE
  130 CONTINUE
C
      DO 150 IR = 1,6
      DO 150 IC = IR,6
      S(IR,IC)  = 0.0
      DO 140 IN = 1,6
      S(IR,IC) = S(IR,IC) + S(IR,IN+6)*H(IC,IN)
  140 CONTINUE
  150 CONTINUE
C
C     REFLECT FOR SYMMETRY
C
      DO 165 I = 1,12
      DO 165 K = I,12
      S(K,I) = S(I,K)
  165 CONTINUE
C
C            E
C     STORE K   IN KEP(1) THRU KEP(36) AND
C            AA
C
C            E
C     STORE K   IN KEP(37) THRU KEP(72)
C            AB
C
      J = 0
      DO 340 I = 1,72,12
      LOW = I
      LIM = LOW + 5
      DO 330 K = LOW,LIM
      J = J + 1
      KEP(J) = KE(K)
  330 KEP(J+36) = KE(K+6)
  340 CONTINUE
C
C     COMPUTE THERMAL MATRIX
C
      L = DCR*ECPT(29)*ECPT(30)
      DO 341 I = 1,6
  341 HUT(I) = 0.0
      ALPHAR = ALPHA*R
      HUT(1) =-ALPHAR*SID(BETAR)
      HUT(2) =-ALPHAR*(1.-COD(BETAR))
      HUT(6) = 0.0
      CALL GMMATS (KEP(1),6,6,0, HUT,6,1,0, THERM(1))
C
C                                                             T
C     STORE VECI, VECJ, VECK IN KE(1) THRU KE(9) FORMING THE A  MATRIX.
C
      KE(1) = VECI(1)
      KE(2) = VECI(2)
      KE(3) = VECI(3)
      KE(4) = VECJ(1)
      KE(5) = VECJ(2)
      KE(6) = VECJ(3)
      KE(7) = VECK(1)
      KE(8) = VECK(2)
      KE(9) = VECK(3)
C
C     SET POINTERS SO THAT WE WILL BE WORKING WITH POINT A.
C
      BASIC = ABASIC
      JCSID = JCSIDA
      IWBEG = 0
      IKEL  = 1
      IAB   = 1
      INDEX = ISILNO(1)
C
C     ZERO OUT THE ARRAY WHERE THE 3 X 3 MATRIX AND THE W  AND W  6 X 6
C     MATRICES WILL RESIDE.                              A      B
C
      DO 350 I = 28,108
  350 KE(I) = 0.0
C
C     SET UP THE -G- MATRIX. IG POINTS TO THE BEGINNING OF THE G MATRIX.
C     G = AT X TI
C
  360 IG = 1
      IF (BASIC) GO TO 380
      CALL TRANSS (ECPT(JCSID),KE(10))
      CALL GMMATS (KE(1),3,3,0, KE(10),3,3,0, KE(19))
      IG = 19
C
C     FORM THE W  MATRIX OR THE W  MATRIX IN KE(37) OR KE(73) DEPENDING
C               A                B
C     UPON WHICH POINT - A OR B - IS UNDER CONSIDERATION.  G WILL BE
C     STORED IN THE UPPER LEFT AND LOWER RIGHT CORNERS.  H, IF NON-ZERO,
C     WILL BE STORED IN THE UPPER RIGHT CORNER.
C
C
  380 KE(IWBEG+37) = KE(IG  )
      KE(IWBEG+38) = KE(IG+1)
      KE(IWBEG+39) = KE(IG+2)
      KE(IWBEG+43) = KE(IG+3)
      KE(IWBEG+44) = KE(IG+4)
      KE(IWBEG+45) = KE(IG+5)
      KE(IWBEG+49) = KE(IG+6)
      KE(IWBEG+50) = KE(IG+7)
      KE(IWBEG+51) = KE(IG+8)
      KE(IWBEG+58) = KE(IG  )
      KE(IWBEG+59) = KE(IG+1)
      KE(IWBEG+60) = KE(IG+2)
      KE(IWBEG+64) = KE(IG+3)
      KE(IWBEG+65) = KE(IG+4)
      KE(IWBEG+66) = KE(IG+5)
      KE(IWBEG+70) = KE(IG+6)
      KE(IWBEG+71) = KE(IG+7)
      KE(IWBEG+72) = KE(IG+8)
C
C                              E                    E
C     FORM THE PRODUCT  S  =  K   X  W   OR  S   = K    X  W, DEPENDING
C                        A     AA     A       B     AB      B
C     UPON WHICH POINT WE ARE WORKING WITH.
C
      CALL GMMATS (KEP(IKEL),6,6,0, KE(IWBEG+37),6,6,0, SA(IAB))
C
C     IF THE POINT UNDER CONSIDERATION IS POINT B WE ARE FINISHED. IF
C     NOT, SET UP POINTS AND INDICATORS FOR WORKING WITH POINT B.
C
      IF (IWBEG .EQ. 36) GO TO 500
      BASIC = BBASIC
      JCSID = JCSIDB
      IWBEG = 36
      IKEL  = 37
      IAB   = 37
      INDEX = ISILNO(2)
      DO 400 I = 28,36
  400 KE(I) = 0.0
      GO TO 360
C
C     FILL REMAINDER OF OUTPUT BLOCK.
C
  500 JELID   = IELID
      JSILNO(1) = ISILNO(1)
      JSILNO(2) = ISILNO(2)
      I12     = 0.
      OUT( 1) = A*E*ALPHA
      OUT( 2) = A*E/L
      OUT( 3) = A
      OUT( 4) = FJ
      OUT( 5) = I1
      OUT( 6) = I2
      OUT( 7) = C
      OUT( 8) = C1
      OUT( 9) = C2
      OUT(10) = D1
      OUT(11) = D2
      OUT(12) = F1
      OUT(13) = F2
      OUT(14) = G1
      OUT(15) = G2
      OUT(16) = T SUB 0
      OUT(17) = SIGT
      OUT(18) = SIGC
      OUT(19) = L
      OUT(20) = R
      OUT(21) = BETAR
      RETURN
      END

      SUBROUTINE APDOE(ID,Z,START,END,FOUND,COUNT)
C
C     APDOE FINDS AND OPEN ENDED CARD FOR ID
C     GIVEN A LIST Z(START ) TO Z(END)
C     FOUND = 0 IF NOT FOUND
C     FOUND = POINTER TO START OF CARD Z(FOUND)
C     COUNT = NUMBER OF DATA ITEMS NOT COUNTING THE ID
C
      INTEGER START,END,FOUND,COUNT,Z(1)
      LOGICAL LOOK
      FOUND = 0
      LOOK = .TRUE.
      COUNT = 0
      IF(START.EQ.0) GO TO 50
      DO 10 I = START,END
      IF(LOOK) GO TO 20
      IF(Z(I).EQ.-1) LOOK = .TRUE.
      GO TO 10
   20 IF(Z(I).EQ.ID) GO TO 30
      LOOK = .FALSE.
   10 CONTINUE
      GO TO 50
   30 FOUND = I
      J = I + 2
      COUNT = COUNT + 1
C
C     START COUNT AT + 2 BECAUSE PAERO4 CARD CAN HAVE -1 IN FIELD 2
C
      DO 40 I=J,END
      IF(Z(I).EQ.-1) GO TO 50
      COUNT = COUNT + 1
   40 CONTINUE
   50 RETURN
      END

      SUBROUTINE A4 2 A8 (A,B,C)
C
C     MERGES TWO A4 BCD WORDS (A AND B) TO ONE A8 BCD WORD (C)
C
      CHARACTER*4     KA,    KB
      CHARACTER*8     KC,    D
      REAL            A,     B
      REAL            C(2)
      COMMON /SYSTEM/ DUMMY(40), NCPW
C
      WRITE (D,10) A,B
      IF (NCPW .LT. 8) READ (D,10) C(1),C(2)
      IF (NCPW .GE. 8) READ (D,20) C(1)
 10   FORMAT (2A4)
 20   FORMAT ( A8)
      RETURN
C
C
      ENTRY A4 2 K8 (A,B,KC)
C     ======================
C
C     MERGES TWO A4 BCD WORDS (A AND B) TO ONE A8 CHARACTER WORD (KC)
C
      WRITE (KC,10) A,B
      RETURN
C
C
      ENTRY A4 2 K4 (A,KA,NOTUSE)
C     ===========================
C
C     CONVERTS ONE A4 BCD WORD (A) TO ONE A4 CHARACTER WORD (KA)
C
      WRITE  (KA,30) A
 30   FORMAT (A4)
      RETURN
C
C
      ENTRY A8 2 K8 (C,KC,NOTUSE)
C     ===========================
C
C     CONVERTS ONE A8 BCD WORD (C) TO ONE A4 CHARACTER WORD (KC)
C
      IF (NCPW .LT. 8) WRITE (KC,10) C(1),C(2)
      IF (NCPW .GE. 8) WRITE (KC,20) C(1)
      RETURN
C
C
      ENTRY K4 2 K8 (KA,KB,KC)
C     ========================
C
C     MERGES TWO A4 CHARACTER WORDS (KA AND KB) TO ONE A8 CHARACTER
C     WORD (KC)
C
C     NOTE - SOME MACHINES, SUCH AS UNIVAC, HANDLE BCD WORD AND
C            CHARACTER WORD QUIT DIFFERENTLY
C
      WRITE (KC,10) KA,KB
      RETURN
C
C
      ENTRY K4 2 A8 (KA,KB,C)
C     =======================
C
C     MERGES TWO A4 CHARACTER WORDS (KA AND KB) TO ONE A8 BCD WORD (C)
C
      WRITE (D,10) KA,KB
      IF (NCPW .LT. 8) READ (D,10) C(1),C(2)
      IF (NCPW .GE. 8) READ (D,20) C(1)
      RETURN
C
C
      ENTRY K4 2 A4 (KA,A,NOTUSE)
C     ===========================
C
C     CONVERTS ONE A4 CHARACTER WORD (KA) TO ONE A4 BCD WORD (A)
C
      READ (KA,30) A
      RETURN
C
C
      ENTRY K8 2 A8 (KC,C,NOTUSE)
C     ===========================
C
C     CONVERTS ONE A8 CHARACTER WORD (KC) TO ONE A8 BCD WORD (C)
C
      IF (NCPW .LT. 8) READ (KC,10) C(1),C(2)
      IF (NCPW .GE. 8) READ (KC,20) C(1)
      RETURN
C
      END

      SUBROUTINE EQMCK
C
C     EQMCK CREATES AN OUTPUT FILE OF MPC CONSTRAINT FORCES AND AN
C     OVERALL TOTAL OF FORCES AND MOMENTS ON THE MODEL TO PROVIDE AN
C     EQUILIBRIUM CHECK.
C     VALID ONLY FOR STATICS AND REAL EIGENVALUE ANALYSIS.
C
C     DMAP CALLING SEQUENCE (DEFAULT PARAMETERS SHOWN)
C                                                        LAMA
C     EQMCK  CASECC,EQEXIN,GPL,BGPDT,SIL,USET,KGG,GM,UGV,PGG,QG,CSTM/
C            OQM1/V,Y,OPT=0/V,Y,GRDPNT=-1/V,N,NSKIP/V,Y,SUBNAM $
C     WHERE
C     OPT .EQ. 0, CREATE OQM
C         .LT. 0, CALCULATE ST1
C         .GT. 0, CALCULATE ST1 AND CREATES OQM
C     GRDPNT - POINT ABOUT WHICH EQUILIBRIUM IS CALCULATED.
C     NSKIP  - NO. RECORDS TO SKIP ON APPENDED FILES (1 OR GREATER),
C              NEGATIVE IF EIGENVALUE PROBLEM.
C     SUBNAM - RESERVED FOR FUTURE USE
C
      INTEGER         BGPDT,CSTM,CASECC,EQEXIN,GM,GPL,NAME(2),OQM,PGG,
     1                QG,SF(7),SIL,UGV,USET,PARM,KFIL(14),TRL,SFL(7)
      CHARACTER       UFM*23,UWM*25
      COMMON /XMSSG / UFM,UWM
      COMMON /BLANK / IOPT,IGRID,NSKIP
      COMMON /EQMK1 / K(21),KMPC,KLOAD,KSPC ,PARM(4),TRL(7)
      COMMON /SYSTEM/ KSYSTM(80)
      EQUIVALENCE     (KSYSTM(2),NOUT),(K(1),CASECC),(K(2),EQEXIN),
     1                (K(3),GPL),(K(4),BGPDT),(K(5),SIL),(K(6),USET),
     2                (K(7),KGG),(K(8),GM),(K(9),UGV),(K(10),PGG),
     3                (K(11),QG),(K(12),CSTM),(K(13),LAMA),(K(14),OQM),
     4                (K(15),SF(1))
      DATA     KFIL /
C          ... CASECC,EQEXIN,GPL,BGPDT,SIL,USET,KGG,GM ,UGV,PGG,QG,CSTM,
     1         101  , 102,   103,104,  105,106, 107,108,109,110,111,112,
C          ... LAMA , OQM .....
     2         110  , 201 /
      DATA     SFL  / 301,302,303,304,305,306,307 /
      DATA     NAME / 4HEQMC, 2HK  /
C
      OQM   = 0
      KMPC  = 0
      KSPC  = 0
      KLOAD = 0
      PARM(3) = NAME(1)
      PARM(4) = NAME(2)
      DO 5 I = 1,7
    5 SF(I) = SFL(I)
C
      DO 10 I = 1,11
      TRL(1) = KFIL(I)
      CALL RDTRL (TRL)
      K(I) = TRL(1)
   10 CONTINUE
      LAMA = K(10)
      CSTM = KFIL(12)
C
C     ALWAYS NECESSARY FILES
C
      PARM(2) = KFIL(1)
      IF (CASECC .LT. 0) GO TO 120
      PARM(2) = KFIL(2)
      IF (EQEXIN .LT. 0) GO TO 120
      PARM(2) = KFIL(13)
      IF (NSKIP.LT.0 .AND. LAMA.LT.0) GO TO 120
C
C     FILES FOR OQM
C
      L = 0
      IF (IOPT .LT. 0) GO TO 40
      IF (GPL.LT.0 .OR. SIL.LT.0 .OR. USET.LT.0) GO TO 20
      OQM = KFIL(14)
C
C     MPC CONSTRAINTS
C
   20 IF (GM.LT.0 .OR. UGV.LT.0 .OR. KGG.LT.0) GO TO 30
      KMPC = 1
   30 IF (KMPC.LE.0 .OR. IOPT.LT.0) OQM = -KFIL(14)
      IF (OQM  .GT. 0) GO TO 40
      IF (IOPT .LT. 0) GO TO 40
      CALL PAGE2 (2)
      WRITE  (NOUT,35) UWM,NAME
   35 FORMAT (A25,' 2370, MULTI-POINT CONSTRAINT FORCES NOT CALCULATED',
     1       ' IN ',A4,A2,' DUE TO MISSING INPUT FILE.')
      IF (IOPT .EQ. 0) GO TO 70
C
C     ST1 CALCULATION
C
CWKBD 11/93 SPR93007   40 IF (IOPT  .EQ. 0) GO TO 60
CWKBD 11/93 SPR93007      IF (BGPDT .LT. 0) GO TO 50
CWKBI 11/93 SPR93007
   40 CONTINUE
      IF (PGG.GE.0 .AND. NSKIP.GE.0) KLOAD  = 1
      IF (QG .GE. 0) KSPC = 1
      L = KSPC + KMPC + KLOAD
CWKBNB 11/93 SPR93007
      IF (IOPT  .EQ. 0) GO TO 60
      IF (BGPDT .LT. 0) GO TO 50
CWKBNE 11/93 SPR93007
      IF (L .GT. 0) GO TO 60
   50 CALL PAGE2 (2)
      WRITE (NOUT,110) UWM,NAME
      IF (IOPT .LT. 0) GO TO 70
      IOPT = 0
C
   60 CONTINUE
      IF (IOPT.LT.0 .AND. L  .EQ.0) GO TO 70
      IF (IOPT.EQ.0 .AND. OQM.LE.0) GO TO 70
      IF (IOPT.GT.0 .AND. L.EQ.0 .AND. OQM.LE.0) GO TO 70
C
C     CREATE MPC DATA AND OQM
C
      IF (KMPC.GT.0 .OR. (NSKIP.GT.1 .AND. L.GT.0)) CALL EQMCKM
      IF (L .EQ. 0) GO TO 70
C
C     CALCULATE D-T FOR ST1
C
      I = IGRID
      CALL EQMCKA (IGRID,BGPDT,CSTM,EQEXIN,SF(2),L)
      IF (IGRID .NE. 0) IGRID = I
      IF (L .EQ. 0) GO TO 140
C
C     CALCULATE AND OUTPUT ST1
C
      CALL EQMCKS
C
   70 RETURN
C
C     ERROR MESSAGES
C
  110 FORMAT (A25,' 2371, EQUILIBRIUM FORCES NOT CALCULATED IN ',A4,A2,
     1       ' DUE TO MISSING INPUT FILE.')
  120 PARM(1) = 1
      CALL MESAGE (PARM(1),PARM(2),PARM(3))
      GO TO 70
C
  140 CALL PAGE2 (2)
      WRITE  (NOUT,150) UWM,NAME
  150 FORMAT (A25,' 2372, ',A4,A2,' IS UNABLE TO CALCULATE RIGID BODY ',
     1       'TRANSFORMATION FOR SCALAR MODEL.')
      GO TO 70
      END

      SUBROUTINE FNDNXL (NAME,NEWNM)
C
C     THE SUBROUTINE LOOKS FOR A HIGHER LEVEL SUBSTRUCTURE TO THE
C     SUBSTRUCTURE NAME.  IF NAME DOES HAVE A HIGHER LEVEL SUBSTRUCTURE,
C     THE NAME OF THE HIGHER LEVEL SUBSTRUCTURE WILL BE RETURNED IN
C     NEWNM.  IF NAME DOES NOT HAVE A HIGHER LEVEL SUBSTRUCTURE, NAME
C     WILL BE RETURNED IN NEWNM.  IF NAME IS NOT KNOWN TO THE SYSTEM,
C     BLANKS WILL BE RETURNED IN NEWNM.
C
      EXTERNAL        ANDF
      LOGICAL         DITUP,MDIUP
      INTEGER         ANDF,BUF,DIT,DITPBN,DITLBN,DITSIZ,DITNSB,DITBL,
     1                MDI,MDIPBN,MDILBN,MDIBL,HL
      DIMENSION       NAME(2),NEWNM(2),NMSBR(2)
      COMMON /ZZZZZZ/ BUF(1)
      COMMON /SOF   / DIT,DITPBN,DITLBN,DITSIZ,DITNSB,DITBL,IODUM(8),
     1                MDI,MDIPBN,MDILBN,MDIBL,NXTDUM(15),DITUP,MDIUP
      DATA    HL    / 2     /
      DATA    IEMPTY/ 4H    /, NMSBR /4HFNDN,4HXL  /
C
      CALL CHKOPN (NMSBR(1))
      CALL FDSUB  (NAME(1),K)
      IF (K .NE. -1) GO TO 10
      NEWNM(1) = IEMPTY
      NEWNM(2) = IEMPTY
      RETURN
C
C     FIND THE HIGHER LEVEL SUBSTRUCTURE TO NAME.
C
   10 CALL FMDI (K,IMDI)
      I = ANDF(BUF(IMDI+HL),1023)
      IF (I .EQ. 0) GO TO 20
C
C     NAME DOES HAVE A HIGHER LEVEL SUBSTRUCTURE.
C
      CALL FDIT (I,JDIT)
      NEWNM(1) = BUF(JDIT  )
      NEWNM(2) = BUF(JDIT+1)
      RETURN
C
C     NAME DOES NOT HAVE A HIGHER LEVEL SUBSTRUCTURE.
C
   20 NEWNM(1) = NAME(1)
      NEWNM(2) = NAME(2)
      RETURN
      END

      SUBROUTINE PKQDM1
C  THIS ROUTINE CALCULATES PHASE I OUTPUT FOR THE QUAD-MEMBRAND IN
C   PLA4
C
      REAL IVEC,JVEC,KVEC
      INTEGER NECPT(100)
      DIMENSION M(12),R(6),NGRID(4),COORD(16),S(27)
C
      COMMON /CONDAS/ CONSTS(5)
      COMMON /PLA42C/ DUMCL(149),NOGO
      COMMON /PLA42S/ DUMMY(100),SUM(36),STEMP(9),D1(3),D2(3),A1(3),
     1 A2(3),A3(3),A4(3),IVEC(3),JVEC(3),KVEC(3),VECL,H,V(8),ECPTSA(36),
     2 ST(3),NCOORD,NPOINT,NSUB1,NSUB2,NSUB3,T(9),COSANG,SINANG,U1,U2,
     3  THETA, DUMY(85)
      COMMON /PLA4ES/ ECPT(100),PH1OUT(200)
      COMMON /MATIN / MATID,INFLAG,ELTEMP,STRESS,SINTH,COSTH
C
      EQUIVALENCE ( CONSTS(4) , DEGRA  )
      EQUIVALENCE (NECPT(1),ECPT(1))
      EQUIVALENCE (R(1),IVEC(1)),(NGRID(1),ECPTSA(2)),
     1   (COORD(1),ECPTSA(10))  ,  (S(1),PH1OUT(10))
C
      DATA  M / 1, 2, 4, 2, 3, 1, 3, 4, 2, 4, 1, 3 /
C     ******************************************************************
C          ECPT                       ECPT
C       RECEIVED BY                REQUIRED BY
C         SQDME1                     STRME1
C     ******************************************************************
C     ECPT( 1) = EL. ID          ECPT( 1) = EL. ID
C     ECPT( 2) = GRD. PT. A      ECPT( 2) = GRD. PT. A
C     ECPT( 3) = GRD. PT. B      ECPT( 3) = GRD. PT. B
C     ECPT( 4) = GRD. PT. C      ECPT( 4) = GRD. PT. C
C     ECPT( 5) = GRD. PT. D      ECPT( 5) = THETA
C     ECPT( 6) = THETA           ECPT( 6) = MATERIAL ID
C     ECPT( 7) = MATERIAL ID     ECPT( 7) = T
C     ECPT( 8) = T               ECPT( 8) = NON-STRUCT. MASS
C     ECPT( 9) = NON-STRUCT. MASSECPT( 9) = COORD. SYS. ID 1
C     ECPT(10) = COORD. SYS. ID 1ECPT(10) = X1
C     ECPT(11) = X1              ECPT(11) = Y1
C     ECPT(12) = Y1              ECPT(12) = Z1
C     ECPT(13) = Z1              ECPT(13) = COORD. SYS. ID 2
C     ECPT(14) = COORD. SYS. ID 2ECPT(14) = X2
C     ECPT(15) = X2              ECPT(15) = Y2
C     ECPT(16) = Y2              ECPT(16) = Z2
C     ECPT(17) = Z2              ECPT(17) = COORD. SYS. ID 3
C     ECPT(18) = COORD. SYS. ID 3ECPT(18) = X3
C     ECPT(19) = X3              ECPT(19) = Y3
C     ECPT(20) = Y3              ECPT(20) = Z3
C     ECPT(21) = Z3              ECPT(21) = ELEMENT TEMPERATURE
C     ECPT(22) = COORD. SYS. ID 4    NOTE. THE FOLLOWING ARE INTEGERS...
C     ECPT(23) = X4                  GRID POINTS, MAT ID, EL.ID,
C     ECPT(24) = Y4                  COORD. SYS. IDS.
C     ECPT(25) = Z4                  ALL OTHERS ARE REAL IN THE ECPT.
C     ECPT(26) = ELEMENT TEMPERATURE
C     ******************************************************************
C
C
C     VECTORS D1 AND D2  FMMS-46 PAGE 6
C     A1 A2 A3 A4
C
      DO 10 I=1,3
      D1(I) = ECPT(I + 18) - ECPT(I + 10)
      D2(I) = ECPT(I + 22) - ECPT(I + 14)
      A1(I) = ECPT(I + 14) - ECPT(I + 10)
      A2(I) = ECPT(I + 18) - ECPT(I + 14)
      A3(I) = ECPT(I + 22) - ECPT(I + 18)
   10 A4(I) = ECPT(I + 10) - ECPT(I + 22)
C
C     K-VECTOR = NORMALIZED D1 CROSS D2
C
      KVEC(1) = D1(2) * D2(3) - D1(3) * D2(2)
      KVEC(2) = D1(3) * D2(1) - D1(1) * D2(3)
      KVEC(3) = D1(1) * D2(2) - D1(2) * D2(1)
      VECL = SQRT ( KVEC(1)**2 + KVEC(2)**2 + KVEC(3)**2 )
      IF (VECL.LT.1.0E-06) GO TO 120
      KVEC(1) = KVEC(1)/VECL
      KVEC(2) = KVEC(2)/VECL
      KVEC(3) = KVEC(3)/VECL
C
C     I-VECTOR = NORMALIZED A SUB 12 - H * KVECTOR
C     GET H FIRST = ( A SUB 12 DOT KVECTOR)/2
C
      H = (A1(1)*KVEC(1) + A1(2)*KVEC(2) + A1(3)*KVEC(3))/2.0E0
C
      IVEC(1) = A1(1) - H * KVEC(1)
      IVEC(2) = A1(2) - H * KVEC(2)
      IVEC(3) = A1(3) - H * KVEC(3)
      VECL = SQRT ( IVEC(1)**2 + IVEC(2)**2 + IVEC(3)**2 )
      IF (VECL.LT.1.0E-06) GO TO 120
      IVEC(1) = IVEC(1)/VECL
      IVEC(2) = IVEC(2)/VECL
      IVEC(3) = IVEC(3)/VECL
C
C     J-VECTOR = K CROSS I
C
      JVEC(1) = KVEC(2) * IVEC(3) - KVEC(3) * IVEC(2)
      JVEC(2) = KVEC(3) * IVEC(1) - KVEC(1) * IVEC(3)
      JVEC(3) = KVEC(1) * IVEC(2) - KVEC(2) * IVEC(1)
C
      VECL = SQRT(JVEC(1)**2 + JVEC(2)**2 + JVEC(3)**2)
      JVEC(1) = JVEC(1)/VECL
      JVEC(2) = JVEC(2)/VECL
      JVEC(3) = JVEC(3)/VECL
C
      THETA = ECPT(6) * DEGRA
      SINANG = SIN(THETA)
      COSANG = COS(THETA)
C
      V(1) = 1.0E0
      V(2) = 0.0E0
C
C     R ARRAY IS EQUIVALENCED TO IVECTOR AND JVECTOR
C
      CALL GMMATS(R,2,3,0,  A2,3,1,0,  V(3))
      CALL GMMATS(R,2,3,0,  A3,3,1,0,  V(5))
      CALL GMMATS(R,2,3,0,  A4,3,1,0,  V(7))
C
C     NORMALIZE THE 4 2X1 V ARRAYS
C
      DO 20 I=1,4
      VECL = SQRT ( V(2*I-1)**2 + V(2*I)**2 )
      IF(VECL .LT. 1.0E-10) CALL MESAGE(-30,26,ECPT(1))
      V(2*I-1) = V(2*I-1)/VECL
   20 V(2*I  ) = V(2*I  )/VECL
C
C     MAPPING MATRIX M IS IN DATA STATEMENT.
C
C     NOW MAKE 4 CALLS TO PKTRM1 WHICH WILL RETURN
C     S , S , S , S , T SUB 0
C      A   B   C   T
C
C     SAVE GRID SILS AND COORDINATE SYSTEMS.
C
      DO 30 I=1,36
   30 ECPTSA(I) = ECPT(I)
C
      ECPT(6) = ECPT(7)
      ECPT(7) = ECPT(8)
      ECPT(8) = ECPT(9)
C
C     ZERO OUT SUM MATRICES
C
      DO 40 I=1,36
   40 SUM(I) = 0.0E0
      ST(1) = 0.0E0
      ST(2) = 0.0E0
      ST(3) = 0.0E0
C
      DO 90 I=1,4
C
C     POINTER TO THE SILS IN THE MAPPING MATRIX
      NCOORD = 8
      NPOINT = 3*I-3
      DO 60 J=2,4
      NPOINT = NPOINT + 1
      NSUB1 = M(NPOINT)
      DO 50 K=1,4
      NSUB3 = 4*NSUB1 - 4 + K
      NCOORD = NCOORD + 1
   50 ECPT(NCOORD) = COORD(NSUB3)
   60 NECPT(J) = NGRID( NSUB1 )
C
C     SET UP T MATRIX FOR THIS TRIANGLE.  T IS 3X3
C
      U1 = V(2*I-1)
      U2 = V(2*I  )
C
      T(1) = U1 ** 2
      T(2) = U2 ** 2
      T(7) = U1 * U2
      T(3) = -2.0E0 * T(7)
      T(4) = T(2)
      T(5) = T(1)
      T(6) = -T(3)
      T(8) = -T(7)
      T(9) = T(1) - T(2)
C
C     COMPUTE NET SINTH AND COSTH FOR ANISOTROPIC POSSIBILITY
C
      SINTH = SINANG * U1 - COSANG * U2
      COSTH = COSANG * U1 + SINANG * U2
C
      CALL PKTRM1 (1)
C
C
C     NOW TRANSFORM AND ADD THE S MATRICES INTO THE RESPECTIVE SUM
C     MATRICES.
C
      DO 80 J=1,3
C
C     POINTER TO TRIANGLE I ROW IN THE MAPPING MATRIX
C
      NPOINT = 3*I-3
C
C     TRANSFORM S
C
      CALL GMMATS( T,3,3,0,  S(9*J-8),3,3,0,  STEMP )
C
C     ADD STEMP INTO RESPECTIVE KSUM POSITIONS
C
C     ZERO POINTER INTO KSUM MATRICES
      NSUB1 = NPOINT + J
      NSUB1 = M(NSUB1)*9 - 9
      DO 70 K=1,9
      NSUB1 = NSUB1 + 1
   70 SUM(NSUB1) = SUM(NSUB1) + STEMP(K)
   80 CONTINUE
   90 CONTINUE
C
C     ALL MATRICES COMPLETE
C
C     FILL OUTPUT BLOCK
C
      DO 100 I=1,5
  100 PH1OUT(I) = ECPTSA(I)
      DO 110 I=1,36
  110 PH1OUT(I+9) = 0.25E0 * SUM(I)
C     PHASE 1 COMPLETE OUTPUT BLOCK CONTAINS 45 WORDS
C
      RETURN
  120 CALL MESAGE(30,26,ECPT(1))
C
C  SET FLAG FOR FATAL ERROR WHILE ALLOWING ERROR MESSAGES TO ACCUMULATE
C
      NOGO=1
      RETURN
      END

      SUBROUTINE XPOLCK (DBN1,DBN2,FN,L)
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        LSHIFT   ,  ANDF    ,   ORF
      DIMENSION       NPOLCK(2),  DDBN( 1),   DFNU( 1),  FCUM( 1),
     1                FCUS(  1),  FDBN( 1),   FEQU( 1),  FILE( 1),
     2                FKND(  1),  FMAT( 1),   FNTU( 1),  FPUN( 1),
     3                FON (  1),  FORD( 1),   MINP( 1),  MLSN( 1),
     4                MOUT(  1),  MSCR( 1),   SAL ( 1),  SDBN( 1),
     5                SNTU(  1),  SORD(  1)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG / UFM,UWM,UIM,SFM
      COMMON /SYSTEM/ KSYSTM(65)
      COMMON /XFIAT / FIAT(7)
      COMMON /XFIST / FIST
      COMMON /XDPL  / DPD(6)
      COMMON /XSFA1 / MD(401),SOS(1501),COMM(20),XF1AT(5)
      EQUIVALENCE    (KSYSTM(2),OUTTAP  )
      EQUIVALENCE               (DPD  (1),DNAF    ),(DPD  (2),DMXLG   ),
     1      (DPD  (3),DCULG   ),(DPD  (4),DDBN (1)),(DPD  (6),DFNU (1)),
     2      (FIAT (1),FUNLG   ),(FIAT (2),FMXLG   ),(FIAT (3),FCULG   ),
     3      (FIAT (4),FEQU (1)),(FIAT (4),FILE (1)),(FIAT (4),FORD (1)),
     4      (FIAT (5),FDBN (1)),(FIAT (7),FMAT (1)),(MD   (1),MLGN    ),
     5      (MD   (2),MLSN (1)),(MD   (3),MINP (1)),(MD   (4),MOUT (1)),
     6      (MD   (5),MSCR (1)),(SOS  (1),SLGN    ),(SOS  (2),SDBN (1)),
     7      (SOS  (4),SAL  (1)),(SOS  (4),SNTU (1)),(SOS  (4),SORD (1)),
     8      (XF1AT(1),FNTU (1)),(XF1AT(1),FON  (1)),(XF1AT(2),FPUN (1)),
     9      (XF1AT(3),FCUM (1)),(XF1AT(4),FCUS (1)),(XF1AT(5),FKND (1))
      EQUIVALENCE               (COMM (1),ALMSK   ),(COMM (2),APNDMK  ),
     1      (COMM (3),CURSNO  ),(COMM (4),ENTN1   ),(COMM (5),ENTN2   ),
     2      (COMM (6),ENTN3   ),(COMM (7),ENTN4   ),(COMM (8),FLAG    ),
     3      (COMM (9),FNX     ),(COMM(10),LMSK    ),(COMM(11),LXMSK   ),
     4      (COMM(12),MACSFT  ),(COMM(13),RMSK    ),(COMM(14),RXMSK   ),
     5      (COMM(15),S       ),(COMM(16),SCORNT  ),(COMM(17),TAPMSK  ),
     6      (COMM(18),THCRMK  ),(COMM(19),ZAP     )
      DATA   POOL    /4HPOOL       /
      DATA   NPOLCK  /4HXPOL,4HCK  /
C
C
C     XPOLCK CHECKS THE DATA POOL DICT FOR A DATA BLOCK NAME
C
      LMT1 = DCULG*ENTN4
      DO 1 I = 1,LMT1,ENTN4
      IF (DBN1.NE.DDBN(I) .OR. DBN2.NE.DDBN(I+1)) GO TO 1
      FN = ANDF(RMSK,DFNU(I))
      L  = I
      RETURN
C
    1 CONTINUE
      FN = 0
      RETURN
C
C
      ENTRY XFILPS (NEW)
C     ==================
C
C     XFILPS POSITIONS THE POOL TAPE FORWARD OR BACKWARD
C
C     NEW IS DESIRED POSITION
C     FNX IS CURRENT POSITION
C
      FDIF = NEW - FNX
      IF (FDIF) 10,30,20
   10 FDIF = FDIF - 1
   20 CALL SKPFIL (POOL,FDIF)
      IF (FDIF.LT.0 .AND. NEW.NE.1) CALL SKPFIL (POOL,+1)
   30 RETURN
C
C
      ENTRY XPLEQK (NX,NY)
C     ====================
C
C     XPLEQK MOVES SECONDARY EQUIVALENCED DATA BLOCK NAMES FROM THE
C     POOL DICT. TO FIAT.   NTU-LTU DATA ARE ALSO STORED IN FIAT FOR THE
C     EQUIV. D.B.   NTU-LTU DATA IS EXTRACTED FROM SOS IF FOUND, IF NOT,
C     IT IS COPIED FROM THE CALLING PRIMARY D.B.
C
C     NX IS THE POOL DICT. INDEX
C     NY IS THE FIAT INDEX FOR PRIMARY D.B.
C
      FEQU(NY) = ORF(S,FEQU(NY))
      KFIL = ANDF(RMSK,DFNU(NX))
      LMT1 = DCULG*ENTN4
      LMT2 = SLGN *ENTN2
      LMT3 = FCULG*ENTN1
      NFCULG = LMT3 + 1
C
C     SEARCH FOR EQUIV FILES IN DICT
C
      DO 150 I = 1,LMT1,ENTN4
      IF (DDBN(I).EQ.0 .AND. DDBN(I+1).EQ.0) GO TO 150
      IF (KFIL .NE. ANDF(RMSK,DFNU(I))) GO TO 150
      IF (I .EQ. NX) GO TO 150
C
C     SEE IF NAME IS IN FIAT
C
      DO 100 J = 1,LMT3,ENTN1
      IF (DDBN(I).EQ.FDBN(J) .AND. DDBN(I+1).EQ.FDBN(J+1)) GO TO 115
  100 CONTINUE
      FDBN(NFCULG  ) = DDBN(I  )
      FDBN(NFCULG+1) = DDBN(I+1)
      FILE(NFCULG) = FILE(NY)
      FNTU(NFCULG) = FNTU(NY)
      FORD(NFCULG) = ORF(LSHIFT(1000,16),ANDF(RMSK,FILE(NFCULG)))
      FEQU(NFCULG) = ORF(S,FEQU(NFCULG))
      DO 110 J = 1,LMT2,ENTN2
      IF (DDBN(I).EQ.SDBN(J) .AND. DDBN(I+1).EQ.SDBN(J+1)) GO TO 120
  110 CONTINUE
      GO TO 140
C
C     FILE ALREADY ALLOCATED  BE SURE EQUIVED
C
  115 FILE(J) = ORF(ANDF(RMSK,FILE(NY)),ANDF(LMSK,FILE(J)))
      FEQU(J) = ORF(S,FEQU(J))
      GO TO 150
  120 FORD(NFCULG) = ORF(ANDF(LMSK,SORD(J)),ANDF(RMSK,FILE(NFCULG)))
      FEQU(NFCULG) = ORF(S,FEQU(NFCULG))
      FNTU(NFCULG) = SNTU(J)
  140 NFCULG = NFCULG+ ENTN1
      FCULG  = FCULG + 1
C
C     FLAG INDICATES D.B. S HAVE BEEN ADDED TO FIAT
C
      FLAG = -1
      IF (FCULG .GT. FMXLG) GO TO 900
  150 CONTINUE
      RETURN
C
  900 WRITE  (OUTTAP,901) SFM
  901 FORMAT (A25,' 1051, FIAT OVERFLOW')
      CALL MESAGE (-37,0,NPOLCK)
      RETURN
      END

      SUBROUTINE STRM62 (TI)
C
C
C     PHASE II OF STRESS DATA RECOVERY FOR TRIANGULAR MEMBRANE ELEMENT
C     TRIM6
C
C     PHASE I OUTPUT IS THE FOLLOWING
C
C     PH1OUT(1)               ELEMENT ID
C     PH1OUT(2, THRU 7)       6 S1L5
C     PH1OUT(8 THRU 10)       THICKNESSES AT CORNER GRID POINT
C     PH1OUT(11)              REFERENCE TEMPERATURE
C     PH1OUT(12)-(227)        S SUB I MATRICES FOR 4 POINTS
C     PH1OUT(228)-(230)       THERMAL VECTOR - G TIMES ALPHA
C
C
      INTEGER         TLOADS
      DIMENSION       TI(6),NS1L(6),NPH1OU(990),STR(18),SI(36),
     1                STOUT(99),STRESS(3)
      COMMON /ZZZZZZ/ Z(1)
      COMMON /SDR2X4/ DUMMY(35),IVEC,IVECN,LDTEMP,DEFORM,DUM8(8),TLOADS
      COMMON /SDR2X7/ PH1OUT(250)
      COMMON /SDR2X8/ TEMP,DELTA,NPOINT,IJ1,IJ2,NPT1,VEC(5),TEM
      EQUIVALENCE     (NS1L(1),PH1OUT(2)),(NPH1OU(1),PH1OUT(1)),
     1                (SI(1),PH1OUT(11)),(LDTEMP,FTEMP)
C
      DO 155 II=1,4
C
C     ZERO OUT LOCAL STRESSES
C
      SIG X  1 =0.0
      SIG Y  1 =0.0
      SIG XY 1 =0.0
      SIG X  2 =0.0
      SIG Y  2 =0.0
      SIG XY 2 =0.0
      IF (NS1L(1).EQ.0) GO TO 90
C
C     ZERO STRESS VECTOR STORAGE
C
      DO 42 I=1,3
      STRESS(I)=0.0
   42 CONTINUE
C
C                        I=6
C     STRESS VECTOR =(SUMMATION (5 )(U ) ) - (S )(TEMP      - TEMP   )
C                        I=1      I   I        T      POINT       REF
C
      DO 60 I=1,6
C
C     POINTER TO I-TH SIL IN PH1OUT
C
      NPOINT = IVEC + NPH1OU(I+1) - 1
C
C     POINTER TO  3X3 S SUB I MATRIX
C
      NPT1=12+(I-1)*9+(II-1)*54
C
      CALL GMMATS (PH1OUT(NPT1),3,3,0,Z(NPOINT),3,1,0,VEC(1))
      DO 50 J=1,3
      STRESS(J)=STRESS(J)+VEC(J)
      STR(J)=STRESS(J)
   50 CONTINUE
   60 CONTINUE
      IF (LDTEMP.EQ.(-1)) GO TO 80
      II12=II*2-1
      IF (II.NE.4) TEM=TI(II12)-PH1OUT(11)
      IF( II.EQ.4) TEM=(TI(1)+TI(2)+TI(3)+TI(4)+TI(5)+TI(6))/6.0-
     1    PH1OUT(11)
      DO 70 I=1,3
      STRESS(I)=STRESS(I)-PH1OUT(227+I)*TEM
      STR(I)=STRESS(I)
   70 CONTINUE
   80 CONTINUE
   90 IF (NPH1OU(2).EQ.0) GO TO 120
C
C     COMPUTE PRINCIPAL STRESSES
C
C
C     8 LOCATIONS FOR STRESS AT A POINT AS FOLLOWS
C
C      1. ELEMENT ID
C      2. SIGMA X1
C      3. SIGMA Y1
C      4. SIGMA XY1
C      5. ANGLE OF ZERO SHEAR
C      6. SIGMA PRINCIPAL STRESS 1
C      7. SIGMA PRINCIPAL STRESS 2
C      8. TAU MAX
C
C     FOR EACH POINT, THESE VALUES ARE STORED IN STOUT(1-8,9-16,
C     17-24,25-32) ALSO IN LOCATIONS STR(1-7) EXCEPT THE ELEMENT ID
C     FINALLY, THESE VALUES ARE STORED IN PH1OUT(101-108,109-115,
C     116-122,123-129)
C
      TEMP = STRESS(1)-STRESS(2)
      TEMP1= SQRT ((TEMP/2.0E0)**2 + STRESS(3)**2)
      STR(7)= TEMP1
      DELTA= (STRESS(1)+STRESS(2))/2.0
      STR(5)=DELTA+TEMP1
      STR(6)=DELTA-TEMP1
      DELTA= 2.0E0 * STRESS(3)
      IF (ABS(DELTA).LT.1.0E-15.AND.ABS(TEMP).LT.1.0E-15) GO TO 100
      STR(4)=ATAN2(DELTA,TEMP)*28.6478898E0
      GO TO 110
  100 STR(4)=0.0
  110 CONTINUE
      GO TO 140
  120 DO 130 I=1,9
      STR(I)=0.0E0
  130 CONTINUE
  140 CONTINUE
      IJK=(II-1)*8
      STOUT(IJK+1)=PH1OUT(1)
      DO 149 I=2,8
  149 STOUT(IJK+I)=STR(I-1)
  155 CONTINUE
      DO 156 I=1,8
  156 PH1OUT(100+I)=STOUT(I)
      DO 159 J=1,3
      DO 159 I=1,7
      J1=108+(J-1)*7+I
      J2=J*8+I+1
      PH1OUT(J1)=STOUT(J2)
  159 CONTINUE
      RETURN
      END

      SUBROUTINE DETM
      DOUBLE PRECISION P,DETX,PS1,DET1
      INTEGER PREC,SCR1,SCR2,SCR3,SCR4,SCR5,SCR6,SCR7
      INTEGER NAME(2)
      COMMON /DETMX/P(4),DETX(4),PS1(4),DET1(4),N2EV,IPSAV,IPS,IDET,
     1  IPDETA,PREC,NSTART,NDCMP,IC, NSMOVE,ITERM,IS,ND,IADD,SML1,
     2  IPDETX(4),IPDET1(4), IFAIL,K,FACT1,IFFND,NFAIL
     3, NPOLE,ISNG
      COMMON  /REGEAN/ IM(7),IK(7),IEV(7),SCR1,SCR2,SCR3,SCR4,SCR5,LCORE
     1 , RMAX,RMIN,MZ,NEV,EPSI,RMINR,NE,NIT,NEVM,SCR6,SCR7
     2  ,NFOUND,LAMA
      DATA NAME/4HDETE,4HRM  /
C
C     RMAX = APPROXIMATE MAGNITUDE OF LARGEST EIGENVALUE OF INTEREST
C
C     RMIN = LOWEST  NON-ZERO  EIGENVALUE
C
C     MZ = NUMBER OF ZERO EIGENVALUES
C
C     NEV = NUMBER OF NON-ZERO EIGENVALUES IN RANGE OF INTEREST
C
C     EPSI = CONVERGENCE CRITERION
C
C     RMINR = LOWEST EIGENVALUE OF INTEREST
C
C     NE   =  NUMBER OF PERMISSIBLE CHANGES OF EPSI
C
C     NIT = INTERATIONS TO AN EIGENVALUE
C
C     NEVM = MAXIMUM NUMBER OF EIGENVALUES DESIRED
C
C     IS  = STARTING SET COUNTER
C
C     IC  = COUNTER FOR CHANGE OF CONVERGENCE CRITERIA
C
C     NFOUND  = THE NUMBER OF EIGENVALUES FOUND TO DATA
C
C      IM = MASS MATRIX CONTROL BLOCK
C
C      IK = K MATRIX CONTROL BLOCK
C
C        A = M +P*K
C
C     IEV = EIGENVECTOR CONTROL BLOCK
C
      NSTART =0
      LCORE=0
      NDCMP = 0
      NSMOVE =0
      NPOLE =0
      ITERM = 1
      IFFND = 0
      NFAIL =0
C*****
      PREC = IK(5)
C*****
      ISCR7 = SCR7
      IF(MZ .GT. NEVM) GO TO 40
      IF (IM(1) .GT. 0) GO TO 5
C
C     MASS MATRIX PURGED -- ASSUME IDENTITY
C
      IM(1) =  IK(1)
      CALL RDTRL(IM(1))
      IM(4) =8
    5 CONTINUE
      CALL DETM1(*60)
   10 CALL KLOCK(ITIME1)
      CALL DETM3(*30,*40,*11)
      NFOUND = NFOUND+1
      CALL FDVECT(SML1,P(3))
      IDONE=NFOUND+1
      IF(MZ .GT. 0)  IDONE=IDONE+MZ
      CALL DETM4
      IF(IDONE .GT. NEVM) GO TO 50
      CALL KLOCK(ITIME2)
      CALL TMTOGO(ITLEFT)
      IF(2*(ITIME2-ITIME1) .LE. ITLEFT) GO TO 10
C
C     INSUFFICIENT TIME TO FIND ANOTHER E. V.
C
   11 CONTINUE
      CALL MESAGE(45,NEVM-IDONE,NAME)
      ITERM = 3
      GO TO 50
   20 RETURN
   30 CALL DETM2
      GO TO 10
   40 ITERM = 2
   50 SCR7 = ISCR7
      CALL DETM5
      GO TO 20
C
C     SINGULAR MATRIX EVERYWHERE
C
   60 ITERM = 4
      GO TO 50
      END

      SUBROUTINE GP4PRT (IBUF)
C
C     1. PRINTS  DOF VS. DISP. SETS IF DIAG 21 ON.
C     2. PRINTS  DISP. SETS VS. DOF IF DIAG 22 ON.
C     3. CREATES SUBSTRUCTURE COUPLING DATA TABLE.
C
C     IF IBUF IS .LT. 0, SOME FILES MAY NOT BE CLOSED PROPERLY WHEN
C     THIS ROUTINE IS CALLED
C
      EXTERNAL        ANDF,ORF
      INTEGER         TITLE(2,8),Z,SYSBUF,ANDF,EQEXIN,ORF,FILE,NAME(3),
     1                D21,D22,MSK(12),IFLG(8),SCR1,ZDUM(10),ZCOM(10),
     2                EREC1,BUF,TWO,UM,UO,UR,USG,USB,UL,UA,UF,US,UN,UG,
     3                DASH,UPBIT(12),BLANK,TDB204,NAM204(2),TRL(7),
     4                EXFLAG,EXTYPE,SBIT(12),
     5                IFRMAT(32),IIFRMT(2),IAFRMT(2)
      CHARACTER       UFM*23,UWM*25,UIM*29
      COMMON /XMSSG / UFM,UWM,UIM
      COMMON /SYSTEM/ SYSBUF,NOUT,JUNK(6),NLPP,MTEMP,NPAGE,LINE
      COMMON /TWO   / TWO(32)
      COMMON /BITPOS/ UM,UO,UR,USG,USB,UL,UA,UF,US,UN,UG
      COMMON /ZZZZZZ/ Z(1)
      COMMON /BLANK / LUSET,MPCF1,MPCF2,SINGLE,OMIT1,REACT,NSKIP,
     1                REPEAT,NOSETS,NOL,NOA,IDSUB,IAUTSP
      DATA    SCR1  / 301/  , EQEXIN / 103   /, TDB204 / 204 /
      DATA    NAME  / 4HGP4P, 4HRT   , 4H    /
      DATA    IBEGN , IEND  / 4HBEGN , 4HEND /
      DATA    TITLE / 4H    , 4H MPC ,
     2                4H    , 4H SPC ,
     3                4H    , 4HOMIT ,
     4                4HANAL, 4HYSIS ,
     5                4H  SU, 4HPORT ,
     6                4HPERM, 4H SPC ,
     7                4HBDRY, 4H SPC ,
     8                4HAUTO, 4H SPC /
      DATA    BLANK / 1H  /
      DATA    DASH  / 1H- /
      DATA    IFRMAT/ 4H(13X, 4H,I6,, 4H3X,I, 4H8,1X, 4H,A1,, 4HI2,1,
     1                4HX   , 4H,1X,, 4H  I6, 4H,1X,, 4H  I6, 4H,1X,,
     2                4H  I6, 4H,1X,, 4H  I6, 4H,1X,, 4H  I6, 4H,1X,,
     3                4H  I6, 4H,1X,, 4H  I6, 4H,1X,, 4H  I6, 4H,1X,,
     X                4H  I6, 4H,1X,,
     4                4H  I6, 4H,1X,, 4H  I6, 4H,1X,, 4H  I6, 4H)   /
      DATA    IIFRMT/ 4H,1X,, 4H  I6/
      DATA    IAFRMT/ 4H,3X,, 4H  A4/
      DATA    IPRINT/ 0   /
C
C
      CALL SSWTCH (21,D21)
      CALL SSWTCH (22,D22)
      IF (D21.NE.1 .AND. D22.NE.1 .AND. IDSUB.LE.0) RETURN
      IF (IPRINT .EQ. 1) RETURN
      IPRINT  = 1
      NAME(3) = IBEGN
      CALL CONMSG (NAME,3,0)
      BUF  = IABS(IBUF)
      FILE = EQEXIN
      IF (IBUF .LT. 0) CALL CLOSE (EQEXIN,1)
      CALL OPEN (*1220,EQEXIN,Z(BUF),0)
      CALL FWDREC (*1230,EQEXIN)
      CALL FWDREC (*1230,EQEXIN)
      EREC1 = LUSET +1
      CALL READ (*1230,*2900,EQEXIN,Z(EREC1),BUF-EREC1,1,KN)
      GO TO 9001
 2900 CALL CLOSE (EQEXIN,1)
      CALL SORT (0,0,2,2,Z(EREC1),KN)
C
      IF (D21 .NE. 1) GO TO 3000
      KU = 1
      MSK(KU+1 ) = TWO(USB)
      MSK(KU+2 ) = TWO(USG)
      MSK(KU+3 ) = TWO( UL)
      MSK(KU+4 ) = TWO( UA)
      MSK(KU+5 ) = TWO( UF)
      MSK(KU+6 ) = TWO( UN)
      MSK(KU+7 ) = TWO( UG)
      MSK(KU+8 ) = TWO( UR)
      MSK(KU+9 ) = TWO( UO)
      MSK(KU+10) = TWO( US)
      MSK(KU+11) = TWO( UM)
      DO 2910 KU = 1,12
      SBIT(KU) = 0
 2910 CONTINUE
      CALL PAGE1
      LINE = LINE + 2
      WRITE (NOUT,1900) UIM
      LINE = LINE + 4
      WRITE (NOUT,1902)
      I  = EREC1
      KL = 0
      DO 2960 K = 1,KN,2
      ITM = Z(K+I)/10
      ITM = Z(K+I) - 10*ITM
      L   = 6
      IF (ITM .EQ. 2) L = 1
      DO 2950 KK = 1,L
      KL = KL + 1
      IU = Z(KL)
      IP = Z(I+K-1)
      IDOF = KK
      IF (ANDF(MSK(11),IU) .EQ. 0) GO TO 2914
      IF (ANDF(MSK(2),IU).NE.0 .OR. ANDF(MSK(3),IU).NE.0) GO TO 2914
      SBIT(1)   = SBIT(1) + 1
      UPBIT(1)  = SBIT(1)
      IFRMAT(8) = IIFRMT(1)
      IFRMAT(9) = IIFRMT(2)
      GO TO 2916
 2914 UPBIT(1)  = BLANK
      IFRMAT(8) = IAFRMT(1)
      IFRMAT(9) = IAFRMT(2)
 2916 DO 2940 KU = 2,12
      INDEX = 2*(KU-1) + 8
      IF (ANDF(MSK(KU),IU) .EQ. MSK(KU)) GO TO 2920
      UPBIT(KU) = BLANK
      IFRMAT(INDEX  ) = IAFRMT(1)
      IFRMAT(INDEX+1) = IAFRMT(2)
      GO TO 2940
 2920 SBIT (KU) = SBIT(KU) + 1
      UPBIT(KU) = SBIT(KU)
      IFRMAT(INDEX  ) = IIFRMT(1)
      IFRMAT(INDEX+1) = IIFRMT(2)
 2940 CONTINUE
      IF (L .EQ. 1) IDOF = 0
      LINE = LINE + 1
      IF (LINE .LE. NLPP) GO TO 2945
      CALL PAGE1
      WRITE (NOUT,1902)
      LINE = LINE + 5
 2945 WRITE (NOUT,IFRMAT) KL,IP,DASH,IDOF,UPBIT
 2950 CONTINUE
 2960 CONTINUE
      WRITE (NOUT,1901) SBIT
      LINE = LINE + 2
C
 3000 IF (D22.NE.1 .AND. IDSUB.LE.0) RETURN
      MSK(1)  = TWO(UM )
      MSK(2)  = TWO(US )
      MSK(3)  = TWO(UO )
      MSK(4)  = TWO(UA )
      MSK(5)  = TWO(UR )
      MSK(6)  = TWO(USG)
      MSK(7)  = TWO(USB)
      EXFLAG  = 0
      EXTYPE  = 0
      IF (D22 .NE. 1) GO TO 3010
      CALL PAGE1
      LINE = LINE + 2
      WRITE (NOUT,1907) UIM
      LINE = LINE + 4
 3010 FILE = SCR1
      IF (IBUF .LT. 0) CALL CLOSE (SCR1,1)
      CALL OPEN (*1220,SCR1,Z(BUF),1)
      DO 4000 IMK = 1,8
      IFLG(IMK) = 0
      I  = EREC1
      IP = 0
      KL = 0
      DO 3960 K = 1,KN,2
      ITM = Z(K+I)/10
      ITM = Z(K+I) - 10*ITM
      L   = 6
      IF (ITM .EQ. 2) L = 1
      DO 3950 KK = 1,L
      KL = KL + 1
      IU = Z(KL)
      IF (Z(I+K-1) .LT. IP) EXFLAG = 1
      IP = Z(I+K-1)
      IF (L .EQ. 1) GO TO 3920
      IDOF = KK
      EXTYPE = ORF(EXTYPE,2)
      GO TO 3930
 3920 IDOF = 0
      EXTYPE = ORF(EXTYPE,1)
 3930 IF (IMK .NE. 8) GO TO 3940
      IF (ANDF(IU,MSK(2)) .EQ. 0) GO TO 3950
      IF (ANDF(IU,MSK(6)).NE.0 .OR. ANDF(IU,MSK(7)).NE.0) GO TO 3950
      GO TO 3945
 3940 IF (ANDF(IU,MSK(IMK)) .NE. MSK(IMK)) GO TO 3950
 3945 CALL WRITE (SCR1,10*IP+IDOF,1,0)
      IFLG(IMK) = 1
 3950 CONTINUE
 3960 CONTINUE
      IF (IFLG(IMK) .NE. 1) GO TO 4000
      CALL WRITE (SCR1,0,0,1)
 4000 CONTINUE
      CALL WRITE (SCR1,Z(1),LUSET,1)
      CALL CLOSE (SCR1,1)
      CALL OPEN  (*1220,SCR1,Z(BUF),0)
      IFLAG = 0
      DO 4500 I = 1,8
      IF (IFLG(I) .NE. 1) GO TO 4500
      IFLAG = IFLAG + 1
      CALL READ (*1230,*4010,SCR1,Z(1),BUF,1,KN)
      CALL PAGE2 (-4)
      WRITE (NOUT,9501) FILE
      GO TO 4600
 4010 CONTINUE
      IF (IDSUB.LE.0 .OR. I.NE.4) GO TO 4040
      CALL CLOSE (SCR1,2)
      FILE = TDB204
      CALL OPEN  (*1220,TDB204,Z(BUF),1)
      CALL FNAME (TDB204,NAM204)
      CALL WRITE (TDB204,NAM204,2,1)
      CALL WRITE (TDB204,Z(1),KN,1)
      CALL CLOSE (TDB204,1)
      TRL(1) = TDB204
      TRL(2) = 0
      TRL(3) = KN
      TRL(4) = 0
      TRL(5) = IDSUB
      TRL(6) = EXFLAG
      TRL(7) = EXTYPE
      CALL WRTTRL (TRL)
      CALL OPEN (*1220,SCR1,Z(BUF),2)
 4040 CONTINUE
      IF (D22 .NE. 1) GO TO 4500
      IPAS = KN/10
      IREM = KN - 10*IPAS
      IF (IFLAG .GT. 1) LINE = NLPP
      ID1  =-9
      INOS = 0
      IF (IPAS .LT. 1) GO TO 4105
      DO 4100 K = 1,IPAS
      DO 4050 J = 1,10
      INOS = INOS + 1
      ZDUM(J) = Z(INOS)/10
      ZCOM(J) = Z(INOS) - 10*ZDUM(J)
 4050 CONTINUE
      LINE = LINE + 1
      IF (IFLAG.EQ.1 .AND. K.EQ.1) GO TO 4060
      IF (LINE .LE. NLPP) GO TO 4090
      CALL PAGE1
 4060 WRITE (NOUT,1910) TITLE(1,I),TITLE(2,I)
      LINE = LINE + 5
 4090 CONTINUE
      ID1 = ID1 + 10
      WRITE (NOUT,1913) ID1,(ZDUM(KK),ZCOM(KK),KK=1,10)
 4100 CONTINUE
 4105 IF (IREM .EQ. 0) GO TO 4500
      DO 4110 J = 1,IREM
      INOS = INOS + 1
      ZDUM(J) = Z(INOS)/10
      ZCOM(J) = Z(INOS) - ZDUM(J)*10
 4110 CONTINUE
      LINE = LINE + 1
      IF (IFLAG.EQ.1 .AND. IPAS.EQ.0) GO TO 4120
      IF (LINE .LE. NLPP) GO TO 4400
      CALL PAGE1
 4120 WRITE (NOUT,1910) TITLE(1,I),TITLE(2,I)
      LINE = LINE + 5
 4400 CONTINUE
      ID1 = ID1 + 10
      WRITE (NOUT,1913) ID1,(ZDUM(KK),ZCOM(KK),KK=1,IREM)
 4500 CONTINUE
C
C     RE-ESTABLISH USET IN OPEN CORE.
C
 4600 CALL READ (*1230,*9001,SCR1,Z(1),LUSET,1,KN)
      CALL CLOSE (SCR1,1)
      NAME(3) = IEND
      CALL CONMSG (NAME,3,0)
C
C     TERMINATE RUN IF DIAG 21 OR 22, AND DIAG 20 ARE REQUESTED BY UESER
C     SIMLUTANEOUSLY
C
      CALL SSWTCH (20,J)
      IF (J.EQ.0 .OR. D21+D22.EQ.0) RETURN
      WRITE  (NOUT,4700)
 4700 FORMAT (10X,25HJOB TERMINATED BY DIAG 20)
      CALL PEXIT
C
 1220 J = -1
      GO TO 1260
 1230 J = -2
 1260 CALL MESAGE (J,FILE,NAME)
      RETURN
C
 1900 FORMAT (A29,' 2118, SUBROUTINE GP4PRT - DIAG 21 SET-DOF VS. DISP',
     1       ' SETS FOLLOWS.')
 1901 FORMAT (1H0, 34H--- C O L U M N   T O T A L S --- , 12I7)
 1902 FORMAT (1H0,14X,5H(SIL), /14X,
     1        48HINT DOF   EXT GP. DOF  SAUTO     SB     SG      ,
     2        49HL      A      F      N      G      R      O      ,
     3         8HS      M, /1H , 131(1H-))
 1907 FORMAT (A29,' 2119, SUBROUTINE GP4PRT - DIAG 22 SET DISP SETS VS',
     1       '. DOF FOLLOWS')
 1910 FORMAT (1H0,52X,2A4,17H DISPLACEMENT SET ,/
     1        1H0,15X,3H-1-,8X,3H-2-,8X,3H-3-,8X,3H-4-,8X,3H-5-,
     2             8X,3H-6-,8X,3H-7-,8X,3H-8-,8X,3H-9-,7X,4H-10- ,/1H )
 1913 FORMAT (1H ,I6,1H=,10(1X,I8,1H-,I1))
C
C     ERRORS
C
 9001 CALL PAGE2(-4)
      WRITE  (NOUT,9501) UWM,FILE
 9501 FORMAT (A25,' 2110, INSUFFICIENT CORE TO HOLD CONTENTS OF GINO ',
     1       'FILE',I4, //5X,
     2       'FURTHER PROCESSING OF THIS DATA BLOCK IS ABANDONED.')
C
      CALL CLOSE (FILE,1)
      RETURN
C
      END

      SUBROUTINE MMA1 ( ZI, ZR, ZD, ZC, ZDC )
C
C     MMA1 PERFORMS THE MATRIX OPERATION USING METHODS 10 AND 11
C       (+/-)A(T & NT) * B (+/-)C = D
C     
C     MMA1 IS DESIGNED AS FOLLOWS:
C       1.  THIS IS FOR "A" NON-TRANSPOSED AND TRANSPOSED
C       2.  UNPACK AS MANY COLUMNS OF "A" INTO MEMORY AS POSSIBLE
C           LEAVING SPACE FOR ONE COLUMN OF "B" AND "D".
C       3.  INITIALIZE EACH COLUMN OF "D" WITH THE DATA FROM "C".
C       4.  CALL UNPACK TO READ MATRICES "A" AND "C".
C       5.  FOR METHOD 10, CALL UNPACK TO READ COLUMNS OF MATRIX "B".
C       6.  FOR METHOD 11, CALL MMARC1,2,3,4 TO READ COLUMNS OF MATRIX "B"
C           INTO MEMORY IN COMPACT FORM.
C
C
      INTEGER           ZI(2)      ,MODULE(3),SYSBUF,SCRTCH
      INTEGER           TYPEI      ,TYPEP    ,TYPEU ,SIGNAB, SIGNC
      INTEGER           RD         ,RDREW    ,WRT   ,WRTREW, CLSREW,CLS
      INTEGER           OFILE      ,FILEA    ,FILEB ,FILEC , FILED
      REAL              ZR(2)
      DOUBLE PRECISION  ZD(2)
      COMPLEX           ZC(2)
      DOUBLE COMPLEX    ZDC(2)
      COMMON / NAMES  / RD         ,RDREW    ,WRT   ,WRTREW, CLSREW,CLS
      COMMON / TYPE   / IPRC(2)    ,NWORDS(4),IRC(4)
      COMMON / MPYADX / FILEA(7)   ,FILEB(7) ,FILEC(7)    
     1,                 FILED(7)   ,NZ       ,T     ,SIGNAB,SIGNC ,PREC1 
     2,                 SCRTCH     ,TIME
      INCLUDE           'MMACOM.COM'
      COMMON / SYSTEM / KSYSTM(152)
      COMMON / UNPAKX / TYPEU      ,IUROW1   ,IUROWN, INCRU
      COMMON / PACKX  / TYPEI      ,TYPEP    ,IPROW1, IPROWN , INCRP
      EQUIVALENCE       (KSYSTM( 1),SYSBUF)  , (KSYSTM( 2),NOUT  ) 
      EQUIVALENCE       (KSYSTM(58),KSYS58)
      EQUIVALENCE       (FILEA(2)  ,NAC   )  , (FILEA(3)  ,NAR   )
     1,                 (FILEA(4)  ,NAFORM)  , (FILEA(5)  ,NATYPE)
     2,                 (FILEA(6)  ,NANZWD)  , (FILEA(7)  ,NADENS)
      EQUIVALENCE       (FILEB(2)  ,NBC   )  , (FILEB(3)  ,NBR   )
     1,                 (FILEB(4)  ,NBFORM)  , (FILEB(5)  ,NBTYPE)
     2,                 (FILEB(6)  ,NBNZWD)  , (FILEB(7)  ,NBDENS)
      EQUIVALENCE       (FILEC(2)  ,NCC   )  , (FILEC(3)  ,NCR   )
     1,                 (FILEC(4)  ,NCFORM)  , (FILEC(5)  ,NCTYPE)
     2,                 (FILEC(6)  ,NCNZWD)  , (FILEC(7)  ,NCDENS)
      EQUIVALENCE       (FILED(2)  ,NDC   )  , (FILED(3)  ,NDR   )
     1,                 (FILED(4)  ,NDFORM)  , (FILED(5)  ,NDTYPE)
     2,                 (FILED(6)  ,NDNZWD)  , (FILED(7)  ,NDDENS)
C
      DATA    MODULE / 4HMMA1  , 4H     ,4H    /
      DATA    KZERO  / 1H0   /   
      DATA    KONE   / 1H1   /
      DATA    JBEGN  / 4HBEGN/ , JEND  / 3HEND /
      MODULE( 3 ) = JBEGN
      IF ( NBSTOR .EQ. 1 ) MODULE( 2 ) = KZERO
      IF ( NBSTOR .EQ. 2 ) MODULE( 2 ) = KONE
      CALL CONMSG ( MODULE, 3, 0 )
      INCRU  = 1
      TYPEI  = NDTYPE
      TYPEP  = NDTYPE
      SIGN   = SIGNAB
      NWDD   = NWORDS( NDTYPE )
      NWDB   = NWORDS( NBTYPE )
      IRFILE = FILEB( 1 )
C
C   OPEN CORE ALLOCATION AS FOLLOWS:
C     Z( 1        ) = ARRAY FOR ONE COLUMN OF "B" MATRIX
C     Z( IDX      ) = ARRAY FOR ONE COLUMN OF "D" MATRIX
C     Z( IAX      ) = ARRAY FOR MULTIPLE COLUMNS OF "A" MATRIX
C        THROUGH
C     Z( LASMEM   )
C     Z( IBUF4    ) = BUFFER FOR "D" FILE
C     Z( IBUF3    ) = BUFFER FOR "C" FILE
C     Z( IBUF2    ) = BUFFER FOR "B" FILE 
C     Z( IBUF1    ) = BUFFER FOR "A" FILE
C     Z( NZ       ) = END OF OPEN CORE THAT IS AVAILABLE
C
      IF ( NBSTOR .EQ. 1 .OR. KSYS58 .EQ. 10 ) IDX = 1 + NWDD*NBR  
      IF ( NBSTOR .NE. 2 .AND. KSYS58 .NE. 11 ) GO TO 90
C
C REDEFINE IDX AND INSURE A QUAD WORD BOUNDARY FOR COMPLEX DOUBLE
C
      IDX = 1 + NWDD*NBR + NBR  
      ITEST = MOD( IDX, 4 )
      IF ( ITEST .EQ. 1 ) GO TO 90
      IF ( ITEST .EQ. 0 ) IDX = IDX + 1
      IF ( ITEST .EQ. 2 ) IDX = IDX + 3
      IF ( ITEST .EQ. 3 ) IDX = IDX + 2
90    CONTINUE
      IDX2   = ( ( IDX+1 ) / 2 ) - 1  
      IDX4   = ( IDX+1 ) / 4    
      IAX    = IDX  + NWDD*NDR 
      IBUF1  = NZ    - SYSBUF
      IBUF2  = IBUF1 - SYSBUF
      IBUF3  = 0
      IF ( FILEC( 1 ) .EQ. 0 .OR. SIGNC .EQ. 0 ) GO TO 100
      IBUF3  = IBUF2 - SYSBUF
      IBUF4  = IBUF3 - SYSBUF
      GO TO 200
100   CONTINUE
      IBUF4  = IBUF2 - SYSBUF
200   CONTINUE
      LASMEM = IBUF4 - 1
      IPROW1 = 1
      IPROWN = NDR
      INCRP  = 1
      CALL GOPEN  ( FILEA, ZR( IBUF1 ), RDREW )
      CALL GOPEN  ( FILEB, ZR( IBUF2 ), RDREW )
C
C   DETERMINE HOW MANY COLUMNS OF A CAN BE READ INTO MEMORY IN ONE PASS
C
220   CONTINUE
      IAVAIL = LASMEM - IAX + 1 
C
C   NCOLPP  -  NUMBER OF COLUMNS OF "A" THAT CAN BE READ IN ONE PASS
C   NPASS   -  NUMBER OF PASSES NEEDED TO READ ENTIRE "A" MATRIX
C      
      NCOLPP = IAVAIL / ( 2+NWDD*NAR )
      IF ( NCOLPP .GT. NAC ) NCOLPP = NAC
      IF ( NCOLPP .LE. 0 )
     &   CALL MESAGE ( -8, IAVAIL+NWDD*NAR, MODULE )
      NPASS  = ( (NAC-1) / NCOLPP ) + 1
      IF ( NPASS .EQ. 1 .OR. IBUF3 .NE. 0 ) GO TO 250
C
C MUST ALLOCATE TWO BUFFERS FOR MULTIPLE PASSES
C
      IBUF3  = IBUF2 - SYSBUF
      IBUF4  = IBUF3 - SYSBUF
      LASMEM = IBUF4 - 1
      GO TO 220
250   CONTINUE
      DO 70000 M = 1, NPASS
      IPASS = M
      IBROW = ( M-1 ) * NCOLPP
      IF ( M .EQ. NPASS ) GO TO 400
C
C MULTIPLE PASSES REQUIRED, DETERMINE PROPER FILE FOR OUTPUT SO THAT 
C REQUESTED OUTPUT FILE IS USED ON THE LAST PASS
C      
      ITEST = NPASS - M
      ITEST = MOD( ITEST, 2 )
      IF ( ITEST .NE. 0 ) GO TO 350
      IFILE = SCRTCH
      OFILE = FILED( 1 )
      GO TO 380
350   IFILE = FILED( 1 )
      OFILE = SCRTCH
380   CONTINUE
      IF ( M .EQ. 1 ) GO TO 300
      CALL REWIND( FILEB )
      CALL SKPREC( FILEB, 1 )
      CALL GOPEN ( IFILE, ZR( IBUF3 ), RDREW )
      CALL GOPEN ( OFILE, ZR( IBUF4 ), WRTREW)
      GO TO 490
C FIRST PASS, OPEN "C" FILE IF IT EXISTS
300   CONTINUE
      CALL GOPEN ( OFILE, ZR( IBUF4 ), WRTREW)      
310   IFILE = FILEC( 1 )
      IF ( SIGNC .EQ. 0 ) IFILE = 0
      IF ( IFILE .EQ. 0 ) GO TO 490 
      CALL GOPEN  ( IFILE, ZR( IBUF3 ), RDREW )     
      GO TO 490
C LAST PASS, CREATE OUTPUT FILE
400   CONTINUE
      NCOLPP = NAC - NCOLPP*(NPASS-1)
      OFILE = FILED( 1 )
      IFILE = SCRTCH   
      CALL REWIND( FILEB )
      CALL SKPREC( FILEB, 1 )
      CALL GOPEN ( FILED, ZR( IBUF4 ), WRTREW)
      FILED( 2 ) = 0
      FILED( 6 ) = 0
      FILED( 7 ) = 0
      IF ( M .EQ. 1 ) GO TO 310
      CALL GOPEN  ( IFILE, ZR( IBUF3 ), RDREW )     
490   CONTINUE
      INDX   = IAX
      TYPEU  = NDTYPE
      DO 900 I = 1, NCOLPP
      IUROW1 = -1
      CALL UNPACK ( *500, FILEA, ZR( INDX+2 ) )
      ZI( INDX   ) = IUROW1
      ZI( INDX+1 ) = IUROWN
      INDX    = INDX + 2 + NWDD*NAR   
      GO TO 900
500   CONTINUE
C NULL COLUMN READ
      ZI( INDX   ) = 0
      ZI( INDX+1 ) = 0
      INDX    = INDX + 2 + NWDD*NAR   
900   CONTINUE
      IF ( KSYS58 .EQ. 10 ) GO TO 950
      IF ( KSYS58 .EQ. 11 ) GO TO 1000
      IF ( NBSTOR .EQ. 2  ) GO TO 1000     
C PROCESS ALL OF THE COLUMNS OF "B", ADD "C" DATA ON FIRST PASS
950   CONTINUE
      IF ( NDTYPE .EQ. 1 ) CALL MMA101( ZI, ZR )
      IF ( NDTYPE .EQ. 2 ) CALL MMA102( ZI, ZD )
      IF ( NDTYPE .EQ. 3 ) CALL MMA103( ZI, ZC )
      IF ( NDTYPE .EQ. 4 ) CALL MMA104( ZI, ZD, ZDC )
      GO TO 60000
1000  CONTINUE
      IF ( NDTYPE .EQ. 1 ) CALL MMA111( ZI, ZR )
      IF ( NDTYPE .EQ. 2 ) CALL MMA112( ZI, ZD )
      IF ( NDTYPE .EQ. 3 ) CALL MMA113( ZI, ZC )
      IF ( NDTYPE .EQ. 4 ) CALL MMA114( ZI, ZD, ZDC )
60000 CONTINUE
      CALL CLOSE ( IFILE, CLSREW )
      CALL CLOSE ( OFILE, CLSREW )
70000 CONTINUE
      CALL CLOSE ( FILEA, CLSREW )
      CALL CLOSE ( FILEB, CLSREW )
      MODULE( 3 ) = JEND
      CALL CONMSG ( MODULE, 3, 0 )
      RETURN
      END

      SUBROUTINE XSCNDM
C
C     THE PURPOSE OF THIS ROUTINE IS TO RETURN TO THE CALLING PROGRAM
C     THE NEXT BCD OR BINARY ENTRY IN DMAP ARRAY.
C
C     IBUFF  = BUFFER AREA WHERE CARD IMAGE IS STORED FOR XRCARD INPUT.
C     IDLMTR = TABLE OF DELIMITER CHARACTERS
C     ITYPE  = TABLE FOR CONVERTING NUMBER TYPE TO WORD LENGTH.
C
C     LAST REVISED BY G.CHAN/UNISYS, 2/90
C     REMOVING LVAX AND .NOT.LVAX AND STANDARDIZED ALL BYTE OPERATIONS
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        LSHIFT,RSHIFT,ORF
      INTEGER         GNOBUF(1),ITYPE(6),DMPCRD(1),IDLMTR(8),OS(5),
     1                OSCAR(1)
      COMMON /SYSTEM/ KSYSTM(100)
      COMMON /XGPIC / ICOLD,ISLSH,IEQUL,NBLANK,NXEQUI,
     1                NDIAG,NSOL,NDMAP,NESTM1,NESTM2,NEXIT,
     2                NBEGIN,NEND,NJUMP,NCOND,NREPT,NTIME,NSAVE,NOUTPT,
     3                NCHKPT,NPURGE,NEQUIV,NACPW,NBPC,NAWPC,
     4                MASKHI,MASKLO,ISGNON,NOSGN,IALLON
      COMMON /XGPIE / NSCR
      COMMON /ZZZZZZ/ CORE(1)
      COMMON /XGPI4 / IRTURN,INSERT,ISEQN,DMPCNT,
     1                IDMPNT,DMPPNT,BCDCNT,LENGTH,ICRDTP,ICHAR,NEWCRD,
     2                MODIDX,LDMAP,ISAVDW,DMAP(1)
      COMMON /XGPI5 / IAPP,START,ALTER(2)
      COMMON /XGPI6 / KRUD(6),DIAG14,DIAG17,DIAG4,DIAG25,IFIRST,
     1                IBUFF(20)
      COMMON /PASSER/ ISTOPF,MODNAM,KKCOMM
      EQUIVALENCE     (KSYSTM(3),NOGO),(CORE(1),OS(1),LOSCAR),
     1                (OS(2),OSPRC),(OS(3),OSBOT),(OS(4),OSPNT),
     2                (OS(5),OSCAR(1),DMPCRD(1),GNOBUF(1))
      DATA    ITYPE / 1,1,2,2,2,4/ ,IDLMTR/
     1        4H$   , 4H/   ,4H=   ,4H,   ,4H(   ,4H)   ,4H    ,4H*   /
      DATA    NOSCR1/ 4HOSCA/,      NOSCR2/4HR   /
      DATA    NPT   / 4HNPTP/,      IZERO / 0    /
      DATA    NWPC  / 18    /,      NCPW  / 4    /
C
C *** WARNING - NWPC AFFECTS CODE IN XOSGEN SO BEWARE IF YOU CHANGE IT.
C
      KCOMMA = KHRFN1(IZERO,1,IDLMTR(4),1)
      KBLANK = KHRFN1(IZERO,1,IDLMTR(7),1)
      KKCOMM = 0
C
C     CHECK FOR OSCAR TABLE OVERFLOW
C
      IF (OSCAR(OSBOT)+OSBOT .GT. ICRDTP) GO TO 310
C
C     CHECK FOR CARD READ ERROR
C
      IF (NOGO .EQ. 2) GO TO 340
C
C     CHECK FOR NEW CARD NEEDED.
C
      IF (NEWCRD .NE. 0) GO TO 200
      IF (BCDCNT) 330,10,130
C
C     BCDCNT = 0, TEST MODE
C
   10 IF (MODNAM .EQ. 0) GO TO 90
      KFL1 = 0
      ICOM = 0
      DO 80 KH  = 1,NWPC
      DO 70 KDH = 1,NCPW
      NCHAR  = KHRFN1(IZERO,1,IBUFF(KH),KDH)
      IF (NCHAR-KBLANK) 40,20,40
   20 IF (KFL1) 30,70,30
   30 KFL1 = 2
      GO TO 70
   40 IF (NCHAR-KCOMMA) 50,60,50
   50 IF (ICOM.EQ.1 .OR. KFL1.EQ.2) GO TO 90
      KFL1 = 1
      GO TO 70
   60 KFL1 = 2
      ICOM = ICOM + 1
      IF (ICOM .NE. 2) GO TO 70
      KKCOMM = 1
      GO TO 90
   70 CONTINUE
   80 CONTINUE
   90 IF (DMAP(IDMPNT) .EQ. RSHIFT(IALLON,1)) GO TO 180
      IF (DMAP(IDMPNT)) 100,110,120
C
C     BINARY VALUE - TRANSLATE TYPE INTO LENGTH
C
  100 I = IABS(DMAP(IDMPNT))
      IF (I .GT. 6) GO TO 330
C
C     A MISUNDERSTANDING MAKES THE FOLLOWING STATEMENT NECESSARY.
C
      DMAP(IDMPNT) = ORF(ISGNON,I)
      LENGTH = ITYPE(I)
      DMPPNT = IDMPNT
      IDMPNT = LENGTH + 1 + IDMPNT
      IRTURN = 3
      GO TO 350
C
C     CONTINUE MODE - GET NEXT CARD
C
  110 NEWCRD = 1
      GO TO 200
C
C     MODE IS BCD, INITIALIZE BCDCNT, DMPPNT, AND CHECK FOR OVERFLOW
C
  120 BCDCNT = DMAP(IDMPNT)
      IDMPNT = IDMPNT + 1
      IF (2*BCDCNT+IDMPNT .GT. LDMAP) GO TO 330
C
C     TEST FOR OPERATOR ENTRY.
C
  130 IRTURN = 2
      IF (DMAP(IDMPNT) .EQ. IALLON) GO TO 150
  140 DMPPNT = IDMPNT
      IDMPNT = IDMPNT + 2
      BCDCNT = BCDCNT - 1
      GO TO 350
C
C     DELIMITER FOUND - CHECK FOR COMPLEX NUMBER
C
  150 IRTURN = 1
      IF (KHRFN1(IZERO,1,DMAP(IDMPNT+1),1) .NE.
     1    KHRFN1(IZERO,1,IDLMTR(5),1)) GO TO 140
C
C     LEFT PAREN FOUND - SEE IF TWO NUMBERS FOLLOW
C
      IF (DMAP(IDMPNT+2).EQ.-2 .AND. DMAP(IDMPNT+4).EQ.-2) GO TO 160
      IF (DMAP(IDMPNT+2).NE.-4 .OR.  DMAP(IDMPNT+5).NE.-4) GO TO 140
C
C     DOUBLE PRECISION COMPLEX NUMBER FOUND - FORM NUMBER CORRECTLY AND
C     SET TYPE CODE.
C
      DMAP(IDMPNT+5) = DMAP(IDMPNT+4)
      DMAP(IDMPNT+4) = DMAP(IDMPNT+3)
      DMAP(IDMPNT+3) = -6
      GO TO 170
C
C     SINGLE PRECISION COMPLEX NUMBER FOUND - FORM NUMBER CORRECTLY
C
  160 DMAP(IDMPNT+4) = DMAP(IDMPNT+3)
      DMAP(IDMPNT+3) = -5
  170 BCDCNT = 0
      IDMPNT = IDMPNT + 3
      GO TO 100
C
C     END OF DMAP INSTRUCTION
C
  180 IRTURN = 4
      GO TO 350
C
C     GET NEXT CARD IMAGE AND TRANSLATE INTO DMAP ARRAY.
C
  200 IBUFCT = 1
      IBWRD  = 1
      ICALL  = 0
C
C     CHECK FOR INSERT TO BE MADE
C
      IF (INSERT.GT.0 .OR. INSERT.EQ.-1) GO TO 210
      GO TO 250
C
C     GET NEXT CARD IMAGE FROM ALTER FILE
C
  210 CONTINUE
      CALL READ (*230,*220,NPT,IBUFF,18,1,L)
      GO TO 260
C
C     NO MORE INSTRUCTIONS TO INSERT FOR THIS ALTER
C     MOVE NEXT ALTER CONTROL TO ALTER CELLS
C
  220 ALTER(1) = IBUFF(1)
      ALTER(2) = IBUFF(2)
      GO TO 240
C
C     END OF ALTER FILE - SET ALTER CELL INFINITE
C
  230 ALTER(1) = 10000
  240 CONTINUE
      IF (NEWCRD .GT. 0) GO TO 300
      GO TO 180
C
C     FILL IBUFF WITH CARD IMAGE
C
  250 CALL READ (*320,*260,NSCR,IBUFF,NWPC,0,LX)
C
C     CHECK INSERT FOR NO PRINT
C
  260 IF (INSERT .LT. 0) GO TO 270
C
C     PRINTOUT DMAP INSTRUCTION
C
      IF (IFIRST .EQ. 0) GO TO 270
      IF (DIAG17.EQ.0 .AND. (DIAG14.EQ.0 .OR. DIAG14.GE.10)) GO TO 270
      I = 5
      IF (NEWCRD .GT. 0) I = 6
      CALL XGPIMW (I,NWPC,DMPCNT,IBUFF)
C
C     CHECK FOR COMMENT CARD
C
  270 IF (KHRFN1(IZERO,1,IDLMTR(1),1) .EQ. KHRFN1(IZERO,1,IBUFF(1),1))
     1    GO TO 200
C
C     CONVERT CARD IMAGE
C
      CALL XRCARD (DMAP,LDMAP,IBUFF)
C
C     CHECK FOR BAD CARD FORMAT
C
      IF (DMAP(1) .EQ. 0) GO TO 180
C
C     TRANSLATE CARD IMAGE INTO DMAP ARRAY
C
      IDMPNT = 1
      BCDCNT = 0
      NEWCRD = 0
      GO TO 10
C
C     DIAGNOSTIC MESSAGES -
C
C     ERROR IN ALTER DECK - CANNOT FIND LOGICAL END OF CARD
C
  300 CALL XGPIDG (40,0,0,0)
      GO TO 180
C
C     OSCAR TABLE OVERFLOW
C
  310 CALL XGPIDG (14,NOSCR1,NOSCR2,DMPCNT)
      CALL XGPIDG (-38,2000,0,0)
C
C     THIS DMAP INSTRUCTION NOT FOLLOWED BY END CARD.
C
  320 CALL XGPIDG (44,OSPNT,0,0)
      GO TO 340
C
C     CANNOT INTERPRET DMAP CARD
C
  330 CALL XGPIDG (34,0,DMPCNT,0)
C
C     ABORT - CANNOT CONTINUE COMPILATION
C
  340 NOGO   = 2
      IRTURN = 5
  350 RETURN
      END

      SUBROUTINE APDB2 (IBUF1,IBUF2,NEXT,LEFT,NSTNS,NLINES,XSIGN,
     1                  LCSTM,ACSTM,NODEX,NODEI,ISILC,XYZB)
C
C     GENERATE GTKA TRANSFORMATION MATRIX FOR SWEPT TURBOPROP
C     BLADES (AERODYNAMIC THEORY NUMBER 7).
C
      EXTERNAL        ANDF
      LOGICAL         MULTI,OMIT,SINGLE,DEBUG
      INTEGER         GM,GO,GTKA,SCR1,SCR2,CORE,IDATA(7),
     1                UM,UO,UR,USG,USB,UL,UA,UF,US,UN,UG,USET1,
     2                GTKG,GKNB,GKM,GKAB,GKF,GKS,GKO,GKN,GSIZE,
     3                ANDF,RD,RDREW,WRT,WRTREW,CLSREW,TGKG(7)
      DIMENSION       ITRL(7),XYZB(4,NSTNS),IZ(1),Z(1),RDATA(7),
     1                TA(3,3),TBL(3),TBLA(3),TBLT(3),TBLR(3),
     2                ACSTM(1),NODEX(1),NODEI(1),ISILC(1)
      COMMON /SYSTEM/ KSYSTM(54),IPREC
      COMMON /TWO   / ITWO(32)
      COMMON /ZZZZZZ/ CORE(1)
      COMMON /ZBLPKX/ AP(4),II
      COMMON /BITPOS/ UM,UO,UR,USG,USB,UL,UA,UF,US,UN,UG
      COMMON /PATX  / LC,N,NO,NY,USET1,IBC(7)
      COMMON /NAMES / RD,RDREW,WRT,WRTREW,CLSREW
      COMMON /APDBUG/ DEBUG
      EQUIVALENCE     (Z(1),CORE(1))
      EQUIVALENCE     (Z(1),IZ(1)), (IDATA(1),RDATA(1))
      DATA    SINGLE, MULTI,OMIT /.TRUE.,.TRUE.,.TRUE./
C
      USET = 102
      GM   = 106
      GO   = 107
      GTKA = 204
      SCR1 = 301
      SCR2 = 302
      GKNB = 303
      GKM  = 304
      GKAB = 305
      ITRL(1) = USET
      CALL RDTRL (ITRL)
      GSIZE = ITRL(3)
      IF (ANDF(ITRL(5),ITWO(UM)) .EQ. 0) MULTI = .FALSE.
      IF (ANDF(ITRL(5),ITWO(US)) .EQ. 0) SINGLE= .FALSE.
      IF (ANDF(ITRL(5),ITWO(UO)) .EQ. 0) OMIT  = .FALSE.
      IF (.NOT.(MULTI .OR. SINGLE .OR. OMIT)) SCR2 = GTKA
      GTKG = SCR2
C
C     OPEN SCR1 TO READ BLADE NODE DATA
C
C                         T
C     OPEN SCR2 TO WRITE G   MATRIX OF ORDER (GSIZE X KSIZE)
C                         KG
C
      CALL GOPEN (SCR1,Z(IBUF1),RDREW)
      CALL GOPEN (GTKG,Z(IBUF2),WRTREW)
      TGKG(1) = GTKG
      TGKG(2) = 0
      TGKG(3) = GSIZE
      TGKG(4) = 2
      TGKG(5) = 1
      TGKG(6) = 0
      TGKG(7) = 0
C
C     SET-UP CALL TO TRANSS VIA PRETRS
C
      IF (LCSTM .GT. 0) CALL PRETRS (ACSTM,LCSTM)
C
C     LOOP ON STREAMLINES
C
      DO 50 NLINE = 1,NLINES
C
C     READ STREAMLINE NODE DATA FROM SCR1
C
      DO 10 NST = 1,NSTNS
      CALL FREAD (SCR1,IDATA,7,0)
      IF (DEBUG) CALL BUG1 ('SCR1 IDATA',10,IDATA,7)
      NODEX(NST) = IDATA(1)
      NODEI(NST) = IDATA(2)
      ISILC(NST) = IDATA(3)
      XYZB(1,NST)= RDATA(4)
      XYZB(2,NST)= RDATA(5)
      XYZB(3,NST)= RDATA(6)
      XYZB(4,NST)= RDATA(7)
   10 CONTINUE
C
C     GENERATE BASIC TO LOCAL TRANSFORMATION MATRIX FOR THIS STREAMLINE
C
      CALL APDB2A (NLINES,NLINE,SCR1,NSTNS,XSIGN,XYZB(2,1),
     1             XYZB(2,NSTNS),TBLT,TBLR)
C
C     SET TRANSFORMATION TO TRANSLATION FIRST
C
      DO 15 NN = 1,3
  15  TBL(NN) = TBLT(NN)
C
C     LOOP FOR TRANSLATION THEN ROTATION
C
      NDEG = 0
      DO 45 NLOOP = 1,2
      IF (DEBUG) CALL BUG1 ('MAT-TBL   ' ,18,TBL,3)
C
C     LOOP ON COMPUTING STATIONS
C
      DO 40 NCS = 1,NSTNS
C
C     LOCATE GLOBAL TO BASIC TRANSFORMATION MATRIX
C
      RDATA(1) = XYZB(1,NCS)
      IF (LCSTM.EQ.0 .OR. IDATA(1).EQ.0) GO TO 20
      CALL TRANSS (XYZB(1,NCS),TA)
      CALL GMMATS (TBL,1,3,0,TA,3,3,0,TBLA)
      GO TO 25
   20 TBLA(1) = TBL(1)
      TBLA(2) = TBL(2)
      TBLA(3) = TBL(3)
   25 CONTINUE
      IF (DEBUG) CALL BUG1 ('MAT-TBLA  ',25,TBLA,3)
C
C     COMPUTE LOCATION IN G-SET USING SIL
C     KODE = 1 FOR GRID POINT
C     KODE = 2 FOR SCALAR POINT (NOT ALLOWED, CHECK WAS MADE BY APDB)
C
      ISIL = ISILC(NCS)/10
      CALL BLDPK (1,1,GTKG,0,0)
C
C     OUTPUT GKG(TRANSPOSE) = GTKG
C     II IS ROW POSITION
C
      DO 30 ICOL = 1,3
      II = ISIL + NDEG
      AP(1) = TBLA(ICOL)
      IF (DEBUG) CALL BUG1 ('ISIL      ',28,ISIL,1)
      IF (DEBUG) CALL BUG1 ('MAT-AP    ',29,AP,1)
      CALL ZBLPKI
      ISIL = ISIL + 1
   30 CONTINUE
      CALL BLDPKN (GTKG,0,TGKG)
   40 CONTINUE
C
C     CHANGE BASIC TO LOCAL TRANSFORMATION TO ROTATION
C
      DO 43 NN = 1,3
   43 TBL(NN) = TBLR(NN)
      NDEG = 3
   45 CONTINUE
   50 CONTINUE
      CALL CLOSE (SCR1,CLSREW)
      CALL CLOSE (GTKG,CLSREW)
      CALL WRTTRL (TGKG)
C
C     CREATE GTKA MATRIX
C
      IF (MULTI .OR. SINGLE .OR. OMIT) GO TO 60
      GO TO 100
   60 CONTINUE
      LC  = KORSZ(CORE)
      GKF = GKNB
      GKS = GKM
      GKO = GKS
      USET1 = USET
C
C     REDUCE TO N-SET IF MULTI POINT CONSTRAINTS
C
      GKN = GTKG
      IF (.NOT.MULTI) GO TO 70
      IF (.NOT.SINGLE .AND. .NOT.OMIT) GKN = GTKA
      CALL CALCV (SCR1,UG,UN,UM,CORE)
      CALL SSG2A (GTKG,GKNB,GKM,SCR1)
      CALL SSG2B (GM,GKM,GKNB,GKN,1,IPREC,1,SCR1)
C
C     PARTITION INTO F-SET IF SINGLE POINT CONSTRAINTS
C
   70 IF (.NOT.SINGLE) GO TO 80
      IF (.NOT.OMIT  ) GKF = GTKA
      CALL CALCV (SCR1,UN,UF,US,CORE)
      CALL SSG2A (GKN,GKF,0,SCR1)
      GO TO 90
C
C     REDUCE TO A-SET IF OMITS
C
   80 GKF = GKN
   90 IF (.NOT.OMIT) GO TO 100
      CALL CALCV (SCR1,UF,UA,UO,CORE)
      CALL SSG2A (GKF,GKAB,GKO,SCR1)
      CALL SSG2B (GO,GKO,GKAB,GTKA,1,IPREC,1,SCR1)
  100 RETURN
      END

      SUBROUTINE SETIG (KG1,KG2,IG,NORIG)
C
C     THIS ROUTINE IS USED ONLY IN BANDIT MODULE
C
C     THIS ROUTINE SETS IG(KG1,-)=KG2 AND IG(KG2,-)=KG1 IF THIS
C     CONNECTION HAS NOT ALREADY BEEN SET.
C     NEDGE = NUMBER OF UNIQUE EDGES.
C
      INTEGER          BUNPK
      DIMENSION        IG(1),    NORIG(1), SUB(2)
      COMMON /BANDS /  NN,       MM,       DUM2(2),  MAXGRD,   MAXDEG,
     1                 DUM3(3),  NEDGE
      COMMON /SYSTEM/  IBUF,     NOUT
      DATA             SUB /     4HSETI,   4HG       /
C
      IF (KG1.EQ.0 .OR. KG2.EQ.0 .OR. KG1.EQ.KG2) GO TO 80
      L=KG1
      K=KG2
      DO 50 LOOP=1,2
      IF (LOOP.EQ.1) GO TO 20
      L=KG2
      K=KG1
   20 M=0
   30 M=M+1
      IF (M.GT.MAXDEG) GO TO 60
      IS=BUNPK(IG,L,M)
      IF (IS.EQ.0) GO TO 40
      IF (IS.NE.K) GO TO 30
      GO TO 80
   40 CALL BPACK (IG,L,M,K)
      MM=MAX0(MM,M)
      IF (LOOP.EQ.1) NEDGE = NEDGE + 1
   50 CONTINUE
      GO TO 80
C
   60 WRITE (NOUT,70) NORIG(L),MAXDEG
   70 FORMAT (34H0***  FATAL ERROR - - - GRID POINT,I10,
     1        48H  HAS DEGREE EXCEEDING THE NODAL DEGREE LIMIT OF,I8)
      CALL MESAGE (-8,0,SUB)
   80 RETURN
      END

      SUBROUTINE WRITE ( FILE, IDATA, N, EORFLG )
      INCLUDE 'DSIOF.COM'
      INCLUDE 'XNSTRN.COM'
      COMMON / DDIOSV / IFLPOS( 2,80 )
      INTEGER  FILE, EORFLG, IDATA( 2 )
      IEOR   = EORFLG
      NAME   = FILE
      NWORDS = N
      IF ( NWORDS .GE. 0 ) GO TO 10
      CALL DSMSG( 6 )
10    CALL DSGEFL
      IF ( NWORDS .EQ. 0 ) GO TO 25
      IF ( IPRVOP .NE. 0 ) GO TO 20
      CALL DSMSG( 7 )
20    IF ( INDCLR .NE. INDCBP ) GO TO 30
      IFLPOS( 1,IFILEX ) = FCB( 3, IFILEX )
      IFLPOS( 2,IFILEX ) = FCB( 4, IFILEX )
      IBASE( INDCLR ) = IDSRH + IDSC
      IBLOCK = NBLOCK
      IBASE( INDBAS + NBUFF + 2 ) = NBLOCK
      GO TO 40
25    IF ( INDCBP .NE. INDCLR ) GO TO 70
      LWORDS = NBUFF - ( INDCLR - INDBAS ) - 2
      IF ( LWORDS .GT. 0 ) GO TO 70
      IBASE( INDCLR ) = IDSEB
      CALL DSWRNB
      IBASE( INDCLR ) = IDSRH + IDSC
      IBASE( INDCLR + 1 ) = IDSRT + IDSC + ( INDCLR - INDBAS + 1 )
      INDCBP = INDCBP + 2
      INDCLR = INDCBP
      GO TO 80
30    IBLOCK = IBASE( INDBAS + NBUFF + 2 )
40    LWORDS = NBUFF - ( INDCBP-INDBAS )
      IF ( LWORDS .GE. NWORDS ) GO TO 50
      CALL DSWRT1( IDATA )
CWKBI SPR94013 11/94
      IBASE( INDBAS + NBUFF + 2 ) = IBLOCK
      GO TO 80
50    DO 60 I = 1, NWORDS
      IBASE( INDCBP + I  ) = IDATA( I )
60    CONTINUE
      IBASE( INDCLR ) = IBASE( INDCLR ) + NWORDS
      INDCBP = INDCBP + NWORDS
70    IF ( IEOR .EQ. 0 ) GO TO 80
      IF ( INDCBP .NE. INDCLR ) GO TO 75
      IBASE( INDCBP ) = IDSRH + IDSC
      IFLPOS( 1,IFILEX ) = FCB( 3, IFILEX )
      IFLPOS( 2,IFILEX ) = FCB( 4, IFILEX )
75    IBASE( INDCBP+1 ) = IDSRT + IDSC + ( INDCLR-INDBAS+1 )
      INDCBP = INDCBP + 2
      INDCLR = INDCBP
80    CALL DSSDCB
      RETURN
      END

      FUNCTION ITTYPE(ITEMX)
C
C*****
C
C     THIS FUNCTION RETURNS AN INTEGER CODE NUMBER TO INDICATE
C     WHETHER A PARTICULAR SOF ITEM IS A MATRIX OR TABLE.
C     THE RETURN CODES ARE
C
C          1 - MATRIX ITEM
C          0 - TABLE ITEM
C         -1 - ILLEGAL ITEM NAME
C
C*****
C
      COMMON / ITEMDT /       NITEM    ,ITEM(7,1)
C
      DO 10 I=1,NITEM
      IF(ITEMX .EQ. ITEM(1,I)) GO TO 20
   10 CONTINUE
C
C     ILLIGAL ITEM - RETURN -1
C
      ITTYPE = -1
      RETURN
C
C     ITEM FOUND - RETURN TYPE
C
   20 IF(ITEM(2,I) .LE. 0) ITTYPE = 0
      IF(ITEM(2,I) .GT. 0) ITTYPE = 1
      RETURN
      END

      SUBROUTINE SSG2C (A,B,C,OP,BLOCK)
C
      INTEGER          A,B,C    ,OP       ,BLOCK(11),NA(2)    ,NB(2)
      DIMENSION        IA(5)    ,IB(5)    ,IC(5)    ,IT(1)    ,IT1(1)
      DOUBLE PRECISION DIT1
      INTEGER          DT1(2)
      CHARACTER        UFM*23   ,UWM*25
      COMMON /XMSSG /  UFM      ,UWM
      COMMON /ZZZZZZ/  CORE(1)
      COMMON /SADDX /  NOMAT    ,LCORE    ,MCBS(67)
      COMMON /SYSTEM/  KSYSTM(65)
      EQUIVALENCE      (DT1,DIT1)
      EQUIVALENCE      (KSYSTM(55),IPR1)  ,(MCBS(1),IA(1))  ,
     1                 (MCBS(8),IT(1),DIT),(MCBS(13),IB(1)) ,
     2                 (MCBS(20),IT1(1)),(MCBS(61),IC(1)) ,
     3                 (KSYSTM(2),NOUT)   ,(IA5,IA(5)) ,(IB5,IB(5))
C
C     BLOCK(6) WAS NOT USED IN ORIGINAL NASTRAN. IT IS NOW USED TO FLAG
C     THE CHECKING OF THE INPUT MATRICES COMPATABILITY IF THE CALLER
C     PRESETS BLOCK(6) TO -1
C
      IA(1) = A
      CALL RDTRL (IA)
      IF (IA(1) .LT. 0) IA(1) = 0
      IB(1) = B
      CALL RDTRL (IB)
      IF (IB(1) .GT. 0) GO TO 10
      IB(1) = 0
      IF (IA(1)) 150,150,30
   10 DO 20 I = 2,4
   20 IC(I) = IB(I)
      GO TO 50
   30 DO 40 I = 2,4
   40 IC(I) = IA(I)
C
   50 NOMIX = 0
      IF (BLOCK(6) .NE. -1) GO TO 70
      IF (IA5.EQ.0 .OR. IB5.EQ.0) GO TO 70
      IF ((IA5.LE.2 .AND. IB5.LE.2) .OR. (IA5.GE.3 .AND. IB5.GE.3))
     1    GO TO 70
      IF (MAX0(IA5,BLOCK(1)) .EQ. MAX0(IB5,BLOCK(7))) GO TO 70
      NOMIX = 1
      CALL FNAME (A,NA)
      CALL FNAME (B,NB)
      WRITE  (NOUT,60) UWM,NA,IA(2),IA(3),IA5,IA(4),NB,IB(2),IB(3),
     1                 IB5,IB(4)
   60 FORMAT (A25,', SSG2C RECEIVES TWO MIXED FILE TYPES FOR ADDING.',
     1        /,2(5X,'FILE ',2A4,'(',I6,' X',I6,') TYPE =',I3,
     2        ', FORM =',I3))
C
C     UNSY + SYM = UNSY
C
   70 IF (IC(4) .NE. 6) GO TO 80
      IF (IA(1).NE.0 .AND. IA(4).NE.6) IC(4) = 1
      IF (IB(1).NE.0 .AND. IB(4).NE.6) IC(4) = 1
   80 IF (OP .LT. 0) IA(2) = -IC(2)
      DO 90 I = 1,5
      IT(I)  = BLOCK(I  )
   90 IT1(I) = BLOCK(I+6)
      DT1(1) = MCBS(20)
      DT1(2) = MCBS(21)
      IF (NOMIX .NE. 0) WRITE (NOUT,92,ERR=95) IT(1),DIT,IT1(1),DIT1
   92 FORMAT ('  MULTIPLIERS =',I3,D12.3,I8,D12.3)
   95 IC(1)  = C
      LCORE  = KORSZ(CORE)
C
C     DETERMINE TYPE OF OUTPUT
C
      IRC = 0
      IF (IA(1) .EQ. 0) GO TO 100
      IF (IA5.GT.2 .OR.  IT(1).GT.2) IRC = 2
  100 IF (IB(1) .EQ. 0) GO TO 110
      IF (IB5.GT.2 .OR. IT1(1).GT.2) IRC = 2
  110 CONTINUE
      IPREC = IPR1
      IC(5) = IRC + IPREC
      NOMAT = 2
      IF (NOMIX .EQ. 0) GO TO 130
      CALL FNAME (IC(1),NA)
      WRITE  (NOUT,120) NA,IC(2),IC(3),IC(5),IC(4)
  120 FORMAT (5X,'FILE ',2A4,'(',I6,' X',I6,') TYPE =',I3,', FORM =',I3,
     1        5X,'(RESULTANT)')
  130 CALL SADD (CORE,CORE)
      CALL WRTTRL (IC)
  150 RETURN
      END

      SUBROUTINE PTHBDY
C
C     PTHBDY MODIFIES THE SIL,ECT,EQEXIN AND BGBDT FOR CHBDY ELEMENTS
C     SO THEY CAN BE PLOTTED.
C
C     THE SIL BGPDT AND EQEXIN OUTPUT LOOKALIKES ARE ADD ON FILES
C     THE ECT OUTPUT FILE HAS THE CHBDY FLAG SET NEGATIVE
C     SO PLTSET CAN TELL THE ECTS APART IT ALSO HAS THE NEW GRID POINTS
C
      INTEGER         NAME(2),EPT,ECT,SIL,IEQ,BGPDT,HECT,HSIL,OEQ,
     1                HBGPDT,GEOM2,SCR1,SCR2,FLAG,IZ(1),SYSBUF,OUT,
     2                CBS(20),OSIL,FILE1,FILE2,VIEW(2),CHBDY(2),
     3                PHBDY(2),BUF1,BUF2,BUF3,BUF4,BUF5,BUF6,TRL(7)
      DIMENSION       NSIL(7),NEQ(14),TEM(3),E(3),V(3),R21(3)
      CHARACTER       UFM*23,UWM*25
      COMMON /XMSSG / UFM,UWM
      COMMON /BLANK / NHBDY,MESH(2)
      COMMON /SYSTEM/ SYSBUF,OUT,DUM(6),NLPP
      COMMON /CONDAS/ PI
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE     (IZ(1),Z(1))
      DATA    GEOM2 , ECT, EPT, SIL, IEQ, BGPDT                   /
     1        101   , 102, 103, 104, 105,   106                   /
      DATA    HECT  , HSIL, OEQ, HBGPDT, SCR1, SCR2               /
     1        201   , 202,  203,    204,  301,  302               /
      DATA    IYES  , NO    , NAME  ,         NPHBDY, NVIEW, NCB2 /
     1        4HYES , 4HNO  , 4HPLNB, 4HDY  , 7     , 6    , 15   /
      DATA    VIEW  ,         CHBDY  ,        PHBDY        , NECT /
     1        2606  , 26    , 4208,42,        2502,25      , 15   /
C
C     PRINT FLAG CHBDY FLAG
C
      IPRT  = 0
      IF (MESH(1) .EQ. IYES) IPRT = 1
      NHBDY = -1
      LINE  = NLPP
C
C     INITIALIZE
C
      BUF1 = KORSZ(Z(1)) - SYSBUF
      BUF2 = BUF1 - SYSBUF  - 1
      BUF3 = BUF2 - SYSBUF
      BUF4 = BUF3 - SYSBUF
      BUF5 = BUF4 - SYSBUF
      BUF6 = BUF5 - SYSBUF
      CALL PRELOC (*1000,Z(BUF1),GEOM2)
      CALL LOCATE (*1000,Z(BUF1),CHBDY,N)
C
C     MAKE A SCRATCH FILE WITH EID AF DISLIN FOR CHBDY
C
      IPN  = 0
      IVEW = 0
      CALL PRELOC (*25,Z(BUF2),EPT)
      FILE1 = EPT
      CALL LOCATE (*15,Z(BUF2),PHBDY,N)
      CALL READ (*1002,*10,EPT,Z(1),BUF3,0,N)
      GO TO 1008
   10 IPN = N
   15 IPV = IPN + 1
      NRD = BUF3 - IPV
      CALL LOCATE (*25,Z(BUF2),VIEW,N)
      CALL READ (*1002,*20,EPT,Z(IPV),NRD,0,N)
      GO TO 1008
   20 IVEW = N
   25 CALL CLOSE (EPT,1)
      CALL GOPEN (SCR1,Z(BUF2),1)
      FILE1 = GEOM2
   30 CALL READ (*1002,*70,GEOM2,CBS,NCB2,0,N)
      TEM(1) = 0.0
      TEM(2) = 0.0
      IF (IPN .EQ. 0) GO TO 40
      DO 35 I = 1,IPN,NPHBDY
      IF (CBS(2) .NE. IZ(I)) GO TO 35
      TEM(1) = Z(I+2)
      GO TO 40
   35 CONTINUE
   40 IF (IVEW    .EQ. 0) GO TO 65
      IF (CBS(15) .EQ. 0) GO TO 65
      DO 60 I = 1,IVEW,NVIEW
      IF (CBS(15) .NE. IZ(IPN+I)) GO TO 60
      TEM(2) = Z(IPN+I+5)
      IF (IPRT .EQ.    0) GO TO 65
      IF (LINE .LT. NLPP) GO TO 50
      LINE = 1
      CALL PAGE1
      WRITE  (OUT,45)
   45 FORMAT (1H0,17X,5HIDENT,8X,4HBETA,7X,5HGAMMA,9X,3HCAN,6X,6HCAN BE,
     1       /6X,5HCHBDY,6X,6HNUMBER,8X,4HMESH,8X,4HMESH,7X,5HSHADE,6X,
     2       6HSHADED,5X,7HDISLIN ,/)
   50 NB = IYES
      NS = IYES
      IF (IZ(IPN+I+1) .EQ. 0) NB = NO
      IF (IZ(IPN+I+2) .EQ. 0) NS = NO
      LINE = LINE+1
      WRITE (OUT,55) CBS(1),IZ(IPN+I),IZ(IPN+I+3),IZ(IPN+I+4),NB,NS,
     1               TEM(2)
   55 FORMAT (1H ,4(I10,2X),6X,A4,8X,A4,2X,1P,E10.4)
      GO TO 65
   60 CONTINUE
   65 CALL WRITE (SCR1,TEM,2,0)
      GO TO 30
   70 CALL WRITE (SCR1,0,0,1)
      CALL CLOSE (SCR1 ,1)
      CALL CLOSE (GEOM2,1)
      CALL GOPEN (SCR1,Z(BUF1),0)
      TRL(1) = SIL
      CALL RDTRL (TRL)
      OSIL   = TRL(3)
      TRL(1) = BGPDT
      CALL RDTRL (TRL)
      NIN = TRL(2)
      NRD = 4*TRL(2)
      IF (5*SYSBUF+NRD+50 .GT. BUF1) GO TO 1008
C
C     FIND CHBDY CARDS COPY ECT TO CHBDY CARDS
C
      CALL GOPEN (ECT,Z(BUF2),0)
      CALL GOPEN (HECT,Z(BUF3),1)
      FILE1 = ECT
   80 CALL READ (*1000,*1000,ECT,CBS,3,0,N)
      CALL WRITE (HECT,CBS,3,0)
      IF (CBS(1).EQ.CHBDY(1) .AND. CBS(2).EQ.CHBDY(2)) GO TO 95
C
C     DUPE REST OF RECORD
C
   85 CALL READ (*1002,*90,ECT,Z(1),BUF6-1,0,N)
      CALL WRITE (HECT,Z(1),BUF6-1,0)
      GO TO 85
   90 CALL WRITE (HECT,Z(1),N,1)
      GO TO 80
C
C     COPY SIL EQEXIN TO NEW FILES
C
   95 ICORE = BUF6 - 1
      ILFT  = 1
      FILE1 = SIL
      FILE2 = HSIL
      N     = BUF4
      LEQ   = 0
  100 CALL GOPEN (FILE1,Z(BUF6),0)
      CALL GOPEN (FILE2,Z(N),1)
  105 CALL READ (*1002,*120,FILE1,Z(ILFT),ICORE,0,M)
      IF (FILE1 .NE. IEQ) GO TO 115
      DO 110 I = 1,ICORE,2
      IF (IZ(I) .GT. LEQ) LEQ = IZ(I)
  110 CONTINUE
  115 CALL WRITE (FILE2,Z(ILFT),ICORE,0)
      GO TO 105
  120 IF (FILE1 .NE. IEQ) GO TO 130
      DO 125 I = 1,M,2
      IF (IZ(I) .GT. LEQ) LEQ = IZ(I)
  125 CONTINUE
  130 CALL WRITE (FILE2,Z(ILFT),M,0)
      CALL CLOSE (FILE1,1)
      IF (N .EQ. BUF5) GO TO 150
      FILE1 = IEQ
      FILE2 = OEQ
      N     = BUF5
      GO TO 100
C
C     BRING IN BGPDT
C
  150 CALL GOPEN (BGPDT,Z(BUF6),0)
      FILE1 = BGPDT
      CALL READ (*1002,*1002,BGPDT,Z(1),NRD,0,N)
      CALL CLOSE (BGPDT,1)
C
C     FINALLY TIME TO GO TO WORK
C
      NHBDY = 0
      NNGP  = 0
      NBGP  = NRD + 1
      DO 155 I = 1,24
      IZ(NRD+I) = 0
  155 CONTINUE
      FILE1 = ECT
      CALL GOPEN (SCR2,Z(BUF6),1)
  160 CALL READ (*1002,*350,ECT,CBS,NECT,0,N)
      CBS(NECT) = 0.0
      IF (CBS(3) .GT. 6) CBS(3) = 3
      CALL READ (*1002,*1002,SCR1,TEM,2,0,N)
      FLAG  = CBS(3)
      NHBDY = NHBDY + 1
      GO TO (200,250,260,270,280,260), FLAG
C
C     POINT
C
C
C     BGPDT DATA FOR POINT
C
  200 I1 = (CBS(4)-1)*4 + 2
      ITRY = 1
      E(1) = 0.0
      E(2) = 0.0
      E(3) = 0.0
      CALL SAPB (CBS(12),E,V)
      CALL SANORM (*400,V)
      E(1) = 1.0
  205 XL = SADOTB(V,E)
      R21(1) = E(1) - XL*V(1)
      R21(2) = E(2) - XL*V(2)
      R21(3) = E(3) - XL*V(3)
      XL = SADOTB(R21,R21)
      IF (XL  .GT. .2) GO TO 210
      IF (ITRY .EQ. 2) GO TO 400
      ITRY = 2
      E(1) = 0.0
      E(2) = 1.0
      GO TO 205
  210 CALL SANORM (*215,R21)
  215 CALL SAXB (V,R21,E)
      XL = 0.0
      IF (TEM(1) .NE. 0.0) XL = SQRT(TEM(1)/PI)
      ZS3 = .8660254
      Z(NBGP+ 1) = Z(I1  ) + XL*R21(1)
      Z(NBGP+ 2) = Z(I1+1) + XL*R21(2)
      Z(NBGP+ 3) = Z(I1+2) + XL*R21(3)
      Z(NBGP+ 5) = Z(I1  ) + XL*( .5*R21(1) + ZS3*E(1))
      Z(NBGP+ 6) = Z(I1+1) + XL*( .5*R21(2) + ZS3*E(2))
      Z(NBGP+ 7) = Z(I1+2) + XL*( .5*R21(3) + ZS3*E(3))
      Z(NBGP+ 9) = Z(I1  ) + XL*(-.5*R21(1) + ZS3*E(1))
      Z(NBGP+10) = Z(I1+1) + XL*(-.5*R21(2) + ZS3*E(2))
      Z(NBGP+11) = Z(I1+2) + XL*(-.5*R21(3) + ZS3*E(3))
      Z(NBGP+14) = Z(I1+1) - XL* R21(2)
      Z(NBGP+15) = Z(I1+2) - XL* R21(3)
      Z(NBGP+17) = Z(I1  ) + XL*(-.5*R21(1) - ZS3*E(1))
      Z(NBGP+18) = Z(I1+1) + XL*(-.5*R21(2) - ZS3*E(2))
      Z(NBGP+19) = Z(I1+2) + XL*(-.5*R21(3) - ZS3*E(3))
      Z(NBGP+21) = Z(I1  ) + XL*(+.5*R21(1) - ZS3*E(1))
      Z(NBGP+22) = Z(I1+1) + XL*(+.5*R21(2) - ZS3*E(2))
      Z(NBGP+23) = Z(I1+2) + XL*(+.5*R21(3) - ZS3*E(3))
      Z(NBGP+25) = Z(I1  ) + XL*V(1)
      Z(NBGP+26) = Z(I1+1) + XL*V(2)
      Z(NBGP+27) = Z(I1+2) + XL*V(3)
      NNGP= NNGP + 7
      NS  = 7
      NEA = 14
      NB  = 28
      M   = 7
      N   = 5
  220 NN  = 1
      DO 225 I = 1,M
      LEQ = LEQ + 1
      NIN = NIN + 1
      NSIL(I) = NIN
      NEQ(NN) = LEQ
      NEQ(NN+1) = NIN
      CBS(N   ) = NIN
      NN  = NN + 2
      N   = N  + 1
  225 CONTINUE
      GO TO 300
C
C     LINE
C
C
C     BGPDT DATA FOR LINE
C
  250 I1 = (CBS(4)-1)*4 + 2
      I2 = (CBS(5)-1)*4 + 2
      CALL SAMB (Z(I2),Z(I1),R21)
      XL = SADOTB(R21,R21)
      IF (XL .EQ. 0.0) GO TO 400
      X1 = SADOTB(R21,CBS(12))
      XL = X1/XL
      E(1) = XL*R21(1)
      E(2) = XL*R21(2)
      E(3) = XL*R21(3)
      CALL SAMB (CBS(12),E,V)
      CALL SANORM (*400,V)
      CALL SAXB   (V,R21,E)
      CALL SANORM (*400,E)
      D  = TEM(2)
      AF = TEM(1)*.5
      Z(NBGP+ 1) = Z(I1  ) + D*V(1) - AF*E(1)
      Z(NBGP+ 2) = Z(I1+1) + D*V(2) - AF*E(2)
      Z(NBGP+ 3) = Z(I1+2) + D*V(3) - AF*E(3)
      Z(NBGP+ 5) = Z(I2  ) + D*V(1) - AF*E(1)
      Z(NBGP+ 6) = Z(I2+1) + D*V(2) - AF*E(2)
      Z(NBGP+ 7) = Z(I2+2) + D*V(3) - AF*E(3)
      Z(NBGP+ 9) = Z(I2  ) + D*V(1) + AF*E(1)
      Z(NBGP+10) = Z(I2+1) + D*V(2) + AF*E(2)
      Z(NBGP+11) = Z(I2+2) + D*V(3) + AF*E(3)
      Z(NBGP+13) = Z(I1  ) + D*V(1) + AF*E(1)
      Z(NBGP+14) = Z(I1+1) + D*V(2) + AF*E(2)
      Z(NBGP+15) = Z(I1+2) + D*V(3) + AF*E(3)
      Z(NBGP+17) = Z(I1  ) + D*V(1) + .5*R21(1)
      Z(NBGP+18) = Z(I1+1) + D*V(2) + .5*R21(2)
      Z(NBGP+19) = Z(I1+2) + D*V(3) + .5*R21(3)
      Z(NBGP+21) = Z(NBGP+17) + 2.*AF*V(1)
      Z(NBGP+22) = Z(NBGP+18) + 2.*AF*V(2)
      Z(NBGP+23) = Z(NBGP+19) + 2.*AF*V(3)
      NNGP= NNGP + 6
      NS  = 6
      NEA = 12
      NB  = 24
      M   = 6
      N   = 6
      GO TO 220
C
C     REV  OR  ELIP   DO NOTHING
C
  260 GO TO 310
C
C     AREA3
C
C     BGPDT DATA FOR AREA3
C
  270 I1 = (CBS(4)-1)*4 + 2
      I2 = (CBS(5)-1)*4 + 2
      I3 = (CBS(6)-1)*4 + 2
      CALL SAMB (Z(I2),Z(I1),E)
      CALL SAMB (Z(I3),Z(I1),V)
      CALL SAXB (E,V,E)
      CALL SANORM (*400,E)
      CALL SAMB (Z(I2),Z(I1),V)
      X1 = SADOTB(V,V)
      CALL SAMB (Z(I3),Z(I1),V)
      X2 = SADOTB(V,V)
      CALL SAMB (Z(I3),Z(I2),V)
      X3 = SADOTB(V,V)
      X1 = AMAX1(X1,X2)
      X1 = AMAX1(X1,X3)
      XL = .25* SQRT(X1)
      CALL SAPB (Z(I1),Z(I2),V)
      CALL SAPB (Z(I3),V,V)
      Z(NBGP+1) = V(1)/3.0
      Z(NBGP+2) = V(2)/3.0
      Z(NBGP+3) = V(3)/3.0
      Z(NBGP+5) = Z(NBGP+1) + XL*E(1)
      Z(NBGP+6) = Z(NBGP+2) + XL*E(2)
      Z(NBGP+7) = Z(NBGP+3) + XL*E(3)
  275 NNGP= NNGP + 2
      NS  = 2
      NEA = 4
      NB  = 8
      LEQ = LEQ + 1
      NIN = NIN + 1
      N   = 7
      IF (FLAG .EQ. 5) N = 8
      NSIL(1)= NIN
      NEQ(1) = LEQ
      NEQ(2) = NIN
      CBS(N) = NIN
      LEQ = LEQ + 1
      NIN = NIN + 1
      NSIL( 2) = NIN
      NEQ ( 3) = LEQ
      NEQ ( 4) = NIN
      CBS(N+1) = NIN
      CBS(N+2) = NIN
      CBS(N+3) = NIN
      IF (FLAG .EQ. 4) CBS(N+4) = NIN
      GO TO 300
C
C     AREA4
C
C     BGPDT DATA FOR AREA4
C
  280 I1 = (CBS(4)-1)*4 + 2
      I2 = (CBS(5)-1)*4 + 2
      I3 = (CBS(6)-1)*4 + 2
      I4 = (CBS(7)-1)*4 + 2
      CALL SAMB (Z(I3),Z(I1),E)
      CALL SAMB (Z(I4),Z(I2),V)
      CALL SAXB (E,V,E)
      CALL SANORM (*400,E)
      CALL SAMB (Z(I2),Z(I1),V)
      X1 = SADOTB(V,V)
      CALL SAMB (Z(I3),Z(I2),V)
      X2 = SADOTB(V,V)
      CALL SAMB (Z(I4),Z(I3),V)
      X3 = SADOTB(V,V)
      CALL SAMB (Z(I4),Z(I1),V)
      X4 = SADOTB(V,V)
      X1 = AMAX1(X1,X2)
      X1 = AMAX1(X1,X3)
      X1 = AMAX1(X1,X4)
      XL = .25* SQRT(X1)
      CALL SAPB (Z(I1),Z(I2),V)
      CALL SAPB (V,Z(I3),V)
      CALL SAPB (V,Z(I4),V)
      Z(NBGP+1) = .25*V(1)
      Z(NBGP+2) = .25*V(2)
      Z(NBGP+3) = .25*V(3)
      Z(NBGP+5) = Z(NBGP+1) + XL*E(1)
      Z(NBGP+6) = Z(NBGP+2) + XL*E(2)
      Z(NBGP+7) = Z(NBGP+3) + XL*E(3)
      GO TO 275
C
C     ADD TO HSIL HEQEXIN  HECT
C     BGPDT
C
  300 CALL WRITE (HSIL,NSIL,NS,0)
      CALL WRITE (OEQ,NEQ,NEA,0)
      CALL WRITE (SCR2,Z(NBGP),NB,0)
  310 CBS(3) = -CBS(3)
      CALL WRITE (HECT,CBS,NECT,0)
      GO TO 160
C
C     END CLOSE FILES, WRITE NBGPDT, WRITE TRAILERS THEN FINISH ECT COPY
C
  350 CALL WRITE (HSIL,0,0,1)
      CALL WRITE (OEQ ,0,0,1)
      CALL WRITE (HECT,0,0,1)
      CALL WRITE (SCR2,0,0,1)
      CALL CLOSE (SCR2,1)
      CALL CLOSE (SCR1,1)
      CALL CLOSE (HSIL,1)
      CALL CLOSE (OEQ ,1)
      CALL GOPEN (HBGPDT,Z(BUF1),1)
      CALL WRITE (HBGPDT,Z,NRD,0)
      IF (NNGP .EQ. 0) GO TO 380
      FILE1 = SCR2
      CALL GOPEN (SCR2,Z(BUF6),0)
  360 CALL READ (*1002,*370,SCR2,Z(1),BUF6-1,0,N)
      CALL WRITE (HBGPDT,Z(1),BUF6-1,0)
      GO TO 360
  370 CALL WRITE (HBGPDT,Z(1),N,1)
      CALL CLOSE (SCR2,1)
  380 CALL CLOSE (HBGPDT,1)
      TRL(1) = HBGPDT
      TRL(2) = NRD/4  + NNGP
      CALL WRTTRL (TRL)
      TRL(1) = OEQ
      CALL WRTTRL (TRL)
      TRL(1) = HSIL
      TRL(3) = NNGP + OSIL
      CALL WRTTRL (TRL)
      TRL(1) = ECT
      CALL RDTRL (TRL)
      TRL(1) = HECT
      CALL WRTTRL (TRL)
      FILE1  = ECT
      GO TO 80
C
C     BAD GEOMETRY FOR ELEMENT
C
  400 CBS(3) = -CBS(3)
      NHBDY  = NHBDY - 1
      WRITE  (OUT,410) UWM,CBS(1)
  410 FORMAT (A25,', CHBDY ELEMENT',I9,' HAS NO NORMAL OR BAD GEOMETRY',
     1       ' WHICH MAKES IT UNPLOTTABLE')
      GO TO 310
C
C     RETURN OR ERROR MESSAGES
C
 1000 CALL CLOSE (ECT,1)
      CALL CLOSE (HECT,1)
      CALL CLOSE (GEOM2,1)
      RETURN
C
 1002 CALL MESAGE (-2,0,FILE1)
 1008 CALL MESAGE (-8,0,NAME)
      RETURN
      END

      SUBROUTINE ASCM12 (NAME,IPHASE,ISOL,NOGO)
C
C     PLOT COMMAND DMAP DATA
C
      INTEGER        COMND(6,1),SUBNAM(2),RDMAP(18,6),PTBS(7,15)
      COMMON /ASDBD/ IRDM,NRDM,IXTRA,NXTRA,IOCT,NOCT,IPTBS,NPTBS,
     1               IPH,NPH,IDAT(213)
      DATA    COMND/ 4HPLOT,  6,  0,  0, 15,  0   /
      DATA    RDMAP/
     1 4HPLTM,4HRG  ,4H  CA,4HSECC,4H,PCD,4HB/PL,4HTSTP,4H,GPS,4HTP,E,
     * 4HLSTP,4H,BGS,4HTP,C,4HASST,4HP,EQ,4HSTP/,4H*NAM,4HE   ,4H */ ,
     2 4H    ,4H    ,4H  S,,4HN,NG,4HP/S,,4HN,LS,4HIL/S,4H,N,N,4HPSET,
     * 4H $  , 8*4H    ,
     3 4HSETV,4HAL  ,4H  //,4HS,N,,4HPLTF,4HLG/1,4H/S,N,4H,PFI,4HL/0 ,
     * 4H$   , 8*4H    ,
     4 4HPLOT,4H    ,4H  PL,4HTSTP,4H,GPS,4HTP,E,4HLSTP,4H,CAS,4HSTP,,
     * 4HBGST,4HP,EQ,4HSTP,,4H,,,,,4H,,/P,4HMSTP,4H/NGP,4H/LSI,4HL/  ,
     5 4H    ,4H    ,4H  S,,4HN,NP,4HSET/,4HS,N,,4HPLTF,4HLG/S,4H,N,P,
     * 4HFIL ,4H$   , 7*4H    ,
     6 4HPRTM,4HSG  ,4H  PM,4HSTP/,4H/ $ ,13*4H        /
      DATA    PTBS /
     1           1  , 26  , 26  ,  3  ,4HSTEP  ,         0  ,  0  ,
     2           1  , 32  , 32  ,  3  ,4HSTEP  ,         0  ,  0  ,
     3           1  , 38  , 38  ,  3  ,4HSTEP  ,         0  ,  0  ,
     4           1  , 44  , 44  ,  3  ,4HSTEP  ,         0  ,  0  ,
     5           1  , 51  , 51  ,  3  ,4HSTEP  ,         0  ,  0  ,
     6           1  , 57  , 57  ,  3  ,4HSTEP  ,         0  ,  0  ,
     7           1  , 62  , 62  ,  8  ,4HNAME  ,         0  ,  0  ,
     8           4  , 14  , 14  ,  3  ,4HSTEP  ,         0  ,  0  ,
     9           4  , 20  , 20  ,  3  ,4HSTEP  ,         0  ,  0  ,
     O           4  , 26  , 26  ,  3  ,4HSTEP  ,         0  ,  0  ,
     1           4  , 33  , 33  ,  3  ,4HSTEP  ,         0  ,  0  ,
     2           4  , 39  , 39  ,  3  ,4HSTEP  ,         0  ,  0  ,
     3           4  , 45  , 45  ,  3  ,4HSTEP  ,         0  ,  0  ,
     4           4  , 58  , 58  ,  3  ,4HSTEP  ,         0  ,  0  ,
     5           6  , 13  , 13  ,  3  ,4HSTEP  ,         0  ,  0  /
      DATA  SUBNAM  / 4HASCM,2H12  /
C
C     VALIDATE COMMAND AND SET POINTERS
C
      IF (NAME .NE. COMND(1,1)) GO TO 70
      ICOMND = 1
      IRDM   = 1
      NRDM   = COMND(2,ICOMND)
      IXTRA  = IRDM  + 18*NRDM
      NXTRA  = COMND(3,ICOMND)
      IOCT   = IXTRA + NXTRA
      NOCT   = COMND(4,ICOMND)
      IPTBS  = IOCT  + 3*NOCT
      NPTBS  = COMND(5,ICOMND)
      IPH    = IPTBS + 7*NPTBS
      NPH    = COMND(6,ICOMND)
C
C     MOVE RDMAP DATA
C
      K = 0
      IF (NRDM .EQ. 0) GO TO 35
      DO 30 J = 1,NRDM
      DO 30 I = 1,18
      K = K + 1
   30 IDAT(K) = RDMAP(I,J)
   35 CONTINUE
C
C     MOVE PTBS DATA
C
      IF (NPTBS .EQ. 0) GO TO 65
      DO 60 J = 1,NPTBS
      DO 60 I = 1,7
      K = K + 1
   60 IDAT(K) = PTBS(I,J)
   65 CONTINUE
C
      RETURN
C
C     INPUT ERROR
C
   70 CALL MESAGE (7,0,SUBNAM)
      NOGO = 1
      RETURN
C
      END

      SUBROUTINE GENPAR
C
C     GENERATES PARTITIONING VECTORS FOR DDAM SO THAT ONLY THE FIRST
C     LMODES MODES WILL BE USED, NOT NECESSARILY ALL THE ONES FOUND ON
C     THE PREVIOUS EIGENVALUE RUN. LMODES MUST BE GREATER THAN ZERO.
C     IF LMODES IS GREATER THAN THE NUMBER FOUND(OBTAINED FROM PF), IT
C     IS REDUCED TO THE NUMBER PREVIOUSLY FOUND
C
C     GENPART  PF/RPLAMB,CPLAMB,RPPF,CPMP/C,Y,LMODES/V,N,NMODES $
C     SAVE NMODES $
C
      INTEGER         PF,CPLAMB,RPLAMB,RPPF,CPMP,BUF1,SYSBUF,OTPE
      DIMENSION       IZ(1),MCB(7),NAM(2)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /BLANK / LMODES,NMODES
      COMMON /PACKX / IN,IOUT,II,NN,INCR
      COMMON /SYSTEM/ SYSBUF,OTPE
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE     (Z(1),IZ(1))
      DATA    PF,RPLAMB,CPLAMB,RPPF,CPMP / 101,201,202,203,204 /
      DATA    NAM   / 4HGENP,4HART /
C
      LCORE = KORSZ(Z)
      BUF1  = LCORE - SYSBUF + 1
      LCORE = BUF1 - 1
      IF (LCORE .LT. 5) GO TO 1008
C
      IN   = 1
      IOUT = 1
      II   = 1
      INCR = 1
C
      IF (LMODES .LE. 0) GO TO 500
      MCB(1) = PF
      CALL RDTRL (MCB)
      NMODES = MCB(3)
      NDIR   = MCB(2)
      IF (LMODES .GT. NMODES) LMODES=NMODES
C
C     GENERATE ROW PARTITIONING VECTOR FOR LAMB MATRIX TO PICK OFF THE
C     2ND COLUMN, WHICH IS THE COLUMN OF RADIAN FREQUENCIES. THEN
C     TRUNCATE THE COLUMN TO LMODES SIZE
C
      IF (LCORE .LT. NMODES) GO TO 1008
      CALL GOPEN (CPLAMB,Z(BUF1),1)
      NN = 0
      Z(   1) = 0.
      Z(NN+2) = 1.
      Z(NN+3) = 0.
      Z(NN+4) = 0.
      Z(NN+5) = 0.
      NN = 5
      MCB(1) = CPLAMB
      MCB(2) = 0
      MCB(3) = 5
      MCB(4) = 2
      MCB(5) = 1
      MCB(6) = 0
      MCB(7) = 0
      CALL PACK (Z,CPLAMB,MCB)
      CALL CLOSE (CPLAMB,1)
      CALL WRTTRL (MCB)
C
      CALL GOPEN (RPLAMB,Z(BUF1),1)
      DO 10 I = 1,LMODES
   10 Z(I) = 1.
      IF (LMODES .EQ. NMODES) GO TO 30
      L1 = LMODES + 1
      DO 20 I = L1,NMODES
   20 Z(I) = 0.
   30 NN = NMODES
      MCB(1) = RPLAMB
      MCB(2) = 0
      MCB(3) = NMODES
      MCB(4) = 2
      MCB(5) = 1
      MCB(6) = 0
      MCB(7) = 0
      CALL PACK (Z,RPLAMB,MCB)
      CALL CLOSE (RPLAMB,1)
      CALL WRTTRL (MCB)
C
C     ROW PARTITION FOR PF
C
      CALL GOPEN (RPPF,Z(BUF1),1)
      MCB(1) = RPPF
      MCB(2) = 0
      MCB(6) = 0
      MCB(7) = 0
      CALL PACK (Z,RPPF,MCB)
      CALL CLOSE (RPPF,1)
      CALL WRTTRL (MCB)
C
C     COLUMN PARTITION FOR MP-SAME AS ROW PARTITION FOR PREVIOUS FILES
C
      CALL GOPEN (CPMP,Z(BUF1),1)
      MCB(1) = CPMP
      MCB(2) = 0
      MCB(6) = 0
      MCB(7) = 0
      CALL PACK (Z,CPMP,MCB)
      CALL CLOSE (CPMP,1)
      CALL WRTTRL (MCB)
C
      RETURN
  500 WRITE  (OTPE,501) UFM
  501 FORMAT (A23,', LMODES PARAMETER MUST POSITIVE')
      CALL MESAGE (-61,0,0)
C
 1008 CALL MESAGE (-8,0,NAM)
      RETURN
      END

        SUBROUTINE FWDREC ( *, FILE )
      INCLUDE 'DSIOF.COM'
        INTEGER           FILE
        NAME = FILE
        CALL DSGEFL
        CALL DSFWR1
        CALL DSSDCB
        IF ( IRETRN .EQ. 1 ) RETURN 1
        RETURN
        END

      SUBROUTINE FPONT
C
C     DOES DIRECT,TPONT,FPONT,AND SCALAR LOADS
C
      INTEGER         GPID,SLT,PONT(5),SWLOAD(2)
      DIMENSION       IGPCO(4,5),GPCO1(3),GPCO2(3),GPCO3(3),GPCO4(3),
     1                VECT1(3),VECT2(3),IORD(5),VECT(3),GRIDP(7)
      COMMON /LOADX / LC,SLT,BG,OLD,N(12),IFM
      COMMON /ZZZZZZ/ CORE(1)
      EQUIVALENCE     (GPID,GRIDP(2)), (GRIDP(4),IP1), (GRIDP(5),IP2),
     1                (GRIDP(6),IP3) , (GRIDP(7),IP4),
     2                (IGPCO(2,1),GPCO1(1)), (IGPCO(2,2),GPCO2(1)),
     3                (IGPCO(2,3),GPCO3(1)), (IGPCO(2,4),GPCO4(1)),
     4                (ICOSYT,GRIDP(3))
      DATA    SWLOAD/ 4HFPON,4HT   /
C
      NR = 6
      NP = 5
      MINUS = 5
   10 CALL READ (*120,*130,SLT,GRIDP(2),NR,0,FLAG)
      SCALE   = GRIDP(3)
      PONT(1) = IP1
      PONT(2) = IP2
      IF (NP .EQ. 3) GO TO 20
      PONT(3) = IP3
      PONT(4) = IP4
   20 PONT(NP)= GPID
      CALL PERMUT (PONT(1),IORD(1),NP,OLD)
      DO 30 I = 1,NP
      L = IORD(I)
   30 CALL FNDPNT (IGPCO(1,L),PONT(L))
      IF (NP .EQ. 3) GO TO 50
      DO 40 I = 1,3
      VECT1(I) = GPCO2(I) - GPCO1(I)
   40 VECT2(I) = GPCO4(I) - GPCO3(I)
      CALL CROSS (VECT1(1),VECT2(1),VECT(1))
      GO TO 70
   50 DO 60 I = 1,3
   60 VECT(I) = GPCO2(I) - GPCO1(I)
   70 CALL NORM (VECT(1),XL)
   80 IF (IGPCO(1,NP)) 90,100,90
   90 CALL BASGLB (VECT(1),VECT(1),IGPCO(2,NP),IGPCO(1,NP))
  100 CALL FNDSIL (GPID)
      GPID = GPID + (IFM-MINUS)*3 - 1
      DO 110 I = 1,3
      IN = GPID + I
      CORE(IN) = CORE(IN) + VECT(I)*SCALE
  110 CONTINUE
      GO TO 150
  120 N1 = -2
      GO TO 140
  130 N1 = -3
  140 IPARM = SLT
      CALL MESAGE (N1,IPARM,SWLOAD)
  150 RETURN
C
C
      ENTRY TPONT
C     ===========
C
C     TPONT PROCESSES FORCE1 AND MOMENT1 CARDS
C
      NR = 4
      NP = 3
      MINUS = 3
      GO TO 10
C
C
      ENTRY DIRECT
C     ============
C
C     DIRECT PROCESSES FORCE+ MOMENT CARDS
C
      NP = 1
      MINUS = 1
      CALL READ (*120,*130,SLT,GRIDP(2),6,0,FLAG)
      DO 170 I = 1,3
  170 VECT(I) = GRIDP(I+4)
      CALL FNDPNT (IGPCO(1,1),GPID)
      SCALE = GRIDP(4)
      IF (ICOSYT .EQ. IGPCO(1,NP)) GO TO 100
      IF (ICOSYT) 180,80,180
  180 CALL GLBBAS (VECT(1),VECT(1),IGPCO(2,1),ICOSYT)
      GO TO 80
C
C
      ENTRY SLOAD
C     ===========
C
C     SLOAD PROCESSES SLOAD CARDS
C
      CALL READ (*120,*130,SLT,GRIDP(2),2,0,FLAG)
      CALL FNDSIL (GPID)
      CORE(GPID) = CORE(GPID) + GRIDP(3)
      GO TO 150
      END

      SUBROUTINE ENDPUT ( BLOCK )
      INCLUDE 'DSIOF.COM'
      INCLUDE 'XNSTRN.COM'
      INTEGER BLOCK( 15 )
      LIM = NBUFF - BLOCK( 3 )*2
      NAME = BLOCK( 1 )
      CALL DSGEFL
      IF ( BLOCK( 7 ) .LE. 0 ) GO TO 10
      IF ( BLOCK( 6 ) .GE. BLOCK( 7 ) ) GO TO 5
      CALL DSMSG1( BLOCK )
      CALL DSMSG ( 109 )
5     IBASE( INDCBP+1 ) = IDSSH  + BLOCK(7)
      IBASE( INDCBP+2 ) = BLOCK(4)
      NWORDS = BLOCK( 11 )
      INDCBP = INDCBP + ( BLOCK( 7 ) * NWORDS ) + 2
      IF ( ( INDCBP-INDBAS ) .GT. LIM ) CALL DSMSG( 108 )
      IF ( BLOCK( 3 ) .EQ. 0 ) GO TO 10
      IBASE( INDCBP+1 ) = IDSST + BLOCK( 7 )
      IBASE( INDCBP+2 ) = BLOCK(4) + BLOCK(7) - 1
      INDCBP = INDCBP + 2
10    IF ( BLOCK( 8 ) .NE. 1 ) GO TO 20
      IBASE( INDCBP+1 ) = IDSCT +  BLOCK(3)*MULQ3 + BLOCK(2)
      IBASE( INDCBP+2 ) = BLOCK( 12 )
      IBASE( INDCBP+3 ) = IDSRT + IDSC + ( INDCLR-INDBAS+1 )
      IBASE( INDCLR )   = IDSSB + BLOCK( 9 ) + INDCBP-INDCLR+2
      INDCBP = INDCBP + 4
      INDCLR = INDCBP
20    IF ( BLOCK( 6 ) .NE. BLOCK( 7 ) ) GO TO 50
      IF ( BLOCK ( 8 ) .NE. 1 ) GO TO 30
      IBASE( INDCBP ) = IDSEB
      GO TO 40
30    IFLG = BLOCK( 9 )
      IF ( IFLG .EQ. IDSX ) GO TO 45
      IFLG = IDSP
      BLOCK( 9 ) = IDSX
45    IBASE( INDCLR ) = IDSSB + IFLG + ( INDCBP-INDCLR )
      IBASE( INDCBP + 1 ) = IDSRT + IFLG + ( INDCLR-INDBAS+1 )
      IBASE( INDCBP + 2 ) = IDSEB
      INDCLR = INDCBP + 2
      INDCBP = INDCLR
40    CALL DSWRNB
CWKBD  NCL93007 11/94
C  50 CALL DSSDCB
CWKBNB NCL93007 11/94
C ACCUMULATE THE TOTAL NUMBER OF TERMS AND STRINGS
50    FCB( 16, IFILEX ) = FCB( 16, IFILEX ) + 1
      FCB( 17, IFILEX ) = FCB( 17, IFILEX ) + BLOCK( 7 )
      CALL DSSDCB
CWKBNE NCL93007 11/94
      RETURN
      END

      SUBROUTINE STORD1
C
C
C*****
C THIS ROUTINE IS PHASE  I OF STRESS DATA RECOVERY FOR AN AXI-SYMMETRIC
C TOROIDAL THIN SHELL RING
C*****
C
C
C
C                        ECPT FOR THE TOROIDAL RING
C
C                                                       TYPE
C ECPT( 1) ELEMENT IDENTIFICATION                         I
C ECPT( 2) SCALAR INDEX NO. FOR GRID POINT A              I
C ECPT( 3) SCALAR INDEX NO. FOR GRID POINT B              I
C ECPT( 4) ANGLE OF CURVATURE AT GRID POINT A             R
C ECPT( 5) ANGLE OF CURVATURE AT GRID POINT B(NOT USED)   R
C ECPT( 6) MATERIAL ORIENTATION (NOT USED)                R
C ECPT( 7) MATERIAL IDENTIFICATION                        I
C ECPT( 8) MEMBRANE THICKNESS                             R
C ECPT( 9) FLEXURE THICKNESS                              R
C ECPT(10) COOR. SYS. ID. FOR GRID POINT A                I
C ECPT(11) X-COOR. OF GRID POINT A (IN BASIC COOR.)       R
C ECPT(12) Y-COOR. OF GRID POINT A (IN BASIC COOR.)       R
C ECPT(13) Z-COOR. OF GRID POINT A (IN BASIC COOR.)       R
C ECPT(14) COOR. SYS. ID. FOR GRID POINT B                I
C ECPT(15) X-COOR. OF GRID POINT B (IN BASIC COOR.)       R
C ECPT(16) Y-COOR. OF GRID POINT B (IN BASIC COOR.)       R
C ECPT(17) Z-COOR. OF GRID POINT B (IN BASIC COOR.)       R
C ECPT(18) EL. TEMPERATURE FOR MATERIAL PROPERTIES        R
C
C
      DIMENSION          IECPT(18)
      DIMENSION          GAMBQF(72),    GAMBQM(48)
      DIMENSION          EE(4), GAMBQ(144), GAMRS(144)
      DIMENSION          AKI(36),  DELINT(66)
      DIMENSION                    ICS(2)
      DIMENSION          GAMBL(144)
C
      COMMON /CONDAS/ CONSTS(5)
      COMMON   /SDR2X5/
     1                   ECPT(18)
     2,                  DUM5(82)
     3,                  IDEL,     IGP(2),   TZ
     4,                  SEL(180), TS(30),   AK(144)
      COMMON   /MATIN/
     1                   MATIDC        ,MATFLG
     2,                  ELTEMP        ,STRESS
     3,                  SINTH         ,COSTH
      COMMON   /MATOUT/
     1                   E(3)          ,ANU(3)
     2,                  RHO           ,G(3)
     3,                  ALF(3)        ,TZERO,    GSUBE
      COMMON   /SDR2X6/
     1                   D(180),   R(2),     Z(2),     ALPH(2)
C
      EQUIVALENCE ( CONSTS(2) , TWOPI  )
      EQUIVALENCE ( CONSTS(4) , DEGRA  )
      EQUIVALENCE        (IECPT(1) , ECPT(1))
      EQUIVALENCE        (A1, ALPH(1)), (A2, ALPH(2))
      EQUIVALENCE        (R1, R(1)),    (R2, R(2))
      EQUIVALENCE        (Z1, Z(1)),    (Z2, Z(2))
      EQUIVALENCE        (GAMBQF(1), GAMBQ(1))
      EQUIVALENCE        (GAMBQM(1), GAMBQ(73))
      EQUIVALENCE        (DELINT(1), GAMBQ(1))
      EQUIVALENCE        (GAMRS(1),  GAMBQ(1))
      EQUIVALENCE        (AKI(1),    GAMBQ(1))
      EQUIVALENCE        (GAMBL(1), GAMBQ(1))
C
C ----------------------------------------------------------------------
C
C STORE ECPT PARAMETERS IN LOCAL VARIABLES
C
      IDEL   = IECPT(1)
      IGP(1) = IECPT(2)
      IGP(2) =  IECPT(3)
      MATID  =  IECPT(7)
      ICS(1) =  IECPT(10)
      ICS(2) =  IECPT(14)
      ALPH(1)=  ECPT(4)
      ALPH(2)=  ECPT(5)
      TM     =  ECPT(8)
      TF     =  ECPT(9)
      R(1)   =  ECPT(11)
      D(1)   =  ECPT(12)
      Z(1)   =  ECPT(13)
      R(2)   =  ECPT(15)
      D(2)   =  ECPT(16)
      Z(2)   =  ECPT(17)
      TEMPE  =  ECPT(18)
C
C
C TEST THE VALIDITY OF THE GRID POINT COORDINATES
C
      DO 200 I = 1,2
      IF (R(I) .LT. 0.0E0) CALL MESAGE(-30,37,IDEL)
      IF (D(I) .NE. 0.0E0) CALL MESAGE(-30,37,IDEL)
  200 CONTINUE
C
C
C DETERMINE IF ELEMENT IS A TOROIDAL, CONICAL OR CYLINDRICAL RING
C
      ITORD = 0
      IF (ABS(A1-A2) .LE. .000001) ITORD = 1
      IF (ITORD .EQ. 1  .AND.  ABS(A1-90.0E0) .LE. .00001) ITORD = -1
C
C
C COMPUTE THE ELEMENT COORDINATES
C
      A1 = A1 * DEGRA
      A2 = A2 * DEGRA
      PHIB = A2 - A1
      SINA1 =  SIN(A1)
      COSA1 =  COS(A1)
      SINA2 =  SIN(A2)
      COSA2 =  COS(A2)
C
      IF (ITORD .NE. 0) GO TO 300
C
C FOR THE TOROIDAL RING
C
      RP =  SQRT( (R2-R1)**2 + (Z2-Z1)**2 )
     1      / (2.0E0 *  SIN(PHIB/2.0E0))
      S = PHIB * RP
      GO TO 350
C
C FOR THE CONICAL OR CYLINDRICAL RING
C
  300 CONTINUE
      RP = 0.0D0
      S  =  SQRT( (R2-R1)**2 + (Z2-Z1)**2 )
C
  350 CONTINUE
C
C
C COMPUTE THE BASIC AND REQUIRED INTEGRALS
C
C
C SET UP ARRAY OF CONSTANTS FOR ROMBER INTEGRATION ROUTINE
C
      D(21) = 0.0E0
      D(22) = RP
      D(23) = R1
      D(24) = COSA1
      D(25) = SINA1
C
C COMPUTE CONSTANTS NEEDED FOR INTEGRAL CALCULATIONS
C
      D(30) = R1 - RP * SINA1
      D(31) = RP * COSA1
      D(32) = RP * SINA1
      D(33) = COSA1 ** 2
      D(34) = SINA1 * COSA1
      D(35) = SINA1 ** 2
      D(36) = 0.5 - D(35)
C
C START LOOP  FOR CALCULATIONS OF INTEGRALS
C
      DO 500 JP1 = 1,11
      J = JP1 - 1
      K = (J * 6) + 1
      DJP1 = JP1
C
C TEST FOR ELEMENT SHAPE
C
      IF (ITORD) 470,400,430
C
C THE TOROIDAL RING BASIC INTEGRALS WILL BE COMPUTED IN
C LOCATIONS D(1),...,D(6)
C
  400 CONTINUE
      D(20) = (RP ** JP1)
C
C COMPUTE I(J,1)
C
      D(1) = D(20) * (PHIB ** JP1) / DJP1
C
C COMPUTE I(J,2)
C
      D(2) = (PHIB ** (JP1+1)) / (DJP1 + 1.0E0)
      D(10) = 1.0E0
      DO 410 I = 1,20
      IP = JP1 + 2 * I + 1
      D(11) = 2 * I + 1
      D(10) = D(10) * D(11) * (D(11)-1.0E0)
      D(12) = (-1.0E0)** I  * PHIB ** IP
     1        / ((DJP1 + D(11)) * D(10))
      D(13) =  ABS( D(12) / D(2) )
      D(2) = D(2) + D(12)
      IF (D(13) .LE. 1.0E-10) GO TO 415
  410 CONTINUE
      CALL MESAGE(-30,26,IDEL)
  415 CONTINUE
      D(2) = D(20) * D(2)
C
C COMPUTE I(J,3)
C
      D(3) = (PHIB ** JP1) / DJP1
      D(10) = 1.0E0
      DO 420 I = 1,20
      IP = JP1 + 2 * I
      D(11) = 2 * I
      D(10) = D(10) * D(11) * (D(11) - 1.0E0)
      D(12) = (-1.0E0)** I  * PHIB ** IP
     1        / ((DJP1 + D(11)) * D(10))
      D(13) =  ABS( D(12) / D(3) )
      D(3) = D(3) + D(12)
      IF (D(13) .LE. 1.0E-10) GO TO 425
  420 CONTINUE
      CALL MESAGE(-30,26,IDEL)
  425 CONTINUE
      D(3) = D(20) * D(3)
      D(26) = DJP1
C
C COMPUTE I(J,4)
C
      CALL ROMBER (PHIB, D(10), IP, D(4), 1, D(21) )
      IF (IP .GE. 15) CALL MESAGE (30,26,IDEL)
      D(4) = D(20) * D(4)
C
C COMPUTE I(J,5)
C
      CALL ROMBER (PHIB, D(10), IP, D(5), 2, D(21) )
      IF (IP .GE. 15) CALL MESAGE (30,26,IDEL)
      D(5) = D(20) * D(5)
C
C COMPUTE I(J,6)
C
      CALL ROMBER (PHIB, D(10), IP, D(6), 3, D(21) )
      IF (IP .GE. 15) CALL MESAGE (30,26,IDEL)
      D(6) = D(20) * D(6)
C
C THE TOROIDAL RING REQUIRED INTEGRALS
C
      DELINT(K  ) = D(30) * D(1) + D(31) * D(2) + D(32) * D(3)
      DELINT(K+1) = COSA1 * D(2) + SINA1 * D(3)
      DELINT(K+2) = D(33) * D(4) + D(34) * D(5) + D(35) * D(6)
      DELINT(K+3) = COSA1 * D(3) - SINA1 * D(2)
      DELINT(K+4) = D(34) * (D(6)-D(4))  + D(36) * D(5)
      DELINT(K+5) = D(33) * D(6) - D(34) * D(5) + D(35) * D(4)
      GO TO 490
C
C THE CONICAL RING BASIC INTEGRALS WILL BE COMPUTED IN
C LOCATIONS D(1) AND D(2)
C
  430 CONTINUE
C
C COMPUTE I(J,1)
C
      D(1) = (S ** JP1) / DJP1
C
      IF (J - 1) 435,440,445
C
C COMPUTE I(0,2)
C
  435 CONTINUE
      D(2) = ALOG( (R1 + S*COSA1) / R1 ) / COSA1
      GO TO 460
C
C COMPUTE I(1,2)
C
  440 CONTINUE
      D(2) = (S - (R1/COSA1) * ALOG( (R1 + S*COSA1) / R1 )) / COSA1
      GO TO 460
C
C COMPUTE I(J,2) WHERE J .GT. 1
C
  445 CONTINUE
      D(2) = 1.0E0 / DJP1
      D(10) =-S * COSA1 / R1
      DO 450 I = 1,1000
      D(11) = JP1 + I
      D(12) = (D(10) ** I) / D(11)
      D(2) = D(2) + D(12)
      IF (D(12) .LT. 1.0E-4 ) GO TO 455
  450 CONTINUE
      CALL MESAGE(-30,26,IDEL)
  455 CONTINUE
      D(2) = ( (S ** JP1) / R1 ) * D(2)
  460 CONTINUE
C
C THE CONICAL RING REQUIRED INTEGRALS
C
      DELINT(K  ) = R1 * D(1) + COSA1 * ((S**(JP1+1)) / (DJP1+1.0E0))
      DELINT(K+1) = SINA1 * D(1)
      DELINT(K+2) = D(35) * D(2)
      DELINT(K+3) = COSA1 * D(1)
      DELINT(K+4) = D(34) * D(2)
      DELINT(K+5) = D(33) * D(2)
      GO TO 490
C
C THE CYLINDRICAL RING BASIC INTEGRALS WILL BE COMPUTED IN
C LOCATIONS D(1) AND D(2)
C
  470 CONTINUE
C
C COMPUTE I(J,1)
C
      D(1) = (S ** JP1) / DJP1
C
C COMPUTE I(J,2)
C
      D(2) = D(1) / R1
C
C THE CYLINDRICAL RING REQUIRED INTEGRALS
C
      DELINT(K  ) = R1 * D(1) + COSA1 * ((S**(JP1+1)) / (DJP1+1.0E0))
      DELINT(K+1) = SINA1 * D(1)
      DELINT(K+2) = D(35) * D(2)
      DELINT(K+3) = 0.0E0
      DELINT(K+4) = 0.0E0
      DELINT(K+5) = 0.0E0
C
  490 CONTINUE
  500 CONTINUE
C
C
C LOCATE THE MATERIAL PROPERTIES IN THE MAT1 OR MAT3 TABLE
C
      MATIDC = MATID
      MATFLG = 7
      ELTEMP = TEMPE
      CALL MAT(IDEL)
C
C
C SET MATERIAL PROPERTIES IN LOCAL VARIABLES
C
      EP = E(1)
      ET = E(2)
      VPT= ANU(1)
      TZ = TZERO
      VTP= VPT * ET / EP
      DEL = 1.0E0 - VPT * VTP
C
C
C GENERATE THE ELASTIC CONSTANTS MATRIX(2X2)
C
      EE(1) = EP / DEL
      EE(2) = ET * VPT / DEL
      EE(3) = EE(2)
      EE(4) = ET / DEL
C
C
C FORM THE STIFFNESS MATRIX IN FIELD COORDINATES
C
C COMPUTE CONSTANTS NEEDED IN DMATRX SUBROUTINE
C
      D(1) = EP / ET
      D(7) = 0.0E0
      IF (ITORD .EQ. 0) D(7) = 1.0E0 / RP
      D(2) = D(1) * D(7)
      D(3) = D(2) * D(7)
      D(4) = VPT * D(7)
      D(5) =(EP * TM / (D(1) - VPT**2)) * TWOPI
      D(6) =(EP * (TF**3) / (12.0E0 * (D(1) - VPT**2))) * TWOPI
C
C CALL THE AMATRIX SUBROUTINE TO COMPUTE THE STIFFNESS MATRIX (10X10)
C
C NOTE THE DOUBLE SUBSCRIPTING USED IN AMATRIX SUBROUTINE IS
C COMPATIBLE WITH THE CALLING PROGRAM. THE DELINT ARRAY OF INTEGRALS
C IS A (11X6) SINGLY SUBSCRIPTED ARRAY (STORED ROWWISE) IN THE CALLING
C PROGRAM AND IT IS A (6X11) DOUBLY SUBSCRIPTED ARRAY (STORED
C COLUMNWISE) IN AMATRX ROUTINE.
C
C
      CALL AMATRX(AK(1), VPT, D(1), D(2), D(3), D(4), D(5), D(6)
     1,           DELINT(1) )
C
C
C FORM THE STRESS MATRIX IN FIELD COORDINATES
C
C COMPUTE THE CONSTANTS NEEDED IN THE SCRLM SUBROUTINE
C
      D(1) = 0.0E0
      IF (ITORD .EQ. 0) D(1) = 1.0E0 / RP
      D(2) = 0.0E0
      D(3) = S / 2.0E0
      D(4) = S
C
C CALL THE SCRLM SUBROUTINE TO COMPUTE THE STRESS MATRIX TRANSPOSED
C
C NOTE THE DOUBLE SUBSCRIPTING USED IN THE SCRLM SUBROUTINE IS
C COMPATIBLE WITH THE CALLING PROGRAM. THE SEL ARRAY WILL RETURN WITH
C THE STRESS MATRIX TRANSPOSED (10X15, STORED ROWWISE) BUT IN THE SCRLM
C SUBROUTINE THE STRESS MATRIX IS COMPUTED AS A DOUBLY SUBSCRIPTED
C 15X10 ARRAY (STORED COLUMNWISE).
C
C
      CALL SCRLM (SEL(1), D(2), EE(1), TM, 0.0E0, RP, A1, R1, D(1), TF)
C
C
C FORM THE TRANSFORMATION MATRIX(10X12) FROM FIELD COORDINATES TO GRID
C POINT DEGREES OF FREEDOM
C
      DO 600 I = 1,72
      GAMBQF(I) = 0.0E0
  600 CONTINUE
      D(1) = S
      D(2) = S ** 2
      D(3) = S ** 3
      D(4) = S ** 4
      D(5) = S ** 5
      GAMBQF( 3) = 1.0E0
      GAMBQF(16) = 1.0E0
      GAMBQF(30) = 0.5E0
      GAMBQF(39) = -10.0E0 / D(3)
      GAMBQF(40) = - 6.0E0 / D(2)
      GAMBQF(42) = - 1.5E0 / D(1)
      GAMBQF(45) = -GAMBQF(39)
      GAMBQF(46) = - 4.0E0 / D(2)
      GAMBQF(48) =   0.5E0 / D(1)
      GAMBQF(51) =  15.0E0 / D(4)
      GAMBQF(52) =   8.0E0 / D(3)
      GAMBQF(54) =   1.5E0 / D(2)
      GAMBQF(57) = -GAMBQF(51)
      GAMBQF(58) =   7.0E0 / D(3)
      GAMBQF(60) = - 1.0E0 / D(2)
      GAMBQF(63) = - 6.0E0 / D(5)
      GAMBQF(64) = - 3.0E0 / D(4)
      GAMBQF(66) = - 0.5E0 / D(3)
      GAMBQF(69) = -GAMBQF(63)
      GAMBQF(70) =  GAMBQF(64)
      GAMBQF(72) = -GAMBQF(66)
      DO 650 I = 1,48
      GAMBQM(I) = 0.0E0
  650 CONTINUE
      GAMBQM( 1) = 1.0E0
      GAMBQM(17) = 1.0E0
      GAMBQM(25) = - 3.0E0 / D(2)
      GAMBQM(29) = - 2.0E0 / D(1)
      GAMBQM(31) = -GAMBQM(25)
      GAMBQM(35) = - 1.0E0 / D(1)
      GAMBQM(37) =   2.0E0 / D(3)
      GAMBQM(41) =   1.0E0 / D(2)
      GAMBQM(43) = -GAMBQM(37)
      GAMBQM(47) =  GAMBQM(41)
C
C
C TRANSFORM THE STIFFNESS MATRIX TO GRID POINT DEGREES OF FREEDOM
C
      CALL GMMATS(GAMBQ(1), 10, 12, 1, AK(1), 10, 10, 0, D(1) )
      CALL GMMATS(D(1), 12, 10,  0, GAMBQ(1), 10, 12, 0, AK(1) )
C
C
C RE-ARRANGE THE TRANSFORMATION MATRIX (GAMBQ) SUCH THAT THE MEMBRANE
C AND FLEXURE TERMS ARE REVERSED
C
      DO 660 I = 1,72
      D(I) = GAMBQF(I)
  660 CONTINUE
      DO 670 I = 1,48
      GAMBQ(I) = GAMBQM(I)
  670 CONTINUE
      DO 680 I = 1,72
      GAMBQ(I+48) = D(I)
  680 CONTINUE
C
C
C TRANSFORM THE STRESS MATRIX TO GRID POINT DEGREES OF FREEDOM
C
      CALL GMMATS (SEL(1), 10, 15, 1, GAMBQ(1), 10, 12, 0, D(1) )
C
C
C FORM THE TRANSFORMATION MATRIX (12X12) FROM ELEMENT TO BASIC
C COORDINATES
C
      DO 700 I = 1,144
      GAMRS(I) = 0.0E0
  700 CONTINUE
      GAMRS( 1) =  COSA1
      GAMRS( 3) = -SINA1
      GAMRS(25) =  SINA1
      GAMRS(27) =  COSA1
      GAMRS(40) = -1.0E0
      GAMRS(53) =  1.0E0
      GAMRS(66) =  1.0E0
      GAMRS(79) =  COSA2
      GAMRS(81) = -SINA2
      GAMRS(103)=  SINA2
      GAMRS(105)=  COSA2
      GAMRS(118)= -1.0E0
      GAMRS(131)=  1.0E0
      GAMRS(144)=  1.0E0
C
C
C TRANSFORM THE STRESS MATRIX FROM ELEMENT TO BASIC COORDINATES
C
      CALL GMMATS (  D(1), 15, 12, 0, GAMRS(1), 12, 12, 0, SEL(1) )
C
C
C TRANSFORM THE STIFFNESS MATRIX FROM ELEMENT TO BASIC COORDINATES
C
      CALL GMMATS(GAMRS(1), 12, 12, 1, AK(1), 12, 12, 0, D(1) )
      CALL GMMATS(D(1), 12, 12,  0, GAMRS(1), 12, 12, 0, AK(1) )
C
C
C LOCATE THE TRANSFORMATION MATRICES FROM BASIC TO LOCAL COORDINATES
C FOR THE TWO GRID POINTS AND EXPAND TO (6X6)
C
      DO 730 I = 1,144
      GAMBL(I) = 0.0E0
  730 CONTINUE
      DO 800 I = 1,2
      CALL TRANSS (ICS(I) , D(1))
      K = 78 * (I - 1)
      DO 750 J = 1,3
      KK = K + 12* (J-1) + 1
      KL = 3 * (J-1) + 1
      KJ = K + 12* (J+2) + J + 3
      GAMBL(KK  ) = D(KL  )
      GAMBL(KK+1) = D(KL+1)
      GAMBL(KK+2) = D(KL+2)
      GAMBL(KJ) = 1.0E0
  750 CONTINUE
  800 CONTINUE
C
C
C
C TRANSFORM THE STIFFNESS MATRIX FROM BASIC TO LOCAL COORDINATES
C
      CALL GMMATS (GAMBL(1), 12, 12, 1, AK(1), 12, 12, 0, D(1) )
      CALL GMMATS (D(1), 12, 12,  0, GAMBL(1), 12, 12, 0, AK(1) )
C
C
C TRANSFORM THE STRESS MATRIX FROM BASIC TO LOCAL COORDINATES
C
      CALL GMMATS (SEL(1), 15, 12, 0, GAMBL(1), 12, 12, 0, D(1) )
C
      DO 820 I = 1,180
      SEL(I) = D(I)
  820 CONTINUE
C
C
C FORM THE THERMAL STRESS VECTOR (30X1)
C
C THE MEMBRANE TEMPERATURE TERMS WILL BE STORED IN TS(1),...,TS(15) AND
C THE FLEXURE GRADIENT TEMP. TERMS WILL BE STORED IN TS(16),...,TS(30)
C
C
C COMPUTE CONSTANTS NEEDED IN THE THERMAL STRESS CALCULATIONS
C
      D(1) = 0.0E0
      D(2) = S / 2.0E0
      D(3) = S
      D(4) = EE(1) * ALF(1) + EE(2) * ALF(2)
      D(5) = EE(3) * ALF(1) + EE(4) * ALF(2)
      D(6) = (EE(1)-EE(2)) * ALF(1) + (EE(3)-EE(4)) * ALF(2)
      D(7) = TF ** 3 / 12.0E0
      D(8) = TM / S
      D(9) = D(7) / S
C
C START THE LOOP TO FORM THE THERMAL STRESS VECTORS AT EACH OF THE
C THREE STRESS POINTS
C
      DO 850 I = 1,3
      CALL SOLVE1(A1, R1, RP, D(I), D(12), D(13), D(14), 0.0E0)
      K = 5 * (I - 1)
      KK = K + 15
      TS(K +1) = TM * D(4)
      TS(K +2) = TM * D(5)
      TS(K +3) = D(7) * D(4)
      TS(K +4) =-D(7) * D(5)
      TS(K +5) = D(7) * D(12) * D(6)
      TS(KK+1) = D(8) * D(I)  * D(4)
      TS(KK+2) = D(8) * D(I)  * D(5)
      TS(KK+3) = D(9) * D(I)  * D(4)
      TS(KK+4) =-D(9) * D(I)  * D(5)
      TS(KK+5) = D(9) * (D(4) + D(I) * D(12) * D(6))
  850 CONTINUE
C
C
      RETURN
      END

      SUBROUTINE SMC2CS ( ZI, ZCS, ZIL, ZOL, NAR, LASROW, RTEMP
     &                  , I1, I2, I3  )
C
C ZIL    = INNER LOOP TERMS (SIZE = MAXNAC * (MAXNCOL+NEXTRA)
C ZOL    = OUTER LOOP TERMS (SIZE = (MAXNCOL+NEXTRA) * 2)
C NAR    = SAVE AREA FOR ACTIVE ROWS OF PREVIOUS COLUMN
C I1     = MAXIMUM NUMBER OF ACTIVE ROWS FOR THIS COLUMN
C I2     = NUMBER OF COLUMNS ALLOCATED FOR STORAGE OF INNER AND 
C          NUMBER OF ROWS ALLOCATED FOR OUTER LOOP
C I3     = MAXIMUM NUMBER OF WORDS FOR DEFINING THE ACTIVE ROWS FOR 
C          ANY COLUMN
C LASROW = LAST NON-ZERO ROW INDEX FOR A GIVEN COLUMN (SIZE = MAXNCOL
C          +NEXTRA)
C
      COMPLEX           ZCS(10)      , RTEMP(I3)              
      COMPLEX           ZIL( I1, I2 ), ZOL( I2, 2 ), ZOLTMP
      INTEGER           ZI(10), NAR( I3 )
      INTEGER           LASROW(I2)
      INCLUDE           'SMCOMX.COM'                    
C      
C GET ROW VALUES CORRESPONDING TO THE ACTIVE ROWS OF COLUMN K FOR
C EACH COLUMN KFRCOL THROUGH KLSCOL IN ORDER TO FILL INNER LOOP AND
C OUTER LOOP AREAS.
C
C
C BEGIN TO PROCESS EACH COLUMN
C FOR COLUMN K, GET OUTER LOOP TERMS
C    A(K,J) / A(J,J)
C       K = CURRENT PIVOTAL COLUMN
C       J = RANGES FROM FIRST COLUMN DATA NEEDED FOR COLUMN K TO K-1
C    (E.G.,
C         A(5,1)/A(1,1)
C         A(5,2)/A(2,2)
C         A(5,3)/A(3,3)
C         A(5,4)/A(4,4)
C ALSO, GET INNER LOOP TERMS
C    A(I,J)
C       K = CURRENT PIVOTAL COLUMN
C       I = RANGES FROM K TO LAST ACTIVE ROW OF COLUMN K
C       J = RANGES FROM FIRST COLUMN DATA NEEDED FOR COLUMN K TO K-1
C    (E.G.,
C         A(5,1) A(6,1)  .  A(N,1)
C         A(5,2) A(6,2)  .  A(N,2)
C         A(5,3) A(6,3)  .  A(N,3)
C         A(5,4) A(6,4)  .  A(N,4)
C         
C  LOOP 7000 WILL BE ON K
C  LOOP 6000 WILL BE ON J
C    
      IC1     = 1
      IC2     = 2
      IILROW1 = 1
c      print *,' i1,i2,i3,maxncol,maxnac=',i1,i2,i3,maxncol,maxnac
      DO 7000 K = 1, NCOL
      KK      = MOD( K, I2 )
      IF ( KK .EQ. 0 ) KK = I2
      LASROW( KK ) = 0
c      PRINT *,' SMC2RD PROCESSING COLUMN K=',K
      KCOL    = K
      KDIR    = K*4 - 3
      KMIDX   = ZI( KDIR   )
C
C SEE IF DATA IS ON IN MEMORY OR ON THE SPILL FILE     
C      
      IF ( KMIDX .NE. 0 ) GO TO 500
C
C DATA IS ON THE SPILL FILE
C      
      CALL SMCSPL ( KCOL, ZI )
      KMIDX  = ZI( KDIR )
500   CONTINUE
      KFRCOLP= KFRCOL
      KLSCOLP= KLSCOL
      KFRCOL = ZI( KDIR+1 )  
      KM2    = ZI( KMIDX+1)
      KRIDXN = KMIDX + 4 + KM2
      KLSCOL = K - 1
      KRIDX  = KMIDX+4
      KRIDXS = KRIDX
      KROW1  = ZI( KRIDX   )
      KROWN  = KROW1 + ZI( KRIDX+1 ) - 1
      KAROWS = 0
      DO 510 KK = 1, KM2, 2
      KAROWS = KAROWS + ZI( KRIDX+KK )
510   CONTINUE
C
C IF THE PREVIOUS COLUMN DID NOT NEED DATA FROM A COLUMN PRECEEDING IT,
C THEN MUST RELOAD THE INNER AND OUTER LOOP ARRAYS
C
      IF ( KLSCOLP .LT. KFRCOLP ) GO TO 1350
C     
C NOW MUST FIND THE ROW AND COLUMN NUMBER FOR THIS PIVOT COLUMN
C THAT IS NOT ALREADY IN THE INNER LOOP AND OUTER LOOP ARRAYS.
C FIRST CHECK THAT THE FIRST REQUIRED ROW IS STORED, IF NOT THEN WE MUST 
C BEGIN AS IF NOTHING STORED.  IF SOME OF THE REQUIRED ROWS ARE PRESENT,
C THEN FIND THE NEXT POSITION AND ROW NUMBER TO BE STORED IN THE INNER
C LOOP ARRAY AND THE NEXT POSITION AND COLUMN NUMBER TO BE STORED IN THE
C OUTER LOOP ARRAY.
C
C IF THE FIRST COLUMN IS LESS THAN FIRST COLUMN OF LAST PIVOT COLUMN
C THEN WE MUST LOAD THE INNER AND OUTER LOOPS FROM THE BEGINNING
C
      IF ( KFRCOL .LT. KFRCOLP ) GO TO 1350
      KR      = 1
      LROW1   = NAR( 1 ) 
      LROWN   = NAR( 1 ) + NAR( 2 ) - 1
C
C  LROW1 = FIRST ROW OF A STRING OF CONTIGUOUS ROWS OF LAST PIVOT 
C          COLUMN PROCESSED
C  LROWN = LAST ROW OF A STRING OF CONTIGUOUS ROWS OF LAST PIVOT COLUMN 
C          PROCESSED
C      
C FIND FIRST ROW IN INNER LOOP THAT MATCHES THE FIRST ROW REQUIRED
C FOR THIS COLUMN
C
C IF THERE IS NO MATCH FOR THE FIRST COLUMN, THEN GO TO 1350
C
1105  CONTINUE
      IF ( LROW1 .GT. KROW1 ) GO TO 1350
      IF ( KROW1 .LT. LROWN ) GO TO 1100
C
C NO OVERLAP WITH THIS STRING, GO AND GET NEXT STRING
C ADJUST 'ILLROW1' WHICH IS THE POINTER TO THE FIRST ROW IN THE INNER
C LOOP THAT CONTAINS THE VALUE OF ROW "KROW1" OF EACH COLUMN.
C
      INCR    = LROWN - LROW1 + 1
      IILROW1 = IILROW1 + INCR
      IF ( IILROW1 .GT. I1 ) IILROW1 = IILROW1 - I1
      KR      = KR + 2    
      LROW1   = NAR( KR )
      IF ( LROW1 .EQ. 0 ) GO TO 1350     
      LROWN   = LROW1 + NAR( KR+1 ) - 1
      GO TO 1105
1100  CONTINUE
C      
C THERE IS AN OVERLAP, SET KROWB, KROWSB, AND IILROW1 TO REFLECT
C THE PROPER ROW NUMBER IN THE INNER LOOP
C
      INCR    = KROW1 - LROW1
      KROWB   = KROW1 
      KROWSB  = KROWN - KROWB + 1 
      KRIDXS  = KRIDX
      IILROW1 = IILROW1 + INCR
      IF ( IILROW1 .GT. I1    ) IILROW1 = IILROW1 - I1
      LROW1   = KROW1
      IILROW  = IILROW1
1120  IF ( LROW1 .NE. KROW1 ) GO TO 1180
      IF ( LROWN .EQ. KROWN ) GO TO 1130
      IF ( LROWN .LT. KROWN ) GO TO 1140
      IF ( LROWN .GT. KROWN ) GO TO 1150
C
C THIS SET OF ROWS MATCHES, GO AND CHECK THE NEXT SET OF ROW NUMBERS
C
1130  CONTINUE
      INCR    = KROWN - KROWB + 1
      IILROW  = IILROW + INCR
      IF ( IILROW .GT. I1 ) IILROW = IILROW - I1
      KRIDX   = KRIDX + 2
      IF ( KRIDX .EQ. KRIDXN ) GO TO 1170
      KR      = KR + 2
      KROW1   = ZI( KRIDX )
      KROWB   = KROW1   
      KROWSB  = ZI( KRIDX+1 )  
      KROWN   = KROW1 + KROWSB -1
      KRIDXS  = KRIDX
      LROW1   = NAR( KR )
      LROWN   = LROW1 + NAR( KR+1 ) - 1
      IF ( LROW1 .EQ. 0 ) GO TO 1180 
      GO TO 1120
C
C LAST ROW NUMBERS DO NOT MATCH, KROWN GT LROWN
C
1140  CONTINUE
      INCR    = LROWN  - KROWB + 1
1145  KROWB   = KROWB  + INCR
      KROWSB  = KROWSB - INCR
      KRIDXS  = KRIDX
      IILROW  = IILROW + INCR
      IF ( IILROW .GT. I1 ) IILROW = IILROW - I1
      GO TO 1180
C
C LAST ROW NUMBERS DO NOT MATCH, KROWN LT LROWN
C
1150  CONTINUE
      INCR    = LROWN - LROW1 + 1
      GO TO 1145
C
C ROWS MATCH FOR INNER LOOP COLUMN VALUES, NOW DETERMINE THE COLUMN INDEX
C FOR THE NEXT COLUMN TO ADD TO THE INNER AND OUTER LOOP ARRAYS.
1170  CONTINUE
      KFRCOLG = KLSCOLP+1
      IILROW  = IILROW1
      GO TO 1400
C
C NOT ALL NEEDED ROW VALUES ARE PRESENT, MUST GET NEEDED ROWS
C FOR ALL COLUMNS REQUIRED FOR THIS PIVOT COLUMN
C
1180  CONTINUE
      KFRCOLG = KFRCOL
      GO TO 1400
C
C NO MATCH FOUND, WILL START LOADING THE INNER AND OUTER LOOP ARRAYS
C FROM THE BEGINNING
C
1350  IILROW1 = 1
      IILROW  = 1
      KROWB   = KROW1
      KROWSB  = KROWN - KROW1 + 1
      KFRCOLG = KFRCOL
1400  CONTINUE
      KRIDX   = KMIDX+4
      DO 1450 J = 1, KM2
      NAR( J ) = ZI( KRIDX+J-1 )
1450  CONTINUE
      NAR( KM2+1 ) = 0
      IILROWB = IILROW
C
C KFRCOL  = FIRST COLUMN NEEDED FOR PIVOT COLUMN "K"
C KLSCOL  = LAST COLUMN NEEDED FOR PIVOT COLUMN "K"
C KFRCOLG = FIRST COLUMN TO BE PLACED IN INNER/OUTER LOOP ARRAYS
C KFRCOLP = FIRST COLUMN OF LAST PIVOT COLUMN PROCESSED
C KLSCOLP = LAST COLUMN OF LAST PIVOT COLUMN PROCESSED
C
c      PRINT *,' KFRCOL,KLSCOL,KFRCOLG,KFRCOLP,KLSCOLP,KAROWS='
c      PRINT *,  KFRCOL,KLSCOL,KFRCOLG,KFRCOLP,KLSCOLP,KAROWS
c      PRINT *,' KROWB,KROWSB,IILROW1,IILROW,kridx='
c      PRINT *,  KROWB,KROWSB,IILROW1,IILROW,kridx
C
C KLSCOL WILL BE LESS THAN KFRCOLG FOR THE FIRST COLUMN AND FOR ANY
C COLUMN THAT DOES NOT NEED A PRECEEDING COLUMN OF DATA
C
      IF ( KLSCOL .LT. KFRCOLG ) GO TO 6000
      DO 3000 J = KFRCOLG, KLSCOL
      IILCOL = MOD ( J, I2 )  
      IF ( IILCOL .EQ. 0 ) IILCOL = I2
      JCOL   = J
      JDIR   = J*4 - 3
      JMIDX  = ZI( JDIR   )
C
C SEE IF COLUMN DATA IS IN MEMORY OR ON THE SPILL FILE
C      
      IF (  JMIDX .NE. 0 ) GO TO 1500
C
C DATA IS ON THE SPILL FILE
C      
      CALL SMCSPL ( JCOL, ZI )
      IF ( ZI( JDIR ) .EQ. 0 ) JMIDX = ISPILL
      IF ( ZI( JDIR ) .NE. 0 ) JMIDX = ZI( JDIR )
1500  CONTINUE
      JRIDX  = JMIDX + 4
      JM2    = ZI( JMIDX + 1 )
      JRIDXN = JRIDX + JM2
      JROWL  = ZI( JRIDX+JM2-2 ) + ZI( JRIDX+JM2-1 ) - 1
      JVIDX  = JRIDXN
C
C SAVE DIAGONAL TERM FOR COLUMN J ; (ALWAYS, THE FIRST TERM)
C      
      JVIDX  = JVIDX  / 2 + 1
      ZOL( IILCOL, IC2 )  = (1.0,0.0) / ZCS( JVIDX )
C
C FOR EACH COLUMN J, GET REQUIRED ROWS; I.E, ACTIVE ROWS OF COLUMN K
C      
      IF ( J .GT. KLSCOLP ) GO TO 1530
C
C SET VARIABLES FOR ADDING ROW TERMS TO AN EXISTING COLUMN IN THE INNER LOOP
C
      KRIDX  = KRIDXS   
      KROW   = KROWB
      KROWS  = KROWSB
      IILROW = IILROWB           
C
C SET LASROW TO ZERO IF THIS COLUMN IS BEING RELOADED INTO ZIL AND NOT
C BEING ADDED TO FROM SOME PREVIOUS COLUMN PROCESSING.
C
      IF ( IILROWB .EQ. IILROW1 ) LASROW( J ) = 0
      GO TO 1540
1530  CONTINUE
C
C  MUST RESET KRIDX, KROW AND KROWS FOR INSERTION OF NEW COLUMN IN INNER LOOP
C
      KRIDX  = KMIDX+4
      KROW   = ZI( KRIDX   )
      KROWS  = ZI( KRIDX+1 )
      IILROW = IILROW1
1540  CONTINUE
      KROWN  = KROW + KROWS - 1
C
C JROWL IS LAST ROW TERM IN COLUMN "J".  IF THIS IS BEFORE THE FIRST ROW 
C "KROW" TERM NEEDED, THEN NO MORE TERMS ARE NEEDED FROM COLUMN "J" AND
C "LASROW" WILL INDICATE THE LAST VALUE STORED FOR COLUMN "J".
C
      IF ( JROWL .LT. KROW ) GO TO 3000
2000  JROW   = ZI( JRIDX )
      JROWS  = ZI( JRIDX+1 )
      JROWN  = JROW + JROWS - 1
2010  CONTINUE      
      IF ( JROWN .LT. KROW  ) GO TO 2895
      IF ( JROW  .GT. KROWN ) GO TO 2400
      MISSIN = KROW - JROW
C
C CHECK TO SEE IF THERE ARE MISSING TERMS, I.E., TERMS CREATED DURING
C THE DECOMPOSITION.  IF THERE ARE MISSING TERMS, THEN SET THEIR VALUES
C TO BE INITIALLY ZERO.
C      
      IF ( MISSIN .GE. 0 ) GO TO 2050
      NZEROS = IABS( MISSIN )
C
C  STORE "NZEROS" NUMBER OF ZEROS FOR INNER LOOP TERMS
C
      IAVAIL = I1 - ( IILROW+NZEROS-1 )
      IF ( IAVAIL .LT. 0 ) GO TO 2022
      DO 2020 I = 1, NZEROS
      ZIL( IILROW+I-1, IILCOL ) = (0.0,0.0)
2020  CONTINUE
      IILROW = IILROW + NZEROS
      GO TO 2028
2022  ILIM1 = I1 - IILROW + 1
      ILIM2 = NZEROS - ILIM1
      DO 2024 I = 1, ILIM1
      ZIL( IILROW+I-1, IILCOL ) = (0.0,0.0)
2024  CONTINUE
      DO 2026 I = 1, ILIM2
      ZIL( I, IILCOL ) = (0.0,0.0)
2026  CONTINUE
      IILROW = ILIM2 + 1
2028  CONTINUE
      KROW  = KROW  + NZEROS 
      KROWS = KROWS - NZEROS 
2050  CONTINUE
      IF ( MISSIN .LE. 0 ) GO TO 2070
      ISKIP  = KROW  - JROW
      JVIDX  = JVIDX + ISKIP
      JROW   = JROW  + ISKIP
2070  CONTINUE
      IROWN  = MIN0 ( KROWN, JROWN )
      NUM    = IROWN - KROW + 1                                    
C
C  MOVE INNER LOOP VALUES FROM IN-MEMORY LOCATION TO 
C  THE INNER LOOP AREA
C      
      NROWS = IROWN - KROW + 1
      IF ( NROWS .GT. ( I1 - IILROW + 1 ) ) GO TO 2120
      DO 2100 I = 1, NROWS
      ZIL( IILROW+I-1, IILCOL ) = ZCS(JVIDX+I-1 )
2100  CONTINUE
      IILROW = IILROW + NROWS
      GO TO 2180
2120  ILIM1 = I1 - IILROW + 1
      ILIM2 = NROWS - ILIM1
      DO 2122 I = 1, ILIM1
      ZIL( IILROW+I-1, IILCOL ) = ZCS( JVIDX+I-1 )
2122  CONTINUE
      JVTMP = JVIDX + ILIM1
      DO 2124 I = 1, ILIM2
      ZIL( I, IILCOL ) = ZCS( JVTMP+I-1 )
2124  CONTINUE
      IILROW = ILIM2 + 1
2180  CONTINUE
      LASROW( IILCOL ) = IILROW 
C
C IF ALL OF THE ROWS ARE NON-ZERO, SET LASROW COUNTER TO IILROW1
C
      IF ( IILROW .EQ. IILROW1 ) LASROW( IILCOL ) = IILROW1
      JVIDX  = JVIDX + NROWS
      JROW   = JROW  + NROWS
      KROW   = IROWN + 1
      KROWS  = KROWN - IROWN 
C
C INCREMENT EITHER KROW OR JROW DEPENDING UPON WHETHER IROWN = JROWN
C OR IROWN = KROWN
C      
      IF ( IROWN .EQ. JROWN ) GO TO 2900
      GO TO 2530
2400  CONTINUE
C
C STORE ZEROS FOR CREATED TERMS AND INCREMENT TO THE NEXT SET OF
C OF ROWS FOR THIS PIVOTAL COLUMN. 
C
      IAVAIL = I1 - ( IILROW+KROWS-1 )
      IF ( IAVAIL .LT. 0 ) GO TO 2522
      DO 2510 I = 1, KROWS
      ZIL( IILROW+I-1, IILCOL ) = (0.0,0.0)
2510  CONTINUE
      IILROW = IILROW + KROWS
      GO TO 2528
2522  CONTINUE
      ILIM2  = KROWS - ( I1 - IILROW + 1 )
      DO 2524 I = IILROW1, I1
      ZIL( I, IILCOL ) = (0.0,0.0)
2524  CONTINUE
      DO 2526 I = 1, ILIM2
      ZIL( I, IILCOL ) = (0.0,0.0)
2526  CONTINUE
      IILROW = ILIM2 + 1
2528  CONTINUE
C      
C INCREMENT THE INDEX TO THE NEXT SET OF ROWS FOR COLUMN "K"
C
2530  KRIDX  = KRIDX + 2
C
C IF THERE ARE NO MORE ROWS FOR THIS COLUMN, THEN COLUMN IS COMPLETE
C
      IF ( KRIDX .GE. KRIDXN ) GO TO 3000
      KROW   = ZI( KRIDX )
      KROWS  = ZI( KRIDX+1)
      KROWN  = KROW + KROWS - 1
      GO TO 2010
2895  CONTINUE
C
C INCREMENT "JVIDX" TO POINT TO THE CORRESPONDING VALUE TERM FOR THE 
C NEXT ROW OF COLUMN "J"
C
      JVIDX  = JVIDX + ( JROWN - JROW + 1 )
C
C INCREMENT THE INDEX TO THE NEXT SET OF ROWS FOR COLUMN "J"
C
2900  JRIDX  = JRIDX + 2
      IF ( JRIDX .GE. JRIDXN ) GO TO 3000
      GO TO 2000
3000  CONTINUE
      IF ( K .EQ. 1 ) GO TO 6000
C
C COMPUTE THE TERMS FOR THE CURRENT COLUMN OF DATA
C 
C      do 100 k = 1,n
C         do 10  i = k,n
C         temp = 0.
C         do 5  l = 1,k-1
C            temp = temp + a(i,l)*a(k,l) / a(l,l)
C    5       continue
C         a(i,k) = a(i,k) - temp
C   10    continue
C
C  THE FOLLOWING LAST COMPUTATION TAKES PLACE IN SUBROUTINE SMCOUT.
C  THE RESULTS OF THE DIVISION ARE WRITTEN TO THE OUTPUT FILE BUT
C  THE RESULTS OF THE ABOVE (WITHOUT THE DIVISION BELOW) IS
C  MAINTAINED IN MEMORY FOR REMAINING COLUMN COMPUTATIONS.
C
C         do 11 j = k+1,n
C           a(k,j) = a(j,k) / a( k,k )
C   11      continue
C  100 continue
C
C   NROWS  = NUMBER OF ROWS STORED IN INNER LOOP
C   KCOL   = LAST COLUMN NUMBER STORED IN INNER LOOP
C   KFRCOL = FIRST COLUMN NUMBER STORED IN INNER LOOP
C
      NROWS = KAROWS
      KDIR  = ( KCOL-1 ) * 4 + 1
      KMIDX = ZI( KDIR )
      KRIDX = KMIDX + 4
      KM2   = ZI( KMIDX+1 )
      KVIDX = KRIDX + KM2
      KVIDX = ( KVIDX / 2 ) + 1
      ILIM1   = IILROW1 + NROWS - 1
      ILIM2   = 0
      IAVAIL  = I1 - ILIM1
      IF ( IAVAIL .GE. 0 ) GO TO 4010
      ILIM1   = I1
      ILIM2   = NROWS - ( I1 - IILROW1 + 1 )
4010  CONTINUE
      JLIM1   = MOD( KFRCOL, I2 )
      JLIM2   = MOD( KLSCOL, I2 )
      IF ( JLIM1 .EQ. 0 ) JLIM1 = I2
      IF ( JLIM2 .EQ. 0 ) JLIM2 = I2
      JLIM4   = 0
      IF ( KFRCOL .EQ. K ) GO TO 6000
      IF ( JLIM2 .GE. JLIM1 ) GO TO 4015
      JLIM4   = JLIM2
      JLIM2   = I2
4015  CONTINUE
C      PRINT *,' JLIM1,JLIM2,JLIM4,IILROW1=',JLIM1,JLIM2,JLIM4,IILROW1
C      PRINT *,' ILIM1,ILIM2,JLIM1,JLIM2,JLIM4,IILROW1,NROWS'
C      PRINT *,  ILIM1,ILIM2,JLIM1,JLIM2,JLIM4,IILROW1,NROWS
      IF ( K .EQ. 1 ) GO TO 4007
C
C COMPUTE THE OUTER LOOP TERM FOR THIS COLUMN J
C I.E.,   -A(K,J) / A(J,J) 
C  where K = current pivot column number; J = column being processed
C      
C     KAROWS = NUMBER OF ACTIVE ROWS FOR THE CURRENT PIVOTAL COLUMN
C     JCOL   = COLUMN NUMBER OF CURRENT PIVOTAL COLUMN
C     ZOL(KBC,IC1) = FIRST ACTIVE ROW ("IILROW1") TERM OF COLUMN "KBC"
C     ZOL(KBC,IC2) = DIAGONAL TERM FOR COLUMN "KBC"
C
      DO 4005 KBC = JLIM1, JLIM2           
      ZOL( KBC, IC1 ) = ZIL( IILROW1, KBC ) * ZOL( KBC, IC2 )
4005  CONTINUE
      IF ( JLIM4 .EQ. 0 ) GO TO 4007
      DO 4006 KBC = 1, JLIM4
      ZOL( KBC, IC1 ) = ZIL( IILROW1, KBC ) * ZOL( KBC, IC2 )
4006  CONTINUE
4007  CONTINUE
C      CALL KBHELPCS( KFRCOL, KLSCOL, ZOL, ZIL, I1, I2, LASROW )  
      DO 4008 I = IILROW1, ILIM1
      RTEMP(I) = (0.0,0.0)
4008  CONTINUE
C
C PROCESS COLUMNS JLIM1 THROUGH JLIM2
C      
      DO 4022 J = JLIM1, JLIM2
      LIMIT = ILIM1
      ITEST = LASROW( J )
      IF ( ITEST .EQ. 0 ) GO TO 4022
      IF ( ITEST .GT. IILROW1 ) LIMIT = ITEST - 1
C
C PROCESS ROWS IILROW1 THROUGH LIMIT FOR COLUMNS JLIM1 THROUGH JLIM2
C      
      ZOLTMP = ZOL( J, IC1 )   
      CALL SMCCCS ( RTEMP( IILROW1 ), ZIL( IILROW1,J ), LIMIT-IILROW1+1
     &             ,ZOLTMP )
C      DO 4020 I = IILROW1, LIMIT
C      RTEMP(I) = RTEMP(I) + ZIL( I, J ) * ZOLTMP
C4020  CONTINUE
4022  CONTINUE
      IF ( JLIM4 .EQ. 0 ) GO TO 4030
C
C PROCESS ROWS IILROW1 THROUGH LIMIT FOR COLUMNS 1 THROUGH JLIM4
C      
      DO 4024 J = 1, JLIM4
      ITEST = LASROW(J)
      IF ( ITEST .EQ. 0 ) GO TO 4024
      LIMIT = ILIM1
      IF ( ITEST .GT. IILROW1 ) LIMIT = ITEST - 1
      ZOLTMP = ZOL( J, IC1 )   
      CALL SMCCCS ( RTEMP( IILROW1 ), ZIL( IILROW1,J ), LIMIT-IILROW1+1
     &             ,ZOLTMP )
C      DO 4023 I = IILROW1, LIMIT
C      RTEMP(I) = RTEMP(I) + ZIL( I, J ) * ZOLTMP
C4023  CONTINUE
4024  CONTINUE
4030  CONTINUE
      IF ( ILIM2 .EQ. 0 ) GO TO 4060
      DO 4032 I = 1, ILIM2
      RTEMP(I) = (0.0,0.0)
4032  CONTINUE
C
C PROCESS COLUMNS JLIM1 THROUGH JLIM2
C      
      DO 4042 J = JLIM1, JLIM2
      ITEST = LASROW( J )
      IF ( ITEST .EQ. 0 .OR. ITEST .GT. IILROW1 ) GO TO 4042
      LIMIT = ILIM2
      IF ( ITEST .LE. ILIM2 ) LIMIT = ITEST - 1
C
C PROCESS ROWS 1 THROUGH LIMIT FOR COLUMNS JLIM1 THROUGH JLIM2
C      
      ZOLTMP = ZOL( J, IC1 )   
      CALL SMCCCS ( RTEMP( 1 ), ZIL( 1,J ), LIMIT, ZOLTMP ) 
C      DO 4040 I = 1, LIMIT
C      RTEMP(I) = RTEMP(I) + ZIL( I, J ) * ZOLTMP             
C4040  CONTINUE
4042  CONTINUE
      IF ( JLIM4 .EQ. 0 ) GO TO 4046
C
C PROCESS ROWS 1 THROUGH LIMIT FOR COLUMNS 1 THROUGH JLIM4
C      
      DO 4044 J = 1, JLIM4
      ITEST = LASROW( J )
      IF ( ITEST .EQ. 0 .OR. ITEST .GT. IILROW1 ) GO TO 4044
      LIMIT = ILIM2
      IF ( ITEST .LE. ILIM2 ) LIMIT = ITEST - 1
      ZOLTMP = ZOL( J, IC1 )   
      CALL SMCCCS ( RTEMP( 1 ), ZIL( 1,J ), LIMIT, ZOLTMP ) 
C      DO 4043 I = 1, LIMIT
C      RTEMP(I) = RTEMP(I) + ZIL( I, J ) * ZOLTMP
C4043  CONTINUE
4044  CONTINUE
4046  CONTINUE
4060  CONTINUE
C      
C UPDATE EACH ACTIVE ROW TERM FOR COLUMN "K" BY SUBTRACTING "RTEMP"
C
      DO 4047 I = IILROW1, ILIM1
      ZCS( KVIDX ) = ZCS( KVIDX ) - RTEMP(I)
      KVIDX = KVIDX + 1
4047  CONTINUE
      IF ( ILIM2 .EQ. 0 ) GO TO 4070
      DO 4048 I = 1, ILIM2
      ZCS( KVIDX ) = ZCS( KVIDX ) - RTEMP(I)
      KVIDX = KVIDX + 1
4048  CONTINUE
4070  CONTINUE
C
C CALL SMCOUT TO WRITE OUT THE COLUMN TO THE OUTPUT LOWER TRIANGULAR      
C MATRIX FILE
C      
6000  CONTINUE
      CALL SMCOUT ( ZI, ZI, ZCS, ZOL( 1,IC1 ), ZOL( 1,IC1 ) )
7000  CONTINUE      
      RETURN
      END

      SUBROUTINE VECPRT (*,*,PX,NX,A,OX)
C
      INTEGER         P,PX,O,OX,COUNT,EJECT,PM,TRA,RSP,RDP,CSP,CDP
      DIMENSION       A(NX)
      COMMON /SYSTEM/ SKP1,MO,SKP2(6),MAXLIN,SKP3(2),COUNT
      DATA            RSP,RDP,CSP,CDP / 1,2,3,4 /
C
C     PX = VECTOR TYPE + PRECISION.
C     NX = VECTOR LENGTH.
C     A  = VECTOR LOCATION.
C
C     THE VECTOR COMPONENTS WILL BE PRINTED 6 PER LINE IF REAL OR
C                IMAGINARY, AND 3 PER LINE IF COMPLEX.
C          O = 0 IF ALL THE VECTOR COMPONENTS ARE TO BE PRINTED, AND IF
C                THEY ARE TO BE PRINTED STARTING ON A NEW PAGE IF THEY
C                WILL NOT FIT ON THE CURRENT PAGE.
C          O = 1 IF ONLY THOSE LINES WHICH HAVE AT LEAST ONE NON-ZERO
C                COMPONENT ARE TO BE PRINTED, AND IF THE VECTOR IS TO BE
C                PRINTED STARTING ON A NEW PAGE IF IT WILL NOT FIT ON
C                THE CURRENT PAGE.
C          O =-1 IF ONLY THOSE LINES WHICH HAVE AT LEAST ONE NON-ZERO
C                COMPONENT ARE TO BE PRINTED, AND IF THE VECTOR IS TO BE
C                PRINTED ON THE CURRENT PAGE UNLESS TWO LINES WILL NOT
C                FIT.
C
C     RETURN 1 - PRINT SUBTITLE + VECTOR IDENTIFICATION.
C     RETURN 2 - PRINT VECTOR IDENTIFICATION ONLY.
C                PRTVEC = RETURN ENTRY POINT.
C
      P = PX
      N = NX
      O = OX
C
      PM = P
      IF (P .EQ. RDP) PM = RSP
      IF (P .EQ. CDP) PM = CSP
      KK = 1
      IF (PM .EQ. CSP) KK = 2
      IF (P.EQ.RDP .OR. P.EQ.CDP) KK = 2*KK
      KN = KK*N
      IF (PM .EQ. CSP) KK = KK/2
      K6 = KK*6
      IF (O .EQ. 0) GO TO 40
C
      M = 1
      DO 30 K = 1,KN,K6
      L = K + K6 - KK
      IF (L .GT. KN)  L = KN
      DO 10 I = K,L,KK
      IF (A(I) .NE. 0.) GO TO 20
   10 CONTINUE
      GO TO 30
   20 M = M + 1
   30 CONTINUE
      IF (M .EQ. 1) GO TO 160
C
      IF (O .LT. 0) M = 2
      GO TO 50
   40 M = (N+5)/6 + 1
      IF (PM .EQ. CSP) M = (N+2)/3 + 2
   50 ASSIGN 60 TO TRA
      IF (EJECT(M)) 170,180,170
   60 COUNT = COUNT - M
      KNKK  = KN/KK
      IF (KNKK .GT. 6) GO TO 70
      CALL FORMAT (A,1,KN,KK,-1,N)
      COUNT = COUNT + 1
      GO TO 140
C
   70 ASSIGN 110 TO TRA
      K = 1
   80 L = K + K6 - KK
      IF (L .GT. KN) L = KN
      IF (O .EQ.  0) GO TO 100
      DO 90 I = K,L,KK
      IF (A(I) .NE. 0.) GO TO 100
   90 CONTINUE
      GO TO 130
  100 IF (EJECT(1) .NE. 0) GO TO 170
  110 K1 = (K + KK - 1)/KK
      K2 = (L + KK - 1)/KK
      IF (PM .NE. CSP) GO TO 120
      K1 = (K1+1)/2
      K2 = K2/2
  120 CALL FORMAT (A,K,L,KK,K1,K2)
  130 K = K + K6
      IF (K .LE. KN) GO TO 80
C
  140 WRITE  (MO,150)
  150 FORMAT (1X)
      COUNT = COUNT + 1
  160 RETURN
C
  170 RETURN 1
  180 RETURN 2
C
C
      ENTRY PRTVEC (*,*)
C     ==================
C
      COUNT = COUNT + 1
      IF (PM .NE. CSP) GO TO 260
      COUNT = COUNT + 1
      IF (KNKK-4) 200,220,240
  200 WRITE  (MO,210)
  210 FORMAT (51X,4HREAL,11X,9HIMAGINARY)
      GO TO 260
  220 WRITE  (MO,230)
  230 FORMAT (21X,2(12X,4HREAL,11X,9HIMAGINARY))
      GO TO 260
  240 WRITE  (MO,250)
  250 FORMAT (3X,3(12X,4HREAL,11X,9HIMAGINARY))
  260 GO TO TRA, (60,110)
      END

      SUBROUTINE MRED2
C
C     THIS SUBROUTINE IS THE MRED2 MODULE WHICH PERFORMS THE MAJOR
C     COMPUTATIONS FOR THE REDUCE COMMAND.
C
C     DMAP CALLING SEQUENCE
C     MRED2    CASECC,LAMAMR,PHISS,EQST,USETMR,KAA,MAA,BAA,K4AA,PAA,DMR,
C              QSM/KHH,MHH,BHH,K4HH,PHH,POVE/STEP/S,N,DRY/POPT $
C
C     12 INPUT DATA BLOCKS
C     GINO -   CASECC - CASE CONTROL DATA
C              LAMAMR - EIGENVALUE TABLE FOR SUBSTRUCTURE BEING REDUCED
C              PHISS  - EIGENVECTORS FOR SUBSTRUCTURE BEING REDUCED
C              EQST   - EQSS DATA FOR BOUNDARY SET FOR SUBSTRUCTURE
C                       BEINGREDUCED
C              USETMR - USET TABLE FOR REDUCED SUBSTRUCTURE
C              KAA    - SUBSTRUCTURE STIFFNESS MATRIX
C              MAA    - SUBSTRUCTURE MASS MATRIX
C              BAA    - SUBSTRUCTURE VISCOUS DAMPING MATRIX
C              K4AA   - SUBSTRUCTURE STRUCTURE DAMPINF MATRIX
C              PAA    - SUBSTRUCTURE LOAD MATRIX
C              DMR    - FREE BODY MATRIX
C              QSM    - MODEL REACTION MATRIX
C     SOF  -   LAMS   - EIGENVALUE TABLE FOR ORIGINAL SUBSTRUCTURE
C              PHIS   - EIGENVECTOR TABLE FOR ORIGINAL SUBSTRUCTURE
C              LMTX   - STIFFNESS DECOMPOSITION PRODUCT FOR ORIGINAL
C                       SUBSTRUCTURE
C              GIMS   - G TRANSFORMATION MATRIX FOR BOUNDARY POINTS FOR
C                       ORIGINAL SUBSTRUCTURE
C              HORG   - H TRANSFORMATION MATRIX FOR ORIGINAL
C                       SUBSTRUCTURE
C
C     6 OUTPUT DATA BLOCKS
C     GINO -   KHH    - REDUCED STIFFNESS MATRIX
C              MHH    - REDUCED MASS MATRIX
C              BHH    - REDUCED VISCOUS DAMPING MATRIX
C              K4HH   - REDUCED STRUCTURE DAMPING MATRIX
C              PHH    - REDUCED LOAD MATRIX
C              POVE   - INTERIOR POINT LOAD MATRIX
C     SOF  -   LAMS   - EIGENVALUE TABLE FOR ORIGINAL SUBSTRUCTURE
C              PHIS   - EIGENVECTOR TABLE FOR ORIGINAL SUBSTRUCTURE
C              LMTX   - STIFFNESS DECOMPOSITION PRODUCT FOR ORIGINAL
C                       SUBSTRUCTURE
C              GIMS   - G TRANSFORMATION MATRIX FOR BOUNDARY POINTS FOR
C                       ORIGINAL SUBSTRUCTURE
C              HORG   - H TRANSFORMATION MATRIX FOR ORIGINAL
C                       SUBSTRUCTURE
C              UPRT   - PARTITIONING VECTOR FOR MREDUCE FOR ORIGINAL
C                       SUBSTRUCTURE
C              POVE   - INTERNAL POINT LOADS FOR ORIGINAL SUBSTRUCTURE
C              POAP   - INTERNAL POINTS APPENDED LOADS FOR ORIGINAL
C                       SUBSTRUCTURE
C              EQSS   - SUBSTRUCTURE EQUIVALENCE TABLE FOR REDUCED
C                       SUBSTRUCTURE
C              BGSS   - BASIC GRID POINT DEFINITION TABLE FOR REDUCED
C                       SUBSTRUCTURE
C              CSTM   - COORDINATE SYSTEM TRANSFORMATION MATRICES FOR
C                       REDUCED SUBSTRUCTURE
C              LODS   - LOAD SET DATA FOR REDUCED SUBSTRUCTURE
C              LOAP   - APPENDED LOAD SET DATA FOR REDUCED SUBSTRUCTURE
C              PLTS   - PLOT SET DATA FOR REDUCED SUBSTRUCTURE
C              KMTX   - STIFFNESS MATRIX FOR REDUCED SUBSTRUCTURE
C              MMTX   - MASS MATRIX FOR REDUCED SUBSTRUCTURE
C              PVEC   - LOAD MATRIX FOR REDUCED SUBSTRUCTURE
C              PAPD   - APPENDED LOAD MATRIX FOR REDUCED SUBSTRUCTURE
C              BMTX   - VISCOUS DAMPING MATRIX FOR REDUCED SUBSTRUCTURE
C              K4MX   - STRUCTURE DAMPING MATRIX FOR REDUCED
C                       SUBSTRUCTURE
C
C     11 SCRATCH DATA BLOCKS
C
C     PARAMETERS
C     INPUT  - STEP   - CONTROL DATA CASECC RECORD (INTEGER)
C              POPT   - PVEC OR PAPP OPTION FLAG (BCD)
C     OUTPUT - DRY    - MODULE OPERATION FLAG (INTEGER)
C     OTHERS - GBUF   - GINO BUFFERS
C              SBUF   - SOF BUFFERS
C              INFILE - INPUT FILE NUMBERS
C              OTFILE - OUTPUT FILE NUMBERS
C              ISCR   - ARRAY OF SCRATCH FILE NUMBERS
C              ISCR11 - LII PARTITION MATRIX USED IN MRED2B AND MRED2F
C              KORLEN - LENGTH OF OPEN CORE
C              KORBGN - BEGINNING ADDRESS OF OPEN CORE
C              OLDNAM - NAME OF SUBSTRUCTURE BEING REDUCED
C              NEWNAM - NAME OF REDUCED SUBSTRUCTURE
C              FREBDY - FREE BODY MODES CALCULATION FLAG
C              RANGE  - RANGE OF FREQUENCIES TO BE USED
C              NMAX   - MAXIMUM NUMBER OF FREQUENCIES TO BE USED
C              USRMOD - USERMODES CALCULATION FLAG
C              IO     - IO OPTIONS FLAG
C              BOUNDS - OLDBOUNDS OPTION FLAG
C              MODES  - OLDMODES OPTION FLAG
C              RSAVE  - SAVE REDUCTION PRODUCT FLAG
C              LAMSAP - BEGINNING ADDRESS OF MODE USE DESCRIPTION ARRAY
C              MODPTS - NUMBER OF MODAL POINTS
C              MODLEN - LENGTH OF MODE USE ARRAY
C
      EXTERNAL        ORF
      LOGICAL         FREBDY,BOUNDS,MODES,RSAVE,PONLY
      INTEGER         STEP,DRY,POPT,GBUF1,GBUF2,SBUF1,SBUF2,SBUF3,
     1                OTFILE,OLDNAM,USRMOD,GBUF3,Z,SYSBUF,CASECC,ORF
      DIMENSION       MODNAM(2),NMONIC(10),RZ(1),ITRLR(7)
      COMMON /BLANK / STEP,DRY,POPT,GBUF1,GBUF2,GBUF3,SBUF1,SBUF2,SBUF3,
     1                INFILE(12),OTFILE(6),ISCR(10),KORLEN,KORBGN,
     2                OLDNAM(2),NEWNAM(2),FREBDY,RANGE(2),NMAX,USRMOD,
     3                IO,BOUNDS,MODES,RSAVE,LAMSAP,MODPTS,MODLEN,PONLY,
     4                LSTZWD,ISCR11
      COMMON /ZZZZZZ/ Z(1)
      COMMON /SYSTEM/ SYSBUF,IPRNTR
      EQUIVALENCE     (CASECC,INFILE(1)), (RZ(1),Z(1))
      DATA    NMONIC/ 4HNAMA,4HNAMB,4HFREE,4HRANG,4HNMAX,4HUSER,4HOUTP,
     1                4HOLDB,4HOLDM,4HRSAV/
      DATA    IBLANK, NHLODS,NHLOAP/4H    ,4HLODS,4HLOAP/
      DATA    MODNAM/ 4HMRED,4H2   /
      DATA    ITRLR / 106   ,6*0   /
C
C     COMPUTE OPEN CORE AND DEFINE GINO, SOF BUFFERS
C
      IF (DRY .EQ. -2) RETURN
      NOZWDS = KORSZ(Z(1))
      LSTZWD = NOZWDS- 1
      GBUF1  = NOZWDS- SYSBUF - 2
      GBUF2  = GBUF1 - SYSBUF
      GBUF3  = GBUF2 - SYSBUF
      SBUF1  = GBUF3 - SYSBUF
      SBUF2  = SBUF1 - SYSBUF - 1
      SBUF3  = SBUF2 - SYSBUF
      KORLEN = SBUF3 - 1
      KORBGN = 1
      IF (KORLEN .LE. KORBGN) GO TO 290
C
C     INITIALIZE SOF
C
      CALL SOFOPN (Z(SBUF1),Z(SBUF2),Z(SBUF3))
C
C     INITIALIZE CASE CONTROL PARAMETERS
C
      DO 2 I = 1,12
    2 INFILE(I) = 100 + I
      DO 4 I = 1,6
    4 OTFILE(I) = 200 + I
      DO 6 I = 1, 10
    6 ISCR(I) = 300 + I
      ISCR11  = 311
      DO 10 I = 1, 2
      OLDNAM(I) = IBLANK
   10 NEWNAM(I) = IBLANK
      RANGE(1) = 0.0
      RANGE(2) = 1.0E+35
      FREBDY = .FALSE.
      NMAX   = 2147483647
      USRMOD = -1
      IO     = 0
      NRANGE = 0
      BOUNDS = .FALSE.
      MODES  = .FALSE.
      RSAVE  = .FALSE.
      PONLY  = .FALSE.
C
C     ** PROCESS CASE CONTROL
C
      IFILE  = CASECC
      CALL OPEN (*260,CASECC,Z(GBUF2),0)
      IF (STEP) 20,40,20
   20 DO 30 I = 1, STEP
   30 CALL FWDREC (*280,CASECC)
C
C     READ CASECC
C
   40 CALL READ (*270,*280,CASECC,Z(KORBGN),2,0,NWDSRD)
      NWDSCC = Z(KORBGN+1)
      DO 200 I = 1,NWDSCC,3
      CALL READ (*270,*280,CASECC,Z(KORBGN),3,0,NWDSRD)
C
C     TEST CASE CONTROL MNEMONICS
C
      DO 50 J = 1,10
      IF (Z(KORBGN) .EQ. NMONIC(J)) GO TO 60
   50 CONTINUE
      GO TO 200
C
C     SELECT DATA TO EXTRACT
C
   60 GO TO (70,90,110,120,140,150,160,170,180,190), J
C
C     EXTRACT NAME OF SUBSTRUCTURE BEING REDUCED
C
   70 DO 80 K = 1,2
   80 OLDNAM(K) = Z(KORBGN+K)
      GO TO 200
C
C     EXTRACT NAME OF REDUCED SUBSTRUCTURE
C
   90 DO 100 K = 1,2
  100 NEWNAM(K) = Z(KORBGN+K)
      GO TO 200
C
C     EXTRACT FREEBODY MODES FLAG
C
  110 FREBDY = .TRUE.
      GO TO 200
C
C     EXTRACT FREQUENCY RANGE
C
  120 IF (NRANGE .EQ. 1) GO TO 130
      NRANGE = 1
      RANGE(1) = RZ(KORBGN+2)
      GO TO 200
  130 RANGE(2) = RZ(KORBGN+2)
      GO TO 200
C
C     EXTRACT MAXIMUM NUMBER OF FREQUENCIES
C
  140 IF (Z(KORBGN+2) .EQ. 0) GO TO 200
      NMAX = Z(KORBGN+2)
      GO TO 200
C
C     EXTRACT USERMODE FLAG
C
  150 USRMOD = Z(KORBGN+2)
      GO TO 200
C
C     EXTRACT OUTPUT FLAGS
C
  160 IO = ORF(IO,Z(KORBGN+2))
      GO TO 200
C
C     EXTRACT OLDBOUND FLAG
C
  170 BOUNDS = .TRUE.
      GO TO 200
C
C     EXTRACT OLDMODES FLAG
C
  180 MODES = .TRUE.
      GO TO 200
C
C     EXTRACT REDUCTION SAVE FLAG
C
  190 RSAVE = .TRUE.
C
  200 CONTINUE
      CALL CLOSE (CASECC,1)
C
C     TEST FOR RUN = GO
C
      MRD2G = 1
      IF (DRY .EQ. 0) GO TO 230
C
C     CHECK FOR USERMODE = TYPE 2
C
      IF (USRMOD .EQ. 2) GO TO 210
C
C     CHECK FOR STIFFNESS PROCESSING
C
      CALL RDTRL (ITRLR)
      IF (ITRLR(1) .GT. 0) GO TO 208
C
C     CHECK FOR LOADS ONLY
C
      CALL SFETCH (NEWNAM,NHLODS,3,ITEST)
      IF (ITEST .EQ. 3) GO TO 204
      CALL SFETCH (NEWNAM,NHLOAP,3,ITEST)
      IF (ITEST .EQ. 3) GO TO 204
      MRD2G = 4
      GO TO 230
  204 MRD2G = 3
      PONLY = .TRUE.
      GO TO 230
C
C     PROCESS STIFFNESS MATRIX
C
  208 MRD2G = 2
      CALL MRED2A
C
C     PROCESS OLDBOUND FLAG
C
      CALL MRED2B
C
C     PROCESS OLDMODES FLAG
C
      CALL MRED2C (1)
      GO TO 220
C
C     PROCESS USERMODES FLAG
C
  210 CALL MRED2D
      CALL MRED2C (3)
      GO TO 240
C
C     CALCULATE MODAL TRANSFORMATION MATRIX
C
  220 CALL MRED2E
      CALL MRED2C (2)
C
C     CALCULATE FREE BODY EFFECTS
C
      CALL MRED2F
C
C     CALCULATE STRUCTURAL MATRICES
C
C     MRD2G .EQ. 1, M,B,K4,P/PA PROCESSING (RUN = GO)
C     MRD2G .EQ. 2, K,M,B,K4,P/PA PROCESSING
C     MRD2G .EQ. 3, P/PA PROCESSING (ONLY)
C     MRD2G .EQ. 4, M,B,K4,P/PA PROCESSING (RUN = STEP)
C
  230 CALL MRED2G (MRD2G)
      IF (MRD2G .EQ. 1) GO TO 250
C
C     PROCESS NEW TABLE ITEMS
C
  240 CALL MRED2H
C
C     CLOSE ANY OPEN FILES
C
  250 CALL SOFCLS
      IF (DRY .EQ. -2) WRITE (IPRNTR,900)
      RETURN
C
C     PROCESS SYSTEM FATAL ERRORS
C
  260 IMSG = -1
      GO TO 300
  270 IMSG = -2
      GO TO 300
  280 IMSG = -3
      GO TO 300
  290 IMSG = -8
      IFILE = 0
  300 CALL SOFCLS
      CALL MESAGE (IMSG,IFILE,MODNAM)
      RETURN
C
  900 FORMAT (//,'  MODULE MREDUCE TERMINATING DUE TO ABOVE ERRORS.')
C
      END

      SUBROUTINE TYPINT (X,Y,XYD,NUM,FIELD,OPT)
C
C     (X,Y) = STARTING OR ENDING POINT OF THE NUMBER TO BE TYPED (ALWAYS
C             LEFT-TO-RIGHT OR TOP-TO-BOTTOM).
C     XYD   = NO ACTION IF OPT IS ZERO
C           = (+/-)1 IF X = STARTING OR ENDING POINT OF THE NUMBER.
C           = (+/-)2 IF Y = STARTING OR ENDING POINT OF THE NUMBER.
C     NUM   = INTEGER NUMBER TO BE TYPED (AT MOST 10 DIGITS).
C     FIELD = NO ACTION IF OPT IS ZERO
C           = 1 IF THE NUMBER IS TO BE CENTERED AT (X,Y). IF XYD=1 OR 2,
C             THE NUMBER WILL BE TYPED IN THE X OR Y DIRECTION.
C           = 0 OR -1 IF THE NUMBER IS TO BE TYPED STARTING OR ENDING AT
C             (X,Y). IF FIELD = -1, FIELD WILL BE SET TO THE NUMBER OF
C             DIGITS PRINTED.
C     OPT   =-1 TO INITIATE  THE TYPING MODE.
C           =+1 TO TERMINATE THE TYPING MODE.
C           = 0 TO TYPE A LINE.
C
      INTEGER         XYD,FIELD,OPT,PLOTER,ASTER,DIR,D(11)
      COMMON /PLTDAT/ MODEL,PLOTER,SKPPLT(18),SKPA(3),CNTX,CNTY
      DATA    ASTER , MINUS / 41,40 /
C
      IF (OPT .EQ. 0) GO TO 100
      CALL TIPE (0,0,0,0,0,OPT)
      GO TO 200
C
C     SEPARATE THE DIGITS OF THE NUMBER (MAXIMUM OF 10).
C
  100 ND = -1
      IF (NUM .GE. 0) GO TO 110
      ND = 0
      D(1) = MINUS
  110 N = IABS(NUM)
      DO 111 I = 1,10
      J = N/10**(10-I)
      IF (J.EQ.0 .AND. ND.LE.0) GO TO 111
      IF (J  .GT. 9) J  = ASTER - 1
      IF (ND .LE. 0) ND = ND + 1
      ND = ND + 1
      D(ND) = J + 1
      N = N - J*10**(10-I)
  111 CONTINUE
      IF (ND .GT. 0) GO TO 112
      ND   = 1
      D(1) = 1
C
  112 XX = X
      YY = Y
      IF (FIELD.GT.0 .AND. ND.GT.1) GO TO 120
C
C     THE TYPED NUMBER IS NOT TO BE CENTERED AT (X,Y).
C
      DIR = XYD
      IF (FIELD .LT. 0) FIELD = ND
      GO TO 150
C
C     THE TYPED NUMBER MUST BE CENTERED AT (X,Y).
C
  120 XY = ND/2
      IF (ND/2 .EQ. (ND+1)/2) XY = XY - .5
      DIR = MAX0(IABS(XYD),1)
      IF (DIR.EQ.1) XX = X - XY*CNTX
      IF (DIR.EQ.2) YY = Y - XY*CNTY
C
C     TYPE THE NUMBER.
C
  150 CALL TYPE10 (XX,YY,DIR,D,ND,0)
      GO TO 200
C
  200 RETURN
      END

      SUBROUTINE MPY3P (Z,IZ,DZ)
C*****
C    PERFORMS MULTIPLICATION AND SUMMATION.
C*****
      DOUBLE PRECISION DZ(1),DFACT
C
C
C
      INTEGER CODE,PREC
      INTEGER ZPNTRS
C
C
C
      DIMENSION Z(1),IZ(1)
C
C
C SUBROUTINE CALL PARAMETERS
      COMMON / MPY3CP / ITRL,ICORE,N,NCB,M,DUM1(3),ZPNTRS(22),LAEND,
     1                  DUM2(6),KA,KB
C FILES
      COMMON / MPY3TL / FILEA(7),FILEB(7),FILEE(7),FILEC(7),SCR1,SCR2,
     1                  SCR,LKORE,CODE,PREC,LCORE,SCR3(7),BUF1,BUF2,
     2                  BUF3,BUF4,E
C
C
C
      EQUIVALENCE     (FACT,DFACT)
C OPEN CORE POINTERS
      EQUIVALENCE     (IPOINT,ZPNTRS(3)),      (IACOLS,ZPNTRS(5)),
     *                (ITRANS,ZPNTRS(7)),      (IC,ZPNTRS(9)),
     *                (IBCOLS,ZPNTRS(11)),     (IAKJ,ZPNTRS(21))
C*****
C    LOOP FOR ACCUMULATING SUMS.
C*****
      KJ = IAKJ + KA - 1
      KJ2 = (IAKJ - 1)/2 + KA
      KB = IBCOLS + PREC*((KB - 1)*N - 1)
      IF (CODE .EQ. 2 .OR. ICORE .EQ. 1) GO TO 100
C*****
C    A(T)BA CASE.
C*****
      LP = IPOINT - 1
      DO 90 L=1,N
C CALCULATE FACTOR = B(LK)*A(KJ) TO BE MULTIPLIED TO NON-ZERO TERMS IN
C LTH COLUMN OF A(T)
      KB = KB + PREC
      LP = LP + 1
      IF (IZ(LP) .EQ. 0) GO TO 90
      IF (PREC .EQ. 2) GO TO 10
      IF (Z(KB) .EQ. 0.0) GO TO 90
      FACT = Z(KB)*Z(KJ)
      GO TO 20
   10 KB2 = (KB + 1)/2
      IF (DZ(KB2) .EQ. 0.0D0) GO TO 90
      DFACT = DZ(KB2)*DZ(KJ2)
   20 I1 = IZ(LP)
      IF (L .EQ. N) GO TO 40
C ACCUMULATE SUMS FOR NON-ZERO TERMS IN COLUMN L OF A(T)
      L1 = L + 1
      LLP = LP
      DO 30 LL=L1,N
      LLP = LLP + 1
      IF (IZ(LLP) .NE. 0) GO TO 50
   30 CONTINUE
   40 I2 = LAEND
      GO TO 60
   50 I2 = IZ(LLP) - 1
   60 IAC = IACOLS + I1 - 2
      IF (PREC .EQ. 2) GO TO 80
C SINGLE PRECISION CASE
      IAT = ITRANS + I1 - 2
      DO 70 I=I1,I2
      IAC = IAC + 1
      IAT = IAT + 1
      II = IC + IZ(IAC) - 1
   70 Z(II) = Z(II) + Z(IAT)*FACT
      GO TO 90
C DOUBLE PRECISION CASE
   80 IAT = (ITRANS - 3)/2 + I1
      DO 85 I=I1,I2
      IAC = IAC + 1
      IAT = IAT + 1
      II = (IC - 1)/2 + IZ(IAC)
   85 DZ(II) = DZ(II) + DZ(IAT)*DFACT
      III = (IC - 1)/2 + 1
   90 CONTINUE
      GO TO 999
C*****
C    BA CASE.
C*****
  100 IF (PREC .EQ. 2) GO TO 140
C SINGLE PRECISION CASE
      II = IC - 1
      DO 130 I=1,N
      II = II + 1
      KB = KB + 1
      IF (Z(KB) .EQ. 0.0) GO TO 130
      Z(II) = Z(II) + Z(KB)*Z(KJ)
  130 CONTINUE
      GO TO 999
C DOUBLE PRECISION CASE
  140 II = (IC - 1)/2
      KB = (KB + 1)/2
      DO 150 I=1,N
      II = II + 1
      KB = KB + 1
      IF (DZ(KB) .EQ. 0.0D0) GO TO 150
      DZ(II) = DZ(II) + DZ(KB)*DZ(KJ2)
  150 CONTINUE
C
  999 RETURN
      END

      SUBROUTINE GKAD1C (XMD,XOD,XCR1,XCR2,XCR3,XCR4,XCR5,XCR6,XSETD)
C
C     GKAD1C SETS UP TO REDUCE STRUCTURAL MODAL
C
      INTEGER         XMD,XOD,XCR1,XCR2,XCR3,XCR4,XCR5,XCR6,XSETD,
     1                GMD,GOD,SCR1,SCR2,SCR3,SCR4,SCR5,SCR6,USETD,
     2                OMIT,SINGLE,CHECK,NAME(2)
CNV  3                MCB(7),T
      COMMON /BITPOS/ UM,UO,UR,USG,USB,UL,UA,UF,US,UN,UG,UE,UP,UNE,UFE,
     1                UD
      COMMON /BLANK / TYPE(2),APP(2),MODAL(2),G,W3,W4,IK2PP,
     1                IM2PP,IB2PP,MULTI,SINGLE,OMIT,NOUE
      DATA    NAME  / 4HGKAD,4H1C      /
C
      GMD   = XMD
      GOD   = XOD
      SCR1  = XCR1
      SCR2  = XCR2
      SCR3  = XCR3
      SCR4  = XCR4
      SCR5  = XCR5
      SCR6  = XCR6
      USETD = XSETD
      CHECK = 123456789
      RETURN
C
C
      ENTRY GKAD1D (K2PP,K2DD)
C     ========================
C
      IF (CHECK .NE. 123456789) CALL MESAGE (-37,0,NAME)
C
C     NAVY'S FIX (MARKED BY CNV) TO FORCE K2NN BE SYMMETRIC IF K2PP IS
C     SYMMETRIC. A PARAMETER OF -6 IS PASSED TO SSG2B TO FLAG THE FORM
C     OF THE MATRIX TO BE SYMMETRIC.
C     ALSO, IN SSG2B, ABOUT LINE 55, ADD FOLLOWING 2 LINES
C           IF (T1 .EQ. -6) T = 1
C           IF (T1 .EQ. -6) FILED(4) = SYMM
C
C     (THE FIX IS NOT ADOPTED HERE. A MORE GENERAL FIX IS ADDED IN SSG2B
C     WHICH SHOULD TAKE CARE OF THE PROBLEM HERE   G.C/UNISYS 3/93)
C
CNV   MCB(1) = K2PP
CNV   CALL RDTRL (MCB)
CNV   T = 1
CNV   IF (MCB(4) .EQ. 6) T = -6
C
      K2FF = K2DD
      IF (MULTI .LT. 0) GO TO 20
      IF (OMIT.LT.0 .AND. SINGLE.LT.0) GO TO 10
      K2NN = SCR4
      IF (SINGLE .LT. 0) K2NN = K2DD
      GO TO 30
   10 K2NN = K2DD
      GO TO 30
   20 K2NN = K2PP
   30 IF (SINGLE .GE. 0) GO TO 40
      K2FF = K2NN
   40 IF (MULTI .LT. 0) GO TO 50
C
C     MULTI POINT CONSTRAINTS
C
      CALL UPART (USETD,SCR1,UP,UNE,UM)
      CALL MPART (K2PP,SCR2,SCR3,SCR5,SCR4)
      CALL SSG2B (SCR4,GMD,SCR3,SCR1,0,2,1,SCR6)
      CALL SSG2B (SCR5,GMD,SCR2,SCR3,0,2,1,SCR6)
C
CNV   CALL SSG2B (GMD,SCR1,SCR3,K2NN,T,2,1,SCR6)
      CALL SSG2B (GMD,SCR1,SCR3,K2NN,1,2,1,SCR6)
C
   50 IF (SINGLE .LT. 0) GO TO 60
      CALL UPART (USETD,SCR1,UNE,UFE,US)
      CALL MPART (K2NN,K2FF,0,0,0)
   60 IF (OMIT .LT. 0) GO TO 70
      CALL UPART (USETD,SCR1,UFE,UD,UO)
      CALL MPART (K2FF,SCR2,SCR3,SCR5,SCR4)
      CALL SSG2B (SCR4,GOD,SCR3,SCR1,0,2,1,SCR6)
      CALL SSG2B (SCR5,GOD,SCR2,SCR3,0,2,1,SCR6)
C
CNV   CALL SSG2B (GOD,SCR1,SCR3,K2DD,T,2,1,SCR6)
      CALL SSG2B (GOD,SCR1,SCR3,K2DD,1,2,1,SCR6)
C
   70 RETURN
      END

      SUBROUTINE SOFTRL (NAME,ITEM,MCB)
C
C     UTILITY SUBROUTINE TO OBTAIN THE MATRIX TRAILER FOR A MATRIX
C     STORED ON THE SOF
C     STATUS OF THE SOF ITEM IS RETURNED IN WORD ONE OF THE MATRIX
C     CONTROL BLOCK
C
C         1 NORMAL RETURN - THE TRAILER IS STORED IN WORDS 2 THRU 7
C         2 ITEM WAS PESUDO WRITTEN
C         3 ITEM DOES NOT EXIST
C         4 SUBSTRUCTURE NAME DOES NOT EXIST
C         5 ILLEGAL ITEM NAME
C
      EXTERNAL        ANDF,RSHIFT
      INTEGER         ANDF,RSHIFT,BUF,BLKSIZ,NMSBR(2),MCB(7),NAME(2)
      COMMON /MACHIN/ MACH,IHALF,JHALF
      COMMON /SOF   / DITDUM(6),IO,IOPBN,IOLBN,IOMODE,IOPTR,IOSIND,
     1                IOITCD,IOBLK
      COMMON /SYS   / BLKSIZ
      COMMON /ZZZZZZ/ BUF(1)
      DATA    IRD   / 1/
      DATA    NMSBR / 4HSOFT,4HRL  /
C
C
C     CHECK IF ITEM IS ONE OF THE FOLLOWING ALLOWABLE NAMES.
C     KMTX,MMTX,PVEC,POVE,UPRT,HORG,UVEC,QVEC,PAPP,POAP,LMTX
C
      CALL CHKOPN (NMSBR(1))
      IOITCD = ITCODE(ITEM)
      ITM = ITTYPE(ITEM)
      IF (ITM .NE. 1) GO TO 1000
C
C     FIND SUBSTRUCTURE NAME AND MDI BLOCK
C
      CALL FDSUB (NAME,IOSIND)
      IF (IOSIND .LT. 0) GO TO 1010
      CALL FMDI (IOSIND,IMDI)
C
C     GET BLOCK NUMBER OF FIRST BLOCK
C
      IOPBN = ANDF(BUF(IMDI+IOITCD),JHALF)
      IF (IOPBN .EQ.     0) GO TO 1020
      IF (IOPBN .EQ. JHALF) GO TO 1030
      IOLBN = 1
C
C     GET NEXT BLOCK IN CHAIN
C
   20 CALL FNXT (IOPBN,INXT)
      IF (MOD(IOPBN,2) .EQ. 1) GO TO 30
      NEXT = ANDF(RSHIFT(BUF(INXT),IHALF),JHALF)
      GO TO 40
   30 NEXT = ANDF(BUF(INXT),JHALF)
   40 CONTINUE
      IF (NEXT .EQ. 0) GO TO 50
      IOPBN = NEXT
      IOLBN = IOLBN + 1
      GO TO 20
C
C     WE HAVE HIT END OF CHAIN - READ THE LAST BLOCK
C
   50 CALL SOFIO (IRD,IOPBN,BUF(IO-2))
      I1 = IO - 2
      I2 = I1 + BLKSIZ + 4
C
C     EXTRACT TRAILER FROM BLOCK
C
      DO 60 I = 1,6
   60 MCB(I+1) = BUF(IO+BLKSIZ-6+I)
      MCB(1  ) = 1
      RETURN
C
C
C     ERRORS
C
C     ILLEGAL ITEM
C
 1000 MCB(1) = 5
      RETURN
C
C     SUBSTRUCTURE DOES NOT EXIST
C
 1010 MCB(1) = 4
      RETURN
C
C     ITEM DOES NOT EXIST
C
 1020 MCB(1) = 3
      RETURN
C
C     ITEM IS PESUDO WRITTEN
C
 1030 MCB(1) = 2
      RETURN
      END

      SUBROUTINE PSTPL1
C
C     THIS ROUTINE CALCULATES PHASE I OUTPUT FOR PLA3
C     FOR THE TRI-PLATE PART OF COMBINATION ELEMENTS
C
C     PHASE I OF STRESS DATA RECOVERY FOR TRI-PLATE
C
C     OUTPUTS FROM THIS PHASE FOR USE IN PHASE II ARE THE FOLLOWING.
C
C     1) ELEMENT ID
C     2) 3 SILS AND A DUMMY
C     3) I
C     4) Z1 AND Z2
C     5) 3  5X6 S-SUB-I ARRAYS
C     THUS, 98 WORDS FOR THE TRI-PLATE
C
C
C     ECPT LISTS AS OF AUGUST 4, 1967
C
C                 DEFINITION
C       ECPT      BSC.BEND.TRI. AND THE TRI-PLATE
C     ========   =================  =======
C     ECPT( 1) = ELEMENT ID         INTEGER
C     ECPT( 2) = GRID PT. A         INTEGER
C     ECPT( 3) = GRID PT. B         INTEGER
C     ECPT( 4) = GRID PT. C         INTEGER
C     ECPT( 5) = THETA              REAL
C     ECPT( 6) = MAT ID 1           INTEGER
C     ECPT( 7) = I  MOM. OF INERT.  REAL
C     ECPT( 8) = MAT ID 2           INTEGER
C     ECPT( 9) = T2                 REAL
C     ECPT(10) = NON-STRUCT. MASS   REAL
C     ECPT(11) = Z1                 REAL
C     ECPT(12) = Z2                 REAL
C     ECPT(13) = COORD. SYS. ID 1   INTEGER
C     ECPT(14) = X1                 REAL
C     ECPT(15) = Y1                 REAL
C     ECPT(16) = Z1                 REAL
C     ECPT(17) = COORD. SYS. ID 2   INTEGER
C     ECPT(18) = X2                 REAL
C     ECPT(19) = Y2                 REAL
C     ECPT(20) = Z2                 REAL
C     ECPT(21) = COORD. SYS. ID 3   INTEGER
C     ECPT(22) = X3                 REAL
C     ECPT(23) = Y3                 REAL
C     ECPT(24) = Z3                 REAL
C     ECPT(25) = ELEMENT TEMP       REAL
C
      INTEGER         SUBSCA   ,SUBSCB    ,SUBSCC
      REAL            L1       ,L2        ,IVECT     ,JVECT   ,KVECT
      DIMENSION       M(9)     ,REQUIV(9) ,G(36)     ,TITE(10),V(25) ,
     1                HQ(12)   ,TEMP15(15),PROD15(15),NECPT(25)      ,
     2                V1(3)    ,V2(3)     ,V3(3)
      COMMON /CONDAS/ CONSTS(5)
      COMMON /PLA3ES/ ECPT(100),PH1OUT(200)
      COMMON /PLA32S/ A(45)    ,T(9)      ,S(18)     ,
     2                HINV(36) ,PROD12(12),D1(3)     ,
     3                D2(3)    ,HABC(18)  ,SSUM(60)  ,
     4                R(2,4)   ,IVECT(3)  ,JVECT(3)  ,
     5                KVECT(3) ,VV1(2)    ,VV2(2)    ,XSUBB  ,XSUBC  ,
     6                YSUBC    ,E(18)     ,TEMP      ,
     7                L1       ,L2        ,C1        ,
     8                C2       ,S1        ,S2        ,
     9                X1       ,X2        ,Y1        ,
     T                Y2       ,NPOINT    ,DUM9      ,
     1                TEMP1    ,TEMP2     ,PROD9(9)  ,
     2                TEMP9(9) ,DUM8      ,KM        ,
     3                SUBSCA   ,SUBSCB    ,SUBSCC    ,DUM11   ,
     4                THETA    ,NSUBC     ,ISING     ,
     5                U1       ,U2        ,SINANG    ,
     6                COSANG   ,DUM10     ,XC        ,
     7                YC       ,DETERM    ,DUM12(29)
      COMMON /MATIN / MATID    ,INFLAG    ,ELTEMP    ,STRESS  ,SINTH  ,
     1                COSTH
      EQUIVALENCE     (CONSTS(4),DEGRA)   ,(PROD15(1),PROD9(1))       ,
     1                (REQUIV(1),R(1,1))  ,(NECPT(1) ,ECPT(1) )       ,
     2                (ECPT(14) ,V1(1))   ,(V2(1)    ,ECPT(18))       ,
     3                (ECPT(22) ,V3(1))   ,(TITE(1)  ,A(1)    )       ,
     4                (PROD12(1),V(1))    ,(HQ(1)    ,A(1)    )
      DATA    M     / 1,2,4,  2,3,4,  3,1,4 /
C
      THETA  = ECPT(5)*DEGRA
      SINANG = SIN(THETA)
      COSANG = COS(THETA)
C
C     FORMATION OF THE R-MATRIX CONTAINING COORDINATES OF THE
C     SUB TRIANGLES. (2X4) FOR THE TRIANGULAR PLATE.
C     FORMATION ALSO OF THE I,J, AND K VECTORS USED IN THE E-MATRIX.
C
C     ZERO OUT R-MATRIX
C
      DO 10 I = 1,8
   10 REQUIV(I) = 0.0
C
      DO 20 I = 1,3
      D2(I) = V2(I) - V1(I)
   20 D1(I) = V3(I) - V1(I)
C
C     X2  GOES IN R(1,2)
C
      R(1,2) = SQRT(D2(1)**2 + D2(2)**2 + D2(3)**2)
      DO 30 I = 1,3
   30 IVECT(I) = D2(I)/R(1,2)
C
C     NON-NORMALIZED K-VECTOR
C
      KVECT(1) = IVECT(2)*D1(3) - D1(2)*IVECT(3)
      KVECT(2) = IVECT(3)*D1(1) - D1(3)*IVECT(1)
      KVECT(3) = IVECT(1)*D1(2) - D1(1)*IVECT(2)
C
C     Y3 GOES INTO R(2,3)
C
      R(2,3) = SQRT(KVECT(1)**2 + KVECT(2)**2 + KVECT(3)**2)
      DO 40 I = 1,3
   40 KVECT(I) = KVECT(I)/R(2,3)
C
C     J-VECTOR = K X I  VECTORS
C
      JVECT(1) = KVECT(2)*IVECT(3) - IVECT(2)*KVECT(3)
      JVECT(2) = KVECT(3)*IVECT(1) - IVECT(3)*KVECT(1)
      JVECT(3) = KVECT(1)*IVECT(2) - IVECT(1)*KVECT(2)
C
C     NORMALIZE J VECTOR TO MAKE SURE
C
      TEMP = SQRT(JVECT(1)**2 + JVECT(2)**2 + JVECT(3)**2)
      DO 60 I = 1,3
   60 JVECT(I) = JVECT(I)/TEMP
C
C     X3 GOES INTO R(1,3) = D1 DOT IVECT
C
      R(1,3) = D1(1)*IVECT(1) + D1(2)*IVECT(2) + D1(3)*IVECT(3)
C
C     CENTROID POINT GOES INTO R(1,4) AND R(2,4)
C
      R(1,4) = (R(1,2)+R(1,3))/3.0
      R(2,4) = R(2,3)/3.0
C
C     COMPUTE SUB-TRIANGLE COORDINATES
C     CALL BASIC BENDING ROUTINE FOR ALL SUB-TRIANGLES.
C
      DO 80 I = 1,60
   80 SSUM(I) = 0.0
      DO 90 I = 1,36
   90 G(I)   = 0.0
C
      DO 180 J = 1,3
      KM     = 3*J - 3
      SUBSCA = M(KM+1)
      SUBSCB = M(KM+2)
      SUBSCC = M(KM+3)
C
      DO 100 I = 1,2
      VV1(I) = R(I,SUBSCB) - R(I,SUBSCA)
  100 VV2(I) = R(I,SUBSCC) - R(I,SUBSCA)
      XSUBB  = SQRT(VV1(1)**2 + VV1(2)**2)
      U1     = VV1(1)/XSUBB
      U2     = VV1(2)/XSUBB
      XSUBC  = U1*VV2(1) + VV2(2)*U2
      YSUBC  = U1*VV2(2) - VV2(1)*U2
C
      XC     = XSUBC
      YC     = YSUBC
C
      SINTH  = SINANG*U1 - COSANG*U2
      COSTH  = COSANG*U1 + SINANG*U2
      IF (ABS(SINTH) .LT. 1.0E-06) SINTH = 0.0
C
C     AT THIS POINT, XSUBB, XSUBC, YSUBC ARE AT HAND FOR
C     TRIANGLE -J-
C
      CALL PSTRB1 (2)
C
C     RETURNING FROM PSTRB1 THE FOLLOWING QUANTITIES ARE AT HAND.
C
C       S , S , S , EACH 5X3.   45 WORDS STORED IN A( 1) THRU A(45)
C        A   B   C
C
C     AND ALSO H-INVERSE IS AT A(73) THRU A(108) AND S IS AT A(55) THRU
C     A(72)
C
C     SET UP OF T-MATRIX
C
      T(1) = 1.0
      T(2) = 0.0
      T(3) = 0.0
      T(4) = 0.0
      T(5) = U1
      T(6) = U2
      T(7) = 0.0
      T(8) =-U2
      T(9) = U1
C
C     SET UP V-MATRIX PER FMMS 51-A
C
      V( 1) = U1*U1/3.0
      V( 2) = U2*U2/3.0
      V(11) = U1*U2/3.0
      V( 3) =-V(11)*2.0
      V( 4) = 0.0
      V( 5) = 0.0
      V( 6) = V(2)
      V( 7) = V(1)
      V( 8) =-V(3)
      V( 9) = 0.0
      V(10) = 0.0
      V(12) =-V(11)
      V(13) = V(1) - V(2)
      V(14) = 0.0
      V(15) = 0.0
      V(16) = 0.0
      V(17) = 0.0
      V(18) = 0.0
      V(19) = U1/3.0
      V(20) =-U2/3.0
      V(21) = 0.0
      V(22) = 0.0
      V(23) = 0.0
      V(24) =-V(20)
      V(25) = V(19)
C
C     ADD IN S , S , S   TO THE 4 5X3 SSUM MATRICES
C             A   B   C
C
      DO 120 I = 1,3
      CALL GMMATS (V(1),5,5,0, A(15*I-14),5,3,0, TEMP15(1))
      CALL GMMATS (TEMP15(1),5,3,0, T(1),3,3,0, PROD15(1))
C
C     POINTER TO SSUM MATRIX
C
      NPOINT = KM + I
      NPOINT = 15*M(NPOINT) - 15
      DO 110 K = 1,15
      NSUBC  = NPOINT + K
  110 SSUM(NSUBC) = SSUM(NSUBC) + PROD15(K)
  120 CONTINUE
C
C     FORM HQ (2X6)
C
      TEMP1  = XSUBB - XSUBC
      TEMP2  = YSUBC**2
      L1     = SQRT(XSUBC**2 + TEMP2)
      L2     = SQRT(TEMP1**2 + TEMP2)
      S1     = XSUBC/L1
      S2     = TEMP1/L2
      C1     = YSUBC/L1
      C2     = YSUBC/L2
      X1     = XSUBC/2.0
      Y1     = YSUBC/2.0
      X2     = (XSUBB + XSUBC)/2.0
      Y2     = Y1
      HQ( 1) =-XSUBC*C1
      HQ( 2) = X1*S1 - Y1*C1
      HQ( 3) = 2.0*Y1*S1
      HQ( 4) =-3.0*X1*X1*C1
      HQ( 5) = Y1*(2.0*X1*S1 - Y1*C1)
      HQ( 6) = 3.0*Y1*Y1*S1
      HQ( 7) = 2.0*X2*C2
      HQ( 8) = X2*S2 + Y2*C2
      HQ( 9) = 2.0*Y2*S2
      HQ(10) = 3.0*X2*X2*C2
      HQ(11) = Y2*(2.0*X2*S2 + Y2*C2)
      HQ(12) = 3.0*Y2*Y2*S2
C
C                      I                    -1
C     COMPUTE (H       I  H     )  = (HQ)(H)    STORE IN PROD12
C               PSI,B  I   PSI,C
C                      I
C
      CALL GMMATS (HQ(1),2,6,0, HINV(1),6,6,0, PROD12(1))
C
C     COMPUTE (H     ) = -(PROD12)(S)
C               PSI,A
C
      CALL GMMATS (PROD12(1),2,6,0, S(1),6,3,0, HABC(1))
      HABC(1) = -HABC(1)
      HABC(2) = -HABC(2) + S1
      HABC(3) = -HABC(3) + C1
      HABC(4) = -HABC(4)
      HABC(5) = -HABC(5) + S2
      HABC(6) = -HABC(6) - C2
C
C     SPLIT(H     ) AND (H     )  PARTITION
C            PSI,B        PSI,C
C
      HABC( 7) = PROD12( 1)
      HABC( 8) = PROD12( 2)
      HABC( 9) = PROD12( 3)
      HABC(10) = PROD12( 7)
      HABC(11) = PROD12( 8)
      HABC(12) = PROD12( 9)
      HABC(13) = PROD12( 4)
      HABC(14) = PROD12( 5)
      HABC(15) = PROD12( 6)
      HABC(16) = PROD12(10)
      HABC(17) = PROD12(11)
      HABC(18) = PROD12(12)
C
C     MAP  H , H , AND H  INTO THE G-MATRICES.
C           A   B       C
C
      DO 170 I = 1,3
C
C     POINTER TO H  = 6*I-6
C                 I
C
C     TRANSFORM H SUB I
C
      CALL GMMATS (HABC(6*I-5),2,3,0, T(1),3,3,0, TEMP9(1))
C
      NPOINT = KM + I
      NPOINT = 9*M(NPOINT) - 9
C
C     J = 1  ROW 1 OF H INTO ROW 1 OF G.
C            ROW 2 OF H INTO ROW 2 OF G.
C     J = 2  ROW 1 OF H INTO ROW 2 OF G.
C            ROW 2 OF H INTO ROW 3 OF G.
C     J = 3  ROW 1 OF H INTO ROW 3 OF G.
C            ROW 2 OF H INTO ROW 1 OF G.
C
      IF (J-2) 140,130,160
C
  130 NPOINT = NPOINT + 3
  140 DO 150 K = 1,6
      NPOINT = NPOINT + 1
  150 G(NPOINT) = G(NPOINT) + TEMP9(K)
      GO TO 170
  160 G(NPOINT+7) = G(NPOINT+7) + TEMP9(1)
      G(NPOINT+8) = G(NPOINT+8) + TEMP9(2)
      G(NPOINT+9) = G(NPOINT+9) + TEMP9(3)
      G(NPOINT+1) = G(NPOINT+1) + TEMP9(4)
      G(NPOINT+2) = G(NPOINT+2) + TEMP9(5)
      G(NPOINT+3) = G(NPOINT+3) + TEMP9(6)
C
  170 CONTINUE
  180 CONTINUE
C
C     FILL E-MATRIX
C
      DO 190 I = 1,18
  190 E(I)  = 0.0
      E( 1) = KVECT(1)
      E( 4) = KVECT(2)
      E( 7) = KVECT(3)
      E(11) = IVECT(1)
      E(14) = IVECT(2)
      E(17) = IVECT(3)
      E(12) = JVECT(1)
      E(15) = JVECT(2)
      E(18) = JVECT(3)
C
C               *         *     -1
C     (S ) = (S  )  -  (S  )(G )  (G )           I=A,B,C
C       I      I         4    4     I
C
C        E            T                  T
C     (S  ) = (S ) (E) (C ) = (S ) (TITE)    I=A,B,C
C       I       I        I      I
C
C                                 *     -1
C     FIRST GET COMMON PRODUCT (S  )(G )
C                                4    4
C
C     INVERT  (G )  STORE INVERSE BACK INTO  (G )
C               4                              4
C
C     NO NEED TO COMPUTE DETERMINANT SINCE IT IS NOT USED SUBSEQUENTLY.
C
      ISING = -1
      CALL INVERS (3,G(28),3,PROD9(1),0,DETERM,ISING,TEMP9(1))
C
C     CHECK FOR SINGULARITY.  ISING = 2 IMPLIES SINGULARITY
C
      GO TO (210,200), ISING
  200 CALL MESAGE (-30,36,ECPT(1))
C
  210 CALL GMMATS (SSUM(46),5,3,0, G(28),3,3,0, PROD15(1))
C
      DO 260 I = 1,3
C
C    (PROD15)(G )
C              I
C
      CALL GMMATS (PROD15(1),5,3,0, G(9*I-8),3,3,0, TEMP15(1))
C
C     SUBTRACT TEMP15 FROM S
C                          I
C
      NPOINT = 15*I - 15
      DO 220 K = 1,15
      NPOINT = NPOINT + 1
  220 SSUM(NPOINT) = SSUM(NPOINT) - TEMP15(K)
C
C     DO WE NEED TRANSFORMATION T
C                                I
      NSUBC = 4*I + 9
      IF (NECPT(NSUBC) .EQ. 0) GO TO 230
      CALL TRANSS (NECPT(NSUBC),T(1))
      CALL GMMATS (T(1),3,3,1, E( 1),3,3,0, TITE( 1))
      CALL GMMATS (T(1),3,3,1, E(10),3,3,0, TITE(10))
      GO TO 250
C
  230 DO 240 K = 1,18
  240 TITE(K) = E(K)
C
  250 CALL GMMATS (SSUM(15*I-14),5,3,0, TITE(1),6,3,1, PH1OUT(30*I-21))
C
  260 CONTINUE
C
C     I, Z1, Z2, ELEM ID, 3 SILS FOR PHASE 2.  PH1OUT(5) IS A DUMMY
C
      PH1OUT(1) = ECPT( 1)
      PH1OUT(2) = ECPT( 2)
      PH1OUT(3) = ECPT( 3)
      PH1OUT(4) = ECPT( 4)
      PH1OUT(6) = ECPT( 7)
      PH1OUT(7) = ECPT(11)
      PH1OUT(8) = ECPT(12)
C
C     ALL PHASE ONE COMPLETE
C
      RETURN
      END

      SUBROUTINE TRD1C(IC,PD,NGROUP,NLFTP,UDV,ILOOP,SCR1,DIT,NLFT,NOUE,
CRLBR SPR94003 9/94
CRLBR1                 MODAL,PNL)
     1                 MODAL,PNL,ISKIP)
C
C     THIS ROUTINE STEPS INTEGRATION PROCEDURE
C
C     THIS ROUTINE IS SUITABLE FOR SINGLE PRECISION OPERATION
C
      LOGICAL NOPD
C
      INTEGER DIT1,PNL1,PNL
      INTEGER PD,UDV,SCR1,DIT,SYSBUF,FILE,IZ(1),MCB(7),IPNL(7)
CRLBR SPR94003 9/94      
CRLBR INTEGER SUBNAM(2)
      INTEGER SUBNAM(2), MOUTPU(7)
C
      COMMON /BLANK /DUMMY(4), NCOL
CRLBR SPR94003 9/94      
CRLBR COMMON /SYSTEM/SYSBUF
      COMMON /SYSTEM/SYSBUF, NNOUT, ISYSTM(79), ICPFLG
      COMMON /ZZZZZZ/Z(1)
      COMMON /PACKX /IT1,IT2,II,JJ,INCR
      COMMON /TRDXX /IK(7),IDUM(14),ISCR1,ISCR2,ISCR3,ISCR4,ISCR5,ISCR6,
     1               IOPEN,ISYM,TO,NOPD,ISPNL
      COMMON /UNPAKX/IT3,III,JJJ,INCR1
      COMMON /TRDD1 /NLFT1,DIT1,NLFTP1,NOUT,ICOUNT,ILOOP1,MODAL1,NZ,
     1               ICORE,IU2,IP4,IPNL,NMODES,NSTEP,PNL1,IST,IU1,
     2               DELTAT,IFRST
C
      EQUIVALENCE    (Z(1),IZ(1))
C
      DATA   SUBNAM /4HTRD1,1HC/
CRLBNB SPR94003 9/94
      DATA  IOUTPU, ISCR9 /203, 309/
CRLBNE
C
C ----------------------------------------------------------------------
C
C     INITIALIZE
C
      NROW  = IK(3)
      IT1   = 1
      IT2   = 1
      II    = 1
      JJ    = NROW
      INCR  = 1
      IT3   = 1
      III   = 1
      JJJ   = NROW
      INCR1 = 1
      NZ    = KORSZ(Z)
      IGROUP= NZ -3*NGROUP +1
      IBUF1 = IGROUP -SYSBUF
      IBUF2 = IBUF1 -SYSBUF
      IBUF3 = IBUF2 -SYSBUF
      IBUF4 = IBUF3-SYSBUF
      IBUF5 = IBUF4-SYSBUF
      IBUF6 = IBUF5-SYSBUF
      IBUF7 = IBUF6-SYSBUF
      IBUF8 = IBUF7 -SYSBUF
CRLBNB SPR94003 9/94
      IF (NLFTP .EQ. 0) IBUF8 = IBUF7
      IBUF9 = IBUF8 - SYSBUF
      IBUFA = IBUF9 - SYSBUF
      IF (ICPFLG .EQ. 0) IBUFA = IBUF8
      IF (ICPFLG .NE. 0 .AND. ISKIP .EQ. 1) IBUFA = IBUF9
      NZ = IBUFA - 1
CRLBNE
CRLBD SPR94003 9/94 NZ = IBUF7-1
CRLBD SPR94003 9/94 IF(NLFTP .NE. 0) NZ = IBUF8-1
      IOPEN = 0
CRLBR SPR94003 9/94 ICRQ = 14*NROW + 1 - NZ
      ICRQ = 14*(NROW+1) + 1 - NZ
      IF(ICRQ.GT.0) GO TO 430
CRLBR SPR94003 9/94 IU1=0
      IU1=1
CRLBR SPR94003 9/94 IU2= IU1+NROW
      IU2= IU1+NROW + 1
CRLBR SPR94003 9/94 IU3= IU2+ NROW
      IU3= IU2+ NROW + 1
CRLBR SPR94003 9/94 IP1= IU3+ NROW
      IP1= IU3+ NROW + 1
CRLBR SPR94003 9/94 IP2= IP1+ NROW
      IP2   = IP1+ NROW
      IP3   = IP2+ NROW
      IP4   = IP3+ NROW
      NLFT1 = NLFT
      DIT1  = DIT
      NLFTP1= NLFTP
      ILOOP1= ILOOP
      MODAL1= MODAL
      IST   = 0
CRLBR SPR94003 9/94 NZ    = NZ - 14*NROW - 1
      NZ    = NZ - 14*(NROW+1) - 1
      ICORE = IP4 +NROW
      NMODES= NROW- NOUE
      PNL1  = PNL
      ASSIGN 60 TO IRET1
      NSTEP = IZ(IGROUP) + 1
      DELTAT= Z(IGROUP+1)
      NOUT  = IZ(IGROUP+2)
      IF( ILOOP .NE. 1) GO TO 210
C
C     FIRST ENTRY INITIALIZE STUFF
C
      IST  =-1
      FILE = PD
C
C     PUT P0 IN IP2
C
      IPNT = IP2
      NOPD = .TRUE.
      ASSIGN 5 TO IRETN
      CALL OPEN(*310,PD,IZ(IBUF2),0)
      CALL SKPREC(PD,1)
      NOPD = .FALSE.
      GO TO 290
CRLBD SPR94003 9/94     5 FILE = UDV
CRLBD SPR94003 9/94       IAPEND = 0
CRLBR SPR94003 9/94       IF (NCOL .LE. 0) GO TO 8
    5 IF (NCOL .GT. 2) GO TO 325
CRLBD SPR94003 9/94      MCB(1) = UDV
CRLBD SPR94003 9/94      CALL RDTRL (MCB)
CRLBD SPR94003 9/94      IF (MCB(2) .NE. 0) GO TO 330
CRLBR SPR94003 9/94    8 CALL GOPEN (UDV,IZ(IBUF3),1)
      CALL GOPEN (UDV, IZ(IBUF3), 1)
      CALL MAKMCB (MCB,UDV,NROW,2,2)
CRLBNB SPR94003 9/94 
    8 IF (ICPFLG .EQ. 0) GO TO 10
      CALL MAKMCB (MOUTPU, IOUTPU, NROW+1, ISKIP, 2)
      CALL GOPEN (IOUTPU, IZ(IBUF9), 1)
      IF (ISKIP .EQ. 0) CALL GOPEN (ISCR9, IZ(IBUFA), 1)
CRLBNE
   10 IF (NLFTP.EQ.0) GO TO 20
C
C     CHECK TO SEE IF PNL HAS BEEN PRE-PURGED.
C
      IPNL(1)= PNL1
      CALL RDTRL(IPNL)
      ISPNL= 0
      IF(IPNL(1) .LE. 0) GO TO 20
      ISPNL= 1
      CALL GOPEN(PNL1,IZ(IBUF8),1)
      CALL MAKMCB(IPNL,PNL1,NROW,2,1)
   20 CONTINUE
CRLBR SPR94003 9/94      IF (IAPEND .EQ. 1) GO TO 50
      IF (NCOL .GT. 2) GO TO 50
      FILE = IC
      CALL GOPEN(IC,IZ(IBUF1),0)
      ASSIGN 30 TO IRETN
      IPNT = IU2
      GO TO 290
   30 ASSIGN 40 TO IRETN
      IPNT = IU3
      GO TO 290
   40 CALL CLOSE(IC,1)
      NSTEP = IZ(IGROUP)+1
      DELTAT= Z(IGROUP+1)
      NOUT  = IZ(IGROUP+2)
C
C     FORM  U=1, PO, P-1
C
      CALL FORM1( Z(IU2+1),Z(IU3+1),Z(IU1+1),Z(IP2+1),Z(IP1+1),DELTAT,
     1  Z(IBUF1))
C
C     START TIME STEP COUNT
C
   50 CONTINUE
      ICOUNT = 1
CRLBNB SPR94003 9/94   
      MCOL = 1
CRLBNE
   60 CONTINUE
      IF (NLFTP .EQ. 0) GO TO 62
      IFRST=0
      CALL TRD1D
      IFRST=1
   62 CONTINUE
C
C     OPEN FBS FILES
C
      FILE = ISCR1
      CALL OPEN(*390,ISCR1,IZ(IBUF4),0)
      FILE = ISCR2
      CALL OPEN(*390,ISCR2,IZ(IBUF5),0)
      FILE = ISCR3
CIBMR 5/95
C     CALL OPEN(*390,ISCR3,IZ(IBUF6),0)
      IF ( ISYM .EQ. 1 ) CALL OPEN(*390,ISCR3,IZ(IBUF6),0)
      FILE = ISCR4
      CALL OPEN(*390,ISCR4,IZ(IBUF7),0)
C
C     ZERO P*
C
   70 CALL TMTOGO(ITLEFT)
      IF(ITLEFT .LE. 0) GO TO 170
      DO 80 I = 1,NROW
      K = IP4 +I
      Z(K) =0.0
   80 CONTINUE
      IF(NLFTP .EQ. 0) GO TO 90
C
C     FORM NON-LINEAR LOADS
C
      CALL TRD1D
      IF(ICOUNT.EQ. 1 .OR. ICOUNT .EQ. NSTEP .OR. MOD(ICOUNT+IST,NOUT)
     1   .EQ. 0) GO TO 85
      GO TO 90
   85 IF (ISPNL.GT.0) CALL PACK (Z(IP4+1), PNL, IPNL)
C
C     BRING IN NEXT P
C
   90 IPNT = IP3
      FILE = PD
      ASSIGN 100 TO IRETN
      IF ( NOPD ) GO TO 310
      GO TO 290
C
C     ADD P-S TO FORM P*
C
  100 DO 110 I=1,NROW
      K = IP4 + I
      L = IP1 + I
      M = IP2 + I
      J = IP3 + I
      Z(K) = Z(K) +(Z(L) + Z(M) + Z(J))/3.0
  110 CONTINUE
      IF (ILOOP.NE.1.OR.ICOUNT.NE.1) GO TO 115
CRLBR SPR94003 9/94      IF (IAPEND .EQ. 1) GO TO 115
      IF (NCOL .GT. 2) GO TO 113
C
C     OUTPUT INITIAL DISPLACEMENT
C
      CALL PACK (Z(IU2 + 1), UDV, MCB(1))
C
C     OUTPUT INITIAL VELOCITY
C
      CALL PACK (Z(IU3 + 1), UDV, MCB(1))
CRLBNB SPR94003 9/94 
  113 IF (ICPFLG .EQ. 0) GO TO 115
      IF (ISKIP .EQ. 0) CALL WRITE (ISCR9, MCOL, 1, 0)
CRLBNE
C
C     SOLVE FOR NEXT SOLUTION
C
  115 CALL STEP  (Z(IU3 + 1), Z(IU2 + 1), Z(IU1 + 1), Z(IP4 + 1),
     1            IZ(IBUF1))
CRLBNB SPR94003 9/94      
      IF (ICPFLG .EQ. 0) GO TO 118
      JJ = NROW + 1
      Z(IP2) = DELTAT
      IF (ILOOP.NE.1 .AND. ICOUNT.EQ.0) Z(IP2) = DELTA1
      CALL PACK (Z(IP2), IOUTPU, MOUTPU)
      IF (ISKIP .EQ. 1) GO TO 117
      Z(IU2) = MCOL + 0.1
      CALL PACK (Z(IU2), IOUTPU, MOUTPU)
  117 JJ = NROW
  118 CONTINUE
CRLBNE
      IF (ILOOP.EQ.1.AND.ICOUNT.EQ.1) GO TO 145
      IF (ICOUNT.EQ.NSTEP.OR.MOD(ICOUNT+IST, NOUT).EQ.0) GO TO 130
      IF (ICOUNT.EQ.1) GO TO 130
C
C     ROTATE P POINTERS
C
  120 J  = IP1
      IP1= IP2
      IP2= IP3
      IP3= J
C
C     ROTATE U POINTERS
C
      J  = IU1
      IU1= IU2
      IU2= IU3
      IU3= J
      ICOUNT = ICOUNT +1
CRLBNB SPR94003 9/94      
      MCOL = MCOL + 1
CRLBNE
      IF(ICOUNT-NSTEP) 70,160,170
C
C     IT-S OUTPUT TIME -- LUCKY FELLOW
C
  130 CALL PACK( Z(IU2+1), UDV, MCB(1) )
C
C     COMPUTE U DOT
C
      H = 1.0/(2.0*DELTAT)
      DO 140 I=1,NROW
      K = IP4 +I
      L = IU3+I
      M = IU1 + I
      Z(K) = (Z(L)-Z(M))*H
  140 CONTINUE
      CALL PACK( Z(IP4+1), UDV, MCB(1) )
CRLBNB SPR94003 9/94      
      IF (ICPFLG .EQ. 0) GO TO 145
      IF (ISKIP .EQ. 0) CALL WRITE (ISCR9, MCOL, 1, 0)
CRLBNE
C
C     COMPUTE U DOT DOT
C
  145 H = 1.0/(DELTAT*DELTAT)
      DO 150 I=1,NROW
      K = IP4+I
      L = IU3+I
      M = IU1+I
      J = IU2 +I
      Z(K) = (Z(L)+Z(M)- 2.0*Z(J))*H
  150 CONTINUE
      CALL PACK( Z(IP4+1), UDV, MCB(1) )
      GO TO 120
C
C     END OF 1 GROUP
C
  160 IF(ILOOP .NE. NGROUP) GO TO 200
      GO TO 70
  170 J = 1
  180 CALL CLOSE(UDV,J)
      CALL CLOSE(PD, J)
CRLBNB SPR94003 9/94
      IF (ICPFLG .EQ. 0) GO TO 188
      IF (J.NE.1 .OR. ISKIP.EQ.1) GO TO 186
      CALL CLOSE (ISCR9, 1)
C
C     COPY THE SINGLE RECORD IN FILE ISCR9 AS THE
C     LAST RECORD IN FILE IOUTPU
C
      CALL GOPEN (ISCR9, IZ(IBUFA), 0)
      FILE = ISCR9
  183 CALL READ (*410, *184, ISCR9, Z(IU2+1), NROW, 0, IFLAG)
      CALL WRITE (IOUTPU, Z(IU2+1), NROW, 0)
      GO TO 183
  184 CALL WRITE (IOUTPU, Z(IU2+1), IFLAG, 1)
      CALL CLOSE (ISCR9, 1)
  186 CALL CLOSE (IOUTPU, J)
      CALL WRTTRL (MOUTPU)
  188 CONTINUE
CRLBNE
      CALL CLOSE(ISCR1,1)
      CALL CLOSE(ISCR2,1)
CIBMR 5/95
C     CALL CLOSE(ISCR3,1)   
      IF ( ISYM .EQ. 1 ) CALL CLOSE(ISCR3,1)   
      CALL CLOSE(ISCR4,1)
      CALL WRTTRL(MCB)
      IF( NLFTP .EQ. 0) GO TO 190
      IF (ISPNL.EQ.0) GO TO 190
      CALL CLOSE(PNL,J)
      CALL WRTTRL(IPNL)
  190 RETURN
C
C     MORE GROUPS TO COME SAVE STUFF
C
  200 J = 2
      FILE = SCR1
      CALL OPEN(*390,SCR1,IZ(IBUF1),1)
      CALL WRITE(SCR1,Z(IU3+1),NROW,1)
      CALL WRITE(SCR1,Z(IU1+1),NROW,1)
      CALL WRITE(SCR1,Z(IU2+1),NROW,1)
CRLBR SPR94003 9/94
CRLBR CALL WRITE (SCR1,Z(IP1+1),NROW,1)
      CALL WRITE (SCR1,Z(IP2+1),NROW,1)
      CALL CLOSE(SCR1,1)
      GO TO 180
C
C     CHANGE OF TIME STEP--RESTORE POINTERS ETC
C
  210 IGROUP = IGROUP +(ILOOP-1)*3
      DELTA1 = Z(IGROUP-2)
      NSTEP  = IZ(IGROUP)
      DELTAT = Z(IGROUP+1)
      NOUT   = IZ(IGROUP+2)
      IF (.NOT.NOPD) CALL GOPEN (PD, IZ(IBUF2), 2)
      CALL GOPEN(UDV,IZ(IBUF3),3)
      MCB(1)= UDV
      CALL RDTRL(MCB)
CRLBNB SPR94003 9/94  
      IF (ICPFLG .EQ. 0) GO TO 217
      CALL GOPEN (IOUTPU, IZ(IBUF9), 3)
      MOUTPU(1) = IOUTPU
      CALL RDTRL (MOUTPU)
  217 CONTINUE
CRLBNE
      IF(NLFTP .EQ. 0) GO TO 220
      IF (ISPNL.GT.0) CALL GOPEN (PNL1, IZ(IBUF8), 3)
  220 CONTINUE
C
C     RESTORE STUFF SAVED
C
      FILE = SCR1
      CALL OPEN(*390,SCR1,IZ(IBUF1),0)
      CALL FREAD(SCR1,Z(IU1+1),NROW,1)
      CALL FREAD(SCR1,Z(IU3+1),NROW,1)
      CALL FREAD(SCR1,Z(IU2+1),NROW,1)
      CALL FREAD(SCR1,Z(IP2+1),NROW,1)
      CALL CLOSE(SCR1,1)
C
C     COMPUTE U DOT
C
CRLBR SPR94003 9/94      H = 1.0D0/DELTA1
  225 H = 1.0D0/DELTA1
      DO 230 I=1,NROW
      K =  IP1 +I
      L = IU2 +I
      M = IU3 +I
      Z(K) = (Z(L)-Z(M))*H
  230 CONTINUE
C
C     COMPUTE U DOT DOT
C
      H = 1.0/(DELTA1*DELTA1)
      DO 240 I=1,NROW
      K = IP4+ I
      L = IU2+ I
      M = IU3+ I
      J = IU1+ I
      Z(K) = (Z(L)- 2.0*Z(M) +Z(J))*H
  240 CONTINUE
CRLBD SPR94003 9/94   250 CONTINUE
C
C     COMPUTE UI PRIME
C
      H = DELTAT*DELTAT/2.0
      DO 260 I=1,NROW
      K =IU1 +I
      L = IU2 +I
      M = IP1+I
      J = IP4 +I
      Z(K) = Z(L) -DELTAT*Z(M)+ H*Z(J)
  260 CONTINUE
C
C     COMPUTE U DOT PRIME
C
      DO 270 I=1,NROW
      K = IU3 + I
      L = IP1+I
      M = IP4 + I
      Z(K) = Z(L) -DELTAT*Z(M)
  270 CONTINUE
C
C     COMPUTE PI PRIME
C
      DO 280 I=1,NROW
      K = IP1+I
      Z(K) = 0.0
  280 CONTINUE
      CALL FORM2(Z(IP4+1),Z(IU3+1),Z(IU1+1),Z(IP1+1),Z(IBUF1))
      ICOUNT = 0
CRLBR SPR94003 9/94      GO TO IRET1, (60,10)
      GO TO IRET1, (60,8)
C
C     INTERNAL ROUTINE TO UNPACK VECTORS
C
  290 CALL UNPACK(*310,FILE,Z(IPNT+1))
CRLBR SPR94003 9/94  300 GO TO IRETN, (5,30,40,100,350,360,370)
  300 GO TO IRETN, (5,30,40,100,340,350,360,370,385,387)
CRLBR SPR94003 9/94  310 DO 320 INL = 1,NROW
  310 DO 320 INL = III, JJJ
      K = IPNT +INL
      Z(K) = 0.0
  320 CONTINUE
      GO TO 300
CRLBNB SPR94003 9/94
C     THE FOLLOWING LINES (UNTIL CRPKNE) REPRESENT
C     REPLACEMENTS FOR THE OLD CODE WHICH HAS BEEN
C     DELETED BELOW
C
C     RETRIEVE REQUIRED INFORMATION FROM
C     THE CHECKPOINT RUN
C
  325 MCOL = NCOL
      CALL GOPEN (IOUTPU, IZ(IBUF4), 0)
      MOUTPU(1) = IOUTPU
      CALL RDTRL (MOUTPU)
      JSKIP = 1
      IF (MOUTPU(4) .EQ. 1) GO TO 335
      JSKIP = 2
      CALL SKPREC (IOUTPU, MOUTPU(2))
      FILE = IOUTPU
      NWDS = NCOL - 1
  327 CALL READ (*410, *330, IOUTPU, MCOL, -NWDS, 0, IFLAG)
      GO TO 333
  330 NWDS = NWDS - IFLAG
      GO TO 327
  333 CALL READ (*410, *333, IOUTPU, MCOL, 1, 0, IFLAG)
      CALL REWIND (IOUTPU)
      CALL SKPREC (IOUTPU, 1)
C
  335 CALL SKPREC (IOUTPU, JSKIP*(MCOL-1))
      FILE = IOUTPU
      JJJ = NROW + 1
C
C     GET P SUB I+1
C
      IPNT = IP2 - 1
      ASSIGN 340 TO IRETN
      GO TO 290
  340 ITYPE = 1
      DELTA1 = Z(IP2)
      IF (DELTA1 .EQ. DELTAT) GO TO 345
      ITYPE = 2
      GO TO 350
  345 CALL SKPREC (IOUTPU, -(JSKIP+1))
C
C     GET P SUB I
C
      IPNT = IP1 - 1
      ASSIGN 350 TO IRETN
      GO TO 290
  350 CALL CLOSE (IOUTPU, 1)
C
      FILE = UDV
      CALL GOPEN (UDV, IZ(IBUF3), 0)
      K = 3*(NCOL - 1)
      KK = 5
      KKK = 4
      KKP = 0
      JJJ = NROW
      CALL SKPREC (UDV, K)
C
C     GET U SUB I+1
C
      IPNT = IU2
      ASSIGN 360 TO IRETN
      GO TO 290
C
C     GET U DOT SUB I+1
C
  360 IPNT = IP3
      ASSIGN 370 TO IRETN
      GO TO 290
C
  370 IF (MCOL .EQ. NCOL) GO TO 380
      CALL CLOSE (UDV, 1)
      FILE = IOUTPU
      CALL GOPEN (IOUTPU, IZ(IBUF4), 0)
      K = 2*MCOL - 3
      KK = 0
      KKK = 3
      KKP = 1
      JJJ = NROW + 1
      CALL SKPREC (IOUTPU, K)
C
C     GET U SUB I
C
  380 IPNT = IU1 - KKP
      IF (ITYPE .EQ. 2) IPNT = IU3 - KKP
      CALL SKPREC (FILE, -KK)
      ASSIGN 385 TO IRETN
      GO TO 290
  385 IF (ITYPE .EQ. 1) GO TO 388
      IF (MCOL .EQ. NCOL) GO TO 386
      ITEST = Z(IPNT+1)
      IF (MCOL .EQ. ITEST+1) GO TO 386
      WRITE (NNOUT, 500)
      CALL MESAGE (-61, 0, 0)
  386 CALL SKPREC (FILE, -KKK)
C
C     GET U SUB I-1
C
      IPNT = IU1 - KKP
      ASSIGN 387 TO IRETN
      GO TO 290
  387 IF (MCOL .EQ. NCOL) GO TO 388
      ITEST = Z(IPNT+1)
      IF (MCOL .EQ. ITEST+2) GO TO 388
      WRITE (NNOUT, 600)
      CALL MESAGE (-61, 0, 0)
  388 CALL CLOSE (FILE, 1)
      JJJ = NROW
      CALL GOPEN (UDV, IZ(IBUF3), 1)
      CALL MAKMCB(MCB,UDV,NROW,2,1)
C
C     OUTPUT INITIAL DISPLACEMENT
C
      CALL PACK (Z(IU2 + 1), UDV, MCB(1))
C
C     OUTPUT INITIAL VELOCITY
C
      CALL PACK (Z(IP3 + 1), UDV, MCB(1))
      IF (ITYPE .EQ. 1) GO TO 8
      ASSIGN 8 TO IRET1
      GO TO 225
CRLBNE
CRLBDB SPR94003 9/94
CRLBD C
CRLBD C     RETRIEVE LAST VECTOR
CRLBD C
CRLBD   330 CALL GOPEN(UDV,IZ(IBUF3),0)
CRLBD       K = 3*(NCOL - 1)
CRLBD       IAPEND = 1
CRLBD       CALL SKPREC(UDV,K)
CRLBD C
CRLBD C     GET U SUB I+1
CRLBD C
CRLBD       IPNT = IU2
CRLBD       ASSIGN 350 TO IRETN
CRLBD       GO TO 290
CRLBD CP
CRLBD C     GET U SUB I+1 DOT
CRLBD C
CRLBD   350 IPNT = IP1
CRLBD       ASSIGN 360 TO IRETN
CRLBD       GO TO 290
CRLBD C
CRLBD C     GET U SUB I+1 DOT DOT
CRLBD C
CRLBD   360 IPNT = IP4
CRLBD       ASSIGN 370 TO IRETN
CRLBD       GO TO 290
CRLBD   370 CONTINUE
CRLBD       CALL CLOSE(UDV,1)
CRLBD       CALL GOPEN (UDV, IZ(IBUF3), 1)
CRLBD       CALL MAKMCB (MCB, UDV, NROW, 2, 1)
CRLBD C
CRLBD C     OUTPUT INITIAL DISPLACEMENT
CRLBD C
CRLBD       CALL PACK (Z(IU2+1), UDV, MCB(1))
CRLBD C
CRLBD C     OUTPUT INITIAL VELOCITY
CRLBD C
CRLBD       CALL PACK (Z(IP1+1), UDV, MCB(1))
CRLBD C
CRLBD C     FORM P SUB I+1
CRLBD C
CRLBD       DO 380 I =1,NROW
CRLBD       K = IP2+I
CRLBD       Z(K) = 0.0
CRLBD   380 CONTINUE
CRLBD       CALL FORM2(Z(IP4+1),Z(IP1+1),Z(IU2+1),Z(IP2+1),Z(IBUF1))
CRLBD       ASSIGN 10 TO IRET1
CRLBD       GO TO 250
CRLBDE
C
C     ERROR MESAGES
C
  390 IP1 = -1
  400 CALL MESAGE(IP1,FILE,SUBNAM)
      RETURN
CRLBNB SPR94003 9/94
  410 IP1 = -2
      GO TO 400
CRLBNE
  430 IP1 = -8
      FILE= ICRQ
      GO TO 400
CRLBNB SPR94003 9/94
  500 FORMAT ('0*** SYSTEM FATAL MESSAGE, LOGIC ERROR 1 IN ',
     *        'SUBROUTINE TRD1C2 WHILE PROCESSING THE RESTART ',
     *        'INFORMATION')
  600 FORMAT ('0*** SYSTEM FATAL MESSAGE, LOGIC ERROR 2 IN ',
     *        'SUBROUTINE TRD1C2 WHILE PROCESSING THE RESTART ',
     *        'INFORMATION')
CRLBNE
      END

      SUBROUTINE FRLGA (DLT,FRL,CASECC,DIT,PP,LUSETD,NFREQ,NLOAD,
     1                  FRQSET,FOL,NOTRD)
C
C     THIS ROUTINE GENERATES LOADS INCORE AT EACH FREQUENCY
C
C     WITH ENTRY POINTS - GUST1A AND FRRD1A
C                         ======     ======
C
      INTEGER         SYSBUF,DLT,FRL,CASECC,DIT,PP,FRQSET,ICORE(14),
     1                FILE,MCB(7),IHEAD(8),ITLIST(13),NAME(6),FOL
      REAL            FX(2)
      COMPLEX         POW,EB,R2,R1
      DIMENSION       HEAD(8)
      COMMON /SYSTEM/ KSYSTM(55)
      COMMON /BLANK / XX
      COMMON /PACKX / IT1,IT2,II,JJ,INCR
      COMMON /ZZZZZZ/ CORE(1)
      COMMON /CONDAS/ PI,TWOPHI,RADEG,DEGRA,S4PISQ
      COMMON /FRRDST/ OVR(152),ITL(3)
      EQUIVALENCE     (CORE(1),ICORE(1)), (HEAD(1),IHEAD(1),ISIL),
     1                (HEAD(2),A), (HEAD(3),TAU), (HEAD(4),THETA),
     1                (KSYSTM(1),SYSBUF), (KSYSTM(55),IPREC)
      DATA    ITLIST/ 4,1105,11,1,1205,12,2,1305,13,3,1405,14,4 /
      DATA    NAME  / 4HDLT ,4HFRLG,4HA   ,4HGUST,4H1A  ,4HFRRD /
      DATA    IFRL  / 4HFRL /
C
C     IDENTIFICATION OF VARIABLES
C
C     NFREQ  = NUMBER OF FREQ IN SELECTED FREQ SET
C     NDONE  =  NUMBER OF FREQUENCIES CURRENTLY BUILT FOR CUR LOAD
C     LLIST  = POINTER TO START OF LOAD TABLE
C     ITABL  = POINTER TO START OF LIST OF TABLES NEEDED FOR CURRENT
C              LOAD
C     ILOAD  = POINTER TO BEGINNING OF LOADS IN CORE
C     IFL    = POINTER TO VALUES OF FREQ  FUNCTIONS
C     NBUILD = NUMBER OF FREQUENCIES WHICH CAN BE BUILT AT ONCE
C     NLOAD  = NUMBER OF LOADS FOUND IN CASE CONTROL
C     LCORE  = AMOUNT OF CORE AVAILABLE TO HOLD  LOADS + F(F)-S
C     FRQSET = SELECT FREQUENCY SET ID
C     LOADN  = SELECTED DYNAMIC LOAD
C     NDLOAD = NUMBER OF DLOAD CARDS
C     NSIMPL = NUMBER OF SIMPLE LOADS
C     NSUBL  = NUMBEL OF  SIMPLE LOADS COMPOSING PRESENT LOAD
C     NTABL  = NUBER OF TABLE ID-S IN PRESENT LOAD
C     ICDTY  = CARD TYPE CODE  1=RLOAD1,  2=RLOAD2
C
C
      GO TO 2
C
C
      ENTRY GUST1A (DLT,FRL,CASECC,DIT,PP,LUSETD,NFREQ,NLOAD,
     1              FRQSET,FOL,NOTRD)
C     =======================================================
C
      NAME(2) = NAME(4)
      NAME(3) = NAME(5)
      GO TO 2
C
C
      ENTRY FRRD1A (DLT,FRL,CASECC,DIT,PP,LUSETD,NFREQ,NLOAD,
     1              FRQSET,FOL,NOTRD)
C     =======================================================
C
      NAME(2) = NAME(6)
      NAME(3) = NAME(5)
C
C
C     INITALIZE
C
    2 IT1   = 3
      IT2   = 2 + IPREC
      II    = 1
      JJ    = LUSETD
      INCR  = 1
      NOTRD =-1
      LCORE = KORSZ(CORE(1))
C
C     PICK UP AND STORE FREQUENCY SET
C
      IBUF  = LCORE - SYSBUF + 1
      NZ1   = IBUF  - 1
      LCORE = LCORE - 2*SYSBUF
      NZ    = LCORE
      IGUST = 0
      IF (CASECC .GT. 0) GO TO 5
      CASECC = IABS(CASECC)
      IGUST  = 1
    5 CONTINUE
      FILE   = CASECC
      CALL OPEN (*510,CASECC,CORE(IBUF),0)
      CALL FWDREC (*530,CASECC)
      CALL FREAD  (CASECC,CORE,149,0)
      FRQSET = ICORE(14)
      NLOAD  = 0
      LOADN  = ICORE(13)
      CALL CLOSE (CASECC,1)
      ITL(1) = 2
      I149   = 149
      ITL(2) = ICORE(I149)
      ITL(3) = ITL(2) + 1
      ITLD   = 1
C
C     BRING IN AND SAVE FREQ LIST -- CONVERT  W-S TO F    F = TWOPHI* W
C
      FILE  = FRL
      CALL OPEN (*510,FRL,CORE(IBUF),0)
      CALL READ (*530,*10,FRL,CORE(1),NZ1,0,IFLAG)
      GO TO 540
   10 DO 20 I = 3,IFLAG
      IF (ICORE(I) .EQ. FRQSET) GO TO 30
   20 CONTINUE
      NAME(1) = IFRL
      CALL MESAGE (-31,FRQSET,NAME)
   30 K = I-3
      IF (K .EQ. 0) GO TO 50
      DO 40 I = 1,K
      CALL FWDREC (*530,FRL)
   40 CONTINUE
C
C     READ IN  FREQ LIST
C
   50 CALL READ (*530,*60,FRL,CORE(1),NZ1,0,NFREQ)
      GO TO 540
   60 CALL CLOSE (FRL,1)
      LCORE = LCORE - NFREQ
      NZ1   = NZ1   - NFREQ
      FRQSET= K + 1
      LLIST = NFREQ + 1
C
C     CONVERT TO F
C
      DO 70 I = 1,NFREQ
      CORE(I) = CORE(I)/TWOPHI
   70 CONTINUE
C
C     PUT HEADER ON LOAD FILE
C
      FILE = PP
      NZ   = IBUF - SYSBUF
      NZ1  = NZ1  - SYSBUF
      CALL OPEN (*510,PP,CORE(NZ),1)
      CALL FNAME (PP,MCB(1))
      CALL WRITE (PP,MCB(1),2,0)
      CALL WRITE (PP,CORE(1),NFREQ,1)
      FILE = FOL
      CALL OPEN (*71,FOL,CORE(IBUF),1)
      CALL FNAME (FOL,MCB)
      CALL WRITE (FOL,MCB,2,0)
      CALL WRITE (FOL,CORE,NFREQ,1)
      CALL CLOSE (FOL,1)
      MCB(1) = FOL
      MCB(2) = NFREQ
      MCB(3) = FRQSET
      CALL WRTTRL (MCB)
   71 CONTINUE
C
C     SET UP MCB FOR PP
C
      MCB(1) = PP
      MCB(2) = 0
      MCB(3) = LUSETD
      MCB(4) = 2
      MCB(5) = 2 + IPREC
      MCB(6) = 0
      MCB(7) = 0
C
C     BEGIN LOOP ON LOADS SELECTED
C
   80 IF (NLOAD .EQ. 0) GO TO 100
      FILE = CASECC
      CALL OPEN (*510,CASECC,CORE(IBUF),0)
      L = NLOAD + 1
      DO 90 I = 1,L
      CALL FWDREC (*530,CASECC)
   90 CONTINUE
      CALL READ (*500,*540,CASECC,CORE(LLIST),16,1,IFLAG)
      LOADN = ICORE(LLIST+12)
      CALL CLOSE (CASECC,1)
  100 NLOAD = NLOAD + 1
      IF (LOADN .EQ. 0) GO TO 491
      NDONE = 0
      LCORE = NZ1
C
C     FIND SELECTED LOAD IN DLT
C
      FILE = DLT
      CALL OPEN (*510,DLT,CORE(IBUF),0)
      CALL READ (*530,*110,DLT,CORE(LLIST),NZ1,0,IFLAG)
C
C     IS IT A DLOAD SET
C
  110 NDLOAD = ICORE(LLIST+2)
      NSIMPL = IFLAG - 3 - NDLOAD
      IF (NSIMPL .EQ. 0) CALL MESAGE (-31,LOADN,NAME)
      IF (NDLOAD .EQ. 0) GO TO 300
      K = LLIST + 2
      DO 120 I = 1,NDLOAD
      K = K + 1
      IF (ICORE(K) .EQ. LOADN) GO TO 130
  120 CONTINUE
      GO TO 300
C
C     PROCESS DLOAD SET
C
C     FORMAT OF DLOAD CARD = SET ID, SCALE,SCALE,ID, SCALE, ID, ...,0,-1
C
  130 NZ1 = NZ1 - IFLAG
C
C     BRING IN ALL DLOADS
C
      L = LLIST + IFLAG
      CALL READ (*530,*140,DLT,CORE(L),NZ1,0,I)
      GO TO 540
C
C     FIND SELECTED ID
C
  140 ISEL  = L
  150 IF (ICORE(ISEL) .EQ. LOADN) GO TO 170
  160 ISEL = ISEL + 2
      IF (ICORE(ISEL+1) .NE. -1) GO TO 160
      ISEL = ISEL + 2
      GO TO 150
C
C     FOUND LOAD SET  SELECTED
C
  170 SCALE  = CORE(ISEL+1)
C
C     CONVERT  SCALE FACTORS TO OVERALL  SCALE +ID-S TO RECORD NUMBERS-1
C
      L = ISEL + 2
      NSUBL = 0
  180 CORE(L) = CORE(L)*SCALE
      K = LLIST + 2 + NDLOAD
      DO 190 I = 1,NSIMPL
      K = K + 1
      IF (ICORE(L+1) .EQ. ICORE(K)) GO TO 200
  190 CONTINUE
      CALL MESAGE (-31,ICORE(L),NAME)
C
C     FOUND SIMPLE ID
C
  200 ICORE(L+1) = I + 1
      NSUBL = NSUBL + 1
      L = L + 2
      IF (ICORE(L+1) .GE. 0) GO TO 180
C
C     MOVE TO LOAD LIST AREA
C
      L = ISEL + 2
      K = LLIST
      DO 210 I = 1,NSUBL
      ICORE(K)  = ICORE(L+1)
      CORE(K+1) = CORE(L)
      L = L + 2
      K = K + 2
  210 CONTINUE
C
C     BUILD LIST OF UNIQUE TABLES NEEDED FOR NSUBL LOADS
C
      IPOS  = 2
  230 NTABL = 0
      ITABL = LLIST + 2*NSUBL
      DO 290 I = 1,NSUBL
      K = LLIST + (I-1)*2
      J = ICORE(K)
      L = J - IPOS
      IF (L .EQ. 0) GO TO 250
      DO 240 K = 1,L
      CALL FWDREC (*530,DLT)
  240 CONTINUE
C
C     READ IN DESCRIPTOR WORDS
C
  250 IPOS = J + 1
      CALL READ (*530,*550,DLT,HEAD(1),8,1,IFLAG)
      ICDTY = IHEAD(1)
      NT    = 4
      GO TO (251,251,252,291), ICDTY
C
C     TLOAD 1 CARD
C
  252 NT    = 3
      ITLD  = 2
      NOTRD = 1
  251 CONTINUE
      DO 280 M = 3,NT
      IF (IHEAD(M) .EQ. 0) GO TO 280
      IF( NTABL    .EQ. 0) GO TO 270
      DO 260 K = 1,NTABL
      L  = ITABL+K
      IF (ICORE(L) .EQ. IHEAD(M)) GO TO 280
  260 CONTINUE
C
C     STORE NEW TABLE ID
C
  270 NTABL = NTABL + 1
      K = ITABL + NTABL
      ICORE(K) = IHEAD(M)
  280 CONTINUE
      GO TO 290
C
C     TLOAD2 CARD
C
  291 CONTINUE
      NOTRD = 1
  290 CONTINUE
      CALL REWIND (DLT)
      LCORE = LCORE - NTABL - 1
      ILOAD = ITABL + NTABL + 1
      ICORE(ITABL)  = NTABL
      GO TO 330
C
C     PROCESS SIMPLE LOAD REQUEST
C
  300 NSUBL = 1
      CORE(LLIST+1) = 1.0
      L = LLIST + 2 + NDLOAD
      DO 310 I = 1,NSIMPL
      L = L + 1
      IF (ICORE(L) .EQ. LOADN) GO TO 320
  310 CONTINUE
      CALL MESAGE (-31,LOADN,NAME)
C
C     FOUND SIMPLE LOAD  STORE RECORD NUMBER
C
  320 IF (NDLOAD .NE. 0) I = I + 1
      ICORE(LLIST) = I
      IPOS  = 1
      LCORE = LCORE - 2
      GO TO 230
C
C     ALLOCATE CORE
C
  330 LVECT  = 2*LUSETD
      NBUILD = LCORE/(LVECT+NTABL*ITLD)
      NBUILD = MIN0(NBUILD,NFREQ)
      IF (NBUILD .EQ. 0) GO TO 540
      KK  = NTABL*NBUILD
      IFL = NZ - NTABL*NBUILD*ITLD
C
C     LOOP HERE FOR FREQUENCY SPILL
C
      LCORE = LCORE - NTABL*NBUILD
      NBUF  = LCORE - SYSBUF
      IF (NTABL .EQ. 0) GO TO 361
  340 CALL PRETAB (DIT,CORE(ILOAD),CORE(ILOAD),CORE(NBUF),NBUF,L,
     1             CORE(ITABL),ITLIST(1))
      DO 360 J = 1,NTABL
      L = ITABL + J
      DO 350 I = 1,NBUILD
      M = NDONE + I
      K = IFL + NBUILD*(J-1) + I - 1
      IF (ITLD .EQ. 2) GO TO 341
C
C                 TAB      X       F(X)
      CALL TAB (CORE(L),CORE(M),CORE(K))
      GO TO 350
C
C     TRANSFOR LOOK UP FOR TLOAD 1 CARDS
C
  341 CONTINUE
      CALL TAB1 (CORE(L),CORE(M),FX(1))
      CORE(K   ) = FX(1)
      CORE(K+KK) = FX(2)
      GO TO 350
  350 CONTINUE
  360 CONTINUE
  361 CONTINUE
C
C     READY CORE FOR BUILDING LOADS
C
      K = ILOAD - 1
      DO 380 I = 1,NBUILD
      DO 370 L = 1,LVECT
      K = K + 1
      CORE(K) = 0.0
  370 CONTINUE
  380 CONTINUE
C
C     POSITION TO LOAD IN DLT
C
      IPOS = 0
      DO 480 I = 1,NSUBL
      K = LLIST + 2*I - 2
      L = ICORE(K) - IPOS
      SCALE = CORE(K+1)
      IF (L  .EQ. 0) GO TO 400
      DO 390 J = 1,L
      CALL FWDREC (*530,DLT)
  390 CONTINUE
C
C     READ IN 8 WORD LOAD ID
C
  400 IPOS  = L + 1 + IPOS
      CALL READ (*530,*540,DLT,HEAD(1),8,0,IFLAG)
      ICDTY = IHEAD(1)
      TK1   = HEAD(3)
      TK2   = HEAD(4)
      NT    = 4
      GO TO (404,404,403,435), ICDTY
  403 NT    = 3
C
C     FIND COEFFICIENTS IN TABLE LIST
C
  404 DO 430 K = 3,NT
      IF (IHEAD(K) .NE. 0) GO TO 405
      IHEAD(K+3) = -1
      GO TO 430
  405 DO 410 L = 1,NTABL
      M = ITABL + L
      IF (ICORE(M) .EQ. IHEAD(K)) GO TO 420
  410 CONTINUE
      GO TO 550
C
C     COMPUTE POINTER INTO COEF TABLE
C
  420 IHEAD(K+3) = IFL + (L-1)*NBUILD
      IF (ICDTY .EQ. 3) IHEAD(K+4) = IFL + (L-1)*NBUILD + NTABL*NBUILD
  430 CONTINUE
C
C     REPEATLY READ IN  4  WORDS --SIL,A,TAU,THETA
C
  435 IGUST1 = 0
  440 CONTINUE
      IF (IGUST  .EQ. 0) GO TO 442
      IF (IGUST1 .EQ. 1) GO TO 480
      IGUST1 = 1
  442 CONTINUE
      CALL READ (*530,*480,DLT,IHEAD(1),4,0,IFLAG)
      IF (IGUST .EQ. 0) GO TO 443
      ISIL  = 1
      A     = 1.0
      TAU   = 0.0
      THETA = 0.0
  443 CONTINUE
      A     = A*SCALE
      THETA = THETA*DEGRA
      DO 470 J = 1,NBUILD
      IF (ICDTY .EQ. 4) GO TO 448
C
C     COMPUTE COEFFICIENTS
C
      C1 = 0.0
      IF (IHEAD(6) .LT. 0) GO TO 445
      K  = IHEAD(6) + J - 1
      C1 = CORE(K)
  445 C2 = 0.0
      IF (IHEAD(7) .LT. 0) GO TO 448
      K  = IHEAD(7) + J - 1
      C2 = CORE(K)
  448 L  = NDONE + J
      M  = (J-1)*LVECT + 2*ISIL - 2 + ILOAD
      GO TO (450,460,450,471), ICDTY
C
C     RLOAD 1 CARDS OF TLOAD1 CARDS
C
  450 XLAMA = THETA - CORE(L)*TAU*TWOPHI
      SINXL = SIN(XLAMA)
      COSXL = COS(XLAMA)
      CORE(M  ) = A*(C1*COSXL - C2*SINXL) + CORE(M  )
      CORE(M+1) = A*(C1*SINXL + C2*COSXL) + CORE(M+1)
      GO TO 470
C
C     RLOAD2  CARDS
C
  460 XLAMA = THETA - CORE(L)*TAU*TWOPHI + C2*DEGRA
      CORE(M  ) = A*C1*COS(XLAMA) + CORE(M  )
      CORE(M+1) = A*C1*SIN(XLAMA) + CORE(M+1)
      GO TO 470
C
C     TLOAD 2 CARDS
C
  471 CONTINUE
      F   = HEAD(5)
      P   = HEAD(6)*DEGRA
      C   = HEAD(7)
      IB  = HEAD(8)  +.5
      DT  = TK2 - TK1
      RZ  =-C*DT
      CZ  =-DT*(F-CORE(L))*TWOPHI
C
C     COMPUTE  E(B+1) (ZR2)
C
      CALL FRR1A1 (RZ,CZ,IB+1,REB,CEB)
      EB = CMPLX(REB,CEB)
      RP =-RZ
      CP = P - CORE(L)*TWOPHI*TK2 + TWOPHI*F*DT
      POW= CMPLX(RP,CP)
      R2 = CEXP(POW)*EB
C
C     COMPUTE  R1
C
      CZ = -DT*(-F -CORE(L))*TWOPHI
C
C     COMPUTE  E(B+1)ZR1
C
      CALL FRR1A1 (RZ,CZ,IB+1,REB,CEB)
      EB  = CMPLX(REB,CEB)
      CP  =-P - CORE(L)*TWOPHI*TK2 - TWOPHI*F*DT
      POW = CMPLX(RP,CP)
      R1  = R2 + CEXP(POW)*EB
C
C     COMPUTE   P(W)
      R2  = CMPLX(0.,-CORE(L)*TAU*TWOPHI)
      POW = R1*CEXP(R2)
      CP  = (DT**(IB+1))/(2.0 *(HEAD(8)+1.))
      RZ  = REAL(POW)*A*CP
      CZ  = AIMAG (POW)*A*CP
      CORE(M  ) = CORE(M  ) + RZ
      CORE(M+1) = CORE(M+1) + CZ
      GO TO 470
  470 CONTINUE
      GO TO 440
C
C     END OF STUFF IN DLT TABLE
C
  480 CONTINUE
C
C     PACK OUT LOADS BUILT
C
      DO 490 I = 1,NBUILD
      M = (I-1)*LVECT + ILOAD
      CALL PACK (CORE(M),PP,MCB(1))
  490 CONTINUE
      NDONE  = NDONE  + NBUILD
      NBUILD = MIN0(NBUILD,NFREQ-NDONE)
      CALL REWIND (DLT)
      IF (NBUILD .NE. 0) GO TO 340
      CALL CLOSE (DLT,1)
      GO TO 80
C
C     BUILD ZERO LOAD
C
  491 DO 492 I = 1,NFREQ
      CALL BLDPK (3,3,PP,0,0)
      CALL BLDPKN (PP,0,MCB)
  492 CONTINUE
      GO TO 80
C
C     EOF  ON CASECC  END OF ROUTINE
C
  500 CALL CLOSE (CASECC,1)
      CALL WRTTRL (MCB(1))
      CALL CLOSE (PP,1)
      RETURN
C
C     ERROR MESAGES
C
  510 IP1 = -1
  520 CALL MESAGE (IP1,FILE,NAME(2))
  530 IP1 = -2
      GO TO 520
  540 IP1 = -8
      GO TO 520
  550 IP1 = -7
      GO TO 520
      END

      SUBROUTINE GRAV (NGRAV,GVECT,NLIST,ILIST,NLOOP)
C
      INTEGER        NAME(2)
      DIMENSION      GVECT(1),GL(5),X(3),ILIST(1)
      COMMON /TRANX/ NSYS,TYSYS,RO(3),TO(3,3)
      COMMON /LOADX/ LCORE,SLT,N(14),NOBLD
      EQUIVALENCE    (IGL,GL(2))
      DATA    NAME / 4HGRAV,4H    /
C
C     CONVERTS GRAV CARD TO BASIC AND STORES
C     GB = G*TON*V
C
      CALL READ (*30,*40,SLT,GL(1),5,0,FLAG)
      GO TO 50
   20 RETURN
C
   30 CONTINUE
   40 CALL MESAGE (-7,NAME,NAME)
   50 NGRAV = NGRAV + 1
      IF (GL(1)) 60,70,60
   60 CALL FDCSTM (GL(1))
      CALL MPYL (TO,GL(3),3,3,1,X(1))
      DO 61 I = 1,3
      GL(I+2) = X(I)
   61 CONTINUE
   70 DO 80 I = 1,3
      J = (NGRAV-1)*3 + I
   80 GVECT(J) = GL(I+2)*GL(2)
      NL1 = NLOOP - NGRAV + 1
      IF (NL1 .EQ. NLIST) GO TO 20
      NSAVE  = ILIST(NL1)
      NLIST1 = NLIST - 1
      DO 90 I = NL1,NLIST1
   90 ILIST(I) = ILIST(I+1)
      ILIST(NLIST) = NSAVE
      GO TO 20
      END

      SUBROUTINE SQUD42
C
C     PHASE 2 STRESS RECOVERY FOR 4-NODE ISOPARAMETRIC QUADRILATERAL
C     SHELL ELEMENT (QUAD4)
C
C     NOTE - FOR LAMINATED COMPOSITE ELEMENTS THE FOLLOWING ARE
C            NOT SUPPORTED
C
C         1. VARIABLE GRID POINT THICKNESS
C         3. TEMPERATURE AT 'FIBRE' DISTANCE
C
C         ALSO STRESSES ARE ONLY EVALUATED AT THE ELEMENT CENTRE
C         AND SIMILARILY FOR STRESS RESULTANTS
C
C
C     ALGORITHM -
C
C     1- STRAIN RECOVERY DATA IS SENT BY PHASE 1 THRU 'PHIOUT',
C        WHICH INCLUDES ALL THE NECESSARY TRANSFORMATIONS AND
C        STRAIN RECOVERY MATRICES. THE DATA IS REPEATED FOR EACH
C        STRESS EVALUATION POINT.
C     2- GLOBAL DISPLACEMENT VECTOR ENTERS THE ROUTINE IN CORE.
C     3- BASED ON THE DATA IN /SDR2X4/, LOCATION OF THE GLOBAL
C        DISPLACEMENT VECTOR FOR THE CURRENT SUBCASE IS DETERMINED.
C     4- WORD 132 OF /SDR2DE/ CONTAINS THE STRESS OUTPUT REQUEST
C        OPTION FOR THE CURRENT SUBCASE.
C     5- ELEMENT/GRID POINT TEMPERATURE DATA ENTERS THE ROUTINE
C        THRU /SDR2DE/ (POSITIONS 97-103, 104-129 NOT USED.)
C     6- ELEMENT STRAINS ARE CALCULATED, CORRECTED FOR THERMAL
C        STRAINS, AND PREMULTIPLIED BY G-MATRIX.
C
      EXTERNAL        ANDF
      LOGICAL         EXTRM,LAYER,COMPOS,GRIDS,INTGS,MAXSH,VONMS,BENDNG,
     1                TRNFLX,TEMPP1,TEMPP2,SNRVRX,SNRVRY,FOUR,PCMP,
     2                PCMP1,PCMP2,DEBUG
CWKBNB NCL93012 3/94      
      LOGICAL         OSTRAI
      REAL            EPSAVG(6)
CWKBNE NCL93012 3/94
      INTEGER         INTZ(1),IGRID(5),NPHI(2395),NSTRES(86),ELID,
     1                KSIL(8),IORDER(8),CENTER,NFORS(46),EXTRNL,
CWKBR 3/95 SPR94017 2  INDXG2(3,3),INDX(6,3),OPRQST,FLAG,IPN(5),COMPS,  
     2                INDXG2(3,3),INDX(6,3),FLAG,IPN(5),COMPS,  
     3                OES1L,OEF1L,PCOMP,PCOMP1,PCOMP2,PIDLOC,SYM,SYMMEM,
     4                SOUTI,FTHR,STRAIN,ELEMID,PLYID,ANDF,SDEST,FDEST
C    5,               GPSTRS,INDEXU(3,3),INDEXV(2,3)
      REAL            MOMINR,KHIT,MINTR,TDELTA(6),DELTA(48),TSTB(5,5),
     1                TSTT(5,5),TSTN(50),DELTAT(8),U(36),G(36),G2(9),
     2                ALFAM(3),ALFAB(3),Z1(5),Z2(5),GPTH(4),STRES(86),
     3                G3(4),TMI(9),TRANS(9),STRNT(3),STRNB(3),STRNTC(3),
     4                STRNBC(3),EPST(3),EPSB(3),EPSE(3),EPSTOT(3),FB(2),
     5                EPSLNE(3),STRESL(3),STRESE(3),EZEROT(6),ALPHA(3),
     6                V(2),EI(2),ZBAR(2),TRNAR(2),TRNSHR(2),ULTSTN(6),
     7                ABBD(6,6),STIFF(36),MTHER(6),DUMC(6),STEMP(8)
      CHARACTER       UFM*23,UWM*25
      COMMON /XMSSG / UFM,UWM
      COMMON /ZZZZZZ/ Z(1)
      COMMON /SYSTEM/ KSYSTM(60)
      COMMON /SDR2C1/ IPCMP,NPCMP,IPCMP1,NPCMP1,IPCMP2,NPCMP2,
     1                NSTROP
      COMMON /SDR2X2/ DUMM(30),OES1L,OEF1L
      COMMON /SDR2X4/ DUMMY(35),IVEC,IVECN,LDTEMP
      COMMON /SDR2X7/ PHIOUT(2395)
      COMMON /SDR2X8/ SIGMA(3),ICOUNT,NSTOT,THIKNS(5),ISTRES,KPOINT,
     1                EXTRNL(8),TSTR(50),XPOINT(2),SHPFNC(4),EPSLN(8),
     2                KHIT(3),G2ALFB(30),TST(20),TES(9),TESU(9),TESV(4),
     3                REALI(5),GT(36),EPSLNT(6),TSIGMA(8),SIGNX(4),
     4                SIGNY(4),VXCNTR,VYCNTR,FXCNTR,FYCNTR,FXYCNT,
     5                STRX(2),STRY(2),STRS(2),FORSUL(46)
      COMMON /SDR2DE/ KSDRDE(141)
CWKBR NCL93012 3/94      COMMON /BLANK / APP(2),SORT2,IDUM(2),COMPS   
      COMMON /BLANK / APP(2),SORT2,IDUM(2),COMPS,SKP(4),OSTRAI
      COMMON /CONDAS/ PI,TWOPI,RADDEG,DEGRAD
      EQUIVALENCE     (Z(1)   ,INTZ(1)   ), (NFORS(1) ,FORSUL(1) ),
     1                (NPHI(1),PHIOUT(1) ), (NSTRES(1),STRES(1)  ),
     2                (ELID   ,NPHI(1)   ), (KSIL(1)  ,NPHI(2)   ),
     3                (TSUB0  ,PHIOUT(18)), (IORDER(1),NPHI(10)  ),
     4                (AVGTHK ,PHIOUT(21)), (MOMINR   ,PHIOUT(22)),
     5                (G(1)   ,PHIOUT(23)), (ALFAM(1) ,PHIOUT(59)),
     6                (GPTH(1),PHIOUT(65)), (ALFAB(1) ,PHIOUT(62)),
     7                (IPID   ,NPHI(79)  ), (KSTRS    ,KSDRDE(42)),
     8                (KFORCE ,KSDRDE(41)), (STEMP(1) ,KSDRDE(97)),
     9                (SDEST  ,KSDRDE(26)), (FDEST    ,KSDRDE(33)),
     O                (NOUT   ,KSYSTM(2) ), (STEMP(7) ,FLAG      )
C    1,               (INDEXU(1,1),INDEXV(1,1))
      DATA    DEBUG / .FALSE.  /
      DATA    CENTER/ 4HCNTR   /
      DATA    CONST / 0.57735026918962/
      DATA    EPSS  / 1.0E-11  /
      DATA    EPSA  / 1.0E-7   /
      DATA    IPN   / 1,4,2,3,5/
      DATA    PCOMP / 0 /
      DATA    PCOMP1/ 1 /
      DATA    PCOMP2/ 2 /
      DATA    SYM   / 1 /
      DATA    MEM   / 2 /
      DATA    SYMMEM/ 3 /
      DATA    STRAIN/ 5 /
C
C     DEFINE PHIOUT(2395), THE TRANSMITTED DATA BLOCK
C
C     ADDRESS     DESCRIPTIONS
C
C        1        ELID
C      2 - 9      SIL NUMBERS
C     10 - 17     IORDER
C       18        TREF
C     19 - 20     FIBRE DISTANCES Z1, Z2 AS SPECIFIED ON PSHELL CARD
C       21        AVGTHK- AVERAGE THICKNESS OF THE ELEMENT
C       22        MOMINR- MOMENT OF INERTIA FACTOR
C     23 - 58     GBAR-MATRIX, 6X6 MATRIX OF MATERIAL PROPERTY (W/O G3)
C     59 - 61     THERMAL EXPANSION COEFFICIENTS FOR MEMBRANE
C     62 - 64     THERMAL EXPANSION COEFFICIENTS FOR BENDING
C     65 - 68     CORNER NODE THICKNESSES
C     69 - 77     TUM-MATRIX, 3X3 TRANSFORMATION FROM MATERIAL TO USER
C                 DEFINED COORDINATE SYSTEM
C       78        OFFSET OF ELEMENT FROM GP PLANE
C       79        ORIGINAL PROPERTY ID FOR COMPOSITES
C     80 - 79+9*NNODE
C                 TEG-MATRIX, A 3X3 MATRIX FOR THE TRANSFORMATION
C                 MATRIX FROM GLOBAL COORD TO ELMT COORD FOR
C                 EACH NODE.
C                 TEG-MATRIX, 3X3 DATA ARE REPEATED FOR NNODES
C     --------
C     START FROM PHIOUT(79+9*NNODE+1) AS A REFERENCE ADDRESS
C                       79+9*4    +1= 116
C
C     ADDRESS     DESCRIPTIONS
C
C        1        T, MEMBRANE THICKNESS AT THIS EVALUATION POINT
C      2 - 10     TES-MATRIX, A 3X3 TRANSFORMATION MATRIX FROM ELEM.
C                        C.S. TO USER DEFINED STRESS C.S. AT THIS
C                        EVALUATION POINT
C     11 - 19     CORRECTION TO GBAR-MATRIX FOR MEMBRANE-BENDING
C                        COUPLING AT THIS EVALUATION POINT
C     20 - 28     TMI-MATRIX, 3X3 TRANSFORMATION FROM TANGENT TO MATERIA
C     29 - 32     G3-MATRIX
C     33 - 32+NNODE
C                 ELEMENT SHAPE FUNCTION VALUES AT THIS EVAL. POINT
C     32+NNODE+1 -
C     32+NNODE+8*NDOF
C                 B-MATRIX, 8 X NDOF
C
C     --------    ABOVE DATA BATCH REPEATED 10 TIMES
C
C     TOTAL PHIOUT WORDS = (116-1) + (32+4+8*(6*4))*10
C                        =    115  + (32+4+192)*10 = 115 + 2280 = 2395
C
C
C     DEFINE STRES (TOTAL OF 86 WORDS), THE STRESS OUTPUT DATA BLOCK
C
C     ADDRESS     DESCRIPTIONS
C
C        1        ELID
C     -------------------------------------------------------
C        2        INTEGRATION POINT NUMBER
C     3  - 10     STRESSES FOR LOWER POINTS
C     11 - 18     STRESSES FOR UPPER POINTS
C     ---------   ABOVE DATA REPEATED 4 TIMES
C     70 - 86     STRESSES FOR CENTER POINT
C
C     DEFINE FORSUL (TOTAL OF 46 WORDS), THE FORCE RESULTANT OUTPUT
C     DATA BLOCK.
C
C     ADDRESS    DESCRIPTIONS
C
C        1       ELID
C     ------------------------------------------------
C        2       GRID POINT NUMBER
C      3 - 10    FORCES
C     --------   ABOVE DATA REPEATED 4 TIMES
C     38 - 46    FORCES FOR CENTER POINT
C
C     NSTOT  = NUMBER OF DATA OUTPUT THRU 'STRES'
C     NFORCE = NUMBER OF DATA OUTPUT THRU 'FORSUL'
C     NNODE  = TOTAL NUMBER OF NODES
C     NDOF   = TOTAL NUMBER OF DEGREES OF FREEDOM
C     LDTEMP = SWITCH TO DETERMINE IF THERMAL EFFECTS ARE PRESENT
C     ICOUNT = POINTER FOR PHIOUT DATA
C
C     STAGE 1 -  INITIALIZATION
C     =========================
C
CWKBNB 3/95 SPR94017
      DO 5 I = 1,6
      EPSAVG( I ) = 0.
5     CONTINUE
CWKBNE 3/95 SPR94017
      NSTOT = 1 + 5 + 5*2*8
      NFORCE= 1 + 5*9
      NNODE = 0
      DO 10 ICHK = 1,8
      IF (KSIL(ICHK) .GT. 0) NNODE = NNODE + 1
   10 EXTRNL(ICHK) = 0
      NDOF = 6*NNODE
      FOUR = NNODE .EQ. 4
C
C     COMMENTS FROM G.C. 2/1990
C     EXTRNL ARE SET TO ZEROS ABOVE AND NEVER SET TO ANY VALUE LATER.
C     IT IS THEN USED TO SET IGRID. WHAT'S EXTRNL FOR?
C     THE ANSWER IS THAT EXTRNL AND IGRID ARE USED ONLY WHEN GRIDS FLAG
C     IS TRUE. GRIDS IS FALSE IN COSMIC VERSION.
C
C     ALSO, A MISSING ROUTINE, FNDGID, SUPPOSELY RETURNS EXTERNAL GRID
C     NUMBER FROM SIL INDEX. FNDGID IS LOCATED A FEW LINES BELOW 80
C
C     CHECK THE OUTPUT AND STRESS REQUEST
C
      GRIDS = .FALSE.
      INTGS = .TRUE.
      MAXSH = ANDF(NSTROP,1) .EQ. 0
      VONMS = ANDF(NSTROP,1) .NE. 0
      EXTRM = ANDF(NSTROP,2) .EQ. 0
      LAYER = ANDF(NSTROP,2) .NE. 0
      BENDNG= MOMINR .GT. 0.0
C
C     NOTE - MAXSH AND EXTRM ARE NO LONGER USED
C
C     IF LAYERED STRESS/STARIN OUTPUT IS REQUESTED, AND THERE ARE NO
C     LAYERED COMPOSITE DATA, SET LAYER FLAG TO FALSE
C
      IF (LAYER .AND. NPCMP+NPCMP1+NPCMP2.LE.0) LAYER = .FALSE.
C
C     IF LAYERED OUTPUT IS REQUESTED BUT THE CURRENT ELEMENT IS NOT A
C     LAYERED COMPOSITE, SET LAYER FLAG TO FALSE
C
      IF (LAYER .AND. IPID.LT.0) LAYER = .FALSE.
C
CWKBDB 3/95 SPR94017
C      OPRQST = -2
C      IF (KSTRS  .EQ. 1) OPRQST = OPRQST + 1
C      IF (KFORCE .EQ. 1) OPRQST = OPRQST + 2
CWKBI NCL93012 3/94
C      IF ( OSTRAI ) OPRQST = OPRQST + 1
C      IF (OPRQST .EQ.-2) RETURN
CWKBDE 3/95 SPR94017
CWKBI  3/95 SPR94017
      IF ( ( KSTRS  .NE. 1 ) .AND. 
     &     ( KFORCE .NE. 1 ) .AND. 
     &     (.NOT.OSTRAI)          )RETURN
C
C     CHECK FOR FIBRE DISTANCES Z1 AND Z2 BEING BLANK
C
      LOGZ12 = -4
      IF (NPHI(19) .EQ. 0) LOGZ12 = LOGZ12 + 2
      IF (NPHI(20) .EQ. 0) LOGZ12 = LOGZ12 + 4
C
C     CHECK FOR THE TYPE OF TEMPERATURE DATA
C     NOTES  1- TYPE TEMPP1 ALSO INCLUDES TYPE TEMPP3
C            2- IF NIETHER TYPE IS TRUE, GRID POINT TEMPERATURES
C               ARE PRESENT.
C
      TEMPP1 = FLAG .EQ. 13
      TEMPP2 = FLAG .EQ.  2
C
C     CHECK FOR OFFSET AND COMPOSITES
C
      OFFSET = PHIOUT(78)
      COMPOS = COMPS.EQ.-1 .AND. IPID.GT.0
C
C     ZERO OUT STRESS AND FORCE RESULTANT ARRAYS
C
      DO 20 K = 1,NSTOT
   20 STRES(K) = 0.0
      DO 30 I = 1,NFORCE
   30 FORSUL(I)= 0.0
      NSTRES(1)= ELID
      NFORS(1) = ELID
C
C     ZERO OUT THE COPY OF GBAR-MATRIX TO BE USED BY THIS ROUTINE
C
      DO 40 K = 1,36
   40 GT(K) = 0.0
C
C     STAGE 2 - ARRANGEMENT OF INCOMING DATA
C     ======================================
C
C     SORT THE GRID TEMPERATURE CHANGES INTO SIL ORDER (IF PRESENT)
C
      IF (LDTEMP .EQ.     -1) GO TO 60
      IF (TEMPP1 .OR. TEMPP2) GO TO 60
C
C     DO 50 K = 1,NNODE
C     KPOINT = IORDER(K)
C  50 DELTAT(K) = STEMP(KPOINT)
C
C     COMMENTS FORM G.CHAN/UNISYS  2/93
C     THE ABOVE DO 50 LOOP DOES NOT WORK SINCE STEMP(2 THRU NNODE) = 0.0
C
      DO 50 K = 1,NNODE
   50 DELTAT(K) = STEMP(1)
C
C     PICK UP THE GLOBAL DISPLACEMENT VECTOR AND TRANSFORM IT
C     INTO THE ELEMENT C.S.
C
   60 DO 80 IDELT = 1,NNODE
      JDELT = IVEC + KSIL(IDELT) - 2
      KDELT = 6*(IDELT-1)
      DO 70 LDELT = 1,6
      TDELTA(LDELT) = Z(JDELT+LDELT)
   70 CONTINUE
C
C     FETCH TEG-MATRIX 3X3 FOR EACH NODE AND LOAD IT IN A 6X6 MATRIX
C     INCLUDE THE EFFECTS OF OFFSET
C
      CALL TLDRS  (OFFSET,IDELT,PHIOUT(80),U)
      CALL GMMATS (U,6,6,0, TDELTA,6,1,0, DELTA(KDELT+1))
   80 CONTINUE
C
C     GET THE EXTERNAL GRID POINT ID NUMBERS FOR CORRESPONDING SIL
C     NUMBERS.
C
C     CALL FNDGID (ELID,8,KSIL,EXTRNL)
C
C     STAGE 3 - CALCULATION OF STRAINS
C     ================================
C
C     INTEGRATION DATA IN PHIOUT IS ARRANGED IN ETA, XI INCREASING
C     SEQUENCE.
C
      ISIG  = 1
      ICOUNT= -(8*NDOF+NNODE+32) + 79 + 9*NNODE
C
      DO 350 INPLAN = 1,5
      INPLN1 = IPN(INPLAN)
C
C     MATCH GRID ID NUMBER WHICH IS IN SIL ORDER
C
      IF (INPLAN .EQ. 5) GO TO 100
      DO 90 I = 1,NNODE
      IF (IORDER(I) .NE. INPLN1) GO TO 90
      IGRID(INPLAN) = EXTRNL(I)
      GO TO 110
   90 CONTINUE
      GO TO 110
C
  100 IGRID(INPLAN) = CENTER
  110 CONTINUE
C
      DO 340 IZTA = 1,2
      ZETA = (IZTA*2-3)*CONST
C
      ICOUNT = ICOUNT + 8*NDOF + NNODE + 32
      IF (IZTA .EQ. 2) GO TO 160
C
C     THICKNESS AND MOMENT OF INERTIA AT THIS POINT
C
      THIKNS(INPLAN) = PHIOUT(ICOUNT+1)
      IF (GRIDS .AND. INPLAN.NE.5) THIKNS(INPLAN) = GPTH(INPLN1)
      REALI(INPLAN) = MOMINR*THIKNS(INPLAN)**3/12.0
C
C     DETERMINE FIBER DISTANCE VALUES
C
      IF (LOGZ12 .EQ. -4) GO TO 150
      IF (LOGZ12) 120,130,140
C
  120 Z1(INPLAN) = -0.5*THIKNS(INPLAN)
      Z2(INPLAN) = PHIOUT(20)
      GO TO 160
C
  130 Z1(INPLAN) = PHIOUT(19)
      Z2(INPLAN) = 0.5*THIKNS(INPLAN)
      GO TO 160
C
  140 Z1(INPLAN) = -0.5*THIKNS(INPLAN)
      Z2(INPLAN) = -Z1(INPLAN)
      GO TO 160
C
  150 Z1(INPLAN) = PHIOUT(19)
      Z2(INPLAN) = PHIOUT(20)
  160 CONTINUE
C
C     FIRST COMPUTE LOCAL STRAINS UNCORRECTED FOR THERMAL STRAINS
C     AT THIS EVALUATION POINT.
C
C        EPSLN  = PHIOUT(KSIG) * DELTA
C          EPS  =       B      *   U
C          8X1        8XNDOF    NDOFX1
C
      KSIG = ICOUNT+NNODE+33
      CALL GMMATS (PHIOUT(KSIG),8,NDOF,0, DELTA(1),NDOF,1,0, EPSLN)
C
C     CALCULATE THERMAL STRAINS IF TEMPERATURES ARE PRESENT
C
      IF (LDTEMP .EQ. -1) GO TO 260
      DO 170 IET = 1,6
  170 EPSLNT(IET) = 0.0
C
C     A) MEMBRANE STRAINS
C
      IF (TEMPP1 .OR. TEMPP2) GO TO 190
C
C     GRID TEMPERATURES
C
      KSHP = ICOUNT + 32
      TBAR = 0.0
      DO 180 ISH = 1,NNODE
      KSH  = KSHP + ISH
  180 TBAR = TBAR + PHIOUT(KSH)*DELTAT(ISH)
      TMEAN= TBAR
      GO TO 200
C
C     ELEMENT TEMPERATURES
C
  190 TBAR = STEMP(1)
  200 TBAR = TBAR - TSUB0
      DO 210 IEPS = 1,3
  210 EPSLNT(IEPS) = -TBAR*ALFAM(IEPS)
C
C     B) BENDING STRAINS (ELEMENT TEMPERATURES ONLY)
C
      IF (.NOT.BENDNG) GO TO 260
      IF (.NOT.(TEMPP1 .OR. TEMPP2)) GO TO 260
C
C     EXTRACT G2-MATRIX FROM GBAR-MATRIX AND CORRECT IT FOR COUPLING
C
      IG21 = 0
      DO 220 IG2 = 1,3
      IG22 = (IG2-1)*6 + 21
      DO 220 JG2 = 1,3
      IG21 = IG21 + 1
      JG22 = JG2  + IG22
  220 G2(IG21) = G(JG22) + PHIOUT(ICOUNT+10+IG21)
C
      IG2AB = (ISIG*3)/5 + 1
      CALL GMMATS (G2,3,3,0, ALFAB,3,1,0, G2ALFB(IG2AB))
C
      IF (TEMPP1) GO TO 240
      CALL INVERS (3,G2,3,GDUM,0,DETG2,ISNGG2,INDXG2)
      CALL GMMATS (G2,3,3,0, STEMP(2),3,1,0, KHIT)
      DO 230 IEPS = 4,6
  230 EPSLNT(IEPS) = KHIT(IEPS-3)*ZETA*THIKNS(INPLAN)/(2.*REALI(INPLAN))
      GO TO 260
C
  240 TPRIME = STEMP(2)
      DO 250 IEPS = 4,6
  250 EPSLNT(IEPS) = -TPRIME*ALFAB(IEPS-3)*ZETA*THIKNS(INPLAN)/2.
C
C     MODIFY GBAR-MATRIX
C
  260 I1 = -6
      I2 = 12
      I3 = 11 + ICOUNT
      DO 270 I = 1,3
      I1 = I1 + 6
      I2 = I2 + 6
      DO 270 J = 1,3
      J1 = J  + I1
      J3 = J1 + 3
      J4 = J  + I2
      J2 = J4 + 3
      GT(J1) = G(J1)
      GT(J2) = G(J2)
      GT(J3) = G(J3) + PHIOUT(I3)
      GT(J4) = G(J4) + PHIOUT(I3)
  270 I3 = I3 + 1
C
C     DETERMINE G MATRIX FOR THIS EVALUATION POINT
C
      DO 280 I = 1,4
  280 G3(I) = PHIOUT(ICOUNT+28+I)
C
      IF (LDTEMP .EQ. -1) GO TO 300
C
C     CORRECT STRAINS FOR THERMAL EFFECTS
C
      DO 290 I = 1,6
  290 EPSLN(I) = EPSLN(I) + EPSLNT(I)
C
C     CALCULATE STRESS VECTOR
C
  300 CALL GMMATS (GT(1),6,6,0, EPSLN(1),6,1,0, TSIGMA(1))
      CALL GMMATS (G3(1),2,2,0, EPSLN(7),2,1,0, TSIGMA(7))
CWKBNB NCL93012 3/94
      IF ( IZTA .NE. 1 ) GO TO 303
      DO 301 IAV = 1, 3
      EPSAVG(IAV) = EPSAVG(IAV) + EPSLN(IAV)
301   CONTINUE
      DO 302 IAV = 4, 6
      EPSAVG(IAV) = EPSAVG(IAV) + EPSLN(IAV) / CONST
302   CONTINUE
303   CONTINUE
CWKBNE NCL93012 3/94
      IF (.NOT.BENDNG) GO TO 320
C
C     COMBINE STRESSES ONLY IF 'BENDING'
C
      DO 310 I = 1,3
  310 TSIGMA(I) = TSIGMA(I+3)
C
  320 CONTINUE
C
C     TRANSFORM STRESSES FROM ELEMENT TO STRESS C.S.
C
      DO 330 I = 1,9
  330 TES(I) = PHIOUT(ICOUNT+1+I)
C
      TESU(1) = TES(1)*TES(1)
      TESU(2) = TES(4)*TES(4)
      TESU(3) = TES(1)*TES(4)
      TESU(4) = TES(2)*TES(2)
      TESU(5) = TES(5)*TES(5)
      TESU(6) = TES(2)*TES(5)
      TESU(7) = TES(1)*TES(2)*2.0
      TESU(8) = TES(4)*TES(5)*2.0
      TESU(9) = TES(1)*TES(5) + TES(2)*TES(4)
C
      CALL GMMATS (TESU(1),3,3,1, TSIGMA(1),3,1,0, TSTR(ISIG))
C
      TESV(1) = TES(5)*TES(9) + TES(6)*TES(8)
      TESV(2) = TES(2)*TES(9) + TES(8)*TES(3)
      TESV(3) = TES(4)*TES(9) + TES(7)*TES(6)
      TESV(4) = TES(1)*TES(9) + TES(3)*TES(7)
C
      ISIG = ISIG + 3
      CALL GMMATS (TESV(1),2,2,1, TSIGMA(7),2,1,0, TSTR(ISIG))
C
  340 ISIG = ISIG + 2
  350 CONTINUE
C
C     IF REQUIRED, EXTRAPOLATE STRESSES FROM INTEGRATION POINTS
C     TO CORNER POINTS.
C
C     FIRST EXTRAPOLATE ACROSS ZETA, REGARDLESS OF INPLANE REQUEST
C
      DO 370 IKK = 1,5
      ITB = (IKK-1)*10
      DO 360 IJJ = 1,5
      TSTB(IKK,IJJ) = TSTR(ITB+  IJJ)
      TSTT(IKK,IJJ) = TSTR(ITB+5+IJJ)
  360 CONTINUE
  370 CONTINUE
C
      X1 = -CONST
      X2 = -X1
C
      DO 380 K = 1,2
      IK = 0
      XX = -1.0
      IF (K .EQ. 2) XX =-XX
      IF (K .EQ. 2) IK = 5
C
      XN22 = (XX-X1)/(X2-X1)
      XN11 = 1.0 - XN22
C
      DO 380 I = 1,5
      IKKN = (I-1)*10 + IK
      DO 380 J = 1,5
  380 TSTN(IKKN+J) = TSTB(I,J)*XN11 + TSTT(I,J)*XN22
C
      DO 390 II = 1,50
  390 TSTR(II) = TSTN(II)
C
      IF (INTGS .OR. COMPOS) GO TO 540
C
      IXTR = 5
      JXTR = IXTR*4
C
      IZ1 = 0
      DO 530 IZ = 1,2
C
      DO 400 I = 1,JXTR
  400 TST(I) = 0.0
C
C     FOR THE SAKE OF COMPATIBILITY BETWEEN THE CONVENTION FOR
C     SHEAR FORCES, AND THE CONVENTION FOR EXTRAPOLATION, WE MAY
C     HAVE TO CHANGE THE SIGNS AROUND FOR SPECIFIC POINTS. THEY
C     WILL BE RETURNED TO THE ORIGINAL SIGNS AFTER EXTRAPOLATION IS
C     COMPLETE.
C
CWKBR 3/95 SPR94017      IF (OPRQST .LT. 0) GO TO 460
      IF ( KFORCE .NE. 1 ) GO TO 460
      DO 440 I = 1,4
      J = (I-1)*2*IXTR + IZ1 + 4
      IF (TSTR(J) .EQ. 0.0) GO TO 410
      SIGNY(I) = TSTR(J)/ABS(TSTR(J))
      GO TO 420
  410 SIGNY(I) = 0.0
  420 IF (TSTR(J+1) .EQ. 0.0) GO TO 430
      SIGNX(I) = TSTR(J+1)/ABS(TSTR(J+1))
      GO TO 440
  430 SIGNX(I) = 0.0
  440 CONTINUE
C
      SNRVRY = .FALSE.
      IF (SIGNY(1)*SIGNY(2).LE.0.0 .OR. SIGNY(3)*SIGNY(4).LE.0.0 .OR.
     1    SIGNY(3)*SIGNY(1).LE.0.0) SNRVRY = .TRUE.
      SNRVRX = .FALSE.
      IF (SIGNX(1)*SIGNX(2).LE.0.0 .OR. SIGNX(3)*SIGNX(4).LE.0.0 .OR.
     1    SIGNX(3)*SIGNX(1).LE.0.0) SNRVRX = .TRUE.
C
      IF (.NOT.SNRVRY) GO TO 450
      TSTR(IZ1+4) = -TSTR(IZ1+4)
      TSTR(IZ1+4+4*IXTR) = -TSTR(IZ1+4+4*IXTR)
  450 IF (.NOT.SNRVRX) GO TO 460
      TSTR(IZ1+5) = -TSTR(IZ1+5)
      TSTR(IZ1+5+2*IXTR) = -TSTR(IZ1+5+2*IXTR)
  460 CONTINUE
C
      XPOINT(1) = -1.0
      XPOINT(2) = +1.0
      IR = 0
C
      DO 490 IX = 1,2
      XI = XPOINT(IX)
C
      DO 490 IE = 1,2
      ETA = XPOINT(IE)
C
      SHPFNC(1) = 0.75*(CONST-XI)*(CONST-ETA)
      SHPFNC(2) = 0.75*(CONST-XI)*(CONST+ETA)
      SHPFNC(3) = 0.75*(CONST+XI)*(CONST-ETA)
      SHPFNC(4) = 0.75*(CONST+XI)*(CONST+ETA)
C
      LI = IR*IXTR
      IR = IR + 1
C
      DO 480 IS = 1,4
      LK = (IS-1)*2*IXTR + IZ1
C
      DO 470 IT = 1,IXTR
      TST(LI+IT) = TST(LI+IT) + SHPFNC(IS)*TSTR(LK+IT)
  470 CONTINUE
  480 CONTINUE
  490 CONTINUE
C
      J1 = 0
      DO 500 IS = 1,4
      J2 = (IS-1)*2*IXTR + IZ1
      DO 500 JS = 1,IXTR
      J1 = J1 + 1
      J2 = J2 + 1
  500 TSTR(J2) = TST(J1)
C
C     CHANGE THE SIGNS BACK, IF NECESSARY
C
CWKBR 3/95 SPR94017     IF (OPRQST .LT. 0) GO TO 520
      IF ( KFORCE .NE. 1 ) GO TO 520
      IF (.NOT.SNRVRY) GO TO 510
      TSTR(IZ1+4) = -TSTR(IZ1+4)
      TSTR(IZ1+4+4*IXTR) = -TSTR(IZ1+4+4*IXTR)
  510 IF (.NOT.SNRVRX) GO TO 520
      TSTR(IZ1+5) = -TSTR(IZ1+5)
      TSTR(IZ1+5+2*IXTR) = -TSTR(IZ1+5+2*IXTR)
  520 CONTINUE
  530 IZ1 = IZ1 + IXTR
  540 CONTINUE
C
C     STAGE 4 - CALCULATION OF OUTPUT STRESSES
C     ========================================
C
CWKBR 3/95 SPR94017     IF (OPRQST .EQ. 0) GO TO 740  
      IF ( (KSTRS .NE. 1) .AND. (.NOT. OSTRAI) ) GO TO 740  
C
CWKBNB NCL93012 3/94
      DO 731 IAV = 1, 3
      EPSAVG(IAV) = EPSAVG(IAV) / 5.
731   CONTINUE
      DO 732 IAV = 4, 6
      EPSAVG(IAV) = EPSAVG(IAV) / ( 5. * PHIOUT(21)/2. )
732   CONTINUE
CWKBNE NCL93012 3/94
      ISIG    = 0
      IG2A    = 0
      STRX(1) = 0.0
      STRX(2) = 0.0
      STRY(1) = 0.0
      STRY(2) = 0.0
      STRS(1) = 0.0
      STRS(2) = 0.0
      DO 730 INPLAN = 1,5
      INPLN1 = INPLAN
      IF (INPLAN .EQ. 2) INPLN1 = 4
      IF (INPLAN .EQ. 3) INPLN1 = 2
      IF (INPLAN .EQ. 4) INPLN1 = 3
C
      ISTRES = (INPLN1-1)*17 + 2
C
      IDPONT = IGRID(INPLAN)
      IF (INTGS) IDPONT = INPLN1
      IF (INTGS .AND. INPLAN.EQ.5) IDPONT = CENTER
      NSTRES(ISTRES) = IDPONT
      THICK = THIKNS(INPLAN)
C
      DO 720 IZ = 1,2
      IF (IZ .EQ. 2) ISTRES = ISTRES + 8
      FIBRE = Z1(INPLAN)
      IF (IZ .EQ. 2) FIBRE = Z2(INPLAN)
CWKBNB NCL93012 3/94
      IF ( .NOT. OSTRAI ) GO TO 545
      IF ( IZ .NE. 1 ) GO TO 542
      NSTRES( ISTRES+1 ) = 0
      SIGMA( 1 ) = EPSAVG( 1 )
      SIGMA( 2 ) = EPSAVG( 2 )
      SIGMA( 3 ) = EPSAVG( 3 )
      GO TO 630
542   CONTINUE
      NSTRES( ISTRES+1 ) = -1
      SIGMA( 1 ) = EPSAVG( 4 )
      SIGMA( 2 ) = EPSAVG( 5 )
      SIGMA( 3 ) = EPSAVG( 6 )
      GO TO 630
545   CONTINUE
CWKBNE NCL93012 3/94
      STRES(ISTRES+1) = FIBRE
C
C     EVALUATE STRESSES AT THIS FIBRE DISTANCE
C
      DO 550 I = 1,3
      SIGMA(I) = (0.5-FIBRE/THICK)*TSTR(ISIG+I) + (0.5+FIBRE/THICK)
     1           *TSTR(ISIG+I+5)
  550 CONTINUE
C
C     IF TEMPERATURES ARE PRESENT, CORRECT STRESSES FOR THERMAL
C     STRESSES ASSOCIATED WITH THE DATA RELATED TO FIBRE DISTANCES.
C
      IF (LDTEMP .EQ. -1) GO TO 610
C
C     IF NO BENDING, TREAT IT LIKE GRID POINT TEMPERATURES
C
      IF (.NOT.BENDNG) GO TO 610
      IF (TEMPP1) GO TO 560
      IF (TEMPP2) GO TO 570
      GO TO 610
C
  560 TSUBI = STEMP(2+IZ)
      IF (ABS(TSUBI) .LT. EPSS) GO TO 610
      TSUBI = TSUBI - TPRIME*FIBRE
      GO TO 590
C
  570 TSUBI = STEMP(4+IZ)
      IF (ABS(TSUBI) .LT. EPSS) GO TO 610
      DO 580 IST = 1,3
  580 SIGMA(IST) = SIGMA(IST) - STEMP(IST+1)*FIBRE/REALI(INPLAN)
  590 TSUBI = TSUBI - TBAR
      DO 600 ITS = 1,3
      SIGMA(ITS) = SIGMA(ITS) - TSUBI*G2ALFB(IG2A+ITS)
  600 CONTINUE
C
C     AVERAGE THE VALUES FROM OTHER 4 POINTS FOR THE CENTER POINT
C
  610 IF (INPLAN .EQ. 5) GO TO 620
      STRX(IZ) = STRX(IZ) + 0.25*SIGMA(1)
      STRY(IZ) = STRY(IZ) + 0.25*SIGMA(2)
      STRS(IZ) = STRS(IZ) + 0.25*SIGMA(3)
      GO TO 630
  620 SIGMA(1) = STRX(IZ)
      SIGMA(2) = STRY(IZ)
      SIGMA(3) = STRS(IZ)
  630 DO 640 IS = 1,3
  640 STRES(ISTRES+1+IS) = SIGMA(IS)
C
C     CALCULATE PRINCIPAL STRESSES
C
      SIGAVG = 0.5*(SIGMA(1) + SIGMA(2))
      PROJ   = 0.5*(SIGMA(1) - SIGMA(2))
      TAUMAX = PROJ*PROJ + SIGMA(3)*SIGMA(3)
CWKBNB 7/94 SPR94004
      IF ( .NOT. OSTRAI ) GO TO 645
      TAUMAX = PROJ*PROJ + SIGMA(3)*SIGMA(3)/4.
      GO TO 649
645   CONTINUE
CWKBNE 7/94 SPR94004
      IF (ABS(TAUMAX) .LE. EPSS) GO TO 650
CWKBI  7/94 SPR94004
649   CONTINUE
      TAUMAX = SQRT(TAUMAX)
      GO TO 660
  650 TAUMAX = 0.0
C
C     PRINCIPAL ANGLE
C
  660 TXY2 = SIGMA(3)*2.0
      PROJ = PROJ*2.0
      IF (ABS(TXY2).LE.EPSA .AND. ABS(PROJ).LE.EPSA) GO TO 670
      STRES(ISTRES+5) = 28.647890*ATAN2(TXY2,PROJ)
      GO TO 680
  670 STRES(ISTRES+5) = 0.0
  680 SIGMA1 = SIGAVG + TAUMAX
      SIGMA2 = SIGAVG - TAUMAX
      STRES(ISTRES+6) = SIGMA1
      STRES(ISTRES+7) = SIGMA2
C
C     OUTPUT VON MISES YIELD STRESS IF ASKED FOR BY THE USER
C
      IF (VONMS) GO TO 690
      STRES(ISTRES+8) = TAUMAX
CWKBI NCL93012 3/94
      IF ( OSTRAI ) STRES(ISTRES+8) = 2.*TAUMAX
      GO TO 720
C
  690 SIGYP = SIGMA1*SIGMA1 + SIGMA2*SIGMA2 - SIGMA1*SIGMA2
      IF (ABS(SIGYP) .LE. EPSS) GO TO 700
      SIGYP = SQRT(SIGYP)
      GO TO 710
  700 SIGYP = 0.0
  710 STRES(ISTRES+8) = SIGYP
C
  720 IG2A = IG2A + 3
  730 ISIG = ISIG + 10
CWKBNB NCL93012 3/94
      DO 733 IAV = 1, 6
      EPSAVG( IAV ) = 0.
733   CONTINUE
CWKBNE NCL93012 3/94
C
C     STAGE 5 - ELEMENT FORCE OUTPUT
C     ==============================
C
  740 IF (LAYER) GO TO 750
CWKBR 3/95 SPR94017     IF (OPRQST .LT. 0) GO TO 790
      IF ( KFORCE .NE. 1 ) GO TO 790
C
  750 CONTINUE
      ISIG   = 0
      VXCNTR = 0.0
      VYCNTR = 0.0
      FXCNTR = 0.0
      FYCNTR = 0.0
      FXYCNT = 0.0
      DO 780 INPLAN = 1,5
      INPLN1 = INPLAN
      IF (INPLAN .EQ. 2) INPLN1 = 4
      IF (INPLAN .EQ. 3) INPLN1 = 2
      IF (INPLAN .EQ. 4) INPLN1 = 3
      THICK = THIKNS(INPLAN)
C
      IFORCE = (INPLN1-1)*9 + 2
C
      IDPONT = IGRID(INPLAN)
      IF (INTGS) IDPONT = INPLN1
      IF (INTGS .AND. INPLAN.EQ.5) IDPONT = CENTER
      NFORS(IFORCE) = IDPONT
C
C     CALCULATE FORCES AT MID-SURFACE LEVEL
C
      DO 760 IFOR = 1,3
      FORSUL(IFORCE+IFOR  )=(TSTR(ISIG+IFOR)+TSTR(ISIG+IFOR+5))*THICK/2.
      FORSUL(IFORCE+IFOR+3)=(TSTR(ISIG+IFOR)-TSTR(ISIG+IFOR+5))*
     1                       REALI(INPLAN)/THICK
  760 CONTINUE
C
C     INTERCHANGE 7 AND 8 POSITIONS TO BE COMPATIBLE WITH THE
C     OUTPUT FORMAT OF VX AND VY (WE HAVE CALCULATED VY AND VX)
C
      IF (INPLAN .EQ. 5) GO TO 770
      FORSUL(IFORCE+7) = (TSTR(ISIG+5) + TSTR(ISIG+10))*THICK*0.5
      FORSUL(IFORCE+8) = (TSTR(ISIG+4) + TSTR(ISIG+ 9))*THICK*0.5
C
C     SUBSTITUTE THE AVERAGE OF CORNER (OR INTEGRATION) POINT
C     MEMBRANE AND SHEAR FORCES FOR THE CENTER POINT
C
      FXCNTR = FXCNTR + FORSUL(IFORCE+1)*0.25
      FYCNTR = FYCNTR + FORSUL(IFORCE+2)*0.25
      FXYCNT = FXYCNT + FORSUL(IFORCE+3)*0.25
      VXCNTR = VXCNTR + FORSUL(IFORCE+7)*0.25
      VYCNTR = VYCNTR + FORSUL(IFORCE+8)*0.25
      GO TO 780
  770 CONTINUE
      FORSUL(IFORCE+1) = FXCNTR
      FORSUL(IFORCE+2) = FYCNTR
      FORSUL(IFORCE+3) = FXYCNT
      FORSUL(IFORCE+7) = VXCNTR
      FORSUL(IFORCE+8) = VYCNTR
C
  780 ISIG = ISIG + 10
C
C     DO NOT WRITE TO PHIOUT IF LAYER STRESSES ARE REQUESTED
C     BECAUSE PHIOUT NEEDS TO BE INTACT
      IF (LAYER) GO TO 900
C
C     STAGE 7 - SHIPPING OF NORMAL STRESSES
C     =====================================
C
C     STORE THE STRESSES WHERE THE HIGHER LEVEL ROUTINES EXPECT
C     TO FIND THEM.
C     BUT FIRST, MOVE THE CENTER POINT STRESSES TO THE TOP.
C
CWKBR 3/95 SPR94017     IF (OPRQST .EQ. 0) GO TO 840     
      IF ( (KSTRS .NE. 1) .AND. (.NOT.OSTRAI) ) GO TO 840     
  790 NPHI(101) = NSTRES(1)
      DO 800 I = 3,18
      I99 = I + 99
  800 NPHI(I99) = NSTRES(I+68)
C
C     DEBUG PRINTOUT
C
      IF (DEBUG) WRITE (NOUT,810) (STRES(I),I=71,86)
  810 FORMAT (' SQUD42 - STRESSES', (/1X,8E13.5))
C
      DO 830 I = 19,86
      I99 = I + 99
  830 NPHI(I99) = NSTRES(I-17)
C
C     STORE FORCES IN THEIR APPROPRIATE LOCATION
C
CWKBR 3/95 SPR94017     IF (OPRQST .LT. 0) RETURN
      IF ( KFORCE .NE. 1 ) RETURN
  840 NPHI(201) = NFORS(1)
      DO 850 I = 3,10
      I199 = I + 199
  850 NPHI(I199) = NFORS(I+36)
C
C     DEBUG PRINTOUT
C
      IF (DEBUG) WRITE (NOUT,860) (FORSUL(I),I=39,46)
  860 FORMAT (' SQUD42 - FORCES', (/1X,8E13.5))
C
      DO 870 I = 11,46
      I199 = I + 199
  870 NPHI(I199) = NFORS(I-9)
C
C     PROCESSING FOR NORMAL STRESS REQUEST COMPLETED
C
      GO TO 2100
C
C     ELEMENT LAYER STRESS CALCULATION
C
C     CHECK STRESS AND FORCE OUTPUT REQUEST
C
  900 IF ((KFORCE.NE.0 .OR. KSTRS.NE.0) .AND. .NOT.COMPOS) GO TO 2220
C
C     WRITE FORCE RESULTANTS TO OEF1L IF REQUESTED
C         1.    10*ELEMENT ID + DEVICE CODE (FDEST)
C        2-9.   FORCE RESULTANTS
C               FX, FY, FXY, MX, MY, MXY, VX, VY
C
      IF (KFORCE .EQ.  0) GO TO 910
      ELEMID = 10*ELID + FDEST
      IF (LDTEMP .NE. -1) GO TO 910
      CALL WRITE (OEF1L,ELEMID,1,0)
      CALL WRITE (OEF1L,FORSUL(39),8,0)
C
  910 IF (KSTRS.EQ.0 .AND. LDTEMP.EQ.-1) RETURN
      ELEMID = 10*ELID + SDEST
C
C     LOCATE PID BY CARRYING OUT A SEQUENTIAL SEARCH
C     OF THE PCOMPS DATA BLOCK, AND ALSO DETERMINE
C     THE TYPE OF 'PCOMP' BULK DATA ENTRY.
C
C     SET POINTER LPCOMP
C
      LPCOMP = IPCMP + NPCMP + NPCMP1 + NPCMP2
C
C
C     POINTER DESCRIPITION
C     --------------------
C     IPCMP  - LOCATION OF START OF PCOMP DATA IN CORE
C     NPCMP  - NUMBER OF WORDS OF PCOMP DATA
C     IPCMP1 - LOCATION OF START OF PCOMP1 DATA IN CORE
C     NPCMP1 - NUMBER OF WORDS OF PCOMP1 DATA
C     IPCMP2 - LOCATION OF START OF PCOMP2 DATA IN CORE
C     NPCMP2 - NUMBER OF WORDS OF PCOMP2 DATA
C
C     ITYPE  - TYPE OF PCOMP BULK DATA ENTRY
C
C     LAMOPT - LAMINATION GENERATION OPTION
C            = SYM  (SYMMETRIC)
C            = MEM  (MEMBRANE )
C            = SYMMEM  (SYMMETRIC-MEMBRANE)
C
C     FTHR   - FAILURE THEORY
C            = 1    HILL
C            = 2    HOFFMAN
C            = 3    TSAI-WU
C            = 4    MAX-STRESS
C            = 5    MAX-STRAIN
C
C     ULTSTN - ULTIMATE STRENGTH VALUES
C
C     SET POINTERS
C
      ITYPE = -1
C
      PCMP  = .FALSE.
      PCMP1 = .FALSE.
      PCMP2 = .FALSE.
C
      PCMP  = NPCMP  .GT. 0
      PCMP1 = NPCMP1 .GT. 0
      PCMP2 = NPCMP2 .GT. 0
C
C     CHECK IF NO 'PCOMP' DATA HAS BEEN READ INTO CORE
C
      IF (.NOT.PCMP .AND. .NOT.PCMP1 .AND. .NOT.PCMP2) GO TO 2200
C
C     SEARCH FOR PID IN PCOMP DATA
C
      IF (.NOT.PCMP) GO TO 960
C
      IP = IPCMP
      IF (INTZ(IP) .EQ. IPID) GO TO 950
      IPC11 = IPCMP1 - 1
      DO 930 IP = IPCMP,IPC11
      IF (INTZ(IP).EQ.-1 .AND. IP.LT.(IPCMP1-1)) GO TO 920
      GO TO 930
  920 IF (INTZ(IP+1) .EQ. IPID) GO TO 940
  930 CONTINUE
      GO TO 960
C
  940 IP = IP + 1
  950 ITYPE = PCOMP
      GO TO 1070
C
C     SEARCH FOR PID IN PCOMP1 DATA
C
  960 IF (.NOT.PCMP1) GO TO 1010
      IP = IPCMP1
      IF (INTZ(IP) .EQ. IPID) GO TO 1000
      IPC21 = IPCMP2 - 1
      DO 980 IP = IPCMP1,IPC21
      IF (INTZ(IP).EQ.-1 .AND. IP.LT.(IPCMP2-1)) GO TO 970
      GO TO 980
  970 IF (INTZ(IP+1) .EQ. IPID) GO TO 990
  980 CONTINUE
      GO TO 1010
C
  990 IP = IP + 1
 1000 ITYPE = PCOMP1
      GO TO 1070
C
C     SEARCH FOR PID IN PCOMP2 DATA
C
 1010 IF (.NOT.PCMP2) GO TO 1060
C
      IP = IPCMP2
      IF (INTZ(IP) .EQ. IPID) GO TO 1050
      LPC11 = LPCOMP - 1
      DO 1030 IP = IPCMP2,LPC11
      IF (INTZ(IP).EQ.-1 .AND. IP.LT.(LPCOMP-1)) GO TO 1020
      GO TO 1030
 1020 IF (INTZ(IP+1) .EQ. IPID) GO TO 1040
 1030 CONTINUE
      GO TO 1060
C
 1040 IP = IP + 1
 1050 ITYPE = PCOMP2
      GO TO 1070
C
C     CHECK IF PID HAS NOT BEEN LOCATED
C
 1060 IF (ITYPE .EQ. -1) GO TO 2200
C
C     LOCATION OF PID
C
 1070 PIDLOC = IP
      LAMOPT = INTZ(PIDLOC+8)
C
C     INTILIZE
C
      DO 1080 IR = 1,3
      STRNT(IR) = 0.0
      STRNB(IR) = 0.0
 1080 CONTINUE
C
C     CALCULATION OF STRAINS
C
C     INTEGRATION DATA IN PHIOUT IS ARRANGED IN ETA,XI INCREASING
C     SEQUENCE.
C
      ISIG   = 1
      ICOUNT = -(8*NDOF+NNODE+32) + 79 + 9*NNODE
C
      DO 1200 INPLAN = 1,5
      INPLN1 = IPN(INPLAN)
C
C     MATCH GRID ID NUMBER WHICH IS IN SIL ORDER
C
      IF (INPLAN .EQ. 5) GO TO 1100
      DO 1090 I = 1,NNODE
      IF (IORDER(I) .NE. INPLN1) GO TO 1090
      IGRID(INPLAN) = EXTRNL(I)
      GO TO 1110
 1090 CONTINUE
      GO TO 1110
C
 1100 IGRID(INPLAN) = CENTER
 1110 CONTINUE
C
      DO 1190 IZTA = 1,2
      ZETA = (IZTA*2-3)*CONST
C
      ICOUNT = ICOUNT + 8*NDOF + NNODE + 32
C
C     FIRST COMPUTE LOCAL STRAINS AT THIS EVALUATION POINT
C
C        EPSLN = PHIOUT(KSIG) * DELTA
C          EPS =        B     *   U
C          8X1        8XNDOF    NDOFX1
C
      KSIG = ICOUNT + NNODE + 33
      CALL GMMATS (PHIOUT(KSIG),8,NDOF,0, DELTA(1),NDOF,1,0, EPSLN)
C
C     TRANSFORM THE STRAINS AT THIS EVALUATION POINT TO THE
C     MATERIAL COORDINATE SYSTEM
C
      DO 1120 IR = 1,9
 1120 TMI(IR) = PHIOUT(ICOUNT+19+IR)
C
C     TOTAL STRAIN AT EVALUATION POINT = MEMBRANE + BENDING
C
      DO 1130 IR = 1,3
 1130 EPSTOT(IR) = EPSLN(IR) + EPSLN(IR+3)
C
C     GENERATE TRANS-MATRIX TO TRANSFORM STRAINS FROM I TO M SYSTEM
C
      TRANS(1)  = TMI(1)*TMI(1)
      TRANS(2)  = TMI(2)*TMI(2)
      TRANS(3)  = TMI(1)*TMI(2)
      TRANS(4)  = TMI(4)*TMI(4)
      TRANS(5)  = TMI(5)*TMI(5)
      TRANS(6)  = TMI(4)*TMI(5)
      TRANS(7)  = 2.0*TMI(1)*TMI(4)
      TRANS(8)  = 2.0*TMI(2)*TMI(5)
      TRANS(9)  = TMI(1)*TMI(5) + TMI(2)*TMI(4)
C
C     TRANSFORM TOTAL STRAINS
C
      CALL GMMATS (TRANS(1),3,3,0, EPSTOT(1),3,1,0, EPSE(1))
C
      IF (INPLAN .EQ. 5) GO TO 1160
C
C     AVERAGE THE STRAIN VECTORS OF THE FOUR INTGS POINTS AT EACH
C     LEVEL TO CALCULATE THE ELEMENT CENTRE STRAIN VECTOR FOR THE
C     UPPER AND BOTTOM LEVELS.
C
      DO 1150 IR = 1,3
      IF (IZTA .EQ. 2) GO TO 1140
      STRNB(IR) = STRNB(IR) + 0.25*EPSE(IR)
      GO TO 1150
 1140 STRNT(IR) = STRNT(IR) + 0.25*EPSE(IR)
 1150 CONTINUE
      GO TO 1190
C
C     TOTAL STRAIN VECTORS AT ELEMENT CENTRE
C
 1160 DO 1180 IR = 1,3
      IF (IZTA .EQ. 2) GO TO 1170
      STRNBC(IR) = EPSE(IR)
      GO TO 1180
 1170 STRNTC(IR) = EPSE(IR)
 1180 CONTINUE
C
 1190 CONTINUE
 1200 CONTINUE
C
C     EXTRAPOLATE STRAINS ACROSS ZETA
C
      DO 1210 IR = 1,3
      EPST(IR) = (STRNT(IR)-STRNB(IR))*(+1.0+CONST)/(2.0*CONST)
     1         +  STRNB(IR)
      EPSB(IR) = (STRNT(IR)-STRNB(IR))*(-1.0+CONST)/(2.0*CONST)
     1         +  STRNB(IR)
 1210 CONTINUE
C
C     CALCULATE LAYER STRESSES AND FAILURE INDICES (IF REQUESTED)
C     AND WRITE TO THE OUTPUT FILE OES1L
C         1.    10*ELEMENT ID + DEVICE CODE (SDEST)
C         2.    NLAYER - NUMBER OF LAYERS FOR LAMINATE
C         3.    TYPE OF FAILURE THEORY SELECTED
C
C         4.    PLY ID
C       5,6,7.  LAYER STRESSES
C         8.    PLY FAILURE INDEX (FP)
C         9.    IFLAG (= 1 IF FP.GE.0.999, DEFAULT = 0)
C       10,11.  INTERLAMINAR SHEAR STRESSES
C        12.    SHEAR BONDING INDEX (SB)
C        13.    IFLAG (= 1 IF SB.GE.0.999, DEFAULT = 0)
C         :     4 - 13 REPEATED FOR THE NUMBER OF LAYERS WITH
C         :           LAYER STRESS REQUEST
C      LAST-1.  MAXIMUM FAILURE INDEX OF LAMINATE  (FIMAX)
C       LAST.   IFLAG (= 1 IF FIMAX.GE.0.999, DEFAULT = 0)
C
C      1-LAST.  REPEAT FOR NUMBER OF ELEMENTS
C
C       (NOTE - ONLY THE ELEMENT CENTRE VALUES ARE CALCULATED)
C
C     == 1.
C
      IF (KSTRS .EQ. 1) CALL WRITE (OES1L,ELEMID,1,0)
C
C     DETERMINE INTRINSIC LAMINATE PROPERTIES
C
C     LAMINATE THICKNESS
C
      TLAM = PHIOUT(21)
C
C     REFERENCE SURFACE
C
      ZREF = -TLAM/2.0
C
C     NUMBER OF LAYERS
C
      NLAY = INTZ(PIDLOC+1)
C
C     FOR PCOMP BULK DATA DETERMINE HOW MANY LAYERS HAVE THE STRESS
C     OUTPUT REQUEST (SOUTI)
C     NOTE - FOR PCOMP1 OR PCOMP2 BULK DATA ENTRIES LAYER
C            STRESSES ARE OUTPUT FOR ALL LAYERS.
C
      NLAYER = NLAY
C
      IF (ITYPE .NE. PCOMP) GO TO 1230
C
      NSTRQT = 0
      DO 1220 K = 1,NLAY
      IF (INTZ(PIDLOC+8+4*K) .EQ. 1) NSTRQT = NSTRQT + 1
 1220 CONTINUE
      NLAYER = NSTRQT
C
C     WRITE TOTAL NUMBER OF LAYERS WITH STRESS REQ TO OES1L
C
 1230 IF (LAMOPT.EQ.SYM .OR. LAMOPT.EQ.SYMMEM) NLAYER = 2*NLAYER
C
C     == 2.
C
      IF (KSTRS .EQ. 1) CALL WRITE (OES1L,NLAYER,1,0)
C
C     SET POINTER
C
      IF (ITYPE .EQ. PCOMP ) IPOINT = PIDLOC + 8 + 4*NLAY
      IF (ITYPE .EQ. PCOMP1) IPOINT = PIDLOC + 8 +   NLAY
      IF (ITYPE .EQ. PCOMP2) IPOINT = PIDLOC + 8 + 2*NLAY
C
C     FAILURE THEORY TO BE USED IN COMPUTING FAILURE INDICES
C
      FTHR = INTZ(PIDLOC+5)
C
C     WRITE TO OUTPUT FILE TYPE OF FAILURE THEORY SELECTED
C
C     == 3.
C
      IF (KSTRS .EQ. 1) CALL WRITE (OES1L,FTHR,1,0)
C
C     SHEAR BONDING STRENGTH
C
      SB     = Z(PIDLOC+4)
      FINDEX = 0.0
      FBOND  = 0.0
      FPMAX  = 0.0
      FBMAX  = 0.0
      FIMAX  = 0.0
C
C     SET TRNFLX IF INTERLAMINAR SHEAR STRESS CALCULATIONS
C     IS REQUIRED
C
      TRNFLX = .FALSE.
C
C     TRANSVERSE SHEAR STRESS RESULTANTS QX AND QY
C
      V(1) = FORSUL(45)
      V(2) = FORSUL(46)
      TRNFLX = V(1).NE.0.0 .AND. V(2).NE.0.0
      IF (.NOT.TRNFLX) GO TO 1240
      IF (ITYPE .EQ. PCOMP) ICONTR = IPOINT + 27*NLAY
      IF (ITYPE.EQ.PCOMP1 .OR. ITYPE.EQ.PCOMP2)
     1    ICONTR = IPOINT + 25 + 2*NLAY
C
C     LAMINATE BENDING INERTIA
C
      EI(1)   = Z(ICONTR+1)
      EI(2)   = Z(ICONTR+2)
C
C     LOCATION OF NEUTRAL SURFACE
C
      ZBAR(1) = Z(ICONTR+3)
      ZBAR(2) = Z(ICONTR+4)
C
C     INTILIZISE
C
 1240 DO 1250 LL = 1,2
      TRNAR(LL)  = 0.0
      TRNSHR(LL) = 0.0
 1250 CONTINUE
C
C     ALLOW FOR THE ORIENTATION OF THE MATERIAL AXIS FROM
C     THE USER DEFINED COORDINATE SYSTEM
C
      THETAE = ACOS(PHIOUT(69))
      THETAE = THETAE*DEGRAD
C
C     SWITCH FOR THEMAL EFFECTS
C
      IF (LDTEMP .EQ. -1) GO TO 1290
C
C     LAMINATE REFERENCE (OR LAMINATION) TEMPERATURE
C
      TSUBO = Z(IPOINT+24)
C
C     MEAN ELEMENT TEMPERATURE
C
      TBAR = TMEAN
      IF (TEMPP1 .OR. TEMPP2) TBAR = STEMP(1)
      IF (LAMOPT.EQ.MEM .OR. LAMOPT.EQ.SYMMEM) GO TO 1290
      IF (.NOT.(TEMPP1 .OR. TEMPP2)) GO TO 1290
      IF (.NOT.TEMPP1) GO TO 1260
C
C     TEMPERATURE GRADIENT TPRIME
C
      TPRIME = STEMP(2)
C
 1260 IF (.NOT.TEMPP2) GO TO 1290
C
C     COMPUTE REFERENCE SURFACE STRAINS AND CURVATURES
C     DUE TO THERMAL MOMENTS
C
C     MOMENT OF INERTIA OF LAMINATE
C
      MINTR = (TLAM**3)/12.0
C
C     DETERMINE ABBD-MATRIX FROM PHIOUT(23-58)
C
      ICOUNT = 89 + 9*NNODE
      DO 1270 LL = 1,3
      DO 1270 MM = 1,3
      NN = MM + 6*(LL-1)
      II = MM + 3*(LL-1)
      ABBD(LL  ,MM  ) = PHIOUT(NN+22)*TLAM
      ABBD(LL  ,MM+3) = PHIOUT(ICOUNT+II)*(TLAM*TLAM)/(-6.0*CONST)
      ABBD(LL+3,MM  ) = PHIOUT(ICOUNT+II)*(TLAM*TLAM)/(-6.0*CONST)
      ABBD(LL+3,MM+3) = PHIOUT(NN+43)*MINTR
 1270 CONTINUE
C
C     COMPUTE THERMAL REF STRAINS AND CURVATURES
C                                   -1
C        EZEROT-VECTOR =  ABBD-MATRIX   X  MTHR-VECTOR
C
      MTHER( 1) = 0.0
      MTHER( 2) = 0.0
      MTHER( 3) = 0.0
      MTHER( 4) = STEMP(2)
      MTHER( 5) = STEMP(3)
      MTHER( 6) = STEMP(4)
C
      CALL INVERS (6,ABBD,6,DUMC,0,DETRM,ISING,INDX)
C
      DO 1280 LL = 1,6
      DO 1280 MM = 1,6
      NN = MM + 6*(LL-1)
      STIFF(NN) = ABBD(LL,MM)
 1280 CONTINUE
C
      CALL GMMATS (STIFF(1),6,6,0, MTHER(1),6,1,0, EZEROT(1))
C
 1290 CONTINUE
C
      DO 1300 LL = 1,6
 1300 FORSUL(LL) = 0.0
C
C     LOOP OVER NLAY
C
      DO 1600 K = 1,NLAY
C
C     ZSUBI -DISTANCE FROM REFERENCE SURFACE TO MID OF LAYER K
C
      ZK1 = ZK
      IF (K .EQ. 1) ZK1 = ZREF
      IF (ITYPE .EQ. PCOMP ) ZK = ZK1 + Z(PIDLOC+6+4*K)
      IF (ITYPE .EQ. PCOMP1) ZK = ZK1 + Z(PIDLOC+7    )
      IF (ITYPE .EQ. PCOMP2) ZK = ZK1 + Z(PIDLOC+7+2*K)
C
      ZSUBI = (ZK+ZK1)/2.0
C
C     LAYER THICKNESS
C
      TI = ZK - ZK1
C
C     CALCULATE STRAIN VECTOR AT STN ZSUBI
C
      DO 1400 IR = 1,3
      EPSLNE(IR) = (.5-ZSUBI/TLAM)*EPSB(IR) + (.5+ZSUBI/TLAM)*EPST(IR)
 1400 CONTINUE
C
C     LAYER ORIENTATION
C
      IF (ITYPE .EQ. PCOMP ) THETA = Z(PIDLOC+7+4*K)
      IF (ITYPE .EQ. PCOMP1) THETA = Z(PIDLOC+8+  K)
      IF (ITYPE .EQ. PCOMP2) THETA = Z(PIDLOC+8+2*K)
C
C     BUILD TRANS-MATRIX TO TRANSFORM LAYER STRAINS FROM MATERIAL
C     TO FIBRE DIRECTION.
C
      THETA = THETA*DEGRAD
C
      C   = COS(THETA)
      C2  = C*C
      S   = SIN(THETA)
      S2  = S*S
C
      TRANS(1)  = C2
      TRANS(2)  = S2
      TRANS(3)  = C*S
      TRANS(4)  = S2
      TRANS(5)  = C2
      TRANS(6)  =-C*S
      TRANS(7)  =-2.0*C*S
      TRANS(8)  = 2.0*C*S
      TRANS(9)  = C2-S2
C
C     TRANSFORM STRAINS FROM ELEMENT TO FIBRE COORD SYSTEM
C
      CALL GMMATS (TRANS(1),3,3,0, EPSLNE(1),3,1,0, EPSLN(1))
C
C     SWITCH FOR TEMPERATURE EFFECTS
C
      IF (LDTEMP .EQ. -1) GO TO 1470
C
C     CORRECT LAYER STRAIN VECTOR FOR THERMAL EFFECTS
C
C     LAYER THERMAL COEFFICIENTS OF EXPANSION ALPHA-VECTOR
C
      DO 1410 LL = 1,3
      ALPHA(LL) = Z(IPOINT+13+LL)
 1410 CONTINUE
C
C     ELEMENT TEMPERATURE
C
      DELT = TBAR - TSUBO
C
      IF (LAMOPT.EQ.MEM .OR. LAMOPT.EQ.SYMMEM) GO TO 1420
      IF (.NOT.TEMPP1) GO TO 1420
C
C     TEMPERATURE GRADIENT TPRIME
C
      DELT = DELT + ZSUBI*TPRIME
C
 1420 DO 1430 LL = 1,3
      EPSLNT(LL) = -ALPHA(LL)*DELT
 1430 CONTINUE
C
      IF (LAMOPT.EQ.MEM .OR. LAMOPT.EQ.SYMMEM) GO TO 1450
      IF (.NOT.TEMPP2) GO TO 1450
C
C     COMPUTE STRAIN DUE TO THERMAL MOMENTS
C
      DO 1440 LL = 1,3
      EPSLNT(LL) = EPSLNT(LL) + (EZEROT(LL) + ZSUBI*EZEROT(LL+3))
 1440 CONTINUE
C
C     COMBINE MECHANICAL AND THERMAL STRAINS
C
 1450 DO 1460 LL = 1,3
      EPSLN(LL) = EPSLN(LL) + EPSLNT(LL)
 1460 CONTINUE
C
 1470 CONTINUE
C
C     CALCULATE STRESS VECTOR STRESL IN FIBRE COORD SYS
C
C     STRESL-VECTOR  =  G-MATRIX  X  EPSLN-VECTOR
C
      CALL GMMATS (Z(IPOINT+1),3,3,0, EPSLN,3,1,0, STRESL(1))
C
C     USE FORCE RESTULANTS CALCULATED PREVIOUSLY
C     I.E. AT EXTREME FIBER STATIONS EXCEPT FOR THERMAL LOADING CASES
C
      IF (LDTEMP .EQ. -1) GO TO 1490
      IF (KFORCE .EQ.  0) GO TO 1490
C
C     TRANSFORM LAYER STRESSES TO ELEMENT AXIS
C
      IF (THETAE .GT. 0.0) THETA = THETA + THETAE
C
C     BUILD STRESS TRANSFORMATION MATRIX
C
      C   = COS(THETA)
      C2  = C*C
      S   = SIN(THETA)
      S2  = S*S
C
      TRANS(1)  = C2
      TRANS(2)  = S2
      TRANS(3)  =-2.0*C*S
      TRANS(4)  = S2
      TRANS(5)  = C2
      TRANS(6)  = 2.0*C*S
      TRANS(7)  = C*S
      TRANS(8)  =-C*S
      TRANS(9)  = C2-S2
C
      CALL GMMATS (TRANS(1),3,3,0, STRESL(1),3,1,0, STRESE(1))
C
      DO 1480 IR = 1,3
      FORSUL(IR) = FORSUL(IR) + STRESE(IR)*TI
      IF (LAMOPT.EQ.MEM .OR. LAMOPT.EQ.SYMMEM) GO TO 1480
      FORSUL(IR+3) = FORSUL(IR+3) - STRESE(IR)*TI*ZSUBI
 1480 CONTINUE
C
 1490 IF (FTHR .LE. 0) GO TO 1530
C
C     WRITE ULTIMATE STRENGTH VALUES TO ULTSTN
C
      DO 1500 IR = 1,6
 1500 ULTSTN(IR) = Z(IPOINT+16+IR)
C
C     CALL FTHR TO COMPUTE FAILURE INDEX FOR PLY
C
      IF (FTHR .EQ. STRAIN) GO TO 1510
      CALL FAILUR (FTHR,ULTSTN,STRESL,FINDEX)
      GO TO 1520
C
 1510 CALL FAILUR (FTHR,ULTSTN,EPSLN,FINDEX)
C
C     DETERMINE THE MAX FAILURE INDEX
C
 1520 IF (ABS(FINDEX) .GE. ABS(FPMAX)) FPMAX = FINDEX
C
 1530 CONTINUE
C
C     SET POINTERS
C
      IF (ITYPE .EQ. PCOMP) ICONTR = IPOINT + 25
      IF (ITYPE.EQ.PCOMP1 .OR. ITYPE.EQ.PCOMP2)
     1    ICONTR = IPOINT + 23 + 2*K
C
      IF (LAMOPT.EQ.MEM .OR. LAMOPT.EQ.SYMMEM) GO TO 1570
      IF (.NOT.TRNFLX) GO TO 1570
C
C     CALCULATE INTERLAMINAR SHEAR STRESSES
C
      DO 1540 IR = 1,2
      TRNAR(IR) = TRNAR(IR) + (Z(ICONTR+IR))*TI*(ZBAR(IR)-ZSUBI)
 1540 CONTINUE
C
C     THE INTERLAMINAR SHEAR STRESSES AT STN ZSUBI
C
      DO 1550 IR = 1,2
      TRNSHR(IR) = V(IR)*TRNAR(IR)/EI(IR)
 1550 CONTINUE
C
C     CALCULATE SHEAR BONDING FAILURE INDEX FB
C     NOTE- SB IS ALWAYS POSITIVE
C
      IF (SB .EQ. 0.0) GO TO 1570
C
      DO 1560 IR = 1,2
      FB(IR) = ABS(TRNSHR(IR))/SB
 1560 CONTINUE
C
      FBOND = FB(1)
      IF (FB(2) .GT. FB(1)) FBOND = FB(2)
C
C     CALCULATE MAX SHEAR BONDING INDEX
C
      IF (FBOND .GE. FBMAX) FBMAX = FBOND
C
 1570 CONTINUE
C
      IF (KSTRS .EQ. 0) GO TO 1590
C
C     WRITE TO OUTPUT FILE THE FOLLOWING
C       4.    PLY (OR LAYER) ID
C     5,6,7.  LAYER STRESSES
C       8.    LAYER FAILURE INDEX
C       9.    IFLAG (= 1 IF FP.GE.0.999, DEFAULT = 0)
C     10,11.  INTERLAMINAR SHEAR STRESSES
C      12.    SHEAR BONDING FAILURE INDEX
C      13.    IFLAG (= 1 IF SB.GE.0.999, DEFAULT = 0)
C
C     CHECK LAYER STRESS OUTPUT REQUEST (SOUTI) FOR PCOMP BULK DATA
C     (NOT SUPPORTED FOR PCOMP1 OR PCOMP2 BULK DATA)
C
      IF (ITYPE .NE. PCOMP) GO TO 1580
      SOUTI = INTZ(PIDLOC+8+4*K)
      IF (SOUTI .EQ. 0) GO TO 1590
 1580 PLYID = K
C
C     == 4.
C
      CALL WRITE (OES1L,PLYID,1,0)
C
C     == 5,6,7.
C
      CALL WRITE (OES1L,STRESL(1),3,0)
C
C     == 8.
C
      CALL WRITE (OES1L,FINDEX,1,0)
C
C     SET IFLAG
C
      IFLAG = 0
      IF (ABS(FINDEX) .GE. 0.999) IFLAG = 1
C
C     == 9.
C
      CALL WRITE (OES1L,IFLAG,1,0)
C
C     == 10,11.
C
      CALL WRITE (OES1L,TRNSHR(1),2,0)
C
C     == 12.
C
      CALL WRITE (OES1L,FBOND,1,0)
C
C     SET IFLAG
C
      IFLAG = 0
      IF (ABS(FBOND) .GE. 0.999) IFLAG = 1
C
C     == 13.
C
      CALL WRITE (OES1L,IFLAG,1,0)
C
C
C     UPDATE IPOINT FOR PCOMP BULK DATA ENTRY
C
 1590 IF (ITYPE.EQ.PCOMP .AND. K.NE.NLAY) IPOINT = IPOINT + 27
C
 1600 CONTINUE
C
C     FALL HERE IF SYMMETRIC OPTION HAS BEEN EXERCISED
C
      IF (LAMOPT.NE.SYM .AND. LAMOPT.NE.SYMMEM) GO TO 2000
C
C     LOOP OVER SYMMETRIC LAYERS
C
      DO 1900 KK = 1,NLAY
      K = NLAY + 1 - KK
C
C     ZSUBI -DISTANCE FROM REFERENCE SURFACE TO MID OF LAYER K
C
      ZK1 = ZK
      IF (ITYPE .EQ. PCOMP ) ZK = ZK1 + Z(PIDLOC+6+4*K)
      IF (ITYPE .EQ. PCOMP1) ZK = ZK1 + Z(PIDLOC+7    )
      IF (ITYPE .EQ. PCOMP2) ZK = ZK1 + Z(PIDLOC+7+2*K)
C
      ZSUBI = (ZK+ZK1)/2.0
C
C     LAYER THICKNESS
C
      TI = ZK - ZK1
C
C     CALCULATE STRAIN VECTOR AT STN ZSUBI
C
      DO 1700 IR = 1,3
      EPSLNE(IR) = (.5-ZSUBI/TLAM)*EPSB(IR) + (.5+ZSUBI/TLAM)*EPST(IR)
 1700 CONTINUE
C
C     LAYER ORIENTATION
C
      IF (ITYPE .EQ. PCOMP ) THETA = Z(PIDLOC+7+4*K)
      IF (ITYPE .EQ. PCOMP1) THETA = Z(PIDLOC+8+  K)
      IF (ITYPE .EQ. PCOMP2) THETA = Z(PIDLOC+8+2*K)
C
C     BUILD TRANS-MATRIX TO TRANSFORM LAYER STRAINS FROM MATERIAL
C     TO FIBRE DIRECTION.
C
      THETA = THETA*DEGRAD
      C   = COS(THETA)
      C2  = C*C
      S   = SIN(THETA)
      S2  = S*S
C
      TRANS(1)  = C2
      TRANS(2)  = S2
      TRANS(3)  = C*S
      TRANS(4)  = S2
      TRANS(5)  = C2
      TRANS(6)  =-C*S
      TRANS(7)  =-2.0*C*S
      TRANS(8)  = 2.0*C*S
      TRANS(9)  = C2 - S2
C
C     TRANSFORM STRAINS FROM MATERIAL TO FIBRE COORD SYSTEM
C
      CALL GMMATS (TRANS(1),3,3,0, EPSLNE(1),3,1,0, EPSLN(1))
C
C     SWITCH FOR TEMPERATURE EFFECTS
C
      IF (LDTEMP .EQ. -1) GO TO 1770
C
C     CORRECT LAYER STRAIN VECTOR FOR THERMAL EFFECTS
C
C     LAYER THERMAL COEFFICIENTS OF EXPANSION ALPHA-VECTOR
C
      DO 1710 LL = 1,3
      ALPHA(LL) = Z(IPOINT+13+LL)
 1710 CONTINUE
C
C     ELEMENT TEMPERATURE
C
      DELT = TBAR - TSUBO
      IF (LAMOPT .EQ. SYMMEM) GO TO 1720
      IF (.NOT.TEMPP1) GO TO 1720
C
C     TEMPERATURE GRADIENT TPRIME
C
      DELT = DELT + ZSUBI*TPRIME
C
 1720 DO 1730 LL = 1,3
      EPSLNT(LL) = -ALPHA(LL)*DELT
 1730 CONTINUE
C
      IF (LAMOPT .EQ. SYMMEM) GO TO 1750
      IF (.NOT.TEMPP2) GO TO 1750
C
C     COMPUTE STRAIN DUE TO THERMAL MOMENTS
C
      DO 1740 LL = 1,3
      EPSLNT(LL) = EPSLNT(LL) + (EZEROT(LL) + ZSUBI*EZEROT(LL+3))
 1740 CONTINUE
C
C     COMBINE MECHANICAL AND THERMAL STRAINS
C
 1750 DO 1760 LL = 1,3
      EPSLN(LL)  = EPSLN(LL) + EPSLNT(LL)
 1760 CONTINUE
C
 1770 CONTINUE
C
C     CALCULATE STRESS VECTOR STRESL IN FIBRE COORD SYS
C
C     STRESL-VECTOR =  G-MATRIX  X  EPSLN-VECTOR
C
      CALL GMMATS (Z(IPOINT+1),3,3,0, EPSLN,3,1,0, STRESL(1))
C
C     COMPUTE FORCE RESULTANTS IF REQUESTED
C
      IF (LDTEMP .EQ. -1) GO TO 1790
      IF (KFORCE .EQ.  0) GO TO 1790
C
C     TRANSFORM LAYER STRESSES TO ELEMENT AXIS
C
      IF (THETAE .GT. 0.0) THETA = THETA + THETAE
C
C     BUILD STRESS TRANSFORMATION MATRIX
C
      C   = COS(THETA)
      C2  = C*C
      S   = SIN(THETA)
      S2  = S*S
C
      TRANS(1)  = C2
      TRANS(2)  = S2
      TRANS(3)  =-2.0*C*S
      TRANS(4)  = S2
      TRANS(5)  = C2
      TRANS(6)  = 2.0*C*S
      TRANS(7)  = C*S
      TRANS(8)  =-C*S
      TRANS(9)  = C2 - S2
C
      CALL GMMATS (TRANS(1),3,3,0, STRESL(1),3,1,0, STRESE(1))
C
      DO 1780 IR = 1,3
      FORSUL(IR) = FORSUL(IR) + STRESE(IR)*TI
      IF (LAMOPT .EQ. SYMMEM) GO TO 1780
      FORSUL(IR+3) = FORSUL(IR+3) - STRESE(IR)*TI*ZSUBI
 1780 CONTINUE
C
 1790 IF (FTHR .LE. 0) GO TO 1830
C
C     WRITE ULTIMATE STRENGTH VALUES TO ULTSTN
C
      DO 1800 IR = 1,6
 1800 ULTSTN(IR) = Z(IPOINT+16+IR)
C
C     CALL FTHR TO COMPUTE FAILURE INDEX FOR PLY
C
      IF (FTHR .EQ. STRAIN) GO TO 1810
      CALL FAILUR (FTHR,ULTSTN,STRESL,FINDEX)
      GO TO 1820
C
 1810 CALL FAILUR (FTHR,ULTSTN,EPSLN,FINDEX)
C
C     DETERMINE THE MAX FAILURE INDEX
C
 1820 IF (ABS(FINDEX) .GE. ABS(FPMAX)) FPMAX = FINDEX
C
 1830 CONTINUE
C
C     SET POINTERS
C
      IF (ITYPE .EQ. PCOMP) ICONTR = IPOINT + 25
      IF (ITYPE.EQ.PCOMP1 .OR. ITYPE.EQ.PCOMP2)
     1    ICONTR = IPOINT + 23 + 2*K
C
      IF (LAMOPT .EQ. SYMMEM) GO TO 1870
      IF (.NOT.TRNFLX) GO TO 1870
C
C     CALCULATE INTERLAMINAR SHEAR STRESSES
C
      DO 1840 IR = 1,2
      TRNAR(IR) = TRNAR(IR) + (Z(ICONTR+IR))*TI*(ZBAR(IR)-ZSUBI)
 1840 CONTINUE
C
C     THE INTERLAMINAR SHEAR STRESSES AT STN ZSUBI
C
      DO 1850 IR = 1,2
      TRNSHR(IR) = V(IR)*TRNAR(IR)/EI(IR)
 1850 CONTINUE
C
C     CALCULATE SHEAR BONDING FAILURE INDEX FB
C     NOTE- SB IS ALWAYS POSITIVE
C
      IF (SB .EQ. 0.0) GO TO 1870
C
      DO 1860 IR = 1,2
      FB(IR) = ABS(TRNSHR(IR))/SB
 1860 CONTINUE
C
      FBOND = FB(1)
      IF (FB(2) .GT. FB(1)) FBOND = FB(2)
C
C     CALCULATE MAX SHEAR BONDING INDEX
C
      IF (FBOND .GE. FBMAX) FBMAX = FBOND
C
 1870 CONTINUE
C
      IF (KSTRS .EQ. 0) GO TO 1890
C
C     WRITE TO OUTPUT FILE THE FOLLOWING
C       4.     PLY (OR LAYER) ID
C     5,6,7.   LAYER STRESSES
C       8.     LAYER FAILURE INDEX
C       9.     IFLAG (= 1 IF FP.GE.0.999, DEFAULT = 0)
C     10,11.   INTERLAMINAR SHEAR STRESSES
C      12.     SHEAR BONDING FAILURE INDEX
C      13.     IFLAG (= 1 IF SB.GE.0.999, DEFAULT = 0)
C
C     CHECK LAYER STRESS OUTPUT REQUEST (SOUTI) FOR PCOMP BULK DATA
C     (NOT SUPPORTED FOR PCOMP1 OR PCOMP2 BULK DATA)
C
      IF (ITYPE .NE. PCOMP) GO TO 1880
      SOUTI = INTZ(PIDLOC+8+4*K)
      IF (SOUTI .EQ. 0) GO TO 1890
 1880 PLYID = NLAY + KK
C
C     == 4.
C
      CALL WRITE (OES1L,PLYID,1,0)
C
C     == 5,6,7
C
      CALL WRITE (OES1L,STRESL(1),3,0)
C
C     == 8.
C
      CALL WRITE (OES1L,FINDEX,1,0)
C
C     SET IFLAG
C
      IFLAG = 0
      IF (ABS(FINDEX) .GE. 0.999) IFLAG = 1
C
C     == 9.
C
      CALL WRITE (OES1L,IFLAG,1,0)
C
C     == 10,11.
C
      CALL WRITE (OES1L,TRNSHR(1),2,0)
C
C     == 12.
C
      CALL WRITE (OES1L,FBOND,1,0)
C
C     SET IFLAG
C
      IFLAG = 0
      IF (ABS(FBOND) .GE. 0.999) IFLAG = 1
C
C     == 13.
C
      CALL WRITE (OES1L,IFLAG,1,0)
C
C     UPDATE IPOINT FOR PCOMP BULK DATA ENTRY
C
 1890 IF (ITYPE .EQ. PCOMP) IPOINT = IPOINT - 27
 1900 CONTINUE
C
 2000 IF (FTHR .LE. 0) GO TO 2010
C
C     DETERMINE 'FIMAX' THE MAX FAILURE INDEX FOR THE LAMINATE
C
      FIMAX = FPMAX
      IF (FBMAX .GT. ABS(FPMAX)) FIMAX = FBMAX
C
C     == LAST-1.
C
 2010 IF (KSTRS .EQ. 1) CALL WRITE (OES1L,FIMAX,1,0)
C
      IFLAG = 0
      IF (ABS(FIMAX) .GE. 0.999) IFLAG = 1
C
C     == LAST.
C
      IF (KSTRS .EQ. 1) CALL WRITE (OES1L,IFLAG,1,0)
C
      IF (KFORCE .EQ.  0) GO TO 2100
      IF (LDTEMP .EQ. -1) GO TO 2100
      CALL WRITE (OEF1L,ELEMID,1,0)
      CALL WRITE (OEF1L,FORSUL(1),6,0)
      CALL WRITE (OEF1L,FORSUL(45),2,0)
C
 2100 RETURN
C
C     ERROR MESSAGES
C
 2200 WRITE  (NOUT,2210) UWM
 2210 FORMAT (A25,' - NO PCOMP, PCOMP1 OR PCOMP2 DATA AVAILABLE FOR ',
     1       'LAYER STRESS RECOVERY BY SUBROUTINE SQUD42.')
      GO TO 2100
 2220 WRITE  (NOUT,2230) UFM
 2230 FORMAT (A23,', LAYER STRESS OR FORCE RECOVERY WAS REQUESTED WHILE'
     1,      ' PROBLEM WAS NOT SET UP FOR', /5X,'LAYER COMPUTATION')
      CALL MESAGE (-61,0,0)
      END

        SUBROUTINE DSWRT1 ( IDATA )
      INCLUDE 'DSIOF.COM'
      INCLUDE 'XNSTRN.COM'
        INTEGER IDATA( 2 )
        INEXT = 0
        IF ( LWORDS .LE. -1 ) GO TO 50
        IF ( NBLOCK .EQ. IBLOCK ) GO TO 10
        IFLG = IDSX
        GO TO 20
10      IFLG = IDSP
20      IF ( LWORDS .LE. 0 ) GO TO 40
        ICOUNT = IAND( IBASE( INDCLR ), MASKH2 )
        IBASE( INDCLR ) = IDSRH + IFLG + ICOUNT + LWORDS
        DO 30 I = 1, LWORDS
        IBASE( INDCBP + I ) = IDATA( I )
30      CONTINUE
        INDCBP = INDCBP + LWORDS + 1
        IBASE( INDCBP ) = IDSRT + IFLG + ( INDCLR-INDBAS+1 )
        INDCLR = INDCBP + 1
        IBASE( INDCBP+1 ) = IDSEB
        IFLG   = IDSX
        GO TO 60
40      IBASE( INDCLR ) = IAND( IBASE( INDCLR ), NOT( MASKQ2 ) )
        IBASE( INDCLR ) = IOR( IFLG, IBASE( INDCLR ) )
        IBASE( INDCBP+1 ) = IDSRT + IFLG + ( INDCLR-INDBAS+1 )
        IBASE( INDCBP+2 ) = IDSEB
        LWORDS = 0
        INDCLR = INDCBP + 2
        INDCBP = INDCLR
        IFLG   = IDSX
        GO TO 60
50      IBASE( INDCLR ) = IDSEB
        LWORDS = 0
        IFLG    = IDSX
        IF ( IBLOCK .EQ. NBLOCK ) IFLG = IDSC
60      CALL DSWRNB
        IRWORDS = NWORDS - LWORDS
        INEXT   = INEXT + LWORDS
70      IF ( IRWORDS .GT. ( NBUFF-5 ) ) GO TO 80
        IFIN    = 1
        NWORDS  = IRWORDS
        GO TO 90
80      IFIN    = 0
        IF ( IFLG .EQ. IDSC ) IFLG = IDSP
        NWORDS  = NBUFF - 5
90      IBASE( INDCLR ) = IDSRH + IFLG + NWORDS
        DO 100 I = 1, NWORDS
        IBASE( INDCBP+I ) = IDATA( INEXT+I )
100     CONTINUE
        INDCBP = INDCBP + NWORDS
        IF ( IFIN .EQ. 1 ) GO TO 110
        INEXT  = INEXT + NWORDS
        IBASE( INDCBP+1 ) = IDSRT + IFLG + ( INDCLR-INDBAS+1 )
        IBASE( INDCBP+2 ) = IDSEB
        IRWORDS = IRWORDS - NWORDS
        IFLG   = IDSX
        INDCLR  = INDCLR + NWORDS + 2
        CALL DSWRNB
        GO TO 70
110     IF ( IEOR .EQ. 0 ) GO TO 120
        IBASE( INDCBP+1 ) = IDSRT + IDSC + ( INDCLR-INDBAS+1 )
        INDCLR = INDCBP + 2
        INDCBP = INDCLR
120     RETURN
        END

      SUBROUTINE DSHXDD ( II,IARR, LEN)
      INTEGER    IARR( 10000)
      COMMON / DSBUFF / IIBUFF(2048)
      DO 10 K = 1, LEN
10    IIBUFF(K) = IARR(K)
      WRITE ( 6, 901 ) II,(IIBUFF(I),I=1,LEN )
901   FORMAT(I5,200(8(1X,Z8),/))
      RETURN
      END

      INTEGER FUNCTION FORFIL (NAME)
C
C     FORFIL RETURNS THE LOGICAL UNIT TO WHICH NAME IS ASSIGNED.
C
      EXTERNAL        ANDF
      INTEGER         ANDF    ,EXFIAT,FIAT  ,FIST  ,SYSOUT
      CHARACTER       UFM*23  ,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG / UFM     ,UWM   ,UIM   ,SFM
      COMMON /SYSTEM/ SYSBUF  ,SYSOUT
      COMMON /XXFIAT/ EXFIAT(1)
      COMMON /XFIAT / FIAT(1)
      COMMON /XFIST / MFIST   ,NFIST ,FIST(1)
C
C     SEARCH FIST FOR NAME. ERROR IF NOT FOUND.
C
      NN = 2*NFIST - 1
      DO 2001 I = 1,NN,2
      IF (FIST(I) .EQ. NAME) GO TO 2010
 2001 CONTINUE
      WRITE  (SYSOUT,2002) SFM,NAME,NAME
 2002 FORMAT (A25,' 2179, ERROR DETECTED IN FUNCTION FORFIL',A4,I4,
     1       ' NOT IN FIST.')
      CALL MESAGE (-61,0,0)
      FORFIL = 0
      RETURN
C
C     PICK UP UNIT FROM /XXFIAT/ OR /XFIAT/ AND RETURN.
C
 2010 J = FIST(I+1)
      IF (J) 2013,2014,2015
 2013 J = -J
 2014 FORFIL = ANDF(EXFIAT(J+1),32767)
      RETURN
 2015 FORFIL = ANDF(FIAT(J+1),32767)
      RETURN
      END

      SUBROUTINE MCE1C
C
C     MCE1C PERFORMS A FORWARD-BACKWARD SUBSTITUTION WITH THE
C     TRIANGULAR FACTORS OF RM TO SOLVE FOR GM IN THE EQUATION
C     RM*GM = -RN.
C
C
      INTEGER USET  , RG    ,GM    ,SCR1  ,SCR2  ,SCR3  ,RM    ,RN     ,
     1        U     , UX    ,RNX   ,GMX   ,PREC  ,SIGN
      COMMON /BLANK / USET  ,RG    ,GM    ,SCR1  ,SCR2  ,SCR3  ,RM    ,
     1                RN    ,L     ,U     ,MCB(7)
      COMMON /GFBSX / LX (7),UX (7), RNX(7),GMX(7),NZ   ,PREC  ,SIGN
      COMMON /ZZZZZZ/ Z(1)
      COMMON /SYSTEM/ KSYSTM(65)
      EQUIVALENCE     (KSYSTM(55),IPREC)
C
C     INITIALIZE MATRIX CONTROL BLOCKS
C
      NZ = KORSZ(Z)
      LX(1)  = L
      CALL RDTRL (LX)
      UX(1)  = U
      CALL RDTRL (UX)
      RNX(1) = RN
      CALL RDTRL (RNX)
      GMX(1) = GM
      GMX(3) = RNX(3)
      GMX(4) = RNX(4)
      GMX(5) = IPREC
      PREC   = IPREC
      SIGN   =-1
C
C     PERFORM SOLUTION
C
      CALL GFBS (Z,Z)
C
C     WRITE TRAILER
C
      CALL WRTTRL (GMX)
      RETURN
      END

      SUBROUTINE STPAX2 (SORC,TI)
C
C     THIS ROUTINE IS PHASE II OF STRESS RECOVERY FOR THE TRAPEZOIDAL
C     CROSS SECTION RING
C
C     OUTPUTS FROM PHASE I ARE THE FOLLOWING..
C     IDEL, IGP(4), TZ, SEL(360), TS(06), AK(144), PHI(14)
C     AKUPH(48), AKPH2(16), SELP1(120), SELP2(180), SELP3(60)
C
C     ANY GROUP OF STATEMENTS PREFACED BY AN IF STATEMENT CONTAINING
C     ...KSYS78 OR LSYS78 ...  INDICATES CODING NECESSARY FOR THIS
C     ELEMENT*S PIEZOELECTRIC CAPABILITY
C
C     KSYS78 = 0   ELASTIC, NON-PIEZOELECTRIC MATERIAL
C     KSYS78 = 1   ELECTRICAL-ELASTIC COUPLED, PIEZOELETRIC MATERIAL
C     KSYS78 = 2   ELASTIC ONLY, PIEZOELECTRIC MATERIAL
C     LSYS78 = .TRUE. IF KSYS78 = 0, OR 2
C
      LOGICAL         ZERO,ZERON,LSYS78
      INTEGER         SORC,IBLOCK(62,14),ISTRES(100),IFORCE(25),ELEMID,
     1                ICLOCK(62,14)
      REAL            NPHI
      DIMENSION       TI(4),DUM3(225),STRES(100),FORCE(25),AKUPH(48),
     1                AKPH2(16),SELP1(120),SELP2(180),SELP3(60),D4(4),
     2                D15(15),D30(30),DISPP(4),ECHRG(4),EFLUX(15)
C
C     SDR2 VARIABLE CORE
C
      COMMON /ZZZZZZ/ ZZ(1)
C
C     SDR2 BLOCK FOR POINTERS AND LOADING  TEMPERATURES
C
      COMMON /SDR2X4/ DUM1(33),ICSTM,NCSTM,IVEC,IVECN,TEMPLD,ELDEFM,
     1                DUM4(12),KTYPE
C
C     SCRATCH BLOCK
C
      COMMON /SDR2X8/ DISP(12),EFORC(12),ESTRES(30),HARM,N,SINPHI,
     1                CONPHI,NPHI,NANGLE,ELEMID,UNU(93),NELHAR,KANGLE,
     2                KLEMID
C
C     SDR2 INPUT AND OUTPUT BLOCK
C
      COMMON /SDR2X7/ IDEL,IGP(4),TZ,SEL(360),TS(6),AK(144),PHI(14),
     1                DUM2(424),BLOCK(62,14),CLOCK(62,14)
C
      COMMON /SYSTEM/ KSYSTM(77),KSYS78
      COMMON /SDR2DE/ DUM5(33), IPART
      COMMON /CONDAS/ CONSTS(5)
      EQUIVALENCE     (IBLOCK(1,1),BLOCK(1,1)),(ICLOCK(1,1),CLOCK(1,1)),
     1                (DUM3(1),IDEL),(DUM3(101),STRES(1),ISTRES(1)),
     2                (DUM3(201),FORCE(1),IFORCE(1)),(CONSTS(4),DEGRAD),
     3                (LDTEMP,TEMPLD),(DUM2(1),AKUPH(1)),
     4                (DUM2(49),AKPH2(1)),(DUM2(65),SELP1(1)),
     5                (DUM2(185),SELP2(1)),(DUM2(365),SELP3(1)),
     6                (UNU(1),D4(1)),(UNU(5),D15(1)),(UNU(20),D30(1))
      DATA    ZERON / .FALSE. /
      DATA    IOSORC/ 0       /
C
      ELEMID = IDEL / 1000
      NELHAR = IDEL - ELEMID*1000
      KLEMID = ELEMID
      LSYS78 =.FALSE.
      IF (KSYS78.EQ.0 .OR. KSYS78.EQ.2) LSYS78 = .TRUE.
C
C     SET BLOCK = 0 IF HARMONIC = 0
C
      N = NELHAR - 1
      IF (N .NE. 0) GO TO 21
      IF (N.EQ.0 .AND. ZERON .AND. IOSORC .NE. SORC) GO TO 14
      ZERON  = .TRUE.
      IOSORC = SORC
      DO 15 I = 2,62
      DO 15 J = 1,14
      IF (KTYPE.NE.2 .OR. IPART.NE.2) BLOCK(I,J) = 0.0
      CLOCK(I,J) = 0.0
   15 CONTINUE
C
C     SET ANGLES CONTROL FOR SUMMATION
C
      ZERO = .FALSE.
      J = 0
      DO 16 I = 1,14
      IF (PHI(I)) 17,18,17
   18 IF (ZERO) GO TO 16
      ZERO = .TRUE.
   17 J = J + 1
      BLOCK(1,J) = PHI(I)
      CLOCK(1,J) = PHI(I)
   16 CONTINUE
      J = J + 1
      IF (J .GT. 14) GO TO 21
      IBLOCK(1,J) = 1
      ICLOCK(1,J) = 1
      GO TO 21
   14 ZERON = .FALSE.
   21 HARM  = N
C
C     INITIALIZE LOCAL VARIABLES
C
      NDOF  = 3
      NUMPT = 4
      N     = NDOF*NUMPT
      NSP   = 5
      NCOMP = 6
      NS    = NSP*NCOMP
C
C     FIND GRID POINTS DISPLACEMENTS
C
      K = 0
      DO 100 I = 1,NUMPT
      ILOC = IVEC + IGP(I) - 2
C
      IF (LSYS78) GO TO 90
      ILOCP = ILOC + 4
      DISPP(I) = ZZ(ILOCP)
   90 CONTINUE
C
      DO 100 J = 1,NDOF
      ILOC = ILOC + 1
      K = K + 1
      DISP(K) = ZZ(ILOC)
  100 CONTINUE
C
C     COMPUTE THE GRID POINT FORCES
C
      CALL GMMATS (AK(1),N,N,0, DISP(1),N,1,0, EFORC(1))
C
      DO 109 I = 1,4
  109 ECHRG(I) = 0.0
C
      IF (LSYS78) GO TO 125
      CALL GMMATS (AKUPH(1),N,NUMPT,0, DISPP(1),NUMPT,1,0, D15(1))
      DO 110 I = 1,12
  110 EFORC(I) = EFORC(I) + D15(I)
C
      CALL GMMATS (AKUPH(1),N,NUMPT,1, DISP(1),N,1,0, D4(1))
      CALL GMMATS (AKPH2(1),NUMPT,NUMPT,0, DISPP(1),NUMPT,1,0, ECHRG(1))
      DO 120 I = 1,4
  120 ECHRG(I) = ECHRG(I) + D4(I)
  125 CONTINUE
C
C     COMPUTE THE STRESSES
C
      CALL GMMATS (SEL(1),NS,N,0, DISP(1),N,1,0, ESTRES(1))
C
      DO 129 I = 1,15
  129 EFLUX(I) = 0.0
C
      IF (LSYS78) GO TO 145
      CALL GMMATS (SELP1(1),NS,NUMPT,0, DISPP(1),NUMPT,1,0, D30(1))
      DO 130 I = 1,30
  130 ESTRES(I) = ESTRES(I) + D30(I)
C
      CALL GMMATS (SELP2(1),15,N,0, DISP(1),N,1,0, EFLUX(1))
      CALL GMMATS (SELP3(1),15,NUMPT,0, DISPP(1),NUMPT,1,0, D15(1))
      DO 140 I = 1,15
  140 EFLUX(I) = EFLUX(I) + D15(I)
  145 CONTINUE
C
C     COMPUTE THERMAL STRESS IF IT IS EXISTS
C
      IF (LDTEMP .EQ. -1) GO TO 300
      K = 0
      T = TZ
      IF (HARM .GT. 0.0) T = 0.0
      DO 200 I = 1,NSP
      DT = TI(I) - T
      IF (I .EQ. 5) DT = (TI(1)+TI(2)+TI(3)+TI(4))/4.0 - T
      DO 200 J = 1,NCOMP
      K = K + 1
      ESTRES(K) = ESTRES(K) - DT*TS(J)
  200 CONTINUE
  300 CONTINUE
C
C     BRANCH TO INSERT HARMONIC STRESSES AND FORCES INTO BLOCK OR CLOCK
C
C     KTYPE = 1 - REAL OUTPUT, STORED IN BLOCK, NOTHING IN CLOCK
C     KTYPE = 2 - COMPLEX OUTPUT
C     IPART = 1 - IMAGINARY PART OF COMPLEX OUTPUT, STORED IN BLOCK
C     IPART = 2 - REAL PART OF COMPLEX OUTPUT, STORED IN CLOCK
C
      IF (KTYPE.EQ.2 .AND. IPART.EQ.2) GO TO 550
C
C     INSERT HARMONIC STRESSES AND FORCES INTO BLOCK
C
      DO 370 I = 1,14
      IF (IBLOCK(1,I) .EQ. 1) GO TO 380
      IF (HARM .EQ. 0.0) GO TO 350
      NPHI   = HARM*BLOCK(1,I)*DEGRAD
      SINPHI = SIN(NPHI)
      CONPHI = COS(NPHI)
      GO TO (330,310), SORC
C
  310 CONTINUE
      DO 315 IE = 1,5
      KE   = 9*(IE-1)
      KEPZ = 6*(IE-1)
      BLOCK(2+KE,I) = BLOCK(2+KE,I) + CONPHI*ESTRES(1+KEPZ)
      BLOCK(3+KE,I) = BLOCK(3+KE,I) + CONPHI*ESTRES(2+KEPZ)
      BLOCK(4+KE,I) = BLOCK(4+KE,I) + CONPHI*ESTRES(3+KEPZ)
      BLOCK(5+KE,I) = BLOCK(5+KE,I) + CONPHI*ESTRES(4+KEPZ)
      BLOCK(6+KE,I) = BLOCK(6+KE,I) + SINPHI*ESTRES(5+KEPZ)
      BLOCK(7+KE,I) = BLOCK(7+KE,I) + SINPHI*ESTRES(6+KEPZ)
C
      IF (LSYS78) GO TO 315
      KEPZ2 = KEPZ/2
      BLOCK( 8+KE,I) = BLOCK( 8+KE,I) + CONPHI*EFLUX (1+KEPZ2)
      BLOCK( 9+KE,I) = BLOCK( 9+KE,I) + CONPHI*EFLUX (2+KEPZ2)
      BLOCK(10+KE,I) = BLOCK(10+KE,I) + SINPHI*EFLUX (3+KEPZ2)
  315 CONTINUE
C
      DO 320 IR = 1,4
      KR   = 4*(IR-1)
      KRPZ = 3*(IR-1)
      BLOCK(47+KR,I) = BLOCK(47+KR,I) + CONPHI*EFORC(1+KRPZ)
      BLOCK(48+KR,I) = BLOCK(48+KR,I) + SINPHI*EFORC(2+KRPZ)
      BLOCK(49+KR,I) = BLOCK(49+KR,I) + CONPHI*EFORC(3+KRPZ)
      KR3 = 1 + KRPZ/3
      IF(.NOT.LSYS78) BLOCK(50+KR,I) = BLOCK(50+KR,I) +CONPHI*ECHRG(KR3)
  320 CONTINUE
      GO TO 370
C
  330 CONTINUE
      DO 335 IE = 1,5
      KE   = 9*(IE-1)
      KEPZ = 6*(IE-1)
      BLOCK(2+KE,I) = BLOCK(2+KE,I) + SINPHI*ESTRES(1+KEPZ)
      BLOCK(3+KE,I) = BLOCK(3+KE,I) + SINPHI*ESTRES(2+KEPZ)
      BLOCK(4+KE,I) = BLOCK(4+KE,I) + SINPHI*ESTRES(3+KEPZ)
      BLOCK(5+KE,I) = BLOCK(5+KE,I) + SINPHI*ESTRES(4+KEPZ)
      BLOCK(6+KE,I) = BLOCK(6+KE,I) - CONPHI*ESTRES(5+KEPZ)
      BLOCK(7+KE,I) = BLOCK(7+KE,I) - CONPHI*ESTRES(6+KEPZ)
C
      IF (LSYS78) GO TO 335
      KEPZ2 = KEPZ/2
      BLOCK( 8+KE,I) = BLOCK( 8+KE,I) + SINPHI*EFLUX(1+KEPZ2)
      BLOCK( 9+KE,I) = BLOCK( 9+KE,I) + SINPHI*EFLUX(2+KEPZ2)
      BLOCK(10+KE,I) = BLOCK(10+KE,I) - CONPHI*EFLUX(3+KEPZ2)
  335 CONTINUE
C
      DO 340 IR = 1,4
      KR   = 4*(IR-1)
      KRPZ = 3*(IR-1)
      BLOCK(47+KR,I) = BLOCK(47+KR,I) + SINPHI*EFORC(1+KRPZ)
      BLOCK(48+KR,I) = BLOCK(48+KR,I) - CONPHI*EFORC(2+KRPZ)
      BLOCK(49+KR,I) = BLOCK(49+KR,I) + SINPHI*EFORC(3+KRPZ)
      KR3 = 1 + KRPZ/3
      IF(.NOT.LSYS78) BLOCK(50+KR,I) = BLOCK(50+KR,I) +SINPHI*ECHRG(KR3)
  340 CONTINUE
      GO TO 370
C
  350 DO 355 IE = 1,5
      KE   = 9*(IE-1)
      KEPZ = 6*(IE-1)
      BLOCK(2+KE,I) = ESTRES(1+KEPZ)
      BLOCK(3+KE,I) = ESTRES(2+KEPZ)
      BLOCK(4+KE,I) = ESTRES(3+KEPZ)
      BLOCK(5+KE,I) = ESTRES(4+KEPZ)
      BLOCK(6+KE,I) = ESTRES(5+KEPZ)
      BLOCK(7+KE,I) = ESTRES(6+KEPZ)
C
      IF (LSYS78) GO TO 355
      KEPZ2 = KEPZ/2
      BLOCK( 8+KE,I) = EFLUX(1+KEPZ2)
      BLOCK( 9+KE,I) = EFLUX(2+KEPZ2)
      BLOCK(10+KE,I) = EFLUX(3+KEPZ2)
  355 CONTINUE
C
      DO 360 IR = 1,4
      KR   = 4*(IR-1)
      KRPZ = 3*(IR-1)
      BLOCK(47+KR,I) = EFORC(1+KRPZ)
      BLOCK(48+KR,I) = EFORC(2+KRPZ)
      BLOCK(49+KR,I) = EFORC(3+KRPZ)
      KR3 = 1 + KRPZ/3
      IF(.NOT.LSYS78) BLOCK(50+KR,I) = ECHRG(KR3)
  360 CONTINUE
C
  370 CONTINUE
C
C     COPY STRESSES AND FORCES INTO OUTPUT BLOCKS
C
  380 CONTINUE
      J = 2
      K = 1
      L = 0
      ISTRES (1) = ELEMID
      ISTRES (2) = NELHAR
      DO 400 I = 1,NS
      J = J + 1
      STRES(J) = ESTRES(I)
C
      IF (I/6 .NE. K) GO TO 400
      K = K + 1
      DO 390 II = 1,3
      J = J + 1
      L = L + 1
      STRES(J) = EFLUX(L)
  390 CONTINUE
C
  400 CONTINUE
      K = 0
      J = 2
      L = 1
      IFORCE(1) = ELEMID
      IFORCE(2) = NELHAR
      DO 500 I  = 1,NUMPT
      DO 500 KK = 1,NDOF
      J = J + 1
      K = K + 1
      FORCE(J) = EFORC(K)
C
      IF (K/3 .NE. L) GO TO 500
      J = J + 1
      FORCE(J) = ECHRG(L)
      L = L + 1
C
  500 CONTINUE
C
      IF (KTYPE.EQ.1 .OR. (KTYPE.EQ.2 .AND. IPART.EQ.1)) GO TO 1001
  550 CONTINUE
C
C     INSERT HARMONIC STRESSES AND FORCES INTO CLOCK
C
      DO 690 I = 1,14
      IF (ICLOCK(1,I) .EQ. 1) GO TO 700
      IF (HARM .EQ. 0.0) GO TO 660
      NPHI   = HARM*CLOCK(1,I)*DEGRAD
      SINPHI = SIN(NPHI)
      CONPHI = COS(NPHI)
      GO TO (630,600), SORC
  600 CONTINUE
C
      DO 610 IE = 1,5
      KE   = 9*(IE-1)
      KEPZ = 6*(IE-1)
      CLOCK(2+KE,I) = CLOCK(2+KE,I) + CONPHI*ESTRES(1+KEPZ)
      CLOCK(3+KE,I) = CLOCK(3+KE,I) + CONPHI*ESTRES(2+KEPZ)
      CLOCK(4+KE,I) = CLOCK(4+KE,I) + CONPHI*ESTRES(3+KEPZ)
      CLOCK(5+KE,I) = CLOCK(5+KE,I) + CONPHI*ESTRES(4+KEPZ)
      CLOCK(6+KE,I) = CLOCK(6+KE,I) + SINPHI*ESTRES(5+KEPZ)
      CLOCK(7+KE,I) = CLOCK(7+KE,I) + SINPHI*ESTRES(6+KEPZ)
C
      IF (LSYS78) GO TO 610
      KEPZ2 = KEPZ/2
      CLOCK( 8+KE,I) = CLOCK( 8+KE,I) + CONPHI*EFLUX (1+KEPZ2)
      CLOCK( 9+KE,I) = CLOCK( 9+KE,I) + CONPHI*EFLUX (2+KEPZ2)
      CLOCK(10+KE,I) = CLOCK(10+KE,I) + SINPHI*EFLUX (3+KEPZ2)
  610 CONTINUE
C
      DO 620 IR = 1,4
      KR   = 4*(IR-1)
      KRPZ = 3*(IR-1)
      CLOCK(47+KR,I) = CLOCK(47+KR,I) + CONPHI*EFORC(1+KRPZ)
      CLOCK(48+KR,I) = CLOCK(48+KR,I) + SINPHI*EFORC(2+KRPZ)
      CLOCK(49+KR,I) = CLOCK(49+KR,I) + CONPHI*EFORC(3+KRPZ)
      KR3 = 1 + KRPZ/3
      IF(.NOT.LSYS78) CLOCK(50+KR,I) = CLOCK(50+KR,I) +CONPHI*ECHRG(KR3)
  620 CONTINUE
      GO TO 690
C
  630 CONTINUE
      DO 640 IE = 1,5
      KE   = 9*(IE-1)
      KEPZ = 6*(IE-1)
      CLOCK(2+KE,I) = CLOCK(2+KE,I) + SINPHI*ESTRES(1+KEPZ)
      CLOCK(3+KE,I) = CLOCK(3+KE,I) + SINPHI*ESTRES(2+KEPZ)
      CLOCK(4+KE,I) = CLOCK(4+KE,I) + SINPHI*ESTRES(3+KEPZ)
      CLOCK(5+KE,I) = CLOCK(5+KE,I) + SINPHI*ESTRES(4+KEPZ)
      CLOCK(6+KE,I) = CLOCK(6+KE,I) - CONPHI*ESTRES(5+KEPZ)
      CLOCK(7+KE,I) = CLOCK(7+KE,I) - CONPHI*ESTRES(6+KEPZ)
C
      IF (LSYS78) GO TO 640
      KEPZ2 = KEPZ/2
      CLOCK( 8+KE,I) = CLOCK( 8+KE,I) + SINPHI*EFLUX(1+KEPZ2)
      CLOCK( 9+KE,I) = CLOCK( 9+KE,I) + SINPHI*EFLUX(2+KEPZ2)
      CLOCK(10+KE,I) = CLOCK(10+KE,I) - CONPHI*EFLUX(3+KEPZ2)
  640 CONTINUE
C
      DO 650 IR = 1,4
      KR   = 4*(IR-1)
      KRPZ = 3*(IR-1)
      CLOCK(47+KR,I) = CLOCK(47+KR,I) + SINPHI*EFORC(1+KRPZ)
      CLOCK(48+KR,I) = CLOCK(48+KR,I) - CONPHI*EFORC(2+KRPZ)
      CLOCK(49+KR,I) = CLOCK(49+KR,I) + SINPHI*EFORC(3+KRPZ)
      KR3 = 1 + KRPZ/3
      IF(.NOT.LSYS78) CLOCK(50+KR,I) = CLOCK(50+KR,I) +SINPHI*ECHRG(KR3)
  650 CONTINUE
      GO TO 690
C
  660 DO 670 IE = 1,5
      KE   = 9*(IE-1)
      KEPZ = 6*(IE-1)
      CLOCK(2+KE,I) = ESTRES(1+KEPZ)
      CLOCK(3+KE,I) = ESTRES(2+KEPZ)
      CLOCK(4+KE,I) = ESTRES(3+KEPZ)
      CLOCK(5+KE,I) = ESTRES(4+KEPZ)
      CLOCK(6+KE,I) = ESTRES(5+KEPZ)
      CLOCK(7+KE,I) = ESTRES(6+KEPZ)
C
      IF (LSYS78) GO TO 670
      KEPZ2 = KEPZ/2
      CLOCK( 8+KE,I) = EFLUX(1+KEPZ2)
      CLOCK( 9+KE,I) = EFLUX(2+KEPZ2)
      CLOCK(10+KE,I) = EFLUX(3+KEPZ2)
  670 CONTINUE
C
      DO 680 IR = 1,4
      KR   = 4*(IR-1)
      KRPZ = 3*(IR-1)
      CLOCK(47+KR,I) = EFORC(1+KRPZ)
      CLOCK(48+KR,I) = EFORC(2+KRPZ)
      CLOCK(49+KR,I) = EFORC(3+KRPZ)
      KR3 = 1 + KRPZ/3
      IF(.NOT.LSYS78) CLOCK(50+KR,I) = ECHRG(KR3)
  680 CONTINUE
C
  690 CONTINUE
C
C     COPY STRESSES AND FORCES INTO OUTPUT BLOCKS
C
  700 CONTINUE
      J = 2
      K = 1
      L = 0
      ISTRES (1) = ELEMID
      ISTRES (2) = NELHAR
      DO 720 I = 1,NS
      J = J + 1
      STRES(J) = ESTRES(I)
C
      IF (I/6 .NE. K) GO TO 720
      K = K + 1
      DO 710 II = 1,3
      J = J + 1
      L = L + 1
      STRES(J) = EFLUX(L)
  710 CONTINUE
  720 CONTINUE
C
      K = 0
      J = 2
      L = 1
      IFORCE(1) = ELEMID
      IFORCE(2) = NELHAR
      DO 800 I  = 1,NUMPT
      DO 800 KK = 1,NDOF
      J = J + 1
      K = K + 1
      FORCE(J) = EFORC(K)
C
      IF (K/3 .NE. L) GO TO 800
      J = J + 1
      FORCE(J) = ECHRG(L)
      L = L + 1
  800 CONTINUE
C
 1001 CONTINUE
C
      RETURN
      END

      SUBROUTINE PLOAD1 (OPT,ISLT,V,SA,SB,BA,BB,PA,PB,TA,TB,SLT,EPT)
C
C     PLOAD1 CALCULATES THE END LOADS ON A BAR ELEMENT FOR PLOAD1 LOADS
C     IT IS CALLED ONLY BY PLBAR1
C
C     OPT   = 1, CALLED FROM PLBAR1/EXTERN,  2, CALLED FROM SDRX
C     SLT   = PLOAD1 CARD
C     V     = REFERENCE VECTOR IN BASIC
C     SA    = OFFSET VECTOR IN BASIC POINT A
C     SB    = OFFSET VECTOR IN BASIC POINT B
C     BA    = BASIC  COORD  FOR POINT A
C     BB    = BASIC  COORD  FOR POINT B
C     PA    = LOAD   VECOTR FOR POINT A
C     PB    = LOAD   VECOTR FOR POINT B
C     TA,TB = TRANSFORMATION MATRICES FOR A AND B ONLY USED WITH OPT 1
C     EPT   = POINTER TO EST
C
      INTEGER          OPT,OLDID,TYPE,SCALE,ISLT(7)
      REAL             LEN
      DOUBLE PRECISION AX,AY,AZ,BX,BY,BZ,DX1,DX2,DL,DT,DFX1,DFY1,DFZ1,
     1                 DFX2,DFY2,DFZ2,S1,S2,S3,S4,S5,
     2                 I01,I11,I21,I31,I41,I02,I12,I22,I32,I42
      DIMENSION        V(3),SA(3),SB(3),BA(3),BB(3),PA(6),PB(6),EPT(32),
     1                 A(3),B(3),C(3),D(9),E(9),SLT(7),TA(9),TB(9),TP(3)
      COMMON /MATOUT/  F,G
      EQUIVALENCE      (A(1),E(1)),(B(1),E(7)),(C(1),E(4))
      DATA    OLDID ,  D / 10*0 /
C
      IF (OLDID .EQ. ISLT(1)) GO TO 20
      OLDID = ISLT(1)
C
C     CALCULATE AXIS AND LENGTH, AND THE E MATRIX
C
      A(1) = BB(1)-BA(1) + SB(1)-SA(1)
      A(2) = BB(2)-BA(2) + SB(2)-SA(2)
      A(3) = BB(3)-BA(3) + SB(3)-SA(3)
      LEN  = SQRT(SADOTB(A,A))
      IF (LEN .EQ. 0.0) GO TO 380
      A(1) = A(1)/LEN
      A(2) = A(2)/LEN
      A(3) = A(3)/LEN
      CALL SAXB (A,V,B)
C
      TEMP = SQRT(SADOTB(B,B))
      IF (TEMP .EQ. 0.0) GO TO 380
      B(1) = B(1)/TEMP
      B(2) = B(2)/TEMP
      B(3) = B(3)/TEMP
      CALL SAXB (B,A,C)
C
C     TRANSVERSE SHEAR
C
      TEMP = EPT(31)*EPT(17)*G*LEN**2
      TMP  = 12.0*F*EPT(18)
      ALY  = 0.0
      IF (ABS(TEMP+TMP) .GT. 1.0E-14) ALY = TMP/(TMP+TEMP)
      OMALY = 1.0 - ALY
C
      TEMP = (TEMP/EPT(31))*EPT(32)
      TMP  = 12.0*F*EPT(19)
      ALZ  = 0.0
      IF (ABS(TEMP+TMP) .GT. 1.0E-14) ALZ = TMP/(TMP+TEMP)
      OMALZ = 1.0 - ALZ
C
C     START BUILDING THE FORCES AND MOMENTS
C
   20 TYPE  = ISLT(2)
      SCALE = ISLT(3)
      X1  =  SLT(4)
      F1  =  SLT(5)
      X2  =  SLT(6)
      F2  =  SLT(7)
      I   = (TYPE-1)/6 + 1
      J   = MOD(TYPE,6)
      IF (J .EQ. 0) GO TO 60
      GO TO (30,30,30,40,50,60), J
   30 FX1 = A(J)*F1
      FY1 = C(J)*F1
      FZ1 = B(J)*F1
      FX2 = A(J)*F2
      FY2 = C(J)*F2
      FZ2 = B(J)*F2
      GO TO 100
   40 FX1 = F1
      FY1 = 0.0
      FZ1 = 0.0
      FX2 = F2
      FY2 = 0.0
      FZ2 = 0.0
      GO TO 100
   50 FX1 = 0.0
      FY1 = F1
      FZ1 = 0.0
      FX2 = 0.0
      FY2 = F2
      FZ2 = 0.0
      GO TO 70
   60 FX1 = 0.0
      FY1 = 0.0
      FZ1 = F1
      FX2 = 0.0
      FY2 = 0.0
      FZ2 = F2
   70 J   = 4
C
C     SCALED
C
  100 IF (SCALE.EQ.2 .OR. SCALE.EQ.4) GO TO 110
      X1  = X1/LEN
      X2  = X2/LEN
C
C     DISTRIBUTED SCALED LOADS
C
  110 IF (X1 .EQ. X2) GO TO 220
      IF (SCALE.LE.2 .OR. J.EQ.4) GO TO 120
      FSCALE = SQRT(1.0-A(J)**2)
      FX1  = FSCALE*FX1
      FY1  = FSCALE*FY1
      FZ1  = FSCALE*FZ1
      FX2  = FSCALE*FX2
      FY2  = FSCALE*FY2
      FZ2  = FSCALE*FZ2
C
C     DISTRIBUTED LOADS
C
  120 DX1  = X1
      DX2  = X2
      DL   = LEN
      DFX1 = FX1
      DFY1 = FY1
      DFZ1 = FZ1
      DFX2 = FX2
      DFY2 = FY2
      DFZ2 = FZ2
      S1   = DX2 - DX1
      S2   = .5000000D0*(DX2**2 - DX1**2)
      S3   = .3333333D0*(DX2**3 - DX1**3)
      S4   = .2500000D0*(DX2**4 - DX1**4)
      S5   = .2000000D0*(DX2**5 - DX1**5)
      IF (I .EQ. 2) GO TO 140
C
C     FORCES
C
      I01  = DL*(S1-S2)
      I11  = DL*(S1-3.0D0*S3 + 2.0D0*S4)
      I21  = DL*(   3.0D0*S3 - 2.0D0*S4)
      I31  = DL*(S2-2.0D0*S3 + S4)
      I41  = DL*(S4-S3)
      DT   = DL*DL
      I02  = DT*(S2-S3)
      IF (F1 .EQ. F2) GO TO 130
      I12  = DT*(S2-3.0D0*S4 + 2.0D0*S5)
      I22  = DT*(   3.0D0*S4 - 2.0D0*S5)
      I32  = DT*(S3-2.0D0*S4 + S5)
      I42  = DT*(S5-S4)
      DT   = DL*(DX2-DX1)
      BX   = (DFX2-DFX1)/DT
      BY   = (DFY2-DFY1)/DT
      BZ   = (DFZ2-DFZ1)/DT
      AX   = DFX1 - DX1*BX*DL
      AY   = DFY1 - DX1*BY*DL
      AZ   = DFZ1 - DX1*BZ*DL
      GO TO 170
  130 AX   = DFX1
      AY   = DFY1
      AZ   = DFZ1
      GO TO 160
C
C     MOMENTS
C
  140 I01  = DL*(S1-S2)
      I11  =-6.0D0*(S2-S3)
      I21  =-I11
      I31  = S1 - 4.0D0*S2 + 3.0D0*S3
      I41  =    - 2.0D0*S2 + 3.0D0*S3
      IF (F1 .EQ. F2) GO TO 150
      I02  = (S2-S3)*DL**2
      I12  =-6.0D0*DL*(S3-S4)
      I22  =-I12
      I32  = DL*(S2-4.0D0*S3 + 3.0D0*S4)
      I42  =-DL*(   2.0D0*S3 - 3.0D0*S4)
      DT   = (DX2 -DX1)*DL
      BX   = (DFX2-DFX1)/DT
      BY   = (DFZ2-DFZ1)/DT
      BZ   =-(DFY2-DFY1)/DT
      AX   = DFX1 + DX1*BX*DL
      AY   = DFZ1 + DX1*BY*DL
      AZ   =-DFY1 + DX1*BZ*DL
      GO TO 170
  150 AX   = DFX1
      AY   = DFZ1
      AZ   =-DFY1
  160 BX   = 0.0D0
      BY   = 0.0D0
      BZ   = 0.0D0
      I12  = 0.0D0
      I22  = 0.0D0
      I32  = 0.0D0
      I42  = 0.0D0
C
C     LOADS
C
  170 PA(1) = I01*AX + I02*BX
      PA(2) = I11*AY + I12*BY
      PA(3) = I11*AZ + I22*BZ
      PA(4) = 0.0
      PA(5) =-DL*(I31*AZ + I32*BZ)
      PA(6) = DL*(I31*AY + I32*BY)
      DT    = DL*DL
      PB(1) = DL*S2*AX + DT*S3*BX
      PB(2) = I21  *AY + I22  *BY
      PB(3) = I21  *AZ + I22  *BZ
      PB(4) = 0.0
      PB(5) =-DL*(I41*AZ + I42*BZ)
      PB(6) = DL*(I41*AY + I42*BY)
      IF (I .EQ. 2) GO TO 190
      IF (ALY .EQ. 0.0) GO TO 180
      PA(2) = OMALY*PA(2) + ALY*(  I01*AY + I02*BY   )
      PA(6) = OMALY*PA(6) + ALY*(  I02*AY - I41*BY*DT)*.50
      PB(2) = OMALY*PB(2) + ALY*(DL*S2*AY + S3 *BY*DT)
      PB(6) = OMALY*PB(6) - ALY*(  I02*AY - I41*BY*DT)*.50
  180 IF (ALZ .EQ. 0.0) GO TO 300
      PA(3) = OMALZ*PA(3) + ALZ*(  I01*AZ + I02*BZ   )
      PA(5) = OMALZ*PA(5) - ALZ*(  I02*AZ - I41*BZ*DT)*.50
      PB(3) = OMALZ*PB(3) + ALZ*(DL*S2*AZ + S3 *BZ*DT)
      PB(5) = OMALZ*PB(5) + ALZ*(  I02*AZ - I41*BZ*DT)*.50
      GO TO 300
  190 TEMP  = PA(1)
      PA(1) = PA(4)
      PA(4) = TEMP
      TEMP  = PB(1)
      PB(1) = PB(4)
      PB(4) = TEMP
      IF (ALY .EQ. 0.0) GO TO 200
      PA(2) = OMALY*PA(2)
      PA(6) = OMALY*PA(6) + ALY*(I01*AY + I02*BY)
      PB(2) = OMALY*PB(2)
      PB(6) = OMALY*PB(6) + ALY*(DL*S2*AY + S3*BY*DT)
  200 IF (ALZ .EQ. 0.0) GO TO 300
      PA(3) = OMALZ*PA(3)
      PA(5) = OMALZ*PA(5) + ALZ*(I01*AZ + I02*BZ)
      PB(3) = OMALZ*PB(3)
      PB(5) = OMALZ*PB(5) + ALZ*(DL*S2*AZ + S3*BZ*DT)
      GO TO 300
C
C     CONCENTRATED LOADS
C
  220 TMP = 1.0 - X1
      IF (I .EQ. 2) GO TO 230
C
C     FORCES
C
      TEMP  = 1.0 - 3.0*X1**2 + 2.0*X1**3
      PA(1) = TMP*FX1
      PA(2) = TEMP*FY1*OMALY + FY1*TMP*ALY
      PA(3) = TEMP*FZ1*OMALZ + FZ1*TMP*ALZ
      PA(4) = 0.0
      TEMP  =-LEN*X1*TMP**2
      TMP   = TMP*LEN*X1*.50
      PA(5) = TEMP*FZ1*OMALZ - FZ1*TMP*ALZ
      PA(6) =-TEMP*FY1*OMALY + FY1*TMP*ALY
      TEMP  = 3.0*X1**2 - 2.0*X1**3
      PB(1) = X1*FX1
      PB(2) = TEMP*FY1*OMALY + FY1*X1*ALY
      PB(3) = TEMP*FZ1*OMALZ + FZ1*X1*ALZ
      PB(4) = 0.0
      TEMP  = (1.0-X1)*LEN*X1**2
      PB(5) = TEMP*FZ1*OMALZ + FZ1*TMP*ALZ
      PB(6) =-TEMP*FY1*OMALY - FY1*TMP*ALY
      GO TO 300
C
C     MOMENTS
C
  230 TEMP  =-(6.0/LEN*X1)*TMP
      PA(1) = 0.0
      PA(2) = TEMP*FZ1*OMALY
      PA(3) =-TEMP*FY1*OMALZ
      PA(4) = TMP*FX1
      TEMP  = 1.0 - 4.0*X1 + 3.0*X1**2
      PA(5) = TEMP*FY1*OMALZ + FY1*TMP*ALZ
      PA(6) = TEMP*FZ1*OMALY + FZ1*TMP*ALY
      PB(1) = 0.0
      PB(2) =-PA(2)
      PB(3) =-PA(3)
      PB(4) = X1*FX1
      TEMP  = 3.0*X1**2 - 2.0*X1
      PB(5) = TEMP*FY1*OMALZ + FY1*X1*ALZ
      PB(6) = TEMP*FZ1*OMALY + FZ1*X1*ALY
      GO TO 300
C
C     PIN FLAGS
C
  300 CALL PLOAPF (EPT,EPT,LEN,PA,PB)
C
C     LOAD VECTORS DONE FOR SDRX
C
      IF (OPT .EQ. 2) GO TO 400
C
C     TRANSFORM LOAD VECTOR TO GLOBAL
C
      CALL GMMATS (E ,3,3,1,PA(1),3,1,0,TP   )
      CALL GMMATS (TA,3,3,1,TP   ,3,1,0,PA(1))
      CALL GMMATS (E ,3,3,1,PB(1),3,1,0,TP   )
      CALL GMMATS (TB,3,3,1,TP   ,3,1,0,PB(1))
      CALL GMMATS (E ,3,3,1,PA(4),3,1,0,TP   )
      CALL GMMATS (TA,3,3,1,TP   ,3,1,0,PA(4))
      CALL GMMATS (E ,3,3,1,PB(4),3,1,0,TP   )
      CALL GMMATS (TB,3,3,1,TP   ,3,1,0,PB(4))
C
      DO 310 I = 1,3
      IF (SA(I) .NE. 0.0) GO TO 320
  310 CONTINUE
      GO TO 330
  320 D(2)  =-SA(3)
      D(3)  = SA(2)
      D(4)  = SA(3)
      D(6)  =-SA(1)
      D(7)  =-SA(2)
      D(8)  = SA(1)
      CALL GMMATS (D,3,3,0,PA(1),3,1,0,TP)
      PA(4) = PA(4) + TP(1)
      PA(5) = PA(5) + TP(2)
      PA(6) = PA(6) + TP(3)
C
  330 DO 340 I = 1,3
      IF (SB(I) .NE. 0.0) GO TO 350
  340 CONTINUE
      GO TO 400
  350 D(2)  =-SB(3)
      D(3)  = SB(2)
      D(4)  = SB(3)
      D(6)  =-SB(1)
      D(7)  =-SB(2)
      D(8)  = SB(1)
      CALL GMMATS (D,3,3,0,PB(1),3,1,0,TP)
      PB(4) = PB(4) + TP(1)
      PB(5) = PB(5) + TP(2)
      PB(6) = PB(6) + TP(3)
      GO TO 400
C
C     ERROR
C
  380 CALL MESAGE (-30,31,OLDID)
C
  400 RETURN
      END

      SUBROUTINE VAXSCH (NIN,NOUT)
C
C     TO SEARCH UNIT NIN FOR END OF BULK DATA DECK
C
      CHARACTER*8 E1,E2,E3,CHR
      DATA        E1,E2,E3 / 'ENDDATA ', 'END DATA', 'ENDATA  ' /
C
C
   60 READ (NIN,70,END=80) CHR
   70 FORMAT (A8)
      IF (CHR.EQ.E1 .OR. CHR.EQ.E2 .OR. CHR.EQ.E3) GO TO 100
      GO TO 60
C
C     ENDDATA CARD NOT FOUND
C
   80 WRITE  (NOUT,90)
   90 FORMAT ('0*** USER FATAL MESSAGE: "ENDDATA" CARD NOT FOUND BY ',
     1        'INPUT MODULE')
      CALL VAXEND
C
  100 RETURN
      END

      SUBROUTINE EQOUT1 (IA,LEN1,NS,LEN2,ISIL)
C
C     THIS ROUTINE GENERATES OUTPUT ENTRIES FOR CONNECTION TRACE
C
      EXTERNAL        LSHIFT,RSHIFT
      INTEGER         IA(1),NS(1),IBITS(2),N1(17),N2(14),RSHIFT,OUTT
      COMMON /CMB002/ JUNK(8),OUTT
      COMMON /SYSTEM/ JUNK1(8),NLPP,JUNK2(2),NLINE
      COMMON /CMB003/ ICOMB(7,5),CONSET,IAUTO,TOLER,NPSUB
      COMMON /MACHIN/ MACH,IHALF
      DATA    IBLANK/ 4H      /
C
C     SORT ON PSEUDOSTRUCTURE NUMBER
C
      IFIRST = 1
      DO 28 K = 1,17
      N1(K) = IBLANK
   28 CONTINUE
      DO 29 K = 1,14
      N2(K) = IBLANK
   29 CONTINUE
      CALL SORT (0,0,4,1,IA(1),LEN1)
      J = 1
      N1(1) = IA(J+2)
      ICODE = IA(J+3)
      CALL BITPAT (ICODE,IBITS)
      DO 1 I = 1,2
      N1(I+1) = IBITS(I)
    1 CONTINUE
   13 IPS   = RSHIFT(IA(J),IHALF)
      ISUB  = 2*(IPS-1) + 4
      IDBAS = IA(J) - LSHIFT(IPS,IHALF)
      N1(ISUB  ) = NS(2*IDBAS-1)
      N1(ISUB+1) = NS(2*IDBAS  )
      IA(J) = -IA(J)
      CALL PUSH (IA(J+1),N2(2*IPS-1),1,8,1)
      JJ = J
   12 IF (JJ+4 .GT. LEN1) GO TO 14
      IF (IA(JJ+4)) 11,11,50
  50  IF (RSHIFT(IABS(IA(J)),IHALF) - RSHIFT(IA(JJ+4),IHALF)) 10,11,10
   11 JJ = JJ + 4
      GO TO 12
   10 J = JJ + 4
      GO TO 13
C
C     WRITE OUTPUT
C
   14 NLINE = NLINE + 3
      IF (NLINE .LE. NLPP) GO TO 20
      CALL PAGE
      NLINE = NLINE + 3
   20 CONTINUE
      J = 3 + 2*NPSUB
      IF (IFIRST .EQ. 1) WRITE(OUTT,1000) N1(1),ISIL,(N1(K),K=2,J)
      IF (IFIRST .EQ. 0) WRITE(OUTT,1003) (N1(K),K=4,J)
      WRITE (OUTT,1001) (N2(K),K=1,14)
      IFIRST = 0
      J = -3
   15 J = J + 4
      IF (J .GT. LEN1) GO TO 17
      IF (IA(J)) 15,15,16
   16 DO 18 K = 1,17
      N1(K) = IBLANK
   18 CONTINUE
      DO 19 K = 1,14
      N2(K) = IBLANK
   19 CONTINUE
      GO TO 13
   17 WRITE  (OUTT,1002)
 1000 FORMAT (8X,I6,6X,I6,8X,A4,A2,7(3X,2A4))
 1001 FORMAT (40X,7(3X,2A4) )
 1002 FORMAT (7X,4H  --,27(4H----),4H-    )
 1003 FORMAT (/40X,7(3X,2A4) )
      RETURN
      END

      SUBROUTINE TRHT
C
C     TRANSIENT INTEGRATION HEAT TRANSFER MODULE
C
C     INPUTS  CASEXX,USETD,NLFT,DIT,GPTT,KDD,BDD,RDD,PD,TRL (10)
C
C     OUTPUTS  UDVT,PNLD (2)
C
C     SCRATCHES (7)
C     PARAMETERS BETA(R),TABS(R),NORAD(L),RADLIN(L)
C
C     ICR1 IS LLL
C     ICR2 IS ULL
C     ICR5 IS INITIAL CONDITIONS
C     ICR6 IS A MATRIX
C     ICR3,ICR4,ICR7 ARE DECOMP SCRATCH FILES
C
      INTEGER         CASEXX,USETD,NLFT,DIT,GPTT,KDD,BDD,RDD,PD,TRL,
     1                UDVT,PNLD,RADLIN,ISCR1,ISCR2,ISCR3,ISCR4,
     2                IZ(1),NAME(2),IPNL(7),SYSBUF,DIT1,PNL1
      COMMON /BLANK / BETA,TABS,NORAD,RADLIN,SIGMA
      COMMON /SYSTEM/ KSYSTM(65)
      COMMON /ZZZZZZ/ Z(1)
      COMMON /TRHTX / IK(7),IB(7),ICR1,ICR2,ICR3,ICR4,ICR5,ISYM,ICR6,
     1                ICR7,TIM
      COMMON /TRDD1 / NLFT1,DIT1,NLFTP1,NOUT,ICOUNT,ILOOP1,MODA1,NZ,
     1                ICORE,IU2,IP4,IPNL,NMODES,NSTEP,PNL1,IST,MORE(6)
      EQUIVALENCE     (KSYSTM(1),SYSBUF),(KSYSTM(55),IPREC),(Z(1),IZ(1))
      DATA    CASEXX, USETD,NLFT,DIT,GPTT,KDD,BDD,RDD,PD ,TRL/
     1        101   , 102  ,103 ,104,105 ,106,107,108,109,110/,
     2        UDVT  , PNLD,ISCR1 ,ISCR2,ISCR3,ISCR4,ISCR5,ISCR6,ISCR7/
     3        201   , 202 ,301   ,302  ,303  ,304  ,305  ,306  ,307  /
      DATA    NAME  / 4HTRD ,4H    /,   NB   / 8 /
C
C     SET UP FILES
C
      IK(1) = KDD
      CALL RDTRL (IK)
      IB(1) = BDD
      CALL RDTRL (IB)
      ICR1 = ISCR1
      ICR2 = ISCR2
      ICR3 = ISCR3
      ICR4 = ISCR4
      ICR5 = ISCR5
      ICR6 = ISCR6
      ICR7 = ISCR7
C
C     SET UP NONLINEAR FILES
C
      NLFT1 = NLFT
      DIT1  = DIT
      PNL1  = PNLD
      IF (IK(1) .LE. 0) IK(1) = 0
      IF (IB(1) .LE. 0) IB(1) = 0
      MODA1 = -1
      IF (IB(1) .NE. 0) IK(2) = IB(2)
C
C     OBTAIN PARAMETERS, INITIAL CONDITIONS
C
      CALL TRHT1A (CASEXX,USETD,GPTT,TRL,NGROUP)
C
C     ALLOCATE CORE
C
      NZ = KORSZ(Z)
      IGROUP = NZ - 3*NGROUP + 1
      NV = 4
      IF (NLFTP1.NE.0 .OR. NORAD.NE.-1) NV = NV + 3
      IF (NZ .LT. NV*IK(2)*IPREC-NB*SYSBUF-3*NGROUP)
     1    CALL MESAGE (-8,0,NAME)
      TIM = 0.
      DO 10 I = 1, NGROUP
      CALL KLOCK (ITIM1)
      NSTEP  = IZ(IGROUP )
      DELTA  = Z(IGROUP+1)
      IGROUP = IGROUP + 3
C
C     FORM  A  MATRIX AND DECOMPOSE
C
      CALL TRHT1B (3*NGROUP,DELTA)
      CALL KLOCK  (ITIM3)
      CALL TRHT1C (NGROUP,UDVT,PD,RDD,I)
      CALL KLOCK  (ITIM2)
      CALL TMTOGO (ITLEFT)
      IF (I .EQ. NGROUP) GO TO 10
      IF ((ITIM 3-ITIM1+((ITIM 2-ITIM 3)/NSTEP)*IZ(IGROUP)) .GE. ITLEFT)
     1   GO TO 30
   10 CONTINUE
   20 RETURN
C
   30 CALL MESAGE (45,NGROUP-I,NAME)
      GO TO 20
      END

      SUBROUTINE OPTPR1
C
C     THIS ROUTINE IS THE DRIVER FOR PROPERTY OPTIMIZATION, PHASE 1.
C
C
C     OPTPR1  MPT,EPT,ECT,DIT,EST/OPTP1/V,N,PRINT/V,N,TSTART/
C                                       V,N,COUNT $
C
C     WHERE PRINT  = OUTPUT, INTEGER = 1
C           TSTART = OUTPUT, INTEGER = TIME AT EXIT OF OPTPR1.
C           COUNT  = OUTPUT, INTEGER =-1 NOT PROPERTY OPTIMIZATION.
C                                    = 1 IS  PROPERTY OPTIMIZATION.
C     CRITERIA FOR OPTIMIZATION
C
C        1. OUTPUT FILE NOT PURGED.
C        2. BULK DATA CARD -POPT IS PRESENT.
C           AFTER THESE TESTS ALL ERRORS ARE FATAL.
C
C
C      SUBROUTINES USED
C
C      OPTP1A - READS ELEMENT DATA INTO CORE (NWDSE PER ELEMENT).
C      OPTP1B - READS PROPERTY IDS INTO CORE AND SETS ELEMENT DATA
C               POINTER (V1) TO ITS LOCATION. (NWDSP PER PROPERTY).
C      OPTP1C - READS DESIGN PROPERTIES INTO CORE.
C      OPTP1D - READS PLIMIT DATA INTO CORE AND SETS PROPERTY DATA
C               POINTER (PLIM) TO ITS LOCATION. (NWDSK PER LIMIT)
C
C
C     LOGICAL         DEBUG
      INTEGER         DATTYP(21),DATDTY(90),DTYP(90),SYSBUF,B2,B1P1,
     1                NAME(2),CREW,FILE,YCOR,PCOR1,ECOR1,PRCOR1,FNAM(2),
     2                PRINT,COUNT,POPH(2),HPOP(2),PLMH(2),NONE(2),
     3                EPT,ECT,DIT,EST,OPTP1,OUTTAP,Y(1),SCRTH1,ZCOR,
     4                PCOR2,TSTART
      REAL            X(7)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG / UFM,UWM,UIM,SFM
      COMMON /BLANK / PRINT,TSTART,COUNT,SKP(2),YCOR,B1P1,NPOW,
     1                NELW,NWDSE,NPRW,NWDSP,NKLW,MPT,EPT,ECT,DIT,EST,
     2                OPTP1,SCRTH1,NELTYP,ITYPE(21)
      COMMON /OPTPW1/ ZCOR,Z(100)
      COMMON /ZZZZZZ/ CORE(1)
      COMMON /NAMES / NRD,NRREW,NWRT,NWREW,CREW
      COMMON /SYSTEM/ SYSBUF,OUTTAP
      COMMON /GPTA1 / NTYPES,LAST,INCR,NE(1)
      EQUIVALENCE     (X(1),CORE(1)), (X(7),Y(1))
C     DATA    DEBUG / .FALSE. /
      DATA    POPH  , PLMH / 404,4, 304,3 /,  NAME / 4H OPT,3HPR1 /,
     1        HPOP  / 4H   P,4HOPT  /      ,  NONE / 4H (NO,4HNE) /,
     2        LTYPE / 90 /  ,NUMTYP / 20  /
C
C     NELTYP      = NO. ELEMENT TYPES THAT MAY BE OPTIMIZED
C     LTYPE       = DIMENSION OF DATDTY AND DTYP
C     DATTYP/DTYP = ARRAY TO GIVE RELATIVE LOCATIONS OF ELEMENTS IN
C                   /GPTA1/
C
      DATA    DATTYP/
     1        34, 81, 80, 16, 62, 63, 15, 19, 18, 1,  4,  7,  6,  17,
C             BR  EB  IS  QM  M1  M2  QP  Q1  Q2  RD  SH  TB  T1  T2
     2        73,  9,  8,  3, 64, 83,  0 /
C             T6  TM  TP  TU  Q4  T3
C
C     SETUP DATDYP/DTYP IN ALPHABETICAL ORDER AND IN /GPTA1/ SEQUENCE
C
      DATA    DATDTY  / 10, 0, 18, 11,  0, 13, 12, 17, 16,  0
C             ELEMENT   RD  2  TU  SH   5  T1  TB  TP  TM  10
     1,                 4*0  ,  7,  4, 14,  9,  8,  0
C             ELEMENT   11-14  QP  QM  T2  Q2  Q1  20
     2,                 10*0
C             ELEMENT   21-30
     3,                 3*0  ,  1,   6*0
C             ELEMENT   31-33  BR   35-40
     4,                 10*0
C             ELEMENT   41-50
     5,                 10*0
C             ELEMENT   51-60
     6,                  0, 5,  6,  19,  6*0
C             ELEMENT   61 M1  M2   Q4  65-70
     7,                 2*0,   15,  6*0,   3
C             ELEMENT   71-72  T6  74-79  D8
     8,                  2, 0, 20,  7*0 /
C             ELEMENT   EB 82  T3  84-90
C
C     SET UP ELEMENT TYPES
C
      NELTYP = NUMTYP
      DO 1 I = 1,21
      IF (NTYPES .GT. LTYPE) GO TO 140
    1 ITYPE(I) = DATTYP(I)
      DO 2 I = 1,NTYPES
    2 DTYP(I) = DATDTY(I)
C
C
      ZCOR  = 100
      MPT   = 101
      EPT   = 102
      ECT   = 103
      DIT   = 104
      EST   = 105
      OPTP1 = 201
      SCRTH1= 301
C
C     STEP 1.  INITIALIZE AND CHECK FOR OUTPUT FILE
C
      COUNT = 0
      PRINT = 1
      CALL FNAME (OPTP1,FNAM)
      IF (FNAM(1).EQ.NONE(1) .AND. FNAM(2).EQ.NONE(2)) GO TO 120
C
      B1P1  = KORSZ(CORE(1)) - SYSBUF
      B2    = B1P1 - SYSBUF
      YCOR  = B2 - 7
      PCOR1 =-1
      ECOR1 =-1
      PRCOR1=-1
      KCOR1 =-1
      NWDSE = 5
      NWDSP = 6
      NPOW  = NELTYP
      CALL DELSET
C
C     STEP 2.  FIND POPT CARD
C
      CALL PRELOC (*120,X(B1P1),MPT)
      CALL LOCATE (*110,X(B1P1),POPH,I)
      CALL READ (*10,*30,MPT,X,7,1,NWDS)
C
C     ILLEGAL NUMBER OF WORDS
C
   10 CALL PAGE2 (-2)
      WRITE  (OUTTAP,20) SFM,NAME,NWDS,HPOP
   20 FORMAT (A25,' 2288, ',2A4,'READ INCORRECT NUMBER WORDS (',I2,2A4,
     1        2H).)
      GO TO 80
C
   30 IF (NWDS.NE.6) GO TO 10
C
C     STEP 2A.  PROCESS PLIMIT CARDS ON SCRATCH FILE
C
      IF (YCOR .LE. 11) GO TO 60
      NKLW = 0
      CALL LOCATE (*40,X(B1P1),PLMH,I)
      CALL GOPEN (SCRTH1,X(B2),NWREW)
      CALL OPTPX (DTYP)
      CALL CLOSE (SCRTH1,CREW)
   40 CALL CLOSE (MPT,CREW)
      IF (NKLW    .LT. 0) GO TO 60
      IF (COUNT+1 .EQ. 0) GO TO 80
C
C     STEP 3.  LOAD MATERIAL DATA
C
      CALL PREMAT (Y(1),Y(1),X(B1P1),YCOR,MCOR,MPT,DIT)
      PCOR1 = MCOR  + 1
      PCOR2 = PCOR1 + NTYPES
      ECOR1 = PCOR2 + 2*(NPOW+1)
      YCOR  = YCOR  - ECOR1
      IF (YCOR .LT. (NWDSE+NWDSP)) GO TO 60
C
C     STEP 4.  READ ELEMENTS INTO CORE
C
      CALL GOPEN (EST,X(B2),0)
      CALL OPTP1A (Y(PCOR1),Y(PCOR2),Y(ECOR1),DTYP)
      CALL CLOSE (EST,CREW)
      IF (COUNT+1 .EQ. 0) GO TO 80
      IF (NELW    .LE. 0) GO TO 60
C
C     STEP 5.  READ IN PROPERTIES IDS, SET V1.  SECOND BUFFER NOT NEEDED
C
      PRCOR1 = ECOR1 + NELW
      YCOR   = YCOR  - NELW + SYSBUF
      IF (YCOR .LT. NWDSP) GO TO 60
      FILE = ECT
      CALL PRELOC (*90,X(B1P1),ECT)
      CALL OPTP1B (Y(PCOR1),Y(PCOR2),Y(ECOR1),Y(PRCOR1))
      CALL CLOSE (ECT,CREW)
      IF (COUNT+1 .EQ. 0) GO TO 60
      IF (NPRW    .LE. 0) GO TO 80
C
C     STEP 6.  READ PROPERTY DATA INTO CORE
C
      KCOR1 = PRCOR1 + NPRW
      YCOR  = YCOR   - NPRW
C
      FILE = EPT
      CALL PRELOC (*90,X(B1P1),EPT)
      CALL OPTP1C (Y(PCOR1),Y(PCOR2),Y(PRCOR1))
      CALL CLOSE (EPT,CREW)
      IF (COUNT+1 .EQ.0) GO TO 80
C
C     STEP 7.  PROCESS PLIMIT CARDS
C
      IF (NKLW .LE. 0) GO TO 50
      IF (YCOR .LT. 4) GO TO 60
      CALL GOPEN (SCRTH1,X(B1P1),NRREW)
      CALL OPTP1D (Y(PCOR2),Y(PRCOR1),Y(KCOR1))
      CALL CLOSE (SCRTH1,CREW)
      IF (NKLW    .LT. 0) GO TO 60
      IF (COUNT+1 .EQ. 0) GO TO 80
C
C     STEP 7.  COUNT=0, OUTPUT FILE OPTPR1
C
   50 FILE = OPTP1
      CALL OPEN  (*90,OPTP1,X(B1P1),NWREW)
      CALL WRITE (OPTP1,FNAM,2,0)
      CALL WRITE (OPTP1,X(1),6,1)
C
      CALL WRITE (OPTP1,Y(PCOR1),NTYPES,0)
      CALL WRITE (OPTP1,NPOW,1,0)
      CALL WRITE (OPTP1,Y(PCOR2),2*(NPOW+1),1)
      CALL WRITE (OPTP1,Y(ECOR1),NELW,1)
      CALL WRITE (OPTP1,Y(PRCOR1),NPRW,1)
      CALL WRITE (OPTP1,Y(KCOR1),NKLW,1)
      CALL EOF   (OPTP1)
      J      = 0
      Y(J+1) = OPTP1
      Y(J+2) = 0
      Y(J+3) = NELW
      Y(J+4) = NPRW
      Y(J+5) = NKLW
      Y(J+6) = 0
      Y(J+7) = NTYPES
      CALL WRTTRL (Y(1))
      CALL CLOSE (OPTP1,CREW)
      GO TO 130
C
C     ERROR MESSAGES - FILE NOT CREATED
C
C     INSUFFICIENT CORE
C
   60 CALL PAGE2 (-3)
      WRITE  (OUTTAP,70) UFM,NAME,B1P1,PCOR1,ECOR1,PRCOR1,KCOR1
   70 FORMAT (A23,' 2289, ',2A4,'INSUFFICIENT CORE (',I10,2H ), /9X,I9,
     1       ' = MATERIAL',I9,' = POINTERS',I9,' = ELEMENTS',I9,
     2       ' = PROPERTIES')
   80 CALL MESAGE(-61,EPT,NAME)
C
C    INPUT FILE PURGED - ILLEGALLY
C
   90 CALL MESAGE (-1,FILE,NAME)
C
C    OPTPR1 NOT CREATED
C
  110 CALL CLOSE (MPT,CREW)
  120 COUNT = -1
C
C     OPTPR1 CREATED
C
  130 CONTINUE
      CALL KLOCK (TSTART)
      RETURN
C
C     ERROR MESSAGE
C
  140 WRITE  (OUTTAP,150) SFM
  150 FORMAT (A25,', DATDTY AND DTYP ARRAYS TOO SMALL')
      CALL MESAGE (-37,0,NAME)
      END

      SUBROUTINE CPUTIM (ICPUSC,RCPUSC,IFLAG)
C
C     THIS ROUTINE IS MACHINE DEPENDENT
C
C     THIS ROUTINE OBTAINS THE CURRENT CPU TIME IN SECONDS.
C     IF IFLAG .EQ. 0, CPU TIME IS RETURNED AS AN INTEGER VALUE.
C     IF IFLAG .NE. 0, CPU TIME IS RETURNED AS A REAL VALUE.
C
C     DESIGN REQUIREMENT:
C     RCPUSC MUST OVER THE RANGE OF 10**-3 TO 10**5 CPU SECONDS
C
C     DEC VAX/VMS VERSION
C     ===================
C
C     INCLUDE '($JPIDEF)'
C
C     INTEGER   BUF_ADDR, ZERO, CPU_TIME
C     INTEGER*2 BUF_LNGTH, ITEM_CODE
C
C     COMMON /CPU_LIST/ BUF_LNGTH, ITEM_CODE, BUF_ADDR, LNGTH_ADDR,
C    1                  ZERO
C
C     DATA BUF_LNGTH, LNGTH_ADDR, ZERO /4, 2*0/
C     DATA ITEM_CODE /JPI$_CPUTIM/
C
C     BUF_ADDR = %LOC (CPU_TIME)
C     CALL SYS$GETJPI (,,,BUF_LNGTH,,,)
C     IF (IFLAG.EQ.0) ICPUSC = CPU_TIME/100
C     IF (IFLAG.NE.0) RCPUSC = CPU_TIME/100.0
C     RETURN
C
C
C     SUBROUTINE CPUTIM (ICPUSC,RCPUSC,IFLAG)
C
C     UNIX VERSION
C     ============
C
C     THIS ROUTINE OBTAINS THE CURRENT CPU TIME IN SECONDS
C     IF IFLAG.EQ.0, CPU TIME IS RETURNED AS AN INTEGER VALUE IN ICPUSC
C     IF IFLAG.NE.0, CPU TIME IS RETURNED AS A REAL VALUE IN RCPUSC,
C
C     DESIGN REQUIREMENT -
C     RCPUSC MUST COVER THE RANGE OF 1.0**-3 TO 1.0**+5 CPU SECONDS
C
C     NOTE - THE CURRENT CALL TO CPUTIM MUST GIVE A TIME VALUE BIGGER
C     THAN PREVIOUS CPUTIME CALL. OTHERWISE, CALLING ROUTINE MAY GET
C     INTO TROUBLE, SUCH AS DIVIDED BY ZERO.
C
C     REAL ARRAY(2)
C
C     CALL ETIME (ARRAY)
C     IF (IFLAG .NE. 0) GO TO 10
C     ICPUSC = ARRAY(2) + .49
C     GO TO 20
C  10 SAVE   = RCPUSC
C     RCPUSC = ARRAY(2)
C     IF (RCPUSC .LE. SAVE) RCPUSC = RCPUSC + 0.0001
C  20 RETURN
C
C
C
C     SUBROUTINE CPUTIM (ICPUSC,RCPUSC,IFLAG)
C
C     UNIVERSAL VERSION
C     =================
C
C     THIS ROUTINE OBTAINS THE CURRENT CPU TIME IN SECONDS
C     IF IFLAG.EQ.0, CPU TIME IS RETURNED AS AN INTEGER VALUE IN ICPUSC
C     IF IFLAG.NE.0, CPU TIME IS RETURNED AS A REAL VALUE IN RCPUSC,
C
C     DESIGN REQUIREMENT -
C     RCPUSC MUST COVER THE RANGE OF 1.0**-3 TO 1.0**+5 CPU SECONDS
C     (SECNDS MAY BE ACCURATE ONLY TO 1/60, OR 0.001 SECOND)
C
C     NOTE - THE CURRENT CALL TO CPUTIM MUST GIVE A TIME VALUE BIGGER
C     THAN PREVIOUS CPUTIME CALL. OTHERWISE, CALLING ROUTINE MAY GET
C     INTO TROUBLE, SUCH AS DIVIDED BY ZERO.
C
      REAL ARRAY(2)
      REAL RESULT
      CALL ETIME(ARRAY,RESULT)
      T=ARRAY(2)
      IF (IFLAG .NE. 0) GO TO 30
      ICPUSC = T + .49
      GO TO 40
   30 SAVE   = RCPUSC
      RCPUSC = T
      IF (RCPUSC .LE. SAVE) RCPUSC = RCPUSC + 0.0001
   40 RETURN
C
      END

      SUBROUTINE EMG
C
C     ELEMENT-MATRIX-GENERATOR MAIN DRIVING ROUTINE.
C
C     DMAP SEQUENCE
C
C     EMG, EST,CSTM,MPT,DIT,GEOM2, /KMAT,KDICT, MMAT,MDICT, BMAT,BDICT/
C          V,N,NOKGG/V,N,NOMGG/V,N,NOBGG/V,N,NOK4GG/V,N,NOKDGG/
C          C,Y,COUPMASS/C,Y,CPBAR/C,Y,CPROD/C,Y,CPQUAD1/C,Y,CPQUAD2/
C          C,Y,CPTRIA1/C,Y,CPTRIA2/C,Y,CPTUBE/C,Y,CQDPLT/C,Y,CPTRPLT/
C          C,Y,CPTRBSC/V,Y,VOLUME/V,Y,SURFACE $
C
      LOGICAL         ERROR, ANYCON, NOGO, HEAT, LINEAR
      INTEGER         Z, EST, CSTM, DIT, GEOM2, DICTN
      INTEGER         PRECIS, CMASS, FLAGS, NAME(2)
      DIMENSION       IBUF(7),MCB(7)
      COMMON /BLANK / NOK, NOM, NOB, NOK4GG, NOKDGG, CMASS
      COMMON /EMGPRM/ ICORE, JCORE, NCORE, ICSTM, NCSTM, IMAT, NMAT,
     1                IHMAT, NHMAT, IDIT, NDIT, ICONG, NCONG, LCONG,
     2                ANYCON, FLAGS(3), PRECIS, ERROR, HEAT, ICMBAR,
     3                LCSTM, LMAT, LHMAT, KFLAGS(3), L38
      COMMON /ZZZZZZ/ Z(1)
      COMMON /EMGFIL/ EST, CSTM, MPT, DIT, GEOM2, MATS(3), DICTN(3)
      COMMON /HMATDD/ SKP(4), LINEAR
      COMMON /SYSTEM/ KSYSTM(65)
      COMMON /MACHIN/ MACH
      EQUIVALENCE     (KSYSTM(3),NOGO), (KSYSTM(55),IPRECI),
     1                (KSYSTM(2),NOUT), (KSYSTM(56),NOHEAT)
      DATA    NAME  / 4HEMG ,4H     /
C
C     SET EMG PRECISION FLAG TO SYSTEM PRECISION FLAG
C
      PRECIS = IPRECI
C
C     IF .NOT.1 .AND. .NOT.2 DEFAULT EMG PRECISION TO SINGLE
C
      IF (PRECIS.LT.1 .OR. PRECIS.GT.2) PRECIS = 1
C
C     HEAT  FORMULATION
C
      HEAT   = .FALSE.
      IF (NOHEAT .LE. 0) GO TO 2
      HEAT   = .TRUE.
      LINEAR = .TRUE.
      NOKDGG = -1
C
C     TEST FOR NO SIMPLE ELEMENTS
C
    2 NOGO   = .FALSE.
      MCB(1) = 101
      CALL RDTRL (MCB)
      IF (MCB(1) .LT. 0) GO TO 3
      IF (MCB(2).NE.0 .OR. MCB(5).NE.0 .OR. MCB(6).NE.0 .OR.
     1    MCB(7).NE.0) GO TO 5
    3 NOK = -1
      NOM = -1
      NOB = -1
      NOK4GG = -1
      RETURN
C
C     SET OPEN CORE
C
    5 NCORE = KORSZ(Z(1))
      ICORE = 3
      IF (MACH.EQ.3 .OR. MACH.EQ.4) CALL EMGSOC (ICORE,NCORE,HEAT)
      NCORE = NCORE - 1
      JCORE = ICORE
C
C     SET WORKING CORE TO ALL ZEROS
C
      DO 10 I = ICORE,NCORE
      Z(I) = 0
   10 CONTINUE
C
C     THIS MODULE WILL SET NOK4GG = -1 . IF DURING EXECUTION A NON-ZERO
C     DAMPING CONSTANT IS DETECTED IN A DICTIONARY BY EMGOUT, NOK4GG
C     WILL BE SET TO 1
C
C     A DMAP DETERMINATION CAN THEN BE MADE WHETHER OR NOT TO HAVE EMA
C     FORM THE K4GG MATRIX
C
      NOK4GG = -1
C
C     SET GINO FILE NUMBERS
C
      EST    = 101
      CSTM   = 102
      MPT    = 103
      DIT    = 104
      GEOM2  = 105
      DO 20 I = 1,3
      MATS(I) = 199 + 2*I
      DICTN(I) = MATS(I) + 1
   20 CONTINUE
      ERROR = .FALSE.
C
C     IF DIAG 38 IS ON, PRINT TOTAL TIME (IN SECONDS) USED BY EMGPRO
C     AND MESSAGES 3113 AND 3107  WHILE PRPCESSING ELEMENTS
C
      CALL SSWTCH (38,L38)
C
C     READ AND SETUP INTO CORE MISC. TABLES.
C     E.G. MPT, CSTM, DIT, ETC.
C
      CALL EMGTAB
C
C     PROCESS ANY CONGRUENT DATA CARDS AND BUILD TABLE IN OPEN CORE.
C
      CALL EMGCNG
C
C     SETUP BALANCE OF CORE WITH REQUIRED BUFFERS AND OPEN
C     REQUIRED DATA BLOCKS.
C
      CALL EMGCOR (IBUF)
C
C     PASS THE EST AND WRITE THE OUTPUT DATA BLOCKS.
C
      IF (L38 .EQ. 1) CALL KLOCK (I)
      CALL EMGPRO (IBUF)
      IF (L38 .EQ. 0) GO TO 40
      CALL KLOCK (J)
      J = J - I
      WRITE  (NOUT,30) J
   30 FORMAT (///,34H *** EMG ELEMENT PROCESSING TIME =,I10,8H SECONDS)
C
C     WRAP-UP OPERATIONS.
C
   40 CALL EMGFIN
      IF (NOGO .OR. ERROR) CALL MESAGE (-37,0,NAME)
      RETURN
      END

      SUBROUTINE FBS21 (BLOCK,Y,YN,NWDS)
C
C     FBS2 EXECUTES THE FORWARD/BACKWARD PASS FOR FBS IN RSP
C                                                        ===
C
      INTEGER          BLOCK(20),DBL,BUF(3),SUBNAM(2),BEGN,END
      REAL             Y(1),YN(1)
      DOUBLE PRECISION LJJ,L
      CHARACTER        UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG /  UFM,UWM,UIM,SFM
      COMMON /SYSTEM/  SYSBUF,NOUT
      COMMON /ZZZZZZ/  L(1)
      COMMON /FBSX  /  DBL, N
      DATA    SUBNAM,  BEGN, END /4HFBS2, 4H1   , 4HBEGN, 4HEND /
C
      BUF(1) = SUBNAM(1)
      BUF(2) = SUBNAM(2)
      BUF(3) = BEGN
      CALL CONMSG (BUF,3,0)
      NBRITM = NWDS/2
      NBRVEC = (LOCFX(YN) - LOCFX(Y))/NWDS + 1
      LAST = 1 + (NBRVEC-1)*NBRITM
      DO 38 J=1,N
C
C     MAKE 1ST STRING CALL FOR COLUMN AND SAVE DIAGONAL ELEMENT
C
      BLOCK(8) = -1
      CALL GETSTR (*81,BLOCK)
      IF (BLOCK(4) .NE. J) GO TO 81
      JSTR = BLOCK(5)
      LJJ  = L(JSTR)
CWKBI
      XLJJ = LJJ
      IF (BLOCK(6) .EQ. 1) GO TO 20
      NSTR = JSTR + BLOCK(6) - 1
      JSTR = JSTR + 1
      BLOCK(4) = BLOCK(4) + 1
C
C     PROCESS CURRENT STRING IN TRIANGULAR FACTOR AGAINST EACH
C     LOAD VECTOR IN CORE -- Y(I,K) = Y(I,K) + L(I,J)*Y(J,K)
C
   10 DO 18 K = 1,LAST,NBRITM
      YJK = Y(J+K-1)
      IK  = BLOCK(4) + K - 1
      DO 16 IJ = JSTR,NSTR
CWKBI
      XLIJ = L(IJ)
CWKBR Y(IK) = Y(IK) + L(IJ)*YJK
      Y(IK) = Y(IK) + XLIJ*YJK
      IK = IK + 1
   16 CONTINUE
   18 CONTINUE
C
C     GET NEXT STRING IN TRIANGULAR FACTOR
C
   20 CALL ENDGET (BLOCK)
      CALL GETSTR (*30,BLOCK)
      JSTR = BLOCK(5)
      NSTR = JSTR + BLOCK(6) - 1
      GO TO 10
C
C     END-OF-COLUMN ON TRIANGULAR FACTOR -- DIVIDE BY DIAGONAL
C
   30 DO 34 K = 1,LAST,NBRITM
CWKBR Y(J+K-1) = Y(J+K-1)/LJJ
      Y(J+K-1) = Y(J+K-1)/XLJJ
   34 CONTINUE
   38 CONTINUE
C
C     INITIALIZE FOR BACKWARD PASS BY SKIPPING THE NTH COLUMN
C
      IF (N .EQ. 1) GO TO 65
      CALL BCKREC (BLOCK)
      J = N - 1
C
C     GET A STRING IN CURRENT COLUMN. IF STRING INCLUDES DIAGONAL,
C     ADJUST STRING TO SKIP IT.
C
   40 BLOCK(8) = -1
   42 CALL GETSTB (*60,BLOCK)
      IF (BLOCK(4)-BLOCK(6)+1 .EQ. J) BLOCK(6) = BLOCK(6) - 1
      IF (BLOCK(6) .EQ. 0) GO TO 59
      NTERMS = BLOCK(6)
C
C     PROCESS CURRENT STRING IN TRIANGULAR FACTOR AGAINST EACH
C     LOAD VECTOR IN CORE -- Y(J,K) = Y(J,K) + L(J,I)*Y(I,K)
C
      DO 58 K = 1,LAST,NBRITM
      JI = BLOCK(5)
      IK = BLOCK(4) + K - 1
      JK = J + K - 1
      DO 56 II = 1,NTERMS
      Y(JK) = Y(JK) + L(JI)*Y(IK)
      JI = JI - 1
      IK = IK - 1
   56 CONTINUE
   58 CONTINUE
C
C     TERMINATE CURRENT STRING AND GET NEXT STRING
C
   59 CALL ENDGTB (BLOCK)
      GO TO 42
C
C     END-OF-COLUMN -- TEST FOR COMPLETION
C
   60 IF (J .NE. 1) GO TO 70
   65 BUF(3) = END
      CALL CONMSG (BUF,3,0)
      RETURN
C
   70 J = J - 1
      GO TO 40
C
C     FATAL ERROR MESSAGE
C
   81 WRITE  (NOUT,82) SFM,SUBNAM
   82 FORMAT (A25,' 2149, SUBROUTINE ',2A4,/5X,'FIRST ELEMENT OF A COL',
     1     'UMN OF LOWER TRIANGULAR MATRIX IS NOT THE DIAGONAL ELEMENT')
      CALL MESAGE (-61,0,0)
      RETURN
      END

      SUBROUTINE STRSL1
C
C     OUTPUTS FROM THIS PHASE FOR USE IN PHASE II ARE THE FOLLOWING
C
C     1)  ELEMENT ID              WORDS    1    STORAGE IN PH1OUT  1
C     2)  SIX SILS                WORDS    6                     2-7
C     3)  3 MEMBRANE  THICKNESES  WORDS    3                     8-10
C     4)  3 BENDING  THICKNESES   WORDS    3                    11-13
C     5)  8  STRESS DATA POINTS   WORDS    8                    14-21
C     6)  4 NOS. STRESS MATRICES (6-5X6 EACH) WORDS 720         22-741
C     7)  S SUB T MATRIX          WORDS  4X3                   742-753
C     8)  ELEMENT ID              WORD     1                   754
C     9)  SIX SILS                WORDS    6                   755-760
C     10) ELEMENT TEMPERATURE     WORD     1                   761
C     11) 4 NOS. MEMBRANE STRESS MATRICES 4(6-3X3)             762-1193
C
C     ECPT LISTS
C
C     ECPT ( 1) = ELEMENT ID                                    INTEGER
C     ECPT ( 2) = SCALAR INDEX NUMBER FOR GRID POINT 1          INTEGER
C     ECPT ( 3) = SCALAR INDEX NUMBER FOR GRID POINT 2          INTEGER
C     ECPT ( 4) = SCALAR INDEX NUMBER FOR GRID POINT 3          INTEGER
C     ECPT ( 5) = SCALAR INDEX NUMBER FOR GRID POINT 4          INTEGER
C     ECPT ( 6) = SCALAR INDEX NUMBER FOR GRID POINT 5          INTEGER
C     ECPT ( 7) = SCALAR INDEX NUMBER FOR GRID POINT 6          INTEGER
C     ECPT ( 8) = THETA                                         REAL
C     ECPT ( 9) = MATERIAL ID 1                                 INTEGER
C     ECPT (10) = THICKNESS T1 AT GRID POINT G1
C     ECPT (11) = THICKNESS T3 AT GRID POINT G3
C     ECPT (12) = THICKNESS T5 AT GRID POINT G5
C     ECPT (13) = MATERIAL ID 2                                 INTEGER
C     ECPT (14) = THICKNESS TBEND1 FOR BENDING AT GRID POINT G1
C     ECPT (15) = THICKNESS TBEND3 FOR BENDING AT GRID POINT G3
C     ECPT (16) = THICKNESS TBEND5 FOR BENDING AT GRID POINT G5
C     ECPT (17) = MATERIAL ID 3                                 INTEGER
C     ECPT (18) = THICKNESS TSHR1 FOR TRANSVERSE SHEAR AT GRID POINT G1
C     ECPT (19) = THICKNESS TSHR3 FOR TRANSVERSE SHEAR AT GRID POINT G3
C     ECPT (20) = THICKNESS TSHR5 FOR TRANSVERSE SHEAR AT GRID POINT G5
C     ECPT (21) = NON-STRUCTURAL MASS                           REAL
C     ECPT (22) = DISTANCE Z11 FOR STRESS CALCULATION  AT GRID POINT G1
C     ECPT (23) = DISTANCE Z21 FOR STRESS CALCULATION  AT GRID POINT G1
C     ECPT (24) = DISTANCE Z13 FOR STRESS CALCULATION  AT GRID POINT G3
C     ECPT (25) = DISTANCE Z23 FOR STRESS CALCULATION  AT GRID POINT G3
C     ECPT (26) = DISTANCE 015 FOR STRESS CALCULATION  AT GRID POINT G5
C     ECPT (27) = DISTANCE Z25 FOR STRESS CALCULATION  AT GRID POINT G5
C
C     X1,Y1,Z1 FOR ALL SIX POINTS ARE IN NASTRAN BASIC SYSTEM
C
C     ECPT (28) = CO-ORDINATE SYSTEM ID FOR GRID A              INTEGER
C     ECPT (29) = CO-ORDINATE X1                                REAL
C     ECPT (30) = CO-ORDINATE Y1                                REAL
C     ECPT (31) = CO-ORDINATE Z1                                REAL
C     ECPT (32) = CO-ORDINATE SYSTEM ID FOR GRID B              INTEGER
C     ECPT (33) = CO-ORDINATE X1                                REAL
C     ECPT (34) = CO-ORDINATE Y1                                REAL
C     ECPT (35) = CO-ORDINATE Z1                                REAL
C     ECPT (36) = CO-ORDINATE SYSTEM ID FOR GRID C              INTEGE9
C     ECPT (37) = CO-ORDINATE X1                                REAL
C     ECPT (38) = CO-ORDINATE Y1                                REAL
C     ECPT (39) = CO-ORDINATE Z1                                REAL
C     ECPT (40) = CO-ORDINATE SYSTEM ID FOR GRID D              INTEGER
C     ECPT (41) = CO-ORDINATE X1                                REAL
C     ECPT (42) = CO-ORDINATE Y1                                REAL
C     ECPT (43) = CO-ORDINATE Z1                                REAL
C     ECPT (44) = CO-ORDINATE SYSTEM ID FOR GRID E              INTEGER
C     ECPT (45) = CO-ORDINATE X1                                REAL
C     ECPT (46) = CO-ORDINATE Y1                                REAL
C     ECPT (47) = CO-ORDINATE Z1                                REAL
C     ECPT (48) = CO-ORDINATE SYSTEM ID FOR GRID F              INTEGER
C     ECPT (49) = CO-ORDINATE X1                                REAL
C     ECPT (50) = CO-ORDINATE Y1                                REAL
C     ECPT (51) = CO-ORDINATE Z1                                REAL
C     ECPT (52) = ELEMENT TEMPERATURE  AT GRID POINTS G1        REAL
C     ECPT (53) = ELEMENT TEMPERATURE  AT GRID POINTS G2        REAL
C     ECPT (54) = ELEMENT TEMPERATURE  AT GRID POINTS G3        REAL
C     ECPT (55) = ELEMENT TEMPERATURE  AT GRID POINTS G4        REAL
C     ECPT (56) = ELEMENT TEMPERATURE  AT GRID POINTS G5        REAL
C     ECPT (57) = ELEMENT TEMPERATURE  AT GRID POINTS G6        REAL
C
      LOGICAL         NOTS
      REAL            J11,J12,J22,NSM,IVECT(3),JVECT(3),KVECT(3)
      DIMENSION       NAME(2),INDEX(20,3),ICS(6),NL(6),XC(6),YC(6),
     1                ZC(6),QQQ(20,20),QQQINV(360),TS6(40),TS7(60),
     2                E(18),V1(3),V2(3),V3(3),IEST(42),E1(18),PH1BEN(9),
     3                PH1SHR(6),PH2(18),PH3(12),PH4(90),TMMM(36),
     4                Q(6,6),IND(6,3),CAB(3),EE( 30),PH1MEM(6),EPH1(15),
     5                SI(9),EMOD(9),D(9),DPH1(9),G(4),GPH1(6),
     6                NPH1OU(990),TM(96),TMQQ(90),EE1(5,6),TMM(3,12),
     7                TMB(60),TMBQ(54),TRANS(9),BALOTR(36)
      COMMON /MATIN / MATID,MATFLG,ELTEMP,PLA34,SINTH,COSTH
      COMMON /MATOUT/ EM(6),RHOY,ALF(3),TREF,GSUBE,SIGTY,SIGCY,SIGSY,
     1                RJ11,RJ12,RJ22
      COMMON /SDR2X5/ EST(100),PH1OUT(1200),FORVEC(24),X,Y,Z,DISTA,
     1                DISTB,DISTC,A1,A2,A3,AA1,AA2,AA3,QQQINV,QQ,TM,
     2                TMQQ,TS6,TS7,Q,EE,EE1,PH2,PH3,PH4,E,E1,XC,YC,ZC,
     3                PH1MEM,PH1BEN,PH1SHR,DPH1,EPH1,GPH1,G,D,ICS,NL,
     4                CAB,TRANS,BALOTR,EMOD,SI
      EQUIVALENCE     (A,DISTA),(B,DISTB),(C,DISTC),(V1(1),EST(29)),
     1                (V2(1),EST(37)),(V3(1),EST(45)),(IEST(1),EST(1)),
     2                (TMMM(1),TMM(1,1)),(PH1OUT(1),QQQ(1,1)),
     3                (PH1OUT(401),INDEX(1,1),IND(1,1)),
     4                (NPH1OU(1),PH1OUT(1))
      DATA   DEGRA  / 0.0174532925 /
      DATA   BLANK  , NAME / 4H    , 4HTRSH, 4HL     /
C
      NOTS   = .TRUE.
      IDELE  = IEST(1)
      DO 10 I = 1,6
      NL(I)  = IEST(I+1)
   10 CONTINUE
      THETAM = EST(8)
      MATID1 = IEST(9)
      TMEM1  = EST(10)
      TMEM3  = EST(11)
      TMEM5  = EST(12)
      MATID2 = IEST(13)
      TBEND1 = (EST(14)*12.0)**0.3333333333
      TBEND3 = (EST(15)*12.0)**0.3333333333
      TBEND5 = (EST(16)*12.0)**0.3333333333
      MATID3 = IEST(17)
      TSHR1  = EST(18)
      TSHR3  = EST(19)
      TSHR5  = EST(20)
      NSM    = EST(21)
      J      = 0
      IF (TMEM3.EQ.0.0 .OR. TMEM3.EQ.BLANK) TMEM3 = TMEM1
      IF (TMEM5.EQ.0.0 .OR. TMEM5.EQ.BLANK) TMEM5 = TMEM1
      IF (TSHR3.EQ.0.0 .OR. TSHR3.EQ.BLANK) TSHR3 = TSHR1
      IF (TSHR5.EQ.0.0 .OR. TSHR5.EQ.BLANK) TSHR5 = TSHR1
      IF (TSHR1 .EQ. 0.0) NOTS =.TRUE.
      IF (TBEND3.EQ.0.0 .OR. TBEND3.EQ.BLANK) TBEND3 = TBEND1
      IF (TBEND5.EQ.0.0 .OR. TBEND5.EQ.BLANK) TBEND5 = TBEND1
      DO 20 I = 28,48,4
      J = J + 1
      ICS(J) = IEST(I )
      XC(J)  = EST(I+1)
      YC(J)  = EST(I+2)
      ZC(J)  = EST(I+3)
   20 CONTINUE
      ELTEMP = EST(52)
      THETA1 = THETAM*DEGRA
      SINTH  = SIN(THETA1)
      COSTH  = COS(THETA1)
      IF (ABS(SINTH) .LE. 1.0E-06) SINTH = 0.0
C
C     EVALUATE MATERIAL PROPERTIES
C
      MATFLG = 2
      MATID  = MATID1
      IF (MATID1 .EQ. 0) GO TO 30
      CALL MAT (IDELE)
      G11 = EM(1)
      G12 = EM(2)
      G13 = EM(3)
      G22 = EM(4)
      G23 = EM(5)
      G33 = EM(6)
C
   30 MATID = MATID2
      IF (MATID2 .EQ. 0) GO TO 40
      MATFLG = 2
      CALL MAT (IDELE)
      D11  = EM(1)
      D12  = EM(2)
      D13  = EM(3)
      D21  = D12
      D22  = EM(4)
      D23  = EM(5)
      D31  = D13
      D32  = D23
      D33  = EM(6)
      D(1) = D11
      D(2) = D12
      D(3) = D13
      D(4) = D21
      D(5) = D22
      D(6) = D23
      D(7) = D13
      D(8) = D23
      D(9) = D33
      D334 = D33*4.0
      D132 = D13*2.0
      D232 = D23*2.0
      J11  = 0.0
      J12  = 0.0
      J22  = 0.0
      IF (NOTS) GO TO 40
      CALL MAT (IDELE)
C
C     CALCULATIONS FOR THE TRIANGLE
C
   40 CALL TRIF (XC,YC,ZC,IVECT,JVECT,KVECT,A,B,C,IEST(1),NAME)
C
C     EVALUATE THE CONSTANTS C1,C2,AND C3 IN THE LINEAR EQUATION FOR
C     THICKNESS VARIATION - MEMBRANE
C
      CALL AF (F,1,A,B,C,C1,C2,C3,TMEM1,TMEM2,TMEM3,1)
      CAB(1) = C1
      CAB(2) = C2
      CAB(3) = C3
C
C     A1,A2,A3 ARE THE COEFFICIENTS OF LINEAR EQUATION FOR VARIATION
C     OF BENDING THICKNESSES
C
      CALL AF (F,1,A,B,C,A1,A2,A3,TBEND1,TBEND3,TBEND5,1)
      A1SQ = A1*A1
      A2SQ = A2*A2
      A3SQ = A3*A3
      C1   = A1SQ*A1
      C2   = 3.0*A1SQ*A2
      C3   = 3.0*A1SQ*A3
      C4   = 3.0*A1*A2SQ
      C5   = 6.0*A1*A2*A3
      C6   = 3.0*A3SQ*A1
      C7   = A2SQ*A2
      C8   = 3.0*A2SQ*A3
      C9   = 3.0*A2*A3SQ
      C10  = A3*A3SQ
C
C     AA1, AA2, AA3  ARE COEFFICIENTS IN THICKNESS VARIATION FOR
C     TRANSVERSE SHEAR
C
      CALL AF (F,1,A,B,C,AA1,AA2,AA3,TSHR1,TSHR3,TSHR5,1)
C
C
C     FILL E-MATRIX
C
      DO 50 I = 1,18
   50 E(I)  = 0.0
      E( 1) = KVECT(1)
      E( 4) = KVECT(2)
      E( 7) = KVECT(3)
      E(11) = IVECT(1)
      E(14) = IVECT(2)
      E(17) = IVECT(3)
      E(12) = JVECT(1)
      E(15) = JVECT(2)
      E(18) = JVECT(3)
C
C     CALCULATIONS FOR QMATRIX (QQQ) AND ITS INVERSE
C
      DO 60 I = 1,400
   60 QQQ(I,1) = 0.0
      DO 70 I = 1,6
      I1 = (I-1)*3 + 1
      I2 = (I-1)*3 + 2
      I3 = (I-1)*3 + 3
      QQQ(I1, 1) = 1.0
      QQQ(I1, 2) = XC(I)
      QQQ(I1, 3) = YC(I)
      QQQ(I1, 4) = XC(I)*XC(I)
      QQQ(I1, 5) = XC(I)*YC(I)
      QQQ(I1, 6) = YC(I)*YC(I)
      QQQ(I1, 7) = QQQ(I1, 4)*XC(I)
      QQQ(I1, 8) = QQQ(I1, 4)*YC(I)
      QQQ(I1, 9) = QQQ(I1, 5)*YC(I)
      QQQ(I1,10) = QQQ(I1, 6)*YC(I)
      QQQ(I1,11) = QQQ(I1, 7)*XC(I)
      QQQ(I1,12) = QQQ(I1, 7)*YC(I)
      QQQ(I1,13) = QQQ(I1, 8)*YC(I)
      QQQ(I1,14) = QQQ(I1, 9)*YC(I)
      QQQ(I1,15) = QQQ(I1,10)*YC(I)
      QQQ(I1,16) = QQQ(I1,11)*XC(I)
      QQQ(I1,17) = QQQ(I1,12)*YC(I)
      QQQ(I1,18) = QQQ(I1,13)*YC(I)
      QQQ(I1,19) = QQQ(I1,14)*YC(I)
      QQQ(I1,20) = QQQ(I1,15)*YC(I)
      QQQ(I2, 3) = 1.0
      QQQ(I2, 5) = XC(I)
      QQQ(I2, 6) = YC(I)*2.0
      QQQ(I2, 8) = QQQ(I1, 4)
      QQQ(I2, 9) = QQQ(I1, 5)*2.0
      QQQ(I2,10) = QQQ(I1, 6)*3.0
      QQQ(I2,12) = QQQ(I1, 7)
      QQQ(I2,13) = QQQ(I1, 8)*2.0
      QQQ(I2,14) = QQQ(I1, 9)*3.0
      QQQ(I2,15) = QQQ(I1,10)*4.0
      QQQ(I2,17) = QQQ(I1,12)*2.0
      QQQ(I2,18) = QQQ(I1,13)*3.0
      QQQ(I2,19) = QQQ(I1,14)*4.0
      QQQ(I2,20) = QQQ(I1,15)*5.0
      QQQ(I3, 2) =-1.0
      QQQ(I3, 4) =-2.0*XC(I)
      QQQ(I3, 5) =-YC(I)
      QQQ(I3, 7) =-QQQ(I1, 4)*3.0
      QQQ(I3, 8) =-QQQ(I1, 5)*2.0
      QQQ(I3, 9) =-QQQ(I1, 6)
      QQQ(I3,11) =-QQQ(I1, 7)*4.0
      QQQ(I3,12) =-QQQ(I1, 8)*3.0
      QQQ(I3,13) =-QQQ(I1, 9)*2.0
      QQQ(I3,14) =-QQQ(I1,10)
      QQQ(I3,16) =-QQQ(I1,11)*5.0
      QQQ(I3,17) =-QQQ(I1,13)*3.0
      QQQ(I3,18) =-QQQ(I1,14)*2.0
      QQQ(I3,19) =-QQQ(I1,15)
   70 CONTINUE
C
      QQQ(19,16) = 5.0*A**4*C
      QQQ(19,17) = 3.0*A**2*C**3 - 2.0*A**4*C
      QQQ(19,18) =-2.0*A*C**4 + 3.0*A**3*C**2
      QQQ(19,19) = C**5 - 4.0*A**2*C**3
      QQQ(19,20) = 5.0*A*C**4
      QQQ(20,16) = 5.0*B**4*C
      QQQ(20,17) = 3.0*B**2*C**3 - 2.0*B**4*C
      QQQ(20,18) = 2.0*B*C**4 - 3.0*B**3*C**2
      QQQ(20,19) = C**5 - 4.0*B**2*C**3
      QQQ(20,20) =-5.0*B*C**4
      DO 80 I = 1,6
      DO 80 J = 1,6
      I1 = 3*(I-1) + 1
   80 Q(I,J) = QQQ(I1,J)
C
C     NO NEED TO COMPUTE DETERMINANT SINCE IT IS NOT USED SUBSEQUENTLY.
C
      ISING = -1
      CALL INVERS (6,Q,6,TS6(1),0,DET,ISING,IND)
C
C     FOURTH ARGUMENT IS A DUMMY LOCATION FOR INVERSE AND HENCE TS1(1)
C     IS U
C
C     SET ISING = -1 AGAIN.
      ISING = -1
      CALL INVERS (20,QQQ,20,TS6(1),0,DETERM,ISING,INDEX)
C
C     ISING EQUAL TO 2 IMPLIES THAT QQQ IS SINGULAR
C
C
C     FIRST 18 COLUMNS OF QQQ INVERSE IS THE QQQINV FOR USE IN STIFFNESS
C     MATRIX CALCULATIONS
C
      H4 = Q(4,1)*ZC(1) + Q(4,2)*ZC(2) + Q(4,3)*ZC(3) + Q(4,4)*ZC(4) +
     1     Q(4,5)*ZC(5) + Q(4,6)*ZC(6)
      H5 = Q(5,1)*ZC(1) + Q(5,2)*ZC(2) + Q(5,3)*ZC(3) + Q(5,4)*ZC(4) +
     1     Q(5,5)*ZC(5) + Q(5,6)*ZC(6)
      H6 = Q(6,1)*ZC(1) + Q(6,2)*ZC(2) + Q(6,3)*ZC(3) + Q(6,4)*ZC(4) +
     1     Q(6,5)*ZC(5) + Q(6,6)*ZC(6)
      H4 = H4*2.0
      H6 = H6*2.0
C
C     H5 IS MULTIPLIED BY 2.0, SO THAT EXY=DU/DY + DV/DX - ZXY * W
C
      H5 = H5*2.0
      DO 90 I = 1,20
      DO 90 J = 1,18
      IJ = (I-1)*18 + J
      QQQINV(IJ) = QQQ(I,J)
   90 CONTINUE
      DO 100 I = 1,36
  100 BALOTR(I) = 0.0
C
      DO 110 I = 1,7
      NPH1OU (I) = IEST(I)
  110 CONTINUE
      IF (MATID2.EQ.0) GO TO 120
      GO TO 140
  120 DO 130 I = 2,7
      NPH1OU (I) = 0
  130 CONTINUE
  140 PH1OUT( 8) = TMEM1
      PH1OUT( 9) = TMEM3
      PH1OUT(10) = TMEM5
      PH1OUT(11) = TBEND1
      PH1OUT(12) = TBEND3
      PH1OUT(13) = TBEND5
      PH1OUT(14) = EST(22)
      PH1OUT(15) = EST(23)
      PH1OUT(16) = EST(24)
      PH1OUT(17) = EST(25)
      PH1OUT(18) = EST(26)
      PH1OUT(19) = EST(27)
      EMOD(1) = G11
      EMOD(2) = G12
      EMOD(3) = G13
      EMOD(4) = G12
      EMOD(5) = G22
      EMOD(6) = G23
      EMOD(7) = G13
      EMOD(8) = G23
      EMOD(9) = G33
      DO 150 I = 1,30
  150 EE(I)   = 0.0
      EE( 1)  = IVECT(1)
      EE( 2)  = JVECT(1)
      EE( 3)  = KVECT(1)
      EE( 6)  = IVECT(2)
      EE( 7)  = JVECT(2)
      EE( 8)  = KVECT(2)
      EE(11)  = IVECT(3)
      EE(12)  = JVECT(3)
      EE(13)  = KVECT(3)
      EE(19)  = IVECT(1)
      EE(20)  = JVECT(1)
      EE(24)  = IVECT(2)
      EE(25)  = JVECT(2)
      EE(29)  = IVECT(3)
      EE(30)  = JVECT(3)
      DO 340 JJ = 1,4
      J = 2*JJ - 1
      IF (JJ .EQ. 4) GO TO 160
      X = XC(J)
      Y = YC(J)
      GO TO 170
  160 X = (XC(1) + XC(3) + XC(5))/3.0
      Y = (YC(1) + YC(3) + YC(5))/3.0
      PH1OUT(20) = (A1 + A2*X + A3*Y)/2.0
      PH1OUT(21) =-PH1OUT(20)
  170 IF (MATID2 .EQ. 0) GO TO 190
      DO 180 I = 1,60
      TS7(I) = 0.0
  180 CONTINUE
      THK  = A1 + A2*X + A3*Y
      THK1 = THK**3/12.0
      D(1) = D11*THK1
      D(2) = D12*THK1
      D(3) = D13*THK1
      D(4) = D(2)
      D(5) = D22*THK1
      D(6) = D23*THK1
      D(7) = D(3)
      D(8) = D(6)
      D(9) = D33*THK1
      X2   = X*X
      XY   = X*Y
      Y2   = Y*Y
      X3   = X2*X
      X2Y  = X2*Y
      XY2  = X*Y2
      Y3   = Y2*Y
      TS7( 4) = 2.0
      TS7( 7) = 6.0*X
      TS7( 8) = 2.0*Y
      TS7(11) = 12.0*X2
      TS7(12) = 6.0*XY
      TS7(13) = 2.0*Y2
      TS7(16) = 20.0*X3
      TS7(17) = 6.0*XY2
      TS7(18) = 2.0*Y3
      TS7(26) = 2.0
      TS7(29) = 2.0*X
      TS7(30) = 6.0*Y
      TS7(33) = 2.0*X2
      TS7(34) = TS7(12)
      TS7(35) = 12.0*Y2
      TS7(37) = 2.0*X3
      TS7(38) = 6.0*X2Y
      TS7(39) = 12.0*XY2
      TS7(40) = 20.0*Y3
      TS7(45) = 2.0
      TS7(48) = 4.0*X
      TS7(49) = 4.0*Y
      TS7(52) = 6.0*X2
      TS7(53) = 8.0*XY
      TS7(54) = 6.0*Y2
      TS7(57) = 12.0*X2Y
      TS7(58) = TS7(39)
      TS7(59) = 8.0*Y3
      CALL GMMATS (TS7,3,20,0,QQQINV,20,18,0,PH4(1))
      CALL STRSLV (TS6,NOTS)
      CALL GMMATS (TS6,2,20,0,QQQINV,20,18,0,PH4(55))
C
  190 IF (MATID1 .EQ. 0) GO TO 220
      DO 200 I = 1,36
      TMMM(I) = 0.0
  200 CONTINUE
      DO 210 J = 1,6
      J1 = (J-1)*2 + 1
      J2 = J1 + 1
      TMM(1,J1) = Q(2,J) + 2.0*X*Q(4,J) + Y*Q(5,J)
      TMM(2,J2) = Q(3,J) + X*Q(5,J) + 2.0*Y*Q(6,J)
      TMM(3,J1) = TMM(2,J2)
      TMM(3,J2) = TMM(1,J1)
  210 CONTINUE
      X4   = X3*X
      X3Y  = X3*Y
      X2Y2 = X2*Y2
      XY3  = X*Y3
      Y4   = Y*Y3
      X5   = X4*X
      X3Y2 = X3*Y2
      X2Y3 = X2*Y3
      XY4  = X*Y4
      Y5   = Y*Y4
      TMB( 1) = -H4
      TMB( 2) = -H4*X
      TMB( 3) = -H4*Y
      TMB( 4) = -H4*X2
      TMB( 5) = -H4*XY
      TMB( 6) = -H4*Y2
      TMB( 7) = -H4*X3
      TMB( 8) = -H4*X2Y
      TMB( 9) = -H4*XY2
      TMB(10) = -H4*Y3
      TMB(11) = -H4*X4
      TMB(12) = -H4*X3Y
      TMB(13) = -H4*X2Y2
      TMB(14) = -H4*XY3
      TMB(15) = -H4*Y4
      TMB(16) = -H4*X5
      TMB(17) = -H4*X3Y2
      TMB(18) = -H4*X2Y3
      TMB(19) = -H4*XY4
      TMB(20) = -H4*Y5
      TMB(21) = -H6
      TMB(22) = -H6*X
      TMB(23) = -H6*Y
      TMB(24) = -H6*X2
      TMB(25) = -H6*XY
      TMB(26) = -H6*Y2
      TMB(27) = -H6*X3
      TMB(28) = -H6*X2Y
      TMB(29) = -H6*XY2
      TMB(30) = -H6*Y3
      TMB(31) = -H6*X4
      TMB(32) = -H6*X3Y
      TMB(33) = -H6*X2Y2
      TMB(34) = -H6*XY3
      TMB(35) = -H6*Y4
      TMB(36) = -H6*X5
      TMB(37) = -H6*X3Y2
      TMB(38) = -H6*X2Y3
      TMB(39) = -H6*XY4
      TMB(40) = -H6*Y5
      TMB(41) = -H5
      TMB(42) = -H5*X
      TMB(43) = -H5*Y
      TMB(44) = -H5*X2
      TMB(45) = -H5*XY
      TMB(46) = -H5*Y2
      TMB(47) = -H5*X3
      TMB(48) = -H5*X2Y
      TMB(49) = -H5*XY2
      TMB(50) = -H5*Y3
      TMB(51) = -H5*X4
      TMB(52) = -H5*X3Y
      TMB(53) = -H5*X2Y2
      TMB(54) = -H5*XY3
      TMB(55) = -H5*Y4
      TMB(56) = -H5*X5
      TMB(57) = -H5*X3Y2
      TMB(58) = -H5*X2Y3
      TMB(59) = -H5*XY4
      TMB(60) = -H5*Y5
      CALL GMMATS (TMB,3,20,0, QQQINV,20,18,0, TMBQ)
C
  220 DO 330 II = 1,6
      IF (ICS(II) .EQ. 0) GO TO 240
      CALL TRANSS (IEST(4*II+24),TRANS)
      DO 230 J = 1,3
      L = 6*(J-1) + 1
      M = 3*(J-1) + 1
      BALOTR(L   ) = TRANS(M  )
      BALOTR(L+1 ) = TRANS(M+1)
      BALOTR(L+2 ) = TRANS(M+2)
      BALOTR(L+21) = TRANS(M  )
      BALOTR(L+22) = TRANS(M+1)
      BALOTR(L+23) = TRANS(M+2)
  230 CONTINUE
      CALL GMMATS (E,6,3,+1, BALOTR,6,6,0, E1)
      GO TO 260
  240 DO 250 I = 1,3
      DO 250 J = 1,6
      I1 = (I-1)*6 + J
      J1 = (J-1)*3 + I
      E1(I1) = E(J1)
  250 CONTINUE
  260 IF (MATID2 .EQ. 0) GO TO 300
      KZ = (II-1)*3 + 1
      PH1BEN(1) = PH4(KZ   )
      PH1BEN(2) = PH4(KZ+ 1)
      PH1BEN(3) = PH4(KZ+ 2)
      PH1BEN(4) = PH4(KZ+18)
      PH1BEN(5) = PH4(KZ+19)
      PH1BEN(6) = PH4(KZ+20)
      PH1BEN(7) = PH4(KZ+36)
      PH1BEN(8) = PH4(KZ+37)
      PH1BEN(9) = PH4(KZ+38)
      CALL GMMATS (D,3,3,0, PH1BEN,3,3,0, DPH1)
      CALL GMMATS (DPH1,3,3,0, E1,3,6,0, PH2)
      MZ = (II-1)*3 + 55
      PH1SHR(1) = PH4(MZ   )
      PH1SHR(2) = PH4(MZ+ 1)
      PH1SHR(3) = PH4(MZ+ 2)
      PH1SHR(4) = PH4(MZ+18)
      PH1SHR(5) = PH4(MZ+19)
      PH1SHR(6) = PH4(MZ+20)
      IF (NOTS) GO TO 270
      THK  = AA1 + AA2*X + AA3*Y
      G(1) = EM(6)*THK
      G(2) = 0.0
      G(3) = 0.0
      G(4) = G(1)
      CALL GMMATS (G,2,2,0, PH1SHR,2,3,0, GPH1)
      GO TO 280
  270 GPH1(1) = PH1SHR(1)
      GPH1(2) = PH1SHR(2)
      GPH1(3) = PH1SHR(3)
      GPH1(4) = PH1SHR(4)
      GPH1(5) = PH1SHR(5)
      GPH1(6) = PH1SHR(6)
  280 CALL GMMATS (GPH1,2,3,0, E1,3,6,0, PH3)
      DO 290 I = 1,3
      DO 290 J = 1,6
      I1 = (I-1)*6 + J
      I2 = I1 + 18
      J1 = (II-1)*30 + (JJ-1)*180 + I1 + 21
      J2 = J1 + 18
      PH1OUT(J1) = PH2(I1)
      IF (I .NE. 3) PH1OUT(J2) = PH3(I1)
  290 CONTINUE
C
  300 IF (MATID1 .EQ. 0) GO TO 330
      DO 310 I = 1,3
      DO 310 J = 1,2
      JI = (I-1)*5 + J
      IJ = (J-1)*3 + I + (II-1)*6
      TM(JI) = TMMM(IJ)
  310 CONTINUE
      DO 320 I = 1,3
      DO 320 J = 1,3
      JI = (I-1)*5  + J + 2
      IJ = (I-1)*18 + J + (II-1)*3
      TM(JI) = TMBQ(IJ)
  320 CONTINUE
      IF (ICS(II) .NE. 0) CALL GMMATS (EE,6,5,+1, BALOTR,6,6,0, EE1)
      IJ1 = (JJ-1)*108 + (II-1)*18 + 762
      CALL  GMMATS (EMOD,3,3,0, TM(1),3,5,0, EPH1)
      IF (ICS(II) .EQ. 0) CALL GMMATS (EPH1,3,5,0,EE,6,5,+1,PH1OUT(IJ1))
      IF (ICS(II) .NE. 0) CALL GMMATS (EPH1,3,5,0,EE1,5,6,0,PH1OUT(IJ1))
  330 CONTINUE
  340 CONTINUE
C
      JST = 742 + (JJ-1)*3
      IF (MATID2 .NE. 0) CALL GMMATS (D,3,3,0,ALF(1),3,1,0,PH1OUT(JST))
      IF (MATID1 .NE. 0) CALL GMMATS (EMOD,3,3,0,ALF(1),3,1,0,
     1    PH1OUT(1194))
      IF (MATID1 .EQ. 0) GO TO 360
      DO 350 I = 1,7
  350 NPH1OU(753+I) = IEST(I)
      GO TO 380
  360 DO 370 I = 1,7
      NPH1OU(753+I) = 0
  370 CONTINUE
  380 PH1OUT(761) = TREF
      RETURN
      END

      SUBROUTINE IFPPVC (*,IPVS,JR)
C
C     IFPPVC TAKES 1PARM AND 1VARY CARDS AND MAKES A SCRATCH FILE
C     TO USE IN MODIFYING OTHER BULK DATA CARDS
C
      LOGICAL         ABORT
      INTEGER         DUM,T1,BLANK,JR(1),NAME(2)
      DIMENSION       Z(1)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /SYSTEM/ IBUF,NOUT,ABORT,DUM(79),JRUN
      COMMON /IFPDTA/ ID(2),KN,D1(52),M(50),MF(50),M1(35),M1F(35),
     1                D2(3),NOPEN,D3(6),KNT,D4(18)
      COMMON /ZZZZZZ/ KOR(1)
      COMMON /IFPX1 / NCDS,T1(2,1)
      EQUIVALENCE     (KOR(1), Z(1))
      DATA    NCDSMX, IFIL,  IPLUS, ISTAR, NPTP,  ITHR,  BLANK   /
     1        343,    213,   1H+,   1H*,   4HNPTP,4HTHRU,4H      /
      DATA    IVAR,   IPAR,  IVAR1, IPAR1, NAME                  /
     1        4HAVAR, 4HAPAR,4H1VAR,4H1PAR,4HIFPP,4HVC           /
C
      ISTOP = 0
      ICS   = 0
      LTJ   = 0
      ISORT = 0
      IPP   = 2*IBUF + 2
      LN    = IPP
      II    = IPP - 1
      LST   = 0
      NV    = 0
      IDON  = 0
      IF0   = 0
      IOLDN = 0
      ISV   = 0
      IPLUS = KHRFN1(BLANK,4,IPLUS,1)
      ISTAR = KHRFN1(BLANK,4,ISTAR,1)
      CALL SSWTCH (42,L42)
      GO TO 20
C
C     READ NEW CARD
C
   10 CALL READ (*410,*410,NPTP,JR,20,1,KDUM)
      KNT = KNT + 1
   20 IT  = KHRFN1(BLANK,4,JR(1),1)
      IF (IT.EQ.IPLUS .OR. IT.EQ.ISTAR) GO TO 420
      IF (JR(1) .EQ. IVAR1) GO TO 90
      IF (JR(1) .NE. IPAR1) GO TO 300
C
C     1PARM CARDS
C
      JR(1) = IPAR
      IF (L42 .EQ. 0) CALL RCARD2 (M1,M1F,NW,JR)
      IF (L42 .NE. 0) CALL RCARD  (M1,M1F,NW,JR)
      IF (NW .NE. 10) GO TO 430
C
C     CHECK FORMAT
C
      IF (M1F(2).NE.1 .OR. M1(3).LT.0) GO TO 430
      IF (M1(3) .LT. JRUN) GO TO 10
      IF (M1F(3).NE.0 .AND. M1F(3).NE.1) GO TO 430
      IF (M1F(5).NE.0 .AND. M1F(5).NE.1) GO TO 430
      IF (M1F(7).NE.0 .AND. M1F(7).NE.1) GO TO 430
      IF (M1( 4).LT.0  .OR. M1( 6).LT.0) GO TO 430
      IF (M1( 8).LT.0  .OR. M1F(9).NE.0) GO TO 430
      IF (M1F(4).NE.2 .AND. M1F(4).NE.0) GO TO 430
      IF (M1F(6).NE.2 .AND. M1F(6).NE.0) GO TO 430
      IF (M1F(8).NE.2 .AND. M1F(8).NE.0) GO TO 430
      IF (JRUN .EQ. 0) GO TO 10
      IF (M1(3).NE.JRUN .AND. ISORT.EQ.0) GO TO 80
      IF (M1(3) .NE. JRUN) GO TO 40
C
C     FORM LIST OF K  SK PAIRS FOR THIS J
C
      ISORT = 1
   25 IF (IPP .GE. NOPEN) GO TO 440
      DO 30 I = 3,7,2
      IF (M1F(I).EQ.0 .AND. M1F(I+1).NE.0) GO TO 430
      IF (M1F(I) .EQ. 0) GO TO 30
      KOR(IPP  ) = M1(I+1)
      KOR(IPP+1) = M1(I+2)
      IPP = IPP + 2
   30 CONTINUE
      GO TO 10
C
C     SORT LIST ERROR IF DUPLICATE
C
   40 I  = LN
      IT = 0
      N  = IPP - I
      IF (N .LT. 3) GO TO 50
      CALL SORT (0,0,2,-1,KOR(I),N)
      IT = KOR(I)
      J  = N - 1
      DO 45 K = 2,J,2
      IF (KOR(I+K) .NE. IT) GO TO 42
      ABORT = .TRUE.
      WRITE (NOUT,450) UFM,IT
   42 IT = KOR(I+K)
   45 CONTINUE
   50 ISORT = 0
      IF (ICS .NE. 0) GO TO 55
      LST= N
      LN = IPP
   55 IF (JR(1) .EQ. IVAR1) GO TO 100
      IF (IDON .EQ. 1) GO TO 310
C
C     CHECK FOR DUPLICATE K ON 1PARM ON JRUN = 1
C
   80 IF (JRUN .NE. 1) GO TO 10
      IF (ICS  .NE. 0) GO TO 82
      ICS = 1
      LTJ = M1(3)
   82 IF (LTJ .EQ. M1(3)) GO TO 25
      LTJ = M1(3)
      GO TO 40
C
C     1VARY CARDS START BUILDING SCRATCH FILE
C
   90 IF (ISORT.EQ.1 .OR. LTJ.NE.0) GO TO 40
C
C     IF LST = 0 USE ALL DEFAULT VALUES FOR SK
C
  100 LTJ = 0
      NV  = NV + 1
      JR(1) = IVAR
      IF (L42 .EQ. 0) CALL RCARD2 (M1,M1F,NW,JR)
      IF (L42 .NE. 0) CALL RCARD  (M1,M1F,NW,JR)
      IF (NW.LT.10 .OR. NW.GT.12) GO TO 430
C
C     CHECK FORMAT
C
      IF (M1F(2) .NE. 3) GO TO 430
      IF (M1F(3).NE.1  .OR. M1F(4).NE.1) GO TO 430
      IF (M1( 5).LE.0  .OR. M1( 6).LE.0) GO TO 430
      IF (M1F(5).NE.0 .AND. M1F(5).NE.2) GO TO 430
      IF (M1F(6).NE.0 .AND. M1F(6).NE.2) GO TO 430
      IF (M1F(7).NE.0 .AND. M1F(7).NE.1) GO TO 430
      IF (M1F(8).NE.0 .AND. M1F(8).NE.1 .AND. M1F(8).NE.3) GO TO 430
      IF (M1F(9).NE.0 .AND. M1F(9).NE.1) GO TO 430
      IF (M1F(7).EQ.0 .AND. M1F(8).EQ.0 .AND. M1F(9).EQ.0) GO TO 430
      IF (M1F(7).EQ.1 .AND. M1( 9).EQ.0) GO TO 430
      IF (M1F(8).EQ.1 .AND. M1(10).EQ.0) GO TO 430
      I = 0
      IF (M1F(8) .EQ. 3) I = 1
      IF (M1F(9).EQ.1 .AND. M1(I+11).EQ. 0) GO TO 430
      IF (M1F(8).EQ.3 .AND. M1(10).NE.ITHR) GO TO 430
      IF (M1F(8).EQ.3 .AND. M1(9).GT.0 .AND. M1(12).LT.0) GO TO 430
      IF (M1F(8).EQ.3 .AND. M1(9).LT.0 .AND. M1(12).GT.0) GO TO 430
      IF (JRUN .EQ. 0) GO TO 10
      DO 105 KN = 1,NCDSMX
      IF (M1(3).EQ.T1(1,KN) .AND. M1(4).EQ.T1(2,KN)) GO TO 110
  105 CONTINUE
      GO TO 460
  110 IF (KN.NE.IOLDN .AND. IOLDN.NE.0) GO TO 140
  112 IOLDN = KN
C
C     START A LIST WITH THIS NUMONIC
C
      IFIELD = M1(5)
      K      = M1(6)
      IA     = M1(7)
      IB     = M1(8)
      IF (M1F(8) .EQ. 3) GO TO 120
      IF (LST+ISV+18 .GT. NOPEN) GO TO 440
      DO 115 I = 7,9
      IF (M1F(I) .EQ. 0) GO TO 115
      KOR(LN+ISV  ) = KN
      KOR(LN+ISV+1) = M1(I+2)
      KOR(LN+ISV+2) = IFIELD
      KOR(LN+ISV+3) = K
      KOR(LN+ISV+4) = IA
      KOR(LN+ISV+5) = IB
      ISV = ISV + 6
  115 CONTINUE
      GO TO 10
C
C     THRU OPTION
C
  120 N1 = M1(9)
      N2 = M1(12)
      IF (N2 .GE. N1) GO TO 125
      IT = N1
      N1 = N2
      N2 = IT
  125 IF (LST+ISV+(IABS(N2-N1)*6) .GT. NOPEN) GO TO 440
  130 KOR(LN+ISV  ) = KN
      KOR(LN+ISV+1) = N1
      KOR(LN+ISV+2) = IFIELD
      KOR(LN+ISV+3) = K
      KOR(LN+ISV+4) = IA
      KOR(LN+ISV+5) = IB
      ISV = ISV + 6
      N1  = N1  + 1
      IF (N1 .LE. N2) GO TO 130
      GO TO 10
C
C     THIS TYPE OF CARD IS DONE SORT LIST AND MAKE FILE
C     SORT ON ID THEN FIELD THEN K
C
  140 IF (ISV .EQ. 6) GO TO 150
      CALL SORT (0,0,6,-2,KOR(LN),ISV)
      CALL SORT (0,0,6,-3,KOR(LN),ISV)
      CALL SORT (0,0,6,-4,KOR(LN),ISV)
C
C     FIX UP CORE FOR THIS BUFFER AND OPEN FILE
C
  150 IF (IF0 .NE. 0) GO TO 160
      IBUF1 = NOPEN + 2*IBUF
      NOPEN = NOPEN - IBUF
      IF0   = 1
      IF (LST+ISV .GT. NOPEN) GO TO 440
      CALL OPEN (*470,IFIL,KOR(IBUF1+1),1)
C
C     TEST FOR DUPLICATE K FOR SAME FIELD AND ID PLUS SORT AND REG
C
  160 IF (ISV .EQ. 6) GO TO 220
      IT  = KOR(LN+1)
      ICS = KOR(LN+2)
      IK  = KOR(LN+3)
      DO 210 I = 7,ISV,6
      IF (IT.EQ.KOR(LN+I).AND.ICS.EQ.KOR(LN+I+1).AND.IK.EQ.KOR(LN+I+2))
     1   GO TO 170
      GO TO 180
  170 ABORT = .TRUE.
      WRITE (NOUT,480) UFM,IT,ICS,IK
  180 IF (IT.LT.0 .AND. KOR(LN+I).GT.0) GO TO 220
      IF (IT.GT.0 .AND. KOR(LN+I).LT.0) GO TO 200
  190 IT  = KOR(LN+I  )
      ICS = KOR(LN+I+1)
      IK  = KOR(LN+I+2)
      GO TO 210
  200 J = KOR(LN)
      WRITE (NOUT,485) UFM,T1(1,J),T1(2,J)
      GO TO 190
  210 CONTINUE
C
C     PUT OUT CARDS SORT TYPE OF IDS (NEG) DO IN REVERSE
C     FIND VALUES OF SK FOR EACH K
C
  220 N = 6
      I = LN
      IF (KOR(LN+1) .GT. 0) GO TO 230
      N = -6
      I = LN + ISV - 6
  230 A = 0.0
      IF (KOR(I+3).EQ.JRUN .AND. LST.EQ.0) A = 1.0
      IF (LST .EQ. 0) GO TO 250
      DO 240 K = 1,LST,2
      IF (KOR(I+3) .NE. KOR(II+K)) GO TO 240
      A = Z(II+K+1)
      GO TO 250
  240 CONTINUE
  250 Z(I+3) = A
      IT = KOR(I+1)
      ICS= KOR(I+2)
      IF (IT.GT.0 .AND .ICS.EQ.2) GO TO 260
      J = ICS/10
      J = J*10
      IF (J .NE. ICS) GO TO 270
  260 ABORT = .TRUE.
      J = KOR(LN)
      WRITE (NOUT,500) UFM,T1(1,J),T1(2,J),IT,ICS
      GO TO 280
  270 J = (ICS-1)/ 10
      J = J*10
      IF (J .EQ. ICS-1) GO TO 260
  280 CONTINUE
      IF (ABORT .OR. A.EQ.0.0) GO TO 290
      CALL WRITE (IFIL,KOR(I),6,0)
  290 I = I + N
      ISV = ISV - IABS(N)
      IF (ISV .GT. 0) GO TO 230
      ISV = 0
      IF (IDON .EQ. 1) GO TO 310
      GO TO 112
C
C     CARDS ARE DONE
C
  300 IDON = 1
      IF (JRUN .EQ. 0) GO TO 320
      IF (NV.EQ.0 .AND. JRUN.GT.0) GO TO 490
      IF (NV .EQ. 0) GO TO 310
      GO TO 140
  310 IF (JRUN .EQ. 0) GO TO 320
      CALL WRITE (IFIL,0,0,1)
      CALL CLOSE (IFIL,1)
      IPVS = 1
  320 IF (ISTOP .EQ. 0) RETURN
      IF (ISTOP .EQ. 1) RETURN 1
C
C     ERROR MESSAGES
C
  400 ABORT = .TRUE.
      IF (IDON-1) 10,310,10
  410 WRITE  (NOUT,415) UFM
  415 FORMAT (A23,', NO BULK DATA CARDS TO MODIFY.  ERROR IN IFPPVC')
      ISTOP = 1
      GO TO  310
  420 WRITE  (NOUT,425) UFM,JR
  425 FORMAT (A23,' 312, NO CONTINUATION CARD ALLOWED ON 1PARM OR ',
     1       '1VARY CARDS', /5X,'CARD- ',20A4)
      GO TO  400
  430 I = KNT +1
      WRITE  (NOUT,435) UFM,M1(1),M1(2),I,JR
  435 FORMAT (A23,' 317, ILLEGAL DATA OR FORMAT ON CARD ',2A4,' SORTED',
     1        I8 ,/5X,'CARD- ' ,20A4)
      GO TO  400
  440 WRITE  (NOUT,445) UFM
  445 FORMAT (A23,' 3008, NOT ENOUGH CORE FOR 1PARM AND 1VARY CARDS')
      GO TO  400
  450 FORMAT (A23,' 314, DUPLICATE OR NO K  ON 1PARM CARDS FOR SOME J ',
     1       'K =',I9)
  460 WRITE  (NOUT,465) UFM,M1(3),M1(4)
  465 FORMAT (A23,'316, CARD TYPE ',2A4,' NOT LEGAL ON 1VARY')
      GO TO  400
  470 CALL MESAGE (-1,IFIL,NAME)
  480 FORMAT (A23,'314, DUPLICATE K FOR  ID',I9,' FIELD',I9,' K',I9)
  485 FORMAT (A23,'316, ILLEGAL TO USE SORTED COUNT AND REGULAR ID ON ',
     1       'SAME TYPE OF CARD ',2A4)
  490 WRITE  (NOUT,495) UFM
  495 FORMAT (A23,', NO 1VARY CARDS TO GO WITH 1PARM CARDS.  ERROR IN ',
     1       'IFPPVC')
      IF (ISORT.EQ.1 .OR. LTJ.NE.0) GO TO 40
      GO TO  400
  500 FORMAT (A23,'31, CARD TYPE ',2A4,' ID =',I9,' HAS ILLEGAL FIELD',
     1        I9)
      END

      SUBROUTINE CFNOR2 (RIGHT,LEFT,SIZE2,OPTION,RI)
C
C     CFNOR2 IS A DOUBLE-PRECISION ROUTINE (CREATED FOR USE BY
C     THE COMPLEX FEER METHOD) WHICH NORMALIZES A COMPLEX PAIR
C     OF VECTORS TO MAGNITUDE UNITY
C
C     DEFINITION OF INPUT PARAMETERS
C
C     RIGHT    = ORIGINAL RIGHT-HANDED COMPLEX DOUBLE PRECISION VECTOR
C     LEFT     = ORIGINAL LEFT -HANDED COMPLEX DOUBLE PRECISION VECTOR
C     SIZE2    = LENGTH OF EITHER VECTOR IN DOUBLE PRECISION WORDS
C                (I.E., TWICE THE LENGTH OF THE COMPLEX VECTORS)
C     OPTION   = 0  NORMALIZE THE INPUT VECTORS, AND OUTPUT THE
C                   SQUARE ROOT OF THE INNER PRODUCT IN RI(2)
C              = 1  ONLY OUTPUT INNER-PRODUCT, IN RI(2)
C              = 2  ONLY OUTPUT SQUARE ROOT OF INNER-PRODUCT, IN RI(2)
C
C     DEFINITION OF OUTPUT PARAMETERS
C
C     RIGHT    = NORMALIZED RIGHT-HANDED VECTOR
C     LEFT     = NORMALIZED LEFT -HANDED VECTOR
C     RI       = INNER-PRODUCT, OR SQUARE ROOT OF INNER-PRODUCT (SEE
C                OPTION)
C
      LOGICAL          SKIP     ,QPR
      INTEGER          SIZE2    ,OPTION
      DOUBLE PRECISION RIGHT(1) ,LEFT(1)  ,RI(2)    ,RSQRT    ,
     1                 THETA2   ,RJ(2)
      CHARACTER        UFM*23   ,UWM*25
      COMMON  /XMSSG / UFM      ,UWM
      COMMON  /FEERXC/ DUMXC(21),QPR
      COMMON  /SYSTEM/ KSYSTM(65)
      EQUIVALENCE      (KSYSTM(2),NOUT)
C
      SKIP = .FALSE.
C
C     COMPUTE INNER PRODUCT (LEFT*RIGHT)
C
    5 RI(1) = 0.D0
      RI(2) = 0.D0
      DO 10 I = 1,SIZE2,2
      J = I + 1
      RI(1) = RI(1) + LEFT(I)*RIGHT(I) - LEFT(J)*RIGHT(J)
   10 RI(2) = RI(2) + LEFT(J)*RIGHT(I) + LEFT(I)*RIGHT(J)
      IF (OPTION .EQ. 1) GO TO 50
      IF (SKIP) GO TO 200
C
C     COMPUTE MAGNITUDE OF SQUARE ROOT
C
      RSQRT = DSQRT(DSQRT(RI(1)**2 + RI(2)**2))
      IF (RSQRT .GT. 0.D0) GO TO 30
      WRITE  (NOUT,20) UWM
   20 FORMAT (A25,' 3162', //5X,'ATTEMPT TO NORMALIZE NULL VECTOR. ',
     1        'NO ACTION TAKEN.'//)
      GO TO 50
C
C     COMPUTE MODULUS OF SQUARE ROOT
C
   30 THETA2 = .5D0*DATAN2(RI(2),RI(1))
C
C     COMPUTE REAL AND IMAGINARY PARTS OF SQUARE ROOT OF INNER PRODUCT
C
      RI(1) = RSQRT*DCOS(THETA2)
      RI(2) = RSQRT*DSIN(THETA2)
      IF (OPTION .EQ. 2) GO TO 50
      RJ(1) = RI(1)
      RJ(2) = RI(2)
C
C     INVERT THE ABOVE COMPLEX NUMBER (THETA2 IS DUMMY)
C
      THETA2= 1.D0/(RI(1)**2 + RI(2)**2)
      RI(1) = RI(1)*THETA2
      RI(2) =-RI(2)*THETA2
C
C     NORMALIZE THE INPUT VECTORS
C
      DO 40 I = 1,SIZE2,2
      J = I + 1
      THETA2   = RIGHT(I)
      RIGHT(I) = RI(1)*RIGHT(I) - RI(2)*RIGHT(J)
      RIGHT(J) = RI(2)*THETA2   + RI(1)*RIGHT(J)
      THETA2   = LEFT(I)
      LEFT(I)  = RI(1)*LEFT(I)  - RI(2)*LEFT(J)
   40 LEFT(J)  = RI(2)*THETA2   + RI(1)*LEFT(J)
C
C     ----------- SPECIAL PRINT ----------------------------------------
      IF (.NOT.QPR) GO TO 45
      SKIP = .TRUE.
      GO TO 5
  200 THETA2 = DSQRT(RI(1)**2 + RI(2)**2)
      WRITE  (NOUT,300) THETA2,RI
  300 FORMAT (3H --,32(4H----), /,7H CFNOR2,26X,
     1       16HOUTPUT MAGNITUDE,D16.8,8X,2D16.8, /,3H --,32(4H----))
      WRITE  (NOUT,400) (RIGHT(I),I=1,SIZE2)
  400 FORMAT ((1H ,4D25.16))
      WRITE  (NOUT,500)
  500 FORMAT (3H --,32(4H----))
      WRITE  (NOUT,400) (LEFT(I),I=1,SIZE2)
      WRITE  (NOUT,500)
C     ------------------------------------------------------------------
C
   45 RI(1) = RJ(1)
      RI(2) = RJ(2)
   50 RETURN
      END

      SUBROUTINE RCOVUO (PID,UAO,LASTSS)
C
C     THIS SUBROUTINE CALCULATES THE FULL SIZE DISPLACEMENT VECTOR ON
C     ANY OMITTED POINTS.  THE OPTIONAL INERTIA AND DAMPING EFFECTS
C     WILL BE INCLUDED IF REQUESTED.
C
C     FILE USAGE IS AS FOLLOWS
C
C     SCR1 AND SCR5 ARE NOT USED
C     SCR4 CONTAINS PID ON INPUT AND IS DESTROYED
C     SCR7 CONTAINS UAO OUTPUT
C     ALL OTHER SCRATCH FILES ARE USED
C
      INTEGER          RULE       ,PAO        ,BUF1       ,PID        ,
     1                 RC         ,UAO        ,TYPIN      ,TYPOT      ,
     2                 POVE       ,DRY        ,STEP       ,FSS        ,
     3                 RFNO       ,UINMS      ,UA         ,LASTSS(2)  ,
C    4                 SOLN       ,SRD        ,SWRT       ,SCHK       ,
     5                 IZ(1)      ,RD         ,RDREW      ,WRT        ,
     6                 WRTREW     ,REW        ,EOFNRW     ,RSP        ,
     7                 RDP        ,CSP        ,CDP        ,SQUARE     ,
     8                 RECT       ,DIAG       ,UPPER      ,LOWER      ,
     9                 SYM        ,SCRA       ,SCRB       ,SDCMPZ     ,
     O                 SCR4       ,NAME(2)    ,POWER      ,FILE       ,
     1                 MCBPAO(7)  ,SCR3       ,UMCB       ,BMCB       ,
     2                 SCRC       ,CHLSKY     ,XMCB       ,FBSZ       ,
     3                 PREC       ,SIGN       ,SCR2       ,
     4                 UPRT       ,SCR7       ,SCR6       ,SCR8       ,
     5                 SOF1       ,SOF2       ,SOF3       ,SCR9       ,
     6                 TYPA       ,TYPB
      DOUBLE PRECISION DZ(1)      ,DET        ,DETI       ,MINDIA
      CHARACTER        UFM*23     ,UWM*25     ,UIM*29     ,SFM*25     ,
     1                 SWM*27
      COMMON /XMSSG /  UFM        ,UWM        ,UIM        ,SFM        ,
     1                 SWM
      COMMON /BLANK /  DRY        ,LOOP       ,STEP       ,FSS(2)     ,
     1                 RFNO       ,NEIGV      ,LUI        ,UINMS(2,5) ,
     2                 NOSORT     ,UTHRES     ,PTHRES     ,QTHRES
      COMMON /RCOVCR/  ICORE      ,LCORE      ,BUF1       ,BUF2       ,
     1                 BUF3       ,BUF4       ,SOF1       ,SOF2       ,
     2                 SOF3
      COMMON /RCOVCM/  MRECVR     ,UA         ,PA         ,QA         ,
     1                 IOPT       ,RSS(2)     ,ENERGY     ,UIMPRO     ,
     2                 RANGE(2)   ,IREQ       ,LREQ       ,LBASIC
      COMMON /SYSTEM/  SYSBUF     ,NOUT
      COMMON /SADDX /  NOMAT      ,LCOR       ,MCBAA(7)   ,TYPA       ,
     1                 ALPHA      ,ALP(3)     ,MCBBB(7)   ,TYPB       ,
     2                 BETA       ,BET(3)     ,DUM(36)    ,MCBXX(7)
      COMMON /NAMES /  RD         ,RDREW      ,WRT        ,WRTREW     ,
     1                 REW        ,NOREW      ,EOFNRW     ,RSP        ,
     2                 RDP        ,CSP        ,CDP        ,SQUARE     ,
     3                 RECT       ,DIAG       ,UPPER      ,LOWER      ,
     4                 SYM
      COMMON /PACKX /  TYPIN      ,TYPOT      ,IRO        ,NRO        ,
     1                 INCRP
      COMMON /PARMEG/  MCBK(7)    ,MCBK11(7)  ,MCBK21(7)  ,MCBK12(7)  ,
     1                 MCBK22(7)  ,MRGZ       ,RULE
      COMMON /SFACT /  MCBA(7)    ,MCBL(7)    ,MCBLT(7)   ,SCRA       ,
     1                 SCRB       ,SDCMPZ     ,DET        ,DETI       ,
     2                 POWER      ,SCRC       ,MINDIA     ,CHLSKY
      COMMON /FBSX  /  LMCB(7)    ,UMCB(7)    ,BMCB(7)    ,XMCB(7)    ,
     1                 FBSZ       ,PREC       ,SIGN
      COMMON /ZZZZZZ/  Z(1)
      EQUIVALENCE      (Z(1),IZ(1),DZ(1))
      DATA    NAME  /  4HRCOV,4HUO   /
      DATA    POVE  ,  LMTX / 4HPOVE,4HLMTX /
      DATA    UPRT  ,  KMTX / 4HUPRT,4HKMTX /
      DATA    SCR2  ,  SCR3,SCR4,SCR6,SCR7,SCR8,SCR9 /
     1        302   ,  303 ,304 ,306 ,307 ,308 ,309  /
C
C     SET UP COMMON BLOCKS
C
      LCOREZ = KORSZ(Z) - LREQ - ICORE - 1
      IDPCOR = ICORE/2 + 1
      RULE   = 0
      MCBK21(1) = 0
      MCBK12(1) = 0
      MCBK22(1) = 0
      SIGN   = 1
C
C     CALCUATE THE LOADS ON THE OMMITED POINTS
C
      PAO = 0
      IF (RFNO .EQ. 3) GO TO 10
      PAO = SCR3
      CALL RCOVSL (LASTSS,POVE,0,SCR6,SCR7,SCR8,PAO,Z(ICORE),Z(ICORE),
     1             SOF3-ICORE-1,.FALSE.,RFNO)
      MCBPAO(1) = PAO
      CALL RDTRL (MCBPAO)
C
C     ADD IN OPTIONAL INERTIA AND DAMPING FORCES TO THE LOADS ON THE
C     OMMITED POINTS
C
  10  IF (PID .EQ. 0) GO TO 200
      IF (PAO .EQ. 0) GO TO 120
      NOMAT = 2
      TYPA  = 1
      ALPHA = 1.0
      MCBAA(1) = PID
      CALL RDTRL (MCBAA)
      TYPB  = 1
      BETA  = 1.0
      MCBBB(1) = PAO
      CALL RDTRL (MCBBB)
      CALL MAKMCB (MCBXX,SCR6,MCBAA(3),RECT,MCBAA(5))
      MCBXX(2) = MCBAA(2)
      LCOR  = LCOREZ
      CALL SOFCLS
      CALL SADD (DZ(IDPCOR),DZ(IDPCOR))
      CALL WRTTRL (MCBXX)
      DO 110 I = 1,7
  110 MCBPAO(I) = MCBXX(I)
      CALL SOFOPN (Z(SOF1),Z(SOF2),Z(SOF3))
      GO TO 200
C
C     NO STATIC LOADS SO THE ADD IS UNECESSARY
C
  120 MCBPAO(1) = PID
      CALL RDTRL (MCBPAO)
C
  200 IF (MCBPAO(1) .LE. 0) GO TO 500
C
C     CHECK FOR EXISTENCE OF LMTX ON THE SOF.  IF IT EXISTS
C     SKIP THE PARTN AND DECOMP
C
      CALL SOFTRL (LASTSS,LMTX,LMCB(1))
      IF (LMCB(1) .NE. 1) GO TO 395
C
C     BRING IN LMTX FROM SOF AND SET UP FOR FBS DIRECTLY
C
      CALL MTRXI (SCR2,LASTSS,LMTX,0,RC)
      DO 390 I = 1,7
  390 BMCB(I) = MCBPAO(I)
      LMCB(1) = SCR2
      CALL SOFCLS
      GO TO 411
C
C     COMPUTE THE KOO PARTITION OF KMTX FOR LASTSS
C
C     COPY THE PARTITIONING VECTOR TO SCR2
C
  395 CALL MTRXI (SCR2,LASTSS,UPRT,0,RC)
      ITEM = UPRT
      IF (RC .NE. 1) GO TO 6317
C
C     COPY KMTX TO SCR5
C
      ITEM = KMTX
      CALL MTRXI (SCR8,LASTSS,KMTX,0,RC)
      IF (RC .NE. 1) GO TO 6317
      MCBK(1) = SCR8
      CALL RDTRL (MCBK)
C
C     PARTITION KMTX INTO KOO.  STORE KOO ON SCR4.
C
      CALL SOFCLS
      IZ(ICORE) = SCR2
      CALL RDTRL (IZ(ICORE))
      CALL MAKMCB (MCBK11,SCR9,MCBPAO(3),SYM,MCBK(5))
      MCBK11(2) = MCBPAO(3)
      MRGZ = LCOREZ - 7
      I    = (ICORE+7)/2 + 1
      CALL PARTN (Z(ICORE),Z(ICORE),DZ(I))
      CALL WRTTRL (MCBK11)
C
C     DECOMPOSE KOO
C
      DO 400 I = 1,7
  400 MCBA(I) = MCBK11(I)
      CALL MAKMCB (MCBL,SCR2,MCBA(3),LOWER,MCBA(5))
      MCBLT(1) = SCR8
      SCRA = SCR3
      IF (SCRA .EQ. MCBPAO(1)) SCRA = SCR6
      SCRB = SCR4
      IF (SCRB .EQ. MCBPAO(1)) SCRB = SCR6
      SCRC = SCR7
      SDCMPZ = MRGZ
      POWER  = 1
      CHLSKY = 0
      CALL SDCOMP (*6311,DZ(IDPCOR),DZ(IDPCOR),DZ(IDPCOR))
      CALL WRTTRL (MCBL)
C
C     FORWARD AND BACKWARD SUBSTITUTION TO SOLVE FOR UAO
C
      DO 410 I = 1,7
      LMCB(I) = MCBL(I)
  410 BMCB(I) = MCBPAO(I)
  411 FBSZ   = LCOREZ
      MATTYP = BMCB(5)
      CALL MAKMCB (XMCB,SCR8,BMCB(3),RECT,MATTYP)
      PREC = 2 - (MATTYP-2*(MATTYP/2))
      CALL FBS (DZ(IDPCOR),DZ(IDPCOR))
      CALL WRTTRL (XMCB)
C
C     MERGE UAO INTO THE UA SET
C
C     COPY UPRT BACK TO SCR2
C
      CALL SOFOPN (Z(SOF1),Z(SOF2),Z(SOF3))
      ITEM = UPRT
      CALL MTRXI (SCR2,LASTSS,UPRT,0,RC)
      IF (RC .NE. 1) GO TO 6317
      CALL SOFCLS
      IZ(ICORE) = SCR2
      CALL RDTRL (IZ(ICORE))
C
C     SETUP MCB-S IN /PARMEG/
C
      DO 412 I = 1,7
  412 MCBK11(I) = XMCB(I)
      UAO = SCR7
      CALL MAKMCB (MCBK,UAO,IZ(ICORE+2),RECT,MCBK11(5))
      MCBK(2) = XMCB(2)
      IF (RFNO .EQ. 9) MCBK(2) = 3*XMCB(2)
C
C     SETUP A NULL ROW PARTITIONING VECTOR OR FOR RIGID FORMAT 9 A
C     VECTOR THAT WILL MERGE IN A NULL VELOCITY AND ACCELERATION
C     VECTOR FOR EACH DISPLACEMENT VECTOR
C
      NRO = MCBK(2)
      CALL MAKMCB (Z(ICORE+7),SCR6,NRO,RECT,RSP)
      IF (NRO+15 .GT. LCOREZ) GO TO 9008
      DO 420 I = 1,NRO
  420 Z(ICORE+14+I) = 0.0
      IF (RFNO .NE. 9) GO TO 440
      DO 430 I = 1,NRO,3
      Z(ICORE+15+I) = 1.0
  430 Z(ICORE+16+I) = 1.0
  440 CONTINUE
      CALL GOPEN (SCR6,Z(BUF1),WRTREW)
      TYPIN = 1
      TYPOT = 1
      IRO   = 1
      INCRP = 1
      CALL PACK (Z(ICORE+15),SCR6,IZ(ICORE+7))
      CALL CLOSE (SCR6,REW)
      CALL WRTTRL (IZ(ICORE+7))
C
      MRGZ = LCOREZ - 14
      I    = (ICORE+14)/2 + 1
      CALL MERGE (Z(ICORE+7),Z(ICORE),DZ(I))
      CALL WRTTRL (MCBK)
C
C     NORMAL RETURN
C
      RETURN
C
C     NO LOADS SO THE DISPLACEMENTS ARE ZERO
C
  500 UAO = 0
      CALL SOFCLS
      RETURN
C
C     ERROR PROCESSING
C
 6311 WRITE  (NOUT,6312) SWM,LASTSS
 6312 FORMAT (A27,' 6311, SDCOMP DECOMPOSITION FAILED ON KOO MATRIX ',
     1       'FOR SUBSTRUCTURE ',2A4)
      GO TO 9000
 6317 IF (RC .EQ. 2) RC = 3
      CALL SMSG (RC-2,ITEM,LASTSS)
 9000 IOPT = -1
      RETURN
C
 9008 N    = 8
      IOPT = -1
      CALL SOFCLS
      CALL MESAGE (N,FILE,NAME)
      CALL CLOSE (PAO,REW)
      CALL CLOSE (SCR3,REW)
      RETURN
      END

      SUBROUTINE PSTQ2 (NPTS)
C  THIS ROUTINE CALCULATES PHASE II OUTPUT FOR PLA3
C  FOR COMBINATION ELEMENTS
C
C     ****PHASE II OF STRESS DATA RECOVERY*********
C
C     NPTS = 3 IMPLIES STRIA1 OR STRIA2  (PHASE II)
C     NPTS = 4 IMPLIES SQUAD1 OR SQUAD2  (PHASE II)
C
      DIMENSION  NSIL(4), NPH1OU(2), SI(36)
C
      COMMON /PLA3UV/ IVEC,Z(24)
      COMMON /PLA3ES/ PH1OUT(200),FORVEC(6),DUMMY(94)
      COMMON /PLA32S/ STRESS(3),TEMP,DELTA,NPOINT,I,J,NPT1,VEC(5),TEM,
     1                Z1OVRI, Z2OVRI,DUM1(308)
      COMMON /SOUT/ STR(18)
      EQUIVALENCE
     1  (NSIL(1),PH1OUT(2))
     2 ,(NPH1OU(1),PH1OUT(1))
     3 ,(SI(1),PH1OUT(9))
C
C **********************************************************************
C **********************************************************************
C
C     PHASE I OUTPUT FROM THE PLATE IS THE FOLLWOING
C
C     PH1OUT(1)                        ELEMENT ID
C     PH1OUT(2 THRU 5)                 3 SILS AND DUMMY OR 4 SILS
C     PH1OUT(6)                        I
C     PH1OUT(7 THRU 8)                 Z1 AND Z2
C     PH1OUT(9 THRU 30*NPTS+8)         3 OR 4 S SUB I  5X6 ARRAYS
C
C **********************************************************************
C
C     PHASE I OUTPUT FROM THE MEMBRANE IS THE FOLLOWING
C     NOTE..BEGIN = 30*NPTS+8
C
C     PH1OUT(BEGIN + 1)                ELEMENT ID
C     PH1OUT(BEGIN + 2 THRU BEGIN + 5) 3 SILS AND DUMMY OR 4 SILS
C     PH1OUT(BEGIN + 6)                T SUB 0
C     PH1OUT(BEGIN + 7 THRU BEGIN + 9) S SUB T  3X1 ARRAY
C     PH1OUT(BEGIN + 10 THRU BEGIN + 9*NPTS+9) 3 OR 4 S SUB I 3X3 ARRAYS
C
C **********************************************************************
C **********************************************************************
C
C     THE ABOVE ELEMENTS ARE COMPOSED OF PLATES AND MEMBRANES...
C     SOME MAY ONLY CONTAIN PLATES WHILE OTHERS MAY ONLY CONTAIN
C     MEMBRANES.
C     A CHECK FOR A ZERO FIRST SIL IN THE PHASE I OUTPUT, WHICH
C     INDICATES WHETHER ONE OR THE OTHER HAS BEEN OMITTED, IS MADE BELOW
C
C
C
C     FIRST GET FORCE VECTOR FOR THE PLATE CONSIDERATION
C
C     M ,  M ,  M  ,  V ,  V
C      X    Y    XY    X    Y
C
C                                NPTS
C     THE  5X1 FORCE VECTOR = SUMMATION  (S )(U )
C                                I=1       I   I
C
C
C     ZERO OUT LOCAL STRESSES
C
      SIG X  1 = 0.0E0
      SIG Y  1 = 0.0E0
      SIG XY 1 = 0.0E0
      SIG X  2 = 0.0E0
      SIG Y  2 = 0.0E0
      SIG XY 2 = 0.0E0
C
      IF( NSIL(1) .EQ. 0 ) GO TO 30
C
C     FORM SUMMATION
C
      DO 20 I=1,NPTS
C
C     POINTER TO DISPLACEMENT VECTOR IN VARIABLE CORE
C
      NPOINT = IVEC + NSIL(I) - 1
C
      CALL GMMATS( SI(30*I-29),5,6,0,  Z(NPOINT),6,1,0,  VEC(1)  )
C
      DO 10 J=2,6
   10 FORVEC(J) = FORVEC(J) + VEC(J-1)
C
   20 CONTINUE
C
C     FORCE VECTOR IS NOW COMPLETE
C
      Z1 = PH1OUT(7)
      Z2 = PH1OUT(8)
C
      Z1 OVR I = - PH1OUT(7) / PH1OUT(6)
      Z2 OVR I = - PH1OUT(8) / PH1OUT(6)
C
      SIG X  1 = FORVEC(2) * Z1 OVR I
      SIG Y  1 = FORVEC(3) * Z1 OVR I
      SIG XY 1 = FORVEC(4) * Z1 OVR I
      SIG X  2 = FORVEC(2) * Z2 OVR I
      SIG Y  2 = FORVEC(3) * Z2 OVR I
      SIG XY 2 = FORVEC(4) * Z2 OVR I
C     *******************************
C
      GO TO 40
   30 Z1 = 0.0E0
      Z2 = 0.0E0
C
C     FIND SIG X, SIG Y, SIG XY, FOR MEMBRANE CONSIDERATION
   40 IF( NPH1OU(30*NPTS+10) .EQ. 0 ) GO TO 90
C
C
C                        I=NPTS
C     STRESS VECTOR = ( SUMMATION(S )(U ) )
C                        I=1       I   I
C
      DO 60 I=1,NPTS
C
C     POINTER TO I-TH SIL IN PH1OUT
      NPOINT = 30*NPTS + 9 + I
C     POINTER TO DISPLACEMENT VECTOR IN VARIABLE CORE
      NPOINT = IVEC + NPH1OU (NPOINT) - 1
C
C     POINTER TO S SUB I 3X3
      NPT1 = 30 * NPTS + 9 + 9 * I
C
      CALL GMMATS ( PH1OUT(NPT1),3,3,0,  Z(NPOINT),3,1,0,  VEC(1)  )
C
      DO 50 J=1,3
   50 STRESS(J) = STRESS(J) + VEC(J)
C
   60 CONTINUE
C
C
C     ADD MEMBRANE STRESSES TO PLATE STRESSES
C
      SIG X  1 = SIG X  1 + STRESS(1)
      SIG Y  1 = SIG Y  1 + STRESS(2)
      SIG XY 1 = SIG XY 1 + STRESS(3)
      SIG X  2 = SIG X  2 + STRESS(1)
      SIG Y  2 = SIG Y  2 + STRESS(2)
      SIG XY 2 = SIG XY 2 + STRESS(3)
C
C     STRESS OUTPUT VECTOR IS THE FOLLOWING
C
C      1) ELEMENT ID
C      2) Z1 = FIBER DISTANCE 1
C      3) SIG X  1
C      4) SIG Y  1
C      5) SIG XY 1
C      6) ANGLE OF ZERO SHEAR AT Z1
C      7) SIG P1 AT Z1
C      8) SIG P2 AT Z1
C      9) TAU MAX = MAXIMUM SHEAR STRESS AT Z1
C
C     10) ELEMENT ID
C     11) Z2 = FIBER DISTANCE 2
C     12) SIG X  2
C     13) SIG Y  2
C     14) SIG XY 2
C     15) ANGLE OF ZERO SHEAR AT Z2
C     16) SIG P1 AT Z2
C     17) SIG P2 AT Z2
C     S7) SIG P2 AT Z2
C     18) TAU MAX = MAXIMUM SHEAR STRESS AT Z2
C
C
   90 IF( NPH1OU(2) .EQ. 0 .AND. NPH1OU(30*NPTS+10) .EQ. 0 ) GO TO 120
C
C     COMPUTE PRINCIPAL STRESSES
C
      STR( 1) = PH1OUT(1)
      STR( 2) = Z1
      STR( 3) = SIG X  1
      STR( 4) = SIG Y  1
      STR( 5) = SIG XY 1
      STR(10) = PH1OUT(1)
      STR(11) = Z2
      STR(12) = SIG X  2
      STR(13) = SIG Y  2
      STR(14) = SIG XY 2
C
      DO 110 I=3,12,9
      TEMP = STR(I) - STR(I+1)
      STR(I+6) = SQRT( (TEMP/2.0E0)**2 + STR(I+2)**2 )
      DELTA = (  STR(I)  +  STR(I+1)  )  /  2.0E0
      STR(I+4) = DELTA + STR(I+6)
      STR(I+5) = DELTA - STR(I+6)
      DELTA = 2.0E0 * STR(I+2)
      IF( ABS(DELTA) .LT. 1.0E-15 .AND. ABS(TEMP) .LT. 1.0E-15)GO TO 100
      STR(I+3) = ATAN2( DELTA,TEMP ) * 28.6478898E0
      GO TO 110
  100 STR(I+3) = 0.0E0
  110 CONTINUE
C
      GO TO 140
  120 DO 130 I=2,18
  130 STR(I) = 0.0E0
  140 STR(1) = PH1OUT(1)
      STR(10) = PH1OUT(1)
C
C
C     ADDITION TO ELIMINATE 2ND ELEMENT ID IN OUTPUT
C
      DO 150 I=10,17
  150 STR(I) = STR(I+1)
C
      RETURN
      END

       SUBROUTINE ERRTRC ( NAME, IVAL )
       CHARACTER *(*) NAME
       COMMON / SYSTEM / ISYSBF, NOUT
       WRITE ( NOUT, * ) ' ERRTRC CALLED'
       WRITE ( NOUT, * ) ' NAME=',NAME
       WRITE ( NOUT, * ) ' IVAL=',IVAL
       RETURN
       END

      SUBROUTINE SSG2A (PG,PNBAR,PM,PVACT)
C
      INTEGER         PG,PNBAR,PM,PVACT,RULE,PVECT(7),CORE(6)
      COMMON /PARMEG/ IA1(7),IA11(7),IA12(7),IA21(7),IA22(7),LCR,RULE
      COMMON /PATX  / LCORE,N,NO(4)
      COMMON /ZZZZZZ/ ICORE(1)
      EQUIVALENCE     (ICORE(1),CORE(1))
C
C
      PVECT(1)= PVACT
      CALL RDTRL (PVECT)
      IA1(1)  = PG
      CALL RDTRL (IA1)
      IA11(1) = PNBAR
      IA12(1) = PM
      DO 10 I = 2,5
      IA11(I) = IA1(I)
   10 IA12(I) = IA1(I)
      IA11(3) = N
      IA12(3) = NO(1)
      IA21(1) = 0
      IA22(1) = 0
      RULE    = 0
      LCR     = KORSZ(CORE)
      CORE(1) = 0
      CORE(2) = 1
      CORE(3) = IA1(2)
      CORE(4) = 2
      CORE(5) = 1
      CORE(6) = 0
      CALL PARTN (CORE,PVECT,CORE)
      IF (IA11(1) .NE. 0) CALL WRTTRL (IA11)
      IF (IA12(1) .NE. 0) CALL WRTTRL (IA12)
      RETURN
      END

      SUBROUTINE DSSEND ( FILE )
C
C DSSEND (Dataset Set to End) will position a file to the end
C to allow for closing a file for read and opening it for write
C append.  This eliminates having to read sequentially to the end
C of the file before closing for read.
C
      INCLUDE 'DSIOF.COM'
      INCLUDE 'XNSTRN.COM'
      INTEGER    FILE
      NAME  = FILE
      CALL DSGEFL
C
C GET LAST BLOCK NUMBER IN THIS FILE FROM FCB
C
      NBLOCK = FCB( 6, IFILEX )
C
C GET CURRENT BLOCK NUMBER IN THIS FILE FROM FCB
C
      ICBLK  = FCB( 4, IFILEX )
      IF ( ICBLK .EQ. NBLOCK ) GO TO 10
      CALL DBMMGR( 6 )
10    CONTINUE
      INDCLR = IBASE( INDBAS+4) + INDBAS - 1
      INDCBP = INDCLR
      CALL DSSDCB
      RETURN
      END

      SUBROUTINE IFB2AR (TYPE,IFB,AR,L)
C
C     THIS ROUTINE STORES IN ARRAY AR(L+1) THE BCD VALUE OF IFB, AND
C     UPDATE THE L COUNTER
C
C     IF TYPE=1, IFB IS AN INTEGER, AND 8 DIGITS ARE USED IN AR, AND
C                L IS INCREASED BY 2 (INTEGER IS RIGHT ADJUSTED)
C     IF TYPE=2, IFB IS A REAL NUMBER, 12 DIGITS ARE USED IN AR, AND
C                L IS INCREASED BY 3
C     IF TYPE=3, IFB IS A BCD WORD, 4 LETTERS ARE USE IN AR, AND
C                L IS INCREASED BY 1
C
      INTEGER      IA,TYPE,IFB,AR(1),L,SUB(2),ZERO(2)
      REAL         RA,X,XL
      CHARACTER*7  FMTX,FMT(10)
      CHARACTER*8  C8
      CHARACTER*10 FMTY,FNT(9)
      CHARACTER*12 C12
      EQUIVALENCE  (IA,RA)
      DATA  FMT / '(F12.9)', '(F12.8)', '(F12.7)', '(F12.6)', '(F12.5)',
     1            '(F12.4)', '(F12.3)', '(F12.2)', '(F12.1)', '(F12.0)'/
      DATA  FNT /'(1X,F11.8)', '(1X,F11.7)', '(1X,F11.6)', '(1X,F11.5)',
     1           '(1X,F11.4)', '(1X,F11.3)', '(1X,F11.2)', '(1X,F11.1)',
     2           '(1X,F11.0)'/
      DATA  ZERO/  4H    ,    4H 0.0  /
      DATA  SUB /  4HIFB2,    4HAR    /
C
      K = -1
      J = TYPE + 1
      GO TO (300,200,300,250), J
 100  K = K + 1
      IF (K) 150,200,250
 150  CALL MESAGE (-37,0,SUB)
C
C     INTEGER, RIGHT ADJUSTED
C
 200  WRITE (C8,210,ERR=300) IFB
      READ  (C8,220) AR(L+1),AR(L+2)
 210  FORMAT (I8)
 220  FORMAT (2A4)
      L = L + 2
      RETURN
C
C     BCD WORD
C
 250  AR(L+1) = IFB
      L = L + 1
      RETURN
C
C     REAL NUMBER
C
 300  IA = IFB
      X  = ABS(RA)
      IF (X .LT. 1.0E-36) GO TO 390
      XL = ALOG10(X)
      IF (XL.GT.-4.0 .AND. XL.LT.10.0) IF (XL-1.0) 350,350,330
 310  WRITE  (C12,320,ERR=100) RA
 320  FORMAT (1P,E12.5)
      GO TO 370
 330  I = XL
      IF (RA .LT. 0.) I = I + 1
      IF (I.LE.0   .OR.   I.GT.9 ) GO TO 310
      IF (RA.GT.0. .AND. XL.GT.0.) GO TO 340
      FMTX = FMT(I)
      GO TO 360
 340  FMTY = FNT(I)
      WRITE (C12,FMTY) RA
      GO TO 370
 350  FMTX = FMT(1)
 360  WRITE  (C12,FMTX) RA
 370  READ   (C12,380) (AR(L+J),J=1,3)
 380  FORMAT (3A4)
      GO TO 400
 390  AR(L+1) = ZERO(1)
      AR(L+2) = ZERO(1)
      AR(L+3) = ZERO(2)
 400  L = L + 3
      RETURN
      END

      SUBROUTINE IHEX(TEMPS,PG,TYPE)
C
C     ELEMENT THERMAL LOAD GENERATOR FOR ISOPARAMETRIC SOLID ELEMENTS
C
C     TYPE = 1     CIHEX1
C     TYPE = 2     CIHEX2
C     TYPE = 3     CIHEX3
C
C***********************************************************************
C           THE EST ENTRIES ARE
C
C     NAME  ---------INDEX---------   DESCRIPTION
C            IHEX1   IHEX2   IHEX3
C
C     EID        1       1       1    ELEMENT ID NO.
C     SIL      2-9    2-21    2-33    SCALAR INDEX LIST
C     MID       10      22      34    MATERIAL ID NO.
C     CID       11      23      35    MATERIAL COORD. SYSTEM ID NO.
C     NIP       12      24      36    NO. INTEGRATION POINTS PER EDGE
C     MAXAR     13      25      37    MAX ASPECT RATIO
C     ALFA      14      26      38    MAX ANGLE FOR NORMALS
C     BETA      15      27      39    MAX ANGLE FOR MIDSIDE POINTS
C     BGPDT  16-47  28-107  40-167    BASIC GRID POINT DATA
C     GPT    48-55 108-127 168-199    GRID POINT TEMPERATURES
C***********************************************************************
C
      LOGICAL TDEP     ,MTDEP      ,ANIS       ,RECT
C
      INTEGER TYPE     ,OTPT       ,EID        ,IEST(1)    ,BGPDT      ,
     2        BCORD    ,GPT        ,JZ(32)     ,SIL        ,CID        ,
     3        UFM(6)
      INTEGER IB(46)
C
      DOUBLE PRECISION  SHP        ,DSHP       ,JACOB      ,DETJ
     1,     S          ,SFACT      ,A(6)      ,E1         ,E2
     2,     E3         ,PARG(96)   ,CN(3,32)   ,TEMP       ,ELTEMP
     3,     ALPVEC     ,GMAT(36)   ,GAUSS(8)   ,DALPHA(6)
C
      REAL  TEMPS(1)   ,PG(1)      ,PSGL(96)
C
      COMMON/TRIMEX/ EST(200)
      COMMON/MATIN/ MID      ,INFLAG     ,ELTEMP
      COMMON/MATOUT/   SE          ,G          ,SNU        ,RHO        ,
     2  TALPHA,TREF,CDAMP,SPACE(18),
     3                 MTDEP
      COMMON/MATISO/ BUFM6(46)
      COMMON/SYSTEM/ SYSBUF  ,OTPT       ,SYS1(7)          ,MTEMP      ,
     2               SYS2(45),HEAT
C
      COMMON/SSGWRK/    SHP(32)    ,DSHP(3,32) ,JACOB(3,3) ,S(4)
     1,     H(4)
C
      EQUIVALENCE (EID,EST(1),IEST(1)),(JZ(1),SHP(1))
      EQUIVALENCE (PSGL(1),PARG(1))
      EQUIVALENCE (IB(1),BUFM6(1))
C
      DATA  GAUSS/      0.577350269189626D0    ,0.555555555555556D0
     1,                 0.774596669241483D0    ,0.888888888888889D0
     2,                 0.347854845137454D0    ,0.861136311594053D0
     3,                 0.652145154862546D0    ,0.339981043584856D0/
      DATA UFM /4H0***,4H USE,4HR FA,4HTAL ,4HMESS,4HAGE /
C
C*****
C     COMPUTE EST POINTERS
C*****
      NGP = 12*TYPE - 4
      MID = 10 + 12*(TYPE - 1)
      CID=IEST(MID+1)
      NIP=IEST(MID+2)
      IF (NIP .LT. 2 .OR. NIP .GT. 4) NIP=TYPE/2+2
      BGPDT = MID + 6
      GPT=BGPDT+4*NGP
      DO 110 I=1,NGP
  110 JZ(I) = IEST(BGPDT + 4*I - 4)
      BCORD=GPT-3
      DO 120  I=2,NGP
      DO 120  J=1,3
      K = BGPDT + 4*(NGP - I) + 4 - J
      BCORD = BCORD - 1
      EST(BCORD) = EST(K)
  120 CONTINUE
      DO 130  I=2,NGP
  130 IEST(BGPDT+I-1) = JZ(I)
      MID=IEST(NGP+2)
C
C     ABSCISSAE AND WEIGHT COEFFICIENTS FOR GAUSSIAN QUADRATURE
C
      I=NIP-1
      GO TO (131,132,133),I
  131 H(1)=1.0
      S(1)=GAUSS(1)
      H(2)=H(1)
      S(2)=-S(1)
      GO TO 134
  132 H(1)=GAUSS(2)
      S(1)=GAUSS(3)
      H(2)=GAUSS(4)
      S(2)=0.0
      H(3)=H(1)
      S(3)=-S(1)
      GO TO 134
  133 H(1)=GAUSS(5)
      S(1)=GAUSS(6)
      H(2)=GAUSS(7)
      S(2)=GAUSS(8)
      H(3)=H(2)
      S(3)=-S(2)
      H(4)=H(1)
      S(4)=-S(1)
  134 CONTINUE
C
C=======================================================================
C     THIS SECTION OF CODE MUST BE UPDATED WHEN GENERAL ANISOTROPIC
C     MATERIAL IS ADDED
C
C     TEST FOR ANISOTROPIC MATERIAL
C
      ANIS = .FALSE.
      INFLAG=10
C
C     TEST FOR RECTANGULAR COORDINATE SYSTEM IN WHICH THE ANISOTROPIC
C     MATERIAL IS DEFINED
C
      RECT = .TRUE.
C=======================================================================
C
C     FETCH MATERIAL AND SET TEMPERATURE DEPENDENCE FLAG
C
      TDEP=.TRUE.
      DO 140 I=2,NGP
      IF (EST(GPT) .NE. EST(GPT+I-1)) GO TO 150
  140 CONTINUE
      TDEP=.FALSE.
  150 ELTEMP=EST(GPT)
      CALL MAT(EID)
      IF (.NOT. MTDEP) TDEP=.FALSE.
      IF (IB(46).EQ.6) ANIS=.TRUE.
      TREF=BUFM6(44)
C*****
C     IF ISOTROPIC TEMPERATURE INDEPENDENT MATERIAL, COMPUTE CONSTANTS
C*****
      IF (TDEP) GO TO 800
      IF (ANIS) GO TO 700
      IF (IB(46).NE.0) GO TO 640
      CALL PAGE2(2)
      WRITE(OTPT,7300) UFM,MID,EID
      NOGO = 1
      RETURN
  640 E1=BUFM6(1)
      E2=BUFM6(2)
      E3=BUFM6(22)
      TALPHA=BUFM6(38)
      GO TO 800
C
C=======================================================================
C     CODE TO TRANSFORM GENERAL ANISOTROPIC MATERIAL PROPERTIES TO
C     BASIC COORDINATE SYSTEM MUST BE ADDED HERE
C=======================================================================
C
  700 DO 710 IJK=1,36
  710 GMAT(IJK)=BUFM6(IJK)
  800 NTLP = 3*NGP
      DO 900 I=1,NTLP
  900 PARG(I) = 0.0
C*****
C     BEGIN INTEGRATION LOOP NOW
C*****
      DO 2000 I=1,NIP
      DO 2000 J=1,NIP
      DO 2000 K=1,NIP
C*****
C     GENERATE SHAPE FUNCTIONS AND JACOBIAN MATRIX INVERSE
C*****
      CALL IHEXSD(TYPE,SHP,DSHP,JACOB,DETJ,EID,S(I),S(J),S(K),
     2            EST(BCORD))
      IF (DETJ .NE. 0.0D0) GO TO 1010
C
C     JACOBIAN MATRIX WAS SINGULAR
C
      CALL MESAGE(-61,0,0)
C*****
C     COMPUTE PARTIAL DERIVATIVE OF SHAPE FUNCTIONS WITH RESPECT
C     TO BASIC COORDINATES
C*****
 1010 CALL GMMATD(DSHP,NGP,3,0,JACOB,3,3,0,CN)
C*****
C     COMPUTE LOADING TEMPERATURE AT THIS INTEGRATION POINT
C*****
      TEMP=0.0D0
      DO 1012 L=1,NGP
 1012 TEMP=TEMP+SHP(L)*DBLE(TEMPS(L))
      TEMP=TEMP-DBLE(TREF)
C*****
C     IF MATERIAL IS TEMPERATURE DEPENDENT, COMPUTE TEMPERATURE AT THIS
C     INTEGRATION POINT AND FETCH MATERIAL PROPERTIES
C*****
      IF(.NOT.TDEP)  GO TO 1030
      ELTEMP=0.0D0
      DO 1020  L=1,NGP
 1020 ELTEMP=ELTEMP+SHP(L)*DBLE(EST(GPT+L-1))
      CALL MAT(EID)
      IF (ANIS) GO TO 1040
      IF (IB(46).NE.0) GO TO 1025
      CALL PAGE2(2)
      WRITE(OTPT,7300)  UFM,MID,EID
      NOGO = 1
      RETURN
 1025 E1=BUFM6(1)
      E2=BUFM6(2)
      E3=BUFM6(22)
      TALPHA=BUFM6(38)
      GO TO 1100
C*****
C     IF MATERIAL IS ANISOTROPIC AND NOT DEFINED IN RECTANGULAR COOR-
C     DINATE SYSTEM, MUST TRANSFORM TO BASIC COORDINATE SYSTEM AT THIS
C     INTEGRATION POINT
C*****
 1030 IF(.NOT. ANIS)  GO TO 1100
      IF (RECT) GO TO 1500
 1040 CONTINUE
      DO 1041 IJK=1,36
 1041 GMAT(IJK)=BUFM6(IJK)
C
C=======================================================================
C     INSERT GLOBAL TO BASIC TRANSFORMATION OPERATIONS HERE FOR
C     ANISOTROPIC MATERIAL MATRIX
      GO TO 1500
C=======================================================================
C*****
C     COMPUTE CONTRIBUTION TO THERMAL LOAD VECTOR FOR ISOTROPIC MATERIAL
C*****
 1100 ALPVEC=DBLE(TALPHA)*(E1+2.0*E2)
      SFACT=H(I)*H(J)*H(K)*DETJ*ALPVEC*TEMP
      L = 0
      DO 1400  II=1,NGP
      DO 1400 JJ=1,3
      L = L + 1
      PARG(L) = SFACT*CN(JJ,II)  + PARG(L)
 1400 CONTINUE
      GO TO 2000
C=======================================================================
 1500 CONTINUE
C     ADD LOAD COMPUTATIONS FOR ANISOTROPIC MATERIAL HERE
C=======================================================================
C
      SFACT=H(I)*H(J)*H(K)*DETJ*TEMP
      DO 1560 IJK=1,6
 1560 DALPHA(IJK)=BUFM6(IJK+37)
C
      CALL GMMATD(GMAT,6,6,0,DALPHA,6,1,0,A(1))
      L=0
      DO 1600 II=1,NGP
      L=L+1
      PARG(L)=PARG(L)+SFACT*(CN(1,II)*A(1)+CN(2,II)*A(4)+CN(3,II)*A(6))
      L=L+1
      PARG(L)=PARG(L)+SFACT*(CN(2,II)*A(2)+CN(1,II)*A(4)+CN(3,II)*A(5))
      L=L+1
      PARG(L)=PARG(L)+SFACT*(CN(3,II)*A(3)+CN(2,II)*A(5)+CN(1,II)*A(6))
 1600 CONTINUE
 2000 CONTINUE
      DO 2100 I=1,NTLP
 2100 PSGL(I)=PARG(I)
C*****
C     INSERT THERMAL LOAD INTO GLOBAL LOAD VECTOR  (PG ARRAY)
C*****
C
      DO 3000 I=1,NGP
      SIL = IEST(I+1)
      IBGP = BGPDT + I - 1
      IF (IEST(IBGP) .EQ. 0) GO TO 2500
      CALL BASGLB(PSGL(3*I-2),PSGL(3*I-2),EST(BCORD+3*I-3),IEST(IBGP))
 2500 DO 2600 J=1,3
      PG(SIL+J-1)=PG(SIL+J-1)+PSGL(3*I-3+J)
 2600 CONTINUE
 3000 CONTINUE
C
C
 7300 FORMAT(6A4,69H4005. AN ILLEGAL VALUE OF -NU- HAS BEEN SPECIFIED UN
     2DER MATERIAL ID =,I10,17H FOR ELEMENT ID =,I10)
      RETURN
      END

      SUBROUTINE FRMLTA (IFILE,Z,Y,ZM)
C
C     LOWER TRIANGULAR TRANSPOSE WITH OFF-DIAGONAL SWITCH
C     SINGLE PRECISION VERSION
C
C     LAST REVISED  11/91, BY G.CHAN/UNISYS
C     ADDITIONAL OF A NEW METHODS WHICH IS MORE EFFICIENT, AND IS
C     ALREADY GOOD FOR VECTORIZATION
C
      REAL             Z(1)    ,Y(1)    ,ZM(1)
      DIMENSION        IFILE(7),NAM(2)
      COMMON  /UNPAKX/ ITYP    ,IP      ,NP      ,INCR
      COMMON  /FEERXX/ DM18(18),NZM
      COMMON  /ZZZZZZ/ IZ(1)
      COMMON  /SYSTEM/ IBUF    ,NOUT
      EQUIVALENCE      (DP,IDP)
      DATA     NAM   / 4HFRML  ,4HTA  /
C
      N    = IFILE(2)
      IFL  = IFILE(1)
      IF (IFILE(7) .LT. 0) IFL = -IFILE(7)
      CALL REWIND (IFL)
      IF (IFILE(7) .LT. 0) GO TO 30
      CALL SKPREC (IFL,1)
      ITYP = IFILE(5)
C
C     NASTRAN ORIGINAL METHOD
C
      INCR = 1
      DO 20 I = 1,N
      Y(I) = 0.0
      IP   = 0
      CALL UNPACK (*30,IFL,ZM(1))
      IF (IP .EQ. I) ZM(1) = -ZM(1)
      SUM  = 0.0
      II   = 0
      DO 10 J = IP,NP
      II   = II + 1
   10 SUM  = SUM - ZM(II)*Z(J)
      Y(I) = SUM
   20 CONTINUE
      GO TO 150
C
C     NEW METHOD
C
C     UNLIKE FRMLT, IFL WAS UNPACKED BACKWARD FIRST, THEN FORWARD BY
C     UNPSCR/FEER3. SO WE SKIP BACKWARD PASS BEFORE READING DATA
C
   30 NREC = IFILE(4)/10
      CALL SKPREC (IFL,NREC+1)
      NREC = 0
      LL2  = 0
      NTMS = 1
      DO 70 I = 1,N
      IF (NTMS .LT. LL2) GO TO 50
      NREC = NREC + 1
      CALL READ (*100,*40,IFL,ZM,NZM,1,LL)
      CALL MESAGE (-8,0,NAM)
   40 LL2  = LL
      NTMS = 1
   50 DP   = ZM(NTMS)
      II   = IDP
      IF (II .NE. I) GO TO 120
      DP   = ZM(NTMS+1)
      JJ   = IDP
      ZM(NTMS+2) = -ZM(NTMS+2)
      SUM  = 0.0
      LL   = NTMS + 1
      DO 60 J = II,JJ
      LL   = LL + 1
   60 SUM  = SUM - ZM(LL)*Z(J)
      Y(I) = SUM
   70 NTMS = NTMS + JJ - II + 3
      GO TO 150
C
  100 J = IFILE(4)/10
      WRITE  (NOUT,110) NREC,I,N,J
  110 FORMAT ('0*** TRY TO READ RECORD',I5,'.  I,N,IFILE(4) =',2I7,I5)
      CALL MESAGE (-2,ILF,NAM)
  120 WRITE  (NOUT,130) II,I
  130 FORMAT ('0*** II AND I MISMATCH =',2I8)
      CALL MESAGE (-37,0,NAM)
C
  150 RETURN
      END

      BLOCK DATA PLA4BD
CPLA4BD
C
      INTEGER         CSTM   ,ECPTS  ,GPCT   ,ECPTO  ,OUTRW  ,
     1                EOR    ,CLSRW  ,DIT
C
      COMMON /PLA42C/ NPVT   ,GAMI   ,GAMIP1 ,IPASS  ,ICSTM  ,
     1                NCSTM  ,IGPCT  ,NGPCT  ,IPOINT ,NPOINT ,
     2                I6X6K  ,N6X6K  ,CSTM   ,MPT    ,ECPTS  ,
     3                GPCT   ,DIT    ,KGGNL  ,ECPTO  ,INRW   ,
     4                OUTRW  ,EOR    ,NEOR   ,CLSRW  ,JMAX   ,
     5                FROWIC ,LROWIC ,NROWSC ,NLINKS ,NWORDS(40),
     6                IOVRLY(40)     ,LINK(40)       ,NOGO
C
      DATA    NPVT  , GAMI,GAMIP1,IPASS,ICSTM,NCSTM  / 6*0   /,
     1        IGPCT , NGPCT,IPOINT,NPOINT,I6X6K,N6X6K/ 6*0   /,
     2        CSTM  , MPT,GPCT,DIT, KGGNL,ECPTO, ECPTS       /
     3        101   , 102,104 ,105, 201  ,202  , 301         /,
     4        INRW  , OUTRW , EOR, NEOR, CLSRW / 0,1,1,0,1   /,
     5        JMAX  , FROWIC,LROWIC,NROWSC,NLINKS / 4*0, 1   /,
     6        NWORDS/
C
C    1         ROD       BEAM      TUBE      SHEAR     TWIST
C    2         TRIA1     TRBSC     TRPLT     TRMEM     CONROD
C    3         ELAS1     ELAS2     ELAS3     ELAS4     QDPLT
C    4         QDMEM     TRIA2     QUAD2     QUAD1     DAMP1
C    5         DAMP2     DAMP3     DAMP4     VISC      MASS1
C    6         MASS2     MASS3     MASS4     CONM1     CONM2
C    7         PLOTEL    REACT     QUAD3     BAR       CONE
C    8         TRIARG    TRAPRG    TORDRG    CORE      CAP
C
     1         26,       0,        25,       0,        0,
     2         42,       0,        0,        36,       26,
     3         0,        0,        0,        0,        0,
     4         44,       36,       44,       50,       0,
     5         0,        0,        0,        0,        0,
     6         0,        0,        0,        0,        0,
     7         0,        0,        0,        57,       0,
     8         0,        0,        0,        0,        0    /,
C
     7        IOVRLY/ 40*1/,
     8        NOGO  / 0   /
      END

      SUBROUTINE DBMIO ( OPCODE )
      INCLUDE 'DSIOF.COM'
      INCLUDE 'GINOX.COM'
      INCLUDE 'XNSTRN.COM'
C
C  OPCODE
C         = 1   OPEN, IOCODE = 0 OPEN FOR READ WITH REWIND
C                            = 1 OPEN FOR WRITE WITH REWIND
C                            = 2 OPEN FOR READ WITHOUT REWIND
C                            = 3 OPEN FOR WRITE WITHOUT REWIND
C         = 2   CLOSE, IOCODE = 1 CLOSE WITH REWIND
C                                OTHERWISE, NO REWIND
C         = 3   REWIND
C         = 4   WRITE ONE BLOCK
C         = 5   READ ONE BLOCK
C         = 6   POSITION
C         = 7   DELETE FILE
C         = 8   WRTBLK CODE
C         = 9   RDBLK CODE
C-----------------------------------------------------------------------
      INTEGER   OPCODE
C      PRINT *,' DBMIO CALLED WITH OPCODE,IFILEX=',OPCODE,IFILEX
C      PRINT *,' DBMIO,NBLOCK,IOCODE=',NBLOCK,IOCODE
C      WRITE(6,40646)(FCB(K,IFILEX),K=1,15)
40646 FORMAT(' DBMIO-ENTRY,FCB=',/
     & I3,I7,4I5,I7,I2,4I7,1X,2A4,I4)
      GO TO (100,200,300,400,500,600,700,800,900),OPCODE
C-OPEN ------------------------------
C     OPEN FILE ACCORDING TO IOCODE
C       =0, OPEN AND READ FIRST BLOCK
C       =1, OPEN AND RETURN ( OPEN FOR WRITE )
C       =2, OPEN AND READ THE CURRENT BLOCK WHEN FILE WAS CLOSED
C       =3, OPEN AND READ THE CURRENT BLOCK WHEN FILE WAS CLOSED
100   CONTINUE
      CALL DSGNOP
      FCB( 15, IFILEX ) = 700+IOCODE
      FCB(  1, IFILEX ) = IOCODE
      IF ( IOCODE .EQ. 0 ) GO TO 110
      IF ( IOCODE .EQ. 1 ) GO TO 111
      IF ( IOCODE .EQ. 2 ) GO TO 112
      IF ( IOCODE .EQ. 3 ) GO TO 113
110   CONTINUE
      FCB( 4, IFILEX ) = NBLOCK
      GO TO 600
111   CONTINUE
      FCB( 4, IFILEX ) = NBLOCK
      FCB( 5, IFILEX ) = NBLOCK
      FCB( 6, IFILEX ) = NBLOCK
      GO TO 7000
112   CONTINUE
113   CONTINUE
      NBLOCK = FCB( 4, IFILEX )
      IF ( FCB( 5, IFILEX ) .NE. 0 ) GO TO 600
      NBLOCK = 1
      GO TO 111
C-CLOSE -----------------------------
200   CONTINUE
      CALL DSGNCL
      IF ( IOCODE .EQ. 0 ) FCB( 4, IFILEX ) = 1
      IF ( FCB( 15, IFILEX ) .NE. 701 .AND. FCB( 15, IFILEX ) .NE. 703 )
     &     GO TO 210
      FCB(  4, IFILEX ) = FCB(  4, IFILEX ) - 1
      FCB(  6, IFILEX ) = FCB(  6, IFILEX ) - 1
210   CONTINUE
      FCB( 15, IFILEX ) = 0
      GO TO 7000
C-REWIND ----------------------------
300   CONTINUE
      FCB(  4, IFILEX ) = 1
      NBLOCK = 1
      IF ( FCB( 15, IFILEX ) .EQ. 701 .OR.
     &     FCB( 15, IFILEX ) .EQ. 703 ) GO TO 7000
      GO TO 600
C-WRITE -----------------------------
400   CONTINUE
      CALL DSGNWR
      FCB( 4, IFILEX ) = FCB( 4, IFILEX ) + 1
      IF ( FCB( 4, IFILEX ) .GT. FCB( 6, IFILEX ) )
     &     FCB( 6, IFILEX ) = FCB( 4, IFILEX )
      GO TO 7000
C-READ
500   CONTINUE
      FCB( 4, IFILEX ) = FCB( 4, IFILEX ) + 1
      NBLOCK = FCB( 4, IFILEX )
      CALL DSGNRD
      GO TO 7000
C-POSITION AND READ BLOCK "NBLOCK"
600   CONTINUE
      CALL DSGNRD
      GO TO 7000
C-DELETE FILE
700   CONTINUE
      OPEN  (IFILEX, FILE=MDSNAM(IFILEX), STATUS='UNKNOWN')
      CLOSE (IFILEX, STATUS='DELETE')
      FCB( 5, IFILEX ) = 0
      FCB( 6, IFILEX ) = 0
      GO TO 7000
C-SPECIAL RDBLK CALL
900   CONTINUE
      PRINT *,' ERROR, DBMIO CALLED FOR RDBLK CALL'
      STOP
C-SPECIAL WRTBLK CALL
800   CONTINUE
      PRINT *,' ERROR, DBMIO CALLED FOR WRTBLK CALL'
      STOP
7000  CONTINUE
C      WRITE(6,40647)(FCB(K,IFILEX),K=1,15)
40647 FORMAT(' DBMIO-EXIT,FCB=',/
     & I3,I7,4I5,I7,I2,4I7,1X,2A4,I4)
      RETURN
      END

      SUBROUTINE SXLOOP (X,Y,N)
C
C     SINGLE PRECISION VERSION OF CXLOOP, CALLED ONLY BY CDCMPS
C
      REAL       X(1),   Y(1)
      REAL       XX(2) , YY(2), MPY(2)
      NN = N + N
      DO 10 I = 1,NN
   10 X(I) = Y(I)
      RETURN
C
      ENTRY SLOOP (XX,YY,MPY,M)
      MM = M + M
      DO 20 I = 1,MM,2
      XX(I  ) = XX(I  ) - MPY(1)*YY(I) + MPY(2)*YY(I+1)
   20 XX(I+1) = XX(I+1) - MPY(2)*YY(I) - MPY(1)*YY(I+1)
      RETURN
      END

      SUBROUTINE EXIO1
C
C     EXIO1 SERVICES INTERNAL FORMAT FUNCTIONS FOR EXIO.
C
      EXTERNAL LSHIFT   ,RSHIFT   ,ANDF     ,ORF
      LOGICAL  FIRST    ,OPNSOF   ,DITUP    ,MDIUP    ,NXTUP     ,
     1         NXTRST   ,TAPBIT
      INTEGER  DRY      ,COR(1)   ,DEVICE   ,UNAME    ,POS       ,
     1         DATYPE   ,PDATE    ,PTIME    ,TIME     ,SEC       ,
     2         HOURS    ,SSNAME   ,SAVREC   ,HDREC    ,REWI2     ,
     3         BUF      ,SYSBUF   ,DATE     ,RD       ,RDREW     ,
     4         WRT      ,WRTREW   ,REW      ,EOFNRW   ,FILNAM    ,
     5         FILSIZ   ,STATUS   ,PASSWD   ,BLKSIZ   ,DIRSIZ    ,
     6         SUPSIZ   ,AVBLKS   ,DIT      ,DITPBN   ,DITLBN    ,
     7         DITSIZ   ,DITNSB   ,DITBL    ,Z        ,TAPE      ,
     8         DISK     ,SOFIN    ,SOFOUT   ,CHECK    ,APPEND    ,
     9         COMPRS   ,REWI     ,EQF      ,ALL      ,TABLES    ,
     O         PHASE3   ,DUMP     ,RESTOR   ,WHOLE(2) ,XITEMS(50),
     1         SUBR(2)  ,BLANK    ,SOF      ,EOI      ,HDR       ,
     2         Q        ,QQQQ     ,XXXX     ,SCR1     ,SRD       ,
     3         SWRT     ,RSHIFT   ,ANDF     ,SOFSIZ   ,ORF       ,
     4         BUF1     ,BUF2     ,BUF3     ,BUF4     ,UNIT      ,
     5         RC       ,FLAG     ,OLDTSZ   ,BUF5     ,SCR2      ,
     6         HEAD1    ,HEAD2    ,INBLK(15),OUTBLK(15)
      CHARACTER          UFM*23   ,UWM*25   ,UIM*29   ,SFM*25    ,
     1                   SWM*27   ,SIM*31
      COMMON  /XMSSG /   UFM      ,UWM      ,UIM      ,SFM       ,
     1                   SWM      ,SIM
      COMMON  /MACHIN/   MACH     ,IHALF    ,JHALF
      COMMON  /BLANK /   DRY      ,XMACH    ,DEVICE(2),UNAME(2)  ,
     1                   FORMT(2) ,MODE(2)  ,POS(2)   ,DATYPE(2) ,
     2                   NAMES(10),PDATE    ,PTIME    ,TIME(3)   ,
     3                   SSNAME(2),SAVREC(9),HDREC(10),BUF(10)
      COMMON  /SYSTEM/   SYSBUF   ,NOUT     ,X1(6)    ,NLPP      ,
     1                   X2(2)    ,LINE     ,X3(2)    ,DATE(3)   ,
     2                   X4(21)   ,NBPC     ,NBPW     ,NCPW
      COMMON  /NAMES /   RD       ,RDREW    ,WRT      ,WRTREW    ,
     1                   REW      ,NOREW    ,EOFNRW
      COMMON  /SOFCOM/   NFILES   ,FILNAM(10)         ,FILSIZ(10),
     1                   STATUS   ,PASSWD(2),FIRST    ,OPNSOF
      COMMON  /SYS   /   BLKSIZ   ,DIRSIZ   ,SUPSIZ   ,AVBLKS    ,
     1                   NOBLKS   ,IFRST
      COMMON  /ITEMDT/   NITEM    ,ITEMS(7,1)
      COMMON  /OUTPUT/   HEAD1(96),HEAD2(96)
      COMMON  /SOF   /   DIT      ,DITPBN   ,DITLBN   ,DITSIZ    ,
     1                   DITNSB   ,DITBL    ,IO       ,IOPBN     ,
     2                   IOLBN    ,IOMODE   ,IOPTR    ,IOSIND    ,
     3                   IOITCD   ,IOBLK    ,MDI      ,MDIPBN    ,
     4                   MDILBN   ,MDIBL    ,NXT      ,NXTPBN    ,
     5                   NXTLBN   ,NXTTSZ   ,NXTFSZ(10)          ,
     6                   NXTCUR   ,DITUP    ,MDIUP    ,NXTUP     ,
     7                   NXTRST
      COMMON  /ZZZZZZ/   Z(1)
      EQUIVALENCE        (COR(1)  ,Z(1))
      EQUIVALENCE        (TIME(1) ,HOURS)   ,(TIME(2) ,MIN)      ,
     1                   (TIME(3) ,SEC)
      DATA     TAPE     ,DISK     ,SOFIN    ,SOFOUT   ,CHECK     /
     1         4HTAPE   ,4HDISK   ,4HSOFI   ,4HSOFO   ,4HCHEC    /,
     2         APPEND   ,COMPRS   ,NOREWI   ,REWI     ,EQF       /
     3         4HAPPE   ,4HCOMP   ,4HNORE   ,4HREWI   ,4HEOF     /,
     4         ALL      ,MATRIC   ,TABLES   ,PHASE3   ,DUMP      /
     5         4HALL    ,4HMATR   ,4HTABL   ,4HPHAS   ,4HDUMP    /,
     6         RESTOR   ,WHOLE              ,REWI2               /
     8         4HREST   ,4HWHOL   ,4HESOF   ,4HND                /,
     9         SUBR               ,BLANK    ,SOF      ,EOI       /
     O         4HEXIO   ,4H1      ,4H       ,4HSOF    ,4HEOI     /,
     1         ID       ,HDR      ,Q        ,QQQQ     ,XXXX      /
     2         4H$ID$   ,4H$HD$   ,4HQ      ,4HQQQQ   ,4HXXXX    /
      DATA     SCR1     ,SCR2     ,SRD      ,SWRT     ,IZ2       /
     1         301      ,302      ,1        ,2        ,2         /
C
C     INITIALIZE
C
      IF (NITEM .GT. 50) CALL ERRMKN (25,10)
      LCORE = KORSZ(Z)
      BUF1  = LCORE- SYSBUF + 1
      BUF2  = BUF1 - SYSBUF - 1
      BUF3  = BUF2 - SYSBUF
      BUF4  = BUF3 - SYSBUF
      BUF5  = BUF4 - SYSBUF
      LCORE = BUF5 - 1
      NCORE = LCORE
      NOS   = 0
      IDM   = 1
      IF (LCORE .LE. 0) CALL MESAGE (-8,0,SUBR)
      IF (MODE(1) .NE. RESTOR) CALL SOFOPN (Z(BUF1),Z(BUF2),Z(BUF3))
      UNIT  = UNAME(1)
C
C     CHECK TAPE BIT IF DEVICE=TAPE
C
      IF (DEVICE(1) .EQ. DISK .OR. MODE(1) .EQ. COMPRS .OR.
     1    MODE(1) .EQ. APPEND) GO TO 10
      IF (DEVICE(1) .NE. TAPE) GO TO 1810
      IF (.NOT.  TAPBIT(UNIT)) GO TO 1800
C
C     SET REWIND VARIABLE
C
C     IF SOFOUT COMMAND POSITION TO END-OF-FILE IF REQUESTED
C
C     IF POSITION = REWIND AND WE ARE WRITING THEN BCKREC OVER LAST EOF
C
C     IF POSITION = EOF AND WE ARE WRITING THEN BCKREC FIRST TO INSURE
C     WE ARE INFRONT OF AND EOF AND THEN SEARCH FOR EOF
C
   10 IPOS = -1
      IF (POS(1).EQ.NOREWI .OR. POS(1).EQ.EQF) IPOS = 2
      IF (POS(1) .EQ. REWI) IPOS = 0
      IF (IPOS .LT. 0) GO TO 1830
      IF (MODE(1).EQ.DUMP .OR. MODE(1).EQ.RESTOR) IPOS = 0
      IF (IPOS .NE. 0) GO TO 20
      HEAD2(13) = REWI
      HEAD2(14) = REWI2
   20 IF (MODE(1) .NE. SOFOUT) GO TO 60
      IF (IPOS .EQ. 0) GO TO 60
      CALL OPEN (*1860,UNIT,Z(BUF4),RD)
      CALL BCKREC (UNIT)
      IF (POS(1) .EQ. NOREWI) GO TO 50
   30 CALL FWDREC (*40,UNIT)
      GO TO 30
   40 CALL BCKREC (UNIT)
   50 CALL CLOSE (UNIT,NOREW)
C
C     BRANCH ON MODE OF OPERATION
C
   60 IF (MODE(1).EQ.SOFOUT .OR. MODE(1).EQ.  DUMP) GO TO 70
      IF (MODE(1).EQ.SOFIN  .OR. MODE(1).EQ.RESTOR) GO TO 370
      IF (MODE(1) .EQ. CHECK ) GO TO 1160
      IF (MODE(1) .EQ. APPEND) GO TO 1220
      IF (MODE(1) .EQ. COMPRS) GO TO 1500
      GO TO 1820
C
C
C     **********************   W R I T E   **********************
C
C     OPEN FILE AND WRITE 9 WORD ID RECORD
C
   70 CALL OPEN (*1860,UNIT,Z(BUF4),WRTREW+IPOS)
      CALL WALTIM (SEC)
      HOURS= SEC/3600
      SEC  = MOD(SEC,3600)
      MIN  = SEC/60
      SEC  = MOD(SEC,60)
      HDREC(1) = ID
      HDREC(2) = PASSWD(1)
      HDREC(3) = PASSWD(2)
      DO 80 I = 1,3
      HDREC(I+3) = DATE(I)
      HDREC(I+6) = TIME(I)
   80 CONTINUE
      CALL WRITE (UNIT,HDREC,9,1)
      CALL PAGE
      WRITE (NOUT,2120) UIM,PASSWD,DATE,TIME
      LINE = LINE + 1
C
C     WRITE DIT AND MDI CONTROL WORDS
C
      N = DITSIZ/2
      CALL WRITE (UNIT,N,1,0)
      DO 90 I = 1,N
      CALL FDIT(I,J)
      CALL WRITE (UNIT,COR(J),2,0)
      CALL FMDI  (I,J)
      CALL WRITE (UNIT,COR(J+1),2,0)
   90 CONTINUE
      CALL WRITE (UNIT,0,0,1)
      CALL WRITE (UNIT,EOI,1,1)
      IF (MODE(1) .NE. DUMP) GO TO 110
C
C
C     DUMP FORM --
C
C     COPY OUT ALL SOF SUPERBLOCKS WHICH HAVE BEEN USED WITHOUT REGARD
C     TO THE DATA SEQUENCE OR CONTENT.
C
C
      DO 100 I = 1,NOBLKS
      CALL SOFIO (SRD,I,Z(BUF1))
      CALL WRITE (UNIT,Z(BUF1+3),BLKSIZ,0)
  100 CONTINUE
      CALL WRITE (UNIT,0,0,1)
      CALL CLOSE (UNIT,REW)
      WRITE (NOUT,2130) UIM,NOBLKS,NXTTSZ,UNAME
      GO TO 1740
C
C     STANDARD FORM --
C
C     COPY OUT EACH SUBSTRUCTURE/ITEM WITH ITS DATA IN THE CORRECT
C     SEQUENCE.
C
C     SETUP THE ARRAY XITEMS OF NAMES OF ITEMS TO BE COPIED.
C
  110 IF (DATYPE(1) .NE. ALL) GO TO 130
      NITEMS = NITEM
      DO 120 I = 1,NITEM
  120 XITEMS(I) = ITEMS(1,I)
      GO TO 200
  130 IF (DATYPE(1) .NE. TABLES) GO TO 150
      NITEMS = 0
      DO 140 I = 1,NITEM
      IF (ITEMS(2,I) .GT. 0) GO TO 140
      NITEMS = NITEMS + 1
      XITEMS(NITEMS) = ITEMS(1,I)
  140 CONTINUE
      GO TO 200
  150 IF (DATYPE(1) .NE. MATRIC) GO TO 170
      NITEMS = 0
      DO 160 I = 1,NITEM
      IF (ITEMS(2,I) .LE. 0) GO TO 160
      NITEMS = NITEMS + 1
      XITEMS(NITEMS) = ITEMS(1,I)
  160 CONTINUE
      GO TO 200
  170 IF (DATYPE(1) .NE. PHASE3) GO TO 190
      NITEMS = 0
      DO 180 I = 1,NITEM
      IF (ANDF(ITEMS(7,I),8) .EQ. 0) GO TO 180
      NITEMS = NITEMS + 1
      XITEMS(NITEMS) = ITEMS(1,I)
  180 CONTINUE
      GO TO 200
  190 NITEMS = 2
      XITEMS(1) = DATYPE(1)
      XITEMS(2) = DATYPE(2)
      IF (XITEMS(2) .EQ. BLANK) NITEMS = 1
C
C     LOOP OVER SUBSTRUCTURE NAMES.  FOR EACH SUBSTRUCTURE, WRITE OUT
C     THE NITEMS IN XITEMS.
C
  200 ISS = 0
  210 ISS = ISS + 1
      IF (NAMES(1).NE.WHOLE(1) .OR. NAMES(2).NE.WHOLE(2)) GO TO 220
C
C     WRITE ALL SUBSTRUCTURES IN THE RESIDENT SOF.
C
      IF (ISS .GT. DITSIZ/2) GO TO 360
      CALL FDIT (ISS,I)
      IF (COR(I) .EQ. BLANK) GO TO 210
      SSNAME(1) = COR(I  )
      SSNAME(2) = COR(I+1)
      GO TO 230
C
C     WRITE ONLY THOSE SUBSTRUCTURES IN THE PARAMETER LIST
C
  220 IF (ISS .GT. 5) GO TO 360
      IF (NAMES(2*ISS-1) .EQ. XXXX) GO TO 210
      SSNAME(1) = NAMES(2*ISS-1)
      SSNAME(2) = NAMES(2*ISS  )
C
C     LOOP OVER ALL ITEMS OF THIS SUBSTRUCTURE.
C
  230 DO 350 ITEM = 1,NITEMS
      KDH = ITTYPE(XITEMS(ITEM))
      IF (KDH .EQ. 1) GO TO 260
      CALL SFETCH (SSNAME,XITEMS(ITEM),SRD,RC)
      GO TO (260,240,350,250,250), RC
  240 LINE = LINE + 2
      IF (LINE .GT. NLPP) CALL PAGE
      WRITE (NOUT,2160) UWM,SSNAME,XITEMS(ITEM)
      GO TO 350
  250 LINE = LINE+2
      IF (LINE .GT. NLPP) CALL PAGE
      CALL SMSG (RC-2,XITEMS(ITEM),SSNAME)
      GO TO 350
C
C     WRITE SUBSTRUCTURE/ITEM HEADER RECORD
C
  260 CALL WALTIM (SEC)
      HOURS = SEC/3600
      SEC   = MOD(SEC,3600)
      MIN   = SEC/60
      SEC   = MOD(SEC,60)
      HDREC(1) = HDR
      HDREC(2) = SSNAME(1)
      HDREC(3) = SSNAME(2)
      HDREC(4) = XITEMS(ITEM)
      DO 270 I = 1,3
      HDREC(I+4) = DATE(I)
      HDREC(I+7) = TIME(I)
  270 CONTINUE
      IF (KDH .EQ. 1) GO TO 310
      CALL WRITE (UNIT,HDREC,10,1)
C
C     COPY DATA
C
  280 CALL SUREAD (Z(1),LCORE,NWDS,RC)
      GO TO (290,300,340), RC
  290 CALL WRITE (UNIT,Z,LCORE,0)
      GO TO 280
  300 CALL WRITE (UNIT,Z,NWDS,1)
      GO TO 280
C
C     COPY MATRIX DATA ITEMS
C
  310 IFILE = SCR1
      CALL MTRXI (SCR1,SSNAME,XITEMS(ITEM),0,RC)
      GO TO (320,240,350,250,250,2010), RC
  320 CALL WRITE (UNIT,HDREC,10,1)
      Z(1) = SCR1
      CALL RDTRL (Z(1))
      CALL WRITE (UNIT,Z(IZ2),6,1)
      CALL OPEN  (*2010,SCR1,Z(BUF5),RDREW)
      CALL CPYFIL(SCR1,UNIT,Z,LCORE,ICOUNT)
      CALL CLOSE (SCR1,1)
C
C     WRITE END-OF-ITEM RECORD AND USER MESSAGE
C
  340 CALL WRITE (UNIT,EOI,1,1)
      LINE = LINE + 1
      IF (LINE .GT. NLPP) CALL PAGE
      WRITE (NOUT,2170) UIM,SSNAME,XITEMS(ITEM),SOF,UNIT,DATE,TIME
  350 CONTINUE
C
C     BOTTOM OF LOOP OVER SUBSTRUCTURES
C
      GO TO 210
C
C     ALL SUBSTRUCTURE/ITEMS HAVE NOW BEEN COPIED.  CLOSE WITH EOF AND
C     NO REWIND (IN CASE MORE DATA TO FOLLOW).
C
C     WRITE EOF FOR NOU BECAUSE LEVEL 16 GINO OPT=3 DOESN T AS
C     ADVERTISED
C
  360 CALL EOF (UNIT)
      CALL CLOSE (UNIT,EOFNRW)
      GO TO 1740
C
C     ***********************   R E A D  ************************
C
C     BRANCH FOR RESTORE OR STANDARD READ
C
  370 IF (MODE(1) .NE. RESTOR) GO TO 400
C
C     RESTORE FORM --
C
C     COPY EACH LOGICAL RECORD ON THE EXTERNAL FILE INTO CONSEQUTIVE,
C     CONTIGUOUS BLOCKS ON THE RESIDENT SOF.
C
C     MAKE SURE THE RESIDENT SOF IS EMPTY.
C
      IF (STATUS .NE. 0) GO TO 1840
      CALL SOFOPN (Z(BUF1),Z(BUF2),Z(BUF3))
      CALL SOFCLS
C
C     OPEN FILE AND READ THE ID RECORD
C
      CALL OPEN (*1860,UNIT,Z(BUF4),RDREW)
      CALL READ (*1850,*1850,UNIT,HDREC,9,1,FLAG)
      IF (HDREC(1) .NE. ID) GO TO 1850
      CALL PAGE
      LINE = LINE+1
      WRITE (NOUT,2120) UIM,(HDREC(I),I=2,9)
      CALL FWDREC (*1870,UNIT)
      CALL FWDREC (*1870,UNIT)
C
C     BEGIN DATA TRANSFER
C
      I = 1
  380 CALL READ (*1870,*390,UNIT,Z(BUF1+3),BLKSIZ,0,FLAG)
      CALL SOFIO (SWRT,I,Z(BUF1))
      I = I+1
      GO TO 380
C
C     RESTORE COMPLETE.  CLOSE FILE AND GIVE USER THE NEWS.
C
  390 CALL CLOSE (UNIT,REW)
      I = I - 1
      WRITE (NOUT,2200) UIM,I
      GO TO 1750
C
C     STANDARD FORM -
C
C     COPY IN EACH INDIVIDUAL SUBSTRUCTURE/ITEM.
C
  400 ISS = 0
C
C     SETUP ARRAY OF NAMES OF ITEMS TO BE COPIED.
C
      IF (DATYPE(1) .NE. ALL) GO TO 420
      NITEMS = NITEM
      DO 410 I = 1,NITEM
  410 XITEMS(I) = ITEMS(1,I)
      GO TO 490
  420 IF (DATYPE(1) .NE. TABLES) GO TO 440
      NITEMS = 0
      DO 430 I = 1,NITEM
      IF (ITEMS(2,I) .GT. 0) GO TO 430
      NITEMS = NITEMS + 1
      XITEMS(NITEMS) = ITEMS(1,I)
  430 CONTINUE
      GO TO 490
  440 IF (DATYPE(1) .NE. MATRIC) GO TO 460
      NITEMS = 0
      DO 450 I = 1,NITEM
      IF (ITEMS(2,I) .LE. 0) GO TO 450
      NITEMS = NITEMS + 1
      XITEMS(NITEMS) = ITEMS(1,I)
  450 CONTINUE
      GO TO 490
  460 IF (DATYPE(1) .NE. PHASE3) GO TO 480
      NITEMS = 0
      DO 470 I = 1,NITEM
      IF (ANDF(ITEMS(7,I),8) .EQ. 0) GO TO 470
      NITEMS = NITEMS + 1
      XITEMS(NITEMS) = ITEMS(1,I)
  470 CONTINUE
      GO TO 490
  480 NITEMS = 2
      XITEMS(1) = DATYPE(1)
      XITEMS(2) = DATYPE(2)
      IF (XITEMS(2) .EQ. BLANK) NITEMS = 1
C
C     DETERMINE NUMBER OF SUBSTRUCTURE/ITEMS TO BE COPIED AND INITIALIZE
C     COUNTER.
C
  490 JCOPY = 0
      NCOPY = 0
      IF (NAMES(1).EQ.WHOLE(1) .AND. NAMES(2).EQ.WHOLE(2)) GO TO 510
      DO 500 I = 1,5
      IF (NAMES(2*I-1) .NE. XXXX) NCOPY = NCOPY + 1
  500 CONTINUE
      NCOPY = NCOPY*NITEMS
      IF (PDATE .NE. 0) NCOPY = 1
C
C     OPEN THE EXTERNAL FILE AND READ THE IDENTIFICATION OR HEADER
C     RECORD.
C     REMEMBER IT IN CASE THE USER HAS REQUESTED A SUBSTRUCTURE/ITEM
C     WHICH IS NOT PRESENT ON THE FILE.
C
  510 CALL PAGE
      CALL OPEN (*1860,UNIT,Z(BUF4),RDREW+IPOS)
  520 CALL READ (*530,*540,UNIT,HDREC,10,1,LREC1)
      LREC1 = 10
      GO TO 540
  530 CALL REWIND (UNIT)
      GO TO 520
  540 DO 550 I = 1,LREC1
  550 BUF(I) = HDREC(I)
      IF (HDREC(1) .NE.  ID) GO TO 560
      GO TO 610
  560 IF (HDREC(1) .NE. HDR) GO TO 1850
      GO TO 610
C
C     SCAN THROUGH THE EXTERNAL TAPE.  FOR EACH SUBSTRUCTURE/ITEM
C     ENCOUNTERED, CHECK TO SEE IF IT SHOULD BE READ.  THEN, EITHER
C     READ OR SKIP IT.
C
C     FOR EACH SUBSTRUCTURE/ITEM WHICH IS READ, SAVE THE HEADER RECORD
C     IN OPEN CORE.  WHEN DUPLICATES ARE FOUND, AND THE DATE AND TIME
C     PARAMETERS HAVE NOT BEEN SET, ISSUE A WARNING AND USE THE MOST
C     RECENT.
C
C     IF THE DATE AND TIME PARAMETERS ARE NON-ZERO, READ ONLY THE
C     SUBSTRUCTURE/ITEM WHICH HAS MATCHING VALUES AND IGNORE THE
C     SUBSTRUCTURE AND ITEM NAME PARAMETERS.
C
C     READ AN IDENTIFICATION OR HEADER RECORD
C
  570 CALL READ (*580,*590,UNIT,BUF,10,1,FLAG)
      GO TO 590
  580 IF (NAMES(1).EQ.WHOLE(1) .AND. NAMES(2).EQ.WHOLE(2)) GO TO 1150
      CALL REWIND (UNIT)
      GO TO 570
C
C     CHECK IT AGAINST THE FIRST RECORD READ.  IF IT MATCHES, THE ENTIRE
C     TAPE HAS BEEN SCANNED, BUT NOT ALL ITEMS WERE FOUND.
C
  590 DO 600 I = 1,LREC1
      IF (BUF(I) .NE. HDREC(I)) GO TO 610
  600 CONTINUE
      GO TO 1080
C
C     IF THAT WAS AN ID RECORD, ISSUE MESSAGE AND GO BACK TO READ THE
C     IMMEDIATELY FOLLOWING HEADER RECORD.
C
  610 IF (BUF(1) .NE. ID) GO TO 620
C
C     READ OLD DIT AND MDI DATA
C
      CALL READ (*1870,*1880,UNIT,NOS,1,0,FLAG)
      LCORE= NCORE - 4*NOS
      IDM  = LCORE + 1
      IF (LCORE .LE. 0) GO TO 1890
      NOS4 = NOS*4
      CALL READ (*1870,*1880,UNIT,Z(IDM),NOS4,1,FLAG)
      CALL FWDREC (*1870,UNIT)
      LINE = LINE + 1
      IF (LINE .GT. NLPP) CALL PAGE
      WRITE (NOUT,2120) UIM,(BUF(I),I=2,9)
      GO TO 570
C
C     READ OR SKIP THE SUBSTRUCTURE/ITEM DATA.
C
  620 IF (PDATE .NE. 0) GO TO 820
      IF (NAMES(1).EQ.WHOLE(1) .AND. NAMES(2).EQ.WHOLE(2)) GO TO 680
      DO 630 I = 1,5
      IF (NAMES(2*I-1) .EQ. XXXX) GO TO 630
      IF (BUF(2).EQ.NAMES(2*I-1) .AND. BUF(3).EQ.NAMES(2*I)) GO TO 640
  630 CONTINUE
      GO TO 660
  640 DO 650 I = 1,NITEMS
      IF (BUF(4) .EQ. XITEMS(I)) GO TO 680
  650 CONTINUE
C
C     SKIP -
C
  660 CALL RECTYP (UNIT,IREC)
      IF (IREC .EQ. 0) GO TO 670
C
C     STRING RECORD - SKIP IT
C
      CALL FWDREC (*1870,UNIT)
      GO TO 660
C
C     NORMAL GINO RECORD - CHECK IF EOI
C
  670 CALL READ (*1870,*660,UNIT,I,1,1,FLAG)
      IF (I-EOI) 660,570,660
C
C     READ -
C
C     CHECK HEADER RECORDS SAVED IN CORE FOR DUPLICATE
C
  680 IF (ISS .EQ. 0) GO TO 850
      DO 700 I = 1,ISS
      JSS = 10*(I-1)
      DO 690 J = 1,3
      IF (BUF(J+1) .NE. Z(JSS+J)) GO TO 700
  690 CONTINUE
      GO TO 710
  700 CONTINUE
      GO TO 850
C
C     DUPLICATE SUBSTRUCTURE/ITEM ENCOUNTER.  USE MOST RECENT.
C
  710 IF (Z(JSS+10) .NE. 0) GO TO 780
      LINE = LINE+3
      IF (LINE .GT. NLPP) CALL PAGE
C
C     CHECK YEAR, MONTH, DAY, HOUR, MINUTE, SECOND
C
      IF (Z(JSS+6)-BUF( 7)) 800,720,770
  720 IF (Z(JSS+4)-BUF( 5)) 800,730,770
  730 IF (Z(JSS+5)-BUF( 6)) 800,740,770
  740 IF (Z(JSS+7)-BUF( 8)) 800,750,770
  750 IF (Z(JSS+8)-BUF( 9)) 800,760,770
  760 IF (Z(JSS+9)-BUF(10)) 800,780,770
C
C     MOST RECENT VERSION IS THE ONE ALREADY READ.  THEREFORE, SKIP THE
C     ONE ON TAPE.
C
  770 WRITE (NOUT,2210) UWM,BUF(2),BUF(3),BUF(4),UNAME,(BUF(I),I=5,10)
  780 CALL RECTYP (UNIT,IREC)
      IF (IREC .EQ. 0) GO TO 790
C
C     STRING RECORD - SKIP IT
C
      CALL FWDREC (*1870,UNIT)
      GO TO 780
C
C     NORMAL GINO RECORD - CHECK IF EOI
C
  790 CALL READ (*1870,*780,UNIT,I,1,1,FLAG)
      IF (I-EOI) 780,570,780
C
C     MOST RECENT VERSION IS ON TAPE.  REPLACE OLDER VERSION ALREADY
C     READ.
C
  800 WRITE (NOUT,2210) UWM,BUF(2),BUF(3),BUF(4),UNAME,(Z(JSS+I),I=4,9)
      DO 810 I = 1,9
  810 Z(JSS+I) = BUF(I+1)
      JCOPY = JCOPY - 1
      CALL DELETE (BUF(2),BUF(4),RC)
      GO TO 870
C
C     IF DATE AND TIME PARAMETERS WERE INVOKED, CHECK THEM.
C
  820 IF (MOD(PDATE,100)       .EQ.BUF( 7) .AND.
     1    PDATE/10000          .EQ.BUF( 5) .AND.
     2    MOD(PDATE,10000)/100 .EQ.BUF( 6) .AND.
     3    PTIME/10000          .EQ.BUF( 8) .AND.
     4    MOD(PTIME,10000)/100 .EQ.BUF( 9) .AND.
     5    MOD(PTIME,100)       .EQ.BUF(10)) GO TO 870
C
C     DATE AND TIME DONT MATCH. SKIP THIS SUBSTRUCTURE/ITEM.
C
  830 CALL RECTYP (UNIT,IREC)
      IF (IREC .EQ. 0) GO TO 840
C
C     STRING RECORD - SKIP IT
C
      CALL FWDREC (*1870,UNIT)
      GO TO 830
C
C     NORMAL GINO RECORD - CHECK IF EOI
C
  840 CALL READ (*1870,*830,UNIT,I,1,1,FLAG)
      IF (I-EOI) 830,570,830
C
C     NO DUPLICATE.  ADD THIS HEADER TO THOSE IN CORE.
C
  850 IF (10*(ISS+1) .GT. LCORE) GO TO 1890
      DO 860 I = 1,9
  860 Z(10*ISS+ I) = BUF(I+1)
      Z(10*ISS+10) = 0
      ISS = ISS+1
C
C     FETCH THE ITEM ON THE SOF.
C
  870 RC  = 3
      KDH = ITTYPE(BUF(4))
      IF (KDH .EQ. 1) GO TO 970
      CALL SFETCH (BUF(2),BUF(4),SWRT,RC)
      IF (RC .EQ. 3) GO TO 930
      LINE = LINE + 2
      IF (LINE .GT. NLPP) CALL PAGE
      GO TO (880,930,930,890,900), RC
C
C     ITEM ALREADY EXISTS.
C
  880 WRITE (NOUT,2220) UWM,BUF(2),BUF(3),BUF(4)
      Z(10*ISS) = 1
      GO TO 910
C
C     SUBSTRUCTURE DOES NOT EXIST.  ADD IT TO THE SOF HIERARCHY.
C
  890 CALL EXLVL (NOS,Z(IDM),BUF(2),Z(10*ISS+1),LCORE-10*ISS)
      GO TO 870
C
C     INVALID ITEM NAME
C
  900 CALL SMSG (3,BUF(4),BUF(2))
C
C     BECAUSE OF ERRORS, NO COPY.  SKIP DATA.
C
  910 CALL RECTYP (UNIT,IREC)
      IF (IREC .EQ. 0) GO TO 920
C
C     STRING RECORD - SKIP IT
C
      CALL FWDREC (*1870,UNIT)
      GO TO 910
C
C     NORMAL GINO RECORD - CHECK IF EOI
C
  920 CALL READ (*1870,*910,UNIT,I,1,1,FLAG)
      IF (I-EOI) 910,570,910
C
C     COPY THE DATA FROM THE GINO FILE TO THE SOF.
C
  930 I = 10*ISS + 1
      J = LCORE - I + 1
      IF (J .LT. 2) GO TO 1890
  940 CALL READ (*1870,*950,UNIT,Z(I),J,0,FLAG)
      RC = 1
      CALL SUWRT (Z(I),J,RC)
      GO TO 940
  950 IF (Z(I) .EQ. EOI) GO TO 960
      RC = 2
      CALL SUWRT (Z(I),FLAG,RC)
      GO TO 940
  960 RC = 3
      CALL SUWRT (0,0,RC)
      GO TO 1070
C
C     COPY MATRIX DATA FROM THE GINO FILE TO THE SOF.
C
  970 IFILE = SCR2
      I = 10*ISS + 1
      J = LCORE - I + 1
      IF (J .LT. 7) GO TO 1890
      CALL READ (*2020,*2030,UNIT,Z(I+1),6,1,NW)
      Z(I) = SCR2
      CALL WRTTRL (Z(I))
      INBLK(1)  = UNIT
      OUTBLK(1) = SCR2
      CALL OPEN (*2010,SCR2,Z(BUF5),WRTREW)
  980 CALL RECTYP (UNIT,ITYPE)
      IF (ITYPE .NE. 0) GO TO 1010
  990 CALL READ (*2010,*1000,UNIT,Z(I),J,0,NW)
      CALL WRITE (SCR2,Z(I),J,0)
      GO TO 990
 1000 IF (Z(I) .EQ. EOI) GO TO 1020
      CALL WRITE (SCR2,Z(I),NW,1)
      GO TO 980
 1010 CALL CPYSTR (INBLK,OUTBLK,0,0)
      GO TO 980
 1020 CALL CLOSE (SCR2,1)
 1030 CALL MTRXO (SCR2,BUF(2),BUF(4),0,RC)
      GO TO (1040,1070,1070,1050,1060,2010), RC
C
C     ITEM ALREADY EXISTS
C
 1040 LINE = LINE + 2
      IF (LINE .GT. NLPP) CALL PAGE
      WRITE (NOUT,2220) UWM,BUF(2),BUF(3),BUF(4)
      Z(10*ISS) = 1
      GO TO 570
C
C     SUBSTRUCTURE DOES NOT EXIST - ADD IT TO THE SOF HIERARCHY
C
 1050 CALL EXLVL (NOS,Z(IDM),BUF(2),Z(10*ISS+1),LCORE-10*ISS)
      GO TO 1030
C
C     ILLEGAL ITEM NAME
C
 1060 LINE = LINE + 2
      IF (LINE .GT. NLPP) CALL PAGE
      CALL SMSG (3,BUF(4),BUF(2))
      GO TO 570
C
C     ITEM COPIED - PRINT MESSAGE
C
 1070 LINE = LINE + 1
      IF (LINE .GT. NLPP) CALL PAGE
      WRITE (NOUT,2170) UIM,BUF(2),BUF(3),BUF(4),UNIT,SOF,
     1                  (BUF(I),I=5,10)
C
C     INCREMENT NUMBER OF ITEMS COPIED.  IF NOT ALL ARE COPIED, LOOP
C     BACK TO FIND NEXT SUBSTRUCTURE/ITEM ON THE EXTERNAL FILE TO BE
C     COPIED.
C
      JCOPY = JCOPY + 1
      IF (NCOPY-JCOPY) 570,1150,570
C
C     THE ENTIRE EXTERNAL FILE HAS NOW BEEN SCANNED, BUT NOT ALL ITEMS
C     WERE FOUND.  WARN USER OF EACH ITEM NOT FOUND.
C
C     SKIP REMAINDER OF CURRENT ITEM SO FILE IS PROPERLY POSITIONED
C     FOR NEXT EXECUTION OF MODULE.
C
 1080 DO 1120 I = 1,9,2
      IF (NAMES(I) .EQ. XXXX) GO TO 1120
      DO 1110 ITEM = 1,NITEMS
      IF (ISS .EQ. 0) GO TO 1100
      DO 1090 J = 1,ISS
      JSS = 10*(J-1)
      IF (NAMES(I).EQ.Z(JSS+1) .AND. NAMES(I+1).EQ.Z(JSS+2) .AND.
     1    XITEMS(ITEM) .EQ. Z(JSS+3)) GO TO 1110
 1090 CONTINUE
 1100 LINE = LINE + 2
      IF (LINE .GT. NLPP) CALL PAGE
      WRITE (NOUT,2230) UWM,NAMES(I),NAMES(I+1),XITEMS(ITEM),UNAME
 1110 CONTINUE
 1120 CONTINUE
 1130 CALL RECTYP (UNIT,IREC)
      IF (IREC .EQ. 0) GO TO 1140
C
C     STRING RECORD - SKIP IT
C
      CALL FWDREC (*1870,UNIT)
      GO TO 1130
C
C     NORMAL GINO RECORD - CHECK IF EOI
C
 1140 CALL READ (*1870,*1130,UNIT,I,1,1,FLAG)
      IF (I-EOI) 1130,1150,1130
C
C     READ OPERATION COMPLETE
C
 1150 CALL CLOSE (UNIT,NOREW)
      GO TO 1740
C
C     *********************   C H E C K   ***************************
C
C     REWIND THE EXTERNAL FILE AND PRINT A LIST OF ALL SUBSTRUCTURE/
C     ITEMS ON IT WITH THE DATE AND TIME WHEN THEY WERE WRITTEN THERE.
C
 1160 CALL OPEN (*1860,UNIT,Z(BUF4),RDREW)
      CALL PAGE
      WRITE (NOUT,2240) UIM,UNAME
      LINE = LINE + 1
      CALL READ (*1870,*1880,UNIT,BUF,9,1,FLAG)
      GO TO 1180
 1170 CALL READ (*1210,*1180,UNIT,BUF,10,1,FLAG)
      LINE = LINE + 1
      IF (LINE .GT. NLPP) CALL PAGE
      WRITE (NOUT,2250) (BUF(I),I=2,10)
      GO TO 1190
 1180 LINE = LINE + 1
      IF (LINE .GT. NLPP) CALL PAGE
      WRITE (NOUT,2120) UIM,(BUF(I),I=2,9)
 1190 CALL RECTYP (UNIT,IREC)
      IF (IREC .EQ. 0) GO TO 1200
C
C     STRING RECORD - SKIP IT
C
      CALL FWDREC (*1870,UNIT)
      GO TO 1190
C
C     NORMAL GINO RECORD - CHECK IF EOI
C
 1200 CALL READ (*1870,*1190,UNIT,I,1,1,FLAG)
      IF (I-EOI) 1190,1170,1190
 1210 CALL BCKREC (UNIT)
      CALL CLOSE (UNIT,NOREW)
      GO TO 1740
C
C     ********************   A P P E N D   ***************************
C
C     ADD AN EXISTING SOF IN ITS RANDOM ACCESS FORM TO THE RESIDENT SOF.
C     THE MDI AND DIT OF THE EXTERNAL SOF ARE MERGED INTO THOSE OF THE
C     RESIDENT SOF.  THE NXT OF THE EXTERNAL SOF IS INCREMENTED BY THE
C     NUMBER OF BLOCKS IN THE RESIDENT SOF.  THE COMMON BLOCKS /SYS/,
C     /SOF/, AND /SOFCOM/ ARE UPDATED AND WRITTEN TO THE FIRST PHYSICAL
C     BLOCK ON EACH FILE OF THE RESIDENT SOF BY SOFCLS.  NOTE THAT NO
C     USER DATA IS ACTUALLY MOVED.
C
C     FIRST, ADD THE EXTERNAL SOF TO /SOFCOM/ SO THAT SOFIO CAN BE USED
C     TO READ IT.
C
 1220 IF (NFILES .LT. 10) GO TO 1230
      WRITE (NOUT,2260) UWM,UNAME
      WRITE (NOUT,2270)
      GO TO 1910
 1230 NFILES = NFILES + 1
      FILNAM(NFILES) = UNIT
      FILSIZ(NFILES) = 4
      NSAVE = NOBLKS + 1
C
C     READ THE FIRST PHYSICAL BLOCK OF THE EXTERNAL SOF AND SEE THAT IT
C     IS COMPATIBLE WITH THE RESIDENT SOF.
      INCBLK =-4
      DO 1240 I = 1,NFILES
 1240 INCBLK = INCBLK+FILSIZ(I)
      CALL SOFIO (SRD,INCBLK+1,Z(BUF4))
C
C     PASSWORD CHECK
C
      IF (Z(BUF4+3).EQ.DATYPE(1) .AND. Z(BUF4+4).EQ.DATYPE(2))
     1    GO TO 1250
      WRITE (NOUT,2260) UWM,UNAME
      WRITE (NOUT,2310)
      INCBLK =-1
C
C     FILE SEQUENCE NUMBER CHECK
C
 1250 IF (Z(BUF4+5) .EQ. 1) GO TO 1260
      WRITE (NOUT,2260) UWM,UNAME
      WRITE (NOUT,2280)
      INCBLK =-1
C
C     NUMBER OF EXTERNAL FILES CHECK
C
 1260 IF (Z(BUF4+6) .EQ. 1) GO TO 1270
      WRITE (NOUT,2260) UWM,UNAME
      WRITE (NOUT,2290)
      INCBLK =-1
C
C     BLOCKSIZE CHECK
C
 1270 IF (Z(BUF4+27) .EQ. BLKSIZ) GO TO 1280
      WRITE (NOUT,2260) UWM,UNAME
      WRITE (NOUT,2300) BLKSIZ,Z(BUF4+27)
      INCBLK =-1
 1280 IF (INCBLK .LT. 0) GO TO 1490
C
C     COMPLETE THE UPDATING OF THE COMMON BLOCKS
C
      FILSIZ(NFILES) = Z(BUF4+17)
      AVBLKS = AVBLKS + Z(BUF4+30)
      NXTCUR = 1
      NXTRST =.TRUE.
      NXTFSZ(NFILES) = Z(BUF4+36)
      J = NFILES-1
      NXTTSZ = 0
      DO 1290 I = 1,J
 1290 NXTTSZ = NXTTSZ + NXTFSZ(I)
      OLDTSZ = NXTTSZ + 1
      NXTTSZ = NXTTSZ + Z(BUF4+35)
C
C     READ THE DIT OF THE EXTERNAL SOF AND ADD EACH SUBSTRUCTURE THERE
C     TO THE DIT OF THE RESIDENT SOF.  KEEP A TABLE IN OPEN CORE OF TWO
C     WORDS PER SUBSTRUCTURE -
C
C     (1)  SUBSTRUCTURE NUMBER FROM THE EXTERNAL SOF.
C     (2)  NEW SUBSTRUCTURE NUMBER ON THE RESIDENT SOF.
C
      NOLD = Z(BUF4+32)
      IF (2*NOLD .GT. LCORE) GO TO 1890
      ISS = 1
      K   = 1
      KDIT = Z(BUF4+33) + INCBLK
      KMDI = Z(BUF4+34) + INCBLK
 1300 CALL SOFIO (SRD,KDIT,Z(BUF4))
      DO 1350 I = 1,BLKSIZ,2
      SSNAME(1) = Z(BUF4+I+2)
      SSNAME(2) = Z(BUF4+I+3)
      IF (SSNAME(1) .EQ. BLANK) GO TO 1350
 1320 CALL FDSUB (SSNAME,J)
      IF (J .EQ. -1) GO TO 1330
C
C     DUPLICATE NAME ON RESIDENT SOF.  PREFIX IT WITH -Q- AND TRY AGAIN.
C
      WRITE (NOUT,2320) UWM,SSNAME
      CALL PREFIX (Q,SSNAME)
      IF (SSNAME(2) .NE. QQQQ) GO TO 1320
      WRITE (NOUT,2330)
      Z(ISS  ) = (I+1)/2
      Z(ISS+1) = 0
      ISS = ISS + 2
      GO TO 1340
 1330 CALL CRSUB (SSNAME,J)
      Z(ISS  ) = K
      Z(ISS+1) = J
      ISS = ISS + 2
      K   = K + 1
 1340 IF (ISS/2 .GE. NOLD) GO TO 1380
 1350 CONTINUE
C
C     GET THE NEXT BLOCK OF THE DIT FROM THE EXTERNAL SOF
C
      CALL FNXT (KDIT,J)
      IF (MOD(KDIT,2) .EQ. 1) GO TO 1360
      I = ANDF(RSHIFT(COR(J),IHALF),JHALF)
      GO TO 1370
 1360 I = ANDF(COR(J),JHALF)
 1370 KDIT = I + INCBLK
      GO TO 1300
C
C     THE DIT OF THE EXTERNAL SOF HAS NOW BEEN MERGED WITH THE DIT OF
C     THE RESIDENT SOF.  NOW MERGE THE MDI
C
 1380 ISS = 0
 1390 CALL SOFIO (SRD,KMDI,Z(BUF4))
      DO 1420 I = 1,BLKSIZ,DIRSIZ
      IF (BLKSIZ-I+1 .LT. DIRSIZ) GO TO 1420
      ISS = ISS  + 1
      JMDI= BUF4 + I + 1
      CALL BISLOC (*1900,ISS,Z,2,NOLD,K)
      CALL FMDI (Z(K+1),JRMDI)
C
C     PUT THE CONVERTED SUBSTRUCTURE INDICES IN THE FIRST TWO WORDS OF
C     THE MDI OF THE RESIDENT SOF.
C
      DO 1400 J = 1,6
      MASK = LSHIFT(1023,10*((J-1)/2))
C                   1023 = 2*10-1, LEFT SHIFT 0, 10, AND 20 BITS
C
      K = MOD(J-1,2) + 1
      JSS = ANDF(Z(JMDI+K),MASK)
      IF (JSS .EQ. 0) GO TO 1400
      CALL BISLOC (*1900,JSS,Z,2,NOLD,K)
      JSS = Z(K+1)
      COR(JRMDI+K) = ANDF(COR(JRMDI+K),LSHIFT(JSS,10*((J-1)/2)))
 1400 CONTINUE
C
C     INCREMENT THE BLOCK INDICES OF THE ITEMS IN THIS MDI DIRECTORY BY
C     THE NUMBER OF BLOCKS ON THE RESIDENT SOF.
C
      DO 1410 J = IFRST,DIRSIZ
      IF (ANDF(Z(JMDI+J),JHALF) .EQ. 0) GO TO 1410
      COR(JRMDI+J) = Z(JMDI+J) + INCBLK
 1410 CONTINUE
      IF (ISS .EQ. NOLD) GO TO 1450
 1420 CONTINUE
C
C     GET THE NEXT BLOCK OF THE MDI FROM THE EXTERNAL SOF.
C
      CALL FNXT (KMDI,J)
      IF (MOD(KMDI,2) .EQ. 1) GO TO 1430
      I = ANDF(RSHIFT(COR(J),IHALF),JHALF)
      GO TO 1440
 1430 I = ANDF(COR(J),JHALF)
 1440 KMDI = I + INCBLK
      GO TO 1390
C
C     THE MDI OF THE EXTERNAL SOF HAS NOW BEEN MERGED WITH THE MDI OF
C     THE RESIDENT SOF.  NOW UPDATE THE NXT OF THE EXTERNAL SOF.
C
 1450 N = BLKSIZ
      KNXT = INCBLK + 2
      INCBLK = ORF(INCBLK,LSHIFT(INCBLK,IHALF))
      DO 1470 I = OLDTSZ,NXTTSZ
      CALL SOFIO (SRD,KNXT,Z(BUF4))
      IF (I-OLDTSZ+1 .EQ. NXTFSZ(NFILES))
     1    N = (MOD(FILSIZ(NFILES)-2,SUPSIZ)+1)/2 + 1
      DO 1460 J = 1,N
 1460 Z(BUF4+J+2) = Z(BUF4+J+2) + INCBLK
      CALL SOFIO (SWRT,KNXT,Z(BUF4))
      KNXT = KNXT + SUPSIZ
 1470 CONTINUE
C
C     RELEASE THE BLOCKS USED BY THE MDI AND DIT OF THE EXTERNAL SOF.
C     (THIS WILL CAUSE THE EXTERNAL SOF TO BE UNUSEABLE IN ITS ORIGINAL
C     FORM.)
C
      INCBLK = ANDF(INCBLK,JHALF)
      CALL SOFIO (SRD,INCBLK+1,Z(BUF4))
      KDIT = Z(BUF4+33) + INCBLK
      KMDI = Z(BUF4+34) + INCBLK
      CALL RETBLK (KDIT)
      CALL RETBLK (KMDI)
C
C     WRITE ON ALL BLOCKS BETWEEN THE HIGHEST BLOCK WRITTEN ON THE
C     ORIGINAL RESIDENT SOF AND THE FIRST BLOCK OF THE APPENDED SOF.
C     THIS IS REQUIRED TO AVOID DATA TRANSMISSION ERRORS.
C
      N = FILSIZ(NFILES-1)
      DO 1480 I = NSAVE,N
      CALL SOFIO (SWRT,NSAVE,Z(BUF4))
 1480 CONTINUE
C
C     SOFCLS WILL UPDATE THE FIRST PHYSICAL BLOCK ON EACH SOF UNIT.
C
      CALL SOFCLS
C
C     APPEND OPERATION COMPLETED SUCCESSFULLY.  TELL USER THE NEWS.
C
      WRITE (NOUT,2340) UIM,UNAME
      N = SOFSIZ(N)
      WRITE (NOUT,2360) UIM,AVBLKS,N
      GO TO 1750
C
C     APPEND OPERATION ABORTED.  RESTORE THE COMMON BLOCKS FOR THE
C     RESIDENT SOF.
C
 1490 FIRST =.TRUE.
      OPNSOF=.FALSE.
      CALL SOFOPN (Z(BUF1),Z(BUF2),Z(BUF3))
      GO TO 1900
C
C     ********************   C O M P R E S S   **********************
C
C     FOR EACH SUBSTRUCTURE IN THE DIT, COPY EACH ITEM WHICH EXISTS OR
C     PSEUDO-EXISTS TO SCR1 AND DELETE THE ITEM ON THE SOF.  THEN COPY
C     ALL ITEMS BACK.  ALL INTERMEDIATE FREE BLOCKS WILL THUS BE
C     ELIMINATED AND THE DATA FOR ANY ONE ITEM WILL BE STORED ON
C     CONTIGUOUS BLOCKS.
C
C     THE FORMAT OF THE SCRATCH FILE IS --
C
C                                      +------------+
C     SUBSTRUCTURE NAME (2 WORDS)      I            I+
C     ITEM NAME (1 WORD)               I HEADER     I +
C     PSEUDO FLAG -- 2 FOR PSEUDO-ITEM I RECORD     I  +
C                    3 FOR REAL DATA   I            I   +   REPEATED
C                                      +------------+    +  FOR EACH
C     DATA -- 1 SOF GROUP PER          I DATA       I   +   SUBS./ITEM
C             GINO LOGICAL RECORD      I RECORDS    I  +
C                                      +------------+ +
C     END OF ITEM FLAG (1 WORD)        I EOI RECORD I+
C                                      +------------+
C
 1500 UNIT = SCR1
      CALL OPEN (*1860,SCR1,Z(BUF4),WRTREW)
C
C     COPY OUT DIT AND MDI INFORMATION
C
      ISS = 0
      DO 1510 K = 1,DITSIZ,2
      ISS = ISS + 1
      CALL FDIT  (ISS,J)
      CALL WRITE (SCR1,COR(J),2,0)
      CALL FMDI  (ISS,J)
      CALL WRITE (SCR1,COR(J+1),2,0)
 1510 CONTINUE
      CALL WRITE (SCR1,0,0,1)
C
C     COPY OUT SUBSTRUCTURE ITEMS
C
      ISS = 0
      DO 1600 K = 1,DITSIZ,2
      ISS = ISS + 1
      CALL FDIT (ISS,J)
      SSNAME(1) = COR(J  )
      SSNAME(2) = COR(J+1)
      IF (SSNAME(1) .EQ. BLANK) GO TO 1600
      DO 1590 ITEM = 1,NITEM
      KDH = ITEMS(2,ITEM)
      IF (KDH .EQ. 1) GO TO 1570
      CALL SFETCH (SSNAME,ITEMS(1,ITEM),SRD,RC)
      GO TO (1540,1530,1590,1520,1520), RC
 1520 CALL SMSG (RC-2,ITEMS(1,ITEM),SSNAME)
      GO TO 1590
C
C     ITEM PSEUDO-EXISTS.  WRITE PSEUDO-HEADER RECORD AND EOI RECORD.
C
 1530 CALL WRITE (SCR1,SSNAME,2,0)
      CALL WRITE (SCR1,ITEMS(1,ITEM),1,0)
      CALL WRITE (SCR1,2,1,1)
      CALL WRITE (SCR1,EOI,1,1)
      GO TO 1590
C
C     ITEM EXISTS.  COPY IT OUT.
C
 1540 CALL WRITE (SCR1,SSNAME,2,0)
      CALL WRITE (SCR1,ITEMS(1,ITEM),1,0)
      CALL WRITE (SCR1,3,1,1)
 1550 CALL SUREAD(Z,LCORE,N,RC)
      IF (RC .GT. 1) GO TO 1560
      CALL WRITE (SCR1,Z,LCORE,0)
      GO TO 1550
 1560 CALL WRITE (SCR1,Z,N,1)
      IF (RC .EQ. 2) GO TO 1550
C
C     END OF ITEM HIT.  WRITE EOI RECORD
C
      CALL WRITE (SCR1,EOI,1,1)
      GO TO 1590
C
C     PROCESS MATRIX ITEMS
C
 1570 CALL MTRXI (SCR2,SSNAME,ITEMS(1,ITEM),0,RC)
      IFILE = SCR2
      GO TO (1580,1530,1590,1520,1520,2010), RC
 1580 CALL WRITE (SCR1,SSNAME,2,0)
      CALL WRITE (SCR1,ITEMS(1,ITEM),1,0)
      CALL WRITE (SCR1,3,1,1)
      CALL OPEN  (*2010,SCR2,Z(BUF5),RDREW)
      Z(1) = SCR2
      CALL RDTRL (Z(1))
      CALL WRITE (SCR1,Z(IZ2),6,1)
      CALL CPYFIL(SCR2,SCR1,Z,LCORE,ICOUNT)
      CALL WRITE (SCR1,EOI,1,1)
      CALL CLOSE (SCR2,1)
 1590 CONTINUE
 1600 CONTINUE
C
C     COPY ALL ITEMS BACK TO THE SOF
C
      CALL CLOSE (SCR1,REW)
      CALL OPEN  (*1860,SCR1,Z(BUF4),RDREW)
C
C     RE-INITIALIZE THE SOF, THEN RESTORE THE OLD DIT AND MDI
C
      CALL SOFCLS
      STATUS= 0
      FIRST =.TRUE.
      CALL SOFOPN (Z(BUF1),Z(BUF2),Z(BUF3))
      CALL PAGE
      ISS = 0
 1610 CALL READ (*1870,*1620,SCR1,BUF,4,0,FLAG)
      ISS = ISS + 1
      IF (BUF(1) .EQ. BLANK) GO TO 1610
      CALL CRSUB (BUF,I)
      CALL FMDI  (I,J)
      COR(J+1) = BUF(3)
      COR(J+2) = BUF(4)
      MDIUP = .TRUE.
      GO TO 1610
C
C     READ HEADER RECORD AND FETCH THE SOF ITEM
C
 1620 CALL READ (*1730,*1880,SCR1,BUF,4,1,FLAG)
      KDH = ITTYPE(BUF(3))
      IF (KDH .EQ. 1) GO TO 1660
      CALL SFETCH (BUF,BUF(3),2,BUF(4))
C
C     COPY THE DATA
C
 1630 CALL READ (*1870,*1640,SCR1,Z,LCORE,0,FLAG)
      IF (Z(1) .EQ. EOI) GO TO 1650
      CALL SUWRT (Z,LCORE,1)
      GO TO 1630
 1640 IF (Z(1) .EQ. EOI) GO TO 1650
      CALL SUWRT (Z,FLAG,2)
      GO TO 1630
C
C     EOI FOUND
C
 1650 CALL SUWRT (0,0,3)
      GO TO 1720
C
C     COPY IN MATRIX ITEMS
C
 1660 CALL OPEN (*2010,SCR2,Z(BUF5),WRTREW)
      CALL READ (*1870,*1880,SCR1,Z(IZ2),6,1,NW)
      Z(1) = SCR2
      CALL WRTTRL (Z(1))
      INBLK(1)  = SCR1
      OUTBLK(1) = SCR2
 1670 CALL RECTYP (SCR1,ITYPE)
      IF (ITYPE .NE. 0) GO TO 1700
 1680 CALL READ (*1870,*1690,SCR1,Z,LCORE,0,NW)
      CALL WRITE (SCR2,Z,LCORE,0)
      GO TO 1680
 1690 IF (Z(1) .EQ. EOI) GO TO 1710
      CALL WRITE (SCR2,Z,NW,1)
      GO TO 1670
 1700 CALL CPYSTR (INBLK,OUTBLK,0,0)
      GO TO 1670
C
C     EOI FOUND
C
 1710 CALL CLOSE (SCR2,1)
      CALL MTRXO (SCR2,BUF,BUF(3),0,RC)
 1720 CONTINUE
      LINE = LINE + 1
      IF (LINE .GT. NLPP) CALL PAGE
      WRITE (NOUT,2350) UIM,BUF(1),BUF(2),BUF(3)
      GO TO 1620
C
C     COMPRESS COMPLETE
C
 1730 CALL CLOSE (SCR1,REW)
C
C     **********************   C O D A   ************************
C
C     NORMAL TERMINATION
C
 1740 CALL SOFCLS
 1750 RETURN
C
C     ERRORS CAUSING MODULE AND/OR JOB TERMINATION
C
 1800 WRITE (NOUT,2100) UWM,UNAME
      GO TO 1910
 1810 WRITE (NOUT,2110) UWM,DEVICE
      GO TO 1910
 1820 WRITE (NOUT,2140) UWM,MODE
      GO TO 1910
 1830 WRITE (NOUT,2150) UWM,POS
      GO TO 1910
 1840 WRITE (NOUT,2180) UWM
      GO TO 1910
 1850 WRITE (NOUT,2190) SWM,UNAME
      CALL CLOSE (UNIT,NOREW)
      GO TO 1910
C
 1860 N = -1
      GO TO 2000
 1870 N = -2
      GO TO 2000
 1880 N = -3
      GO TO 2000
 1890 N = 8
      GO TO 2000
 1900 N = -61
      GO TO 2000
 1910 CALL SOFCLS
      DRY = -2
      WRITE (NOUT,2370) SIM
      RETURN
C
 2000 CALL SOFCLS
      CALL MESAGE (N,UNIT,SUBR)
      DRY = -2
      WRITE (NOUT,2370) SIM
      RETURN
C
 2010 N = -1
      GO TO 2040
 2020 N = -2
      GO TO 2040
 2030 N = -3
 2040 CALL SOFCLS
      CALL MESAGE (N,IFILE,SUBR)
      RETURN
C
C     TEXT OF ERROR MESSAGES
C
 2100 FORMAT (A25,' 6334, EXIO DEVICE PARAMETER SPECIFIES TAPE, BUT ',
     1        'UNIT ',2A4,' IS NOT A PHYSICAL TAPE')
 2110 FORMAT (A25,' 6335, ',2A4,' IS AN INVALID DEVICE FOR MODULE EXIO')
 2120 FORMAT (A29,' 6336, EXIO FILE IDENTIFICATION.  PASSWORD= ',2A4,
     1       '  DATE=',I3,1H/,I2,1H/,I2,7H  TIME=,I3,1H.,I2,1H.,I2)
 2130 FORMAT (A29,' 6337,',I6,' BLOCKS (',I4,' SUPERBLOCKS) OF THE SOF',
     1       ' SUCCESSFULLY DUMPED TO EXTERNAL FILE ',2A4)
 2140 FORMAT (A25,' 6338, ',2A4,' IS AN INVALID MODE PARAMETER FOR ',
     1       'MODULE EXIO')
 2150 FORMAT (A25,' 6339, ',2A4,' IS AN INVALID FILE POSITIONING ',
     1       'PARAMETER FOR MODULE EXIO')
 2160 FORMAT (A25,' 6340, SUBSTRUCTURE ',2A4,' ITEM ',A4,
     1       ' PSEUDOEXISTS ONLY AND CANNOT BE COPIED OUT BY EXIO')
 2170 FORMAT (A29,' 6341, SUBSTRUCTURE ',2A4,' ITEM ',A4,
     1       ' SUCCESSFULLY COPIED FROM ',A4,' TO ',A4,2H (,
     2       I2,1H/,I2,1H/,I2,2H, ,I2,1H.,I2,1H.,I2,1H))
 2180 FORMAT (A25,' 6342, SOF RESTORE OPERATION FAILED.  THE RESIDENT ',
     1       'SOF IS NOT EMPTY')
 2190 FORMAT (A27,' 6343, ',2A4,' IS NOT AN EXTERNAL SOF FILE')
 2200 FORMAT (A29,' 6344, SOF RESTORE OF ',I6,' BLOCKS SUCCESSFULLY ',
     1       'COMPLETED')
 2210 FORMAT (A25,' 6345, SUBSTRUCTURE ',2A4,' ITEM ',A4,
     1       ' IS DUPLICATED ON EXTERNAL FILE ',2A4, /32X,
     2       'OLDER VERSION (',I2,1H/,I2,1H/,I2,2H, ,I2,1H.,I2,1H.,I2,
     3       ') IS IGNORED')
 2220 FORMAT (A25,' 6346, SUBSTRUCTURE ',2A4,' ITEM ',A4,
     1       ' NOT COPIED.  IT ALREADY EXISTS ON THE SOF')
 2230 FORMAT (A25,' 6348, SUBSTRUCTURE ',2A4,' ITEM ',A4,
     1       ' NOT FOUND ON EXTERNAL FILE ',2A4)
 2240 FORMAT (A29,' 6349, CONTENTS OF EXTERNAL SOF FILE ',2A4,' FOLLOW')
 2250 FORMAT (5X,'SUBSTRUCTURE ',2A4,5X,'ITEM ',A4,10X,5HDATE ,I2,1H/,
     1       I2,1H/,I2,10X,5HTIME ,I2,1H.,I2,1H.,I2)
 2260 FORMAT (A25,' 6350, SOF APPEND OF FILE ',2A4,' FAILED')
 2270 FORMAT (32X,'TOO MANY PHYSICAL SOF UNITS. MAXIMUM ALLOWED IS 10')
 2280 FORMAT (32X,'THE SEQUENCE NUMBER OF THE EXTERNAL SOF FILE IS NOT',
     1       ' 1')
 2290 FORMAT (32X,'THE EXTERNAL SOF FILE MUST CONSIST OF ONLY ONLY ONE',
     1       ' PHYSICAL UNIT')
 2300 FORMAT(32X,45HTHE EXTERNAL SOF HAS INCOMPATIBLE BLOCK SIZE., /
     1       32X, 32HBLOCK SIZE OF THE RESIDENT SOF = ,I5, /
     2       32X, 32HBLOCK SIZE OF THE EXTERNAL SOF = ,I5 )
 2310 FORMAT (32X,17HINVALID PASSWORD.)
 2320 FORMAT (A25,' 6351, DUPLICATE SUBSTRUCTURE NAME ',2A4,
     1       ' FOUND DURING SOF APPEND OF FILE ',2A4, /32X,
     2       'THE SUBSTRUCTURE WITH THIS NAME ON THE FILE BEING ',
     3       'APPENDED WILL BE PREFIXED WITH Q')
 2330 FORMAT (1H0,31X, 37HPREFIX FAILED.  SUBSTRUCTURE IGNORED.)
 2340 FORMAT (A29,' 6352, EXTERNAL SOF FILE ',2A4,
     1       ' SUCCESSFULLY APPENDED TO THE RESIDENT SOF')
 2350 FORMAT (A29,' 6353, SUBSTRUCTURE ',2A4,' ITEM ',A4,
     1       ' HAS BEEN SUCCESSFULLY COMPRESSED')
 2360 FORMAT (A29,' 6354, THERE ARE',I7,' FREE BLOCKS (',I9,
     1       ' WORDS) ON THE RESIDENT SOF')
 2370 FORMAT (A31,' 6355, EXIO TERMINATED WITH ERRORS.  DRY RUN MODE ',
     1       'ENTERED')
      END

      SUBROUTINE FRRD
C
C     FREQUENCY AND RANDOM RESPONSE MODULE
C
C     INPUTS CASECC,USETD,DLT,FRL,GMD,GOD,KDD,BDD,MDD,PHIDH,DIT
C
C     OUTPUTS UDV,PS,PD,PP
C
C     8 SCRATCHES
C
      INTEGER         SINGLE,OMIT,CASECC,USETD,DLT,FRL,GMD,GOD,BDD,
     1                PHIDH,DIT,SCR1,SCR2,SCR3,SCR4,SCR5,SCR6,SCR7,SCR8,
     2                UDV,PS,PD,PP,PDD,FOL,NAME(2),MCB(7)
      COMMON /BLANK / APP(2),MODAL(2),LUSETD,MULTI,SINGLE,OMIT,
     1                NONCUP,FRQSET
      COMMON /FRRDST/ OVF(150),ICNT,IFRST,ITL(3),IDIT,IFRD,K4DD
      COMMON /CDCMPX/ DUM32(32),IB,IBBAR
      DATA    CASECC, USETD,DLT,FRL,GMD,GOD,KDD,BDD,MDD,PHIDH,DIT /
     1        101   , 102,  103,104,105,106,107,108,109,110,  111 /
      DATA    UDV   , PS, PD, PP ,PDD,FOL /
     1        201   , 202,203,204,203,205 /
      DATA    SCR1  , SCR2,SCR3,SCR4,SCR5,SCR6,SCR7,SCR8 /
     1        301   , 302, 303, 304, 305, 306, 307, 308  /
      DATA    MODA  / 4HMODA /,      NAME /4HFRRD,4H     /
C
      PDD  = 203
      SCR6 = 306
      IB   = 0
C
C     BUILD LOADS ON P SET ORDER IS ALL FREQ. FOR LOAD TOGETHER
C     FRRD1A IS AN ENTRY POINT IN FRLGA
C
      CALL FRRD1A (DLT,FRL,CASECC,DIT,PP,LUSETD,NFREQ,NLOAD,FRQSET,FOL,
     1             NOTRD)
      IF (MULTI.LT.0 .AND. SINGLE.LT.0 .AND. OMIT.LT.0 .AND.
     1    MODAL(1).NE. MODA) GO TO 60
C
C     REDUCE LOADS TO D OR H SET
C     FRRD1B IS AN ENTRY POINT IN FRLGB
C
      CALL FRRD1B (PP,USETD,GMD,GOD,MULTI,SINGLE,OMIT,MODAL(1),PHIDH,PD,
     1             PS,SCR5,SCR1,SCR2,SCR3,SCR4)
C
C     SCR5 HAS PH IF MODAL FORMULATION
C
      IF (MODAL(1) .EQ.MODA) PDD = SCR5
C
C     SOLVE PROBLEM FOR EACH FREQUENCY
C
      IF (NONCUP.LT.0 .AND. MODAL(1).EQ.MODA) GO TO 50
   10 IF (NFREQ.EQ.1  .OR.  NLOAD.EQ.1) SCR6 = UDV
      DO 20 I = 1,NFREQ
      CALL KLOCK (ITIME1)
C
C     FORM AND DECOMPOSE MATRICES
C     IF MATRIX IS SINGULAR, IGOOD IS SET TO 1 IN FRRD1C. ZERO OTHERWISE
C
      CALL FRRD1C (FRL,FRQSET,MDD,BDD,KDD,I,SCR1,SCR2,SCR3,SCR4,SCR8,
     1             SCR7,IGOOD)
C
C     ULL IS ON SCR1 -- LLL IS IN SCR2
C
C     SOLVE FOR PD LOADS STACK ON SCR6
C
      CALL FRRD1D (PDD,SCR1,SCR2,SCR3,SCR4,SCR6,I,NLOAD,IGOOD,NFREQ)
      CALL KLOCK  (ITIME2)
      CALL TMTOGO (ITLEFT)
      IF (2*(ITIME2-ITIME1) .GT. ITLEFT .AND. I.NE.NFREQ) GO TO 70
   20 CONTINUE
C
      I = NFREQ
   30 IF (NFREQ.EQ.1 .OR. NLOAD.EQ.1) GO TO 40
C
C     RESORT SOLUTION VECTORS INTO SAME ORDER AS LOADS
C     FRRD1E IS AN ENTRY POINT IN FRRD1D
C
      CALL FRRD1E (SCR6,UDV,NLOAD,I)
   40 RETURN
C
C     UNCOUPLED MODAL
C
   50 CALL FRRD1F (MDD,BDD,KDD,FRL,FRQSET,NLOAD,NFREQ,PDD,UDV)
      GO TO 40
   60 PDD = PP
      GO TO 10
C
C     INSUFFICIENT TIME TO COMPLETE ANOTHER LOOP
C
   70 CALL MESAGE (45,NFREQ-I,NAME)
      MCB(1) = SCR6
      CALL RDTRL (MCB(1))
      NDONE  = MCB(2)
      MCB(1) = PP
      CALL RDTRL (MCB(1))
      MCB(2) = NDONE
      CALL WRTTRL (MCB(1))
      IF (SINGLE .LT. 0) GO TO 80
      MCB(1) = PS
      CALL RDTRL (MCB(1))
      MCB(2) = NDONE
      CALL WRTTRL (MCB(1))
   80 MCB(1) = PD
      CALL RDTRL( MCB(1))
      MCB(2) = NDONE
      CALL WRTTRL (MCB(1))
      GO TO 30
      END

      SUBROUTINE XLNKDD
C
C     LINK SPECIFICATION TABLE
C
C     A LINK TABLE ENTRY CONTAINS AN EXECUTABLE DMAP INSTRUCTION NAMES,
C     THEIR CORRESPONDING SUBROUTINE ENTRY POINT NAMES, AND THE LINK OR
C     LINKS WHERE THEY RESIDE
C     EACH BIT IN THE LINK FLAG SPECIFIES A LINK NUMBER. BIT 1 (RIGHT
C     MOST) SPECIFIES LINK ONE, BIT 2 SPECIFIES LINK 2, ETC.
C     BIT ON SPECIFIES MODULE IS IN THAT LINK, BIT OFF MEANS IT IS NOT.
C     EXAMPLE - SUPPOSE MODULE X IS IN LINKS 2,4 AND 5. ITS LINK
C               FLAG=32(8).
C
C     LLINK = LENGTH OF LINK TABLE.
C
C     SET SENSE SWITCH 28 TO GENERATE ALL FORTRAN CODE BELOW.
C
      DIMENSION       LINK (960),
     1                LINK01(90), LINK02(90), LINK03(90),LINK04(90),
     2                LINK05(90), LINK06(90), LINK07(90),LINK08(90),
     3                LINK09(90), LINK10(90), LINK11(70)
      COMMON /XLKSPC/ LLINK     , KLINK(970)
      EQUIVALENCE     (LINK(  1), LINK01(1)), (LINK( 91),LINK02(1)),
     1                (LINK(181), LINK03(1)), (LINK(271),LINK04(1)),
     2                (LINK(361), LINK05(1)), (LINK(451),LINK06(1)),
     3                (LINK(541), LINK07(1)), (LINK(631),LINK08(1)),
     4                (LINK(721), LINK09(1)), (LINK(811),LINK10(1)),
     5                (LINK(901), LINK11(1))
      DATA    LLINKX / 970 /
      DATA    LINK01 / 4HCHKP,4HNT  , 4HXCHK,4H    , 32767 ,
     1                 4HREPT,4H    , 4HXCEI,4H    , 32767 ,
     2                 4HJUMP,4H    , 4HXCEI,4H    , 32767 ,
     3                 4HCOND,4H    , 4HXCEI,4H    , 32767 ,
     4                 4HSAVE,4H    , 4HXSAV,4HE   , 32766 ,
     5                 4HPURG,4HE   , 4HXPUR,4HGE  , 32767 ,
     6                 4HEQUI,4HV   , 4HXEQU,4HIV  , 32767 ,
     7                 4HEND ,4H    , 4HXCEI,4H    , 32767 ,
     8                 4HEXIT,4H    , 4HXCEI,4H    , 32767 ,
     9                 4HADD ,4H    , 4HDADD,4H    , 72    ,
     O                 4HADD5,4H    , 4HDADD,4H5   , 64    ,
     1                 4HAMG ,4H    , 4HAMG ,4H    , 256   ,
     2                 4HAMP ,4H    , 4HAMP ,4H    , 256   ,
     3                 4HAPD ,4H    , 4HAPD ,4H    , 256   ,
     4                 4HBMG ,4H    , 4HBMG ,4H    , 512   ,
     5                 4HCASE,4H    , 4HCASE,4H    , 512   ,
     6                 4HCEAD,4H    , 4HCEAD,4H    , 1024  ,
     7                 4HCYCT,4H1   , 4HCYCT,4H1   , 64    /
      DATA    LINK02 / 4HCYCT,4H2   , 4HCYCT,4H2   , 64    ,
     1                 4HDDR ,4H    , 4HDDR ,4H    , 128   ,
     2                 4HDDR1,4H    , 4HDDR1,4H    , 2048  ,
     3                 4HDDR2,4H    , 4HDDR2,4H    , 2048  ,
     4                 4HDDRM,4HM   , 4HDDRM,4HM   , 2048  ,
     5                 4HDECO,4HMP  , 4HDDCO,4HMP  , 64    ,
     6                 4HDIAG,4HONAL, 4HDIAG,4HON  , 16384 ,
     7                 4HDPD ,4H    , 4HDPD ,4H    , 32    ,
     8                 4HDSCH,4HK   , 4HDSCH,4HK   , 64    ,
     9                 4HDSMG,4H1   , 4HDSMG,4H1   , 4096  ,
     O                 4HDSMG,4H2   , 4HDSMG,4H2   , 8     ,
     1                 4HDUMM,4HOD1 , 4HDUMO,4HD1  , 4     ,
     2                 4HDUMM,4HOD2 , 4HDUMO,4HD2  , 64    ,
     3                 4HDUMM,4HOD3 , 4HDUMO,4HD3  , 64    ,
     4                 4HDUMM,4HOD4 , 4HDUMO,4HD4  , 64    ,
     5                 4HEMA1,4H    , 4HEMA1,4H    , 128   ,
     6                 4HEMG ,4H    , 4HEMG ,4H    , 128   ,
     7                 4HFA1 ,4H    , 4HFA1 ,4H    , 1024  /
      DATA    LINK03 / 4HFA2 ,4H    , 4HFA2 ,4H    , 1024  ,
     1                 4HFBS ,4H    , 4HDFBS,4H    , 64    ,
     2                 4HFRLG,4H    , 4HFRLG,4H    , 512   ,
     3                 4HFRRD,4H    , 4HFRRD,4H    , 512   ,
     4                 4HGI  ,4H    , 4HGI  ,4H    , 256   ,
     5                 4HGKAD,4H    , 4HGKAD,4H    , 512   ,
     6                 4HGKAM,4H    , 4HGKAM,4H    , 512   ,
     7                 4HGP1 ,4H    , 4HGP1 ,4H    , 2     ,
     8                 4HGP2 ,4H    , 4HGP2 ,4H    , 2     ,
     9                 4HGP3 ,4H    , 4HGP3 ,4H    , 2     ,
     O                 4HGP4 ,4H    , 4HGP4 ,4H    , 8     ,
     1                 4HGPCY,4HC   , 4HGPCY,4HC   , 64    ,
     2                 4HGPFD,4HR   , 4HGPFD,4HR   , 4096  ,
     3                 4HDUMM,4HOD5 , 4HDUMO,4HD5  , 64    ,
     4                 4HGPWG,4H    , 4HGPWG,4H    , 8     ,
     5                 4HINPU,4HT   , 4HINPU,4HT   , 2     ,
     6                 4HINPU,4HTT1 , 4HINPT,4HT1  , 2     ,
     7                 4HINPU,4HTT2 , 4HINPT,4HT2  , 2     /
      DATA    LINK04 / 4HINPU,4HTT3 , 4HINPT,4HT3  , 2     ,
     1                 4HINPU,4HTT4 , 4HINPT,4HT4  , 2     ,
     2                 4HMATG,4HEN  , 4HMATG,4HEN  , 64    ,
     3                 4HMATG,4HPR  , 4HMATG,4HPR  , 16    ,
     4                 4HMATP,4HRN  , 4HMATP,4HRN  , 32766 ,
     5                 4HMATP,4HRT  , 4HPRTI,4HNT  , 32766 ,
     6                 4HMCE1,4H    , 4HMCE1,4H    , 8     ,
     7                 4HMCE2,4H    , 4HMCE2,4H    , 8     ,
     8                 4HMERG,4HE   , 4HMERG,4HE1  , 64    ,
     9                 4HMODA,4H    , 4HMODA,4H    , 64    ,
     O                 4HMODA,4HCC  , 4HMODA,4HCC  , 2048  ,
     1                 4HMODB,4H    , 4HMODB,4H    , 64    ,
     2                 4HMODC,4H    , 4HMODC,4H    , 64    ,
     3                 4HMPYA,4HD   , 4HDMPY,4HAD  , 64    ,
     4                 4HMTRX,4HIN  , 4HMTRX,4HIN  , 512   ,
     5                 4HOFP ,4H    , 4HOFP ,4H    , 8192  ,
     6                 4HOPTP,4HR1  , 4HOPTP,4HR1  , 2     ,
     7                 4HOPTP,4HR2  , 4HOPTP,4HR2  , 128   /
      DATA    LINK05 / 4HOUTP,4HUT  , 4HOUTP,4HT   , 8192  ,
     1                 4HOUTP,4HUT1 , 4HOUTP,4HT1  , 8192  ,
     2                 4HOUTP,4HUT2 , 4HOUTP,4HT2  , 8192  ,
     3                 4HOUTP,4HUT3 , 4HOUTP,4HT3  , 8192  ,
     4                 4HOUTP,4HUT4 , 4HOUTP,4HT4  , 8192  ,
     5                 4HPARA,4HM   , 4HQPAR,4HAM  , 32766 ,
     6                 4HPARA,4HML  , 4HPARA,4HML  , 32766 ,
     7                 4HPARA,4HMR  , 4HQPAR,4HMR  , 32766 ,
     8                 4HPART,4HN   , 4HPART,4HN1  , 64    ,
     9                 4HMRED,4H1   , 4HMRED,4H1   , 16384 ,
     O                 4HMRED,4H2   , 4HMRED,4H2   , 16384 ,
     1                 4HCMRE,4HD2  , 4HCMRD,4H2   , 16384 ,
     2                 4HPLA1,4H    , 4HPLA1,4H    , 4     ,
     3                 4HPLA2,4H    , 4HPLA2,4H    , 4096  ,
     4                 4HPLA3,4H    , 4HPLA3,4H    , 4096  ,
     5                 4HPLA4,4H    , 4HPLA4,4H    , 4096  ,
     6                 4HPLOT,4H    , 4HDPLO,4HT   , 2     ,
     7                 4HPLTS,4HET  , 4HDPLT,4HST  , 2     /
      DATA    LINK06 / 4HPLTT,4HRAN , 4HPLTT,4HRA  , 2     ,
     1                 4HPRTM,4HSG  , 4HPRTM,4HSG  , 2     ,
     2                 4HPRTP,4HARM , 4HPRTP,4HRM  , 128   ,
     3                 4HRAND,4HOM  , 4HRAND,4HOM  , 8192  ,
     4                 4HRMG ,4H    , 4HRMG ,4H    , 16    ,
     5                 4HRBMG,4H1   , 4HRBMG,4H1   , 8     ,
     6                 4HRBMG,4H2   , 4HRBMG,4H2   , 8     ,
     7                 4HRBMG,4H3   , 4HRBMG,4H3   , 8     ,
     8                 4HRBMG,4H4   , 4HRBMG,4H4   , 8     ,
     9                 4HREAD,4H    , 4HREIG,4H    , 32    ,
     O                 4HSCAL,4HAR  , 4HSCAL,4HAR  , 16384 ,
     1                 4HSCE1,4H    , 4HSCE1,4H    , 8     ,
     2                 4HSDR1,4H    , 4HSDR1,4H    , 2048  ,
     3                 4HSDR2,4H    , 4HSDR2,4H    , 4096  ,
     4                 4HSDR3,4H    , 4HSDR3,4H    , 8192  ,
     5                 4HSDRH,4HT   , 4HSDRH,4HT   , 4096  ,
     6                 4HSEEM,4HAT  , 4HSEEM,4HAT  , 2     ,
     7                 4HSETV,4HAL  , 4HSETV,4HAL  , 32766 /
      DATA    LINK07 / 4HSMA1,4H    , 4HSMA1,4H    , 4     ,
     1                 4HSMA2,4H    , 4HSMA2,4H    , 4     ,
     2                 4HSMA3,4H    , 4HSMA3,4H    , 8     ,
     3                 4HSMP1,4H    , 4HSMP1,4H    , 8     ,
     4                 4HSMP2,4H    , 4HSMP2,4H    , 8     ,
     5                 4HSMPY,4HAD  , 4HSMPY,4HAD  , 64    ,
     6                 4HSOLV,4HE   , 4HSOLV,4HE   , 64    ,
     7                 4HSSG1,4H    , 4HSSG1,4H    , 16    ,
     8                 4HSSG2,4H    , 4HSSG2,4H    , 16    ,
     9                 4HSSG3,4H    , 4HSSG3,4H    , 16    ,
     O                 4HSSG4,4H    , 4HSSG4,4H    , 16    ,
     1                 4HSSGH,4HT   , 4HSSGH,4HT   , 16    ,
     2                 4HTA1 ,4H    , 4HTA1 ,4H    , 2     ,
     3                 4HCURV,4H    , 4HCURV,4H    , 4096  ,
     4                 4HTABP,4HCH  , 4HTABP,4HCH  , 32766 ,
     5                 4HTABP,4HRT  , 4HTABF,4HMT  , 32766 ,
     6                 4HTABP,4HT   , 4HTABP,4HT   , 32766 ,
     7                 4HTIME,4HTEST, 4HTIMT,4HST  , 256   /
      DATA    LINK08 / 4HTRD ,4H    , 4HTRD ,4H    , 1024  ,
     1                 4HTRHT,4H    , 4HTRHT,4H    , 1024  ,
     2                 4HTRLG,4H    , 4HTRLG,4H    , 16    ,
     3                 4HTRNS,4HP   , 4HDTRA,4HNP  , 64    ,
     4                 4HUMER,4HGE  , 4HDUME,4HRG  , 64    ,
     5                 4HUPAR,4HTN  , 4HDUPA,4HRT  , 64    ,
     6                 4HVDR ,4H    , 4HVDR ,4H    , 2048  ,
     7                 4HVEC ,4H    , 4HVEC ,4H    , 64    ,
     8                 4HXYPL,4HOT  , 4HXYPL,4HOT  , 2     ,
     9                 4HXYPR,4HNPLT, 4HXYPR,4HPT  , 8192  ,
     O                 4HXYTR,4HAN  , 4HXYTR,4HAN  , 2     ,
     1                 4HCOMB,4H1   , 4HCOMB,4H1   , 16384 ,
     2                 4HCOMB,4H2   , 4HCOMB,4H2   , 16384 ,
     3                 4HEXIO,4H    , 4HEXIO,4H    , 16384 ,
     4                 4HRCOV,4HR   , 4HRCOV,4HR   , 16384 ,
     5                 4HRCOV,4HR3  , 4HRCOV,4HR3  , 16384 ,
     6                 4HREDU,4HCE  , 4HREDU,4HCE  , 16384 ,
     7                 4HSGEN,4H    , 4HSGEN,4H    , 16384 /
      DATA    LINK09 / 4HSOFI,4H    , 4HSOFI,4H    , 16384 ,
     1                 4HSOFO,4H    , 4HSOFO,4H    , 16384 ,
     2                 4HSOFU,4HT   , 4HSOFU,4HT   , 16384 ,
     3                 4HSUBP,4HH1  , 4HSUBP,4HH1  , 16384 ,
     4                 4HPLTM,4HRG  , 4HPLTM,4HRG  , 16384 ,
     5                 4HCOPY,4H    , 4HCOPY,4H    , 64    ,
     6                 4HSWIT,4HCH  , 4HSWIT,4HCH  , 64    ,
     7                 4HMPY3,4H    , 4HMPY3,4H    , 64    ,
     8                 4HSDCM,4HPS  , 4HDDCM,4HPS  , 64    ,
     9                 4HLODA,4HPP  , 4HLODA,4HPP  , 16384 ,
     O                 4HGPST,4HGEN , 4HGPST,4HGN  , 8     ,
     1                 4HEQMC,4HK   , 4HEQMC,4HK   , 2048  ,
     2                 4HADR ,4H    , 4HADR ,4H    , 512   ,
     3                 4HFRRD,4H2   , 4HFRRD,4H2   , 512   ,
     4                 4HGUST,4H    , 4HGUST,4H    , 512   ,
     5                 4HIFT ,4H    , 4HIFT ,4H    , 512   ,
     6                 4HLAMX,4H    , 4HLAMX,4H    , 256   ,
     7                 4HEMA ,4H    , 4HEMA ,4H    , 128   /
      DATA    LINK10 / 4HANIS,4HOP  , 4HANIS,4HOP  , 2     ,
     1                 4HEMFL,4HD   , 4HEMFL,4HD   , 4096  ,
     2                 4HGENC,4HOS  , 4HGENC,4HOS  , 4096  ,
     3                 4HDDAM,4HAT  , 4HDDAM,4HAT  , 4096  ,
     4                 4HDDAM,4HPG  , 4HDDAM,4HPG  , 4096  ,
     5                 4HNRLS,4HUM  , 4HNRLS,4HUM  , 4096  ,
     6                 4HGENP,4HART , 4HGENP,4HAR  , 4096  ,
     7                 4HCASE,4HGEN , 4HCASE,4HGE  , 4096  ,
     8                 4HDESV,4HEL  , 4HDESV,4HEL  , 4096  ,
     9                 4HPROL,4HATE , 4HPROL,4HAT  , 4096  ,
     O                 4HMAGB,4HDY  , 4HMAGB,4HDY  , 16    ,
     1                 4HCOMB,4HUGV , 4HCOMU,4HGV  , 4096  ,
     2                 4HFLBM,4HG   , 4HFLBM,4HG   , 8     ,
     3                 4HGFSM,4HA   , 4HGFSM,4HA   , 8     ,
     4                 4HTRAI,4HLER , 4HTRAI,4HL   , 8     ,
     5                 4HSCAN,4H    , 4HSCAN,4H    , 8192  ,
     6                 4HPLTH,4HBDY , 4HPTHB,4HDY  , 2     ,
     7                 4HVARI,4HAN  , 4HVARI,4HAN  , 8192  /
      DATA    LINK11 / 4HFVRS,4HTR1 , 4HFVRS,4HT1  , 64    ,
     1                 4HFVRS,4HTR2 , 4HFVRS,4HT2  , 64    ,
     2                 4HALG ,4H    , 4HALG ,4H    , 32    ,
     3                 4HAPDB,4H    , 4HAPDB,4H    , 256   ,
     4                 4HPROM,4HPT1 , 4HPROM,4HPT  , 8194  ,
     5                 4HSITE,4HPLOT, 4HOLPL,4HOT  , 2     ,
     6                 4HINPU,4HTT5 , 4HINPT,4HT5  , 2     ,
     7                 4HOUTP,4HUT5 , 4HOUTP,4HT5  , 8192  ,
     8                 4HPARA,4HMD  , 4HQPAR,4HMD  , 32766 ,
     9                 4HGINO,4HFILE, 4HGINO,4HFL  , 32766 ,
     O                 4HDATA,4HBASE, 4HDBAS,4HE   , 8202  ,
     1                 4HNORM,4H    , 4HNORM,4HAL  , 16    ,
     2                 4HVECG,4HRB  , 4HGRBV,4HEC  , 64    ,
     3                 4HAUTO,4HASET, 4HAASE,4HT   , 8     /
C
C     INITIALIZE /XLKSPC/
C
      LLINK = LLINKX
      DO 10 I = 1,LLINK
   10 KLINK(I) = LINK(I)
      RETURN
      END

      SUBROUTINE SCAN        
C        
C     THIS IS THE MAIN DRIVER FOR THE OUTPUT SCAN MODULE - SCAN        
C        
C     THIS SCAN MODULE CAN BE CALLED DIRECTLY FROM ALL RIGID FORMATS, OR
C     BY USER DMAP ALTER. THE CALLING INSTRUCTIONS ARE        
C        
C     (THREE INPUT FILES IF CALLED BY RIGID FORMAT VIA SCAN INPUT CARDS)
C     (1) FORCE AND STRESS SCAN -        
C     SCAN  CASECC,OESI,OEFI/OESFI/*RF*  $    (WHERE I=1, OR 2)        
C           OR        
C     SCAN  CASECC,OESI,OEFI/OESFI/*OLI* $    FOR ON-LINE SCAN        
C        
C         . IF INPUT FILES ARE OES1, OEF1, SORT1 TYPE DATA ARE SCANNED  
C         . IF INPUT FILES ARE OES2, OEF2, SORT2 TYPE DATA ARE SCANNED  
C        
C     (ONE INPUT FILE ONLY IF CALLED BY USER VIA DMAP ALTER)        
C     (2) STRESS SCAN -        
C     SCAN, ,OESI, /OESFI/C,N,ELEMENT/C,N,ICOMP/C,N,NTOP/C,N,AMAX/      
C           C,N,AMIN/C,N,IBEG/C,N,IEND/C,N,ICOMPX $        
C     OR (3) FORCE SCAN -        
C     SCAN, ,,OEFI /OESFI/C,N,ELEMENT/C,N,ICOMP/C,N,NTOP/C,N,AMAX/      
C           C,N,AMIN/C,N,IBEG/C,N,IEND/C,N,ICOMPX $        
C        
C         . FOR SORT1 TYPE DATA, OESI AND OEFI ARE OES1 AND OEF1, AND   
C           IBEG AND IEND ARE RANGE OF ELEMENT IDS TO BE SCANNED        
C         . FOR SORT2 TYPE DATA, OESI AND OEFI ARE OES2 AND OEF2, AND   
C           IBEG AND IEND ARE RANGE OF SUBCASE IDS TO BE SCANNED        
C         . IF IBEG AND IEND ARE NOT GIVEN, ALL IDS IMPLY        
C        
C         . OESB1, OESC1, OEFB1, AND OEFC1 CAN BE USED IN LIEU OF OES1  
C           AND OEF1. SIMILARLY, OESC2 AND OEFC2  FOR OES2 AND OEF2     
C        
C     INPUT  FILES  - CASECC, OES1, OEF1, (OR OES2, OEF2)        
C                     (OESB1, OESC1, OEFB1, OEFC1, OESB2, OEFB2 CAN BE  
C                     USED INSTEAD)        
C     OUTPUT FILE   - OESF1 (OR OESF2)        
C     SCRATCH FILE  - SCR1        
C        
C     THIS SCAN MODULE SHOULD BE FOLLOWED BY OFP TO PRINT SCAN RESULTS  
C     OFP  OESFI,,,,, //S,N,CARDNO $        
C        
C     PARAMETERS -        
C        
C           ELEMENT - ELEMENT NAME IN BCD.  E.G. BAR, CBAR, QUAD2, ETC. 
C           ICOMP   - THE OUTPUT FIELD NO. (BY COLUMN, 1 THRU 31) OF    
C                     OUTPUT LISTING.        
C           ICOMPX  - OUTPUT FIELD NO. CONTINUATION (FROM 32 THRU 62)   
C           NTOP    - TOP N VALUES TO BE OUTPUT.  DEFAULT=20        
C      AMAX-AMIN    - SCAN VALUES OUTSIDE THIS MAX-MIN RANGE, DEFAULT=0.
C      IBEG,IEND    - SEE EXPLANATION ABOVE        
C        
C     DEFINITION OF SOME LOCAL VARIABLES        
C        
C           DEBUG   - USED FOR LOCAL DEBUG        
C           S OR F  - STRESS OR FORCE SCAN FLAG        
C           NSCAN   - NO. OF SCAN INPUT CARDS IN CASECC        
C           SUBC    - CURRENT SUBCASE ID        
C           NZ      - TOP OF OPEN CORE, JUST BELOW GINO BUFFERS        
C           LCORE   - AVAILABLE CORE FOR STRSCN ROUTINE        
C           IOPEN   - INPUT  FILE STATUS FLAG, .T. FOR OPEN, .F. NOT    
C           JOPEN   - OUTPUT FILE STATUS FLAG, .T. FOR OPEN, .F. NOT    
C           KOPEN   - SCR1   FILE STATUS FLAG, .T. FOR OPEN, .F. NOT    
C           LOPEN   - CASECC FILE STATUS FLAG, .T. FOR OPEN, .F. NOT    
C           ISET    - SCAN ONLY BY THE SPECIFIED SET OF ELEM. IDS       
C                   - ALL IS IMPLIED IF ISET IS NOT GIVEN        
C                   - USED ONLY IF SCAN IS CALLED FROM RIGID FORMAT     
C      IDUPL,INC    - SET UP COMPONENT FIELDS TO BE REPEATEDLY SCANNED  
C                     IDUPL TIMES, WITH FIELD INCREMENT BY INC (RF ONLY)
C      LBEG,LEND    - A LIST OF TO-BE-SCANNED ELEMENT IDS, STORED IN    
C                     Z(LBEG) THRU Z(LEND).        
C                   - NO SUCH LIST EXISTS IF LBEG.GT.LEND OR LBEG=LEND=0
C           IOPT    - DATA SCAN BY AMAX AND AMIN IF IOPT=1, BY NTOP IF 2
C           ISORT   - SET TO 1 (BY STRSCN) IF DATA TYPE IS IN SORT1     
C                     FORMAT, AND SET TO 2 IF SORT2        
C        
C     WRITTEN BY G.CHAN/SPERRY      OCTOBER 1984        
C        
C     THIS ROUTINE OPENS AND CLOSES ALL INPUT AND OUTPUT FILES.        
C     IT SETS UP THE SCANNING PARAMETERS AND CALL STRSCN TO SCAN THE    
C     OUTPUT STRESS OR FORCE DATA        
C        
C     THE SCAN INPUT CARDS OPERATE VERY SIMILARY TO THE ELEMENT STRESS  
C     OR FORCE CARDS. THEY CAN BE PLACED ABOVE ALL SUBCASES, OR INSIDE  
C     ANY SUBCASE LEVEL, OR BOTH        
C     HOWEVER, UNLIKE THE STRESS OR FORCE CARDS, MULTI-SCAN CARDS ARE   
C     ALLOWED, AND THEY DO NOT EXCLUDE ONE ANOTHER.        
C        
C     MODIFIED IN 10/1989, TO ALLOW SETS TO BE DEFINED BEFORE OR AFTER  
C     SCAN CARDS IN CASE CONTROL SECTION        
C     (CURRENTLY, THIS MODIFICATION IS OK, BUT IFP1/IFP1H DO NOT ALLOW  
C     SET TO BE DEFINED AFTER SCAN. IN FACT, IFP1 DOES NOT ALLOW SET TO 
C     BE DEFINED AFTER ANY GUY WHO USES THE SET)        
C        
      LOGICAL         DEBUG,    IOPEN,    JOPEN,    KOPEN,    LOPEN     
CWKBI  1/4/94 SPR93010 & 93011
      LOGICAL         STRESS,   FORCE,    LAYERD
CWKBI  1/4/94 SPR93010 & 93011
      INTEGER         QUAD4,    TRIA3
CRLBR 12/29/93 SPR 93010 & 93011
C     INTEGER         CASECC,   OESI,     OEFI,     OESFI,    SCR1,     
      INTEGER         CASECC,   OESI(2),  OEFI(2),  OESFI(2), SCR1,     
     1                OUFILE,   FILE,     SORF,     Z(166),   NAM(2),   
     2                E,        EOR,      SUBC,     OSUBC,    OEL       
CRLBNB 12/29/93 SPR 93010 & 93011
      INTEGER         JELT(2)
CRLBNE 12/29/93 SPR 93010 & 93011
     
      CHARACTER       UFM*23,   UWM*25,   UIM*29,   SFM*25,   SWM*27    
      COMMON /XMSSG / UFM,      UWM,      UIM,      SFM,      SWM       
      COMMON /BLANK / IELT(2),  ICOMP,    NTOP,     AMAX,     AMIN,     
     1                IBEG,     IEND,     ICOMPX        
      COMMON /SYSTEM/ IBUF,     NOUT,     SKP(83),  INTRA        
      COMMON /NAMES / RD,       RDREW,    WRT,      WRTREW,   REW,      
     1                NOREW,    EOFNRW        
      COMMON /GPTA1 / NELEM,    LAST,     INCR,     E(1)        
      COMMON /XSCANX/ INFILE,   OUFILE,   LCORE,    LBEG,     LEND,     
     1                IOPEN,    JOPEN,    IEL,      IOPT,     ISET,     
     2                ISORT,    ITRL3,    SUBC,     OSUBC,    OEL,      
CWKBR 1/4/94 SPR93010 & 93011     3                DEBUG          
     3                DEBUG,    LLOOP,    QUAD4,    TRIA3,    STRESS,
     4                FORCE,    LAYERD
      COMMON /ZZZZZZ/ CORE(1)        
      EQUIVALENCE     (IMAX,AMAX),        (IMIN,AMIN),        
     1                (IDUPL,IBEG),       (INC,IEND),        
     2                (CORE(1),Z(1))        
CRLBDB 12/29/93 SPR 93010 & 93011
C     DATA            CASECC,   OESI,     OEFI,     OESFI,    SCR1    / 
C    1                101,      102,      103,      201,      301     / 
CRLBDE 12/29/93 SPR 93010 & 93011
CRLBNB 12/29/93 SPR 93010 & 93011
      DATA            CASECC,   OESI(1),  OEFI(1),  OESI(2),  OEFI(2),   
     1                OESFI(1), OESFI(2), SCR1    / 
     2                101,      102,      103,      104,      105,
     3                201,      202,      301     / 
CRLBNE 12/29/93 SPR 93010 & 93011
      DATA            NAM,                LLC,      EOR,      IRF     / 
     1                4HSCAN,   4H    ,   4HC   ,   1,        4HRF    / 
      DATA            IOL1,     IOL2      /        
     1                4HOL1 ,   4HOL2     /        
C        
      DEBUG = .FALSE.        
CWKBNB 1/4/94 SPR93011 & 93010
      QUAD4 = 0
      TRIA3 = 0
C        
C     ALLOCATE OPEN CORE        
C        
CRLBNB 12/29/93 SPR 93010 & 93011
      LLOOP = 1
      JELT(1) = IELT(1)
      JELT(2) = IELT(2)
  10  CONTINUE
CRLBNB 12/29/93 SPR 93010 & 93011
      NZ    = KORSZ(Z)        
      IBUF1 = NZ - IBUF + 1        
      IBUF2 = IBUF1 - IBUF        
      IBUF3 = IBUF2 - IBUF        
      NZ    = IBUF3 - 1        
      LCORE = IBUF2 - 1        
      IOPEN =.FALSE.        
      JOPEN =.FALSE.        
      KOPEN =.FALSE.        
      LOPEN =.FALSE.        
C        
C     OPEN CASECC AND CHECK SCAN DATA        
C        
      ISET = 0        
      IF (IELT(1) .NE. IRF) ISET = -2        
      IF (IELT(1).EQ.IOL1 .OR. IELT(1).EQ.IOL2) ISET = -3        
      IF (ISET .EQ. -2) GO TO 40        
      FILE = CASECC        
      CALL OPEN (*310,CASECC,Z(IBUF1),RDREW)        
      LOPEN = .TRUE.        
      CALL FWDREC (*320,CASECC)        
      IF (ISET .EQ. -3) GO TO 40        
 30   CALL READ (*80,*80,CASECC,Z(1),200,1,L)        
      LENCC = Z(166)        
      NSCAN = Z(LENCC-1)        
      IF (NSCAN .EQ. 0) GO TO 30        
C        
C     CHECK THE PRESENCE OF STRESS AND/OR FORCE FILE.        
C     QUIT IF BOTH ARE PURGED        
C        
 40   IOES  = 1        
      IOEF  = 1        
CRLBDB 12/29/93 SPR 93010 & 93011
C     Z( 1) = OESI        
C     Z(11) = OEFI        
CRLBDE 12/29/93 SPR 93010 & 93011
CRLBNB 12/29/93 SPR 93010 & 93011
      Z( 1) = OESI(LLOOP)        
      Z(11) = OEFI(LLOOP)        
CRLBNE 12/29/93 SPR 93010 & 93011
      CALL RDTRL (Z( 1))        
      CALL RDTRL (Z(11))        
      IF (Z( 1) .LT. 0) IOES = 0        
      IF (Z(11) .LT. 0) IOEF = 0        
      IF (IOES+IOEF.EQ.0 .AND. ISET.NE.-3) GO TO 300        
C        
C     OPEN OUTPUT FILE OESFI        
C        
CRLBDB 12/29/93 SPR 93010 & 93011
C     FILE = OESFI        
C     OUFILE = OESFI        
C     CALL FNAME (OESFI,Z)        
C     CALL OPEN  (*310,OESFI,Z(IBUF2),WRTREW)        
C     CALL WRITE (OESFI,Z,2,EOR)        
CRLBDE 12/29/93 SPR 93010 & 93011
CRLBNB 12/29/93 SPR 93010 & 93011
      FILE = OESFI(LLOOP) 
      OUFILE = OESFI(LLOOP) 
      CALL FNAME (OUFILE,Z)        
      CALL OPEN  (*310,OUFILE,Z(IBUF2),WRTREW)        
      CALL WRITE (OUFILE,Z,2,EOR)        
CRLBNE 12/29/93 SPR 93010 & 93011
      JOPEN  =.TRUE.        
      ITRL3  = 0        
      LX     =-1        
      IF (IELT(1) .EQ. IOL2) LX = -2        
      IF (ISET .EQ. -3) CALL ONLINS (*280,LX)        
      IF (ISET .NE. -2) GO TO 90        
C        
C     SCAN CALLED BY USER VIA DMAP ALTER (ISET=-2)        
C     ============================================        
C        
      LS   = LCORE        
      LBEG = 0        
      LEND = 0        
C        
C     CHECK USER DMAP ERROR, SET IOPT FLAG, AND INITIALIZE ISCAN ARRAY  
C     FOR COMPONENT SPECIFIED.        
C        
      IF (IOES+IOEF .GT. 1) GO TO 400        
      IF (AMIN  .GT.  AMAX) GO TO 410        
      IF (ICOMP .LE.     1) GO TO 420        
      IF ((AMAX.EQ.0. .AND. AMIN.EQ.0.) .AND. NTOP.EQ.0) GO TO 430      
      IF ((AMAX.NE.0. .OR.  AMIN.NE.0.) .AND. NTOP.NE.0) GO TO 440      
      IF ((IBEG.EQ.0 .AND. IEND.NE.0) .OR. IBEG.GT.IEND .OR.        
     1    (IBEG.NE.0 .AND. IEND.EQ.0)) GO TO 460        
      IF ( IBEG.EQ.0 .AND. IEND.EQ.0 ) IBEG = -1        
      IOPT = 1        
      IF (NTOP .GT. 0) IOPT = 2        
C        
C     DETERMINE ELEMENT TYPE, DROP THE FIRST LETTER C IF NECESSARY      
C        
      Z(1) = IRF        
      Z(2) = IRF        
      IF (KHRFN2(IELT(1),1,1) .NE. LLC) GO TO 50        
      Z(1) = KHRFN3(NAM(2),IELT(1),1,1)        
      Z(1) = KHRFN1(Z(1),4,IELT(2),1  )        
      Z(2) = KHRFN3(NAM(2),IELT(2),1,1)        
 50   DO 60 I = 1,LAST,INCR        
      IF (IELT(1).EQ.E(I) .AND. IELT(2).EQ.E(I+1)) GO TO 70        
      IF (   Z(1).EQ.E(I) .AND.    Z(2).EQ.E(I+1)) GO TO 70        
 60   CONTINUE        
      GO TO 450        
 70   IEL = E(I+2)        
C        
C     SPECIAL HANDLING OF THE QUAD4 AND TRIA3 ELEMENT, STRESS ONLY      
C     (THE 2ND, 3RD, 9TH, AND 13TH WORDS IN OES1/OES1L FILES ARE        
C     NOT PRINTED. THE 9TH AND 13TH WORDS MAY BE BLANKS OR ASTERISKS)   
C        
      IF ((IEL.NE.64 .AND. IEL.NE.83) .OR. IOES.EQ.0) GO TO 75        
CWKBD 1/3/94 SPR93011 & 93011      ICOMP = ICOMP + 2       
CWKBD 1/3/94 SPR93010 & 93011      IF (ICOMP .GT. 8) ICOMP = ICOMP + 1        
C        
C     OPEN INPUT FILE        
C        
CRLBDB 12/29/93 SPR 93010 & 93011
C75   INFILE = OESI        
C     IF (IOES .EQ. 0) INFILE = OEFI        
CRLBDE 12/29/93 SPR 93010 & 93011
CRLBNB 12/29/93 SPR 93010 & 93011
 75   INFILE = OESI(LLOOP)        
      STRESS = .TRUE.
      FORCE  = .FALSE.
      IF (IOES .NE. 0) GO TO 76
      STRESS = .FALSE.
      FORCE  = .TRUE.
      INFILE = OEFI(LLOOP)        
CRLBNE 12/29/93 SPR 93010 & 93011
 76   FILE = INFILE        
      CALL OPEN (*340,INFILE,Z(IBUF1),RDREW)        
      IOPEN = .TRUE.        
C        
C ... NEXT I/O OPERATION ON INFILE WILL BE IN SUBROUTINE STRSCN        
C        
C     ALL SET TO GO        
C        
      J = 1        
      IF (IOES .EQ. 0) J = 2        
      CALL STRSCN (J)        
      GO TO 280        
C        
 80   CALL CLOSE (CASECC,REW)        
      LOPEN = .FALSE.        
      RETURN        
C        
C        
C     SCAN IS CALLED BY RIGID FORMAT (ISET .GE. -1)        
C     OR CALLED BY INTERACTIVE MODE  (ISET .EQ. -3)        
C     =============================================        
C        
 90   LS = NZ        
C        
C     OPEN SCR1 FILE, SEPERATE SCAN DATA FROM SET DATA IN CASECC, AND   
C     SAVE THE COMPLETE SCAN DATA IN SCR1 FILE.        
C        
      FILE = SCR1        
      CALL OPEN (*310,SCR1,Z(IBUF3),WRTREW)        
      KOPEN =.TRUE.        
      NSCAN = 0        
      NCASE = 0        
      NXX   = NZ        
      IF (INTRA .LE. 0) GO TO 95        
      NXX = 198        
      L   = LX        
      IF (LX .GT. 0) GO TO 110        
 95   FILE = CASECC        
      CALL REWIND (CASECC)        
      CALL FWDREC (*320,CASECC)        
C        
C     READ CASECC AND PROCESS ALL SUBCASES        
C        
 100  CALL READ (*210,*110,CASECC,Z(1),NXX,1,L)        
      IF (NXX .GE. 200) GO TO 380        
 110  NCASE = NCASE + 1        
      LENCC = Z(166)        
      NSCAN = Z(LENCC-1)        
      LSEM  = Z(LENCC)        
      SUBC  = Z(1)        
C        
C     PICK UP ALL THE SET ID'S AND THEIR LOCATIONS IN Z ARRAY, Z(L1)    
C     THRU Z(LL). SORT, AND CHECK DUPLICATE        
C        
      JMP = 0        
      II  = LENCC + LSEM        
      L1  = L + 1        
      LL  = L        
 115  II  = II + JMP        
      IF (II .GE. L) GO TO 120        
      JMP = Z(II+2) + 2        
      IF (Z(II+1).GE.10000000 .AND. JMP.EQ.8) GO TO 115        
      Z(LL+1) = Z(II+1)        
      Z(LL+2) = II        
      LL = LL + 2        
      GO TO 115        
 120  LLL1 = LL - L1 + 1        
      LL2  = LLL1/2        
      IF (DEBUG) WRITE (NOUT,125) (Z(I),I=L1,LL)        
 125  FORMAT (' ...SET/@125',/,(10X,I8,' @',I6))        
C        
      JMP = 0        
      II  = LENCC + LSEM        
      KK  = NZ        
      IF (LL2 .LE. 1) GO TO 140        
      CALL SORT (0,0,2,1,Z(L1),LLL1)        
      J = L1 + 2        
      DO 130 I = J,LL,2        
      IF (Z(I) .EQ. Z(I-2)) WRITE (NOUT,600) UWM,Z(I)        
 130  CONTINUE        
C        
C     PROCESS THE SCAN CARDS        
C        
C     PICK UP SCAN 8 WORD ARRAY, AND PICK UP SET DATA        
C     WRITE TO SCR1 A RECORD (OF EACH SUBCASE) OF THE SCAN INPUT DATA   
C     IN REVERSE ORDER (FIRST SCAN CARD LAST, AS SET UP BY CASECC)      
C        
 140  II = II + JMP        
      IF (II .GE. L) GO TO 190        
      JMP = Z(II+2) + 2        
      IF (Z(II+1).LT.10000000 .OR. JMP.NE.8) GO TO 140        
      IE  = 0        
      ISET= Z(II+4)        
      IF (ISET .EQ. -1) GO TO 160        
      IF (LLL1 .LE.  0) GO TO 470        
      CALL BISLOC (*470,ISET,Z(L1),2,LL2,I)        
      IB = Z(I+L1) + 2        
      IE = Z(IB)        
      IF (DEBUG) WRITE (NOUT,145) ISET,I,IB,IE        
 145  FORMAT (' @145, SET',I8,' FOUND.  I,IB,IE =',3I6)        
      KK = KK - IE        
      DO 150 I = 1,IE        
 150  Z(KK+I) = Z(IB+I)        
 160  KK = KK - 9        
      DO 170 I = 1,8        
 170  Z(KK+I) = Z(II+I)        
      Z(KK+9) = 0        
      IDUPL   = Z(KK+8)        
      IF (IDUPL .EQ. 0) GO TO 180        
CWKBD 1/3/94 SPR93010 & 93011      INC = IDUPL/100        
CWKBD 1/3/94 SPR93010 & 93011      Z(KK+8) = MOD(IDUPL,100)        
CWKBNB 1/3/94 SPR93010 & 93011
      INC = MOD ( IDUPL, 100 )
      Z(KK+8) = IDUPL / 100
CWKBNE 1/3/94 SPR93010 & 93011
      Z(KK+9) = INC        
 180  Z(KK+2) = Z(KK+2) + 1 + IE        
C        
C     HERE AT THE TAIL END OF OPEN CORE, WE ACCUMULATE ANOTHER RECORD   
C     OF A SCAN DATA SET        
C        WORD 1,  10000000 FOR STRESS, OR 20000000 FOR FORCE        
C             2,  NO. OF WORDS OF THIS DATA SET (SCAN + SET)        
C                 (FIRST 2 WORDS NOT INCLUDED)        
C             3,  ELEMENT TYPE NUMERIC CODE        
C             4,  SET-ID, OR -1        
C             5,  COMPONENT CODE, ICOMP        
C             6,  NTOP, OR AMAX        
C             7,  -1,   OR AMIN        
C             8,  COMPONENT - DUPLICATION, OR ZERO        
C             9,  COMPONENT - INCREMENT,   OR ZERO        
C        10-END,  SET DATA        
C     REPEAT FOR ANOTHER SCAN CARD        
C        
C        
C     SPECIAL HANDLING OF THE QUAD4 AND TRIA3 ELEMENT, STRESS ONLY      
C     (THE 2ND, 3RD, 9TH,  AND 13TH WORDS IN OES1/OES1L FILES ARE       
C     NOT PRINTED. THE 9TH AND 13TH WORDS MAY BE BLANKS OR ASTERISKS)
CWKBI 12/93 SPR93010 & 93011
C     ABOVE IS TRUE ONLY FOR LAMINATED QUAD4 AND TRIA3)   
C        
CWKBD 12/31/93 SPR93010 & 93011     
C     IF ((Z(KK+3).NE.64 .AND. Z(KK+3).NE.83) .OR. Z(KK+1).NE.10000000) 
      IF ((Z(KK+3).NE.64 .AND. Z(KK+3).NE.83) .OR. Z(KK+8).EQ.0) 
     1    GO TO 140        
CWKBDB 1/3/94 SPR93010 & 93011
C      Z(KK+5) = Z(KK+5) + 2        
C      IF (Z(KK+5) .GT. 8) Z(KK+5) = Z(KK+5) + 1        
C      IF (Z(KK+9) .NE. 0) Z(KK+9) = Z(KK+9) + 2        
CWKBDE 1/3/94 SPR93010 & 93011
      GO TO 140        
C        
C     AT THE END OF EACH SUBCASE, WE COMPUTE THE TOTAL LENGTH OF THIS   
C     SCAN DATA ARRAY, AND WRITE THE ARRAY OUT TO SCR1.  ONE RECORD PER 
C     SUBCASE        
C        
 190  KK = KK - 2        
      IF (KK .LT. LL) GO TO 610        
      IE = NZ - KK        
      Z(KK+1) = SUBC        
      Z(KK+2) = IE - 2        
      CALL WRITE (SCR1,Z(KK+1),IE,1)        
      L  = KK + 1        
      NN = 200        
      IF (DEBUG) WRITE (NOUT,200) NN,(Z(J),J=L,NZ)        
 200  FORMAT (/,11H SCAN/DEBUG,I3,  (/2X,13I9))        
      IF (INTRA.LE.0 .OR. LX.LT.200) GO TO 100        
C        
C     THUS, END OF THE PREPARATION PHASE.  CLOSE CASECC AND SCR1        
C        
 210  CALL CLOSE (CASECC,REW)        
      CALL CLOSE (SCR1  ,REW)        
      KOPEN =.FALSE.        
      LOPEN =.FALSE.        
C        
C     NOW, SET UP 2 LOOPS FOR STRESS (10000000) AND FORCE (20000000)    
C     OUTPUT SCAN        
C        
      SORF = 30000000        
 220  SORF = SORF - 10000000        
      IF (DEBUG) WRITE (NOUT,225) SORF        
 225  FORMAT (///,18H PROCESSING SERIES,I15 /1X,8(4H====),/)        
      IF (IOPEN) CALL CLOSE (INFILE,REW)        
      IOPEN = .FALSE.        
      IF (SORF.EQ.10000000 .AND. IOES.EQ.0) GO TO 220        
      IF (SORF.EQ.20000000 .AND. IOEF.EQ.0) GO TO 220        
      IF (SORF .LE. 0) GO TO 280        
C        
C     OPEN INPUT FILES        
C        
CRLBDB 12/29/93 SPR 93010 & 93011
C     INFILE = OESI        
C     IF (SORF .GE. 20000000) INFILE=OEFI        
CRLBDE 12/29/93 SPR 93010 & 93011
CRLBNB 12/29/93 SPR 93010 & 93011
      INFILE = OESI(LLOOP)        
      STRESS = .TRUE.
      FORCE  = .FALSE.
      IF (SORF .LT. 20000000) GO TO 226
      STRESS = .FALSE.
      FORCE  = .TRUE.
      INFILE=OEFI(LLOOP)        
CRLBNE 12/29/93 SPR 93010 & 93011
226   FILE = INFILE        
      CALL OPEN (*310,INFILE,Z(IBUF1),RDREW)        
      IOPEN = .TRUE.        
C ... NEXT I/O OPERATION ON INFILE WILL BE IN SUBROUTINE STRSCN        
C        
C     NOW, LOAD THE SCAN DATA PREVIOUSLY SAVED IN SCR1, TO THE TAIL END 
C     OF THE OPEN CORE.        
C     ONE OR MORE SCAN CARDS MAY BE PRESENT IN  ONE SUBCASE        
C     SET UP POINTERS IN FRONT OF THE SCAN DATA, SO THAT FIRST SCAN     
C     INPUT CARD WILL BE PROCESS FIRST, SECOND CARD SECOND, ETC.        
C     NOTE - USE SUBCASE 1 SCAN DATA IF OUTPUT IS SORT 2 TYPE        
C            (IF SUBCASE 1 DOES NOT HAVE SCAN DATA, USE NEXT SUBCASE)   
C        
      FILE = SCR1        
      IF (.NOT.KOPEN) CALL OPEN (*310,SCR1,Z(IBUF3),RDREW)        
      IF (     KOPEN) CALL REWIND (SCR1)        
      KOPEN =.TRUE.        
      ISORT = 0        
      OSUBC = 0        
      OEL   = 0        
C        
      DO 270 II = 1,NCASE        
      IF (ISORT .EQ. 2) GO TO 220        
      CALL READ (*320,*330,SCR1,Z(1),2,0,L)        
      J = Z(2)        
      IF (J .EQ. 0) GO TO 260        
      SUBC = Z(1)        
      LS   = NZ - J        
      CALL READ (*320,*330,SCR1,Z(LS+1),J,1,L)        
      LE = LS        
      I  = LS        
 230  Z(LS) = I        
      LS = LS - 1        
      I  = I + Z(I+2) + 2        
      IF (I .LT. NZ) GO TO 230        
      LCORE = LS        
      J  = LS + 1        
      KK = 230        
      IF (DEBUG) WRITE (NOUT,200) KK,SUBC,(Z(I),I=J,NZ)        
C        
C     NOW IS THE TIME TO SET THE SCAN PARAMETERS FOR EACH SCAN CARD     
C     WITHIN A SUBCASE, AND CALL STRSCN TO SCAN THE OUTPUT DATA        
C        
      I = LS        
 240  I = I + 1        
      IF (I .GT. LE) GO TO 270        
      IB = Z(I)        
      IF (Z(IB+1) .NE. SORF) GO TO 240        
      JMP   = Z(IB+2)        
      IEL   = Z(IB+3)        
C ONLY QUAD4 (=64) AND TRIA3 (=83) ARE VALID FOR LLOOP=2
      IF ( LLOOP .EQ. 2 .AND. IEL .NE. 64 .AND. IEL .NE. 83 )
     &     GO TO 240
      ISET  = Z(IB+4)        
      ICOMP = Z(IB+5)        
      NTOP  = Z(IB+6)        
      IMAX  = Z(IB+6)        
      IMIN  = Z(IB+7)        
      IDUPL = Z(IB+8)        
      INC   = Z(IB+9)        
      IOPT  = 1        
      IF (IMIN .EQ. -1) IOPT = 2        
      IF (IOPT .NE.  2) NTOP = 0        
      LBEG = LCORE        
      LEND = LCORE - 1        
      IF (ISET .EQ. -1) GO TO 250        
      LBEG = IB + 10        
      LEND = IB + JMP + 2        
 250  J    = (IEL-1)*INCR        
      IELT(1) = E(J+1)        
      IELT(2) = E(J+2)        
      IF (DEBUG) WRITE (NOUT,255) IELT,(Z(IB+J),J=3,9),IOPT,LBEG,LEND,  
     1           II,SUBC        
 255  FORMAT (/5X,16HDEBUG/SCAN255 - ,2A4,/5X,12I9)        
      CALL STRSCN (SORF/10000000)        
      IF (IOPT .LT. 0) GO TO 480        
      GO TO 240        
 260  CALL FWDREC (*320,SCR1)        
 270  CONTINUE        
C        
C     GO BACK TO PROCESS NEXT INPUT FILE        
C        
      GO TO 220        
C        
C     ALL SCAN DONE.  WRITE OUTPUT FILE TRAILERS AND CLOSE ALL FILES    
C        
 280  IF (ITRL3 .LE. 0) GO TO 300        
CRLBR 12/29/93 SPR 93010 & 93011
C     Z(1) = OESFI        
      Z(1) = OESFI(LLOOP)        
      Z(2) = 1        
      Z(3) = ITRL3        
      DO 290 I = 4,7        
 290  Z(I) = 0        
      CALL WRTTRL (Z(1))        
C        
 300  IF (IOPEN) CALL CLOSE (INFILE,REW)        
      IF (JOPEN) CALL CLOSE (OUFILE,REW)        
      IF (KOPEN) CALL CLOSE (SCR1  ,REW)        
      IF (LOPEN) CALL CLOSE (CASECC,REW)        
CRLBNE 12/29/93 SPR 93010 & 93011
      IF (LLOOP .EQ. 2) GO TO 305
      LLOOP = 2
      IELT(1) = JELT(1)
      IELT(2) = JELT(2)
      GO TO 10
 305  CONTINUE
      IF ( QUAD4 .EQ. -1 ) WRITE ( NOUT, 605 ) 'QUAD4'
      IF ( TRIA3 .EQ. -1 ) WRITE ( NOUT, 605 ) 'TRIA3'
 605  FORMAT(//' SCAN MODULE DID NOT FIND ELEMENT ',A5,
     &       ' IN USER OUTPUT REQUESTS.',/
     &      ,' POSSIBLY WRONG COMPONENT SPECIFIED FOR LAYERED OR '
     &      ,'NON-LAYERED CASE',//)
CRLBNE 12/29/93 SPR 93010 & 93011
      RETURN        
C        
C     FILE ERRORS        
C        
 310  J = -1        
      GO TO 350        
 320  J = -2        
      GO TO 350        
 330  J = -3        
      GO TO 350        
 340  CONTINUE        
      GO TO 70        
 350  CALL MESAGE (J,FILE,NAM)        
 380  J = -8        
      GO TO 350        
C        
C     ERROR MESSAGES        
C        
 400  WRITE (NOUT,500)        
      GO TO 490        
 410  WRITE (NOUT,510)        
      GO TO 490        
 420  WRITE (NOUT,520)        
      GO TO 490        
 430  WRITE (NOUT,530)        
      GO TO 490        
 440  WRITE (NOUT,540)        
      GO TO 490        
 450  WRITE (NOUT,550) IELT        
      GO TO 490        
 460  WRITE (NOUT,560) SFM,IELT,IBEG,IEND        
      GO TO 490        
 470  WRITE (NOUT,570) UWM,ISET        
      GO TO 140        
 480  WRITE (NOUT,580) IOPT        
 490  WRITE (NOUT,590) SWM        
      GO TO 280        
C        
 500  FORMAT (//5X,48HONLY ONE INPUT FILE ALLOWED FROM SCAN DMAP ALTER) 
 510  FORMAT (//5X,21HAMAX-AMIN RANGE ERROR)        
 520  FORMAT (//5X,35HFIELD COMPONENT SPECIFICATION ERROR)        
 530  FORMAT (//5X,30HNO AMAX-AMIN OR NTOP SPECIFIED)        
 540  FORMAT (//5X,46HSPECIFY EITHER AMAX-AMIN OR NTOP, BUT NOT BOTH,   
     1         /5X,21H(NTOP=20  BY DEFAULT))        
 550  FORMAT (//5X,22HELEMENT MIS-SPELLED - ,2A4)        
 560  FORMAT (A25,' - SCANNING ',2A4,' ELEMENT. IBEG-IEND OUT OF RANGE',
     1       '.  SCAN ABORTED')        
 570  FORMAT (A25,' FROM SCAN, SET',I9,' NOT FOUND')        
 580  FORMAT (//5X,44HUSER ERROR.  ILLEGAL INPUT FILE SENT TO SCAN,I6)  
 590  FORMAT (A27,' FROM SCAN.  CASE ABORTED ***')        
 600  FORMAT (A25,' FROM SCAN, DUPLICATE SET',I9)        
C        
 610  CALL MESAGE (8,0,NAM)        
      RETURN        
      END        

      SUBROUTINE AMG
C
C     THIS IS THE MAIN DRIVER FOR AEROELASTIC MATRIX GENERATION
C
C     NOTES ON NEW METHOD IMPLIMENTATION
C     1. ACPT FILE WILL BE POSITIONED READY TO READ AN INPUT RECORD
C        LEAVE FILE READY TO READ NEXT RECORD.
C
C     2. ALWAYS PACK OUT A COLUMN (REALY A ROW) OF NJ LENGTH
C        OUTPUT FILE, PACKX, AND TRAILER(MCB) WILL BE SET UP
C
C     3. YOUR ROW POSITION WILL START AT NROW + 1
C
C     4. ALWAYS BUMP NROW BY THE NUMBER OF ROWS WHICH EXIST IN
C        YOUR INPUT RECORD
C
C     5. COMPUTATIONS FOR AJJK MATRIX WILL HAVE 3 BUFFERS OF CORE USED
C        COMPUTATIONS FOR OTHER MATRICES WILL HAVE 4 BUFFERS USED
C
      LOGICAL         DEBUG
      INTEGER         SYSBUF,BUF1,BUF2,BUF3,AERO,ACPT,AJJL,SKJ,W1JK,
     1                W2JK,TSKJ,TW1JK,TW2JK
      DIMENSION       FMACH(1),ND(1),NAME(2)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG / UFM,UWM,UIM,SFM
      COMMON /BLANK / NK,NJ
      COMMON /AMGMN / MCB(7),NROW,ND,NE,REFC,FMACH,RFK,TSKJ(7),ISK,NSK
      COMMON /AMGP2 / TW1JK(7),TW2JK(7)
      COMMON /SYSTEM/ SYSBUF,IOUT
      COMMON /PACKX / ITI,ITO,II,NN,INCR
      COMMON /AMGBUG/ DEBUG
      COMMON /ZZZZZZ/ IZ(1)
      DATA    NAME  / 4HAMG ,4H      /
      DATA    AERO  / 101/, ACPT /102/, AJJL /201/,
     1        SKJ   / 202/, W1JK /203/, W2JK /204/
C
      DEBUG =.FALSE.
      CALL SSWTCH (20,J)
      IF (J .EQ. 1) DEBUG =.TRUE.
C
C     USE IZ TO COMPUTE BUFFERS
C
      ICORE = KORSZ(IZ)
      IFILE = 4*SYSBUF + 3*NJ
      IF (ICORE .LE. IFILE) GO TO 460
C
C     OPEN INPUT STRUCTURAL DATA
C
      ICORE = ICORE - SYSBUF
      CALL GOPEN (ACPT,IZ(ICORE+1),0)
C
C     OPEN AND SKIP HEADER ON AERO
C
      IFILE = AERO
      BUF1  = ICORE - SYSBUF
      CALL GOPEN (AERO,IZ(BUF1+1),0)
C
C     READ 3 INPUT WORDS INTO COMMON
C
      CALL READ (*450,*450,AERO,ND,3,1,N)
C
C     OPEN OUTPUT FILE FOR AJJL MATRIX, SET UP TRAILER AND WRITE HEADER
C
      BUF2  = BUF1 - SYSBUF
      IFILE = AJJL
      CALL OPEN  (*440,AJJL,IZ(BUF2+1),1)
      CALL FNAME (AJJL,MCB)
      CALL WRITE (AJJL,MCB,2,0)
      CALL WRITE (AJJL,NJ,1,0)
      CALL WRITE (AJJL,NK,1,0)
      BUF3  = BUF2 - SYSBUF
      CALL GOPEN (SKJ,IZ(BUF3+1),1)
      IFILE = AERO
      CALL READ (*440,*10,AERO,IZ,BUF3,0,N)
      GO TO 460
   10 NMK   = N/2
      CALL REWIND (AERO)
      CALL FWDREC (*450,AERO)
      CALL FWDREC (*450,AERO)
      CALL WRITE  (AJJL,NMK,1,0)
      CALL WRITE  (AJJL,IZ,N,0)
      IFILE = ACPT
      IZ(1) = 0
      N1    = 2
   20 CALL READ (*90,*90,ACPT,METHOD,1,0,N)
      IZ( 1) = IZ(1) + 1
      IZ(N1) = METHOD
      GO TO (30,40,50,50,50,60,70), METHOD
C
C     DOUBLET LATTICE METHOD
C
   30 CONTINUE
      CALL READ (*440,*450,ACPT,MCB,3,1,N)
C
C     NUMBER OF COLUMNS ADDED EQUAL NUMBER OF BOXES
C
      IZ(N1+1) = MCB(3)
      IZ(N1+2) = MCB(3)
      GO TO 80
C
C     DOUBLET LATTICE WITH BODIES
C
   40 CALL READ (*440,*450,ACPT,MCB,2,1,N)
      IZ(N1+1) = MCB(1)
      IZ(N1+2) = MCB(2)
      GO TO 80
C
C     MACH BOX  STRIP THEORY  PISTON THEORY
C
   50 CALL READ (*440,*450,ACPT,MCB,1,1,N)
      IZ(N1+1) = MCB(1)
      IZ(N1+2) = MCB(1)
      GO TO 80
C
C     COMPRESSOR BLADE METHOD
C
   60 CALL READ (*440,*450,ACPT,MCB,5,1,N)
C
C     NUMBER OF COLUMNS ADDED IS NJ = NK = (NSTNS*NLINES) FOR THE BLADE
C
      IZ(N1+1) = MCB(4)*MCB(5)
      IZ(N1+2) = IZ(N1+1)
      GO TO 80
C
C     SWEPT TURBOPROP BLADE METHOD
C
   70 CALL READ (*440,*450,ACPT,MCB,5,1,N)
C
C     NUMBER OF COLUMNS ADDED IS NJ = NK = (2*NSTNS*NLINES) FOR THE PROP
C
      IZ(N1+1) = 2*MCB(4)*MCB(5)
      IZ(N1+2) = IZ(N1+1)
   80 N1 = N1 + 3
      GO TO 20
   90 CALL REWIND (ACPT)
      CALL WRITE  (AJJL,IZ,N1-1,1)
      MCB(1)  = AJJL
      MCB(2)  = 0
      MCB(3)  = NJ
      MCB(4)  = 2
      MCB(5)  = 3
      MCB(6)  = 0
      MCB(7)  = 0
      INCR    = 1
      TSKJ(1) = SKJ
      TSKJ(2) = 0
      TSKJ(3) = NK
      TSKJ(4) = 2
      TSKJ(5) = 3
      TSKJ(6) = 0
      TSKJ(7) = 0
      IFILE   = ACPT
C
C     READ MACH NUMBER AND REDUCED FREQUENCY AND LOOP UNTIL COMPLETED
C
  100 CALL READ (*210,*210,AERO,FMACH,2,0,N)
C
C     NUMBER OF ROWS ADDED BY EACH RECORD ON ACPT
C
      NROW = 0
      ISK  = 1
      NSK  = 0
C
C     SKIP HEADER
C
      CALL FWDREC (*450,ACPT)
C
C     READ A RECORD AND LOOP BY METHOD UNTIL EOF
C     NSK IS BUMPED BY DRIVERS = COLUMNS BUILT  ISK = NEXT COLUMN
C
  110 CALL READ (*200,*200,ACPT,METHOD,1,0,N)
      GO TO (120,130,140,150,160,170,180), METHOD
C
C     DOUBLET LATTICE METHOD
C
  120 CALL DLAMG (ACPT,AJJL,SKJ)
      GO TO 190
C
C     DOUBLET LATTICE WITH BODIES
C
  130 CALL DLAMBY (ACPT,AJJL,SKJ)
      GO TO 190
C
C     MACH BOX
C
  140 CALL MBAMG (ACPT,AJJL,SKJ)
      GO TO 190
C
C     STRIP THEORY
C
  150 CALL STPDA (ACPT,AJJL,SKJ)
      GO TO 190
C
C     PISTON THEORY
C
  160 CALL PSTAMG (ACPT,AJJL,SKJ)
      GO TO 190
C
C     COMPRESSOR BLADE METHOD
C
  170 CALL AMGB1 (ACPT,AJJL,SKJ)
      GO TO 190
C
C     SWEPT TURBOPROP BLADE METHOD
C
  180 CALL AMGT1 (ACPT,AJJL,SKJ)
  190 IF (NSK .GT. NK) GO TO 400
      IF (NROW.GT. NJ) GO TO 420
      GO TO 110
  200 CALL REWIND (ACPT)
      GO TO 100
  210 CALL CLOSE  (AERO,1)
      CALL CLOSE  (AJJL,1)
      CALL CLOSE  (SKJ,1)
      CALL WRTTRL (TSKJ)
      CALL WRTTRL (MCB)
C
C     COMPUTE W1JK - W2JK
C
C
C     OPEN OUTPUT FILES
C
      CALL FWDREC (*450,ACPT)
      IFILE = W1JK
      CALL GOPEN (W1JK,IZ(BUF1+1),1)
      IFILE = W2JK
      CALL GOPEN (W2JK,IZ(BUF2+1),1)
      IFILE = ACPT
C
C     SET UP PACKX AND TRAILERS
C
      INCR = 1
      ITI  = 1
      ITO  = 1
C
C     II AND NN ARE BUMPED BY METHOD DRIVERS
C
      II   = 1
      DO 220 I = 2,7
      TW1JK(I) = 0
      TW2JK(I) = 0
  220 CONTINUE
      TW1JK(1) = W1JK
      TW2JK(1) = W2JK
      TW1JK(3) = NK
      TW1JK(4) = 2
      TW1JK(5) = 1
      TW2JK(3) = NK
      TW2JK(4) = 2
      TW2JK(5) = 1
C
C     READ A RECORD AND LOOP ON METHOD UNTIL EOR
C
  230 CALL READ (*300,*300,ACPT,METHOD,1,0,N)
      GO TO (240,250,260,260,260,270,280), METHOD
C
C     DOUBLET LATTICE METHOD
C
  240 CALL DLPT2 (ACPT,W1JK,W2JK)
      GO TO 290
C
C     DOUBLET LATTICE WITH BODIES
C
  250 CALL DLBPT2 (ACPT,W1JK,W2JK)
      GO TO 290
C
C     STRIP THEORY     PISTON THEORY
C     MACH BOX
C
  260 CALL STPPT2 (ACPT,W1JK,W2JK)
      GO TO 290
C
C     COMPRESSOR BLADE METHOD
C
  270 CALL AMGB2 (ACPT,W1JK,W2JK)
      GO TO 290
C
C     SWEPT TURBOPROP BLADE METHOD
C
  280 CALL AMGT2 (ACPT,W1JK,W2JK)
  290 IF (NN .GT. NK) GO TO 410
      GO TO 230
C
C     DONE
C
  300 CALL CLOSE  (ACPT,1)
      CALL CLOSE  (W1JK,1)
      CALL CLOSE  (W2JK,1)
      CALL WRTTRL (TW1JK)
      CALL WRTTRL (TW2JK)
      RETURN
C
C     ERROR MESSAGES
C
C     NROW IN RECORDS DID NOT MATCH NJ PARAMETER
C
  400 NROW = NSK
      NJ   = NK
      GO TO 420
  410 NROW = NN
      NJ   = NK
  420 WRITE  (IOUT,430) SFM,NROW,NJ
  430 FORMAT (A25,' 2264, NUMBER OF ROWS COMPUTED (',I4,') WAS GREATER',
     1       ' THAN SIZE REQUESTED FOR OUTPUT MATRIX (',I4,2H).)
      CALL MESAGE (-61,N,NAME)
  440 NMS = -1
      GO TO 470
  450 NMS = -2
      GO TO 470
  460 NMS = -8
  470 CALL MESAGE (NMS,IFILE,NAME)
      RETURN
      END

      SUBROUTINE EXTERN (NEX,NGRAV,GVECT,ILIST,PG,N1,IHARM)
C
C     GENERATES EXTERNAL LOADS
C
      IMPLICIT INTEGER (A-Z)
      INTEGER         PG(1),ILIST(1),NAME(2),IZ(1)
      REAL            CORE,GVECT(1)
      COMMON /TRANX / IDUM(14)
      COMMON /BLANK / NROWSP
      COMMON /ZZZZZZ/ CORE(1)
      COMMON /LOADX / LCARE,SLT,BGPDT,OLD,CSTM,SIL,ISIL,EST,MPT,NN(7),
     1                NOBLD,IDIT,ICM,ILID
      COMMON /SYSTEM/ SYSBUF
      COMMON /PACKX / ITYA,ITYB,II,JJ,INCUR
      COMMON /HMATDD/ IIHMAT,NNHMAT,MPTFIL,IDITFL
      COMMON /PINDEX/ IEST(45)
      COMMON /GPTA1 / JDUM
      EQUIVALENCE     (CORE(1),IZ(1))
      DATA    CASECC, PERMBD,HCFLDS,REMFLS,SCR6,HCCENS, NAME         /
     1        110   , 112   ,304   ,305   ,306 ,307   , 4HEXTE,4HRN  /
C
      IEST(1) =-1
      IDUM(1) = 0
      JOPEN = 0
      IPRE  = 0
      INCUR = 1
      II    = 1
      JJ    = NROWSP
      NGRAV = 0
      OLD   = 0
      ICM   = 1
      ITYA  = 1
      ITYB  = 1
      IBUF1 = LCARE - SYSBUF + 1
      IBUF2 = IBUF1 - SYSBUF
      IBUF3 = IBUF2 - SYSBUF
      IBUF4 = IBUF3 - SYSBUF
      IBUF5 = IBUF4 - SYSBUF
      LCORE = IBUF5 - SYSBUF
      CALL GOPEN (SLT,CORE(IBUF1),0)
      CALL GOPEN (BGPDT,CORE(IBUF2),0)
      FILE = CSTM
      CALL OPEN (*20,CSTM,CORE(IBUF3),0)
      ICM  = 0
      CALL SKPREC (CSTM,1)
   20 CALL GOPEN (SIL,CORE(IBUF4),0)
      FILE = SLT
      ISIL = 0
      IF (LCORE .LT. NROWSP) GO TO 1580
C
      III  = 1
      DO 1400 NLOOP = 1,N1
C
      ILID = ILIST(III)
      IF (ILID .NE. 0) GO TO 30
      CALL SKPREC (SLT,1)
      GO TO 1310
   30 DO 40 I = 1,NROWSP
   40 CORE(I) = 0.0
      NOGRAV  = 0
      NGROLD  = NGRAV
   50 CALL READ (*1520,*1300,SLT,NOBLD,1,0,FLAG)
      CALL FREAD (SLT,IDO,1,0)
      IF (NOGRAV .EQ.  1) GO TO 1570
      IF (NOBLD .EQ. -20) GO TO 800
      GO TO (100,100,120,120,140,140,160,200,220,300,
     1       320,340,600,620,630,640,360,700,730,800,
     2       800,800,800,800,400), NOBLD
  100 DO 110 J = 1,IDO
  110 CALL DIRECT
      GO TO 50
  120 DO 130 J = 1,IDO
  130 CALL TPONT
      GO TO 50
  140 DO 150 J = 1,IDO
  150 CALL FPONT
      GO TO 50
  160 DO 170 J = 1,IDO
  170 CALL SLOAD
      GO TO 50
  200 IF (NOGRAV .EQ. 2) GO TO 1570
      DO 210 J = 1,IDO
      CALL GRAV (NGRAV,GVECT(1),NEX,ILIST(1),NLOOP)
  210 CONTINUE
      NOGRAV = 1
      GO TO 50
  220 DO 230 J = 1,IDO
  230 CALL PLOAD
      GO TO 50
C
C     RFORCE CARDS
C
  300 DO 310 J = 1,IDO
  310 CALL RFORCE (LCORE)
      GO TO 50
C
C     PRESAX CARDS
C
  320 DO 330 J = 1,IDO
  330 CALL PRESAX (IHARM)
      GO TO 50
C
C     QHBDY CARDS
C
  340 DO 350 J = 1,IDO
      CALL QHBDY
  350 CONTINUE
      GO TO 50
C
C     PLOAD3 CARDS
C
  360 DO 370 J = 1,IDO
  370 CALL PLOAD3
      GO TO 50
C
C     PLOAD4 CARDS
C
  400 CALL PLOAD4 (IBUF5,IDO,JOPEN)
      GO TO 50
C
C     QVOL CARDS (MODIFIED USER ENTRYS)
C
  600 DO 610 J = 1,IDO
      CALL QVOL
  610 CONTINUE
      GO TO 50
C
C     QBDY1 CARDS (MODIFIED USER ENTRYS)
C
  620 KKKK = 1
      GO TO 650
C
C     QBDY2 CARDS (MODIFIED USER ENTRYS)
C
  630 KKKK = 2
      GO TO 650
C
C     QVECT CARDS (MODIFIED USER ENTRYS)
C
  640 KKKK = 3
  650 DO 660 J = 1,IDO
      CALL QLOADL (KKKK)
  660 CONTINUE
      GO TO 50
C
C     PLOAD1 CARDS
C
  700 IF (IPRE .EQ. 1) GO TO 710
      IPRE  = 1
      LCORE = LCORE - SYSBUF - 1
      MCORE = LCORE - NROWSP - 1
      IF (LCORE .LT. NROWSP) GO TO 1580
      CALL PREMAT (CORE(NROWSP+1),CORE(NROWSP+1),CORE(LCORE),MCORE,
     1             NCORE,MPT,IDIT)
  710 DO 720 J = 1,IDO
      CALL PLBAR1 (IDO,LCORE)
  720 CONTINUE
      GO TO 50
C
C     PLOADX CARDS
C
  730 DO 740 J = 1,IDO
      CALL PLOADX
  740 CONTINUE
      GO TO 50
C
C     CEMLOOP, SPCFLD, GEMLOOP, MDIPOLE, AND REMFLUX CARDS
C
C     BRING HEAT MATERIALS INTO CORE
C
  800 IF (IPRE .EQ. 1) GO TO 1230
      IPRE = 1
C
C     1ST AND LAST AVAILABLE LOCATIONS IN OPEN CORE
C
      IIHMAT = NROWSP
      NNHMAT = LCORE
      MPTFIL = MPT
      IDITFL = IDIT
      CALL PREHMA (CORE)
C
C     NOW NNHMAT CONTAINS LAST LOCATION OF MATERIAL INFO
C
      NEXTZ = NNHMAT + 1
C
C     OPEN HCFLDS TO CONTAIN APPLIED MAGNETIC FIELD LOAD
C
      LCORE = LCORE - SYSBUF
      IF (LCORE .LE. NEXTZ) GO TO 1580
C
C     STORE SILS  ON PERMBDY, IF ANY, INTO OPEN CORE
C
      NBDYS = 0
      FILE  = PERMBD
      CALL OPEN (*820,PERMBD,CORE(LCORE+1),0)
      CALL FWDREC (*1520,PERMBD)
      CALL READ (*1520,*810,PERMBD,CORE(NEXTZ),LCORE-NEXTZ+1,0,NBDYS)
      GO TO 1580
  810 CALL CLOSE (PERMBD,1)
  820 CONTINUE
      NEXTZ = NEXTZ + NBDYS
C
C     NOW CHECK FOR FORCE REQUESTS ON CASECC(MAGNETIC FIELD REQUESTS)
C     MAKE A UNIQUE LIST OF ELEMENT ID-S CORRESPONDING TO ALL SUBCASES.
C     IF A SUBCASE REQUESTS ALL, NO LIST IS NECESSARY.
C
      ALL    = 0
      NELOUT = 0
      IJ     = 0
C
C     1ST GET MAXIMUM LENGTH OF CASE CONTROL IN ORDER TO STORE ELEMENT
C     ID-S
C
      NCC = 0
      CALL GOPEN (CASECC,CORE(LCORE+1),0)
  830 CALL READ (*850,*840,CASECC,CORE(NEXTZ),LCORE-NEXTZ+1,0,KCC)
      GO TO 1580
  840 NCC = MAX0(NCC,KCC)
      GO TO 830
  850 CALL REWIND (CASECC)
      CALL FWDREC (*1520,CASECC)
      KSET = NEXTZ + NCC
C
  860 CALL READ (*1200,*870,CASECC,CORE(NEXTZ),LCORE-NEXTZ+1,0,NCC)
      GO TO 1580
  870 SETNO = IZ(NEXTZ+25)
      IF (SETNO .EQ. 0) GO TO 860
      IF (SETNO .GT. 0) GO TO 1010
C
C     ALL
C
 1000 ALL    = 1
      NELOUT = 0
      GO TO 1200
C
C     CREATE UNIQUE LIST OF ELEMENT ID-S
C
 1010 ILSYM  = IZ(NEXTZ+165)
      ISETNO = ILSYM  + IZ(ILSYM+NEXTZ-1) + NEXTZ
 1020 ISET   = ISETNO + 2
      NSET   = IZ(ISETNO+1) + ISET - 1
      IF (IZ(ISETNO) .EQ. SETNO) GO TO 1030
      ISETNO = NSET + 1
C
C     IF SET CANNOT BE FOUND, SET TO ALL. BUT SHOULD NOT HAPPEN
C
      IF (ISETNO .LT. NCC+NEXTZ-1) GO TO 1020
      GO TO 1000
C
C     PICK UP ELEMENT ID-S. STORE IN UNIQUE LIST
C
 1030 I = ISET
 1040 IF (I    .EQ. NSET) GO TO 1060
      IF (IZ(I+1) .GT. 0) GO TO 1060
      IB = IZ(I  )
      N  =-IZ(I+1)
      I  = I + 1
      ASSIGN 1050 TO RET
      GO TO 1100
 1050 IB = IB + 1
      IF (IB .LE. N) GO TO 1100
      GO TO 1070
 1060 IB = IZ(I)
      ASSIGN 1070 TO RET
      GO TO 1100
 1070 I = I + 1
      IF (I .LE. NSET) GO TO 1040
C
C     DONE WITH THIS SET. GO BACK FOR ANOTHER
C
      GO TO 860
C
C     SEARCH LIST OF ELEMENT ID-S. ADD ID TO LIST IF NOT A DUPLICATE
C
 1100 IF (IJ .NE. 0) GO TO 1110
      MSET = KSET
      IZ(MSET) = IB
      NELOUT = 1
      IJ = MSET
      GO TO RET, (1050,1070)
 1110 DO 1120 J = MSET,IJ
      IF (IZ(J) .EQ. IB) GO TO RET, (1050,1070)
 1120 CONTINUE
      IJ = IJ + 1
      IF (IJ .LT. LCORE) GO TO 1130
      GO TO 1000
 1130 IZ(IJ) = IB
      NELOUT = NELOUT + 1
      GO TO RET, (1050,1070)
C
C     DONE WITH ALL CASES. IF ALL.NE.1, MOVE THE ID-S UP IN CORE
C
 1200 CALL CLOSE (CASECC,1)
      IF (ALL .EQ. 1) GO TO 1220
C
      DO 1210 J = 1,NELOUT
 1210 IZ(NEXTZ+J-1) = IZ(MSET+J-1)
      NEXTZ = NEXTZ + NELOUT
 1220 CONTINUE
C
      CALL GOPEN (HCFLDS,CORE(LCORE+1),1)
      I = LCORE - SYSBUF
      J = I     - SYSBUF
      LCORE = J - SYSBUF
      IF (LCORE .LE. NEXTZ) GO TO 1580
      CALL GOPEN (REMFLS,CORE(I+1),1)
      CALL GOPEN (HCCENS,CORE(J+1),1)
      CALL GOPEN (SCR6,CORE(LCORE+1),1)
C
C     NO DO LOOP ON IDO. IN EANDM WE WILL READ ALL CARDS
C
 1230 CALL EANDM (NOBLD,IDO,NEXTZ,LCORE,NBDYS,ALL,NELOUT)
      GO TO 50
C
C
 1300 IF (NGROLD .NE. NGRAV) GO TO 1400
      CALL PACK (CORE,PG,PG(1))
 1310 III = III + 1
C
 1400 CONTINUE
C
      CALL CLOSE (BGPDT,1)
      IF (ICM .EQ. 0) CALL CLOSE (CSTM,1)
      CALL CLOSE (SLT,1)
      CALL CLOSE (SIL,1)
      IF (IPRE .NE. 1) GO TO 1410
      CALL CLOSE (HCFLDS,1)
      CALL CLOSE (REMFLS,1)
      CALL CLOSE (HCCENS,1)
      CALL CLOSE (SCR6,1)
 1410 CONTINUE
      RETURN
C
C     FILE ERRORS
C
 1520 IP1 = -2
      GO TO 1600
 1570 IP1 = -7
      GO TO 1600
 1580 IP1 = -8
 1600 CALL MESAGE (IP1,FILE,NAME(1))
      RETURN
      END

      SUBROUTINE XYPLOT
C
C     XYPLOT IS AN OUTPUT MODULE
C
C     INFORMATION SUPPLIED BY XYTRAN THROUGH DATA BLOCK XYPLOT
C     IS INTERPRETED AND OUTPUT TO EITHER PLT1(BCD TAPE FILE) OR
C     PLT2(BINARY TAPE FILE) FOR PLOTTING ON AN OFF-LINE PLOTTER.
C
C
      EXTERNAL        LSHIFT,RSHIFT
      INTEGER         EXPO,ISYM(2),IX(1),LTTN(10),LTTP(10),D4,
     1                OUTAPE,RSHIFT,SYSBUF,XYPLT
      REAL            NUMS,TLTV(22),X(1),Y(1),XY(2),CHRSCL,CSCALE
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25,SWM*27
      COMMON /XMSSG / UFM,UWM,UIM,SFM,SWM
      COMMON /MACHIN/ MACH,IHALF
      COMMON /SYSTEM/ KSYSTM(65)
CZZ   COMMON /ZZXYPL/ Z(1)
      COMMON /ZZZZZZ/ Z(20000)
      COMMON /XXPARM/ IPLTBF,ICMRA,IFSKP,PNAM1,PNAM2,IPTDN,NPENS,
     1                PAPSZX,PAPSZY,PTYP1,PTYP2,JPSZ(8),PC(8,2),
     2                SPARE,YA(115)
      COMMON /PLTDAT/ MODEL,IPLTNR,XWMIN,YLOW,AXMAX,YUP,XWMAX,YWMAX,
     1                XEDGE,YEDGE,XA(9),CHRSCL,
     2                XYMAX(2),CNTPI,CCH,CCV,ALL,MNP,APO(2),ITP,LTAPE
      COMMON /XYPLIN/ IDSB,NFRM,NCRV,IDPE,NCOM,IDMJ,ITBF,
     1                NWFR,ISKP,D1  ,XMIN,XMAX,YMIN,YMAX,
     2                XTIC,XDTC,XLTC,NXDG,IXPR,NXTT,IXVS,
     3                IXDT,YTIC,YDTC,YLTC,NYDG,IYPR,NYTT,
     4                IYVS,IYDT,ITTC,IBTC,ILTC,IRTC,LOGX,
     5                LOGY,IXAX,XINT,IYAX,YINT,ICRV,D2(2),
     6                IPENS,IPENN,SKP5(5),TITL(32),SBTL(32),
     7                CLBL(32),CVTL(32),XATL(32),YATL(32),
     8                IXGD,IYGD,D3(37),CSCALE,IPSZ,NPLT,XPAP,
     9                YPAP,NCMR,D4(13)
      EQUIVALENCE     (KSYSTM( 1),SYSBUF), (KSYSTM( 2),OUTAPE),
     1                (KSYSTM( 9),NLPP  ), (KSYSTM(12),NLINES),
     2                (Z(1),X(1),IX(1),XY(1)), (XY(2),Y(1))
      DATA    LPLTMD, LCMR, XLPAP, YLPAP / -1, -1, -1.0, -1.0   /
      DATA    XYPLT / 101   /
      DATA    NRWD  , IRDRW ,ICLSRW /
     1        300   , 0     ,1      /
      DATA    IPLUS , IE, LEP, LEM  / 1H+, 1HE, 4H1E+ , 4H1E-   /
      DATA    LTTN  / 8,  8, 5, 4, 3, 2, 2, 1, 1, 1 / ,
     1        LTTP  / 15,15,10, 6, 3, 1, 1, 7, 7, 7 / ,
     2        TLTV  / 3.,6.,2.,5.,8.,2.,4.,6.,8.,2.,3.,5.,7.,9.,2.,3.,
     3                4.,5.,6.,7.,8.,9. /
C
C
C     DEFINITION OF COMMON BLOCK /PLTDAT/ CONTENTS
C
C     MODEL  - MODEL NUMBER OF THE CURRENT PLOTTER.
C     IPLTNR - NUMBER OF CURRENT PLOTTER IN USE
C     XWMIN  - MINIMUM X VALUE OF PLOTTING REGION IN PLOTTER COUNTS
C     YLOW   - MIN. Y VALUE OF PLOT. REGION(AFTER TITLES)
C              IN PLOTTER COUNTS
C     AXMAX  - MAX. X VALUE OF PLOT. REGION(LESS MARGIN)
C              IN PLOTTER COUNTS
C     YUP    - MAX. Y VALUE OF PLOT. REGION(LESS MARGIN)
C              IN PLOTTER COUNTS
C     XWMAX  - ACTUAL MAXIMUM REGION SIZE IN X DIRECTION
C              IN PLOTTER COUNTS
C     YWMAX  - ACTUAL MAXIMUM REGION SIZE IN Y DIRECTION
C              IN PLOTTER COUNTS
C     XEDGE  - MARGIN OF X EDGE IN PLOTTER COUNTS (TABLE PLOTTERS ONLY)
C     YEDGE  - MARGIN OF Y EDGE IN PLOTTER COUNTS (TABLE PLOTTERS ONLY)
C     XA     - SPARES
C
C     THE FOLLOWING SYMBOLIC VALUES PERTAIN TO THE CURRENT PLOTTER.
C     AND ARE SET WHEN STPLOT OR PLTSET IS CALLED.
C
C     XYMAX - X AND Y FRAME LIMITS IN PLOTTER COUNTS.
C     CNTPI - PLOTTER COUNTS PER INCH.
C     CCH   - HORIZONTAL PLOTTER COUNTS PER SINGLE CHARACTER
C     CCV   - VERTICAL PLOTTER COUNTS PER SINGLE CHARACTER
C     ALL   - MAXIMUM LINE LENGTH DRAWN WITH SINGLE COMMAND
C             (PLOTTER COUNT)
C     MNP   - MAXIMUM NUMBER OF PENS
C     APOX  - ACTUAL PLOTTER X ORIGIN IN PLOTTER COUNTS
C     APOY  - ACTUAL PLOTTER Y ORIGIN IN PLOTTER COUNTS
C             NOTE - INCREMENTAL PLOTTERS USE AS CURRENT PEN POSITION.
C     ITP   - PLOTTER TYPE.
C     LTAPE - GINO NAME OF THE PLOT TAPE.
C
C     DEFINITION OF I.D. RECORD CONTENTS OF INPUT DATA FILE /XYPLIN/
C
C     IDSB - SUBCASE I.D.               NFRM - FRAME NUMBER
C     NCRV - CURVE NUMBER               IDPE - POINT OR ELEMENT I.D.
C     NCOM - COMPONENT NUMBER           IDMJ - VECTOR NUMBER
C     ITBF - BOTTOM TOP FULL FRAME IND. NWFR - NEW AXIS AND LABEL IND.
C     ISKP - FRAME SKIP NUMBER          D1   - SPARE
C     XMIN - MINIMUM X DATA FOR CURVE   XMAX - MAXIMUM X DATA FOR CURVE
C     YMIN - MINIMUM Y DATA FOR CURVE   YMAX - MAXIMUM Y DATA FOR CURVE
C     XTIC - FIRST X TICK VALUE         XDTC - VALUE BETWEEN X TICKS
C     XLTC - HIGHEST X-VALUE ON FRAME.  NXDG - MAX. DIGITS FOR X-TICKS
C     IXPR - 10 POWER ON PRINTED X TICK NXTT - TOTAL NUMBER OF X TICKS
C     IXVS - X TICKS BETWEEN LABELS     IXDT - DELTA PRINT VALUE X TICKS
C     YTIC - FIRST Y TICK VALUE         YDTC - VALUE BETWEEN Y TICKS
C     YLTC - HIGHEST Y-VALUE ON FRAME.  NYDG - MAX. DIGITS FOR Y-TICKS
C     IYPR - 10 POWER ON PRINTED Y TICK NYTT - TOTAL NUMBER OF Y TICKS
C     IYVS - Y TICKS BETWEEN LABELS     IYDT - DELTA PRINT VALUE Y TICKS
C     ITTC - TICKS W/WO VALUES - TOP    IBTC - TICKS W/WO VALUES - BOTTM
C     ILTC - TICKS W/WO VALUES - LEFT   IRTC - TICKS W/WO VALUES - RIGHT
C     LOGX - LINEAR/LOG - X DIRECTION   LOGY - LINEAR/LOG - Y DIRECTION
C     IXAX - X AXIS/NO AXIS INDICATOR   XINT - X AXIS  Y INTERCEPT
C     IYAX - Y AXIS/NO AXIS INDICATOR   YINT - Y AXIS  X INTERCEPT
C     ICRV - POINT/LINE PLOT INDICATOR  D2   - SPARES
C     TITL - PLOT TITLE                 SBTL - PLOT SUBTITLE
C     CLBL - PLOT LABEL                 CVTL - PLOT CURVE TITLE
C     XATL - X AXIS TITLE               YATL - Y AXIS TITLE
C     IXGD - X GRID LINES               IYGD - Y GRID LINES
C     D3   - SPARES                     IPNR - PEN COLOR
C     IPSZ - PEN SIZE                   NPLT - TYPE OF PLOTTER
C     XPAP - PAPER SIZE(IN.) X DIR.     YPAP - PAPER SIZE(IN.) Y DIR.
C     NCMR - CAMERA NR. FOR SC-4020     D4   - XYTRAN INTERNAL FLAGS
C
C
C     SET IOPN=0 (PLOT TAPE CLOSED) AND NERR=0 (NUMBER OF ID RECORDS
C     WITH WRONG WORD COUNT).  WHEN NERR=5, XYPLOT ASSUMES BAD INPUT
C     FILE AND ABANDONS OPERATION.
C
      MB1  = KORSZ(Z) - SYSBUF
      IPCHG= 0
      IOPN = 0
      CALL OPEN (*920,XYPLT,Z(MB1),IRDRW)
   99 CALL FWDREC (*960,XYPLT)
      NERR = 0
C
C     READ I.D. RECORD ON INPUT DATA FILE
C
  100 CALL READ (*960,*120,XYPLT,IDSB,NRWD+1,1,NACT)
  110 NERR = NERR + 1
      IF (NERR .GE. 5) GO TO 940
      GO TO 100
  120 IF (NACT .NE. NRWD) GO TO 110
C
C     SKIP DATA IF IT WAS FOR THE PAPERPLOTER ONLY
C
      IF (D4(2) .LE. 0) GO TO 99
      IF (NWFR  .NE. 0) GO TO 270
C
C     READ DATA PAIRS FROM INPUT DATA FILE FOR CURVE TO BE PLOTTED
C
  130 CALL READ (*960,*250,XYPLT,Z,MB3,0,NACT)
C
C     SET IFIN TO SHOW MORE DATA REMAINING TO BE READ FROM RECORD.
C     SET L AS INDEX TO LAST LEGITIMATE X VALUE OF DATA PAIRS IN CORE.
C
      IFIN = 0
      L    = MB3 - 1
  140 IF (IX(L) .NE. 1) GO TO 150
      L = L - 2
      IF (L .LE. 0) GO TO 240
C
C     CONVERT DATA POINTS TO PLOTTER COUNTS AND PLOT SYMBOL AT EACH
C     LEGITIMATE POINT WHEN REQUIRED.
C
  150 IF (ICRV .NE. 0) CALL SYMBOL (0,0,0,-1)
C
      ISYM(1) = IABS(ICRV) + NCRV - 1
      ISYM(2) = 0
C
      DO 190 I = 1,L,2
      IF (IX(I) .EQ.    1) GO TO 190
      IF (X(I) .GT. XMAXS) GO TO 180
      IF (X(I) .LT. XMINS) GO TO 180
      IF (LOGXS .LE.    0) GO TO 160
      X(I) = ALOG10(X(I))
  160 X(I) = XDR*X(I)+XC
      IF (Y(I) .GT. YMAXS) GO TO 180
      IF (Y(I) .LT. YMINS) GO TO 180
      IF (LOGYS .LE.    0) GO TO 170
      Y(I) = ALOG10(Y(I))
  170 Y(I) = YDR*Y(I) + YC
      IF (ICRV .NE. 0) CALL SYMBOL (X(I),Y(I),ISYM,0)
      GO TO 190
  180 IX(I  ) = 1
      IX(I+1) = 1
  190 CONTINUE
      IF (ICRV .NE. 0) CALL SYMBOL (0,0,0,1)
C
C     PLOT LINES BETWEEN LEGITIMATE POINTS WHEN REQUIRED
C
      IF (ICRV.LT.0 .AND. IPENN.GT.0) ICRV = -ICRV
      IF (ICRV .LT. 0) GO TO 240
      CALL LINE (0,0,0,0,0,-1)
      OLDX = X(1)
      OLDY = Y(1)
      IF (IPCHG .EQ. 1) GO TO 193
      ICPEN = IPSZ
      IF (IPENS .EQ. 0) GO TO 192
      ICPEN = IPENS
      IPCHG = 1
      GO TO 192
  193 IF (ICPEN .EQ. IPENN) ICPEN = IPENS - 1
      ICPEN = ICPEN + 1
  192 CONTINUE
      DO 230 I = 1,L,2
      IF (IX(I) .EQ. 1) GO TO 220
      T1 = OLDX - X(I)
      T2 = OLDY - Y(I)
      IF (T1) 210,200,210
  200 IF (T2) 210,230,210
  210 CALL LINE (OLDX,OLDY,X(I),Y(I),ICPEN,0)
      OLDX = X(I)
      OLDY = Y(I)
      GO TO 230
  220 OLDX = X(I+2)
      OLDY = Y(I+2)
  230 CONTINUE
      CALL LINE (0,0,0,0,0,1)
  240 IF (IFIN) 100,130,100
C
C     ALL DATA PAIRS IN CORE, SET IFIN TO SHOW NO MORE DATA REMAINS
C     FOR PRESENT CURVE.  IF ODD NUMBER OF DATA VALUES OUTPUT WARNING
C     MESSAGE AND CONTINUE.  SET L AS INDEX TO LAST X VALUE OF DATA
C     PAIRS.
C
  250 IFIN = 1
      IF (NACT .EQ. (NACT/2)*2) GO TO 260
      NACT = NACT - 1
      WRITE (OUTAPE,990) UWM,NFRM,NCRV
      NLINES = NLINES + 2
      IF (NLINES .GE. NLPP) CALL PAGE
  260 L = NACT - 1
      IF (L) 100,100,140
C
C     NEW AXIS, LABELS, ETC. ARE NEEDED.
C
C     NASTRAN PLOTTING SOFTWARE INITIALIZATION.
C
  270 IF (ITBF.GE.0 .AND. IOPN.NE.0) CALL STPLOT (-1)
      IPLTNR = RSHIFT(NPLT,IHALF)
      MODEL  = NPLT - LSHIFT(IPLTNR,IHALF) - 100
      IF (NCMR .GT. 0) ICMRA=NCMR
      IFSKP  = ISKP
      CSCALE = CHRSCL
      IF (CSCALE .LT. 1.) CSCALE = 1.0
      IF (XPAP   .GT. 0.) PAPSZX = XPAP
      IF (YPAP   .GT. 0.) PAPSZY = YPAP
      DO 280 I = 1,NPENS
  280 JPSZ(I) = IPSZ
      IF (ITBF .GE. 0) GO TO 284
C
C     LOWER HALF MAY NOT CHANGE FRAME OR PLOTTER OR CALL PLTSET
C
C     IF (NCMR .NE. LCMR  ) GO TO 925
      IF (XPAP .NE. XLPAP ) GO TO 925
      IF (YPAP .NE. YLPAP ) GO TO 925
      IF (NPLT .NE. LPLTMD) GO TO 925
      GO TO 286
C
  284 CALL PLTSET
      LCMR  = NCMR
      XLPAP = XPAP
      YLPAP = YPAP
      LPLTMD= NPLT
      MB2   = MB1 - IPLTBF
      MB3   = 2*((MB2-1)/2)
C
C     SET VALUES FOR FULL FRAME PLOTTING
C
  286 YWMIN= 0.
      YLOW = 4.*CCV
      YXTR = (YWMAX+YLOW)/2.
C
C     START A NEW PLOT IF NECESSARY.
C
      IF (ITBF .LT. 0) GO TO 290
      CALL SOPEN (*930,LTAPE,Z(MB2),IPLTBF)
      IOPN = 1
      CALL STPLOT (NFRM)
  290 CALL PRINT (0,0,0,0,0,-1)
      IF (ITBF) 300,320,310
C
C     MODIFY VALUE FOR LOWER HALF FRAME PLOTTING
C
  300 YUP = YXTR
      GO TO 330
C
C     MODIFY VALUE FOR UPPER HALF FRAME PLOTTING
C
  310 YLOW = YXTR
C
C     SAVE YLOW AND EXPAND REGION SIZE FOR PRINTING OF TITLES.  RESTORE
C     YLOW AFTER PRINTING THE FOUR CURVE TITLES AT BOTTOM OF FRAME.
C
  320 XPRM = XWMIN
      YPRM = YWMIN
      Y1T  = YLOW
      YLOW = YWMIN
      CALL PRINT (XPRM,YPRM,1,CLBL(1),32,0)
      YPRM = YPRM + CCV
      CALL PRINT (XPRM,YPRM,1,SBTL(1),32,0)
      YPRM = YPRM + CCV
      CALL PRINT (XPRM,YPRM,1,TITL(1),32,0)
      YPRM = YPRM + CCV
      CALL PRINT (XPRM,YPRM,1,CVTL(1),32,0)
      YLOW = Y1T
C
C     OUTPUT X AND Y AXES TITLES
C
  330 YPRM = YLOW
      XPRM = XWMIN + 8.*CCH
      CALL PRINT (XPRM,YPRM,1,XATL(1),32,0)
      YPRM = YUP - 2*CCV
      XPRM = XWMIN
      CALL PRINT (XPRM,YPRM,2,YATL(1),32,0)
      CALL TIPE (0,0,0,0,0,1)
C
C     MEANING OF SYMBOLS USED
C     XDR,XC,YDR,YC - FACTORS TO CONVERT ENGINEERING UNITS TO PLOTTER
C                     COUNTS IN X AND Y DIRECTIONS.
C     CONVERSION IS - PLOTTER COUNTS = ENG. UNITS * XDR  +  XC
C
C     JTC,J1T,J2T,J3T,J4T,J5T - TEMPORARY INTEGER VALUES
C     T1,T2,T3,T4,X1T,Y1T     - TEMPORARY REAL VALUES
C
C     TEST XMAX,XMIN,YMAX, AND YMIN FOR COMPATIBILITY
C
      N  = 0
  340 DX = XLTC - XTIC
      DY = YLTC - YTIC
      IF (DX.GT.0.0 .AND. DY.GT.0.0) GO TO 440
      IF (N .NE.  0) GO TO 350
      IF (DX.LE.0.0) XLTC = XTIC + XDTC*FLOAT(NXTT+1)
      IF (DY.LE.0.0) YLTC = YTIC + YDTC*FLOAT(NYTT+1)
      N = 1
      GO TO 430
  350 N = 2
      IF (DX .GT. 0.0) GO TO 360
      XLTC = XTIC + 10.0
      XDTC = 2.0
      NXTT = 0
  360 IF (DY .GT. 0.0) GO TO 430
      YLTC = YTIC + 10.0
      YDTC = 2.0
      NYTT = 4
C
C     PRINT WARNING (N=NO. OF PASSES TO CORRECT)
C
  430 WRITE (OUTAPE,1010) UWM,N,NFRM
      NLINES = NLINES + 2
      IF (NLINES .GE. NLPP) CALL PAGE
      IF (N .EQ. 1) GO TO 340
C
C     SAVE XMAX, XMIN, YMAX, YMIN, LOGX AND LOGY FOR USE IF NEXT
C     I.D. RECORD IS NOT A NEW FRAME
C
  440 LOGXS = LOGX
      LOGYS = LOGY
      XMINS = XTIC
      XMAXS = XLTC
      YMINS = YTIC
      YMAXS = YLTC
C
C     CALCULATE CONVERSION FACTORS
C
      XPL = XWMAX - 7.*CCH
      XPS = XWMIN + 8.*CCH
      YPL = YUP   - 2.*CCV
      YPS = YLOW  + 2.*CCV
C
C     PUT FRAME AT X AND Y MAXIMUM AND MINIMUM LIMITS
C
      IF (IXGD.EQ.0 .AND. IYGD.EQ.0) GO TO 450
      CALL AXIS (0,0,0,0,0,-1)
      CALL AXIS (XPS,YPS,XPS,YPL,IPSZ,0)
      CALL AXIS (XPS,YPL,XPL,YPL,IPSZ,0)
      CALL AXIS (XPL,YPL,XPL,YPS,IPSZ,0)
      CALL AXIS (XPL,YPS,XPS,YPS,IPSZ,0)
      CALL AXIS (0,0,0,0,0,+1)
  450 IF (LOGX .LE. 0) GO TO 460
      XTIC = ALOG10(XTIC)
      XLTC = ALOG10(XLTC)
      DX   = XLTC - XTIC
      IF (IYAX .EQ. 1) YINT = ALOG10(YINT)
  460 IF (LOGY .LE. 0) GO TO 470
      YTIC = ALOG10(YTIC)
      YLTC = ALOG10(YLTC)
      DY   = YLTC - YTIC
      IF (IXAX .EQ. 1) XINT = ALOG10(XINT)
  470 XDR = (XPL-XPS)/DX
      XC  = (XPS*XLTC-XPL*XTIC)/DX
      YDR = (YPL-YPS)/DY
      YC  = (YPS*YLTC-YPL*YTIC)/DY
C
C     PREPARE TO CREATE + LABEL ANY REQUESTED TIC MARKS IN THE
C     X-DIRECTION.
C
      IF (ITTC.EQ.0 .AND. IXAX.NE.1 .AND. IBTC.EQ.0 .AND. IYGD.EQ.0)
     1    GO TO 575
      NDG = 0
      IF (LOGX .GT. 0) GO TO 480
      DTC = XDTC
      IF (DTC.GT.0. .AND. NXTT.GT.0) GO TO 477
      NTT = 0
      GO TO 485
  477 NTT = NXTT
      XTS = XTIC*XDR + XC
      IF (ITTC.LE.0 .AND. IBTC.LE.0) GO TO 485
      NDG  = MIN0(NXDG+1,6)
      EXPO = NDG + IXPR - 2
      NUMS = XTIC/10.**EXPO
      DL   = DTC/10.**EXPO
      LSTEP= MAX0(IXVS+1,1)
      GO TO 485
  480 NTT = LOGX + 1
      XTS = XTIC*XDR + XC
      DTC = 1.
      NDG = 4
      IF (LOGX .GT. 10) GO TO 485
      ILL  = LTTP(LOGX)
      NITK = LTTN(LOGX)
C
  485 DO 555 K = 1,3
      LABEL = 1
CWKBR 9/93 LOG = XTIC - 1.0 + SIGN(0.1,XTIC)
      LOG = XTIC - 1.0 + SIGN(0.1,XTIC) - 1
      GO TO (490,495,500), K
C
C     TICS + LABELS AT THE TOP.
C
  490 ITC= ITTC
      YT = YPL
      YL = YT + CCV
      GO TO 505
C
C     TICS ALONG THE X-AXIS.
C
  495 ITC = 0
      IF (IXAX .EQ. 1) ITC = -1
      IF (ITC  .EQ. 0) GO TO 505
      YT = XINT*YDR + YC
      CALL AXIS (0,0,0,0,0,-1)
      CALL AXIS (XPL,YT,XPS,YT,IPSZ,0)
      GO TO 505
C
C     TICS + LABELS AT THE BOTTOM.
C
  500 ITC= IBTC
      YT = YPS
      YL = YT - CCV
C
  505 IF (ITC.EQ.0 .OR. NTT.LE.0) GO TO 555
      CALL TIPE (0,0,0,0,0,-1)
      DO 545 J = 1,NTT
      R = XTS + DTC*XDR*FLOAT(J-1)
      CALL TIPE (R,YT,1,IPLUS,1,0)
      IF (LOGX .GT. 0) GO TO 530
      IF (ITC.LT.0 .OR. LABEL.NE.J) GO TO 545
C
C     LABEL THIS LINEAR TIC MARK.
C
      IFIELD = NDG
      RNUM   = NUMS + DL*FLOAT(J-1)
      IF (RNUM) 510,525,515
  510 IFIELD = IFIELD + 1
  515 T = ABS(RNUM)
      IF (T .GE. 1.E-4) GO TO 525
      IF (T .GE. 5.E-5) GO TO 520
      RNUM = 0.
      GO TO 525
  520 RNUM = SIGN(1.E-4,RNUM)
  525 CALL TYPFLT (R,YL,1,RNUM,IFIELD,0)
      LABEL = LABEL + LSTEP
      IF (LABEL .LE. NTT) GO TO 545
      R = R + FLOAT(IFIELD)*CCH
      CALL TIPE (R,YL,1,IE,1,0)
      CALL TYPINT(R+CCH,YL,1,EXPO,0,0)
      GO TO 545
C
C     LABEL THIS LOGARITHMIC CYCLE TIC MARK.
C
  530 LOG = LOG + 1
      IF (ITC .LT. 0) GO TO 535
      I = LEP
      IF (LOG .LT. 0) I = LEM
      CALL PRINT (R-CCH,YL,1,I,1,0)
      CALL TYPINT (R+2.*CCH,YL,1,IABS(LOG),0,0)
  535 IF (LOGX.GT.10 .OR. J.EQ.NTT) GO TO 545
C
C     CREATE + LABEL THE LOGARITHMIC INTRACYCLE TIC MARKS WITHIN THIS
C     CYCLE.
C
      DO 540 I = 1,NITK
      L = ILL + I - 1
      T = XDR*(ALOG10(TLTV(L))+FLOAT(LOG)) + XC
      CALL TIPE (T,YT,1,IPLUS,1,0)
      IF (ITC .LT. 0) GO TO 540
      L = TLTV(L) + .01
      CALL TYPINT (T,YL,1,L,1,0)
  540 CONTINUE
C
  545 CONTINUE
      CALL TIPE (0,0,0,0,0,+1)
  555 CONTINUE
      IF (IYGD.EQ.0 .OR. NTT.LE.0) GO TO 575
C
C     DRAW THE Y-DIRECTION GRID NETWORK.
C
      CALL AXIS (0,0,0,0,0,-1)
CWKBR 9/93 LOG = XTIC - 1.0 + SIGN(0.1,XTIC)
      LOG = XTIC - 1.0 + SIGN(0.1,XTIC) - 1
      K = 1
      DO 570 J = 1,NTT
      K = -K
      R = XTS + DTC*XDR*FLOAT(NTT-J)
      IF (K .GT. 0) CALL AXIS (R,YPL,R,YPS,IPSZ,0)
      IF (K .LT. 0) CALL AXIS (R,YPS,R,YPL,IPSZ,0)
      IF (LOGX.LE.0 .OR. LOGX.GT.10 .OR. J.EQ.NTT) GO TO 570
C
C     DRAW THE Y-DIRECTION GRID LINES WITHIN THIS LOGARITHMIC CYCLE.
C
      LOG = LOG + 1
      DO 565 I = 1,NITK
      L = ILL + NITK - I
      T = XDR*(ALOG10(TLTV(L))+FLOAT(LOG)) + XC
      K = -K
      IF (K .GT. 0) CALL AXIS (T,YPL,T,YPS,IPSZ,0)
      IF (K .LT. 0) CALL AXIS (T,YPS,T,YPL,IPSZ,0)
  565 CONTINUE
C
  570 CONTINUE
      CALL AXIS (0,0,0,0,0,+1)
C
C     PREPARE TO CREATE + LABEL ANY REQUESTED TIC MARKS IN THE
C     Y-DIRECTION.
C
  575 IF (ILTC.EQ.0 .AND. IYAX.NE.1 .AND. IRTC.EQ.0 .AND. IXGD.EQ.0)
     1    GO TO 130
      NDG = 0
      IF (LOGY .GT. 0) GO TO 580
      DTC = YDTC
      IF (DTC.GT.0. .AND. NYTT.GT.0) GO TO 577
      NTT = 0
      GO TO 585
  577 NTT = NYTT
      YTS = YTIC*YDR + YC
      IF (ILTC.LE.0 .AND. IRTC.LE.0) GO TO 585
      NDG  = MIN0(NYDG+1,6)
      EXPO = NDG + IYPR - 2
      NUMS = YTIC/10.**EXPO
      DL   = DTC/10.**EXPO
      LSTEP= MAX0(IYVS+1,1)
      GO TO 585
  580 NTT = LOGY + 1
      YTS = YTIC*YDR + YC
      DTC = 1.
      NDG = 4
      IF (LOGY .GT. 10) GO TO 585
      ILL = LTTP(LOGY)
      NITK= LTTN(LOGY)
C
  585 DO 655 K = 1,3
      LABEL = 1
      LOG = YTIC - 1.0 + SIGN(0.1,YTIC)
      GO TO (590,595,600), K
C
C     TICS + LABELS ON THE LEFT SIDE.
C
  590 ITC= ILTC
      XT = XPS
      XL = XT - CCH*FLOAT(NDG+1)
      GO TO 605
C
C     TICS ALONG THE Y-AXIS.
C
  595 ITC = 0
      IF (IYAX .EQ. 1) ITC = -1
      IF (ITC  .EQ. 0) GO TO 605
      XT = YINT*XDR + XC
      CALL AXIS (0,0,0,0,0,-1)
      CALL AXIS (XT,YPL,XT,YPS,IPSZ,0)
      GO TO 605
C
C     TICS + LABELS ON THE RIGHT SIDE.
C
  600 ITC= IRTC
      XT = XPL
      XL = XT + CCH
C
  605 IF (ITC.EQ.0 .OR. NTT.LE.0) GO TO 655
      CALL TIPE (0,0,0,0,0,-1)
      DO 645 J = 1,NTT
      S = YTS + DTC*YDR*FLOAT(J-1)
      CALL TIPE (XT,S,1,IPLUS,1,0)
      IF (LOGY .GT. 0) GO TO 630
      IF (ITC.LT.0 .OR. LABEL.NE.J) GO TO 645
C
C     LABEL THIS LINEAR TIC MARK.
C
      IFIELD = NDG
      RNUM   = NUMS + DL*FLOAT(J-1)
      IF (RNUM) 610,625,615
  610 IFIELD = IFIELD + 1
  615 T = ABS(RNUM)
      IF (T .GE. 1.E-4) GO TO 625
      IF (T .GE. 1.E-5) GO TO 620
      RNUM = 0.
      GO TO 625
  620 RNUM = SIGN(1.E-4,RNUM)
  625 CALL TYPFLT (XL,S,1,RNUM,-IFIELD,0)
      LABEL  = LABEL + LSTEP
      YLABEL = S
      GO TO 645
C
C     LABEL THIS LOGARITHMIC CYCLE TIC MARK.
C
  630 LOG = LOG + 1
      IF (ITC .LT. 0) GO TO 635
      I = LEP
      IF (LOG .LT. 0) I = LEM
      CALL PRINT (XL,S,1,I,1,0)
      CALL TYPINT (XL+3.*CCH,S,1,IABS(LOG),0,0)
  635 IF (LOGY.GT.10 .OR. J.EQ.NTT) GO TO 645
C
C     CREATE + LABEL THE LOGARITHMIC INTRACYCLE TIC MARKS WITHIN THIS
C     CYCLE.
C
      DO 640 I = 1,NITK
      L = ILL + I - 1
      T = YDR*(ALOG10(TLTV(L))+FLOAT(LOG)) + YC
      CALL TIPE (XT,T,1,IPLUS,1,0)
      IF (ITC .LT. 0) GO TO 640
      L = TLTV(L) + .01
      CALL TYPINT (XL,T,1,L,1,0)
  640 CONTINUE
C
  645 CONTINUE
      IF (ITC.LT.0 .OR. LOGY.GT.0) GO TO 650
      CALL TIPE (XL,YLABEL-CCV,1,IE,1,0)
      CALL TYPINT (XL+CCH,YLABEL-CCV,1,EXPO,0,0)
  650 CALL TIPE (0,0,0,0,0,+1)
  655 CONTINUE
      IF (IXGD.EQ.0 .OR. NTT.LE.0) GO TO 130
C
C     DRAW THE X-DIRECTION GRID NETWORK.
C
      CALL AXIS (0,0,0,0,0,-1)
      LOG = YTIC - 1.0 + SIGN(0.1,YTIC)
      K = 1
      DO 670 J = 1,NTT
      K = -K
      S = YTS + DTC*YDR*FLOAT(NTT-J)
      IF (K .GT. 0) CALL AXIS (XPS,S,XPL,S,IPSZ,0)
      IF (K .LT. 0) CALL AXIS (XPL,S,XPS,S,IPSZ,0)
      IF (LOGY.LE.0 .OR. LOGY.GT.10 .OR. J.EQ.NTT) GO TO 670
C
C     DRAW THE X-DIRECTION GRID LINES WITHIN THIS LOGARITHMIC CYCLE...
C
      LOG = LOG + 1
      DO 665 I = 1,NITK
      L = ILL + NITK - I
      T = YDR*(ALOG10(TLTV(L))+FLOAT(LOG)) + YC
      K = -K
      IF (K .GT. 0) CALL AXIS (XPS,T,XPL,T,IPSZ,0)
      IF (K .LT. 0) CALL AXIS (XPL,T,XPS,T,IPSZ,0)
  665 CONTINUE
C
  670 CONTINUE
      CALL AXIS (0,0,0,0,0,+1)
      GO TO 130
C
C     OUTPUT WARNING NESSAGES, CLOSE INPUT FILE AND PLOT TAPE AND RETURN
C
  920 RETURN
  925 WRITE (OUTAPE,1020) SWM
      GO TO 950
  930 WRITE (OUTAPE,1000) UWM,LTAPE
      GO TO 950
  940 WRITE (OUTAPE,980) UWM
  950 NLINES = NLINES + 2
      IF (NLINES .GE. NLPP) CALL PAGE
  960 CALL CLOSE (XYPLT,ICLSRW)
      IF (IOPN .NE. 0) CALL STPLOT (-1)
      RETURN
C
  980 FORMAT (A25,' 992, XYPLOT INPUT DATA FILE ID. RECORDS TOO SHORT.',
     1       '  XYPLOT ABANDONED.')
  990 FORMAT (A25,' 993, XYPLOT FOUND ODD NR. OF VALUES FOR DATA PAIRS',
     1       ' IN FRAME',I5,', CURVE NR.',I5,'.  LAST VALUE IGNORED.')
 1000 FORMAT (A25,' 994, XYPLOT OUTPUT FILE NAME ',A4,' NOT FOUND.',
     1       '  XYPLOT ABANDONED.')
 1010 FORMAT (A25,' 997, NR.',I4,'.  FRAME NR.',I5,' INPUT DATA ',
     1       'INCOMPATIBLE.  ASSUMPTIONS MAY PRODUCE INVALID PLOT.')
 1020 FORMAT (A27,' 998, XYPLOT PLOTTER OR FRAME MAY NOT CHANGE FOR ',
     1       'LOWER FRAME.  XYPLOT ABANDONED.')
      END

      SUBROUTINE ENCODE( II )
C
C     THIS SUBROUTINE CONVERTS THE DEGREE OF FREEDOM CODES AS GIVEN
C     IN BULK DATA FORM ( INTEGERS FROM 1-6 ) TO THE BIT PATTERN
C     USED IN SUBSTRUCTURE ANALYSIS.
C
      DIMENSION IDIV(6)
      DATA IDIV/ 100000 , 10000 , 1000 , 100 , 10 , 1 /
C
      ISUM = 0
      DO 1 I=1,6
      J = II/IDIV(I)
      IF( J .EQ. 0 ) GO TO 1
      ISUM = ISUM + 2 ** (J-1)
      II = II - J*IDIV(I)
 1    CONTINUE
      II = ISUM
      RETURN
      END

      SUBROUTINE GKAD1A (USETD,GO,GOD,SCR1,UE,UA,UD)
C
C     GKAD1A WILL EXPAND GO BY NULL MATRIX TO MAKE GOD, AND
C     AA-S TO D-S ADDING ZEROS FOR E-S
C
      INTEGER USETD,USET1,GO,GOD,IPV1(7),SCR1,CORE,BAA,B1DD
      COMMON /PATX  / LC,N,NO,N4,USET1
      COMMON /ZZZZZZ/ CORE(1)
      COMMON /PARMEG/ IA(7),IA11(7),IA12(7),IB11(7),IB12(7),NZ,IRULE
      COMMON /SYSTEM/ IDUM(54),IPREC
C
C
      IENT = 0
C
C     COMPUTE CORE FOR CALCV AND MERGE
C
   20 LC = KORSZ(CORE)
C
C     BUILD PART VECTOR
C
      USET1 = USETD
      CALL CALCV (SCR1,UD,UA,UE,CORE(1))
C
C     SET UP FOR MERGE
C
      NZ = LC
      IRULE = 0
      DO 10 I = 1,7
      IA11 (I) = 0
      IA   (I) = 0
      IA12 (I) = 0
      IB11 (I) = 0
      IB12 (I) = 0
   10 CONTINUE
      IPV1(1) = SCR1
      CALL RDTRL (IPV1)
      IF (IENT .NE. 0) GO TO 30
C
C     SET UP FOR 2 WAY MERGE
C
      IA11(1) = GO
      CALL RDTRL (IA11)
      IA(1) = GOD
      IA(2) = N+NO+N4
      IA(3) = IA11(3)
      IA(4) = IA11(4)
      IA(5) = IA11(5)
C     BUILD NULL COLUMN IN CORE
      I = 0
      CORE(  1) = 0
      CORE(I+2) = 1
      CORE(I+3) = IA(3)
      CORE(I+4) = 2
      CORE(I+5) = 1
      CORE(I+6) = 0
      CORE(I+7) = 0
      CALL MERGE (IPV1(1),CORE(1),CORE(1))
      CALL WRTTRL (IA)
   40 RETURN
C
C
      ENTRY GKAD1B (USETD,KAA,MAA,BAA,K4AA,K1DD,M1DD,B1DD,K41DD,UA,UE,
     1              UD,SCR1)
C     ================================================================
C
      IENT = 1
      GO TO 20
C
C     VECTOR MADE, SET UP MCB-S
C
   30 IA(2) = N+NO+N4
      IA(3) = IA(2)
      IA(4) = 6
      IA(5) = IPREC
      IA11(1) = KAA
      IA(1) = K1DD
      IOUT  = 1
      CALL RDTRL (IA11)
      IF (IA11(1) .GT. 0) GO TO 35
      K1DD = 0
      GO TO 31
   35 CALL MERGE (IPV1(1),IPV1(1),CORE(1))
      CALL WRTTRL (IA)
   31 GO TO (32,33,34,40), IOUT
   32 IOUT  = 2
      IA(1) = B1DD
      IA11(1) = BAA
      CALL RDTRL (IA11)
      IF (IA11(1) .GT. 0) GO TO 35
      B1DD = 0
      GO TO 31
   33 IOUT  = 3
      IA(1) = M1DD
      IA11(1) = MAA
      CALL RDTRL (IA11)
      IF (IA11(1) .GT. 0) GO TO 35
      M1DD = 0
      GO TO 31
   34 IOUT  = 4
      IA(1) = K41DD
      IA11(1) = K4AA
      CALL RDTRL (IA11)
      IF (IA11(1) .GT. 0) GO TO 35
      K41DD = 0
      GO TO 31
      END

      SUBROUTINE EQSOUT
C
C     THIS ROUTINE WRITES THE CONNECTION TRACE FOR A NEWLY COMBINED
C     PSEUDOSTRUCTURE.
C
      EXTERNAL        LSHIFT,RSHIFT,ANDF,ORF
      INTEGER         Z,SCORE,ORF,NBOT(7),NTOP(7),CNAM
      INTEGER         COMBO,IORDS(2)
      INTEGER         WORDS(6),IHD(64),STRING(32),ANDF,RSHIFT
      COMMON /CMB002/ JUNK(5),SCORE
      COMMON /CMB003/ COMBO(7,5),CONSET,IAUTO,TOLER,NPSUB,CONECT,TRAN,
     1                MCON,RESTCT(7,7),ISORT,ORIGIN(7,3),IPRINT
      COMMON /CMB004/ TDAT(6),NIPNEW,CNAM(2)
      COMMON /ZZZZZZ/ Z(1)
      COMMON /OUTPUT/ ITITL(96),IHEAD(96)
      COMMON /MACHIN/ MACH,IHALF
      DATA IHD/ 10*4H     , 4H   S , 4HUMMA , 4HRY O , 4HF PS , 4HEUDO ,
     1                      4HSTRU , 4HCTUR , 4HE CO , 4HNNEC , 4HTIVI ,
     2                      4HTIES , 12*4H           , 4HINTE , 4HRNAL ,
     2                      4H   I , 4HNTER ,
     3                      4HNAL  , 4H  DE , 4HGREE , 4HS OF ,
     4                      4H  ** ,5*4H****, 4H P S , 4H E U ,
     5                      4H D O , 4H S T , 4H R U , 4H C T , 4H U R ,
     6                      4H E   , 4H N A , 4H M E , 4H S * ,3*4H****,
     7                      3*4H      /
      DATA WORDS / 4HPOIN , 4HT NO , 4HFREE , 4HDOM  , 4HDOF  , 4HNO   /
      DATA IBLANK,NHEQSS  / 4H     , 4HEQSS /
C
      IF (ANDF(RSHIFT(IPRINT,11),1) .NE. 1) RETURN
      CALL SFETCH (CNAM,NHEQSS,1,ITEST)
      CALL SUREAD (Z(SCORE),-1,NOUT,ITEST)
      NCOMP = Z(SCORE+2)
      NWRD  = NOUT - 4
      ISTEQS= SCORE + NWRD
C
C     MOVE COMPONENT SUBSTRUCTURE NAMES INTO FIRST NWRD OF OPEN CORE.
C
      DO 100 I=1,NWRD
      II = I - 1
      Z(SCORE+II) = Z(SCORE+II+4)
  100 CONTINUE
      DO 1 I=1,32
      STRING(I) = IBLANK
    1 CONTINUE
      CALL PUSH (WORDS(1),STRING, 5,8,0)
      CALL PUSH (WORDS(5),STRING,17,8,0)
      CALL PUSH (WORDS(3),STRING,29,8,0)
      DO 2 I=1,NPSUB
      IORDS(1) = COMBO(I,1)
      IORDS(2) = COMBO(I,2)
      LOC = 39+11*(I-1)
      CALL PUSH (IORDS(1),STRING,LOC,8,0)
    2 CONTINUE
      DO 3 I=1,64
      IHEAD(I) = IHD(I)
    3 CONTINUE
      DO 4 I=65,96
      IHEAD(I) = STRING(I-64)
    4 CONTINUE
      CALL PAGE
C
C     COMPUTE FIRST AND LAST COMPONENT SUBSTRUCTURE ID NUMBERS
C     FOR EACH PSEUDOSTRUCTURE.
C
      NBOT(1) = 1
      DO 110 I=1,NPSUB
      NTOP(I) = NBOT(I) + COMBO(I,5) - 1
      II = I + 1
      IF (I .EQ. NPSUB) GO TO 110
      NBOT(II) = NTOP(I) + 1
  110 CONTINUE
C
C     READ EQSS INTO OPEN CORE STARTING AT LOCATION ISTEQS
C
      JJ    = 0
      ICOMP = 0
  180 ICOMP = ICOMP + 1
      IF (ICOMP .GT. NCOMP) GO TO 140
  170 CALL SUREAD (Z(ISTEQS+JJ+1),3,NOUT,ITEST)
      GO TO (130,120,140), ITEST
  130 CONTINUE
C
C     NORMAL ROUTE - PROCESS ENTRIES
C
      Z(ISTEQS+JJ) = ICOMP
      DO 160 J=1,NPSUB
      IF (ICOMP.GE.NBOT(J) .AND. ICOMP.LE.NTOP(J)) GO TO 150
  160 CONTINUE
  150 Z(ISTEQS+JJ) = ORF(LSHIFT(J,IHALF),Z(ISTEQS+JJ))
      JJ = JJ + 4
      GO TO 170
  120 GO TO 180
C
C     SORT ON INTERNAL POINT NUMBER
C
  140 CONTINUE
      Z(ISTEQS+JJ  ) = 0
      Z(ISTEQS+JJ+1) = 0
      Z(ISTEQS+JJ+2) = 0
      Z(ISTEQS+JJ+3) = 0
      CALL SORT (0,0,4,3,Z(ISTEQS),JJ)
      II   = 1
      ISIL = 1
      DO 200 I=1,JJ,4
      IF (Z(ISTEQS+I+1) .NE. Z(ISTEQS+I+5)) GO TO 210
      II = II + 1
      GO TO 200
  210 IW = 4*II
      IOFF = I - 1 - 4*(II-1)
      ICODE = Z(ISTEQS+IOFF+3)
      CALL DECODE (ICODE,STRING,NDOF)
      CALL EQOUT1 (Z(ISTEQS+IOFF),IW,Z(SCORE),NWRD,ISIL)
      ISIL = ISIL + NDOF
      II   = 1
  200 CONTINUE
      RETURN
      END

      INTEGER FUNCTION KHRFN1 (WORD1,I,WORD2,J)
C
C     CHARACTER-FUNCTIONS 1,2,3,4, AND 5 WERE WRITTEN BY G.CHAN/UNISYS
C     TO STANDARDIZE NASTRAN BCD-WORD BYTE PROCESSING.
C
C     NOTE - THE INPUT WORD(S) ARE INTEGERS OR REALS, HOLDING BCD TYPE
C            DATA. (NOT CHARACTER)
C            BYTE COUNTS FROM LEFT TO RIGHT
C
C     THESE FIVE CHARACTER FUNCTIONS ARE COMPLETELY MACHINE INDEPENDENT
C
C     KHRFN1 REPLACES THE I-TH BYTE OF WORD 1 BY THE J-TH BYTE OF WORD2
C     E.G.   WORD1=ABCD,    WORD2=1234
C            KHRFN1(WORD1,3,WORD2,2) GIVES  AB2D
C
C     ABSOLUTE VALUES OF I AND J ARE USED
C
C     THE CODE BELOW WORKS WITH ALL MACHINES.  HOWEVER, SEE THE
C     SIMPLIFIED VERSION FURTHER DOWN.
C
C     INTEGER      WORD1(1),WORD2(1),TEMP(2)
C     CHARACTER*8  TEMP8
C
C     TEMP(1) = WORD1(1)
C     TEMP(2) = WORD2(1)
C     CALL BCDKH2 (TEMP,TEMP8)
C     II = IABS(I)
C     JJ = IABS(J) + 4
C     TEMP8(II:II) = TEMP8(JJ:JJ)
C     CALL KHRBC2 (TEMP8,TEMP)
C     KHRFN1 = TEMP(1)
C
C     SIMPLIFIED VERSION
C
C     FOR MACHINES (CDC, IBM, VAX, AND GRAY) THAT ALLOW EQUIVALENCE
C     BETWEEN CHARACTERS AND INTEGER VARIABLES, THE FOLLOWING SIMPLIFIED
C     CODE CAN BE USED.
C
      INTEGER      WORD1(1),WORD2(1),TEMP1,TEMP2
      CHARACTER*4  TEMPC1,TEMPC2
C     CHARACTER*n  TEMPC1,TEMPC2
C        (WHERE n is 10 for CDC, 8 for 64-BIT UNIX and
C                     4 for VAX and IBM)
      EQUIVALENCE (TEMP1,TEMPC1), (TEMP2,TEMPC2)
C
      TEMP1 = WORD1(1)
      TEMP2 = WORD2(1)
      II = IABS(I)
      JJ = IABS(J)
      TEMPC1(II:II) = TEMPC2(JJ:JJ)
      KHRFN1 = TEMP1
      RETURN
C
C     DEC/ULTRIX VERSION
C     ==================
C     THE ABOVE VAX VERSION DOES NOT WORK IN DEC/ULTRIX(RISC)
C
C     INTEGER     TEMP1,TEMP2,WORD1,WORD2
C     CHARACTER*1 TMP1(4),TMP2(4)
C     EQUIVALENCE (TEMP1,TMP1(1)),(TEMP2,TMP2(1))
C
C     TEMP1 = WORD1
C     TEMP2 = WORD2
C     II = IABS(I)
C     JJ = IABS(J)
C     TMP1(II) = TMP2(JJ)
C     KHR = TEMP1
C     RETURN
C
C     CDC VERSION
C     ===========
C     THE CHARACTER OPERATIONS IN CDC MACHINE ARE EXTREMELY SLOW.
C     THE FOLLOWING CODE, USING SHIFT/AND/OR IS 2 TO 3 TIMES
C     FASTER
C
C     INTEGER       WORD1,WORD2,MASK1(4),MASK2(4),BLANK
C     DATA  MASK1 / O"77000000000000000000", O"00770000000000000000",
C    1              O"00007700000000000000", O"00000077000000000000"/
C     DATA  MASK2 / O"00777777000000000000", O"77007777000000000000",
C    1              O"77770077000000000000", O"77777700000000000000"/
C     DATA  BLANK / O"00000000555555555555"/
C
C     II = IABS(I)
C     JJ = IABS(J)
C     KK = (JJ-II)*6
C     JJ = SHIFT(WORD2,KK)
C     KK = AND(JJ,MASK1(II))
C     JJ = AND(WORD1,MASK2(II))
C     II = OR(JJ,KK)
C     KHRFN1 = OR(II,BLANK)
C     RETURN
C
C
C     UNIVAC VERSION (1988 ORIGINAL)
C     ==============================
C
C     INTEGER     WORD1(1),WORD2(1)
C     CHARACTER   W1(8)*1 ,W4*4, W8*8
C     EUIVALENCE  (W1(1),W4,W8)
C
C     WRITE  (W8,10) WORD1(1),WORD2(1)
C  10 FORMAT (2A4)
C     II = IABS(I)
C     JJ = IABS(J) + 4
C     W1(II) = W1(JJ)
C     READ (W4,20) KHRFN1
C  20 FORMAT (A4)
C     RETURN
C
      END

      SUBROUTINE HSBG(N,A,IA,B)
C
C     ..................................................................
C
C        SUBROUTINE HSBG
C
C        PURPOSE
C           TO REDUCE A REAL MATRIX INTO UPPER ALMOST TRIANGULAR FORM
C
C        USAGE
C           CALL HSBG(N,A,IA)
C
C        DESCRIPTION OF THE PARAMETERS
C           N      ORDER OF THE MATRIX
C           A      THE INPUT MATRIX, N BY N
C           IA     SIZE OF THE FIRST DIMENSION ASSIGNED TO THE ARRAY
C                  A IN THE CALLING PROGRAM WHEN THE MATRIX IS IN
C                  DOUBLE SUBSCRIPTED DATA STORAGE MODE.  IA=N WHEN
C                  THE MATRIX IS IN SSP VECTOR STORAGE MODE.
C
C        REMARKS
C           THE HESSENBERG FORM REPLACES THE ORIGINAL MATRIX IN THE
C           ARRAY A.
C
C        SUBROUTINES AND FUNCTION SUBPROGRAMS REQUIRED
C           NONE
C
C        METHOD
C           SIMILARITY TRANSFORMATIONS USING ELEMENTARY ELIMINATION
C           MATRICES, WITH PARTIAL PIVOTING.
C
C        REFERENCES
C           J.H. WILKINSON - THE ALGEBRAIC EIGENVALUE PROBLEM -
C           CLARENDON PRESS, OXFORD, 1965.
C
C     ..................................................................
C
      DIMENSION B(1)
      DOUBLE PRECISION A(1),PIV,S,T
C
C     MAKE THIS ROUTINE DOUBLE A AND B ARE SAME SPACE
C
      N2=N*N
      K=N2
      DO 10 I=1,N2
      A(K)=B(K)
10    K=K-1
      L=N
      NIA=L*IA
      LIA=NIA-IA
C
C        L IS THE ROW INDEX OF THE ELIMINATION
C
   20 IF(L-3) 360,40,40
   40 LIA=LIA-IA
      L1=L-1
      L2=L1-1
C
C        SEARCH FOR THE PIVOTAL ELEMENT IN THE LTH ROW
C
      ISUB=LIA+L
      IPIV=ISUB-IA
      PIV=DABS(A(IPIV))
      IF(L-3) 90,90,50
   50 M=IPIV-IA
      DO 80 I=L,M,IA
      T=DABS(A(I))
      IF(T-PIV) 80,80,60
   60 IPIV=I
      PIV=T
   80 CONTINUE
   90 IF(PIV) 100,320,100
100   IF(PIV-DABS(A(ISUB))) 180,180,120
C
C        INTERCHANGE THE COLUMNS
C
  120 M=IPIV-L
      DO 140 I=1,L
      J=M+I
      T=A(J)
      K=LIA+I
      A(J)=A(K)
  140 A(K)=T
C
C        INTERCHANGE THE ROWS
C
      M=L2-M/IA
      DO 160 I=L1,NIA,IA
      T=A(I)
      J=I-M
      A(I)=A(J)
  160 A(J)=T
C
C        TERMS OF THE ELEMENTARY TRANSFORMATION
C
  180 DO 200 I=L,LIA,IA
      A(I)=A(I)/A(ISUB)
200   CONTINUE
C
C        RIGHT TRANSFORMATION
C
      J=-IA
      DO 240 I=1,L2
      J=J+IA
      LJ=L+J
      DO 220 K=1,L1
      KJ=K+J
      KL=K+LIA
      A(KJ)=A(KJ)-A(LJ)*A(KL)
220   CONTINUE
  240 CONTINUE
C
C        LEFT TRANSFORMATION
C
      K=-IA
      DO 300 I=1,N
      K=K+IA
      LK=K+L1
      S=A(LK)
      LJ=L-IA
      DO 280 J=1,L2
      JK=K+J
      LJ=LJ+IA
      S=S+A(LJ)*A(JK)
280   CONTINUE
  300 A(LK)=S
C
C        SET THE LOWER PART OF THE MATRIX TO ZERO
C
      DO 310 I=L,LIA,IA
  310 A(I)=0.0
  320 L=L1
      GO TO 20
  360 RETURN
      END

      SUBROUTINE PAGE
C
C     MASTER PAGING ROUTINE FOR NASTRAN.
C
      INTEGER         OTPE,DATE,CRDATE,SYM,TITLEX(18),NAME(2),FCHAR
      CHARACTER       MONTH(12)*3,AHEAD*30,MCHNAM*11,MACHOS*7
      COMMON /CHMACH/ MCHNAM, MACHOS
      COMMON /MACHIN/ MACH(4)
      COMMON /SYSTEM/ SYSBUF,OTPE,MPCN(3),SPCN,METHOD,LOADN,SYM,ST,
     1                IPAGE,LINE,ITLINE,MAXLIN,DATE(3),DUM15(15),IOFP,
     2                X(8),CRDATE(3)
      COMMON /OUTPUT/ TITLE(32),SUBTIT(32),LABEL(32),HEAD1(32),
     1                HEAD2(32),HEAD3(32)
      EQUIVALENCE     (TITLEX(1),TITLE(1))
      DATA    MONTH /'JAN', 'FEB', 'MAR', 'APR', 'MAY', 'JUN', 
     1               'JUL', 'AUG', 'SEP', 'OCT', 'NOV', 'DEC'/
      DATA    NAME  / 4HPAGE, 4H    /
C
      IOUT  = 1
   10 IPAGE = IPAGE  + 1
      ITLINE= ITLINE + LINE
      LINE  = 0
      IF (ITLINE .GT. MAXLIN) GO TO 70
      IN = DATE(1)
C
C   ASSEMBLE PAGE HEADING
C
      AHEAD = ' '
      NCMNAM = INDEX(MCHNAM,' ') - 1
      IF (NCMNAM .LE. -1) NCMNAM = 11
      NCMOS  = INDEX(MACHOS,' ') - 1
      IF (NCMOS .LE. -1) NCMOS = 7
      FCHAR = (18 - NCMNAM - NCMOS)/2 + 1
      WRITE (AHEAD(FCHAR:FCHAR+1),15) CRDATE(3)
   15 FORMAT (A2)
      FCHAR = FCHAR + 3
      AHEAD(FCHAR:30) = MCHNAM(1:NCMNAM) // ' ' // MACHOS(1:NCMOS) //
     1 ' NASTRAN'
C
      WRITE  (OTPE,20) TITLEX, AHEAD, MONTH(IN),DATE(2),DATE(3),IPAGE
   20 FORMAT (1H1,4X,17A4,A2,' /',A30,'/ ',A3,1X,I2,', ',I2, 
     1        ' / PAGE',I6)
      WRITE  (OTPE,30) SUBTIT
   30 FORMAT (5X,31A4,A3)
      WRITE  (OTPE,40) LABEL
   40 FORMAT (1H0,4X,31A4,A3)
      LINE = LINE + 4
      IF (IOUT .EQ.0) GO TO 60
      WRITE (OTPE,40) (HEAD1(I),I=1,32)
      WRITE (OTPE,30) (HEAD2(I),I=1,32)
      WRITE (OTPE,30) (HEAD3(I),I=1,32)
      LINE = LINE + 4
   60 RETURN
C
C     MAX LINES EXCEEDED.  BUMP MAXLINES BY 3000 AND CALL MESAGE
C
   70 MAXLIN = MAXLIN + 3000
      CALL MESAGE (-19,ITLINE,NAME)
      GO TO 60
C
C
      ENTRY PAGE1
C     ===========
C
      IOUT = 0
      GO TO 10
      END

      SUBROUTINE FRRD2
C
C     AEROELASTIC FREQUENCY RESPONSE SOLUTION MODULE
C
C     INPUTS      KHH,BHH,MHH,QHHL,PHF,FOL
C
C     OUTPUT      UHVF
C
C     SCRATCHES   NINE
C
C     PARAMETERS    BOV - REAL - INPUT
C                   Q   - REAL - INPUT
C                   M   - REAL - INPUT
C
C     COMMON FRD2BC WILL BE USED BY ROUTINES FRD2B AND FRD2C.
C
      INTEGER         BHH,QHHL,PHF,FOL,UHVF,
     1                SCR1,SCR2,SCR3,SCR4,SCR5,SCR6,SCR7,SCR8,SCR9,
     2                SYSBUF,IZ(1),MCB(7),NAME(2),PASS,ITAB(5)
      REAL            M,ZZZ(1)
      COMPLEX         A1,A2,A3,A4,A5
      COMMON /CONDAS/ PHI,TWOPI
      COMMON /FRRDST/ OVF(150),ICNT,IFRST
      COMMON /BLANK / BOV,Q,M
      COMMON /SYSTEM/ SYSBUF
      COMMON /CDCMPX/ DUMM32(32),IB
      COMMON /FRD2BC/ IH,IPFRDC
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE     (ZZZ(1),Z(1))
      EQUIVALENCE     (IZ(1) ,Z(1))
      DATA    KHH ,BHH ,MHH ,QHHL,PHF ,FOL, UHVF/
     1        101 ,102 ,103 ,104 ,105 ,106, 201 /
      DATA    SCR1,SCR2,SCR3,SCR4,SCR5,SCR6,SCR7,SCR8,SCR9/
     1        301 ,302 ,303 ,304 ,305 ,306 ,307 ,308 ,309 /
      DATA    NAME  / 4HFRRD,4H2   /
C     DATA    PASS  / 0 /
C
C     SETUP
C
      SCR9   = 309
      PASS   = 0
      IB     = 0
      IH     = 0
      IPFRDC = 0
      NZ     = KORSZ(Z)
      IBUF1  = NZ - SYSBUF - 1
      NZ     = NZ - SYSBUF
      NONCUP = 1
      MCB(1) = QHHL
      CALL RDTRL (MCB)
      IF (MCB(1).LE.0 .OR. Q.EQ.0.0) NONCUP = -1
C
C     IF QHHL IS PURGED AND MACH NUMBER IS NEGATIVE, THE COUPLED EQU.
C     (-M*W**2 + IW*B + K)*U = P IS SOLVED. COMPLEX D.P. IS USED.
C     THE VARIABLE IH WILL BE USED TO CONTROL SOLUTION LOGIC IN
C     ROUTINES FRRD2, FRD2B AND FRD2C.
C
      IF (MCB(1).LE.0 .AND. M.LT.0.0) NONCUP = 1
C
      MCB(1) = PHF
      CALL RDTRL (MCB)
      I = PHF
      IF (MCB(1) .LT. 0) GO TO 920
      I = FOL
      CALL OPEN (*920,FOL,IZ(IBUF1),0)
      CALL READ (*910,*10,FOL,IZ,2,0,NFREQ)
      CALL READ (*910,*10,FOL,IZ,NZ,0,NFREQ)
      CALL MESAGE (-8,0,NAME)
   10 CONTINUE
      CALL CLOSE (FOL,1)
      NLOAD = MCB(2)/NFREQ
      IF (NONCUP .EQ. -1) GO TO 200
      IF (NFREQ.EQ.1 .OR. NLOAD.EQ.1) SCR9 = UHVF
      ICNT  = 0
      IFRST = 0
C
C     BUILD INTERPOLATION MATRIX - ON SCR1
C
      CALL FRD2I (IZ(1),NFREQ,NZ+SYSBUF,QHHL,SCR1,SCR2,SCR3,SCR4,IH)
      NTO  = 0
      IHH  = MCB(3)
      ICOR = KORSZ(ZZZ) - 6*SYSBUF - 3
      NCORE= 2*(IH*IH + 2*(IHH*NLOAD)) + 50
      ICOR = ICOR - NCORE
C
C     IF IH = 0, COMPLEX D.P. COMPUTATION WILL BE USED.  NOTICE THAT THE
C     ROUTINE INCORE IS WRITTEN ONLY FOR COMPLEX S.P. OPERATION.
C
      IF (IH.EQ.0 .OR. ICOR.LT.500) GO TO 20
      NTO     = 1
      ITAB(1) = MHH
      ITAB(2) = BHH
      ITAB(3) = KHH
      ITAB(4) = PHF
      ITAB(5) = SCR1
      IHH     = 4
      IF (IH .NE. 0) IHH = 5
      CALL OPEN  (*21,MHH,IZ(IBUF1),0)
   21 CALL CLOSE (MHH,1)
      CALL OPEN  (*22,BHH,IZ(IBUF1),0)
   22 CALL CLOSE (BHH,1)
      CALL OPEN  (*23,KHH,IZ(IBUF1),0)
   23 CALL CLOSE (KHH,1)
      CALL OPEN  (*24,PHF,IZ(IBUF1),0)
   24 CALL CLOSE (PHF,1)
   20 CONTINUE
C
C     LOOP ON FREQUENCY
C
      DO 40 I = 1,NFREQ
C
C     PICK UP FREQUENCY
C
      IF (I .LE. ICNT+IFRST-1) GO TO 30
      CALL GOPEN  (FOL,IZ(IBUF1),0)
      CALL BCKREC (FOL)
      CALL FREAD  (FOL,OVF,-(I-1)-2,0)
      ICNT = MIN0(150,NFREQ-I+1)
      CALL FREAD (FOL,OVF,ICNT,0)
      IFRST = I
      CALL CLOSE (FOL,1)
   30 CONTINUE
      K = I - IFRST + 1
      W = OVF(K)*TWOPI
      IF (IH .EQ. 0) GO TO 35
C
C     INTERPOLATE QHHL
C
      CALL FRD2A (SCR1,SCR2,SCR3,IH,I)
      GO TO 38
   35 CONTINUE
C
C     CREATE NULL TRAILERS FOR SCR2 (QHR) AND SCR3 (QHI) IF IH = 0.
C     (THESE DATA BLOCKS ARE NORMALLY GENERATED BY FRD2A IF IH .NE. 0.
C     SINCE FRD2A IS NOT EXECUTED WHEN IH = 0, AND SINCE SCR2 AND SCR3
C     ARE ALSO USED BY FRD2C, WE NEED TO CLEAR THE TRAILERS.)
C
      CALL MAKMCB (MCB,SCR2,0,0,0)
      CALL WRTTRL (MCB)
      MCB(1) = SCR3
      CALL WRTTRL (MCB)
C
   38 CONTINUE
C
C     FOR DYNAMIC MATRIX
C
      A1 = CMPLX(-W*W,0.0)
      A2 = CMPLX(0.0,W)
      A3 = CMPLX(0.0,-W*Q*BOV)
      A4 = CMPLX(1.0,0.0)
      A5 = CMPLX(-Q,0.0)
      CALL FRD2B (MHH,A1,BHH,A2,SCR3,A3,KHH,A4,SCR2,A5,SCR4)
C
C     DECOMPOSE SCR4 AND SOLVE
C
      CALL FRD2C (SCR4,PHF,SCR7,SCR2,SCR3,SCR5,SCR6,SCR8,NLOAD,I)
C
C     COPY TO TEMPORARY UHVF
C
      CALL FRD2D (SCR7,SCR9,PASS)
      PASS = PASS + 1
   40 CONTINUE
      IF (NFREQ.EQ.1 .OR. NLOAD.EQ.1) GO TO 100
      CALL FRD2E (SCR9,UHVF,NLOAD,NFREQ)
C
C     FORM FINAL ANSWER
C
  100 RETURN
C
C     UNCOUPLED MODAL
C
  200 CONTINUE
C
C     THE FREQUENCIES FOL (ALREADY IN IZ ARRAY) IS CONVERTED FROM CPS
C     TO RADIAN UNITS (FRL), AND SAVED IN SCR1.  NO TRAILER NEEDED.
C
      CALL GOPEN (SCR1,IZ(IBUF1),1)
      DO 210 I = 1,NFREQ
      Z(I) = Z(I)*TWOPI
  210 CONTINUE
      CALL WRITE (SCR1,Z,NFREQ,1)
      CALL CLOSE (SCR1,1)
      CALL FRD2F (MHH,BHH,KHH,SCR1,1,NLOAD,NFREQ,PHF,UHVF)
      GO TO 100
  910 CALL MESAGE (-3,FOL,NAME)
  920 CALL MESAGE (-1,I,NAME)
      RETURN
      END

      SUBROUTINE ASCM01 (NAME,IPHASE,ISOL,NOGO)
C
C     SUBSTRUCTURE COMMAND DMAP DATA
C
C     COMMENTS FROM G.CHAN/UNISYS   8/1991
C     IN SOME UNIX MACHINES, SUCH AS SiliconGraphics, THE FORTRAN
C     COMPILER IS A SUBSET OF THE C COMPILER. THE SYMBOL /* IS A COMMENT
C     MARKER FOR C, AND ANYTHING AFTER /* IS NOT PASS OVER TO THE
C     FORTRAN COMPILER. THEREFORE, ALL /* SYMBOLS IN RDMAP ARRAY ARE
C     REPLACED BY
C     THE ! WILL BE CHANGED BACK TO / IN THE EXECUTABLE CODE.
C
      INTEGER         COMND(6,3),XTRA(3),SUBNAM(2),ISAVE(21),
     1                RDMAP(18,29),RDMAP1(18,9),RDMAP2(18,9),
     2                RDMAP3(18,9),RDMAP4(18,2),OCT(3,13),OCT1(3,13),
     3                PTBS(7,16),PTBS1(7,16)
      COMMON /PHAS11/ IPAS11(8)
      COMMON /PHAS31/ IPAS31(2)
      COMMON /ASDBD / IRDM,NRDM,IXTRA,NXTRA,IOCT,NOCT,IPTBS,NPTBS,
     1                IPH,NPH,IDAT(684)
      EQUIVALENCE     (RDMAP1(1,1),RDMAP(1, 1)),(OCT1(1,1),OCT(1,1)),
     1                (RDMAP2(1,1),RDMAP(1,10)),(PTBS1(1,1),PTBS(1,1)),
     2                (RDMAP3(1,1),RDMAP(1,19)),
     3                (RDMAP4(1,1),RDMAP(1,28))
      DATA COMND    /
     1                4HSUBS    , 29    ,  3    , 13    , 16    ,  8  ,
     2                4HSUBS    ,  8    ,  1    ,  0    ,  3    ,  0  ,
     3                4HSUBS    ,  8    ,  1    ,  0    ,  3    ,  2  /
      DATA SLASH    / 1H/       /
      DATA ISAVE    /
     1     3,13,1, 19,8,2, 26,13,3, 26,15,2, 26,17,1, 27,5,1, 28,4,3  /
      DATA RDMAP 1  /
     1 4HALTE,4HR   ,4H  (B,4HEGIN,4H) $ ,13*4H    ,
     2 4HPARA,4HM   ,4H  //,4H*NOP,4H*/AL,4HLWAY,4HS=-1,4H $  ,4H    ,
     * 4H    ,8*4H    ,
     3 4HSGEN,4H    ,4H  CA,4HSECC,4H,,,/,4HCASE,4HSS,C,4HASEI,4H,,,,,
     * 4H,,,,,4H/S,N,4H,DRY,4H!*XX,4HXXXX,4HXX*/,4HS,N,,4HLUSE,4HT/  ,
     4 4H    ,4H    ,4H  S,,4HN,NO,4HGPDT,4H $  ,12*4H    ,
     5 4HEQUI,4HV   ,4H  CA,4HSEI,,4HCASE,4HCC/A,4HLLWA,4HYS $,4H    ,
     * 4H    ,8*4H    ,
     6 4HALTE,4HR   ,4H  (A,4HFTGP,4H4) $,13*4H    ,
     7 4HPARA,4HM   ,4H  //,4H*ADD,4H*/DR,4HY/-1,4H /0 ,4H$   ,4H    ,
     * 4H    ,8*4H    ,
     8 4HLABE,4HL   ,4H  LB,4HSBEG,4H $  ,13*4H    ,
     9 4HCOND,4H    ,4H  LB,4HLIS,,4HDRY ,4H$   ,12*4H    /
      DATA RDMAP 2  /
     O 4HSSG1,4H    ,4H  SL,4HT,BG,4HPDT,,4HCSTM,4H,SIL,4H,EST,4H,MPT,
     * 4H,GPT,4HT,ED,4HT,MG,4HG,CA,4HSECC,4H,DIT,4H,/PG,4H,,,,,4H/   ,
     1 4H    ,4H    ,4H  LU,4HSET/,4HNSKI,4HP $ ,12*4H    ,
     2 4HCHKP,4HNT  ,4H  PG,4H $  ,14*4H    ,
     3 4HALTE,4HR   ,4H  (S,4HOLVE,4H) $ ,13*4H    ,
     4 4HSSG2,4H    ,4H  US,4HET,G,4HM,,K,4HFS,G,4HO,,P,4HG/QR,4H,PO,,
     * 4HPS,P,4HL $ ,7*4H    ,
     5 4HCHKP,4HNT  ,4H  PO,4H,PS,,4HPL $,13*4H    ,
     6 4HLABE,4HL   ,4H  LB,4HLIS ,4H$   ,13*4H    ,
     7 4HALTE,4HR   ,4H  (S,4HDR) ,4H$   ,13*4H    ,
     8 4HSUBP,4HH1  ,4H  CA,4HSECC,4H,EQE,4HXIN,,4HUSET,4H,BGP,4HDT,C,
     * 4HSTM,,4HGPSE,4HTS,E,4HLSET,4HS//S,4H,N,D,4HRY/ ,4H    ,4H    /
      DATA RDMAP 3  /
     9 4H    ,4H    ,4H  *N,4HAME ,4H   *,4H/XPL,4HOTID,4H !*P,4HVEC*,
     * 4H $  ,8*4H    ,
     O 4HCOND,4H    ,4H  LB,4HSEND,4H,DRY,4H $  ,12*4H    ,
     1 4HEQUI,4HV   ,4H  PG,4H,PL/,4HNOSE,4HT $ ,12*4H    ,
     2 4HCOND,4H    ,4H  LB,4HL10,,4HNOSE,4HT $ ,12*4H    ,
     3 4HSSG2,4H    ,4H  US,4HET,G,4HM,YS,4H,KFS,4H,GO,,4H,PG/,4HQR,P,
     * 4HO,PS,4H,PL ,4H$   ,6*4H    ,
     4 4HCHKP,4HNT  ,4H  PO,4H,PS,,4HPL $,13*4H    ,
     5 4HLABE,4HL   ,4H  LB,4HL10 ,4H$   ,13*4H    ,
     6 4HSOFO,4H    ,4H  ,K,4HAA,M,4HAA,P,4HL,BA,4HA,K4,4HAA//,4HS,N,,
     * 4HDRY/,4H*XXX,4HXXXX,4HX*!*,4HKMTX,4H*!*M,4HMTX*,4H!*PV,4HEC*/,
     7 4H    ,4H    ,4H  *B,4HMTX*,4H!*K4,4HMX* ,4H$   ,4H    ,4H    ,
     * 4H    ,8*4H    /
      DATA RDMAP 4  /
     8 4HLODA,4HPP  ,4H  PL,4H,/!*,4HNAME,4H    ,4H*/S,,4HN,DR,4HY $ ,
     * 4H    ,8*4H    ,
     9 4HEQUI,4HV   ,4H  CA,4HSESS,4H,CAS,4HECC/,4HALWA,4HYS $,4H    ,
     * 4H    ,8*4H    /
      DATA XTRA     /
     1 4HSAVE,4HNAME,4HRUN      /
      DATA OCT 1    /
     1                     9    ,    524288    ,         0     ,
     2                    10    ,    983040    ,        12     ,
     3                    11    ,    983040    ,        12     ,
     4                    12    ,    983040    ,        12     ,
     5                    14    ,    983040    ,        12     ,
     6                    15    ,    983040    ,        12     ,
     7                    16    ,    524288    ,         0     ,
     8                    21    ,   1572864    ,        12     ,
     9                    22    ,   1572864    ,        12     ,
     O                    23    ,   1572864    ,        12     ,
     1                    24    ,   1572864    ,        12     ,
     2                    25    ,   1572864    ,        12     ,
     3                    28    ,    524288    ,         8     /
      DATA PTBS 1   /
     1           1  , 11  , 11  ,  7  ,     4  ,         0  ,  0  ,
     2           6  , 11  , 11  ,  8  ,     1  ,         0  ,  0  ,
     3           7  , 22  , 23  ,  3  ,4HRUN   ,         0  ,  0  ,
     4          13  , 11  , 11  ,  7  ,     2  ,         0  ,  0  ,
     5          17  , 11  , 11  ,  5  ,     3  ,         0  ,  0  ,
     6          19  , 11  , 12  ,  8  ,4HNAME  ,         0  ,  0  ,
     7          19  , 21  , 22  ,  8  ,4HSAVE  ,         0  ,  0  ,
     8          19  , 30  , 32  ,  4  ,4HPITM  ,    524300  ,  0  ,
     9          26  , 12  , 15  ,  0  ,4HNAME  ,         1  ,  0  ,
     O          26  , 16  , 19  ,  0  ,4HNAME  ,         2  ,  0  ,
     1          26  , 20  , 22  ,  0  ,4HNAME  ,        12  ,  0  ,
     2          26  , 23  , 26  ,  0  ,4HNAME  ,        16  ,  0  ,
     3          26  , 27  , 31  ,  0  ,4HNAME  ,        32  ,  0  ,
     4          26  , 40  , 42  ,  8  ,4HNAME  ,         0  ,  0  ,
     5          26  , 65  , 67  ,  4  ,4HPITM  ,    524288  ,  0  ,
     6          28  , 15  , 17  ,  8  ,4HNAME  ,         0  ,  0  /
      DATA SUBNAM   / 4HASCM,2H01  /
C
C     RESTORE ORIGINAL DATA BY REPLACING ! BY / IN RDMAP
C
      DO 20 L = 1,21,3
      I = ISAVE(L+1)
      J = ISAVE(L  )
      K = ISAVE(L+2)
      RDMAP(I,J) = KHRFN1(RDMAP(I,J),K,SLASH,1)
   20 CONTINUE
C
C     VALIDATE COMMAND AND SET POINTERS
C
      IF (NAME .NE. COMND(1,IPHASE)) GO TO 1000
      ICOMND = IPHASE
      IRDM   = 1
      NRDM   = COMND(2,ICOMND)
      IXTRA  = IRDM  + 18*NRDM
      NXTRA  = COMND(3,ICOMND)
      IOCT   = IXTRA + NXTRA
      NOCT   = COMND(4,ICOMND)
      IPTBS  = IOCT  + 3*NOCT
      NPTBS  = COMND(5,ICOMND)
      IPH    = IPTBS + 7*NPTBS
      NPH    = COMND(6,ICOMND)
C
C     MOVE RDMAP DATA
C
      K = 0
      IF (NRDM .EQ. 0) GO TO 35
      DO 30 J = 1,NRDM
      DO 30 I = 1,18
      K = K + 1
   30 IDAT(K) = RDMAP(I,J)
   35 CONTINUE
C
C      MOVE XTRA DATA
C
      IF (NXTRA .EQ. 0) GO TO 45
      DO 40 I = 1,NXTRA
      K = K + 1
   40 IDAT(K) = XTRA(I)
   45 CONTINUE
C
C     MOVE OCT DATA
C
      IF (NOCT .EQ. 0) GO TO 55
      DO 50 J = 1,NOCT
      DO 50 I = 1,3
      K = K + 1
   50 IDAT(K) = OCT(I,J)
   55 CONTINUE
C
C     MOVE PTBS DATA
C
      IF (NPTBS .EQ. 0) GO TO 65
      DO 60 J = 1,NPTBS
      DO 60 I = 1,7
      K = K + 1
   60 IDAT(K) = PTBS(I,J)
   65 CONTINUE
C
C     MOVE PHASE 1 DATA
C
      IF (IPHASE.NE.1 .OR. NPH.EQ.0) GO TO 80
      DO 70 I = 3,8
      K = K + 1
   70 IDAT(K) = IPAS11(I)
      DO 75 I = 1,2
      K = K + 1
      IDAT(K) = IPAS11(I)
   75 CONTINUE
      GO TO 200
   80 CONTINUE
C
C     MOVE PHASE 3 DATA
C
      IF (IPHASE.NE.3 .OR. NPH.EQ.0) GO TO 200
      DO 110 I = 1,NPH
      K = K + 1
  110 IDAT(K) = IPAS31(I)
C
  200 RETURN
C
C     INPUT ERROR
C
 1000 CALL MESAGE (7,0,SUBNAM)
      NOGO = 1
      RETURN
C
      END

        SUBROUTINE DSRLSE
      INCLUDE 'DSIOF.COM'
      INCLUDE 'GINOX.COM'
      INEXT  = IFILEX
10    NEXDSN = IAND( MDSFCB( 3,INEXT ), MASKH2 )
      IF ( NEXDSN .EQ. 0 ) GO TO 20
      MDSFCB( 1, INEXT ) = IAND( MDSFCB( 1,INEXT ), MASKH1 )
      MDSFCB( 2, INEXT ) = 0
      MDSFCB( 3, INEXT ) = 0
C
C OPEN AND CLOSE FILE TO DELETE SPACE ALLOCATION
C
      CALL DSOPEN ( MDSNAM(NEXDSN), NEXDSN, 1 )
      CALL DSCLOS ( NEXDSN )
      INEXT  = NEXDSN
      GO TO 10
20    RETURN
        END

        SUBROUTINE PUTSTR ( BLOCK )
********************************************************
*
*       FORMAT OF THE I/O MATRIX CONTROL TABLE
*
*    WORD    QUARTER            DESCRIPTION
*       1       -       GINO FILE NAME
*       2       -       TYPE OF ELEMENTS (1,2,3,4) - REFERS TO TYPE
*                       BEING WRITTEN (BLDPK--) TO THE BUFFER OR
*                       TYPE OF ELEMENTS READ (INTPK--) FROM THE BUFFER
*       3       -       TRAILERS TO BE INCLUDED (0=NO,1=YES) ON WRITE
*                       TO BUFFER OR ARE INCLUDED ON READ FROM BUFFER
*       4       -       ROW NUMBER
*       5       -       INDEX TO STRING (RELATIVE TO /XNSTRN/)
*       6       -       NUMBER OF ELEMENTS AVAIL. OR  RESIDE IN STRING
*       7       -       NUMBER OF ELEMENTS WRITTEN TO STRING BY USER
*       8       -       BEGIN/END FLAG (-1, FIRST CALL FOR COLUMN,
*                       =0, INTERMEDIATE CALL; =1, LAST CALL)
*       9       -       INTERIM FLAG FOR COLUMN ('C','P','X')
*       10      -       COUNT OF NON-ZERO WORDS PER COLUMN
*       11      -       NUMBER OF WORDS PER ELEMENT (SEE WORD 2)
*       12      -       COLUMN NUMBER
*       13      -       TYPE OF INPUT (BLDPK) OR OUTPUT (INTPK)
*       14      -       DIVISOR FOR COMPUTING BLOCK(5)
*       15      -       ROW NUMBER ON INPUT (BLDPK)
*
**********************************************************************
      INCLUDE 'DSIOF.COM'
      INCLUDE 'XNSTRN.COM'
        INTEGER BLOCK( 15 ), IDIV( 4 )
        DATA    IDIV / 1, 2, 1, 2 /
        NAME = BLOCK( 1 )
        CALL DSGEFL
        LIM  = INDBAS + NBUFF + 2
        IF ( BLOCK( 8 ) .EQ. -1 ) GO TO 10
        NWORDS = BLOCK( 11 )
        IFLG = BLOCK( 9 )
        GO TO 30
10      NWORDS = NWRDEL( BLOCK( 2 ) )
        BLOCK( 14 ) = IDIV( BLOCK( 2 ) )
        BLOCK( 11 ) = NWORDS
        BLOCK(  8 ) = 0
        BLOCK(  9 ) = IDSC
        IFLG = IDSC
        IF ( ( LIM-INDCBP-6-BLOCK(3)*2 ).GE. NWORDS ) GO TO 20
        IBASE( INDCBP ) = IDSEB
        CALL DSWRNB
        LIM  = INDBAS + NBUFF + 2
20      IBASE( INDCBP+1 ) = IDSCH +  BLOCK( 3 )*MULQ3 + BLOCK( 2 )
        IBASE( INDCBP+2 ) = BLOCK( 12 )
        INDCBP = INDCBP + 2
30      NLR = IABS( MOD( INDCBP+2, BLOCK( 14 ) ) )
        NELM = ( LIM - INDCBP - NLR - 6 - BLOCK( 3 )*2 ) / NWORDS
        IF ( NELM .GE. 1 ) GO TO 50
        IFLG = BLOCK( 9 )
        IF ( IFLG .EQ. IDSX ) GO TO 40
        IFLG = IDSP
        BLOCK( 9 ) = IDSX
40      IBASE( INDCLR ) = IDSSB + IFLG + ( INDCBP - INDCLR )
        IBASE( INDCBP + 1 ) = IDSRT + IFLG + ( INDCLR-INDBAS+1 )
        IBASE( INDCBP + 2 ) = IDSEB
        INDCLR = INDCBP + 2
        CALL DSWRNB
        LIM  = INDBAS + NBUFF + 2
        GO TO 30
50      BLOCK( 6 ) = NELM
        BLOCK( 7 ) = 0
        BLOCK( 5 ) = ( INDCBP+NLR+2 ) / BLOCK( 14 ) + 1
        IF ( NLR .EQ. 0 ) GO TO 70
        IBASE( INDCBP + 1 ) = IDSSD
        INDCBP = INDCBP + 1
70      CALL DSSDCB
        RETURN
        END

      SUBROUTINE TRLGD(FCT,FCO,AP,AS,AD,AH,
     1     PPO,PSO,PDO,PDT,PHT,IFLAG1,SCR1,IFLAG      )
C
C     THE PURPOSE OF THIS SUBROUTINE IS TO COMPUTE LOAD FACTORS
C         BOTH AT APPLIED TIMES(T) AND OUTPUT TIMES(O).
C
C     INPUTS (6)
C
C       FCT --MATRIX OF TIME FUNCTIONS--ALL TIMES
C       FCO --MATRIX OF TIME FUNCTIONS--OUTPUT TIMES
C       IFLAG =-1   IMPLIES FCT = FCO AND ONLY FCT EXISTS
C         NOTE THAT ALSO IMPLIES PDO = PDT
C       AP,AS,AD,AH  ARE TRANSFORMATION MATRICIES TO P,S,D,AND H SET RES
C
C     OUTPUTS (5)
C       PPO,PSO,PDO  LOADS AT OUTPUT TIMES(ANY MAY NOT EXIST)
C       PDT,PHT      LOADS AT ALL TIMES (ANY MAY NOT EXIST)
C
C     SCR1          SCRATCH FILE FOR MPYAD
C
C     IFLAG1 =-1  IMPLIES THAT AP = AD
C
C     FCT MAY BE FCO, IN CASE OF EQUALITY THE T FILES WILL EXIST
C
      INTEGER  FCT,FCO,AP,AS,AD,AH,PPO,PSO,PDT,PHT,SCR1,MCB(7)
     1, TRNSP,SIGN,PREC,PDO
C
      COMMON /SYSTEM/ISKIP(54),IPREC
C
      SIGN = +1
      TRNSP = 0
      PREC = IPREC
C
C     FORM PPO
C
      MCB(1) = PPO
      CALL RDTRL(MCB)
      IF(MCB(1) .LE. 0) GO TO 10
      CALL SSG2B(AP,FCO,0,PPO,TRNSP,PREC,SIGN,SCR1)
      MCB(1) = PPO
      CALL RDTRL(MCB)
      MCB(2) = MCB(2) -1
      CALL WRTTRL(MCB)
   10 CONTINUE
C
C     FORM   PSO
C
      MCB(1) = PSO
      CALL RDTRL(MCB)
      IF (MCB(1) .LE. 0) GO TO 20
      MCB(1) = AS
      CALL RDTRL(MCB)
      IF (MCB(2) .LE. 0)  GO TO 20
      CALL SSG2B(AS,FCO,0,PSO,TRNSP,PREC,SIGN,SCR1)
      MCB(1) = PSO
      CALL RDTRL(MCB)
      MCB(2) = MCB(2) -1
      CALL WRTTRL(MCB)
   20 CONTINUE
C
C     BUILD PDO
C
      IF(IFLAG1 .EQ. -1) GO TO 30
      MCB(1) = PDO
      CALL RDTRL(MCB)
      IF (MCB(1) .LE. 0) GO TO 30
      CALL SSG2B(AD,FCO,0,PDO,TRNSP,PREC,SIGN,SCR1)
      MCB(1) = PDO
      CALL RDTRL(MCB)
      MCB(2) = MCB(2) -1
      CALL WRTTRL(MCB)
   30 CONTINUE
C
C     BUILD PDT
C
      MCB(1) = PDT
      CALL RDTRL(MCB)
      IF (MCB(1) .LE. 0) GO TO 40
      CALL SSG2B(AD,FCT,0,PDT,TRNSP,PREC,SIGN,SCR1)
   40 CONTINUE
C
C     BUILD PHT
C
      MCB(1) = PHT
      CALL RDTRL(MCB)
      IF(MCB(1) .LE. 0) GO TO 50
      CALL SSG2B(AH,FCT,0,PHT,TRNSP,PREC,SIGN,SCR1)
   50 CONTINUE
      RETURN
      END

      SUBROUTINE IFP1B
C
C     THIS ROUTINE DETERMINES THE LOOP CONDITIONS AND CASE CONTROL
C     REQUEST CHNGES
C     LOOP$ -- THE CURRENT PROBLEM WILL LOOP
C
C     LOOP1$-- THE OLD PROBLEM WAS A LOOP AND CASE CONTROL IS CHANGED
C     IN LENGTH
C
C     COMMENTS FROM G.C.  10/92
C     IWORD AND IBIT 200 WORDS EACH CORRESPOND TO 200 WORDS IN CASECC
C     ZERO IN IWORD MEANS NO FURTHER CHECKING
C     INTEGER VALUE IN IBIT POINTS TO RESTART BIT POSITION, AND WILL BE
C     SAVED IN BITS(17) AND BITS(18), BITS FOR LCC. (LBD = 16)
C
C     LAST REVISED  7/91, BY G.CHAN/UNISYS, TO ALLOW HUGE THRU-RANGE ON
C     SET IN CASE CONTROL SECTION FOR PRINTOUT OR PLOTTING
C
      EXTERNAL        ANDF,ORF
      LOGICAL         NEW,DEBUG
      INTEGER         NAME(2),OPTP,CASECC,BITS,TWO1,CORE(2),CASE,CC,SS,
     1                ORF,ANDF,COREY(401)
      DIMENSION       ICASE(200,2),IWORD(200),IBIT(200)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG / UFM,UWM,UIM,SFM
      COMMON /TWO   / TWO1(32)
      COMMON /SYSTEM/ IBUF,NOUT
      COMMON /IFPX0 / LBD,LCC,BITS(1)
      COMMON /XIFP1 / IBLANK
      COMMON /ZZZZZZ/ COREX(1)
      COMMON /IFP1A / SCR1,CASECC,IS,NWPC,NCPW4,NMODES,ICC,NSET,NSYM,
     1                ZZZZBB,ISTR,ISUB,LENCC,IBEN,EQUAL,IEOR
      EQUIVALENCE    (COREX(1),COREY(1),ICASE(1,1)),(CORE(1),COREY(401))
      DATA    NAME  / 4HIFP1,  4HB          /
      DATA    CASE  , CC     / 4HCASE,4HCC  /
      DATA    SS    / 4HSS   /
      DATA    OPTP  / 4HOPTP /
      DATA    IWORD /
     1      -1,01,01,01,01,01,01,01,01,00,01,01,01,01,01,-1,00,01,01,00,
     2      01,01,00,01,01,00,01,01,00,01,01,00,01,01,00,01,01,01,-1,-1,
     3      -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     4      -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     5      -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     6      -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     7      -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,00,-1,-1,01,01,01,
     8      01,01,01,01,00,00,-1,01,01,-1,00,01,01,00,01,01,00,01,01,01,
     9      -1,-1,01,01,01,-1,00,01,01,00,01,01,00,01,01,00,01,01,01,00,
     X      01,01,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1/
      DATA    IBIT  /
     1      00,02,03,04,05,06,07,08,09,10,10,10,13,14,15,00,18,18,18,18,
     2      18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,17,00,00,
     3      00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,
     4      00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,
     5      00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,
     6      00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,
     7      00,00,00,00,00,00,00,00,00,00,00,00,00,00,16,00,00,20,21,21,
     8      22,22,23,23,18,18,00,24,25,00,10,10,10,10,10,10,10,10,10,27,
     9      00,00,30,26,29,00,18,18,18,18,18,18,10,10,10,10,10,10,33,18,
     X      18,18,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00/
      DATA    NEW,DEBUG   / 2*.FALSE. /
C
      K  = LBD + 1
      IFIROD = 0
      IOLOOP = 0
      ILOOP  = 0
      IFIRST = 0
      IEOPTP = 0
C
C     ALLOCATE GINO BUFFERS
C
      NZ     = KORSZ(CORE)
      IBUF1  = NZ - IBUF + 1
      IBUF2  = IBUF1 - IBUF
      NZ     = NZ - 2*IBUF
      ICRQ   =-NZ
      IF (NZ .LE. 0) GO TO 700
      IECASE = 0
C
C     TRY TO FIND CASECC ON OPTP - TRY TO ASSUME PROPER POSITION
C
      CALL OPEN (*560,OPTP,CORE(IBUF1),2)
      IOPN = 0
C
C     FIND CASECC
C
   10 CALL READ (*600,*610,OPTP,CORE(1),2,1,IFLAG)
      IF (CORE(1).EQ.CASE .AND. CORE(2).EQ.CC) GO TO 30
      IF (CORE(1).EQ.CASE .AND. CORE(2).EQ.SS) GO TO 20
      IF (IOPN .EQ. 0) CALL REWIND (OPTP)
      IOPN = 1
      CALL SKPFIL (OPTP,1)
      GO TO 10
C
C     CASESS FOUND ON OPTP - SKIP TO CASECC
C
   20 CALL READ (*600,*610,OPTP,CORE(1),2,1,IFLAG)
      IF (CORE(1).NE.CASE .OR. CORE(2).NE.CC) GO TO 20
C
C     CASECC FOUND ON OLD PROB TAPE
C
C     OPEN CASECC AND SKIP CASESS IF PRESENT
C
   30 CALL OPEN (*650,CASECC,CORE(IBUF2),0)
   40 CALL READ (*670,*680,CASECC,CORE(1),2,1,IFLAG)
      IF (CORE(1).NE.CASE .OR. CORE(2).NE.CC) GO TO 40
      ASSIGN 50 TO IHOP
   50 CALL READ (*550,*610,OPTP,ICASE(1,2),LENCC,0,IFLAG)
      IF (ICASE(16,2) .EQ. 0) GO TO 60
      CALL FWDREC (*600,OPTP)
      GO TO 50
   60 IF (ICASE(LENCC,2) .EQ. 0) GO TO 70
      LSYM = ICASE(LENCC,2)
      CALL READ (*600,*610,OPTP,CORE(1),-LSYM,0,IFLAG )
   70 CALL READ (*600,*80 ,OPTP,CORE(1),   NZ,1,IFOPTP)
      ICRQ = NZ
      GO TO 700
   80 CALL READ (*510,*680,CASECC,ICASE(1,1),LENCC,0,IFLAG)
      IF (ICASE(16,1) .EQ. 0) GO TO 90
      CALL FWDREC (*670,CASECC)
      GO TO 80
   90 IF (ICASE(LENCC,1) .EQ. 0) GO TO 100
      LSYM = ICASE(LENCC,1)
      CALL READ (*670,*680,CASECC,CORE(IFOPTP+1),-LSYM,0,IFLAG)
  100 CALL READ (*670,*110,CASECC,CORE(IFOPTP+1),NZ-IFOPTP,1,IFCASE)
      ICRQ = NZ - IFOPTP
      GO TO 700
C
C     CHECK FOR LOOPING PROBLEM
C
  110 IF (IFIRST .NE. 0) GO TO 120
      IFIRST= 1
      ISPC  = ICASE(  3,1)
      IMPC  = ICASE(  2,1)
      IMTD  = ICASE(  5,1)
      IFREQ = ICASE( 14,1)
      ITFL  = ICASE( 15,1)
      IK1   = ICASE(139,1)
      IK2   = ICASE(140,1)
      IM1   = ICASE(141,1)
      IM2   = ICASE(142,1)
      IB1   = ICASE(143,1)
      IB2   = ICASE(144,1)
      IF (ICASE(165,1).GT.0 .OR. ICASE(164,1).GT.0) GO TO 130
      GO TO 140
  120 IF (ICASE(  3,1) .NE. ISPC) GO TO 130
      IF (ICASE(  2,1) .NE. IMPC) GO TO 130
      IF (ICASE(  5,1) .NE. IMTD) GO TO 130
      IF (ICASE(139,1).NE.IK1 .OR. ICASE(140,1).NE.IK2) GO TO 130
      IF (ICASE(141,1).NE.IM1 .OR. ICASE(142,1).NE.IM2) GO TO 130
      IF (ICASE(143,1).NE.IB1 .OR. ICASE(144,1).NE.IB2) GO TO 130
      IF (ICASE( 15,1) .NE. ITFL ) GO TO 130
      IF (ICASE( 14,1) .NE. IFREQ) GO TO 130
      IF (ICASE(138,1) .GT. 0) GO TO 130
      IF (ICASE( 38,1) .NE. 0) GO TO 130
      GO TO 140
C
C     SET LOOP$
C
  130 BITS(K) = ORF(BITS(K),TWO1(11))
      ILOOP = 1
  140 CONTINUE
C
C     DETERMINE IF OLD PROBLEM WOULD HAVE LOOPED
C
      IF (IFIROD .NE. 0) GO TO 150
      IFIROD= 1
      ISPC1 = ICASE(  3,2)
      IMPC1 = ICASE(  2,2)
      IMTD1 = ICASE(  5,2)
      IK11  = ICASE(139,2)
      IK21  = ICASE(140,2)
      IM11  = ICASE(141,2)
      IM21  = ICASE(142,2)
      IB11  = ICASE(143,2)
      IB21  = ICASE(144,2)
      ITFL1 = ICASE( 15,2)
      IFREQ1= ICASE( 14,2)
      IF (ICASE(164,2).GT.0 .OR. ICASE(165,2).GT.0) GO TO 160
      GO TO 170
C
C     SECOND RECORD APPLY LOOP RULES
C
  150 IF (ICASE(  3,2) .NE. ISPC1) GO TO 160
      IF (ICASE(  2,2) .NE. IMPC1) GO TO 160
      IF (ICASE(  5,2) .NE. IMTD1) GO TO 160
      IF (ICASE(139,2).NE.IK11 .OR. ICASE(140,2).NE.IK21) GO TO 160
      IF (ICASE(141,2).NE.IM11 .OR. ICASE(142,2).NE.IM21) GO TO 160
      IF (ICASE(143,2).NE.IB11 .OR. ICASE(144,2).NE.IB21) GO TO 160
      IF (ICASE(138,2) .GT. 0) GO TO 160
      IF (ICASE( 38,2) .NE. 0) GO TO 160
      IF (ICASE( 15,2) .NE. ITFL1 ) GO TO 160
      IF (ICASE( 14,2) .NE. IFREQ1) GO TO 160
      GO TO 170
  160 IOLOOP = 1
  170 CONTINUE
      IF (IECASE .NE. 1) GO TO 180
      IF (IOLOOP .EQ. 1) GO TO 530
      GO TO 520
C
C     CHECK FOR CHANGES -
C
  180 IF (IEOPTP .EQ. 1) IEOPTP = 2
      DO 500 I = 1,LENCC
      IF (IBIT(I) .EQ. 0) GO TO 500
      L = IBIT(I)
      IF (L.LE.32 .AND. ANDF(BITS(K),TWO1(L)).NE.0) GO TO 500
      IF (IWORD(I) .EQ. 0) GO TO 210
      IF (ICASE(I,1) .EQ. ICASE(I,2)) GO TO 500
  190 IF (L .GT. 32) GO TO 200
      BITS(K) = ORF(BITS(K),TWO1(L))
      GO TO 500
C
C     SECOND CASECC WORD
C
  200 L = L - 31
      BITS(K+1) = ORF(BITS(K+1),TWO1(L))
      GO TO 500
C
C     CHECK FOR PRESENCE OF PRINT AND PLOT REQUESTS
C
  210 IF (I.NE.135 .AND. ICASE(I,1).EQ.0) GO TO 500
      IF (I .NE. 135) GO TO 220
      IF (ICASE(I,1).NE.0 .OR. ICASE(I,2).NE.0) GO TO 190
      GO TO 500
  220 IF (IBIT(I) .EQ. 18) BITS(K+1) = ORF(BITS(K+1),TWO1(3))
      IF (IBIT(I) .EQ. 10) BITS(K+1) = ORF(BITS(K+1),TWO1(4))
      IF (IEOPTP  .EQ.  2) GO TO 190
      IF (ICASE(I,1).LT.0 .AND. ICASE(I,2).LT.0) GO TO 500
      IF (ICASE(I,1).LT.0 .AND. ICASE(I,2).GE.0) GO TO 190
      IF (ICASE(I,1).GT.0 .AND. ICASE(I,2).LE.0) GO TO 190
      IPCASE = IFOPTP + 1
  230 IF (IPCASE .GT. IFOPTP+IFCASE) GO TO 690
      IF (CORE(IPCASE) .EQ. ICASE(I,1)) GO TO 240
      IPCASE = IPCASE + CORE(IPCASE+1) + 2
      GO TO 230
  240 IPOPTP = 1
  250 IF (IPOPTP .GT. IFOPTP) GO TO 620
      IF (CORE(IPOPTP) .EQ. ICASE(I,2)) GO TO 260
      IPOPTP = IPOPTP + CORE(IPOPTP+1) + 2
      GO TO 250
  260 IQCASE = IFOPTP + IFCASE + 1
      IX = IPCASE
      IY = IQCASE
      ASSIGN 280 TO JUMP
      IF (DEBUG) WRITE (NOUT,270)
  270 FORMAT (/,' ------ NPTP PASS ------')
      GO TO 360
  280 IQOPTP = IY
      IX = IPOPTP
      ASSIGN 300 TO JUMP
      IF (DEBUG) WRITE (NOUT,290)
  290 FORMAT (/,' ------ OPTP PASS ------')
      GO TO 360
  300 LENG1 = IQOPTP - IQCASE
      LENG2 = IY - IQOPTP
      IF (DEBUG) WRITE (NOUT,310) CORE(IPCASE),LENG1,LENG2,IY,IQOPTP,
     1                            IQCASE
  310 FORMAT (//,' IFP1B/@310  CHECKING SETS',I9,' FROM NPTP AND OPTP',
     1        /5X,'LENG1,LENG2, IY,IQOPTP,IQCASE =', 2I5,3I7)
      IF (LENG1 .NE. LENG2) GO TO 340
      DO 320 MM = 1,LENG1
      IF (CORE(IQCASE+MM-1) .NE. CORE(IQOPTP+MM-1)) GO TO 340
  320 CONTINUE
      IF (DEBUG) WRITE (NOUT,330) CORE(IPCASE)
  330 FORMAT (' ... NO DIFFERENCES IN SET',I8)
      GO TO 500
  340 WRITE  (NOUT,350) UIM,CORE(IPCASE)
  350 FORMAT (A29,', SET',I9,' DEFINITION HAS BEEN CHANGED IN RESTART')
      GO TO 190
C
C     A NEW NON-EXPANDING METHOD IS IMPLEMENTED HERE BY  G.CAHN/UNISYS
C     8/91, IN CASE THE ORIGINAL LOGIC RUNS OUT OF CORE SPACE
C
C     THE NEW METHOD WILL CONCATINATE VARIATIONS OF SET DEFINITION TO
C     THE SIMPLEST FORM.  E.G. THE NEXT 3 LINES SPECIFY THE SAME SET
C     10 THRU 400000  (THIS IS THE SIMPLEST FORM)
C     10, 11, 12 THRU 400008, 400009, 400000
C     10 THRU 20, 21, 22, 23 THRU 200, 201 THRU 500, 501 502 THRU 400000
C
  360 IF (NEW) GO TO 420
      IN = CORE(IX+1)
      IX = IX + 2
      M  = 0
  370 M  = M + 1
      IF (M-IN) 380,400,490
  380 IF (CORE(IX+M) .GT. 0) GO TO 400
      M1 = CORE(IX+M-1)
      M2 =-CORE(IX+M  )
      ICRQ = IY + M2 - M1 - NZ
      IF (ICRQ .GT. 0) GO TO 410
      DO 390 MM = M1,M2
      CORE(IY) = MM
      IY = IY + 1
  390 CONTINUE
      M = M + 1
      GO TO 370
  400 ICRQ = IY - NZ
      IF (IY .GT. NZ) GO TO 700
      CORE(IY) = CORE(IX+M-1)
      IY = IY + 1
      GO TO 370
C
C     INSUFFICIENT CORE SPACE, SWITCH TO NEW METHOD
C
  410 NEW = .TRUE.
      GO TO 260
C
C     NEW LOGIC WITHOUT THRU RANGE EXPANSION
C
  420 IN = CORE(IX+1)
      IX = IX + 2
      M0 = IY
      CORE(IY) = CORE(IX)
      IY = IY + 1
      IF (IN .EQ. 1) GO TO 490
      CORE(IY) = CORE(IX+1)
      IF (CORE(IY) .EQ. CORE(IY-1)+1) CORE(IY) = -CORE(IY)
      IY = IY + 1
      M  = 1
  430 M  = M + 1
      IF (M .GE. IN) GO TO 470
      M1 = CORE(IX+M)
      M2 = IABS(M1)
      IF (DEBUG) WRITE (NOUT,440) M,IN,IX,IY,M1,CORE(IY-1)
  440 FORMAT (' @440   M,IN,IX,IY,M1,CORE(IY-1) =',6I8)
      IF (M1 .LT. 0) GO TO 450
      IF (M1 .NE. 1-CORE(IY-1)) GO TO 460
      CORE(IY-1) = -M2
      GO TO 430
  450 IF (CORE(IY-1) .GT. 0) GO TO 460
      CORE(IY-1) = -M2
      GO TO 430
  460 CORE(IY) = M1
      IF (M1 .EQ. CORE(IY-1)+1) CORE(IY) = -M2
      IY = IY + 1
      GO TO 430
  470 ICRQ = IY - NZ
      IF (IY .GT. NZ) GO TO 700
      M1 = IY - 1
      IF (DEBUG) WRITE (NOUT,480) CORE(IX-2),(CORE(J),J=M0,M1)
  480 FORMAT (/,' IFP1B/@480    SET',I8, /,(2X,15I8))
C
  490 GO TO JUMP, (280,300)
C
  500 CONTINUE
      GO TO IHOP, (50,80)
C
C     EOF ON CASECC
C
  510 CALL CLOSE (CASECC,1)
      IF (IEOPTP .NE. 0) GO TO 530
      IECASE = 1
      GO TO 150
  520 CALL READ (*530,*610,OPTP,ICASE(1,2),LENCC,1,IFLAG)
      IF (ICASE(16,2) .NE. 0) GO TO 520
      GO TO 150
  530 CALL CLOSE (OPTP,2)
      IF (IEOPTP.EQ.1 .OR. IOLOOP.EQ.0) GO TO 540
C
C     SET LOOP1  THIS SHOULD REEXECUTE THE ENTIRE LOOP
C
      BITS(K) = ORF(BITS(K),TWO1(12))
C
C     CHECK FOR LOOP$ IF NOT ON SET NOLOOP$
C
  540 IF (ILOOP .EQ. 0) BITS(K) = ORF(BITS(K),TWO1(32))
      RETURN
C
C     EOF ON  OPTP
C
  550 ASSIGN 80 TO IHOP
      IEOPTP = 1
      GO TO 80
C
C     ERROR MESSAGES
C
  560 IP1 = -1
  570 IP2 = OPTP
  580 CALL MESAGE (IP1,IP2,NAME)
      RETURN
C
  600 IP1 = -2
      GO TO 570
  610 IP1 = -3
      GO TO 570
  620 CORE(1) = OPTP
      CORE(2) = IBLANK
  630 WRITE  (NOUT,640) SFM,CORE(1),CORE(2)
  640 FORMAT (A25,' 651, LOGIC ERROR IN SUBROUTINE IFP1B WHILE ',
     1       'PROCESSING SET DATA ON ',2A4,' FILE.')
      IP1 = -37
      GO TO 580
  650 IP1 = -1
  660 IP2 = CASECC
      GO TO 580
  670 IP1 = -2
      GO TO 660
  680 IP1 = -3
      GO TO 660
  690 CORE(1) = CASE
      CORE(2) = CC
      GO TO 630
  700 IP1 = -8
      IP2 = ICRQ
      GO TO 580
      END

      SUBROUTINE OFPPNT (OUT,NWDS,FMT)
C
CWKBD LOGICAL         DEBUG
CWKBR INTEGER         OUT(NWDS), FMT(300)
      INTEGER         OUT(NWDS)
      CHARACTER*1     FMT(1200)
CWKBI
      COMMON /MACHIN/ MACHX
      COMMON /SYSTEM/ SYSBUF,    L
CWKBD DATA    DEBUG / .FALSE. /
C
CWKBD IF (DEBUG) WRITE (L,10) (FMT(K),K=1,32)
 10   FORMAT (' FMT=',32A4)
CWKBR 5/95     IF ( MACHX.EQ.2 .OR. MACHX.EQ.5  )  
      IF ( MACHX.EQ.2 .OR. MACHX.EQ.5 .OR. MACHX .EQ. 21  )  
     *     WRITE (L,FMT,IOSTAT=IOSXX) (OUT(K),K=1,NWDS)
CWKBR 5/95      IF ( MACHX.NE.2 .AND. MACHX.NE.5 )  
      IF ( MACHX.NE.2 .AND. MACHX.NE.5 .AND. MACHX .NE. 21 )  
     *     CALL FORWRT (FMT, OUT, NWDS)
      RETURN
      END

      SUBROUTINE DPSE3
C
C     PRESSURE STIFFNESS CALCULATIONS FOR A TRIANGULAR MEMBRANE
C     ELEMENT (3 GRID POINTS).
C     THREE 6X6 STIFFNESS MATRICES FOR THE PIVOT POINT ARE INSERTED.
C
C     DOUBLE PRECISION VERSION
C
C     WRITTEN BY E. R. CHRISTENSEN/SVERDRUP, 9/91, VERSION 1.1
C     INSTALLED IN NASTRAN AS ELEMENT DPSE3 BY G.CHAN/UNISYS, 2/92
C
C     REFERENCE - E. CHRISTENEN: 'ADVACED SOLID ROCKET MOTOR (ASRM)
C                 MATH MODELS - PRESSURE STIFFNESS EFFECTS ANALYSIS',
C                 NASA TD 612-001-02, AUGUST 1991
C
C     LIMITATION -
C     (1) ALL GRID POINTS USED BY ANY IF THE CPSE2/3/4 ELEMENTS MUST BE
C         IN BASIC COORDINATE SYSTEM!!!
C     (2) CONSTANT PRESSURE APPLIED OVER AN ENCLOSED VOLUMN ENCOMPASSED
C         BY THE CPSE2/3/4 ELEMENTRS
C     (3) PRESSURE ACTS NORMALLY TO THE CPSE2/3/4 SURFACES
C
C     SEE NASTRAN DEMONSTRATION PROBLEM -  T13022A
C
      DOUBLE PRECISION GAMMA,KIJ,SGN,SGN1,SGN2,DP,C
      DIMENSION        NECPT(5)
C     COMMON /SYSTEM/  IBUF,NOUT
      COMMON /DS1AAA/  NPVT,ICSTM,NCSTM
      COMMON /DS1AET/  ECPT(21),DUM2(2),DUM9(9)
      COMMON /DS1ADP/  GAMMA,KIJ(36),SGN,SGN1,SGN2,DP(21),C(9)
      EQUIVALENCE      (NECPT(1),ECPT(1))
C
C     ECPT FOR THE PRESSURE STIFFNESS CPES3 ELEMENT
C
C     ECPT( 1) = ELEMENT ID
C     ECPT( 2) = SIL FOR GRID POINT A OR 1
C     ECPT( 3) = SIL FOR GRID POINT B OR 2
C     ECPT( 4) = SIL FOR GRID POINT C OR 3
C     ECPT( 5) = PRESSURE
C     ECPT( 6) = NOT USED
C     ECPT( 7) = NOT USED
C     ECPT( 8) = NOT USED
C     ECPT( 9) = COORD. SYSTEM ID 1
C     ECPT(10) = X1
C     ECPT(11) = Y1
C     ECPT(12) = Z1
C     ECPT(13) = COORD. SYSTEM ID 2
C     ECPT(14) = X2
C     ECPT(15) = Y2
C     ECPT(16) = Z2
C     ECPT(17) = COORD. SYSTEM ID 3
C     ECPT(18) = X3
C     ECPT(19) = Y3
C     ECPT(20) = Z3
C     ECPT(21) = ELEMENT TEMPERATURE
C     ECPT(22) THRU (32) = DUM2 AND DUM9, NOT USED IN THIS ROUTINE
C
C     STORE ECPT IN DOUBLE PRECISION
C
      DP(5) = ECPT(5)
      K = 9
      DO 20 I = 1,3
      DO 10 J = 1,3
      K = K + 1
   10 DP(K) = ECPT(K)
   20 K = K + 1
C
C     CALCULATE THE THREE VECTORS R1, R2 AND R2 USED IN COMPUTING
C     THE PRESSURE STIFFNESS MATRICES:
C
C     R1 = RA - 2*RC + RB
C     R2 = 2*RB - RA - RC
C     R3 = RB - 2*RA + RC
C
C     R1 STORED IN C(1), C(2), C(3)
C     R2 STORED IN C(4), C(5), C(6)
C     R3 STORED IN C(7), C(8), C(9)
C
      C(1) = DP(10) - 2.0D0*DP(18) + DP(14)
      C(2) = DP(11) - 2.0D0*DP(19) + DP(15)
      C(3) = DP(12) - 2.0D0*DP(20) + DP(16)
C
      C(4) = 2.0D0*DP(14) - DP(10) - DP(18)
      C(5) = 2.0D0*DP(15) - DP(11) - DP(19)
      C(6) = 2.0D0*DP(16) - DP(12) - DP(20)
C
      C(7) = DP(14) - 2.0D0*DP(10) + DP(18)
      C(8) = DP(15) - 2.0D0*DP(11) + DP(19)
      C(9) = DP(16) - 2.0D0*DP(12) + DP(20)
C
      DO 30 I = 1,3
      IF (NECPT(I+1) .NE. NPVT) GO TO 30
      NPIVOT = I
      GO TO 40
   30 CONTINUE
      RETURN
C
C     GENERATE THE THREE BY THREE PARTITIONS IN GLOBAL COORDINATES HERE
C
C     SET COUNTERS ACCORDING TO WHICH GRID POINT IS THE PIVOT
C
   40 IF (NPIVOT-2) 50,60,70
C
C     SET COUNTERS AND POINTERS FOR CALCULATING KAB, KAC
C
   50 NI = 2
      NJ = 3
      NK = 1
      K1 = 1
      K2 = 4
      SGN1 = 1.0D0
      SGN2 = 1.0D0
      GO TO 80
C
C     SET COUNTERS AND POINTERS FOR CALCULATING KBA, KBC
C     NOTE THAT KBA = -KAB
C
   60 NI = 1
      NJ = 3
      NK = 2
      K1 = 1
      K2 = 7
      SGN1 =-1.0D0
      SGN2 = 1.0D0
      GO TO 80
C
C     SET COUNTERS AND POINTERS FOR CALCULATING KCA, KCB
C     NOTE THAT KCA = -KAC, KCB = -KBC
C
   70 NI = 1
      NJ = 2
      NK = 1
      K1 = 4
      K2 = 7
      SGN1 =-1.0D0
      SGN2 =-1.0D0
C
   80 GAMMA =-DP(5)/12.0D0
      SGN   = SGN1*GAMMA
      K = K1
      DO 100 I = NI,NJ,NK
      DO 90  J = 1,36
   90 KIJ(J) = 0.0D0
      KK2 = K + 1
      KK3 = K + 2
      KIJ( 2) =-C(KK3)*SGN
      KIJ( 3) = C(KK2)*SGN
      KIJ( 7) = C(KK3)*SGN
      KIJ( 9) =-C(K  )*SGN
      KIJ(13) =-C(KK2)*SGN
      KIJ(14) = C(K  )*SGN
      CALL DS1B (KIJ(1),NECPT(I+1))
      SGN = SGN2*GAMMA
      K   = K2
  100 CONTINUE
C
      RETURN
      END

      SUBROUTINE GIBSTK (NDSTK,IOLD,RENUM,NDEG,LVL,LVLS1,LVLS2,CCSTOR,
     1                   JUMP,ICRIT,NHIGH,NLOW,NACUM,SIZE,STPT,UN,IDIM)
C
C     THIS ROUTINE IS USED ONLY IN BANDIT MODULE
C
C     GIBBSTOCK USES GRAPH THEORETICAL METHODS TO PRODUCE A PERMUTATION
C     OF AN INPUT ARRAY WHICH REDUCES ITS BANDWITH
C
C     THE FOLLOWING INPUT PARAMETERS ARE REQUIRED--NDSTK,N,IDEG,IOLD
C
C     THESE INTEGER ARRAYS MUST BE DIMENSIONED IN THE CALLING PROGRAM--
C     NDSTK(NR,D1),RENUM(D2+1),NDEG(D2),IOLD(D2),LVL(D2),LVLS1(D2),
C     LVLS2(D2),CCSTOR(D2)   WHERE D1 .GE. MAX DEGREE OF ANY NODE AND
C     D2 AND NR ARE .GE. THE TOTAL NUMBER OF NODES IN THE GRAPH.
C
C     EXPLANATION OF PARAMETERS--
C     NDSTK   - ADJACENCY ARRAY REPRESENTING GRAPH TO BE PROCESSED
C               NDSTK(I,J) = NODE NUMBER OF JTH CONNECTION TO NODE
C               NUMBER I.  A CONNECTION OF A NODE TO ITSELF IS NOT
C               LISTED.  EXTRA POSITIONS MUST HAVE ZERO FILL.
C     NR      - ROW DIMENSION ASSIGNED NDSTK IN CALLING PROGRAM = II1
C     IOLD(I) - RENUMBERING OF ITH NODE BEFORE GIBBSTOCK PROCESSING
C               IF NO RENUMBERING EXISTS THEN ILD(1)=1,ILD(2)=2, ETC.
C     N       - NUMBER OF NODES IN GRAPH BEING PROCESSED
C     IDEG    - MAX DEGREE OF ANY NODE IN GRAPH BEING PROCESSED
C     JUMP   IS SET TO 0 IF EITHER CRITERION IS REDUCED.
C     ICRIT   - RESEQUENCING CRITERION, SET BY BANDIT
C               1 RMS WAVEFRONT, 2 BANDWIDTH, 3 PROFILE, 4 MAX.WAVEFRONT
C
C     ON OUTPUT THESE VARIABLES CONTAIN THE FOLLOWING INFORMATION--
C     RENUM(I)- THE NEW NUMBER FOR THE ITH NODE
C     NDEG(I) - THE DEGREE OF THE ITH NODE
C     IDPTH   - NUMBER OF LEVELS IN GIBBSTOCK LEVEL STRUCTURE
C     IBW2    - THE BANDWITH AFTER RENUMBERING
C     IPF2    - THE PROFILE AFTER RENUMBERING
C
C     THE FOLLOWING ONLY HAVE MEANING IF THE GRAPH WAS ALL ONE COMPONENT
C     LVL(I)  - INDEX INTO LVLS1 TO THE FIRST NODE IN LEVEL I
C               LVL(I+1)-LVL(I)= NUMBER OF NODES IN ITH LEVEL
C     LVLS1   - LEVEL STRUCTURE CHOSEN BY GIBBSTOCK
C     LVLS2(I)- THE LEVEL ASSIGNED TO NODE I BY GIBBSTOCK
C
      INTEGER          STNODE,   RVNODE,   RENUM,    XC,       SUMWB,
     1                 STNUM,    CCSTOR,   SIZE,     STPT,     SBNUM,
     2                 OBW,      OP,       XCMAX
      REAL             IM1,      IM2
      DIMENSION        NHIGH(1), NLOW(1),  NACUM(1), SIZE(1),  STPT(1),
     1                 CCSTOR(1),IOLD(1),  LVL(1),   LVLS1(1), LVLS2(1),
     2                 RENUM(1), NDEG(1),  NDSTK(1), UN(1)
      COMMON /BANDA /  DUM5A(5), METHOD
      COMMON /BANDB /  DUM3B(3), NGRID
      COMMON /BANDD /  OBW,      NBW,      OP,       NP,       NCM,
     1                 NZERO
      COMMON /BANDG /  N,        IDPTH,    IDEG
      COMMON /BANDW /  MAXW0,    RMS0,     MAXW1,    RMS1,     I77,
     1                 BRMS0,    BRMS1
      COMMON /BANDS /  NN,       MM
      COMMON /SYSTEM/  IBUF,     NOUT,     DUM6S(6), NLPP
C
C     OLD AND NEW MAX AND RMS WAVEFRONT FOR ENTIRE PROBLEM,
C     NOT JUST GIBSTK.
C     DIMENSIONS OF NHIGH, NLOW, AND NACUM ARE IDIM EACH
C     SIZE AND STPT HAVE DIMENSION IDIM/2 AND SHOULD BE CONTIGUOUS IN
C     CORE WITH SIZE FIRST.
C     XC = NUMBER OF SUB-COMPONENTS RESULTING AFTER REMOVING DIAMETER
C     FROM ONE COMPONENT OF ORIGINAL GRAPH.
C
      XCMAX = IDIM/2
      NCM   = 0
      N     = NN
      IBW2  = 0
      IPF2  = 0
C
C     SET RENUM(I) = 0 FOR ALL I TO INDICATE NODE I IS UNNUMBERED
C     THEN COMPUTE DEGREE OF EACH NODE AND ORIGINAL B AND P.
C
      DO 30 I = 1,N
   30 RENUM(I) = 0
      CALL DGREE (NDSTK,NDEG,IOLD,IBW1,IPF1,UN)
C
C     ORIGINAL ACTIVE COLUMN DATA IN MAXW1 AND RMS1, COMPUTED BY SCHEME
C
      IF (METHOD .NE. 0) GO TO 35
      MAXWA = MAXW1
      RMSA  = RMS1
      BRMSA = BRMS1
      GO TO 38
   35 MAXWA = MAXW0
      RMSA  = RMS0
      BRMSA = BRMS0
   38 CONTINUE
C
C     NUMBER THE NODES OF DEGREE ZERO
C     SBNUM = LOW  END OF AVAILABLE NUMBERS FOR RENUMBERING
C     STNUM = HIGH END OF AVAILABLE NUMBERS FOR RENUMBERING
C
      SBNUM = 1
      STNUM = N
      DO 40 I = 1,N
      IF (NDEG(I) .GT. 0) GO TO 40
      RENUM(I) = STNUM
      STNUM = STNUM-1
   40 CONTINUE
C
C     NODES OF ZERO DEGREE APPEAR LAST IN NEW SEQUENCE.
C
      NZERO = N - STNUM
      NCM   = NZERO
C
C     FIND AN UNNUMBERED NODE OF MIN DEGREE TO START ON
C
   50 LOWDG = IDEG + 1
      NCM   = NCM + 1
      NFLG  = 1
      ISDIR = 1
      DO 70 I = 1,N
      IF (NDEG(I).GE.LOWDG .OR. RENUM(I).GT.0) GO TO 70
      LOWDG  = NDEG(I)
      STNODE = I
   70 CONTINUE
C
C     FIND PSEUDO-DIAMETER AND ASSOCIATED LEVEL STRUCTURES.
C     STNODE AND RVNODE ARE THE ENDS OF THE DIAM AND LVLS1 AND LVLS2
C     ARE THE RESPECTIVE LEVEL STRUCTURES.
C
      CALL FNDIAM (STNODE,RVNODE,NDSTK,NDEG,LVL,LVLS1,LVLS2,CCSTOR,
     1             IDFLT,SIZE,UN,IDIM)
      IF (NGRID .EQ. -3) RETURN
      IF (NDEG(STNODE) .LE. NDEG(RVNODE)) GO TO 75
C
C     NFLG INDICATES THE END TO BEGIN NUMBERING ON
C
      NFLG   =-1
      STNODE = RVNODE
   75 CALL RSETUP (LVL,LVLS1,LVLS2,           NACUM,IDIM)
C                                  NHIGH,NLOW,    <===== NEW
      IF (NGRID .EQ. -3) RETURN
C
C     FIND ALL THE CONNECTED COMPONENTS  (XC COUNTS THEM)
C
      XC    = 0
      LROOT = 1
      LVLN  = 1
      DO 85 I = 1,N
      IF (LVL(I) .NE. 0) GO TO 85
      XC = XC + 1
      IF (XC .LE. XCMAX) GO TO 80
C
C     DIMENSION EXCEEDED.  STOP JOB.
C
      NGRID =-3
      RETURN
C
   80 STPT(XC) = LROOT
      CALL TREE (I,NDSTK,LVL,CCSTOR,NDEG,LVLWTH,LVLBOT,LVLN,MAXLW,N,UN)
      SIZE(XC) = LVLBOT + LVLWTH - LROOT
      LROOT = LVLBOT + LVLWTH
      LVLN  = LROOT
   85 CONTINUE
      CALL PIKLVL (*90,LVLS1,LVLS2,CCSTOR,IDFLT,ISDIR,XC,NHIGH,NLOW,
     1             NACUM,SIZE,STPT)
C
C     ON RETURN FROM PIKLVL, ISDIR INDICATES THE DIRECTION THE LARGEST
C     COMPONENT FELL.  ISDIR IS MODIFIED NOW TO INDICATE THE NUMBERING
C     DIRECTION.  NUM IS SET TO THE PROPER VALUE FOR THIS DIRECTION.
C
   90 ISDIR = ISDIR*NFLG
      NUM   = SBNUM
      IF (ISDIR .LT. 0) NUM = STNUM
C
      CALL NUMBER (STNODE,NUM,NDSTK,LVLS2,NDEG,RENUM,LVLS1,LVL,NFLG,
     1             IBW2,IPF2,CCSTOR,ISDIR,NHIGH,NLOW,NACUM,SIZE,UN,IDIM)
      IF (NGRID .EQ. -3) RETURN
C
C     UPDATE STNUM OR SBNUM AFTER NUMBERING
C
      IF (ISDIR .LT. 0) STNUM = NUM
      IF (ISDIR .GT. 0) SBNUM = NUM
      IF (SBNUM .LE. STNUM) GO TO 50
C
C     COMPUTE THE NEW BANDWIDTH, PROFILE, AND WAVEFRONT.
C
      CALL WAVEY (NDSTK,RENUM,LVL,0,LVLS2,LVLS1,MAXB,MAXWB,AVERWB,
     1            SUMWB,RMSB,BRMSB,UN)
C
      IBW2 = MAXB
      IPF2 = SUMWB
      IF (NLPP .GT. 50) WRITE (NOUT,100) MAXB,SUMWB,MAXWB,AVERWB,
     1                                   RMSB,BRMSB
  100 FORMAT (/31X,66HAFTER RESEQUENCING BY GIBBS-POOLE-STOCKMEYER (GPS)
     1 ALGORITHM - - -,
     2        /40X,13HBANDWIDTH    ,I9,  /40X,13HPROFILE      ,I9,
     3        /40X,13HMAX WAVEFRONT,I9,  /40X,13HAVG WAVEFRONT,F9.3,
     4        /40X,13HRMS WAVEFRONT,F9.3,/40X,13HRMS BANDWIDTH,F9.3)
C
C     CHECK NEW NUMBERING AGAINST OLD NUMBERING.
C
      GO TO (110,120,130,140), ICRIT
  110 IM1   = RMSA
      IM2   = IPF1
      CRIT1 = RMSB
      CRIT2 = IPF2
      GO TO 150
  120 IM1   = IBW1
      IM2   = IPF1
      CRIT1 = IBW2
      CRIT2 = IPF2
      GO TO 150
  130 IM1   = IPF1
      IM2   = IBW1
      CRIT1 = IPF2
      CRIT2 = IBW2
      GO TO 150
  140 IM1   = MAXWA
      IM2   = RMSA
      CRIT1 = MAXWB
      CRIT2 = RMSB
C
  150 IF (CRIT1-IM1) 210,160,170
  160 IF (CRIT2 .LT. IM2) GO TO 210
C
C     IF ORIGINAL NUMBERING IS BETTER THAN NEW ONE, SET UP TO RETURN IT
C
  170 DO 200 I = 1,N
  200 RENUM(I) = IOLD(I)
      IBW2  = IBW1
      IPF2  = IPF1
      MAXWB = MAXWA
      RMSB  = RMSA
      BRMSB = BRMSA
      GO TO 220
C
C     EQUATE CORRESPONDING GPS AND BANDIT VARIABLES.
C
  210 JUMP  = 0
  220 NBW   = IBW2
      NP    = IPF2
      MAXW1 = MAXWB
      RMS1  = RMSB
      BRMS1 = BRMSB
      RETURN
      END

      SUBROUTINE SELBO2 (TI)
C
C     THIS ROUTINE IS THE PHASE II SUBROUTINE OF STRESS DATA RECOVERY
C     FOR THE BEAM ELEMENT.
C
      INTEGER         TLOADS
      REAL            I1,I2,L,M1A,M2A,M1B,M2B,I12,K1A,K2A,K1B,K2B,
     1                TI(14),M2BT
      EQUIVALENCE     (LDTEMP,TEMPLD),(MSTEN,SMTEN),(MSCOM,SMCOM)
      COMMON /ZZZZZZ/ ZZ(1)
      COMMON /SDR2X4/ XXXXXX(33),ICSTM,NCSTM,IVEC,IVECN,LDTEMP,ELDEFM,
     1                DUM8(8),TLOADS
C
C     THE FIRST 100 LOCATIONS OF THE SDR2X7 BLOCK ARE RESERVED FOR INPUT
C     PARAMETERS, THE SECOND 100 FOR STRESS OUTPUT PARAMETERS, AND FORCE
C     OUTPUT PARAMETERS BEGIN AT LOCATION 201.
C
      COMMON /SDR2X7/ JELID,JSILNO(2),SA(36),SB(36),ST,SDELTA,A,FJ,I1,
     1                I2,C,R1,T1,R2,T2,R3,T3,R4,T4,T SUB 0,SIGMAT,
     2                SIGMAC,L,R,BETAR,THERM(4)
      COMMON /SDR2X7/ ISELID,SIG1A,SIG2A,SIG3A,SIG4A,SIGAX,SIGAMX,
     3                SIGAMN,MSTEN,SIG1B,SIG2B,SIG3B,SIG4B,SIGBX,
     4                SIGBMX,SIGBMN,MSCOM,YYYYYY(83)
      COMMON /SDR2X7/ IFELID,M1A,M2A,V1,V2,FX,T,M1B,M2BT,V1BT,FXBT,TBT
C
      COMMON /SDR2X8/ FA(6),FB(6),IDISP,IUA,IUB,P1,K1A,K2A,K1B,K2B,Q,W
      DATA    DCR   / .017453292 /
C
      SID(X) = SIN(X*DCR)
      COD(X) = COS(X*DCR)
C
      X   = 1.0
      YL  = R*(1.-COD(BETAR))
      XL  = R*SID(BETAR)
      I12 = 0.
      IDISP = IVEC - 1
      IUA = IDISP + JSILNO(1)
      CALL GMMATS (SA(1),6,6,0, ZZ(IUA),6,1,0, FA(1))
      IUB = IDISP + JSILNO(2)
      CALL GMMATS (SB(1),6,6,0, ZZ(IUB),6,1,0, FB(1))
      FX  = -FA(1) - FB(1)
      V1  = -FA(2) - FB(2)
      V2  = -FA(3) - FB(3)
      T   = -FA(4) - FB(4)
      M2A =  FA(5) + FB(5)
      M1A = -FA(6) - FB(6)
C
C     IF LDTEMP = -1, THE LOADING TEMPERATURE IS UNDEFINED
C
      IF (TLOADS .EQ. 0) GO TO 10
      TBAR = TI(1)
      DT   = TBAR - TSUB0
      DO 5 I = 1,6
      FA(I) = DT*THERM(I)
    5 CONTINUE
      FX  = FX  + FA(1)
      V1  = V1  + FA(2)
      M1A = M1A + FA(6)
10    M1B = M1A - V1*XL + FX*YL
      M2B = M2A - V2*XL
      TB  = T   - V2*YL
C
C     TRANSFORM FORCES AT B-END TO A COORD. SYS TANGENT TO B-END
C
      FXBT = V1*SID(BETAR) + FX*ABS(COD(BETAR))
      V1BT = V1*ABS(COD(BETAR))  - FX*SID(BETAR)
      M2BT = M2B*ABS(COD(BETAR)) + TB*SID(BETAR)
      TBT  =-M2B*SID(BETAR) + TB*ABS(COD(BETAR))
C
C     COMPUTE ELEMENT STRESSES AT 4 POINTS
C
C
C     COMPUTE K1A AND K2A
C
      IF (I12 .NE. 0.0) GO TO 30
      IF (I1  .NE. 0.0) GO TO 20
      K1A = 0.0
      GO TO 40
   20 K1A = -M1A/I1
      GO TO 40
   30 K1A = (M2A*I12 - M1A*I2)/(I1*I2 - I12**2)
      K2A = (M1A*I12 - M2A*I1)/(I1*I2 - I12**2)
      GO TO 60
   40 IF (I2 .NE. 0.0) GO TO 50
      K2A = 0.0
      GO TO 60
   50 K2A = -M2A/I2
C
C     CHANGE STRESS RECOVERY CONSTANTS FROM CYL. TO RECT. COORD.
C
      C1 = R1*SID(T1)
      C2 = R1*COD(T1)
      D1 = R2*SID(T2)
      D2 = R2*COD(T2)
      F1 = R3*SID(T3)
      F2 = R3*COD(T3)
      G1 = R4*SID(T4)
      G2 = R4*COD(T4)
C
C     COMPUTE SIG1A, SIG2A, SIG3A AND SIG4A
C
   60 SIG1A = K1A*C1*C + K2A*C2
      SIG2A = K1A*D1*C + K2A*D2
      SIG3A = K1A*F1*C + K2A*F2
      SIG4A = K1A*G1*C + K2A*G2
C
C     COMPUTE K1B AND K2B
C
      IF (I12 .NE. 0.0) GO TO 80
      IF (I1  .NE. 0.0) GO TO 70
      K1B = 0.0
      GO TO 90
   70 K1B = -M1B/I1
      GO TO 90
   80 K1B = (M2BT*I12 - M1B *I2)/(I1*I2 - I12**2)
      K2B = (M1B *I12 - M2BT*I1)/(I1*I2 - I12**2)
      GO TO 110
   90 IF (I2 .NE. 0.0) GO TO 100
      K2B = 0.0
      GO TO 110
  100 K2B = -M2BT/I2
C
C     COMPUTE SIG1B, SIG2B, SIG3B AND SIG4B
C
  110 SIG1B = K1B*C1*C + K2B*C2
      SIG2B = K1B*D1*C + K2B*D2
      SIG3B = K1B*F1*C + K2B*F2
      SIG4B = K1B*G1*C + K2B*G2
      IF (TLOADS .EQ. 0) GO TO 115
C
C     TEST IF AT LEAST ONE POINT TEMPERATURE IS GIVEN
C
      DO 111 I = 7,14
      IF (TI(I) .NE. 0.0) GO TO 112
  111 CONTINUE
      GO TO 115
  112 IF (A .EQ. 0.0) GO TO 115
      EALF  =-ST/A
      SIG1A = SIG1A + EALF*(TI( 7) - TI(3)*C1*C - TI(5)*C2 - TI(1))
      SIG2A = SIG2A + EALF*(TI( 8) - TI(3)*D1*C - TI(5)*D2 - TI(1))
      SIG3A = SIG3A + EALF*(TI( 9) - TI(3)*F1*C - TI(5)*F2 - TI(1))
      SIG4A = SIG4A + EALF*(TI(10) - TI(3)*G1*C - TI(5)*G2 - TI(1))
      SIG1B = SIG1B + EALF*(TI(11) - TI(4)*C1*C - TI(6)*C2 - TI(2))
      SIG2B = SIG2B + EALF*(TI(12) - TI(4)*D1*C - TI(6)*D2 - TI(2))
      SIG3B = SIG3B + EALF*(TI(13) - TI(4)*F1*C - TI(6)*F2 - TI(2))
      SIG4B = SIG4B + EALF*(TI(14) - TI(4)*G1*C - TI(6)*G2 - TI(2))
  115 CONTINUE
C
C     COMPUTE AXIAL STRESS
C
      SIGAX = 0.0
      SIGBX = 0.0
      IF (A .NE. 0.0) SIGAX = FX/A
      IF (A .NE. 0.0) SIGBX = FXBT/A
C
C     COMPUTE MAXIMA AND MINIMA
C
      SIGAMX = SIGAX + AMAX1(SIG1A,SIG2A,SIG3A,SIG4A)
      SIGBMX = SIGBX + AMAX1(SIG1B,SIG2B,SIG3B,SIG4B)
      SIGAMN = SIGAX + AMIN1(SIG1A,SIG2A,SIG3A,SIG4A)
      SIGBMN = SIGBX + AMIN1(SIG1B,SIG2B,SIG3B,SIG4B)
C
C     COMPUTE MARGIN OF SAFETY IN TENSION
C
      IF (SIGMAT .LE. 0.0) GO TO 620
      IF (AMAX1(SIGAMX,SIGBMX) .LE. 0.0) GO TO 620
      Q = SIGMAT/AMAX1(SIGAMX,SIGBMX)
      SMTEN = Q - 1.0
      GO TO 630
  620 MSTEN = 1
C
C     COMPUTE MARGIN OF SAFETY IN COMPRESSION
C
  630 IF (SIGMAC .LE. 0.0) GO TO 640
      IF (AMIN1(SIGAMN,SIGBMN) .GE. 0.0) GO TO 640
      W = -SIGMAC/AMIN1(SIGAMN,SIGBMN)
      SMCOM  = W - 1.0
      GO TO 150
  640 MSCOM  = 1
  150 ISELID = JELID
      IFELID = JELID
      RETURN
      END

      SUBROUTINE STUBE1
C*****
C THE TUBE BEING SO SIMILAR TO THE ROD, WE ALTER THE ECPT FOR THE TUBE
C SO THAT IT IS IDENTICAL TO THE ONE FOR THE ROD AND THEN CALL SROD1
C TO COMPUTE THE PHASE I PARAMETERS FOR STRESS DATA RECOVERY FOR THE ROD
C*****
C
C
C
C                      E C P T  F O R  T H E  T U B E
C
C
C
C ECPT( 1)  -  ELEMENT ID.
C ECPT( 2)  -  SCALAR INDEX NUMBER FOR GRID POINT A
C ECPT( 3)  -  SCALAR INDEX NUMBER FOR GRID POINT B
C ECPT( 4)  -  MATERIAL ID.
C ECPT( 5)  -  OUTSIDE DIAMETER
C ECPT( 6)  -  THICKNESS
C ECPT( 7)  -  NON-STRUCTURAL MASS
C ECPT( 8)  -  COOR. SYS. ID. FOR GRID POINT A
C ECPT( 9)  -  BASIC COORDINATES OF GRID POINT A
C ECPT(10)  -                ...
C ECPT(11)  -                ...
C ECPT(12)  -  COOR. SYS. ID. FOR GRID POINT B
C ECPT(13)  -  BASIC COORDINATES OF GRID POINT B
C ECPT(14)  -                ...
C ECPT(15)  -                ...
C ECPT(16)  -  ELEMENT TEMPERATURE
C
C
C
C
C SDR2 PHASE I INPUT AND OUTPUT BLOCK
C
      COMMON   /SDR2X5/
     1                   ECPT(16)           ,DUM(84)
C
C SDR2 SCRATCH BLOCK
C
      COMMON   /SDR2X6/
     1                   TEMP               ,A
     2,                  FJ                 ,C
C
C PHYSICAL CONSTANTS
C
      COMMON /CONDAS/    PI       ,TWOPI    ,RADEG    ,DEGRA    ,
     1                   S4PISQ
C
C
C
      TEMP = ECPT(5) - ECPT(6)
C
C COMPUTE AREA, TORSIONAL INERTIA AND STRESS COEFFICIENT.
C
      A = TEMP * ECPT(6) * PI
      FJ = .25 * A * (TEMP**2  +  ECPT(6)**2)
      C  = .5  * ECPT(5)
C
C MOVE THE -END- OF THE ARRAY -DOWN ONE SLOT- SO THAT ENTRIES 7 THRU 16
C OF THE ECPT WILL BE STORED AT POSITIONS 8 THRU 17.
C
      M = 18
      DO 10 I = 1,10
      M = M - 1
   10 ECPT(M) = ECPT(M-1)
      ECPT(5) = A
      ECPT(6) = FJ
      ECPT(7) = C
      CALL SROD1
      RETURN
      END

      SUBROUTINE SSGKHI (TREAL,TINT,FN)
C
C     THIS SUBROUTINE COMPUTES THE (5X1) KHI  VECTOR FOR USE BY TRBSC,
C                                           E
C     TRPLT, AND QDPLT.
C
C     WHEN PROCESSING THE TRPLT OR QDPLT THIS ROUTINE SHOULD BE CALLED
C     AFTER THE FIRST SUBTRIANGLE ONLY DUE TO THE D MATRIX ORIENTATION.
C
      INTEGER         TINT(6),INDEX(9)
      REAL            TREAL(6),KHI
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /SSGTRI/ D(9),KHI(5),KS(30),P(6)
      COMMON /MATOUT/ DUM(7),ALPHA1,ALPHA2,ALPH12
      COMMON /TRIMEX/ EID
      COMMON /SYSTEM/ SYSBUF,IOUT
C
C     DETERMINE TYPE OF TEMPERATURE DATA
C
      IF (TINT(6) .NE. 1) GO TO 100
C
C     TEMPERATURE DATA IS TEMPP1 OR TEMPP3 TYPE.
C
      KHI(1) = -ALPHA1*TREAL(2)*FN
      KHI(2) = -ALPHA2*TREAL(2)*FN
      KHI(3) = -ALPH12*TREAL(2)*FN
      GO TO 120
C
C     TEMPERATURE DATA IS TEMPP2 TYPE.
C
C     NO NEED TO COMPUTE DETERMINANT SINCE IT IS NOT USED SUBSEQUENTLY.
C
  100 ISING = -1
      CALL INVERS (3,D(1),3,0,0,DETERM,ISING,INDEX)
      IF (ISING .NE. 2) GO TO 110
      WRITE  (IOUT,105) UFM,EID
  105 FORMAT (A23,' 4018, A SINGULAR MATERIAL MATRIX -D- FOR ELEMENT',
     1       I9,' HAS BEEN DETECTED BY ROUTINE SSGKHI', /26X,'WHILE ',
     2       'TRYING TO COMPUTE THERMAL LOADS WITH TEMPP2 CARD DATA.')
      CALL MESAGE (-61,0,0)
  110 CALL GMMATS (D(1),3,3,0, TREAL(2),3,1,0, KHI(1))
      KHI(1) = KHI(1)*FN
      KHI(2) = KHI(2)*FN
      KHI(3) = KHI(3)*FN
  120 KHI(4) = 0.0
      KHI(5) = 0.0
      RETURN
      END

      SUBROUTINE STRP11
C
C     PHASE 1 STRESS DATA RECOVERY FOR CTRPLT1 - HIGHER ORDER PLATE
C     ELEMENT
C
C     OUTPUTS FROM THIS PHASE FOR USE IN PHASE II ARE THE FOLLOWING
C
C     1) ELEMENT ID              WORDS    1     STORAGE IN PH1OUT  1
C     2) SIX SILS                WORDS    6                      2-7
C     3) BENDING THICKNESSES     WORDS    3                      8-10
C     4) STRESS POINTS           WORDS    8                     11-18
C     5) 4 NOS. 6 5X6 S MATRICES WORDS    720                   19-738
C     6) 3X1 S SUB T MATRIX      WORDS    3                    739-741
C
C     ECPT ENTRIES
C     AS IN STIFFNESS ROUTINE KTRPL1
C
      LOGICAL          NOTS
      REAL             J11,J12,J22,NSM,IVECT,JVECT,KVECT
      DOUBLE PRECISION DETERM
      DIMENSION        NAME(2),INDEX(20,3),ICS(6),NL(6),Q(6,6),IND(6,3),
     1                 EMOD(9),XC(6),YC(6),ZC(6),QQQ(20,20),QQQINV(360),
     2                 TS6(40),TS7(59),IEST(42),IVECT(3),JVECT(3),
     3                 KVECT(3),E(18),V1(3),V2(3),V3(3),E1(18),
     4                 PH1BEN(9),PH1SHR(6),PH2(18),PH3(12),PH4(90),
     5                 TRANS(9),BALOTR(36),D(9),DPH1(9),G(4),GPH1(6),
     6                 NPH1OU(990)
      COMMON /SDR2X5/  EST(100),PH1OUT(990),FORVEC(24),
     1                 X,Y,Z,DISTA,DISTB,DISTC,A1,A2,A3,B1,B2,B3,
     2                 QQQINV,TS6,TS7,PH2,PH3,PH4,Q,E,E1,TRANS,BALOTR
C
C     INPUT AND OUTPUT BLOCKS FOR SUBROUTINE MAT
C
      COMMON /MATIN /  MATID,MATFLG,ELTEMP,PLA34,SINTH,COSTH
      COMMON /MATOUT/  EM(6),RHOY,ALF(3),TREF,GSUBE,SIGTY,SIGCY,SIGSY,
     1                 RJ11,RJ12,RJ22
C
C
C     EQUIVALENCE IECPT WITH ECPT IN COMMON BLOCK /SMA1ET/ SINCE ECPT IS
C     A MIXED INTEGER AND REAL ARRAY
C
      EQUIVALENCE     (A,DISTA), (B,DISTB), (C,DISTC),
     1                (V1(1),EST(19)),(V2(1),EST(23)),(V3(1),EST(27)),
     2                (IEST(1),EST(1)),
     3                (D11,EM(1)),(D12,EM(2)), (D13,EM(3)),
     4                (D22,EM(4)),(D23,EM(5)), (D33,EM(6))
      EQUIVALENCE     (NPH1OU(1),PH1OUT(1))
      EQUIVALENCE     (PH1OUT(401),INDEX(1,1),IND(1,1))
      EQUIVALENCE     (PH1OUT(1),QQQ(1,1))
      DATA  DEGRA  /  0.0174532925            /
      DATA  BLANK  ,  NAME / 4H    , 4HCTRP, 4HLT1   /
C
      NOTS  =.FALSE.
      IDELE = IEST(1)
      DO 109 I = 1,6
      NL(I) = IEST(I+1)
  109 CONTINUE
      THETAM = EST(8)
      MATID1 = IEST(9)
      TMEM1  = (EST(10)*12.0)**0.333333333333
      TMEM3  = (EST(11)*12.0)**0.333333333333
      TMEM5  = (EST(12)*12.0)**0.333333333333
      MATID2 = IEST(13)
      TSHR1  = EST(14)
      TSHR3  = EST(15)
      TSHR5  = EST(16)
      NSM    = EST(17)
      J      = 0
      DO 120 I = 24,44,4
      J      = J + 1
      ICS(J) = IEST(I)
      XC(J)  = EST(I+1)
      YC(J)  = EST(I+2)
      ZC(J)  = EST(I+3)
  120 CONTINUE
C
C     IF TMEM3 OR TMEM5 IS ZERO OR BLANK, THEY WILL BE SET EQUAL TO
C     TMEM1
C     SO ALSO FOR TEMP3 OR TEMP5
C
      IF (TMEM3.EQ.0.0 .OR. TMEM3.EQ.BLANK) TMEM3 = TMEM1
      IF (TMEM5.EQ.0.0 .OR. TMEM5.EQ.BLANK) TMEM5 = TMEM1
      IF (TSHR3.EQ.0.0 .OR. TSHR3.EQ.BLANK) TSHR3 = TSHR1
      IF (TSHR5.EQ.0.0 .OR. TSHR5.EQ.BLANK) TSHR5 = TSHR1
      IF (TSHR1 .EQ. 0.0) NOTS = .TRUE.
      ELTEMP = EST(48)
      THETA1 = THETAM*DEGRA
      SINTH  = SIN(THETA1)
      COSTH  = COS(THETA1)
      IF (ABS(SINTH) .LE. 1.0E-06) SINTH = 0.0
C
C     EVALUATE MATERIAL PROPERTIES
C
      MATFLG = 2
      MATID  = MATID1
      CALL MAT (IDELE)
C
      EMOD(1) = D11
      EMOD(2) = D12
      EMOD(3) = D13
      EMOD(4) = D12
      EMOD(5) = D22
      EMOD(6) = D23
      EMOD(7) = D13
      EMOD(8) = D23
      EMOD(9) = D33
      MATID   = MATID2
      MATFLG  = 3
      J11     = 0.0
      J12     = 0.0
      J22     = 0.0
      IF (NOTS) GO TO 146
      CALL MAT (IDELE)
  146 CONTINUE
C
C     CALCULATIONS FOR THE TRIANGLE
C
      CALL TRIF (XC,YC,ZC,IVECT,JVECT,KVECT,A,B,C,IEST(1),NAME)
      CALL AF (F,1,A,B,C,A1,A2,A3,TMEM1,TMEM3,TMEM5,1)
      CALL AF (F,1,A,B,C,B1,B2,B3,TSHR1,TSHR3,TSHR5,1)
C
C     FILL E-MATRIX
C
      DO 177 I = 1,18
  177 E( I) = 0.0
      E( 1) = KVECT(1)
      E( 4) = KVECT(2)
      E( 7) = KVECT(3)
      E(11) = IVECT(1)
      E(14) = IVECT(2)
      E(17) = IVECT(3)
      E(12) = JVECT(1)
      E(15) = JVECT(2)
      E(18) = JVECT(3)
C
C     NO NEED TO COMPUTE DETERMINANT SINCE IT IS NOT USED SUBSEQUENTLY.
C
      ISING = -1
C
C     CALCULATIONS FOR QMATRIX (QQQ) AND ITS INVERSE
C
      DO 110 I = 1,20
      DO 110 J = 1,20
  110 QQQ(I,J) = 0.0
      DO 115 I = 1,6
      I1 = (I-1)*3 + 1
      I2 = (I-1)*3 + 2
      I3 = (I-1)*3 + 3
      QQQ(I1, 1) = 1.0
      QQQ(I1, 2) = XC(I)
      QQQ(I1, 3) = YC(I)
      QQQ(I1, 4) = XC(I)*XC(I)
      QQQ(I1, 5) = XC(I)*YC(I)
      QQQ(I1, 6) = YC(I)*YC(I)
      QQQ(I1, 7) = QQQ(I1, 4)*XC(I)
      QQQ(I1, 8) = QQQ(I1, 4)*YC(I)
      QQQ(I1, 9) = QQQ(I1, 5)*YC(I)
      QQQ(I1,10) = QQQ(I1, 6)*YC(I)
      QQQ(I1,11) = QQQ(I1, 7)*XC(I)
      QQQ(I1,12) = QQQ(I1, 7)*YC(I)
      QQQ(I1,13) = QQQ(I1, 8)*YC(I)
      QQQ(I1,14) = QQQ(I1, 9)*YC(I)
      QQQ(I1,15) = QQQ(I1,10)*YC(I)
      QQQ(I1,16) = QQQ(I1,11)*XC(I)
      QQQ(I1,17) = QQQ(I1,12)*YC(I)
      QQQ(I1,18) = QQQ(I1,13)*YC(I)
      QQQ(I1,19) = QQQ(I1,14)*YC(I)
      QQQ(I1,20) = QQQ(I1,15)*YC(I)
      QQQ(I2, 3) = 1.0
      QQQ(I2, 5) = XC(I)
      QQQ(I2, 6) = YC(I)*2.0
      QQQ(I2, 8) = QQQ(I1, 4)
      QQQ(I2, 9) = QQQ(I1, 5)*2.0
      QQQ(I2,10) = QQQ(I1, 6)*3.0
      QQQ(I2,12) = QQQ(I1, 7)
      QQQ(I2,13) = QQQ(I1, 8)*2.0
      QQQ(I2,14) = QQQ(I1, 9)*3.0
      QQQ(I2,15) = QQQ(I1,10)*4.0
      QQQ(I2,17) = QQQ(I1,12)*2.0
      QQQ(I2,18) = QQQ(I1,13)*3.0
      QQQ(I2,19) = QQQ(I1,14)*4.0
      QQQ(I2,20) = QQQ(I1,15)*5.0
      QQQ(I3, 2) =-1.0
      QQQ(I3, 4) =-2.0*XC(I)
      QQQ(I3, 5) =-YC(I)
      QQQ(I3, 7) =-QQQ(I1, 4)*3.0
      QQQ(I3, 8) =-QQQ(I1, 5)*2.0
      QQQ(I3, 9) =-QQQ(I1, 6)
      QQQ(I3,11) =-QQQ(I1, 7)*4.0
      QQQ(I3,12) =-QQQ(I1, 8)*3.0
      QQQ(I3,13) =-QQQ(I1, 9)*2.0
      QQQ(I3,14) =-QQQ(I1,10)
      QQQ(I3,16) =-QQQ(I1,11)*5.0
      QQQ(I3,17) =-QQQ(I1,13)*3.0
      QQQ(I3,18) =-QQQ(I1,14)*2.0
      QQQ(I3,19) =-QQQ(I1,15)
C
C     IF NO TRANSVERSE SHEAR GO TO 113
C
      IF (NOTS) GO TO 1137
      X = XC(I)
      Y = YC(I)
      CALL STRPTS (TS6,NOTS)
      DO 113 JJ = 1,20
      QQQ(I2,JJ) = QQQ(I2,JJ) - TS6(20+JJ)
      QQQ(I3,JJ) = QQQ(I3,JJ) + TS6(   JJ)
  113 CONTINUE
 1137 CONTINUE
  115 CONTINUE
      QQQ(19,16) = 5.0*A**4*C
      QQQ(19,17) = 3.0*A**2*C**3 - 2.0*A**4*C
      QQQ(19,18) =-2.0*A*C**4 + 3.0*A**3*C**2
      QQQ(19,19) = C**5 - 4.0*A**2*C**3
      QQQ(19,20) = 5.0*A*C**4
      QQQ(20,16) = 5.0*B**4*C
      QQQ(20,17) = 3.0*B**2*C**3 - 2.0*B**4*C
      QQQ(20,18) = 2.0*B*C**4 - 3.0*B**3*C**2
      QQQ(20,19) = C**5 - 4.0*B**2*C**3
      QQQ(20,20) =-5.0*B*C**4
C
C     FOURTH ARGUMENT IS A DUMMY LOCATION FOR INVERSE AND HENCE TS1(1)
C     IS U
C
      CALL INVERS (20,QQQ,20,TS6(1),0,DETERM,ISING,INDEX)
C
C     ISING EQUAL TO 2 IMPLIES THAT QQQ IS SINGULAR
C
C     FIRST 18 COLUMNS OF QQQ INVERSE IS THE QQQINV FOR USE IN STIFFNESS
C     MATRIX CALCULATIONS
C
      DO 152 I = 1,20
      DO 152 J = 1,18
      IJ = (I-1)*18 + J
      QQQINV(IJ) = QQQ(I,J)
  152 CONTINUE
      DO 154 I = 1,36
  154 BALOTR(I) = 0.0
C
      DO 102 I = 1,7
      PH1OUT(I) = EST(I)
  102 CONTINUE
      PH1OUT( 8) = TMEM1
      PH1OUT( 9) = TMEM3
      PH1OUT(10) = TMEM5
      PH1OUT(11) = EST(18)
      PH1OUT(12) = EST(19)
      PH1OUT(13) = EST(20)
      PH1OUT(14) = EST(21)
      PH1OUT(15) = EST(22)
      PH1OUT(16) = EST(23)
      DO 700 JJ = 1,4
      JJ1 = JJ*2 - 1
      IF (JJ .NE. 4) X = XC(JJ1)
      IF (JJ .NE. 4) Y = YC(JJ1)
      IF (JJ .EQ. 4) X = (XC(1)+XC(3)+XC(5))/3.0
      IF (JJ .EQ. 4) Y = (YC(1)+YC(3)+YC(5))/3.0
      IF (JJ .EQ. 4) PH1OUT(17) = (A1+A2*X+A3*Y)/2.0
      IF( JJ .EQ. 4) PH1OUT(18) = -PH1OUT(17)
      DO 105 I = 1,60
      TS7(I) = 0.0
  105 CONTINUE
      AI = PH1OUT(7+JJ)**3/12.0
      IF (JJ .EQ. 4) AI = PH1OUT(17)**3/1.5
      DO 107 I = 1,9
  107 D(I) = EMOD(I)*AI
      X2  = X*X
      XY  = X*Y
      Y2  = Y*Y
      X3  = X2*X
      X2Y = X2*Y
      XY2 = X*Y2
      Y3  = Y2*Y
      TS7( 4) = 2.0
      TS7( 7) = 6.0*X
      TS7( 8) = 2.0*Y
      TS7(11) = 12.0*X2
      TS7(12) = 6.0*XY
      TS7(13) = 2.0*Y2
      TS7(16) = 20.0*X3
      TS7(17) = 6.0*XY2
      TS7(18) = 2.0*Y3
      TS7(26) = 2.0
      TS7(29) = 2.0*X
      TS7(30) = 6.0*Y
      TS7(33) = 2.0*X2
      TS7(34) = TS7(12)
      TS7(35) = 12.0*Y2
      TS7(37) = 2.0*X3
      TS7(38) = 6.0*X2Y
      TS7(39) = 12.0*XY2
      TS7(40) = 20.0*Y3
      TS7(45) = 2.0
      TS7(48) = 4.0*X
      TS7(49) = 4.0*Y
      TS7(52) = 6.0*X2
      TS7(53) = 8.0*XY
      TS7(54) = 6.0*Y2
      TS7(57) = 12.0*X2Y
      TS7(58) = TS7(39)
      TS7(59) = 8.0*Y3
      CALL GMMATS (TS7,3,20,0, QQQINV,20,18,0, PH4(1))
      CALL STRPTS (TS6,NOTS)
      CALL GMMATS (TS6,2,20,0, QQQINV,20,18,0, PH4(55))
      DO 600 II = 1,6
      IF (ICS(II) .EQ. 0) GO TO 130
      J = 4*II + 20
      CALL TRANSS (IEST(J),TRANS)
      DO 124 J = 1,3
      L = 6*(J-1) + 1
      M = 3*(J-1) + 1
      BALOTR(L   ) = TRANS(M  )
      BALOTR(L+ 1) = TRANS(M+1)
      BALOTR(L+ 2) = TRANS(M+2)
      BALOTR(L+21) = TRANS(M  )
      BALOTR(L+22) = TRANS(M+1)
      BALOTR(L+23) = TRANS(M+2)
  124 CONTINUE
      CALL GMMATS (E,6,3,+1, BALOTR,6,6,0, E1)
      GO TO 133
  130 CONTINUE
      DO 132 I = 1,3
      DO 132 J = 1,6
      I1 = (I-1)*6 + J
      J1 = (J-1)*3 + I
      E1(I1) = E(J1)
  132 CONTINUE
  133 CONTINUE
      KZ = (II-1)*3 + 1
      PH1BEN(1) = PH4(KZ   )
      PH1BEN(2) = PH4(KZ+ 1)
      PH1BEN(3) = PH4(KZ+ 2)
      PH1BEN(4) = PH4(KZ+18)
      PH1BEN(5) = PH4(KZ+19)
      PH1BEN(6) = PH4(KZ+20)
      PH1BEN(7) = PH4(KZ+36)
      PH1BEN(8) = PH4(KZ+37)
      PH1BEN(9) = PH4(KZ+38)
      CALL GMMATS (D,3,3,0, PH1BEN,3,3,0, DPH1)
      CALL GMMATS (DPH1,3,3,0, E1,3,6,0, PH2)
      MZ = (II-1)*3 + 55
      PH1SHR(1) = PH4(MZ   )
      PH1SHR(2) = PH4(MZ+ 1)
      PH1SHR(3) = PH4(MZ+ 2)
      PH1SHR(4) = PH4(MZ+18)
      PH1SHR(5) = PH4(MZ+19)
      PH1SHR(6) = PH4(MZ+20)
      IF (NOTS) GO TO 166
      THK  = B1 + B2*X + B3*Y
      G(1) = EM(6)*THK
      G(2) = 0.0
      G(3) = 0.0
      G(4) = G(1)
      CALL GMMATS (G,2,2,0, PH1SHR,2,3,0, GPH1)
      GO TO 168
  166 CONTINUE
      GPH1(1) = PH1SHR(1)
      GPH1(2) = PH1SHR(2)
      GPH1(3) = PH1SHR(3)
      GPH1(4) = PH1SHR(4)
      GPH1(5) = PH1SHR(5)
      GPH1(6) = PH1SHR(6)
  168 CONTINUE
      CALL GMMATS (GPH1,2,3,0, E1,3,6,0, PH3)
      DO 148 I = 1,3
      DO 148 J = 1,6
      I1 = (I-1)*6 + J
      I2 = I1 + 18
      J1 = (II-1)*30 + (JJ-1)*180 + I1 + 18
      J2 = J1 + 18
      PH1OUT(J1) = PH2(I1)
      IF (I .NE. 3) PH1OUT(J2) = PH3(I1)
  148 CONTINUE
  600 CONTINUE
      JJ1 = (JJ-1)*3 + 1
      CALL GMMATS (D,3,3,0, ALF,3,1,0, PH1OUT(738+JJ1))
  700 CONTINUE
      RETURN
      END

      SUBROUTINE IFP5A (NUM)
C
C     IFP5A PRINTS MESSAGE NUMBER LINE ONLY.
C     CALLING SUBROUTINE PRINTS THE MESSAGE.
C
      LOGICAL         NOGO
      INTEGER         OUTPUT
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /SYSTEM/ SYSBUF,OUTPUT,NOGO
C
      CALL PAGE2 (4)
      I = NUM + 4080
      WRITE  (OUTPUT,10) UFM,I
   10 FORMAT (A23,I15,1H.)
      NOGO = .TRUE.
      RETURN
      END

      SUBROUTINE DSXFSZ
      INCLUDE 'DSIOF.COM'
      INCLUDE 'GINOX.COM'
      COMMON / XFIST / LFIST, NFIST, IFIST( 100 )
      COMMON / XFIAT / IFIAT( 643 )
      COMMON / ZZZZZZ/ MEM(2)
      IDSN   = IFILEX
      NUN    = 0
      ITOTAL = 0
10    LASBLK = FCB( 6,IDSN )
      IFRBLK = FCB( 5,IDSN )
      NUMBLK = LASBLK - IFRBLK + 1
      IF ( IDSN .EQ. IFILEX ) GO TO 20
      NUN    = NUN + 1
      ITOTAL = ITOTAL + NUMBLK
      GO TO 40
20    IPBLKS = NUMBLK
      IF ( FCB( 10, IFILEX ) .EQ. 0 ) GO TO 40
      INDEX  = FCB( 10, IFILEX )
      LBLOCK = MEM( INDEX+3 )
      IPBLKS = IPBLKS + LBLOCK
40    IDSN   = IAND( MDSFCB( 3,IDSN ), MASKH2 )
      IF ( IDSN .NE. 0 ) GO TO 10
      LIM    = 2 * NFIST
      DO 50 I = 1,LIM,2
      IF ( NAME .NE. IFIST( I ) ) GO TO 50
      IF ( IFIST( I+1 ) .LE. 0 ) GO TO 70
      INDX   = IFIST( I+1 )
      IFIAT( INDX+7 ) = IPBLKS * 2**16 + NUN * 2**8
      IFIAT( INDX+8 ) = ITOTAL * 2**16
      GO TO 70
50    CONTINUE
70    CONTINUE
      MAXUSM = 0
      MAXUSD = 0
C ACCUMULATE TOTAL I/O USAGE STATISTICS
      DO 100 I = 1, 80
      IF ( I .EQ. 7 ) GO TO 100
      ITOTL1 = 0
      ITOTL2 = 0
      IF ( FCB( 4, I ) .EQ. 0 ) GO TO 100
      NEXBLK  = FCB( 10, I )
      IF ( NEXBLK .NE. 0 ) ITOTL1 = MEM( NEXBLK+3 )
      IF ( FCB( 5, I ) .NE. 0 )
     &   ITOTL2 = FCB( 6, I ) - FCB( 5, I ) + 1
      MAXUSM = MAXUSM + ITOTL1
      MAXUSD = MAXUSD + ITOTL2
100   CONTINUE
      IF ( MAXBLK .LT. MAXUSM ) MAXBLK = MAXUSM
      IF ( MAXDSK .LT. MAXUSD ) MAXDSK = MAXUSD
      RETURN
      END

      SUBROUTINE MODB
C
C*****
C
C     DUMMY DECK FOR MODULE MODB   SEE USERS MANUAL SECTION 5.3
C                                  FOR MODULE PROPERTIES CHECK XMPLBD
C                                  OR USE DIAG 29
C
C*****
C
      INTEGER IPARM1   , IPARM2
C     INTEGER INFILE(3), OUTFIL(4)
C
      COMMON /BLANK/ PARM(4),IPARM1(3),PARM8,IPARM2(3)
C
C     DATA INFILE /101,102,103/
C     DATA OUTFIL /201,202,203,104/
C
      RETURN
      END

      SUBROUTINE SDCOM4( P, AC, WA, WB )
C******
C
C SDCOM4 COMPUTES THE CONTRIBUTIONS OF THE PIVOT ROW FOR SDCOMP IN CDP
C
C******
      INTEGER AC(1), ROW, C, START, SC
C
      DOUBLE PRECISION P(2), WA(1), WB(1), PIR, PII
      DOUBLE PRECISION  P1,  P2
C
      COMMON/ SDCOMX / ROW, C, SPFLG, START, FRSTPC, LASTPL, LASTI, SC
C
      J = 1
      L = 1
C
C FOR THE OUTER LOOP I RUNS FROM START TO LASTI.
C BEGIN BY FORMING -P(I)/P(1). THEN DECIDE WHICH INNER LOOP TO EXECUTE
C
      P2 = P(1)**2 + P(2)**2
      P1 = P(1) / P2
      P2 = P(2) / P2
      DO 48 I=START,LASTI
      PIR = -P(2*I-1) * P1 - P(2*I) * P2
      PII =  P(2*I-1) * P2 - P(2*I) * P1
      IF( I .LE. LASTPL ) GO TO 30
      IF( AC(I) .LT. 0 ) GO TO 20
      K1 = I
C
C LOOP 1 -- L IS INCREMENTED WHENEVER AC(K) .GT. 0
C
   10 DO 18 K=K1,C
      IF( AC(K) .GT. 0 ) GO TO 12
      WB(J  ) = PIR*P(2*K-1) - PII*P(2*K  )
      WB(J+1) = PIR*P(2*K  ) + PII*P(2*K-1)
      GO TO 14
   12 WB(J  ) = PIR*P(2*K-1) - PII*P(2*K  ) + WA(L  )
      WB(J+1) = PIR*P(2*K  ) + PII*P(2*K-1) + WA(L+1)
      L = L + 2
   14 J = J + 2
   18 CONTINUE
      GO TO 40
C
C LOOP 2 -- L IS NEVER INCREMENTED
C
   20 DO 28 K=I,C
      WB(J  ) = PIR*P(2*K-1) - PII*P(2*K  )
      WB(J+1) = PIR*P(2*K  ) + PII*P(2*K-1)
      J = J + 2
   28 CONTINUE
      GO TO 40
C
C LOOP 3 -- K RUNS FROM I TO LASTPL AND L IS INCREMENTED EVERY TIME
C           THEN, IF LASTPL .LT. C, LOOP 1 IS EXECUTED TO FINISH IT UP
C
   30 DO 38 K=I,LASTPL
      WB(J  ) = PIR*P(2*K-1) - PII*P(2*K  ) + WA(L  )
      WB(J+1) = PIR*P(2*K  ) + PII*P(2*K-1) + WA(L+1)
      L = L + 2
      J = J + 2
   38 CONTINUE
      IF( LASTPL .EQ. C ) GO TO 40
      K1 = LASTPL + 1
      GO TO 10
C
C END OUTER LOOP BY STORING -P(I)/P(1) AT P(1).
C
   40 P(2*I-1 ) = PIR
      P(2*I   ) = PII
   48 CONTINUE
      RETURN
      END

      SUBROUTINE SGEN
C
C     THIS MODULE PREPARES THE INPUT FILES TO NASTRAN FROM A SUBSTRUCTUR
C     FORMULATION IN ORDER TO RUN THE SOLUTION PHASE OF NASTRAN.
C     3 MAJOR STEPS ARE-
C
C     1.  READ CONSTRAINT AND DYNAMICS DATA, CONVERT TO PSEUDO-STRUCTURE
C         DATA, AND OUTPUT ON GP4S AND DYNS.
C
C     2.  READ LOAD COMBO. DATA AND ASSEMBLE SCALAR LOAD SETS ON OUTPUT
C         FILE GP3S.
C
C     3.  BUILD DUMMY FILES FOR EXECUTION- CASEI, GPL, EQEXIN, GPDT,
C         BGPDT, CSTM, AND SIL.
C
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        ANDF,ORF,COMPLF
      LOGICAL         NOLC,NOLS,PSUEDO,STEST
      INTEGER         TEMP(10),TEMP2(10),TYPE(2),SPCS1(2),SPCSD(2),
     1                MPCS(2),SPCS(2),LOADC(2),CTYPES(2,8),CTYPEO(2,8),
     2                DAREAS(2),DELAYS(2),DPHSES(2),TICS(2),NLIMIT(3),
     3                MINUS(3),ICODE(4,9),ICOMP(32),LTAB(4,9),MCB(7),
     4                LSLOAD(3),LLOAD(3),NSGEN(2),NCASEC(2),Z(4)
      REAL            RZ,FACT,RTEMP(10),RTEMP2(10)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG / UFM,UWM,UIM,SFM
      COMMON /BLANK / DRY,NAME(2),LUSET,NOGPDT
      COMMON /SGENCM/ NONO,NSS,IPTR,BUF1,BUF2,BUF3,NZ
      COMMON /ZZZZZZ/ RZ(1)
      COMMON /SYSTEM/ IBUF,OUTT
      COMMON /TWO   / TWO(2)
      COMMON /UNPAKX/ ITY,IROW,NROW,INCR
      EQUIVALENCE     (RZ(1),Z(1)),            (TEMP(1),RTEMP(1)),
     1                (TEMP2(1),RTEMP2(1)),
     2                (CTYPES(1,1),MPCS(1)),   (CTYPES(1,2),SPCS(1)),
     3                (CTYPES(1,3),SPCS1(1)),  (CTYPES(1,4),SPCSD(1)),
     4                (CTYPES(1,5),DAREAS(1)), (CTYPES(1,6),DELAYS(1)),
     5                (CTYPES(1,7),DPHSES(1)), (CTYPES(1,8),TICS(1))
      DATA    MINUS , NLIMIT /3*-1, 3*2147483647 /,
     1        EQSS  / 4HEQSS /,     LODS /4HLODS /
      DATA    CASEC , GEOM3 ,GEOM4 ,DYNAM        /
     1        101   , 102   ,103   ,104          /,
     2        CASES , CASEI ,GPL   ,EQEX  ,GPDT  /
     3        201   , 202   ,203   ,204   ,205   /,
     4        BGPDT , SIL   ,GP3S  ,GP4S  ,DYNS  /
     5        206   , 207   ,208   ,209   ,210   /,
     6        SCRT  , SCRT2 /
     7        201   , 202   /
      DATA    PVEC  / 4HPVEC/      ,NSGEN / 4HSGEN,4H    /
C
C     BULK DATA CARD CODES
C
      DATA    ICODE /
C             MPCS
     1                1110  ,11    ,0     ,0      ,
C             SPCS
     2                810   ,8     ,0     ,0      ,
C             SPCS1
     3                710   ,7     ,0     ,0      ,
C             SPCSD
     4                610   ,6     ,0     ,0      ,
C             LOADC
     5                500   ,5     ,0     ,0      ,
C             DAREAS
     6                9027  ,90    ,0     ,0      ,
C             DELAYS
     7                9137  ,91    ,0     ,0      ,
C             DPHASES
     8                9277  ,92    ,0     ,0      ,
C             TICS
     9                9307  ,93    ,0     ,0      /
C
      DATA    NTYPEC / 4 /
      DATA    NTYPED / 4 /
      DATA    LTAB   /
C             MPC
     1                4901  ,49    ,17    ,1      ,
C             SPC
     2                5501  ,55    ,16    ,2      ,
C             SPC1
     3                5481  ,58    ,12    ,3      ,
C             SPCD
     4                5110  ,51    ,256   ,4      ,
C             LOADC
     5                500   ,5     ,264   ,0      ,
C             DAREA
     6                27    ,17    ,182   ,5      ,
C             DELAY
     7                37    ,18    ,183   ,6      ,
C             DPHASE
     8                77    ,19    ,184   ,7      ,
C             TIC
     9                6607  ,66    ,137   ,8      /
      DATA    LLOAD / 4551  ,61    ,84    /       ,
     1        LSLOAD/ 5401  ,54    ,25    /
      DATA    MPCS  / 4HMPCS,4H    /,     SPCS   / 4HSPCS,4H     /,
     1        SPCS1 / 4HSPCS,4H1   /,     SPCSD  / 4HSPCS,4HD    /,
     2        LOADC / 4HLOAD,4HC   /,     DAREAS / 4HDARE,4HAS   /,
     3        DELAYS/ 4HDELA,4HYS  /,     DPHSES / 4HDPHA,4HSES  /,
     4        TICS  / 4HTICS,4H    /
      DATA    NCASEC/ 4HCASE,4HCC  /
      DATA    CTYPEO/ 4HMPC ,4H    ,
     1                4HSPC ,4H    ,
     2                4HSPC1,4H    ,
     3                4HSPCD,4H    ,
     4                4HDARE,4HA   ,
     5                4HDELA,4HY   ,
     6                4HDPHA,4HSE  ,
     7                4HTIC ,4H    /
      DATA    XXXX  / 4HXXXX       /
C
C     INITIALIZE
C
      ITY  = 1
      INCR = 1
      NONO = 0
      LARGE= TWO(2)
      NZ   = KORSZ(Z(1))
      IBS1 = NZ   - IBUF + 1
      IBS2 = IBS1 - IBUF - 1
      IBS3 = IBS2 - IBUF
      BUF1 = IBS3 - IBUF
      BUF2 = BUF1 - IBUF
      BUF3 = BUF2 - IBUF
      BUF4 = BUF3 - IBUF
      NZ   = BUF4 - 1
      IF (NZ .LE. 0) GO TO 5011
      IF (NAME(1).EQ.XXXX .AND. NAME(2).EQ.XXXX) GO TO 3000
C
C     INITIALIZE LUSET AND NOGPDT FLAGS
C
      LUSET  = 0
      NOGPDT = -1
C
C     FORM TABLES OF REFERENCED SID-S FOR LOAD, MPC, AND SPC
C     CASE CONTROL CARDS.
C
C
C     OPEN  SOF , GET EQSS ITEM , READ  SIL DATA INTO CORE
C
      CALL SOFOPN (Z(IBS1),Z(IBS2),Z(IBS3))
      CALL SFETCH (NAME,EQSS,1,FLAG)
      ITEM  = EQSS
      IF (FLAG .NE. 1) GO TO 5001
      CALL SUREAD (Z(1),NZ,NWDS,FLAG)
      IF (FLAG .NE. 2) GO TO 5011
      NSS = Z(3)
      IZ  = NWDS + 1
C
C     READ SIL GROUP INTO CORE
C
      CALL SJUMP (NSS)
      CALL SUREAD (Z(IZ),NZ-IZ+1,NSIL,FLAG)
      IF  (FLAG .NE. 2) GO TO 5011
      IPT =  IZ + NSIL - 2
C
C     FIND LENGTH OF VECTOR = LUSET
C
      IC = Z(IPT+1)
      CALL DECODE (IC,ICOMP,NC)
      LUSET = Z(IPT) + NC - 1
      NOGPDT= LUSET
C
C     READ EQSS ( G ,IP, AND C AT A TIME) AND CONVERT IP TO SIL .
C     WRITE ON SCRT
C
      IS   = 0
      FILE = SCRT
      CALL GOPEN (SCRT,Z(BUF2),1)
      CALL SFETCH (NAME,EQSS,1,FLAG)
      NJ = 1
      CALL SJUMP (NJ)
C
   50 CALL SUREAD (TEMP,3,NWDS,FLAG)
      IF (FLAG .NE. 1) GO TO 100
      IPT  = IZ + 2*TEMP(2) - 2
      TEMP(2) = Z(IPT)
      CALL WRITE (SCRT,TEMP,3,0)
      GO TO 50
  100 IS = IS + 1
      CALL WRITE (SCRT,TEMP,0,1)
      IF (IS .LT. NSS) GO TO 50
      CALL CLOSE (SCRT,1)
C
C     READ CONVERTED EQSS INTO CORE, STORE POINTERS TO THE BASIC  SUBS
C     IN  Z(IPTR) TO Z(NPTR)
C     CORE WILL CONTAIN-
C       1. 4 WORD HEADER
C       2. 2*NSS NAMES
C       3. NSS+1 POINTERS TO EACH BASIC SUBST.BLOCK
C       4. NSS BLOCKS OF G, IP, C DATA
C       5. NZB LEFT OVER
C
C
      IPTR = IZ
      NPTR = IPTR
      ISUB = IPTR + NSS + 1
      NZB  = NZ - ISUB + 1
      FILE = SCRT
      CALL GOPEN (SCRT,Z(BUF2),0)
      DO 200 I = 1,NSS
      Z(NPTR) = ISUB
      NPTR = NPTR + 1
      CALL READ (*9002,*110,SCRT,Z(ISUB),NZB,1,NWDS)
      GO TO 5011
  110 ISUB = ISUB + NWDS
      NZB  = NZB  - NWDS
      IF (NZB .LE. 0) GO TO 5011
  200 CONTINUE
      Z(NPTR) = ISUB
      CALL CLOSE (SCRT,1)
C
C     ***  GEOM4 DATA CONVERSION  ***
C
C          IN  - MPCS,SPCS,SPCS1,SPCSD CARDS
C          OUT - MPC ,SPC ,SPC1 ,SCPD  ON SCRT
C
      FILE = GEOM4
      NOG4 = 0
      CALL PRELOC (*400,Z(BUF1),GEOM4)
      MCB(1) = GEOM4
      CALL RDTRL (MCB)
      CALL GOPEN (SCRT,Z(BUF2),1)
      STEST = .FALSE.
C
C     ***  MPCS CARDS  ***
C
C          IN  - NAME(2), G, C, F
C          OUT - SIL, 0, F
C
      CALL LOCATE (*350,Z(BUF1),ICODE(1,1),IDX)
      CALL WRITE (SCRT,ICODE(1,1),3,0)
      STEST = .TRUE.
      ICODE(4,1) = 1
      TYPE(1) = MPCS(1)
      TYPE(2) = MPCS(2)
      IFL = 0
      LID = 0
  305 CALL READ (*9002,*346,GEOM4,J,1,0,NWDS)
      IF (J .NE. LID) NSILD = 0
      LID = J
      CALL WRITE (SCRT,J,1,0)
  310 CALL READ (*9002,*346,GEOM4,TEMP,5,0,NWDS)
      IF (TEMP(3) .EQ.-1) GO TO 345
      IF (TEMP(3) .EQ. 0) GO TO 310
C
C     FIND  REQUESTED SUBSTRUCTURE
C
      DO 320 I = 1,NSS
      INAM = 2*I + 3
      IF (Z(INAM).EQ.TEMP(1) .AND. Z(INAM+1).EQ.TEMP(2)) GO TO 330
  320 CONTINUE
C
C     SUBSTRUCTURE NOT FOUND
C
      WRITE (OUTT,63290) UWM,TEMP(1),TEMP(2),TYPE,NAME
      GO TO 310
C
C     FOUND SUBSTRUCTURE NAME
C
  330 IPT  = IPTR + I - 1
      IGRD =  Z(IPT)
      NGRD = (Z(IPT+1) - Z(IPT))/3
C
C     SEARCH FOR GRID POINT
C
      CALL BISLOC (*334,TEMP(3),Z(IGRD),3,NGRD,IGR)
      IG = IGR + IGRD - 1
  325 IF (Z(IG-3) .NE. Z(IG)) GO TO 331
      IF (IG .LE. IGRD) GO TO 331
      IG = IG - 3
      GO TO 325
  331 CODE = Z(IG+2)
C
C     FIND   THE  COMPONENT
C
      CALL DECODE (CODE,ICOMP,NC)
      IF (TEMP(4) .EQ. 0) TEMP(4) = 1
      DO 332 I = 1,NC
      IF (TEMP(4) .NE. ICOMP(I)+1) GO TO 332
      IC = I
      GO TO 340
  332 CONTINUE
      IF (Z(IG+3) .NE. Z(IG)) GO TO 334
      IF (IG+3 .GE. IGRD+3*NGRD) GO TO 334
      IG = IG + 3
      GO TO 331
C
C     BAD COMPONENT
C
  334 NONO = 1
      WRITE (OUTT,60220) UFM,(TEMP(I),I=1,4),TYPE,NAME
      GO TO 310
C
C     WRITE CONVERTED DATA ON SCRT
C
  340 TEMP(6) = Z(IG+1) + IC - 1
      TEMP(7) = 0
      TEMP(8) = TEMP(5)
      CALL WRITE (SCRT,TEMP(6),3,0)
C
C     CHECK FOR DUPLICATE DEPENDENT SIL-S
C
      IF (IFL  .NE.  0) GO TO 310
      IF (NSILD .EQ. 0) GO TO 343
      DO 342 I = 1,NSILD
      IF (Z(ISUB+I-1) .NE. TEMP(6)) GO TO 342
      NONO = 1
      WRITE (OUTT,63620) UFM,J,TEMP(1),TEMP(2),TEMP(3),TEMP(4)
  342 CONTINUE
      IF (NSILD .GT. NZB) GO TO 5011
  343 Z(ISUB+NSILD) = TEMP(6)
      NSILD = NSILD + 1
      IFL = 1
      GO TO 310
C
C     FINISHED ONE LOGICAL CARD, WRITE -1 FLAGS
C
  345 CALL WRITE (SCRT,MINUS,3,0)
      IFL = 0
      GO TO 305
C
C     FINISHED ALL MPCS CARDS, WRITE EOR AND UPDATE TRAILER
C
  346 CALL WRITE (SCRT,TEMP,0,1)
C
C     TURN OFF MPCS BIT
C
      J = (ICODE(2,1)-1)/16
      I =  ICODE(2,1)- 16*J
      MCB(J+2) = ANDF(COMPLF(TWO(I+16)),MCB(J+2))
C
C     TURN ON MPC BIT
C
      J = (LTAB(2,1)-1)/16
      I =  LTAB(2,1)- 16*J
      MCB(J+2) = ORF(TWO(I+16),MCB(J+2))
C
C     ***  SPCS CARDS  ***
C
C          IN  - SID, NAME(2), G, C, G, C, G, C, ..., -1, -1
C          OUT - SID, SIL, 0, 0 - REPEATED FOR EACH GRID
C
  350 CALL SGENA (SPCS,Z(BUF1),MCB,GEOM4,ICODE(1,2),0,SCRT,LTAB(1,2),1)
C
C     ***  SPCS1 CARDS  ***
C
C          IN  - SID, NAME(2), C, G, G, G, ..., -1
C          OUT - SID, 0, SIL, -1 - REPEATED FOR EACH GRID
C
      CALL SGENB (SPCS1,Z(BUF1),MCB,GEOM4,ICODE(1,3),0,SCRT,LTAB(1,3),1)
C
C     ***  SPCSD CARDS  ***
C
C          IN  - SID, NAME(2), G, C, Y, ..., -1, -1, -1
C          OUT - SID, SIL, 0, Y - REPEATED FOR EACH GRID
C
      CALL SGENA (SPCSD,Z(BUF1),MCB,GEOM4,ICODE(1,4),1,SCRT,LTAB(1,4),1)
C
C     END OF CONSTRAINT CARD CONVERSION
C
      CALL CLOSE (GEOM4,1)
      CALL CLOSE (SCRT,1)
      MCB(1) = GP4S
      CALL WRTTRL (MCB)
      GO TO 700
  400 NOG4 = 1
C
C     ***  DYNAMICS DATA CONVERSION  ***
C
C          IN  - DAREAS,DELAYS,DPHASES,TICS CARDS
C          OUT - DAREA ,DELAY ,DPHASE ,TIC  ON SCRT
C
  700 FILE  = DYNAM
      NODYN = 0
      CALL PRELOC (*750,Z(BUF1),DYNAM)
      MCB(1) = DYNAM
      CALL RDTRL (MCB)
      CALL GOPEN (SCRT2,Z(BUF2),1)
C
C     ***  DAREAS  CARDS ***
C
C          IN  - SID, NAME(2), G, C, A, ..., -1, -1, -1
C          OUT - SID, SIL, 0, A - REPEATED FOR EACH GRID
C
      CALL SGENA (DAREAS,Z(BUF1),MCB,DYNAM,ICODE(1,6),1,SCRT2,LTAB(1,6),
     1            1)
C
C     ***  DELAYS CARDS  ***
C
C          IN  - SID, NAME(2), G, C, T, ..., -1, -1, -1
C          OUT - SID, SIL, 0, T - REPEATED FOR EACH GRID
C
      CALL SGENA (DELAYS,Z(BUF1),MCB,DYNAM,ICODE(1,7),1,SCRT2,LTAB(1,7),
     1            1)
C
C    ***  DPHASES CARDS  ***
C
C         IN  - SID, NAME(2), G, C, TH, ..., -1, -1, -1
C         OUT - SID, SIL, 0, TH - REPEATED FOR EACH GRID
C
      CALL SGENA (DPHSES,Z(BUF1),MCB,DYNAM,ICODE(1,8),1,SCRT2,LTAB(1,8),
     1            1)
C
C     ***  TICS CARDS  ***
C
C          IN  - SID, NAME(2), G, C, U, V, ..., -1, -1, -1, -1
C          OUT - SID, SIL, 0, U, V - REPEATED FOR EACH GRID
C
      CALL SGENA (TICS,Z(BUF1),MCB,DYNAM,ICODE(1,9),2,SCRT2,LTAB(1,9),2)
C
C     END OF DYNAMICS CONVERSION
C
      CALL CLOSE (DYNAM,1)
      CALL CLOSE (SCRT2,1)
      MCB(1) = DYNS
      CALL WRTTRL (MCB)
      GO TO 1000
  750 NODYN = 1
C
C     MERGE CONVERTED DATA WITH EXISTING DATA - GEOM4
C
 1000 IF (NOG4 .EQ. 1) GO TO 1500
      CALL SGENM (NTYPEC,GEOM4,SCRT,GP4S,ICODE(1,1),LTAB(1,1),
     1            CTYPES(1,1),CTYPEO(1,1))
C
C     MERGE CONVERTED DATA WITH EXISTING DATA - DYNAMICS
C
 1500 IF (NODYN .EQ. 1) GO TO 2005
      CALL SGENM (NTYPED,DYNAM,SCRT2,DYNS,ICODE(1,6),LTAB(1,6),
     1            CTYPES(1,1),CTYPEO(1,1))
C
C
C     ***  GEOM3 PROCESSING  ***
C
C     THE LOAD VECTORS ARE COMBINED BY THE FACTORS
C     GIVEN ON THE LOADC CARDS AND MERGED WITH SLOAD CARDS
C
 2005 CONTINUE
      NOLC = .TRUE.
      NOLS = .TRUE.
      CALL PRELOC (*2350,Z(BUF1),GEOM4)
      CALL LOCATE (*2350,Z(BUF1),ICODE(1,5),IDX)
C
C     READ FIRST GROUP OF LODS ITEM FOR SOLUTION STRUCTURE
C
      ITEM = LODS
      CALL SFETCH (NAME,LODS,1,FLAG)
      GO TO (2045,5001,2042,5001,5001), FLAG
C
C     LODS ITEM DOES NOT EXIST
C
 2042 NOLC = .TRUE.
      GO TO 2350
 2045 CALL SUREAD (Z(1),NZ,NWDS,ITEST)
      GO TO (5011,2047,5002), ITEST
 2047 NSS = Z(4)
      ISS1= 5
      NL  = Z(3)
      IPT = 2*NSS + 5
      IZL = 2*NSS + IPT + 2
      Z(IPT  ) = IZL
      Z(IPT+1) = 0
      IF (IZL+NSS+NL .LE. NZ) GO TO 2050
C
C     INSUFFICIENT CORE
C
      CALL CLOSE (GEOM4,1)
      GO TO 5011
C
C     READ REMAINDER OF LODS INTO OPEN CORE AT Z(IZL)
C
 2050 DO 2100 I = 1,NSS
      CALL SUREAD (Z(IZL),NZ-IZL+1,NWDS,ITEST)
      GO TO (5011,2060,5002), ITEST
 2060 IZL= IZL + NWDS
      JG = IPT + 2*I
      Z(JG  ) = IZL
      Z(JG+1) = Z(JG-1) + NWDS - 1
 2100 CONTINUE
C
C     CORE NOW CONTAINS
C
C            WORDS                 CONTENTS
C        ------------------    -----------------------------------
C        1--(IPT-1)            HEADER GROUP
C        IPT--IPT+2*(NSS+1)    LOAD DATA POINTER, NO. OF PRIOR LOAD
C                                  VECTORS (2 WORDS PER STRUCTURE)
C        IPT+2*(NSS+1)+1 --=   NO OF LOADS + LOAD SET IDS
C                                  GROUPED BY BASIC STRUCTURE
C
C     READ LOADC DATA CARDS AND CONVERT
C
C          IN  - SET ID, FACTOR, (NAME(2),SET,FACTOR) (REPEATED)
C          OUT - SET ID, FACTOR, (VECTOR NO.,FACTOR)
C
      TYPE(1) = LOADC(1)
      TYPE(2) = LOADC(2)
      CALL OPEN (*9001,SCRT,Z(BUF2),1)
 2150 CALL READ (*9002,*2300,GEOM4,TEMP,2,0,NWDS)
      CALL WRITE (SCRT,TEMP,2,0)
      LID = TEMP(1)
      NOLC=.FALSE.
C
C     READ AN ENTRY
C
 2160 CALL FREAD (GEOM4,TEMP,4,0)
      IF( TEMP(3) .EQ. -1) GO TO 2280
C
C     FIND SUBSTRUCTURE AND SET
C
      DO 2210 I = 1,NSS
      INAM = ISS1 + 2*(I-1)
      IF (Z(INAM).EQ.TEMP(1) .AND. Z(INAM+1).EQ.TEMP(2)) GO TO 2220
 2210 CONTINUE
C
C     SUBSTRUCTURE NOT FOUND
C
      WRITE (OUTT,63290) UWM,TEMP(1),TEMP(2),TYPE,NAME
      GO TO 2160
C
C     FOUND SUBSTRUCTURE NAME
C
 2220 JPT = IPT + 2*I - 2
C
C     POINTER TO LODS DATA FOR THIS SUBSTRUCTURE
C
      ILD = Z(JPT)
C
C     NUMBER OF SETS IN LODS DATA FOR THIS SUBSTRUCTURE
C
      NSET = Z(ILD)
C
C     FIND LOADC SET IN LODS DATA
C
      IF (NSET .EQ. 0) GO TO 2240
      DO 2230 I = 1,NSET
      IP = ILD + I
      IF (Z(IP) .NE. TEMP(3)) GO TO 2230
      LVEC = Z(JPT+1) + I
      GO TO 2250
 2230 CONTINUE
C
C     SET NOT FOUND
C
 2240 NONO = 1
      WRITE (OUTT,63310) UFM,NAME,LID,TEMP(3),TEMP(1),TEMP(2)
      GO TO 2160
 2250 TEMP(1) = LVEC
      TEMP(2) = TEMP(4)
      CALL WRITE (SCRT,TEMP,2,0)
      GO TO 2160
C
C     END OF LOGICAL LOADC CARD
C
 2280 CALL WRITE (SCRT,TEMP,0,1)
      GO TO 2150
C
C     END OF LOADC RECORD
C
 2300 CALL CLOSE (SCRT,1)
 2350 CALL CLOSE (GEOM4,1)
C
C     MERGE CONVERTED LOAD DATA WITH SLOAD DATA.
C
C
C     IF ANY ERRORS WERE DETECTED, SKIP LOAD COMPUTATION
C
      IF (NONO .NE. 0) GO TO 3000
      CALL GOPEN (GP3S,Z(BUF4),1)
C
C     COPY LOAD CARDS TO GP3S
C
      CALL PRELOC (*2430,Z(BUF1),GEOM3)
      LDCD = 0
      CALL LOCATE (*2420,Z(BUF1),LLOAD,IDX)
      LDCD = 1
      CALL WRITE (GP3S,LLOAD,3,0)
 2405 CALL READ (*9002,*2410,GEOM3,Z(1),NZ,0,NWDS)
      CALL WRITE (GP3S,Z(1),NZ,0)
      GO TO 2405
 2410 CALL WRITE (GP3S,Z(1),NWDS,1)
C
C     POSITION TO SLOAD CARDS
C
 2420 CALL LOCATE (*2430,Z(BUF1),LSLOAD,IDX)
      NOLS = .FALSE.
 2430 IF (NOLS) CALL CLOSE (GEOM3,1)
      IF (.NOT.(NOLS .AND. NOLC)) CALL WRITE (GP3S,LSLOAD,3,0)
      IF (NOLC) GO TO 2530
C
C     COPY LOAD VECTORS TO SCRATCH FILE
C
      FILE = SCRT2
      ITEM = PVEC
      IF (DRY .LT. 0) GO TO 2510
      CALL MTRXI (SCRT2,NAME,PVEC,Z(BUF3),FLAG)
      GO TO (2520,2431,5001,5001,5001,9001), FLAG
 2431 FLAG = 3
      GO TO 5001
C
C     IN DRY RUN MODE, LOADS PSEUDO-EXIST
C
 2510 PSUEDO =.TRUE.
      GO TO 2530
C
C     LOADS EXIST
C
 2520 PSUEDO = .FALSE.
      CALL GOPEN (SCRT2,Z(BUF3),0)
      IREC   = 1
      MCB(1) = SCRT2
      CALL RDTRL (MCB)
      NVEC  = MCB(2)
      LUSET = MCB(3)
      IF (2*LUSET .LT. NZ) GO TO 2530
C
C     INSUFFICIENT CORE
C
      CALL CLOSE (SCRT2,1)
      CALL CLOSE (GP3S ,1)
      CALL CLOSE (GEOM3,1)
      GO TO 5011
C
C     MERGE REAL AND ARTIFICIAL SLOAD CARDS
C
 2530 SIDC = 0
      IROW = 1
      NROW = LUSET
      IF (.NOT.NOLC) CALL OPEN (*9001,SCRT,Z(BUF2),0)
 2550 IF (NOLS) GO TO 2560
      FILE = GEOM3
      CALL READ (*9002,*2560,GEOM3,TEMP2,3,0,NWDS)
      GO TO 2570
 2560 IF (NOLC) GO TO 2900
      TEMP2(1) = LARGE
 2570 SIDS = TEMP2(1)
      IF (NOLC) GO TO 2635
      IF (SIDC .GT. SIDS) GO TO 2600
C
C     READ THE SID AND FACTOR OF THE LOADC CARD ITSELF
C
      FILE = SCRT
      CALL READ (*2580,*9003,SCRT,TEMP,2,0,NWDS)
      GO TO 2600
 2580 TEMP(1) = LARGE
      NOLC = .TRUE.
      CALL CLOSE (SCRT,1)
      IF (NOLS) GO TO 2900
 2600 CONTINUE
      DO 2620 I = 1,LUSET
 2620 RZ(I) = 0.0
      SIDC = TEMP(1)
      FACT = RTEMP(2)
      IF (.NOT.NOLC) GO TO 2670
 2635 IF (NOLS) GO TO 2900
C
C     NO MORE LOADC CARDS, WRITE ENTIRE  SLOAD  RECORD
C
      CALL WRITE (GP3S,TEMP2,3,0)
      FILE = GEOM3
 2640 CALL READ (*9002,*2650,GEOM3,Z(1),NZ,0,NWDS)
      CALL WRITE (GP3S,Z(1),NZ,0)
      GO TO 2640
 2650 CALL WRITE (GP3S,Z(1),NWDS,1)
      GO TO 2900
 2670 IF (.NOT.NOLS) GO TO 2680
C
C     NO MORE SLOAD CARDS ARE PRESENT
C
      SIDS = LARGE
      GO TO 2700
C
C     BOTH LOADC AND SLOAD CARDS ARE PRESENT
C
 2680 IF (SIDS .LT. SIDC) GO TO 2810
C
C     READ LOADC DATA, FIND VECTOR, UNPACK, MULT BY FACTOR, AND ADD
C     TO FIND A MATRIX COLUMN,USING FWDREC, CHANGE ON 16
C
 2700 FILE = SCRT
      CALL READ (*9002,*2790,SCRT,TEMP,2,0,NWDS)
      IF (TEMP(1).EQ.0 .OR. PSUEDO .OR. TEMP(2).EQ.0) GO TO 2700
      N = TEMP(1) - IREC
      IF (N) 2710,2750,2720
 2710 N = -N
      DO 2715 I = 1,N
      CALL BCKREC (SCRT2)
 2715 CONTINUE
      GO TO 2750
 2720 DO 2725 I = 1,N
      CALL FWDREC (*2730,SCRT2)
 2725 CONTINUE
      GO TO 2750
C
C     CANT FIND LOAD VECTOR
C
 2730 WRITE (OUTT,63320) SFM,TEMP(1),NVEC,LUSET,NAME
      NONO = 1
      GO TO 2900
C
C     NOW SCRT2 IS POSITIONED TO THE DESIRED LOAD VECTOR.  UNPACK IT AND
C     FACTOR AND ADD IT TO VECTOR AT TOP OF OPEN CORE
C
 2750 IREC = TEMP(1) + 1
      CALL UNPACK (*2700,SCRT2,RZ(LUSET+1))
      DO 2755 I = 1,LUSET
      RZ(I) = RTEMP(2)*FACT*RZ(LUSET+I)+RZ(I)
 2755 CONTINUE
      GO TO 2700
C
C     HERE WHEN FINISHED COMBINING VECTORS FOR ONE LOADC CARD
C
 2790 CONTINUE
      IF (SIDC .LT. SIDS) GO TO 2850
 2810 IZ = TEMP2(2)
      RZ(IZ) = RZ(IZ) +RTEMP2(3)
      FILE = GEOM3
      CALL READ (*9002,*2840,GEOM3,TEMP2,3,0,NWDS)
      IF (TEMP2(1) .EQ. SIDS) GO TO 2810
      SIDS = TEMP2(1)
      GO TO 2850
 2840 NOLS =.TRUE.
C
C     WRITE OUT LOAD VECTOR IN SLOAD FORMAT
C
 2850 TEMP(1) = MIN0(SIDS,SIDC)
      DO 2860 I = 1,LUSET
      IF (RZ(I) .EQ. 0.0) GO TO 2860
      TEMP(2)  = I
      RTEMP(3) = RZ(I)
      CALL WRITE (GP3S,TEMP,3,0)
 2860 CONTINUE
      IF (SIDS .NE. SIDC) GO TO 2570
      GO TO 2550
C
C     ALL LOADS PROCESSED
C
 2900 CALL WRITE (GP3S,0,0,1)
      CALL WRITE (GP3S,NLIMIT,3,1)
      CALL CLOSE (SCRT,1)
      CALL CLOSE (GP3S,1)
      CALL CLOSE (SCRT2,1)
      CALL CLOSE (GEOM3,1)
      MCB(1) = GP3S
C
C     TURN ON SLOAD BIT IN GP3S TRAILER
C     ALSO LOAD CARD BIT IF LOAD CARDS EXIST
C
      DO 2910 I = 2,7
 2910 MCB(I) = 0
      J = (LSLOAD(2)-1)/16
      I = LSLOAD(2)-16*J
      MCB(J+2) = TWO(I+16)
      IF (LDCD .EQ. 0) GO TO 2920
      J = (LLOAD(2)-1)/16
      I = LLOAD(2)-16*J
      MCB(J+2) = ORF(MCB(J+2),TWO(I+16))
 2920 CALL WRTTRL (MCB)
C
C     SPLIT CASE CONTROL  INTO SUBSTRUCTURE AND NORMAL NASTRAN
C
 3000 CALL OPEN (*9001,CASEC,Z(BUF1),0)
      CALL OPEN (*9001,CASES,Z(BUF2),1)
      CALL OPEN (*9001,CASEI,Z(BUF3),1)
      FILE = CASES
 3250 CALL READ (*3800,*3350,CASEC,Z(1),NZ,0,NWDS)
 3350 IF (Z(1).EQ.NCASEC(1) .AND. Z(2).EQ.NCASEC(2)) FILE = CASEI
      CALL WRITE (CASES,Z,NWDS,1)
      IF (FILE .EQ. CASEI) CALL WRITE (CASEI,Z(1),NWDS,1)
      GO TO 3250
 3800 CONTINUE
      MCB(1) = CASEC
      CALL RDTRL (MCB)
      MCB(1) = CASES
      CALL WRTTRL (MCB)
      MCB(1) = CASEI
      CALL WRTTRL (MCB)
      CALL CLOSE (CASEC,1)
      CALL CLOSE (CASEI,1)
      CALL CLOSE (CASES,1)
      IF (NAME(1).EQ.XXXX .AND. NAME(2).EQ.XXXX) RETURN
      IF (NONO .NE. 0) GO TO 4050
C
C     GENERATE  FICTITIOUS GP1 DATA BLOCKS
C
C
C     ***  GPL FILE  ***
C
C     GPL HEADER RECORD HAS 3 WORD, (SEE GP1)
C     SET THE 3RD WORD, MULTIPLIER MULT, TO 1000
C
      DO 4005 I = 2,7
 4005 MCB(I) = 0
      MCB(1) = GPL
      FILE   = GPL
      N = -1
      CALL OPEN (*9200,GPL,Z(BUF1),1)
      CALL FNAME (GPL,TEMP(1))
      TEMP(3) = 1000
      CALL WRITE (GPL,TEMP(1),3,1)
      DO 4010 I = 1,LUSET
 4010 CALL WRITE (GPL,I,1,0)
      CALL WRITE (GPL,I,0,1)
      DO 4020 I = 1,LUSET
      TEMP(1) = I
      TEMP(2) = 1000*I
      CALL WRITE (GPL,TEMP,2,0)
 4020 CONTINUE
      CALL WRITE (GPL,I,0,1)
      CALL CLOSE (GPL,1)
      MCB(2) = LUSET
      CALL WRTTRL (MCB)
C
C     ***  EQEXIN FILE  ***
C
 4050 MCB(1) = EQEX
      CALL GOPEN (EQEX,Z(BUF1),1)
      DO 4060 I = 1,LUSET
      TEMP(1) = I
      TEMP(2) = I
      CALL WRITE (EQEX,TEMP,2,0)
 4060 CONTINUE
      CALL WRITE (EQEX,TEMP,0,1)
      DO 4070 I = 1,LUSET
      TEMP(1) = I
      TEMP(2) = 10*I + 2
      CALL WRITE (EQEX,TEMP,2,0)
 4070 CONTINUE
      CALL WRITE (EQEX,TEMP,0,1)
      CALL CLOSE (EQEX,1)
      MCB(2) = LUSET
      CALL WRTTRL (MCB)
C
C     ***  GPDT FILE  ***
C
      MCB(1) = GPDT
      DO 4105 I = 3,7
 4105 TEMP(I) = 0
      TEMP(2) = -1
      CALL GOPEN (GPDT,Z(BUF1),1)
      DO 4120 I = 1,LUSET
      TEMP(1) = I
      CALL WRITE (GPDT,TEMP,7,0)
 4120 CONTINUE
      CALL WRITE (GPDT,TEMP,0,1)
      CALL CLOSE (GPDT,1)
      MCB(2) = LUSET
      CALL WRTTRL (MCB)
      IF (NONO .NE. 0) GO TO 4200
C
C     ***  BGPDT FILE  ***
C
      MCB(1) = BGPDT
      DO 4160 I = 2,4
 4160 TEMP(I) = 0
      TEMP(1) =-1
      CALL GOPEN (BGPDT,Z(BUF1),1)
      DO 4170 I = 1,LUSET
      CALL WRITE (BGPDT,TEMP,4,0)
 4170 CONTINUE
      CALL WRITE (BGPDT,TEMP,0,1)
      CALL CLOSE (BGPDT,1)
      MCB(2) = LUSET
      CALL WRTTRL (MCB)
C
C     ***  SIL FILE  ***
C
 4200 MCB(1) = SIL
      CALL GOPEN (SIL,Z(BUF1),1)
      DO 4220 I = 1,LUSET
      CALL WRITE (SIL,I,1,0)
 4220 CONTINUE
      CALL WRITE (SIL,I,0,1)
      CALL CLOSE (SIL,1)
C
C
      MCB(2) = LUSET
      MCB(3) = LUSET
      CALL WRTTRL (MCB)
      IF (NONO .NE. 0) DRY=-2
      CALL SOFCLS
      RETURN
C
C     ERRORS
C
 5001 N = 2 - FLAG
      GO TO 5010
 5002 N = -ITEST - 4
 5010 IF (DRY .LT. 0) N = IABS(N)
      DRY = -2
      CALL SMSG (N,ITEM,NAME)
      RETURN
 5011 N = -8
      GO TO 9100
 9001 N = -1
      GO TO 9100
 9002 N = -2
      GO TO 9100
 9003 N = -3
 9100 CALL SOFCLS
      IF (DRY .LT. 0) N = IABS(N)
      DRY = -2
 9200 CALL MESAGE (N,FILE,NSGEN)
      RETURN
C
C     MESSAGE FORMATS
C
60220 FORMAT (A23,' 6022, SUBSTRUCTURE ',2A4,', GRID POINT',I9,
     1       ', COMPONENTS',I9,1H,, /30X,'REFERENCED ON ',2A4,
     2       ' CARD, DO NOT EXIST ON SOLUTION STRUCTURE ',2A4)
63290 FORMAT (A25,' 6329, SUBSTRUCTURE ',2A4,' REFERENCED ON ',2A4,
     1       ' CARD', /30X,'IS NOT A COMPONENT BASIC SUBSTRUCTURE OF ',
     2       'SOLUTION STRUCTURE ',2A4,/30X,'THIS CARD WILL BE IGNORED')
63310 FORMAT (A23,' 6331, SOLUTION SUBSTRUCTURE ',2A4,' - LOADC SET',I9,
     1       ' REFERENCES UNDEFINED LOAD', /30X,'SET',I9,
     2       ' OF BASIC SUBSTRUCTURE ',2A4)
63320 FORMAT (A25,' 6332, CANT FIND LOAD VECTOR NUMBER',I9,' IN LOAD ',
     1       'MATRIX OF',I9,' COLUMNS', /32X,'BY',I9,
     2       ' ROWS FOR SOLUTION STRUCTURE ',2A4)
63620 FORMAT (A23,' 6362, MPCS SET',I9,' IS ILLEGAL.', //5X,
     1       'SUBSTRUCTURE ',2A4,' GRID POINT',I9,' COMPONENT',I5,
     2       ' SPECIFIES A NON-UNIQUE DEPENDENT DEGREE OF FREEDOM')
      END

      SUBROUTINE ROTATE (DA,ROW,ROW1,ROW2, O,SIN,COS)
C
C     THIS ROUTINE IS CALLED ONLY BY TRIDI SUBROUTINE, WHICH IS CALLED
C     ONLY BY VALVEC
C
      INTEGER          ROW,ROW1,ROW2
C    1,                CHECK
      DOUBLE PRECISION O(1),SIN(1),COS(1),SINE,COSINE,X,Y,Z,DA(1)
      COMMON /GIVN  /  TITLE(100),N
C
C     O     = 2ND ROW OF THE COMPLETE MATRIX.
C     SIN   = SINES.
C     COS   = COSINES.
C     DA = MATRIX PARTITION (TRIANGULAR) - DOUBLE PRECISION
C
      M    = 0
  200 DO 230 J = ROW1,ROW2
      SINE = SIN(J)
      COSINE = COS(J)
      M    = M + 1
      IF (SINE .EQ. 0.0D0) GO TO 210
      X    = O(ROW+1)*COSINE + O(J)*SINE
      Y    = DA(M)   *SINE   + O(J)*COSINE
      Z    = X       *COSINE + Y   *SINE
      O(J) = Y       *COSINE - X   *SINE
      DA(M)= O(ROW+1)+ DA(M) - Z
      O(ROW+1) = Z
  210 IF (J .EQ. N) GO TO 230
      JP1  = J + 1
      DO 220 I = JP1,N
      M    = M + 1
      X    = DA(M)*COSINE - O(I)*SINE
      O(I) = O(I)*COSINE  + DA(M)*SINE
      Y    = COS(I)*O(J)  + SIN(I)*X
      DA(M)= COS(I)*X     - SIN(I)*O(J)
      O(J) = Y
  220 CONTINUE
  230 CONTINUE
      RETURN
      END

      SUBROUTINE LPROPS (G)
C     &    ENTRY LPROPD (D)
C
C     THIS ROUTINE RETURNS INTRINSIC LAYER PROPERTIES FOR
C     ALL LAYERS REFERENCING MAT1, MAT2 OR MAT8 PROPERTY
C     ENTRIES IN A STANDARD FORMAT AS REQUIRED FOR FILE PCOMPS
C
      REAL             G(25),MTYPE,NU12,NU21
      DOUBLE PRECISION D(25),DONST
      COMMON  /MATOUT/ RMTOUT(25)
      EQUIVALENCE      (RMTOUT(1),E1),(RMTOUT(2),NU12),(RMTOUT(3),E2)
C
C     SINGLE PRECISION -
C
      DO 10 I=1,25
   10 G(I) = 0.0
      MTYPE = RMTOUT(25)
      MTYP = IFIX(MTYPE+.05) - 2
      IF (MTYP) 20,30,60
C
C****
C     ISOTROPIC MATERIALS, MAT1 IN MAT2 FORMAT
C
C****  LAYER PROPERTY MATRIX
C
   20 CONTINUE
C
C****
C     ANISOTROPIC MATERIALS, MAT2
C
C****  LAYER PROPERTY MATRIX
C
   30 DO 40 I=1,3
   40 G(I) = RMTOUT(I)
      G(5) = RMTOUT(4)
      G(6) = RMTOUT(5)
      G(9) = RMTOUT(6)
      G(4) = G(2)
      G(7) = G(3)
      G(8) = G(6)
C
C**** TRANSVERSE SHEAR FLEXIBILITY MATRIX
      DO 50 I=10,13
      II = I - 9
   50 G(I) = RMTOUT(II)
      G(12) = G(11)
C
C**** THERMAL COEFFICIENTS OF EXPANSION
      G(14) = RMTOUT( 8)
      G(15) = RMTOUT( 9)
      G(16) = RMTOUT(10)
C
C**** ULTIMATE STRENGTH VALUES
      G(17) = RMTOUT(13)
      G(18) = RMTOUT(13)
      G(19) = RMTOUT(14)
      G(20) = RMTOUT(14)
      G(21) = RMTOUT(15)
      G(22) = 0.0
C
C*** RHO, TREF, GE
      G(23) = RMTOUT( 7)
      G(24) = RMTOUT(11)
      G(25) = RMTOUT(12)
      GO TO 160
C
C****
C     ORTHOTROPIC MATERIALS, MAT8
C
C****  LAYER PROPERTY MATRIX
C
   60 NU21 = NU12 * E2 / E1
      CONST= 1.0 - (NU21*NU12)
      G(1) = E1 / CONST
      G(2) = NU12 * E2 / CONST
      G(5) = E2 / CONST
      G(4) = G(2)
      G(9) = RMTOUT(4)
C
C**** TRANSVERSE SHEAR FLEXIBILITY MATRIX
      G(10) = RMTOUT(6)
      G(13) = RMTOUT(5)
C
C**** THERMAL COEFFICIENTS OF EXPANSION
      G(14) = RMTOUT(8)
      G(15) = RMTOUT(9)
C
C**** ULTIMATE STRENGTH VALUES
      G(17) = RMTOUT(11)
      G(18) = RMTOUT(12)
      G(19) = RMTOUT(13)
      G(20) = RMTOUT(14)
      G(21) = RMTOUT(15)
      G(22) = RMTOUT(17)
C
C*** RHO, TREF, GE
      G(23) = RMTOUT( 7)
      G(24) = RMTOUT(10)
      G(25) = RMTOUT(16)
      GO TO 160
C
      ENTRY LPROPD (D)
C     ================
C
C     DOUBLE PRECISION -
C
      DO 100 I=1,25
  100 D(I) = 0.0D0
      MTYPE = RMTOUT(25)
      MTYP  = IFIX(MTYPE+.05) - 2
      IF (MTYP) 110,120,150
C
C****
C     ISOTROPIC MATERIALS, MAT1 IN MAT2 FORMAT
C
C****  LAYER PROPERTY MATRIX
C
  110 CONTINUE
C
C****
C     ANISOTROPIC MATERIALS, MAT2
C
C****  LAYER PROPERTY MATRIX
C
  120 DO 130 I=1,3
  130 D(I) = RMTOUT(I)
      D(5) = RMTOUT(4)
      D(6) = RMTOUT(5)
      D(9) = RMTOUT(6)
      D(4) = D(2)
      D(7) = D(3)
      D(8) = D(6)
C
C**** TRANSVERSE SHEAR FLEXIBILITY MATRIX
      DO 140 I=10,13
      II = I - 9
  140 D(I) = RMTOUT(II)
      D(12) = D(11)
C
C**** THERMAL COEFFICIENTS OF EXPANSION
      D(14) = RMTOUT( 8)
      D(15) = RMTOUT( 9)
      D(16) = RMTOUT(10)
C
C**** ULTIMATE STRENGTH VALUES
      D(17) = RMTOUT(13)
      D(18) = RMTOUT(13)
      D(19) = RMTOUT(14)
      D(20) = RMTOUT(14)
      D(21) = RMTOUT(15)
      D(22) = 0.0D0
C
C*** RHO, TREF, GE
      D(23) = RMTOUT( 7)
      D(24) = RMTOUT(11)
      D(25) = RMTOUT(12)
      GO TO 160
C
C****
C     ORTHOTROPIC MATERIALS, MAT8
C
C****  LAYER PROPERTY MATRIX
C
  150 NU21 = NU12 * E2 / E1
      DONST= 1.0D0 - DBLE(NU21*NU12)
      D(1) = E1 / DONST
      D(2) = NU12 * E2 / DONST
      D(5) = E2 / DONST
      D(4) = D(2)
      D(9) = RMTOUT(4)
C
C**** TRANSVERSE SHEAR FLEXIBILITY MATRIX
      D(10) = RMTOUT(6)
      D(13) = RMTOUT(5)
C
C**** THERMAL COEFFICIENTS OF EXPANSION
      D(14) = RMTOUT(8)
      D(15) = RMTOUT(9)
C
C**** ULTIMATE STRENGTH VALUES
      D(17) = RMTOUT(11)
      D(18) = RMTOUT(12)
      D(19) = RMTOUT(13)
      D(20) = RMTOUT(14)
      D(21) = RMTOUT(15)
      D(22) = RMTOUT(17)
C
C*** RHO, TREF, GE
      D(23) = RMTOUT( 7)
      D(24) = RMTOUT(10)
      D(25) = RMTOUT(16)
C
  160 RETURN
      END

      SUBROUTINE DLAMBY(INPUT,MATOUT,SKJ)
C
C     DRIVER FOR DOUBLET LATTICE WITH BODIES
C
      INTEGER         ECORE,SYSBUF,IZ(1),TSKJ,SKJ
      INTEGER         SCR1,SCR2,SCR3,SCR4,SCR5
      DIMENSION       NAME(2)
      COMMON /SYSTEM/ SYSBUF
      COMMON /ZZZZZZ/ Z(1)
      COMMON /BLANK / NK,NJ
      COMMON /AMGMN / MCB(7),NROW,ND,NE,REFC,FMACH,RFK,TSKJ(7),ISK,NSK
      COMMON /DLBDY / NJ1,NK1,NP,NB,NTP,NBZ,NBY,NTZ,NTY,NT0,NTZS,NTYS,
     1                INC,INS,INB,INAS,IZIN,IYIN,INBEA1,INBEA2,INSBEA,
     2                IZB,IYB,IAVR,IARB,INFL,IXLE,IXTE,INT121,INT122,
     3                IZS,IYS,ICS,IEE,ISG,ICG,IXIJ,IX,IDELX,IXIC,IXLAM,
     4                IA0,IXIS1,IXIS2,IA0P,IRIA,INASB,IFLA1,IFLA2,
     5                ITH1A,ITH2A,ECORE,NEXT,SCR1,SCR2,SCR3,SCR4,SCR5,
     6                NTBE
      EQUIVALENCE     (IZ(1),Z(1))
      DATA   NAME /4HDLAM,4HBY  /
      DATA NHAERO,NHPOIN,NHCORE / 4HAERO,4HPOIN,4HCORE/
C
      SCR1 = 301
      SCR2 = 302
      SCR3 = 303
      SCR4 = 304
      SCR5 = 305
C
C     GET CORE THEN SET POINTERS TO ACPT TABLE ARRAYS
C
      ECORE = KORSZ(IZ) - 4*SYSBUF
C
C     READ LENGTHS OF ARRAYS
C
      CALL FREAD(INPUT,NJ1,13,0)
C
C     COMPUTE POINTERS TO OPEN CORE
C
      LNS = INC
      INC = 1
      INS = INC
      INB = INS + NP
      INAS = INB + NP
      IZIN = INAS
      IYIN = IZIN
      INBEA1 = IYIN + NP
      INBEA2 = INBEA1 + NB
      INSBEA = INBEA2 + NB
      IZB = INSBEA + NB
      IYB = IZB + NB
      IAVR = IYB + NB
      IARB = IAVR + NB
      INFL = IARB + NB
      IXLE = INFL + NB
      IXTE = IXLE + NB
      INT121 = IXTE + NB
      INT122 = INT121 + NB
      IZS = INT122 + NB
      N = 3*NP + 12 * NB
C
C     READ FIXED ARRAYS
C
      IF(N .GT. ECORE) GO TO 998
      CALL FREAD(INPUT,IZ,N,0)
C
C     GET LENGTHS OF VARIABLE ARRAYS, PANELS THEN BODIES
C
      LNAS = 0
      IF(NP .EQ. 0) GO TO 20
      DO 10 I=1,NP
   10 LNAS = LNAS + IZ(INAS+I-1)
   20 LNB = 0
      LNSB = 0
      LNFL = 0
      LT1 = 0
      LT2 = 0
      DO 30 I=1,NB
      K = I-1
      LNB = LNB + IZ(INBEA1+K)
      LNSB = LNSB + IZ(INSBEA+K)
      LNFL = LNFL + IZ(INFL+K)
      LT1 = LT1 + IZ(INT121+K)
   30 LT2 = LT2 + IZ(INT122+K)
      NTBE = NTP+LNB
C
C     READ VARIABLE  ARRAYS AND SET POINTERS TO CORE
C
      NEXT = N+1
      N = 2*NB + 5*LNS + 4*NTP + 3*LNB + 4*LNSB + LNAS + 2*LNFL
     *  + LT1 + LT2
      IF(NEXT+N+4*NJ.GE.ECORE) GO TO 998
      CALL FREAD(INPUT,IZ(NEXT),N,1)
      NEXT = NEXT + N + 1
      IYS = IZS + NB + LNS
      ICS = IYS
      IEE = ICS + NB + LNS
      ISG = IEE + LNS
      ICG = ISG + LNS
      IXIJ = ICG
      IX = IXIJ + LNS
      IDELX = IX + NTP + LNB
      IXIC = IDELX + NTP + LNB
      IXLAM = IXIC + NTP
      IA0 = IXLAM + NTP
      IXIS1 = IA0 + LNSB
      IXIS2 = IXIS1 + LNSB
      IA0P = IXIS2 + LNSB
      IRIA = IA0P + LNSB
      INASB = IRIA + LNB
      IFLA1 = INASB + LNAS
      IFLA2 = IFLA1 + LNFL
      ITH1A = IFLA2 + LNFL
      ITH2A = ITH1A + LT1
C
C     BUILD A MATRIX
C
      CALL BUG(NHAERO,100,ND,5)
      CALL BUG(NHPOIN,100,NJ1,59)
      CALL BUG(NHCORE,100,Z,NEXT)
      N1 = NEXT
      N = NEXT + 2*NTBE
      NEXT = NEXT + 4*NTBE
      IF(NT0 .NE. 0) CALL GENDSB(Z(INC),Z(INB),Z(ISG),Z(ICG),Z(INFL),
     *   Z(INBEA1),Z(INBEA2),Z(IFLA1),Z(IFLA2),Z(N1),Z(N1),Z(N))
      N = NTZS + NTYS
      NEXT = N1
      BETA = SQRT(1.0-FMACH**2)
      IF( NT0 .NE. 0 .AND. N .NE. 0) CALL AMGROD(Z(N1),BETA)
      CALL AMGSBA(MATOUT,Z(IA0),Z(IARB),Z(INSBEA),Z(N1),Z(IYB),Z(IZB))
      NROW = NROW + NJ1
C
C     BUILD SKJ MATRIX BE SURE TO BUMP ISK NSK
C
      CALL AMGBFS(SKJ,Z(IEE),Z(IDELX),Z(INC),Z(INB),Z(IXIS2),Z(IXIS1),
     *      Z(IA0),Z(IA0P),Z(INSBEA))
 1000 RETURN
C
C     ERROR MESSAGES
C
  998 CALL MESAGE(-8,0,NAME)
      GO TO 1000
      END

      SUBROUTINE GFSPTN (FILEA,FILE11,FILE21,FILE12,FILE22,RPART,CPART)
C
C     GENERAL MATRIX PARTION ROUTINE
C
C
C                              --               --
C                              I        I        I
C                  --     --   I FILE11 I FILE12 I
C                  I       I   I        I        I
C                  I FILEA I = I-----------------I
C                  I       I   I        I        I
C                  --     --   I FILE21 I FILE22 I
C                              I        I        I
C                              --               --
C
C        WHERE
C
C             RPART - ROW PARTITIONING VECTOR
C             CPART - COLUMN PARTITION VECTOR
C
      INTEGER       FILEA    ,FILE11   ,FILE12   ,FILE21   ,FILE22  ,
     1              RPART    ,CPART    ,RULE     ,CORE     ,NAME(2) ,
     2              RP(7)    ,CP(7)
C
C     OPEN CORE
C
      COMMON / ZZZZZZ /       CORE(1)
C
C     CALCV COMMON BLOCK
C
C
C     PARTITION - MERGE COMMON BLOCK
      COMMON / PATX   /       LCORE    ,NSUB0    ,NSUB1
C
      COMMON / PARMEG /       IA(7)    ,IA11(7)  ,IA21(7)  ,IA12(7) ,
     1                        IA22(7)  ,LCR      ,RULE
C
      DATA     NAME   /       4HGFSP   ,4HTN     /
C
C
C     GET TRAILERS FOR INPUTS
C
      RP(1) = RPART
      IF (RPART .NE. 0) CALL RDTRL (RP)
      CP(1) = CPART
      IF (CPART .NE. 0) CALL RDTRL (CP)
      IA(1) = FILEA
      CALL RDTRL (IA)
C
C     SET UP MATRIX CONTROL BLOCKS FOR OUTPUTS
C
      IA11(1) = FILE11
      IA12(1) = FILE12
      IA21(1) = FILE21
      IA22(1) = FILE22
C
      DO 10 I = 2,5
      IA11(I) = IA(I)
      IA12(I) = IA(I)
      IA21(I) = IA(I)
   10 IA22(I) = IA(I)
C
C     SET UP DUMMY PARTITION VECTOR
C
      I = 0
      CORE(  1) = 0
      CORE(I+2) = 1
      CORE(I+3) = IA(2)
      CORE(I+4) = 2
      CORE(I+5) = 1
      CORE(I+6) = 0
C
      RULE = 0
      LCR  = KORSZ(CORE)
C
      IF (RPART .EQ. 0) GO TO 30
      IF (CPART .EQ. 0) GO TO 20
C
C     FULL PARTITION
C
      IA11(3) = NSUB0
      IA12(3) = NSUB0
      IA21(3) = NSUB1
      IA22(3) = NSUB1
      CALL PARTN (RP,CP,CORE)
      GO TO 40
C
C     ROW PARTITION
C
   20 CALL PARTN (RP,CORE,CORE)
      GO TO 40
C
C     COLUMN PARTITION
C
   30 IF (CPART .EQ. 0) GO TO 1007
      IA11(3) = NSUB0
      IA12(3) = NSUB0
      IA21(3) = NSUB1
      IA22(3) = NSUB1
      CALL PARTN (CORE,CP,CORE)
C
C     WRITE TRAILERS FOR OUTPUTS
C
   40 IF (IA11(1) .NE. 0) CALL WRTTRL (IA11)
      IF (IA12(1) .NE. 0) CALL WRTTRL (IA12)
      IF (IA21(1) .NE. 0) CALL WRTTRL (IA21)
      IF (IA22(1) .NE. 0) CALL WRTTRL (IA22)
C
      RETURN
C
C     ILLEGAL INPUT - NO PARTITION VECTOR
C
 1007 CALL MESAGE (-7,0,NAME)
      RETURN
      END

      SUBROUTINE RAND6(XYCB,BUFFER,NPOINT,IZ,INPUT,LCORE)
C
C     ANALYSIS OF REQUESTS AND BUILDS LIST
C
      INTEGER XYCB,BUFFER(1),IZ(1),FILE,NAME(2),ILIST(6),PSDF,AUTO,
     1  ITYPE(13,5)
      DATA NAME,PSDF,AUTO/4HRAND,4H6   ,2,3/
      DATA ITYPE /
     1    13,4HDISP,1,4HVELO,2,4HACCE,3,4HDISP,8,4HVELO,9,4HACCE,10,
     2     3,4HLOAD,5,           10*0,
     3     3,4HSPCF,4,           10*0,
     4     3,4HSTRE,6,           10*0,
     5     3,4HELFO,7,           10*0 /
C *****
C     XYCB     XY OUTPUT REQUESTS
C     BUFFER   SYSTEM BUFFER
C     NPOINT   NUMBER OF POINTS REQUESTED FOR THIS FILE
C     IZ       LIST OF REQUESTS
C     INPUT    CURRENT FILE
C     ILIST    LIST OF REQUEST FROM XYCB   6  WORDS PER
C     SUBC,FILE,ID,COMP,OPER,DEST
C     PSDF     KEY FOR POWER SPECTRAL DENSITY FUNCTION
C     AUTO     KEY FOR AUTOCORRELATION FUNCTION
C     ITYPE    LIST OF DATA TYPES ON EACH INPUT FILE
C     IREQ     PSDF =1 , AUTO =2  BOTH = 3
C     IP       POINTER INTO  IZ  FOR LAST POINT(SAME POINT MAY OCCUR
C                MANY TIMES IN XYCB
C
C     LIST FORMAT
C     FILE,ID,COMP,IREQ,DEST
C
C
C
C
C
C
C     FIND  ACCEPTABLE MNEUMONICS
C
      K = INPUT -103
      NTYPE =  ITYPE(1,K)
      IP =-4
      NPOINT = 0
C
C     OPEN XYCB
C
      FILE =XYCB
      CALL OPEN(*90,XYCB,BUFFER(1),0)
      CALL FWDREC(*910,XYCB)
C
C     SKIP PROSE RECORD
C
      CALL FWDREC(*40,XYCB)
C
C     READ DATA RECORD 6 WORDS AT A TIME
C
    5 CALL READ(*40,*40,XYCB,ILIST(1),6,0,I)
C
C     IS DATA BLOCK PROPER
C
      DO 10 I=2, NTYPE,2
      IF(ILIST(2) .EQ. ITYPE(I+1,K)) GO TO 20
   10 CONTINUE
C
C     GO TO NEXT REQUEST
C
      GO TO 5
C
C     CHECK FOR RANDOM REQUEST
C
   20 IF(ILIST(5) .EQ. PSDF) GO TO 25
      IF(ILIST(5) .EQ. AUTO) GO TO 30
      GO TO 5
C     PSDF REQUEST
C
   25 IREQ =1
      GO TO 31
C
C     AUTOCORRELATION REQUEST
C
   30 IREQ =2
C
C     STORE  IN LIST
C
   31 IF(NPOINT .EQ. 0) GO TO 35
C
C     IS THIS A NEW POINT
C
      IF(IZ(IP) .NE. ITYPE(I,K)) GO TO 35
      IF(IZ(IP+1) .NE. ILIST(3) .OR. IZ(IP+2) .NE. ILIST(4)) GO TO 35
C
C     ANOTHER REQUEST FOR SAME POINT
C
      IF( IZ(IP+3) .EQ. 3 .OR. IZ(IP+3) .EQ. IREQ) GO TO 32
      IZ(IP+3) = IZ(IP+3) + IREQ
   32 IF(IZ(IP+4) .EQ.  3  .OR. IZ(IP+4).EQ. ILIST(6))GO TO 5
      IZ(IP+4) = IZ(IP+4) + ILIST(6)
      GO TO 5
C
C     ADD POINT TO LIST
C
   35 NPOINT = NPOINT +1
      IP = IP +5
      IF (IP+5 .GT. LCORE) GO TO 905
      IZ(IP) = ITYPE(I,K)
      IZ(IP+1) = ILIST(3)
      IZ(IP+2) = ILIST(4)
      IZ(IP+3) = IREQ
      IZ(IP+4) = ILIST(6)
      GO TO 5
C
C     GET OUT
C
   40 CALL CLOSE(XYCB,1)
C
C     SAVE ORIGINAL COMPONENT IN THE FIFTH LIST LORD
C
      IF(NPOINT .EQ. 0) GO TO 90
      DO 45 I = 1,NPOINT
      L = (I-1)*5+1
      IZ(L+4) = IZ(L+2)
      IF(K .LT. 4) IZ(L+2) = IZ(L+2) -2
   45 CONTINUE
   90 RETURN
C
C     FILE ERRORS
C
  905 NPOINT = NPOINT+9
      GO TO 90
  910 IP1= -2
  911 CALL MESAGE(IP1,FILE,NAME(1))
      GO TO 911
      END

      SUBROUTINE CURCAS(*,NSKIP,TRL,MCB,ZZ,IBUF)
C   THIS SUBROUTINE COPIES MATRIX FILE TRL(1) TO FILE MCB(1)
C SKIPPING NSKIP-1 MATRIX COLUMNS.  PRIMARY USE IS TO CREATE A MATRIX
C THAT INCLUDES ONLY SUBCASES IN THE CURRENT DMAP LOOP.
C   ALL FILES ARE OPENED, CLOSED AND TRIALERS WRITTEN.
C   IF NSKIP WOULD RESULT IN NO-COPY, MCB(1) IS SET TO TRL(1).
C     TRL - INPUT TRAILER FOR FILE BEING CONVERTED.
C     MCB - OUTPUT TRAILER - WORD 1 HAS GINO FILE NAME.
C     ZZ  - OPEN CORE.
C     IBUF- LOCATION OF TWO GINO BUFFERS.
C     NSKIP - ONE MORE THAN THE SUBCASES TO SKIP.
C       * - NONSTANDARD RETURN IF UNABLE TO PROCESS.
C-----
      INTEGER PARM(4)  ,MCB(7)   ,TRL(7)   ,ZZ(1)    ,COUNT
C
      COMMON /NAMES / IRD,IRDRW,IWT,IWTRW, KREW,KNRW,KNERW
      COMMON /SYSTEM/ ISBZ
      EQUIVALENCE (ICNT,RCNT)
      DATA PARM(3),PARM(4) / 4HCURC,2HAS  /
C
      PARM(2) = TRL(1)
      IF (NSKIP.LE.1) GO TO 55
C  . FOR STATICS THE NUMBER OF SUBCASES SKIPPED = NO. COLUMNS SKIPPED.
C  .  OTHER ANALYSIS TYPES NEED TO SUPPLY PROPER VALUE FOR NSKIP...
      I = NSKIP - 1
      IBF2 = IBUF+ISBZ
      IF (IBUF.LE.0) GO TO 100
C
      CALL RDTRL(TRL)
      IF (TRL(1).LE.0) GO TO 90
      IF (TRL(2).LE.I) GO TO 110
      CALL OPEN(*90,TRL(1),ZZ(IBF2),IRDRW)
      PARM(2) = MCB(1)
      CALL OPEN(*90,MCB(1),ZZ(IBUF),IWTRW)
      CALL WRITE(MCB(1),MCB(1),2,1)
      PARM(2) = TRL(1)
      CALL FWDREC(*120,TRL(1))
C
      MCB(2) = TRL(2) - I
      MCB(3) = TRL(3)
      MCB(4) = TRL(4)
      MCB(5) = TRL(5)
      MCB(6) = TRL(6)
      DO 20 J = 1,I
      CALL FWDREC(*120,TRL(1))
   20 CONTINUE
      CALL CPYFIL (TRL,MCB,ZZ,IBUF-1,COUNT)
      RCNT = COUNT
      MCB(7) = ICNT
      CALL EOF (MCB)
C
      CALL CLOSE (TRL(1),KRW)
      CALL CLOSE (MCB(1),KRW)
      CALL WRTTRL (MCB(1))
       GO TO 60
   55 MCB(1) = TRL(1)
   60 RETURN
C
C  . ERROR MESSAGES...
C
   90 PARM(1) = +1
       GO TO 130
  100 PARM(1) = +8
       GO TO 130
  110 PARM(1) = +7
       GO TO 130
  120 PARM(1) = +2
C
  130 CALL MESAGE (PARM(1),PARM(2),PARM(3))
      RETURN 1
      END

      SUBROUTINE PROLAT
C
C     PROLATE COMPUTES COEFFICIENTS FOR A PROLATE SPHEROIDAL HARMONIC
C     EXPANSION FOR MAGNETOSTATICS PROBLEMS. A PROLATE SPHEROID IA
C     ASSUMED TO ENCLOSE THE FERROMAGNETIC BODY AND ALL MAGNETIC
C     SOURCES. A PROLATE BULK DATA CARD DEFINES THE GRIDS ON HTE SURFACE
C     OF TEH PROLATE SPHEROID, THE NUMBER OF TERMS IN THE SERIES
C     EXPANSION,ETC. CASE CONTROL CARD AXISYM CONTROLS SYMMETRY OR ANTI-
C     SYMMETRY(OR LACK OF) OF THE POTENTIAL W.R.T. THE X-Y PLANE FOR
C     EACH SUBCASE.
C
C     PROLATE  GEOM1,EQEXIN,BGPDT,CASECC,NSLT,HUGV,REMFLD,HEST,MPT,DIT/
C              PROCF
C
      LOGICAL         REMFL,ONLYAR,ANOM,WRIT
      INTEGER         BUF1,BUF2,FILE,GEOM1,EQEXIN,BGPDT,CASECC,HUGV,
     1                PROCOF,SYSBUF,OTPE,TYPOUT,SCR1,PROLTE(2),INFO(7),
     2                SUBCAS,HEST,PROCOS,TRAIL(7)
C     INTEGER         DIT,REMFLD,MPT
      REAL            INTER(4,4),J11,J12,J21,J22
      DIMENSION       IZ(6),NAM(2),MCB(7),V13(3),V24(3),VX(3),POTI(4),
     1                POTV(4),XII(4),ETAI(4),XDETJ(4),IPT(4),XX(4),
     2                YY(4),ZZ(4),PNMV(4),XETA(4),XPHI(4),TRIGC(4),
     3                TRIGS(4),ETAINT(4),PHIINT(4),XN(4),FO(7),TITLE(96)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25,SWM*27,SIM*31
      COMMON /XMSSG / UFM,UWM,UIM,SFM,SWM,SIM
      COMMON /BIOT  / NG1,NG2,IST,SUBCAS,X1,Y1,Z1,X2,Y2,Z2,BUF2,REMFL,
     1                MCORE,LOAD,NSLT,SCR1,HEST,NTOT
      COMMON /SYSTEM/ SYSBUF,OTPE
      COMMON /UNPAKX/ TYPOUT,II,NN,INCR
      COMMON /PACKX / ITYPIN,ITYPOU,III,NNN,JNCR
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE     (Z(1),IZ(1)) , (INFO(1),FO(1))
      DATA    NAM   / 4HPROL,4HATE /
      DATA    PROCOS/ 302    /
      DATA    PROLTE/ 4101,41/
      DATA    GEOM1,  EQEXIN,BGPDT,CASECC/101,102,103,104/
      DATA    HUGV,   PROCOF /106,201    /
C     DATA    REMFLD, MPT,DIT/107,109,110/
      DATA    PT1,    PT2    /.211324865,.788675135/
      DATA    INTER(1,1),INTER(2,2),INTER(3,3),INTER(4,4)/4*.622008469/
      DATA    INTER(1,2),INTER(1,4),INTER(2,1),INTER(2,3)/4*.16666667 /
      DATA    INTER(3,2),INTER(3,4),INTER(4,1),INTER(4,3)/4*.16666667 /
      DATA    INTER(1,3),INTER(2,4),INTER(3,1),INTER(4,2)/4*.044658199/
      DATA    PI    / 3.1415927/
C
      TPI    = 2.*PI
      WRIT   = .FALSE.
      NSLT   = 105
      HEST   = 108
      SCR1   = 301
      LCORE  = KORSZ(Z)
      LLCORE = LCORE
      BUF1   = LCORE - SYSBUF
      LCORE  = BUF1 - 1
      IF (LCORE .LE. 0) GO TO 1008
C
      XII(1) = PT1
      XII(2) = PT1
      XII(3) = PT2
      XII(4) = PT2
      ETAI(1)= PT2
      ETAI(2)= PT1
      ETAI(3)= PT1
      ETAI(4)= PT2
C
C     CHECK TO SEE IF PROLATE CARD EXISTS.IF NOT, WARNING AND OUT
C
      FILE = GEOM1
      CALL PRELOC (*1001,Z(BUF1),GEOM1)
      CALL LOCATE (*10,Z(BUF1),PROLTE,IDX)
      GO TO 20
   10 WRITE  (OTPE,15) SIM
   15 FORMAT (A31,', NO PROLAT CARD FOUND')
      CALL CLOSE (GEOM1,1)
      RETURN
C
C     THERE IS ONLY ONE PROLAT CARD IN THE DECK-READ IT IN
C
   20 CALL READ (*1002,*30,GEOM1,Z,LCORE,0,NGRIDS)
      GO TO 1008
   30 CALL CLOSE (GEOM1,1)
      SEMAJ  = Z(1)
      J      = 2
      SEMIN  = Z(J)
      NSEGS  = IZ(3)
      MSEGS  = IZ(4)
      NNHARM = IZ(5)
      NMHARM = IZ(6)
      IGRID  = 6
C
C     CREATE A LIST OF COORDINATES FOR THE GRID POINTS. WE WILL NEED
C     BOTH INTERNAL AND SIL VALUES FOR THE GRIDS.BUT THESE ARE THE SAME
C     IN HEAT TRANSFER. SO READ IN ONLY THE 1ST RECORD OF EQEXIN
C
      MCORE = LCORE-NGRIDS
      IEQEX = NGRIDS
      CALL GOPEN (EQEXIN,Z(BUF1),0)
      FILE = EQEXIN
      CALL READ (*1002,*40,EQEXIN,Z(IEQEX+1),MCORE,0,NEQEX)
      GO TO 1008
   40 CALL CLOSE (EQEXIN,1)
C
C     CREATE A LIST OF INTERNAL VALUES OF THE GRIDS ON PROLAT-CHECK CORE
C
      INEXT = IEQEX + NEQEX
      IF (INEXT+NGRIDS-6 .GT. LCORE) GO TO 1008
C
      IGRID1 = IGRID + 1
      K = 0
      DO 50 I = IGRID1,NGRIDS
      K = K + 1
      CALL BISLOC (*60,IZ(I),IZ(IEQEX+1),2,NEQEX/2,JLOC)
C
C     STORE  THE INTERNAL VALUE
C
      IZ(INEXT+K) = IZ(IEQEX+JLOC+1)
   50 CONTINUE
      GO TO 70
   60 WRITE  (OTPE,65) UFM,IZ(I)
   65 FORMAT (A23,', GRID',I8,' ON PROLAT CARD DOES NOT EXIST')
      CALL MESAGE (-61,0,0)
C
C     MOVE THIS LIST UP IN CORE  / ALL ELSE IN OPEN CORE IS EXPENDABLE
C
   70 DO 80 I = 1,K
   80 IZ(I)  = IZ(INEXT+I)
      NGRIDS = NGRIDS - 6
C
C     CREATE SCRATCH FILE OF HC VALUES FOR EACH REMFLUX CARD(FOR LATER
C     USE IN HC LINE INTEGRALS)
C
      BUF2 = BUF1
      MCORE= LCORE
      CALL REMFLX (NGRIDS)
C
C     NOW PICK UP COORDINATES OF THESE POINTS-OPEN CORE 1-NGRIDS GIVES
C     THE POINTERS
C
      IBG  = NGRIDS
      CALL GOPEN (BGPDT,Z(BUF1),0)
      FILE = BGPDT
      CALL READ (*1002,*90,BGPDT,Z(IBG+1),LCORE-NGRIDS,0,NBG)
      GO TO 1008
   90 CALL CLOSE (BGPDT,1)
C
      K = IBG + NBG
      IF (K+3*NGRIDS .GT. LCORE) GO TO 1008
      DO 100 I = 1,NGRIDS
      IPZ  = IZ(I)
      ISUB = 4*(IPZ-1) + IBG
      ISUB1= ISUB + 1
      DO 95 J = 1,3
   95 Z(K+J) = Z(ISUB1+J)
      K = K + 3
  100 CONTINUE
C
C     MOVE THESE UP IN CORE SO THAT TOTAL WORDS OF OPEN CORE IS NOW
C     4*NGRIDS
C
      K = IBG + NBG
      DO 110 I = 1,NGRIDS
      IJ = NGRIDS + 3*(I-1)
      DO 105 J = 1,3
  105 Z(IJ+J) = Z(K+J)
      K = K + 3
  110 CONTINUE
      IBG = NGRIDS
      IOP = 0
      IOP1= 1
C
C     NOW PICK UP POTENTIAL VALUES AY THESE GRIDS
C
      MCB(1) = HUGV
      CALL RDTRL (MCB)
      NCOL  = MCB(2)
      NROW  = MCB(3)
      TYPOUT= 1
      II    = 1
      NN    = NROW
      INCR  = 1
      SUBCAS= 0
  115 INEXT = 4*NGRIDS
      IPOT  = INEXT
      IF (INEXT+NROW+NGRIDS .GT. LCORE) GO TO 1008
      SUBCAS = SUBCAS + 1
      CALL GOPEN  (HUGV,Z(BUF1),IOP)
      CALL UNPACK (*131,HUGV,Z(INEXT+1))
      CALL CLOSE  (HUGV,2)
C
C     PICK UP POTENTIALS OF ASSOCIATED POINTS
C
      ISUB = INEXT + NROW
      DO 120 I = 1,NGRIDS
      IPZ = IZ(I)
      Z(ISUB+I) = Z(INEXT+IPZ)
  120 CONTINUE
C
C     MOVE THESE  UP
C
      DO 130 I = 1,NGRIDS
  130 Z(IPOT+I) = Z(ISUB+I)
      GO TO 150
C
C     ZERO POTENTIALS
C
  131 DO 132 I = 1,NGRIDS
  132 Z(IPOT+I) = 0.
      CALL CLOSE (HUGV,2)
C
C     OPEN CORE ARRANGEMENT
C
C     1 - NGRIDS                            SIL VALUES
C     NGRIDS + 1 - 4*NGRIDS                 BGPDT VALUES OF THESE POINTS
C     4*NGRIDS + 1 - 5*NGRIDS               ANOMALY POTENTIALS
C     5*NGRIDS + 1 - 5*NGRIDS + NTOT        LOAD INFO IF NEEDED
C     5*NGRIDS + NTOT + 1 - 6*NGRIDS + NTOT HC POTENTIALS
C
C     PICK UP SYMMETRY INDICATOR FOR THIS CASE. 0 MEANS NO SYMMETRY,
C     1(SINE) MEANS ANTI-SYMMETRY, 2(COSINE) MEANS SYMMETRY. 0 IMPLIES
C     360 DEGREE MODELING, 1 AND 2 IMPLY 180 DEGREE MODELING(SKIP SUBCOM
C     REPCASE. IF LOAD=0, THEN BIOT SAVART LOADS ARE ZERO)
C
C     INDICATOR=10,20, OR 30 MEANS ANOMALY ONLY, IE DO NOT INCLUDE
C     EFFECTS OF   APPLIED FIELD(USED MAINLY IN INDUCING FIELDS)
C     IF THIS IS THE CASE, SET ANOM TO TRUE AND GO  BACK TO 0,1,2
C
  150 INEXT = 5*NGRIDS
      IF (INEXT+136 .GT. LCORE) GO TO 1008
      CALL GOPEN (CASECC,Z(BUF1),IOP)
  135 CALL FREAD (CASECC,Z(INEXT+1),136,1)
      NSYM = IZ(INEXT+16)
      LOAD = IZ(INEXT+4)
      ISYM = IZ(INEXT+136)
      DO 136 I = 1,96
  136 TITLE(I) = Z(INEXT+38+I)
      ANOM = .FALSE.
      IF (ISYM.LE.2) GO TO 140
      ANOM = .TRUE.
      IF (ISYM.EQ.30) ISYM = 0
      ISYM = ISYM/10
  140 CONTINUE
      IF (NSYM .NE. 0) GO TO 135
      CALL CLOSE (CASECC,2)
C
C     PROLATE SPHEROID COORDINATE XI IS CONSTANT OVER THE REFERNCE
C     SPHEROID. DFOC=DISTANCE BETWEEN FOCI
C
      INEXT = 5*NGRIDS
      DFOC = 2.*SQRT(SEMAJ**2-SEMIN**2)
      XI   = 2.*SEMAJ/DFOC
      DXI  = 2./DFOC/XI
C
C     IF BIOT-SAVART LOAD ARE ZERO OR ANOMALY ONLY, SKIP HC POTENTIALS
C
      IF (LOAD .EQ. 0) GO TO 192
      IF (ANOM) GO TO 192
C
C     SET UP LOADS FOR LINE INTEGRAL COMPUTATIONS
C
      BUF2  = BUF1
      MCORE = LCORE
      IST   = INEXT
C
      CALL LOADSU
C
      INEXT = INEXT + NTOT
      IF (INEXT+NGRIDS .GT. LCORE) GO TO 1008
C
C     CHECK CORE FOR BIOTSV
C
      IF (REMFL .AND. INEXT+4*NGRIDS.GT.LCORE) GO TO 1008
C
C     FIRST INTEGRATE THE BIOT-SAVART FIELD ON THE PROLATE SPHEROID TO
C     COME UP WITH AN EQUIVALENT POTENTIAL AT EACH POINT TO BE ADDED TO
C     THE ANOMALY POTENTIAL. STORE THESE POTENTIALS IN 5*NGRIDS+NTOT+1
C     THRU 6*NGRIDS+NTOT
C
C
      DO 160 I = 1,NGRIDS
  160 Z(INEXT+I) = 0.
      IHCPOT = INEXT
      MLONG  = MSEGS + 1
      IF (ISYM .EQ. 0) MLONG = MSEGS
      MCIRC = MSEGS
      IF (ISYM .EQ. 0) MCIRC = MSEGS - 1
C
      DO 190 N = 1,NSEGS
C
      DO 170 M = 1,MLONG
C
C     INTEGRATE HC LONGITUDINALLY. PERFORM LINE INTEGRAL OF HC.DL
C     RETRIEVE COORDINATES OF POINTS
C
      IPT1 = (M-1)*(NSEGS-1) + 2 + (N-1)
      IPT2 = IPT1 + 1
      IF (N .EQ.     1) IPT1 = 1
      IF (N .EQ. NSEGS) IPT2 = 2
C
      ISUB = 3*(IPT1-1) + IBG
      X1   = Z(ISUB+1)
      Y1   = Z(ISUB+2)
      Z1   = Z(ISUB+3)
      ISUB = 3*(IPT2-1) + IBG
      X2   = Z(ISUB+1)
      Y2   = Z(ISUB+2)
      Z2   = Z(ISUB+3)
      NG1  = IZ(IPT1)
      NG2  = IZ(IPT2)
C
      CALL LINEIN (X1,Y1,Z1,X2,Y2,Z2,HCDL)
C
C     NOW ADD POTENTIAL FROM 1ST POINT TO INTEGRAL AT 2ND TO GIVE
C     INITIAL POTENTIAL AT 2ND POINT. IF 2ND POINT IS RIGHT END POINT
C     (POINT 2 ON PROLAT), ACCUMULATE FOR AVERAGING
C
      ADD = 0.
      IF (IPT2 .EQ. 2) ADD = Z(IHCPOT+2)
      Z(IHCPOT+IPT2) = Z(IHCPOT+IPT1) + HCDL + ADD
C
C     GET ANOTHER CIRCUMFERENTIAL SEGMENT
C
  170 CONTINUE
C
C     AVERAGE THE INTEGRALS AT RIGHT END POINT
C
      Z(IHCPOT+2) = Z(IHCPOT+2)/FLOAT(MLONG)
C
C     LONGITUDINAL INTEGRATIONS FOR THIS LONGITUDINAL SEGMENT ARE
C     COMPLETE.
C     NOW INTEGRATE CIRCUMFERENTIALLY DOWN THE RIGHT HAND SIDE OF THE
C     LONGITUDINAL SEGMENT AND AVERGAE WITH THE LONGITUDINAL RESULTS.
C     IF WE ARE AT THE LAST SET OF LONGITUDINAL SEGMENTS, DO NOT DO ANY
C     CIRCUMFERENTIAL INTEGRATIONS SINCE WE HAVE ONLY THE RIGHT END
C     POINT.
C
      IF (N .EQ. NSEGS) GO TO 190
      DO 180 M = 1,MCIRC
      IPT1 = (M-1)*(NSEGS-1) + 2 + N
      IPT2 = IPT1 + (NSEGS-1)
      ISUB = 3*(IPT1-1) + IBG
      X1   = Z(ISUB+1)
      Y1   = Z(ISUB+2)
      Z1   = Z(ISUB+3)
      ISUB = 3*(IPT2-1) + IBG
      X2   = Z(ISUB+1)
      Y2   = Z(ISUB+2)
      Z2   = Z(ISUB+3)
      NG1  = IZ(IPT1)
      NG2  = IZ(IPT2)
C
      CALL LINEIN (X1,Y1,Z1,X2,Y2,Z2,HCDL)
C
C     TO GET FINAL HC POTENTIAL AT 2ND POINT, ADD PRESENT POTENTIAL AT
C     POINT 2(WHICH RESULTED FROM LONGITUDINAL INTEGRATION) TO THE SUM
C     OF THE POTENTIAL AT POINT 1 AND PRESENT INTEGRAL. THEN AVERAGE
C
      Z(IHCPOT+IPT2) = (Z(IHCPOT+IPT2) + Z(IHCPOT+IPT1) + HCDL)/2.
C
  180 CONTINUE
C
C     GET ANOTHER SET OF LONGITUDINAL SEGMENTS
C
  190 CONTINUE
C
      CALL CLOSE (NSLT,1)
C
C     USING THE POTENTIALS JUST COMPUTED, COMPUTE AN AVERAGE REFERNCE
C     POTENTIAL TO BE SUBTRACTED FROM THESE POTENTIALS SO THAT THE
C     AVERAGE POTENTIAL IS ZERO GIVING A ZERO MONOPOLE.
C     (AVERAGE POTENTIAL=(U/AREA)*(INTEGRAL OF PHI*D(AREA))-INTEGRATE
C     OVER EACH SURFACE PATCH. ALSO COMPARE COMPUTED AREA TO ANALYTICAL
C     AREA. IF THIS SUBCASE IS A SINE CASE, THEN AVERGAE IS
C     AUTOMATICALLY ZERO AND WE CAN SKIP THIS.(THE AREA IN THE
C     INTEGRATION IS 4*PI-MORSE+FESCHBACH-PAGES 1265 AND 1285--OR THE
C     A00 TE-M OF THE EXPANSION)
C     THE REASON FOR THE REFERENCE POTENTIAL IS THAT WE MUST ARBITRARILY
C     SET PHI=0 AT SOME POINT AND THEN THEN INTEGRATE TO GET PHIC.
C     REFF COMPENSATES FOR THAT
C
      REFF = 0.
  192 ONLYAR = .FALSE.
      IF (LOAD.EQ.0 .OR. ISYM.EQ.1) ONLYAR = .TRUE.
      IF (ANOM) ONLYAR = .TRUE.
C
      SUMP = 0.
      SUMA = 0.
      SUMEP= 0.
      DO 240 N = 1,NSEGS
      DO 240 M = 1,MSEGS
C
C     GET THE COORDINATES OF THE 4 CORNERS OF THE PATCH(3 CORNERS IF
C     1ST OR LAST SET OF SEGMENTS)
C
      IPT(1) = (M-1)*(NSEGS-1) + 2 + (N-1)
      IPT(2) = IPT(1) + (NSEGS-1)
      IPT(3) = IPT(2) + 1
      IPT(4) = IPT(1) + 1
      IF (M .NE. MSEGS) GO TO 195
      IF (ISYM  .NE. 0) GO TO 195
      IPT(2) = N + 1
      IPT(3) = IPT(2) + 1
  195 IF (N .NE. 1) GO TO 200
      IPT(1) = 1
      IPT(2) = 1
      GO TO 210
  200 IF (N .NE. NSEGS) GO TO 210
      IPT(3) = 2
      IPT(4) = 2
C
C     COMPITE VECTOR COMPONENTS FOR THE DIAGONALS AND TAKE 1/2 THE CROSS
C     PRODUCT TO GET THE PATCH AREA
C
  210 DO 215 I = 1,4
      ISUB  = 3*(IPT(I)-1) + IBG
      XX(I) = Z(ISUB+1)
      YY(I) = Z(ISUB+2)
      ZZ(I) = Z(ISUB+3)
      XETA(I) = DXI*XX(I)
      IF (ZZ(I).EQ.0. .AND. YY(I).EQ.0.) GO TO 215
      XPHI(I) = ATAN2(ZZ(I),YY(I))
      IF (XPHI(I) .LT. 0.) XPHI(I) = XPHI(I) + TPI
  215 CONTINUE
      IF (ISYM.NE.0 .OR. M.NE.MSEGS) GO TO 216
      XPHI(2) = TPI
      XPHI(3) = TPI
  216 IF (N .NE. 1) GO TO 217
      XPHI(1) = XPHI(4)
      XPHI(2) = XPHI(3)
      GO TO 218
  217 IF (N .NE. NSEGS) GO TO 218
      XPHI(4) = XPHI(1)
      XPHI(3) = XPHI(2)
  218 CONTINUE
C
      V13(1) = XX(3) - XX(1)
      V13(2) = YY(3) - YY(1)
      V13(3) = ZZ(3) - ZZ(1)
      V24(1) = XX(4) - XX(2)
      V24(2) = YY(4) - YY(2)
      V24(3) = ZZ(4) - ZZ(2)
C
      VX(1) = V13(2)*V24(3) - V13(3)*V24(2)
      VX(2) = V13(3)*V24(1) - V13(1)*V24(3)
      VX(3) = V13(1)*V24(2) - V13(2)*V24(1)
C
      AREA   = .5*SQRT(VX(1)**2+VX(2)**2+VX(3)**2)
      AREAEP = .5*((XETA(4)-XETA(2))*(XPHI(1)-XPHI(3))
     1           -(XETA(1)-XETA(3))*(XPHI(4)-XPHI(2)))
C
C     FOLLOWING IS BECAUSE OF BACKWARDS DEFINITION OF XPHI
C
      AREAEP = -AREAEP
      IF (ONLYAR) GO TO 235
C
C     PERFORM LINEAR INTERPOLATION OF TEH POTENTIALS FROM THE VERTICES
C     TO THE INTEGRATION POINTS USING ISOPARAMETRIC SHAPE FUNCTIONS AND
C     THEN INTEGRATE. 1ST PICK UP VERTEX POTENTIALS
C
C
      IPT1 = IPT(1)
      IPT2 = IPT(2)
      IPT3 = IPT(3)
      IPT4 = IPT(4)
      POTV(1) = Z(IHCPOT+IPT1)
      POTV(2) = Z(IHCPOT+IPT2)
      POTV(3) = Z(IHCPOT+IPT3)
      POTV(4) = Z(IHCPOT+IPT4)
C
      DO 220 I = 1,4
      POTI(I) = 0.
      DO 220 J = 1,4
      POTI(I) = POTI(I)+INTER(I,J)*POTV(J)
  220 CONTINUE
C
      SUM = 0.
      DO 230 I = 1,4
C
C     COMPUTE DETREMINANT OF JACOBIAN
C
      J11 = ETAI(I)*(XETA(4)-XETA(1)) + (1.-ETAI(I))*(XETA(3)-XETA(2))
      J12 = ETAI(I)*(XPHI(4)-XPHI(1)) + (1.-ETAI(I))*(XPHI(3)-XPHI(2))
      J21 = XII(I)*(XETA(4)-XETA(3)) + (1.- XII(I))*(XETA(1)-XETA(2))
      J22 = XII(I)*(XPHI(4)-XPHI(3)) + (1.- XII(I))*(XPHI(1)-XPHI(2))
      J12 =-J12
      J22 =-J22
      DETJ= J11*J22 - J12*J21
  230 SUM = SUM + POTI(I)*DETJ*.25
C
C     NOTE---  .25 * SUM OF THE 4 DETJ-S EQUALS AREAEP
C
      SUMP = SUMP + SUM
  235 SUMA = SUMA + AREA
      SUMEP= SUMEP + AREAEP
C
C     GET ANOTHER PATCH
C
  240 CONTINUE
C
      IF (SUMA .GT. 0.) GO TO 260
      WRITE  (OTPE,250) UFM
  250 FORMAT (A23,', AREA OF PROLATE SPHEROID IS ZERO')
      CALL MESAGE (-61,0,0)
C
C     COMPUTE ANALYTICAL AREA
C
  260 EPS  = .5*DFOC/SEMAJ
      AREA = 2.*PI*(SEMIN**2+SEMAJ*SEMIN*ASIN(EPS)/EPS)
      IF (ISYM .NE. 0) SUMA = 2.*SUMA
C
      IF (.NOT.WRIT) WRITE (OTPE,270) UIM,AREA,SUMA
  270 FORMAT (A29,', THE EXACT SURFACE AREA OF THE PROLATE SPHEROID IS',
     1       1X,1P,E15.3,',  THE COMPUTED AREA IS ',1P,E15.3)
      WRIT = .TRUE.
      IF (LOAD .EQ. 0) GO TO 295
      IF (ANOM) GO TO 295
      IF (ISYM .EQ. 1) GO TO 280
C
C     GET REFERNCE POTENTIAL AND SUBTRACT FROM SUM OF ANOMALY AND HC
C     POTENTI
C
      REFF = SUMP/SUMEP
  280 DO 290 I = 1,NGRIDS
  290 Z(IPOT+I) = Z(IPOT+I) + Z(IHCPOT+I) - REFF
C
C     FINALLY NOW WE CAN COMPUTE THE COEFFICIENTS A(M,N) AND B(M,N).
C     MORSE ABD FESCHBACH P. 1285--CHAECK FOR ENOUGH OPEN VORE SPACE TO
C     STORE THE A-S AND B-S. FOR EACH TYPE, THE NUMBER OF COEFFICIENTS
C     IS THE SUM OF TH+ INTEGERS FROM 1 TO (\+1), UNLESS M HAS A MAXIMUM
C     LESS THAN N, IN WHICH CASE, THE COUNT IS (M+1)*(N+1-M)+SUM OF
C     INTEGERS FROM 1 TO M. THE COEFFICIENTS WE NEED ARE
C
C              M=0       M=1       M=2       M=4       ETC
C        N=0   A00
C        N=1   A01       A11
C        N=2   A02       A12       A22
C        N=3   A03       A13       A23       A33
C         .
C        ETC
C
C     WE NO LONGER NEED THE HC POTENTIALS OR LOAD INFO. SO STORE
C     COEFFICIENTS STARTING AT 5*NGRIDS+1
C
  295 IACOEF = IPOT + NGRIDS
      NCOEFS = ((NNHARM+1)*(NNHARM+2))/2
      IF (NMHARM .LT. NNHARM) NCOEFS = (NMHARM+1)*(NNHARM+1-NMHARM)+
     1                                 (NMHARM*(NMHARM+1))/2
      IBCOEF = IACOEF + NCOEFS
      IF (IBCOEF+NCOEFS .GT. LCORE) GO TO 1008
      N2 = 2*NCOEFS
      DO 300 I = 1,N2
  300 Z(IACOEF+I) = 0.
C
C     START THE INTEGRATIONS - FOR EACH PATCH IN TURN, DO ALL THE M-S
C     AND N-
C
      DO 460 NS = 1,NSEGS
      DO 460 MS = 1,MSEGS
C
C     INITIAL PART IS SAME AS FOR REFERNEC POTENTIAL
C
      IPT(1) = (MS-1)*(NSEGS-1) + 2 + (NS-1)
      IPT(2) = IPT(1) + (NSEGS-1)
      IPT(3) = IPT(2) + 1
      IPT(4) = IPT(1) + 1
      IF (MS .NE. MSEGS) GO TO 310
      IF (ISYM  .NE.  0) GO TO 310
      IPT(2) = NS + 1
      IPT(3) = IPT(2) + 1
  310 IF (NS .NE. 1) GO TO 320
      IPT(1) = 1
      IPT(2) = 1
      GO TO 330
  320 IF (NS .NE. NSEGS) GO TO 330
      IPT(3) = 2
      IPT(4) = 2
  330 DO 335 I = 1,4
      ISUB  = 3*(IPT(I)-1) + IBG
      XX(I) = Z(ISUB+1)
      YY(I) = Z(ISUB+2)
      ZZ(I) = Z(ISUB+3)
      XETA(I) = DXI*XX(I)
      IF (ZZ(I).EQ.0. .AND. YY(I).EQ.0.) GO TO 335
      XPHI(I) = ATAN2(ZZ(I),YY(I))
      IF (XPHI(I) .LT. 0.) XPHI(I) = XPHI(I) + TPI
  335 CONTINUE
      IF (ISYM.NE.0 .OR. MS.NE.MSEGS) GO TO 337
      XPHI(2) = TPI
      XPHI(3) = TPI
  337 IF (NS .NE. 1) GO TO 338
      XPHI(1) = XPHI(4)
      XPHI(2) = XPHI(3)
      GO TO 339
  338 IF (NS .NE. NSEGS) GO TO 339
      XPHI(4) = XPHI(1)
      XPHI(3) = XPHI(2)
  339 CONTINUE
C
C     GET POTENTAILS AT VERTICES
C
      DO 336 I = 1,4
      ISUB = IPT(I)
      POTV(I) = Z(IPOT+ISUB)
  336 CONTINUE
C
C     INTERPOLATE TO GET POTENTIALS AT EACH INTEGRATION POINT
C
      DO 340 I = 1,4
      POTI(I) = 0.
      DO 340 J = 1,4
      POTI(I) = POTI(I) + INTER(I,J)*POTV(J)
  340 CONTINUE
C
C     SAVE JACOBIAN DETERMINA5TS AT THE INTEGRATION POINTS
C
      DO 350 I = 1,4
      J11 = ETAI(I)*(XETA(4)-XETA(1)) + (1.-ETAI(I))*(XETA(3)-XETA(2))
      J12 = ETAI(I)*(XPHI(4)-XPHI(1)) + (1.-ETAI(I))*(XPHI(3)-XPHI(2))
      J21 = XII(I)*(XETA(4)-XETA(3))  + (1.- XII(I))*(XETA(1)-XETA(2))
      J22 = XII(I)*(XPHI(4)-XPHI(3))  + (1.- XII(I))*(XPHI(1)-XPHI(2))
C
C     BECAUSE OF MY INCONSISTENCY IN DIRECTIONS BETWEEN PROLATE SPHEROID
C     COORDINATES IN ANGLE DIRECTION AND ISOPARAMETRIC COORDINATES IN
C     THAT DIRECTION, WE MUST SWITCH SIGNS FOR XPHI DIFFERENCES- OR ELSE
C     WE WE WILL GET NEGATIVE AREAS
C
      J12 = -J12
      J22 = -J22
C
      XDETJ(I) = J11*J22 - J12*J21
  350 CONTINUE
C
C     COMPUTE 4 (ETA,PHI) COORDINATES AT THE INTEGRATION POINTS. USE
C     SHAPE FUNCTIONS FOR UNIT SQUARE. (ETAINT AND PHIINT ARE PROLATE
C     SPHEROIDAL COORDINATES AT INTEGRATION POINTS. XETA,XHPI ARE
C     PROLATE SPHEROIDAL COORDS. AT VERTICES. XII,ETAI ARE ISOPARAMETRIC
C     COORDS AT INTEGRATION POINTS FOR UNIT ISOPARAMEQRIC SPUARE.
C
      DO 358 I = 1,4
      XN(1) = (1.-XII(I))*ETAI(I)
      XN(2) = (1.-XII(I))*(1.-ETAI(I))
      XN(3) = XII(I)*(1.-ETAI(I))
      XN(4) = XII(I)*ETAI(I)
      ETAINT(I) = 0.
      PHIINT(I) = 0.
      DO 357 J  = 1,4
      ETAINT(I) = ETAINT(I) + XN(J)*XETA(J)
      PHIINT(I) = PHIINT(I) + XN(J)*XPHI(J)
  357 CONTINUE
  358 CONTINUE
C
C     START ACTUAL INTEGRATION FOR A GIVEN N,M
C
      KOUNT = 0
      NNP1  = NNHARM + 1
      DO 450 N = 1,NNP1
      IAN = N - 1
      CN  = IAN
C
C     SINCE M SUMMATION GOES ONLY TO N, COMPUTE MIN(N,NNHARM)
C
      NMP1 = NMHARM + 1
      IF (NMP1 .GT. N) NMP1 = N
C
      DO 450 M = 1,NMP1
      IAM = M - 1
      CM  = IAM
      KOUNT = KOUNT + 1
C
C     COMPUTE ASSOCIATED LEGENDRE FUNCTION OF 1ST KIND AT EAC
C     INTEGRATION POINT
C
      DO 360 I = 1,4
      CALL PNM (IAM,IAN,ETAINT(I),0,PNMV(I))
  360 CONTINUE
C
C     COMPUTE TRIG FUNCTION AT EAC INTEGRATION POINT
C
      DO 370 I = 1,4
      ANG = CM*PHIINT(I)
      TRIGS(I) = SIN(ANG)
      TRIGC(I) = COS(ANG)
  370 CONTINUE
C
      SUMA = 0.
      SUMB = 0.
      DO 380 I = 1,4
      IF (ISYM.EQ.0 .OR. ISYM.EQ.1)
     1    SUMB = SUMB + TRIGS(I)*PNMV(I)*POTI(I)*XDETJ(I)*.25
      IF (ISYM.EQ.0 .OR. ISYM.EQ.2)
     1    SUMA = SUMA + TRIGC(I)*PNMV(I)*POTI(I)*XDETJ(I)*.25
  380 CONTINUE
C
C     NOW FORM MULTIPLICATICE CONSTANT BASED ON N,M
C
      EM = 1.
      IF (IAM .GT. 0) EM = 2.
C
C     ADJUST EM FOR 1/2 MODEL IF NECESSARY
C
      IF (ISYM .GT. 0) EM = 2.*EM
C
C     COMPUTE FACTORIALS
C
      NMM = IAN - IAM
      IF (NMM .NE. 0) GO TO 390
      FNUM = 1.
      GO TO 410
  390 FNUM = 1.
      C = 1.
      DO 400 I = 1,NMM
      FNUM = FNUM*C
      C = C + 1.
  400 CONTINUE
  410 NPM = IAN+IAM
      IF (NPM .NE. 0) GO TO 420
      FDEN = 1.
      GO TO 440
  420 FDEN = 1.
      C = 1.
      DO 430 I = 1,NPM
      FDEN = FDEN*C
      C = C + 1.
  430 CONTINUE
  440 CON = EM*(2.*CN+1.)*FNUM/FDEN/4./PI
C
      SUMA = SUMA*CON
      SUMB = SUMB*CON
C
C     STORE THE COEFFICIENTS
C
      Z(IACOEF+KOUNT) = SUMA+Z(IACOEF+KOUNT)
      Z(IBCOEF+KOUNT) = SUMB+Z(IBCOEF+KOUNT)
C
C     GET ANOTHER N OR M
C
  450 CONTINUE
C
C     GET ANOTHER AREA PATCH
C
  460 CONTINUE
C
C     DONE - THE SCARATCH DATA BLOCK PROCOS WILL HAVE 5 RECORDS FOR EACH
C     SUBCASE. 1ST IS 7 WORD INFO ARRAY, 2ND IS A(M,N) 3RD IS B(M,N)
C     4TH IS POTENTIALS ON SURFACE FROM ANOMALY+HC POTENTIALS-REFF,
C     5TH IS POTENTAILS ON SURFACE USING EXPANSION(WHICH WE WILL DO NOW)
C
      ISUMP = IBCOEF + NCOEFS
      IF (ISUMP+NGRIDS .GT. LCORE) GO TO 1008
C
      DO 480 I = 1,NGRIDS
C
C     PICK UP COORDINATES OF POINT
C
      ISUB = 3*(I-1) + IBG
      X1 = Z(ISUB+1)
      Y1 = Z(ISUB+2)
      Z1 = Z(ISUB+3)
C
C     COMPUTE PROLATE SPHEROIDAL COORDINATES
C
      ETA = DXI*X1
      PHI = 0.
      IF (Z1.EQ.0. .AND. Y1.EQ.0.) GO TO 465
      PHI = ATAN2(Z1,Y1)
C
C     START SUMMATION
C
  465 KOUNT = 0
      SUM   = 0.
      DO 470 N = 1,NNP1
      IAN = N - 1
      CN  = IAN
      NMP1= NMHARM + 1
      IF (NMP1 .GT. N) NMP1 = N
      DO 470 M = 1,NMP1
      IAM = M - 1
      CM  = IAM
      KOUNT = KOUNT + 1
C
C     GET LEGENDRE AND TRIG FUNCTIONS
C
      CALL PNM (IAM,IAN,ETA,0,V)
      ANG   = CM*PHI
      TRIG1 = COS(ANG)
      TRIG2 = SIN(ANG)
      AB    = 0.
      IF (ISYM.EQ.0 .OR. ISYM.EQ.1) AB = AB+Z(IBCOEF+KOUNT)*TRIG2
      IF (ISYM.EQ.0 .OR. ISYM.EQ.2) AB = AB+Z(IACOEF+KOUNT)*TRIG1
C
      SUM = SUM + AB*V
  470 CONTINUE
C
C     STORE VALUE
C
      Z(ISUMP+I) = SUM
C
C     GET ANOTHER POINT
C
  480 CONTINUE
C
C     WRITE RESULTS TO PROCOS
C
      FO(1)   = SEMAJ
      FO(2)   = SEMIN
      INFO(3) = NNHARM
      INFO(4) = NMHARM
      INFO(5) = NCOEFS
      INFO(6) = ISYM
      INFO(7) = NGRIDS
      CALL GOPEN (PROCOS,Z(BUF1),IOP1)
      CALL WRITE (PROCOS,INFO,7,0)
      CALL WRITE (PROCOS,TITLE,96,1)
      CALL WRITE (PROCOS,Z(IACOEF+1),NCOEFS,1)
      CALL WRITE (PROCOS,Z(IBCOEF+1),NCOEFS,1)
      CALL WRITE (PROCOS,Z(IPOT  +1),NGRIDS,1)
      CALL WRITE (PROCOS,Z(ISUMP +1),NGRIDS,1)
      CALL CLOSE (PROCOS,2)
C
C     NOW THAT WE ARE FINISHED ALL THIS WORK, WE SHOULD SEE IF THERE
C     ARE OTHER SUBCASES WE MUST DO IT FOR
C
      IF (SUBCAS .GE. NCOL) GO TO 490
      IOP  = 2
      IOP1 = 3
      GO TO 115
C
C     DONE
C
  490 TRAIL(1) = PROCOS
      TRAIL(2) = SUBCAS
      DO 500 I = 3,7
  500 TRAIL(I) = 0
      CALL WRTTRL (TRAIL)
C
C     CHECK FOR SUBCOMS AND REPCASES AND WRITE ( TO OUTPUT FILE
C
      CALL PROCOM (PROCOS,PROCOF,CASECC,NCOEFS,NGRIDS)
C
      RETURN
C
 1001 N =-1
      GO TO 1010
 1002 N =-2
      GO TO 1010
 1008 N =-8
      FILE = 0
 1010 CALL MESAGE (N,FILE,NAM)
      RETURN
      END

      SUBROUTINE STRIR1
C
C
C*****
C THIS ROUTINE IS PHASE I OF STRESS DATA RECOVERY FOR THE TRIANGULAR
C CROSS SECTION RING
C*****
C
C
C                        ECPT FOR THE TRIANGULAR RING
C
C
C                                                      TYPE
C ECPT( 1) ELEMENT IDENTIFICATION                        I
C ECPT( 2) SCALAR INDEX NO. FOR GRID POINT A             I
C ECPT( 3) SCALAR INDEX NO. FOR GRID POINT B             I
C ECPT( 4) SCALAR INDEX NO. FOR GRID POINT C             I
C ECPT( 5) MATERIAL ORIENTATION ANGLE(DEGREES)           R
C ECPT( 6) MATERIAL IDENTIFICATION                       I
C ECPT( 7) COOR. SYS. ID. FOR GRID POINT A               I
C ECPT( 8) X-COOR. OF GRID POINT A (IN BASIC COOR.)      R
C ECPT( 9) Y-COOR. OF GRID POINT A (IN BASIC COOR.)      R
C ECPT(10) Z-COOR. OF GRID POINT A (IN BASIC COOR.)      R
C ECPT(11) COOR. SYS. ID. FOR GRID POINT B               I
C ECPT(12) X-COOR. OF GRID POINT B (IN BASIC COOR.)      R
C ECPT(13) Y-COOR. OF GRID POINT B (IN BASIC COOR.)      R
C ECPT(14) Z-COOR. OF GRID POINT B (IN BASIC COOR.)      R
C ECPT(15) COOR. SYS. ID. FOR GRID POINT C               I
C ECPT(16) X-COOR. OF GRID POINT C (IN BASIC COOR.)      R
C ECPT(17) Y-COOR. OF GRID POINT C (IN BASIC COOR.)      R
C ECPT(18) Z-COOR. OF GRID POINT C (IN BASIC COOR.)      R
C ECPT(19) EL. TEMPERATURE FOR MATERIAL PROPERTIES       R
C
C
      DIMENSION          IECPT(19)
      DIMENSION          R(3),     Z(3),     ICS(3)
      DIMENSION          SP(18),   TEO(16),  DELINT(8)
C
      COMMON /CONDAS/ CONSTS(5)
      COMMON   /SDR2X5/
     1                   ECPT(19)
     2,                  DUM5(81)
     3,                  IDEL,     IGP(3),   TZ
     4,                  SEL(36),  TS(4),    AK(81)
      COMMON   /MATIN/
     1                   MATIDC             ,MATFLG
     2,                  ELTEMP             ,STRESS
     3,                  SINTH              ,COSTH
      COMMON   /MATOUT/
     1                   E(3)               ,ANU(3)
     2,                  RHO                ,G(3)
     3,                  ALF(3)             ,TZERO
      COMMON   /SDR2X6/
     1                   D(81) ,   GAMBQ(36),     EE(16),   GAMQS(54)
     3,                  DZERO(24),     GAMBL(81),     ALFB(4)
C
      EQUIVALENCE ( CONSTS(2) , TWOPI  )
      EQUIVALENCE ( CONSTS(4) , DEGRA  )
      EQUIVALENCE        (IECPT(1) , ECPT(1))
      EQUIVALENCE   (R(1),R1),     (R(2),R2),     (R(3),R3)
     1,             (Z(1),Z1),     (Z(2),Z2),     (Z(3),Z3)
      EQUIVALENCE        (GAMBL( 1),    SP(1))
      EQUIVALENCE        (GAMBL( 1),    TEO(1))
      EQUIVALENCE        (GAMBL(17),    DELINT(1))
C
C ----------------------------------------------------------------------
C
C STORE ECPT PARAMETERS IN LOCAL VARIABLES
C
      IDEL  = IECPT(1)
      IGP(1)= IECPT(2)
      IGP(2)= IECPT(3)
      IGP(3)= IECPT(4)
      MATID = IECPT(6)
      ICS(1)= IECPT(7)
      ICS(2)= IECPT(11)
      ICS(3)= IECPT(15)
      R(1)  = ECPT(8)
      D(1)  = ECPT(9)
      Z(1)  = ECPT(10)
      R(2)  = ECPT(12)
      D(2)  = ECPT(13)
      Z(2)  = ECPT(14)
      R(3)  = ECPT(16)
      D(3)  = ECPT(17)
      Z(3)  = ECPT(18)
      TEMPE = ECPT(19)
      DGAMA = ECPT(5)
C
C
C TEST THE VALIDITY OF THE GRID POINT COORDINATES
C
      DO 200 I = 1,3
      IF (R(I) .LT. 0.0E0) CALL MESAGE (-30, 37, IDEL)
      IF (D(I) .NE. 0.0E0) CALL MESAGE (-30, 37, IDEL)
  200 CONTINUE
C
C
C COMPUTE THE ELEMENT COORDINATES
C
      ZMIN = AMIN1(Z1, Z2, Z3)
      Z1 = Z1 - ZMIN
      Z2 = Z2 - ZMIN
      Z3 = Z3 - ZMIN
C
C
C
C FORM THE TRANSFORMATION MATRIX (6X6) FROM FIELD COORDINATES TO GRID
C POINT DEGREES OF FREEDOM
C
      DO 300 I = 1,36
      GAMBQ(I) = 0.0E0
  300 CONTINUE
      GAMBQ( 1) = 1.0E0
      GAMBQ( 2) = R1
      GAMBQ( 3) = Z1
      GAMBQ(10) = 1.0E0
      GAMBQ(11) = R1
      GAMBQ(12) = Z1
      GAMBQ(13) = 1.0E0
      GAMBQ(14) = R2
      GAMBQ(15) = Z2
      GAMBQ(22) = 1.0E0
      GAMBQ(23) = R2
      GAMBQ(24) = Z2
      GAMBQ(25) = 1.0E0
      GAMBQ(26) = R3
      GAMBQ(27) = Z3
      GAMBQ(34) = 1.0E0
      GAMBQ(35) = R3
      GAMBQ(36) = Z3
C
C
C     NO NEED TO COMPUTR DETERMINANT SINCE IT IS NOT USED SUBSEQUENTLY.
      ISING = -1
      CALL INVERS (6, GAMBQ(1),6 , D(10), 0, D(11) , ISING , SP)
C
      IF (ISING .EQ. 2) CALL MESAGE(-30,26,IDEL)
C
C
C
C CALCULATE THE INTEGRAL VALUES IN ARRAY DELINT WHERE THE ORDER IS
C INDICATED BY THE FOLLOWING TABLE
C
C              DELINT( 1) - (-1,0)
C              DELINT( 2) - (-1,1)
C              DELINT( 3) - (-1,2)
C              DELINT( 4) - ( 0,0)
C              DELINT( 5) - ( 0,1)
C              DELINT( 6) - ( 1,0)
C              DELINT( 7) - ( 0,2)
C              DELINT( 8) - ( 1,2)
C
C
C TEST FOR RELATIVE SMALL AREA OF INTEGRATION
C AND IF AREA IS SMALL THEN APPROXIMATE INTEGRALS
C
      DR = AMAX1 (  ABS(R1-R2) ,  ABS(R2-R3) ,  ABS(R3-R1) )
      RH = AMIN1 ( R1 , R2 , R3 ) / 10.0E0
      DZ = AMAX1 (  ABS(Z1-Z2) ,  ABS(Z2-Z3) ,  ABS(Z3-Z1) )
      ZH = AMIN1 ( Z1 , Z2 , Z3 ) / 10.0E0
      RA = (R1 + R2 + R3) / 3.0E0
      ZA = (Z1 + Z2 + Z3) / 3.0E0
      AREA =(R1*(Z2-Z3) + R2*(Z3-Z1) + R3*(Z1-Z2)) / 2.0E0
      KODE = 0
      IF ( ABS( (R2-R1)/R2 ) .LT. 1.0E-5) KODE = 1
      IF ( DR .LE. RH  .OR.  DZ .LE. ZH ) KODE = -1
C
C
  310 CONTINUE
      I1 = 0
      DO 400 I = 1,3
      IP = I - 2
      DO 350 J = 1,3
      IQ = J - 1
      IF (IP.EQ.1 .AND. IQ.EQ.1) GO TO 350
      I1 = I1 + 1
      IF (KODE) 320,330,340
  320 DELINT(I1) =((RA) ** IP)*((ZA) ** IQ) * AREA
      GO TO 350
  330 DELINT(I1) =    AI (1,3,1,2,1,3,IP,IQ,R,Z)
     1            +   AI (3,2,1,2,3,2,IP,IQ,R,Z)
      GO TO 350
  340 CONTINUE
      DELINT(I1) =    AI (1,3,3,2,1,3,IP,IQ,R,Z)
  350 CONTINUE
  400 CONTINUE
      D(1)      = DELINT(6)
      DELINT(6) = DELINT(7)
      DELINT(7) = D(1)
C
C
C TEST FOR EXCESSIVE ROUND-OFF ERROR IN INTEGRAL CALCULATIONS
C AND IF IT EXIST APPROXIMATE INTEGRALS
C
      IF (KODE .LT. 0) GO TO 500
      DO 450 I = 1,8
      IF (DELINT(I) .LT. 0.0E0) GO TO 475
  450 CONTINUE
      IF (DELINT(8) .LE. DELINT(7)) GO TO 475
      IF (DELINT(3) .GE. DELINT(8)) GO TO 475
      IF (DELINT(3) .GT. DELINT(7)) GO TO 475
      GO TO 500
  475 CONTINUE
      KODE = -1
      GO TO 310
  500 CONTINUE
C
C
C
C LOCATE THE MATERIAL PROPERTIES IN THE MAT1 OR MAT3 TABLE
C
      MATIDC = MATID
      MATFLG = 7
      ELTEMP = TEMPE
      CALL  MAT (IDEL)
C
C
C SET MATERIAL PROPERTIES IN LOCAL VARIABLES
C
      ER = E(1)
      ET = E(2)
      EZ = E(3)
      VRT = ANU(1)
      VTZ = ANU(2)
      VZR = ANU(3)
      GRZ = G(3)
      TZ = TZERO
      VTR = VRT * ET / ER
      VZT = VTZ * EZ / ET
      VRZ = VZR * ER / EZ
      DEL = 1.0E0 - VRT*VTR - VTZ*VZT - VZR*VRZ - VRT*VTZ*VZR
     1       - VRZ*VTR*VZT
C
C
C GENERATE ELASTIC CONSTANTS MATRIX (4X4)
C
      EE(1) = ER * (1.0E0 - VTZ*VZT) / DEL
      EE(2) = ER * (VTR + VZR*VTZ) / DEL
      EE(3) = ER * (VZR + VTR*VZT) / DEL
      EE(4) = 0.0E0
      EE(5) = EE(2)
      EE(6) = ET * (1.0E0 - VRZ*VZR) / DEL
      EE(7) = ET * (VZT + VRT*VZR) / DEL
      EE(8) = 0.0E0
      EE(9) = EE(3)
      EE(10)= EE(7)
      EE(11)= EZ * (1.0E0 - VRT*VTR) / DEL
      EE(12)= 0.0E0
      EE(13)= 0.0E0
      EE(14)= 0.0E0
      EE(15)= 0.0E0
      EE(16)= GRZ
C
C
C FORM TRANSFORMATION MATRIX (4X4) FROM MATERIAL AXIS TO ELEMENT
C GEOMETRIC AXIS
C
      DGAMR = DGAMA * DEGRA
      COSG =  COS(DGAMR)
      SING =  SIN(DGAMR)
      TEO( 1) = COSG ** 2
      TEO( 2) = 0.0E0
      TEO( 3) = SING ** 2
      TEO( 4) = SING * COSG
      TEO( 5) = 0.0E0
      TEO( 6) = 1.0E0
      TEO( 7) = 0.0E0
      TEO( 8) = 0.0E0
      TEO( 9) = TEO(3)
      TEO(10) = 0.0E0
      TEO(11) = TEO(1)
      TEO(12) = -TEO(4)
      TEO(13) = -2.0E0 * TEO(4)
      TEO(14) = 0.0E0
      TEO(15) = -TEO(13)
      TEO(16) = TEO(1) - TEO(3)
C
C
C TRANSFORM THE ELASTIC CONSTANTS MATRIX FROM MATERIAL
C TO ELEMENT GEOMETRIC AXIS
C
      CALL GMMATS (TEO , 4, 4, 1, EE , 4, 4, 0, D )
      CALL GMMATS (D   , 4, 4, 0, TEO, 4, 4, 0, EE)
C
C
C
C FORM THE ELEMENT STIFFNESS MATRIX IN FIELD COORDINATES
C
      AK( 1) = EE(6) * DELINT(1)
      AK( 2) = (EE(2) + EE(6)) * DELINT(4)
      AK( 3) = EE(6) * DELINT(2) + EE(8) * DELINT(4)
      AK( 4) = 0.0E0
      AK( 5) = EE(8) * DELINT(4)
      AK( 6) = EE(7) * DELINT(4)
      AK( 7) = AK(2)
      AK( 8) = (EE(1) + 2.0E0*EE(2) + EE(6)) * DELINT(6)
      AK( 9) = (EE(2) + EE(6)) * DELINT(5) + (EE(4) + EE(8)) *DELINT(6)
      AK(10) = 0.0E0
      AK(11) = (EE(4) + EE(8)) * DELINT(6)
      AK(12) = (EE(3) + EE(7)) * DELINT(6)
      AK(13) = AK(3)
      AK(14) = AK(9)
      AK(15) = EE(6) * DELINT(3) + 2.0E0*EE(8) * DELINT(5)
     1         + EE(16) * DELINT(6)
      AK(16) = 0.0E0
      AK(17) = EE(8) * DELINT(5) + EE(16) * DELINT(6)
      AK(18) = EE(7) * DELINT(5) + EE(12) * DELINT(6)
      AK(19) = 0.0E0
      AK(20) = 0.0E0
      AK(21) = 0.0E0
      AK(22) = 0.0E0
      AK(23) = 0.0E0
      AK(24) = 0.0E0
      AK(25) = AK(5)
      AK(26) = AK(11)
      AK(27) = AK(17)
      AK(28) = 0.0E0
      AK(29) = EE(16) * DELINT(6)
      AK(30) = EE(12) * DELINT(6)
      AK(31) = AK(6)
      AK(32) = AK(12)
      AK(33) = AK(18)
      AK(34) = 0.0E0
      AK(35) = AK(30)
      AK(36) = EE(11) * DELINT(6)
C
      DO 600 I = 1,36
      AK(I) = TWOPI * AK(I)
  600 CONTINUE
C
C TRANSFORM THE ELEMENT STIFFNESS MATRIX FROM FIELD COORDINATES
C TO GRID POINT DEGREES OF FREEDOM
C
      CALL GMMATS (GAMBQ , 6, 6, 1, AK , 6, 6, 0, D )
      CALL GMMATS (D  , 6, 6, 0, GAMBQ , 6, 6, 0, AK)
C
C
C
C GENERATE THE TRANSFORMATION MATRIX FROM TWO TO THREE DEGREES OF
C FREEDOM PER POINT
C
      DO 700 I = 1,54
      GAMQS( I) = 0.0E0
  700 CONTINUE
      GAMQS( 1) = 1.0E0
      GAMQS(12) = 1.0E0
      GAMQS(22) = 1.0E0
      GAMQS(33) = 1.0E0
      GAMQS(43) = 1.0E0
      GAMQS(54) = 1.0E0
C
C
C TRANSFORM THE STIFFNESS MATRIX FROM TWO TO THREE DEGREES OF
C FREEDOM PER POINT
C
      CALL GMMATS (GAMQS(1) , 6, 9, 1, AK(1) , 6, 6, 0, D(1) )
      CALL GMMATS (D(1)    , 9, 6, 0, GAMQS(1) , 6, 9, 0, AK(1) )
C
C
C LOCATE THE TRANSFORMATION MATRICES FOR THE THREE GRID POINTS
C
      DO 750 I = 1,81
      GAMBL(I) = 0.0E0
  750 CONTINUE
      DO 800 I = 1,3
      CALL TRANSS (ICS(I) , D(1))
      K = 30* (I-1) + 1
      DO 800 J = 1,3
      KK = K + 9 * (J-1)
      JJ = 3 * (J-1) + 1
      GAMBL(KK  ) = D(JJ  )
      GAMBL(KK+1) = D(JJ+1)
      GAMBL(KK+2) = D(JJ+2)
  800 CONTINUE
C
C
C TRANSFORM THE STIFFNESS MATRIX FROM BASIC TO LOCAL COORDINATES
C
      CALL GMMATS (GAMBL(1) , 9, 9, 1, AK(1) , 9, 9, 0, D(1) )
      CALL GMMATS (D(1)    , 9, 9, 0, GAMBL(1) , 9, 9, 0, AK(1) )
C
C
C FORM THE D SUB 0 MATRIX
C
      DO 850 I = 1,24
      DZERO(I) = 0.0E0
  850 CONTINUE
      DZERO( 2) = 1.0E0
      DZERO( 7) = 1.0E0 / RA
      DZERO( 8) = 1.0E0
      DZERO( 9) = ZA / RA
      DZERO(18) = 1.0E0
      DZERO(21) = 1.0E0
      DZERO(23) = 1.0E0
C
C
C COMPUTE THE STRESS MATRIX IN FIELD COORDINATES
C
      CALL GMMATS (EE(1) , 4, 4, 0, DZERO(1) , 4, 6, 0, D(1) )
C
C
C TRANSFORM THE STRESS MATRIX TO GRID POINT DEGREES OF FREEDOM
C
      CALL GMMATS (D(1) , 4, 6, 0, GAMBQ(1) , 6, 6, 0, SEL(1) )
C
C
C TRANSFORM THE STRESS MATRIX FROM TWO TO THREE DEGREES OF FREEDOM
C PER POINT
C
      CALL GMMATS (SEL(1) , 4, 6, 0, GAMQS(1) , 6, 9, 0, D(1) )
C
C
C TRANSFORM THE STRESS MATRIX FROM BASIC TO LOCAL COORDINATES
C
      CALL GMMATS (D(1) , 4, 9, 0, GAMBL(1) , 9, 9, 0, SEL(1) )
C
C
C COMPUTE THE THERMAL STRAIN VECTOR
C
      DO 900 I = 1,3
      ALFB(I) = ALF(I)
  900 CONTINUE
      ALFB(4) = 0.0E0
C
C
C COMPUTE THE THERMAL STRESS VECTOR
C
      CALL GMMATS (EE(1) , 4, 4, 0, ALFB(1) , 4, 1, 0, TS(1) )
C
C
      RETURN
      END

      SUBROUTINE VALVEC
C
C     LARGE ORDER REAL SYMMETRIC EIGENVALUE-EIGENVECTOR PROBLEM
C
      INTEGER         QR,MCB(8),TRI(3),QRX(3),WIL(3),VAL(3)
      DIMENSION       VCOM(30)
      COMMON /ZZZZZZ/ A(1)
      COMMON /GIVN  / TITLE(150)
CWKBR 2/94 SPR93027 COMMON /SYSTEM/ ISYS
      COMMON /SYSTEM/ ISYS, IDUMM(53), IPREC
      EQUIVALENCE     (MD   ,TITLE(3)), (VCOM(1),TITLE(101)),
     1                (N    ,VCOM( 1)), (NV     ,VCOM(   7)),
     2                (OEIGS,VCOM(11)), (NVER   ,VCOM(  13)),
     3                (NEVER,VCOM(14)), (ITERM  ,VCOM(  16))
      DATA    TRI   / 4HTRID, 4HI   , 4H    /
      DATA    QRX   / 4HQRIT, 4HER  , 4H    /
      DATA    WIL   / 4HWILV, 4HEC  , 4H    /
      DATA    VAL   / 4HVALV, 4HEC  , 4H    /
      DATA    IBEGN , IEND  / 4HBEGN, 4HEND /
C
C     DEFINITION OF VARIABLES AND DATA FORMATS
C
C     MD       INPUT MATRIX
C     N        SIZE OF MATRIX
C     NV       NUMBER OF EIGENVECTORS DESIRED
C     OEIGS    EIGENVALUE SUMMARY FILE
C     A        OPEN CORE
C     ID       POINTER TO DIAGONALS      -- N OF THEM (D.P.)
C     IO       POINTER TO OFF-DIAGONALS  -- N OF THEM (D.P.)
C     IV       POINTER TO EIGENVALUES    -- N OF THEM (D.P.)
C     IL       POINTER TO ORDER FOUND ARRAY N OF THEM (S.P.)
C     I1 - I6  POINTS TO SCRATCH ARRAYS  -- 2XN LONG
C     NVER     NUMBER OF VECTORS    ERRORS
C     NEVER    NUMBER OF EIGENVALUE ERRORS
C     ITERM    REASON FOR TERMINATION
C
C     INITIALIZATION FOR VALVEC IN BLOCKDATA ROUTINE READBD
C
C     DATA
C    1 MO, MD,MR1, M1, M2, M3, M4,LGAMA,OEIGS,PHIA,ORDER,RSTRT,NCOL,MAX/
C    *301,304,202,303,307,308,309,  201,  204, 305,   -2,   0 ,   0,253/
C
C
      VAL(3) = IBEGN
      CALL CONMSG (VAL,3,0)
      ITERM  = 1
      MCB(1) = MD
      CALL RDTRL (MCB(1))
      N  = MCB(2)
      N2 = N*IPREC
      ID = 1
      IO = ID + N2
      IV = IO + N2
      IL = IV + N2
      I1 = IL + N
      IF ((I1 + 1)/2  .EQ. I1/2) I1 = I1 + 1
      I2 = I1 + N2
      I3 = I2 + N2
      I4 = I3 + N2
      I5 = I4 + N2
      I6 = I5 + N2
C
C     TRIDIAGONALIZATION.
C
      IF (N .GT. 2) GO TO 101
CWKBD 2/94 SPR93027 CALL SMLEIG (A(ID),A(IO),A(IV)) 
CWKBNB 2/94 SPR93027
      IF ( IPREC .EQ. 2 ) CALL SMLEIG (A(ID),A(IO),A(IV)) 
      IF ( IPREC .EQ. 1 ) CALL SMLEIG1(A(ID),A(IO),A(IV)) 
CWKBNE 2/94 SPR93027
      
      IF (N-2) 300,200,300
  101 TRI(3) = IBEGN
      CALL CONMSG (TRI,3,0)
CWKBD 2/94 SPR93027 CALL TRIDI (A(ID),A(IO),A(IV),A(IL),A(I1),A(IL))
CWKBNB 2/94 SPR93027
      IF ( IPREC .EQ. 2 )
     &CALL TRIDI (A(ID),A(IO),A(IV),A(IL),A(I1),A(IL))
C                   D      O    V     A     B    
      IF ( IPREC .EQ. 1 )
     &CALL TRIDI1(A(ID),A(IO),A(IV),A(IL),A(I1),A(IL))
C                   D      O    V     A     B   
CWKBNE 2/94 SPR93027
      TRI(3) = IEND
      CALL CONMSG (TRI,3,0)
C
C     EIGENVALUES
C
  200 QR =  0
      IF (N .LE. 2) QR = 1
      QRX(3) = IBEGN
      CALL CONMSG (QRX,3,0)
CWKBD 2/94 SPR93027 CALL QRITER (A(IV),A(I1),A(IL),QR) 
CWKBNB 2/94 SPR93027
      IF ( IPREC .EQ. 2 ) CALL QRITER (A(IV),A(I1),A(IL),QR) 
      IF ( IPREC .EQ. 1 ) CALL QRITER1(A(IV),A(I1),A(IL),QR) 
CWKBNE 2/94 SPR93027
      
      QRX(3) = IEND
      CALL CONMSG (QRX,3,0)
      RSTRT  = 0
      WIL(3) = IBEGN
      CALL CONMSG (WIL,3,0)
C
C     EIGENVECTORS
C
CWKBDB 2/94 SPR93027
C     CALL WILVEC (A(ID),A(IO),A(IV),A(IL),A(I1),A(I2),A(I3),A(I4),
C     1             A(I5),A(I6),N,A(I6))
CWKBDE 2/94 SPR93027
CWKBNB 2/94 SPR93027
      IF ( IPREC .EQ. 1 )
C                    D      0    C    A      B
     &CALL WILVEC1(A(ID),A(IO),A(IV),A(IL),A(I1),A(I2),A(I3),A(I4),
     &             A(I5),A(I6),N,A(I6))
      IF ( IPREC .EQ. 2 )
C                    D      0    C    A      B
     &CALL WILVEC (A(ID),A(IO),A(IV),A(IL),A(I1),A(I2),A(I3),A(I4),
     &             A(I5),A(I6),N,A(I6))
CWKBNE 2/94 SPR93027
      WIL(3) = IEND
      CALL CONMSG (WIL,3,0)
  300 CONTINUE
      CALL GOPEN (OEIGS,A(1),1)
      MCB(1) = 4
      MCB(2) = N
      MCB(3) = NV
      MCB(4) = NEVER
      MCB(5) = NVER
      MCB(8) = ITERM
      CALL WRITE (OEIGS,MCB,8,1)
      CALL CLOSE (OEIGS,1)
      VAL(3) = IEND
      CALL CONMSG (VAL,3,0)
      RETURN
      END

      SUBROUTINE DTRIA (IOPT)
C
C     THIS ROUTINE GENERATES THE FOLLOWING
C
C     THREE 6X6 DIFFERENTIAL STIFFNESS MATRIX PARTITION FOR ONE PIVOT
C     POINT FOR A TRIA1, TRIA2 OR TORA3 ELEMENT.
C
C
C     CALLS FROM THIS ROUTINE ARE MADE TO
C           DTRBSC - BASIC BENDING TRI. ROUTINE.
C           DTRMEM - TRIANGLULAR MEMBRANE ROUTINE
C           TRANSD - SUPPLIES 3X3 TRANSFORMATIONS
C           INVERD - MATRIX INVERSION ROUTINE
C           GMMATD - GENERAL MATRIX MULITPLY AND TRANSPOSE ROUTINE
C           DS1B   - INSERTION ROUTINE
C
C
C          IOPT  = 1               2           3
C     ECPT INDEX   TRIA1           TRIA2       TRIA3       TRMEM
C     **********   *********       ********    ********    ********
C           1      EL ID           EL ID       EL ID        EL ID
C           2      SIL1            SIL1        SIL1         SIL1
C           3      SIL2            SIL2        SIL2         SIL2
C           4      SIL3            SIL3        SIL3         SIL3
C           5      THETA           THETA       MEM T1       THETA
C           6      MAT ID 1        MAT ID      MEM T2       MAT ID
C           7      T1              T           MEM T3       T
C           8      MAT ID 2        NSM         THETA        NSM
C           9      INERTIA I       CID1        FLAG FOR 8   CID1
C          10      MAT ID 3        X1          GRD OFFSET   X1
C          11      T2              Y1          MAT ID1      Y1
C          12      NSM             Z1          THICKNESS    Z1
C          13      Z1              CID2        MAT ID2      CID2
C          14      Z2              X2          INERTIA I    X2
C          15      CID1            Y2          MAT ID 3     Y2
C          16      X1              Z2          TS/T         Z2
C          17      Y1              CID3        NSM          CID3
C          18      Z1              X3          Z1           X3
C          19      CID2            Y3          Z2           Y3
C          20      X2              Z3          MAT ID 4     Z3
C          21      Y2              EL TEMP     THETA        EL TEMP
C          22      Z2                          FLAG FOR 21  EL DEFORM
C          23      CID3                        INTEGRATION  LOAD TEMP
C          24      X3              U1          STRESS ANGLE U1
C          25      Y3              V1          FLAG FOR 24  V2
C          26      Z3              W1          ZOFF1        W3
C          27      EL TEMP         U2          CID1         U2
C          28      EL DEFORM       V2          X1           V2
C          29      EL LOAD TEMP    W2          Y1           W2
C          30      U1 -DISP FOR U1 U3          Z1           U3
C          31      V1 -DISP FOR V1 V3          CID2         V3
C          32      W1 -DISP FOR Z1 W3          X2           W3
C          33      U2 -DISP FOR X2             Y2
C          34      V2 -DISP FOR Y2             Z2
C          35      W2 -DISP FOR Z2             CID3
C          36      U3 -DISP FOR X3             X3
C          37      V3 -DISP FOR Y3             Y3
C          38      W3 -DISP FOR Z3             Z3
C          39                                  EL TEMP
C          40
C          41
C          42                                  U1
C          43                                  V1
C          44                                  W1
C          45                                  U2
C          46                                  V2
C          47                                  W2
C          48                                  U3
C          49                                  V3
C          50                                  W3
C
      INTEGER          SUBSCA        ,SUBSCB        ,SUBSCC        ,
     1                 CID1
      DOUBLE PRECISION
     1                 R             ,D1            ,HABC          ,
     2                 TEMP          ,D2            ,HINV          ,
     3                 KSUM          ,IVECT         ,G             ,
     4                 V             ,JVECT         ,E             ,
     5                 VV            ,KVECT         ,TITE          ,
     6                 XSUBB         ,TEMP9         ,TJTE          ,
     7                 XSUBC         ,PROD9         ,ARR9          ,
     8                 YSUBC         ,U1            ,ARRAY9        ,
     9                 T             ,U2            ,TEMP18        ,
     T                 A             ,TEMP1         ,PROD12        ,
     1                 C1            ,TEMP2         ,HQ            ,
     2                 C2            ,L1            ,Y1            ,
     3                 X1            ,L2            ,Y2            ,
     4                 X2            ,S1            ,DETERM        ,
     5                 S2            ,KOUT          ,S             ,
     6                 REQUIV
      DOUBLE PRECISION SIGX          ,SIGY          ,SIGXY         ,
     1                 STRES         ,DUMTWO
      DIMENSION
     1                 NECPT(100)    ,M(9)          ,REQUIV(8)     ,
     2                 HQ(12)        ,PROD12(12)    ,HABC(18)      ,
     3                 G(36)         ,TITE(18)      ,TJTE(18)      ,
     4                 KOUT(36)      ,TEMP18(18)    ,V1(3)         ,
     5                 V2(3)         ,V3(3)         ,D1(3)         ,
     6                 D2(3)
      CHARACTER        UFM*23        ,UWM*25        ,UIM*29        ,
     1                 SFM*25
      COMMON /XMSSG /  UFM           ,UWM           ,UIM           ,
     1                 SFM
      COMMON /MATIN /  MATID,INFLAG  ,ELTEMP,STRESS ,SINTH,COSTH
      COMMON /MATOUT/  G11,G12,G13   ,G22,G23,G33   ,RHO,ALPHA1    ,
     1                 ALPHA2,ALP12  ,T SUB 0       ,G SUB E       ,
     2                 SIGTEN,SIGCOM ,SIGSHE,G2X211 ,G2X212 ,G2X222
      COMMON /DS1AAA/  NPVT          ,ICSTM         ,NCSTM
      COMMON /DS1AET/  ECPT(100)
      COMMON /DS1ADP/  A(54)         ,S(18)         ,HINV(36)      ,
     1                 T(9)          ,TEMP9(9)      ,PROD9(9)      ,
     2                 ARR9(9)       ,ARRAY9(9)     ,
     3                 E(18)         ,TEMP          ,TEMP1         ,
     4                 TEMP2         ,L1            ,L2            ,
     5                 S1            ,S2            ,C1            ,
     6                 C2            ,X1            ,X2            ,
     7                 Y1            ,Y2            ,DUMTWO(2)     ,
     8                 DETERM        ,SIGX          ,SIGY          ,
     9                 SIGXY         ,XSUBB         ,XSUBC         ,
     T                 YSUBC         ,STRES(3)      ,KSUM(63)      ,
     1                 IVECT(3)      ,JVECT(3)      ,KVECT(3)      ,
     2                 R(2,4)        ,
     3                 V(2)          ,VV(2)         ,U1            ,
     4                 U2            ,NPOINT        ,KM            ,
     5                 SUBSCA        ,SUBSCB        ,SUBSCC        ,
     6                 NPIVOT        ,IPVT          ,THETA         ,
     7                 NSUBB         ,NSUBC         ,ISING         ,
     8                 NPT1          ,SINANG        ,COSANG
      COMMON /CONDAS/  PI            ,TWOPI         ,RADEG         ,
     1                 DEGRA         ,S4PISQ
      COMMON /SYSTEM/  IBUFF         ,NOUT          ,NOGO
      EQUIVALENCE
     1                 (NECPT(1),ECPT(1)) , (PROD12(1),A(13))      ,
     2                 (HABC(1),A(25))    , (TITE(1),A(37))        ,
     3                 (TJTE(1),S( 1))    , (KOUT(1),A(1))         ,
     4                 (TEMP18(1),HINV(1)), (V1(1),ECPT(66))       ,
     5                 (V2(1),ECPT(70))   , (V3(1),ECPT(74))       ,
     6                 (REQUIV(1),R(1,1)) , (D1(1),A(1))           ,
     7                 (D2(1),A(4))       , (HQ(1),A(1))
C
C
      DATA     M    /  1,2,4,  2,3,4,  3,1,4 /,  CID1  / 65        /
C
C
C     THE ECPT DATA IS COPIED TO ECPT(PLUS 50)
C     THE DATA IN ECPT(BELOW 50) IS THEN PUT INTO TRMEM FORMAT TO BE
C     USED BY DTRMEM
C     THE DATA IN ECPT(ABOVE 50, SPECIALLY 51 THRU 62, 65 THRU 88) IS
C     PUT INTO TRIA1 FORMAT, WHICH WILL BE USED BY DTRBSC AND LOCALLY
C
      ICID = CID1 - 4
      DO 10 I = 1,50
   10 ECPT(I+50) = ECPT(I)
      GO TO (15,25,35), IOPT
C
C     TRIA1
C
   15 J = 15
      DO 20 I = 9,32
      ECPT(I) = ECPT(J)
   20 J = J + 1
      GO TO 60
C
C     TRIA2
C
   25 ECPT(58) = ECPT(6)
      ECPT(59) =(ECPT(7)**3)/12.0
      ECPT(60) = ECPT(6)
      ECPT(61) = ECPT(7)
C
      J = 9
      DO 30 I = 65,88
      ECPT(I) = ECPT(J)
   30 J = J + 1
      GO TO 60
C
C     TRIA3
C
C     IF NECPT(9)=0, ECPT(8) IS MATERIAL PROPERTY ORIENTAION ANGLE THETA
C     IF NECPT(9).NE.0, NECPT(8) IS MATERIAL COORDINATE SYSTEM ID. IN
C     THIS CASE, WE CAN NOT CONTINUE (NEED MORE STUFFS TO COMPUTE THETA,
C     SEE SHCSGD)
C
   35 IF (NECPT(9) .NE. 0) GO TO 410
      ECPT(5) = ECPT( 8)
      ECPT(6) = ECPT(11)
      ECPT(7) = ECPT(12)
      J = 27
      DO 40 I = 9,32
      ECPT(I) = ECPT(J)
   40 J = J + 1
C
      ECPT(55) = ECPT(58)
      J = 61
      DO 45 I = 56,60
      ECPT(I) = ECPT(J)
   45 J = J + 1
      ECPT(61) = ECPT(62)
      J = 77
      DO 50 I = 65,88
      ECPT(I) = ECPT(J)
   50 J = J + 1
C
   60 THETA  = ECPT(5)*DEGRA
      SINANG = SIN(THETA)
      COSANG = COS(THETA)
      SINTH  = SINANG
      COSTH  = COSANG
C
      CALL DTRMEM (2)
C
C     SIGX, SIGY , SIGXY ARE NOW AVAILABLE. SAVE THEM.
C
      STRES(1) = SIGX
      STRES(2) = SIGY
      STRES(3) = SIGXY
C
      ELTEMP = ECPT(21)
C
C     DETERMINE PIVOT POINT NUMBER
C
      DO 70 I = 1,3
      IF (NPVT .NE. NECPT(I+1)) GO TO 70
      NPIVOT = I
      GO TO 80
   70 CONTINUE
      RETURN
C
C     FALL THRU ABOVE LOOP IMPLIES ERROR CONDITION
C
   80 CONTINUE
C
C     FORMATION OF THE R-MATRIX CONTAINING COORDINATES OF THE
C     SUB TRIANGLES. (2X4) FOR TRIANGULAR PLATE. (COLUMN 4 BLANK)
C     FORMATION ALSO OF THE I,J, AND K VECTORS USED IN THE E-MATRIX.
C
C     ZERO OUT R-MATRIX
C
      DO 90 I = 1,8
   90 REQUIV(I) = 0.0D0
C
      DO 100 I = 1,3
      D2(I) = DBLE(V2(I)) - DBLE(V1(I))
  100 D1(I) = DBLE(V3(I)) - DBLE(V1(I))
C
C     X2  GOES IN R(1,2)
C
      R(1,2) = DSQRT(D2(1)**2 + D2(2)**2 + D2(3)**2)
      DO 110 I = 1,3
  110 IVECT(I) = D2(I)/R(1,2)
C
C     NON-NORMALIZED K-VECTOR
C
      KVECT(1) = IVECT(2)*D1(3) - D1(2)*IVECT(3)
      KVECT(2) = IVECT(3)*D1(1) - D1(3)*IVECT(1)
      KVECT(3) = IVECT(1)*D1(2) - D1(1)*IVECT(2)
C
C     Y3 GOES INTO R(2,3)
C
      R(2,3) = DSQRT(KVECT(1)**2 + KVECT(2)**2 + KVECT(3)**2)
      DO 120 I = 1,3
  120 KVECT(I) = KVECT(I)/R(2,3)
C
C     J-VECTOR = K X I  VECTORS
C
      JVECT(1) = KVECT(2)*IVECT(3) - IVECT(2)*KVECT(3)
      JVECT(2) = KVECT(3)*IVECT(1) - IVECT(3)*KVECT(1)
      JVECT(3) = KVECT(1)*IVECT(2) - IVECT(1)*KVECT(2)
C
C     NORMALIZE J VECTOR TO MAKE SURE
C
      TEMP = DSQRT(JVECT(1)**2 + JVECT(2)**2 + JVECT(3)**2)
      DO 130 I = 1,3
  130 JVECT(I) = JVECT(I)/TEMP
C
C     X3 GOES INTO R(1,3) = D1 DOT IVECT
C
      R(1,3) = D1(1)*IVECT(1) + D1(2)*IVECT(2) + D1(3)*IVECT(3)
C
C     CENTROID POINT GOES INTO R(1,4) AND R(2,4)
C
      R(1,4) = (R(1,2) + R(1,3))/3.0D0
      R(2,4) = R(2,3)/3.0D0
C
C
C     THE COORDINATES AND CENTROID OF THE PLATE IN THE ELEMENT
C     SYSTEM ARE STORED IN THE R-MATRIX WHERE THE COLUMN DENOTES THE
C     POINT AND THE ROW DENOTES THE X OR Y COORDINATE FOR ROW 1 OR
C     ROW 2 RESPECTIVELY.
C
C
C     SET UP THE M-MATRIX FOR MAPPING TRIANGLES, IN DATA STATEMENT.
C
C     ZERO OUT THE KSUM MATRIX FOR 63 AND THE GSUM MATRIX FOR 36
C
      DO 140 I = 1,63
  140 KSUM(I) = 0.0D0
      DO 150 I = 1,36
  150 G(I) = 0.0D0
C
      DO 280 J = 1,3
      KM = 3*J - 3
      SUBSCA = M(KM+1)
      SUBSCB = M(KM+2)
      SUBSCC = M(KM+3)
C
      DO 160 I = 1,2
      V(I)  = R(I,SUBSCB) - R(I,SUBSCA)
  160 VV(I) = R(I,SUBSCC) - R(I,SUBSCA)
      XSUBB = DSQRT(V(1)**2 + V(2)**2)
      U1    = V(1)/XSUBB
      U2    = V(2)/XSUBB
      XSUBC = U1*VV(1) + U2*VV(2)
      YSUBC = U1*VV(2) - U2*VV(1)
C
      SINTH = SINANG*U1 - COSANG*U2
      COSTH = COSANG*U1 + SINANG*U2
      IF (ABS(SINTH) .LT. 1.0E-06) SINTH = 0.0
C
C     AT THIS POINT, XSUBB, XSUBC, YSUBC ARE AT HAND FOR TRIANGLE -J-
C
      C2   = U1**2
      S2   = U2**2
      L1   = U1*U2
      SIGX = C2*STRES(1) + S2*STRES(2) + 2.0D0*L1*STRES(3)
      SIGY = S2*STRES(1) + C2*STRES(2) - 2.0D0*L1*STRES(3)
      SIGXY=-L1*STRES(1)+ L1*STRES(2) + (C2-S2)*STRES(3)
      IPVT = 0
      DO 170 I = 1,2
      NPOINT = KM + I
      IF (M(NPOINT) .EQ. NPIVOT) IPVT = I
  170 CONTINUE
      CALL DTRBSC (1,IPVT)
C
C     NOW WE HAVE 6 MATRICES STORED AT A(1) TO A(54)- HIA,HIB,HIC
C                                                     HAC,HBC,HCC
C
C     NOW ADD CERTAIN OF THESE INTO THE SUMMED MATRICES
C
C
C     SET UP OF T-MATRIX
C
      T(1) = 1.0D0
      T(2) = 0.0D0
      T(3) = 0.0D0
      T(4) = 0.0D0
      T(5) = U1
      T(6) = U2
      T(7) = 0.0D0
      T(8) =-U2
      T(9) = U1
C
      DO 190 I = 1,3
      CALL GMMATD (T(1),3,3,1, A(9*I+19),3,3,0, TEMP9(1))
      CALL GMMATD (TEMP9(1),3,3,0, T(1),3,3,0,  PROD9(1))
C
C     ADD THIS PRODUCT IN NOW.
C     COMPUTE POINTER TO KSUM MATRIX DESIRED.  (ZERO POINTER)
C
      NPOINT = KM + I
      NPOINT = 9*M(NPOINT) + 18
C
      DO 180 K = 1,9
      NSUBC  = NPOINT + K
  180 KSUM(NSUBC) = KSUM(NSUBC) + PROD9(K)
  190 CONTINUE
      IF (IPVT .EQ. 0) GO TO 220
      DO 210 I = 1,2
      NPOINT = KM +I
      NPOINT = 9*M(NPOINT) -9
C
C     TRANSFORM
C
      CALL GMMATD (T(1),3,3,1, A(9*I-8),3,3,0, TEMP9(1))
      CALL GMMATD (TEMP9(1),3,3,0, T(1),3,3,0, PROD9(1))
C
C     INSERT
C
      DO 200 K = 1,9
      NSUBC = K + NPOINT
  200 KSUM(NSUBC) = KSUM(NSUBC) + PROD9(K)
  210 CONTINUE
  220 CONTINUE
C
C     FORM HQ (2X6)
C
      TEMP1 = XSUBB - XSUBC
      TEMP2 = YSUBC**2
      L1 = DSQRT(XSUBC**2 + TEMP2)
      L2 = DSQRT(TEMP1**2 + TEMP2)
      S1 = XSUBC/L1
      S2 = TEMP1/L2
      C1 = YSUBC/L1
      C2 = YSUBC/L2
      X1 = XSUBC/2.0D0
      Y1 = YSUBC/2.0D0
      X2 = (XSUBB+XSUBC)/2.0D0
      Y2 = Y1
      HQ( 1) =-XSUBC*C1
      HQ( 2) = X1*S1 - Y1*C1
      HQ( 3) = 2.0D0*Y1*S1
      HQ( 4) =-3.0D0*X1*X1*C1
      HQ( 5) = Y1*(2.0D0*X1*S1 - Y1*C1)
      HQ( 6) = 3.0D0*Y1*Y1*S1
      HQ( 7) = 2.0D0*X2*C2
      HQ( 8) = X2*S2 + Y2*C2
      HQ( 9) = 2.0D0*Y2*S2
      HQ(10) = 3.0D0*X2*X2*C2
      HQ(11) = Y2*(2.0D0*X2*S2 + Y2*C2)
      HQ(12) = 3.0D0*Y2*Y2*S2
C
C                      I                    -1
C     COMPUTE (H       I  H     )  = (HQ)(H)    STORE IN PROD12
C               PSI,B  I   PSI,C
C                      I
C
C
      CALL GMMATD (HQ(1),2,6,0, HINV(1),6,6,0, PROD12(1))
C
C
C     COMPUTE (H     ) = -(PROD12)(S)
C               PSI,A
C
      CALL GMMATD (PROD12(1),2,6,0, S(1),6,3,0, HABC(1))
C
      HABC(1) = -HABC(1)
      HABC(2) = -HABC(2) + S1
      HABC(3) = -HABC(3) + C1
      HABC(4) = -HABC(4)
      HABC(5) = -HABC(5) + S2
      HABC(6) = -HABC(6) - C2
C
C     SPLIT (H     ) AND (H     )    PARTITION
C             PSI,B        PSI,C
C
      HABC( 7) = PROD12( 1)
      HABC( 8) = PROD12( 2)
      HABC( 9) = PROD12( 3)
      HABC(10) = PROD12( 7)
      HABC(11) = PROD12( 8)
      HABC(12) = PROD12( 9)
      HABC(13) = PROD12( 4)
      HABC(14) = PROD12( 5)
      HABC(15) = PROD12( 6)
      HABC(16) = PROD12(10)
      HABC(17) = PROD12(11)
      HABC(18) = PROD12(12)
C
C     MAP  H , H , AND H  INTO THE G-MATRICES.
C           A   B       C
C
C     TRIANGLE NUMBER = J, THE THREE POINTS ARE SUBSCA, SUBSCB, SUBSCC.
C
      DO 270 I = 1,3
C
C     POINTER TO H  = 6*I-6
C                 I
C
C
C     TRANSFORM H SUB I
C
      CALL GMMATD (HABC(6*I-5),2,3,0, T(1),3,3,0, TEMP9(1))
C
C
      NPOINT = KM + I
      NPOINT = 9*M(NPOINT) - 9
C
C     J = 1    ROW 1 OF H INTO ROW 1 OF G.
C              ROW 2 OF H INTO ROW 2 OF G.
C     J = 2    ROW 1 OF H INTO ROW 2 OF G.
C              ROW 2 OF H INTO ROW 3 OF G.
C     J = 3    ROW 1 OF H INTO ROW 3 OF G.
C              ROW 2 OF H INTO ROW 1 OF G.
C
      IF (J-2) 240,230,260
C
  230 NPOINT = NPOINT + 3
  240 DO 250 K = 1,6
      NPOINT = NPOINT + 1
  250 G(NPOINT) = G(NPOINT) + TEMP9(K)
      GO TO 270
  260 G(NPOINT+7) = G(NPOINT+7) + TEMP9(1)
      G(NPOINT+8) = G(NPOINT+8) + TEMP9(2)
      G(NPOINT+9) = G(NPOINT+9) + TEMP9(3)
      G(NPOINT+1) = G(NPOINT+1) + TEMP9(4)
      G(NPOINT+2) = G(NPOINT+2) + TEMP9(5)
      G(NPOINT+3) = G(NPOINT+3) + TEMP9(6)
C
  270 CONTINUE
C
C
C     END OF LOOP FOR BASIC TRIANGLES
C
  280 CONTINUE
C
C
C     FILL E-MATRIX
C
      DO 290 I = 1,18
  290 E(I) = 0.0D0
      E( 1) = KVECT(1)
      E( 4) = KVECT(2)
      E( 7) = KVECT(3)
      E(11) = IVECT(1)
      E(14) = IVECT(2)
      E(17) = IVECT(3)
      E(12) = JVECT(1)
      E(15) = JVECT(2)
      E(18) = JVECT(3)
C
C              T
C     FORM   T   E      STORE IN TITE-MATRIX (6X3)
C             I
C
      IF (NECPT(4*NPIVOT+ICID) .EQ. 0) GO TO 300
      CALL TRANSD (NECPT(4*NPIVOT+ICID),T(1))
      CALL GMMATD (T(1),3,3,1, E( 1),3,3,0, TITE( 1))
      CALL GMMATD (T(1),3,3,1, E(10),3,3,0, TITE(10))
      GO TO 320
C
  300 DO 310 K = 1,18
  310 TITE(K) = E(K)
C
C     SOLVE NOW FOR
C
C       E                   T     T                       T
C    (K  ) = (K  ) - (TERM ) (K  ) - (K  )(TERM ) + (TERM )(K  )(TERM )
C      IJ      IJ         I    J4      I4      J         I   44      J
C
C                           -1                               I=NPIVOT
C      WHERE  (TERM ) = (G )  (G ) ,I=NPIVOT                 J=1,2,3
C                  I      4     I
C
C                           -1
C             (TERM ) = (G )  (G ) ,J=1,2,3 AS ABOVE
C                  J      4     J
C
C     AND WITH TRANSFORMATIONS
C
C       G        T      E   T
C    (K  ) = (C ) (E)(K  )(E )(C )
C      IJ      I       IJ       J
C
C
C     COMPUTE  (TERM        )  STORE IN PROD9
C                   I=NPIVOT
C
C                  -1
C     FIRST GET (G )
C                 4
C
  320 CONTINUE
C
C     NO NEED TO COMPUTE DETERMINANT SINCE IT IS NOT USED SUBSEQUENTLY.
C
      ISING = -1
      CALL INVERD (3,G(28),3,PROD9,0,DETERM,ISING,TEMP9)
C
      CALL GMMATD (G(28),3,3,0, G(9*NPIVOT-8),3,3,0, PROD9(1))
C
C                       T
C     GET  (TERM        )(K  ) -(K  )  STORE IN TEMP9
C               I=NPIVOT   44     I4
C
      CALL GMMATD (PROD9(1),3,3,1, KSUM(55),3,3,0, TEMP9(1))
      DO 340 K = 1,9
      NPOINT = 9*NPIVOT + 18 + K
  340 TEMP9(K) = TEMP9(K) - KSUM(NPOINT)
C
C
C     THE TWO COMMON PRODUCTS ARE NOW AT HAND IN PROD9 AND TEMP9.
C
      DO 400 J = 1,3
C
C                   T     T
C     (TERM        ) (K  )    STORE IN ARR9
C          I=NPIVOT    J4
C
      CALL GMMATD (PROD9(1),3,3,1, KSUM(9*J+19),3,3,1, ARR9(1))
C
C     SUBTRACT FROM (K  )
C                     IJ
C
      NBEGIN = 9*J - 9
      DO 350 I = 1,9
      NPOINT = NBEGIN + I
  350 KSUM(NPOINT) = KSUM(NPOINT) - ARR9(I)
C
C
C      COMPUTE  (TERM )  STORE IN ARR9
C                   J
C
      CALL GMMATD (G(28),3,3,0, G(9*J-8),3,3,0, ARR9(1))
C
C                            T
C     COMPUTE ((TERM        )(K  ) -(K  )) (TERM ) = (TEMP9)(ARR9)
C                   I=NPOINT   44     I4        J
C
      CALL GMMATD (TEMP9(1),3,3,0, ARR9(1),3,3,0, ARRAY9(1))
C
C     ADD TO K
C             IJ
C
      DO 360 I = 1,9
      NPOINT = NBEGIN + I
  360 KSUM(NPOINT) = KSUM(NPOINT) + ARRAY9(I)
C
C       E
C     K    COMPLETE
C      IJ
C
C     TRANSFORM NOW, AND INSERT.
C
C
C     TRANSFORMATIONS AND INSERTION
C
      IF (NECPT(4*J+ICID) .EQ. 0) GO TO 370
      CALL TRANSD (NECPT(4*J+ICID),T(1))
      CALL GMMATD (T(1),3,3,1, E( 1),3,3,0, TJTE( 1))
      CALL GMMATD (T(1),3,3,1, E(10),3,3,0, TJTE(10))
      GO TO 390
C
  370 DO 380 K = 1,18
  380 TJTE(K) = E(K)
  390 CALL GMMATD (KSUM(NBEGIN+1),3,3,0, TJTE(1),6,3,1, TEMP18(1))
      CALL GMMATD (TITE(1),6,3,0, TEMP18(1),3,6,0, KOUT(1))
      CALL DS1B (KOUT(1),NECPT(J+1))
  400 CONTINUE
      RETURN
C
C     COULD NOT DO IT
C
  410 WRITE  (NOUT,420) SFM
  420 FORMAT (A25,', DEFFICIENT SOURCE CODE IN DTRIA TO HANDLE CTRIA3 ',
     1       'ELEMENT WITH MATERIAL', /5X,
     2       'PROPERTY COORD. SYSTEM. ANGLE MUST BE SPECIFIED')
      NOGO = 1
      RETURN
      END

      SUBROUTINE MPY4T (IZ,Z,DZ)
C
C     INNER LOOP FOR MPYAD, METHOD 4 WITH TRANSPOSE
C
C          T
C         A * B + C = D
C
C     THIS ROUTINE IS CALLED ONLY BY MPYAD WHEN METHOD 2 TRANSPOSE,
C     MPY2T, IS SELECTED, AND DIAG 41 IS NOT TURNED ON BY USER.
C
C     MPY4T IS ABOUT 5 TIMES FASTER THAN MPY2T AS TESTED ON VAX
C
C     THERE IS A PICTORIAL DISCRIPTION ABOUT MPY4T IN MPYAD SUBROUTINE
C
C     THIS MACHINE INDEPENDENT ROUTINE CAN ACTUALLY BE INCORPORATED
C     INTO MPYQ, WHICH IS PRESENTLY A .MDS ROUTINE
C
C     IF MATRIX A, OR B, OR BOTH,  IS COMPLEX, MATRIX D IS COMPLEX.
C     MATRIX D CAN NOT BE COMPLEX, IF BOTH MATRICES A AND B ARE REAL.
C
C
C     WRITTEN BY G.CHAN/UNISYS   1/92
C
      IMPLICIT INTEGER (A-Z)
      REAL             Z(1)    ,SUMR    ,SUMI
      DOUBLE PRECISION DZ(1)   ,DSUMR   ,DSUMI   ,DZERO
      DIMENSION        IZ(1)   ,NAM(2)
      COMMON /MPYADX/  FILEA(7),FILEB(7),FILEC(7),FILED(7)
      COMMON /TYPE  /  PRC(2)  ,NWDS(4) ,RC(4)
      COMMON /MACHIN/  MACH    ,IHALF   ,JHALF
      COMMON /UNPAKX/  TYP     ,II      ,JJ
      COMMON /MPYADZ/  RCB     ,RCD     ,LL      ,LLL     ,JBB   ,
     1                 NBX(3)  ,AROW    ,AROW1   ,AROWN   ,ACORE ,
     2                 APOINT  ,BCOL    ,CROW    ,FIRSTL  ,NA(3) ,
     3                 NWDA
      COMMON /MPYQT4/  RCA     ,PRCA    ,ALL     ,JUMP    ,PRCD
      EQUIVALENCE      (DSUMR  ,SUMR  ) ,(DSUMI  ,SUMI)
      DATA    NAM   /  4HMPY4  ,1HT   / ,DZERO   / 0.0D+0 /
C
C*****
C     ANDF(I,J)   = IAND(I,J)
C     RSHIFT(I,J) = ISHFT(I,-J)
C     WHERE         ISHFT(I,-J) IS RIGHT-SHIFT I BY J BITS, ZERO FILL
C     AND           ISHFT IS SYSTEM ROUTINE
C
C UNIX:
C     REMOVE ABOVE 2 ON-LINE FUNCTIONS IF IAND AND ISHFT SYSTEM
C     FUNCTIONS ARE NOT AVAILABLE. ANDF AND RSHIFT ARE ALREADY ENTRY
C     POINTS IN SUBROUTINE MAPFNS.
C*****
C
C     METHOD 4T TRANSPOSE CASE
C
C     ARRAY Z(JBB) THRU Z(ACORE-1) HOLDS THE CURRENT COLUMN OF MATRIX B
C     ARRAY Z(1) THRU Z(JBB-1) IS A WORKING COLUMN SPACE FOR MATRIX D
C
C     ON EACH ROW OF A, WE WANT TO MULTIPLY
C
C        A(ROW,J)*B(J,COL) + C(ROW,COL) = D(ROW,COL)
C
C     NOTICE B(J,COL) RUNS FROM B(II,COL) THRU B(JJ,COL) WITHOUT
C     SKIPPING,
C     WHILE A(ROW,J) RUNS IN MULTIPLE STRING SEGMENTS ALONG J.
C     ALSO THE BEGINING OF J IN A(ROW,J) AND THE BEGINING OF J IN
C     B(J,COL) MOST LIKELY START DIFFERNTLY
C
C     NOW, ON EACH ROW, WE START FROM FIRST STRING. SKIP THIS STRING
C     IF IT IS NOT WITHIN B(II,) AND B(JJ,) RANGE. (ALSO, WE HAVE
C     SAVED PREVIOUSLY THE LAST TERM OF THE LAST STRING, AND THEREFORE
C     IF THE WHOLE ROW OF A(,J) WITH ITS STRINGS IS NOT WITHIN II,JJ
C     RANGE OF COLUMN B, WE SKIP THE WHOLE ROW-AND-COLUMN COMPUTATION.)
C     IF IT IS WITHIN THE RANGE, WE NEED TO SYNCHRONIZE THE J INDEX FOR
C     BOTH A(ROW,J) AND B(J,COL), THEN MULTIPLY, AND SUM ON AN ELEMENT
C     OF MATRIX D. THEN MOVE ON TO THE NEXT STRING, AND DO THE SAME.
C     REPEAT THIS PROCESS UNTIL J IS EXHAUST EITHER ON A(ROW,J) OR ON
C     B(J,COL).
C     WHEN ALL ROWS OF MATRIX A CURRENTLY IN CORE HAVE PASSED THRU, WE
C     HAVE ONE COLUMN OF MATRIX D DONE, FROM AROW1 THRU AROWN.
C
C     SINCE TRANSPOSE OF MATRIX A IS WHAT WE WANT, THE TERM 'ROW' IS
C     ACTUALLY 'COLUMN' WHEN THE DATA WAS MOVED INTO Z SPACE IN MPYAD
C
C     RCA,RCB    = 1, MATRIX A,B  IS REAL, = 2 MATRIX A,B IS COMPLEX
C     PRCA       = 1, MATRIX A IS IN S.P., = 2 MATRIX A IS IN D.P.
C     PRCD       = 0, MATRIX D IS IN S.P., = 1 MATRIX A IS IN D.P.
C     NWDA       = NUMBER OF WORDS PER ELEMENT OF MATRIX A
C     JBB        = POINTER TO FIRST WORD OF COLUMN B
C     II,JJ      = FIRST TO LAST NON-ZERO TERMS IN CURRENT COLUMN OF B
C     ALL        = 1,2,3,4 ALL MATRICES ARE OF THE SAME TYPE - S.P.,
C                  D.P., C.S.P., OR C.D.P. RESPECTIVELY
C                = 5, MATRICES ARE OF MIXED TYPES
C     JUMP       = BRANCHING INDEX TO MIXED TYPE MATRICES COMPUTATION.
C
C     APOINT     = POINTER TO STRING CONTROL WORD
C                = 0, CURRENT ROW OF A IS EXHAULTED
C     IZ(APOINT) = LEFT HALF OF WORD IS NBR, RIGHT HALF IS NBRSTR
C     NBR        = NO. OF WORDS   IN THIS STRING
C     NBRSTR     = NO. OF STRINGS IN THIS ROW A
C     INIT       = COLUMN POSITION OF 1ST STRING WORD
C     IF (INIT .GT. JJ) = 1ST STRING WORD IS BEYOND LAST WORD IN COLN B
C     IF (INIT+NBR .LT. II) = LAST STRING WORD IS BEFORE 1ST WORD IN
C                  COLUMN OF B
C     JB,JE      = BEGINNING AND ENDING J-INDEX FOR COLUMN A AND ROW B
C     IPOINT     = THE JB WORD POSITION IN ROW A
C     JA         = POINTER TO ROW A ELEMENT
C     KB         = POINTER TO COLUMN B ELEMENT
C     LAST       = POSITION OF LAST NON-ZERO COLUMN TERM IN ROW OF A
C
C
C     WE START FROM FIRST ROW AROW1, AND WILL RUN THRU TO LAST ROW AROWN
C
      AROW = AROW1
      L    = FIRSTL
   10 APOINT = IZ(L)
      IF (APOINT .EQ. 0) GO TO 510
      LAST = RSHIFT(IZ(L-1),IHALF)
      INIT = ANDF(IZ(APOINT),JHALF)
      IF (INIT.GT.JJ .OR. LAST.LT.II) GO TO 510
      NBRSTR = ANDF(IZ(L-1),JHALF)
      GO TO 30
   20 INIT = ANDF(IZ(APOINT),JHALF)
   30 NBR  = RSHIFT(IZ(APOINT),IHALF)
      IF (INIT .GT. JJ) GO TO 510
      IF (INIT+NBR .LT. II) GO TO 500
      JB   = MAX0(INIT,II)
      JE   = MIN0(INIT+NBR-1,JJ)
      IF (JB .GT. JE) GO TO 500
      IPOINT = APOINT + (JB-INIT+1)*PRCA
      JA   = (IPOINT-1)/PRCA + 1
      KB   = (JB-II)*RCB + JBB
      DSUMR= DZERO
      GO TO (40,60,80,100,120,520), ALL
C
   40 DO 50 J = JB,JE
      SUMR = SUMR + Z(JA)*Z(KB)
C
C     DON'T BE SUPRISED TO SEE SOME Z(JA) ARE ZEROS
C     (VAX PACKING ROUTINE ALLOWS UP TO 3 ZEROS BETWEEN STRINGS)
C
      JA   = JA + RCA
   50 KB   = KB + RCB
      Z(AROW) = Z(AROW) + SUMR
      GO TO 500
C
   60 DO 70 J = JB,JE
      DSUMR = DSUMR + DZ(JA)*DZ(KB)
      JA    = JA + RCA
   70 KB    = KB + RCB
      DZ(AROW) = DZ(AROW) + DSUMR
      GO TO 500
C
   80 SUMI = 0.0
      DO 90 J = JB,JE
      SUMR = SUMR + Z(JA)*Z(KB  ) - Z(JA+1)*Z(KB+1)
      SUMI = SUMI + Z(JA)*Z(KB+1) + Z(JA+1)*Z(KB  )
      JA   = JA + RCA
   90 KB   = KB + RCB
      Z(AROW  ) = Z(AROW  ) + SUMR
      Z(AROW+1) = Z(AROW+1) + SUMI
      GO TO 500
C
  100 DSUMI = DZERO
      DO 110 J = JB,JE
      DSUMR = DSUMR + DZ(JA)*DZ(KB  ) - DZ(JA+1)*DZ(KB+1)
      DSUMI = DSUMI + DZ(JA)*DZ(KB+1) + DZ(JA+1)*DZ(KB  )
      JA    = JA + RCA
  110 KB    = KB + RCB
      DZ(AROW  ) = DZ(AROW  ) + DSUMR
      DZ(AROW+1) = DZ(AROW+1) + DSUMI
      GO TO 500
C
C
  120 GO TO (130,150,170,190, 210,230,250,270,
     1       290,310,330,350, 370,390,410,430), JUMP
C
C                      +--------------- MATRIX  B -----------------+
C        MATRIX          REAL        REAL       COMPLEX     COMPLEX
C          A            SINGLE      DOUBLE      SINGLE      DOUBLE
C     ---------------  ----------  ---------  ----------  ----------
C     REAL SINGLE         130         150         170         190
C     REAL DOUBLE         210         230         250         270
C     COMPLEX SINGLE      290         310         330         350
C     COMPLEX DOUBLE      370         390         410         430
C
C
  130 DO 140 J = JB,JE
      DSUMR = DSUMR + DBLE(Z(JA)*Z(KB))
      JA    = JA + RCA
  140 KB    = KB + RCB
      GO TO 460
C
  150 DO 160 J = JB,JE
      DSUMR = DSUMR + DBLE(Z(JA))*DZ(KB)
      JA    = JA + RCA
  160 KB    = KB + RCB
      IF (PRCD) 470,470,460
C
  170 DSUMI = DZERO
      DO 180 J = JB,JE
      DSUMR = DSUMR + DBLE(Z(JA)*Z(KB  ))
      DSUMI = DSUMI + DBLE(Z(JA)*Z(KB+1))
      JA   = JA + RCA
  180 KB   = KB + RCB
      IF (PRCD) 490,490,480
C
  190 DSUMI = DZERO
      DO 200 J = JB,JE
      DSUMR = DSUMR + DBLE(Z(JA))*DZ(KB  )
      DSUMI = DSUMI + DBLE(Z(JA))*DZ(KB+1)
      JA    = JA + RCA
  200 KB    = KB + RCB
      IF (PRCD) 490,490,480
C
  210 DO 220 J = JB,JE
      DSUMR = DSUMR + DZ(JA)*DBLE(Z(KB))
      JA    = JA + RCA
  220 KB    = KB + RCB
      IF (PRCD) 470,470,460
C
  230 DO 240 J = JB,JE
      DSUMR = DSUMR + DZ(JA)*DZ(KB)
      JA    = JA + RCA
  240 KB    = KB + RCB
      GO TO 470
C
  250 DSUMI = DZERO
      DO 260 J = JB,JE
      DSUMR = DSUMR + DZ(JA)*DBLE(DZ(KB  ))
      DSUMI = DSUMI + DZ(JA)*DBLE(DZ(KB+1))
      JA    = JA + RCA
  260 KB    = KB + RCB
      IF (PRCD) 490,490,480
C
  270 DSUMI = DZERO
      DO 280 J = JB,JE
      DSUMR = DSUMR + DZ(JA)*DZ(KB  )
      DSUMI = DSUMI + DZ(JA)*DZ(KB+1)
      JA    = JA + RCA
  280 KB    = KB + RCB
      IF (PRCD) 490,490,480
C
  290 DSUMI = DZERO
      DO 300 J = JB,JE
      DSUMR = DSUMR + DBLE(Z(JA  )*Z(KB))
      DSUMI = DSUMI + DBLE(Z(JA+1)*Z(KB))
      JA   = JA + RCA
  300 KB   = KB + RCB
      IF (PRCD) 490,490,480
C
  310 DSUMI = DZERO
      DO 320 J = JB,JE
      DSUMR = DSUMR + DBLE(Z(JA  ))*DZ(KB)
      DSUMI = DSUMI + DBLE(Z(JA+1))*DZ(KB)
      JA    = JA + RCA
  320 KB    = KB + RCB
      IF (PRCD) 490,490,480
C
  330 DSUMI = DZERO
      DO 340 J = JB,JE
      DSUMR = DSUMR + DBLE(Z(JA)*Z(KB  )) - DBLE(Z(JA+1)*Z(KB+1))
      DSUMI = DSUMI + DBLE(Z(JA)*Z(KB+1)) + DBLE(Z(JA+1)*Z(KB  ))
      JA    = JA + RCA
  340 KB    = KB + RCB
      GO TO 480
C
  350 DSUMI = DZERO
      DO 360 J = JB,JE
      DSUMR = DSUMR + DBLE(Z(JA  ))*DZ(KB)
      DSUMI = DSUMI + DBLE(Z(JA+1))*DZ(KB)
      JA    = JA + RCA
  360 KB    = KB + RCB
      IF (PRCD) 490,490,480
C
  370 DSUMI = DZERO
      DO 380 J = JB,JE
      DSUMR = DSUMR + DZ(JA  )*DBLE(Z(KB))
      DSUMI = DSUMI + DZ(JA+1)*DBLE(Z(KB))
      JA    = JA + RCA
  380 KB    = KB + RCB
      IF (PRCD) 490,490,480
C
  390 DSUMI = DZERO
      DO 400 J = JB,JE
      DSUMR = DSUMR + DZ(JA  )*DZ(KB)
      DSUMI = DSUMI + DZ(JA+1)*DZ(KB)
      JA    = JA + RCA
  400 KB    = KB + RCB
      IF (PRCD) 490,490,480
C
  410 DSUMI = DZERO
      DO 420 J = JB,JE
      DSUMR = DSUMR + DZ(JA)*DBLE(Z(KB  )) - DZ(JA+1)*DBLE(Z(KB+1))
      DSUMI = DSUMI + DZ(JA)*DBLE(Z(KB+1)) + DZ(JA+1)*DBLE(Z(KB  ))
      JA    = JA + RCA
  420 KB    = KB + RCB
      IF (PRCD) 490,490,480
C
  430 DSUMI = DZERO
      DO 440 J = JB,JE
      DSUMR = DSUMR + DZ(JA)*DZ(KB  ) - DZ(JA+1)*DZ(KB+1)
      DSUMI = DSUMI + DZ(JA)*DZ(KB+1) + DZ(JA+1)*DZ(KB  )
      JA    = JA + RCA
  440 KB    = KB + RCB
      GO TO 490
C
  460 DZ(AROW) = DZ(AROW) + DSUMR
      GO TO 500
  470 Z(AROW)  = Z(AROW)  + SNGL(DSUMR)
      GO TO 500
  480 DZ(AROW  ) = DZ(AROW  ) + DSUMR
      DZ(AROW+1) = DZ(AROW+1) + DSUMI
      GO TO 500
  490 Z(AROW  ) = Z(AROW  ) + SNGL(DSUMR)
      Z(AROW+1) = Z(AROW+1) + SNGL(DSUMI)
C
C
C     END OF STRING DATA. IF THIS IS NOT THE LAST STRING OF CURRENT
C     ROW OF A, RETURN FOR NEXT STRING
C
  500 NBRSTR = NBRSTR - 1
      APOINT = APOINT + NBR*NWDA + PRCA
      IF (NBRSTR .GT. 0) GO TO 20
C
C     END OF A ROW OF MATRIX A.
C     RETURN FOR NEXT ROW IF THIS IS NOT THE LAST ROW IN OPEN CORE.
C     IF IT IS THE LAST ROW, RETURN TO CALLER FOR PACKING OUT THE
C     CURRENT COLUMN OF MATRIX D (IN C ARRAY)
C
  510 L    = L - 2
      AROW = AROW + 1
      IF (AROW .LE. AROWN) GO TO 10
      RETURN
C
  520 CALL MESAGE (-37,0,NAM)
      RETURN
      END

      SUBROUTINE SMCSPL ( MCOL, ZI )
C      
C SMCSPL RETRIEVES COLUMN "MCOL" FROM THE SPILL FILE.
C IF THIS COLUMN IS THE PIVOT COLUMN AND NO SPACE IS AVAILABLE, THEN
C IN-MEMORY DATA WILL BE WRITTEN TO THE SPILL FILE TO MAKE SPACE
C AVAILABLE FOR THE COLUMN DATA.  IF THE COLUMN IS NOT THE PIVOT 
C COLUMN, THEN THE DATA IS READ INTO THE SPILL ARRAY IN OPEN CORE.
C WHEN A NEW PIVOT COLUMN IS DETERMINED, AN ANALYSIS IS DONE TO
C FREE UP MEMORY OF COLUMN DATA NO LONGER NEEDED.
C
      INTEGER          ZI(10), ITEMP(4)
      INCLUDE  'SMCOMX.COM'
      CHARACTER    UFM*23, UWM*25, UIM*29, SFM*25
      COMMON / XMSSG / UFM, UWM, UIM, SFM
      MDIR = (MCOL-1)*4 + 1
C
C POSITION SPILL FILE TO CORRECT RECORD FOR THIS COLUMN AND READ DATA
C
      CALL FILPOS ( ISCR1, ZI( MDIR+3 ) )
      CALL READ ( *7001, *7002, ISCR1, ZI( ISPILL ), 4, 0, 4 )  
      MM2    = ZI( ISPILL+1 )
      MTERMS = ZI( ISPILL+3 )
      MWORDS = MM2 + MTERMS * IVWRDS 
C      PRINT *,' SMCSPL,MM2,MTERMS,MWORDS=',MM2,MTERMS,MWORDS
      CALL READ ( *7001, *7002, ISCR1, ZI( ISPILL+4 ),MWORDS,1,MWORDS ) 
C
C CHECK IF WE HAVE ALREADY SCANNED FOR UNNEEDED COLUMNS FOR THIS PIVOT
C      
C      PRINT *,' SMCSPL,MEMLCK,KCOL=',MEMLCK,KCOL
      IF ( MEMLCK .EQ. KCOL ) GO TO 300
      MEMLCK = KCOL
C
C SCAN FOR COLUMNS NO LONGER NEEDED AND ADD THEM TO THE FREE CHAIN
C      
      IFIRST = 0
      DO 200 I = MEMCOL1, KCOL
      IDIR = (I-1)*4 + 1
C
C CHECK TO SEE IF THIS COLUMN NEEDED BY ANY SUBSEQUENT COLUMNS TO FOLLOW
C
      IF ( ZI( IDIR + 2 ) .GE. KCOL ) GO TO 199
C      
C DATA NO LONGER NEEDED, IS DATA IN MEMORY IF SO FREE THE SPACE TO THE
C FREE CHAIN
C
      IF ( ZI( IDIR     ) .EQ. 0    ) GO TO 200
C       
C DATA IS IN MEMORY, RETURN SPACE TO FREE CHAIN
C FIRST, CHECK IF A FREE CHAIN EXISTS
C
      IF ( MEMFRE .NE. 0 ) GO TO 100
C
C FREE CHAIN DOES NOT EXISTS, MAKE THIS SPACE THE FREE CHAIN      
C
      IIDX   = ZI( IDIR )
      MEMFRE = IIDX
      MEMLAS = IIDX
      ZI( IIDX )   = 0
      ZI( IIDX+1 ) = 0
      ZI( IDIR   ) = 0
      GO TO 200
C
C FREE CHAIN EXISTS, ADD THIS SPACE TO IT
C
100   LIDX   = MEMLAS
      IIDX   = ZI( IDIR )
      MEMLAS = IIDX
      ZI( LIDX+1 ) = MEMLAS
      ZI( IIDX   ) = LIDX
      ZI( IIDX+1 ) = 0
      ZI( IDIR   ) = 0
      GO TO 200
199   IF ( IFIRST .EQ. 0 ) IFIRST = I
200   CONTINUE
      MEMCOL1 = IFIRST
C
C CHECK IF THE FREE CHAIN IS EMPTY
C
300   IF ( MEMFRE .EQ. 0 ) GO TO 1000 
C
C LOOP THROUGH FREE CHAIN TO FIND BLOCK LARGE ENOUGH FOR DATA
C      
      IIDX = MEMFRE
400   CONTINUE
      IF ( ZI( IIDX+2 ) .GE. (MWORDS+4) ) GO TO 500
      IIDX = ZI( IIDX+1 )
      IF ( IIDX .NE. 0 ) GO TO 400
C
C FREE CHAIN EXHAUSTED WITHOUT LARGE ENOUGH BLOCK, MUST CREATE SPACE
C      
C      PRINT *,' SMCSPL GOING TO 1000 FROM 400'
      GO TO 1000
C
C SPACE FOUND, USE THIS FOR THE COLUMN DATA READ FROM THE SPILL FILE.
C RECONNECT FREE CHAIN WITHOUT THIS SPACE
C
500   ZI ( MDIR ) = IIDX
      IPREV  = ZI( IIDX   )
      INEXT  = ZI( IIDX+1 )
C      PRINT *,' SMCSPL,AFTER 500,IPREV,INEXT=',IPREV,INEXT
      IF ( IPREV .NE. 0 ) GO TO 510
      IF ( INEXT .EQ. 0 ) GO TO 505 
      ZI( INEXT ) = 0
      MEMFRE      = INEXT
      GO TO 530
505   MEMFRE = 0
      GO TO 530
510   IF ( INEXT .EQ. 0 ) GO TO 520
C      PRINT *,' SMCSPL,AFTER 510,INEXT,IPREV=',INEXT,IPREV
      ZI( IPREV+1 ) = INEXT
      ZI( INEXT   ) = IPREV
      GO TO 530
520   ZI( IPREV+1 ) = 0
      MEMLAS        = IPREV
C 
C MOVE DATA TO IN MEMORY LOCATION
C
530   CONTINUE
      ZI( MDIR    ) = IIDX
      ZI( MDIR+3  ) = 0   
      ZI( IIDX    ) = MCOL
      ZI( IIDX+1  ) = MM2
      ZI( IIDX+3  ) = MTERMS
      DO 540 J = 1, MWORDS
      ZI( IIDX+J+3 ) = ZI (ISPILL+J+3 )
540   CONTINUE
      MEMCOLN = MCOL
C      PRINT *,' SMCSPL,A540,IIDX,ZI(1-5=',IIDX,(ZI(IIDX+KB),KB=0,4)
      GO TO 7777
C
C NO SPACE FOUND IN MEMORY FOR THIS DATA.
C CHECK IF COLUMN BEING REQUESTED IS THE PIVOT COLUMN
C
 1000 CONTINUE 
C      PRINT *,' SMCSPL,MCOL,KCOL=',MCOL,KCOL
      IF ( MCOL .NE. KCOL ) GO TO 2000 
C
C COLUMN REQUESTED IS THE PIVOT COLUMN, FIRST DETERMINE IF THERE
C ARE CONTIGUOUS BLOCKS IN THE FREE CHAIN THAT CAN BE MERGED TOGETHER
C
      IF ( MEMFRE .EQ. 0 ) GO TO 1400
      INDEX1 = MEMFRE
      INDEXT = MEMFRE
1100  CONTINUE
      INDEX2 = ZI( INDEXT + 1 )
      IF ( INDEX2 .EQ. 0 ) GO TO 1300
C
C COMPUTE THE LAST ADDRESS (PLUS 1) OF THIS FREE BLOCK AND COMPARE
C IT WITH THE BEGINNING OF BLOCK REFERENCED BY VARIABLE "INDEX1"
C      
      IEND   = INDEX2 + ZI( INDEX2 + 2 )
      IF ( IEND .EQ. INDEX1 ) GO TO 1200
C
C BLOCK IS NOT CONTIGUOUS, GO AND TEST NEXT BLOCK IN CHAIN
C
      INDEXT = INDEX2
      GO TO 1100
C 
C BLOCK IS CONTIGUOUS, MERGE THIS BLOCK AND THEN GO BACK TO
C TEST THE FREE CHAIN FOR SPACE FOR THE CURRENT PIVOT COLUMN.
C     EACH FREE CHAIN BLOCK HAS THE FOLLOWING FORMAT FOR THE FIRST 3
C     WORDS: 
C             (1) = Pointer to previous block in chain
C             (2) = Pointer to next block in chain
C             (3) = Number of words in this block
C         (Note: Blocks are allocated from high memory to low:)
C              Memory Address N
C                     Block k
C                     Block k-1
C                        .
C                     Block 1
C              Memory Address N+M
C
1200  CONTINUE
C      PRINT *,' SMCSPL,A1200,INDEX1,INDEX2=',INDEX1,INDEX2
      ZI( INDEX2+2 ) = ZI( INDEX1+2 ) + ZI( INDEX2+2 )
C
C RESET NEXT AND PREVIOUS POINTERS OF CHAIN BLOCKS
C
      INDEXP        = ZI( INDEX1 )
      ZI( INDEX2 )  = INDEXP
      IF ( INDEXP .EQ. 0 ) MEMFRE = INDEX2
      IF ( INDEXP .NE. 0 ) ZI( INDEXP+1 ) = INDEX2
C      PRINT *,' SMCSPL,A1200,MWORDS,ZI(INDEX1+2=',MWORDS,ZI(INDEX1+2)
      IF ( ZI( INDEX2+2 ) .LT. (MWORDS+4) ) GO TO 1000
      IIDX = INDEX2
      GO TO 500
C
C  NO BLOCKS CONTIGUOUS WITH THIS BLOCK, GET NEXT BLOCK IN CHAIN
C  AND CHECK FOR CONTIGUOUS BLOCKS WITH IT.
C
1300  CONTINUE
      INDEX1 = ZI( INDEX1 + 1 )
C
C  FIRST CHECK THAT THERE IS ANOTHER BLOCK IN THE FREE CHAIN
C
      IF ( INDEX1 .EQ. 0 ) GO TO 1400
      INDEXT = MEMFRE
      GO TO 1100
1400  CONTINUE
C
C COLUMN REQUESTED IS THE PIVOT COLUMN, MUST FIND MEMORY TO READ
C THIS DATA INTO.  SEARCH FOR LAST COLUMN IN MEMORY WITH SUFFICIENT
C SPACE AND WRITE THAT COLUMN TO SPILL AND READ THE PIVOT COLUMN DATA
C INTO THE MEMORY THAT BECAME AVAILABLE.
C      
      IDIR   = (MEMCOLN-1) * 4 + 1
      KCOLP1 = KCOL + 1
      DO 1500 I = MEMCOLN, 1, -1
      IF ( I .EQ. KCOL ) GO TO 1500
      IDIR = (I-1)*4 + 1
C
C CHECK TO SEE IF DATA ALREADY ON SPILL FILE
C      
      IF ( ZI( IDIR ) .EQ. 0 ) GO TO 1500
C
C DATA IS IN MEMORY, CHECK TO SEE IF ENOUGH SPACE
C      
      IMIDX = ZI( IDIR )
      IF ( ZI( IMIDX+2 ) .LT. (MWORDS+4) ) GO TO 1500
C
C SUFFICIENT SPACE, WRITE THIS COLUMN DATA TO THE SPILL FILE
C TO MAKE ROOM FOR THE PIVOTAL COLUMN DATA TO BE KEPT IN MEMORY.
C SKIP TO END OF FILE, BACKSPACE OVER EOF, CLOSE AND REOPEN FILE 
C FOR WRITE WITH APPEND.
C      
      CALL DSSEND( ISCR1 )
      CALL SKPREC( ISCR1, -1 )
      CALL CLOSE ( ISCR1,  2 )
      CALL GOPEN ( ISCR1, ZI( IBUF2 ), 3 )
      IM2    = ZI( IMIDX+1 )
      ITERMS = ZI( IMIDX+3 ) 
      LENGTH = IM2 + ITERMS*IVWRDS
      ITEMP( 1 ) = I
      ITEMP( 2 ) = IM2
      ITEMP( 3 ) = 0
      ITEMP( 4 ) = ITERMS
      CALL WRITE ( ISCR1, ITEMP , 4, 0 )
      CALL SAVPOS( ISCR1, KPOS )  
      CALL WRITE ( ISCR1, ZI( IMIDX+4 ), LENGTH, 1 )
      CALL CLOSE ( ISCR1, 3 )
      CALL GOPEN ( ISCR1, ZI( IBUF2 ), 0 )
C 
C SET DIRECTORY AND MOVE DATA INTO MEMORY LOCATION
C
C      PRINT *,' SMCSPL B1450,IMIDX,ISPILL=',IMIDX,ISPILL
      ZI( IDIR    ) = 0
      ZI( IDIR+3  ) = KPOS
      ZI( MDIR    ) = IMIDX
      ZI( MDIR+3  ) = 0
      ZI( IMIDX   ) = MCOL
      ZI( IMIDX+1 ) = MM2
      ZI( IMIDX+3 ) = MTERMS
C      PRINT *,' SMCSPL,B1450,MCOL,MM2,MTERMS=',MCOL,MM2,MTERMS
      DO 1450 J = 1, MWORDS
      ZI( IMIDX+J+3 ) = ZI (ISPILL+J+3 )
1450  CONTINUE
      MEMCOLN = MCOL
C      PRINT *,' SMCSPL,A1450,ZI(1-5=',(ZI(IMIDX+KB),KB=0,4)
      GO TO 7777    
1500  CONTINUE
C
C NONE OF THE EXISTING IN-MEMORY ALLOCATIONS ARE LARGE ENOUGH.
C THEREFORE, MUST MERGE TWO TOGETHER TO TRY AND MAKE ENOUGH SPACE.
C      
      DO 1900 I = MEMCOLN, 1, -1
      IF ( I .EQ. KCOL ) GO TO 1900
      IDIR = ( I-1)*4 + 1
      IF ( ZI( IDIR ) .EQ. 0 ) GO TO 1900
      IMIDX1  = ZI( IDIR )
      ISPACE1 = ZI( IMIDX1+2 )
C      PRINT *,' SMCSPL,B1800,IMIDX1,ISPACE1=',IMIDX1,ISPACE1
      IEND1   = IMIDX1 + ISPACE1
      DO 1800 J = MEMCOLN, 1, -1
      IF ( J .EQ. KCOL ) GO TO 1800
      IF ( J .EQ. I    ) GO TO 1800
      JDIR = ( J-1 ) * 4 + 1
      IF ( ZI( JDIR ) .EQ. 0 ) GO TO 1800
      JMIDX1  = ZI( JDIR )
      ISPACE2 = ZI( JMIDX1+2 )
C      PRINT *,' SMCSPL,I1800,JMIDX1,ISPACE2=',JMIDX1,ISPACE2
      IEND2   = JMIDX1 + ISPACE2
      IF ( IABS( IMIDX1-IEND2 ) .LE. 4 ) GO TO 1700
      IF ( IABS( JMIDX1-IEND1 ) .LE. 4 ) GO TO 1700
      GO TO 1800
C
C COLUMNS J AND I HAVE CONTIGUOUS MEMORY, CHECK IF COMBINED SPACE IS
C LARGE ENOUGH FOR THIS COLUMN
C
1700  ITOTAL = ISPACE1 + ISPACE2
C      PRINT *,' SMCSPL,A1700,ISPACE1,ISPACE2,ITOTAL,MWORDS='
C     &,         ISPACE1,ISPACE2,ITOTAL,MWORDS
      IF ( ITOTAL .LT. (MWORDS+4) ) GO TO 1900
C
C SPACE IS LARGE ENOUGH, SO WRITE COLUMNS I AND J TO SPILL AND MERGE
C THE TWO AREAS TOGETHER.
C SKIP TO END OF FILE, BACKSPACE OVER EOF, CLOSE AND REOPEN FILE 
C FOR WRITE WITH APPEND.
C      
      CALL DSSEND ( ISCR1 )
      CALL SKPREC ( ISCR1, -1 )
      CALL CLOSE  ( ISCR1,  2 )
      CALL GOPEN  ( ISCR1, ZI( IBUF2 ), 3 )
C
C WRITE COLUMN I TO SPILL FILE
C
      IM2        = ZI( IMIDX1+1 )
      ITERMS     = ZI( IMIDX1+3 )
      ILEN       = IM2 + ITERMS*IVWRDS
      ITEMP( 1 ) = I
      ITEMP( 2 ) = IM2
      ITEMP( 3 ) = 0
      ITEMP( 4 ) = ITERMS
C      PRINT *,' SMCSPL WRITING COLUMN I=',I
      CALL WRITE ( ISCR1, ITEMP, 4, 0 )
      CALL SAVPOS( ISCR1, KPOS ) 
      CALL WRITE ( ISCR1, ZI( IMIDX1+4 ), ILEN, 1 )
C      
C RESET DIRECTORY FOR COLUMN I
C
      ZI( IDIR   ) = 0
      ZI( IDIR+3 ) = KPOS
C
C WRITE COLUMN J TO THE SPILL FILE
C
      JM2    = ZI( JMIDX1+1 )
      JTERMS = ZI( JMIDX1+3 )
      JLEN   = 4 + JM2 + JTERMS*IVWRDS
      ITEMP( 1 ) = J
      ITEMP( 2 ) = JM2
      ITEMP( 3 ) = 0
      ITEMP( 4 ) = JTERMS
C      PRINT *,' SMCSPL,WRITING COLUMN J=',J
      CALL WRITE ( ISCR1, ITEMP, 4, 0 )
      CALL SAVPOS( ISCR1, KPOS )
      CALL WRITE ( ISCR1, ZI( JMIDX1+4 ), JLEN, 1 )
C 
C RESET DIRECTORY FOR COLUMN J
C
      ZI( JDIR   ) = 0
      ZI( JDIR+3 ) = KPOS
      CALL CLOSE ( ISCR1, 3 )
      CALL GOPEN ( ISCR1, ZI( IBUF2 ), 0 )
      INDEX = JMIDX1
      IF ( IMIDX1 .LT. JMIDX1 ) INDEX = IMIDX1
C
C MOVE DATA INTO MEMORY LOCATION
C
      PRIN T*,' B1750,INDEX,ISPILL=',INDEX,ISPILL
      ZI( INDEX   ) = MCOL   
      ZI( INDEX+1 ) = MM2
      ZI( INDEX+2 ) = ITOTAL
      ZI( INDEX+3 ) = MTERMS
      ZI( MDIR    ) = INDEX
      ZI( MDIR+3  ) = 0
      DO 1750 K = 1, MWORDS
      ZI( INDEX+K+3 ) = ZI( ISPILL+K+3 )
1750  CONTINUE
      MEMCOLN = MCOL
      GO TO 7777
1800  CONTINUE
1900  CONTINUE
      GO TO 7003
C
C NO SPACE FOUND AND COLUMN IS NOT THE PIVOTAL COLUMN, USE DATA
C FROM SPILL AREA
C
2000  CONTINUE
7777  CONTINUE
C      print *,' smcspl is returning, memfre=',memfre
C      ikb = memfre
C      do 9777 kk = 1, 100
C      if ( ikb .eq. 0 ) go to 9778
C      print *,' free block i,1-3=',kk,(zi(ikb+kb),kb=0,2)
C      ikb = zi( ikb+1 )
C9777  continue
C9778  continue
      RETURN
7001  WRITE ( NOUT, 9001 ) UFM, KCOL
9001  FORMAT(1X, A23,/,' UNEXPECTED END OF FILE FOR COLUMN ',I4
     &,' IN SUBROUTINE SMCSPL')
      IERROR = 3
      GO TO 7070
7002  WRITE ( NOUT, 9002 ) UFM, KCOL
9002  FORMAT(1X, A23,/,' UNEXPECTED END OF RECORD FOR COLUMN ',I4
     &,' IN SUBROUTINE SMCSPL')
      IERROR = 3
      GO TO 7070
7003  WRITE ( NOUT, 9003 ) UFM, KCOL
9003  FORMAT(1X,A23,/,' INSUFFICIENT CORE IN SUBROUTINE SMCSPL FOR'
     &,' SYMMETRIC DECOMPOSITION, COLUMN=',I6)
      IERROR = 1
      GO TO 7070
7070  CALL SMCHLP 
      CALL MESAGE( -61, 0, 0 )
      RETURN
      END

      SUBROUTINE XCLEAN
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        LSHIFT,RSHIFT,ANDF,ORF
      DIMENSION       NCLEAN( 2),DDBN ( 1),DFNU ( 1),FCUM ( 1),
     2                FCUS  ( 1),FDBN ( 1),FEQU ( 1),FILE ( 1),
     2                FKND  ( 1),FMAT ( 1),FNTU ( 1),FPUN ( 1),
     3                FON   ( 1),FORD ( 1),MINP ( 1),MLSN ( 1),
     4                MOUT  ( 1),MSCR ( 1),SAL  ( 1),SDBN ( 1),
     5                SNTU  ( 1),SORD ( 1)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG / UFM,UWM,UIM,SFM
      COMMON /SYSTEM/ IBUFSZ,OUTTAP
      COMMON /XFIAT / FIAT(7)
      COMMON /XFIST / FIST
      COMMON /XDPL  / DPD(6)
      COMMON /XSFA1 / MD(401),SOS(1501),COMM(20),XF1AT(5)
      EQUIVALENCE             (DPD  (1),DNAF    ),(DPD  (2),DMXLG   ),
     1    (DPD  (3),DCULG   ),(DPD  (4),DDBN (1)),(DPD  (6),DFNU(1) ),
     2    (FIAT (1),FUNLG   ),(FIAT (2),FMXLG   ),(FIAT (3),FCULG   ),
     3    (FIAT (4),FEQU (1)),(FIAT (4),FILE (1)),(FIAT (4),FORD (1)),
     4    (FIAT (5),FDBN (1)),(FIAT (7),FMAT (1)),(MD   (1),MLGN    ),
     5    (MD   (2),MLSN (1)),(MD   (3),MINP (1)),(MD   (4),MOUT (1)),
     6    (MD   (5),MSCR (1)),(SOS  (1),SLGN    ),(SOS  (2),SDBN (1)),
     7    (SOS  (4),SAL  (1)),(SOS  (4),SNTU (1)),(SOS  (4),SORD (1)),
     8    (XF1AT(1),FNTU (1)),(XF1AT(1),FON  (1)),(XF1AT(2),FPUN (1)),
     9    (XF1AT(3),FCUM (1)),(XF1AT(4),FCUS (1)),(XF1AT(5),FKND (1))
      EQUIVALENCE             (COMM (1),ALMSK   ),(COMM (2),APNDMK  ),
     1    (COMM (3),CURSNO  ),(COMM (4),ENTN1   ),(COMM (5),ENTN2   ),
     2    (COMM (6),ENTN3   ),(COMM (7),ENTN4   ),(COMM (8),FLAG    ),
     3    (COMM (9),FNX     ),(COMM(10),LMSK    ),(COMM(11),LXMSK   ),
     4    (COMM(12),MACSFT  ),(COMM(13),RMSK    ),(COMM(14),RXMSK   ),
     5    (COMM(15),S       ),(COMM(16),SCORNT  ),(COMM(17),TAPMSK  ),
     6    (COMM(18),THCRMK  ),(COMM(19),ZAP     )
      DATA  NCLEAN / 4HXCLE,4HAN  /
C
C     ENTRY SIZE NUMBERS,  1=FIAT, 2=SOS, 3=MD
C
      IFAIL  = 0
      ENTN1X = ENTN1 - 1
      ENTN1Y = ENTN1*2
      LMT1   = FUNLG*ENTN1
      LMT2   = LMT1 + 1
      LMT3   = FCULG*ENTN1
      FLAG   = 0
      ICURSN = LSHIFT(CURSNO,16)
C
C     MERGE FIAT BY REPLACING ANY UNIQUE FILES WITH MATCHED CURRENT
C     FILES ONLY CURRENT TAIL  AND  EXCEPT EQU FILES
C
      IF (FUNLG .EQ. FCULG) GO TO 170
      ASSIGN 170 TO ISW
  100 DO 160 I = LMT2,LMT3,ENTN1
      TRIAL = ANDF(RMSK,FILE(I))
      IF (TRIAL .EQ. ZAP) GO TO 160
C
C     ERASE SCRATCH AND LTU EXPIRED FILES FROM CURRENT TAIL
C
      K = ANDF(LMSK,FORD(I))
      IF (K.EQ.LMSK .OR. (ICURSN.GT.K .AND. K.NE.0 .AND. FEQU(I).GT.0))
     1    GO TO 152
      DO 130 J = 1,LMT1,ENTN1
      IF (TRIAL .NE. ANDF(RMSK,FILE(J))) GO TO 130
      IF (FEQU(J)) 160,140,140
  130 CONTINUE
      GO TO 160
  140 K = ANDF(LMSK,FORD(J))
      IF (K.NE.LMSK .AND. ICURSN.LE.K) GO TO 160
      LMT4 = I + ENTN1X
      DO 150 K = I,LMT4
      FILE(J) = FILE(K)
      FILE(K) = 0
      FNTU(J) = FNTU(K)
  150 J = J + 1
      J = J - ENTN1
      GO TO 156
  152 LMT4 = I + ENTN1X
      DO 154 K = I,LMT4
  154 FILE(K) = 0
      J = I
  156 CALL XPOLCK (FDBN(J),FDBN(J+1),IK,L)
      IF (FEQU(J) .LT. 0) FLAG = -1
      IF (IK .EQ. 0) GO TO 160
      DDBN(L  ) = 0
      DDBN(L+1) = 0
  160 CONTINUE
      GO TO ISW, (170,310)
C
C     REGENERATE ALL NTU VALUES (AND LTU IF EMPTY) IN FIAT BY SCANNING
C     SOS DELETE FIAT ENTRY IF NOT FOUND, OR A SCRATCH
C
  170 LMT4 = MLGN*ENTN3
      LMT2 = LMT1 + 1
C
C     FIAT LOOP
C
      DO 250 I = 1,LMT3,ENTN1
      IF (ANDF(LMSK,FORD(I)) .EQ. LMSK) GO TO 220
      TRIAL = FDBN(I)
      IF (TRIAL .EQ. 0) GO TO 250
C
C     SOS LOOP - BY MODULE
C
      LMT6 = 0
      DO 200 J = 1,LMT4,ENTN3
      LMT5 = LMT6 + 1
      LMTI = LMT6 + MINP(J)*ENTN2
      LMT6 = LMT6 +(MINP(J) + MOUT(J) + MSCR(J))*ENTN2
C
C     SOS LOOP - BY FILE WITHIN MODULE
C
      DO 200 K = LMT5,LMT6,ENTN2
      IF (TRIAL.NE.SDBN(K) .OR. FDBN(I+1).NE.SDBN(K+1)) GO TO 200
      IF (ANDF(RMSK,FILE(I)) .EQ. ZAP) GO TO 190
      IF (K.GT.LMTI .OR. FMAT(I).NE.0 .OR. FMAT(I+1).NE.0 .OR.
     1    FMAT(I+2).NE.0) GO TO 190
      IF (ENTN1.EQ.11 .AND. (FMAT(I+5).NE.0 .OR. FMAT(I+6).NE.0 .OR.
     1    FMAT(I+7).NE.0)) GO TO 190
C
C     IF FIAT ENTRY IS INPUT WITH ZERO TRAILERS - PURGE IT
C
      IF (I .LE. LMT1) GO TO 185
      LMTI = 0
      FILE(I) = ORF(FILE(I),ZAP)
      GO TO 210
C
C     PURGE FILE --PUT ENTRY AT END OF FIAT
C
  185 IF (FCULG .EQ. FMXLG) GO TO 186
      NFCULG = FCULG*ENTN1 + 1
      IFAIL  = 0
      FCULG  = FCULG + 1
      FILE(NFCULG  ) = ORF(FILE(I),ZAP)
      FDBN(NFCULG  ) = FDBN(I  )
      FDBN(NFCULG+1) = FDBN(I+1)
      GO TO 210
C
C     TRY TO PACK FIAT FOR MORE SPACE
C
  186 IF (IFAIL .EQ. 1) GO TO 900
      IFAIL = 1
      ASSIGN 170 TO IHOP
      GO TO 310
  190 FNTU(I) = ANDF(RMSK,MLSN(J))
      IF (ANDF(LMSK,FORD(I)) .EQ. 0)
     1    FORD(I) = ORF(FORD(I),ANDF(LMSK,SORD(K)))
      GO TO 250
  200 CONTINUE
C
C     DELETE FIAT ENTRY (UNLESS LTU YET TO COME)
C
C     HOLD FILES UNTIL LARGEST LTU OF EQUIVALENCED GROUP EXPIRES
C
      IF (FEQU(I).GE.0 .AND. ICURSN.GT.ANDF(LMSK,FORD(I))) GO TO 210
      FNTU(I) = RSHIFT(ANDF(LMSK,FORD(I)),16)
      GO TO 250
  210 CALL XPOLCK (FDBN(I),FDBN(I+1),IK,L)
      IF (IK .EQ. 0) GO TO 215
      DDBN(L  ) = 0
      DDBN(L+1) = 0
  215 IF (LMTI .EQ. 0) GO TO 250
  220 HOLD = ANDF(RXMSK,FILE(I))
      IF (FEQU(I) .LT. 0) FLAG = -1
      LMT6 = I + ENTN1X
      DO 230 K = I,LMT6
  230 FILE(K) = 0
      IF (I .GT. LMT1) GO TO 250
      FILE(I) = HOLD
      FLAG = -1
  250 CONTINUE
      LMT3 = FCULG*ENTN1
C
C     CHECK EQU FILES FOR BREAKING OF EQU
C
      IF (FUNLG .EQ. FCULG) RETURN
      DO 300 I = 1,LMT3,ENTN1
      IF (FEQU(I).GE.0 .OR. ANDF(LMSK,FORD(I)).GE.ICURSN) GO TO 300
      DO 290 J = 1,LMT3,ENTN1
      IF (FEQU(J) .GE. 0) GO TO 290
      IF (I .EQ. J) GO TO 290
      IF (ANDF(RMSK,FILE(I)) .EQ. ANDF(RMSK,FILE(J)) .AND.
     1    ICURSN.LE.ANDF(LMSK,FORD(J))) GO TO 300
C
  290 CONTINUE
      FEQU(I) = ANDF(ALMSK,FEQU(I))
      FLAG = -1
  300 CONTINUE
C
C     IF BREAK HAS OCCURED, REPEAT FIAT MERGE
C
      ASSIGN 451 TO IHOP
      IF (FLAG .NE. -1) GO TO 310
      ASSIGN 310 TO ISW
      GO TO 100
C
C     CLOSE UP FILES(IF ANY) BELOW UNIQUE LENGTH - RESET FCULG
C
  310 LMT7 = LMT3 - ENTN1X
      LMT3 = LMT7 - 1
  330 IF (LMT7 .LT. LMT2) GO TO 450
      IF (FDBN(LMT7) .NE. 0) GO TO 350
      LMT7 = LMT7 - ENTN1
      GO TO 420
  350 DO 390 I = LMT2,LMT3,ENTN1
      IF (FDBN(I) .NE. 0) GO TO 390
      LMT4 = I + ENTN1X
      DO 380 K = I,LMT4
      FILE(K) = FILE(LMT7)
      FILE(LMT7) = 0
      FNTU(K) = FNTU(LMT7)
  380 LMT7 = LMT7 + 1
      GO TO 410
  390 CONTINUE
      GO TO 450
  410 LMT7 = LMT7  - ENTN1Y
      LMT2 = I + ENTN1
  420 LMT3 = LMT3  - ENTN1
      FCULG= FCULG - 1
      GO TO 330
C
C     RESET ANY NECESSARY OFF SWITCHES
C
  450 GO TO IHOP, (451,170)
  451 IF (FUNLG .EQ. FCULG) RETURN
      LMT2 = LMT1 + 1
      LMT3 = FCULG*ENTN1
      DO 480 I = LMT2,LMT3,ENTN1
      IF (FEQU(I) .LT. 0) GO TO 480
      TRIAL = ANDF(RMSK,FILE(I))
      IF (TRIAL .EQ. RMSK) GO TO 480
      IFORDI = ANDF(LMSK,FORD(I))
      DO 460 J = 1,LMT3,ENTN1
      IF (TRIAL .NE. ANDF(RMSK,FILE(J))) GO TO 460
      IF (I .EQ. J) GO TO 460
      IF (ANDF(LMSK,FORD(J))-IFORDI) 452,460,454
  452 FON(J) = ORF(S,FON(J))
      GO TO 460
  454 FON(I) = ORF(S,FON(I))
  460 CONTINUE
  480 CONTINUE
      RETURN
C
  900 WRITE  (OUTTAP,901) SFM
  901 FORMAT (A25,' 1021, FIAT OVERFLOW.')
      CALL MESAGE (-37,0,NCLEAN)
      RETURN
      END

      SUBROUTINE DROD
C*****
C THIS ROUTINE COMPUTES THE TWO 6 X 6 MATRICES  K(NPVT,NPVT) AND
C K(NPVT,J) FOR A ROD HAVING END POINTS NUMBERED NPVT AND J.
C*****
C
C
C
C                        E C P T  F O R  T H E  R O D
C
C
C
C                                                                CARD
C                                                 TYPE   TABLE   TYPE
C ECPT( 1)ELEMENT ID.                               I     ECT    CROD
C ECPT( 2)SCALAR INDEX NUMBER FOR GRID POINT A      I     ECT    CROD
C ECPT( 3)SCALAR INDEX NUMBER FOR GRID POINT B      I     ECT    CROD
C ECPT( 4)MATERIAL ID.                              I     EPT    PROD
C ECPT( 5)AREA  (A)                                 R     EPT    PROD
C ECPT( 6)POLAR MOMENT OF INERTIA (J)               R     EPT    PROD
C ECPT( 7) TORSIONAL STRESS COEFF (C)                R    EPT    PROD
C ECPT( 8) NON-STRUCTRAL MASS (MU)                   R    EPT    PROD
C ECPT( 9) COOR. SYS. ID. NO. FOR GRID POINT A       I   BGPDT   GRID
C ECPT(10) X-COORDINATE OF GRID PT. A (IN BASIC COOR)R   BGPDT
C ECPT(11) Y-COORDINATE OF GRID PT. A (IN BASIC COOR)R   BGPDT
C ECPT(12) Z-COORDINATE OF GRID PT. A (IN BASIC COOR)R   BGPDT
C ECPT(13) COOR. SYS. ID. NO. FOR GRID POINT B       I   BGPDT
C ECPT(14) X-COORDINATE OF GRID PT. B (IN BASIC COOR)R   BGPDT
C ECPT(15) Y-COORDINATE OF GRID PT. B (IN BASIC COOR)R   BGPDT
C ECPT(16) Z-COORDINATE OF GRID PT. B (IN BASIC COOR)R   BGPDT
C ECPT(17) ELEMENT TEMPERATURE
C ECPT(18) ELEMENT DEFORMATION
C ECPT(19) AVERAGE ELEMENT LOADING TEMPERATURE
C ECPT(20)                ...
C ECPT(21) DISPLACEMENT COOR. FOR GRID PT. A
C ECPT(22)                ...
C ECPT(23)                ...
C ECPT(24) DISPLACEMENT COOR. FOR GRID PT. B
C ECPT(25)                ...
C
C
C
      DOUBLE PRECISION
     1                   DZ(1)              ,X
     2,                  Y                  ,Z
     3,                  XL                 ,XN(3)
     4,                  KE(36)             ,TA(9)
     5,                  TB(9)              ,A
     6,                  E                  ,ALPHA
     7,                  TSUB0              ,UA(6)
     8,                  UB(6)              ,DIFF(3)
     9,                  DPTERM             ,DELTA
     T,                  AVGLTP             ,FX
     1,                  XM(3)              ,YYT(18)
     2,                  ZZT(9)             ,YVEC(3)
     3,                  ZVEC(3)            ,D(6)
     4,                  YL                 ,ZL
     5,                  GX
C
C
C
      DIMENSION
     1                   IZ(1)              ,IECPT(19)
C
C DS1A VARIABLE CORE
C
      COMMON   /ZZZZZZ/  RZ(1)
C
C DS1A COMMON BLOCK
C
      COMMON   /DS1AAA/  NPVT
     1,                  ICSTM              ,NCSTM
     2,                  IGPCT              ,NGPCT
     3,                  IPOINT             ,NPOINT
     4,                  I6X6K              ,N6X6K
     5,                  CSTM               ,MPT
     6,                  DIT                ,ECPTDS
     7,                  GPCT               ,KGGD
     8,                  INRW               ,OUTRW
     9,                  EOR                ,NEOR
     T,                  CLSRW
     1,                  JMAX               ,FROWIC
     2,                  LROWIC             ,NROWSC
     3,                  NLINKS             ,LINK(10)
     4,                  NOGO
C
C ECPT COMMON BLOCK
C
      COMMON   /DS1AET/  ECPT(100)
C
C DS1A LOCAL VARIABLE (SCRATCH) BLOCK
C
      COMMON   /DS1ADP/
     1                   X                  ,Y
     2,                  Z                  ,XL
     3,                  XN                 ,KE
     4,                  TA                 ,TB
     5,                  A                  ,E
     6,                  ALPHA              ,T SUB 0
     7,                  UA                 ,UB
     8,                  DIFF               ,DPTERM
     9,                  DELTA              ,AVGLTP
     T,                  FX                 ,XM
     1,                  YYT
     2,                  YVEC               ,ZVEC
     3,                  YL                 ,ZL
C
C INPUT AND OUTPUT BLOCKS FOR SUBROUTINE MAT
C
      COMMON   /MATIN/
     1                   MATIDC             ,MATFLG
     2,                  ELTEMP             ,STRESS
     3,                  SINTH              ,COSTH
C
C
C
      COMMON   /MATOUT/
     1                   ES                 ,G
     2,                  NU                 ,RHO
     3,                  ALPHA S            ,T SUB 0 S
     4,                  GSUBE              ,SIGT
     5,                  SIGC               ,SIGS
C
C
C
      EQUIVALENCE
     1                   (RZ(1),IZ(1),DZ(1)),(ECPT(1),IECPT(1))
     2,                  (ZZT(1),YYT(10))
C
C BEGIN EXECUTION
C
      IF (IECPT(2) .EQ. NPVT) GO TO 10
      IF (IECPT(3) .NE. NPVT) CALL MESAGE (-30,34,IECPT(1))
      ITEMP = IECPT(2)
      IECPT(2) = IECPT(3)
      IECPT(3) = ITEMP
      KA  = 13
      KB  =  9
      IDISPA = 22
      IDISPB = 19
      GO TO 20
   10 KA  =  9
      KB  =  13
      IDISPA = 19
      IDISPB = 22
C
C AT THIS POINT KA POINTS TO THE COOR. SYS. ID. OF THE PIVOT GRID POINT.
C SIMILARLY FOR KB AND THE NON-PIVOT GRID POINT.
C NOW COMPUTE THE LENGTH OF THE ROD.
C
C
C WE STORE THE COORDINATES IN THE D ARRAY SO THAT ALL ARITHMETIC WILL BE
C DOUBLE PRECISION
C
   20 D(1) = ECPT(KA+1)
      D(2) = ECPT(KA+2)
      D(3) = ECPT(KA+3)
      D(4) = ECPT(KB+1)
      D(5) = ECPT(KB+2)
      D(6) = ECPT(KB+3)
      X    = D(1) - D(4)
      Y    = D(2) - D(5)
      Z    = D(3) - D(6)
      XL = DSQRT (X**2 + Y**2 + Z**2)
      IF (XL.EQ.0.0D0) GO TO 120
C
C CALCULATE A NORMALIZED DIRECTION VECTOR IN BASIC COORDINATES.
C
      XN(1) = X / XL
      XN(2) = Y / XL
      XN(3) = Z / XL
C
C CALL SUBROUTINE MAT TO FETCH MATERIAL PROPERTIES.
C
      MATIDC = IECPT(4)
      MATFLG = 1
      ELTEMP = ECPT(17)
      CALL MAT (IECPT(1))
C
C STORE DISPLACEMENT VECTORS IN DOUBLE PRECISION LOCATIONS
C
      UA(1) = ECPT(IDISPA+1)
      UA(2) = ECPT(IDISPA+2)
      UA(3) = ECPT(IDISPA+3)
      UB(1) = ECPT(IDISPB+1)
      UB(2) = ECPT(IDISPB+2)
      UB(3) = ECPT(IDISPB+3)
C
C
C COMPUTE THE DIFFERENCE VECTOR DIFF =  T  * U   -  T  * U
C                                        A    A      B    B
C
      IBASEA = 0
      IF (IECPT(KA) .EQ. 0) GO TO 30
      CALL TRANSD (ECPT(KA),TA)
      IBASEA = 3
      CALL GMMATD (TA,3,3,0, UA(1),3,1,0, UA(4))
   30 IBASEB = 0
      IF (IECPT(KB) .EQ. 0) GO TO 40
      CALL TRANSD (ECPT(KB),TB)
      IBASEB = 3
      CALL GMMATD (TB,3,3,0, UB(1),3,1,0, UB(4))
   40 DIFF(1) = UA(IBASEA+1) - UB(IBASEB+1)
      DIFF(2) = UA(IBASEA+2) - UB(IBASEB+2)
      DIFF(3) = UA(IBASEA+3) - UB(IBASEB+3)
C
C COMPUTE DOT PRODUCT XN . DIFF
C
      CALL GMMATD (XN,3,1,1, DIFF,3,1,0, DPTERM)
C
C COMPUTE AXIAL FORCE FX, AND TORSIONAL FORCE GX
C
      DELTA = ECPT(18)
      FX = DPTERM - DELTA
      IF (IECPT(19) .EQ. (-1)) GO TO 50
      T SUB 0 = T SUB 0 S
      ALPHA = ALPHA S
      AVGLTP = ECPT(19)
      FX = FX - ALPHA*XL*(AVGLTP - T SUB 0)
   50 A  = ECPT(5)
      E  = E S
      FX = A * E * FX / XL**2
      GX = ECPT(6) * FX / A
C
C COMPUTE THE XM VECTOR
C
      XM(1) = 0.0D0
      XM(2) = 0.0D0
      XM(3) = 0.0D0
      I = 1
      IF (DABS(XN(2)) .LT. DABS(XN(1))) I = 2
      IF (DABS(XN(3)) .LT. DABS(XN(I))) I = 3
      XM(I) = 1.0D0
C
C COMPUTE YVEC, THE CROSS PRODUCT XM X XN
C
      YVEC(1) = XM(2) * XN(3)  -  XM(3) * XN(2)
      YVEC(2) = XM(3) * XN(1)  -  XM(1) * XN(3)
      YVEC(3) = XM(1) * XN(2)  -  XM(2) * XN(1)
      YL = DSQRT (YVEC(1)**2  +  YVEC(2)**2  +  YVEC(3)**2)
      YVEC(1) = YVEC(1) / YL
      YVEC(2) = YVEC(2) / YL
      YVEC(3) = YVEC(3) / YL
C
C COMPUTE ZVEC, THE CROSS PRODUCT XN X YVEC
C
      ZVEC(1) = XN(2) * YVEC(3)  -  XN(3) * YVEC(2)
      ZVEC(2) = XN(3) * YVEC(1)  -  XN(1) * YVEC(3)
      ZVEC(3) = XN(1) * YVEC(2)  -  XN(2) * YVEC(1)
      ZL = DSQRT (ZVEC(1)**2  +  ZVEC(2)**2  +  ZVEC(3)**2)
      ZVEC(1) = ZVEC(1) / ZL
      ZVEC(2) = ZVEC(2) / ZL
      ZVEC(3) = ZVEC(3) / ZL
C
C                    T                 T
C COMPUTE YVEC * YVEC  AND  ZVEC * ZVEC
C
      CALL GMMATD (YVEC,3,1,0, YVEC,3,1,1, YYT)
      CALL GMMATD (ZVEC,3,1,0, ZVEC,3,1,1, ZZT)
C
C ADD THESE TWO MATRICES AND STORE IN YYT
C
      DO 60 I = 1,9
   60 YYT(I) = YYT(I) + ZZT(I)
C
C          T
C COMPUTE T  (YYT) IF POINT A IS NOT IN BASIC COORDINATES
C          A
C
      IAYPNT = 1
      IF (IECPT(KA) .EQ. 0) GO TO 70
      IAYPNT = 10
      CALL GMMATD (TA,3,3,1, YYT,3,3,0, YYT(10))
C
C          T
C COMPUTE T  (YYT) T  AND STORE IN YYT(1)
C          A        A
C
      CALL GMMATD (YYT(10),3,3,0, TA,3,3,0, YYT(1))
C
C ZERO OUT KE MATRIX
C
   70 DO 80 I = 1,36
   80 KE(I) = 0.0D0
      K = 1
      J = 2
C
C FILL UP THE 6 X 6 KE
C
   90 KE( 1) = FX * YYT(K  )
      KE( 2) = FX * YYT(K+1)
      KE( 3) = FX * YYT(K+2)
      KE( 7) = FX * YYT(K+3)
      KE( 8) = FX * YYT(K+4)
      KE( 9) = FX * YYT(K+5)
      KE(13) = FX * YYT(K+6)
      KE(14) = FX * YYT(K+7)
      KE(15) = FX * YYT(K+8)
      KE(22) = GX * YYT(K  )
      KE(23) = GX * YYT(K+1)
      KE(24) = GX * YYT(K+2)
      KE(28) = GX * YYT(K+3)
      KE(29) = GX * YYT(K+4)
      KE(30) = GX * YYT(K+5)
      KE(34) = GX * YYT(K+6)
      KE(35) = GX * YYT(K+7)
      KE(36) = GX * YYT(K+8)
      CALL DS1B (KE,IECPT(J))
      IF (J .EQ. 3) RETURN
      IF (IECPT(KB) .EQ. 0) GO TO 100
      IBYPNT = 1
      IF (IAYPNT .EQ. 1) IBYPNT = 10
      CALL GMMATD (YYT(IAYPNT),3,3,0, TB,3,3,0, YYT(IBYPNT))
      K = IBYPNT
      GO TO 110
  100 K = IAYPNT
  110 J = 3
      FX = -FX
      GX = -GX
      GO TO 90
  120 CALL MESAGE(30,26,IECPT(1))
C
C  SET FLAG FOR FATAL ERROR WHILE ALLOWING ERROR MESSAGES TO ACCUMULATE
C
      NOGO=1
      RETURN
      END

      SUBROUTINE DDRMMP(*,Z,NCORE,LUSED,IXYTYP,ICASE,BUFF,ANYXY)
C*****
C  BUILD LIST OF POINTS IN SORT FOR WHICH XYCDB OUTPUT REQUESTS EXIST
C  OF FILE TYPE -IXYTYP- AND OF SUBCASE 0 AND SUBCASE -ICASE-.
C*****
      INTEGER Z(1), LOC(6), BUFF(1), XYCDB
C
      LOGICAL ANYXY
C/////
      COMMON/SYSTEM/ SYSBUF, IOUT
      COMMON/NAMES / RD, RDREW, WRT, WRTREW, CLSREW, CLS
      COMMON/DDRMC1/ DUMMY(362), IERROR
C/////
C
      DATA XYCDB/ 108 /, NOEOR / 0 /
C
      LUSED = 0
      ANYXY = .FALSE.
      CALL OPEN(*100,XYCDB,BUFF,RDREW)
      CALL FWDREC(*300,XYCDB)
      CALL FWDREC(*300,XYCDB)
C
C     FIND ENTRIES IN SUBCASE 0 OF THIS TYPE IF ANY.
C
    5 CALL READ(*300,*300,XYCDB,LOC,6,NOEOR,NWDS)
      IF( LOC(1) ) 10,10,20
   10 IF( LOC(2) .NE. IXYTYP ) GO TO 5
C
C     SAVE ID IN TABLE
C
      IF( LUSED ) 11,11,12
C
C      ADD TO LIST IF NOT A REPEAT ID
C
   12 IF( LOC(3) .EQ. Z(LUSED) ) GO TO 5
   11 LUSED = LUSED + 1
      IF( LUSED .GT. NCORE ) GO TO 1000
      Z(LUSED) = LOC(3)
      GO TO 5
C
C     FIND ENTRIES IN SUBCASE -ICASE- OF THIS TYPE IF ANY EXIST.
C
   15 CALL READ(*300,*300,XYCDB,LOC,6,NOEOR,NWDS)
   20 IF( LOC(1) - ICASE ) 15, 30, 300
   30 IF( LOC(2) - IXYTYP ) 15, 40, 300
   40 LUSED = LUSED + 1
      IF( LUSED .GT. NCORE ) GO TO 1000
      Z(LUSED) = LOC(3)
      GO TO 15
C
C     LIST IS NOW COMPLETE THUS SORT IT, AND REMOVE REPEATED IDS.
C
  300 CALL CLOSE( XYCDB, CLSREW )
      IF( LUSED ) 100,100,301
  301 CALL SORT( 0, 0, 1, 1, Z(1), LUSED )
      ANYXY = .TRUE.
C
      J = 1
      IF( LUSED .EQ. 1 ) GO TO 305
      DO 303 I = 2,LUSED
      IF( Z(I) .EQ. Z(J) ) GO TO 303
      J = J + 1
      Z(J) = Z(I)
  303 CONTINUE
C
  305 LUSED = J
  100 RETURN
C
C     INSUFFICIENT CORE ALTERNATE RETURN.
C
 1000 IERROR = 859
      RETURN 1
      END

      SUBROUTINE QHBDY
C*****
C
C  THIS ROUTINE APPLIES THE LOADS DUE TO A SELECTED HEAT FLUX
C  LOADING CONDITION.
C
C  DATA CARD IS...
C
C  QHBDY  SETID  FLAG  Q0  AF  G1  G2  G3  G4
C                ============================
C                ABOVE FIELDS AVAILABLE TO THIS ROUTINE ONLY.
C                GRIDS ARE IN INTERNAL NOTATION AT THIS POINT.
C*****
      INTEGER  MAP(15)  ,CARD(7)  ,IGRIDS(5),SLT      ,OLD      ,BG
      INTEGER  SILS(4)  ,GRIDS(4) ,ORDER(4) ,SUBR(2)
C
      REAL     BGPDT(4,4)         ,X(4)     ,Y(4)     ,Z(4)
      REAL     DATA4(4) ,P(4)     ,R12(3)   ,R13(3)   ,LENGTH
C
      COMMON /CONDAS/ CONSTS(5)
      COMMON/LOADX / LC, SLT, BG, OLD, N(12), IFM
      COMMON/ZZZZZZ/ CORE(1)
C
      EQUIVALENCE ( CONSTS(1) , PI     )
      EQUIVALENCE(X(1),BGPDT(1,2)), (Y(1),BGPDT(1,3)), (Z(1),BGPDT(1,4))
      EQUIVALENCE(IFLAG,CARD(1)), (Q0,CARD(2)), (AF,CARD(3))
      EQUIVALENCE(GRIDS(1),CARD(4),SILS(1))
C
      DATA MAP/ 1,2,3,  1,2,4,  2,3,1,  3,4,2,  4,1,3 /
      DATA IGRIDS/ 1,2,2,3,4 /
      DATA SUBR/ 4HQHBD,4HY    /
C*****
C  READ AND PROCESS ONE QHBDY IMAGE PER CALL TO THIS ROUTINE.
C*****
      CALL READ(*902,*903,SLT,CARD(1),7,0,FLAG)
      NGRIDS = IGRIDS(IFLAG)
C*****
C  OBTAIN A GRID (INTERNAL) POINT SORT VECTOR SO AS TO CALL FOR BGPDT
C  DATA EFFICIENTLY.
C*****
      IF( NGRIDS .LE. 1 ) GO TO 35
      CALL PERMUT( GRIDS(1), ORDER(1), NGRIDS, OLD )
      GO TO 38
   35 ORDER(1) = 1
C*****
C  PICK UP BGPDT FOR THE 1 TO 4 POINTS AND OBTAIN THE SILS.
C*****
   38 DO 40 I = 1,NGRIDS
      L = ORDER(I)
      CALL FNDPNT( DATA4(1), GRIDS(L) )
      BGPDT(L,1) = DATA4(1)
      BGPDT(L,2) = DATA4(2)
      BGPDT(L,3) = DATA4(3)
      BGPDT(L,4) = DATA4(4)
      CALL FNDSIL( GRIDS(L) )
   40 CONTINUE
C*****
C  ALL DATA IS AT HAND FOR LOAD CALCULATIONS
C*****
      AF = AF * Q0
      GO TO (100,200,300,400,500),IFLAG
C*****
C  IFLAG=1   A POINT...
C*****
  100 P(1) = AF
      GO TO 700
C*****
C  IFLAG=2  A LINE...
C*****
  200 LENGTH = SQRT( (X(2)-X(1))**2 + (Y(2)-Y(1))**2 +  (Z(2)-Z(1))**2 )
      P(1) = AF * LENGTH * 0.50E0
      P(2) = P(1)
      GO TO 700
C*****
C  IFLAG=3  A LINE OF REVOLUTION...
C*****
  300 FACT = PI*Q0*SQRT( (X(2)-X(1))**2 + (Z(2)-Z(1))**2 ) / 3.0E0
      P(1) = FACT * (2.0E0*X(1) + X(2))
      P(2) = FACT * (X(1) + 2.0E0*X(2))
      GO TO 700
C*****
C  IFLAG=4  A TRIANGLE...
C*****
  400 FACT = Q0 / 6.0E0
      IMAP = 1
      NMAP = 3
      GO TO 600
C*****
C  IFLAG=5  A QUADRILATERAL...
C*****
  500 FACT = Q0 / 12.0E0
      IMAP = 4
      NMAP = 15
C*****
C  MAP 1 OR 4 TRIANGLES INTO 3 OR 4 POINTS.
C*****
  600 P(1) = 0.0E0
      P(2) = 0.0E0
      P(3) = 0.0E0
      P(4) = 0.0E0
      DO 650 I = IMAP,NMAP,3
      I1 = MAP(I)
      I2 = MAP(I+1)
      I3 = MAP(I+2)
      R12(1) = X(I2) - X(I1)
      R12(2) = Y(I2) - Y(I1)
      R12(3) = Z(I2) - Z(I1)
      R13(1) = X(I3) - X(I1)
      R13(2) = Y(I3) - Y(I1)
      R13(3) = Z(I3) - Z(I1)
      CALL SAXB( R12(1), R13(1), R12(1) )
      FACTX= FACT * SQRT( R12(1)**2  + R12(2)**2  + R12(3)**2 )
      P(I1) = P(I1) + FACTX
      P(I2) = P(I2) + FACTX
      P(I3) = P(I3) + FACTX
  650 CONTINUE
C*****
C  LOAD VALUES COMPLETE.
C*****
  700 DO 800 I = 1,NGRIDS
      ISIL = SILS(I)
      CORE(ISIL  ) = CORE(ISIL  ) + P(I)
  800 CONTINUE
      RETURN
C*****
C  END OF FILE OR END OF RECORD HIT ERROR.
C*****
  902 CALL MESAGE(-2,SLT,SUBR)
  903 CALL MESAGE(-3,SLT,SUBR)
      GO TO 902
      END

      SUBROUTINE DPPS(KS,I,J1,J2,SGR,CGR,YS,ZS,NBARAY,NCARAY,DT,WORK)
C   ***   GENERATES ROWS OF THE  DPP  SUBMATRIX USING
C         SUBROUTINE  SUBP
      DIMENSION YS(1),ZS(1),NBARAY(1),NCARAY(1),WORK(1)
      COMPLEX DT(1), SUM
      COMMON /DLCOM / NP,NSTRIP,NTP,F,NJJ,NEXT,LENGTH,
     1                INC,INB,IYS,IZS,IEE,ISG,ICG,
     2                IXIC,IDELX,IXLAM,IDT,
     3  ICORE
      L    = 1
C  L IS THE PANEL NUMBER ASSOCIATED WITH SENDING   POINT  J
      LS   = 1
C  LS IS THE STRIP NUMBER ASSOCIATED WITH SENDING   POINT  J
      NBXS = NBARAY(L)
      NC1  = NCARAY(L)
      NBCUM= NC1
      YREC = YS(KS)
      ZREC = ZS(KS)
      DO   20  J=J1,J2
      CALL SUBP(I,L,LS,J,SGR,CGR,YREC,ZREC,SUM,
     1 WORK(IXIC),WORK(IDELX),WORK(IEE),WORK(IXLAM),
     2  WORK(ISG),WORK(ICG),YS,ZS)
      DT(J)= SUM
      IF (J.EQ.J2)  GO TO   20
      IF (J.LT.NBXS)   GO TO  10
      L    = L+1
      NC1  = NCARAY(L)
      NBXS = NBARAY(L)
   10 CONTINUE
      IF (J.LT.NBCUM)  GO TO  20
      LS   = LS+1
      NBCUM= NBCUM+NC1
   20 CONTINUE
      RETURN
      END

      SUBROUTINE CMRELS
C
C     THIS SUBROUTINE ENFORCES THE RELES DATA SPECIFIED FOR THE
C     COMB1 MODULE.
C
      EXTERNAL        ANDF
      LOGICAL         FIRST
      INTEGER         IX(7,3),SCBDAT,Z,SCORE,BUF1,BUF2,SCCONN,PS1,PS2
      INTEGER         LIST(32),ANDF,STCE,AAA(2)
      COMMON /CMB001/ SCR1,SCR2,SCBDAT,SCSFIL,SCCONN
      COMMON /CMB002/ BUF1,BUF2,BUF3,BUF4,BUF5,SCORE,LCORE,INPT,OUTT
      COMMON /CMB003/ JUNK(38),NPSUB
      COMMON /ZZZZZZ/ Z(1)
      DATA    AAA   / 4HCMRE,4HLS   /
C
      IFILE = SCBDAT
      KJ = 0
      DO 20 I = 1,7
      DO 10 J = 1,3
      IX(I,J) = 0
   10 CONTINUE
   20 CONTINUE
      DO 70 I = 1,NPSUB
      FIRST = .TRUE.
      CALL OPEN (*150,SCBDAT,Z(BUF1),0)
      CALL SKPFIL (SCBDAT,3)
   30 CALL READ (*60,*170,SCBDAT,ID,1,0,N)
      IF (ID .EQ. I) GO TO 40
      CALL FWDREC (*60,SCBDAT)
      GO TO 30
   40 CALL READ (*160,*50,SCBDAT,Z(SCORE+KJ),LCORE,1,NW)
      GO TO 180
   50 IF (FIRST) IX(I,2) = SCORE + KJ
      FIRST = .FALSE.
      IX(I,3) = IX(I,3) + NW/2
      KJ = KJ + NW
      LCORE = LCORE - NW
      IX(I,1) = 1
      GO TO 30
   60 CALL CLOSE (SCBDAT,1)
   70 CONTINUE
      DO 80 I = 1,NPSUB
      IF (IX(I,1) .EQ. 0) GO TO 80
      IST = IX(I,2)
      NW  = IX(I,3)*2
      CALL SORT (0,0,2,1,Z(IST),NW)
   80 CONTINUE
      IFILE = SCCONN
      CALL OPEN (*150,SCCONN,Z(BUF2),0)
      NWRD = 2 + NPSUB
      NCE  = 0
      STCE = SCORE + KJ
   90 CALL READ (*110,*100,SCCONN,Z(SCORE+KJ),LCORE,1,NNN)
      GO TO 180
  100 KJ  = KJ + NWRD
      NCE = NCE + 1
      GO TO 90
  110 CALL CLOSE (SCCONN,1)
      NCE = NWRD*NCE
      DO 130 I = 1,NCE,NWRD
      II = I - 1
      ICODE = Z(STCE+II+1)
      CALL DECODE (ICODE,LIST,NC)
      IF (NC .NE. 2) GO TO 130
      PS1  = LIST(1) + 1
      PS2  = LIST(2) + 1
      IST1 = IX(PS1,2)
      IST2 = IX(PS2,2)
      NW1  = IX(PS1,3)
      NW2  = IX(PS2,3)
      IF (IX(PS1,1) .EQ. 0) GO TO 120
      KID  = Z(STCE+II+1+PS1)
      CALL BISLOC (*120,KID,Z(IST1),2,NW1,IW)
      Z(STCE+II) = Z(STCE+II) - ANDF(Z(STCE+II),Z(IST1+IW))
  120 IF (IX(PS2,1) .EQ. 0) GO TO 130
      KID = Z(STCE+II+1+PS2)
      CALL BISLOC (*130,KID,Z(IST2),2,NW2,IW)
      Z(STCE+II) = Z(STCE+II) - ANDF(Z(STCE+II),Z(IST2+IW))
  130 CONTINUE
      CALL OPEN (*150,SCCONN,Z(BUF1),1)
      DO 140 I = 1,NCE,NWRD
      II = I - 1
      IF (Z(STCE+II) .NE. 0) CALL WRITE (SCCONN,Z(STCE+II),NWRD,1)
  140 CONTINUE
      CALL EOF (SCCONN)
      CALL CLOSE (SCCONN,1)
      RETURN
C
  150 IMSG = -1
      GO TO 190
  160 IMSG = -2
      GO TO 190
  170 IMSG = -3
      GO TO 190
  180 IMSG = -8
  190 CALL MESAGE (IMSG,IFILE,AAA)
      RETURN
      END

      SUBROUTINE MCE2
C
C     MCE2 PARTITIONS KGG INTO KNNB, KMNB AND KMMB THEN COMPUTES
C
C     KNN = KNNB + GM(T)*KMNB + KMNB(T)*GM + GM(T)*KMMB*GM
C
C     SIMILAR OPERATIONS ARE PERFORMED ON MGG, BGG AND K4GG IF THE
C     MATRIX HAS NOT BEEN PURGED.
C
      INTEGER         SCR1  ,SCR2  ,SCR6  ,USET  ,MCB(7),GM    ,UG    ,
     1                UN    ,UM    ,BGG   ,BNNB  ,BMNB  ,BNN   ,BMMB
      COMMON /BITPOS/ UM    ,UO    ,UR    ,USG   ,USB   ,UL    ,UA    ,
     1                UF    ,US    ,UN    ,UG    ,UE    ,UP
C
C     INPUT AND OUTPUT FILES
C
      DATA    USET  , GM , KGG, MGG, BGG, K4GG,   KNN, MNN, BNN, K4NN /
     1        101   , 102, 103, 104, 105, 106 ,   201, 202, 203, 204  /
C
C     SCRATCH FILES
C
      DATA    SCR1  , SCR2, SCR6 / 301, 302, 306 /
      DATA    KNNB  , KMNB, KMMB / 303, 304, 305 /
      DATA    MNNB  , MMNB, MMMB / 303, 304, 305 /
      DATA    BNNB  , BMNB, BMMB / 303, 304, 305 /
      DATA    K4NNB , K4MNB,K4MMB/ 303, 304, 305 /
C
C     ARITHMETIC TYPES
C
C     PARTITION KGG INTO KNNB, KMNB, AND KMMB
C
      CALL UPART (USET,SCR1,UG,UN,UM)
      CALL MPART (KGG,KNNB,KMNB,0,KMMB)
C
C     COMPUTE KNN
C
      CALL ELIM (KNNB,KMNB,KMMB,GM,KNN,SCR1,SCR2,SCR6)
C
C     TEST TO SEE IF MGG IS PRESENT
C
      MCB(1) = MGG
      CALL RDTRL (MCB)
      IF (MCB(1) .LT. 0) GO TO 110
C
C     IF MGG PRESENT, PARTITION INTO MNNB, MMNB, AND MMMB
C     THEN COMPUTE MNN
C
      CALL UPART (USET,SCR1,UG,UN,UM)
      CALL MPART (MGG,MNNB,MMNB,0,MMMB)
      CALL ELIM  (MNNB,MMNB,MMMB,GM,MNN,SCR1,SCR2,SCR6)
C
C     TEST TO SEE IF BGG IS PRESENT
C
  110 MCB(1) = BGG
      CALL RDTRL (MCB)
      IF (MCB(1) .LT. 0) GO TO 130
C
C     IF BGG PRESENT, PARTITION INTO BNNB, BMNB, AND BMMB
C     THEN COMPUTE BNN
C
      CALL UPART (USET,SCR1,UG,UN,UM)
      CALL MPART (BGG,BNNB,BMNB,0,BMMB)
      CALL ELIM  (BNNB,BMNB,BMMB,GM,BNN,SCR1,SCR2,SCR6)
C
C     TEST TO SEE IF K4GG IS PRESENT
C
  130 MCB(1) = K4GG
      CALL RDTRL (MCB)
      IF (MCB(1) .LT. 0) RETURN
C
C     IF K4GG IS PRESENT, PARTITION INTO K4NNB, K4MNB, AND K4MMB
C     THEN COMPUTE K4NN
C
      CALL UPART (USET,SCR1,UG,UN,UM)
      CALL MPART (K4GG,K4NNB,K4MNB,0,K4MMB)
      CALL ELIM  (K4NNB,K4MNB,K4MMB,GM,K4NN,SCR1,SCR2,SCR6)
      RETURN
      END

      SUBROUTINE MXCIDS(*,Z,MSET,MSZE,NWDS,USET,NSTRT,SNAM)
C-----
C   THIS SUBROUTINE CREATES A LIST OF SUBSTRUCTURE NAMES AT Z(1)
C AND AN ARRAY AT Z(NSTRT) OF LENGTH MSZE*NWDS WITH THE FIRST TWO WORDS
C OF EACH ENTRY AS,
C     1 - EXTERNAL ID * 10 + COMPONENT
C     2 - POINTER TO FIRST WORD OF SUBSTRUCTURE NAME...
C
C INPUT
C     Z     = OPEN CORE - Z(1) TO Z(NSTRT-1)
C     MSET  = ONE WORD BCD IDENTIFING SET
C     MSZE  = NUMBER OF COLUMNS IN MATRIX
C     NWDS  = NUMBER WORDS/ENTRY DESIRED (2 MINIMUM)
C     USET  = USET GINO FILE NAME
C     NSTRT = LOCATION OF FIRST OF FOUR (4) BUFFERS.
C     SNAM  = SUBSTRUCTURE NAME BEING SOLVED (2 WORD BCD).
C OUTPUT
C     *     = TASK NOT COMPLETED
C     Z     = SUBSTRUCTURE NAMES + COLUMN IDENTIFIERS (SEE ABOVE)
C     NSTRT = FIRST WORD OF COLUMN IDENTIFIERS
C-----
C
C       N O T   C O D E D   Y E T
C
        IF (MSET.EQ.1) RETURN
      RETURN 1
        END

      BLOCK DATA VDRBD
CVDRBD
C BLOCK DATA FOR THE VECTOR DATA RECOVERY MODULE (VDR).
C*****
      INTEGER USETD,CASECC,EQDYN ,OEIGS ,PP    ,XYCDB ,PNL   ,OUTFLE
     1       ,OPNL1,SCR1  ,SCR2  ,BUF1  ,BUF2  ,BUF3  ,CEI   ,FRQ
     2       ,TRN  ,DIRECT,XSET0 ,BUF
C
      DIMENSION NAM(2)    ,BUF(50)      ,MASKS(6)
     1         ,CEI(2)    ,FRQ( 2)      ,TRN(2)       ,MODAL(2)
     2         ,DIRECT(2)
C
      COMMON/VDRCOM/VDRCOM,IDISP ,IVEL  ,IACC  ,ISPCF ,ILOADS,ISTR
     1             ,IELF  ,IADISP,IAVEL ,IAACC ,IPNL  ,ITTL  ,ILSYM
     2             ,IFROUT,IDLOAD,CASECC,EQDYN ,USETD ,INFILE,OEIGS
     3             ,PP    ,XYCDB ,PNL   ,OUTFLE,OPNL1 ,SCR1  ,SCR2
     4             ,BUF1  ,BUF2  ,BUF3  ,NAM   ,BUF   ,MASKS ,CEI
     5             ,FRQ   ,TRN   ,DIRECT,XSET0 ,VDRREQ,MODAL
C
C DATA DEFINING POSITION OF PARAMETERS IN CASE CONTROL RECORD.
C
      DATA   IDISP  / 20/ ,IVEL   / 32/ ,IACC   / 29/ ,ISPCF  / 35/
     1      ,ILOADS / 17/ ,ISTR   / 23/ ,IELF   / 26/ ,IADISP /151/
     2      ,IAVEL  /154/ ,IAACC  /157/ ,IPNL   / 10/ ,ITTL   / 39/
     3      ,ILSYM  /200/ ,IFROUT /145/ ,IDLOAD / 13/
C
C DATA DEFINING GINO FILE NAMES
C
      DATA   CASECC /101/ ,EQDYN  /102/ ,USETD  /103/ ,INFILE /104/
     1      ,OEIGS  /105/ ,PP     /105/ ,XYCDB  /106/ ,PNL    /107/
     2      ,OUTFLE /201/ ,OPNL1  /202/ ,SCR1   /301/ ,SCR2   /302/
C
C MISC DATA
C
      DATA   BUF   /50*0/ ,NAM    /4HVDR ,4H    /
     1      ,MASKS /4,8,16,32,64,128/,XSET0/100000000/
C
C DATA DEFINING RIGID FORMATS AND PROBLEM TYPES
C
      DATA   CEI    /4HCEIG,4HEN  /,FRQ   /4HFREQ,4HRESP/
     1      ,TRN    /4HTRAN,4HRESP/,MODAL /4HMODA,4HL   /
     2      ,DIRECT /4HDIRE,4HCT  /
      END

      SUBROUTINE SSLOT1(IOPT)
C                  IOPT-  CSLOT3 = 0,  CSLOT4 = 1
C     THE ECPT DATA FOR THESE ELEMENTS ARE
C
C     FIELD   CSLOT3                CSLOT4
C       1       ID                  ID
C       2       SIL1                SIL1
C       3       SIL2                SIL2
C       4       SIL3                SIL3
C       5       RHO                 SIL4
C       6       BULK                RHO
C       7       M                   BULK
C       8       N                   M
C       9       CID1                N
C       10      R1                  CID1
C      11       Z1                  R1
C      12       W1                  Z1
C      13       CID2                W1
C      14       R2                  CID2
C      15       Z2                  R2
C      16       W2                  Z2
C      17       CID3                W2
C      18       R3                  CID3
C      19       Z3                  R3
C      20       W3                  Z3
C      21       TEMP                W3
C      22                           CID4
C      23                           R4
C      24                           Z4
C***** 25                           W4
C***** 26                           TEMP
      INTEGER NECPT(100),NOUT(100)
      DIMENSION SV(24)
      COMMON/SDR2X5/ ECPT(100),OUT(100)
      COMMON/SDR2X6/ R(4),Z(4),RHO,FACT,A,NC1,NC2,NC3,IRET,NR,
     1 COL,NR1,NR2,NR3,II,IJ
      EQUIVALENCE (ECPT(1),NECPT(1)),(OUT(1),NOUT(1)),(OUT(6),SV(1))
      IOT = 6
      DO 10 I=1,30
   10 NOUT(I) = 0
      NC1 =1
      NC2 =2
      NC3 =3
      IF(IOPT.NE.0) GO TO 30
C     SET UP FOR THE SLOT3 ELEMENT
C****
      RHO = ECPT(5)
      IRET=4
      DO 20 I=1,3
      NR= 4*(I-1)+10
      R(I)=ECPT(NR)
      Z(I)=ECPT(NR+1)
   20 CONTINUE
      GO TO 80
C****
C     THE CSLOT4 ELEMENT IS CALCULATED AS FOLLOWS
   30 CONTINUE
      RHO = ECPT(6)*4.0
      DO 40 I =1,4
      NR = 4*(I-1) +11
      R(I) = ECPT(NR)
      Z(I) = ECPT(NR+1)
   40 CONTINUE
      NCOL=6
      IRET =1
      GO TO 80
   50 NC3 =4
      IRET=2
      GO TO 80
   60 NC2 =3
      IRET=3
      GO TO 80
   70 NC1= 2
      IRET=4
   80 A =    (R(NC1)*(Z(NC2)-Z(NC3)) +R(NC2)*(Z(NC3)-Z(NC1))
     1        + R(NC3)*(Z(NC1)-Z(NC2)) )
      FACT = - RHO *A
      SV(NC1)=(Z(NC2) -Z(NC3))/FACT+SV(NC1)
      SV(NC2)=(Z(NC3) -Z(NC1))/FACT+SV(NC2)
      SV(NC3)=(Z(NC1) -Z(NC2))/FACT+SV(NC3)
C
      NR1= 3+IOPT +NC1
      NR2= 3+IOPT +NC2
      NR3= 3+IOPT +NC3
C
      SV(NR1)=(R(NC3)-R(NC2))/FACT +SV(NR1)
      SV(NR2)=(R(NC1)-R(NC3))/FACT +SV(NR2)
      SV(NR3)=(R(NC2)-R(NC1))/FACT +SV(NR3)
C
      GO TO (50,60,70,90),IRET
C
   90 CONTINUE
      NR = IOPT+3
      IF(IOPT .EQ. 1) RHO =RHO/4.0
      DO 100 I =1,NR
      J=I+1
      IF(J .GT. IOPT+3) J =J-IOPT-3
      FACT = 1.0/(SQRT((R(J)-R(I))**2+(Z(J)-Z(I))**2)*RHO)
      II=  IOPT*(I+1) +4*I+3
      FACT = 1.0/(SQRT((R(J)-R(I))**2+(Z(J)-Z(I))**2)*RHO)
      II=  IOPT*(I+1) +4*I+3
      IJ = II +J -I
      SV(II) = FACT
      SV(IJ) =-FACT
  100 CONTINUE
C
C*****
C     WRAP UP OUTPUT
C*****
      NOUT(1)= NECPT(1)
      NOUT(2)= NECPT(2)
      NOUT(3)= NECPT(3)
      NOUT(4)= NECPT(4)
      IF(IOPT.GT.0) NOUT(5)= NECPT(5)
      RETURN
      END

      SUBROUTINE DUMOD4
C
C*****
C
C     DUMMY DECK FOR MODULE DUMMOD4 - SEE USER'S MANUAL SECTION 5.6.
C                                     FOR MODULE PROPERTIES, CHECK
C                                     SUBROUTINE XMPLDD OR USE DIAG 31.
C
C*****
C
      COMPLEX          PARM9
C
      DOUBLE PRECISION PARM8,PARM10
C
      INTEGER          PARM1,PARM2,PARM3,PARM4,PARM7
      INTEGER          INFILE(8),OUTFIL(8),SCRFIL(10)
C
      COMMON /BLANK /  PARM1,PARM2,PARM3,PARM4,PARM5,PARM6,
     1                 PARM7(2),PARM8,PARM9,PARM10(2)
      COMMON /ZZZZZZ/  X(1)
C
      DATA    INFILE/  101,102,103,104,105,106,107,108/
      DATA    OUTFIL/  201,202,203,204,205,206,207,208/
      DATA    SCRFIL/  301,302,303,304,305,306,307,308,309,310/
C
      RETURN
      END

      SUBROUTINE AMPC2 (INP,OUTP,SCRF)
C
C     THE PURPOSE OF THIS ROUTINE IS TO COPY SCR5 ONTO THE BOTTOM OF
C     OUTPUT
C
      INTEGER         OUTP,SCRF,SYSBUF,MCBI(7),MCBO(7)
      COMMON /PACKX / IT1,IT2,II,JJ,INCR
      COMMON /UNPAKX/ IT3,II1,JJ1,INCR1
      COMMON /SYSTEM/ SYSBUF
      COMMON /ZZZZZZ/ IZ(1)
      COMMON /TYPE  / ISK(2),IWORD(4)
C
C
      MCBI(1) = INP
      CALL RDTRL (MCBI)
      MCBO(1) = OUTP
      CALL RDTRL (MCBO)
C
C     IS THIS THE FIRST ENTRY
C
      IF (MCBO(2) .NE. 0) GO TO 10
C
C     SWITCH SCRATCH FILES
C
      CALL FILSWI (INP,OUTP)
      RETURN
C
C     MUST DO COPY
C
   10 CALL FILSWI (OUTP,SCRF)
      IBUF1 = KORSZ(IZ) - SYSBUF + 1
      IBUF2 = IBUF1 - SYSBUF
      IBUF3 = IBUF2 - SYSBUF
      CALL GOPEN (INP,IZ(IBUF1),0)
      CALL GOPEN (SCRF,IZ(IBUF2),0)
      CALL GOPEN (OUTP,IZ(IBUF2),1)
      NCOL  = MCBI(2)
      NROWO = MCBI(3) + MCBO(3)
      IT1   = MCBI(5)
      IT2   = IT1
      IT3   = IT1
      INCR  = 1
      INCR1 = 1
      NTERM = NROWO*IWORD(IT1)
      II    = 1
      JJ    = NROWO
      NROWIS= MCBO(3)*IWORD(IT1) + 1
      II1   = 1
      NRI   = MCBI(3)
      NRO   = MCBO(3)
      MCBO(2) = 0
      MCBO(6) = 0
      MCBO(7) = 0
      MCBO(3) = NROWO
      DO 20 I = 1,NCOL
      DO 30 J = 1,NTERM
      IZ(J) = 0
   30 CONTINUE
      JJ1 = NRO
      CALL UNPACK (*40,SCRF,IZ)
   40 CONTINUE
      JJ1 = NRI
      CALL UNPACK (*50,INP,IZ(NROWIS))
   50 CALL PACK (IZ,OUTP,MCBO)
   20 CONTINUE
      CALL CLOSE (SCRF,1)
      CALL CLOSE (INP,1)
      CALL CLOSE (OUTP,1)
      CALL WRTTRL (MCBO)
      RETURN
      END

      SUBROUTINE HCCOM(ITYPE,LCORE,ICORE,NEXTZ,KCOUNT)
C
C COMBINES HC CENTROID INFO ON SCR6 TO HCCENS
C
      INTEGER SCR6,HCCENS,IZ(1),ID(2),NAM(2),MCBH(7)
      LOGICAL INCORE,BLDP,EOR
      DIMENSION HC(63)
      COMMON/SYSTEM/IDUM,IOUT
      COMMON/ZZZZZZ/Z(1)
      COMMON/PACKX/ITA,ITB,II,JJ,INCR
      COMMON/ZBLPKX/A(4),IROW
      EQUIVALENCE (Z(1),IZ(1))
      DATA MCBH/307,0,0,2,1,0,0/
      DATA SCR6,HCCENS/306,307/
      DATA NAM/4HHCCO,4HM   /
C
      ITA=1
      ITB=1
      II=1
      INCR=1
      ICOUNT=0
      NSKIP=0
      NSKIP1=0
      IN=0
      EOR=.FALSE.
      BLDP=.FALSE.
      INCORE=.TRUE.
C
C IF TYPE IS 24 JUST PACK ZEROS ON HCCENS
C
      IF(ITYPE.EQ.24)GO TO 60
C
      CALL GOPEN(SCR6,Z(LCORE+1),0)
C
C SCR6 HAS 3 ENTRIES PER ELEMENT-ID,NUMBER OF POINTS AT WHICH HC IS
C COMPUTED=N, AND 3*N HC VALUES--THERE IS ONE RECORD PER CARD TYPE
C ON SCR6 FOR THIS SUBCASE
C IF  .NOT. INCORE, THEN WE ARE BACK HERE DUE TO SPILL LOGIC AND  ARE
C TRYING TO FINISH THE FIRST RECORD. SO WE MUST SKIP THE PART OF THE
C RECORD PREVIOUSLY READ.
C
    5 IF(.NOT.INCORE)CALL FREAD(SCR6,ID,-NSKIP,0)
      INWORD=0
   10 CALL READ (*1002,*20,SCR6,ID,2,0,NWDS)
      NSKIP=NSKIP+2
      INEXT=NEXTZ+INWORD
      NWORDS=3*ID(2)
      IF(INEXT+NWORDS.GT.ICORE)GO TO 80
      CALL FREAD(SCR6,Z(INEXT),NWORDS,0)
C
C INWORD IS THE NUMBER OF WORDS READ INTO CORE ON THIS READ
C NSKIP IS THE TOTAL NUMBER OF WORDS READ FROM SCR6 FROM THIS RECORD
C ICOUNT IS THE TOTAL NUMBER OF WORDS SAVED IN CORE FROM THIS RECORD
C
      INWORD=INWORD+NWORDS
      NSKIP=NSKIP+NWORDS
      ICOUNT=ICOUNT+NWORDS
      GO TO 10
C
   20 EOR=.TRUE.
      IF(.NOT.INCORE)GO TO 95
C
C CHECK ON COUNT CONSISTENCY
C
      IF(ICOUNT.NE.KCOUNT)GO TO 500
C
C EOR ON SCR6, I.E. END OF HC FOR A GIVEN CARD TYPE IN THIS SUBCASE.
C IF OTHER CARD TYPES EXIST IN THIS SUBCASE, THEY ARE IN SUBSEQUENT
C RECORDS. ADD RESULTS TO PREVIOUS ONES
C
   30 JCOUNT=0
   35 CALL READ (*50,*30,SCR6,ID,2,0,NWDS)
      NWORDS=3*ID(2)
      CALL FREAD(SCR6,HC,NWORDS,0)
C
C ADD TO PREVIOUS HC FOR THIS ELEMENT- ALL ELEMENTS SHOULD BE  ON SCR6
C IN SAME ORDER IN EVERY RECORD
C
      NJ=NEXTZ+JCOUNT-1
      DO 40 I=1,NWORDS
      Z(NJ+I)=Z(NJ+I)+HC(I)
   40 CONTINUE
      JCOUNT=JCOUNT+NWORDS
      IF((.NOT.INCORE).AND.JCOUNT.EQ.INWORD)GO TO 90
      GO TO 35
C
C INFO WILL NOT FIT IN CORE - SPILL LOGIC
C
   80 INCORE=.FALSE.
   90 CALL FWDREC (*1002,SCR6)
C
C SKIP APPROPRIATE NUMBER OF WORDS IN THIS RECORD TO ACCOUNT FOR
C THE PORTION OF THIS RECORD PREVIOUSLY READ
C
   95 CALL READ (*50,*1003,SCR6,ID,-NSKIP1,0,NWDS)
      GO TO 30
C
C
C DONE FOR THIS SUBCASE. PACK RESULTS. CLOSE SCR6 AND REOPEN TO WRITE
C NEXT SUBCASE (IF ALL DATA CAN FIT INTO CORE)
C
   50 IF(INCORE)GO TO 57
C
C SPILL LOGIC-PACK OUT INWORD WORDS. THEN REWIND  SCRL AND SKIP DOWN
C AS NECESSARY
C
      IF(.NOT.BLDP)CALL BLDPK(1,1,SCR6,0,0)
      BLDP=.TRUE.
      DO 55 K=1,INWORD
      A(1)=Z(NEXTZ+K-1)
      IROW=IN+K
      CALL ZBLPKI
   55 CONTINUE
      IF(EOR)GO TO 58
C
      IN=IN+INWORD
      CALL REWIND(SCR6)
      CALL FWDREC (*1002,SCR6)
      NSKIP=NSKIP-2
      NSKIP1=NSKIP
      GO TO 5
C
   57 CALL CLOSE(SCR6,1)
      JJ=ICOUNT
      MCBH(3)=JJ
      CALL PACK(Z(NEXTZ),HCCENS,MCBH)
      GO TO 70
C
C DONE FOR THIS SUBCASE (SPILL LOGIC)
C
   58 CALL CLOSE(SCR6,1)
      MCBH(3)=ICOUNT
      CALL BLDPKN(SCR6,0,MCBH)
      GO TO 70
C
C
C PACK A COLUMN OF ZEROS CORRESPONDING TO REMFLUX
C
   60 MCBH(3)=KCOUNT
      CALL BLDPK(1,1,HCCENS,0,0)
      CALL BLDPKN(HCCENS,0,MCBH)
C
   70 CALL WRTTRL(MCBH)
      IF(ITYPE.EQ.24)GO TO 75
C
C CHECK ON COUNT CONSISTENCY
C
      IF(INCORE)GO TO 75
      IF(ICOUNT.NE.KCOUNT)GO TO 500
C
   75 CALL GOPEN(SCR6,Z(LCORE+1),1)
      RETURN
C
  500 WRITE(IOUT,501)
  501 FORMAT(58H0***SYSTEM FATAL ERROR,LOGIC ERROR,COUNTS ARE OFF IN HCC
     1OM)
      CALL MESAGE(-61,0,0)
C
 1002 CALL MESAGE(-2,SCR6,NAM)
 1003 CALL MESAGE(-3,SCR6,NAM)
      RETURN
      END

      FUNCTION ITCODE (ITEMX)
C
C     THE FUNCTION RETURNS AN INTEGER CODE NUMBER FOR ITEM.  THE CODE
C     NUMBER IS USED IN UPDATING THE MDI.  IF AN INCORRECT ITEM NAME IS
C     USED, THE VALUE RETURNED WILL BE -1.
C
      COMMON /ITEMDT/ NITEM,ITEM(7,1)
      COMMON /SYS   / SYS(5),IFRST
C
      DO 10 I = 1,NITEM
      IF (ITEMX .EQ. ITEM(1,I)) GO TO 20
   10 CONTINUE
C
C     INVALID ITEM - RETURN -1
C
      ITCODE = -1
      RETURN
C
C     ITEM FOUND - RETURN MDI POSITION POINTER
C
   20 ITCODE = I + IFRST - 1
      RETURN
      END

      SUBROUTINE CRIGGP (N23)
C
C     ******************************************************************
C                                                                      *
C     THIS SUBROUTINE GENERATES COEFFICIENTS FOR RIGID ELEMENTS        *
C     FOR USE BY SUBROUTINE GP4.  THE DATA SO GENERATED IS             *
C     COMPATIBLE WITH MPC SET DATA.                                    *
C                                                                      *
C     (MODIFIED BY G.CHAN/SPERRY TO REDUCE EXCESSIVE OPENINGS,         *
C     CLOSINGS, AND READINGS OF THE BGPDT FILE (IN 2ND METHOD).        *
C     WITHOUT THIS MODIFICATION, A PROBLEM OF 2000 RIGID ELEMENTS,     *
C     FOR EXAMPLE, WOULD REQUIRE MORE THAN 10,000 OPENS AND 10,000     *
C     CLOSES AND OVER 10 MILLION CALLS TO SUBROUTINE READ   10/86)     *
C                                                                      *
C     (MODIFIED AGAIN BY G.CHAN/UNISYS TO INCLUDE CRROD, CRBAR, CRBE1, *
C     CRBE2, CRBE3, CRTRPLT, AND CRSPLINE RIGID ELEMENTS    11/88)     *
C                                                                      *
C     ******************************************************************
C
C     EXTERNAL          ORF    ,LSHIFT
      LOGICAL           AGAIN  ,GENRE  ,L38    ,DEBUG
C     INTEGER           ORF    ,LSHIFT
      INTEGER           GEOMP  ,BGPDT  ,CSTM   ,RGT    ,SCR1       ,
     1                  BUF(20),MASK16 ,GPOINT ,Z      ,FLAG       ,
     2                  FILE   ,RET    ,RET1   ,IC(1)  ,MCODE(2)   ,
     3                  BUF1   ,BUF2   ,BUF3   ,BUF4
      INTEGER           CRIGDR(2),CRIGD1(2)    ,CRIGD2(2),CRIGD3(2),
     1                  CRTRPT(2),CRSPLI(2)    ,CRROD(2) ,CRBAR(2) ,
     2                  CRBE1(2) ,CRBE2(2)     ,CRBE3(2)
CWKBR 8/94 SUN  INTEGER           RDREW    ,CLRSEW
      INTEGER           RDREW
      DOUBLE PRECISION  DZ(1)
      DIMENSION         RZ(1)  ,NAME(2),INDCMP(6)
      DIMENSION         A(36)  ,B(6)   ,IB(6)  ,C(18)
      CHARACTER         UFM*23 ,UWM*25 ,UIM*29
      COMMON /XMSSG /   UFM    ,UWM    ,UIM
      COMMON /MACHIN/   MACH   ,IHALF  ,JHALF
      COMMON /ZZZZZZ/   Z(1)
      COMMON /GP4FIL/   GEOMP  ,BGPDT  ,CSTM   ,RGT    ,SCR1
      COMMON /GP4PRM/   BUF    ,BUF1   ,BUF2   ,BUF3   ,BUF4   ,KNKL1  ,
     1                  MASK16 ,NOGO   ,GPOINT ,KN
      COMMON /NAMES /   RD     ,RDREW  ,WRT    ,WRTREW ,CLSREW
      COMMON /SYSTEM/   KSYSTM(55)
      EQUIVALENCE      (Z(1),RZ(1),DZ(1))
      EQUIVALENCE      (IC(1)     ,C(1) )
      EQUIVALENCE      (KSYSTM(2) , NOUT)
      EQUIVALENCE      (KSYSTM(55),IPREC)
      DATA    CRIGD1/  5310,   53/,
     1        CRIGD2/  5410,   54/,
     2        CRIGD3/  8310,   83/,
     3        CRIGDR/  8210,   82/,
     4        CRROD /  6510,   65/,
     5        CRBAR /  6610,   66/,
     6        CRTRPT/  6710,   67/,
     7        CRBE1 /  6810,   68/,
     8        CRBE2 /  6910,   69/,
     9        CRBE3 /  7010,   70/,
     O        CRSPLI/  7110,   71/
      DATA    NAME  /  4HCRIG,2HGP/
      DATA    MSET  /  4HMSET    /
      DATA    A     /  36*0.     /
      DATA    DEBUG /  .FALSE.   /
      DATA    L38   /  .FALSE.   /
C
C
C     ****************************************************************
C      OPEN CORE -
C                                        ALLOCATED BY
C     !<--- ALLOCATED BY GP4 --->!<------- CRIGGP -   --------->!
C     +--------+--------+------+-+----+-----+------   ----+-----+-----+
C     ! EQEXIN ! EQEXIN !SORTED!U!CSTM!BGPDT!   ...       ! DEP ! GINO!
C     !1ST REC !2ND REC ! SIL  !S!    !     !             ! SIL !BFFRS!
C     +--------+--------+------+-+----+-----+------   ----+-----+-----+
C      1      KN       KM        /    /    / \_KNKL1      /     /
C                            KNKL2  KNKL3 KNKL4         MU   BUF4
C
C      OPEN CORE FORMAT, STARTS WITH Z(KNKL2)
C      (KNKL2 = INITIAL VALUE OF KNKL1)
C
C      NUMBER OF WORDS                 CONTENTS
C
C           NCSTM    ***     COORDINATE SYSTEM TRANSFORMATION TABLE
C           NBGPDT   ***     BASIC GRID POINT DEFINITION TABLE
C                    *       (ONLY IF ENOUGH OPEN CORE SPACE AVAILABLE)
C                    ***     SIL 1   ***
C                    *       SIL 2     *
C             6      *       SIL 3     *  INDEPENDENT GRID POINT
C                    *       SIL 4     *
C                    *       SIL 5     *
C                    ***     SIL 6   ***
C                    ***     SIL 1          ***             ***
C                    *       DEGREE OF FREEDOM*               *
C                    *       INTERNAL INDEX   *               *
C                    *       SIL 2            *               *
C                    *       DEGREE OF FREEDOM*  FIRST DEPEND.*  ALL
C                    *       INTERNAL INDEX   *  GRID POINT   *  DEPEND.
C           3*MDEP   *           .            *               *  GRID
C                    *           .            *               *  POINTS
C                    *       SIL 6            *               *
C                    *       DEGREE OF FREEDOM*               *
C                    ***     INTERNAL INDEX ***             ***
C                    ***     INDEPENDENT GRID POINT BGPDT TABLE
C             4      *          WORD 1     COORDINATE SYSTEM ID-INTEGER
C                    ***        WORD 2-4 = X, Y, Z, IN BASIC SYSTEM-REAL
C          4*MDBGP   ***     DEPENDENT GRID POINT BGPDT TABLE
C                    ***
C         36*MDBGP   *       ROW STORED GG MATRIX (SINGLE PRECISION)
C                    ***     36 ELEMENTS * NO. DEPEND. GRID PT.
C          9*IPREC   ***     INDEPEND. GRID PT TRANSFORMATION MAT.-REAL
C          9*IPREC   ***     DEPEND. GRID PT TRANSFORMATION MATRIX-REAL
C         36*IPREC   ***     GG MATRIX  -  REAL  36 ELEMENTS
C                    ***          .        ***
C                    *            .          *
C                    *  AVAILABLE OPEN CORE  *
C                    *            .          *
C                    *            .          *
C                    ***          .        ***
C                    ***
C           MDEP     *       DEPENDENT SILS
C                    ***
C                    ***
C          BUFFERS   *       GINO BUFFERS
C                    ***
C
C     *************************************************************
C     NOTE  IPREC = 1   SINGLE PRECISION
C           IPREC = 2   DOUBLE PRECISION
C           MDEP  =     NUMBER DEPENDENT SILS
C           MDBGP =     NUMBER DEPENDENT GRID POINTS
C     *************************************************************
C
      MASK15= JHALF/2
      KN2   = KN/2
      NCSTM = 0
      KNKL2 = KNKL1
      KIOLD = 0
      IBUF1 =-99
      AGAIN = .FALSE.
      CALL SSWTCH (20,J)
      IF (J .EQ. 1) DEBUG =.TRUE.
      CALL SSWTCH (38,J)
      IF (J .EQ. 1) L38 =.TRUE.
      CALL PAGE2(-4)
      WRITE  (NOUT,200) UIM
  200 FORMAT (A29,' 3113, RIGID ELEMENTS ARE BEING PROCESSED IN GP4',/)
C
C     OPEN CSTM AND READ INTO CORE, FROM Z(KNKL2) THRU Z(KNKL3)
C
      LEFT = BUF4 - KNKL1
      FILE = CSTM
      CALL OPEN (*300,CSTM,Z(BUF2),RDREW)
      CALL SKPREC (CSTM,1)
      CALL READ (*1230,*270,CSTM,Z(KNKL2),LEFT,1,NCSTM)
      GO TO 1280
C
C     IF CORE WAS FILLED WITHOUT HITTING AN EOR, CALL MESAGE
C
  270 IF (IPREC .EQ. 1) CALL PRETRS (Z(KNKL1),NCSTM)
      IF (IPREC .EQ. 2) CALL PRETRD (Z(KNKL1),NCSTM)
      CALL CLOSE (CSTM,CLSREW)
      GO TO 300
C
C     IF THERE IS ENOUGH CORE AVAILABLE, OPEN AND READ BGPDT INTO OPEN
C     CORE, FROM Z(KNKL3+1) THRU Z(KNKL4), CLOSE BGPDT FILE, AND RESET
C     VARIOUS POINTERS FOR BUILDING UP RGT DATA. (AGAIN=.FALSE.)
C     THIS METHOD USES ONLY ONE OPEN, ONE CLOSE, AND ONE READ.
C
C     HOWEVER, IF THERE IS NOT ENOUGH CORE FOR BGPDT DATA AND THE NEEDED
C     SPACE FOR BUILDING UP RGT DATA, SET AGAIN TO .TRUE., AND REPEAT
C     DATA PROCESSING BY READING DATA DIRECTLY OFF THE BGPDT FILE EACH
C     TIME WHEN THE BGPDT DATA IS NEEDED.   THIS SECOND METHOD USES ONLY
C     ONE OPEN, ONE CLOSE, AND MULTIPLE READS.
C
C     IN THE SECOND METHOD, TWO POINTERS, KIOLD AND KINEW, ARE USED TO
C     COMPUTE PRECISELY WHERE TO READ DATA OFF THE BGPDT FILE
C
  290 AGAIN = .TRUE.
      CALL WRITE  (RGT,0,0,1)
      CALL BCKREC (RGT)
      KNKL3 = 0
      KNKL1 = KNKL2
      NBGPDT= KNKL1 + NCSTM
      CALL CLOSE (BGPDT,CLSREW)
  300 FILE  = BGPDT
      CALL OPEN (*1210,BGPDT,Z(BUF2),RDREW)
      CALL FWDREC (*1240,BGPDT)
      KIOLD = 0
C
C     CALCULATE STARTING POINT
C     AND READ BGPDT INTO OPEN CORE
C
      KNKL1 = KNKL1 + NCSTM
      IF (AGAIN) GO TO 310
      KNKL3 = KNKL1
      CALL READ (*1230,*310,BGPDT,Z(KNKL3+1),BUF4-KNKL3,1,NBGPDT)
      IMHERE = 305
      IF (DEBUG) WRITE (NOUT,1255) IMHERE
      KNKL3 = 0
      NBGPDT= KNKL1
      AGAIN = .TRUE.
      CALL BCKREC (BGPDT)
  310 IF (.NOT.AGAIN) CALL CLOSE (BGPDT,CLSREW)
      KNKL4 = KNKL3 + NBGPDT
      KNKL1 = KNKL4 + 1
      MU    = BUF4  - 1
      IRDG  = 0
      ITYPE = 0
      GENRE = .FALSE.
C
C     *************************************************************
C
C     CRIGD1, CRIDG2, AND CRBE2 RIGID ELEMENTS ARE PROCESSED HERE
C
C     *************************************************************
C
C     LOCATE CRIGD1 DATA IN THE INPUT FILE
C
      FILE = GEOMP
      CALL LOCATE (*500,Z(BUF1),CRIGD1,FLAG)
      IRDG = 1
      GO TO 1000
C
C     LOCATE CRIGD2 DATA ON INPUT FILE
C
  500 FILE = GEOMP
      CALL LOCATE (*600,Z(BUF1),CRIGD2,FLAG)
      IRDG = 2
      IMHERE = 500
      IF (DEBUG) WRITE (NOUT,4400) IMHERE
      GO TO 1000
C
C     LOCATE CRBE2 DATA ON INPUT FILE
C
  600 FILE = GEOMP
      CALL LOCATE (*4000,Z(BUF1),CRBE2,FLAG)
      IRDG = 3
      IMHERE = 600
      IF (DEBUG) WRITE (NOUT,4400) IMHERE
C
 1000 CONTINUE
      IF (DEBUG) WRITE (NOUT,1005) IRDG
 1005 FORMAT ('0 IRDG/CRIGGP =',I6)
C
C     READ ELEMENT ID AND INDEPENDENT GRID POINT NUMBER
C
 1730 IFILE = GEOMP
      NWDS  = 2
      GO TO 1734
 1732 IFILE = SCR1
      NWDS  = 9
 1734 FILE  = IFILE
      CALL READ (*1230,*1240,IFILE,BUF,NWDS,0,FLAG)
      IF ((DEBUG.OR.L38) .AND. BUF(1).NE.IBUF1) WRITE (NOUT,1735) BUF(1)
 1735 FORMAT (5X,'ELEMENT',I8,' IS BEING PROCESSED')
      IF (.NOT.GENRE) GO TO 1739
      IBUF1 = BUF(1)
C
C     SET UP INDEPENDENT D.O.F. FOR THE GENERAL RIGID ELEMENTS,
C     CRIGID3 AND CRBE1, AND ALSO THE CRBAR AND CRTRPLT ELEMENTS
C     WHICH WERE CONVERTED TO CRIGID3 FORMAT BY IFS3P
C
      DO 1736 I = 1,6
      INDCMP(I) = BUF(I+2)
 1736 CONTINUE
      ITYPE = BUF(9)
      IF (ITYPE .NE. 0) GO TO 1739
      DO 1737 I = 1,36
 1737 A(I) = 0.0
      INDEX = 0
      ILAST = 0
      DO 1738 I = 1,6
      IF (INDCMP(I) .NE. I) GO TO 1738
      J    = 6*ILAST + I
      A(J) = 1.0
      ILAST= ILAST + 1
 1738 CONTINUE
      NIND = ILAST
C
 1739 ASSIGN 1740 TO RET
      ASSIGN 1743 TO RET1
      IDR   = BUF(1)
      GPOINT= BUF(2)
      NTYPE = 1
      GO TO 7060
C
C     STORE SIL FOR INDEPENDENT DEGREES OF FREEDOM
C
 1740 DO 1742 I=1,6
      Z(KNKL1+I-1) = GPOINT + I - 1
 1742 CONTINUE
 1743 KINEW = K - 2*KN
      ASSIGN 1750 TO RET
      ASSIGN 1745 TO RET1
C
C     READ DEPENDENT GRID POINTS
C
      J = KNKL1 + 3
      MDBGP = 0
      MDEP  = 0
 1745 CALL READ (*1230,*1240,IFILE,BUF,7,0,FLAG)
      IF (BUF(1) .EQ. -1) GO TO 1760
      MDBGP = MDBGP + 1
      GPOINT= BUF(1)
      NTYPE = 2
      GO TO 7060
 1750 CONTINUE
      IF (NOGO .NE. 0) GO TO 1745
C
C     STORE DEPENDENT GRID POINT SIL, DOF, AND INTERNAL INDEX
C
      DO 1756 I = 1,6
      IF (BUF(I+1) .EQ. 0) GO TO 1756
      J = J + 3
      L = J
      Z(L) = GPOINT + I - 1
      Z(L+1) = I
      Z(L+2) = K - 2*KN
      MDEP   = MDEP + 1
 1756 CONTINUE
      GO TO 1745
C
C     HERE WHEN ALL DEPENDENT GRID POINTS FOR AN ELEMENT HAVE BEEN READ
C
 1760 MORE = 0
      I = KNKL1 + 6 + 3*MDEP + 4 + 4*MDBGP + (9+9+36*MDBGP+36)*IPREC
C
C     CHECK FOR OPEN CORE AVAILABILITY
C
      IMHERE = 176
      IF (I      .GE. MU) GO TO 1250
      IF (BUF(2) .EQ.  0) MORE = 1
      IF (NOGO   .NE.  0) GO TO 3645
C
C     LOCATE DATA IN BGPDT FOR INDEPENDENT GRID POINT
C
      IOPEN = KNKL1 + 6 + 3*MDEP
      IF (AGAIN) GO TO 1761
      KI4 = KNKL3 + KINEW*4
      IF (KI4 .GT. KNKL4) GO TO 1290
      Z(IOPEN    ) = Z(KI4 -3)
      Z(IOPEN + 1) = Z(KI4 -2)
      Z(IOPEN + 2) = Z(KI4 -1)
      Z(IOPEN + 3) = Z(KI4   )
      GO TO 1763
 1761 FILE = BGPDT
      IF (KINEW .GT. KIOLD) GO TO 1762
      CALL BCKREC (BGPDT)
      KIOLD = 0
 1762 KI4 = (KINEW-KIOLD-1) * 4
      IF (KI4 .GT. 0) CALL READ (*1230,*1240,BGPDT,BUF,-KI4,0,FLAG)
      CALL READ (*1230,*1240,BGPDT,BUF,4,0,FLAG)
      Z(IOPEN    ) = BUF(1)
      Z(IOPEN + 1) = BUF(2)
      Z(IOPEN + 2) = BUF(3)
      Z(IOPEN + 3) = BUF(4)
 1763 KIOLD = KINEW
C
C     SORT DEPENDENT DEGREE OF FREEDOM LIST ON BGPDT REFERENCE NUMBER
C
      I = MDEP*3
      CALL SORT (0,0,3,3,Z(KNKL1+6),I)
C
      J = 0
      M = 0
      INDX  = KNKL1 + 5
      INDXX = KNKL1 + 6 + 3*MDEP + 4
      DO 1768 I = 1,MDEP
      K = INDX + 3*I
      KINEW = Z(K)
      IF (KIOLD .EQ. KINEW) GO TO 1767
      J = J + 1
C
C     READ GRID POINT INFORMATION
C
      M = M + 1
      N = INDXX + (M-1)*4
      IF (AGAIN) GO TO 1764
      KI4 = KNKL3 + KINEW*4
      IF (KI4 .GT. KNKL4) GO TO 1290
      Z(N    ) = Z(KI4 -3)
      Z(N + 1) = Z(KI4 -2)
      Z(N + 2) = Z(KI4 -1)
      Z(N + 3) = Z(KI4   )
      GO TO 1766
 1764 FILE = BGPDT
      IF (KINEW .GT. KIOLD) GO TO 1765
      CALL BCKREC (BGPDT)
      KIOLD = 0
 1765 KI4 = (KINEW-KIOLD-1)*4
      IF (KI4 .GT. 0) CALL READ (*1230,*1240,BGPDT,BUF,-KI4,0,FLAG)
      CALL READ (*1230,*1240,BGPDT,BUF,4,0,FLAG)
      Z(N    ) = BUF(1)
      Z(N + 1) = BUF(2)
      Z(N + 2) = BUF(3)
      Z(N + 3) = BUF(4)
 1766 KIOLD = KINEW
 1767 Z(K)  = J
 1768 CONTINUE
C
      IF (IPREC .EQ. 2) GO TO  3200
C
C     FORM REFERENCE GRID POINT TRANSFORMATION MATRIX
C
      IBA = KNKL1 + 6 + 3*MDEP
      ITA = IBA + 4 + 4*MDBGP + 36*MDBGP
      IF (Z(IBA) .NE. 0) CALL TRANSS (RZ(IBA),RZ(ITA))
C
C     PREPARE POINTERS USED TO FORM THE G MATRIX
C
      ITB = ITA + 9
      ITC = ITB - 1
C
C     SET INDEXES FOR TRANSFORMATION MATRIXES AND GG MATRIXES TO
C     FIRST ELEMENT - 1 FOR SUBROUTINE FORMGG
C
      ITA = ITA - 1
      IG  = INDXX + 4*MDBGP - 1
      IGG = IG + (36*MDBGP) + 9 + 9
      INDX= KNKL1 + 3
      M   = -1
C
C     BEGIN LOOP TO FORM THE G MATRIX
C
      DO 3050 I = 1,MDEP
      K  = INDX + I*3
      MM = Z(K+2)
      IF (MM .EQ. M) GO TO 3030
      IBB = INDXX + (MM-1)*4
C
C     FORM DEPENDENT DEGREE OF FREEDOM TRANSFORMATION MATRIX
C
      IF (Z(IBB) .NE. 0) CALL TRANSS (RZ(IBB),RZ(ITB))
C
C     FORM THE GG MATRIX
C
      CALL FORMGG (IGG,ITA,ITC,IBA,IBB)
 3030 CONTINUE
C
C     SELECT PROPER ROW BASED ON COMPONENT NUMBER AND STORE IN G
C     ACCORDING TO PARTITIONING VECTOR OF REFERENCE GRID POINT.
C
      M  = MM
      MM = Z(K+1)
      DO 3040 IJ = 1,6
      INDXXX = IGG + (MM-1)*6 + IJ
      RZ(IG+IJ) = RZ(INDXXX)
 3040 CONTINUE
      IG = IG + 6
 3050 CONTINUE
      GO TO 3300
C
C     FORM REFERENCE GRID POINT TRANSFORMATION MATRIX (DOUBLE PREC.)
C
 3200 IBASE = (KNKL1 + 6 + 3*MDEP + 4 + 4*MDBGP + 36*MDBGP) / 2 + 1
      IBA = KNKL1 + 6 + 3*MDEP
      ITA = IBASE
      IF (Z(IBA) .NE. 0) CALL TRANSD (RZ(IBA),DZ(ITA))
C
C     PREPARE POINTERS USED TO FORM THE G MATRIX
C
      ITB = ITA + 9
      ITC = ITB - 1
C
C     SET INDEXES FOR TRANSFORMATION MATRIXES AND GG MATRIXES TO
C     FIRST ELEMENT - 1 FOR SUBROUTINE FORMGG
C
      ITA = ITA - 1
      IG  = INDXX + 4*MDBGP - 1
      IGG = IBASE + 9 + 9 - 1
      INDX= KNKL1 + 3
      M   = -1
C
C     BEGIN LOOP TO FORM THE G MATRIX
C
      DO 3250 I = 1, MDEP
      K  = INDX  + I*3
      MM = Z(K+2)
      IF (MM .EQ. M) GO TO 3230
      IBB = INDXX + (MM-1)*4
C
C     FORM DEPENDENT DEGREE OF FREEDOM TRANSFORMATION MATRIX
C
      IF (Z(IBB) .NE. 0) CALL TRANSD (RZ(IBB),DZ(ITB))
C
C     FORM THE GG MATRIX
C
      CALL FORMG2 (IGG,ITA,ITC,IBA,IBB)
 3230 CONTINUE
C
C     SELECT PROPER ROW BASED ON COMPONENT NUMBER AND STORE IN G
C
      M  = MM
      MM = Z(K+1)
      DO 3240 IJ = 1,6
      INDXXX = IGG + (MM-1)*6 + IJ
      RZ(IG+IJ) = DZ (INDXXX)
 3240 CONTINUE
      IG = IG + 6
 3250 CONTINUE
 3300 IG = INDXX + 4*MDBGP - 1
C
C     WRITE THE CODED COLUMN-ROW NUMBERS AND ELEMENTS OF THE GM
C     MATRIX ON RGT FILE SO AS TO MAKE RIGID ELEMENT DATA
C     COMPATIBLE WITH MPC SET DATA
C     (REVISED 7/86, CODED COLUMN-ROW NUMBERS ARE NOT USED HERE.
C     THEY WILL BE RE-CODED IN GP4 IF NEEDED)
C
      K  = 0
      IF (GENRE .AND. ITYPE.EQ.0) GO TO 3380
      MU = MU - MDEP
C
C     TEST FOR OPEN CORE AVAILABILITY
C
      IMHERE = 3380
      IF (IOPEN .GE. MU) GO TO 1250
 3380 CONTINUE
      INDX = KNKL1 + 3
      DO 3640 I = 1, MDEP
      IF (GENRE .AND. ITYPE.EQ.0) GO TO 3390
      Z(MU+I) = Z(INDX + I*3)
 3390 KROW    = Z(INDX + I*3)
      MCODE(2)= KROW
      IF (KROW .GT. MASK15) N23 = 3
      DO 3620 J = 1,6
      K    = K+1
      KCOL = Z(KNKL1+J-1)
      MCODE(1) = KCOL
      IF (KCOL .GT. MASK15) N23 = 3
      IF (GENRE .AND. ITYPE.EQ.0) GO TO 3440
      RZ(IG+K) = -RZ(IG+K)
      IF (GENRE .AND. ITYPE.EQ.1) GO TO 3400
      CALL WRITE (RGT,MCODE,2,0)
      CALL WRITE (RGT,RZ(IG+K),1,0)
      GO TO 3620
 3400 IC(J) = IB(J)
      IF (IC(J) .GT. MASK15) N23 = 3
      GO TO 3620
 3440 IF (INDEX  .GE. NIND) GO TO 3460
      IF (INDCMP(J) .NE. J) GO TO 3460
      INDEX = INDEX + 1
      IB(INDEX) = KCOL
 3460 A(6*ILAST+J) = RZ(IG+K)
 3620 CONTINUE
      IF (   .NOT.GENRE) GO TO 3635
      IF (ITYPE .EQ. -1) GO TO 3635
      IF (ITYPE .EQ.  1) GO TO 3625
      INDEX = INDEX + 1
      IB(INDEX) = KROW
      ILAST = ILAST + 1
      GO TO 3640
 3625 CALL GMMATS (RZ(IG+K-5),1,6,0,A,6,6,0,B)
      DO 3630 J = 1, 6
      CALL WRITE (RGT,IC(J),1,0)
      CALL WRITE (RGT,KROW ,1,0)
      CALL WRITE (RGT,B(J) ,1,0)
 3630 CONTINUE
 3635 MCODE(1) = KROW
      COEFF = 1.0
      CALL WRITE (RGT,MCODE,2,0)
      CALL WRITE (RGT,COEFF,1,0)
 3640 CONTINUE
      IF (.NOT.GENRE .OR. ITYPE.NE.0) GO TO 3645
C     NO NEED TO COMPUTE DETERMINANT SINCE IT IS NOT USED SUBSEQUENTLY.
      ISING = -1
      CALL INVERS (6,A,6,B,0,DET,ISING,C)
C
C     CHECK TO SEE IF GENERAL RIGID ELEMENTS (CRIGD3, CRBE1, CRBAR, AND
C     CRTRPLT) ARE PROPERLY DEFINED
C
      IF (ISING .NE. 2) GO TO 3645
      WRITE  (NOUT,6130) UFM,IDR
      NOGO = 1
 3645 IF (MORE .EQ.0) GO TO 3650
      IF (.NOT.GENRE) GO TO 1730
      GO TO 1732
C
 3650 IF (GENRE) CALL CLOSE (SCR1,1)
      IF (IRDG .LE. 8) GO TO (500,600,4000,4100,4200,4300,5200), IRDG
      CALL ERRTRC ('CRIGGP  ',3655)
C
C     ******************************************************************
C
C     CRBAR, CRTRPLT, CRIGD3, AND CRBE1 ELEMENTS ARE PROCESSED HERE.
C     THE CRBAR AND CRTRPLT HAVE THE SAME DATA FORMAT AS THAT OF THE
C     GENERAL RIGID ELEMENT CRIGD3.
C     CRBE1 WAS MADE EXACTLY SAME AS CRIGD3 IN IFS3P ROUTINE.
C
C     ******************************************************************
C
C     LOCATE CRBAR DATA ON INPUT FILE
C
 4000 FILE = GEOMP
      IMHERE = 4000
      IF (DEBUG) WRITE (NOUT,4400) IMHERE
      CALL LOCATE (*4100,Z(BUF1),CRBAR,FLAG)
      IRDG = 4
      GO TO 5000
C
C     LOCATE CRTRPLT DATA ON INPUT FILE
C
 4100 FILE = GEOMP
      IMHERE = 4100
      IF (DEBUG) WRITE (NOUT,4400) IMHERE
      CALL LOCATE (*4200,Z(BUF1),CRTRPT,FLAG)
      IRDG = 5
      GO TO 5000
C
C     LOCATE CRIGD3 DATA ON INPUT FILE
C
 4200 CALL LOCATE (*4300,Z(BUF1),CRIGD3,FLAG)
      IMHERE = 4200
      IF (DEBUG) WRITE (NOUT,4400) IMHERE
      IRDG = 6
      GO TO 5000
C
C     LOCATE CRBE1 DATA ON INPUT FILE
C
 4300 CALL LOCATE (*5200,Z(BUF1),CRBE1,FLAG)
      IMHERE = 4300
      IF (DEBUG) WRITE (NOUT,4400) IMHERE
 4400 FORMAT ('0  I AM HERE/CRIGGP =',I6)
      IRDG  = 7
C
 5000 GENRE = .TRUE.
      MORE  = 1
      IF (DEBUG) WRITE (NOUT,1005) IRDG
C
C     OPEN SCR1 FILE TO WRITE
C
      CALL OPEN (*1210,SCR1,Z(BUF4),1)
C
C     READ ELEMENT ID
C
 5010 FILE = GEOMP
      CALL READ (*1230,*1240,GEOMP,BUF,1,0,FLAG)
      IDR = BUF(1)
C
C     READ INDEPENDENT GRID POINTS AND THEIR COMPONENT NUMBERS
C
      N = 0
      J = KNKL1
 5020 CALL READ (*1230,*1240,GEOMP,BUF,1,0,FLAG)
      IF (BUF(1) .EQ. MSET) GO TO 5040
      N = N + 7
      Z(J) = BUF(1)
      CALL READ (*1230,*1240,GEOMP,Z(J+1),6,0,FLAG)
      J = J + 7
      GO TO 5020
 5040 NIND = N/7
C
C     CHECK TO SEE IF THE NUMBER OF INDEPENDENT GRID POINTS
C     IS MORE THAN ONE AND SET TYPE FLAG
C
      ITYPE = -1
      IF (NIND .EQ. 1) GO TO 5050
      ITYPE = 0
      J = KNKL1
C
C     WRITE THE INDEPENDENT GRID POINTS AS A PSEUDO CRIGD2 ELEMENT
C
C
C     WRITE THE ELEMENT ID
C
      CALL WRITE (SCR1,IDR,1,0)
C
C     WRITE THE FIRST INDEPENDENT GRID POINT AND ITS COMPONENT NUMBERS
C
      CALL WRITE (SCR1,Z(J),7,0)
C
C     WRITE THE TYPE FLAG
C
      CALL WRITE (SCR1,ITYPE,1,0)
C
C     WRITE THE REMAINING INDEPENDENT GRID POINTS AND THEIR
C     COMPONENT NUMBERS
C
      J = J + 7
      N = N - 7
      CALL WRITE (SCR1,Z(J),N,0)
      DO 5045 L =1,7
 5045 BUF(L) = -1
      BUF(2) =  0
      CALL WRITE (SCR1,BUF,7,0)
      ITYPE = 1
C
C     WRITE THE FIRST INDEPENDENT GRID POINT AND ALL THE
C     DEPENDENT GRID POINTS AS A PSEUDO CRIGD2 ELEMENT
C
 5050 J = KNKL1
C
C     WRITE THE ELEMENT ID
C
      CALL WRITE (SCR1,IDR,1,0)
C
C     WRITE THE FIRST INDEPENDENT GRID POINT AND ITS COMPONENT NUMBERS
C
      CALL WRITE (SCR1,Z(J),7,0)
C
C     WRITE THE TYPE FLAG
C
      CALL WRITE (SCR1,ITYPE,1,0)
C
C     PROCESS THE DEPENDENT GRID POINTS AND THEIR COMPONENT NUMBERS
C
 5060 CALL READ (*1230,*1240,GEOMP,BUF,7,0,FLAG)
      IF (BUF(1) .EQ. -1) GO TO 5070
      CALL WRITE (SCR1,BUF,7,0)
      GO TO 5060
 5070 IF (BUF(2) .EQ. -1) MORE = 0
      DO 5080 L = 1,7
 5080 BUF(L) = -1
      BUF(2) =  0
      IF (MORE .EQ. 0) BUF(2) = -1
      CALL WRITE (SCR1,BUF,7,0)
      IF (MORE .EQ. 1) GO TO 5010
      CALL WRITE (SCR1,0,0,1)
C
C     CLOSE SCR1, AND OPEN IT FOR READ
C
      CALL CLOSE (SCR1,1)
      CALL OPEN (*1210,SCR1,Z(BUF4),0)
      IMHERE = 5085
      IF (DEBUG) WRITE (NOUT,4400) IMHERE
      GO TO 1732
C
C     *********************************************************
C
C     CRBE3 AND CRSPLINE ELEMENTS ARE PROCESSED HERE
C
C     *********************************************************
C
C     LOCATE CRBE3 DATA ON INPUT FILE
C
 5200 FILE = GEOMP
      IRDG = 8
      CALL LOCATE (*5300,Z(BUF1),CRBE3,FLAG)
      IMHERE = 5200
      IF (DEBUG) WRITE (NOUT,4400) IMHERE
      GO TO 5400
C
C     LOCATE CRSPLINE DATA ON INPUT FILE
C
 5300 FILE = GEOMP
      IRDG = 9
      CALL LOCATE (*5800,Z(BUF1),CRSPLI,FLAG)
      IMHERE = 530
      IF (DEBUG) WRITE (NOUT,4400) IMHERE
C
 5400 J = IRDG-7
      IF (DEBUG) WRITE (NOUT,1005) IRDG
      IF (IPREC .EQ. 1) CALL CRSPLS (*5600,J,MU,KNKL3+1,Z(KNKL1),AGAIN,
     1    N23)
      IF (IPREC .EQ. 2) CALL CRSPLD (*5600,J,MU,KNKL3+1,Z(KNKL1),AGAIN,
     1    N23)
      GO TO (5300,5800), J
 5600 WRITE  (NOUT,5610) UFM
 5610 FORMAT (A23,' 8, INSUFFICIENT CORE FOR CRBE3 OR CRSPLINE RIGID ',
     1       'ELEMENT COMPUTATION')
      NOGO = 1
C
C     *********************************************************
C
C     CRIGDR AND CRROD (RIGID ROD ELEMENTS) ARE PROCESSED HERE
C     (CRROD DATA FORMAT WAS CONVERTED TO CRIGDR FORMAT IN IFS3P)
C
C     *********************************************************
C
C     LOCATE CRIGDR AND CRROD DATA ON INPUT FILE
C
 5800 GENRE= .FALSE.
      NWDS = 4
      FILE = GEOMP
      CALL LOCATE (*5900,Z(BUF1),CRIGDR,FLAG)
      IRDG = 10
      IMHERE = 5800
      IF (DEBUG) WRITE (NOUT,4400) IMHERE
      GO TO 6000
 5900 FILE = GEOMP
      IRDG = 11
      CALL LOCATE (*7000,Z(BUF1),CRROD,FLAG)
      IMHERE = 5900
      IF (DEBUG) WRITE (NOUT,4400) IMHERE
C
C     ***************************************************************
C
C                  OPEN CORE FORMAT FOR RIGID ROD
C
C      NUMBER OF WORDS                 CONTENTS
C
C           NCSTM    ***     COORDINATE SYSTEM TRANSFORMATION TABLE
C           NBGPDT   ***     BASIC GRIP POINT DEFINITION TABLE
C                    ***     SIL 1 ***
C             3      *       SIL 2   * INDEPENDENT GRID POINT
C                    ***     SIL 3 ***
C                    ***     INDEPENDENT GRID POINT BGPDT TABLE
C             4      *          WORD 1     COORDINATE SYSTEM ID-INTEGER
C                    ***        WORD 2-4   X, Y, Z, IN BASIC SYSTEM-REAL
C                    ***     SIL 1 ***
C             3      *       SIL 2   * DEPENDENT GRID POINT
C                    ***     SIL 3 ***
C             4      ***     DEPENDENT GRID POINT BGPDT TABLE
C                    ***                   ***
C                    *                       *
C                    *  AVAILABLE OPEN CORE  *
C                    *                       *
C                    *                       *
C                    ***                   ***
C                    ***
C           MDEP     *       DEPENDENT SILS
C                    ***
C                    ***
C          BUFFERS   *       GINO BUFFERS
C                    ***
C
C     **************************************************************
C
C
C     CHECK AVAILABILITY OF CORE
C
 6000 CONTINUE
      IF (DEBUG) WRITE (NOUT,1005) IRDG
      ITEST  = KNKL1 + 14 + 27*IPREC + 2
      IF (ITEST .GE. MU) GO TO 1250
C
C     READ ELEMENT DATA
C
 6010 CALL READ (*1230,*7000,GEOMP,BUF,NWDS,0,FLAG)
      IDR   = BUF(1)
      IDEPGP= BUF(3)
      ICOMP = BUF(4)
C
C     PROCESS THE INDEPENDENT GRID POINT
C
      FILE = BGPDT
      J = KNKL1
      GPOINT = BUF(2)
      ASSIGN 6020 TO RET
      ASSIGN 6050 TO RET1
      GO TO 7060
C
C     STORE SIL VALUES
C
 6020 IF (NOGO  .EQ. 0) GO TO 6030
      IF (J .EQ. KNKL1) GO TO 6050
      GO TO 6010
 6030 Z(J  ) = GPOINT
      Z(J+1) = GPOINT + 1
      Z(J+2) = GPOINT + 2
      KINEW  = K - 2*KN
C
C     LOCATE DATA IN BGPDT
C
      IF (AGAIN) GO TO 6035
      KI4 = KNKL3 + KINEW*4
      IF (KI4 .GT. KNKL4) GO TO 1290
      Z(J+3) = Z(KI4-3)
      Z(J+4) = Z(KI4-2)
      Z(J+5) = Z(KI4-1)
      Z(J+6) = Z(KI4  )
      GO TO 6045
 6035 IF (KINEW .GT. KIOLD) GO TO 6040
      CALL BCKREC (BGPDT)
      KIOLD = 0
 6040 KI4 = (KINEW-KIOLD-1) * 4
      IF (KI4 .GT. 0) CALL READ (*1230,*1240,BGPDT,BUF,-KI4,0,FLAG)
      CALL READ (*1230,*1240,BGPDT,BUF,4,0,FLAG)
C
C     STORE BASIC GRID POINT DATA
C
      Z(J+3) = BUF(1)
      Z(J+4) = BUF(2)
      Z(J+5) = BUF(3)
      Z(J+6) = BUF(4)
 6045 KIOLD  = KINEW
      IF (J .NE. KNKL1) GO TO 6060
C
C     PROCESS THE DEPENDENT GRID POINT
C
 6050 J = J + 7
      GPOINT = IDEPGP
      ASSIGN 6010 TO RET1
      GO TO 7060
 6060 IF (IPREC .EQ. 1) CALL CRDRD  (*6065,*6125,MU,ICOMP,N23)
      IF (IPREC .EQ. 2) CALL CRDRD2 (*6065,*6125,MU,ICOMP,N23)
      GO TO 6010
 6065 WRITE  (NOUT,6070) UFM,IDR
 6070 FORMAT (A23,' 3133, RIGID ELEMENT',I9,' HAS ZERO LENGTH')
      NOGO = 1
      GO TO 6010
 6125 WRITE  (NOUT,6130) UFM,IDR
 6130 FORMAT (A23,' 3134, RIGID ELEMENT',I9,' IS NOT PROPERLY DEFINED')
      NOGO = 1
      GO TO 6010
C
 7000 IF (IRDG .EQ. 10) GO TO 5900
C
      IF (AGAIN) CALL CLOSE (BGPDT,CLSREW)
      IF (NOGO .NE. 0) CALL MESAGE (-61,0,NAME)
      CALL WRITE (RGT,0,0,1)
C
C     WRITE A LIST OF DEPENDENT SIL VALUES FOR RIGID ELEMENTS ONTO THE
C     RGT IN SORTED FORM
C
      JRIGID = MU + 1
      M = BUF4 - JRIGID
      CALL SORT  (0,0,1,1,Z(JRIGID),M)
      CALL WRITE (RGT,Z(JRIGID),M,1)
      J = BUF4-1
      IF (DEBUG) WRITE (NOUT,7010) (Z(I),I=JRIGID,J)
 7010 FORMAT (/,'  CRIGGP/@7010  DEPEND.SIL LIST:',/,(5X,10I7))
      KNKL1 = KNKL2
C
C     CLOSE RGT FILE AND RETURN
C
      CALL CLOSE (RGT,CLSREW)
      RETURN
C
C     **********************************************************
C
C     INTERNAL SUBROUTINE TO PERFORM BINARY SEARCH IN EQEXIN
C     AND CONVERT THE EXTERNAL NUMBER TO A SIL VALUE
C
 7060 KLO = 0
      KHI = KN2
      LASTK = 0
 7070 K= (KLO+KHI+1)/2
      IF (LASTK .EQ. K) GO TO 1350
      LASTK = K
      IF (GPOINT-Z(2*K-1)) 7090,7150,7100
 7090 KHI= K
      GO TO 7070
 7100 KLO= K
      GO TO 7070
 7150 K = Z(2*K) + 2*KN
      GPOINT= Z(K)
      GO TO RET, (1740,1750,6020)
C
C     **********************************************************
C
C     FATAL ERROR MESSAGES
C
 1210 J= -1
      GO TO 1260
 1230 J= -2
      GO TO 1260
 1240 J= -3
      GO TO 1260
 1250 IF (AGAIN) GO TO 1280
      CALL CLOSE (SCR1,CLSREW)
      WRITE  (NOUT,1255) IMHERE
 1255 FORMAT (///,' *** CRIGGP/GP4 NEEDS MORE OPEN CORE.',
     1        /5X,' CRIGGP REVERTED TO USE SLOW METHOD',I9,//)
      GO TO 290
 1260 CALL MESAGE (J,FILE,NAME)
 1280 J= -8
      GO TO 1260
 1290 WRITE  (NOUT,1300) KNKL1,KNKL3,KNKL4,KI4
 1300 FORMAT (//,' *** SYSTEM FATAL ERROR IN CRIGGP',4I10)
      J =-61
      GO TO 1260
 1330 NOGO= 1
      CALL MESAGE (30,N,BUF)
      GO TO RET1, (1743,1745,6010,6050)
 1350 IF (GENRE .AND. ITYPE.EQ.1 .AND. NTYPE.EQ.1) GO TO 1743
      BUF(1) = GPOINT
      BUF(2) = IRDG*100000000 + IDR
      N = 151
      GO TO 1330
      END

      SUBROUTINE CNORM1 (X,N)
C
C     CNORM1 WILL SEARCH A VECTOR FOR THE LARGEST VALUE AND NORMALIZE
C     THE VECTOR TO LARGEST ELEMENT EQUAL TO ONE
C
      INTEGER          NAME(2)
      DOUBLE PRECISION X(1),DUM,MAX,DIV(2)
      COMMON /SYSTEM/  IBUF,NOUT
      DATA    NAME  /  4HCNOR,4HM1   /
C
      NN   = N + N
      MAX  = 0.D0
      INDEX= 0
      DO 10 I = 1,NN,2
      DUM = X(I)*X(I) + X(I+1)*X(I+1)
      IF (DUM .LE. MAX) GO TO 10
      MAX   = DUM
      INDEX = I
   10 CONTINUE
      IF (INDEX .EQ. 0) GO TO 30
      DIV(1) = X(INDEX  )
      DIV(2) = X(INDEX+1)
      MAX    = DIV(1)*DIV(1) + DIV(2)*DIV(2)
      DO 20 I = 1,NN,2
      DUM    = (X(I)*DIV(1) + X(I+1)*DIV(2))/MAX
      X(I+1) = (X(I+1)*DIV(1) - X(I)*DIV(2))/MAX
   20 X(I)   = DUM
      RETURN
C
   30 WRITE  (NOUT,40)
   40 FORMAT (//5X,37HCNORM1 RECEIVED A VECTOR OF ALL ZEROS)
      CALL MESAGE (-37,0,NAME)
      RETURN
      END

      SUBROUTINE SGENM (NTYPE,IFILE,SFILE,OFILE,ICODE,OCODE,CTYPES,
     1                  CTYPEO)
C
C     THIS SUBROUTINE MERGES CONVERTED SUBSTRUCTURING DATA WITH EXISTING
C     NASTRAN DATA
C
C     INPUTS
C     NTYPE  - NUMBER OF DIFFERENT SUBSTRUCTURING CARDS
C     IFILE  - INPUT FILE NAME
C     SFILE  - SCRATCH FILE NAME
C     OFILE  - OUTPUT FILE NAME
C     ICODE  - LOCATE CODES FOR INPUT CARD TYPES
C     OCODE  - LOCATE CODES FOR OUTPUT CARD TYPES
C     CTYPES - BCD NAMES OF SUBSTRUCTURING CARDS
C     CTYPEO - BCD NAMES OF CORRESPONDING NASTRAN CARDS
C
      INTEGER         SFILE,OFILE,ICODE(4,1),OCODE(4,1),CTYPES(2,8),
     1                CTYPEO(2,8),BUF1,BUF2,BUF3,Z,SYSBUF,OUTT,CARD(3),
     2                NLIMIT(3),SUBNAM(2)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /BLANK / IDRY,NAME(2)
      COMMON /SGENCM/ NONO,NSS,IPTR,BUF1,BUF2,BUF3,NZ
      COMMON /ZZZZZZ/ Z(1)
      COMMON /SYSTEM/ SYSBUF,OUTT
      DATA    NLIMIT/ 3*2147483647 /
      DATA    SUBNAM/ 4HSGEN,4HM    /
C
C     OPEN FILES
C
      CALL GOPEN (IFILE,Z(BUF1),0)
      CALL GOPEN (SFILE,Z(BUF2),0)
      CALL GOPEN (OFILE,Z(BUF3),1)
C
C     READ HEADER FROM IFILE - DETERMINE IF SUBSTRUCTURING OR NASTRAN
C     CARD
C
      FILE = IFILE
   10 CALL READ (*1002,*1003,IFILE,CARD,3,0,IDX)
      IF (CARD(1) .EQ. NLIMIT(1)) GO TO 70
      DO 20 I = 1,NTYPE
      IF (ICODE(1,I).NE.CARD(1) .OR. ICODE(2,I).NE.CARD(2)) GO TO 20
C
C     SKIP RECORD IF SUBSTRUCTURING CARD
C
      CALL FWDREC (*70,IFILE)
      GO TO 10
   20 CONTINUE
      DO 30 I = 1,NTYPE
      IF (OCODE(1,I).NE.CARD(1) .OR. OCODE(2,I).NE.CARD(2)) GO TO 30
C
C     FATAL ERROR IF BOTH SUBSTRUCTURING AND NASTRAN CARDS
C
      IF (ICODE(4,I) .EQ. 0) GO TO 40
      NONO = 1
      J = OCODE(4,I)
      WRITE (OUTT,6330) UFM,NAME,(CTYPES(K,J),K=1,2),(CTYPEO(K,J),K=1,2)
      CALL FWDREC (*70,IFILE)
      GO TO 10
   30 CONTINUE
C
C     COPY RECORD FROM IFILE TO OUTPUT
C
   40 CALL WRITE (OFILE,CARD,3,0)
   50 CALL READ  (*1002,*60,IFILE,Z,NZ,0,NWDS)
      CALL WRITE (OFILE,Z,NZ,0)
      GO TO 50
   60 CALL WRITE (OFILE,Z,NWDS,1)
      GO TO 10
C
C     COPY RECORD FROM SFILE TO OUTPUT
C
   70 I1 = 1
   80 DO 90 I = I1,NTYPE
      IF (ICODE(4,I) .EQ. 1) GO TO 100
   90 CONTINUE
      GO TO 150
  100 CALL FREAD (SFILE,CARD,3,0)
      CALL WRITE (OFILE,OCODE(1,I),3,0)
      FILE = SFILE
  110 CALL READ  (*1002,*120,SFILE,Z,NZ,0,NWDS)
      CALL WRITE (OFILE,Z,NZ,0)
      GO TO 110
  120 CALL WRITE (OFILE,Z,NWDS,1)
      I1 = I + 1
      GO TO 80
C
C     CLOSE FILES
C
  150 CALL WRITE (OFILE,NLIMIT,3,1)
      CALL CLOSE (IFILE,1)
      CALL CLOSE (SFILE,1)
      CALL CLOSE (OFILE,1)
      RETURN
C
C     ERRORS
C
 1002 M = -2
      GO TO 2000
 1003 M = -3
 2000 CALL MESAGE (M,FILE,SUBNAM)
      RETURN
C
 6330 FORMAT (A23,' 6330, SOLUTION SUBSTRUCTURE ',2A4,3H - ,2A4,' AND ',
     1       2A4,' CARDS CANNOT BE USED TOGETHER.', /30X,
     2       'USE EITHER ONE, BUT NOT BOTH.')
      END

      SUBROUTINE DSMG1
C
C     THIS ROUTINE IS THE DRIVER FOR THE DIFFERENTIAL STIFFNESS MATRIX
C     GENERATOR MODULE OF THE NASTRAN SYSTEM.  SUBROUTINE DS1 APPENDS
C     TEMPERATURE, ELEMENT DEFORMATION AND DISPLACEMENT INFORMATION TO
C     THE ECPT DATA BLOCK AND A SCRATCH FILE, ECPTDS, OF THIS MERGED
C     INFORMATION IS CREATED.  SUBROUTINE DS1A IS STRUCTURED IDENTICALLY
C     TO SMA1A. IT READS THE ECPTDS FILE AND CREATES A SECOND ORDER
C     APPROXIMATION TO THE KGG, WHICH IS CALLED KDGG.
C
C     DMAP CALL -
C
C     DSMG1    CASECC,GPTT,SIL,EDT,UGV,CSTM,MPT,ECPT,GPCT,DIT/KDGG/
C
      CALL DS1 (IARG)
      IF (IARG .GT. 0) GO TO 10
C
C     ECPTDS IS EMPTY. WRITE MESSAGE AND CALL EXIT.
C
      CALL MESAGE (30,81,0)
      CALL MESAGE (-61,0,0)
   10 CALL DS1A
      RETURN
      END

      SUBROUTINE T3BMGD (IERR,SHEART,IPT,IORDER,EGPDT,DGPTH,AIC,TH,
     1                  DETJAC,SHP,BTERMS,BMATRX)
C
C     B-MATRIX GENERATOR ROUTINE FOR TRIA3 ELEMENTS
C
C     DOUBLE PRECISION ROUTINE TO GENERATE A 9XNDOF B-MATRIX AT A
C     GIVEN INTEGRATION POINT, USING THE DERIVATIVES OF THE 2-D SHAPE
C     FUNCTIONS.
C     OPTIONALLY, AN 8XNDOF B-MATRIX IS CONSTRUCTED AND/OR SHEAR TERMS
C     MAY BE DROPPED ALTOGETHER, YIELDING 6XNDOF MATRIX.
C     FOR STRESS RECOVERY, THE EVALUATION POINTS ARE AT THE ELEMENT
C     INTERIOR POINTS RATHER THAN ON THE EDGES.
C     THE CONTENTS OF /TERMS/ ARE USED TO CONSTRUCT THE B-MATRIX
C     ACCORDING TO THE BEHAVIORAL REQUIREMENTS OF THE ELEMENT.
C
C
C     INPUT :
C           IPT    - POINTER TO THE CURVILNEAR COORDINATES
C           SHEART - LOGICAL INDICATING THE REQUIREMENT FOR OUT-OF-PLANE
C                    SHEAR TERMS
C           IORDER - ARRAY OF INTERNAL SEQUENCE OF NODES
C           EGPDT  - GRID POINT DATA IN THE ELEMENT COORD. SYSTEM
C           DGPTH  - NODAL THICKNESSES
C           AIC    - TRANSFORMATION TO RELIEVE GEOMETRY BIAS
C     OUTPUT:
C           IERR   - ERROR FLAG
C           TH     - THICKNESS AT THE INTEG. PT.
C           DETJAC - DETERMINANT OF JACOBIAN AT THE INTEG. PT.
C           SHP    - ARRAY OF REORDERED SHAPE FUNCTIONS
C           BTERMS - DERIVATIVES WRT THE PHYSICAL COORDINATES
C           BMATRX - STRAIN-DISPLACEMENT RELATIONSHIP
C
C
      LOGICAL          SHEART,MEMBRN,BENDNG,SHRFLX,MBCOUP,NORPTH
      INTEGER          IORDER(3)
      DOUBLE PRECISION EGPDT(4,1),DGPTH(1),AIC(1),TH,DETJAC,BMATRX(1),
     1                 BTERMS(1),SHP(3),DSHPX(3),DSHPE(3),TSHP(3),
     2                 TDSHPX(3),TDSHPE(3),VI(2),VJ(2),JACOB(4),EPS,
     3                 PTINT(2,7),TRC(2,3),XSI,XSII,ETA,ETAI,PSI,PSII,
     4                 DNX,DNY,SHPF
      COMMON /TERMS /  MEMBRN,BENDNG,SHRFLX,MBCOUP,NORPTH
      DATA    EPS   /  1.0D-13 /
      DATA    PTINT /  0.5D0, 0.0D0, 0.5D0, 0.5D0, 0.0D0, 0.5D0,
     1                 0.333333333333333D0, 0.333333333333333D0,
     2                 0.166666666666667D0, 0.166666666666667D0,
     3                 0.166666666666667D0, 0.666666666666667D0,
     4                 0.666666666666667D0, 0.166666666666667D0/
      DATA    TRC   /  0.0D0, 0.0D0, 1.0D0, 0.0D0, 0.0D0, 1.0D0/
C
C     INITIALIZE
C
      IERR = 0
      NNODE= 3
      ND1  = NNODE*6
      ND2  = ND1*2
      ND3  = ND1*3
      ND4  = ND1*4
      ND5  = ND1*5
      ND6  = ND1*6
      ND7  = ND1*7
      ND8  = ND1*8
      ND9  = ND1*9
C
      DO 30 I = 1,6
      BTERMS(I) = 0.0D0
   30 CONTINUE
      DO 40 I = 1,ND9
      BMATRX(I) = 0.0D0
   40 CONTINUE
C
C     CALCULATE THE SHAPE FUNCTIONS AND THEIR DERIVATIVES, THEN SORT
C     THEM.
C
      XSI = PTINT(1,IPT)
      ETA = PTINT(2,IPT)
      PSI = 1.0D0 - XSI - ETA
C
      DO 50 I = 1,3
      XSII = TRC(1,I)
      ETAI = TRC(2,I)
      PSII = 1.0D0 - XSII - ETAI
C
      SHP(I)   = XSI*XSII + ETA*ETAI + PSI*PSII
      DSHPX(I) = XSII - PSII
      DSHPE(I) = ETAI - PSII
   50 CONTINUE
C
      DO 60 I  = 1,NNODE
      TSHP(I)  = SHP(I)
      TDSHPX(I)= DSHPX(I)
      TDSHPE(I)= DSHPE(I)
   60 CONTINUE
C
      DO 70 I  = 1,NNODE
      KK       = IORDER(I)
      SHP(I)   = TSHP(KK)
      DSHPX(I) = TDSHPX(KK)
      DSHPE(I) = TDSHPE(KK)
   70 CONTINUE
C
C     COMPUTE THE ELEMENT THICKNESS
C
      TH = 0.0D0
      DO 80 ISH = 1,NNODE
      TH = TH + SHP(ISH)*DGPTH(ISH)
   80 CONTINUE
C
C     SET UP THE JACOBIAN
C
      DO 90 I = 1,2
      VI(I) = 0.0D0
      VJ(I) = 0.0D0
      II = I + 1
      DO 90 J = 1,NNODE
      VI(I) = VI(I) + EGPDT(II,J)*DSHPX(J)
      VJ(I) = VJ(I) + EGPDT(II,J)*DSHPE(J)
   90 CONTINUE
C
C     INVERT THE JACOBIAN
C
      DETJAC = VI(1)*VJ(2) - VI(2)*VJ(1)
      IF (DETJAC .GE. EPS) GO TO 100
      IERR = 1
      RETURN
C
  100 JACOB(1) =  VJ(2)/DETJAC
      JACOB(2) = -VI(2)/DETJAC
      JACOB(3) = -VJ(1)/DETJAC
      JACOB(4) =  VI(1)/DETJAC
C
      DO 110 I = 1,4
      IF (DABS(JACOB(I)) .LT. EPS) JACOB(I) = 0.0D0
  110 CONTINUE
C
      IPT1 = IPT*2 - 1
      I71  = IPT1
      I72  = IPT1 + 1
      I81  = IPT1 + 6
      I82  = IPT1 + 7
      I91  = IPT1 + 12
      I92  = IPT1 + 13
C
C     LOOP OVER NODES AND BUILD PARTITIONS OF B-MATRIX
C
      IP = 0
      DO 150 I = 1,NNODE
C
C     CALCULATE DERIVATIVES WRT THE PHYSICAL COORDINATES.
C
      DNX  = JACOB(1)*DSHPX(I) + JACOB(2)*DSHPE(I)
      DNY  = JACOB(3)*DSHPX(I) + JACOB(4)*DSHPE(I)
      SHPF = SHP(I)
C
      BTERMS(I      ) = DNX
      BTERMS(I+NNODE) = DNY
C
      IF (.NOT.MEMBRN) GO TO 120
C
C     ROW 1
C
      BMATRX(IP+1) = DNX
C
C     ROW 2
C
      BMATRX(IP+2+ND1) = DNY
C
C     ROW 3
C
      BMATRX(IP+1+ND2) = DNY
      BMATRX(IP+2+ND2) = DNX
C
  120 IF (.NOT.BENDNG) GO TO 150
C
C     ROW 4
C
      BMATRX(IP+5+ND3) = -DNX
C
C     ROW 5
C
      BMATRX(IP+4+ND4) =  DNY
C
C     ROW 6
C
      BMATRX(IP+5+ND5) = -DNY
      BMATRX(IP+4+ND5) =  DNX
C
      IF (.NOT.SHEART) GO TO 150
      IF (IPT .LT.  4) GO TO 130
C
C     8-ROW MATRIX
C
C     ROW 7
C
      BMATRX(IP+3+ND6) =  DNY
      BMATRX(IP+4+ND6) = -SHPF
C
C     ROW 8
C
      BMATRX(IP+3+ND7) =  DNX
      BMATRX(IP+5+ND7) =  SHPF
      GO TO 150
C
C     9-ROW MATRIX
C
C     ROW 7
C
  130 BMATRX(IP+3+ND6) =  AIC(I71)*DNY + AIC(I72)*DNX
      BMATRX(IP+4+ND6) = -AIC(I71)*SHPF
      BMATRX(IP+5+ND6) =  AIC(I72)*SHPF
C
C     ROW 8
C
      BMATRX(IP+3+ND7) =  AIC(I81)*DNY + AIC(I82)*DNX
      BMATRX(IP+4+ND7) = -AIC(I81)*SHPF
      BMATRX(IP+5+ND7) =  AIC(I82)*SHPF
C
C     ROW 9
C
      BMATRX(IP+3+ND8) =  AIC(I91)*DNY + AIC(I92)*DNX
      BMATRX(IP+4+ND8) = -AIC(I91)*SHPF
      BMATRX(IP+5+ND8) =  AIC(I92)*SHPF
C
  150 IP = IP + 6
C
      RETURN
      END

      SUBROUTINE CYCT2
C
C     CYCT2 TRANSFORMS CYCLIC PROBLEMS BETWEEN SOLUTION VARIABLES AND
C     THE CYCLIC COMPONENTS
C
C     INPUT DATA BLOCKS - CYCD    CYCLIC COMPONENT CONSTRAINT DATA
C     INPUT DATA BLOCKS - KAA     MATRIX - STIFFNESS    MAY BE PURGED
C     INPUT DATA BLOCKS - MAA     MATRIX - MASS         MAY BE PURGED
C     INPUT DATA BLOCKS - V1I     MATRIX - LOAD OR DISP MAY BE PURGED
C     INPUT DATA BLOCKS - V2I     MATRIX - EIGENVECTORS MAY BE PURGED
C     INPUT DATA BLOCKS - LAMX    TABLE  - EIGENVALUES MUST EXIS IF V2I
C
C     OUTPUT DATA BLOCKS- KXX,MXX,V1O,V2O,LAMA
C
C     PARAMETERS - CDIR           INPUT,  BCD, (FORE OR BACK)
C     PARAMETERS - NSEG           INPUT,  INTEGER,NUMBER OF SEGS
C     PARAMETERS - KSEG           INPUT,  INTEGER,CYCLIC INDEX
C     PARAMETERS - CYCSEQ         INPUT,  INTEGER,ALTERNATE=-1
C     PARAMETERS - NLOAD          INPUT,  INTEGER,NUMBER OF LOAD COND
C     PARAMETERS - NOGO           OUTPUT, INTEGER,-1 = ERROR
C
C     SCRATCH FILES (6)
C
C     DEFINITION OF VARIABLES
C     LUA       LENGT OF A SET
C     ITYP      TYPE (0=ROT, 1=DIH)
C     IDIR      DIRECTION (0=FORE, 1=BACK)
C     IFLAG     1 IMPLIES KSEG = 0 OR 2*KSEG = NSEG
C     IPASS     1 IMPLIES SECOND PASS TRROUGH CYCD
C     IGC       1 IMPLIES FIRST MATRIX TYPE (GC FOR ROT)
C     ICS       1 IMPLIES FIRST COLUMN TYPE (COSINE FOR ROT)
C
C
      INTEGER         CYCD,KAA,V1I,V2I,LAMX,V1O,V2O,CDIR(2),CYCSEQ,
     1                SYSBUF,FILE,NAME(2),SCR1,SCR2,SCR3,MCB(14),FORE,
     2                IZ(1),MCB1(7),MCB2(7),SCR4,SCR5,SCR6
      DOUBLE PRECISION DZ,ARG,PI,COS,SIN,CONSTD
      COMMON /UNPAKX/ ITC,IIK,JJK,INCR1
      COMMON /ZBLPKX/ DZ(2),III
      COMMON /PACKX / ITA,ITB,II,JJ,INCR
      COMMON /ZZZZZZ/ Z(1)
      COMMON /SYSTEM/ KSYSTM(65)
      COMMON /CONDAD/ CONSTD(5)
      COMMON /BLANK / CDIR,NSEG,KSEG,CYCSEQ,NLOAD,NOGO
      EQUIVALENCE     (KSYSTM(1),SYSBUF),(KSYSTM(55),IPREC),
     1                (CONSTD(1),PI    ),(KSEG,KINDEX),
     2                (Z(1),IZ(1)),(MCB(1),MCB1(1)),(MCB(8),MCB2(1))
      DATA    CYCD,KAA,MAA,V1I,V2I,LAMX,KXX,MXX,V1O,V2O,LAMA/
     1        101 ,102,103,104,105,106 ,201,202,203,204,205 /
      DATA    SCR1,SCR2,SCR3,SCR4,SCR5,SCR6  /
     1        301 ,302 ,303 ,304 ,305 ,306   /
      DATA    NAME,FORE /4HCYCT,4H2   ,4HFORE/
C
C
CIBMNB 6/93
      CYCD = 101
      KAA  = 102
      MAA  = 103
      V1I  = 104
      V2I  = 105
      LAMX = 106
      KXX  = 201
      MXX  = 202
      V1O  = 203
      V2O  = 204
      LAMA = 205
      SCR1 = 301
      SCR2 = 302
      SCR3 = 303
      SCR4 = 304
      SCR5 = 305
      SCR6 = 306
CIBMNE
      NZ    = KORSZ(IZ)
      NOGO  = 1
      V1I   = 104
      V1O   = 203
      SCR3  = 303
      MCB(1)= CYCD
      CALL RDTRL (MCB)
      LUA   = MCB(3)
      ITYP  = MCB(2) - 1
      IDIR  = 1
      IF (CDIR(1) .EQ. FORE) IDIR = 0
      NX    = NZ
      IBUF1 = NZ - SYSBUF + 1
      IBUF2 = IBUF1 - SYSBUF
      IBUF3 = IBUF2 - SYSBUF
      NZ    = IBUF3 - 1
      IF (2*KSEG.GT.NSEG .OR. KSEG.LT.0 .OR. NSEG.LE.0) GO TO 640
      J = 2
      IF (MCB(5) .EQ. 4) J = 4
      IF (NZ .LT. J*LUA) CALL MESAGE (-8,0,NAME)
C
C     PRODUCE GC AND GS MATRICES (ON SCR1 AND SCR2)
C
      ARG = FLOAT(KSEG)/FLOAT(NSEG)
      ARG = ARG*PI
      IF (ITYP .EQ. 0) ARG = 2.0D0*ARG
C
C     BRING IN CYCD
C
      CALL GOPEN (CYCD,IZ(IBUF1),0)
      CALL FREAD (CYCD,IZ(1),LUA,1)
      CALL CLOSE (CYCD,1)
      CALL GOPEN (SCR1,IZ(IBUF1),1)
C
C     COMPUTE COS AND SIN
C
      IF (ITYP .EQ. 0) GO TO 30
      IF (KSEG .EQ. 0) GO TO 10
      IF (2*KSEG .EQ. NSEG) GO TO 20
      GO TO 50
   10 COS = 1.0
      SIN = 0.0
      GO TO 60
   20 COS = 0.0
      SIN = 1.0
      GO TO 60
   30 IF (KSEG   .EQ.    0) GO TO 10
      IF (2*KSEG .EQ. NSEG) GO TO 40
      GO TO 50
   40 COS = -1.0
      SIN = 0.0
      GO TO 60
   50 CONTINUE
      COS = DCOS(ARG)
      SIN = DSIN(ARG)
   60 CONTINUE
      IFLAG = 0
      IF (KSEG.EQ.0 .OR. 2*KSEG.EQ.NSEG) IFLAG = 1
      IF (ITYP.NE.0 .OR. IFLAG.EQ.0) CALL GOPEN (SCR2,IZ(IBUF2),1)
      ITA = 2
      ITB = 1
      INCR= 1
      II  = 1
      JJ  = LUA
      CALL MAKMCB (MCB1,SCR1,LUA,2,IPREC)
      CALL MAKMCB (MCB2,SCR2,LUA,2,IPREC)
      CALL WRTTRL (MCB1)
      CALL WRTTRL (MCB2)
      IPASS = 0
      IF (ITYP .NE. 0) GO TO 200
C
C     BUILD ROTATIONAL MATRICES
C
   70 L  = 1
   80 IF (IZ(L) .LT. 0) GO TO 190
      MM = IZ(L)
      IP = 1
C
C     FIRST BUILD GC
C
      IGC  = 1
      FILE = SCR1
C
C     FIRST DO COSINE
C
      ICS = 1
      IF (IPASS .NE. 0) ICS = 0
C
C     BUILD COLUMN
C
   90 CONTINUE
      CALL BLDPK (2,IPREC,FILE,0,0)
      IF (MM) 190,100,110
C
C     INTERIOR POINT
C
  100 CONTINUE
      IF ((ICS.EQ.0 .AND. IGC.EQ.1) .OR. (ICS.EQ.1 .AND.  IGC.EQ.0))
     1   GO TO 170
      III   = L
      DZ(1) = 1.0
      CALL ZBLPKI
      GO TO 170
C
C     SIDE 1 POINTS
C
  110 IF (ICS .NE. 0) GO TO 140
C
C     SINE COLUMN
C
      IF (IGC .NE. 0) GO TO 160
C
C     MATRIX IS GS
C
  120 IF (L .GT. MM) GO TO 130
      DZ(1) = 1.0
      III   = L
      CALL ZBLPKI
      DZ(1) = COS
      III   = MM
      CALL ZBLPKI
      GO TO 170
  130 III   = MM
      DZ(1) = COS
      CALL ZBLPKI
      III   = L
      DZ(1) = 1.0
      CALL ZBLPKI
      GO TO 170
C
C     COSINE COLUMN
C
  140 IF (IGC .NE. 0) GO TO 150
C
C     MATRIX IS GS
C
      III   = MM
      DZ(1) =-SIN
      CALL ZBLPKI
      GO TO 170
C
C     MATRIX IS GC
C
  150 GO TO 120
C
C     MATRIX IS GC
C
  160 III   = MM
      DZ(1) = SIN
      CALL ZBLPKI
      GO TO 170
  170 CONTINUE
      CALL BLDPKN (FILE,0,MCB(IP))
      IF (CYCSEQ .EQ. 1) GO TO 180
C
C     NOW DO SINE COLUMN
C
      IF (ICS   .EQ. 0) GO TO 180
      IF (IFLAG .EQ. 1) GO TO 190
      ICS = 0
      GO TO 90
C
C     NOW DO GS
C
  180 IF (IFLAG.EQ.1 .OR. IP.EQ.8) GO TO 190
      IP  = 8
      IGC = 0
      ICS = 1
      FILE = SCR2
      GO TO 90
C
C     CONSIDER NEXT CYCD VALUE
C
  190 L = L + 1
      IF (L .LE. LUA) GO TO 80
C
C     GONE THRU CYCD ONCE. DONE IF CYCSEQ = -1
C
      IF (CYCSEQ .EQ. -1) GO TO 400
C
C     MUST NOW DO SINE COLUMNS UNLESS IFLAG = 1
C
      IF (IPASS .EQ. 1) GO TO 400
      IF (IFLAG .EQ. 1) GO TO 400
      IPASS = 1
      GO TO 70
C
C     BUILD DIHEDRAL MATRICES
C
  200 IPASS = 0
  210 L     = 1
  220 IP    = 1
      IGC   = 1
      FILE  = SCR1
C
C     FIRST DO S COLUMN
C
      ICS = 1
      IF (IPASS .NE. 0) ICS = 0
      MM  = IZ(L)
      IF (MM.GT.0 .AND. IPASS.EQ.1) GO TO 390
  230 CONTINUE
      CALL BLDPK (2,IPREC,FILE,0,0)
      IF (MM .GT. 0) GO TO 280
C
C     INTERIOR POINT
C
      IF (ICS .NE. 0) GO TO 260
C
C     A COLUMN
C
      IF (IGC .NE. 0) GO TO 250
C
C     MATRIX IS GA  - COLUMN IS A
C
  240 DZ(1) = 1.0
      III = L
      CALL ZBLPKI
      GO TO 370
C
C     MATRIX IS GS - COLUMN IS A
C
  250 GO TO 370
C
C     SCOLUMN
C
  260 IF (IGC .NE. 0) GO TO 270
C
C     MATRIX IS GA - S COLUMN
C
      GO TO 370
C
C     MATRIX IS GS - COLUMN IS S
C
  270 GO TO 240
C
C     SIDE POINT
C
  280 IF (IGC .EQ. 0) GO TO 350
C
C     MATRIX IS GS
C
      GO TO (290,320,330,370), MM
  290 III   = L
  300 DZ(1) = COS
  310 CALL ZBLPKI
      GO TO 370
  320 III   = L
      DZ(1) =-SIN
      GO TO 310
  330 III   = L
  340 DZ(1) = 1.0
      GO TO 310
C
C     MATRIX IS GA
C
  350 III = L
      GO TO (360,300,370,340), MM
  360 DZ(1) = SIN
      GO TO 310
  370 CONTINUE
      CALL BLDPKN (FILE,0,MCB(IP))
      IF (CYCSEQ.EQ.1 .OR. MM.GT.0) GO TO 380
C
C     NOW DO A COLUMN
C
      IF (ICS .EQ. 0) GO TO 380
      ICS = 0
      GO TO 230
C
C     NOW DO GA
C
  380 IF (IP .EQ. 8) GO TO 390
      IP  = 8
      IGC = 0
      FILE= SCR2
      ICS = 1
      GO TO 230
C
C     CONSIDER NEXT CYCD VALUE
C
  390 L = L + 1
      IF (L .LE. LUA) GO TO 220
C
C     GONE THRU CYCD ONCE - DONE IF CYCSEQ = -1
C
      IF (CYCSEQ .EQ. -1) GO TO 400
C
C     NOW DO A COLUMNS
C
      IF (IPASS .EQ. 1) GO TO 400
      IPASS = 1
      GO TO 210
C
C     CLOSE UP SHOP
C
  400 CALL CLOSE (SCR1,1)
      CALL CLOSE (SCR2,1)
      CALL WRTTRL (MCB1)
      IF (IFLAG.EQ.0 .OR. ITYP.NE.0) CALL WRTTRL (MCB2)
      ITC = 1
      IIK = 1
      JJK = LUA
      INCR1 = 1
      IF (IDIR .NE. 0) GO TO 490
C
C     FORWARD TRANSFORMATIONS
C
C
C     TRANSFORM MATRICES
C
      CALL CYCT2A (KAA,KXX,SCR1,SCR2,SCR3,SCR4,SCR5)
      CALL CYCT2A (MAA,MXX,SCR1,SCR2,SCR3,SCR4,SCR5)
C
      MCB1(1) = KAA
      MCB2(1) = MAA
      CALL RDTRL (MCB1(1))
      CALL RDTRL (MCB2(1))
      IF (MCB1(5).GT.2 .OR.  MCB2(5).GT.2) GO TO 405
      IF (MCB1(4).NE.6 .AND. MCB2(4).NE.6) GO TO 405
      MCB1(1) = KXX
      MCB2(1) = MXX
      CALL RDTRL (MCB1(1))
      CALL RDTRL (MCB2(1))
      MCB1(4) = 6
      MCB2(4) = 6
      IF (MCB1(1) .GT. 0) CALL WRTTRL (MCB1(1))
      IF (MCB2(1) .GT. 0) CALL WRTTRL (MCB2(1))
C
C     TRANSFORM LOADS
C
  405 MCB(1) = V1I
      CALL RDTRL (MCB(1))
      IF (MCB(1) .LE. 0) GO TO 460
      ITC = MCB(5)
      IF (ITC.EQ.4 .AND. NZ.LT.4*LUA) CALL MESAGE (-8,0,NAME)
      CALL GOPEN (V1I,IZ(IBUF1),0)
      CALL GOPEN (SCR3 ,IZ(IBUF2),1)
      CALL GOPEN (SCR4,IZ(IBUF3),1)
C
C     COMPUTE NUMBER OF RECORDS TO SKIP
C
      CALL MAKMCB (MCB1,SCR3,LUA,2,MCB(5))
      CALL MAKMCB (MCB2,SCR4,LUA,2,MCB(5))
      IF (KSEG .EQ. 0) GO TO 420
      NSKIP = NLOAD*KSEG*(ITYP+1)*2 - NLOAD*(ITYP+1)
      FILE  = V1I
      DO 410 I = 1,NSKIP
      CALL FWDREC (*620,V1I)
  410 CONTINUE
  420 CONTINUE
      CALL CYCT2B (V1I,SCR3,NLOAD,IZ,MCB1)
      IF (ITYP  .EQ. 0) GO TO 430
      IF (IFLAG .NE. 0) GO TO 430
C
C     COPY - PCA
C
      DO 421 J = 1,NLOAD
      CALL FWDREC (*620,V1I)
  421 CONTINUE
      CALL CYCT2B (V1I,SCR3,NLOAD,IZ,MCB1)
C
C     NOW COPY ONTO PS
C
  430 IF (ITYP.EQ.0 .AND. IFLAG.NE.0) GO TO 440
      CALL CYCT2B (V1I,SCR4,NLOAD,IZ,MCB2)
      IF (IFLAG .NE. 0) GO TO 440
      IF (ITYP  .EQ. 0) GO TO 440
      CALL REWIND (V1I)
      CALL FWDREC (*620,V1I)
      NLPS = NSKIP + NLOAD
      DO 431 J = 1,NLPS
      CALL FWDREC (*620,V1I)
  431 CONTINUE
      ITC = -MCB(5)
      CALL CYCT2B (V1I,SCR4,NLOAD,IZ,MCB2)
      ITC = MCB(5)
C
C     DONE WITH COPY
C
  440 CALL CLOSE (V1I,1)
      CALL CLOSE (SCR3,1)
      CALL CLOSE (SCR4,1)
      CALL WRTTRL (MCB1)
      CALL WRTTRL (MCB2)
      IF (IFLAG.NE.0 .AND. ITYP.EQ.0) GO TO 450
      CALL SSG2B (SCR1,SCR3 ,0,SCR5,1,IPREC,1,V1O)
      CALL SSG2B (SCR2,SCR4,SCR5,V1O,1,IPREC,1,SCR3)
      GO TO 460
C
C     NO GS
C
  450 CALL SSG2B (SCR1,SCR3,0,V1O,1,IPREC,1,SCR5)
C
C     TRANSFORM EIGENVECTORS FORWARD
C
  460 IF (V1O .EQ. V2O) RETURN
      MCB(1) = V2I
      CALL RDTRL (MCB)
      IF (MCB(1) .LE. 0) RETURN
      ITC = MCB(5)
      IF (ITC.EQ.4 .AND. NZ.LT.4*LUA) CALL MESAGE (-8,0,NAME)
      IF (MOD(MCB(2),2).NE. 2) CALL MESAGE (-7,0,NAME)
      IF (IFLAG.NE.1 .OR. ITYP.NE.0) GO TO 470
C
C     IN = OUT
C
      V1O  = V2O
      SCR3 = V1I
      GO TO 450
  470 CALL GOPEN (V2I,IZ(IBUF1),0)
      CALL GOPEN (SCR3,IZ(IBUF2),1)
      CALL GOPEN (SCR4,IZ(IBUF3),1)
      NCOPY = MCB(2)
      CALL MAKMCB (MCB1,SCR3,LUA,2,MCB(5))
      CALL MAKMCB (MCB2,SCR4,LUA,2,MCB(5))
      DO 480 I = 1,NCOPY
      FILE = SCR3
      IP = 1
      IF (MOD(I,2) .EQ. 0) IP = 8
      IF (MOD(I,2) .EQ. 0) FILE = SCR4
      CALL CYCT2B (V2I,FILE,1,IZ,MCB(IP))
  480 CONTINUE
      V1O = V2O
      V1I = V2I
      GO TO 440
C
C     DIRECTION IS BACK
C
  490 CONTINUE
      MCB(1) = V1I
      CALL RDTRL (MCB)
      IF (MCB(1) .LE. 0) GO TO 560
      IKS = MCB(3)
      ITC = MCB(5)
      IF (ITC.EQ.4 .AND. NZ.LT.4*LUA) CALL MESAGE (-8,0,NAME)
C
C     POSITION V1O
C
      MCB(1) = V1O
      IF (KINDEX .EQ. 0) GO TO 495
      CALL RDTRL (MCB)
      IF (MCB(2) .GT. 0) GO TO 500
  495 CONTINUE
      CALL GOPEN  (V1O,IZ(IBUF1),1)
      CALL CLOSE  (V1O,2)
      CALL MAKMCB (MCB,V1O,LUA,2,MCB(5))
      CALL WRTTRL (MCB)
      GO TO 510
  500 CONTINUE
      CALL GOPEN  (V1O,IZ(IBUF1),0)
      CALL SKPFIL (V1O,+1)
      CALL SKPFIL (V1O,-1)
      CALL CLOSE  (V1O,2)
  510 CONTINUE
      IF (ITYP .EQ. 0) GO TO 550
C
C     DISTRIBUTE UX1 AND UX2 FOR MULTIPLYS
C
      IF (IFLAG .EQ. 1) GO TO 550
      CALL MAKMCB (MCB1,SCR3,IKS,2,MCB(5))
      CALL MAKMCB (MCB2,SCR4,IKS,2,MCB(5))
      CALL GOPEN  (V1I,IZ(IBUF1),0)
      CALL GOPEN  (SCR3,IZ(IBUF2),1)
      CALL GOPEN  (SCR4,IZ(IBUF3),1)
      CALL CYCT2B (V1I,SCR3,NLOAD,IZ(1),MCB1)
      CALL CYCT2B (V1I,SCR4,NLOAD,IZ(1),MCB2)
      CALL CLOSE  (SCR3,1)
      CALL WRTTRL (MCB1)
      CALL CLOSE  (SCR4,1)
      CALL WRTTRL (MCB2)
      CALL CLOSE  (V1I,1)
C
C     COMPUTE UCS
C
  520 CALL SSG2B  (SCR1,SCR3,0,SCR5,0,IPREC,1,SCR6)
      CALL GOPEN  (V1O,IZ(IBUF1),3)
      CALL GOPEN  (SCR5,IZ(IBUF2),0)
      MCB(1) = V1O
      CALL RDTRL  (MCB(1))
      CALL CYCT2B (SCR5,V1O,NLOAD,IZ(1),MCB)
      IF (ITYP.EQ.0 .AND. IFLAG.NE.0) GO TO 540
      CALL CLOSE  (V1O,2)
      CALL CLOSE  (SCR5,1)
      IF (ITYP.EQ.0 .OR. IFLAG.NE.0) GO TO 530
C
C     COMPUTE UCA
C
      CALL SSG2B  (SCR2,SCR4,0,SCR5,0,IPREC, 0,SCR6)
      CALL GOPEN  (V1O,IZ(IBUF1),3)
      CALL GOPEN  (SCR5,IZ(IBUF2),0)
      CALL CYCT2B (SCR5,V1O,NLOAD,IZ(1),MCB)
      CALL CLOSE  (V1O,2)
      CALL CLOSE  (SCR5,1)
C
C     COMPUTE USS
C
      CALL SSG2B  (SCR1,SCR4,0,SCR5,0,IPREC,1,SCR6)
      CALL GOPEN  (V1O,IZ(IBUF1),3)
      CALL GOPEN  (SCR5,IZ(IBUF2),0)
      CALL CYCT2B (SCR5,V1O,NLOAD,IZ(1),MCB)
      CALL CLOSE  (SCR5,1)
      CALL CLOSE  (V1O,2)
C
C     COMPUTE USA
C
  530 CONTINUE
      CALL SSG2B  (SCR2,SCR3,0,SCR5,0,IPREC,1,SCR6)
      CALL GOPEN  (V1O,IZ(IBUF1),3)
      CALL GOPEN  (SCR5,IZ(IBUF2),0)
      CALL CYCT2B (SCR5,V1O,NLOAD,IZ(1),MCB)
  540 CONTINUE
      CALL CLOSE  (SCR5,1)
      CALL CLOSE  (V1O,1)
      CALL WRTTRL (MCB)
      GO TO 560
C
C     DO ROTATIONAL OR SPECIAL CASE DIH
C
  550 SCR3 = V1I
      GO TO 520
C
C     SEE IF DONE
C
  560 MCB(1) = V2I
      CALL RDTRL (MCB)
      IF (MCB(1) .LE. 0) RETURN
      SCR3 = 303
      ITC  = MCB(5)
      IF (ITC.EQ.4 .AND. NZ.LT.4*LUA) CALL MESAGE (-8,0,NAME)
C
C     NOW DO EIGENVECTORS
C
C
C     COMPUTE NEW VECTORS
C
      CALL SSG2B (SCR1,V2I,0,SCR3,0,IPREC,1,SCR5)
      IF (ITYP.EQ.0 .AND. IFLAG.EQ.1) GO TO 570
      CALL SSG2B (SCR2,V2I,0,SCR4,0,IPREC,1,SCR5)
  570 CONTINUE
C
C     POSITION FILES
C
C
C      SET LAMA FLAG
C
      MCB(1) = LAMX
      CALL RDTRL (MCB)
      ILAMA  = 0
      IF (MCB(1) .LE. 0) ILAMA = 1
      CALL GOPEN (V2O,IZ(IBUF1),1)
      IF (ILAMA .NE. 0) GO TO 571
      CALL GOPEN (LAMA,IZ(IBUF2),1)
      FILE = LAMX
      CALL GOPEN (LAMX,IZ(IBUF3),0)
      CALL READ  (*620,*630,LAMX,IZ(1),146,1,IFLAG)
      CALL WRITE (LAMA,IZ(1),146,1)
  571 CONTINUE
      MCB(1) = V2I
      CALL RDTRL (MCB)
      NLOAD = MCB(2)
      CALL MAKMCB (MCB,V2O,LUA,2,MCB(5))
      IBUF4 = IBUF3 - SYSBUF
      CALL GOPEN (SCR3,IZ(IBUF4),0)
      IF (ITYP.EQ.0 .AND. IFLAG.EQ.1) GO TO 580
      IBUF5 = IBUF4 - SYSBUF
      CALL GOPEN (SCR4,IZ(IBUF5),0)
  580 DO 590 I = 1,NLOAD
      CALL CYCT2B (SCR3,V2O,1,IZ(1),MCB)
      IF (ILAMA .NE. 0) GO TO 572
      CALL READ  (*620,*630,LAMX,IZ(1),7,0,IFLAG)
      CALL WRITE (LAMA,IZ(1),7,0)
  572 CONTINUE
      IF (ITYP.EQ.0 .AND. IFLAG.EQ.1) GO TO 590
      IF (ILAMA .EQ. 0) CALL WRITE (LAMA,IZ(1),7,0)
      CALL CYCT2B (SCR4,V2O,1,IZ(1),MCB)
  590 CONTINUE
      CALL WRTTRL (MCB)
      CALL CLOSE  (V2O,1)
      CALL CLOSE  (SCR3,1)
      CALL CLOSE  (SCR4,1)
      IF (ILAMA .NE. 0) GO TO 573
      CALL CLOSE  (LAMA,1)
      CALL CLOSE  (LAMX,1)
      MCB(1) = LAMA
      CALL WRTTRL (MCB)
  573 CONTINUE
C
C     DONE
C
      RETURN
C
C     ERROR MESSAGES
C
C 600 IP1 = -1
  610 CALL MESAGE (IP1,FILE,NAME)
      GO TO 640
  620 IP1 = -2
      GO TO 610
  630 IP1 = -3
      GO TO 610
  640 CALL MESAGE (7,0,NAME)
      NOGO = -1
      RETURN
      END

      SUBROUTINE QDMM1 (TBAR,PG)
C
C     QUADRILATERAL MEMBRANE ELEMENT
C
C     CALLS FROM THIS ROUTINE ARE MADE TO
C           MAT    - MATERIAL DATA ROUTINE
C           MESAGE - ERROR MESSAGE WRITER
C           BASGLB - TRANSFER COORDINATES FROM BASIC TO GLOBAL
C           GMMATS - SINGLE PRECISION MATRIX MULTIPLY AND TRANSPOSE
C           TRANSS - SINGLE PRECISION TRANSFORMATION SUPPLIER
C
C     ECPT LIST
C                                                    IN THIS
C      ECPT       DESCRIPTION                        ROUTINE   TYPE
C     ========   =================================   ========  =======
C     ECPT( 1) = ELEMENT ID                          NECPT(1)  INTEGER
C     ECPT( 2)   GRID POINT A                        NGRID(1)  INTEGER
C     ECPT( 3)   GRID POINT B                        NGRID(2)  INTEGER
C     ECPT( 4)   GRID POINT C                        NGRID(3)  INTEGER
C     ECPT( 5)   GRID POINT D                        NGRID(4)  INTEGER
C     ECPT( 6) = THETA = ANGLE OF MATERIAL           ANGLE      REAL
C     ECPT( 7)   MATERIAL ID                         MATID1    INTEGER
C     ECPT( 8) = THICKNESS                           T          REAL
C     ECPT( 9) = NON-STRUCTURAL MASS                 FMU        REAL
C     ECPT(10)   COORD. SYSTEM ID 1                  NECPT(10) INTEGER
C     ECPT(11) = X1                                   X1        REAL
C     ECPT(12) = Y1                                   Y1        REAL
C     ECPT(13) = Z1                                   Z1        REAL
C     ECPT(14)   COORD. SYSTEM ID 2                  NECPT(14) INTEGER
C     ECPT(15) = X2                                   X2        REAL
C     ECPT(16) = Y2                                   Y2        REAL
C     ECPT(17) = Z2                                   Z2        REAL
C     ECPT(18)   COORD. SYSTEM ID 3                  NECPT(18) INTEGER
C     ECPT(19) = X3                                   X3        REAL
C     ECPT(20) = Y3                                   Y3        REAL
C     ECPT(21) = Z3                                   Z3        REAL
C     ECPT(22)   COORD. SYSTEM ID 4                  NECPT(22) INTEGER
C     ECPT(23) = X4                                   X4        REAL
C     ECPT(24) = Y4                                   Y4        REAL
C     ECPT(25)   Z4                                   Z4        REAL
C
      REAL            LA,LB,LC,LD,LDD2,LBD1,LCD1,LCD2,MAGI,MAGJ,MAGK
      DIMENSION       ECPT(26),PG(1),G(9),E(9)
      COMMON /CONDAS/ CONSTS(5)
      COMMON /TRIMEX/ NECPT(1),NGRID(4),ANGLE,MATID1,T,FMU,
     1                DUMMY1,X1,Y1,Z1,DUMMY2,X2,Y2,Z2,DUMMY3,X3,Y3,Z3,
     2                DUMMY4,X4,Y4,Z4
      COMMON /SSGWRK/ EE(144),B(96),TEMPAR(24),C(24),TI(9)
      COMMON /MATIN / MATID,INFLAG,ELTEMP,STRESS,SINTH,COSTH
      COMMON /MATOUT/ G11,G12,G13,G22,G23,G33,RHO,ALPHAS(3),
     1                T SUB 0,G SUB E,SIGTEN,SIGCOM,SIGSHE,
     2                G2X211,G2X212,G2X222
      EQUIVALENCE     (CONSTS(4),DEGRA),(ECPT(1),NECPT(1))
C
C     SET UP THE E MATRIX WHICH IS (12X12) FOR THE QUAD-MEMBRANE PROJECT
C                         ONTO THE MEAN PLANE
C
      DO 2 I = 1,144
      EE(I) = 0.
    2 CONTINUE
C
C     E(1), E(4), E(7) WILL BE THE I-VECTOR
C     E(2), E(5), E(8) WILL BE THE J-VECTOR
C     E(3), E(6), E(9) WILL BE THE K-VECTOR
C
C     COMPUTE DIFFERENCES OF COORDINATES OF ACTUAL GRID POINTS
C
      X21 = X2 - X1
      Y21 = Y2 - Y1
      Z21 = Z2 - Z1
      X31 = X3 - X1
      Y31 = Y3 - Y1
      Z31 = Z3 - Z1
      X41 = X4 - X1
      Y41 = Y4 - Y1
      Z41 = Z4 - Z1
      X42 = X4 - X2
      Y42 = Y4 - Y2
      Z42 = Z4 - Z2
C
C     COMPUTE THE ELEMENTS OF THE (3X3) E MATRIX
C
      PK1  = Y31*Z42 - Z31*Y42
      PK2  = Z31*X42 - X31*Z42
      PK3  = X31*Y42 - Y31*X42
      MAGK = SQRT(PK1**2 + PK2**2 + PK3**2)
      IF (MAGK .GT. 1.0E-06) GO TO 40
      CALL MESAGE (-30,32,ECPT(1))
   40 PK1  = PK1/MAGK
      PK2  = PK2/MAGK
      PK3  = PK3/MAGK
C
C     HH IS THE MEASURE OF NON-PLANARITY OF THE ELEMENT
C
      HH   = X21*PK1 + Y21*PK2 + Z21*PK3
      PI1  = X21 - HH*PK1
      PI2  = Y21 - HH*PK2
      PI3  = Z21 - HH*PK3
      MAGI = SQRT(PI1**2 + PI2**2 + PI3**2)
      IF (MAGI.GT.1.0E-06) GO TO 41
      CALL MESAGE (-30,31,ECPT(1))
   41 PI1  = PI1/MAGI
      PI2  = PI2/MAGI
      PI3  = PI3/MAGI
      HH   =-HH/2.
C
C     THIS SIGN CHANGE MADE BECAUSE SIGN OF H AS DEFINED ON
C     PAGE 4.87-105 OF PROGRAMMERS MANUAL IS WRONG
C
      PJ1  = PK2*PI3 - PK3*PI2
      PJ2  = PK3*PI1 - PK1*PI3
      PJ3  = PK1*PI2 - PK2*PI1
      MAGJ = SQRT(PJ1**2 + PJ2**2 + PJ3**2)
      PJ1  = PJ1/MAGJ
      PJ2  = PJ2/MAGJ
      PJ3  = PJ3/MAGJ
C
C     INSERT ELEMENTS INTO THE (3X3) E MATRIX
C
      E(1) = PI1
      E(2) = PJ1
      E(3) = PK1
      E(4) = PI2
      E(5) = PJ2
      E(6) = PK2
      E(7) = PI3
      E(8) = PJ3
      E(9) = PK3
C
C     STORE FOUR (3X3) E MATRICES INTO (12X12) E MATRIX
C
      LLCT = -39
      DO 5 IICT = 1,12,3
      LLCT = LLCT + 39
      NNCT = 0
      MMCT =-12
      DO 4 JJCT = 1,3
      MMCT = MMCT + 12
      DO 3 KKCT = 1,3
      NNCT = NNCT + 1
      KTOT = KKCT + LLCT + MMCT
      EE(KTOT) = E(NNCT)
    3 CONTINUE
    4 CONTINUE
    5 CONTINUE
C
C     COMPUTE DIFFERENCES OF COORDINATES OF GRID POINTS IN THE MEAN PLAN
C
      X12 = -X21*E(1) - Y21*E(4) - Z21*E(7)
      X13 = -X31*E(1) - Y31*E(4) - Z31*E(7)
      X14 = -X41*E(1) - Y41*E(4) - Z41*E(7)
      Y3A =  X31*E(2) + Y31*E(5) + Z31*E(8)
      Y4A =  X42*E(2) + Y42*E(5) + Z42*E(8)
      X24 =  X14 - X12
      X23 =  X13 - X12
      X34 =  X14 - X13
      Y34 =  Y3A - Y4A
C
C     COMPUTE LENGTHS OF SIDES OF ELEMENT IN THE MEAN PLANE
C
      LA = ABS(X12)
      LB = SQRT(X23**2 + Y3A**2)
      LC = SQRT(X34**2 + Y34**2)
      LD = SQRT(X14**2 + Y4A**2)
C
C     COMPUTE THE CHARACTERISTIC ANGLES OF ELEMENT IN THE MEAN PLANE
C
      CTH1  =-X14/LD
      STH1  = Y4A/LD
      CTH2  = X23/LB
      STH2  = Y3A/LB
      CTH31 = X34/LC
      STH31 =-Y34/LC
      CTH41 = CTH1
      STH41 = STH1
      CTH32 = STH2
      STH32 = CTH2
      CTH42 = STH31
      STH42 = CTH31
      DLT1  = CTH31*CTH32 - STH31*STH32
      DLT2  = CTH42*CTH41 + STH41*STH42
      LDD2  = LD*DLT2
      LBD1  = LB*DLT1
      LCD1  = LC*DLT1
      LCD2  = LC*DLT2
C
C     SET UP THE (12X12) TRANSFORMATION MATRIX B BETWEEN THE MEAN PLANE
C                        AND ACTUAL GRID POINTS
C
      DO 6 I = 1,96
    6 B( I) = 0.
      B( 1) = 1.
      B(10) = 1.
      B(17) =-HH/LA
      B(18) =-HH/(LD*STH1)+((HH*CTH1)/(LA*STH1))
      B(19) = HH/LA
      B(20) = (HH*CTH2)/(LA*STH2)
      B(23) = (HH*CTH42)/LDD2
      B(24) = (HH*STH42)/LDD2
      B(27) = 1.
      B(36) = 1.
      B(41) =-B(17)
      B(42) =-(HH*CTH1)/(LA*STH1)
      B(43) = B(17)
      B(44) = ((-HH*CTH2)/(LA*STH2))+(HH/(LB*STH2))
      B(45) =-(HH*STH31)/LBD1
      B(46) =-(HH*CTH31)/LBD1
      B(53) = 1.
      B(62) = 1.
      B(68) =-HH/(LB*STH2)
      B(69) = HH*((STH31/LBD1)+(CTH32/LCD1))
      B(70) = HH*((CTH31/LBD1)+(STH32/LCD1))
      B(71) =-(HH*STH41)/LCD2
      B(72) = (HH*CTH41)/LCD2
      B(79) = 1.
      B(88) = 1.
      B(90) = HH/(LD*STH1)
      B(93) =-(HH*CTH32)/LCD1
      B(94) =-(HH*STH32)/LCD1
      B(95) = HH*((-CTH42/LDD2)+(STH41/LCD2))
      B(96) = HH*((-STH42/LDD2)-(CTH41/LCD2))
      H     = ECPT( 8)
      ELTEMP= ECPT(26)
C
C     SET UP (3X8) C MATRIX (SEE FMMS)
C
      C( 1) =-(H*Y4A)/2.
      C( 2) = 0.
      C( 3) =-(H*X24)/2.
      C( 4) = 0.
      C( 5) =-(H*X24)/2.
      C( 6) =-(H*Y4A)/2.
      C( 7) = (H*Y3A)/2.
      C( 8) = 0.
      C( 9) = (H*X13)/2.
      C(10) = 0.
      C(11) = (H*X13)/2.
      C(12) = (H*Y3A)/2.
      C(13) = (H*Y4A)/2.
      C(14) = 0.
      C(15) = (H*X24)/2.
      C(16) = 0.
      C(17) = (H*X24)/2.
      C(18) = (H*Y4A)/2.
      C(19) =-(H*Y3A)/2.
      C(20) = 0.
      C(21) =-(H*X13)/2.
      C(22) = 0.
      C(23) =-(H*X13)/2.
      C(24) =-(H*Y3A)/2.
      THETA = ANGLE*DEGRA
      SINTH = SIN(THETA)
      COSTH = COS(THETA)
      IF (ABS(SINTH) .LT. 1.0E-06) SINTH = 0.0
      MATID  = MATID1
      INFLAG = 2
C                                                     T
C     COMPUTE TRANSFORMED MATRIX OF STIFFNESSES  G = P  * G * P
C
      CALL MAT (ECPT(1))
C
C     STORE INTO G MATRIX
C
      G(1) = G11
      G(2) = G12
      G(3) = G13
      G(4) = G12
      G(5) = G22
      G(6) = G23
      G(7) = G13
      G(8) = G23
      G(9) = G33
C
C                   T                            -
C     COMPUTE PG = T  * E * B * C * G * ALPHA * (T - T )
C                                                     0
C
      TEMP = TBAR - TSUB0
      TEMPAR(1) = ALPHAS(1)*TEMP
      TEMPAR(2) = ALPHAS(2)*TEMP
      TEMPAR(3) = ALPHAS(3)*TEMP
      CALL GMMATS (G(1),3,3,0,TEMPAR(1),3,1,0,TEMPAR(13))
      CALL GMMATS (C(1),8,3,0,TEMPAR(13),3,1,0,TEMPAR(1))
      CALL GMMATS (B(1),12,8,0,TEMPAR(1),8,1,0,TEMPAR(13))
      CALL GMMATS (EE(1),12,12,0,TEMPAR(13),12,1,0,TEMPAR(1))
      DO 13 I = 1,4
C
C     T-SUB-I WILL BE USED BELOW ONLY IF THE PIVOT COORDINATE SYSTEM ID
C     IS NOT ZERO, OTHERWISE IT IS ASSUMED TO BE THE IDENTITY MATRIX.
C
      KA = 4*I + 6
C
C     DO WE NEED TRANSFORMATION TI
C
      ISW = 0
      JJ  = 3*I - 2
      IF (NECPT(KA) .EQ. 0) GO TO 9
      ISW = 1
      CALL BASGLB (TEMPAR(JJ),TEMPAR(20),NECPT(KA+1),NECPT(KA))
C
C     COMPUTE PG VECTOR
C
    9 DO 12 K = 1,3
      JJK = JJ + K - 1
      K19 = K + 19
      IF (ISW .EQ. 0) TEMPAR(K19) = TEMPAR(JJK)
      I1 = I + 1
      L  = NECPT(I1) + K - 1
      PG(L) = PG(L) + TEMPAR(K19)
   12 CONTINUE
   13 CONTINUE
      RETURN
      END

       SUBROUTINE SDR2A
C
C     SDR2A PROCESSES THE CASE CONTROL DATA BLOCK. DEPENDING ON THE
C     RIGID FORMAT AND THE VARIOUS OUTPUT REQUESTS, SDR2A SETS FLAGS
C     AND PARAMETERS TO CONTROL OPERATION OF THE REMAINDER OF THE PHASES
C     OF SDR2
C
      EXTERNAL        LSHIFT,RSHIFT
      LOGICAL         AXIC  ,DDRMM ,STRAIN
      INTEGER         Z     ,CASECC,CSTM  ,FILE  ,BUF1  ,BUF2  ,BUF3  ,
     1                BUF4  ,BUF5  ,ALL   ,ANY   ,DISPL ,SPCF  ,STRESS,
     2                ELDEF ,ANY1  ,SETNO ,ZI    ,RSHIFT,STRNFL,FORCE ,
     3                PREVS ,PREVF ,TWO   ,PLOTS ,RET   ,PASS  ,SYSBUF,
     4                APP   ,STA   ,REI   ,DS0   ,DS1   ,FRQ   ,TRN   ,
     5                BK0   ,BK1   ,CEI   ,PLA   ,BRANCH,SORT2 ,VEL   ,
     6                ACC   ,TLOADS
      DIMENSION       ISYSTM(175)
      COMMON /MACHIN/ MACH  ,IHALF ,JHALF
      COMMON /ZZZZZZ/ Z(1)
      COMMON /BLANK / APP(2),SORT2,ISTRN  ,STRNFL,IDUMMY(5)    ,STRAIN
      COMMON /SDR2X1/ IEIGEN,IELDEF,ITLOAD,ISYMFL,ILOADS,IDISPL,ISTR  ,
     1                IELF  ,IACC  ,IVEL  ,ISPCF ,ITTL  ,ILSYM
      COMMON /SDR2X2/ CASECC,CSTM  ,MPT   ,DIT   ,EQEXIN,SIL   ,GPTT  ,
     1                EDT   ,BGPDT ,PG    ,QG    ,UGV   ,EST   ,PHIG  ,
     2                EIGR  ,OPG1  ,OQG1  ,OUGV1 ,OES1  ,OEF1  ,PUGV1 ,
     3                OEIGR ,OPHIG ,PPHIG ,ESTA  ,GPTTA ,HARMS
      COMMON /SDR2X4/ NAM(2),END   ,MSET  ,ICB(7),OCB(7),MCB(7),DTYPE(8)
     1,               ICSTM ,NCSTM ,IVEC  ,IVECN ,TEMP  ,DEFORM,FILE  ,
     2                BUF1  ,BUF2  ,BUF3  ,BUF4  ,BUF5  ,ANY   ,ALL   ,
     3                TLOADS,ELDEF ,SYMFLG,BRANCH,KTYPE ,LOADS ,SPCF  ,
     4                DISPL ,VEL   ,ACC   ,STRESS,FORCE ,KWDEST,KWDEDT,
     5                KWDGPT,KWDCC ,NRIGDS,STA(2),REI(2),DS0(2),DS1(2),
     6                FRQ(2),TRN(2),BK0(2),BK1(2),CEI(2),PLA(22)      ,
     7                NRINGS,NHARMS,AXIC  ,KNSET ,ISOPL ,STRSPT,DDRMM
      COMMON /NAMES / RD    ,RDREW ,WRT   ,WRTREW,CLSREW
      COMMON /SYSTEM/ SYSBUF,OPTE  ,NOGO  ,INTAP ,MPCN  ,SPCN  ,METHOD,
     1                LOADNN,SYMM  ,STFTMP,PAGE  ,LINE  ,TLINE ,MAXLIN,
     2                DATE(3)      ,TIME  ,ECHO  ,PLOTS ,DDD(6),MN
      COMMON /TWO   / TWO(32)
      EQUIVALENCE     (SYSBUF, ISYSTM)
      DATA    MMREIG/ 4HMMRE /
C
C
C     CHECK FOR STRAIN OPTION
C
      STRAIN = .FALSE.
      IF (ISTRN .GE. 0) STRAIN = .TRUE.
C
C     PERFORM BUFFER ALLOCATION.
C
      BUF1 = KORSZ(Z) - SYSBUF - 2
      BUF2 = BUF1 - SYSBUF
      BUF3 = BUF2 - SYSBUF
      BUF4 = BUF3 - SYSBUF
      BUF5 = BUF4 - SYSBUF
C
C     SET PARAMETER FOR APPROACH.
C
      N = 2*NRIGDS - 1
C
C     FIRST CHECK FOR SPECIAL APPROACH FOR DYNAMIC-DATA-RECOVERY-MATRIX-
C     METHOD.  IF APPROACH IS -MMREIG- THEN DDRMM FLAG IS SET TO INSURE
C     ENOUGH OUTPUTS UNDER CERTAIN CONDITIONS.
C
      DDRMM = .FALSE.
      IF (APP(1) .NE. MMREIG) GO TO 7
      DDRMM = .TRUE.
      I = 3
      GO TO 20
C
    7 DO 10 I = 1,N,2
      IF (STA(I) .EQ. APP(1)) GO TO 20
   10 CONTINUE
      CALL MESAGE (-30,75,APP)
   20 BRANCH = (I+1)/2
C
C    OPEN CASE CONTROL. SKIP HEADER RECORD.
C    IF DIFF. STIFF. PHASE 1 OR BUCKLING PHASE 1, SKIP 1ST CASECC RECORD
C
      CALL GOPEN (CASECC,Z(BUF1),RDREW)
      IF (APP(1).EQ.DS1(1) .OR. APP(1).EQ.BK1(1)) CALL SKPREC (CASECC,1)
      KWDCC = 0
C
C     INITIALIZE VARIOUS OUTPUT REQUEST FLAGS.
C
      ALL   = 0
      ANY   = 0
      DISPL = 0
      VEL   = 0
      ACC   = 0
      SPCF  = 0
      LOADS = 0
      STRESS= 0
      FORCE = 0
      TLOADS= 0
      ELDEF = 0
      II    = 0
      PREVS = 0
      PREVF = 0
C
C     READ A RECORD IN CASE CONTROL.
C     IF REQUEST FOR STRESSES IS PRESENT, TURN ON STRESS FLAG.
C     IF REQUEST FOR FORCES   IS PRESENT, TURN ON FORCE  FLAG.
C     -ANY- FLAG = STRESS .OR. FORCE.
C     -ALL- FLAG = ANY REQUEST FOR ALL STRESSES OR FORCES.
C     IF ANY.NE.0 .AND ALL.EQ.0, BUILD LIST OF UNIQUE ELEMENT IDS.
C
   40 CALL READ (*220,*50,CASECC,Z,BUF5-1,1,NCC)
      CALL MESAGE (+8,0,NAM)
      ALL  = 1
   50 ANY1 = 0
      KWDCC= MAX0(KWDCC,NCC)
      MSET = MAX0(MSET,KWDCC+1)
C
C     SET DMAP FLAG FOR USE IN DISP R.F. 1
C
      IF (ISTRN.GE.0 .OR. STRNFL.GE.0) GO TO 55
      J = 180
      IF (Z(J) .NE. 0) STRNFL = 1
   55 ISTR = 23
      IF (STRAIN) ISTR = 180
      IF (Z(ISTR)) 60,80,70
   60 ALL = 1
   70 STRESS = 1
      ANY1 = 1
   80 IF (Z(IELF)) 90,110,100
   90 ALL = 1
  100 FORCE = 1
      ANY1  = 1
  110 IF (ALL.NE.0 .OR. ANY1.EQ.0) GO TO 200
C
C     INITIALIZE TO PROCESS STRESS OUTPUT REQUEST.
C     BUILD MASTER SET LIST ONLY IF CURRENT SET ID IS NEW
C
      ASSIGN 190 TO PASS
      SETNO = Z(ISTR)
      IF (SETNO .EQ. PREVS) GO TO 190
      PREVS = SETNO
C
C     IF REQUEST PRESENT, LOCATE SET DEFINITION IN CASE CONTROL DATA.
C
  120 IF (SETNO .EQ. 0) GO TO PASS, (190,200)
      ISETNO = ILSYM + Z(ILSYM) + 1
  130 ISET = ISETNO + 2
      NSET = Z(ISETNO+1) + ISET - 1
      IF (Z(ISETNO) .EQ. SETNO) GO TO 140
      ISETNO = NSET + 1
      IF (ISETNO .LT. NCC) GO TO 130
      ALL = 1
      GO TO 200
C
C     PICK UP ELEMENT IDS IN SET. SAVE IN UNIQUE LIST.
C
  140 I = ISET
  150 IF (I  .EQ.  NSET) GO TO 170
      IF (Z(I+1) .GT. 0) GO TO 170
      ZI= Z(I  )
      N =-Z(I+1)
      I = I + 1
      ASSIGN 160 TO RET
      GO TO 260
  160 ZI = ZI + 1
      IF (ZI .GT. N) GO TO 180
      II =II + 1
      IF (II .GT. BUF2) GO TO 280
      Z(II) = ZI
      GO TO 160
  170 ZI = Z(I)
      ASSIGN 180 TO RET
      GO TO 260
  180 I = I + 1
      IF (I .LE. NSET) GO TO 150
      GO TO PASS, (190,200)
C
C     INITIALIZE TO PROCESS FORCE OUTPUT REQUEST.
C     BUILD MASTER SET LIST ONLY IF CURRENT SET ID IS NEW
C
  190 SETNO = Z(IELF)
      IF (SETNO .EQ. PREVF) GO TO 200
      PREVF = SETNO
      ASSIGN 200 TO PASS
      GO TO 120
C
C     TURN ON FLAGS FOR OTHER OUTPUT REQUESTS.
C
  200 IF (Z(ILOADS) .NE. 0) LOADS = 1
      IF (Z(ISPCF ) .NE. 0) SPCF  = 1
      IF (Z(IDISPL) .NE. 0) DISPL = 1
      IF (Z(IVEL  ) .NE. 0) VEL   = 1
      IF (Z(IACC  ) .NE. 0) ACC   = 1
      IF (Z(IELDEF) .NE. 0) ELDEF = 1
      IF (Z(ITLOAD) .NE. 0) TLOADS= 1
      IF (Z(ILOADS+2).LT.0 .OR. Z(ISPCF +2).LT.0 .OR.
     1    Z(IDISPL+2).LT.0 .OR. Z(IVEL  +2).LT.0 .OR.
     2    Z(IACC  +2).LT.0 .OR. Z(ISTR  +2).LT.0 .OR.
     3    Z(IELF  +2).LT.0 .OR. APP(     1).EQ.TRN(1)) SORT2 = 1
      ANY = STRESS + FORCE
C
C     CONICAL SHELL PROBLEM
C
      AXIC = .FALSE.
      IF (MN .EQ. 0) GO TO 210
      NRINGS = ISYSTM(161)
      NHARMS = MN
      AXIC = .TRUE.
  210 CONTINUE
C
C     RETURN TO READ ANOTHER RECORD IN CASE CONTROL (UNLESS DIFF STIFF
C     PHASE 0 OR BUCKLING PHASE 0)
C
      IF (APP(1).NE.DS0(1) .AND. APP(1).NE.BK0(1)) GO TO 40
C
C     IF ALL .EQ. 0, SORT LIST OF ELEMENT IDS AND MOVE LIST TO END OF
C     CORE. AND THROW AWAY ANY DUPLICATE.
C
  220 IF (ALL.NE.0 .OR. ANY.EQ.0) GO TO 240
      KN = II - MSET + 1
      CALL SORT (0,0,1,-1,Z(MSET),KN)
      JJ = BUF2 - 1
  230 Z(JJ) = Z(II)
  235 II = II - 1
      IF (Z(II) .EQ. Z(JJ)) GO TO 235
      JJ = JJ - 1
      IF (II .GE. MSET) GO TO 230
      MSET  = JJ + 1
      KNSET = BUF2 - MSET
      GO TO 250
  240 MSET = BUF2 - 1
C
C     CLOSE CASE CONTROL AND RETURN
C
  250 CALL CLOSE (CASECC,CLSREW)
      IF (APP(1) .NE. BK1(1)) RETURN
      ELDEF = 0
      TLOADS= 0
      RETURN
C
C
C     SEARCH LIST OF ELEM ID. IF CURRENT ID IS IN LIST RETURN
C     OTHERWISE ADD ID TO LIST
C
C
C     ADD ELEM ID TO LIST. NO NEED TO CHECK DUPLICATE ID HERE
C
  260 IF (II .EQ. 0) II = MSET - 1
      II = II + 1
      IF (II .LT. BUF2) GO TO 290
  280 ALL = 1
      GO TO 200
  290 Z(II) = ZI
      GO TO RET, (160,180)
C
      END

      SUBROUTINE FRD2E (IN,IO,NLOAD,NFREQ)
C
      INTEGER         MA(7),MB(7)
      COMMON /SYSTEM/ ISYS
      COMMON /UNPAKX/ IOUT,INN,NNN,INCR1
      COMMON /ZZZZZZ/ Z(1)
C
C     MAKE UHDF FROM IN
C
      INCR1 = 1
      MA(1) = IN
      MB(1) = IO
      IB1   = KORSZ(Z) - ISYS
      IB2   = IB1 - ISYS
      CALL RDTRL (MA)
      IOUT  = MA(5)
      CALL GOPEN (IN,Z(IB1),0)
      CALL GOPEN (IO,Z(IB2),1)
      CALL MAKMCB (MB,IO,MA(3),MA(4),IOUT)
      DO 30 J = 1,NLOAD
      CALL SKPREC (IN,J-1)
      DO 10 I = 1,NFREQ
      CALL CYCT2B (IN,IO,1,Z,MB)
      IF (I .NE. NFREQ) CALL SKPREC (IN,NLOAD-1)
   10 CONTINUE
      CALL REWIND (IN)
      CALL SKPREC (IN,1)
   30 CONTINUE
      CALL CLOSE (IN,1)
      CALL CLOSE (IO,1)
      CALL WRTTRL (MB)
      RETURN
      END

      SUBROUTINE BAR (Z,IDEFM,NOGPTT,NOEDT)
C
C     THIS IS THE ELEMENT TEMPERATURE AND DEFORMATION LOADING ROUTINE
C     FOR THE BAR ELEMENT.
C
C     THIS ROUTINE IS VERY MUCH SIMILIAR TO THAT OF SUBROUTINES KBAR AND
C     SBAR1 THUS ANY ALTERS HERE MAY BE REQUIRED IN THESE OTHER TWO
C     ROUTINES ALSO.
C
C     ECPT FOR THE BAR
C
C     ECPT( 1)  -  IELID         ELEMENT ID. NUMBER
C     ECPT( 2)  -  ISILNO(2)     * SCALAR INDEX NOS. OF THE GRID POINTS
C     ECPT( 3)  -    ...         *
C     ECPT( 4)  -  SMALLV(3)     $ REFERENCE VECTOR
C     ECPT( 5)  -    ...         $
C     ECPT( 6)  -    ...         $
C     ECPT( 7)  -  ICSSV         COOR. SYS. ID FOR SMALLV VECTOR
C     ECPT( 8)  -  IPINFL(2)     * PIN FLAGS
C     ECPT( 9)  -    ...         *
C     ECPT(10)  -  ZA(3)         $ OFFSET VECTOR FOR POINT A
C     ECPT(11)  -    ...         $
C     ECPT(12)  -    ...         $
C     ECPT(13)  -  ZB(3)         * OFFSET VECTOR FOR POINT B
C     ECPT(14)  -    ...         *
C     ECPT(15)  -    ...         *
C     ECPT(16)  -  IMATID        MATERIAL ID.
C     ECPT(17)  -  A             CROSS-SECTIONAL AREA
C     ECPT(18)  -  I1            $ AREA MOMENTS OF INERTIA
C     ECPT(19)  -  I2            $
C     ECPT(20)  -  FJ            TORSIONAL CONSTANT
C     ECPT(21)  -  NSM           NON-STRUCTURAL MASS
C     ECPT(22)  -  FE            FORCE ELEM DESCRIPTIONS (FORCE METHOD)
C     ECPT(23)  -  C1            * STRESS RECOVERY COEFFICIENTS
C     ECPT(24)  -  C2            *
C     ECPT(25)  -  D1            *
C     ECPT(26)  -  D2            *
C     ECPT(27)  -  F1            *
C     ECPT(28)  -  F2            *
C     ECPT(29)  -  G1            *
C     ECPT(30)  -  G2            *
C     ECPT(31)  -  K1            $ AREA FACTORS FOR SHEAR
C     ECPT(32)  -  K2            $
C     ECPT(33)  -  I12           AREA MOMENT OF INERTIA
C     ECPT(34)  -  MCSIDA        COOR. SYS. ID. FOR GRID POINT A
C     ECPT(35)  -  GPA(3)        * BASIC COORDINATES FOR GRID POINT A
C     ECPT(36)  -    ...         *
C     ECPT(37)  -    ...         *
C     ECPT(38)  -  MCSIDB        COOR. SYS. ID. FOR GRID POINT B
C     ECPT(39)  -  GPB(3)        $ BASIC COORDINATES FOR GRID POINT B
C     ECPT(40)  -    ...         $
C     ECPT(41)  -    ...         $
C     ECPT(42)  -  ELTEMP        AVG. ELEMENT TEMPERATURE
C
      LOGICAL           ABASIC   ,BBASIC   ,BASIC    ,AOFSET ,BOFSET   ,
     1                  OFFSET
      REAL              L        ,LSQ      ,LCUBE    ,I1     ,I2       ,
     1                  K1       ,K2       ,KE       ,KEP    ,I12      ,
     2                  NSM      ,LR1      ,LR2      ,LB     ,L2B3     ,
     3                  L2B6     ,UA(6)
      DIMENSION         VECI(3)  ,VECJ(3)  ,VECK(3)  ,Z(1)   ,TA(18)   ,
     1                  TB(9)    ,ECPT(100),IECPT(38),IPIN(10)         ,
     2                  SMALV0(6)
C
C     SDR2 PHASE I INPUT AND OUTPUT COMMON BLOCK
C
      COMMON   /TRIMEX/ IELID    ,ISILNO(2),SMALLV(3),ICSSV  ,IPINFL(2),
     1                  ZA(3)    ,ZB(3)    ,IMATID   ,A      ,I1       ,
     2                  I2       ,FJ       ,NSM      ,FE     ,C1       ,
     3                  C2       ,D1       ,D2       ,F1     ,F2       ,
     4                  G1       ,G2       ,K1       ,K2     ,I12      ,
     5                  MCSIDA   ,GPA(3)   ,MCSIDB   ,GPB(3) ,TEMPEL
C
      COMMON   /SSGWRK/ KE(144)  ,KEP(144) ,DELA(6)  ,DELB(6)
C
C     INPUT AND OUTPUT BLOCKS FOR SUBROUTINE MAT
C
      COMMON   /MATIN / MATIDC   ,MATFLG   ,ELTEMP   ,STRESS  ,SINTH   ,
     1                  COSTH
      COMMON   /MATOUT/ E        ,G        ,NU       ,RHO     ,ALPHA   ,
     1                  T SUB 0  ,G SUB E  ,SIGT     ,SIGC    ,SIGS
      EQUIVALENCE       (IELID,ECPT(1),IECPT(1))     ,(TA(10),TB(1))
C
C
C     SET UP POINTERS TO COOR. SYS. IDS., OFFSET VECTORS, AND PIN FLAGS.
C     ICSIDA AND ICSIDB ARE COOR. SYS. IDS.
C
      JCSIDA = 34
      JCSIDB = 38
      JOFSTA = 10
      JOFSTB = 13
      JPINA  =  8
      JPINB  =  9
      ICSIDA = IECPT(34)
      ICSIDB = IECPT(38)
C
C     NORMALIZE THE REFERENCE VECTOR WHICH LIES IN THE FIRST PRINCIPAL
C     AXIS PLANE  (FMMS - 36 P. 4)
C
      FL = 0.0
      DO 50 I = 1,3
   50 FL = FL + SMALLV(I)**2
      FL = SQRT(FL)
      DO 60 I = 1,3
   60 SMALLV(I) = SMALLV(I)/FL
C
C     DETERMINE IF POINT A AND B ARE IN BASIC COORDINATES OR NOT.
C
      ABASIC = .TRUE.
      BBASIC = .TRUE.
      IF (ICSIDA .NE. 0) ABASIC = .FALSE.
      IF (ICSIDB .NE. 0) BBASIC = .FALSE.
C
C     COMPUTE THE TRANSFORMATION MATRICES TA AND TB IF NECESSARY
C
      IF (.NOT.ABASIC) CALL GBTRAN (ECPT(JCSIDA),ECPT(JCSIDA+1),TA)
      IF (.NOT.BBASIC) CALL GBTRAN (ECPT(JCSIDB),ECPT(JCSIDB+1),TB)
C
C     DETERMINE IF WE HAVE NON-ZERO OFFSET VECTORS.
C
      AOFSET = .TRUE.
      J = JOFSTA - 1
      DO 70 I = 1,3
      J = J + 1
      IF (ECPT(J) .NE. 0.0) GO TO 80
   70 CONTINUE
      AOFSET = .FALSE.
   80 BOFSET = .TRUE.
      J = JOFSTB - 1
      DO 90 I = 1,3
      J = J + 1
      IF (ECPT(J) .NE. 0.0) GO TO 100
   90 CONTINUE
      BOFSET = .FALSE.
C
C     FORM THE CENTER AXIS OF THE BEAM WITHOUT OFFSETS.
C
  100 VECI(1) = ECPT(JCSIDA+1) - ECPT(JCSIDB+1)
      VECI(2) = ECPT(JCSIDA+2) - ECPT(JCSIDB+2)
      VECI(3) = ECPT(JCSIDA+3) - ECPT(JCSIDB+3)
C
C     TRANSFORM THE OFFSET VECTORS IF NECESSARY
C
      IF (.NOT.AOFSET .AND. .NOT.BOFSET) GO TO 150
C
C     TRANSFORM THE OFFSET VECTOR FOR POINT A IF NECESSARY.
C
      IDELA = 1
      J = JOFSTA - 1
      DO 110 I = 1,3
      J = J + 1
  110 DELA(I) = ECPT(J)
      IF (ABASIC) GO TO 120
      IDELA = 4
      CALL GMMATS (TA,3,3,0, DELA(1),3,1,0, DELA(4))
C
C     TRANSFORM THE OFFSET VECTOR FOR POINT B IF NECESSARY
C
  120 IDELB = 1
      J = JOFSTB - 1
      DO 130 I = 1,3
      J = J + 1
  130 DELB(I) = ECPT(J)
      IF (BBASIC) GO TO 140
      IDELB = 4
      CALL GMMATS (TB,3,3,0, DELB(1),3,1,0, DELB(4))
C
C     SINCE THERE WAS AT LEAST ONE NON-ZERO OFFSET VECTOR RECOMPUTE VECI
C
  140 VECI(1) = VECI(1) + DELA(IDELA  ) - DELB(IDELB  )
      VECI(2) = VECI(2) + DELA(IDELA+1) - DELB(IDELB+1)
      VECI(3) = VECI(3) + DELA(IDELA+2) - DELB(IDELB+2)
C
C     COMPUTE THE LENGTH OF THE BIG V (VECI) VECTOR AND NORMALIZE
C
  150 VECI(1) = -VECI(1)
      VECI(2) = -VECI(2)
      VECI(3) = -VECI(3)
      FL = SQRT (VECI(1)**2 + VECI(2)**2 + VECI(3)**2)
      DO 160 I = 1,3
  160 VECI(I) = VECI(I)/FL
C
C     COMPUTE THE SMALL V SUB 0 VECTOR, SMALV0.  ***CHECK THIS LOGIC***
C
      DO 165 I = 1,3
  165 SMALV0(I) = SMALLV(I)
      ISV = 1
      IF (ICSSV .EQ. 0) GO TO 180
      ISV = 4
      CALL GMMATS (TA,3,3,0, SMALV0(1),3,1,0, SMALV0(4))
C
C     COMPUTE THE K VECTOR, VECK = VECI X SMALV0, AND NORMALIZE
C
  180 VECK(1) =  VECI(2)*SMALV0(ISV+2) - VECI(3)*SMALV0(ISV+1)
      VECK(2) =  VECI(3)*SMALV0(ISV  ) - VECI(1)*SMALV0(ISV+2)
      VECK(3) =  VECI(1)*SMALV0(ISV+1) - VECI(2)*SMALV0(ISV)
      FLL     =  SQRT(VECK(1)**2 + VECK(2)**2 + VECK(3)**2)
      VECK(1) =  VECK(1)/FLL
      VECK(2) =  VECK(2)/FLL
      VECK(3) =  VECK(3)/FLL
C
C     COMPUTE THE J VECTOR, VECJ = VECK X VECI, AND NORMALIZE
C
      VECJ(1) =  VECK(2)*VECI(3) - VECK(3)*VECI(2)
      VECJ(2) =  VECK(3)*VECI(1) - VECK(1)*VECI(3)
      VECJ(3) =  VECK(1)*VECI(2) - VECK(2)*VECI(1)
      FLL     =  SQRT(VECJ(1)**2 + VECJ(2)**2 + VECJ(3)**2)
      VECJ(1) =  VECJ(1)/FLL
      VECJ(2) =  VECJ(2)/FLL
      VECJ(3) =  VECJ(3)/FLL
C
C     CALL MAT TO GET MATERIAL PROPERTIES.
C
      MATIDC = IMATID
      MATFLG = 1
      ELTEMP = TEMPEL
      CALL MAT (IECPT(1))
C
C     SET UP INTERMEDIATE VARIABLES FOR ELEMENT STIFFNESS MATRIX
C     CALCULATION
C
      L    = FL
      LSQ  = L**2
      LCUBE= LSQ*L
      EI1  = E*I1
      EI2  = E*I2
      IF (K1.EQ.0.0 .OR. I12 .NE.0.0) GO TO 210
      GAK1 = G*A*K1
      R1   = (12.0*EI1*GAK1)/(GAK1*LCUBE + 12.0*L*EI1)
      GO TO 220
  210 R1   =  12.0*EI1/LCUBE
  220 IF (K2.EQ.0.0 .OR. I12.NE.0.0) GO TO 230
      GAK2 = G*A*K2
      R2   = (12.0*EI2*GAK2)/(GAK2*LCUBE + 12.0*L*EI2)
      GO TO 240
  230 R2   =  12.0*EI2/LCUBE
C
C     COMPUTE THE -SMALL- K-S, SK1, SK2, SK3, AND SK4
C
  240 SK1 = 0.25*R1*LSQ + EI1/L
      SK2 = 0.25*R2*LSQ + EI2/L
      SK3 = 0.25*R1*LSQ - EI1/L
      SK4 = 0.25*R2*LSQ - EI2/L
C
C     COMPUTE THE TERMS THAT WILL BE NEEDED FOR THE 12 X 12 MATRIX KE
C
      AEL = A*E /L
      LR1 = L*R1/2.0
      LR2 = L*R2/2.0
      GJL = G*FJ/L
C
C     CONSTRUCT THE 12 X 12 MATRIX KE
C
      DO 250 I = 1,144
  250 KE(I) = 0.0
      KE(  1) =  AEL
      KE(  7) = -AEL
      KE( 14) =  R1
      KE( 18) =  LR1
      KE( 20) = -R1
      KE( 24) =  LR1
      KE( 27) =  R2
      KE( 29) = -LR2
      KE( 33) = -R2
      KE( 35) = -LR2
      KE( 40) =  GJL
      KE( 46) = -GJL
      KE( 51) = -LR2
      KE( 53) =  SK2
      KE( 57) =  LR2
      KE( 59) =  SK4
      KE( 62) =  LR1
      KE( 66) =  SK1
      KE( 68) = -LR1
      KE( 72) =  SK3
      KE( 73) = -AEL
      KE( 79) =  AEL
      KE( 86) = -R1
      KE( 90) = -LR1
      KE( 92) =  R1
      KE( 96) = -LR1
      KE( 99) = -R2
      KE(101) =  LR2
      KE(105) =  R2
      KE(107) =  LR2
      KE(112) = -GJL
      KE(118) =  GJL
      KE(123) = -LR2
      KE(125) =  SK4
      KE(129) =  LR2
      KE(131) =  SK2
      KE(134) =  LR1
      KE(138) =  SK3
      KE(140) = -LR1
      KE(144) =  SK1
      IF (I12 .EQ. 0.0) GO TO 255
      BETA = 12.0*E*I12/LCUBE
      LB   = L  *BETA/2.0
      L2B3 = LSQ*BETA/3.0
      L2B6 = LSQ*BETA/6.0
      KE( 15) =  BETA
      KE( 17) = -LB
      KE( 21) = -BETA
      KE( 23) = -LB
      KE( 26) =  BETA
      KE( 30) =  LB
      KE( 32) = -BETA
      KE( 36) =  LB
      KE( 50) = -LB
      KE( 54) = -L2B3
      KE( 56) =  LB
      KE( 60) = -L2B6
      KE( 63) =  LB
      KE( 65) = -L2B3
      KE( 69) = -LB
      KE( 71) = -L2B6
      KE( 87) = -BETA
      KE( 89) =  LB
      KE( 93) =  BETA
      KE( 95) =  LB
      KE( 98) = -BETA
      KE(102) = -LB
      KE(104) =  BETA
      KE(108) = -LB
      KE(122) = -LB
      KE(126) = -L2B6
      KE(128) =  LB
      KE(132) = -L2B3
      KE(135) =  LB
      KE(137) = -L2B6
      KE(141) = -LB
      KE(143) = -L2B3
C
C     DETERMINE IF THERE ARE NON-ZERO PIN FLAGS.
C
  255 KA = IECPT(JPINA)
      KB = IECPT(JPINB)
      IF (KA.EQ.0 .AND. KB.EQ.0) GO TO 325
C
C     SET UP THE IPIN ARRAY
C
      DO 260 I = 1,5
      IPIN(I  ) = MOD(KA,10)
      IPIN(I+5) = MOD(KB,10) + 6
      IF (IPIN(I+5) .EQ. 6) IPIN(I+5) = 0
      KA = KA/10
  260 KB = KB/10
C
C     ALTER KE MATRIX DUE TO PIN FLAGS.
C
      DO 320 I = 1,10
      IF (IPIN(I) .EQ. 0) GO TO 320
      II = 13*IPIN(I) - 12
      IF (KE(II) .NE. 0.0) GO TO 280
      IL = IPIN(I)
      II = II - IL
      DO 270 J = 1,12
      II = II + 1
      KE(II) = 0.0
      KE(IL) = 0.0
      IL = IL + 12
  270 CONTINUE
      GO TO 320
  280 DO 300 J = 1,12
      JI = 12*(J-1) + IPIN(I)
      IJ = 12*(IPIN(I) - 1) + J
      DO 290 LL = 1,12
      JLL = 12*(J-1) + LL
      ILL = 12*(IPIN(I) - 1) + LL
      KEP(JLL) = KE(JLL) - (KE(ILL)/KE(II))*KE(JI)
  290 CONTINUE
      KEP(IJ) = 0.0
      KEP(JI) = 0.0
  300 CONTINUE
      DO 310 K = 1,144
  310 KE(K) = KEP(K)
  320 CONTINUE
C
C            E
C     STORE K   IN KEP(1),...,KEP(36) AND
C            AA
C
C            E
C     STORE K   IN KEP(37),...,KEP(72)
C            AB
C
  325 J = 0
      DO 340 I = 1,72,12
      LOW = I
      LIM = LOW + 5
      DO 330 K = LOW,LIM
      J = J + 1
      KEP(J) = KE(K)
  330 KEP(J+36) = KE(K+6)
  340 CONTINUE
C                                                            T
C     STORE VECI, VECJ, VECK IN KE(1),...,KE(9) FORMING THE A  MATRIX.
C
      KE(1) = VECI(1)
      KE(2) = VECI(2)
      KE(3) = VECI(3)
      KE(4) = VECJ(1)
      KE(5) = VECJ(2)
      KE(6) = VECJ(3)
      KE(7) = VECK(1)
      KE(8) = VECK(2)
      KE(9) = VECK(3)
C
C     SET POINTERS SO THAT WE WILL BE WORKING WITH POINT A.
C
      BASIC = ABASIC
      JCSID = JCSIDA
      OFFSET= AOFSET
      JOFSET= JOFSTA
      IWBEG = 0
      IKEL  = 1
      ISASB = 73
      INDEX = ISILNO(1)
C
C     ZERO OUT THE ARRAY WHERE THE 3 X 3 MATRIX AND THE W  AND W  6 X 6
C     MATRICES WILL RESIDE.                              A      B
C
      DO 350 I = 28,108
  350 KE(I) = 0.0
C
C     SET UP THE -G- MATRIX.  IG POINTS TO THE BEGINNING OF THE G MATRIX
C     G = AT X TI
C
  360 IG = 1
      IF (BASIC) GO TO 370
      CALL GBTRAN (ECPT(JCSID),ECPT(JCSID+1),KE(10))
      CALL GMMATS (KE(1),3,3,0,KE(10),3,3,0, KE(19))
      IG = 19
C
C     IF THERE IS A NON-ZERO OFFSET FOR THE POINT, SET UP THE D 3 X 3
C     MATRIX.
C
  370 IF (.NOT. OFFSET) GO TO 380
      KE(10) =  0.0
      KE(11) =  ECPT(JOFSET+2)
      KE(12) = -ECPT(JOFSET+1)
      KE(13) = -KE(11)
      KE(14) =  0.0
      KE(15) =  ECPT(JOFSET)
      KE(16) = -KE(12)
      KE(17) = -KE(15)
      KE(18) =  0.0
C
C     FORM THE 3 X 3 PRODUCT H = G X D, I.E., KE(28) = KE(IG) X KE(10)
C
      CALL GMMATS (KE(IG),3,3,0, KE(10),3,3,0, KE(28))
C
C     FORM THE W  MATRIX OR THE W  MATRIX IN KE(37) OR KE(73) DEPENDING
C               A                B
C     UPON WHICH POINT - A OR B - IS UNDER CONSIDERATION.  G WILL BE
C     STORED IN THE UPPER LEFT AND LOWER RIGHT CORNERS.  H, IF NON-ZERO,
C     WILL BE STORED IN THE UPPER RIGHT CORNER.
C
  380 KE(IWBEG+37) = KE(IG  )
      KE(IWBEG+38) = KE(IG+1)
      KE(IWBEG+39) = KE(IG+2)
      KE(IWBEG+43) = KE(IG+3)
      KE(IWBEG+44) = KE(IG+4)
      KE(IWBEG+45) = KE(IG+5)
      KE(IWBEG+49) = KE(IG+6)
      KE(IWBEG+50) = KE(IG+7)
      KE(IWBEG+51) = KE(IG+8)
      KE(IWBEG+58) = KE(IG  )
      KE(IWBEG+59) = KE(IG+1)
      KE(IWBEG+60) = KE(IG+2)
      KE(IWBEG+64) = KE(IG+3)
      KE(IWBEG+65) = KE(IG+4)
      KE(IWBEG+66) = KE(IG+5)
      KE(IWBEG+70) = KE(IG+6)
      KE(IWBEG+71) = KE(IG+7)
      KE(IWBEG+72) = KE(IG+8)
      IF (.NOT.OFFSET) GO TO 390
      KE(IWBEG+40) = KE(28)
      KE(IWBEG+41) = KE(29)
      KE(IWBEG+42) = KE(30)
      KE(IWBEG+46) = KE(31)
      KE(IWBEG+47) = KE(32)
      KE(IWBEG+48) = KE(33)
      KE(IWBEG+52) = KE(34)
      KE(IWBEG+53) = KE(35)
      KE(IWBEG+54) = KE(36)
C                              E                    E
C     FORM THE PRODUCT  S  =  K   X  W   OR  S  = K   X  W  , DEPENDING
C                        A     AA     A       B    AB     B
C
C     UPON WHICH POINT WE ARE WORKING WITH.
C
  390 CALL GMMATS (KEP(IKEL),6,6,0, KE(IWBEG+37),6,6,0, KEP(ISASB))
C
C     IF THE POINT UNDER CONSIDERATION IS POINT B WE ARE FINISHED.  IF
C     NOT, SET UP POINTS AND INDICATORS FOR WORKING WITH POINT B.
C
      IF (IWBEG .EQ. 36) GO TO 500
      BASIC  = BBASIC
      JCSID  = JCSIDB
      OFFSET = BOFSET
      JOFSET = JOFSTB
      IWBEG  = 36
      IKEL   = 37
      ISASB  = 109
      INDEX  = ISILNO(2)
      DO 400 I = 28,36
  400 KE(I) = 0.0
      GO TO 360
C
C     NOW PERFORM THE ELEMENT TEMPERATURE AND DEFORMATION LOADING.
C
  500 TBAR = TSUB0
      IF (NOGPTT .EQ. 0) GO TO 510
      CALL SSGETD (ECPT(1),KE(1),0)
      TBAR = (KE(1) + KE(2))/2.0
  510 DELTA = 0.0
      IF (NOEDT .EQ. 0) GO TO 520
      KE(3) =  0.0
      KE(4) =  0.0
      KE(5) =  0.0
      KE(6) =  0.0
      CALL FEDT (ECPT(1),DELTA,IDEFM)
      GO TO 530
  520 DELTA = 0.0
C
C     ELEMENT TEMPERATURE DATA BEGINS AT KE(1)
C     ELEMENT DEFORMATION DATA = DELTA
C
C     S  BEGINS AT KEP(73)             (6 X 6)
C      A
C
C     S  BEGINS AT KEP(109)            (6 X 6)
C      B
C
C     NOW FILL THE U  MATRIX           (6 X 1)
C                   A
C
  530 ALPHAL = ALPHA*L
C
      UA(1) = -ALPHAL*(TBAR - TSUB0) - DELTA
      UA(2) = -ALPHAL*L*(KE(3) + 2.0*KE(4))/6.0
      UA(3) = -ALPHAL*L*(KE(5) + 2.0*KE(6))/6.0
      UA(4) =  0.0
      UA(5) = -ALPHAL*(KE(5) + KE(6))/2.0
      UA(6) =  ALPHAL*(KE(3) + KE(4))/2.0
C
C     COMPUTE P  AND P  AND STORE THEM INTO Z (OPEN CORE)
C              A      B
C
      DO 600 I = 1,2
      CALL GMMATS (KEP(36*I+37),6,6,1, UA(1),6,1,0, KE(1))
      K = IECPT(I+1) - 1
      DO 550 J = 1,6
      K = K + 1
  550 Z(K) = Z(K) + KE(J)
  600 CONTINUE
C
      RETURN
      END

      SUBROUTINE PEXIT
C
      EXTERNAL        LINK
      INTEGER         HH,SS,DATE(3)
      COMMON /OUTPUT/ LE(17)
      COMMON /MACHIN/ MACH
      COMMON /MSGX  / NMSG
      COMMON /RESDIC/ IRDICT
      COMMON /SYSTEM/ ISYSTM(100)
      EQUIVALENCE     (ISYSTM( 2),NOUT  ), (ISYSTM(76),NOSBE),
     1                (ISYSTM(82),ICPFLG),
     2                (ISYSTM(15),DATE  )
C
C     SEE IF ANY MESSAGES ARE IN THE QUEUE
C
      IF (NMSG   .GT. 0) CALL MSGWRT
      IF (ICPFLG .NE. 0) WRITE (IRDICT,10)
   10 FORMAT ('$ END OF CHECKPOINT DICTIONARY')
C
C     JOB DONE. PRINT LAST 4 MESSAGE LINES
C
      CALL WALTIM (I)
      HH = I/3600
      MM = (I-HH*3600)/60
      SS = I - HH*3600 - MM*60
      CALL CPUTIM (I,T,0)
      IF (MACH .EQ. 4) I = T
      IF (LE(1).EQ.-1 .AND. LE(2).EQ.-1) GO TO 70
      WRITE  (NOUT,20) LE,DATE,HH,MM,SS
   20 FORMAT (////40X,'* * * END OF JOB * * *', /1H1, /,' JOB TITLE = ',
     1       17A4, /,' DATE:',I3,1H/,I2,1H/,I2, /,' END TIME:',I3,1H:,
     2       I2,1H:,I2)
C
C     CDC TOTAL CPU TIME IS A BIG NUMBER. DON'T PRINT IT
C
      IF (MACH.EQ.4 .OR. LE(1).EQ.-1) GO TO 50
      IF (MACH .LE. 5) WRITE (NOUT,30) I
      IF (MACH .GT. 5) WRITE (NOUT,40) I
   30 FORMAT (' TOTAL CPU TIME',I6,' SEC.')
   40 FORMAT (' TOTAL WALL CLOCK TIME',I7,' SEC.')
C
C     FLUSH O/P BUFFERS
C
   50 WRITE  (NOUT,60)
   60 FORMAT (1H )
C
      IF (MACH.EQ.4 .AND. NOSBE.GT.0) CALL LINK (-1,NOSBE,1)
      GO TO 90
C
   70 J = 5
      IF (LE(9) .GE. 0) J = 3
      WRITE  (NOUT,80) (LE(I),I=J,8)
   80 FORMAT (//1X,6A4)
C
   90 CONTINUE
      CALL DBMSTF
      DO 100 I = 1,4
      CLOSE ( I )
100   CONTINUE
      DO 200 I = 7,22
      CLOSE ( I )
200   CONTINUE
CWKBR 8/94 SUN  CALL EXIT
      CALL EXIT( 0 )
      END

      SUBROUTINE POLYPT( LOCTOF,STEDGE,TR, NGRIDF,FLEDGE,FL,LOCFOS, EPS,
     1  NPOLY,P)
C
C     POLYPT DETERMINES PERIMETER POINTS OF AREA COMMON TO STRUCTURAL
C        TRIANGLE BOUNDED BY TR POINTS AND FLUID ELEMENT BOUNDED BY
C        (3 OR 4) FL POINTS
C
      DOUBLE PRECISION P(2,7)
      DOUBLE PRECISION TR(3,3), FL(3,4), SS(2), P1(2), EPS(2)
      INTEGER   STEDGE(2,3), FLEDGE(2,4), KEDGE(2,5), JEDGE(2,7)
     1, LOCTOF(3), LOCFOS(4)
C
      IP= 0
      NPOLY= 0
C
      DO 10 I=1,2
      DO 10 J=1,7
   10 P(I,J)= 0.D0
C
      DO 20 K=1,3
      IF ( LOCTOF(K) .LT. 0)  GO TO 40
   20 CONTINUE
C
C     STRUCTURAL TRIANGLE IS COMMON AREA WHEN NO STR PTS LIE OUTSIDE
C        FLUID ELEMENT BOUNDRY
      IP= 3
      DO 30 K=1,3
      DO 30 I=1,2
   30 P(I,K)= TR(I,K)
      GO TO 9000
C
   40 CONTINUE
C
      K= NGRIDF -1
      DO 50 I=1,2
      DO 45 J=1,K
      JEDGE(I,J)= FLEDGE(I,J)
   45 JEDGE(I,J+NGRIDF)= FLEDGE(I,J)
   50 JEDGE(I,NGRIDF)= FLEDGE(I,NGRIDF)
C
      DO 60 I=1,2
      DO 55 J=1,2
      KEDGE(I,J)= STEDGE(I,J)
   55 KEDGE(I,J+3)= STEDGE(I,J)
   60 KEDGE(I,3)= STEDGE(I,3)
C
C
      DO 100 K=1,3
      K1= KEDGE(1,K)
      K2= KEDGE(2,K)
      DO 100 J=1,NGRIDF
      J1= JEDGE(1,J)
      J2= JEDGE(2,J)
      CALL PTINTR( TR(1,K1),TR(1,K2), FL(1,J1),FL(1,J2), SS, INTER, EPS)
      IF (INTER .EQ. 1)  GO TO 200
  100 CONTINUE
C
C - - AREAS ARE DISJOINT
      GO TO 9000
C
C
  200 JLAST= J
      JJ1= J
      JJ2= J +NGRIDF -1
      KLAST= K
      KK1= K +1
      KK2= K+2
C
      IF (LOCTOF(K1) .EQ. 1)  GO TO 1800
C     1ST TRI POINT IS OUTSIDE FLUID BOUNDRY
      P1(2)= SS(2)
      P1(1)= SS(1)
      AP1= (P1(1)-TR(1,K1))**2 +(P1(2)-TR(2,K1))**2
      JP1= JLAST
      JJ1= JLAST+1
C
      DO 300 J=JJ1,JJ2
      J1= JEDGE(1,J)
      J2= JEDGE(2,J)
      CALL PTINTR( TR(1,K1),TR(1,K2), FL(1,J1),FL(1,J2), SS, INTER, EPS)
      IF (INTER .EQ. 1)  GO TO 400
  300 CONTINUE
C
      IP= IP+1
      P(1,IP)= P1(1)
      P(2,IP)= P1(2)
      GO TO 1000
C
  400 AP2= (SS(1)-TR(1,K1))**2 + (SS(2)-TR(2,K1))**2
      IF (AP1 .LT. AP2)  GO TO 500
C
      P(1,IP+1)= SS(1)
      P(2,IP+1)= SS(2)
      P(1,IP+2)= P1(1)
      P(2,IP+2)= P1(2)
      IP= IP+2
      JLAST= JP1
      GO TO 600
C
  500 P(1,IP+1)= P1(1)
      P(2,IP+1)= P1(2)
      P(1,IP+2)= SS(1)
      P(2,IP+2)= SS(2)
      IP= IP+2
      JLAST= J
C
  600 CONTINUE
      IF ( JLAST .GT. NGRIDF)  JLAST= JLAST -NGRIDF
      JJ1= JLAST
      JJ2= JJ1 +NGRIDF -1
      J2= JEDGE(2,JLAST)
      GO TO 2000
C
C     SEARCH ALONG LAST STRUCTURAL TRIANGLE EDGE FOR NEXT PTINTR
C
 1000 IF ( LOCTOF(K2) .LT. 0)  GO TO 1100
      IF (TR(1,K2) .EQ. P(1,1)  .AND. TR(2,K2) .EQ. P(2,1))  GO TO 9000
      IP= IP+1
      P(1,IP)= TR(1,K2)
      P(2,IP)= TR(2,K2)
      KLAST= KLAST +1
      IF ( KLAST .EQ. KK2)   GO TO 9000
      K2= KEDGE(2,KLAST)
      GO TO 1000
C
 1100 CONTINUE
      JJ1= JLAST
      IF (JJ1 .GT. JJ2)  GO TO 9000
      DO 1150 J= JJ1,JJ2
      J1= JEDGE(1,J)
      J2= JEDGE(2,J)
      CALL PTINTR( P(1,IP),TR(1,K2), FL(1,J1),FL(1,J2), SS, INTER, EPS)
      IF ( INTER .EQ. 1)  GO TO 1200
 1150 CONTINUE
C
      GO TO 9000
C
 1200 IF (SS(1) .EQ. P(1,1)  .AND.  SS(2) .EQ. P(2,1))  GO TO 9000
      IP= IP +1
      P(1,IP)= SS(1)
      P(2,IP)= SS(2)
      JLAST= J
      GO TO 2000
C
 1800 P(1,IP+1)= TR(1,K1)
      P(2,IP+1)= TR(2,K1)
      P(1,IP+2)= SS(1)
      P(2,IP+2)= SS(2)
      IP= IP+2
C
C     SEARCH ALONG LAST FLUID EDGE FOR NEXT PTINTR
C
 2000 IF ( LOCFOS(J2) .LT. 0)  GO TO 2100
      IF (FL(1,J2) .EQ. P(1,1)  .AND.  FL(2,J2) .EQ. P(2,1))  GO TO 9000
      IP= IP+1
      P(1,IP)= FL(1,J2)
      P(2,IP)= FL(2,J2)
      JLAST= JLAST +1
      IF ( JLAST .GT. JJ2)   GO TO 9000
      J2= JEDGE(2,JLAST)
      GO TO 2000
C
 2100 CONTINUE
      KK1= KLAST
      IF (KK1 .GT. KK2)  GO TO 9000
      DO 2150 K=KK1,KK2
      K1= KEDGE(1,K)
      K2= KEDGE(2,K)
      CALL PTINTR( P(1,IP),FL(1,J2), TR(1,K1),TR(1,K2), SS, INTER, EPS)
      IF ( INTER .EQ. 1)  GO TO 2200
 2150 CONTINUE
C
      GO TO 9000
C
 2200 IF (SS(1) .EQ. P(1,1)  .AND.  SS(2) .EQ. P(2,1))  GO TO 9000
      IP= IP +1
      P(1,IP)= SS(1)
      P(2,IP)= SS(2)
      KLAST= K
      GO TO 1000
C
C
 9000 CONTINUE
      NPOLY= IP
      RETURN
      END

      SUBROUTINE GIGTKG
C
      EXTERNAL        WRITE
      INTEGER         GSIZE,SCR2,SCR3,TRL(7),IZ(1),SYSBUF,OUT,BUF1,
     1                BUF2,NAM(2),SDTAB(6,5),CTYPE
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /SYSTEM/ SYSBUF,OUT
      COMMON /PACKX / ITI,ITO,II,NN,INCR
      COMMON /GICOM / SPLINE,DUM(8),KSIZE,GSIZE,SCR1,SCR2,SCR3
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE    (Z(1),IZ(1))
      DATA    NAM   / 4HGIGT,4HKG     /
      DATA    SDTAB / 9, 9, 0, 9, 1, 9,
     1                9, 0, 1, 9, 2, 3,
     2                9, 9, 0, 9, 9, 9,
     3                9, 9, 0, 9, 1, 2,
     4                9, 9, 0, 9, 1, 2/
C
      NCORE  = KORSZ(Z) - 2*SYSBUF
      BUF1   = NCORE
      BUF2   = BUF1 + SYSBUF
      ITI    = 1
      ITO    = 1
      II     = 1
      INCR   = 1
      TRL(1) = SCR2
      TRL(2) = 0
      TRL(3) = GSIZE
      TRL(4) = 2
      TRL(5) = 1
      TRL(6) = 0
      TRL(7) = 0
C
C     BUILD A G BY K MATRIX PUT OUT SPLINE3 COLUMNS WHEN NECESSARY
C
      CALL GOPEN (SCR2,Z(BUF1),1)
      CALL GOPEN (SCR3,Z(BUF2),0)
      ISS  = GSIZE + 1
      NCORE= NCORE - ISS
      KCOL = 0
      DO 80 I = 1,KSIZE
      IF (KCOL .LT. I) GO TO 20
   10 IF (KCOL .EQ. I) GO TO 50
      NN   = 1
      Z(1) = 0.0
      CALL PACK (Z,SCR2,TRL)
      GO TO 80
   20 CALL READ (*30,*40,SCR3,Z(ISS),NCORE,0,NWR)
      GO TO 90
   30 KCOL = KSIZE +1
      GO TO 10
   40 KST  = IZ(ISS+2)
      CTYPE= IZ(ISS+NWR-9)
      ICM  = IZ(ISS+3)
      K    = SDTAB(ICM,CTYPE)
      IF(K.EQ.9) GO TO 100
      KCOL = KST + K
      GO TO 10
C
C     BUILD COLUMN FOR SPLINE CARD
C
   50 DO 60 J = 1,GSIZE
   60 Z(J) = 0.0
      NN   = GSIZE
      JJ   = ISS+4
      JJJ  = ISS+NWR-19
      DO 70 J = JJ,JJJ,3
      K    = IZ(J) + IZ(J+1) -1
      Z(K) = Z(J+2)
   70 CONTINUE
      CALL PACK (Z,SCR2,TRL)
   80 CONTINUE
      CALL CLOSE (SCR2,1)
      CALL CLOSE (SCR3,1)
      CALL WRTTRL (TRL)
      GO TO 120
C
C     ERROR MESSAGES
C
   90 CALL MESAGE (-8,NCORE,NAM)
  100 WRITE  (OUT,110) UFM,IZ(ISS),CTYPE,ICM
  110 FORMAT (A23,' 2263, SPLINE3',I9,' FOR CAERO',I1,
     1       ' HAS ILLEGAL COMPONENT',I6)
      CALL MESAGE (-37,0,NAM)
  120 RETURN
      END

      SUBROUTINE REDU (CDATA,NX,IX,NAS,IAS,NVAR,VAR,IPRE,IER)
C
      INTEGER         CDATA(5),VAR(3,6),BLANK,EQS
      DIMENSION       IX(3,1),IAS(2,1),KEYS(6)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /SYSTEM/ IBUF,IOUT
      DATA    KEYS  / 4HNAMA,4HNAMB,4HNONA,4HNONB,4HPREC,4HBOUN /
      DATA    NAME  / 4HNAME/, EQS /4H=   /,BLANK/4H            /
C
C     INITIALLIZE
C
      DO 10 I = 1,6
   10 VAR(1,I) = KEYS(I)
C
      NVAR = 18
      DO 20 I = 1,2
      VAR(2,I) = BLANK
   20 VAR(3,I) = BLANK
      DO 30 I = 3,6
      VAR(2,I) = -1
   30 VAR(3,I) = 0
C
C     DECODE COMMAND
C
      I2 = 4
      IF (CDATA(5) .EQ.  EQS) I2 = 6
      IF (CDATA(1)*2 .LT. I2) GO TO 100
C
      VAR(2,1) = CDATA(I2  )
      VAR(3,1) = CDATA(I2+1)
C
      NVX = 6
C
C     FIND NAME
C
      DO 40 I = 1,NX
      IF (IX(1,I) .NE. NAME) GO TO 35
      VAR(2,2) = IX(2,I)
      VAR(3,2) = IX(3,I)
      GO TO 40
  35  IF (IX(1,I) .NE. KEYS(6)) GO TO 37
      VAR(2,6) = IX(2,I)
      VAR(3,6) = IX(3,I)
      GO TO 40
   37 NVX = NVX + 1
      DO 38 J = 1,3
   38 VAR(J,NVX) = IX(J,I)
   40 CONTINUE
      IF (VAR(2,2) .EQ. BLANK) GO TO 100
      IF (VAR(3,6) .LE.     0) GO TO 120
      IF (IPRE.LE.0 .OR. IPRE.GT.2) IPRE = 1
C
      VAR(3,5) = IPRE
C
C     FIND STRUCTURE NUMBERS, B MAY NOT PRE-EXIST
C
      IF (NAS .EQ. 0)  GO TO  80
      DO 70 I = 1,NAS
      IF (VAR(2,1).NE.IAS(1,I) .OR. VAR(3,1).NE.IAS(2,I)) GO TO 55
      VAR(3,3) = I
      GO TO 70
   55 IF (VAR(2,2).EQ.IAS(1,I) .AND. VAR(3,2).EQ.IAS(2,I)) GO TO 100
   70 CONTINUE
   80 NAS = NAS + 1
      VAR(3,4) = NAS
      IAS(1,NAS) = VAR(2,2)
      IAS(2,NAS) = VAR(3,2)
      IF (VAR(3,3) .NE. 0) GO TO 90
      NAS = NAS + 1
      VAR(3,3) = NAS
      IAS(1,NAS) = VAR(2,1)
      IAS(2,NAS) = VAR(3,1)
   90 IER  = 0
      NVAR = NVX*3
      RETURN
C
  100 WRITE  (IOUT,101) UFM
  101 FORMAT (A23,' 6614, ILLEGAL OR NON-EXISTANT STRUCTURE NAME USED ',
     1        'ABOVE')
      GO TO 130
  120 WRITE  (IOUT,121) UFM
  121 FORMAT (A23,' 6615, ILLEGAL BOUNDARY SET IDENTIFICATION NUMBER')
  130 IER = 1
      RETURN
      END

      SUBROUTINE OFPCS2(IX,L1,L2,L3,L4,L5,POINT)
C*****
C  SETS HEADER LINE FORMATS FOR COMPLEX STRESSES SORT2
C*****
      INTEGER C, POINT
      COMMON/OFPB4/ C(10)
      IX = C(POINT)
      L1 = C(POINT+1)
      L2 = C(POINT+2)
      L3 = C(POINT+3)
      L4 = C(POINT+4)
      L5 = C(POINT+5)
      RETURN
      END

      SUBROUTINE ALGPB (IDAT,NTYPE)
C
      INTEGER NA(4)
      DATA    NA / 2 ,     2  ,   3 ,    1 /
C                ZERO, INTEGER, REAL, ALPHA
C
C     RETURN FROM NUMTYP IS            SET NTYPE TO
C       0 -  ZERO                        1 - ALPHA
C       1 -  INTEGER                     2 - INTEGER
C       2 -  REAL                        3 - REAL
C       3 -  BCD
C
C     BLANK IS ALPHA,  ZERO IS INTEGER UNLESS NUMTYP SET IT TO REAL
C
      ITYPE = NUMTYP(IDAT) + 1
      NTYPE = NA(ITYPE)
      RETURN
      END

      SUBROUTINE EMG1B (BUF,SIL,II,FILE,DAMPC)
C
C     THIS ROUTINE REPLACES SMA1B AND GROUPS TOGETHER THE
C     SUB-PARTITIONS OF A PIVOT-PARTITION.
C
C     THE SUB-PARTIONS ARE ARRANGED IN CORE BY ASCENDING SILS OF THE
C     ELEMENT INVOLVED.
C
      LOGICAL          ANYCON, ERROR, DOUBLE, LAST, HEAT
      INTEGER          Z, ZBASE, POSVEC, PRECIS, ROWSIZ, FILE,
     1                 ELTYPE, ELID, DICT, OUTPT, ESTID,
     2                 FILTYP, SIL, SILS, SUBR(2), FLAGS
      REAL             RZ(1)
      DOUBLE PRECISION DZ(1), DAMPC, BUF(1)
      CHARACTER        UFM*23, UWM*25, UIM*29, SFM*25
      COMMON /XMSSG /  UFM, UWM, UIM, SFM
      COMMON /EMGPRM/  ICORE, JCORE, NCORE, ICSTM, NCSTM, IMAT, NMAT,
     1                 IHMAT, NHMAT, IDIT, NDIT, ICONG, NCONG, LCONG,
     2                 ANYCON, FLAGS(3), PRECIS, ERROR, HEAT, ICMBAR,
     3                 LCSTM, LMAT, LHMAT
      COMMON /EMG1BX/  NSILS, POSVEC(10), IBLOC, NBLOC, IROWS, DICT(15),
     1                 FILTYP, SILS(10), LAST
      COMMON /EMGDIC/  ELTYPE, LDICT, NLOCS, ELID, ESTID
      COMMON /SMA1IO/  SMAIO(36)
      COMMON /ZZZZZZ/  Z(1)
      COMMON /SYSTEM/  KSYSTM(65)
      COMMON /IEMG1B/  ICALL, ILAST
C
      EQUIVALENCE      (KSYSTM(2), OUTPT)
      EQUIVALENCE      (Z(1), DZ(1), RZ(1)),   (C, IC)
      EQUIVALENCE      (SMAIO(13), IF4GG)
C
      DATA    SUBR  /  4HEMG1,4HB   /
C
      IF (ERROR) RETURN
      IF (SIL .EQ. -1111111) GO TO 155
      DOUBLE = .FALSE.
      IF (PRECIS .EQ. 2) DOUBLE = .TRUE.
      ICALL = ICALL + 1
C
C     IF -FILE- EQUALS IF4GG FOR THE OLD ELEMENTS, THEN THE ELEMENT
C     DAMPING CONSTANT SENT IS PLACED IN THE DICTIONARY AND A SIMPLE
C     RETURN IS MADE.
C
      IF (HEAT) GO TO  10
      IF (FILE .NE. IF4GG) IF (II) 20,20,10
      C = DAMPC
      DICT(5) = IC
      ICALL = ICALL - 1
      RETURN
C
   10 IROWS = 1
      DICT(4) = 1
      GO TO 30
   20 IROWS = 6
      DICT(4) = 63
   30 IF (ICALL .GT. 1) GO TO 70
      ROWSIZ = NSILS*IROWS
      DICT(3) = ROWSIZ
      IBLOC = JCORE + MOD(JCORE+1,2)
      IF (DICT(2) .EQ. 2) GO TO 40
      NBLOC = IBLOC + ROWSIZ*IROWS*PRECIS - 1
      GO TO 50
   40 NBLOC = IBLOC + IROWS*PRECIS - 1
   50 IF (NBLOC .GT. NCORE) CALL MESAGE (-8,NBLOC-NCORE,SUBR)
      IF (DOUBLE) GO TO 60
      DO  55  I = IBLOC, NBLOC
      RZ(I) = 0.0E0
   55 CONTINUE
      GO TO 70
C
   60 IDBLOC = IBLOC/2 + 1
      NDBLOC = NBLOC/2
      DO 65 I = IDBLOC,NDBLOC
      DZ(I) = 0.0D0
   65 CONTINUE
C
C     INSERT SUB-PARTITION OF PARTITION IN POSITION OF SIL ORDER.
C
C     BUF IS ASSUMED DOUBLE PRECISION.
C
   70 DO 80 I = 1,NSILS
      IF (SIL .EQ. SILS(I)) GO TO 100
   80 CONTINUE
      WRITE  (OUTPT,90) SFM,ELID
   90 FORMAT (A25,' 3116, ELEMENT ID',I10,' SENDS BAD SIL TO ROUTINE ',
     1       'EMG1B.')
      CALL MESAGE (-37,0,SUBR)
C
  100 IF (DICT(2) .EQ. 2) GO TO 130
      ZBASE = IROWS*(I-1)
      KMAT = 1
      IF (DOUBLE) GO TO 125
C
C     SINGLE PRECISION ADDITION OF DATA
C
      J1 = IBLOC + ZBASE
      J2 = J1 + IROWS - 1
      DO  120  I = 1,IROWS
      DO  110  J = J1,J2
      RZ(J) = RZ(J) + SNGL(BUF(KMAT))
      KMAT = KMAT + 1
  110 CONTINUE
      J1 = J1 + ROWSIZ
      J2 = J2 + ROWSIZ
  120 CONTINUE
      GO TO 150
C
C     DOUBLE PRECISION ADDITION OF MATRIX DATA.
C
  125 J1 = IDBLOC + ZBASE
      J2 = J1 + IROWS - 1
      DO  127  I = 1,IROWS
      DO  126  J = J1,J2
      DZ(J) = DZ(J) + BUF(KMAT)
      KMAT = KMAT + 1
  126 CONTINUE
      J1 = J1 + ROWSIZ
      J2 = J2 + ROWSIZ
  127 CONTINUE
      GO TO 150
C
C     SIMPLE DIAGONAL MATRIX INSERTION
C
  130 KMAT = 1
      IF (DOUBLE) GO TO 145
      J1 = IBLOC
      DO  140  I = 1,IROWS
      RZ(J1) = RZ(J1) + SNGL(BUF(KMAT))
      J1 = J1 + 1
      KMAT = KMAT + 14
  140 CONTINUE
      GO TO 150
C
  145 J1 = IDBLOC
      DO  146  I = 1,IROWS
      DZ(J1) = DZ(J1) + BUF(KMAT)
      J1 = J1 + 1
      KMAT = KMAT + 14
  146 CONTINUE
C
  150 RETURN
C
C     OUTPUT PIVOT-ROWS-PARTITION
C
  155 IF (ICALL .LE. 0) GO TO 161
      IF (.NOT. LAST) GO TO 160
      ILAST = 1
  160 CALL EMGOUT (Z(IBLOC),Z(IBLOC),(NBLOC-IBLOC+1)/PRECIS,ILAST,
     1             DICT,FILTYP,PRECIS)
  161 ILAST = 0
      ICALL = 0
      RETURN
      END

      SUBROUTINE INVP3 (NORM1,SUB,MTIMSU,XTRNSY)
C
C     SUBROUTINE INVP3, THE MAIN LINK OF INVPWR, SOLVES FOR THE
C     EIGENVALUES AND EIGENVECTORS OF (K-LAMBDA*M)
C     THIS ROUTINE HANDLES BOTH SINGLE AND DOUBLE PRECISION VERSIONS
C
      EXTERNAL          NORM1     ,SUB      ,MTIMSU   ,XTRNSY
      INTEGER           FILEK     ,END      ,SYSBUF   ,SR2FIL   ,
     1                  SR3FIL    ,FILEL    ,FILELT   ,NAME(2)  ,
     2                  SR7FIL    ,COMFLG   ,TIMEIT   ,TIMED    ,
     3                  SR8FIL    ,SWITCH   ,T1       ,T2       ,
     4                  OPTION    ,OPT2     ,FILEM    ,FILEVC   ,
     5                  FILELM    ,MCBVC(7) ,DMPFIL
      INTEGER           REW       ,EOFNRW
      REAL              LAMMIN    ,LAMMAX
      DOUBLE PRECISION  DZ(1)     ,ALN      ,ALNM1    ,CN       ,
     1                  DTEMP     ,LAM1     ,LM1NM1   ,ETA      ,
     2                  ETANM1    ,LAM2     ,LM2NM1   ,H2N      ,
     3                  H2NM1     ,DELTA    ,LAMBDA   ,LMBDA    ,
     4                  LAM1D     ,FREQ
      COMMON   /ZZZZZZ/ Z(1)
      COMMON   /UNPAKX/ ITU       ,IIU      ,JJU      ,INCRU
      COMMON   /PACKX / ITP1      ,ITP2     ,IIP      ,JJP      ,
     1                  INCRP
      COMMON   /INVPWX/ FILEK(7)  ,FILEM(7) ,SR1FIL(7),SR2FIL(7),
     1                  FILELM    ,FILEVC   ,SR3FIL   ,SR4FIL   ,
     2                  SR5FIL    ,SR6FIL   ,SR7FIL   ,SR8FIL   ,
     3                  DMPFIL    ,LAMMIN   ,LAMMAX   ,NOEST    ,
     4                  NDPLUS    ,NDMNUS   ,EPS      ,NORTHO
      COMMON   /SYSTEM/ KSYSTM(65)
      COMMON   /INFBSX/ FILEL(7)  ,FILELT(7)
      COMMON   /FBSX  / LFILE(7)
      COMMON   /NAMES / RD        ,RDREW    ,WRT      ,WRTREW   ,
     1                  REW       ,NOREW    ,EOFNRW
      COMMON   /INVPXX/ LAMBDA    ,COMFLG   ,ITERTO   ,TIMED    ,
     1                  NOPOS     ,RZERO    ,NEG      ,NOCHNG   ,
     2                  IND       ,LMBDA    ,SWITCH   ,NZERO    ,
     3                  NONEG     ,IVECT    ,IREG     ,ISTART
      COMMON   /REIGKR/ OPTION
      COMMON   /DCOMPX/ DUMX(20)  ,IOFFF
      COMMON   /TRDXX / IDUMMY(27),IOPEN
      COMMON   /REGEAN/ IDUM40(40),IBUCK
      EQUIVALENCE       (DZ(1)     ,Z(1)  ) ,(KSYSTM( 1),SYSBUF ),
     1                  (KSYSTM( 2),IOUTPT) ,(KSYSTM( 9),NLPP   ),
     2                  (KSYSTM(12),NLNS  ) ,(KSYSTM(55),IPREC  )
      DATA      NAME  / 4HINVP, 4H3       / ,OPT2   / 4HUINV    /
C
C     DEFINITION OF LOCAL PARAMETERS
C
C     ITER     =  NUMBER OF ITERATIONS FROM THE CURRENT SHIFT POINT
C     IRAPID   =  1 = RAPID CONVERGENCE DO ONE MORE ITERATION
C     IEP2     =  1 = EPSILON 2 TEST FAILED
C     A        =  CONVERGENCE SAFETY FACTOR
C     EP1      =  EPSILON FOR DETERMINING IF IT IS POSSIBLE TO SHIFT
C     EP2      =  EPSILON TO DETERMINE IF LAMBDA 2 IS VALID
C     EP3      =  EPSILON TO DETERMINE IF EIGENVALUE IS TOO CLOSE TO SHI
C     GAMMA    =  CLOSE ROOT CRITERION
C     II1      =  POINTER TO U(N)
C     II2      =  POINTER TO U(N-1) OR DELTA U(N)
C     JJ1      =  POINTER TO F(N)
C     JJ2      =  POINTER TO DELTA F(N-1)
C     JJ3      =  POINTER TO F(N-1) OR DELTA F(N)
C     ALN      =  ALPHA(N)
C     ALNM1    =  ALPHA(N-1)
C     CN       =  NORMALIZATION FACTOR FOR LAST EIGENVECTOR
C
      IOPEN = -10
      CALL SSWTCH (16,L16)
      KHR   = 0
      NZ    = KORSZ(Z)
      NCOL  = FILEK(2)
      NCOL2 = NCOL*IPREC
      CALL MAKMCB (MCBVC,FILEVC,NCOL,2,IPREC)
      ITU   = IPREC
      IIU   = 1
      JJU   = NCOL
      INCRU = 1
      ITP1  = IPREC
      ITP2  = IPREC
      IIP   = 1
      JJP   = NCOL
      INCRP = 1
C
C     INITIALIZE
C
      ITER  = 0
      IRAPID= 0
      IEP2  = 0
      KEP2  = 0
      KOLD  =-1
      KOUNT = 0
      GO TO 30
C
   10 IF (NORTHO .EQ. 0) GO TO 30
      CALL KLOCK  (ICURNT)
      CALL TMTOGO (IIJJKK)
      NAVG = (ICURNT-ISTART)/NORTHO
      IF (IIJJKK .GE. 2*NAVG) GO TO 30
   20 COMFLG = 8
      GO TO 1140
C
   30 IEPCNT = 0
      IF (SWITCH .EQ. 1) GO TO 40
      FILEL(1)  = SR2FIL(1)
      FILELT(1) = SR3FIL
      GO TO 50
   40 FILEL(1)  = SR7FIL
      FILELT(1) = SR8FIL
C
   50 DO 60 I = 2,7
      LFILE(I) = FILEK(I)
   60 FILEL(I) = FILEK(I)
      LFILE(5) = IPREC
      FILEL(5) = IPREC
      LFILE(1) = FILEL(1)
      FILELT(7)= IOFFF
C
C     SET CONVERGENCE CRITERIA
C
      A   = .1
      EP1 = .003
      EP2 = .00001
      EP2 = .02
      EP3 = .05
      GAMMA = .01
      IF (L16.EQ.0 .OR. KHR.NE.0) GO TO 100
      CALL PAGE1
      NLNS = NLNS + 10
      WRITE  (IOUTPT,70)
   70 FORMAT (85H0D I A G   1 6   O U T P U T   F R O M    R O U T I N E
     1   I N V P 3   F O L L O W S . ,//)
      WRITE  (IOUTPT,80) RZERO,EPS,GAMMA,A,EP1,EP2,EP3
   80 FORMAT (8H0RZERO =,1P,E13.5,4X,5HEPS =,1P,E13.5,4X,7HGAMMA =,
     1        1P,E13.5,4X,3HA =,1P,E13.5, /,8H EP1   =,1P,E13.5,4X,
     2        5HEP2 =,1P,E13.5,4X,7HEP3   =,1P,E13.5)
      WRITE  (IOUTPT,90)
   90 FORMAT (5H0ITER,5H CFLG,11X,3HSTP,11X,3HSHP,10X,4HLAM1,10X,4HLAM2,
     1    11X,3HETA,9X,5HDELTA,4X,1HK,11X,3HH2N,9X,5HLAM1D,/1X,126(1H=))
C
C     INITIALIZE POINTERS TO VECTORS
C
  100 II1   = 1
      II2   = II1 + NCOL2
      JJ1   = II2 + NCOL2
      JJ2   = JJ1 + NCOL2
      JJ3   = JJ2 + NCOL2
      JJ4   = JJ3 + NCOL2
      JJ5   = JJ4 + NCOL2
      END   = JJ5 + NCOL2
      IEND  = END
      END   = IEND + NCOL
      IBUF1 = NZ   - SYSBUF
      IBUF2 = IBUF1- SYSBUF
      IBUF3 = IBUF2- SYSBUF
      IOBUF = IBUF3- SYSBUF
      IF (END .GE. IOBUF) GO TO 1300
C
C     GET ORTHOGONALITY FLAGS FOR PREVIOUS EIGENVECTORS
C
      IF (ITERTO .NE. 0) GO TO 160
      IF (NORTHO .EQ. 0) GO TO 170
      CALL GOPEN (FILEVC,Z(IOBUF),RDREW)
      CALL GOPEN (FILEM ,Z(IBUF1),RDREW)
      DO 150 I = 1,NORTHO
      IX = IEND + I - 1
      Z(IX) = 1.0
      CALL UNPACK (*110,FILEVC,Z(II1))
      GO TO 140
  110 J = NCOL2
      IF (IPREC .EQ. 2) GO TO 130
  120 Z(J) = 0.0
      J = J - 1
      IF (J .GT. 0) GO TO 120
      GO TO 140
  130 DZ(J) = 0.0D0
      J = J - 1
      IF (J .GT. 0) GO TO 130
  140 CALL M TIMS U (Z(II1),Z(JJ1),Z(IBUF1))
      CALL X TRNS Y (Z(II1),Z(JJ1),DTEMP)
      IF (DTEMP .LT. 0.0D0) Z(IX) = -1.0
  150 CONTINUE
      CALL CLOSE (FILEM ,REW)
      CALL CLOSE (FILEVC,REW)
      GO TO 170
  160 IF (NORTHO .EQ. 0) GO TO 170
      IFILE = DMPFIL
      CALL GOPEN (DMPFIL,Z(IOBUF),RDREW)
      CALL READ  (*1310,*1320,DMPFIL,Z(IEND),NORTHO,1,IDUM)
      CALL CLOSE (DMPFIL,1)
  170 IFILE = FILEM(1)
      CALL GOPEN (IFILE,Z(IBUF3),RDREW)
      IFILE = FILEL(1)
      CALL GOPEN (IFILE,Z(IBUF1),RDREW)
CWKBNB 1/95    FILELT NOT NEEDED FOR SMCOMP OR SDCOMP - ONLY DECOMP
      IF (OPTION .NE. OPT2) GO TO 171     
      IFILE = FILELT(1)
      CALL GOPEN (IFILE,Z(IBUF2),RDREW)
  171 CONTINUE
CWKBNE 1/95
C
C     GENERATE A STARTING VECTOR
C
      IF (IVECT . EQ. 1) GO TO 240
      KSAVE = K
      K = IABS(IND)
      IF (IPREC .EQ. 2) GO TO 210
      DO 200 I = 1,NCOL
      Z(I) = 1.0/FLOAT((MOD(K,13)+1)*(1+5*I/NCOL))
  200 K = K + 1
      GO TO 230
  210 DO 220 I = 1,NCOL
      DZ(I) = 1.0D0/FLOAT((MOD(K,13)+1)*(1+5*I/NCOL))
  220 K = K + 1
  230 K = KSAVE
      GO TO 310
C
C      USE PREVIOUSLY STORED VECTOR AS A STARTING VECTOR
C
  240 IFILE = FILEVC
      CALL GOPEN (FILEVC,Z(IOBUF),RD)
      CALL BCKREC (FILEVC)
      IN1 = 1
      IF (COMFLG-1) 260,250,260
  250 IN1 = JJ5
      CALL BCKREC (FILEVC)
  260 CALL UNPACK (*270,FILEVC,Z(IN1))
      GO TO 300
  270 J = IN1 + NCOL2
      IF (IPREC .EQ. 2) GO TO 290
  280 J = J - 1
      Z(J) = 0.0
      IF (J .GT. IN1) GO TO 280
      GO TO 300
  290 J = J - 1
      DZ(J) = 0.0D0
      IF (J   .GT.  IN1) GO TO 290
  300 IF (COMFLG .EQ. 1) GO TO 320
      CALL BCKREC (FILEVC)
      CALL CLOSE  (FILEVC,NOREW)
      IVECT = 0
  310 CONTINUE
      INTSUB = 1
      GO TO 490
C
C     PICK UP THE LAST ITERATED VECTOR FOR A STARTING VECTOR
C
  320 CONTINUE
      CALL UNPACK (*330,FILEVC,Z)
      GO TO 360
  330 J = NCOL2
      IF (IPREC .EQ. 2) GO TO 350
  340 Z(J) = 0.0
      J = J - 1
      IF (J .GT. 0) GO TO 340
      GO TO 360
  350 DZ(J) = 0.0D0
      J = J - 1
      IF (J.GT.0) GO TO 350
  360 CALL BCKREC (FILEVC)
      CALL BCKREC (FILEVC)
      CALL CLOSE  (FILEVC,NOREW)
      GO TO 310
C
C     SHIFT POINTERS TO VECTORS
C
  400 II  = II1
      II1 = II2
      II2 = II
      II  = JJ1
      JJ1 = JJ2
      JJ2 = JJ3
      JJ3 = II
      IF (L16.EQ.0 .OR. KHR.EQ.0) GO TO 420
      IF (NLNS .GE. NLPP) CALL PAGE1
      NLNS = NLNS + 1
      WRITE (IOUTPT,410) ITERTO,COMFLG,
     1                   LMBDA,LAMBDA,LAM1,LAM2,ETA,DELTA,K,H2N,LAM1D
  410 FORMAT (2I5,6(1P,D14.5),I5,2(1P,D14.5))
  420 KHR = 1
C
C     SAVE N-1 VECTOR
C
      IF (SWITCH .NE. 0) GO TO 460
      IXX = JJ5 + NCOL2 - 1
      IXZ = II2
      IF (IPREC .NE. 2) GO TO 440
      DO 430 I = JJ5,IXX,2
      Z(I  ) = Z(IXZ  )
      Z(I+1) = Z(IXZ+1)
  430 IXZ = IXZ + 2
      GO TO 460
  440 DO 450 I = JJ5,IXX
      Z(I) = Z(IXZ)
  450 IXZ  = IXZ + 1
  460 CONTINUE
C
C     SHIFT PARAMETERS
C
      ALNM1  = ALN
      ETANM1 = ETA
      H2NM1  = H2N
      LM1NM1 = LAM1
      LM2NM1 = LAM2
C
C     CALL INVFBS TO MAKE ONE ITERATION
C
      CALL KLOCK (T1)
      IF (OPTION .NE. OPT2) GO TO 470     
      IF (FILEL(5) .EQ. 2) CALL INVFBS (Z(JJ3),Z(II1),Z(IOBUF))
      IF (FILEL(5) .EQ. 1) CALL INTFBS (Z(JJ3),Z(II1),Z(IOBUF))
      GO TO 480
  470 CALL FBSINV (Z(JJ3),Z(II1),Z(IOBUF))
  480 ITERTO = ITERTO + 1
      ITER   = ITER   + 1
      IEPCNT = IEPCNT + 1
      CALL TMTOGO (IJKK)
      IF (IJKK .LE. 0) GO TO 20
      INTSUB = 2
  490 CONTINUE
      IF (NORTHO .EQ. 0) GO TO 550
C
C     NORMALIZE CURRENT ITERANT WITH RESPECT TO VECTORS FOUND IN THE
C     CURRENT AND PREVIOUS SEARCH REGIONS
C
      CALL M TIMS U (Z(II1),Z(JJ1),Z(IOBUF))
      IFILE = FILEVC
      CALL GOPEN (FILEVC,Z(IOBUF),RDREW)
      DO 540 I = 1,NORTHO
      CALL UNPACK (*500,FILEVC,Z(JJ4))
      GO TO 530
  500 J = JJ4 + NCOL2
      IF (IPREC .EQ. 2) GO TO 520
  510 J = J - 1
      Z(J) = 0.0
      IF (J .GT. JJ4) GO TO 510
      GO TO 530
  520 J = J - 1
      DZ(J) = 0.0D0
      IF (J .GT. JJ4) GO TO 520
  530 CALL X TRNS Y (Z(JJ4),Z(JJ1),DTEMP)
      IX = IEND + I - 1
      DTEMP = -DTEMP*Z(IX)
  540 CALL SUB (Z(JJ4),Z(II1),DTEMP,-1.0D0)
      CALL CLOSE (FILEVC,NOREW)
  550 CALL NORM1 (Z(II1),CN)
C
C     BEGIN TESTING CONVERGENCE CRITERIA
C
C     COMPUTE F(N)
C
      CALL M TIMS U (Z(II1),Z(JJ1),Z(IOBUF))
C
C     COMPUTE ALPHA(N)
C
      CALL X TRNS Y (Z(II1),Z(JJ1),ALN)
      ALN = DSQRT(DABS(ALN))
C
C     COMPUTE DELTA U(N)
C
      GO TO (400,600), INTSUB
  600 CALL SUB (Z(II1),Z(II2),1.0D0/ALN,1.0D0/ALNM1)
C
C     COMPUTE DELTA F(N)
C
      CALL SUB (Z(JJ1),Z(JJ3),1.0D0/ALN,1.0D0/ALNM1)
      LAM1 = ALNM1/(CN*ALN)
      IF (IRAPID .EQ. 1) GO TO 900
      CALL X TRNS Y (Z(II2),Z(JJ3),ETA)
      ETA = DSQRT(DABS(ETA))
C
C     RAPID CONVERGENCE TEST
C
      IF (ETA .GE. A*EPS*GAMMA*DABS(1.0D0+LAMBDA/LAM1)) GO TO 620
  610 IRAPID = 1
      GO TO 400
  620 IF (ITER   .EQ.     1) GO TO 400
      IF (ETANM1 .GE. 1.E-6) GO TO 700
      IF (ETA - 1.01*ETANM1) 700,700,610
C
C     EPSILON 2 TEST
C
  700 IF (IEP2  .EQ.  1) GO TO 720
      IF (ETA .EQ. 0.D0) GO TO 910
      CALL X TRNS Y (Z(II2),Z(JJ2),DTEMP)
      LAM2 = LAM1*DTEMP/ETA**2
      H2N  = (LAM2-LM2NM1)/LAMBDA
CWKBI 3/94 THE FOLLOWING LINE ADDED TO GET AROUND AN APPARENT COMPILER BUG ON
C          ULTRIX
      IF ( ETA .EQ. 0.D0)print *,' invp3,lam1,dtemp,eta=',lam1,dtemp,eta
      IF (ITER .LT. 4) GO TO 720
      IF (EP2.GT.DABS(H2N) .AND. DABS(H2N).GT.DABS(H2NM1)) GO TO 710
      GO TO 720
  710 CONTINUE
      IEP2 = 1
      LAM2 = LM2NM1
  720 DELTM1 = DELTA
      DELTA  = ETA**2/DMIN1((1.0D0-LAM2/LAM1)**2,10.0D0)
C
C     VECTOR CONVERGENCE TEST
C
      IF (DSQRT(DELTA) .LE. A*EPS) GO TO 910
      IF (ITER .LE. 3) GO TO 400
C
C     EPSILON 1 TEST
C
      IF (IEPCNT .GE. 100) GO TO 1270
      IF (IEPCNT .GE.  10) GO TO 800
      LAM1D = DABS(LAM1-LM1NM1)/RZERO
      IF (LAM1D .GE. DBLE(EP1)) GO TO 400
  800 CONTINUE
C
C     SHIFT DECISION
C
      IF (IEPCNT.GT.5 .AND. DELTA.GT.DELTM1) GO TO 850
      IF (DABS(LAM2/LAM1) .GT. 1.) GO TO 820
      IF (KEP2) 850,810,810
  810 KEP2 = -1
      GO TO 400
  820 KEP2 = 0
      CALL KLOCK (T2)
      TIMEIT = T2 - T1
      K= DLOG(DSQRT(DABS(DELTA))/(A*EPS))/DABS(DLOG(DABS(LAM2/LAM1)))+1.
      K= MIN0(K,9999)
      IF (K .NE. KOLD) GO TO 830
      KOUNT = KOUNT + 1
      IF (KOUNT .GE. 6) GO TO 850
      GO TO 840
  830 KOLD  = K
      KOUNT = 0
  840 CONTINUE
  850 LAMBDA= LAMBDA + LAM1
      K     = 0
      KOLD  =-1
      KOUNT = 0
      IEPCNT= 0
      IF (L16  .EQ.    0) GO TO 870
      IF (NLNS .GE. NLPP) CALL PAGE1
      NLNS = NLNS + 3
      WRITE  (IOUTPT,860) LAMBDA
  860 FORMAT (18H0NEW SHIFT POINT =,1P,D14.5,/)
C
C     STORE THE LAST VECTOR BEFORE A SHIFT FOR USE AS A STARTING VECTOR
C
  870 IF (SWITCH .EQ. 1) GO TO 880
      IN1 = II1
      GO TO 890
  880 IN1 = JJ5
  890 IFILE = FILEVC
      CALL GOPEN (FILEVC,Z(IOBUF),WRT)
      CALL PACK  (Z(IN1),FILEVC,MCBVC)
      IVECT  = 1
      COMFLG = 1
C
C     STORE THE CURRENT VECTOR ON THE EIGENVECTOR FILE SO IT CAN BE
C     USED AS A STARTING VECTOR
C
      CALL PACK  (Z(II1),FILEVC,MCBVC)
      CALL CLOSE (FILEVC,EOFNRW)
      GO TO 1140
C
C     MAKE EPSILON 1 TEST
C
  900 IF (DABS (LAM1-LM1NM1)/RZERO .GE. DBLE(EP1)) GO TO 400
C
C     CONVERGENCE ACHIEVED, NORMALIZE THE EIGENVECTOR
C
  910 CALL M TIMS U (Z(II1),Z(JJ1),Z(IOBUF))
      CALL X TRNS Y (Z(II1),Z(JJ1),DTEMP)
      IX = IEND + NORTHO
      Z(IX) = 1.0
      IF (DTEMP .LT. 0.0D0) Z(IX) = -1.0
      DTEMP = 1.0D0/DSQRT(DABS(DTEMP))
      J = II1
      KLOCAL = II1 + NCOL2 - 1
      IF (IPREC .NE. 2) GO TO 930
      J = (J+1)/2
      KLOCAL = KLOCAL/2
      DO 920 I = J,KLOCAL
  920 DZ(I) = DZ(I)*DTEMP
      GO TO 950
  930 DO  940 I = J,KLOCAL
  940 Z(I) = Z(I)*DTEMP
  950 CONTINUE
C
C     STORE THE EIGENVECTOR AND EIGENVALUE ON THE OUTPUT FILES
C
      LAM1 = LAM1 + LAMBDA
      IF (L16  .EQ. 0) GO TO 1010
      IF (NLNS .GE. NLPP) CALL PAGE1
      NLNS = NLNS + 3
      FREQ = (1.0D0/(8.0D0*DATAN(1.0D0)))*DSQRT(DABS(LAM1))
      WRITE  (IOUTPT,1000) LAM1,FREQ
 1000 FORMAT (32H0CONVERGENCE ACHIEVED AND LAM1 =,1P,D14.5,
     1        7X,'FREQ =',1P,D14.5,'HZ',/)
 1010 IFILE = FILEVC
      CALL GOPEN (FILEVC,Z(IOBUF),WRT)
      CALL PACK  (Z(II1),FILEVC,MCBVC)
      CALL CLOSE (FILEVC,EOFNRW)
      CALL GOPEN (FILELM,Z(IOBUF),WRT)
      CALL WRITE (FILELM,LAM1,2,1)
      CALL CLOSE (FILELM,EOFNRW)
      CALL CLOSE (SR7FIL,EOFNRW)
      CALL CLOSE (FILEL,REW)
      CALL CLOSE (FILELT,REW)
      CALL CLOSE (FILEM,REW)
      NORTHO = NORTHO + 1
      IEP2   = 0
      IRAPID = 0
      NOCHNG = 0
      IF (LAM1) 1020,1030,1030
 1020 IF (IBUCK .NE. 3) GO TO 1030
      IF (LAM1 .GE. LAMMIN) NONEG = NONEG + 1
      GO TO 1040
 1030 IF (LAM1 .LE. LAMMAX) NOPOS = NOPOS + 1
 1040 IF (NOPOS.GE.NDPLUS .AND. NONEG.GE.NDMNUS) GO TO 1230
      IF (NORTHO .GE. NCOL-NZERO) GO TO 1220
      IF (NORTHO .GE.    3*NOEST) GO TO 1210
      COMFLG = 0
      IF (SWITCH .EQ. 0) GO TO 1050
      SWITCH = 0
      LAMBDA = LMBDA
      GO TO 1060
 1050 CONTINUE
      IVECT = 0
      IF (ITER .LE. 5) GO TO 1070
 1060 IN1 = JJ5
      CALL GOPEN (FILEVC,Z(IOBUF),WRT)
      CALL PACK  (Z(IN1),FILEVC,MCBVC)
      CALL CLOSE (FILEVC,EOFNRW)
      IVECT = 1
 1070 ITER  = 0
C
C     TEST IF REGION IS EXHAUSTED
C
      IF (NEG) 1120,1100,1110
C
C     NO NEGATIVE REGION
C
 1100 IF (LAM1 .GT. LAMMAX) GO TO 1240
      GO TO 1130
C
C     ON POSITIVE SIDE
C
 1110 IF (NOPOS.LT.NDPLUS .AND. LAM1.LE.LAMMAX) GO TO 1130
C
C     SWITCH TO NEGATIVE SIDE
C
      COMFLG = 3
      GO TO 1140
C
C     ON NEGATIVE SIDE
C
 1120 IF (NONEG.GE.NDMNUS .OR. LAM1.LT.LAMMIN) GO TO 1240
C
C     CONTINUE ON SAME SIDE
C
 1130 IF (LAM1.LE.LAMBDA+RZERO .AND. LAM1.GE.LAMBDA-RZERO) GO TO 1250
      IF (IREG.NE.0 .AND. IND.GT.0) GO TO 1200
      COMFLG = 0
      IND = -IND
 1140 CALL CLOSE (FILEL,REW)
      CALL CLOSE (FILELT,REW)
      CALL CLOSE (FILEM,REW)
      CALL WRTTRL (MCBVC)
      IF (L16  .EQ.    0) GO TO 1150
      IF (NLNS .GE. NLPP) CALL PAGE1
      NLNS = NLNS + 1
      WRITE (IOUTPT,410) ITERTO,COMFLG,LMBDA,LAMBDA,
     1                   LAM1,LAM2,ETA,DELTA,K,H2N,LAM1D
 1150 IF (NORTHO .EQ. 0) RETURN
C
      CALL GOPEN (DMPFIL,Z(IOBUF),WRTREW)
      CALL WRITE (DMPFIL,Z(IEND),NORTHO,1)
      CALL CLOSE (DMPFIL,1)
      RETURN
C
 1200 IND = -(IND+1)
      IVECT = 0
      IF (IND .EQ .-13) IND = -1
      GO TO 1260
 1210 COMFLG = 4
      GO TO 1140
 1220 COMFLG = 5
      GO TO 1140
 1230 COMFLG = 6
      GO TO 1140
 1240 COMFLG = 7
      GO TO 1140
 1250 IND = IABS(IND)
      IREG = 1
      XXX = LAM1 - LAMBDA
      IF (EPS*ABS(RZERO) .GE. EP3*ABS(XXX)) GO TO 1270
 1260 IF (NORTHO .EQ. 0) GO TO 10
      CALL GOPEN (DMPFIL,Z(IOBUF),WRTREW)
      CALL WRITE (DMPFIL,Z(IEND),NORTHO,1)
      CALL CLOSE (DMPFIL,1)
      GO TO 10
C
C     CURRENT SHIFT POINT TOO CLOSE TO THE EIGENVALUE
C
 1270 IF (COMFLG .NE. 2) GO TO 1280
      COMFLG = 9
      GO TO 1140
 1280 CONTINUE
      XXX = LAM1 - LAMBDA
      LAMBDA = LAMBDA + SIGN(.02,XXX)*RZERO
      COMFLG = 2
      GO TO 1140
C
C     ERROR EXITS
C
 1300 NO = -8
      IFILE = END - IOBUF
      GO TO 1330
 1310 NO = -2
      GO TO 1330
 1320 NO = -3
 1330 CALL MESAGE (NO,IFILE,NAME(1))
      RETURN
      END

      SUBROUTINE FRLGB (PP,USETD,GMD,GOD,MULTI,SINGLE,OMIT,MODAL,PHIDH,
     1                  PD,PS,PH,SCR1,SCR2,SCR3,SCR4)
C
C     THIS ROUTINE REDUCES LOADS FROM P SET TO D SET
C
C     ENTRY POINT - FRRD1B
C                   ======
C
      INTEGER         PP,USETD,GMD,GOD,SINGLE,OMIT,PHIDH,PD,PS,PH,PO,
     1                SCR1,SCR2,SCR3,SCR4,USET,PN,PNBAR,PM,PF,PDBAR
      COMMON /BITPOS/ UM,UO,UR,USG,USB,UL,UA,UF,US,UN,UG,UE,UP,UNE,UFE,
     1                UD
      COMMON /PATX  / NZ,N1,N2,N3,USET
      COMMON /ZZZZZZ/ CORE(1)
      DATA    MODA  / 4HMODA /
C
      GO TO 5
C
C
      ENTRY FRRD1B (PP,USETD,GMD,GOD,MULTI,SINGLE,OMIT,MODAL,PHIDH,
     1              PD,PS,PH,SCR1,SCR2,SCR3,SCR4)
C     =============================================================
C
C     SET UP INITIAL VALUES
C
    5 NZ    = KORSZ(CORE)
      USET  = USETD
      PNBAR = SCR2
      PM    = SCR3
      PN    = SCR4
      PF    = SCR2
      PDBAR = SCR3
      PO    = PH
C
C     REMOVE EACH TYPE OF CONSTRAINT
C
      IF (MULTI .LT. 0) GO TO 10
C
C     REMOVE MULTIPOINT CONSTRAINTS
C
      IF (SINGLE.LT.0 .AND. OMIT.LT.0) PN = PD
      CALL CALCV (SCR1,UP,UNE,UM,CORE(1))
      CALL SSG2A (PP,PNBAR,PM,SCR1)
      CALL SSG2B (GMD,PM,PNBAR,PN,1,1,1,SCR1)
      GO TO 20
C
C     NO M-S
C
   10 PN = PP
   20 IF (SINGLE .LT. 0) GO TO 30
C
C     REMOVE SINGLE POINT CONSTRAINTS
C
      IF (OMIT .LT. 0) PF = PD
      CALL CALCV (SCR1,UNE,UFE,US,CORE(1))
      CALL SSG2A (PN,PF,PS,SCR1)
      GO TO 40
C
C     NO SINGLE POINT CONSTRAINTS
C
   30 PF = PN
   40 IF (OMIT .LT. 0) GO TO 50
C
C     REMOVE OMITS
C
      CALL CALCV (SCR1,UFE,UD,UO,CORE(1))
      CALL SSG2A (PF,PDBAR,PO,SCR1)
      CALL SSG2B (GOD,PO,PDBAR,PD,1,1,1,SCR1)
      GO TO 60
   50 PD = PF
   60 IF (MODAL .NE. MODA) GO TO 70
C
C     TRANSFORM TO MODAL COORDINATES
C
      CALL SSG2B (PHIDH,PD,0,PH,1,1,1,SCR1)
   70 RETURN
      END

      SUBROUTINE APDB
C
C     AERODYNAMIC POOL DISTRIBUTOR AND GEOMETRY INTERPOLATOR FOR
C     COMPRESSOR BLADES (AERODYNAMIC THEORY 6) AND SWEPT TURBOPROP
C     BLADES (AERODYNAMIC THEORY 7).
C
C     THIS IS THE DMAP DRIVER FOR APDB
C
C     DMAP CALLING SEQUENCE
C
C     APDB     EDT,USET,BGPDT,CSTM,EQEXIN,GM,GO / AEROB,ACPT,FLIST,
C              GTKA,PVECT / V,N,NK/V,N,NJ/V,Y,MINMACH/V,Y,MAXMACH/
C              V,Y,IREF/V,Y,MTYPE/V,N,NEIGV/V,Y,KINDEX $
C
C     INPUT  DATA BLOCKS CSTM, GM AND GO MAY BE PURGED
C     OUTPUT DATA BLOCK  PVECT MAY BE PURGED
C     PARAMETERS NK AND NJ ARE OUTPUT, THE OTHERS ARE INPUT
C
C
      LOGICAL         LMKAER,FIRST,DEBUG
      INTEGER         SYSBUF,RD,RDREW,WRT,WRTREW,CLSREW,NOREW,EOFNRW,
     1                NAME(2),AERO(3),MKAER1(3),MKAER2(3),FLUTTR(3),
     2                FLFACT(3),ITRL(7),STRML1(3),STRML2(3),SCR1,FILE,
     3                FLAG,NAME1(6,2),BUF(7),EDT,BGPDT,CSTM,EQEXIN,
     4                AEROB,ACPT,FLIST,PVECT,CORWDS,PSTRM(100),TYPIN,
     5                TYPOUT,SINE,IZ(6)
      REAL            MINMAC,MAXMAC
      CHARACTER       UFM*23,UWM*25
      COMMON /XMSSG / UFM,UWM
      COMMON /BLANK / NK,NJ,MINMAC,MAXMAC,IREF,MTYPE(2),NEIGV,KINDEX
      COMMON /SYSTEM/ SYSBUF,IOUT,NSYS(91)
      COMMON /APDBUG/ DEBUG
      COMMON /PACKX / TYPIN,TYPOUT,II,NN,INCR
      COMMON /ZZZZZZ/ Z(1)
      COMMON /NAMES / RD,RDREW,WRT,WRTREW,CLSREW,NOREW,EOFNRW
C     NAMES  -VALUE =  2   0    3    1      1      2     3
      EQUIVALENCE     (Z(1),IZ(1)), (MINMAC,MACMIN), (MAXMAC,MACMAX)
      DATA    AERO  / 3202,32,0/, MKAER1 /3802,38,0/, MKAER2 /3702,37,0/
      DATA    FLUTTR/ 3902,39,0/, FLFACT /4102,41,0/
      DATA    STRML1/ 3292,92,0/, STRML2 /3293,93,0/
      DATA    EDT   , BGPDT,CSTM,EQEXIN  /
     1        101   , 103  ,104 ,105     /
      DATA    AEROB , ACPT ,FLIST,PVECT  /
     1        201   , 202  ,203  ,205    /
      DATA    NAME  / 4HAPDB,4H          /, SCR1 /301/
      DATA    ITRL  / 7*0 / , FIRST / .TRUE./,  SINE / 4HSINE/
      DATA    NAME1(1,1),NAME1(1,2) / 4HAERO,4H      /
      DATA    NAME1(2,1),NAME1(2,2) / 4HMKAE,4HRO    /
      DATA    NAME1(3,1),NAME1(3,2) / 4HFLFA,4HCT    /
      DATA    NAME1(4,1),NAME1(4,2) / 4HFLUT,4HTER   /
      DATA    NAME1(5,1),NAME1(5,2) / 4HSTRE,4HAML1  /
      DATA    NAME1(6,1),NAME1(6,2) / 4HSTRE,4HAML2  /
C
      DEBUG = .FALSE.
      CALL SSWTCH (20,J)
      IF (J .EQ. 1) DEBUG = .TRUE.
C
C     SELECT AERODYNAMIC THEORY
C
C     COMPRESSOR BLADES (AERODYNAMIC THEORY 6).
C     SWEPT TURBOPROPS  (AERODYNAMIC THEORY 7).
C
C     AT PRESENT THE USER SELECTS THE THEORY VIA THE NASTRAN CARD.
C     SET SYSTEM(93)=0  FOR THEORY 6 OR SYSTEM(93)=1 FOR THEORY 7.
C     NOTE - THE DEFAULT IS THEORY 6 (SYSTEM(93)=0).
C
C     FOR EXAMPLE, TO SELECT THEORY 7, USE THE FOLLOWING CARD -
C     NASTRAN SYSTEM(93)=1
C
      IF (NSYS(91) .EQ. 0) MTHD = 6
      IF (NSYS(91) .EQ. 1) MTHD = 7
C
      IF (DEBUG) CALL BUG1 ('BLANK COMM',1,NK,9)
      NOGO  = 0
      MAXSL = 100
      IBUF1 = KORSZ(Z) - SYSBUF
      IBUF2 = IBUF1 - SYSBUF
      IBUF3 = IBUF2 - SYSBUF
      LAST  = IBUF3 - SYSBUF - 1
      IF (LAST .LE. 0) GO TO 991
      LEFT = CORWDS(Z(1),Z(LAST))
C
C     CREATE AEROB DATA BLOCK
C
      CALL GOPEN (AEROB,Z(IBUF2),WRTREW)
C
C     READ AERO CARD VALUES - BREF, SYMXZ AND SYMXY
C
      FILE = EDT
      CALL PRELOC (*992,Z(IBUF1),EDT)
      CALL LOCATE (*981,Z(IBUF1),AERO,FLAG)
      CALL READ   (*993,*994,EDT,Z(1),6,1,FLAG)
      IF (DEBUG) CALL BUG1 ('AERO CARD ',2,Z,6)
      IZ(1) = IZ(5)
      IZ(2) = IZ(6)
      CALL WRITE (AEROB,Z,3,1)
C
C     READ IN MKAERO1 CARDS
C
      LMKAER = .FALSE.
      NEXT = 1
      CALL LOCATE (*60,Z(IBUF1),MKAER1,FLAG)
      CALL READ (*993,*10,EDT,Z(NEXT),LEFT,1,NX)
      GO TO 991
   10 N1 = NEXT
      IF (DEBUG) CALL BUG1 ('MKAERO1   ',10,Z(N1),NX)
      LMKAER = .TRUE.
   20 N2 = N1 + 7
      DO 40 I = N1,N2
      IF (IZ(I) .EQ. -1) GO TO 50
      BUF(1) = IZ(I)
      N3 = N2 + 1
      N4 = N3 + 7
      DO 30 J = N3,N4
      IF (IZ(J) .EQ. -1) GO TO 40
      BUF(2) = IZ(J)
   30 CALL WRITE (AEROB,BUF,2,0)
   40 CONTINUE
   50 IF (N4-NEXT+1 .GE. NX) GO TO 60
      N1 = N1 + 16
      GO TO 20
C
C     READ IN MKAERO2 CARDS
C
   60 CALL LOCATE (*80,Z(IBUF1),MKAER2,FLAG)
      CALL READ (*993,*70,EDT,Z(NEXT),LEFT,1,NX)
      GO TO 991
   70 CALL WRITE (AEROB,Z(NEXT),NX,0)
      IF (DEBUG) CALL BUG1 ('MKAERO2   ',70,Z(NEXT),NX)
      LMKAER = .TRUE.
   80 CALL WRITE (AEROB,0,0,1)
      CALL CLOSE (AEROB,CLSREW)
      IF (.NOT.LMKAER) GO TO 982
      ITRL(1) = AEROB
      ITRL(2) = 1
      CALL WRTTRL (ITRL)
C
C     CREATE FLIST TABLE
C
      CALL OPEN  (*85,FLIST,Z(IBUF2),WRTREW)
      CALL FNAME (FLIST,IZ(NEXT))
      CALL WRITE (FLIST,IZ(NEXT),2,1)
      CALL LOCATE (*981,Z(IBUF1),AERO,FLAG)
      CALL READ (*993,*90,EDT,Z(NEXT),LEFT,1,NX)
      GO TO 991
C
C     FLIST CAN BE PURGED IF THE APPROACH IS NOT AERO
C
   85 IF (IABS(NSYS(19)) .NE. 4) GO TO 115
      FILE = FLIST
      GO TO 992
   90 CALL WRITE (FLIST,AERO,3,0)
      CALL WRITE (FLIST,Z(NEXT),NX,1)
      IF (DEBUG) CALL BUG1 ('FLIST AERO',90,Z(NEXT),NX)
      CALL LOCATE (*983,Z(IBUF1),FLFACT,FLAG)
      CALL READ (*993,*100,EDT,Z(NEXT),LEFT,1,NX)
      GO TO 991
  100 CALL WRITE (FLIST,FLFACT,3,0)
      CALL WRITE (FLIST,Z(NEXT),NX,1)
      IF (DEBUG) CALL BUG1 ('FLIST FLFA',100,Z(NEXT),NX)
      CALL LOCATE (*984,Z(IBUF1),FLUTTR,FLAG)
      CALL READ (*993,*110,EDT,Z(NEXT),LEFT,1,NX)
      GO TO 991
  110 CALL WRITE (FLIST,FLUTTR,3,0)
      CALL WRITE (FLIST,Z(NEXT),NX,1)
      IF (DEBUG) CALL BUG1 ('FLIST FLUT',110,Z(NEXT),NX)
      CALL CLOSE (FLIST,CLSREW)
      ITRL(1) = EDT
      CALL RDTRL (ITRL)
      ITRL(1) = FLIST
      CALL WRTTRL (ITRL)
  115 CONTINUE
C
C     CREATE ACPT TABLE
C
      CALL GOPEN (ACPT,Z(IBUF2),WRTREW)
C
C     STORE EXTERNAL NODE NUMBER, INTERNAL NODE NUMBER AND BASIC
C     COORDINATES OF ALL NODES ON BLADE ON SCR1
C
      CALL GOPEN (SCR1,Z(IBUF3),WRTREW)
C
C     READ STREAML1 AND STREAML2 CARDS. STORE IN-CORE
C
      NSL1A = NEXT
      CALL LOCATE (*985,Z(IBUF1),STRML1,FLAG)
      CALL READ (*993,*120,EDT,Z(NSL1A),LEFT,1,NSL1L)
      GO TO 991
  120 NSL1B = NSL1A + NSL1L - 1
      IF (DEBUG) CALL BUG1 ('STREAML1  ',120,Z(NSL1A),NSL1L)
      NSL2A = NSL1B + 1
      LEFT  = CORWDS(Z(NSL2A),Z(LAST))
      CALL LOCATE (*986,Z(IBUF1),STRML2,FLAG)
      CALL READ (*993,*130,EDT,Z(NSL2A),LEFT,1,NSL2L)
      GO TO 991
  130 NSL2B = NSL2A + NSL2L - 1
      IF (DEBUG) CALL BUG1 ('STREAML2  ',130,Z(NSL2A),NSL2L)
      CALL CLOSE (EDT,CLSREW)
C
C     INPUT CHECKS  (ALL ARE THEORY DEPENDENT RESTRICTIONS)
C     STREAML1 - ALL CARDS MUST HAVE THE SAME NUMBER OF NODES
C     STREAML2 - THERE MUST BE AT LEAST THREE(3) STREAML2 CARDS.
C                (THIS IS A THEORY DEPENDENT RESTRICTION,
C                SEE AMG MODULE - COMPRESSOR BLADE CODE FOR AJJL)
C              - NSTNS MUST BE THE SAME FOR ALL STREAML2 CARDS
C                AND MUST EQUAL THE NO. OF NODES ON THE STRAML1 CARD
C
C     COUNT THE NUMBER OF STREAML2 CARDS
C
      NLINES = NSL2L/10
      IF (DEBUG) CALL BUG1 ('NLINES    ',131,NLINES,1)
      IF (NLINES .GE. 3) GO TO 135
      NOGO = 1
      WRITE (IOUT,3001) UFM,NLINES
  135 IF (NLINES .GT. MAXSL) GO TO 988
C
C     LOCATE STREAML1 CARDS THAT CORRESPOND TO STREAML2 CARDS BY
C     MATCHING SLN VALUES
C
      NLINE = 0
      DO 140 ISLN = NSL2A,NSL2B,10
      NLINE = NLINE + 1
  140 PSTRM(NLINE) = -IZ(ISLN)
C
C     LOCATE SLN AND COUNT THE NUMBER OF COMPUTING STATIONS
C
      IPOS = NSL1A
  145 DO 150 NS = IPOS,NSL1B
      IF (IZ(NS) .EQ. -1) GO TO 155
  150 CONTINUE
C
C     CHECK FOR VALID SLN
C
  155 DO 160 NLINE = 1,NLINES
      IF (IZ(IPOS) .EQ. -PSTRM(NLINE)) GO TO 165
  160 CONTINUE
      GO TO 175
  165 PSTRM(NLINE) = IPOS
      NSTNSX = NS - IPOS - 1
      IF (.NOT.FIRST) GO TO 170
      NSTNS = NSTNSX
      FIRST = .FALSE.
      GO TO 175
C
C     ALL NSTNSX MUST BE THE SAME
C
  170 IF (NSTNSX .EQ. NSTNS) GO TO 175
      NOGO = 2
      WRITE (IOUT,3002) UFM,IZ(IPOS)
  175 IPOS = NS + 1
      IF (IPOS .LT. NSL1B) GO TO 145
C
C     IS THERE A STREAML1 CARD FOR EVERY STREAML2 CARD
C
      DO 180 NLINE = 1,NLINES
      IF (PSTRM(NLINE) .GT. 0) GO TO 180
      NOGO = 3
      ISLN = -PSTRM(NLINE)
      WRITE (IOUT,3003) UFM,ISLN
  180 CONTINUE
      IF (NOGO .GT. 0) GO TO 1000
C
C     READ BGPDT
C
      NBG1 = NSL2B + 1
      LEFT = CORWDS(Z(NBG1),Z(LAST))
      FILE = BGPDT
      CALL GOPEN (BGPDT,Z(IBUF1),RDREW)
      CALL READ (*993,*200,BGPDT,Z(NBG1),LEFT,1,NBGL)
      GO TO 991
  200 CALL CLOSE (BGPDT,CLSREW)
      IF (DEBUG) CALL BUG1 ('BGPDT     ',200,Z(NBG1),NBGL)
      NBG2 = NBG1 + NBGL - 1
C
C     READ EQEXIN (RECORD 1)
C
      NEQ1 = NBG2 + 1
      LEFT = CORWDS(Z(NEQ1),Z(LAST))
      FILE = EQEXIN
      CALL GOPEN (EQEXIN,Z(IBUF1),RDREW)
      CALL READ (*993,*210,EQEXIN,Z(NEQ1),LEFT,1,NEQL)
      GO TO 991
  210 NEQ2 = NEQ1 + NEQL - 1
      IF (DEBUG) CALL BUG1 ('EQEXIN R1 ',210,Z(NEQ1),NEQL)
C
C     READ EQEXIN (RECORD 2)
C
      NEQ21 = NEQ2 + 1
      LEFT = CORWDS(Z(NEQ21),Z(LAST))
      CALL READ (*993,*215,EQEXIN,Z(NEQ21),LEFT,1,NEQ2L)
      GO TO 991
  215 NEQ22 = NEQ2 + NEQ2L - 1
      IF (DEBUG) CALL BUG1 ('EQEXIN R2 ',212,Z(NEQ21),NEQ2L)
      CALL CLOSE (EQEXIN,CLSREW)
C
C     WRITE ACPT
C
C     KEY WORD = 6 FOR COMPRESSOR BLADES, I.E. METHOD ID = 6
C     KEY WORD = 7 FOR SWEPT TURBOPROPS , I.E. METHOD ID = 7
C
C     WRITE CONSTANT PARAMETERS, WORDS 1 - 6
C
      BUF(1) = MTHD
      BUF(2) = IREF
      BUF(3) = MACMIN
      BUF(4) = MACMAX
      BUF(5) = NLINES
      BUF(6) = NSTNS
      CALL WRITE (ACPT,BUF,6,0)
      IF (DEBUG) CALL BUG1 ('ACPT WRT 1',216,BUF,6)
C
C     WRITE STREAMLINE DATA
C
      KN = NEQL/2
      NLINE = 0
      DO 240 NSL = NSL2A,NSL2B,10
C
C     MAKE SURE NSTNS ON ALL STREAML2 CARDS IS THE SAME
C
      IF (IZ(NSL+1) .EQ. NSTNS) GO TO 217
      WRITE (IOUT,3004) UWM,IZ(NSL)
      IZ(NSL+1) = NSTNS
C
C     WRITE STREAML2 DATA
C
  217 CALL WRITE (ACPT,Z(NSL),10,0)
      IF (DEBUG) CALL BUG1 ('ACPT WRT 2',217,Z(NSL),10)
C
C     WRITE BASIC X, Y AND Z FOR EACH NODE ON STREAML1 CARD
C
      NLINE = NLINE + 1
      IPOS  = PSTRM(NLINE)
      IPOS1 = IPOS + 1
      IPOS2 = IPOS + NSTNS
      DO 230 IGDP = IPOS1,IPOS2
C
C     LOCATE INTERNAL NUMBER THAT CORRESOONDS TO THIS EXTERNAL NODE
C
      CALL BISLOC (*220,IZ(IGDP),IZ(NEQ1),2,KN,JLOC)
      GO TO 225
C
C     STREAML1 REFERNCES AN EXTERNAL ID THAT DOES NOT EXIST
C
  220 NOGO = 5
      WRITE (IOUT,3005) UFM,IZ(IPOS),IZ(IGDP)
      GO TO 230
C
C     PICK-UP BASIC GRID DATA FOR THIS NODE
C
  225 INTRL  = IZ(NEQ1+JLOC)
      ISILC  = IZ(NEQ21+JLOC)
      JLOC   = NBG1 + (INTRL-1)*4
      BUF(1) = IZ(IGDP)
      BUF(2) = INTRL
      BUF(3) = ISILC
      BUF(4) = IZ(JLOC  )
      BUF(5) = IZ(JLOC+1)
      BUF(6) = IZ(JLOC+2)
      BUF(7) = IZ(JLOC+3)
C
C     TEST FOR SCALAR POINT (CID = -1)
C
      IF (BUF(4) .GE. 0) GO TO 227
      NOGO = 6
      WRITE (IOUT,3006) UFM,IZ(IPOS),IZ(IGDP)
  227 CALL WRITE (ACPT,BUF(5),3,0)
      CALL WRITE (SCR1,BUF,7,0)
      IF (DEBUG) CALL BUG1 ('ACPT WRT 3',227,BUF,7)
C
C-----DETERMINE DIRECTION OF BLADE ROTATION VIA Y-COORDINATES AT TIP
C-----STREAMLINE. USE COORDINATES OF FIRST 2 NODES ON STREAMLINE.
C
      IF (NLINE.EQ.NLINES .AND. IGDP.EQ.IPOS1)   YTIP1 = Z(JLOC+2)
      IF (NLINE.EQ.NLINES .AND. IGDP.EQ.IPOS1+1) YTIP2 = Z(JLOC+2)
C
  230 CONTINUE
  240 CONTINUE
C
      XSIGN = 1.0
      IF (YTIP2 .LT. YTIP1) XSIGN = -1.0
      IF (DEBUG) CALL BUG1 ('XSIN      ',240,XSIGN,1)
      CALL WRITE (ACPT,0,0,1)
      CALL WRITE (SCR1,0,0,1)
      CALL CLOSE (ACPT,CLSREW)
      CALL CLOSE (SCR1,CLSREW)
      ITRL(1) = ACPT
      ITRL(2) = 1
      ITRL(3) = 0
      ITRL(4) = 0
      ITRL(5) = 0
      ITRL(6) = 0
      ITRL(7) = 0
      CALL WRTTRL (ITRL)
      IF (NOGO .GT. 0) GO TO 1000
C
C     SET OUTPUT PARAMETERS NK AND NJ FOR APPROPRIATE THEORY.
C
C     COMPRESSOR BLADES (THEORY 6) - NK = NJ = NSTNS*NLINES.
C     SWEPT TURBOPROPS  (THEORY 7) - NK = NJ = 2*NSTNS*NLINES.
C
      IF (MTHD .EQ. 6) NK = NSTNS*NLINES
      IF (MTHD .EQ. 7) NK = 2*NSTNS*NLINES
      NJ = NK
      IF (DEBUG) CALL BUG1 ('BLANK COM ',241,NK,9)
C
C     CREATE PVECT PARTITIONING VECTOR     (PVECT MAY BE PURGED)
C     PVECT IS A COLUMN PARTITIONING VECTOR TO BE USED BY MODULE PARTN
C     TO PARTITION OUT EITHER THE SINE OR COSINE COLUMNS OF MATRIX
C     PHIA WHICH IS OUTPUT BY THE CYCT2 MODULE  WHEN DOING A CYCLIC
C     NORMAL MODES ANALYSIS
C     PARAMETER MTYPE=SINE OR COSINE (DEFAULT IS COSINE)
C
C     OPEN PVECT AND WRITE HEADER
C
      CALL OPEN (*270,PVECT,Z(IBUF2),WRTREW)
C
C     TEST FOR VALID NEIGV AND KINDEX
C
      IF (NEIGV.LE.0 .OR. KINDEX.LT.0) GO TO 987
C
      CALL FNAME (PVECT,BUF)
      CALL WRITE (PVECT,BUF,2,1)
C
C     PVECT IS TO BE GENERATED
C
      LEFT = LEFT - NEQ2
      NCOL = NEIGV
      IF (KINDEX .GT. 0) NCOL = 2*NCOL
      IPOS1 = NEQ2 + 1
      IPOS2 = NEQ2 + NCOL
      DO 250 IPV = IPOS1,IPOS2
  250 Z(IPV) = 0.0
      IF (KINDEX .EQ. 0) GO TO 260
      IPOS3 = IPOS1
      IF (MTYPE(1) .NE. SINE) IPOS3 = IPOS1 + 1
      DO 255 IPV = IPOS3,IPOS2,2
  255 Z(IPV) = 1.0
  260 TYPIN  = 1
      TYPOUT = 1
      II     = 1
      NN     = NCOL
      INCR   = 1
      CALL MAKMCB (ITRL,PVECT,NCOL,2,1)
      CALL PACK (Z(IPOS1),PVECT,ITRL)
      IF (DEBUG) CALL BUG1 ('PVECT     ',260,Z(IPOS1),NCOL)
      CALL CLOSE (PVECT,CLSREW)
      CALL WRTTRL (ITRL)
  270 CONTINUE
C
C     GENERATE GTKA TRANSFORMATION MATRIX
C
C     READ CSTM INTO CORE
C
      NCSTM1 = 1
      NCSTML = 0
      FILE   = CSTM
      ITRL(1)= CSTM
      CALL RDTRL (ITRL)
      IF (ITRL(1) .NE. CSTM) GO TO 300
      LEFT = CORWDS(Z(NCSTM1),Z(LAST))
      CALL GOPEN (CSTM,Z(IBUF1),RDREW)
      CALL READ (*993,*300,CSTM,Z(NCSTM1),LEFT,1,NCSTML)
      GO TO 991
  300 NCSTM2 = NCSTM1 + NCSTML - 1
      IF (DEBUG) CALL BUG1 ('CSTM      ',300,Z(NCSTM1),NCSTML)
      CALL CLOSE (CSTM,CLSREW)
C
C     ALLOCATE WORK STORAGE
C
      IP1  = NCSTM2 + 1
      IP2  = IP1 + NSTNS
      IP3  = IP2 + NSTNS
      IP4  = IP3 + NSTNS
      NEXT = IP4 + 4*NSTNS
      LEFT = LEFT - NEXT + 1
      IF (LEFT .LE. 0) GO TO 991
C
C     GENERATE GTKA TRANSFORMATION MATRIX FOR APPROPRIATE THEORY.
C
C     COMPRESSOR BLADES (AERODYNAMIC THEORY 6).
C
      IF (MTHD .EQ. 6) CALL APDB1 (IBUF1,IBUF2,NEXT,LEFT,NSTNS,NLINES,
     1    XSIGN,NCSTML,Z(NCSTM1),Z(IP1),Z(IP2),Z(IP3),Z(IP4))
C
C     SWEPT TURBOPROPS (AERODYNAMIC THEORY 7).
C
      IF (MTHD .EQ. 7) CALL APDB2 (IBUF1,IBUF2,NEXT,LEFT,NSTNS,NLINES,
     1    XSIGN,NCSTML,Z(NCSTM1),Z(IP1),Z(IP2),Z(IP3),Z(IP4))
      GO TO 1000
C
C     ERROR MESSAGES
C
C     NO AERO CARD FOUND
  981 KODE = 1
      GO TO 989
C
C     NO MKAERO1 OR MKAERO2 CARDS FOUND
C
  982 KODE = 2
      GO TO 989
C
C     NO FLFACT CARD FOUND
C
  983 KODE = 3
      GO TO 989
C
C     NO FLUTTER CARD FOUND
C
  984 KODE = 4
      GO TO 989
C
C     NO STREAML1 CARD FOUND
C
  985 KODE = 5
      GO TO 989
C
C     NO STREAML2 CARD FOUND
C
  986 KODE = 6
      GO TO 989
C
C     NEIGV OR KINDEX INVALID
C
  987 WRITE (IOUT,2987) UFM,NEIGV,KINDEX
      GO TO 1091
C
C     MAXIMUM NUMBER OF STREAML2 CARDS EXCEEDED FOR
C     LOCAL ARRAY PSTRM. SEE ERROR MESSAGE FOR FIX.
C
  988 WRITE (IOUT,3007) UFM,MAXSL
      GO TO 1091
  989 WRITE (IOUT,2989) UFM,NAME1(KODE,1),NAME1(KODE,2)
      GO TO 1091
C
C     NOT ENOUGH CORE
C
  991 IP1 = -8
      GO TO 999
C
C     DATA SET NOT IN FIST
C
  992 IP1 = -1
      GO TO 999
C
C     E-O-F ENCOUNTERED
C
  993 IP1 = -2
      GO TO 999
C
C     E-O-L ENCOUNTERED
C
  994 IP1 = -3
  999 CALL MESAGE (IP1,FILE,NAME)
C
 1000 IF (NOGO .EQ. 0) GO TO 1099
 1091 CALL MESAGE (-37,0,NAME)
 1099 RETURN
C
 2987 FORMAT (A23,' - APDB MODULE - INVALID PARAMETER NEIGV OR KINDEX',
     1       ' INPUT.', /40X,
     2       'DATA BLOCK PVECT (FILE 205) CANNOT BE GENERATED.', /40X,
     3       7HNEIGV =,I8,10H, KINDEX =,I8)
 2989 FORMAT (A23,' - MODULE APDB - BULK DATA CARD ',2A4,
     1       ' MISSING FROM INPUT DECK.')
 3001 FORMAT (A23,' - APDB MODULE - THE NO. OF STREAML2 CARDS INPUT =',
     1       I3, /40X,'THERE MUST BE AT LEAST THREE(3) STREAML2 CARDS',
     2       ' INPUT.')
 3002 FORMAT (A23,' - APDB MODULE - ILLEGAL NO. OF NODES ON STREAML1 ',
     1       'CARD WITH SLN =',I8, /40X,
     2       'ALL STREAML1 CARDS MUST HAVE THE SAME NUMBER OF NODES.')
 3003 FORMAT (A23,' - APDB MODULE - NO STREAML1 CARD FOR THE STREAML2',
     1       ' WITH SLN =',I8)
 3004 FORMAT (A25,' - APDB MODULE - STREAML2 WITH SLN =',I8, /42X,
     1       'NSTNS INCONSISTENT WITH NO. OF NODES ON STREAML2 CARD ',
     2       'FOR BLADE ROOT.', /42X,'CORRECT VALUE OF NSTNS WILL BE ',
     3       'SUBSTITUTED ON STREAML2 CARD.')
 3005 FORMAT (A23,' - APDB MODULE - STREAML1 CARD WITH SLN =',I8,
     1       ' REFERENCES NON-EXISTENT EXTERNAL NODE =',I8)
 3006 FORMAT (A23,' - APDB MODULE - STREAML1 CARD WITH SLN =',I8,
     1       ' REFERENCES A SCALAR POINT WITH EXTERNAL ID =',I8, /40X,
     2       'SCALAR POINTS ARE ILLEGAL. USE A GRID POINT.')
 3007 FORMAT (A23,' - APDB MODULE - MAXIMUM NUMBER OF STREAML2 CARDS ',
     1       'EXCEEDED FOR LOCAL ARRAY PSTRM.', /40X,
     2       'UPDATE VARABLE MAXSL AND ARRAY PSTRM IN ROUTINE APDB.',
     3       /40X,'CURRENT VALUE OF MAXSL AND DIMENSION OF PSTRM =',I4)
      END

      SUBROUTINE READ3 (NOVECT,NCOL,SR1FIL,SR2FIL,FILC,KDBLM)
C
C     READ3 PACKS THE EIGENVECTORS AND EIGENVALUES AND PUTS THEM OUT IN
C     ASCENDING ORDER
C
C     LAST REVISED  1/92, BY G.CHAN/UNISYS
C     ZERO OUT RIGID BODY FREQUENCIES IF METHOD IS 'FEER' (NOT 'FEER-X'
C     NOR 'FEER-Q')
C
      INTEGER            SYSBUF    ,IZ(1)    ,RSP      ,RDP      ,
     1                   FILELM    ,FILEVC   ,SR1FIL   ,SR2FIL   ,
     2                   FILC      ,OPTION   ,OPTN2    ,FEER     ,
     3                   DASHZ     ,STURM
      INTEGER            RDREW
      DOUBLE PRECISION   DXX(2)
      DIMENSION          NAM(2)    ,FILEVC(7),FILELM(7)
      COMMON   /ZZZZZZ/  Z(1)
      COMMON   /STURMX/  STURM     ,SHFTPT
      COMMON   /REIGKR/  OPTION    ,OPTN2
      COMMON   /SYSTEM/  SYSBUF    ,NOUT     ,SYSTM(52),IPREC
      COMMON   /NAMES /  RD        ,RDREW    ,WRT      ,WRTREW   ,
     1                   REW       ,NOREW    ,EOFNRW   ,RSP      ,
     2                   RDP
      COMMON   /PACKX /  ITYPA     ,ITYPB    ,IPAK     ,JPAK     ,
     1                   INCR
      COMMON   /UNPAKX/  ITYPU     ,IUNP     ,JUNP     ,INCRU
      EQUIVALENCE        (IZ(1),Z(1))
      DATA      FEER  ,  DASHZ /4HFEER,   4H-X   /
      DATA      NAM   /  4HREAD,4H3   /,  I2 / 2 /
C
C     FILELM (=KDBLM=LAMA=201) WILL HOLD THE EIGENVALUES  UPON RETURN
C     FILEVC (=FILC =PHIA=202) WILL HOLD THE EIGENVECTORS UPON RETURN
C
      FILELM(1) = KDBLM
      FILEVC(1) = FILC
      ITYPA = RSP
      ITYPB = RSP
      INCR  = 1
      IPAK  = 1
      JPAK  = NCOL
      NCOL2 = IPREC*NCOL
      ITYPU = RSP
      INCRU = 1
      NOCL  = 2*NCOL + 2
      NZ    = KORSZ(Z)
      IBUF1 = NZ    - SYSBUF
      IBUF2 = IBUF1 - SYSBUF
C
C     READ IN ALL EIGENVALUES
C
      IFILE = SR1FIL
      CALL GOPEN (SR1FIL,Z(IBUF1),RDREW)
      I = 1
   10 CALL FREAD (SR1FIL,DXX,IPREC,1)
      Z(I+1) = DXX(1)
      I = I + 1
      IF (I .LE. NOVECT) GO TO 10
      CALL CLOSE (SR1FIL,REW)
C
C     SET UP AN INDEX VECTOR AND SORT THE EIGENVALUES
C
      J = NCOL + 2
      K = J + NCOL - 1
      II = 1
      DO 20 I = J,K
      IZ(I) = II
   20 II = II + 1
      Z(1) = Z(I2)
      J = 2
      K = J + NOVECT - 1
      DO 25 I = J,K
      IF (Z(I) .LT. Z(1)) Z(1) = Z(I)
   25 CONTINUE
      DO 40 I = 1,NOVECT
      K = I
   30 IF (Z(K+1) .GE. Z(K)) GO TO 40
      ZZ     = Z(K  )
      Z(K  ) = Z(K+1)
      Z(K+1) = ZZ
      J  = K + NCOL
      II = IZ(J)
      IZ(J  ) = IZ(J+1)
      IZ(J+1) = II
      K = K - 1
      GO TO 30
   40 CONTINUE
C
C     ZERO OUT RIGID BODY EIGENVALUES IF THEY ARE PRESENT AND METHOD IS
C     'FEER-Z'
C     I.E. ZERO FREQUENCIES BELOW PTSHFT AND KEEP, AS CHECKED BY STURM
C     SEQUENCE
C
      IF (STURM .LT. 0) GO TO 45
      DO 43 I = 2,NOVECT
      IK = I + STURM
      IF (Z(IK).GE.SHFTPT .OR. IK.GT.NOVECT) GO TO 45
      IF (Z(I).LT.0. .AND. OPTION.EQ.FEER .AND. OPTN2.EQ.DASHZ) Z(I)= 0.
   43 CONTINUE
C
C     READ THE EIGENVECTORS AND PACK THEM IN ASCENDING ORDER
C
   45 CALL GOPEN (FILEVC,Z(IBUF1),1)
      IFILE = SR2FIL
      CALL GOPEN (SR2FIL,Z(IBUF2),RDREW)
      IPOS = 1
      CALL MAKMCB (FILEVC(1),FILC,NCOL,2,RSP)
C
      DO 110 I = 1,NOVECT
      K  = I + NCOL + 1
      NO = IZ(K)
      IF (NO-IPOS) 50,80,70
   50 CALL REWIND (SR2FIL)
      IPOS = NO
      IF (NO .LE. 0) GO TO 120
   60 CALL SKPREC (SR2FIL,NO)
      GO TO 80
   70 NO   = NO - IPOS
      IPOS = IPOS + NO
      GO TO 60
   80 IUNP = 0
      CALL UNPACK (*90,SR2FIL,Z(NOCL))
      IPOS = IPOS + 1
      IPAK = IUNP
      JPAK = JUNP
      GO TO 100
   90 IPAK = 1
      JPAK = 1
      Z(NOCL) = 0.0
  100 CALL PACK (Z(NOCL),FILEVC,FILEVC)
  110 CONTINUE
C
      CALL CLOSE  (FILEVC(1),REW)
      CALL CLOSE  (SR2FIL,REW)
      CALL WRTTRL (FILEVC)
C
C     OUTPUT THE EIGENVALUES, 1ST DATA RECORD
C
      CALL GOPEN (FILELM,Z(IBUF1),1)
      CALL WRITE (FILELM,Z(I2),NOVECT,1)
C
C     SAVE ORDER FOUND IN 2ND DATA RECORD
C
      CALL WRITE (FILELM,IZ(NCOL+2),NOVECT,1)
      CALL CLOSE (FILELM(1),REW)
      FILELM(2) = NOVECT
      CALL WRTTRL (FILELM)
      RETURN
C
  120 CALL MESAGE (-7,FILE,NAM)
      RETURN
C
      END

      SUBROUTINE PLA4
C*****
C THIS FUNCTIONAL MODULE IS THE LAST OF FOUR FUNCTIONAL MODULES UNIQUE
C TO THE PIECE-WISE LINEAR ANALYSIS (DISPLACEMENT METHOD) RIGID FORMAT.
C*****
C DMAP CALL...
C
C PLA4   CSTM,MPT,ECPTNL,GPCT,DIT,DELTAUGV/KGGNL,ECPTNL1/V,N,PLACOUNT/V,
C        N,PLSETNO/V,N,PLFACT/ $
C
C THE OUTPUT DATA BLOCKS AND PARAMETERS ARE DEFINED AS FOLLOWS...
C
C KGGNL IS THE STIFFNESS MATRIX OF NON-LINEAR (STRESS DEPENDENT)
C       ELEMENTS.
C ECPTNL1 IS THE UP-TO-DATE VERSION OF THE INPUT DATA BLOCK, ECPTNL.
C         THAT IS, THE ECPTNL1 DATA BLOCK CONTAINS THE SAME INFORMATION
C         AS ECPTNL EXCEPT THE STRESS INFORMATION IS UPDATED.
C
C PARAMETER NAMES BELOW ARE FORTRAN RATHER THAN DMAP NAMES
C
C PLACNT IS PIECE-WISE LINEAR ANALYSIS RIGID FORMAT DMAP LOOP COUNTER.
C PLSETN IS THE PLFACT CARD SET NUMBER CHOSEN BY THE USER IN HIS CASE
C        CONTROL PACKAGE.
C PLFACT IS THE FACTOR BY WHICH THE LOAD VECTOR WILL MULTIPLIED THE NEXT
C        TIME THROUGH THE PLA DMAP LOOP
C*****
C THIS ROUTINE IS THE MODULE DRIVER.  PLA41 APPENDS DISPLACEMENT INFOR-
C MATION TO THE ECPTNL DATA BLOCK AND A SCRATCH DATA BLOCK, ECPTS, OF
C THIS MERGED INFORMATION IS CREATED.  SUBROUTINE PLA42 USES THE DATA
C BLOCK ECPTS TO CREATE THE KGGNL MATRIX.  ALSO THE UPDATED ECPT INFOR-
C MATION IS OUTPUT AS DATA BLOCK ECPTNL1 BY PLA42.
C*****
      CALL PLA41
      CALL PLA42
      RETURN
      END

      SUBROUTINE GP3B
C
C     GP3B BUILDS THE GRID POINT TEMPERATURE TABLE (GPTT).
C     TEMPD AND TEMP CARDS ARE READ.
C     THE GPTT HEADER CONTAINS THE FILE NAME PLUS 3 WORDS FOR EACH
C     TEMPERATURE SET.
C       WORD 1 = TEMP SET ID.
C       WORD 2 = DEFAULT TEMP OR -1 IF NO DEFAULT TEMP.
C       WORD 3 = RECORD NO. (AFTER HEADER RECORD) OF TEMPERATURE DATA
C                FOR THE SET, OR
C                ZERO IF ONLY A DEFAULT TEMP IS DEFINED FOR THE SET.
C     DATA RECORDS OF THE GPTT CONSIST OF PAIRS OF EXTERNAL INDEX AND
C     TEMPERATURE. EACH DATA RECORD IS SORTED ON EXTERNAL INDEX.
C
C     AN IDENTICAL SET OF RECORDS WITH INTERNAL INDICES IS APPENDED AT
C     THE END OF THE GPTT.
C
C
      LOGICAL         INTERN
      INTEGER         GEOMP ,EQEXIN,SLT   ,GPTT  ,SCR1  ,BUF1  ,BUF2  ,
     1                BUF   ,TEMP  ,TEMPD ,FILE  ,FLAG  ,Z     ,RD    ,
     2                RDREW ,WRTREW,WRT   ,CLSREW,NAM(2),GEOM3 ,ETT   ,
     3                TEMPP1,TEMPP2,TEMPP3,TEMPRB,BUF3  ,TEMPG ,TEMPP4
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /BLANK / NOGRAV,NOLOAD,NOTEMP
      COMMON /GP3COM/ GEOM3 ,EQEXIN,GEOM2 ,SLT   ,ETT   ,SCR1  ,SCR2  ,
     1                BUF1  ,BUF2  ,BUF(50)      ,CARDID(60)   ,IDNO(30)
     2,               CARDDT(60)   ,MASK(60)     ,STATUS(60)   ,NTYPES,
     3                IPLOAD,IGRAV ,PLOAD2(2)    ,LOAD(2)      ,NOPLD2,
     4                TEMP(2)      ,TEMPD(2)     ,TEMPP1(2)           ,
     5                TEMPP2(2)    ,TEMPP3(2)    ,TEMPRB(2)    ,BUF3  ,
     6                PLOAD3(2)    ,IPLD3        ,TEMPG(2)            ,
     7                TEMPP4(2)
      COMMON /NAMES / RD    ,RDREW ,WRT   ,WRTREW,CLSREW
      COMMON /ZZZZZZ/ Z(1)
      COMMON /SYSTEM/ SYSBUF,NOUT
      EQUIVALENCE     (GEOM3,GEOMP),(GPTT,SCR1)
      DATA    NAM   / 4HGP3B,4H    /
C
C     TURN NODEF FLAG ON
C
      ID    = 0
      NODEF = 0
C
C     READ EQEXIN INTO CORE
C
      FILE = EQEXIN
      CALL OPEN (*400,EQEXIN,Z(BUF2),RDREW)
      CALL FWDREC (*410,EQEXIN)
      CALL READ (*410,*10,EQEXIN,Z,BUF3,1,NEQX)
      CALL MESAGE (-8,0,NAM)
   10 CALL CLOSE (EQEXIN,CLSREW)
      KN = NEQX/2
      ITEMPD = NEQX + 1
      ITABL  = ITEMPD
C
C     READ TEMPERATURE DEFAULT CARDS (IF PRESENT)
C
      FILE = GEOMP
      CALL PRELOC (*460,Z(BUF1),GEOMP)
      CALL LOCATE (*40,Z(BUF1),TEMPD,FLAG)
      I = ITEMPD
      NODEF  = 1
      NOTEMP = 1
   20 CALL READ (*410,*30,GEOMP,Z(I),2,0,FLAG)
      I = I + 2
      GO TO 20
   30 ITABL  = I
      NTEMPD = I - 2
      N = ITABL - ITEMPD
      CALL SORT (0,0,2,1,Z(ITEMPD),N)
C
C     READ TEMP CARDS.  DETERMINE NO. OF TEMP SETS
C     FOR EACH SET ID, LOOK UP THE DEFAULT TEMPERATURE
C     WRITE SET ID, DEFAULT TEMP (OR -1) AND RECORD NUMBER
C     OF THE TEMPERATURE DATA (OR 0) IN THE GPTT HEADER
C
   40 J = 0
      K = ITEMPD
      I = ITABL
      L = 1
      FILE = GEOMP
      CALL LOCATE (*270,Z(BUF1),TEMP,FLAG)
      NOTEMP = 1
      FILE   = GPTT
      CALL OPEN  (*400,GPTT,Z(BUF2),WRTREW)
      CALL FNAME (GPTT,BUF)
      CALL WRITE (GPTT,BUF,2,0)
C
C     OPEN ETT AS TEMPORARY SCRATCH TO FORM IDENTICAL FILE WITH
C     INTERNAL NOTATION
C
      FILE = ETT
      CALL OPEN  (*400,ETT,Z(BUF3),WRTREW)
      CALL FNAME (ETT,BUF)
      CALL WRITE (ETT,BUF,2,0)
      FILE = GEOMP
   50 CALL READ (*410,*110,GEOMP,BUF,3,0,FLAG)
      J = J + 1
      IF (ID .EQ. BUF(1)) GO TO 50
      ID = BUF(1)
      Z(I) = J
      I = I + 1
      IF (NODEF .EQ.  0) GO TO 80
   60 IF (K .GT. NTEMPD) GO TO 80
      IF (ID-Z(K)) 80,90,70
   70 BUF(1) = Z(K  )
      BUF(2) = Z(K+1)
      BUF(3) = 0
      CALL WRITE (GPTT,BUF,3,0)
      CALL WRITE (ETT ,BUF,3,0)
      K = K + 2
      GO TO 60
   80 BUF(2) = -1
      GO TO 100
   90 BUF(2) = Z(K+1)
      K = K + 2
  100 BUF(3) = L
      BUF(1) = ID
      L = L + 1
      CALL WRITE (GPTT,BUF,3,0)
      CALL WRITE (ETT ,BUF,3,0)
      J = 0
      GO TO 50
  110 IF (NODEF .EQ.  0) GO TO 130
      IF (K .GT. NTEMPD) GO TO 130
      BUF(3) = 0
      DO 120 L = K,NTEMPD,2
      BUF(1) = Z(L  )
      BUF(2) = Z(L+1)
      CALL WRITE (ETT ,BUF,3,0)
  120 CALL WRITE (GPTT,BUF,3,0)
  130 CALL WRITE (GPTT,0,0,1)
      CALL WRITE (ETT ,0,0,1)
      CALL BCKREC (GEOMP)
      N = I
      Z(N) = J + 1
      I = ITABL + 1
C
C     READ EACH TEMP SET
C     SORT ON EXTERNAL INDEX AND WRITE ON GPTT
C
      IFILE  = GPTT
      INTERN = .FALSE.
      ISAVE  = I
      NOGO   = 0
  140 CALL READ (*410,*420,GEOMP,0,-3,0,FLAG)
      N1 = N + 1
  150 J  = N1
      NX = Z(I)
      NI = 1
  160 CALL READ (*410,*420,GEOMP,BUF,3,0,FLAG)
      IF (INTERN) GO TO 300
  170 Z(J  ) = BUF(2)
      Z(J+1) = BUF(3)
      J  = J + 2
      IF (J .GE. BUF3) GO TO 430
      NI = NI + 1
      IF (NI .LE. NX) GO TO 160
      NX = J - N1
      CALL SORT (0,0,2,1,Z(N1),NX)
C
C     TEST FOR UNIQUENESS OF POINT AND TEMPERATURE
C
      KHI = J  - 1
      KLO = N1 + 2
      K   = J
      IF (KLO .GE. KHI) GO TO 210
      K   = KLO
      DO 200 J = KLO,KHI,2
      IF (Z(J) .NE. Z(J-2)) GO TO 190
C
C     NOT FATAL IF SAME TEMPERATURE
C
      IF (Z(J+1) .NE. Z(J-1)) NOGO = NOGO + 1
      IF (INTERN) GO TO 200
      CALL PAGE2 (2)
      WRITE  (NOUT,180) UFM,Z(J-1),Z(J+1),Z(J)
  180 FORMAT (A23,' 2100, TEMPERATURE SPECIFIED HAS ',1P,E10.3,4H AND,
     1        1P,E10.3,' FOR GRID',I9)
      GO TO 200
C
C     VALID TEMPERATURE
C
  190 Z(K  ) = Z(J  )
      Z(K+1) = Z(J+1)
      K  = K + 2
  200 CONTINUE
C
  210 NX = K - N1
      CALL WRITE (IFILE,Z(N1),NX,1)
      I  = I + 1
      IF (I .LE. N) GO TO 150
C
C     NOW DO SAME AS ABOVE WITH OUTPUT IN INTERNAL INDEX NOTATION.
C
      IF (NOGO .NE. 0) CALL MESAGE (-61,NOGO,0)
      IF (INTERN) GO TO 220
      CALL BCKREC (GEOMP)
      INTERN = .TRUE.
      IFILE  = ETT
      I = ISAVE
      GO TO 140
C
C     NOW APPEND ENTIRE ETT FILE TO GPTT FILE
C
  220 FILE = ETT
      CALL CLOSE (ETT,CLSREW)
      CALL OPEN  (*400,ETT,Z(BUF3),RDREW)
  230 CALL READ  (*250,*240,ETT,Z,BUF3-1,0,FLAG)
      CALL WRITE (GPTT,Z,BUF3-1,0)
      GO TO 230
  240 CALL WRITE (GPTT,Z,FLAG,1)
      GO TO 230
  250 CALL CLOSE (GPTT,CLSREW)
      CALL CLOSE (ETT,CLSREW)
  260 CALL CLOSE (GEOMP,CLSREW)
      GO TO 460
C
C     NO TEMP CARDS PRESENT. IF NO DEFAULT CARDS, NO GPTT.
C     OTHERWISE, GPTT IS COMPRISED ONLY OF DEFAULT TEMPERATURES.
C     WRITE THE SET IDS AND DEFAULT TEMPS IN THE HEADER RECORD.
C
  270 IF (NODEF .EQ. 0) GO TO 260
      FILE = GPTT
      CALL OPEN  (*400,GPTT,Z(BUF2),WRTREW)
      CALL FNAME (GPTT,BUF)
      CALL WRITE (GPTT,BUF,2,0)
      FILE = ETT
      CALL OPEN  (*400,ETT,Z(BUF3),WRTREW)
      CALL FNAME (ETT,BUF)
      CALL WRITE (ETT,BUF,2,0)
      BUF(3) =  0
      DO 280 K = ITEMPD,NTEMPD,2
      BUF(1) = Z(K  )
      BUF(2) = Z(K+1)
  280 CALL WRITE (GPTT,BUF,3,0)
      CALL WRITE (ETT ,BUF,3,0)
      CALL WRITE (GPTT,0,0,1)
      CALL WRITE (ETT ,0,0,1)
      GO TO 220
C
C     INTERNAL BINARY SEARCH ROUTINE.
C
  300 KLO = 1
      KHI = KN
  310 K = (KLO+KHI+1)/2
  320 IF (BUF(2)-Z(2*K-1)) 330,390,340
  330 KHI = K
      GO TO 350
  340 KLO = K
  350 IF (KHI -KLO-1) 440,360,310
  360 IF (K .EQ. KLO) GO TO 370
      K = KLO
      GO TO 380
  370 K = KHI
  380 KLO = KHI
      GO TO 320
  390 BUF(2) = Z(2*K)
      GO TO 170
C
C     FATAL ERROR MESAGES
C
  400 J = -1
      GO TO 450
  410 J = -2
      GO TO 450
  420 J = -3
      GO TO 450
  430 J = -8
      GO TO 450
  440 CALL MESAGE (-30,9,BUF)
  450 CALL MESAGE (J,FILE,NAM)
C
  460 RETURN
      END

      SUBROUTINE STRAX1
C
C     THIS ROUTINE IS PHASE I OF STRESS DATA RECOVERY FOR THE AXI-
C     SYMMETRIC RING WITH TRIANGULAR CROSS SECTION RING
C
C     ECPT ( 1) = ELEMENT ID
C     ECPT ( 2) = SIL A                                   I
C     ECPT ( 3) = SIL B                                   I
C     ECPT ( 4) = SIL C                                   I
C     ECPT ( 5) = MATERIAL ORIENTATION ANGLE(DEGREES)     R
C     ECPT ( 7) = MATERIAL ID                             I
C     ECPT ( 8) TO ECPT(21) = STRESS PHASE ANG.           R
C     ECPT (22) = CORD. SYS. GRID POINT A (NOT USED)      I
C     ECPT (23) = R-CORD OF GRID A                        R
C     ECPT (24) = Z-CORD OF GRID A                        R
C     ECPT (25) = 0.0                                     R
C     ECPT (26) = CORD. SYS. GRID POINT B (NOT USED)      I
C     ECPT (27) = R-CORD OF GRID B                        R
C     ECPT (28) = Z-CORD OF GRID B                        R
C     ECPT (29) = 0.0                                     R
C     ECPT (30) = CORD. SYS. GRID POINT C (NOT USED)      I
C     ECPT (31) = R-CORD OF GRID C                        R
C     ECPT (32) = Z-CORD OF GRID C                        R
C     ECPT (33) = 0.0                                     R
C     ECPT (34) = EL. TEMPERATURE FOR MATERIAL PROP       R
C
C     ANY GROUP OF STATEMENTS PREFACED BY AN IF STATEMENT CONTAINING
C     ...KSYS78 OR LSYS78 ...  INDICATES CODING NECESSARY FOR THIS
C     ELEMENT*S PIEZOELECTRIC CAPABILITY
C
C     KSYS78 = 0   ELASTIC, NON-PIEZOELECTRIC MATERIAL
C     KSYS78 = 1   ELECTRICAL-ELASTIC COUPLED, PIEZOELETRIC MATERIAL
C     KSYS78 = 2   ELASTIC ONLY, PIEZOELECTRIC MATERIAL
C     LSYS78 = .TRUE. IF KSYS78 = 0, OR 2
C
      LOGICAL         PZMAT,LSYS78
      DIMENSION       IECPT(35),DELINT(12),TEO(45),ACURL(117),R(3),
     1                Z(3),ICS(3),D1(27),D2(9),ACURP1(27),ACURP2(9),
     2                GABABP(3,3),EE(63),WJP(3,3)
C     ECPT COMMON BLOCK
      COMMON /SDR2X5/ ECPT(34),DUM5(66),IDEL,IGP(3),TZ,SEL(54),TS(6),
     1                AK(81),PHI(14),SELP1(18),AKPH2(9),AKUPH(27),
     2                SELP2(27),SELP3(9)
      COMMON /SDR2X6/ GABABQ(9,9), D(81), WJ(6,9)
      COMMON /MATIN / MATIDC,MATFLG,ELTEMP,STRESS,SINTH,COSTH
      COMMON /MATOUT/ E(3),ANU(3),RHO,G(3),ALF(3),TZERO,GSUBE,MOSKP(9),
     1                SETMAT
      COMMON /MATPZ / PZOUT(51)
C     COMMON /MATPZ / CE11,CE12,CE13,CE14,CE15,CE16,CE22,CE23,CE24,CE25,
C                     CE26,CE33,CE34,CE35,CE36,CE44,CE45,CE46,CE55,CE56,
C                     CE66,E11,E12,E13,E14,E15,E16,E21,E22,E23,E24,E25,
C                     E26,E31,E32,E33,E34,E35,E36,EPS11,EPS12,EPS13,EPS2
C                     EPS23,EPS33,RHO,A1,A2,A12,TREF,GE
C
      COMMON /CONDAS/ CONSTS(5)
      COMMON /SYSTEM/ KSYSTM(77),KSYS78
      EQUIVALENCE     (IECPT(1),ECPT(1)), (Z(1),Z1), (Z(2),Z2),
     1                (R(1),R1), (R(2),R2), (R(3),R3), (Z(3),Z3),
     2                (CONSTS(1),PI), (CONSTS(4),DEGRAD),
     3                (ACURP1(1),ACURL(82)), (ACURP2(1),ACURL(109))
C
      LSYS78 = .FALSE.
      IF (KSYS78.EQ.0 .OR. KSYS78.EQ.2) LSYS78 = .TRUE.
C
C     START EXECUTION
C
C     STORE ECPT PARAMETERS IN LOCAL VARIABLES
C
      IDEL   = IECPT( 1)
      IGP(1) = IECPT( 2)
      IGP(2) = IECPT( 3)
      IGP(3) = IECPT( 4)
      MATID  = IECPT( 7)
      ICS(1) = IECPT(22)
      R(1)   = ECPT( 23)
      Z(1)   = ECPT( 24)
      D(1)   = ECPT( 25)
      ICS(2) = IECPT(26)
      R(2)   = ECPT( 27)
      Z(2)   = ECPT( 28)
      D(2)   = ECPT( 29)
      ICS(3) = IECPT(30)
      R(3)   = ECPT( 31)
      Z(3)   = ECPT( 32)
      D(3)   = ECPT( 33)
      DGAMA  = ECPT(  5)
      TEMPE  = ECPT( 34)
C
C     TEST THE VALIDITY OF THE GRID POINT COORDINATES
C
      DO 200 I = 1,3
      IF (R(I) .LE. 0.0) GO TO 910
      IF (D(I) .NE. 0.0) GO TO 910
  200 CONTINUE
C
C     COMPUTE THE ELEMENT COORDINATES
C
      ZMIN = AMIN1(Z1,Z2,Z3)
      Z1 = Z1 - ZMIN
      Z2 = Z2 - ZMIN
      Z3 = Z3 - ZMIN
C
C     FORM THE TRANSFORMATION MATRIX GABABQ (9X9) FROM FIELD COORDINATES
C     TO GRID POINT DEGREES OF FREEDOM
C
      DO 300 I = 1,81
  300 GABABQ(I,1) = 0.0
      AA = R2*Z3 + R1*Z2 + Z1*R3 - Z2*R3 - R1*Z3 - R2*Z1
      AA = 1.0/AA
      C1 = AA*(R2*Z3 - Z2*R3)
      C2 =-AA*(Z3 - Z2)
      C3 = AA*(R3 - R2)
      GABABQ(1,1) = C1
      GABABQ(1,2) = C2
      GABABQ(1,3) = C3
      GABABQ(2,4) = C1
      GABABQ(2,5) = C2
      GABABQ(2,6) = C3
      GABABQ(3,7) = C1
      GABABQ(3,8) = C2
      GABABQ(3,9) = C3
      IF (LSYS78) GO TO 302
      GABABP(1,1) = C1
      GABABP(1,2) = C2
      GABABP(1,3) = C3
  302 CONTINUE
      C1 =-AA*(R1*Z3 - Z1*R3)
      C2 = AA*(Z3 - Z1)
      C3 =-AA*(R3 - R1)
      GABABQ(4,1) = C1
      GABABQ(4,2) = C2
      GABABQ(4,3) = C3
      GABABQ(5,4) = C1
      GABABQ(5,5) = C2
      GABABQ(5,6) = C3
      GABABQ(6,7) = C1
      GABABQ(6,8) = C2
      GABABQ(6,9) = C3
      IF (LSYS78) GO TO 304
      GABABP(2,1) = C1
      GABABP(2,2) = C2
      GABABP(2,3) = C3
  304 CONTINUE
      C1 = AA*(R1*Z2 - Z1*R2)
      C2 =-AA*(Z2 - Z1)
      C3 = AA*(R2 - R1)
      GABABQ(7,1) = C1
      GABABQ(7,2) = C2
      GABABQ(7,3) = C3
      GABABQ(8,4) = C1
      GABABQ(8,5) = C2
      GABABQ(8,6) = C3
      GABABQ(9,7) = C1
      GABABQ(9,8) = C2
      GABABQ(9,9) = C3
      IF (LSYS78) GO TO 306
      GABABP(3,1) = C1
      GABABP(3,2) = C2
      GABABP(3,3) = C3
  306 CONTINUE
C
C     COMPUTE THE INTEGRAL VALUES IN ARRAY DELINT THE ORDER IS INDICATED
C     BY THE FOLLOWING TABLE
C
C       DELINT(01) = (-1,0)
C       DELINT(02) = (-1,1)
C       DELINT(03) = (-1,2)
C       DELINT(04) = (0, 0)
C       DELINT(05) = (0, 1)
C       DELINT(06) = (1, 0)
C
      RA  = (R1 + R2 + R3)/3.0
      ZA  = (Z1 + Z2 + Z3)/3.0
      RH  = AMIN1(R1,R2,R3)/10.0
      DR  = AMAX1(ABS(R1-R2),ABS(R2-R3),ABS(R3-R1))
      AREA= (R1*(Z2-Z3) + R2*(Z3-Z1) + R3*(Z1-Z2))/2.0
      I1  = 0
      DO 400 I = 1,2
      IP  = I - 2
      DO 350 J = 1,3
      IQ  = J  - 1
      I1  = I1 + 1
      IF (I1 .NE. 6) GO TO 310
      IP  = 1
      IQ  = 0
  310 IF (DR .GT. RH) GO TO 320
      DELINT(I1) = ((RA**IP)*(ZA**IQ))*AREA
      GO TO 330
  320 DELINT(I1) = AIS(3,IP,IQ,R,Z)
  330 DELINT(I1) = ABS(DELINT(I1))
  350 CONTINUE
  400 CONTINUE
C
C     LOCATE THE MATERIAL PROPERTIES IN THE MAT1 OR MAT3
C
      DGAMR  = DGAMA*DEGRAD
      COSG   = COS(DGAMR)
      SING   = SIN(DGAMR)
      SINTH  = SING
      COSTH  = COSG
      MATIDC = MATID
      MATFLG = 7
      IF (KSYS78 .GT. 0) MATFLG = 9
      ELTEMP = TEMPE
      CALL MAT (IDEL)
      PZMAT  = .FALSE.
      IF (SETMAT.EQ.4. .OR. SETMAT.EQ.5.) PZMAT = .TRUE.
      IF (PZMAT) GO TO 410
      KSAVE  = KSYS78
      KSYS78 = 0
      LSYS78 = .TRUE.
      GO TO 420
  410 RHO    = PZOUT(46)
      ALF(1) = PZOUT(47)
      ALF(2) = PZOUT(48)
      ALF(3) = PZOUT(49)
      TZERO  = PZOUT(50)
      GSUBE  = PZOUT(51)
  420 CONTINUE
      IF (SETMAT .EQ. 2.0) GO TO 920
      TZ = TZERO
      IF (KSYS78 .GT. 0) GO TO 500
C
C     SET MATERIAL PROPERTIES IN LOCAL VARIABLES (AGAIN)
C
      ER  = E(1)
      ET  = E(2)
      EZ  = E(3)
      VRO = ANU(1)
      VOZ = ANU(2)
      VZR = ANU(3)
      GOR = G(1)
      GZO = G(2)
      GRZ = G(3)
      VOR = VRO*ET/ER
      VZO = VOZ*EZ/ET
      VRZ = VZR*ER/EZ
      DEL = 1.0/(1.0-VRO*VOR-VOZ*VZO-VZR*VRZ-VRO*VOZ*VZR-VRZ*VOR*VZO)
C
C     COMPUTE ELASTIC CONSTANTS MATRIX FROM MATERIAL TO ELEMENT AXIS
C
  500 CONTINUE
      DO 510 I = 1,45
  510 TEO (I) = 0.0
      IF (KSYS78 .GT. 0) GO TO 512
      TEO ( 1) = ER*(1.0 - VOZ*VZO)*DEL
      TEO ( 2) = ER*(VZR + VZO*VOR)*DEL
      TEO ( 3) = EZ*(1.0 - VRO*VOR)*DEL
      TEO ( 4) = ER*(VOR + VZR*VOZ)*DEL
      TEO ( 5) = ET*(VZO + VRO*VZR)*DEL
      TEO ( 6) = ET*(1.0 - VRZ*VZR)*DEL
      TEO (10) = GRZ
      TEO (15) = GOR
      TEO (21) = GZO
      GO TO 514
  512 CONTINUE
C
C     PIEZOELECTRIC MATERIAL PROPERTIES STORED IN TEO(22-39)
C     DIELECTRIC MATERIAL PROPERTIES STORED IN TEO(40-45)
C     TEO(22-39) CONTAINS E-TRANSPOSE
C
      TEO( 1) = PZOUT( 1)
      TEO( 2) = PZOUT( 2)
      TEO( 3) = PZOUT( 7)
      TEO( 4) = PZOUT( 3)
      TEO( 5) = PZOUT( 8)
      TEO( 6) = PZOUT(12)
      TEO( 7) = PZOUT( 4)
      TEO( 8) = PZOUT( 9)
      TEO( 9) = PZOUT(13)
      TEO(10) = PZOUT(16)
      TEO(11) = PZOUT( 5)
      TEO(12) = PZOUT(10)
      TEO(13) = PZOUT(14)
      TEO(14) = PZOUT(17)
      TEO(15) = PZOUT(19)
      TEO(16) = PZOUT( 6)
      TEO(17) = PZOUT(11)
      TEO(18) = PZOUT(15)
      TEO(19) = PZOUT(18)
      TEO(20) = PZOUT(20)
      TEO(21) = PZOUT(21)
C
      IF (KSYS78 .EQ. 2) GO TO 514
      TEO(22) = PZOUT(22)
      TEO(23) = PZOUT(28)
      TEO(24) = PZOUT(34)
      TEO(25) = PZOUT(23)
      TEO(26) = PZOUT(29)
      TEO(27) = PZOUT(35)
      TEO(28) = PZOUT(24)
      TEO(29) = PZOUT(30)
      TEO(30) = PZOUT(36)
      TEO(31) = PZOUT(25)
      TEO(32) = PZOUT(31)
      TEO(33) = PZOUT(37)
      TEO(34) = PZOUT(26)
      TEO(35) = PZOUT(32)
      TEO(36) = PZOUT(38)
      TEO(37) = PZOUT(27)
      TEO(38) = PZOUT(33)
      TEO(39) = PZOUT(39)
      TEO(40) =-PZOUT(40)
      TEO(41) =-PZOUT(41)
      TEO(42) =-PZOUT(42)
      TEO(43) =-PZOUT(43)
      TEO(44) =-PZOUT(44)
      TEO(45) =-PZOUT(45)
  514 CONTINUE
C
      DO 520 I = 5,63
  520 EE(I) = 0.0
      C2  = COSG*COSG
      C4  = C2  *C2
      S2  = SING*SING
      S4  = S2  *S2
      C2S2= C2  *S2
      C3  = COSG*C2
      S3  = SING*S2
      CS2 = COSG*S2
      SC2 = SING*C2
      CS  = COSG*SING
C
      EE( 1) = TEO(1)*C4 + TEO(3)*S4 + 2.0*C2S2*(TEO(2) + 2.0*TEO(10))
      EE( 2) = TEO(2)*(C4+S4) + C2S2*(TEO(1) + TEO(3)-4.0*TEO(10))
      EE( 3) = TEO(4)*C2 + TEO(5)*S2
      EE( 4) = COSG*SING*S2*(TEO(2)-TEO(3) + 2.0*TEO(10))
     4       + SING*COSG*C2*(TEO(1)-TEO(2) - 2.0*TEO(10))
      EE( 7) = EE(2)
      EE( 8) = TEO(1)*S4 + 2.0*C2S2*(TEO(2) + 2.0*TEO(10)) + TEO(3)*C4
      EE( 9) = TEO(4)*S2 + TEO(5)*C2
      EE(10) = SING*COSG*C2 * (TEO(2)-TEO(3) + 2.0*TEO(10))
     O       + COSG*SING*S2 * (TEO(1)-TEO(2) - 2.0*TEO(10))
      EE(13) = EE(3)
      EE(14) = EE(9)
      EE(15) = TEO(6)
      EE(16) = SING*COSG*(TEO(4)-TEO(5))
      EE(19) = EE(4)
      EE(20) = EE(10)
      EE(21) = EE(16)
      EE(22) = C2S2*(TEO(1) - 2.0*TEO(2) + TEO(3)) + TEO(10)*(C2-S2)**2
      EE(29) = TEO(15)*C2 + TEO(21)*S2
      EE(30) = SING*COSG*(TEO(15)-TEO(21))
      EE(35) = EE(30)
      EE(36) = TEO(15)*S2 + TEO(21)*C2
      IF (LSYS78) GO TO 530
C
C     PIEZOELECTRIC MATERIAL PROPERTIES IN ELEMENT COORDINATES
C
      EE(37) = C3*TEO(22) - S3*TEO(26) + CS2*(TEO(25)+2.0*TEO(32))
     7       - SC2*(TEO(23)+2.0*TEO(31))
      EE(38) = C3*TEO(23) + S3*TEO(25) + CS2*(TEO(26)-2.0*TEO(31))
     8       + SC2*(TEO(22)-2.0*TEO(32))
      EE(39) = S2*TEO(27) + C2*TEO(24) - 2.0*CS*TEO(33)
      EE(40) = C3*TEO(25) - S3*TEO(23) + CS2*(TEO(22)-2.0*TEO(32))
     O       - SC2*(TEO(26)-2.0*TEO(31))
      EE(41) = C3*TEO(26) + S3*TEO(22) + CS2*(TEO(23)+2.0*TEO(31))
     1       + SC2*( TEO(25)+2.0*TEO(32))
      EE(42) = S2*TEO(24) + C2*TEO(27) + 2.0*CS*TEO(33)
      EE(43) = COSG*TEO(28) - SING*TEO(29)
      EE(44) = COSG*TEO(29) + SING*TEO(28)
      EE(45) = TEO(30)
      EE(46) = C3*TEO(31) + S3*TEO(32) - CS2*(TEO(23)-TEO(26)+TEO(31))
     6       + SC2*(-TEO(32)-TEO(25)+TEO(22))
      EE(47) = C3*TEO(32) - S3*TEO(31) - CS2*(TEO(25)-TEO(22)+TEO(32))
     7       + SC2*(TEO(23)+TEO(31)-TEO(26))
      EE(48) = (C2-S2)*TEO(33) + CS*(TEO(24)-TEO(27))
      EE(49) = C2*TEO(34) + S2*TEO(38) - CS*(TEO(35)+TEO(37))
      EE(50) = C2*TEO(35) - S2*TEO(37) + CS*(TEO(34)-TEO(38))
      EE(51) = COSG*TEO(36) - SING*TEO(39)
      EE(52) = C2*TEO(37) - S2*TEO(35) - CS*(TEO(38)-TEO(34))
      EE(53) = C2*TEO(38) + S2*TEO(34) + CS*(TEO(35)+TEO(37))
      EE(54) = COSG*TEO(39) + SING*TEO(36)
C
C     DIELECTRIC MATERIAL PROPERTIES IN ELEMENT COORDINTES
C
      EE(55) = S2*TEO(43) - 2.0*CS*TEO(41) + C2*TEO(40)
      EE(56) = (C2-S2)*TEO(41) - CS*(TEO(43)-TEO(40))
      EE(57) =-SING*TEO(44) + COSG*TEO(42)
      EE(59) = C2*TEO(43) + 2.0*CS*TEO(41) + S2*TEO(40)
      EE(60) = COSG*TEO(44) + SING*TEO(42)
      EE(63) = TEO(45)
  530 CONTINUE
C
      IECPT(1) = IECPT(1) - (IECPT(1)/1000)*1000 - 1
      AJHO  = IECPT(1)
      AJJHO = AJHO*AJHO
C
C     FORM THE ELEMENT STIFFNESS MATRIX IN FIELD SYSTEM
C
      ACURL( 1) = (EE(15) + AJJHO*EE(29))*DELINT(1)
      ACURL( 2) = (EE( 3) + EE(15) + AJJHO*EE(29))*DELINT(4)
      ACURL( 3) = (EE(15) + AJJHO*EE(29))*DELINT(2) + EE(16)*DELINT(4)
      ACURL( 4) = (EE(15) + EE(29))*AJHO*DELINT(1)
      ACURL( 5) = EE(15)*AJHO*DELINT(4)
      ACURL( 6) = (EE(15)+EE(29))*AJHO*DELINT(2) - EE(30)*AJHO*DELINT(4)
      ACURL( 7) = AJJHO*DELINT(1)*EE(35)
      ACURL( 8) = (EE(16) + AJJHO*EE(35))*DELINT(4)
      ACURL( 9) = EE(9)*DELINT(4) + AJJHO*DELINT(2)*EE(35)
      ACURL(11) = (EE(1) + 2.0*EE(3) + EE(15) + AJJHO*EE(29))*DELINT(6)
      ACURL(12) = (EE(3) + EE(15) + AJJHO*EE(29))*DELINT(5)
     1          + (EE(4) + EE (16))*DELINT(6)
      ACURL(13) = (EE(3) + EE(15) + EE(29))*AJHO*DELINT(4)
      ACURL(14) = (EE(3) + EE(15))*DELINT(6)*AJHO
      ACURL(15) = (EE(3) + EE(15) + EE(29))*AJHO*DELINT(5)
     1          - AJHO*EE(30)*DELINT(6)
      ACURL(16) = AJJHO*DELINT(4)*EE(35)
      ACURL(17) = (EE(4) + EE(16) + AJJHO*EE(35))*DELINT(6)
      ACURL(18) = (EE(2) + EE(9))*DELINT(6) + AJJHO*DELINT(5)*EE(35)
      ACURL(21) = (EE(15) + AJJHO*EE(29))*DELINT(3) + EE(22)*DELINT(6)
     1          + 2.0*EE(16)*DELINT(5)
      ACURL(22) = (EE(15) + EE(29))*AJHO*DELINT(2)
     1          + AJHO*DELINT(4)*EE(16)
      ACURL(23) = EE(15)*AJHO*DELINT(5) + AJHO*DELINT(6)*EE(16)
      ACURL(24) = (EE(15) + EE(29))*AJHO*DELINT(3)
     1          + (EE(16) - EE(30))*AJHO*DELINT(5)
      ACURL(25) = AJJHO*DELINT(2)*EE(35)
      ACURL(26) = EE(22)*DELINT(6) + (EE(21) + AJJHO*EE(35))*DELINT(5)
      ACURL(27) = EE(9)*DELINT(5) + EE(10)*DELINT(6)
     1          + AJJHO*DELINT(3)*EE(35)
      ACURL(31) = (EE(29) + AJJHO*EE(15))*DELINT(1)
      ACURL(32) = EE(15)*AJJHO*DELINT(4)
      ACURL(33) = (EE(29) + AJJHO*EE(15))*DELINT(2) - EE(30)*DELINT(4)
      ACURL(34) = AJHO*DELINT(1)*EE(35)
      ACURL(35) = AJHO*(EE(16) + EE(35))*DELINT(4)
      ACURL(36) = EE(9)*AJHO*DELINT(4) + AJHO*DELINT(2)*EE(35)
      ACURL(41) = AJJHO*DELINT(6)*EE(15)
      ACURL(42) = EE(15)*AJJHO*DELINT(5)
      ACURL(43) = 0.0
      ACURL(44) = AJHO*DELINT(6)*EE(16)
      ACURL(45) = EE(9)*AJHO*DELINT(6)
      ACURL(51) = (EE(29) + AJJHO*EE(15))*DELINT(3) + EE(36)*DELINT(6)
     1          - 2.0*DELINT(5)*EE(35)
      ACURL(52) = AJHO*(DELINT(2)*EE(30) - DELINT(4)*EE(36))
      ACURL(53) = -EE(36)*AJHO*DELINT(6) + AJHO*(EE(16)
     1          + EE(35))*DELINT(5)
      ACURL(54) = (EE(9) - EE(36))*AJHO*DELINT(5)
     1          + AJHO*DELINT(3)*EE(35)
      ACURL(61) = EE(36)*AJJHO*DELINT(1)
      ACURL(62) = EE(36)*AJJHO*DELINT(4)
      ACURL(63) = (EE(36))*AJJHO*DELINT(2)
      ACURL(71) = (EE(22) + AJJHO*EE(36))*DELINT(6)
      ACURL(72) = EE(36)*AJJHO*DELINT(5) + EE(20)*DELINT(6)
      ACURL(81) = EE(36)*AJJHO*DELINT(3) + EE(8)*DELINT(6)
C
      IF (LSYS78) GO TO 540
      ACURL(82) =-(EE(45)-AJHO*EE(51))*AJHO*DELINT(1)
      ACURL(83) = (EE(43)-AJHO*EE(45)-AJHO*EE(49)
     3          + AJJHO*EE(51))*DELINT(4)
      ACURL(84) = (EE(44)-AJHO*EE(50))*DELINT(4)-(EE(45)
     4          - AJHO*EE(51))*AJHO*DELINT(2)
      ACURL(85) =-(EE(39)+EE(45)-AJHO*EE(51))*AJHO*DELINT(4)
      ACURL(86) = (EE(37)+EE(43)-(EE(39)+EE(45)+EE(49)
     6          - AJHO*EE(51))*AJHO)*DELINT(6)
      ACURL(87) = (EE(38)+EE(44)-AJHO*EE(50))*DELINT(6)-(EE(39)+EE(45)
     7          - AJHO*EE(51))*AJHO*DELINT(5)
      ACURL(88) =-(EE(45)-AJHO*EE(51))*AJHO*DELINT(2)-EE(48)*AJHO*
     8            DELINT(4)
      ACURL(89) = (EE(43)-AJHO*EE(45)-AJHO*EE(49)+AJJHO*EE(51))*
     9            DELINT(5) +(EE(46)-EE(48)*AJHO)*DELINT(6)
      ACURL(90) = (EE(44)-AJHO*EE(48)-AJHO*EE(50))*DELINT(5)+EE(47)*
     O            DELINT(6) - (EE(45)-AJHO*EE(51))*AJHO*DELINT(3)
      ACURL(91) =-(EE(45)*AJHO-EE(51))*AJHO*DELINT(1)
      ACURL(92) = (AJHO*EE(43)-AJJHO*EE(45)-EE(49)+AJHO*EE(51))*
     2            DELINT(4)
      ACURL(93) = (EE(44)*AJHO-EE(50))*DELINT(4)-(EE(45)*AJHO-EE(51))*
     3            AJHO*DELINT(2)
      ACURL(94) =-EE(45)*AJJHO*DELINT(4)
      ACURL(95) = (EE(43)-AJHO*EE(45))*AJHO*DELINT(6)
      ACURL(96) = EE(44)*AJHO*DELINT(6)-EE(45)*AJJHO*DELINT(5)
      ACURL(97) =-(EE(45)*AJHO-EE(51))*AJHO*DELINT(2)-EE(54)*AJHO*
     7            DELINT(4)
      ACURL(98) = (EE(43)*AJHO-AJJHO*EE(45)-EE(49)+EE(51)*AJHO)*
     8            DELINT(5)+(EE(52)-AJHO*EE(54))*DELINT(6)
      ACURL(99) = (EE(44)*AJHO-EE(50)-EE(54)*AJHO)*DELINT(5)+EE(53)*
     9            DELINT(6)-(EE(45)*AJHO-EE(51))*AJHO*DELINT(3)
      ACURL(100) = EE(54)*AJJHO*DELINT(1)
      ACURL(101) =-(EE(52)-EE(54)*AJHO)*AJHO*DELINT(4)
      ACURL(102) =-(EE(53)*DELINT(4)-EE(54)*AJHO*DELINT(2))*AJHO
      ACURL(103) =-(EE(48)-EE(54)*AJHO)*AJHO*DELINT(4)
      ACURL(104) = (EE(46)-EE(48)*AJHO-EE(52)*AJHO+EE(54)*AJJHO)*
     4             DELINT(6)
      ACURL(105) = (EE(47)-EE(53)*AJHO)*DELINT(6)-(EE(48)-EE(54)*AJHO)*
     5             AJHO*DELINT(5)
      ACURL(106) = EE(54)*AJJHO*DELINT(2)-EE(42)*AJHO*DELINT(4)
      ACURL(107) = (EE(40)-EE(42)*AJHO)*DELINT(6)-(EE(52)-EE(54)*AJHO)*
     7             AJHO*DELINT(5)
      ACURL(108) = EE(41)*DELINT(6)+(-EE(42)-EE(53))*AJHO*DELINT(5)+
     8             EE(54)*AJJHO*DELINT(3)
      ACURL(109) = EE(63)*AJJHO*DELINT(1)
      ACURL(110) = (-EE(57)+EE(63)*AJHO)*AJHO*DELINT(4)
      ACURL(111) =-EE(60)*AJHO*DELINT(4)+EE(63)*AJJHO*DELINT(2)
      ACURL(112) = ACURL(110)
      ACURL(113) = (EE(55)-2.0*EE(57)*AJHO+EE(63)*AJJHO)*DELINT(6)
      ACURL(114) = (EE(56)-EE(60)*AJHO)*DELINT(6)+(-EE(57)+EE(63)*AJHO)*
     4             AJHO*DELINT(5)
      ACURL(115) = ACURL(111)
      ACURL(116) = ACURL(114)
      ACURL(117) = EE(59)*DELINT(6)-2.0*EE(60)*AJHO*DELINT(5)+EE(63)*
     7             AJJHO*DELINT(3)
  540 CONTINUE
C
C     EXPAND ACURL INTO (9X9)
C
      DO 610 IB = 2,9
      IC = 10*IB - 19
      I  = IC
      DO 605 J = IB,9
      IC = IC + 9
      I  = I + 1
  605 ACURL(IC) = ACURL(I)
  610 CONTINUE
      DGAMR = PI
      IF (AJHO .EQ. 0) DGAMR = 2.0*PI
      DO 630 I = 1,81
  630 ACURL(I) = DGAMR*ACURL(I)
C
      IF (LSYS78) GO TO 640
      DO 635 I = 82,117
  635 ACURL(I) = ACURL(I)*DGAMR
  640 CONTINUE
C
C     TRANSFORM THE ELEMENT STIFFNESS MATRIX FROM FIELD SYSTEM
C     TO GRID POINT DEGREES OF FREEDOM
C
      CALL GMMATS (GABABQ,9,9,1, ACURL,9,9,0,D )
      CALL GMMATS (     D,9,9,0,GABABQ,9,9,0,AK)
C
      IF (LSYS78) GO TO 650
      CALL GMMATS (GABABQ,9,9,1,ACURP1,9,3,0,D1   )
      CALL GMMATS (    D1,9,3,0,GABABP,3,3,0,AKUPH)
      CALL GMMATS (GABABP,3,3,1,ACURP2,3,3,0,D2   )
      CALL GMMATS (    D2,3,3,0,GABABP,3,3,0,AKPH2)
  650 CONTINUE
C
C
C     LOCATE THE TRANSFORMATION MATRICES FOR THE THREE GRID POINTS
C     **** COORDINATE SYS NOT POSSIBLE WITH RINGAX ********
C     **** THE FOLLOWING CODE COULD IMPLEMENT IT   ********
C     **   IF FOLLOWING CODE IS IMPLEMENTED MUST BE MODIFIED FOR
C          PIEZOELECTRIC
C.    DO 750 I = 1,81
C.750 AKI(I) = 0.00
C.    DO 800 I = 1,3
C.    CALL TRANSS (ICS(I),D(1))
C.    K = 30*(I-1) + 1
C.    DO 800 J = 1,3
C.    KK = K + 9*(J-1)
C.    JJ = 3*(J-1) + 1
C.    AKI(KK  ) = D(JJ  )
C.    AKI(KK+1) = D(JJ+1)
C.    AKI(KK+2) = D(JJ+2)
C.800 CONTINUE
C
C     TRANSFORM THE STIFFNESS MATRIX FROM BASIC TO LOCAL COORDINATES
C
C.    CALL GMMATS (AKI,9,9,1, AK,9,9,0,D )
C.    CALL GMMATS (  D,9,9,0,AKI,9,9,0,AK)
C
C     FORM WJ MATRIX
C
      DO 1000 I = 1,6
      DO 1000 J = 1,9
 1000 WJ (I,J) = 0.0
      RSUM = 0.0
      ZSUM = 0.0
      DO 1040 I = 1,3
      RSUM = RSUM + R(I)
 1040 ZSUM = ZSUM + Z(I)
      RSUM = RSUM/3.0
      ZSUM = ZSUM/3.0
      ZDR  = ZSUM/RSUM
      WJ (1,2) = 1.0
      WJ (2,9) = 1.0
      WJ (3,1) = 1.0/RSUM
      WJ (3,2) = 1.0
      WJ (3,3) = ZDR
      WJ (3,4) = AJHO/RSUM
      WJ (3,5) = AJHO
      WJ (3,6) = AJHO*ZDR
      WJ (4,3) = 1.0
      WJ (4,8) = 1.0
      WJ (5,1) =-AJHO/RSUM
      WJ (5,2) =-AJHO
      WJ (5,3) =-AJHO*ZDR
      WJ (5,4) =-1.0/RSUM
      WJ (5,6) =-ZDR
      WJ (6,6) = 1.0
      WJ (6,7) =-AJHO/RSUM
      WJ (6,8) =-AJHO
      WJ (6,9) =-AJHO*ZDR
C
      IF (LSYS78) GO TO 1060
C
C     FORM WJP MATRIX
C
      DO 1050 I = 1,3
      DO 1050 J = 1,3
 1050 WJP(I,J) = 0.0
C
      WJP(1,2) = 1.0
      WJP(2,3) = 1.0
      WJP(3,1) = -AJHO/RSUM
      WJP(3,2) = -AJHO
      WJP(3,3) = -AJHO*ZDR
 1060 CONTINUE
C
C     COMPUTE THE STRESS MATRIX
C
      CALL GMMATS (   WJ,9,6,1,GABABQ,9,9,0,D(1))
      CALL GMMATS (EE(1),6,6,0,  D(1),6,9,0,SEL )
      IF (LSYS78) GO TO 1070
      CALL GMMATS (   WJP,3,3,1,GABABP,3,3,0,D2(1))
      CALL GMMATS (EE(37),6,3,0, D2(1),3,3,0,SELP1)
      CALL GMMATS (EE(37),6,3,1,  D(1),6,9,0,SELP2)
      CALL GMMATS (EE(55),3,3,0, D2(1),3,3,0,SELP3)
 1070 CONTINUE
C
C    *** MORE CORD SYS REMOVAL.  FEL ABOVE IS WJ **********
C    **  IF FOLLOWING CODE IS IMPLEMENTED MUST BE MODIFIED FOR
C        PIEZOELECTRIC
C
C.    CALL GMMATS (WJ,6,9,0, AK,9,9,0, SEL)
C
C
C     TRANSFORM THE STRESS MATRIX FROM BASIC TO LOCAL COORDINATES
C
C     COMPUTE THE THE THERMAL STRESS
C
      TS(1) = EE( 1)*ALF(1) + EE( 2)*ALF(3) + EE( 3)*ALF(2)
      TS(2) = EE( 7)*ALF(1) + EE( 8)*ALF(3) + EE( 9)*ALF(2)
      TS(3) = EE(13)*ALF(1) + EE(14)*ALF(3) + EE(15)*ALF(2)
      TS(4) = EE(19)*ALF(1) + EE(20)*ALF(3) + EE(21)*ALF(2)
      TS(5) = 0.0
      TS(6) = 0.0
      DO 1100 IKI = 1,14
      PHI(IKI) = ECPT(7+IKI)
 1100 CONTINUE
      GO TO 940
C
C     SET FATAL ERROR FLAG AND ALLOWING ERROR MESSAGES TO ACCUMULATE
C
  910 I = 37
      GO TO 930
  920 I = 126
  930 CALL MESAGE (30,I,IDEL)
      NOGO = 1
  940 IF (.NOT.PZMAT) KSYS78 = KSAVE
      RETURN
      END

      SUBROUTINE EMA1
C
C     EMA1 ASSEMBLES A STRUCTURAL MATRIX FOR THE MODEL FROM EACH OF
C     THE INDIVIDUAL ELEMENT STRUCTURAL MATRICES.
C
C     EMA1   GPECT,KDICT,KELEM,SIL,ECT / KGG / C,N,NOK4/ C,N,WTMASS
C
C     NOK4 .NE. -1 MEANS MULTIPLY BY DAMPING FACTOR (GE)
C     ABS(WTMASS-1.0) .GT. 1.E-6 MEANS MULTIPLY BY WTMASS
C
C     EMA1 USES 2 SCRATCH FILES
C
      LOGICAL          LAST
      INTEGER          SYSTEM  ,SYSBUF ,ZI(1)  ,RD     ,RDREW  ,WRT   ,
     1                 WRTREW  ,CLSREW ,CLS    ,GPECT  ,SIL    ,ECT   ,
     2                 SUBNAM(2)       ,SCR1   ,SCR2   ,ELEM   ,DOFG  ,
     3                 MCBKGG(7)       ,TYPIN1 ,TYPOU1 ,TYPIN2 ,PREC  ,
     4                 TRLSIL(7)       ,EVEN   ,BUF(10),BUF1   ,BUF2  ,
     5                 BUF3    ,OPENW  ,OPENR  ,SILNBR ,OPCLS  ,MCB(7),
     6                 TT(3)   ,OLDCOD ,SCALAS(32)     ,DOF           ,
     7                 BLOCK(20)
      REAL             ZS(1)   ,XS(4)
      DOUBLE PRECISION ZD      ,XD     ,D
      CHARACTER        UFM*23  ,UWM*25 ,UIM*29 ,SFM*25
      COMMON /XMSSG /  UFM     ,UWM    ,UIM    ,SFM
      COMMON /SYSTEM/  SYSTEM(80)
      COMMON /NAMES /  RD      ,RDREW  ,WRT    ,WRTREW ,CLSREW ,CLS
      COMMON /BLANK /  NOK4    ,WTMASS
      COMMON /PACKX /  TYPIN1  ,TYPOU1 ,II1    ,JJ1    ,INCR1
      COMMON /UNPAKX/  TYPIN2  ,II2    ,JJ2    ,INCR2
      COMMON /ZBLPKX/  XD(2)   ,IX
      COMMON /GPTA1 /  NELEM   ,JLAST  ,INCRE  ,ELEM(1)
      COMMON /MA1XX /  D(18)
      COMMON /ZZZZZZ/  ZD(1)
      EQUIVALENCE      (SYSTEM(1),SYSBUF), (SYSTEM(2),NOUT),
     1                 (TRLSIL(2),NBRSIL), (TRLSIL(3),LUSET),
     2                 (SYSTEM(22),MACH ), (ZD(1),ZS(1),ZI(1)),
     3                 (XD(1),XS(1))
C
C     DEFINITION OF INPUT DATA BLOCKS
C
      DATA    GPECT ,  KDICT, KELEM, SIL, ECT  /
     1        101   ,  102  , 103  , 104, 105  /
C
C     DEFINITION OF OUTPUT DATA BLOCKS
C
      DATA    KGG   /  201  /
C
C     DEFINITION OF SCRATCH FILES
C
      DATA    SCR1  ,  SCR2 / 301, 302 /
C
C     MISCELANEOUS DATA
C
      DATA    SUBNAM/  4HEMA1,4H    /, NHEMA1/ 4HEMA1/,
     1        LARGE /  2147483647   /, LPCB  / 8     /
C
C     DATA    TERMS /  1, 0, 9, 0, 0, 18 /,
C    1        SCL   /  1, 1, 0           /
C
C     STATEMENT FUNCTION
C
      EVEN(N) = 2*((N+1)/2)
C
C     PERFORM GENERALIZATION
C
      LCORE = KORSZ(ZD)
      TRLSIL(1) = SIL
      CALL RDTRL (TRLSIL)
      WRITE  (NOUT,999) (TRLSIL(I),I=1,7)
  999 FORMAT (1H ,7I10)
      ISIL0 = LCORE - NBRSIL - 1
      LCORE = ISIL0
      BUF1  = LCORE - SYSBUF
      BUF2  = BUF1 - SYSBUF
      BUF3  = BUF2 - SYSBUF
      BUF(1)= KELEM
      CALL RDTRL (BUF)
      WRITE (NOUT,999) (BUF(I),I=1,7)
      PREC  = BUF(2)
      CALL MAKMCB (MCBKGG,KGG,LUSET,6,PREC)
      OPENW = WRTREW
      OPENR = RDREW
      LAST  = .FALSE.
      SILNBR= 0
      OPCLS = CLS
      MAXDCT= 0
      MAXVEC= 0
      OLDCOD= 0
C
C     SET SWITCH FOR MULTIPLICATION BY DAMPING AND/OR WEIGHT MASS FACTOR
C
      EPS = ABS(WTMASS-1.0)
      IF (EPS.LT.1.E-6 .AND. NOK4.LT.0) ASSIGN 244 TO KFACT
      IF (EPS.LT.1.E-6 .AND. NOK4.GE.0) ASSIGN 245 TO KFACT
      IF (EPS.GE.1.E-6 .AND. NOK4.LT.0) ASSIGN 246 TO KFACT
      IF (EPS.GE.1.E-6 .AND. NOK4.GE.0) ASSIGN 247 TO KFACT
C
C     READ THE CONTENTS OF THE SIL DATA BLOCK INTO CORE
C
      CALL GOPEN (SIL,ZI(BUF1),RDREW)
      CALL FREAD (SIL,ZI(ISIL0+1),NBRSIL,1)
      CALL CLOSE (SIL,CLSREW)
      ZI(ISIL0+NBRSIL+1) = LUSET + 1
      CALL CDCBUG (NHEMA1,100,ZI(ISIL0+1),NBRSIL+1)
C
C     READ THE KDICT AND ECT DATA BLOCKS. WRITE A MODIFIED KDICT ON SCR2
C     WHICH INCLUDES THE INTERNAL GRID NUMBERS FOR EACH ELEMENT.
C     THE FORMAT FOR EACH RECORD ON SCR2 IS...
C     3-WORD RECORD HEADER
C        1  ELEMENT TYPE
C        2  NBR OF WORDS PER ENTRY( N )
C        3  NBR OF GRID POINTS PER ENTRY
C     N-WORD ELEMENT ENTRY
C        1  ELEMENT ID( INTERNAL NUMBER )
C        2  FORM OF COLUMN PARTITIONS( 1=RECT, 2=DIAG )
C        3  NUMBER OF TERMS PER COLUMN PARTITION
C        4  SCALAR CODE DEFINING DOF PER GRID POINT
C        5  GE
C        6  INTERNAL INDEX OF 1ST GRID POINT
C        7  GINO ADDRESS OF 1ST COLUMN PARTITION
C       ...
C       N-1 INTERNAL INDEX OF LAST GRID POINT
C        N  GINO ADDRESS OF LAST COLUMN PARTITION
C
C     NOTE...
C     GRID POINTS ARE IN SORT BY INTERNAL INDEX. ZERO INDICATES
C     MISSING GRID POINT. ANY ZERO-S ARE LAST IN LIST.
C
      CALL GOPEN (KDICT,ZI(BUF1),RDREW )
      CALL GOPEN (ECT  ,ZI(BUF2),RDREW )
      CALL GOPEN (SCR2 ,ZI(BUF3),WRTREW)
  111 CALL READ  (*124,*111,KDICT,BUF(4),3,0,J)
      CALL CDCBUG (NHEMA1,111,BUF(4),3)
  112 CALL ECTLOC (*900,ECT,BUF,I)
      CALL CDCBUG (NHEMA1,112,BUF,3)
      IF (ELEM(I+2) .EQ. BUF(4)) GO TO 114
      CALL SKPREC (ECT,1)
      GO TO 112
  114 BUF(5) = BUF(5) + BUF(6)
      CALL WRITE (SCR2,BUF(4),3,0)
      IGRID  = ELEM(I+12)
      NBRGRD = ELEM(I+ 9)
      NWDECT = ELEM(I+ 5)
      IDICT  = NWDECT + 1
      NWDDCT = BUF(5) - BUF(6)
      NGRID  = IGRID + NBRGRD - 1
      MAXDCT = MAX0(MAXDCT,BUF(5))
      IF (NBRGRD .NE. BUF(6)) GO TO 901
  115 CALL READ (*122,*122,ECT,ZI,NWDECT,0,J)
      CALL CDCBUG (NHEMA1,115,ZI,NWDECT)
      CALL FREAD (KDICT,ZI(IDICT),NWDDCT,0)
      CALL CDCBUG (NHEMA1,116,ZI(IDICT),NWDDCT)
      DO 116 J = IGRID,NGRID
      IF (ZI(J) .EQ. 0) ZI(J) = LARGE
  116 CONTINUE
      CALL SORT (0,0,1,1,ZI(IGRID),NBRGRD)
      DO 118 J = IGRID,NGRID
      IF (ZI(J) .EQ. LARGE) ZI(J) = 0
  118 CONTINUE
      CALL CDCBUG (NHEMA1,118,ZI(IGRID),NBRGRD)
      CALL WRITE  (SCR2,ZI(IDICT),NWDDCT-NBRGRD,0)
      ILOC = IDICT + NWDDCT - NBRGRD
      DO 120 J = 1,NBRGRD
      CALL WRITE (SCR2,ZI(IGRID+J-1),1,0)
      CALL WRITE (SCR2,ZI(ILOC +J-1),1,0)
  120 CONTINUE
      MAXVEC = MAX0(MAXVEC,ZI(IDICT+2)*PREC)
      GO TO 115
  122 CALL SKPREC (KDICT,1)
      CALL WRITE (SCR2,0,0,1)
      GO TO 111
  124 CALL CLOSE (KDICT,CLSREW)
      CALL CLOSE (  ECT,CLSREW)
      CALL CLOSE ( SCR2,CLSREW)
      TT(1) = MAXDCT
      TT(2) = MAXVEC
      CALL CDCBUG (NHEMA1,125,TT,2)
C
C     READ GPECT AND PREPARE THE SCR1 DATA BLOCK. FOR EACH GRID/SCALAR
C     POINT, TWO RECORDS ARE WRITTEN. THE 1ST CONTAINS 6 WORDS...
C       1  INTERNAL INDEX OF GRID/SCALAR POINT
C       2  DOF OF POINT (1=SCALAR, 6=GRID)
C       3  DOF OF EACH CONNECTED POINT (0 IF NO CONNECTED POINTS)
C       4  NUMBER OF CONNECTED POINTS
C       5  INDEX OF  1ST CONNECTED POINT
C       6  INDEX OF LAST CONNECTED POINT
C
C     THE 2ND RECORD IS A PACKED COLUMN WHICH CONTAINS A NON-ZERO TERM
C     FOR EACH CONNECTED POINT.
C
      TYPIN1 = 1
      TYPOU1 = 1
      INCR1  = 1
      INCR2  = 1
      CALL MAKMCB (MCB,SCR1,NBRSIL,1,1)
      ILOOK0 = NBRSIL + 1
      IF (ILOOK0+LUSET+1 .GE. BUF3) CALL MESAGE (-8,0,SUBNAM)
      DO 131 I = 1,NBRSIL
      J = ZI(ISIL0+I)
      ZI(ILOOK0+J) = I
  131 CONTINUE
      CALL CDCBUG (NHEMA1,131,ZI(ILOOK0+1),LUSET)
      CALL GOPEN (GPECT,ZI(BUF1),RDREW )
      CALL GOPEN (SCR1 ,ZI(BUF2),WRTREW)
      DO 148 II = 1,NBRSIL
      NBRCON = BUF(4)
      MINNBR = BUF(5)
      MAXNBR = BUF(6)
      IF (II .NE. 1) GO TO 130
      NBRCON = NBRSIL
      MINNBR = 1
      MAXNBR = NBRSIL
  130 CALL FREAD (GPECT,BUF,2,0)
      BUF(1) = II
      BUF(3) = 0
      BUF(4) = 0
      BUF(5) = LARGE
      BUF(6) = 0
      IF (NBRCON .EQ. 0) GO TO 134
      DO 132 I = MINNBR,MAXNBR
      ZI(I) = 0
  132 CONTINUE
  134 CALL READ (*138,*138,GPECT,TT,3,0,I)
      CALL CDCBUG (NHEMA1,134,TT,3)
      NBRGRD = IABS(TT(1)) - 2
      DO 136 I = 1,NBRGRD
      CALL FREAD (GPECT,SILNBR,1,0)
      J = ZI(ILOOK0+SILNBR )
      IF (ZS(J) .NE. 0) GO TO 136
      BUF(3) = MAX0(BUF(3),ZI(ISIL0+J+1)-ZI(ISIL0+J))
      BUF(4) = BUF(4) + 1
      BUF(5) = MIN0(BUF(5),J)
      BUF(6) = MAX0(BUF(6),J)
      ZS(J)  = 1.0
  136 CONTINUE
      GO TO 134
  138 CALL WRITE (SCR1,BUF,6,1)
      CALL CDCBUG (NHEMA1,138,BUF,6)
      IF (BUF(4) .EQ. 0) GO TO 142
C
C     PACK COLUMN FOR POINT WITH CONNECTED POINTS
C
      II1 = BUF(5)
      JJ1 = BUF(6)
      CALL CDCBUG (NHEMA1,139,ZI(II1),JJ1-II1+1)
      CALL PACK (ZS(II1),SCR1,MCB)
      GO TO 148
C
C     HERE IF PIVOT HAS NO CONNECTED POINTS
C
  142 CONTINUE
      MCB(2) = MCB(2) + 1
C
C     CLOSE FILES
C
  148 CONTINUE
      CALL CLOSE (GPECT,CLSREW)
      CALL CLOSE ( SCR1,CLSREW)
      CALL WRTTRL (MCB)
C
C     ALLOCATE STORAGE FOR MAXIMUM COLUMN OF ELEMENT MATRIX
C     AND MAXIMUM ENTRY FROM MODIFIED KDICT( SCR2 )
C
      IDICT = MAXVEC + 1
      IGRID = IDICT + 5
      IPVT  = IDICT + MAXDCT
      LCORE = EVEN( BUF2 ) - 1
C
C
C     BEGIN A PASS BY OPENING SCR1 AND SETTING ALLOCATION POINTERS
C
C
  150 CALL GOPEN (SCR1,ZI(BUF1),OPENR)
      II = IPVT
      JJ = LCORE
C
C     BEGIN A PIVOT ALLOCATION BY READING PIVOT CONTROL BLOCK FROM SCR1
C
  160 CONTINUE
      TT(1) = II
      TT(2) = JJ
      CALL CDCBUG (NHEMA1,160,TT,2)
      IF (II+LPCB .GE. JJ) GO TO 202
      CALL FREAD (SCR1,ZI(II),6,1)
      SILNBR = ZI(II)
      ZI(II+6) = 0
      ZI(II+7) = 0
      IF (ZI(II+3) .EQ. 0) GO TO 195
C
C     ATTEMPT TO ALLOCATE SPACE FOR CONNECTED GRID VECTOR
C     AND FOR MATRICES CONNECTED TO THE PIVOT
C
      NWDCGV = ZI(II+5) - ZI(II+4) + 1
      NWDMAT = PREC*ZI(II+1)*ZI(II+2)*ZI(II+3)
      IF (II+LPCB .GE. JJ-NWDCGV-NWDMAT) GO TO 200
      IMAT = JJ - NWDMAT
      ZI(II+6) = IMAT - EVEN(NWDCGV)
      ZI(II+7) = IMAT
      JJ   = ZI(II+6)
      NMAT = IMAT + NWDMAT - 1
      DO 165 I = IMAT,NMAT
      ZS(I) = 0
  165 CONTINUE
      ICGVEC = JJ
      NCGVEC = ICGVEC + NWDCGV - 1
C
C     UNPACK CONNECTED GRID VECTOR. CONVERT NON-ZERO POSITIONS TO
C     RELATIVE POINTERS (IN PRECISION OF PROBLEM) TO THE CORRESPONDING
C     1ST TERM OF THE ELEMENT MATRIX
C
      II2 = ZI(II+4)
      JJ2 = ZI(II+5)
      NTRMEC = ZI(II+2)
      KK = 1
      TYPIN2 = 1
      CALL UNPACK (*902,SCR1,ZS(ICGVEC))
      DO 174 I = ICGVEC,NCGVEC
      IF (ZI(I) .EQ. 0) GO TO 174
      ZI(I) = KK
      KK = KK + NTRMEC
  174 CONTINUE
      CALL CDCBUG (NHEMA1,174,ZI(II),8)
      CALL CDCBUG (NHEMA1,175,ZI(ICGVEC),NWDCGV)
      IF (KK-1 .NE. ZI(II+2)*ZI(II+3)) GO TO 903
C
C     TEST FOR LAST PIVOT. IF NOT, TRY TO ALLOCATE ANOTHER PIVOT
C
  195 IF (SILNBR .EQ. NBRSIL) GO TO 210
      II = II + LPCB
      GO TO 160
C
C     HERE IF CURRENT PIVOT CANNOT BE ALLOCATED -- MAKE SURE AT LEAST
C     ONE PIVOT HAS BEEN ALLOCATED.
C
  200 CALL BCKREC (SCR1)
  202 IF (II .EQ. IPVT) CALL MESAGE (-8,0,SUBNAM)
      NPVT = II - LPCB
      GO TO 220
C
C     HERE WHEN LAST PIVOT HAS BEEN READ AND ALLOCATED
C
  210 LAST = .TRUE.
      OPCLS= CLSREW
      NPVT = II
C
C
C     CLOSE SCR1, OPEN SCR2 AND KELEM. PREPARE TO ASSEMBLE
C     STRUCTURAL MATRIX FOR THOSE PIVOTS CURRENTLY ALLOCATED.
C
C
  220 CONTINUE
      CALL CLOSE (SCR1,OPCLS)
      CALL GOPEN (SCR2, ZI(BUF1),RDREW)
      CALL GOPEN (KELEM,ZI(BUF2),RDREW)
C
C     READ HEADER FOR CURRENT ELEMENT TYPE FROM SCR2
C
  230 CONTINUE
      CALL READ (*260,*230,SCR2,TT,3,0,I)
      CALL CDCBUG (NHEMA1,230,TT,3)
      NWDDCT = TT(2)
      NGRID  = IGRID + 2*(TT(3)-1)
C
C     READ AN ELEMENT DEFINITION. IF ANY GRID POINT IS IN CURRENT
C     ALLOCATION, PREPARE TO PROCESS IT.
C
  240 CALL READ (*230,*230,SCR2,ZI(IDICT),NWDDCT,0,I)
      CALL CDCBUG (NHEMA1,240,ZI(IDICT),NWDDCT)
      DO 242 I = IGRID,NGRID,2
      IF (ZI(I).GE.ZI(IPVT) .AND. ZI(I).LE.ZI(NPVT))
     1    GO TO KFACT, (244,245,246,247)
  242 CONTINUE
      GO TO 240
  244 FACTOR = 1.0
      GO TO 248
  245 FACTOR = ZS(IDICT+4)
      GO TO 248
  246 FACTOR = WTMASS
      GO TO 248
  247 FACTOR = WTMASS*ZS(IDICT+4)
C
C     DECODE RELATIVE COLUMN NUMBERS
C
  248 IF (OLDCOD .EQ. ZI(IDICT+3)) GO TO 250
      ICODE = ZI(IDICT+3)
      CALL DECODE (ICODE,SCALAS,NSCA)
      OLDCOD = ZI(IDICT+3)
C
C     READ EACH COLUMN OF THE ELEMENT MATRIX.
C     ADD IT TO THE STRUCTURAL MATRIX.
C
  250 NWDCOL = PREC*ZI(IDICT+2)
      IF (ZI(IDICT+1) .EQ. 2) NWDCOL = PREC
  252 II = IPVT + (ZI(I)-ZI(IPVT))*LPCB
      TT(1) = I
      TT(2) = ZI(I)
      TT(3) = NSCA
      CALL CDCBUG (NHEMA1,252,TT,3)
      CALL FILPOS (KELEM,ZI(I+1))
      ICGVEC = ZI(II+6)
      IMAT   = ZI(II+7)
      DO 254 J = 1,NSCA
      CALL FREAD (KELEM,ZI,NWDCOL,0)
      CALL CDCBUG(NHEMA1,254,ZI,NWDCOL)
      IF (PREC .EQ. 1) CALL EMA1S (J,NSCA,SCALAS,ZI(II),ZI(IDICT),
     1                             ZI(ICGVEC),ZI(IMAT),ZI,FACTOR)
      IF (PREC .EQ. 2) CALL EMA1D (J,NSCA,SCALAS,ZI(II),ZI(IDICT),
     1                             ZI(ICGVEC),ZI(IMAT),ZI,FACTOR)
  254 CONTINUE
  255 IF (I .EQ. NGRID) GO TO 240
      I = I + 2
      IF (ZI(I).GE.ZI(IPVT) .AND. ZI(I).LE.ZI(NPVT)) GO TO 252
      GO TO 255
C
C     ALL COLUMNS OF STRUCTURAL MATRIX NOW ALLOCATED ARE COMPLETE.
C     OPEN KGG AND PACK COLUMNS.
C
  260 CALL CLOSE (SCR2,CLSREW)
      CALL CLOSE (KELEM,CLSREW)
      CALL GOPEN (KGG,ZI(BUF1),OPENW)
      DO 269 II = IPVT,NPVT,LPCB
      DOF    = ZI(II+1)
      DOFG   = ZI(II+2)
      NBRCON = ZI(II+3)
      ICGVEC = ZI(II+6)
      IMAT   = ZI(II+7)
      II1    = ZI(II+4)
      II2    = ZI(II+5)
      KK     = IMAT
      CALL CDCBUG (NHEMA1,260,ZI(IMAT),((II2-II1+1)*(DOF*DOFG)))
C
C     PACK COLUMNS WITH BLDPK
C
      DO 268 JJ = 1,DOF
      CALL BLDPK (PREC,PREC,KGG,BLOCK,1)
      IF (NBRCON .EQ. 0) GO TO 266
      I = ICGVEC
      DO 264 J = II1,II2
      IF (ZI(I) .EQ. 0) GO TO 263
      K  = ZI(ISIL0+J)
      N  = K + MIN0(DOFG,ZI(ISIL0+J+1)-ZI(ISIL0+J)) - 1
      LL = KK
      DO 262 SILNBR = K,N
      CALL BLDPKI (ZS(LL),SILNBR,KGG,BLOCK)
      LL = LL + PREC
  262 CONTINUE
      KK = KK + DOFG*PREC
  263 I  = I + 1
  264 CONTINUE
  266 CALL BLDPKN (KGG,BLOCK,MCBKGG)
  268 CONTINUE
  269 CONTINUE
      CALL CLOSE (KGG,OPCLS)
C
C     TEST FOR COMPLETION OF LAST PASS
C
      IF (LAST) GO TO 310
      OPENR = RD
      OPENW = WRT
      GO TO 150
C
C     KGG NOW COMPLETE -- WRITE ITS TRAILER.
C
  310 CONTINUE
      CALL WRTTRL (MCBKGG)
      RETURN
C
C     FATAL ERRORS
C
  900 KERR = 112
      GO TO 990
  901 KERR = 114
      GO TO 990
  902 KERR = 172
      GO TO 990
  903 KERR = 174
      GO TO 990
C
C     PROCESS LOGIC ERROR
C
  990 WRITE  (NOUT,991) SFM,KERR
  991 FORMAT (A25,' 3102, EMA1 LOGIC ERROR',I4)
      IF (MACH.EQ.2 .OR. MACH.EQ.5 .OR. MACH.EQ.21) KERR = -KERR
      CALL GPERR (SUBNAM,KERR)
      RETURN
      END

        SUBROUTINE READ ( *, *, FILE, IDATA, N, IEORFL, M )
      INCLUDE 'DSIOF.COM'
      INCLUDE 'GINOX.COM'
      INCLUDE 'XNSTRN.COM'
        INTEGER           FILE, IDATA( 2 )
        NAME   = FILE
        NWORDS = N
        IEOR   = IEORFL
        IRETRN = 0
        CALL DSGEFL
        IF ( IPRVOP .EQ. 0 ) GO TO 10
        CALL DSMSG ( 4 )
10      ID = IAND( IBASE( INDCLR ), MASKQ1 )
        IF ( ID .NE. IDSEB ) GO TO 30
        CALL DBMLBK( LASBLK )
        IF ( LASBLK .GT. NBLOCK ) GO TO 20
        IRETRN = 1
        GO TO 7000
20      CALL DSRDNB
        ID = IAND( IBASE( INDCLR ), MASKQ1 )
30      IF ( ID .EQ. IDSRH ) GO TO 50
        IF ( ID .EQ. IDSEF ) GO TO 40
        CALL DSMSG ( 105 )
40      INDCLR = INDCLR + 1
        INDCBP = INDCLR
        IRETRN = 1
        GO TO 7000
50      IWORDS = IAND( IBASE( INDCLR ), MASKH2 )
        IDIFF  = INDCBP - INDCLR
        IWORDS = IWORDS - IDIFF
        IREQ   = IABS( NWORDS )
        IF ( IREQ .GT. IWORDS ) GO TO 80
        IF ( NWORDS .LE. 0 ) GO TO 70
        L = 1
        ILIM = INDCBP + NWORDS - 1
        DO 60 K = INDCBP, ILIM
        IDATA( L ) = IBASE( K+1 )
        L = L + 1
60      CONTINUE
70      INDCBP = INDCBP + IREQ
        GO TO 90
80      CALL DSRDMB ( IDATA, M )
90      IF ( IEOR .EQ. 0 ) GO TO 7000
        CALL DSSKRC
7000    CALL DSSDCB
        IF ( IRETRN .EQ. 2 ) RETURN 2
        IF ( IRETRN .EQ. 1 ) RETURN 1
        RETURN
        END

      SUBROUTINE XSFA (X)
C
C     ENTRY SIZE NUMBERS,  1=FIAT, 2=SOS, 3=MD, 4=DPD
C
C     REVISED  8/89,  SEE XSFABD
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        LSHIFT,RSHIFT,ANDF,ORF,COMPLF
      DIMENSION       IPRT(23),NSFA(3),DDBN(1),DFNU(1),FCUM(1),
     1                FCUS( 1),FDBN(1),FEQU(1),FILE(1),FKND(1),
     2                FMAT( 1),FNTU(1),FPUN(1),FON (1),FORD(1),
     3                MINP( 1),MLSN(1),MOUT(1),MSCR(1),SAL (1),
     4                SDBN( 1),SNTU(1),SORD(1),PFIL(2,3)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG / UFM,UWM,UIM,SFM
      COMMON /BLANK / IBNK(1)
      COMMON /MACHIN/ MCH
      COMMON /XFIAT / FIAT(7)
      COMMON /XFIST / FIST
      COMMON /XDPL  / DPD(6)
      COMMON /ZZZZZZ/ BUF1
      COMMON /SYSTEM/ IBUFSZ,OUTTAP,DUM(17),PLTFLG,DUM1,THISLK,DUM2,
     1                ICFIAT,DMM(14),NBPC,NBPW,NCPW
      COMMON /IXSFA / LMT3,BFF,PAD,IDEFR1,IDEFR2
      COMMON /XSFA1 / MD(401),SOS(1501),COMM(20),XF1AT(5)
      EQUIVALENCE               (DPD  (1),DNAF    ),(DPD  (2),DMXLG   ),
     1      (DPD  (3),DCULG   ),(DPD  (4),DDBN (1)),(DPD  (6),DFNU (1)),
     2      (FIAT (1),FUNLG   ),(FIAT (2),FMXLG   ),(FIAT (3),FCULG   ),
     3      (FIAT (4),FEQU (1)),(FIAT (4),FILE (1)),(FIAT (4),FORD (1)),
     4      (FIAT (5),FDBN (1)),(FIAT (7),FMAT (1)),(MD   (1),MLGN    ),
     5      (MD   (2),MLSN (1)),(MD   (3),MINP (1)),(MD   (4),MOUT (1)),
     6      (MD   (5),MSCR (1)),(SOS  (1),SLGN    ),(SOS  (2),SDBN (1)),
     7      (SOS  (4),SAL  (1)),(SOS  (4),SNTU (1)),(SOS  (4),SORD (1)),
     8      (XF1AT(1),FNTU (1)),(XF1AT(1),FON  (1)),(XF1AT(2),FPUN (1)),
     9      (XF1AT(3),FCUM (1)),(XF1AT(4),FCUS (1)),(XF1AT(5),FKND (1))
      EQUIVALENCE               (COMM (1),ALMSK   ),(COMM (2),APNDMK  ),
     1      (COMM (3),CURSNO  ),(COMM (4),ENTN1   ),(COMM (5),ENTN2   ),
     2      (COMM (6),ENTN3   ),(COMM (7),ENTN4   ),(COMM (8),FLAG    ),
     3      (COMM (9),FNX     ),(COMM(10),LMSK    ),(COMM(11),LXMSK   ),
     4      (COMM(12),MACSFT  ),(COMM(13),RMSK    ),(COMM(14),RXMSK   ),
     5      (COMM(15),S       ),(COMM(16),SCORNT  ),(COMM(17),TAPMSK  ),
     6      (COMM(18),THCRMK  ),(COMM(19),ZAP     )
      DATA  OSCAR1, OSCAR2/ 4HXOSC, 4HAR  /, POOL  / 4HPOOL  /
      DATA  NSFA  / 4HXSFA, 4H    , 4H    /, NS14  / 4HNS14  /
      DATA  IBEGN,  IEND  / 4HBEGN, 4HEND /
      DATA  PLUS  / 1H+   /
      DATA  PFIL  / 4HPLTP, 4HAR  , 4HGPSE, 4HTS  , 4HELSE, 4HTS   /
C
      CALL XSFADD
      NSFA(3) = IBEGN
      CALL CONMSG (NSFA,3,0)
C
C     ALMSK  = O 377777777777     Z 7FFFFFFF
      ALMSK  = RSHIFT(COMPLF(0),1)
C
C     THCRMK = O 777777000000     Z FFFFFF00
      THCRMK = LSHIFT(ALMSK,NBPW-(3*NBPC))
C
C     S      = O 400000000000     Z 80000000
      S      = LSHIFT(1,NBPW-1)
C
C     MACSFT = SHIFT COUNT TO PLACE INTEGER IN 4TH FROM LEFT CHARACTER
      MACSFT = (NCPW-4)*NBPC
C
      ENTN1  = ICFIAT
      CURSNO = X
C
C     GET OSCAR FILE POSITION AND SAVE IN FNOS
C     ALSO SAVE RECORD POSITION IN RNOS
C
      CALL XPOLCK (OSCAR1,OSCAR2,FNOS,NX)
      IF (FNOS .EQ. 0) GO TO 920
      FNX  = FNOS
      RNOS = CURSNO
      CALL XSOSGN
      IF (MLGN .EQ. 0) GO TO 930
      CALL XCLEAN
C
C     INITIALIZE PRIOR TO FIRST MODULE ALLOCATION
C
      ASSIGN 670 TO ITEST
C
      LMT1  = MLGN *ENTN3
      LMT8  = FUNLG*ENTN1
      LMT8P1= LMT8 + 1
      DO 110 I = 1,LMT8,ENTN1
      IF (ANDF(TAPMSK,FILE(I)) .NE. 0) GO TO 120
  110 CONTINUE
      TAPMSK = 0
C
C     LOOP THRU ALL MODULES IN SOS
C
  120 I = 1
  125 TOTIO = MINP(I)+ MOUT(I)
      TOTF  = TOTIO  + MSCR(I)
      ALCNT = 0
      LMT2  = LMT3 + 1
      LMT4  = LMT3 + MINP(I)*ENTN2
      LMT5  = LMT4 + MOUT(I)*ENTN2
      LMT3  = LMT3 + TOTF   *ENTN2
      LMT9  = FCULG*ENTN1
      NFCULG= LMT9 + 1
      ITIORD= LSHIFT(MLSN(I),16)
      DO 130 J = 1,LMT9,ENTN1
  130 FCUM(J) = 0
C
C     SEQUENCE THRU SOS (ONE MODULE) LOOK FOR NAME MATCH + LTU COMPARE
C
  150 FLAG = 0
      DO 260 K = LMT2,LMT3,ENTN2
      IF (SAL(K) .LT. 0)  GO TO 260
      ITPFLG = ANDF(TAPMSK,SNTU(K))
C
C     SEQUENCE THRU FIAT (NAME MATCH)
C
      DO 170 F1 = 1,LMT9,ENTN1
      IF (SDBN(K).NE.FDBN(F1) .OR. SDBN(K+1).NE.FDBN(F1+1)) GO TO 170
      IF (FPUN(F1) .LT. 0) GO TO 680
      FNTU(F1) = ORF(ANDF(S,FON(F1)),SNTU(K))
      FCUM(F1) = -1
      FCUS(F1) = -1
      IF (FKND(F1) .EQ. 0) FKND(F1) = 1
      GO TO 230
  170 CONTINUE
      IF (MLSN(I) .LT. 0) GO TO 260
      IF (K    .LE. LMT4) GO TO 260
      IF (ANDF(APNDMK,SORD(K)) .EQ. APNDMK) GO TO 260
C
C     SEQUENCE THRU FIAT (LTU COMPARE)
C
      DO 220 F1 = 1,LMT9,ENTN1
      IF (ITIORD .LE. ANDF(LMSK,FORD(F1))) GO TO 220
      IF (FON (F1) .LT. 0) GO TO 220
      IF (FCUM(F1) .LT. 0) GO TO 220
      IF (FDBN(F1) .EQ. 0) GO TO 220
      IF (ANDF(RMSK,FILE(F1)) .EQ. RMSK) GO TO 220
      IF (ANDF(LMSK,FORD(F1)) .EQ. LMSK) GO TO 220
      IF (ITPFLG.NE.0 .AND. ANDF(TAPMSK,FILE(F1)).EQ.0) GO TO 220
      IF (FEQU(F1) .GE. 0) GO TO 210
      FIL = ANDF(RMSK,FILE(F1))
      DO 200 L = 1,LMT9,ENTN1
      IF (FEQU(L) .GE. 0) GO TO 200
      IF (F1      .EQ. L) GO TO 200
      IF (FIL    .NE. ANDF(RMSK,FILE(L))) GO TO 200
      IF (ITIORD .LE. ANDF(LMSK,FORD(L))) GO TO 220
      IF (FON(L)  .LT. 0) GO TO 220
      IF (FCUM(L) .LT. 0) GO TO 220
  200 CONTINUE
  210 IF (FCULG+PAD .GE. FMXLG) GO TO 680
      FON(F1) = ORF(S,FON(F1))
      FDBN(NFCULG  ) = SDBN(K  )
      FDBN(NFCULG+1) = SDBN(K+1)
      FORD(NFCULG  ) = ORF(ANDF(LXMSK,SORD(K)),ANDF(RXMSK,FILE(F1)))
      FNTU(NFCULG  ) = SNTU(K)
      FCUM(NFCULG  ) = -1
      FCUS(NFCULG  ) = -1
      FKND(NFCULG  ) = 2
      NFCULG = NFCULG+ ENTN1
      FCULG  = FCULG + 1
      GO TO 230
  220 CONTINUE
      GO TO 260
  230 SAL(K) = ORF(S,SAL(K))
      ALCNT  = ALCNT + 1
  260 CONTINUE
      IF (ALCNT .EQ. TOTF) GO TO 600
C
C     SEQUENCE THRU SOS (ONE MODULE) LOOK FOR BLANK FILES + GREATER NTU
C
      DO 550 K = LMT2,LMT3,ENTN2
      IF (SAL(K) .LT. 0) GO TO 550
      IF (FLAG.NE.0 .AND. K.GT.LMT4 .AND. K.LE.LMT5) GO TO 150
      IAPFLG = 0
      IUNPFG = 0
      IF (ANDF(APNDMK,SORD(K)) .EQ. APNDMK) IAPFLG = -1
      ITPFLG = ANDF(TAPMSK,SNTU(K))
C
C     SEQUENCE THRU FIAT-UNIQUE (BLANK FILES)
C
      IF (BFF .LT. 0) GO TO 390
      DO 330 F1 = 1,LMT8,ENTN1
      IF (FDBN(F1) .NE. 0) GO TO 330
      IF (ITPFLG.NE.0 .AND. ANDF(TAPMSK,FILE(F1)).EQ.0) GO TO 330
      IF (K.GT.LMT4 .AND. IAPFLG.EQ.0) GO TO 310
      CALL XPOLCK (SDBN(K),SDBN(K+1),FN,NX)
      IF (IAPFLG.NE.0 .AND. FN.EQ.0) GO TO 310
      IF (FN     .NE. 0) GO TO 300
      IF (PLTFLG .NE. 0) GO TO 280
      DO 270 IP = 1,3
      IF (SDBN(K).EQ.PFIL(1,IP) .AND. SDBN(K+1).EQ.PFIL(2,IP)) GO TO 300
  270 CONTINUE
  280 IF (THISLK .NE. NS14) CALL MESAGE (22,0,SDBN(K))
      GO TO 320
  300 FPUN(F1) = FN
      IUNPFG   = F1
  310 FDBN(F1  ) = SDBN(K  )
      FDBN(F1+1) = SDBN(K+1)
      FORD(F1) = ORF(ANDF(LXMSK,SORD(K)),FILE(F1))
      FNTU(F1) = SNTU(K)
      FCUM(F1) =-1
      FCUS(F1) =-1
      FKND(F1) = 3
  320 SAL(K) = ORF(S,SAL(K))
      ALCNT  = ALCNT + 1
      GO TO 540
  330 CONTINUE
      IF (ITPFLG .EQ. 0) BFF = -1
C
C     SEQUENCE THRU FIAT (GREATEST NTU) FOR POOLING
C
  390 IF (MLSN(I) .LT. 0) GO TO 680
C
C     BEFORE PERMITTING POOLING CHECK IF AT LEAST ONE MODULE IS ALLOCATE
C
      IF (I .NE. 1) GO TO 620
  400 MXNTU  = CURSNO
      MXNTUI = 0
      DO 460 F1 = 1,LMT8,ENTN1
      IF (FCUS(F1) .LT. 0) GO TO 460
      IF (IDEFR2   .LT. 0) GO TO 420
      IF (FMAT(F1).NE.0 .OR. FMAT(F1+1).NE.0 .OR. FMAT(F1+2).NE.0)
     1   GO TO 410
      IF (ENTN1.EQ.11 .AND. (FMAT(F1+5).NE.0 .OR. FMAT(F1+6).NE.0 .OR.
     1   FMAT(F1+7).NE.0)) GO TO 410
      GO TO 420
  410 IDEFR1 = -1
      GO TO 460
  420 IF (FKND(F1) .LT. 0) GO TO 460
      IF (FPUN(F1) .NE. 0) GO TO 460
      IF (ITPFLG.NE.0 .AND. ANDF(TAPMSK,FILE(F1)).EQ.0) GO TO 460
      TRIAL = ANDF(FNTU(F1),RMSK)
      IF (TRIAL .LE. MXNTU) GO TO 460
      MXNTU  = TRIAL
      MXNTUI = F1
  460 CONTINUE
      IF (MXNTUI .NE. 0) GO TO 463
C
C     FILE NOT FOUND - HAS A PASS BEEN DEFERRED
C
      IF (IDEFR1 .EQ. 0) GO TO 680
C
C     PASS HAS BEEN DEFERRED - TRY IT NOW
C
      IDEFR1 = 0
      IDEFR2 =-1
      DO 462 IX = 1,LMT8,ENTN1
  462 FKND(IX) = IABS(FKND(IX))
      GO TO 400
C
C     A GREATER NTU FILE EXISTS
C
  463 N = 1
C
C     SEARCH FOR EQUIV OR STACKED MATCH
C
      FIL = ANDF(RMSK,FILE(MXNTUI))
      DO 470 J = LMT8P1,LMT9,ENTN1
      IF (FIL .NE. ANDF(RMSK,FILE(J))) GO TO 470
C
C     A MATCH IS FOUND, IS MATCHED FILE USED IN CURRENT SEG
C
      IF (FCUS(J) .LT. 0) GO TO 490
C
C     IF MATCHED FILE HAS NTU LESS - TEST AND SET DEFER FLAG
C
      IF (IDEFR2 .LT. 0) GO TO 465
      IF (FMAT(J).NE.0 .OR.  FMAT(J+1).NE.0 .OR. FMAT(J+2).NE.0)
     1    GO TO 464
      IF (ENTN1.EQ.11 .AND. (FMAT(J+5).NE.0 .OR. FMAT(J+6).NE.0 .OR.
     1    FMAT(J+7).NE.0)) GO TO 464
      IF (ANDF(RMSK,FNTU(1)) .GE. ANDF(RMSK,FNTU(MXNTUI))) GO TO 465
  464 IDEFR1 = -1
      GO TO 490
C
C     MATCHED FILE IS O.K. - IS IT EQUIV OR STACKED
C
  465 IF (FEQU(J) .GE. 0) GO TO 467
      FKND(J) = 7
      N = N + 1
      GO TO 470
C
C     STACKED - WIPE OUT MATCH (IF EMPTY)
C
  467 IF (FMAT(J).NE.0 .OR.  FMAT(J+1).NE.0 .OR. FMAT(J+2).NE.0)
     1    GO TO 490
      IF (ENTN1.EQ.11 .AND. (FMAT(J+5).NE.0 .OR. FMAT(J+6).NE.0 .OR.
     1    FMAT(J+7).NE.0)) GO TO 490
      FILE(J  ) = 0
      FDBN(J  ) = 0
      FDBN(J+1) = 0
  470 CONTINUE
      FPUN(MXNTUI) = ORF(S,N)
      IF (K.GT.LMT4 .AND. IAPFLG.EQ.0) GO TO 520
      CALL XPOLCK (SDBN(K),SDBN(K+1),FN,NX)
      IF (IAPFLG.NE.0 .AND. FN.EQ.0) GO TO 520
      IF (FN .NE. 0) GO TO 500
      IF (THISLK .NE. 14) CALL MESAGE (22,0,SDBN(K))
      GO TO 530
  490 IF (FKND(MXNTUI) .EQ. 0) FKND(MXNTUI) = 9
      FKND(MXNTUI) = -IABS(FKND(MXNTUI))
      GO TO 400
  500 FPUN(NFCULG) = FN
      IUNPFG = NFCULG
  520 IF (FCULG+PAD .GE. FMXLG) GO TO 680
      FON(MXNTUI ) = ORF(S,FON(MXNTUI))
      FORD(NFCULG) = ORF(ANDF(RXMSK,FILE(MXNTUI)),ANDF(LXMSK,SORD(K)))
      FKND(NFCULG) = ORF(FKND(NFCULG),5)
      FDBN(NFCULG  ) = SDBN(K  )
      FDBN(NFCULG+1) = SDBN(K+1)
      FNTU(NFCULG) = SNTU(K)
      FCUM(NFCULG) = -1
      FCUS(NFCULG) = -1
      NFCULG = NFCULG+ ENTN1
      FCULG  = FCULG + 1
  530 SAL(K) = ORF(S,SAL(K))
      ALCNT  = ALCNT+ 1
  540 IF (IUNPFG   .EQ. 0) GO TO 550
      IF (DFNU(NX) .GE. 0) GO TO 550
      CALL XPLEQK (NX,IUNPFG)
      LMT9  = FCULG*ENTN1
      NFCULG= LMT9 + 1
  550 CONTINUE
C
C     MODULE ALLOCATION COMPLETE
C
  600 CURSNO = ANDF(RMSK,MLSN(I)) + 1
C
C     END OF I MODULE PSEUDO LOOP
C
      I = I + ENTN3
      IF (I .LE. LMT1) GO TO 125
C
  620 CALL XPUNP
      CALL XDPH
C
C     REPOSITION OSCAR FOR SEM
C
      CALL XPOLCK (OSCAR1,OSCAR2,FNOS,NX)
      IF (FNOS .EQ. 0) GO TO 920
  630 CALL OPEN (*940,POOL,BUF1,0)
      IF (FNOS .NE. 1) CALL SKPFIL (POOL,FNOS-1)
      DO 650 J = 1,RNOS
      CALL FWDREC (*950,POOL)
  650 CONTINUE
      CALL CLOSE (POOL,2)
C
  655 CONTINUE
C
C     DUMP FIAT IF SENSE SWITCH 2 IS ON
C
      CALL SSWTCH (2,IX)
      IF (IX .NE. 1) GO TO ITEST, (670,715)
      CALL PAGE1
      CALL PAGE2 (-4)
      WRITE  (OUTTAP,660) FIAT(1),FIAT(2),FIAT(3),X,CURSNO
  660 FORMAT (15H0FIAT AFTER SFA,3I4,12H  OSCAR STR ,I4,6H, STP ,I4, //,
     1        ' EQ AP  LTU  TP  UNIT  NTU  OF SG KN TR DATA-BLK      *',
     2     6X,'*   TRAILER   *      *      *  PRI BLKS   SEC FLS/BLKS',
     3     3X,'TER FLS/BLKS')
      II = FIAT(3)*ENTN1
      DO 665 IX = 1,II,ENTN1
      IPRT( 1) = RSHIFT(FEQU(IX),NBPW-1)
      IPRT( 2) = RSHIFT(ANDF(APNDMK,FORD(IX)),30)
      IPRT( 3) = RSHIFT(ANDF(LMSK  ,FORD(IX)),16)
      IPRT( 4) = RSHIFT(ANDF(TAPMSK,FILE(IX)),15)
      IPRT( 5) = ANDF(RMSK,FILE(IX))
      IPRT( 6) = ANDF(RMSK,FNTU(IX))
      IPRT( 7) = RSHIFT(FON(IX),NBPW-1)
      IPRT( 8) = FCUS(IX)
      IPRT( 9) = FKND(IX)
      IPRT(10) = RSHIFT(ANDF(TAPMSK,FNTU(IX)),15)
      IPRT(11) = FDBN(IX  )
      IPRT(12) = FDBN(IX+1)
      IF (IPRT(11) .NE. 0) GO TO 661
      IPRT(11) = NSFA(2)
      IPRT(12) = NSFA(2)
  661 IF (ENTN1 .EQ. 11) GO TO 662
      IPRT(13) = RSHIFT(FMAT(IX),16)
      IPRT(14) = ANDF(RXMSK,FMAT(IX))
      IPRT(15) = RSHIFT(FMAT(IX+1),16)
      IPRT(16) = ANDF(RXMSK,FMAT(IX+1))
      IPRT(17) = RSHIFT(FMAT(IX+2),16)
      IPRT(18) = ANDF(RXMSK,FMAT(IX+2))
      GO TO 663
  662 IPRT(13) = FMAT(IX  )
      IPRT(14) = FMAT(IX+1)
      IPRT(15) = FMAT(IX+2)
      IPRT(16) = FMAT(IX+5)
      IPRT(17) = FMAT(IX+6)
      IPRT(18) = FMAT(IX+7)
  663 IPRT(19) = RSHIFT(FMAT(IX+3),16)
      ITEMP    = ANDF(FMAT(IX+3),RXMSK)
      IPRT(20) = RSHIFT(ITEMP,8)
      IPRT(21) = RSHIFT(FMAT(IX+4),16)
      IPRT(22) = ITEMP - IPRT(20)*2**8
      IPRT(23) = ANDF(RXMSK,FMAT(IX+4))
      CALL PAGE2 (-1)
      WRITE  (OUTTAP,664) (IPRT(IY),IY=1,23)
  664 FORMAT (1H ,2(I2,1X),I5,1X,I2,2(1X,I5),4(1X,I2),1X,2A4,6I7,
     1        4X,I5,1X,2(7X,I2,1H/,I5))
  665 CONTINUE
      CALL XFLSZD (0,BLKSIZ,0)
      CALL PAGE2 (-2)
      WRITE  (OUTTAP,628) BLKSIZ
  628 FORMAT (30X,20H EACH BLOCK CONTAINS,I5,7H WORDS.)
      WRITE  (OUTTAP,666)
  666 FORMAT (52H POOL FILE CONTENTS   EQ    SIZE   FILE   DATA BLOCK)
      II = DPD(3)*3
      DO 668 IX = 1,II,3
      IPRT(1) = RSHIFT(DFNU(IX),NBPW-1)
      IPRT(2) = RSHIFT(DFNU(IX),16)
      IPRT(3) = ANDF(RXMSK,DFNU(IX))
      IPRT(4) = DDBN(IX  )
      IPRT(5) = DDBN(IX+1)
      CALL PAGE2 (-1)
      WRITE  (OUTTAP,667) (IPRT(IY),IY=1,5)
  667 FORMAT (22X,I2,I7,I7,3X,2A4)
  668 CONTINUE
      CALL DBMDIA
      CALL DBMSTF
C
      GO TO ITEST, (670,715)
C
  670 J = MCH
      IF (IABS(IBNK(ENTN1*5))/1000.NE.J .AND. J.GT.6) COMM(4) = J
      X = CURSNO
      NSFA(3) = IEND
      CALL CONMSG (NSFA,3,0)
      RETURN
C
C     MODULE ALLOCATION INCOMPLETE
C
  680 IF (I      .NE. 1) GO TO 620
      IF (ITPFLG .EQ. 0) GO TO 700
C
C     LOOKING FOR A TAPE + AT LEAST ONE TAPE EXISTS
C
      NOAVAL = 0
      DO 690 M = 1,LMT8,ENTN1
      IF (ANDF(TAPMSK,FILE(M)) .EQ. 0) GO TO 690
      IF (ANDF(TAPMSK,FNTU(M)) .EQ. 0) GO TO 710
      NOAVAL = 1
  690 CONTINUE
      IF (NOAVAL .EQ. 0) GO TO 700
      TAPMSK = 0
      GO TO 790
  700 CURSNO = 0
      GO TO 630
C
C     A TAPE FILE EXIST CONTAINING A D.B. NOT REQUIRING A TAPE  -
C     FREE THAT TAPE***  CHECK FOR EQUIV AND LTU D.B. ON SAME UNIT
C
  710 N = 1
C
      ASSIGN 715 TO ITEST
      GO TO 655
  715 CONTINUE
      ASSIGN 670 TO ITEST
C
      TRIAL = ANDF(RMSK,FILE(M))
      LMT   = LMT8 + 1
      DO 750 J = LMT,LMT9,ENTN1
      IF (TRIAL .NE. ANDF(RMSK,FILE(J))) GO TO 750
      INAM1 = FDBN(J  )
      INAM2 = FDBN(J+1)
      IF (FEQU(M).LT.0 .AND. FEQU(J).LT.0) GO TO 720
      FDBN(J) = ALMSK
      GO TO 725
  720 N = N + 1
  725 DO 730 L = LMT2,LMT3,ENTN2
      IF (INAM1.EQ.SDBN(L) .AND. INAM2.EQ.SDBN(L+1)) GO TO 740
  730 CONTINUE
      GO TO 750
C
C     TURN OFF ALLOC FLAG
C
  740 SAL(L) = ORF(ALMSK,SAL(L))
      ALCNT  = ALCNT - 1
  750 CONTINUE
      INAM1 = FDBN(M  )
      INAM2 = FDBN(M+1)
      DO 760 L = LMT2,LMT3,ENTN2
      IF (INAM1.EQ.SDBN(L) .AND. INAM2.EQ.SDBN(L+1)) GO TO 770
  760 CONTINUE
      GO TO 780
  770 SAL(L) = ORF(ALMSK,SAL(L))
      ALCNT  = ALCNT - 1
  780 FPUN(M)= ORF(S,N)
      CALL XPUNP
      FDBN(M  ) = SDBN(K  )
      FDBN(M+1) = SDBN(K+1)
      FORD(M  ) = ORF(ANDF(LXMSK,SORD(K)),ANDF(RXMSK,FILE(M)))
      FKND(M  ) = 8
C
      CALL SSWTCH (2,IX)
      IF (IX .NE. 1) GO TO 790
      CALL PAGE2 (-2)
      WRITE  (OUTTAP,785)
  785 FORMAT (38H0* XSFA REPEATS TO USE FREED TAPE FILE)
C
  790 BFF = 0
      GO TO 150
C
  920 WRITE  (OUTTAP,921) SFM
  921 FORMAT (A25,' 1001, OSCAR NOT FOUND IN DPL')
      GO TO  1000
  930 WRITE  (OUTTAP,931) SFM
  931 FORMAT (A25,' 1002, OSCAR CONTAINS NO MODULES')
      GO TO  1000
  940 WRITE  (OUTTAP,941) SFM
  941 FORMAT (A25,' 1003, POOL COULD NOT BE OPENED')
      GO TO  1000
  950 WRITE  (OUTTAP,951) SFM
  951 FORMAT (A25,' 1004, ILLEGAL EOF ON POOL')
 1000 CALL MESAGE (-37,0,NSFA)
      RETURN
      END

      SUBROUTINE CURV2
C*****
C PASSES NEXT SUBCASE OF ELEMENT STRESS OR STRAIN DATA IN OES1
C AND OUTPUTS OES1M FOR THIS SUBCASE. SETS UP FILES AND TABLES
C FOR -CURV3- IF OES1G IS TO BE FORMED.
C
C     OPEN CORE MAP DURING -CURV2- EXECUTION.
C     =======================================
C
C     FROM-------+------------+
C     CURV1      I  Z(IELTYP) I  MASTER LIST OF ELEMENT TYPES THAT
C     EXECUTION  I    THRU    I  EXIST ON ESTX(SCR1)
C                I  Z(NELTYP) I
C                +------------+
C                I  Z(IMCSID) I  MASTER LIST OF MCSIDS ELEMENTS IN
C                I    THRU    I  PROBLEM REFERENCE, WITH COUNTS OF
C                I  Z(NMCSID) I  OES1M ELEMENTS FOR CURRENT SUBCASE.
C                +------------+
C                I  Z(ICSTM)  I  CSTM FOR EACH -MCSID- IN ABOVE LIST.
C                I    THRU    I  14 WORD ENTRIES. (USER MAY NOT HAVE
C                I  Z(NCSTM)  I  SUPPLIED ALL, BUT MAY BE OK.)
C     FROM-------+------------+
C     AND DURING I  Z(IESTX)  I  SPACE FOR ONE ENTRY OF ESTX(SCR1)
C     CURV2      I    THRU    I  ENTRIES.  (SIZE IS ELEMENT DEPENDENT)
C     EXECUTION  I  Z(NESTX)  I
C                +------------+
C                I  Z(IOES1M) I  TABLE OF INCR-WORD .RIES FOR 1 ELEMENT
C                I    THRU    I  TYPE.  CONTAINS ELEMENT-ID,MCSID,XY-
C                I  Z(NOES1M) I  COMPONENT-CODE, AND (INCR-3) SIGMAS.
C                +------------+  INCR =  9 FOR REAL STRESS
C                I     .      I       = 15 FOR COMPLEX STRESS
C                I     .      I  AVAILABLE CORE.
C                I     .      I
C                I     .      I
C                I     .      I
C                I  Z(JCORE)  I
C                +------------+
C                I  Z(IBUF4)  I  GINO-BUFFER(OES1M)
C                I            I
C                +------------+
C                I  Z(IBUF3)  I  GINO-BUFFER(SCR2 AND SCR3)
C                I            I
C                +------------+
C                I  Z(IBUF2)  I  GINO-BUFFER(SCR1)
C                I            I
C                +------------+
C                I  Z(IBUF1)  I  GINO-BUFFER(OES1)
C                I            I
C                I  Z(LCORE)  I
C                +------------+
C
C
C*****
      REAL               Z(1)     ,RBUF(100),U(9)
C
      INTEGER            CSTMS    ,SCR1     ,SCR2     ,SCR3     ,MCB(7)
      INTEGER            SCR4     ,OES1M    ,OES1G    ,OES1     ,SCR5
      INTEGER            CSTM     ,EST      ,SIL      ,GPL
      INTEGER            ELTYPE   ,SUBCAS   ,FILE     ,ESTWDS
      INTEGER            EWORDS   ,OWORDS   ,DEPTS    ,CSTYPE
      INTEGER            DEVICE   ,OLDID    ,BUF      ,SBUF
      INTEGER            RD       ,RDREW    ,WRT      ,WRTREW
      INTEGER            CLS      ,CLSREW   ,EOR      ,SYSBUF
C
      LOGICAL            ANY      ,EOFOS1   ,FIRST    ,ANYOUT
      LOGICAL            FOES1G   ,STRAIN   ,ANY1M    ,ANY1G
C
      COMMON/BLANK /     IP1      ,IP2      ,ICMPLX   ,ZDUM(3)
C
      COMMON/SYSTEM/     SYSBUF   ,IOUTPT
C
      COMMON/NAMES /     RD       ,RDREW    ,WRT      ,WRTREW
     1                  ,CLSREW   ,CLS
C
      COMMON/CONDAS/     VALPI    ,VAL2PI   ,RADDEG   ,DEGRAD
     1                  ,S4PISQ
C
      COMMON/ZZZZZZ/     IZ(1)
C
      COMMON/CURVC1/     LSBUF    ,SBUF(10)
C
      COMMON/CURVC2/     LBUF     ,BUF(100)
C
      COMMON/CURVC3/     VEC(3)   ,VMAX(3)  ,VMIN(3)  ,IDREC(146)
C
      COMMON/CURVTB/     IMID     ,NMID     ,LMID     ,NMIDS
     A                  ,IELTYP   ,NELTYP   ,JELTYP   ,ICSTM
     B                  ,NCSTM    ,CSTMS    ,LCSTM    ,IESTX
     C                  ,NESTX    ,IMCSID   ,NMCSID   ,LMCSID
     D                  ,MCSIDS   ,JMCSID   ,KMCSID   ,ISIL
     E                  ,NSIL     ,LSIL     ,JSIL     ,IOES1M
     F                  ,NOES1M   ,LOES1M   ,IDEP     ,NDEP
     G                  ,IINDEP   ,NINDEP   ,JINDEP   ,ISIGMA
     H                  ,NSIGMA   ,IGMAT    ,NGMAT    ,IEXT
     I                  ,NEXT     ,LEXT     ,SCR1     ,SCR2
     J                  ,SCR3     ,SCR4     ,OES1M    ,OES1G
     K                  ,OES1     ,MPT      ,CSTM     ,EST
     L                  ,SIL      ,GPL      ,JCORE    ,LCORE
     M                  ,IBUF1    ,IBUF2    ,IBUF3    ,IBUF4
     N                  ,I        ,J        ,K        ,L
     O                  ,K1       ,K2       ,IXYZ1    ,IXYZ2
     P                  ,LX1      ,LX2      ,ELTYPE   ,MCSID
     Q                  ,IDSCR1   ,IDOES1   ,NPTS     ,NPTS4
     R                  ,IWORDS   ,NWORDS   ,SUBCAS   ,KOUNT
     S                  ,ISIG1    ,ISIG2    ,LOC      ,FILE
      COMMON/CURVTB/     IMSG     ,NELEMS   ,IMATID   ,ICOMP
     1                  ,ESTWDS   ,EWORDS   ,JP       ,OWORDS
     2                  ,MATID    ,DEPTS    ,INDPTS   ,ICTYPE
     3                  ,IVMAT    ,ITRAN    ,CSTYPE   ,ISING
     4                  ,DEVICE   ,OLDID    ,ANY      ,EOFOS1
     5                  ,FIRST    ,ANYOUT   ,FOES1G   ,STRAIN
     6                  ,LOGERR   ,ANY1M    ,ANY1G    ,SCR5
C
      EQUIVALENCE        (Z(1),IZ(1)), (BUF(1),RBUF(1))
      EQUIVALENCE        (NOEOR,RDREW), (EOR,CLS)
C
      DATA MCB/ 7*1 /
C
C  OPEN OES1M FOR ANY POSSIBLE OUTPUTS DURING THIS SUBCASE PASS.
C
      ISIG1 = 3
      ISIG2 = 11
      FILE = OES1M
      LOC = 60
      CALL OPEN(*9001,OES1M,IZ(IBUF3),WRT)
C
C  OPEN OES1 NOREWIND TO CONTINUE
C
      FIRST = .TRUE.
      ANY = .FALSE.
      FILE = OES1
      CALL OPEN(*9001,OES1,IZ(IBUF1),RD)
      FILE = SCR1
      CALL OPEN(*9001,SCR1,IZ(IBUF2),RDREW)
C
C  ZERO ELEMENT COUNTS FOR EACH -MCSID- THIS SUBCASE MAY REFERENCE.
C
      DO 80 I = IMCSID,NMCSID,2
      IZ(I+1) = 0
   80 CONTINUE
C
C  READ NEXT ID-RECORD
C
  100 FILE = OES1
      LOC = 100
      CALL READ(*300,*9003,OES1,IDREC(1),146,EOR,NWORDS)
C
C  CHECK IF STILL SAME SUBCASE UNLESS THIS IS THE FIRST ID-RECORD OF A
C  SUBCASE GROUP.
C
      IF( .NOT. FIRST ) GO TO 200
C
C  YES THIS IS FIRST ID-RECORD OF A SUBCASE GROUP.
C  SET SUBCASE IDENTIFIERS.
C
      SUBCAS = IDREC(4)
      FIRST = .FALSE.
      GO TO 500
C
C  CHECKING FOR CHANGE IN SUBCASE
C
  200 IF( SUBCAS .EQ. IDREC(4) ) GO TO 500
C
C  CHANGE IN SUBCASE THUS BACK RECORD OVER THIS ID-RECORD CLOSE
C  OES1, AND WRAP UP OPERATIONS ON OES1M FOR CURRENT SUBCASE.
C
      CALL BCKREC( OES1 )
      CALL CLOSE( OES1, CLS )
C
C  CLOSE ESTX(SCR1) AND ESTXX(SCR2).
C
  250 CALL CLOSE( SCR1, CLSREW )
      CALL CLOSE( SCR2, CLSREW )
      GO TO 5000
C
C  END OF FILE ON OES1. SET EOF FLAG AND WRAP UP CURRENT OPERATIONS
C  ON OES1M.
C
  300 EOFOS1 = .TRUE.
      CALL CLOSE( OES1, CLSREW )
      CALL CLOSE(OES1M,CLSREW)
      GO TO 250
C
C  ID RECORD ON OES1 WILL BE FOR SOME KIND OF ELEMENT.
C  CHECK TO SEE IF ITS TYPE IS IN THE LIST OF TYPES NOW ON SCR1
C  WHICH IS THE ABBREVIATED EST. IF NOT THEN SKIP THE DATA RECORD
C  AND GO TO NEXT ID RECORD.
C
  500 ELTYPE = IDREC(3)
      IFORMT = IDREC(9)
      OWORDS = IDREC(10)
      DO 520 I = IELTYP,NELTYP
      IF( ELTYPE .EQ. IZ(I) ) GO TO 600
  520 CONTINUE
      CALL FWDREC(*300,OES1)
      GO TO 100
C
C  POSITION TO SCR1 RECORD FOR THIS ELEMENT TYPE. IF IT CAN NOT BE
C  FOUND BY FORWARD SEARCH THERE IS A LOGIC ERROR, OR OES1 ELEMENT
C  TYPES ARE NOT IN SAME ORDER AS EST ELEMENT TYPES.
C
  600 FILE = SCR1
      LOC = 600
      CALL REWIND (SCR1)
  640 CALL READ(*9002,*9003,SCR1,BUF(1),3,NOEOR,NWORDS)
      IF( BUF(1) .EQ. ELTYPE ) GO TO 650
      CALL FWDREC(*9002,SCR1)
      GO TO 640
C
C  NOW POSITIONED TO READ ELEMENT ENTRIES FROM ESTX(SCR1) WHICH
C  ARE OK FOR INCLUSION IN OES1M AND OES1G PROCESSING.
C
C  ALSO POSITIONED TO READ OUTPUT STRESS/STRAIN ENTRIES FROM OES1.
C  HOWEVER, ONLY THOSE ALSO ON ESTX(SCR1) WILL BE PULLED.
C
  650 ANYOUT = .FALSE.
      EWORDS = BUF(2)
      NPTS = BUF(3)
      NPTS4 = 4*NPTS
      IESTX = NCSTM + 1
      NESTX = NCSTM + EWORDS
      IOES1M = NESTX + 1
      NOES1M = NESTX
      LOC = 650
      ICRQ = NOES1M - JCORE
      IF( NOES1M .GT. JCORE ) GO TO 9008
      IDSCR1 = 0
C
C  READ NEXT OES1 ENTRY AND SET IDOES1  (STRIPPING OFF DEVICE CODE)
C
  670 FILE = OES1
      LOC = 670
      CALL READ(*9002,*900,OES1,BUF(1),OWORDS,NOEOR,NWORDS)
      IDOES1 = BUF(1) / 10
      IF( IDOES1 ) 9000,9000,700
C
C  READ NEXT SCR1 ENTRY AND SET IDSCR1
C
  680 FILE = SCR1
      LOC = 680
      CALL READ(*9002,*950,SCR1,IZ(IESTX),EWORDS,NOEOR,NWORDS)
      IDSCR1 = IZ(IESTX)
      IF( IDSCR1 ) 9000,9000,700
C
C  CHECK FOR MATCH OF ESTX(SCR1) ENTRY ID WITH OES1 ENTRY ID.
C
  700 IF( IDOES1 - IDSCR1 ) 670,710,680
C
C  MATCH FOUND THUS BEGIN OES1M ENTRY CALCULATIONS
C
  710 MCSID = IZ(IESTX+1)
      LOC = 710
      CALL TRANEM( MCSID, NPTS, Z(IESTX+NPTS+2), ICOMP, U(1), VEC(1) )
C
C  FORM AND ADD ENTRY TO CORE. INVARIANTS WILL BE COMPUTED LATER.
C
      INCR = 9
      IF (ICMPLX.EQ.1) INCR = 15
      ICRQ = NOES1M + INCR - JCORE
      IF( NOES1M+INCR .GT. JCORE ) GO TO 9008
      IZ(NOES1M+1) = BUF(1)
      IZ(NOES1M+2) = MCSID
      IZ(NOES1M+3) = ICOMP
      IF (ICMPLX.EQ.1) GO TO 730
C
C  IF STRAINS DO MODIFICATION OF GAMMA
C
      IF( .NOT. STRAIN ) GO TO 720
      RBUF(ISIG1+2) = RBUF(ISIG1+2) / 2.0
      RBUF(ISIG2+2) = RBUF(ISIG2+2) / 2.0
  720 CALL GMMATS( U(1),3,3,0,  RBUF(ISIG1),3,1,0,  Z(NOES1M+4) )
      CALL GMMATS( U(1),3,3,0,  RBUF(ISIG2),3,1,0,  Z(NOES1M+7) )
C
      NOES1M = NOES1M + 9
      GO TO 740
C
  730 IF (IFORMT.NE.3) GO TO 732
      DO 731 MM1 = 3, 10, 7
      MM2 = MM1 + 4
      DO 731 LLL = MM1, MM2, 2
      ZTEMP   = RBUF(LLL)*COS(RBUF(LLL+1)*DEGRAD)
      RBUF(LLL+1) = RBUF(LLL)*SIN(RBUF(LLL+1)*DEGRAD)
      RBUF(LLL) = ZTEMP
  731 CONTINUE
  732 ZDUM(1) = RBUF(3)
      ZDUM(2) = RBUF(5)
      ZDUM(3) = RBUF(7)
      CALL GMMATS (U(1),3,3,0,ZDUM,3,1,0,Z(NOES1M+4))
      ZDUM(1) = RBUF(4)
      ZDUM(2) = RBUF(6)
      ZDUM(3) = RBUF(8)
      CALL GMMATS (U(1),3,3,0,ZDUM,3,1,0,Z(NOES1M+7))
      ZDUM(1) = RBUF(10)
      ZDUM(2) = RBUF(12)
      ZDUM(3) = RBUF(14)
      CALL GMMATS (U(1),3,3,0,ZDUM,3,1,0,Z(NOES1M+10))
      ZDUM(1) = RBUF(11)
      ZDUM(2) = RBUF(13)
      ZDUM(3) = RBUF(15)
      CALL GMMATS (U(1),3,3,0,ZDUM,3,1,0,Z(NOES1M+13))
C
      IF (IFORMT.NE.3) GO TO 738
      DO 737 MM1 = 4, 10, 6
      MM2 = MM1 + 2
      DO 737 LLL = MM1, MM2
      LL1 = NOES1M + LLL
      LL2 = LL1 + 3
      ZTEMP   = SQRT (Z(LL1)**2 + Z(LL2)**2)
      IF (ZTEMP.NE.0.0) GO TO 734
      Z(LL2) = 0.0
      GO TO 736
  734 Z(LL2) = ATAN2 (Z(LL2), Z(LL1))*RADDEG
      IF (Z(LL2).LT.-0.00005E0) Z(LL2) = Z(LL2) + 360.0
  736 Z(LL1) = ZTEMP
  737 CONTINUE
C
  738 NOES1M = NOES1M + 15
C
C
C  IF THIS IS THE FIRST ELEMENT ENTRY TO BE FOUND
C  AND OES1G IS TO BE FORMED, THE ID-RECORD IS SAVED FOR USE BY
C  CURV3 OVERLAY.
C
  740 IF( .NOT. FOES1G ) GO TO 790
      IF( ANY ) GO TO 750
      FILE = SCR3
      LOC = 740
      CALL OPEN(*9001,SCR3,IZ(IBUF4),WRTREW)
      CALL WRITE( SCR3, IDREC(1), 146, EOR )
      CALL CLOSE( SCR3, CLSREW )
C
      FILE = SCR2
      CALL OPEN(*9001,SCR2,IZ(IBUF4),WRTREW)
      DEVICE = MOD( BUF(1), 10 )
      ANY = .TRUE.
C
C  OUTPUT SPECIAL ESTXX (SCR2) ENTRY FOR USE BY CURV3.
C
  750 CALL WRITE( SCR2, MCSID, 1, NOEOR )
      CALL WRITE( SCR2, Z(NOES1M-5), 6, NOEOR )
      CALL WRITE( SCR2, VEC(1), 3, NOEOR )
      CALL WRITE( SCR2, NPTS, 1, NOEOR )
      CALL WRITE( SCR2, IZ(IESTX+2), NPTS4, NOEOR )
  790 CONTINUE
      GO TO 670
C*****
C  END OF ENTRY DATA POSSIBLE FOR THIS ELEMENT TYPE
C******
C
C  SKIP ANY UNUSED DATA IN ESTX (SCR1) DATA RECORD FOR THIS ELEMENT TYPE
C
  900 FILE = SCR1
      LOC = 900
      CALL FWDREC(*9002,SCR1)
      GO TO 960
C
C  SKIP ANY UNUSED DATA IN OES1 DATA RECORD FOR THIS ELEMENT TYPE.
C
  950 FILE = OES1
      LOC = 950
      CALL FWDREC(*9002,OES1)
C
C  IF ANY ENTRIES WERE FOUND AND COMPLETED AND PLACED IN CORE
C  THEY ARE SORTED ON -MCSID- AND OUTPUT. AS THEY ARE OUTPUT
C  THE INVARIANTS ARE COMPUTED.
C
  960 IF( NOES1M .LT. IOES1M ) GO TO 100
C
C  YES THERE ARE SOME ENTRIES
C
      LOES1M = NOES1M - IOES1M + 1
      CALL SORT( 0, 0, INCR, 2, IZ(IOES1M), LOES1M )
C
C  OUTPUT ID-RECORD, REDEFINE MAJOR-ID FOR OFP MODULE
C
C  RE-DEFINITION MISSING FOR NOW.
C
      IDREC(3) = IDREC(3) + 1000
      CALL WRITE( OES1M, IDREC(1), 146, EOR )
      MCB(1) = OES1M
      CALL WRTTRL( MCB(1) )
      ANY1M = .TRUE.
C
C  MOVE AXIS CODE AND COMPLETE INVARIANTS OF EACH ENTRY.
C
      KMCSID = IZ(IOES1M+1)
      KOUNT = 0
C
      DO 970 I = IOES1M, NOES1M, INCR
      BUF(1) = IZ(I)
      BUF(2) = IZ(I+1)
      RBUF(3) = Z(I+3)
      IF (ICMPLX.EQ.1) GO TO 963
      RBUF(4) = Z(I+4)
      RBUF(5) = Z(I+5)
      CALL CURVPS( RBUF(3), RBUF(6) )
      IF( .NOT. STRAIN ) GO TO 961
      RBUF(5) = 2.0 * RBUF(5)
      RBUF(9) = 2.0 * RBUF(9)
  961 BUF(10) = IZ(I+2)
      RBUF(11) = Z(I+6)
      RBUF(12) = Z(I+7)
      RBUF(13) = Z(I+8)
      CALL CURVPS ( RBUF(11), RBUF(14) )
      IF( .NOT. STRAIN ) GO TO 962
      RBUF(13) = 2.0 * RBUF(13)
      RBUF(17) = 2.0 * RBUF(17)
  962 CALL WRITE( OES1M, BUF(1), 17, NOEOR )
      GO TO 964
  963 RBUF( 4) = Z(I+ 6)
      RBUF( 5) = Z(I+ 4)
      RBUF( 6) = Z(I+ 7)
      RBUF( 7) = Z(I+ 5)
      RBUF( 8) = Z(I+ 8)
      BUF(  9) = IZ(I+2)
      RBUF(10) = Z(I+ 9)
      RBUF(11) = Z(I+12)
      RBUF(12) = Z(I+10)
      RBUF(13) = Z(I+13)
      RBUF(14) = Z(I+11)
      RBUF(15) = Z(I+14)
      CALL WRITE (OES1M, BUF(1), 15, NOEOR)
C
C  KEEP COUNT OF ELEMENTS IN EACH MCSID GROUP
C
  964 IF( IZ(I+1) .NE. KMCSID ) GO TO 965
      KOUNT = KOUNT + 1
      IF( I+INCR-1 .LT. NOES1M ) GO TO 970
C
C  CHANGE IN -MCSID- OF OUTPUT ENTRIES OR LAST ENTRY.
C  ADD COUNT OF ELEMENTS OF CURRENT TYPE TO TOTAL COUNT
C  OF ELEMENTS OF THIS -MCSID-.
C
  965 LOC = 965
      CALL BISLOC(*9000,KMCSID,IZ(IMCSID),2,MCSIDS,JP)
      IZ(IMCSID+JP) = IZ(IMCSID+JP) + KOUNT
      KOUNT = 1
      KMCSID = IZ(I+1)
  970 CONTINUE
      CALL WRITE( OES1M, 0, 0, EOR )
      GO TO 100
C*****
C  ALL PROCESSING OF ONE SUBCASE COMPLETE FOR OES1M.
C*****
 5000 CALL CLOSE( OES1M, CLS )
      RETURN
C*****
C  ERROR CONDITION ENCOUNTERED
C*****
 9000 IMSG = -LOGERR
      GO TO 5000
 9001 IMSG = -1
      GO TO 5000
 9002 IMSG = -2
      GO TO 5000
 9003 IMSG = -3
      GO TO 5000
 9008 IMSG = -8
      LCORE = ICRQ
      GO TO 5000
      END

      SUBROUTINE TLDRS (OFFSET,II,TRANS,TRANS1)
C
C     &    ENTRY TLDRD (DFFSET,II,TRAND,TRAND1)
C
C     MODIFIED TO INCLUDE THE EFFECTS OF OFFSET
C
      REAL             TRANS(1),TRANS1(36),OFFSET
      DOUBLE PRECISION TRAND(1),TRAND1(36),DFFSET
C
C     SINGLE PRECISION -
C
      DO 10 I = 1,36
   10 TRANS1(I) = 0.0
C
      IPOINT = 9*(II-1)
C
      DO 30 I = 1,3
      JPOINT = 6*(I-1)
      KPOINT = JPOINT  + 21
      LPOINT = 3*(I-1) + IPOINT
C
      DO 20 J = 1,3
      TRANS1(JPOINT+J) = TRANS(LPOINT+J)
      TRANS1(KPOINT+J) = TRANS(LPOINT+J)
   20 CONTINUE
   30 CONTINUE
C
      IF (OFFSET .EQ. 0.0) GO TO 100
      TRANS1(4) = OFFSET*TRANS(IPOINT+4)
      TRANS1(5) = OFFSET*TRANS(IPOINT+5)
      TRANS1(6) = OFFSET*TRANS(IPOINT+6)
      TRANS1(10)=-OFFSET*TRANS(IPOINT+1)
      TRANS1(11)=-OFFSET*TRANS(IPOINT+2)
      TRANS1(12)=-OFFSET*TRANS(IPOINT+3)
      GO TO 100
C
      ENTRY TLDRD (DFFSET,II,TRAND,TRAND1)
C     ====================================
C
C     DOUBLE PRECISION -
C
      DO 60 I = 1,36
   60 TRAND1(I) = 0.0D0
C
      IPOINT = 9*(II-1)
C
      DO 80 I = 1,3
      JPOINT = 6*(I-1)
      KPOINT = JPOINT  + 21
      LPOINT = 3*(I-1) + IPOINT
C
      DO 70 J = 1,3
      TRAND1(JPOINT+J) = TRAND(LPOINT+J)
      TRAND1(KPOINT+J) = TRAND(LPOINT+J)
   70 CONTINUE
   80 CONTINUE
C
      IF (DFFSET .EQ. 0.0D0) GO TO 100
      TRAND1(4) = DFFSET*TRAND(IPOINT+4)
      TRAND1(5) = DFFSET*TRAND(IPOINT+5)
      TRAND1(6) = DFFSET*TRAND(IPOINT+6)
      TRAND1(10)=-DFFSET*TRAND(IPOINT+1)
      TRAND1(11)=-DFFSET*TRAND(IPOINT+2)
      TRAND1(12)=-DFFSET*TRAND(IPOINT+3)
  100 RETURN
      END

      SUBROUTINE IFP1S (LIST,ISTOR,NLIST)
C
C     THIS ROUTINE FINDS ANY OVERLAPPING INTERVALS IN A SET LIST.
C     IT WILL ALSO CHECK SINGLES
C
      INTEGER         OTPE
      DIMENSION       LIST(1),ISTOR(1)
      CHARACTER       UFM*23,UWM*25
      COMMON /XMSSG / UFM,UWM
      COMMON /SYSTEM/ SYSBUF,OTPE,INX(6),NLPP,INX1(2),LINE
C
      IPAIR = 0
      DO 100 I = 1,NLIST
      IF (LIST(I) .GT. 0) GO TO 100
   10 IF (IPAIR   .NE. 0) GO TO 40
   20 L = 2*IPAIR + 1
      ISTOR(L  ) = LIST(I-1)
      ISTOR(L+1) = LIST(I  )
      IPAIR = IPAIR + 1
   30 LIST(I  ) = 0
      LIST(I-1) = 0
      GO TO 100
C
C     PAIR FOUND - CHECK FOR OVERLAP
C
   40 L  = 1
      IN = IABS(LIST(I-1))
      IOUT = IABS(LIST(I  ))
      K  = 2*L - 1
   50 IF (IN.GE.ISTOR(K)   .AND. IN.LE.IABS(ISTOR(K+1))  ) GO TO 60
      IF (IOUT.GE.ISTOR(K) .AND. IOUT.LE.IABS(ISTOR(K+1))) GO TO 60
      L  = L + 1
      IF (L .LE. IPAIR) GO TO 50
C
C     STORE NEW PAIR IN LIST
C
      GO TO 20
C
C     ERROR IN INTERVAL
C
   60 LIST(I-1) = MIN0(IN,ISTOR(K))
      LIST(I  ) =-MAX0(IOUT,IABS(ISTOR(K+1)))
      IF (LIST(I-1).EQ.ISTOR(K) .AND. LIST(I).EQ.ISTOR(K+1)) GO TO 30
      IX = IABS(ISTOR(K+1))
      WRITE  (OTPE,70) UWM,IN,IOUT,ISTOR(K),IX
   70 FORMAT (A25,' 621, INTERVAL',I8,' THRU',I8,' OVERLAPS INTERVAL',
     1       I8,' THRU', I8,'. THE MAXIMUM INTERVAL WILL BE USED.')
      LINE = LINE + 3
      IF (LINE .GE. NLPP) CALL PAGE
C
C     REMOVE PAIR L FROM ISTOR
C
   80 IF (L .GE. IPAIR) GO TO 90
      M = 2*L + 1
      K = 2*L - 1
      ISTOR(K  ) = ISTOR(M  )
      ISTOR(K+1) = ISTOR(M+1)
      L = L + 1
      GO TO 80
   90 IPAIR = IPAIR - 1
      GO TO 10
  100 CONTINUE
C
C     ALL PAIRS PROCESSED - TRY SINGLES
C
      ISING = 0
      M  = 2*IPAIR
      DO 180 I = 1,NLIST
      IN = LIST(I)
      IF (IPAIR   .EQ. 0) GO TO 140
      IF (LIST(I) .EQ. 0) GO TO 180
C
C     CHECK EACH PAIR
C
      L = 1
  110 K = 2*L - 1
      IF (IN.GE.ISTOR(K) .AND. IN.LE.IABS(ISTOR(K+1))) GO TO 120
      L = L + 1
      IF (L-IPAIR) 110,110,140
C
C     ERROR -- PAIR CONTAINS SINGLE
C
  120 IN1 = IABS(ISTOR(K+1))
      WRITE  (OTPE,130) UWM,IN,ISTOR(K),IN1
  130 FORMAT (A25,' 619, SET MEMBER',I8,' BELONGS TO',I8,' THRU',I8)
      LINE = LINE + 3
      IF (LINE .GE. NLPP) CALL PAGE
      GO TO 180
C
C     CHECK FOR DUPLICATE SINGLES
C
  140 IF (ISING .EQ. 0) GO TO 170
      DO 160 K = 1,ISING
      L = 2*IPAIR + K
      IF (IN .NE. ISTOR(L)) GO TO 160
      WRITE  (OTPE,150) UWM,IN
  150 FORMAT (A25,' 620, SET MEMBER',I8,' IS DUPLICATED IN SET LIST.')
      LINE = LINE + 3
      IF (LINE .GE. NLPP) CALL PAGE
      GO TO 180
  160 CONTINUE
  170 M = M + 1
      ISING = ISING + 1
      ISTOR(M) = IN
  180 CONTINUE
C
C     COPY GOOD STUFF INTO LIST
C
      DO 190 I = 1,M
  190 LIST(I) = ISTOR(I)
      NLIST = M
C
C     SORT LIST
C
      N1 = M - 1
      DO 230 I = 1,N1
      N2 = I + 1
      DO 220 K = N2,M
      IF (IABS(LIST(I))-IABS(LIST(K))) 220,220,210
C
C     SWITCH
C
  210 IN = LIST(I)
      LIST(I) = LIST(K)
      LIST(K) = IN
  220 CONTINUE
  230 CONTINUE
C
      RETURN
      END

      BLOCK DATA FLBBD
CFLBBD
C     FLBBD - BLOCK DATA FOR MODULE FLBMG
C
      INTEGER         GEOM2    ,ECT      ,BGPDT    ,SIL      ,GEOM3    ,
     1                CSTM     ,USET     ,EQEXIN   ,USETF    ,USETS    ,
     2                AF       ,DKGG     ,FBELM    ,FRELM    ,CONECT   ,
     3                AFMAT    ,AFDICT   ,KGMAT    ,KGDICT
C
C     GINO FILES
C
      COMMON /FLBFIL/ GEOM2    ,ECT      ,BGPDT    ,SIL      ,MPT      ,
     1                GEOM3    ,CSTM     ,USET     ,EQEXIN   ,USETF    ,
     2                USETS    ,AF       ,DKGG     ,FBELM    ,FRELM    ,
     3                CONECT   ,AFMAT    ,AFDICT   ,KGMAT    ,KGDICT
C
C     INPUT DATA BLOCKS
C
      DATA            GEOM2    ,ECT      ,BGPDT    ,SIL      ,MPT      ,
     1                GEOM3    ,CSTM     ,USET     ,EQEXIN             /
     2                101      ,102      ,103      ,104      ,105      ,
     3                106      ,107      ,108      ,109                /
C
C     OUTPUT DATA BLOCKS
C
      DATA            USETF    ,USETS    ,AF       ,DKGG               /
     1                201      ,202      ,203      ,204                /
C
C     INTERNAL SCRATCH FILES
C
      DATA            FBELM    ,FRELM    ,CONECT   ,AFMAT    ,AFDICT   ,
     1                KGMAT    ,KGDICT                                 /
     2                301      ,302      ,303      ,304      ,305      ,
     3                306      ,307                                    /
C
      END

      SUBROUTINE SINC0S1 (ROW,SICK, D,O,COS)
C                    =
C     SUBROUTINE SICOX (D,O,COS)
C
C     THIS ROUTINE WAS CALLED SICOX BEFORE, WITH ENTRY POINT SINCAS
C                                                                =
C     THIS ROUTINE IS CALLED ONLY BY TRIDI SUBROUTINE, WHICH IS CALLED
C     ONLY BY VALVEC
C
C     IT CALCULATES SINES AND COSINES FOR GIVENS TRIDIAGONALIZATION
C
      INTEGER          ROWP2,ROW,SICK
      REAL             D(1),O(1),COS(1),Z
      COMMON /GIVN  /  TITLE(100),N
C
C     D   = DIAGONAL AND SINES.
C     O   = OFF-DIAGONAL.
C     COS = COSINES.
C
C     RETURN
C
C
C     ENTRY SINCAS (ROW,SICK)
C     =======================
C
C     CALCULATE THE SINES AND COSINES OF ROW -ROW-.
C
      SICK  = 0
      ROWP2 = ROW + 2
      DO 105 I = ROWP2,N
      IF (D(I) .EQ. 0.0) GO TO 101
C
C     CALCULATE THE ROTATION.
C
      SICK = 1
      Z    = SQRT(D(I)**2 + D(ROW+1)**2)
      D(I) = D(I)/Z
      COS(I) = D(ROW+1)/Z
      D(ROW+1) = Z
      IF (COS(I) .GE. 0.0) GO TO 105
      COS(I) = ABS(COS(I))
      D(I)   = -D(I)
      D(ROW+1) = -D(ROW+1)
      GO TO 105
C
C     NO ROTATION.
C
  101 COS(I) = 1.0
  105 CONTINUE
      O(ROW) = D(ROW+1)
      RETURN
      END

      SUBROUTINE XYLOG( V1, V2, CYCLES )
      INTEGER CYCLES, POWER1, POWER2
C*****
C  THIS SUBROUTINE TAKES V1 AND V2 REGARDLESS OF THEIR VALUES
C  AND COMPUTES A LOG SCALE OF AT LEAST 1 CYCLE...
C*****
      IF( V1 .GT. 0.0E0 ) GO TO 20
      IF( V2 .GT. 0.0E0 ) GO TO 10
C
C     V1 AND V2 ARE BOTH NEGATIVE OR ZERO.  SET ARBITRARY LIMITS
C
    5 V1 = 1.0E-5
      V2 = 1.0E+5
      CYCLES = 10
      RETURN
C
C     V2 IS POSITIVE BUT V1 IS NEGATIVE OR 0
C
   10 V1 = V2 * 1.0E-5
      GO TO 40
C
   20 IF( V2 .GT. 0.0E0 ) GO TO 30
C
C     V1 IS POSITIVE BUT V2 IS NEGATIVE OR 0
C
      V2 = V1 * 1.0E+5
      GO TO 40
C
   30 IF( V2 .GT. V1 ) GO TO 40
      TEMP = V1
      V1 = V2
      V2 = TEMP
C
C     RAISE V2 TO POWER OF 10,  LOWER V1 TO POWER OF 10
C
   40 POWER1 = 0
CWKBR 9/93  50 IF( V1 .LT. 1.0E0      ) GO TO 70
   50 IF( V1 .LT. 0.99999) GO TO 70
CWKBR 9/93  60 IF( V1 .LT. 10.0E0) GO TO 80
   60 IF( V1 .LE. 10.0001) GO TO 80
      V1 = V1 / 10.0E0
      POWER1 = POWER1 + 1
      GO TO 60
   70 V1 = V1 * 10.0E0
      IF( V1 .LE. 0.0E0 ) GO TO 5
      POWER1 = POWER1 - 1
      GO TO 50
C
   80 V1 = 10.0E0 ** POWER1
C
      POWER2 = 1
   90 IF(V2.LE. 1.0E0) GO TO 110
CWKBR 9/93 100 IF( V2 .LT. 10.00001E0) GO TO 120
  100 IF( V2 .LE. 10.0001   ) GO TO 120
      V2 = V2 / 10.0E0
      POWER2 = POWER2 + 1
      GO TO 100
  110 V2 = V2 * 10.0E0
      IF( V2 .LE. 0.0E0 ) GO TO 5
      POWER2 = POWER2 - 1
      GO TO 90
C
  120 V2 = 10.0 ** POWER2
C
      CYCLES = POWER2 - POWER1
      RETURN
      END

      SUBROUTINE SHSETD (*,MM,SIL,BGPDT,IGPDT,GPTH,ELTH,GPTEMP,BGPDM,
     1                   EGPDT,DGPTH,GPNORM,EPNORM,NNODE,MMN,NSIL,
     2                   IORDER,IORDRN,TEB,TUB,CENTE,AVGTHK,TCE,ELID)
C
C     TO SET UP FOR ISOPARAMETRIC SHELL ELEMENTS, CALLED ONLY BY SHHMGD
C
C     DOUBLE PRECISION VERSION
C
C     INPUT :
C           MM       - MAXIMUM NO. OF NODES PER THIS TYPE ELEMENT
C           SIL      - ARRAY OF SIL NUMBERS
C           BGPDT    - BGPDT DATA FROM EST (REAL ARRAY)
C           IGPDT    - BGPDT DATA FROM EST (INTEGER ARRAY)
C           GPTH     - GRID POINT THICKNESS DATA
C           ELTH     - ELEMENT THICKNESS FROM EPT
C           GPTEMP   - GRID POINT TEMPERATURE DATA
C           ELID     - ELEMENT ID
C     OUTPUT:
C           SIL      - ARRAY OF SIL NUMBERS        (REARRANGED)
C           BGPDT    - BGPDT DATA (REAL ARRAY)     (REARRANGED)
C           IGPDT    - BGPDT DATA (INTEGER ARRAY)  (REARRANGED)
C           GPTH     - GRID POINT THICKNESS DATA   (REARRANGED)
C           GPTEMP   - GRID POINT TEMPERATURE DATA (REARRANGED)
C           BGPDM    - BGPDT DATA SAVED IN ORIGINAL FORMAT
C           EGPDT    - BGPDT DATA IN ELEMENT COORD. SYSTEM
C           DGPTH    - GRID POINT THICKNESS DATA
C           GPNORM   - GRID POINT NORMALS
C           EPNORM   - GRID POINT NORMALS IN ELEMENT COORD. SYSTEM
C           NNODE    - THE NO. OF NODES PRESENT IN THE ELEMENT
C           MMN      - ARRAY OF MISSING MIDSIDE NODES
C           NSIL     - INTERNALLY ORDERED SIL ARRAY
C           IORDER   - ARRAY OF ORDER INDICATORS FOR REARRANGED DATA
C           IORDRN   - ARRAY OF ORDER INDICATORS FOR TRIA
C           TEB      - TRANSFORMATION FROM ELEMENT TO BASIC COORD.SYSTEM
C           TUB      - TRANSFORMATION FROM USER TO BASIC COORD. SYSTEM
C           CENTE    - LOCATION OF THE CENTER OF THE ELEMENT
C           AVGTHK   - AVERAGE THICKNESS OF THE ELEMENT
C
      LOGICAL          QUAD
      INTEGER          SIL(8),IORDER(8),KSIL(8),KCID(8),MMN(8),NSIL(8),
     1                 IORDRN(8),IGPDT(4,8),ELID
      REAL             GPTEMP(8),TEMTEM(8),BGPDT(4,8),TGRID(4,8),
     1                 GPTH(8),TMPTHK(8),BGPDM(3,8)
      DOUBLE PRECISION CENT(3),CENTE(3),EGPDT(4,8),GGU(9),GGN(9),TEB(9),
     1                 TEU(9),SMAX,SMIN,SL(3),GGE(9),TUB(9),CC,DGPTH(8),
     2                 GPNORM(4,8),EPNORM(4,8),X31,Y31,X42,Y42,EXI,EXJ,
     3                 AA,BB,UGPDM(3,8),TCE(63),AVGTHK
C
C
      IF (MM.NE.3 .AND. MM.NE.4 .AND. MM.NE.6 .AND. MM.NE.8) GO TO 700
C           TRIA3         QUAD4         TRIA6         QUAD8
C
      QUAD = MM.EQ.8 .OR. MM.EQ.4
      MMX  = 3
      IF (QUAD) MMX = 4
      NNODE = MM
      DO 10 I = 1,MM
      MMN(I) = SIL(I)
      KSIL(I)= SIL(I)
      IF (SIL(I) .GT. 0) GO TO 10
      NNODE = NNODE - 1
   10 CONTINUE
C
C     FILL IN ARRAY GGU WITH THE COORDINATES OF GRID POINTS 1,2 AND 4
C     (3 FOR TRIA). THIS ARRAY WILL BE USED LATER TO DEFINE THE USER
C     COORDINATE SYSTEM WHILE CALCULATING TRANSFORMATIONS INVOLVING
C     THIS COORDINATE SYSTEM.
C
      DO 20 I = 1,3
      II = (I-1)*3
      IJ = I
      IF (QUAD .AND. IJ.EQ.3) IJ = 4
      DO 20 J = 1,3
      JJ = J + 1
   20 GGU(II+J) = DBLE(BGPDT(JJ,IJ))
      CALL BETRND (TUB,GGU,0,ELID)
C
C     STORE INCOMING BGPDT FOR LUMPED MASS AND ELEMENT COORD. SYSTEM
C
      DO 30 I = 1,3
      I1 = I + 1
      DO 30 J = 1,MM
   30 BGPDM(I,J) = BGPDT(I1,J)
C
C     TRANSFORM BGPDM FROM BASIC TO USER COORD. SYSTEM
C
      DO 40 I = 1,3
      IP = (I-1)*3
      DO 40 J = 1,MM
      UGPDM(I,J) = 0.0D0
      DO 40 K = 1,3
      KK = IP + K
   40 UGPDM(I,J) = UGPDM(I,J) + TUB(KK)*(DBLE(BGPDM(K,J))-GGU(K))
C
      IF (QUAD) GO TO 200
C
C     FOR TRIA
C     CALCULATE THE CENTER COORDINATES
C
      CENTE(1) = (GGU(1)+GGU(4)+GGU(7))/3.0D0
      CENTE(2) = (GGU(2)+GGU(5)+GGU(8))/3.0D0
      CENTE(3) = (GGU(3)+GGU(6)+GGU(9))/3.0D0
C
C     ESTABLISH THE INTERNAL COORDINATES:
C     X-AXIS IS ALONG THE MIDDLE-SIZED SIDE AND THE XY-PLANE IS
C     DETERMINED BY IT TOGETHER WITH THE SHORTEST SIDE
C
      CC = (GGU(7)-GGU(4))*(GGU(7)-GGU(4))
     1   + (GGU(8)-GGU(5))*(GGU(8)-GGU(5))
     2   + (GGU(9)-GGU(6))*(GGU(9)-GGU(6))
      IF (CC .LE. 0.0D0) GO TO 700
      SL(1) = DSQRT(CC)
      CC = (GGU(7)-GGU(1))*(GGU(7)-GGU(1))
     1   + (GGU(8)-GGU(2))*(GGU(8)-GGU(2))
     2   + (GGU(9)-GGU(3))*(GGU(9)-GGU(3))
      IF (CC .LE. 0.0D0) GO TO 700
      SL(2) = DSQRT(CC)
      CC = (GGU(4)-GGU(1))*(GGU(4)-GGU(1))
     1   + (GGU(5)-GGU(2))*(GGU(5)-GGU(2))
     2   + (GGU(6)-GGU(3))*(GGU(6)-GGU(3))
      IF (CC .LE. 0.0D0) GO TO 700
      SL(3) = DSQRT(CC)
      SMAX  = SL(1)
      ISMAX = 1
      DO 100 I = 2,3
      IF (SL(I) .LE. SMAX) GO TO 100
      SMAX  = SL(I)
      ISMAX = I
  100 CONTINUE
      SMIN  = SL(1)
      ISMIN = 1
      DO 110 I = 2,3
      IF (SL(I) .GE. SMIN) GO TO 110
      SMIN  = SL(I)
      ISMIN = I
  110 CONTINUE
      IF (ISMAX .EQ. ISMIN) ISMIN = 3
      MIDDL = IABS(ISMAX-ISMIN)
      IF (ISMAX+ISMIN .EQ. 3) MIDDL = 3
C
C     DETECT THE POSSIBLE REVERSAL OF THE INTERNAL Z-AXIS WITH RESPECT
C     TO THE USER Z-AXIS. IF THAT IS THE CASE, SWITCH ISMAX AND ISMIN
C     TO AVOID THE PROBLEM. THE SIDE WITH MEDIUM LENGTH WILL STILL BE
C     THE X-AXIS.
C
      IF (ISMAX .NE. MOD(ISMIN,3)+1) GO TO 120
      III    = ISMIN
      ISMIN  = ISMAX
      ISMAX  = III
C
  120 IS3    = 3*(ISMAX-1)
      GGN(1) = GGU(IS3+1)
      GGN(2) = GGU(IS3+2)
      GGN(3) = GGU(IS3+3)
C
      IS3    = 3*(ISMIN-1)
      GGN(4) = GGU(IS3+1)
      GGN(5) = GGU(IS3+2)
      GGN(6) = GGU(IS3+3)
C
      IS3    = 3*(MIDDL-1)
      GGN(7) = GGU(IS3+1)
      GGN(8) = GGU(IS3+2)
      GGN(9) = GGU(IS3+3)
C
      CALL BETRND (TEB,GGN,0,ELID)
      GO TO 300
C
C     FOR QUAD
C     THE ORIGIN OF THE ELEMENT COORD.SYSTEM IS IN THE MIDDLE OF THE
C     ELEMENT
C
  200 DO 210 J = 1,3
      CENT(J) = 0.0D0
      DO 210 I = 1,MM
  210 CENT(J) = CENT(J) + UGPDM(J,I)/NNODE
C
C     STORE THE CORNER NODE DIFF. IN THE USER COORD. SYSTEM
C
      X31 = UGPDM(1,3) - UGPDM(1,1)
      Y31 = UGPDM(2,3) - UGPDM(2,1)
      X42 = UGPDM(1,4) - UGPDM(1,2)
      Y42 = UGPDM(2,4) - UGPDM(2,2)
      AA  = X31*X31 + Y31*Y31
      IF (AA .LE. 0.0D0) GO TO 700
      AA  = DSQRT(AA)
      BB  = X42*X42 + Y42*Y42
      IF (BB .LE. 0.0D0) GO TO 700
      BB  = DSQRT(BB)
C
C     NORMALIZE XIJ'S
C
      X31 = X31/AA
      Y31 = Y31/AA
      X42 = X42/BB
      Y42 = Y42/BB
      EXI = X31 - X42
      EXJ = Y31 - Y42
C
C     STORE GGE ARRAY, THE OFFSET BETWEEN ELEMENT COORD. SYSTEM AND USER
C     COORD. SYSTEM
C
      GGE(1) = CENT(1)
      GGE(2) = CENT(2)
      GGE(3) = CENT(3)
C
      GGE(4) = GGE(1) + EXI
      GGE(5) = GGE(2) + EXJ
      GGE(6) = GGE(3)
C
      GGE(7) = GGE(1) - EXJ
      GGE(8) = GGE(2) + EXI
      GGE(9) = GGE(3)
C
      CALL BETRND (TEU,GGE,0,ELID)
      CALL GMMATD (TEU,3,3,0, TUB,3,3,0,  TEB)
      CALL GMMATD (TUB,3,3,1, CENT,3,1,0, CENTE)
C
C     THE ARRAY IORDER STORES THE ELEMENT NODE ID IN INCREASING SIL
C     ORDER.
C
C     IORDER(1)  = NODE WITH LOWEST  SIL NUMBER
C     IORDER(MM) = NODE WITH HIGHEST SIL NUMBER
C
C     ELEMENT NODE NUMBER IS THE INTEGER FROM THE NODE LIST
C     G1,G2,G3,G4,G5,G6,G7,G8 .  THAT IS, THE "I" PART OF THE "GI" AS
C     THEY ARE LISTED ON THE CONNECTIVITY BULK DATA CARD DESCRIPTION.
C
  300 KSILD = 99999995
      DO 310 I = 1,MM
      IORDER(I) = 0
      IORDRN(I) = 0
      KSIL(I) = SIL(I)
      IF (SIL(I) .NE. 0) GO TO 310
      KSIL(I) = KSILD
      KSILD   = KSILD + 1
  310 CONTINUE
      DO 330 I = 1,MM
      ITEMP = 1
      ISIL  = KSIL(1)
      DO 320 J = 2,MM
      IF (ISIL .LE. KSIL(J)) GO TO 320
      ITEMP = J
      ISIL  = KSIL(J)
  320 CONTINUE
      IORDER(I) = ITEMP
      IORDRN(I) = ITEMP
      KSIL(ITEMP) = 99999999
  330 CONTINUE
C
C     ADJUST EST DATA
C
C     USE THE POINTERS IN IORDER TO COMPLETELY REORDER THE GEOMETRY DATA
C     INTO INCREASING SIL ORDER.
C     DON'T WORRY!! IORDER ALSO KEEPS TRACK OF WHICH SHAPE FUNCTIONS GO
C     WITH WHICH GEOMETRIC PARAMETERS!
C
      DO 350 I = 1,MM
      KSIL(I)  = SIL(I)
      TMPTHK(I)= GPTH(I)
      IF (MM .NE. 4) TEMTEM(I) = GPTEMP(I)
      KCID(I) = IGPDT(1,I)
      DO 340 J = 2,4
      TGRID(J,I) = BGPDT(J,I)
  340 CONTINUE
  350 CONTINUE
      DO 370 I = 1,MM
      IPOINT  = IORDER(I)
      SIL(I)  = KSIL(IPOINT)
      NSIL(I) = KSIL(IPOINT)
      GPTH(I) = TMPTHK(IPOINT)
      IF (MM .NE. 4) GPTEMP(I) = TEMTEM(IPOINT)
      IGPDT(1,I) = KCID(IPOINT)
      DO 360 J = 2,4
      BGPDT(J,I) = TGRID(J,IPOINT)
  360 CONTINUE
  370 CONTINUE
C
      IF (QUAD) GO TO 500
C
C     FOR TRIA
C     CREATE THE INTERNAL ORDER OF THE NODES OF ELEMENT IN CONNECTION
C     WITH THE INTERNAL COORDINATE SYSTEM THEN CALCULATE NORMALS
C
      DO 400 I = 1,MM
      IF (IORDER(I) .EQ. ISMAX) IORDRN(I) = 1
      IF (IORDER(I) .EQ. ISMIN) IORDRN(I) = 2
      IF (IORDER(I) .EQ. MIDDL) IORDRN(I) = 3
      IF (IORDER(I) .EQ. 4) IND4=I
      IF (IORDER(I) .EQ. 5) IND5=I
      IF (IORDER(I) .EQ. 6) IND6=I
  400 CONTINUE
      IF (MM .NE. 6) GO TO 410
      IF (ISMAX+ISMIN .EQ. 3) IORDRN(IND4) = 4
      IF (ISMAX+ISMIN .EQ. 4) IORDRN(IND6) = 4
      IF (ISMAX+ISMIN .EQ. 5) IORDRN(IND5) = 4
      IF (ISMIN+MIDDL .EQ. 3) IORDRN(IND4) = 5
      IF (ISMIN+MIDDL .EQ. 4) IORDRN(IND6) = 5
      IF (ISMIN+MIDDL .EQ. 5) IORDRN(IND5) = 5
      IF (MIDDL+ISMAX .EQ. 3) IORDRN(IND4) = 6
      IF (MIDDL+ISMAX .EQ. 4) IORDRN(IND6) = 6
      IF (MIDDL+ISMAX .EQ. 5) IORDRN(IND5) = 6
C
  410 DO 420 I = 1,3
      II = I + 1
      IP = (I-1)*3
      DO 420 J = 1,NNODE
      EGPDT(II,J) = 0.0D0
      DO 420 K = 1,3
      KK = IP + K
      EGPDT(II,J) = EGPDT(II,J) + TEB(KK)*(DBLE(BGPDT(K+1,J))-GGN(K))
  420 CONTINUE
C
C     USE THE POINTERS IN IORDER AND IORDRN TO REORDER MMN
C
      DO 430 I = 1,MM
      IPOINT = IORDRN(I)
      JPOINT = IORDER(I)
      MMN(IPOINT) = KSIL(JPOINT)
  430 CONTINUE
C
      IF (MM .NE. 3) GO TO 520
      DO 440 II=1,3
      EPNORM(1,II) = 0.0D0
      EPNORM(2,II) = 0.0D0
      EPNORM(3,II) = 0.0D0
      EPNORM(4,II) = 1.0D0
      GPNORM(1,II) = 0.0D0
      GPNORM(2,II) = TEB(7)
      GPNORM(3,II) = TEB(8)
      GPNORM(4,II) = TEB(9)
  440 CONTINUE
      GO TO 520
C
C     FOR QUAD - COMPUTE NODAL NORMALS
C     THE COORDINATES OF THE ELEMENT GRID POINTS HAVE TO BE TRANSFORMED
C     FROM THE BASIC COORD. SYSTEM TO THE ELEMENT COORD. SYSTEM
C
  500 IFLAG = 0
      IF (MM .EQ. 4) CALL Q4NRMD (BGPDT,GPNORM,IORDER,IFLAG)
      IF (IFLAG .NE. 0) GO TO 700
C
      DO 510 I = 1,3
      II = I + 1
      IP = (I-1)*3
      DO 510 J = 1,NNODE
      EPNORM(II,J) = 0.0D0
      EGPDT (II,J) = 0.0D0
      DO 510 K = 1,3
      KK = IP + K
      K1 = K  + 1
      CC = DBLE(BGPDT(K1,J)) - GGU(K) - CENTE(K)
      EPNORM(II,J) = EPNORM(II,J) + TEB(KK)*GPNORM(K1,J)
      EGPDT (II,J) = EGPDT (II,J) + TEB(KK)*CC
  510 CONTINUE
C
C     SET AVGTHK TO ZERO
C
  520 AVGTHK = 0.0D0
      DO 550 I = 1,NNODE
      IO = IORDER(I)
      IF (IO .GT. MMX) GO TO 550
C
      IF (GPTH(I)) 700,530,540
  530 IF (ELTH .LE. 0.0) GO TO 700
      GPTH(I)  = ELTH
  540 DGPTH(I) = DBLE(GPTH(I))
      AVGTHK = AVGTHK + DGPTH(I)/NNODE
  550 CONTINUE
C
      DO 620 I = 1,NNODE
      IO = IORDER(I)
      IF (IO      .LE. MMX) GO TO 620
      IF (GPTH(I) .GT. 0.0) GO TO 610
      IO1 = IO  - MMX
      IO2 = IO1 + 1
      IF (IO2 .EQ. MMX+1) IO2 = 1
      DO 600 J = 1,MM
      JO = IORDER(J)
      IF (JO .EQ. IO1) IC1 = J
      IF (JO .EQ. IO2) IC2 = J
  600 CONTINUE
      GPTH (I) = (GPTH(IC1)+GPTH(IC2))/2.0
  610 DGPTH(I) = DBLE(GPTH(I))
      AVGTHK = AVGTHK + DGPTH(I)/NNODE
  620 CONTINUE
      RETURN
C
  700 RETURN 1
      END

      SUBROUTINE RANDOM
C
C     RANDOM ANALYSIS MODULE
C
C     INPUTS   CASECC,XYCB,DIT,DISP,SPCF,LOAD,STRESS,FORCE,PSDL  (9)
C
C     OUTPUTS  PSDF,AUTO  (2)
C
C     SCRATCHES (0)
C
C     PARAMETERS 1 INTEGER
      INTEGER CASECC,XYCB,DIT,IFILE(5),PSDL,PSDF,AUTO
      COMMON /BLANK/ ICOUP
      DATA XYCB,DIT,PSDL,IFILE,CASECC/101,102,103,104,105,106,107,108,
     1   109/
      DATA PSDF,AUTO /201,202/
      DATA NFILE              /5/
C
C     INITIALIZE + SET UP
C
      CALL RAND7(IFILE,NFILE,PSDL,DIT,ICOUP,NFREQ,NPSDL,NTAU,LTAB,
     1   CASECC,XYCB)
      IF( ICOUP) 10,20,30
   10 RETURN
C
C     UNCOUPLED
C
   20 CALL RAND5(NFREQ,NPSDL,NTAU,XYCB,LTAB,IFILE,PSDF,AUTO,NFILE)
      GO TO 10
C
C     COUPLED
C
   30 CALL RAND8(NFREQ,NPSDL,NTAU,XYCB,LTAB,IFILE,PSDF,AUTO,NFILE)
      GO TO 10
      END

      SUBROUTINE FRRD1F (MHH,BHH,KHH,FRL,FRQSET,NLOAD,NFREQ,PH,UHV)
C
C     ROUTINE  SOLVES DIRECTLY FOR UNCOUPLED MODAL FORMULATION
C
      INTEGER         BHH,FRL,FRQSET,PH,UHV,SYSBUF,FILE,MCB(7),NAME(2)
      COMMON /SYSTEM/ SYSBUF
      COMMON /ZBLPKX/ B(4),JJ
      COMMON /ZNTPKX/ A(4),II,IEOL,IEOR
      COMMON /ZZZZZZ/ CORE(1)
      DATA    NAME  / 4HFRRD,4H1F  /
C
C
      IBUF1 = KORSZ(CORE) - SYSBUF + 1
C
C     PICK UP FREQUENCY LIST
C
      CALL GOPEN  (FRL,CORE(IBUF1),0)
      CALL SKPREC (FRL,FRQSET-1)
      IF (IBUF1-1 .LT. NFREQ) GO TO 170
      CALL FREAD (FRL,CORE,NFREQ,1)
      CALL CLOSE (FRL,1)
C
C     BRING IN  MODAL MATRICES
C
      IMHH   = NFREQ
      MCB(1) = MHH
      CALL RDTRL (MCB)
      LHSET  = MCB(2)
      IF (IBUF1-1 .LT. NFREQ+3*LHSET) GO TO 170
      IBHH   = IMHH + LHSET
      IKHH   = IBHH + LHSET
C
C     BRING IN MHH
C
      MATNAM = MHH
      ASSIGN 30 TO IRET
      IPNT   = IMHH
      GO TO 110
C
C     BRING  IN  BHH
C
   30 MATNAM = BHH
      ASSIGN 40 TO IRET
      IPNT   = IBHH
      GO TO 110
C
C     BRING IN KHH
C
   40 MATNAM =  KHH
      ASSIGN 50 TO IRET
      IPNT   = IKHH
      GO TO 110
C
C     READY LOADS
C
   50 CALL GOPEN (PH,CORE(IBUF1),0)
C
C     READY SOLUTIONS
C
      IBUF2 = IBUF1 - SYSBUF
      CALL GOPEN  (UHV,CORE(IBUF2),1)
      CALL MAKMCB (MCB,UHV,LHSET,2,3)
C
C     COMPUTE  SOLUTIONS
C
      DO 100 I = 1,NLOAD
      DO 90  J = 1,NFREQ
C
C     PICK  UP  FREQ
C
      W  = CORE(J)
      W2 = -W*W
      CALL BLDPK (3,3,UHV,0,0)
      CALL INTPK (*80,PH,0,3,0)
   60 IF (IEOL) 80,70,80
   70 CALL ZNTPKI
C
C     COMPUTE  REAL AND COMPLEX PARTS OF DENOMINATOR
C
      IK   = IKHH + II
      IB   = IBHH + II
      IM   = IMHH + II
      RDEM = W2*CORE(IM) + CORE(IK)
      CDEM = CORE(IB)*W
CIBMD DEM  = RDEM*RDEM + CDEM*CDEM
CIBMR IF (DEM .NE. 0.0) GO TO 71
      IF (RDEM.NE.0.0 .OR. CDEM.NE.0.0) GO TO 71
      CALL MESAGE (5,J,NAME)
      B(1) = 0.0
      B(2) = 0.0
      GO TO 72
   71 CONTINUE
C
C     COMPUTE REAL AND COMPLEX PHI-S
C
CIBMD B(1) = (A(1)*RDEM + A(2)*CDEM)/DEM
CIBMD B(2) = (A(2)*RDEM - A(1)*CDEM)/DEM
CIBMNB
      IF (RDEM .EQ. 0.0) GO TO 715
      RATIO = CDEM/RDEM
      FACTR = 1.0 / (RDEM + RATIO*CDEM)
      B(1) = (A(1) + A(2)*RATIO) * FACTR
      B(2) = (A(2) - A(1)*RATIO) * FACTR
      GO TO 72
  715 RATIO = RDEM/CDEM
      FACTR = 1.0 / (RATIO*RDEM + CDEM)
      B(1) = (A(1)*RATIO + A(2)) * FACTR
      B(2) = (A(2)*RATIO - A(1)) * FACTR
CIBMNE
   72 JJ   = II
      CALL ZBLPKI
      GO TO 60
C
C     END  COLUMN
C
   80 CALL BLDPKN (UHV,0,MCB)
   90 CONTINUE
  100 CONTINUE
      CALL CLOSE  (UHV,1)
      CALL CLOSE  (PH,1)
      CALL WRTTRL (MCB)
      RETURN
C
C     INTERNAL SUBROUTINE TO BRING IN  H MATRICES
C
  110 FILE = MATNAM
      CALL OPEN (*132,MATNAM,CORE(IBUF1),0)
      CALL SKPREC (MATNAM,1)
      DO 130 I = 1,LHSET
      IPNT = IPNT + 1
      CALL INTPK (*120,MATNAM,0,1,0)
      CALL ZNTPKI
      IF (II.NE.I .OR. IEOL.NE.1) GO TO 180
      CORE(IPNT) = A(1)
      GO TO 130
C
C     NULL COLUMN
C
  120 CORE(IPNT) = 0.0
  130 CONTINUE
      CALL CLOSE (MATNAM,1)
  131 GO TO IRET, (30,40,50)
C
C     ZERO CORE FOR PURGED MATRIX
C
  132 DO 133 I = 1,LHSET
      IPNT = IPNT + 1
      CORE(IPNT) = 0.0
  133 CONTINUE
      GO TO 131
C
C     ERROR MESAGES
C
  150 CALL MESAGE (IP1,FILE,NAME)
  170 IP1 = -8
      GO TO  150
  180 IP1 = -7
      GO TO  150
      END

      SUBROUTINE ROD
C
C     ELEMENT TEMPERATURE AND DEFORMATION LOADING FOR THE ROD, CONROD,
C     TUBE
C
      INTEGER         ELTYPE,EID,GPIDA,GPIDB
      REAL            ARRY(3),GPIDA1(1),GPIDB1(1)
      COMMON /CONDAS/ PI,TWOPI,RADEG,DEGRA,S4PISQ
      COMMON /ZZZZZZ/ CORE(1)
      COMMON /TRIMEX/ EID, GPIDA, GPIDB, IARRY(97)
      COMMON /MATIN / MATID,INFLAG,TEMP,STRESS,SINTH,COSTH
      COMMON /MATOUT/ E1,G,NU,RHO,ALPHA,TO1,GE,SIGMAT,SIGMAC,SIGMAS,
     1                SPACE(10)
      COMMON /SSGWRK/ TI(16),VECT(3),FORCE(3),BGPDT(9),VMAG,IN,L,TBAR,
     1                DELTA,XL
      COMMON /SSGETT/ ELTYPE,OLDEL,EORFLG,ENDID,BUFFLG,ITEMP,IDEFT,IDEFM
      EQUIVALENCE     (IARRY(1),ARRY(1)),
     1                (ICSTMA,BGPDT(1)),(ICSTMB,BGPDT(5)),
     2                (GPIDA1(1),BGPDT(2)),(GPIDB1(1),BGPDT(6))
C
      NEPT = 5
      IF (ELTYPE .EQ. 3) NEPT = 4
      A = ARRY(2)
C
C     RECOMPUTE AREA IF ELEMENT IS TUBE
C
      IF (NEPT .EQ. 4) A = PI*(A-ARRY(3))*ARRY(3)
C
      DO 100 I = 1,9
      NEPT = NEPT + 1
  100 BGPDT(I) = ARRY(NEPT)
C
C     OBTAIN THE MATERIAL DATA
C
      INFLAG = 1
      MATID  = IARRY(1)
      TEMP   = BGPDT(9)
      CALL MAT (EID)
      IF (ITEMP) 240,250,240
  240 CALL SSGETD (EID,TI,0)
      TBAR = TI(1) - TO1
      GO TO 260
  250 TBAR = 0.0
  260 IF (IDEFT) 270,280,270
  270 CALL FEDT (EID,DELTA,IDEFM)
      GO TO 290
  280 DELTA = 0.0
  290 DO 310 I = 1,3
  310 VECT(I) = GPIDA1(I) - GPIDB1(I)
      CALL NORM (VECT(1),XL)
      VMAG = E1*A*(DELTA + ALPHA*XL*TBAR)/XL
      DO 320 I = 1,3
      VECT(I) = -VECT(I)*VMAG
  320 FORCE (I) = -VECT(I)
      IF (ICSTMB) 330,340,330
  330 CALL BASGLB (VECT(1),VECT(1),GPIDB1,ICSTMB)
  340 IN = GPIDB - 1
      DO 350 I = 1,3
      L  = IN + I
  350 CORE(L) = CORE(L) + VECT(I)
      IF (ICSTMA) 370,380,370
  370 CALL BASGLB (FORCE(1),FORCE(1),GPIDA1,ICSTMA)
  380 IN = GPIDA - 1
      DO 390 I = 1,3
      L  = IN + I
  390 CORE(L) = CORE(L) + FORCE(I)
      RETURN
      END

      SUBROUTINE TIMTST
C
C     TIMETEST   /,/ C,N,N / C,N,M / C,N,T / C,N,O1 / C,N,O2 $
C
      INTEGER         T,O1,O2
      CHARACTER       UFM*23,UWM*25
      COMMON /XMSSG / UFM,UWM
      COMMON /BLANK / N,M,T,O1,O2
      COMMON /SYSTEM/ ISYSBF, NOUT
C
      IF (O1.LT.1 .OR. O1.GT.2) GO TO 9901
      GO TO (100, 200), O1
C
  100 CONTINUE
      CALL TIMTS1
      GO TO 900
C
  200 CONTINUE
      CALL TIMTS2
C
  900 CONTINUE
      RETURN
C
C     ERROR MESSAGES
C
 9901 WRITE  (NOUT,9951) UWM
 9951 FORMAT (A25,' 2195, ILLEGAL VALUE FOR P4 =',I7)
C
      WRITE  (NOUT,9996)
 9996 FORMAT ('0*** MODULE TIMETEST TERMINAL ERROR.')
C
      RETURN
C
      END

      SUBROUTINE OSCXRF (IOP,AVAIL)
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        LSHIFT,RSHIFT,ANDF,ORF,COMPLF
      INTEGER         DBENT(3),BLOCK(6),LAB(6),IOUT(32),IHD1(32),
     1                IHD2(32),IHD3(32),IHD4(32),IHD5(32)
      COMMON /OUTPUT/ ITITL(96),IHEAD(96)
      COMMON /MODDMP/ IFLG(5)
      COMMON /SYSTEM/ KSYS(65)
      COMMON /LNKLST/ I,NVAIL,ISEQN,KIND,ITYPE,MASK3,MASK4,MASK5
      COMMON /ZZZZZZ/ Z(1)
      COMMON /XVPS  / VPS(3)
      EQUIVALENCE     (KSYS(2),OP), (KSYS(9),NLPP), (KSYS(12),NLINE)
      DATA    IHD1  / 7*4H    ,4HCOSM,4HIC /,4H NAS,4HTRAN,4H DMA,
     1                4HP CO  ,4HMPIL,4HER -,4H DMA,4HP CR,4HOSS ,
     2                4HREFE  ,4HRENC,4HE LI,4HSTIN,4HG   ,9*4H    /
      DATA    IHD2  / 32*4H     /
      DATA    IHD3  / 4HMODU,4HLE N,4HAME ,4HDMAP,4H STA,4HTEME,
     1                4HNT N,4HUMBE,4HRS  ,23*4H     /
      DATA    IHD4  / 4HDATA,4H BLO,4HCK  ,4HDMAP,4H STA,4HTEME,
     1                4HNT N,4HUMBE,4HRS  ,23*4H     /
      DATA    IHD5  / 4HPARA,4HMETE,4HR   ,4HTYPE,4H    ,4HDMAP,
     1                4H STA,4HTEME,4HNT N,4HUMBE,4HRS  ,21*4H     /
      DATA    LAB   / 4HI   ,4HR   ,4HBCD ,4HRDP ,4HCSP ,4HCDP     /
      DATA    POOL  / 4HPOOL  /
      DATA    NBLANK/ 4H      /    ,IOUT  /32*4H     /
      DATA    NASTK / 4H*     /    ,NOTAPP/4HN.A.    /
C
C     RESTRICT OPEN CORE DUE TO LIMITED FIELD SIZE FOR POINTERS
C
      NVAIL = AVAIL
      IF (NVAIL .GT. 16350) NVAIL = 16350
C
C     PROCESS VARAIABLE PARAMETER LIST
C
      MASK2 = LSHIFT(1,16) - 1
      MASK1 = ANDF(LSHIFT(1,20)-1,COMPLF(MASK2))
      MASK3 = LSHIFT(1,14) - 1
      MASK4 = LSHIFT(MASK3,14)
      MASK5 = COMPLF(ORF(MASK3,MASK4))
      NOSGN = COMPLF(LSHIFT(1,KSYS(40)-1))
C
      DO 14 I = 1,1600
   14 Z(I) = 0
      K = 3
      I = 1
      KIND  =-5
      NPARAM= 1
   20 ITYPE = ANDF(VPS(K+2),MASK1)
      ITYPE = RSHIFT(ITYPE,16)
      LEN   = ANDF(VPS(K+2),MASK2)
      CALL LINKUP (*999,VPS(K))
      K = K + LEN + 3
      IF (K .GT. VPS(2)) GO TO 30
      NPARAM = NPARAM + 1
      GO TO 20
C
C     PROCESS NAMES OF MODULES AND DATA BLOCKS
C
   30 PSEQ = 0
   40 CALL READ (*200,*998,POOL,BLOCK,6,0,Q)
      IAUTO = 0
      MI    = RSHIFT(BLOCK(3),16)
      ITYPE = ANDF(MASK2,BLOCK(3))
      ISEQN = ANDF(NOSGN,BLOCK(6))
      KIND  = 1
      IF (PSEQ.EQ.ISEQN .AND. (MI.EQ.3 .OR. MI.EQ.8)) IAUTO = 1
      IF (IAUTO .EQ. 1) KIND = 2
      PSEQ = ISEQN
      CALL LINKUP (*999,BLOCK(4))
      KIND = 3
      GO TO (50,50,70,90), ITYPE
C
C     PROCESS FUNCTIONAL MODULE IO SECTIONS
C
   50 IRLH = 0
   51 IRLH = IRLH + 1
      CALL READ (*998,*998,POOL,NDB,1,0,Q)
      DO 52 J = 1,NDB
      CALL READ (*998,*998,POOL,DBENT,3,0,Q)
      IF (DBENT(1) .EQ. 0) GO TO 52
      CALL LINKUP (*999,DBENT)
   52 CONTINUE
      KIND = 4
      IF (ITYPE.EQ.1 .AND. IRLH.EQ.1) GO TO 51
      KIND = 5
      CALL READ (*998,*998,POOL,NDB, -1,0,Q)
      CALL READ (*998,*998,POOL,NPARM,1,0,Q)
      IF (NPARM .EQ. 0) GO TO 80
      DO 65 J = 1,NPARM
      CALL READ (*998,*998,POOL,IL,1,0,Q)
      IF (IL) 60,55,55
   55 CALL READ (*998,*998,POOL,DBENT,-IL,0,Q)
      GO TO 65
   60 IL = ANDF(NOSGN,IL)
      CALL LINKUP (*999,VPS(IL-3))
   65 CONTINUE
      GO TO 80
   70 IF (MI .NE. 7) GO TO 80
      KIND = 5
      CALL READ (*998,*998,POOL,IL,1,0,Q)
      IL = ANDF(MASK2,IL)
      CALL LINKUP (*999,VPS(IL-3))
   80 CALL FWDREC (*998,POOL)
      GO TO 40
   90 MI = MI - 7
      IF (MI .LT. 0) MI = 4
      GO TO (100,120,170,120) ,MI
  100 CALL READ (*998,*998,POOL,NDB,1,0,Q)
      KIND = 5
      IF (IAUTO .EQ. 1) KIND = 6
      DO 110 J = 1,NDB
      CALL READ (*998,*998,POOL,DBENT,2,0,Q)
      IL = DBENT(1)
      CALL LINKUP (*999,VPS(IL-3))
  110 CONTINUE
      GO TO 80
  120 CALL READ (*998,*40,POOL,NDB,1,0,Q)
      KIND = 3
  130 DO 140 J = 1,NDB
      CALL READ (*998,*998,POOL,DBENT,2,0,Q)
      IF (DBENT(1) .EQ. 0) GO TO 140
      CALL LINKUP (*999,DBENT)
  140 CONTINUE
      IF (MI .EQ. 4) GO TO 80
      CALL READ (*998,*998,POOL,IL,1,0,Q)
      IF (IL) 160,160,150
  150 KIND = 5
      CALL LINKUP (*999,VPS(IL-3))
  160 IF (MI .EQ. 2) GO TO 120
  170 CALL READ (*998,*40,POOL,NDB,1,0,Q)
      KIND = 3
      CALL READ (*998,*998,POOL,DBENT,3,0,Q)
      IF (DBENT(1) .EQ. 0) GO TO 180
      CALL LINKUP (*999,DBENT)
  180 NDB = NDB - 1
      GO TO 130
C
C     SORT PARAMETER AND MODULE NAMES, 8-BCD WORD SORT
C
  200 NWDS = 4*NPARAM
      CALL SORTA8 (0,0,4,1,Z(1),NWDS)
      IST = NWDS + 1
      J   = I - 1 - NWDS
      CALL SORTA8 (0,0,4,1,Z(IST),J)
      NWDS = I - 1
C
C     TRAVERSE LINKED LISTS AND GENERATE OUTPUT
C
      K   = 1
      KDH = 0
      DO 260 J = 1,32
      IHEAD(J   ) = IHD1(J)
      IHEAD(J+32) = IHD2(J)
      IHEAD(J+64) = IHD5(J)
  260 CONTINUE
      CALL PAGE
      WRITE (OP,900)
      NLINE = NLINE + 1
C
C     PROCESS PARAMETER NAMES
C
  270 IOUT(2) = Z(K  )
      IOUT(3) = Z(K+1)
      NTYPE   = RSHIFT(Z(K+2),28)
      IOUT(4) = NBLANK
      IOUT(5) = LAB(NTYPE)
      IF (NTYPE.EQ.0 .OR. NTYPE.GT.6) IOUT(5) = NOTAPP
      IOUT(6) = NBLANK
C
C     TRACE THROUGH LINKED LIST
C
      II = 7
  280 LINK = ANDF(MASK3,Z(K+2))
  310 ISN  = ANDF(MASK3,Z(LINK))
      IF (KDH .EQ. 0) ISN = -ISN
      CALL OUTPAK (II,IOUT,ISN)
      ITEMP = RSHIFT(Z(LINK),28)
      IF (ITEMP.EQ.2 .OR. ITEMP.EQ.4 .OR. ITEMP.EQ.6) IOUT(II+1) = NASTK
      LINK = RSHIFT(ANDF(Z(LINK),MASK4),14)
      IF (LINK .EQ. 0) GO TO 320
      II = II + 2
      GO TO 310
C
C     PRINT OUTPUT
C
  320 NLINE = NLINE + 1
      IF (NLINE .LE. NLPP) GO TO 321
      CALL PAGE
      NLINE = NLINE + 1
      WRITE (OP,900)
      NLINE = NLINE + 1
  321 WRITE (OP,902) (IOUT(LL),LL=2,32)
      DO 325 LL = 2,32
      IOUT(LL) = NBLANK
  325 CONTINUE
  328 K = K + 4
      IF (K .GE. IST) GO TO 330
      IF (KDH .EQ. 1) GO TO 337
      IF (KDH .EQ. 2) GO TO 425
      GO TO 270
C
C     PROCESS MODULE NAMES
C
  330 IF (KDH .GT. 0) GO TO 340
      KDH = 1
      DO 335 J = 1,32
      IHEAD(J+64) = IHD3(J)
  335 CONTINUE
      WRITE (OP,910)
      CALL PAGE
      NLINE = NLINE + 1
      WRITE (OP,900)
      K   = IST
      IST = NWDS
  337 IF (RSHIFT(Z(K+3),28) .GE. 3) GO TO 328
  339 IOUT(2) = Z(K  )
      IOUT(3) = Z(K+1)
      IOUT(4) = NBLANK
      II = 5
      GO TO 280
C
C     PROCESS DATA BLOCKS
C
  340 IF (KDH .GT. 1) GO TO 430
      KDH = 2
      DO 420 J = 1,32
      IHEAD(J+64) = IHD4(J)
  420 CONTINUE
      WRITE (OP,905)
      CALL PAGE
      NLINE = NLINE + 1
      WRITE (OP,900)
      K   = 4*NPARAM + 1
      IST = NWDS
  425 IF (RSHIFT(Z(K+3),28) .GE. 3) GO TO 339
      GO TO 328
  430 WRITE (OP,906)
      CALL REWIND (POOL)
      CALL SKPFIL (POOL,IOP)
      CALL FWDREC (*998,POOL)
      GO TO 1000
  998 CALL XGPIDG (59,0,0,0)
      GO TO 1000
  999 CALL XGPIDG (60,0,0,0)
 1000 RETURN
C
  900 FORMAT (1H )
  902 FORMAT (5X,31A4)
  905 FORMAT (//6X,'* DENOTES AUTOMATICALLY GENERATED INSTRUCTIONS',
     1        /8X,'STATEMENT NUMBER REFERS TO DMAP SEQUENCE NUMBER OF ',
     2        'PREVIOUS INSTRUCTION')
  906 FORMAT (//6X,'* DENOTES STATEMENTS IN WHICH THE DATA BLOCK ',
     1        'APPEARSRS AS OUTPUT.')
  910 FORMAT (//6X,'* DENOTES APPEARANCE OF PARAMETER IN AUTOMATICALLY',
     1        ' GENERATED SAVE INSTRUCTION')
      END

      SUBROUTINE STPLOT (PLTNUM)
C
      INTEGER         PLTNUM,DATE(3),IDTE(8),CHAR,PLOTER,PLTYPE,PLTAPE,
     1                EOF,CAMERA,BFRAMS
      REAL            SAVE(2,2)
      COMMON /XXPARM/ PBUFSZ,CAMERA,BFRAMS
      COMMON /SYSTEM/ KSYSTM(65)
      COMMON /CHAR94/ CHAR(60)
      COMMON /PLTDAT/ MODEL,PLOTER,REG(2,2),XYMAX(13),CHRSCL,SKPA1(3),
     1                CNTX,SKPA2(5),PLTYPE,PLTAPE,SKPA3,EOF
      EQUIVALENCE     (KSYSTM(15),DATE(1))
      DATA    IDTE  / 2*1H ,1H/, 2*1H , 1H/, 2*1H  /, LSTPLT, M / 0,0 /
C
      IF (PLTNUM .LT. 0) GO TO 150
C
C     SELECT THE PROPER CAMERA
C
      CALL SELCAM (CAMERA,PLTNUM,0)
C
C     GENERATE THE ID PLOT
C
      IF (PLOTER .NE. LSTPLT) CALL SKPFRM (1)
      LSTPLT = PLOTER
      CALL IDPLOT (ID)
      IF (ID .EQ. 0) GO TO 120
      CALL SELCAM (CAMERA,PLTNUM,0)
      CALL SKPFRM (1)
C
C     INSERT THE BLANK FRAMES ON FILM ONLY
C
  120 IF (CAMERA.EQ.2 .OR. IABS(PLTYPE).NE.1) GO TO 130
      IF (BFRAMS .EQ. 0) GO TO 130
      CALL SELCAM (1,0,1)
      CALL SKPFRM (MAX0(BFRAMS,1))
  130 CALL SELCAM (CAMERA,0,1)
C
C     TYPE THE PLOT NUMBER IN UPPER LEFT AND RIGHT CORNERS OF THE PLOT
C
      IF (PLTNUM .EQ. 0) GO TO 135
      DO 131 I  = 1,2
      SAVE(I,1) = REG(I,1)
      REG (I,1) = 0.
      SAVE(I,2) = REG(I,2)
      REG (I,2) = XYMAX(I)
  131 CONTINUE
      CALL TYPINT (0,0,0,0,0,-1)
      CALL TYPINT (REG(1,1)+CHRSCL,REG(2,2)-CHRSCL,+1,PLTNUM,0,0)
C
C     PRINT THE DATE
C
      IF (M .NE. 0) GO TO 1312
      DO 1311 N = 1,7,3
      M = M + 1
      I = DATE(M)/10 + 1
      J = DATE(M) - (I-1)*10 + 1
      IF (I .EQ. 1) I = 48
      IDTE(N  ) = CHAR(I)
 1311 IDTE(N+1) = CHAR(J)
C
 1312 CALL TIPE (8.*CNTX,REG(2,2)-CHRSCL,1,IDTE(1),8,0)
C
      CALL TYPINT (REG(1,2)-CHRSCL,REG(2,2)-CHRSCL,-1,PLTNUM,0,0)
      DO 132 I = 1,2
      REG(I,1) = SAVE(I,1)
      REG(I,2) = SAVE(I,2)
  132 CONTINUE
  135 CALL TYPINT (0,0,0,0,0,1)
      GO TO 200
C
C     TERMINATE A PLOT
C
  150 CALL SKPFRM (1)
      CALL TYPINT (0,0,0,0,0,1)
      IF (EOF .EQ. 0) CALL SEOF (PLTAPE)
      CALL SCLOSE (PLTAPE)
C
  200 RETURN
      END

      SUBROUTINE KPANEL (IARG)
C*****
C THIS ROUTINE COMPUTES THE  4  6 X 6 MATRICES K(NPVT,NPVT), K(NPVT,J1)
C K(NPVT,J2), K(NPVT,J3) FOR A SHEAR PANEL (IF IARG = 4) AND FOR A
C TWIST PANEL (IF IARG = 5)
C*****
C
C                 E C P T  F O R  B O T H  P A N E L S
C ECPT( 1)  -  IELID          ELEMENT ID. NO.
C ECPT( 2)  -  ISILNO(4)      SCALAR INDEX NUMBERS
C ECPT( 3)  -   ...                   ...
C ECPT( 4)  -   ...                   ...
C ECPT( 5)  -   ...                   ...
C ECPT( 6)  -  MATID          MATERIAL ID.
C ECPT( 7)  -  T              THICKNESS
C ECPT( 8)  -  FMU            NON-STRUCTURAL MASS
C ECPT( 9)  -  ICSID1         COOR. SYS. ID. FOR GRID POINT 1
C ECPT(10)  -  GP1(3)         BASIC COORDINATES FOR GRID POINT 1
C ECPT(11)  -   ...                      ...
C ECPT(12)  -   ...                      ...
C ECPT(13)  -  ICSID2         COOR. SYS. ID. FOR GRID POINT 2
C ECPT(14)  -  GP2(3)         BASIC COORDINATES FOR GRID POINT 2
C ECPT(15)  -   ...                      ...
C ECPT(16)  -   ...                      ...
C ECPT(17)  -  ICSID3         COOR. SYS. ID. FOR GRID POINT 3
C ECPT(18)  -  GP3(3)         BASIC COORDINATES FOR GRID POINT 3
C ECPT(19)  -   ...                      ...
C ECPT(20)  -   ...                      ...
C ECPT(21)  -  ICSID4         COOR. SYS. ID. FOR GRID POINT 4
C ECPT(22)  -  GP4(3)         BASIC COORDINATES FOR GRID POINT 4
C ECPT(23)  -   ...                      ...
C ECPT(24)  -   ...                      ...
C ECPT(25)  -  TEMPEL         ELEMENT TEMPERATURE
C
C
C
C
C
C
      DOUBLE PRECISION
     1                   DPCON              ,VLEFT(6)
     2,                  VRIGHT(6)          ,TI(9)
     3,                  KE(36)             ,DAMPC
     4,                  VD1                ,VD2
     5,                  VKN                ,VK
     6,                  V12                ,V41
     7,                  VP12               ,VI
     8,                  VJ                 ,AVEC
     9,                  SMALLU             ,SMALLV
     T,                  P                  ,X1
     1,                  X2                 ,X3
     2,                  X4                 ,Y1
     3,                  Y2                 ,Y3
     4,                  Y4                 ,VKL
     5,                  PA                 ,V12DK
     6,                  CEP1               ,CEP2
     7,                  EP                 ,TEMP
      DOUBLE PRECISION
     1                   YP                 ,XP
     2,                  SA                 ,XQ
     4,                  B                  ,XL
     5,                  A                  ,A2
     6,                  A3                 ,A4
     7,                  A5                 ,B2
     8,                  B3                 ,B4
     9,                  B5                 ,C
     T,                  C2                 ,C3
     1,                  C4                 ,C5
     2,                  D                  ,D2
     3,                  D3                 ,D4
     4,                  D5                 ,TERM1
     5,                  TERM2              ,TERM3
     6,                  TERM4              ,TERM5
     7,                  XL13               ,XL24
      DOUBLE PRECISION
     1                   VP12L              ,VJL
     2,                  Z                  ,TERM
     3,                  F                  ,E
     4,                  G                  ,NU
     5,                  T                  ,C23
     6,                  NUC
      REAL
     1                   NUSP
C
C
C
      INTEGER
     1                   OUTRW              ,CLSNRW
     2,                  CLSRW              ,EOR
     3,                  FROWIC             ,TNROWS
C
C
C
      DIMENSION
     1                   VD1(3)             ,VD2(3)
     2,                  VKN(3)             ,VK(3)
     3,                  V12(3)             ,V41(3)
     4,                  VP12(3)            ,VI(3)
     5,                  VJ(3)              ,AVEC(4)
     6,                  SMALLU(4)          ,SMALLV(4)
     7,                  P(4)               ,IECPT(100)
     8,                  ECPT(100)
C
C
C
      COMMON   /SYSTEM/
     1                   ISYS
C
C SMA1 I/O PARAMETERS
C
      COMMON   /SMA1IO/
     1                   IFCSTM             ,IFMPT
     2,                  IFDIT              ,IDUM1
     3,                  IFECPT             ,IGECPT
     4,                  IFGPCT             ,IGGPCT
     5,                  IFGEI              ,IGGEI
     6,                  IFKGG              ,IGKGG
     7,                  IF4GG              ,IG4GG
     8,                  IFGPST             ,IGGPST
     9,                  INRW               ,OUTRW
     T,                  CLSNRW             ,CLSRW
     1,                  NEOR               ,EOR
     2,                  MCBKGG(7)          ,MCB4GG(7)
C
C SMA1 VARIABLE CORE BOOKKEEPING PARAMETERS
C
      COMMON   /SMA1BK/
     1                   ICSTM              ,NCSTM
     2,                  IGPCT              ,NGPCT
     3,                  IPOINT             ,NPOINT
     4,                  I6X6K              ,N6X6K
     5,                  I6X64              ,N6X64
C
C SMA1 PROGRAM CONTROL PARAMETERS
C
      COMMON   /SMA1CL/
     1                   IOPT4              ,K4GGSW
     2,                  NPVT               ,LEFT
     3,                  FROWIC             ,LROWIC
     4,                  NROWSC             ,TNROWS
     5,                  JMAX               ,NLINKS
     6,                  LINK(10)           ,IDETCK
     7,                  DODET              ,NOGO
C
C ECPT COMMON BLOCK
C
      COMMON   /SMA1ET/
     1                   IELID              ,ISILNO(4)
     2,                  MATID              ,TSP
     3,                  FMU                ,ICSID1
     4,                  GP1(3)             ,ICSID2
     5,                  GP2(3)             ,ICSID3
     6,                  GP3(3)             ,ICSID4
     7,                  GP4(3)             ,TEMPEL
C
C SMA1 LOCAL VARIABLES
C
      COMMON   /SMA1DP/
     1                   KE                 ,TI
     2,                  VLEFT              ,VRIGHT
     3,                  DAMPC              ,DPCON
     4,                  VD1                ,VD2
     5,                  VKN                ,VK
     6,                  V12                ,V41
     7,                  VP12               ,VI
     8,                  VJ                 ,AVEC
     9,                  SMALLU             ,SMALLV
     T,                  P                  ,X1
     1,                  X2                 ,X3
     2,                  X4                 ,Y1
     3,                  Y2                 ,Y3
     4,                  Y4                 ,VKL
     5,                  PA                 ,V12DK
     6,                  CEP1               ,CEP2
     7,                  EP                 ,TEMP
      COMMON   /SMA1DP/
     1                   YP                 ,XP
     2,                  SA                 ,XQ
     4,                  B                  ,XL
     5,                  A                  ,A2
     6,                  A3                 ,A4
     7,                  A5                 ,B2
     8,                  B3                 ,B4
     9,                  B5                 ,C
     T,                  C2                 ,C3
     1,                  C4                 ,C5
     2,                  D                  ,D2
     3,                  D3                 ,D4
     4,                  D5                 ,TERM1
     5,                  TERM2              ,TERM3
     6,                  TERM4              ,TERM5
     7,                  XL13               ,XL24
      COMMON   /SMA1DP/
     1                   VP12L              ,VJL
     2,                  Z                  ,TERM
     3,                  F                  ,E
     4,                  G                  ,NU
     5,                  T                  ,C23
     6,                  NUC
C
C INPUT AND OUTPUT BLOCKS FOR SUBROUTINE MAT
C
      COMMON   /MATIN/
     1                   MATIDC             ,MATFLG
     2,                  ELTEMP             ,STRESS
     3,                  SINTH              ,COSTH
C
C
C
      COMMON   /MATOUT/
     1                   ESP                ,GSP
     2,                  NUSP               ,RHO
     3,                  ALPHA              ,TSUBO
     4,                  GSUBE              ,SIGT
     5,                  SIGC               ,SIGS
C
C
C
      EQUIVALENCE    ( IECPT(1), ECPT(1), IELID )
C
C CALL MAT TO GET MATERIAL PROPERTIES.
C
      MATIDC = MATID
      MATFLG = 1
      ELTEMP = TEMPEL
      CALL MAT (IECPT(1))
      DAMPC = G SUB E
C
C STORE ECPT AND MPT VARIABLES IN DOUBLE PRECISION LOCATIONS
C
      E    = ESP
      G    = GSP
      NU   = NUSP
      T    = TSP
      IF(T*G .EQ. 0.0) GO TO 250
      C23  = 2.0D0 / 3.0D0
      NUC  = 1.0D0 / (1.0D0 + NU)
C
C COMPUTE DIAGONAL VECTORS.
C
      DO 10 I=1,3
      VD1(I) = GP3(I) - GP1(I)
   10 VD2(I) = GP4(I) - GP2(I)
C
C COMPUTE THE NORMAL VECTOR VKN, NORMALIZE, AND COMPUTE THE PROJECTED
C AREA, PA
C
      VKN(1) = VD1(2)*VD2(3)-VD1(3)*VD2(2)
      VKN(2) = VD1(3)*VD2(1)-VD1(1)*VD2(3)
      VKN(3) = VD1(1)*VD2(2)-VD1(2)*VD2(1)
      VKL = DSQRT (VKN(1)**2  +  VKN(2)**2  +  VKN(3)**2  )
      IF (VKL .EQ. 0.0D0) GO TO 230
      VK(1) = VKN(1)/VKL
      VK(2) = VKN(2)/VKL
      VK(3) = VKN(3)/VKL
      PA = .5D0 * VKL
C
C COMPUTE  SIDES -12- AND -41-
C
      DO 20 I=1,3
      V12(I) = GP2(I) - GP1(I)
   20 V41(I) = GP1(I) - GP4(I)
C
C COMPUTE DOT PRODUCT, V12DK, OF V12 AND VK, THE VECTORS VP12, VI, VJ
C
      V12DK = V12(1)*VK(1)+V12(2)*VK(2)+V12(3)*VK(3)
      VP12(1) = V12(1)-V12DK*VK(1)
      VP12(2) = V12(2)-V12DK*VK(2)
      VP12(3) = V12(3)-V12DK*VK(3)
      VP12L = DSQRT (VP12(1)**2  +  VP12(2)**2  +  VP12(3)**2 )
      IF (VP12L .EQ. 0.0D0) GO TO 240
      VI(1) = VP12(1)/VP12L
      VI(2) = VP12(2)/VP12L
      VI(3) = VP12(3)/VP12L
      VJ(1) = VK(2)*VI(3)-VK(3)*VI(2)
      VJ(2) = VK(3)*VI(1)-VK(1)*VI(3)
      VJ(3) = VK(1)*VI(2)-VK(2)*VI(1)
C
C NORMALIZE J FOR GOOD MEASURE
C
      VJL = DSQRT (VJ(1)**2  + VJ(2)**2  +  VJ(3)**2 )
      IF (VJL .EQ. 0.0D0) GO TO 250
      VJ(1) = VJ(1) / VJL
      VJ(2) = VJ(2) / VJL
      VJ(3) = VJ(3) / VJL
      X1 = 0.0D0
      Y1 = 0.0D0
      X2 = VP12L
      Y2 = 0.0D0
      X3 = VI(1) * VD1(1)  +  VI(2) * VD1(2)  +  VI(3) * VD1(3)
      Y3 = VJ(1) * VD1(1)  +  VJ(2) * VD1(2)  +  VJ(3) * VD1(3)
      X4 =-VI(1) * V41(1)  -  VI(2) * V41(2)  -  VI(3) * V41(3)
      Y4 =-VJ(1) * V41(1)  -  VJ(2) * V41(2)  -  VJ(3) * V41(3)
C
C CHECK TO SEE IF INTERIOR ANGLES ARE LESS THAN 180 DEGREES.  IF NOT,
C CALL FATAL ERROR MESSAGE.
C
      IF (Y3 .LE. 0.0D0) GO TO 260
      IF(Y4 .LE. 0.0D0) GO TO 280
      IF(X3 .LE. Y3*X4/Y4) GO TO 270
      IF (X4 .GE. X2 - (X2-X3)*Y4/Y3) GO TO 290
C
C TEST FOR PARALLEL EFFECTS.
C
      TEMP = X3 - X2
      EP=1.0D-1
      IF (DABS(Y3-Y4).LT.DABS(X3-X4)*EP) GO TO 30
      IF (DABS(Y4*TEMP-Y3*X4).LT.DABS(X4*TEMP+Y4*Y3)*EP) GO TO 40
      GO TO 70
   30 IF (DABS(Y4*TEMP-Y3*X4).LT.DABS(X4*TEMP+Y4*Y3)*EP) GO TO 50
C
C AT THIS POINT THE LINE CONNECTING POINTS 3 AND 4 IS -PARALLEL- TO THE
C LINE CONNECTING POINTS 1 AND 2.
C
      TEMP = Y3*X4  -  Y4 * (X3-X2)
      YP   = X2*Y3*Y4 / TEMP
      P(1) = YP - Y1
      P(2) = YP - Y2
      P(3) = YP - Y3
      P(4) = YP - Y4
      XP   = X2*Y3*X4 / TEMP
      SA   =(X2 - XP) / YP
      C    =(X1 - XP) / YP
      Z   = ( (P(1)*P(2)*PA) / (P(3)*P(4)*2.0D0*G*T) ) *
     1        (1.0D0 + C23*NUC  * (SA**2 + SA*C + C**2) )
      GO TO 80
C
C AT THIS POINT THE LINE CONNECTING POINTS 1 AND 4 IS -PARALLEL- TO THE
C LINE CONNECTING POINTS 2 AND 3.
C
   40 D   = -.5D0 * (  X4/Y4  +  (X3-X2) / Y3  )
      XQ   = X4  - Y4  *  (X3-X4)/(Y3-Y4)
      TEMP = 1.0D0 / DSQRT (1.0D0 + D**2)
      P(1) = ( XQ - X1 - D*Y1) * TEMP
      P(2) = ( XQ - X2 - D*Y2) * TEMP
      P(3) = ( XQ - X3 - D*Y3) * TEMP
      P(4) = ( XQ - X4 - D*Y4) * TEMP
      TEMP =   XQ - X4
      B    =   (TEMP * D  +  Y4)  /  (TEMP  -  Y4*D)
      Z   = (  (P(1)*P(2)*PA) / (P(3)*P(4)*2.0D0*G*T)  ) *
     1      (1.0D0  +  C23*NUC* (B**2 + B*D + D**2)  )
      GO TO 80
C
C IN THIS CASE THE PANEL APPROXIMATES A PARALLELOGRAM.
C
   50 DO 60 I=1,4
   60 P(I) = 1.0D0
      D   = -.5D0 * (  X4/Y4  +  (X3-X2)/Y3  +  (Y3-Y4)/(X3-X4)  )
      Z   = PA / (2.0D0*G*T) * (1.0D0 + 2.0D0*D**2*NUC)
      GO TO 80
C
C IN THIS CASE NO PARALLEL EFFECTS EXIST.
C
   70 XQ   = X4  -  (X3-X4)/(Y3-Y4) * Y4
      TEMP = Y3*X4  -  Y4*(X3-X2)
      XP   = X2*Y3*X4 / TEMP
      YP   = X2*Y3*Y4 / TEMP
      XL   = DSQRT ( (XQ-XP)**2 + YP**2 )
      D    = (XQ-XP)/YP
      TEMP = YP/XL
      P(1) = TEMP * (XQ - X1 - D*Y1)
      P(2) = TEMP * (XQ - X2 - D*Y2)
      P(3) = TEMP * (XQ - X3 - D*Y3)
      P(4) = TEMP * (XQ - X4 - D*Y4)
      C    = XL/P(1) - D
      B    = XL/P(4) - C
      A    = XL/P(2) - D
      A2   = A**2
      B2   = B**2
      C2   = C**2
      D2   = D**2
      A3   = A2*A
      B3   = B2*B
      C3   = C2*C
      D3   = D2*D
      A4   = A3*A
      B4   = B3*B
      C4   = C3*C
      D4   = D3*D
      A5   = A4*A
      B5   = B4*B
      C5   = C4*C
      D5   = D4*D
      TEMP = .5D0 * P(1) * P(2) * P(3) * P(4) / XL**2
      TERM = A  +  B  +  C23*(A3+B3)  +  .2D0*(A5+B5)
      TERM1= C  +  D  +  C23*(C3+D3)  +  .2D0*(C5+D5)
      TERM2= B  +  C  +  C23*(B3+C3)  +  .2D0*(B5+C5)
      TERM3= D  +  A  +  C23*(D3+A3)  +  .2D0*(D5+A5)
      TERM =    TERM * DLOG( DABS (A+B) )
      TERM1=    TERM1* DLOG( DABS (C+D) )
      TERM2=    TERM2* DLOG( DABS (B+C) )
      TERM3=    TERM3* DLOG( DABS (D+A) )
      TERM4=   .1D0*( (A2-C2)*(B3-D3)  +  (B2-D2)*(A3-C3) )
      TERM5=   .2D0*( (A -C )*(B4-D4)  +  (B -D )*(A4-C4) )
      F    =  TEMP * (TERM + TERM1 - TERM2 - TERM3 + TERM4 - TERM5)
      Z  =  P(1)*P(2) / (P(3)*P(4)*2.0D0*G*T) * (PA + 4.0D0*NUC*
     1                                                  (F - C23*PA))
   80 XL13 = DSQRT (X3**2 + Y3**2)
      XL24 = DSQRT (  (X4-X2)**2  +  Y4**2  )
      SMALLU(1) = X3/XL13
      SMALLU(2) = (X4-X2)/XL24
      SMALLU(3) = SMALLU(1)
      SMALLU(4) = SMALLU(2)
      SMALLV(1) = Y3/XL13
      SMALLV(2) = Y4/XL24
      SMALLV(3) = SMALLV(1)
      SMALLV(4) = SMALLV(2)
      TEMP = X4 * Y3  -  X3 * Y4
      AVEC(1) = -.5D0 * X2 * Y4 * XL13 / TEMP
      AVEC(2) = .5D0 * X2 * Y3 * XL24 / (TEMP - X2 * (Y3-Y4) )
      AVEC(3) = - AVEC(1)
      AVEC(4) = - AVEC(2)
C
C IF IARG = 4, WE HAVE A SHEAR PANEL, AND IF IARG = 5, A TWIST PANEL.
C
      IF (IARG .EQ. 4) GO TO 100
C
C SINCE WE ARE DEALING WITH A TWIST PANEL STORE -SMALLV IN SMALLU AND
C SMALLU IN SMALLV.
C
      DO 90 I=1,4
      TEMP = SMALLU(I)
      SMALLU(I) = -SMALLV(I)
   90 SMALLV(I) = TEMP
C
C SEARCH THE LIST OF THE 4 SIL NOS. TO DETERMINE WHICH IS THE PIVOT
C
  100 DO 110 I=1,4
      IF (ISILNO(I) .NE. NPVT) GO TO 110
      IPVT = I
      GO TO 120
  110 CONTINUE
      CALL MESAGE (-30,34,IECPT(1))
C
C COMPUTE THE DOUBLE PRECISION CONSTANT DPCON
C
  120 IF (IARG .EQ. 5) GO TO 130
      DPCON = AVEC(IPVT) / (2.0D0 * Z)
      GO TO 140
  130 DPCON = AVEC(IPVT) * T**2 / (24.0D0 * Z)
C
C COMPUTE THE -VLEFT- VECTOR
C
  140 IVLBEG = 1
      VLEFT(1) = VI(1) * SMALLU(IPVT)  +  VJ(1) * SMALLV(IPVT)
      VLEFT(2) = VI(2) * SMALLU(IPVT)  +  VJ(2) * SMALLV(IPVT)
      VLEFT(3) = VI(3) * SMALLU(IPVT)  +  VJ(3) * SMALLV(IPVT)
      IF (IECPT(4*IPVT+5) .EQ. 0) GO TO 150
      CALL TRANSD (IECPT(4*IPVT+5),TI)
      IVLBEG = 4
      CALL GMMATD (TI,3,3,1, VLEFT(1),3,1,0, VLEFT(4) )
C
C ZERO OUT THE 6 X 6 MATRIX KE
C
  150 DO 160 I=1,36
  160 KE(I) = 0.0D0
C
C COMPUTE THE 6 X 6 -S
C
      DO 220 J=1,4
      IVRBEG = 1
      VRIGHT(1) = SMALLU(J) * VI(1)  +  SMALLV(J) * VJ(1)
      VRIGHT(2) = SMALLU(J) * VI(2)  +  SMALLV(J) * VJ(2)
      VRIGHT(3) = SMALLU(J) * VI(3)  +  SMALLV(J) * VJ(3)
      IF (IECPT(4*J+5) .EQ. 0) GO TO 170
      CALL TRANSD (IECPT(4*J+5),TI)
      CALL GMMATD (VRIGHT(1),1,3,0, TI,3,3,0, VRIGHT(4) )
      IVRBEG = 4
  170 CALL GMMATD (VLEFT(IVLBEG),3,1,0, VRIGHT(IVRBEG),1,3,0, KE(1) )
      DO 180 K=1,9
  180 KE(K) = DPCON * KE(K) * AVEC(J)
      IF (IARG . EQ. 5) GO TO 190
      KE(13) = KE(7)
      KE(14) = KE(8)
      KE(15) = KE(9)
      KE( 7) = KE(4)
      KE( 8) = KE(5)
      KE( 9) = KE(6)
      KE( 4) = 0.0D0
      KE( 5) = 0.0D0
      KE( 6) = 0.0D0
      GO TO 210
  190 KE(22) = KE(1)
      KE(23) = KE(2)
      KE(24) = KE(3)
      KE(28) = KE(4)
      KE(29) = KE(5)
      KE(30) = KE(6)
      KE(34) = KE(7)
      KE(35) = KE(8)
      KE(36) = KE(9)
      DO 200 II=1,9
  200 KE(II) = 0.0D0
  210 CALL SMA1B (KE,IECPT(J+1),-1,IFKGG,0.0D0)
      IF (IOPT4 .EQ. 0  .OR.  G SUB E .EQ. 0.0) GO TO 220
      K4GGSW = 1
      CALL SMA1B (KE,IECPT(J+1),-1,IF4GG,DAMPC)
  220 CONTINUE
      RETURN
  230 CONTINUE
  240 CONTINUE
  250 CALL MESAGE(30,26,IECPT(1))
C
C  SET FLAG FOR FATAL ERROR WHILE ALLOWING ERROR MESSAGES TO ACCUMULATE
C
      NOGO=1
      RETURN
  260 IECPT(2) = 2
      GO TO 300
  270 IECPT(2) = 4
      GO TO 300
  280 IECPT(2) = 1
      GO TO 300
  290 IECPT(2) = 3
  300 CALL MESAGE(30,27,IECPT(1))
C
C  SET FLAG FOR FATAL ERROR WHILE ALLOWING ERROR MESSAGES TO ACCUMULATE
C
      NOGO=1
      RETURN
      END

      SUBROUTINE PLOAD3
C
C     COMPUTES THE CONTRIBUTION TO THE LOAD VECTOR DUE TO PRESSURES
C     APPLIED TO THE FACES OF ISOPARAMETRIC SOLID ELEMENTS
C
      INTEGER     GP(32)     ,SEQ(32)    ,FACE       ,SGNCOL(6)  ,
     1            COL        ,TYPE       ,CID(32)    ,N(3)       ,
     2            IBGPD(4)
C
      DOUBLE PRECISION  SHP(32)    ,DSHP(3,32) ,JINV(3,3)  ,DETJ
     1,     S(3,2)     ,ABSISA     ,PFACT      ,F(3,32)
C
      REAL  BXYZ(3,32) ,BGPD(4)    ,P(6)       ,RF(3,32)
C
      COMMON /LOADX /         LCORE      ,SLT        ,BGPDT      ,
     1                        OLD
      COMMON /ZZZZZZ/         CORE(1)
C
      EQUIVALENCE (BGPD(1),IBGPD(1),DSHP(1,1))
      EQUIVALENCE (SEQ(1),SHP(1))
      EQUIVALENCE (N(1),NI)  ,(N(2),NJ)  ,(N(3),NK)
      EQUIVALENCE (F(1,1),RF(1,1))
C
      DATA ABSISA/0.577350269189626D0/
      DATA SGNCOL/-3,-2,1,2,-1,3/
C
C     READ PRESSURES AND GRID POINT ID S FROM THE SLT, DETERMINE
C     ELEMENT TYPE AND NUMBER OF GRID POINTS AND GET BASIC COORDINATES.
C
      CALL READ(*500,*500,SLT,P,6,0,I)
      CALL READ(*500,*500,SLT,GP,32,0,I)
      TYPE=1
      NGP=8
      IF (GP(9) .EQ. 0) GO TO 10
      TYPE=2
      NGP=20
      IF (GP(21) .EQ. 0) GO TO 10
      TYPE=3
      NGP=32
   10 CALL PERMUT(GP,SEQ,NGP,OLD)
      DO 30 I=1,NGP
      J=SEQ(I)
      CALL FNDPNT(BGPD,GP(J))
      CID(J)=IBGPD(1)
      DO 20 K=1,3
      F(K,I)=0.0
      BXYZ(K,J)=BGPD(K+1)
   20 CONTINUE
   30 CONTINUE
C
C     LOOP OVER SIX ELEMENT FACES
C
      DO 300 FACE=1,6
      IF (P(FACE) .EQ. 0.0) GO TO 300
      J=1
      I=ISIGN(J,SGNCOL(FACE))
      SGN=FLOAT(I)
      COL=IABS(SGNCOL(FACE))
      DO 50 I=1,3
      IF (I .NE. COL) GO TO 40
      S(I,1)=SGN
      N(I)=1
      GO TO 50
   40 S(I,1)=-ABSISA
      S(I,2)= ABSISA
      N(I)=2
   50 CONTINUE
C
C     INTEGRATION LOOPS
C
      DO 200 I=1,NI
      DO 200 J=1,NJ
      DO 200 K=1,NK
C
C     GENERATE SHAPE FUNCTIONS AND JACOBIAN MATRIX INVERSE.
C
      CALL IHEXSD(TYPE,SHP,DSHP,JINV,DETJ,0,S(1,I),S(2,J),S(3,K),BXYZ)
      IF (DETJ .EQ. 0.0) CALL MESAGE(-61,0,0)
      PFACT=DETJ*DBLE(SGN*P(FACE))
C
C     LOOP OVER GRID POINTS
C
      DO 100 L=1,NGP
      IF (SHP(L) .EQ. 0.0) GO TO 100
      DO 60 M=1,3
   60 F(M,L)=PFACT*JINV(M,COL)*SHP(L)+F(M,L)
  100 CONTINUE
  200 CONTINUE
  300 CONTINUE
      J=3*NGP
      DO 305 I=1,J
  305 RF(I,1)=F(I,1)
C
C     TRANSFORM VECTOR TO GLOBAL AND ADD TO GLOBAL LOAD VECTOR.
C
      DO 400 I=1,NGP
      IF (CID(I) .EQ. 0) GO TO 310
      CALL BASGLB(RF(1,I),RF(1,I),BXYZ(1,I),CID(I))
  310 CALL FNDSIL(GP(I))
      DO 320 J=1,3
      K=GP(I)+J-1
      CORE(K)=CORE(K)+RF(J,I)
  320 CONTINUE
  400 CONTINUE
      RETURN
  500 CALL MESAGE(-61,0,0)
      RETURN
      END

      SUBROUTINE EXFORT (RW,U,F,BUF,NWDS,PREC,DBUF)
C*****
C
C         *** IBM 360/370, VAX/780 VERSION ***
C
C     EXFORT PERFORMS FORTRAN FORMATTED IO FOR MODULE EXIO
C
C*****
      INTEGER          RW,U,F,BUF(NWDS),PREC,FP,FMT,FRMT(10)
      DOUBLE PRECISION DBUF(1)
      COMMON /BLANK /  X1(26),LBUF
      COMMON /EXIO2P/  NF,FP(5,1)
      COMMON /EXIO2F/  FMT(1)
C     COMMON /EXIO2X/  ==> /ZZEXO2/ UNIVAC ONLY
C
      DATA    LEOF  / 4H&EOF/
C
      IF (NWDS .LE. 0) RETURN
      IF (F    .LE. 0) GO TO 8
      IFMT = FP(1,F)-1
      DO 5 I = 1,10
    5 FRMT(I) = FMT(IFMT+I)
    8 GO TO (10,20,80,150), RW
   10 GO TO (30,50), PREC
   20 GO TO (40,60), PREC
C
C     READ -- SINGLE PRECISION
C
   30 READ (U,FRMT,ERR=35) BUF
   35 IF (BUF(1) .EQ. LEOF) GOTO 70
      RETURN
C
C     WRITE -- SINGLE PRECISION
C
   40 WRITE (U,FRMT,ERR=45) BUF
   45 RETURN
C
C     READ -- DOUBLE PRECISION
C
   50 N = NWDS/3
      READ (U,FRMT) (BUF(4*I-3),DBUF(2*I),I=1,N)
      RETURN
C
C     WRITE -- DOUBLE PRECISION
C
   60 N = NWDS/3
      WRITE (U,FRMT) (BUF(4*I-3),DBUF(2*I),I=1,N)
      RETURN
C
C     END OF FILE
C
   70 BUF(3) = -1
      RETURN
C
C     POSITION THE FILE
C
   80 GO TO (90,100,100), NWDS
   90 REWIND U
      RETURN
  100 N = LBUF/33+1
      DO 110 I = 1,N
  110 BACKSPACE U
  120 READ (U,160) N
      IF (N .NE. LEOF) GO TO 120
      BACKSPACE U
      RETURN
C
C     WRITE LOGICAL EOF
C
  150 N = LBUF/33
      DO 170 I = 1,N
      WRITE  (U,160) LEOF
  160 FORMAT (A4,128X)
  170 CONTINUE
      RETURN
      END

      SUBROUTINE SPANL1(IARG)
C*****
C THIS ROUTINE COMPUTES PHASE I PARAMETERS FOR STRESS DATA RECOVERY FOR
C THE SHEAR PANEL (IF IARG = 4) AND THE TWIST PANEL (IF IARG = 5).
C MUCH OF THE CODE WAS LIFTED FROM SUBROUTIVE KPANEL
C*****
C
C                 E C P T  F O R  B O T H  P A N E L S
C ECPT( 1)  -  IELID          ELEMENT ID. NO.
C ECPT( 2)  -  ISILNO(4)      SCALAR INDEX NUMBERS
C ECPT( 3)  -   ...                   ...
C ECPT( 4)  -   ...                   ...
C ECPT( 5)  -   ...                   ...
C ECPT( 6)  -  MATID          MATERIAL ID.
C ECPT( 7)  -  T              THICKNESS
C ECPT( 8)  -  FMU            NON-STRUCTURAL MASS
C ECPT( 9)  -  ICSID1         COOR. SYS. ID. FOR GRID POINT 1
C ECPT(10)  -  GP1(3)         BASIC COORDINATES FOR GRID POINT 1
C ECPT(11)  -   ...                      ...
C ECPT(12)  -   ...                      ...
C ECPT(13)  -  ICSID2         COOR. SYS. ID. FOR GRID POINT 2
C ECPT(14)  -  GP2(3)         BASIC COORDINATES FOR GRID POINT 2
C ECPT(15)  -   ...                      ...
C ECPT(16)  -   ...                      ...
C ECPT(17)  -  ICSID3         COOR. SYS. ID. FOR GRID POINT 3
C ECPT(18)  -  GP3(3)         BASIC COORDINATES FOR GRID POINT 3
C ECPT(19)  -   ...                      ...
C ECPT(20)  -   ...                      ...
C ECPT(21)  -  ICSID4         COOR. SYS. ID. FOR GRID POINT 4
C ECPT(22)  -  GP4(3)         BASIC COORDINATES FOR GRID POINT 4
C ECPT(23)  -   ...                      ...
C ECPT(24)  -   ...                      ...
C ECPT(25)  -  TEMPEL         ELEMENT TEMPERATURE
C
C
C
      REAL
     1                   NU
C
C
C
C
C
C
      DIMENSION
     1                   VD1(3)             ,VD2(3)
     2,                  VKN(3)             ,VK(3)
     3,                  V12(3)             ,V41(3)
     4,                  VP12(3)            ,VI(3)
     5,                  VJ(3)              ,AVEC(4)
     6,                  SMALLU(4)          ,SMALLV(4)
     7,                  P(4)               ,IECPT(100)
     8,                  ECPT(100)
     9,                  VLEFT(6)           ,TI(9)
C
C SDR2 PHASE I INPUT AND OUTPUT BLOCK
C
      COMMON   /SDR2X5/
     1                   IELID              ,ISILNO(4)
     2,                  MATID              ,T
     3,                  FMU                ,ICSID1
     4,                  GP1(3)             ,ICSID2
     5,                  GP2(3)             ,ICSID3
     6,                  GP3(3)             ,ICSID4
     7,                  GP4(3)             ,TEMPEL
     8,                  XXXXXX(75)
      COMMON   /SDR2X5/
     1                   JELID              ,JSILNO(4)
     2,                  S(3,4)             ,OUT(15)
     3,                  YYYYYY(93)
C
C SDR2 SCRATCH BLOCK
C
      COMMON   /SDR2X6/
     1                   VLEFT              ,TI
     2,                  SPCON
     4,                  VD1                ,VD2
     5,                  VKN                ,VK
     6,                  V12                ,V41
     7,                  VP12               ,VI
     8,                  VJ                 ,AVEC
     9,                  SMALLU             ,SMALLV
     T,                  P                  ,X1
     1,                  X2                 ,X3
     2,                  X4                 ,Y1
     3,                  Y2                 ,Y3
     4,                  Y4                 ,VKL
     5,                  PA                 ,V12DK
     6,                  CEP1               ,CEP2
     7,                  EP                 ,TEMP
      COMMON   /SDR2X6/
     1                   YP                 ,XP
     2,                  SA                 ,XQ
     4,                  B                  ,XL
     5,                  A                  ,A2
     6,                  A3                 ,A4
     7,                  A5                 ,B2
     8,                  B3                 ,B4
     9,                  B5                 ,C
     T,                  C2                 ,C3
     1,                  C4                 ,C5
     2,                  D                  ,D2
     3,                  D3                 ,D4
     4,                  D5                 ,TERM1
     5,                  TERM2              ,TERM3
     6,                  TERM4              ,TERM5
     7,                  XL13               ,XL24
C
C INPUT AND OUTPUT BLOCKS FOR SUBROUTINE MAT
C
      COMMON   /MATIN/
     1                   MATIDC             ,MATFLG
     2,                  ELTEMP             ,STRESS
     3,                  SINTH              ,COSTH
C
C
C
      COMMON   /MATOUT/
     1                   E                  ,G
     2,                  NU                 ,RHO
     3,                  ALPHA              ,TSUBO
     4,                  GSUBE              ,SIGT
     5,                  SIGC               ,SIGS
C
C
C
      EQUIVALENCE
     1                   (IELID,IECPT(1),ECPT(1))
C
C CALL MAT TO GET MATERIAL PROPERTIES.
C
      MATIDC = MATID
      MATFLG = 1
      ELTEMP = TEMPEL
      CALL MAT (IECPT(1))
C
C COMPUTE DIAGONAL VECTORS.
C
      DO 10 I=1,3
      VD1(I) = GP3(I) - GP1(I)
   10 VD2(I) = GP4(I) - GP2(I)
C
C COMPUTE THE NORMAL VECTOR VKN, NORMALIZE, AND COMPUTE THE PROJECTED
C AREA, PA
C
      VKN(1) = VD1(2)*VD2(3)-VD1(3)*VD2(2)
      VKN(2) = VD1(3)*VD2(1)-VD1(1)*VD2(3)
      VKN(3) = VD1(1)*VD2(2)-VD1(2)*VD2(1)
      VKL = SQRT(VKN(1)**2+VKN(2)**2+VKN(3)**2)
      IF (VKL .EQ. 0.0) GO TO 160
      VK(1) = VKN(1)/VKL
      VK(2) = VKN(2)/VKL
      VK(3) = VKN(3)/VKL
      PA = .5 * VKL
C
C COMPUTE  SIDES -12- AND -41-
C
      DO 20 I=1,3
      V12(I) = GP2(I) - GP1(I)
   20 V41(I) = GP1(I) - GP4(I)
C
C COMPUTE DOT PRODUCT, V12DK, OF V12 AND VK, THE VECTORS VP12, VI, VJ
C
      V12DK = V12(1)*VK(1)+V12(2)*VK(2)+V12(3)*VK(3)
      VP12(1) = V12(1)-V12DK*VK(1)
      VP12(2) = V12(2)-V12DK*VK(2)
      VP12(3) = V12(3)-V12DK*VK(3)
      VP12L = SQRT(VP12(1)**2+VP12(2)**2+VP12(3)**2)
      IF (VP12L .EQ. 0.0) GO TO 170
      VI(1) = VP12(1)/VP12L
      VI(2) = VP12(2)/VP12L
      VI(3) = VP12(3)/VP12L
      VJ(1) = VK(2)*VI(3)-VK(3)*VI(2)
      VJ(2) = VK(3)*VI(1)-VK(1)*VI(3)
      VJ(3) = VK(1)*VI(2)-VK(2)*VI(1)
C
C NORMALIZE J FOR GOOD MEASURE
C
      VJL = SQRT (VJ(1)**2  +  VJ(2)**2  +  VJ(3)**2)
      IF (VJL .EQ. 0.0) GO TO 180
      VJ(1) = VJ(1) / VJL
      VJ(2) = VJ(2) / VJL
      VJ(3) = VJ(3) / VJL
      X1 = 0.0
      Y1 = 0.0
      X2 = VP12L
      Y2 = 0.0
      X3 = VI(1) * VD1(1)  +  VI(2) * VD1(2)  +  VI(3) * VD1(3)
      Y3 = VJ(1) * VD1(1)  +  VJ(2) * VD1(2)  +  VJ(3) * VD1(3)
      X4 =-VI(1) * V41(1)  -  VI(2) * V41(2)  -  VI(3) * V41(3)
      Y4 =-VJ(1) * V41(1)  -  VJ(2) * V41(2)  -  VJ(3) * V41(3)
C
C CHECK TO SEE IF INTERIOR ANGLES ARE LESS THAN 180 DEGREES.  IF NOT,
C CALL FATAL ERROR MESSAGE.
C
      IF (Y3 .LE. 0.0) GO TO 190
      IF (X3 .LE. Y3*X4/Y4) GO TO 200
      IF (Y4 .LE. 0.0) GO TO 210
      IF (X4 .GE. X2 - (X2-X3)*Y4/Y3) GO TO 220
C
C TEST FOR PARALLEL EFFECTS.
C
      TEMP = X3 - X2
      EP = 0.01
      IF (ABS(Y3-Y4).LT.ABS(X3-X4)*EP) GO TO 30
      IF (ABS(Y4*TEMP-Y3*X4).LT.ABS(X4*TEMP+Y4*Y3)*EP) GO TO 40
      GO TO 70
   30 IF (ABS(Y4*TEMP-Y3*X4).LT.ABS(X4*TEMP+Y4*Y3)*EP) GO TO 50
C
C AT THIS POINT THE LINE CONNECTING POINTS 3 AND 4 IS -PARALLEL- TO THE
C LINE CONNECTING POINTS 1 AND 2.
C
      TEMP = Y3*X4  -  Y4 * (X3-X2)
      YP   = X2*Y3*Y4 / TEMP
      P(1) = YP - Y1
      P(2) = YP - Y2
      P(3) = YP - Y3
      P(4) = YP - Y4
      XP   = X2*Y3*X4 / TEMP
      SA   =(X2 - XP) / YP
      C    =(X1 - XP) / YP
      Z    =(  (P(1)*P(2)*PA) / (P(3)*P(4)*2.0*G*T)  ) *
     1      (  1.0  +  2.0/(3.0 + 3.0*NU) * (SA**2 + SA*C + C**2)  )
      GO TO 80
C
C AT THIS POINT THE LINE CONNECTING POINTS 1 AND 4 IS -PARALLEL- TO THE
C LINE CONNECTING POINTS 2 AND 3.
C
   40 D    = -.5 * (  X4/Y4  +  (X3-X2)/Y3  )
      XQ   = X4  - Y4  *  (X3-X4)/(Y3-Y4)
      TEMP = 1.0 / SQRT (1.0 + D**2)
      P(1) = ( XQ - X1 - D*Y1) * TEMP
      P(2) = ( XQ - X2 - D*Y2) * TEMP
      P(3) = ( XQ - X3 - D*Y3) * TEMP
      P(4) = ( XQ - X4 - D*Y4) * TEMP
      TEMP =   XQ - X4
      B    =   (TEMP * D  +  Y4)  /  (TEMP  -  Y4*D)
      Z    =(  (P(1)*P(2)*PA) / (P(3)*P(4)*2.0*G*T)  ) *
     1      (  1.0  +  2.0/(3.0 + 3.0*NU) * (B**2 + B*D + D**2)  )
      GO TO 80
C
C IN THIS CASE THE PANEL APPROXIMATES A PARALLELOGRAM.
C
   50 DO 60 I=1,4
   60 P(I) = 1.0
      D    = -.5 * (  X4/Y4  +  (X3-X2)/Y3  +  (Y3-Y4)/(X3-X4)  )
      Z    = PA / (2.0*G*T) * (1.0 + 2.0*D**2/(1.0+NU))
      GO TO 80
C
C IN THIS CASE NO PARALLEL EFFECTS EXIST.
C
   70 XQ   = X4  -  (X3-X4)/(Y3-Y4) * Y4
      TEMP = Y3*X4  -  Y4*(X3-X2)
      XP   = X2*Y3*X4 / TEMP
      YP   = X2*Y3*Y4 / TEMP
      XL   = SQRT ( (XQ-XP)**2 + YP**2 )
      D    = (XQ-XP)/YP
      TEMP = YP/XL
      P(1) = TEMP * (XQ - X1 - D*Y1)
      P(2) = TEMP * (XQ - X2 - D*Y2)
      P(3) = TEMP * (XQ - X3 - D*Y3)
      P(4) = TEMP * (XQ - X4 - D*Y4)
      C    = XL/P(1) - D
      B    = XL/P(4) - C
      A    = XL/P(2) - D
      A2   = A**2
      B2   = B**2
      C2   = C**2
      D2   = D**2
      A3   = A2*A
      B3   = B2*B
      C3   = C2*C
      D3   = D2*D
      A4   = A3*A
      B4   = B3*B
      C4   = C3*C
      D4   = D3*D
      A5   = A4*A
      B5   = B4*B
      C5   = C4*C
      D5   = D4*D
      TEMP = .5 * P(1) * P(2) * P(3) * P(4) / XL**2
      TERM =    A  +  B  +  2.0*(A3+B3)/3.0  +  .2*(A5+B5)
      TERM1=    C  +  D  +  2.0*(C3+D3)/3.0  +  .2*(C5+D5)
      TERM2=    B  +  C  +  2.0*(B3+C3)/3.0  +  .2*(B5+C5)
      TERM3=    D  +  A  +  2.0*(D3+A3)/3.0  +  .2*(D5+A5)
      TERM =   TERM  * ALOG(ABS(A+B))
      TERM1=   TERM1 * ALOG(ABS(C+D))
      TERM2=   TERM2 * ALOG(ABS(B+C))
      TERM3=   TERM3 * ALOG(ABS(D+A))
      TERM4=  .1*( (A2-C2)*(B3-D3)  +  (B2-D2)*(A3-C3) )
      TERM5=  .2*( (A -C )*(B4-D4)  +  (B -D )*(A4-C4) )
      F    =  TEMP * (TERM + TERM1 - TERM2 - TERM3 + TERM4 - TERM5)
      Z    =  P(1)*P(2) / (P(3)*P(4)*2.0*G*T) * (PA + 4.0/(1.0+NU) *
     1                                               (F - 2.0*PA/3.0))
   80 XL13 =  SQRT (X3**2 + Y3**2)
      XL24 =  SQRT (  (X4-X2)**2  +  Y4**2  )
      SMALLU(1) = X3/XL13
      SMALLU(2) = (X4-X2)/XL24
      SMALLU(3) = SMALLU(1)
      SMALLU(4) = SMALLU(2)
      SMALLV(1) = Y3/XL13
      SMALLV(2) = Y4/XL24
      SMALLV(3) = SMALLV(1)
      SMALLV(4) = SMALLV(2)
      TEMP = X4 * Y3  -  X3 * Y4
      AVEC(1) = -.5 * X2 * Y4 * XL13 / TEMP
      AVEC(2) = .5 * X2 * Y3 * XL24 / (TEMP - X2 * (Y3-Y4) )
      AVEC(3) = - AVEC(1)
      AVEC(4) = - AVEC(2)
C
C IF IARG = 4, WE HAVE A SHEAR PANEL, AND IF IARG = 5, A TWIST PANEL.
C
      IF (IARG .EQ. 4) GO TO 100
C
C SINCE WE ARE DEALING WITH A TWIST PANEL STORE -SMALLV IN SMALLU AND
C SMALLU IN SMALLV.
C
      DO 90 I=1,4
      TEMP = SMALLU(I)
      SMALLU(I) = -SMALLV(I)
   90 SMALLV(I) = TEMP
C
C COMPUTE THE SINGLE PRECISION CONSTANT SPCON
C
  100 IF (IARG .EQ. 5) GO TO 110
      SPCON = -1.0/ (2.0 * Z * T)
      GO TO 120
  110 SPCON = -1.0/ (4.0 * Z)
C
C COMPUTE THE FOUR 1 X 3 MATRICES S
C
  120 DO 140 I=1,4
      IVLBEG = 1
      VLEFT(1) = SMALLU(I) * VI(1)  +  SMALLV(I) * VJ(1)
      VLEFT(2) = SMALLU(I) * VI(2)  +  SMALLV(I) * VJ(2)
      VLEFT(3) = SMALLU(I) * VI(3)  +  SMALLV(I) * VJ(3)
      IF (IECPT(4*I+5) .EQ. 0) GO TO 130
      IVLBEG = 4
      CALL TRANSS (IECPT(4*I+5),TI)
      CALL GMMATS (VLEFT(1),3,1,1, TI,3,3,0, VLEFT(4) )
  130 CONTINUE
      S(1,I) = SPCON * VLEFT(IVLBEG  ) * AVEC(I)
      S(2,I) = SPCON * VLEFT(IVLBEG+1) * AVEC(I)
      S(3,I) = SPCON * VLEFT(IVLBEG+2) * AVEC(I)
  140 CONTINUE
      OUT(1) = AVEC(1)
      OUT(2) = AVEC(2)
      OUT(3) = T
      OUT(4) = P(2) / P(1)
      OUT(5) = P(1) * P(2) / P(3)**2
      OUT(6) = P(1) * P(2) / P(4)**2
      OUT(7) = SIGS
      JELID = IELID
      DO 150 I=1,4
  150 JSILNO(I) = ISILNO(I)
      IF( IARG .NE. 4 ) RETURN
C*****
C  ADDITIONAL PHASE-1 OUTPUTS FOR SHEAR PANEL FORCES  IN PHASE 2
C*****
      OUT(8) = P(1) / P(3) *T
      OUT(9) = ( P(1)*P(2) ) / ( P(3)*P(4) ) * T
      OUT(10) = P(2) / P(4) * T
      OUT(11)= -V12DK / 2.0
      OUT(12)= X2 / 2.0
      OUT(13)= SQRT( (X3-X2)**2 + Y3**2 ) / 2.0
      OUT(14)= SQRT( (X4-X3)**2 + (Y4-Y3)**2 ) / 2.0
      OUT(15)= SQRT( X4**2 + Y4**2 ) / 2.0
      RETURN
  160 CONTINUE
  170 CONTINUE
  180 CALL MESAGE (-30,26,IECPT(1))
  190 IECPT(2) = 2
      GO TO 230
  200 IECPT(2) = 4
      GO TO 230
  210 IECPT(2) = 1
      GO TO 230
  220 IECPT(2) = 3
  230 CALL MESAGE (-30,27,IECPT(1))
      RETURN
      END

      SUBROUTINE MERGED (A11,A12,A21,A22,A,RP,CP,N1,N2)
C
      INTEGER         A11,A12,A21,A22,A,RP,CP,RULE,MCB(20),MCB1(20)
      COMMON /PARMEG/ MCBA(7),MCBA11(7),MCBA21(7),MCBA12(7),MCBA22(7),
     1                NX,RULE
      COMMON /ZZZZZZ/ IZ(1)
C
      IF (RP .NE. 0) GO TO 10
      MCB(1) = 0
      MCB(2) = 1
      MCB(3) = N1
      MCB(4) = 2
      MCB(5) = 1
      GO TO 20
C
   10 MCB(1) = RP
      CALL RDTRL (MCB)
   20 IF (CP .NE. 0) GO TO 30
      MCB1(1) = 0
      MCB1(2) = 1
      MCB1(3) = N2
      MCB1(4) = 2
      MCB1(5) = 1
      GO TO 40
C
   30 MCB1(1) = CP
      CALL RDTRL (MCB1)
   40 NX    = KORSZ (IZ)
      RULE  = 0
      IOTYP = 0
      MCBA11(1) = A11
      IF (A11 .EQ. 0) GO TO 50
      CALL RDTRL (MCBA11)
      IF (MCBA11(1) .LE. 0) MCBA11(1) = 0
C
   50 MCBA21(1) = A21
      IF (A21 .EQ. 0) GO TO 60
      CALL RDTRL (MCBA21)
      IF (MCBA21(1) .LE. 0) MCBA21(1) = 0
C
   60 MCBA12(1) = A12
      IF (A12 .EQ. 0) GO TO 70
      CALL RDTRL (MCBA12)
      IF (MCBA12(1) .LE. 0) MCBA12(1) = 0
C
   70 MCBA22(1) = A22
      IF (A22 .EQ. 0) GO TO 80
      CALL RDTRL (MCBA22)
      IF (MCBA22(1) .LE. 0) MCBA22(1) = 0
C
   80 MCBA(1) = A
      MCBA(2) = MCB(3)
      MCBA(3) = MCB1(3)
      DO 90 I = 1,28,7
      IF (MCBA11(I) .EQ. 0) GO TO 90
      IOTYP   = MAX0(IOTYP,MCBA11(I+4))
   90 CONTINUE
      MCBA(4) = 2
      MCBA(5) = IOTYP
      IF (MCBA(2) .EQ. MCBA(3)) MCBA(4) = 1
      CALL MERGE (MCB,MCB1,IZ)
      CALL WRTTRL (MCBA)
      RETURN
      END

      SUBROUTINE XRGDTB (LU)
C
C     XRGDTB PROCESSES THE CARD AND FILE NAME RESTART TABLES
C     THIS SUBROUTINE IS CALLED ONLY BY XRGDFM
C
C     WRITTEN BY  RPK CORPORATION; DECEMBER, 1983
C
C     INPUT
C       LU            FORTRAN UNIT NUMBER FOR THE RIGID FORMAT FILE
C     /SYSTEM/
C       OPTAPE        OUTPUT UNIT NUMBER FOR THE PRINT FILE
C     /XRGDXX/
C       ICHAR         ARRAY IN 80A1 FORMAT CONTAINING CARD IMAGE
C       ISCR          FILE NUMBER ON WHICH TABLES ARE WRITTEN
C       ITYPE         TYPE OF TABLE BEING PROCESSED-('CARD'OR'FILE')
C       LIMIT         LOWER/UPPER LIMITS FOR VALUES IN THE TABLE
C       RECORD        CARD IMAGE IN 20A4 FORMAT
C
C     OUTPUT
C     /XRGDXX/
C       ICOL          COLUMN WITHIN CARD BEING PROCESSED
C       ICOUNT        NUMBER OF ALPHA CHARACTERS WITHIN A NAME
C       IERROR        ERROR FLAG - NON-ZERO IF ERROR OCCURRED
C       NAME          NAME OF THE SUBROUTINE
C       NUMBER        VALUE OF NUMBER RETURNED BY XRGNUM
C
C     LOCAL VARIABLES
C       ASTRSK          CONTAINS THE VALUE 1H*
C       BLANK           CONTAINS THE VALUE 1H
C       COMENT          CONTAINS THE VALUE OF 4H$$$$
C       DOLLAR          CONTAINS THE VALUE OF 1H$
C       ICOLUM          COLUMN NUMBER OF THE NEXT CHARACTER WITHIN
C                       A NAME
C
C     FUNCTIONS
C       1. CALLS READ AND XDCODE FOR EACH CARD WITHIN THE TABLE.
C       2. CALLS XRGNUM TO PROCESS ALL NUMBERS
C       3. CALLS XECODE TO PROCESS ALL NAMES
C       4. ALL ENTRIES READ ARE EXPECTED TO BE IN THE FOLLOWING
C          FORMAT:    NNNN    NAME  NAME  NAME  NAME  NAME ...
C          WHERE NNNN IS ANY NUMBER.
C
C     SUBROUTINES CALLED - XRGNUM,XECODE,READ,WRITE
C
C     ERRORS  MESSAGES 8028,8034,8029,8036 MAY BE ISSUED
C
      INTEGER         RECORD, BLANK, DOLLAR, ASTRSK, OPTAPE, COMENT
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /SYSTEM/ KSYSTM(100)
      COMMON /XRGDXX/ IRESTR, NSUBST, IPHASE, ICOL  , NUMBER, ITYPE ,
     1                ISTATE, IERROR, NUM(2), IND   , NUMENT        ,
     2                RECORD(20)    , ICHAR(80)     , LIMIT(2)      ,
     3                ICOUNT, IDMAP , ISCR  , NAME(2), MEMBER(2)    ,
     4                IGNORE
      EQUIVALENCE     (KSYSTM( 2),OPTAPE), (KSYSTM(39), NBPC),
     1                (KSYSTM(40), NBPW ), (KSYSTM(41), NCPW)
      DATA    BLANK / 1H /,  DOLLAR / 1H$ /, ASTRSK / 1H* /
      DATA    COMENT/ 4H$$$$ /
C
 100  NUMBER  = 0
      NAME(1) = 0
      READ (LU,150,ERR=710,END=710) RECORD
 150  FORMAT (20A4)
      CALL XDCODE
      IF (RECORD(1) .EQ. COMENT) GO TO 100
      IF (ICHAR(1).EQ.DOLLAR .AND. ICHAR(2).EQ.ASTRSK) GO TO 800
      ICOL = 1
 200  IF (ICHAR(ICOL).EQ.BLANK .OR. ICOL.GT.80) GO TO 500
      IF (NUMBER .NE. 0) GO TO 300
      CALL XRGNUM
      IF (NUMBER .EQ. 0) GO TO 720
      IF (NUMBER.GE.LIMIT(1) .AND. NUMBER.LE.LIMIT(2)) GO TO 200
      GO TO 730
 300  ICOUNT = 1
 350  ICOLUM = ICOL + ICOUNT
      IF (ICHAR(ICOLUM).EQ.BLANK .OR. ICOLUM.GT.80) GO TO 400
      ICOUNT = ICOUNT + 1
      IF (ICOUNT .LE. 8) GO TO 350
      GO TO 740
 400  IF (ICOUNT .EQ. 0) GO TO 350
      CALL XECODE
      CALL WRITE (ISCR,NAME,2,0)
      CALL WRITE (ISCR,NUMBER,1,0)
      ICOL = ICOL + ICOUNT
      GO TO 200
 500  IF (ICOL .GE. 80) GO TO 600
      ICOL = ICOL + 1
      GO TO 200
 600  IF (NUMBER.EQ.0 .OR. NAME(1).EQ.0) GO TO 750
      GO TO 100
C
C     ERRORS
C
 710  WRITE  (OPTAPE,715) UFM,MEMBER
 715  FORMAT (A23,' 8027, UNEXPECTED EOF ENCOUNTERED ON FILE ',2A4,
     1        ' IN SUBROUTINE XRGDTB.')
      GO TO 770
 720  WRITE  (OPTAPE,725) UFM,RECORD
 725  FORMAT (A23,' 8028, EXPECTED TO FIND AN INTEGER IN THE FIRST ',
     1        'FIELD OF THE FOLLOWING CARD', //20X,20A4)
      GO TO 760
 730  WRITE  (OPTAPE,735) UFM,NUMBER,RECORD,LIMIT,ITYPE
 735  FORMAT (A23,' 8029, THE VALUE',I4,' GIVEN IN THE FIRST FIELD OF',
     1        ' THE FOLLOWING CARD', //20X,20A4, //5X,'IS OUTSIDE THE ',
     2        'RANGE OF',I5,1H-,I4,6H FOR ',A4,8H' CARDS.)
      GO TO 760
 740  WRITE  (OPTAPE,745) UFM,RECORD
 745  FORMAT (A23,' 8029, THE FOLLOWING CARD CONTAINS NAMES THAT ARE' ,
     2        'COMPRISED OF MORE THAN 8 CHARACTERS', //20X,20A4)
      GO TO 760
 750  WRITE  (OPTAPE,755) UFM,RECORD
 755  FORMAT (A23,' 8036, MISSING FIELDS ON THE FOLLOWING CARD', /20X,
     1        20A4)
 760  IERROR = 1
      GO TO 100
 770  IERROR = 1
 800  CALL WRITE (ISCR,0,0,1)
      RETURN
      END

      SUBROUTINE ROTAT (ECT2,B1,GPLST,X)
C
      INTEGER         GPLST(1),ECT2,B1,TYPES(13),ESYM,ELID,GPTS(12),
     1                BAR,OFFSET
      REAL            X(3,1),MAGTUD(2),NORMAL(3)
      DIMENSION       REC1(146),REC2(17),A(3,3),T(2,2),V(2,3),CROSS(3),
     1                SHEAR(3),ISYM(13)
      COMMON /BLANK / SKIP(23),OES1,SCR1,SCR2,NEWOES
      COMMON /XXPARM/ SKPPAR(211),ICASE,FLAG,DATA,SKPARM
      EQUIVALENCE     (REC1(3),ITYPE),(REC1(4),ISUB),(REC1( 5),TIME),
     1                (REC1(6),EIGEN),(REC1(10),NWDS)
      DATA    TYPES / 6,7,8,9,15,16,17,18,19,62,63,64,83 /
      DATA    ISYM  / 2HT1,2HTB,2HTP,2HTM,2HQP,2HQM,2HT2,2HQ2,2HQ1,2HM1,
     1                2HM2,2HQ4,2HT3/,    ESYM/2H  /,    BAR /2HBR/
C
      TWOPI = 8.0*ATAN(1.0)
      IRDECT= 0
      SUM   = 0.0
      CALL OPEN (*110,NEWOES,GPLST(B1),1)
      IREC  = 0
      ELID  = 0
   10 CALL READ (*110,*110,OES1,REC1,146,1,M)
      IF (ISUB .NE. ICASE) GO TO 13
      IF (FLAG .EQ.   0.0) GO TO 14
      IF (FLAG.EQ.1.0 .AND. TIME.EQ.DATA) GO TO 14
      FIGEN = SQRT(ABS(EIGEN))/TWOPI
      IF (FLAG.EQ.2.0 .AND. ABS(FIGEN-DATA).GT.1.0E-5) GO TO 14
   13 IF (IREC .EQ. 0) GO TO 18
      GO TO 100
C
C     CHECK ELEMENT TYPE
C
   14 IREC = IREC + 2
      DO 15 IT = 1,13
      IF (ITYPE .EQ. TYPES(IT)) GO TO 20
   15 CONTINUE
C
C     SKIP SUBCASE
C
   18 CALL FWDREC (*110,OES1)
      GO TO 10
C
C     CHECK ELEMENT TYPE
C
   20 IF (ELID .NE. 0) GO TO 21
      CALL READ (*22,*22,ECT2,ESYM,1,0,N)
      CALL FREAD (ECT2,NGPPE,1,0)
      IRDECT = 1
      OFFSET = 0
      IF (ESYM .EQ. BAR) OFFSET = 6
      IF (ESYM.EQ.ISYM(12) .OR. ESYM.EQ.ISYM(13)) OFFSET = 1
      IF (ESYM .EQ. ISYM(IT)) GO TO 23
   21 CALL FREAD (ECT2,ELID,1,0)
      IF (ELID .EQ. 0) GO TO 20
      J = 1 + NGPPE + OFFSET
      CALL FREAD (ECT2,0,-J,0)
      GO TO 21
   22 CALL BCKREC (ECT2)
      IRDECT = 0
      GO TO 18
C
C     PROCESS SUBCASE
C
   23 CALL WRITE (NEWOES,REC1,146,1)
      NWDS = NWDS - 1
   25 CALL READ  (*100,*56,OES1,IELMT,1,0,M)
      CALL FREAD (OES1,REC2,NWDS,0)
   30 CALL FREAD (ECT2,ELID,1,0)
      IF (ELID .EQ. 0) GO TO 55
      CALL FREAD (ECT2,0,-1,0)
      CALL FREAD (ECT2,GPTS,NGPPE,0)
      IF (OFFSET .NE. 0) CALL FREAD (ECT2,0,-OFFSET,0)
   29 IF (ELID .EQ. IELMT/10) GO TO 31
      IF (ELID .GT. IELMT/10) GO TO 60
      GO TO 30
   31 IG1 = GPTS(1)
      IG2 = GPTS(2)
      IG1 = IABS(GPLST(IG1))
      IG2 = IABS(GPLST(IG2))
      IG3 = GPTS(3)
      IG3 = IABS(GPLST(IG3))
      DO 32 I = 1,3
      V(1,I) = X(I,IG1) - X(I,IG2)
      V(2,I) = X(I,IG1) - X(I,IG3)
   32 CONTINUE
      MAGTUD(1) = SQRT(V(1,1)**2 + V(1,2)**2 + V(1,3)**2)
      MAGTUD(2) = SQRT(V(2,1)**2 + V(2,2)**2 + V(2,3)**2)
      DO 33 I = 1,3
      V(1,I) = V(1,I)/MAGTUD(1)
      V(2,I) = V(2,I)/MAGTUD(2)
      A(1,I) = V(1,I)
   33 CONTINUE
      A(2,1) = A(1,2)
      A(3,1) = A(1,3)
      A(3,3) =   V(1,1)*V(2,2) - V(2,1)*V(1,2)
      CROSS(1) = V(1,2)*V(2,3) - V(2,2)*V(1,3)
      CROSS(2) = V(2,1)*V(1,3) - V(1,1)*V(2,3)
      CROSS(3) = A(3,3)
      A(2,2) = CROSS(1)*V(1,3) - V(1,1)*CROSS(3)
      A(2,3) = V(1,1)*CROSS(2) - CROSS(1)*V(1,2)
      A(3,2) = A(2,3)
      IEL    = 0
      DO 40 MORE = 1,2
      IF (ITYPE.EQ.9 .OR. ITYPE.EQ.16) GO TO 34
      NORM   = IEL + 2
      ISHEAR = IEL + 4
      GO TO 35
   34 NORM   = IEL + 1
      ISHEAR = IEL + 3
   35 T(1,1) = REC2(NORM  )
      T(2,2) = REC2(NORM+1)
      T(1,2) = REC2(ISHEAR)
      T(2,1) = T(1,2)
      DO 38 I = 1,3
      SUM = 0.0
      DO 37 J = 1,2
      DO 37 K = 1,2
      SUM = SUM + A(I,J)*A(I,K)*T(J,K)
   37 CONTINUE
      NORMAL(I) = SUM
   38 CONTINUE
      SHEAR(1) = A(2,1)*A(1,1)*T(1,1) + A(2,1)*A(1,2)*T(1,2)
     1         + A(2,2)*A(1,2)*T(2,1) + A(2,2)*A(1,2)*T(2,2)
      SHEAR(2) = A(3,1)*A(1,1)*T(1,1) + A(3,1)*A(1,2)*T(1,2)
     1         + A(3,2)*A(1,2)*T(2,1) + A(3,2)*A(1,2)*T(2,2)
      SHEAR(3) = A(3,1)*A(2,1)*T(1,1) + A(3,1)*A(2,2)*T(1,2)
     1         + A(3,2)*A(2,1)*T(2,1) + A(3,2)*A(2,2)*T(2,2)
      DO 39 I = 1,3
      ISHEAR = ISHEAR + 1
      REC2(NORM  ) = NORMAL(I)
      REC2(ISHEAR) = SHEAR(I)
      NORM = NORM + 1
   39 CONTINUE
      IEL  = IEL + 8
      IF (ITYPE.EQ.9 .OR. ITYPE.EQ.16) GO TO 50
   40 CONTINUE
   50 CALL WRITE (NEWOES,IELMT,1,0)
      CALL WRITE (NEWOES,REC2,NWDS,0)
      GO TO 25
C
C     CLOSE RECORD
C
   55 CALL FREAD (OES1,0,0,1)
   56 CALL WRITE (NEWOES,0,0,1)
      GO TO 10
C
C     SKIP ELEMENT
C
   60 CALL READ  (*100,*56,OES1,IELMT,1,0,M)
      CALL FREAD (OES1,REC2,NWDS,0)
      GO TO 29
  100 CONTINUE
  110 IF (IRDECT .GT. 0) CALL BCKREC (ECT2)
      CALL BCKREC (OES1)
      CALL CLOSE  (NEWOES,1)
      RETURN
      END

      SUBROUTINE BSEQGP (NORIG,ILD,JUMP)
C
      EXTERNAL        ORF
      INTEGER         GEOM1,    GEOM2,    SEQGP(3), EOF(3),   SUB(2),
     1                TWO,      ORF,      OBW,      OP,       RD,
     2                RDREW,    WRT,      WRTREW,   REW,      GRID(8),
     3                Z
      DIMENSION       NORIG(2), ILD(1),   ISYS(100)
      COMMON /BANDA / IBUF1,    DUM2A(2), NOPCH,    DUM1A,    METHOD,
     1                ICRIT,    NGPTS,    NSPTS
      COMMON /BANDB / NBIT,     KORE,     DUM1B,    NGRD
      COMMON /BANDD / OBW,      NBW,      OP,       NP,       NCM,
     1                NZERO,    NEL,      NEQ,      NEQR
      COMMON /BANDS / NN,       MM,       DUM2(2),  NGRID,    DUM3(3),
     1                MINDEG,   NEDGE
      COMMON /BANDW / MAXW0,    RMS0,     MAXW1,    RMS1,     I77,
     1                BRMS0,    BRMS1
      COMMON /TWO   / TWO(1)
      COMMON /SYSTEM/ IBUF,     NOUT
      COMMON /NAMES / RD,       RDREW,    WRT,      WRTREW,   REW,
     1                NOREW
      COMMON /GEOMX / GEOM1,    GEOM2
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE     (IBUF,ISYS(1)),     (NLPP,ISYS(9)),
     1                (LPCH,ISYS(91)),    (IECHO,ISYS(19))
      DATA            SUB           ,  EOF    ,  SEQGP          /
     1                4HSSEQ, 4HGP  ,  3*2147483647,  5301, 53, 4    /
C
C     THIS ROUTINE IS USED ONLY IN BANDIT MODULE
C
C     NORIG(I) = ORIGINAL GRID POINT CORRESPONDING TO BANDIT INTERNAL
C                LABLE I
C     ILD(I)   = NEW RESEQUENCED LABEL CORRESPONDING TO BANDIT INTERNAL
C                LABLE I
C     NN       = NUMBER OF GRID POINTS
C     NGRD     .LT.0, INSUFF. WORKING CORE, OR SCRATCH ARRAY FOR BANDIT
C
      J77 = 0
      IF (NN.LE.0 .OR. NGRD.LT.0) GO TO 145
C
C     PRINT BANDIT SUMMARY.
C
      IF (NLPP.LE.48 .AND. METHOD.EQ.0) CALL PAGE1
      WRITE  (NOUT,10)
   10 FORMAT (//53X,22H*** BANDIT SUMMARY ***,/,
     1       /72X,6HBEFORE,5X,5HAFTER)
C
      WRITE  (NOUT,20) OBW,NBW,OP,NP,MAXW0,MAXW1
   20 FORMAT (40X,13HBANDWIDTH (B),15X,2I10,
     1       /40X,11HPROFILE (P), 17X,2I10,
     2       /40X,25HMAXIMUM WAVEFRONT (C-MAX),3X,2I10)
C
      ANN = FLOAT(NN)
      AV1 = FLOAT(OP)/ANN
      AV2 = FLOAT(NP)/ANN
      WRITE  (NOUT,30) AV1,AV2,RMS0,RMS1,BRMS0,BRMS1,NGPTS
   30 FORMAT (40X,25HAVERAGE WAVEFRONT (C-AVG),3X,2F10.3,
     1       /40X,21HRMS WAVEFRONT (C-RMS),7X,2F10.3,
     2       /40X,21HRMS BANDWITCH (B-RMS),7X,2F10.3,
     3       /40X,25HNUMBER OF GRID POINTS (N),15X,I8)
C
      IF (NSPTS .GT. 0) WRITE (NOUT,35) NSPTS
   35 FORMAT (40X,23HNUMBER OF SCALAR POINTS,17X,I8)
C
      WRITE  (NOUT,40) NEL,NEQR,NEQ
   40 FORMAT (40X,30HNUMBER OF ELEMENTS (NON-RIGID) ,10X,I8,
     1       /40X,35HNUMBER OF RIGID ELEMENTS PROCESSED*,5X,I8,
     2       /40X,35HNUMBER OF MPC  EQUATIONS PROCESSED*,5X,I8)
C
      WRITE  (NOUT,50) NCM,MM,MINDEG
   50 FORMAT (40X,20HNUMBER OF COMPONENTS,20X,I8,
     1       /40X,20HMAXIMUM NODAL DEGREE,20X,I8,
     2       /40X,20HMINIMUM NODAL DEGREE,20X,I8)
C
      NONZ = 2*NEDGE + NN
      AN   = NN*NN
      DEN  = FLOAT(NONZ)*100./AN
      WRITE  (NOUT,60) NEDGE,DEN,NZERO,KORE
   60 FORMAT (40X,22HNUMBER OF UNIQUE EDGES,18X,I8,
     1       /40X,23HMATRIX DENSITY, PERCENT, 16X,F9.3,
     2       /40X,31HNUMBER OF POINTS OF ZERO DEGREE,9X,I8,
     3       /40X,16HBANDIT OPEN CORE,24X,I8)
C
      IF (ICRIT .EQ. 1) WRITE (NOUT,61)
      IF (ICRIT .EQ. 2) WRITE (NOUT,62)
      IF (ICRIT .EQ. 3) WRITE (NOUT,63)
      IF (ICRIT .EQ. 4) WRITE (NOUT,64)
   61 FORMAT (40X,10HCRITERION*,25X,13HRMS WAVEFRONT)
   62 FORMAT (40X,10HCRITERION*,29X,9HBANDWIDTH)
   63 FORMAT (40X,10HCRITERION*,31X,7HPROFILE)
   64 FORMAT (40X,10HCRITERION*,25X,13HMAX WAVEFRONT)
C
      IF (METHOD .EQ. -1) WRITE (NOUT,66)
      IF (METHOD .EQ. +1) WRITE (NOUT,67)
      IF (METHOD .EQ.  0) WRITE (NOUT,68)
   66 FORMAT (40X,12HMETHOD USED*,34X,2HCM)
   67 FORMAT (40X,12HMETHOD USED*,33X,3HGPS)
   68 FORMAT (40X,12HMETHOD USED*,26X,10HCM AND GPS)
C
      IF (JUMP .EQ. 0) GO TO 90
      WRITE  (NOUT,75)
   75 FORMAT (/31X,'(* THESE DEFAULT OPTIONS CAN BE OVERRIDDEN BY THE',
     1       ' NASTRAN CARD)')
      WRITE  (NOUT,80)
   80 FORMAT (//31X,'BANDIT FINDS GRID POINT RE-SEQUENCING NOT ',
     1       'NECESSARY')
      GO TO 142
C
C     GENERATE SEQGP ARRAY AND OUTPUT SEQGP CARDS
C
   90 J = 0
      DO 100 I = 1,NN
      Z(J+1) = NORIG(I)
      Z(J+2) = ILD(I)
  100 J = J + 2
      CALL SORT (0,0,2,1,Z(1),J)
C
C     CHECK AGAINST ORIGINAL GRID POINT DATA, AND SEE ANY UNUSED GRIDS
C     (SUCH AS THE THIRD GRID ON CBAR CARD). IF THEY EXIST, BRING THEM
C     IN, AND RE-SORT TABLE.  (GEOM1 IS READY HERE, SEE BGRID)
C
      CALL OPEN (*160,GEOM1,Z(IBUF1),RD)
      NNX = NN
      IF (NN .EQ. NGRID) GO TO 106
      CALL READ (*104,*104,GEOM1,GRID,3,0,K)
  102 CALL READ (*104,*104,GEOM1,GRID,8,0,K)
      CALL BISLOC (*103,GRID(1),Z,2,NNX,K)
      GO TO 102
  103 NN = NN + 1
      Z(J+1) = GRID(1)
      Z(J+2) = NN
      J = J + 2
      GO TO 102
C
C     DO THE SAME CHECK IF SCALAR POINTS ARE PRESENT
C
  104 IF (NSPTS .EQ. 0) GO TO 1045
      NONZ = J + 2*NSPTS + 2
      CALL PRELOC (*1045,Z(NONZ),GEOM2)
      GRID(1) = 5551
      GRID(2) = 49
      CALL LOCATE (*1044,Z(NONZ),GRID,K)
 1042 CALL READ (*1044,*1044,GEOM2,I,1,0,K)
      CALL BISLOC (*1043,I,Z,2,NNX,K)
      GO TO 1042
 1043 NN = NN + 1
      Z(J+1) = I
      Z(J+2) = NN
      J = J + 2
      GO TO 1042
 1044 CALL CLOSE (GEOM2,REW)
 1045 I = NN - NNX
      IF (I .GT. 0) WRITE (NOUT,105) I
  105 FORMAT (40X,29HNO. OF NON-ACTIVE GRID POINTS,11X,I8)
  106 I = (J+7)/8
      WRITE  (NOUT,107) I
  107 FORMAT (40X,28HNO. OF SEQGP CARDS GENERATED,12X,I8)
      WRITE  (NOUT,75)
      IF (NOPCH .EQ. +9) GO TO 147
      IF (NNX   .NE. NN) CALL SORT (0,0,2,1,Z(1),J)
      IF (IECHO .EQ. -1) GO TO 125
      CALL PAGE1
      WRITE  (NOUT,110)
  110 FORMAT (//35X,52HS Y S T E M  G E N E R A T E D  S E Q G P  C A R
     1D S,/)
      WRITE  (NOUT,120) (Z(I),I=1,J)
  120 FORMAT (25X,8HSEQGP   ,8I8)
  121 FORMAT (    8HSEQGP   ,8I8)
  125 IF (NOPCH .LE. 0) GO TO 130
      WRITE (LPCH,121) (Z(I),I=1,J)
  127 J77 = -2
      GO TO 141
C
C     BEEF UP INTERNAL GRID NOS. BY 1000 AS REQUIRED BY NASTRAN
C
  130 DO 140 I = 2,J,2
  140 Z(I) = Z(I)*1000
C
C     REWIND AND SKIP FORWARDS TO THE END OF GEOM1 FILE.
C     OVERWRITE THE OLD SEQGP RECORD IF NECESSARY.
C     (WARNING - IF SEQGP IS NOT THE VERY LAST ITEM IN GEOM1 FILE, THE
C      FOLLOWING LOGIC OF INSERTING SEQGP CARDS NEEDS MODIFICATION -
C      BECAUSE GEOM1 IS IN ALPHA-NUMERIC SORTED ORDER).
C
      CALL REWIND (GEOM1)
      CALL SKPFIL (GEOM1,+1)
      CALL SKPFIL (GEOM1,-1)
      CALL BCKREC (GEOM1)
      CALL READ (*150,*150,GEOM1,NORIG(1),3,1,I)
      IF (NORIG(1).EQ.SEQGP(1) .AND. NORIG(2).EQ.SEQGP(2))
     1    CALL BCKREC (GEOM1)
      CALL CLOSE (GEOM1,NOREW)
C
C     ADD SEQGP CARDS TO THE END OF GEOM1 FILE
C     SET GEOM1 TRAILER, AND CLEAR /SYSTEM/ 76TH WORD
C
      CALL OPEN  (*160,GEOM1,Z(IBUF1),WRT)
      CALL WRITE (GEOM1,SEQGP(1),3,0)
      CALL WRITE (GEOM1,Z(1),J,1)
      CALL WRITE (GEOM1,EOF(1),3,1)
C
      Z(1) = GEOM1
      CALL RDTRL (Z(1))
      I = (SEQGP(2)+31)/16
      J = SEQGP(2)-I*16 + 48
      Z(I) = ORF(Z(I),TWO(J))
      CALL WRTTRL (Z(1))
  141 CALL CLOSE (GEOM1,REW)
  142 DO 143 I = 1,KORE
  143 Z(I) = 0
  145 ISYS(I77) = J77
      IF (NGRD .LT. 0) RETURN
      CALL PAGE2 (-2)
      WRITE  (NOUT,146)
  146 FORMAT (1H0,9X,45H**NO ERRORS FOUND - EXECUTE NASTRAN PROGRAM**)
      RETURN
C
C     SPECIAL PUNCH OPTION (BANDTPCH=+9)
C     TO PUNCH OUT EXTERNAL GRIDS IN RE-SEQUENCED INTERNAL ORDER
C
  147 CALL SORT (0,0,2,2,Z(1),J)
      WRITE  (NOUT,148) (Z(I),I=1,J,2)
  148 FORMAT (1H1,35X,59HLIST OF EXTERNAL GRID POINTS IN INTERNAL RE-SEQ
     1UENCED ORDER,/4X,31(4H----),/,(/5X,15I8))
      WRITE  (LPCH,149) (Z(I),I=1,J,2)
  149 FORMAT (10I7)
      GO TO 127
C
C     FILE ERROR
C
  150 K = -2
      GO TO 170
  160 K = -1
  170 CALL MESAGE (K,GEOM1,SUB)
      RETURN
      END

      SUBROUTINE MRED2B
C
C     THIS SUBROUTINE PERFORMS THE GUYAN REDUCTION ON THE STRUCTURE
C     POINTS FOR THE MRED2 MODULE.
C
C     INPUT DATA
C     GINO   - KII    - KII PARTITION MATRIX
C     SOF    - GIMS   - G TRANSFORMATION MATRIX FOR BOUNDARY POINTS OF
C                       ORIGINAL SUBSTRUCTURE
C
C     OUTPUT DATA
C     GINO   - LII    - LII PARTITION MATRIX
C     SOF    - LMTX   - LII PARTITION MATRIX
C              GIMS   - G TRANSFORMATION MATRIX FOR BOUNDARY POINTS OF
C                       ORIGINAL SUBSTRUCTURE
C
C     PARAMETERS
C     INPUT  - GBUF   - GINO BUFFER
C              ISCR   - SCRATCH FILE NUMBER ARRAY
C              KORLEN - LENGTH OF OPEN CORE
C              KORBGN - BEGINNING ADDRESS OF OPEN CORE
C              OLDNAM - NAME OF SUBSTRUCTURE BEGING REDUCED
C              BOUNDS - OLDBOUNDS OPTION FLAG
C              RSAVE  - DECOMPOSITION SAVE FLAG
C     OTHERS - KIB    - KIB PARTITION MATRIX FILE NUMBER
C              KII    - KII PARTITION MATRIX FILE NUMBER
C              LII    - LII PARTITION MATRIX FILE NUMBER (ISCR11)
C
      LOGICAL         BOUNDS,RSAVE
      INTEGER         DRY,SBUF1,SBUF2,SBUF3,OLDNAM,Z,POWER,CHLSKY,U,
     1                GIBT,PREC,SIGN,GIB,DBLKOR,DMR
      DOUBLE          PRECISION DETR,DETI,MINDIA,DZ
      DIMENSION       ITRLR(7),MODNAM(2),ITMLST(2),DZ(1)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25,SWM*27
      COMMON /XMSSG / UFM,UWM,UIM,SFM,SWM
      COMMON /BLANK / IDUM1,DRY,IDUM4(4),SBUF1,SBUF2,SBUF3,INFILE(12),
     1                IDUM6(6),ISCR(10),KORLEN,KORBGN,OLDNAM(2),
     2                IDUM2(8),BOUNDS,IDUM3,RSAVE,IDUM7(4),LSTZWD,ISCR11
      COMMON /ZZZZZZ/ Z(1)
      COMMON /SFACT / KIIT(7),LIIT(7),ISCRQ(7),ISCRA,ISCRB,NZSF,
     1                DETR,DETI,POWER,ISCRC,MINDIA,CHLSKY
      COMMON /FBSX  / LIIFBS(7),U(7),KIBT(7),GIBT(7),NZFBS,PREC,SIGN
      COMMON /SYSTEM/ IDUM5,IPRNTR
      EQUIVALENCE     (DMR,INFILE(11)),(GIB,ISCR(6)),(DZ(1),Z(1)),
     1                (KIB,ISCR(2)),(KII,ISCR(3)),(LII,ISCR11)
      DATA    MODNAM/ 4HMRED,4H2B  /
      DATA    LOWER / 4 /
      DATA    ITMLST/ 4HLMTX,4HGIMS/
C
C     TEST FOR GUYAN REDUCTION
C
      IF (DRY .EQ. -2) GO TO 140
      IF (.NOT.BOUNDS) GO TO 10
      ITRLR(1) = DMR
      CALL RDTRL (ITRLR)
      IF (ITRLR(1) .LT. 0) GO TO 35
      ITEM = ITMLST(1)
      CALL SOFTRL (OLDNAM,ITEM,ITRLR)
      IF (ITRLR(1) .EQ. 1) GO TO 35
C
C     DECOMPOSE INTERIOR STIFFNESS MATRIX
C
C                                 T
C        **   **   **   ** **   **
C        *     *   *     * *     *
C        * KII * = * LII * * LII *
C        *     *   *     * *     *
C        **   **   **   ** **   **
C
   10 CALL SOFCLS
      KIIT(1) = KII
      CALL RDTRL (KIIT)
      CALL MAKMCB (LIIT,LII,KIIT(3),LOWER,KIIT(5))
      ISCRQ(1) = ISCR(6)
      ISCRA  = ISCR(7)
      ISCRB  = ISCR(8)
      ISCRC  = ISCR(9)
      POWER  = 1
      CHLSKY = 0
      DBLKOR = 1 + KORBGN/2
      NZSF   = LSTZWD - 2*DBLKOR - 1
      CALL SDCOMP (*40,DZ(DBLKOR),DZ(DBLKOR),DZ(DBLKOR))
      CALL WRTTRL (LIIT)
C
C     SAVE LII AS LMTX ON SOF
C
      IF (.NOT. RSAVE) GO TO 20
      CALL SOFOPN (Z(SBUF1),Z(SBUF2),Z(SBUF3))
      IFILE = LII
      ITEM  = ITMLST(1)
      CALL MTRXO (LII,OLDNAM,ITEM,0,ITEST)
      IF (ITEST .NE. 3) GO TO 70
      IF (BOUNDS) GO TO 35
      CALL SOFCLS
C
C     SOLVE STRUCTURE REDUCTION TRANSFORMATION MATRIX
C
C                       T
C        **   ** **   ** **   **    **   **
C        *     * *     * *     *    *     *
C        * LII * * LII * * GIB * = -* KIB *
C        *     * *     * *     *    *     *
C        **   ** **   ** **   **    **   **
C
   20 IF (BOUNDS) GO TO 32
      KIBT(1) = KIB
      CALL RDTRL (KIBT)
      DO 30 I = 1,7
   30 LIIFBS(I) = LIIT(I)
      CALL MAKMCB (GIBT,GIB,KIBT(3),KIBT(4),KIBT(5))
      NZFBS = LSTZWD - 2*DBLKOR
      PREC  = KIBT(5)
      SIGN  = -1
      CALL FBS (DZ(DBLKOR),DZ(DBLKOR))
      CALL WRTTRL (GIBT)
C
C     SAVE GIB AS GIMS ON SOF
C
      CALL SOFOPN (Z(SBUF1),Z(SBUF2),Z(SBUF3))
      IFILE = GIB
      ITEM  = ITMLST(2)
      CALL MTRXO (GIB,OLDNAM,ITEM,0,ITEST)
      IF (ITEST .NE. 3) GO TO 70
      GO TO 35
   32 CALL SOFOPN (Z(SBUF1),Z(SBUF2),Z(SBUF3))
   35 CONTINUE
      GO TO 140
C
C     PROCESS SYSTEM FATAL ERRORS
C
   40 WRITE  (IPRNTR,45) SWM,OLDNAM
   45 FORMAT (A27,' 6311, SDCOMP DECOMPOSITION FAILED ON KII MATRIX ',
     1       'FOR SUBSTRUCTURE ',2A4)
      IMSG  = -37
      IFILE = 0
      CALL MESAGE (IMSG,IFILE,MODNAM)
      GO TO 140
C
C     PROCESS MODULE FATAL ERRORS
C
   70 GO TO (80,80,80,90,100,120), ITEST
   80 IMSG = -9
      GO TO 130
   90 IMSG = -2
      GO TO 110
  100 IMSG = -3
  110 CALL SMSG (IMSG,ITEM,OLDNAM)
      GO TO 140
  120 IMSG = -10
  130 DRY = -2
      CALL SMSG1 (IMSG,ITEM,OLDNAM,MODSAM)
  140 RETURN
C
      END

      SUBROUTINE SHGMGD (*,ELID,TEM,MID,TS,NOALFA,G,RHO,GSUBE,TSUB0,
     1                   EGNOR,ALPHA)
C
C     MATERIAL PROPERTY G-MATRICES GENERATOR FOR SHELL ELEMENTS
C
C     DOUBLE PRECISION VERSION
C
C     INPUT :
C           ELID   - ELEMENT ID
C           TEM    - 3X3 TRANSFORMATION BETWEEN ELEMENT AND MATERIAL
C                    COORDINATE SYSTEMS
C           MID    - ARRAY OF LENGTH 4, CONTAINS MATERIAL ID'S
C           TS     - EQUIVALENT SHEAR THICKNESS
C           NOALFA - LOGICAL TO REQUEST OR NOT REQUEST THERMAL EXPANSION
C                    COEFFICIENTS
C
C     OUTPUT:
C           G      - ARRAY OF LENGTH 36 (FOUR 3X3), CONATINS MATERIAL
C                    PROPERTIES IN ELEMENT COORD. SYSTEM
C           RHO    - MASS DENSITY FROM MEMBRANE MATERIAL
C           GSUBE  - DAMPING COEFFICIENT FROM MEMBRANE OR BENDING
C                    MATERIALS
C           TSUB0  - REFERENCE TEMPERATURE
C           EGNOR  - ARRAY OF PSEUDO E'S AND G'S FOR SHEAR FACTOR
C                    CALCULATIONS IN BENDING
C           ALPHA  - ARRAY OF THERMAL EXPANSION COEFFICIENTS
C
C     NOTES:
C           1- THIS ROUTINE BUILDS THE MATERIAL PROPERTY MATRIX USING
C              THE OUTPUT OF SUBROUTINE 'MAT' (/MATOUT/).
C              /MATOUT/ IS IN MAT2 FORMAT IF MAT1 AND/OR MAT2 ARE USED
C              /MATOUT/ IS IN MAT8 FORMAT IF MAT8 CARD IS REQUESTED.
C           2- ISOTROPIC, ORTHOTROPIC, AND ANISOTROPIC PROPERTY TYPES
C              ARE SUPPORTED.
C           3- PROPERTIES FOR MEMBRANE, BENDING, SHEAR FLEXIBILITY, AND
C              MEMBRANE/BENDING COUPLING ARE PROCESSED.
C           4- NON-STANDARD RETURN IS TAKEN WHEN THE MATERIAL FOR SHEAR
C              FLEXIBILITY IS NOT PROPERLY DEFINED.
C           5- SOME OF THE CONTENTS OF /MATIN/ MUST BE DEFINED PRIOR TO
C              A CALL TO THIS ROUTINE.
C           6- CONTENTS OF /TERMS/, MID, AND TS MAY BE CHANGED IN THIS
C              ROUTINE.
C
C
C
      LOGICAL          MEMBRN,BENDNG,SHRFLX,MBCOUP,NORPTH,NOALFA
      INTEGER          MID(4),INDEX(3,3),ELID,NAME(2)
      REAL             NU12,NU21,MATSET
      DOUBLE PRECISION G(36),TEM(9),U(9),GT(9),EGNOR(4),DN12,DN21,PS1,
     1                 PS2,RHO,TS,CONST,ALPHA(6),TALPHA(6),DETU,BDUM
      COMMON /TERMS /  MEMBRN,BENDNG,SHRFLX,MBCOUP,NORPTH
      COMMON /MATIN /  MATID,INFLAG,ELTEMP,DUMMY,SINMAT,COSMAT
      COMMON /MATOUT/  G11,G12,G13,G22,G23,G33,RHOX,ALPH1,ALPH2,ALPH12,
     1                 TREF,GE,ST,SC,SS,E,DUM(8),MATSET
C                      MAT8 FORMAT...
      EQUIVALENCE      (E1 ,G11),(NU12,G12),(E2,G13),(G2Z,G23),
     1                 (G1Z,G33),(G12X,G22)
C    2,                (GE ,E  ),(T0,ALPH12)
C             EQUIV    (MATOUT(1),G11))
      DATA    NAME  /  4HSHGM, 4HGD   /
C
C
C     INITIALIZE
C
C     SET INFLAG = 12 SO THAT SUBROUTINE MAT WILL SEARCH FOR:
C     ISOTROPIC   MATERIAL PROPERTIES AMONG THE MAT1 CARDS,
C     ORTHOTROPIC MATERIAL PROPERTIES AMONG THE MAT8 CARDS, AND
C     ANISOTROPIC MATERIAL PROPERTIES AMONG THE MAT2 CARDS.
C
      DO 10 IG = 1,36
   10 G(IG) = 0.0D0
      DO 20 IG = 1,4
   20 EGNOR(IG) = 0.0D0
      IF (NOALFA) GO TO 40
      DO 30 IG = 1,6
      ALPHA(IG) = 0.0D0
   30 CONTINUE
C
   40 RHO   = 0.0D0
      GSUBE = 0.0
      TSUB0 = 0.0
      INFLAG= 12
      IGOBK = 0
      IT0   = 0
C
C     BEGIN THE LOOP TO FETCH PROPERTIES FOR EACH MATERIAL ID. FOR SHEAR
C     FLEXIBILITY MATERIAL, DEFAULT TO THE BENDING MATERIAL IF BENDING
C     IS PRESENT.
C     IF SHEAR MATERIAL IS PRESENT, BUT YIELDS ZEROES, GO BACK AND RESET
C     IT TO BENDING MATERIAL.
C
      M = 0
  100 LPOINT = M*9
      M = M + 1
      IF (M .GT. 4) GO TO 600
      IF (M.EQ.4 .AND. IGOBK.EQ.1) GO TO 610
      MATID = MID(M)
      IF (MATID.EQ.0 .AND. M.NE.3) GO TO 100
      IF (MATID.EQ.0 .AND. M.EQ.3 .AND. .NOT.BENDNG) GO TO 100
      IF (MATID.EQ.0 .AND. M.EQ.3 .AND. BENDNG) MATID = MID(2)
C
      IF (M-1) 130,120,110
  110 IF (MATID.EQ.MID(M-1) .AND. IGOBK.EQ.0) GO TO 130
  120 CALL MAT (ELID)
      TMTSET = MATSET
      IF (MATSET .EQ. 8.0) TMTSET = 3.0
      MTYPE = IFIX(TMTSET+0.05) - 2
C
C     SET THE MISC ITEMS
C
  130 IF (MEMBRN .AND. M.EQ.1) RHO = DBLE(RHOX)
      IF (MEMBRN .AND. M.NE.1 .OR. .NOT.MEMBRN .AND. M.NE.2) GO TO 140
      GSUBE = GE
      IF (MTYPE .GT. 0) GSUBE = E
  140 IF (IT0 .GT. 0) GO TO 150
      IT0   = 1
      TSUB0 = TREF
      IF (MTYPE .GT. 0) TSUB0 = ALPH12
C
C     BRANCH ON MATERIAL TYPE
C
  150 IF (MTYPE) 200, 210, 250
C               MAT1,MAT2,MAT8
C
C
C     ISOTROPIC  MATERIALS (MAT1)
C     ---------------------------
C
C 200 IF (M .NE. 3) GO TO 205
  200 IF (M .NE. 3) GO TO 220
C
C     G(LPOINT+1) = MATOUT(3)    <== G13, SHOULD BE MATOUT(6) <== G33
C     G(LPOINT+4) = G(LPOINT+1)
C     IF (G(LPOINT+1).EQ.0.0 .AND. SHRFLX) GO TO 300
C
      G(LPOINT+1) = G33
      G(LPOINT+4) = G33
      IF (G33.EQ.0.0 .AND. SHRFLX) GO TO 300
      GO TO 400
C
C     ACCORDING TO Q4GMGD, SHOULD GO TO 220 NEXT
C
C 205 G(LPOINT+1) = G22
C     G(LPOINT+2) = G12*G22
C     G(LPOINT+4) = G12*G22
C     G(LPOINT+5) = G22
C     G(LPOINT+0) = G13         <== G13,  SHOULD IT BE G33 ??
C     GO TO 400
C
C     ANISOTROPIC  MATERIALS (MAT2)
C     -----------------------------
C
  210 IF (M .EQ. 3) GO TO 230
  220 G(LPOINT+1) = G11
      G(LPOINT+2) = G12
      G(LPOINT+3) = G13
      G(LPOINT+4) = G12
      G(LPOINT+5) = G22
      G(LPOINT+6) = G23
      G(LPOINT+7) = G13
      G(LPOINT+8) = G23
      G(LPOINT+9) = G33
      GO TO 400
C
  230 IF (SHRFLX) GO TO 240
      IF (G11.EQ.0.0 .OR. G22.EQ.0.0) GO TO 400
      DN21  = G12/G11
      DN12  = G12/G22
      CONST = DN21*DN12
      IF (CONST .LT. 0.0D0) GO TO 400
      PS1 = DBLE(G11)*(1.0D0-CONST)
      PS2 = DBLE(G22)*(1.0D0-CONST)
      IF (CONST .GT. 0.0D0) CONST = DSQRT(CONST)
      CONST = 2.0D0*(1.0D0+CONST)
      G(LPOINT+1) = PS1/CONST
      G(LPOINT+4) = PS2/CONST
      GO TO 400
C
  240 G(LPOINT+1) = G11
      G(LPOINT+2) = G12
      G(LPOINT+3) = G12
      G(LPOINT+4) = G22
      IF (G33 .NE. 0.0) GO TO 300
      GO TO 400
C
C     ORTHOTROPIC MATERIALS (MAT8)
C     ----------------------------
C
  250 IF (M  .EQ.   3) GO TO 260
      IF (E1 .EQ. 0.0) GO TO 400
      NU21 = NU12*E2/E1
      CONST= 1.0D0 - DBLE(NU21*NU12)
      IF (CONST .LE. 0.0D0) GO TO 400
      G(LPOINT+1) = E1/CONST
      G(LPOINT+2) = NU12*E2/CONST
      G(LPOINT+4) = G(LPOINT+2)
      G(LPOINT+5) = E2/CONST
      G(LPOINT+9) = G12X
      GO TO 400
C
  260 IF (SHRFLX) GO TO 270
      IF (E1 .EQ. 0.0) GO TO 400
      NU21  = NU12*E2/E1
      CONST = NU21*NU12
      IF (CONST .LE. 0.0D0) GO TO 400
      CONST = DSQRT(CONST)
      CONST = 2.0D0*(1.0D0+CONST)
      G(LPOINT+1) = DBLE(E1)/CONST
      G(LPOINT+4) = DBLE(E2)/CONST
      GO TO 400
C
C 270 G(LPOINT+1) = MATOUT(5)        <== COSMIC (5) & (6) INTERCHANGED
C     G(LPOINT+4) = MATOUT(6)
  270 G(LPOINT+1) = G1Z
      G(LPOINT+4) = G2Z
      IF (G1Z.EQ.0.0 .AND. G2Z.EQ.0.0) GO TO 300
      GO TO 400
C
C     BAD SHEAR MATERIAL
C
  300 IF (.NOT.SHRFLX .AND. BENDNG) GO TO 400
      RETURN 1
C
C     TRANSFORM NON-ISOTROPIC MATERIALS
C
  400 IF (MTYPE .LT. 0) GO TO 430
      IF (M     .EQ. 3) GO TO 410
      U(1) = TEM(1)*TEM(1)
      U(2) = TEM(4)*TEM(4)
      U(3) = TEM(1)*TEM(4)
      U(4) = TEM(2)*TEM(2)
      U(5) = TEM(5)*TEM(5)
      U(6) = TEM(2)*TEM(5)
      U(7) = TEM(1)*TEM(2)*2.0D0
      U(8) = TEM(4)*TEM(5)*2.0D0
      U(9) = TEM(1)*TEM(5) + TEM(2)*TEM(4)
      L    = 3
      GO TO 420
C
  410 U(1) = TEM(5)*TEM(9) + TEM(6)*TEM(8)
      U(2) = TEM(2)*TEM(9) + TEM(8)*TEM(3)
      U(3) = TEM(4)*TEM(9) + TEM(7)*TEM(6)
      U(4) = TEM(1)*TEM(9) + TEM(3)*TEM(7)
      L    = 2
C
  420 CALL GMMATD ( U(1),L,L,1, G(LPOINT+1),L,L,0, GT(1))
      CALL GMMATD (GT(1),L,L,0, U(1),L,L,0,  G(LPOINT+1))
C
C     GET THE THERMAL EXPANSION COEFFICIENTS, IF NEEDED
C
  430 IF (NOALFA .OR. M.GT.2) GO TO 100
      MORB = (M-1)*3
      IF (MTYPE) 500, 510, 520
C               MAT1,MAT2,MAT8
C
C     MAT1
C
  500 ALPHA(MORB+1) = ALPH1
      ALPHA(MORB+2) = ALPH1
      ALPHA(MORB+3) = 0.0D0
      GO TO 100
C
C     MAT2
C
  510 ALPHA(MORB+1) = ALPH1
      ALPHA(MORB+2) = ALPH2
      ALPHA(MORB+3) = ALPH12
      GO TO 530
C
C     MAT8
C
  520 ALPHA(MORB+1) = ALPH1
      ALPHA(MORB+2) = ALPH2
      ALPHA(MORB+3) = 0.0D0
C
C     TRANSFORM THERMAL EXPANSION COEFFICIENTS AND STORE THEM IN ALPHA.
C     THE ALPHAS NEED TO BE PREMULTIPLIED BY [U] INVERSE.
C
  530 DO 540 IG = 1,3
  540 TALPHA(IG+MORB) = ALPHA(IG+MORB)
      MORB = MORB + 1
      CALL INVERD (3,U,3,BDUM,0,DETU,ISNGU,INDEX)
      CALL GMMATD (U,3,3,0, TALPHA(MORB),3,1,0, ALPHA(MORB))
      GO TO 100
C
C
C     LOOP IS DONE, CHECK FOR ALL ZEROES FOR SHEAR MATERIAL
C
  600 IF (G(19).NE.0.0D0 .OR. G(20).NE.0.0D0 .OR. G(21).NE.0.0D0 .OR.
     1    G(22).NE.0.0D0) GO TO 610
      IGOBK  = 1
      M      = 2
      MID(3) = 0
      SHRFLX = .FALSE.
      TS     = 0.833333333D0
C              0.833333333D0 = 5.0D0/6.0D0
      GO TO 100
C
C     SAVE PSEUDO E'S AND G'S FOR SHEAR FACTOR CALCULATIONS
C
  610 IF (.NOT.BENDNG) GO TO 620
      EGNOR(1) = G(10)
      EGNOR(2) = G(14)
      EGNOR(3) = G(19)
      EGNOR(4) = G(22)
C
  620 RETURN
      END

      SUBROUTINE DS1 (IARG)
C
C     THIS ROUTINE CREATES THE SCRATCH FILE ECPTDS BY APPENDING TO EACH
C     ELEMENT IN THE ECPT AN ELEMENT DEFORMATION, AN AVERAGE ELEMENT
C     LOADING TEMPERATURE, AND THE PROPER COMPONENTS OF THE DISPLACEMENT
C     VECTORS. SUBROUTINE DS1A READS THE ECPTDS IN THE SAME WAY AS SMA1A
C     READS THE ECPT IN ORDER TO CREATE A SECOND ORDER APPROXIMATION TO
C     THE KGG, WHICH IS CALLED KGGD.
C     IF DS1 CANNOT FIND ANY ELEMENTS IN THE ECPT WHICH ARE IN THE SET
C     OF ELEMENTS FOR WHICH DIFFERENTIAL STIFFNESS IS DEFINED, IARG IS
C     RETURNED CONTAINING A ZERO TO THE CALLING ROUTINE, DSMG1.
C
      EXTERNAL        RSHIFT
      LOGICAL         DSTYPE,EORFLG,ENDID,RECORD
      INTEGER         BUFFR1,BUFFR2,EOR,CLSRW,OUTRW,CASECC,GPTT,EDT,
     1                UGV,ECPT,ECPTDS,FILE,TSETNO,DSETNO,TMPSET,
     2                RECNO,EDTLOC,EDTBUF,ELTYPE,ELID,BUFLOC,DFMSET,
     3                RSHIFT,JSIL(2),OLDEL,CCBUF,OLDEID,BUFFR3
      DIMENSION       TGRID(33),IZ(1),XECPT(328),IECPT(328),CCBUF(2),
     1                GPTBF3(3),NAME(2),EDTBUF(3),EDTLOC(2),MCBUGV(7)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG / UFM,UWM,UIM,SFM
      COMMON /MACHIN/ MACH,IHALF
      COMMON /GPTA1 / NELEMS,LAST,INCR,NE(1)
      COMMON /SYSTEM/ ISYS,SYSDUM(25),MN,XXX18(18),NDUM(9)
      COMMON /ZZZZZZ/ Z(1)
      COMMON /UNPAKX/ ITYPEB,IUNPK,JUNPK,INCUPK
      COMMON /DS1ETT/ ELTYPE,OLDEL,EORFLG,ENDID,BUFFLG,TSETNO,FDFALT,
     1                IBACK,RECORD,OLDEID
      COMMON /BLANK / DSCSET
      EQUIVALENCE     (Z(1),IZ(1))       ,(XECPT(1),IECPT(1)),
     1                (GPTBF3(1),TMPSET) ,(GPTBF3(2),IDFALT) ,
     2                (GPTBF3(3),RECNO)  ,(EDTBUF(1),DFMSET) ,
     3                (EDTBUF(2),ELID)   ,(EDTBUF(3),DEFORM) ,
     4                (IOUTPT,SYSDUM(1))
      DATA            EDTLOC/104,1 /,     NSKIP/ 137  /
      DATA            CASECC,GPTT,EDT,UGV,ECPT,ECPTDS /
     1                101,   102, 104,105,108, 301    /
      DATA            NAME  /4HDS1 ,4H         /
      DATA            INRW,OUTRW,EOR,NEOR,CLSRW/ 0,1,1,0,1 /
C
C     SET IARG TO ZERO
C
      CALL DELSET
      IARG = 0
C
C     DETERMINE SIZE OF AVAILABLE CORE, DEFINE 2 BUFFERS AND INITIALIZE
C     OPEN CORE POINTERS AND COUNTERS.
C
      IZMAX  = KORSZ(Z)
      BUFFR1 = IZMAX  - ISYS
      BUFFR2 = BUFFR1 - ISYS
      BUFFR3 = BUFFR2 - ISYS
      BUFLOC = IZMAX  - ISYS - 3
      ILEFT  = BUFFR3 - 1
      LEFT   = ILEFT  - NELEMS - 2
      ISIL   = 0
      NSIL   = 0
      IEDT   = 0
      NEDT   = 0
C
C     SET DIFFERENTIAL STIFFNESS FLAGS FOR ALL ELEMENT TYPES TO ZERO
C
      DO 10 I = 1,NELEMS
      IZ(LEFT+I) = 0
   10 CONTINUE
C
C     OPEN CASECC, SKIP HEADER, SKIP 5 WORDS AND READ DEFORMATION SET
C     NUMBER AND LOADING TEMPERATURE SET NUMBER.
C
      CALL GOPEN (CASECC,Z(BUFFR1),INRW)
      CALL FREAD (CASECC,0,-5,NEOR)
      CALL FREAD (CASECC,CCBUF,2,NEOR)
      DSETNO = CCBUF(1)
      TSETNO = CCBUF(2)
C
C     STORE THE DIFFERENTIAL STIFFNESS COEFFICIENT (BETA) SET NUMBER
C     IN COMMON.  THIS WORD IS THE 138TH WORD OF THE 2ND RECORD OF CASE
C     CONTROL.
C
      FILE = CASECC
      CALL FWDREC (*400,CASECC)
      CALL FREAD  (CASECC,0,-NSKIP,NEOR)
      CALL FREAD  (CASECC,DSCSET,1,NEOR)
      CALL CLOSE  (CASECC,CLSRW)
C
C     IS THERE A TEMPERATURE LOAD
C
      RECORD =.FALSE.
      IBACK  = 0
      IF (TSETNO .LE. 0) GO TO 60
C
C     THERE IS. OPEN THE GPTT, SKIP FIRST TWO WORDS OF THE HEADER RECORD
C     AND READ 3 WORD ENTRIES OF THE HEADER RECORD UNTIL A SET NUMBER
C     MATCHES THE SET NUMBER READ IN THE CASE CONTROL RECORD.
C
      FILE = GPTT
      CALL OPEN  (*400,GPTT,Z(BUFFR3),INRW)
      CALL FREAD (GPTT,0,-2,NEOR)
   20 CALL FREAD (GPTT,GPTBF3,3,NEOR)
      IF (TMPSET .EQ. TSETNO) GO TO 30
      GO TO 20
   30 FDFALT = GPTBF3(2)
      IF (RECNO  .NE.  0) GO TO 40
      IF (IDFALT .EQ. -1) CALL MESAGE (-30,29,TSETNO)
      CALL CLOSE (GPTT,CLSRW)
      GO TO 60
C
C     POSITION GPTT TO DESIRED TEMPERATURE RECORD
C
   40 CALL REWIND (GPTT)
      DO 50 I = 1,RECNO
      CALL FWDREC (*410,GPTT)
   50 CONTINUE
      RECORD =.TRUE.
C
C     READ SETID AND VERIFY FOR CORRECTNESS
C
      CALL FREAD (GPTT,IDSET,1,0)
      IF (TSETNO .NE. IDSET) CALL MESAGE (-30,29,TSETNO)
C
C     INITIALIZE /DS1ETT/ VARIABLES
C
      OLDEID = 0
      OLDEL  = 0
      EORFLG =.FALSE.
      ENDID  =.TRUE.
C
C     DETERMINE IF AN ENFORCED DEFORMATION SET IS CALLED FOR.
C
   60 IEDT = ISIL
      I    = ISIL
      IF (DSETNO .LE. 0) GO TO 90
      FILE = EDT
      CALL PRELOC (*90,Z(BUFLOC),EDT)
      CALL LOCATE (*450,Z(BUFLOC),EDTLOC,IFLAG)
   70 CALL READ (*410,*80,EDT,EDTBUF,3,NEOR,IFLAG)
      IF (DFMSET .NE. DSETNO) GO TO 70
      IZ(I+1) = ELID
      Z (I+2) = DEFORM
      NEDT = NEDT + 2
      I    = I + 2
      LEFT = LEFT - 2
      IF (LEFT .LE. 0) CALL MESAGE (-8,0,NAME)
      GO TO 70
   80 CALL CLOSE (EDT,CLSRW)
      LOW = IEDT + 1
      LIM = IEDT + NEDT
C
C     READ THE UGV INTO CORE.
C
   90 CALL GOPEN (UGV,Z(BUFFR1),INRW)
      IDISP = IEDT + NEDT
      MCBUGV(1) = UGV
      CALL RDTRL (MCBUGV(1))
      IF (LEFT .LT. MCBUGV(3)) CALL MESAGE (-8,0,NAME(1))
      ITYPEB = 1
      IUNPK  = 1
      JUNPK  = MCBUGV(3)
      INCUPK = 1
      CALL UNPACK (*460,UGV,Z(IDISP+1))
      CALL CLOSE  (UGV,CLSRW)
C
C     OPEN THE ECPTDS AND ECPT FILES.
C
      CALL GOPEN (ECPTDS,Z(BUFFR2),OUTRW)
      CALL GOPEN (ECPT,Z(BUFFR1),INRW)
C
C     READ THE PIVOT POINT (1ST WORD).
C
  100 FILE   = ECPT
      IMHERE = 100
      ELTYPE = -1
      J      = -1
      CALL READ (*390,*430,ECPT,NPVT,1,NEOR,IFLAG)
      IND = 0
  110 DSTYPE =.FALSE.
C
C     READ ELEMENT TYPE (2ND WORD)
C
      CALL READ (*410,*370,ECPT,ELTYPE,1,NEOR,IFLAG)
      IF (ELTYPE.LT.1 .OR. ELTYPE.GT.NELEMS) GO TO 480
C
C     READ ELEMENT ID (3RD WORD, BEGINNING OF J NO. OF WORDS)
C
      IMHERE = 115
      CALL READ (*410,*430,ECPT,IECPT,1,NEOR,IFLAG)
      IF (IBACK .EQ. 0) GO TO 120
      IF (ELTYPE.EQ.OLDEL .AND. IECPT(1).GE.OLDEID) GO TO 130
      CALL BCKREC (GPTT)
C
C     RESET /DS1ETT/ VARIABLES
C
      IBACK  = 0
      OLDEID = 0
      OLDEL  = 0
      EORFLG =.FALSE.
      ENDID  =.TRUE.
      CALL READ (*410,*420,GPTT,IDSET,1,0,FLAG)
      IF (TSETNO .NE. IDSET) CALL MESAGE (-30,29,TSETNO)
C
  120 IDX = (ELTYPE-1)*INCR
      NTEMP = 1
C                IS2D8              IHEX1              IHEX3
      IF (ELTYPE.EQ.80 .OR. (ELTYPE.GE.65 .AND. ELTYPE.LE.67))
     1    NTEMP = NE(IDX+15) - 1
C
C     READ ECPT ENTRY FOR THIS ELEMENT (J-1 WORDS)
C
  130 J = NE(IDX+12)
      IF (NE(IDX+24) .NE. 0) DSTYPE = .TRUE.
      IMHERE = 130
      CALL READ (*410,*430,ECPT,XECPT(2),J-1,NEOR,IFLAG)
C
C     IS THIS ELEMENT IN THE SET OF DS ELEMENTS.
C
      IF (DSTYPE) GO TO 150
      IF (IZ(LEFT+ELTYPE) .EQ. 1) GO TO 110
      IZ(LEFT+ELTYPE) = 1
      CALL PAGE2 (-2)
      WRITE  (IOUTPT,140) UWM,NE(IDX+1),NE(IDX+2),ELTYPE
  140 FORMAT (A25,' 3117, DIFFERENTIAL STIFFNESS CAPABILITY NOT DEFINED'
     1,      ' FOR ',2A4,' ELEMENTS (ELEMENT TYPE ',I3,2H).)
      GO TO 110
  150 IARG = 1
C
C     DETERMINE IF THE ELEMENT IS A CONE.  IF IT IS, IT MUST HAVE A
C     NONZERO MEMBRANE THICKNESS FOR IT TO BE ADMISSIBLE TO THE ECPTDS.
C
      IF (ELTYPE .NE. 35) GO TO 170
C                 CONEAX
      NTEMP = 2
      IF (XECPT(5) .EQ. 0.0) GO TO 110
C
C     DETERMINE THE NUMBER OF RINGAX POINTS FROM THE 27TH WORD OF
C     /SYSTEM/.
C
      NRNGAX = RSHIFT(MN,IHALF)
C
C     DETERMINE THE HARMONIC NUMBER, IHARM, FROM THE ELEMENT IDENT.
C     NUMBER, IECPT(1)
C
      ITEMP = IECPT(1)/1000
      IHARM = IECPT(1) - ITEMP*1000 - 1
C
C     DETERMINE THE SIL NUMBERS, SIL(1) AND SIL(2), WHICH WILL BE USED
C     TO APPEND TEMPERATURES AND DISPLACEMENT VECTORS.
C
      IF (IHARM .NE. 0) GO TO 160
      JSIL(1) = IECPT(2)
      JSIL(2) = IECPT(3)
      GO TO 180
  160 ITEMP   = 6*IHARM*NRNGAX
      JSIL(1) = IECPT(2) - ITEMP
      JSIL(2) = IECPT(3) - ITEMP
      GO TO 180
C
C     IF WE ARE DEALING WITH A TRIA1 OR QUAD1 ELEMENT, IT MUST HAVE A
C     NONZERO MEMBRANE THICKNESS FOR IT TO BE ADMISSIBLE TO THE ECPTDS.
C
  170 IF (ELTYPE.NE.6 .AND. ELTYPE.NE.19) GO TO 180
C               TRIA1              QUAD1
      KK = 7
      IF (ELTYPE .EQ. 19) KK = 8
C                  QUAD1
      IF (XECPT(KK) .EQ. 0.0) GO TO 110
C
C     WRITE PIVOT POINT
C
  180 IF (IND .EQ. 0) CALL WRITE (ECPTDS,NPVT,1,NEOR)
      IND = 1
      IF (ELTYPE .NE. 34) GO TO 200
C                    BAR
C
C     THE ELEMENT IS A BAR.  THE ECPT ENTRY WILL BE REARRANGED SO THAT
C     THE DBAR SUBROUTINE MAY BE CALLED IN SUBROUTINE DS1A.
C
      ELTYPE = 2
C           BEAM
C
C     IF THE COUPLED MOMENT OF INERTIA TERM I12 (=ECPT(33)) IS NON-ZERO
C     SET I12 = 0.0, WRITE WARNING MESSAGE AND PROCEED.
C
      IF (XECPT(33) .EQ. 0.0) GO TO 190
      XECPT(33) = 0.0
      CALL MESAGE (30,111,IECPT(1))
  190 XECPT(47) = XECPT(42)
      XECPT(46) = XECPT(41)
      XECPT(45) = XECPT(40)
      XECPT(44) = XECPT(39)
      XECPT(43) = XECPT(38)
      XECPT(42) = XECPT(37)
      XECPT(41) = XECPT(36)
      XECPT(40) = XECPT(35)
      XECPT(39) = XECPT(34)
      XECPT(29) = XECPT(31)
      XECPT(30) = XECPT(32)
      XECPT(28) = XECPT(21)
      XECPT(27) = XECPT(20)
      XECPT(25) = XECPT(19)
      XECPT(24) = XECPT(18)
      XECPT(21) = XECPT(17)
      XECPT(20) = XECPT(16)
      J = 47
C
C     WRITE ELEMENT TYPE
C
  200 CALL WRITE (ECPTDS,ELTYPE,1,NEOR)
C
C     ATTACH THE ELEMENT DEFORMATION TO THE XECPT ARRAY.
C
      J = J + 1
      NOGPTS = NE(IDX+10)
      XECPT(J) = 0.0
      IF (DSETNO .GT. 0) GO TO 210
      GO TO 230
C
C     SEARCH THE EDT TO FIND AN ELEMENT NO. IN THE TABLE CORRESPONDING
C     TO THE CURRENT ELEMENT NO., IECPT(1).  IF IT CANNOT BE FOUND NOTE
C     THE ELEMENT DEFORMATION, IECPT(J), HAS BEEN SET TO ZERO.
C
  210 DO 220 I = LOW,LIM,2
      IF (IZ(I) .NE. IECPT(1)) GO TO 220
      XECPT(J) = Z(I+1)
      GO TO 230
  220 CONTINUE
C
C     APPEND THE LOADING TEMPERATURE(S) TO THE XECPT ARRAY
C
  230 IF (ELTYPE .EQ. 2) ELTYPE = 34
C                  BEAM          BAR
      CALL DS1ETD (IECPT(1),TGRID,NTEMP)
      IF (ELTYPE .NE. 34) GO TO 240
C                    BAR
      ELTYPE = 2
      IF (TSETNO .LE. 0) GO TO 240
      TGRID(1) = (TGRID(1) + TGRID(2))*0.5
  240 III = 1
      IF (ELTYPE .NE. 80) GO TO 250
C                  IS2D8
      J = J + 1
      IECPT(J) = TSETNO
      III = 2
  250 CONTINUE
      DO 260 I = III,NTEMP
      J = J + 1
      XECPT(J) = TGRID(I)
  260 CONTINUE
C
C     NOW ATTACH THE DISPLACEMENT VECTORS
C
      J = J + 1
      IF (ELTYPE .EQ. 35) GO TO 330
C                 CONEAX
      IF (ELTYPE.EQ. 2 .OR. ELTYPE.EQ.75) GO TO 290
C                 BEAM             TRSHL
      IF (ELTYPE.LT.53 .OR. ELTYPE.GT.61) GO TO 280
C                 DUM1              DUM9
C
C
C     DUMMY ELEMENTS
C
      IF (MOD(NDUM(ELTYPE-52),10) .EQ. 6) GO TO 290
  280 NWDS = 3
      GO TO 300
  290 NWDS = 6
  300 DO 320 I = 1,NOGPTS
      INDEX = IDISP + IECPT(I+1)
      DO 310 I1 = 1,NWDS
      XECPT(J) = Z(INDEX)
      INDEX = INDEX + 1
  310 J = J + 1
  320 CONTINUE
      GO TO 360
C
C     APPEND THE ZERO HARMONIC COMPONENTS OF THE DISPLACEMENT VECTOR.
C     NOTE THAT FOR A CONICAL SHELL ELEMENT DIRECT POINTERS INTO THE
C     DISPLACEMENT VECTOR ARE SIL(1) AND SIL(2).
C
  330 DO 350 J1 = 1,2
      DO 340 I  = 1,6
      INDEX = IDISP + JSIL(J1) + I - 1
      XECPT(J) = Z(INDEX)
  340 J = J + 1
  350 CONTINUE
C
C     THE APPENDED ECPT, ECPTDS, IS NOW COMPLETE.
C
  360 CALL WRITE (ECPTDS,XECPT,J-1,NEOR)
      GO TO 110
C
C    IF IND = 0, THEN NO ELEMENTS IN THE CURRENT ECPT RECORD ARE IN THE
C    DS ELEMENT SET.  WRITE A -1 FOR THIS PIVOT POINT.
C
  370 IF (IND .NE. 0) GO TO 380
      CALL WRITE (ECPTDS,-1,1,EOR)
      GO TO 100
C
C     WRITE AN EOR ON THE ECPTDS FILE
C
  380 CALL WRITE (ECPTDS,0,0,EOR)
      GO TO 100
C
C     CLOSE BOTH FILES
C
  390 CALL CLOSE (ECPT,CLSRW)
      CALL CLOSE (GPTT,CLSRW)
      CALL CLOSE (ECPTDS,CLSRW)
      RETURN
C
C     FATAL ERROR RETURNS
C
  400 J = -1
      GO TO 470
  410 J = -2
      GO TO 470
  420 FILE = GPTT
  430 J = -3
      IF (FILE .EQ. ECPT) WRITE (IOUTPT,440) IMHERE,ELTYPE,J
  440 FORMAT (/,'0*** DS1/IMHERE,ELTYPE,J = ',3I5)
      GO TO 470
  450 J = -4
      GO TO 470
  460 CALL MESAGE (-30,83,NAME(1))
  470 CALL MESAGE (J,FILE,NAME)
  480 WRITE  (IOUTPT,490) SFM,ELTYPE
  490 FORMAT (A25,' 2147, ILLEGAL ELEMENT TYPE =',I10,
     1       ' ENCOUNTERED BY DSMG1 MODULE.')
      CALL MESAGE (-61,0,NAME)
      RETURN
      END

      SUBROUTINE DIS2D8
C
C     2-D, 8 GRID POINT ISOPARAMETRIC STRUCTURAL ELEMENT
C     DIFFERENTIAL STIFFNESS MATRIX ROUTINE
C
      REAL             KX,KY
      DOUBLE PRECISION KIJ,G,B,XI,ETA,DNXI,DNETA,XX,TB,DNL,PT,H,XJB,
     1                 XXJB,DETERM,DNC,GSUBE,DUMARG,
     2                 BT,TEMPAR,TEMP,DNX,DNY,SAVE,TSAVE,
     3                 KWD(36),CID(18),CJD(18),KMULT(18),DHH,
     4                 THICK,PSTMUL(9),PREMUL(9),E1T
      DIMENSION        SIG(3),ALPHAS(3),ST(3),SEMP(9),TTB(9),STB(9),
     1                 BB(72),DB(72),S(6),R(9),SE1T(6),DN(8),
     2                 G(9),QQ(15),XI(8),ETA(8),TB(9),XY1(3),XY2(3),
     3                 B(12),BT(12),ECPT(1),TEMP(9),TEMPAR(1),DNX(1),
     4                 DNY(1),DNXI(1),DNETA(1),SAVE(72),TSAVE(72),
     5                 VEC(3),VVEC(3),VECI(3),VECJ(3),VECK(3),E1T(9),
     6                 IWS(2,3)
      COMMON /DS1AAA/  NPVT,ICSTM,NCSTM
      COMMON /DS1AET/  NECPT(1),NGRID(8),ID1,TH,MATID1,T,ISYS1,X1,Y1,Z1,
     1                 ISYS2,X2,Y2,Z2,ISYS3,X3,Y3,Z3,ISYS4,X4,Y4,Z4,
     2                 ISYS5,X5,Y5,Z5,ISYS6,X6,Y6,Z6,ISYS7,X7,Y7,Z7,
     3                 ISYS8,X8,Y8,Z8,TTEMP,EDT,ISETNO,TGRID(8),DISP(24)
      COMMON /MATIN /  MATID,INFLAG,ELTEMP,STRESS,SINTH,COSTH
      COMMON /MATOUT/  G11,G12,G13,G22,G23,G33,RHO,ALPHA1,ALPHA2,ALP12,
     1                 TREF,GE,KX,KY,C
      COMMON /DS1ADP/  KIJ(36),XX(16),DNC(16),DNL(16),XXJB(2,2),XJB(4),
     1                 PT(3),H(3),G,B,BT,TB,DETERM,GSUBE,DUMARG,TSAVE
      EQUIVALENCE      (ALPHAS(1),ALPHA1),
     1                 (ECPT(1),NECPT(1)),(TEMP(1),B(1)),
     2                 (DNC(1),DNXI(1)),(DNC(9),DNETA(1)),
     3                 (DNL(1),DNX(1)),(DNL(9),DNY(1)),(QQ(1),G11),
     4                 (TEMPAR(1),BT(1)),(XY1(1),X1),(XY2(1),X2)
      DATA     XI   /  -1.D0, 1.D0, 1.D0,-1.D0, 0.D0, 1.D0, 0.D0,-1.D0/
      DATA     ETA  /  -1.D0,-1.D0, 1.D0, 1.D0,-1.D0, 0.D0, 1.D0, 0.D0/
C
C     ECPT LIST
C                                      IN
C                                      THIS
C     ECPT       DESCRIPTION           ROUTINE        TYPE
C     ******************************************************************
C     ECPT( 1) = ELEMENT ID            NECPT(1)       INTEGER
C     ECPT( 2) = GRID POINT 1          NGRID(1)       INTEGER
C     ECPT( 3) = GRID POINT 2          NGRID(2)       INTEGER
C     ECPT( 4) = GRID POINT 3          NGRID(3)       INTEGER
C     ECPT( 5) = GRID POINT 4          NGRID(4)       INTEGER
C     ECPT( 6) = GRID POINT 5          NGRID(5)       INTEGER
C     ECPT( 7) = GRID POINT 6          NGRID(6)       INTEGER
C     ECPT( 8) = GRID POINT 7          NGRID(7)       INTEGER
C     ECPT( 9) = GRID POINT 8          NGRID(8)       INTEGER
C     ECPT(10) = COORD SYS ID-STRESS   ID1            INTEGER
C     ECPT(11) = ANIS. MATERIAL ANGLE  TH             REAL
C     ECPT(12) = MATERIAL ID           MATID1         INTEGER
C     ECPT(13) = THICKNESS             T              REAL
C     ECPT(14) = COORD SYS ID 1        ISYS1          INTEGER
C     ECPT(15) = X1                    X1             REAL
C     ECPT(16) = Y1                    Y1             REAL
C     ECPT(17) = Z1                    Z1             REAL
C     ECPT(18) = COORD SYS ID 2        ISYS2          INTEGER
C     ECPT(19) = X2                    X2             REAL
C     ECPT(20) = Y2                    Y2             REAL
C     ECPT(21) = Z2                    Z2             REAL
C     ECPT(22) = COORD SYS ID 3        ISYS3          INTEGER
C     ECPT(23) = X3                    X3             REAL
C     ECPT(24) = Y3                    Y3             REAL
C     ECPT(25) = Z3                    Z3             REAL
C     ECPT(26) = COORD SYS ID 4        ISYS4          INTEGER
C     ECPT(27) = X4                    X4             REAL
C     ECPT(28) = Y4                    Y4             REAL
C     ECPT(29) = Z4                    Z4             REAL
C     ECPT(30) = COORD SYS ID 5        ISYS5          INTEGER
C     ECPT(31) = X5                    X5             REAL
C     ECPT(32) = Y5                    Y5             REAL
C     ECPT(33) = Z5                    Z5             REAL
C     ECPT(34) = COORD SYS ID 6        ISYS6          INTEGER
C     ECPT(35) = X6                    XL             REAL
C     ECPT(36) = Y6                    Y6             REAL
C     ECPT(37) = Z6                    Z6             REAL
C     ECPT(38) = COORD SYS ID 7        ISYS7          INTEGER
C     ECPT(39) = X7                    X7             REAL
C     ECPT(40) = Y7                    Y7             REAL
C     ECPT(41) = Z7                    Z7             REAL
C     ECPT(42) = COORD SYS ID 8        ISYS8          INTEGER
C     ECPT(43) = X8                    X8             REAL
C     ECPT(44) = Y8                    Y8             REAL
C     ECPT(45) = Z8                    Z8             REAL
C     ECPT(46) = ELEMENT TEMP          TTEMP          REAL
C     ECPT(47) = 0.                    EDT            REAL
C     ECPT(48) = TEMPERATURE SET       ISETNO         INTEGER
C     ECPT(49) = *
C     ECPT(. ) = *  GRID POINT TEMPERATURES
C     ECPT(56) = *
C     ECPT(57) = *
C     ECPT(. ) = *  TRANSLATIONAL DOF-S OF GRIDS FOR THIS ELEMENT
C     ECPT(80) = *
C
C
C     TEST FOR PIVOT POINT
C
      DO 10 KK = 1,8
      IF (NGRID(KK) .EQ. NPVT) GO TO 20
   10 CONTINUE
C
C     IF FALL HERE NO ELEMENT GRID POINT IS THE PIVOT POINT
C
      CALL MESAGE (-30,34,ECPT(1))
C
C     UNIT I VECTOR IS FROM GRID POINT 1 TO GRID POINT 2
C
   20 DO 30 I = 1,3
      VECI(I) = XY2(I) - XY1(I)
   30 CONTINUE
      VECIL = SQRT(VECI(1)**2 + VECI(2)**2 + VECI(3)**2)
      IF (VECIL .EQ. 0.0) GO TO 60
      VECI(1) = VECI(1)/VECIL
      VECI(2) = VECI(2)/VECIL
      VECI(3) = VECI(3)/VECIL
C
C     K VECTOR IS OBTAINED BY CROSSING I INTO VECTOR FROM GRID PT. 1 TO
C     GRID
C
      VECK(1) = VECI(2)*(Z4-Z1) - VECI(3)*(Y4-Y1)
      VECK(2) = VECI(3)*(X4-X1) - VECI(1)*(Z4-Z1)
      VECK(3) = VECI(1)*(Y4-Y1) - VECI(2)*(X4-X1)
      VECKL=SQRT(VECK(1)**2 + VECK(2)**2 + VECK(3)**2)
      IF (VECKL .EQ. 0.0) GO TO 60
      VECK(1) = VECK(1)/VECKL
      VECK(2) = VECK(2)/VECKL
      VECK(3) = VECK(3)/VECKL
C
C     J VECTOR IS OBTAINED BY CROSSING K INTO I
C
      VECJ(1) = VECK(2)*VECI(3) - VECK(3)*VECI(2)
      VECJ(2) = VECK(3)*VECI(1) - VECK(1)*VECI(3)
      VECJ(3) = VECK(1)*VECI(2) - VECK(2)*VECI(1)
C
      E1T(1) = VECI(1)
      E1T(2) = VECI(2)
      E1T(3) = VECI(3)
      E1T(4) = VECJ(1)
      E1T(5) = VECJ(2)
      E1T(6) = VECJ(3)
      E1T(7) = VECK(1)
      E1T(8) = VECK(2)
      E1T(9) = VECK(3)
      DO 40 I = 1,6
   40 SE1T(I) = E1T(I)
C
C     STORE ELEMENT COORDS FOR GRIDS 1 AND 2
C
      XX(1) = 0.
      XX(2) = 0.
      XX(3) = VECIL
      XX(4) = 0.
C
C     FOR GRIDS 3-8, THE X COORDINATE IS THE DOT PRODUCT OF HTE VECTOR
C     FROM GRID POINT 1 TO THE GRID POINT AND THE I VECTOR. THE Y COORD.
C     IS THE L OF THE I VECTOR CROSSED INTO THE VECTOR FROM GRID 1 TO
C     THE GRID POINT.
C
      DO 50 I = 3,8
      IXX  = 2*I - 1
      ISUB = 4*I + 11
      VEC(1)  = ECPT(ISUB  ) - X1
      VEC(2)  = ECPT(ISUB+1) - Y1
      VEC(3)  = ECPT(ISUB+2) - Z1
      XX(IXX) = VEC(1)*VECI(1) + VEC(2)*VECI(2) + VEC(3)*VECI(3)
      VVEC(1) = VECI(2)*VEC(3) - VECI(3)*VEC(2)
      VVEC(2) = VECI(3)*VEC(1) - VECI(1)*VEC(3)
      VVEC(3) = VECI(1)*VEC(2) - VECI(2)*VEC(1)
      XX(IXX+1) = SQRT(VVEC(1)**2 + VVEC(2)**2 + VVEC(3)**2)
   50 CONTINUE
      GO TO 70
C
C     INAPPROPRIATE GEOMETRY
C
   60 CALL MESAGE (30,31,ECPT(1))
      NOGO = 1
      RETURN
C
C     COMPUTE MATERIAL PROPERTIES
C
   70 TTH   = TH*3.1415927/180.
      SINTH = SIN(TTH)
      COSTH = COS(TTH)
      ELTEMP= TTEMP
      INFLAG= 2
      MATID = MATID1
      CALL MAT (ECPT(1))
      DO 80 I = 1,3
   80 G(I)  = QQ(I)
      G(4)  = QQ(2)
      G(5)  = QQ(4)
      G(6)  = QQ(5)
      G(7)  = QQ(3)
      G(8)  = QQ(5)
      G(9)  = QQ(6)
      THICK = T
      DO 90 I = 1,9
   90 R(I)  = G(I)
      IF (ISETNO .NE. 0) CALL GMMATS (R,3,3,0,ALPHAS,3,1,0,ST)
C
C     ZERO OUT THE KIJ AND SAVE MATRICES
C
      DO 100 I = 1,36
      KWD(I) = 0.D0
  100 KIJ(I) = 0.D0
      DO 110 I = 1,72
  110 SAVE(I) = 0.D0
C
      PT(1) =-0.57735027D0
      PT(2) =-PT(1)
      H(1)  = 1.D0
      H(2)  = 1.D0
      IF (ID1 .EQ. 2) GO TO 120
      PT(1) =-0.77459667D0
      PT(2) = 0.D0
      PT(3) =-PT(1)
      H(1)  = 5.D0/9.D0
      H(2)  = 8.D0/9.D0
      H(3)  = H(1)
C
C     2 OR 3 QUADRATURE POINTS
C
  120 DO 410 III = 1,ID1
      DO 410 JJJ = 1,ID1
C
C     COMPUTE GAUSS POINT STRESSES
C
C
C     COMPUTE DERIVATIVES WITH RESPECT TO XI AND ETA
C     EACH GRID POINT
C
      DO 130 N = 1,4
      DNXI(N)  = .25D0*XI(N)*(1.D0+PT(JJJ)*ETA(N))*
     1           (2.D0*PT(III)*XI(N)+PT(JJJ)*ETA(N))
      DNETA(N) = .25D0*ETA(N)*(1.D0+PT(III)*XI(N))*
     1           (PT(III)*XI(N)+2.D0*PT(JJJ)*ETA(N))
  130 CONTINUE
      DO 140 N = 5,7,2
C
      DNXI(N)  = -PT(III)*(1.D0+PT(JJJ)*ETA(N))
      DNETA(N) = .5D0*(1.D0-PT(III)*PT(III))*ETA(N)
  140 CONTINUE
C
      DO 150 N = 6,8,2
      DNXI(N)  = .5D0*XI(N)*(1.D0-PT(JJJ)*PT(JJJ))
      DNETA(N) = -PT(JJJ)*(1.D0+PT(III)*XI(N))
  150 CONTINUE
C
C     COMPUTE JACOBEAN
C
C           N1XI   N2XI   N3XI   N4XI   N5XI   N6XI   N7XI   N8XI
C     DNC = N1ETA  N2ETA  N3ETA  N4ETA  N5ETA  N6ETA  N7ETA  N8ETA
C
C          X1  Y1
C          X2  Y2
C          X3  Y3
C     XX = X4  Y4
C          X5  Y5
C          X6  Y6
C          X7  Y7
C          X8  Y8
C
      CALL GMMATD (DNC,2,8,0,XX,8,2,0,XJB)
C
C     XJB IS ROW-STORED-IT MUST BE COLUMN-STORED AND DOUBLY DIMENSIONED
C     FOR INVERSION
C
      K = 0
      DO 160 I = 1,2
      DO 160 J = 1,2
      K = K + 1
  160 XXJB(I,J) = XJB(K)
C
C     COMPUTE INVERSE AND DETERMINANT OF JACOBEAN
C
      CALL INVERD (2,XXJB,2,DUMARG,0,DETERM,ISING,IWS)
      IF (ISING .EQ. 2) CALL MESAGE (-30,143,ECPT(1))
      DHH = DETERM*H(III)*H(JJJ)
C
C     COMPUTE DERIVATIVES WITH RESPECT TO X AND Y
C
      K = 0
      DO 170 I = 1,2
      DO 170 J = 1,2
      K = K + 1
  170 XJB(K) = XXJB(I,J)
      CALL GMMATD (XJB,2,2,0,DNC,2,8,0,DNL)
C
C           N1X N2X N3X N4X N5X N6X N7X N8X
C     DNL = N1Y N2Y N3Y N4Y N5Y N6Y N7Y N8Y
C
      DO 180 I = 1,72
  180 BB(I) = 0.
C
C     SET UP INDICATOR FOR GRID POINT TEMPERATURES
C
      IDTEMP = 0
      DO 190 I = 1,8
      IF (TGRID(I) .NE. 0.) GO TO 200
  190 CONTINUE
      GO TO 210
  200 IDTEMP = 1
C
  210 DO 270 N = 1,8
C
      DO 220 I = 1,9
  220 SEMP(I) = 0.
      DO 230 I = 1,6
  230 S(I) = 0.
      S(1) = DNX(N)
      S(4) = DNY(N)
      S(5) = DNY(N)
      S(6) = DNX(N)
C
C     TRANSFORM TO ELEMENT COORDINATES
C
      IF (NECPT(4*N+10) .EQ. 0) GO TO 240
      CALL TRANSS (NECPT(4*N+10),TTB)
      CALL GMMATS (SE1T,2,3,0,TTB,3,3,0,STB)
      GO TO 260
  240 DO 250 I = 1,6
  250 STB(I) = SE1T(I)
  260 CALL GMMATS (S,3,2,0,STB,2,3,0,SEMP(1))
      N3 = 3*N
      BB(N3- 2) = SEMP(1)
      BB(N3- 1) = SEMP(2)
      BB(N3   ) = SEMP(3)
      BB(N3+22) = SEMP(4)
      BB(N3+23) = SEMP(5)
      BB(N3+24) = SEMP(6)
      BB(N3+46) = SEMP(7)
      BB(N3+47) = SEMP(8)
      BB(N3+48) = SEMP(9)
  270 CONTINUE
C
C     BRING IN G MATRIX
C
      CALL GMMATS (R,3,3,0,BB,3,24,0,DB)
C
C     COMPUTE STRESSES
C
      CALL GMMATS (DB,3,24,0,DISP,24,1,0,SIG)
C
C
C     COMPUTE GAUSS POINT  TEMPERATURES
C
      IF (ISETNO .EQ. 0) GO TO 350
      IF (IDTEMP .EQ. 1) GO TO 280
      RGTEMP = ELTEMP - TREF
      GO TO 330
C
C     ALL TEMPERATURES ARE DEFAULT VALUE
C
  280 DO 290 N = 1,4
      DN(N) = .25*(1.+PT(III)*XI(N))*(1.+PT(JJJ)*ETA(N))
     1        *(PT(III)*XI(N)+PT(JJJ)*ETA(N)-1.)
  290 CONTINUE
      DO 300 N = 5,7,2
      DN(N) = .5*(1.-PT(III)*PT(III))*(1.+PT(JJJ)*ETA(N))
  300 CONTINUE
      DO 310 N = 6,8,2
      DN(N) = .5*(1.+PT(III)*XI(N))*(1.-PT(JJJ)*PT(JJJ))
  310 CONTINUE
      GSTEMP = 0.
      DO 320 N = 1,8
      GSTEMP = GSTEMP + DN(N)*TGRID(N)
  320 CONTINUE
      RGTEMP = GSTEMP - TREF
  330 DO 340 I = 1,3
      SIG(I) = SIG(I) - ST(I)*RGTEMP
  340 CONTINUE
C
  350 CONTINUE
C
C     FORM KWD MATRIX
C
      KWD( 1) = SIG(2)
      KWD( 2) =-SIG(3)
      KWD( 7) =-SIG(3)
      KWD( 8) = SIG(1)
      KWD(15) = SIG(1) + SIG(2)
      KWD(16) =-SIG(3)
      KWD(17) = SIG(3)
      KWD(18) = SIG(1) - SIG(2)
      KWD(21) =-SIG(3)
      KWD(27) = SIG(3)
      KWD(33) = SIG(1) - SIG(2)
C
C     FORM CID FOR I = NPVT
C
      DO 360 I = 1,18
  360 CID( I) = 0.D0
      CID( 3) = DNY(KK)
      CID( 6) =-DNX(KK)
      CID( 7) =-.5*DNY(KK)
      CID( 8) = .5*DNX(KK)
      CID(10) = DNX(KK)
      CID(14) = DNY(KK)
      CID(16) =.5*DNY(KK)
      CID(17) =.5*DNX(KK)
C
      CALL GMMATD (CID,6,3,1,KWD,6,6,0,KMULT)
C
C     LOOP FOR THE 8 6X6 PARTITIONS CORRESPONDING TO THE PRESENT
C     PIVOT POINT
C
      DO 400 N = 1,8
C
      DO 370 I = 1,18
  370 CJD(I) = 0.D0
C
      CJD( 3) = DNY(N)
      CJD( 6) =-DNX(N)
      CJD( 7) =-.5*DNY(N)
      CJD( 8) = .5*DNX(N)
      CJD(10) = DNX(N)
      CJD(14) = DNY(N)
      CJD(16) =.5*DNY(N)
      CJD(17) =.5*DNX(N)
C
      CALL GMMATD (KMULT,3,6,0,CJD,6,3,0,TEMPAR(1))
C
C     THROW IN JACOBEAN DETERMINANT AND WEIGHT FACTORS
C
      DO 380 I = 1,9
      TEMPAR(I) = TEMPAR(I)*DHH
  380 CONTINUE
C
C     ADD THE RESULTS OF THIS INTEGRATION TO THE PREVIOUS RESULTS
C
      LL = 9*(N-1)
      DO 390 I = 1,9
      L = LL + I
      SAVE(L) = SAVE(L) + TEMPAR(I)
  390 CONTINUE
C
C     LOOP FOR MORE PARTITIONS
C
  400 CONTINUE
C
C     LOOP FOR MORE GAUSS POINTS
C
  410 CONTINUE
C
C     CHECK ON NECESSITY OF PRE-MULTIPLYING COORDINATE TRANSFORMATIONS
C
      ISUB = 4*KK + 10
      IF (NECPT(ISUB) .EQ. 0) GO TO 420
C
C     ELEMENT TO GLOBAL
C
      CALL TRANSD (NECPT(ISUB),TB)
      CALL GMMATD (E1T,3,3,0,TB,3,3,0,PREMUL)
      GO TO 440
  420 DO 430 I = 1,9
      PREMUL(I) = E1T(I)
  430 CONTINUE
  440 DO 460 N = 1,8
      LL = 9*N - 8
      CALL GMMATD (PREMUL,3,3,1,SAVE(LL),3,3,0,TEMP)
C
C     STORE THE 3 X 3 IN TSAVE
C
      DO 450 I = 1,9
      L = 9*N + I - 9
  450 TSAVE(L) = TEMP(I)
C
  460 CONTINUE
C
C     NOW CHECK ON THE NECESSITY FOR POST-MULTIPLYING TRANSFORMATIONS
C
      DO 500 N = 1,8
      ISUB = 4*N + 10
      LL = 9*N - 8
      IF (NECPT(ISUB) .EQ. 0) GO TO 470
C
C     GLOBAL TO ELEMENT
C
      CALL TRANSD (NECPT(ISUB),TB)
      CALL GMMATD (E1T,3,3,0,TB,3,3,0,PSTMUL)
      GO TO 490
  470 DO 480 I = 1,9
      PSTMUL(I) = E1T(I)
  480 CONTINUE
C
C     POST-MULTIPLY
C
  490 CALL GMMATD (TSAVE(LL),3,3,0,PSTMUL,3,3,0,TEMP)
C
C     FILL OUT THE 6 X 6 PARTITION
C
      KIJ( 1) = TEMP(1)*THICK
      KIJ( 2) = TEMP(2)*THICK
      KIJ( 3) = TEMP(3)*THICK
      KIJ( 7) = TEMP(4)*THICK
      KIJ( 8) = TEMP(5)*THICK
      KIJ( 9) = TEMP(6)*THICK
      KIJ(13) = TEMP(7)*THICK
      KIJ(14) = TEMP(8)*THICK
      KIJ(15) = TEMP(9)*THICK
C
C     INSERT INTO THE OVERALL STIFFNESS MATRIX
C
      CALL DS1B (KIJ,NECPT(N+1))
C
C     LOOP FOR MORE PARTITIONS
C
  500 CONTINUE
C
      RETURN
      END

      SUBROUTINE SMCRTR ( ZR, ZD )
C
C  THIS SUBROUTINE MOVES DATA FROM STRINGS TO OPEN CORE AND PERFORMS      
C  ANY TYPE CONVERSIONS REQUIRED.  KTYPE IS THE TYPE THAT THE
C  DECOMPOSITION IS TO BE DONE.  MTYPE IS THE TYPE OF INPUT DATA ON
C  THE MATRIX TO BE DECOMPOSED.  ISKIP IS THE NUMBER OF TERMS AT THE
C  BEGINNING OF THE STRING TO SKIP OVER.
C      
      REAL              ZR(10)
      DOUBLE PRECISION  XND(10), ZD(10)
      INCLUDE 'SMCOMX.COM'
      COMMON  /ZZZZZZ/  XNS(10)
      EQUIVALENCE       ( XNS, XND )
      EQUIVALENCE       ( MBLK(6), MTERMS ), (MBLK(5), MSTR )
      EQUIVALENCE       ( MBLK(4), MROW   ), (MBLK(2), MTYPE)
      GO TO ( 1000, 2000, 3000, 4000 ), KTYPE
1000  GO TO ( 1010, 1020, 1030, 1040 ), MTYPE
C
C INPUT IS RS AND DECOMPOSITION TO BE DONE IN RS
C
1010  CONTINUE
      ISTR   = MSTR   + ISKIP
      NUM    = MTERMS - ISKIP 
      DO 1015 K = 1, NUM
      ZR( INDEXV + K - 1 ) = XNS( ISTR + K - 1 )
1015  CONTINUE
      INDEXV = INDEXV + NUM           
      GO TO 7000
C
C INPUT IS RD AND DECOMPOSITION TO BE DONE IN RS   
C
1020  CONTINUE
      ISTR   = MSTR   + ISKIP
      NUM    = MTERMS - ISKIP 
      DO 1025 K = 1, NUM
      ZR( INDEXV + K - 1 ) = XND( ISTR + K - 1 )
1025  CONTINUE
      INDEXV  = INDEXV  + NUM
      GO TO 7000
C
C INPUT IS CS AND DECOMPOSITION TO BE DONE IN RS   
C
1030  CONTINUE
      ISTR   = MSTR   + ISKIP*2
      NUM    = MTERMS - ISKIP 
      DO 1035 K = 1, NUM
      ZR( INDEXV + K - 1 ) = XNS( ISTR + (K-1)*2 )
1035  CONTINUE
      INDEXV = INDEXV + NUM           
      GO TO 7000
C
C INPUT IS CD AND DECOMPOSITION TO BE DONE IN RS
C
1040  CONTINUE
      ISTR   = MSTR   + ISKIP*2
      NUM    = MTERMS - ISKIP 
      DO 1045 K = 1, NUM
      ZR( INDEXV + K - 1 ) = XND( ISTR + (K-1)*2 )
1045  CONTINUE
      INDEXV  = INDEXV  + NUM
      GO TO 7000
2000  GO TO ( 2010, 2020, 2030, 2040 ), MTYPE
C
C INPUT IS RS AND DECOMPOSITION TO BE DONE IN RD
C
2010  CONTINUE
      ISTR   = MSTR   + ISKIP
      NUM    = MTERMS - ISKIP 
      DO 2015 K = 1, NUM
      ZD( INDEXVD + K - 1 ) = XNS( ISTR + K - 1 )
2015  CONTINUE
      INDEXV  = INDEXV  + 2*NUM           
      INDEXVD = INDEXVD + NUM
      GO TO 7000
C
C INPUT IS RD AND DECOMPOSITION TO BE DONE IN RD   
C
2020  CONTINUE
      ISTR   = MSTR   + ISKIP
      NUM    = MTERMS - ISKIP 
      DO 2025 K = 1, NUM
      ZD( INDEXVD + K - 1 ) = XND( ISTR + K - 1 )
2025  CONTINUE
      INDEXVD = INDEXVD + NUM               
      INDEXV  = INDEXV  + 2*NUM
      GO TO 7000
C
C INPUT IS CS AND DECOMPOSITION TO BE DONE IN RD   
C
2030  CONTINUE
      ISTR   = MSTR + ISKIP*2
      NUM    = MTERMS - ISKIP 
      DO 2035 K = 1, NUM
      ZD( INDEXVD + K - 1 ) = XNS( ISTR + (K-1)*2 )
2035  CONTINUE
      INDEXV  = INDEXV  + 2*NUM           
      INDEXVD = INDEXVD + NUM
      GO TO 7000
C
C INPUT IS CD AND DECOMPOSITION TO BE DONE IN RD
C
2040  CONTINUE
      ISTR   = MSTR + ISKIP*2
      NUM    = MTERMS - ISKIP 
      DO 2045 K = 1, NUM
      ZD( INDEXVD + K - 1 ) = XND( ISTR + (K-1)*2 )
2045  CONTINUE
      INDEXVD = INDEXVD + NUM           
      INDEXV  = INDEXV  + 2*NUM
      GO TO 7000
3000  GO TO ( 3010, 3020, 3030, 3040 ), MTYPE
C
C INPUT IS RS AND DECOMPOSITION TO BE DONE IN CS
C
3010  CONTINUE
      ISTR   = MSTR   + ISKIP
      NUM    = MTERMS - ISKIP 
      DO 3015 K = 1, NUM
      ZR( INDEXV + (K-1)*2 )   = XNS( ISTR + K - 1 )
      ZR( INDEXV + (K-1)*2+1 ) = 0.0
3015  CONTINUE
      INDEXV = INDEXV + 2*NUM           
      GO TO 7000
C
C INPUT IS RD AND DECOMPOSITION TO BE DONE IN CS   
C
3020  CONTINUE
      ISTR   = MSTR   + ISKIP
      NUM    = MTERMS - ISKIP 
      DO 3025 K = 1, NUM
      ZR( INDEXV + (K-1)*2 )     = XND( ISTR + K - 1 )  
      ZR( INDEXV + (K-1)*2 + 1 ) = 0.0D0  
3025  CONTINUE
      INDEXV  = INDEXV  + 2*NUM
      GO TO 7000
C
C INPUT IS CS AND DECOMPOSITION TO BE DONE IN CS   
C
3030  CONTINUE
      ISTR   = MSTR + ISKIP*2
      NUM    = ( MTERMS - ISKIP ) * 2
      DO 3035 K = 1, NUM
      ZR( INDEXV + K - 1 ) = XNS( ISTR + K - 1 )
3035  CONTINUE
      INDEXV = INDEXV + NUM           
      GO TO 7000
C
C INPUT IS CD AND DECOMPOSITION TO BE DONE IN CS
C
3040  CONTINUE
      ISTR   = MSTR + ISKIP*2
      NUM    = ( MTERMS - ISKIP ) * 2
      DO 3045 K = 1, NUM
      ZR( INDEXV + K - 1 ) = XND( ISTR + K - 1 )
3045  CONTINUE
      INDEXV  = INDEXV  + NUM
      GO TO 7000
4000  GO TO ( 4010, 4020, 4030, 4040 ), MTYPE
C
C INPUT IS RS AND DECOMPOSITION TO BE DONE IN CD
C
4010  CONTINUE
      ISTR   = MSTR   + ISKIP
      NUM    = MTERMS - ISKIP 
      DO 4015 K = 1, NUM
      ZD( INDEXVD + (K-1)*2 )   = XNS( ISTR + K - 1 )
      ZD( INDEXVD + (K-1)*2+1 ) = 0.0
4015  CONTINUE
      INDEXV = INDEXV   + 4*NUM           
      INDEXVD = INDEXVD + 2*NUM
      GO TO 7000
C
C INPUT IS RD AND DECOMPOSITION TO BE DONE IN CD   
C
4020  CONTINUE
      ISTR   = MSTR   + ISKIP
      NUM    = MTERMS - ISKIP 
      DO 4025 K = 1, NUM
      ZD( INDEXVD + (K-1)*2 )     = XND( ISTR + K - 1 )  
      ZD( INDEXVD + (K-1)*2 + 1 ) = 0.0D0  
4025  CONTINUE
      INDEXV  = INDEXV  + 4*NUM
      INDEXVD = INDEXVD + 2*NUM
      GO TO 7000
C
C INPUT IS CS AND DECOMPOSITION TO BE DONE IN CD   
C
4030  CONTINUE
      ISTR   = MSTR + ISKIP*2
      NUM    = ( MTERMS - ISKIP ) * 2
      DO 4035 K = 1, NUM
      ZD( INDEXVD + K - 1 ) = XNS( ISTR + K - 1 )
4035  CONTINUE
      INDEXV  = INDEXV + 2*NUM           
      INDEXVD = INDEXVD + NUM
      GO TO 7000
C
C INPUT IS CD AND DECOMPOSITION TO BE DONE IN CD
C
4040  CONTINUE
      ISTR   = MSTR + ISKIP*2
      NUM    = ( MTERMS - ISKIP ) * 2
      DO 4045 K = 1, NUM
      ZD( INDEXVD + K - 1 ) = XND( ISTR + K - 1 )
4045  CONTINUE
      INDEXV  = INDEXV  + 2*NUM
      INDEXVD = INDEXVD + NUM
      GO TO 7000
7000  RETURN
      END

      SUBROUTINE MFLUD3
C*****
C     THIS ROUTINE GENERATES THE PSUEDO   MASS    MATRIX TERMS
C     FOR THE TRIANGULAR FLUID ELEMENT
C*****
C     THE ECPT DATA IS THE FOLLOWING
C
C         FIELD         SYMBOL
C           1             ID
C           2             SIL1
C           3             SIL2
C           4             SIL3
C           5             RHO
C           6             BULK
C           7             N
C           8             CSF
C           9             R1
C           10            Z1
C           11            -
C           12            CSF
C           13            R2
C           14            Z2
C           15            -
C           16            CSF
C           17            R3
C           18            Z3
C           19            -
C           20            -
C****
      DOUBLE PRECISION        R         ,Z        ,ARE2
     1                        ,PIAB     ,EMASS
C*****
      INTEGER NECPT(100)
      COMMON/SMA2CL/ DUM(2),NPVT
      COMMON/SMA2IO/ DUM1(10),IFMGG
      COMMON  /SMA2ET/ ECPT(100)
      COMMON/SMA2DP/          R(3)      ,Z(3)     ,ARE2
     1                       ,PIAB      ,EMASS    ,JP
     2                       ,IR        ,JPVT     ,IGRID
      EQUIVALENCE        (ECPT(1),NECPT(1))
C*****
C*****
C
      IF(ECPT(6).EQ. 0.0) RETURN
C*****
C     STORE THE POINT LOCATIONS AND FIND THE PIVOT POINT
C*****
      JP =0
      DO 20 I=1,3
      IR =  9 + 4*(I-1)
      R(I)  = ECPT(IR)
      IF(ECPT(IR).LE.0.0) GO TO 1000
      Z(I)  = ECPT(IR+1)
      IF( NPVT .NE. NECPT(I+1)) GO TO 20
      JP = I
   20 CONTINUE
      IF( JP .EQ.0) GO TO 1000
      ARE2=DABS((R(2) -R(1))*(Z(3)-Z(1)) - (R(3)-R(1))*(Z(2)-Z(1)) )
      PIAB = 2.617994D-2 *ARE2 / DBLE( ECPT(6) )
      IF (NECPT(7) .EQ. 0) PIAB = PIAB*2.0D0
      JPVT = NPVT
      DO 50  I = 1,3
      IGRID = NECPT(I+1)
      EMASS = PIAB*( R(1)+R(2)+R(3) +R(JP) +R(I))
      IF (I .EQ. JP) EMASS = EMASS*2.0D0
      CALL SMA2B ( EMASS, IGRID,JPVT,IFMGG,0.0D0)
   50 CONTINUE
 1000 RETURN
      END

      SUBROUTINE PARTN3 (FILE,SIZE,ONES,IZ,NZ,HERE,BUF,CORE)
CDIR$ INTEGER=64
C
C     CDIR$ IS CRAY COMPILER DIRECTIVE. 64-BIT INTEGER IS USED LOCALLY
C     DO LOOP 10 MAY NOT WORK PROPERLY WITH 48 BIT INTEGER
C
C     PARTN3 CALLED BY PARTN1 AND MERGE1 (VIA PARTN2) BUILDS A BIT
C     STRING AT Z(IZ) THROUGH Z(NZ) AND CONTAINING ONE-BITS ONLY IN
C     THE RESPECTIVE POSITIONS OCCUPIED BY NON-ZERO ELEMENTS IN THE
C     COLUMN VECTOR WHICH IS STORED ON FILE.
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        LSHIFT,RSHIFT,ORF
      LOGICAL         HERE,PASS
      DIMENSION       BUF(4),MCB(7),TRL(6),BIT(64),SUBR(2)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25,SWM*27
      COMMON /XMSSG / UFM,UWM,UIM,SFM,SWM
      COMMON /NAMES / RD,RDREW,WRT,WRTREW,CLSREW,CLS
      COMMON /SYSTEM/ SYSBUF,OUTPT,XXX(37),NBPW
      COMMON /ZNTPKX/ ELEM(4),ROW,EOL
      COMMON /ZZZZZZ/ Z(1)
      COMMON /BLANK / SYM,TYPE,FORM(4),CPCOL,RPCOL,IREQCL
      EQUIVALENCE     (TRL(1),MCB(2))
      DATA    SUBR  / 4HPART,4HN3  /
      DATA    PASS  / .FALSE.      /
C
C     SET UP TABLE OF BITS ON FIRST PASS THROUGH THIS ROUTINE.
C
      IF (PASS) GO TO 20
      PASS = .TRUE.
      J = NBPW - 1
      K = LSHIFT(1,J)
      DO 10 I = 1,NBPW
      BIT(I) = K
      K = RSHIFT(K,1)
   10 CONTINUE
C
   20 CALL OPEN (*130,FILE,BUF,RDREW)
      HERE   = .TRUE.
      MCB(1) = FILE
      CALL RDTRL (MCB)
C
C     NUMBER OF WORDS IN COLUMN INCLUDING ZEROS
C
      SIZE = TRL(2)
      IF (IREQCL .EQ. 0) GO TO 37
      IF (IREQCL.GT.0 .AND. IREQCL.LE.TRL(1)) GO TO 38
      IF (TRL(1) .LE. 0) GO TO 37
      WRITE  (OUTPT,30) SWM,FILE,TRL(1),IREQCL
   30 FORMAT (A27,' 2173, PARTITIONING VECTOR FILE',I5,' CONTAINS',I10,
     1       ' COLUMNS.', /5X,' THE FIRST COLUMN WILL BE USED, NOT THE',
     2       ' REQUESTED COLUMN',I10)
   37 IREQCL = 1
   38 CALL SKPREC (FILE,IREQCL)
      IF (TRL(4).EQ.1 .OR. TRL(4).EQ.2) GO TO 60
      WRITE  (OUTPT,50) SWM,FILE
   50 FORMAT (A27,' 2174, PARTITIONING VECTOR ON FILE',I5,
     1       ' IS NOT REAL-SINGLE OR REAL-DOUBLE PRECISION.')
C
C     ZERO THE BIT STRING
C
   60 NZ = IZ + (SIZE-1)/NBPW
      IF (NZ .GT. CORE) CALL MESAGE (-8,0,SUBR)
      DO 70 I = IZ,NZ
      Z(I) = 0
   70 CONTINUE
C
C     SET UP TO UNPACK THE COLUMN
C
      ONES = 0
      EOL  = 0
      CALL INTPK (*120,FILE,0,1,0)
      GO TO 90
C
C     UNPACK THE ELEMENTS AND TURN ON BITS IN THE BIT STRING.  MAINTAIN
C     COUNT OF BITS IN -ONES-.
C
   80 IF (EOL) 90,90,120
   90 CALL ZNTPKI
      IF (ROW .GT. SIZE) GO TO 100
      K     = ROW - 1
      ZWORD = K/NBPW + IZ
      ZBIT  = MOD(K,NBPW) + 1
      Z(ZWORD) = ORF(Z(ZWORD),BIT(ZBIT))
      ONES  = ONES + 1
      GO TO 80
C
C     ELEMENT OF COLUMN LIES OUT OF RANGE INDICATED BY TRAILER
C
  100 WRITE  (OUTPT,110) SFM,FILE
  110 FORMAT (A25,' 2175, THE ROW POSITION OF AN ELEMENT OF A COLUMN ',
     1       'ON FILE',I5, /5X,'IS GREATER THAN NUMBER OF ROWS ',
     2       'SPECIFIED BY TRAILER.')
      GO TO 160
C
C     BIT STRING IS COMPLETE.
C
  120 CALL CLOSE (FILE,CLSREW)
      RETURN
C
C     FILE IS PURGED
C
  130 SIZE = 0
      ONES = 0
      HERE = .FALSE.
      RETURN
C
C     FATAL ERROR
C
  160 CALL CLOSE  (FILE,CLSREW)
      CALL MESAGE (-61,0,SUBR)
      RETURN
      END

      SUBROUTINE DETDET(DETA,IPOWR1,P,SML1,OLDD,IOLD)
C
      DIMENSION IPOWR1(1)
C
      DOUBLE PRECISION DETA(1),P(1),PROD,DET,CORE,SML2,OLDD,DET1,SML21
C
      DOUBLE PRECISION MINDD
C
      INTEGER FA,FL,FC,SR1,SR2,SR3,FA1,FL1,FC1,SR11,SR21
      INTEGER OPTION,SDET
      INTEGER OTPE,B,C,R,SR31
C
      COMMON /MACHIN/MACH
      COMMON /REGEAN/IM(21),IA,IN(4),LC,IN1(2),MZ,IN2(2),RMINR,IN3(2),
     1               NEVM,IL1,IL2,NFOUND,LAMA,IBUCK,NSYM
      COMMON /DETMX /ISEW(33),IPAAV,ISEW1(5),NDCMP,ISEW2(20),NPOLE
     1              ,ISING
      COMMON /DCOMPX/FA(7),FL(7),FC(7),SR1,SR2,SR3,DET,IPOWR,NZ
     1              ,SML2
      COMMON /ZZZZZZ /CORE(1)
      COMMON /REIGKR/OPTION
      COMMON /SFACT /FA1(7)   ,FC1(7)   ,FL1(7)   ,SR11     ,SR21
     1              ,NZ1      ,DET1(2)  ,IPOWRA   ,SR31     ,MINDD
     3              ,ICHOL    ,B        ,C        ,R        ,SML21
      COMMON /SYSTEM/KSYSTM(65)
C
      EQUIVALENCE ( KSYSTM( 2) , OTPE   )
C
      DATA SDET /4HSDET/
C
C ----------------------------------------------------------------------
C
      CALL SSWTCH (7, IPRT)
      ISAVE = IN(4)
      IN(4) = IL2
      IL2 = ISAVE
      NZZ = (KORSZ(CORE)/2)*2 -LC
      NDCMP = NDCMP+1
      IF(OPTION .EQ. SDET) GO TO 5
      FA(1)=IA
      CALL RDTRL(FA)
C
C     SET UP FOR UNSYMMETRIC
C
      NZ = NZZ
C
C
C     PUT IN TO PREVENT REWRITE
C
C     FA1(1) = -FA1(1)
C
CWKBD 10/94 SPR94011 FA(1) = -FA(1)
      FL(1)=IN(1)
      FC(1)=IN(2)
      DO 10 I=2,5
      FL(I)=FA(I)
   10 FC(I)=FA(I)
      SR1 = IN(3)
      SR2 = IN(4)
      SR3 = IL1
      CALL DECOMP(*60,CORE,CORE,CORE)
CWKBD 10/94 SPR94011     FC(1) = SR2
      CALL WRTTRL(FC)
      GO TO 14
C
C     SET UP FOR SYMMETRIC DECOMPOSITION
C
    5 FA1(1) = IA
      CALL RDTRL(FA1)
      FL1(1) = IN(1)
      FC1(1) = IN(4)
      ICHOL = 0
      IF(NDCMP .EQ. 1) B=0
      NZ1 = NZZ
      DO 6 I = 2,5
      FL1(I) = FA1(I)
      FC1(I) = FA1(I)
    6 CONTINUE
      SR11= IN(3)
      SR21 = IN(2)
      SR31 = IL1
      IF(MACH.EQ.4 .OR. MACH.EQ.12) FL1(5) = 1
      CALL SDCOMP(*60,CORE,CORE,CORE)
      FC1(5) = FL1(5)
      CALL WRTTRL(FC1)
      IPOWR=IPOWRA
      DET = DET1(1)
      SML1= SML21
   14 PROD = 1.0D0
      IF(IPRT .EQ. 0) GO TO 15
      WRITE(OTPE,99) P(1),DET,IPOWR
   99 FORMAT(2D16.7,I8)
   15 CONTINUE
      IPROD = 0
      IF( MZ  .EQ. 0) GO TO 12
      II =  IABS(MZ)
      DO 11  I=1,II
      PROD = PROD* P(1)
      CALL DETM6(PROD,IPROD)
   11 CONTINUE
C
C     TAKE OUT  POLE AT  RMINR
C
   12 IF (NPOLE .EQ. 0) GO TO 20
      DO  13  I = 1,NPOLE
      PROD = PROD*(P(1)- RMINR)
      CALL DETM6( PROD,IPROD)
   13 CONTINUE
   20 IF(NFOUND .EQ. 0) GO TO 40
      DO 30 I=1,NFOUND
      II = IPAAV +I
      IF(P(1).EQ. CORE(II)) GO TO 70
      PROD = PROD*(P(1)-CORE(II))
      CALL DETM6(PROD,IPROD)
   30 CONTINUE
   40 DETA(1) = DET/PROD
      SML1= SML2
      IPOWR1(1)= IPOWR-IPROD
      CALL DETM6(DETA(1),IPOWR1(1))
   50 IF(IPRT .EQ. 0) GO TO 51
      WRITE(OTPE,99) P(1),DETA(1),IPOWR1(1)
   51 RETURN
   60 DETA(1) = 0.0D0
      IPOWR1(1)=1
      SML1 = 1.0E-8
      ISING = ISING+1
      ISAVE = IN(4)
      IN(4) = IL2
      IL2 = ISAVE
      GO TO 50
C
C     SET DK = DK-1
C
   70 DETA(1) = OLDD
      SML1 = SML2
      IPOWR1(1) = IOLD
      GO TO 50
      END

      SUBROUTINE IFP1D (MSNO)
C
C     MESSAGE WRITER FOR IFP1
C
      INTEGER         AMSNO
      CHARACTER       UFM*23,UWM*25
      COMMON /XMSSG / UFM,UWM
      COMMON /SYSTEM/ D,NOUT,NOGO,DD(5),NLPP,DDD(2),LINE
      DATA    MAXMSG/ 646   /
C
      AMSNO = IABS(MSNO)
      IF (MSNO  .LT. 0) NOGO = 1
      IF (AMSNO .GT. MAXMSG) GO TO 40
      IF (AMSNO .EQ. 612) CALL PAGE1
      IF (MSNO .LE. 0) WRITE (NOUT,10) UFM,AMSNO
      IF (MSNO .GT. 0) WRITE (NOUT,20) UWM,AMSNO
   10 FORMAT (A23,I7)
   20 FORMAT (A25,I5)
      IF (AMSNO.GE.634 .AND. AMSNO.LE.644) WRITE (NOUT,30)
   30 FORMAT (1H+,37X,'(FROM SCAN)')
      IWHER = AMSNO - 600
      GO TO ( 60, 80,100,120,140,160,180,200,220,240,
     1       260,280,400,420,440,460,480,500, 40, 40,
     2        40,520,540,560,580,600,620,640,660,680,
     3       700,720,740,760,780,800,820,840,860,880,
     4       900,920,940,960,980,1000), IWHER
C
C     619 - 621 ARE DEFINED IN IFP1S
C
   40 WRITE  (NOUT,50) AMSNO
   50 FORMAT (' NO TEXT AVAILABLE FOR MESSAGE',I6)
      GO TO  1100
C
   60 WRITE  (NOUT,70)
   70 FORMAT (' THE KEYWORD ON THE ABOVE CARD TYPE IS ILLEGAL OR MISS',
     1        'PELLED.  SEE THE FOLLOWING LIST FOR LEGAL KEYWORDS.')
      GO TO  1100
   80 WRITE  (NOUT,90)
   90 FORMAT (' TWO OR MORE OF THE ABOVE CARD TYPES DETECTED WHERE ',
     1        'ONLY ONE IS LEGAL.' ,/,' THE LAST FOUND WILL BE USED.')
      LINE = LINE + 1
      GO TO  1100
  100 WRITE  (NOUT,110)
  110 FORMAT (' THE ABOVE CARD DOES NOT END PROPERLY. COMMENTS SHOULD',
     1        'BE PRECEEDED', /,' BY A DOLLAR SIGN.')
      LINE = LINE + 1
      GO TO  1100
  120 WRITE  (NOUT,130)
  130 FORMAT (' THE ABOVE CARD HAS A NON-INTEGER IN AN INTEGER FIELD.')
      GO TO  1100
  140 WRITE  (NOUT,150)
  150 FORMAT (' A SYMSEQ OR SUBSEQ CARD APPEARS WITHOUT A SYMCOM OR ',
     1        'SUBCOM CARD.')
      GO TO  1100
  160 WRITE  (NOUT,170)
  170 FORMAT (' A REQUEST FOR TEMPERATURE DEPENDENT MATERIALS OCCURS AT'
     1,       ' THE SUBCASE LEVEL.', /,' ONLY ONE ALLOWED PER PROBLEM.')
      GO TO  1100
  180 WRITE  (NOUT,190)
  190 FORMAT (' A REPCASE CARD MUST BE PROCEEDED BY A SUBCASE CARD')
      GO TO  1100
  200 WRITE  (NOUT,210)
  210 FORMAT (' THE SET ID SPECIFIED ON THE ABOVE CARD MUST BE DEFINED',
     1        ' PRIOR TO THIS CARD.')
      GO TO  1100
  220 WRITE  (NOUT,230)
  230 FORMAT (' SUBCASE DELIMITER CARDS MUST HAVE A UNIQUE IDENTIFYING',
     1        ' INTEGER.')
      GO TO  1100
  240 WRITE  (NOUT,250)
  250 FORMAT (' NO SET ID SPECIFIED.  ALL WILL BE ASSUMED.')
      GO TO  1100
  260 WRITE  (NOUT,270)
  270 FORMAT (' TEN CARDS HAVE ILLEGAL KEY WORDS. NASTRAN ASSUMES BEGIN'
     1,       ' BULK CARD', /,' IS MISSING. IT WILL NOW PROCESS YOUR ',
     2        'BULK DATA.')
      LINE = LINE + 1
      GO TO  1100
C
C     THE LIST OF CASE CONTROL CARDS IS FORMATTED FOR SHORT PAPER
C
  280 WRITE  (NOUT,290)
  290 FORMAT (///,10(1H-),' THE FOLLOWING IS A LIST OF VALID CASE ',
     1        'CONTROL KEY WORDS EXCEPT FOR THE PLOTTER PACKAGES.',
     2        10(1H-), //6X,'KEYWORD',20X,'MEANING',/)
      WRITE  (NOUT,300)
  300 FORMAT (5X,'ACCELERATION',12X,
     1       'OUTPUT REQUEST FOR ACCELERATION VECTORS',
     2       /6X,'AEROFORCE',15X,
     3       'OUTPUT REQUEST FOR AERODYNAMIC FORCES',
     4       /6X,'AXISYMMETRIC',12X,
     5       'AXISYMMETRIC CASE SELECTION (SINE OR COSINE)',
     6       /6X,'B2PP',20X,
     7       'SELECTION OF STRUCTURAL DAMPING OR THERMAL CAPACITANCE ',
     8       'MATRICES',
     9       /6X,'CMETHOD',17X,
     O       'COMPLEX EIGENVALUE METHOD SELECTION',
     1       /6X,'DEFORM',18X,
     2       'REQUEST FOR ENFORCED ELEMENT DEFORMATION',
     3       /6X,'DISPLACEMENT',12X,
     4       'OUTPUT REQUEST FOR DISPLACEMENT VECTORS',
     5       /6X,'DLOAD',19X,
     6       'DYNAMIC LOAD SELECTION')
      WRITE  (NOUT,310)
  310 FORMAT (6X,'DSCOEFFICIENT',11X,
     1       'DIFFERENTIAL STIFFNESS COEFFICIENT SET SELECTION',
     2       /6X,'ECHO',20X,
     3       'BULK DATA ECHO SELECTOR (SORT,UNSORT,BOTH,NONE,PUNCH)',
     4       /6X,'ELFORCE',17X,
     5       'OUTPUT REQUEST FOR ELEMENT FORCES',
     6       /6X,'ELSTRESS',16X,
     7       'OUTPUT REQUEST FOR ELEMENT STRESSES',
     8       /6X,'ESE',21X,
     9       'REQUEST FOR ELEMENT STRAIN ENERGY OUTPUT',
     O       /6X,'FMETHOD',17X,
     1       'REQUEST FOR AEROELASTIC FLUTTER METHOD',
     2       /6X,'FORCE',18X,
     3       'OUTPUT REQUEST FOR ELEMENT FORCES',
     4       /6X,'FREQUENCY',15X,
     5       'FREQUENCY SET SELECTION')
      WRITE  (NOUT,320)
  320 FORMAT (6X,'GPFORCE',17X,
     1       'REQUEST FOR GRID POINT FORCE BALANCE OUTPUT',
     2       /6X,'GUST',20X,
     3       'AEROELASTIC RESPONSE ANALYSIS INPUT LOADING CONDITION',
     4       /6X,'HARMONICS',15X,
     5       'HARMONICS TO BE PRINTED FOR AXISYMMETRIC SHELL PROBLEM',
     6       /6X,'IC',22X,
     7       'INITIAL CONDITIONS FOR DIRECT TRANSIENT PROBLEM',
     8       /6X,'K2PP',20X,
     9       'SELECTION OF STRUCT-L STIFFNESS OR THERMAL CONDUCTANCE ',
     O       'MATRICES',
     1       /6X,'LABEL',19X,
     2       'DEFINES PRINTER, PLOTTER AND PUNCH OUTPUT LABEL',
     3       /6X,'LINE',20X,
     4       'NUMBER OF LINES PER PAGE (DFLT = 50 -CDC,IBM, 45 -UNIVAC)'
     5,      /6X,'LOAD',20X,
     6       'STATIC ANALYSIS EXTERNAL LOAD SELECTION OR HEAT POWER/',
     7       'FLUX')
      WRITE  (NOUT,330)
  330 FORMAT (6X,'M2PP',20X,
     1       'SELECTION OF INPUT MASS MATRICES VIA DMIG CARDS',
     2       /6X,'MAXLINES',16X,
     3       'MAXIMUM NUMBER OF PRINTER LINES (DEFAULT = 20000)',
     4       /6X,'METHOD',18X,
     5       'REAL EIGENVALUE METHOD SELECTION',
     6       /6X,'MODES',19X,
     7       'DUPLICATE CASE CONTROL THIS MANY TIMES',
     8       /6X,'MPC',21X,
     9       'SELECTS MULTI-POINT CONSTRAINTS OR HEAT TRANSFER ',
     O       'BOUNDARY TEMPS',
     1       /6X,'MPCFORCE',16X,
     2       'OUTPUT REQUEST FOR MULTI-POINT FORCES OF CONSTRAINT',
     3       /6X,'NCHECK',18X,
     4       'OUTPUT REQUEST FOR FORCE AND STRESS PRECISION',
     5       /6X,'NLLOAD',18X,
     6       'OUTPUT REQUEST FOR NON-LINEAR LOADS FOR ANALYSIS SET')
C
      CALL PAGE1
      WRITE  (NOUT,340)
  340 FORMAT (//6X,7HKEYWORD,20X,7HMEANING,
     1       //6X,'NONLINEAR',15X,
     2       'NON-LINEAR LOAD SET FOR TRANSIENT PROBLEMS',
     3       /6X,'OFREQUENCY',14X,
     4       'SELECTS OUTPUT FREQUENCIES OR -IM- PART OF COMPLEX ',
     5       'EIGENVALUES',
     6       /6X,'OLOAD',19X,
     7       'OUTPUT REQUEST FOR APPLIED LOAD',
     8       /6X,'OTIME',19X,
     9       'REQUEST FOR SELECTED OUTPUT TIMES',
     O       /6X,'OUTPUT',18X,
     1       'OUTPUT PACKET DELIMITER (THIS CARD IS OPTIONAL)',
     2       /6X,'OUTPUT(PLOT)',12X,
     3       'STRUCTURE PLOTTER OUTPUT PACKET DELIMITER',
     4       /6X,'OUTPUT(XYOUT)',11X,
     5       'XY OUTPUT PACKET DELIMITER (PLOTTER, PRINTER AND PUNCH)',
     6       /6X,'OUTPUT(XYPLOT)',10X,
     7       'EQUIVALENT TO OUTPUT(XYOUT)')
      WRITE  (NOUT,350)
  350 FORMAT (6X,'PLCOEFFICIENT',11X,
     1       'PIECEWISE LINEAR COEFFICIENT SET SELECTION',
     2       /6X,'PLOTID',18X,
     3       'DEFINES PLOTTER OUTPUT HEADER FRAME TITLE',
     4       /6X,'PRESSURE',16X,
     5       'OUTPUT REQUEST FOR HYDROELASTIC PRESSURE',
     6       /6X,'RANDOM',18X,
     7       'RANDOM ANALYSIS PSDL AND RANDT SET SELECTION',
     8       /6X,'REPCASE',17X,
     9       'REPEAT THE PRECEDING CASE AGAIN',
     O       /6X,'SACCELERATION',11X,
     1       'OUTPUT REQUEST FOR SOLUTION SET ACCELERATION VECTORS',
     2       /6X,'SCAN',20X,
     3       'SCAN AND OUTPUT STRESSES OR FORCES FOR PREDETERMINED ',
     4       'CRITERIA',
     5       /6X,'SDAMPING',16X,
     6       'MODAL FORMULATION STRUCTURAL DAMPING TABULAR FUNCTION ',
     7       'SELECTION',
     8       /6X,'SDISPLACEMENT',11X,
     9       'OUTPUT REQUEST FOR SOLUTION SET DISPLACEMENT VECTORS')
      WRITE  (NOUT,360)
  360 FORMAT (6X,'SET',21X,
     1       'DEFINES OUTPUT SET LIST',
     2       /6X,'SPC',21X,
     3       'SELECTS SINGLE POINT CONSTRAINTS OR HEAT TRANSFER ',
     4       'BOUNDARY TEMP',
     5       /6X,'SPCFORCE',16X,
     6       'REQUESTS SINGLE POINT CONSTRAINT FORCES OR THERMAL POWER',
     7       /6X,'STRAIN',18X,
     8       'OUTPUT REQUEST FOR ELEMENT STRAINS',
     9       /6X,'STRESS',18X,
     O       'OUTPUT REQUEST FOR ELEMENT STRESSES',
     1       /6X,'SUBCASE',17X,
     2       'SUBCASE DELIMITER',
     3       /6X,'SUBCOM',18X,
     4       'THIS CASE IS A LINEAR COMBINATION OF THE PRECEDING ',
     5       'SUBCASES',
     6       /6X,'SUBSEQ',18X,
     7       'DEFINES COEFFICIENTS FOR LINEAR SUBCASE COMBINATION')
      WRITE  (NOUT,370)
  370 FORMAT (6X,'SUBTITLE',16X,
     1       'DEFINES PRINTER, PLOTTER AND PUNCH OUTPUT SUBTITLE',
     2       /6X,'SVECTOR',17X,
     3       'OUTPUT REQUEST FOR SOLUTION SET DISPLACEMENT VECTORS',
     4       /6X,'SVELOCITY',15X,
     5       'OUTPUT REQUEST FOR SOLUTION SET VELOCITY VECTORS',
     6       /6X,'SYM',21X,
     7       'SYMMETRY SUBCASE DELIMITER',
     8       /6X,'SYMCOM',18X,
     9       'THIS CASE IS A LINEAR COMBINATION OF THE PRECEDING SYM ',
     O       'CASES',
     1       /6X,'SYMSEQ',18X,
     2       'DEFINES COEFFICIENTS FOR LINEAR SYM COMBINATION (DEFAULT',
     3       ' = 1.0)',
     4       /6X,'TEMPERATURE(BOTH)',7X,
     5       'THERMAL SET SELECTION FOR BOTH LOAD AND MATERIAL DATA',
     6       /6X,'TEMPERATURE(LOAD)',7X,
     7       'THERMAL LOAD TEMPERATURE SET SELECTION')
C
      CALL PAGE1
      WRITE  (NOUT,380)
  380 FORMAT (//6X,'KEYWORD',20X,'MEANING',
     1       /6X,'TEMPERATURE(MATERIAL)',3X,
     2       'SELECTS THERMAL DEPENDENT MATERIALS OR TEMPERATURE ',
     3       'ESTIMATES',
     4       /6X,'TFL',21X,
     5       'TRANSFER FUNCTION SET SELECTION',
     6       /6X,'THERMAL',17X,
     7       'OUTPUT REQUEST FOR TEMPERATURES IN HEAT TRANSFER ANALYSIS'
     8,      /6X,'TITLE',19X,
     9       'DEFINES PRINTER, PLOTTER AND PUNCH OUTPUT TITLE',
     O       /6X,'TSTEP',19X,
     1       'TIME STEP SET SELECTION FOR TRANSIENT PROBLEMS',
     2       /6X,'VECTOR',18X,
     3       'OUTPUT REQUEST FOR DISPLACEMENT VECTORS',
     4       /6X,'VELOCITY',16X,
     5       'OUTPUT REQUEST FOR VELOCITY VECTORS',
     6       /6X,'BEGIN BULK',14X,
     7       'THIS CARD MARKS THE END OF THE CASE CONTROL DECK')
      GO TO 1110
C
  400 WRITE  (NOUT,410)
  410 FORMAT (' THE ABOVE SET CONTAINS -EXCEPT- WHICH IS NOT PRECEDED ',
     1        'BY -THRU-.')
      GO TO  1100
  420 WRITE  (NOUT,430)
  430 FORMAT (' THE ABOVE SET IS INCORRECTLY SPECIFIED.  CHECK FORMAT ',
     1        'ON THIS OR PREVIOUS CARD.')
      GO TO  1100
  440 WRITE  (NOUT,450)
  450 FORMAT (' AN IMPROPER OR NO NAME GIVEN TO THE ABOVE SET.')
      GO TO  1100
  460 WRITE  (NOUT,470)
  470 FORMAT (' ELEMENT IN THRU RANGE LIES IN RANGE OF PREVIOUS THRU ',
     1        'OR EXCEPT.  MISSING ELEMENT OR INCORRECT USE OF THRU.')
      GO TO  1100
  480 WRITE  (NOUT,490)
  490 FORMAT (' INCORRECT OR MISSING VALUE ON CASE CONTROL CARD. ',
     1        ' CHECK FOR CORRECT CARD FORMAT.')
      GO TO  1100
  500 WRITE  (NOUT,510)
  510 FORMAT (' PLOT OUTPUT IS REQUESTED BUT THE PROPER PLOT TAPE IS ',
     1        'NOT A PHYSICAL TAPE')
      GO TO  1100
C
  520 WRITE  (NOUT,530)
  530 FORMAT (' REAL VALUES NOT ALLOWED IN A THRU SEQUENCE.')
      GO TO  1100
  540 WRITE  (NOUT,550)
  550 FORMAT (' UNEXPECTED END-OF-RECORD ON CASE CONTROL CARD.  CHECK ',
     1        'FOR CORRECT CARD FORMAT.')
      GO TO  1100
  560 WRITE  (NOUT,570)
  570 FORMAT (' BEGIN BULK CARD NOT FOUND.')
      GO TO  1100
  580 WRITE  (NOUT,590)
  590 FORMAT (' TOO LARGE ID ON PRECEDING SUBCASE TYPE CARD. ALL ID-S ',
     1        'MUST BE LESS THAN 99,999,999.')
      GO TO  1100
  600 WRITE  (NOUT,610)
  610 FORMAT (' VALUES IN EXCEPT MUST BE SPECIFIED IN ASCENDING ORDER')
      GO TO  1100
  620 WRITE  (NOUT,630)
  630 FORMAT (' THE ABOVE SUBCASE HAS BOTH A STATIC LOAD AND A REAL ',
     1        'EIGENVALUE METHOD SELECTION - REMOVE ONE.')
      GO TO  1100
  640 WRITE  (NOUT,650)
  650 FORMAT (/,' THERMAL, DEFORMATION, AND EXTERNAL LOADS CANNOT HAVE',
     1        ' THE SAME SET IDENTIFICATION NUMBER.')
      GO TO  1100
  660 WRITE  (NOUT,670)
  670 FORMAT (' ECHO CARD HAS REPEATED OR UNRECOGNIZABLE SPECIFICATION',
     1        ' DATA - ',/11X,'REPEATED SPECIFICATIONS WILL BE IGNORED',
     2        /11X,'UNRECOGNIZABLE SPECIFICATIONS WILL BE TREATED AS ',
     3        'SORT.')
      LINE = LINE + 2
      GO TO  1100
  680 WRITE  (NOUT,690)
  690 FORMAT (' ECHO CARD WITH -NONE- SPECIFICATION HAS ADDITIONAL ',
     1        'SPECIFICATIONS WHICH WILL BE IGNORED.')
      GO TO  1100
  700 WRITE  (NOUT,710)
  710 FORMAT (' PLOT AND/OR SET COMMAND CARD MISSING FROM STRUCTURE ',
     1        'PLOTTER OUTPUT PACKAGE.')
      GO TO  1100
  720 WRITE  (NOUT,730)
  730 FORMAT (' XYPLOT COMMAND CARDS FOUND IN STRUCTURE PLOTTER OUTPUT',
     1        ' PACKAGE.')
      GO TO  1100
  740 WRITE  (NOUT,750)
  750 FORMAT (' SUBCASE LIMIT OF 360 EXCEEDED')
      GO TO  1100
C
C     MESSAGES 634 - 644 (760 THRU 960) ARE CALLED ONLY BY SCAN
C
  760 WRITE  (NOUT,770)
  770 FORMAT (5X,'KEYWORD INSIDE BRACKETS IS ILLEGAL OR MIS-SPELLED')
      GO TO  1100
  780 WRITE  (NOUT,790)
  790 FORMAT (5X,'ONLY ONE SET-ID ALLOWED')
      GO TO  1100
  800 WRITE  (NOUT,810)
  810 FORMAT (5X,'EXTRA VALUE ENCOUNTERED OR WRONG TYPE OF INPUT DATA')
      GO TO  1100
  820 WRITE  (NOUT,830)
  830 FORMAT (5X,'ILLEGAL COMPONENT SPECIFIED')
      GO TO  1100
  840 WRITE  (NOUT,850)
  850 FORMAT (5X,'COMPONENT LIMIT OF 31 IS EXCEEDED')
      GO TO  1100
  860 WRITE  (NOUT,870)
  870 FORMAT (5X,'SET ID ERROR (REQUESTED BEFORE EQUAL SIGN OR ',
     1       'SPLITTED ID)')
      GO TO  1100
  880 WRITE  (NOUT,890)
  890 FORMAT (5X,'TOO MANY COMPONENTS')
      GO TO  1100
  900 WRITE  (NOUT,910)
  910 FORMAT (5X,'MINUS MAX EXCEEDS PLUS MAX')
      GO TO  1100
  920 WRITE  (NOUT,930)
  930 FORMAT (5X,'COMPONENT NAME NOT AVAILABLE FOR ELEMENT SELECTED')
      GO TO  1100
  940 WRITE  (NOUT,950)
  950 FORMAT (5X,'OUTPUT SCAN BY FORCE OR BY STRESS ONLY')
      GO TO  1100
  960 WRITE  (NOUT,970)
  970 FORMAT (5X,'LARGE TOPN VALUE REQUESTED MAY RESULT IN INSUFFICIENT'
     1,      ' CORE IN OUTPUT SCAN MODULE LATER')
      GO TO  1100
C
  980 WRITE  (NOUT,990)
  990 FORMAT (5X,'SORT2 REQUEST FOR STRESSES ON THE LAYERED ELEMENTS ',
     1       'IS CURRENTLY NOT SET UP BY THE RIGID FORMAT')
      GO TO  1100
 1000 WRITE  (NOUT,1010)
 1010 FORMAT (5X,'LAYER OPTION IS AVAILABLE ONLY IN STRESS OR ELSTRESS')
 1100 LINE = LINE + 3
      IF (LINE .GE. NLPP) CALL PAGE
 1110 RETURN
      END

      SUBROUTINE DTRMEM( IOPT )
C
C     DIFFERENTIAL STIFFNESS CALCULATIONS FOR THE TRIANGULAR MEMBRANE
C     ELEMENT.  THREE 6X6 MATRICES FOR THE PIVOT POINT ARE INSERTED.
C     IF THIS ROUTINE IS CALLED FROM DTRIA OR DQUAD ONLY THE IN PLANE
C     EFFECTS ARE GENERATED AND THE STRESS VALUES ARE RETURNED.
C
C     THE VALUE OF IOPT TELLS US WHICH ROUTINE IS CALLING DTRMEM.
C      THE OPTIONS ARE
C                IOPT        ROUTINE
C               ******       *******
C                 0            DSIA
C                 1            DQDMEM
C                 2            DTRIA
C                 3            DQUAD
C
C
C     THIS ROUTINE COMPUTES AN E-MATRIX UNIQUE TO THIS ROUTINE.
C
C                       IX  IY  IZ
C                  E =  JX  JY  JZ
C                       KX  KY  KZ
C
      DOUBLE PRECISION   E             ,C
     1                  ,KD            ,SIGX
     2                  ,SIGY          ,SIGXY
     3                  ,TEMP1         ,TEMP2
     4                                 ,KIJ
     5                  ,G             ,XSUBB
     6                  ,XSUBC         ,YSUBC
     7                  ,SUM           ,MU
     8                  ,LAMDA         ,DELTA
     9                  ,TEMP          ,GAMMA1
     T                  ,GAMMA2        ,GAMMA3
     1                  ,DISP          ,T
      DOUBLE PRECISION   AREAT         ,DUMDP
C
      DIMENSION          SUM(3)        ,NECPT(6)      ,KIJ(36)
C
C
C     INTERFACE DATA BLOCKS
C
      COMMON /CONDAS/ CONSTS(5)
      COMMON /MATIN / MATID, INFLAG, ELTEMP, STRESS, SINTH, COSTH
      COMMON /MATOUT/ G11,G12,G13,G22,G23,G33,RHO,ALPHA1,ALPHA2,ALPH12,
     1       TSUB0,GSUBE,SIGTEN,SIGCOM,SIGSHE,G2X211,G2X212,G2X222
      COMMON /DS1AAA/ NPVT, ICSTM, NCSTM
      COMMON /DS1AET/ ECPT(21),ELDEF,LDTEMP,SDISP(9)
      COMMON /DS1ADP/    E(9)          ,C(54)
     1                  ,KD(36)        ,TEMP1(18)
     2                  ,TEMP2(18)
     3                  ,G(9)          ,T(9)
     4                  ,DISP(9)       ,MU
     5                  ,LAMDA         ,DELTA
     6                  ,TEMP          ,GAMMA1
     7                  ,GAMMA2        ,GAMMA3
     8                  ,AREAT         ,XSUBB
     9                  ,XSUBC         ,YSUBC
     T                  ,DUMDP(12)     ,THETA
     1                  ,ICSTM1        ,NPIVOT
     2                  ,IDUM
     3                  ,SIGX          ,SIGY           ,SIGXY
C
      EQUIVALENCE ( CONSTS(4) , DEGRA  )
      EQUIVALENCE (LDTEMP,FTEMP),(NECPT(1),ECPT(1)),(SUM(1),SIGX)
      EQUIVALENCE        (KIJ(1),KD(1))
C
C
C     ******************************************************************
C     ECPT( 1) = ELEMENT ID
C     ECPT( 2) = GRID POINT A OR 1
C     ECPT( 3) = GRID POINT B OR 2
C     ECPT( 4) = GRID POINT C OR 3
C     ECPT( 5) = THETA = ANGLE OF MATERIAL CUT IF ANISOTROPIC
C     ECPT( 6) = MATERIAL ID
C     ECPT( 7) = THICKNESS
C     ECPT( 8) = NON-STRUCTURAL MASS
C     ECPT( 9) = COORD. SYSTEM ID 1
C     ECPT(10) = X1
C     ECPT(11) = Y1
C     ECPT(12) = Z1
C     ECPT(13) = COORD. SYSTEM ID 2
C     ECPT(14) = X2
C     ECPT(15) = Y2
C     ECPT(16) = Z2
C     ECPT(17) = COORD. SYSTEM ID 3
C     ECPT(18) = X3
C     ECPT(19) = Y3
C     ECPT(20) = Z3
C     ECPT(21) = ELEMENT TEMPERATURE
C     ECPT(22) = ELEMENT DEFORMATION DELTA
C     ECPT(23) = AVG. LOADING TEMPERATURE =(-1) IF NO LOADING TEMP.
C     ECPT(24) = X-TRANS POINT 1
C     ECPT(25) = Y-TRANS POINT 1
C     ECPT(26) = Z-TRANS POINT 1
C     ECPT(27) = X-TRANS POINT 2
C     ECPT(28) = Y-TRANS POINT 2
C     ECPT(29) = Z-TRANS POINT 2
C     ECPT(30) = X-TRANS POINT 3
C     ECPT(31) = Y-TRANS POINT 3
C     ECPT(32) = Z-TRANS POINT 3
C     ******************************************************************
C//////
C     CALL BUG(4HTMET,0,ECPT,32)
C//////
C
      SIGX=0.0D0
      SIGY=0.0D0
      SIGXY=0.0D0
      IF(ECPT(7) .EQ. 0.0 .OR. NECPT(6) .EQ. 0 ) RETURN
C     FILL ELEMENT TO GLOBAL E-TRANSFORMATION MATRIX
C
C     IVEC = E(1). . .E(3)
C     JVEC = E(4). . .E(6)
C     KVEC = E(7). . .E(9)
C
      DO 10 I=1,3
   10 E(I) = DBLE( ECPT(I+13) ) - DBLE( ECPT(I+9) )
C
C     LENGTH THEN = XSUBB
C
      XSUBB = DSQRT( E(1)**2 + E(2)**2 + E(3)**2 )
C
C     R  - R   (INTERMEDIATE STEP) AND NOMALIZE IVECTOR = E(1). . .E(3)
C      C    A
C
      DO 20 I=1,3
      E(I+3) = DBLE( ECPT(I+17) ) - DBLE( ECPT(I+9) )
   20 E(I) = E(I) / XSUBB
C
C     XSUBC = I DOT (R  - R )
C                     C    A
C
      XSUBC = E(1) * E(4)  +  E(2) * E(5)  +  E(3) * E(6)
C
C     KVEC = IVEC CROSS (R  - R )
C                         C    A
C
      E(7) = E(2) * E(6)  -  E(3) * E(5)
      E(8) = E(3) * E(4)  -  E(1) * E(6)
      E(9) = E(1) * E(5)  -  E(2) * E(4)
C
C     LENGTH = YSUBC
C
      YSUBC = DSQRT(E(7)**2 + E(8)**2 + E(9)**2 )
C
C     NORMALIZE KVECTOR
      E(7) = E(7) / YSUBC
      E(8) = E(8) / YSUBC
      E(9) = E(9) / YSUBC
C
C     JVECTOR = I CROSS K
C
      E(4) = E(3) * E(8)  -  E(2) * E(9)
      E(5) = E(1) * E(9)  -  E(3) * E(7)
      E(6) = E(2) * E(7)  -  E(1) * E(8)
C
C     NORMALIZE JVECTOR TO MAKE SURE
      TEMP = DSQRT( E(4)**2 + E(5)**2 + E(6)**2 )
      E(4) = E(4) / TEMP
      E(5) = E(5) / TEMP
      E(6) = E(6) / TEMP
C
C     MU, LAMDA, AND DELTA
C
      MU    = 1.0D0 / XSUBB
      LAMDA = 1.0D0 / YSUBC
      DELTA =(XSUBC/XSUBB) - 1.0D0
      AREAT = XSUBB * YSUBC * 0.50D0 * DBLE( ECPT(7) )
C
C     C MATRIX    C  =(3X2) STORED C( 1). . .C( 6)
C                  A
C                 C  =(3X2) STORED C( 7). . .C(12)
C                  B
C                 C  =(3X2) STORED C(13). . .C(18)
C                  C
C
      C( 1) = -MU
      C( 2) =  0.0D0
      C( 3) =  0.0D0
      C( 4) =  LAMDA * DELTA
      C( 5) =  C(4)
      C( 6) = -MU
      C( 7) =  MU
      C( 8) =  0.0D0
      C( 9) =  0.0D0
      C(10) = -LAMDA * MU * XSUBC
      C(11) =  C(10)
      C(12) =  MU
      C(13) =  0.0D0
      C(14) =  0.0D0
      C(15) =  0.0D0
      C(16) =  LAMDA
      C(17) =  LAMDA
      C(18) =  0.0D0
C
      IF( IOPT .GE. 1 ) GO TO 30
C     THE REASON FOR THIS IS THAT IF THE DQDMEM ROUTINE IS CALLING,
C     EACH INDIVIDUAL SUBTRIANGLE WILL ALREADY HAVE A SINTH AND COSTH.
C
      THETA = ECPT(5) * DEGRA
      SINTH = SIN( THETA )
      COSTH = COS( THETA )
   30 IF( ABS(SINTH) .LT. 1.0E-06 ) SINTH = 0.0E0
C
      ELTEMP = ECPT(21)
      MATID = NECPT(6)
      INFLAG = 2
      CALL MAT( ECPT(1) )
C
C     FILL G-MATRIX WITH OUTPUT FROM MAT ROUTINE.
C
      G(1) = G11
      G(2) = G12
      G(3) = G13
      G(4) = G12
      G(5) = G22
      G(6) = G23
      G(7) = G13
      G(8) = G23
      G(9) = G33
C
C     G, E, C MATRICES ARE COMPLETE
C
C     FOLLOWING COMPUTES SIG , SIG , SIG      (3X1) VECTOR
C                           X     Y     XY
C
C         I=3
C      = (SUM (G)(C )(E)(T )(DISP )) - (S )(LDTEMP - T )
C         I=1      I      I      I       T            0
C
C        WHERE  S  =(G)(ALPHAS)   (3X1)
C                T
C
      SUM(1) = 0.0E0
      SUM(2) = 0.0E0
      SUM(3) = 0.0E0
C
C     MAKE DISPLACEMENT VECTOR DOUBLE PRECISION
C
      DO 40 I=1,9
   40 DISP(I) = SDISP(I)
C
      DO 90 I=1,3
C     DO WE NEED TRANSFORMATIONS
C
      IF(NECPT(4*I+5)) 50,60,50
   50 CALL TRANSD( NECPT(4*I+5),T(1))
      CALL GMMATD( T(1),3,3,0, DISP(3*I-2),3,1,0, TEMP1(1))
      GO TO 80
C
   60 DO 70 J=1,3
      IDUM=  3*(I-1)+J
   70 TEMP1(J) = DISP(IDUM)
C
   80 CALL GMMATD( E(1),2,3,0,TEMP1(1),3,1,0, TEMP2(1)  )
      CALL GMMATD( C(6*I-5),3,2,0,  TEMP2(1),2,1,0,  TEMP1(1) )
      CALL GMMATD( G(1),3,3,0,    TEMP1(1),3,1,0,    TEMP2(1) )
C
      SUM(1) = SUM(1) + TEMP2(1)
      SUM(2) = SUM(2) + TEMP2(2)
      SUM(3) = SUM(3) + TEMP2(3)
C
   90 CONTINUE
C
      IF( LDTEMP .EQ. (-1) ) GO TO 110
C     COMPUTE S MATRIX
C               T
C
      TEMP2(1) = ALPHA1
      TEMP2(2) = ALPHA2
      TEMP2(3) = ALPH12
C     ABOVE IS FOR SINGLE TO DOUBLE PRECISION.
C
      CALL GMMATD( G(1),3,3,0,  TEMP2(1),3,1,0,  TEMP1(1) )
      TEMP = FTEMP - TSUB0
      DO 100 I=1,3
  100 SUM(I) = SUM(I) - TEMP1(I) * TEMP
C
C//////
C     CALL BUG(4HSUMS,90,SUM,6)
C//////
C  90 AT 90 SIG = SUM(1),  SIG = SUM(2),  SIG   = SUM(3)
C              X              Y              XY
C
C     ABOVE SIMULATES SMA,SDR2-PHASE I+II
C     FROM ABOVE THE E MATRIX (3X3), AND THE SUM (3X1) MATRIX ALONG WITH
C     XSUBB, XSUBC, AND YSUBC ARE NOW USED...
  110 DO 120  I =1,36
  120 KD(I) =0.0D0
C
      IF( IOPT.EQ. 3 ) AREAT=AREAT/2.0D0
C
      MU = SIGX*AREAT
      LAMDA = SIGY*AREAT
      DELTA = SIGXY *AREAT
C
      IF ( IOPT .GE. 2)  GO TO 130
      KD(1) = LAMDA
      KD(2) =-DELTA
      KD(7) = KD(2)
      KD(8) = MU
  130 KD(15) = MU+LAMDA
      KD(16) =-DELTA
      KD(17) = DELTA
      KD(18) = MU -LAMDA
      KD(21) = KD(16)
      KD(27) = KD(17)
      KD(33) = KD(18)
C
C     GENERATE C MATRICES
C
      DO 140 I=1,54
  140 C(I) =0.0D0
C
C     FILL NON ZERO TERMS
C
      GAMMA1 = 1.0D0 /XSUBB
      GAMMA2 = 1.0D0 /YSUBC
      GAMMA3 = XSUBC /( XSUBB*YSUBC)
      C(3) = GAMMA3 -GAMMA2
      C(6) = GAMMA1
      C(7) =-C(3)/2.0D0
      C(8) =-GAMMA1/2.0D0
      C(10)=-GAMMA1
      C(14)= C(3)
      C(16)=-C(7)
      C(17)= C(8)
C
      C(21)=-GAMMA3
      C(24)=-GAMMA1
      C(25)= GAMMA3/2.0D0
      C(26)=-C(8)
      C(28)= GAMMA1
      C(32)=-GAMMA3
      C(34)=-C(25)
      C(35)= C(26)
C
      C(39)=GAMMA2
      C(43)=-GAMMA2/2.0D0
      C(50)= GAMMA2
      C(52)=-C(43)
C
C     REPLACE C MATRICES BY  (C)(E )(T) FOR EACH POINT
      DO 200 I =1,3
      IF( NECPT(4*I+5)) 150,160,150
C
C     GLOBAL TO BASIC MATRIX T IS GENERATED AGAIN HERE
C
  150 CALL TRANSD( NECPT(4*I+5),T(1))
      CALL GMMATD( E(1),3,3,0,  T(1),3,3,0, TEMP1(1) )
      GO TO 180
  160 DO 170 J =1,9
  170 TEMP1(J) = E(J)
C
  180 CALL GMMATD( C(18*I-17),6,3,0,  TEMP1(1),3,3,0,  TEMP2(1))
      DO 190  J=1,18
      IDUM =  18*(I-1) +J
  190 C(IDUM) = TEMP2(J)
C
  200 CONTINUE
C
      DO 210 I =1,3
      IF(NECPT(I+1) .NE. NPVT) GO TO 210
      NPIVOT= I
      GO TO 220
  210 CONTINUE
      RETURN
  220 CALL GMMATD( C(18*NPIVOT-17),6,3,1, KD(1),6,6,0, TEMP1(1))
C
C     TEMP1 NOW CONTAINS                   T
C                           ( (C )(E)(T ) ) ( KD)
C                               J      J
C     WHERE J IS THE PIVOT POINT
C
C     GENERATE THE THREE BY THREE PARTITIONS IN GLOBAL COORDINATES HERE
C
      DO 240 I=1,3
      CALL GMMATD( TEMP1,3,6,0, C(18*I-17),6,3,0,TEMP2(1)  )
C//////
C     CALL BUG(4HTRMK,260,TEMP2,18)
C//////
      DO 230 J=1,36
  230 KIJ(J) = 0.0D0
      KIJ( 1) = TEMP2(1)
      KIJ( 2) = TEMP2(2)
      KIJ( 3) = TEMP2(3)
      KIJ( 7) = TEMP2(4)
      KIJ( 8) = TEMP2(5)
      KIJ( 9) = TEMP2(6)
      KIJ(13) = TEMP2(7)
      KIJ(14) = TEMP2(8)
      KIJ(15) = TEMP2(9)
C
      CALL DS1B( KIJ(1), NECPT(I+1) )
C
  240 CONTINUE
      RETURN
      END

      SUBROUTINE BMG
C
C     HYDROELASTIC BOUNDARY MATRIX GENERATOR
C
C     7/12/73 NO AXIAL SYMMETRY UPPER INTEGRATION LIMIT OF LAST
C             CIRCUMFERENTIAL GRID IS INCORRECT
C
      LOGICAL          LABFL    ,LKBFL    ,NSTAR    ,HEAD
      INTEGER          SYSBUF   ,NABFL(2) ,NKBFL(2) ,SUBR(2)  ,FORM   ,
     1                 BUF(10)  ,Z        ,SCRT1    ,BDPOOL   ,CSTM   ,
     2                 EQEXIN   ,BGPDT    ,RD       ,RDREW    ,ENTRYS ,
     3                 WRT      ,WRTREW   ,CLSREW   ,DMIG(3)  ,CLS    ,
     4                 FILE     ,BUF1     ,BUF2     ,BUF3     ,CORE   ,
     5                 POINT    ,BNDFL(2) ,FLAG     ,MONES(3) ,EOR
      REAL             RBUF(10) ,RZ(1)    ,KII
      DOUBLE PRECISION DZ(1)    ,DTEMP(3) ,TERM(3)  ,VI(3)    ,T0F(9) ,
     1                 TI(9)    ,AIN      ,DUB
      CHARACTER        UFM*23   ,UWM*25   ,UIM*29   ,SFM*25
      COMMON /XMSSG /  UFM      ,UWM      ,UIM      ,SFM
      COMMON /CONDAS/  CONSTS(5)
      COMMON /SYSTEM/  SYSBUF   ,IOUT     ,ISKP(52) ,IPREC
      COMMON /BLANK /  KFLAGS(2),VALUE(2)
      COMMON /ZZZZZZ/  Z(1)
      COMMON /NAMES /  RD,RDREW,WRT,WRTREW,CLSREW,CLS
      EQUIVALENCE      (CONSTS(2),TWOPI)  ,(CONSTS(4),DEGRAD)  ,
     1                 (Z(1),RZ(1),DZ(1)) ,(BUF(1),RBUF(1))
      DATA    SUBR  /  4HBMG ,4H    /,  NABFL / 4HABFL,4H    /
      DATA    BNDFL /  9614  ,96    /,  MONES / -1, -1, -1   /
      DATA    IS    /  1            /,  DMIG  / 114, 1, 120  /
      DATA    EOR   ,  NOEOR/ 1,0   /,  NKBFL / 4HKBFL,4H    /
      DATA    MATPOL,  BGPDT,EQEXIN,CSTM / 101,102,103,104   /
      DATA    BDPOOL/  201          /,  SCRT1 / 301          /
      DATA    IZ2   ,  IZ6,IZ7,IZ8,IZ9   /  2, 6, 7, 8, 9    /
C
C     DEFINE CORE AND BUFFER POINTERS
C
      CORE = KORSZ(Z)
      BUF1 = CORE - SYSBUF - 2
      BUF2 = BUF1 - SYSBUF - 2
      BUF3 = BUF2 - SYSBUF - 2
      CORE = BUF3 - 1
      IF (CORE .LT. 100) CALL MESAGE (-8,0,SUBR)
      KFLAGS(1) = -1
      KFLAGS(2) = -1
C
C     OPEN MATPOOL AND LOCATE THE BNDFL RECORD AS PREPARED BY IFP4.
C
      CALL PRELOC (*10000,Z(BUF1),MATPOL)
      CALL LOCATE (*10000,Z(BUF1),BNDFL,FLAG)
C
C     THIS MODULE DOES NOTHING IF THE MATPOOL IS PURGED OR THE BNDFL
C     RECORD IS ABSENT.  NOW READ THE HEADER DATA OF THIS RECORD.
C
      FILE = MATPOL
      CALL READ (*10002,*10003,MATPOL,Z(1),9,NOEOR,FLAG)
      IN = 10
      NN = Z(IZ9) + 9
      IF (NN+5 .GT. CORE) CALL MESAGE (-8,0,SUBR)
C
C     READ THE INDICES
C
      CALL READ (*10002,*10003,MATPOL,Z(IN),Z(IZ9),NOEOR,FLAG)
      VALUE(1) = Z(IZ6)
      VALUE(2) = 0.0
      IF (Z(IZ6) .EQ. 0) VALUE(1) = 1.0
C
C     MODIFY LIST OF INDICES TO FIT THE FOLLOWING TABLE
C
C        M      S1    S2         N              N*
C        -      --    --         -              --
C        0                      ALL             ALL
C
C                               K M
C     .GE.2      S     S        ---             NONE
C                                2
C
C                             (2K+1)M
C     .GE.2      S     A      -------           NONE
C                                4
C
C                                              (2K+1)M
C     .GE.2      A     S        NONE           -------
C                                                 4
C
C                                               K M
C     .GE.2      A     A        NONE            ---
C                                                2
C
C     K MAY BE 0,1,2,..... IN ORDER TO CHECK INDICE FOR MATCH.
C
      IF (Z(IZ6)) 90,90,10
C
C     M IS POSITIVE THUS CHECK FOR STAR OR NO-STAR INDICES PERMITTED.
C     DETERMINE THE FORM OF THE CHECK EQUATION.
C
C          Z(7) = S1
C          Z(8) = S2
C          Z(6) = M
C
   10 IF (Z(IZ7) .EQ. IS) GO TO 12
      NSTAR = .TRUE.
      GO TO 13
   12 NSTAR = .FALSE.
   13 IF (Z(IZ7) .EQ. Z(IZ8)) GO TO 14
      FORM = 1
      GO TO 15
   14 FORM = -1
C
C     NOW FORM NEW LIST OF INDICES
C
   15 INN = NN + 1
      NNN = NN
      DO 80 I = IN,NN
      N = (Z(I)-1)/2
      IF (MOD(Z(I),2)) 30,20,30
C
C     NON-STAR CASE
C
   20 IF (NSTAR) GO TO 80
      IF (FORM ) 40,70,70
C
C     STAR CASE
C
   30 IF (.NOT.NSTAR) GO TO 80
      IF (FORM) 40,70,70
C
C                           K M
C     CHECK USING EQUATION  ---
C                            2
C
   40 N2 = N*2
      K  = N2/Z(IZ6)
      IF (K*Z(IZ6) .NE. N2) GO TO 80
C
C     GOOD INDICE,  ADD IT TO THE LIST
C
   50 NNN = NNN + 1
      Z(NNN) = Z(I)
      GO TO 80
C
C                            (2K+1)M
C     CHECK USING EQUATION   -------
C                               4
C
   70 N4 = N*4
      IK = N4 / Z(IZ6)
      IK = IK - 1
      K  = IK / 2
      IF ((2*K+1)*Z(IZ6) .EQ. N4) GO TO 50
   80 CONTINUE
C
C     LIST IS COMPLETE
C
      IN = INN
      NN = NNN
   90 LABFL = .TRUE.
      IF (NN .LT. IN) LABFL = .FALSE.
C
C     SET LKBFL AS A FLAG INDICATING WHETHER KBFL WILL BE GENERATED
C     ALONG WITH ABFL.  IF G IS NON-ZERO THEN KBFL WILL BE GENERATED.
C
      LKBFL = .TRUE.
      IF (RZ(IZ2).EQ.0.0) LKBFL = .FALSE.
      IF (LKBFL) KFLAGS(1) = 0
      IF (LABFL) KFLAGS(2) = 0
      IF (.NOT.LABFL .AND. .NOT.LKBFL) GO TO 10000
C
C     BGPDT IS NOW READ INTO CORE AS 5 WORD ENTRIES, RESERVING FIRST
C     WORD FOR THE EXTERNAL ID.
C
      FILE   = BGPDT
      IBGPDT = NN + 1
      NBGPDT = NN
      CALL GOPEN (BGPDT,Z(BUF2),RDREW)
  100 CALL READ (*10002,*120,BGPDT,Z(NBGPDT+2),4,NOEOR,FLAG)
      NBGPDT = NBGPDT + 5
      IF (NBGPDT+5 .GT. CORE) CALL MESAGE (-8,0,SUBR)
      GO TO 100
  120 CALL CLOSE (BGPDT,CLSREW)
C
C     READ EQEXIN PLACING EXTERNAL ID ON RESPECTIVE BGPDT ENTRY.
C
      FILE = EQEXIN
      CALL GOPEN (EQEXIN,Z(BUF2),RDREW)
  130 CALL READ (*10002,*140,EQEXIN,BUF,2,NOEOR,FLAG)
      N = 5*BUF(2) - 5 + IBGPDT
      Z(N) = BUF(1)
      GO TO 130
  140 CALL CLOSE (EQEXIN,CLSREW)
      LBGPDT = NBGPDT - IBGPDT + 1
      ENTRYS = LBGPDT / 5
C
C     SORT THE BGPDT ON EXTERNAL ID
C
      CALL SORT (0,0,5,1,Z(IBGPDT),LBGPDT)
C
C  BLAST CSTM INTO CORE
C
      FILE = CSTM
      CALL GOPEN (CSTM,Z(BUF2),RDREW)
      ICSTM = NBGPDT + 1
      CALL READ (*10002,*160,CSTM,Z(ICSTM),CORE-ICSTM,NOEOR,FLAG)
      CALL MESAGE (-8,0,SUBR)
  160 NCSTM = ICSTM + FLAG - 1
      LCSTM = NCSTM - ICSTM + 1
      CALL CLOSE (CSTM,CLSREW)
C
C     LOCATE THE T   MATRIX IN THE CSTM DATA BY USING CSID = CDF IN
C                 0F
C
C     THE HEADER DATA.      ( Z(1) )
C
      DO 200 I = ICSTM,NCSTM,14
      IF (Z(1) .EQ. Z(I)) GO TO 240
  200 CONTINUE
      WRITE  (IOUT,210) SFM,Z(1)
  210 FORMAT (A25,' 4060, COORDINATE SYSTEM =',I9,
     1       ' CAN NOT BE FOUND IN CSTM DATA.')
      GO TO 9999
  240 N = I + 5
      DO 250 I = 1,9
      T0F(I) = DBLE(RZ(N))
      N = N + 1
  250 CONTINUE
C
C     OPEN BDPOOL FOR ABFL, AND SCRATCH1 FOR KBFL AND WRITE THE DMIG
C     HEADER INFORMATION.
C
      CALL GOPEN (BDPOOL,Z(BUF2),WRTREW)
C
C     WRITE DMIG RECORD ID
C
      CALL WRITE (BDPOOL,DMIG,3,NOEOR)
      BUF(1) = NABFL(1)
      BUF(2) = NABFL(2)
      BUF(3) = 0
      BUF(4) = 1
      BUF(5) = 1
      BUF(6) = IPREC
      BUF(7) = 0
      BUF(8) = 0
      BUF(9) = 0
      IF (.NOT. LABFL) GO TO 270
      CALL WRITE (BDPOOL,BUF,9,NOEOR)
  270 IF (.NOT.LKBFL) GO TO 280
      FILE = SCRT1
      CALL OPEN (*10001,SCRT1,Z(BUF3),WRTREW)
      BUF(1) = NKBFL(1)
      BUF(2) = NKBFL(2)
      CALL WRITE (SCRT1,BUF,9,NOEOR)
C
C     READ SOME FLUID-PT DATA (IDF,R,Z,L,C,S,RHO)
C
  280 FILE = MATPOL
      CALL READ (*10002,*10003,MATPOL,IDF,1,NOEOR,FLAG)
  285 IDATA = NCSTM + 1
      NDATA = NCSTM + 6
      CALL READ (*10002,*10003,MATPOL,Z(IDATA),6,NOEOR,FLAG)
C
C     START BUILDING TABLE OF CONNECTED GRID POINTS.
C     READ ID,PHI.  CREATE A 26 WORD ENTRY FOR EACH ID,PHI.
C
      ITABLE = NDATA + 1
C
C     INSURE THAT TABLE STARTS ON AN EVEN BOUNDARY FOR DOUBLE
C     PRECISION
C
      IF (MOD(ITABLE,2) .NE. 1) ITABLE = ITABLE + 1
      NTABLE = ITABLE - 1
  290 CALL READ (*10002,*10003,MATPOL,Z(NTABLE+1),2,NOEOR,FLAG)
      IF (Z(NTABLE+1) .EQ. -1) GO TO 300
C
C     CONVERT PHI TO RADIANS
C
      RZ(NTABLE+2) = RZ(NTABLE+2)*DEGRAD
      NTABLE = NTABLE + 26
      IF (NTABLE+26 .GT. CORE) CALL MESAGE (-8,0,SUBR)
      GO TO 290
C
C     COMPUTATION AND INSERTION OF PHI   AND PHI   FOR EACH ENTRY.
C                                     0         1
C
  300 DO 370 I = ITABLE,NTABLE,26
C
C     SET UP PHI  IN THIRD SLOT OF ENTRY = (PHI  + PHI   )/2.0
C               0                              I      I-1
C
      IF (I .NE. ITABLE) GO TO 310
C
C     SPECIAL CASE ON FIRST POINT, TEST M TO FIND PHI
C                                                    I-1
C
      IF (Z(IZ6) .GT. 1) GO TO 320
      PHIL1 = RZ(NTABLE-24) - TWOPI
      GO TO 350
  320 PHIL1 = RZ(ITABLE+1)
      GO TO 350
  310 PHIL1 = RZ(I-25)
  350 RZ(I+2) = (RZ(I+1) + PHIL1) / 2.0
C
C     SET UP PHI  IN FOURTH SLOT OF ENTRY = (PHI  + PHI   )/2.0
C               1                               I      I+1
C
      IF (I .NE. NTABLE-25) GO TO 345
C
C     SPECIAL CASE ON LAST POINT, TEST M TO FIND PHI
C                                                   I+1
C
      IF (Z(IZ6) .GT. 1) GO TO 340
      PHIP1 = RZ(ITABLE+1) + TWOPI
      GO TO 360
  340 PHIP1 = RZ(NTABLE-24)
      GO TO 360
  345 PHIP1 = RZ(I+27)
  360 RZ(I+3) = (RZ(I+1) + PHIP1) / 2.0
  370 CONTINUE
C
C     PICK UP NEXT FLUID POINT IDF
C
      NEXTID = 0
      CALL READ (*10002,*400,MATPOL,NEXTID,1,NOEOR,FLAG)
      IF (NEXTID .NE. IDF) GO TO 400
C
C     NEXTID IS SAME AS CURRENT IDF, THUS ADD ANOTHER ENTRY OF R,Z,L,C,
C     S,RH FIRST MOVE SINGLE ENTRY DOWN UNDER TABLE SO IT CAN GROW.
C
      Z(NTABLE+1) = Z(IDATA  )
      Z(NTABLE+2) = Z(IDATA+1)
      Z(NTABLE+3) = Z(IDATA+2)
      Z(NTABLE+4) = Z(IDATA+3)
      Z(NTABLE+5) = Z(IDATA+4)
      Z(NTABLE+6) = Z(IDATA+5)
      IDATA = NTABLE + 1
      NDATA = NTABLE + 6
  380 IF (NDATA+6 .GT. CORE) CALL MESAGE (-8,0,SUBR)
      CALL READ (*10002,*10003,MATPOL,Z(NDATA+1),6,NOEOR,FLAG)
      NDATA = NDATA + 6
C
C     SKIP THE ID-PHI PAIRS AS THEY SHOULD BE IDENTICAL TO ONES ALREADY
C     IN THE TABLE.
C
  390 CALL READ (*10002,*10003,MATPOL,BUF,2,NOEOR,FLAG)
      IF (BUF(1) .NE. -1) GO TO 390
C
C     READ THE NEXTID
C
      NEXTID = 0
      CALL READ (*10002,*400,MATPOL,NEXTID,1,NOEOR,FLAG)
      IF (NEXTID .EQ. IDF) GO TO 380
C
C     SORT THE TABLE ON FIELD ONE OF EACH ENTRY THE ID.
C
  400 CALL SORT (0,0,26,1,Z(ITABLE),NTABLE-ITABLE+1)
C
C                                  T
C     FOR EACH ENTRY GENERATE THE T T   MATRICE AND IF LKBFL = .TRUE.
C                                  I 0F
C
C     THE W  MATRICE.
C          I
C
      DO 500 I = ITABLE,NTABLE,26
C
C     LOCATE THE TRANSFORMATION MATRIX IN DOUBLE PRECISION.
C     FIRST LOCATE BGPDT ENTRY
C
      KID = Z(I)
      CALL BISLOC (*10004,KID,Z(IBGPDT),5,ENTRYS,POINT)
      POINT = POINT + IBGPDT
      CALL BMGTNS (Z(ICSTM),LCSTM,Z(POINT),TI(1))
C
C     COMPUTE VI MATRIX.  (3X3)
C
      CALL GMMATD (TI(1),3,3,1, T0F(1),3,3,0, Z(I+4))
      IF (.NOT. LKBFL) GO TO 500
      J = (I+4)/2
      RZ(I+22) = DZ(J+3)
      RZ(I+23) = DZ(J+6)
      RZ(I+24) = DZ(J+9)
  500 CONTINUE
C
C     GENERATION AND OUTPUT OF MATRIX COLUMNS TO THE ABFL MATRIX.
C
      IF (.NOT.LABFL) GO TO 690
      DO 680 I = IN,NN
C
C     COLUMN INDEX INFORMATION GJ,CJ FOR THIS HARMONIC COLUMN
C
      BUF(1) = IDF + Z(I)*500000
      BUF(2) = 0
      CALL WRITE (BDPOOL,BUF,2,NOEOR)
C
C     TERMS OF THE COLUMN
C
      DO 670 J = ITABLE,NTABLE,26
C
C     3 TERMS FOR THE J-TH ID ARE THE FOLLOWING SUMMATION
C
      TERM(1) = 0.0D0
      TERM(2) = 0.0D0
      TERM(3) = 0.0D0
      DO 650 K = IDATA,NDATA,6
C
C                     N
C     COMPUTATION OF A
C                     I
C
      AIN = RZ(K)*RZ(K+2)
      N   = (Z(I) - 1) / 2
      FN  = N
      IF (N) 520,510,520
C
C     N = 0
C
  510 AIN = AIN*DBLE(RZ(J+3) - RZ(J+2))
      GO TO 545
C
C     N IS POSITIVE, CHECK FOR STAR CASE = N*
C
  520 IF (MOD(Z(I),2)) 540,530,540
  530 DUB = (SIN(RZ(J+3)*FN) - SIN(RZ(J+2)*FN)) / FN
      AIN = AIN*DUB
      GO TO 545
  540 DUB = (COS(RZ(J+2)*FN) - COS(RZ(J+3)*FN)) / FN
      AIN = AIN*DUB
C
C     FORM VI MATRIX FOR THIS POINT
C
  545 DTEMP(1) = RZ(K+3)*COS(RZ(J+1))
      DTEMP(2) = RZ(K+3)*SIN(RZ(J+1))
      DTEMP(3) = RZ(K+4)
      CALL GMMATD (Z(J+4),3,3,0, DTEMP(1),3,1,0, VI(1))
      DO 550 L = 1,3
      TERM(L) = TERM(L) + AIN*VI(L)
  550 CONTINUE
  650 CONTINUE
C
C     OUTPUT THESE 3 TERMS
C
      BUF(1) = Z(J)
      DO 660 K = 1,3
      BUF(2) = K
      RBUF(3) = TERM(K)
      IF (RBUF(3)) 655,660,655
  655 CALL WRITE (BDPOOL,BUF,3,NOEOR)
  660 CONTINUE
  670 CONTINUE
      CALL WRITE (BDPOOL,MONES,2,NOEOR)
  680 CONTINUE
C
C     GENERATION AND OUTPUT OF COLUMNS TO THE KBFL MATRIX.
C
  690 IF (.NOT.LKBFL) GO TO 800
      DO 750 I = ITABLE,NTABLE,26
      COSPHI = COS(RZ(I+1))
      SINPHI = SIN(RZ(I+1))
      ANGLE   = RZ(I+3) - RZ(I+2)
C
C     PUT OUT 3 COLUMNS FOR EACH OF THESE CONNECTED GRIDPOINTS
C
C     SOLVE NOW FOR K   V  = 3X1  CONSTANT FOR THE 3 COLUMNS
C                    II  I
C
C     AND IS A SUMMATION
C
      TERM(1) = 0.0D0
      TERM(2) = 0.0D0
      TERM(3) = 0.0D0
      DO 715 J = IDATA,NDATA,6
      KII = RZ(J)*RZ(J+2)*RZ(J+5)*RZ(IZ2)*ANGLE
      DTEMP(1) = KII*RZ(J+3)*COSPHI
      DTEMP(2) = KII*RZ(J+3)*SINPHI
      DTEMP(3) = KII*RZ(J+4)
      CALL GMMATD (Z(I+4),3,3,0, DTEMP(1),3,1,0, VI(1))
      DO 710 K = 1,3
      TERM(K) = TERM(K) + VI(K)
  710 CONTINUE
  715 CONTINUE
C
C     PUT OUT THE 3 COLUMNS
C
      DO 740 J = 1,3
      HEAD = .FALSE.
      L = I + J + 21
      DTEMP(1) = DBLE(RZ(L))*TERM(1)
      DTEMP(2) = DBLE(RZ(L))*TERM(2)
      DTEMP(3) = DBLE(RZ(L))*TERM(3)
      BUF(1) = Z(I)
      DO 730 K = 1,3
      BUF(2) = K
      RBUF(3) = DTEMP(K)
C
C     TERM IS NOT WRITTEN IF HAS A ZERO VALUE
C
      IF (RBUF(3)) 720,730,720
  720 IF (HEAD) GO TO 721
      BUF(4) = Z(I)
      BUF(5) = J
      CALL WRITE (SCRT1,BUF(4),2,NOEOR)
      HEAD = .TRUE.
  721 CALL WRITE (SCRT1,BUF,3,NOEOR)
  730 CONTINUE
      IF (HEAD) CALL WRITE (SCRT1,MONES,2,NOEOR)
  740 CONTINUE
  750 CONTINUE
C
C     PROCESS THE NEXT FLUID POINT
C
  800 IF (NEXTID) 810,840,810
  810 IDF = NEXTID
      GO TO 285
C
C     ALL FLUID POINTS HAVE NOW BEEN PROCESSED.  APPEND THE KBFL, IF
C     ANY, DATA TO THE ABFL DATA AND WRAP UP.
C
  840 IF (LABFL) CALL WRITE (BDPOOL,MONES,2,NOEOR)
      IF (.NOT.LKBFL) GO TO 900
      CALL WRITE (SCRT1,0,0,EOR)
      CALL CLOSE (SCRT1,CLSREW)
      FILE = SCRT1
      CALL OPEN (*10001,SCRT1,Z(BUF3),RDREW)
  850 CALL READ (*10002,*860,SCRT1,Z(1),CORE,NOEOR,FLAG)
      CALL WRITE (BDPOOL,Z(1),CORE,NOEOR)
      GO TO 850
  860 CALL WRITE (BDPOOL,Z(1),FLAG,NOEOR)
      CALL WRITE (BDPOOL,MONES,2,EOR)
  900 CALL CLOSE (BDPOOL,CLSREW)
C
C     PREPARE AND WRITE TRAILER
C
      BUF(1) = BDPOOL
C
C     SET TRAILER BIT FOR DMIG CARDS
C
      BUF(2) = 32768
      BUF(3) = 0
      BUF(4) = 0
      BUF(5) = 0
      BUF(6) = 0
      BUF(7) = 0
      CALL WRTTRL (BUF)
      CALL CLOSE (SCRT1,CLSREW)
C
C     END OF PROCESSING
C
10000 CALL CLOSE (MATPOL,CLSREW)
      RETURN
C
C     ERROR CONDITIONS
C
10001 CALL MESAGE (-1,FILE,SUBR)
10002 CALL MESAGE (-2,FILE,SUBR)
10003 CALL MESAGE (-3,FILE,SUBR)
      GO TO 10000
10004 WRITE  (IOUT,10005) SFM,Z(I)
10005 FORMAT (A25,' 4061, CONNECTED FLUID POINT ID =',I10,
     1       ' IS MISSING BGPDT DATA.')
C
 9999 CALL MESAGE (-61,0,0)
      RETURN
C
      END

      SUBROUTINE XLNKHD
C
C     THE PURPOSE OF XLNKHD IS TO GENERATE THE LINK HEADER SECTION FOR
C     AN OSCAR ENTRY
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        LSHIFT,RSHIFT,ANDF,ORF
      DIMENSION       MED(1),OSCAR(1),OS(5)
      COMMON /SYSTEM/ ISYS(81),CPFLG
      COMMON /XGPIC / ICOLD,ISLSH,IEQUL,NBLANK,NXEQUI,
     1                NDIAG,NSOL,NDMAP,NESTM1,NESTM2,NEXIT,
     2                NBEGIN,NEND,NJUMP,NCOND,NREPT,NTIME,NSAVE,NOUTPT,
     3                NCHKPT,NPURGE,NEQUIV,
     4                NCPW,NBPC,NWPC,
     5                MASKHI,MASKLO,ISGNON,NOSGN,IALLON,MASKS(1)
      COMMON /ZZZZZZ/ CORE(1)
      COMMON /XGPI2 / LMPL,MPLPNT,MPL(1)
      COMMON /XGPI4 / IRTURN,INSERT,ISEQN,DMPCNT,
     1                IDMPNT,DMPPNT,BCDCNT,LENGTH,ICRDTP,ICHAR,NEWCRD,
     2                MODIDX,LDMAP,ISAVDW,DMAP(1)
      COMMON /XGPI5 / IAPP,START,ALTER(2),SOL,SUBSET,IFLAG,IESTIM,
     1                ICFTOP,ICFPNT,LCTLFL,ICTLFL(1)
      COMMON /XGPI6 / MEDTP,FNMTP,CNMTP,MEDPNT,LMED,DUMMY(5),IFIRST
      COMMON /XMDMSK/ NMSKCD,NMSKFL,NMSKRF,MEDMSK(7)
      COMMON /XOLDPT/ XX(4),SEQNO
      COMMON /AUTOHD/ IHEAD
      COMMON /XGPID / ICST,IUNST,IMST,IHAPP,IDSAPP,IDMAPP
      EQUIVALENCE     (CORE(1),OS(1),LOSCAR),(OS(2),OSPRC),
     1                (OS(3),OSBOT),(OS(4),OSPNT),
     2                (OSCAR(1),MED(1),OS(5))
      DATA    XCHK  / 4HXCHK   /
C
      OR (I,J) = ORF(I,J)
      AND(I,J) = ANDF(I,J)
      MPLER = MPL(MPLPNT+3)
      IF (IHEAD .EQ. 1) MPLER = 4
C
C     CHECK FOR DECLARATIVE INSTRUCTION
C
      IF (IHEAD .EQ. 1) GO TO 20
      IF (MPLER .NE. 5) GO TO 10
      OSPNT = OSCAR(OSBOT) + OSBOT
      GO TO 20
C
C     UPDATE OSCAR PARAMETERS
C
   10 OSPRC = OSBOT
      OSBOT = OSCAR(OSBOT) + OSBOT
      OSPNT = OSBOT
      ISEQN = OSCAR(OSPRC+1) + 1
C
C     LOAD LINK HEADER INFORMATION
C
      OSCAR(OSPNT    ) = 6
      OSCAR(OSPNT + 1) = ISEQN
      OSCAR(OSPNT + 2) = MPLER + LSHIFT(MODIDX,16)
      OSCAR(OSPNT + 3) = DMAP(DMPPNT    )
      OSCAR(OSPNT + 4) = DMAP(DMPPNT + 1)
      OSCAR(OSPNT + 5) = DMPCNT
C
      MPLPNT = MPLPNT + 4
   20 OSCAR(OSPNT+5) = OR(ISGNON,OSCAR(OSPNT+5))
C
C     ALWAYS RAISE EXECUTE FLAG FOR COLD START RUNS
C
      IF (START .EQ. ICST)  GO TO 70
C
C     COMPARE SEQ NO. WITH REENTRY SEQ NO.
C
      IF (DMPCNT .LT. RSHIFT(SEQNO,16)) GO TO 30
C
C     WE ARE BEYOND REENTRY POINT - EXECUTE ALL MODULES HERE ON OUT.
C
      IF (ANDF(MASKHI,SEQNO).EQ.0 .AND. MPLER.NE.5)
     1    SEQNO = OR(ISEQN,AND(MASKLO,SEQNO))
      GO TO 70
C
C     WE ARE BEFORE REENTRY POINT - CHECK APPROACH AND TYPE OF RESTART
C     ALWAYS RAISE EXECUTE FLAG FOR INSERT FOR MODIFIED RESTARTS.
C
   30 IF (INSERT.NE.0 .AND. START.EQ.IMST) GO TO 70
      IF (START .EQ. IMST) GO TO 40
C
C     LOWER EXECUTE FLAG FOR UNMODIFIED RESTART RUNS.
C
      OSCAR(OSPNT+5) = AND(NOSGN,OSCAR(OSPNT+5))
      IF (MPLER .EQ. 5) GO TO 90
      RETURN
C
C     FOR RIGID FORMAT - CHECK DECISION TABLE FOR MODIFIED RESTART
C
   40 I = MED(MEDTP+1)
      DO 50 J = 1,I
      K = MEDPNT + J - 1
      IF (AND(MED(K),MEDMSK(J)) .NE. 0) GO TO 70
   50 CONTINUE
      OSCAR(OSPNT+5) = AND(NOSGN,OSCAR(OSPNT+5))
   70 IF (OSCAR(OSPNT+3).EQ.XCHK .AND. CPFLG.EQ.0)
     1    OSCAR(OSPNT+5) = AND(NOSGN,OSCAR(OSPNT+5))
      IF (OSCAR(OSPNT+5).GE.0 .AND. MPLER.NE.5) RETURN
C
C     PRINT COMPILE/EXECUTE FLAG FOR RESTART
C
   90 IF (START.EQ.ICST   .OR.  IFIRST.EQ.0) RETURN
      IF (DMPCNT.EQ.IFLAG .AND. INSERT.EQ.0) RETURN
      IFLAG = DMPCNT
      I = 7
      IF (MPLER .EQ. 5) I = 10
      CALL XGPIMW (I,0,0,0)
      RETURN
      END

      SUBROUTINE RFOPEN (MEMBER,LU)
C
C     THIS .MIS ROUTINE OPENS THE RIGID FORMAT FILE, AS AN ORDINARY
C     FORTRAN FILE. USE REGULAR FORTRAN READ TO READ THE FILE
C
C     ENTRY POINT RFCLSE TO CLOSE IT
C
C     IF RIGID FORMAT FILE OPENS OK, LU IS THE FORTRAN UNIT NUMBER
C     OTHERWISE, LU = 0
C
C     THIS ROUTINE REPLACES ALL THE MACHINE DEPENDENT DSXOPN, DSXCLS,
C     DSXREA, AND DSXFRE ROUTINES. PLUS DSXRDS, DSXIO, AND DSXSIO IN
C     IBM VERSION, AND DSXRET AND DSXZER IN CDC
C
C     NOTE - FORTRAN UNIT 'IN' IS USED TO READ THE RIGID FORMAT FILE.
C            UNIT 'IN' IS SYNCHRONOUS WITH ANY READFILE OR NESTED
C            READFILE OPERATION.
C
C     WRITTEN BY G.CHAN/UNISYS.   10/1990
C
      INTEGER         MEMBER(2),FACSF
      CHARACTER*1     BK,MB1(8)
      CHARACTER       MB5*5,MB6*6
      CHARACTER*8     MB8,FREE8,ADD(3)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25
CWKBI
      CHARACTER*44    RFDIR, DSN
      COMMON /XMSSG / UFM,UWM,UIM,SFM
      COMMON /MACHIN/ MACH
      COMMON /XXREAD/ IN
      COMMON /SYSTEM/ IBUF,NOUT,NOGO
      EQUIVALENCE     (MB1(1),MB5,MB6,MB8)
      DATA    BK,     ADD(1),   ADD(3), FREE8     /
     1        ' '   , '@ADD,E ',' .  ', '@FREE   '/
C
      CALL A42K8 (MEMBER(1),MEMBER(2),MB8)
      IF (MACH .EQ. 3) GO TO 30
      IN = IN + 1
      IF (IN .LT. 60) IN = 60
      J  = 5
      IF (MB1(6) .NE. BK) J = 6
C
C           DUMMY  IBM  UNVC  CDC  VAX  ULTRIX  SUN   AIX   HP
C             S/G  MAC  CRAY CNVX  NEC  FUJTSU   DG  AMDL PRIME
C             486 DUMMY ALFA RESV
C            ---- ----  ---- ---- ----  ------ ----  ---- -----
      GO TO (  60,  50,   30,  50,  50,     50,  50,   50,  50,
     1         50,  70,   70,  70,  70,     70,  70,   70,  70,
     2         50,  60,   50,  70), MACH
C
C     UNIVAC ONLY -
C     ADD FILE TO INPUT STREAM
C
 30   ADD(2) = MB8
      J = FACSF(ADD)
      LU = 5
      GO TO 130
50    CONTINUE
      RFDIR = ' '
      CALL GETENV ( 'RFDIR', RFDIR )
      DO 55 I = 44, 1, -1
      IF ( RFDIR( I:I ) .EQ. ' ' ) GO TO 55
      LENR = I
      GO TO 56
55    CONTINUE
      LENR = 44
56    DSN = ' '
      DSN = RFDIR(1:LENR) // '/' // MB6
CWKBR IF (J .EQ. 6) OPEN (UNIT=IN,FILE=MB6,ACCESS='SEQUENTIAL',ERR=100,
      OPEN (UNIT=IN,FILE=DSN,ACCESS='SEQUENTIAL',ERR=100,
     1                    FORM='FORMATTED',STATUS='OLD')
      GO TO 80
C
C     OTHERS -
C
 60   GO TO 100
C
 70   OPEN (UNIT=IN,FILE=MB8,ACCESS='SEQUENTIAL',ERR=100,STATUS='OLD',
     1      FORM='FORMATTED')
C
C     VERIFY FILE EXISTANCE
C
 80   READ (IN,90,ERR=100,END=100) J
 90   FORMAT (A1)
      REWIND IN
      LU = IN
      GO TO 130
C
CWKBR100  WRITE  (NOUT,110) SFM,MB8
 100  WRITE  (NOUT,110) SFM,DSN
CWKBR 110  FORMAT (A25,', RFOPEN CAN NOT OPEN ',A8)
 110  FORMAT (A25,', RFOPEN CAN NOT OPEN ',A44)
C
      IF (MACH.GT.7 .AND. MACH.NE.21) WRITE (NOUT,120) MACH
 120  FORMAT (5X,'MACHINE',I4,' IS NOT AVAILABLE/RFOPEN')
      LU   = 0
      NOGO = 1
C
 130  RETURN
C
C
      ENTRY RFCLSE (LU)
C     =================
C
      IF (MACH .EQ. 3) GO TO 150
      IF (LU  .LT. 60) WRITE (NOUT,140) SFM,LU
 140  FORMAT (A25,'. RFCLSE/RFOPEN ERROR.  LU =',I4)
      CLOSE (UNIT=LU)
      IN = IN - 1
      IF (IN .LT. 60) IN = 0
      GO TO 160
C
 150  ADD(1) = FREE8
      J = FACSF(ADD)
 160  LU = 0
      RETURN
      END

      SUBROUTINE MRED2M (NUF,N2,NUS)
C
C     THIS SUBROUTINE FORMS THE HK MATRIX FOR THE MRED2 MODULE.
C
      INTEGER         DRY,GBUF1,OTFILE,Z,TYPIN,TYPOUT,HKPG,PHI12I,HK,
     1                RPRTN,CPRTN
      DIMENSION       ITRLR1(7),MODNAM(2),ITRLR2(7),ISUB(4),RZ(1)
      COMMON /BLANK / IDUM1,DRY,IDUM4,GBUF1,IDUM2(17),OTFILE(6),
     1                ISCR(10),KORLEN,KORBGN,IDUM3(14),NMODES
      COMMON /ZZZZZZ/ Z(1)
      COMMON /PACKX / TYPIN,TYPOUT,IROW,NROW,INCR
      EQUIVALENCE     (HK,ISCR(2)),(IDENT,ISCR(8)),(HKPG,ISCR(3)),
     1                (PHI12I,ISCR(8)),(CPRTN,ISCR(9)),(RPRTN,ISCR(9))
      EQUIVALENCE     (RZ(1),Z(1))
      DATA    MODNAM/ 4HMRED,4H2M  /
C
C     FORM HK MATRIX
C
C        **  **   **             **
C        *    *   *      .        *
C        * HK * = * HKPG . PHI12I *
C        *    *   *      .        *
C        **  **   **             **
C
      IF (DRY .EQ. -2) RETURN
      IF (NUF .EQ.  0) GO TO 30
      ITRLR1(1) = HKPG
      CALL RDTRL (ITRLR1)
      ITRLR2(1) = PHI12I
      CALL RDTRL (ITRLR2)
      INCR    = 1
      TYPIN   = 1
      TYPOUT  = 1
      IROW    = 1
      NROW    = ITRLR1(3) + ITRLR2(3)
      ISUB(1) = ITRLR1(3)
      ISUB(2) = ITRLR2(3)
      DO 20 I = 1,NROW
      RZ(KORBGN+I-1) = 0.0
      IF (I .GT. ITRLR1(3)) RZ(KORBGN+I-1) = 1.0
   20 CONTINUE
      IFORM = 7
      CALL MAKMCB (ITRLR2,RPRTN,NROW,IFORM,TYPIN)
      CALL GOPEN (RPRTN,Z(GBUF1),1)
      CALL PACK (Z(KORBGN),RPRTN,ITRLR2)
      CALL CLOSE (RPRTN,1)
      CALL WRTTRL (ITRLR2)
      ITYPE = 2
      CALL GMMERG (HK,HKPG,0,PHI12I,0,RPRTN,0,ISUB,ITYPE,Z(KORBGN),
     1            KORLEN)
      RETURN
C
C     NO UF POINTS
C
C        **  **   **     **
C        *    *   *   .   *
C        * HK * = * 0 . I *
C        *    *   *   .   *
C        **  **   **     **
C
   30 TYPIN  = 1
      TYPOUT = 1
      IROW   = 1
      NROW   = NMODES
      INCR   = 1
      IFORM  = 8
      IF (KORBGN+NMODES .GE. KORLEN) GO TO 100
C
C     GENERATE IDENTITY MATRIX
C
      CALL MAKMCB (ITRLR2,IDENT,NMODES,IFORM,TYPIN)
      CALL GOPEN  (IDENT,Z(GBUF1),1)
      DO 70 I = 1,NMODES
      DO 60 J = 1,NMODES
      RZ(KORBGN+J-1) = 0.0
      IF (J .EQ. I) RZ(KORBGN+J-1) = 1.0
   60 CONTINUE
   70 CALL PACK (Z(KORBGN),IDENT,ITRLR2)
      CALL CLOSE (IDENT,1)
      CALL WRTTRL (ITRLR2)
C
C     GENERATE ROW PARTITIONING VECTOR
C
      NROW = NUS + NMODES
      IF (KORBGN+NROW .GE. KORLEN) GO TO 100
      J = NROW
      DO 90 I = 1,J
      RZ(KORBGN+I-1) = 0.0
      IF (I .GT. NUS) RZ(KORBGN+I-1) = 1.0
   90 CONTINUE
      IFORM = 7
      CALL MAKMCB (ITRLR2,RPRTN,NROW,IFORM,TYPIN)
      CALL GOPEN (RPRTN,Z(GBUF1),1)
      CALL PACK (Z(KORBGN),RPRTN,ITRLR2)
      CALL CLOSE (RPRTN,1)
      CALL WRTTRL (ITRLR2)
C
C     FORM HK MATRIX
C
      ISUB(1) = NUS
      ISUB(2) = NMODES
      ITYPE   = 2
      CALL GMMERG (HK,0,0,IDENT,0,RPRTN,0,ISUB,ITYPE,Z(KORBGN),KORLEN)
      RETURN
C
C     PROCESS SYSTEM ERRORS
C
  100 IMSG  =-8
      IFILE = 0
      CALL SOFCLS
      CALL MESAGE (IMSG,IFILE,MODNAM)
      RETURN
C
      END

      SUBROUTINE NORMAL
C
C     THIS IS THE DRIVER FOR THE NORM MODULE.
C
C     NORM        INMAT/OUTMAT/S,N,NCOL/S,N,NROW/S,N,XNORM/V,Y,IOPT $
C
C     DEPENDING ON THE VALUE OF IOPT, THIS MODULE PERFORMS THE
C     FOLLOWING FUNCTIONS --
C
C     IOPT = 'MAX'
C                 NORM GENERATES A MATRIX.  EACH COLUMN OF THIS OUTPUT
C                 MATRIX REPRESENTS A COLUMN OF THE INPUT MATRIX
C                 NORMALIZED BY ITS LARGEST ROW ELEMENT. (DEFAULT)
C
C     IOPT = 'SRSS'
C                 NORM GENERATES A COLUMN VECTOR.  EACH ELEMENT OF THIS
C                 VECTOR REPRESENTS THE SQUARE ROOT OF THE SUM OF THE
C                 SQUARES (SRSS) OF THE CORRESPONDING ROW OF THE INPUT
C                 MATRIX.
C
C
C
C     INPUT DATA BLOCK --
C
C     INMAT     - ANY MATRIX
C
C     OUTPUT DATA BLOCK --
C
C     OUTMAT    - OUTPUT MATRIX GENERATED AS DESCRIBED BELOW
C
C     PARAMETERS --
C
C     NCOL      - NO. OF COLUMNS OF THE INPUT MATRIX (OUTPUT/INTEGER)
C
C     NROW      - NO. OF ROWS OF THE INPUT MATRIX (OUTPUT/INTEGER)
C
C     XNORM     - MAX. NORMALIZING OR SRSS VALUE, DEPENDING UPON THE
C                 IOPT VALUE SPECIFIED (OUTPUT/REAL)
C     IOPT      - OPTION INDICATING WHETHER EACH COLUMN OF THE INPUT
C                 MATRIX IS TO BE NORMALIZED BY THE MAXIMUM ROW ELEMENT
C                 IN THAT COLUMN OR WHETHER THE SRSS VALUE FOR EACH ROW
C                 OF THE INPUT MATRIX IS TO BE COMPUTED (INPUT/BCD)
C
C     THIS MODULE DEVELOPED BY P. R. PAMIDI OF RPK CORPORATION,
C     MARCH 1988
C
      DIMENSION        MCB(7), Z(1)   , ISUBNM(2)
      DOUBLE PRECISION DXMAX , ZD(1)  , DZERO
      CHARACTER        UFM*23
      COMMON /XMSSG /  UFM
      COMMON /BLANK /  NCOL   , NROW   , XXMAX , IOPT(2)
      COMMON /PACKX /  IPKOT1 , IPKOT2 , IP1   , IP2   , INCRP
      COMMON /SYSTEM/  ISYSBF , NOUT
      COMMON /TYPE  /  IPRC(2), NWDS(4), IRC(4)
      COMMON /UNPAKX/  IUNOUT , IU1    , IU2   , INCRU
      COMMON /ZZZZZZ/  IZ(1)
      EQUIVALENCE      (IZ(1),Z(1),ZD(1)), (IOPT1,IOPT(1))
      DATA    MATIN ,  MATOUT / 101, 201/
      DATA    ISUBNM,           MAX     , ISRSS , IBLNK  , DZERO  /
     1        4HNORM,  4HAL   , 4HMAX   , 4HSRSS, 4H     , 0.0D+0 /
C
      IF (IOPT(2).EQ.IBLNK .AND. (IOPT1.EQ.MAX .OR. IOPT1.EQ.ISRSS))
     1    GO TO 20
      WRITE  (NOUT,10) UFM,IOPT
   10 FORMAT (A23,', ILLEGAL BCD VALUE (', 2A4,') FOR THE 4TH PARAMATER'
     1,      ' IN MODULE NORM')
      CALL MESAGE (-61,0,0)
   20 INCRU  = 1
      INCRP  = 1
      ICORE  = KORSZ(IZ)
      IBUF1  = ICORE - ISYSBF + 1
      IBUF2  = IBUF1 - ISYSBF
      ICORE  = IBUF2 - 1
      CALL GOPEN (MATIN ,IZ(IBUF1),0)
      CALL GOPEN (MATOUT,IZ(IBUF2),1)
      MCB(1) = MATIN
      CALL RDTRL (MCB)
      NCOL   = MCB(2)
      NROW   = MCB(3)
      NROW2  = 2*NROW
      ITYPE  = MCB(5)
      IPREC  = ITYPE
      IF (IPREC .GT. 2) IPREC = IPREC - 2
      IUNOUT = ITYPE
      IPKOT1 = ITYPE
      IPKOT2 = ITYPE
      NROWP  = IPREC*NROW
      NWORDS = NWDS(ITYPE)
      MWORDS = NROW*NWORDS
      KWORDS = MWORDS
      IF (IOPT1 .NE. MAX) KWORDS = KWORDS + NROWP
      ICRREQ = KWORDS - ICORE
      IF (ICRREQ .GT. 0) CALL MESAGE (-8,ICRREQ,ISUBNM)
      IVEC   = MWORDS
      IVEC1  = IVEC + 1
      IVEC2  = IVEC + NROWP
      IF (IOPT1 .EQ. MAX) GO TO 40
      MCB(5) = IPREC
      IPKOT1 = IPREC
      IPKOT2 = IPREC
      DO 30 I= IVEC1,IVEC2
   30 Z(I)   = 0.0
   40 MCB(1) = MATOUT
      MCB(2) = 0
      MCB(6) = 0
      MCB(7) = 0
      IU1    = 1
      IU2    = NROW
C
      XXMAX  = 0.0
      DO 700 I = 1,NCOL
      XX   = 0.0
      CALL UNPACK (*50,MATIN,Z)
      IP1  = IU1
      IP2  = IU2
      XMAX =-1.0
      GO TO 70
   50 IP1  = 1
      IP2  = 1
      XMAX = 0.0
      DO 60 J = 1,NWORDS
      Z(J) = 0.0
   60 CONTINUE
C
   70 IF (IOPT1 .EQ. ISRSS) GO TO 600
      IF (XMAX  .EQ.   0.0) GO TO 510
C
C     OPTION IS MAX
C
      GO TO (100,200,300,400), ITYPE
C
  100 XMAX = 0.0
      DO 110 J = 1,NROW
      X = ABS(Z(J))
      IF (X .GT. XMAX) XMAX = X
  110 CONTINUE
      IF (XMAX .EQ. 0.0) GO TO 510
      XX = XMAX
      DO 120 J = 1,NROW
      Z(J) = Z(J)/XMAX
  120 CONTINUE
      GO TO 500
C
  200 DXMAX = DZERO
      DO 210 J = 1,NROW
      DX = DABS(ZD(J))
      IF (DX .GT. DXMAX) DXMAX = DX
  210 CONTINUE
      IF (DXMAX .EQ. DZERO) GO TO 510
      XX = DXMAX
      DO 220 J = 1,NROW
      ZD(J) = ZD(J)/DXMAX
  220 CONTINUE
      GO TO 500
C
  300 XMAX = 0.0
      DO 310 J = 1,NROW2,2
      X = SQRT(Z(J)*Z(J) + Z(J+1)**2)
      IF (X .GT. XMAX) XMAX = X
  310 CONTINUE
      IF (XMAX .EQ. 0.0) GO TO 510
      XX = XMAX
      DO 320 J = 1,NROW2,2
      Z(J  ) = Z(J  )/XMAX
      Z(J+1) = Z(J+1)/XMAX
  320 CONTINUE
      GO TO 500
C
  400 DXMAX = DZERO
      DO 410 J = 1,NROW2,2
      DX = DSQRT(ZD(J)*ZD(J) + ZD(J+1)**2)
      IF (DX .GT. DXMAX) DXMAX = DX
  410 CONTINUE
      IF (DXMAX .EQ. DZERO) GO TO 510
      XX = DXMAX
      DO 420 J = 1,NROW2,2
      ZD(J  ) = ZD(J  )/DXMAX
      ZD(J+1) = ZD(J+1)/DXMAX
  420 CONTINUE
C
  500 IF (XX .GT. XXMAX) XXMAX = XX
  510 CALL PACK (Z,MATOUT,MCB)
      GO TO 700
C
C     OPTION IS SRSS
C
  600 IF (XMAX .EQ. 0.0) GO TO 700
      GO TO (610,630,650,670), ITYPE
C
  610 DO 620 J = 1,NROW
      K = IVEC + J
      Z(K) = Z(K) + Z(J)*Z(J)
  620 CONTINUE
      GO TO 700
C
  630 DO 640 J = 1,NROW
      K = IVEC + J
      ZD(K) = ZD(K) + ZD(J)*ZD(J)
  640 CONTINUE
      GO TO 700
C
  650 K = IVEC
      DO 660 J = 1,NROW2,2
      K = K + 1
      Z(K) = Z(K) + Z(J)*Z(J) + Z(J+1)**2
  660 CONTINUE
      GO TO 700
C
  670 K = IVEC
      DO 680 J = 1,NROW2,2
      K = K + 1
      ZD(K) = ZD(K) + ZD(J)*ZD(J) + ZD(J+1)**2
  680 CONTINUE
C
  700 CONTINUE
      CALL CLOSE (MATIN, 1)
      IF (IOPT1 .EQ. MAX) GO TO 760
C
      IP1 = IU1
      IP2 = IU2
      GO TO (710,730), IPREC
C
  710 DO 720 I = IVEC1,IVEC2
      Z(I) = SQRT(Z(I))
      IF (Z(I) .GT. XXMAX) XXMAX = Z(I)
  720 CONTINUE
      GO TO 750
C
  730 DO 740 I = IVEC1,IVEC2
      ZD(I) = DSQRT(ZD(I))
      IF (ZD(I) .GT. XXMAX) XXMAX = ZD(I)
  740 CONTINUE
C
  750 CALL PACK (Z(IVEC1),MATOUT,MCB)
C
  760 CALL CLOSE (MATOUT,1)
      CALL WRTTRL (MCB)
      RETURN
      END

      SUBROUTINE INPTT3
C
C     THIS ROUTINE READS MATRIX DATA FROM AN INPUT TAPE, WRITTEN IN
C     ROCKWELL INTERNATIONAL COMPANY'S CUSTOMARY FORMAT, INTO NASTRAN
C     GINO MATRIX BLOCK.
C     (THE RI DATA IS IN A COMPACT FORTRAN-FORMATTED CODED FORM, DOUBLE
C     PRECISION, WHCIH APPEARS TO HAVE QUITE WIDESPREAD ACCEPTANCE IN
C     THE AEROSPACE FIELD, AND PARTICULARY IN MARSHALL SPACE FLIEGHT
C     CENTER (MSFC) AREA)
C
C     WRITTEN ORIGINALLY BY MEL MARTENS, ROCKWELL INTERNATIONAL, SPACE
C     DIVISION (213) 922-2316, AND MODIFIED UP TO NASTRAN STANDARD BY
C     G.CHAN/UNISYS, 2/1987
C
C     INPTT3  /O1,O2,O3,O4,O5/V,N,UNIT/V,N,ERRFLG/V,N,TEST  $
C
C             UNIT  = FORTRAN INPUT TAPE UNIT NO.
C                     TAPE IS REWOUND BEFORE READ IF UNIT IS NEGATIVE
C                     FORTRAN UNIT 11 (INPT) IS USED IF UNIT= 0 OR -1.
C             ERRFLG= 1, JOB TERMINATED IF DATA BLOCK ON TAPE NO FOUND
C                     0, NO TERMINATION IF DATA BLOCK NO FOUND ON TAPE
C             TEST  = 0, NO CHECK ON FILE NAMES ON TAPE AND DMAP NAMES
C                   = 1, NAMES CHECK, WILL SEARCH TAPE FOR MATCH.
C
      IMPLICIT INTEGER (A-Z)
      INTEGER          MCB(7),  NAME(2),  NAMX(2), SUBNAM(2)
      DOUBLE PRECISION DZ(1)
      CHARACTER        UFM*23,  UWM*25,   UIM*29
      COMMON /XMSSG /  UFM,     UWM,      UIM
      COMMON /SYSTEM/  IBUF,    NOUT
      COMMON /PACKX /  TYPIN,   TYPOUT,   II,      JJ,      INCR
      COMMON /ZZZZZZ/  Z(1)
      COMMON /BLANK /  UNIT,    ERRFLG,   TEST
      COMMON /NAMES /  RD,      RDREW,    WRT,     WRTREW,  REW
      EQUIVALENCE      (Z(1),DZ(1))
      DATA             END,     HEAD,     SUBNAM                  /
     1                 -999,    -111,     4HINPT,  4HT3           /
C
      CORE = KORSZ(Z(1))
      BUF1 = CORE - IBUF + 1
      CORE = BUF1 - 1
      TYPIN= 2
      TYPOUT=2
      INCR = 1
C
      IU = UNIT
      IF (UNIT.EQ.0 .OR. UNIT.EQ.-1) IU = -11
      IF (IU .GT. 0) GO TO 10
      IU  = -IU
      IREW= 0
      REWIND IU
C
   10 DO 150 K = 1,5
      FILE = 200 + K
      MCB(1) = FILE
      CALL RDTRL (MCB)
      IF (MCB(1) .LE. 0) GO TO 150
      CALL GOPEN (FILE,Z(BUF1),WRTREW)
      CALL FNAME (FILE,NAME)
   20 READ (IU,30,ERR=160,END=180) I,NAMX
   30 FORMAT (I6,2A4)
      IF (I .GT.    0) GO TO 20
      IF (I .EQ.  END) GO TO 120
      IF (I .NE. HEAD) GO TO 130
      IF (NAMX(1).EQ.NAME(1) .AND. NAMX(2).EQ.NAME(2)) GO TO 50
      WRITE  (NOUT,40) UIM,NAMX,NAME
   40 FORMAT (A29,', DATA BLOCK ',2A4,' FOUND WHILE SEARCHING FOR ',2A4)
      IF (TEST) 20,70,20
C
C     FOUND
C
   50 WRITE  (NOUT,60) UIM,NAME
   60 FORMAT (A29,', DATA BLOCK ',2A4,' FOUND')
   70 READ   (IU,80) NR,NC,TYPE
   80 FORMAT (3I6)
      WRITE  (NOUT,90) NAME,NC,NR,TYPE
   90 FORMAT (/5X,'MATRIX BLOCK ',2A4,' IS OF SIZE ',I6,'(COL) BY',I5,
     1       '(ROW),  AND TYPE =',I6)
      IF (NR .GT. CORE) CALL MESAGE (-8,NR-CORE,SUBNAM)
      IREW= 1
      II  = 1
      JJ  = NR
      CALL MAKMCB (MCB,FILE,NR,TYPE,2)
      DO 110 I = 1,NC
      READ (IU,100,ERR=160,END=180) (DZ(J),J=1,NR)
  100 FORMAT (12X,1P,5D24.16)
      CALL PACK (Z,FILE,MCB)
  110 CONTINUE
      CALL CLOSE (FILE,REW)
      CALL WRTTRL (MCB)
      GO TO 150
C
  120 IF (IREW .EQ. 0) GO TO 130
      REWIND IU
      IREW = 0
      GO TO 20
  130 WRITE  (NOUT,140) UWM,NAME
  140 FORMAT (A25,', INPTT3 FAILED TO LOCATE DATA BLOCK ',2A4,' ON ',
     1       'TAPE')
      IF (ERRFLG .NE. 0) CALL MESAGE (-61,0,SUBNAM)
      REWIND IU
      IREW = 0
  150 CONTINUE
      RETURN
C
  160 WRITE  (NOUT,170) IU
  170 FORMAT ('0*** ERROR DUING READ.  TAPE UNIT',I5)
      CALL CLOSE (FILE,REW)
      CALL MESAGE (-61,0,SUBNAM)
  180 WRITE  (NOUT,190) UWM,IU
  190 FORMAT (A25,' FROM INPTT3, EOF ENCOUNTERED ON INPUT TAPE',I4)
      CALL CLOSE  (FILE,REW)
      CALL WRTTRL (MCB)
      RETURN
      END

      SUBROUTINE TMTSLP
C
C     TMTSLP TIME TESTS CPU TIMES FOR VARIOUS TYPES OF LOOPS
C
C     COMMENT FROM G.CHAN/UNISYS   5/91
C     BASICALLY THIS ROUTINE IS SAME AS TIMTS2
C
C     IF ALL TIMING CONSTANTS ARE ZEROS (OR 0.001) SYSTEM HAS A WRONG
C     CPUTIM.MDS SUBROUTINE. MOST LIKELY THE CPUTIM.MIS IS BEING USED.
C
      INTEGER          SYSBUF,BUF1,BUF2,END,END2,END4,TYPE,ISUBR(2)
      REAL             B(1),C(1),D(1),E(16)
      COMPLEX          AC(1),BC(1),CC(1),DC(1),ADNC
      DOUBLE PRECISION ADND,AD(1),BD(1),CD(1),DD(1)
      COMMON /MACHIN/  MACH
      COMMON /NTIME /  NITEMS,TGINO ,TBLDPK,TINTPK,TPACK ,
     1                 TUNPAK,TGETST,TPUTST,
     2                 TTLRSP,TTLRDP,TTLCSP,TTLCDP,
     3                 TLLRSP,TLLRDP,TLLCSP,TLLCDP,TGETSB
      COMMON /SYSTEM/  SYSBUF,NOUT,SKIP(74),ISY77
      COMMON /ZZZZZZ/  A(1)
      EQUIVALENCE      (A(1),AC(1),AD(1),B(1),BC(1),BD(1),C(1),CC(1),
     1                 CD(1),D(1),DC(1),DD(1)),    (E(1),TGINO)
      DATA    ISUBR /  4HTMTS, 4HLP  /
C
C     INITIALIZE
C     DOUBLE N SIZE SINCE VAX (AND UNIX) CLOCK MAY NOT TICK FAST ENOUGH
C
      N = 50
      IF (MACH .GE. 5) N = 100
      M = N
C
      BUF1 = KORSZ(A) - SYSBUF
      BUF2 = BUF1 - SYSBUF
      END  = N*M
      IF (END .GE. BUF1-1) CALL MESAGE (-8,0,ISUBR)
C
C     CPU TIME TESTS
C
      ASQ  = M + N
      ADNO = 1/(ASQ*ASQ)
      ADND = ADNO
      ADNC = CMPLX(ADNO,ADNO)
      END2 = END/2
      END4 = END/4
      DO 420 TYPE = 1,4
      GO TO (10,90,170,250), TYPE
C
C     REAL CPU TIME TESTS
C
   10 CONTINUE
C
      IF (M.GT.END .OR. N.GT.END) CALL MESAGE (-8,0,ISUBR)
      DO 20 I = 1,END
   20 A(I) = ADNO
      CALL CPUTIM (T1,T1,1)
      DO 40 I = 1,N
      DO 30 J = 1,M
      D(J) = A(J)*B(J) + C(J)
   30 CONTINUE
   40 CONTINUE
      CALL CPUTIM (T2,T2,1)
      ASSIGN 340 TO IRET
      GO TO 330
   50 CONTINUE
C
      DO 60 I = 1,END
   60 A(I) = ADNO
      CALL CPUTIM (T1,T1,1)
      DO 80 I = 1,N
      DO 70 J = 1,M
      L = I + J - 1
      D(J) = A(I)*B(L) + C(J)
   70 CONTINUE
   80 CONTINUE
      CALL CPUTIM (T2,T2,1)
      ASSIGN 350 TO IRET
      GO TO 330
C
C     DOUBLE PRECISION TESTS
C
   90 CONTINUE
C
      IF (M.GT.END2 .OR. N.GT.END2) CALL MESAGE (-8,0,ISUBR)
      DO 100 I = 1,END2
  100 AD(I) = ADND
      CALL CPUTIM (T1,T1,1)
      DO 120 I = 1,N
      DO 110 J = 1,M
      DD(J) = AD(J)*BD(J) + CD(J)
  110 CONTINUE
  120 CONTINUE
      CALL CPUTIM (T2,T2,1)
      ASSIGN 360 TO IRET
      GO TO 330
  130 CONTINUE
C
      DO 140 I = 1,END2
  140 AD(I) = ADND
      CALL CPUTIM (T1,T1,1)
      DO 160 I = 1,N
      DO 150 J = 1,M
      L = I + J - 1
      DD(J) = AD(I)*BD(L) + CD(J)
  150 CONTINUE
  160 CONTINUE
      CALL CPUTIM (T2,T2,1)
      ASSIGN 370 TO IRET
      GO TO 330
C
C     COMPLEX SINGLE PRECISION TESTS
C
  170 CONTINUE
C
      IF (M.GT.END2 .OR. N.GT.END2) CALL MESAGE (-8,0,ISUBR)
      DO 180 I = 1,END2
  180 AC(I) = ADNC
      CALL CPUTIM (T1,T1,1)
      DO 200 I = 1,N
      DO 190 J = 1,M
      DC(J) = AC(J)*BC(J) + CC(J)
  190 CONTINUE
  200 CONTINUE
      CALL CPUTIM (T2,T2,1)
      ASSIGN 380 TO IRET
      GO TO 330
  210 CONTINUE
C
      DO 220 I = 1,END2
  220 AC(I) = ADNC
      CALL CPUTIM (T1,T1,1)
      DO 240 I = 1,N
      DO 230 J = 1,M
      L = I + J - 1
      DC(J) = AC(I)*BC(L) + CC(J)
  230 CONTINUE
  240 CONTINUE
      CALL CPUTIM (T2,T2,1)
      ASSIGN 390 TO IRET
      GO TO 330
C
C     DOUBLE PRECISION COMPLEX TESTS
C
  250 CONTINUE
C
      IF (M.GT.END4 .OR. N.GT.END4) CALL MESAGE (-8,0,ISUBR)
      DO 260 I = 1,END2
  260 AD(I) = ADND
      CALL CPUTIM (T1,T1,1)
      DO 280 I = 1,N
      DO 270 J = 1,M
C
C     D(J) AND D(J+1) CALCULATIONS WERE REVERSED
C     IN ORDER TO COUNTERACT THE ITERATIVE BUILD UP
C
      DD(J+1) = AD(J)*BD(J  ) - AD(J+1)*BD(J+1) + CD(J  )
      DD(J  ) = AD(J)*BD(J+1) + AD(J+1)*BD(J  ) + CD(J+1)
  270 CONTINUE
  280 CONTINUE
      CALL CPUTIM (T2,T2,1)
      ASSIGN 400 TO IRET
      GO TO 330
  290 CONTINUE
C
      DO 300 I = 1,END2
  300 AD(I) = ADND
      CALL CPUTIM (T1,T1,1)
      DO 320 I = 1,N
      DO 310 J = 1,M
      L = I + J - 1
      DD(J  ) = AD(I)*BD(L  ) - AD(I+1)*BD(L+1) + CD(J  )
      DD(J+1) = AD(I)*BD(L+1) + AD(I+1)*BD(L  ) + CD(J+1)
  310 CONTINUE
  320 CONTINUE
      CALL CPUTIM (T2,T2,1)
      ASSIGN 410 TO IRET
C
C
C     INTERNAL ROUTINE TO STORE TIMING DATA IN /NTIME/ COMMON BLOCK
C
  330 TIME = T2 - T1
      ITOT = M*N
      TPEROP = 1.0E6*TIME/ITOT
      GO TO IRET, (340,350,360,370,380,390,400,410)
  340 TTLRSP = TPEROP
      GO TO 50
  350 TLLRSP = TPEROP
      GO TO 420
  360 TTLRDP = TPEROP
      GO TO 130
  370 TLLRDP = TPEROP
      GO TO 420
  380 TTLCSP = TPEROP
      GO TO 210
  390 TLLCSP = TPEROP
      GO TO 420
  400 TTLCDP = TPEROP
      GO TO 290
  410 TLLCDP = TPEROP
  420 CONTINUE
C
C     MAKE SURE ALL TIME CONTSTANTS ARE OK
C
      DO 430 I = 1,NITEMS
      IF (ISY77.EQ.-3 .AND. E(I).LT.0.001) E(I) = 0.001
      IF (ISY77.NE.-3 .AND. E(I).LT.1.E-7) E(I) = 1.E-7
  430 CONTINUE
      IF (ISY77 .NE. -3) GO TO 460
      WRITE  (NOUT,440) NITEMS,NITEMS,E
  440 FORMAT ('0*** NASTRAN SYSTEM MESSAGE. IF THESE',I4,' NEW TIMING',
     1   ' CONSTANTS ARE HARD-CODED INTO THE LABEL COMMON /NTIME/ OF',
     2   /5X, 'SUBROUTINE SEMDBD, COMPILE, AND RE-LINKE LINK 1, THE ',
     3   'COMPUTATIONS OF THESE CONSTANTS IN ALL NASTRAN JOBS WILL',/5X,
     4   'BE ELIMINATED.',  /5X,'OR TO ACCOMPLISH THE SAME RESULT, ',
     5   'EDIT THE TIM-LINE IN THE NASINFO FILE TO INCLUDE THESE',I4,
     6   ' NEW',/5X,'TIMING CONSTANTS', //5X,9F8.3, /5X,7F8.3,//)
      CALL PEXIT
  460 CALL SSWTCH (35,J)
      IF (J .NE. 0) CALL TMTSOT
C
      RETURN
      END

      SUBROUTINE RULER (RULE,ICP,ZRCT,ONCT,LIST,N,BUFF,IOPT)
C
C     DETERMINES STRING OF ZEROS AND ONES IN LIST BY APPLYING RULE TO
C     CP.
C
      EXTERNAL        ORF
      INTEGER         ZRCT,ONCT,OCT,RULE,EOL,ORF,ZCT
      DIMENSION       LIST(1),BUFF(1),ICP(1)
      COMMON /TWO   / TWO1(32)
      COMMON /ZNTPKX/ A1(4),L,EOL
C
C     PICK UP PARAMETERS
C
      EOL = 0
      R   = RULE
      NAMCP = ICP(1)
      ZCT = 0
      OCT = 0
      ASSIGN 150 TO IS
      IF (R .GE. 0.0) ASSIGN 140 TO IS
      R   = ABS(R)
      L   = 0
      J1  = 0
      M   = 0
      N1  = N
      IF (NAMCP .EQ. 0) GO TO 50
      CALL GOPEN (NAMCP,BUFF,0)
      CALL INTPK (*50,NAMCP,0,1,0)
      GO TO 60
   50 M   = N1
      EOL = 1
   60 DO 200 I = 1,N1
      J = (I+31)/32
      IF (M   .GE. I) GO TO 90
      IF (EOL .EQ. 0) GO TO 80
      L = N1
      A1(1) = 0.0
      GO TO 90
   80 CALL ZNTPKI
   90 IF (L .EQ. I) GO TO 110
      M = L
      A = 0.0
      GO TO 120
  110 A = A1(1)
  120 IF (IOPT.EQ.1 .OR. J.LE.J1) GO TO 130
      J1 = J
      LIST(J) = 0
  130 GO TO IS, (140,150)
  140 IF (A-R) 160,190,160
  150 IF (A-R) 160,190,200
  160 OCT = OCT + 1
      IF (IOPT .EQ. 1) GO TO 180
      K = I - ((I-1)/32)*32
      LIST(J) = ORF(LIST(J),TWO1(K))
      GO TO 200
  180 LIST(I) = OCT
      GO TO 200
  190 ZCT = ZCT + 1
      IF (IOPT .NE. 0) LIST(I) = -ZCT
  200 CONTINUE
      ZRCT = ZCT
      ONCT = OCT
      IF (NAMCP .NE. 0) CALL CLOSE (NAMCP,1)
      RETURN
      END

      SUBROUTINE XIPFL
C
C     THE PURPOSE OF XIOFL IS TO GENERATE THE INPUT AND OUTPUT FILE
C     SECTIONS FOR AN OSCAR ENTRY.
C
      EXTERNAL        ANDF,ORF
      INTEGER         DMPCNT,DMPPNT,BCDCNT,DMAP,OSPRC,OSBOT,OSPNT,
     1                OSCAR(1),OS(5),ANDF,ORF
      COMMON /XGPIC / ICOLD,ISLSH,IEQUL,NBLANK,NXEQUI,
C                  ** CONTROL CARD NAMES **
     1                NDIAG,NSOL,NDMAP,NESTM1,NESTM2,NEXIT,
C                  ** DMAP CARD NAMES **
     2                NBEGIN,NEND,NJUMP,NCOND,NREPT,NTIME,NSAVE,NOUTPT,
     3                NCHKPT,NPURGE,NEQUIV,NCPW,NBPC,NWPC,
     4                MASKHI,MASKLO,ISGNON,NOSGN,IALLON,MASKS(1)
      COMMON /ZZZZZZ/ CORE(1)
      COMMON /XGPI2 / LMPL,MPLPNT,MPL(1)
      COMMON /XGPI4 / IRTURN,INSERT,ISEQN,DMPCNT,
     1                IDMPNT,DMPPNT,BCDCNT,LENGTH,ICRDTP,ICHAR,NEWCRD,
     2                MODIDX,LDMAP,ISAVDW,DMAP(1)
      COMMON /PASSER/ ISTOPF,MODNAM,ICOMON
      EQUIVALENCE     (CORE(1),OS(1),LOSCAR),(OS(2),OSPRC),
     1                (OS(3),OSBOT),(OS(4),OSPNT),(OS(5),OSCAR(1))
C
C
C     SET INPUT FILE FLAG
C
      IOFL = 1
      K3   = 0
      ISTOPF = 0
      J = MPL(MPLPNT)
      MPLPNT = MPLPNT + 1
      IF (J .NE. 0) GO TO 8
C
C     NO INPUT FILES - MAKE ONE NULL ENTRY IN OSCAR
C
      OSCAR(OSPNT+6) = 1
      OSCAR(OSPNT+7) = 0
      OSCAR(OSPNT+8) = 0
      OSCAR(OSPNT+9) = 0
      OSCAR(OSPNT) = OSCAR(OSPNT) + 4
      GO TO 7
C
C
      ENTRY XOPFL
C     ===========
C
C     SET O/P FLAG
C
      IOFL = 0
      K3   = 0
      ISTOPF = 0
      J = MPL(MPLPNT)
      MPLPNT = MPLPNT + 1
      IF (J .NE. 0) GO TO 8
C
C     THERE ARE NO O/P FILES - CHANGE OSCAR ENTRY TYPE CODE TO O FORMAT
C
      OSCAR(OSPNT+2) = ORF(2,ANDF(MASKLO,OSCAR(OSPNT+2)))
      GO TO 7
C
C
C     SCAN INPUT OR OUTPUT SECTION
C
    8 I = OSPNT + OSCAR(OSPNT)
      ISTOPF   = I
      OSCAR(I) = J
      OSCAR(OSPNT) = 1 + OSCAR(OSPNT)
      I = I + 1
      J = I + 3*(J-1)
      OSCAR(OSPNT) = J + 3 - OSPNT
C
C     ZERO I/O SECTION
C
      L = J + 2
      DO 1 K = I,L
    1 OSCAR(K) = 0
C
C     ENTER FILE NAME IN OSCAR FROM DMAP
C
      DO 10 K = I,J,3
      CALL XSCNDM
      GO TO (30,2,20,30,20), IRTURN
C
C     OK IF NAME RETURNED FROM XSCNDM
C
    2 IF (DMAP(DMPPNT) .EQ. NBLANK) GO TO 10
C
C     ENTER NAME IN OSCAR AND INITIALIZE ORDNAL
C
      OSCAR(K  ) = DMAP(DMPPNT  )
      OSCAR(K+1) = DMAP(DMPPNT+1)
      OSCAR(K+2) = 0
   10 CONTINUE
    7 CALL XSCNDM
      GO TO (15,20,20,22,20), IRTURN
   15 IF (DMAP(DMPPNT+1) .EQ. ISLSH) GO TO 22
C
C     NORMAL EXIT IF DMAP OPERATOR IS /
C
C     ERROR EXIT
C     BLANK ITEM IN O/P SECTION OF TYPE O FORMAT IS OKAY
C
   20 IF (J.EQ.0 .AND. IOFL.EQ.0 .AND. DMAP(DMPPNT).EQ.NBLANK)
     1    GO TO 7
      K1 = 1 + (K-I)/3
      K2 = 1 + (J-I)/3
      IF (K1  .LE. K2) GO TO 21
      IF (K3  .EQ.  1) GO TO 7
      IF (IOFL .EQ. 1) CALL XGPIDG (62,OSPNT,0,0)
      IF (IOFL .EQ. 0) CALL XGPIDG (63,OSPNT,0,0)
      K3 = 1
      GO TO 7
   21 IRTURN = 2
      GO TO 25
   22 IRTURN = 1
   25 RETURN
C
C
C     DELIMITER OR END OF INSTRUCTION ENCOUNTERED BEFORE ANTICIPATED -
C     CHECK FOR ILLEGAL INPUT FORMAT
C
   30 IF (IOFL.NE.1 .OR. DMAP(DMPPNT+1).NE.ISLSH) GO TO 20
      IF (ICOMON .EQ. 0) GO TO 21
      ITYP = ANDF(OSCAR(OSPNT+2),7)
      IF (ITYP .EQ. 2) GO TO 22
C
C     FIRST INPUT FILE WAS NULL - SHIFT I/P SECTION BY ONE ENTRY AND
C     ZERO FIRST ENTRY
C     ISSUE WARNING MESSAGE
C
      CALL XGPIDG (-1,OSPNT,0,0)
      IF (I .EQ. J) GO TO 22
      I = I + 3
      J = J + 2
      DO 32 K = I,J
      L = J - K + I
   32 OSCAR(L  ) = OSCAR(L-3)
      OSCAR(I-3) = 0
      OSCAR(I-2) = 0
      OSCAR(I-1) = 0
      GO TO 22
      END

      SUBROUTINE RMG
C
C     RADIATION MATRIX GENERATOR MODULE.
C
C     DMAP CALLING SEQUENCE
C
C     RMG    EST,MATPOOL,GPTT,KGGX/RGG,QGE,KGG/C,Y,TABS/C,Y,SIGMA/
C            V,N,NLR/V,N,LUSET $
C
C     THIS MODULE COMPUTES AND OUTPUTS DATA IN SINGLE OR DOUBLE
C     PRECISION BASED ON -PRECIS-.
C
      LOGICAL          NOGO     ,DOUBLE   ,LRAD
      INTEGER          BUF(10)  ,SUBR(2)  ,RADLST(2),RADMTX(2),HBDYTP  ,
     1                 EST      ,GPTT     ,RGG      ,QGE      ,SCRT1   ,
     2                 SCRT2    ,SCRT3    ,SCRT4    ,SCRT5    ,SCRT6   ,
     3                 SYSBUF   ,OUTPT    ,TSET     ,PRECIS   ,UNOUT   ,
     4                 UNIROW   ,UNNROW   ,UNINCR   ,PKIN     ,PKOUT   ,
     5                 PKIROW   ,PKNROW   ,PKINCR   ,RD       ,RDREW   ,
     6                 WRT      ,WRTREW   ,CLSREW   ,CLS      ,ELEM    ,
     7                 Z        ,CORE     ,BUF1     ,BUF2     ,BUF3    ,
     8                 FLAG     ,WORDS    ,EOR      ,MCB1(7)  ,MCB2(7) ,
     9                 MCB3(7)  ,ELTYPE   ,ESTWDS   ,ECPT(100),RCOL    ,
     O                 DCOL     ,RX       ,DX       ,SQR      ,FILE    ,
     1                 DIRGG    ,DNRGG    ,IDATA(16),BLOCK(20),RADCHK  ,
     2                 MCB(7)   ,NAME(2)  ,RADTYP(2),BLOCK2(20)
      REAL             RZ(2)    ,RBUF(10) ,RDATA(16),AI(4)
      DOUBLE PRECISION DETT     ,MINDIA   ,DSUMFA   ,DO(2)    ,DI(2)   ,
     1                 DZ(1)    ,DTEMP2   ,DVALUE
      CHARACTER        UFM*23   ,UWM*25   ,UIM*29   ,SFM*25   ,SWM*27
      COMMON /XMSSG /  UFM      ,UWM      ,UIM      ,SFM      ,SWM
      COMMON /SYSTEM/  KSYSTM(65)
      COMMON /NAMES /  RD       ,RDREW    ,WRT      ,WRTREW   ,CLSREW  ,
     1                 CLS      ,SKIP5(5) ,SQR
      COMMON /ZBLPKX/  AO(4)    ,IROW
      COMMON /PACKX /  PKIN     ,PKOUT    ,PKIROW   ,PKNROW   ,PKINCR
      COMMON /UNPAKX/  UNOUT    ,UNIROW   ,UNNROW   ,UNINCR
      COMMON /GFBSX /  JL(7)    ,JU(7)    ,JB(7)    ,JX(7)    ,NZZZ    ,
     1                 IPR      ,ISGN
      COMMON /DCOMPX/  IA(7)    ,IL(7)    ,IU(7)    ,ISR1     ,ISR2    ,
     1                 ISR3     ,DETT     ,IPOW     ,NZZ      ,MINDIA  ,
     2                 IB       ,IBBAR
      COMMON /GPTA1 /  NELEMS   ,LAST     ,INCR     ,ELEM(1)
      COMMON /ZZZZZZ/  Z(1)
      COMMON /BLANK /  TABS     ,SIGMA    ,NLR      ,LUSET
      EQUIVALENCE      (Z(1),RZ(1),DZ(1) ),(BUF(1),RBUF(1)   ),
     1                 (DO(1)   ,AO(1)   ),(DI(1) ,AI(1)     ),
     2                 (IDATA(1),RDATA(1)),(DEFALT,IDEFLT    ),
     3                 (KSYSTM( 1),SYSBUF),(KSYSTM( 2),OUTPT ),
     4                 (KSYSTM(10),TSET  ),(KSYSTM(55),IPREC ),
     5                 (KSYSTM(57),MYRADM),(KSYSTM(58),RADCHK)
C
C     MYRADM  = 1  IMPLIES SYMMETRIC SCRIPT-AF INPUT
C     RADCHK NE 0  REQUESTS DIAGNOSTIC PRINTOUT OF AREAS AND VIEW FACTOR
C     MYRADM  = 2  IMPLIES UNSYMMETRIC SCRIPT-AF INPUT
C
      DATA     SUBR  / 4HRMG ,4H     /
      DATA     RADTYP/ 4H    ,4H  UN /
      DATA     RADLST/ 2014,  20     /
      DATA     RADMTX/ 3014,  30     /
      DATA     HBDYTP/ 52            /
      DATA     NOEOR / 0  /, EOR / 1 /
      DATA     EST   , MATPOL, GPTT, KGGX, RGG, QGE, KGG   /
     1         101   , 102   , 103 , 104 , 201, 202, 203   /
      DATA     SCRT1 , SCRT2, SCRT3, SCRT4, SCRT5, SCRT6   /
     1         301   , 302  , 303  , 304  , 305  , 306     /
C
C     DEFINITION OF CORE AND BUFFER POINTERS
C
      CALL DELSET
      SCRT1  = 301
      PRECIS = 2
      IF (IPREC .NE. 2) PRECIS = 1
      CORE = KORSZ(Z)
      BUF1 = CORE - SYSBUF - 2
      BUF2 = BUF1 - SYSBUF - 2
      BUF3 = BUF2 - SYSBUF - 2
      CORE = BUF3 - 1
      IF (CORE .LT. 100) CALL MESAGE (-8,0,SUBR)
      NOGO   = .FALSE.
      DOUBLE = .FALSE.
      IF (PRECIS .EQ. 2) DOUBLE = .TRUE.
      IF (MYRADM.EQ.1 .OR. MYRADM.EQ.2) WRITE (OUTPT,5) UWM,
     1                                                  RADTYP(MYRADM)
    5 FORMAT (A25,' 2358, ',A4,'SYMMETRIC SCRIPT-AF MATRIX (HREE) ',
     1        'ASSUMED IN RADMTX')
C
C     OPEN MATPOOL DATA BLOCK.
C
      FILE = MATPOL
      CALL PRELOC (*1100,Z(BUF1),MATPOL)
C
C     LOCATE RADLST DATA
C
      CALL LOCATE (*1090,Z(BUF1),RADLST,FLAG)
C
C     BUILD ELEMENT DATA TABLE.  -LENTRY- WORDS PER ELEMENT ID PRESENT
C     IN RADLST.
C
C     EACH ENTRY CONTAINS THE FOLLOWING OR MORE
C
C     WORD  1 = ELEMENT ID OF HBDY ELEMENT
C     WORD  2 = DIAGONAL MATRIX ELEMENT A-SUB-I
C     WORD  3 = DIAGONAL MATRIX ELEMENT E-SUB-I
C     WORD  4 = ELEMENT FA SUM (USED FOR RADMTX CHECK)
C     WORD  5 = SIL-1
C     WORD  6 = SIL-2
C     WORD  7 = SIL-3
C     WORD  8 = SIL-4
C     WORD  9 = GIJ-1  (GIJ TERMS MAY BE 2 WORDS EACH IF DOUBLE PREC)
C     WORD 10 = GIJ-2
C     WORD 11 = GIJ-3
C     WORD 12 = GIJ-4
C
C
      LENTRY = 8 + 4*PRECIS
      IELTAB = 1
      IDXM8  = IELTAB - LENTRY - 1
      NELTAB = IELTAB - 1
   10 IF (NELTAB+LENTRY .GT. CORE) CALL MESAGE (-8,0,SUBR)
      CALL READ (*1110,*1120,MATPOL,Z(NELTAB+1),1,NOEOR,WORDS)
      IF (Z(NELTAB+1)) 30,30,20
   20 Z(NELTAB+2) = 0
      Z(NELTAB+3) = 0
      NELTAB = NELTAB + LENTRY
      GO TO 10
C
C     ALL RADLST DATA NOW IN CORE.
C     (POSITION TO END OF RECORD ON  MATPOOL)
C
   30 CALL READ (*1110,*50,MATPOL,BUF,1,EOR,WORDS)
      WRITE  (OUTPT,40) SWM
   40 FORMAT (A27,' 3071, EXTRA DATA IN RADLST RECORD OF MATPOOL DATA ',
     1       'BLOCK IGNORED.')
C
C     LOCATE RADMTX DATA
C
   50 NE = (NELTAB-IELTAB+1)/LENTRY
      CALL LOCATE (*135,Z(BUF1),RADMTX,FLAG)
      LRAD = .TRUE.
C
C     READ IN RADMTX DATA.  FOR LOWER TRIANGLE COLUMNS PRESENT
C     ENTRY WORDS 2 AND 3 IN -ELTAB- WILL BE USED TO STORE FIRST
C     AND LAST LOCATIONS OF LOWER TRIANGLE COLUMN.  ZEROS IMPLY COLUMN
C     IS NULL.
C
      IRAD = NELTAB + 1
C
C     READ COLUMN INDEX
C
   60 CALL READ (*1110,*140,MATPOL,INDEX,1,NOEOR,WORDS)
C
C     MAXIMUM NUMBER OF INPUT TERMS FOR THIS COLUMN. (LOWER TRIANGLE)
C
      MAX = NE - INDEX + 1
      IF (MYRADM .EQ. 2) MAX = NE
C
C     SET -IDX- TO ELTAB ENTRY
C
      IDX = IDXM8 + INDEX*LENTRY
C
C     READ IN COLUMN ELEMENTS IF ANY
C
      N = 0
   70 CALL READ (*1110,*1120,MATPOL,Z(IRAD),1,NOEOR,WORDS)
      IF (Z(IRAD) .EQ. -1) GO TO 100
      N = N + 1
      IRAD = IRAD + 1
      IF (IRAD .GT. CORE) CALL MESAGE (-8,0,SUBR)
      IF (N .LE. MAX) GO TO 70
C
C     TOO MANY COLUMN ELEMENTS INPUT
C
      IRAD = IRAD - 1
C
C     SKIP TO END OF COLUMN
C
   80 CALL READ (*1110,*1120,MATPOL,IDUM,1,NOEOR,WORDS)
      IF (IDUM .NE. -1) GO TO 80
      WRITE  (OUTPT,90) UWM,INDEX,NE
   90 FORMAT (A25,' 3072, TOO MANY MATRIX VALUES INPUT VIA RADMTX BULK',
     1       ' DATA FOR COLUMN',I9,1H., /5X,'EXTRA VALUES IGNORED AS ',
     2       'MATRIX SIZE IS DETERMINED TO BE OF SIZE',I9,
     3       ' FROM RADLST COUNT OF ELEMENT ID-S.')
C
C     ALL DATA FOR LOWER TRIANGLE PORTION OF COLUMN IS IN CORE.
C     (BACK UP OVER ANY ZEROS)
C
  100 IF (N) 60,60,110
  110 IF (Z(IRAD-1)) 130,120,130
  120 N = N - 1
      IRAD = IRAD - 1
      GO TO 100
C
C     SET FIRST AND LAST POINTERS
C
  130 Z(IDX+2) = IRAD - N
      Z(IDX+3) = IRAD - 1
C
C     GO READ NEXT COLUMN
C
      GO TO 60
C
C     NULL RADMTX ASSUMED
C
  135 LRAD = .FALSE.
C
C     RADMTX IS COMPLETELY IN CORE IN TEMPORARY SPECIAL PACKED FORM.
C
C     NOW PACK OUT EACH COLUMN OF MATRIX F TO SCRATCH 1
C
  140 CALL CLOSE (MATPOL,CLSREW)
      IF (MYRADM.EQ.1 .OR. MYRADM.EQ.2) SCRT1 = 303
      CALL GOPEN (SCRT1,Z(BUF1),WRTREW)
      CALL MAKMCB (MCB1,SCRT1,NE,SQR,PRECIS)
      DO 210 JCOL = 1,NE
C
C     INITIALIZE PACKING OF COLUMN -JCOL-
C
      CALL BLDPK (1,PRECIS,SCRT1,0,0)
C
C     PACK OUT ELEMENTS OF COLUMN -JCOL-
C
      INXCOL = IDXM8 + JCOL*LENTRY
C
C     SET FA SUM TO ZERO FOR CURRENT COLUMN.
C
      SUMFA = 0.0
      IF (.NOT.LRAD) GO TO 205
      DO 200 IROW = 1,NE
C
C     LOCATE ELEMENT ROW-IROWK, COL-JCOL.
C
      IF (IROW.GE.JCOL .OR. MYRADM.EQ.2) GO TO 180
C
C     HERE IF ABOVE THE DIAGONAL
C     ELEMENT DESIRED IS IN COLUMN -IROW- IN CORE AND POSITION
C     (JCOL-IROW+1) OF THE LOWER TRIANGLE PORTION.
C
      IDX = IDXM8 + IROW*LENTRY
      I1  = Z(IDX+2)
      IF (I1) 200,200,150
  150 I2  = Z(IDX+3)
      IPOS= JCOL - IROW + I1
  160 IF (IPOS .GT. I2) GO TO 200
      IF (RZ(IPOS)) 162,200,170
  162 WRITE  (OUTPT,164) UWM,JCOL,IROW,RZ(IPOS)
  164 FORMAT (A25,' 2359, COL',I6,', ROW',I6,
     1        ' OF RADMTX IS NEGATIVE (',E14.6,').')
  170 AO(1) = RZ(IPOS)
      IF (MYRADM.EQ.1 .OR. MYRADM.EQ.2) AO(1) = -SIGMA*RZ(IPOS)
      IF (JCOL.EQ.IROW .AND. (MYRADM.EQ.1 .OR. MYRADM.EQ.2)) GO TO 175
      SUMFA = SUMFA + RZ(IPOS)
  175 CALL ZBLPKI
      GO TO 200
C
C     HERE IF BELOW OR ON DIAGONAL.
C     ELEMENT DESIRED IS IN COLUMN -JCOL- IN POSITION (IROW-JCOL+I1)
C
  180 IDX= INXCOL
      I1 = Z(IDX+2)
      IF (I1) 200,200,190
  190 I2 = Z(IDX+3)
      IPOS = IROW - JCOL + I1
      IF (MYRADM .EQ. 2) IPOS = IROW + I1 - 1
      GO TO 160
C
  200 CONTINUE
C
C     COMPLETE COLUMN
C
  205 CALL BLDPKN (SCRT1,0,MCB1)
C
C     SAVE COLUMN FA SUM IN ELTAB FOR AWHILE.
C
      RZ(INXCOL+4) = SUMFA
C
  210 CONTINUE
C
C     PACKED MATRIX IS COMPLETE
C
      CALL WRTTRL (MCB1)
      CALL CLOSE (SCRT1,CLSREW)
C/////
C     CALL DMPFIL (-SCRT1,Z(NELTAB+1),CORE-NELTAB-2)
C     CALL BUG (10HF-MATRIX    ,210,0,1)
C/////
C
C     OUTPUT OF ELEMENT-ID LIST TO QGE HEADER RECORD IS PERFORMED AT
C     THIS TIME.
C
      FILE = QGE
      CALL OPEN  (*1130,QGE,Z(BUF1),WRTREW)
      CALL FNAME (QGE,NAME)
      CALL WRITE (QGE,NAME,2,NOEOR)
      DO 215 I = IELTAB,NELTAB,LENTRY
      CALL WRITE (QGE,Z(I),1,NOEOR)
  215 CONTINUE
      CALL WRITE (QGE,0,0,EOR)
      CALL CLOSE (QGE,CLS)
C
C     OPEN EST AND PROCESS EST ELEMENT DATA OF ONLY THE HBDY ELEMENTS
C     WHOSE ELEMENT ID-S ARE IN THE RADLST.  I.E. NOW IN THE RDLST TABLE
C
      FILE = EST
      CALL GOPEN (EST,Z(BUF1),RDREW)
      GO TO 230
C
C     LOCATE HBDY ELEMENT TYPE RECORD
C
  220 CALL FWDREC (*1110,EST)
C
C     READ ELEMENT TYPE
C
  230 CALL READ (*300,*1120,EST,ELTYPE,1,NOEOR,WORDS)
      IF (ELTYPE .NE. HBDYTP) GO TO 220
C
C     NOW POSITIONED TO READ EST DATA FOR HBDY ELEMENT.
C
      J = (ELTYPE-1)*INCR
      ESTWDS = ELEM(J+12)
      LOST = 0
C
C     READ EST FOR ONE ELEMENT
C
  240 CALL READ (*1110,*300,EST,ECPT,ESTWDS,NOEOR,WORDS)
C
C     FIND ID IN LIST
C
      DO 250 I = IELTAB,NELTAB,LENTRY
      IF (ECPT(1) .EQ. Z(I)) GO TO 260
  250 CONTINUE
      GO TO 240
C
C     ELEMENT ID IS IN LIST
C
  260 CALL HBDY (ECPT,ECPT,1,RDATA,IDATA)
C
C     ON RETURN TAKE ELEMENT OUTPUTS AND PLANT THEM IN ALL ENTRIES
C     HAVING THIS SAME ID.
C
      IADD = 4*PRECIS + 7
      DO 290 J = IELTAB,NELTAB,LENTRY
      IF (ECPT(1) .NE. Z(J)) GO TO 290
C
C     CHECK TO SEE IF SUM FA/A EQUALS 1.0 FOR THIS ELEMENT.
C
      IF (RDATA(2) .GT. 1.0E-10) GO TO 261
      CHECK = 9999999.
      GO TO 263
  261 CHECK = RZ(J+3)/RDATA(2)
      IF (MYRADM.EQ.1 .OR. MYRADM.EQ.2) CHECK = CHECK/RDATA(3)
      IF (CHECK .GT. 0.99) GO TO 262
      LOST = LOST + 1
  262 IF (CHECK .LT. 1.01) GO TO 266
  263 WRITE  (OUTPT,264) UFM,Z(J),CHECK,RDATA(2)
  264 FORMAT (A23,' 2360, TOTAL VIEW FACTOR (FA/A), FOR ELEMENT',I9,
     1       ' IS',1P,E14.6,', (ELEMENT AREA IS ',1P,E14.5,').')
      NOGO = .TRUE.
  266 IF (CHECK.LT.1.01 .AND. RADCHK.NE.0) WRITE (OUTPT,267) UIM,Z(J),
     1                                     CHECK,RDATA(2)
  267 FORMAT (A29,' 2360, TOTAL VIEW FACTOR (FA/A), FOR ELEMENT',I9,
     1       ' IS ',1P,E14.6,', (ELEMENT AREA IS ',1P,E14.5,')')
      Z(J  ) = IDATA(1)
      Z(J+1) = IDATA(2)
      Z(J+2) = IDATA(3)
      Z(J+3) = IDATA(4)
      Z(J+4) = IDATA(5)
      Z(J+5) = IDATA(6)
      Z(J+6) = IDATA(7)
      Z(J+7) = IDATA(8)
      IF (DOUBLE) GO TO 270
      RZ(J+ 8) = RDATA( 9)
      RZ(J+ 9) = RDATA(10)
      RZ(J+10) = RDATA(11)
      RZ(J+11) = RDATA(12)
      GO TO 280
  270 DX = J/2 + 1
      DZ(DX+4) = RDATA( 9)
      DZ(DX+5) = RDATA(10)
      DZ(DX+6) = RDATA(11)
      DZ(DX+7) = RDATA(12)
  280 Z(J) = -Z(J)
  290 CONTINUE
      GO TO 240
C
C     ALL ELEMENTS PROCESSED.
C
  300 CALL CLOSE (EST,CLSREW)
      IF (LOST .GT. 0) WRITE (OUTPT,302) UIM,LOST
  302 FORMAT (A29,' 2361, ',I4,' ELEMENTS HAVE A TOTAL VIEW FACTOR (FA',
     1       '/A) LESS THAN 0.99 , ENERGY MAY BE LOST TO SPACE.')
C
C     CHECK TO SEE IF ALL ELEMENTS WERE PROCESSED.
C
C/////
C     CALL BUG (4HELTB ,270,Z(IELTAB),NELTAB-IELTAB+1)
C/////
      DO 340 I = IELTAB,NELTAB,LENTRY
      IF (Z(I)) 310,310,320
  310 Z(I) = -Z(I)
      GO TO 340
  320 NOGO = .TRUE.
      WRITE  (OUTPT,330) UFM,Z(I)
  330 FORMAT (A23,' 3073, NO -HBDY- ELEMENT SUMMARY DATA IS PRESENT ',
     1       'FOR ELEMENT ID =',I9, /5X,
     2       'WHICH APPEARS ON A -RADLST- BULK DATA CARD.')
  340 CONTINUE
      IF (NOGO) CALL MESAGE (-61,0,0)
      IF (MYRADM.EQ.1 .OR. MYRADM.EQ.2) GO TO 345
C
C     FORMATION OF THE Y MATRIX.  MATRIX F IS STORED ON SCRATCH 1
C
C         Y    = -F  (1.0 - E )  +  A
C          IJ      IJ        J       I
C
C         A  IS ADDED IN ONLY TO THE DIAGONAL TERMS I.E. I = J
C          I
C
C     MATRIX Y WILL BE STORED ON SCRATCH 2.
C
C
C     OPEN SCRATCH 1 FOR MATRIX F COLUMN UNPACKING.
C
      CALL GOPEN (SCRT1,Z(BUF1),RDREW)
C
C     OPEN SCRATCH 2 FOR MATRIX Y COLUMN PACKING
C
      CALL GOPEN  (SCRT2,Z(BUF2),WRTREW)
      CALL MAKMCB (MCB2,SCRT2,NE,SQR,PRECIS)
C
C     SET UP VECTOR CORE (INSURE EVEN BOUNDARY)
C
  345 ICOL = MOD(NELTAB,2) + NELTAB + 1
      RCOL = ICOL
      DCOL = ICOL/2 + 1
      NCOL = ICOL + PRECIS*NE - 1
      IF (NCOL .GT. CORE) CALL MESAGE (-8,0,SUBR)
      IF (MYRADM.EQ.1 .OR. MYRADM.EQ.2) GO TO 465
      MELTAB = IELTAB - LENTRY - 1
C
C     SETUP /PACKX/ FOR PACKING COLUMNS OF Y (SCRATCH 2)
C
      PKIN   = PRECIS
      PKOUT  = PRECIS
      PKIROW = 1
      PKNROW = NE
      PKINCR = 1
C
C     SETUP /UNPAKX/ FOR UNPACKING COLUMNS OF F (SCRATCH 1)
C
      UNOUT  = PRECIS
      UNIROW = 1
      UNNROW = NE
      UNINCR = 1
      DO 430 I = 1,NE
      MELTAB = MELTAB + LENTRY
      RX = RCOL
      DX = DCOL
C
C     UNPACK A COLUMN OF F INTO CORE.
C
      CALL UNPACK (*350,SCRT1,Z(ICOL))
      GO TO 370
  350 DO 360 J = ICOL,NCOL
      Z(J) = 0
  360 CONTINUE
C
C     COMPUTE THE Y-COLUMN
C
  370 DO 390 IROW = 1,NE
      IF (DOUBLE) GO TO 380
C
C     REAL COMPUTATION
C
      RZ(RX) = -RZ(RX)*(1.0E0 - RZ(MELTAB+3))
      IF (IROW .EQ. I) RZ(RX) = RZ(RX) + RZ(MELTAB+2)
      RX = RX + 1
      GO TO 390
C
C     DOUBLE PRECISION COMPUTATION
C
  380 DZ(DX) = -DZ(DX)*(1.0D0 - DBLE(RZ(MELTAB+3)))
      IF (IROW .EQ. I) DZ(DX) = DZ(DX) + DBLE(RZ(MELTAB+2))
      DX = DX + 1
  390 CONTINUE
C
C     PACK COLUMN OUT
C
      MCBSAV  = MCB2(6)
      MCB2(6) = 0
      CALL PACK (Z(ICOL),SCRT2,MCB2)
      IF (MCB2(6)) 400,400,420
  400 NOGO = .TRUE.
      WRITE  (OUTPT,410) UFM,I
  410 FORMAT (A23,' 3074, COLUMN',I9,' OF THE Y MATRIX IS NULL.')
  420 MCB2(6) = MAX0(MCB2(6),MCBSAV)
C
  430 CONTINUE
      IF (NOGO) CALL MESAGE (-61,0,SUBR)
      CALL CLOSE (SCRT1,CLSREW)
      CALL WRTTRL (MCB2)
      CALL CLOSE (SCRT2,CLSREW)
C/////
C     CALL DMPFIL (-SCRT2,Z(ICOL),CORE-ICOL-1)
C     CALL BUG (10HY-MATRIX    ,400,0,1)
C/////
C
C     NOW SOLVING FOR MATRIX X ON SCRATCH-3
C
C     (Y) (X) = (F)
C
C     F IS ON SCRATCH 1
C     Y IS ON SCRATCH 2
C
C
C     SETUP /DCOMPX/
C
      IA(1) = SCRT2
      IL(1) = 201
      IU(1) = 203
      IL(5) = PRECIS
      ISR1  = SCRT4
      ISR2  = SCRT5
      ISR3  = SCRT6
      CALL RDTRL (IA)
      NZZ   = KORSZ(Z(ICOL))
      IB    = 0
      IBBAR = 0
      CALL DECOMP (*440,Z(ICOL),Z(ICOL),Z(ICOL))
      GO TO 460
  440 WRITE  (OUTPT,450) UFM
  450 FORMAT (A23,' 3075, INTERMEDIATE MATRIX Y IS SINGULAR.')
      CALL MESAGE (-61,0,SUBR)
C
C     SETUP /GFBSX/
C
  460 JL(5) = IL(5)
      JU(7) = IU(7)
      JL(1) = 201
      JU(1) = 203
      JB(1) = SCRT1
      JX(1) = SCRT3
      IPR   = PRECIS
C//// WHAT ABOUT IDET
      ISGN  = 1
      NZZZ  = NZZ
      JL(3) = NE
      JX(5) = PRECIS
      CALL RDTRL (JB(1))
      CALL GFBS (Z(ICOL),Z(ICOL))
      JX(3) = NE
      JX(4) = SQR
      CALL WRTTRL (JX)
C/////
C     CALL DMPFIL (-SCRT3,Z(ICOL),CORE-ICOL-1)
C     CALL BUG (10HX-MATRIX     ,438,0,1)
C/////
C
C     FORMATION OF THE R MATRIX (TO BE STORED ON SCRATCH 1)
C
C          R    =(-SIGMA*E *A *E *X  ) + (SIGMA*E *A )
C           IJ            J  I  I  IJ            J  I
C
C     (TERM2 IS ADDED IN ONLY WHEN I = J)
C
C     IF MYRADM = 1 OR 2    , RADMTX MULTIPLIED BY -SIGMA IS ON SCRT3
C     MATRIX X IS ON SCRATCH 3
C
C
C     OPEN SCRATCH 3 FOR MATRIX X COLUMN UNPACKING.
C
  465 CALL GOPEN (SCRT3,Z(BUF3),RDREW)
C
C     THE FOLLOWING CARD IS NEEDED IF DIRECT SCRIPT-F INPUT IS USED
C
      SCRT1 = 301
C
C     OPEN SCRATCH 1 FOR MATRIX R COLUMN PACKING.
C
      FILE = SCRT1
      CALL GOPEN  (SCRT1,Z(BUF1),WRTREW)
      CALL MAKMCB (MCB1,SCRT1,NE,SQR,PRECIS)
      MELTAB = IELTAB - LENTRY - 1
C
C     SETUP /PACKX/ FOR PACKING COLUMNS OF R (SCRATCH 1)
C
      PKIN   = PRECIS
      PKOUT  = PRECIS
      PKIROW = 1
      PKNROW = NE
      PKINCR = 1
C
C     SETUP /UNPAKX/ FOR UNPACKING COLUMNS OF X (SCRATCH 3)
C
      UNOUT  = PRECIS
      UNIROW = 1
      UNNROW = NE
      UNINCR = 1
C
      IDX1 = IELTAB - LENTRY
      DO 520 ICOLUM = 1,NE
      DSUMFA = 0.
      SUMFA  = 0.
      MELTAB = MELTAB + LENTRY
C
C     COMPUTE CONSTANT FOR COLUMN
C
C     TEMP1 = SIGMA*E
C                    J
C
      TEMP1 = SIGMA*RZ(MELTAB+3)
      RX = RCOL
      DX = DCOL
C
C     UNPACK A COLUMN OF X INTO CORE.
C
      CALL UNPACK (*470,SCRT3,Z(ICOL))
      GO TO 490
  470 DO 480 J = ICOL,NCOL
      Z(J) = 0
  480 CONTINUE
C
C     COMPUTE THE R-COLUMN
C
  490 IDX2 = IDX1
      DO 510 IROW = 1,NE
      IDX2 = IDX2 + LENTRY
      IF (DOUBLE) GO TO 500
C
C     REAL COMPUTATION.
C
      IF (MYRADM.EQ.1 .OR. MYRADM.EQ.2) GO TO 495
      TEMP2  = TEMP1*RZ(IDX2+1)
      RZ(RX) =-TEMP2*RZ(IDX2+2)*RZ(RX)
      IF (IROW .EQ. ICOLUM) RZ(RX) = RZ(RX) + TEMP2
  495 IF (IROW .NE. ICOLUM) SUMFA  = SUMFA  + RZ(RX)
      RX = RX + 1
      GO TO 510
C
C     DOUBLE PRECISON COMPUTATION
C
  500 IF (MYRADM.EQ.1 .OR. MYRADM.EQ.2) GO TO 505
      DTEMP2 = DBLE(TEMP1)*DBLE(RZ(IDX2+1))
      DZ(DX) =-DTEMP2*DBLE(RZ(IDX2+2))*DZ(DX)
      IF (IROW .EQ. ICOLUM) DZ(DX) = DZ(DX) + DTEMP2
  505 IF (IROW .NE. ICOLUM) DSUMFA = DSUMFA + DZ(DX)
      DX = DX + 1
C
  510 CONTINUE
C
C     PACK COLUMN OF R OUT
C
      IF (MYRADM.NE.1 .AND. MYRADM.NE.2) GO TO 515
      IF (DOUBLE) DZ(DX-1-NE+ICOLUM) = -DSUMFA
      IF (.NOT.DOUBLE) RZ(ICOLUM+RX-1-NE) = -SUMFA
  515 CALL PACK (Z(ICOL),SCRT1,MCB1)
  520 CONTINUE
      CALL WRTTRL (MCB1)
      CALL CLOSE (SCRT1,CLSREW)
      CALL CLOSE (SCRT3,CLSREW)
C/////
C     CALL DMPFIL (-SCRT1,Z(ICOL),CORE-ICOL-1)
C     CALL BUG (10HR-MATRIX    ,490,0,1)
C/////
C
C     ALL OF THE HBDY ELEMENTS OF THE RADLST HAVE
C     HAD THEIR G TERMS COMPUTED, THESE G TERMS MAY BE INSERTED INTO
C     THE FULL MATRIX G.
C
C     GOING THROUGH THE RADLST TABLE WE HAVE EACH ELEMENT ENTRY FORMING
C     A COLUMN OF G WITH THE G TERMS OF THE RESPECTIVE ENTRY BEING
C     ENTERED INTO THE COLUMN AT THE SIL LOCATIONS.  (THE SILS WERE
C     PLACED IN THE RADLST ENTRY EARLIER)
C
C
C     AS THE X MATRIX STORED ON SCRATCH 3 IS NO LONGER NEEDED
C     WE WILL USE SCRATCH 3 FOR THE G MATRIX NOW.
C
      CALL GOPEN  (SCRT3,Z(BUF3),WRTREW)
      CALL MAKMCB (MCB3,SCRT3,LUSET,2,PRECIS)
C
C     LOOP ON THE RADLST TABLE
C
      DO 600 I = IELTAB,NELTAB,LENTRY
C
C     BEGIN PACKING A COLUMN OUT
C
      CALL BLDPK (PRECIS,PRECIS,SCRT3,0,0)
C
C     PACK 1 TO 4 TERMS OUT.
C
      I1 = I + 4
      I2 = I + 7
      DO 580 J = 1,4
C
C     PICKING THE SMALLEST SIL NOT ZERO FOR THE NEXT TERM OUT
C
      ISIL = 0
      DO 560 L = I1,I2
      IF (Z(L)) 560,560,530
  530 IF (ISIL) 550,550,540
  540 IF (Z(L)-ISIL) 550,550,560
  550 ISIL = Z(L)
      K = L
  560 CONTINUE
C
C     ZERO SIL IMPLYS OUT OF VALUES
C
      IF (ISIL) 590,590,570
C
C     PACK OUT TERM  (MAY BE SINGLE OR DOUBLE PRECISON)
C
  570 IROW = Z(K)
      Z(K) = 0
C
C     RESET K TO GIJ TERM PTR.
C
      KK = K + 4
      IF (DOUBLE) KK = KK + K - I1
      AO(1) = RZ(KK  )
      AO(2) = RZ(KK+1)
      CALL ZBLPKI
  580 CONTINUE
C
C     COMPLETE THE COLUMN
C
  590 CALL BLDPKN (SCRT3,0,MCB3)
  600 CONTINUE
C
C     G MATRIX IS COMPLETE ON SCRATCH 3.
C
      CALL WRTTRL (MCB3)
      CALL CLOSE  (SCRT3,CLSREW)
C/////
C     CALL DMPFIL (-SCRT3,Z(ICOL),CORE-ICOL-1)
C     CALL BUG (10HG-MATRIX     ,570,0,1)
C/////
C
C     FORM OUTPUT MATRIX  (Q  ) = (G)(R )
C                           GE         E
C
C
C     ALL CORE AT THIS POINT IS AVAILABLE THUS OPEN CORE FOR SSG2B
C     WHICH IS IN /SSGB2/ MAY BE AT THE SAME LEVEL AS
C     /RMGZZZ/.  SSG2B IS THE DRIVER FOR MPYAD.
C
      CALL SSG2B (SCRT3,SCRT1,0,SCRT5,0,PRECIS,1,SCRT2)
C
C                                        T
C     FORM OUTPUT MATRIX  (R  ) = (Q  )(G )
C                           GG      GE
C
C
C     THE MATRIX G IS FIRST TRANSPOSED.
C
C     MATRIX G IS ON SCRATCH-3.  MATRIX G TRANSPOSE WILL BE ON SCRATCH-2
C
C     OPEN CORE /DTRANX/ FOR TRANP1 MAY BE AT SAME LEVEL AS /RMGZZZ/.
C
      CALL TRANP1 (SCRT3,SCRT2,4,SCRT4,SCRT6,SCRT1,RGG,0,0,0,0)
C/////
C     CALL DMPFIL (-SCRT2,Z(ICOL),CORE-ICOL-1)
C     CALL BUG (10HG-TRANSP    ,570,0,1)
C/////
C
C     SSG2B MAY BE CALLED NOW TO COMPUTE (R  )
C                                          GG
C
      CALL SSG2B (SCRT5,SCRT2,0,RGG,0,PRECIS,1,SCRT1)
C
C     QGE WAS PLACED ON SCRT5.  NOW COPY IT TO QGE (WHERE THE HEADER
C     RECORD HAS BEEN SPECIALLY PREPARED EARLIER) .
C
      FILE = QGE
      CALL OPEN (*1130,QGE,Z(BUF1),WRT)
      FILE = SCRT5
      CALL GOPEN  (SCRT5,Z(BUF2),RDREW)
      CALL CPYFIL (SCRT5,QGE,Z,CORE,ICOUNT)
      MCB(1) = SCRT5
      CALL RDTRL (MCB)
      MCB(1) = QGE
      CALL WRTTRL (MCB)
      CALL CLOSE (SCRT5,CLSREW)
      CALL CLOSE (QGE,CLSREW)
C
C                    1      3
C     FORM  S   = 4(U  + T )  THIS IS ACTUALLY A DIAGONAL MATRIX.
C            GG      G    A
C
C     NOW ALLOCATE S   DIAGONAL MATRIX SPACE AND STORE -TABS- EVERYWHERE
C                   GG
C
C
      ISGG = 1
      NSGG = PRECIS*LUSET
      IF (NSGG .GT. CORE) CALL MESAGE (-8,0,SUBR)
      IF (DOUBLE) GO TO 620
C
C     REAL VECTOR
C
      DO 610 I = ISGG,NSGG
      RZ(I) = TABS
  610 CONTINUE
      GO TO 640
C
C     DOUBLE PRECISION VECTOR
C
  620 DX = ISGG/2 + 1
      NDX = DX + LUSET - 1
      DO 630 I = DX,NDX
      DZ(I) = TABS
  630 CONTINUE
C
C     IF -TSET- IS SPECIFIED THEN THAT SET OF TEMPERATURES IS ADDED TO
C     THE UG VECTOR IN CORE.
C
  640 IF (TSET) 900,900,650
C
C     TSET IS REQUESTED
C
  650 FILE = GPTT
      CALL OPEN (*1130,GPTT,Z(BUF1),RDREW)
C
C     DETERMINE NUMBER OF RECORDS IN ELEMENT TEMPERATURE SECTION TO
C     SKIP OVER. (FIRST SKIP THE NAME IN HEADER)
C
      CALL READ (*1110,*1120,GPTT,BUF,2,NOEOR,FLAG)
C
C     LOOK FOR REQUESTED TSET POINTERS AND REPOSITION GPTT.
C
      NUMBER =  0
      NUMTST = -1
  660 CALL READ (*1110,*670,GPTT,BUF,3,NOEOR,FLAG)
      IF (BUF(3) .GT. NUMBER) NUMBER = BUF(3)
      IF (TSET .NE. BUF(1)) GO TO 660
C
C     BUF(1)=SET-ID, BUF(2)=-1 OR DEFAULT TEMP, BUF(3)=GPTT DATA RECORD.
C
      DEFALT = RBUF(2)
      NUMTST = BUF(3)
      GO TO 660
C
C     CHECK FOR TSET NOT FOUND.
C
  670 IF (NUMTST .EQ. -1) GO TO 1170
C
C     ADD SKIP COUNTS (EL. RECORDS + DUPE HEADER + TEMP SET -1)
C
      NUMBER = NUMBER + NUMTST
C
C     NO NEED TO DO FURTHER I/O IF TSET IS ALL DEFAULT TEMPS.
C
      IF (NUMTST .EQ. 0) NUMBER = 0
      IF (NUMBER) 740,740,720
  720 DO 730 I = 1,NUMBER
      CALL FWDREC (*1110,GPTT)
  730 CONTINUE
C
C     TEMPERATURE DATA IS IN PAIRS OF INTERNAL ID AND TEMPERATURE.
C
C
C     AT THIS POINT THE GRID POINT TEMPERATUE DATA IS ADDED INTO THE SGG
C     DIAGONAL HELD IN CORE.
C
  740 NSIL = 1
      RX = ISGG - 1
      DX = ISGG/2
      ASSIGN 750 TO IRETRN
      IF (NUMBER) 790,790,750
  750 CALL READ (*1110,*870,GPTT,BUF,2,NOEOR,FLAG)
  760 IF (BUF(1)-NSIL) 770,820,800
  770 WRITE  (OUTPT,780) SFM
  780 FORMAT (A25,' 3076, GPTT DATA IS NOT IN SORT BY INTERNAL ID.')
      CALL MESAGE (-61,0,SUBR)
C
C     ADD DEFAULT TEMPERATURE (IF ONE EXISTS) TO THOSE POINTS NOT HAVING
C     AN EXPLICIT TEMPERATURE DEFINED.
C
  790 BUF(1) = LUSET + 1
  800 IF (IDEFLT .NE. -1) GO TO 830
      WRITE  (OUTPT,810) UFM,NSIL
  810 FORMAT (A23,' 3077, THERE IS NO GRID POINT TEMPERATURE DATA OR ',
     1       'DEFAULT TEMPERATURE DATA FOR SIL POINT',I9, /5X,
     2       'AND POSSIBLY OTHER POINTS.')
      CALL MESAGE (-61,0,SUBR)
  820 VALUE = RBUF(2)
      GO TO 840
  830 VALUE = DEFALT
      ASSIGN 880 TO IRETRN
      ISIL = NSIL
      KSIL = BUF(1) - 1
      NSIL = BUF(1)
      GO TO 845
  840 ISIL = NSIL
      KSIL = BUF(1)
      NSIL = BUF(1) + 1
  845 DO 860 I = ISIL,KSIL
      IF (I .GT. LUSET) GO TO 890
      IF (DOUBLE) GO TO 850
      RX = RX + 1
      RZ(RX) = RZ(RX) + VALUE
      GO TO 860
  850 DX = DX + 1
      DZ(DX) = DZ(DX) + DBLE(VALUE)
  860 CONTINUE
      GO TO IRETRN, (750,890,880)
  870 ASSIGN 890 TO IRETRN
      BUF(1) = LUSET
      VALUE  = DEFALT
      GO TO 840
  880 ASSIGN 750 TO IRETRN
      GO TO 760
C
C     ALL TEMPERATURE DATA HAS BEEN ADDED IN.
C
  890 CALL CLOSE (GPTT,CLSREW)
C/////
C     CALL BUG (4HTMPS,890,Z(ISGG),NSGG-ISGG+1)
C/////
C
C     NOW CUBE EACH TERM AND THEN MULTIPLY EACH TERM BY 4.0
C
  900 IF (DOUBLE) GO TO 920
C
C     REAL COMPUTATION
C
      DO 910 I = ISGG,NSGG
      RZ(I) = 4.0*(RZ(I)**3)
  910 CONTINUE
      GO TO 940
C
C     DOUBLE PRECISION COMPUTATION
C
  920 DX  = ISGG/2 + 1
      NDX = DX + LUSET - 1
      DO 930 I = DX,NDX
      DZ(I) = 4.0D0*(DZ(I)**3)
  930 CONTINUE
C
C     ALLOCATION OF CORE FOR A COLUMN OF MATRIX RGG.
C
  940 IRGG  = NSGG + 1
      NRGG  = IRGG + PRECIS*LUSET - 1
      DIRGG = IRGG/2 + 1
      DNRGG = DIRGG + LUSET - 1
      IF (NRGG .GT. CORE) CALL MESAGE (-8,0,SUBR)
C
C                                   X
C     FORM OUTPUT MATRIX  (K  ) = (K  ) + (R  )(S  )
C                           GG      GG      GG   GG
C
C
C     THE DIAGONAL MATRIX (S  ) RESIDES IN CORE FROM Z(ISGG) TO Z(NSGG)
C                           GG
C
C     Z(IRGG) TO Z(NRGG) WILL BE USED TO HOLD A COLUMN OF R.
C
C       X
C     (K  ) WILL BE UNPACKED INCREMENTALLY AND ADDED INTO THE COLUMN
C       GG
C
C     OF R, AFTER THAT COLUMN OF R HAS BEEN MULTIPLIED BY THE RESPECTIVE
C
C     DIAGONAL ELEMENT OF (S  ).
C                           GG
C
C/////
C     CALL BUG (4HSGG  ,829,Z(ISGG),NSGG-ISGG+1)
C/////
      CALL GOPEN (RGG,Z(BUF1),RDREW)
      CALL GOPEN (KGGX,Z(BUF2),RDREW)
      CALL GOPEN (KGG,Z(BUF3),WRTREW)
      CALL MAKMCB (MCB1,KGG,LUSET,SQR,PRECIS)
C
C     SET UP /PACKX/ FOR PACKING COLUMN OF KGG OUT.
C
      PKIN   = PRECIS
      PKOUT  = PRECIS
      PKIROW = 1
      PKNROW = LUSET
      PKINCR = 1
      RX = ISGG - 1
      DX = ISGG/2
C
C     LOOP THROUGH -LUSET- COLUMNS TO BE OUTPUT.
C
      DO 1080 I = 1,LUSET
      IF (DOUBLE) GO TO 950
      RX = RX + 1
      VALUE = RZ(RX)
      GO TO 960
  950 DX = DX + 1
      DVALUE = DZ(DX)
C
C     UNPACK A COLUMN OF R
C
  960 DO 980 J = IRGG,NRGG
      Z(J) = 0
  980 CONTINUE
C
C     -UNPACK- CAN NOT BE USED HERE DUE TO UNPACKING OF KGGX BELOW.
C
      CALL INTPK  (*990,RGG,BLOCK2,PRECIS,1)
  984 CALL INTPKI (AI,IIROW,RGG,BLOCK2,IEOL)
      IF (DOUBLE) GO TO 985
      K = IRGG - 1 + IIROW
      RZ(K) = RZ(K) + AI(1)
      IF (IEOL) 984,984,990
  985 K = DIRGG - 1 + IIROW
      DZ(K) = DZ(K) + DI(1)
      IF (IEOL) 984,984,990
C
C     MULTIPLY RGG COLUMN BY DIAGONAL ELEMENT OF SGG.
C
  990 IF (DOUBLE) GO TO 1010
C
C     REAL COMPUTATION
C
      DO 1000 J = IRGG,NRGG
      RZ(J) = RZ(J)*VALUE
 1000 CONTINUE
      GO TO 1030
C
C     DOUBLE PRECISION COMPUTATION
C
 1010 DO 1020 J = DIRGG,DNRGG
      DZ(J) = DZ(J)*DVALUE
 1020 CONTINUE
C
C     INCREMENTAL UNPACK OF A COLUMN OF KGGX.
C     ADD TO MODIFIED COLUMN OF RGG IN CORE, AND THEN
C     BLAST PACK OUT FURTHER MODIFIED COLUMN AS A COLUMN OF KGG.
C
C     START UNPACKING COLUMN OF KGGX
C
 1030 CALL INTPK  (*1070,KGGX,BLOCK,PRECIS,1)
 1040 CALL INTPKI (AI,IIROW,KGGX,BLOCK,IEOL)
C
C     ADD VALUE IN
C
      IF (IIROW .GT. LUSET) GO TO 1050
      IF (DOUBLE) GO TO 1060
C
C     REAL ADD IN
C
      K = IRGG - 1 + IIROW
      RZ(K) = RZ(K) + AI(1)
 1050 IF (IEOL) 1040,1040,1070
C
C     DOUBLE PRECISION ADD IN
C
 1060 K = DIRGG - 1 + IIROW
      DZ(K) = DZ(K) + DI(1)
      IF (IEOL) 1040,1040,1070
C
C     PACK OUT COMPLETED COLUMN.
C
 1070 CALL PACK (Z(IRGG),KGG,MCB1)
 1080 CONTINUE
      CALL WRTTRL (MCB1)
      CALL CLOSE (KGG,CLSREW )
      CALL CLOSE (KGGX,CLSREW)
      CALL CLOSE (RGG,CLSREW )
C
C     ALL PROCESSING COMPLETED.
C
      NLR = +1
      RETURN
 1090 CALL CLOSE (MATPOL,CLSREW)
 1100 NLR = -1
      RETURN
C
C     ERROR CONDITIONS
C
C
C     END OF FILE
C
 1110 J = -2
      GO TO 1140
C
C     END OF RECORD
C
 1120 J = -3
      GO TO 1140
C
C     UNDEFINED FILE
C
 1130 J = -1
 1140 CALL MESAGE (J,FILE,SUBR)
C
C     GPTT DATA MISSING FOR SET -TSET-.
C
 1170 WRITE  (OUTPT,1180) UFM,TSET
 1180 FORMAT (A23,' 3078, NO GPTT DATA IS PRESENT FOR TEMPERATURE SET ',
     1        I8,1H.)
      CALL MESAGE (-61,0,SUBR)
C
C     NO HBDY ELEMENTS
C
C
      RETURN
      END

      SUBROUTINE FLBEMG
C
C     GENERATES ELEMENT AREA FACTOR AND GRAVITIATIONAL STIFFNESS
C     MATRICES
C
      INTEGER       GEOM2    ,ECT      ,BGPDT    ,SIL      ,MPT
     1             ,GEOM3    ,CSTM     ,USET     ,EQEXIN   ,USETF
     2             ,USETS    ,AF       ,DKGG     ,FBELM    ,FRELM
     3             ,CONECT   ,AFMAT    ,AFDICT   ,KGMAT    ,KGDICT
     4             ,Z        ,GRAV(2)  ,POS      ,FRREC(7) ,FBREC(12)
     5             ,FILE     ,NAME(2)  ,DICT(2)
C
      LOGICAL       ERROR    ,NOCARD
C
      DOUBLE PRECISION        AFE(48)  ,KGE(144)
C
C     GINO FILES
C
      COMMON / FLBFIL /       GEOM2    ,ECT      ,BGPDT    ,SIL
     1                       ,MPT      ,GEOM3    ,CSTM     ,USET
     2                       ,EQEXIN   ,USETF    ,USETS    ,AF
     3                       ,DKGG     ,FBELM    ,FRELM    ,CONECT
     4                       ,AFMAT    ,AFDICT   ,KGMAT    ,KGDICT
C
C     OPEN CORE
C
      COMMON / ZZZZZZ /       Z(1)
C
C     CORE POINTERS
C
      COMMON / FLBPTR /       ERROR    ,ICORE    ,LCORE    ,IBGPDT
     1                       ,NBGPDT   ,ISIL     ,NSIL     ,IGRAV
     2                       ,NGRAV    ,IGRID    ,NGRID    ,IBUF1
     3                       ,IBUF2    ,IBUF3    ,IBUF4    ,IBUF5
C
C     MODULE PARAMETERS
C
      COMMON /BLANK/     NOGRAV   ,NOFREE   ,TILT(2)
C
      DATA NAME / 4HFLBE,4HMG   /
      DATA GRAV / 4401 , 44 /
C
C***********************************************************************
C
C     READ MATERIAL PROPERTY DATA INTO CORE
C
      IMAT = ICORE
      NZ = IBUF5 - IMAT
      CALL PREMAT(Z(IMAT),Z(IMAT),Z(IBUF1),NZ,NMAT,MPT,0)
C
C     READ CSTM DATA INTO CORE
C
      ICSTM = IMAT + NMAT
      NCSTM = 0
      NZ = IBUF5 - ICSTM
      FILE = CSTM
      CALL OPEN(*20,CSTM,Z(IBUF1),0)
      CALL FWDREC(*1002,CSTM)
      CALL READ(*1002,*10,CSTM,Z(ICSTM),NZ,0,NCSTM)
      GO TO 1008
   10 CALL CLOSE(CSTM,1)
      CALL PRETRD(Z(ICSTM),NCSTM)
C
C     READ GRAV DATA INTO CORE
C
   20 IGRAV = ICSTM + NCSTM
      NGRAV = 0
      NZ = IBUF5 - IGRAV
      NOGRAV = -1
      NOCARD = .TRUE.
      FILE = GEOM3
      CALL PRELOC(*40,Z(IBUF1),GEOM3)
      CALL LOCATE(*30,Z(IBUF1),GRAV,ID)
      NOCARD = .FALSE.
      CALL READ(*1002,*30,GEOM3,Z(IGRAV),NZ,0,NGRAV)
      GO TO 1008
C
   30 CALL CLOSE(GEOM3,1)
   40 CONTINUE
C
C     OPEN MATRIX AND DICTIONARY FILES
C
      CALL GOPEN(AFMAT,Z(IBUF2),1)
      CALL GOPEN(AFDICT,Z(IBUF4),1)
      IF(NOCARD) GO TO 60
      CALL GOPEN(KGMAT,Z(IBUF3),1)
      CALL GOPEN(KGDICT,Z(IBUF5),1)
C
C
C     PASS THROUGH FBELM FILE AND PROCESS EACH ENTRY ON THE BOUNDARY.
C     SUBROUTINE BOUND WILL GENERATE THE ELEMENT MATRICES FOR
C     EACH ENTRY.
C
   60 FILE = FBELM
      CALL GOPEN(FBELM,Z(IBUF1),0)
   70 CALL READ(*1002,*120,FBELM,FBREC,12,0,N)
C
      CALL BOUND(FBREC,AFE,NAFE,KGE,NKGE)
      IF(ERROR) GO TO 70
C
C     CONVERT GRID POINTS TO SILS
C
      DO 80 I=1,4
      J = FBREC(I+2) - 1
      IF(J .GE. 0) FBREC(I+2) = Z(ISIL+J)
      J = FBREC(I+8) - 1
      IF(J .GE. 0) FBREC(I+8) = Z(ISIL+J)
   80 CONTINUE
C
C     WRITE AREA MATRICES AND DICTIONARY ENTRUES
C
      CALL WRITE(AFMAT,FBREC(3),4,0)
      CALL WRITE(AFMAT,FBREC(9),4,0)
      CALL WRITE(AFMAT,AFE,NAFE,1)
      CALL SAVPOS(AFMAT,POS)
      DICT(2) = POS
      DO 90 I=1,4
      DICT(1) = FBREC(I+8)
      IF(DICT(1) .LT. 0) GO TO 90
      CALL WRITE(AFDICT,DICT,2,0)
   90 CONTINUE
C
C     WRITE GRAVITATIONAL STIFFNESS MATRICES IF THEY EXIST
C
      IF(NKGE .EQ. 0) GO TO 70
      CALL WRITE(KGMAT,FBREC(3),4,0)
      CALL WRITE(KGMAT,FBREC(3),4,0)
      CALL WRITE(KGMAT,KGE,NKGE,1)
      CALL SAVPOS(KGMAT,POS)
      DICT(2) = POS
      DO 110 I=1,4
      JSIL = FBREC(I+2)
      IF(JSIL .LT. 0) GO TO 110
      DO 100 J=1,3
      DICT(1) = JSIL
      CALL WRITE(KGDICT,DICT,2,0)
  100 JSIL = JSIL + 1
  110 CONTINUE
C
      GO TO 70
  120 CALL CLOSE(FBELM,1)
C
C
C     PASS THROUGH FRELM FILE AND PROCESS EACH ENTRY ON THE FREE
C     SURFACE.  SUBROUTINE FLFREE WILL CALCULATE THE AREA AND
C     GRAVITATIONAL STIFFNESS MATRICES FOR EACH ENTRY
C
      IF(NOFREE .LT. 0) GO TO 180
      FILE = FRELM
      CALL GOPEN(FRELM,Z(IBUF1),0)
  130 CALL READ(*1002,*170,FRELM,FRREC,7,0,N)
C
      CALL FLFREE(FRREC,AFE,NAFE,KGE,NKGE)
      IF(ERROR) GO TO 130
C
C     CONVERT GRID POINTS TO SILS
C
      DO 140 I=1,4
      J = FRREC(I+2) - 1
      IF(J .GE. 0) FRREC(I+2) = Z(ISIL+J)
  140 CONTINUE
C
C     WRITE AREA MATRICES AND DICTIONARY ENTRIES
C
      CALL WRITE(AFMAT,FRREC(3),4,0)
      CALL WRITE(AFMAT,FRREC(3),4,0)
      CALL WRITE(AFMAT,AFE,NAFE,1)
      CALL SAVPOS(AFMAT,POS)
      DICT(2) = POS
      DO 150 I=1,4
      DICT(1) = FRREC(I+2)
      IF(DICT(1) .LT. 0) GO TO 150
      CALL WRITE(AFDICT,DICT,2,0)
  150 CONTINUE
C
C     WRITE GRAVITATIONAL STIFFNESS MATRICES IF THEY EXIST
C
      IF(NKGE .EQ. 0) GO TO 130
      CALL WRITE(KGMAT,FRREC(3),4,0)
      CALL WRITE(KGMAT,FRREC(3),4,0)
      CALL WRITE(KGMAT,KGE,NKGE,1)
      CALL SAVPOS(KGMAT,POS)
      DICT(2) = POS
      DO 160 I=1,4
      DICT(1) = FRREC(I+2)
      IF(DICT(1) .LT. 0) GO TO 160
      CALL WRITE(KGDICT,DICT,2,0)
  160 CONTINUE
C
      GO TO 130
  170 CALL CLOSE(FRELM,1)
C
C     CLOSE FILES AND RETURN
C
  180 CALL CLOSE(AFMAT,1)
      CALL CLOSE(AFDICT,1)
      IF(NOCARD) GO TO 190
      CALL CLOSE(KGMAT,1)
      CALL CLOSE(KGDICT,1)
C
  190 CONTINUE
      RETURN
C
C     ERROR CONDITIONS
C
 1002 N = -2
      GO TO 1100
 1008 N = -8
 1100 CALL MESAGE(N,FILE,NAME)
      RETURN
      END

      SUBROUTINE GENCOS
C
C     GENCOS  GENERATES DIRECTION COSINE MATRIX, UP TO NX3, FOR DDAM.
C     THE SHOCK DIRECTIONS ARE GIVEN BY A COORDINATE SYSTEM (PROBABLY
C     RECTANGULAR, BUT NOT NECESSARILY) DEFINED ON A CORDIJ CARD.
C     THE ID OF THAT SYSTEM MUST BE SPECIFIED BY PARAM SHOCK ID.
C     THE DIRECTIONS OF INTEREST MUST BE SPECIFIED ON A PARAM DIRECT DIR
C     CARD WHERE DIR=1,2,3,12,13,23,OR 123 GIVING THE SHOCK DIRECTIONS
C     DESIRED IN THE SHOCK COORDINATE SYSTEM.  (DEFAULT IS 123)  WE WILL
C     BE CONVERTING A ROW VECTOR IN THE GLOBAL SYSTEM TO A ROW VECTOR IN
C     THE SHOCK SYSTEM.  TO CONVERT A COLUMN VECTOR FROM GLOBAL TO SHOCK
C     FIRST CONVERT TO BASIC.  THEN TRANSFORM FROM BASIC TO SHOCK, I.E.
C     (VECTOR-SHOCK) = (TRANSPOSE(T-SHOCK TO BASIC))*
C                      (T-GLOBAL TO BASIC)*(VECTOR-GLOBAL)
C     BUT BECAUSE WE ARE TRANSFORMING ROW VECTORS, THE EQUATION IS
C     TRANSPOSED . NSCALE =1 MEANS THERE ARE SCALAR POINTS,=0 MEANS NO
C
C     GENCOS    BGPDT,CSTM/DIRCOS/C,Y,SHOCK=0/C,Y,DIRECT=123/
C               V,N,LUSET/V,N,NSCALE $
C
      LOGICAL         REC,ALL
      INTEGER         BGPDT,CSTM,DIRCOS,BUF1,FILE,SHOCK,DIRECT,OTPE
      DIMENSION       NAM(2),MCB(7),IZ(1),TSHOCK(9),COORD(4),ICOORD(4),
     1                TPOINT(9),TFINAL(9),IDIR(3),ISUB(3)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /BLANK / SHOCK,DIRECT,LUSET,NSCALE
      COMMON /SYSTEM/ IBUF,OTPE
      COMMON /PACKX / IN,IOUT,II,NN,INCR
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE     (Z(1),IZ(1)), (COORD(1),ICOORD(1))
      DATA    BGPDT , CSTM,DIRCOS   / 101,102,201 /
      DATA    NAM   / 4HGENC,4HOS   /
C
C     OPEN CORE AND BUFFERS
C
      LCORE = KORSZ(Z)
      BUF1  = LCORE - IBUF + 1
      LCORE = BUF1  - 1
      IF (LCORE .LE. 0) GO TO 1008
C
C     CHECK FOR SCALAR POINTS AND SET NSCALE
C
      MCB(1) = BGPDT
      CALL RDTRL (MCB)
      NPTS = MCB(2)
      CALL GOPEN (BGPDT,Z(BUF1),0)
      DO 1 I = 1,NPTS
      CALL FREAD (BGPDT,COORD,4,0)
      IF (ICOORD(1) .EQ. -1) GO TO 2
    1 CONTINUE
      NSCALE = 0
      GO TO 3
    2 NSCALE = 1
    3 CALL CLOSE (BGPDT,1)
C
      IF (DIRECT.GE.1  .AND. DIRECT.LE.3) GO TO 5
      IF (DIRECT.NE.12 .AND. DIRECT.NE.13 .AND. DIRECT.NE.23 .AND.
     1    DIRECT.NE.123) GO TO 500
    5 IF (SHOCK .LT.  0) GO TO 500
      NCSTM  = 0
      NCOUNT = 0
      ALL    = .FALSE.
      REC    = .FALSE.
      NDIR   = 2
      IF (DIRECT .LE. 3) NDIR = 1
      IF (DIRECT .EQ. 123)  NDIR = 3
      IF (LUSET*NDIR .GT. LCORE) GO TO 1008
C
      GO TO (6,7,8), NDIR
C
    6 IDIR(1) = DIRECT
      GO TO 9
C
    7 IF (DIRECT .EQ. 23) GO TO 175
      IDIR(1) = 1
      IDIR(2) = 2
      IF (DIRECT .EQ. 13) IDIR(2) = 3
      GO TO 9
  175 IDIR(1) = 2
      IDIR(2) = 3
      GO TO 9
C
    8 IDIR(1) = 1
      IDIR(2) = 2
      IDIR(3) = 3
    9 CONTINUE
C
C
C     READ CSTM FOR FETCHING TRANSFORMATION MATRICES
C
      CALL OPEN (*10,CSTM,Z(BUF1),0)
      GO TO 30
C
C     CSTM IS PURGED.  SO, GLOBAL SYSTEM IS BASIC AND SHOCK SYSTEM MUST
C     BE ALSO.  IF SHOCK SYSTEM IS NOT 0, FATAL MESSAGE.  IF IT IS 0,
C     THEN NEED ONLY IDENTITIES.
C
   10 IF (SHOCK .EQ. 0) GO TO 25
      WRITE  (OTPE,20) UFM
   20 FORMAT (A23,', IN GENCOS, CSTM IS PURGED AND SHOCK COORDINATE ',
     1       'SYSTEM IS NOT BASIC')
      CALL MESAGE (-61,0,0)
C
C     EVERYTHING IS BASIC - CHECK FOR SCALAR POINTS - IF THEY EXIST,
C     WE MUST READ BGPDT
C
   25 IF (NSCALE .EQ. 1) GO TO 55
      ALL  = .TRUE.
      ISYS = 0
      GO TO 130
C
   30 FILE = CSTM
      CALL FWDREC (*1002,CSTM)
      CALL READ (*1002,*40,CSTM,Z,LCORE,0,NCSTM)
      GO TO 1008
   40 CALL CLOSE (CSTM,1)
C
C     CHECK FOR ENOUGH OPEN CORE
C
      IF (NCSTM+LUSET*NDIR .GT. LCORE) GO TO 1008
      CALL PRETRS (Z(1),NCSTM)
C
C     IF SHOCK COORDINATE SYSTEM IS RECTANGULAR, LET'S GET THE TRANS-
C     FORMATION MATRIX ONCE SINCE IT WILL NOT BE POINT-DEPENDENT.
C
      IF (SHOCK .EQ. 0) GO TO 55
      DO 50 I = 1,NCSTM,14
      IF (SHOCK .NE. IZ(I)) GO TO 50
      IF (IZ(I+1) .NE. 1) GO TO 60
C
C     RECTANGULAR
C
      REC = .TRUE.
      DO 45 J = 1,9
   45 TSHOCK(J) = Z(I+J+4)
      GO TO 60
   50 CONTINUE
C
C     CAN'T FIND SHOCK COORDINATE SYSTEM
C
      CALL MESAGE (-30,25,SHOCK)
C
C     SHOCK IS BASIC
C
   55 REC = .TRUE.
      DO 56 I = 1,9
   56 TSHOCK(I) = 0.
      TSHOCK(1) = 1.
      TSHOCK(5) = 1.
      TSHOCK(9) = 1.
C
C     OPEN BGPDT TO GET GRID POINT OUTPUT COORDINATE SYSTEMS AND
C     BASIC COORDINATES
C
   60 CALL GOPEN (BGPDT,Z(BUF1),0)
      FILE = BGPDT
   70 CALL READ (*1002,*210,BGPDT,COORD,4,0,IWORDS)
      ISYS = ICOORD(1)
      IF (ICOORD(1) .EQ. -1) GO TO 150
      IF (ICOORD(1) .NE.  0) GO TO 80
C
C     IDENTITY - BASIC SYSTEM
C
      DO 75 I = 1,9
   75 TPOINT(I) = 0.
      TPOINT(1) = 1.
      TPOINT(5) = 1.
      TPOINT(9) = 1.
      GO TO 85
C
C     FETCH GLOBAL-TO-BASIC MATRIX FOR THIS POINT
C
   80 CALL TRANSS (COORD,TPOINT)
C
C     IF SHOCK IS NOT RECTANGULAR, FETCH SHOCK-TO-BASIC FOR THIS POINT
C
   85 IF (REC) GO TO 90
      ICOORD(1) = SHOCK
      CALL TRANSS (COORD,TSHOCK)
C
C     THE MATRIX WE NEED IS (TRANSPOSE(TPOINT))*(TSHOCK)
C
   90 IF (SHOCK .EQ. 0) GO TO 100
      IF (ISYS  .EQ. 0) GO TO 110
C
C     NEITHER MATRIX IS NECESSARILY IDENTITY
C
      CALL GMMATS (TPOINT,3,3,1,TSHOCK,3,3,0,TFINAL)
      GO TO 150
C
C     TSHOCK IS IDENTITY
C
  100 IF (ISYS .EQ. 0) GO TO 130
C
C     BUT TPOINT IS NOT
C
      TFINAL(1) = TPOINT(1)
      TFINAL(2) = TPOINT(4)
      TFINAL(3) = TPOINT(7)
      TFINAL(4) = TPOINT(2)
      TFINAL(5) = TPOINT(5)
      TFINAL(6) = TPOINT(8)
      TFINAL(7) = TPOINT(3)
      TFINAL(8) = TPOINT(6)
      TFINAL(9) = TPOINT(9)
      GO TO 150
C
C     TPOINT IS IDENTITY, BUT TSHOCK IS NOT
C
  110 DO 120 I = 1,9
  120 TFINAL(I) = TSHOCK(I)
      GO TO 150
C
C     BOTH ARE IDENTITY
C
  130 DO 140 I = 1,9
  140 TFINAL(I) = 0.
      TFINAL(1) = 1.
      TFINAL(5) = 1.
      TFINAL(9) = 1.
C
C     STORE TFINAL BY INTERNAL ORDERING AND DIRECTIONS REQUESTED START-
C     ING AT Z(NCSTM+1) - MAKE UP TO 3 COLUMNS OF LUSET EACH
C
  150 ISUB(1) = NCSTM   + NCOUNT
      ISUB(2) = ISUB(1) + LUSET
      ISUB(3) = ISUB(2) + LUSET
C
      DO 200 I = 1,NDIR
      IP   = IDIR(I)
      JSUB = ISUB(I)
      IF (ISYS .EQ. -1) GO TO 195
      Z(JSUB+1) = TFINAL(IP  )
      Z(JSUB+2) = TFINAL(IP+3)
      Z(JSUB+3) = TFINAL(IP+6)
      Z(JSUB+4) = 0.
      Z(JSUB+5) = 0.
      Z(JSUB+6) = 0.
      GO TO 200
C
C     SCALAR
C
  195 Z(JSUB+1) = 1.
  200 CONTINUE
C
C     GO BACK FOR ANOTHER POINT
C
      NCOUNT = NCOUNT + 6
      IF (ISYS .EQ. -1)  NCOUNT = NCOUNT - 5
      IF (.NOT.ALL) GO TO 70
      IF (NCOUNT .EQ. LUSET) GO TO 210
      GO TO 150
C
C     DONE WITH ALL POINTS - PACK RESULTS
C
  210 IF (.NOT.ALL) CALL CLOSE (BGPDT,1)
      CALL GOPEN (DIRCOS,Z(BUF1),1)
      IN   = 1
      IOUT = 1
      II   = 1
      NN   = LUSET
      INCR = 1
      MCB(1) = DIRCOS
      MCB(2) = 0
      MCB(3) = LUSET
      MCB(4) = 2
      MCB(5) = 1
      MCB(6) = 0
      MCB(7) = 0
      DO 220 I = 1,NDIR
      JSUB = NCSTM + LUSET*(I-1)
      CALL PACK (Z(JSUB+1),DIRCOS,MCB)
  220 CONTINUE
C
      CALL CLOSE (DIRCOS,1)
      CALL WRTTRL (MCB)
      RETURN
C
  500 WRITE  (OTPE,510) UFM,SHOCK,DIRECT
  510 FORMAT (A23,', SHOCK AND DIRECT ARE',2I10, /10X,'RESPECTIVELY. ',
     1       'SHOCK MUST BE NONNEGATIVE AND DIRECT MUST BE EITHER 1,2',
     2       ',3,12,13,23, OR 123')
      CALL MESAGE (-61,0,0)
C
 1002 N = -2
      GO TO 1010
 1008 N = -8
      FILE = 0
 1010 CALL MESAGE (N,FILE,NAM)
      RETURN
      END

      SUBROUTINE DZYMAT (D,NFB,NLB,NTZYS,IDZDY,NTAPE,XP,BETA,IPRNT,NS,
     1                   NC,YP,ZP,SG,CG,YB,ZB,NBEA)
C
C     CALCULATION OF DZ AND DY MATRICES SLENDER BODY CALCULATIONS
C
C     D         WORKING ARRAY USED TO STORE A ROW OF DZ OR DY
C     NFB       NUMBER OF THE FIRST BODY WITH THE ORIENTATION REQUESTED
C     NLB       NUMBER OF THE LAST BODY WITH THE ORIENTATION
C               REQUESTED
C     NTZYS     NUMBER OF Z OR Y ORIENTED SLENDER BODY ELE.
C     NTAPE     I/O UNIT NUMBER WHICH THE OUTPUT MATRIX IS TO
C               BE WRITTEN ON
C     XP        X-CONTROL POINT COORDINATE OF LIFTING SURFACE
C               BOXES
C     BETA      SQRT(1.0 - M**2)
C
      INTEGER         BY,BZ,C,C1,P,S,S1,YT,ZT
      DIMENSION       D(2,NTZYS),XP(1),NS(1),NC(1),YP(1),ZP(1),SG(1),
     1                CG(1),YB(1),ZB(1),NBEA(1)
      COMMON /DLBDY / NJ1,NK1,NP,NB,NTP,NBZ,NBY,NTZ,NTY,NT0,NTZS,NTYS,
     1                INC,INS,INB,INAS,IZIN,IYIN,INBEA1,INBEA2,INSBEA,
     2                IZB,IYB,IAVR,IARB,INFL,IXLE,IXTE,INT121,INT122,
     3                IZS,IYS,ICS,IEE,ISG,ICG,IXIJ,IX,IDELX,IXIC,IXLAM,
     4                IA0,IXIS1,IXIS2,IA0P,IRIA,INASB,IFLA1,IFLA2,ITH1A,
     5                ITH2A,ECORE,NEXT,SCR1,SCR2,SCR3,SCR4,SCR5
      COMMON /ZZZZZZ/ Z(1)
      COMMON /AMGMN / MCB(7),NROW,ND,NE,REFC,FMACH,KR
      COMMON /SYSTEM/ SYSBUF,NPOT
C
      C1 = 0
      S1 = 0
      NFYB = NB - NBY  + 1
      IF (NP .EQ. 0) GO TO 410
C
C     THIS LOOP IS FOR EACH LIFTING SURF. PANEL
C
      ISN = 0
      DO 400 P = 1,NP
      NSP = NS(P)
      NCP = NC(P)
      NSP = (NSP-ISN)/NCP
      ISN = NS(P)
C
C     LOOP FOR EACH STRIP IN PANEL -P-
C
      DO 350 S = 1,NSP
      S1  = S1 + 1
C
C     Y AND Z COORDINATE OF STRIP
C
      DY  = YP(S1)
      DZ  = ZP(S1)
      SGR = SG(S1)
      CGR = CG(S1)
C
C     LOOP FOR EACH CHORDWISE ELEMENT IN STRIP
C
      DO 300 C = 1,NCP
      C1  = C1 + 1
      DX  = XP(C1)
C
C     - ROWDYC -  CALCULATES ROW -C1- OF DZ OR DY
C
      CALL ROWDYZ (NFB,NLB,C1,NTZYS,D,DX,DY,DZ,BETA,IDZDY,NTAPE,SGR,
     1             CGR,IPRNT,YB,ZB,Z(IARB),Z(INSBEA),Z(IXIS1),Z(IXIS2),
     2             Z(IA0))
C
  300 CONTINUE
  350 CONTINUE
  400 CONTINUE
C
C     WE HAVE NOW CALCULATED -C1- ROWS WHICH ARE THE LIFTING SURFACES.
C     NOW, LOOP FOR THE -Z- ORIENTED BODIES
C
  410 CONTINUE
      IF (NBZ.LE.0 .OR. NTZ.LE.0) GO TO 510
      SGR = 0.0
      CGR = 1.0
      DO 500 BZ = 1,NBZ
      DY  = YB(BZ)
      DZ  = ZB(BZ)
      NBEZ = NBEA(BZ)
C
C     LOOP FOR EACH ELEMENT OF BODY -BZ-
C
      DO 450 ZT = 1,NBEZ
      C1  = C1 + 1
      DX  = XP(C1)
C
      CALL ROWDYZ (NFB,NLB,C1,NTZYS,D,DX,DY,DZ,BETA,IDZDY,NTAPE,SGR,
     1             CGR,IPRNT,YB,ZB,Z(IARB),Z(INSBEA),Z(IXIS1),Z(IXIS2),
     2             Z(IA0))
  450 CONTINUE
  500 CONTINUE
C
C     NOW, LOOP FOR THE -Y- ORIENTED BODIES
C
  510 IF (NB.LT.NFYB .OR. NTY.LE.0) GO TO 650
      IXP = NTP
      IF (NFYB .LE. 1) GO TO 530
      NFYBM1 = NFYB - 1
      DO 520 I = 1,NFYBM1
  520 IXP = IXP + NBEA(I)
  530 CONTINUE
      SGR =-1.0
      CGR = 0.0
      DO 600 BY = NFYB,NB
      DY  = YB(BY)
      DZ  = ZB(BY)
      NBEY = NBEA(BY)
C
C     LOOP FOR EACH ELEMENT OF BODY -BY-
C
      DO 550 YT = 1,NBEY
      C1  = C1  + 1
      IXP = IXP + 1
      DX  = XP(IXP)
C
      CALL ROWDYZ (NFB,NLB,C1,NTZYS,D,DX,DY,DZ,BETA,IDZDY,NTAPE,SGR,
     1             CGR,IPRNT,YB,ZB,Z(IARB),Z(INSBEA),Z(IXIS1),Z(IXIS2),
     2             Z(IA0))
C
  550 CONTINUE
  600 CONTINUE
  650 CONTINUE
      RETURN
      END

      SUBROUTINE AMPD (QJHUA,QHHO,SKJ,GKI,QHH,SCR1,SCR2,SCR3,SCR4)
C
C     THE PURPOSE OF THIS ROUTINE IS TO COMPUTE(OR RETRIEVE) QHH
C
C     QHH EITHER EXISTS ON QHHO (AS COLUMN QCOL) OR MUST BE COMPUTED
C     AS FOLLOWS
C
C     1. QKH = SKJ*QJH
C     2. QIH = GKI(T)*QKH
C     3. QHH = 1 QIH 1
C              1-----1
C              1 0   1
C              1     1
C
      INTEGER         QJHUA,QHHO,SKJ,GKI,QHH,AJJCOL,QHHCOL,SYSBUF,FILE,
     1                SCR1,SCR2,SCR3,NAME(2),MCB(7),SCR4,QKH
      COMMON /AMPCOM/ NCOL,NSUB,XM,XK,AJJCOL,QHHCOL,NGP,NGPD(2,30),
     1                MCBQHH(7),MCBQJH(7),NOH
      COMMON /ZZZZZZ/ IZ(1)
      COMMON /SYSTEM/ SYSBUF,NOUT,SKP(52),IPREC
      COMMON /UNPAKX/ ITC,II,JJ,INCR
      COMMON /BLANK / NOUE
      DATA    NAME  / 4HAMPD,4H    /
C
      IBUF1 = KORSZ(IZ) - SYSBUF + 1
      IBUF2 = IBUF1 - SYSBUF
      INCR  = 1
      ITC   = MCBQHH(5)
C
C     DETERMINE IF QHH EXISTS ON QHHO
C
      IF (QHHCOL .EQ. 0) GO TO 100
C
C     COPY FROM QHHO TO QHH
C
      CALL GOPEN (QHH,IZ(IBUF1),3)
      CALL GOPEN (QHHO,IZ(IBUF2),0)
      K = QHHCOL - 1
      IF (K .EQ. 0) GO TO 20
      FILE = QHHO
      DO 10 I = 1,K
      CALL FWDREC (*910,QHHO)
   10 CONTINUE
   20 CONTINUE
      CALL CYCT2B (QHHO,QHH,NOH,IZ,MCBQHH)
      CALL CLOSE  (QHHO,1)
      CALL CLOSE  (QHH,3)
      RETURN
C
C     QHH MUST BE COMPUTED
C
  100 CONTINUE
C
C     COPY SKJ TO SCR4 FOR PROPER M-K PAIR
C
      CALL GOPEN (SKJ,IZ(IBUF1),0)
      CALL GOPEN (SCR4,IZ(IBUF2),1)
      K = AJJCOL - 1
      CALL SKPREC (SKJ,K)
      MCB(1) = QJHUA
      CALL RDTRL (MCB)
      NCOLJ  = MCB(3)
      MCB(1) = SKJ
      CALL RDTRL (MCB)
      MCBQJH(3) = MCB(3)
      MCB(1) = SCR4
      MCB(2) = 0
      MCB(6) = 0
      MCB(7) = 0
      ITC = MCB(5)
      CALL CYCT2B (SKJ,SCR4,NCOLJ,IZ,MCB)
      CALL CLOSE  (SKJ,1)
      CALL CLOSE  (SCR4,1)
      CALL WRTTRL (MCB)
      CALL SSG2B  (SCR4,QJHUA,0,SCR1,0,IPREC,1,SCR2)
C
C     COPY SCR1(QKH) TO OUTPUT
C
      QKH = MCBQJH(1)
      IF (QKH .LE. 0) GO TO 200
      ITC  = MCBQJH(5)
      INCR = 1
      CALL GOPEN  (SCR1,IZ(IBUF1),0)
      CALL GOPEN  (QKH,IZ(IBUF2),3)
      CALL CYCT2B (SCR1,QKH,NOH,IZ,MCBQJH)
      CALL CLOSE  (QKH,3)
      CALL CLOSE  (SCR1,1)
  200 CONTINUE
      CALL SSG2B (GKI,SCR1,0,SCR3,1,IPREC,1,SCR2)
C
C     COPY TO QHH
C
      CALL GOPEN (QHH,IZ(IBUF1),3)
      CALL GOPEN (SCR3,IZ(IBUF2),0)
      ITC  = MCBQHH(5)
      INCR = 1
      CALL CYCT2B (SCR3,QHH,NOH,IZ,MCBQHH)
      CALL CLOSE  (SCR3,1)
      CALL CLOSE  (QHH,3)
      RETURN
C
C     ERRORS
C
  910 IP1 = -2
      CALL MESAGE (IP1,FILE,NAME)
      GO TO 910
      END

      SUBROUTINE CM TIM U (Y,X,FILE,BUF)
C
C     CM TIM U FORMS THE MATRIX PRODUCT X = M*Y WHERE ALL MAY BE COMPLEX
C
      INTEGER            DIAG      ,EOL      ,EOR      ,FILEM(7) ,
     1                   FILEK     ,FILE(1)  ,FILEMM   ,BUF(1)   ,
     2                   NAME(2)
      DOUBLE PRECISION   X(1)      ,Y(1)     ,DA
      COMMON   /CINVPX/  FILEK(7)  ,FILEMM(7)
      COMMON   /NAMES /  RD        ,RDREW    ,WRT      ,WRTREW   ,
     1                   REW       ,NOREW    ,EOFNRW   ,RSP      ,
     2                   RDP       ,CSP      ,CDP      ,SQR      ,
     3                   RECT      ,DIAG     ,LOWTRI   ,UPRTRI   ,
     4                   SYM       ,ROW      ,IDENTY
      COMMON   /CINVXX/  DUM(21)   ,NZERO
      COMMON   /ZNTPKX/  DA(2)     ,II       ,EOL      ,EOR
C     COMMON   /DESCRP/  LENGTH    ,MAJOR(1)
      EQUIVALENCE        (NCOL,FILEK(2))
      DATA      NAME  /  4HCMTI    ,4HMU     /
C
      IF (FILE(1) .EQ. 0) GO TO 5
C
C     USE MATRIX OTHER THAN THE MASS MATRIX
C
      DO 4 I = 1,7
    4 FILEM(I) = FILE(I)
      GO TO 8
C
C     USE MASS MATRIX
C
    5 DO 7 I = 1,7
    7 FILEM(I) = FILEMM(I)
    8 CONTINUE
      NCOL2 = NCOL + NCOL
      IF (FILEM(4) .EQ. IDENTY) GO TO 50
      NZERO = 0
      CALL GOPEN (FILEM(1),BUF,RDREW)
      DO 10 I = 1,NCOL2
   10 X(I) = 0.D0
      IF (FILEM(4) .EQ. DIAG) GO TO 40
C
C     MASS MATRIX IS NOT DIAGONAL
C
      DO 30 I = 1,NCOL2,2
      IF (Y(I).EQ.0.D0 .AND. Y(I+1).EQ.0.D0) GO TO 25
      CALL INTPK (*30,FILEM(1),0,CDP,0)
   22 CALL ZNTPKI
      IF (II .EQ. I) NZERO = NZERO + 1
      II = II+II-1
      X(II  ) = X(II  ) + DA(1)*Y(I  )-DA(2)*Y(I+1)
      X(II+1) = X(II+1) + DA(1)*Y(I+1)+DA(2)*Y(I  )
      IF (EOL .EQ. 0) IF (EOR) 30,22,30
      GO TO 30
   25 CALL FWDREC (*80,FILEM(1))
   30 CONTINUE
      GO TO 80
C
C     FILE ERROR
C
C  35 J = -1
C     GO TO 37
C  36 J = -2
C  37 CALL MESAGE (J,FILEM(1),NAME)
C
C     MASS MATRIX IS DIAGONAL
C
   40 CALL INTPK (*80,FILEM(1),0,CDP,0)
   45 CALL ZNTPKI
      II = II + II - 1
      X(II  ) = Y(II)*DA(1) - Y(II+1)*DA(2)
      X(II+1) = Y(II)*DA(2) + Y(II+1)*DA(1)
      NZERO = NZERO + 1
      IF (EOL .EQ. 0) IF (EOR) 80,45,80
      GO TO 80
C
C     MASS MATRIX IS THE IDENTY
C
   50 DO 55 I = 1,NCOL2
   55 X(I) = Y(I)
      NZERO = 0
      RETURN
C
   80 CALL CLOSE (FILEM(1),REW)
      NZERO = 0
      RETURN
      END

      SUBROUTINE SCRLM (SCURL, XXI, E, H, CONT, RP, ALF1, R1, LAM1,HF)
C
C THIS SUBROUTINE COMPUTES THE STRESS MATRIX IN FIELD COORDINATES
C FOR THE TOROIDAL RING ELEMENT
C
C
C NOTE THE DOUBLE SUBSCRIPTING USED IN THE SCRLM SUBROUTINE IS
C COMPATIBLE WITH THE CALLING PROGRAM. THE SEL ARRAY WILL RETURN WITH
C THE STRESS MATRIX TRANSPOSED (10X15, STORED ROWWISE) BUT IN THE SCRLM
C SUBROUTINE THE STRESS MATRIX IS COMPUTED AS A DOUBLY SUBSCRIPTED
C 15X10 ARRAY (STORED COLUMNWISE).
C
      DIMENSION SCURL (15,10), E (2,2), XXI (3)
      REAL LAM1 , LAM2 , LAM3 ,LAM4
C     ------------------------------------------------------------------
C
      SC1 = H
      SC2 =HF**3 / 12.0
      JJ = 1
      KK = 3
      LL = 5
C
      DO 195 I = 1,3
      XX1 = XXI(I)
      XX2 = XX1 * XX1
      XX3 = XX2 * XX1
      XX4 = XX3 * XX1
      XX5 = XX4 * XX1
      CALL SOLVE1(ALF1,R1,RP,XX1,LAM2,LAM3,LAM4,CONT)
      DO 185 J = 1,2
      SCURL(JJ, 1) = LAM2 * E(J,2)
      SCURL(JJ, 2) = SCURL(JJ,1) * XX1 + E(1,J)
      SCURL(JJ, 3) = SCURL(JJ,1) * XX2 + E(1,J) * 2.0 * XX1
      SCURL(JJ, 4) = SCURL(JJ,1) * XX3 + E(1,J) * 3.0 * XX2
      SCURL(JJ, 5) = LAM1 * E(1,J) + LAM3 * E(J,2)
      SCURL(JJ, 6) = SCURL(JJ,5) * XX1
      SCURL(JJ, 7) = SCURL(JJ,5) * XX2
      SCURL(JJ, 8) = SCURL(JJ,5) * XX3
      SCURL(JJ, 9) = SCURL(JJ,5) * XX4
      SCURL(JJ,10) = SCURL(JJ,5) * XX5
      JJ = JJ + 1
  185 CONTINUE
      JJ = JJ + 3
      DO 190 K = 1,2
      SCURL (KK,1) = 0.0
      SCURL (KK,2) = 0.0
      SCURL (KK,3) = 0.0
      SCURL (KK,4) = 0.0
      SCURL(KK, 5) = 0.0
      SCURL(KK, 6) = -LAM2 * E(K,2)
      SCURL(KK, 7) = SCURL(KK,6) * 2.0 * XX1 - E(1,K) *  2.0
      SCURL(KK, 8) = SCURL(KK,6) * 3.0 * XX2 - E(1,K) *  6.0 * XX1
      SCURL(KK, 9) = SCURL(KK,6) * 4.0 * XX3 - E(1,K) * 12.0 * XX2
      SCURL(KK,10) = SCURL(KK,6) * 5.0 * XX4 - E(1,K) * 20.0 * XX3
      KK = KK + 1
  190 CONTINUE
      KK = KK + 3
      EL = E(1,1) * LAM2
      ELL = EL * LAM1
      EEL = E(1,1) * LAM1
      SCURL (LL,1) = 0.0
      SCURL (LL,2) = 0.0
      SCURL (LL,3) = 0.0
      SCURL (LL,4) = 0.0
      SCURL (LL,5) = 0.0
      SCURL(LL, 6) = LAM2**2 * E(2,2) - LAM4 * E(1,2)
      SCURL(LL, 7) = SCURL(LL,6) * 2.0 * XX1 - 2.0 * EL
      SCURL(LL, 8) = SCURL(LL,6) * 3.0 * XX2 - 6.0 * (EL * XX1 + E(1,1))
      SCURL(LL, 9) = SCURL(LL,6) * 4.0 * XX3 - 12.0 * EL * XX2 - 24.0 *
     1 E(1,1) * XX1
      SCURL(LL,10) = SCURL(LL,6) * 5.0 * XX4 - 20.0 * EL * XX3 - 60.0 *
     1 E(1,1) * XX2
      LL = LL + 5
  195 CONTINUE
C
C     ADJUSTMENT FOR SHELL CAP CASE
      IF ( ALF1 .NE. 0.0 )  GO TO 198
      SCURL (1,2) =  E(1,2) + E(1,1)
      SCURL (2,2) =  E(2,2) + E(1,2)
      SCURL (3,7) = -2. * (E(1,2) + E(1,1) )
      SCURL (4,7) =  2. * (E(2,2) + E(1,2) )
      SCURL (5,8) =  3. * (E(2,2) - 4.*E(1,1) )
  198 DO 200 J = 1,15,5
      DO 200 I = 1,10
      SCURL(J  ,I) = SCURL(J  ,I) * SC1
      SCURL(J+1,I) = SCURL(J+1,I) * SC1
      SCURL(J+2,I) = SCURL(J+2,I) * SC2
      SCURL(J+3,I) = SCURL(J+3,I) * SC2
      SCURL(J+4,I) = SCURL(J+4,I) * SC2
  200 CONTINUE
      RETURN
      END

      SUBROUTINE FVRS1C (Z,W1,OMEGA,NF)
C----------------------------------------------------------------------
      COMPLEX Z(3,NF),P,Z1,PY1A,PY1B,PZ1A,PZ1B,PY2A,PY2B,PZ2A,PZ2B
C
      DIMENSION W1(NF)
C
      COMMON /CONDAS/ PI,TWOPI,RADEG,DEGRA,S4PIQ
      COMMON /BLANK / DUM(5),IXT,IXP,IYT,IYP,IZT,IZP,DUM1(3)
C----------------------------------------------------------------------
      LL=1
      DO 400 KKK=1,NF
      IF(W1(KKK).EQ.0.0)GO TO 30
      A=1.0
      IF(W1(KKK)-OMEGA.LT.0.0)A=-1.0
      B=1.0
      IF(W1(KKK)+OMEGA.LT.0.0)B=-1.0
C
C     COMPUTE BASE(FI)(3X3)  IF W.NE.0--MODFRL=TRUE
C
C     ZERO OUT MATRIX
C
      KK=LL+2
      DO 1 I=1,3
      DO 1 J=LL,KK
  1   Z(I,J)=(0.0,0.0)
      F=W1(KKK)/TWOPI
      IF(IXT.EQ.-1) GO TO 9
      CALL TAB(IXT,F,XO)
      IF(IXP.EQ.-1)GO TO 4
      CALL TAB(IXP,F,PHI)
      RAD=PHI*DEGRA
      Z1=CMPLX(0.0,RAD)
      P=CEXP(Z1)
      GO TO 5
 4    P=(1.0,0.0)
 5    Z(1,LL+1)=XO*P
 9    IF(IYT.EQ.-1)GO TO 11
      CALL TAB(IYT,F,YO)
      GO TO 12
 11   YO=0.0
 12   IF(IZT.EQ.-1)GO TO 13
      CALL TAB(IZT,F,ZO)
      GO TO 14
 13   ZO=0.0
 14   IF(IYP.EQ.-1)GO TO 15
      CALL TAB(IYP,F,PHI)
      GO TO 16
 15   PHI=0.0
 16   RAD=PHI*DEGRA
      Z1=CMPLX(0.0,RAD)
      PY1A=CEXP(A*Z1)
      PY1B=CEXP(B*Z1)
      Z1=CMPLX(0.0,RAD-0.5*PI*A)
      PY2A=CEXP(A*Z1)
      Z1=CMPLX(0.0,RAD-0.5*PI*B)
      PY2B=CEXP(B*Z1)
      IF(IZP.EQ.-1)GO TO 17
      CALL TAB(IZP,F,PHI)
      GO TO 18
 17   PHI=0.0
 18   RAD=PHI*DEGRA
      Z1=CMPLX(0.0,RAD)
      PZ1A=CEXP(A*Z1)
      PZ1B=CEXP(B*Z1)
      Z1=CMPLX(0.0,RAD-0.5*PI*A)
      PZ2A=CEXP(A*Z1)
      Z1=CMPLX(0.0,RAD-0.5*PI*B)
      PZ2B=CEXP(B*Z1)
      Z(2,LL)=(YO*PY1A-A*ZO*PZ2A)*0.5
      Z(3,LL)=(A*YO*PY2A+ZO*PZ1A)*0.5
      Z(2,LL+2)=(YO*PY1B+B*ZO*PZ2B)*0.5
      Z(3,LL+2)=(-B*YO*PY2B+ZO*PZ1B)*0.5
      LL=LL+3
      GO TO 400
 30   CONTINUE
C
C     COMPUTE BASE(FI)(3X2) IF W1=0.0, FOR MODFRL=TRUE
C
      A=1.0
      IF(OMEGA.LT.0.0)A=-1.0
C------ZERO OUT MATRIX(3X2)
      KK=LL+1
      DO 32 I=1,3
      DO 32 J=LL,KK
 32   Z(I,J)=(0.0,0.0)
      F=W1(KKK)/TWOPI
      IF(IXT.EQ.-1)GO TO 90
      CALL TAB(IXT,F,XO)
      IF(IXP.EQ.-1)GO TO 40
      CALL TAB(IXP,F,PHI)
      RAD=PHI*DEGRA
      Z1=CMPLX(0.0,RAD)
      P=CEXP(Z1)
      GO TO 50
 40   P=(1.0,0.0)
 50   Z(1,LL)=XO*P
      GO TO 100
 90   Z(1,LL)=(0.0,0.0)
 100  IF(IYT.EQ.-1)GO TO 190
      CALL TAB(IYT,F,YO)
      IF(IYP.EQ.-1) GO TO 140
      CALL TAB(IYP,F,PHI)
      RAD=PHI*DEGRA
      CY=COS(RAD)
      GO TO 150
 140  CY=1.0
 150  YY=YO*CY
      GO TO 200
 190  YY=0.0
 200  IF(IZT.EQ.-1)GO TO 290
      CALL TAB(IZT,F,ZO)
      IF(IZP.EQ.-1) GO TO 240
      CALL TAB(IZP,F,PHI)
      RAD=PHI*DEGRA
      CZ=COS(RAD)
      GO TO 250
 240  CZ=1.0
 250  ZZ=ZO*CZ
      GO TO 300
 290  ZZ=0.0
 300  Z(2,KK)=YY-A*CMPLX(0.0,ZZ)
      Z(3,KK)=ZZ+A*CMPLX(0.0,YY)
      LL=LL+2
 400  CONTINUE
      RETURN
      END

      SUBROUTINE SAXB( A, B, C )
      REAL A(3), B(3), C(3), D(3)
C*****
C  SINGLE-PRECISION VERSION
C
C  THIS ROUTINE PERFORMS A X B INTO C.  (C MAY OVERLAP A OR B IN CORE.)
C*****
      D(1) = A(2)*B(3) - A(3)*B(2)
      D(2) = A(3)*B(1) - A(1)*B(3)
      D(3) = A(1)*B(2) - A(2)*B(1)
      C(1) = D(1)
      C(2) = D(2)
      C(3) = D(3)
      RETURN
C
C*****
      ENTRY SAPB( A, B, C )
C
C  THIS ROUTINE PERFORMS A + B INTO C.
C*****
      C(1) = A(1) + B(1)
      C(2) = A(2) + B(2)
      C(3) = A(3) + B(3)
      RETURN
C
C*****
      ENTRY SAMB( A, B, C )
C
C  THIS ROUTINE PERFORMS A - B INTO C.
C*****
      C(1) = A(1) - B(1)
      C(2) = A(2) - B(2)
      C(3) = A(3) - B(3)
      RETURN
      END

      SUBROUTINE ALG17 (ISTAK,PLTSZE,ITRIG,TITLE,IKDUM,IFPLOT)
C
      DIMENSION TITLE(18)
C
      PLTTIT=PLTSZE*.1
      IF (ISTAK.LT.2) GO TO 10
      BAL=.35*PLTSZE
      XLEN1=.3*PLTSZE
      XLEN2=XLEN1
      YLEN1=.25*PLTSZE
      YLEN2=-1.*YLEN1
      XBACK1=-1.9
      XBACK2=-6.2
      GO TO 50
10    IF (ISTAK.EQ.0) GO TO 20
      XLEN1=.70*PLTSZE
      XLEN2=.15*PLTSZE
      XBACK1=-1.9-.20*PLTSZE
      XBACK2=-6.2-.20*PLTSZE
      IF (IKDUM.EQ.1) GO TO 30
      GO TO 40
20    CONTINUE
      XLEN1=.15*PLTSZE
      XLEN2=.70*PLTSZE
      XBACK1=-1.9+.20*PLTSZE
      XBACK2=-6.2+.20*PLTSZE
      IF (IKDUM.EQ.1) GO TO 40
30    BAL=.25*PLTSZE
      YLEN1=.50*PLTSZE
      YLEN2=-.15*PLTSZE
      GO TO 50
40    BAL=.50*PLTSZE
      YLEN1=.15*PLTSZE
      YLEN2=-.50*PLTSZE
50    CONTINUE
      YBACK1=-(.35+BAL)
      YBACK2=YBACK1-.01*PLTSZE-.175
      GO TO (60,70), ITRIG
60    CONTINUE
      GO TO 80
70    XBACK1=XBACK1+0.35
80    CONTINUE
      RETURN
      END

      SUBROUTINE SSGETD (ELID,TI,GRIDS)
C
C     THIS ROUTINE (CALLED BY -EDTL-) READS ELEMENT TEMPERATURE
C     DATA FROM A PRE-POSITIONED RECORD
C
C     ELID   = ID OF ELEMENT FOR WHICH DATA IS DESIRED
C     TI     = BUFFER DATA IS TO BE RETURNED IN
C     GRIDS  = 0 IF EL-TEMP FORMAT DATA IS TO BE RETURNED
C            = NO. OF GRID POINTS IF GRID POINT DATA IS TO BE RETURNED.
C     ELTYPE = ELEMENT TYPE TO WHICH -ELID- BELONGS
C     OLDEL  = ELEMENT TYPE CURRENTLY BEING WORKED ON (INITIALLY 0)
C     EORFLG = .TRUE. WHEN ALL DATA HAS BEEN EXHAUSTED IN RECORD
C     ENDID  = .TRUE. WHEN ALL DATA HAS BEEN EXHAUSTED WITHIN AN ELEMENT
C              TYPE.
C     BUFFLG = NOT USED
C     ITEMP  = TEMPERATURE LOAD SET ID
C     IDEFT  = NOT USED
C     IDEFM  = NOT USED
C     RECORD = .TRUE. IF A RECORD OF DATA IS INITIALLY AVAILABLE
C     DEFALT = THE DEFALT TEMPERATURE VALUE OR -1 IF IT DOES NOT EXIST
C     AVRAGE = THE AVERAGE ELEMENT TEMPERATURE
C
      LOGICAL         EORFLG   ,ENDID    ,BUFFLG   ,RECORD
      INTEGER         TI(7)    ,GRIDS    ,ELID     ,ELTYPE   ,OLDEL   ,
     1                NAME(2)  ,GPTT     ,DEFALT
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /SYSTEM/ DUM      ,IOUT
      COMMON /SSGETT/ ELTYPE   ,OLDEL    ,EORFLG   ,ENDID    ,BUFFLG  ,
     1                ITEMP    ,IDEFT    ,IDEFM    ,RECORD
      COMMON /LOADX / DUMMY(9) ,GPTT
      COMMON /FPT   / DEFALT
      DATA    NAME  / 4HSSGE,4HTD   /    ,MAXWDS   / 15 /
C
      IF (ITEMP .NE. 0) GO TO 20
      DO 10 I = 1,MAXWDS
   10 TI(I) = 0
      RETURN
C
   20 IF (.NOT.RECORD .OR. EORFLG) GO TO 80
   30 IF (ELTYPE .NE. OLDEL) GO TO 150
      IF (ENDID) GO TO 80
C
C     HERE WHEN ELTYPE IS AT HAND AND END OF THIS TYPE DATA
C     HAS NOT YET BEEN REACHED.  READ AN ELEMENT ID
C
   40 CALL READ (*200,*210,GPTT,ID,1,0,FLAG)
      IF (ID) 50,80,50
   50 IF (IABS(ID) .EQ. ELID) IF (ID) 90,90,70
      IF (ID) 40,40,60
   60 CALL READ (*200,*210,GPTT,TI,NWORDS,0,FLAG)
      GO TO 40
C
C     MATCH ON ELEMNT ID MADE, AND IT WAS WITH DATA.
C     IF QUAD4 OR TRIA3 ELEMENT, SET THE TI(7) FLAG FOR TLQD4D/S (QAUD4)
C     OR TLTR3D/S (TRIA3)
C
   70 CALL READ (*200,*210,GPTT,TI,NWORDS,0,FLAG)
      IF (ELTYPE.NE.64 .AND. ELTYPE.NE.83) RETURN
      TI(7) = 13
      IF (TI(6) .NE. 1) TI(7) = 2
      RETURN
C
C     NO MORE DATA FOR THIS ELEMENT TYPE
C
   80 ENDID = .TRUE.
C
C     NO DATA FOR ELEMENT ID DESIRED, THUS USE DEFALT
C
   90 IF (DEFALT .EQ. -1) GO TO 130
      IF (GRIDS  .GT.  0) GO TO 110
      DO 100 I = 2,MAXWDS
  100 TI(I) = 0
      TI(1) = DEFALT
      IF (ELTYPE .EQ. 34) TI(2) = DEFALT
      RETURN
  110 DO 120 I = 1,GRIDS
  120 TI(I) = DEFALT
      TI(GRIDS+1) = DEFALT
      RETURN
C
C     NO TEMP DATA OR DEFALT
C
  130 WRITE  (IOUT,140) UFM,ELID,ITEMP
  140 FORMAT (A23,' 4017. THERE IS NO TEMPERATURE DATA FOR ELEMENT',I9,
     1        ' IN SET',I9)
      CALL MESAGE (-61,0,0)
C
C     LOOK FOR MATCH ON ELTYPE (FIRST SKIP ANY UNUSED ELEMENT DATA)
C
  150 IF (ENDID) GO TO 180
  160 CALL READ (*200,*210,GPTT,ID,1,0,FLAG)
      IF (ID) 160,180,170
  170 CALL READ (*200,*210,GPTT,TI,NWORDS,0,FLAG)
      GO TO 160
C
C     READ ELTYPE AND COUNT
C
  180 CALL READ (*200,*190,GPTT,TI,2,0,FLAG)
      OLDEL  = TI(1)
      NWORDS = TI(2)
      ENDID  = .FALSE.
      GO TO 30
C
C     END OF RECORD HIT
C
  190 EORFLG = .TRUE.
      GO TO 80
C
  200 CALL MESAGE (-2,GPTT,NAME)
  210 CALL MESAGE (-3,GPTT,NAME)
      RETURN
      END

      SUBROUTINE RCOVSS
C
C     THIS ROUTINE GENERATES THE STATIC SOLUTION ITEM FOR RIGID FORMATS
C     1 AND 2
C
      INTEGER         DRY        ,STEP       ,FSS        ,RFNO       ,
     1                SYSBUF     ,IZ(5)      ,RD         ,RDREW      ,
     2                WRT        ,WRTREW     ,REW        ,EOFNRW     ,
     3                LOD(4)     ,SOLN       ,EQSS       ,LOADC(2)   ,
     4                SRD        ,SWRT       ,EOG        ,EOI        ,
     5                CASESS     ,GEOM4      ,SCR1       ,RC         ,
     6                BUF1       ,BUF2       ,BUF3       ,CC(2)      ,
     7                FILE       ,NAME(2)    ,CASECC(2)
      REAL            CLOD(4)
      CHARACTER       UFM*23     ,UWM*25
      COMMON /XMSSG / UFM        ,UWM
      COMMON /BLANK / DRY        ,LOOP       ,STEP       ,FSS(2)     ,
     1                RFNO       ,NEIGV      ,LUI        ,UINMS(2,5) ,
     2                NOSORT     ,UTHRES     ,PTHRES     ,QTHRES
      COMMON /RCOVCR/ ICORE      ,LCORE      ,BUF1       ,BUF2       ,
     1                BUF3       ,BUF4       ,SOF1       ,SOF2       ,
     2                SOF3
      COMMON /RCOVCM/ MRECVR     ,UA         ,PA         ,QA         ,
     1                IOPT       ,RSS(2)     ,ENERGY     ,UIMPRO     ,
     2                RANGE(2)   ,IREQ       ,LREQ       ,LBASIC
      COMMON /SYSTEM/ SYSBUF     ,NOUT
      COMMON /ZZZZZZ/ Z(1)
      COMMON /NAMES / RD         ,RDREW      ,WRT        ,WRTREW     ,
     1                REW        ,NOREW      ,EOFNRW
      EQUIVALENCE     (Z(1),IZ(1)), (LOD(1),CLOD(1))
      DATA    NAME  / 4HRCOV,4HSS   /
      DATA    SOLN  , EQSS, LODS / 4HSOLN,4HEQSS,4HLODS /
      DATA    CASESS, GEOM4,SCR1 / 101,102,301 /
      DATA    LOADC / 500  ,5    /
      DATA    SRD   , SWRT, EOG,EOI / 1,2,2,3  /
      DATA    CASECC/ 4HCASE,4HCC   /
C
C     CREATE SOLN FOR RIGID FORMAT 1 OR 2
C
C     GET NUMBER OF BASIC SUBSTRUCTURES (NS) FROM EQSS AND CREATE
C     GROUP 0 OF SOLN AT TOP OF OPEN CORE
C
      CALL SFETCH (FSS,EQSS,SRD,RC)
      IF (RC .EQ. 1) GO TO 110
      CALL SMSG (RC-2,EQSS,FSS)
      GO TO 440
  110 CALL SUREAD (Z,2,NWDS,RC)
      CALL SUREAD (NS,1,NWDS,RC)
      IF (LCORE .LT. 3*NS+5) GO TO 9008
      CALL SUREAD (Z,1,NWDS,RC)
      IZ(1) = FSS(1)
      IZ(2) = FSS(2)
      IZ(3) = RFNO
      IZ(4) = NS
C
C     GET SUBSTRUCTURE NAMES FROM EQSS
C
      DO 120 I = 1,NS
      CALL SUREAD (Z(3*I+3),2,NWDS,RC)
  120 CONTINUE
C
C     COUNT NUMBER OF SUBCASES (NC) ON CASECC
C
      CALL GOPEN (CASESS,Z(BUF2),RDREW)
      NSKIP = 1
  130 CALL FREAD (CASESS,CC,2,1)
      NSKIP = NSKIP + 1
      IF (CC(1) .NE. CASECC(1)) GO TO 130
      IF (CC(2) .NE. CASECC(2)) GO TO 130
      NC = 0
  140 CALL FWDREC (*150,CASESS)
      NC = NC + 1
      GO TO 140
  150 CALL REWIND (CASESS)
      IZ(5) = NC
C
C     GET NUMBER OF LOAD VECTORS FOR EACH SUBSTRUCTURE FROM LODS
C
      CALL SFETCH (FSS,LODS,SRD,RC)
      IF (RC .EQ. 1) GO TO 160
      CALL SMSG (RC-2,LODS,FSS)
      GO TO 9200
  160 J = 1
      CALL SJUMP (J)
      DO 170 I = 1,NS
      CALL SUREAD (Z(3*I+5),1,NWDS,RC)
  170 CALL SJUMP (J)
C
C     SOLN GROUP 0 COMPLETE.  WRITE IT ON SCR1
C
      J = 3
      CALL GOPEN (SCR1,Z(BUF3),WRTREW)
      CALL WRITE (SCR1,Z,3*NS+5,1)
C
C     COMPRESS SUBSTRUCTURE NAMES AT TOP OF OPEN CORE
C
      DO 180 I = 1,NS
      IZ(2*I-1) = IZ(3*I+3)
  180 IZ(2*I  ) = IZ(3*I+4)
C
C     PREPARE TO LOOP OVER ALL SUBCASES
C
      ICASE = 2*NS + 1
      ILODS = ICASE + 166
      IF (ILODS .GT. LCORE) GO TO 9008
      LODSIN= 0
      NLODS = ILODS - 1
      FILE  = CASESS
      DO 190 I = 1,NSKIP
  190 CALL FWDREC (*9002,CASESS)
      NOLDC = 1
      CALL PRELOC (*195,Z(BUF1),GEOM4)
      CALL LOCATE (*195,Z(BUF1),LOADC,I)
      NOLDC = 0
C
C     BEGIN SUBCASE LOOP.  FOR EACH SUBCASE, BUILD ONE GROUP OF SOLN
C
  195 DO 390 ISC = 1,NC
      CALL FREAD (CASESS,Z(ICASE),166,0)
      NLDS = 0
      IF (IZ(ICASE+15) .NE. 0) GO TO 310
      FILE = CASESS
      CALL FWDREC (*9002,CASESS)
      FILE = GEOM4
C
C     PROCESS REGULAR SUBCASE.  IF LODS ITEM NOT IN CORE, GET IT.
C
      IF (IZ(ICASE+3) .EQ. 0) GO TO 300
      IF (NOLDC  .EQ. 1) GO TO 300
      IF (LODSIN .EQ. 1) GO TO 205
      CALL SFETCH (FSS,LODS,SRD,RC)
      I = 1
      CALL SJUMP (I)
      I = ILODS
      DO 200 J = 1,NS
      CALL SUREAD (Z(I),1,NWDS,RC)
      NLODS = I+IZ(I)
      IF (NLODS .GT. LCORE) GO TO 9008
      CALL SUREAD (Z(I+1),-1,NWDS,RC)
      I = NLODS + 1
  200 CONTINUE
      LODSIN = 1
C
C     LODS ITEM IN CORE.  FIND MATCH ON LOADC CARD WITH LOAD SET ID
C     FROM CASECC
C
  205 JSOLN = NLODS + 2
  210 CALL READ (*9002,*300,GEOM4,LOD,2,0,NWDS)
      IF (LOD(1) .EQ. IZ(ICASE+3)) GO TO 230
  220 CALL FREAD (GEOM4,LOD,4,0)
      IF (LOD(4) .EQ. -1) GO TO 210
      GO TO 220
C
C     FOUND MATCH ON LOADC CARD
C
  230 SFAC = CLOD(2)
C
C     LOOP OVER BASIC SUBSTRUCTURES ON THE LOADC CARD
C
  240 CALL FREAD (GEOM4,LOD,4,0)
      IF (LOD(4)  .EQ.    -1) GO TO 290
      IF (JSOLN+1 .GT. LCORE) GO TO 9008
C
C     FIND BASIC SUBSTRUCTURE NUMBER BY MATCHING ITS NAME WITH THOSE
C     FROM EQSS.  THEN DETERMINE LOAD VECTOR NUMBER BY MATCHING THE
C     BASIC SUBSTRUCTURE LOAD SET ID WITH THOSE IN LODS DATA IN CORE.
C
      DO 245 I = 1,NS
      IF (LOD(1) .NE. IZ(2*I-1)) GO TO 245
      K = I
      IF (LOD(2) .EQ. IZ(2*I)) GO TO 250
  245 CONTINUE
      WRITE (NOUT,6315) UWM,LOD(1),LOD(2),LOD(3),FSS
  250 N = 0
      I = ILODS
      J = 1
  260 IF (J .EQ. K) GO TO 265
      N = N + IZ(I)
      I = I + IZ(I) + 1
      J = J + 1
      GO TO 260
  265 J = IZ(I)
      DO 270 K = 1,J
      N = N + 1
      IF (IZ(I+K) .EQ. LOD(3)) GO TO 280
  270 CONTINUE
      WRITE (NOUT,6316) UWM,LOD(3),LOD(1),LOD(2),FSS
C
C     BUILD SOLN GROUP IN OPEN CORE FOLLOWING LODS DATA
C
  280 IZ(JSOLN ) = N
      Z(JSOLN+1) = SFAC*CLOD(4)
      JSOLN = JSOLN + 2
      NLDS  = NLDS  + 1
      GO TO 240
  290 IZ(NLODS+1) = NLDS
      JSOLN = NLODS + 1
      GO TO 385
C
C     NO LOADS FOR THIS SUBCASE
C
  300 NLDS = 0
      GO TO 290
C
C     PROCESS SYMCOM OR SUBCOM SUBCASE
C
C     READ SYMSEQ OR SUBSEQ INTO OPEN CORE AT ISEQ
C
  310 LCC   = IZ(ICASE+165)
      LSKIP = 167 - LCC
      CALL FREAD (CASESS,0,LSKIP,0)
      CALL FREAD (CASESS,LSEM,1,0)
  320 IF (LSEM+NLODS .LT. LCORE) GO TO 340
      IF (LODSIN .EQ. 0) GO TO 9008
C
C     SHORT OF CORE.  WIPE OUT LODS DATA AND RE-USE SPACE
C
  330 LODSIN = 0
      NLODS  = ILODS - 1
      GO TO 320
  340 ISEQ = NLODS + 1
      CALL FREAD (CASESS,Z(ISEQ),LSEM,1)
C
C     READ THE PREVIOUS LSEM GROUPS OF SOLN INTO OPEN CORE FOLLOWING SEQ
C
      JSOLN = ISEQ + LSEM
      K = JSOLN + 1
      CALL CLOSE (SCR1,EOFNRW)
      FILE = SCR1
      CALL OPEN (*9001,SCR1,Z(BUF3),RD)
      NREC = 1
      NLDS = 0
      DO 380 I = 1,LSEM
  342 DO 344 J = 1,NREC
  344 CALL BCKREC (SCR1)
      CALL FREAD (SCR1,N,1,0)
      NREC = 2
      IF (N .LT. 0) GO TO 342
      IF (K+2*N-1 .LT. LCORE) GO TO 360
      IF (LODSIN .EQ. 0) GO TO 9008
C
C     SHORT OF CORE.  REPOSITION CASESS, WIPE OUT LODS DATA, AND TRY
C     AGAIN
C
      CALL BCKREC (CASESS)
      CALL FREAD (CASESS,0,-166,0)
      GO TO 330
  360 CALL FREAD (SCR1,Z(K),2*N,1)
C
C     SCALE LOAD FACTORS BY SYMSEQ OR SUBSEQ FACTORS
C
      DO 370 J = 1,N
  370 Z(K+2*J-1) = Z(ISEQ+LSEM-I)*Z(K+2*J-1)
      K = K + 2*N
      NLDS = NLDS + N
  380 CONTINUE
      IZ(JSOLN) = -NLDS
C
C     COMBINATION GROUP COMPLETE.  REPOSITION SCR1
C
      FILE = SCR1
  381 CALL FWDREC (*382,SCR1)
      GO TO 381
  382 CALL SKPFIL (SCR1,-1)
      CALL CLOSE (SCR1,NOREW)
      CALL OPEN (*9001,SCR1,Z(BUF3),WRT)
C
C     GROUP COMPLETE IN CORE.  SORT ON LOAD VECTOR NUMBERS
C
  385 CALL SORT (0,0,2,1,Z(JSOLN+1),2*NLDS)
C
C     WRITE GROUP ON SCR1 AND POSITION GEOM4 TO BEGINNING OF LOADC CARDS
C
      CALL WRITE (SCR1,Z(JSOLN),2*NLDS+1,1)
      IF (NOLDC .EQ. 1) GO TO 390
      CALL BCKREC (GEOM4)
      CALL FREAD (GEOM4,0,-3,0)
C
C     END OF LOOP OVER SUBCASES
C
  390 CONTINUE
      CALL CLOSE (CASESS,REW)
      CALL CLOSE (GEOM4,REW)
      CALL CLOSE (SCR1,REW)
C
C     COPY SOLN FROM SCR1 TO SOF
C
      CALL GOPEN (SCR1,Z(BUF1),RDREW)
      RC = 3
      CALL SFETCH (FSS,SOLN,SWRT,RC)
  392 CALL READ (*396,*394,SCR1,Z,LCORE,1,NWDS)
      GO TO 9008
  394 CALL SUWRT (Z,NWDS,EOG)
      GO TO 392
  396 CALL CLOSE (SCR1,REW)
C
C     FINISH
C
      CALL SUWRT (0,0,EOI)
  440 CONTINUE
      RETURN
C
C     DIAGNOSTICS
C
 6315 FORMAT (A25,' 6315, RCOVR MODULE IS UNABLE TO FIND SUBSTRUCTURE ',
     1       2A4,' AMONG THOSE ON EQSS.' /32X,'LOAD SET',I9,
     2       ' FOR THAT SUBSTRUCTURE WILL BE IGNORED IN CREATING', /32X,
     3       'THE SOLN ITEM FOR FINAL SOLUTION STRUCTURE ',2A4)
 6316 FORMAT (A25,' 6316, RCOVR MODULE IS UNABLE TO FIND LOAD SET',I9,
     1       ' FOR SUBSTRUCTURE ',2A4, /32X,'AMONG THOSE ON LODS.  ',
     2       'IT WILL BE IGNORED IN CREATING THE SOLN ITEM FOR FINAL',
     3       /32X,'SOLUTION STRUCTURE ',2A4)
C
 9001 N = 1
      GO TO 9100
 9002 N = 2
      GO TO 9100
 9008 N = 8
 9100 CALL MESAGE (N,FILE,NAME)
 9200 CALL SOFCLS
      IOPT = -1
      CALL CLOSE (CASESS,REW)
      CALL CLOSE (GEOM4,REW)
      CALL CLOSE (SCR1,REW)
C
      RETURN
      END

      SUBROUTINE XCSA
C
C     XCSA READS AND PROCESSES THE NASTRAN EXECUTIVE CONTROL DECK.
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        LSHIFT,RSHIFT,ANDF,ORF,COMPLF
      LOGICAL         TAPBIT
      DIMENSION       ALTER(2),APPTYP(4),BGNAL(2),CEND(2),DIAGX(11),
     1                DMAPBF(1),ECTT(51),ENDAL(2),HDG(19),IPTDIC(1),
     2                IUFILE(2),IZ(2),NXPTDC(2),NXCSA(2),OSOLU(2),
     3                OUTCRD(200),SOLREC(6),SOLU(12),SOLNM3(7,11),
     5                SOLNMS(7,31),SOLNM1(7,10),SOLNM2(7,10),SOLNMX(6),
     6                XALT(2),XSYS(100)
      INTEGER         INSERT(4), DELETE(9), ALTRBS, ALNOGO
      INTEGER         ALTFIL, ERRALT, ALTOPN
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG / UFM,UWM,UIM,SFM
      COMMON /MACHIN/ MACH,IJHALF(3),MCHNAM
      COMMON /SEM   / MSKDUM(3),LINKS(15)
      COMMON /SYSTEM/ IBUFSZ,OUTTAP,XNOGO,INTAPE,SY5,SY6,LOGFL,SY8,
     1                NLPP,SY10,SY11,NLINES,SY13,SY14,IDATE(3),SY18,
     2                IECHO,SY20,APPRCH,SY22,SY23,ICFIAT,RFFLAG,
     3                SY26(11),LU,SY38,NBPC,NBPW,NCPW,SY42(13),PREC,
     4                SY56(13),ISUBS,SY70(9),SWITCH(3),ICPFLG,SY83(2),
     5                SY85,INTRA,SY87(5),LDICT
      COMMON /XECHOX/ DUM9(9),NOECHO
      COMMON /XRGDXX/ IRESTR,NSUBST
      COMMON /ALTRXX/ ALTFIL, NEWALT,ALNOGO
      COMMON /RESDIC/ IRDICT, IROPEN
      COMMON /XOLDPT/ ITOP,IBOT,LDIC,NRLFL,ISEQNO
      COMMON /XXFIAT/ IXXFAT(1)
      COMMON /XPFIST/ IXPFST
      COMMON /XFIST / IFIST(1)
      COMMON /XFIAT / IFIAT(1)
      COMMON /ZZZZZZ/ GBUFF(1)
      COMMON /BLANK / ZCOM,CARD(20)
      COMMON /STAPID/ TAPID(6),OTAPID(6)
      COMMON /STIME / TIME
      COMMON /L15 L8/ L15,L8,L13
      COMMON /XLINK / LXLINK,MAXLNK
      COMMON /OUTPUT/ PGHDG1(32),PGHDG2(32), PGHDG3(32),
     1                PGHDG4(32),PGHDG5(32), PGHDG6(32)
      EQUIVALENCE     (IBUFSZ   ,XSYS(1)  ), (MASK    ,MASKHI  ),
     1                (ECTT(16) ,BGNAL(1) ), (ECTT(25),ENDAL(1)),
     2                (ECTT(13) ,CEND(1)  ), (ECTT(34),ID      ),
     3                (SOLREC(1),APPREC   ), (SOLREC(2),RSTRT  ),
     4                (SOLREC(3),ALTER(1) ), (SOLREC(5),SOLU(1)),
     5                (GBUFF(1) ,DMAPBF( 1), IPTDIC(1)),
     6                (SOLNMS(1, 1),SOLNM1(1,1)),
     7                (SOLNMS(1,11),SOLNM2(1,1)),
     8                (SOLNMS(1,21),SOLNM3(1,1))
      DATA  APPTYP                                                   /
     1      4HDMAP,   4HDISP,   4HHEAT,   4HAERO                     /
      DATA  BLANK,    IXDMAP,   NSUBS,    RENTER,   DOLSIN           /
     2      1H ,      4HXDMA,   4HSUBS,   4HREEN,   4H$              /
      DATA  IYES,     NO,       IDISK,    PTAPE,    OPTAPE,   DMEND  /
     3      4HYES ,   4HNO  ,   4HDISK,   4HNPTP,   4HOPTP,   4HEND  /
      DATA  IUFILE,   XALT,               NXPTDC,             INTGR  /
     4      2*0,      4HXALT,   4HER  ,   4HXPTD,   4HC   ,   -1     /
      DATA  NXCSA,              DIAGX                                /
     5      4HXCSA,   4H    ,   4,9,14,17,23,24,25,28,29,30,31       /
      DATA  APPDMP,   APPHEA,   APPAER,   NUMAPP,   SOLREC           /
     6      1,        3,        4,        4,        0,1,0,0,0,0      /
      DATA  SOLUF,    OSOLU,    ICOLD,    IGNORE,   OUTCRD           /
     7      0,        2*0,      1,        0,        3,199*4H         /
      DATA  PLOT,     PRNT,     BOTH,     INP9  ,   NOTALT           /
     8      4HPLOT,   4HPRIN,   4HBOTH,   4HINP9,   0                /
      DATA  MASK /    32767 /
C                     32767 = O77777 = 2**15-1 = MASK HI
      DATA  LECTT,    ECTT /    51,
     1     4HTIME,4H    ,0   ,   4HAPP ,4H    ,0   ,   4HCHKP,4HNT  ,0,
     4     4HREST,4HART ,0   ,   4HCEND,4H    ,0   ,   4HALTE,4HR   ,0,
     7     4HSOL ,4H    ,0   ,   4HBEGI,4HN   ,0   ,   4HENDA,4HLTER,0,
     X     4HDIAG,4H    ,0   ,   4HUMF ,4H    ,0   ,   4HID  ,4H    ,1,
     3     4HUMFE,4HDIT ,0   ,   4HPREC,4H    ,0   ,   4HINTE,4HRACT,0
     *,    4HINSE,4HRT  ,0   ,   4HDELE,4HTE  ,0/
      DATA ILEFT  /4H(    /
      DATA ALTOPN / 0     /
      DATA HDG/4HN A ,4HS T ,4HR A ,4HN   ,4H E X,4H E C,4H U T,4H I V,
     1  4H E  ,4H  C ,4HO N ,4HT R ,4HO L ,4H   D,4H E C,4H K  ,4H  E ,
     2  4HC H ,4HO   /
      DATA NSOLNM /26/
      DATA SOLNM1 /
     1     4HSTAT,4HICS  , 4H    ,4H     , 4H    ,4H     ,  1 ,
     2     4HINER,4HTIA  , 4HRELI,4HEF   , 4H    ,4H     ,  2 ,
     3     4HNORM,4HAL   , 4HMODE,4HS    , 4H    ,4H     ,  3 ,
     4     4HDIFF,4HEREN , 4HSTIF,4HFNES , 4H    ,4H     ,  4 ,
     5     4HBUCK,4HLING , 4H    ,4H     , 4H    ,4H     ,  5 ,
     6     4HPIEC,4HEWIS , 4HLINE,4HAR   , 4H    ,4H     ,  6 ,
     7     4HDIRE,4HCT   , 4HCOMP,4HLEX  , 4HEIGE,4HNVAL ,  7 ,
     8     4HDIRE,4HCT   , 4HFREQ,4HUENC , 4HRESP,4HONSE ,  8 ,
     9     4HDIRE,4HCT   , 4HTRAN,4HSIEN , 4HRESP,4HONSE ,  9 ,
     O     4HMODA,4HL    , 4HCOMP,4HLEX  , 4HEIGE,4HNVAL , 10 /
      DATA SOLNM2 /
     1     4HMODA,4HL    , 4HFREQ,4HUENC , 4HRESP,4HONSE , 11 ,
     2     4HMODA,4HL    , 4HTRAN,4HSIEN , 4HRESP,4HONSE , 12 ,
     3     4HSTEA,4HDY   , 4HSTAT,4HE    , 4H    ,4H     ,  3 ,
     4     4HTRAN,4HSIEN , 4H    ,4H     , 4H    ,4H     ,  9 ,
     5     4HMODE,4HS    , 4H    ,4H     , 4H    ,4H     ,  3 ,
     6     4HREAL,4H     , 4HEIGE,4HNVAL , 4H    ,4H     ,  3 ,
     7     4HMODA,4HL    , 4HFLUT,4HTER  , 4HANAL,4HYSIS , 10 ,
     8     4HMODA,4HL    , 4HAERO,4HELAS , 4HRESP,4HONSE , 11 ,
     9     4HNORM,4HAL   , 4HMODE,4HS    , 4HANAL,4HYSIS , 13 ,
     O     4HSTAT,4HICS  , 4HCYCL,4HIC   , 4HSYMM,4HETRY , 14 /
      DATA SOLNM3 /
     1     4HMODE,4HS    , 4HCYCL,4HIC   , 4HSYMM,4HETRY , 15 ,
     2     4HSTAT,4HIC   , 4HAERO,4HTHER , 4HMOEL,4HASTI , 16 ,
     3     4HBLAD,4HE    , 4HCYCL,4HIC   , 4HMODA,4HL    ,  9 ,
     4     4HDYNA,4HMIC  , 4HDESI,4HGN A , 4HNALY,4HSIS  , 17 ,
     5     4HDIRE,4HCT   , 4HFORC,4HED V , 4HIBRA,4HTION , 18 ,
     6     4HMODA,4HAL   , 4HFORC,4HED V , 4HIBRA,4HTION , 19 ,
     7     4H****,4H**** , 4H****,4H**** , 4H****,4H**** ,  0 ,
     8     4H****,4H**** , 4H****,4H**** , 4H****,4H**** ,  0 ,
     9     4H****,4H**** , 4H****,4H**** , 4H****,4H**** ,  0 ,
     O     4H****,4H**** , 4H****,4H**** , 4H****,4H**** ,  0 ,
     1     4H****,4H**** , 4H****,4H**** , 4H****,4H**** ,  0 /
C
C     SET UP DATA IN COMMON
C
      ITOP   = 0
      IBOT   = 0
      LDIC   = 0
      NRLFL  = 0
      ISEQNO = 0
      ALTFIL = 301
      NEWALT = 0
      ALNOGO = 0
      ERRALT = 0
      NSCR   = 315
      IRESTR = 0
      NSUBST = 0
      NWPC   = 18
      DRECSZ = 0
C
C
C     INITIALIZE MACHINE DEPENDENT CONSTANTS
C
C     ALLON  = O777777777777  ALL BITS ON
C     ISIGN  = O400000000000  SIGN ON ONLY
C     MASK5  = O500000000000  SIGN AND NEXT BIT ON
C     ENDCD  = O377777777777  ALL BITS ON EXCEPT SIGN
C     MHIBYT = O770000000000  MASK IN HIGH ORDER BYTE
C
      ISIGN  = LSHIFT(1,NBPW-1)
      MASK5  = ORF(ISIGN,RSHIFT(ISIGN,1))
      ALLON  = COMPLF(0)
      MHIBYT = LSHIFT(ALLON,(NCPW-1)*NBPC)
      ENDCD  = RSHIFT(ALLON,1)
      J      = DIAGX(2)*5 - 1
      CARD(J  ) = XSYS(J)
      CARD(J+1) = KHRFN1(BNK,1,XSYS(J),2)
      CALL NA12IF (*1420,CARD(J),2,S7,1)
      IF (S7 .NE. 0) I7 = MACH*100
C
C     DETERMINE OPEN CORE SIZE AND ALLOCATE BUFFER AREA
C
      DMAPBS = KORSZ(GBUFF) - 2*IBUFSZ
      ALTRBS = DMAPBS + IBUFSZ
      CALL WALTIM (TIMEW)
      TIMEW = MOD(TIMEW,10000000)
C
C     LOAD PAGE HEADING IN /OUTPUT/
C
      J = 32
      DO 5 I = 1,J
      PGHDG1(I) = BLANK
      PGHDG2(I) = BLANK
      PGHDG3(I) = BLANK
      PGHDG4(I) = BLANK
      PGHDG5(I) = BLANK
      PGHDG6(I) = BLANK
    5 CONTINUE
      DO 10 I = 1,19
   10 PGHDG3(I+1) = HDG(I)
      CALL PAGE
C
C     CARD PREPARATION
C
      N7 = I7 + S7
      I7 = I7/100
      N7 = N7 - 2*I7
      M7 = CARD(LECTT+9)
      J  = IABS(M7)
      I  = 3
      IF (M7.LT.0 .AND. MOD(J,10).EQ.7) I = 4
      IF (J/10.EQ.N7 .AND. XSYS(17)-I.LE.S7) CARD(LECTT+2) = ICOLD
      CARD(LECTT+11) = KHRFN1(CARD(LECTT+11),2,XALT(1),3)
      CARD(LECTT+13) = KHRFN1(CARD(LECTT+13),1,NXCSA(1),1)
      CARD(LECTT+14) = KHRFN1(CARD(LECTT+14),2,IDISK,1)
C
C     WRITE DUMMY ID FILE ON PROBLEM TAPE IN CASE OF ID CONTROL CARD
C     ERROR.
C
      NOGO   = XNOGO
      XNOGO  = 0
      OLDALT = 0
C
C     READ CONTROL CARD AND PROCESS
C
   20 IF (ALTOPN .LE. 0) ASSIGN 70 TO IRTN1
   30 NLINES = NLINES + 1
      IF (NLINES .GE. NLPP) CALL PAGE
      IF (ZCOM .NE. 0) GO TO 40
      CALL XREAD (*1232,CARD)
C
C     ECHO CARD
C     (NOECHO IS SET BY SEMDBD AND READFILE OF FFREAD)
C
   40 ZCOM = 0
      IF (NOECHO .NE. 0) GO TO 52
      WRITE  (OUTTAP,50) CARD
   50 FORMAT (5X,20A4)
      GO TO 55
   52 NOECHO = NOECHO + 1
      NLINES = NLINES - 1
C
C     CHECK FOR COMMENT CARD
C
   55 IF (KHRFN1(BLANK,1,CARD(1),1) .EQ. DOLSIN) GO TO 30
C
C     CALL RMVEQ TO REPLACE ONE EQUAL SIGN BY ONE BLANK
C     IF CARD IS NOT WITHIN ALTER RANGE
C
CCCCC   NEXT LINE CAUSE ERROR IN READING RESTART DICTIONARY. POSITION
CCCCC   PROBLEM
CCCCC
CCCCC      IF (NOTALT .EQ. 0) CALL RMVEQ (CARD)
      CALL XRCARD (OUTCRD,200,CARD)
C
C     CHECK FOR ERROR DETECTED BY XRCARD
C
      IF (XNOGO .EQ. 0) GO TO 60
      IF (NOGO  .EQ. 0) NOGO = 1
      XNOGO = 0
      GO TO 30
C
C     CHECK FOR BLANK CARD
C
   60 IF (OUTCRD(1) .EQ. 0) GO TO 30
      GO TO IRTN1, (70,270,370,510)
   70 J = 0
      DO 80 I = 1,LECTT,3
      J = J + 1
      IF (OUTCRD(2).EQ.ECTT(I) .AND. OUTCRD(3).EQ.ECTT(I+1)) GO TO 90
   80 CONTINUE
      IF (OUTCRD(2) .EQ. IXDMAP) GO TO 400
      IF (IGNORE .EQ. 0) GO TO 690
      GO TO 20
C
C     HAS THIS TYPE CARD ALREADY BEEN PROCESSED
C
   90 IGNORE = 0
      IF (ECTT(I+2).LT.0 .AND. OUTCRD(2).EQ.ECTT(28)) ECTT(I+2) = 0
C                                               DIAG
      IF (ECTT(I+2)) 720,100,100
  100 ECTT(I+2) = ORF(ECTT(I+2),MASK5)
      GO TO (110, 120, 140, 210, 570, 330, 390, 400,1180, 480,
     1       460, 530, 560, 565, 555, 330, 330), J
C
C
C     NOW PROCESS TIME CARD
C
  110 IMHERE = 110
      IF (OUTCRD(4).NE.-1 .OR. OUTCRD(5).LE.0) GO TO 760
      TIME = OUTCRD(5)*60
      GO TO 20
C
C
C     NOW PROCESS APPROACH CARD
C
  120 DO 130 JJ = 1,NUMAPP
      APPRCH = JJ
      APPREC = JJ
      IF (OUTCRD(4) .EQ. APPTYP(JJ)) GO TO 132
  130 CONTINUE
      IMHERE = 130
      GO TO 760
C
C     CHECK FOR SUBSTRUCTURE ANALYSIS
C
  132 IF (OUTCRD(6) .NE. NSUBS) GO TO 20
      ISUBS = APPRCH
      IF (OUTCRD(8) .NE. -1) GO TO 20
      ISUBS = ISUBS + 10*OUTCRD(9)
      GO TO 20
C
C
C     NOW PROCESS CHKPNT CARD
C
  140 IF (OUTCRD(4).EQ.NO .OR. OUTCRD(6).EQ.NO) GO TO 20
C
C     CHECK FOR ILLEGAL FORMAT
C
      IMHERE = 140
      IF (OUTCRD(4).NE.IYES .AND. OUTCRD(6).NE.IYES) GO TO 750
      ICPFLG = 1
      IF (OUTCRD(6) .EQ. IDISK) GO TO 20
      ASSIGN 150 TO L
      IDFIST = PTAPE
C
C     CHECKPOINT FLAG IS ON,MAKE SURE NEW PROBLEM TAPE IS ON
C     PHYSICAL TAPE DRIVE
C
      GO TO 160
  150 IF (NOSTUP .NE. 0) GO TO 790
      GO TO 20
C
C     CHECK TAPE SETUP
C
  160 IF (TAPBIT(IDFIST)) GO TO 190
C
C     TAPE NOT SETUP
C
      NOSTUP = 1
      GO TO 200
  190 CONTINUE
C
C     TAPE SETUP
C
      NOSTUP = 0
C     GO TO L, (150,470)
  200 GO TO L, (150)
C
C
C     NOW PROCESS RESTART CARD
C
  210 NGINO  = OPTAPE
      IRESTR = 1
C
C     SET UNSORTED AND SORTED BULK DATA OUTPUT (ECHO = BOTH)
C     AS THE DEFAULT FOR RESTART RUNS
C
      IECHO = 3
      CALL OPEN (*850,OPTAPE,GBUFF(DMAPBS+1),0)
      CALL READ (*1350,*1350,OPTAPE,OTAPID,6,0,FLGWRD)
      CALL READ (*1350,*222,OPTAPE,TIMEX,1,1,FLGWRD)
      GO TO 225
  222 OUTCRD(21) = 0
      TIMEX = 0
C
C     COMPARE ID OF OLD PTAPE WITH THAT ON RSTART CARD
C
  225 RSTRT = 2
C
C     UNPACK DATE
C
      I     = LSHIFT(OTAPID(5),7)
      IYEAR = RSHIFT(ANDF(I,MASKHI),7)
      I     = RSHIFT(I,6)
      IDAY  = RSHIFT(ANDF(I,MASKHI),9)
      I     = RSHIFT(I,5)
      IMNTH = RSHIFT(ANDF(I,MASKHI),10)
      JJ    = OUTCRD(1)*2 - 2
      DO 230 JK = 1,JJ
      IF (OTAPID(JK) .NE. OUTCRD(JK+3)) GO TO 820
  230 CONTINUE
      IF (OUTCRD( 9).EQ.0 .AND. OUTCRD(14).EQ.0 .AND. OUTCRD(19) .EQ. 0)
     1    GO TO 235
      IF (IMNTH.NE.OUTCRD(9) .OR. IDAY.NE.OUTCRD(14) .OR.
     1    IYEAR.NE.OUTCRD(19)) GO TO 820
  235 CONTINUE
      IF (OUTCRD(21) .EQ. 0) TIMEX = 0
      IF (TIMEX .NE. OUTCRD(21)) GO TO 820
C
C     MAKE SURE CORRCET REEL IS MOUNTED
C
      IF (OTAPID(6) .EQ. 1) GO TO 240
      GO TO 820
C
C     GET OLD SOLUTION NUMBER
C
  240 CALL SKPFIL (OPTAPE,1)
      CALL READ  (*1350,*1350,OPTAPE,OSOLU,1,0,FLGWRD)
      IF (OSOLU(1) .EQ. XALT(1)  ) OLDALT = OLDALT + 1
      IF (OSOLU(1) .EQ. NXPTDC(1)) OLDALT = OLDALT + 1
      IF (OSOLU(1) .NE. NXCSA(1) ) GO TO 240
      CALL FWDREC (*1350,OPTAPE)
      CALL READ (*1350,*1350,OPTAPE,0,-4,0,FLGWRD)
      CALL READ (*1350,*1350,OPTAPE,OSOLU,2,1,FLGWRD)
      CALL SKPFIL (OPTAPE,1)
      CALL CLOSE  (OPTAPE,2)
C
C     LOAD PROBLEM TAPE DICTIONARY
C
      ICRDCT = 0
      ISEQNO = 0
      ITOP = DRECSZ + 1
      LDIC = KORSZ(IPTDIC(ITOP)) - IBUFSZ
      IBOT = ITOP - 3
C
C     ZERO FIRST PTDIC ENTRY IN CASE THERE ARE NO ENTRIES
C
      IPTDIC(ITOP  ) = 0
      IPTDIC(ITOP+1) = 0
      IPTDIC(ITOP+2) = 0
C
C     SET ITOPX SO THAT FIRST XVPS ENTRY IN PTDIC WILL BE PRESERVED
C
      ITOPX  = ITOP + 3
  260 ICRDCT = 1 + ICRDCT
C
C     READ IN NEXT CONTROL CARD
C
      ASSIGN 270 TO IRTN1
      GO TO 30
  270 IF (OUTCRD(1) .NE.     -1) GO TO 320
      IF (OUTCRD(2) .NE. ICRDCT) GO TO 1210
      IF (OUTCRD(3) .EQ.      5) GO TO 310
      IF (OUTCRD(3) .EQ.  ENDCD) GO TO 320
      IF (OUTCRD(3) .GT.      3) GO TO 310
C
C     CHECK FORMAT
C
      IMHERE = 275
      IF (OUTCRD(3).NE.3 .OR. OUTCRD(10).NE.-1 .OR. OUTCRD(12).NE.2 .OR.
     1    OUTCRD(17).NE.-1 .OR. OUTCRD(19).NE.2 .OR. OUTCRD(24).NE.-1)
     2    GO TO 760
C
C     PACK FLAGS/REEL/FILE
C
      FLAGS = 0
      IF (OUTCRD(11) .GE. 4) FLAGS = ISIGN
      REEL = ORF(LSHIFT(OUTCRD(18),16),OUTCRD(25))
C
C     SEE IF FILE IS ALREADY IN PTDIC - IF IT IS, PUT LATEST REEL/FILE
C     NO. IN EXISTING ENTRY
C
      IF (IBOT .LT. ITOPX) GO TO 290
      DO 280 K = ITOPX,IBOT,3
      IF (IPTDIC(K).EQ.OUTCRD(4) .AND. IPTDIC(K+1).EQ.OUTCRD(5))
     1    GO TO 300
  280 CONTINUE
C
C     FILE NOT IN PTDIC - MAKE NEW ENTRY
C
  290 IBOT = IBOT + 3
C
C     CHECK FOR OVERFLOW
C
      IF (IBOT+3-ITOP .GT. LDIC) GO TO 1260
      K = IBOT
      IPTDIC(K  ) = OUTCRD(4)
      IPTDIC(K+1) = OUTCRD(5)
  300 IPTDIC(K+2) = ORF(FLAGS,REEL)
      GO TO 260
C
C     THIS IS A REENTRY CARD - LOAD DMAP INSTRUCTION NO. IN ISEQNO
C
  310 IMHERE = 310
      IF (OUTCRD(4).NE.RENTER .OR. OUTCRD(14).NE.-1) GO TO 760
      ISEQNO = LSHIFT(OUTCRD(15),16)
      GO TO 260
C
C     DICTIONARY PROCESSED - COPY ONTO NEW PROBLEM TAPE.
C     THERE MUST ALWAYS BE AT LEAST ONE ENTRY IN PTDIC
C
  320 IF (IBOT .LT. ITOP) IBOT = ITOP
      NGINO = PTAPE
      IMHERE= 320
      CALL OPEN (*1320,PTAPE,GBUFF(DMAPBS+1),3)
C
C     RECORD 1 = ID
C
      CALL WRITE (PTAPE,NXPTDC,2,1)
C
C     RECORD 2 = CONTENTS OF IPTDIC
C
      CALL WRITE (PTAPE,IPTDIC(ITOP),IBOT+3-ITOP,1)
      CALL EOF   (PTAPE)
      CALL CLOSE (PTAPE,2)
      IF (OUTCRD(3) .EQ. ENDCD) GO TO 20
      GO TO 70
C
C
C     PROCESS ALTER CONTROL CARDS
C
  330 ASSIGN 370 TO IRTN1
      IF (ECTT(27) .LT. 0) GO TO 30
      NOTALT = 1
      IMHERE = 330
      NGINO = ALTFIL
      CALL OPEN (*1320,ALTFIL,GBUFF(ALTRBS+1),1)
      ALTOPN = 1
      IF (J .EQ. 16) GO TO 3605
      IF (J .EQ. 17) GO TO 3655
  340 IF (OUTCRD(6) .NE. ENDCD) GO TO 350
      OUTCRD(6) = INTGR
      OUTCRD(7) = 0
  350 IMHERE = 350
      IF (OUTCRD(4).NE.INTGR .OR. OUTCRD(6).NE.INTGR .OR. OUTCRD(5).LE.0
     1   .OR. OUTCRD(7).LT.0) GO TO 750
      IF (OUTCRD(7).GT.0 .AND. OUTCRD(8).NE.ENDCD) GO TO 750
C
C
      ALTER(1) = OUTCRD(5)
      ALTER(2) = OUTCRD(7)
C
C
C     WRITE ALTER PARAMETERS ONTO THE ALTER SCRATCH FILE
C     AND FOLLOW IT BY THE CARD IMAGE
C
      CALL WRITE (ALTFIL, ALTER,  2, 1)
      CALL WRITE (ALTFIL, CARD , 18, 1)
C
C     READ NEXT CARD INTO CORE
C
      GO TO 30
C
C     PROCESS INSERT CONTROL CARDS HERE
C
 3605 INSERT(1) = OUTCRD(4)
      INSERT(2) = OUTCRD(5)
      INSERT(3) = 1
      INSERT(4) = 0
      IF (OUTCRD(6) .EQ. ALLON .AND. OUTCRD(7) .EQ. ILEFT .AND.
     *    OUTCRD(8) .EQ. INTGR) GO TO 3610
      JN = 7
      IF (OUTCRD(6) .EQ. INTGR) GO TO 3615
      IF (OUTCRD(6) .EQ. ENDCD) GO TO 3620
      GO TO 750
 3610 IF (OUTCRD(9) .LE. 0) GO TO 750
      INSERT(3) = OUTCRD(9)
      JN = 11
      IF (OUTCRD(10) .EQ. INTGR) GO TO 3615
      IF (OUTCRD(10) .EQ. ENDCD) GO TO 3620
      GO TO 750
 3615 INSERT(4) = OUTCRD(JN)
      IF (OUTCRD(JN+1) .NE. ENDCD) GO TO 750
C
C     WRITE INSERT PARAMETERS ONTO THE ALTER SCRATCH FILE
C     AND FOLLOW IT BY THE CARD IMAGE
C
 3620 CALL WRITE (ALTFIL, INSERT,  4, 1)
      CALL WRITE (ALTFIL, CARD  , 18, 1)
      NEWALT = 1
      GO TO 30
C
C     PROCESS DELETE CONTROL CARDS HERE
C
 3655 DELETE(1) = OUTCRD(4)
      DELETE(2) = OUTCRD(5)
      DELETE(3) = 1
      DELETE(4) = 0
      DELETE(5) = 0
      IF (OUTCRD(6) .EQ. ALLON .AND. OUTCRD(7) .EQ. ILEFT .AND.
     *    OUTCRD(8) .EQ. INTGR) GO TO 3660
      JN = 7
      JNX = 7
      IF (OUTCRD(6) .EQ. INTGR) GO TO 3665
      IF (OUTCRD(6) .EQ. ENDCD) GO TO 3670
      JNX = 6
      GO TO 3675
 3660 IF (OUTCRD(9) .LE. 0) GO TO 750
      DELETE(3) = OUTCRD(9)
      JN = 11
      JNX = 11
      IF (OUTCRD(10) .EQ. INTGR) GO TO 3665
      IF (OUTCRD(10) .EQ. ENDCD) GO TO 3670
      IF (OUTCRD(10) .GT.     0) GO TO 3675
      GO TO 750
 3665 DELETE(4) = OUTCRD(JN)
      JN = JN + 1
      JNX = JN + 1
      IF (OUTCRD(JN) .EQ. ENDCD) GO TO 3670
      IF (OUTCRD(JN) .GT.     0) GO TO 3675
      GO TO 750
C
C     WRITE DELETE PARAMETERS ONTO THE ALTER SCRATCH FILE
C     AND FOLLOW IT BY THE CARD IMAGE
C
 3670 CALL WRITE (ALTFIL, DELETE,  5, 1)
      CALL WRITE (ALTFIL, CARD  , 18, 1)
      NEWALT = 1
      GO TO 30
C
 3675 JN = JNX
      DELETE(5) = 1
      DELETE(6) = OUTCRD(JN  )
      DELETE(7) = OUTCRD(JN+1)
      DELETE(8) = 1
      DELETE(9) = 0
      JN = JN + 2
      JNX = JN + 3
      IF (OUTCRD(JN  ) .EQ. ALLON .AND. OUTCRD(JN+1) .EQ. ILEFT .AND.
     *    OUTCRD(JN+2) .EQ. INTGR) GO TO 3680
      JNX = JN + 1
      IF (OUTCRD(JN) .EQ. INTGR) GO TO 3685
      IF (OUTCRD(JN) .EQ. ENDCD) GO TO 3690
      GO TO 750
 3680 JN = JNX
      IF (OUTCRD(JN) .LE. 0) GO TO 750
      DELETE(8) = OUTCRD(JN)
      JN = JN + 1
      JNX = JN + 1
      IF (OUTCRD(JN) .EQ. INTGR) GO TO 3685
      IF (OUTCRD(JN) .EQ. ENDCD) GO TO 3690
      GO TO 750
 3685 DELETE(9) = OUTCRD(JNX)
      IF (OUTCRD(JNX+1) .NE. ENDCD) GO TO 750
C
C     WRITE DELETE PARAMETERS ONTO THE ALTER SCRATCH FILE
C     AND FOLLOW IT BY THE CARD IMAGE
C
 3690 CALL WRITE (ALTFIL, DELETE,  9, 1)
      CALL WRITE (ALTFIL, CARD  , 18, 1)
      NEWALT = 1
      GO TO 30
  370 CONTINUE
C
C     CHECK FOR CEND CARD TO PREVENT STREAMING THRU BULK DATA
C
      IF (OUTCRD(2).EQ.CEND(1) .AND. OUTCRD(3).EQ.CEND(2)) GO TO 910
C
C     CHECK FOR ANOTHER ALTER CARD
C
      IF (OUTCRD(2).EQ.BGNAL(1) .AND. OUTCRD(3).EQ.BGNAL(2)) GO TO 340
C
C     CHECK FOR ANOTHER INSERT CARD
C
      IF (OUTCRD(2).EQ.ECTT(46) .AND. OUTCRD(3).EQ.ECTT(47))
     *   GO TO 3605
C
C     CHECK FOR ANOTHER DELETE CARD
C
      IF (OUTCRD(2).EQ.ECTT(49) .AND. OUTCRD(3).EQ.ECTT(50))
     *   GO TO 3655
C
C     CHECK FOR ENDALTER CARD
C
      IF (OUTCRD(2).NE.ENDAL(1) .OR.  OUTCRD(3).NE.ENDAL(2)) GO TO 380
C
C     ENDALTER ENCOUNTERED
C
      IF (ECTT(27) .LT. 0) GO TO 720
      ECTT(27) = ORF (ECTT(27), MASK5)
      CALL EOF (ALTFIL)
      CALL CLOSE (ALTFIL,2)
      ALTOPN = -1
      NOTALT = 0
      GO TO 20
C
C
C
C     WRITE DMAP INSTRUCTION ON THE ALTER SCRATCH FILE
C
  380 IF (ECTT(27) .LT. 0) GO TO 30
      CALL WRITE (ALTFIL, CARD, 18, 1)
      GO TO 30
C
C
C     NOW PROCESS SOL CONTROL CARD
C
  390 SOLUF = 1
C
C     =====================================
C     ECTT(I+2) = 0
C     DO 2000 JJ = 1,12
C2000 SOLU(JJ) = 0
C     WRITE  (6,2001)
C2001 FORMAT (16H0+++ OUTCARD +++)
C     JJ = 1
C2002 WRITE  (6,2003) JJ,OUTCRD(JJ)
C2003 FORMAT (20X,I5,5X,O20)
C     IF (OUTCRD(JJ) .EQ. ENDCD) GO TO 2004
C     JJ = JJ + 1
C     GO TO 2002
C2004 CONTINUE
C     =====================================
C
      IF (OUTCRD(1) .EQ. 1) GO TO 395
C
      DO 391 JJ = 1,6
  391 SOLNMX(JJ) = BLANK
      JK = 2*OUTCRD(1) + 3
      SOLNMX(1) = OUTCRD(4)
      SOLNMX(2) = OUTCRD(5)
      IF (OUTCRD(1).EQ.2 .OR. OUTCRD(7).EQ.BLANK) GO TO 392
      SOLNMX(3) = OUTCRD(6)
      SOLNMX(4) = OUTCRD(7)
      IF (OUTCRD(1).EQ.3 .OR. OUTCRD(9).EQ.BLANK) GO TO 392
      SOLNMX(5) = OUTCRD(8)
      SOLNMX(6) = OUTCRD(9)
  392 DO 394 JJ = 1,NSOLNM
      DO 393 K  = 1,6
      IF (SOLNMX(K) .NE. SOLNMS(K,JJ)) GO TO 394
  393 CONTINUE
      SOLU(1) = SOLNMS(7,JJ)
      GO TO 396
  394 CONTINUE
      IUFILE(1) = OUTCRD(4)
      IUFILE(2) = OUTCRD(5)
      SOLU(1)   = 0
      GO TO 396
C
  395 IMHERE = 395
      IF (OUTCRD(4) .NE. -1) GO TO 750
      JK = 7
      SOLU(1) = OUTCRD(5)
      IF (OUTCRD(6) .EQ. 1) JK = JK + 3
      IF (OUTCRD(6) .EQ. 2) JK = JK + 5
C
  396 CONTINUE
      RFFLAG = SOLU(1)
      IF (OUTCRD(JK-1) .EQ. ENDCD) GO TO 399
      IMHERE = 397
      JJ = 1
  397 JJ = JJ + 1
      IF (JJ .GT. 12) GO TO 750
      IF (OUTCRD(JK-1) .NE. -1) GO TO 750
      NSUBST = JJ
      SOLU(JJ) = OUTCRD(JK)
      IF (OUTCRD(JK+1) .EQ. ENDCD) GO TO 399
      JK = JK + 2
      GO TO 397
  399 CONTINUE
C
C     ===========================================
C2005 FORMAT (1H0,100(1H+)/1H0/1H0)
C     WRITE  (6,2006)
C2006 FORMAT (13H0+++ SOLU +++)
C     JJ = 1
C2007 IF (SOLU(JJ).EQ.0 .AND. JJ.GT.2) GO TO 2009
C     WRITE  (6,2008) JJ,SOLU(JJ)
C2008 FORMAT (20X,I5,5X,I10)
C     JJ = JJ + 1
C     GO TO 2007
C2009 CONTINUE
C     WRITE (6,2005)
C     ===========================================
C
      GO TO 20
C
C
C     B E G I N  CONTROL CARD
C     PROCESS DMAP SEQUENCE
C
  400 JJ = 0
      WRITE  (OUTTAP,410)
  410 FORMAT (5X,'(SEE NASTRAN SOURCE PROGRAM COMPILATION FOR LISTING ',
     1        'OF DMAP SEQUENCE)')
      DO 420 JK = 1,NWPC
      JJ = JJ + 1
  420 DMAPBF(JJ) = CARD(JK)
  430 CALL XREAD (*1232,CARD)
      DO 440 JK = 1,NWPC
      JJ = JJ + 1
      DMAPBF(JJ) = CARD(JK)
  440 CONTINUE
      IF (JJ .GT. DMAPBS) GO TO 1290
C
C     CHECK FOR END OR CEND CARD
C
      CALL XRCARD (OUTCRD,200,CARD)
C
C     CHECK FOR ERROR DETECTED BY XRCARD
C
      IF (XNOGO .EQ. 0) GO TO 450
      WRITE (OUTTAP,50) CARD
      IF (NOGO  .EQ. 0) NOGO = 1
      XNOGO = 0
      GO TO 430
  450 IF (OUTCRD(2).EQ.CEND(1) .AND. OUTCRD(3).EQ.CEND(2)) GO TO 940
      IF (OUTCRD(2) .NE. DMEND) GO TO 430
      WRITE (OUTTAP,50) CARD
      DRECSZ = JJ
      GO TO 20
C
C
C     NOW PROCESS UMF CARD
C     CHECK FORMAT
C
  460 WRITE  (OUTTAP,465) UWM,ECTT(I),ECTT(I+1)
  465 FORMAT (A25,', ',2A4,' CARD IS NO LONGER AVAILABLE')
      GO TO 20
C
C 460 IMHERE = 460
C     IF (OUTCRD(4).NE.INTGR .OR. OUTCRD(6).NE.INTGR .OR.
C    1    OUTCRD(5).LE.    0 .OR. OUTCRD(7).LT.   0) GO TO 750
C
C     SET UNSORTED AND SORTED BULK DATA OUTPUT (ECHO = BOTH)
C     AS THE DEFAULT FOR RUNS USING THE UMF
C
C     IECHO = 3
C
C     MAKE SURE UMF TAPE IS SETUP
C
C     ASSIGN 470 TO L
C     IDFIST = NUMF
C     GO TO 160
C 470 IF (NOSTUP .NE. 0) GO TO 970
C
C     MAKE SURE CORRECT UMF TAPE IS MOUNTED
C
C     NGINO = NUMF
C     IMHERE= 470
C     CALL OPEN  (*1320,NUMF,GBUFF(DMAPBS+1),0)
C     CALL READ  (*1350,*1350,NUMF,UMFID,1,0,FLGWRD)
C     CALL SKPFIL (NUMF,1)
C     CALL CLOSE (NUMF,2)
C     IF (UMFID .NE. OUTCRD(5)) GO TO 1000
C     UMFID = OUTCRD(7)
C     GO TO 20
C
C
C     PROCESS DIAG CARD
C     ALLOW MULTIPLE DIAG CARDS TO BE PROCESSED.
C
  480 CONTINUE
      I = 2
  490 I = I + 2
      IF (OUTCRD(I) .EQ.     0) GO TO 505
      IF (OUTCRD(I) .NE. INTGR) GO TO 520
C
C     SET SENSE SWITCH BITS. (DIAG 1 THRU 48, BIT COUNTS 0 THRU 47)
C     BITS 49 THRU 63 ARE RESERVED FOR LINK NO.  (-1 THRU -15)
C
      JJ = OUTCRD(I+1)
CWKBD IF (JJ .GT. 63-MAXLNK) GO TO 503
CWKBD IF (JJ.GE.-MAXLNK .AND. JJ.LE.-1) JJ = 63 - MAXLNK - JJ
      IF (JJ .GT. 31) GO TO 500
      SWITCH(1) = ORF(LSHIFT(1,JJ-1),SWITCH(1))
C
C     TURN ON DIAG 14 IF DIAG 25 HAS BEEN REQUESTED
C
      IF (JJ .EQ. 25) SWITCH(1) = ORF(LSHIFT(1,13),SWITCH(1))
      GO TO 503
  500 IF (JJ.EQ.42 .AND. MACH.GT.5) WRITE (OUTTAP,501) UWM,MCHNAM
  501 FORMAT (A25,', DIAG 42 IS UNSUPPORTED IN ALL UNIX MACHINES, ',
     1        'INCLUDING ',A6,' ***')
      JJ = JJ - 31
      SWITCH(2) = ORF(LSHIFT(1,JJ-1),SWITCH(2))
  503 CONTINUE
      GO TO 490
C
C     DIAG CONTINUED ON NEXT CARD - READ IN NEXT CARD
C
  505 ASSIGN 510 TO IRTN1
      GO TO 30
  510 IF (OUTCRD(2).EQ.CEND(1) .AND. OUTCRD(3).EQ.CEND(2)) GO TO 570
      I = -1
      GO TO 490
C
C     SHOULD BE END OF LOGICAL DIAG CARD
C
  520 IMHERE = 520
      IF (OUTCRD(I) .NE. ENDCD) GO TO 750
CIBMDB 5/95      
C      SWITCH(3) = ORF(SWITCH(3),SWITCH(1))
C      SWITCH(1) = 0
C      CALL PRESSW (LINKS(1),I)
C
C     RE-ACTIVATE THOSE LINK1 SPECIAL DIAGS IN DIAGX LIST IF NECESSARY
C
C      IF (SWITCH(1) .EQ. SWITCH(3)) GO TO 527
C      DO 525 I = 1,11
C      JJ = DIAGX(I) - 1
C      SWITCH(1) = ORF(ANDF(LSHIFT(1,JJ),SWITCH(3)),SWITCH(1))
C  525 CONTINUE
C      IF (SWITCH(1) .NE. SWITCH(3)) CALL PRESSW (RENTER,I)
CIBMDE 5/95  
  527 CALL SSWTCH (15,L15)
      CALL SSWTCH (8 ,L 8)
      CALL SSWTCH (13,L13)
      GO TO 20
C
C
C     NOW PROCESS ID CARD
C     CHECK FORMAT - MUST BE AT LEAST 3 BCD FIELDS
C
  530 IMHERE = 530
      IF (OUTCRD(1) .LT. 3) GO TO 750
C
C     MAKE SURE ID CARD IS FIRST CONTROL CARD
C     IF ID CARD WAS IN ERROR CONTROL WILL STILL RETURN TO HERE
C
  531 DO 540 I = 1,LECTT,3
      IF (ECTT(I+2).LT.0 .AND. ECTT(I).NE.ID) GO TO 1060
  540 CONTINUE
      IF (LOGFL .LE. 0) CALL LOGFIL (CARD)
      DO 550 JJ = 1,4
  550 TAPID(JJ) = OUTCRD(JJ+3)
C
C      PACK DATE -
C
      IMNTH = LSHIFT(IDATE(1),14)
      IDAY  = LSHIFT(IDATE(2),8)
      IYEAR = IDATE(3)
      TAPID(5) = ORF(IMNTH,ORF(IDAY,IYEAR))
C
C     REEL NO. TO TAPID
C
      TAPID(6) = 1
C
C     OUTPUT IF ON NEW PROBLEM TAPE
C
      NGINO = PTAPE
      CALL OPEN  (*1320,PTAPE,GBUFF(DMAPBS+1),1)
      CALL WRITE (PTAPE,TAPID,6,0)
      CALL WRITE (PTAPE,TIMEW,1,1)
      CALL EOF   (PTAPE)
      CALL CLOSE (PTAPE,2)
      GO TO 20
C
C
C     PROCESS INTERACTIVE CARD
C     SET INTRA TO NEGATIVE IN BATCH RUN (I.E. PRE-INTERACTIVE RUN)
C     INTRA WILL BE RESET TO POSITIVE IN AN ON-LINE INTERACTIVE RUN
C
C     CHECK FORMAT AND FILE ASSIGNMENT
C
  555 INTRA = 0
      DO 557 JJ = 4,9
      IF (OUTCRD(JJ) .EQ. PLOT) INTRA = ORF(INTRA,1)
      IF (OUTCRD(JJ) .EQ. PRNT) INTRA = ORF(INTRA,2)
      IF (OUTCRD(JJ) .EQ. BOTH) INTRA = ORF(INTRA,3)
  557 CONTINUE
      IF (INTRA .EQ. 0) GO TO 700
      INTRA = -INTRA
      JJ = 1
      IF (MACH .EQ. 3) CALL FACIL (INP9,JJ)
      IF (JJ   .EQ. 2) GO TO 1250
      GO TO 20
C
C
C     UMFEDIT CARD FOUND - SET EDTUMF FLAG
C
  560 WRITE (OUTTAP,465) UWM,ECTT(I),ECTT(I+1)
C     EDTUMF = 1
      GO TO 20
C
C
C     PROCESS PREC CARD
C
  565 IMHERE = 565
      IF (OUTCRD(5).NE.1 .AND. OUTCRD(5).NE.2) GO TO 750
      PREC = OUTCRD(5)
      GO TO 20
C
C     CEND CARD FOUND - NO MORE CONTROL CARDS TO PROCESS
C
C
C     SET APP DEFAULT TO 'DISPLACEMENT' AND TIME TO 10 MINUTES
C
  570 IF (APPRCH .NE. 0) GO TO 572
      APPRCH  = 2
      APPREC  = 2
      WRITE  (OUTTAP,571)
  571 FORMAT ('0*** APP  DECLARATION CARD MISSING.  DISPLACEMENT IS ',
     1        'SELECTED BY DEFAULT')
  572 IF (TIME .GT. 0) GO TO 575
      TIME = 300
      WRITE  (OUTTAP,573)
  573 FORMAT ('0*** TIME  CARD MISSING. MAXIMUM EXECUTION TIME IS SET ',
     1        'TO 5 MINUTES BY DEFAULT')
C
C     CALL NSINFO TO PRINT DIAG48, OR
C     PRINT THE FOLLOWING MESSAGE OUT ONLY IF THE JOB IS RUN ON THE SAME
C     YEAR OF THE RELEASE DATE, AND USER DOES NOT MAKE A DIAG48 REQUEST
C
C     DIAG48 TEXT IS STORED IN 4TH SECTION OF THE NASINFO FILE
C
C
  575 CALL SSWTCH (48,JJ)
      IF (JJ .NE. 1) GO TO 576
      CALL NSINFO (4)
      GO TO 580
  576 JJ = IDATE(3)
      JJ = MOD(JJ,100)
      CALL INT2A8 (*577,JJ,IZ(1))
  577 IF (IZ(1) .EQ. SY42(3)) WRITE (OUTTAP,578) UIM
  578 FORMAT (//,A29,', TURN DIAG 48 ON FOR NASTRAN RELEASE NEWS, ',
     1       'DIAG DEFINITION, NEW DMAP', /9X,
     2       'MODULES AND NEW BULKDATA CARDS INFORMATION')
C
C     CLOSE NASINFO FILE IF IT EXISTS
C     AND RESET THE 37TH WORD OF /SYSTEM/ BACK TO ZERO
C
  580 IF (LU .NE. 0) CLOSE (UNIT=LU)
      LU = 0
C
C     NOW MAKE SURE ALL NECESSARY CARDS HAVE BEEN FOUND
C
      DO 590 I = 1,LECTT,3
      TEST = ANDF(ECTT(I+2),MASK)
      IF (TEST .GT. 0) IF (ECTT(I+2)) 590,1090,1090
  590 CONTINUE
C
C     SET APPRCH NEGATIVE FOR RESTART
C
      IF (RSTRT .NE. ICOLD) APPRCH = -APPRCH
      IF (SOLUF.EQ.1 .AND. DRECSZ.NE.0) GO TO 1120
      IF (SOLUF.EQ.0 .AND. DRECSZ.EQ.0) GO TO 1150
C     IF (RSTRT.NE.ICOLD .AND. UMFID.NE.0) GO TO 1030
C
C
  600 IF (NOGO .GT. 1) GO TO 1380
C
C     WRITE XCSA CONTROL FILE ONTO PROBLEM TAPE
C     FIRST RECORD IS HEADER RECORD CONTAINING A SINGLE WORD (XCSA)
C
      IF (APPREC .EQ. APPDMP) GO TO 610
C
C     IF APPROACH IS HEAT ADD TWENTY THREE TO SOLUTION
C
      IF (APPREC .EQ. APPHEA) SOLU(1) = SOLU(1) + 23
C
C     IF APPROACH IS AEROELASTIC ADD THIRTY TO SOLUTION
C
      IF (APPREC .EQ. APPAER) SOLU(1) = SOLU(1) + 30
      GO TO 612
  610 NGINO = PTAPE
      IMHERE= 610
      CALL OPEN  (*1320,PTAPE,GBUFF(DMAPBS+1),3)
      CALL WRITE (PTAPE,NXCSA,2,1)
C
C     DIS OLD PT HAVE AN ALTER FILE AND/OR CKPT DIST
C
      SOLREC(4) = OLDALT
C
C     WRITE SIX-WORD CONTROL FILE RECORD
C
      CALL WRITE (PTAPE,SOLREC,6,1)
      CALL EOF   (PTAPE)
      CALL CLOSE (PTAPE, 3)
      IF (APPREC .NE. APPDMP) GO TO 640
  612 NGINO = NSCR
      IMHERE= 612
      CALL OPEN (*1320,NSCR,GBUFF(DMAPBS+1),1)
      IF (APPREC .EQ. APPDMP) GO TO 620
C
C     APPROACH IS RIGID FORMAT
C     WRITE RIGID FORMAT AND MED TABLES ONTO SCRATCH FILE
C
      ISIZE = KORSZ (DMAPBF(1)) - IBUFSZ
      IF (ALTOPN .EQ. 0) GO TO 614
      IF (ERRALT .EQ. 0) GO TO 613
      NEWALT = 0
  613 IF (NEWALT .EQ. 0) GO TO 614
      ISIZE = ISIZE - IBUFSZ
      NGINO = ALTFIL
      CALL OPEN (*1320, ALTFIL, GBUFF(ALTRBS+1), 3)
  614 CALL XRGDFM (SOLU,OSOLU,APPREC,IUFILE,DMAPBF,ISIZE,NSCR,NOGO)
      IF (XNOGO .EQ. 0) GO TO 615
      IF (NOGO  .EQ. 0) NOGO = 1
      XNOGO = 0
  615 CONTINUE
      IF (NOGO .GT. 1) GO TO 1380
      CALL CLOSE (NSCR, 1)
      SOLREC(3) = 0
      IF (ALTOPN .EQ. 0) GO TO 610
      IF (ERRALT .EQ. 1) GO TO 610
      SOLREC(3) = 1
      NGINO = PTAPE
      CALL OPEN (*1320, PTAPE,  GBUFF(DMAPBS+1), 3)
      NGINO = ALTFIL
      CALL OPEN (*1320, ALTFIL, GBUFF(ALTRBS+1), 0)
      CALL DMPALT (ISIZE, DMAPBF, PTAPE)
      CALL EOF (PTAPE)
      CALL CLOSE (PTAPE,  2)
      CALL CLOSE (ALTFIL, 1)
      IF (ALNOGO .EQ. 0) GO TO 610
      IF (NOGO .LT. 2) NOGO = 2
      GO TO 610
C
C     APPROACH IS DMAP
C     WRITE DMAP SEQUENCE ONTO SCRATCH FILE FROM OPEN CORE
C
  620 CALL WRITE (NSCR,DMAPBF,DRECSZ,1)
  630 CALL CLOSE (NSCR,1)
  640 CONTINUE
C
C     PUNCH RESTART CARD IF CHECKPOINT FLAG IS SET.
C
      IF (ICPFLG .EQ. 0) GO TO 660
C      IF (IROPEN .EQ. 1) GO TO 6405
C      OPEN (UNIT=4, FILE=DSNAMES(4), STATUS='UNKNOWN')
C      IROPEN = 1
      WRITE (IRDICT,641) (TAPID(I),I=1,4),(IDATE(J),J=1,3),TIMEW
  641 FORMAT (9HRESTART  ,2A4,1H,,2A4,1H,,I2,1H/,I2,1H/,I2,1H,,I8,1H,)
      CALL SSWTCH (9,DIAG09)
      IF (DIAG09 .EQ. 1) GO TO 660
      CALL PAGE
      WRITE  (OUTTAP,651) (TAPID(I),I=1,4),(IDATE(J),J=1,3),TIMEW
  651 FORMAT ('0ECHO OF FIRST CARD IN CHECKPOINT DICTIONARY TO BE ',
     1        'PUNCHED OUT FOR THIS PROBLEM', /
     2 14H0   RESTART   ,2A4,1H,,2A4,1H,,I2,1H/,I2,1H/,I2,1H,,I8,1H,)
  660 XNOGO = NOGO
      RETURN
C
C     ERROR MESSAGES
C
C     USER  FATAL MESSAGES
C
  670 NLINES = NLINES + 2
      IF (NLINES .GE. NLPP) CALL PAGE
      IF (NOGO   .LT.    1) NOGO = 1
      IGNORE = 1
      GO TO IRTN2, ( 700, 730, 770, 800, 830, 860,      920, 950,
     1              1070,1100,1130,1160,1190,1220,1234)
C
  690 ASSIGN 700 TO IRTN2
      MSGNUM = 505
      GO TO 670
  700 WRITE  (OUTTAP,710) UFM,MSGNUM,OUTCRD(2),OUTCRD(3)
  710 FORMAT (A23,I5,', CONTROL CARD ',2A4,11H IS ILLEGAL)
      GO TO 20
C
  720 ASSIGN 730 TO IRTN2
      MSGNUM = 506
      GO TO 670
  730 WRITE  (OUTTAP,740) UFM,MSGNUM,OUTCRD(2),OUTCRD(3)
  740 FORMAT (A23,I5,', CONTROL CARD ',2A4,11H DUPLICATED)
      GO TO 20
C
  750 CONTINUE
      ERRALT = 1
  760 ASSIGN 770 TO IRTN2
      MSGNUM = 507
      GO TO 670
  770 WRITE  (OUTTAP,780) UFM,MSGNUM,IMHERE
  780 FORMAT (A23,I5,', ILLEGAL SPECIFICATION OR FORMAT ON PRECEDING ',
     1       'CARD.', /5X,'IMHERE =',I5)
      IF (OUTCRD(2).EQ.ECTT(34) .AND. OUTCRD(3).EQ.ECTT(35)) GO TO 531
      GO TO 20
C
  790 ASSIGN 800 TO IRTN2
      MSGNUM = 508
      GO TO 670
  800 WRITE  (OUTTAP,810) UFM,MSGNUM
  810 FORMAT (A23,I5,', PROBLEM TAPE MUST BE ON PHYSICAL TAPE FOR ',
     1      'CHECK POINTING')
      IGNORE = 0
      ICPFLG = 0
      GO TO 20
C
  820 ASSIGN 830 TO IRTN2
      MSGNUM = 509
      GO TO 670
  830 WRITE  (OUTTAP,840) UFM,MSGNUM,(OTAPID(I),I=1,4),IMNTH,IDAY,
     1                    IYEAR,TIMEX,OTAPID(6)
  840 FORMAT (A23,I5,', WRONG OLD TAPE MOUNTED.', /30X,
     1        23H OLD PROBLEM TAPE ID = ,2A4,1H,,2A4,1H,,I2,1H/,I2,1H/,
     2        I2,1H,,2X,I8,1H,,5X,10HREEL NO. =,I4)
      GO TO 1410
C
  850 ASSIGN 860 TO IRTN2
      MSGNUM = 512
      GO TO 670
  860 WRITE  (OUTTAP,870) UFM,MSGNUM
  870 FORMAT (A23,I5,', OLD PROBLEM TAPE IS MISSING AND IS NEEDED FOR ',
     1       'RESTART')
      NOGO = 3
      GO TO 20
C
C
  910 ASSIGN 920 TO IRTN2
      MSGNUM = 514
      GO TO 670
  920 WRITE  (OUTTAP,930) UFM,MSGNUM
  930 FORMAT (A23,I5,', ENDALTER CARD IS MISSING')
      IF (NOGO .LT. 2) NOGO = 2
      GO TO 570
C
  940 ASSIGN 950 TO IRTN2
      MSGNUM = 515
      GO TO 670
  950 WRITE  (OUTTAP,960) UFM,MSGNUM
  960 FORMAT (A23,I5,', END INSTRUCTION MISSING IN DMAP SEQUENCE')
      IF (NOGO .LT. 2) NOGO = 2
      GO TO 570
C
C 970 ASSIGN 980 TO IRTN2
C     MSGNUM = 516
C     GO TO 670
C 980 WRITE  (OUTTAP,990) UFM,MSGNUM
C 990 FORMAT (A23,I5,', UMF TAPE MUST BE MOUNTED ON PHYSICAL TAPE ',
C    1       'DRIVE')
C     NOGO = 3
C     GO TO 20
C
C1000 ASSIGN 1010 TO IRTN2
C     MSGNUM = 517
C     GO TO 670
C1010 WRITE  (OUTTAP,1020) UFM,MSGNUM,UMFID
C1020 FORMAT (A23,I5,', WRONG UMF TAPE MOUNTED - TAPE ID =',I10)
C     NOGO = 3
C     GO TO 20
C
C1030 ASSIGN 1040 TO IRTN2
C     MSGNUM = 518
C     GO TO 670
C1040 WRITE  (OUTTAP,1050) UFM,MSGNUM
C1050 FORMAT (A23,I5,', CANNOT USE UMF TAPE FOR RESTART')
C     NOGO = 3
C     GO TO 1380
C
 1060 ASSIGN 1070 TO IRTN2
      MSGNUM = 519
      GO TO 670
 1070 WRITE  (OUTTAP,1080) UFM,MSGNUM
 1080 FORMAT (A23,I5,', ID CARD MUST PRECEDE ALL OTHER CONTROL CARDS')
      NOGO = 3
      GO TO 20
C
 1090 ASSIGN 1100 TO IRTN2
      MSGNUM = 520
      GO TO 670
 1100 WRITE  (OUTTAP,1110) UFM,MSGNUM,ECTT(I),ECTT(I+1)
 1110 FORMAT (A23,I5,', CONTROL CARD ',2A4,' IS MISSING')
      ECTT(I+2) = ORF(ECTT(I+2),MASK5)
      IF (ECTT(I) .NE. ECTT(4)) GO TO 570
C
C     MISSING CARD IS APP
C
      IF (NOGO .LT. 2) NOGO = 2
      GO TO 570
C
 1120 ASSIGN 1130 TO IRTN2
      MSGNUM = 521
      GO TO 670
 1130 WRITE  (OUTTAP,1140) UFM,MSGNUM
 1140 FORMAT (A23,I5,', SPECIFY A SOLUTION OR A DMAP SEQUENCE BUT NOT ',
     1      'BOTH')
      IF (NOGO .LT. 2) NOGO = 2
      GO TO 1380
C
 1150 ASSIGN 1160 TO IRTN2
      MSGNUM = 522
      GO TO 670
 1160 WRITE  (OUTTAP,1170) UFM,MSGNUM
 1170 FORMAT (A23,I5,', NEITHER A SOL CARD NOR A DMAP SEQUENCE WAS ',
     1       'INCLUDED')
      IF (NOGO .LT. 2) NOGO = 2
      GO TO 1380
C
 1180 ASSIGN 1190 TO IRTN2
      NOTALT = 0
      MSGNUM = 523
      GO TO 670
 1190 WRITE  (OUTTAP,1200) UFM,MSGNUM
 1200 FORMAT (A23,I5,', ENDALTER CARD OUT OF ORDER')
      GO TO 20
C
 1210 ASSIGN 1220 TO IRTN2
      MSGNUM = 526
      GO TO 670
 1220 WRITE  (OUTTAP,1230) UFM,MSGNUM
 1230 FORMAT (A23,I5,', CHECKPOINT DICTIONARY OUT OF SEQUENCE - ',
     1       'REMAINING RESTART CARDS IGNORED')
      GO TO 20
 1232 ASSIGN 1234 TO IRTN2
      MSGNUM = 529
      GO TO 670
 1234 WRITE  (OUTTAP,1236) UFM,MSGNUM
 1236 FORMAT (A23,I5,', MISSING CEND CARD.')
      NOGO = 3
      GO TO 1380
C
C     SYSTEM FATAL MESSAGES
C
 1240 NLINES = NLINES +2
      IF (NLINES .GE. NLPP) CALL PAGE
      IF (NOGO   .LT.    2) NOGO = 2
      IGNORE = 1
      GO TO IRTN3, (1255,1270,1300,1330,1360)
C
 1250 ASSIGN 1255 TO IRTN3
      MSGNUM = 530
      GO TO 1240
 1255 WRITE  (OUTTAP,1256) SFM,MSGNUM
 1256 FORMAT (A25,I5,2H, , /5X,'INP9 FILE WAS NOT ASSIGNED FOR ',
     1       'NASTRAN INTERACTIVE POST-PROCESSOR',/)
      GO TO 20
 1260 ASSIGN 1270 TO IRTN3
      MSGNUM = 510
      GO TO 1240
 1270 WRITE  (OUTTAP,1280) SFM,MSGNUM
 1280 FORMAT (A25,I5,', CHECKPOINT DICTIONARY EXCEEDS CORE SIZE - ',
     1       'REMAINING RESTART CARDS IGNORED')
      GO TO 20
C
 1290 ASSIGN 1300 TO IRTN3
      MSGNUM = 511
      GO TO 1240
 1300 WRITE  (OUTTAP,1310) SFM,MSGNUM
 1310 FORMAT (A25,I5,', DMAP SEQUENCE EXCEEDS CORE SIZE - ',
     1       'REMAINING DMAP INSTRUCTIONS IGNORED')
      IF (NOGO .LT. 2) NOGO = 2
      GO TO 20
C
 1320 ASSIGN 1330 TO IRTN3
      MSGNUM = 524
      GO TO 1240
 1330 WRITE  (OUTTAP,1340) SFM,MSGNUM,NGINO,IMHERE
 1340 FORMAT (A25,I5,', ALTERNATE RETURN TAKEN WHEN OPENING FILE ',A4,
     1        3X,1H-,I3)
      NOGO = 3
      GO TO 1410
C
 1350 ASSIGN 1360 TO IRTN3
      MSGNUM = 525
      GO TO 1240
 1360 WRITE  (OUTTAP,1370) SFM,MSGNUM,NGINO
 1370 FORMAT (A25,I5,', ILLEGAL FORMAT ENCOUNTERED WHILE READING FILE ',
     1        A4)
      NOGO = 3
      GO TO 1410
C
 1380 GO TO (600,1400,1390), NOGO
C
C     NOGO = 3 - TERMINATE JOB HERE
C
 1390 ICPFLG = 0
      CALL MESAGE (-61,0,0)
C
C     NOGO = 2 - PUT IN DUMMY CONTROL FILE ON PROBLEM TAPE
C
 1400 NGINO = PTAPE
      CALL CLOSE (PTAPE,1)
      CALL OPEN  (*1320,PTAPE,GBUFF(DMAPBS+1),0)
      CALL SKPFIL(PTAPE,1)
      CALL CLOSE (PTAPE,2)
      CALL OPEN  (*1320,PTAPE,GBUFF(DMAPBS+1),3)
      CALL WRITE (PTAPE,NXCSA,2,1)
      SOLU(1) = 0
      SOLU(2) = 0
      APPRCH  = APPDMP
      IF (RSTRT .NE. ICOLD) APPRCH = -APPRCH
      CALL WRITE (PTAPE,SOLREC,6,1)
      CALL EOF   (PTAPE)
      CALL CLOSE (PTAPE,3)
      GO TO 640
C
C
C     XCSA HAS BEEN DISASTERED - GET DUMP AND QUIT.
C
 1410 ICPFLG = 0
 1420 CALL MESAGE (-37,0,NXCSA)
      RETURN
      END

      SUBROUTINE MPY3IC (Z,IZ,DZ)
C
C     IN-CORE PRODUCT.
C
      LOGICAL         FIRST1,FIRST2,E
      INTEGER         FILEA,FILEB,FILEE,FILEC,CODE,PREC,SCR1,SCR3,FILE,
     1                BUF1,BUF2,BUF3,BUF4,D,ZPNTRS,TYPIN,TYPOUT,ROW1,
     2                ROWM,UTYP,UROW1,UROWN,UINCR,EOL,EOR,PRECM
      DOUBLE PRECISION DZ(1),DD,NN,MM,PP
      DIMENSION       Z(1),IZ(1),NAME(2)
      COMMON /MPY3TL/ FILEA(7),FILEB(7),FILEE(7),FILEC(7),SCR1,SCR2,
     1                SCR,LKORE,CODE,PREC,LCORE,SCR3(7),BUF1,BUF2,
     2                BUF3,BUF4,E
      COMMON /MPY3CP/ ITRL,ICORE,N,NCB,M,NK,D,MAXA,ZPNTRS(22),LAEND,
     1                FIRST1,FIRST2,K,K2,KCOUNT,IFLAG,KA,LTBC,J,I,NTBU
      COMMON /PACKX / TYPIN,TYPOUT,ROW1,ROWM,INCR
      COMMON /UNPAKX/ UTYP,UROW1,UROWN,UINCR
      COMMON /ZNTPKX/ A(2),DUM(2),IROW,EOL,EOR
      COMMON /SYSTEM/ SYSBUF,NOUT
      EQUIVALENCE     (ISAVP ,ZPNTRS( 1)), (NSAVP ,ZPNTRS( 2)),
     1                (IPOINT,ZPNTRS( 3)), (NPOINT,ZPNTRS( 4)),
     2                (IACOLS,ZPNTRS( 5)), (NACOLS,ZPNTRS( 6)),
     3                (ITRANS,ZPNTRS( 7)), (NTRANS,ZPNTRS( 8)),
     4                (IC    ,ZPNTRS( 9)), (NC    ,ZPNTRS(10)),
     5                (IBCOLS,ZPNTRS(11)), (NBCOLS,ZPNTRS(12)),
     6                (IBCID ,ZPNTRS(13)), (NBCID ,ZPNTRS(14)),
     7                (IBNTU ,ZPNTRS(15)), (NBNTU ,ZPNTRS(16)),
     8                (IKTBP ,ZPNTRS(17)), (NKTBP ,ZPNTRS(18)),
     9                (IANTU ,ZPNTRS(19)), (NANTU ,ZPNTRS(20)),
     O                (IAKJ  ,ZPNTRS(21)), (NAKJ  ,ZPNTRS(22))
      DATA     NAME / 4HMPY3,4HIC   /
C
C
C     INITIALIZATION.
C
      FIRST1 = .TRUE.
      FIRST2 = .TRUE.
      DD     = D
      NN     = NCB
      MM     = M
      PP     = PREC
C
C     OPEN CORE POINTERS
C
      ISAVP  = 1
      NSAVP  = NCB
      IPOINT = NSAVP  + 1
      NPOINT = NSAVP  + NCB
      IACOLS = NPOINT + 1
C     NACOLS = NPOINT + D*NCB*M/10000
      NACOLS = NPOINT + (DD*NN*MM/10000.D0 + 0.5D0)
      ITRANS = NACOLS + 1
      IF (PREC.NE.1 .AND. MOD(ITRANS,2).NE.1) ITRANS = ITRANS + 1
C     NTRANS = ITRANS + PREC*D*NCB*M/10000 - 1
      NTRANS = ITRANS + (PP*DD*NN*MM/10000.D0 + 0.5D0) - 1
      IC = NTRANS + 1
      IF (PREC.NE.1 .AND. MOD(IC,2).NE.1) IC = IC + 1
      NC = IC + PREC*M - 1
      IBCOLS= NC + 1
      NBCOLS= NC + PREC*N*NK
      IBCID = NBCOLS + 1
      NBCID = NBCOLS + NK
      IBNTU = NBCID  + 1
      NBNTU = NBCID  + NK
      IKTBP = NBNTU  + 1
      NKTBP = NBNTU  + MAXA
      IANTU = NKTBP  + 1
      NANTU = NKTBP  + MAXA
      IAKJ  = NANTU  + 1
      NAKJ  = NANTU  + PREC*MAXA
C
C     PACK PARAMETERS
C
      TYPIN = PREC
      TYPOUT= PREC
      ROW1  = 1
      INCR  = 1
C
C     UNPACK PARAMETERS
C
      UTYP  = PREC
      UROW1 = 1
      UINCR = 1
C
C     PREPARE B AND A(T).
C
      CALL MPY3A (Z,Z,Z)
C
C     OPEN FILES AND CHECK EXISTENCE OF MATRIX E.
C
      IF (.NOT.E) GO TO 20
      FILE = FILEE(1)
      CALL OPEN (*5001,FILEE,Z(BUF4),2)
      CALL FWDREC (*5002,FILEE)
   20 FILE = FILEA(1)
      CALL OPEN (*5001,FILEA,Z(BUF1),2)
      CALL FWDREC (*5002,FILEA)
      FILE = SCR1
      CALL OPEN (*5001,SCR1,Z(BUF2),0)
      FILE = FILEC(1)
      CALL GOPEN (FILEC,Z(BUF3),1)
      ROWM = FILEC(3)
C
C     PROCESS COLUMNS OF C ONE BY ONE.
C
      DO 1000 J = 1,M
C
C     INITIALIZE COLUMN OF C.
C
      DO 30 IX = IC,NC
   30 Z(IX) = 0.
      IF (.NOT.E) GO TO 50
      UROWN = M
      CALL UNPACK (*50,FILEE,Z(IC))
   50 PRECM = PREC*M
C
C     PROCESS A AND PERFORM FIRST PART OF PRODUCT.
C
      CALL MPY3B (Z,Z,Z)
C
C     TEST IF PROCESSING IS COMPLETE
C
      IF (IFLAG .EQ. 0) GO TO 900
C
C     PROCESS REMAINING TERMS OF COLUMN J OF A.
C
C     TEST IF BCOLS IS FULL
C
  100 IF (K2 .LT. NK) GO TO 150
C
C     CALCULATE NEXT TIME USED FOR COLUMNS OF B AND/OR TERMS OF A
C
      IF (.NOT.FIRST2) GO TO 120
      FIRST2 = .FALSE.
      IBC = IBCID - 1
      IB  = IBNTU - 1
      DO 110 II = 1,NK
      IBC= IBC + 1
      I  = IZ(IBC)
      CALL MPY3NU (Z)
      IB = IB + 1
  110 IZ(IB) = NTBU
  120 IK = IKTBP - 1
      IA = IANTU - 1
      DO 140 II = 1,K
      IK = IK + 1
      IA = IA + 1
      IF (IZ(IK) .EQ. 0) GO TO 130
      I  = IZ(IK)
      CALL MPY3NU (Z)
      IZ(IA) = NTBU
      GO TO 140
  130 IZ(IA) = 0
  140 CONTINUE
C
C     ADD OR REPLACE COLUMN OF B INTO CORE AND PERFORM COMPUTATION
C
  150 CALL MPY3C (Z,Z,Z)
      IF (KCOUNT .EQ. K) GO TO 900
      IF (FIRST2) GO TO 100
      GO TO 150
C
C     PACK COLUMN OF C.
C
  900 CALL PACK (Z(IC),FILEC,FILEC)
 1000 CONTINUE
C
C     CLOSE FILES.
C
      CALL CLOSE (FILEA,2)
      CALL CLOSE (SCR1,1)
      CALL CLOSE (FILEC,1)
      IF (E) CALL CLOSE (FILEE,2)
      GO TO 9999
C
C     ERROR MESSAGES.
C
 5001 NERR = -1
      GO TO 6000
 5002 NERR = -2
 6000 CALL MESAGE (NERR,FILE,NAME)
C
 9999 RETURN
      END

      SUBROUTINE DIAG36 (Z,BUF,GPL,SIL,EQEXIN)
C
C     THIS ROUTINE PRINTS THE INTERNAL-EXTERNAL-SIL NOS. OF THE GRID
C     POINTS AND SCALAR POINTS, AS REQUESTED BY DIAG 36
C
      INTEGER         Z(2),     BUF,      GPL,      SIL,      EQEXIN,
     1                FILE,     NAM(2)
      COMMON /SYSTEM/ IBUF,     L,        DUMMY(6), NLPP
      COMMON /NAMES / RD,       RDREW,    SKIP(2),  REW
      DATA            NAM /     4HDIAG,   4H34      /
C
      FILE = GPL
      Z(1) = GPL
      CALL RDTRL (Z(1))
      N1 = Z(2)
      N2 = N1 + N1
      N3 = N2 + N1 + 1
      IF (N1 .LE. 0) GO TO 150
C
      N = 1
      DO 10 I = 1,2
      CALL OPEN (*150,FILE,Z(BUF),RDREW)
      CALL FWDREC (*160,FILE)
      CALL READ (*150,*170,FILE,Z(N),N1,1,J)
      CALL CLOSE (FILE,REW)
      FILE = SIL
 10   N = N + N1
C
C     HERE WE HAVE, IN INTERNAL NUMBER ORDER,
C        Z(   1 THRU N1) = EXTERNAL NOS.
C        Z(N1+1 THRU N2) = SIL NOS.
C
      NLPX = NLPP - 8
      N = NLPX*3
      DO 60 I = 1,N1,N
      CALL PAGE1
      WRITE  (L,30)
 30   FORMAT (/46X,38HTABLE OF INTERNAL-EXTERNAL-SIL NUMBERS,
     1       //10X,3(6X,30HINTERNAL  EXTERNAL      SIL   ),
     2        /10X,3(6X,3(10H--------  )))
      IM1 = I - 1
      DO 50 J = 1,NLPX
      J1 = IM1 + J
      J2 = J1  + NLPX
      J3 = J2  + NLPX
      IF (J3 .LE. N1) WRITE (L,40)
     1   J1,Z(J1),Z(J1+N1), J2,Z(J2),Z(J2+N1), J3,Z(J3),Z(J3+N1)
      IF (J3.GT.N1 .AND. J2.LE.N1) WRITE (L,40)
     1   J1,Z(J1),Z(J1+N1), J2,Z(J2),Z(J2+N1)
      IF (J2.GT.N1 .AND. J1.LE.N1) WRITE (L,40) J1,Z(J1),Z(J1+N1)
 40   FORMAT (10X,3(4X,3I10,2X))
 50   CONTINUE
 60   CONTINUE
C
      CALL SSWTCH (20,J)
      IF (J .EQ. 0) RETURN
C
      FILE = EQEXIN
      CALL OPEN (*150,FILE,Z(BUF),RDREW)
      CALL FWDREC (*160,FILE)
      CALL READ (*150,*170,FILE,Z( 1),N2,1,J)
      CALL READ (*150,*170,FILE,Z(N3),N2,1,J)
      CALL CLOSE (FILE,REW)
      I = N3 - 1
      J = N2
      K = N3 + N2 - 1
      DO 70 N = 1,N1
      Z(I  ) = Z(K  )
      Z(I-1) = Z(J  )
      Z(I-2) = Z(J-1)
      I = I - 3
      J = J - 2
 70   K = K - 2
C
C     HERE WE HAVE AN ARRAY OF EXTERNAL-INTERNAL-CODED SIL. PRINT IT OUT
C
      NLPX = NLPX*3
      N    = NLPX*3
      N3   = N3 - 1
      DO 100 I = 1,N3,N
      CALL PAGE1
      WRITE  (L,80)
 80   FORMAT (/44X,44HTABLE OF EXTERNAL-INTERNAL-CODED SIL NUMBERS,
     1       //10X,3(6X,30HEXTERNAL  INTERNAL CODED SIL  ),
     2        /10X,3(5X,3(10H--------- ),1X))
      IM1 = I - 1
      DO 90 J = 1,NLPX,3
      J1 = IM1 + J
      J2 = J1  + NLPX
      J3 = J2  + NLPX
      IF (J3 .LE. N3) WRITE (L,40)
     1   Z(J1),Z(J1+1),Z(J1+2), Z(J2),Z(J2+1),Z(J2+2),
     2   Z(J3),Z(J3+1),Z(J3+2)
      IF (J3.GT.N3 .AND. J2.LE.N3) WRITE (L,40)
     1   Z(J1),Z(J1+1),Z(J1+2), Z(J2),Z(J2+1),Z(J2+2)
      IF (J2.GT.N3 .AND. J1.LE.N3) WRITE (L,40) Z(J1),Z(J1+1),Z(J1+2)
 90   CONTINUE
 100  CONTINUE
C
      WRITE  (L,110)
 110  FORMAT (//10X,33H*** JOB TERMINATED BY DIAG 20 ***)
      CALL PEXIT
C
 150  N = -1
      GO TO 180
 160  N = -2
      GO TO 180
 170  N = -7
 180  CALL MESAGE (N,FILE,NAM)
      RETURN
      END

      SUBROUTINE OLDEL2
C
C     ANY ELEMENT (NEW OR OLD) WHICH HAS NOT BEEN CONVERTED TO USE
C     EMGPRO SHOULD HAVE AN ENTRY POINT IN OLDEL1, OLDEL2, OR OLDEL3
C     ***************************************************************
C
      ENTRY HEXA1S
      GO TO 10
      ENTRY HEXA1D
      GO TO 10
      ENTRY HEXA2S
      GO TO 10
      ENTRY HEXA2D
      GO TO 10
      ENTRY PLOTLS
      GO TO 10
      ENTRY PLOTLD
      GO TO 10
      ENTRY QDMEMS
      GO TO 10
      ENTRY QDMEMD
      GO TO 10
      ENTRY QDPLTS
      GO TO 10
      ENTRY QDPLTD
      GO TO 10
      ENTRY QUAD1S
      GO TO 10
      ENTRY QUAD1D
      GO TO 10
      ENTRY QUAD2S
      GO TO 10
      ENTRY QUAD2D
      GO TO 10
      ENTRY SLOT3S
      GO TO 10
      ENTRY SLOT3D
      GO TO 10
      ENTRY SLOT4S
      GO TO 10
      ENTRY SLOT4D
C
 10   CALL EMGOLD
      RETURN
      END

      SUBROUTINE PLA31
C
C     THIS ROUTINE READS THE INCREMENTAL DISPLACEMENT VECTOR INTO CORE
C     AND APPENDS THE PROPER DISPLACEMENT VALUES TO THE ESTNL ENTRY FOR
C     EACH ELEMENT, THEREBY CREATING THE ESTNLS, THE ESTNL SCRATCH FILE,
C     WHICH IS PROCESSED BY SUBROUTINE PLA32.
C
      INTEGER         BUFSZ,BUFR1,BUFR2,DELUGV,ESTNL,ESTNLS,FILE,EOR,
     1                CLSRW,IZ(1),IESTBK(100),ESTWDS(40),ELTYPE
      DIMENSION       NAME(2),NGPTS(40),MCBUGV(7),ESTBK(100)
      COMMON /BLANK / ICOM
      COMMON /SYSTEM/ BUFSZ
      COMMON /ZZZZZZ/ Z(1)
      COMMON /UNPAKX/ ITYPEB,IUNPK,JUNPK,INCUPK
      EQUIVALENCE     (Z(1),IZ(1)),(ESTBK(1),IESTBK(1))
      DATA    NAME  / 4HPLA3,4H1   /
      DATA    DELUGV, ESTNL,ESTNLS / 104,105,301/
      DATA    EOR   , NEOR,CLSRW   / 1,0,1      /
C
C    1        ROD       BEAM      TUBE      SHEAR     TWIST
C    2        TRIA1     TRBSC     TRPLT     TRMEM     CONROD
C    3        ELAS1     ELAS2     ELAS3     ELAS4     QDPLT
C    4        QDMEM     TRIA2     QUAD2     QUAD1     DAMP1
C    5        DAMP2     DAMP3     DAMP4     VISC      MASS1
C    6        MASS2     MASS3     MASS4     CONM1     CONM2
C    7        PLOTEL    REACT     QUAD3     BAR       CONE
C    8        TRIARG    TRAPRG    TORDRG    CORE      CAP
C
      DATA    ESTWDS/
     1           21,        0,       20,        0,        0,
     2           38,        0,        0,       27,       21,
     3            0,        0,        0,        0,        0,
     4           32,       32,       37,       43,        0,
     5            0,        0,        0,        0,        0,
     6            0,        0,        0,        0,        0,
     7            0,        0,        0,       50,        0,
     8            0,        0,        0,        0,        0 /
      DATA    NGPTS /
     1            2,        2,        2,        4,        4,
     2            3,        3,        3,        3,        2,
     3            2,        2,        2,        2,        4,
     4            4,        3,        4,        4,        2,
     5            2,        2,        2,        2,        2,
     6            2,        2,        2,        2,        2,
     7            2,        0,        0,        2,        2,
     8            3,        4,        2,        4,        2 /
C
C     DETERMINE SIZE OF CORE, DEFINE BUFFERS AND INITIALIZE CORE
C     POINTERS AND COUNTERS
C
      IZMAX = KORSZ (Z)
      BUFR1 = IZMAX - BUFSZ
      BUFR2 = BUFR1 - BUFSZ
      LEFT  = BUFR2 - 1
      IDISP = 0
C
C     OPEN THE DISPLACEMENT VECTOR FILE AND READ THE DISPLACEMENT VECTOR
C     INTO OPEN CORE.
C
      FILE = DELUGV
      CALL GOPEN (DELUGV,Z(BUFR1),0)
      MCBUGV(1) = DELUGV
      CALL RDTRL (MCBUGV)
      IF (LEFT .LT. MCBUGV(3)) CALL MESAGE (-8,0,NAME)
      ITYPEB = 1
      IUNPK  = 1
      JUNPK  = MCBUGV(3)
      INCUPK = 1
      CALL UNPACK (*9040,DELUGV,Z(IDISP+1))
      CALL CLOSE (DELUGV,CLSRW)
C
C     BUILD THE SCRATCH FILE ESTNLS
C
      CALL GOPEN (ESTNL,Z(BUFR1),0)
      CALL GOPEN (ESTNLS,Z(BUFR2),1)
C
C     READ AN ELEMENT TYPE FROM ESTNL AND WRITE IT ON ESTNLS.
C
   10 CALL READ (*60,*9030,ESTNL,ELTYPE,1,NEOR,IFLAG)
      NWDSRD = ESTWDS(ELTYPE)
      IF (NWDSRD .LE. 0) CALL MESAGE (-30,91,ELTYPE)
      CALL WRITE (ESTNLS,ELTYPE,1,NEOR)
C
C     READ AN ESTNL ENTRY
C
   20 J = NWDSRD
      CALL READ (*9020,*50,ESTNL,ESTBK,J,NEOR,IFLAG)
      NOGPTS = NGPTS(ELTYPE)
      IF (NOGPTS .LE. 0) CALL MESAGE (-30,92,ELTYPE)
C
C     APPEND THE DISPLACEMENT VECTORS ONTO THE ESTBK.
C
      NWDS = 3
      J = J + 1
      IF (ELTYPE.EQ. 1 .OR. ELTYPE.EQ. 3 .OR. ELTYPE.EQ.10 .OR.
     1    ELTYPE.EQ. 6 .OR. ELTYPE.EQ.17 .OR. ELTYPE.EQ.18 .OR.
     2    ELTYPE.EQ.19 .OR. ELTYPE.EQ.34) NWDS = 6
      DO 40 I = 1,NOGPTS
      INDEX = IDISP + IESTBK(I+1)
      DO 30 K = 1,NWDS
      ESTBK(J) = Z(INDEX)
      INDEX = INDEX + 1
   30 J = J + 1
   40 CONTINUE
C
C     THE APPENDED ESTNL ENTRY, WHICH IS AT ESTBK IS NOW COMPLETE.
C
      CALL WRITE (ESTNLS,ESTBK,J-1,NEOR)
      GO TO 20
C
C     WRITE AN EOR ON THE ESTNLS FILE.
C
   50 CALL WRITE (ESTNLS,0,0,EOR)
      GO TO 10
C
C     PROCESSING IS NOW COMPLETE
C
   60 CALL CLOSE (ESTNL,CLSRW)
      CALL CLOSE (ESTNLS,CLSRW)
      RETURN
C
C     FATAL ERRORS
C
 9020 CALL MESAGE (-2,FILE,NAME)
 9030 CALL MESAGE (-3,FILE,NAME)
 9040 CALL MESAGE (-5,DELUGV,NAME)
      RETURN
      END

      SUBROUTINE ALG03 (LNCT,L)
C
      COMMON /UPAGE / LIMIT,LQ
      COMMON /UD3PRT/ IPRTC
C
      LNCT=LNCT+L
      IF(LNCT.LE.LIMIT)RETURN
      LNCT=1+L
      IF (IPRTC .NE. 0) WRITE(LQ,100)
100   FORMAT(1H1)
      RETURN
      END

      SUBROUTINE CMRD2A
C
C     THIS SUBROUTINE PARTITIONS THE STIFFNESS MATRIX INTO BOUNDARY AND
C     INTERIOR POINTS AND THEN SAVES THE PARTITIONING VECTOR ON THE SOF
C     AS THE UPRT ITEM FOR THE CMRED2 MODULE.
C
C     INPUT DATA
C     GINO - USETMR - USET TABLE FOR REDUCED SUBSTRUCTURE
C            KAA    - SUBSTRUCTURE STIFFNESS MATRIX
C
C     OUTPUT DATA
C     GINO - KBB  - KBB PARTITION MATRIX
C            KIB  - KIB PARTITION MATRIX
C            KII  - KII PARTITION MATRIX
C     SOF  - UPRT - PARTITION VECTOR FOR ORIGINAL SUBSTRUCTURE
C
C     PARAMETERS
C     INPUT  - GBUF   - GINO BUFFER
C              INFILE - INPUT FILE NUMBERS
C              ISCR   - SCRATCH FILE NUMBERS
C              KORLEN - LENGTH OF OPEN CORE
C              KORBGN - BEGINNING ADDRESS OF OPEN CORE
C              OLDNAM - NAME OF SUBSTRUCTURE BEING REDUCED
C     OTHERS - USETMR - USETMR INPUT FILE NUMBER
C              KAA    - KAA INPUT FILE NUMBER
C              KBB    - KBB OUTPUT FILE NUMBER
C              KIB    - KIB OUTPUT FILE NUMBER
C              KBI    - KBI OUTPUT FILE NUMBER
C              KII    - KII OUTPUT FILE NUMBER
C              UPRT   - KAA PARTITION VECTOR FILE NUMBER
C
      INTEGER         DRY,GBUF1,OTFILE,OLDNAM,Z,UN,UB,UI,FUSET,USETMR,
     1                UPRT,MODNAM(2)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /BLANK / IDUM1,DRY,IDUM6,GBUF1,IDUM2(5),INFILE(11),
     1                OTFILE(6),ISCR(11),KORLEN,KORBGN,OLDNAM(2)
      COMMON /ZZZZZZ/ Z(1)
      COMMON /BITPOS/ IDUM4(9),UN,IDUM5(10),UB,UI
      COMMON /PATX  / LCORE,NSUB(3),FUSET
      COMMON /SYSTEM/ IDUM3,IPRNTR
      EQUIVALENCE     (USETMR,INFILE(6)),(KAA,INFILE(7)),
     1                (KBB,ISCR(1)),(KIB,ISCR(2)),(KII,ISCR(4)),
     2                (KBI,ISCR(3)),(UPRT,ISCR(5))
      DATA    MODNAM/ 4HCMRD,4H2A  /
      DATA    ITEM  / 4HUPRT       /
C
C     SET UP PARTITIONING VECTOR
C
      IF (DRY .EQ. -2) RETURN
      LCORE = KORLEN
      FUSET = USETMR
      CALL CALCV(UPRT,UN,UI,UB,Z(KORBGN))
C
C     PARTITION STIFFNESS MATRIX
C
C                  **         **
C                  *     .     *
C        **   **   * KBB . KBI *
C        *     *   *     .     *
C        * KAA * = *...........*
C        *     *   *     .     *
C        **   **   * KIB . KII *
C                  *     .     *
C                  **         **
C
      CALL GMPRTN(KAA,KII,KBI,KIB,KBB,UPRT,UPRT,NSUB(1),NSUB(2),
     1     Z(KORBGN),KORLEN)
C
C     SAVE PARTITIONING VECTOR
C
      CALL MTRXO(UPRT,OLDNAM,  ITEM,0,ITEST)
      IF (ITEST .NE. 3) GO TO 30
      RETURN
C
C     PROCESS MODULE FATAL ERRORS
C
   30 GO TO (40,40,40,50,60,80), ITEST
   40 WRITE (IPRNTR,900) UFM,MODNAM,ITEM,OLDNAM
      DRY = -2
      RETURN
   50 IMSG = -2
      GO TO 70
   60 IMSG = -3
   70 CALL SMSG(IMSG,ITEM,OLDNAM)
      RETURN
C
   80 WRITE (IPRNTR,901) UFM,MODNAM,ITEM,OLDNAM
      DRY = -2
      RETURN
C
  900 FORMAT (A23,' 3211, MODULE ',2A4,8H - ITEM ,A4,
     1       ' OF SUBSTRUCTURE ',2A4,' HAS ALREADY BEEN WRITTEN.')
  901 FORMAT (A23,' 6632, MODULE ',2A4,' - NASTRAN MATRIX FILE FOR ',
     1       'I/O OF SOF ITEM ',A4,', SUBSTRUCTURE ',2A4,', IS PURGED.')
C
      END

      SUBROUTINE MTRXIN
C
C     TWO CAPABILITIES -
C
C     (1) TO PROVIDE DIRECT INPUT MATRICES CAPABILITY, IN DYNAMIC RIGID
C         FORMATS, AND
C     (2) TO CONVERT DMIG TYPE MATRICES TO NASTRAN MATRIX FORMAT.
C
C     REVISED  1/90 BY G.CHAN/UNISYS
C     NO INTEGER ROW AND COLUMN PACKING FOR 32-BIT WORD MACHINE, AND
C     REAL AND COMPLEX DMIG MATRIX GENERATION FROM DMIG INPUT CARDS
C     WITH DOUBLE PRECISION DATA
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL         ORF,LSHIFT,RSHIFT,ANDF
      LOGICAL          PACK
      REAL             X,ALPHA(4),BETA(4),BUFR(13)
      DOUBLE PRECISION XD(2),BUFD(2)
      DIMENSION        BUF(20),MCB(50),DMIG(2),NAM(2),BLOCK(81),DB(13),
     1                 FILEI(3),BUFI(3),FILEA(7),FILEB(7),FILEC(7)
      CHARACTER        UFM*23
      COMMON /XMSSG /  UFM
      COMMON /MACHIN/  MACH,IHALF,JHALF
      COMMON /BLANK /  LUSET,NOMAT(3)
     1       /ZZZZZZ/  Z(1)
     2       /SYSTEM/  SYSBUF,NOUT,XX(5),LOADNN
     3       /TYPE  /  PRC(2),NWDS(4)
     4       /ZBLPKX/  X(4),ROW
     5       /NAMES /  RD,RDREW,WRT,WRTREW,CLSREW
     6       /SETUP /  IFILE(6)
     7       /SADDX /  NOMATS,NZ,MCBS(67)
      EQUIVALENCE      (BUF(1)  ,BUFR(1) ), (X(1)    ,XD(1)   ),
     1                 (FILEI(1),FILE1   ), (FILEI(2),FILE2   ),
     2                 (BUFI(1) ,BUF3    ), (BUFI(2) ,BUF4    ),
     3                 (NOMAT(1),NOMAT1  ), (NOMAT(2),NOMAT2  ),
     4                 (FILEI(3),FILE3   ), (BUFI(3) ,BUF5    ),
     5                 (NOMAT(3),NOMAT3  ), (BUFD(1) ,DB(13)  ),
     6                 (BUF(1)  ,DB(2)   )
      EQUIVALENCE      (MCBS( 1),FILEA(1)), (MCBS( 8),TYPALP  ),
     1                 (MCBS( 9),ALPHA(1)), (MCBS(13),FILEB(1)),
     2                 (MCBS(20),TYPBET  ), (MCBS(21),BETA(1) ),
     3                 (MCBS(61),FILEC(1))
      DATA    MCB   /  201   ,9*0   ,202   ,9*0   ,203   ,29*0  /,
     1        CASECC,  MPOOL ,EQEX  ,TFPOOL                     /
     2        101   ,  102   ,103   ,105                        /,
     3        SCR1  ,  SCR2  ,SCR3  ,SCR4  ,SCR5  ,SCR6  ,SCR7  /
     4        301   ,  302   ,303   ,304   ,305   ,306   ,307   /,
     5        BLOCK /  81*0         /,
     6        NAM   /  4HMTRX,4HIN  /,
     7        DMIG  /  114   ,1     /,
     8        NFILES/  21           /,
     9        IMAT1 ,  IMAT2 ,IMAT3 ,ITF /  139,   141,  143, 15/
C
C     PERFORM GENERAL INITIALIZATION
C
      BUF1  = KORSZ(Z) - SYSBUF - 2
      BUF2  = BUF1 - SYSBUF
      BUF3  = BUF2 - SYSBUF
      BUF4  = BUF3 - SYSBUF
      BUF5  = BUF4 - SYSBUF
      NOMAT1= -1
      NOMAT2= -1
      NOMAT3= -1
      MASK16= JHALF
C
C     IF MACHINE IS MORE THEN 32 BITS PER WORD, WE USE PACKING LOGIC
C     OTHERWISE, WE DO NOT PACK ROW AND COLUMN INDICES INTO ONE WORD
C
      PACK  = .FALSE.
      IF (IHALF .GT. 16) PACK = .TRUE.
      DO 12 I = 1,NFILES,10
      J1 = I + 1
      JN = I + 9
      DO 11 J = J1,JN
      MCB(J)  = 0
   11 CONTINUE
   12 CONTINUE
      TFSET   = 0
      TYPALP  = 1
      ALPHA(1)= 1.0
      TYPBET  = 1
      BETA(1) = 1.0
      NOGO    = 0
C
C     OPEN MPOOL. IF PURGED, SET FLAG.
C
      FILE   = MPOOL
      NOMPOO = 0
      NODMIG = 0
      CALL PRELOC (*30,Z(BUF1),MPOOL)
      NOMPOO = 1
      CALL LOCATE (*30,Z(BUF1),DMIG,FLAG)
      NODMIG = 1
C
C     READ CASE CONTROL RECORD.
C     SET NAMES OF REQUESTED MATRICES.
C     IF CASE CONTROL IS PURGED, SET NAMES OF REQUESTED MATRICES EQUAL
C     NAMES OF OUTPUT DATA BLOCKS.
C
   30 FILE = CASECC
      CALL OPEN (*90,CASECC,Z(BUF2),RDREW)
      CALL FWDREC (*680,CASECC)
      CALL READ (*650,*50,CASECC,Z,BUF2,1,FLAG)
      CALL MESAGE (-8,0,NAM)
   50 CONTINUE
      CALL CLOSE (CASECC,CLSREW)
      TFSET = Z(ITF)
      IF (Z(IMAT1) .EQ. 0) GO TO 70
      NOMAT1 = 1
      MCB(8) = Z(IMAT1  )
      MCB(9) = Z(IMAT1+1)
   70 IF (Z(IMAT2) .EQ. 0) GO TO 80
      NOMAT2  = 1
      MCB(18) = Z(IMAT2  )
      MCB(19) = Z(IMAT2+1)
   80 IF (Z(IMAT3) .EQ. 0) GO TO 110
      NOMAT3  = 1
      MCB(28) = Z(IMAT3  )
      MCB(29) = Z(IMAT3+1)
      GO TO 110
   90 DO 100 I = 1,21,10
      MCB(31)  = MCB(I)
      CALL RDTRL (MCB(31))
      IF (MCB(31) .EQ. MCB(I)) CALL FNAME (MCB(31),MCB(I+7))
  100 CONTINUE
      GO TO 290
C
C     IF TRANSFER FUNCTION MATRICES EXIST, BUILD THEM IN MATRIX FORMAT.
C     WRITE THEM ON 201,202,203 IF NO DMIG MATRICES TO ADD, OTHERWISE,
C     WRITE THEM ON SCR5,SCR6,SCR7.
C     IF NO TRANSFER FUNCTION MATRICES AND NO DMIG MATRICES, EXIT.
C
  110 IF (NOMAT1+NOMAT2+NOMAT3 .EQ. -3) GO TO 114
      IF (NODMIG) 116,630,116
  114 NODMIG = 0
  116 IF (NODMIG.EQ.0 .AND. TFSET.EQ.0) GO TO 650
      IF (TFSET .EQ. 0) GO TO 290
      FILE1 = SCR5
C
C     TEST FOR PURGED OUTPUT DATA BLOCKS.
C
      DO 102 I = 1,21,10
  102 CALL RDTRL (MCB(I))
      IF (NOMAT1 .EQ. -1) FILE1 = MCB( 1)
      FILE2 = SCR7
      IF (NOMAT3 .EQ. -1) FILE2 = MCB(21)
      FILE3 = SCR6
      IF (NOMAT2 .EQ. -1) FILE3 = MCB(11)
      NOMAT1 = 1
      NOMAT2 = 1
      NOMAT3 = 1
C
C     OPEN TFPOOL AND POSITION TO REQUESTED SET.
C     IF SET NOT IN TFPOOL, QUEUE MESSAGE AND TURN ON NOGO FLAG.
C
      FILE = TFPOOL
      CALL OPEN (*140,TFPOOL,Z(BUF2),RDREW)
  130 CALL FWDREC (*140,TFPOOL)
      CALL READ (*140,*140,TFPOOL,BUF,1,0,FLAG)
      IF (BUF(1) .EQ. TFSET) GO TO 150
      GO TO 130
  140 NOGO = 1
      BUF(1) = TFSET
      BUF(2) = 0
      CALL MESAGE (30,74,BUF)
      IF (DMIG(1) .EQ. TFSET) GO TO 150
      CALL CLOSE (TFPOOL,CLSREW)
      GO TO 290
C
C     OPEN OUTPUT FILES. WRITE HEADER RECORDS.
C
  150 DO 160 I = 1,3
C
C     CHECK FOR PURGED OUTPUT DATA BLOCKS.
C
      IF (FILEI(I) .GT. 0) GO TO 152
      NOMAT(I) = -1
      GO TO 160
  152 FILE = FILEI(I)
      BUFX = BUFI(I)
      CALL GOPEN (FILE,Z(BUFX),WRTREW)
  160 CONTINUE
C
C     PACK MATRICES ONTO OUTPUT FILES.
C
      NCOL = LUSET
      ICOL = 1
      JSW  = 0
      ISW  = 0
      I45  = 5
      IF (PACK) I45 = 4
      I12  = I45 - 3
  180 DO 190 I = 1,3
      IF (FILEI(I) .LE. 0) GO TO 190
      CALL BLDPK (1,1,FILEI(I),BLOCK(20*I-19),1)
  190 CONTINUE
      IF (ISW .NE. 0) GO TO 210
  200 IF (JSW .NE. 0) GO TO 240
      CALL READ (*680,*260,TFPOOL,BUF,I45,0,FLAG)
      ISW = 1
      COL = BUF(1)
      ROW = BUF(2)
      IF (.NOT.PACK) GO TO 210
      COL = RSHIFT(BUF(1),IHALF)
      ROW = ANDF(BUF(1),MASK16)
  210 IF (COL .GT. ICOL) GO TO 240
      DO 230 I = 1,3
      IF (FILEI(I) .LE. 0) GO TO 230
      CALL BLDPKI (BUF(I+I12),ROW,FILEI(I),BLOCK(20*I-19))
  230 CONTINUE
      ISW = 0
      GO TO 200
  240 DO 250 I = 1,3
      IF (FILEI(I) .LE. 0) GO TO 250
      CALL BLDPKN (FILEI(I),BLOCK(20*I-19),BLOCK(7*I+54))
  250 CONTINUE
      ICOL = ICOL + 1
      IF (ICOL .LE. NCOL) GO TO 180
      GO TO 270
  260 JSW = 1
      GO TO 240
C
C     CLOSE FILES AND WRITE TRAILERS. IF NO DMIG MATRICES, RETURN
C
  270 CALL CLOSE (TFPOOL,CLSREW)
      DO 280 I = 1,3
      IF (FILEI(I) .LE. 0) GO TO 280
      I7 = 7*I
      BLOCK(I7+54) = FILEI(I)
      BLOCK(I7+56) = NCOL
      BLOCK(I7+57) = 1
      BLOCK(I7+58) = 1
      CALL CLOSE  (FILEI(I),1)
      CALL WRTTRL (BLOCK(I7+54))
  280 CONTINUE
      IF (NODMIG .EQ. 0) GO TO 650
C
C     READ EQUIVALENCE TABLE INTO CORE
C
  290 FILE = EQEX
      CALL GOPEN (EQEX,Z(BUF2),0)
      CALL SKPREC (EQEX,1)
      CALL READ (*680,*300,EQEX,Z,BUF2,1,NEQEX)
      CALL MESAGE (-8,0,NAM)
  300 CALL CLOSE (EQEX,CLSREW)
      KN = NEQEX/2
      NN = NEQEX - 1
      DO 310 I = 1,NN,2
      Z(I+1) = Z(I+1)/10
  310 CONTINUE
C
C     READ MATRIX HEADER INFORMATION.
C     LOOK UP MATRIX NAME IN NAME LIST. IF ABSENT, SKIP MATRIX.
C
  320 CALL READ (*680,*630,MPOOL,BUF,9,0,FLAG)
C
C     BUF(5)= INPUT MATRIX TYPE, BUF(6)= OUTOUT MATRIX TYPE
C     BUF(1) AND BUF(2) ARE MATRIX NAME FROM DMIG CARDS.
C
      K    = BUF(6)
      PREC = PRC(K)
      K    = BUF(5)
      IPRC = MOD(K,2)
      NWD  = NWDS(K)
      NWD1 = NWD + 1
      I11  = 11
      IF (PACK) GO TO 325
      I11  = 10
      NWD1 = NWD + 2
  325 I10  = I11 - 1
      DO 330 I = 1,NFILES,10
      IF (MCB(I+7).EQ.BUF(1) .AND. MCB(I+8).EQ.BUF(2)) GO TO 360
  330 CONTINUE
  340 CALL FREAD (MPOOL,BUF,2,0)
      IF (BUF(1) .EQ. -1) GO TO 320
  350 CALL FREAD (MPOOL,BUF,2,0)
      IF (BUF(1) .EQ. -1) GO TO 340
      CALL FREAD (MPOOL,BUF,-NWD,0)
      GO TO 350
C
C     OPEN SCRATCH FILE. SET POINTERS.
C
  360 IPTR = I
      FILE = MCB(IPTR)
      MCB(IPTR+2) = LUSET
      MCB(IPTR+3) = BUF(4)
      MCB(IPTR+4) = BUF(6)
      MCB(IPTR+9) = 1
      IQQ = (IPTR-1)/10
      NOMAT(IQQ+1) = +1
      ISW = 0
      IMTRX = NEQEX + 1
      I = IMTRX
C
C
      CALL OPEN (*670,SCR1,Z(BUF2),WRTREW)
C
C     READ COLUMN GRID AND COMPONENT, AND CHECK DUPLICATE.
C     CONVERT GRID AND COMPONENT TO SIL NO.
C
C     REMOVE DUPLICATE CHECK ADDED HERE IN 91 VERSION. CHECKING SHOULD
C     BE DONE EARLY IN IFP MODULE, AND NOT HERE. REMOVED ALSO NOGOX AND
C     ITS ASSOCIATED LINES.   3/93
C
  370 CALL FREAD (MPOOL,BUF(10),2,0)
      IF (BUF(10) .EQ. -1) GO TO 450
C
C
      ASSIGN 380 TO RET
      GO TO 710
  380 COL = Z(2*K)
      IF (BUF(11) .NE. 0) COL = COL + BUF(11) - 1
      IF (PACK) COL = LSHIFT(COL,IHALF)
C
C     READ A COLUMN OF THE MATRIX.
C     STORE IN CORE OR ON SCRATCH FILE IF TOO BIG FOR CORE.
C
  390 CALL FREAD (MPOOL,BUF(10),2,0)
      IF (BUF(10) .EQ. -1) GO TO 370
      ASSIGN 400 TO RET
      GO TO 710
  400 ROW = Z(2*K)
      IF (BUF(11) .NE. 0) ROW = ROW + BUF(11) - 1
      BUF(11) = ROW
      BUF(10) = COL
      IF (PACK) BUF(11) = ROW + COL
      CALL FREAD (MPOOL,BUF(12),NWD,0)
      IF (ISW .EQ. 0) GO TO 420
  410 CALL WRITE (SCR1,BUF(I11),NWD1,0)
      GO TO 390
  420 IF (I+NWD1 .LT. BUF2) GO TO 430
      ISW = 1
      CALL WRITE (SCR1,Z(IMTRX),I-IMTRX,0)
      GO TO 410
  430 DO 440 J = 1,NWD1
      Z(I) = BUF(J+I10)
  440 I = I + 1
      GO TO 390
C
C     SORT MATRIX.
C
  450 IF (ISW   .EQ. 0) GO TO 460
      CALL WRITE (SCR1,0,0,1)
      CALL CLOSE (SCR1,CLSREW)
      CALL OPEN  (*670,SCR1,Z(BUF2),RDREW)
      IFILE(1) = SCR2
      IFILE(2) = SCR3
      IFILE(3) = SCR4
      IF (     PACK) CALL SORTI  (SCR1,0,NWD1,1,Z(IMTRX),BUF2-IMTRX)
      IF (.NOT.PACK) CALL SORTI2 (SCR1,0,NWD1,1,Z(IMTRX),BUF2-IMTRX)
      CALL CLOSE (SCR1,CLSREW)
      GO TO 470
  460 N = I - IMTRX
      NMTRX = I - NWD1
      CALL CLOSE (SCR1,CLSREW)
      IF (     PACK) CALL SORTI  (0,0,NWD1,1,Z(IMTRX),N)
      IF (.NOT.PACK) CALL SORTI2 (0,0,NWD1,1,Z(IMTRX),N)
C
C     OPEN OUTPUT FILE. WRITE HEADER RECORD
C     IF SORTED MATRIX NOT IN CORE, OPEN FILE WITH MATRIX.
C
  470 IF (TFSET .NE. 0) FILE = SCR1
      CALL OPEN  (*670,FILE,Z(BUF2),WRTREW)
      CALL FNAME (FILE,BUF(19))
      CALL WRITE (FILE,BUF(19),2,1)
      IF (ISW .NE. 0) CALL OPEN (*670,IFILE(6),Z(BUF3),RDREW)
C
C     PACK MATRIX ONTO OUTPUT FILE.
C
      NCOL = LUSET
      J    = IMTRX
      ICOL = 1
      JSW  = 0
  490 CALL BLDPK (BUF(6),BUF(6),FILE,0,0)
      IF (JSW .NE.   0) GO TO 540
  500 IF (J .GT. NMTRX) GO TO 570
      IF (ISW .EQ.   0) GO TO 510
      CALL READ (*680,*580,IFILE(6),BUF(I11),NWD1,0,FLAG)
      GO TO 530
  510 DO 520 K = 1,NWD1
      BUF(K+I10) = Z(J)
  520 J   = J + 1
  530 COL = BUF(10)
      ROW = BUF(11)
      IF (.NOT.PACK) GO TO 540
      COL = RSHIFT(BUF(11),IHALF)
      ROW = ANDF(BUF(11),MASK16)
  540 IF (COL .GT. ICOL) GO TO 590
      JSW = 0
      IF (PREC .EQ. 2) GO TO 550
      IF (IPRC .EQ. 0) GO TO 545
      X(1) = BUFR(12)
      X(2) = BUFR(13)
      GO TO 560
  545 X(1) = BUFD(1)
      X(2) = BUFD(2)
      GO TO 560
  550 IF (IPRC .EQ. 0) GO TO 555
      XD(1) = BUFR(12)
      XD(2) = BUFR(13)
      GO TO 560
  555 XD(1) = BUFD(1)
      XD(2) = BUFD(2)
  560 CALL ZBLPKI
      GO TO 500
  570 CALL BLDPKN (FILE,0,MCB(IPTR))
      ICOL = ICOL + 1
      IF (ICOL .LE. NCOL) GO TO 490
      GO TO 600
  580 J = NMTRX + 1
      GO TO 570
  590 JSW = 1
      GO TO 570
  600 CALL CLOSE (FILE,CLSREW)
      IF (ISW .NE. 0) CALL CLOSE (IFILE(6),CLSREW)
      CALL WRTTRL (MCB(IPTR))
C
C     IF TRANSFER FUNCTION MATRICES ARE TO BE ADDED, CALL MATRIX ADD
C     ROUTINE THEN RETURN TO READ NEXT MATRIX IN THE MATRIX POOL.
C
      IF (TFSET .EQ. 0) GO TO 320
      J = 2
      IF (IPTR .EQ.  1) J = 1
      IF (IPTR .EQ. 11) J = 3
      DO 620 I = 1,7
      K = IPTR + I - 1
      FILEA(I) = MCB(K)
      K = 7*J + I
      FILEB(I) = BLOCK(K+53)
  620 FILEC(I) = 0
      FILEA(1) = SCR1
      FILEC(1) = MCB(IPTR)
      FILEC(2) = NCOL
      FILEC(3) = NCOL
      FILEC(4) = FILEA(4)
      FILEC(5) = FILEA(5)
      NZ = BUF1 - IMTRX
      NOMATS = 2
      K = ORF(IMTRX,1)
      CALL SADD (Z(K),Z(K))
      CALL WRTTRL (FILEC)
      GO TO 320
C
C     TEST FOR ALL REQUESTED MATRICES FOUND.
C
  630 DO 640 I = 1,NFILES,10
      IF (MCB(I+7).EQ.0 .OR. MCB(I+9).NE.0) GO TO 640
      CALL MESAGE (30,70,MCB(I+7))
      NOGO = 1
  640 CONTINUE
  650 IF (NOMPOO .NE. 0) CALL CLOSE (MPOOL,CLSREW)
      IF (NOGO   .NE. 0) CALL MESAGE (-61,0,NAM)
      RETURN
C
C     FATAL ERRORS
C
  670 N = -1
      GO TO 700
  680 N = -2
  700 CALL MESAGE (N,FILE,NAM)
C
C     BINARY SEARCH ROUTINE
C
  710 KLO = 1
      KHI = KN
  720 K = (KLO+KHI+1)/2
  730 IF (BUF(10)-Z(2*K-1)) 740,810,750
  740 KHI = K
      GO TO 760
  750 KLO = K
  760 IF (KHI-KLO-1) 800,770,720
  770 IF (K.EQ.KLO) GO TO 780
      K = KLO
      GO TO 790
  780 K = KHI
  790 KLO = KHI
      GO TO 730
  800 NOGO = 1
      BUF(11) = 0
  810 GO TO RET, (380,400)
      END

      SUBROUTINE GMMATC( A,ROWA,COLA,MTA, B, ROWB,COLB,NTB, C )
C*****
C     GMMATC - G E N E R A L  M A T R I X  M U L T I P L Y
C                                 A N D
C                           T R A N S P O S E
C            S I N G L E  P R E C I S I O N  V E R S I O N
C     COMPLEX VERSION
C
C     PERFORMS                                     WHEN
C               A            *  B            =  C     MTA=0  NTB= 0
C               A            *  B TRANSPOSE  =  C          0       1
C               A TRANSPOSE  *  B            =  C          1       0
C               A TRANSPOSE  *  B TRANSPOSE  =  C          1       1
C*****
C     A -  IS A MATRIX (ROWA) ROWS BY (COLA) COLUMNS
C     B -  IS A MATRIX (ROWB) ROWS BY (COLB) COLUMNS
C     A,B AND C ARE STORED BY ROWS (EXAMPLE)
C              MATRIX                   STORED
C         A=   1    2              A=   1
C              3    4                   2
C              5    6                   3
C                                       4
C                                       5
C                                       6
C*****
C
C
C     IF MTA .LT. 0, C IS NOT ZEROED OUT.  HENCE THE ROUTINE, IN THIS
C     CASE, COMPUTES  A * B  +  D  =  C  WHERE THE MATRIX  D  HAS BEEN
C     STORED ROW-WISE AT  C  BY THE CALLING PROGRAM.  IF MTA = -1,  A
C     IS TRANSPOSED.  IF MTA = -2,  A  IS NOT TRANSPOSED.  NTB IS
C     DEFINED AS ABOVE AND IS INDEPENDENT OF MTA.
C
C
      INTEGER   ROWA,COLA,  ROWB,COLB
C
C
C
      INTEGER IPARM(2)
      COMPLEX A(1),B(1),C(1)
C
C
C
      NTA = IABS(MTA)
      IF (MTA .EQ. (-2)) NTA = 0
      IF ( NTA .NE. 0 ) GO TO 10
C
C A IS NOT TRANSPOSED
C
      NROWA = ROWA
      NCOLA = COLA
      INCRIK = 1
      IKN = COLA
      INCIK1 = COLA
      GO TO 20
C
C A IS TRANSPOSED
C
   10 NROWA = COLA
      NCOLA = ROWA
      INCRIK = COLA
      IKN = ( ROWA-1 )*COLA + 1
      INCIK1 = 1
   20 IF( NTB .NE. 0 ) GO TO 30
C
C B IS NOT TRANSPOSED
C
      NROWB = ROWB
      NCOLB = COLB
      INCRKJ = COLB
      INCKJ1 = 1
      GO TO 40
C
C B IS TRANSPOSED
C
   30 NROWB = COLB
      NCOLB = ROWB
      INCRKJ = 1
      INCKJ1 = COLB
C
C CHECK CONSISTANT DIMENSIONS AND ZERO C IF NO D MATRIX
C
   40 IF( NCOLA .NE. NROWB ) GO TO 80
      IF( MTA .LT. 0 ) GO TO 50
      NTERMS = NROWA*NCOLB
      DO 42 I=1,NTERMS
      C(I) = 0
   42 CONTINUE
C
C PERFORM MATRIX MULTIPLICATION
C
   50 IJ1 = 1
      IJN = NCOLB
      IK1 = 1
      DO 58 I=1,NROWA
      KJ1 = 1
      DO 56 IJ =IJ1,IJN
      KJ = KJ1
      DO 54 IK=IK1,IKN,INCRIK
      C(IJ) = C(IJ) + A(IK)*B(KJ)
      KJ = KJ + INCRKJ
   54 CONTINUE
      KJ1 = KJ1 + INCKJ1
   56 CONTINUE
      IJ1 = IJN + 1
      IJN = IJN + NCOLB
      IK1 = IK1 + INCIK1
      IKN = IKN + INCIK1
   58 CONTINUE
      RETURN
   80 IPARM(1) = NTA
      IPARM(2) = NTB
      CALL MESAGE (-30,21,IPARM(1))
      RETURN
      END

      SUBROUTINE RDMODX (FILE,MODE,WORD)
C
C     ENTRY POINTS - RDMODX (FILE ,MODE,WORD)
C                    RDMODY (A    ,MODE,WORD)
C                    RDMODE (*,*,*,MODE,WORD)
C                    RDWORD (      MODE,WORD)
C     RDMODX, RDMODE AND RDWORD CALLED BY PLOT, FIND, PARAM AND SETINP
C     RDMODY CALLED ONLY BY PLOT
C
C     REVISED 10/10/92 BY G.CHAN/UNISYS
C     THE ORIGINAL WAY PASSING 'FILE' AND ARRAY 'A' FROM RDMODX AND
C     RDMODY ARE NOT ANSI FORTRAN77 STANDARD. THERE IS NO GUARANTY THAT
C     RDMODE AND RDWORD WILL PICK THEM UP CORRECTLY. MODIFICATIONS HERE
C     ARE (1) SAVE 'FILE' IN /XRDMOD/, AND (2) COMPUTE A REFERENCE
C     POINTER, REFPTR, SUCH THAT ARRAY A IS ACCESSIBLE VIA ARRAY Z
C
      INTEGER         FILEX,CHECK1,CHECK2,BITSON,ENTRY,COMPLF,EOR,BLANK,
     1                FILE,REFPTR,Z,A(1),MODE(1),WORD(2),NAME(2),NEXT(2)
      COMMON /XRDMOD/ FILEX,REFPTR,CHECK1,CHECK2,BITSON,ENTRY
      COMMON /ZZZZZZ/ Z(1)
      DATA    BLANK , EOR,NAME / 1H ,1000000, 4HRDMO,4HDX  /
C
C     -RDMODX- IS CALLED IF -MODE- IS TO BE READ FROM DATA SET -FILE-
C
      ENTRY  = 0
      FILEX  = FILE
      CHECK1 = 13579
      GO TO 10
C
C
      ENTRY RDMODY (A,MODE,WORD)
C     ==========================
C
C     -RDMODY- IS CALLED IF -MODE- IS TO BE READ FROM THE -A- ARRAY
C
C     COMPUTE THE REFERENCE POINTER FROM Z(1) TO A(1), AND NEXT TIME
C     WHEN A ARRAY IS USED, USE Z ARRAY WITH THE REFERENCE POINTER
C
      ENTRY  = 1
      REFPTR = LOCFX(A(1)) - LOCFX(Z(1))
      CHECK2 = 24680
   10 BITSON = COMPLF(0)
      RETURN
C
C
      ENTRY RDMODE (*,*,*,MODE,WORD)
C     ==============================
C
C     -RDMODE- IS CALLED TO READ -MODE-
C     IF MODE = -4, THE NEXT TWO WORDS ARE READ INTO -WORD-
C     IF MODE IS NEGATIVE AND NOT = -4, ONLY THE NEXT ONE WORD IS READ
C     INTO -WORD-
C     RETURN 1 - NUMERIC MODE (-MODE- NEGATIVE)
C                -MODE- = -1, -WORD- IS INTEGER
C                -MODE- = -2, -WORD- IS REAL NUMBER
C                -MODE- = -3, -WORD- IS ZERO ?
C                -MODE- = -4, -WORD- IS D.P.REAL
C     RETURN 2 - ALPHABETIC MODE (-MODE- POSITIVE)
C     RETURN 3 - END OF LOGICAL CARD (RECORD TERMINATED),
C                -MODE- = 1000000
C
      IF (ENTRY .NE. 0) GO TO 80
      IF (CHECK1 .NE. 13579) CALL MESAGE (-37,0,NAME)
C
   20 CALL FREAD (FILEX,MODE,1,0)
      IF (MODE(1)) 70,30,40
   30 CALL FREAD (FILEX,0,0,1)
      GO TO 20
   40 IF (MODE(1) .GE. EOR) GO TO 60
   50 CALL FREAD (FILEX,NEXT,2,0)
      IF (NEXT(1).NE.BITSON .AND. NEXT(1).NE.BLANK) RETURN 2
      MODE(1) = MODE(1) - 1
      IF (MODE(1)) 20,20,50
   60 CALL FREAD (FILEX,0,0,1)
      RETURN 3
C
   70 I = 1
      IF (MODE(1) .EQ. -4) I = 2
      CALL FREAD (FILEX,WORD,I,0)
      RETURN 1
C
   80 IF (CHECK2 .NE. 24680) CALL MESAGE (-37,0,NAME)
      MODE(1) = Z(ENTRY+REFPTR)
      ENTRY   = ENTRY + 1
      IF (MODE(1)) 120,80,90
   90 IF (MODE(1) .GE. EOR) GO TO 110
  100 NEXT(1) = Z(ENTRY+0+REFPTR)
      NEXT(2) = Z(ENTRY+1+REFPTR)
      ENTRY   = ENTRY + 2
      IF (NEXT(1).NE.BITSON .AND. NEXT(1).NE.BLANK) RETURN 2
      MODE(1) = MODE(1) - 1
      IF (MODE(1)) 80,80,100
  110 ENTRY   = ENTRY + 1
      RETURN 3
C
  120 WORD(1) = Z(ENTRY+REFPTR)
      ENTRY   = ENTRY + 1
      IF (MODE(1) .NE. -4) RETURN 1
      WORD(2) = Z(ENTRY+REFPTR)
      ENTRY   = ENTRY + 1
      RETURN 1
C
C
      ENTRY RDWORD (MODE,WORD)
C     ========================
C
C     -RDWORD- IS CALLED TO READ TWO BCD WORDS INTO -WORD-
C     NOTE - ALL DATA FIELD DELIMITERS ARE SKIPPED
C
      WORD(1) = NEXT(1)
      WORD(2) = NEXT(2)
  130 MODE(1) = MODE(1) - 1
      IF (MODE(1) .LE. 0) GO TO 160
      IF (ENTRY   .NE. 0) GO TO 140
      IF (CHECK1  .NE. 13579) CALL MESAGE (-37,0,NAME)
      CALL FREAD (FILEX,NEXT,2,0)
      GO TO 150
C
  140 IF (CHECK2 .NE. 24680) CALL MESAGE (-37,0,NAME)
      NEXT(1) = Z(ENTRY  +REFPTR)
      NEXT(2) = Z(ENTRY+1+REFPTR)
      ENTRY   = ENTRY + 2
  150 IF (NEXT(1).EQ.BITSON .OR. NEXT(1).EQ.BLANK) GO TO 130
  160 RETURN
      END

      SUBROUTINE SSG3A (A,LLL,B,X,SR1,SR2,ITR1,RES)
C
C     SSG3A SOLVES AX = B USING A = L*LT
C
C     ON OPTION COMPUTES RESIDUAL VECTOR RES = A*X - B
C     AND EPSI= X(T)*RES/B(T)*X
C
      INTEGER          A,        B,        X,        SR1,
     1                 FILL,     FILLT,    FILB,     SR2,
     2                 FILX,     PREC,     RES,      SYSBUF,
     3                 NAME(2)
      DOUBLE PRECISION DCORE(1), DNUM,     DNOM,     DX
      COMMON /BLANK /  N,        IRES,     NSKIP,    IEPSI
      COMMON /FBSX  /  FILL(7),  FILLT(7), FILB(7),  FILX(7),
     1                 NZ,       PREC,     ISIGN
      COMMON /ZZZZZZ/  CORE(1)
      COMMON /SYSTEM/  KSYSTM(55)
      COMMON /UNPAKX/  ITB,      I,        J,        INCUR
      COMMON /ZNTPKX/  DX(2),    IK,       IEOL,     IEOR
      EQUIVALENCE      (CORE(1),DCORE(1)), (KSYSTM(1),SYSBUF),
     1                 (KSYSTM(55),IPREC)
      DATA    NAME  /  4HSSG3,   4HA       /
C
      FILL(1) = LLL
      CALL RDTRL (FILL)
      IF (FILL(1) .LE. 0) CALL MESAGE (-1,LLL,NAME)
      FILB(1) = B
      CALL RDTRL (FILB)
      NLOAD = FILB(2)
      NLEN  = FILB(3)
      ISIGN = 1
      PREC  = 2
      NZ    = KORSZ(CORE)
      DO 10 I = 2,7
   10 FILX(I) = FILB(I)
      FILX(1) = X
C
C     SAVE DISPLACEMENT VECTOR IN DOUBLE PRECISION
C
      FILX(5) = 1
      IF (FILB(5) .GT. 2) FILX(5) = 3
      FILX(5) = FILX(5) + IPREC - 1
      CALL FBS (CORE,CORE)
      CALL WRTTRL (FILX)
      IF (ITR1 .LT. 0) GO TO 130
      FILL(1) = RES
      CALL RDTRL (FILL)
      IF (FILL(1) .LE. 0) GO TO 130
C
C     COMPUTE RESIDUAL VECTOR
C
      CALL SSG2B (A,X,B,RES,0,2,-2,SR1)
C
C     COMPUTE EPSI
C
      NZ = NZ - SYSBUF
      CALL GOPEN (X,CORE(NZ+1),0)
      NZ = NZ - SYSBUF
      CALL GOPEN (RES,CORE(NZ+1),0)
      NZ = NZ - SYSBUF
      CALL GOPEN (B,CORE(NZ+1),0)
      IF (NZ .LT. 2*NLEN) GO TO 180
      ITB = 2
      INCUR = 1
      I = 1
      J = NLEN
      DO 120 L = 1,NLOAD
      CALL UNPACK (*80,X,CORE)
      DNUM = 0.0D0
      DNOM = 0.0D0
      CALL INTPK (*90,RES,0,2,0)
   20 IF (IEOL) 40,30,40
   30 CALL ZNTPKI
      DNUM = DNUM + DX(1)*DCORE(IK)
      GO TO 20
   40 CALL INTPK (*100,B,0,2,0)
   50 IF (IEOL) 70,60,70
   60 CALL ZNTPKI
      DNOM = DNOM + DX(1)*DCORE(IK)
      GO TO 50
   70 EPSI = DNUM/DNOM
      GO TO 110
   80 CALL FWDREC (*160,RES)
   90 CALL FWDREC (*170,B)
  100 EPSI = 0.0
  110 CALL MESAGE (35,NSKIP+L-1,EPSI)
      IF (ABS(EPSI) .LT. 1.0E-3) GO TO 120
      IEPSI = -1
      CALL MESAGE (58,1.0E-3,NSKIP+L-1)
  120 CONTINUE
      CALL CLOSE (X,1)
      CALL CLOSE (RES,1)
      CALL CLOSE (B,1)
  130 RETURN
C
  150 CALL MESAGE (-1,IPM,NAME)
  160 IPM = RES
      GO TO 150
  170 IPM = B
      GO TO 150
  180 CALL MESAGE (-8,0,NAME)
      RETURN
C
      END

      SUBROUTINE FA2
C
C     THIS IS THE DMAP MODULE FA2
C
C     DMAP CALLING SEQUENCE
C
C     FA2  PHIH,CLAMA,FSAVE/PHIHL,CLAMAL,CASEYY,OVG/V,N,TSTART/C,Y,VREF/
C    1     C,Y,PRINT=YES $
C
C     ALL OUTPUTS ARE APPEND
C
C     THE PURPOSE OF THIS MODULE IS TO COPY PARTS OF PHIH, CLAMA, AND
C    1    FSAVE ONTO PHIHL, CLAMAL, CASEYY, AND OVG RESPECTIVELY
C
      EXTERNAL        LSHIFT
      INTEGER         SYSBUF,PHIH,CLAMA,FSAVE,PHIHL,CLAMAL,CASEYY,OVG,
     1                TSTART,PRINT(2),MCB(7),FILE,NAME(2),FMETH,FLOOP,
     2                MCBPHL(7),MCBCL(7),MCBCC(7),MCBOVG(7),BUF(146),
     3                EJECT,IARY(22),IALPH(2),ME(3),YES,YESB
      REAL            XMACH,KFREQ,LBUF(6),IML,Z(1)
      COMMON /SYSTEM/ SYSBUF,NOUT,SKP(6),NLPP,MTEMP,NPAG,NLINES
      COMMON /ZZZZZZ/ IZ(1)
      COMMON /UNPAKX/ ITC,II,JJ,INCR
      COMMON /BLANK / TSTART,VREF,PRINT
      EQUIVALENCE     (Z(1),IZ(1))
      DATA    PHIH  , CLAMA,FSAVE,PHIHL,CLAMAL,CASEYY,OVG /
     1        101   , 102  ,  103,  201,   202,   203,204 /
      DATA    NAME  , NO,MCBCL,MCBCC,MCBOVG,IBLNK         /
     1        4HFA2 , 1H , 2HNO, 21*0,4H                  /
      DATA    BUF   / 146*1H                              /
      DATA    IARY  / 4H POI,4HNT =,1H ,1H ,4H MAC,4HH = ,1H ,1H ,
     1        4H KFR, 4HEQ= ,1H ,1H ,4H RHO,4H =  ,1H ,1H ,6*1H /
      DATA    TWOPHI/ 6.28318531          /
      DATA    ME    / 1HK,  2HKE,  2HPK   /
      DATA    YES   , YESB/ 3HYES, 4HYESB /
C
C     INITIALIZE
C
      NZ    = KORSZ(Z)
      IBUF1 = NZ - SYSBUF + 1
      IBUF2 = IBUF1 - SYSBUF
      IBUF3 = IBUF2 - SYSBUF
      IBUF4 = IBUF3 - SYSBUF
      NZ    = IBUF4 - 1
      ITC   = 3
      INCR  = 1
      MCBCL(1) = CLAMAL
      MCBCC(1) = CASEYY
      MCBOVG(1)= OVG
      IF (VREF .EQ. 0.0) VREF = 1.0
C
C     FIND PROPER METHOD
C
      FILE  = FSAVE
      CALL OPEN (*900,FSAVE,IZ(IBUF1),0)
      CALL READ (*910,*920,FSAVE,IZ(1),8,1,IFLAG)
      J     = 3
      FMETH = IZ(J)
      METH  = ME(FMETH)
      ONEOK = 1.E+25
      MCB(1)= FSAVE
      CALL RDTRL (MCB)
      FLOOP = MCB(2)
      NLOOP = MCB(3)
      NVALUE= MCB(7)
      J     = 6
      BREF  = Z(J)
      PHIB  = TWOPHI*BREF
      GO TO (1000,2000,3000), FMETH
C
C     K  METHOD
C
 1000 CONTINUE
C
C     PICK UP CONSTANTS
C
      NVALUE = 8
      NVALUE = IZ(NVALUE)
C
C     COPY ONTO PHIHL
C
      IF (FLOOP .NE. 1) GO TO 1010
C
C     FIRST TIME
C
      CALL GOPEN (PHIHL,IZ(IBUF2),1)
      CALL CLOSE (PHIHL,1)
      MCBPHL(1) = PHIH
      CALL RDTRL (MCBPHL)
      MCBPHL(2) = 0
      MCBPHL(6) = 0
      MCBPHL(7) = 0
      MCBPHL(1) = PHIHL
      CALL WRTTRL (MCBPHL)
      CALL GOPEN  (CLAMAL,IZ(IBUF2),1)
      CALL GOPEN  (CLAMA,IZ(IBUF3),0)
      CALL FREAD  (CLAMA,BUF,146,1)
      CALL CLOSE  (CLAMA,1)
      CALL WRITE  (CLAMAL,BUF,146,1)
      CALL WRITE  (CLAMAL,0,0,1)
      CALL CLOSE  (CLAMAL,1)
      CALL GOPEN  (CASEYY,IZ(IBUF2),1)
      CALL CLOSE  (CASEYY,1)
      CALL GOPEN  (OVG,IZ(IBUF2),1)
      CALL CLOSE  (OVG,1)
C
C     COPY NVALUE VECTORS TO PHIHL
C
 1010 CONTINUE
      MCB(1) = PHIH
      CALL RDTRL (MCB)
      NCOPY = MIN0(NVALUE,MCB(2))
      CALL GOPEN  (PHIH,IZ(IBUF2),0)
      CALL GOPEN  (PHIHL,IZ(IBUF3),0)
      CALL SKPFIL (PHIHL, 1)
      CALL SKPFIL (PHIHL,-1)
      CALL CLOSE  (PHIHL, 2)
      CALL GOPEN  (PHIHL,IZ(IBUF3),3)
      MCBPHL(1) = PHIHL
      CALL RDTRL  (MCBPHL)
      MCBPHL(7) = (2*MCBPHL(7)*MCBPHL(2)*MCBPHL(3))/10000
      CALL CYCT2B (PHIH,PHIHL,NCOPY,IZ,MCBPHL)
      CALL CLOSE  (PHIH,1)
      CALL CLOSE  (PHIHL,1)
      CALL WRTTRL (MCBPHL)
C
C     PICK UP M,K,RHO FOR THIS LOOP
C
      CALL FREAD (FSAVE,IZ,-3*(FLOOP-1),0)
      CALL FREAD (FSAVE,Z,3,1)
      J     = 0
      XMACH = Z(  1)
      KFREQ = Z(J+2)
      RHO   = Z(J+3)
      CALL FREAD (FSAVE,Z,1,1)
C
C     PUT CASEYY INTO CORE
C
      CALL READ (*910,*1020,FSAVE,IZ,NZ,0,IFLAG)
      CALL MESAGE (-8,0,NAME)
 1020 CONTINUE
      CALL CLOSE (FSAVE,1)
      K = 39
      DO 1021 I = 51,146
      BUF(I) = IZ(K)
      K = K + 1
 1021 CONTINUE
C
C     READY CLAMA
C
      CALL GOPEN  (CLAMA,IZ(IBUF1),0)
      CALL FWDREC (*910,CLAMA)
C
C     READY CLAMAL
C
      CALL GOPEN  (CLAMAL,IZ(IBUF2),0)
      CALL SKPFIL (CLAMAL, 1)
      CALL SKPFIL (CLAMAL,-1)
      CALL BCKREC (CLAMAL)
      CALL READ   (*910,*1022,CLAMAL,IZ(IFLAG+1),NZ,0,I)
      CALL MESAGE (-8,0,NAME)
 1022 CONTINUE
      CALL BCKREC (CLAMAL)
      CALL CLOSE  (CLAMAL,2)
      CALL GOPEN  (CLAMAL,IZ(IBUF2),3)
      CALL WRITE  (CLAMAL,IZ(IFLAG+1),I,0)
      CALL RDTRL  (MCBCL)
C
C     READY CASEYY
C
      CALL GOPEN  (CASEYY,IZ(IBUF3),0)
      CALL SKPFIL (CASEYY, 1)
      CALL SKPFIL (CASEYY,-1)
      CALL CLOSE  (CASEYY, 2)
      CALL GOPEN  (CASEYY,IZ(IBUF3),3)
      CALL RDTRL  (MCBCC)
C
C     READY OVG
C
      CALL GOPEN  (OVG,IZ(IBUF4),0)
      CALL SKPFIL (OVG, 1)
      CALL SKPFIL (OVG,-1)
      CALL CLOSE  (OVG,2)
      CALL GOPEN  (OVG,IZ(IBUF4),3)
      CALL RDTRL  (MCBOVG)
      MCBOVG(2)= MCBOVG(2) + 1
      MCBCC(4) = IFLAG
      CALL WRTTRL (MCBOVG)
      MCBCC(2) = MCBCC(2) + NCOPY
      CALL WRTTRL (MCBCC)
      MCBCL(2) = MCBCL(2) + NCOPY
      CALL WRTTRL (MCBCL)
      GO TO 1042
C
C     K-E METHOD
C
 2000 CONTINUE
C
C     P - K METHOD
C
 3000 CONTINUE
C
C     READY OVG
C
      CALL GOPEN (OVG,IZ(IBUF2),1)
      MCBOVG(2) = 1
      CALL WRTTRL (MCBOVG)
C
C     PUT RECORD 2 OF FSAVE INTO CORE
C
      CALL READ (*910,*3010,FSAVE,IZ(1),NZ,1,IFLAG)
      CALL MESAGE (-8,0,NAME)
 3010 CONTINUE
      CALL SKPREC (FSAVE,1)
      CALL FREAD  (FSAVE,0,-51,0)
      CALL FREAD  (FSAVE,BUF,96,1)
      IMR   = 1
      FLOOP = 1
C
C     COUNT RHO S
C
      NRHO = 1
      IF (FMETH .EQ. 3) GO TO 3012
      IRHO = 1
      RHO  = Z(IMR+2)
      IMR1 = IMR + 3
 3013 CONTINUE
      IF (IMR1 .GT.     IFLAG) GO TO 3012
      IF (RHO  .EQ. Z(IMR1+2)) GO TO 3012
      NRHO = NRHO + 1
      IMR1 = IMR1 + 3
      GO TO 3013
 3012 CONTINUE
 3011 CONTINUE
      NV = 1
C
C     DETERMINE THE NUMBER OF M-RHO PAIRS FOR THIS GO
C
      XMACH = Z(IMR  )
      RHO   = Z(IMR+2)
      NCOPY = 1
      IMR1  = IMR + 3*NRHO
 3020 CONTINUE
      IF (IMR1 .GT. IFLAG) GO TO 1042
      IF (XMACH.NE.Z(IMR1) .OR. RHO.NE.Z(IMR1+2)) GO TO 1042
      NCOPY = NCOPY + 1
      IMR1  = IMR1 + 3*NRHO
      GO TO 3020
 1042 CONTINUE
C
      IF (PRINT(1) .EQ. NO) GO TO 1041
C     SET UP PAGE FORMATS
C
      CALL PAGE1
      NLINES = NLINES + 7
      IF (PRINT(1) .EQ. YESB) WRITE (NOUT,1039) FLOOP,XMACH,RHO,METH
      IF (PRINT(1) .EQ. YES ) WRITE (NOUT,1040) FLOOP,XMACH,RHO,METH
 1039 FORMAT (1H0,55X,16HFLUTTER  SUMMARY, //7X,
     1        9HPOINT =  ,I3,5X,14HSIGMA VALUE = ,F8.3,4X,
     2        16HDENSITY RATIO = ,1P,E11.4,5X,9HMETHOD = ,A4, ///7X,
     3        5HKFREQ,12X, 8H1./KFREQ, 9X,8HVELOCITY, 12X,7HDAMPING,
     4        9X,9HFREQUENCY,12X,20HCOMPLEX   EIGENVALUE)
 1040 FORMAT (1H0,55X,16HFLUTTER  SUMMARY, //7X,
     1        9HPOINT =  ,I3, 5X,14HMACH NUMBER = ,F7.4,5X,
     2        16HDENSITY RATIO = ,1P,E11.4, 5X,9HMETHOD = ,A4, ///7X,
     3        5HKFREQ, 12X,8H1./KFREQ, 9X,8HVELOCITY, 12X,7HDAMPING,
     4        9X,9HFREQUENCY, 12X,20HCOMPLEX   EIGENVALUE)
 1041 CONTINUE
C
C     SET UP FOR OVG
C
      BUF(1) = 60
      BUF(2) = 2002
      BUF(4) = 1
      BUF(5) = 10*FLOOP
      BUF(9) = 1
      BUF(10)= 4
      CALL WRITE (OVG,BUF,146,1)
      IF (FMETH .NE. 1) GO TO 1101
      DO  1090 I = 115,146
      BUF(I) = IBLNK
 1090 CONTINUE
      CALL INT2A8 (*1092,FLOOP,IALPH)
 1092 IARY(3) = IALPH(1)
      IARY(4) = IALPH(2)
      CALL RE2AL (XMACH,IALPH)
      IARY(7) = IALPH(1)
      IARY(8) = IALPH(2)
      CALL RE2AL (KFREQ,IALPH)
      IARY(11) = IALPH(1)
      IARY(12) = IALPH(2)
      CALL RE2AL (RHO,IALPH)
      IARY(15) = IALPH(1)
      IARY(16) = IALPH(2)
      K = 115
      DO 1095 I = 1,16
      BUF(K) = IARY(I)
      K = K + 1
 1095 CONTINUE
      K = 103
      DO 1100 I = 115,146
      IZ(K) = BUF(I)
      K = K + 1
 1100 CONTINUE
 1101 CONTINUE
      DO  1030 I = 1,NCOPY
      GO TO (1102,1150,3200), FMETH
C
C     KE METHOD
C
 1150 CONTINUE
      IF (I.NE.1 .OR. NV.NE.1) GO TO 1152
      IR = IFLAG + 1
      J  = NVALUE*2
      DO 1153 M = 1,NCOPY
C
C     READ A RECORD OF COMPLEX EIGENVALUES INTO CORE
C
      CALL FREAD  (FSAVE,IZ(IR),J,1)
      CALL SKPREC (FSAVE,NRHO-1)
C
C     REARRANGE THE COMPLEX EIGENVALUES IN THE RECORD IN ASCENDING
C     ORDER OF THE ABSOLUTE VALUES OF THE IMAGINARY PARTS
C
      NVALU1 = NVALUE - 1
      DO 1170 L = 1,NVALU1
      LR = IR + 2*(L-1)
      LI = LR + 1
      VALUER = Z(LR)
      VALUEI = Z(LI)
      VALUE  = ABS(VALUEI)
      INDEX  = L
      L1     = L + 1
      DO 1160 K = L1,NVALUE
      KR = IR + 2*(K-1)
      KI = KR + 1
      VALUE1 = ABS(Z(KI))
      IF (VALUE1 .GE. VALUE) GO TO 1160
      VALUER = Z(KR)
      VALUEI = Z(KI)
      VALUE  = VALUE1
      INDEX  = K
 1160 CONTINUE
      IF (INDEX .EQ. L) GO TO 1170
      IRR = IR  + 2*(INDEX-1)
      IRI = IRR + 1
      Z(IRR) = Z(LR)
      Z(IRI) = Z(LI)
      Z(LR)  = VALUER
      Z(LI)  = VALUEI
 1170 CONTINUE
      IR = IR + J
 1153 CONTINUE
C
C     SELECT EACH FOR OUTPUT
C
 1152 CONTINUE
      J    = IFLAG + 1 + (I-1)*NVALUE*2 + (NV-1)*2
      REL  = Z(J)
      IML  = Z(J+1)
      VOUT = ABS(IML)/VREF
      G    = 0.0
      IF (IML .NE. 0.0) G = 2.*REL/IML
      KFREQ= Z(IMR+3*I-2)
      F    = KFREQ*IML/PHIB
      GO TO 1103
C
C     PK METHOD
C
 3200 CONTINUE
      CALL FREAD (FSAVE,LBUF,-(NV-1)*5,0)
      CALL FREAD (FSAVE,LBUF,5,1)
      REL = LBUF(1)
      IML = LBUF(2)
      KFREQ = LBUF(3)
      F = LBUF(4)
      G = LBUF(5)
      VOUT = ABS(Z(IMR+3*I-2))/VREF
      GO TO 1103
C
C     K METHOD
C
 1102 CONTINUE
      CALL FREAD (CLAMA ,LBUF,6,0)
      CALL WRITE (CLAMAL,LBUF,6,0)
      REL = LBUF(3)
      IML = LBUF(4)
      VOUT= ABS(IML)/VREF
      G   = 0.0
      IF (IML .NE. 0.0) G = 2.0*REL/IML
      F =  KFREQ*IML/(PHIB)
C
C     PUT OUT CASEYY
C
      CALL WRITE (CASEYY,IZ,IFLAG,1)
 1103 CONTINUE
      IF (PRINT(1) .EQ. NO) GO TO 1050
C
C     PRINT OUTPUT
C
      K = EJECT(1)
      IF (K .EQ. 0) GO TO 1060
      IF (PRINT(1) .EQ. YESB) WRITE (NOUT,1039) FLOOP,XMACH,RHO,METH
      IF (PRINT(1) .EQ. YES ) WRITE (NOUT,1040) FLOOP,XMACH,RHO,METH
      NLINES = NLINES + 7
 1060 CONTINUE
      IF (KFREQ .NE. 0.0) ONEOK = 1.0/KFREQ
      WRITE  (NOUT,1070) KFREQ,ONEOK,VOUT,G,F,REL,IML
 1070 FORMAT (1H ,5X,F8.4,5X,6(1X,1P,E14.7,3X))
 1050 CONTINUE
C
C     PUT OUT OVG PARTS
C
      LBUF(1) = VOUT
      LBUF(2) = 0.0
      LBUF(3) = G
      LBUF(4) = F
      CALL WRITE (OVG,LBUF,4,0)
 1030 CONTINUE
      FLOOP = FLOOP+1
      CALL WRITE (OVG,0,0,1)
      GO TO (1031,2031,3331), FMETH
C
C     FINISH UP FOR KE METHOD
C
 2031 CONTINUE
      NV = NV + 1
      IF (NV .LE. NVALUE) GO TO 1042
C
C     ALL MODES DONE
C
      IF (IRHO .GE. NRHO) GO TO 2090
C
C     DO ANOTHER RHO
C
      IRHO= IRHO + 1
      IMR = IMR  + 3
      RHO = Z(IMR+2)
      CALL SKPREC (FSAVE,NCOPY*(NRHO-1))
      GO TO 1042
 2090 CONTINUE
      IF (IMR1 .GT. IFLAG) GO TO 4000
      IMR = IMR1
      GO TO 3011
C
C     P-K AT POINT END
C
 3331 CONTINUE
      NV = NV + 1
      IF (NV .GT. NVALUE) GO TO 3390
      CALL SKPREC (FSAVE,-NCOPY)
      GO TO 1042
C
C     ALL MODES DONE--CONSIDER MORE M-RHO VALUES
C
 3390 IF (IMR1 .GT. IFLAG) GO TO 4000
      IMR = IMR1
      GO TO 3011
C
C     DONE
C
 4000 CALL CLOSE (OVG,1)
      CALL CLOSE (FSAVE,1)
      RETURN
C
C     FINISH UP
C
 1031 CALL WRITE (CLAMAL,0,0,1)
      CALL CLOSE (OVG,1)
      CALL CLOSE (CLAMAL,1)
      CALL CLOSE (CLAMA,1)
      CALL CLOSE (CASEYY,1)
C
C     CHECK TIMES
C
      CALL KLOCK  (NOW)
      CALL TMTOGO (ITLFT)
      IF (NOW-TSTART.GE.ITLFT .AND. FLOOP.NE.NLOOP) GO TO 1110
      RETURN
C
C     INSUFFICIENT TIME
C
 1110 CALL MESAGE (45,NLOOP - FLOOP,NAME)
      TSTART = -1
      RETURN
C
C     ERROR MESSAGES
C
  900 IP1 = -1
      GO TO 901
  910 IP1 = -2
      GO TO 901
  920 IP1 = -3
  901 CALL MESAGE (IP1,FILE,NAME)
      RETURN
      END

      SUBROUTINE MPYDRI (A,DA,B,DB,C,DC)
C
C     SPECIAL MPYAD PERFORMS THE MATRIX OPERATION
C        (+/-)A   *B (+/-)C = D   OR
C        (+/-)A(T)*B (+/-)C = D
C
C     WHERE A, OR B IS , OR BOTH ARE, DIAGONAL, ROW VECTOR, OR IDENTITY
C     MATRIX.  MATRIX C CAN BE PURGED
C
C     THIS ROUITNE DOES NOT HANDEL A-TRANSPOSE, WHILE B IS DIAGNOL, ROW
C     VECTOR, OR IDENTIY MASTRIX. ONLY EXCEPTION IS A IS TRULY (Nx1).
C
C     NOTE -
C     1. IN NASTRAN GINO, THE TRAILER 2ND AND 3RD WORDS FOR A ROW-VECTOR
C        IS (1xM), AND THE DIAGONAL MATRIX IS ALSO (1xM)
C     2. THE ROW-VECTOR AND DIAGONAL MATRIX ARE PACKED IN ONE RECORD.
C        AND THUS, THEY REQUIRE SPECIAL ATTENTION DEALING WITH THE FILEB
C        WHILE FILEA IS ALREADY A ROW-VECTOR, OR A DIAGONAL MATRIX
C
C     WRITTEN BY G.CHAN/UNISYS,  1/92
C     LAST MODIFIED FOR SPECIAL CASES THAT INVOLVE B MATRIX IS ALSO
C     A DIAGONAL MATRIX OR A ROW-VECOTR,  2/93                 ----
C
      IMPLICIT INTEGER (A-Z)
      INTEGER          NAME(2),AD(7),SD(7)
      REAL             A(1),B(1),C(1)
      DOUBLE PRECISION DA(1),DB(1),DC(1)
      CHARACTER        UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG /  UFM,UWM,UIM,SFM
      COMMON /MPYADX/  FILEA(7),FILEB(7),FILEC(7),FILED(7),NZZ,T,SIGNAB,
     1                 SIGNC,PREC,SCR
      COMMON /SYSTEM/  SYSBUF,NOUT
      COMMON /TYPE  /  PRC(2),WORDS(4)
      COMMON /NAMES /  RD,RDREW,WRT,WRTREW,CLSREW
      COMMON /PACKX /  TYPEP,TYPOUT,IP,JP,INCRP
      COMMON /UNPAKX/  TYPEU,IU,JU,INCRU
      COMMON /TRNSPX/  NAMEA(7),NAMEAT(7),LCORE,NSCR,ISCR
      EQUIVALENCE      (FILEA(1),FA   ),(FILEA(4),FORMA),
     2                 (FILEA(5),TYPEA),(FILEB(1),FB   ),
     4                 (FILEB(4),FORMB),(FILEB(5),TYPEB),
     5                 (FILEC(1),FC   ),(FILEC(4),FORMC),
     7                 (FILEC(5),TYPEC),(FILED(1),FD   ),
     8                 (FILED(2),COLD ),(FILED(4),FORMD),
     9                 (FILED(5),TYPED)
      DATA    NAME   / 4HMPYA , 4HDRI /,
     1        DIAGNL , ROWVEC , IDENT / 3, 7, 8  /
C
C     MOVE TRUE ROWS AND COLUMNS INTO ROWA/B/C AND COLA/B/C
C
      COLA = FILEA(2)
      ROWA = FILEA(3)
      COLB = FILEB(2)
      ROWB = FILEB(3)
      COLC = FILEC(2)
      ROWC = FILEC(3)
      IF (FORMA.EQ.DIAGNL .OR. FORMA.EQ.ROWVEC) COLA = ROWA
      IF (FORMA .EQ. ROWVEC) ROWA = 1
      IF (FORMB.EQ.DIAGNL .OR. FORMB.EQ.ROWVEC) COLB = ROWB
      IF (FORMB .EQ. ROWVEC) ROWB = 1
      IF (FORMC.EQ.DIAGNL .OR. FORMC.EQ.ROWVEC) COLC = ROWC
      IF (FORMC .EQ. ROWVEC) ROWC = 1
C
      IF (SIGNAB.EQ.0 .AND. FC.EQ.0) GO TO 1100
      IF (SIGNAB.EQ.0 .AND. FC.NE.0) GO TO 780
      BUF1  = NZZ  - SYSBUF
      BUF2  = BUF1 - SYSBUF
      BUF3  = BUF2 - SYSBUF
      COLD  = 0
      ROWD  = ROWA
      IF (T .EQ. 1) ROWD = COLA
      IF (PREC.EQ.1 .AND. (TYPED.EQ.2 .OR. TYPED.EQ.4)) TYPED = TYPED -1
      TYPOUT= TYPED
      NWDS  = WORDS(TYPED)
      ROWA2 = ROWA*NWDS
      ROWB2 = ROWB*NWDS
      ROWD2 = ROWD*NWDS
      COLB2 = COLB*2
      NZ    = BUF3 - 1
      SD(1) = SCR
      IF (FC .NE. 0) GO TO 10
      SD(1) = FD
      NZ    = BUF2 - 1
   10 CALL MAKMCB (SD,SD,ROWD,FORMD,TYPED)
C
C     REMEMBER, ONLY FILEA CAN HAVE TRANSPOSE, NOT FILEB.
C     IF FILEA IS DIAGONAL, ROW VECTOR, OR IDENTITY MATRIX, THE ACTUAL
C     TRANSPOSE OF FILEA HAS NEVER TAKEN PLACE.
C
C     FA, FB, FC AND FD ARE FILEA, FILEB, FILEC AND FILED RESPECTIVELY.
C     AD(1) IS EITHER FILEA OR FILED, AND
C     SD(1) IS EITHER SCRATCH FILE OR FILED
C
      IF (T .EQ. 1) GO TO 30
      DO 20 I = 1,7
   20 AD(I) = FILEA(I)
      GO TO 50
   30 DO 40 I = 1,7
   40 AD(I) = FILED(I)
   50 IP    = 1
      JP    = ROWD
      INCRP = 1
      IU    = 1
      INCRU = 1
      IF (FA .LE. 0) GO TO 60
      FILE = FA
      CALL OPEN (*1010,FA,A(BUF1),RDREW)
      CALL FWDREC (*1020,FA)
   60 IF (FB .LE. 0) GO TO 70
      FILE = FB
      CALL OPEN (*1010,FB,A(BUF2),RDREW)
      CALL FWDREC (*1020,FB)
C
   70 IF (FA .LE. 0) GO TO 80
      IF (FORMA .EQ. DIAGNL) GO TO  90
      IF (FORMA .EQ. ROWVEC) GO TO 200
      IF (FORMA .EQ. IDENT ) GO TO 400
   80 IF (T .EQ. 1)  GO TO 990
      IF (FORMB .EQ. DIAGNL) GO TO 490
      IF (FORMB .EQ. ROWVEC) GO TO 600
      IF (FORMB .EQ. IDENT ) GO TO 750
      FILE = 0
      GO TO 1070
C
C                                         D   G   J   M
C     FILEA IS                            E   H   K   N
C     DIAGONAL -                          F   I   L   O
C                      a      a  0  0    aD  aG  aJ  aM
C                      b      0  b  0    bE  bH  bK  bN
C                      c ==>  0  0  c    cF  cI  cL  cO
C
C     SPECIAL CASE NEEDS TO BE CONSIDERED -
C     FILEB IS ALSO A DIAGONAL MATRIX. (FILEB CANNOT BE A ROW VECTOR)
C
   90 FILE  = FA
      JU    = ROWA
      TYPEU = TYPED*SIGNAB
      CALL UNPACK (*1050,FA,A)
      CALL CLOSE (FA,CLSREW)
      CALL GOPEN (SD,A(BUF1),WRTREW)
      FILE  = FB
      JU    = ROWB
      TYPEU = TYPED
      IF (FORMB .EQ. DIAGNL) GO TO 150
      DO 145 I = 1,COLB
      CALL UNPACK (*1050,FB,B)
      GO TO (100,110,120,130), TYPEB
  100 DO 105 J = 1,ROWB
  105 C(J) = A(J)*B(J)
      GO TO 140
  110 DO 115 J = 1,ROWB
  115 DC(J) = DA(J)*DB(J)
      GO TO 140
  120 DO 125 J = 1,ROWB2,2
      C(J  ) = A(J)*B(J  ) - A(J+1)*B(J+1)
  125 C(J+1) = A(J)*B(J+1) + A(J+1)*B(J  )
      GO TO 140
  130 DO 135 J = 1,ROWB2,2
      DC(J  ) = DA(J)*DB(J  ) - DA(J+1)*DB(J+1)
  135 DC(J+1) = DA(J)*DB(J+1) + DA(J+1)*DB(J  )
  140 CALL PACK (C,SD,SD)
  145 CONTINUE
      GO TO 190
C
C     SPECIAL CASE - FILEB IS ALSO A DIAGONAL MATRIX
C
  150 CALL UNPACK (*1050,FB,B)
      IF (TYPEB .GE. 3) GO TO 165
      DO 155 J = 1,ROWB
  155 C(J) = 0.0
      DO 160 J = 1,ROWB
      IF (TYPEB .EQ. 1)  C(J) =  A(J)* B(J)
      IF (TYPEB .EQ. 2) DC(J) = DA(J)*DB(J)
      CALL PACK (C,SD,SD)
      C(J) = 0.0
      IF (TYPEB .EQ. 2) DC(J) = 0.0D+0
  160 CONTINUE
      GO TO 190
C
  165 DO 170 J = 1,ROWB2
  170 C(J) = 0.0
      DO 180 J = 1,ROWB2,2
      IF (TYPEB .EQ. 4) GO TO 175
      C(J  ) = A(J)*B(J  ) - A(J+1)*B(J+1)
      C(J+1) = A(J)*B(J+1) + A(J+1)*B(J  )
      CALL PACK (C,SD,SD)
      C(J  ) = 0.0
      C(J+1) = 0.0
      GO TO 180
  175 DC(J  ) = DA(J)*DB(J  ) - DA(J+1)*DB(J+1)
      DC(J+1) = DA(J)*DB(J+1) + DA(J+1)*DB(J  )
      CALL PACK (C,SD,SD)
      DC(J  ) = 0.0D+0
      DC(J+1) = 0.0D+0
  180 CONTINUE
C
  190 CALL CLOSE (FB,CLSREW)
      CALL CLOSE (SD,CLSREW)
      GO TO 800
C                                         E       I      M
C     FILEA IS A ROW     a                F       J      N
C     VECTOR -           b                G       K      O
C     RESULT IN FILED,   c                H       L      P
C     A (Nx1) RECT.      d ==> a b c d  aE+bF+  aI+bJ+  aM+bN+
C     MATRIX or A ROW-                  cG+dH   cK+dL   cO+dP
C     VECTOR
C
C     SPECIAL CASE NEEDS TO BE CONSIDERED -
C     FILEB IS A DIAGONAL MATRIX. (FILEB CANNOT BE A ROW VECTOR)
C
C
C     TRANSPOSE OF FILEA,                 E       F       G
C     A ROW VECTOR -               a     aE      aF      aG
C                                  b     bE      bF      bG
C                                  c     cE      cF      cG
C                                  d     dE      dF      dG
C
C     SPECIAL CASES NEED TO BE CONSIDERED -
C     FILEB MUST BE A (Nx1) RECTANGULAR MATRIX, OR A ROW VECTOR
C
  200 FILE  = FA
      JU    = ROWA
      TYPEU = TYPED*SIGNAB
      CALL UNPACK (*1050,FA,A)
      CALL CLOSE (FA,CLSREW)
      CALL GOPEN (SD,A(BUF1),WRTREW)
      FILE  = FB
      TYPEU = TYPED
      IF (T .EQ. 1) GO TO 350
C
C     FILEA IS A ROW-VECTOR, RESULT IS ALSO A ROW-VECTOR, OR A
C     (Nx1) RECTANGULAR MATRIX
C
      JU    = ROWB
      IF (FORMB .EQ. DIAGNL) GO TO 260
      IF (ROWB  .NE.   ROWA) GO TO 1030
      COLB4 = COLB*4
      DO 205 J = 1,COLB4
  205 C(J) = 0.0
      DO 250 J = 1,COLB
      CALL UNPACK (*290,FB,B)
      GO TO (210,220,230,240), TYPEB
  210 DO 215 K = 1,ROWB
  215 C(J) = C(J) + A(K)*B(K)
      GO TO 250
  220 DO 225 K = 1,ROWB
  225 DC(J) = DC(J) + DA(K)*DB(K)
      GO TO 250
  230 DO 235 K = 1,ROWB2,2
      C(J  ) = C(J  ) + A(K)*B(K  ) - A(K+1)*B(K+1)
  235 C(J+1) = C(J+1) + A(K)*B(K+1) + A(K+1)*B(K  )
      GO TO 250
  240 DO 245 K = 1,ROWB,2
      DC(J  ) = DC(J  ) + DA(K)*DB(K  ) - DA(K+1)*DB(K+1)
  245 DC(J+1) = DC(J+1) + DA(K)*DB(K+1) + DA(K+1)*DB(K  )
  250 CONTINUE
      GO TO 300
C
C     SPECIAL CASE - FILEB IS A DIAGONAL MATRIX.
C
  260 CALL UNPACK (*1050,FB,B)
      GO TO (270,280,290,300), TYPEB
  270 DO 275 J = 1,COLB
  275 C(J) = A(J)*B(J)
      GO TO 310
  280 DO 285 J = 1,COLB
  285 DC(J) = DA(J)*DB(J)
      GO TO 310
  290 DO 295 J = 1,COLB2,2
      C(J  ) = A(J)*B(J  ) - A(J+1)*B(J+1)
  295 C(J+1) = A(J)*B(J+1) + A(J+1)*B(J  )
      GO TO 310
  300 DO 305 J = 1,COLB2,2
      DC(J  ) = DA(J)*DB(J  ) - DA(J+1)*DB(J+1)
  305 DC(J+1) = DA(J)*DB(J+1) + DA(J+1)*DB(J  )
C
  310 CALL CLOSE (FB,CLSREW)
      IF (FC .EQ. 0) GO TO 340
      FILE  = FC
      TYPEU = TYPEC*SIGNC
      CALL GOPEN (FC,A(BUF2),RDREW)
      IF (FORMC .NE. ROWVEC) GO TO 311
      CALL UNPACK (*1050,FC,A(1))
      GO TO 314
  311 IP = 1
      JP = 1
      DO 313 J = 1,COLC
      CALL UNPACK (*312,FC,A(J*NWDS-1))
      GO TO 313
  312 A(J*NWDS-1) = 0.
      A(J*NWDS  ) = 0.
  313 CONTINUE
C
  314 CALL CLOSE (FC,CLSREW)
      GO TO (315,325), TYPED
  315 DO 320 J = 1,ROWD2
  320 C(J) = C(J) + A(J)
      GO TO 340
  325 DO 330 J = 1,ROWD2
  330 DC(J) = DC(J) + DA(J)
C
  340 CALL PACK (C,SD,SD)
      FORMD = ROWVEC
      GO TO 970
C
C     FILEA (A ROW VECTOR) TRANSFPOSE
C
  350 IF (FORMB .EQ. ROWVEC) GO TO 390
      IF (ROWB .NE. 1) GO TO 1030
      IU = 0
      J  = 1
      DO 380 I = 1,ROWB
      CALL UNPACK (*360,FB,B(J))
      IF (IU .NE. I) GO TO 1030
      GO TO 380
  360 JE = J + NWDS
      DO 370 K = J,JE
  370 B(K) = 0.0
  380 J  = J + NWDS
      CALL CLOSE (FB,CLSREW)
      IU = 1
      GO TO 610
C
C     SPECAIL CASE - FILE B IS A ROW VECTOR
C
  390 IF (ROWB .NE. 1) GO TO 1030
      JU = COLB
      CALL UNPACK (*1030,FB,B(1))
      CALL CLOSE (FB,CLSREW)
      GO TO 610
C
C     FILEA IS IDENTITY -
C
C     SPECIAL CASEs NEED TO BE CONSIDERED -
C     SIGNAB IS NEGATIVE, OR FILEB IS A DIAGONAL MATRIX
C     (FILEB CANNOT BE A ROW-VECTOR)
C
  400 CALL CLOSE (FA,CLSREW)
      IF (FORMB.EQ.DIAGNL .OR. SIGNAB.LT.0) GO TO 420
      FILE = SD(1)
      CALL OPEN (*1010,FA,A(BUF1),WRTREW)
      CALL REWIND (FB)
      CALL CPYFIL (FB,SD,A(1),NZ,K)
      CALL CLOSE (FB,CLSREW)
      CALL CLOSE (SD,CLSREW)
      IF (FC .EQ. 0) GO TO 410
      DO 405 I = 2,7
  405 SD(I) = FILEB(I)
      GO TO 800
  410 DO 415 I = 2,7
  415 FILED(I) = FILEB(I)
      GO TO 1100
C
C     SPECIAL CASE - FILEB IS A DIAGONAL MATRIX
C                    OR SIGNAB IS NEGATIVE
C
  420 CALL GOPEN (SD,A(BUF1),WRTREW)
      JU    = ROWB
      FILE  = FB
      TYPEU = TYPED*SIGNAB
      IF (FORMB .NE. DIAGNL) GO TO 430
      CALL UNPACK (*1050,FB,B)
      CALL CLOSE (FB,CLSREW)
      J  = 1
      DO 425 I = 1,ROWA
      IP = I
      JP = I
      CALL PACK (B(J),SD,SD)
  425 J = J + NWDS
      CALL CLOSE (SD,CLSREW)
      IF (FC) 800,950,800
C
C     SPECIAL CASE - SIGNAB IS NEGATIVE
C
  430 FILE = FB
      DO 435 I = 1,COLB
      CALL UNPACK (*1050,FB,B)
      CALL PACK (B,SD,SD)
  435 CONTINUE
      CALL CLOSE (SD,CLSREW)
      CALL CLOSE (FB,CLSREW)
      IF (FC) 800,950,800
C
C     FILEA IS A COLUMN MATRIX -
C     i.e. A (1,N) RECTANGULAR MATRIX OR A (Nx1) TRANSPOSE
C
C     FILEB MUST BE A (Nx1) RECTANGULAR MATRIX
C
C     CURRENTLY THIS CASE IS HANDLED IN MPYAD SUBROUINTE
C
C     HOWEVER, IF FILEB IS A ROW VECTOR,  IT IS HANDLED IN 600
C     IF FILEA IS A ROW VECTOR TRANSPOSE, IT IS HANDLED IN 200/350
C
C 440 CONTINUE
C
C                                         X   0   0      X
C     FILEB IS DIAGONAL -                 0   Y   0      Y
C                                         0   0   Z <==  Z
C                             a  e  i    aX  eY  iZ
C                             b  f  j    bX  fY  jZ
C                             c  g  k    cX  gY  kZ
C                             d  h  l    dX  hY  lZ
C
  490 FILE  = FB
      JU    = COLB
      TYPEU = TYPED*SIGNAB
      CALL UNPACK (*1050,FB,B)
      CALL CLOSE (FB,CLSREW)
      CALL GOPEN (SD,A(BUF2),WRTREW)
      FILE  = FA
      JU    = ROWA
      TYPEU = TYPED
      DO 590 I = 1,COLA
      CALL UNPACK (*1050,FA,A)
      GO TO (500,520,540,560) TYPEB
  500 DO 510 J = 1,ROWA
  510 C(J)  = A(J)*B(I)
      GO TO 580
  520 DO 530 J = 1,ROWA
  530 DC(J) = DA(J)*DB(I)
      GO TO 580
  540 DO 550 J = 1,ROWA2,2
      C(J  ) = A(J)*B(J  ) - A(J+1)*B(J+1)
  550 C(J+1) = A(J)*B(J+1) + A(J+1)*B(J  )
      GO TO 580
  560 DO 570 J = 1,ROWA2,2
      DC(J  ) = DA(J)*DB(J  ) - DA(J+1)*DB(J+1)
  570 DC(J+1) = DA(J)*DB(J+1) + DA(J+1)*DB(J  )
  580 CALL PACK (C,SD,SD)
  590 CONTINUE
      CALL CLOSE (AD,CLSREW)
      CALL CLOSE (SD,CLSREW)
      GO TO 800
C
C     FILEB IS A ROW VECTOR -                            E
C                                                        F
C     NOTE - FILEA MUST BE A               E   F   G <== G
C     ONE-COLUMN MATRIX.             a    aE  aF  aG
C     i.e. A(1xN) OR                 b    bE  bF  bG
C          A(Nx1) TRNASPOSE          c    cE  cF  cG
C                                    d    dE  dF  dG
C     WE ALREADY HANDLED THE CASE
C     WHERE FILEA IS A ROW-VECTOR TRANSPOSE IN 200
C
  600 FILE  = FB
      JU    = COLB
      TYPEU = TYPED*SIGNAB
      IF (T .EQ. 1) GO TO 602
      IF (COLA .NE. 1) GO TO 1030
      CALL UNPACK (*1050,FB,B)
      GO TO 608
  602 IF (ROWA .NE. 1) GO TO 1030
      J = COLA*NWDS
      DO 604 I = 1,J
  604 B(I) = 0.0
      J = 1
      DO 606 I = 1,COLA
      CALL UNPACK (*606,FB,B(J))
  606 J = J + NWDS
  608 CALL CLOSE (FB,CLSREW)
      FILE  = FA
      JU    = ROWA
      TYPEU = TYPED
      CALL UNPACK (*1050,FA,A)
      CALL CLOSE (AD,CLSREW)
      CALL GOPEN (FD,A(BUF1),WRTREW)
  610 DO 710 J = 1,COLB
      GO TO (620,640,660,680), TYPEA
  620 DO 630 I = 1,ROWA
  630 C(I) = A(I)*B(J)
      GO TO 700
  640 DO 650 I = 1,ROWA
  650 DA(I) = DA(I)*DB(J)
      GO TO 700
  660 DO 670 I = 1,ROWA2,2
      C(I  ) = A(I)*B(J  ) - A(I+1)*B(J+1)
  670 C(I+1) = A(I)*B(J+1) + A(I+1)*B(J  )
      GO TO 700
  680 DO 690 I = 1,ROWA2,2
      DC(I  ) = DA(I)*DB(J  ) - DA(I+1)*DB(J+1)
      DC(I+1) = DA(I)*DB(J+1) + DA(I+1)*DB(J  )
  690 KX = KX + NWDS
  700 CALL PACK (C,FD,FILED)
  710 CONTINUE
      CALL CLOSE (FD,CLSREW)
      GO TO 800
C
C     FILEB IS IDENTITY -
C
C     SPECIAL CASE NEEDS TO BE CONSIDERED -
C     NEGATIVE SIGNAB
C
  750 CALL CLOSE (FB,CLSREW)
      FILE = SD(1)
      CALL OPEN (*1010,SD,A(BUF2),WRTREW)
      IF (SIGNAB .LT. 0) GO TO 760
      CALL REWIND (FA)
      CALL CPYFIL (FA,SD,A(1),NZ,K)
      GO TO 770
C
  760 TYPEU = TYPED*SIGNAB
      JU    = ROWA
      FILE  = FA
      DO 765 I = 1,COLA
      CALL UNPACK (*1050,FA,A)
      CALL PACK (A,SD,SD)
  765 CONTINUE
  770 CALL CLOSE (FA,CLSREW)
      CALL CLOSE (SD,CLSREW)
      IF (FC) 800,950,800
C
C     NULL MATRIX PRODUCT A*B, COPY FILEC TO FILED
C
  780 FILE = FC
      CALL OPEN (*1010,FC,A(BUF1),RDREW)
      FILE = FD
      CALL OPEN (*1010,FD,A(BUF2),WRTREW)
      CALL CPYFIL (FC,FD,A(1),NZ,K)
      CALL CLOSE (FC,CLSREW)
      CALL CLOSE (FD,CLSREW)
      DO 790 I = 2,7
      FILED(I) = FILEC(I)
  790 CONTINUE
      GO TO 1100
C
C     ADD PRODUCT OF A*B TO C
C
  800 IF (FC .EQ. 0) GO TO 950
      CALL GOPEN (FD,A(BUF3),WRTREW)
      FILE = FC
      CALL OPEN (*1010,FC,A(BUF2),RDREW)
      CALL FWDREC (*1020,FC)
      FILE = SD(1)
      CALL OPEN (*1010,SD,A(BUF1),RDREW)
      CALL FWDREC (*1020,SD)
      JU   = ROWC
      TYPEP = TYPED
      DO 920 I = 1,COLC
      TYPEU = TYPED*SIGNC
      CALL UNPACK (*810,FC,C)
      GO TO 830
  810 DO 820 J = 1,ROWD2
  820 C(J) = 0.0
  830 TYPEU = TYPED
      CALL UNPACK (*840,SD,B)
      GO TO 860
  840 DO 850 J = 1,ROWD2
  850 B(J) = 0.0
  860 GO TO (870,890,870,890), TYPED
  870 DO 880 J = 1,ROWD2
  880 A(J) = B(J) + C(J)
      GO TO 910
  890 DO 900 J = 1,ROWD2
  900 DA(J) = DB(J) + DC(J)
  910 CALL PACK (A,FD,FILED)
  920 CONTINUE
      CALL CLOSE (FC,CLSREW)
      CALL CLOSE (SD,CLSREW)
C
  950 IF (COLD .NE. 0) GO TO 970
      DO 960 I = 2,7
  960 FILED(I) = SD(I)
  970 CALL CLOSE  (FD,CLSREW)
      CALL WRTTRL (FILED)
      GO TO 1100
C
C     ERROR
C
  990 WRITE  (NOUT,1000) SFM
 1000 FORMAT (A25,'. MPYDRI DOES NOT HANDLE A-TRANSPOSE. SHOULD NOT BE',
     1       ' CALLED BY MPYAD')
      GO TO 1070
 1010 J = -1
      GO TO 1080
 1020 J = -2
      GO TO 1080
 1030 WRITE  (NOUT,1040) UFM
 1040 FORMAT (A23,' FROM MPYAD/MPYDRI.  FILES NOT COMPATIBLE')
      GO TO 1070
 1050 WRITE  (NOUT,1060) UFM
 1060 FORMAT (A23,' FROM MPYAD/MPYDRI.  NULL COLUMN ENCOUNTERED DURING',
     1        ' MATRIX UNPACK')
 1070 J = -37
 1080 CALL MESAGE (J,FILE,NAME)
C
 1100 RETURN
      END

      SUBROUTINE STRM61
C
C
C   PHASE I OF  STRESS DATA RECOVERY FOR TRIANGULAR MEMBRANE ELEMENT TRI
C
C   OUTPUTS FROM THIS PHASE FOR USE IN PHASE II ARE THE FOLLOWING
C
C   1) ELEMENT ID             WORDS    1    STORAGE IN PH1OUT   1
C   2) SIX SILS               WORDS    6                        2-7
C   3) THICKNESS T1           WORDS    1                        8
C   4) THICKNESS T2           WORDS    1                        9
C   5) THICKNESS T3           WORDS    1                       10
C   6) REFERENCE TEMP T0      WORDS    1                       11
C   7) S SUB I MATRICES       WORDS    216                     12-227
C   8) THERMAL VECTOR G ALF   WORDS    3                      228-230
C
C    EST ENTRIES SAME AS IN SUBROUTINE KTRM6S
C
C
      REAL NSM,IVECT,JVECT,KVECT
C
      DIMENSION IEST(45),IND(6,3),EE1(6),NPH1OU(990),XC(6),YC(6),ZC(6)
     1,   Q(6,6),QQ(36),IVECT(3),JVECT(3),KVECT(3),E( 6 ),EPH1(6)
     2,   NAME(2),ICS(6),NL(6),TRANS(9),BALOTR(9),EMOD(9),TM(3,12)
     3,   TMM(36)
C
      COMMON /SDR2X5/ EST(100),PH1OUT(250)
      COMMON /MATIN / MATID,MATFLG,ELTEMP,PLA34,SINTH,COSTH
      COMMON /MATOUT/ EM(6),RHOY,ALF(3),TREF,GSUBE,SIGTY,SIGCY,SIGSY
C
      EQUIVALENCE (NPH1OU(1),PH1OUT(1)),(IEST(1),EST(1))
      EQUIVALENCE (TM(1,1),TMM(1))
C
      DATA NAME /4HSTRM,4H61  / , BLANK  /4H    /
      DATA DEGRA /0.0174532925/
C
      IDELE=IEST(1)
      DO 109 I=1,6
      NL(I)=IEST(I+1)
  109 CONTINUE
      THETAM=EST(8)
      MATID1=IEST(9)
      TMEM1 =EST(10)
      TMEM3 =EST(11)
      TMEM5 =EST(12)
C
C   IF TMEM3 OR TMEM5 IS 0.0 OR BLANK , IT WILL BE SET EQUAL TO TMEM1
C
      IF (TMEM3.EQ.0.0. OR .TMEM3.EQ.BLANK)  TMEM3 = TMEM1
C
      IF (TMEM5.EQ.0.0. OR .TMEM5.EQ.BLANK)  TMEM5 = TMEM1
C
      NSM = EST(13)
C
      J=0
      DO 120 I=14,34,4
      J=J+1
      ICS(J)=IEST(I)
      XC(J) = EST(I+1)
      YC(J) = EST(I+2)
      ZC(J)=EST(I+3)
  120 CONTINUE
      ELTEMP=(EST(38)+EST(39)+EST(40)+EST(41)+EST(42)+EST(43))/6.0
      THETA1=THETAM*DEGRA
      SINTH=SIN(THETA1)
      COSTH=COS(THETA1)
      IF (ABS(SINTH).LE.1.0E-06) SINTH=0.0
C
C
C   EVALUATE MATERIAL PROPERTIES
C
      MATFLG = 2
      MATID  = MATID1
      CALL MAT (IDELE)
      TO=TREF
C
C   CALCULATIONS FOR THE TRIANGLE
C
      CALL TRIF (XC,YC,ZC,IVECT,JVECT,KVECT,DISTA,DISTB,DISTC,IEST(1),
     1           NAME)
C
C   TRANSFORMATION MATRIX BETWEEN ELEMENT AND BASIC CO-ORDINATES
C
      E(1)=IVECT(1)
      E(2)=JVECT(1)
      E(3)=IVECT(2)
      E(4)=JVECT(2)
      E(5)=IVECT(3)
      E(6)=JVECT(3)
C
C   CALCULATIONS FOR  Q MATRIX AND ITS INVERSE
C
      DO 110 I=1,6
      DO 110 J=1,6
      Q(I,J)=0.0
  110 CONTINUE
      DO 115 I=1,6
      Q(I,1)=1.0
      Q(I,2)=XC(I)
      Q(I,3)=YC(I)
      Q(I,4)=XC(I)*XC(I)
      Q(I,5)=XC(I)*YC(I)
      Q(I,6)=YC(I)*YC(I)
  115 CONTINUE
C
C     FIND INVERSE OF Q  MATRIX
C
C     NO NEED TO COMPUTE DETERMINANT SINCE IT IS NOT USED SUBSEQUENTLY.
      ISING = -1
      CALL INVERS (6,Q,6,QQ(1),0,DETERM,ISING,IND)
C
C   ISING EQUAL TO 2 IMPLIES THAT Q MATRIX IS SINGULAR
C
      DO 152 I=1,6
      DO 152 J=1,6
      IJ=(I-1)*6+J
      QQ(IJ)=Q(I,J)
  152 CONTINUE
      DO 154 I=1,9
      BALOTR(I)=0.0
  154 CONTINUE
C
      DO 102 I=1,7
      PH1OUT(I)=EST(I)
  102 CONTINUE
      PH1OUT(8)=EST(10)
      PH1OUT(9)=EST(11)
      PH1OUT(10)=EST(12)
      PH1OUT(11)=TO
      EMOD(1)=EM(1)
      EMOD(2)=EM(2)
      EMOD(3)=EM(3)
      EMOD(4)=EM(2)
      EMOD(5)=EM(4)
      EMOD(6)=EM(5)
      EMOD(7)=EM(3)
      EMOD(8)=EM(5)
      EMOD(9)=EM(6)
C
C   STRESSES AND STRAINS ARE EVALUATED AT FOUR POINTS ,VIZ., THE THREE
C   CORNER GRID POINTS AND THE CENTROID
C
      DO 700 JJ=1,4
      J=2*(JJ-1)+1
      IF (J.EQ.7) GO TO 103
      X=XC(J)
      Y=YC(J)
      GO TO 104
  103 X=(XC(1)+XC(3)+XC(5))/3.0
      Y=(YC(1)+YC(3)+YC(5))/3.0
  104 CONTINUE
      DO 105 I=1,36
      TMM(I)=0.0E0
  105 CONTINUE
C
C   TM MATRIX IS THE PRODUCT OF B AND QINVERSE MATRICES
C
      DO 258 J=1,6
      J1=(J-1)*2+1
      J2=J1+1
      TM(1,J1)=Q(2,J)+2.0*X*Q(4,J)+Y*Q(5,J)
      TM(2,J2)=Q(3,J)+X*Q(5,J)+2.0*Y*Q(6,J)
      TM(3,J1)=TM(2,J2)
      TM(3,J2)=TM(1,J1)
  258 CONTINUE
      DO 600 II=1,6
      IF (ICS(II).EQ.0) GO TO 130
      CALL TRANSS (IEST(4*II+10),TRANS)
      CALL GMMATS (E,3,2,+1,TRANS,3,3,0,EE1)
      GO TO 133
  130 CONTINUE
      DO 132 I=1,3
      DO 132 J=1,2
      I1=(I-1)*2+J
      J1=(J-1)*3+I
      EE1(J1)=E(I1)
  132 CONTINUE
  133 CONTINUE
      IJ1=(JJ-1)*54+(II-1)*9+12
      MZ=(II-1)*6+1
      CALL GMMATS (EMOD,3,3,0,TMM(MZ),2,3,+1,EPH1)
      CALL GMMATS (EPH1,3,2,0,EE1,2,3,0,PH1OUT(IJ1))
  600 CONTINUE
  700 CONTINUE
      CALL GMMATS (EMOD,3,3,0,ALF,3,1,0,PH1OUT(228))
      RETURN
      END

      SUBROUTINE SHTRMD (*,ELID,MM,NNODE,XI,ETA,GPTH,EPNORM,EGPDT,
     1                   IORDER,MMN,DETERM,TH,SHP,TIE,BTERMS)
C
C     TO CONSTRUCT THE JACOBIAN, SET UP INTEGRATION POINT COORD.
C     SYSTEM, AND CALCULATE [B] TERMS FOR THE ISOPARAMETRIC QUADRATIC
C     QUAD8 AND TRIA6 SHELL ELEMENTS
C     =====     =====
C
C        *********************************************************
C        *                                                       *
C        *  PRESENTLY COSMIC/NASTRAN DOES NOT USE THIS ROUTINE   *
C        *                                                       *
C        *********************************************************
C
C     INPUT :
C           ELID     - ELEMENT ID
C           MM       - MAXIMUM NO. OF NODES FOR THIS TYPE ELEMENT
C           NNODE    - THE NO. OF PRESENT NODES
C           XI
C           ETA      - INTEGERATION POINT COORDINATES
C           GPTH     - GRID POINT THICKNESSES
C           EPNORM   - GRID POINT NORMALS IN ELEMENT COORD. SYSTEM
C           EGPDT    - GRID POINT DATA IN ELEMENT COORD. SYSTEM
C           IORDER   - REORDERING ARRAY
C           MMN      - MISSING MIDSIDE NODE INDICATOR
C     OUTPUT:
C           DETERM   - DETERMINANT OF JACOBIAN
C           TH       - THICKNESS AT THIS INTEGRATION POINT
C           SHP      - ARRAY OF SHAPE FUNCTIONS
C           TIE      - TRANSFORMATION BETWEEN INTEG. PT. AND ELEMENT
C                      COORD. SYSTEMS
C           BTERMS   - TERMS OF [B] (DERIVATIVES OF SHAPE FUNCTIONS
C                      WITH RESPECT TO XYZ OF ELEMENT COORD. SYSTEM)
C
      LOGICAL          BADJAC
      INTEGER          IORDER(1),MMN(1),ELID
      DOUBLE PRECISION EGPDT(4,1),EPNORM(4,1),DETERM,XI,ETA,HZTA,DETJ,
     1                 SHP(10),JACOB(3,3),DSHPX(10),DSHPE(10),DSHP(16),
     2                 TSHP(8),TDSHP(16),BTERMS(1),PSITRN(9),TIE(9),
     3                 GPTH(1),TH
      COMMON /Q8T6DT/  DETJ,HZTA,PSITRN,NN1,BADJAC,NN2
C
C
C     DOUBLE PRECISION VERSION
C
      IF (MM .EQ. 8) GO TO 10
      IF (MM .EQ. 6) GO TO 20
      GO TO 80
C
C     QUAD8 VERSION
C
   10 CALL Q8SHPD (MMN,XI,ETA,SHP,DSHP)
      GO TO 30
C
C     TRIA6 VERSION
C
   20 CALL T6SHPD (XI,ETA,MMN,SHP,DSHPX,DSHPE)
      DO 25 I = 1,MM
      DSHP(I   ) = DSHPX(I)
   25 DSHP(I+MM) = DSHPE(I)
C
   30 DO 40 I = 1,MM
      TSHP (I) = SHP (I)
      TDSHP(I) = DSHP(I)
   40 TDSHP(I+MM) = DSHP(I+MM)
      DO 45 I = 1,MM
      IO = IORDER(I)
      SHP (I) = TSHP(IO)
      DSHP(I) = TDSHP(IO)
   45 DSHP(I+MM) = TDSHP(IO+MM)
C
      TH = 0.0D0
      DO 50 I = 1,NNODE
   50 TH = TH + GPTH(I)*SHP(I)
C
      NN1 = NNODE
      NN2 = MM
      HZTA = 0.0D0
      CALL JACOBD (ELID,SHP,DSHP,GPTH,EGPDT,EPNORM,JACOB)
      IF (BADJAC) GO TO 80
C
      DETERM = DETJ
      DO 60 I = 1,9
   60 TIE(I) = PSITRN(I)
C
      IJ = 1
      DO 70 I = 1,2
      DO 70 J = 1,NNODE
      BTERMS(IJ) = JACOB(I,1)*DSHP(J) + JACOB(I,2)*DSHP(J+MM)
   70 IJ = IJ + 1
      RETURN
C
   80 RETURN 1
C
C
      ENTRY SHTRMS (*,ELID,MM,NNODE,XI,ETA,GPTH,EPNORM,EGPDT,
     1                   IORDER,MMN,DETERM,TH,SHP,TIE,BTERMS)
C     =======================================================
C
C     SINGLE PRELCISION VERSION
C
      GO TO 80
      END

      SUBROUTINE SQDM11
C
C     PHASE I OF STRESS DATA RECOVERY FOR THE  QUADRILATERAL MEMBRANE
C     ELEMENT
C
C     CALLS FROM THIS ROUTINE ARE MADE TO
C
C            MAT    - MATERIAL DATA ROUTINE
C            MESAGE - ERROR MESSAGE WRITER
C            GMMATS - SINGLE MATRIX MULTIPLY AND TRANSPOSE
C            TRANSS - SINGLE PRECISION TRANSFORMATION SUPPLIER
C
C
      REAL            LA,LB,LC,LD,LDD2,LBD1,LCD1,LCD2,MAGI,MAGJ,MAGK
      DIMENSION       ECPT(26),EE(144)
      COMMON /SYSTEM/ DUMMY(39),NBPW
      COMMON /CONDAS/ CONSTS(5)
      COMMON /SDR2X5/ NECPT(1),NGRID(4),ANGLE,MATID1,T,FMU,
     2                DUMMY1,X1,Y1,Z1,DUMMY2,X2,Y2,Z2,
     4                DUMMY3,X3,Y3,Z3,DUMMY4,X4,Y4,Z4,DUMB(75),
     6                PH1OUT(100),FORVEC(25)
      COMMON /SDR2X6/ E(9),TI(9),THETA,TEMPAR(150),A(24),G(9),B(96)
      COMMON /MATIN / MATID,INFLAG,ELTEMP,STRESS,SINTH,COSTH
      COMMON /MATOUT/ G11,G12,G13,G22,G23,G33,RHO,ALPHAS(3),TSUB0,GSUBE,
     1                SIGTEN,SIGCOM,SIGSHE,G2X211,G2X212,G2X222
      EQUIVALENCE     (CONSTS(4),DEGRA),(ECPT(1),NECPT(1))
C
C
C      ECPT LIST
C                                                      IN
C                                                      THIS
C        ECPT       DESCRIPTION                        ROUTINE    TYPE
C     *******    *********************************     ********  ******
C     ECPT( 1) = ELEMENT ID                            NECPT(1)  INTEGER
C     ECPT( 2)   GRID POINT A                          NGRID(1)  INTEGER
C     ECPT( 3)   GRID POINT B                          NGRID(2)  INTEGER
C     ECPT( 4)   GRID POINT C                          NGRID(3)  INTEGER
C     ECPT( 5)   GRID POINT D                          NGRID(4)  INTEGER
C     ECPT( 6) = THETA = ANGLE OF MATERIAL             ANGLE      REAL
C     ECPT( 7)   MATERIAL ID                           MATID     INTEGER
C     ECPT( 8) = THICKNESS                             T          REAL
C     ECPT( 9) = NON-STRUCTURAL MASS                   FMU        REAL
C     ECPT(10)   COORD. SYSTEM ID 1                    NECPT(10) INTEGER
C     ECPT(11) = X1                                     X1        REAL
C     ECPT(12) = Y1                                     Y1        REAL
C     ECPT(13) = Z1                                     Z1        REAL
C     ECPT(14)   COORD. SYSTEM ID 2                    NECPT(14) INTEGER
C     ECPT(15) = X2                                     X2        REAL
C     ECPT(16) = Y2                                     Y2        REAL
C     ECPT(17) = Z2                                     Z2        REAL
C     ECPT(18)   COORD. SYSTEM ID 3                    NECPT(18) INTEGER
C     ECPT(19) = X3                                     X3        REAL
C     ECPT(20) = Y3                                     Y3        REAL
C     ECPT(21) = Z3                                     Z3        REAL
C     ECPT(22)   COORD. SYSTEM ID 4                    NECPT(22) INTEGER
C     ECPT(23) = X4                                     X4        REAL
C     ECPT(24) = Y4                                     Y4        REAL
C     ECPT(25)   Z4                                     Z4        REAL
C     ECPT(26) = ELEMENT TEMPERATURE                    ECPT(26)  REAL
C
C
C     SET UP THE E MATRIX WHICH IS (12X12) FOR THE QUAD-MEMBRANE PROJECT
C                         ONTO THE MEAN PLANE
C
      DO 2 I = 1,144
      EE(I) = 0.
    2 CONTINUE
C
C     E(1), E(4), E(7) WILL BE THE I-VECTOR
C     E(2), E(5), E(8) WILL BE THE J-VECTOR
C     E(3), E(6), E(9) WILL BE THE K-VECTOR
C
C     COMPUTE DIFFERENCES OF COORDINATES OF ACTUAL GRID POINTS
C
      X21 = X2 - X1
      Y21 = Y2 - Y1
      Z21 = Z2 - Z1
      X31 = X3 - X1
      Y31 = Y3 - Y1
      Z31 = Z3 - Z1
      X41 = X4 - X1
      Y41 = Y4 - Y1
      Z41 = Z4 - Z1
      X42 = X4 - X2
      Y42 = Y4 - Y2
      Z42 = Z4 - Z2
C
C     COMPUTE ELEMENTS OF THE E MATRIX (3X3)
C
      PK1 = Y31*Z42 - Z31*Y42
      PK2 = Z31*X42 - X31*Z42
      PK3 = X31*Y42 - Y31*X42
      MAGK= SQRT(PK1**2 + PK2**2 + PK3**2)
      IF (MAGK .GT. 1.0E-06) GO TO 40
      CALL MESAGE (-30,32,ECPT(1))
   40 PK1 = PK1/MAGK
      PK2 = PK2/MAGK
      PK3 = PK3/MAGK
C
C     HH IS THE MEASURE OF NON-PLANARITY OF THE ELEMENT
C
      HH  = X21*PK1 + Y21*PK2 + Z21*PK3
      PI1 = X21 - HH*PK1
      PI2 = Y21 - HH*PK2
      PI3 = Z21 - HH*PK3
      MAGI= SQRT(PI1**2 + PI2**2 + PI3**2)
      IF (MAGI .GT. 1.0E-06) GO TO 41
      CALL MESAGE (-30,31,ECPT(1))
   41 PI1 = PI1/MAGI
      PI2 = PI2/MAGI
      PI3 = PI3/MAGI
      HH  =-HH/2.
C
C     THIS SIGN CHANGE MADE BECAUSE SIGN OF H AS DEFINED ON
C     PAGE 4.87-105 OF PROGRAMMERS MANUAL IS WRONG
C
      PJ1 = PK2*PI3 - PK3*PI2
      PJ2 = PK3*PI1 - PK1*PI3
      PJ3 = PK1*PI2 - PK2*PI1
      MAGJ= SQRT(PJ1**2 + PJ2**2 + PJ3**2)
      PJ1 = PJ1/MAGJ
      PJ2 = PJ2/MAGJ
      PJ3 = PJ3/MAGJ
      E(1)= PI1
      E(2)= PJ1
      E(3)= PK1
      E(4)= PI2
      E(5)= PJ2
      E(6)= PK2
      E(7)= PI3
      E(8)= PJ3
      E(9)= PK3
C
C     STORE FOUR (3X3) E MATRICES INTO (12X12) E MATRIX
C
      LLCT = -39
      DO 5 IICT = 1,12,3
      LLCT = LLCT + 39
      NNCT = 0
      MMCT =-12
      DO 4 JJCT = 1,3
      MMCT = MMCT + 12
      DO 3 KKCT = 1,3
      NNCT = NNCT + 1
      KTOT = KKCT + LLCT + MMCT
      EE(KTOT) = E(NNCT)
    3 CONTINUE
    4 CONTINUE
    5 CONTINUE
C
C     COMPUTE DIFFERENCES OF COORDINATES OF GRID POINTS IN THE MEAN PLAN
C
      X12 =-(X21*E(1) + Y21*E(4) + Z21*E(7))
      X13 =-(X31*E(1) + Y31*E(4) + Z31*E(7))
      X14 =-(X41*E(1) + Y41*E(4) + Z41*E(7))
      Y3A = (X31*E(2) + Y31*E(5) + Z31*E(8))
      Y4A = (X42*E(2) + Y42*E(5) + Z42*E(8))
      X24 = X14 - X12
      X23 = X13 - X12
      X34 = X14 - X13
      Y34 = Y3A - Y4A
C
C
C     COMPUTE LENGTHS OF SIDES OF ELEMENT IN THE MEAN PLANE
C
      LA = ABS(X12)
      LB = SQRT(X23**2 + Y3A**2)
      LC = SQRT(X34**2 + Y34**2)
      LD = SQRT(X14**2 + Y4A**2)
C
C     COMPUTE THE CHARACTERISTIC ANGLES OF ELEMENT IN THE MEAN PLANE
C
      CTH1  =-X14/LD
      STH1  = Y4A/LD
      CTH2  = X23/LB
      STH2  = Y3A/LB
      CTH31 = X34/LC
      STH31 =-Y34/LC
      CTH41 = CTH1
      STH41 = STH1
      CTH32 = STH2
      STH32 = CTH2
      CTH42 = STH31
      STH42 = CTH31
C
      DLT1  = CTH31*CTH32 - STH31*STH32
      DLT2  = CTH42*CTH41 + STH41*STH42
      LDD2  = LD*DLT2
      LBD1  = LB*DLT1
      LCD1  = LC*DLT1
      LCD2  = LC*DLT2
C
C                                                  *       *
C     COMPUTE THE INTERSECTION OF THE DIAGONALS(ETA  AND XI ) OF
C     THE ELEMENTS IN THE MEAN PLANE
C
      TOL  = 1.0E-3*(-X12)
      IF (NBPW .GE. 60) TOL  = 1.0E-5*(-X12)
      TOL2 = 1.0E-3*X12*X12
      IF (NBPW .GE. 60) TOL2 = 1.0E-5*X12*X12
      IF (ABS(X34+X12).GT.TOL .OR. ABS(Y34).GT.TOL) GO TO 6
      ETAS =.5
      XIS  =.5
      GO TO 16
    6 IF (ABS(X24).LT.TOL .OR. ABS(X13).LT.TOL) GO TO 7
      XSTAR = (Y4A*X13*X12)/((Y3A*X24)-(Y4A*X13))
      YSTAR = (-Y4A/X24)*(XSTAR+X12)
      GO TO 9
    7 IF (ABS(X13) .GT. TOL) GO TO 8
      XSTAR = -X13
      YSTAR = (-Y4A/X24)*X12
      GO TO 9
    8 XSTAR = -X12
      YSTAR = (Y3A/X13)*X12
    9 IF (ABS(X34+X12) .LT. TOL) GO TO 13
      C1 = Y34*XSTAR - YSTAR*(X34+X12)
      A2 =-Y4A*X23 + Y3A*X14
      B2 =-Y4A*X12 + C1
      IF (ABS(A2) .LE. TOL2) GO TO 10
      TEMP2 = SQRT(B2**2-(4.*A2*X12*YSTAR))/(2.*A2)
      TEMP1 =-B2/(2.*A2)
      ETAS  = TEMP1 - TEMP2
      IF (ETAS.LE.0. .OR. ETAS.GE.1.) ETAS = TEMP1 + TEMP2
      GO TO 11
   10 ETAS = (-X12*YSTAR)/B2
   11 IF (ABS(Y34) .LT. TOL) GO TO 12
      XIS = (-C1 + ((Y4A*X23) - (Y3A*X14))*ETAS)/(Y34*X12)
      GO TO 16
   12 XIS = (XSTAR + (X14*ETAS))/((ETAS*(X34+X12)) - X12)
      GO TO 16
   13 A3 = -X14*Y34
      B3 =  X12*Y4A - Y34*XSTAR
      IF (ABS(A3) .LE. TOL2) GO TO 14
      TEMP2 = SQRT(B3**2 + (4.*A3*X12*YSTAR))/(2.*A3)
      TEMP1 = -B3/(2.*A3)
      ETAS  = TEMP1 - TEMP2
      IF (ETAS.LE.0. .OR. ETAS.GE.1.) ETAS = TEMP1 + TEMP2
      GO TO 15
   14 ETAS = (X12*YSTAR)/B3
   15 XIS  = (YSTAR - (Y4A*ETAS))/(Y34*ETAS)
C
C     SET UP THE (12X12) TRANSFORMATION MATRIX B BETWEEN THE MEAN PLANE
C                        AND ACTUAL GRID POINTS
C
   16 DO 17 I = 2,92
      B(I)  = 0.
   17 CONTINUE
      B(1)  = 1.
      B(10) = 1.
      B(17) =-HH/LA
      B(18) =-HH/(LD*STH1) + ((HH*CTH1)/(LA*STH1))
      B(19) = HH/LA
      B(20) = (HH*CTH2)/(LA*STH2)
      B(23) = (HH*CTH42)/LDD2
      B(24) = (HH*STH42)/LDD2
      B(27) = 1.
      B(36) = 1.
      B(41) =-B(17)
      B(42) = (-HH*CTH1)/(LA*STH1)
      B(43) = B(17)
      B(44) = ((-HH*CTH2)/(LA*STH2)) + (HH/(LB*STH2))
      B(45) = (-HH*STH31)/LBD1
      B(46) = (-HH*CTH31)/LBD1
      B(53) = 1.
      B(62) = 1.
      B(68) =-HH/(LB*STH2)
      B(69) = HH*((STH31/LBD1) + (CTH32/LCD1))
      B(70) = HH*((CTH31/LBD1) + (STH32/LCD1))
      B(71) = (-HH*STH41)/LCD2
      B(72) = (HH*CTH41)/LCD2
      B(79) = 1.
      B(88) = 1.
      B(90) = HH/(LD*STH1)
      B(93) = (-HH*CTH32)/LCD1
      B(94) = (-HH*STH32)/LCD1
      B(95) = HH*((-CTH42/LDD2) + (STH41/LCD2))
      B(96) = HH*((-STH42/LDD2) - (CTH41/LCD2))
      DO 18 I = 1,24
      A(I)  = 0.
   18 CONTINUE
C                                                     T
C     COMPUTE TRANSFORMED MATRIX OF STIFFNESSES  G = P  * G * P
C
      THETA  = ANGLE*DEGRA
      SINTH  = SIN(THETA)
      COSTH  = COS(THETA)
      IF (ABS(SINTH) .LT. 1.0E-06) SINTH = 0.0E0
      MATID  = MATID1
      INFLAG = 2
      ELTEMP = ECPT(26)
      CALL MAT (ECPT(1))
C
C     STORE INTO G MATRIX
C
      G(1) = G11
      G(2) = G12
      G(3) = G13
      G(4) = G12
      G(5) = G22
      G(6) = G23
      G(7) = G13
      G(8) = G23
      G(9) = G33
C
C     COMPUTE MATRIX A TO RELATE DISPLACEMENTS TO STRAINS
C
      AJ    = (-Y4A*X12) + (-Y34*X12*XIS) + ETAS*((-Y4A*X23)+(Y3A*X14))
      A(1)  = (-Y4A + (Y3A*ETAS) - (Y34*XIS))/AJ
      A(3)  = ( Y4A - (Y4A*ETAS) + (Y34*XIS))/AJ
      A(5)  = ( Y4A*ETAS)/AJ
      A(7)  = (-Y3A*ETAS)/AJ
      A(10) = (-X24 + (X23*ETAS) + (X34*XIS))/AJ
      A(12) = ( X14 - (X14*ETAS) - (X34*XIS))/AJ
      A(14) = ((X14*ETAS) - (X12*XIS))/AJ
      A(16) = (-X12 - (X23*ETAS) + (X12*XIS))/AJ
      A(17) = (-X24 + (X23*ETAS) + (X34*XIS))/AJ
      A(18) = (-Y4A + (Y3A*ETAS) - (Y34*XIS))/AJ
      A(19) = ( X14 - (X14*ETAS) - (X34*XIS))/AJ
      A(20) = ( Y4A - (Y4A*ETAS) + (Y34*XIS))/AJ
      A(21) = ((X14*ETAS) - (X12*XIS))/AJ
      A(22) = (Y4A*ETAS)/AJ
      A(23) = (-X12 - (X23*ETAS) + (X12*XIS))/AJ
      A(24) = (-Y3A*ETAS)/AJ
C
C                          T    T
C     COMPUTE S = G * A * B  * E
C
      CALL GMMATS (B(1),12,8,1,EE(1),12,12,1,TEMPAR(1))
      CALL GMMATS (A(1),3,8,0,TEMPAR(1),8,12,0,TEMPAR(100))
      CALL GMMATS (G(1),3,3,0,TEMPAR(100),3,12,0,TEMPAR(1))
      DO 27 L = 1,4
      DO 19 N = 2,5
      IF (NECPT(N) .NE. NGRID(L)) GO TO 19
      KA = 4*N + 2
      GO TO 20
   19 CONTINUE
      CALL MESAGE (-30,34,ECPT(1))
   20 IF (NECPT(KA) .EQ. 0) GO TO 21
      CALL TRANSS (NECPT(KA),TI)
      GO TO 23
   21 DO 22 II = 1,9
      TI(II) = 0.
   22 CONTINUE
      TI(1) = 1.
      TI(5) = 1.
      TI(9) = 1.
   23 LCNT  = 3*(L-1)
      IROWCT= -12
      NN    = 0
      DO 25 JJ = 1,3
      IROWCT= IROWCT + 12
      DO 24 KK = 1,3
      NN   = NN + 1
      KTOT = KK + IROWCT + LCNT
      NN49 = NN + 49
      TEMPAR(NN49) = TEMPAR(KTOT)
   24 CONTINUE
   25 CONTINUE
      CALL GMMATS (TEMPAR(50),3,3,0,TI,3,3,0,TEMPAR(60))
C
C                                                          TH
C     MATRICES S  RELATE DISPLACEMENTS TO STRESSES AT THE I   GRIDPOINT
C               I
C
      DO 26 IL = 1,9
      KTOT = IL + 9*L
      IL59 = IL + 59
      PH1OUT(KTOT) = TEMPAR(IL59)
   26 CONTINUE
   27 CONTINUE
      CALL GMMATS (G(1),3,3,0,ALPHAS(1),3,1,0,PH1OUT(7))
      PH1OUT(1) = ECPT(1)
      PH1OUT(2) = ECPT(2)
      PH1OUT(3) = ECPT(3)
      PH1OUT(4) = ECPT(4)
      PH1OUT(5) = ECPT(5)
      PH1OUT(6) = TSUB0
      RETURN
      END

      SUBROUTINE INVERT( IA,IB,SCR1)
C
C     DRIVER  FOR  INVTR
C
C     INVERTS  LOWER OR UPPER TRIANGLE  IA  ONTO  IB
C
C     SCR1 WILL BE USED  ONLY IF  IA  IS AN  UPPER  TRIANGLE
C
      INTEGER  FA,FB,SCRFIL,PREC,SCR1,NAME(2)
C
      COMMON /INVTRX/ FA(7),FB(7),SCRFIL,NX,PREC
      COMMON / ZZZZZZ/ Z(1)
C
      DATA NAME /4HINVE,4HRT  /
C
C     FILL  MATRIX  CONTROL  BLOCKS  FOR  A  AND  B
C
      FA(1) = IA
      CALL RDTRL(FA)
      FB(1) = IA
      CALL RDTRL(FB)
      FB(1) = IB
      SCRFIL = SCR1
      PREC = FA(5)
      NX  =  KORSZ(Z)
      CALL INVTR(*50,Z,Z)
      CALL WRTTRL(FB)
      RETURN
C
C     SINGULAR  MATRIX
C
   50 CALL MESAGE(-5,FA,NAME)
      GO TO 50
      END

      SUBROUTINE HRING (POINTS)
C
C     HEAT CONDUCTIVITY SMA1 ROUITNE FOR TRIANGULAR (POINTS=3) AND
C     TRAPEZOIDAL (POINTS=4) RING ELEMENTS.
C     THIS ROUTINE IS SEPARATE FROM KTRAPR AND KTRIRG SO AS TO BE
C     IN OVERLAY WITH KTRMEM AND KQDMEM.
C
      LOGICAL         NOGO
      INTEGER         POINTS  ,OUTPT   ,SYSBUF  ,TINT    ,MAP(15)
      CHARACTER       UFM*23  ,UWM*25  ,UIM*29  ,SFM*25  ,SWM*27
      COMMON /XMSSG / UFM     ,UWM     ,UIM     ,SFM     ,SWM
      COMMON /SYSTEM/ SYSBUF  ,OUTPT   ,NOGO
      COMMON /SMA1ET/ ECPT(100)
      EQUIVALENCE     (T,TINT)
      DATA    PI23  / 2.0943951024E0 /
      DATA    MAP   / 1,2,3, 1,2,3, 2,3,4, 3,4,1, 4,1,2 /
C
C     ECPT LISTS
C
C     ECPT     TRIRG -------- TRMEM          TRAPRG ------- QDMEM
C     ===========================================================
C      1       EL-ID          EL-ID          EL-ID          EL-ID
C      2       SIL-1          SIL-1          SIL-1          SIL-1
C      3       SIL-2          SIL-2          SIL-2          SIL-2
C      4       SIL-3          SIL-3          SIL-3          SIL-3
C      5       THETA          THETA          SIL-4          SIL-4
C      6       MATID          MATID          THETA          THETA
C      7       CSID-1         T              MATID          MATID
C      8       X1             NS-MASS        CSID-1         T
C      9       Y1             CSID-1         X1             NS-MASS
C     10       Z1             X1             Y1             CSID-1
C     11       CSID-2         Y1             Z1             X1
C     12       X2             Z1             CSID-2         Y1
C     13       Y2             CSID-2         X2             Z1
C     14       Z2             X2             Y2             CSID-2
C     15       CSID-3         Y2             Z2             X2
C     16       X3             Z2             CSID-3         Y2
C     17       Y3             CSID-3         X3             Z2
C     18       Z3             X3             Y3             CSID-3
C     19       AVG-TEMP       Y3             Z3             X3
C     20                      Z3             CSID-4         Y3
C     21                      AVG-TEMP       X4             Z3
C     22                                     Y4             CSID-4
C     23                                     Z4             X4
C     24                                     AVG-TEMP       Y4
C     25                                                    Z4
C     26                                                    AVG-TEMP
C
C     GEOMETRY CHECKS  X  MUST BE .GT.0, AND Y  = 0  FOR I = 1,2,..,PTS.
C                       I                     I
C
      I1 = POINTS + 4
      I2 = I1 + 4*POINTS - 1
      DO 100 I = I1,I2,4
      IF (ECPT(I+1)) 900,900,90
   90 IF (ECPT(I+2)) 900,100,900
  100 CONTINUE
C
C     POINT ORDERING CHECK.
C
      IF (POINTS .EQ. 4) GO TO 200
      I1 = 1
      I2 = 3
      GO TO 300
  200 I1 = 4
      I2 = 15
  300 JPOINT = POINTS + 1
      DO 600 I = I1,I2,3
      IR = MAP(I  )*4 + JPOINT
      IS = MAP(I+1)*4 + JPOINT
      IT = MAP(I+2)*4 + JPOINT
      TEMP = (ECPT(IS) - ECPT(IR))*(ECPT(IT+2) - ECPT(IS+2))  -
     1       (ECPT(IT) - ECPT(IS))*(ECPT(IS+2) - ECPT(IR+2))
      IF (TEMP) 900,900,600
  600 CONTINUE
C
C     TRAPEZOID TEST.
C
      IF (POINTS .NE. 4) GO TO 700
      IF (ECPT(11)-ECPT(15)) 650,640,650
  640 IF (ECPT(19)-ECPT(23)) 650,670,650
  650 CALL PAGE2 (-2)
      WRITE  (OUTPT,660) SWM,ECPT(1)
  660 FORMAT (A27,' 2158, A TRAPRG ELEMENT =',I14,
     1       ' DOES NOT HAVE SIDE 1-2 PARALLEL TO SIDE 3-4.')
C
C     THICKNESS OF TRMEM OR QDMEM TO BE CALLED BELOW.
C     QDMEM WILL SUBDIVIDE THICKNESS FOR SUB-TRIANGLES AND THUS
C     T IS SET = INTEGER 1 AS A FLAG TO QDMEM ROUTINE WHICH WILL
C     COMPUTE T FOR EACH.
C
  670 TINT = 1
      TINT = TINT
      GO TO 750
  700 T = PI23*(ECPT(8) + ECPT(12) + ECPT(16))
C
C     CONVERT ECPT TO THAT OF A TRMEM OR QDMEM.
C
  750 J = 5*POINTS + 6
      K = 4*POINTS + 1
      DO 800 I = 1,K
      ECPT(J) = ECPT(J-2)
      J = J - 1
  800 CONTINUE
      ECPT(POINTS+4) = T
      ECPT(POINTS+5) = 0.0
      IF (POINTS .EQ. 4) GO TO 850
      CALL KTRMEM (0)
      RETURN
C
  850 CALL KQDMEM
      RETURN
C
C     BAD GEOMETRY FATAL ERROR.
C
  900 WRITE  (OUTPT,910) UFM,ECPT(1)
  910 FORMAT (A23,' 2159, TRIRG OR TRAPRG ELEMENT =',I14,
     1       ' POSSESSES ILLEGAL GEOMETRY.')
      NOGO = .TRUE.
      RETURN
      END

      SUBROUTINE WRTTRL (FILBLK)
C
      EXTERNAL        LSHIFT,RSHIFT,ANDF,ORF
      INTEGER         FILBLK(7),FIAT,FIST,NAME(2),ORF,RSHIFT,ANDF,
     1                FILBK(7),LB(2)
      REAL            WORDS(4)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25,SWM*27
      COMMON /XMSSG / UFM,UWM,UIM,SFM,SWM
      COMMON /MACHIN/ MACH
      COMMON /XFIAT / FIAT(3)
      COMMON /XFIST / FIST(2)
      COMMON /XSORTX/ ISAV(6)
      COMMON /L15 L8/ L15,L8
      COMMON /SYSTEM/ SYSTEM(175)
      COMMON /LOGOUT/ LOUT
      EQUIVALENCE     (SYSTEM(2),IOUT), (SYSTEM(24),ICFIAT),
     1                (SYSTEM(40),NBPW)
      DATA    MBIT  / 0 /   ,WORDS / 1.0, 2.0, 2.0, 4.0 /
      DATA    NAME  / 4HWRTT,4HRL  /
      DATA    MASK  / 65535 /
C
C
C     IF ICFIAT= 8, WRTTRL WILL PACK SIX SIXTEEN BIT POSITIVE INTEGERS
C     INTO THREE THIRTY-TWO BIT WORDS AND STORE THEM IN THE FIAT
C     NO SUCH PACKING IF ICFIAT=11
C
C
C     SEARCH FIST FOR THE FILE
C
C     WRTTRL WILL NOT CHANGE TRAILER FOR 100 SERIES FILES
C
      IF (FILBLK(1).GT.100 .AND. FILBLK(1).LT.199) CALL MESAGE (-40,
     1    FILBLK(1),NAME)
C
C     ONLY MATGEN, OPTION 10, SENDS FILE 199 OVER HERE
C
      IF (FILBLK(1) .EQ. 199) FILBLK(1) = 101
C
C     THIS 'NEXT TO SIGN' MBIT IS SET BY SDCOMP AND SDCMPS
C
      MBIT = LSHIFT(1,NBPW-2 - (NBPW-32))
      NOUT = IOUT
      NOUT = LOUT
C
C     VERIFY SQUARE AND SYMM. MATRICES
C
      IF (L8.EQ.0 .OR. L15.EQ.0) GO TO 20
      IF (FILBLK(7)  .LT.  MBIT) GO TO 20
      IF (FILBLK(4).NE.1 .AND. FILBLK(4).NE.6) GO TO 20
      IF (FILBLK(2) .EQ. FILBLK(3)) GO TO 20
      CALL FNAME (FILBLK(1),LB(1))
      WRITE  (IOUT,10) SWM,LB(1),LB(2),FILBLK(2),FILBLK(3),FILBLK(4)
   10 FORMAT (A27,', DATA BLOCK ',2A4,1H,,I9,3H BY,I8,', IS MIS-LABLED',
     1       ' SQUARE OR SYMM.  (FORM=',I3,1H), /5X,
     2       'TURN DIAGS 1, 8 AND 15 ON FOR ERROR TRACEBACK')
      CALL SSWTCH (1,N)
CWKBD IF (N .NE. 0) CALL ERRTRC ('WRTTRL  ',10)
C
   20 CONTINUE
      N = FIST(2)*2 + 1
      DO 30 I = 3,N,2
      IF (FIST(I) .NE. FILBLK(1)) GO TO 30
      INDEX = FIST(I+1) + 1
      GO TO 40
   30 CONTINUE
      CALL MESAGE (-11,FILBLK(1),NAME)
C
C     IF (1) BIT 'NEXT TO SIGN BIT' IS ON IN FILBLK(7), (2) FILBLK(2)
C     AND FILBLK(3), WHICH ARE COLUMN AND ROW, ARE NON ZEROS, AND
C     FILBLK(5), WHICH IS TYPE, IS 1,2,3 OR 4, THE INCOMING TRAILER IS
C     A MATRIX TRAILER. IN THIS CASE FILBLK(7) IS CONVERTED TO A DENSITY
C     PERCENTAGE BEFORE STORING IN THE FIAT.
C
   40 IF (FILBLK(7) .LT. MBIT) GO TO 50
      COUNT = FILBLK(7) - MBIT
      I = FILBLK(5)
      IF (FILBLK(2).EQ.0 .OR. FILBLK(3).EQ.0 .OR. I.LT.1 .OR. I.GT.4)
     1    GO TO 50
      FN = FILBLK(2)
      FM = FILBLK(3)
      FILBLK(7) = (COUNT/(FN*FM*WORDS(I)))*1.E4 + 1.0E-3
      IF (FILBLK(7).EQ.0 .AND. FILBLK(6).NE.0) FILBLK(7) = 1
   50 CONTINUE
C
      IF (L8 .EQ. 0) GO TO 100
      WRITE  (NOUT,60,ERR=70) FIAT(INDEX+1),FIAT(INDEX+2),
     1                        (FILBLK(I),I=2,7)
   60 FORMAT (' *** DIAG 8, MESSAGE -- TRAILER FOR DATA BLOCK ',2A4,
     1        2H =,6I10)
      GO TO 100
   70 CALL SSWTCH (1,N)
      IF (N .EQ. 0) GO TO 100
      WRITE  (NOUT,80,ERR=90) (FILBLK(I),I=2,7)
CIBMR 6/93 80 FORMAT (3H  (,6O20,1H))
   80 FORMAT (3H  (,6I8,1H))
CWKBR   90 CALL ERRTRC ('WRTTRL  ',70)
   90 CONTINUE
C
C     IF ICFIAT IS 8, PACK THE TRAILER INFORMATION IN THE FIAT.
C     BEFORE PACKING MAKE SURE NUMBERS ARE POSITIVE AND .LE. 16 BITS.
C
C     IF ICFIAT IS 11, 6 TRAILER WORDS ARE STORED DIRECTLY INTO 4TH,
C     5TH, 6TH, 9TH, 10TH AND 11TH WORD OF A FIAT ENTRY
C
  100 IF (ICFIAT .EQ. 11) GO TO 120
      DO 110 I = 2,7
      FILBLK(I) = ANDF(MASK,IABS(FILBLK(I)))
  110 CONTINUE
      FIAT(INDEX+ 3) = ORF(FILBLK(3),LSHIFT(FILBLK(2),16))
      FIAT(INDEX+ 4) = ORF(FILBLK(5),LSHIFT(FILBLK(4),16))
      FIAT(INDEX+ 5) = ORF(FILBLK(7),LSHIFT(FILBLK(6),16))
      GO TO 130
  120 FIAT(INDEX+ 3) = FILBLK(2)
      FIAT(INDEX+ 4) = FILBLK(3)
      FIAT(INDEX+ 5) = FILBLK(4)
      FIAT(INDEX+ 8) = FILBLK(5)
      FIAT(INDEX+ 9) = FILBLK(6)
      FIAT(INDEX+10) = FILBLK(7)
  130 IF (FIAT(INDEX) .GE. 0) GO TO 150
C
C     FIND EQUIVALENCED FILES IN FIAT AND WRITE TRAILER ON THEM
C
      IUCB  = ANDF(FIAT(INDEX),MASK)
      IENDF = FIAT(3)*ICFIAT - 2
      DO 140 I = 4,IENDF,ICFIAT
      IF (FIAT(I) .GE. 0) GO TO 140
C
C     PICK UP UNIT CONTROL BLOCK
C
      ITUCB = ANDF(FIAT(I),MASK)
      IF (ITUCB .NE. IUCB) GO TO 140
C
C     FOUND FILE
C
      FIAT(I+ 3) = FIAT(INDEX+ 3)
      FIAT(I+ 4) = FIAT(INDEX+ 4)
      FIAT(I+ 5) = FIAT(INDEX+ 5)
      IF (ICFIAT .EQ. 8) GO TO 140
      FIAT(I+ 8) = FIAT(INDEX+ 8)
      FIAT(I+ 9) = FIAT(INDEX+ 9)
      FIAT(I+10) = FIAT(INDEX+10)
  140 CONTINUE
C
C     SAVE THE TRAILER IN ISAV IF FILE IS SCRATCH 1
C     (SAVED FOR GINOFILE MODULE, SUBROUTINE GINOFL)
C
  150 IF (FILBLK(1) .NE. 301) RETURN
      ISAV(1) = FIAT(INDEX+ 3)
      ISAV(2) = FIAT(INDEX+ 4)
      ISAV(3) = FIAT(INDEX+ 5)
      IF (ICFIAT .EQ. 8) GO TO 160
      ISAV(4) = FIAT(INDEX+ 8)
      ISAV(5) = FIAT(INDEX+ 9)
      ISAV(6) = FIAT(INDEX+10)
  160 RETURN
C
C
      ENTRY RDTRL (FILBK)
C     ===================
C
C     RDTRL WILL UNPACK THE THREE WORDS STORED IN THE FIAT AND RETURN
C     THE SIX WORDS OF TRAILER INFORMATION
C
C
C     SEARCH THE FIST FOR THE FILE
C
      N = FIST(2)*2 + 1
      DO 200 I = 3,N,2
      IF (FIST(I) .NE. FILBK(1)) GO TO 200
      INDEX = FIST(I+1) + 1
      GO TO 210
  200 CONTINUE
C
C     FILE WAS NOT FOUND, SET THE FILE NAME NEGATIVE
C
      FILBK(1) = -IABS(FILBK(1))
      RETURN
C
C     CHECK FIAT ENTRY 8 OR 11 WORDS PER ENTRY
C
  210 IF (ICFIAT .EQ. 11) GO TO 220
C
C     8 WORD ENTRY, UNPACK THE TRAILER INFORMATION
C
      FILBK(2) = RSHIFT(FIAT(INDEX+3),16)
      FILBK(3) = ANDF(FIAT(INDEX+3),MASK)
      FILBK(4) = RSHIFT(FIAT(INDEX+4),16)
      FILBK(5) = ANDF(FIAT(INDEX+4),MASK)
      FILBK(6) = RSHIFT(FIAT(INDEX+5),16)
      FILBK(7) = ANDF(FIAT(INDEX+5),MASK)
      GO TO 230
C
C     11 WORD ENTRY, TRAILER NOT PACKED
C
  220 FILBK(2) = FIAT(INDEX+ 3)
      FILBK(3) = FIAT(INDEX+ 4)
      FILBK(4) = FIAT(INDEX+ 5)
      FILBK(5) = FIAT(INDEX+ 8)
      FILBK(6) = FIAT(INDEX+ 9)
      FILBK(7) = FIAT(INDEX+10)
C
  230 RETURN
      END

      SUBROUTINE ASCM10 (NAME,IPHASE,ISOL,NOGO)
C
C     SUBSTRUCTURE UTILITY COMMANDS DMAP DATA
C
      INTEGER        COMND(6,6),XTRA(1),SUBNAM(2),RDMAP(18,2),PTBS(7,10)
      COMMON /ASDBD/ IRDM,NRDM,IXTRA,NXTRA,IOCT,NOCT,IPTBS,NPTBS,
     1               IPH,NPH,IDAT(109)
      DATA    COMND/
     1               4HDEST    ,  2    ,  0    ,  0    ,  3    ,  0  ,
     2               4HEDIT    ,  2    ,  0    ,  0    ,  3    ,  0  ,
     3               4HEQUI    ,  2    ,  1    ,  0    ,  5    ,  0  ,
     4               4HSOFP    ,  2    ,  0    ,  0    , 10    ,  0  ,
     5               4HDELE    ,  2    ,  0    ,  0    , 10    ,  0  ,
     6               4HRENA    ,  2    ,  0    ,  0    ,  5    ,  0  /
      DATA    SLASH/ 1H/       /
      DATA    RDMAP/
     1 4HSOFU,4HT   ,4H  //,4HDRY/,4H*NAM,4HE   ,4H *!*,4HOPER,4H*/OP,
     * 4HT!*N,4HAME0,4H002*,4H!*PR,4HEF*/,4H*ITM,4H1*!*,4HITM2,4H*/  ,
     2 4H    ,4H    ,4H  *I,4HTM3*,4H!*IT,4HM4*/,4H*ITM,4H5* $,4H    ,
     * 4H    ,8*4H          /
      DATA    XTRA / 4HPREF /
      DATA    PTBS /
     1          1  , 16  , 18  ,  8  ,4HNAME  ,         0  ,  0  ,
     2          1  , 27  , 29  ,  4  ,4HOPER  ,         0  ,  0  ,
     3          1  , 34  , 35  ,  3  ,4HOPTI  ,         0  ,  0  ,
     4          1  , 38  , 40  ,  8  ,4HNEW   ,         0  ,  0  ,
     5          1  , 49  , 51  ,  4  ,4HPREF  ,         0  ,  0  ,
     6          1  , 56  , 58  ,  4  ,4HITM1  ,         0  ,  0  ,
     7          1  , 63  , 65  ,  4  ,4HITM2  ,         0  ,  0  ,
     8          2  , 11  , 12  ,  4  ,4HITM3  ,         0  ,  0  ,
     9          2  , 17  , 19  ,  4  ,4HITM4  ,         0  ,  0  ,
     O          2  , 24  , 26  ,  4  ,4HITM5  ,         0  ,  0  /
      DATA   SUBNAM / 4HASCM,2H10    /
C
C     RESTORE TO ORIGINAL DATA BY REPLACEING ! BY / IN RDMAP ARRAY
C     (SEE ASCM01 FOR EXPLANATION))
C
      RDMAP(7, 1) = KHRFN1(RDMAP(7, 1),3,SLASH,1)
      RDMAP(10,1) = KHRFN1(RDMAP(10,1),2,SLASH,1)
      RDMAP(13,1) = KHRFN1(RDMAP(13,1),1,SLASH,1)
      RDMAP(16,1) = KHRFN1(RDMAP(16,1),3,SLASH,1)
      RDMAP(5, 2) = KHRFN1(RDMAP(5, 2),1,SLASH,1)
C
C     VALIDATE COMMAND AND SET POINTERS
C
      DO 10 I = 1,6
      IF (NAME .EQ. COMND(1,I)) GO TO 20
   10 CONTINUE
      GO TO 70
   20 ICOMND = I
      IRDM   = 1
      NRDM   = COMND(2,ICOMND)
      IXTRA  = IRDM  + 18*NRDM
      NXTRA  = COMND(3,ICOMND)
      IOCT   = IXTRA + NXTRA
      NOCT   = COMND(4,ICOMND)
      IPTBS  = IOCT  + 3*NOCT
      NPTBS  = COMND(5,ICOMND)
      IPH    = IPTBS + 7*NPTBS
      NPH    = COMND(6,ICOMND)
C
C     MOVE RDMAP DATA
C
      K = 0
      IF (NRDM .EQ. 0) GO TO 35
      DO 30 J = 1,NRDM
      DO 30 I = 1,18
      K = K + 1
   30 IDAT(K) = RDMAP(I,J)
   35 CONTINUE
C
C     MOVE XTRA DATA
C
      IF (NXTRA .EQ. 0) GO TO 45
      DO 40 I = 1,NXTRA
      K = K + 1
   40 IDAT(K) = XTRA(I)
   45 CONTINUE
C
C     MOVE PTBS DATA
C
      IF (NPTBS .EQ. 0) GO TO 65
      DO 60 J = 1,NPTBS
      DO 60 I = 1,7
      K = K + 1
   60 IDAT(K) = PTBS(I,J)
   65 CONTINUE
C
      RETURN
C
C     INPUT ERROR
C
   70 CALL MESAGE (7,0,SUBNAM)
      NOGO = 1
      RETURN
C
      END

      SUBROUTINE CASE
C
C     CASE READS THE CASE CONTROL DATA BLOCK AND WRITES A NEW
C     DATA BLOCK WHICH CONTAINS ONLY THOSE RECORDS WHICH DESCRIBE THE
C     CURRENT CASE IN THE LOOP. ADDITIONALLY, THE LOOP CONTROL PARAMETER
C     IS SET.
C
C
      INTEGER         APP    ,COUNT  ,SYSBUF,CASECC,CASEXX,FILE  ,Z    ,
     1                BUF1   ,BUF2   ,RFMTS ,BRANCH,BUF   ,ERROR(2)
      INTEGER         BUF3   ,PSDL
      DIMENSION       NAM(2) ,BUF(20),MCB(7),RFMTS(40)
      COMMON /BLANK / APP(2) ,COUNT  ,LOOP
      COMMON /SYSTEM/ SYSBUF
      COMMON /NAMES / RD     ,RDREW  ,WRT   ,WRTREW,CLSREW
      COMMON /ZZZZZZ/ Z(1)
C
C     DATA DESCRIBING DATA BLOCK FILE NAMES AND POSITION
C     OF PARAMETERS IN THE CASE CONTROL RECORD.
C
      DATA   CASECC / 101/ ,CASEXX /201/ ,IK2PP  /139/ ,IM2PP /141/ ,
     1       IB2PP  / 143/ ,ITFL   / 15/ ,PSDL   /102/ ,IRAND /163/
      DATA   ERROR  / 4HPSDL,4HCASE/
      DATA   IFREQ  / 14/  ,IMETH  /  5/
C
C     DATA DEFINING RIGID FORMATS.
C
      DATA   NRIGDS / 10   /, RFMTS  /
     1                4HSTAT,4HICS , 4HREIG,4HEN  , 4HDS0 ,4H    ,
     2                4HDS1 ,4H    , 4HFREQ,4H    , 4HTRAN,4HSNT ,
     3                4HBKL0,4H    , 4HBKL1,4H    , 4HCEIG,4HEN  ,
     4                4HPLA ,4H    , 20*0  /
C
C     MISC DATA
C
      DATA   NAM    / 4HCASE,4H    /, MCB    / 7*0  /
C
C     PERFORM BUFFER ALLOCATION.
C
      BUF1  = KORSZ(Z) - SYSBUF + 1
      BUF3  = BUF1 - SYSBUF
      BUF2  = BUF3 - SYSBUF
      IRY   = 0
      M8    = -8
      IF (COUNT .LE. 0) COUNT = 1
      LOOP  = 1
      IOCNT = COUNT
C
C     SET PARAMETER FOR APPROACH.
C
      N = 2*NRIGDS - 1
      DO 20 I = 1,N,2
      IF (RFMTS(I) .EQ. APP(1)) GO TO 30
   20 CONTINUE
      CALL MESAGE (30,75,APP)
      I = 19
   30 BRANCH = (I+1)/2
C
C     OPEN CASECC. SKIP RECORDS ALREADY PROCESSED. OPEN CASEXX.
C     WRITE HEADER RECORD. THEN BRANCH ON APPROACH.
C
      FILE = CASECC
      CALL OPEN (*130,CASECC,Z(BUF1),RDREW)
      DO 40 I = 1,COUNT
   40 CALL FWDREC (*140,CASECC)
      FILE = CASEXX
      CALL OPEN  (*130,CASEXX,Z(BUF2),WRTREW)
      CALL FNAME (CASEXX,BUF)
      CALL WRITE (CASEXX,BUF,2,1)
      GO TO (120,50,120,120,50,100,120,120,50,120), BRANCH
C
C     COMPLEX EIGENVALUES OR FREQUENCY RESPONSE.
C
   50 CALL READ (*140,*60,CASECC,Z,BUF2,1,NCC)
      CALL MESAGE (M8,0,NAM)
   60 BUF(1) = Z(IK2PP  )
      BUF(2) = Z(IK2PP+1)
      BUF(3) = Z(IM2PP  )
      BUF(4) = Z(IM2PP+1)
      BUF(5) = Z(IB2PP  )
      BUF(6) = Z(IB2PP+1)
      BUF(7) = Z(ITFL)
      IRSET  = Z(IRAND)
      IFRQST = Z(IFREQ)
      IMRQST = Z(IMETH)
      IF (BRANCH.EQ.5 .AND. IRSET.NE.0) IRY = 1
      IF (IRY .EQ. 0) GO TO 70
C
C     BUILD LIST OF UNIQUE LOAD ID-S
C
      FILE = PSDL
      CALL OPEN (*68,PSDL,Z(BUF3),RDREW)
      CALL FWDREC (*90,PSDL)
      ILS  = BUF2
      ILF  = BUF2 - 1
   61 CALL READ (*90,*66,PSDL,Z(NCC+1),6,0,J)
      IF (Z(NCC+1) .NE. IRSET) GO TO 61
      J = 1
      ILOAD = Z(NCC+2)
      IF (ILS .EQ. ILF+1) GO TO 63
   65 DO 62 I = ILS,ILF
      IF (Z(I) .EQ. ILOAD) GO TO 64
   62 CONTINUE
C
C     NEW LOAD ID
C
   63 ILS = ILS - 1
      Z(ILS) = ILOAD
   64 IF (J .EQ. 0) GO TO 61
      J = 0
      ILOAD = Z(NCC+3)
      GO TO 65
C
C     END OF PSDL RECORD
C
   66 CALL CLOSE (PSDL,CLSREW)
      IF (ILS .EQ. ILF+1) CALL MESAGE (-31,IRSET,ERROR(1))
      BUF2 = ILS - 1
      GO TO 70
C
C     NO PSDL IS EQUIVALENT TO NO RANDOM
C
   68 IRY = 0
   70 CALL WRITE (CASEXX,Z,NCC,1)
      COUNT = COUNT + 1
      IF (IRY .EQ. 0) GO TO 71
C
C     CHECK  SUBCASE ID-S
C
      DO 72 I = ILS,ILF
      IF (Z(1) .EQ. Z(I)) GO TO 74
   72 CONTINUE
      GO TO 71
C
C     MARK USED
C
   74 Z(I) = -Z(I)
   71 CONTINUE
      CALL READ (*90,*80,CASECC,Z,BUF2,1,NCC)
      CALL MESAGE (M8,0,NAM)
   80 IF (Z(IK2PP).NE.BUF(1) .OR. Z(IK2PP+1).NE.BUF(2) .OR.
     1    Z(IM2PP).NE.BUF(3) .OR. Z(IM2PP+1).NE.BUF(4) .OR.
     2    Z(IB2PP).NE.BUF(5) .OR. Z(IB2PP+1).NE.BUF(6)) GO TO 120
      IF (Z(ITFL) .NE. BUF(7)) GO TO 120
      IF (Z(IMETH).NE.0 .AND. Z(IMETH).NE.IMRQST) GO TO 120
C
C     TEST FOR CHANGED FREQUENCY SET
C
      IF (Z(IFREQ).NE.IFRQST .AND. BRANCH.EQ.5) GO TO 120
      GO TO 70
   90 COUNT = -1
      GO TO 120
C
C     TRANSIENT RESPONSE.
C
  100 CALL READ (*140,*110,CASECC,Z,BUF2,1,NCC)
      CALL MESAGE (M8,0,NAM)
  110 CALL WRITE (CASEXX,Z,NCC,1)
      COUNT = COUNT + 1
      CALL READ (*90,*120,CASECC,Z,BUF2,1,NCC)
      GO TO 120
C
C     CLOSE FILES. WRITE TRAILER. RETURN.
C
  120 CALL CLOSE (CASECC,CLSREW)
      CALL CLOSE (CASEXX,CLSREW)
      MCB(1) = CASEXX
      MCB(2) = COUNT
      CALL WRTTRL (MCB)
      IF (COUNT.LE.1 .AND. IOCNT.EQ.1) LOOP = -1
C
C     CHECK ALL PSDL ACCOUNTED FOR
C
      IF (IRY .EQ. 0) GO TO 125
      NOGO = 0
      DO 121  I = ILS,ILF
      IF (Z(I) .LT. 0) GO TO 121
      NOGO = -1
      CALL MESAGE (33,Z(I),NAM)
  121 CONTINUE
      IF (NOGO .LT. 0) CALL MESAGE (-7,0,NAM)
  125 RETURN
C
C     FATAL FILE ERRORS.
C
  130 N = -1
      GO TO 150
  140 N = -2
      FILE = CASECC
  150 CALL MESAGE (N,FILE,NAM)
      GO TO 150
      END

      SUBROUTINE MBBSLJ (ARG,N,BSL)
C
C     SUBROUTINE TO COMPUTE EVEN ORDERED BESSEL FUNCTIONS OF FIRST KIND
C
C     UNDERFLOW MAY OCCUR IN THIS ROUTINE. THE RESULTS ARE NOT AFFECTED
C
      DIMENSION       BSL(4)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG / UFM,UWM,UIM,SFM
      COMMON /SYSTEM/ SYSBUF,N6
C
      DO 1 I = 1,20
    1 BSL(I) = 0.0
      ASQ = ARG**2
      IF (ASQ .LT. 0.01) GO TO 60
      N  = AMIN1(17.0,(ARG+10.0))
      F  = 2*N + 4
      BSL(N+3) = 0.0
      PF = (4.0*F*(F-1.0)/ASQ-(F-1.0)/F)*0.3
      IF (PF .LE. 1.E-08) GO TO 70
      BSL(N+2) = PF*1.E-30
      PF = 0.0
      J  = N + 1
      DO 10 I = 1,J
      M  = N - I + 2
      F  = 2*M + 1
      BSL(M) = ((4.*(F-1.)/ASQ-1./F-1./(F-2.))*BSL(M+1)-BSL(M+2)/F)*
     1         (F-2.0)
   10 PF = PF + 2.0*BSL(M+1)
      PF = PF + BSL(1)
      F  = 0.0
      IF (ABS(PF) .LE. 1.0) GO TO 20
      F  = ABS(PF)*1.E-10
   20 N  = N + 2
      DO 40 I = 1,N
      IF (F .GE. ABS(BSL(I))) BSL(I) = 0.0
      BSL(I) = BSL(I)/PF
   40 CONTINUE
      M  = N
      DO 50 I = 1,M
      IF (ABS(BSL(N)) .GT. 1.0E-07) RETURN
      N  = N - 1
   50 CONTINUE
      RETURN
C
   60 BSL(2) = 0.125*ASQ
      BSL(1) = 1.0 - 2.0*BSL(2)
      N  = 2
      GO TO 90
C
   70 CALL PAGE2 (3)
      WRITE  (N6,80) SFM,ARG
   80 FORMAT (A25,' 2435, MBBSLJ SUBROUTINE FAILED BECAUSE THE ARGUMEN',
     1       'T IS TOO LARGE FOR THE BSL ARRAY', /5X,'ARG =',1P,E13.5)
      CALL MESAGE (-61,0,0)
   90 RETURN
      END

      SUBROUTINE DBMINT
C********************************************************************
C     DBMINT - INITIALIZES ALL PARAMETERS AND THE FREE BLOCK CHAIN
C              FOR THE IN-MEMORY DATA BASE.
C
C        ARGUMENTS
C            IDBADR - (INPUT)-BEGINNING ADDRESS FOR IN-MEMORY DATA BASE
C            IDBLEN - (INPUT)-NUMBER OF MEMORY WORDS FOR IN-MEMORY
C                             DATA BASE
C        / DBMPAR/
C            IDBBAS - (OUTPUT)-INDEX TO IN-MEMORY DATA BASE RELATIVE
C                              TO /DBM/
C            IDBFRE - (OUTPUT)-INDEX TO FREE CHAIN OF IN-MEMORY DATA
C                              BASE RELATIVE TO /DBM/
C            IDBDIR - (OUTPUT)-INDEX TO FIRST DIRECTORY BLOCK
C        FREE CHAIN FORMAT
C               IDBFRE==> WORD 0 - 0   (POINTS TO PREVIOUS FREE BLOCK
C                                      IN CHAIN, ALWAYS 0 FOR 1ST BLK)
C                         WORD 1 - 0   (POINTS TO NEXT BLOCK IN CHAIN
C                                      -INITIALLY SET TO ZERO)
C                         WORD 2 - L   (NUMBER OF FREE WORDS IN BLOCK)
C        DIRECTORY FORMAT
C               THE FIRST TWO WORDS OF THE DIRECTORY BLOCK CONTAIN:
C                   WORD  0 - MAXIMUM NUMBER OF ENTRIES IN DIRECTORY
C                   WORD  1 - CURRENT ENTRIES IN THE DIRECTORY
C               EACH ENTRY IN THE DIRECTORY HAS THE FOLLOWING FORMAT
C               (NOTE, FIRST ENTRY BEGINS AT WORD 3 OF BLOCK)
C                   WORD  0 - UNIT NUMBER OF DMAP FILE AS FOUND IN FIAT
C                   WORD  1 - INDEX TO FIRST IN-MEMORY DATA BLOCK
C                   WORD  2 - INDEX TO LAST IN-MEMORY DATA BLOCK
C                   WORD  3 - INDEX TO CURRENT IN-MEMORY DATA BLOCK
C                   WORD  4 - CURRENT BLOCK NUMBER BEING PROCESSED
C                   WORD  5 - LAST BLOCK NUMBER
C                   WORD  6 - ORIGINAL BUFFER ADDRESS
C                   WORD  7 - TOTAL BLOCKS (EXT. FILE + IN M. DB)
C                   WORD  8 - OPEN FLAG FOR EXT. FILE (0,NO;1,YES)
C               WORDS  9-10 - DMAP FILE NAME
C               WORDS 11-16 - DMAP FILE TRAILER
C********************************************************************
      INCLUDE  'DSIOF.COM'
      COMMON / SYSTEM / ISYSBF, IWR
      COMMON / ZZZZZZ / MEM( 4 )
      IDBDIR = 0
      IF ( IDBLEN .EQ. 0 ) GO TO 700
C  INITIALIZE THE CHAIN OF FREE BLOCKS AS ONE BIG FREE BLOCK
      IDBBAS = LOCFX( MEM )
      IDBFRE = IDBADR - IDBBAS + 1
      MEM( IDBFRE )  = 0
      MEM( IDBFRE+1) = 0
      MEM( IDBFRE+2) = IDBLEN - 2
      MAXALC         = IDBLEN / ( ISYSBF-3+4 )
      IDBDIR = 1
700   CONTINUE
      END

      SUBROUTINE MPY3
C*****
C     PRIMARY DRIVER FOR MATRIX TRIPLE PRODUCT.
C
C     ASSOCIATED SUBROUTINES
C         MPY3DR - SECONDARY DRIVER.  SETS UP OPEN CORE AND DETERMINES
C                  SOLUTION METHOD.
C         MPY3IC - IN-CORE PRODUCT.
C         MPY3OC - OUT-OF-CORE PRODUCT.
C         MPY3A  - PREPARES B AND A(T).
C         MPY3B  - PROCESSES A AND PERFORMS FIRST PART OF PRODUCT.
C         MPY3P  - PERFORMS MULTIPLICATION AND SUMMATION.
C         MPY3NU - CALCULATES NEXT TIME USED FOR INDIVIDUAL COLUMNS OF B
C                  OR ENTRIES OF A.
C         MPY3C  - PERFORMS MULTIPLICATION AND SUMMATION FOR REMAINING
C                  TERMS IN COLUMN OF A.
C
C     DMAP CALLING SEQUENCE
C
C         MPY3     A,B,E / C / C,N,CODE/ C,N,PREC   $
C*****
      INTEGER         FILEA,FILEB,FILEE,FILEC,CODE,PREC, SCR1,SCR2,SCR3
C
C     DMAP PARAMETERS
      COMMON /BLANK / IBCC,IBCP
C     FILES
      COMMON /MPY3TL/ FILEA(7),FILEB(7),FILEE(7),FILEC(7),SCR1,SCR2,
     1                SCR3,LCORE,CODE,PREC,DUMMY(13)
C     OPEN CORE
      COMMON /ZZZZZZ/ Z(1)
C
C*****
C     ASSIGN GINO FILE NUMBERS.
C*****
      FILEA(1) = 101
      FILEB(1) = 102
      FILEE(1) = 103
      SCR1  = 301
      SCR2  = 302
      SCR3  = 303
      CODE  = IBCC
      PREC  = IBCP
      LCORE = KORSZ(Z)
C*****
C     GET MATRIX TRAILERS
C*****
      CALL RDTRL (FILEA)
      CALL RDTRL (FILEB)
      CALL RDTRL (FILEE)
      IF (FILEE(1) .LT. 0) FILEE(1) = 0
C
      CALL MAKMCB (FILEC,201,FILEA(2),1,PREC)
      IF (CODE .EQ. 0) GO TO 10
      IF (CODE .EQ. 2) FILEC(3) = FILEB(3)
      IF (CODE.EQ.1 .AND. FILEA(2).NE.FILEB(2)) FILEC(4) = 2
      IF (CODE.EQ.2 .AND. FILEB(3).NE.FILEA(2)) FILEC(4) = 2
C*****
C     PERFORM MULTIPLY
C*****
   10 CALL MPY3DR (Z)
      CALL WRTTRL (FILEC)
C
      RETURN
      END

      SUBROUTINE PLA32
C
C     THIS ROUTINE READS THE ESTNLS DATA BLOCK CREATED IN SUBROUTINE
C     PLA31, AND CALLS THE PROPER ELEMENT ROUTINE TO COMPUTE ELEMENT
C     STRESSES.
C     ELEMENT STRESS INFORMATION IS STORED BY THE ELEMENT ROUTINE IN
C     /STROUT/.  THE ELEMENT ROUTINE ALSO UPDATES THE EST ENTRY WHICH
C     HAS BEEN COMMUNICATED TO IT VIA /PLA32E/.  NOTE THAT THIS UPDATED
C     EST ENTRY DOES NOT CONTAIN DISPLACEMENT VECTOR INFORMATION.
C
      INTEGER         BUFSZ,BUFR1,BUFR2,BUFR3,CSTM,DIT,ESTNLS,CASECC,
     1                ONLES,ESTNL1,EOR,CLSRW,FILE,IZ(1),IESTBK(100),
     9                ESTWDS(40),ELTYPE,OUTRW,PLACNT,PLSETN,PLANOS(2),
     2                OSTRT(7),ESTT(7),SETNO
      DIMENSION       NAME(2),NSTWDS(40),NWDSP2(40),P(4),IP(4),DUM2(2),
     1                TUBSAV(20),ICHAR(9),ITITLE(3),IY(30)
      COMMON /BLANK / PLACNT,PLSETN
      COMMON /SYSTEM/ BUFSZ
      COMMON /CONDAS/ PI,TWOPI,RADEG,DEGRA,S4PISQ
      COMMON /ZZZZZZ/ Z(1)
      COMMON /PLA32C/ GAMMA,GAMMAS,IPASS
      COMMON /PLA32E/ ESTBK(100)
C
C     SCRATCH BLOCK USED BY ELEMENT ROUTINES (325 SINGLE PRECISION
C     CELLS)  AND OUTPUT BLOCK FOR ELEMENT STRESSES
C
      COMMON /PLA32S/ XXXXXX(325)
      COMMON /SOUT  / YYYYYY(30)
      EQUIVALENCE     (Z(1),IZ(1)),(ESTBK(1),IESTBK(1)),(P(1),IP(1)),
     1                (YYYYYY(1),IY(1))
      DATA    NAME  / 4HPLA3, 4H2          /
      DATA    ITITLE/ 4HLOAD, 4H FAC,4HTOR /
      DATA    CSTM  , MPT,DIT,ESTNLS,CASECC/ 101,102,103,301,106 /
      DATA    ONLES , ESTNL1  / 201,202    /
      DATA    INRW  , OUTRW,EOR,NEOR,CLSRW / 0,1,1,0,1 /
      DATA    PLANOS/ 1103,11 /
C
C    1        ROD       BEAM      TUBE      SHEAR     TWIST
C    2        TRIA1     TRBSC     TRPLT     TRMEM     CONROD
C    3        ELAS1     ELAS2     ELAS3     ELAS4     QDPLT
C    4        QDMEM     TRIA2     QUAD2     QUAD1     DAMP1
C    5        DAMP2     DAMP3     DAMP4     VISC      MASS1
C    6        MASS2     MASS3     MASS4     CONM1     CONM2
C    7        PLOTEL    REACT     QUAD3     BAR       CONE
C    8        TRIARG    TRAPRG    TORDRG    CORE      CAP
C
      DATA    ESTWDS/
     1           21,        0,       20,        0,        0,
     2           38,        0,        0,       27,       21,
     3            0,        0,        0,        0,        0,
     4           32,       32,       37,       43,        0,
     5            0,        0,        0,        0,        0,
     6            0,        0,        0,        0,        0,
     7            0,        0,        0,       50,        0,
     8            0,        0,        0,        0,        0 /
      DATA    NSTWDS/
     1            5,        0,        5,        0,        0,
     2           17,        0,        0,        8,        5,
     3            0,        0,        0,        0,        0,
     4            8,       17,       17,       17,        0,
     5            0,        0,        0,        0,        0,
     6            0,        0,        0,        0,        0,
     7            0,        0,        0,       16,        0,
     8            0,        0,        0,        0,        0 /
      DATA    NWDSP2/
     1           33,        0,       32,        0,        0,
     2           56,        0,        0,       36,       33,
     3            0,        0,        0,        0,        0,
     4           44,       50,       61,       67,        0,
     5            0,        0,        0,        0,        0,
     6            0,        0,        0,        0,        0,
     7            0,        0,        0,       62,        0,
     8            0,        0,        0,        0,        0 /
C
C     DEFINE POSITION IN CASECC RECORD OF DESTINATION (PRINTER, PUNCH,
C     ETC.) OF ELEMENT STRESSES.
C
      DATA          IDEST /24/
C
C
C     DETERMINE SIZE OF CORE, DEFINE BUFFERS AND INITIALIZE CORE POINTER
C     AND COUNTERS
C
      IZMAX = KORSZ(Z)
      BUFR1 = IZMAX - BUFSZ
      BUFR2 = BUFR1 - BUFSZ
      BUFR3 = BUFR2 - BUFSZ
      LEFT  = BUFR3 - 1
      IPASS = PLACNT- 1
      ICSTM = 0
      NCSTM = 0
      DO 5 I = 1,7
      OSTRT(I) = 0
    5 ESTT(I)  = 0
C
C     ATTEMPT TO READ CSTM INTO CORE
C
      FILE = CSTM
      CALL OPEN (*20,CSTM,Z(BUFR1),INRW)
      CALL FWDREC (*9020,CSTM)
      CALL READ (*9020,*10,CSTM,Z(ICSTM+1),LEFT,EOR,NCSTM)
      CALL MESAGE (-8,0,NAME)
   10 LEFT = LEFT - NCSTM
      CALL CLOSE (CSTM,CLSRW)
      CALL PRETRS (Z(ICSTM+1),NCSTM)
   20 IMAT = NCSTM
C
C     COMPUTE GAMMA AND GAMMAS FROM THE PROPER PLFACT CARD
C
      FILE = MPT
      CALL PRELOC (*9010,Z(BUFR1-3),MPT)
      CALL LOCATE (*9040,Z(BUFR1-3),PLANOS,IFLAG)
   30 CALL READ (*9020,*9030,MPT,SETNO,1,NEOR,IFLAG)
      IF (SETNO .EQ. PLSETN) GO TO 40
   35 CALL READ (*9020,*9030,MPT,NN,1,NEOR,IFLAG)
      IF (NN .EQ. -1) GO TO 30
      GO TO 35
   40 IF (PLACNT .LE. 4) GO TO 45
      CALL READ (*9020,*9030,MPT,0,-(PLACNT-4),NEOR,IFLAG)
   45 NWDSRD = 4
      IF (PLACNT .LT. 4) NWDSRD = PLACNT
      CALL READ (*9020,*9030,MPT,P,NWDSRD,NEOR,IFLAG)
      IF (IP(NWDSRD) .NE. -1) GO TO 48
      IF (PLACNT-3) 42,43,44
  42  GAMMAS = 1.0
      GO TO 46
  43  GAMMAS = (P(2) - P(1))/P(1)
      GO TO 46
  44  GAMMAS = (P(3) - P(2))/(P(2) - P(1))
  46  GAMMA = 1.0
      GO TO 65
  48  A = P(2) - P(1)
      IF (PLACNT-3) 50,55,60
   50 GAMMAS = 0.0
      GAMMA  = A/P(1)
      GO TO 65
  55  GAMMAS = A/P(1)
      GAMMA = (P(3) - P(2))/A
      GO TO 65
   60 WORD = P(3) - P(2)
      GAMMAS = WORD/A
      GAMMA  = (P(4) - P(3))/WORD
   65 CALL CLOSE (MPT,CLSRW)
C
C     READ MPT AND DIT FILES.  NOTE MINUS SIGN ON DIT TO TRIGGER PLA
C     FLAG.
C
      CALL PREMAT (IZ(IMAT+1),Z(IMAT+1),Z(BUFR1-3),LEFT,MUSED,MPT,-DIT)
      LEFT = LEFT  - MUSED
      ICC  = NCSTM + MUSED
C
C     READ CASECC INTO OPEN CORE
C
      FILE = CASECC
      CALL OPEN (*9010,CASECC,Z(BUFR1),INRW)
      CALL FWDREC (*9020,CASECC)
      CALL READ (*9020,*68,CASECC,Z(ICC+1),LEFT,EOR,NCC)
      CALL MESAGE (-8,0,NAME)
   68 LEFT = LEFT - NCC
      CALL CLOSE (CASECC,CLSRW)
C
C OPEN INPUT FILE
C
      FILE = ESTNLS
      CALL OPEN (*9010,ESTNLS,Z(BUFR1),INRW)
      CALL FWDREC (*9020,ESTNLS)
C
C     OPEN THE ELEMENT STRESS FILE FOR OUTPUT AND BUILD HEADER WHICH IS
C     NON-CHANGING.
C
      FILE = ONLES
      CALL OPEN (*9010,ONLES,Z(BUFR2),OUTRW)
      CALL FNAME (ONLES,DUM2)
      CALL WRITE (ONLES,DUM2,2,EOR)
C
C     THE FOLLOWING INDICES HAVE TO CHANGE  WHEN THERE ARE CHANGES IN
C     THE FORMAT OF THE CASECC DATA BLOCK
C
      IONLES = ICC + NCC
      IZ(IONLES+1) = IZ(ICC+18) + 100
      IZ(IONLES+2) = 5
      IZ(IONLES+4) = IZ(ICC+1)
      IZ(IONLES+5) = IZ(ICC+4)
      IZ(IONLES+6) = 0
      IZ(IONLES+7) = 0
      IZ(IONLES+8) = 0
      IZ(IONLES+9) = 0
      ILOW  = IONLES + 51
      IHIGH = IONLES + 146
      LEFT  = LEFT - 146
      IF (LEFT .LT. 0) CALL MESAGE (-8,0,NAME)
      J = ICC + 38
      DO 70 I = ILOW,IHIGH
      J = J + 1
   70 IZ(I) = IZ(J)
C
C     STORE LOAD FACTOR AND INTEGER IN LABEL PORTION OF OUTPUT
C
      IZ(IONLES+135) = ITITLE(1)
      IZ(IONLES+136) = ITITLE(2)
      IZ(IONLES+137) = ITITLE(3)
      III = PLACNT - 1
      CALL INT2AL (III,IZ(IONLES+138),ICHAR)
C
C     DEFINE DESTINATION OF OUTPUT
C
      I = ICC + IDEST
      JDEST = IZ(I)
C
C     OPEN THE ESTNL1 FILE FOR OUTPUT.
C
      FILE = ESTNL1
      CALL OPEN (*9010,ESTNL1,Z(BUFR3),OUTRW)
      CALL FNAME (ESTNL1,DUM2)
      CALL WRITE (ESTNL1,DUM2,2,EOR)
      FILE = ESTNLS
C
C     READ ELEMENT TYPE
C
   80 CALL READ (*220,*9030,ESTNLS,ELTYPE,1,NEOR,IFLAG)
C
C     FILL IN REMAINDER OF ID RECORD FOR THE ONLES FILE
C
      IZ(IONLES+3)  = ELTYPE
      IZ(IONLES+10) = NSTWDS(ELTYPE)
      IF (NSTWDS(ELTYPE) .LE. 0) CALL MESAGE (-30,91,ELTYPE)
C
C     WRITE ID RECORD FOR ONLES FILE
C
      CALL WRITE (ONLES,IZ(IONLES+1),146,EOR)
      CALL WRITE (ESTNL1,ELTYPE,1,NEOR)
C
C     READ AN ENTRY FROM THE APPENDED ESTNL FILE AND CALL THE PROPER
C     ROUTINE
C
   90 CALL READ (*9020,*210,ESTNLS,ESTBK,NWDSP2(ELTYPE),NEOR,IFLAG)
C
C               1,ROD    2,BEAM    3,TUBE   4,SHEAR   5,TWIST
      GO TO (     110,      999,      120,      999,      999,
C             6,TRIA1   7,TRBSC   8,TRPLT   9,TRMEM 10,CONROD
     1            130,      999,      999,      140,      110,
C            11,ELAS1  12,ELAS2  13,ELAS3  14,ELAS4  15,QDPLT
     2            999,      999,      999,      999,      999,
C            16,QDMEM  17,TRIA2  18,QUAD2  19,QUAD1  20,DAMP1
     3            150,      160,      170,      180,      999,
C            21,DAMP2  22,DAMP3  23,DAMP4   24,VISC  25,MASS1
     4            999,      999,      999,      999,      999,
C            26,MASS2  27,MASS3  28,MASS4  29,CONM1  30,CONM2
     5            999,      999,      999,      999,      999,
C           31,PLOTEL  32,REACT  33,QUAD3    34,BAR   35,CONE
     6            999,      999,      999,      190,      999,
C           36,TRIARG 37,TRAPRG 38,TORDRG   39,CORE?   40,CAP?
     7            999,      999,      999,      999,      999), ELTYPE
C
C     ROD, CONROD
C
  110 CALL PSROD
C
C     IF ELEMENT IS A TUBE, RESTORE SAVED EST ENTRY AND STORE UPDATED
C     STRESS VARIABLES IN PROPER SLOTS.
C
      IF (ELTYPE .NE. 3) GO TO 200
      DO 115 I = 1,16
  115 ESTBK(I) = TUBSAV(I)
      ESTBK(17) = ESTBK(18)
      ESTBK(18) = ESTBK(19)
      ESTBK(19) = ESTBK(20)
      ESTBK(20) = ESTBK(21)
      GO TO 200
C
C
C     TUBE - REARRANGE ESTBK FOR THE TUBE SO THAT IT IS IDENTICAL TO THE
C            ONE FOR THE ROD
C
C     SAVE THE EST ENTRY FOR THE TUBE EXCEPT THE 4 WORDS WHICH WILL BE
C     UPDATED BY THE THE ROD ROUTINE AND THE DISPLACEMENT VECTORS
C
  120 DO 125 I = 1,16
  125 TUBSAV(I) = ESTBK(I)
C
C     COMPUTE AREA, TORSIONAL INERTIA TERM AND STRESS COEFFICIENT
C
      D  = ESTBK(5)
      T  = ESTBK(6)
      DMT= D - T
      A  = DMT*T* PI
      FJ = .25*A*(DMT**2 + T**2)
      C  = D/2.0
C
C     MOVE THE END OF THE ESTBK ARRAY DOWN ONE SLOT SO THAT ENTRIES 7
C     THRU 32 WILL BE MOVED TO POSITIONS 8 THRU 33.
C
      M = 33
      DO 127 I = 1,26
      ESTBK(M) = ESTBK(M-1)
  127 M = M - 1
      ESTBK(5) = A
      ESTBK(6) = FJ
      ESTBK(7) = C
      GO TO 110
C
C     TRIA1
C
  130 CALL PSTRI1
      GO TO 200
C
C     TRMEM
C
  140 CALL PSTRM
      GO TO 200
C
C     QDMEM
C
  150 CALL PSQDM
      GO TO 200
C
C     TRIA2
C
  160 CALL PSTRI2
      GO TO 200
C
C     QUAD2
C
  170 CALL PSQAD2
      GO TO 200
C
C     QUAD1
C
  180 CALL PSQAD1
      GO TO 200
C
C     BAR
C
  190 CALL PSBAR
      GO TO 200
C
C     ALTER ELEMENT IDENTIFICATION FROM EXTERNAL (USER) IDENTIFICATION
C     TO INTERNAL ID., AND WRITE OUTPUT FILES.
C
  200 IY(1) = 10*IY(1) + JDEST
      CALL WRITE (ONLES,IY,NSTWDS(ELTYPE),NEOR)
      CALL WRITE (ESTNL1,ESTBK,ESTWDS(ELTYPE),NEOR)
      OSTRT(2) = OSTRT(2) + 1
      ESTT(2)  = ESTT(2)  + 1
      GO TO 90
C
C     WRITE EORS
C
  210 CALL WRITE (ONLES,0,0,EOR)
      CALL WRITE (ESTNL1,0,0,EOR)
      GO TO 80
C
C     CLOSE FILES AND WRITE TRAILERS
C
  220 CALL CLOSE (ONLES,CLSRW)
      CALL CLOSE (ESTNL1,CLSRW)
      CALL CLOSE (ESTNLS,CLSRW)
      OSTRT(1) = ONLES
      ESTT(1)  = ESTNL1
      CALL WRTTRL (OSTRT)
      CALL WRTTRL (ESTT)
      RETURN
C
C     FATAL ERRORS
C
  999 CALL MESAGE (-30,92,ELTYPE)
 9010 J = -1
      GO TO 9050
 9020 J = -2
      GO TO 9050
 9030 J = -3
      GO TO 9050
 9040 J = -5
 9050 CALL MESAGE (J,FILE,NAME)
      RETURN
      END

      SUBROUTINE FERRDM ( MCB,NIDX,MEMTOT,IBUFFI,LASIND,IPOS )  
C
C  FERRDM - This routine will store an entire matrix in memory
C           if sufficient memory exists.  The matrix    
C           is stored in memory according to the following scheme:
C
C  1st word = current column number
C  2nd word = number of terms in string (ntms)
C  3rd word           }
C     |               }
C     |               } = actual
C     |               }   matrix
C     |               }   string
C     |               }   data
C     |               }
C     |               }
C  3+(ntms*prec)      } (where prec=1 for s.p.; =2 for d.p. )
C  3+(ntms*prec)+1 = row position of first element in above string
C  3+(ntms*prec)+2 = number of terms in ABOVE string (ntms)
C
C  The above data repeats for all strings within a column and then
C  for all columns in the matrix.
C
C  Argument list :
C     MCB    - Matrix control block for input matrix
C     NIDX   - Memory index for storing matrix data
C     MEMTOT - Total amount of memory available for this data
C     IBUFFI - Buffer allocation for input matrix
C     LASIND - Memory index of last string stored in memory 
C     IPOS   - 6 word array with the following information
C              (1) = last column read into memory
C              (2) = block number of following column not read into memory
C              (3) = current logical record pointer for following column
C                    not read into memory
C              (4) = current buffer pointer for following record not read
C                    into memory
C              (5) = last block number in file
C              (6) = current logical record pointer for last record in file
C              (7) = current buffer pointer for last record in file
C
      DOUBLE PRECISION DCORE(1), DXL(1)
      REAL             RCORE(1), RXL(1)
      INTEGER          RD, RDREW, WRT, WRTREW, REW, IXL(1)
      INTEGER          IPOS(7)
      DIMENSION        IBLK(20),MCB(7)
      COMMON  /SYSTEM/ KSYSTM(65)
      COMMON  /ZZZZZZ/ ICORE(1)
      COMMON  /NAMES / RD, RDREW, WRT, WRTREW, REW
      EQUIVALENCE      ( KSYSTM( 2), NOUT              )
      EQUIVALENCE      ( KSYSTM(55), IPREC             )
      EQUIVALENCE      ( ICORE,DCORE,RCORE,DXL,RXL,IXL )
      MEM          = NIDX
      NCOL         = MCB( 2 )
      NTWDS        = 0
      IPOS( 1 )    = NCOL
      DO 10 i  = 1,20
 10   IBLK(i)      = 0
      IBLK(1)      = MCB( 1 )
      IBLK(9)      = 1
      IBLK(10)     = 1
      CALL GOPEN  ( MCB, ICORE( IBUFFI ), RDREW )
      CALL REWIND ( MCB)
      CALL SKPREC ( MCB, 1 )
      DO 1000 JCOL = 1,NCOL
      IBLK(8)      = -1
      LASIND       = MEM - 1        
      CALL DSCPOS  ( MCB, IBLOCK, ICLR, ICBP )     
  100 CALL GETSTR(*1000,IBLK(1))
      INDEX        = IBLK( 5 )
      NTMS         = IBLK( 6 )
      JROW         = IBLK( 4 )
      NTWDS        = NTWDS + 4 + NTMS*IPREC
      IF ( NTWDS .GT. MEMTOT ) GO TO 2000
      ICORE(MEM)   = JCOL
      ICORE(MEM+1) = NTMS
      IF ( IPREC .EQ. 1 ) GO TO 160
      MINDEX         = MEM/2+1
      DO 150 II = 1,NTMS
      DCORE(MINDEX+II) = DXL(INDEX+II-1)
  150 CONTINUE
      GO TO 180
  160 MINDEX     = MEM + 1
      DO 170 II  = 1,NTMS
      RCORE(MINDEX+II) = RXL(INDEX+II-1)
  170 CONTINUE
  180 CONTINUE
      MEM          = MEM + 2 + NTMS*IPREC
      ICORE(MEM  ) = JROW
      ICORE(MEM+1) = NTMS
      MEM          = MEM + 2
  185 CALL ENDGET (IBLK( 1 ) )
      GO TO 100
 1000 CONTINUE  
      LASIND    = MEM - 1        
      GO TO 7000
 2000 IPOS( 1 ) = JCOL - 1
      IPOS( 2 ) = IBLOCK
      IPOS( 3 ) = ICLR
      IPOS( 4 ) = ICBP
      CALL SKPREC ( MCB, NCOL-JCOL+1 )
      CALL DSCPOS ( MCB, IBLOCK, ICLR, ICBP )
      IPOS( 5 ) = IBLOCK
      IPOS( 6 ) = ICLR
      IPOS( 7 ) = ICBP
 7000 CONTINUE
      CALL CLOSE ( MCB , REW )
      RETURN        
      END

      SUBROUTINE RCOVR
C
C     MAIN DRIVER FOR PHASE 2 SUBSTRUCTURING RECOVER OPERATION
C
C     THIS MODULE WILL CALCULATE THE DISPLACEMENT AND REACTION MATRICES
C     FOR ANY OF THE SUBSTRUCTURES COMPOSING THE FINAL SOLUTION STRUC-
C     TURE.  OUTPUT DATA MAY BE PLACED ON OFP PRINT FILES OR SAVED ON
C     THE SOF FOR SUBSEQUENT PROCESSING.
C
C     DMAP CALLING SEQUENCES
C
C     RIGID FORMATS 1 AND 2  (STATIC ANALYSIS)
C
C     RCOVR   CASESS,GEOM4,KGG,MGG,PG,UGV,,,,,/OUGV1,OPG1,OQG1,U1,
C             U2,U3,U4,U5/DRY/ILOOP/STEP/FSS/RFNO/0/LUI/U1NM/U2NM/
C             U3NM/U4NM/U5NM/S,N,NOSORT2/V,Y,UTHRESH/V,Y,PTHRESH/
C             V,Y,QTHRESH $
C
C     RIGID FORMAT 3  (MODAL ANALYSIS)
C
C     RCOVR   CASESS,LAMA,KGG,MGG,,PHIG,,,,,/OPHIG,,OQG1,U1,U2,U3,
C             U4,U5/DRY/ILOOP/STEP/FSS/RFNO/NEIGV/LUI/U1NM/U2NM/
C             U3NM/U4NM/U5NM/S,N,NOSORT2/V,Y,UTHRESH/V,Y,PTHRESH/
C             V,Y,QTHRESH $
C
C     RIGID FORMAT 8  (FREQUENCY ANALYSIS)
C
C     RCOVR   CASESS,GEOM4,KGG,MGG,PPF,UPVC,DIT,DLT,BGG,K4GG,PPF/
C             OUGV1,OPG1,OQG1,U1,U2,U3,U4,U5/DRY/ILOOP/STEP/FSS/
C             RFNO/0/LUI/U1NM/U2NM/U3NM/U4UN/U5NM/S,N,NOSORT2/
C             V,Y,UTHRESH/V,Y,PTHRESH/V,Y,QTHRESH $
C
C     RIGID FORMAT 9  (TRANSIENT ANALYSIS)
C
C     RCOVR   CASESS,GEOM4,KGG,MGG,PPT,UPV,DIT,DLT,BGG,K4GG,TOL/
C             OUGV1,OPG1,OQG1,U1,U2,U3,U4,U5/DRY/ILOOP/STEP/FSS/
C             RFNO/0/LUI/U1NM/U2NM/U3NM/U4UN/U5NM/S,N,NOSORT2/
C             V,Y,UTHRESH/V,Y,PTHRESH/V,Y,QTHRESH $
C
C     MRECOVER  (ANY RIGID FORMAT)
C
C     RCOVR   ,,,,,,,,,,/OPHIG,,OQG1,U1,U2,U3,U4,U5/DRY/ILOOP/
C             STEP/FSS/3/NEIGV/LUI/U1NM/U2NM/U3NM/U4NM/U5NM/
C             S,N,NOSORT2/V,Y,UTHRESH/V,Y,PTHRESH/V,Y,QTHRESH $
C
C     MAJOR SUBROUTINES FOR RCOVR ARE -
C
C     RCOVA - COMPUTES THE SOLN ITEM FOR THE FINAL SOLUTION STRUCTURE
C     RCOVB - PERFORMS BACK-SUBSTITUTION TO RECOVER DISPLACEMENTS OF
C             LOWER LEVEL SUBSTRUCTURES FROM THOSE OF THE FINAL SOLUTION
C             STRUCTURE
C     RCOVC - COMPUTES REACTION MATRICES AND WRITES OUTPUT DATA BLOCKS
C             FOR THE OFP
C     RCOVO - PROCESS CASESS FOR THE RCOVER COMMAND AND ANY OUTPUT
C             REQUESTS SPECIFIED
C     RCOVE - COMPUTES MODAL ENERGIES AND ERRORS FOR A MODAL REDUCED
C             SUBSTRUCTURE
C
C     JUNE 1977
C
      INTEGER ENERGY
      COMMON /BLANK / DRY        ,LOOP       ,STEP       ,FSS(2)     ,
     1                RFNO       ,NEIGV      ,LUI        ,UINMS(2,5) ,
     2                NOSORT     ,UTHRES     ,PTHRES     ,QTHRES
      COMMON /RCOVCM/ MRECVR     ,UA         ,PA         ,QA         ,
     1                IOPT       ,RSS(2)     ,ENERGY     ,UIMPRO     ,
     2                RANGE(2)   ,IREQ       ,LREQ       ,LBASIC
C
      NOSORT = -1
      CALL RCOVO
      CALL RCOVA
      IF (IOPT .LT. 0) GO TO 10
      CALL RCOVB
      IF (IOPT .LE. 0) GO TO 10
      CALL RCOVC
      IF (ENERGY .NE. 0) CALL RCOVE
   10 RETURN
      END

      SUBROUTINE SIHEX1 (TYPE,STRSPT,NIP)
C
C     PHASE 1 STRESS ROUTINE FOR IHEX1, IHEX2, AND IHEX3 ELEMENTS
C
C     TYPE = 1    IHEX1
C     TYPE = 2    IHEX2
C     TYPE = 3    IHEX3
C
C     THE EST ENTRIES ARE
C
C     NAME  ---------INDEX---------   DESCRIPTION
C            IHEX1   IHEX2   IHEX3
C
C     EID        1       1       1    ELEMENT ID NO.
C     SIL      2-9    2-21    2-33    SCALAR INDEX LIST
C     MID       10      22      34    MATERIAL ID NO.
C     CID       11      23      35    MATERIAL COORD. SYSTEM ID NO.
C     NIP       12      24      36    NO. INTEGRATION POINTS PER EDGE
C     MAXAR     13      25      37    MAX ASPECT RATIO
C     ALFA      14      26      38    MAX ANGLE FOR NORMALS
C     BETA      15      27      39    MAX ANGLE FOR MIDSIDE POINTS
C     BGPDT  16-47  28-107  40-167    BASIC GRID POINT DATA
C     GPT    48-55 108-127 168-199    GRID POINT TEMPERATURES
C
C     PHIOUT (ESTA) CONTAINS THE FOLLOWING WHERE NGP IS THE NUMBER
C     OF GRID POINTS
C
C     ELEMENT ID
C     NGP SIL NUMBERS
C     NGP VALUES OF THE SHAPE FUNCTIONS AT THIS STRESS POINT
C     REFERENCE TEMPERATURE
C     6 THERMAL STRESS COEFFICIENTS
C     NGP, 6 BY 3 MATRICES, RELATING STRESS TO DISPLACEMENTS AT THIS
C          STRESS POINT (STORED ROW-WISE)
C
      LOGICAL         TDEP     ,ANIS       ,RECT       ,MTDEP
      INTEGER         CID      ,BGPID      ,TYPE       ,IEST(1)    ,
     1                EID      ,IPHIO(1)   ,STRSPT     ,ITAB(3,64) ,
     2                IB(46)
      REAL            NU       ,JACOB      ,DSHPB(3,32),BXYZ(3)    ,
     1                GAUSS(8) ,S(4)       ,GMAT(36)   ,STORE(18)
      CHARACTER       UFM*23   ,UWM*25
      COMMON /XMSSG / UFM      ,UWM
      COMMON /SYSTEM/ SYSBUF   ,IPRNT      ,JUNK(7)    ,MTEMP
      COMMON /MATIN / MID      ,INFLAG     ,TEMP
      COMMON /MATOUT/ E        ,G          ,NU         ,RHO        ,
     1                ALPHA    ,TREF       ,SPACE(19)  ,MTDEP
      COMMON /MATISO/ BUFM6(46)
      COMMON /SDR2X5/ EST(100) ,PHIOUT(649)
      COMMON /SDR2X6/ CID      ,BGPID(32)  ,EID        ,BGPDT(3,32),
     1                GPT(32)  ,JACOB(3,3) ,DSHP(3,32) ,DETJ       ,
     2                D        ,E1         ,E2         ,E3         ,
     3                T(3,3)   ,NGP        ,SGLOB(18)
      EQUIVALENCE     (EST(1),IEST(1),DSHPB(1,1)),
     1                (PHIOUT(1),IPHIO(1)),(EST(97),IDXYZ),
     2                (EST(98),BXYZ(1))   ,(IB(1),BUFM6(1))
      DATA    GAUSS/  .57735027, .55555556, .77459667, .88888889 ,
     1                .34785485, .86113631, .65214515, .33998104 /
C
      IF (STRSPT .EQ. 0) STRSPT = STRSPT + 1
      IF (STRSPT .GT. 1) GO TO 505
C
C     MOVE EST DATA INTO /SDR2X6/, /MATIN/, AND PHIOUT
C
      EID = IEST(1)
      NGP = 12*TYPE - 4
      MID = IEST(NGP+2)
      CID = IEST(NGP+3)
      NIP = IEST(NGP+4)
      IF (NIP .EQ. 0) NIP = TYPE/2 + 2
C
C     FOR STRESS COMPUTATION, SET NUMBER OF STRESS POINTS TO 2
C     NUMBER OF GAUSS POINTS) TO CUT DOWN ON AMOUNT OF INFO ON ESTA
C
      NIP = 2
      L   = 0
      DO 5 I = 1,NIP
      DO 5 J = 1,NIP
      DO 5 K = 1,NIP
      L   = L + 1
      ITAB(1,L) = I
      ITAB(2,L) = J
      ITAB(3,L) = K
    5 CONTINUE
      DO 10 I = 1,NGP
      GPT(  I) = EST (5*NGP+7+I)
      BGPID(I) = IEST(NGP+4+4*I)
      DO 10 J = 1,3
      BGPDT(J,I) = EST(NGP+4+4*I+J)
   10 CONTINUE
      PHIOUT(1) = EST(1)
      DO 20 I = 1,NGP
   20 PHIOUT(I+1) = EST(I+1)
C
C     FETCH MATERIAL PROPERTIES
C
C     CHANGE FOR GENERAL ANISOTROPIC MATERIAL
C
C     TEST FOR ANISOTROPIC MATERIAL
C
      ANIS   = .FALSE.
      INFLAG = 10
C
C     TEST FOR RECTANGULAR COORDINATE SYSTEM IN WHICH ANISOTROPIC
C     MATERIAL IS DEFINED
C
      RECT = .TRUE.
      TDEP = .TRUE.
C
      DO 60 I = 2,NGP
      IF (GPT(I) .NE. GPT(1)) GO TO 70
   60 CONTINUE
      TDEP = .FALSE.
   70 TEMP = GPT(1)
      CALL MAT (EID)
      IF (IB(46) .EQ. 6) ANIS = .TRUE.
      TREF = BUFM6(44)
      IF (.NOT.MTDEP) TDEP = .FALSE.
C
C     IF ISOTROPIC, TEMPERATURE INDEPENDENT MATERIAL, COMPUTE CONSTANTS
C
      IF (TDEP) GO TO 500
      IF (ANIS) GO TO 490
      IF (IB(46) .NE. 0) GO TO 480
      WRITE  (IPRNT,470) UWM,MID,EID
  470 FORMAT (A25,' 4005. AN ILLEGAL VALUE OF -NU- HAS BEEN SPECIFIED',
     1       ' UNDER MATERIAL ID =',I10,' FOR ELEMENT ID =',I10, /32X,
     2       'NU = 0.333 ASSUMED FOR STRESS COMPUTATION')
      E1 = 1.5*E
      E2 = 0.75*E
      E3 = 0.375*E
      GO TO 490
  480 E1 = BUFM6(1)
      E2 = BUFM6(2)
      E3 = BUFM6(22)
      ALPHA = BUFM6(38)
      GO TO 500
C
C     IF MATERIAL IS ANISOTROPIC, DEFINED IN A RECTANGULAR
C     COORDINATE SYSTEM, AND NOT TEMPERATURE DEPENDENT, TRANSFORM
C     IT TO THE BASIC SYSTEM.
C
  490 IF (.NOT.RECT) GO TO 500
C
C     ADD CODE TO TRANSFORM GENERAL ANISOTROPIC MATERIAL
C     TO BASIC COORDINATE SYSTEM HERE.
C
      DO 491 IJK = 1,36
  491 GMAT(IJK) = BUFM6(IJK)
C
C     INITIALIZATION TO FIND GAUSS POINT COORDINATES
C
  505 CONTINUE
  500 NIPM1 = NIP - 1
      GO TO (510,520,530), NIPM1
  510 S(1) = GAUSS(1)
      S(2) =-GAUSS(1)
      GO TO  540
  520 S(1) = GAUSS(3)
      S(2) = 0.
      S(3) =-GAUSS(3)
      GO TO  540
  530 S(1) = GAUSS(6)
      S(2) = GAUSS(8)
      S(3) =-GAUSS(8)
      S(4) =-GAUSS(6)
  540 IF (STRSPT .EQ. NIP**3+1) GO TO 541
      L = ITAB(1,STRSPT)
      X = S(L)
      L = ITAB(2,STRSPT)
      Y = S(L)
      L = ITAB(3,STRSPT)
      Z = S(L)
      GO TO 542
  541 X = 0.
      Y = 0.
      Z = 0.
  542 CONTINUE
C
C     GENERATE SHAPE FUNCTIONS AND JACOBIAN MATRIX INVERSE
C
      CALL IHEXSS (TYPE,PHIOUT(NGP+2),DSHP,JACOB,DETJ,EID,X,Y,Z,BGPDT)
      IF (DETJ .NE. 0.0) GO TO 605
C
C     FALL HERE IF JACOBIAN MATRIX SINGULAR (BAD ELEMENT)
C
      J = NGP*19 + 7
      DO 600 I = 1,J
  600 PHIOUT(NGP+1+I) = 0.0
      RETURN
C
C     COMPUTE STRAIN-DISPLACEMENT RELATIONS
C
C     REVERSE CALLING SEQUENCE SINCE MATRICES ARE COLUMN STORED
C
  605 CALL GMMATS (DSHP,NGP,3,0,JACOB,3,3,0,DSHPB)
C
C     IF MATERIAL IS TEMPERATURE DEPENDENT, MUST COMPUTE TEMPERATURE
C     AT THIS STRESS POINT AND FETCH MATERIAL PROPERTIES AGAIN
C
      IF (.NOT.TDEP) GO TO 620
      TEMP = 0.0
      DO 610 J = 1,NGP
  610 TEMP = TEMP + GPT(J)*PHIOUT(NGP+1+J)
      CALL MAT (EID)
      IF (ANIS) GO TO 630
      IF (IB(46) .NE. 0) GO TO 615
      WRITE (IPRNT,470) UWM,MID,EID
      E1 = 1.5*E
      E2 = 0.75*E
      E3 = 0.375*E
      GO TO 640
  615 E1 = BUFM6(1)
      E2 = BUFM6(2)
      E3 = BUFM6(22)
      ALPHA = BUFM6(38)
      GO TO 640
C
C     IF MATERIAL IS ANISOTROPIC AND NOT DEFINED IN RECTANGJLAR
C     COORDINATE SYSTEM, TRANSFORM IT TO BASIC COORDINATE SYSTEM AT
C     THIS STRESS POINT.
C
C
C     IN THIS VERSION, ANISOTROPIC PROPERTIES MUST BE RECTANGULAR
C     JUST STORE G MATRIX
C     ===========================================================
C
C     THIS CODE MUST BE COMPLETED WHEN GENERAL ANISOTROPIC MATERIAL IS
C     ADDED.
C
  620 IF (.NOT.ANIS) GO TO 640
  630 CONTINUE
      DO 635 IJK = 1,36
  635 GMAT(IJK) = BUFM6(IJK)
C
C     INSERT GLOBAL TO BASIC TRANSFORMATION OPERATIONS HERE FOR
C     ANISOTROPIC MATERIAL.
C
C     MATERIAL HAS BEEN EVALUATED AT THIS STRESS POINT WHEN GET TO HERE
C
C     TEMPERATURE TO STRESS VECTOR
C
  640 PHIOUT(2*NGP+2) = TREF
      IF (ANIS) GO TO 660
C
C     ISOTROPIC CASE
C
      DO 650 J = 1,3
      PHIOUT(2*NGP+2+J) = -ALPHA*(E1+2.0*E2)
      PHIOUT(2*NGP+5+J) = 0.0
  650 CONTINUE
      GO TO 670
C
C     ANISOTROPIC CASE
C
C     ADD CODE WHEN ANISOTROPIC MATERIAL BECOMES AVAILABLE
C
  660 CONTINUE
      CALL GMMATS (GMAT,6,6,0,BUFM6(38),6,1,0,PHIOUT(2*NGP+3))
      DO 661 IJK = 1,6
      IS = 2*NGP + 2 + IJK
      PHIOUT(IS) = -PHIOUT(IS)
  661 CONTINUE
C
C     DISPLACEMENT TO STRESS MATRICES
C
  670 DO 840 I = 1,NGP
      IS = 2*NGP + 8 + 18*(I-1)
C
C     ROW-STORED
C
      IF (ANIS) GO TO 680
C
C     ISOTROPIC CASE
C
      PHIOUT(IS+ 1) = E1*DSHPB(1,I)
      PHIOUT(IS+ 2) = E2*DSHPB(2,I)
      PHIOUT(IS+ 3) = E2*DSHPB(3,I)
      PHIOUT(IS+ 4) = E2*DSHPB(1,I)
      PHIOUT(IS+ 5) = E1*DSHPB(2,I)
      PHIOUT(IS+ 6) = E2*DSHPB(3,I)
      PHIOUT(IS+ 7) = E2*DSHPB(1,I)
      PHIOUT(IS+ 8) = E2*DSHPB(2,I)
      PHIOUT(IS+ 9) = E1*DSHPB(3,I)
      PHIOUT(IS+10) = E3*DSHPB(2,I)
      PHIOUT(IS+11) = E3*DSHPB(1,I)
      PHIOUT(IS+14) = E3*DSHPB(3,I)
      PHIOUT(IS+15) = E3*DSHPB(2,I)
      PHIOUT(IS+16) = E3*DSHPB(3,I)
      PHIOUT(IS+18) = E3*DSHPB(1,I)
      PHIOUT(IS+12) = 0.0
      PHIOUT(IS+13) = 0.0
      PHIOUT(IS+17) = 0.0
      GO TO 690
C
C     ANISOTROPIC CASE
C
C     ADD CODE WHEN GENERAL ANISOTROPIC MATERIAL BECOMES AVAILABLE
C
  680 CONTINUE
      DO 681 IJK = 1,18
  681 STORE(IJK) = 0.
      STORE( 1) = DSHPB(1,I)
      STORE( 5) = DSHPB(2,I)
      STORE( 9) = DSHPB(3,I)
      STORE(10) = DSHPB(2,I)
      STORE(11) = DSHPB(1,I)
      STORE(14) = DSHPB(3,I)
      STORE(15) = DSHPB(2,I)
      STORE(16) = DSHPB(3,I)
      STORE(18) = DSHPB(1,I)
C
      CALL GMMATS (GMAT(1),6,6,0,STORE(1),6,3,0,PHIOUT(IS+1))
C
C     POST-MULTIPLY BY GLOBAL TO BASIC TRANSFORMATION MATRIX,
C     IF NECESSARY
C
  690 IF (BGPID(I) .EQ. 0) GO TO 840
      IDXYZ = BGPID(I)
      DO 820 K = 1,3
  820 BXYZ(K) = BGPDT(K,I)
C
C     FETCH TRANSFORMATION AND USE IT
C
      CALL TRANSS (IDXYZ,T)
      CALL GMMATS (PHIOUT(IS+1),6,3,0,T,3,3,0,SGLOB)
      DO 830 J = 1,18
  830 PHIOUT(IS+J) = SGLOB(J)
  840 CONTINUE
      IPHIO(20*NGP+9) = NIP
      NWDNOW = 20*NGP + 9
      NWDISO = 649 - NWDNOW
      IF (NWDISO .EQ. 0) RETURN
      DO 850 I = 1,NWDISO
      ISUB = NWDNOW + I
  850 PHIOUT(ISUB) = 0.
      RETURN
      END

      SUBROUTINE FRD2A (NQHL,QHR,QHI,IH,NFREQ)
C
      INTEGER         QHR,QHI,SYSBUF,MCB(7),THR(7),THI(7)
      DIMENSION       Z(1)
      COMMON /ZZZZZZ/ Z
      COMMON /SYSTEM/ SYSBUF
      COMMON /UNPAKX/ IOUT,INN,NNN,INCR1
      COMMON /PACKX / ITI,ITO,II,NN,INCR
C
C     FIND COLUMN OF NQHL AND COPY REAL TO QHR AND IMAG TO QHI
C
      NZ = KORSZ(Z) - SYSBUF
      MCB(1) = NQHL
      CALL RDTRL (MCB)
      IF (MCB(2) .EQ.0) GO TO 999
      IOUT = MCB(5)
      ITI  = 1
      IF (IOUT .EQ. 4) ITI = 2
      ITO  = ITI
      NNN  = MCB(3)
      INN  = 1
      INCR1= 1
      II   = 1
      NN   = IH
      INCR = 2
      NWC  = 2
      IF (IOUT .EQ. 4) NWC = 4
      IBUF1 = NZ
      IBUF2 = IBUF1 - SYSBUF
      CALL OPEN (*999,NQHL,Z(IBUF1),0)
      CALL READ (*999,*999,NQHL,Z(1),-2,1,FLAG)
      CALL MAKMCB (THR,QHR,IH,MCB(4),ITO)
      CALL MAKMCB (THI,QHI,IH,MCB(4),ITO)
      CALL SKPREC (NQHL,NFREQ-1)
      CALL UNPACK (*25,NQHL,Z(1))
      GO TO 30
   25 CALL ZEROC  (Z,NNN*NWC)
   30 J = 1
      CALL CLOSE (NQHL,1)
      CALL GOPEN (QHR,Z(IBUF2),1)
      CALL GOPEN (QHI,Z(IBUF1),1)
      DO 40 I = 1,IH
      CALL PACK (Z(J),QHR,THR)
      CALL PACK (Z(J+1),QHI,THI)
      J = J + IH*NWC
   40 CONTINUE
      CALL CLOSE  (QHR,1)
      CALL CLOSE  (QHI,1)
      CALL WRTTRL (THR)
      CALL WRTTRL (THI)
      CALL DMPFIL (-QHR,Z,NZ)
      CALL DMPFIL (-QHI,Z,NZ)
      GO TO 1000
  999 CALL MAKMCB (THR,QHR,0,0,0)
      CALL WRTTRL (THR)
      THR(1) = QHI
      CALL WRTTRL (THR)
 1000 RETURN
      END

      SUBROUTINE MRED2G (KODE)
C
C     THIS SUBROUTINE CALCULATES THE FINAL STRUCTURAL MATRICES FOR THE
C     MRED2 MODULE.
C
C     INPUT DATA
C     GINO -   KBB    - STIFFNESS PARTITION MATRIX
C              KIB    - KIB  STIFFNESS PATTITION MATRIX
C              HIE    - HIE  PARTITION MATRIX
C              KII    - KII  PARTITION MATRIX
C              HGH    - HORG PARTITION MATRIX
C              MAA    - MASS INPUT MATRIX
C              BAA    - DAMPING INPUT MATRIX
C              K4AA   - STIFFNESS INPUT MATRIX
C              PAA    - LOADS INPUT MATRIX
C     SOF  -   GIMS   - G TRANSFORMATION MATRIX
C
C     OUTPUT DATA
C     GINO -   KHH    - STIFFNESS MATRIX
C              MHH    - MASS MATRIX
C              BHH    - DAMPING MATRIX
C              K4HH   - K4HH  MATRIX
C              PHH    - LOADS MATRIX
C     SOF  -   KMTX   - STIFFNESS MATRIX
C              MMTX   - MASS  MATRIX
C              PVEC   - LOADS MATRIX
C              PAPP   - APPENDED LOADS MATRIX
C              BMTX   - DAMPING MATRIX
C              K4MX   - K4MX STIFFNESS MATRIX
C
C     PARAMETERS
C     INPUT  - POPT   - LOADS OPTION FLAG
C              GBUF   - GINO BUFFERS
C              INFILE - INPUT   FILE NUMBERS
C              OTFILE - OUTPUT  FILE NUMBERS
C              ISCR   - SCRATCH FILE NUMBERS
C              KORLEN - LENGTH OF OPEN CORE
C              KORBGN - BEGINNING ADDRESS OF OPEN CORE
C              OLDNAM - NAME OF SUBSTRUCTURE BEING REDUCED
C     OTHERS - PAA    - LOADS INPUT FILE NUMBER
C              KHH    - STIFFNESS I
C              KHH    - STIFFNESS OUTPUT FILE NUMBER
C              POVE   - LOADS OUTPUT FILE NUMBER
C              UPRT   - PARTITION VECTOR FILE NUMBER
C              ZEROEB - ZERO PARTITION FILE NUMBER
C              KBB    - KBB INPUT FILE NUMBER
C              ZEROBE - ZERO PARTITION MATRIX
C              KIB    - KIB INPUT FILE NUMBER
C              KII    - KII INPUT FILE NUMBER
C              KBARBB - KBARBB FILE NU BER
C              GIB    - GIB INPUT FILE NUMBER
C              KEE    - KEE FILE NUMBER
C              HGH    - HORG INPUT FILE NUMBER
C
      LOGICAL          FREBDY,BOUNDS,MODES,PONLY
      INTEGER          DRY,POPT,GBUF1,SBUF1,SBUF2,SBUF3,OTFILE,OLDNAM,Z,
     1                 T,SIGNAB,SIGNC,PREC,SCR,TYPIN,TYPOUT,UN,UB,UI,
     2                 FUSET,PREC3,ZEROBE,ZEROEB,BLANKS,PAPP,PAA,POVE,
     3                 UPRT,GIB,HGH,HIE,RPRTN,CPRTN,USETMR,DBLKOR,EQST
      DOUBLE PRECISION DZ
      DIMENSION        MODNAM(2),ITRLR1(7),ITRLR2(7),ITRLR3(7),ISUB(4),
     1                 ITMLST(11),ITMNAM(2),RZ(1),DZ(1)
      CHARACTER        UFM*23
      COMMON /XMSSG /  UFM
      COMMON /BLANK /  IDUM1,DRY,POPT,GBUF1,IDUM2(2),SBUF1,SBUF2,SBUF3,
     1                 INFILE(12),OTFILE(6),ISCR(10),KORLEN,KORBGN,
     2                 OLDNAM(2),NEWNAM(2),FREBDY,IDUM6(5),BOUNDS,MODES,
     3                 IDUM7(4),PONLY,LSTZWD
      COMMON /ZZZZZZ/  Z(1)
      COMMON /SYSTEM/  IDUM3,IPRNTR
      COMMON /MPYADX/  ITRLRA(7),ITRLRB(7),ITRLRC(7),ITRLRD(7),NZ,T,
     1                 SIGNAB,SIGNC,PREC,SCR,DUMM
      COMMON /PACKX /  TYPIN,TYPOUT,IROW,NROW,INCR
      COMMON /BITPOS/  IDUM4(9),UN,IDUM5(10),UB,UI
      COMMON /PATX  /  LCORE,NSUB(3),FUSET
      COMMON /MPY3TL/  JTRLRA(7),JTRLRB(7),JTRLRE(7),JTRLRC(7),JSCR(3),
     1                 LKORE,ICODE,PREC3,DUMMY(13)
      EQUIVALENCE      (EQST,INFILE(5)),(USETMR,INFILE(5)),
     1                 (PAA,INFILE(10)),(KHH,OTFILE(1)),(POVE,OTFILE(6))
      EQUIVALENCE      (ZEROBE,ISCR(1)),(UPRT,ISCR(1)),(KIB,ISCR(2)),
     1                 (ZEROEB,ISCR(3)),(KII,ISCR(3)),(KBB,ISCR(1)),
     2                 (GIB,ISCR(4)),(KBARBB,ISCR(5)),(KEE,ISCR(6)),
     3                 (HIE,ISCR(7)),(HGH,ISCR(8)),(RPRTN,ISCR(2)),
     4                 (CPRTN,ISCR(4)),(RZ(1),Z(1)),(DZ(1),Z(1))
      DATA    MODNAM/  4HMRED,4H2G  /,      PAPP  ,BLANKS/4HPAPP,4H    /
      DATA    ITMLST/  4HKMTX,4HMMTX,4HBMTX,4HK4MX,4HPVEC,4HPAPP,4HPOVE,
     1                 4HGIMS,4HHORG,4HPOAP,4HUPRT/
      DATA    MRED2 /  27 /
C
C     SELECT OPERATION
C     KODE = 1, NO SETLVL, NO STIFFNESS CALCULATIONS
C     KODE = 2, SETLVL, STIFFNESS CALCULATIONS
C     KODE = 3, NO SETLVL, NO STIFFNESS CALCULATIONS
C     KODE = 4, SETLVL, NO STIFFNESS CALCULATIONS
C
      IF (DRY .EQ. -2) GO TO 300
      GO TO (90,1,90,1), KODE
C
C     SET UP NEW SUBSTRUCTURE
C
    1 IF (BOUNDS .OR. MODES) GO TO 5
      NUMB = 1
      CALL SETLVL (NEWNAM,NUMB,OLDNAM,ITEST,MRED2)
      IF (ITEST .EQ. 8) GO TO 290
    5 IF (KODE  .EQ. 4) GO TO 90
C
C     FORM PRELIMINARY STIFFNESS CALCULATION
C
C                                      T
C        **      **   **   **   **   ** **   **
C        *        *   *     *   *     * *     *
C        * KBARBB * = * KBB * + * GIB * * KIB *
C        *        *   *     *   *     * *     *
C        **      **   **   **   **   ** **   **
C
      ITRLR1(1) = KBB
      CALL RDTRL (ITRLR1)
      ITEM = ITMLST(8)
      ITMNAM(1) = OLDNAM(1)
      ITMNAM(2) = OLDNAM(2)
      CALL SOFTRL (OLDNAM,ITEM,ITRLR2)
      ITEST = ITRLR2(1)
      IF (ITEST .NE. 1) GO TO 200
      CALL MTRXI (GIB,OLDNAM,ITEM,0,ITEST)
      IF (ITEST .NE. 1) GO TO 200
      CALL SOFCLS
      ITRLR2(1) = GIB
      CALL RDTRL (ITRLR2)
      ITRLR3(1) = KIB
      CALL RDTRL (ITRLR3)
      DO 10 I = 1,7
      ITRLRA(I) = ITRLR2(I)
      ITRLRB(I) = ITRLR3(I)
   10 ITRLRC(I) = ITRLR1(I)
      IFORM = 6
      IPRC  = 1
      ITYP  = 0
      IF ((ITRLRA(5) .EQ. 2) .OR. (ITRLRA(5) .EQ. 4)) IPRC = 2
      IF ((ITRLRB(5) .EQ. 2) .OR. (ITRLRB(5) .EQ. 4)) IPRC = 2
      IF ((ITRLRC(5) .EQ. 2) .OR. (ITRLRC(5) .EQ. 4)) IPRC = 2
      IF (ITRLRA(5) .GE. 3) ITYP = 2
      IF (ITRLRB(5) .GE. 3) ITYP = 2
      IF (ITRLRC(5) .GE. 3) ITYP = 2
      ITYPE = IPRC + ITYP
      CALL MAKMCB (ITRLRD,KBARBB,ITRLR1(3),IFORM,ITYPE)
      T      = 1
      SIGNAB = 1
      SIGNC  = 1
      PREC   = 0
      SCR    = ISCR(9)
      DBLKOR = KORBGN/2 + 1
      NZ = LSTZWD - (2*DBLKOR - 1)
      CALL MPYAD  (DZ(DBLKOR),DZ(DBLKOR),DZ(DBLKOR))
      CALL WRTTRL (ITRLRD)
      KBAROW = ITRLRD(3)
      KCOL   = ITRLRD(2)
C
C     FORM PRELIMINARY STIFFNESS CALCULATION
C
C                         T
C        **   **   **   ** **   ** **   **
C        *     *   *     * *     * *     *
C        * KEE * = * HIE * * KII * * HIE *
C        *     *   *     * *     * *     *
C        **   **   **   ** **   ** **   **
C
      ITRLR1(1) = HIE
      ITRLR2(1) = KII
      CALL RDTRL (ITRLR1)
      CALL RDTRL (ITRLR2)
      DO 20 I = 1,7
      JTRLRA(I) = ITRLR1(I)
      JTRLRB(I) = ITRLR2(I)
   20 JTRLRE(I) = 0
      IPRC = 1
      ITYP = 0
      IF (JTRLRA(5).EQ.2 .OR. JTRLRA(5).EQ.4) IPRC = 2
      IF (JTRLRB(5).EQ.2 .OR. JTRLRB(5).EQ.4) IPRC = 2
      IF (JTRLRA(5).GE.3 .OR. JTRLRB(5).GE.3) ITYP = 2
      ITYPE = IPRC + ITYP
      CALL MAKMCB (JTRLRC,KEE,ITRLR1(2),IFORM,ITYPE)
      JSCR(1) = ISCR(9)
      JSCR(2) = ISCR(2)
      JSCR(3) = ISCR(1)
      LKORE   = NZ
      ICODE   = 0
      PREC3   = 0
      CALL MPY3DR (DZ(DBLKOR))
      CALL WRTTRL (JTRLRC)
      KEEROW = JTRLRC(3)
      KEECOL = JTRLRC(2)
C
C     GENERATE MERGE PARTITION VECTOR
C
      NROW = KCOL + KEECOL
      DO 80 I = 1,NROW
      RZ(KORBGN+I-1) = 0.0
      IF (I .GT. KCOL) RZ(KORBGN+I-1) = 1.0
   80 CONTINUE
      TYPIN  = 1
      TYPOUT = 1
      IROW   = 1
      INCR   = 1
      IFORM  = 7
      CALL MAKMCB (ITRLR1,RPRTN,NROW,IFORM,TYPIN)
      CALL GOPEN  (RPRTN,Z(GBUF1),1)
      CALL PACK   (RZ(KORBGN),RPRTN,ITRLR1)
      CALL CLOSE  (RPRTN,1)
      CALL WRTTRL (ITRLR1)
C
C     FORM STIFFNESS MATRIX
C
C                  **            **
C                  *        .     *
C        **   **   * KBARBB .  0  *
C        *     *   *        .     *
C        * KHH * = *..............*
C        *     *   *        .     *
C        **   **   *   0    . KEE *
C                  *        .     *
C                  **            **
C
      ISUB(1) = KCOL
      ISUB(2) = KEECOL
      ISUB(3) = KBAROW
      ISUB(4) = KEEROW
      IFORM   = 6
      CALL GMMERG (KHH,KBARBB,0,0,KEE,RPRTN,RPRTN,ISUB,IFORM,Z(KORBGN),
     1             KORLEN)
C
C     STORE KHH AS KMTX ON SOF
C
      CALL SOFOPN (Z(SBUF1),Z(SBUF2),Z(SBUF3))
      ITMNAM(1) = NEWNAM(1)
      ITMNAM(2) = NEWNAM(2)
      CALL MTRXO (KHH,NEWNAM,ITMLST(1),0,ITEST)
      ITEM = ITMLST(1)
      IF (ITEST .NE. 3) GO TO 200
      GO TO 100
C
C     LOCATE HGH MATRIX
C
   90 CALL MTRXI (HGH,OLDNAM,ITMLST(9),0,ITEST)
      ITEM = ITMLST(9)
      ITMNAM(1) = OLDNAM(1)
      ITMNAM(2) = OLDNAM(2)
      IF (ITEST .NE. 1) GO TO 200
  100 SIGNAB = 1
      SIGNC  = 1
      SCR    = ISCR(1)
      DBLKOR = KORBGN/2 + 1
      LCORE  = LSTZWD - (2*DBLKOR - 1)
C
C     GENERATE MATRICES REQUESTED
C     I = 2, GENERATE MHH MATRIX
C     I = 3, GENERATE BHH MATRIX
C     I = 4, GENERATE K4HH MATRIX
C     I = 5, GENERATE PHH MATRIX
C
      DO 180 I = 2,5
      ITRLR1(1) = INFILE(I+5)
      CALL RDTRL (ITRLR1)
      IF (ITRLR1(1) .LT. 0) GO TO 180
      CALL SOFCLS
C
C     CALCULATE MATRIX REQUIRED
C
C                                T
C        **          **   **   ** **          ** **   **
C        *            *   *     * *            * *     *
C        * (M,B,K4)HH * = * HGH * * (M,B,K4)AA * * HGH *
C        *            *   *     * *            * *     *
C        **          **   **   ** **          ** **   **
C
C                         T
C        **   **   **   ** **   **
C        *     *   *     * *     *
C        * PHH * = * HGH * * PAA *
C        *     *   *     * *     *
C        **   **   **   ** **   **
C
      ITRLR2(1) = HGH
      CALL RDTRL (ITRLR2)
      ITEM = ITMLST(I)
      IF (I.EQ.5 .AND. POPT.EQ.PAPP) ITEM = ITMLST(6)
      DO 120 J = 1,7
      JTRLRA(J) = ITRLR2(J)
      JTRLRB(J) = ITRLR1(J)
  120 JTRLRE(J) = 0
      IFORM = 6
      IPRC  = 1
      ITYP  = 0
      IF (JTRLRA(5).EQ.2 .OR. JTRLRA(5).EQ.4) IPRC = 2
      IF (JTRLRB(5).EQ.2 .OR. JTRLRB(5).EQ.4) IPRC = 2
      IF (JTRLRA(5).GE.3 .OR. JTRLRB(5).GE.3) ITYP = 2
      ITYPE = IPRC + ITYP
      CALL MAKMCB (JTRLRC,OTFILE(I),ITRLR2(2),IFORM,ITYPE)
      JSCR(1) = ISCR(9)
      JSCR(2) = ISCR(2)
      JSCR(3) = ISCR(1)
      ICODE   = 0
      IF (I .EQ. 5) ICODE = 1
      PREC3 = 0
      CALL MPY3DR (DZ(DBLKOR))
      CALL WRTTRL (JTRLRC)
C
C     STORE MATRIX ON SOF
C     I = 2, STORE MHH AS MMTX
C     I = 3, STORE BHH AS BMTX
C     I = 4, STORE K4HH AS K4MX
C     I = 5, STORE PHH AS PVEC OR PAPP
C
      CALL SOFOPN (Z(SBUF1),Z(SBUF2),Z(SBUF3))
      ITMNAM(1) = NEWNAM(1)
      ITMNAM(2) = NEWNAM(2)
      CALL MTRXO (OTFILE(I),NEWNAM,ITEM,0,ITEST)
      IF (ITEST .NE. 3) GO TO 200
  180 CONTINUE
C
C     TEST FOR LOAD PROCESSING
C
      IF (POPT .EQ. BLANKS) GO TO 190
      IF (.NOT. PONLY) GO TO 184
      ITRLR1(1) = EQST
      CALL RDTRL (ITRLR1)
      NSUB(1 )  = ITRLR1(6)
      NSUB(2)   = ITRLR1(7)
      ITEM      = ITMLST(11)
      ITMNAM(1) = OLDNAM(1)
      ITMNAM(2) = OLDNAM(2)
      CALL MTRXI (UPRT,OLDNAM,ITEM,0,ITEST)
      IF (ITEST .NE. 1) GO TO 200
      GO TO 188
C
C     PARTITION PAA VECTOR
C
  184 LCORE = KORLEN
      FUSET = USETMR
      CALL CALCV (UPRT,UN,UI,UB,Z(KORBGN))
  188 CONTINUE
      CALL GMPRTN (PAA,POVE,0,0,0,0,UPRT,NSUB(1),NSUB(2),Z(KORBGN),
     1             KORLEN)
C
C     SAVE POVE AS POVE OR POAP ON SOF
C
      IF (MODES) GO TO 190
      ITEM = ITMLST(7)
      IF (POPT .EQ. PAPP) ITEM = ITMLST(10)
      CALL MTRXO (POVE,OLDNAM,ITEM,0,ITEST)
      IF (ITEST .NE. 3) GO TO 200
  190 CONTINUE
      GO TO 300
C
C     PROCESS MODULE ERRORS
C
  200 GO TO (210,220,230,240,250,270), ITEST
  210 IMSG = -9
      GO TO 280
  220 IMSG = -11
      GO TO 280
  230 IMSG = -1
      GO TO 260
  240 IMSG = -2
      GO TO 260
  250 IMSG = -3
  260 CALL SMSG (IMSG,ITEM,ITMNAM)
      GO TO 300
  270 IMSG = -10
  280 DRY  = -2
      CALL SMSG1 (IMSG,ITEM,ITMNAM,MODNAM)
      GO TO 300
  290 WRITE  (IPRNTR,295) UFM
  295 FORMAT (A23,' 6518, ONE OF THE COMPONENT SUBSTRUCTURES HAS BEEN ',
     1       'USED IN A PREVIOUS COMBINE OR REDUCE.')
      DRY = -2
  300 RETURN
      END

      SUBROUTINE CFER3S (V1,V1L,V2,V2L,V3,V3L,V4,V4L,V5,V5L,ZB,ZC)
C
C     CFER3S IS A SINGLE PRECISION ROUTINE (CALLED BY CFEER3) WHICH
C     PERFORMS THE TRIDIAGONAL REDUCTION FOR THE COMPLEX FEER METHOD
C
      LOGICAL           SUCESS   ,NO B     ,SKIP     ,AGAIN      ,
     1                  QPR      ,SYMMET
      INTEGER           CSP      ,NAME(2)
      REAL              LAMBDA   ,TEMP1(2)
      DOUBLE PRECISION  TEMP2
      DIMENSION         ZB(1)    ,ZC(1)    ,S(8)     ,A(2)       ,
     1                  V1(1)    ,V1L(1)   ,V2(1)    ,V2L(1)     ,
     2                  V3(1)    ,V3L(1)   ,V4(1)    ,V4L(1)     ,
     3                  V5(1)    ,V5L(1)   ,DSAVE(2) ,D(4)
      CHARACTER         UFM*23   ,UWM*25
      COMMON  /XMSSG /  UFM      ,UWM
      COMMON  /FEERAA/  IKMB(7,3),ILAM(7)  ,IPHI(7)  ,DUDXX      ,
     1                  ISCR(11) ,DUMAA(84),MCBVEC(7)
      COMMON  /FEERXC/  LAMBDA(4),SYMMET   ,MREDUC   ,NORD       ,
     1                  IDIAG    ,EPSDUM(2),NORTHO   ,NORD2      ,
     2                  NORD4    ,NORDP1   ,NSWP(2)  ,NO B       ,
     3                  IT       ,TEN2MT   ,TENMHT   ,NSTART     ,
     4                  QPR      ,REGDUM(2),NZERO    ,XCDUM(3)   ,
     5                  NUMRAN
      COMMON  /SYSTEM/  KSYSTM(65)
      COMMON  /UNPAKX/  IPRC     ,II       ,NN       ,INCR
      COMMON  /PACKX /  ITP1     ,ITP2     ,IIP      ,NNP        ,
     1                  INCRP
      COMMON  /NAMES /  RD       ,RDREW    ,WRT      ,WRTREW     ,
     1                  REW      ,NOREW    ,EOFNRW   ,RSP        ,
     2                  RDP      ,CSP      ,CDP      ,SQR
      EQUIVALENCE       (A(1),D(3))        ,(KSYSTM(2),NOUT )    ,
     1                  (D(1),S(1))        ,(TEMP1(1) ,TEMP2)
      DATA     ZERO  /  0.           /
      DATA     NAME  /  4HCFER,4H3S  /
C
C     DEFINITION OF INPUT AND OUTPUT PARAMETERS
C
C     V1,V2,V3,V4,V5  = AREAS OF OPEN CORE DESIGNATED BY SUBROUTINE
C                       CFEER3 AND USED INTERNALLY AS WORKING VECTORS,
C                       USUALLY RIGHT-HANDED
C     V1L,.......,V5L = SAME AS V1 THRU V5 BUT USUALLY LEFT-HANDED
C     RESTRICTION ..... LEFT-HANDED VECTOR MUST IMMEDIATELY FOLLOW
C                       CORRESPONDING RIGHT-HANDED VECTOR IN CORE
C                       ALSO, V2 SHOULD FOLLOW V1L FOR READ TO WORK
C     ZB,ZC           = REQUIRED GINO BUFFERS
C
C     DEFINITION OF INTERNAL PARAMETERS
C
C     A        = DIAGONAL ELEMENTS OF REDUCED TRIDIAGONAL MATRIX
C     D        = OFF-DIAG ELEMENTS OF REDUCED TRIDIAGONAL MATRIX
C     AGAIN    = LOGICAL INDICATOR FOR CYCLING THRU LOGIC AGAIN WHEN
C                NULL VECTOR TEST (D-BAR) FAILS
C     SKIP     = LOGICAL INDICATOR FOR AVOIDING REDUNDANT OPERATIONS
C     NORTHO   = TOTAL CURRENT NUMBER OF VECTOR PAIRS ON ORTHOGONAL
C                VECTOR FILE
C     NZERO    = NUMBER OF EIGENVECTOR PAIRS ON EIGENVECTOR FILE
C                (RESTART AND PRIOR NEIGHBORHOODS)
C     LANCOS   = LANCZOS ALGORITHM COUNTER
C     NSTART   = NUMBER OF INITIAL REORTHOGONALIZATION ATTEMPTS
C
      IF (QPR) WRITE (NOUT,8887)
 8887 FORMAT (1H1,50X,6HCFER3S,/1H0)
C
C     SET PACK AND UNPACK CONSTANTS
C
      IPRC = CSP
      INCR = 1
      ITP1 = IPRC
      ITP2 = ITP1
      INCRP= INCR
      II   = 1
      IIP  = 1
C
C     NN AND NNP ARE SET LOCALLY
C
      CALL GOPEN (ISCR(7),ZB(1),WRTREW)
      CALL CLOSE (ISCR(7),NOREW)
      IF (NORTHO .EQ. 0) GO TO 20
C
C     LOAD AND RE-NORMALIZE ALL EXISTING VECTORS ON THE NASTRAN
C     EIGENVECTOR FILE (INCLUDES ANY RESTART VECTORS AND ALL VECTORS
C     OBTAINED IN PRIOR NEIGHBORHOODS). PACK THESE VECTORS ON
C     THE ORTHOGONAL VECTOR SCRATCH FILE.
C
      CALL OPEN (*170,IPHI(1),ZC(1),0)
C
C     LEFT-HAND VECTOR IS STORED IMMEDIATELY AFTER RIGHT-HAND VECTOR
C
      NNP   = NORD2
      NORD8 = 2*NORD4
      DO 15 I = 1,NORTHO
            IF (QPR) WRITE (NOUT,8802) I
 8802       FORMAT(1H ,13(10H----------),/,18H ORTHOGONAL VECTOR,I3)
C
C     THIS LOADS VALUES INTO V1, V1L, V2, AND V2L
C
      CALL READ (*190,*5,IPHI(1),V1(1),NORD8+10,0,N3)
      GO TO 210
C
C     COMPRESS PHYSICAL EIGENVECTORS TO SINGLE PRECISION
C
    5 DO 6 J = 1,NORD4
      J2 = J*2
      TEMP1(1) = V1(J2-1)
      TEMP1(2) = V1(J2  )
    6 V1(J) = TEMP2
      IF (IDIAG .EQ. 0) GO TO 13
      DO 8 J = 1,NORD4
      IF (V1(J) .NE. ZERO) GO TO 13
    8 CONTINUE
      WRITE (NOUT,590) I
   13 CONTINUE
            IF (QPR) WRITE (NOUT,8803) (V1 (J),J=1,NORD2)
            IF (QPR) WRITE (NOUT,8803) (V1L(J),J=1,NORD2)
 8803       FORMAT (1H ,(1H ,4E25.16))
      CALL CFNOR1 (V1(1),V1L(1),NORD2,0,D(1))
      IF (IDIAG.NE.0 .AND. NORD2.LE.70) WRITE (NOUT,570) I,
     1               (V1(J),V1(J+1),V1L(J),V1L(J+1),J=1,NORD2,2)
      CALL GOPEN (ISCR(7),ZB(1),WRT)
      CALL PACK  (V1(1),ISCR(7),MCBVEC(1))
      CALL CLOSE (ISCR(7),NOREW)
   15 CONTINUE
      CALL CLOSE (IPHI(1),NOREW)
      IF (IDIAG .NE. 0) WRITE (NOUT,580) NORTHO,MCBVEC
C
C     GENERATE INITIAL PSEUDO-RANDOM VECTORS
C
   20 N3 = 3*NORD
      IJ = 0
      SS = 1.
      NZERO  = NORTHO
      NSTART = 0
      LANCOS = 0
      AGAIN  = .FALSE.
      D(1)   = ZERO
      D(2)   = ZERO
   25 NUMRAN = NUMRAN + 1
      DO 30 I = 1,NORD4
      IJ = IJ + 1
      SS =-SS
      IF (I .GT. NORD2) GO TO 28
      IF (I .GT. NORD ) GO TO 27
      JJ = 2*I - 1
      GO TO 30
   27 JJ = 2*(I-NORD)
      GO TO 30
   28 IF (I .GT. N3) GO TO 29
      JJ = 2*I - 1 - NORD2
      GO TO 30
   29 JJ = 2*(I-N3) + NORD2
C
C     THIS LOADS VALUES INTO V1 AND V1L
C
   30 V1(JJ) = SS*(MOD(IJ,3)+1)/
     1         (3.*(MOD(IJ,13)+1)*(1+5*FLOAT(I)/NORD))
      IF (QPR) WRITE (NOUT,8844) (V1(I),I=1,NORD4)
 8844 FORMAT (1H0,13(10H----------),/,(1H ,4E25.16))
      IF (QPR) WRITE (NOUT,8845)
 8845 FORMAT (1H ,13(10H----------))
C
C     NORMALIZE RIGHT AND LEFT START VECTORS
C
      CALL CFNOR1 (V1(1),V1L(1),NORD2,0,D(1))
C
C     REORTHOGONALIZE START VECTORS W.R.T. RESTART AND
C     PRIOR-NEIGHBORHOOD VECTORS
C
      CALL CF1ORT (SUCESS,10,TEN2MT,NZERO,LANCOS,
     2             V1(1),V1L(1),V5(1),V5L(1),V3(1),V3L(1),ZB(1))
      IF (SUCESS) GO TO 40
      IF (AGAIN ) GO TO 160
   35 NSTART = NSTART + 1
      IF (NSTART .LE. 2) GO TO 25
      WRITE (NOUT,600) UWM,LAMBDA(1),LAMBDA(3)
      GO TO 450
   40 IF (AGAIN) GO TO 90
C
C     SWEEP START VECTORS CLEAN OF ZERO-ROOT EIGENVECTORS
C
      CALL CFE1AO (.FALSE.,V1 (1),V2 (1),V3 (1),ZB(1))
      CALL CFE1AO (.TRUE .,V1L(1),V2L(1),V3L(1),ZB(1))
C
C     NORMALIZE THE PURIFIED VECTOR AND OBTAIN D(1)
C
      CALL CFNOR1 (V2(1),V2L(1),NORD2,0,D(1))
      IF (NZERO.EQ.0 .OR. NORTHO.GT.NZERO) GO TO 50
C
C     IF RESTART OR BEGINNING OF NEXT NEIGHBORHOOD, PERFORM
C     REORTHOGONALIZATION AND RENORMALIZATION
C
      CALL CF1ORT (SUCESS,10,TEN2MT,NZERO,LANCOS,
     1             V2(1),V2L(1),V5(1),V5L(1),V3(1),V3L(1),ZB(1))
      IF (.NOT.SUCESS) GO TO 35
      CALL CFNOR1 (V2(1),V2L(1),NORD2,0,D(1))
C
C     LOAD FIRST VECTORS TO ORTHOGONAL VECTOR FILE
C
   50 CALL GOPEN (ISCR(7),ZB(1),WRT)
      NNP = NORD2
      CALL PACK  (V2(1),ISCR(7),MCBVEC(1))
      CALL CLOSE (ISCR(7),NOREW)
      NORTHO = NORTHO + 1
C
C     COMMENCE LANCZOS ALGORITHM
C
C     INITIALIZE BY CREATING NULL VECTOR
C
      DO 60  I = 1,NORD2
      V1 (I) = ZERO
   60 V1L(I) = ZERO
      SKIP = .FALSE.
C
C     ENTER LANCZOS LOOP
C
   70 LANCOS = LANCOS + 1
C
C     GENERATE DIAGONAL ELEMENT OF REDUCED TRIDIAGONAL MATRIX
C
      IF (.NOT.SKIP) CALL CFE1AO (.FALSE.,V2(1),V3(1),V5(1),ZB(1))
      SKIP = .FALSE.
      CALL CFNOR1 (V3(1),V2L(1),NORD2,1,A(1))
C
C     COMPUTE D-BAR
C
      CALL CFE1AO (.TRUE.,V2L(1),V3L(1),V5(1),ZB(1))
      DO 80 I = 1,NORD2,2
      J = I + 1
      V4(I) = V3(I) - A(1)*V2(I) + A(2)*V2(J) - D(1)*V1(I) + D(2)*V1(J)
      V4(J) = V3(J) - A(1)*V2(J) - A(2)*V2(I) - D(1)*V1(J) - D(2)*V1(I)
      V4L(I) = V3L(I) - A(1)*V2L(I) + A(2)*V2L(J)
     1                - D(1)*V1L(I) + D(2)*V1L(J)
   80 V4L(J) = V3L(J) - A(1)*V2L(J) - A(2)*V2L(I)
     1                - D(1)*V1L(J) - D(2)*V1L(I)
      CALL CFNOR1 (V4(1),V4L(1),NORD2,2,D(1))
      DSAVE(1) = D(1)
      DSAVE(2) = D(2)
C
C     TEST IF LANCZOS ALGORITHM FINISHED
C
      IF (LANCOS .EQ. MREDUC) GO TO 150
      IF (.NOT.QPR) GO TO 85
      WRITE  (NOUT,8845)
      WRITE  (NOUT,8886) D
 8886 FORMAT (8H D-BAR =,2E16.8,9X,3HA =,2E16.8)
      WRITE  (NOUT,8844) (V4 (I),I=1,NORD2)
      WRITE  (NOUT,8844) (V4L(I),I=1,NORD2)
      WRITE  (NOUT,8845)
   85 CONTINUE
C
C     NULL VECTOR TEST
C
      IF (SQRT(D(1)**2+D(2)**2) .GT. SQRT(A(1)**2+A(2)**2)*TENMHT)
     1    GO TO 100
      IF (IDIAG .NE. 0) WRITE (NOUT,610) D
      AGAIN = .TRUE.
      GO TO 25
   90 CALL CFE1AO (.FALSE.,V1 (1),V4 (1),V3 (1),ZB(1))
      CALL CFE1AO (.TRUE .,V1L(1),V4L(1),V3L(1),ZB(1))
C
C     PERFORM REORTHOGONALIZATION
C
  100 CALL CFNOR1 (V4(1),V4L(1),NORD2,0,D(1))
      CALL CF1ORT (SUCESS,10,TEN2MT,NZERO,LANCOS,
     1             V4(1),V4L(1),V3(1),V3L(1),V5(1),V5L(1),ZB(1))
      IF (.NOT.SUCESS) GO TO 160
C
C     NORMALIZE THE REORTHOGONALIZED VECTORS
C
      CALL CFNOR1 (V4(1),V4L(1),NORD2,0,D(1))
C
C     GENERATE OFF-DIAGONAL ELEMENT OF REDUCED TRIDIAGONAL MATRIX
C
      CALL CFE1AO (.FALSE.,V4(1),V3(1),V5(1),ZB(1))
      SKIP = .TRUE.
      CALL CFNOR1 (V3(1),V2L(1),NORD2,1,D(1))
      IF (AGAIN) GO TO 105
C
C     NULL VECTOR TEST
C
      IF (SQRT(D(1)**2+D(2)**2) .LE. SQRT(A(1)**2+A(2)**2)*TENMHT)
     1    GO TO 160
      GO TO 110
  105 AGAIN = .FALSE.
      D(1)  = ZERO
      D(2)  = ZERO
C
C     TRANSFER TWO ELEMENTS TO REDUCED TRIDIAGONAL MATRIX FILE
C
  110 CALL WRITE (ISCR(5),S(1),4,1)
      IF (IDIAG .NE. 0) WRITE (NOUT,560) LANCOS,D
C
C     LOAD CURRENT VECTORS TO ORTHOGONAL VECTOR FILE
C
      CALL GOPEN (ISCR(7),ZB(1),WRT)
      NNP = NORD2
      CALL PACK  (V4(1),ISCR(7),MCBVEC(1))
      CALL CLOSE (ISCR(7),NOREW)
      NORTHO = NORTHO + 1
C
C     TRANSFER (I+1)-VECTORS TO (I)-VECTORS AND CONTINUE LANCZOS LOOP
C
      DO 130 I = 1,NORD2
      V1 (I) = V2 (I)
      V1L(I) = V2L(I)
      V2 (I) = V4 (I)
  130 V2L(I) = V4L(I)
      GO TO 70
C
C     TRANSFER TWO ELEMENTS TO REDUCED TRIDIAGONAL MATRIX FILE
C
  150 IF (D(1).NE.ZERO .OR. D(2).NE.ZERO) GO TO 155
      D(1) = DSAVE(1)
      D(2) = DSAVE(2)
  155 CALL WRITE (ISCR(5),S(1),4,1)
      IF (IDIAG .NE. 0) WRITE (NOUT,560) LANCOS,D
      GO TO 450
  160 MREDUC = LANCOS
      WRITE (NOUT,500) UWM,MREDUC,LAMBDA(1),LAMBDA(3)
      IF (.NOT.AGAIN) GO TO 150
      D(1) = ZERO
      D(2) = ZERO
      GO TO 150
C
  170 I = -1
  180 CALL MESAGE (I,IPHI(1),NAME)
  190 I = -2
      GO TO 180
  210 I = -8
      GO TO 180
C
  450 RETURN
C
  500 FORMAT (A25,' 3157', //5X,'FEER PROCESS MAY HAVE CALCULATED ',
     1       'FEWER ACCURATE MODES',I5,
     2       ' THAN REQUESTED IN THE NEIGHBORHOOD OF ',2E14.6,//)
  560 FORMAT (36H REDUCED TRIDIAGONAL MATRIX ELEMENTS,5X,3HROW,I4, /10X,
     1        14HOFF-DIAGONAL =,2E24.16, /14X,10HDIAGONAL =,2E24.16)
  570 FORMAT (1H0,17HORTHOGONAL VECTOR,I4, /1H0,23X,5HRIGHT,56X,4HLEFT,
     1        //,(1H ,2E25.16,10X,2E25.16))
  580 FORMAT (1H0,I10,32H ORTHOGONAL VECTOR PAIRS ON FILE,I5,12X,6I8,/)
  590 FORMAT (18H ORTHOGONAL VECTOR,I4,8H IS NULL)
  600 FORMAT (A25,' 3158', //5X,'NO ADDITIONAL MODES CAN BE FOUND BY ',
     1       'FEER IN THE NEIGHBORHOOD OF ',2E14.6,//)
  610 FORMAT (14H D-BAR IS NULL,10X,4E20.12)
      END

      SUBROUTINE ALAMDA (ARG,Y,BLAMDA)
C
C     SUBROUTINE FOR COMPUTING LAMDA
C
      COMPLEX BLAMDA,AI,C1
C
      COMMON/BLK1/SCRK,SPS,SNS,DSTR,AI,PI,DEL,SIGMA,BETA,RES
C
      SCRK1= ABS(SCRK)
      ARG1=  ABS(ARG)
      S1=(ARG-DEL)*SPS+SIGMA
      IF( SCRK1.GT.ARG1) GO TO 10
      GAM=SQRT(ARG**2-SCRK**2)
      C1=COS(GAM*(SNS-Y))-CEXP(AI*S1)*COS(GAM*Y)
      C2=COS(SNS*GAM)-COS(S1)
      BLAMDA=C1/C2
      RETURN
   10 CONTINUE
      GAM=SQRT(SCRK**2-ARG**2)
      C1=COSH(GAM*(SNS-Y))-CEXP(AI*S1)*COSH(GAM*Y)
      C2=COSH(SNS*GAM)-COS(S1)
      BLAMDA=C1/C2
      RETURN
      END

      SUBROUTINE WALTIM (WALSEC)
C
C     THIS ROUTINE OBTAINS THE CURRENT WALL CLOCK TIME IN SECONDS,
C     PASS MID-NIGHT
C
      INTEGER WALSEC, TIME(3)
C
      CALL ITIME ( TIME )
      WALSEC = TIME(1) * 3600 + TIME(2) * 60 + TIME(3)
      RETURN
      END

      SUBROUTINE GFSDIR
C
C     THIS ROUTINE PERFORMS THE DIRECT FORMULATION OF THE
C     FLUID/STRUCTURE MATRICES
C
      EXTERNAL      ANDF
      INTEGER       SCR1     ,SCR2     ,SCR3     ,SCR4     ,SCR5     ,
     1              SCR6     ,SCR7     ,SCR8     ,AXY      ,AFRY     ,
     2              KYY      ,DKAA     ,DKFRFR   ,KAA      ,MAA      ,
     3              GM       ,GO       ,USETS    ,USETF    ,KMAT     ,
     4              MMAT     ,GIA      ,PVEC     ,IDENT    ,KJJL     ,
     5              ANYBAR   ,AFY      ,AWY      ,SCR9     ,KAABAR   ,
     6              AMY      ,AAYBAR   ,AWJ      ,KJJ      ,GJW      ,
     7              ANY      ,AOY      ,AJW      ,AC       ,GYW      ,
     8              AAY      ,KWWBAR   ,MWWBAR   ,KC       ,H        ,
     9              USET     ,MCB(7)   ,MBIT     ,SBIT     ,SFBIT    ,
     O              OBIT     ,UM       ,US       ,UO       ,UG       ,
     1              UN       ,UA       ,UF       ,UY       ,UAB      ,
     2              UFR      ,UI       ,Z        ,SYSBUF   ,TWO      ,
     3              FILE     ,TYPIN    ,TYPOUT   ,BADD(11) ,NAME(2)  ,
     4              UR       ,USG      ,USB      ,UL       ,UX       ,
     5              UZ       ,BIT      ,AYW      ,MT       ,HC       ,
     6              COMPTP   ,ANDF
      REAL          RZ(1)    ,KCOMP    ,RBADD(12)
      DOUBLE PRECISION        DBADD(5)
C
C     MODULE PARAMETERS
C
      COMMON / BLANK  /       NOGRAV   ,NOFREE   ,KCOMP   ,COMPTP    ,
     1                        FORM     ,LMODES
C
C     SYSTEM COMMON
C
      COMMON / SYSTEM /       SYSBUF
C
C     CALCV COMMON BLOCK
C
      COMMON / PATX   /       LCORE    ,NSUB0    ,NSUB1    ,NSUB2    ,
     1                        USET
C
C     OPEN CORE
C
      COMMON / ZZZZZZ /       Z(1)
C
C     PACK COMMON BLOCKS
C
      COMMON / ZBLPKX /       A(4)     ,IROW
      COMMON / PACKX  /       TYPIN    ,TYPOUT   ,II       ,NN       ,
     1                        INCR
C
C     POWERS OF TWO
C
      COMMON / TWO    /       TWO(32)
C
C     USET BIT POSITIONS
C
      COMMON / BITPOS /       UM       ,UO       ,UR       ,USG      ,
     1                        USB      ,UL       ,UA       ,UF       ,
     2                        US       ,UN       ,UG       ,BIT(12)  ,
     3                        UX       ,UY       ,UFR      ,UZ       ,
     4                        UAB      ,UI
C
C     SCRATCH FILE ASSIGNMENTS
C
      EQUIVALENCE   (BADD(1),RBADD(2)) , (DBADD(1),RBADD(3)) ,
     1              (RZ(1), Z(1)),
     2              (SCR1 , PVEC , IDENT , KJJL) ,
     3              (SCR2 , ANYBAR , AFY , AWY ) ,
     4              (SCR3 , AMY , AAYBAR , AWJ , GJW , KJJ) ,
     5              (SCR4 , AOY , AJW , GYW)  ,
     6              (SCR5 , AAY , KWWBAR , AYW ) ,
     7              (SCR6 , AC) ,
     8              (SCR7 , KC  , MT) ,
     9              (SCR8 , H)  ,
     O              (SCR9 , GIA)
C
C     GINO FILE ASSIGNMENTS
C
      DATA          AXY      ,AFRY     ,KYY      ,DKAA     ,DKFRFR   ,
     1              KAA      ,MAA      ,GM       ,GO       ,USETS    ,
     2              USETF    ,KMAT     ,MMAT     ,HC       ,
     3              GIA      ,SCR1     ,SCR2     ,SCR3     ,SCR4     ,
     4              SCR5     ,SCR6     ,SCR7     ,SCR8               /
     5              101      ,102      ,103      ,104      ,105      ,
     6              106      ,107      ,108      ,109      ,110      ,
     7              111      ,201      ,202      ,205      ,
     8              203      ,301      ,302      ,303      ,304      ,
     9              305      ,306      ,307      ,308                /
C
      DATA   NAME / 4HGFSD   ,4HIR     /
      DATA   BADD / 11*0     /
C
C
      ANY    = SCR4
      KAABAR = SCR2
      MWWBAR = SCR6
C
      LCORE = KORSZ(Z(1))
      IBUF  = LCORE - SYSBUF - 1
      IF (IBUF .LT. 0) GO TO 1008
C
C     REDUCE FLUID / STRUCTURE AREA MATRIX.  MATRIX IS TREATED AS
C     A LOAD VECTOR
C
      MCB(1) = USETS
      CALL RDTRL (MCB)
      MBIT = ANDF(MCB(5),TWO(UM))
      SBIT = ANDF(MCB(5),TWO(US))
      OBIT = ANDF(MCB(5),TWO(UO))
C
      USET = USETS
C
C     PARTITION OUT MULTIPOINT CONSTRAINTS
C
      IF (MBIT) 10,20,10
   10 CALL CALCV  (PVEC,UG,UN,UM,Z(1))
      CALL GFSPTN (AXY,ANYBAR,AMY,0,0,0,PVEC)
      CALL SSG2B  (GM,AMY,ANYBAR,ANY,1,2,1,SCR1)
      GO TO 30
C
   20 ANY = AXY
C
C     PARTITION OUT SINGLE POINT CONSTRAINTS
C
   30 IF (SBIT) 40,50,40
   40 CALL CALCV  (PVEC,UN,UF,US,Z(1))
      CALL GFSPTN (ANY,AFY,0,0,0,0,PVEC)
      GO TO 60
C
   50 CALL GFSWCH (AFY,ANY)
C
C     PARTITION OUT OMITS
C
   60 IF (OBIT) 70,80,70
   70 CALL CALCV  (PVEC,UF,UA,UO,Z(1))
      CALL GFSPTN (AFY,AAYBAR,AOY,0,0,0,PVEC)
      CALL SSG2B  (GO,AOY,AAYBAR,AAY,1,2,1,SCR1)
      GO TO 85
C
   80 CALL GFSWCH (AAY,AFY)
C
C     IF FREE SURFACE POINTS EXIST - MERGE THEM WITH THE REDUCED
C     AREA MATRIX
C
   85 USET = USETF
      IF (NOFREE) 100,90,90
   90 CALL CALCV  (PVEC,UA,UAB,UFR,Z(1))
      CALL GFSMRG (AWY,AAY,AFRY,0,0,0,PVEC)
      GO TO 110
C
  100 CALL GFSWCH (AWY,AAY)
C
C     DETERMINE IF ANY SINGLE POINT CONSTRAINTS EXIST ON THE FLUID
C
  110 CALL CALCV (PVEC,UY,UF,US,Z(1))
      NUY   = NSUB0 + NSUB1
      SFBIT = 1
      IF (NSUB1 .EQ. 0) SFBIT = 0
C
C     IF SPC POINTS EXIST ON THE FLUID - PARTITION THEM OUT OF
C     THE FLUID AREA AND STIFFNESS MATRIX
C
      IF (SFBIT) 120,130,120
  120 CALL GFSPTN (AWY,AWJ,0,0,0,PVEC,0)
      CALL GFSTRN (AWJ,AJW,SCR2,SCR5)
      CALL GFSPTN (KYY,KJJ,0,0,0,PVEC,PVEC)
      GO TO 170
C
C     NO SPC POINTS EXIST ON THE FLUID
C
C     CONSTRAIN THE FIRST FLUID POINT TO REMOVE ANY POTENTIAL
C     SINGULARITIES
C
  130 CALL GFSSPC (NUY,PVEC)
      NSUB0 = NUY - 1
      NSUB1 = 1
      CALL GFSPTN (KYY,KJJ,0,0,0,PVEC,PVEC)
C
C     GENERATE THE H TRANSFORMATION MATRIX
C
      CALL GFSH   (NUY,H)
      CALL GFSTRN (AWY,AYW,SCR1,SCR6)
      CALL SSG2B  (H,AYW,0,AJW,0,2,1,SCR6)
C
C     CHECK COMPRESSIBLITY TYPE
C
      IF (COMPTP .GT. 0) GO TO 140
C
C     A SPRING WILL BE GENERATED TO COUPLE THE STRUCTURE AND THE
C     FREE SURFACE TO RESTRICT VOLUME CHANGES
C
C     COMPUTE THE COMPRESSIBLITY MATRIX WHICH CONTAINS THIS SPRING
C
      CALL GFSCOM (AWY,NUY,KC,IDENT,AC,SCR5)
      GO TO 170
C
C     PURELY INCOMPRESSIBLE APPROACH - A CONSTRAINT EQUATION IS
C     GENERATED TO RESTRICT VOLUME CHANGE
C
C     GENERATE HC MATRIX WHICH CONTAINS THE CONSTRAINT
C
  140 CALL GFSHC (AWY,NUY,HC,IDENT,AC,MROW)
C
C     SOLVE FOR THE INITIAL PRESSURE TRANSFORMATION MATRIX
C
  170 CALL FACTOR (KJJ,KJJL,SCR2,SCR5,SCR6,SCR9)
      CALL SSG3A  (0,KJJL,AJW,GJW,SCR5,SCR6,-1,0)
C
C     IF GRAVITY EXISTS - ADD THE ADDITIONAL STIFFNESS
C
      IF (NOGRAV) 190,180,180
  180 BADD (1) = 2
      DBADD(1) = 1.0D0
      BADD (7) = 2
      DBADD(4) = 1.0D0
      CALL SSG2C (KAA,DKAA,KAABAR,0,BADD)
      GO TO 200
C
  190 KAABAR = KAA
C
C     IF FREE SURFACE EXISTS - MERGE THE STIFFNESS TO SOLUTION SIZE
C     AND EXPAND THE MASS MATRIX
C
  200 IF (NOFREE) 220,210,210
  210 CALL CALCV  (PVEC,UA,UAB,UFR,Z(1))
      CALL GFSMRG (KWWBAR,KAABAR,0,0,DKFRFR,PVEC,PVEC)
      CALL GFSMRG (MWWBAR,MAA,0,0,0,PVEC,PVEC)
      GO TO 230
C
  220 CALL GFSWCH (KWWBAR,KAABAR)
      MWWBAR = MAA
C
C     COMPUTE THE FINAL MASS MATRIX
C     FOR COMPTP = 1 THIS MATRIX IS NOT THE FINAL ONE
C
  230 CALL SSG2B (AJW,GJW,MWWBAR,MMAT,1,2,1,SCR2)
C
C     COMPUTE THE FINAL STIFFNESS MATRIX
C
      IF (SFBIT) 260,240,260
  240 IF (COMPTP .GT. 0) GO TO 250
C
C     ADD IN THE SPRING FACTOR KC
C
      BADD (1) = 2
      DBADD(1) = 1.0D0
      BADD (7) = 2
      DBADD(4) = 1.0D0
      CALL SSG2C (KWWBAR,KC,KMAT,0,BADD)
      GO TO 270
C
C     APPLY THE CONSTRAINT EQUATION TO STIFFNESS AND MASS FOR
C     THE INCOMPRESSIBLE APPROACH
C
  250 CALL SSG2B (HC,KWWBAR,0,SCR2,1,2,1,SCR1)
      CALL SSG2B (SCR2,HC,0,KMAT,0,2,1,SCR1)
      CALL SSG2B (HC,MMAT,0,SCR2,1,2,1,SCR1)
      CALL SSG2B (SCR2,HC,0,MT,0,2,1,SCR1)
C
C     ADD 1.0 TO THE NULL COLUMN IN THE MASS MATRIX TO PREVENT
C     SINGULATITIES
C
      CALL GFSMT (MT,MMAT,MROW)
      GO TO 270
C
  260 CALL GFSWCH (KMAT,KWWBAR)
C
C     TRANSFORM THE FINAL PRESSURE TRANSFORMATION MATRIX OR IF
C     SPC POINTS EXIST ON THE FLUID MERGE IN ZEROS
C
  270 IF (SFBIT) 300,280,300
  280 CALL SSG2B (H,GJW,0,GYW,1,2,1,SCR5)
      GO TO 310
C
  300 CALL CALCV  (PVEC,UY,UF,US,Z(1))
      CALL GFSMRG (GYW,GJW,0,0,0,0,PVEC)
C
C     PARTITON OUT THE FREE SURFACE POINTS
C
  310 IF (NOFREE) 330,320,320
  320 CALL CALCV  (PVEC,UY,UFR,UI,Z(1))
      CALL GFSPTN (GYW,0,GIA,0,0,0,PVEC)
      RETURN
C
  330 CALL GFSWCH (GIA,GYW)
      RETURN
C
C     ERROR CONDITIONS
C
 1008 N = -8
      CALL MESAGE (N,FILE,NAME)
      RETURN
      END

      SUBROUTINE SROD2
C*****
C THIS ROUTINE IS PHASE II OF STRESS DATA RECOVERY FOR THE ROD.
C*****
      REAL    CFRVEC(4),FRLAST(2)
      INTEGER EJECT    ,ISHD(7)  ,TYP(4)
C
      COMMON   /SYSTEM/  IBFSZ    ,NOUT     ,IDM(9)   ,LINE
      COMMON /SDR2DE/ SKP2DE(8),IELTYP
C
C SDR2 VARIABLE CORE
C
      COMMON   /ZZZZZZ/  ZZ(1)
C
C BLOCK FOR POINTERS, LOADING TEMPERATURE AND ELEMENT DEFORMATION.
C
      COMMON   /SDR2X4/
     1                   DUMMY(33)          ,ICSTM
     2,                  NCSTM              ,IVEC
     3,                  IVECN              ,TEMPLD
     4,                  ELDEFM
C
C SDR2 INPUT AND OUTPUT BLOCK
C
      COMMON   /SDR2X7/
     1                   IELID              ,ISILNO(2)
     2,                  SAT(3)             ,SBT(3)
     3,                  SAR(3)             ,SBR(3)
     4,                  ST                 ,SDELTA
     5,                  AREA               ,FJOVRC
     6,                  T SUBC 0           ,SIGMAT
     7,                  SIGMAC             ,SIGMAS
     8,                  DUMMY2(77)
     9,                  JSELID             ,SIGMA
     T,                  SMSIG              ,TAU
     1,                  SMTAU              ,DUMMY3(95)
     2,                  JFELID             ,P
     3,                  TORQUE             ,DUMMY4(22)
C
C SCRATCH BLOCK
C
      COMMON   /SDR2X8/
     1                   TRANA              ,TRANB
     2,                  ROTA               ,ROTB
     3,                  IUTA               ,IUTB
     4,                  IURA               ,IURB
     5,                  IFRVEC(7)          ,CHKVEC(4)
C
      COMMON /SDR2X9/ NCHK,ISUB,ILD,FRTMEI(2),TWOTOP,FNCHK
C
      EQUIVALENCE
     1                   (TEMPLD,LDTEMP)    ,(SMSIG,MSSIG)
     2,                  (SMTAU,MSTAU)
     3,      (CFRVEC(1),CSIGA) , (CFRVEC(2),CTAU) , (CFRVEC(3),CP)
     4,      (CFRVEC(4),CTRQUE), (IFRVEC(4),CFRVEC(1))
     5,      (ISHD(1),LSUB), (ISHD(2),LLD), (ISHD(6),FRLAST(1))
C
      DATA LLD,LSUB,FRLAST / 2*-1, -1.0E30, -1.0E30 /
      DATA TYP / 4H CON , 4HROD  , 4HTUBE, 1H   /
C
      IDISP = IVEC - 1
      IUTA  = IDISP + ISILNO(1)
      CALL SMMATS (SAT(1),3,1,1, ZZ(IUTA),3,1,0, TRANA,CTRNA)
      IUTB  = IDISP + ISILNO(2)
      CALL SMMATS (SBT(1),3,1,1, ZZ(IUTB),3,1,0, TRANB,CTRNB)
      SIGMA = TRANA + TRANB + SDELTA * ELDEFM
      CSIGA = CTRNA + CTRNB
      IF (LDTEMP .EQ. (-1) ) GO TO 10
      SIGMA = SIGMA + ST * (TEMPLD - T SUBC 0)
   10 IURA  = IUTA + 3
      CHKVEC(1) = SIGMA
      CALL SMMATS (SAR(1),3,1,1, ZZ(IURA),3,1,0, ROTA,CRTA)
      IURB  = IUTB + 3
      CALL SMMATS (SBR(1),3,1,1, ZZ(IURB),3,1,0, ROTB,CRTB)
      TORQUE = ROTA + ROTB
      CP = AREA * CSIGA
      CHKVEC(3) = P
      CTAU = ABS (FJOVRC) * CTRQUE
      CHKVEC(2) = TAU
      CTRQUE = CRTA + CRTB
      CHKVEC(4) = TORQUE
C
C COMPUTE AXIAL FORCE, P, AND TORQUE
C
      P = AREA * SIGMA
      TAU = FJOVRC * TORQUE
C
C COMPUTE MARGIN OF SAFETY IN EXTENSION
C
      IF(SIGMA.LE.0.0)GO TO 101
      IF(SIGMAT.LE.0.0)GO TO 102
      SMSIG=SIGMAT/SIGMA-1.0
      GO TO 180
  101 IF(SIGMA.NE.0.0) GO TO 103
      GO TO 102
  103 IF(SIGMAC .LE. 0.0) GO TO 102
      SMSIG = -SIGMAC/SIGMA - 1.0
      GO TO 180
  102 MSSIG=1
C
C     COMPUTE MARGIN OF SAFETY IN TORSION
C
  180 IF(SIGMAS.LE.0.0) GO TO 190
      IF(TAU.EQ.0.0)GO TO 190
      SMTAU= SIGMAS/ABS(TAU) - 1.0
      GO TO 110
  190 MSTAU=1
  110 JSELID = IELID
      JFELID = IELID
      IF (NCHK .LE. 0 ) GO TO 260
C
C  . CHECK PRECISION...
C
      IFRVEC(3) = IELID
      K = 0
      CALL SDRCHK (CHKVEC,CFRVEC,4,K)
C
      IF (K.EQ.0) GO TO 260
C
C  . LIMITS EXCEEDED...
C
      J = 0
      IFRVEC(1) = TYP(4)
      IF (IELTYP.EQ.10) IFRVEC(1) = TYP(1)
      IFRVEC(2) = TYP(2)
      IF (IELTYP.EQ.3) IFRVEC(2) = TYP(3)
C
      IF (LSUB.EQ.ISUB .AND. FRLAST(1).EQ.FRTMEI(1) .AND.
     1    LLD .EQ.ILD  .AND. FRLAST(2).EQ.FRTMEI(2) ) GO TO 240
C
      LSUB = ISUB
      LLD = ILD
      FRLAST(1) = FRTMEI(1)
      FRLAST(2) = FRTMEI(2)
      J = 1
      CALL PAGE1
C
  220 CALL SD2RHD (ISHD,J)
      LINE = LINE + 1
      WRITE(NOUT,230)
  230 FORMAT(7X,4HTYPE,5X,3HEID,5X,2HSA,5X,2HST,5X,9HAF TORQUE )
      GO TO 245
C
  240 IF (EJECT(2).NE.0) GO TO 220
  245 WRITE(NOUT,250) IFRVEC
  250 FORMAT (1H0,3X,2A4,I7,4F7.1)
  260 CONTINUE
      RETURN
      END

      SUBROUTINE ASPRO (DMAP,VAR,NVAR,OBITS,SOL)
C
C     THIS CODE  PERFORMS THE  ROUTINE PROCESSING OF THE  DMAP ALTERS
C     FOR ASDMAP.  KEY TABLES ARE-
C
C      DMAP  -  RAW  18 WORD PER CARD BCD DATA ON INPUT, VARIABLE
C               CHARACTERS ARE ADDED AND  FIELDS AND CARDS ARE DELETED
C               DEPENDING ON USER INPUT IN  VAR(IABLE) AND OPTION FLAGS.
C
C      VAR      CONTROL DATA AND USER INPUT DATA, 3 WORDS, BCD + DATA
C
C      PTBS     POSITIONS-TO-BE-SET TABLE, CONTENTS-PER ENTRY
C
C                    1   CARD NUMBER IN DMAP
C                    2   FIRST CHARACTER OF MODIFIED FIELD
C                    3   FIRST CHARACTER FOR ADDED VARIABLE
C                    4   NUMBER OF VARIABLE CHARACTERS
C                    5   KEY OF VARIABLE TO BE INSERTED
C                    6   MATRIX OPTION FLAG , 1= K, 2=M, 4=P  ETC
C                    7   OUTPUT CONTROL FLAG, AVOIDS SAME DATA BLOCK
C                        OUTPUT FROM TWO MODULES
C
C      OCT      OPTIONAL CARDS TABLE - EACH ENTRY =
C                   DMAP CARD NO. , DELETE BITS ,  KEEP BITS
C
C      OBITS -  BITS ARE ON FOR REQUIRED MATRICES  =  SUM OF NUMBERS
C                   K=1 , M=2 , P=4 , PA=8 , B=16 , K4=32
C
      EXTERNAL        ANDF
      LOGICAL         RMV,RMVALL
      INTEGER         ANDF,DBS(2,50),DMAP(18,1),FLAG,II(2),NAME(4),
     1                OBITS,OCT(3,50),PTBS(7,200),VAR(3,200),VWORD,SOL,
     2                ALTER,BLANK,AST,SLAS,OBALL,RFMASK(40)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG / UFM,UWM,UIM,SFM
      COMMON /ASDBD / IRDM,NRDM,IXTRA,NXTRA,IOCT,NOCT,IPTBS,NPTBS,
     1                IPH,NPH,IDAT(1)
      COMMON /ZZZZZZ/ SBD(2)
      COMMON /SYSTEM/ IDUM1,IOUT,NOGO
      EQUIVALENCE     (NDBS,SBD(1)),(DBS(1,1),SBD(2))
      DATA    ALTER / 4HALTE /,      BLANK  / 4H     /
      DATA    AST   / 4H*    /,      SLAS   / 4H/    /
      DATA    RFMASK/ 65536,131072,262144,0,0,0,0,524288,1048576,31*0 /
      DATA    OBALL / 63     /
C
      RMVALL = .TRUE.
      NXDEL  = 0
      NOLD   = 0
C
C     DELETE CARDS USING OCT TABLE.
C
      IF (NOCT .EQ. 0) GO TO 45
      M = IOCT - 1
      DO 10 J = 1,NOCT
      DO 10 I = 1,3
      M = M + 1
      OCT(I,J) = IDAT(M)
   10 CONTINUE
      DO 40 I = 1,NOCT
      ICD = OCT(1,I)
      IF (OCT(3,I) .EQ. 0) GO TO 20
      IF (ANDF(OCT(3,I),OBITS)       .EQ. 0) GO TO 35
   20 IF (ANDF(OCT(2,I),RFMASK(SOL)) .EQ. 0) GO TO 40
   35 DMAP(1,ICD) = -1
   40 CONTINUE
   45 IF (NPTBS .EQ. 0) GO TO 2000
      M = IPTBS - 1
      DO 46 J = 1,NPTBS
      DO 46 I = 1,7
      M = M + 1
      PTBS(I,J) = IDAT(M)
   46 CONTINUE
      DO 1000 I = 1,NPTBS
      ICD = PTBS(1,I)
      IF (DMAP(1,ICD) .EQ. -1) GO TO 1000
      IF (ICD .EQ. 0) GO TO 1000
      RMV = .FALSE.
C
C     CHECK IF  OPTION IS ON
C
      KOPT = PTBS(6,I)
      IF (ANDF(KOPT,OBITS) .EQ. 0) RMV = .TRUE.
      IF (ANDF(KOPT,OBALL) .EQ. 0) RMV = .FALSE.
      IF (ANDF(KOPT,RFMASK(SOL)) .NE. 0) RMV = .TRUE.
      NCHAR = PTBS(4,I)
      NC    = 0
      FLAG  = 0
      VWORD = BLANK
      ICOL  = PTBS(3,I)
C
C     FIND  VARIABLE  IF  REQUIRED
C
      IF (RMV) GO TO 300
      KEY = PTBS(5,I)
      I3  = NVAR/3
      DO 60 J = 1,I3
      IF (VAR(1,J) .EQ. KEY) GO TO 70
      IF (KEY.EQ.J .AND. VAR(1,J).EQ.ALTER) GO TO 450
   60 CONTINUE
C
C     VARIABLE HAS NOT BEEN SET
C
      VWORD = BLANK
      RMV   = .TRUE.
      GO TO 300
C
C     VARIABLE  IS FOUND , IT IS IN VAR(2,J) AND/OR VAR(3,J)
C
   70 VWORD   = VAR(2,J)
      NAME(1) = VAR(2,J)
      NAME(2) = VAR(3,J)
C
C     TEST FOR REAL OR INTEGER
C
      IF (VWORD .EQ.  0) GO TO 300
      IF (VWORD .EQ. -1) GO TO 74
      IF (VWORD .EQ. -2) GO TO 3010
C
C     WORD IS REAL (TEMPORARY ERROR)
C
      GO TO 75
C
C     WORD IS AN INTEGER
C
   74 NAME(1) = NAME (2)
      NAME(2) = 0
      FLAG    = 1
   75 IF (PTBS(7,I) .EQ. 0) GO TO 500
      NC    = PTBS(3,I) - PTBS(2,I)
      II(1) = BLANK
      II(2) = BLANK
      IF (NC .GT. 0) GO TO 80
      IF (NC .LT. 0) GO TO 3010
      II(1) = NAME(1)
      II(2) = NAME(2)
      GO TO 100
C
C     CONSTRUCT WHOLE DATA BLOCK NAME
C
   80 CALL PULL (DMAP(1,ICD),II,PTBS(2,I),NC,0)
      CALL PUSH (NAME,II,NC+1,NCHAR,FLAG)
C
C     CHECK OUTPUT DATA BLOCKS AGAINST PREVIOUS OUTPUTS
C
  100 IF (NDBS .EQ. 0) GO TO 142
C
      DO 140 L = 1, NDBS
      IF (II(1).EQ.DBS(1,L) .AND. II(2).EQ.DBS(2,L)) GO TO 150
  140 CONTINUE
  142 IF (PTBS(7,I) .GT. 0) GO TO 200
C
C     VARIABLE IS OK , ADD NAME TO LIST
C
      NDBS = NDBS + 1
      DBS(1,NDBS) = II(1)
      DBS(2,NDBS) = II(2)
      GO TO 500
  150 IF (PTBS(7,I) .GT. 0) GO TO 500
C
C     DATA BLOCK IS OUTPUT, REMOVE IF ALLREADY DEFINED.
C
  200 RMV  =.TRUE.
C
C     REMOVE WHOLE  NAME HERE  , CHECK FOR PARAMETER
C
  300 II(1)   = 0
      NAME(1) = BLANK
      NAME(2) = BLANK
      NAME(3) = BLANK
      NAME(4) = BLANK
      FLAG    = 0
      CALL PULL (DMAP(1,ICD),II,PTBS(2,I),1,0)
      IF (II(1).EQ.SLAS .OR. II(1).EQ.AST) GO TO 500
      ICOL  = PTBS(2,I)
      NCHAR = NCHAR + PTBS(3,I) - PTBS(2,I)
      GO TO 500
C
C     CHECK IF ALTER CARD, OUTPUT AS BCD AND TWO INTEGERS
C
  450 DMAP(1,ICD) = ALTER
      DMAP(2,ICD) = VAR(2,J)
      DMAP(3,ICD) = VAR(3,J)
      RMVALL = .FALSE.
      NXDEL  = 0
      IF (VAR(2,J) .EQ. 0) RMVALL = .TRUE.
      GO TO 910
C
C     ADD VARIABLES TO BCD DMAP
C
  500 CALL PUSH (NAME,DMAP(1,ICD),ICOL,NCHAR,FLAG)
C
      IF (.NOT.RMV) RMVALL = .FALSE.
C
C     IF ALL VARIABLES ARE REMOVED FROM ONE CARD, DELETE THE CARD
C
      NNEW = PTBS(1,I+1)
      IF (ICD .EQ. NNEW) GO TO 1000
C
C     NEXT  COMMAND GOES TO NEW CARD,  CHECK IF CONTINUATION
C
  905 CALL PULL (DMAP(1,ICD+1),II,1,4,0)
C
      IF (II(1) .NE. BLANK) GO TO 910
C
C     CONTINUATION FOUND
C
      NXDEL = NXDEL + 1
      IF (NNEW .EQ. ICD+1) GO TO 1000
      ICD = ICD+1
      GO TO 905
C
C     FINISHED WITH  LOGICAL CARD
C
  910 IF (.NOT.RMVALL) GO TO 940
      DMAP(1,ICD) = -1
      IF (NXDEL .LE. 0) GO TO 1000
      DO 930 L = 1,NXDEL
      J = ICD-L
      DMAP(1,J) = -1
  930 CONTINUE
  940 RMVALL = .TRUE.
C
C     END OF LOOP ON VARIABLE CHARACTERS
C
      NXDEL = 0
C
 1000 CONTINUE
C
C     PROCESS CARDS TO BE DELETED FROM SEQUENCE
C
 2000 IKEEP = 0
      DO 2500 ICD = 1,NRDM
C
      IF (DMAP(1,ICD) .EQ. -1) GO TO 2500
C
C     KEEP CARD
C
      IKEEP = IKEEP + 1
      DO 2450 J = 1,18
      DMAP(J,IKEEP) = DMAP(J,ICD)
 2450 CONTINUE
 2500 CONTINUE
      NRDM = IKEEP
      RETURN
 3010 WRITE  (IOUT,3020) SFM,DMAP(1,ICD)
 3020 FORMAT (A25,' 6010, ILLEGAL VARIABLE TO BE SET IN DMAP STATEMENT',
     1        3X,A4)
C
      NOGO = 1
      RETURN
      END

      SUBROUTINE TRD1D2
C
C     THIS ROUTINE COMPUTES NON-LINEAR LOADS FOR TRANSIENT ANALYSIS
C
C     THIS ROUTINE IS SUITABLE FOR DOUBLE PRECISION OPERATION
C
      LOGICAL          DEC
      INTEGER          IZ(1),PNL,DIT,FILE,SYSBUF,ITLIST(13),NAME(2),
     1                 NMTD(2)
      DIMENSION        Z(1)
      DOUBLE PRECISION X,Y,DZ,H,FX,FY
      CHARACTER        UFM*23,UWM*25
      COMMON /XMSSG /  UFM,UWM
      COMMON /SYSTEM/  SYSBUF,IOUT
      COMMON /MACHIN/  MACH
      COMMON /ZZZZZZ/  DZ(1)
      COMMON /PACKX /  IT1,IT2,II,NROW,INCR
      COMMON /TRDD1 /  NLFT,DIT,NLFTP,NOUT,ICOUNT,ILOOP,MODAL,LCORE,
     1                 ICORE,IU,IP,IPNL(7),NMODES,NSTEP,PNL,IST,IU1,
     2                 DELTAT,IFRST,TABS,SIGMA,TIM
      EQUIVALENCE      (Z(1),IZ(1),DZ(1))
      DATA    ITLIST/  4,1105,11,1,1205,12,2,1305,13,3,1405,14,4/
      DATA    NAME  /  4HNLFT,4HTRDD /
      DATA    NMTD  /  4HTRD1,4HD2   /
      DATA    KOUNT /  0             /
C
C     IDENTIFICATION OF VARIABLES
C
C     NLFT    NON-LINEAR FUNCTION TABLE
C     PNL     NON-LINEAR FORCES --MATRIX
C     DIT     DIRECT INPUT TABLES
C     NLFTP   NON-LINEAR FUNCTION SET SELECTION
C     NOUT    OUT PUT  EVERY NOUT TIME STEPS( PLUS 1 AND NSTEP)
C     ICOUNT  CURRENT INTERATION COUNTER
C     ILOOP   LOOP ON NUMBER OF TIME STEP CHANGES
C     MODAL   LESS THAN ZERO IMPLIES THIS IS A DIRECT FORMULATION
C     LCORE   AMOUNT OF CORE FOR TRD1D
C     ICORE   POINTER TO FIRST CELL OF OPEN CORE
C     IU      POINTER TO LATEST DISPLACEMENT VECTOR
C     IU1     POINTER TO DISPLACEMENT VECTOR -- ONE TIME STEP BACK
C     IP      POINTER TO LOAD VECTOR
C     NMODES  NUMBER OF MODES IN PROBLEM
C     NSTEP   NUMBER OF TIME STEPS
C     ITLIST  LIST OF CARD TYPES FOR DYNAMIC TABLES
C     NROW    SIZE OF SOLUTION SET
C     IBUF1   POINTER TO BUFFER
C     NCARDS  NUMBER OF LOAD CARDS IN SELECTED SET
C     ICARDS  POINTER  TO FIRST CARD
C     NTABL   NUMBER OF TABLES
C     ITABL   POINTER TO FIRST TABLE
C     IPNL    MATRIX CONTROL BLOCK FOR PNL
C
C     DESCRIPTION OF TYPES OF NON-LINEAR LOADING
C
C     TYPE    DESCRIPTION
C     ----    -----------
C
C       1     DISPLACEMENT-DEPENDENT NOLIN1 LOAD
C       2     DISPLACEMENT-DEPENDENT/DISPLACEMENT-DEPENDENT NOLIN2 LOAD
C       3     DISPLACEMENT-DEPENDENT NOLIN3 LOAD
C       4     DISPLACEMENT-DEPENDENT NOLIN4 LOAD
C       5     VELOCITY-DEPENDENT NOLIN1 LOAD
C       6     VELOCITY-DEPENDENT/DISPLACEMENT-DEPENDENT NOLIN2 LOAD
C       7     VELOCITY-DEPENDENT NOLIN3 LOAD
C       8     VELOCITY-DEPENDENT NOLIN4 LOAD
C       9     VELOCITY-DEPENDENT/VELOCITY-DEPENDENT NOLIN2 LOAD
C      10     DISPLACEMENT-DEPENDENT/VELOCITY-DEPENDENT NOLIN2 LOAD
C      11     TEMPERATURE-DEPENDENT CONVECTION NON-LINEAR LOAD (FTUBE)
C      12     TEMPERATURE-DEPENDENT EMISSIVITIES-ABSORPTIVITIES, NOLIN5
C      13     DISPLACEMENT-DEPENDENT/VELOCITY-DEPENDENT NOLIN6 LOAD
C      14     VELOCITY-DEPENDENT/DISPLACEMENT-DEPENDENT NOLIN6 LOAD
C
C     DETERMINE ENTRY NUMBER
C
      DEC = MACH.EQ.5 .OR. MACH.EQ.6 .OR. MACH.EQ.21
      IPX = IP
C
      IF ((ILOOP.EQ.1 .AND. ICOUNT.GT.1) .OR. (ILOOP.GT.1 .AND.
     1     ICOUNT.GT.0)) GO TO 170
      IF (IFRST  .NE. 0) GO TO 170
C
C     FIRST TIME FOR TIME STEP
C
      CALL SSWTCH (10,IALG)
      IBUF1 = LCORE + ICORE - SYSBUF
      FILE  = NLFT
      LCORE = LCORE - SYSBUF - 1
      ICRQ  =-LCORE
      IF (LCORE .LE. 0) GO TO 430
      CALL OPEN (*400,NLFT,IZ(IBUF1),0)
C
C     FIND SELECTED SET ID
C
      CALL READ (*420,*10,NLFT,IZ(ICORE+1),LCORE,0,IFLAG)
      ICRQ = LCORE
      GO TO 430
   10 DO 20 I = 3,IFLAG
      K = I + ICORE
      IF (IZ(K) .EQ. NLFTP) GO TO 30
   20 CONTINUE
      CALL MESAGE (-31,NLFTP,NAME)
C
C     FOUND SET ID -- POSITION TO RECORD IN NLFT
C
   30 K = I-3
      IF (K .EQ. 0) GO TO 50
      DO 40 I = 1,K
      CALL FWDREC (*420,NLFT)
   40 CONTINUE
C
C     BRING IN  8 WORDS PER CARD
C     FORMAT =    TYPE,SILD,SILE,A,SILD,SILE,A OR SILD,SILE
C     CONVERT TO  TYPE,ROWP,ROWP,A,ROWP OR A
C     COUNT NUMBER OF CARDS
C
   50 NCARDS = 0
      ICARDS = ICORE + 1
      K      = ICARDS
   60 ICRQ   = 8 - LCORE
      IF (ICRQ  .GT. 0) GO TO 430
      CALL READ (*420,*80,NLFT,IZ(K),8,0,IFLAG)
      IF (MODAL .LT. 0) GO TO 70
C
C     MODAL FORM -- CONVERT SILE TO ROW POSITIONS AND STORE IN SILD
C
      IF (IZ(K+2) .EQ. 0) GO TO 440
      IZ(K+1) = IZ(K+2) + NMODES
      IF (IZ(K+5) .EQ. 0) GO TO 440
      IZ(K+4) = IZ(K+5) +  NMODES
      IF (IZ(K).NE.2 .AND. IZ(K).NE.6 .AND. IZ(K).NE.9 .AND.
     1    IZ(K).NE.10) GO TO 70
      IF (IZ(K+7) .EQ. 0) GO TO 440
      IZ(K+6) = IZ(K+7) + NMODES
   70 CONTINUE
C
C     MOVE UP
C
      IZ(K+2) = IZ(K+4)
      IZ(K+4) = IZ(K+6)
      K       = K + 5
      LCORE   = LCORE  - 5
      NCARDS  = NCARDS + 1
      GO TO 60
C
C     END OF RECORD-- DONE
C
   80 CALL CLOSE (NLFT,1)
C
C     EXTRACT LIST OF  UNIQUE TABLES FROM CARD TYPES 1,5,11 AND 14
C
      L     = ICARDS
      NTABL = 0
      ITABL = K
      DO 120 I = 1,NCARDS
      IZL = IZ(L)
      IF (IZL.NE.1 .AND. IZL.NE.5 .AND. (IZL.LT.11 .OR. IZL.GT.14))
     1   GO TO 110
      IF (IZL.NE.11 .AND. IZL.NE.12) GO TO 85
      IZL = IZ(L+4)
      IF (IZ(L) .NE. 11) GO TO 83
C
C     NFTUBE CARD
C
   81 NXX = NUMTYP(IZL)
      IF (DEC .AND. IZL.GT.16000 .AND. IZL.LE.99999999) NXX = 1
      IF (NXX-1) 110,85,110
C
C     NOLIN5 CARD
C
   83 NXX   = NUMTYP(IZ(L+3))
      IF (DEC .AND. IZ(L+3).GT.16000 .AND. IZ(L+3).LE.99999999)
     1    NXX = 1
      IF (NXX .NE. 1) GO TO 81
      ITID1 = IZ(L+3)
      NXX   = NUMTYP(IZL)
      IF (DEC .AND. IZL.GT.16000 .AND. IZL.LE.99999999) NXX = 1
      IF (NXX .NE. 1) GO TO 87
      ITID2 = IZ(L+4)
      NUMTB = 2
      GO TO 89
   85 ITID1 = IZ(L+4)
   87 NUMTB = 1
   89 CONTINUE
C
C     FIND OUT IF UNIQUE TABLE
C
      IF (NTABL .EQ. 0) GO TO 100
      DO 90 M = 1,NTABL
      K = ITABL + M
      IF (IZ(K) .EQ. ITID1) GO TO 110
   90 CONTINUE
C
C     NEW TABLE
C
  100 NTABL = NTABL + 1
      K     = ITABL + NTABL
      IZ(K) = ITID1
  110 CONTINUE
      IF (NUMTB .EQ. 1) GO TO 115
      NUMTB = 1
      ITID1 = ITID2
      GO TO 89
  115 L     = L + 5
  120 CONTINUE
C
      IZ(ITABL) = NTABL
      LCORE = LCORE - NTABL - 1
      ICRQ  =-LCORE
      IF (LCORE .LE. 0) GO TO 430
      IF (NTABL .EQ. 0) GO TO 150
C
C     INITIALIZE TABLES
C
      K     = ITABL + NTABL + 1
      CALL PRETAB (DIT,IZ(K),IZ(K),IZ(IBUF1),LCORE,L,IZ(ITABL),ITLIST)
      LCORE = LCORE - L
      IF (IALG .EQ. 0) GO TO 140
      IN1   = (K + L)/2
      IN2   = IN1 + NROW
      IN3   = IN2 + NROW
      LCORE = LCORE - 6*NROW
      ICRQ  =-LCORE
      IF (LCORE .LT. 0) GO TO 430
C
C     ZERO LOAD VECTORS
C
      DO 130 I = 1,NROW
      K     = IN1 + I
      DZ(K) = 0.0D0
      K     = IN2 + I
      DZ(K) = 0.0D0
      K     = IN3 + I
      DZ(K) = 0.0D0
  130 CONTINUE
  140 CONTINUE
  150 RETURN
C
C     COMPUTE LOADS
C
  170 K   = ICARDS + NCARDS*5 - 1
      IF (IALG .EQ. 0) GO TO 180
      IPX = IN1
      DO 175 I = 1,NROW
      L   = IN1 + I
      DZ(L) = 0.0D0
  175 CONTINUE
C
C     LOOP THRU EACH LOAD CARD OR COLLECTION (NOLIN5, NOLIN6)
C
  180 H  = 1.0D0/DELTAT
      I  = ICARDS
  190 CONTINUE
      FX = 0.0D0
      FY = 1.0D0
      M  = IU + IZ(I+2)
      MM = IU + IZ(I+4)
      N  = IU1+ IZ(I+2)
      NN = IU1+ IZ(I+4)
      X  = DZ(M)
      Y  = (X-DZ(N))*H
      L  = IZ(I)
C     L  =     1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14
      GO TO (200,210,220,230,205,213,225,235,215,217,250,260,240,245), L
C
C     NOLIN 1
C
  200 XSP = X
      CALL TAB (IZ(I+4),XSP,FXSP)
      FX = FXSP
      GO TO 290
  205 X  = Y
      GO TO 200
C
C     NOLIN 2
C
  210 Y  = DZ(MM)
      FX = X*Y
      GO TO 290
  213 X  = Y
      GO TO 210
  215 X  = Y
  217 FX = X*(DZ(MM) - DZ(NN))*H
      GO TO 290
C
C     NOLIN 3
C
  220 IF (X .LE. 0.0D0) GO TO 290
      FX = X**Z(I+4)
      GO TO 290
  225 X  = Y
      GO TO 220
C
C     NOLIN 4
C
  230 IF (X .GE. 0.0D0) GO TO 290
      FX =-DABS(X)**Z(I+4)
      GO TO 290
  235 X  = Y
      GO TO 230
C
C     NOLIN6
C
  240 X  = Y
      FY = X*DABS(X)
      X  = DZ(M)
      GO TO 200
  245 Y  = DZ(MM)
      FY = Y*DABS(Y)
      GO TO 200
C
C     NFTUBE.  LOOKUP VDOT IF NEEDED
C
  250 FXSP =  Z(I+4)
      IZL  = IZ(I+4)
      NXX  = NUMTYP(IZL)
      IF (DEC .AND. IZL.GT.16000 .AND. IZL.LE.99999999) NXX = 1
      IF (NXX  .EQ.   1) CALL TAB (IZ(I+4),TIM,FXSP)
      IF (FXSP .GE. 0.0) M = IU + IZ(I+1)
      FX   = FXSP*DZ(M)
      L    = IPX + IZ(I+2)
      DZ(L)= DZ(L) + FX*Z(I+3)
      FY   =-1.0D0
      GO TO 290
C
C     NOLIN5
C
C     A. COMPUTE SURFACE AVERAGE TEMPERATURES
C
  260 MM = 0
      NN = 0
      TAVGA = 0.0
      TAVGB = 0.0
      J  = 1
      DO 270 L = 1,4
      IF (L .EQ. 3) J = 6
      M  = IZ(I+J)
      IF (M .EQ. 0) GO TO 265
      M  = IU + M
      TAVGA = TAVGA + Z(M)
      MM = MM + 1
  265 M  = IZ(I+J+10)
      IF (M .EQ. 0) GO TO 270
      M  = IU + M
      TAVGB = TAVGB + Z(M)
      NN = NN + 1
  270 J  = J + 1
      TAVGA = TAVGA/FLOAT(MM)
      TAVGB = TAVGB/FLOAT(NN)
      AA    = Z(I+3)
      AB    = Z(I+4)
      FAB   = Z(I+8)
      FABSQ = FAB*FAB
      ETA   = Z(I+13)
      ETB   = Z(I+14)
      NXX   = NUMTYP(IZ(I+13))
      IF (DEC .AND. IZ(I+13).GT.16000 .AND. IZ(I+13).LE.99999999)
     1    NXX = 1
      IF (NXX .EQ. 1) CALL TAB (IZ(I+13),TAVGA,ETA)
      NXX   = NUMTYP(IZ(I+14))
      IF (DEC .AND. IZ(I+14).GT.16000 .AND. IZ(I+14).LE.99999999)
     1    NXX = 1
      IF (NXX .EQ. 1) CALL TAB (IZ(I+14),TAVGB,ETB)
      ALPHA = Z(I+18)
      ALPHB = Z(I+19)
      NXX   = NUMTYP(IZ(I+18))
      IF (DEC .AND. IZ(I+18).GT.16000 .AND. IZ(I+18).LE.99999999)
     1    NXX = 1
      IF (NXX .EQ. 1) CALL TAB (IZ(I+18),TAVGA,ALPHA)
      NXX   = NUMTYP(IZ(I+19))
      IF (DEC .AND. IZ(I+19).GT.16000 .AND. IZ(I+19).LE.99999999)
     1    NXX = 1
      IF (NXX .EQ. 1) CALL TAB (IZ(I+19),TAVGB,ALPHB)
      ALPHA = ALPHA - 1.0
      ALPHB = ALPHB - 1.0
C
C     B. COMPUTE DENOMINATOR
C
      XH  = SIGMA*ETA*(TAVGA+TABS)**4
      XK  = SIGMA*ETB*(TAVGB+TABS)**4
      FXSP= ALPHA*FAB*XK - AA*XH + FAB*XK - (ALPHB*FABSQ*XH)/AB
      FYSP= ALPHB*FAB*XH - AB*XK + FAB*XH - (ALPHA*FABSQ*XK)/AA
      FAB = 1.0 - (ALPHA*ALPHB/AA)*(FABSQ/AB)
      FX  = FXSP/(FAB*FLOAT(MM))
      FY  = FYSP/(FAB*FLOAT(NN))
C
C     C. APPLY FORCES ON AREAS A AND  B
C
      J = 1
      DO 280 L = 1,4
      IF (L .EQ. 3) J = 6
      M = IZ(I+J)
      IF (M .EQ. 0) GO TO 275
      M = IPX + M
      DZ(M) = DZ(M) + FX
  275 M = IZ(I+J+10)
      IF (M .EQ. 0) GO TO 280
      M = IPX + M
      DZ(M) = DZ(M) + FY
  280 J = J + 1
      I = I + 20
      GO TO 320
C
C     FINISH APPLYING SCALE FACTOR AND ADD
C
  290 L     = IPX + IZ(I+1)
      DZ(L) = DZ(L) + FX*FY*Z(I+3)
      IF (DABS(DZ(L)) .LT. 1.0D-36) DZ(L) = 0.0D0
      IF (DABS(DZ(L)) .LT. 1.0D+36) GO TO 310
      KOUNT = KOUNT + 1
      IF (KOUNT.EQ.1 .OR. KOUNT.EQ.4) WRITE (IOUT,295)
      IF (KOUNT .LE. 3) WRITE (IOUT,300) UWM,DZ(L)
  295 FORMAT (/1X,28(4H****),/)
  300 FORMAT (A25,' 3309, UNUSUALLY LARGE VALUE COMPUTED FOR NONLINEAR',
     1        ' FORCING FUNCTION',5X,D15.5)
  310 I = I + 5
  320 IF (I .LT. K) GO TO 190
C
C     END OF LOAD LOOP
C
C     DONE
C
      IF (IALG .EQ. 0) GO TO 380
      DO 370 I = 1,NROW
C
C     SUM OVER LAST THREE LOADS
C
      L  = IP  + I
      K  = IN1 + I
      M  = IN2 + I
      KK = IN3 + I
      DZ(L) = DZ(L) + (DZ(K)+DZ(M)+DZ(KK))/3.0D0
  370 CONTINUE
C
C     SWITCH POINTERS
C
      K   = IN1
      IN1 = IN2
      IN2 = IN3
      IN3 = K
  380 RETURN
C
C     ERROR MESSAGES
C
  400 WRITE  (IOUT,405) UFM
  405 FORMAT (A23,', NON-LINEAR FORCING LOAD (NLFT) WAS NOT GENERATED',
     1        ' PREVIOUSLY')
      IP1 =-37
  410 CALL MESAGE (IP1,FILE,NMTD)
      RETURN
  420 IP1 =-2
      GO TO 410
  430 IP1  =-8
      FILE = ICRQ
      GO TO 410
C
C     LOADED POINT  NOT E-POINT IN MODAL FORMULATION
C
  440 CALL MESAGE (-44,NLFTP,IZ(K))
      RETURN
      END

      SUBROUTINE PHDMIA
C
C     PUNCH SINGLE- OR DOUBLE-FIELD DMI CARDS FOR REAL, SINGLE-
C     PRECISION MATRICES.
C
C  $MIXED_FORMAT
C
      LOGICAL          FIRST
      INTEGER          FMT(8),IQX(8),KFMT(22),RET,NAME(2),RET1,LFMT(23),
     1                 H1,H2,H3,C1,C2,C3,H1A,C1A,ERNO
      REAL             QX(8)
      COMMON /PHDMIX/  NAME,NAM,IFO,ITIN,ITOUT,IR,IC,NOUTPT,KPP,NLPP,
     1                 ERNO,ICOL,IRO,X,ICARD1
      COMMON /SYSTEM/  DUM90(90),NP
      COMMON /MAHCIN/  MACH
      EQUIVALENCE      (QX(1),IQX(1)), (LFMT(2),KFMT(1))
      DATA    DMI   ,  IZ, P  , DMIS  , S       /
     1        3HDMI ,  0 , 1H+, 4HDMI*, 1H*     /
      DATA    KFMT  /  3*4H$$$$,16*4H**** , 4HA1,A,4H2,I5,4H)   /
      DATA    KFMTI ,  KFMTR1,KFMTR2/4HI8 ,,4HF8.1,4H,          /
      DATA    KDMTI ,  KDMTR1,KDMTR2/4HI16,,4H1PE1,4H6.8,       /
      DATA    KFMTB ,  KFMT8 ,KDMTR0/4H    ,4H4X, ,4H  E1       /
      DATA    KDMTB ,  KDMT8 /4H    ,4H8X,      /
      DATA    H1    ,  H2    ,H3    ,C1    ,C2    ,C3    ,H1A   ,C1A   /
     1        4H(A4,,  4H4X, ,4H2A4,,4H(A1,,4HA2, ,4HI5, ,4H A4,,4H A1,/
      DATA   LFMT(1)/  4H(1X,/
C
C     IBM/AIX (MACH=8) DOES NOT LIKE THE NON-ANSI STANDARD FORMAT
C     1PE16.8 (THE STANDARD IS 1P,E16.8).
C
      IF (MACH .EQ. 8) KDMTR1 = KDMTR0
C
C     CALLED INITIALLY FOR EACH MATRIX.
C
C     SET PUNCH UNIT TO 7 FOR IBM AND CDC AND TO 1 FOR UNIVAC
C
      ERNO  = 0
      NOUT  = NOUTPT
      KP    = KPP
      NKP   = 8/KP
      ICARD =-1
      ICARD1= 0
      GO TO (10,20), KP
   10 DMIPS = DMI
      PS = P
      GO TO 30
   20 DMIPS = DMIS
      PS = S
      DO 25 I = 12,19
   25 KFMT(I) = KDMTB
   30 WRITE  (NP,1) DMI,NAME,IZ,IFO,ITIN,ITOUT,IR,IC,P,NAM,ICARD1
    1 FORMAT (A3,5X,2A4,4I8,8X,2I8,A1,A2,I5)
      IF (NOUT .LE. 0) GO TO 40
      WRITE  (NOUT,2) DMI,NAME,IZ,IFO,ITIN,ITOUT,IR,IC,P,NAM,ICARD1
    2 FORMAT (1H1,/1X,A3,5X,2A4,4I8,8X,2I8,A1,A2,I5)
      L = 1
   40 RETURN
C
C
      ENTRY PHDMIB
C     ============
C
C     CALLED FOR FIRST NON-ZERO ELEMENT OF EACH COLUMN.
C
      IQ   = 0
      IROW = IRO
      FIRST=.TRUE.
      IQ   = IQ + 1
      FMT(IQ) = 0
      IQX(IQ) = 0
      IQ   = IQ + 1
      FMT(IQ) = 1
      IQX(IQ) = ICOL
      IQ   = IQ + 1
      FMT(IQ) = 1
      IQX(IQ) = IROW
      IQ   = IQ + 1
      FMT(IQ) = 2
      QX(IQ)  = X
      RETURN
C
C
      ENTRY PHDMIC
C     ============
C
C     CALLED FOR EACH NON-ZERO ELEMENT OF COLUMN EXCEPT FIRST ONE.
C
C     LOOK FOR FULL CARD
C
      IF (IQ .LT. NKP) GO TO 100
      ASSIGN 100 TO RET
      GO TO 700
C
C     DETERMINE IF NEW ENTRY IS CONSECUTIVE OR NON-CONSECUTIVE.
C
  100 IF (IRO .NE. IROW+1) GO TO 200
      IROW = IRO
      IQ   = IQ + 1
      FMT(IQ) = 2
      QX(IQ)  = X
      RETURN
C
  200 IQ   = IQ + 1
      IROW = IRO
      FMT(IQ) = 1
      IQX(IQ) = IRO
      IF (IQ .LT. NKP) GO TO 300
      ASSIGN 300 TO RET
      GO TO 700
  300 IQ = IQ + 1
      FMT(IQ) = 2
      QX(IQ)  = X
      RETURN
C
C
      ENTRY PHDMID
C     ============
C
C     ENTRY POINT FOR COLUMN TERMINATION CALL
C
      IF (IQ .LE. 0) RETURN
      ASSIGN 500 TO RET
      GO TO 700
  500 RETURN
C
C     PUNCH CARD
C
  700 N = IQ
      ASSIGN 800 TO RET1
      GO TO 1000
  800 IF (FIRST) GO TO 900
      WRITE (NP,KFMT,ERR=810) PS,NAM,ICARD,(QX(L),L=1,IQ),PS,NAM,ICARD1
  810 LFMT(2) = C1A
      IF (NOUT .LE. 0) GO TO 850
      IF (L .LT. NLPP) GO TO 830
      WRITE  (NOUT,3)
    3 FORMAT (1H1)
      L = 0
  830 WRITE (NOUT,LFMT,ERR=840) PS,NAM,ICARD,(QX(L),L=1,IQ),
     1                          PS,NAM,ICARD1
  840 L  = L + 1
  850 IQ = 0
      GO TO 950
  900 WRITE (NP,KFMT,ERR=910) DMIPS,NAME,(QX(L),L=2,IQ),PS,NAM,ICARD1
  910 LFMT(2) = H1A
      IF (NOUT .LE. 0) GO TO 940
      IF (L .LT. NLPP) GO TO 920
      WRITE (NOUT,3)
      L  = 0
  920 WRITE (NOUT,LFMT,ERR=930) DMIPS,NAME,(QX(L),L=2,IQ),PS,NAM,ICARD1
  930 L  = L + 1
  940 FIRST = .FALSE.
      IQ = 0
  950 GO TO RET, (100,300,500)
C
C     BUILD FORMAT FOR CARD IMAGE.
C
 1000 ICARD  = ICARD + 1
      ICARD1 = ICARD + 1
      IF (ICARD1 .GT. 99999) GO TO 9901
      GO TO (1001,1101), KP
 1001 IF (FIRST) GO TO 1005
      I1 = 1
      KFMT(1) = C1
      KFMT(2) = C2
      KFMT(3) = C3
      GO TO 1009
 1005 I1 = 2
      KFMT(1) = H1
      KFMT(2) = H2
      KFMT(3) = H3
      KFMT(4) = KFMTB
      KFMT(5) = KFMTB
 1009 DO 1030 I = I1,N
      K  = FMT(I)
      IF (K .EQ. 2) GO TO 1020
 1010 KFMT(2*I+2) = KFMTI
      KFMT(2*I+3) = KFMTB
      GO TO 1030
 1020 KFMT(2*I+2) = KFMTR1
      KFMT(2*I+3) = KFMTR2
 1030 CONTINUE
      IF (N .GE. NKP) GO TO 1999
      N1 = N + 1
      DO 1040 I = N1,NKP
      KFMT(2*I+2) = KFMT8
      KFMT(2*I+3) = KFMT8
 1040 CONTINUE
      GO TO 1999
 1101 IF (FIRST) GO TO 1105
      I1 = 1
      KFMT(1) = C1
      KFMT(2) = C2
      KFMT(3) = C3
      GO TO 1109
 1105 I1 = 2
      KFMT(1) = H1
      KFMT(2) = H2
      KFMT(3) = H3
      KFMT(4) = KDMT8
      KFMT(5) = KDMTB
 1109 DO 1130 I = I1,N
      K  = FMT(I)
      IF (K .EQ. 2) GO TO 1120
 1110 KFMT(2*I+2) = KDMTI
      KFMT(2*I+3) = KDMTB
      GO TO 1130
 1120 KFMT(2*I+2) = KDMTR1
      KFMT(2*I+3) = KDMTR2
 1130 CONTINUE
      IF (N .GE. NKP) GO TO 1999
      N1  = N + 1
      DO 1140 I = N1,NKP
      KFMT(2*I+2) = KDMT8
      KFMT(2*I+3) = KDMT8
 1140 CONTINUE
      GO TO 1999
 1999 GO TO RET1, (800)
C
C
C     ERROR MESSAGES
C
 9901 ERNO = 1
      GO TO 9999
C
C
 9999 RETURN
C
      END

      SUBROUTINE BASGLB (VIN1,VOUT1,PONT,ICSTM)
C
C     THIS ROUTINE CONTAINS FOUR ENTRY POINTS
C
C     1- BASGLB TRANSFORMS A VECTOR FROM BASIC TO GLOBAL
C     2- GLBBAS TRANSFORMS A VECTOR FROM GLOBAL TO BASIC
C     3- FDCSTM FINDS THE LOGICAL RECORD ON THE CSTM FOR A PARTICULAR ID
C     4- GBTRAN FINDS A PARTICULAR GLOBAL TO BASIC TRANSFORMATION AND
C        RETURNS IT AS A 3 X 3 STORED BY ROWS.
C
C
      LOGICAL         TONLY
      INTEGER         CSTM,TYSYS,CHECK
      REAL            T(9)
      DIMENSION       VIN(3),VIN1(3),VOUT1(3),TI(3,3),TL(3,3),
     1                PONT(3),PONT1(3),TZ(3,3),IPARM(2)
      COMMON /XCSTM / TZ
      COMMON /LOADX / LC(4),CSTM,LC1(10),IDUM(3),ICM
      COMMON /TRANX / NSYS,TYSYS,RO(3),TO(3,3)
      COMMON /SYSTEM/ IBUF,NOUT
      DATA    IPARM/ 4HBASG,2HLB /
C
C     NSYS  IS SYSTEM NUMBER
C     TYSYS IS SYSTEM TYPE
C     RO IS LOCATION OF ORIGIN
C     TO IS ROTATION MATRIX
C
      TONLY = .FALSE.
      CHECK = 123456789
      ASSIGN 90 TO IEXIT
      GO TO 10
C
C
      ENTRY GBTRAN (ICSTM,PONT,T)
C     ===========================
C
      IF (ICSTM .EQ. 0) GO TO 300
      IF (TYSYS.GE.2 .AND. CHECK.NE.123456789) WRITE (NOUT,5)
    5 FORMAT ('0*** SYSTEM POTENTIAL ERROR, GBTRAN WAS CALLED WITHOUT',
     1        ' FIRST CALLING BASGLB')
      CHECK = 123456789
      TONLY = .TRUE.
      GO TO 235
C
C
      ENTRY FDCSTM (ICSTM)
C     ====================
C
      TONLY = .FALSE.
      ASSIGN 50 TO IEXIT
C
C     FDCSTM WILL FIND REQUESTED SYSTEM (ICSTM)
C
   10 CONTINUE
      IF (ICSTM .EQ. 0) GO TO 81
      IF (ICM   .NE. 0) GO TO 80
      IF (ICSTM-NSYS) 20,40,20
   20 CALL READ (*60,*80,CSTM,NSYS,14,0,FLAG)
      IF (ICSTM-NSYS) 20,30,20
   30 CALL BCKREC (CSTM)
   40 GO TO IEXIT, (90,240,50)
   50 RETURN
C
   60 N1 = -2
      IPARM1 = CSTM
   70 CALL MESAGE (N1,IPARM1,IPARM)
C
C     UNABLE TO FIND REQUESTED COORDINATE SYSTEM
C
   80 N1      =-30
      IPARM1  = 25
      IPARM(1)= ICSTM
      GO TO 70
C
C     REQUEST FOR BASIC COORDINATE SYSTEM
C
   81 CONTINUE
      TYSYS = 1
      NSYS  = 0
      RO(1) = 0.0
      RO(2) = 0.0
      RO(3) = 0.0
      DO 82 I = 1,3
      DO 82 J = 1,3
      TO(J,I) = 0.0
   82 CONTINUE
      TO(1,1) = 1.0
      TO(2,2) = 1.0
      TO(3,3) = 1.0
      GO TO 40
C
C     CONVERTS BASIC TO GLOBAL
C
   90 IOTH = 0
C
C     RECTANGULAR
C
  100 DO 120 I = 1,3
      DO 110 J = 1,3
      TZ(I,J) = TO(J,I)
  110 TI(I,J) = TO(J,I)
  120 VIN(I)  = VIN1(I)
      IF (TYSYS-2) 130,140,140
  130 CALL MPYL (TI(1,1),VIN(1),3,3,1,VOUT1(1))
      GO TO 50
C
C     CYLINDRICAL
C
  140 DO 150 I = 1,3
  150 PONT1(I) = PONT(I) - RO(I)
      CALL MPYL (TI(1,1),PONT1(1),3,3,1,VIN(1))
      DO 160 I = 1,3
      DO 160 J = 1,3
  160 TL(I,J) = 0.0
      R = SQRT(VIN(1)*VIN(1) + VIN(2)*VIN(2))
      IF (R  .EQ.  0.0) GO TO 210
      IF (TYSYS .GT. 2) GO TO 230
      TL(3,3) = 1.0
      TL(1,1) = VIN(1)/R
      TL(2,2) = TL(1,1)
      TL(2,1) = VIN(2)/R
      TL(1,2) =-TL(2,1)
  170 CALL MPYL (TL(1,1),TI(1,1),3,3,3,TZ(1,1))
  180 IF (TONLY) GO TO 201
      IF ( IOTH) 270,190,270
  190 DO 200 I = 1,3
  200 VIN(I) = VIN1(I)
      CALL MPYL (TZ(1,1),VIN(1),3,3,1,VOUT1(1))
      GO TO 50
C
C     RETURN THE TRANSFORMATION ONLY
C
  201 T(1) = TZ(1,1)
      T(2) = TZ(1,2)
      T(3) = TZ(1,3)
      T(4) = TZ(2,1)
      T(5) = TZ(2,2)
      T(6) = TZ(2,3)
      T(7) = TZ(3,1)
      T(8) = TZ(3,2)
      T(9) = TZ(3,3)
      GO TO 50
C
C     ORIENTATION ARBITARY   TL = I   I.E. TZ = TI
C
  210 DO 220 I = 1,3
      DO 220 J = 1,3
      TZ(I,J) = TI(I,J)
  220 CONTINUE
      GO TO 180
C
C     SPHERICAL
C
  230 XL = SQRT(VIN(1)*VIN(1) + VIN(2)*VIN(2) + VIN(3)*VIN(3))
      XR = VIN(1)/R
      YR = VIN(2)/R
      ZL = VIN(3)/XL
C
C     BUILD TL TRANSPOSE
C
      TL(1,1) = VIN(1)/XL
      TL(1,2) = XR*ZL
      TL(1,3) =-YR
      TL(2,1) = VIN(2)/XL
      TL(2,2) = YR*ZL
      TL(2,3) = XR
      TL(3,1) = ZL
      TL(3,2) =-R/XL
      GO TO 170
C
C
      ENTRY GLBBAS (VIN1,VOUT1,PONT,ICSTM)
C     ====================================
C
      TONLY = .FALSE.
  235 ASSIGN 240 TO IEXIT
      IOTH = 1
      GO TO 10
C
C     CONVERTS FROM GLOBAL TO BASIC
C
  240 IF (TYSYS-2) 250,100,100
  250 IF ( TONLY ) GO TO 261
      DO 260 I = 1,3
  260 VIN(I) = VIN1(I)
      CALL MPYL (TO(1,1),VIN(1),3,3,1,VOUT1(1))
      GO TO 50
C
C     RETURN THE TRANSFORMATION ONLY.
C
  261 T(1) = TO(1,1)
      T(2) = TO(2,1)
      T(3) = TO(3,1)
      T(4) = TO(1,2)
      T(5) = TO(2,2)
      T(6) = TO(3,2)
      T(7) = TO(1,3)
      T(8) = TO(2,3)
      T(9) = TO(3,3)
      GO TO 50
C
C     COMPUTE TL TRANSPOSE
C
C     TRANSPOSE ROTATION PRODUCT
C
  270 DO 280 I = 1,3
      VIN(I) = VIN1(I)
      DO 280 J = 1,3
  280 TI(I,J) = TZ(J,I)
      CALL MPYL (TI(1,1),VIN(1),3,3,1,VOUT1(1))
      GO TO 50
C
C     COORDINATE SYSTEM 0
C
  300 DO 310 I = 2,8
  310 T(I) = 0.
      T(1) = 1.
      T(5) = 1.
      T(9) = 1.
      GO TO 50
      END

        SUBROUTINE SOFIO ( ISOP, IBLKNM, BUF )
      INCLUDE 'GINOX.COM'
      INCLUDE 'DSIOF.COM'
        COMMON / SOFCOM / NFILES, FILNAM( 10 ), FILSIZ( 10 )
        COMMON / SYS    / BLKSIZ, DIRSIZ, SUPSIZ, AVBLKS, HIBLK
        COMMON / SYSTEM / ISYSBF, IWR
        common / sofdsn / sofdsn(10)
        CHARACTER*4       FILNAM
        CHARACTER*80      DSNAME
        character*80      sofdsn
        INTEGER           FILSIZ, HIBLK, BUF(10)
        IF ( LENSOF( 1 ) .NE. 0 ) GO TO 20
        NUMBLK = 1
        IF ( LENWPB .NE. 0 ) NUMBLK = ISYSBF / LENWPB
        DO 10 K = 1, NFILES
        LENSOF( K ) = 0
        DSNAME      = sofdsn(K)
        CALL DSINQR ( DSNAME, ISTAT, ISIZE)
        IF (ISTAT .EQ. 0) GO TO 10
        LENSOF( K ) = FILSIZ( K )
10      CONTINUE
        LASFIL = 0
20      CONTINUE
        IF ( ISOP .EQ. 7 ) GO TO 200
        IBLK   = IBLKNM
        IF ( IBLK .LE. 0 ) GO TO 700
        IFILE  = 0
        DO 50 K = 1, NFILES
        IF ( IBLK .LE. FILSIZ( K ) )GO TO 30
        IBLK   = IBLK - FILSIZ( K )
        GO TO 50
30      IFILE  = K
        GO TO 100
50      CONTINUE
        WRITE( IWR, 9910 ) IBLKNM
9910    FORMAT(' *** SUBSTRUCTURING ERROR - BLOCK NUMBER OUT OF RANGE ',
     *         ' -  BLOCK NUMBER IS ',I10)
        WRITE( IWR, 9915 )
9915    FORMAT( //,' THE FOLLOWING SOF FILES WERE AVAILABLE',//)
        DO 60 K = 1, NFILES
        WRITE( IWR, 9920 ) sofdsn( K ), FILSIZ( K ), LENSOF( K )
9920    FORMAT(' FILE ',A72' HAS ',I10, ' BLOCKS - BLOCKS USED ',I10)
60      CONTINUE
        CALL MESAGE (-61, 0, 0)
100     IF ( LASFIL .EQ. IFILE ) GO TO 120
        IF ( LASFIL .NE. 0 ) CALL DSCLOS ( 90 )
        IALLOC = NUMBLK * FILSIZ(IFILE)
        dsname = sofdsn( IFILE )
        IOP = 0
        CALL DSOPEN (  DSNAME, 90, IOP )
        LASFIL = IFILE
120     IF ( ISOP .EQ. 1 ) GO TO 140
        IF ( ( IBLK - LENSOF( IFILE ) ) .LE. 1 ) GO TO 130
        NUM  = IBLK - LENSOF( IFILE ) - 1
        IF ( NUM .EQ. 0 ) GO TO 130
        DO 125 K = 1, NUM
        LENSOF( IFILE ) = LENSOF( IFILE ) + 1
        CALL DSWRIT ( 90, BUF(4), NBUFF, LENSOF( IFILE ),ICERR )
        IF ( ICERR .NE. 0 ) GO TO 701
125     CONTINUE
130     CONTINUE
        CALL DSWRIT ( 90, BUF(4), NBUFF, IBLK, ICERR )
        IF ( ICERR .NE. 0 ) GO TO 701
        IF ( IBLK   .GT. LENSOF( IFILE ) ) LENSOF( IFILE ) = IBLK
        IF ( IBLKNM .GT. HIBLK ) HIBLK = IBLKNM
        GO TO 700
140     CALL DSREAD ( 90, BUF(4), NBUFF, IBLK )
        GO TO 700
200     CALL DSCLOS( 90 )
        LASFIL = 0
700     GO TO 7000
701     IF ( ICERR .EQ. 28 ) WRITE ( IWR, 901 )
        IF ( ICERR .NE. 28 ) WRITE ( IWR, 902 )
        CALL MESAGE (-61, 0, 0)
901     FORMAT(///,' INSUFFICIENT SPACE FOR SOF FILE ON DEFAULT',
     &             ' DEVICE---JOB ABORTED.')
902     FORMAT(///,' I/O ERROR OCCURRED ON SOF FILE, JOB ABORTED')
7000    RETURN
        END

      SUBROUTINE KHRBCD (KHR80,BCD4)
C
C     MOVE ONLY THE APPROPRIATE PORTION OF THIS ROUTINE TO THE MDS GROUP
C
C     VAX, IBM, AND UNIVAC VERSION
C     ============================
C
C     THESE GROUP OF ROUTINES ARE MAINLY USED BY XREAD, RCARD2, AND
C     XRCARD IN LINK1
C
C     THESE GROUP OF ROUTINES CONVERT CHARACTER STRING (IN KHR100,
C     KHR80, KHR2), TO BCD4 ARRAY, OF 4 BYTES EACH WORD.
C     SAME OPERATION AS:
C
C           READ (KHRi,15) BCD4
C        15 FORMAT (20A4),  or (25A4),  or (2A4)
C
C     (THE READ OPERATION IS I/O BOUND, AND IS SLOW IN MOST MACHINES)
C
C
      INTEGER         B4(2) ,BCD4(2)
      CHARACTER*100   KHR100,K100
      CHARACTER*80    KHR80 ,K80
      CHARACTER*72    KHR72 ,K72
      CHARACTER*8     KHR8  ,K8
      EQUIVALENCE     (K100,K80,K72,K8,B4(1))
C
C     ROUTINE KHRBCD (KAR80,BCD4)
C     ===========================
C     A80 ---> 20A4
C
      K80=KHR80
      DO 10 I=1,20
 10   BCD4(I)=B4(I)
      RETURN
C
C
      ENTRY KHRBC1 (KHR100,BCD4)
C     ==========================
C     A100 ---> 25A4
C
      K100=KHR100
      DO 20 I=1,25
 20   BCD4(I)=B4(I)
      RETURN
C
C
      ENTRY KHRBC2 (KHR8,BCD4)
C     ========================
C     A8 ---> 2A4
C
      K8=KHR8
      BCD4(1)=B4(1)
      BCD4(2)=B4(2)
      RETURN
C
C
C     THE FOLLOWING ROUTINES, BCDKHi, CONVERT FROM BCD ARRAY TO
C     CHARACTER STRING.   SAME OPERATION AS:
C
C           WRITE (KHRi,25) BCD4
C        25 FORMAT (20A4),  or (18A4), or (2A4)
C
C     WHERE KHRi IS KHR80, KHR72, OR KHR8 ACCORDINGLY
C     (THE WRITE OPERATION IS I/O BOUND, AND IS SLOW IN MOST MACHINES)
C
C
      ENTRY BCDKH8 (BCD4,KHR80)
C     =========================
C     20A4 ---> A80
C
      DO 30 I=1,20
 30   B4(I)=BCD4(I)
      KHR80=K80
      RETURN
C
C
      ENTRY BCDKH7 (BCD4,KHR72)
C     =========================
C     18A4 ---> A72
C
      DO 40 I=1,18
 40   B4(I)=BCD4(I)
      KHR72=K72
      RETURN
C
C
      ENTRY BCDKH2 (BCD4,KHR8)
C     ========================
C     2A4 ---> A8
C
      B4(1)=BCD4(1)
      B4(2)=BCD4(2)
      KHR8=K8
      RETURN
C     END
C
C
C
C     SUBROUTINE KHRBCD (KHR,BCD4)
C
C     CDC VERSION
C     ===========
C
C     THIS GROUP OF ROUTINES ARE CALLED BY XREAD, RCARD2, AND XRCARD
C
C     THESE GROUP OF ROUTINES CONVERT CHARACTER STRINGS TO BCD ARRAY,
C     4 BYTES EACH WORD, AND VISE VERSA.     SIMILARY TO -
C
C        METHOD 1:
C        --------
C           READ (KHR80,10) BCD4     and       WRITE (KHR72,20) BCD4
C        10 FORMAT (20A4)                   20 FORMAT (18A4)
C
C        METHOD 2:
C        --------
C           I2=0                     and       I2=0
C           DO 10 I=1,NWDS                     DO 20 I=1,NWDS
C           I1=I2+1                            I1=I2+1
C           I2=I2+4                            I2=I2+4
C        10 BCD4(I)(1:4)=KHR(I1:I2)         20 KHR(I1:I2)=BCD4(I)(1:4)
C
C     HOWEVER THE INTERNAL-FILE READ AND WRITE (METHOD 1) AND THE
C     CHARACTER MANIPULATION (METHOD 2) ARE EXTREMELY SLOW IN CDC
C     (METHOD 1 IS ABOUT 18 TIMES SLOWER THAN SHIFT/AND/OR OPERATIONS
C     THAT ACCOMPLISH THE SAME THING. METHOD 2 IS 2 TO 4 TIMES SLOWER)
C
C     THE CALLING ROUTINES ACTUALLY PASS THE KHR ARGUMENTS IN CHARACTER
C     STRINGS (CHARACTER*100, CHARACTER*80, CHARACTER*2), WHEREAS, THEY
C     ARE PICKED UP HERE IN THIS ROUTINE AS INTEGER-BCD ARRAYS, 10 BYTES
C     EACH WORDS. ONLY THE FIRST 4 BYTES ARE USED IN NASTRAN.
C
C     (THE FOLLOWING CODE ASSUMES NO BREAK ON THE 1ST AND 4TH BCD WORDS
C     IN A GROUP OF 5)
C
C     INPUT  - KHR  = CHARACTER STRING IN CHARACTER*80, CHARACTER*100,
C                     AND CHARACTER*2
C     OUTPUT - BCD4 = BCD ARRAYS (OF DIMENSION NWDS)
C                     EACH BCD4 WORD HOLDS ONLY 4 BYTES OF DATA
C
C     INTEGER       BCD4(1),KHR(1),BLANK,BLK90
C                                     1 2 3 4 5 6 7 8 9 10
C     DATA          M1234,M12,M34 / O"77777777000000000000",
C    1                              O"77770000000000000000",
C    2                              O"00007777000000000000"/
C     DATA          M5678,M90     / O"00000000777777770000",
C    1                              O"00000000000000007777"/
C     DATA          M3456,M7890   / O"00007777777700000000",
C    1                              O"00000000000077777777"/
C     DATA          BLANK,BLK90   / O"00000000555555555555",
C    1                              O"00000000000000005555"/
C                                     1 2 3 4 5 6 7 8 9 10
C
C     SUBROUTINE KHRBCD (KHR,BCD4)
C     ============================
C     A80 ----> 20A4
C
C     NWDS = 20
C     GO TO 40
C
C
C     ENTRY KHRBC1 (KHR,BCD4)
C     =======================
C     A100 ----> 25A4
C
C     NWDS = 25
C     GO TO 40
C
C
C     ENTRY KHRBC2 (KHR,BCD4)
C     =======================
C     A8 ----> 2A4
C
C     NWDS = 2
C
C40   I   =-5
C     II  = 0
C50   I   = I+5
C     IF (I .GE. NWDS) GO TO 80
C     II  = II+1
C     NW1 = KHR(II)
C     NN  = AND(NW1,M1234)
C     BCD4(I+1) = OR(NN,BLANK)
C     NW1 = SHIFT(NW1,24)
C     NN  = AND(NW1,M1234)
C     BCD4(I+2) = OR(NN,BLANK)
C     IF (I+2 .GE. NWDS) GO TO 80
C     NW1 = SHIFT(NW1,24)
C     II=II+1
C     NW2 = KHR(II)
C     IF (I+3 .LT. NWDS) GO TO 60
C     NW2 = SHIFT(NW2,-12)
C     GO TO 70
C60   NW2 = SHIFT(NW2,12)
C     NN  = AND(NW2,M1234)
C     BCD4(I+4) = OR(NN,BLANK)
C     NW2 = SHIFT(NW2,24)
C     NN  = AND(NW2,M1234)
C     BCD4(I+5) = OR(NN,BLANK)
C     NW2 = SHIFT(NW2,12)
C70   NW1 = AND(NW1,M12)
C     NW2 = AND(NW2,M34)
C     NN  = OR(NW1,NW2)
C     BCD4(I+3) = OR(NN,BLANK)
C     GO TO 50
C80   CONTINUE
C     GO TO 140
C
C
C     ENTRY BCDKH8 (BCD4,KHR)
C     =======================
C     20A4 ----> A80
C
C     INPUT  - BCD4 = BCD ARRAYS (OF DIMENSION NWDS). BCD DATA ARE IN
C                     A4 FORMAT
C     OUTPUT - KHR  = CHARACTER STRING IN CHARACTER*80, CHARACTER*100,
C                     AND CHARACTER*2
C
C     NWDS = 20
C     GO TO 100
C
C     ENTRY BCDKH7 (BCD4,KHR)
C     =======================
C     18A4 ----> A72
C
C     NWDS = 18
C     GO TO 100
C
C     ENTRY BCDKH2 (BCD4,KHR)
C     =======================
C     2A4 ----> A8
C
C     NWDS = 2
C
C100  I   =-5
C     II  = 0
C110  I   = I+5
C     IF (I .GE. NDWS) GO TO 140
C     II  = II+1
C     NW1 = AND(BCD4(I+1),M1234)
C     NW2 = SHIFT(BCD4(I+2),-24)
C     NW2 = AND(NW2,M5678)
C     KHR(II) = OR(NW1,NW2)
C     IF (I+2 .GE. NWDS) GO TO 120
C     NW3 = SHIFT(BCD4(I+3),12)
C     NW2 = AND(NW3,M90)
C     KHR(II) = OR(KHR(II),NW2)
C     II  = II+1
C     KHR(II) = AND(NW3,M12)
C     NW3 = SHIFT(BCD4(I+4),-12)
C     NW1 = AND(NW3,M3456)
C     NM3 = SHIFT(BCD4(I+5),-36)
C     NW2 = AND(NW3,M7890)
C     NW3 = OR(NW1,NW2)
C     KHR(II) = OR(KHR(II),NW3)
C     GO TO 110
C120  KHR(II) = OR(KHR(II),BLK90)
C
C140  RETURN
C     END
C
C
C     SUBROUTINE KHRBCD (KHR80,BCD4)
C
C     64-BIT MACHINE, UNIX VERSION
C     ============================
C
C     THIS GROUP OF ROUTINES ARE CALLED BY XREAD, RCARD2, AND XRCARD
C
C     CHARACTER*100 KHR100, KDUM
C     CHARACTER*80  KHR80 , K80
C     CHARACTER*72  KHR72 , K72
C     CHARACTER*8   KHR8  , K8,   BCD4(1)
C
C     EQUIVALENCE   (KDUM,K100,K80,K72,K8)
C
C
C     SUBROUTINE KHRBCD (KHR80,BCD4)
C     ==============================
C     A80 ----> 20A4
C
C     K80  = KHR80
C     NWDS = 20
C     GO TO 100
C
C
C     ENTRY KHRBC1 (KHR100,BCD4)
C     ==========================
C     A100 ----> 25A4
C
C     KDUM = KHR100
C     NWDS = 25
C     GO TO 100
C
C
C     ENTRY KHRBC2 (KHR8,BCD4)
C     ========================
C     A8 ----> 2A4
C
C     K8   = KHR8
C     NWDS = 2
C
C 100 I2 = 0
C     DO 200 I = 1,NWDS
C     I1 = I2 + 1
C     I2 = I2 + 4
C     BCD4(I) = KDUM(I1:I2)
C 200 CONTINUE
C     GO TO 800
C
C
C     ENTRY BCDKH8 (BCD4,KHR80)
C     =========================
C     20A4 ----> A80
C
C     NWDS  = 20
C     GO TO 300
C
C
C     ENTRY BCDKH7 (BCD4,KHR72)
C     =========================
C     18A4 ----> A72
C
C     NWDS = 18
C     GO TO 300
C
C
C     ENTRY BCDKH2 (BCD4,KHR8)
C     ========================
C     2A4 ----> A8
C
C     NWDS = 2
C
C 300 I2 = 0
C     DO 400 I = 1,NWDS
C     I1 = I2 + 1
C     I2 = I2 + 4
C     KDUM(I1:I2) = BCD4(I)
C 400 CONTINUE
C     IF (NWDS-18) 500,600,700
C
C 500 KHR8 = K8
C     GO TO 800
C
C 600 KHR72 = K72
C     GO TO 800
C
C 700 KHR80 = K80
C 800 RETURN
C
      END

      SUBROUTINE FRR1A1 (RZ,CZ,IB,REB,CEB)
C
      COMPLEX   Z,SUM,ZK,TERM
C
      Z  = CMPLX(RZ,CZ)
      IF (CABS(Z) .LT. .1) GO TO 100
      ZK  = CMPLX(1.,0.)
      N   = IB
      BF  = 1.
      BF1 = 0.
      SUM = CMPLX(0.,0.)
      DO 10 I = 1,N
      SUM = SUM + ZK/CMPLX(BF,0.)
      ZK  = ZK*Z
      BF1 = BF1 + 1.
      BF  = BF*BF1
   10 CONTINUE
      ZK  = CMPLX(BF,0.)/ZK*(CEXP(Z)-SUM)
      REB = REAL(ZK)
      CEB = AIMAG(ZK)
      RETURN
C
  100 CONTINUE
      ZK  = Z
      DEN = FLOAT(IB) + 1.
      SUM = CMPLX(1.,0.)
      DO 20 I = 1,30
      TERM= ZK/DEN
      SUM = SUM + TERM
      IF (CABS(TERM) .LT. 1.E-9) GO TO 200
      ZK  = ZK*Z
      DEN = DEN*(FLOAT(IB)+ FLOAT(I+1))
   20 CONTINUE
  200 REB = REAL(SUM)
      CEB = AIMAG(SUM)
      RETURN
      END

      SUBROUTINE SOLVE
C
C     SOLVE IS A DMAP DRIVER TO SOLVE THE MATRIX EQUATION AX=B
C
C     SOLVE   A,B/X/SYM/SIGN/PREC/TYPE $
C
C     SYM     =  1 - USE SYMETRIC DECOMPOSITION
C                0 - CHOOSE WHICH DECOMPOSITION BASED ON INPUT MATRIX
C               -1 - USE UNSYMETRIC DECOMPOSITION
C     ISIGN   =  1   SOLVE AX = B
C               -1   SOLVE AX =-B
C     IPREC   =  PRECISION USED IN THE FBS PASS
C     ITYPE   =  DESIRED TYPE OF THE OUTPUT MATRIX X
C
C
      INTEGER          NAME(2)   ,RECT     ,A        ,B        ,
     1                 CDP       ,RDP      ,SYM      ,SQR      ,
     2                 DOSI(3)   ,REFUS(3) ,OUTPT    ,X
      REAL             ZZ(1)     ,ZZZ(1)   ,ZZZZ(1)  ,ZZZZZ(1)
      DOUBLE PRECISION DET       ,DETT     ,MINDIA   ,CDET     ,
     1                 CMNDIA    ,DETC     ,MINDS
      CHARACTER        UFM*23    ,UWM*25   ,UIM*29   ,SFM*25   ,
     1                 SWM*27
      COMMON /XMSSG /  UFM       ,UWM      ,UIM      ,SFM      ,
     1                 SWM
      COMMON /BLANK /  ISYM      ,KSIGN    ,IPREC    ,ITYPE
      COMMON /SYSTEM/  KSYSTM(65)
      COMMON /SFACT /  IFILA(7)  ,IFILL1(7),IFILC(7) ,ISCR11   ,
     1                 ISCR22    ,NZ       ,DET      ,DETC     ,
     2                 IPOWER    ,ISCR33   ,MINDS    ,ICHOL
      COMMON /FBSX  /  IFILL(7)  ,IFILLT(7),IFILB(7) ,IFILX(7) ,
     1                 NX        ,IPREC1   ,ISIGN1   ,ISCR
      COMMON /DCOMPX/  IA(7)     ,IL(7)    ,IU(7)    ,ISR1     ,
     1                 ISR2      ,ISR3     ,DETT     ,IPOW     ,
     2                 NZZ       ,MINDIA   ,IB       ,IBBAR
      COMMON /CDCMPX/  JA(7)     ,KL(7)    ,KU(7)    ,JSCR1    ,
     1                 JSCR2     ,JSCR3    ,CDET(2)  ,JPOW     ,
     2                 NZZZZ     ,CMNDIA   ,JBB      ,JBBAR
      COMMON /GFBSX /  JL(7)     ,JU(7)    ,JB(7)    ,JX(7)    ,
     1                 NZZZ      ,IPR      ,ISGN
      COMMON /NAMES /  RD        ,RDREW    ,WRT      ,WRTREW   ,
     1                 REW       ,NOREW    ,EOFNRW   ,RSP      ,
     2                 RDP       ,CSP      ,CDP      ,SQR      ,
     3                 RECT      ,DIAG     ,LOWER    ,UPPER    ,
     4                 SYM       ,ROW      ,IDENTY
      COMMON /ZZZZZZ/  Z(1)
      EQUIVALENCE      (ZZ(1),Z(1))
      EQUIVALENCE      (ZZZ(1),Z(1))
      EQUIVALENCE      (ZZZZ(1),Z(1))
      EQUIVALENCE      (ZZZZZ(1),Z(1))
      EQUIVALENCE      (KSYSTM(55),KPREC)  ,(KSYSTM(2),OUTPT)
      DATA    A,B,X /  101,102,201/,     NAME  / 4HSOLV,4HE    /
      DATA    ISCR1 ,  ISCR2,ISCR3,ISCR4,ISCR5 /
     1        301   ,  302  ,303  ,304  ,305   /
      DATA    DOSI  /  4HSING , 4HDOUB , 4HMLTP/,
     1        REFUS /  2*3H   , 3HREF          /
C
C
      JA(1) = A
      CALL RDTRL (JA)
C
      IFORM = JA(4)
      IF (ISYM) 1,5,3
    1 IF (IFORM .EQ. SYM) WRITE (OUTPT,2) UWM,NAME
    2 FORMAT (A25,' 2340, MODULE ',2A4,' HAS BEEN REQUESTED TO DO ',
     1       'UNSYMETRIC DECOMPOSITION OF A SYMETRIC MATRIX.')
      IFORM = RECT
      IF (JA(2) .EQ. JA(3)) IFORM = SQR
      GO TO 5
    3 IF (JA(2).EQ.JA(3) .AND. IFORM.NE.SYM) WRITE (OUTPT,4) SWM,NAME
    4 FORMAT (A27,' 2341, MODULE ',2A4,' HAS BEEN FURNISHED A SQUARE ',
     1       'MATRIX MARKED UNSYMETRIC FOR SYMETRIC DECOMPOSITION.')
      IFORM = SYM
    5 ISYM  = -1
      IF (IFORM .EQ. SYM) ISYM = 1
      JA(4) = IFORM
      IF (ISYM .LT. 0) GO TO 30
C
C     SET UP CALL TO SDCOMP AND FBS
C
      INDEX = 1
      ICHOL = 0
      DO  9  I = 1,7
    9 IFILA(I) = JA(I)
      N = IFILA(2)
      IFILL1(1) = ISCR1
      IFILC(1)  = ISCR2
      ISCR11 = ISCR3
      ISCR22 = ISCR4
      ISCR33 = ISCR5
      NZ = KORSZ(Z)
      IFILL1(5) = IFILA(5)
      CALL SDCOMP (*20,Z,Z,Z)
      IFILL1(3) = IFILL1(2)
      IFILL1(4) = LOWER
      CALL WRTTRL (IFILL1)
      IFILL(1) = ISCR1
      CALL RDTRL (IFILL)
      IFILB(1) = B
      CALL RDTRL (IFILB)
C
C     IF THE B MATRIX IS PURGED, ASSUME AN IDENTITY MATRIX IN ITS PLACE
C
      IF (IFILB(1) .LE. 0) CALL MAKMCB (IFILB,B,N,IDENTY,JA(5))
      ISIGN1 = KSIGN
      IA5 = IFILA(5)
      IB5 = IFILB(5)
C
C     DETERMINE THE PRECISION FOR THE CALCULATIONS
C     AND THE TYPE OF THE OUTPUT MATRIX
C
  200 IPREC1 = KPREC
      IF ((IA5.GT.0 .AND. IA5.LE.4) .OR. (IB5.GT.0 .AND. IB5.LE.4))
     1     IPREC1 = 1
      IF (IA5.EQ.2 .OR. IA5.EQ.4 .OR. IB5.EQ.2 .OR. IB5.EQ.4) IPREC1 = 2
      IF (IPREC.EQ.IPREC1 .OR. IPREC.EQ.0) GO TO 222
      IF (IPREC.LT.1 .OR. IPREC.GT.2) IPREC = 3
      WRITE  (OUTPT,221) SWM,DOSI(IPREC),REFUS(IPREC),NAME,DOSI(IPREC1)
  221 FORMAT (A27,' 2163, REQUESTED ',A4,'LE PRECISION ',A3,'USED BY ',
     1       2A4,2H. ,A4,'LE PRECISION IS LOGICAL CHOICE')
      IF (IPREC .NE. 3 ) IPREC1 = IPREC
  222 IPREC = IPREC1
      LTYPE = IPREC1
      IF (IA5.EQ.3 .OR. IA5.EQ.4 .OR. IB5.EQ.3 .OR. IB5.EQ.4)
     1    LTYPE = IPREC1 + 2
      IF (ITYPE.EQ.0 .OR. ITYPE.EQ.LTYPE) GO TO 224
      JJ = 1
      IF (ITYPE.LT.1 .OR. ITYPE.GT.4 ) JJ = 3
      WRITE  (OUTPT,223) SFM,ITYPE,REFUS(JJ),NAME,LTYPE
  223 FORMAT (A27,' 2164, REQUESTED TYPE ',I4,2H, ,A3,'USED BY ',2A4,
     1       '. TYPE ',I4,' IS LOGICAL CHOICE.')
      IF (JJ .NE. 3 ) LTYPE = ITYPE
  224 ITYPE = LTYPE
      IF (INDEX .EQ. 2) GO TO 45
C
C     DEFINE THE MATRIX CONTROL BLOCK FOR THE OUTPUT MATRIX
C
      CALL MAKMCB (IFILX,X,N,RECT,ITYPE)
      NX = KORSZ(ZZ)
      IF (IFILB(4) .EQ. IDENTY) IFILB(5) = IPREC
      ISCR = ISCR1
      CALL FBS (ZZ,ZZ)
      IF (IFILX(2) .EQ. N) IFILX(4) = SQR
      CALL WRTTRL (IFILX)
      RETURN
C
   20 NO = ISIGN(5,ISYM)
      ISYM = -1
      CALL MESAGE (NO,A,NAME)
C
C     SET UP THE CALL TO DECOMP AND GFBS
C
   30 CONTINUE
      INDEX = 2
      IF (JA(5) .GT. 2) GO TO 80
      IA(1) = A
      IL(1) = ISCR1
      IU(1) = ISCR2
      ISR1  = ISCR3
      ISR3  = ISCR5
      ISR2  = ISCR4
      NZZ   = KORSZ(ZZZ)
      CALL RDTRL (IA)
      IA(4) = SQR
      N     = IA(2)
      IL(5) = JA(5)
      IB    = 0
      IBBAR = 0
      CALL DECOMP (*20,ZZZ,ZZZ,ZZZ)
      DO 35 I = 1,7
      JL(I) = IL(I)
      JU(I) = IU(I)
   35 CONTINUE
   40 JB(1) = B
      CALL RDTRL (JB)
C
C     IF THE B MATRIX IS PURGED, ASSUME AN IDENTITY MATRIX IN ITS PLACE
C
      IF (JB(1) .LE. 0) CALL MAKMCB (JB,B,N,IDENTY,JA(5))
      IA5  = JA(5)
      IB5  = JB(5)
      ISGN = KSIGN
C
C     DETERMINE THE PRECISION FOR THE CALCULATIONS
C     AND THE TYPE OF THE OUTPUT MATRIX
C
      GO TO 200
   45 IPR = IPREC
C
C     DEFINE THE MATRIX CONTROL BLOCK FOR THE OUTPUT MATRIX
C
      CALL MAKMCB (JX,X,N,RECT,ITYPE)
      NZZZ = KORSZ(ZZZZ)
      IF (JB(4) .EQ. IDENTY) JB(5) = IPREC
      CALL GFBS (ZZZZ,ZZZZ)
      IF (JX(2) .EQ. N) JX(4) =  SQR
      CALL WRTTRL (JX)
      RETURN
C
C     SET UP CALL TO CDCOMP AND GFBS
C
   80 CONTINUE
      KL(1) = ISCR1
      KU(1) = ISCR2
      JSCR1 = ISCR3
      JSCR2 = ISCR4
      JSCR3 = ISCR5
      NZZZZ = KORSZ(ZZZZZ)
      JA(4) = SQR
      N     = JA(2)
      KL(5) = JA(5)
      JBB   = 0
      JBBAR = 0
      CALL CDCOMP (*20,ZZZZZ,ZZZZZ,ZZZZZ)
      DO 90 I = 1, 7
      JL(I) = KL(I)
      JU(I) = KU(I)
   90 CONTINUE
      GO TO 40
      END

      SUBROUTINE NASOPN ( *, LU, DSN )
      CHARACTER*80  IFILE, DSN
      INCLUDE 'NASNAMES.COM'
      LOGICAL IEXIST
      KLEN = INDEX( RFDIR, ' ' )
      IFILE = RFDIR(1:KLEN-1) // '/NASINFO'
      DSN = IFILE
      INQUIRE ( FILE=IFILE, EXIST=IEXIST )
      IF ( .NOT. IEXIST ) GO TO 100
      OPEN ( UNIT=LU, FILE=IFILE, STATUS='OLD', ERR=100 )
      RETURN
100   RETURN 1
      END

      SUBROUTINE STRBS1 (IOPT)
C
C     PHASE ONE FOR STRESS RECOVERY
C
C           IOPT = 0    (BASIC BENDING TRIANGLE)
C           IOPT = 1    (SUB-CALCULATIONS FOR SQDPL1)
C           IOPT = 2    (SUB-CALCULATIONS FOR STRPL1)
C
C     CALLS FROM THIS ROUTINE ARE MADE TO
C
C           MAT    - MATERIAL DATA ROUTINE
C           TRANSS - SINGLE PRECISION TRANSFORMATION SUPPLIER
C           INVERS - SINGLE PRECISION INVERSE ROUTINE
C           GMMATS - SINGLE PRECISION MATRIX MULTIPLY AND TRANSPOSE
C           MESAGE - ERROR MESSAGE WRITER
C
      LOGICAL         STRAIN
      INTEGER         SUBSCA,SUBSCB
      REAL            KS,J2X2,ST(3)
      DIMENSION       D(9),G2X2(4),J2X2(4),S(258),ECPT(25),G(9),HIC(18),
     1                HIB(18),TITE(18),T(9),KS(30),HINV(36)
C
C     COMMON /SDR2X3/ ESTWDS(32),ESTAWD(32),NGPS(32),STRSWD(32),
C    1                FORCWD(32)
C     THE ABOVE COMMON BLOCK IS NOT USED IN THIS ROUTINE DIRECTLY.
C
C     ESTWDS(I) = THE NUMBER OF WORDS IN THE EST INPUT BLOCK FOR
C                 THE  I-TH ELEMENT TYPE.
C     ESTAWD(I) = THE NUMBER OF WORDS COMPUTED IN PHASE-I FOR THE
C                 I-TH ELEMENT TYPE, AND INSERTED INTO THE ESTA ARRAY
C                 OF THE LABELED BLOCK SDR2X5
C     NGPS  (I) = THE NUMBER OF GRID POINTS ASSOCIATED WITH THE I-TH
C                 ELEMENT TYPE.
C     STRSWD(I) = THE NUMBER OF WORDS COMPUTED IN PHASE-II FOR
C                 THE I-TH ELEMENT TYPE, AND INSERTED INTO THE ESTA
C                 ARRAY OF THE LABELED BLOCK SDR2X5.
C     FORCWD(I) = THE NUMBER OF WORDS COMPUTED IN PHASE-II FOR
C                 THE I-TH ELEMENT TYPE, AND INSERTED INTO THE FORCES
C                 ARRAY OF THE LABELED BLOCK SDR2X5.
C
      COMMON /BLANK / IDUMMY(10), STRAIN
      COMMON /CONDAS/ CONSTS(5)
      COMMON /MATIN / MATID,INFLAG,ELTEMP,STRESS,SINTH,COSTH
      COMMON /MATOUT/ G11,G12,G13,G22,G23,G33,RHO,ALPHA1,ALPHA2,ALP12,
     1                T SUB 0,G SUB E,SIGTEN,SIGCOM,SIGSHE,G2X211,
     2                G2X212,G2X222
      COMMON /SDR2X6/ A(225),XSUBB,XSUBC,YSUBC,E(18),TEMP,XBAR,AREA,
     1                XCSQ,YBAR2,YCSQ,YBAR,XBSQ,PX2,XCYC,PY2,PXY2,XBAR3,
     2                YBAR3,DETERM,PROD9(9),TEMP9(9),NSIZED,DUMDUM(4),
     3                NPIVOT,THETA ,NSUBC,ISING,SUBSCA,SUBSCB,NERROR,
     4                NBEGIN,NTYPED,XC,YC,YC2,YC3,ISUB,XC3,DUM55(1)
      COMMON /SDR2X5/ NECPT(1),NGRID(3),ANGLE,MATID1,EYE,MATID2,T2,FMU,
     1                Z11,Z22,DUMMY1,X1,Y1,Z1,DUMMY2,X2,Y2,Z2,DUMMY3,
     2                X3,Y3,Z3,DUMB(76),PH1OUT(100),FORVEC(25)
      EQUIVALENCE     (CONSTS(4),DEGRA),(D(1),G(1),A(79)),
     1                (ECPT(1),NECPT(1)),(KS(1),PH1OUT(1)),
     2                (G2X2(1),A(88)),(S(1),A(55)),(TITE(1),A(127)),
     3                (J2X2(1),A(92)),(T(1),A(118)),(HIB(1),A(109)),
     4                (HIC(1),A(127)),(HINV(1),A(73)),(ST(1),PH1OUT(99))
C
C     ECPT LIST FOR BASIC BENDING TRIANGLE             NAME IN
C                                                      THIS
C     ECPT                                             ROUTINE    TYPE
C     --------   -----------------------------------   --------  -------
C     ECPT( 1) = ELEMENT ID                            NECPT(1)  INTEGER
C     ECPT( 2) = GRID POINT A                          NGRID(1)  INTEGER
C     ECPT( 3) = GRID POINT B                          NGRID(2)  INTEGER
C     ECPT( 4) = GRID POINT C                          NGRID(3)  INTEGER
C     ECPT( 5) = THETA = ANGLE OF MATERIAL             ANGLE     REAL
C     ECPT( 6) = MATERIAL ID 1                         MATID1    INTEGER
C     ECPT( 7) = I = MOMENT OF INERTIA                 EYE       REAL
C     ECPT( 8) = MATERIAL ID 2                         MATID2    INTEGER
C     ECPT( 9) = T2                                    T2        REAL
C     ECPT(10) = NON-STRUCTURAL-MASS                   FMU       REAL
C     ECPT(11) = Z1                                    Z11       REAL
C     ECPT(12) = Z2                                    Z22       REAL
C     ECPT(13) = COORD. SYSTEM ID 1                    NECPT(13) INTEGER
C     ECPT(14) = X1                                    X1        REAL
C     ECPT(15) = Y1                                    Y1        REAL
C     ECPT(16) = Z1                                    Z1        REAL
C     ECPT(17) = COORD. SYSTEM ID 2                    NECPT(17) INTEGER
C     ECPT(18) = X2                                    X2        REAL
C     ECPT(19) = Y2                                    Y2        REAL
C     ECPT(20) = Z2                                    Z2        REAL
C     ECPT(21) = COORD. SYSTEM ID 3                    NECPT(21) INTEGER
C     ECPT(22) = X3                                    X3        REAL
C     ECPT(23) = Y3                                    Y3        REAL
C     ECPT(24) = Z3                                    Z3        REAL
C     ECPT(25) = ELEMENT TEMPERATURE                   ELTEMP    REAL
C
      IF (IOPT .GT. 0) GO TO 30
      ELTEMP = ECPT(25)
C
C     SET UP  I, J, K VECTORS STORING AS FOLLOWS AND ALSO CALCULATE
C     X-SUB-B, X-SUB-C, AND Y-SUB-C.
C
C     E(11), E(14), E(17) WILL BE THE I-VECTOR.
C     E(12), E(15), E(18) WILL BE THE J-VECTOR.
C     E( 1), E( 4), E( 7) WILL BE THE K-VECTOR.
C
C     FIND I-VECTOR = RSUBB - RUBA (NON-NORMALIZED)
C
      E(11) = X2 - X1
      E(14) = Y2 - Y1
      E(17) = Z2 - Z1
C
C     FIND LENGTH = X-SUB-B COOR. IN ELEMENT SYSTEM
C
      XSUBB = SQRT(E(11)**2 + E(14)**2 + E(17)**2)
      IF (XSUBB .GT. 1.0E-06) GO TO 10
      CALL MESAGE (-30,37,ECPT(1))
C
C     NORMALIZE I-VECTOR WITH X-SUB-B
C
   10 E(11) = E(11)/XSUBB
      E(14) = E(14)/XSUBB
      E(17) = E(17)/XSUBB
C
C     TAKE RSUBC - RSUBA AND STORE TEMPORARILY IN E(2), E(5), E(8)
C
      E(2) = X3 - X1
      E(5) = Y3 - Y1
      E(8) = Z3 - Z1
C
C     X-SUB-C = I . (RSUBC - RSUBA), THUS
C
      XSUBC = E(11)*E(2) + E(14)*E(5) + E(17)*E(8)
C
C     CROSSING I-VECTOR TO (RSUBC - RSUBA) GIVES THE K-VECTOR
C     (NON-NORMALIZED)
C
      E(1) = E(14)*E( 8) - E( 5)*E(17)
      E(4) = E( 2)*E(17) - E(11)*E( 8)
      E(7) = E(11)*E( 5) - E( 2)*E(14)
C
C     FIND LENGTH = Y-SUB-C COOR. IN ELEMENT SYSTEM
C
      YSUBC = SQRT(E(1)**2 + E(4)**2 + E(7)**2)
      IF (YSUBC .GT. 1.0E-06) GO TO 20
      CALL MESAGE (-30,37,ECPT(1))
C
C     NORMALIZE K-VECTOR WITH Y-SUB-C
C
   20 E(1) = E(1)/YSUBC
      E(4) = E(4)/YSUBC
      E(7) = E(7)/YSUBC
C
C     NOW HAVING I AND K VECTORS GET -- J = K CROSS I
C
      E(12) = E( 4)*E(17) - E(14)*E( 7)
      E(15) = E(11)*E( 7) - E( 1)*E(17)
      E(18) = E( 1)*E(14) - E(11)*E( 4)
C
C     NORMALIZE J-VECTOR FOR COMPUTER EXACTNESS JUST TO MAKE SURE
C
      TEMP  = SQRT(E(12)**2 + E(15)**2 + E(18)**2)
      E(12) = E(12)/TEMP
      E(15) = E(15)/TEMP
      E(18) = E(18)/TEMP
      E( 2) = 0.0
      E( 3) = 0.0
      E( 5) = 0.0
      E( 6) = 0.0
      E( 8) = 0.0
      E( 9) = 0.0
      E(10) = 0.0
      E(13) = 0.0
      E(16) = 0.0
C
C     CONVERT ANGLE FROM DEGREES TO RADIANS STORING IN THETA.
C
      THETA = ANGLE*DEGRA
      SINTH = SIN(THETA)
      COSTH = COS(THETA)
      IF (ABS(SINTH) .LT. 1.0E-06) SINTH = 0.0
C
C     SETTING UP G MATRIX
C
   30 MATID  = MATID1
      INFLAG = 2
      CALL MAT (ECPT(1))
C
C     FILL G-MATRIX WITH OUTPUT FROM MAT ROUTINE
C
      G(1) = G11
      G(2) = G12
      G(3) = G13
      G(4) = G12
      G(5) = G22
      G(6) = G23
      G(7) = G13
      G(8) = G23
      G(9) = G33
C
C     COMPUTATION OF D = I.G-MATRIX (EYE IS INPUT FROM THE ECPT)
C
      DO 50 I = 1,9
   50 D(I) = G(I)*EYE
      IF (IOPT .EQ. 0) CALL GMMATS (D,3,3,0, ALPHA1,3,1,0, ST(1))
C
      XBAR =(XSUBB + XSUBC)/3.0
      YBAR = YSUBC/3.0
      IF (IOPT .GT. 0) GO TO 60
      XC = XBAR
      YC = YBAR
C
C     FORMING K  5X6 AND STORING TEMPORARILY IN PH1OUT OUTPUT SPACE.
C              S                             (EQUIVALENCED)
C
   60 XC3 = 3.0*XC
      YC3 = 3.0*YC
      YC2 = 2.0*YC
      IF (STRAIN) GO TO 63
      KS( 1) = D(1)
      KS( 2) = D(3)
      KS( 3) = D(2)
      KS( 4) = D(1)*XC3
      KS( 5) = D(2)*XC + D(3)*YC2
      KS( 6) = D(2)*YC3
      KS( 7) = D(2)
      KS( 8) = D(6)
      KS( 9) = D(5)
      KS(10) = D(2)*XC3
      KS(11) = D(5)*XC + D(6)*YC2
      KS(12) = D(5)*YC3
      KS(13) = D(3)
      KS(14) = D(9)
      KS(15) = D(6)
      KS(16) = D(3)*XC3
      KS(17) = D(6)*XC + D(9)*YC2
      KS(18) = D(6)*YC3
C
C     ROWS 4 AND 5
C
      KS(19) = 0.0
      KS(20) = 0.0
      KS(21) = 0.0
      KS(22) =-D(1)*6.0
      KS(23) =-D(2)*2.0 - D(9)*4.0
      KS(24) =-D(6)*6.0
      KS(25) = 0.0
      KS(26) = 0.0
      KS(27) = 0.0
      KS(28) =-D(3)*6.0
      KS(29) =-D(6)*6.0
      KS(30) =-D(5)*6.0
      GO TO 67
   63 CONTINUE
      DO 65 I = 1,30
      KS(I) = 0.0
   65 CONTINUE
      KS( 1) = 1.0
      KS( 4) = XC3
      KS( 9) = 1.0
      KS(11) = XC
      KS(12) = YC3
      KS(14) = 0.5
      KS(17) = YC
   67 CONTINUE
C
C     MULTIPLY FIRST 3 ROWS BY 2.0
C
      DO 70 I = 1,18
   70 KS(I) = KS(I)*2.0
C
      XCSQ = XSUBC**2
      YCSQ = YSUBC**2
      XBSQ = XSUBB**2
      XCYC = XSUBC*YSUBC
C
C     F1LL  (HBAR) MATRIX STORING AT A(37) TRHU A(72)
C
      DO 90 I = 37,72
   90 A(I) = 0.0
C
      A(37) = XBSQ
      A(40) = XBSQ*XSUBB
      A(44) = XSUBB
      A(49) =-2.0*XSUBB
      A(52) =-3.0*XBSQ
      A(55) = XCSQ
      A(56) = XCYC
      A(57) = YCSQ
      A(58) = XCSQ*XSUBC
      A(59) = YCSQ*XSUBC
      A(60) = YCSQ*YSUBC
      A(62) = XSUBC
      A(63) = YSUBC*2.
      A(65) = XCYC*2.0
      A(66) = YCSQ*3.0
      A(67) =-2.0*XSUBC
      A(68) =-YSUBC
      A(70) =-3.0*XCSQ
      A(71) =-YCSQ
C
      IF (T2 .EQ. 0.0) GO TO 110
C
C     ALL OF THE FOLLOWING OPERATIONS THROUGH STATEMENT LABEL 500
C     ARE NECESSARY IF T2 IS NON-ZERO.
C
C     GET THE G2X2 MATRIX
C
      MATID  = MATID2
      INFLAG = 3
      CALL MAT (ECPT(1))
      IF (G2X211.EQ.0.0 .AND. G2X212.EQ.0.0 .AND. G2X222.EQ.0.0)
     1    GO TO 110
      G2X2(1) = G2X211*T2
      G2X2(2) = G2X212*T2
      G2X2(3) = G2X212*T2
      G2X2(4) = G2X222*T2
C
      DETERM  = G2X2(1)*G2X2(4) - G2X2(3)*G2X2(2)
      J2X2(1) = G2X2(4)/DETERM
      J2X2(2) =-G2X2(2)/DETERM
      J2X2(3) =-G2X2(3)/DETERM
      J2X2(4) = G2X2(1)/DETERM
C
C     (H  ) IS PARTITIONED INTO A LEFT AND RIGHT PORTION AND ONLY THE
C       YQ  RIGHT PORTION IS COMPUTED AND USED AS A  (2X3). THE LEFT
C           2X3 PORTION IS NULL.  THE RIGHT PORTION WILL BE STORED AT
C           A(73)...A(78) UNTIL NOT NEEDED ANY FURTHER.
C
      TEMP  =  2.0*D(2) + 4.0*D(9)
      A(73) = -6.0*(J2X2(1)*D(1) + J2X2(2)*D(3))
      A(74) = -J2X2(1)*TEMP + 6.0*J2X2(2)*D(6)
      A(75) = -6.0*(J2X2(1)*D(6) + J2X2(2)*D(5))
      A(76) = -6.0*(J2X2(2)*D(1) + J2X2(4)*D(3))
      A(77) = -J2X2(2)*TEMP + 6.0*J2X2(4)*D(6)
      A(78) = -6.0*(J2X2(2)*D(6) + J2X2(4)*D(5))
C
C     THE ABOVE 6 ELEMENTS NOW REPRESENT THE (H  ) MATRIX (2X3)
C                                              YQ
C
C     ADD TO 6 OF THE (HBAR) ELEMENTS THE RESULT OF(H  )(H  )
C                                                    UY   YQ
C     THE PRODUCT IS FORMED DIRECTLY IN THE ADDITION PROCESS BELOW.
C     NO (H  ) MATRIX IS ACTUALLY COMPUTED DIRECTLY.
C          UY
C
C     THE FOLLOWING IS THEN PER STEPS 6 AND 7 PAGE -16- MS-17.
C
      DO 100 I = 1,3
      A(I+39) = A(I+39) + XSUBB*A(I+72)
  100 A(I+57) = A(I+57) + XSUBC*A(I+72) + YSUBC*A(I+75)
C
C     THIS ENDS ADDED COMPUTATION FOR CASE OF T2 NOT ZERO
C
  110 CONTINUE
C
C     AT THIS POINT INVERT  (H) WHICH IS STORED AT A(37) THRU A(72)
C     STORE INVERSE BACK IN A(37) THRU A(72)
C     NO NEED TO COMPUTE DETERMINANT SINCE IT IS NOT USED SUBSEQUENTLY.
C
      ISING = -1
      CALL INVERS (6,A(37),6,A(73),0,DETERM,ISING,A(79))
C
C     CHECK TO SEE IF H WAS SINGULAR
C
      IF (ISING .NE. 2) GO TO 120
C
C
C     ISING = 2 IMPLIES SINGULAR MATRIX THUS ERROR CONDITION.
C
      CALL MESAGE (-30,38,ECPT(1))
C
C     SAVE H-INVERSE IF TRI-PLATE IS CALLING
C
  120 DO 130 I = 1,36
  130 HINV(I) = A(I+36)
C
C     FILL  S-MATRIX, EQUIVALENCED TO A(55).  (6X3)
C
      S( 1) = 1.0
      S( 2) = 0.0
      S( 3) =-XSUBB
      S( 4) = 0.0
      S( 5) = 1.0
      S( 6) = 0.0
      S( 7) = 0.0
      S( 8) = 0.0
      S( 9) = 1.0
      S(10) = 1.0
      S(11) = YSUBC
      S(12) =-XSUBC
      S(13) = 0.0
      S(14) = 1.0
      S(15) = 0.0
      S(16) = 0.0
      S(17) = 0.0
      S(18) = 1.0
C
C     COMPUTE  S , S ,  AND S    NO TRANSFORMATIONS
C               A   B        C
C
C                -1
C     S  = - K  H  S ,   S  = K  H   ,   S  = K  H
C      A      S           B    S  IB      C    S  IC
C
C     S   COMPUTATION.
C      A
C
      CALL GMMATS (HINV(1),6,6,0, S(1),6,3,0, A(16))
C
C     DIVIDE  H-INVERSE INTO A LEFT 6X3 AND RIGHT 6X3 PARTITION.
C
      I = 0
      J =-6
  150 J = J + 6
      K = 0
  160 K = K + 1
      I = I + 1
      ISUB = J + K
      HIB(I) = HINV(ISUB    )
      HIC(I) = HINV(ISUB + 3)
      IF (K .LT. 3 ) GO TO 160
      IF (J .LT. 30) GO TO 150
C
      CALL GMMATS (KS(1),5,6,0, A(16),6,3,0, A(1))
C
C     MULTIPLY S SUB A BY (-1)
C
      DO 170 I = 1,15
  170 A(I) = -A(I)
C
C     S  COMPUTATION
C      B
C
      CALL GMMATS (KS,5,6,0, HIB,6,3,0, A(16))
C
C     S  COMPUTATION
C      C
C
      CALL GMMATS (KS,5,6,0, HIC,6,3,0, A(31))
C
C     RETURN IF TRI OR QUAD PLATE ROUTINE IS CALLING.
C
      IF (IOPT .GT. 0) RETURN
C                                   T
C     TRANSFORM  S , S , S  WITH   E  T  , I = A,B,C
C                 A   B   C            I
C                              T         T
C     COMPUTING TRANSPOSE OF  E  T  =  T  E
C                                 I     I
      DO 200 I = 1,3
C
C     POINTER TO S MATRIX = 15*I - 14
C                 I
C     POINTER TO OUTPUT POSITION = 30*I - 21
C
C     CHECK TO SEE IF T IS NEEDED.
C
      IF (NECPT(4*I+9)) 180,190,180
  180 CALL TRANSS (NECPT(4*I+9),T)
      CALL GMMATS (T,3,3,1, E( 1),3,3,0, TITE( 1))
      CALL GMMATS (T,3,3,1, E(10),3,3,0, TITE(10))
      CALL GMMATS (A(15*I-14),5,3,0, TITE,6,3,1, PH1OUT(30*I-21))
      GO TO 200
  190 CALL GMMATS (A(15*I-14),5,3,0, E,6,3,1, PH1OUT(30*I-21))
  200 CONTINUE
      PH1OUT(1) = ECPT(1)
      PH1OUT(2) = ECPT(2)
      PH1OUT(3) = ECPT(3)
      PH1OUT(4) = ECPT(4)
C
C     PH1OUT(5) IS A DUMMY
C
      PH1OUT(6) = ECPT( 7)
      PH1OUT(7) = ECPT(11)
      PH1OUT(8) = ECPT(12)
C
C     PHASE I   BASIC BENDING TRIANGLE  SDR2 COMPLETE
C
      RETURN
      END

      INTEGER FUNCTION KHRFN5 (WORD1,I,WORD2,J)
C
C     THIS FUNCTION IS SAME AS KHRFN1 EXECPT THAT THE BYTE (WORD1(1) ONL
C     IS IN REVERSE ORDER.  (THIS FUNCTION IS MAINLY USED BY VAX)
C
      INTEGER  WORD1(1), WORD2(1)
      COMMON /SYSTEM/ DUMMY(40), NCPW
      KHRFN5=KHRFN1(WORD1(1),NCPW-I+1,WORD2(1),J)
      RETURN
      END

      SUBROUTINE FBS (ZS,ZD)
C
C     GIVEN A LOWER TRIANGULAR FACTOR WITH DIAGONAL SUPERIMPOSED, AND
C     WRITTEN WITH TRAILING STRING DEFINITION WORDS, FBS WILL PERFORM
C     THE FORWARD-BACKWARD SUBSTITUTION NECESSARY TO SOLVE A LINEAR
C     SYSTEM OF EQUATIONS.
C   
C     THE ARE TWO METHODS AVAILABLE FOR THIS PROCESS.
C     METHOD 1 - THIS METHOD READS AS MANY RIGHT HAND VECTORS INTO MEMORY
C                AS POSSIBLE, AND THEN READS THE LOWER TRIANGULAR MATRIX
C                USING GETSTR AND GETSTB TO SOLVE FOR THE SOLUTION VECTORS.
C                MORE THAN ONE PASS MAY BE REQUIRED IF INSUFFICIENT MEMORY
C                EXISTS FOR LOADING ALL RIGHT HAND VECTORS AT ONE TIME.
C                THIS METHOD IS THE OLDER OF THE TWO METHODS.
C                (SEE SUBROUTINES FBSF, FBSF1, FBSF2, FBSF3 AND FBSF4)
C     METHOD 2 - THIS METHOD IS THE SAME AS METHOD 1 WITH THE EXCEPTION
C                THAT MEMORY EXISTS FOR LOADING PART OR ALL OF THE LOWER
C                TRIANGULAR MATRIX INTO OPEN CORE AFTER LOADING ALL OF 
C                THE RIGHT HAND VECTORS INTO OPEN CORE.  THIS METHOD
C                WILL ELIMINATE THE NEED TO READ THE LOWER TRIANGULAR
C                MATRIX TWICE (ONCE FORWARD AND ONCE BACKWARD).
C                (SEE SUBROUTINES FBSI, FBSI1, FBSI2, FBSI3 AND FBSI4)
C
C     THE SELECTION OF METHOD 1 OR 2 IS DEPENDENT UPON WHETHER
C     MEMORY EXISTS FOR READING THE LOWER TRIANGULAR MATRIX INTO MEMORY
C
C     SEE SUBROUTINES FBSF AND FBSI FOR OPEN CORE LAYOUTS
C
      INTEGER                    DBL      ,DBB      ,SYSBUF
     &,                          WORDS    ,RLCMPX   ,RC       
     &,                          TYPEL    ,TYPEB
      REAL                       ZS(1)    
      DOUBLE  PRECISION          ZD(1) 
      COMMON /FBSX  / DBL(7)    ,DBU(7)   ,DBB(7)   ,DBX(7)   ,LCORE   
     1,               PREC      ,SIGN     ,SCRX
      COMMON /SYSTEM/ SYSBUF    ,NOUT   
      COMMON /TYPE  / PRC(2)    ,WORDS(4) ,RLCMPX(4)
C
C     GENERAL INITIALIZATION
C
C   DIAG 46 FORCES METHOD ONE
C
      CALL SSWTCH ( 46, L46 )
      IF ( L46 .NE. 0 ) GO TO 1000
      NCOL    = DBL( 2 )
      TYPEL   = DBL( 5 )
      TYPEB   = DBB( 5 )
      RC      = RLCMPX( TYPEB )
C
C     NRHVWD = NUMBER OF WORDS REQUIRED FOR EACH RIGHT HAND VECTOR
C     NRHV   = NUMBER OF RIGHT HAND VECTORS
C  
      NRHVWD    = WORDS(TYPEL) * NCOL
      NRHV      = DBB(2)
C
C CHECK FOR RIGHT HAND VECTORS BEING THE IDENTITY MATRIX
C
      IF ( DBB( 4 ) .EQ. 8 ) NRHV = NCOL
C
C COMPUTE THE MEMORY TO READ ALL OF THE RIGHT HAND VECTORS INTO MEMORY
C
      NEED      = NRHV * NRHVWD
      IREMAIN   = LCORE - 2 * SYSBUF - NEED
C
C IF LESS THAN ONE COLUMN WORTH OF MEMORY AVAILABLE, USE METHOD ONE
C
      IF ( IREMAIN .GE. NRHVWD ) GO TO 2000
C
C  METHOD ONE - FIRST, CHECK FOR SUFFICIENT MEMORY FOR PROCESS
C
1000  MEMAVL = LCORE - 2*SYSBUF - NRHVWD
      IF ( MEMAVL .LE. 0 ) CALL MESAGE ( -8, -MEMAVL, SUBNAM )
      CALL FBSF ( ZS, ZD )
      GO TO 7000
C
C  METHOD TWO
C
2000  CALL FBSI ( ZS, ZD )
7000  CONTINUE
      RETURN
      END

      SUBROUTINE EMGCOR (BUF)
C
C     CORE ALLOCATION AND PARAMETER INITIALIZATION FOR MAIN -EMG-
C     PROCESSOR -EMGPRO-.
C
      LOGICAL         ANYCON, ERROR, HEAT
      INTEGER         Z, SYSBUF, OUTPT, SUBR(2), TYPE(3), BUF(8), BUFS,
     1                BUF1, BUF2, RD, WRT, RDREW, WRTREW, CLS, PRECIS,
     2                CLSREW, EST, CSTM, DIT, GEOM2, NAME(2), EOR,
     3                FLAGS, SCR4
      CHARACTER       UFM*23, UWM*25, UIM*29, SFM*25, SWM*27
      COMMON /XMSSG / UFM, UWM, UIM, SFM, SWM
      COMMON /BLANK / NOKMB(3), DUMMY(13), VOLUME, SURFAC
      COMMON /SYSTEM/ KSYSTM(65)
      COMMON /NAMES / RD, RDREW, WRT, WRTREW, CLSREW, CLS
      COMMON /EMGFIL/ EST, CSTM, MPT, DIT, GEOM2, KMBMAT(3), KMBDIC(3)
      COMMON /EMGPRM/ ICORE, JCORE, NCORE, ICSTM, NCSTM, IMAT, NMAT,
     1                IHMAT, NHMAT, IDIT, NDIT, ICONG, NCONG, LCONG,
     2                ANYCON, FLAGS(3), PRECIS, ERROR, HEAT,
     3                ICMBAR, LCSTM, LMAT, LHMAT, KFLAGS(3), L38
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE     (KSYSTM(1), SYSBUF)
      EQUIVALENCE     (KSYSTM(2), OUTPT )
      DATA    TYPE  / 4HSTIF,4HMASS,4HDAMP/
      DATA    SCR4  / 304   /
      DATA    SUBR  / 4HEMGC,4HOR  /,  EOR/ 1 /
C
      IF (L38 .EQ. 0) WRITE (OUTPT,5) UIM
    5 FORMAT (A29,' 238, TURN DIAG 38 ON FOR ADDITIONAL ELEMENT ',
     1        'PROCESSING INFORMATION',/)
C
C     DETERMINATION OF FUNCTIONS TO BE PERFORMED AND RESULTANT NUMBER
C     OF BUFFERS NEEDED.
C
      BUFS = 1
      DO 10 I = 1,3
      FLAGS(I)  = 0
      KFLAGS(I) = 0
      IF (NOKMB(I) .EQ. -1) GO TO 10
      FLAGS(I) = -1
      BUFS = BUFS + 2
   10 CONTINUE
      IF (VOLUME.GT.0.0 .OR. SURFAC.GT.0.0) BUFS = BUFS + 1
C
C     ALLOCATE BUFFERS
C
      N = NCORE
      DO 20 I = 1,BUFS
      BUF(I) = N - SYSBUF - 2
      N = BUF(I)
   20 CONTINUE
      NCORE = N - 1
      IF (NCORE .LT. JCORE) CALL MESAGE (-8,JCORE-NCORE,SUBR)
C
C  OPEN REQUIRED DATA BLOCKS.
C
      BUF1 = BUF(1)
      CALL OPEN (*60,EST,Z(BUF1),RDREW)
      CALL SKPREC (EST,1)
      IBUF = 1
C
C     K, M, OR B MATRIX DATA BLOCKS
C
      DO 50 I = 1,3
      IF (FLAGS(I) .EQ. 0) GO TO 50
      BUF1 = BUF(IBUF+1)
      BUF2 = BUF(IBUF+2)
      CALL OPEN (*30,KMBMAT(I),Z(BUF1),WRTREW)
      CALL OPEN (*30,KMBDIC(I),Z(BUF2),WRTREW)
      CALL FNAME (KMBMAT(I),NAME)
      CALL WRITE (KMBMAT(I),NAME,2,EOR)
      CALL FNAME (KMBDIC(I),NAME)
      CALL WRITE (KMBDIC(I),NAME,2,EOR)
      IBUF = IBUF + 2
      KFLAGS(I) = 1
      GO TO 50
C
C     FILE REQUIRED IS MISSING
C
   30 FLAGS(I) = 0
      CALL PAGE2 (2)
      WRITE  (OUTPT,40) UWM,KMBMAT(I),KMBDIC(I),TYPE(I)
   40 FORMAT (A25,' 3103, EMGCOR OF EMG MODULE FINDS EITHER OF DATA ',
     1        'BLOCKS ',I4,4H OR ,I4,' ABSENT AND THUS,', /5X,A4,
     2        ' MATRIX WILL NOT BE FORMED.')
   50 CONTINUE
C
C     IF VOLUME OR SURFACE COMPUTATION IS REQUESTED BY USER FOR THE 2-D
C     AND 3-D ELEMENTS, OPEN SCR4 FILE. (ONLY TO BE CLOSED BY EMGFIN)
C
      IF (VOLUME.LE.0.0 .AND. SURFAC.LE.0.0) GO TO 55
      IBUF = IBUF + 1
      BUF1 = BUF(IBUF)
      CALL OPEN (*80,SCR4,Z(BUF1),WRTREW)
C
C     ALL FILES READY TO GO.
C
   55 NCORE = BUF(IBUF) - 1
      RETURN
C
C     EST MISSING
C
   60 CALL PAGE2 (2)
      WRITE  (OUTPT,70) SWM,EST
   70 FORMAT (A27,' 3104, EMGCOR FINDS EST (ASSUMED DATA BLOCK',I5,
     2        ') MISSING.  EMG MODULE COMPUTATIONS LIMITED.')
      FLAGS(1) = 0
      FLAGS(2) = 0
      FLAGS(3) = 0
      RETURN
C
   80 CALL MESAGE (-1,SCR4,SUBR)
      RETURN
      END

      SUBROUTINE MMA322 ( ZI, ZD )
C
C     MMA322 PERFORMS THE MATRIX OPERATION IN REAL DOUBLE PRECISION
C       (+/-)A(T & NT) * B (+/-)C = D
C     
C     MMA322 USES METHOD 32 WHICH IS AS FOLLOWS:
C       1.  THIS IS FOR "A" NON-TRANSPOSED AND TRANSPOSED
C       2.  CALL MMARM1 TO PACK AS MANY COLUMNS OF "A" INTO MEMORY 
C           AS POSSIBLE LEAVING SPACE FOR ONE COLUMN OF "B" AND "D".
C       3.  ADD EACH ROW TERM OF "C" TO "D" MATRIX COLUMN
C       4.  CALL MMARC1,2,3,4 TO READ COLUMNS OF "B" AND "C".
C
      INTEGER           ZI(2)      ,T
      INTEGER           TYPEI      ,TYPEP    ,TYPEU ,SIGNAB, SIGNC
      INTEGER           RD         ,RDREW    ,WRT   ,WRTREW, CLSREW,CLS
      INTEGER           OFILE      ,FILEA    ,FILEB ,FILEC , FILED
      DOUBLE PRECISION  ZD(2)      ,DTEMP    ,DD(2)
      INCLUDE           'MMACOM.COM'     
      COMMON / NAMES  / RD         ,RDREW    ,WRT   ,WRTREW, CLSREW,CLS
      COMMON / TYPE   / IPRC(2)    ,NWORDS(4),IRC(4)
      COMMON / MPYADX / FILEA(7)   ,FILEB(7) ,FILEC(7)    
     1,                 FILED(7)   ,NZ       ,T     ,SIGNAB,SIGNC ,PREC1 
     2,                 SCRTCH     ,TIME
      COMMON / SYSTEM / KSYSTM(152)
      COMMON / ZBLPKX / D(4)       ,KDROW
      COMMON / UNPAKX / TYPEU      ,IUROW1   ,IUROWN, INCRU
      COMMON / PACKX  / TYPEI      ,TYPEP    ,IPROW1, IPROWN , INCRP
      EQUIVALENCE       ( D(1)     ,DD(1) )
      EQUIVALENCE       (KSYSTM( 1),SYSBUF)  , (KSYSTM( 2),IWR   ) 
      EQUIVALENCE       (FILEA(2)  ,NAC   )  , (FILEA(3)  ,NAR   )
     1,                 (FILEA(4)  ,NAFORM)  , (FILEA(5)  ,NATYPE)
     2,                 (FILEA(6)  ,NANZWD)  , (FILEA(7)  ,NADENS)
      EQUIVALENCE       (FILEB(2)  ,NBC   )  , (FILEB(3)  ,NBR   )
     1,                 (FILEB(4)  ,NBFORM)  , (FILEB(5)  ,NBTYPE)
     2,                 (FILEB(6)  ,NBNZWD)  , (FILEB(7)  ,NBDENS)
      EQUIVALENCE       (FILEC(2)  ,NCC   )  , (FILEC(3)  ,NCR   )
     1,                 (FILEC(4)  ,NCFORM)  , (FILEC(5)  ,NCTYPE)
     2,                 (FILEC(6)  ,NCNZWD)  , (FILEC(7)  ,NCDENS)
      EQUIVALENCE       (FILED(2)  ,NDC   )  , (FILED(3)  ,NDR   )
     1,                 (FILED(4)  ,NDFORM)  , (FILED(5)  ,NDTYPE)
     2,                 (FILED(6)  ,NDNZWD)  , (FILED(7)  ,NDDENS)
C
C   OPEN CORE ALLOCATION AS FOLLOWS:
C     Z( 1        ) = ARRAY FOR ONE COLUMN OF "B" MATRIX IN COMPACT FORM
C     Z( IDX      ) = ARRAY FOR ONE COLUMN OF "D" MATRIX
C     Z( IAX      ) = ARRAY FOR MULTIPLE COLUMNS OF "A" MATRIX
C        THROUGH
C     Z( LASMEM   )
C     Z( IBUF4    ) = BUFFER FOR "D" FILE
C     Z( IBUF3    ) = BUFFER FOR "C" FILE
C     Z( IBUF2    ) = BUFFER FOR "B" FILE 
C     Z( IBUF1    ) = BUFFER FOR "A" FILE
C     Z( NZ       ) = END OF OPEN CORE THAT IS AVAILABLE
C
      FILED( 2 ) = 0
      FILED( 6 ) = 0
      FILED( 7 ) = 0
      IDROW = IBROW 
      DO 60000 II = 1, NBC
      CALL BLDPK ( NDTYPE, NDTYPE, OFILE, 0, 0 )
C      PRINT *,' PROCESSING B MATRIX COLUMN, II=',II
C      
C READ A COLUMN FROM THE "B" MATRIX
C
      SIGN   = 1
      IRFILE = FILEB( 1 )        
      CALL MMARC2 ( ZI, ZD )
      LASINDB = LASIND
C
C NOW READ "C", OR SCRATCH FILE WITH INTERMEDIATE RESULTS.
C IF NO "C" FILE AND THIS IS THE FIRST PASS, INITIALIZE "D" COLUMN TO ZERO.
C
      IF ( IFILE .EQ. 0 ) GO TO 950            
      IF ( IPASS .EQ. 1 ) SIGN = SIGNC
      IRFILE = IFILE
C      
C READ A COLUMN FROM THE "C" MATRIX
C
      CALL MMARC2 ( ZI( IDX ), ZD( IDX2+1 ) )
      LASINDC = LASIND + IDX - 1
950   CONTINUE
C
C CHECK IF COLUMN OF "B" IS NULL
C
      IF ( ZI( 1 ) .NE. 0 ) GO TO 1000
      IF ( IFILE .NE. 0 ) GO TO 960
951   DD(1) = 0.0D0
      KDROW = 1
      CALL ZBLPKI
      GO TO 55000
960   IF ( ZI( IDX ) .EQ. 0 ) GO TO 951
      INDXC = IDX     
961   IF ( INDXC .GE. LASINDC ) GO TO 55000
      IROWC1 = ZI( INDXC )
      ICROWS = ZI( INDXC+1 )
      IROWCN = IROWC1 + ICROWS - 1
      INDXCV = ( INDXC+3 ) / 2 
      DO 970 I = IROWC1, IROWCN
      DD( 1 ) = ZD( INDXCV )
      KDROW  = I
      CALL ZBLPKI
      INDXCV = INDXCV + 1
970   CONTINUE
      INDXC  = INDXC + 2 + ICROWS*NWDD
      GO TO 961
1000  CONTINUE
      IROWB1 = ZI( 1 )
      IROWS  = ZI( 2 ) 
      IROWBN = IROWB1 + IROWS - 1
      INDXB  = 1
      INDXA  = IAX
      INDXC  = IDX  
      IF ( IFILE .EQ. 0 .OR. INDXC .GE. LASINDC ) GO TO 9000
      IROWC1 = ZI( INDXC )
      ICROWS = ZI( INDXC+1 )
      IROWCN = IROWC1 + ICROWS - 1
1010  CONTINUE
C
C CHECK TO ADD TERMS FROM "C" OR INTERIM SCRATCH FILE BEFORE CURRENT ROW
C
      IF ( IDROW .EQ. 0 .OR. IROWC1 .GT. IDROW ) GO TO 9000
4000  CONTINUE
      IROWN = IDROW
      IF ( IROWCN .LT. IDROW ) IROWN = IROWCN
5000  CONTINUE
      INDXCV = ( INDXC+3 ) / 2
      NROWS = IROWN - IROWC1 + 1
      DO 6000 I = 1, NROWS
      KDROW = IROWC1 + I - 1
      DD( 1 ) = ZD( INDXCV )
      INDXCV = INDXCV + 1
      CALL ZBLPKI
6000  CONTINUE
      IF ( IROWCN .GE. IDROW ) GO TO 9000
      INDXC = INDXC + 2 + ICROWS*NWDD
      IF ( INDXC .GE. LASINDC ) GO TO 9000
      IROWC1 = ZI ( INDXC )
      ICROWS = ZI ( INDXC+1 )
      IROWCN = IROWC1 + ICROWS - 1
      GO TO 4000
9000  CONTINUE
C      
C CHECK FOR NULL COLUMN FROM "B" MATRIX
C
      IF ( IROWB1 .EQ. 0 ) GO TO 50000
C
C  TRANSPOSE CASE ( A(T) * B + C )
C
C DOUBLE PRECISION
10000 CONTINUE
      DO 15000 I = 1, NCOLPP
      DD(1) = 0.0D0
      KDROW  = IDROW + I
      ICOLA  = IBROW + I
      IF ( ICOLA .NE. IABS( ZI( INDXA ) ) ) GO TO 70001
      INDXAL = ZI( INDXA+1 ) + IAX - 1
      INDXA  = INDXA + 2
      INDXB  = 1
11000 IF ( INDXB .GE. LASINDB ) GO TO 14500
      IROWB1 = ZI( INDXB )
      IROWS  = ZI( INDXB+1 )
      IROWBN = IROWB1 + IROWS - 1
      INDXBV = ( ( INDXB+3 ) / 2 )  - IROWB1  
      INDXB  = INDXB + 2 + IROWS*NWDD
12000 CONTINUE
      IF ( INDXA .GE. INDXAL ) GO TO 14500
      IROWA1 = ZI( INDXA )
      NTMS   = ZI( INDXA+1 )
      IROWAN = IROWA1 + NTMS - 1
      IF ( IROWBN .LT. IROWA1 ) GO TO 11000
      IF ( IROWAN .LT. IROWB1 ) GO TO 14200
      IROW1  = MAX0( IROWA1, IROWB1 )
      IROWN  = MIN0( IROWAN, IROWBN )
      INDXAV = ( (INDXA+3 ) / 2 ) - IROWA1
      DTEMP  = 0.0D0
C      PRINT *,' IROW1,N=',IROW1,IROWN
      DO 14000 K = IROW1, IROWN
C      PRINT *,' K,D,A,B=',K,DTEMP,ZD(INDXAV+K),ZD(INDXBV+K)
      DTEMP = DTEMP +  ZD( INDXAV+K ) * ZD( INDXBV+K ) 
14000 CONTINUE                                                
      DD( 1 ) = DD(1) + DTEMP
      IF ( IROWAN .GT. IROWBN ) GO TO 11000
14200 CONTINUE
      INDXA  = INDXA + 2 + NTMS*NWDD
      GO TO 12000
14500 INDXA  = INDXAL
14510 IF ( INDXC .GE. LASINDC .OR. IFILE .EQ. 0 ) GO TO 14600
      IF ( KDROW .LT. IROWC1 ) GO TO 14600
      IF ( KDROW .GT. IROWCN ) GO TO 14550
      INDXCV  = ( INDXC+3 ) / 2 + KDROW - IROWC1
C      PRINT *,' ADDING C,DD,C=',DD(1),ZD(INDXCV)
      DD( 1 ) = DD( 1 ) + ZD( INDXCV )
      GO TO 14600
14550 INDXC   = INDXC + 2 + ICROWS*NWDD
      IF ( INDXC .GE. LASINDC ) GO TO 14600
      IROWC1  = ZI( INDXC )
      ICROWS  = ZI( INDXC+1 )
      IROWCN  = IROWC1 + ICROWS - 1
      GO TO 14510
14600 CONTINUE
      CALL ZBLPKI
15000 CONTINUE
50000 CONTINUE
      IF ( KDROW .EQ. NDR .OR. IFILE .EQ. 0 .OR. INDXC .GE. LASINDC ) 
     &    GO TO 55000
C
C ADD REMAINING TERMS FROM EITHER THE "C" MATRIX OR INTERIM SCRATCH MATRIX
C
      IROW1 = KDROW + 1
50100 CONTINUE
      INDXCV = ( INDXC+3 ) / 2
      IF ( IROW1 .LT. IROWC1 ) GO TO 51000
      IF ( IROW1 .LE. IROWCN ) GO TO 50900
      INDXC   = INDXC + 2 + ICROWS*NWDD
      IF ( INDXC .GE. LASINDC ) GO TO 55000
      IROWC1  = ZI( INDXC )
      ICROWS  = ZI( INDXC+1 )
      IROWCN  = IROWC1 + ICROWS - 1
      GO TO 50100
50900 CONTINUE
      INDXCV = ( INDXC+3 ) / 2 + IROW1 - IROWC1
      IROWC1 = IROW1
51000 CONTINUE
      NROWS = IROWCN - IROWC1 + 1
      DO 51500 K = 1, NROWS
      KDROW = IROWC1 + K - 1
      DD( 1 ) = ZD( INDXCV )
      INDXCV = INDXCV + 1
      CALL ZBLPKI
51500 CONTINUE
      INDXC   = INDXC + 2 + ICROWS*NWDD
      IF ( INDXC .GE. LASINDC ) GO TO 55000
      IROWC1  = ZI( INDXC )
      ICROWS  = ZI( INDXC+1 )
      IROWCN  = IROWC1 + ICROWS - 1
      INDXCV  = ( INDXC+3 ) / 2
      GO TO 51000
55000 CONTINUE
      CALL BLDPKN ( OFILE, 0, FILED )
C END OF PROCESSING THIS COLUMN FOR THIS PASS
60000 CONTINUE
      GO TO 70000
70001 CONTINUE
      WRITE ( IWR, 90001 ) ICOLA, ZI( INDXA ), IAX, INDXA
90001 FORMAT(' UNEXPECTED COLUMN FOUND IN PROCESSING MATRIX A'
     &,/,' COLUMN EXPECTED:',I6
     &,/,' COLUND FOUND   :',I6
     &,/,' IAX =',I7,' INDXA=',I7 )
      CALL MESAGE ( -61, 0, 0 )
70000 RETURN
      END

      SUBROUTINE ASYCON
C
C     SUBROUTINE FOR COMPUTING CONSTANT TERM IN KAPPA MINUS
C
      COMPLEX         BSYCON,AI,C1,C1TEST,ALP,ALN,ARAT1,ARAT2
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /BLK2  / BSYCON
      COMMON /SYSTEM/ SYSBUF,IBBOUT
      COMMON /BLK1  / SCRK,SPS,SNS,DSTR,AI,PI,DEL,SIGMA,BETA,RES
C
      C1   = 1.0
      PI2  = 2.0*PI
      A1   = PI2/(SPS-SNS)
      GAM0 = SPS*DEL - SIGMA
      A2   =-A1
      B1   = GAM0/(SPS-SNS)
      S1   = SPS/(DSTR**2)
      S2   = SNS/DSTR
      C1TEST = 0.0
      DO 10 I = 1,200
      R    = I
      GAMP = PI2*R + GAM0
      GAMN =-PI2*R + GAM0
      C2P  = GAMP/DSTR - SCRK
      C2Q  = GAMP/DSTR + SCRK
      C2N  = GAMN/DSTR - SCRK
      C3Q  = GAMN/DSTR + SCRK
      NN   = 0
      CSEC = C2P*C2Q
      IF (CSEC .LT. 0.0) NN = 1
      T1   = GAMP*S1
      T2   = S2*SQRT(ABS(CSEC))
      IF (C2P.LT.0.0 .AND. C2Q.LT.0.0) T2 =-T2
      IF (NN .EQ. 0) ALP = T1 + T2
      IF (NN .EQ. 1) ALP = CMPLX(T1,T2)
      NN   = 0
      CSEC = C2N*C3Q
      IF (CSEC .LT. 0.0) NN = 1
      T1   = GAMN*S1
      T2   = S2*SQRT(ABS(CSEC))
      IF (C2N.LT.0.0 .AND. C3Q.LT.0.0) T2 =-T2
      IF (NN .EQ. 0) ALN = T1 + T2
      IF (NN .EQ. 1) ALN = CMPLX(T1,T2)
      ARAT1 = (A1*R+B1)/ALP
      ARAT2 = (A2*R+B1)/ALN
      C1    = C1*ARAT1*ARAT2
      IF (CABS((C1-C1TEST)/C1) .LT. 0.0001)  GO TO 60
      C1TEST = C1
   10 CONTINUE
      GO TO 9999
   60 CONTINUE
      BSYCON = C1
      RETURN
C
 9999 WRITE  (IBBOUT,1000) UFM
 1000 FORMAT (A23,' - AMG MODULE - SUBROUTINE ASYCON')
      CALL MESAGE (-61,0,0)
      RETURN
      END

      SUBROUTINE SSPLIN(NI,XYI,ND,XYD,KX,KY,KD,KT,DZ,G,NCORE,ISNG)
      LOGICAL LX,LY,LONE,IKD,IKT
      DIMENSION    G(1),XYI(1),XYD(1),NAME(2)
      REAL DET
      DATA NAME/4HSSPL,4HIN  /
      LONE = .TRUE.
      LX = .TRUE.
      LY = .TRUE.
      IKT = .FALSE.
      IKD = .FALSE.
      IF(KY.LT.0.OR.KX.LT.0) LONE = .FALSE.
      IF(KY.LT.0.OR.KX.GT.0) LX   = .FALSE.
      IF(KY.GT.0.OR.KX.LT.0) LY   = .FALSE.
      N = NI
      IF(LONE) N=N+1
      IF(LX  ) N=N+1
      IF(LY  ) N=N+1
      EX = FLOAT(KX)
      EY = FLOAT(KY)
      IF(KT.EQ.1) IKT = .TRUE.
      IF(KD.EQ.1)  IKD = .TRUE.
      NB = ND*(1+KD)
C
C     CORE NEEDED
C
C                A          G         INVERS
      NEEDED =           NB*NI      + 3*N
C                               B         C
      IF(IKT) NEEDED = NEEDED + NB*N  + NI*N
C                                      C          A OR B
      IF(.NOT.IKT) NEEDED = NEEDED + NI*N + MAX0(N*N,NB*N)
      IF(NEEDED.GT.NCORE) CALL MESAGE(-8,0,NAME)
      IS = NCORE - 3*N -1
      IG = 1
C
C     IF  KT = 1 COMPUTE B THEN A THEN C IN A SPACE
C
C     IF KT = 0 COMPUTE C THEN A THEN B IN A SPACE
C
      NT = 2*NI
      IF(.NOT.IKT) GO TO 65
      GO TO 95
C
C     COMPUTE TO A MATRIX
C
    1 K = IA
C
C     ZERO A
C
      II = K+1
      IK = II + N*N
      DO 5 I = II,IK
    5 G(I) = 0.0
      II = 1
      IK = 0
      DO 60 I = 1,NT,2
      K = K+IK
      JJ = I/2
      DO 20 J = I,NT,2
      K = K+1
      JJ = JJ +1
      SUM = 0.0
      XM = (XYI(I) - XYI(J)) **2
      XP = (XYI(I) + XYI(J)) **2
      YM = (XYI(I+1) - XYI(J+1)) **2
      YP = (XYI(I+1) + XYI(J+1)) **2
      T1 = XM+YM
      T2 = XP+YM
      T3 = XM+YP
      T4 = XP+YP
      IF(T1.NE.0.0) SUM = T1 * ALOG(T1)
      IF(T2.NE.0.0.AND.KX.NE.0)SUM = SUM + (T2*ALOG(T2)*EX)
      IF(T3.NE.0.0.AND.KY.NE.0) SUM = SUM + (T3 * ALOG(T3) * EY)
      IF(T4.NE.0.0.AND.KY.NE.0.AND.KX.NE.0)SUM=SUM+(T4*ALOG(T4)*EX*EY)
      IF(J.EQ.I) GO TO 10
      G(K) = SUM
C
C     SYMETRY TERM
C
      KK = K + (N-1)*(JJ-II)
      G(KK) = SUM
      GO TO 20
   10 G(K) = SUM + DZ
      KK = K
   20 CONTINUE
      INR = 0
      IF(.NOT.LONE) GO TO 30
      INR = INR +1
      G(K+INR) = 1.0
      G(KK+INR*N) = 1.0
   30 IF(.NOT.LX) GO TO 40
      INR = INR +1
      G(K+INR) = XYI(I)
      G(KK+INR*N) = XYI(I)
   40 IF(.NOT.LY) GO TO 50
      INR = INR +1
      G(K+INR) = XYI(I+1)
      G(KK+INR*N) = XYI(I+1)
   50 IK = II + INR
      II = II +1
   60 CONTINUE
C
C     CALL INVERS FOR A-1 C  OR A-1 B
C
C     REPLACE CALLS TO INVAER WITH CALLS TO INVERS
C     NO NEED TO COMPUTE DETERMINANT SINCE IT IS NOT USED SUBSEQUENTLY.
      ISNG = -1
      CALL INVERS(N,G(IA+1),N,G(MP),NC,DET,ISNG,G(IS))
      IF(ISNG.EQ.2) GO TO 1000
      IF(.NOT.IKT) GO TO 100
      IC = IA
      K = IC+1
      GO TO 70
C
C     C MATRIX COLUMN STORED
C
   65 IC = NB*NI
      MP = IC+1
   70 DO 90 I = 1,NI
      DO 80 J = 1,N
      IC = IC+1
      G(IC) = 0.0
      IF(I.EQ.J) G(IC) = 1.0
   80 CONTINUE
   90 CONTINUE
      IF(IKT) GO TO 170
      NC = NI
      IA = IC
      GO TO 1
C
C     B MATRIX COLUMN STORED
C
   95 IB = NB*NI
      MP = IB +1
      GO TO 110
  100 IB = IA
  110 NR = 2*ND
      K = IB +1
      DO 160 J = 1,NR,2
      DO 120 I = 1,NT,2
      IB = IB+1
      ALT1 = 0.0
      ALT2 = 0.0
      ALT3 = 0.0
      ALT4 = 0.0
      XM = XYD(J)- XYI(I)
      XP = XYI(I) + XYD(J)
      YM = XYD(J+1) - XYI(I+1)
      YP = XYI(I+1) + XYD(J+1)
      T1 = XM*XM + YM*YM
      T2 = XP*XP + YM*YM
      T3 = XM*XM + YP*YP
      T4 = XP*XP +YP*YP
      IF(T1.NE.0.0) ALT1 = ALOG(T1)
      IF(T2.NE.0.0.AND.KX.NE.0)ALT2 = ALOG(T2)
      IF(T3.NE.0.0.AND.KY.NE.0)ALT3 = ALOG(T3)
      IF(T4.NE.0.0.AND.KX.NE.0.AND.KY.NE.0) ALT4 = ALOG(T4)
      G(IB) = T1*ALT1 + T2*ALT2*EX + T3*ALT3*EY + T4*ALT4*EX*EY
      IF(.NOT.IKD) GO TO 120
      IK = IB + N
      G(IK) = 2.0*( XM*(1.0+ALT1) + XP*(1.0+ALT2)*EX +
     *        XM*(1.0+ALT3)*EY + XP*(1.0+ALT4)*EX*EY)
  120 CONTINUE
      INR = 0
      IF(.NOT.LONE) GO TO 130
      INR = INR +1
      G(IB+INR) = 1.0
      IF(IKD) G(IB+INR+N) = 0.0
  130 IF(.NOT.LX) GO TO 140
      INR = INR +1
      G(IB+INR) = XYD(J)
      IF(IKD) G(IB+INR+N) = 1.0
  140 IF(.NOT.LY) GO TO 150
      INR = INR +1
      G(IB+INR) = XYD(J+1)
      IF(IKD) G(IB+INR+N) = 0.0
  150 IB = IB+INR + N*KD
  160 CONTINUE
      IF(.NOT.IKT) GO TO 180
      IA = IB
      NC = NB
      GO TO 1
  170 CONTINUE
C
C     GMMATS WANTS ROW STORED SO INVERT ROWS AND COLUMNS AND INVERT
C     MULTIPLICATION ORDER
C
      CALL GMMATS(G(MP),NB,N,0,G(K),NI,N,1,G(IG))
      GO TO 1000
  180 CONTINUE
      CALL GMMATS(G(MP),NI,N,0,G(K),NB,N,1,G(IG))
 1000 RETURN
      END

      SUBROUTINE GELOOP(RBUF,BUF,XX,YY,ZZ,HC1,HC2,HC3)
C
C GELOOP COMPUTES MAGNETIC FIELD COMPONENTS HC1,HC2,HC3(IN BASIC
C COORDS. AT XX,YY,ZZ DUE TO GEMLOOP CARD. DATA FIELDS(EXCEPT SET ID)
C OF GEMLOOP ARE IN RBUF=REAL AND BUF=INTEGER
C
      INTEGER BUF(50),TI1,TI2
      DIMENSION RBUF(50),ZI(3),ZJ(3),ZK(3),ZJXI(3)
      DATA FPI/12.566371/
C
      HC1=0.
      HC2=0.
      HC3=0.
C
      XI=RBUF(1)
C
C ICID IS 0 FOR NOW AND UNUSED
C
      ICID=BUF(2)
      NPTS=BUF(3)
      NPTSM1=NPTS-1
      DO 10 I=1,NPTSM1
C
C 2 CONSECUTIVE POINTS DEFINE A SEGMENT OF A COIL. LET ZI BE THE VECTOR
C FROM 1ST POINT OF SEGMENT TO 2ND. LET ZJ BE VECTOR FROM FILED POINT
C XX,YY,ZZ TO 1ST POINT OF SEGMENT. ZK IS VECTOR FROM FILED POINT
C TO 2ND POINT. IF THE FILED POINT LIES ON A SEGMENT, IGNORE THE
C COMPUTATION FOR THAT SEGMENT FOR THAT POINT
C
      TI1=3*I+3
      TI2=3*(I+1)+3
      ZI(1)=RBUF(TI2-2)-RBUF(TI1-2)
      ZI(2)=RBUF(TI2-1)-RBUF(TI1-1)
      ZI(3)=RBUF(TI2)-RBUF(TI1)
      ZJ(1)=RBUF(TI1-2)-XX
      ZJ(2)=RBUF(TI1-1)-YY
      ZJ(3)=RBUF(TI1)-ZZ
      ZK(1)=RBUF(TI2-2)-XX
      ZK(2)=RBUF(TI2-1)-YY
      ZK(3)=RBUF(TI2)-ZZ
C
      ZKL=SQRT(ZK(1)**2+ZK(2)**2+ZK(3)**2)
      IF(ZKL.LT.1.E-8)GO TO 10
      ZJL=SQRT(ZJ(1)**2+ZJ(2)**2+ZJ(3)**2)
      IF(ZJL.LT.1.E-8)GO TO 10
      ZDOT=0.
      DO 5 II=1,3
      ZDOT=ZDOT+ZI(II)*(ZK(II)/ZKL-ZJ(II)/ZJL)
    5 CONTINUE
      ZJXI(1)=ZJ(2)*ZI(3)-ZJ(3)*ZI(2)
      ZJXI(2)=ZJ(3)*ZI(1)-ZJ(1)*ZI(3)
      ZJXI(3)=ZJ(1)*ZI(2)-ZJ(2)*ZI(1)
      ZLEN2=ZJXI(1)**2+ZJXI(2)**2+ZJXI(3)**2
      IF(ZLEN2.LT.1.E-8)GO TO 10
      FACTOR=XI*ZDOT/FPI/ZLEN2
      HC1=HC1+ZJXI(1)*FACTOR
      HC2=HC2+ZJXI(2)*FACTOR
      HC3=HC3+ZJXI(3)*FACTOR
   10 CONTINUE
      RETURN
      END

      SUBROUTINE DPLTST
C
      IMPLICIT INTEGER (A-Z)
      INTEGER         ERRTTL(32)
      COMMON /BLANK / NGP,NSETS,SKP1(8),PCDB,EQEXIN,ECT,SKP2(7),
     1                MERR,PARM,GPSET,ELSET,SKP3(6),MSET,PECT
      COMMON /SYSTEM/ BUFSIZ
      COMMON /ZZZZZZ/ X(1)
      DATA    OUTREW, REW / 1,1 /
      DATA    ERRTTL/ 8*2H  ,4HERRO,4HR ME,4HSSAG,4HES F,4HROM ,
     1                4HTHE ,4HPLOT,4H SET,4H DEF,4HINIT,4HION ,
     2                4HMODU,4HLE (,4HPLTS,4HET) ,9*1H  /
C
      NSETS  = 0
      PCDB   = 101
      EQEXIN = 102
      ECT    = 103
      EPT    = 104
      MERR   = 201
      PARM   = 202
      GPSET  = 203
      ELSET  = 204
      MSET   = 301
      PECT   = 302
      CALL TOTAPE (1,X(1))
C
      X(1) = EQEXIN
      CALL RDTRL (X)
      I2   = 2
      I3   = 3
      NGP  = X(I2) - X(I3)
      I1   = KORSZ(X) - BUFSIZ + 1
      CALL GOPEN (MERR,X(I1),OUTREW)
      CALL WRITE (MERR,-4,1,0)
      CALL WRITE (MERR,ERRTTL,32,0)
      CALL SETINP
      IF (NSETS .NE. 0) GO TO 150
      NSETS = -1
      GO TO 200
  150 I1 = NSETS + 1
      I2 = I1 + NGP
      I3 = KORSZ(X) - 4*BUFSIZ + 1
      CALL COMECT (X(I2),I3-I2)
      CALL CNSTRC (X(I1),X(I2),X(I3),I3-I2)
C
  200 CALL CLSTAB (MERR,REW)
      RETURN
      END

      SUBROUTINE CDETM2 (P,D,IP,PR,PI,DR,DI,IPS1)
C
C     ARRANGES  P,D,IP  IN ORDER BY MAGNITUDE OF DETERMINANT
C
      INTEGER          IP(6),IPS(3),IPS1(3)
      DOUBLE PRECISION P(6),D(6),PR(3),PI(3),DR(3),DI(3),D1,D2,D3,DD(3),
     1                 D4
      EQUIVALENCE      (D1,DD(1)),(D2,DD(2)),(D3,DD(3))
C
      D1 = D(1)*D(1) + D(2)*D(2)
      D2 = D(3)*D(3) + D(4)*D(4)
      D3 = D(5)*D(5) + D(6)*D(6)
      DO 10 I = 1,3
      DD(I) = DSQRT(DD(I))
   10 CONTINUE
      DO 20 I = 2,6,2
      K = I/2
      IPS(K)  = IP(I)
      IPS1(K) = IP(I)
   20 CONTINUE
C
C     SAVE STUFF IN OUTPUT AREAS
C
      DO 30 I = 1,3
      PR(I) = P(2*I-1)
      PI(I) = P(2*I  )
      DR(I) = D(2*I-1)
      DI(I) = D(2*I  )
   30 CONTINUE
C
C     SCALE  MAGNITUDES
C
      DO 80 I = 1,3
   40 IF (DD(I) .GT. 10.0D0) GO TO 60
   50 IF (DD(I) .LT.  1.0D0) GO TO 70
      GO TO 80
   60 DD(I)  = DD(I)*0.1D0
      IPS(I) = IPS(I) + 1
      GO TO 40
   70 DD(I)  = DD(I)*10.0D0
      IPS(I) = IPS(I) - 1
      GO TO 50
   80 CONTINUE
C
C     START COMPARISON TESTS
C
      IF (IPS(1).GT.IPS(2) .AND. IPS(2).GT.IPS(3)) GO TO 190
      IF (IPS(1).GT.IPS(2) .AND. IPS(1).GT.IPS(3)) GO TO 160
      IF (IPS(2)-IPS(3)) 100,90,130
   90 IF (D2 .GE. D3) GO TO 130
  100 IF (IPS(1)-IPS(3)) 120,110,160
  110 IF (D1 .GE. D3) GO TO 160
  120 IS1 = 1
      IS2 = 3
      ASSIGN 160 TO ISRET
      GO TO 200
  130 IF (IPS(1)-IPS(2)) 150,140,160
  140 IF (D1 .GE. D2) GO TO 160
  150 IS1 = 1
      IS2 = 2
      ASSIGN 160 TO ISRET
      GO TO 200
  160 IF (IPS(2)-IPS(3)) 180,170,190
  170 IF (D2 .GE. D3) GO TO 190
  180 IS1 = 2
      IS2 = 3
      ASSIGN 190 TO ISRET
      GO TO 200
  190 RETURN
C
C      SWITCHES VALUES ON IS1, IS2
C
  200 NX = IPS(IS1)
      IPS(IS1) = IPS(IS2)
      IPS(IS2) = NX
      NX       = IPS1(IS1)
      IPS1(IS1)= IPS1(IS2)
      IPS1(IS2)= NX
      D4       = PR(IS1)
      PR(IS1)  = PR(IS2)
      PR(IS2)  = D4
      D4       = PI(IS1)
      PI(IS1)  = PI(IS2)
      PI(IS2)  = D4
      D4       = DR(IS1)
      DR(IS1)  = DR(IS2)
      DR(IS2)  = D4
      D4       = DI(IS1)
      DI(IS1)  = DI(IS2)
      DI(IS2)  = D4
      D4       = DD(IS1)
      DD(IS1)  = DD(IS2)
      DD(IS2)  = D4
      GO TO ISRET, (160,190)
      END

       SUBROUTINE OPTP1C (ELT,ELOP,PR)
C
      INTEGER         COUNT,ELT(1),ELOP(2,2),EPT,PR(1),SYSBUF,OUTTAP,
     1                YCOR,PRCOR,PRC,NAME(2),CARD(2),DTYP(21),B1P1,ENTRY
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG / UFM,UWM,UIM,SFM
      COMMON /BLANK / SKP1(2),COUNT,SKP2(2),YCOR,B1P1,NPOW,
     1                SKP3(2),NPRW,NWDSP,SKP4,
     2                SKP5,EPT,SKP6(6),ENTRY(21)
      COMMON /OPTPW1/ PRCOR,PRC(1)
      COMMON /ZZZZZZ/ X(1)
      COMMON /GPTA1 / NTYPES,LAST,INCR,NE(1)
      COMMON /SYSTEM/ SYSBUF,OUTTAP
      COMMON /NAMES / NRD,NOEOR,NWRT,NWEOR
      EQUIVALENCE     (M1,RM1)
      DATA    NAME  / 4H OPT,4HP1C  /,  RM1 / -1.0 /
C
C      PROPERTY CORRELATOR TO EST DESIGN VARIABLE (100*EST LOCATION).
C      THIS VALUE ADDS/SUBTRACTS FROM EST ENTRY TO GET EPT LOCATION.
C      ENTRY IS MADE BY THE ELT ARRAY (SEQUENTIAL LIST OF NUMBERS WITH
C      ZEROS FOR ELEMENTS NOT USED).
C
      DATA    DTYP  /
     1        -14, -6, -10, -5, -5, -5, -5, -5, -5, -2,
C              BR  EB   IS  QM  M1  M2  QP  Q1  Q2  RD
     2         -4, -4,  -4, -4, -7, -4, -4, -2, -5, -5,
C              SH  TB   T1  T2  T6  TM  TP  TU  Q4  T3
     3          0/
C
      JETYP = 1
      IDPS  = ELOP(2,1)
      IDPE  = ELOP(2,2) - 1
C
      DO 80 IETYP = 1,NTYPES
      IF (ELT(IETYP) .LE. 0) GO TO 80
      NPR = (IDPE+1-IDPS)/NWDSP
      IF (NPR) 30,70,10
C
   10 IDX = ENTRY(JETYP)
      IDX = INCR*(IDX-1)
      IDP = IDX + 7
      CARD(1) = NE(IDP  )
      CARD(2) = NE(IDP+1)
      IF (NE(IDP+2) .GT. PRCOR) GO TO 130
C
      CALL LOCATE (*110,X(B1P1),CARD,I)
      ICPR = PR(IDPS)
      ICPT = IDPS
C
   20 CALL READ (*150,*160,EPT,PRC,NE(IDP+2),NOEOR,I)
C
C     SEQUENTIAL PROPERTY SEARCH.  PROPERTIES THAT ARE UNSORTED ON EPT
C     WILL FAIL.  THIS MAY OCCUR FOR 2 PID/CARD (E.G., QDMEM, QUAD2,
C     SHEAR, TRIA2, TRMEM).
C
      IF (PRC(1)-ICPR) 20,50,30
C
C     LOGIC OR UNSORTED FILE ERROR
C
   30 CALL PAGE2 (-2)
      WRITE  (OUTTAP,40) SFM,IETYP,PRC(1),NAME
   40 FORMAT (A25,' 2299, INCORRECT LOGIC FOR ELEMENT TYPE',I4,
     1        ', PROPERTY',I9,2H (,2A4,2H).)
      GO TO 100
C
C     PROPERTY IN CORE LOCATED.
C
   50 NPR = NPR - 1
      PR(ICPT+5) = 0
      PR(ICPT+4) = M1
C
C     LOCATE VARIABLE AS SET BY OPTP1A
C
      J1 = PR(ICPT+1)/100
      J2 = J1+DTYP(JETYP)
      PR(ICPT+3) = PRC(J2)
      PR(ICPT+2) = PRC(J2)
C
C     ICPT+0, +1 SET BY OPTP1A
C
      ICPT = ICPT + NWDSP
      IF (ICPT .GT. IDPE) GO TO 60
      ICPR = PR(ICPT)
      GO TO 20
C
C     NEW ELEMENT TYPE COMING
C
   60 IF (NPR .GT. 0) GO TO 30
      CALL FREAD (EPT,0,0,NWEOR)
   70 IDPS  = IDPE  + 1
      JETYP = JETYP + 1
      IF (JETYP .GT. NPOW) GO TO 90
      IDPE = ELOP(2,JETYP+1) - 1
   80 CONTINUE
C
C
   90 RETURN
C
C     ERRORS
C
  100 COUNT = -1
      GO TO 90
C
C     UNABLE TO LOCATE SORTED PID
C
  110 WRITE  (OUTTAP,120) SFM,NAME,PRC(1)
  120 FORMAT (A25,' 2300, ',2A4,'UNABLE TO LOCATE PROPERTY',I10,
     1       ' ON EPT OR IN CORE.')
      GO TO 100
C
C     INSUFFICIENT CORE /OPTPW1/
C
  130 CALL PAGE2 (-2)
      WRITE  (OUTTAP,140) UFM,NAME,PRCOR,IETYP
  140 FORMAT (A23,' 2296. INSUFFICIENT CORE ',2A4,1H(,I10,' ), ELEMENT',
     1        I9)
       GO TO 100
C
C     ILLEGAL EOF
C
  150 CALL MESAGE (-2,EPT,NAME)
C
C     ILLEGAL EOR
C
  160 CALL MESAGE (-3,EPT,NAME)
      GO TO 100
      END

      SUBROUTINE SDRETD (ELID,TI,GRIDS)
C
C     THIS ROUTINE (CALLED BY -SDR2E-) READS ELEMENT TEMPERATURE
C     DATA FROM A PRE-POSITIONED RECORD
C
C     ELID   = ID OF ELEMENT FOR WHICH DATA IS DESIRED
C     TI     = BUFFER DATA IS TO BE RETURNED IN
C     GRIDS  = 0 IF EL-TEMP FORMAT DATA IS TO BE RETURNED
C            = NO. OF GRID POINTS IF GRID POINT DATA IS TO BE RETURNED.
C     ELTYPE = ELEMENT TYPE TO WHICH -ELID- BELONGS
C     OLDEL  = ELEMENT TYPE CURRENTLY BEING WORKED ON (INITIALLY 0)
C     OLDEID = ELEMENT ID FROM LAST CALL
C     EORFLG = .TRUE. WHEN ALL DATA HAS BEEN EXHAUSTED IN RECORD
C     ENDID  = .TRUE. WHEN ALL DATA HAS BEEN EXHAUSTED WITHIN AN ELEMENT
C              TYPE.
C     BUFFLG = NOT USED
C     ITEMP  = TEMPERATURE LOAD SET ID
C     IDEFT  = NOT USED
C     IDEFM  = NOT USED
C     RECORD = .TRUE. IF A RECORD OF DATA IS INITIALLY AVAILABLE
C     DEFALT = THE DEFALT TEMPERATURE VALUE OR -1 IF IT DOES NOT EXIST
C     AVRAGE = THE AVERAGE ELEMENT TEMPERATURE
C
      LOGICAL         EORFLG   ,ENDID    ,BUFFLG   ,RECORD
      INTEGER         TI(33)   ,OLDEID   ,GRIDS    ,ELID     ,ELTYPE   ,
     1                OLDEL    ,NAME(2)  ,GPTT     ,DEFALT
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /SYSTEM/ DUM      ,IOUT
      COMMON /SDRETT/ ELTYPE   ,OLDEL    ,EORFLG   ,ENDID    ,BUFFLG   ,
     1                ITEMP    ,IDEFT    ,IDEFM    ,RECORD   ,OLDEID
      COMMON /SDR2X2/ DUMMY(6) ,GPTT     ,DUM20(20)
      COMMON /SDR2DE/ DUM2(2)  ,DEFALT
      DATA    NAME  / 4HSDRE   ,4HTD  /  ,MAXWDS   / 33 /
C
      IF (OLDEID .EQ. ELID) RETURN
      OLDEID = ELID
      IF (ITEMP .NE. 0) GO TO 20
      DO 10 I = 1,MAXWDS
   10 TI(I) = 0
      RETURN
C
   20 IF (.NOT.RECORD .OR. EORFLG) GO TO 80
      IF (ELTYPE .NE. OLDEL) GO TO 160
      IF (ENDID) GO TO 80
C
C     HERE WHEN ELTYPE IS AT HAND AND END OF THIS TYPE DATA
C     HAS NOT YET BEEN REACHED.  READ AN ELEMENT ID
C
   40 CALL READ (*300,*310,GPTT,ID,1,0,FLAG)
      IF (ID) 50,80,50
   50 IF (IABS(ID) .EQ. ELID) IF (ID) 90,90,70
      IF (ID) 40,40,60
   60 CALL READ (*300,*310,GPTT,TI,NWORDS,0,FLAG)
      GO TO 40
C
C     MATCH ON ELEMNT ID MADE AND IT WAS WITH DATA
C
   70 CALL READ (*300,*310,GPTT,TI,NWORDS,0,FLAG)
C
C     IF QUAD4 (ELTYPE 64) OR TRIA3 (ELTYPE 83) ELEMENT, SET FLAG FOR
C     SQUD42 OR STRI32
C
      IF (ELTYPE.NE.64 .OR. ELTYPE.NE.83) RETURN
      TI(7) = 13
      IF (TI(6) .NE. 1) TI(7) = 2
      RETURN
C
C     NO MORE DATA FOR THIS ELEMENT TYPE
C
   80 ENDID = .TRUE.
C
C     NO DATA FOR ELEMENT ID DESIRED, THUS USE DEFALT
C
   90 IF (DEFALT .EQ. -1) GO TO 140
      IF (GRIDS  .GT.  0) GO TO 110
      DO 100 I = 2,MAXWDS
  100 TI(I) = 0
      TI(1) = DEFALT
      IF (ELTYPE .EQ. 34) TI(2) = DEFALT
      RETURN
C
  110 IF (ELTYPE.NE.64 .OR. ELTYPE.NE.83) GO TO 120
C                 QUAD4             TRIA3
      TI(4) = 0
      TI(5) = 0
      TI(6) = 0
      TI(7) = 0
  120 DO 130 I = 1,GRIDS
  130 TI(I) = DEFALT
      TI(GRIDS+1) = DEFALT
      RETURN
C
C     NO TEMP DATA OR DEFALT
C
  140 WRITE  (IOUT,150) UFM,ELID,ITEMP
  150 FORMAT (A23,' 4016, THERE IS NO TEMPERATURE DATA FOR ELEMENT',I9,
     1       ' IN SET',I9)
      CALL MESAGE (-61,0,0)
C
C     LOOK FOR MATCH ON ELTYPE (FIRST SKIP ANY UNUSED ELEMENT DATA)
C
  160 IF (ENDID) GO TO 190
  170 CALL READ (*300,*310,GPTT,ID,1,0,FLAG)
      IF (ID) 170,190,180
  180 CALL READ (*300,*310,GPTT,TI,NWORDS,0,FLAG)
      GO TO 170
C
C     READ ELTYPE AND COUNT
C
  190 CALL READ (*300,*200,GPTT,TI,2,0,FLAG)
      OLDEL  = TI(1)
      NWORDS = TI(2)
      ENDID = .FALSE.
      GO TO 40
C     END OF RECORD HIT
C
  200 EORFLG = .TRUE.
      GO TO 80
C
  300 CALL MESAGE (-2,GPTT,NAME)
  310 CALL MESAGE (-3,GPTT,NAME)
      RETURN
      END

      SUBROUTINE PROCES (X)
C
      INTEGER          AXES,AXIS,GP,PRJECT
      REAL             X(3,1),XMIN(3),XMAX(3),MIN,MAX
      DOUBLE PRECISION SUM,V(3)
      COMMON /CONDAS/  CONSTS(5)
      COMMON /BLANK /  SKPCOM(5),NGPSET
      COMMON /XXPARM/  PBUFSZ,PLOTER(5),PENPAP(30),SCALE(5),AXES(6),
     1                 ALPHA,BETA,GAMMA,BETA13,BETA2,VIEW(4),
     2                 VANPUT(8),PRJECT
      COMMON /RSTXXX/  CSTM(3,3),MIN(3),MAX(3),D(3),AVER(3),
     1                 AXIS(3),SIGN(3)
      COMMON /DRWAXS/  G(3,3)
      EQUIVALENCE      (CONSTS(3),RAD)
C
C     INITIALIZATION.
C
      DO 10 I = 1,3
      AXIS(I) = IABS(AXES(I))
      SIGN(I) = 1.
      IF (AXES(I) .LT. 0) SIGN(I) = -1.
      MIN(I)  = +1.E+20
      MAX(I)  = -1.E+20
      IF (PRJECT  .NE. 3) GO TO 10
      XMIN(I) = +1.E+20
      XMAX(I) = -1.E+20
   10 CONTINUE
C
C     CALCULATE THE CO-ORDINATE SYSTEM ROTATION MATRIX.
C
      IF (BETA .GT. -1.E+10) GO TO 20
      IF (PRJECT .NE. 2) BETA = BETA13
      IF (PRJECT .EQ. 2) BETA = BETA2
   20 SINA = SIN(ALPHA/RAD)
      SINB = SIN(BETA /RAD)
      SING = SIN(GAMMA/RAD)
      COSA = COS(ALPHA/RAD)
      COSB = COS(BETA /RAD)
      COSG = COS(GAMMA/RAD)
C
      CSTM(1,1) = COSB*COSG
      CSTM(2,1) = COSA*SING + SINA*SINB*COSG
      CSTM(3,1) = SINA*SING - COSA*SINB*COSG
      CSTM(1,2) =-COSB*SING
      CSTM(2,2) = COSA*COSG - SINA*SINB*SING
      CSTM(3,2) = SINA*COSG + COSA*SINB*SING
      CSTM(1,3) = SINB
      CSTM(2,3) =-SINA*COSB
      CSTM(3,3) = COSA*COSB
C
C     SWITCH AXES + ROTATE THE GRID POINT CO-ORDINATES.
C
      DO 60 GP = 1,NGPSET
      DO 30  I = 1,3
      J    = AXIS(I)
      V(I) = SIGN(I)*X(J,GP)
      IF (PRJECT .NE. 3) GO TO 30
      VAL  = V(I)
      XMIN(I) = AMIN1(XMIN(I),VAL)
      XMAX(I) = AMAX1(XMAX(I),VAL)
   30 CONTINUE
      DO 50 J = 1,3
      SUM = 0.D0
      DO 40 I = 1,3
      SUM = SUM + CSTM(J,I)*V(I)
   40 CONTINUE
      VAL = SUM
      X(J,GP) = VAL
      MIN(J)  = AMIN1(MIN(J),VAL)
      MAX(J)  = AMAX1(MAX(J),VAL)
   50 CONTINUE
   60 CONTINUE
C
C     CALCULATE THE MINIMA-MAXIMA DIFFERENCES + AVERAGES.
C
      DO 70 I = 1,3
      IF (PRJECT .NE. 3) D(I) =  MAX(I) -  MIN(I)
      IF (PRJECT .EQ. 3) D(I) = XMAX(I) - XMIN(I)
      AVER(I) = (MAX(I)+MIN(I))/2.
   70 CONTINUE
C
C     CREATE A X-Y-Z UNIT COORDINATES IN /DRWAXS/ FOR VIEW PLOTTING
C
      DO 90 I = 1,9
   90 G(I,1) = 0.0
      G(1,1) = 1.0
      G(2,2) = 1.0
      G(3,3) = 1.0
C
      DO 130 GP = 1,3
      DO 100  I = 1,3
      J    = AXIS(I)
      V(I) = SIGN(I)*G(J,GP)
  100 CONTINUE
      DO 120 J = 1,3
      SUM = 0.D0
      DO 110 I = 1,3
      SUM = SUM + CSTM(J,I)*V(I)
  110 CONTINUE
  120 G(J,GP) = SUM
  130 CONTINUE
C
      RETURN
      END

      SUBROUTINE GKAM
C
C     ROUTINE TO ASSEMBLE MODAL MATRICES
C
C     INPUTS = 9
C
C     USETD,PHIA,MI,LAMA,SDT,M2DD,B2DD,K2DD,CASECC
C
C     OUTPUTS = 4
C
C     MHH,BHH,KHH,PHIDH
C
C     SCRATCHES = 4
C
      INTEGER         USETD,B2DD,SDT,PHIA,PHIDH,BHH,SCR1,SCR2,SCR3,
     1                PHIDH1,SYSBUF,CASECC,NAME(2)
      REAL            LFREQ
      DIMENSION       MCB(7),ICORE(2),BLOCK(11),IBLOCK(11)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG / UFM,UWM,UIM,SFM
      COMMON /BLANK / NOUE,NLMODE,LFREQ,HFREQ,NOM2DD,NOB2DD,NOK2DD,
     1                NONCUP,NMODE,KDAMP
      COMMON /PACKX / IT1,IT2,II,JJ,INCR
      COMMON /UNPAKX/ IT3,II1,JJ1,INCR1
      COMMON /CONDAS/ PI,TWOPHI,RADEG,DEGRA,S4PISQ
      COMMON /ZZZZZZ/ CORE(1)
      COMMON /SYSTEM/ SYSBUF,NOUT
C
      EQUIVALENCE     (CORE(1),ICORE(1)),(IBLOCK(1),BLOCK(1))
C
      DATA    NAME  / 4HGKAM,4H    /
      DATA    IBLOCK(1),IBLOCK(7),BLOCK(2),BLOCK(8)   / 1,1,1.0,1.0 /
      DATA    USETD , PHIA,MI, LAMA,SDT,M2DD,B2DD,K2DD/
     1        101   , 102, 103,104, 105,106, 107, 108 /
      DATA    MHH   , BHH,KHH,PHIDH/
     1        201   , 202,203,204  /
      DATA    SCR1  , SCR2,SCR3,PHIDH1,CASECC /
     1        301   , 302 ,303 ,304   ,109    /
C
C
C     PICK UP AND STORE SELECTED MODES, SAVING EIGENVECTORS
C
      LC1  = KORSZ(CORE)
      NZ   = LC1 - SYSBUF
      ICRQ = 2*SYSBUF - NZ
      IF (ICRQ .GT. 0) GO TO 220
C
C     FIND SELECTED SDT INTO CASECC
C
      CALL GOPEN (CASECC,CORE(NZ+1),0)
      CALL FREAD (CASECC,ICORE,166,1)
      CALL CLOSE (CASECC,1)
      I149  = 149
      NOSDT = ICORE(I149)
C
C     OPEN  LAMA, PHIA, AND PHI0H
C
      CALL GOPEN (LAMA,CORE(NZ+1),0)
      CALL SKPREC (LAMA,1)
      NZ = NZ - SYSBUF
      CALL GOPEN (PHIA,CORE(NZ+1),0)
      ICORE(1) = PHIA
      CALL RDTRL (ICORE)
      NVECT = ICORE(2)
      NZ = NZ - SYSBUF
      IF (NOUE .LT. 0) PHIDH1 = PHIDH
      CALL GOPEN (PHIDH1,CORE(NZ+1),1)
      MCB(1) = PHIA
      CALL RDTRL (MCB)
      MCB(1)= PHIDH1
      IT1   = MCB(5)
      IT2   = IT1
      IT3   = IT1
      INCR  = 1
      INCR1 = 1
      II    = 1
      II1   = 1
      JJ    = MCB(3)
      JJ1   = JJ
      MCB(2)= 0
      MCB(6)= 0
      MCB(7)= 0
      ISW   = 1
      MODES = 1
      DO 10 I = 1,NVECT
      CALL READ (*190,*40,LAMA,CORE(NZ-6),7,0,IFLAG)
C
C     PICK UP FREQUENCY
C
      F = CORE(NZ-2)
      IF (NLMODE .EQ. 0) GO TO 50
C
C     ACCEPT LAMA
C
   20 CORE(MODES) = F*TWOPHI
      MODES = MODES + 1
      CALL UNPACK (*210,PHIA,CORE(MODES))
      GO TO 30
C
C     FREQUENCY RANGE SPECIFICATION
C
   50 IF (F .GT. HFREQ) GO TO 40
      IF (F .GE. LFREQ) GO TO 20
      CALL SKPREC (PHIA,1)
      ISW = ISW + 1
      GO TO 10
   30 CALL PACK (CORE(MODES),PHIDH1,MCB)
      IF (NLMODE .EQ. 0) GO TO 10
      IF (MODES .GT. NLMODE) GO TO 40
   10 CONTINUE
C
C     DONE
C
   40 CALL CLOSE (LAMA,1)
      CALL CLOSE (PHIA,1)
      CALL CLOSE (PHIDH1,1)
      CALL WRTTRL (MCB)
      GO TO 60
C
C     BUILD PHIDH
C
   60 LHSET = MODES - 1
      NMODE = ISW
      IF (LHSET .LE. 0) GO TO 230
      IF (NOUE  .LT. 0) GO TO 70
      CALL GKAM1B (USETD,SCR1,SCR2,PHIDH,PHIDH1,MODES,CORE,LHSET,NOUE,
     1             SCR3)
C
C     FORM H MATRICES
C
   70 MODES = MODES - 1
C
C     SAVE MODES ON SCRATCH3 IN CASE DMI WIPES THEM OUT
C
      NZ = LC1 - SYSBUF
      CALL OPEN  (*250,SCR3,CORE(NZ+1),1)
      CALL WRITE (SCR3,CORE(1),MODES,1)
      CALL CLOSE (SCR3,1)
      NONCUP = 1
C
C     FORM  MHH
C
      CALL  GKAM1A (MI,PHIDH,SDT,SCR1,SCR2,1,MHH,NO M2DD,CORE(1),MODES,
     1              NOSDT,LHSET,M2DD,ISW,SCR3)
      IF (NOM2DD .LT. 0) GO TO 80
      CALL SSG2C (SCR1,SCR2,MHH,1,IBLOCK(1))
   80 CONTINUE
C
C     FORM  BHH
C
      IF (NOSDT.EQ.0 .AND. NOB2DD.LT.0) GO TO 90
      CALL GKAM1A (MI,PHIDH,SDT,SCR1,SCR2,2,BHH,NOB2DD,CORE(1),MODES,
     1             NOSDT,LHSET,B2DD,ISW,SCR3)
      IF (NOB2DD .LT. 0) GO TO 90
      CALL SSG2C (SCR1,SCR2,BHH,1,IBLOCK(1))
   90 CONTINUE
C
C     FORM  KHH
C
      CALL GKAM1A (MI,PHIDH,SDT,SCR1,SCR2,3,KHH,NOK2DD,CORE(1),MODES,
     1             NOSDT,LHSET,K2DD,ISW,SCR3)
      IF (NOK2DD .LT. 0) GO TO 100
      CALL SSG2C (SCR1,SCR2,KHH,1,IBLOCK(1))
  100 CONTINUE
      IF (NOB2DD.LT.0 .AND. NOM2DD.LT.0 .AND. NOK2DD.LT.0) NONCUP = -1
      RETURN
C
C     ERROR MESAGES
C
  120 IP1 = -1
  130 CALL MESAGE (IP1,IP2,NAME)
  190 IP2 = LAMA
      IP1 = -3
      GO TO 130
  210 WRITE  (NOUT,215) SFM
  215 FORMAT (A25,' 2204, UNPACK FOUND NULL COLUMN IN PHIA FILE IN ',
     1       'GKAM MODULE.')
      IP1 = -37
      GO TO 130
  220 IP1 = -8
      FILE = ICRQ
      GO TO 130
C
C     NO MODES SELECTED
C
  230 IP1 = -47
      GO TO 130
  250 IP2 = SCR3
      GO TO 120
      END

        SUBROUTINE DSIPK1 ( BLOCK, ITYPOT )
      INCLUDE 'DSIOF.COM'
        INTEGER BLOCK( 15 )
        IRETRN = 0
        BLOCK( 1 ) = NAME
        BLOCK( 8 ) = -1
        IF ( ITYPOT .GT. 0 ) GO TO 10
        IFLAG = IABS( ITYPOT ) + 64
        GO TO 20
10      IFLAG = ITYPOT
20      BLOCK( 13) = IFLAG
        CALL GETSTR( *777, BLOCK )
        BLOCK( 7 ) = 0
        IF ( IFLAG .GE. 1 .AND. IFLAG .LE. 4 ) GO TO 30
        IF ( IFLAG .GE. 65 .AND. IFLAG .LE. 68 ) GO TO 30
        CALL DSMSG1( BLOCK )
        CALL DSMSG( 118 )
30      CONTINUE
        GO TO 700
777     IRETRN = 1
700     RETURN
        END

      SUBROUTINE SOLVER (LOWER,X,B,IN,OUT,EPS,IFL,SCR)
C
C    SOLVER PERFORMS THREE OPERATIONS--
C    1. SOLVES FOR B BY FORWARD-BACKWARD SUBSTITUTION
C    2. COMPUTES OUT = IN + B(T)*X
C    3. IF REQUESTED, COMPUTES EPSILON = NORM(OUT)/NORM(IN)
C
      INTEGER         X     ,OUT   ,FILEL ,FILEU ,FILEB ,FILEX ,SCR    ,
     1                PREC  ,SIGN  ,FILEE ,FILEF ,FILEG ,FILEH ,T      ,
     2                SIGNC ,SIGNAB,PRECX ,EOL   ,EOR   ,SYSBUF,SCRTCH ,
     3                B     ,SCR1  ,NAME(2)
      DOUBLE PRECISION       AD    ,NUM   ,DENOM
      DIMENSION       FILEL(7)     ,FILEU(7)     ,FILEB(7)     ,
     1                FILEX(7)     ,FILEE(7)     ,FILEF(7)     ,
     2                FILEG(7)     ,FILEH(7)
      CHARACTER       UFM*23,UWM*25
      COMMON /XMSSG / UFM   ,UWM
      COMMON /ZZZZZZ/ Z(1)
      COMMON /FBSX  / FILEL ,FILEU ,FILEB ,FILEX ,NZ    ,PREC  ,SIGN   ,
     1                SCR1
      COMMON /MPYADX/ FILEE ,FILEF ,FILEG ,FILEH ,NZZ   ,T     ,SIGNAB ,
     1                SIGNC ,PRECX ,SCRTCH
      COMMON /ZNTPKX/ AD(2) ,I     ,EOL   ,EOR
      COMMON /SYSTEM/ KSYSTM(65)
      EQUIVALENCE     (KSYSTM(1),SYSBUF)  ,(KSYSTM(55),IPREC)  ,
     1                (KSYSTM(2),IOUTPT)
C
C     INITIALIZE MATRIX CONTROL BLOCKS FOR FORWARD-BACKWARD SOLUTION
C
      NZ = KORSZ(Z)
      FILEL(1) = LOWER
      CALL RDTRL (FILEL)
      FILEB(1) = B
      CALL RDTRL (FILEB)
      CALL MAKMCB (FILEX,X,FILEB(3),FILEB(4),IPREC)
      PREC = IPREC
      SIGN = -1
C
C     SOLVE A*X = -B FOR X WHERE A HAS BEEN FACTORED
C
      SCR1 = SCR
      CALL FBS (Z,Z)
      CALL WRTTRL (FILEX)
C
C     INITIALIZE MATRIX CONTROL BLOCKS FOR MPYAD OPERATION
C
      DO 50 K = 1,7
      FILEE(K) = FILEB(K)
   50 FILEF(K) = FILEX(K)
      FILEG(1) = IN
      CALL RDTRL (FILEG)
      CALL MAKMCB (FILEH,OUT,FILEG(3),FILEG(4),IPREC)
      NZZ = NZ
      T   = 1
      SIGNAB = 1
      SIGNC  = 1
      PRECX  = IPREC
      SCRTCH = SCR
C
C     COMPUTE OUT = IN + B(T)*X
C
      CALL MPYAD  (Z,Z,Z)
      CALL WRTTRL (FILEH)
C
C     IF REQUESTED,COMPUTE EPS = NORM(OUT) / NORM(IN)
C
      IF (IFL .EQ. 0) RETURN
      N1 = NZ - SYSBUF
      N2 = N1 - SYSBUF
      CALL GOPEN (OUT,Z(N1+1),0)
      CALL GOPEN ( IN,Z(N2+1),0)
      NUM   = 0.0D0
      DENOM = 0.0D0
      NCOL  = FILEG(2)
      DO 130 K = 1,NCOL
      CALL INTPK (*110,OUT,0,2,0)
  100 CALL ZNTPKI
      NUM = NUM + DABS(AD(1))*DABS(AD(1))
      IF (EOL .EQ. 0) GO TO 100
  110 CALL INTPK (*130,IN,0,2,0)
  120 CALL ZNTPKI
      DENOM = DENOM + DABS(AD(1))*DABS(AD(1))
      IF (EOL .EQ. 0) GO TO 120
  130 CONTINUE
      IF (DENOM .EQ. 0.0D0) GO TO 160
      EPS = DSQRT(NUM/DENOM)
      GO TO 180
  160 CALL FNAME (IN,NAME)
      WRITE  (IOUTPT,170) UWM,NAME
  170 FORMAT (A25,' 2401, ',2A4,' MATRIX IS NULL.  AN ARBITRARY VALUE ',
     1       'OF 1.0 IS THEREFORE ASSIGNED TO', /5X,
     2       'THE RIGID BODY ERROR RATIO (EPSILON SUB E).')
      EPS = 1.0
  180 CALL CLOSE (IN, 1)
      CALL CLOSE (OUT,1)
      RETURN
      END

        SUBROUTINE DSSKFB( NN )
      INCLUDE 'DSIOF.COM'
      INCLUDE 'XNSTRN.COM'
        N = NN
10      IF ( N .EQ. 0 ) GO TO 7000
20      CALL DSBRC1
        ID = IAND( IBASE( INDCLR ), MASKQ1 )
        IF ( ID .EQ. IDSEF ) GO TO 30
        IF ( NBLOCK .NE. 1 ) GO TO 20
        IF ( ( INDCLR-INDBAS ) .LE. 5 ) GO TO 7000
        GO TO 20
30      N = N + 1
        GO TO 10
7000    RETURN
        END

      SUBROUTINE OFP1C (LINE)
C
C     THIS SUBROUTINE WAS FORMED ONLY TO REDUCE THE SIZE OF OFP1 FOR
C     COMPILATION PURPOSES.  IT IS CALLED ONLY BY OFP1.
C     THIS ROUTINE WAS PART OF OFP1B BEFORE.
C
      COMMON /SYSTEM/ IBUF,L
CZZ   COMMON /ZZOFPX/ L123(1)
      COMMON /ZZZZZZ/ L123(20000)
C
C
CWKBR NCL93012 3/94      IF (LINE .GT. 467) GO TO 100             
CWKBR SPR94001 7/94      IF (LINE .GT. 470) GO TO 100
      IF (LINE .GT. 474) GO TO 100       
      LOCAL = LINE - 380
      GO TO (381,382,383,384,385,386,387,388,389,390,
     1       391,392,393,394,395,396,397,398,399,400,
     2       401,402,403,404,405,406,407,408,409,410,
     3       411,412,413,414,415,416,417,418,419,420,
     4       421,422,423,424,425,426,427,428,429,430,
     5       431,432,433,434,435,436,437,438,439,440,
     6       441,442,443,444,445,446,447,448,449,450,
     7       451,452,453,454,455,456,457,458,459,460,
CWKBR NCL93012 3/94 8       461,462,463,464,465,466,467), LOCAL     
CWKBD SPR94001 7/94 8       461,462,463,464,465,466,467,100,469,470), LOCAL 
CWKBNB SPR94001 7/94
     8       461,462,463,464,465,466,467,100,469,470,
     9       471,472,473,474), LOCAL
CWKBNE SPR94001 7/94
C
  100 WRITE  (L,110) LINE
  110 FORMAT ('0*** OFP ERROR/OFP1C,  LINE=',I9)
      CALL MESAGE (-61,0,0)
C
  381 WRITE (L,881)
      GO TO 1000
  382 WRITE (L,882)
      GO TO 1000
  383 WRITE (L,883)
      GO TO 1000
  384 WRITE (L,884)
      GO TO 1000
  385 WRITE (L,885)
      GO TO 1000
  386 WRITE (L,886)
      GO TO 1000
  387 WRITE (L,887)
      GO TO 1000
  388 WRITE (L,888)
      GO TO 1000
  389 WRITE (L,889)
      GO TO 1000
  390 WRITE (L,890)
      GO TO 1000
  391 WRITE (L,891)
      GO TO 1000
  392 WRITE (L,892)
      GO TO 1000
  393 WRITE (L,893)
      GO TO 1000
  394 WRITE (L,894)
      GO TO 1000
  395 WRITE (L,895)
      GO TO 1000
  396 WRITE (L,896)
      GO TO 1000
  397 WRITE (L,897)
      GO TO 1000
  398 WRITE (L,898)
      GO TO 1000
  399 WRITE (L,899)
      GO TO 1000
  400 WRITE (L,900)
      GO TO 1000
  401 WRITE (L,901)
      GO TO 1000
  402 WRITE (L,902)
      GO TO 1000
  403 WRITE (L,903)
      GO TO 1000
  404 WRITE (L,904)
      GO TO 1000
  405 WRITE (L,905)
      GO TO 1000
  406 WRITE (L,906)
      GO TO 1000
  407 WRITE (L,907)
      GO TO 1000
  408 WRITE (L,908)
      GO TO 1000
  409 WRITE (L,909)
      GO TO 1000
  410 WRITE (L,910)
      GO TO 1000
  411 WRITE (L,911)
      GO TO 1000
  412 WRITE (L,912)
      GO TO 1000
  413 WRITE (L,913)
      GO TO 1000
  414 WRITE (L,914)
      GO TO 1000
  415 WRITE (L,915)
      GO TO 1000
  416 WRITE (L,916)
      GO TO 1000
  417 WRITE (L,917)
      GO TO 1000
  418 WRITE (L,918)
      GO TO 1000
  419 WRITE (L,919)
      GO TO 1000
  420 WRITE (L,920)
      GO TO 1000
  421 WRITE (L,921)
      GO TO 1000
  422 WRITE (L,922)
      GO TO 1000
  423 WRITE (L,923)
      GO TO 1000
  424 WRITE (L,924)
      GO TO 1000
  425 WRITE (L,925)
      GO TO 1000
  426 WRITE (L,926)
      GO TO 1000
  427 WRITE (L,927)
      GO TO 1000
  428 WRITE (L,928)
      GO TO 1000
  429 WRITE (L,929)
      GO TO 1000
  430 WRITE (L,930)
      GO TO 1000
  431 WRITE (L,931)
      GO TO 1000
  432 WRITE (L,932)
      GO TO 1000
  433 WRITE (L,933)
      GO TO 1000
  434 WRITE (L,934)
      GO TO 1000
  435 WRITE (L,935)
      GO TO 1000
  436 WRITE (L,936)
      GO TO 1000
  437 WRITE (L,937)
      GO TO 1000
  438 WRITE (L,938)
      GO TO 1000
  439 WRITE (L,939)
      GO TO 1000
  440 WRITE (L,940)
      GO TO 1000
  441 WRITE (L,941)
      GO TO 1000
  442 WRITE (L,942)
      GO TO 1000
  443 WRITE (L,943)
      GO TO 1000
  444 WRITE (L,944)
      GO TO 1000
  445 WRITE (L,945)
      GO TO 1000
  446 WRITE (L,946)
      GO TO 1000
  447 WRITE (L,947)
      GO TO 1000
  448 WRITE (L,948)
      GO TO 1000
  449 WRITE (L,949)
      GO TO 1000
  450 WRITE (L,950)
      GO TO 1000
  451 WRITE (L,951)
      GO TO 1000
  452 WRITE (L,952)
      GO TO 1000
  453 WRITE (L,953)
      GO TO 1000
  454 WRITE (L,954)
      GO TO 1000
  455 WRITE (L,955)
      GO TO 1000
  456 WRITE (L,956)
      GO TO 1000
  457 WRITE (L,957)
      GO TO 1000
  458 WRITE (L,958)
      GO TO 1000
  459 WRITE (L,959)
      GO TO 1000
  460 WRITE (L,960)
      GO TO 1000
  461 WRITE (L,961)
      GO TO 1000
  462 WRITE (L,962)
      GO TO 1000
  463 WRITE (L,963)
      GO TO 1000
  464 WRITE (L,964)
      GO TO 1000
  465 WRITE (L,965)
      GO TO 1000
  466 WRITE (L,966)
      GO TO 1000
  467 WRITE (L,967)
      GO TO 1000
CWKBNB NCL93012 3/94
469   WRITE ( L,969)
      GO TO 1000
470   WRITE ( L,970)
      GO TO 1000
CWKBNE NCL93012 3/94
CWKBNB SPR94001 7/94
471   WRITE (L,971)
      GO TO 1000
472   WRITE (L,972)
      GO TO 1000
473   WRITE (L,973)
      GO TO 1000
474   WRITE (L,974)
      GO TO 1000
CWKBNE SPR94001 7/94
 1000 RETURN
C
C     ******************************************************************
C
  881 FORMAT (4X,'S T R A I N S / C U R V A T U R E S   I N   G E N E ',
     1       'R A L   Q U A D R I L A T E R A L   E L E M E N T S',6X,
     2       '( C Q U A D 2 )')
  882 FORMAT (4X,'S T R A I N S / C U R V A T U R E S   I N   G E N E ',
     1       'R A L   Q U A D R I L A T E R A L   E L E M E N T S',6X,
     2       '( C Q U A D 1 )')
CWKBRB NCL93012 3/94  
C  883 FORMAT (2X,7HELEMENT,24X,37HSTRNS./CURVS. IN ELEMENT COORD SYSTEM,
C     1       6X,38HPRIN. STRNS./CURVS. (ZERO SHEAR/TWIST),7X,7HMAXIMUM)
CWKBRE NCL93012 3/94  
  883 FORMAT (2X,7HELEMENT,8X,'STRAIN',8X
     1,      37HSTRNS./CURVS. IN ELEMENT COORD SYSTEM
     2,      6X,38HPRIN. STRNS./CURVS. (ZERO SHEAR/TWIST),7X,7HMAXIMUM)
  884 FORMAT (4X,3HID.,6X,15HID./OUTPUT CODE,5X,8HNORMAL-X,7X,
     1       8HNORMAL-Y,6X,8HSHEAR-XY,7X,5HANGLE,9X,5HMAJOR,11X,5HMINOR,
     3       7X,11HSHEAR/TWIST)
  885 FORMAT (2X,7HELEMENT,4X,16HMAT. COORD. SYS.,4X,'STRNS./CURVS. ',
     1       ' IN MATERIAL COORD SYSTEM',5X,
     2       38HPRIN. STRNS./CURVS. (ZERO SHEAR/TWIST),7X,7HMAXIMUM)
  886 FORMAT (33X,'S T R A I N S / C U R V A T U R E S   A T   G R I D',
     1       '   P O I N T S')
  887 FORMAT (2X,7H POINT ,4X,16HMAT. COORD. SYS.,6X,
     1       33HSTRESSES INMATERIAL COORD SYSTEM , 12X,
     2       31HPRINCIPAL STRESSES (ZERO SHEAR), 12X,3HMAX)
  888 FORMAT (2X,7H POINT ,4X,16HMAT. COORD. SYS.,4X,
     1       38HSTRNS./CURVS. IN MATERIAL COORD SYSTEM, 5X,
     2       38HPRIN. STRNS./CURVS. (ZERO SHEAR/TWIST), 7X,7HMAXIMUM)
  889 FORMAT (50X,30H(IN ELEMENT COORDINATE SYSTEM),/)
  890 FORMAT (50X,31H(IN MATERIAL COORDINATE SYSTEM),/)
CWKBRB NCL93012 3/94  
C  891 FORMAT (4X,3HID.,26X,8HNORMAL-X, 7X,8HNORMAL-Y, 6X,8HSHEAR-XY,
C     1       7X,5HANGLE, 9X,5HMAJOR, 11X,5HMINOR, 7X,11HSHEAR/TWIST)
CWKBRE NCL93012 3/94
  891 FORMAT (4X,3HID.,9X,'CURVATURE',7X
     1,      8HNORMAL-X, 7X,8HNORMAL-Y, 6X,8HSHEAR-XY
     2,      7X,5HANGLE, 9X,5HMAJOR, 11X,5HMINOR, 7X,11HSHEAR/TWIST)
  892 FORMAT (4X,'C O M P L E X   F O R C E S   I N   A X I S - S Y M ',
     1       'M E T R I C   T R I A N G U L A R   R I N G   E L E M E ',
     2       'N T S   (CTRIAAX)',/)
  893 FORMAT (2X,'C O M P L E X   S T R E S S E S   I N   A X I S - S ',
     1       'Y M M E T R I C   T R I A N G U L A R   R I N G   E L E ',
     2       'M E N T S   (CTRIAAX)',/)
  894 FORMAT (3X,'C O M P L E X   F O R C E S   I N   A X I S - S Y M ',
     1       'M E T R I C   T R A P E Z O I D A L   R I N G   E L E M ',
     2       'E N T S   (CTRAPAX)',/)
  895 FORMAT (' C O M P L E X   S T R E S S E S   I N   A X I S - S Y ',
     1       ' M M E T R I C   T R A P E Z O I D A L   R I N G   E L E',
     2       ' M E N T S   (CTRAPAX)',/)
  896 FORMAT (3X,'SUBCASE   HARMONIC    POINT',12X,'RADIAL',12X,
     1       'CIRCUMFERENTIAL',12X,'AXIAL',16X,'CHARGE', /14X,
     2       'NUMBER     ANGLE',13X,'(R)',17X,'(THETA-T)',16X,'(Z)')
  897 FORMAT (' SUBCASE   HARMONIC    POINT    RADIAL      AXIAL     ',
     1       'CIRCUM.     SHEAR      SHEAR      SHEAR      F L U X   ',
     2       'D E N S I T I E S', /11X,'NUMBER      ANGLE     (R)',9X,
     3       '(Z)     (THETA-T)    (ZR)       (RT)       (ZT)',8X,
     4       '(R)        (Z)        (T)')
  898 FORMAT ('   FREQUENCY  HARMONIC    POINT            RADIAL',12X,
     1       'CIRCUMFERENTIAL',12X,'AXIAL',16X,'CHARGE', /14X,
     2       'NUMBER     ANGLE',13X,'(R)',17X,'(THETA-T)',16X,'(Z)')
  899 FORMAT (' FREQUENCY HARMONIC    POINT    RADIAL      AXIAL     ',
     1       'CIRCUM.     SHEAR      SHEAR      SHEAR      F L U X   ',
     2       'D E N S I T I E S', /10X,'NUMBER      ANGLE     (R)',9X,
     3       '(Z)     (THETA-T)    (ZR)       (RT)       (ZT)',8X,
     4       '(R)        (Z)        (T)')
  900 FORMAT (4X,'TIME     HARMONIC    POINT            RADIAL',12X,
     1       'CIRCUMFERENTIAL',12X,'AXIAL',16X,'CHARGE', /14X,
     2       'NUMBER     ANGLE',13X,'(R)',17X,'(THETA-T)',16X,'(Z)')
  901 FORMAT (2X,'TIME     HARMONIC    POINT    RADIAL      AXIAL     ',
     1       'CIRCUM.     SHEAR      SHEAR      SHEAR      F L U X   ',
     2       'D E N S I T I E S', /11X,'NUMBER      ANGLE     (R)',9X,
     3       '(Z)     (THETA-T)    (ZR)       (RT)       (ZT)',8X,
     4       '(R)        (Z)        (T)')
  902 FORMAT (5X,4HTIME,7X,8HHARMONIC,8X,2HT1,13X,2HT2,13X,2HT3,13X,
     1       2HR1,13X,2HR2,13X,2HR3)
  903 FORMAT (4X,7HSUBCASE,5X,8HHARMONIC,8X,2HT1,13X,2HT2,13X,2HT3,
     1       13X,2HR1,13X,2HR2,13X,2HR3)
  904 FORMAT (3X,9HFREQUENCY,4X,8HHARMONIC,8X,2HT1,13X,2HT2,13X,2HT3,
     1       13X,2HR1,13X,2HR2,13X,2HR3)
  905 FORMAT (19X,'F I N I T E   E L E M E N T   M A G N E T I C   F I',
     1       ' E L D   A N D   I N D U C T I O N',/)
  906 FORMAT (4X,'ELEMENT-ID   EL-TYPE         X-FIELD',10X,'Y-FIELD',
     1       10X,'Z-FIELD        X-INDUCTION      Y-INDUCTION',6X,
     2       'Z-INDUCTION')
  907 FORMAT (28X,'G R I D   P O I N T   S T R E S S E S   F O R   I S',
     1       ' 2 D 8   E L E M E N T S',/)
  908 FORMAT (2X,7HELEMENT,3X,5HNO.OF,4X,5HNO.OF,7X,4HGRID,3X,6HCOORD.)
  909 FORMAT (4X,3HID.,4X,9HGRID PTS.,1X,8HSTRESSES,3X,5HPOINT,2X,
     1       7HSYS ID.,5X,5HSIG-X,8X,5HSIG-Y,8X,6HTAU-XY)
  910 FORMAT (12X,5HNO.OF,4X,5HNO.OF,13X,6HCOORD.)
  911 FORMAT (4X,4HTIME,3X,9HGRID PTS.,1X,8HSTRESSES,2X,7HGRID PT,1X,
     1       7HSYS ID.,5X,5HSIG-X,8X,5HSIG-Y,8X,6HTAU-XY)
  912 FORMAT (20X,'C O M P L E X   G R I D   P O I N T   S T R E S S E',
     1       ' S   F O R   I S 2 D 8   E L E M E N T S',/)
  913 FORMAT (2X,7HELEMENT,3X,5HNO.OF,4X,5HNO.OF,13X,6HCOORD.,/4X,3HID.,
     1       4X,9HGRID PTS.,1X,8HSTRESSES,2X,7HGRID PT,1X,7HSYS ID.,11X,
     2       5HSIG-X,22X,5HSIG-Y,22X,6HTAU-XY)
  914 FORMAT (12X,5HNO.OF,4X,5HNO.OF,13X,6HCOORD., /1X,9HFREQUENCY,1X,
     1       9HGRID PTS.,1X,8HSTRESSES,2X,7HGRID PT,1X,7HSYS ID.,11X,
     2       5HSIG-X,22X,5HSIG-Y,22X,6HTAU-XY)
  915 FORMAT (12X,5HNO.OF,4X,5HNO.OF,13X,6HCOORD., /2X,7HSUBCASE,2X,
     1       9HGRID PTS.,1X,8HSTRESSES,2X,7HGRID PT,1X,7HSYS ID.,5X,
     2       5HSIG-X,8X,5HSIG-Y,8X,6HTAU-XY)
  916 FORMAT (26X,'F O R C E S    I N    C U R V E D    B E A M    E L',
     1       ' E M E N T S',8X,'( C E L B O W )',/)
  917 FORMAT (5X,7HELEMENT,11X,16H-BENDING MOMENT-,21X,7H-SHEAR-,18X,
     1       13H-AXIAL FORCE-,7X,8H-TORQUE-)
  918 FORMAT (7X,3HID.,7X,13HPLANE-1 END-A,2X,13HPLANE-2 END-A,5X,
     1       13HPLANE-1 END-A,2X,13HPLANE-2 END-A,13X,5HEND-A,13X,
     2       5HEND-A)
  919 FORMAT (25X,5HEND-B,10X,5HEND-B,13X,5HEND-B,28X,5HEND-B,13X,
     1       5HEND-B)
  920 FORMAT (26X,'S T R E S S E S    I N    C U R V E D    B E A M   ',
     1       ' E L E M E N T S',8X,'( C E L B O W )',/)
  921 FORMAT (23X,16H-BENDING MOMENT-,21X,7H-SHEAR-,18X,
     1       13H-AXIAL FORCE-,7X,8H-TORQUE-)
  922 FORMAT (4X,4HTIME,9X,13HPLANE-1 END-A,2X,13HPLANE-2 END-A,5X,
     1       13HPLANE-1 END-A,8X,7HPLANE-2,13X,5HEND-A,13X,5HEND-A,
     2       /25X,5HEND-B,10X,5HEND-B,13X,5HEND-B,28X,5HEND-B,13X,
     3       5HEND-B)
  923 FORMAT (6X,7HSUBCASE,4X,13HPLANE-1 END-A,2X,13HPLANE-2 END-A,5X,
     1       13HPLANE-1 END-A,2X,13HPLANE-2 END-A,13X,5HEND-A,13X,
     2       5HEND-A, /25X,5HEND-B,10X,5HEND-B,13X,5HEND-B,28X,5HEND-B,
     3       13X,5HEND-B)
  924 FORMAT (19X,'C O M P L E X   F O R C E S   I N   C U R V E D   ',
     1       'B E A M   E L E M E N T S   ( C E L B O W )',/)
  925 FORMAT (7X,9HFREQUENCY,21X,14HBENDING-MOMENT,19X,11HSHEAR-FORCE,
     1       22X,5HAXIAL,10X,6HTORQUE, /35X,7HPLANE 1,8X,7HPLANE 2,11X,
     2       7HPLANE 1,8X,7HPLANE 2,13X,5HFORCE)
  926 FORMAT (18X,'C O M P L E X   S T R E S S E S   I N   C U R V E D',
     1       '   B E A M   E L E M E N T S   ( C E L B O W )',/)
  927 FORMAT (7X,9HELEMENT  ,21X,14HBENDING-MOMENT,19X,11HSHEAR-FORCE,
     1       22X,5HAXIAL,10X,6HTORQUE, /35X,7HPLANE 1,8X,7HPLANE 2,11X,
     2       7HPLANE 1,8X,7HPLANE 2,13X,5HFORCE)
  928 FORMAT (23X,'F O R C E S   I N   F L U I D   H E X A H E D R A L',
     1       '   E L E M E N T S   ( C F H E X 2 )',/)
  929 FORMAT (23X,'F O R C E S   I N   F L U I D   H E X A H E D R A L',
     1       '   E L E M E N T S   ( C F H E X 1 )',/)
  930 FORMAT (19X,'F O R C E S   I N   F L U I D   T E T R A H E D R A',
     1       ' L   E L E M E N T S   ( C F T E T R A )',/)
  931 FORMAT (26X,'F O R C E S   I N   F L U I D   W E D G E   E L E M',
     1       ' E N T S    ( C F W E D G E )',/)
  932 FORMAT (24X,'P O W E R   C O N V E C T E D   B Y   F T U B E   ',
     1       'E L E M E N T S   ( C F T U B E )',/)
  933 FORMAT (47X,4HTIME,26X,5HPOWER)
  934 FORMAT (45X,10HELEMENT-ID ,22X,5HPOWER)
  935 FORMAT (2X,7HELEMENT,3X,16HMAT. COORD. SYS.,30X,
     1       42H- STRESSES IN MATERIAL COORDINATE SYSTEM -, /4X,
     2       3HID., 5X,16HID./OUTPUT CODED, 14X,8HNORMAL-X, 26X,
     3       8HNORAML-Y, 25X,8HSHEAR-XY )
  936 FORMAT (16X,16HMAT. COORD. SYS., 30X,
     1       42H- STRESSES IN MATERIAL COORDINATE SYSTEM -, /4X,
     2       9HFREQUENCY, 3X,15HID./OUTPUT CODE,
     3       14X,8HNORAML-X, 26X,8HNORMAL-Y, 25X,8HSHEAR-XY )
  937 FORMAT (50X, 29H(IN STRESS COORDINATE SYSTEM),/)
  938 FORMAT (2X,7HELEMENT,6X,5HFIBRE,15X,'STRESSES IN STRESS COORD. ',
     1       'SYSTEM',13X,31HPRINCIPAL STRESSES (ZERO SHEAR),12X,3HMAX)
  939 FORMAT (4X,3HID.,7X,8HDISTANCE,11X,8HNORMAL-X,7X,8HNORMAL-Y,6X,
     1       8HSHEAR-XY,7X,5HANGLE,9X,5HMAJOR,11X,5HMINOR,10X,5HSHEAR)
  940 FORMAT (20X,'F O R C E S   I N   G E N E R A L   Q U A D R I ',
     1       'L A T E R A L   E L E M E N T S     ( Q U A D 4 )',/)
  941 FORMAT (6X,'ELEMENT',12X,'- MEMBRANE  FORCES -',22X,'- BENDING',
     1       '   MOMENTS -',11X,'- TRANSVERSE SHEAR FORCES -')
  942 FORMAT (8X,'ID',10X,2HFX,12X,2HFY,12X,3HFXY,11X,2HMX,12X,2HMY,
     1       12X,3HMXY,11X,2HVX,12X,2HVY)
  943 FORMAT (19X,5HFIBRE,11X,32HSTRESSES IN STRESS COORD. SYSTEM,13X,
     1       31HPRINCIPAL STRESSES (ZERO SHEAR),10X,7HMAXIMUM, /7X,
     2       4HTIME,7X,8HDISTANCE,7X,8HNORMAL-X,7X,8HNORMAL-Y,6X,
     3       8HSHEAR-XY,7X,5HANGLE,9X,5HMAJOR,11X,5HMINOR,10X,5HSHEAR)
  944 FORMAT (19X, 5HFIBRE, 11X, 32HSTRESSES IN STRESS COORD. SYSTEM,
     1       13X, 31HPRINCIPAL STRESSES (ZERO SHEAR), 10X, 7HMAXIMUM,
     2       /5X, 7HSUBCASE, 6X, 8HDISTANCE, 7X, 8HNORMAL-X, 7X,
     3       8HNORMAL-Y, 6X, 8HSHEAR-XY, 7X, 5HANGLE, 9X, 5HMAJOR,
     4       11X, 5HMINOR, 10X, 5HSHEAR)
  945 FORMAT (6X,' TIME  ',18X,'- MEMBRANE  FORCES -',22X,'- BENDING',
     1       '   MOMENTS -',11X,'- TRANSVERSE SHEAR FORCES -')
  946 FORMAT (26X,2HFX,12X,2HFY,12X,3HFXY,11X,2HMX,12X,2HMY,12X,3HMXY,
     1       11X,2HVX,12X,2HVY)
  947 FORMAT (6X,'SUBCASE',18X,'- MEMBRANE  FORCES -',22X,'- BENDING',
     1       '   MOMENTS -',11X,'- TRANSVERSE SHEAR FORCES -')
  948 FORMAT (6X,'C O M P L E X   S T R E S S E S   I N   G E N E R A ',
     1       'L   Q U A D R I L I A T E R A L   E L E M E N T S   ',
     2       '( C Q U A D 4 )')
  949 FORMAT (9H  ELEMENT,7X,5HFIBRE,38X,'- STRESSES IN STRESS COORDI',
     1       'NATE SYSTEM -', /4X,3HID.,8X,8HDISTANCE,18X,8HNORMAL-X,
     2       26X,8HNORMAL-Y,25X,8HSHEAR-XY)
  950 FORMAT (20X,5HFIBRE,38X,'- STRESSES IN STRESS COORDINATE SYSTEM -'
     1,      /4X,9HFREQUENCY,6X,8HDISTANCE,18X,8HNORMAL-X,26X,
     2       8HNORMAL-Y,25X,8HSHEAR-XY)
  951 FORMAT (6X,7HELEMENT,15X,6HCENTER,22X,7HEDGE  1,14X,7HEDGE  2,14X,
     1       7HEDGE  3,14X,7HEDGE  4, /8X,3HID.,9X,'R ------- PHI ----',
     2       '-- Z',4X,4(8X,13HS ------- PHI))
  952 FORMAT (28X,6HCENTER,22X,7HEDGE  1,14X,7HEDGE  2,14X,7HEDGE  3,
     1       14X,7HEDGE 4, /7X,4HTIME,9X,22HR ------- PHI ------ Z,4X,
     2       4(8X,13HS ------- PHI))
  953 FORMAT (29X,6HCENTER,21X,7HEDGE  1,14X,7HEDGE  2, 14X,7HEDGE  3,
     1       14X,7HEDGE  4,/4X,9HFREQUENCY,7X,22HR ------- PHI ------ Z,
     2       4X,4(8X,13HS ------- PHI))
  954 FORMAT (9X,'C O M P L E X   S T R E S S E S   I N   T R I A N G ',
     1       'U L A R   M E M B R A N E   E L E M E N T S   ',
     2       '( C T R I M 6 )')
  955 FORMAT (11X,'C O M P L E X   F O R C E S   I N   T R I A N G U L',
     1     ' A R   M E M B R A N E   E L E M E N T S   ( C T R I M 6 )')
  956 FORMAT (9X,'C O M P L E X   S T R E S S E S   I N   T R I A N G ',
     1       'U L A R   B E N D I N G   E L E M E N T S   ',
     2       '( C T R P L T 1 )')
  957 FORMAT (11X,'C O M P L E X   F O R C E S   I N   T R I A N G U L',
     1     ' A R   B E N D I N G   E L E M E N T S   ( C T R P L T 1 )')
  958 FORMAT (12X,'C O M P L E X   S T R E S S E S   I N   T R I A N G',
     1       ' U L A R   S H E L L   E L E M E N T S   ( C T R S H L )')
  959 FORMAT (14X,'C O M P L E X   F O R C E S   I N   T R I A N G U L',
     1       ' A R   S H E L L   E L E M E N T S   ( C T R S H L )')
  960 FORMAT (9X,'C O M P L E X   F O R C E S   I N   G E N E R A L   ',
     1       'Q U A D R I L A T E R A L   E L E M E N T S   ',
     2       '( C Q U A D 4 )')
  961 FORMAT (3X,'FREQUENCY',14X,'- MEMBRANE  FORCES -',23X,'- BENDING',
     1       '   MOMENTS -',10X,'- TRANSVERSE SHEAR FORCES -',
     2       /22X,2HFX,12X,2HFY,11X,3HFXY,13X,2HMX,12X,2HMY,11X,3HMXY,
     3       13X,2HVX,12X,2HVY)
  962 FORMAT (16X,4HGRID,11X,35HSTRESSES IN BASIC COORDINATE SYSTEM,13X,
     1       12HDIR. COSINES, /3X,9HFREQUENCY,3X,5HPOINT,5X,8HNORMAL-X,
     2       9X,8HNORMAL-Y,9X,8HNORMAL-Z,9X,8HSHEAR-XY,9X,8HSHEAR-YZ,9X,
     3       8HSHEAR-ZX)
  963 FORMAT (22X,'F O R C E S   I N   G E N E R A L   T R I A N G ',
     1       'U L A R   E L E M E N T S     ( C T R I A 3 )',/)
  964 FORMAT (12X,'C O M P L E X   F O R C E S   I N   G E N E R A L  ',
     1       ' T R I A N G U L A R   E L E M E N T S   ( C T R I A 3 )')
  965 FORMAT (21X,'S T R E S S E S   I N   G E N E R A L   T R I A N G',
     1       ' U L A R   E L E M E N T S',6X,'( C T R I A 3 )')
  966 FORMAT (9X,'C O M P L E X   S T R E S S E S   I N   G E N E R A ',
     1       'L   T R I A N G U L A R   E L E M E N T S   ',
     2       '( C T R I A 3 )')
  967 FORMAT (107X,22HOCTAHEDRAL    PRESSURE, /6X,10H   SUBCASE,8X,
     1       8HSIGMA-XX,6X,8HSIGMA-YY,6X,8HSIGMA-ZZ,7X,6HTAU-YZ,8X,
     2       6HTAU-XZ,8X,6HTAU-XY,8X,5HTAU-0,10X,1HP)
CWKBNB NCL93012 3/94
  969 FORMAT ( 4X, 'S T R A I N S / C U R V A T U R E S   I N   G E N '
     1,'E R A L   Q U A D R I L A T E R A L   E L E M E N T S ',6X
     2,'( Q U A D 4 )' )
  970 FORMAT ( 4X, 'S T R A I N S / C U R V A T U R E S   I N   G E N '
     1,'E R A L   T R I A N G U L A R   E L E M E N T S ',6X
     2,'( T R I A 3 )' )
CWKBNE NCL93012 3/94
CWKBNB SPR94001 7/94
  971 FORMAT (' SUBCASE',5X,'STRESS',15X,'RADIAL',16X
     1,       'CIRCUMFERENTIAL',16X,'AXIAL',21X,'SHEAR')                    
  972 FORMAT (5X,'NO ',6X,'POINT',17X,'(X)',21X,'(THETA)',21X,'(Z)',23X,
     1       '(ZX)')
  973 FORMAT (' SUBCASE   CORNER',18X,'RADIAL',26X,'CIRCUMFERENTIAL',
     1       26X,'AXIAL')
  974 FORMAT ('     NO     POINT',20X,'(X)',31X,'(THETA)',31X,'(Z)')
CWKBNE SPR94001 7/94
      END   

      SUBROUTINE GP3D
C
C     GP3D CREATES THE ETT (ELEMENT TEMPERATURE TABLE)
C
C     THE GPTT AS PREPARED BY GP3B COMES TO THIS ROUTINE VIA SCRATCH
C     DATA SET 1.
C
C     DATA IN THE GPTT IS USED TOGETHER WITH DATA OBTAINED FROM TEMPP1,
C     TEMPP2, TEMPP3, AND TEMPRB CARDS WHICH RESIDE ON GEOM3.
C
      LOGICAL         ANYGPT   ,ANYET    ,LFLAG    ,ANY      ,HEAT
      INTEGER         GEOM3    ,EQEXIN   ,GEOM2    ,SLT      ,ETT      ,
     1                SCR1     ,SCR2     ,BUF1     ,BUF2     ,BUF      ,
     2                FILE     ,CARDID   ,CARDDT   ,STATUS   ,PLOAD2   ,
     3                TEMPD    ,TEMPP1   ,TEMPP2   ,TEMPP3   ,TEMPRB   ,
     4                RD       ,RDREW    ,WRT      ,WRTREW   ,REW      ,
     5                NOREW    ,Z        ,FLAG     ,TWOI     ,DEFALT   ,
     6                NAM(2)   ,RECORD   ,GPTREC   ,SETID    ,OUTPT    ,
     7                SYSBUF   ,OUTWDS   ,ECTWDS   ,ELEM     ,BUF3
      REAL            RZ(1)    ,RBUF(50) ,TGRID(32)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /BLANK / NOGRAV   ,NOLOAD   ,NOTEMP
      COMMON /SYSTEM/ KSYSTM(63)
      COMMON /NAMES / RD       ,RDREW    ,WRT      ,WRTREW   ,REW      ,
     1                NOREW
      COMMON /GP3COM/ GEOM3    ,EQEXIN   ,GEOM2    ,SLT      ,ETT      ,
     1                SCR1     ,SCR2     ,BUF1     ,BUF2     ,BUF(50)  ,
     2                CARDID(60),IDNO(30),CARDDT(60),MASK(60),STATUS(60)
     3,               NTYPES   ,IPLOAD   ,IGRAV    ,PLOAD2(2),LOAD(2)  ,
     4                NOPLD2   ,TEMP(2)  ,TEMPD(2) ,TEMPP1(2),TEMPP2(2),
     5                TEMPP3(2),TEMPRB(2),BUF3
      COMMON /GPTA1 / NELEM    ,LAST     ,INCR     ,ELEM(1)
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE     (RZ(1),Z(1)), (RBUF(1),BUF(1)), (DEFALT,DEFTMP),
     1                (KSYSTM(1),SYSBUF), (KSYSTM(2),OUTPT),
     2                (KSYSTM(56),IHEAT)
      DATA   NAM    / 4HGP3D,4H     /
C
C                 +---------------------+
C     OPEN CORE   I                     I  Z(ILIST) = Z(1)
C                 I  ET SET-LIST        I
C     DESIGN FOR  I  2 WDS/ENTRY        I
C                 I                     I  Z(NLIST)
C     GP3D        +---------------------+
C                 I                     I  Z(IGPTT)
C                 I  GPT SET-LIST       I
C                 I  3 WDS/ENTRY        I
C                 I                     I  Z(NGPTT)
C                 +---------------------+
C                 I                     I  Z(IGPT) *
C                 I  GPTT DATA          I           *
C                 I  FOR CURRENT SETID  I            *
C                 I  2 WDS/ENTRY        I             *
C                 I                     I  Z(NGPT)     *
C                 +---------------------+               *
C                 I                     I  Z(IET1)       *
C                 I  2-DIMEN EL-TEMP    I                * THIS SPACE IS
C                 I  FOR CURRENT SETID  I                * DYNAMIC FOR
C                 I  7 WDS/ENTRY        I                * EACH SET OF
C                 I                     I  Z(NET1)       * TEMPERATURE
C                 +---------------------+                * DATA.
C                 I                     I  Z(IET2)       *
C                 I  1-DIMEN EL-TEMP    I                *
C                 I  FOR CURRENT SETID  I               *
C                 I  15 WDS/ENTRY       I              *
C                 I                     I  Z(NET2)    *
C                 +---------------------+            *
C                 I/////////////////////I           *
C                 I/////////////////////I          *
C                 +---------------------+
C                 I                     I  Z(BUF1)
C                 I  BUFFER 2           I
C                 I                     I
C                 +---------------------+
C                 I                     I  Z(BUF2)
C                 I  BUFFER 1           I
C                 I                     I  Z(KORSZ)
C                 +---------------------+
C
C
C
C     OPEN GEOM3, AND SCR1. READ IN TEMPP1, TEMPP2, TEMPP3, TEMPRB CARDS
C     CONVERT AND WRITE THEM OUT ON SCR2.
C
      HEAT  = .FALSE.
      IF (IHEAT .EQ. 1) HEAT = .TRUE.
      LFLAG = .FALSE.
      J     = -1
      NWORDS= 8
      ILIST = 1
      NLIST = 0
      FILE  = GEOM3
      ANY   = .FALSE.
      CALL PRELOC (*820,Z(BUF1),GEOM3)
      FILE  = SCR2
      CALL OPEN (*820,SCR2,Z(BUF2),WRTREW)
C
C     PICK UP TEMPP1 CARDS
C
      FILE = GEOM3
      CALL LOCATE (*20,Z(BUF1),TEMPP1,FLAG)
      ANY  = .TRUE.
      ASSIGN 10 TO IRETRN
      BUF(7) = 0
      BUF(8) = 1
   10 CALL READ (*840,*20,GEOM3,BUF,6,0,FLAG)
      GO TO 170
C
C     PICK UP TEMPP2 CARDS
C
   20 CALL LOCATE (*40,Z(BUF1),TEMPP2,FLAG)
      ANY = .TRUE.
      ASSIGN 30 TO IRETRN
   30 CALL READ (*840,*40,GEOM3,BUF,8,0,FLAG)
      GO TO 170
C
C     PICK UP TEMPP3 CARDS (CONVERT THESE TO LOOK LIKE TEMPP1 CARDS)
C
   40 CALL LOCATE (*140,Z(BUF1),TEMPP3,FLAG)
      ANY = .TRUE.
      ASSIGN 50 TO IRETRN
   50 CALL READ (*840,*140,GEOM3,BUF,24,0,FLAG)
      N  = 25
      DO 60 I = 1,11
      N  = N - 2
      IF (RBUF(N).NE.0.0 .OR. RBUF(N+1).NE.0.0) GO TO 70
   60 CONTINUE
   70 N  = N/2
      T1 = RBUF(4)
      T2 = RBUF(2*N+2)
      IF (N .EQ. 1) GO TO 100
      H  = RBUF(2*N+1) - RBUF(3)
      SUM= 0.0
      N  = N-1
      DO 80 I = 1,N
      TWOI = 2*I
      FACTOR = RBUF(TWOI+3) - RBUF(TWOI+1)
      IF (FACTOR .LE. 0.0) GO TO 120
      SUM  = SUM + (RBUF(TWOI+2) + RBUF(TWOI+4))*FACTOR
   80 CONTINUE
      TBAR = SUM/(2.0*H)
      HOVER2 = H/2.0
      SUM  = 0.0
      DO 90 I = 1,N
      TWOI = 2*I
      SUM  = SUM + (RBUF(TWOI+3) - RBUF(TWOI+1)    )*(3.0*
     1             (RBUF(TWOI+1) - RBUF(3) - HOVER2)*
     2             (RBUF(TWOI+4) + RBUF(TWOI+2)    ) +
     3             (RBUF(TWOI+2) + 2.0*RBUF(TWOI+4))*
     4             (RBUF(TWOI+3) - RBUF(TWOI+1)   ))
   90 CONTINUE
      TPRIME = 2.0*SUM/H**3
      GO TO 110
C
  100 TBAR = RBUF(4)
      TPRIME = 0.0
C
  110 RBUF(3) = TBAR
      RBUF(4) = TPRIME
      RBUF(5) = T1
      RBUF(6) = T2
      BUF(7)  = 0
      BUF(8)  = 1
      GO TO 170
C
C     BAD DATA ON A TEMPP3 CARD
C
  120 WRITE  (OUTPT,130) UFM,BUF(1),BUF(2)
  130 FORMAT (A23,' 4010, TEMPP3 BULK DATA CARD WITH SET ID =',I8,
     1       ' AND ELEMENT ID =',I8, /27X,
     2       'DOES NOT HAVE ASCENDING VALUES SPECIFIED FOR Z.')
      LFLAG = .TRUE.
      GO TO 50
C
C     END OF 8 WORD CARDS.  WRITE EOR ON SCR2 AND DO TEMPRB CARDS NOW.
C
  140 CALL WRITE (SCR2,0,0,1)
      NWORDS = 16
      CALL LOCATE (*160,Z(BUF1),TEMPRB,FLAG)
      ANY = .TRUE.
      ASSIGN 150 TO IRETRN
  150 CALL READ (*840,*160,GEOM3,BUF,16,0,FLAG)
      GO TO 170
C
C     WRITE EOR ON SCR2. SCR2 THEN WILL HAVE 2 RECORDS (1 OR BOTH EMPTY)
C
  160 CALL WRITE (SCR2,0,0,1)
      CALL CLOSE (GEOM3,REW )
      CALL CLOSE (SCR2 ,REW )
      GO TO 230
C
C     INTERNAL SUBROUTINE TO BUILD SET LIST FROM TEMPERATURE CARD DATA
C     FIND SET-ID OR ADD IT TO LIST IN SORT, BUMP COUNT AND WRITE CARD.
C
  170 IF (J .EQ. -1) GO TO 210
      IF (BUF(1) .EQ. Z(J)) GO TO 180
      IF (BUF(1).GT.Z(J) .AND. J.EQ.NLIST-1) GO TO 210
C
C     LOOK FOR MATCHING SETID OR FIND WHERE NEW SETID BELONGS
C
      CALL BISLOC (*190,BUF(1),Z(ILIST),2,NLIST/2,J)
C
C     MATCH WAS FOUND  (ILIST ASSUMED TO BE EQUAL TO 1)
C
  180 Z(J+1) = Z(J+1) + NWORDS
      GO TO 220
C
C     ADD THIS NEW SETID INTO LIST
C
  190 IF (BUF(1) .GT. Z(J)) J = J + 2
C
C     PUSH Z(J) THRU Z(NLIST) DOWN TWO WORDS TO MAKE ROOM FOR NEW SETID
C
      I = NLIST + 2
      DO 200 K = J,NLIST
      Z(I) = Z(I-2)
      I = I - 1
  200 CONTINUE
      GO TO 211
C
C     ADD NEW SETID TO LIST
C
  210 J = J + 2
  211 Z(J)  = BUF(1)
      NLIST = NLIST + 2
      Z(J+1)= NWORDS
C
C     WRITE OUT THE DATA CARD ON THE SCRATCH FILE FOR LATER USE
C
  220 CALL WRITE (SCR2,BUF,NWORDS,0)
      GO TO IRETRN, (10,30,50,150)
C
C     READ IN GPTT HEADER RECORD FROM SCR1
C
  230 IGPTT = NLIST + 1
      NGPTT = IGPTT
      FILE  = SCR1
      IF (NOTEMP .NE. 1) GO TO 250
      CALL OPEN (*820,SCR1,Z(BUF1),RDREW)
      CALL READ (*840,*240,SCR1,Z(IGPTT),BUF2-IGPTT,1,FLAG)
      CALL MESAGE (-8,0,NAM)
  240 NGPTT = NLIST + FLAG
      IGPTT = IGPTT + 2
      NSETS = (NGPTT - IGPTT + 1)/3
C
C     DETERMINE NUMBER OF RECORDS OF EXTERNAL INDEX TEMP DATA
C     FOLLOWING HEADER RECORD.
C
      IRECS = 0
      IF (NSETS) 247,247,241
  241 DO 244 I = IGPTT,NGPTT,3
      IRECS = MAX0(Z(I+2),IRECS)
  244 CONTINUE
  247 CONTINUE
      CALL CLOSE (SCR1,NOREW)
C
C     OPEN ETT, PUT OUT HEADER RECORD WITH THE 3 WORD SET ENTRIES.
C
  250 IF (NOTEMP.NE.1 .AND. .NOT.ANY) GO TO 810
      NOTEMP = 1
      FILE   = ETT
      CALL OPEN (*820,ETT,Z(BUF2),WRTREW)
      CALL FNAME (ETT,BUF)
      CALL WRITE (ETT,BUF,2,0)
      LIST1 = ILIST
      LIST2 = IGPTT
      RECORD= 0
  260 IF (LIST1.GT.NLIST-1 .AND. LIST2.LE.NGPTT-2) GO TO 290
      IF (LIST1.LE.NLIST-1 .AND. LIST2.GT.NGPTT-2) GO TO 270
      IF (LIST1.GT.NLIST-1 .AND. LIST2.GT.NGPTT-2) GO TO 330
C
      IF (Z(LIST1) - Z(LIST2)) 270,280,290
C
C     SET-ID OF LIST1 IS .LT. SET-ID OF LIST2 OR LIST2 IS ALL USED.
C
  270 BUF(1) = Z(LIST1)
      BUF(2) = -1
      LIST1  = LIST1 + 2
      GO TO 300
C
C     SET-ID OF LIST1 IS .EQ. SET-ID OF LIST2.
C
  280 BUF(1) = Z(LIST2  )
      BUF(2) = Z(LIST2+1)
      LIST1  = LIST1 + 2
      LIST2  = LIST2 + 3
      GO TO 300
C
C     SET-ID OF LIST2 IS .LT. SET-ID OF LIST1 OR LIST1 IS ALL USED.
C
  290 BUF(1) = Z(LIST2  )
      BUF(2) = Z(LIST2+1)
      LIST2  = LIST2 + 3
      IF (Z(LIST2-1) .EQ. 0) GO TO 310
C
C     WRITE 3-WORD SET-ID ENTRY IN HEADER
C
  300 RECORD = RECORD + 1
      BUF(3) = RECORD
      GO TO 320
  310 BUF(3) = 0
  320 CALL WRITE (ETT,BUF,3,0)
      GO TO 260
C
C     HEADER RECORD IS COMPLETE.  WRITE EOR AND CLOSE WITH NOREWIND.
C
  330 CALL WRITE (ETT,0,0,1)
      CALL CLOSE (ETT,NOREW)
C
C     FOR EACH SET DEFINED IN THE EL-TEMP SET LIST AND OR THE GRID-TEMP
C     SET LIST PASS GEOM2 USING LOCATE FOR ALL THE ELEMENTS FOR
C     WHICH ETT TEMP DATA OUTPUT IS POSSIBLE.
C     IF ANY ELEMENTS CONCERNED ARE PRESENT THEN SELECT FROM THE TEMP
C     DATA AVAILABLE THAT WHICH IS APPLICABLE AND OUTPUT THE DATA ON THE
C     ETT IN THE FOLLOWING FORMAT.
C
C     CONTENTS OF 1 RECORD OF THE OUTPUT FILE ETT. EACH RECORD CONTAINS
C     DATA FOR 1 SET.
C
C         SET-ID
C         ELEMENT TYPE          * * * * * * * * * *
C         NUMBER OF TEMPERATURE DATA VALUES/EL-ID  *
C         EL-ID          *                          *
C         TEMP-VALUE      *                          *
C             .           * EL-ID                    *
C             .           * ENTRY                    *
C             .           *                          *  ELEMENT-TYPE
C         LAST-TEMP-VALUE*                           *     ENTRY
C               *             (1 OR MORE EL-ID       *
C               *              ENTRIES PER EL-TYPE   *   (1 OR MORE
C               *              ENTRY)                *    PER RECORD)
C         EL-ID          *                           *
C         TEMP-VALUE      *                          *
C             .           * EL-ID                    *
C             .           * ENTRY                    *
C             .           *                         *
C         LAST-TEMP-VALUE*                         *
C         0                     * * * * * * * * * *
C
C     IN THE ABOVE IF THE ELEMENT HAS NO SPECIAL DATA, A NEGATIVE
C     ELEMENT ID IS INSERTED FOLLOWED BY NO TEMPERATURE DATA.
C
C     NOW GATHER THE DATA AVAILABLE FOR A SET FROM SCR1 AND OR SCR2.
C
      GPTREC = 1
      LIST1  = ILIST
      LIST2  = IGPTT
  340 ANYGPT = .FALSE.
      ANYET  = .FALSE.
      IGPT   = 0
      NGPT   = 0
      IET1   = 0
      NET1   = 0
      IET2   = 0
      NET2   = 0
      IF (LIST1 .GT. NLIST-1) GO TO 350
      IF (LIST2 .LE. NGPTT-2) GO TO 360
      GO TO 370
  350 IF (LIST2 .LE. NGPTT-2) GO TO 390
      GO TO 770
C
  360 IF (Z(LIST1) - Z(LIST2)) 370,380,390
C
C     NEXT SET-ID HAS ONLY EL-TEMP DATA
C
  370 SETID  = Z(LIST1)
      DEFALT = -1
      ANYET  = .TRUE.
      NWORDS = Z(LIST1+1)
      LIST1  = LIST1 + 2
      GO TO 400
C
C     NEXT SET-ID HAS BOTH GRID-TEMP AND EL-TEMP DATA
C
  380 SETID  = Z(LIST2  )
      DEFALT = Z(LIST2+1)
      ANYET  = .TRUE.
      INREC  = Z(LIST2+2)
      IF (INREC .GT. 0) ANYGPT = .TRUE.
      NWORDS = Z(LIST1+1)
      LIST1  = LIST1 + 2
      LIST2  = LIST2 + 3
      GO TO 400
C
C     NEXT SET-ID HAS ONLY GRID-TEMP DATA
C
  390 SETID  = Z(LIST2  )
      DEFALT = Z(LIST2+1)
      INREC  = Z(LIST2+2)
      IF (INREC .GT. 0) ANYGPT = .TRUE.
      LIST2  = LIST2 + 3
      GO TO 400
C
C     AT THIS POINT READ IN ANY GRID-TEMP DATA AND/OR ANY EL-TEMP DATA.
C     SORT THE EL-TEMP DATA ON EL-ID. THE GRID-TEMP DATA IS SORTED ON
C     GRIDS
C
  400 IGPT = NGPTT + 1
      NGPT = IGPT
      IF (.NOT.ANYGPT) GO TO 460
      FILE = SCR1
      CALL OPEN (*820,SCR1,Z(BUF1),RD)
C
C     POSITION GPTT TO DESIRED GRID-POINT-TEMP SET AND READ IT IN.
C
      MOVE = INREC - GPTREC
      IF (MOVE) 410,440,420
  410 CALL REWIND (SCR1)
      MOVE = INREC
  420 DO 430 I = 1,MOVE
      CALL FWDREC (*840,SCR1)
  430 CONTINUE
  440 GPTREC = INREC + 1
      CALL READ (*840,*450,SCR1,Z(IGPT),BUF2-IGPT,1,FLAG)
      CALL MESAGE (-8,0,NAM)
  450 NGPT = IGPT + FLAG - 1
      CALL CLOSE (SCR1,NOREW)
C
C     READ IN EL-TEMP DATA PERTAINING TO THIS SET-ID
C
  460 IF (.NOT.ANYET) GO TO 520
      IF (NGPT+NWORDS .GE. BUF2) CALL MESAGE (-8,0,NAM)
      FILE = SCR2
      CALL OPEN (*820,SCR2,Z(BUF1),RDREW)
      IET1 = NGPT + 1
      NET1 = NGPT
  470 CALL READ (*840,*490,SCR2,BUF,8,0,FLAG)
      IF (BUF(1) .NE. SETID) GO TO 470
      DO 480 I = 2,8
      NET1 = NET1 + 1
  480 Z(NET1) = BUF(I)
      NWORDS  = NWORDS - 8
      IF (NWORDS .NE. 0) GO TO 470
      CALL FWDREC (*820,SCR2)
  490 IET2 = NET1 + 1
      NET2 = NET1
  500 CALL READ (*840,*520,SCR2,BUF,16,0,FLAG)
      IF (BUF(1) .NE. SETID) GO TO 500
      DO 510 I = 2,16
      NET2 = NET2 + 1
  510 Z(NET2) = BUF(I)
      NWORDS  = NWORDS - 16
      IF (NWORDS .NE. 0) GO TO 500
C
C     ALL DATA IS NOW IN CORE FOR THIS SET-ID
C
  520 CALL CLOSE (SCR2,REW)
      IF (.NOT.ANYET .AND. .NOT.ANYGPT) GO TO 340
C
C     SORT THE 7-WORD TEMP CARDS ON ID AND CHECK FOR DUPLICATE ID S
C     AMONG ALL THE ELEMENT TEMPERATURE DATA
C
      IF (IET1 .LT. NET1) CALL SORT (0,0, 7,1,Z(IET1),NET1-IET1+1)
      IF (IET2 .LT. NET2) CALL SORT (0,0,15,1,Z(IET2),NET2-IET2+1)
C
      LET1 = (NET1 - IET1 + 1)/7
      LET2 = (NET2 - IET2 + 1)/15
      LGPT = (NGPT - IGPT + 1)/2
      LFLAG = .FALSE.
      IF (LET1 .LE. 1) GO TO 560
      ID = Z(IET1)
      J  = IET1 + 7
      DO 550 I = J,NET1,7
      IF (ID .NE. Z(I)) GO TO 540
C
C     ERROR - TWO OR MORE ID-S EQUAL IN TEMPERATURE DATA WITHIN A SET.
C
      WRITE  (OUTPT,530) UFM,SETID,ID
  530 FORMAT (A23,' 4011, ELEMENT TEMPERATURE SET',I9,' CONTAINS ',
     1       'MULTIPLE TEMPERATURE DATA SPECIFIED FOR ELEMENT ID',I9)
      LFLAG = .TRUE.
  540 ID = Z(I)
  550 CONTINUE
  560 IF (LET2 .LE. 1) GO TO 590
      ID = Z(IET2)
      J  = IET2 + 15
      DO 580 I = J,NET2,15
      IF (ID .NE. Z(I)) GO TO 570
      WRITE (OUTPT,530) UFM,SETID,ID
      LFLAG = .TRUE.
  570 ID = Z(I)
  580 CONTINUE
C
C     OPEN GEOM2, PREPARE TO PASS GEOM2, AND OUTPUT A RECORD OF THE ETT.
C
  590 FILE = GEOM2
      CALL PRELOC (*820,Z(BUF1),GEOM2)
C
C     OPEN ETT TO PUT OUT DATA-RECORD FOR THIS SET AND WRITE SETID,
C
      FILE = ETT
      CALL OPEN (*820,ETT,Z(BUF2),WRT)
      CALL WRITE (ETT,SETID,1,0)
C
C     RUN THROUGH POSSIBLE TEMPERATURE DEPENDENT ELEMENTS ON GEOM2.
C
      FILE = GEOM2
  595 CALL ECTLOC (*760,FILE,BUF,I)
C
C     OK DATA FOR A CARD TYPE HAS BEEN FOUND.  WRITE EL-TYPE AND
C     DATA FOR A CARD TYPE FOUND.
C
      BUF(1) = ELEM(I+2)
      BUF(2) = ELEM(I+14) - 1
      IELTYP = BUF(1)
C
C     WRITE ELEMENT TYPE HEADER
C
      CALL WRITE (ETT,BUF,2,0)
      IF (ELEM(I+13) .EQ. 0) GO TO 740
      JTEMP  = ELEM(I+13)
      OUTWDS = ELEM(I+14)
      ECTWDS = ELEM(I+ 5)
      IGRID  = ELEM(I+12)
      NGRID  = IGRID + ELEM(I+9) - 1
      FGRIDS = 0.0
  600 CALL READ (*840,*740,GEOM2,BUF,ECTWDS,0,FLAG)
C
C     ON FIRST PASS COUNT NUMBER OF NON-ZERO GRIDS
C
      IF (FGRIDS) 605,601,605
  601 DO 603 J = IGRID,NGRID
      IF (BUF(J) .NE. 0) FGRIDS = FGRIDS + 1.0
  603 CONTINUE
  605 CONTINUE
C
C     SELECT DATA TO BE OUTPUT
C
      IF (.NOT.ANYET) GO TO 650
      GO TO (610,620,650,650), JTEMP
C
C     1 - DIMENSIONAL ELEMENT-TEMP DATA MAY BE AVAIL.
C
  610 IF (LET2 .LT. 1) GO TO 650
      CALL BISLOC (*650,BUF(1),Z(IET2),15,LET2,J)
      J = IET2 + J
C
C     AVERAGE T-BAR-A AND T-BAR-B IF THIS IS A ROD, CONROD, OR TUBE
C
      IF (IELTYP.NE.1 .AND. IELTYP.NE.3 .AND. IELTYP.NE.10) GO TO 630
      RBUF(2) = (RZ(J) + RZ(J+1))/2.0
      GO TO 730
C
C     2 - DIMENSIONAL ELEMENT-TEMP DATA MAY BE AVAIL.
C
  620 IF (LET1 .LT. 1) GO TO 650
      CALL BISLOC (*650,BUF(1),Z(IET1),7,LET1,J)
      J = IET1 + J
  630 DO 640 K = 2,OUTWDS
      BUF(K) = Z(J)
      J = J + 1
  640 CONTINUE
      GO TO 730
C
C     CHECK FOR GRID-POINT-TEMP-DATA
C
  650 IF (.NOT.ANYGPT) GO TO 700
C
C     GRID-POINT-TEMP-DATA IS AVAILABLE FOR SOME OR ALL GRID POINTS.
C
      ANY   = .FALSE.
      RTEMP = 0.0
      II    = 0
      DO 670 K = IGRID,NGRID
      II = II + 1
      IF (BUF(K)) 655,665,655
  655 CALL BISLOC (*660,BUF(K),Z(IGPT),2,LGPT,J)
      J  = IGPT + J
      RTEMP = RTEMP + RZ(J)
      IF (II .GT. 32) CALL MESAGE (-61,0,0)
      TGRID(II) = RZ(J)
      ANY = .TRUE.
      GO TO 670
  660 IF (DEFALT .EQ. -1) GO TO 710
      RTEMP = RTEMP + DEFTMP
      TGRID(II) = DEFTMP
      GO TO 670
C
C     UNDEFINED GRID-POINT
C
  665 TGRID(II) = 0
  670 CONTINUE
C
C     IF NOTHING BUT DEFAULT DATA THEN WRITE NOTHING SINCE THE
C     DEFAULT IS IN THE HEADER RECORD.
C
      IF (.NOT.ANY) GO TO 735
C
C     IF BAR ELEMENT PUT GRID TEMPS INTO BUFFER FOR T-BAR-A AND T-BAR-B
C
      IF (IELTYP .NE. 34) GO TO 675
      RBUF(2) = TGRID(1)
      RBUF(3) = TGRID(2)
      J = 4
      GO TO 676
C
  675 RBUF(2) = RTEMP/FGRIDS
      J = 3
      IF (JTEMP .EQ. 4) J = 2
C
  676 IF (JTEMP .LT. 3) GO TO 690
      DO 680 K = 1,II
      RBUF(J) = TGRID(K)
  680 J = J + 1
  690 IF (J .GT. OUTWDS) GO TO 730
      BUF(J) = 0
      J = J + 1
      GO TO 690
C
C     NO GRID-POINT-TEMP-DATA.  VERIFY THAT THERE IS A DEFAULT TEMP.
C
  700 IF (DEFALT .NE. -1) GO TO 735
C
C     ERROR NO TEMP DATA OR DEFALT OF ANY KIND FOR THIS ID.
C
  710 LFLAG = .TRUE.
      WRITE  (OUTPT,720) UFM,SETID,BUF(1)
  720 FORMAT (A23,' 4012, THERE IS NO ELEMENT, GRID POINT, OR DEFAULT',
     1       ' TEMPERATURE DATA FOR', /30X,'TEMPERATURE SET',I12,
     2       ', WITH RESPECT TO ELEMENT ID =',I8)
      GO TO 735
C
C     OUTPUT ELEMENT-TEMPERATURE DATA FOR 1 ELEMENT OF THIS TYPE IN SET
C
  730 CALL WRITE (ETT,BUF,OUTWDS,0)
      GO TO 600
C
C     OUTPUT A NEGATIVE ELEMENT ID SINCE THERE IS NO DATA AVAILABLE.
C
  735 ID = -BUF(1)
      CALL WRITE (ETT,ID,1,0)
      GO TO 600
C
C     END OF ELEMENTS FOR THIS EL-TYPE.  WRITE ZERO ON ETT
C
  740 CALL WRITE (ETT,0,1,0)
      GO TO 595
  760 CONTINUE
C
C     ETT-RECORD IS COMPLETE FOR THIS SET. WRITE EOR AND PROCESS NEXT
C     SET.
C
      CALL WRITE (ETT,0,0,1)
      CALL CLOSE (ETT,NOREW)
      GO TO 340
C
C     ETT IS COMPLETE
C
  770 IF (LFLAG) CALL MESAGE (-61,0,0)
C
C     WRITE TRAILER FOR ETT
C
      BUF(1) = ETT
      BUF(7) = 7
      DO 775 I = 2,6
  775 BUF(I) = 0
C
C     OPEN ETT AND APPEND GPTT SECTION OF TEMP DATA IN INTERNAL NOTATION
C
      FILE = ETT
      CALL OPEN (*820,ETT,Z(BUF2),WRT)
      IF (.NOT.ANYGPT .AND. .NOT.HEAT) GO TO 800
C
C     OPEN SCR1 AND SKIP THE TEMPERATURE DATA HAVING EXTERNAL INDICES
C
      FILE = SCR1
      CALL GOPEN (SCR1,Z(BUF1),RDREW)
      IF (IRECS) 790,790,780
  780 DO 785 I = 1,IRECS
      CALL FWDREC (*840,SCR1)
  785 CONTINUE
C
C     COPY BALANCE OF SCR1 TO ETT
C
  790 CALL READ  (*800,*795,SCR1,Z,BUF2-1,0,FLAG)
      CALL WRITE (ETT,Z,BUF2-1,0)
      GO TO 790
  795 CALL WRITE (ETT,Z,FLAG,1)
      GO TO 790
  800 CALL CLOSE (SCR1,REW)
      CALL CLOSE (ETT, REW)
      CALL WRTTRL (BUF)
C
C     THERE WAS NO GPTT DATA AND ALSO NO ETT DATA. THUS RETURN HAVING
C     CREATED NO ETT DATA SET.
C
  810 RETURN
C
C     ERROR CONDITIONS ON FILES
C
C
C     FILE NOT IN FIST OR PURGED
C
  820 J = -1
      GO TO 850
C
C     EOF HIT WHILE READING FILE
C
  840 J = -2
  850 CALL MESAGE (J,FILE,NAM)
      RETURN
      END

        SUBROUTINE DSSKRC
      INCLUDE 'DSIOF.COM'
      INCLUDE 'XNSTRN.COM'
10      ID = IAND( IBASE( INDCLR ), MASKQ1 )
        IF ( ID .EQ. IDSRH ) GO TO 40
        IF ( ID .EQ. IDSSB ) GO TO 40
        IF ( ID .EQ. IDSEF ) GO TO 30
        IF ( ID .EQ. IDSEB ) GO TO 20
        CALL DSMSG ( 103 )
20      CALL DSRDNB
        GO TO 10
30      INDCLR = INDCLR + 1
        INDCBP = INDCLR
        GO TO 7000
40      LEN  = IAND( IBASE( INDCLR ), MASKH2 )
        ICLR = INDCLR + LEN + 1
        ID   = IAND( IBASE( ICLR ), MASKQ1 )
        IF ( ID .EQ. IDSRT ) GO TO 50
        CALL DSMSG ( 104 )
50      IFLG = IAND( IBASE( ICLR ), MASKQ2 )
        IF ( IFLG .EQ. IDSC ) GO TO 60
        CALL DSRDNB
        GO TO 10
60      INDCLR = ICLR +  1
        INDCBP = INDCLR
7000    RETURN
        END

      SUBROUTINE SCONE1
C     ******* PHASE I OF STRESS DATA RECOVERY FOR CONICAL SHELL*********
C     OUTPUTS FROM THIS ROUTINE FOR USE IN PHASE II ARE...
C     1) ELEMENT ID
C     2 AND 3) SILS A AND B
C     4) S SUB T
C     5) N
C     6) I
C     7) Z1
C     8) Z2
C     9 THRU 22) PHI-S
C     23 THRU 118) TWO 8X6 S MATRICES
C     TOTAL OF 118 WORDS
C***********************************************************************
C     ECPT( 1) = ELEMENT ID             INTEGER        ECT
C     ECPT( 2) = SIL PT A               INTEGER        ECT
C     ECPT( 3) = SIL PT B B             INTEGER        ECT
C     ECPT( 4) = MATID 1                INTEGER        EPT
C     ECPT( 5) = T   (MEMBRANE THICK)   REAL           EPT
C     ECPT( 6) = MATID 2                INTEGER        EPT
C     ECPT( 7) = I   (MOM.OF INERTIA)   REAL           EPT
C     ECPT( 8) = MATID 3                INTEGER        EPT
C     ECPT( 9) = TS  (SHEAR THICKNESS)  REAL           EPT
C     ECPT(10) = NON-STRUCTURAL-MASS    REAL           EPT
C     ECPT(11) = Z1                     REAL           EPT
C     ECPT(12) = Z2                     REAL           EPT
C     ECPT(13) = PHI  1                 REAL           EPT
C     ECPT(14) = PHI  2                 REAL           EPT
C     ECPT(15) = PHI  3                 REAL           EPT
C     ECPT(16) = PHI  4                 REAL           EPT
C     ECPT(17) = PHI  5                 REAL           EPT
C     ECPT(18) = PHI  6                 REAL           EPT
C     ECPT(19) = PHI  7                 REAL           EPT
C     ECPT(20) = PHI  8                 REAL           EPT
C     ECPT(21) = PHI  9                 REAL           EPT
C     ECPT(22) = PHI 10                 REAL           EPT
C     ECPT(23) = PHI 11                 REAL           EPT
C     ECPT(24) = PHI 12                 REAL           EPT
C     ECPT(25) = PHI 13                 REAL           EPT
C     ECPT(26) = PHI 14                 REAL           EPT
C     ECPT(27) = COORD. SYS. ID PT.1    INTEGER        BGPDT
C     ECPT(28) = RADIUS PT. 1           REAL           BGPDT
C     ECPT(29) = DISTANCE TO PT.1       REAL           BGPDT
C     ECPT(30) = NULL                   REAL           BGPDT
C     ECPT(31) = COORD. SYS. ID PT.2    INTEGER        BGPDT
C     ECPT(32) = RADIUS PT 2            REAL           BGPDT
C     ECPT(33) = DISTANCE TO PT. 2      REAL           BGPDT
C     ECPT(34) = NULL                   REAL           BGPDT
C     ECPT(35) = ELEMENT TEMPERATURE    REAL           GEOM3
C***********************************************************************
      REAL III
      REAL NSPRSQ
      REAL NCPRSQ
      REAL N2RSQ
      REAL T30(30)
      REAL G(9)
      REAL NSPOPI
      REAL INTEG(28)
      REAL FAC(7)
      REAL N
      REAL L2
      REAL NSP
      REAL NCP
      REAL N2
      REAL KS
      REAL NOVR
      REAL N2D33
      REAL HYQ(20)
C
      REAL               I00 ,I01 ,I02 ,I03 ,I04
      REAL               I10 ,I11 ,I12 ,I13 ,I14
      REAL               I20 ,I21 ,I22 ,I23 ,I24
      REAL                    I31 ,I32 ,I33 ,I34
      REAL                         I42 ,I43 ,I44
      REAL                         I52 ,I53 ,I54
      REAL                         I62 ,I63 ,I64
C
      INTEGER NECPT(100)
      INTEGER NERROR(2)
      INTEGER NA(7)
C
      COMMON /CONDAS/    PI       ,TWOPI    ,RADEG    ,DEGRA    ,
     1                   S4PISQ
C
      COMMON /MATIN / MATID, INFLAG, ELTEMP, STRESS, SINTH, COSTH
C
      COMMON /MATOUT/ G11, G12, G13, G22, G23, G33, ALPHA
C
      COMMON /SDR2X5/    ECPT(100)     ,PH1OUT(118)
C
      COMMON /SDR2X6/    HUQ(100)      ,H(120)        ,KS(80)
C
      EQUIVALENCE   ( ECPT(1), NECPT(1))
      EQUIVALENCE   ( ECPT(4), MATID1  )
      EQUIVALENCE   ( G(1)    ,HUQ(1)  )
      EQUIVALENCE   ( ECPT(5) ,T       )
      EQUIVALENCE   ( ECPT(6), MATID2  )
      EQUIVALENCE   ( ECPT(7) ,III     )
      EQUIVALENCE   ( ECPT(8), MATID3  )
      EQUIVALENCE   ( ECPT(9) ,TS      )
      EQUIVALENCE   ( ECPT(11),Z1      )
      EQUIVALENCE   ( ECPT(12),Z2      )
      EQUIVALENCE   ( ECPT(28),RA      )
      EQUIVALENCE   ( ECPT(29),ZA      )
      EQUIVALENCE   ( ECPT(32),RB      )
      EQUIVALENCE   ( ECPT(33),ZB      )
      EQUIVALENCE   ( D11     ,G(1)    )
      EQUIVALENCE   ( D12     ,G(2)    )
      EQUIVALENCE   ( D22     ,G(5)    )
      EQUIVALENCE   ( D33     ,G(9)    )
      EQUIVALENCE   ( INTEG(1),HUQ(1)  )
      EQUIVALENCE   ( T30(1)  ,H(1)    )
      EQUIVALENCE   ( HYQ(1)  ,H(31)   )
      EQUIVALENCE   ( HYQ( 1), H11     )
      EQUIVALENCE   ( HYQ( 2), H12     )
      EQUIVALENCE   ( HYQ( 3), H13     )
      EQUIVALENCE   ( HYQ( 4), H14     )
      EQUIVALENCE   ( HYQ( 5), H15     )
      EQUIVALENCE   ( HYQ( 6), H16     )
      EQUIVALENCE   ( HYQ( 7), H17     )
      EQUIVALENCE   ( HYQ( 8), H18     )
      EQUIVALENCE   ( HYQ( 9), H19     )
      EQUIVALENCE   ( HYQ(10), H1TEN   )
      EQUIVALENCE
     1                   (I00 , INTEG( 1))  ,(I20 , INTEG(11))
     2                  ,(I01 , INTEG( 2))  ,(I21 , INTEG(12))
     3                  ,(I02 , INTEG( 3))  ,(I22 , INTEG(13))
     4                  ,(I03 , INTEG( 4))  ,(I23 , INTEG(14))
     5                  ,(I04 , INTEG( 5))  ,(I24 , INTEG(15))
     6                  ,(I10 , INTEG( 6))  ,(I31 , INTEG(16))
     7                  ,(I11 , INTEG( 7))  ,(I32 , INTEG(17))
     8                  ,(I12 , INTEG( 8))  ,(I33 , INTEG(18))
     9                  ,(I13 , INTEG( 9))  ,(I34 , INTEG(19))
     T                  ,(I14 , INTEG(10))  ,(I52 , INTEG(23))
     1                  ,(I42 , INTEG(20))  ,(I53 , INTEG(24))
     2                  ,(I43 , INTEG(21))  ,(I54 , INTEG(25))
     3                  ,(I44 , INTEG(22))  ,(I62 , INTEG(26))
     4                                      ,(I63 , INTEG(27))
     5                                      ,(I64 , INTEG(28))
C
      DATA FAC/1.0E0,1.0E0,2.0E0,6.0E0,24.0E0,120.0E0,720.0E0/
      DATA NA /1,1,1,2,3,3,3/
      DATA ONE/1.0E0/
C
      COSTH=1.0
      SINTH=0.0
      N = NECPT(1) - ( (NECPT(1)/1000)*1000 ) - 1
      TEMP1 = RB-RA
      TEMP2 = ZB-ZA
      SL =  SQRT(TEMP1**2 + TEMP2**2)
      L2 = SL * SL
      IF(SL) 30,20,30
   20 NERROR(1) = NECPT(1) / 1000
      NERROR(2) = N + .3E0
      CALL MESAGE(-30, 39, NERROR(1) )
   30 SP = TEMP1 / SL
      CP = TEMP2 / SL
      NSP = N * SP
      NCP = N * CP
      N2 = N * N
      SP2 = SP * SP
      A=RA
      B=SP
      IF( B ) 60,40,60
C
C     GO TO 302 FOR B = 0
C
C                            1-N
C                      PI  RA     M+1
C     FOR B = 0 I   = --------- SL    (FOR ALL M,N .GE. 0)
C                M,N    M + 1
C
   40 ISUB = 0
      DO 50 I=1,7
      NBEGIN = NA(I)
C
C
      DO 50 J=NBEGIN,5
C
C     M = I - 1
C     N = J - 1
C     MPLUS1 THUS EQUALS I
      ISUB = ISUB + 1
   50 INTEG(ISUB) = (PI * SL**I) / ( FLOAT(I) * RA**(J-2))
C
C     ABOVE COMPLETES ALL INTEGRALS FOR B = 0...
C
C     IF AN OVERFLOW RESULTS BELOW POSSIBLY B IS NOT ZERO, BUT SMALL..
C
      GO TO 100
C
C     OK BELOW IS FOR B NOT EQUAL TO ZERO
C
C     FIRST M = 0 CASE...
C
C                             2-N     2-N
C                      PI ( RB    - RA   )
C               I     =--------------------   (N NOT EQUAL TO 2)
C                0,N       (2-N)  B
C
C
C     FOR N=2   I     = PI * (LOG RB  -  LOG RA) / B
C                0,2             E          E
C
C
   60 RASQ = RA * RA
      RBSQ = RB * RB
      PIOVB = PI / B
C
      INTEG(1) = 0.5E0 * PIOVB * (RBSQ - RASQ)
      INTEG(2) = PIOVB * (RB - RA)
      INTEG(3) = PIOVB * ALOG(RB/RA)
      INTEG(4) = -PIOVB * (ONE/RB - ONE/RA)
      INTEG(5) = -0.5E0 * PIOVB * (ONE/RBSQ - ONE/RASQ)
C
      ISUB = 5
      DO 90 I=1,6
      MPLUS1 = I + 1
      NBEGIN = NA(MPLUS1)
      DO 90 J=NBEGIN,5
      ISUB = ISUB + 1
C
C     M = I
C     N = J - 1
C
C     WE ARE GETTING INTEGRAL(M,N)
C     M = POWER OF S
C     N = POWER OF R
C
C
C     EVALUATING AT R = RB  THEN AT R = RA...
C
C                                    K   NPOW
C                 M FAC.     M   (-A) (R)
C I    = (PI)(-----------)( SUM ------------------------) + (TERM-X)
C  MN               (M+1)   K=0  (M-K)FAC.(K)FAC.(NPOW)
C                  B        (K.NE.M-N+2)                    (K.EQ.M-N+2)
C
C
C     WHERE NPOW = M - N - K + 2
C
C
C                    M-N+2
C                (-A)     LOG(R)
C       TERM-X = --------------------
C               (M-N+2)FAC.(N-2)FAC.
C
C     NOTE IN DATA STATEMENT THAT 0 FACTORIAL = FAC(1)
C                                 1 FACTORIAL = FAC(2)
C                                 2 FACTORIAL = FAC(3)    ETC...
C
      SUM = 0.0E0
      SIGN = -1.0E0
      DO 80 KK=1,MPLUS1
      SIGN = -SIGN
      K = KK - 1
      NPOW = I - J + 3
      IF(K .EQ. NPOW ) GO TO 70
      NPOW = NPOW - K
      IFAC = MPLUS1 - K
      TEMP = NPOW
      SUM=SUM+SIGN*A**K*(RB**NPOW - RA**NPOW)/(FAC(IFAC)*FAC(K+1)*TEMP)
      GO TO 80
   70 SUM = SUM+SIGN*A**NPOW*ALOG(RB/RA) / (FAC(NPOW+1)*FAC(J-2))
   80 CONTINUE
C
      INTEG(ISUB) = SUM * PI * FAC(MPLUS1) / B**MPLUS1
   90 CONTINUE
  100 CONTINUE
C
C
      DO 120 I = 1,80
  120 KS(I) = 0.0E0
C
      R = 0.50E0 * ( RA + RB )
      S = 0.50E0 * SL
C
      IF( T ) 130,170,130
  130 VAR=1.0
      MATID = MATID1
      ASSIGN 150 TO ICONT
C
  140 ELTEMP = ECPT(35)
      INFLAG = 2
      CALL MAT( ECPT(1) )
      G(1) = G11 * VAR
      G(2) = G12 * VAR
      G(3) = G13 * VAR
      G(4) = G12 * VAR
      G(5) = G22 * VAR
      G(6) = G23 * VAR
      G(7) = G13 * VAR
      G(8) = G23 * VAR
      G(9) = G33 * VAR
C
      GO TO ICONT,(150,195)
C
  150 DO 160 I = 1,30
  160 T30(I) = 0.0E0
C
      T30( 4) = 1.0E0
      T30(11) = N / R
      T30(12) = T30(11) * S
      T30(13) =   SP / R
      T30(14) = S * T30(13)
      T30(15) = CP / R
      T30(16) = S * T30(15)
      T30(17) = S * T30(16)
      T30(18) = S * T30(17)
      T30(21) = - T30(13)
      T30(22) = 1.0E0 - T30(14)
      T30(23) = - T30(11)
      T30(24) = - T30(12)
C
      CALL GMMATS( G(1),3,3,0,  T30(1),3,10,0,  KS(1) )
C
  170 IF( III ) 190,180,190
  180 DO 181 I = 1,9
  181 G(I) = 0.0E0
      GO TO 195
C
C     GET G MATERIAL MATRIX FOR MATERIAL ID 2 AND MULTIPLY BY I...
C     THIS THEN IS THE D 3X3 MATRIX BY EQUIVALENCE...
C
  190 VAR = III
      MATID = MATID2
      ASSIGN 195 TO ICONT
      GO TO 140
C
C     FORMING 1.0/Q DIRECTLY
C
  195 OPI = ONE / PI
      DO 299 I = 1,20
  299 HYQ(I) = 0.0E0
      IF( TS ) 351,352,351
C
  351 ELTEMP = ECPT(35)
      INFLAG = 1
      MATID = MATID3
      CALL MAT( NECPT(1) )
C
      IF(G12.EQ.0.0) GO TO 354
      N2D33 = N2 * D33
      SP2D22 = SP2 * D22
      OQ = SL * TS *  G12    * (RA+RB)*0.5E0 + I02 * (N2D33+SP2D22)*OPI
      OQ = ONE / OQ
      NSPOPI = NSP * OPI
      TWOD33 = 2.0E0 * D33
      TEMP1 = D12 * (ONE/RB - ONE/RA)
      TEMP2 = NSPOPI * (D22 + D33)
      TEMP3 = N * NSPOPI * (TWOD33 + D22)
      TEMP4 = OQ * 0.5E0 * NCP * N * D33 * OPI
      TEMP5 = OPI * (N2 * TWOD33  + SP2 * D22)
      TEMP6 = D12 * N2 * L2 / RB
      TEMP7 = NSPOPI * CP * 0.50E0
C
      HYQ( 1) = OQ*(TEMP1*NCP - TEMP7*I03*(D33+2.0E0*D22))
      HYQ( 2) = OQ*(NCP*SL/RB*D12-TEMP7*I13*(3.0E0*D33+D22)+
     1   1.0E0*NCP*OPI*I02*D33)
      HYQ( 3) = TEMP4 * I03
      HYQ( 4) = TEMP4 * I13
      HYQ( 5) = OQ * (TEMP1*N2  -  TEMP3*I03)
      HYQ( 6) = OQ * (D12*N2*SL/RB - TEMP3*I13 + TEMP5*I02)
      HYQ( 7) = OQ*(2.0E0*D11*(RA-RB)+TEMP6+2.0E0*I12*TEMP5-TEMP3*I23)
      HYQ( 8) =OQ*(-D11*6.E0*SL*RB+TEMP6*SL+3.E0*I22*TEMP5-TEMP3*I33)
      HYQ( 9) = -OQ * TEMP2 * I02
      HYQ(10) = OQ * (N*SL*(D12 + D33) - TEMP2*I12)
      HYQ(19) = 1.0E0
      HYQ(20) = S
C
      TSG3 = TS * G12
      DO 359 I = 1,20
  359 KS(I+60) = HYQ(I) * TSG3
C     FILL HXQ MATIX
C
      GO TO 352
  354 TS=0.0
  352 IF( III ) 500,400,500
  500 S2 = S * S
      S3 = S * S2
      RSQ = R * R
      SPOVR = SP / R
      NCPRSQ = NCP/RSQ
      NSPRSQ = NSP/RSQ
      N2RSQ = N2 / RSQ
      SPCPR2 = SP * CP / RSQ
      NOVR = N / R
      T30( 7) = 2.0E0
      T30( 8) = 6.0E0 * S
      T30(11) = - NCPRSQ - SPOVR * H11
      T30(12) = - S * NCPRSQ - SPOVR * H12
      T30(13) = - SPOVR * H13
      T30(14) = - SPOVR * H14
      T30(15) = - N2RSQ - SPOVR * H15
      T30(16) = SPOVR - N2RSQ * S - SPOVR * H16
      T30(17) = 2.0E0 * S * SPOVR - N2RSQ * S2 - SPOVR * H17
      T30(18) = 3.0E0 * S2 * SPOVR - N2RSQ * S3 - SPOVR * H18
      T30(19) = - NOVR - SPOVR * H19
      T30(20) = - NOVR * S - SPOVR * H1TEN
      T30(21) = 0.5E0 * SPCPR2 + NOVR * H11
      T30(22) = 0.5E0 * ( S * SPCPR2 - 3.0E0 * CP / R ) + NOVR * H12
      T30(23) = -0.50E0 * NCPRSQ + NOVR * H13
      T30(24) = -NCPRSQ * S * 0.50E0 * NOVR * H14
      T30(25) = NSPRSQ + NOVR * H15
      T30(26) = NSPRSQ * S - NOVR * ( 2.0E0 - H16 )
      T30(27) = NSPRSQ * S2 - NOVR * ( 4.0E0 * S - H17 )
      T30(28) = NSPRSQ * S3 - NOVR * ( 6.0E0 * S2 - H18 )
      T30(29) = SPOVR + NOVR * H19
      T30(30) = -1.0E0 + SPOVR * S + NOVR * H1TEN
C
      CALL GMMATS( G(1),3,3,0,  T30(1),3,10,0,  KS(31) )
C
C
C
C     FILL HUQ PER PAGE 15 MS-28
C
  400 DO 290 I=1,100
  290 HUQ(I) = 0.0E0
      HUQ(  1) = ONE
      HUQ( 13) = ONE
      HUQ( 25) = ONE
      HUQ( 36) = ONE
      HUQ( 49) = ONE
      HUQ( 51) = ONE
      HUQ( 52) = SL
      HUQ( 63) = ONE
      HUQ( 64) = SL
      HUQ( 75) = ONE
      HUQ( 76) = SL
      HUQ( 77) = L2
      HUQ( 78) = HUQ(77) * SL
      HUQ( 86) = ONE
      HUQ( 87) = 2.0E0 * SL
      HUQ( 88) = 3.0E0 * HUQ(77)
      HUQ(100) = SL
C
      IF( TS ) 300,320,300
C
  300 HUQ( 41)=CP/RA
      HUQ( 45)=N/RA
      HUQ( 91) = CP / RB
      HUQ( 92) = HUQ(91) * SL
      HUQ( 95) = N / RB
      HUQ( 96) = HUQ(95) * SL
      HUQ( 97) = HUQ(95) * L2
      HUQ( 98) = HUQ(96)*L2
      HUQ( 99) = ONE
      HUQ(100) = SL
C
C     SUBTRACT FROM ROWS 4 AND 9 OF THE ABOVE MATRIX, THE HYQ MATRIX...
C
      DO 310 I=1,10
      HUQ(I+30) = HUQ(I+30) - HYQ(I)
  310 HUQ(I+80) = HUQ(I+80) - HYQ(I)
C
  320 CONTINUE
C     NO NEED TO COMPUTE DETERMINANT SINCE IT IS NOT USED SUBSEQUENTLY.
      ISING = -1
      CALL INVERS( 10, HUQ(1), 10, DUM, 0, DETERM, ISING, T30(1) )
C
C     CHECK SINGULARITY
      GO TO(340,330),ISING
  330 CALL MESAGE( -30, 40, NECPT(1) )
C
C
C     NOT SINGULAR, CONTINUE ON..
  340 CONTINUE
      IF(TS.NE.0.0) GO TO 345
      HUQ(85)=0.0
      HUQ(100)=0.0
  345 CONTINUE
C                            T                      T
C           GET EHAT = (E)(H  ),  AND  EHBT = (E)(H  )
C                           A                      B
C     EHAT WILL BE STORED AT H(1)...H(60) AND EHBT AT H(61)...H(120)
C
C
C              0    SP   CP   0    0
C
C              1    0    0    0    0
C
C              0    CP  -SP   0    0
C   MATRIX E =
C              0    0    0    0    SP
C
C              0    0    0    1    0
C
C              0    0    0    0    CP
      INC1 = 0
      INC2 = 0
  350 DO 360 I=1,10
      ISUB = I + INC1
      ITEN = 10*I - 9 + INC2
      H(ISUB   ) = HUQ(ITEN+1) * SP  +  HUQ(ITEN+2) * CP
      H(ISUB+10) = HUQ(ITEN  )
      H(ISUB+20) = HUQ(ITEN+1) * CP  -  HUQ(ITEN+2) * SP
      H(ISUB+30) = HUQ(ITEN+4) * SP
      H(ISUB+40) = HUQ(ITEN+3)
  360 H(ISUB+50) = HUQ(ITEN+4) * CP
      IF( INC1 ) 380,370,380
  370 INC1 = 60
      INC2 = 5
      GO TO 350
  380 CONTINUE
C
      DO 700 I = 1,2
      CALL GMMATS( KS(1),8,10,0,  H(60*I-59),6,10,1,  PH1OUT(48*I-25) )
  700 CONTINUE
      SSUBT = 0.0E0
      IF( MATID1 ) 800,850,800
C     COMPUTE S SUB T
C
  800 INFLAG = 1
      MATID = MATID1
      ELTEMP = ECPT(35)
      CALL MAT( ECPT(1) )
      SSUBT = G11 * PI * ALPHA / (1.0E0 - G13)
      IF( N .EQ. 0.0E0 ) SSUBT = 2.0E0  * SSUBT
C
  850 PH1OUT(1) = ECPT(1)
      PH1OUT(2) = ECPT(2)
      PH1OUT(3) = ECPT(3)
      PH1OUT(4) = SSUBT
      PH1OUT(5) = N
      PH1OUT(6) = III
      PH1OUT(7) = Z1
      PH1OUT(8) = Z2
      DO 900 I = 9,22
  900 PH1OUT(I) = ECPT(I+4)
C
      RETURN
      END

      SUBROUTINE TRHT1B(IOF,DELTA)
C
C
      DOUBLE PRECISION        QBLOCK(6),          BLOCK(2), BLK(2)
C
      INTEGER                 MCB(7),   NAME(2),  IQBLK(12),IBLOCK(11)
C
      COMMON /BLANK/    BETA,     TABS,     NORAD,    RADLIN
      COMMON /TRHTX /         IK(7),    IB(7),    ICR1,     ICR2,
     1                        ICR3,     ICR4,     ICR5,     ISYM,
     2                        ICR6,     ICR7
C
      EQUIVALENCE             ( IQBLK(1),         QBLOCK(1) )
      EQUIVALENCE             ( IQBLK(2),         IBLOCK(1) )
      EQUIVALENCE             ( QBLOCK(2),        BLOCK(1) )
      EQUIVALENCE             ( QBLOCK(5),        BLK(1) )
C
C ----------------------------------------------------------------------
C
      IBLOCK(1) =2
      BLOCK(1)= 1.0D0/DELTA
      BLOCK(2)= 0.0D0
      IBLOCK(7)= 2
      BLK(1) = BETA
      BLK(2) = 0.0D0
      CALL SSG2C(IB,IK,ICR6,1,IBLOCK)
      MCB(1)=ICR6
      CALL RDTRL(MCB(1))
      IF ( MCB(4) .EQ. 6) GO TO  10
      CALL FACTRU(*40,ICR6,ICR1,ICR2,ICR3,ICR4,ICR7)
      ISYM = 0
      GO TO  20
C
C     SYMMETRIC DECOMP
C
   10 CALL FACTOR( ICR6, ICR1, ICR2, ICR3, ICR4, ICR7 )
      ISYM =1
C
C     LLL  IS ON ICR1
C
C     FORM  A  MATRIX
C
   20 BLK(1) = -(1.0D0 - BETA)
      BLK(2) = 0.0
      CALL SSG2C(IB,IK,ICR6,1,IBLOCK)
   30 RETURN
   40 CALL MESAGE(-5,ICR6,NAME)
      GO TO 30
      END

      SUBROUTINE IFP1G (ITYPE,CASE,ISUB1)
C
C     MAKE SURE THIS VERSION ALSO WORKS IN UNIVAC, IBM, CDC AND 64-BIT
C     MACHINES
C     ================================================================
C     IZZZBB = 0 (ALL BITS ZERO)
C     IBEN   = FIRST BYTE BLANK, REST IS ZERO FILL
C     EQUAL  = FIRST BYTE EQUAL, REST IS ZERO FILL
C
      INTEGER         CHAR,CORE(1),COREY(401),EQUAL,TITLE,CASE(200,2)
      COMMON /OUTPUT/ TITLE(32)
      COMMON /ZZZZZZ/ COREX(1)
      COMMON /IFP1A / SKIP1(3),NWPC,NCPW4,SKIP2(4),IZZZBB,ISTR,SKIP3(2),
     1                IBEN,EQUAL
      EQUIVALENCE     (COREX(1),COREY(1)), (CORE(1),COREY(401))
C
C     FIND EQUAL SIGN AND COPY REMAINING DATA ON CARD
C
C     OR FIND THE FIRST BLANK CHARACTER AFTER THE FIRST NON-BLANK WORD
C     (USED ONLY FOR ITYPE = 8, PTITLE, AXIS TITLE ETC. WHERE EQUAL SIGN
C     IS OPTIONAL AND NOT MANDATORY)
C
      K  = -1
      I2 = NWPC - 2
      DO 160 I = 1,I2
      DO 160 J = 1,NCPW4
      CHAR = KHRFN1(IZZZBB,1,CORE(I),J)
      IF (CHAR .EQ. EQUAL) GO TO 170
      IF (CHAR.NE.IBEN .AND. K.EQ.-1) K = 0
      IF (CHAR.EQ.IBEN .AND. K.EQ. 0) K = I*100 + J
  160 CONTINUE
      IF (ITYPE .NE. 8) GO TO 170
      I  = K/100
      J  = MOD(K,100)
  170 K  = (ITYPE-1)*32
      K1 = K + 38
      IF (ITYPE .EQ. 8) K1 = 0
      IF (J  .NE. NCPW4) GO TO 180
      I = I + 1
      J = 0
  180 J = J + 1
      IPOS  = 1
      ITS   = K + 1
      ISAVE = IZZZBB
      DO 250 II = I,I2
  190 ISAVE = KHRFN1(ISAVE,IPOS,CORE(II),J)
      IPOS  = IPOS + 1
      IF (IPOS .GT. 4) GO TO 210
  200 J = J + 1
      IF (J .LE. NCPW4) GO TO 190
      J = 1
      GO TO 250
  210 IPOS = 1
      IF (ITYPE .EQ. 7) GO TO 220
      IF (ISTR-1) 220,230,220
  220 TITLE(ITS) = ISAVE
      GO TO 240
  230 CASE(K1+1,ISUB1) = ISAVE
      K1 = K1 + 1
  240 ISAVE = IZZZBB
      ITS = ITS + 1
      GO TO 200
  250 CONTINUE
      DO 260 I = IPOS,4
  260 ISAVE = KHRFN1(ISAVE,I,IBEN,1)
      IF (ITYPE .EQ. 7) GO TO 270
      IF (ISTR-1) 270,280,270
  270 TITLE(ITS) = ISAVE
      GO TO 290
  280 CASE(K1+1,ISUB1) = ISAVE
  290 RETURN
      END

      SUBROUTINE FEER3
C                                                               T
C     FEER3 OBTAINS THE REDUCED TRIDIAGONAL MATRIX   (LI)*M*(LI)
C     WHERE M IS A SYMETRIC MATRIX AND L IS LOWER TRIANGULAR, AND (LI)
C     IS INVERSE OF L
C
C     THE TRANSFORMATION IS ALPHA = VT(L**(-1)M (L**-(1))TV
C     WHERE V IS A RECTANGULAR TRANSFORMATION.
C
C  Comments to follow refer to updates made 11/94.
C  This is a new version of FEER3.  The old version has been renamed FEER3X.
C  Diag 43 may be used to force the use of the old version.  The new version
C  uses all of available open core for storage of the orthogonal vectors,
C  the lower triangular matrix from SDCOMP, and the SMA matrix.  If 
C  insufficient memory is available, only part of the lower triangular 
C      
      INTEGER            SYSBUF    ,CNDFLG   ,MCBSCL(7),SR5FLE   ,
     1                   SR6FLE    ,SR7FLE   ,SR8FLE   ,
     2                   IZ(1)     ,NAME(2)  ,REW      ,WRTREW   ,
     3                   OPTN2    ,RDREW    ,SMAPOS
C     INTEGER            DASHQ
      DOUBLE PRECISION   LAMBDA    ,LMBDA    ,DZ(1)    ,DSQ
      COMMON   /FEERCX/  IFKAA(7)  ,IFMAA(7) ,IFLELM(7),IFLVEC(7),
     1                   SR1FLE    ,SR2FLE   ,SR3FLE   ,SR4FLE   ,
     2                   SR5FLE    ,SR6FLE   ,SR7FLE   ,SR8FLE   ,
     3                   DMPFLE    ,NORD     ,XLMBDA   ,NEIG     ,
     4                   MORD      ,IBK      ,CRITF    ,NORTHO   ,
     5                   IFLRVA    ,IFLRVC
      COMMON   /FEERXX/  LAMBDA    ,CNDFLG   ,ITER     ,TIMED    ,
     1                   L16       ,IOPTF    ,EPX      ,NOCHNG   ,
     2                   IND       ,LMBDA    ,IFSET    ,NZERO    ,
     3                   NONUL     ,IDIAG    ,MRANK    ,ISTART  
C
C  NIDSMA = IN-MEMORY INDEX FOR COLUMN DATA OF SMA MATRIX
C  NIDLT  = IN-MEMORY INDEX FOR LOWER TRIANGULAR MATRIX
C  NIDORV = IN-MEMORY INDEX FOR ORTHOGONAL VECTORS
C  NLTLI  = INDEX OF LAST STRING OF LOWER TRIANGULAR MATRIX HELD IN MEMORY
C  NSMALI = INDEX OF LAST STRING OF SMA MATRIX HELD IN MEMORY
C  IBFSMA = IN-MEMORY INDEX FOR BUFFER FOR OPENING SMA MATRIX
C  IBMLT  = IN-MEMORY INDEX FOR BUFFER FOR OPENING LOWER TRIANGULAR MATRIX
C  IBFORV = IN-MEMORY INDEX FOR BUFFER FOR ORTHOGONAL VECTORS
C  SMAPOS = POSITION OF RECORD FOLLOWING LAST RECORD READ INTO MEMORY
C           AND THE LAST RECORD OF MATRIX SMA (SEE SUBROUTINE DSCPOS)
C  LTPOS  = POSITION OF RECORD FOLLOWING LAST RECORD READ INTO MEMORY 
C           AND THE LAST RECORD OF THE LOWER TRIANGULAR MATRIX
C
      COMMON   /FEERIM/  NIDSMA    ,NIDLT    ,NIDORV   ,NLTLI    , 
     1                   NSMALI    ,IBFSMA   ,IBFLT    ,
     2                   IBFORV    ,SMAPOS(7),LTPOS(7)
      COMMON   /REIGKR/  OPTION    ,OPTN2
      COMMON   /TYPE  /  RC(2)     ,IWORDS(4)
      COMMON   /ZZZZZZ/  Z(1)
      COMMON   /SYSTEM/  SYSBUF    ,NOUT     ,SYSTM(52),IPREC    ,
     1                   SKIP36(38),KSYS94
      COMMON   /OPINV /  MCBLT(7)  ,MCBSMA(7),MCBVEC(7),MCBRM(7)
      COMMON   /UNPAKX/  IPRC      ,II       ,NN       ,INCR
      COMMON   /PACKX /  ITP1      ,ITP2     ,IIP      ,NNP      ,
     1                   INCRP
      COMMON   /NAMES /  RD        ,RDREW    ,WRT      ,WRTREW   ,
     1                   REW       ,NOREW    ,EOFNRW
      EQUIVALENCE        (IZ(1),Z(1),DZ(1))
      DATA      NAME  /  4HFEER,4H3   /      
C     DATA      DASHQ / 4H-Q    /
C
C     SR5FLE CONTAINS THE TRIDIAGONAL ELEMENTS
C     SR6FLE CONTAINS THE G VECTORS
C     SR7FLE CONTAINS THE ORTHOGONAL VECTORS
C     SR8FLE CONTAINS THE CONDITIONED MAA OR KAAD MATRIX
C     IFLVEC CONTAINS THE L OR C MATRIX FROM SDCOMP
C     IFLELM CONTAINS     KAA+ALPHA*MAA
C     IFLRVC CONTAINS THE RESTART AND/OR RIGID BODY VECTORS
C
      CALL SSWTCH ( 43, L43 )
      IF ( L43 .EQ. 0 ) GO TO 1
      CALL FEER3X
      GO TO 7777
1     CONTINUE
      IPRC      = MCBLT(5)
      NWDS      = IWORDS(IPRC)
      NZ        = KORSZ(Z)
      CALL MAKMCB (MCBVEC(1),SR7FLE,NORD,2,IPRC)
      MCBVEC(2) = 0
      MCBVEC(6) = 0
      CALL MAKMCB (MCBRM(1) ,SR6FLE,MORD,2,IPRC)
      MCBRM(2)  = 0
      MCBRM(6)  = 0
      MCBSCL(1) = IFLRVC
      CALL RDTRL (MCBSCL(1))
C
C     INITIALIZE ALLOCATIONS
C
      IBUF1  = NZ    - SYSBUF
      IBUF2  = IBUF1 - SYSBUF
      IBUF3  = IBUF2 - SYSBUF
      IBUF4  = IBUF3 - SYSBUF 
      IBFORV = IBUF1   
      IBFLT  = IBUF3
      IBFSMA = IBUF2
      IV1    = 1
      IV2    = IV1 + NORD
      IV2M1  = IV2 - 1    
      IV3    = IV2 + NORD
      IV4    = IV3 + NORD
      IV5    = IV4 + NORD
      IEND   = NWDS*(5*NORD + 1) + 2
      MAVAIL = IEND - IBUF4
      IF (MAVAIL .GT. 0) CALL MESAGE (-8,MAVAIL,NAME)
C
C COMPUTE THE MEMORY REQUIREMENT FOR ORTHOGONAL VECTORS
C
      MEMORT = NORD * ( MORD+NORTHO ) * IPRC
C
C COMPUTE THE MEMORY REQUIREMENT FOR THE LOWER TRIANGULAR MATRIX
C
      CALL DSSIZE ( MCBLT, NCOLS, NTERMS, NSTRGS, NWDTRM )
      MEMLT  = NTERMS*NWDTRM + NSTRGS*4
C
C COMPUTE THE MEMORY REQUIREMENT FOR THE SMA MATRIX
C
      CALL DSSIZE ( MCBSMA, NCOLS, NTERMS, NSTRGS, NWDTRM )
      MEMSMA = NTERMS*NWDTRM + NSTRGS*4
      IF ( L16 .EQ. 0 ) GO TO 2
      MINNEE = IEND + 4*SYSBUF
      MEMTOT = MEMORT + MEMLT + MEMSMA + MINNEE
      WRITE ( NOUT, 901 ) 
     &    MINNEE, MEMORT, MEMSMA, MEMLT, MEMTOT, NZ 
901   FORMAT(' FEER EIGENVALUE EXTRACTION NFORMATION'
     &,/, 5X,' THE FOLLOWING GIVES OPEN CORE REQUIREMENTS FOR KEEPING'
     &,/, 5X,' VARIOUS MATRICES AND VECTORS IN CORE FOR THE FEER'
     &,/, 5X,' EIGENVALUE EXTRACTION METHOD'
     &,/,10X,' MINIMUM NUMBER OF WORDS NEEDED IN OPEN CORE    =',I10   
     &,/,10X,' NUMBER OF WORDS FOR ORTHOGONAL VECTORS         =',I10
     &,/,10X,' NUMBER OF WORDS FOR SMA MATRIX                 =',I10
     &,/,10X,' NUMBER OF WORDS FOR LOWER TRIANGULAR MATRIX    =',I10 
     &,/,10X,' TOTAL NUMBER OF WORDS NEEDED TO ELIMINATE I/O  =',I10
     &,/,10X,' WORDS FOR OPEN CORE SPECIFIED IN THIS RUN      =',I10  
     & ) 
2     CONTINUE
C CHECK TO SEE IF MEMORY AVAILABLE FOR ORTHOGONAL VECTORS
      NIDORV = 0
      ITEST  = IEND + MEMORT
      IF ( ITEST .GT. IBUF4 ) GO TO 3
      NIDORV = IEND
      NIDORV = ( NIDORV/2 ) * 2 + 1
      IEND   = IEND + MEMORT
3     CONTINUE
C CHECK TO SEE IF MEMORY AVAILABLE FOR SMA MATRIX
      IRMEM  = IBUF4 - IEND
      IF ( IRMEM .LE. 10 ) GO TO 4
      NIDSMA = IEND
      NIDSMA = (NIDSMA/2) * 2  + 1
      MEMSMA = MEMSMA
      MEMSMA = MIN0 ( MEMSMA, IRMEM )
      IEND   = IEND + MEMSMA
      GO TO 5
4     CONTINUE
      NIDSMA = 0
      MEMSMA = 0
5     CONTINUE
C CHECK TO SEE IF MEMORY AVAILABLE FOR LOWER TRIANGULAR MATRIX
      IRMEM  = IBUF4 - IEND
      IF ( IRMEM .LE. 10 ) GO TO 6
      NIDLT  = IEND
      NIDLT  = (NIDLT/2) * 2 + 1
      MEMLT  = MEMLT
      MEMLT  = MIN0 ( MEMLT, IRMEM )
      IEND   = IEND + MEMLT
      GO TO 7
6     CONTINUE
      NIDLT  = 0
      MEMLT  = 0
7     CONTINUE
      LTPOS ( 4 ) = -1
      SMAPOS( 4 ) = -1
C      PRINT *,' FEER3, CALLING FERRDM,NIDSMA,NIDLT=',NIDSMA,NIDLT
      IF ( NIDSMA .EQ. 0 ) GO TO 11
      CALL FERRDM ( MCBSMA,NIDSMA,MEMSMA,IBFSMA,NSMALI,SMAPOS)
C      PRINT *,' RETURN FROM FERRDM,MEMSMA,NSMALI=',MEMSMA,NSMALI
C      PRINT *,' SMAPOS=',SMAPOS
11    IF ( NIDLT  .EQ. 0 ) GO TO 12
      CALL FERRDM ( MCBLT ,NIDLT ,MEMLT ,IBFLT ,NLTLI ,LTPOS )
C      PRINT *,' RETURN FROM FERRDM,MEMLT,NLTLI=',MEMLT,NLTLI
C      PRINT *,' LTPOS=',LTPOS
12    CONTINUE  
      IF ( L16 .EQ. 0 ) GO TO 8
      WRITE ( NOUT, 902 ) 'SMA',SMAPOS(1)
      WRITE ( NOUT, 902 ) 'LT ',LTPOS(1)
902   FORMAT(10X,' LAST COLUMN OF ',A3,' MATRIX IN MEMORY IS ',I4 )
C      PRINT *,' SMAPOS=',SMAPOS
C      PRINT *,' LTPOS =',LTPOS
8     CONTINUE
      CALL GOPEN (SR7FLE,Z(IBUF1),WRTREW)
      IF (NORTHO .EQ. 0) GO TO 130
C
C     LOAD RESTART AND/OR RIGID BODY VECTORS
C
      CALL GOPEN (IFLRVC,Z(IBUF2),RDREW)
      INCR  = 1
      INCRP = 1
      ITP1  = IPRC
      ITP2  = IPRC
      DO 110 J = 1,NORTHO
      II  = 1
      NN  = NORD
      CALL UNPACK (*110,IFLRVC,DZ(1))
      IIP = II
      NNP = NN
      IF (IPRC  .EQ. 1) GO TO 60
      IF (IOPTF .EQ. 0) GO TO 40
      DSQ = 0.D0
C      PRINT *,' FERR3 CALLING FRMLTX'
      CALL FRMLTX (MCBLT(1),DZ(IV1),DZ(IV2),DZ(IV3))
      DO 20 IJ = 1,NORD
   20 DSQ = DSQ + DZ(IV2M1+IJ)**2
      DSQ = 1.D0/DSQRT(DSQ)
      DO 30 IJ = 1,NORD
   30 DZ(IJ) = DSQ*DZ(IV2M1+IJ)
   40 CONTINUE
      GO TO 100
   60 IF (IOPTF .EQ. 0) GO TO 90
      SQ = 0.0
C      PRINT *,' FEER3 CALLING FRMLTA'
      CALL FRMLTA (MCBLT(1),Z(IV1),Z(IV2),Z(IV3))
      DO 70 IJ = 1,NORD
   70 SQ = SQ + Z(IV2M1+IJ)**2
      SQ = 1.0/SQRT(SQ)
      DO 80 IJ = 1,NORD
   80 Z(IJ) = SQ*Z(IV2M1+IJ)
   90 CONTINUE
  100 CALL PACK (DZ(1),SR7FLE,MCBVEC(1))
  110 CONTINUE
      CALL CLOSE (IFLRVC,NOREW)
  130 K = NORTHO
      CALL CLOSE (SR7FLE,NOREW)
      J = K
      NONUL = 0
      ITER  = 0
C      PRINT *,' FEER3,SR7FLE,IFLRVC,SR6FLE=',SR7FLE,IFLRVC,SR6FLE
C      PRINT *,' FEER3,SR6FLE,SR8FLE,SR5FLE=',SR6FLE,SR8FLE,SR5FLE
C      PRINT *,' FEER3,MCBSMA,MCBLT,MCBVEC=',MCBSMA(1),MCBLT(1),MCBSMA(1)
      CALL GOPEN (SR6FLE,Z(IBUF4) ,WRTREW)
      CALL CLOSE (SR6FLE,NOREW)
      IF ( SR8FLE .EQ. MCBSMA(1) ) GO TO 131
C      PRINT *,' PROBLEM IN FEER3, SR8FLE NE MCBSMA =',SR8FLE,MCBSMA(1)
      STOP
  131 CONTINUE
C      CALL GOPEN (SR8FLE,Z(IBUF2) ,RDREW )
      CALL GOPEN (SR5FLE,Z(IBUF4) ,WRTREW)
      CALL GOPEN (MCBSMA,Z(IBFSMA),RDREW )
      CALL GOPEN (MCBLT ,Z(IBFLT ),RDREW )
C
C     GENERATE SEED VECTOR
C
  140 K = K + 1
      J = K
      IFN = 0
C
C     GENERATE SEED VECTOR FOR LANCZOS
C
      SS = 1.0
      IF (IPRC .EQ. 1) GO TO 160
      DO 150 I = 1,NORD
      SS =-SS
      J  = J + 1
      DSQ = FLOAT(MOD(J,3)+1)/(3.0*FLOAT((MOD(J,13)+1)*(1+5*I/NORD)))
  150 DZ(IV2M1+I) = DSQ*SS
C      PRINT *,' FEER3 CALLING FERXTD'
      CALL FERXTD (DZ(IV1), DZ(IV2), DZ(IV3)
     1,            DZ(IV4), DZ(IV5), Z(IBUF1), IFN )
      GO TO 180
  160 DO 170 I = 1,NORD
      SS =-SS
      J  = J + 1
      SQ = FLOAT(MOD(J,3)+1)/(3.0*FLOAT((MOD(J,13)+1)*(1+5*I/NORD)))
  170 Z(IV2M1+I) = SQ*SS
C      IF (OPTN2 .EQ. DASHQ) GO TO 175 
      CALL FERXTS ( Z(IV1), Z(IV2)  , Z(IV3), Z(IV4 )
     1,             Z(IV5), Z(IBUF1), IFN)
      GO TO 180 
C  175 CALL FERXTQ ( Z(IV1), Z(IV2)  , Z(IV3), Z(IV4 )
C     1,              Z(IV5), Z(IBUF1), IFN)
  180 IF (ITER .LE. MORD) GO TO 190
      MORD = NORTHO - NZERO
      CNDFLG = 3
      GO TO 200
C
  190 IF (IFN .LT. MORD) GO TO 140
  200 CALL CLOSE (SR5FLE,NOREW)
      CALL CLOSE (SR8FLE,REW)
      CALL CLOSE (MCBLT ,REW)
 7777 CONTINUE
      RETURN
      END

      SUBROUTINE CMHGEN
C
C     THIS SUBROUTINE GENERATES THE (H) TRANSFORMATION MATRICES FOR
C     COMPONENT SUBSTRUCTURES IN A COMBINE OPERATION AND WRITES THEM
C     ON THE SOF
C
      LOGICAL         FRSFIL
      INTEGER         BUFEX,SCR1,MCB(7),IHEAD(2),NAM(2),SCR3,BUF1,
     1                CNAM,COMBO,Z,SSIL,LCORE,SCORE,SCSFIL,BUF2,BUF3,
     2                SCBDAT,SCCONN,LISTO(32),LISTN(32),AAA(2),BUF4,
     3                CE(10)
      DIMENSION       T(6,6),TP(6,6),TPP(6,6),COLOUT(6),TID(6,6),
     1                TTRAN(6,6)
      COMMON /CMB001/ SCR1,SCR2,SCBDAT,SCSFIL,SCCONN,SCMCON,SCTOC,
     1                GEOM4,CASECC,SCCSTM,SCR3
      COMMON /CMB002/ BUF1,BUF2,BUF3,BUF4,BUF5,SCORE,LCORE,INPT,OUTT
      COMMON /CMB003/ COMBO(7,5),CONSET,IAUTO,TOLER,NPSUB
      COMMON /CMB004/ TDAT(6),NIPNEW,CNAM(2)
      COMMON /ZZZZZZ/ Z(1)
      COMMON /PACKX / IIN,IOUT,IIII,NNNN,INCR
      DATA    ZERO  / 0.0 /,AAA/ 4HCMHG,4HEN   /,IHEAD/ 4HHORG,4H    /
      DATA    TID   / 1.,0.,0.,0.,0.,0., 0.,1.,0.,0.,0.,0.,
     1                0.,0.,1.,0.,0.,0., 0.,0.,0.,1.,0.,0.,
     2                0.,0.,0.,0.,1.,0., 0.,0.,0.,0.,0.,1. /
      DATA    NHEQSS/ 4HEQSS   /
C
C     READ SIL,C FROM SOF FOR COMBINED STRUCTURE
C
      INCR  = 1
      BUFEX = LCORE - BUF2 + BUF3
      LCORE = BUFEX - 1
      IF (LCORE .LT. 0) GO TO 320
      IOEFIL = 310
      CALL OPEN (*300,IOEFIL,Z(BUFEX),0)
      MCB(1) = SCR1
      MCB(4) = 2
      MCB(5) = 1
      IIN    = 1
      IOUT   = 1
      CALL SFETCH (CNAM,NHEQSS,1,ITEST)
      NSUB = 0
      DO 10 I = 1,NPSUB
      NSUB = NSUB + COMBO(I,5)
   10 CONTINUE
      CALL SJUMP (NSUB+1)
      CALL SUREAD (Z(SCORE),-1,NSILNW,ITEST)
C
C     LOOP ON NUMBER OF PSEUDO-STRUCTURES BEING COMBINED
C
      SSIL  = SCORE + NSILNW
      LCORE = LCORE - NSILNW
      IFILE = SCR3
      CALL OPEN (*300,SCR3,Z(BUF1),0)
      IFILE = SCSFIL
      CALL OPEN (*300,SCSFIL,Z(BUF2),0)
C
      DO 260 I = 1,NPSUB
      FRSFIL = .TRUE.
      MCB(2) = 0
      MCB(6) = 0
      MCB(7) = 0
C
C     READ SIL,C FOR COMPONENT SUBSTRUCTURE
C
      NCS = COMBO(I,5) + 2
      DO 20 J = 1,NCS
      CALL FWDREC (*310,SCSFIL)
   20 CONTINUE
      IFILE = IOEFIL
      CALL READ (*310,*30,IOEFIL,Z(SSIL),LCORE,1,NSLOLD)
      GO TO 320
   30 ISHPTR = SSIL + NSLOLD
      IFILE  = SCSFIL
      CALL READ (*310,*40,SCSFIL,Z(ISHPTR),LCORE,1,LHPTR)
      GO TO 320
   40 CALL SKPFIL (SCSFIL,1)
C
C     COMPUTE NUMBER OF ROWS IN MATRIX
C
      ICODE = Z(SSIL+NSLOLD-1)
      CALL DECODE (ICODE, LISTO, NCOM)
      MCB(3) = Z(SSIL+NSLOLD-2) + NCOM - 1
C
C     READ CONNECTION ENTRIES
C
C     READ TRANSFORMATION MATRIX FOR PSEUDOSTRUCTURE
C
      IFILE = SCR3
      CALL READ (*310,*50,SCR3,TTRAN,37,1,NNN)
   50 CONTINUE
      CALL SKPFIL (SCR3,-1)
      IF (I .NE. 1) CALL SKPFIL (SCR3,1)
      IFILE = SCCONN
      CALL OPEN (*300,SCCONN,Z(BUF3),0)
      IFILE = SCR1
      CALL OPEN (*300,SCR1,Z(BUF4),1)
      CALL WRITE (SCR1,IHEAD,2,1)
      IPNEW = 0
   60 CALL READ (*250,*70,SCCONN,CE,10,1,NNN)
   70 IPNEW  = IPNEW + 1
      LOCIPN = SCORE + 2*(IPNEW-1) + 1
      IF (CE(I+2) .EQ. 0) GO TO 230
      IPOLD  = CE(I+2)
      LOCIPO = SSIL + 2*(IPOLD-1) + 1
      ICODE  = Z(LOCIPN)
      CALL DECODE (ICODE,LISTN,NCN)
      ICODE  = Z(LOCIPO)
      CALL DECODE (ICODE,LISTO,NCO)
C
      IADDH = ISHPTR + IPOLD - 1
      IDH   = Z(IADDH)
      IF (IDH-1) 80,100,120
C
C     IDENTITY MATRIX
C
   80 CONTINUE
      DO 90 I1 = 1,6
      DO 90 I2 = 1,6
      T(I1,I2) = TID(I1,I2)
   90 CONTINUE
      GO TO 160
C
C     TRANS MATRIX
C
  100 CONTINUE
      DO 110 I1 = 1,6
      DO 110 I2 = 1,6
      T(I1,I2) = TTRAN(I1,I2)
  110 CONTINUE
      GO TO 160
C
C     MATRIX DUE TO GTRAN
C
  120 CONTINUE
      IDHM1 = IDH - 1
      DO 130 I1 = 1,IDHM1
      CALL FWDREC (*310,SCR3)
  130 CONTINUE
      CALL READ (*310,*140,SCR3,T,37,1,NNN)
  140 DO 150 I1 = 1,IDH
      CALL BCKREC (SCR3)
  150 CONTINUE
  160 CONTINUE
C
C     DELETE ROWS OF (T) FOR EACH COLD EQUAL TO ZERO
C
      DO 180 J1 = 1,NCO
      IR = LISTO(J1) + 1
      DO 170 J2 = 1,6
      TP(J1,J2) = T(IR,J2)
  170 CONTINUE
  180 CONTINUE
      NROW = NCO
C
C     DELETE COLUMNS OF (T) FOR EACH CNEW EQUAL TO ZERO
C
      DO 200 J1 = 1,NCN
      IC = LISTN(J1) + 1
      DO 190 J2 = 1,NROW
      TPP(J2,J1) = TP(J2,IC)
  190 CONTINUE
  200 CONTINUE
      NCOL = NCN
      DO 220 I1 = 1,NCOL
      DO 210 I2 = 1,NROW
      COLOUT(I2) = TPP(I2,I1)
  210 CONTINUE
      IIII = Z(LOCIPO-1)
      NNNN = IIII + NROW - 1
      CALL PACK (COLOUT,SCR1,MCB)
  220 CONTINUE
      GO TO 60
  230 IIII = 1
      NNNN = 1
      ICODE = Z(LOCIPN)
      CALL DECODE (ICODE,LISTN,NCN)
      DO 240 I1 = 1,NCN
      CALL PACK (ZERO,SCR1,MCB)
  240 CONTINUE
      GO TO 60
  250 CONTINUE
      CALL CLOSE (SCCONN,1)
      CALL WRTTRL (MCB)
      CALL CLOSE (SCR1,1)
      NAM(1) = COMBO(I,1)
      NAM(2) = COMBO(I,2)
      CALL MTRXO (SCR1,NAM,IHEAD(1),Z(BUF4),ITEST)
      CALL SKPFIL (SCR3,1)
  260 CONTINUE
C
      CALL CLOSE (SCSFIL,1)
      CALL CLOSE (SCR3,1)
      CALL CLOSE (IOEFIL,1)
      LCORE = BUFEX + BUF2 - BUF3
      RETURN
C
  300 IMSG = -1
      GO TO 330
  310 IMSG = -2
      GO TO 330
  320 IMSG = -8
  330 CALL MESAGE (IMSG,IFILE,AAA)
      RETURN
      END

      SUBROUTINE UMFZDD
C
C     SUBROUTINE TO INITIALIZE COMMON /UMFZZZ/ USED BY UMFEDT.
C
      INTEGER KT,TID1,TID2,PID1,NO,LL
      LOGICAL AGAIN,T1,T2,END1
      COMMON   /UMFZZZ/ AGAIN,T1,T2,KT,TID1,TID2,PID1,END1,NO,LL
C
      AGAIN = .FALSE.
      T1    = .FALSE.
      T2    = .FALSE.
      KT = 0
      TID1 = -1
      TID2 = -1
      PID1 = -1
      END1  = .FALSE.
      NO = 0
      LL = 0
C
      RETURN
      END

      SUBROUTINE AKP2
C
      COMPLEX AI
C
      COMMON/BLK1/SCRK,SPS,SNS,DSTR,AI,PI,DEL,SIGMA,BETA,RES
C
      GAM=SQRT(DEL**2-SCRK**2)
      S1=SNS*GAM
      C1=(SIGMA-S1)/2.0
      C2=(SIGMA+S1)/2.0
      DGDA=DEL/GAM
      D1=SPS/2.0
      D2=SNS/2.0*DGDA
      DC1DA=D1-D2
      DC2DA=D1+D2
      RES=1.0/GAM*DGDA+SNS*COS(S1)/SIN(S1)*DGDA
     1-COS(C1)/SIN(C1)*DC1DA-COS(C2)/SIN(C2)*DC2DA
      RETURN
      END

      SUBROUTINE SDCMM (Z,MSET,MSZE,MATRIX,USET,GPL,SIL,SUBNAM)
C
C     THIS ROUTINE WRITES THE EXTERNAL ID AND COMPONENT ID FOR VARIOUS
C     MATRIX ERROR CONDITIONS.
C     SCRATCH1 CONTAINS 3 WORDS/ERROR, EACH MESSAGE BEING 1 RECORD
C         WORD 1 = COLUMN * 10 + ERROR CODE
C         WORD 2 = INPUT DIAGONAL
C         WORD 3 = OUTPUT DIAGONAL
C     SUBROUTINE -MXCID- (NON-SUBSTRUCTURING) IS CALLED TO SUPPLY IDENT.
C     DATA FOR EACH COLUMN.  FOR SUBSTRUCTURING -MXCIDS- IS CALLED - IT
C     RETURNS TWO WORDS/COLUMN PLUS THE BCD NAME OF THE SUBSTRUCTURES AT
C     THE START OF CORE.  IN EITHER CASE, THE 1ST WORD IS 10*ID +
C         COMPONENT.
C     THE SCRATCH FILE IS READ AND THE EXTERNAL ID INDEXED DIRECTLY.E
C     NOTE - THAT EACH COLUMN MAY GENERATE MORE THAN 1 MESSAGE.
C     OPEN CORE IS Z(1) TO Z(BUF-1).  TWO BUFFERS FOLLOW Z(BUF)
C
      INTEGER         BUF,BUF2,SIL,EXIT(8),ERR(14),FILMSG,GPID(4),GPL,
     1                IN(3),INER(4),N(7),NAME(2),SUBNAM(2),TYP(6),USET,
     2                Z(1)
      CHARACTER       UFM*23,UWM*25
CWKBNB 8/94
      CHARACTER*4     CTYP(6)
      REAL            XGPID(4), XIN(3)
CWKBNE 8/94
CWKBI  8/94
      EQUIVALENCE     (CTYP,TYP), (XGPID,GPID), (XIN,IN)
      COMMON /XMSSG / UFM,UWM
      COMMON /SDCQ  / NERR(2),NOGLEV,BUF,FILMSG
      COMMON /NAMES / KRD2,KRR0,SKPN(3), KCL2
      COMMON /SYSTEM/ KSYSTM(69)
      EQUIVALENCE     (KSYSTM(1),NBUFSZ),(KSYSTM(2),IOUT),
     1                (KSYSTM(69),ISUBST)
      DATA    ERR   / 4HNULL, 4HCOL., 4HZERO, 4HDIAG, 4HNEG., 4HDIAG,
     1                4HSING, 4HTEST, 4HBAD , 4HCOL., 4HNON-, 4HCONS,
     2                4HZERO, 4HDIAG/
      DATA    INER  / 4HINPU, 2HT   , 4HDECM, 2HP   /
      DATA    EXIT  / 4HCONT, 4HINUE, 4HAT E, 4HND  , 4HAT S, 4HTART,
     1                4HIN D, 4HECMP/
      DATA    NAME  / 4HSDCM, 2HM   /
      DATA    IBLK  / 4H    /
C
      BUF2 = BUF + NBUFSZ
      N(1) = 0
      N(2) = 0
      N(3) = 0
      N(4) = 0
      N(5) = 0
      N(6) = 0
      N(7) = 0
      IF (BUF .LE. 0) GO TO 50
C
C     GENERATE EXTERNAL ID
C
      IF (ISUBST .EQ. 0) GO TO 5
C
C     SUBSTRUCTURING - READ EQSS FILE ON THE SOF
C
C     4 BUFFERS NEEDED
C
      I = BUF - 2*NBUFSZ
      IF (I .LE. 3*MSZE) GO TO 50
      NWDS = 2
      CALL MXCIDS (*50,Z,MSET,MSZE,NWDS,USET,I,SUBNAM)
      NSTART = I - 1
      GO TO  7
C
    5 NSTART = 0
      NWDS   = 1
C
C     2 BUFFERS NEEDED
C
      CALL MXCID (*50,Z,MSET,MSZE,NWDS,USET,GPL,SIL,BUF)
C
    7 CALL OPEN (*110,FILMSG,Z(BUF2),KRR0)
      CALL PAGE2 (3)
      WRITE  (IOUT,10) UWM
   10 FORMAT (A25,' 2377A, MATRIX CONDITIONING ERRORS GIVEN WITH ',
     1       'EXTERNAL ID', /5X,'GID - C  INPUT-DIAG.   DECOMP-DIAG.',
     2       6X,'TYPE',17X,'SUBSTRUCTURE')
C
      ASSIGN 30 TO IRET
      TYP(5) = IBLK
      TYP(6) = IBLK
      IF (ISUBST.NE.0) ASSIGN 27 TO IRET
C
C     LOOP ON MESSAGES - 0 COLUMN IS FLAG TO QUIT
C
   20 CALL FREAD (FILMSG,IN,3,1)
      IF (IN(1) .EQ. 0) GO TO 200
      I = IN(1)/10
      J = IN(1) - I*10
      L = NSTART + I*NWDS
      GPID(1) = Z(L)/10
      GPID(2) = Z(L) - GPID(1)*10
      GPID(3) = IN(2)
      GPID(4) = IN(3)
C
C     INTERNAL FUNCTION
C
   25 CONTINUE
      IF (J.LE.0 .OR. J.GT.7) GO TO 100
      K = 2*J - 1
      TYP(1) = ERR(K)
      TYP(2) = ERR(K+1)
      K = 1
      IF (J.GT.1 .AND. J.LT.7) K = 3
      TYP(3) = INER(K  )
      TYP(4) = INER(K+1)
      N(J) = N(J) + 1
      CALL PAGE2 (2)
      GO TO IRET, (27,30,80)
C
   27 TYP(5) = Z(2*L-1)
      TYP(6) = Z(2*L  )
   30 CONTINUE
CWKBR 8/94      WRITE  (IOUT,40) GPID,TYP
      WRITE ( IOUT, 40 ) GPID(1), GPID(2), XGPID(3), XGPID(4), CTYP
   40 FORMAT (1H0,I9,2H -,I2,1P,2E14.6,3X,2A5,2H/ ,A4,A2,6HMATRIX,2X,
     1        2A4)
      GO TO 20
C
C     INSUFFICIENT CORE IN -MATCID-
C
   50 CALL PAGE2 (3)
      WRITE  (IOUT,60) UWM
   60 FORMAT (A25,' 2377B, MATRIX CONDITIONING ERRORS GIVEN WITH ',
     1       'INTERNAL ID', /,5X,'COLUMN  INPUT DIAG.   DECOMP-DIAG.',
     2       6X,'TYPE')
C
      CALL OPEN (*110,FILMSG,Z(BUF2),KRR0)
      ASSIGN 80 TO IRET
C
C     LOOP
C
   70 CONTINUE
      CALL FREAD (FILMSG,IN,3,1)
      IF (IN(1) .EQ. 0) GO TO 200
      I = IN(1)/10
      J = IN(1) - I*10
      IN(1) = I
      GO TO 25
C
   80 CONTINUE
CWKBR 8/94  WRITE  (IOUT,90) IN,TYP
      WRITE  (IOUT,90) IN(1), XIN(2), XIN(3), CTYP      
   90 FORMAT (1H0,I8,1P,2E14.6,3X,2A5,2H/ ,A4,A2,6HMATRIX,2X,2A4)
      GO TO 70
C
C     ILLEGAL DATA
C
  100 CALL MESAGE (7,FILMSG,NAME)
      GO TO 200
C
C     SCRATCH FILE NOT AVAILABLE
C
  110 CALL MESAGE (1,FILMSG,NAME)
C
C     ALL DONE, SUMMARIZE
C
  200 CALL PAGE2 (11)
      WRITE  (IOUT,210) MATRIX,MSZE,N
  210 FORMAT (1H0,3X,10HFOR MATRIX,I4,6H, SIZE,I8,/I9,13H NULL COLUMNS,
     1 /I9,15H ZERO DIAGONALS, /I9,19H NEGATIVE DIAGONALS, /I9,
     2 31H SINGULARITY TOLERANCE EXCEEDED, /I9,12H BAD COLUMNS, /I9,
     3 24H NONCONSERVATIVE COLUMNS, /I9,23H ZERO DIAGONALS (INPUT))
C
C     CHECK FOR EXIT CONDITIONS
C
      I = 2*NOGLEV + 1
C
C     NOTE - NOGLEV OF 4 ALSO HAS NEGATIVE PARM(1)
C
      IF (NOGLEV .EQ. 4) I = 7
      J = I + 1
      WRITE  (IOUT,220) EXIT(I),EXIT(J)
  220 FORMAT (1H0,3X,13HABORT CODE = ,2A4)
      CALL CLOSE (FILMSG,KCL2)
      RETURN
      END

      SUBROUTINE IFP4C (FILE,SCRT,BUF1,BUF2,EOF)
C
C     THIS ROUTINE, CALLED BY IFP4, OPENS THE 2 FILES AND COPIES THE
C     HEADER RECORD FROM -FILE- TO -SCRT-.
C
      LOGICAL        EOF
      INTEGER        FILE,SCRT,BUF1(10),BUF2(10),WORK(10),FLAG,NAME(2),
     1               NAME2(2),EOR,TRAIL(7)
      COMMON /NAMES/ RD,RDREW,WRT,WRTREW,CLSREW,CLS
      DATA    NAME / 4HIFP4,4HC   /, EOR,NOEOR/1,0/
C
      TRAIL(1) = FILE
      DO 50 I = 2,7
      TRAIL(I) = 0
   50 CONTINUE
      CALL RDTRL (TRAIL)
      DO 70 I = 2,7
      IF (TRAIL(I)) 60,70,60
   70 CONTINUE
      GO TO 1000
   60 CALL OPEN (*1002,FILE,BUF1,RDREW)
      EOF = .FALSE.
      CALL OPEN (*2000,SCRT,BUF2,WRTREW)
   80 CALL READ (*1001,*100,FILE,WORK,10,NOEOR,FLAG)
      CALL WRITE (SCRT,WORK,10,NOEOR)
      GO TO 80
  100 CALL WRITE (SCRT,WORK,FLAG,EOR)
      RETURN
C
C     FILE IS NULL
C
 1000 EOF = .TRUE.
      CALL OPEN (*2000,SCRT,BUF2,WRTREW)
      CALL FNAME (FILE,NAME2)
      CALL WRITE (SCRT,NAME2,2,EOR)
      RETURN
C
 2000 CALL MESAGE (-1,SCRT,NAME)
 1001 CALL MESAGE (-2,FILE,NAME)
 1002 CALL MESAGE (-1,FILE,NAME)
      RETURN
      END

      SUBROUTINE XYPRPT
C
C*****
C
C     DUMMY DECK FOR MODULE XYPRNPLT - SEE USER'S MANUAL SECTION 5.6.
C                                      FOR MODULE PROPERTIES, CHECK
C                                      SUBROUTINE XMPLDD OR USE DIAG 31.
C
C*****
C
C     INTEGER INFILE
C
C     NO PARAMETERS, OUTPUTS OR SCRATCH FILES
C
C     DATA INFILE /101/
C
      RETURN
      END

      SUBROUTINE PLA42
C
C     THIS ROUTINE PROCESSES THE SCRATCH DATA BLOCK ECPTS, WHICH IS THE
C     ECPTNL DATA BLOCK APPENDED WITH THE PROPER DISPLACEMENT VECTOR
C     COMPONENTS, AND CREATES THE STIFFNESS MATRIX KGGNL AND THE UPDATED
C     ECPTNL, ECPTNL1.  ECPTNL1, NAMED ECPTO IN THIS ROUTINE, DOES NOT
C     CONTAIN DISPLACEMENT VECTOR COMPONENTS.
C
      INTEGER         SYSBUF,BUFFR1,BUFFR2,BUFFR3,CSTM,ECPTS,ECPTO,GPCT,
     1                DIT,PLACNT,PLANOS,SETNO,FROWIC,EOR,CLSRW,OUTRW,
     2                BUFFR4,PLSETN,FILE,ECPTOT
      DOUBLE PRECISION DZ,DPWORD,DDDDDD
      DIMENSION       DZ(1),IZ(1),INPVT(2),NAME(2),MCBKGG(7),P(4),
     1                ECPTOT(7),PLANOS(2),IP(4),NWDSP2(40),TUBSAV(16)
      COMMON /BLANK / PLACNT,PLSETN,PLFACT(2)
      COMMON /SYSTEM/ SYSBUF,ISKPU(53),IPREC
      COMMON /CONDAS/ PI,TWOPI,RADEG,DEGRA,S4PISQ
      COMMON /ZZZZZZ/ Z(1)
      COMMON /PLA42S/ XXXXXX(325)
      COMMON /PLA42D/ DDDDDD(300)
      COMMON /PLA42E/ ECPT(100)
      COMMON /PLA42C/ NPVT,GAMMA,GAMMAS,IPASS,ICSTM,NCSTM,IGPCT,NGPCT,
     1                IPOINT,NPOINT,I6X6K,N6X6K,CSTM,MPT,ECPTS,GPCT,
     2                DIT,KGGNL,ECPTO,INRW,OUTRW,EOR,NEOR,CLSRW,JMAX,
     3                FROWIC,LROWIC,NROWSC,NLINKS,NWORDS(40),IOVRLY(40),
     4                LINK(40),NOGO
      COMMON /ZBLPKX/ DPWORD,DUM(2),INDEX
      COMMON /PLA4ES/ WORDES(300)
      COMMON /PLA4UV/ WORDUV(25)
      EQUIVALENCE     (Z(1),IZ(1),DZ(1)) ,(P(1),IP(1))
      DATA    NAME  / 4HPLA4,4H2   /, PLANOS / 1103,  11    /
      DATA    NWDSP2/ 20,   0,  19,   0,   0,
     1                33,   0,   0,  27,  20,
     2                5*0,
     3                32,  27,  32,  38,   0,
     4                13*0,     45,      6*0/
C
C
      DO 5 I = 1,40
    5 IOVRLY(I) = 1
C
C     DETERMINE SIZE OF VARIABLE CORE AND SET UP BUFFERS
C
      IZMAX  = KORSZ(Z)
      BUFFR1 = IZMAX  - SYSBUF
      BUFFR2 = BUFFR1 - SYSBUF
      BUFFR3 = BUFFR2 - SYSBUF
      BUFFR4 = BUFFR3 - SYSBUF
      LEFTT  = BUFFR4 - 1
      IPASS  = PLACNT - 1
      IPR    = IPREC
C
C     READ THE CSTM INTO CORE
C
      FILE  = CSTM
      NCSTM = 0
      ICSTM = 0
      CALL OPEN (*20,CSTM,Z(BUFFR1),INRW)
      CALL SKPREC (CSTM,1)
      CALL READ (*9020,*10,CSTM,Z(ICSTM+1),LEFTT,EOR,NCSTM)
      CALL MESAGE (-8,0,NAME)
   10 LEFTT = LEFTT - NCSTM
C
C     PRETRD SETS UP SUBSEQUENT CALLS TO TRANSD
C
      CALL PRETRD (Z(ICSTM+1),NCSTM)
      CALL PRETRS (Z(ICSTM+1),NCSTM)
      CALL CLOSE  (CSTM,CLSRW)
   20 IMAT = NCSTM
C
C     SEARCH THE MPT FOR THE PLAFACT CARDS.
C
      FILE = MPT
      CALL PRELOC (*9010,Z(BUFFR1-3),MPT)
      CALL LOCATE (*9040,Z(BUFFR1-3),PLANOS,IFLAG)
C
C     FIND THE CORRECT PLA SET NO.
C
   30 CALL FREAD (MPT,SETNO,1,0)
      IF (SETNO .EQ. PLSETN) GO TO 50
   40 CALL FREAD (MPT,NN,1,0)
      IF (NN .EQ. (-1)) GO TO 30
      GO TO 40
C
C     SKIP THE PROPER NO. OF WORDS ON THE PLFACT CARD SO THAT GAMMA AND
C     GAMMAS (GAMMA STAR) WILL BE CORRECTLY COMPUTED.
C
   50 IF (PLACNT .LE. 4) GO TO 60
      CALL FREAD (MPT,0,-(PLACNT-4),0)
   60 NWDSRD = 4
      IF (PLACNT .LT. 4) NWDSRD = PLACNT
      CALL FREAD (MPT,P,NWDSRD,0)
      IF (PLACNT - 3) 70,80,90
   70 GAMMAS = 0.0
      PLFACT(1) = P(2) - P(1)
      GAMMA = PLFACT(1)/P(1)
      GO TO 100
   80 WORD = P(2) - P(1)
      PLFACT(1) = P(3) - P(2)
      GAMMAS = WORD/P(1)
      GAMMA  = PLFACT(1)/WORD
      GO TO 100
   90 WORD = P(3) - P(2)
      PLFACT(1) = P(4) - P(3)
      GAMMAS = WORD/(P(2)-P(1))
      GAMMA  = PLFACT(1)/WORD
  100 PLFACT(2) = 0.0
      CALL CLOSE (MPT,CLSRW)
C
C     CALL PREMAT TO READ MPT AND DIT INTO CORE.  NOTE NEGATIVE FILE NO.
C     FOR DIT TO TRIGGER PLA FLAG IN SUBROUTINE PREMAT.
C
      CALL PREMAT (Z(IMAT+1),Z(IMAT+1),Z(BUFFR1),LEFTT,MATCR,MPT,-DIT)
      LEFTT = LEFTT - MATCR
      IGPCT = NCSTM + MATCR
C
C     OPEN KGGNL, ECPTO, ECPTS, AND GPCT
C
      IFILE = KGGNL
      CALL GOPEN  (KGGNL,Z(BUFFR1),1)
      CALL MAKMCB (MCBKGG,KGGNL,0,6,IPR)
      CALL GOPEN  (ECPTO,Z(BUFFR2),1)
      CALL MAKMCB (ECPTOT,ECPTO,0,0,0)
      CALL GOPEN  (ECPTS,Z(BUFFR3),0)
      CALL GOPEN  (GPCT,Z(BUFFR4),0)
C
C     READ THE FIRST TWO WORDS OF NEXT GPCT RECORD INTO INPVT(1).
C     INPVT(1) IS THE PIVOT POINT.  INPVT(1) .GT. 0 IMPLIES THE PIVOT
C     POINT IS A GRID POINT.  INPVT(1) .LT. 0 IMPLIES THE PIVOT POINT
C     IS A SCALAR POINT.  INPVT(2) IS THE NUMBER OF WORDS IN THE
C     REMAINDER OF THIS RECORD OF THE GPCT.
C
  130 FILE = GPCT
      CALL READ (*1000,*700,GPCT,INPVT(1),2,NEOR,IFLAG)
      NGPCT = INPVT(2)
      CALL FREAD (GPCT,IZ(IGPCT+1),NGPCT,1)
      IF (INPVT(1) .LT. 0) GO TO 700
C
C     FROWIC IS THE FIRST ROW IN CORE. (1 .LE. FROWIC .LE. 6)
C
      FROWIC = 1
C
C     DECREMENT THE AMOUNT OF CORE REMAINING.
C
      LEFT = LEFTT - 2*NGPCT
      IF (LEFT .LE. 0) CALL MESAGE (-8,0,NAME)
      IPOINT = IGPCT + NGPCT
      NPOINT = NGPCT
      I6X6K  = IPOINT + NPOINT
      I6X6K  = (I6X6K - 1)/2 + 2
C
C     CONSTRUCT THE POINTER TABLE, WHICH WILL ENABLE SUBROUTINE PLA4B TO
C     INSERT THE 6 X 6 MATRICES INTO KGGNL.
C
      IZ(IPOINT+1) = 1
      I1 = 1
      I  = IGPCT
      J  = IPOINT + 1
  140 I1 = I1 + 1
      IF (I1 .GT. NGPCT) GO TO 150
      I  = I + 1
      J  = J + 1
      INC= 6
      IF (IZ(I) .LT. 0) INC = 1
      IZ(J) = IZ(J-1) + INC
      GO TO 140
C
C     JMAX = NO. OF COLUMNS OF KGGNL THAT WILL BE GENERATED WITH THE
C     CURRENT GRID POINT.
C
  150 INC   = 5
      ILAST = IGPCT  + NGPCT
      JLAST = IPOINT + NPOINT
      IF (IZ(ILAST) .LT. 0) INC = 0
      JMAX  = IZ(JLAST) + INC
C
C     IF 2*6*JMAX .LT. LEFT, THERE ARE NO SPILL LOGIC PROBLEMS FOR KGGNL
C     SINCE THE WHOLE DOUBLE PRECISION SUBMATRIX OF ORDER 6 X JMAX CAN
C     FIT IN CORE.
C
      ITEMP = 6*JMAX
      IF (2*ITEMP .LT. LEFT) GO TO 170
      NAME(2) = INPVT(1)
      CALL MESAGE (30,85,NAME)
      NROWSC = 3
  160 IF (2*NROWSC*JMAX .LT. LEFT) GO TO 180
      NROWSC = NROWSC - 1
      IF (NROWSC .EQ. 0) CALL MESAGE (-8,0,NAME)
      GO TO 160
  170 NROWSC = 6
C
C     LROWIC IS THE LAST ROW IN CORE. (1 .LE. LROWIC .LE. 6)
C
  180 LROWIC = FROWIC + NROWSC - 1
C
C     ZERO OUT THE KGGD SUBMATRIX IN CORE.
C
  185 LOW = I6X6K + 1
      LIM = I6X6K + JMAX*NROWSC
      DO 190 I = LOW,LIM
  190 DZ(I) = 0.0D0
C
C     INITIALIZE THE LINK VECTOR TO -1.
C
      DO 200 I = 1,NLINKS
  200 LINK(I) = -1
C
C     TURN FIRST PASS INDICATOR ON.
C
      IFIRST = 1
C
C     READ THE 1ST WORD OF THE ECPT RECORD, THE PIVOT POINT, INTO NPVT.
C     IF NPVT .LT. 0, THE REMAINDER OF THE ECPT RECORD IS NULL SO THAT
C     1 OR 6 NULL COLUMNS MUST BE GENERATED
C
      FILE = ECPTS
      CALL FREAD (ECPTS,NPVT,1,0)
      IF (NPVT .LT. 0) GO TO 700
C
C     WRITE PIVOT POINT ON ECPTNL1 (ECPTO)
C
      CALL WRITE (ECPTO,NPVT,1,NEOR)
C
C     READ THE NEXT ELEMENT TYPE INTO THE CELL ITYPE.
C
  220 CALL READ (*9020,*500,ECPTS,ITYPE,1,NEOR,IFLAG)
C
C     READ THE ECPT ENTRY FOR THE CURRENT TYPE INTO THE ECPT ARRAY. THE
C     NUMBER OF WORDS TO BE READ WILL BE NWORDS(ITYPE).
C
      IF (NWORDS(ITYPE) .LE. 0) CALL MESAGE (-30,61,NAME)
      CALL FREAD (ECPTS,ECPT,NWORDS(ITYPE),0)
      ITEMP = IOVRLY(ITYPE)
C
C     IF THIS IS THE 1ST ELEMENT READ ON THE CURRENT PASS OF THE ECPT
C     CHECK TO SEE IF THIS ELEMENT IS IN A LINK THAT HAS ALREADY BEEN
C     PROCESSED.
C
      IF (IFIRST .EQ. 1) GO TO 230
C
C     THIS IS NOT THE FIRST PASS.  IF ITYPE(TH) ELEMENT ROUTINE IS IN
C     CORE, PROCESS IT.
C
      IF (ITEMP .EQ. LINCOR) GO TO 235
C
C     THE ITYPE(TH) ELEMENT ROUTINE IS NOT IN CORE.  IF THIS ELEMENT
C     ROUTINE IS IN A LINK THAT ALREADY HAS BEEN PROCESSED READ THE NEXT
C     ELEMENT.
C
      IF (LINK(ITEMP) .EQ. 1) GO TO 220
C
C     SET A TO BE PROCESSED LATER FLAG FOR THE LINK IN WHICH THE ELEMENT
C     RESIDES
C
      LINK(ITEMP) = 0
      GO TO 220
C
C     SINCE THIS IS THE FIRST ELEMENT TYPE TO BE PROCESSED ON THIS PASS
C     OF THE ECPT RECORD, A CHECK MUST BE MADE TO SEE IF THIS ELEMENT
C     IS IN A LINK THAT HAS ALREADY BEEN PROCESSED.  IF IT IS SUCH AN
C     ELEMENT, WE KEEP IFIRST = 1 AND READ THE NEXT ELEMENT.
C
  230 IF (LINK(ITEMP) .EQ. 1) GO TO 220
C
C     SET THE CURRENT LINK IN CORE = ITEMP AND IFIRST = 0
C
      LINCOR = ITEMP
      IFIRST = 0
C
C     CALL THE PROPER ELEMENT ROUTINE.
C
C                     ROD      BEAM      TUBE     SHEAR     TWIST
C                       1         2         3         4         5
  235 GO TO   (       240,      999,      250,      999,      999,
C                   TRIA1     TRBSC     TRPLT     TRMEM    CONROD
C                       6         7         8         9        10
     1                260,      999,      999,      270,      240,
C                   ELAS1     ELAS2     ELAS3     ELAS4     QDPLT
C                      11        12        13        14        15
     2                999,      999,      999,      999,      999,
C                   QDMEM     TRIA2     QUAD2     QUAD1     DAMP1
C                      16        17        18        19        20
     3                280,      290,      300,      310,      999,
C                   DAMP2     DAMP3     DAMP4      VISC     MASS1
C                      21        22        23        24        25
     4                999,      999,      999,      999,      999,
C                   MASS2     MASS3     MASS4     CONM1     CONM2
C                      26        27        28        29        30
     5                999,      999,      999,      999,      999,
C                  PLOTEL     REACT     QUAD3       BAR      CONE
C                      31        32        33        34        35
     6                999,      999,      999,      320,      999,
C                   TRIARG    TRAPRG    CTORDRG    CORE      CAP
C                      36        37        38        39        40
     7                999,      999,      999,      999,     999),ITYPE
C
C     ROD, CONROD
C
  240 CALL PKROD
C
C     IF THE ELEMENT IS A TUBE, RESTORE THE SAVED ECPTNL ENTRY AND STORE
C     THE UPDATED VARIABLES IN PROPER SLOTS.
C
      IF (ITYPE .NE. 3) GO TO 400
      DO 245 I = 1,16
  245 ECPT(I)  = TUBSAV(I)
      ECPT(17) = ECPT(18)
      ECPT(18) = ECPT(19)
      ECPT(19) = ECPT(20)
      GO TO 400
C
C     THIS IS A TUBE ELEMENT.  REARRANGE THE ECPT FOR THE TUBE SO THAT
C     IT IS IDENTICAL TO THE ONE FOR THE ROD.
C
C     SAVE THE ECPT ENTRY FOR THE TUBE EXCEPT FOR THE 3 WORDS WHICH WILL
C     BE UPDATED BY THE PKROD ROUTINE AND THE TRANSLATIONAL COMPONENTS
C     OF THE DISPLACEMENTS VECTORS.
C
  250 DO 255 I = 1,16
  255 TUBSAV(I) = ECPT(I)
C
C     COMPUTE AREA, TORSIONAL INERTIA TERM AND STRESS COEFFICIENT.
C
      D = ECPT(5)
      T = ECPT(6)
      DMT = D - T
      A = DMT*T*PI
      FJ= .25*A*(DMT**2 + T**2)
      C = D/2.0
C
C     MOVE THE END OF THE ECPT ARRAY DOWN ONE SLOT SO THAT ENTRIES 7
C     THROUGH  25 WILL BE MOVED TO POSITIONS 8 THROUGH 26.
C
      M = 26
      DO 257 I = 1,19
      ECPT(M) = ECPT(M-1)
  257 M = M - 1
      ECPT(5) = A
      ECPT(6) = FJ
      ECPT(7) = C
      GO TO 240
C
C     TRIA1
C
  260 CALL PKTRI1
      GO TO 400
C
C     TRMEM
C
  270 CALL PKTRM
      GO TO 400
C
C     QDMEM
C
  280 CALL PKQDM
      GO TO 400
C
C     TRIA2
C
  290 CALL PKTRI2
      GO TO 400
C
C     QUAD2
C
  300 CALL PKQAD2
      GO TO 400
C
C     QUAD1
C
  310 CALL PKQAD1
      GO TO 400
C
C     BAR
C
  320 CALL PKBAR
C
C     WRITE ELEMENT TYPE AND UPDATED ECPT ENTRY ONTO ECPTNL1 (ECPTO)
C
  400 CALL WRITE (ECPTO,ITYPE,1,NEOR)
      CALL WRITE (ECPTO,ECPT,NWDSP2(ITYPE),NEOR)
      ECPTOT(2) = ECPTOT(2) + 1
      GO TO 220
C
C     AT STATEMENT NO. 500 WE HAVE HIT AN EOR ON THE ECPT FILE.  SEARCH
C     THE LINK VECTOR TO DETERMINE IF THERE ARE LINKS TO BE PROCESSED.
C
  500 LINK(LINCOR) = 1
      DO  510 I = 1,NLINKS
      IF (LINK(I) .EQ. 0) GO TO 520
  510 CONTINUE
      GO TO 525
C
C     SINCE AT LEAST ONE LINK HAS NOT BEEN PROCESSED THE ECPT FILE MUST
C     BE BACKSPACED.
C
  520 CALL BCKREC (ECPTS)
      GO TO 150
  525 IF (NOGO .EQ. 1) CALL MESAGE (-61,0,0)
C
C     AT THIS POINT BLDPK THE NUMBER OF ROWS IN CORE ONTO THE KGGNL FILE
C
      I1 = 0
  540 I2 = 0
      IBEG = I6X6K + I1*JMAX
      CALL BLDPK (2,IPR,IFILE,0,0)
  550 I2 = I2 + 1
      IF (I2 .GT. NGPCT) GO TO 570
      JJ = IGPCT + I2
      INDEX = IABS(IZ(JJ)) - 1
      LIM = 6
      IF (IZ(JJ) .LT. 0) LIM = 1
      JJJ = IPOINT + I2
      KKK = IBEG + IZ(JJJ) - 1
      I3  = 0
  560 I3  = I3 + 1
      IF (I3 .GT. LIM) GO TO 550
      INDEX = INDEX + 1
      KKK = KKK + 1
      DPWORD = DZ(KKK)
      IF (DPWORD .NE. 0.0D0) CALL ZBLPKI
      GO TO 560
  570 CALL BLDPKN (IFILE,0,MCBKGG)
      I1 = I1 + 1
      IF (I1 .LT. NROWSC) GO TO 540
C
C     WRITE AN EOR ON ECPTO
C
      CALL WRITE (ECPTO,0,0,EOR)
C
C     TEST TO SEE IF THE LAST ROW IN CORE, LROWIC, = THE TOTAL NO. OF
C     ROWS TO BE COMPUTED = 6.  IF IT IS, WE ARE DONE.  IF NOT, THE
C     ECPTS MUST BE BACKSPACED.
C
      IF (LROWIC .EQ. 6) GO TO 130
      CALL BCKREC (ECPTS)
      FROWIC = FROWIC + NROWSC
      LROWIC = LROWIC + NROWSC
      GO TO 185
  700 IF (NOGO .EQ. 1) CALL MESAGE (-61,0,0)
C
C     HERE WE HAVE A PIVOT POINT WITH NO ELEMENTS CONNECTED, SO THAT
C     NULL COLUMNS MUST BE OUTPUT ON THE KGGD FILE.
C
      FILE = ECPTS
      LIM  = 6
      IF (INPVT(1) .LT. 0) LIM = 1
      DO 710 I = 1,LIM
      CALL BLDPK  (2,IPR,IFILE,0,0)
  710 CALL BLDPKN (KGGNL,0,MCBKGG)
      CALL SKPREC (ECPTS,1)
C
C     WRITE PIVOT POINT ON ECPTO
C
      CALL WRITE (ECPTO,NPVT,1,EOR)
      GO TO 130
C
C     CHECK NOGO FLAG. IF NOGO = 1, TERMINATE EXECUTION
C
 1000 IF (NOGO .EQ. 1) CALL MESAGE (-61,0,0)
C
C     WRAP UP BEFORE RETURN
C
      CALL CLOSE (ECPTS,CLSRW)
      CALL CLOSE (ECPTO,CLSRW)
      CALL CLOSE (GPCT,CLSRW)
      CALL CLOSE (KGGNL,CLSRW)
      MCBKGG(3) = MCBKGG(2)
      CALL WRTTRL (MCBKGG)
      CALL WRTTRL (ECPTOT)
      RETURN
C
C     ERROR RETURNS
C
 9010 CALL MESAGE (-1,FILE,NAME)
 9020 CALL MESAGE (-2,FILE,NAME)
 9040 CALL MESAGE (-4,FILE,NAME)
  999 CALL MESAGE (-30,92,ITYPE)
      RETURN
      END

      SUBROUTINE MATCK (MFILE,PFILE,A,Z)
C
C     THIS ROUTINE CHECKS THE UNIQUENESS OF MATERIAL ID'S FOR
C          1. MAT1 (1)     8. MATT1  (MB)  15. MATS1  (MC)
C          2. MAT2         9. MATT2        16. MATPZ1 (MD)
C          3. MAT3        10. MATT3        17. MTTPZ1
C          4. MAT4        11. MATT4        18. MATPZ2
C          5. MAT5        12. MATT5        19. MTTPZ2 (ME)
C          6. MAT6        13. MATT6        20. DUMC
C          7. MAT8 (MA)   14. DUMB         21. DUMD  (NMAT)
C     AND THE MATERIAL ID SPECIFIED ON THE PROPERTY CARDS.
C
C     THIS ROUTINE SHOULD BE CALLED ONLY ONCE BY IFP.
C     THIS ROUTINE DOES NOT OPEN OR CLOSE MATERIAL FILE (MFILE) OR
C     ELEMENT PROPERTY FILE (PFILE)
C
C     WRITTEN BY G.CHAN/UNISYS,  OCT. 1982
C
      LOGICAL         ABORT
      INTEGER         PFILE,    IH(3),    NAME(2),  Z(1),     MATI(2,22)
     1,               GROUP,    A(1),     EPTI(2,40),         MATJ(2,22)
      COMMON /SYSTEM/ N1,       NOUT,     ABORT,    SKIP(42), KDUM(9)
      DATA    MATJ  / 103,-12,  203,-17,  1403,-16, 2103,-3,  2203,-8,
     1               2503,-31,  603,-18,
     2                703,-11,  803,-16,  1503,-16, 2303,-2,  2403,-7,
     3               2603,-31,  -11,-00,
     4                503,-11, 1603,-07,  1803,-07, 1703,-44, 1903,-44,
     5                -11,-00,  -11,-00,   -11,-00/
      DATA    EPTI  /  52,191, 2502,071,  7002,071, 0502,041, 2202,041,
     1               5302,041, 0602,082,  0702,103, 0802,041, 0902,061,
     2               1002,041, 2102,041,  7052,171, 1102,082, 1202,103,
     3               1302,041, 7032,171,  1402,041, 1502,082, 1602,051,
     4               1702,041, 2002,031,  0152,243, 5102,241, 5802,174,
     5               5502,-49, 5602,-06,  5702,-06, 6102,001, 6202,001,
     6               6302,001, 6402,001,  6502,001, 6602,001, 6702,001,
     7               6802,001, 6902,001,     0,  0,    0,  0,    0,  0/
      DATA    NMAT  / 21/,      GROUP/ 7/
      DATA    NEPT  / 37/
      DATA    NAME  / 4HMATC,   4HK     /
C
C     FIRST WORDS ON THE EPTI TABLE ARE PROPERTY CARDS THAT SPECIFY
C     MATERIAL.  THE FIRST 2 DIGITS OF THE SECOND WORD INDICATE THE
C     NUMBER OF WORDS IN EACH PROPERTY INPUT CARD. AND THE 3RD DIGIT
C     INDICATES NUMBER OF MATERIAL ID'S SPECIFIED.
C     IF THIS SECOND WORD IS NEGATIVE, IT MEANS THE PROPERTY CARD IS
C     OPEN-ENDED. THE 3RD DIGIT INDICATES WHERE MID1 BEGINS, AND
C     REPEATING (FOR MID2, MID3,...) EVERY N WORDS WHERE N IS THE
C     ABSOLUTE VALUE OF THE FIRST 2 DIGITS. (NO REPEAT OF N=0)
C
C     ARRAY A CONTAINS A LIST OF ACTIVE PROPERTY IDS - SET UP BY PIDCK
C
      IF (ABORT) GO TO 220
      NOMAT = Z(1)
      IF (NOMAT .EQ. 0) GO TO 145
C
C     UPDATE EPTI ARRAY IF DUMMY ELEMENT IS PRESENT
C
      DO 10 J = 1,9
      IF (KDUM(J) .EQ. 0) GO TO 10
      K = MOD(KDUM(J),1000)/10
      EPTI(2,28+J) = K*10 + 1
 10   CONTINUE
C
C     SET UP POINTERS FOR THE MATI TABLE
C
      MA = GROUP
      MB = MA + 1
      MC = MB + GROUP
      MD = MC + 1
      ME = MC + 4
C
C     READ MATERIAL ID INTO Z SPACE, AND SAVE APPROP. COUNT IN MATI(2,K)
C
      DO 15 J = 1,NMAT
      MATI(1,J) = MATJ(1,J)
 15   MATI(2,J) = MATJ(2,J)
      J = 1
 20   CALL FWDREC (*50,MFILE)
 25   CALL READ (*50,*50,MFILE,IH(1),3,0,KK)
      DO 30 K = 1,NMAT
      IF (IH(1) .EQ. MATI(1,K)) GO TO 35
 30   CONTINUE
      GO TO 20
 35   NWDS =-MATI(2,K)
      IF (NWDS .LT. 0) CALL MESAGE (-37,0,NAME)
      MATI(2,K) = 0
 40   CALL READ (*50,*25,MFILE,Z(J),NWDS,0,KK)
      J = J + 1
      MATI(2,K) = MATI(2,K) + 1
      GO TO 40
C
C     INSTALL INITIAL COUNTERS IN MATI(1,K)
C
 50   JX = J
      IF (JX .LE. 1) GO TO 140
      MATI(1,1) = 0
      DO 60 J = 1,NMAT
      K = J + 1
      IF (MATI(2,J) .LT. 0) MATI(2,J) = 0
 60   MATI(1,K) = MATI(1,J) + MATI(2,J)
C
C     NOTE - ORIGINAL DATA IN MATI TABLE IS NOW DESTROYED
C
C     CHECK MATERIAL ID UNIQUENESS AMONG MAT1, MAT2,..., MAT8
C     (MAT4 AND MAT5 ARE UNIQUE ONLY AMONG THEMSELVES)
C
      J = 0
      DO 70 K = 1,MA
      IF (MATI(2,K) .GT. 0) J = J + 1
 70   CONTINUE
      IF (J .LE. 1) GO TO 90
      KK = MATI(1,MB)
      K1 = KK - 1
      K4 = MATI(1,4)
      DO 80 K = 1,K1
      J  = Z(K)
      IB = K + 1
      DO 75 I = IB,K1
      IF (J .NE. Z(I)) GO TO 75
      IF (K.LT.K4 .AND. I.GE.K4) GO TO 75
      CALL MESAGE (30,213,J)
      ABORT =.TRUE.
      GO TO 80
 75   CONTINUE
 80   CONTINUE
C
C     CHECK MATT1, MATT2,..., MATT6 AND MATS1 MATERIAL ID
C     AND THEIR CROSS REFERENCE TO MATI CARDS
C
 90   DO 110 K = MB,MC
      IF (MATI(2,K) .LE. 0) GO TO 110
      KK = MOD(K,MA)
      IB = MATI(1,KK) + 1
      IE = MATI(2,KK) + IB - 1
      JB = MATI(1,K ) + 1
      JE = MATI(2,K ) + JB - 1
      DO 105 J = JB,JE
      K1 = Z(J)
      IF (IE .LT. IB) GO TO 100
      DO 95 I = IB,IE
      IF (Z(I) .EQ. K1) GO TO 105
 95   CONTINUE
 100  IH(1) = K1
      IH(2) = KK
      K1 = 217
      IF (K .EQ. 15) K1 = 17
      CALL MESAGE (30,K1,IH)
      ABORT =.TRUE.
 105  CONTINUE
 110  CONTINUE
C
C     CHECK MATERIAL ID UNIQUENESS AMONG MATPZI AND MTTPZI
C
      J = 0
      DO 115 K = MD,ME
      IF (MATI(2,K) .GT. 0) J = J + 1
 115  CONTINUE
      IF (J .LE. 1) GO TO 140
      KK = MATI(1,ME+1)
      K1 = KK - 1
      NN = MATI(1,MD)
      DO 130 K = NN,K1
      J  = Z(K)
      IB = K + 1
      DO 125 I = IB,KK
      IF (J .NE. Z(I)) GO TO 125
      CALL MESAGE (30,213,J)
      ABORT =.TRUE.
      GO TO 130
 125  CONTINUE
 130  CONTINUE
C
C     NOW, WE CONTINUE TO CHECK MATERIAL ID'S ON MOST PROPERTY CARDS.
C     (MATERIAL ID'S ARE ON THE 2ND, 4TH, AND 6TH POSITIONS OF THE
C     PROPERTY CARDS, EXECPT THE OPEN-ENDED PCOMPI GROUP)
C
 140  JE = MATI(1,NMAT)
      II = A(1)
 145  CALL FWDREC (*220,PFILE)
 150  CALL READ (*220,*220,PFILE,IH(1),3,0,KK)
      DO 160 K = 1,NEPT
      IF (IH(1) .EQ. EPTI(1,K)) GO TO 170
 160  CONTINUE
      GO TO 145
 170  IF (NOMAT .EQ. 0) GO TO 230
      NWDS= EPTI(2,K)/10
      NN  = EPTI(2,K) - NWDS*10
      IB  = 1
      IE  = NN*2
      IC  = 2
      KOMP= 0
C
C     CHANGE NWDS, IB, IE, AND IC IF PROPERTY CARD IS OPEN-ENDED
C     WHERE (IB+JX) POINTS TO THE FIRST MID POSITION
C
      IF (EPTI(2,K) .GT. 0) GO TO 180
      KOMP= 1
      IB  =-NN - 1
      IC  =-NWDS
      IF (NWDS .EQ. 0) IC = 9999
      NWDS= 10
 180  IF (KOMP .EQ. 1) IE = JX + NWDS - 1
C
C     READ IN PROPERTY CARD. IF ID IS NOT ON ACTIVE LIST, SKIP IT.
C     SKIP IT TOO IF IT HAS NO MATERIAL ID REQUESTED.
C     (NO CORE SIZE CHECK HERE. SHOULD HAVE PLENTY AVAILABLE)
C
      CALL READ (*220,*150,PFILE,Z(JX),NWDS,0,KK)
      IF (KOMP .EQ. 0) GO TO 182
 181  IE = IE + 1
      CALL READ (*220,*150,PFILE,Z(IE),1,0,KK)
      IF (Z(IE) .NE. -1) GO TO 181
      IE = IE - 1 - JX
 182  DO 183 I = 2,II
      IF (Z(JX) .EQ. A(I)) GO TO 185
 183  CONTINUE
      GO TO 180
 185  DO 210 I = IB,IE,IC
      KK = Z(JX+I)
      IF (IE.EQ.8 .AND. I.EQ.7) KK = Z(JX+I+3)
      IF (KK .EQ. 0) GO TO 210
      IF (JX .LE. 1) GO TO 200
      DO 190 J = 1,JE
      IF (KK .EQ. Z(J)) GO TO 210
 190  CONTINUE
 200  IH(1) = KK
      IH(2) = Z(JX)
      CALL MESAGE (30,215,IH)
      ABORT =.TRUE.
 210  CONTINUE
      GO TO 180
 220  RETURN
C
 230  CALL MESAGE (30,16,IH)
      ABORT =.TRUE.
      RETURN
      END

      SUBROUTINE RCOVO
C
C     RCOVO READS THE CASESS RECOVER RECORD AND PROCESSES ANY
C     OUTPUT REQUESTS FOR THE CURRENT SAVE OR PRINT REQUEST
C
C     THE OUTPUT REQUESTS ARE STORED AT THE BOTTOM OF OPEN CORE IN
C     A TABLE WITH THE FOLLOWING FORM
C
C     BUF(IREQ) -  UVEC  -I
C                  PVEC   I- NONZERO IF ANY REQUEST PRESENT
C                  QVEC  -I
C                  NO. OF POINTS
C                  NO. OF BASICS
C                  BASIC NAME(2) -I
C                  DISP SET       I
C                  OLOAD SET      I
C                  SPCF SET       I - REPEATED FOR EACH BASIC
C                  SUBCASES SET   I   SUBSTRUCTURE
C                  MODES SET      I
C                  RANGE(2)       I
C                  VELO SET       I
C                  ACCE SET       I
C                  STEPS SET      I
C                  GRID OR MODAL -I
C
      EXTERNAL        LSHIFT     ,ANDF
      LOGICAL         BASIC      ,MRECVR
      INTEGER         RSS        ,BUF(1)     ,STEP       ,CASESS     ,
     1                EQSS       ,Z          ,BUF1       ,SYSBUF     ,
     2                SOF1       ,SOF2       ,SOF3       ,RECOVR     ,
     3                SAVE       ,PRINT      ,SRD        ,FSS(2)     ,
     4                RD         ,SUBNAM(2)  ,RDREW      ,WRT        ,
     5                WRTREW     ,REW        ,NOREW      ,RC         ,
     6                REC(3)     ,SUBC       ,SUBS       ,MODE       ,
     7                ALL        ,NONE       ,COMDS(13)  ,ENERGY     ,
     8                UIMPRO     ,RFNO       ,TIME       ,FREQ       ,
     9                ANDF       ,MRECOV
      REAL            RBUF(1)    ,RREC(3)
      CHARACTER       UFM*23     ,UWM*25     ,UIM*29     ,SFM*25     ,
     1                SWM*27
      COMMON /XMSSG / UFM        ,UWM        ,UIM        ,SFM        ,
     1                SWM
      COMMON /BLANK / DRY        ,LOOP       ,STEP       ,FSS        ,
     1                RFNO       ,NEIGV      ,LUI        ,UINMS(2,5) ,
     2                NOSORT     ,UTHRES     ,PTHRES     ,QTHRES
      COMMON /RCOVCR/ ICORE      ,LCORE      ,BUF1       ,BUF2       ,
     1                BUF3       ,BUF4       ,SOF1       ,SOF2       ,
     2                SOF3
      COMMON /RCOVCM/ MRECVR     ,UA         ,PA         ,QA         ,
     1                IOPT       ,RSS(2)     ,ENERGY     ,UIMPRO     ,
     2                RANG(2)    ,IREQ       ,LREQ       ,LBASIC
      COMMON /ZZZZZZ/ Z(1)
      COMMON /SYSTEM/ SYSBUF     ,NOUT
      COMMON /NAMES / RD         ,RDREW      ,WRT        ,WRTREW     ,
     1                REW        ,NOREW      ,EOFNRW
      EQUIVALENCE     (BUF(1)    ,Z(1))
      EQUIVALENCE     (BUF(1)    ,RBUF(1))   ,(REC(1)    ,RREC(1))   ,
     1                (ISET      ,RSET)
      DATA   CASESS / 101   /, SUBNAM / 4HRCOV,4HO   /
      DATA   EQSS   / 4HEQSS/
      DATA   RECOVR / 4HRECO/, MRECOV / 4HMREC       /
      DATA   PRINT  / 4HPRIN/, SAVE   / 4HSAVE       /
      DATA   SRD    / 1     /
      DATA   LL     / 2     /
      DATA   NCOMDS / 13    /
      DATA   COMDS  / 4HDISP,4HOLOA,4HSPCF,4HMODE,4HRANG,4HSUBC,4HSORT,
     1                4HBASI,4HVELO,4HACCE,4HENER,4HUIMP,4HSTEP       /
      DATA   SUBC   , SUBS,   MODE,   ALL,    NONE,   TIME,   FREQ    /
     1       4HSUBC , 4HSUBS, 4HMODE, 4HALL , 4HNONE, 4HTIME, 4HFREQ  /
C
C     SET UP BUFFERS
C
      SOF1  = 1
      SOF2  = SOF1 + SYSBUF
      SOF3  = SOF2 + SYSBUF + 1
      BUF1  = SOF3 + SYSBUF
      ICORE = BUF1 + SYSBUF
      LCORE = KORSZ(Z(1)) - ICORE + 1
      IF (LCORE .LE. 0) GO TO 9008
C
C     FIND RECOVER RECORD IN CASESS
C
      CALL GOPEN (CASESS,Z(BUF1),RDREW)
      IF (STEP .EQ. 1) GO TO 20
      DO 10 I = 2,STEP
   10 CALL FWDREC (*9002,CASESS)
   20 CALL FREAD (CASESS,REC,2,0)
      IF (REC(1).NE.RECOVR .AND. REC(1).NE.MRECOV) GO TO 6305
      MRECVR = .FALSE.
      IF (REC(1) .EQ. MRECOV) MRECVR = .TRUE.
C
C     GET PRINT OR SAVE OPTION FOR THIS PASS
C
      I = 0
   30 CALL READ (*9002,*600,CASESS,REC,3,0,NWDS)
      IF (REC(1).NE.PRINT .AND. REC(1).NE.SAVE) GO TO 30
      IF (LOOP .EQ. I) GO TO 40
      I = I + 1
      GO TO 30
C
C     GET NAME OF SUBSTRUCTURE TO BE OPERATED ON
C
   40 RSS(1) = REC(2)
      RSS(2) = REC(3)
      LOOP   = LOOP + 1
      IF (REC(1) .EQ. SAVE) GO TO 700
      IOPT   = 1
C
C     OPEN SOF AND FETCH EQSS FOR SUBSTRUCTURE TO BE PRINTED
C
C
      CALL SOFOPN (Z(SOF1),Z(SOF2),Z(SOF3))
      CALL SFETCH (RSS,EQSS,SRD,RC)
      GO TO (60,50,50,6306,50), RC
C
C     FETCH ON EQSS WAS UNSUCCESSFUL
C
   50 IF (RC .EQ. 2) RC = 3
      CALL SMSG (RC-2,EQSS,RSS)
      GO TO 800
C
C     READ GROUP 0 OF EQSS INTO CORE
C
   60 CALL SUREAD (Z(ICORE),LCORE,NWDS,RC)
      GO TO (9008,65,62,800), RC
   62 CALL SMSG (7,EQSS,RSS)
      GO TO 800
C
C     DETERMINE SIZE OF OUTPUT REQUEST BLOCK AND ALLOCATE SPACE
C     AT BOTTOM OF OPEN CORE
C
   65 NBS  = Z(ICORE+2)
      NP   = Z(ICORE+3)
      LBASIC = 13
      LREQ = 5 + LBASIC*NBS + 2
      IF (LREQ .GT. LCORE-NWDS) GO TO 9008
      NREQ = KORSZ (BUF(1))
      IREQ = NREQ - LREQ + 1
      DO 70 I = IREQ,NREQ
   70 BUF(I) = 0
C
C     MOVE NAMES OF BASICS INTO OUTPUT AREA
C
      BUF(IREQ+3) = NP
      BUF(IREQ+4) = NBS
      DO 80 I = 1,NBS
      I1 = IREQ  + (I-1)*LBASIC + 5
      I2 = ICORE + (I-1)*2+4
      BUF(I1  ) = Z(I2  )
   80 BUF(I1+1) = Z(I2+1)
C
C     INSERT DEFAULTS INTO OUTPUT BLOCK
C
C     MODES    = ALL
C     SUBCASES = ALL
C     RANGE    = -1.0E+35,1.0E+35
C     STEPS    = ALL
C
      ENERGY  = 0
      UIMPRO  = 0
      RANG(1) = -1.0E+35
      RANG(2) =  1.0E+35
      BUF(IREQ  ) = -2
      BUF(IREQ+1) = -2
      BUF(IREQ+2) = -2
      DO 85 I = 1,NBS
      I1 = IREQ + (I-1)*LBASIC + 5
      BUF(I1+ 2) = -2
      BUF(I1+ 3) = -2
      BUF(I1+ 4) = -2
      BUF(I1+ 5) = -1
      BUF(I1+ 6) = -1
      RBUF(I1+7) = -1.0E+35
      RBUF(I1+8) =  1.0E+35
      BUF(I1+ 9) = -2
      BUF(I1+10) = -2
   85 BUF(I1+11) = -1
C
C     READ NEXT COMMAND AND PROCESS OUTPUT REQUEST
C
      NSS1   = 1
      NSS2   = NBS
      IRANGE = 0
      BASIC  = .FALSE.
   90 CALL READ (*9002,*500,CASESS,REC,3,0,NWDS)
      IF (REC(1).EQ.PRINT .OR. REC(1).EQ.SAVE) GO TO 510
      DO 100 I = 1,NCOMDS
      IF (REC(1) .EQ. COMDS(I)) GO TO 110
  100 CONTINUE
      GO TO 90
  110 CONTINUE
      GO TO (120,130,140,150,160,165,170,190,230,240,250,260,270), I
C
C     DISP REQUEST
C
  120 IF (REC(2) .NE. NONE) BUF(IREQ) = 1
      ILOC = 2
      GO TO 400
C
C     OLOAD REQUEST
C
  130 IF (REC(2) .NE. NONE) BUF(IREQ+1) = 1
      IF (REC(2).EQ.NONE .AND. .NOT.BASIC) BUF(IREQ+1) = 0
      ILOC = 3
      GO TO 400
C
C     SPCF REQUEST
C
  140 IF (REC(2) .NE. NONE) BUF(IREQ+2) = 1
      IF (REC(2).EQ.NONE .AND. .NOT.BASIC) BUF(IREQ+2) = 0
      ILOC = 4
      GO TO 400
C
C     MODES REQUEST
C
  150 ILOC = 6
      GO TO 400
C
C     RANGE REQUEST (IF BEFORE A BASIC COMMAND SAVE IT FOR ENERGY
C                    PROCESSING ALSO)
C
  160 ILOC = 7
      IF (MOD(IRANGE,2) .EQ. 1) ILOC = 8
      IRANGE = IRANGE + 1
      IF (REC(2).NE.-2 .AND. REC(3).NE.0) GO TO 450
      IF (BASIC) GO TO 410
      RANG(ILOC-6) = RREC(3)
      GO TO 410
C
C     SUBCASES REQUEST
C
  165 ILOC = 5
      GO TO 400
C
C     SORT COMMAND - IGNORE COMMAND IF AFTER A BASIC DESIGNATOR
C
  170 IF (BASIC) GO TO 180
      I = 0
      IF (REC(2) .EQ. SUBC) I = 1
      IF (REC(2) .EQ. SUBS) I = 2
      IF (REC(2) .EQ. MODE) I = 1
      IF (REC(2) .EQ. TIME) I = 1
      IF (REC(2) .EQ. FREQ) I = 1
      IF (I .EQ. 0) GO TO 450
      IOPT = I
      GO TO 90
  180 WRITE (NOUT,63660) UWM
      GO TO 90
C
C     BASIC COMMAND - VERIFY SUBSTRUCTURE NAME
C
  190 DO 200 I = 1,NBS
      I1 = IREQ + (I-1)*LBASIC + 5
      IF (BUF(I1).EQ.REC(2) .AND. BUF(I1+1).EQ.REC(3)) GO TO 210
  200 CONTINUE
      GO TO 220
  210 NSS1  = I
      NSS2  = I
      BASIC = .TRUE.
      GO TO 90
C
C     NAME NOT A BASIC - SKIP TO NEXT BASIC, PRINT OR SAVE COMMAND
C
  220 WRITE (NOUT,63680) UWM,REC(2),REC(3),RSS
  225 CALL READ (*9002,*500,CASESS,REC,3,0,NWDS)
      IF (REC(1).EQ.PRINT .OR. REC(1).EQ.SAVE) GO TO 510
      IF (REC(1) .EQ. COMDS(8)) GO TO 190
      GO TO 225
C
C     VELOCITY REQUEST
C
  230 IF (RFNO.NE.8 .AND. RFNO.NE.9) GO TO 90
      IF (REC(2) .NE. NONE) BUF(IREQ) = 1
      ILOC = 9
      GO TO 400
C
C     ACCELERATION REQUEST
C
  240 IF (RFNO.NE.8 .AND. RFNO.NE.9) GO TO 90
      IF (REC(2) .NE. NONE) BUF(IREQ) = 1
      ILOC = 10
      GO TO 400
C
C     ENERGY REQUEST
C
  250 ILOC = -1
      GO TO 400
C
C     UIMPROVED REQUEST
C
  260 UIMPRO = 1
      GO TO 90
C
C     STEPS REQUEST
C
  270 ILOC = 11
      GO TO 400
C
C     CHECK VALIDITY OF SET REQUEST
C
  400 IF (REC(2) .EQ. -2) GO TO 450
  410 ISET = 1
      IF (REC(2) .EQ.  ALL) ISET = -1
      IF (REC(2) .EQ. NONE) ISET = 0
      IF (ISET   .LE.  0) GO TO 430
      IF (REC(2) .EQ. -2) GO TO 420
      IF (REC(2) .NE. -1) GO TO 450
C
C     INTEGER VALUE
C
      ISET = REC(3)
      GO TO 430
C
C     REAL VALUE
C
  420 RSET = RREC(3)
C
C     LOOP OVER APPROPRIATE BASIC AREA AND INSERT REQUEST
C
  430 IF (ILOC .LT. 0) GO TO 445
      DO 440 I = NSS1,NSS2
      I1 = IREQ + (I-1)*LBASIC + 5 + ILOC
      BUF(I1) = ISET
  440 CONTINUE
      GO TO 90
C
  445 ENERGY = ISET
      GO TO 90
C
C     ILLEGAL COMMAND FORMAT
C
  450 WRITE (NOUT,63670) UWM,REC(1)
      GO TO 90
C
C
C     END OF RECORD READING CASESS - THIS IS THEREFORE THE LAST
C     SAVE OR PRINT COMMAND
C
  500 LOOP = -1
C
C     END OF PROCESSING FO THIS PRINT COMMAND
C
  510 CALL CLOSE (CASESS,REW)
C
C     DETERMINE IF EACH BASIC IS REALLY A BASIC.  IF NOT THEN THESE
C     WILL BE MODAL POINTS
C
C     BASIC   POINT TYPE = 1
C     MODAL   POINT TYPE = 4
C
      MASKLL = LSHIFT(1023,20)
      DO 550 I = 1,NBS
      I1 = IREQ + (I-1)*LBASIC + 5
      BUF(I1+12) = 1
      CALL FDSUB (BUF(I1),IDIT)
      IF (IDIT .LT. 0) GO TO 550
      CALL FMDI (IDIT,IMDI)
      IF (ANDF(BUF(IMDI+LL),MASKLL) .NE. 0) BUF(I1+12) = 4
  550 CONTINUE
      CALL SOFCLS
      RETURN
C
C
C     NO PRINT OR SAVE COMMAND SPECIFIED - GENERATE A SAVE ON
C     THE SOLUTION SUBSTRUCTURE
C
  600 RSS(1) = FSS(1)
      RSS(2) = FSS(2)
      LOOP   = -1
      GO TO 720
C
C     THIS LOOP IS A SAVE COMMAND - SEE IF ANY OTHER COMMANDS FOLLOW
C
  700 CALL READ (*9002,*710,CASESS,REC,3,0,NWDS)
      IF (REC(1).EQ.PRINT .OR. REC(1).EQ.SAVE) GO TO 720
      GO TO 700
  710 LOOP = -1
C
C     NO OUTPUT BLOCK IS REQUIRED FOR A SAVE COMMAND
C
  720 CALL CLOSE (CASESS,REW)
      IREQ   = 0
      LREQ   = 0
      IOPT   = 0
      ENERGY = 0
      UIMPRO = 0
      RETURN
C
C     ERROR RETURNS
C
  800 CALL SOFCLS
      IOPT = -1
      LOOP = -1
      CALL CLOSE (CASESS,REW)
      RETURN
C
 6305 WRITE (NOUT,63050) SWM,STEP,REC(1)
      GO TO 800
 6306 WRITE (NOUT,63060) UWM,RSS
      GO TO 800
 9002 N = -2
      GO TO 9100
 9008 N = -8
      GO TO 9100
 9100 CALL SOFCLS
      CALL MESAGE (N,CASESS,SUBNAM)
      RETURN
C
C     FORMATS
C
63050 FORMAT (A27,' 6305, RECORD NUMBER',I5,' IS NOT A RECOVER RECORD.',
     1       '  IT IS A ', A4,' RECORD.')
63060 FORMAT (A25,' 6306, ATTEMPT TO RECOVER DISPLACEMENTS FOR NON-',
     1       'EXISTANT SUBSTRUCTURE ',2A4)
63660 FORMAT (A25,' 6366, THE RECOVER OUTPUT COMMAND SORT MUST APPEAR ',
     1       'BEFORE THE FIRST BASIC SUBCOMMAND.', /32X,
     *       'ANY OTHER SORT COMMANDS ARE IGNORED.')
63670 FORMAT (A25,' 6367, ILLEGAL FORMAT ON THE RECOVER OUTPUT COMMAND',
     1       1X,A4,', COMMAND IGNORED.')
63680 FORMAT (A25,' 6368, THE SUBSTRUCTURE ',2A4,' APPEARING ON A ',
     1       'BASIC COMMAND IS NOT A COMPONENT OF ',2A4, /32X,
     2       'ALL OUTPUT REQUESTS UNTIL THE NEXT BASIC, PRINT OR SAVE ',
     3       'COMMAND ARE IGNORED.')
      END

      SUBROUTINE GPWG
C
C     GRID POINT WEIGHT GENERATOR
C
C     INPUTS  - BGPDT,CSTM,EQEXIN,MGG
C
C     OUTPUTS - OGPWG
C
C     PARAMETERS -- POINT,WTMASS
C
      INTEGER        BGPDT,CSTM,EQEXIN,OGPWG,SCR1,SCR2,SCR3,SCR4,POINT
      COMMON /BLANK/ POINT,WTMASS
      DATA    BGPDT, CSTM,EQEXIN,MGG, OGPWG, SCR1,SCR2,SCR3,SCR4 /
     1        101  , 102 ,103   ,104, 201  , 301 ,302 ,303 ,304  /
C
C     FORM D MATRIX (TRANSPOSED)
C
      IP = POINT
C
      CALL GPWG1A (POINT,BGPDT,CSTM,EQEXIN,SCR3,NOGO)
C
C     CHECK FOR AN ALL SCALAR PROBLEM AND A STUPID USER
C
      IF (NOGO .EQ. 0) GO TO 10
C
C     COMPUTE MZERO = DT*MGG*D
C
      CALL TRANP1 (SCR3,SCR1,2,SCR2,SCR4,0,0,0,0,0,0)
      CALL SSG2B  (MGG ,SCR1,0,SCR2,0,1,1,SCR3)
      CALL SSG2B  (SCR1,SCR2,0,SCR4,1,1,1,SCR3)
C
C     M-ZERO IS ON SCR4
C
C     FORM OUTPUT  STUFF
C
      IF (POINT .EQ. 0) IP = 0
      CALL GPWG1B (SCR4,OGPWG,WTMASS,IP)
   10 RETURN
      END

      SUBROUTINE IDF2(EE,E2,    ETA01,ZET01,A2R,A2I,B2R,B2I,C2R,C2I,
     1                R1SQX,DIIJR,DIIJI)
C   ***   INTEGRATES THE NONPLANAR PARTS OF THE INCREMENTAL
C         OSCILLATORY KERNELS FOR UNSTEADY CASES
      EPS  = 0.0001
      AZET = ABS(ZET01)
      DENO = R1SQX-E2
      PARN = ETA01**2 + ZET01**2
      FACR = PARN*A2R + ETA01*B2R + C2R
      FACI = PARN*A2I + ETA01*B2I + C2I
      ETA02=ETA01**2
      ZET02= ZET01**2
      IF  ((AZET/EE) . LE . 0.001)  GO TO  120
      TEST0= ABS((R1SQX-E2)/(2.0*EE*AZET))
      IF (TEST0.GT.0.1)  GO TO 120
      DEN2 = (ETA01+EE)**2+ZET02
      DEN3 = (ETA01-EE)**2+ZET02
      FAC2A= R1SQX*ETA01+(ETA02-ZET02)*EE
      FAC3A= R1SQX*ETA01-(ETA02-ZET02)*EE
      FAC2B= R1SQX+ETA01*EE
      FAC3B= R1SQX-ETA01*EE
      TRM2R= (FAC2A*A2R+FAC2B*B2R+(ETA01+EE)*C2R)/DEN2
      TRM2I= (FAC2A*A2I+FAC2B*B2I+(ETA01+EE)*C2I)/DEN2
      TRM3R=-(FAC3A*A2R+FAC3B*B2R+(ETA01-EE)*C2R)/DEN3
      TRM3I=-(FAC3A*A2I+FAC3B*B2I+(ETA01-EE)*C2I)/DEN3
      IF (TEST0.LE.0.0001)  GO TO 110
      COEF = (2.0*EE)/(R1SQX-E2)
      ARGA = COEF*ZET01
      TEST = ABS(ARGA)
      IF  (TEST.GT.0.3)  GO TO 90
      S    = ARGA**2
      SER  = 1./3.+S*(-1./5.+S*(1./7.+S*(-1./9.+S*(1./11.-S/13.))))
      ALPHA= E2*(COEF**2)*SER
      FUNCT= COEF*(1.0-ALPHA*(ZET01**2)/E2)
      GO TO 100
   90 CONTINUE
      ARGT = COEF*AZET
      ATANA= ATAN(ARGT)
      FUNCT= ATANA/AZET
  100 CONTINUE
      TRM1R= FACR*FUNCT
      TRM1I= FACI*FUNCT
      DIIJR= (TRM1R + TRM2R + TRM3R)/(2.0*ZET02)
      DIIJI= (TRM1I + TRM2I + TRM3I)/(2.0*ZET02)
      GO TO 170
  110 CONTINUE
      FUNCT= 0.0
      GO TO 100
  120 CONTINUE
      DENA = (ETA01+EE)**2 + ZET01**2
      DENB = (ETA01-EE)**2 + ZET01**2
      UP1R = 2.0*(E2*A2R + C2R)
      UP1I = 2.0*(E2*A2I + C2I)
      UP2R = 4.0*E2*ETA01*B2R
      UP2I = 4.0*E2*ETA01*B2I
      TRM1R= (UP1R *(R1SQX+E2) + UP2R )/(DENA*DENB)
      TRM1I= (UP1I *(R1SQX+E2) + UP2I )/(DENA*DENB)
      IF  ((AZET/EE) . LE . 0.001)  GO TO  130
      COEF = (2.0*EE)/(R1SQX-E2)
      ARGA = COEF*ZET01
      TEST = ABS(ARGA)
      IF  (TEST.GT.0.3)  GO TO 125
      S    = ARGA**2
      SER  = 1./3.+S*(-1./5.+S*(1./7.+S*(-1./9.+S*(1./11.-S/13.))))
      ALPHA= E2*(COEF**2)*SER
      FUNCT= COEF*(1.0-ALPHA*(ZET01**2)/E2)
      GO TO 140
  125 CONTINUE
      ARGT= COEF*AZET
      ATANA= ATAN(ARGT)
      FUNCT= ATANA/AZET
      ALPHA= (E2/ZET02)*(1.0-FUNCT*(DENO/(2.0*EE)))
      GO TO 140
  130 CONTINUE
      ALPHA= ((2.0*E2)/(ETA02-E2))**2
  140 CONTINUE
      TRM2R= -ALPHA*FACR/E2
      TRM2I= -ALPHA*FACI/E2
      DIIJR= EE*(TRM1R + TRM2R)/DENO
      DIIJI= EE*(TRM1I + TRM2I)/DENO
  170 CONTINUE
      RETURN
      END

      SUBROUTINE Q4GMGS (MID,FACTOR,G)
C     &    ENTRY Q4GMGD (MID,FACTOD,D)
C
C
C     MATERIAL PROPERTY MATRIX GENERATOR ROUTINE FOR QUAD4 ELEMENT
C
C     THIS ROUTINE BUILDS THE MATERIAL PROPERTY MATRIX, G, USING THE
C     OUTPUT OF SUBROUTINE 'MAT' (/MATOUT/).
C
C     ALL THE MATERIAL OPTIONS, ISOTROPIC, ORTHOTROPIC, AND ANISOTROPIC,
C     ARE AVAILABLE.
C
C     OUTPUT WILL BE G(9) OR D(9) FOR MID1, MID2 AND MID4.
C     FOR MID3,  G(4) OR D(4) IS SENT BACK.
C
      REAL             FACTOR,G(9),CONST,MTYPE,NU12,NU21
      DOUBLE PRECISION FACTOD,D(9),DONST
      COMMON  /MATOUT/ RMTOUT(25)
      EQUIVALENCE      (RMTOUT(1),E1),(RMTOUT(2),NU12),(RMTOUT(3),E2)
C
C     SINGLE PRECISION SECTION -
C
      DO 10 I=1,9
   10 G(I) = 0.0
      MTYPE= RMTOUT(25)
      MTYP = IFIX(MTYPE+.05) - 2
      IF (MTYP) 20,30,80
C
C     ISOTROPIC MATERIALS (MAT1)
C
   20 IF (MID .NE. 3) GO TO 40
      G(1) = RMTOUT(6)
      G(4) = G(1)
      GO TO 100
C
C     ANISOTROPIC MATERIALS (MAT2)
C
   30 IF (MID .EQ. 3) GO TO 60
   40 DO 50 I=1,3
   50 G(I) = RMTOUT(I)
      G(4) = G(2)
      G(5) = RMTOUT(4)
      G(6) = RMTOUT(5)
      G(7) = G(3)
      G(8) = G(6)
      G(9) = RMTOUT(6)
      GO TO 100
C
   60 DO 70 I=1,4
   70 G(I) = RMTOUT(I)
      G(3) = G(2)
      GO TO 100
C
C     ORTHOTROPIC MATERIALS (MAT8)
C
   80 IF (MID .EQ. 3) GO TO 90
      NU21 = NU12 * E2 / E1
      CONST= 1.0 - (NU21*NU12)
      G(1) = E1 / CONST
      G(2) = NU12 * E2 / CONST
      G(4) = G(2)
      G(5) = E2 / CONST
      G(9) = RMTOUT(4)
      GO TO 100
C
   90 G(1) = RMTOUT(6)
      G(4) = RMTOUT(5)
      IF (G(1).EQ.0.0 .AND. G(4).EQ.0.0) GO TO 120
C
C     STANDARD RETURN
C
  100 DO 110 I=1,9
  110 G(I) = G(I)*FACTOR
      GO TO 310
C
C     FATAL RETURN
C
  120 MID = -MID
      GO TO 310
C
      ENTRY Q4GMGD (MID,FACTOD,D)
C     ===========================
C
      DO 200 I=1,9
  200 D(I) = 0.0D0
      MTYPE= RMTOUT(25)
      MTYP = IFIX(MTYPE+.05) - 2
      IF (MTYP) 210,220,270
C
C     ISOTROPIC MATERIALS (MAT1)
C
  210 IF (MID .NE. 3) GO TO 230
      D(1) = RMTOUT(6)
      D(4) = D(1)
      GO TO 290
C
C     ANISOTROPIC MATERIALS (MAT2)
C
  220 IF (MID .EQ. 3) GO TO 250
  230 DO 240 I=1,3
  240 D(I) = RMTOUT(I)
      D(4) = D(2)
      D(5) = RMTOUT(4)
      D(6) = RMTOUT(5)
      D(7) = D(3)
      D(8) = D(6)
      D(9) = RMTOUT(6)
      GO TO 290
C
  250 DO 260 I=1,4
  260 D(I) = RMTOUT(I)
      D(3) = D(2)
      GO TO 290
C
C     ORTHOTROPIC MATERIALS (MAT8)
C
  270 IF (MID .EQ. 3) GO TO 280
      NU21 = NU12 * E2 / E1
      DONST= 1.0D0 - DBLE(NU21*NU12)
      D(1) = E1 / DONST
      D(2) = NU12 * E2 / DONST
      D(4) = D(2)
      D(5) = E2 / DONST
      D(9) = RMTOUT(4)
      GO TO 290
C
  280 D(1) = RMTOUT(6)
      D(4) = RMTOUT(5)
      IF (D(1).EQ.0.0D0 .AND. D(4).EQ.0.0D0) GO TO 120
C
C     STANDARD RETURN
C
  290 DO 300 I=1,9
  300 D(I) = D(I)*FACTOD
C
  310 RETURN
      END

      SUBROUTINE ALG16 (IX,LOG1,X1,Y1,X2,Y2)
C
      REAL LINE
C
      DIMENSION X1(1), Y1(1), X2(1), Y2(1), LINE(121), XNUM(13)
C
      DATA SYMBOL/1H*/,DASH/1H-/,CROSS/1H+/,BLANK/1H /,XI/1HI/
C
      YMIN=Y1(1)
      XMIN=X1(1)
      YMAX=YMIN
      XMAX=XMIN
      DO 10 I=1,IX
      IF (Y2(I).LT.YMIN) YMIN=Y2(I)
      IF (Y2(I).GT.YMAX) YMAX=Y2(I)
      IF (X2(I).LT.XMIN) XMIN=X2(I)
      IF (X2(I).GT.XMAX) XMAX=X2(I)
      IF (Y1(I).GT.YMAX) YMAX=Y1(I)
      IF (X1(I).GT.XMAX) XMAX=X1(I)
10    CONTINUE
      IF (XMAX.EQ.XMIN.OR.YMIN.EQ.YMAX) GO TO 170
      YH=YMAX+(YMAX-YMIN)/25.0
      YL=YMIN-(YMAX-YMIN)/25.0
      XH=XMAX+(XMAX-XMIN)/38.3333
      XL=XMIN-(XMAX-XMIN)/38.3333
      IF ((YH-YL)/(XH-XL).GT.0.75) XH=1.3333*(YH-YL)+XL
      IF ((YH-YL)/(XH-XL).LT.0.75) YH=0.75*(XH-XL)+YL
      XMAX=(XMIN+XMAX-XH+XL)/2.0
      XH=XH-XL+XMAX
      XL=XMAX
      XMAX=(YMIN+YMAX-YH+YL)/2.0
      YH=YH-YL+XMAX
      YL=XMAX
      XMAX=ABS(XH)
      XMIN=ABS(XL)
      YMIN=ABS(YL)
      YMAX=ABS(YH)
      IF (XMIN.GT.XMAX) XMAX=XMIN
      IF (YMIN.GT.YMAX) YMAX=YMIN
      XMAX=ALOG10(XMAX)
      YMAX=ALOG10(YMAX)
      IF (XMAX.LT.0.0) XMAX=XMAX-1.0
      IF (YMAX.LT.0.0) YMAX=YMAX-1.0
      MX=-XMAX
      MY=-YMAX
      WRITE (LOG1,20) MX,MY
20    FORMAT (20X,46HSCALES -  X  IS SHOWN TIMES 10 TO THE POWER OF,I3,4
     10H    Y  IS SHOWN TIMES 10 TO THE POWER OF,I3,/)
      YINC=(YH-YL)/54.0
      YINC2=YINC/2.0
      XRANGE=XH-XL
      DO 140 KLINE=1,55
      IF (KLINE.EQ.1.OR.KLINE.EQ.55) GO TO 50
      DO 30 L=2,120
30    LINE(L)=BLANK
      IF (KLINE.EQ.7.OR.KLINE.EQ.13.OR.KLINE.EQ.19.OR.KLINE.EQ.25.OR.KLI
     1NE.EQ.31.OR.KLINE.EQ.37.OR.KLINE.EQ.43.OR.KLINE.EQ.49) GO TO 40
      LINE(1)=XI
      LINE(121)=XI
      GO TO 80
40    LINE(1)=DASH
      LINE(121)=DASH
      GO TO 80
50    DO 60 L=2,120
60    LINE(L)=DASH
      LINE(1)=CROSS
      LINE(121)=CROSS
      DO 70 L=11,111,10
70    LINE(L)=XI
      GO TO 120
80    DO 100 I=1,IX
      IF (Y2(I).GT.YH+YINC2.OR.Y2(I).LE.YH-YINC2) GO TO 90
      L=(X2(I)-XL)/XRANGE*120.0+1.5
      LINE(L)=SYMBOL
90    IF (Y1(I).GT.YH+YINC2.OR.Y1(I).LE.YH-YINC2) GO TO 100
      L=(X1(I)-XL)/XRANGE*120.0+1.5
      LINE(L)=SYMBOL
100   CONTINUE
      IF (KLINE.EQ.1.OR.KLINE.EQ.7.OR.KLINE.EQ.13.OR.KLINE.EQ.19.OR.KLIN
     1E.EQ.25.OR.KLINE.EQ.31.OR.KLINE.EQ.37.OR.KLINE.EQ.43.OR.KLINE.EQ.4
     29.OR.KLINE.EQ.55) GO TO 120
      WRITE (LOG1,110) LINE
110   FORMAT (8X,121A1)
      GO TO 140
120   YNUM=YH*10.0**MY
      WRITE (LOG1,130) YNUM,LINE
130   FORMAT (1X,F6.3,1X,121A1)
140   YH=YH-YINC
      XNUM(1)=XL*10.0**MX
      XINC=((XH-XL)/12.0)*10.0**MX
      DO 150 I=2,13
150   XNUM(I)=XNUM(I-1)+XINC
      WRITE (LOG1,160) XNUM
160   FORMAT (6X,12(F6.3,4X),F6.3)
      RETURN
170   WRITE (LOG1,180)
180   FORMAT (//,35X,54HNO PLOT HAS BEEN MADE BECAUSE  X  OR  Y  RANGE I
     1S ZERO)
      RETURN
      END

      SUBROUTINE ALG05
C
      REAL LOSS,LAMI,LAMIP1,LAMIM1
C
      DIMENSION XX1(21),XX2(21),XX3(21),XX4(21),XX5(21)
C
      COMMON /UD300C/ NSTNS,NSTRMS,NMAX,NFORCE,NBL,NCASE,NSPLIT,NREAD,
     1NPUNCH,NPAGE,NSET1,NSET2,ISTAG,ICASE,IFAILO,IPASS,I,IVFAIL,IFFAIL,
     2NMIX,NTRANS,NPLOT,ILOSS,LNCT,ITUB,IMID,IFAIL,ITER,LOG1,LOG2,LOG3,
     3LOG4,LOG5,LOG6,IPRINT,NMANY,NSTPLT,NEQN,NSPEC(30),NWORK(30),
     4NLOSS(30),NDATA(30),NTERP(30),NMACH(30),NL1(30),NL2(30),NDIMEN(30)
     5,IS1(30),IS2(30),IS3(30),NEVAL(30),NDIFF(4),NDEL(30),NLITER(30),
     6NM(2),NRAD(2),NCURVE(30),NWHICH(30),NOUT1(30),NOUT2(30),NOUT3(30),
     7NBLADE(30),DM(11,5,2),WFRAC(11,5,2),R(21,30),XL(21,30),X(21,30),
     8H(21,30),S(21,30),VM(21,30),VW(21,30),TBETA(21,30),DIFF(15,4),
     9FDHUB(15,4),FDMID(15,4),FDTIP(15,4),TERAD(5,2),DATAC(100),
     1DATA1(100),DATA2(100),DATA3(100),DATA4(100),DATA5(100),DATA6(100),
     2DATA7(100),DATA8(100),DATA9(100),FLOW(10),SPEED(30),SPDFAC(10),
     3BBLOCK(30),BDIST(30),WBLOCK(30),WWBL(30),XSTN(150),RSTN(150),
     4DELF(30),DELC(100),DELTA(100),TITLE(18),DRDM2(30),RIM1(30),
     5XIM1(30),WORK(21),LOSS(21),TANEPS(21),XI(21),VV(21),DELW(21),
     6LAMI(21),LAMIM1(21),LAMIP1(21),PHI(21),CR(21),GAMA(21),SPPG(21),
     7CPPG(21),HKEEP(21),SKEEP(21),VWKEEP(21),DELH(30),DELT(30),VISK,
     8SHAPE,SCLFAC,EJ,G,TOLNCE,XSCALE,PSCALE,PLOW,RLOW,XMMAX,RCONST,
     9FM2,HMIN,C1,PI,CONTR,CONMX
C
      L1=NDIMEN(I)+1
      GO TO(100,120,140,160),L1
100   DO 110 J=1,NSTRMS
110   XX5(J)=R(J,I)
      GO TO 180
120   DO 130 J=1,NSTRMS
130   XX5(J)=R(J,I)/R(NSTRMS,I)
      GO TO 180
140   DO 150 J=1,NSTRMS
150   XX5(J)=XL(J,I)
      GO TO 180
160   DO 170 J=1,NSTRMS
170   XX5(J)=XL(J,I)/XL(NSTRMS,I)
180   L2=IS2(I)
      L3=NDATA(I)
      L4=NTERP(I)
      CALL ALG01(DATAC(L2),DATA1(L2),L3,XX5,WORK  ,X1,NSTRMS,L4,0)
      CALL ALG01(DATAC(L2),DATA3(L2),L3,XX5,TANEPS,X1,NSTRMS,L4,0)
      DO 190 J=1,NSTRMS
190   TANEPS(J)=TAN(TANEPS(J)/C1)
      IW=NWORK(I)
      IL=NLOSS(I)
      IF(IW.EQ.7.OR.IL.LE.3)
     1CALL ALG01(DATAC(L2),DATA2(L2),L3,XX5,LOSS  ,X1,NSTRMS,L4,0)
      IF(IW.GE.5)
     1CALL ALG01(DATAC(L2),DATA6(L2),L3,XX5,XX1,X1,NSTRMS,L4,0)
      IF(IL.NE.4)GO TO 350
      DO 200 II=I,NSTNS
      IF(NLOSS(II).EQ.1)GO TO 210
200   CONTINUE
210   L2=IS2(II)
      L3=NDATA(II)
      L4=NTERP(II)
      L1=NDIMEN(II)+1
      GO TO(220,240,260,280),L1
220   DO 230 J=1,NSTRMS
230   XX5(J)=R(J,II)
      GO TO 300
240   DO 250 J=1,NSTRMS
250   XX5(J)=R(J,II)/R(NSTRMS,II)
      GO TO 300
260   DO 270 J=1,NSTRMS
270   XX5(J)=XL(J,II)
      GO TO 300
280   DO 290 J=1,NSTRMS
290   XX5(J)=XL(J,II)/XL(NSTRMS,II)
300   CALL ALG01(DATAC(L2),DATA2(L2),L3,XX5,LOSS,X1,NSTRMS,L4,0)
      III=I+NL1(I)+1
      DO 320 J=1,NSTRMS
      XX2(J)=0.0
      DO 310 IK=III,II
      XX2(J)=XX2(J)+SQRT((X(J,IK)-X(J,IK-1))**2+(R(J,IK)-R(J,IK-1))**2)
      IF(IK.EQ.I)XX3(J)=XX2(J)
310   CONTINUE
320   XX3(J)=XX3(J)/XX2(J)
      L1=NCURVE(I)
      L2=NM(L1)
      L3=NRAD(L1)
      DO 340 J=1,NSTRMS
      DO 330 K=1,L3
330   CALL ALG01(DM(1,K,L1),WFRAC(1,K,L1),L2,XX3(J),XX2(K),X1,1,0,0)
      X2=(R(J,II)-R(1,II))/(R(NSTRMS,II)-R(1,II))
      CALL ALG01(TERAD(1,L1),XX2,L3,X2,X1,X1,1,0,0)
340   LOSS(J)=LOSS(J)*X1
350   IF(IW.LT.5)GO TO 420
      IF(IW.NE.5)GO TO 370
      DO 360 J=1,NSTRMS
360   TBETA(J,I)=TAN((WORK(J)+XX1(J))/C1)
      GO TO 420
370   IF(IW.EQ.7)GO TO 400
      DO 380 J=1,NSTRMS
380   XX2(J)=TAN((ATAN((R(J,I+1)-R(J,I))/(X(J,I+1)-X(J,I)))+ATAN((R(J,I)
     1-R(J,I-1))/(X(J,I)-X(J,I-1))))/2.0)
      L1=IS1(I)
      CALL ALG01(RSTN(L1),XSTN(L1),NSPEC(I),R(1,I),X1,XX3,NSTRMS,0,1)
      DO 390 J=1,NSTRMS
390   TBETA(J,I)=TAN(ATAN((TAN(WORK(J)/C1)*(1.0-XX3(J)*XX2(J))-XX2(J)*TA
     1NEPS(J)*SQRT(1.0+XX3(J)**2))/SQRT(1.0+XX2(J)**2))+XX1(J)/C1)
      GO TO 420
400   XN=SPEED(I)*SPDFAC(ICASE)*PI/(30.0*SCLFAC)
      CALL ALG01(DATAC(L2),DATA7(L2),L3,XX5,XX2,X1,NSTRMS,L4,0)
      CALL ALG01(DATAC(L2),DATA8(L2),L3,XX5,XX3,X1,NSTRMS,L4,0)
      CALL ALG01(DATAC(L2),DATA9(L2),L3,XX5,XX4,X1,NSTRMS,L4,0)
      II=I+NL1(I)
      DO 410 J=1,NSTRMS
      X1=C1*ATAN((VW(J,II)-XN*R(J,II))/VM(J,II))
      X2=XX3(J)
      IF(X1.LT.XX1(J))X2=XX4(J)
      LOSS(J)=LOSS(J)*(1.0+((X1-XX1(J))/(X2-XX1(J)))**2)
      IF(LOSS(J).GT.0.5)LOSS(J)=0.5
410   TBETA(J,I)=TAN((WORK(J)+(X1-XX1(J))*XX2(J))/C1)
420   RETURN
      END

      SUBROUTINE ADRI (FL,NFREQ,NCORE,QHHL,SCR2,SCR1,SCR3,SCR4,NROW,
     1                 NCOL,NOGO)
C
      INTEGER         QHHL,SCR1,SCR2,SCR3,SCR4,TRL(7),OUT
      DIMENSION       FL(1),MCB(7),NAME(2)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /BLANK / BOV,RM
      COMMON /CONDAS/ PI,TWOPI
      COMMON /SYSTEM/ ISYS,OUT,DUM(52),IPREC
      COMMON /UNPAKX/ IOUT,INN,NNN,INCR1
      COMMON /PACKX / ITI,ITO,II,NN,INCR
      COMMON /TYPE  / P(2),IWC(4)
      DATA    NHFRDI, NAME /4HFRDI,4HADRI,4H    /
C
      IBUF1 = NCORE - ISYS
      IBUF2 = IBUF1 - ISYS
      NROW  = 0
      INCR  = 1
      INCR1 = 1
      II    = 1
      INN   = 1
      MCB(1)= QHHL
      CALL RDTRL (MCB)
      IF (MCB(1) .LT. 0) GO TO 250
      NROW  = MCB(3)
      CALL OPEN (*250,QHHL,FL(IBUF2),0)
      CALL GOPEN (SCR1,FL(IBUF1),1)
      CALL READ (*220,*220,QHHL,FL(1),-2,0,FLAG)
      CALL READ (*220,*220,QHHL,NCOL,1,0,FLAG)
      CALL READ (*220,*220,QHHL,N,1,0,FLAG)
      N    = N + N
      NI   = (MCB(2)/NCOL)*2
      NI   = MIN0(NI,N)
      NNN  = NROW
      NN   = NCOL*NROW
      ITI  = 3
      ITO  = ITI
      IOUT = ITI
      NWC  = IWC(ITI)
      CALL MAKMCB (TRL,SCR1,NN,MCB(4),ITO)
C
C     MAKE   DEPENDENT FREQ LIST
C
      IPD  = 1
      NL   = 2*NFREQ
      N    = NFREQ + 1
      IPI  = IPD + NL
      DO 10 I = 1,NFREQ
      FL(NL  ) = FL(N-I)*TWOPI*BOV
      FL(NL-1) = 0.0
      NL   = NL -2
   10 CONTINUE
C
C     MAKE INDEPENDENT FREQ LIST
C
      CALL READ (*220,*220,QHHL,FL(IPI),NI,1,FLAG)
C
C     FIND M"S CLOSEST TO RM
C
      ICP = IPI + NI
      RMI = 1.E20
      RMS = 0.0
      DO 30 I = 1,NI,2
      RMX = ABS(FL(IPI+I-1) - RM)
      RMI = AMIN1(RMI,RMX)
      IF (RMX .GT. RMI) GO TO 30
      RMS = FL(IPI+I-1)
   30 CONTINUE
      RMI = RMS
C
C     DO ALL K"S ASSOCIATED WITH RMI
C
      K = 0
      DO 150 I = 1,NI,2
      IF (FL(IPI+I-1) .EQ. RMI) GO TO 120
C
C     SKIP MATRIX
C
      CALL SKPREC (QHHL,NCOL)
      GO TO 150
C
C     MAKE MATRIX INTO COLUMN
C
  120 FL(IPI+K+1) = FL(IPI+I)
      K  = K + 2
      JI = ICP
      N  = NROW*NWC
      DO 130 J = 1,NCOL
      CALL UNPACK (*131,QHHL,FL(JI))
      GO TO 135
  131 CALL ZEROC (FL(JI),N)
  135 JI = JI + N
  130 CONTINUE
C
C     DIVIDE IMAG PART OF QHHL BY FREQUENCY
C
      JJ = ICP + 1
      KK = JI  - 1
      DO 132 J = JJ,KK,2
      FL(J) = FL(J)/FL(IPI+I)
  132 CONTINUE
      CALL PACK (FL(ICP),SCR1,TRL)
  150 CONTINUE
      CALL CLOSE (QHHL,1)
      CALL CLOSE (SCR1,1)
      CALL WRTTRL (TRL)
      CALL BUG (NHFRDI,150,K ,1)
      CALL BUG (NHFRDI,150,NFREQ,1)
      CALL BUG (NHFRDI,150,FL(1),ICP)
C
C     SETUP TO CALL MINTRP
C
      NI   = K/2
      NOGO = 0
      NC   = NCORE - ICP
      CALL DMPFIL (-SCR1,FL(ICP),NC)
      IM   = 0
      IK   = 1
      CALL MINTRP (NI,FL(IPI),NFREQ,FL(IPD),-1,IM,IK,0.0,SCR1,SCR2,
     1             SCR3,SCR4,FL(ICP),NC,NOGO,IPREC)
      IF (NOGO .EQ. 1) GO TO 200
      CALL DMPFIL (-SCR2,FL(ICP),NC)
      RETURN
C
  200 WRITE  (OUT,210) UFM
  210 FORMAT (A23,' 2271, INTERPOLATION MATRIX IS SINGULAR')
CIBMR 6/93  GO TO 240                                                 !*
      GO TO 240
  220 CALL MESAGE (3,QHHL,NAME)
  240 NOGO = 1
  250 CALL CLOSE (QHHL,1)
      RETURN
      END

      SUBROUTINE OUTPT1
C
C     COPY DATA BLOCK(S) ONTO NASTRAN USER TAPE WHICH MUST BE SET-UP.
C
C     CALL TO THIS MODULE IS
C
C     OUTPUT1   IN1,IN2,IN3,IN4,IN5//V,N,P1/V,N,P2/V,N,P3 $
C
C               P1 = 0, NO ACTION TAKEN BEFORE WRITE (DEFAULT)
C                  =+N, SKIP FORWARD N DATA BLOCKS BEFORE WRITE
C                  =-1, USER TAPE IS REWOUND BEFORE WRITE
C                  =-2, A NEW REEL IS MOUNTED BEFORE WRITE
C                  =-3, THE NAMES OF ALL DATA BLOCKS ON USER TAPE ARE
C                       PRINTED AND WRITE OCCURS AT THE END OF TAPE
C                  =-4, AN INPUT TAPE IS TO BE DISMOUNTED.
C                       A NEW OUTPUT REEL WILL THEN BE MOUNTED.
C                  =-9, WRITE EOF, REWIND AND UNLOAD.
C
C               P2 = 0, FILE NAME IS INPT (DEFAULT)
C                  = 1, FILE NAME IS INP1
C                  = 2, FILE NAME IS INP2
C                  = 3, FILE NAME IS INP3
C                  = 4, FILE NAME IS INP4
C                  = 5, FILE NAME IS INP5
C                  = 6, FILE NAME IS INP6
C                  = 7, FILE NAME IS INP7
C                  = 8, FILE NAME IS INP8
C                  = 9, FILE NAME IS INP9
C
C               P3 = TAPE ID CODE FOR USER TAPE, AN ALPHANUMERIC
C                    VARIABLE WHOSE VALUE WILL BE WRITTEN ON A USER
C                    TAPE. THE WRITTING OF THIS ITEM IS DEPENDENT ON
C                    THE VALUE OF P1 AS FOLLOWS..
C                          *P1*             *TAPE ID WRITTEN*
C                           +N                     NO
C                            0                     NO
C                           -1                    YES
C                           -2                    YES (ON NEW REEL)
C                           -3                     NO (WARNING CHECK)
C                           -4                    YES (ON NEW REEL)
C                           -9                     NO
C                    DEFAULT VALUE FOR P3 IS XXXXXXXX
C
C
      IMPLICIT INTEGER (A-Z)
      LOGICAL         TAPEUP,TAPBIT
      INTEGER         TRL(7),NAME(2),SUBNAM(2),IN(5),NAMEX(2),OTT(10),
     1                IDHDR(7),IDHDRX(7),P3X(2),D(3),DX(3),TAPCOD(2)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG / UFM,UWM,UIM,SFM
      COMMON /MACHIN/ MACH
      COMMON /BLANK / P1,P2,P3(2)
     1       /SYSTEM/ KSYSTM(65)
     2       /ZZZZZZ/ X(1)
      EQUIVALENCE     (KSYSTM( 1),NB  ),(KSYSTM( 2),NOUT),
     1                (KSYSTM( 9),NLPP),(KSYSTM(12),LINE),
     2                (KSYSTM(15),D(1))
      DATA    SUBNAM/ 4HOUTP,4HT1        /
      DATA    IN    / 101,102,103,104,105/
      DATA    ZERO  , MONE,MTWO,MTRE,MFOR,MNIN/ 0,-1,-2,-3,-4,-9/
      DATA    OTT   / 4HINPT,4HINP1,4HINP2,4HINP3,4HINP4,
     1                4HINP5,4HINP6,4HINP7,4HINP8,4HINP9/
      DATA    IDHDR / 4HNAST,4HRAN ,4HUSER,4H TAP,4HE ID,4H COD,4HE - /
C
C
      LCOR = KORSZ(X) - 2*NB
      IF (LCOR .LE. 0) GO TO 9908
      INBUF = LCOR  + 1
      OUBUF = INBUF + NB
      TAPCOD(1) = P3(1)
      TAPCOD(2) = P3(2)
      IF (P2.LT.0 .OR. P2.GT.9) GO TO 9904
      OUT = OTT(P2+1)
      IF (MACH .GE. 5) GO TO 120
      TAPEUP = TAPBIT(OUT)
      IF (.NOT.TAPEUP ) GO TO 9909
  120 IF (P1 .LT. MNIN) GO TO 9905
      IF (P1.GT.MNIN .AND. P1.LT.MFOR) GO TO 9905
C
      IF (P1 .EQ. MNIN) GO TO 5000
      IF (P1 .EQ. MTRE) GO TO 2000
      IF (P1 .LE. ZERO) GO TO 150
C
      CALL GOPEN (OUT,X(OUBUF),2)
      DO 130 I = 1,P1
      CALL READ (*9903,*9903,OUT,NAMEX,2,1,NF)
  130 CALL SKPFIL (OUT,1)
      CALL CLOSE (OUT,2)
      GO TO 190
C
  150 IF (P1.NE.MTWO .AND. P1.NE.MFOR) GO TO 190
C
C     P1 = -2 OR P1 = -4 IS ACCEPTABLE ONLY ON IBM OR UNIVAC
C
      IF (MACH.NE.2 .AND. MACH.NE.3) GO TO 9905
C
      IOLD = 3 + P1/2
      CALL GOPEN  (OUT,X(OUBUF),3)
      CALL TPSWIT (OUT,IOLD,2,TAPCOD)
C
C     OPEN USER TAPE TO WRITE WITHOUT REWIND
C
  190 CALL GOPEN (OUT,X(OUBUF),3)
      IF (P1.NE.MONE .AND. P1.NE.MTWO .AND. P1.NE.MFOR) GO TO 195
      CALL REWIND (OUT)
      CALL WRITE (OUT,D,3,0)
      CALL WRITE (OUT,IDHDR,7,0)
      CALL WRITE (OUT,P3,2,1)
      CALL EOF (OUT)
      GO TO 195
C
  193 CALL CLOSE (OUT,2)
      CALL GOPEN (OUT,X(OUBUF),3)
C
  195 DO 1000 I = 1,5
      INPUT  = IN(I)
      TRL(1) = INPUT
      CALL RDTRL (TRL)
      IF (TRL(1) .LE. 0) GO TO 1000
      CALL FNAME (INPUT,NAME)
C
C     OPEN INPUT DATA BLOCK TO READ WITH REWIND.
C
      CALL OPEN  (*9901,INPUT,X(INBUF),0)
      CALL WRITE (OUT,NAME,2,0)
      CALL WRITE (OUT,TRL(2),6,1)
C
C     LEVEL 17.5, THE ABOVE 8 WORD RECORD WAS WRITTEN OUT IN 2 RECORDS
C     2 BCD WORD NAME, AND 7 TRAILER WORDS
C
C     COPY CONTENTS OF INPUT DATA BLOCK ONTO USER TAPE.
C
      CALL CPYFIL (INPUT,OUT,X,LCOR,NF)
C
C     CLOSE INPUT DATA BLOCK WITH REWIND
C
      CALL CLOSE (INPUT,1)
C
      CALL EOF (OUT)
      CALL PAGE2 (-4)
      WRITE  (NOUT,350) UIM,NAME,OUT,(TRL(II),II=2,7)
  350 FORMAT (A29,' 4114', //5X,'DATA BLOCK ',2A4,
     1       ' WRITTEN ON NASTRAN FILE ',A4,', TRLR  =',6I10)
C
 1000 CONTINUE
C
C     CLOSE NASTRAN USER TAPE WITHOUT REWIND, BUT WITH END-OF-FILE
C
      CALL CLOSE (OUT,3)
      RETURN
C
C     OBTAIN LIST OF DATA BLOCKS ON USER TAPE.
C
 2000 CALL OPEN (*9902,OUT,X(OUBUF),0)
      CALL READ (*9911,*9912,OUT,DX,3,0,NF)
      CALL READ (*9911,*9912,OUT,IDHDRX,7,0,NF)
      DO 2005 KF = 1,7
      IF (IDHDRX(KF) .NE. IDHDR(KF)) GO TO 9913
 2005 CONTINUE
      CALL READ (*9911,*9912,OUT,P3X,2,1,NF)
      IF (P3X(1).NE.P3(1) .OR. P3X(2).NE.P3(2)) GO TO 9914
 2006 CALL SKPFIL (OUT,1)
      KF = 0
 2007 CALL PAGE1
      LINE = LINE + 5
      WRITE  (NOUT,2010) OUT
 2010 FORMAT (//50X,A4,14H FILE CONTENTS ,/46X,4HFILE,18X,4HNAME,//)
 2020 CALL READ (*2050,*9915,OUT,NAMEX,2,1,NF)
      CALL SKPFIL (OUT,1)
      KF = KF + 1
      LINE = LINE + 1
      WRITE  (NOUT,2030) KF,NAMEX
 2030 FORMAT (45X,I5,18X,2A4)
      IF (LINE-NLPP) 2020,2007,2007
 2050 CALL SKPFIL (OUT,-1)
      GO TO 193
C
 5000 CONTINUE
      CALL EOF (OUT)
      CALL UNLOAD( OUT)
      RETURN
C
C     ERRORS
C
 9901 MM = -1
      GO TO 9996
 9902 WRITE  (NOUT,9952) SFM,OUT
 9952 FORMAT (A25,' 4117, SUBROUTINE OUTPT1 UNABLE TO OPEN NASTRAN FILE'
     1,       A4,1H.)
      LINE = LINE + 2
      GO TO 9995
 9903 WRITE  (NOUT,9953) UFM,P1,OUT,I
 9953 FORMAT (A23,' 4118, MODULE OUTPUT1 IS UNABLE TO SKIP FORWARD',I10,
     2        ' DATA BLOCKS ON PERMANENT NASTRAN FILE ',A4,1H., /5X,
     3        'NUMBER OF DATA BLOCKS SKIPPED =',I6)
      LINE = LINE + 3
      GO TO 9995
 9904 WRITE  (NOUT,9954) UFM,P2
 9954 FORMAT (A23,' 4119, MODULE OUTPUT1 - ILLEGAL VALUE FOR SECOND ',
     1       'PARAMETER =',I20)
      LINE = LINE + 2
      GO TO 9995
 9905 WRITE  (NOUT,9955) UFM,P1
 9955 FORMAT (A23,' 4120, MODULE OUTPUT1 - ILLEGAL VALUE FOR FIRST ',
     1       'PARAMETER =',I20)
      LINE = LINE + 2
      GO TO 9995
 9908 MM = -8
      INPUT = -LCOR
      GO TO 9996
 9909 WRITE  (NOUT,9959) UFM,OUT
 9959 FORMAT (A23,' 4127, USER TAPE ',A4,' NOT SET UP.')
      LINE = LINE + 2
      GO TO 9995
 9911 WRITE  (NOUT,9961) UFM,OUT
 9961 FORMAT (A23,' 4128, MODULE OUTPUT1 - END-OF-FILE ENCOUNTERED ',
     1       'WHILE ATTEMPTING TO READ TAPE ID CODE ON USER TAPE ',A4)
      LINE = LINE + 2
      GO TO 9995
 9912 WRITE  (NOUT,9962) UFM,OUT
 9962 FORMAT (A23,' 4129, MODULE OUTPUT1 - END-OF-RECORD ENCOUNTERED ',
     1       'WHILE ATTEMPTING TO READ TAPE ID CODE ON USER TAPE ',A4)
      LINE = LINE + 2
      GO TO 9995
 9913 WRITE  (NOUT,9963) UFM,(IDHDRX(KF),KF=1,7)
 9963 FORMAT (A23,' 4130, MODULE OUTPUT1 - ILLEGAL TAPE CODE HEADER = ',
     1        7A4)
      LINE = LINE + 2
      GO TO 9995
 9914 WRITE  (NOUT,9964) UWM,P3X,P3
 9964 FORMAT (A25,' 4131, USER TAPE ID CODE -',2A4,'- DOES NOT MATCH ',
     1       'THIRD OUTPUT1 DMAP PARAMETER -',2A4,2H-.)
      LINE = LINE + 2
      GO TO 2006
 9915 WRITE  (NOUT,9965) SFM
 9965 FORMAT (A25,' 4115, MODULE OUTPUT1 - SHORT RECORD.')
      LINE = LINE + 2
      GO TO 9995
C
 9995 MM = -37
 9996 CALL MESAGE (MM,INPUT,SUBNAM)
      RETURN
C
      END

      SUBROUTINE IFP1C (I81,NZ)
C
      LOGICAL         BIT64
      INTEGER         CORE(1),COREY(401),SCR1,THRU,OTPE,EXCE,BLANK,
     1                NIFP1C(2)
      COMMON /SYSTEM/ SYSBUF,OTPE,NOGO,INTP,MPCN,SPCN,METHOD,LOADNN,
     1                NLPP,STFTEM,IPAGE,LINE,TLINE,MAXLIN,DATE(3),TIM,
     2                IECHO,SPLOTS,SKIP(65),INTRA
      COMMON /IFP1A / SCR1,CASECC,IS,NWPC,NCPW4,NMODES,ICC,NSET,NSYM,
     1                ZZZZBB,ISTR,ISUB,LENCC,IBEN,EQUAL,IEOR
      COMMON /XIFP1 / BLANK,BIT64
      COMMON /ZZZZZZ/ COREX(1)
      EQUIVALENCE     (COREX(1),COREY(1)), (CORE(1),COREY(401))
      DATA   THRU   / 4HTHRU/,EXCE / 4HEXCE/
      DATA   NIFP1C / 4H IFP,4H1C  /
C
      I81O = I81
      CORE(I81+2) = ISUB
      IF (CORE(I81+3) .NE. -1) GO TO 260
      CORE(I81) = CORE(I81+4)
      ILSET = I81 + 1
      CORE(ILSET) = 0
C
C     FIND BEGINNING OF SET LIST
C
      I81 = I81 + 5
      IF (CORE(I81) .EQ. IEOR) GO TO 270
      IREAL = 0
      IF (CORE(I81) .GT.    1) GO TO 200
      I81 = I81 + 3
      IF (CORE(I81) .EQ. IEOR) GO TO 270
      IPUT  = ILSET + 2
   20 ITHRU = 0
      IEXCPT= 0
   30 ASSIGN 20 TO IRET
      IF (CORE(I81)) 40,60,80
   40 ITHRU  = 0
      IEXCPT = 0
   50 IF (IABS(CORE(I81)) .NE. 1) IREAL = 1
      CORE(IPUT) = CORE(I81+1)
      IBK1 = IABS(CORE(I81+1))
      I81  = I81  + 2
      IPUT = IPUT + 1
      CORE(ILSET) = CORE(ILSET) + 1
      GO TO 30
C
C     CONTINUATION CARD
C
C ... ALLOW ON-LINE READ IF INTRA IS .GT. ZERO, SET BY ONLINS
C
   60 IF (INTRA .LE. 0) GO TO 65
      CALL XREAD (*240,CORE(1))
      ICC = ICC + 1
      GO TO 67
   65 CALL READ (*240,*240,SCR1,CORE(1),NWPC,0,FLAG)
      WRITE (OTPE,250) ICC,(CORE(I),I=1,NWPC)
      ICC  = ICC  + 1
      LINE = LINE + 1
      IF (LINE .GE. NLPP) CALL PAGE
   67 I81 = IPUT
      NZ  = NZ - CORE(ILSET)
      CALL XRCARD (CORE(I81),NZ,CORE(1))
      GO TO IRET, (20,120)
C
C     END OF RECORD
C
   70 I81 = IPUT
      IF (CORE(ILSET)-1) 200,230,71
   71 CONTINUE
      IF (IREAL .EQ. 1) GO TO 230
C
C     SORT LIST
C
      ISET = CORE(ILSET)
      CALL IFP1S (CORE(ILSET+2),CORE(I81),CORE(ILSET))
C
C     CORRECT FOR DELETIONS
C
      I81 = I81 + CORE(ILSET) - ISET
      GO TO 230
C
C     THRU AND EXCEPT
C
   80 IF (CORE(I81) .EQ. IEOR) GO TO 70
      IF (IREAL .EQ. 1) CALL IFP1D(-622)
      IF (BIT64) CALL MVBITS (BLANK,0,32,CORE(I81+1),0)
      IF (CORE(I81+1)  .NE. THRU) GO TO 90
      IF (CORE(ILSET)  .EQ. 0) GO TO 200
      IF (CORE(IPUT-1) .LT. 0) GO TO 280
      I81 = I81 +3
      IF (CORE(I81) .EQ. IEOR) GO TO 270
      IBK  = IBK1
      IFWD = CORE(I81+1)
      IFWD1= IFWD
      IF (IBK .GE. IFWD) GO TO 200
      ITHRU = 1
C     TEST FOR DEGENERATE THRU INTERVAL
      IF (IFWD-IBK.EQ.1) GO TO 50
      CORE(I81+1) = -CORE(I81+1)
      GO TO 50
C
C     EXCEPT
C
   90 IF (CORE(I81+1) .NE. EXCE) GO TO 200
      IF (ITHRU .EQ. 1) GO TO 110
C
C     EXCEPT WITHOUT THRU
C
      CALL IFP1D (-613)
      GO TO 220
C
C     PROCESS EXCEPT CANDIDATES
C
  110 I81 = I81 + 3
      IF (CORE(I81) .EQ. IEOR) GO TO 270
      IF (IEXCPT .EQ. 1) GO TO 280
      IEXCPT = 1
      JEXCPT = 0
  120 ASSIGN 120 TO IRET
      IF (CORE(I81)) 130,60,80
  130 IF (CORE(I81+1) .GT. IFWD1) GO TO 20
      IF (CORE(I81+1) .LT.   IBK) GO TO 200
      IF (CORE(I81+1).LE.CORE(I81-1) .AND. JEXCPT.EQ.1 .AND.
     1   (CORE(I81+2).LE.0 .OR. CORE(I81+2).EQ.IEOR)) GO TO 160
      JEXCPT = 1
      IF (CORE(I81+1) .EQ.   IBK) GO TO 290
      IF (CORE(I81+1) .EQ.  IFWD) GO TO 300
      IF (CORE(I81+1) .EQ. IFWD1) GO TO 310
      IF (CORE(I81+1)-1 .EQ. IBK) GO TO 140
      IF (CORE(I81+1)+1 .EQ.IFWD) GO TO 180
C     EXCEPT IN MIDDLE OF INTERVAL
      CORE(IPUT-1) = -CORE(I81+1) + 1
      IACIP = IABS(CORE(IPUT-1))
      IF (IACIP-IBK.EQ.1) CORE(IPUT-1) = IACIP
      CORE(IPUT  ) = CORE(I81+1)+1
      CORE(IPUT+1) = -IFWD
      IF (IFWD-CORE(IPUT).EQ.1) CORE(IPUT+1) = IFWD
      IBK = CORE(IPUT)
      I81 = I81  + 2
      IPUT= IPUT + 2
      CORE(ILSET) = CORE(ILSET) + 2
      GO TO 120
C     EXCEPT ADJACENT TO BOTTOM OF INTERVAL
  140 IL1 = CORE(IPUT-1)
      IBK = IBK + 2
      CORE(IPUT-1) = IBK
      IAL1 = IABS(IL1)
      IF (IAL1-IBK.EQ.1) IL1 = IAL1
      CORE(IPUT) = IL1
      IF (IBK .NE. IAL1) GO TO 150
      IBK  = 0
      IFWD = 0
      I81  = I81 + 2
      GO TO 120
  150 IPUT = IPUT + 1
      I81  = I81  + 2
      CORE(ILSET) = CORE(ILSET) + 1
      GO TO 120
  160 CALL IFP1D (-626)
      I81 = I81 + 2
      GO TO 120
C     EXCEPT ADJACENT TO TOP OF INTERVAL
  180 CORE(IPUT) = IABS(CORE(IPUT-1))
      IFWD = IFWD - 2
      CORE(IPUT-1) = -IFWD
      IF (IFWD-IBK .EQ. 1) CORE(IPUT-1) = IFWD
      GO TO 150
C
C     FOULED UP SET
C
  200 CALL IFP1D (-614)
  220 I81  = I81O
      NSET = NSET - 1
  230 RETURN
  240 CALL MESAGE (-1,SCR1,NIFP1C)
      GO TO 240
  250 FORMAT (11X,I8,6X,20A4)
C
C     NO NAME FOR SET
C
  260 CALL IFP1D (-615)
      GO TO 220
C
C     UNEXPECTED END OF RECORD
C
  270 CALL IFP1D (-623)
      GO TO 220
C
C     EXCEPT FOLLOWED BY THRU
C
  280 CALL IFP1D (-616)
      GO TO 220
C
C     EXCEPTING BEGINNING OF INTERVAL
C
  290 IBK = IBK + 1
      CORE(IPUT-2) = IBK
      I81 = I81 + 2
      IF (IFWD-IBK .EQ. 1) CORE(IPUT-1) = IFWD
      IF (IBK .NE. IFWD) GO TO 120
      IPUT = IPUT - 1
      CORE(ILSET) = CORE(ILSET) - 1
      IBK  = 0
      IFWD = 0
      GO TO 120
C
C     EXCEPT END OF INTERVAL
C
  300 IFWD = IFWD - 1
      CORE(IPUT-1) = -IFWD
      I81 = I81 + 2
      IF (IFWD-IBK .EQ. 1) CORE(IPUT-1) = IFWD
      IF (IBK .NE. IFWD) GO TO 20
      IPUT = IPUT - 1
      CORE(ILSET) = CORE(ILSET) - 1
      GO TO 20
C
C     EXCEPT PAST OLD END OF INTERVAL
C
  310 I81  = I81 + 2
      IPUT = IPUT- 1
      CORE(ILSET) = CORE(ILSET) - 1
      GO TO 20
      END

      SUBROUTINE TRAIL
C
C     MODULE TO INTERROGATE OR ALTER ANY VALUE OF A 6 WORD MATRIX
C     OR TABLE TRAILER
C
C     DMAP CALL
C
C        TRAILER  DB / /*OPT*/WORD/S,N,VALUE $
C
C     INPUT DATA BLOCKS
C
C        DB - DATA BLOCK FOR WHICH TRAILER IS TO BE ALTERED OR READ
C
C     PARAMETERS
C
C        OPT   - BCD,INPUT.
C                RETURN - VALUE OF SPECIFIED TRAILER WORD IS TO
C                         BE RETURNED
C                STORE  - VALUE OF SPECIFIED TRAILER WORD IS TO
C                         CHANGED
C        WORD  - INTEGER,INPUT. DESIRED WORD OF TRAILER
C        VALUE - INTEGER,INPUT OR OUTPUT. LOCATION WHERE VALUED WILL
C                RETURNED OR FROM WHICH REPLACEMENT VALUE WILL BE
C                TAKEN.  RETURNED NEGATIVE IF DB IS PURGED.
C
C     FOR MATRIX DATA BLOCKS, THE TRAILER POSITIONS ARE AS FOLLOWS
C
C        WORD 1 - NUMBER OF COLUMNS
C        WORD 2 - MUNBER OF ROWS
C        WORD 3 - MATRIX FORM
C        WORD 4 - TYPE OF ELEMENTS
C        WORD 5 - MAXIMUM NUMBER OF NON-ZERO WORDS IN ANY ONE COLUMN
C        WORD 6 - MATRIX DENSITY * 100
C
      EXTERNAL        LSHIFT  ,ANDF    ,ORF
      INTEGER         DB      ,OPT     ,WORD     ,VALUE    ,STORE(2) ,
     1                MCB(7)  ,FIAT    ,FIST     ,RETURN(2),MODNAM(2),
     2                ORF     ,ANDF
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /XFIAT / FIAT(2)
      COMMON /XFIST / FIST(2)
      COMMON /BLANK / OPT(2)  ,WORD    ,VALUE
      COMMON /SYSTEM/ IBUF    ,NOUT    ,DUM21(21),ICFIAT
      DATA    STORE / 4HSTOR  ,4HE    /
      DATA    RETURN/ 4HRETU  ,4HRN   /
      DATA    MODNAM/ 4HTRAI  ,4HLER  /
C
C     GET TRAILER
C
      DB = 101
      MCB(1) = DB
      CALL RDTRL (MCB)
      IF (MCB(1) .LE. 0) GO TO 70
C
C     TEST ILLEGAL PARAMETER VALUES AND BRANCH ON OPT
C
      IF (WORD.LT.1 .OR. WORD.GT.6) GO TO 100
      IF (OPT(1).EQ.RETURN(1) .AND. OPT(2).EQ.RETURN(2)) GO TO 10
      IF (OPT(1).EQ.STORE(1)  .AND. OPT(2).EQ.STORE(2) ) GO TO 20
      GO TO 300
C
C     RETURN OPTION
C
   10 VALUE = MCB(WORD+1)
      RETURN
C
C     STORE OPTION
C
C     SEARCH FIST FOR THE FILE
C
   20 N = FIST(2)*2 + 1
      DO 30 I = 3,N,2
      IF (FIST(I) .NE. DB) GO TO 30
      INDEX = FIST(I+1) + 1
      GO TO 40
   30 CONTINUE
      GO TO 70
C
C     PACK THE TRAILER INFORMATION INTO THE REQUESTED WORD.
C     MAKE SURE THE NUMBER IS POSITIVE AND .LE. 16 BITS IF ICFIAT=8
C
   40 IF (VALUE  .LT.  0) GO TO 200
      IF (ICFIAT .EQ. 11) GO TO 60
      IF (VALUE .GT. 65535) GO TO 200
      IW = (WORD+1)/2 + 2
      IF (WORD .EQ. (WORD/2*2)) GO TO 50
C
C     WORD IS ODD
C
      MASK = 65535
      FIAT(INDEX+IW) = ORF(ANDF(FIAT(INDEX+IW),MASK),LSHIFT(VALUE,16))
      RETURN
C
C     WORD IS EVEN
C
   50 MASK = LSHIFT(65535,16)
      FIAT(INDEX+IW) = ORF(ANDF(FIAT(INDEX+IW),MASK),VALUE)
      RETURN
C
C     ICFIAT = 11, TRAILER WORDS ARE NOT PACKED
C
   60 IW = 2
      IF (WORD .GE. 4) IW = 4
      FIAT(INDEX+IW+WORD) = VALUE
      RETURN
C
C     PURGED DATA BLOCK
C
   70 VALUE = -1
      RETURN
C
C     ERROR CONDITIONS
C
  100 WRITE  (NOUT,110) UFM,WORD
  110 FORMAT (A23,' 2202.  PARAMETER, WORD, HAS ILLEGAL VALUE OF',I9)
      GO TO 500
C
  200 WRITE  (6,210) UFM,VALUE
  210 FORMAT (A23,' 2202.  PARAMETER, VALUE, HAS ILLEGAL VALUE OF',I9)
      GO TO 500
C
  300 WRITE  (NOUT,310) UFM,OPT
  310 FORMAT (A23,' 2202.  PARAMETER, OPT, HAS ILLEGAL VALUE OF ',2A4)
C
  500 CALL MESAGE (-37,0,MODNAM)
      RETURN
      END

      SUBROUTINE DMPYAD
C
C     DMPYAD IS THE DMAP DRIVER FOR MATRIX MULTIPLICATION.
C
C     COMMENTS FROM G.CHAN/UNISYS ABOUT PREC1 IN /MPYADX/     1/91
C     ACCORDING TO THE USER'S MANUAL ON P. 3.5-18
C       PREC1 = 0, PERFORM ARITHMETIC IN D.P. IF A,B OR C IS IN D.P.
C             = 1, PERFORM ARITHMETIC IN S.P.
C             = 2, PERFORM ARITHMETIC IN D.P.
C     HOWEVER, THE CODE BELOW ALWAYS SETS
C       PREC1 TO 2, IF ANY OF THE A,B OR C IS IN D.P. AND 1 OTHERWISE
C       IN SUBROUTINE MPYAD, PREC1 IS ALWAYS SET TO 1 FOR CDC MACHINE
C
C     IF ITYPE IN /BLANK/ IS 1 OR 3, MPYAD PRODUCT WILL BE OUPUT IN S.P.
C     AND IN D.P. OF IT IS 2 OR 4
C     IF ITYPE IS 0, MPYAD PRODUCT WILL BE IN S.P. ONLY IF ALL A, B, AND
C     C MATRICES ARE IN S.P. OTHERWISE, THE PRODUCT WILL BE IN D.P.
C
      IMPLICIT INTEGER (A-Z)
      INTEGER         NAME(2)      ,DOSI(3)      ,REFUS(3)      ,
     1                P(4)  ,Q(4)  ,R(4)  ,ZZ(1) ,ZZZ(1)
      REAL            ALP(1),BET(1)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25,SWM*27
      COMMON /XMSSG / UFM   ,UWM   ,UIM   ,SFM   ,SWM
      COMMON /SYSTEM/ KSYSTM(65)
      COMMON /BLANK / T     ,SIGNAB,SIGNC ,ITYPE
      COMMON /MPYADX/ A(7)  ,B(7)  ,C(7)  ,D(7)  ,NZ    ,TRNSP  ,
     1                SAB   ,SC    ,PREC1 ,SCR
      COMMON /DMPYX / E(7)  ,F(7)  ,G(7)  ,NZZ   ,FLAG  ,SGN
      COMMON /SADDX / NOMAT ,NZZZ  ,MCBS(67)
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE     (ZZ(1),Z(1))
      EQUIVALENCE     (ZZZ(1),Z(1))
      EQUIVALENCE     (KSYSTM(55),KPREC), (KSYSTM(2),OUTPT)
      EQUIVALENCE     (MCBS( 1),P(1)   ), (MCBS( 8),TYPA  ),
     1                (MCBS( 9),ALP(1) ), (MCBS(13),Q(1)  ),
     2                (MCBS(20),TYPB   ), (MCBS(21),BET(1)),
     3                (MCBS(61),R(1)   )
      DATA    FILEA , FILEB,FILEC,FILED,SCRTCH  /
     1        101   , 102  ,103  ,201  ,301     /
      DATA    NAME  / 4HMPYA,4HD   /
      DATA    DOSI  / 4HSING,4HDOUB,4HMLTP /, REFUS/ 2*3H   ,3HREF /
      DATA    SQUARE, RECT,DIAG,SYMM,IDENT /  1,2,3,6,8  /
C
C
C     READ TRAILERS FOR A, B AND C MATRICES.
C
      NZ   = KORSZ(Z)
      A(1) = FILEA
      CALL RDTRL (A)
      IF (A(1) .NE. FILEA) GO TO 230
      B(1) = FILEB
      CALL RDTRL (B)
      IF (B(1) .NE. FILEB) GO TO 230
      C(1) = FILEC
      C(5) = 0
      CALL RDTRL (C)
      IF (C(1) .LT. 0) C(1) = 0
      D(1) = FILED
      D(3) = A(3)
      IF (T .NE. 0) D(3) = A(2)
      D(4) = RECT
C
C     CHECK FOR CONFORMABLE MATRICIES
C
      IF (((C(2).NE.B(2) .OR.  C(3).NE.D(3)) .AND. C(1).NE.0) .OR.
     1     (B(3).NE.A(2) .AND. T.EQ.0) .OR. (B(3).NE.A(3) .AND. T.NE.0))
     2     CALL MESAGE (-55,0,NAME)
      TRNSP = T
      SAB   = SIGNAB
      SC    = SIGNC
      PREC  = 1
      IF (ITYPE .EQ. 0) PREC = 0
      IF (ITYPE.EQ.2 .OR. ITYPE.EQ.4) PREC = 2
      PREC1 = MAX0(A(5),B(5),C(5))
      IF (PREC1 .GT. 2) PREC1 = PREC1 - 2
      IF (PREC1.LT.1 .OR. PREC1.GT.2) PREC1 = KPREC
      IF (PREC.EQ.PREC1 .OR. PREC.EQ.0) GO TO 20
      IF (PREC.LT.1 .OR. PREC.GT.2) PREC = 3
      WRITE  (OUTPT,10) SWM,DOSI(PREC),REFUS(PREC),NAME,DOSI(PREC1)
   10 FORMAT (A27,' 2430, REQUESTED ',A4,'LE PRECISION ',A3,'USED BY ',
     1       2A4,2H. ,A4,'LE PRECISION IS LOGICAL CHOICE')
      IF (PREC .NE. 3) PREC1 = PREC
   20 LTYPE = PREC1
      IF (A(5).EQ.3 .OR. A(5).EQ.4 .OR. B(5).EQ.3 .OR. B(5).EQ.4 .OR.
     1    C(5).EQ.3 .OR. C(5).EQ.4) LTYPE = PREC1 + 2
      IF (ITYPE.EQ.0 .OR. ITYPE.EQ.LTYPE) GO TO 40
      JJ = 1
      IF (ITYPE.LT.1 .OR. ITYPE.GT.4) JJ = 3
      WRITE  (OUTPT,30) SWM,ITYPE,REFUS(JJ),NAME,LTYPE
   30 FORMAT (A27,' 2431, REQUESTED TYPE ',I4,2H, ,A3,'USED BY ',2A4,
     1        7H. TYPE ,I4,'  IS LOGICAL CHOICE.')
      IF (JJ .NE. 3) LTYPE = ITYPE
   40 ITYPE = LTYPE
      D(5)  = ITYPE
      SCR   = SCRTCH
C
C     IF NEITHER A NOR B IS DIAGONAL, CALL MPYAD AND RETURN.
C
      IF (A(4).EQ.DIAG .OR. B(4).EQ.DIAG) GO TO 100
      CALL MPYAD (Z,Z,Z)
      IF (D(2) .NE. D(3)) GO TO 60
      D(4) = SQUARE
      IF (C(4) .EQ. 0) C(4) = DIAG
      K = 0
      DO 50 I = 4,21,7
      J = A(I)
      IF (J.NE.SYMM .AND. J.NE.DIAG .AND. J.NE.IDENT) GO TO 60
      IF (J .EQ. SYMM) K = 1
   50 CONTINUE
      IF (K .EQ. 1) D(4) = SYMM
   60 CALL WRTTRL (D)
      RETURN
C
C     OTHERWISE, CALL DMPY FOR DIAGONAL MULTIPLICATION.
C
  100 DO 110 I = 1,7
      E(I) = A(I)
      F(I) = B(I)
      IF (A(4) .EQ. DIAG) GO TO 110
      E(I) = B(I)
      F(I) = A(I)
  110 G(I) = D(I)
      NZZ  = KORSZ(ZZ)
      SGN  = SIGNAB
      FLAG = 0
      IF (B(4) .EQ. DIAG) FLAG = 1
      IF (C(1) .NE.    0) G(1) = SCRTCH
      CALL DMPY (ZZ,ZZ)
      IF (G(2) .NE. G(3)) GO TO 130
      G(4) = SQUARE
      K = 0
      DO 120 I = 4,14,7
      J = E(I)
      IF (J.NE.SYMM .AND. J.NE.DIAG .AND. J.NE.IDENT) GO TO 130
      IF (J .EQ. SYMM) K = 1
  120 CONTINUE
      IF (K .EQ. 1) G(4) = SYMM
  130 CALL WRTTRL (G)
C
C     IF ADDITION REQUIRED, CALL ADD ROUTINE.
C
      IF (C(1) .EQ. 0) RETURN
      DO 200 I = 1,7
      P(I)  = G(I)
      Q(I)  = C(I)
  200 R(I)  = D(I)
      DO 210 I = 2,4
      ALP(I)= 0.0
  210 BET(I)= 0.0
      TYPA  = 1
      ALP(1)= 1.0
      TYPB  = 1
      BET(1)= 1.0
      IF (SIGNC .LT. 0) BET(1) =-1.0
      NZZZ  = KORSZ(ZZZ)
      NOMAT = 2
      CALL SADD (ZZZ,ZZZ)
      IF (R(2) .NE. R(3)) GO TO 230
      R(4) = SQUARE
      IF (P(4).EQ.SYMM .AND. (Q(4).EQ.SYMM .OR. Q(4).EQ.DIAG .OR.
     1    Q(4).EQ.IDENT)) R(4) = SYMM
      CALL WRTTRL (R)
  230 RETURN
      END

      SUBROUTINE IFP4B (FILE,SCRT,ANY,SPACE,LSPACE,RECID,EOF)
C
C     THIS ROUTINE, CALLED BY IFP4, COPIES DATA FROM -FILE- TO -SCRT-
C     UP TO THE -RECID- SPECIFIED IF IT EXISTS AND COPIES THE -RECID-
C     IN ANY EVENT.  -ANY- IS SET TRUE IF THE -RECID- WAS FOUND.
C     -EOF- IS SET TRUE AS SOON AS AN END OF FILE IS HIT ON -FILE-.
C     -SPACE- IS A WORKING AREA OF LENGTH -LSPACE-.  IF RECID(1) = -1,
C     THE BALANCE OF -FILE- IS COPIED TO -SCRT- AND THEN -FILE- IS
C     REWOUND AND -SCRT- IS COPIED BACK ONTO -FILE-.  BOTH FILES ARE
C     THEN CLOSED.
C
      LOGICAL         EOF,ANY,BIT,NOGO
      INTEGER         FILE,SCRT,SPACE(5),RECID(2),OUTPUT,NAME(2),SYSBUF,
     1                FLAG,BUF1,BUF2,REC(3),ILIMIT(3),EOR
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /SYSTEM/ SYSBUF,OUTPUT,NOGO
      COMMON /NAMES / RD,RDREW,WRT,WRTREW,CLSREW,CLS
      DATA    NAME  , NOEOR,EOR  /4HIFP4,4HB   ,0,1/,
     1        ILIMIT/ 3*2147483647 /
C
      IF (RECID(1) .EQ. -1) GO TO 3000
      ANY = .FALSE.
C
C     CHECK TRAILER BIT TO SEE IF RECORD EXISTS
C
      CALL IFP4F (RECID(2),FILE,BIT)
      IF (.NOT.BIT) GO TO 2000
      IF (EOF) GO TO 5001
C
C     READ A 3-WORD RECORD ID
C
      ANY = .TRUE.
      IFILE = FILE
  650 CALL READ  (*5001,*6002,FILE,REC(1),3,NOEOR,FLAG)
      CALL WRITE (SCRT,REC,3,NOEOR)
      IF (REC(1) .EQ. RECID(1)) RETURN
C
C     NOT THE CORRECT RECORD, THUS COPY BALANCE OF RECORD OVER.
C
  750 CALL READ  (*6001,*800,FILE,SPACE,LSPACE,NOEOR,FLAG)
      CALL WRITE (SCRT,SPACE,LSPACE,NOEOR)
      GO TO 750
  800 CALL WRITE (SCRT,SPACE,FLAG,EOR)
      GO TO 650
C
C     RECORD DOES NOT CURRENTLY EXIST, THUS START ONE
C
 2000 CALL WRITE (SCRT,RECID,2,NOEOR)
      CALL WRITE (SCRT,0,1,NOEOR)
C
C     PUT BIT IN TRAILER
C
      CALL IFP4G (RECID(2),FILE)
      RETURN
C
C     WRAP UP FILES
C
 3000 IF (EOF) GO TO 3400
 3100 CALL READ  (*3500,*3200,FILE,SPACE,LSPACE,NOEOR,FLAG)
      CALL WRITE (SCRT,SPACE,LSPACE,NOEOR)
      GO TO 3100
 3200 CALL WRITE (SCRT,SPACE,FLAG,EOR)
      GO TO 3100
 3400 CALL WRITE (SCRT,ILIMIT,3,EOR)
C
C     FILE IS ALL COPIED TO SCRT.  REWIND AND RETURN.
C
 3500 EOF = .TRUE.
      CALL CLOSE (SCRT,CLSREW)
      CALL CLOSE (FILE,CLSREW)
C
C     COPY DATA FROM SCRT TO FILE.
C
      BUF1 = 1
      BUF2 = SYSBUF + 2
      I    = 2*SYSBUF + 4
      J    = LSPACE - I
      IF (I .GT. LSPACE) CALL MESAGE (-8,0,NAME)
      IFILE = FILE
      CALL OPEN (*6003,FILE,SPACE(BUF1),WRTREW)
      IFILE = SCRT
      CALL OPEN  (*6003,SCRT,SPACE(BUF2),RDREW)
 3800 CALL READ  (*4000,*3900,SCRT,SPACE(I),J,NOEOR,FLAG)
      CALL WRITE (FILE,SPACE(I),J,NOEOR)
      GO TO 3800
 3900 CALL WRITE (FILE,SPACE(I),FLAG,EOR)
      GO TO 3800
 4000 CALL CLOSE (SCRT,CLSREW)
      CALL CLOSE (FILE,CLSREW)
      RETURN
C
C     ERROR CONDITIONS
C
 5001 NOGO = .TRUE.
      WRITE  (OUTPUT,5002) UFM,RECID(1),RECID(2),FILE
 5002 FORMAT (A23,' 4056, RECORD ID =',2I10,' IS OUT OF SYNC ON DATA ',
     1       'BLOCK NUMBER',I10, /5X,'AN IFP4 SYSTEM ERROR.')
      EOF = .TRUE.
      RETURN
C
 6001 CALL MESAGE (-2,IFILE,NAME)
 6002 CALL MESAGE (-3,IFILE,NAME)
 6003 CALL MESAGE (-1,IFILE,NAME)
      RETURN
      END

      SUBROUTINE BISHEL(*,LIST,NENT,NTERM,ARRAY)
C-----
C   BISHEL IS A MERGE/SORT/DUPLICATE ENTRY ELIMINATOR.  GIVEN A SORTED
C -ARRAY- AND A -LIST- TO MERGE, BISHEL ADDS THE -LIST- IN THE SORTED
C LOCATION.  SORT IS ONLY ON THE FIRST WORD OF LIST.
C
C   ARGUMENTS...
C
C     LIST  -- IN/OUT - LIST OF LENGTH NTERM TO MERGE INTO ARRAY.
C     NENT  -- IN/OUT - LENGTH OF LIST BEFORE/AFTER MERGE.
C     NTERM -- IN     - LENGTH OF ARRAY (AND LIST) ENTRIES.
C     ARRAY -- IN/OUT - ARRAY TO MERGE LIST INTO.
C     NONSTANDARD RETURN -- WHEN ARRAY(ITERM) IS A DUPLICATE.
C-----
      INTEGER LIST(1),ARRAY(1)
C
      K = 1
      L = NENT + 1
      M = NENT - NTERM + 1
C
C  . LOCATE DUPLICATES...
C
      IF (NENT.LT.NTERM) GO TO 50
      IF (LIST(1) - ARRAY(M) ) 10,20,60
   10 KID = LIST(1)
      CALL BISLOC (*30, KID, ARRAY, NTERM, NENT/NTERM, K)
   20 RETURN 1
C
C  . CREATE A HOLE IN THE LIST BY MOVING THE END OF THE LIST...
C
   30 CONTINUE
      J = L-K
      N = NENT+NTERM
      DO 40 I = 1,J
      M = L-I
      ARRAY(N) = ARRAY(M)
   40 N = N-1
C
C  . LOAD LIST INTO HOLE...
C
      GO TO 70
   50 NENT = 0
      GO TO 70
   60 K = L
   70 CONTINUE
      DO 80 I = 1,NTERM
      ARRAY(K)=LIST(I)
   80 K = K+1
      NENT = NENT + NTERM
      RETURN
      END

      SUBROUTINE XYCHAR (ROW,COL,CHAR)
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        LSHIFT,RSHIFT,ANDF,ORF,COMPLF
      LOGICAL         PASS,EXCEED
      DIMENSION       MASK(4)
      COMMON /MACHIN/ MACH
      COMMON /SYSTEM/ DUM(38),BPERCH,BPERWD
      COMMON /XYPPPP/ IFRAME,TITLEC(32),TITLEL(14),TITLER(14),
     1                XTITLE(32),ID(300),MAXPLT,XMIN,XINC,EXCEED,
     2                I123,MAXROW
      COMMON /ZZZZZZ/ Z(1)
      DATA    PASS  / .FALSE. /
C
      IF (ROW .LE. MAXROW) GO TO 1
      EXCEED = .TRUE.
      RETURN
C
    1 IF (COL.GT.119 .OR. COL.LT.1 .OR. ROW.LT.1) RETURN
C
C     CHAR COMING IN IS ASSUMED LEFT ADJUSTED
C
      IF (PASS) GO TO 20
      PASS = .TRUE.
C
C     SET UP MASKS FIRST TIME THROUGH AFTER LOADING
C
      N = 2**BPERCH  -  1
      ISHIFT = BPERWD - BPERCH
      N = LSHIFT(N,ISHIFT)
      NMASK = N
      DO 10 I = 1,4
      MASK(I) = COMPLF(N)
      N = RSHIFT(N,BPERCH)
   10 CONTINUE
C
C     COMPUTE WORD AND CHARACTER OF WORD
C
   20 IWORD = (COL-1)/4 + 1
      ICHAR = COL - (IWORD-1)*4
      IWORD = (ROW-1)*30 + IWORD
C
C     PACK THE CHARACTER
C
      IF (MACH.EQ.5 .OR. MACH.EQ.6 .OR. MACH.EQ.21) GO TO 30
      LET = RSHIFT(ANDF(CHAR,NMASK),BPERCH*(ICHAR-1))
      Z(IWORD) = ORF(ANDF(Z(IWORD),MASK(ICHAR)),LET)
      RETURN
C
C     VAX, ULTRIX, AND ALPHA
C
   30 Z(IWORD) = KHRFN1(Z(IWORD),ICHAR,CHAR,1)
      RETURN
      END

      SUBROUTINE LINKUP (*,NAME)
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        LSHIFT,RSHIFT,ANDF,ORF,COMPLF
      DIMENSION       NAME(2)
      COMMON /MACHIN/ MACHX
      COMMON /LNKLST/ ITOP,IBOT,ISN,KIND,ITYPE,MASK1,MASK2,MASK3
      COMMON /ZZZZZZ/ Z(1)
C
C     HASH INTO TABLE
C
      GO TO (10,10,10,20,30,30,10,30,30,30,   30,40,10,40,40,30,30,30,
     1       30,30,   30,30), MACHX
C
C     IBM AND UNIVAC
C
   10 ITOTAL = NAME(1) + NAME(2)
      GO TO 50
C
C     60-BIT MACHINE
C
   20 ITOTAL = RSHIFT(NAME(1),18) + RSHIFT(NAME(2),18)
      GO TO 50
C
C     32-BIT MACHINES
C
   30 ITOTAL = RSHIFT(NAME(1), 1) + RSHIFT(NAME(2), 1)
      GO TO 50
C
C     64-BIT MACHINES
C
   40 ITOTAL = RSHIFT(NAME(1),32) + RSHIFT(NAME(2),32)
C
   50 IHASH = 4*IABS(MOD(ITOTAL,250)) + 4
      K = ANDF(Z(IHASH),MASK1)
      IF (K.NE.0) GO TO 60
C
C     NO HASH CHAIN FOUND - CREATE CHAIN
C
      Z(IHASH) = Z(IHASH) + ITOP
      GO TO 90
C
C     HASH CHAIN FOUND - CHECK PRESENCE OF NAME
C
   60 IF (Z(K).NE.NAME(1) .OR. Z(K+1).NE.NAME(2)) GO TO 70
      IKIND = RSHIFT(ANDF(Z(K+3),MASK3),28)
      IF ((IKIND+1)/2 .EQ. (KIND+1)/2) GO TO 100
   70 L = ANDF(Z(K+3),MASK2)
      IF (L .EQ. 0) GO TO 80
      K = RSHIFT(L,14)
      GO TO 60
   80 Z(K+3) = Z(K+3) + LSHIFT(ITOP,14)
C
C     NO ENTRY FOUND - CREATE ENTRY
C
   90 Z(ITOP  ) = NAME(1)
      Z(ITOP+1) = NAME(2)
      Z(ITOP+2) = LSHIFT(ITYPE,28)
      Z(ITOP+3) = Z(ITOP+3) + LSHIFT(IABS(KIND),28)
      ITOP = ITOP + 4
      IF (ITOP .GE. IBOT) RETURN 1
      IF (KIND .LT.    0) RETURN
      K = ITOP - 4
C
C     ADD STATEMENT NUMBER TO LIST
C
  100 L = ANDF(Z(K+2),MASK1)
      IF (L .NE. 0) GO TO 110
C
C     LIST IS EMPTY - START LIST
C
      Z(K+2) = Z(K+2) + IBOT
      GO TO 120
C
C     CHAIN ENTRY ON LIST
C
  110 L    = RSHIFT(ANDF(Z(K+2),MASK2),14)
      Z(L) = ANDF(Z(L),COMPLF(MASK2))
      Z(L) = ORF(Z(L),LSHIFT(IBOT,14))
C
C     ADD ENTRY TO LIST
C
  120 Z(IBOT)= ORF(LSHIFT(KIND,28),ISN)
      Z(K+2) = ANDF(Z(K+2),COMPLF(MASK2))
      Z(K+2) = Z(K+2) + LSHIFT(IBOT,14)
      IBOT   = IBOT - 1
      IF (ITOP .GE. IBOT) RETURN 1
      RETURN
      END

      SUBROUTINE CMDISC
C
C     THIS SUBROUTINE DETERMINES THE DISCONNECTED DEGREES OF FREEDOM
C     AND GENERATES  DISCONNECTION ENTRIES  WHICH ARE MERGED WITH THE
C     CONNECTION ENTRIES
C
      EXTERNAL        ORF
      INTEGER         SCSFIL,Z,SCORE,COMBO,IPTR(7),SCCONN,BUF3,CE(9),
     1                ORF,SCDISC,DE(9),AAA(2),SCR1,SCR2,BUF2,OUTT
      COMMON /CMB001/ SCR1,SCR2,SCBDAT,SCSFIL,SCCONN,SCMCON,SCTOC,
     1                GEOM4,CASECC
      COMMON /CMB002/ BUF1,BUF2,BUF3,BUF4,BUF5,SCORE,LCORE,INPT,OUTT
      COMMON /CMB003/ COMBO(7,5),CONSET,IAUTO,TOLER,NPSUB
      COMMON /CMB004/ TDAT(6),NIPNEW
      COMMON /ZZZZZZ/ Z(1)
      DATA    AAA   / 4HCMDI,4HSC   /
C
C
      NWD = NPSUB+2
      ISVCOR = SCORE
      ITOT = 0
      ILEN = LCORE
      NN = 0
      KK = SCORE
      CALL OPEN (*200,SCSFIL,Z(BUF3),0)
C
C     LOOP ON THE NUMBER OF PSEUDO STRUCTURES READING THE SIL,C TABLE
C     INTO CORE FOR EACH.  THE ARRAY IPTR(I) POINTS TO THE START OF
C     THE I-TH TABLE IN CORE
C
      DO 40 I = 1,NPSUB
      NCSUB = COMBO(I,5)
C
C     FIND SIL, C TABLE
C
      DO 10 J = 1,NCSUB
      CALL FWDREC (*210,SCSFIL)
   10 CONTINUE
      KK = KK + NN
      IPTR(I) = KK
      CALL READ (*210,*20,SCSFIL,Z(KK),LCORE,1,NN)
      GO TO 220
C
C     ZERO OUT SIL VALUES, LOCATION WILL STORE CNEW
C
   20 DO 30 J = 1,NN,2
      Z(KK+J-1) = 0
   30 CONTINUE
      LCORE = LCORE - NN
      ITOT  = ITOT + NN
      CALL SKPFIL (SCSFIL,1)
   40 CONTINUE
      CALL CLOSE (SCSFIL,1)
C
C     ALL EQSS HAVE BEEN PROCESSED, NOW SCAN THE CONNECTION ENTRIES
C     AND GET CNEW VALUES.
C
      CALL OPEN (*200,SCCONN,Z(BUF3),0)
C
C     READ AND PROCESS CONNECTION ENTRIES ONE AT A TIME
C
   50 CALL READ (*80,*60,SCCONN,CE,10,1,NN)
   60 DO 70 I = 1,NPSUB
      IF (CE(2+I) .EQ. 0) GO TO 70
C
C     TRANSLATE CODED IP TO ACTUAL IP, COMPUTE LOCATION IN OPEN CORE
C     AND UPDATE CNEW
C
      IP = CE(2+I) - 1000000*(CE(2+I)/1000000)
      LOC = IPTR(I) + 2*IP - 2
      Z(LOC) = ORF(Z(LOC),CE(1))
   70 CONTINUE
      GO TO 50
C
C     ALL CONNECTIONS HAVE BEEN ACCOUNTED FOR,NOW DETERMINE DISCONN.
C
   80 CONTINUE
      SCDISC = SCR1
      IF (SCR1 .EQ. SCCONN) SCDISC = SCR2
      CALL OPEN (*200,SCDISC,Z(BUF2),1)
      DO 130 I = 1,NPSUB
      IF (I .LT. NPSUB) LEN = IPTR(I+1) - IPTR(I)
      IF (I .EQ. NPSUB) LEN = ITOT - IPTR(I)
      ISTRT = IPTR(I)
      DO 120 J = 1,LEN,2
      DO 90 KDH = 1,9
      DE(KDH) = 0
   90 CONTINUE
      IP  = J/2 + 1
      LOC = ISTRT + J - 1
C
C     POINT IS TOTALLY DISCONNECTED
C
      IF (Z(LOC) .EQ. Z(LOC+1)) GO TO 120
      IF (Z(LOC) .NE. 0) GO TO 100
C
C     POINT IS TOTALLY CONNECTED
C
      DE(1) = Z(LOC+1)
      DE(2) = 2**I
      DE(2+I) = IP
      GO TO 110
C
C     POINT IS PARTIALLY DISCONNECTED
C
  100 DE(1) = Z(LOC+1) - Z(LOC)
      DE(2) = 2**I
      DE(2+I) = IP
  110 CALL WRITE (SCDISC,DE,NWD,1)
  120 CONTINUE
  130 CONTINUE
      CALL EOF (SCDISC)
      CALL CLOSE (SCDISC,1)
      KK = SCORE
      LCORE = ILEN
      CALL OPEN (*200,SCDISC,Z(BUF2),0)
      CALL REWIND (SCCONN)
      ID = 1
  140 CALL READ (*150,*160,SCDISC,Z(KK),LCORE,1,NNN)
      GO TO 220
  150 ID = 2
      CALL READ (*170,*160,SCCONN,Z(KK),LCORE,1,NNN)
      GO TO 220
  160 KK = KK + NWD
      LCORE = LCORE - NWD
      IF (LCORE .LT. NWD) GO TO 220
      IF (ID .EQ. 1) GO TO 140
      GO TO 150
  170 CALL CLOSE (SCCONN,1)
      CALL CLOSE (SCDISC,1)
      CALL OPEN (*200,SCCONN,Z(BUF3),1)
      LEN = KK - SCORE
      NIPNEW = LEN/NWD
      DO 180 I = 1,LEN,NWD
      Z(SCORE+I) = IABS(Z(SCORE+I))
  180 CONTINUE
      CALL SORT (0,0,NWD,2,Z(SCORE),LEN)
      DO 190 I = 1,LEN,NWD
      CALL WRITE (SCCONN,Z(SCORE+I-1),NWD,1)
  190 CONTINUE
      CALL EOF (SCCONN)
      CALL CLOSE (SCCONN,1)
      CALL CLOSE (SCDISC,1)
      SCORE = ISVCOR
      LCORE = ILEN
      RETURN
C
  200 IMSG = -1
      GO TO 230
  210 IMSG = -2
      GO TO 230
  220 IMSG = -8
  230 CALL MESAGE (IMSG,IFILE,AAA)
      RETURN
      END

      SUBROUTINE FA1PKI (FSAVE,QHHL)
C
C     FA1PKI BUILDS AN INTERPOLATION MATRIX IN CORE FOR PK METHOD
C
C     LAST REVISED  2/91, BY J.PETKAS/LOOKHEED
C     TO ALLOW CALCULATION OF INTERPOLATION MATRIX IN D.P.
C
      INTEGER         FSAVE,QHHL,SYSBUF,NAME(2),TRL(7),BUF1,FLOOP
      REAL            NEWM
      DOUBLE PRECISION DX1,DX2,DET,DZ(1)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /BLANK / FLOOP
      COMMON /SYSTEM/ SYSBUF,NOUT
      COMMON /UNPAKX/ IOUT,INN,NNN,INCR1
      COMMON /ZZZZZZ/ Z(1)
      COMMON /FA1PKC/ NCORE,NK,IMVR,IK,IA,IQ,ICP,IFLAG
      EQUIVALENCE     (DZ(1),Z(1))
      DATA    OLDM  / -1.0/
      DATA    NAME  / 4HFA1P,4HKI  /
C
      IFLAG = 0
      IF (OLDM .NE. -1.0) GO TO 20
      NCORE= KORSZ(Z)
      BUF1 = NCORE - SYSBUF
      IMVR = 1
C
C     PUT M V   IN CORE ON SECOND LOOP RETURN IF SAME MACH
C
      IFLE = FSAVE
      CALL GOPEN (FSAVE,Z(BUF1),0)
      CALL READ (*180,*10,FSAVE,Z(IMVR),BUF1,1,NWR)
   10 IK = IMVR + NWR
      CALL CLOSE (FSAVE,1)
   20 I = (FLOOP-1)*3 + IMVR
      NEWM = Z(I)
      IF (OLDM .EQ. NEWM) GO TO 200
      OLDM = NEWM
      IFLAG= 1
C
C     PUT LIST OF M K'S IN CORE FOR THIS MACH
C
      TRL(1) = QHHL
      CALL RDTRL (TRL)
      NROW = TRL(3)
      NI   = (TRL(2)/TRL(3))*2
      IOUT = 3
      INN  = 1
      INCR1= 1
      NNN  = NROW
      N2   = NROW*2
      NN   = NROW*NROW
      IFLE = QHHL
      CALL OPEN (*180,QHHL,Z(BUF1),0)
      CALL READ (*180,*180,QHHL,Z,-3,0,NWR)
      CALL READ (*180,*180,QHHL,N, 1,0,NWR)
      N  = N + N
      NI = MIN0(NI,N)
      CALL READ (*180,*180,QHHL,Z(IK),NI,1,NWR)
C
C     FIND M'S CLOSEST TO NEWM
C
      IA  = IK + NI
      IF (MOD(IA,2) .EQ. 0) IA = IA + 1
      RMI = 1.E20
      RMS = 0.0
      DO 30 I = 1,NI,2
      RMX = ABS(Z(IK+I-1)-NEWM)
      RMI = AMIN1(RMI,RMX)
      IF (RMX .GT. RMI) GO TO 30
      RMS = Z(IK+I-1)
   30 CONTINUE
      RMI = RMS
C
C     COUNT K"S
C
      NK = 0
      DO 50 I = 1,NI,2
      IF (Z(IK+I-1) .EQ. RMI) GO TO 40
      GO TO 50
   40 NK = NK + 1
   50 CONTINUE
C
C     ALLOCATE CORE FOR A-1 AND Q.  THEN BUILD THEM.
C
      I  = 2*(NK+1)**2
      IQ = IA + I
      ICP= IQ + NN*2*NK
      IF (MOD(ICP,2) .EQ. 0) ICP = ICP + 1
      IF (ICP+SYSBUF+N2 .GT. NCORE) CALL MESAGE (-8,0,NAME)
C
C     BUILD A
C
      J = 0
      DO 70 I = 1,NI,2
      IF (Z(IK+I-1) .EQ. RMI) GO TO 60
      GO TO 70
   60 Z(IQ+J) = Z(IK+I)
      J = J + 1
   70 CONTINUE
      NK1 = NK + 1
      N   = 0
      M   = IQ - 1
      IAD = IA/2  + 1
      ICPD= ICP/2 + 1
      DO 90 I = 1,NK1
      DX2 = Z(M+I)
      DO 90 J = 1,NK1
      IF (I.EQ.NK1 .AND. J.EQ.NK1) GO TO 100
      IF (J.EQ.NK1 .OR.  I.EQ.NK1) GO TO 75
      DX1 = Z(M+J)
      DZ(IAD+N) = DABS((DX1-DX2)**3) + (DX1+DX2)**3
      GO TO 80
   75 DZ(IAD+N) = 1.0D+0
   80 N = N + 1
   90 CONTINUE
  100 DZ(IAD+N) = 0.0D+0
C
C     MODIFICATION FOR LEVEL 17.7 UPDATE
C     REPLACE ALL CALLS TO INVAER WITH CALLS TO INVERS.
C     NO NEED TO COMPUTE DETERMINANT SINCE IT IS NOT USED SUBSEQUENTLY.
C
      ISING = -1
      CALL INVERD (NK1,DZ(IAD),NK1,0,0,DET,ISING,DZ(ICPD))
      IF (ISING .EQ. 2) GO TO 150
C
C     BUILD Q
C
      N  = 0
      IN = NN
      L  = 0
      DO 140 I = 1,NI,2
      IF (Z(IK+I-1) .EQ. RMI) GO TO 110
      CALL SKPREC (QHHL,NROW)
      GO TO 140
  110 DO 130 J = 1,NROW
      CALL UNPACK (*115,QHHL,Z(ICP))
      GO TO 120
  115 CALL ZEROC (Z(ICP),NROW*2)
C
C     SPLIT REAL AND IMAGINARY DIVIDE IMAGINARY BY K
C
  120 DO 125 K = 1,N2,2
      Z(IQ+N) = Z(ICP+K-1)
      N = N + 1
      Z(IQ+IN) = Z(ICP+K)/Z(IK+I)
      IN = IN + 1
  125 CONTINUE
  130 CONTINUE
      Z(IK+L) = Z(IK+I)
      L = L  + 1
      N = N  + NN
      IN= IN + NN
  140 CONTINUE
      CALL CLOSE (QHHL,1)
      GO TO 200
C
  150 WRITE  (NOUT,160) UFM,NAME
  160 FORMAT (A23,' 2427, SINGULAR MATRIX FOR INTERPOLATION IN ',2A4)
      CALL MESAGE (-61,0,0)
  180 CALL MESAGE (-2,IFLE,NAME)
  200 RETURN
      END

      SUBROUTINE OFP1B (LINE)
C
C     THIS SUBROUTINE WAS FORMED ONLY TO REDUCE THE SIZE OF OFP1 FOR
C     COMPILATION PURPOSES.  IT IS CALLED ONLY BY OFP1.
C     PREVIOUSLY THIS ROUTINE WAS NAMED OPF1A.
C
      DIMENSION       FD(50),ID(50),OF(6)
      COMMON /SYSTEM/ IBUF,L,NOGO
      COMMON /ZZZZZZ/ CORE(1)
      EQUIVALENCE     (CORE(1),OF(1)),(ID(1),FD(1),OF(6))
      DATA            IDUM1, IDUM2, IDUM3, IDUM4, IDUM5, IDUM6 /
     1                4HDUM1,4HDUM2,4HDUM3,4HDUM4,4HDUM5,4HDUM6/,
     2                IDUM7, IDUM8, IDUM9 /
     3                4HDUM7,4HDUM8,4HDUM9/
C
      IF (LINE .GT. 294) GO TO 10
      LOCAL = LINE - 174
      GO TO (175,176,177,178,179,180,181,182,183,184,185,186,187,188,189
     1      ,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204
     2      ,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219
     3      ,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234
     4      ,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249
     5      ,250,251,252,253,254,255,256,257,258,259,260,261,262,263,264
     6      ,265,266,267,268,269,270,271,272,273,274,275,276,277,278,279
     7      ,280,281,282,283,284,285,286,287,288,289,290,291,292,293,294
     8      ), LOCAL
   10 IF (LINE .GT. 380) RETURN
      LOCAL = LINE - 294
      GO TO (295,296,297,298,299,300,301,302,303,304,305,306,307,308,309
     9      ,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324
     X      ,325,326,327,328,329,330,331,332,333,334,335,336,337,338,339
     B      ,340,341,342,343,344,345,346,347,348,349,350,351,352,353,354
     C      ,355,356,357,358,359,360,361,362,363,364,365,366,367,368,369
     D      ,370,371,372,373,374,375,376,377,378,379,380) LOCAL
  175 CONTINUE
      GO TO 1000
  176 WRITE (L,676)
      GO TO 1000
  177 WRITE (L,677)
      GO TO 1000
  178 WRITE (L,678)
      GO TO 1000
  179 WRITE (L,679)
      GO TO 1000
  180 WRITE (L,680)
      GO TO 1000
  181 WRITE (L,681)
      GO TO 1000
  182 WRITE (L,682)
      GO TO 1000
  183 WRITE (L,683)
      GO TO 1000
  184 WRITE (L,684)
      GO TO 1000
  185 WRITE (L,685)
      GO TO 1000
  186 WRITE (L,686)
      GO TO 1000
  187 WRITE (L,687)
      GO TO 1000
  188 WRITE (L,688)
      GO TO 1000
  189 WRITE (L,689)
      GO TO 1000
  190 WRITE (L,690)
      GO TO 1000
  191 WRITE (L,691)
      GO TO 1000
  192 WRITE (L,692)
      GO TO 1000
  193 WRITE (L,693)
      GO TO 1000
  194 WRITE (L,694)
      GO TO 1000
  195 WRITE (L,695)
      GO TO 1000
  196 WRITE (L,696)
      GO TO 1000
  197 WRITE (L,697)
      GO TO 1000
  198 WRITE (L,698)
      GO TO 1000
  199 WRITE (L,699)
      GO TO 1000
  200 WRITE (L,700)
      GO TO 1000
  201 WRITE (L,701)
      GO TO 1000
  202 WRITE (L,702) ID(3)
      GO TO 1000
  203 WRITE (L,703)
      GO TO 1000
  204 WRITE (L,704)
      GO TO 1000
  205 WRITE (L,705)
      GO TO 1000
  206 WRITE (L,706)
      GO TO 1000
  207 WRITE (L,707)
      GO TO 1000
  208 WRITE (L,708)
      GO TO 1000
  209 WRITE (L,709)
      GO TO 1000
  210 WRITE (L,710)
      GO TO 1000
  211 WRITE (L,711)
      GO TO 1000
  212 WRITE (L,712)
      GO TO 1000
  213 WRITE (L,713)
      GO TO 1000
  214 WRITE (L,714) ID(5)
      GO TO 1000
  215 WRITE (L,715)
      GO TO 1000
  216 WRITE (L,716) (ID(K),K=11,14),ID(17),FD(18),(ID(K),K=19,21)
      IF (ID(17) .EQ. 1) WRITE (L,7161)
      IF (ID(17) .NE. 1) WRITE (L,7162)
      IF (ID(17) .NE. 1) NOGO = 14
      GO TO 1000
  217 WRITE (L,717)
      GO TO 1000
  218 WRITE (L,718)
      GO TO 1000
  219 WRITE (L,719)
      GO TO 1000
  220 WRITE (L,720)
      GO TO 1000
  221 WRITE (L,721)
      GO TO 1000
  222 WRITE (L,722)
      GO TO 1000
  223 WRITE (L,723)
      GO TO 1000
  224 WRITE (L,724)
      GO TO 1000
  225 WRITE (L,725)
      GO TO 1000
  226 WRITE (L,726)
      GO TO 1000
  227 WRITE (L,727)
      GO TO 1000
  228 WRITE (L,728)
      GO TO 1000
  229 IDD   = MOD(ID(5),500000)
      JHARM = (ID(5)-IDD)/500000
      IHARM = (JHARM-1)/2
      IF (MOD(JHARM,2) .EQ. 1) GO TO 1229
      WRITE (L,729) IDD,IHARM
      GO TO 1000
 1229 WRITE (L,1729) IDD,IHARM
      GO TO 1000
  230 WRITE (L,730)
      GO TO 1000
  231 WRITE (L,731)
      GO TO 1000
  232 WRITE (L,732)
      GO TO 1000
  233 WRITE (L,733)
      GO TO 1000
  234 WRITE (L,734)
      GO TO 1000
  235 WRITE (L,735)
      GO TO 1000
  236 WRITE (L,736)
      GO TO 1000
  237 WRITE (L,737)
      GO TO 1000
  238 WRITE (L,738)
      GO TO 1000
  239 WRITE (L,739)
      GO TO 1000
  240 WRITE (L,740)
      GO TO 1000
  241 WRITE (L,741)
      GO TO 1000
  242 WRITE (L,742)
      GO TO 1000
  243 WRITE (L,743)
      GO TO 1000
  244 WRITE (L,744)
      GO TO 1000
  245 WRITE (L,745)
      GO TO 1000
  246 WRITE (L,746)
      GO TO 1000
  247 WRITE (L,747)
      GO TO 1000
  248 WRITE (L,748)
      GO TO 1000
  249 WRITE (L,749)
      GO TO 1000
  250 WRITE (L,750)
      GO TO 1000
  251 WRITE (L,751)
      GO TO 1000
  252 WRITE (L,752)
      GO TO 1000
  253 WRITE (L,753)
      GO TO 1000
  254 IDX = IDUM1
      GO TO 1754
  255 IDX = IDUM2
      GO TO 1754
  256 IDX = IDUM3
      GO TO 1754
  257 IDX = IDUM4
      GO TO 1754
  258 IDX = IDUM5
      GO TO 1754
  259 IDX = IDUM1
      GO TO 1759
  260 IDX = IDUM2
      GO TO 1759
  261 IDX = IDUM3
      GO TO 1759
  262 IDX = IDUM4
      GO TO 1759
  263 IDX = IDUM5
      GO TO 1759
  264 WRITE (L,764)
      GO TO 1000
  265 WRITE (L,765)
      GO TO 1000
  266 IDX = IDUM1
      GO TO 1766
  267 IDX = IDUM2
      GO TO 1766
  268 IDX = IDUM3
      GO TO 1766
  269 IDX = IDUM4
      GO TO 1766
  270 IDX = IDUM5
      GO TO 1766
  271 IDX = IDUM1
      GO TO 1771
  272 IDX = IDUM2
      GO TO 1771
  273 IDX = IDUM3
      GO TO 1771
  274 IDX = IDUM4
      GO TO 1771
  275 IDX = IDUM5
      GO TO 1771
  276 WRITE (L,776)
      GO TO 1000
  277 WRITE (L,777)
      GO TO 1000
  278 WRITE (L,778)
      GO TO 1000
  279 WRITE (L,779)
      GO TO 1000
  280 IDX = IDUM6
      GO TO 1754
  281 IDX = IDUM7
      GO TO 1754
  282 IDX = IDUM8
      GO TO 1754
  283 IDX = IDUM9
      GO TO 1754
  284 IDX = IDUM6
      GO TO 1759
  285 IDX = IDUM7
      GO TO 1759
  286 IDX = IDUM8
      GO TO 1759
  287 IDX = IDUM9
      GO TO 1759
  288 IDX = IDUM6
      GO TO 1766
  289 IDX = IDUM7
      GO TO 1766
  290 IDX = IDUM8
      GO TO 1766
  291 IDX = IDUM9
      GO TO 1766
  292 IDX = IDUM6
      GO TO 1771
  293 IDX = IDUM7
      GO TO 1771
  294 IDX = IDUM8
      GO TO 1771
  295 IDX = IDUM9
      GO TO 1771
  296 WRITE (L,796)
      GO TO 1000
  297 WRITE (L,797)
      GO TO 1000
  298 WRITE (L,798)
      GO TO 1000
  299 WRITE (L,799)
      GO TO 1000
  300 WRITE (L,800)
      GO TO 1000
  301 WRITE (L,801)
      GO TO 1000
  302 WRITE (L,802)
      GO TO 1000
  303 WRITE (L,803)
      GO TO 1000
  304 WRITE (L,804)
      GO TO 1000
  305 WRITE (L,805)
      GO TO 1000
  306 WRITE (L,806)
      GO TO 1000
  307 WRITE (L,807)
      GO TO 1000
  308 WRITE (L,808)
      GO TO 1000
  309 WRITE (L,809)
      GO TO 1000
  310 WRITE (L,810)
      GO TO 1000
  311 WRITE (L,811)
      GO TO 1000
  312 WRITE (L,812)
      GO TO 1000
  313 WRITE (L,813)
      GO TO 1000
  314 WRITE (L,814)
      GO TO 1000
  315 WRITE (L,815)
      GO TO 1000
  316 WRITE (L,816)
      GO TO 1000
  317 WRITE (L,817)
      GO TO 1000
  318 WRITE (L,818)
      GO TO 1000
  319 WRITE (L,819)
      GO TO 1000
  320 WRITE (L,820)
      GO TO 1000
  321 WRITE (L,821)
      GO TO 1000
  322 WRITE (L,822)
      GO TO 1000
  323 WRITE (L,823)
      GO TO 1000
  324 WRITE (L,824)
      GO TO 1000
  325 WRITE (L,825)
      GO TO 1000
  326 WRITE (L,826)
      GO TO 1000
  327 WRITE (L,827)
      GO TO 1000
  328 IDD = ID(3) - 64
      WRITE (L,828) IDD
      GO TO 1000
  329 WRITE (L,829)
      GO TO 1000
  330 WRITE (L,830)
      GO TO 1000
  331 IDD = ID(3) - 64
      WRITE (L,831) IDD
      GO TO 1000
  332 WRITE (L,832)
      GO TO 1000
  333 WRITE (L,833)
      GO TO 1000
  334 WRITE (L,834)
      GO TO 1000
  335 WRITE (L,835)
      GO TO 1000
  336 WRITE (L,836)
      GO TO 1000
  337 WRITE (L,837)
      GO TO 1000
  338 WRITE (L,838)
      GO TO 1000
  339 WRITE (L,839)
      GO TO 1000
  340 WRITE (L,840)
      GO TO 1000
  341 WRITE (L,841)
      GO TO 1000
  342 WRITE (L,842)
      GO TO 1000
  343 WRITE (L,843)
      GO TO 1000
  344 WRITE (L,844)
      GO TO 1000
  345 WRITE (L,845)
      GO TO 1000
  346 WRITE (L,846)
      GO TO 1000
  347 WRITE (L,847)
      GO TO 1000
  348 WRITE (L,848)
      GO TO 1000
  349 WRITE (L,849)
      GO TO 1000
  350 WRITE (L,850)
      GO TO 1000
  351 WRITE (L,851)
      GO TO 1000
  352 WRITE (L,852)
      GO TO 1000
  353 WRITE (L,853)
      GO TO 1000
  354 WRITE (L,854) ID(6),ID(7),FD(3)
      GO TO 1000
  355 WRITE (L,855)
      GO TO 1000
  356 WRITE (L,856)
      GO TO 1000
  357 WRITE (L,857)
      GO TO 1000
  358 WRITE (L,858)
      GO TO 1000
  359 WRITE (L,859)
      GO TO 1000
  360 WRITE (L,860)
      GO TO 1000
  361 WRITE (L,861)
      GO TO 1000
  362 WRITE (L,862)
      GO TO 1000
  363 WRITE (L,863)
      GO TO 1000
  364 WRITE (L,864)
      GO TO 1000
  365 WRITE (L,865)
      GO TO 1000
  366 WRITE (L,866)
      GO TO 1000
  367 WRITE (L,867)
      GO TO 1000
  368 WRITE (L,868)
      GO TO 1000
  369 WRITE (L,869)
      GO TO 1000
  370 WRITE (L,870)
      GO TO 1000
  371 WRITE (L,871)
      GO TO 1000
  372 WRITE (L,872)
      GO TO 1000
  373 WRITE (L,873)
      GO TO 1000
  374 WRITE (L,874)
      GO TO 1000
  375 WRITE (L,875)
      GO TO 990
  376 WRITE (L,876)
      GO TO 1000
  377 WRITE (L,877)
      GO TO 1000
  378 WRITE (L,878)
      GO TO 1000
  379 WRITE (L,879)
      GO TO 1000
  380 WRITE (L,880)
      GO TO 1000
  990 WRITE  (L,995)
  995 FORMAT (1H )
 1000 RETURN
C
C     ******************************************************************
C
  676 FORMAT (2(25X,5HAXIAL,30X), /2(7X,4HTIME,14X,5HFORCE,9X,6HTORQUE,
     1       15X))
  677 FORMAT (21X,17HBEND-MOMENT-END-A,12X,17HBEND-MOMENT-END-B,18X,
     1       5HSHEAR,17X, /7X,4HTIME,3(8X,7HPLANE 1,7X,7HPLANE 2),9X,
     2       5HFORCE,10X,6HTORQUE)
  678 FORMAT (2(25X,5HFORCE,10X,5HFORCE,15X), /2(7X,4HTIME,13X,
     1       7HPTS 1,3,8X,7HPTS 2,4,14X))
  679 FORMAT (2(24X,6HMOMENT,9X,6HMOMENT,15X), /2(7X,4HTIME,13X,
     1       7HPTS 1,3,8X,7HPTS 2,4,14X))
  680 FORMAT (8X,4HTIME,3X,2(11X,11HBEND-MOMENT),11X,12HTWIST-MOMENT,
     1       13X,5HSHEAR,17X,5HSHEAR, /31X,1HX,21X,1HY,43X,1HX,21X,1HY)
  681 FORMAT (4(8X,4HTIME,10X,5HFORCE,6X))
  682 FORMAT (2(21X,5HAXIAL,7X,6HSAFETY,6X,9HTORSIONAL,5X,6HSAFETY), /
     1       2(7X,4HTIME,9X,6HSTRESS,7X,6HMARGIN,8X,6HSTRESS,6X,
     2       6HMARGIN))
  683 FORMAT (7X,4HTIME,12X,3HSA1,12X,3HSA2,12X,3HSA3,10X,
     1       12HAXIAL-STRESS,8X,6HSA-MAX,9X,6HSA-MIN,11X,6HM.S.-T, /23X,
     2       3HSB1,12X,3HSB2,12X,3HSB3,30X,6HSB-MAX,9X,6HSB-MIN,11X,
     3       6HM.S.-C)
  684 FORMAT (2(26X,7HMAXIMUM,8X,7HAVERAGE,6X,6HSAFETY), /2(8X,4HTIME,
     1       15X,5HSHEAR,10X,5HSHEAR,7X,6HMARGIN))
  685 FORMAT (2(54X,6HSAFETY), /2(7X,4HTIME,15X,7HMAXIMUM,8X,7HAVERAGE,
     1       6X,6HMARGIN))
  686 FORMAT (19X,5HFIBRE,11X,32HSTRESSES IN ELEMENT COORD SYSTEM,13X,
     1       31HPRINCIPAL STRESSES (ZERO SHEAR),10X,7HMAXIMUM, /7X,
     2       4HTIME,7X,8HDISTANCE,7X,8HNORMAL-X,7X,8HNORMAL-Y,6X,
     3       8HSHEAR-XY,7X,5HANGLE,9X,5HMAJOR,11X,5HMINOR,10X,5HSHEAR)
  687 FORMAT (20X,32HSTRESSES IN ELEMENT COORD SYSTEM,12X,9HPRINCIPAL,
     1       11X,18HPRINCIPAL STRESSES,10X,7HMAXIMUM, /7X,4HTIME,8X,
     2       8HNORMAL-X,6X,8HNORMAL-Y,7X,8HSHEAR-XY,6X,12HSTRESS ANGLE,
     3       9X,5HMAJOR,10X,5HMINOR,10X,5HSHEAR)
  688 FORMAT (4(8X,4HTIME, 9X,6HSTRESS,6X))
  689 FORMAT (5X,4HTIME,15X,3HSA1,12X,3HSA2,12X,3HSA3,12X,3HSA4,8X,
     1       12HAXIAL-STRESS,6X,6HSA-MAX,9X,6HSA-MIN,5X,6HM.S.-T, /24X,
     2       3HSB1,12X,3HSB2,12X,3HSB3,12X,3HSB4,26X,6HSB-MAX,9X,
     3       6HSB-MIN,5X,6HM.S.-C)
  690 FORMAT (53X,5HAXIAL, /13X,9HFREQUENCY,31X,5HFORCE,41X,6HTORQUE)
  691 FORMAT (11X,2(42X,5HFORCE), /13X,9HFREQUENCY,30X,7HPTS 1,3,40X,
     1       7HPTS 2,4)
  692 FORMAT (11X,2(41X,6HMOMENT), /13X,9HFREQUENCY,30X,7HPTS 1,3,40X,
     1       7HPTS 2,4)
  693 FORMAT (5X,9HFREQUENCY,2X,2(11X,11HBEND-MOMENT),10X,
     1       12HTWIST-MOMENT,2(13X,5HSHEAR,4X), /2(31X,1HX,21X,1HY,12X))
  694 FORMAT (2(12X,9HFREQUENCY,20X,5HFORCE,12X))
  695 FORMAT (53X,5HAXIAL,39X,9HTORSIONAL, /13X,9HFREQUENCY,
     1       2(30X,6HSTRESS,11X))
  696 FORMAT (52X,7HMAXIMUM,39X,7HAVERAGE, /13X,9HFREQUENCY,
     1       2(31X,5HSHEAR,10X))
  697 FORMAT (20X,5HFIBRE,37X,'- STRESSES IN ELEMENT COORDINATE SYSTEM',
     1       2H -, /4X,'FREQUENCY,6X,8HDISTANCE',18X,8HNORMAL-X,26X,
     2       8HNORMAL-Y,25X,8HSHEAR-XY)
  698 FORMAT (53X,41H- STRESSES IN ELEMENT COORDINATE SYSTEM -, /9X,
     1       9HFREQUENCY,18X,8HNORMAL-X,26X,8HNORMAL-Y,26X,8HSHEAR-XY)
  699 FORMAT (2(12X,9HFREQUENCY,19X,6HSTRESS,12X))
  700 FORMAT (39X,4(8HLOCATION,7X),6X,7HAVERAGE, /8X,9HFREQUENCY,26X,
     1       1H1,14X,1H2,14X,1H3,14X,1H4,13X,12HAXIAL STRESS)
  701 FORMAT (21X,17HBEND-MOMENT-END-A,12X,17HBEND-MOMENT-END-B,18X,
     1       5HSHEAR,17X, /4X,9HFREQUENCY,3(6X,7HPLANE 1,7X,
     2       9HPLANE 2  ),6X,5HFORCE,10X,6HTORQUE)
  702 FORMAT (27X,'O U T P U T   F R O M   G R I D   P O I N T   W E I',
     1       ' G H T   G E N E R A T O R', /1H0,53X,
     2       17HREFERENCE POINT =,I9)
  703 FORMAT (5X,9HSECTOR-ID,/6X,8HPOINT-ID,/7X,7HRING-ID,2X,8HHARMONIC,
     1       8X,2HT1,13X,2HT2,13X,2HT3,13X,2HR1,13X,2HR2,13X,2HR3)
  704 FORMAT (11X,'S T R E S S E S   I N   A X I S - S Y M M E T R I C',
     1       '   C O N I C A L   S H E L L   E L E M E N T S   ',
     2       '(CCONEAX)')
  705 FORMAT (13X,'F O R C E S   I N   A X I S - S Y M M E T R I C   ',
     1       'C O N I C A L   S H E L L   E L E M E N T S   (CCONEAX)')
  706 FORMAT (8H ELEMENT,10X,5HPOINT,5X,5HFIBRE,11X,'STRESSES IN ELEM',
     1       'ENT COORD SYSTEM',8X,'PRINCIPAL STRESSES (ZERO SHEAR)',
     2       8X,7HMAXIMUM, /3X,'ID.  HARMONIC  ANGLE    DISTANCE',7X,
     3       8HNORMAL-V,6X,8HNORMAL-U,6X,8HSHEAR-UV,6X,5HANGLE,7X,
     4       5HMAJOR,9X,5HMINOR,9X,5HSHEAR)
  707 FORMAT (9H  ELEMENT,5X,8HHARMONIC,4X,5HPOINT,4X,2(7X,5HBEND-,
     1       6HMOMENT),6X,12HTWIST-MOMENT,2(11X,5HSHEAR,1X), /3X,3HID.,
     2       9X,6HNUMBER,5X,5HANGLE,15X,1HV,17X,1HU,37X,1HV,16X,1HU)
  708 FORMAT (31X,'C O M P L E X   D I S P L A C E M E N T   ',
     1       'V E C T O R  (SOLUTION SET)')
  709 FORMAT (35X,'C O M P L E X   V E L O C I T Y   V E C T O R  ',
     1       '(SOLUTION SET)')
  710 FORMAT (31X,'C O M P L E X   A C C E L E R A T I O N   ',
     1       'V E C T O R   (SOLUTION SET)')
  711 FORMAT (43X,46HV E L O C I T Y   V E C T O R   (SOLUTION SET))
  712 FORMAT (39X,'D I S P L A C E M E N T   V E C T O R   ',
     1       '(SOLUTION SET)')
  713 FORMAT (39X,'A C C E L E R A T I O N   V E C T O R   ',
     1       '(SOLUTION SET)')
  714 FORMAT (29X,'C O M P L E X   E I G E N V E C T O R   N O .',I11,
     1       3X,14H(SOLUTION SET))
  715 FORMAT (30X,'E I G E N V A L U E   A N A L Y S I S   ',
     1       'S U M M A R Y   (GIVENS METHOD)')
  716 FORMAT (///,36X,45HNUMBER OF EIGENVALUES EXTRACTED . . . . . . .,
     1       I10,//36X,45HNUMBER OF EIGENVECTORS COMPUTED . . . . . . .,
     2       I10,//36X,45HNUMBER OF EIGENVALUE CONVERGENCE FAILURES . .,
     3       I10,//36X,45HNUMBER OF EIGENVECTOR CONVERGENCE FAILURES. .,
     4      I10,///36X,45HREASON FOR TERMINATION. . . . . . . . . . . .,
     5  I10,1H*,///36X,45HLARGEST OFF-DIAGONAL MODAL MASS TERM. . . . .,
     6 1P,E10.2,//76X,5H. . .,I10,/46X,'MODE PAIR. . . . . . . . . . .',
     7     /76X,5H. . .,I10,//36X,33HNUMBER OF OFF-DIAG0NAL MODAL MASS ,
     8     /41X,40HTERMS FAILING CRITERION. . . . . . . . .,I10)
 7161 FORMAT (//36X,22H(* NORMAL TERMINATION))
 7162 FORMAT (//36X,31H(* INSUFFICIENT TIME REMAINING))
  717 FORMAT (107X,22HOCTAHEDRAL    PRESSURE, /6X,10HELEMENT-ID,8X,
     1       8HSIGMA-XX,6X,8HSIGMA-YY,6X,8HSIGMA-ZZ,7X,6HTAU-YZ,8X,
     2       6HTAU-XZ,8X,6HTAU-XY,8X,5HTAU-0,10X,1HP)
  718 FORMAT (107X,22HOCTAHEDRAL    PRESSURE, /6X,10H TIME     ,8X,
     1       8HSIGMA-XX,6X,8HSIGMA-YY,6X,8HSIGMA-ZZ,7X,6HTAU-YZ,8X,
     2       6HTAU-XZ,8X,6HTAU-XY,8X,5HTAU-0,10X,1HP)
  719 FORMAT (18X,10HELEMENT-ID,8X,8HSIGMA-XX,6X,8HSIGMA-YY,6X,
     1       8HSIGMA-ZZ,7X,6HTAU-YZ,8X,6HTAU-XZ,8X,6HTAU-XY)
  720 FORMAT (18X,10HFREQUENCY ,8X,8HSIGMA-XX,6X,8HSIGMA-YY,6X,
     1       8HSIGMA-ZZ,7X,6HTAU-YZ,8X,6HTAU-XZ,8X,6HTAU-XY)
  721 FORMAT (19X,'S T R E S S E S   I N   S O L I D   T E T R A H E D',
     1       ' R O N   E L E M E N T S   ( C T E T R A )')
  722 FORMAT (11X,'C O M P L E X   S T R E S S E S   I N   S O L I D  ',
     1     ' T E T R A H E D R O N   E L E M E N T S   ( C T E T R A )')
  723 FORMAT (25X,'S T R E S S E S   I N   S O L I D   W E D G E   ',
     1       'E L E M E N T S   ( C W E D G E )')
  724 FORMAT (17X,'C O M P L E X   S T R E S S E S   I N   S O L I D  ',
     1       ' W E D G E   E L E M E N T S   ( C W E D G E )')
  725 FORMAT (20X,'S T R E S S E S   I N   S O L I D   H E X A H E D R',
     1       ' O N   E L E M E N T S   ( C H E X A 1 )')
  726 FORMAT (12X,'C O M P L E X   S T R E S S E S   I N   S O L I D  ',
     1       ' H E X A H E D R O N   E L E M E N T S   ( C H E X A 1 )')
  727 FORMAT (20X,'S T R E S S E S   I N   S O L I D   H E X A H E D R',
     1       ' O N   E L E M E N T S   ( C H E X A 2 )')
  728 FORMAT (12X,'C O M P L E X   S T R E S S E S   I N   S O L I D  ',
     1       ' H E X A H E D R O N   E L E M E N T S   ( C H E X A 2 )')
  729 FORMAT (6X,10HPOINT-ID =,I7,4X,10HHARMONIC =,I4)
 1729 FORMAT (6X,10HPOINT-ID =,I7,4X,10HHARMONIC =,I4,1H*)
  730 FORMAT (5X,8HHARMONIC,5(3X,8HPOINT-ID,5X,2HT1,5X))
  731 FORMAT (10X,'V E L O C I T I E S   I N   A X I S Y M M E T R I C',
     1       '   F L U I D   E L E M E N T S   ( C A X I F 2 - ',
     2       'S T R E S S )')
  732 FORMAT (10X,'V E L O C I T I E S   I N   A X I S Y M M E T R I C',
     1       '   F L U I D   E L E M E N T S   ( C A X I F 3 - ',
     2       'S T R E S S )')
  733 FORMAT (10X,'V E L O C I T I E S   I N   A X I S Y M M E T R I C',
     1       '   F L U I D   E L E M E N T S   ( C A X I F 4 - ',
     2       'S T R E S S )')
  734 FORMAT (24X,'V E L O C I T I E S   I N   S L O T   E L E M E N T',
     1       ' S   ( C S L O T 3 - S T R E S S )')
  735 FORMAT (24X,'V E L O C I T I E S   I N   S L O T   E L E M E N T',
     1       ' S   ( C S L O T 4 - S T R E S S )')
  736 FORMAT (2X,'C O M P L E X   V E L O C I T I E S   I N   A X I S ',
     1       'Y M M E T R I C   F L U I D   E L E M E N T S   ',
     2       '( C A X I F 2 - S T R E S S )')
  737 FORMAT (2X,'C O M P L E X   V E L O C I T I E S   I N   A X I S ',
     1       'Y M M E T R I C   F L U I D   E L E M E N T S   ',
     2       '( C A X I F 3 - S T R E S S )')
  738 FORMAT (2X,'C O M P L E X   V E L O C I T I E S   I N   A X I S ',
     1       'Y M M E T R I C   F L U I D   E L E M E N T S   ',
     2       '( C A X I F 4 - S T R E S S )')
  739 FORMAT (15X,'C O M P L E X   V E L O C I T I E S   I N   S L O T',
     1       '  E L E M E N T S   ( C S L O T 3 - S T R E S S )')
  740 FORMAT (15X,'C O M P L E X   V E L O C I T I E S   I N   S L O T',
     1       '  E L E M E N T S   ( C S L O T 4 - S T R E S S )')
  741 FORMAT (8X,7HELEMENT,17X,6HCENTER,25X,7HEDGE  1,19X,7HEDGE  2,19X,
     1       7HEDGE  3,/10X,3HID., 8X,27HR --------- PHI --------- Z,
     2       12X,15HS --------- PHI,11X,15HS --------- PHI,11X,
     3       15HS --------- PHI)
  742 FORMAT (31X,6HCENTER,25X,7HEDGE  1,19X,7HEDGE  2,19X,7HEDGE  3,
     1       /2X,8H   TIME ,10X,27HR --------- PHI --------- Z,12X,
     2       15HS --------- PHI,11X,15HS --------- PHI,11X,
     3       15HS --------- PHI)
  743 FORMAT (32X,6HCENTER,25X,7HEDGE  1,19X,7HEDGE  2,19X,7HEDGE  3,
     1       /4X,9HFREQUENCY,8X,27HR --------- PHI --------- Z,12X,
     2       15HS --------- PHI,11X,15HS --------- PHI,11X,
     3       15HS --------- PHI)
  744 FORMAT (13X,7HELEMENT,18X,6HCENTER,20X,7HEDGE  1,11X,7HEDGE  2,
     1       11X,7HEDGE  3,11X,7HEDGE  4,/15X,3HID.,13X,
     2       19HR --------------- Z,17X,1HS,17X,1HS,17X,1HS,17X,1HS)
  745 FORMAT (38X,6HCENTER,20X,7HEDGE  1,11X,7HEDGE  2,11X,7HEDGE  3,
     1       11X,7HEDGE  4, /11X,4HTIME,16X,19HR --------------- Z,17X,
     2       1HS,17X,1HS,17X,1HS,17X,1HS)
  746 FORMAT (38X,6HCENTER,20X,7HEDGE  1,11X,7HEDGE  2,11X,7HEDGE  3,
     1       11X,7HEDGE  4,/9X,9HFREQUENCY,13X,19HR --------------- Z,
     2       17X,1HS,17X,1HS,17X,1HS,17X,1HS)
  747 FORMAT (9X,7HELEMENT,24X,6HCENTER,26X,7HEDGE  1,15X,7HEDGE  2,
     1       15X,7HEDGE  3,/11X,3HID.,17X,23HR ------------------- Z,
     2       21X,1HS,21X,1HS,21X,1HS)
  748 FORMAT (40X,6HCENTER,26X,7HEDGE  1,15X,7HEDGE  2,15X,7HEDGE  3,
     1       /7X,4HTIME,20X,23HR ------------------- Z,21X,1HS,21X,1HS,
     2       21X,1HS)
  749 FORMAT (40X,6HCENTER,26X,7HEDGE  1,15X,7HEDGE  2,15X,7HEDGE  3,
     1       /5X,9HFREQUENCY,17X,23HR ------------------- Z,21X,1HS,21X,
     2       1HS,21X,1HS)
  750 FORMAT (14X,7HELEMENT,30X,6HCENTER,47X,4HEDGE,/16X,3HID.,21X,
     1       27HR ----------------------- Z,25X,
     2       28HS ---------------------- PHI)
  751 FORMAT (51X,6HCENTER,47X,4HEDGE, /12X,4HTIME,24X,
     1       27HR ----------------------- Z,25X,
     2       28HS ---------------------- PHI)
  752 FORMAT (51X,6HCENTER,47X,4HEDGE, /10X,9HFREQUENCY,21X,
     1       27HR ----------------------- Z,25X,
     2       28HS ---------------------- PHI)
  753 FORMAT (46X,35HT E M P E R A T U R E   V E C T O R)
 1754 WRITE  (L,754) IDX
      GO TO  1000
  754 FORMAT (36X,'S T R E S S E S   I N   U S E R   E L E M E N T S',
     1       '  (C',A4,1H))
 1759 WRITE  (L,759) IDX
      GO TO  1000
  759 FORMAT (38X,'F O R C E S   I N   U S E R   E L E M E N T S   (C',
     1       A4,1H) )
  764 FORMAT (5X,9H    EL-ID,6X,2HS1,11X,2HS2,11X,2HS3,11X,2HS4,11X,
     1       2HS5,11X,2HS6,11X,2HS7,11X,2HS8,11X,2HS9)
  765 FORMAT (5X,9H    EL-ID,6X,2HF1,11X,2HF2,11X,2HF3,11X,2HF4,11X,
     1       2HF5,11X,2HF6,11X,2HF7,11X,2HF8,11X,2HF9)
 1766 WRITE  (L,766) IDX
      GO TO  1000
  766 FORMAT (28X,'C O M P L E X   S T R E S S E S   I N   U S E R   ',
     1       'E L E M E N T S   (C',A4,1H))
 1771 WRITE  (L,771) IDX
      GO TO  1000
  771 FORMAT (30X,'C O M P L E X   F O R C E S   I N   U S E R   E L E',
     1       ' M E N T S   (C',A4,1H))
  776 FORMAT (5X,9H     TIME,6X,2HS1,11X,2HS2,11X,2HS3,11X,2HS4,11X,
     1       2HS5,11X,2HS6,11X,2HS7,11X,2HS8,11X,2HS9)
  777 FORMAT (5X,9H     TIME,6X,2HF1,11X,2HF2,11X,2HF3,11X,2HF4,11X,
     1       2HF5,11X,2HF6,11X,2HF7,11X,2HF8,11X,2HF9)
  778 FORMAT (5X,9HFREQUENCY,6X,2HS1,11X,2HS2,11X,2HS3,11X,2HS4,11X,
     1       2HS5,11X,2HS6,11X,2HS7,11X,2HS8,11X,2HS9)
  779 FORMAT (5X,9HFREQUENCY,6X,2HF1,11X,2HF2,11X,2HF3,11X,2HF4,11X,
     1       2HF5,11X,2HF6,11X,2HF7,11X,2HF8,11X,2HF9)
  796 FORMAT (6X,'POINT ID.   TYPE',6X,'ID   VALUE     ID+1 VALUE    ',
     1       'ID+2 VALUE     ID+3 VALUE     ID+4 VALUE     ID+5 VALUE')
  797 FORMAT (19X,'F I N I T E   E L E M E N T   T E M P E R A T U R E',
     1       '   G R A D I E N T S   A N D   F L U X E S')
  798 FORMAT (4X,'ELEMENT-ID   EL-TYPE        X-GRADIENT       Y-',
     1       'GRADIENT       Z-GRADIENT        X-FLUX           Y-FLUX',
     2       '           Z-FLUX')
  799 FORMAT (4X,'TIME         EL-TYPE        X-GRADIENT       Y-',
     1       'GRADIENT       Z-GRADIENT        X-FLUX           Y-FLUX',
     2       '           Z-FLUX')
  800 FORMAT (26X,'ELEMENT-ID      APPLIED-LOAD       CONVECTION      ',
     1       ' RADIATION           TOTAL')
  801 FORMAT (26X,'TIME            APPLIED-LOAD       CONVECTION      ',
     1       ' RADIATION           TOTAL')
  802 FORMAT (33X,'H E A T   F L O W   I N T O   H B D Y   E L E M E N',
     1       ' T S   (CHBDY)')
  803 FORMAT (6X,16HTIME        TYPE  ,6X,7H  VALUE)
  804 FORMAT (21X,'S T R E S S E S   I N   Q U A D R I L A T E R A L',
     1       '   M E M B R A N E S      ( C Q D M E M 1 )')
  805 FORMAT (14X,'C O M P L E X   S T R E S S E S   I N   Q U A D R I',
     1       ' L A T E R A L   M E M B R A N E S   ( C Q D M E M 1 )')
  806 FORMAT (26X,'S T R E S S E S   A C T I N G   I N   Q D M E M 2  ',
     1       ' E L E M E N T S   (CQDMEM2)')
  807 FORMAT (19X,'C O M P L E X   S T R E S S E S   A C T I N G   I N',
     1       '   Q D M E M 2   E L E M E N T S   (CQDMEM2)')
  808 FORMAT (18X,'S T R E S S E S   I N   G E N E R A L   Q U A D R I',
     1       ' L A T E R A L   E L E M E N T S', 6X,15H( C Q U A D 4 ))
  809 FORMAT ('0*** THIS FORMAT 809/OFP1B NOT USED ***')
C                   ==============================
  810 FORMAT (28X,'F O R C E S   A C T I N G   O N   Q D M E M 2   E L',
     1       ' E M E N T S   (CQDMEM2)')
  811 FORMAT (20X,'C O M P L E X   F O R C E S   A C T I N G   O N   ',
     1       'Q D M E M 2   E L E M E N T S   (CQDMEM2)')
  812 FORMAT (18X,106H====== POINT  1 ======      ====== POINT  2 ======
     1      ====== POINT  3 ======      ====== POINT  4 ====== , /7X,
     2       7HELEMENT,4X,8HF-FROM-4,6X,8HF-FROM-2,6X,8HF-FROM-1,6X,
     3       8HF-FROM-3,6X,8HF-FROM-2,6X,8HF-FROM-4,6X,8HF-FROM-3,6X,
     4       8HF-FROM-1, /9X,2HID,15X,6HKICK-1,7X,8HSHEAR-12,7X,
     5       6HKICK-2,7X,8HSHEAR-23,7X,6HKICK-3,7X,8HSHEAR-34,7X,
     6       6HKICK-4,7X,8HSHEAR-41 )
  813 FORMAT (18X,106H====== POINT  1 ======      ====== POINT  2 ======
     1      ====== POINT  3 ======      ====== POINT  4 ====== , /14X,
     2       4X,8HF-FROM-4,6X,8HF-FROM-2,6X,8HF-FROM-1,6X,8HF-FROM-3,6X,
     3       8HF-FROM-2,6X,8HF-FROM-4,6X,8HF-FROM-3,6X,8HF-FROM-1, /5X,
     4       9HFREQUENCY,12X,6HKICK-1,7X,8HSHEAR-12,7X,6HKICK-2,7X,
     5       8HSHEAR-23,7X,6HKICK-3,7X,8HSHEAR-34,7X,6HKICK-4,7X,
     6       8HSHEAR-41)
  814 FORMAT (18X,106H====== POINT  1 ======      ====== POINT  2 ======
     1      ====== POINT  3 ======      ====== POINT  4 ====== , /14X,
     2       4X,8HF-FROM-4,6X,8HF-FROM-2,6X,8HF-FROM-1,6X,8HF-FROM-3,6X,
     3       8HF-FROM-2,6X,8HF-FROM-4,6X,8HF-FROM-3,6X,8HF-FROM-1, /10X,
     4       4HTIME,12X,6HKICK-1,7X,8HSHEAR-12,7X,6HKICK-2,7X,8HSHEAR-23
     5,      7X,6HKICK-3,7X,8HSHEAR-34,7X,6HKICK-4,7X,8HSHEAR-41)
  815 FORMAT (6X,16HSUBCASE     TYPE,10X,2HT1,13X,2HT2,13X,2HT3,13X,
     1       2HR1,13X,2HR2,13X,2HR3)
  816 FORMAT (2(26X,7HMAXIMUM,8X,7HAVERAGE,6X,6HSAFETY),/2(6X,7HSUBCASE,
     1       14X,5HSHEAR,10X,5HSHEAR,7X,6HMARGIN))
  817 FORMAT (20X,32HSTRESSES IN ELEMENT COORD SYSTEM,12X,9HPRINCIPAL,
     1       11X,18HPRINCIPAL STRESSES,10X,7HMAXIMUM, /6X,7HSUBCASE,6X,
     2       8HNORMAL-X,6X,8HNORMAL-Y,7X,8HSHEAR-XY,6X,12HSTRESS ANGLE,
     3       9X,5HMAJOR,10X,5HMINOR,10X,5HSHEAR)
  818 FORMAT (6X,7HSUBCASE,11X,3HSA1,12X,3HSA2,12X,3HSA3,12X,3HSA4,8X,
     1       12HAXIAL-STRESS,6X,6HSA-MAX,9X,6HSA-MIN,5X,6HM.S.-T, /24X,
     2       3HSB1,12X,3HSB2,12X,3HSB3,12X,3HSB4,26X,6HSB-MAX,9X,
     3       6HSB-MIN,5X,6HM.S.-C)
  819 FORMAT (18X,106H====== POINT  1 ======      ====== POINT  2 ======
     1      ====== POINT  3 ======      ====== POINT  4 ====== , /14X,
     2       4X,8HF-FROM-4,6X,8HF-FROM-2,6X,8HF-FROM-1,6X,8HF-FROM-3,6X,
     3       8HF-FROM-2,6X,8HF-FROM-4,6X,8HF-FROM-3,6X,8HF-FROM-1, /5X,
     4       7HSUBCASE,14X,6HKICK-1,7X,8HSHEAR-12,7X,6HKICK-2,7X,
     5       8HSHEAR-23,7X,6HKICK-3,7X,8HSHEAR-34,7X,6HKICK-4,7X,
     6       8HSHEAR-41 )
  820 FORMAT (21X,17HBEND-MOMENT-END-A,12X,17HBEND-MOMENT-END-B,18X,
     1       5HSHEAR, /6X,7HSUBCASE,6X,3(7HPLANE 1,7X,7HPLANE 2,8X),
     2       6H FORCE,10X,6HTORQUE)
  821 FORMAT (2(21X,5HAXIAL,7X,6HSAFETY,6X,9HTORSIONAL,5X,6HSAFETY), /
     1       2(6X,7HSUBCASE,7X,6HSTRESS,7X,6HMARGIN,8X,6HSTRESS,6X,
     2       6HMARGIN))
  822 FORMAT (2(25X,5HAXIAL,30X) , /2(6X,7HSUBCASE,12X,5HFORCE, 9X,
     1       6HTORQUE,15X))
  823 FORMAT (5X,7HELEMENT,8X,33HSTRESSES IN MATERIAL COORD SYSTEM,12X,
     1       9HPRINCIPAL,11X,18HPRINCIPAL STRESSES,12X,3HMAX)
  824 FORMAT (13X,7HELEMENT,33X,'- STRESSES IN MATERIAL COORDINATE ',
     1       'SYSTEM -', /15X,3HID.,18X,8HNORMAL-X,26X,8HNORMAL-Y,26X,
     2       8HSHEAR-XY)
  825 FORMAT (20X,33HSTRESSES IN MATERIAL COORD SYSTEM,11X,9HPRINCIPAL,
     1       11X,18HPRINCIPAL STRESSES,10X,7HMAXIMUM, /7X,4HTIME,8X,
     2       8HNORMAL-X,6X,8HNORMAL-Y,7X,8HSHEAR-XY,6X,12HSTRESS ANGLE,
     3       9X,5HMAJOR,10X,5HMINOR,10X,5HSHEAR)
  826 FORMAT (53X,42H- STRESSES IN MATERIAL COORDINATE SYSTEM -, /9X,
     1       9HFREQUENCY,18X,8HNORMAL-X,26X,8HNORMAL-Y,26X,8HSHEAR-XY)
  827 FORMAT (20X,33HSTRESSES IN MATERIAL COORD SYSTEM,11X,9HPRINCIPAL,
     1       11X,18HPRINCIPAL STRESSES,10X,7HMAXIMUM, /6X,7HSUBCASE,6X,
     2       8HNORMAL-X,6X,8HNORMAL-Y,7X,8HSHEAR-XY,6X,12HSTRESS ANGLE,
     3       9X,5HMAJOR,10X,5HMINOR,10X,5HSHEAR)
  828 FORMAT (21X,'S T R E S S E S   I N   I S O P A R A M E T R I C  ',
     1       ' S O L I D   ( C I H E X',I2,2H ))
  829 FORMAT (2X,7HELEMENT,5X,4HGRID,11X,'STRESSES IN BASIC COORDINATE',
     1       'SYSTEM',13X,12HDIR. COSINES)
  830 FORMAT (7X,2HID,4X,5HPOINT,8X,6HNORMAL,12X,5HSHEAR,10X,9HPRINCIPAL
     1,      10X,1HA,4X,1HB,4X,1HC,4X,11HMEAN STRESS,5X,9HMAX SHEAR)
  831 FORMAT (13X,'C O M P L E X   S T R E S S E S   I N   I S O P A R',
     1       ' A M E T R I C   S O L I D   ( C I H E X',I2,2H ))
  832 FORMAT (7X,2HID,3X,6HPOINTS,5X,8HNORMAL-X,9X,8HNORMAL-Y,9X,
     1       8HNORMAL-Z,9X,8HSHEAR-XY,9X,8HSHEAR-YZ,9X,8HSHEAR-ZX)
  833 FORMAT (25X,'F O R C E   D I S T R I B U T I O N   I N   B A R',
     1       '   E L E M E N T S,10X,11H( C B A R )')
  834 FORMAT (21H0    ELEMENT  STATION,9X,11HBEND-MOMENT,22X,
     1       11HSHEAR FORCE,21X,5HAXIAL)
  835 FORMAT (7X,3HID.,5X,5H(PCT),5X,7HPLANE 1,8X,7HPLANE 2,11X,
     1       7HPLANE 1,8X,7HPLANE 2,15X,5HFORCE,14X,6HTORQUE)
  836 FORMAT (25X,'S T R E S S   D I S T R I B U T I O N   I N   B A R',
     1       '  E L E M E N T S,7X,11H( C B A R )')
  837 FORMAT (21H0    ELEMENT  STATION,4X,3HSXC,11X,3HSXD,11X,3HSXF,11X,
     1        3HSXG,12X,5HAXIAL,10X,5HS-MAX, 9X,5HS-MIN,9X,4HM.S.)
  838 FORMAT (7X,3HID.,5X,5H(PCT))
  839 FORMAT (21X,'F O R C E S  F O R  T H E  Q U A D R I L A T E R A L'
     1,      '  T H I N  S H E L L     ( C Q U A D T S )')
  840 FORMAT (6X,2HEL,            36X,6HFORCES,51X,7HMOMENTS )
  841 FORMAT (6X,2HID,5X,5HPOINT,9X,2HFX,17X,2HFY,17X,2HFZ,17X,2HMX,17X,
     1       2HMY,17X,2HMZ )
  842 FORMAT (17X,'F O R C E S   I N   T R I A N G U L A R   T H I N  ',
     1       'S H E L L   E L E M E N T S   ( C T R S H L )')
  843 FORMAT (19X,'S T R E S S E S  F O R  T H E  Q U A D R I L A T E ',
     1      'R A L  T H I N  S H E L L     ( C Q U A D T S )')
  844 FORMAT (3X,9HEL STRESS,8X,28HMEMBRANE  STRESS  RESULTANTS,24X,
     1       17HFLEXURAL  MOMENTS,27X,5HSHEAR )
  845 FORMAT (3X,'ID  POINT   NORMAL(NX)     NORMAL(NY)     SHEAR(NXY)',
     1       '     NORMAL(MX)     NORMAL(MY)     TORQUE(MXY)     ',
     2       'NORMAL(QX)     NORMAL(QY)')
  846 FORMAT (18X,'S T R E S S E S   I N   T R I A N G U L A R   T H I',
     1       ' N   S H E L L   E L E M E N T S   ( C T R S H L )')
  847 FORMAT (5X,'S T R E S S E S  I N  A X I S - S Y M M E T R I C  ',
     1       'T R I A N G U L A R  R I N G  E L E M E N T S  (CTRIAAX)')
  848 FORMAT (' ELEMENT   HARMONIC    POINT    RADIAL      AXIAL',6X,
     1       'CIRCUM.     SHEAR      SHEAR      SHEAR      F L U X   ',
     2       'D E N S I T I E S', /,' ID.       NUMBER      ANGLE     ',
     3       '(R)         (Z)     (THETA-T)    (ZR)       (RT)       ',
     4       '(ZT)        (R)        (Z)        (T)')
  849 FORMAT (11X,'F O R C E S  I N  A X I S - S Y M M E T R I C  T R ',
     1       'I A N G U L A R  R I N G  E L E M E N T S  (CTRIAAX)')
  850 FORMAT (1X,113H  ELEMENT   HARMONIC    POINT            RADIAL
     1        CIRCUMFERENTIAL            AXIAL                CHARGE,
     1        /1X,'    ID.      NUMBER     ANGLE             (R)',17X,
     3        '(THETA-T)                (Z)')
  851 FORMAT (5X,'S T R E S S E S  I N  A X I S - S Y M M E T R I C  T',
     1      ' R A P E Z O I D A L  R I N G  E L E M E N T S  (CTRAPAX)')
  852 FORMAT (11X,'F O R C E S  I N  A X I S - S Y M M E T R I C  T R ',
     1       'A P E Z O I D A L  R I N G  E L E M E N T S  (CTRAPAX)')
  853 FORMAT (43X,45HE L E M E N T   S T R A I N   E N E R G I E S )
  854 FORMAT (30X,15HELEMENT-TYPE = ,2A4,9X,23H* TOTAL FOR ALL TYPES = ,
     1       1P,E16.7, /1H0,95X,1H*, /36X,10HELEMENT-ID,10X,
     2       13HSTRAIN-ENERGY,11X,16HPERCENT OF TOTAL )
  855 FORMAT (42X,47HG R I D   P O I N T   F O R C E   B A L A N C E )
  856 FORMAT (11H   POINT-ID,4X,10HELEMENT-ID,5X,6HSOURCE,13X,2HT1,13X,
     1       2HT2,13X,2HT3,13X,2HR1,13X,2HR2,13X,2HR3)
  857 FORMAT (22X,'F O R C E S   I N   T R I A N G U L A R   P L A T E',
     1       '  E L E M E N T S   ( C T R P L T 1 )')
  858 FORMAT (20X,'S T R E S S E S   I N   T R I A N G U L A R   ',
     1       'P L A T E   E L E M E N T S   ( C T R P L T 1 )')
  859 FORMAT (1H0,9X,7HELEMENT,4X,5HPOINT,7X,2(11HBEND-MOMENT, 9X),
     1       12HTWIST-MOMENT,2(11X,5HSHEAR,4X))
  860 FORMAT (12X,3HID.,7X,3HNO.,13X,1HX,19X,1HY,39X,1HX,19X,1HY)
  861 FORMAT (1H0, 8H ELEMENT, 2X, 5HPOINT, 5X, 5HFIBER, 11X,
     1       32HSTRESSES IN ELEMENT COORD SYSTEM, 12X,
     2       31HPRINCIPAL STRESSES (ZERO SHEAR), 11X, 3HMAX)
  862 FORMAT (3X,3HID.,6X,3HNO.,5X,8HDISTANCE, 7X,8HNORMAL-X,6X,
     1       8HNORMAL-Y,6X,8HSHEAR-XY,8X,5HANGLE,9X,5HMAJOR,9X,5HMINOR,
     2       10X,5HSHEAR)
  863 FORMAT (18X,'S T R E S S E S   I N   T R I A N G U L A R   ',
     1       'M E M B R A N E   E L E M E N T S   ( C T R I M 6 )')
  864 FORMAT (1H0, 8H ELEMENT, 5X, 5HPOINT, 7X,
     1       32HSTRESSES IN ELEMENT COORD SYSTEM, 13X,
     2       31HPRINCIPAL STRESSES (ZERO SHEAR), 13X, 3HMAX)
  865 FORMAT (4X,3HID.,8X,3HNO., 5X,8HNORMAL-X,7X,8HNORMAL-Y,7X,
     1       8HSHEAR-XY,8X,5HANGLE,10X,5HMAJOR,10X,5HMINOR,10X,5HSHEAR)
  866 FORMAT (2(24X, 6HMOMENT, 9X, 6HMOMENT, 15X), /2(6X, 7HSUBCASE,11X,
     1       7HPTS 1,3, 8X, 7HPTS 2,4, 14X))
  867 FORMAT (6X, 7HSUBCASE, 2X, 2(11X, 11HBEND-MOMENT), 11X,
     1       12HTWIST-MOMENT, 13X, 5HSHEAR, 17X, 5HSHEAR,
     2       /31X, 1HX, 21X, 1HY, 43X, 1HX, 21X, 1HY)
  868 FORMAT (4(6X, 7HSUBCASE, 9X, 5HFORCE, 6X))
  869 FORMAT (5X, 7HSUBCASE, 11X, 3HSA1, 12X, 3HSA2, 12X, 3HSA3, 10X,
     1       12HAXIAL-STRESS, 8X, 6HSA-MAX, 9X, 6HSA-MIN, 11X,6HM.S.-T,
     2       /23X, 3HSB1, 12X, 3HSB2, 12X, 3HSB3, 30X, 6HSB-MAX, 9X,
     3       6HSB-MIN, 11X, 6HM.S.-C)
  870 FORMAT (2(54X, 6HSAFETY), /2(5X, 7HSUBCASE, 14X, 7HMAXIMUM, 8X,
     1       7HAVERAGE, 6X, 6HMARGIN))
  871 FORMAT (19X, 5HFIBRE, 11X, 32HSTRESSES IN ELEMENT COORD SYSTEM,
     1       13X, 31HPRINCIPAL STRESSES (ZERO SHEAR), 10X, 7HMAXIMUM,/
     2       5X, 7HSUBCASE, 6X, 8HDISTANCE, 7X, 8HNORMAL-X, 7X,
     3       8HNORMAL-Y, 6X, 8HSHEAR-XY, 7X, 5HANGLE, 9X, 5HMAJOR,
     4       11X, 5HMINOR, 10X, 5HSHEAR)
  872 FORMAT (4(6X, 7HSUBCASE, 8X, 6HSTRESS, 6X))
  873 FORMAT (107X, 22HOCTAHEDRAL    PRESSURE,/5X, 10HSUBCASE   , 8X,
     1       8HSIGMA-XX, 6X, 8HSIGMA-YY, 6X, 8HSIGMA-ZZ, 7X, 6HTAU-YZ,
     2       8X, 6HTAU-XZ, 8X, 6HTAU-XY, 8X, 5HTAU-0, 10X, 1HP)
  874 FORMAT (107X, 22HOCTAHEDRAL    PRESSURE,/5X, 11HSUBCASE    , 8X,
     1       8HSIGMA-XX, 6X, 8HSIGMA-YY, 6X, 8HSIGMA-ZZ, 7X, 6HTAU-YZ,
     2       8X, 6HTAU-XZ, 8X, 6HTAU-XY, 8X, 5HTAU-0, 10X, 1HP)
  875 FORMAT (32X,'F O R C E S   O F   M U L T I - P O I N T   C O N S',
     1       ' T R A I N T')
  876 FORMAT (2X,7HELEMENT,4X,16HMAT. COORD. SYS.,6X,
     1       33HSTRESSES IN MATERIAL COORD SYSTEM,12X,
     2       31HPRINCIPAL STRESSES (ZERO SHEAR),12X,3HMAX)
  877 FORMAT (4X, 3HID., 6X, 15HID./OUTPUT CODE,
     1       5X, 8HNORMAL-X, 7X, 8HNORMAL-Y, 6X, 8HSHEAR-XY,
     2       7X, 5HANGLE, 9X, 5HMAJOR, 11X, 5HMINOR, 10X, 5HSHEAR)
  878 FORMAT (43X,'S T R E S S E S   A T   G R I D   P O I N T S')
  879 FORMAT (7X,'S T R A I N S / C U R V A T U R E S   I N   G E N E ',
     1       'R A L   T R I A N G U L A R   E L E M E N T S',6X,
     2       '( C T R I A 1 )')
  880 FORMAT (7X,'S T R A I N S / C U R V A T U R E S   I N   G E N E ',
     1       'R A L   T R I A N G U L A R   E L E M E N T S',6X,
     2       '( C T R I A 2 )')
C
      END

      SUBROUTINE ROWDYZ (NFB,NLB,ROW,NTZYS,D,DX,DY,DZ,BETA,IDZDY,NTAPE,
     1                   SGR,CGR,IPRNT,YB,ZB,AR,NSBE,XIS1,XIS2,A0)
C
C     CALCULATE A ROW OF DZ OR DY
C
C     SLENDER BODY
C
C     NFB       FIRST BODY OF THE DESIRED ORIENTATION - Z OR Y -
C     NLB       LAST  BODY OF THE DESIRED ORIENTATION
C     ROW       ROW OF DZ OR DY BEING CALCULATED
C     NTZYS     NO. COLUMNS TO BE CALCULATED
C     D         CALCULATED ROW
C     DX        X - COORD. OF RECEIVING POINT
C     DY        Y - COORD. OF RECEIVING POINT
C     DZ        Z - COORD. OF RECEIVING POINT
C     BETA      EQUALS SQRT(1-M**2)
C     MACH      MACH NO., M
C     IDZDY     FLAG REQUIRED FOR FLLD
C
      INTEGER         B1,T1,B,T,ROW
      REAL            KR
      DIMENSION       AR(1),NSBE(1),XIS1(1),XIS2(1),A0(1),YB(1),ZB(1)
      DIMENSION       D(2,NTZYS)
      COMMON /AMGMN / MCB(7),NROW,ND,NE,REFC,FMACH,KR
      COMMON /SYSTEM/ N,NPOT
C
      DELTA  = FLOAT(ND)
      EPSLON = FLOAT(NE)
      B1     =  0
      T1     =  0
      IT1    = 0
      IF (NFB.EQ.1 .OR. IDZDY.EQ.0) GO TO 10
      B   = NFB - 1
      DO 5 T = 1,B
      IT1 = IT1 + NSBE(T)
    5 CONTINUE
   10 CONTINUE
      DO 200 B = NFB,NLB
      B1    = B1 + 1
      DAR   = AR(B)
      NSBEB = NSBE(B)
      IF (IPRNT .NE. 0) WRITE (NPOT,15) B,DY,YB(B),DZ,ZB(B)
   15 FORMAT (12H ROWDYZ  B =,I10,4E20.8)
C
C     LOOP FOR EACH ELEMENT IN BODY -B-
C
      DO 140 T = 1,NSBEB
      T1  = T1  + 1
      IT1 = IT1 + 1
      D(1,T1) = 0.0
      D(2,T1) = 0.0
      XI1  = XIS1(IT1)
      XI2  = XIS2(IT1)
      AZRO = A0(IT1)
      ETA  = YB(B)
      ZETA = ZB(B)
C
C     CHECK TO SEE IF CALCULATIONS ARE TO BE MADE
C
      IF (DY.EQ.ETA .AND. DZ.EQ.ZETA) GO TO 30
      ASSIGN 20 TO JDZDY
      LHS = 0
      GO TO 100
   20 D(1,T1) = DZYR
      D(2,T1) = DZYI
C
C     SKIP IF NO SYMMETRY
C
   30 CONTINUE
      IF (DELTA .EQ. 0.0) GO TO 70
      ETA = -YB(B)
C
C     CHECK TO SEE IF CALCULATIONS ARE TO BE MADE
C
      IF (DY.EQ.ETA .AND. DZ.EQ.ZETA) GO TO 50
      LHS = 1
      ASSIGN 40 TO JDZDY
      GO TO 100
   40 D(1,T1) = D(1,T1) + DELTA*DZYR
      D(2,T1) = D(2,T1) + DELTA*DZYI
   50 CONTINUE
      IF (EPSLON .EQ. 0.0) GO TO 140
C
C     CALC. ONLY IF DELTA AND EPSLON  NOT EQUAL ZERO
C
      ETA  = -YB(B)
      ZETA = -ZB(B)
C
C     CHECK TO SEE IF CALCULATIONS ARE TO BE MADE
C
      IF (DY.EQ.ETA .AND. DZ.EQ.ZETA) GO TO 70
      ASSIGN 60 TO JDZDY
      GO TO 100
   60 D(1,T1) = D(1,T1) + EPSLON*DELTA*DZYR
      D(2,T1) = D(2,T1) + EPSLON*DELTA*DZYI
C
C     SKIP IF NO GROUND EFFECTS
C
   70 IF (EPSLON .EQ. 0.0) GO TO 140
      ETA  =  YB(B)
      ZETA = -ZB(B)
C
C     CHECK TO SEE IF CALCULATIONS ARE TO BE MADE
C
      IF (DY.EQ.ETA .AND. DZ.EQ.ZETA) GO TO 140
      LHS = 1
      ASSIGN 80 TO JDZDY
      GO TO 100
   80 D(1,T1) = D(1,T1) + EPSLON*DZYR
      D(2,T1) = D(2,T1) + EPSLON*DZYI
      GO TO 140
C
C     CALL SEQUENCE TO DZY
C
  100 CALL DZY (DX,DY,DZ,SGR,CGR,XI1,XI2,ETA,ZETA,DAR,AZRO,KR,REFC,
     1          BETA,FMACH,LHS,IDZDY,DZYR,DZYI)
      LHS = 0
      GO TO JDZDY, (20,40,60,80)
C
  140 CONTINUE
C
C     END OF LOOP FOR ELEMENT
C
C     200 IS END OF LOOP ON SLENDER BODY
C
  200 CONTINUE
C
C     WRITE ROW ON TAPE, ROW NUMBER, NO. ELEMENTS, DATA
C
      CALL WRITE (NTAPE,D,2*T1,0)
      IF (IPRNT .NE. 0) WRITE (NPOT,210) ROW,T1,D
  210 FORMAT (' ROWDYZ - ROW NO.',I5,1H,,I10,' ELEMENTS',/(1X,6E12.4))
      RETURN
      END

      SUBROUTINE CMRD2D (ITER)
C
C     THIS SUBROUTINE CALCULATES THE MODAL TRANSFORMATION MATRIX FOR THE
C     CMRED2 MODULE.
C
C     INPUT  DATA
C     GINO - LAMAMR - EIGENVALUE TABLE FOR SUBSTRUCTURE BEING REDUCED
C            PHISSR - RIGHT EIGENVECTOR MATRIX FOR SUBSTRUCTURE BEING
C                     REDUCED
C            PHISSL - LEFT EIGENVECTOR MATRIX FOR SUBSTRUCTURE BEING
C                     REDUCED
C     SOF  - GIMS   - G TRANSFORMATION MATRIX FOR ORIGINAL SUBSTRUCTURE
C
C     OUTPUT DATA
C     GINO - HIM    - MODAL TRANSFORMATION MATRIX
C
C     PARAMETERS
C     INPUT- GBUF   - GINO BUFFERS
C            INFILE - INPUT FILE NUMBERS
C            OTFILE - OUTPUT FILE NUMBERS
C            ISCR   - SCRATCH FILE NUMBERS
C            KORLEN - LENGTH OF OPEN CORE
C            KORBGN - BEGINNING ADDRESS OF OPEN CORE
C            OLDNAM - NAME OF SUBSTRUCTURE BEING REDUCED
C            NMAX   - MAXIMUM NUMBER OF FREQUENCIES TO BE USED
C     OUTPUT-MODUSE - BEGINNING ADDRESS OF MODE USE DESCRIPTION ARRAY
C            NFOUND - NUMBER OF MODAL POINTS FOUND
C            MODLEN - LENGTH OF MODE USE ARRAY
C     OTHERS-HIMPRT - HIM PARTITION VECTOR
C            PPRTN  - PHISS MATRIX PARTITION VECTOR
C            PHIAM  - PHIAM MATRIX PARTITION
C            PHIBM  - PHIBM MATRIX PARTITION
C            PHIIM  - PHIIM MATRIX PARTITION
C            IPARTN - BEGINNING ADDRESS OF PHISS PARTITION VECTOR
C            LAMAMR - LAMAMR INPUT FILE NUMBER
C            PHISS  - PHISS INPUT FILE NUMBER
C            PPRTN  - PARTITION VECTOR FILE NUMBER
C            HIMPRT - HIM PARTITION VECTOR FILE NUMBER
C            GIB    - GIB INPUT FILE NUMBER
C            PHIAM  - PHIAM PARTITION MATRIX FILE NUMBER
C            PHIBM  - PHIBM PARTITION MATRIX FILE NUMBER
C            PHIIM  - PHIIM PARTITION MATRIX FILE NUMBER
C            HIM    - HIM INPUT FILE NUMBER
C            HIMSCR - HIM SCRATCH INPUT FILE NUMBER
C
      LOGICAL         MODES
      INTEGER         DRY,GBUF1,GBUF2,GBUF3,SBUF1,SBUF2,SBUF3,OTFILE,
     1                OLDNAM,Z,TYPIN,TYPEP,FUSET,T,SIGNAB,SIGNC,PREC,
     2                SCR,UN,UB,UI,RULE,TYPEU,
     3                PHISS,PPRTN,GIB,PHIAM,PHIBM,PHIIM,HIM,HIMPRT,
     4                PHISSR,PHISSL,GIBBAR,HIMBAR,HIMSCR,USETMR,HIMTYP,
     5                DBLKOR,SGLKOR,DICORE
      DOUBLE PRECISION DZ,DHIMSM,DHIMAG,DPHIM,DHIMG
      DIMENSION       MODNAM(2),RZ(1),ITRLR(7),DZ(1)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /BLANK / IDUM1,DRY,IDUM6,GBUF1,GBUF2,GBUF3,SBUF1,SBUF2,
     1                SBUF3,INFILE(11),OTFILE(6),ISCR(11),KORLEN,KORBGN,
     2                OLDNAM(2),IDUM4(3),RANGE(2),NMAX,IDUM5,MODES,
     3                IDUM8,MODUSE,NFOUND,MODLEN,IDUM9,LSTZWD
      COMMON /ZZZZZZ/ Z(1)
      COMMON /PACKX / TYPIN,TYPEP,IROWP,NROWP,INCRP
      COMMON /PATX  / LCORE,NSUB(3),FUSET
      COMMON /MPYADX/ ITRLRA(7),ITRLRB(7),ITRLRC(7),ITRLRD(7),NZ,T,
     1                SIGNAB,SIGNC,PREC,SCR
      COMMON /BITPOS/ IDUM3(9),UN,IDUM7(10),UB,UI
      COMMON /PARMEG/ IA(7),IA11(7),IA21(7),IA12(7),IA22(7),LCR,RULE
      COMMON /UNPAKX/ TYPEU,IROWU,NROWU,INCRU
      COMMON /SYSTEM/ IDUM2,IPRNTR
      EQUIVALENCE     (LAMAMR,INFILE(2)),(PHISSR,INFILE(3)),
     1                (PHISSL,INFILE(4)),(USETMR,INFILE(6)),
     2                (PHIAM,ISCR(8)),(HIMSCR,ISCR(7)),(PHIBM,ISCR(9)),
     3                (GIB,ISCR(8)),(GIBBAR,ISCR(11)),(PHIIM,ISCR(6)),
     4                (HIMPRT,ISCR(7)),(HIMBAR,ISCR(8)),(PPRTN,ISCR(7)),
     5                (HIM,ISCR(10)),(RZ(1),Z(1)),(DZ(1),Z(1))
      DATA    MODNAM/ 4HCMRD,4H2D  /
      DATA    EPSLON/ 1.0E-03/
      DATA    ITEM  / 4HGIMS /
      DATA    ISCR7 / 307    /
C
C     READ LAMA FILE
C
      IF (DRY .EQ. -2) RETURN
      KORE  = KORBGN
      IFILE = LAMAMR
      CALL GOPEN (LAMAMR,Z(GBUF1),0)
      CALL FWDREC (*170,LAMAMR)
      LAMWDS = 6
      IF (MODES) LAMWDS = 7
      IT = 0
    2 CALL READ (*160,*4,LAMAMR,Z(KORBGN),LAMWDS,0,NWDS)
      KORBGN = KORBGN + 6
      IF (KORBGN .GE. KORLEN) GO TO 180
      IT = IT + 1
      GO TO 2
    4 CALL CLOSE (LAMAMR,1)
C
C     ZERO OUT PARTITIONING VECTOR AND SET UP MODE USE DESCRIPTION
C     RECORD
C
      MODEXT   = KORBGN
      ITRLR(1) = PHISSR
      IF (ITER .EQ. 2) ITRLR(1) = PHISSL
      CALL RDTRL (ITRLR)
      ITPHIS = ITRLR(2)
      IF (3*ITPHIS+MODEXT .GE. KORLEN) GO TO 180
      LAMLEN = LAMWDS*ITPHIS
      NNMAX  = MIN0(NMAX,ITPHIS)
      MODUSE = MODEXT + ITPHIS
      IPARTN = MODEXT + 2*ITPHIS
      MODLEN = ITPHIS
      DO 10 I = 1,ITPHIS
      Z(MODUSE+I-1) = 3
      Z(MODEXT+I-1) = 0
   10 RZ(IPARTN+I-1) = 0.0
C
C     SELECT DESIRED MODES
C
      KORBGN = MODEXT + 3*ITPHIS
      NFOUND = 0
      DO 20 I = 1,ITPHIS
      IF (NFOUND .EQ. NNMAX) GO TO 30
      J = 3 + LAMWDS*(I-1)
      IF (RZ(KORE+J).LE.RANGE(1) .OR. RZ(KORE+J).GE.RANGE(2)) GO TO 20
      Z(MODEXT+NFOUND) = I
      NFOUND = NFOUND + 1
      Z(MODUSE+I-1)  = 1
      RZ(IPARTN+I-1) = 1.0
   20 CONTINUE
C
C     PACK OUT PARTITIONING VECTOR
C
   30 TYPIN = 1
      TYPEP = 1
      IROWP = 1
      NROWP = ITRLR(2)
      INCRP = 1
      IFORM = 2
      CALL MAKMCB (ITRLR,PPRTN,NROWP,IFORM,TYPIN)
      CALL GOPEN (PPRTN,Z(GBUF1),1)
      CALL PACK (RZ(IPARTN),PPRTN,ITRLR)
      CALL CLOSE (PPRTN,1)
      CALL WRTTRL (ITRLR)
      KORBGN = KORBGN - ITPHIS
C
C     PARTITION PHISS(R,L) MATRICES
C
C        **     **   **         **
C        *       *   *   .       *
C        * PHISS * = * 0 . PHIAM *
C        *       *   *   .       *
C        **     **   **         **
C
      NSUB(1) = ITPHIS - NFOUND
      NSUB(2) = NFOUND
      NSUB(3) = 0
      LCORE   = KORLEN - KORBGN
      ICORE   = LCORE
      PHISS   = PHISSR
      IF (ITER .EQ. 2) PHISS = PHISSL
      CALL GMPRTN (PHISS,0,0,PHIAM,0,PPRTN,0,NSUB(1),NSUB(2),Z(KORBGN),
     1             ICORE)
C
C     PARTITION PHIAM MATRIX
C
C                    **     **
C                    *       *
C        **     **   * PHIBM *
C        *       *   *       *
C        * PHIAM * = *.......*
C        *       *   *       *
C        **     **   * PHIIM *
C                    *       *
C                    **     **
C
      FUSET = USETMR
      CALL CALCV (PPRTN,UN,UI,UB,Z(KORBGN))
      CALL GMPRTN (PHIAM,PHIIM,PHIBM,0,0,0,PPRTN,NSUB(1),NSUB(2),
     1             Z(KORBGN),ICORE)
      KHIM = 0
      IF (IA21(6) .EQ. 0) GO TO 55
C
C     COMPUTE MODAL TRANSFORMATION MATRIX
C
C        **   **   **     **   **   ** **     **
C        *     *   *       *   *     * *       *
C        * HIM * = * PHIIM * - * GIB * * PHIBM *
C        *     *   *       *   *     * *       *
C        **   **   **     **   **   ** **     **
C
      IF (ITER .EQ. 2) GO TO 40
      CALL SOFTRL (OLDNAM,ITEM,ITRLR)
      ITEST = ITRLR(1)
      IF (ITEST .NE. 1) GO TO 200
      CALL MTRXI (GIB,OLDNAM,ITEM,0,ITEST)
      IF (ITEST .NE. 1) GO TO 200
      ITRLR(1) = GIB
      GO TO 45
   40 ITRLR(1) = GIBBAR
      CALL RDTRL (ITRLR)
   45 DO 50 I = 1, 7
      ITRLRA(I) = ITRLR(I)
      ITRLRB(I) = IA21(I)
   50 ITRLRC(I) = IA11(I)
      IFORM = 2
      IPRC  = 1
      ITYP  = 0
      IF (ITRLRA(5).EQ.2 .OR. ITRLRA(5).EQ.4) IPRC = 2
      IF (ITRLRB(5).EQ.2 .OR. ITRLRB(5).EQ.4) IPRC = 2
      IF (ITRLRC(5).EQ.2 .OR. ITRLRC(5).EQ.4) IPRC = 2
      IF (ITRLRA(5) .GE. 3) ITYP = 2
      IF (ITRLRB(5) .GE. 3) ITYP = 2
      IF (ITRLRC(5) .GE. 3) ITYP = 2
      ITYPE = IPRC + ITYP
      CALL MAKMCB (ITRLRD,HIMSCR,ITRLR(3),IFORM,ITYPE)
      CALL SOFCLS
      T      = 0
      SIGNAB =-1
      SIGNC  = 1
      PREC   = 0
      SCR    = ISCR(7)
      DBLKOR = KORBGN/2 + 1
      NZ     = LSTZWD - 2*DBLKOR - 1
      CALL MPYAD  (DZ(DBLKOR),DZ(DBLKOR),DZ(DBLKOR))
      CALL WRTTRL (ITRLRD)
      CALL SOFOPN (Z(SBUF1),Z(SBUF2),Z(SBUF3))
      I      = ITRLRD(2)
      II     = ITRLRD(3)
      IFORM  = ITRLRD(4)
      HIMTYP = ITRLRD(5)
      GO TO 60
C
C     PHIBM IS NULL, HIM = PHIIM
C
   55 HIMSCR = PHIIM
      I      = IA11(2)
      II     = IA11(3)
      IFORM  = IA11(4)
      HIMTYP = IA11(5)
      KHIM   = 1
      DBLKOR = KORBGN/2 + 1
C
C     TEST SELECTED MODES
C
   60 NCORE = 4*II
      IF (KHIM .EQ. 0) NCORE = NCORE + 4*IA11(3)
      IF (KORBGN+NCORE .GE. KORLEN) GO TO 180
      TYPIN = HIMTYP
      TYPEP = HIMTYP
      IROWP = 1
      NROWP = II
      INCRP = 1
      IROWU = 1
      JHIM  = HIM
      IF (ITER .EQ. 2) JHIM = HIMBAR
      CALL GOPEN (HIMSCR,Z(GBUF1),0)
      IF (KHIM .EQ. 0) CALL GOPEN (PHIIM,Z(GBUF2),0)
      CALL MAKMCB (ITRLR,JHIM,II,IFORM,HIMTYP)
      CALL GOPEN  (JHIM,Z(GBUF3),1)
      NFOUND = 0
      IT     = I
      DBLKOR = KORBGN/2 + 1
      SGLKOR = 2*DBLKOR - 1
      IF (HIMTYP .EQ. 3) DICORE = ((SGLKOR + 2*II)/2) + 1
      IF (HIMTYP .EQ. 4) DICORE = DBLKOR + 2*II
      ICORE = 2*DICORE - 1
C
C     UNPACK HIM AND PHIIM COLUMNS
C
      DO 140 I = 1,IT
      TYPEU = HIMTYP
      INCRU = 1
      NROWU = II
      IHIM  = NROWU
      CALL UNPACK (*110,HIMSCR,DZ(DBLKOR))
      IF (KHIM .EQ. 1) GO TO 70
      TYPEU = IA11(5)
      INCRU = 1
      NROWU = IA11(3)
      IPHIM = NROWU
      CALL UNPACK (*90,PHIIM,DZ(DICORE))
C
C     SAVE LARGEST HIM COLUMN VALUE AND CALCULATE MAGNITUDE OF HIM,
C     PHIIM COLUMNS
C
   70 IF (HIMTYP .EQ. 4) GO TO 74
      ITYPE  = 0
      HIMSUM = 0.0
      HIMMAG = 0.0
      DO 72 J = 1,IHIM
      K = 1 + 2*(J-1)
      HIMAG = SQRT((RZ(SGLKOR+K-1)**2) + (RZ(SGLKOR+K)**2))
      IF (HIMAG .GE. HIMMAG) HIMMAG = HIMAG
   72 HIMSUM = HIMSUM + (RZ(SGLKOR+K-1)**2) + (RZ(SGLKOR+K)**2)
      GO TO 78
   74 ITYPE  = 1
      DHIMSM = 0.0D0
      DHIMAG = 0.0D0
      DO 76 J = 1,IHIM
      K = 1 + 2*(J-1)
      DHIMG = DSQRT((DZ(DBLKOR+K-1)**2) + (DZ(DBLKOR+K)**2))
      IF (DHIMG .GE. DHIMAG) DHIMAG = DHIMG
   76 DHIMSM = DHIMSM + (DZ(DBLKOR+K-1)**2) + (DZ(DBLKOR+K)**2)
   78 IF (KHIM    .EQ. 1) GO TO 95
      IF (IA11(5) .EQ. 4) GO TO 82
      ITYPE  = ITYPE + 1
      PHIMSM = 0.0
      DO 80 J = 1,IPHIM
      K = 1 + 2*(J-1)
   80 PHIMSM = PHIMSM + (RZ(ICORE+K-1)**2) + (RZ(ICORE+K)**2)
      GO TO 85
   82 ITYPE = ITYPE + 2
      DPHIM = 0.0D0
      DO 84 J = 1,IPHIM
      K = 1 + 2*(J-1)
   84 DPHIM = DPHIM + (DZ(DICORE+K-1)**2) + (DZ(DICORE+K)**2)
C
C     TEST FOR INCLUSION
C
   85 GO TO (86,87,88,89), ITYPE
   86 IF (PHIMSM .EQ. 0.0) GO TO 90
      IF (SQRT(HIMSUM)/SQRT(PHIMSM) .GE. EPSLON) GO TO 95
      GO TO 90
   87 IF (DPHIM .EQ. 0.0) GO TO 90
      IF (SQRT(HIMSUM)/DSQRT(DPHIM) .GE. EPSLON) GO TO 95
      GO TO 90
   88 IF (PHIMSM .EQ. 0.0) GO TO 90
      IF (DSQRT(DHIMSM)/SQRT(PHIMSM) .GE. EPSLON) GO TO 95
      GO TO 90
   89 IF (DPHIM .EQ. 0.0D0) GO TO 90
      IF (DSQRT(DHIMSM)/DSQRT(DPHIM) .GE. EPSLON) GO TO 95
C
C     REJECT MODE
C
   90 J = Z(MODEXT+I-1)
      Z(MODUSE+J-1) = 2
      GO TO 140
C
C     USE MODE
C
   95 NFOUND = NFOUND + 1
C
C     SCALE HIM COLUMN
C
      IHIM = 2*IHIM
      IF (HIMTYP .EQ. 4) GO TO 104
      DO 102 J = 1,IHIM
  102 RZ(SGLKOR+J-1) = RZ(SGLKOR+J-1)/HIMMAG
      GO TO 130
  104 DO 106 J = 1,IHIM
  106 DZ(DBLKOR+J-1) = DZ(DBLKOR+J-1)/DHIMAG
      GO TO 130
C
C     NULL COLUMN
C
  110 IHIM = 2*IHIM
      IF (HIMTYP .EQ. 4) GO TO 114
      DO 112 J = 1,IHIM
  112 RZ(SGLKOR+J-1) = 0.0
      GO TO 130
  114 DO 116 J = 1,IHIM
  116 DZ(DBLKOR+J-1) = 0.0D0
C
C     PACK HIM COLUMN
C
  130 NROWP = NROWU
      CALL PACK (DZ(DBLKOR),JHIM,ITRLR)
  140 CONTINUE
      CALL CLOSE (JHIM,1)
      IF (KHIM .EQ. 0) CALL CLOSE (PHIIM,1)
      CALL CLOSE (HIMSCR,1)
      CALL WRTTRL (ITRLR)
      KORBGN = KORE
      IF (KHIM .EQ. 1) HIMSCR = ISCR7
      RETURN
C
C     PROCESS SYSTEM FATAL ERRORS
C
  160 IMSG = -2
      GO TO 190
  170 IMSG = -3
      GO TO 190
  180 IMSG = -8
      IFILE = 0
  190 CALL SOFCLS
      CALL MESAGE (IMSG,IFILE,MODNAM)
      RETURN
C
C     PROCESS MODULE FATAL ERRORS
C
  200 GO TO (210,210,220,230,240,260), ITEST
  210 WRITE (IPRNTR,900) UFM,MODNAM,ITEM,OLDNAM
      DRY = -2
      RETURN
C
  220 IMSG = -1
      GO TO 250
  230 IMSG = -2
      GO TO 250
  240 IMSG = -3
  250 CALL SMSG (IMSG,ITEM,OLDNAM)
      RETURN
C
  260 WRITE (IPRNTR,901) UFM,MODNAM,ITEM,OLDNAM
      DRY = -2
      RETURN
C
  900 FORMAT (A23,' 6215, MODULE ',2A4,' - ITEM ',A4,
     1       ' OF SUBSTRUCTURE ',2A4,' PSEUDO-EXISTS ONLY.')
  901 FORMAT (A23,' 6632, MODULE ',2A4,' - NASTRAN MATRIX FILE FOR I/O',
     1       ' OF SOF ITEM ',A4,', SUBSTRUCRURE ',2A4,', IS PURGED.')
C
      END

        SUBROUTINE DSMSG1 ( BLOCK )
        COMMON / ZBLPKX / A1(4), IROW1
        COMMON / ZNTPKX / A2(4), IROW2, IEOL2, IEOR2
        COMMON / PACKX  / ITIN3, ITOUT3, IROW3, NROW3, INCR3
        COMMON / UNPAKX / ITOUT4,IROW4, NROW4, INCR4
        COMMON / SYSTEM / NONE,  IWR
        INTEGER BLOCK(15)
        WRITE( IWR, 9000 )
        WRITE( IWR, 9010 )
        WRITE( IWR, 9015 ) BLOCK
        WRITE( IWR, 9020 )
        WRITE( IWR, 9015 ) A1, IROW1
        WRITE( IWR, 9030 )
        WRITE( IWR, 9015 ) A2, IROW2, IEOL2, IEOR2
        WRITE( IWR, 9040 )
        WRITE( IWR, 9015 ) ITIN3, ITOUT3, IROW3, NROW3, INCR3
        WRITE( IWR, 9050 )
        WRITE( IWR, 9015 ) ITOUT4, IROW4, NROW4, INCR4
9000    FORMAT(' *** ERROR OCCURRED IN PAKUNPK I/O SUBSYSTEM ***')
9010    FORMAT(' CONTENTS OF THE STRING CONTROL BLOCK')
9015    FORMAT(10(5(1X,Z8),/))
9020    FORMAT(' CONTENTS OF /ZBLPKX/')
9030    FORMAT(' CONTENTS OF /ZNTPKX/')
9040    FORMAT(' CONTENTS OF /PACKX/ ')
9050    FORMAT(' CONTENTS OF /UNPAKX/')
        RETURN
        END

      PROGRAM NASTRN
C
      CHARACTER*80    VALUE
      CHARACTER*5     TMP
      INTEGER         SPERLK
      REAL            SYSTM(94)
      COMMON / LSTADD / LASTAD
      COMMON / SYSTEM / ISYSTM(94),SPERLK
      COMMON / SOFDSN / SDSN(10)
      COMMON / LOGOUT / LOUT
      COMMON / RESDIC / IRDICT, IROPEN
      COMMON / ZZZZZZ / IZ(400000000)
      COMMON / DBM    / IDBBAS, IDBFRE, IDBDIR, INDBAS, INDCLR, INDCBP
     &,                 NBLOCK, LENALC, IOCODE, IFILEX, NAME,   MAXALC
     &,                 MAXBLK, MAXDSK, IDBLEN, IDBADR, IBASBF, INDDIR
     &,                 NUMOPN, NUMCLS, NUMWRI, NUMREA, LENOPC
      INCLUDE 'NASNAMES.COM'
      CHARACTER*80    SDSN
      EQUIVALENCE    ( ISYSTM, SYSTM )
      LENOPC = 400000000
C
C     SAVE STARTING CPU TIME AND WALL CLOCK TIME IN /SYSTEM/
C
      ISYSTM(18) = 0
      CALL SECOND (SYSTM(18))
      CALL WALTIM (ISYSTM(32))
C
C     EXECUTE NASTRAN SUPER LINK
C
      LEN = 80
      VALUE = ' '
      CALL BTSTRP
      CALL GETENV ( 'DBMEM', VALUE )
      READ ( VALUE, * ) IDBLEN
      CALL GETENV ( 'OCMEM', VALUE )
      READ ( VALUE, * ) IOCMEM
      IF ( IOCMEM .LE. LENOPC ) GO TO 10
      PRINT *,' LARGEST VALUE FOR OPEN CORE ALLOWED IS:',LENOPC
      CALL MESAGE ( -61, 0, 0 )
10    IF ( IDBLEN .NE. 0 ) IDBLEN = LENOPC - IOCMEM
      LASTAD = LOCFX( IZ( IOCMEM ) )
      IF ( IDBLEN .NE. 0 ) IDBADR = LOCFX( IZ( IOCMEM+1 ) )
      LENOPC = IOCMEM
      CALL DBMINT
      LOUT   = 3
      IRDICT = 4
      SPERLK = 1
      ISYSTM(11) = 1
      VALUE = ' '
      CALL GETENV ( 'RFDIR',  RFDIR  )
      VALUE = ' '
      CALL GETENV ( 'DIRCTY', DIRTRY )
      LEN = INDEX( DIRTRY, ' ' ) - 1
      DO 20 I = 1, 90
      IF ( I .LE. 9 ) WRITE ( TMP, 901 ) I
      IF ( I .GT. 9 ) WRITE ( TMP, 902 ) I
901   FORMAT('scr',I1)
902   FORMAT('scr',I2)
      DSNAMES( I ) = DIRTRY(1:LEN)//'/'//TMP
20    CONTINUE
      CALL GETENV ( 'LOGNM', LOG )
      DSNAMES(3) = LOG
      CALL GETENV ( 'OPTPNM', OPTP )
      DSNAMES(7)  = OPTP
      CALL GETENV ( 'NPTPNM', NPTP )
      DSNAMES(8)  = NPTP
      CALL GETENV ( 'FTN11', OUT11 )
      DSNAMES(11) = OUT11
      CALL GETENV ( 'FTN12', IN12 )
      DSNAMES(12) = IN12
      CALL GETENV ( 'FTN13', VALUE )
      DSNAMES(13) = VALUE
      CALL GETENV ( 'FTN14', VALUE )
      DSNAMES(14) = VALUE
      CALL GETENV ( 'FTN15', VALUE )
      DSNAMES(15) = VALUE
      CALL GETENV ( 'FTN16', VALUE )
      DSNAMES(16) = VALUE
      CALL GETENV ( 'FTN17', VALUE )
      DSNAMES(17) = VALUE
      CALL GETENV ( 'FTN18', VALUE )
      DSNAMES(18) = VALUE
      CALL GETENV ( 'FTN19', VALUE )
      DSNAMES(19) = VALUE
      CALL GETENV ( 'FTN20', VALUE )
      DSNAMES(20) = VALUE
      CALL GETENV ( 'FTN21', VALUE )
      DSNAMES(21) = VALUE
      CALL GETENV ( 'PLTNM', PLOT )
      DSNAMES(10) = PLOT
      CALL GETENV ( 'DICTNM', DIC )
      DSNAMES(4) = DIC
      CALL GETENV ( 'PUNCHNM', PUNCH )
      DSNAMES(1) = PUNCH
      CALL GETENV ( 'SOF1', VALUE )
      SDSN(1) = VALUE
      CALL GETENV ( 'SOF2', VALUE )
      SDSN(2) = VALUE
      CALL GETENV ( 'SOF3', VALUE )
      SDSN(3) = VALUE
      CALL GETENV ( 'SOF4', VALUE )
      SDSN(4) = VALUE
      CALL GETENV ( 'SOF5', VALUE )
      SDSN(5) = VALUE
      CALL GETENV ( 'SOF6', VALUE )
      SDSN(6) = VALUE
      CALL GETENV ( 'SOF7', VALUE )
      SDSN(7) = VALUE
      CALL GETENV ( 'SOF8', VALUE )
      SDSN(8) = VALUE
      CALL GETENV ( 'SOF9', VALUE )
      SDSN(9) = VALUE
      CALL GETENV ( 'SOF10', VALUE )
      SDSN(10) = VALUE
      OPEN (  3, FILE=DSNAMES(3) ,STATUS='UNKNOWN')
      IF ( DSNAMES(11) .NE. 'none' )
     & OPEN ( 11, FILE=DSNAMES(11),STATUS='UNKNOWN')
      IF ( DSNAMES(12) .NE. 'none' )
     & OPEN ( 12, FILE=DSNAMES(12),STATUS='UNKNOWN')
      IF ( DSNAMES(10) .NE. 'none' )
     & OPEN ( 10, FILE=DSNAMES(10),STATUS='UNKNOWN')
      IF ( DSNAMES(4) .NE. 'none' )
     & OPEN ( 4, FILE=DSNAMES(4),STATUS='UNKNOWN')
      IF ( DSNAMES(1) .NE. 'none' )
     & OPEN ( 1, FILE=DSNAMES(1),STATUS='UNKNOWN')
      CALL XSEM00
      STOP
      END

      SUBROUTINE DSCPOS ( FILE, ICBLK, ICLR, ICBP )
C
C RETURNS THE CURRENT BLOCK NUMBER "ICBLK", CURRENT LOGICAL RECORD
C POINTER "ICLR" AND CURRENT BUFFER POINT "ICBP" FOR "FILE"
C
      INCLUDE 'DSIOF.COM'
      INTEGER          FILE
      NAME   = FILE
      CALL DSGEFL
      ICBLK  = FCB( 4, IFILEX )
      ICLR   = INDCLR - INDBAS + 1
      ICBP   = INDCBP - INDBAS + 1
      RETURN
      END

      SUBROUTINE RCOVIM (HIGHER)
C
C     THIS SUBROUTINE CALCULATES THE ENERGIES ON THE MODAL COORDINATES
C     IN A SUBSTRUCTURE THAT WAS MODAL REDUCED.  IT WILL ALSO
C     CALCULATE THE TOTAL ENERGY FOR EACH COLUMN.
C
      INTEGER         FSS        ,RSS        ,UA         ,RFNO      ,
     1                Z          ,RC         ,SOF1       ,SOF2      ,
     2                SOF3       ,BUF1       ,BUF2       ,BUF3      ,
     3                TFLAG      ,SIGNAB     ,SIGNC      ,SCRM      ,
     4                SCR5       ,SCR6       ,SCR7       ,SCR8      ,
     5                SCR9       ,NAME(2)    ,BUF4       ,FILE      ,
     6                RSP        ,HIGHER(2)  ,UVEC
      REAL            RZ(1)
      COMMON /BLANK / DRY        ,LOOP       ,STEP       ,FSS(2)     ,
     1                RFNO       ,NEIGV      ,LUI        ,UINMS(2,5) ,
     2                NOSORT     ,UTHRES     ,PTHRES     ,QTHRES
      COMMON /RCOVCR/ ICORE      ,LCORE      ,BUF1       ,BUF2       ,
     1                BUF3       ,BUF4       ,SOF1       ,SOF2       ,
     2                SOF3
      COMMON /RCOVCM/ MRECVR     ,UA         ,PA         ,QA         ,
     1                IOPT       ,RSS(2)     ,ENERGY     ,UIMPRO     ,
     2                RANGE(2)   ,IREQ       ,LREQ       ,LBASIC
      COMMON /ZZZZZZ/ Z(1)
      COMMON /MPYADX/ MCBA(7)    ,MCBB(7)    ,MCBC(7)    ,MCBD(7)    ,
     1                MPYZ       ,TFLAG      ,SIGNAB     ,SIGNC      ,
     2                MPREC      ,SCRM
      COMMON /UNPAKX/ ITINU      ,IRU        ,NRU        ,INCRU
      COMMON /PACKX / ITINP      ,ITOUTP     ,IRP        ,NRP        ,
     1                INCRP
      COMMON /NAMES / RD         ,RDREW      ,WRT        ,WRTREW     ,
     1                REW        ,NOREW      ,EOFNRW     ,RSP        ,
     2                RDP        ,CSP        ,CDP        ,SQUARE     ,
     3                RECT       ,DIAG       ,UPPER      ,LOWER      ,
     4                SYM
      EQUIVALENCE     (Z(1),RZ(1))
      DATA    UVEC  , KMTX,MMTX  / 4HUVEC,4HKMTX,4HMMTX /
      DATA    SCR5  , SCR6,SCR7,SCR8,SCR9 / 305,306,307,308,309 /
      DATA    NAME  / 4HRCOV,4HIM         /
C
C     INITIALIZE
C
      LCOREZ = KORSZ(Z)
      MPYZ   = LCOREZ
      TFLAG  = 0
      SIGNAB = 1
      SIGNC  = 1
      MPREC  = 0
C
C     GET THE DISPLACEMENT VECTOR FOR THE HIGHER LEVEL REDUCED
C     SUBSTRUCTURE.
C
      ITEM = UVEC
      CALL MTRXI (SCR5,HIGHER,UVEC,0,RC)
      IF (RC .NE. 1) GO TO 6000
C
C     CALCULATE VELOCITIES IF NOT ALREADY DONE FOR THE OUTPUT PHASE.
C
      INTYP = 1
      IF (RFNO.EQ.3 .OR. RFNO.EQ.8) INTYP = 0
      CALL RCOVVA (SCR5,INTYP,0,SCR8,SCR9,0,HIGHER,Z(1),Z(1),Z(1))
      IF (UA .LE. 0) GO TO 9200
C
C     CALCULATE THE KENETIC ENERTY MULTIPLIER - M * V
C
      ITEM = MMTX
      CALL MTRXI (SCR5,HIGHER,MMTX,0,RC)
      IF (RC .NE. 1) GO TO 6000
      MCBA(1) = SCR5
      CALL RDTRL (MCBA)
      MCBB(1) = SCR9
      CALL RDTRL (MCBB)
      NCOL    = MCBB(2)
      MCBC(1) = 0
      CALL MAKMCB (MCBD,SCR7,MCBB(3),RECT,MCBB(5))
      SCRM = SCR6
      CALL SOFCLS
      CALL MPYAD (Z(1),Z(1),Z(1))
      CALL WRTTRL (MCBD)
C
C     CALCULATE THE KENETIC ENERGIES BY PERFORMING THE SCALAR
C     MULTIPLY IN SINGLE PERCISION.  USE ONLY THE REAL PART IF COMPLEX
C     VECTORS.  APPEND THE TOTAL KINETIC ENERGY TO THE END OF EACH
C     COLUMN.
C
      ITINU = RSP
      IRU   = 1
      NRU   = MCBD(3)
      INCRU = 1
      ITINP = RSP
      ITOUTP= RSP
      IRP   = 1
      NRP   = NRU + 1
      INCRP = 1
      IVEC1 = 1
      IVEC2 = IVEC1 + NRU + 1
      IF (IVEC2+NRU+1 .GT. SOF3) GO TO 9008
C
      FILE = SCR9
      CALL GOPEN (SCR7,Z(SOF1),RDREW)
      CALL GOPEN (SCR9,Z(SOF2),RDREW)
      CALL GOPEN (SCR6,Z(SOF3),WRTREW)
      CALL MAKMCB (MCBA,SCR6,NRP,RECT,RSP)
C
      DO 160 I = 1,NCOL
      ISK = 1
      CALL UNPACK (*130,SCR7,RZ(IVEC1))
      ISK = 0
      CALL UNPACK (*130,SCR9,RZ(IVEC2))
C
      TOTAL = 0.0
      DO 120 J = 1,NRU
      K = J - 1
      RZ(IVEC1+K) = RZ(IVEC1+K)*RZ(IVEC2+K)
      TOTAL = TOTAL + RZ(IVEC1+K)
  120 CONTINUE
      RZ(IVEC1+NRU) = TOTAL
      GO TO 150
C
  130 DO 140 J = 1,NRP
  140 RZ(IVEC1+J-1) = 0.0
      IF (ISK .NE. 0)CALL FWDREC (*9002,SCR9)
C
  150 CALL PACK (RZ(IVEC1),SCR6,MCBA)
C
  160 CONTINUE
C
      CALL CLOSE (SCR7,REW)
      CALL CLOSE (SCR9,REW)
      CALL CLOSE (SCR6,REW)
      CALL WRTTRL (MCBA)
      CALL SOFOPN (Z(SOF1),Z(SOF2),Z(SOF3))
C
C     CALCULATE THE POTENTIAL ENERTY MULTPLYIER - K*U
C
      ITEM = KMTX
      CALL MTRXI (SCR5,HIGHER,KMTX,0,RC)
      IF (RC .NE. 1) GO TO 6000
      MCBA(1) = SCR5
      CALL RDTRL (MCBA)
      MCBB(1) = SCR8
      CALL RDTRL (MCBB)
      CALL MAKMCB (MCBD,SCR9,MCBB(3),RECT,MCBB(5))
      SCRM = SCR7
      CALL SOFCLS
      CALL MPYAD (Z(1),Z(1),Z(1))
      CALL WRTTRL (MCBD)
C
C     CALCULATE THE POTENTIAL ENERGIES BY PERFORMING THE SCALAR
C     MULTIPLY IN SINGLE PERCISION.  USE ONLY THE REAL PART IF COMPLEX
C     VECTORS.  APPEND THE TOTAL POTENTIAL ENERGY TO THE END OF EACH
C     COLUMN.
C
      ITINU = RSP
      IRU   = 1
      NRU   = MCBD(3)
      INCRU = 1
      ITINP = RSP
      ITOUTP= RSP
      IRP   = 1
      NRP   = NRU + 1
      INCRP = 1
C
      FILE = SCR8
      CALL GOPEN (SCR9,Z(SOF1),RDREW)
      CALL GOPEN (SCR8,Z(SOF2),RDREW)
      CALL GOPEN (SCR7,Z(SOF3),WRTREW)
      CALL MAKMCB (MCBA,SCR7,NRP,RECT,RSP)
C
      DO 260 I = 1,NCOL
      ISK = 1
      CALL UNPACK (*230,SCR9,RZ(IVEC1))
      ISK = 0
      CALL UNPACK (*230,SCR8,RZ(IVEC2))
      TOTAL = 0.0
      DO 220 J = 1,NRU
      K = J - 1
      RZ(IVEC1+K) = RZ(IVEC1+K)*RZ(IVEC2+K)
      TOTAL = TOTAL + RZ(IVEC1+K)
  220 CONTINUE
      RZ(IVEC1+NRU) = TOTAL
      GO TO 250
C
  230 DO 240 J = 1,NRP
  240 RZ(IVEC1+J-1) = 0.0
      IF (ISK .NE. 0)CALL FWDREC (*9002,SCR8)
C
  250 CALL PACK (RZ(IVEC1),SCR7,MCBA)
C
  260 CONTINUE
C
      CALL CLOSE (SCR9,REW)
      CALL CLOSE (SCR8,REW)
      CALL CLOSE (SCR7,REW)
      CALL WRTTRL (MCBA)
C
C     NORMAL RETURN
C
      CALL SOFOPN (Z(SOF1),Z(SOF2),Z(SOF3))
      RETURN
C
C     ERRORS
C
 6000 CALL SMSG (RC-2,ITEM,HIGHER)
      GO TO 9200
 9002 N = 2
      GO TO 9100
 9008 N = 8
 9100 CALL MESAGE (N,FILE,NAME)
 9200 IOPT = -1
      RETURN
      END

      SUBROUTINE EADD (P,PREC)
C
      INTEGER          IA(7)    ,IB(7)    ,IC(7)     ,PREC
      DOUBLE PRECISION BETA(2)  ,P(1)     ,ALPHA(2)
      COMMON /REGEAN/  IM(7)    ,IK(7)    ,IEV(7)    ,KA(5)    ,LC    ,
     1                 NN(13)   ,IBUCK
      COMMON /BLANK /  XX
      COMMON /SADDX /  NOMAT    ,NZ       ,MCBS(67)
      COMMON /ZZZZZZ/  CORE(1)
      EQUIVALENCE      (MCBS( 1),IA(1))   ,(MCBS( 8),IALP)     ,
     1                 (MCBS( 9),ALPHA(1)),(MCBS(13),IB(1))    ,
     2                 (MCBS(20),IBETA)   ,(MCBS(21),BETA(1))  ,
     3                 (MCBS(61),IC(1))
C
      NZ = (KORSZ(CORE)/2)*2 - LC
      DO 10 I = 1,7
      IA(I) = IM(I)
      IB(I) = IK(I)
   10 IC(I) = IK(I)
      IC(1) = KA(1)
      KPREC = IK(5)
      IF (PREC.GE.1 .AND. PREC.LE.4) KPREC = PREC
      IALP = KPREC
      ALPHA(1) = P(1)
      IBETA  = KPREC
      BETA(1)= 1.0D0
      NOMAT  = 2
      CALL SADD (CORE,CORE)
      CALL WRTTRL (IC)
      RETURN
      END

      SUBROUTINE TRHT1A (CASEXX,USETD,GPTT,TRL,NGROUP)
C
C     TRHT1A INITIALIZES FOR TRHT MODULE
C
C     ITS TASK IS TO EXTRACT INITIAL CONDITION POINTS FROM CASEXX
C     AND TO PUT INITIAL STUFF ON ICR5
C
      EXTERNAL        ANDF
      INTEGER         CASEXX,USETD,GPTT,TRL,SYSBUF,IZ(160),NAME(2),
     1                FILE,ANDF,TWO1,MCB(7),IA(1)
      COMMON /BITPOS/ ISK(11),IUE,ISK1(3),IUD
      COMMON /TWO   / TWO1(32)
      COMMON /BLANK / X
      COMMON /SYSTEM/ SYSBUF
      COMMON /TRHTX / IK(7),IB(7),ICR1,ICR2,ICR3,ICR4,ISCR5
      COMMON /TRDD1 / NLFT1,DIT1,NLFTP1
      COMMON /ZZZZZZ/ Z(1)
      COMMON /ZBLPKX/ A(4),II
      COMMON /PACKX / IT1,IT2,II1,JJ1,INCR
      EQUIVALENCE     (Z(1),IZ(1)), (A(1),IA(1))
      DATA    NAME  / 4HTRHT,4H1A  /
C
C
      NZ = KORSZ(Z)
      NX = NZ
      IBUF1 = NZ - SYSBUF + 1
      NZ = NZ - SYSBUF
      CALL GOPEN (CASEXX,IZ(IBUF1),0)
      CALL FREAD (CASEXX,IZ(1),166,1)
      CALL CLOSE (CASEXX,1)
      ITSTEP = IZ(38)
      NLFTP1 = IZ(160)
      INTMP  = IZ(9)
      INLTMP = IZ(8)
C
C     FIND STUFF ON TRL
C
      FILE = TRL
      CALL OPEN (*200,TRL,IZ(IBUF1),0)
      CALL READ (*220,*10,TRL,IZ(1),NZ,0,IFLAG)
      GO TO 230
   10 NS =  IZ(3)
      CALL SKPREC (TRL,NS)
   30 CALL READ (*240,*40,TRL,IZ(1),NZ,0,IFLAG)
      GO TO 230
   40 IF (IZ(1) .NE. ITSTEP) GO TO 30
C
C     TSTEP STUFF FOUND
C
      CALL CLOSE (TRL,1)
      NGROUP = (IFLAG-1)/3
C
C     MOVE TSETP STUFF TO BOTTOM OF CURE
C
      NZ = NX - IFLAG + 1
      IGROUP = NZ + 1
      DO 50 I = 2,IFLAG
      K = IGROUP + I - 2
      IZ(K) = IZ(I)
   50 CONTINUE
      IBUF1 = NZ - SYSBUF + 1
      IBUF2 = IBUF1 -SYSBUF
      NZ = IBUF2
      CALL GOPEN (ISCR5,IZ(IBUF1),1)
      CALL WRITE (ISCR5,IZ(IGROUP),IFLAG-1,1)
      FILE = USETD
C
C     BRING IN USETD
C
      CALL GOPEN (USETD,IZ(IBUF2),0)
      CALL READ (*220,*60,USETD,IZ(1),NZ,1,LUSETD)
      GO TO 230
   60 CALL CLOSE (USETD,1)
C
C     BUILD SIL TO SILD CONVERTER TABLE
C
      MSKUE = TWO1(IUE)
      MSKUD = TWO1(IUD)
      M = 1
      L = 0
      DO 70 I = 1,LUSETD
      IF (ANDF(IZ(I),MSKUE) .NE. 0) GO TO 65
      L = L + 1
      IF (ANDF(IZ(I),MSKUD) .EQ. 0) GO TO 67
      IZ(L) = M
   65 CONTINUE
      M = M + 1
      GO TO 70
   67 IZ(L) = 0
   70 CONTINUE
C
C     FIND STUFF IN GPTT
C
      ITS = INTMP
      CALL MAKMCB (MCB,ISCR5,M-1,2,1)
      NS  = 0
      FILE = GPTT
      CALL OPEN (*200,GPTT,IZ(IBUF2),0)
C
C     POSITION TO HEADER RECORD
C
      IVAL = NZ - 2*L
      CALL READ (*220,*80,GPTT,IZ(L+1),IVAL,0,IFLAG)
      GO TO 230
C
C     PUT OUT TEMPS
C
   80 CONTINUE
C
C     DETERMINE NUMBER OF ELEMENT TEMP RECORDS TO SKIP.
C
      LIST = L + 3
      K = L + IFLAG
   82 NSK = IZ(K)
      IF (NSK .GT. 0) GO TO 84
      K = K - 3
      IF (K .GT. LIST) GO TO 82
C
C     SET IPOS TO SKIP ELEMENT TEMP RECORDS AND DUPLICATE HEADER.
C
   84 IPOS = -NSK
      MCB(2) = 0
   90 IF (ITS .EQ. 0) GO TO 170
      K = LIST
  100 IF (IZ(K) .EQ.  ITS) GO TO 110
      K = K + 3
      IF (K .GT. L+IFLAG) CALL MESAGE (-31,ITS,NAME)
      GO TO 100
C
C     FOUND TEMP SET
C
  110 TDFLT = 0.0
      IF (IZ(K+1) .NE. -1) TDFLT = Z(K+1)
      M = L + IFLAG
      DO 130 I = 1,L
      J = M + I
      Z(J) = TDFLT
  130 CONTINUE
C
C     RECORD NUMBER OF TEMP SET FOUND
C
      NS = IZ(K+2)
      IF (NS .EQ. 0) GO TO 150
C
C     SKIP TO DESIRED RECORD
C
  132 IF (NS-IPOS) 134,140,136
  134 CALL BCKREC (GPTT)
      IPOS = IPOS - 1
      GO TO 132
  136 CALL FWDREC (*220,GPTT)
      IPOS = IPOS + 1
      GO TO 132
  140 CALL READ (*220,*145,GPTT,A,2,0,IFLG)
      IF (IA(1) .LE. 0) GO TO 140
      J = IA(1) + M
      Z (J) = A(2)
      GO TO 140
  145 IPOS = IPOS + 1
C
C     ALL SET UP OUTPUT
C
  150 INEXT = M + 1
      DO 160 I = 1,L
      J = M + I
      II = IZ(I) + M
      IF (II .EQ. M) GO TO 160
      IF (II .EQ. INEXT) GO TO 155
      DO 153 K = INEXT,II
  153 Z(K)  = 0.0
  155 Z(II) = Z(J)
      INEXT = II + 1
  160 CONTINUE
      J = INEXT - (M+1)
      CALL WRITE (ISCR5,Z(M+1),J,0)
  170 CALL WRITE (ISCR5,Z(1),0,1)
      MCB(2) = MCB(2) + 1
      IF (MCB(2) .EQ. 2) GO TO 190
      ITS = INLTMP
      GO TO 90
C
C     ALL DONE
C
  190 CALL CLOSE (ISCR5,1)
      CALL CLOSE (GPTT,1)
      CALL WRTTRL (MCB)
      RETURN
C
C     ERROR MESAGES
C
  200 IP1 = -1
  210 CALL MESAGE (IP1,FILE,NAME)
      RETURN
  220 IP1 = -2
      GO TO 210
  230 IP1 = -8
      GO TO 210
  240 CALL MESAGE (-31,ITSTEP,NAME)
      RETURN
      END

      SUBROUTINE EDIT (NAME,IOPT,ITEST)
C
C     REMOVES SELECTED ITEMS OF THE SUBSTRUCTURE NAME FROM THE SOF.
C     THE VALUE OF IOPT IS THE SUM OF THE FOLLOWING INTEGERS REFLECTING
C     WHICH ITEMS ARE TO BE REMOVED.
C
C              1 = STIFFNESS MATRIX
C              2 = MASS MATRIX
C              4 = LOAD DATA
C              8 = SOLUTION DATA
C             16 = TRANSFORMATION DATA
C             32 = ALL ITEMS OF SUBSTRUCTURE
C             64 = APPENDED LOADS DATA
C            128 = DAMPING MATRICES
C            256 = MODES DATA
C
C     THE OUTPUT VARIABLE ITEST TAKES ON ONE OF THE FOLLOWING VALUES
C              1   NORMATL RETURN
C              4   IF NAME DOES NOT EXIST
C
      EXTERNAL        ANDF
      INTEGER         ANDF,NAME(2),NMSBR(2)
      COMMON /ITEMDT/ NITEM,ITEM(7,1)
      DATA    NMSBR / 4HEDIT,4H    /
C
      CALL CHKOPN (NMSBR(1))
      ITEST = 1
      IF (IOPT .LE. 0) GO TO 20
      CALL FDSUB (NAME(1),INDEX)
      IF (INDEX .EQ. -1) GO TO 30
C
C     REMOVE SELECTED ITEMS ACCORDING TO IOPT S VALUE.
C
      DO 10 I = 1,NITEM
      MASK = ITEM(7,I)
      IF (ANDF(IOPT,MASK) .NE. 0) CALL DELETE (NAME,ITEM(1,I),IT)
   10 CONTINUE
   20 RETURN
C
C     NAME DOES NOT EXIST.
C
   30 ITEST = 4
      RETURN
      END

      SUBROUTINE TRIQD( NTYPE, T )
C*****
C  ELEMENT THERMAL AND DEFORMATION LOADING ROUTINE FOR FOUR ELEMENTS
C*****
C
C                     E C P T     L I S T I N G
C                    ***************************
C ECPT  TRMEM   QDMEM   TRPLT   QDPLT   TRIA1   QUAD1   TRIA2   QUAD2
C **********************************************************************
C   1   EL.ID   EL.ID   EL.ID   EL.ID   EL.ID   EL.ID   EL.ID   EL.ID
C   2   GRID A  GRID A  GRID A  GRID A  GRID A  GRID A  GRID A  GRID A
C   3   GRID B  GRID B  GRID B  GRID B  GRID B  GRID B  GRID B  GRID B
C   4   GRID C  GRID C  GRID C  GRID C  GRID C  GRID C  GRID C  GRID C
C   5   THETA   GRID D  THETA   GRID D  THETA   GRID D  THETA   GRID D
C   6   MATID   THETA   MATID1  THETA   MATID1  THETA   MAT ID  THETA
C   7   T       MAT ID  I       MATID1  T1      MATID1  T       MAT ID
C   8   NS MASS T       MATID2  I       MATID2  T1      NS MASS T
C   9   CSID 1  NS MASS T2      MATID2  I       MATID2  CSID 1  NS MASS
C  10   X1      CSID 1  NS MASS T2      MATID3  I       X1      CSID 1
C  11   Y1      X1      Z1      NS MASS T2      MATID3  Y1      X1
C  12   Z1      Y1      Z2      Z1      NS MASS T2      Z1      Y1
C  13   CSID 2  Z1      CSID 1  Z2      Z1      NS MASS CSID 2  Z1
C  14   X2      CSID 2  X1      CSID 1  Z2      Z1      X2      CSID 2
C  15   Y2      X2      Y1      X1      CSID 1  Z2      Y2      X2
C  16   Z2      Y2      Z1      Y1      X1      CSID 1  Z2      Y2
C  17   CSID 3  Z2      CSID 2  Z1      Y1      X1      CSID 3  Z2
C  18   X3      CSID 3  X2      CSID 2  Z1      Y1      X3      CSID 3
C  19   Y3      X3      Y2      X2      CSID 2  Z1      Y3      X3
C  20   Z3      Y3      Z2      Y2      X2      CSID 2  Z3      Y3
C  21   TEMP    Z3      CSID 3  Z2      Y2      X2      TEMP    Z3
C  22           CSID 4  X3      CSID 3  Z2      Y2              CSID 4
C  23           X4      Y3      X3      CSID 3  Z2              X4
C  24           Y4      Z3      Y3      X3      CSID 3          Y4
C  25           Z4      TEMP    Z3      Y3      X3              Z4
C  26           TEMP            CSID 4  Z3      Y3              TEMP
C  27                           X4      TEMP    Z3
C  28                           Y4              CSID 4
C  29                           Z4              X4
C  30                           TEMP            Y4
C  31                                           Z4
C  32                                           TEMP
C **********************************************************************
C
      REAL SAVE(32), T(1)
      COMMON /ZZZZZZ/ CORE(1)
      COMMON /TRIMEX/ ECPT(100)
      EQUIVALENCE (SAVE(1),ECPT(50))
C
C     THIS SUBROUTINE INCORPORATES TRIA1, QUAD1, TRIA2, QUAD2
C
C              NTYPE = 1  IMPLIES  TRIA1
C              NTYPE = 2  IMPLIES  TRIA2
C              NTYPE = 3  IMPLIES  QUAD1
C              NTYPE = 4  IMPLIES  QUAD2
C
C     CALLS FROM THIS ROUTINE ARE MADE TO THE FOLLOWING ELEMENT
C     THERMAL AND DEFORMATION LOADING ROUTINES.
C
C               TRMEM - TRIANGULAR MEMBRANE ROUTINE
C               QDMEM - QUADRILATERAL MEMBRANE ROUTINE
C               TRPLT - TRIANGULAR PLATE ROUTINE.
C               QDPLT - QUADRILATERAL PLATE ROUTINE.
C
C
C     THE SAVED ECPT IS EQUIVALENCED TO ECPT(50)
C
C     SAVE THE INCOMING ECPT
C
      DO 10 I=1,32
   10 SAVE(I) = ECPT(I)
C
C     TRANSFER TO ELEMENT TYPE DESIRED
C
      GO TO(20,70,100,150),NTYPE
C*****
C     ***  TRIA1 ***
C*****
C     SET UP ECPT FOR CALL TO  TRMEM(0), FIRST CHECK T1 FOR ZERO.
C
   20 IF( SAVE(7) .EQ. 0.0E0 ) GO TO 40
      DO 30 I=9,21
   30 ECPT(I) = SAVE(I + 6)
C
      CALL TRIMEM( 0, T(1), CORE(1) )
C
C     SET UP ECPT FOR CALL TO TRPLT, FIRST CHECK I AND T2 EQUAL ZERO.
C
   40 IF( SAVE(9) .EQ. 0.0E0 ) RETURN
      DO 50 I=1,5
   50 ECPT(I) = SAVE(I)
      DO 60 I=6,25
   60 ECPT(I) = SAVE(I + 2)
C
      CALL TRPLT( T(1) )
      RETURN
C*****
C     ***  TRIA2 ***
C*****
   70 IF( SAVE(7) .EQ. 0.0E0 ) RETURN
C
C     SET UP ECPT FOR CALL TO  TRMEM(0)
C
C     ECPT IS OK AS DELIVERED TO THIS ROUTINE
C
      CALL TRIMEM( 0, T(1), CORE(1) )
C
C     SET UP ECPT FOR CALL TO TRPLT
C
      DO 80 I=1,6
   80 ECPT(I) = SAVE(I)
      ECPT(7) = SAVE(7) ** 3  / 12.0E0
      ECPT(8) = SAVE(6)
      ECPT(9) = SAVE(7)
      ECPT(10)= SAVE(8)
      DO 90 I=13,25
   90 ECPT(I) = SAVE(I - 4)
C
      CALL TRPLT( T(1) )
      RETURN
C*****
C     ***  QUAD1 ***
C*****
  100 IF(SAVE(8).EQ.0.0E0)GO TO 120
C
C     SET UP ECPT FOR CALL TO  QDMEM
C
      ECPT(9) = SAVE(13)
      DO 110 I=10,26
  110 ECPT(I) = SAVE(I+6)
C
      CALL QDMEM( T(1), CORE(1) )
C
  120 IF( SAVE(10) .EQ. 0.0E0 ) RETURN
C
C     SET UP ECPT FOR CALL TO QDPLT
C
      DO 130 I=1,6
  130 ECPT(I) = SAVE(I)
      DO 140 I=7,30
  140 ECPT(I) = SAVE(I + 2)
C
      CALL QDPLT( T(1) )
      RETURN
C*****
C     ***  QUAD2 ***
C*****
  150 IF( SAVE(8) .EQ. 0.0E0 ) RETURN
C
C     SET UP ECPT FOR CALL TO  QDMEM
C
C     ECPT IS OK AS DELIVERED TO THIS ROUTINE
C
      CALL QDMEM( T(1), CORE(1) )
C
C     SET UP ECPT FOR CALL TO QDPLT
C
      DO 160 I=1,7
  160 ECPT(I) = SAVE(I)
      ECPT(8) = SAVE(8) **3 / 12.0E0
      ECPT(9) = SAVE(7)
      ECPT(10)= SAVE(8)
      ECPT(11)= SAVE(9)
      DO 170 I=14,30
  170 ECPT(I) = SAVE(I - 4)
C
      CALL QDPLT( T(1) )
C
      RETURN
      END

      SUBROUTINE XSORT2
C
C     XSORT2 REPLACES XSORT FOR SPEED AND EFFICIENCY
C
C     XSORT2 REQUIRES IFP MODULE TO USE RCARD2 ROUTINE INSTEAD OF
C     RCARD (DUE TO THE ASTERISK POSITION IN DOUBLE FIELD INPUT
C     CARD HAS NOT BEEN MOVED TO COLUMN 8)
C
C     XSORT2 READS BULKDATA CARDS FROM THE INPUT TAPE, ADJUSTS THE
C     FIELDS, PERFORMS AN ALPHA-NUMERIC SORT ON THE CARD IMAGES FROM
C     LEFT TO RIGHT, INSERTS CONTINUATION CARDS IN THEIR PROPER
C     POSITION, AND PLACES THE RESULTING SORTED IMAGES ON THE NEW
C     PROBLEM TAPE, NPTP.
C
C     THIS ROUTINE DOES NOT USE XRECPS, RPAGE, INITCO, XFADJ, XFADJ1,
C     XBCDBI, XPRETY, EXTINT, INTEXT, CRDFLG, ISFT, AND THE CHARACTER
C     FUNCTIONS KHRFNi.
C     IT CALLS ONLY SORT2K - TO SORT IN-CORE DATA USING TWO SORT KEYS
C              AND  BISLC2 - BINARY SEARCH USING TWO SORTED KEYS
C
C     XSORT2 NEW LOGIC -
C
C     1.  INPUT BULKDATA CARDS ARE READ INTO OPEN CORE, EXCEPT CONTINU-
C         ATION (* OR +), DELETE (/), COMMENT ($), AND BLANK CARDS.
C     2.  WHEN CORE IS FULL, OR LAST INPUT DATA READ, SORT DATA IN CORE
C         AND WRITE THE ENTIRE SORTED DATA TO SEQUENTIAL GINO FILE 303.
C     3.  REPEAT 1 AND 2, AND WRITE DATA TO GINO FILES 304,305,306 ETC.
C         IF NECESSARY. UP TO 30 FILES ARE ALLOWED.
C     4.  ALL CONTINUATION CARDS ARE WRITEN TO GINO FILE 302. ALL
C         DELETES TO 301. BLANK AND COMMENT CARDS ARE IGNORED.
C     5.  WHEN ALL INPUT DATA CARDS ARE READ AND SAVED IN GINO FILE(S),
C         RE-LOAD THE DELETE CARDS FROM 301 INTO OPEN CORE SPACE, AND
C         COPY OPTP TO 301 WITH DESIGNATED CARDS DELETED.
C     6.  COMPUTE BUFFER SPACE (AT THE END OF OPEN CORE) AND THE WORK
C         SPACE (AT THE BEGINNING OF OPEN CORE) NEEDED FOR FILE MERGE
C         OPERATION, AND READ INTO CORE ALL CONTINUATION CARDS USING
C         THE REMAINING CORE SPACE.
C     7.  IF CORE SPACE IS NOT BIG ENOUGH TO HOLD ALL CONTINUATION
C         CARDS, CREATE A CONTINUATION-INDEX TABLE IN CORE, AND MOVE THE
C         CONTINUATION CARDS TO A NEW GINO FILE, WITH LARGE BLOCKS OF
C         CONTINUATION CARDS
C     8.  PRE-MERGE BULKDATA GINO FILES TO SAVE BUFFER SPACE IF MORE
C         THAN 9 GINO FILES WERE USED IN STEP 3.
C         PERFORM A 2-TO-1 MERGE IF 10 TO 17 FILES WERE INVOLVED, OR
C         A 3-TO-1 MERGE IF MORE THAN 17 FILES WERE USED IN STEP 3.
C         THE MERGE FILES ARE SAVED IN 302,303,304,305 ETC.
C     9.  MERGE ALL FILES IN SORTED ORDER, AND INSERT CONTINUATION CARDS
C         WHEN NECESSARY. THE MERGED RESULTS ARE WRITTEN TO NPTP
C     10. ECHO ANY CONTINUATION CARD WHICH HAS NO PARENT AND THEREFORE
C         NOT USED. MAKE SURE NO REDUNDANT MESSAGE FOR THE 'REMAINING'
C         CONTINUATION CARDS OF ONE 'PARENT'
C
C     NOTES FOR XREAD AND FFREAD ROUTINES, WHICH HAVE DONE SOME
C     IMPORTANT PRELIMINARY TASK -
C
C      1. XSORT2 CALLS XREAD WHICH CALLS FFREAD TO READ ALL INPUT DATA,
C         IN BOTH FIXED-FIELD AND FREE-FIELD FORMATS. UNSORTED INPUT
C         DATA IS NOW PRINTED BY FFREAD IF 'ECHO=UNSORT' IS REQUESTED.
C      2. ALL 10 BULKDATA FIELDS ARE LEFT-ADJUSTED IF INPUT ARE IN
C         FREE-FIELD FORMAT. XREAD LEFT-ADJUSTED ALL FIELDS FOR THE
C         FIXED-FIELD INPUT CASE.
C      3. XREAD PRE-CHECK ANY CONTINUATION, COMMENT, DELETE, BLANK, AND
C         ENDDATA CARDS, AND SET APPROPRIATE FLAGS IN BUF4 CONTROL ARRAY
C      4. THE FIRST THREE BULKDATA FIELDS ARE CONVERTED TO INTERNAL
C         INTEGER CODES AND SAVED IN BUF4 CONTROL ARRAY. THESE INTERNAL
C         CODES ARE READY FOR SORTING.
C      5. XREAD HANDLES BOTH SINGLE-FIELD AND/OR DOUBLE-FIELD INPUT
C         AND PASS ON THE FIRST 3 BULKDATA FIELD INFORMATION INDENTI-
C         CALLY TO THE BUF4 CONTROL ARRAY.
C      6. XREAD/FFREAD COMPLETELY ELIMINATE THE REVERSE-STORAGE PROBLEM
C         OF THE VAX MACHINE.  I.E.
C         THE CONSTANT 'ABCD' IS STORED INTERNALLY AS 'DCBA' IN THE VAX
C      7. IN DOUBLE-FIELD INPUT, THE ASTERISK (*) IN FIELD 1 REMAINS
C         WHERE IT IS. (THE OLD XSORT MOVED IT TO COL. 8 THEN TO COL. 1.
C         SUBROUTINE RCARD MUST BE MODIFIED TO HANDLE THIS DOUBLE-FIELD
C         CASE)
C      8. NO LEADING BCD-ZEROS IN FIELD 2 IF THAT FIELD CONTAINS AN
C         INTEGER NUMBER, AND THE NUMBER IS NOT RIGHT ADJUSTED (I.E.
C         XSORT2 TREATS FIELD 2 INTEGER THE SAME WAY AS INTEGERS IN ALL
C         OTHER FILEDS, NAMELY LEFT ADJUSTED WITH TRAILING BLANKS
C      9. IF THE 1ST FIELD OF THE 2ND CARD IS BLANK, A UNIQUE CONTINUA-
C         TION SYMBOL IS INSERTED INTO THE 1ST FIELD, AND THE SAME
C         SYMBOL IS ADDED TO THE 10TH FIELD OF THE PREVIOUS CARD
C
C     SCRATCH FILE LIMITATION IN LINK1 -
C     SEMDBD ALLOCATES ONLY 15 SCRATCH FILES. SINCE XCSA AND XGPI USE
C     THE LAST SCRATCH FILE FOR RIGID FORMAT, XSORT2, PROGRAMMED UP TO
C     30 FILES, IS THEREFORE PHYSICALLY LIMITTED TO 14 SCRATCH FILES.
C
C     WRITTEN BY G.CHAN/UNISYS   10/1987
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        LSHIFT,RSHIFT,ANDF,ORF
      LOGICAL         ONLY1,DEBUG
      INTEGER         Y(25,1),BUF(50),IBUFX(10),ITAPE(10),TEMP(2),
     1                NAME(2),BULKDA(2),PARAM(2),CDCNT(3),KSMB(3),
     2                FUB(25)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25,HEAD4*28,HEAD(3)*56
      COMMON /XMSSG / UFM,UWM,UIM,SFM
      COMMON /MACHIN/ MACH,IJHALF(2),LQRO
      COMMON /XSORTX/ BUF4(4),TABLE(255)
      COMMON /SYSTEM/ BUFSZ,NOUT,NOGO,IN,DUM3(10),
     1                DATE(4),ECHO,DUM4,APPRC,DUM5(9),HICORE, DUM6(7),
     2                NBPC,NBPW,DUM7(28),SUBS,DUM8(12),CPFLG,DUM9(8),
     3                LPCH
      COMMON /OUTPUT/ DUM10(96),HEAD1(32),HEAD2(32),HEAD3(32)
CZZ   COMMON /ZZXST2/ Z(1)
      COMMON /ZZZZZZ/ Z(196605)
      COMMON /NAMES / RD,RDREW,WRT,WRTREW,REW,NOREW,EOFNRW
      COMMON /STAPID/ DUM11(12),KUMF
      COMMON /XECHOX/ FFFLAG,ECHOU,ECHOS,ECHOP,IXSORT,WASFF,NCARD,
     1                F3LONG,DUM12
      COMMON /IFPX0 / DUM13(2),IBITS(1)
      COMMON /IFPX1 / NUMX1,ICARDS(2)
      COMMON /TWO   / ITWO(32)
      EQUIVALENCE     (Y(1,1),Z(1)),      (BUF41,BUF4(1)),
     1                (IBUFX(1),BUF(26)), (ITAPE(1),BUF(38))
      DATA    HEAD  , HEAD4 /
     1       ' I N P U T   B U L K   D A T A   D E C K   E C H O      ',
     2       '     S O R T E D   B U L K    D A T A    E C H O        ',
     3       ' ---1--- +++2+++ ---3--- +++4+++ ---5--- +++6+++ ---7---',
     4       ' +++8+++ ---9--- +++10+++   '/    ,I25    /25            /
      DATA    NAME         ,CDCNT               ,OPTP   ,NPTP   ,BLANK /
     1        4HXSOR,4HT2  ,4HCARD,4HCOUN,4HT   ,4HOPTP ,4HNPTP ,4H    /
      DATA    TAPE1 ,TAPE2 ,TAPE3 ,MAXSCR,BULKDA        ,PARAM         /
     1        301   ,302   ,303   ,314   ,4HBULK,4HDATA ,4HPARA ,4HM   /
      DATA    KSMB  /4H+C0N,4H+CQN,4H+CON  /    ,DEBUG  /.FALSE.       /
C
C     DIAG 47 CAN BE RE-ACTIVATED FOR PROGRAM DEBUG CHECKING
C
C     CALL SSWTCH (47,J)
C     IF (J .EQ. 1) DEBUG = .TRUE.
C
C     TURN ON XSORT FLAG AND FREE-FIELD FLAG FOR XREAD AND FFREAD
C
      IXSORT = 1
      FFFLAG = 1234
C
C     CHECK UMF REQUEST
C
      IF (KUMF .LE.  0) GO TO 110
      WRITE  (NOUT,100) UFM
  100 FORMAT (A23,' - USER MASTER FILE, UMF, IS  NOT SUPPORTED BY NEW ',
     1        'XSORT ROUTINE', /5X,
     2        'ADD A ''DIAG 42'' CARD AND RESUBMIT YOUR NASTRAN JOB')
C 100 FORMAT (A23,' - USER MASTER FILE, UMF, IS NO LONGER SUPPORTED BY',
C    1        ' NASTRAN',/5X,'(NOTE - RELEASE 87 WAS THE LAST VERSION ',
C    2        'THAT SUPPORTED UMF OPERATION)')
      CALL MESAGE (-37,0,NAME)
C
C     INITIALIZE XSORT2
C
  110 ECHOU = 0
      ECHOS = 0
      ECHOP = 0
      NCARD = 0
      CMMT  = 0
      NCONT = 0
      NDELE = 0
      FULL  = 0
      EXH   = 0
      TAPECC= 0
      BSIZE = 3
      RESTR = 0
      CASE  = 1
      KONTN = 10010000
      KSMBI = KSMB(1)
      IF (APPRC .LT. 0) RESTR = 1
      IF (RESTR .EQ. 1) KSMBI = KHRFN3(KSMB(1),DATE(2),-2,0)
      J     = COMPLF(0)
      LARGE = RSHIFT(J,1   )
      LES1B = RSHIFT(J,NBPC)
      IF (MOD(LQRO,10) .EQ. 1) LES1B = LSHIFT(J,NBPC)
      IF (ECHO .LT. 0) GO TO 120
      ECHOU = ANDF(ECHO,1)
      ECHOS = ANDF(ECHO,2)
      ECHOP = ANDF(ECHO,4)
      IF (CPFLG .NE. 0) ECHOS = 1
C
C     SET UP UNSORTED HEADING
C
C     (UNSORTED INPUT DATA IS NOW PRINTED BY FFREAD ROUTINE BECAUSE
C      XREAD HAS BEEN MODIFIED TO RETURN ALL 10 DATA FIELDS LEFT-
C      ADJUSTED)
C
  120 DO 130 J = 1,32
      HEAD2(J) = BLANK
      HEAD3(J) = BLANK
  130 HEAD1(J) = BLANK
      IMHERE = 130
      IF (DEBUG) WRITE (NOUT,140) IMHERE,RESTR,APPRC,SUBS
  140 FORMAT (//,' *** XSORT2/IMHERE =',6I5)
      READ (HEAD(1),150) (HEAD1(J),J=11,24)
CWKBR 9/93 READ (HEAD(3),150) (HEAD3(J),J= 7,20)
      READ (HEAD(3),150) (HEAD3(J),J= 8,21)
CWKBR 9/93 READ (HEAD 4 ,150) (HEAD3(J),J=21,27)
      READ (HEAD 4 ,150) (HEAD3(J),J=22,28)
  150 FORMAT (14A4)
      IF (ECHOU .NE. 0) CALL PAGE
C
C     GET AVAILABLE CORE
C     IF IBM MACHINE, LIMIT AVAILABLE CORE SIZE TO 1,000,000 WORDS, SUCH
C     THAT DATA WILL BE SAVED IN PRIMARY FILES ONLY, AND NO SPILL INTO
C     SECONDARY FILES.
C
      NZZ   = KORSZ(Z)
      IBUF1 = NZZ   - BUFSZ
      IBUF2 = IBUF1 - BUFSZ
      IBUF3 = IBUF2 - BUFSZ
      NZ    = IBUF3 - 1
      IF (MACH  .EQ. 2) NZ = MIN0(NZ,1000000)
      IF (NZ .LT. 2500) CALL MESAGE (-8,2500,NAME)
      NZ25  = NZ/25
C
C     OPEN TAPE1, GINO FILE 301 FOR DELETE (SLASH) CARDS
C     AND  TAPE2, GINO FILE 302 FOR CONTINUATION CARDS
C     SET  TAPE TO TAPE3, GINO FILE 303, FOR BULKDATA CARDS
C     UP TO 30 FILES ARE ALLOWED FOR REGUALR BULKDATA CARDS
C     (CURRENTLY /XFIST/ IN SEMDBD IS SET UP ONLY TO SCRATCH FILE 315.
C     I.E. UP TO 13 (OR 12, IF DECK CONTAINS MANY CONTINUATION CARDS)
C     FILES CAN BE USED HERE)
C
      IMHERE = 170
      IF (DEBUG) WRITE (NOUT,140) IMHERE,NZ25
      CALL OPEN (*2900,TAPE1,Z(IBUF1),WRTREW)
      CALL OPEN (*2910,TAPE2,Z(IBUF2),WRTREW)
      TAPE = TAPE3 - 1
  170 TAPE = TAPE  + 1
      IF (TAPE .LE. 314) GO TO 180
      IF (DEBUG) WRITE (NOUT,2955)
      CALL MESAGE (-8,-NZZ,NAME)
  180 CALL OPEN (*2960,TAPE,Z(IBUF3),WRTREW)
      WRTTN = 0
C
C
C     START READING INPUT CARDS VIA XREAD/FFREAD.
C
C
C     ADDITIONAL INFORMATION FROM XREAD NOT MENTIONED PREVIOUSLY -
C
C      1. BUF4(1) = BUF4(2) =-1 INDICATE BULKDATA IS A COMMENT CARD
C         BUF4(1) = BUF4(2) =-2 INDICATE BULKDATA IS A CONTINUATION CARD
C         BUF4(1) = BUF4(2) =-3 INDICATE BULKDATA IS A DELETE CARD, WITH
C                   DELETE RANGE SAVED IN BUF4(3) AND BUF4(4)
C         BUF4(1) =-3 AND BUF4(4) =-4 IF TRASH WAS FOUND IN DELETE CARD.
C                   THAT IS, TRASH AFTER SLASH IN BULKDATA FIELD 1
C         BUF4(1) = BUF4(4) =-5 INDICATE A  BLANK   CARD WAS READ
C         BUF4(1) = BUF4(4) =-9 INDICATE AN ENDDATA CARD WAS READ
C      2. IF BULKDATA FIELD 2 IS AN INTEGER INPUT, THE CORRECT INTEGER
C                 VALUE IS SAVED IN BUF4(3)
C         IF BULKDATA FIELD 3 IS AN INTEGER INPUT, THE CORRECT INTEGER
C                 VALUE IS SAVED IN BUF4(4)
C      3. IF THE DATA IN FIELD 2 AND/OR 3 ARE F.P. NUMBER, THEIR INTEGER
C                 VALUES (NOT EXACT) ARE SAVED IN BUF4(3) AND/OR BUF4(4)
C                 THESE VALUES ARE USED ONLY FOR SORTING
C      4. IF BULKDATA FIELD 2 IS NOT NUMERIC, THE FIRST 6 CHARACTERS ARE
C                 CONVERTED TO INTERNAL INTEGER CODE AND SAVED IN BUF4(3
C         IF THE REMAINING 2 CHARACTERS ARE NOT BLANKS, THEY ARE SAVED
C                 IN BUF4(4)
C      5. IF BUF4(4) IS NOT USED BY 4, IT HOLDS THE INTERNAL CODE OR THE
C                 INTEGER VALUE FOR FIELD 3 OF THE ORIGINAL BULKDATA.
C
C     WORK SPACE -                                     NZ
C      1                                               /
C     ------------------------------------------------------------------
C     !                 OPEN CORE, Z                    !    !    !    !
C     ------------------------------------------------------------------
C     !<----------INPUT CARDS, 25 WORDS EACH----------->!<----GINO---->!
C                (20-WORD CARD IMAGE, 4 CONTRL               BUFFERS
C               CONTROL WORDS, 1 INDEX POINTER)
C
C
C     SUMMARY OF COUNTERS -
C
C     NCONT = TOTAL CONTINUATION CARDS COUNT, ON INPUT BULK DATA DECK
C             AND ON RESTART OPTP FILE
C     NDELE = TOTAL COUNT ON RESTART DELETE CARDS
C     CMMT  = TOTAL COUNT ON NON-ESSENTIAL CARDS (COMMENTS, BLANKS, AND
C             RESTART DELETE CARDS) OF INPUT BULK DATA DECK
C     KONTN = SYMBOL COUNTER FOR AUTO-CONTINUAION GENERATION
C     KOUNT = DELETE RANGE COUNTER, USED ONLY IN 800-820 AREA
C     NCARD = TOTAL INPUT BULK DATA CARDS COUNT, INCLUDING NON-ESSENTIAL
C             CARDS; CONTINUATION CARDS AND CARDS ON OPTP ARE EXCLUDED
C     COUNT = CURRENT CORE COUNT ON INPUT CARDS FROM BULK DATA DECK, ALL
C             NON-ESSENTIAL AND CONTINUATION CARDS ARE EXCLUDED
C     NBULK = NO. OF ACTIVE BULK DATA INPUT CARDS
C           = NCARD-CMMT = SUM OF ALL COUNT's
C     NOTE  - NO CARD COUNT ON THE OPTP FILE BEFORE ASSEMBLING NPTP FILE
C
      COUNT = 0
  200 IF (COUNT .LT. NZ25) GO TO (212,214,207,210,210,210), CASE
C                                   1,  2,  3,  4,  5,  6 = CASE
      CASE = 1
      IF (WASFF .LE. 0) GO TO 340
C
C     (200 THRU 215) SPECIAL HANDLING OF CONTINUATION CARD(S) WITH FIRST
C     FIELD BLANK DURING FREE-FIELD INPUT.   REGULAR CONTINUATION CARD
C     (FIRST FIELD NOT BLANK) OR FIXED-FIELD INPUT CARDS (BOTH PARENT
C     AND CHILD) ARE NOT CONSIDERED HERE.
C
C        EXAMPLE -     CBAR,10,20, 1 2 3  9)2
C                      ,,, .5 .5 .5
C
C     WE NEED TO CREATE A UNIQUE CONTINUATION SYMBOL FOR THE 1ST FIELD,
C     AND ADD THE SAME SYMBOL TO THE 10TH FIELD OF THE PREVIOUS CARD.
C     SET BUF41 FLAG TO -2.
C                                                                WAITING
C     AT THIS POINT,                                             CARD IN
C        CASE 1, NO CARD IS WAITING FOR PROCESSING               -------
C        CASE 2, CORE WAS FULL AND WAS EMPTIED OUT. A NON-           BUF
C                CONTINUATION CARD WAS READ AND AWAITS PROCESSING
C        CASE 3, CORE WAS FULL AND EMPTIED. A CONTINUATION CARD      BUF
C                WAS READ AND AWAITS PROCESSING.
C        CASE 4, CORE NOT FULL, A CONT.CARD WAS READ. THE NEXT CARD  FUB
C                IS NOT A CONT.CARD. THE CONT.CARD WAS PROCESSED,
C                AND THE NON-CONT. CARD  AWAITS PROCESSING.
C        CASE 5, CORE NOT FULL, A CONT.CARD WAS READ AND THE NEXT    FUB
C                CARD IS ALSO A CONT.CARD. THE FIRST CONT.CARD
C                WAS PROCESSED, AND THE SECOND CONT.CARD AWAITS
C                PROCESSING.
C        CASE 6, CONTINUE FROM PROCESSING CASES=4,5                  FUB
C
C ... CASES 2 AND 3 -
C     CORE IS FULL, READ ONE MORE CARD AND SEE THE NEW CARD IS A SPECIAL
C     CONTINUATION CARD OR NOT
C     IF IT IS, UPDATE THE 10TH FIELD OF THE PARENT CARD BEFORE
C     SENDING THE ENTIRE CORE FOR SORTING
C
      IMHERE = 202
  202 CALL XREAD (*208,BUF)
      IF (BUF41.EQ.-1 .OR. BUF41.EQ.-5) GO TO 202
      CASE = 2
      IF (BUF(1).NE.BLANK .OR. BUF(2).NE.BLANK) IF (BUF41+2) 340,203,340
  203 BUF41X = -2
      CASE = 3
      GO TO 205
C
C ... CASES 4 AND 5 -
C     CORE IS NOT FULL, A SPECIAL CONTINUATION CARD WAS JUST READ
C
  204 IF (WASFF .LE. 0) GO TO 214
      CASE  = 4
      BUF41 = -2
  205 KONTN = KONTN + 1
      IF (KONTN .EQ. 10020000) KSMBI = KSMB(2)
      IF (KONTN .EQ. 10030000) KSMBI = KSMB(3)
      IMHERE = 205
      IF (DEBUG) WRITE (NOUT,140) IMHERE,KONTN,COUNT,NZ25,CASE
      CALL INT2A8 (*3140,KONTN,BUF(1))
      BUF(1) = KSMBI
      IF (COUNT .LE. 0) GO TO 208
      Y(19,COUNT) = BUF(1)
      Y(20,COUNT) = BUF(2)
      IF (CASE-3) 340,340,207
C
  206 CASE = 6
      IF (BUF41 .EQ. -9) GO TO 350
C
  207 CALL XREAD (*207,FUB)
      IF (BUF41.EQ.-1 .OR. BUF41.EQ.-5) GO TO 207
      FUB41 = BUF41
      BUF41 = -2
      IF (FUB(1).NE.BLANK .OR. FUB(2).NE.BLANK) GO TO 215
      FUB41 = -2
      CASE  = 5
      KONTN = KONTN + 1
      IF (KONTN .EQ. 10020000) KSMBI = KSMB(2)
      IF (KONTN .EQ. 10030000) KSMBI = KSMB(3)
      IMHERE  = 207
      IF (DEBUG) WRITE (NOUT,140) IMHERE,KONTN,COUNT,NZ25,CASE
      CALL INT2A8 (*3140,KONTN,FUB(1))
      FUB(1)  = KSMBI
      BUF(19) = KSMBI
      BUF(20) = FUB(2)
      GO TO 217
C
  208 NOGO  = 1
      WRITE  (NOUT,209) SFM,IMHERE
  209 FORMAT (A25,'.  IMHERE =',I6)
      GO TO 214
C
  210 DO 211 I = 1,25
  211 BUF(I) = FUB(I)
      BUF41  = FUB41
      IF (CASE-5) 214,206,214
  212 CALL XREAD (*3120,BUF)
      IF (BUF(1).EQ.BLANK .AND. BUF(2).EQ.BLANK) GO TO 204
  214 CASE = 1
C
C     IGNORE COMMENT CARD (-1) OR BLANK CARD (-5)
C
  215 IF (BUF41.NE.-1 .AND. BUF41.NE.-5) GO TO 216
      CMMT = CMMT + 1
      GO TO 212
C
C     TEST FOR ENDDATA CARD (-9)
C
  216 IF (BUF41 .EQ. -9) GO TO 350
C
C     IF THIS IS A CONTINUATION CARD (-2), ADD ONE CONTROL WORD ABOUT
C     RESTART, AND WRITE IHE CARD OUT TO TAPE2
C     (THE CONTROL WORD WILL FLAG THE PARENT BIT TO BE SET FOR RESTART
C     WHEN THIS CONTINUATION CARD IS MERGED INTO NPTP)
C
      IF (BUF41 .NE. -2) GO TO 230
  217 BUF(21) = RESTR
      CALL WRITE (TAPE2,BUF(1),21,0)
      IF (DEBUG) WRITE (NOUT,220) BUF(1),BUF(2),BUF(21)
  220 FORMAT (5X,'A CONTINUATION CARD - ',2A4,',  CONT.FLAG=',I9)
      NCONT = NCONT + 1
      GO TO 200
C
C     IF THIS IS A DELETE CARD (-3), REJECT IT IF EXTRANEOUS DATA IN
C     FIELD 1 OTHERWISE WRITE THE RANGE OF DELETION ON TAPE1
C
  230 IF (BUF41 .NE. -3) GO TO 300
      CMMT = CMMT + 1
      IF (BUF4(4) .NE. -4) GO TO 250
      CALL PAGE2 (2)
      WRITE  (NOUT,240) UFM
  240 FORMAT (A23,' 221, EXTRANEOUS DATA IN FIELD 1 OF BULK DATA ',
     1       'DELETE CARD.')
      NOGO = -2
C
  250 IF (BUF4(3) .EQ. -3) GO TO 270
      IF (BUF4(4) .EQ. -3) BUF4(4) = BUF4(3)
      BUF4(3) = BUF4(3) - 2000000000
      BUF4(4) = BUF4(4) - 2000000000
      CALL WRITE (TAPE1,BUF4(3),2,0)
      IF (DEBUG) WRITE (NOUT,260) BUF4(3),BUF4(4)
  260 FORMAT (5X,'A DELETE CARD -',I11,1H,,I11)
      NDELE  = NDELE + 1
      GO TO 200
  270 WRITE  (NOUT,280) UFM
  280 FORMAT (A23,' 221, NO DATA IN FIELD 2 OF BULK DATA DELETE CARD')
      NOGO = -1
      GO TO 200
C
C     REGULAR BULKDATA CARDS.
C     SAVE 20 WORDS OF BUF, 4 WORDS FROM BUF4 AND CORE COUNTER IN OPEN
C     CORE SPACE Y (25 WORDS TOTAL)
C     SET RESTART BITS IF THIS IS A RESTART RUN
C     RETURN TO READ NEXT BULKDATA CARD
C
  300 COUNT = COUNT + 1
      WRTTN = 1
      DO 310 I = 1,20
  310 Y(I,COUNT) = BUF(I)
      DO 320 I = 1,4
  320 Y(I+20,COUNT) = BUF4(I)
      Y(25  ,COUNT) = COUNT
      IF (DEBUG) WRITE (NOUT,330) COUNT,Y(1,COUNT),Y(2,COUNT)
  330 FORMAT (5X,'SAVED IN CORE   COUNT=',I5,3X,2A4)
      IF (RESTR .EQ. 0) GO TO 200
      ASSIGN 200 TO CRDFLG
      FROM = 330
      GO TO 2800
C
C     OPEN CORE BUFFER FULL, ENDDATA CARD HAS NOT BEEN ENCOUNTERED
C
  340 FULL = 1
      GO TO 400
C
C     ENDDATA CARD FOUND, SET FLAG
C
  350 FULL  = -1
      IMHERE= 350
      NCARD = NCARD - 1
      NBULK = NCARD - CMMT
      IF (DEBUG) WRITE (NOUT,140) IMHERE,NCARD,NCONT,NDELE
      CALL PAGE2 (2)
      IF (ECHOU .NE. 1) GO TO 370
      WRITE  (NOUT,360) NCARD
  360 FORMAT (//24X,'TOTAL COUNT=',I7)
      GO TO 400
  370 WRITE  (NOUT,380) NCARD,CMMT
  380 FORMAT (//24X,'(NO. OF UNSORTED BULK DATA CARDS READ =',I6,
     1       ', INCLUDING',I4,' COMMENT CARDS)')
C
C     SORT CARD IMAGES SAVED IN THE OPEN CORE SPACE BY MODIFIED SHELL
C     METHOD.
C     SORT BY 21ST, 22ND, 23RD, AND 24TH CONTROL WORDS ONLY
C     ONLY THE LAST 5 WORDS (21ST THRU 25TH) ARE MOVED INTO SORTED
C     ORDER, THE FIRST 20 WORDS REMAIN STATIONARY.
C
  400 IF (WRTTN .EQ.    0) GO TO 580
      IF (COUNT .GT. NZ25) CALL MESAGE (-37,0,NAME)
      M  = COUNT
      IMHERE = 400
      IF (DEBUG) WRITE (NOUT,140) IMHERE,COUNT
  410 M  = M/2
      IF (M .EQ. 0) GO TO 500
      J  = 1
      K  = COUNT - M
  420 I  = J
  430 N  = I + M
      IF (Y(21,I) - Y(21,N)) 490,440,470
  440 IF (Y(22,I) - Y(22,N)) 490,450,470
  450 IF (Y(23,I) - Y(23,N)) 490,460,470
  460 IF (Y(24,I) - Y(24,N)) 490,490,470
  470 DO 480 L = 21,25
      TEMPX  = Y(L,I)
      Y(L,I) = Y(L,N)
  480 Y(L,N) = TEMPX
      I = I - M
      IF (I .GE. 1) GO TO 430
  490 J = J + 1
      IF (J-K) 420,420,410
C
C     END OF CORE SORT.
C     WRITE THE SORTED BULKDATA CARDS TO FILE, 24 WORDS EACH RECORD
C     IN ORDER GIVEN BY THE 25TH WORD.
C     IF ONLY ONE SCRATCH FILE (TAPE3) IS USED IN RECEIVING BULKDATA,
C     CHECK ANY DUPLICATE CARD.
C
  500 IMHERE = 500
      IF (DEBUG) WRITE (NOUT,140) IMHERE,COUNT,MAXC
      ONLY1 = .FALSE.
      IF (FULL.EQ.-1 .AND. TAPE.EQ.TAPE3) ONLY1=.TRUE.
      BASE = 25
      DO 570 I = 1,COUNT
      IF (ONLY1) BASE = MOD(I,2)*25
      J = Y(25,I)
      DO 510 K = 1,20
  510 BUF(K+BASE) = Y(K,J)
      DO 520 K = 21,24
  520 BUF(K+BASE) = Y(K,I)
      IF (.NOT.ONLY1) GO TO 550
      IF (I  .EQ.  1) GO TO 540
      DO 530 K = 1,20
      IF (BUF(K+BASE) .NE. BUF(K+OBASE)) GO TO 540
  530 CONTINUE
      BUF(21+BASE) = -6
      BUF(22+BASE) = -6
  540 OBASE = BASE
  550 CALL WRITE (TAPE,BUF(BASE+1),24,0)
      IF (DEBUG) WRITE (NOUT,560) TAPE,(BUF(K+BASE),K=1,8)
     1                                ,(BUF(K+BASE),K=21,24)
  560 FORMAT (5X,'WRITE TO ',I3,4(2X,2A4), /9X,'INT.CODE=',4I12)
  570 CONTINUE
      CALL WRITE (TAPE,0,0,1)
  580 CALL CLOSE (TAPE,REW)
      IMHERE = 580
      IF (DEBUG) WRITE (NOUT,140) IMHERE
C
C     REPEAT READING BULKDATA CARDS INTO CORE IF NECESSARY
C
C     IF NO DATA WRITTEN TO CURRENT FILE (e.g. UN-MODIFIED RESTART),
C     REDUCE TAPE COUNT BY ONE
C
      IF (FULL .NE. -1) GO TO 170
      IF (WRTTN .EQ. 0) TAPE = TAPE - 1
C
C     CLOSE DELETE CARD FILE, TAPE 1.
C     CONTINUATION CARD FILE, TAPE 2, IS STILL IN USE
C
      CALL WRITE (TAPE1,0,0,1)
      CALL CLOSE (TAPE1,REW  )
C
C     TEST FOR COLD-START WITH NO BULKDATA
C
C     APPRC = APPROACH FLAG (1 DMAP, 2 DISP, 3 HEAT, 4 AERO)
C     SUBS  = SUBSTRUCTURING FLAG
C
      IMHERE = 585
      IF (DEBUG) WRITE (NOUT,140) IMHERE,COUNT,APPRC,WRTTN,RESTR,SUBS
      IF (WRTTN.EQ.1 .OR. RESTR.EQ.1 .OR. SUBS.NE.0) GO TO 600
      CALL CLOSE (TAPE2,REW)
      ECHOS = 1
      IF (APPRC .EQ. 1) GO TO 1600
      CALL PAGE2 (2)
      WRITE  (NOUT,590) UFM
  590 FORMAT (A23,' 204, COLD START NO BULK DATA.')
      NOGO = -2
      GO TO 3200
C
C     IF MODIFIED RESTART - TURN ON SORT ECHO FLAG IF ECHO IS NOT 'NONO'
C     IF NOT A RESTART JOB - JUMP TO 1000
C
  600 IF (NBULK.GT.1 .AND. RESTR.EQ.1) ECHOS = 1
C     IF (APPRC.EQ.1 .OR.  SUBS .NE.0) ECHOS = 1
      IF (ECHO  .EQ. -2) ECHOS = 0
      IF (RESTR .EQ.  0) GO TO 1000
C
C     THIS IS A RESTART JOB, PROCESS OPTP FILE -
C
C     OPEN OPTP AND LOCATE WHERE BULK DATA BEGINS
C
      IMHERE = 610
      IF (DEBUG) WRITE (NOUT,140) IMHERE
      CALL OPEN (*3080,OPTP,Z(IBUF3),RDREW)
  610 CALL SKPFIL (OPTP,+1)
      CALL READ (*3040,*3040,OPTP,BUF(1),2,1,J)
      IF (BUF(1).NE.BULKDA(1) .OR. BUF(2).NE.BULKDA(2)) GO TO 610
      IF (NBULK.GT.0 .OR. NDELE.NE. 0) GO TO 640
C
C     UN-MODIFIED RESTART, WITH NO NEW BULKDATA CARD AND NO DELETE -
C     SETUP SORTED HEADER FOR OLD BULK DATA CARDS IF ECHO FLAG IS ON,
C     COPY THE REST OF OPTP DIRECTLY TO NPTP, AND JOB DONE
C
C
      IMHERE = 620
      IF (DEBUG) WRITE (NOUT,140) IMHERE
      CALL OPEN  (*3100,NPTP,Z(IBUF1),WRT)
      CALL WRITE (NPTP,BULKDA,2,1)
      NCARD = 0
      IF (ECHOS .EQ. 0) GO TO 620
      READ (HEAD(2),150) (HEAD1(J),J=11,24)
CWKBR 9/93 HEAD2(4) = CDCNT(1)
      HEAD2(5) = CDCNT(1)
CWKBR 9/93 HEAD3(4) = CDCNT(2)
      HEAD3(5) = CDCNT(2)
CWKBR 9/93 HEAD3(5) = CDCNT(3)
      HEAD3(6) = CDCNT(3)
      CALL PAGE
  620 CALL READ  (*630,*630,OPTP,BUF(1),20,1,J)
      CALL WRITE (NPTP,BUF(1),20,1)
      NCARD = NCARD + 1
      IF (ECHOP .NE. 0) WRITE (LPCH,1750) (BUF(J),J=1,20)
      IF (ECHOS .EQ. 0) GO TO 620
      CALL PAGE2 (-1)
      WRITE (NOUT,1730) NCARD,(BUF(J),J=1,20)
      GO TO 620
  630 CALL EOF   (NPTP)
      CALL CLOSE (NPTP,  REW)
      CALL CLOSE (OPTP,NOREW)
      CALL CLOSE (TAPE2, REW)
      IF (ECHOP .NE. 0) WRITE (LPCH,2320)
      CALL PAGE2 (-1)
      IF (ECHOS .NE. 0) WRITE (NOUT,2300)
      IF (ECHOS .EQ. 0) WRITE (NOUT, 635) UIM,NCARD
  635 FORMAT (A29,1H,,I8,' SORTED BULKD DATA CARDS PROCESSED FROM OPTP',
     1        ' FILE TO NPTP, UN-MODIFIED')
      GO TO 2700
C
C     MODIFIED RESTART WITH NEW BULKDATA CARDS, WITH OR WITHOUT DELETE
C
  640 IMHERE = 640
      IF (DEBUG) WRITE (NOUT,140) IMHERE
      IC   = 1
      LEFT = NZ
      IF (NDELE .EQ. 0) GO TO 710
      IF (RESTR .EQ. 1) GO TO 660
      CALL PAGE2 (-1)
      WRITE  (NOUT,650) UWM
  650 FORMAT (A25,' 205, COLD START, DELETE CARDS IGNORED.')
      GO TO 710
C
C     RESTART WITH DELETE CARD(S) -
C     MOVE THE DELETE CARDS  INTO CORE AND FREE TAPE1.
C     SORT THE DELETE CARDS, CHECK FOR AND ELIMINATE OVERLAPS AND
C     REDUNDANCIES
C
  660 CALL OPEN (*2900,TAPE1,Z(IBUF1),RDREW)
      CALL READ (*2900,*670,TAPE1,Z(1),LEFT,1,LEN)
      CALL MESAGE (-8,TAPE1,NAME)
  670 CALL CLOSE  (TAPE1,REW    )
C
      CALL SORT (0,0,2,1,Z(1),LEN)
      Z(LEN+1) = LARGE
      DO 680 I = 2,LEN,2
      Z(I) = Z(I)+1
      IF (Z(I) .LT. Z(I-1)) Z(I) = Z(I-1)
      IF (Z(I) .LT. Z(I+1)) GO TO 680
      Z(I  ) = -1
      Z(I+1) = -1
  680 CONTINUE
      J = 0
      DO 690 I = 1,LEN
      IF (Z(I) .LT. 0) GO TO 690
      J = J + 1
      Z(J) = Z(I)
  690 CONTINUE
      IF (J .GT. 0) LEN = J
      LEFT = NZ - LEN
      IC   = LEN + 1
      Z(IC)  = LARGE
      IMHERE = 700
      IF (DEBUG) WRITE (NOUT,700) IMHERE,(Z(I),I=1,LEN)
  700 FORMAT (/,' *** IMHERE =',I5,(/,3X,10(I7,I5)))
      IF (MOD(LEN,2) .NE. 0) GO TO 3140
      GO TO 800
C
C     IF MODIFIED RESTART WITH NO DELETE, SET DELETE RANGE BEGINNING AT
C     INFINITY
C
  710 Z(1)   = LARGE
      IMHERE = 710
      IF (DEBUG) WRITE (NOUT,140) IMHERE
C
C     WE ARE STILL IN PROCESSING RESTART - COPY OPTP TO TAPE1, SKIP
C     APPROPRIATE RECORDS AS SPECIFIED BY THE DELETE CARDS NOW IN
C     OPEN CORE, Z(1) THRU Z(LEN)
C
C     SEND A CARD FROM OPTP TO YREAD (AN ENTRY POINT IN XREAD) FOR
C     RE-PROCESSING. UPON RETURN FROM YREAD, BUF4 ARRAY HOLDS THE
C     INTERNAL INTEGER CODE GOOD FOR SORTING AND OTHER FUNCTIONS.
C
C     IF IT IS A CONTINUATION CARD, COPY THE FULL CARD (20 WORDS)
C     AND ONE CONTROL WORD TO TAPE2.
C     OTHERWISE COPY 24 WORDS (20-BUF AND 4-BUF4) TO TAPE1.
C
C     IF A CONTINUATION CARD IS DELETED, THE RESTART BITS OF THE
C     PARENT CARD SHOULD BE FLAGGED
C
  800 IMHERE  = 800
      IF (DEBUG) WRITE (NOUT,140) IMHERE,RESTR,TAPE1
      CALL OPEN (*2900,TAPE1,Z(IBUF1),WRTREW)
      KOUNT   = 0
      POINT   = 1
      ONOFF   = 1
      ZPOINT  = Z(POINT)
      BUF(19) = 0
  810 TEMP(1) = BUF(19)
      TEMP(2) = BUF(20)
      CALL READ (*900,*900,OPTP,BUF(1),20,1,J)
      KOUNT   = KOUNT + 1
      IF (KOUNT .LT. ZPOINT) GO TO 820
      POINT   = POINT + 1
      ZPOINT  = Z(POINT)
      ONOFF   = ONOFF*(-1)
  820 CALL YREAD (*3060,BUF)
      IMHERE  = 830
      IF (DEBUG .AND. ONOFF.EQ.-1) WRITE (NOUT,830) IMHERE,KOUNT,
     1                             (BUF(J),J=1,6)
  830 FORMAT (' IMHERE=',I5,'.  DELETED FROM OPTP ==>',I5,2H- ,6A4)
      IF (BUF41 .EQ. -2) GO TO 870
      IF (ONOFF .EQ. +1) GO TO 840
C
C     ANY DELETED CARD, EXCEPT CONTINUATION CARD, MUST RESET
C     RESTART CARD FLAG
C
      ASSIGN 810 TO CRDFLG
      FROM = 830
      GO TO 2800
C
C     REGULAR BULKDATA CARD FROM OPTP -
C     SAVE FIRST FIELD IN KARD1/2 JUST IN CASE THIS IS A PARENT OF
C     A CONTINUATION CARD WHICH FALLS INSIDE A DELETE RANGE.
C
C     NOTE- CARDS FROM OPTP ARE IN SORTED ORDER, AND NO CARD COUNT HERE
C
  840 DO 850 J = 1,4
  850 BUF(J+20) = BUF4(J)
      CALL WRITE (TAPE1,BUF(1),24,0)
      IF (DEBUG) WRITE (NOUT,860) (BUF(J),J=1,6),BUF(21)
  860 FORMAT (' IMHERE=860, OPTP==>TAPE1  ',6A4,'==>',I9)
      KARD1 = BUF(1)
      KARD2 = BUF(2)
      IF (KARD1.NE.PARAM(1) .OR. KARD2.NE.PARAM(2)) GO TO 810
      KARD1 = BUF(3)
      KARD2 = BUF(4)
      GO TO 810
C
C     CONTINUATION CARD FROM OPTP -
C
C     IF BOTH PARENT AND THIS CONTINUATION CARD IN NOT IN DELETE RANGE
C     SEND THIS CONTINUATION CARD TO TAPE2 WITH RESTART CONTROL WORD
C     SET TO ZERO.
C     IF PARENT IS NOT DELETED, BUT THIS CONTINUATION CARD IS, WE NEED
C     TO FLAG PARENT
C     IF PARENT IS ALSO IN DELETE RANGE, SKIP THIS CONTINUATION CARD.
C
  870 IF (ONOFF .EQ. +1) GO TO 890
      IF (KARD1 .EQ. -1) GO TO 810
      IF (BUF(1).EQ.TEMP(1) .AND. BUF(2).EQ. TEMP(2)) GO TO 810
      FROM  = 860
      ASSIGN 880 TO CRDFLG
      GO TO 2810
  880 KARD1 = -1
      GO TO 810
  890 BUF(21) = 0
      CALL WRITE (TAPE2,BUF(1),21,0)
      NCONT = NCONT + 1
      GO TO 810
C
C     OPTP IS SUCCESSFULLY MOVED TO TAPT1 AND TAPE2. CLOSE FILES
C
  900 CALL CLOSE (OPTP ,NOREW)
      CALL WRITE (TAPE1,0,0,1)
      CALL WRITE (TAPE2,0,0,1)
      CALL CLOSE (TAPE1,REW  )
C
C     PREPARE FOR FILE MERGE -
C
C     SELECT METHOD USED TO BRING CONTINUATION CARDS INTO CORE AND
C     COMPUTE NUMBER OF BUFFERS NEEDED FOR FILE PRE-MERGE.
C
C     METHOD 1 - NO FILE PRE-MERGE IF THERE IS NO CONINUATION CARDS, OR
C                ENOUGH SPACE IN CORE TO HOLD ALL CONTINUATION CARDS,
C                BUFFERS AND SCRATCH ARRAYS FOR ALL SCRATCH DATA FILES
C     METHOD 2 - ALL CONTINUATION CARDS, IN 3-WORD TABLE AND 20-WORD
C                CARD IMAGES, AND ALL GINO BUFFERS, OR REDUCED GINO
C                BUFFERS, FIT INTO CORE
C     METHOD 3 - CONTINUATION 3-WORD TABLE AND ALL GINO BUFFERS, OR
C                REDUCED GINO BUFFERS, FIT INTO CORE
C     METHOD 4 - FATAL, INSUFFICIENT CORE
C
 1000 CALL CLOSE (TAPE2,REW)
      METHOD = 1
      N23    = 1
      NFILES = TAPE - TAPE3 + 1
      REDUCE = 1
      IF (NFILES .GE. 10) REDUCE = 2
      IF (NFILES .GT. 17) REDUCE = 3
      J      = 0
      IF (RESTR .EQ. 1) J = 1
      MAXC   = (NZZ-(BUFSZ+25)*(NFILES+J))/21
      IF (NCONT .LE. MAXC) REDUCE = 1
      NFILER = (NFILES+REDUCE-1)/REDUCE + J
      IMHERE = 1010
      IF (DEBUG) WRITE (NOUT,140) IMHERE,REDUCE,NFILES,NFILER
      IF (NCONT) 1020,1100,1020
 1010 SIZE   = (NFILER+1)*BUFSZ + NFILER*25
      SIZE   = SIZE + BUFSZ
      LEFT   = NZZ - SIZE
      MAXC   = LEFT/N23
      IMHERE = 1020
      IF (DEBUG) WRITE (NOUT,140) IMHERE,METHOD,NFILES,NFILER,N23,NCONT
      IF (NCONT .LE. MAXC) GO TO 1100
      GO TO (1020,1030,1040), METHOD
 1020 METHOD = 2
      N23    = 23
      GO TO 1010
 1030 METHOD = 3
      N23    = 3
      GO TO 1010
C
C     INSUFFICIENT CORE, COMPUTE HOW MUCH MORE NEEDED
C
 1040 J = NCONT*N23 - LEFT
      CALL MESAGE (-8,J,NAME)
C
C     ALLOCATE BUFFER SPACE AND REDEFINE AVAILABLE CORE SPACE, NZ
C     ALLOCATE SPACES AT THE BEGINNING OF CORE SPACE FOR BULKDATA
C     TO BE BROUGHT BACK FROM VARIOUS FILES.
C
C     IC     = POINTER, WHERE CONTINUATION TABLE BEGINS
C     IB     = POINTER, WHERE CONTINUATION  DATA BEGINS
C     NFILES = TOTAL NUMBER OF FILES USED BEFORE FILE REDUCTION,
C              RESTART TAPE1 NOT INCLUDED
C     NFILER = REDUCED NUMBER OF FILES THAT HOLD BULKDATA INPUT CARDS,
C              RESTART TAPE1 INCLUDED
C     TAPECC = AN ADDITIONAL FILE USED ONLY IN METHOD 3 (NOT INCLUDED
C              IN NFILES AND NFILER)
C
 1100 IMHERE = 1100
      IF (DEBUG .OR. NFILES.GT.10 .OR. NCONT.GT.1000)
     1    WRITE (NOUT,1110) UIM,METHOD,NFILER,HICORE,NCONT
 1110 FORMAT (A29,' FROM XSORT -  METHOD',I3,' WAS SELECTED TO PROCESS',
     1        ' CONTINUATION CARDS', /5X,'NO. OF FILES USED =',I4,4X,
     2        'HICORE =',I7,' WORDS', 4X,'NO. OF CONT. CARDS =',I7)
      NZ   = IBUF1
      DO 1120 I = 1,NFILER
      NZ   = NZ - BUFSZ
 1120 IBUFX(I) = NZ
      IF (NCONT .GT. 0) NZ = NZ - BUFSZ
      IBUFC= NZ
      NZ   = NZ - 1
      IC   = NFILER*25 + 1
      IB   = IC + NCONT*3
      NZIB = NZ - IB + 1
      LEFT = NZ - IC + 1
C
C     NEED A STORAGE SPACE FOR AT LEASE 100 CONTINUATION CARDS
C
      IF (NZIB .LT. 2100) CALL MESAGE (-8,-2100+NZIB,NAME)
C
C     METHOD 1, NO CONTINUATION CARD IN BULKDATA, SKIP TO 1280
C
      IF (METHOD .EQ. 1) GO TO 1280
C
C     WORKING SPACE FOR THE CONTINUATION TABLE AND CONTINUATION CARD
C     IMAGES -
C
C                  IC                 IB                   NZ
C                  /                  /                    /
C     ------------------------------------------------------------------
C     ! ! ! !..Y..!                  !                     !  !  !  !  !
C     ------------------------------------------------------------------
C     ! SPACE FOR !<--CONTINUATION-->!<--AVAILABLE SPACE-->!<--GINO--->!
C       DATA FROM     INDEX TABLE        FOR CONTINUATION     BUFFERS
C       FILES 303,   (3 WORDS EACH)      CARD IMAGES
C       304,...                          (21 WORDS EACH)
C       FOR FILE      (PART 1 AERA)
C       MERGE                            (PART 2 AREA)
C
      IMHERE = 1125
      IF (DEBUG) WRITE (NOUT,140) IMHERE,METHOD,N23
      CALL OPEN (*2910,TAPE2,Z(IBUF2),RDREW)
      IF (METHOD .EQ. 3) GO TO 1200
C
C     METHOD 2 -
C
C     OPEN CORE IS DIVIDED INTO 2 PARTS - A 3-WORD CONTINUATION TABLE
C     IN PART 1, AND 21-WORD CONTINUATION CARD IMAGES IN PART 2.
C
C     3-WORD TABLE IN PART 1 HOLDS THE 2-BCD CONTIUATION SYMBOLS, WITH
C     THE FIRST BYTE (A + OR *) ZERO OUT, AND AN INDEX POINTER. THIS
C     TABLE WILL BE SORTED, AND WILL BE USED BY BISLC2 TO LOCATE THE
C     CARD IMAGES SAVED EITHER IN PART 2, OR IN TAPECC FILE.
C
      IMHERE = 1130
      IF (DEBUG) WRITE (NOUT,140) IMHERE,METHOD,NCONT,IC,IB
      CALL READ (*3000,*1130,TAPE2,Z(IB),NZIB,1,LEN)
      CALL MESAGE (-8,0,NAME)
 1130 K = LEN + IB - 1
      I = IC
      DO 1140 J = IB,K,21
      Z(I  ) = ANDF(Z(J),LES1B)
      Z(I+1) = Z(J+1)
      Z(I+2) = J
 1140 I = I + 3
      GO TO 1270
C
C     METHOD 3 -
C
C     COMPUTE NCCI (NO. OF CONTINUATION CARD IMAGES) THAT PART 2 AREA
C     (FROM Z(IB) THRU Z(NZ)) CAN HOLD AT A GIVEN TIME.
C     CREATE IN CORE A CONTINUATION TABLE WITH INDEX POINTERS (SAME
C     AS METHOD 2) IN PART 1 AREA.
C     FILL THE REMAINING PART 2 AREA WITH NCCI CARDS, AND WRITE THIS
C     BLOCK OF CARDS OUT TO A NEW SCRATCH FILE, TAPECC. REPEAT THIS
C     PROCESS FOR THE REST OF THE CONTINUATION CARDS.
C     THE INDEX POINTERS IN PART 1 (METHOD 3 ONLY) ALSO INCLUDE THE
C     DATA BLOCK NUMBER INFORMATION
C
 1200 NCCI = NZIB/21
      IF (NCCI .GE. 10000000) NCCI = 10000000 - 1
      NZIB   = NCCI*21
      TAPECC = NFILES + TAPE3
      IMHERE = 1200
      IF (DEBUG) WRITE (NOUT,140) IMHERE,METHOD,TAPECC,NCCI
      IF (TAPECC .GT. MAXSCR) GO TO 2951
      CALL OPEN (*2950,TAPECC,Z(IBUFC),WRTREW)
      BK  = 0
      I   = IC
      IF (NCCI.GE.750 .OR. MACH.LE.2 .OR. NBPW.EQ.64) GO TO 1220
      J   = ((NCONT*23 - NZ+IC +999)/1000)*1000
      WRITE  (NOUT,1210) UIM,J,HICORE
 1210 FORMAT (A29,', DUE TO UNUSUAL LARGE NUMBER OF CONTINUATION CARDS',
     1       ' PRESENT IN THE BULKDATA DECK', /5X,'AN ADDITION OF',I7,
     2       ' WORDS TO OPEN CORE SPACE COULD MAKE LINK1 MORE EFFICIENT'
     3,      /5X,'CURRENTLY NASTRAN HICORE IS',I7,' WORDS')
      IF (NCCI .LT. 100) NOGO = -3
 1220 BK  = BK + 10000000
      J   = IB
      TOP = NZIB
      CALL READ (*1260,*1230,TAPE2,Z(IB),TOP,0,LEN)
      GO TO 1240
 1230 TOP = LEN
 1240 TOP = TOP + IB - 1
 1250 Z(I  ) = ANDF(Z(J),LES1B)
      Z(I+1) = Z(J+1)
      Z(I+2) = J + BK
      I   = I + 3
      J   = J + 21
      IF (J .LT. TOP) GO TO 1250
      CALL WRITE (TAPECC,Z(IB),NZIB,1)
      GO TO 1220
 1260 CALL CLOSE (TAPECC,REW)
 1270 CALL CLOSE (TAPE2 ,REW)
      LEN = I - IC
      IF (LEN .GT. 3) CALL SORT2K (0,0,3,1,Z(IC),LEN)
C
C     NO PRE-MERGING FILES IF REDUCE IS 1 (I.E. LESS THAN 10 SCRATCH
C     FILES WERE USED TO HOLD THE RAW BULKDATA, OR ENOUGH CORE TO HOLD
C     EVERYTHING)
C
 1280 IF (REDUCE .EQ. 1) GO TO 1600
C
C     PRE-MERGE
C     =========
C
C     AT THIS POINT, CONTINUATION CARD IMAGES ARE EITHER IN CORE OR IN
C     SCRATCH FILE TAPECC, AND TAPE2 IS FREE FOR RE-USE.
C     ALL GINO BUFFERS ARE FREE
C
C     IF TOO MANY FILES WERE USED TO SAVE BULKDATA, MERGE THEM TO REDUCE
C     THE TOTAL NUMBER OF FILES GOING TO BE USED (I.E. TO REDUCE BUFFER
C     SPACE IN THE MERGE PHASE COMING NEXT)
C
C     PERFORM A 2-TO-1 MERGE IF NUMBER OF FILES PRESENTLY IS 10-17.
C
C     FILEB + FILEC == FILEA      E.G.  303 + 304 == 302
C                                       305 + 306 == 303
C                                       307 + 308 == 304  ETC.
C     OR
C     PERFORM A 3-TO-1 MERGE IF NUMBER OF FILES PRESENTLY IS 18-30.
C
C     FILEB+FILEC+FILED == FILEA  E.G.  303+304+305==302
C                                       306+307+308==303
C                                       309+310+311==304  ETC.
C
C     NOTE - 301 IS EITHER NOT USED, OR USED BY THE 'MODIFIED' OPTP
C
      IMHERE = 1290
      IF (DEBUG) WRITE (NOUT,140) IMHERE,NFILES,NFILER,REDUCE
      FILEA  = 301
      FILE   = 302 - REDUCE
C
      DO 1580 III = 1,NFILES,REDUCE
      FILE = FILE+REDUCE
C
C ... CHECK LAST DO-LOOP CONDITION
C     IF ONE   FILE  LEFT, QUIT MERGING
C     IF TWO   FILES LEFT, DO A 2-TO-1 MERGE
C     IF THREE FILES LEFT, CONTINUE
C
      IF (NFILES-III .LE. 0) GO TO 1420
C
      FILEA = FILEA + 1
      CALL OPEN (*2930,FILEA,Z(IBUF1),WRTREW)
      IMHERE= 1300
      EXH   = 0
      DO 1300 L = 1,REDUCE
      FILEX = FILE + L
      IBUFL = IBUFX(L)
      ITAPE(L) = 1
      IF (DEBUG) WRITE (NOUT,140) IMHERE,FILEX,J
      CALL OPEN (*2940,FILEX,Z(IBUFL),RDREW)
      CALL READ (*3000,*2980,FILEX,Y(1,L),24,0,I)
 1300 CONTINUE
C
C     PICK THE SMALLEST CONTROL WORDS FROM Y(21,22,23,24 OF A,B,C)
C
 1310 II = 1
      DO 1380 L = 2,REDUCE
      IF (Y(21,L) - Y(21,II)) 1370,1320,1380
 1320 IF (Y(21,L) .EQ. LARGE) GO TO 1380
      IF (Y(22,L) - Y(22,II)) 1370,1330,1380
 1330 IF (Y(23,L) - Y(23,II)) 1370,1340,1380
 1340 IF (Y(24,L) - Y(24,II)) 1370,1350,1380
C
C     FIRST 3 BULKDATA FIELDS THE SAME, CHECK POSSIBLE DUPLICATE CARD
C     SET 21ST AND 22ND CONTROL WORDS TO -6 IF IT IS A DUPLICATE
C
 1350 DO 1360 J = 7,20
      IF (Y(J,L) .NE. Y(J,II)) GO TO 1380
 1360 CONTINUE
      Y(21,II) = -6
      Y(22,II) = -6
      NOGO = -1
      GO TO 1370
C
 1370 II = L
 1380 CONTINUE
      IMHERE = 1380
      IF (DEBUG) WRITE (NOUT,140) IMHERE,II
C
      IF (Y(1,II) .EQ. LARGE) CALL MESAGE (-61,0,NAME)
      CALL WRITE (FILEA,Y(1,II),24,0)
      FILEX = II + FILE
      CALL READ (*2980,*1400,FILEX,Y(1,II),24,0,J)
      IF (DEBUG) WRITE (NOUT,1390) FILEX,Y(1,II),Y(2,II)
 1390 FORMAT (5X,'TO PRE-MERGE FILE',I5,3X,2A4)
      GO TO 1310
C
C ... ONE OF THE FILES IS EXHAUSTED
C
 1400 EXH = EXH + 1
      ITAPE(II) = 0
      IF (EXH .GE. REDUCE-1) GO TO 1420
      DO 1410 J = 1,24
 1410 Y(J,II) = LARGE
      IMHERE  = 1410
      IF (DEBUG) WRITE (NOUT,140) IMHERE,EXH
      GO TO 1310
C
C ... ONLY ONE FILE LEFT WHICH HAS NOT BEEN EXHAUSTED
C
 1420 FILEX = FILE + 1
      IF (ITAPE(2) .EQ. 1) FILEX = FILE + 2
      IF (ITAPE(3) .EQ. 1) FILEX = FILE + 3
      IMHERE = 1420
      IF (DEBUG) WRITE (NOUT,140) IMHERE,FILEX
      DO 1430 J = 1,24
 1430 Z(J) = Y(J,FILEX)
C
C     THIS REMAINING FILE COULD BE VERY BIG. IT COULD BE OPTP
C
      LEFT24 = ((LEFT-24)/24)*24
 1440 FULL = 1
      CALL READ (*3000,*1450,FILEX,Z(I25),LEFT24,0,LEN)
      FULL = 0
      LEN  = LEFT24
 1450 IF (LEN .LT. 24) GO TO 1560
C
C ... CHECK ANY DUPLICATE IN THIS GROUP, SET THE 21ST AND 22ND CONTROL
C     WORDS TO -6 IF DUPLICATE
C     THEN WRITE THE REST TO FILEA
C
      DO 1540 L = 1,LEN,24
      I = L - 1
      K = I + 24
      DO 1500 J = 21,24
      IF (Z(I+J) .NE. Z(K+J)) GO TO 1520
 1500 CONTINUE
      DO 1510 J = 7,20
      IF (Z(I+J) .NE. Z(K+J)) GO TO 1520
 1510 CONTINUE
      Z(I+21) = -6
      Z(I+22) = -6
 1520 CALL WRITE (FILEA,Z(L),24,0)
      IF (DEBUG) WRITE (NOUT,1530) FILEA,Z(L),Z(L+1)
 1530 FORMAT (5X,'TO FILEA',I5,3X,2A4)
 1540 CONTINUE
C
C     IF FILE HAS NOT BEEN EXHAUSTED, GO BACK FOR MORE
C
      IF (FULL .EQ. 1) GO TO 1560
      DO 1550 J = 1,24
 1550 Z(J) = Z(LEN+J)
      GO TO 1440
C
 1560 CALL WRITE (FILEA,Z(LEN+1),24,1)
      IF (DEBUG) WRITE (NOUT,1530) FILEA,Z(LEN+1),Z(LEN+2)
      DO 1570 L = 1,REDUCE
      FILEX = FILE + L
      CALL CLOSE (FILEX,REW)
 1570 CONTINUE
C
 1580 FILE = FILE + REDUCE
C
C     END OF PRE-MERGE
C
C
C     SET UP SORTED HEADING IF APPLICABLE
C
 1600 IF (NBULK .LE. 1) GO TO 1620
      CALL PAGE2 (2)
      WRITE  (NOUT,1610) UIM
 1610 FORMAT (A29,' 207, BULK DATA DECK IS NOT SORTED. NASTRAN WILL ',
     1        'RE-ORDER THE INPUT DECK.')
 1620 IF (F3LONG.EQ.0 .OR. ECHOS.EQ.0) GO TO 1640
      CALL PAGE2 (2)
      WRITE  (NOUT,1630) UIM
 1630 FORMAT (A29,' 207A, SIX CHARACTERS OF NASTRAN BCD NAME IN THE ',
     1        'THIRD FIELD WERE USED DURING RE-ORDERING DECK')
 1640 IF (ECHOS .EQ. 0) GO TO 1650
      READ (HEAD(2),150) (HEAD1(J),J=11,24)
CWKBR 9/93 HEAD2(4) = CDCNT(1)
      HEAD2(5) = CDCNT(1)
CWKBR 9/93 HEAD3(4) = CDCNT(2)
      HEAD3(5) = CDCNT(2)
CWKBR 9/93 HEAD3(5) = CDCNT(3)
      HEAD3(6) = CDCNT(3)
      CALL PAGE
C
C     FINAL FILE MERGE, ADD CONTINUATION CARD AS NEEDED. RESULTS IN NPTP
C           ==========
C
C     ASSIGN BUFFER SPACES FOR THE SCRATCH FILES, RESERVE IBUF1 FOR NPTP
C
C     OPEN SCRATCH DATA FILES (303,304,305... OR        ==METHODS 1,2==
C     PREVIOUSLY SAVED         303,304,305...301  OR
C                              302,303,304,305... OR    ==METHOD  3  ==
C                              302,303,304,305,...,301)
C     AND READ INTO Y SPACE THE FIRST RECORD OF EACH SCRATCH FILE
C
C     OPEN NPTP FOR MERGED RESULT
C
C
 1650 CALL OPEN  (*3100,NPTP,Z(IBUF1),WRT)
      CALL WRITE (NPTP,BULKDA,2,1)
      IF (NBULK+NDELE .EQ. 0) GO TO 2290
      IF (TAPECC .NE. 0) CALL OPEN (*2950,TAPECC,Z(IBUFC),RD)
      RECX   = LARGE
      NCARD  = 0
      EXH    = 0
      IMHERE = 1700
      IF (DEBUG) WRITE (NOUT,140) IMHERE,NCONT,NFILER
C
C     IF NO CONTINUATION CARDS, AND ONLY ONE FILE IS USED TO STORE
C     BULKDATA INPUT CARDS, MOVE DATA FROM TAPE3 (COLD START JOB), OR
C     FROM TAPE1 (RESTART JOB WITH DELETE ONLY AND NO NEW BULK DATA)
C     INTO NPTP DIRECTLY. OTHERWISE, JUMP TO 1760
C
      IF (.NOT.(NCONT.EQ.0 .AND. NFILER.EQ.1)) GO TO 1760
      TAPE = TAPE3
      IF (RESTR .EQ. 1) TAPE = TAPE1
      CALL OPEN (*2920,TAPE,Z(IBUF2),RDREW)
      LEFT24 = ((IBUF2-1)/24)*24
 1700 FULL = 1
      K    = 1
      CALL READ (*3000,*1710,TAPE,Z(1),LEFT24,0,J)
      FULL = 0
      J    = LEFT24
 1710 CALL WRITE (NPTP,Z(K),20,1)
      IF (DEBUG) WRITE (NOUT,1720) Z(K),Z(K+1)
 1720 FORMAT (5X,'WRITE TO NPTP',4X,2A4)
      NCARD = NCARD + 1
      L = K + 19
      IF (ECHOS .EQ. 0) GO TO 1740
      CALL PAGE2 (-1)
      WRITE  (NOUT,1730) NCARD,(Z(I),I=K,L)
 1730 FORMAT (13X,I8,1H-,8X,20A4)
 1740 IF (ECHOP .NE. 0) WRITE (LPCH,1750) (Z(I),I=K,L)
 1750 FORMAT (20A4)
      K = K + 24
      IF (K .LT. J) GO TO 1710
      IMHERE = 1750
      IF (DEBUG) WRITE (NOUT,140) IMHERE,FULL,J
      IF (FULL .EQ. 0) GO TO 1700
      CALL EOF (NPTP)
      CALL CLOSE (NPTP,REW)
      CALL CLOSE (TAPE,REW)
      IF (ECHOP .NE. 0) WRITE (LPCH,2320)
      IF (ECHOS .EQ. 0) GO TO 2700
      CALL PAGE2 (-1)
      WRITE (NOUT,2300)
      GO TO 2700
C
C     OPEN AND READ IN THE FIRST DATA RECORD FROM ALL FILES
C
 1760 IMHERE = 1760
      TAPE = TAPE2
      IF (REDUCE .GT. 1) TAPE = TAPE2 - 1
      IF (DEBUG) WRITE (NOUT,140) IMHERE,REDUCE,NFILER,TAPE
      EMPTY = 0
      DO 1800 II = 1,NFILER
      TAPE = TAPE + 1
      IF (II.EQ.NFILER .AND. RESTR.EQ.1) TAPE = TAPE1
      ITAPE(II) = TAPE
      IIBUF = IBUFX(II)
      CALL OPEN (*2960,TAPE,Z(IIBUF),RDREW)
      CALL READ (*3000,*1780,TAPE,Y(1,II),24,0,J)
      IF (DEBUG) WRITE (NOUT,1770) TAPE,II,Y(1,II),Y(2,II)
 1770 FORMAT (5X,'SETTING MERGE TABLE.  TAPE,II =',2I4,2X,2A4)
      GO TO 1800
 1780 EMPTY = EMPTY + 1
      CALL CLOSE (TAPE,REW)
      DO 1790 I = 1,24
 1790 Y(I,II) = LARGE
 1800 CONTINUE
      EXH = -1
      DO 1810 II = 1,NFILER
      IF (Y(21,II) .EQ. -6) GO TO 1830
 1810 CONTINUE
 1820 EXH = EMPTY
      II  = 1
      IF (NFILER-1) 1980,1980,1900
 1830 L = II
      GO TO 2220
C
C     START MERGING FILES
C
C     PICK THE SMALLEST CONTROL WORDS IN 21ST, 22ND, 23RD AND 24TH
C     WORDS OF EACH Y RECORD AND WRITE IT TO MERGE FILE NPTP, 20 WORDS
C     EACH. REPLACE THE CHOSEN RECORD BY NEXT RECORD OF THE SAME FILE
C
 1900 II = 1
      DO 1970 L = 2,NFILER
      IF (Y(21,L) - Y(21,II)) 1960,1910,1970
 1910 IF (Y(1,L)  .EQ. LARGE) GO TO 1970
      IF (Y(22,L) - Y(22,II)) 1960,1920,1970
 1920 IF (Y(23,L) - Y(23,II)) 1960,1930,1970
 1930 IF (Y(24,L) - Y(24,II)) 1960,1940,1970
C
C ... FIRST 3 BULKDATA FIELDS ARE THE SAME, CHECK POSSIBLE DUPLICATE
C     CARDS
C
 1940 DO 1950 J = 7,20
      IF (Y(J,II) .NE. Y(J,L)) GO TO 1970
 1950 CONTINUE
      GO TO 2220
C
 1960 II = L
 1970 CONTINUE
C
 1980 CALL WRITE (NPTP,Y(1,II),20,1)
      NCARD = NCARD + 1
      IF (ECHOS .EQ. 0) GO TO 1990
      CALL PAGE2 (-1)
      WRITE (NOUT,1730) NCARD,(Y(J,II),J=1,20)
 1990 IF (ECHOP .NE. 0) WRITE (LPCH,1750) (Y(J,II),J=1,20)
      IF (NCONT .EQ. 0) GO TO 2200
      IF (RESTR .EQ. 0) GO TO 2000
C
C     IF THIS IS A RESTART JOB, SAVE THE FIRST FIELD, IN CASE THIS IS
C     THE PARENT OF A CONTINUATION CARD THAT CAME FROM NEW BULK DATA
C
      KARD1 = Y(1,II)
      KARD2 = Y(2,II)
      IF (KARD1.NE.PARAM(1) .OR. KARD2.NE.PARAM(2)) GO TO 2000
      KARD1 = Y(3,II)
      KARD2 = Y(4,II)
C
C     INSERT CONTINUATION CARD IF NEEDED
C
 2000 IF (NOGO .EQ.  -3) GO TO 2200
      TEMPX   = Y(19,II)
      TEMP(1) = ANDF(TEMPX,LES1B)
      TEMP(2) = Y(20,II)
 2010 IF (TEMPX.EQ.BLANK .AND. TEMP(2).EQ.BLANK) GO TO 2200
      CALL BISLC2 (*2140,TEMP(1),Z(IC),NCONT,BSIZE,LOC)
      K = LOC*BSIZE + IC - 1
      L = Z(K)
      IF (L .LT. 0) GO TO 2150
      Z(K) = -L
      IF (L .GT. 10000000) GO TO 2050
 2020 DO 2030 I = 1,20
      BUF(I) = Z(L)
 2030 L = L + 1
      IF (RESTR.EQ.0 .OR. KARD1.EQ.-1 .OR. Z(L).EQ.0) GO TO 2120
C         ----------     -------------    -----------
C    I.E. NO RESTART     ALREADY DONE     BULKDATA CARD
C                                         NOT FLAGGED
C
C     SET THE PARENT'S RESTART BIT IF ABOVE CONDITIONS NOT MET
C
      ASSIGN 2040 TO CRDFLG
      FROM = 2040
      GO TO 2810
 2040 KARD1 = -1
      GO TO 2120
C
C     READ IN CONTINUATION CARD IMAGE FROM TAPECC FILE
C
 2050 REC = L/10000000
      L   = L - REC*10000000
      IF (REC-RECX) 2060,2020,2110
 2060 CALL REWIND (TAPECC)
      IF (REC .EQ. 1) GO TO 2090
      SKIP = REC - 1
 2070 DO 2080 J = 1,SKIP
      CALL FWDREC (*3020,TAPECC)
 2080 CONTINUE
 2090 CALL READ (*3020,*2100,TAPECC,Z(IB),NZIB,1,LEN)
      RECX = REC
      GO TO 2020
 2100 CALL MESAGE (-37,0,NAME)
 2110 SKIP = REC - RECX - 1
      IF (SKIP) 2100,2090,2070
C
C     GOT THE CONTINUATION CARD, WRITE IT OUT TO NPTP
C     CHECK WHETHER IT ASKS FOR MORE CONTINUATION CARD
C
 2120 CALL WRITE (NPTP,BUF,20,1)
      NCARD = NCARD + 1
      IF (ECHOS .EQ. 0) GO TO 2130
      CALL PAGE2 (-1)
      WRITE (NOUT,1730) NCARD,(BUF(J),J=1,20)
 2130 IF (ECHOP .NE. 0) WRITE (LPCH,1750) (BUF(J),J=1,20)
      TEMPX   = BUF(19)
      TEMP(1) = ANDF(TEMPX,LES1B)
      TEMP(2) = BUF(20)
      GO TO 2010
C
C     CONTINUATION CARD NOT FOUND. ASSUME THE 10TH FIELD IS USER'S
C     COMMENT
C
 2140 GO TO 2200
C
C     DUPLICATE PARENT - ERROR
C
 2150 CALL PAGE2 (-1)
      IF (ECHOS .NE. 0) GO TO 2155
      WRITE  (NOUT,2152) UFM,Z(-L),Z(-L+1)
 2152 FORMAT (A23,' 208A, ',2A4,' IS DUPLECATE CONTINUATION MARK.')
      GO TO 2180
 2155 WRITE  (NOUT,2160) UFM
 2160 FORMAT (A23,' 208, PREVIOUS CARD IS A DUPLICATE PARENT.')
      IF (DEBUG) WRITE (NOUT,2170) LOC,BSIZE,IC,K,L,TEMPX,TEMP(2)
 2170 FORMAT ('  LOC,BSIZE,IC,K,L =',5I8,2(2H /,A4),1H/)
 2180 NOGO = -1
C
C     REPLACE THE MERGED RECORD BY THE NEXT RECORD OF THE SAME FILE
C
 2200 TAPE   = ITAPE(II)
      IMHERE = 2200
      IF (DEBUG) WRITE (NOUT,140) IMHERE,TAPE,II
      CALL READ (*3000,*2270,TAPE,Y(1,II),24,0,J)
      IF (DEBUG) WRITE (NOUT,2210) TAPE,II,Y(1,II),Y(2,II),
     1                             (Y(J,II),J=21,24)
 2210 FORMAT (5X,'REPLACING - TAPE,II=',2I4,3X,2A4,4I12)
      IF (Y(21,II) .NE. -6) IF (EXH) 1820,1900,1900
 2220 CALL PAGE2 (-2)
      NCARD = NCARD + 1
      CALL WRITE (NPTP,Y(1,II),20,1)
      WRITE  (NOUT,1730) NCARD,(Y(J,II),J=1,20)
      WRITE  (NOUT,2230) UWM
 2230 FORMAT (A25,' 208, PREVIOUS CARD IS A DUPLICATE')
C     NOGO = -1
      IF (.NOT.DEBUG) GO TO 2200
      DO 2250 K = 1,NFILER
      WRITE  (NOUT,2240) K,(Y(J,K),J=1,24)
 2240 FORMAT (1X,I2,3H)  ,20A4,2H /,4I8)
 2250 CONTINUE
      WRITE  (NOUT,2260) II,L
 2260 FORMAT (//5X,'DUPLICATE  II,L=',2I8)
      GO TO 2200
C
C     A SCRATCH FILE IS JUST EXHAUSTED, SET THE CORRESPONDING RECORD
C     A SET OF VERY LARGE NUMBERS
C     IF ALL FILES ARE EXHAUSTED, MERGING DONE
C
 2270 EXH = EXH + 1
      CALL CLOSE (TAPE,REW)
      IMHERE = 2270
      IF (DEBUG) WRITE (NOUT,140) IMHERE,TAPE,EXH,NFILER,NCARD
      IF (EXH .GE. NFILER) GO TO 2290
      DO 2280 I = 1,24
 2280 Y(I,II) = LARGE
      GO TO 1900
C
C     MERGING DONE. EVERY THING IN NPTP.
C
 2290 CALL EOF (NPTP)
      CALL CLOSE (NPTP,REW)
      IMHERE = 2290
      IF (DEBUG) WRITE (NOUT,140) IMHERE,EXH,NFILER
      IF (ECHOS .EQ. 0) GO TO 2310
      CALL PAGE2 (-1)
      WRITE  (NOUT,2300)
 2300 FORMAT (30X,'ENDDATA')
 2310 IF (ECHOP .NE. 0) WRITE (LPCH,2320)
 2320 FORMAT ('ENDDATA')
C
C     CHECK AND IDENTIFY PARENTLESS CONTINUATION CARDS
C     MAKE SURE TO EXCLUDE ANY BROKEN CONTINUATION CARDS SUPPOSEDLY
C     CONNECTED TO ONE PARENT
C
      IF (NCONT.EQ.0 .OR. NOGO.EQ.-3) GO TO 2700
      IMHERE = 2330
      IF (DEBUG) WRITE (NOUT,140) IMHERE,NCONT,IC
      RECX = LARGE
      J = IC + BSIZE - 1
      DO 2490 I = 1,NCONT
      L = Z(J)
 2400 IF (L  .LT. 0) GO TO 2490
      IMHERE = 2400
      IF (DEBUG) WRITE (NOUT,2480) IMHERE,Z(J-2),Z(J-1),L
      IF (L .LE. 10000000) GO TO 2470
      REC = L/10000000
      L   = L - REC*10000000
      IF (REC-RECX) 2410,2470,2450
 2410 CALL REWIND (TAPECC)
      IF (REC .EQ. 1) GO TO 2440
      SKIP = REC - 1
 2420 DO 2430 K = 1,SKIP
      CALL FWDREC (*3020,TAPECC)
 2430 CONTINUE
 2440 CALL READ (*3020,*2620,TAPECC,Z(IB),NZIB,1,LEN)
      RECX = REC
      GO TO 2470
 2450 SKIP = REC - RECX - 1
      IF (SKIP) 2460,2440,2420
 2460 CALL MESAGE (-37,0,NAME)
 2470 TEMP(1) = ANDF(Z(L+18),LES1B)
      TEMP(2) = Z(L+19)
      IMHERE  = 2470
      IF (DEBUG) WRITE (NOUT,2480) IMHERE,TEMP,L
 2480 FORMAT ('  IMHERE=',I5,'  LOOKING FOR - ',2A4,I14)
      IF (TEMP(1).EQ.BLANK .AND. TEMP(2).EQ.BLANK) GO TO 2490
      LOC = LOC + 1
      IF (TEMP(1).NE.Z(LOC+IC) .OR. TEMP(2).NE. Z(LOC*NCONT+IC))
     1    CALL BISLC2 (*2490,TEMP(1),Z(IC),NCONT,BSIZE,LOC)
      K = LOC*BSIZE + IC - 1
      L = Z(K)
      Z(K) = -IABS(Z(K))
      GO TO 2400
 2490 J = J + BSIZE
C
      J  = IC + BSIZE - 1
      II = 0
      RECX   = LARGE
      IMHERE = 2600
      DO 2610 I = 1,NCONT
      IF (Z(J) .LT. 0) GO TO 2610
      IF (II   .EQ. 1) GO TO 2510
      II = 1
      CALL PAGE1
      WRITE  (NOUT,2500) UFM
 2500 FORMAT (A23,' 209, THE FOLLOWING CONTINUATION INPUT CARDS HAVE ',
     1       'NO PARENTS',//)
      NOGO = -1
 2510 CALL PAGE2 (1)
      L = Z(J)
      IF (L .GT. 10000000) GO TO 2540
 2520 M = L + 19
      WRITE  (NOUT,2530) (Z(K),K=L,M)
 2530 FORMAT (10X,20A4)
      GO TO 2610
C
 2540 REC = L/10000000
      L   = L - REC*10000000
      IF (REC-RECX) 2550,2520,2600
 2550 CALL REWIND (TAPECC)
      IF (REC .EQ. 1) GO TO 2580
      SKIP = REC - 1
 2560 DO 2570 K = 1,SKIP
      CALL FWDREC (*3020,TAPECC)
 2570 CONTINUE
 2580 CALL READ (*3020,*2620,TAPECC,Z(IB),NZIB,1,LEN)
      RECX = REC
      GO TO 2520
 2600 SKIP = REC - RECX - 1
      IF (SKIP) 2620,2580,2560
 2610 J = J + BSIZE
      GO TO 2700
 2620 CALL MESAGE (-2,TAPECC,NAME)
C
C     CLOSE CONTINUAION CARD FILE TAPECC, IF IT WAS OPENED
C     DISABLE FREE-FIELD INPUT OPTION IN XREAD.
C
 2700 IF (TAPECC .GT. 0) CALL CLOSE (TAPECC,REW)
      FFFLAG = 0
      WASFF  = 0
      IF (NOGO .NE. -3) GO TO 2730
      WRITE  (NOUT,2710) UFM
 2710 FORMAT (A23,' 3008, CONTINUATION CARDS WERE NOT ADDED TO SORTED ',
     1       'BULKDATA DECK DUE TO INSUFFICIENT CORE CONDITION.')
      IF (CPFLG .NE. 0) WRITE (NOUT,2720)
 2720 FORMAT (5X,'THE NPTP FILE OR TAPE GENERATED IN THIS RUN IS NOT ',
     1       'SUITABLE FOR RESTART')
      CALL MESAGE (-61,0,0)
 2730 IF (NOGO .NE. 0) NOGO = 1
      IF (.NOT. DEBUG) GO TO 3200
C
C     DEBUG NPTP ECHO
C
      IMHERE = 2730
      WRITE (NOUT,140) IMHERE,FFFLAG,WASFF
      CALL OPEN (*3100,NPTP,Z(IBUF1),RDREW)
 2740 CALL SKPFIL (NPTP,+1)
      CALL READ (*2770,*2770,NPTP,BUF(1),2,1,J)
      IF (BUF(1).NE.BULKDA(1) .OR. BUF(2).NE.BULKDA(2)) GO TO 2740
 2750 CALL READ (*2770,*2770,NPTP,BUF(1),20,1,J)
      WRITE  (NOUT,2760) (BUF(J),J=1,10),(BUF(J),J=17,20)
 2760 FORMAT (' ==NPTP==>',5(1X,2A4),'...',2(1X,2A4))
      GO TO 2750
 2770 CALL CLOSE (NPTP,REW)
      GO TO 3200
C
C
C     INTERNAL ROUTINE TO SET RESTART BITS - CRDFLG
C
C     BITS SET ONLY IF JOB IS A RESTART RUN, AND
C       1. ALL NEW BULK DATA CARDS,   EXCEPT CONTINUATION CARDS
C       2. ALL DELETED CARDS IN OPTP, EXCEPT CONTINUATION CARDS
C       3. THE PARENTS OF THE CONTINUATION CARDS IN 1 AND 2
C
 2800 KARD1 = BUF(1)
      KARD2 = BUF(2)
      IF (KARD1.NE.PARAM(1) .OR. KARD2.NE.PARAM(2)) GO TO 2810
      KARD1 = BUF(3)
      KARD2 = BUF(4)
 2810 IMHERE = 2810
      IF (DEBUG) WRITE (NOUT,2820) IMHERE,FROM,NOGO,KARD1,KARD2
 2820 FORMAT (/,' *** IMHERE',I5,', FROM',I5,', NOGO=',I3,3X,2A4)
      IF (NOGO .NE. 0) GO TO 2850
      K = NUMX1*2
      DO 2840 I = 1,K,2
      IF (KARD1.NE.ICARDS(I) .OR. KARD2.NE.ICARDS(I+1)) GO TO 2840
      J = I/2
      M = (J/31) + 1
      N = MOD(J,31) + 2
      IBITS(M) = ORF(IBITS(M),ITWO(N))
      IF (DEBUG) WRITE (NOUT,2830) KARD1,KARD2
 2830 FORMAT (5X,'BITS SET SUCCESSFULLY FOR ',2A4)
      GO TO 2850
 2840 CONTINUE
 2850 GO TO CRDFLG, (200,810,880,2040)
C
C     ERRORS
C
 2900 TAPE = TAPE1
      GO TO  2960
 2910 TAPE = TAPE2
      GO TO  2960
 2920 TAPE = TAPE3
      GO TO  2960
 2930 TAPE = FILEA
      GO TO  2960
 2940 TAPE = FILEX
      GO TO  2960
 2950 TAPE = TAPECC
      IF (TAPECC .LE. MAXSCR) GO TO 2960
 2951 WRITE  (NOUT,2955) SFM
 2955 FORMAT (A25,' 212, NUMBER OF AVAILABLE SCRATCH FILES EXEEDED.',5X,
     1        'RE-RUN JOB WITH MORE CORE')
      GO TO  3140
 2960 WRITE  (NOUT,2970) SFM,TAPE
 2970 FORMAT (A25,' 210, COULD NOT OPEN SCRATCH FILE',I5)
      GO TO  3140
 2980 WRITE  (NOUT,2990) SFM
 2990 FORMAT (A25,' 211, ILLEGAL EOR ON SCRATCH')
      GO TO  3140
 3000 WRITE  (NOUT,3010) SFM,TAPE
 3010 FORMAT (A25,' 212, ILLEGAL EOF ON SCRATCH',I5)
      GO TO  3140
 3020 WRITE  (NOUT,3030)
 3030 FORMAT (//26X,'212, TAPECC ERROR')
      TAPE = TAPECC
      GO TO  3000
 3040 WRITE  (NOUT,3050) SFM
 3050 FORMAT (A25,' 213, ILLEGAL EOF ON OPTP')
      GO TO  3140
 3060 WRITE  (NOUT,3070) SFM,IMHERE
 3070 FORMAT (A25,' 213X, ILLEGAL DATA ON OPTP.  IMHERE =',I7)
      NOGO = 1
      GO TO  810
 3080 WRITE  (NOUT,3090) SFM
 3090 FORMAT (A25,' 214, OPTP COULD NOT BE OPENED')
      GO TO  3140
 3100 WRITE  (NOUT,3110) SFM
 3110 FORMAT (A25,' 215, NPTP COULD NOT BE OPENED')
      GO TO  3140
 3120 WRITE  (NOUT,3130) SFM,IMHERE
 3130 FORMAT (A25,' 219, MISSING ENDDATA CARD.  IMHERE =',I7)
      NOGO = 1
      GO TO  350
 3140 WRITE  (NOUT,3150) IMHERE
 3150 FORMAT (5X,'IMHERE =',I6)
      CALL MESAGE (-37,0,NAME)
C
C     TURN OFF XSORT FLAG AND FREE-FIELD FLAG
C
 3200 IXSORT = 0
      RETURN
      END

      SUBROUTINE MMARM3 ( ZI, ZR, MEMPCOL )
C
C  MMARM3 - This routine will store matrix columns in memory in compact
C           form and in real complex precision.  The input matrix is 
C           assumed to be stored as real single or complex precision.
C           The column is stored in memory according to the following scheme:
C
C  MEMPCOL  = Input, extra memory needed for each column that is stored
C             in memory in compact form.  This is needed for methods 40
C             and 41 where for each column of "B" stored in compact form
C             in memory, there needs to be space available for a column
C             of the "D" matrix.
C
C  1st word = column number (negative)
C  2nd word = index to next column within this array
C  3st word = row position of first element in following string 
C  4nd word = number of terms in string (ntms)
C  5rd word           }
C     |               }
C     |               } = actual
C     |               }   matrix
C     |               }   string
C     |               }   data
C     |               }
C     |               }
C  5+(ntms*prec)      } (where prec=1 for s.p.;  =2 for d.p. )
C     n               } Last value of last string for this column
C
C  Words 3 through 5+(ntms*prec) above data repeat for all strings 
C  within a column.  Words 1 through n repeat for all columns that are
C  read into memory.
C
C
C  Argument list :
C     ZI  - Memory for storage of data (integer)
C     ZR  - Same location as ZI but real single reference 
C
      INTEGER          ZI(1)
      INTEGER          IBLK(15), MODULE(2) 
      REAL             ZR(1)       
      INCLUDE          'MMACOM.COM'        
      COMMON  /ZZZZZZ/ RXL(1)
      COMMON  /SYSTEM/ IBFSIZ, IWR
      DATA             MODULE / 4HMMAR, 4HM3   /
      MEM       = 1
      DO 10 I   = 1,15
10    IBLK(I)   = 0
      IBLK(1)   = IRFILE
C
C IRCOL1, FIRST COLUMN EXPECTED FOR THIS PASS
C IRCOLN, ON INPUT, THIS IS THE LAST COLUMN THAT IS NEEDED 
C         ON OUTPUT, THIS IS THE LAST COLUMN READ
C LASMEM, LAST AVAILABLE MEMORY INDEX TO THE "ZI" ARRAY
C      
      ICOL      = IRCOL1
100   CONTINUE                   
      IBLK(8)   = -1
      LASINDM   = MEM - 1        
      CALL DSCPOS ( IRFILE, ICBLK, ICLR, ICBP )
      CALL GETSTR ( *900, IBLK )
C      IF ( ICOL .NE. IBLK( 12 ) ) GO TO 7001
      ZI(MEM  ) = -ICOL
      MEM1      = MEM + 1
      MEM       = MEM + 2
105   CONTINUE
      NTMS     = IBLK( 6 )
      IF ( ( MEM + 2 + NTMS*2 ) .GT. LASMEM ) GO TO 2000 
      ITYPE    = IBLK( 2 )    
      JROW     = IBLK( 4 )   
      INDEX    = IBLK( 5 )
      ZI(MEM)  = JROW
      ZI(MEM+1)= NTMS
      GO TO ( 110, 120, 130 ), ITYPE
  110 CONTINUE
      MINDEX   = MEM + 2
      DO 115 II = 1,NTMS
      ZR( MINDEX   ) = SIGN*RXL( INDEX+II-1 )
      ZR( MINDEX+1 ) = 0.
      MINDEX = MINDEX+2
  115 CONTINUE
      GO TO 180
C
C THE FOLLOWING LINE SHOULD NEVER BE REFERENCED
C
  120 CONTINUE
      WRITE( IWR, * )' ERROR IN MMARM3'
      STOP
  130 CONTINUE
      MINDEX   = MEM + 1
      NTMS2    = NTMS*2
      DO 135 II = 1,NTMS2
      ZR( MINDEX+II ) = SIGN*RXL( INDEX+II-1 )
  135 CONTINUE
  180 CONTINUE
      MEM        = MEM + 2 + NTMS*2  
      CALL ENDGET ( IBLK )
      CALL GETSTR ( *1000, IBLK )
      GO TO 105
900   CONTINUE
      ZI( MEM )   = -ICOL
      MEM1        = MEM + 1
      MEM         = MEM + 2
1000  CONTINUE
C
C CHECK IF SPACE AVAILABLE FOR A FULL COLUMN OF "D" MATRIX, IF NECESSARY
C
      IF ( MEM .GT. ( LASMEM-MEMPCOL ) ) GO TO 2000
      LASMEM      = LASMEM - MEMPCOL
      ZI( MEM1 )  = MEM 
      ICOL        = ICOL + 1
      IF ( ICOL .GT. IRCOLN ) GO TO 7000
      GO TO 100
2000  LASINDM    = MEM1 - 2
C 
C SAVE I/O LOCATION OF LAST COLUMN FOR NEXT PASS
C
      IRPOS( 1 ) = ICBLK
      IRPOS( 2 ) = ICLR
      IRPOS( 3 ) = ICBP
      IRCOLN     = ICOL - 1
      IF ( IRCOLN .LT. IRCOL1 ) CALL MESAGE ( -8, MEM+MEMPCOL, MODULE )
      GO TO 7777
7000  CONTINUE  
      LASINDM    = MEM - 1        
C      GO TO 7777
C7001  WRITE( IWR, 9001 ) ICOL, IBLK(12), IRFILE
C9001  FORMAT(' ERROR OCCURRED IN MMARM3, EXPECTED COLUMN =',I10
C     &,/,    ' BUT READ COLUMN =',I10,' FROM FILE =',I5 )
C      CALL MESAGE ( -61, 0, 0 )
7777  RETURN        
      END

      SUBROUTINE XFADJ1 (BF,SHIFT,SD)
C
C     XFADJ1 ADJUSTS 4 CHARACTER FIELDS, LEFT OR RIGHT, 2 OR 4 FIELDS
C     AT A TIME
C
C     BF    = ADDR OF LEFT MOST FIELD
C     SHIFT = LSHIFT OR RSHIFT
C     SD   = 0 SINGLE (2 FIELDS), 1 DOUBLE (4 FIELDS)
C     RIGHT SHIFTING CAUSES INSERTION OF LEADING ZEROS
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        LSHIFT,RSHIFT,ANDF,ORF,SHIFT
      LOGICAL         DEC
      DIMENSION       BF(1),BK(6),MK(6),SFT(3)
      COMMON /MACHIN/ MACH
      COMMON /XSRTCM/ BIMSK1(6),BIMSK2(5),BIMSK3(4),BIMSK4(4),BIMSK5(2),
     1                BIMSK6,BKMSK1(8),BKMSK2,SHIFTS(4),ICON1,ICON2,
     2                STAR,PLUS,DOLLAR,STARL,SLASH,SFTM,MASK,BLANK,MKA,
     3                IS,MBIT4
      EQUIVALENCE     (BK(1) ,BKMSK1(2)),(MK(1),BIMSK1(1)),
     1                (SFT(1),SHIFTS(2)),(BLKS, BKMSK1(8)),
     2                (BKX   ,BKMSK1(1))
C
C     DATA     BK   / 4H0000,4H0000,4H0000,4H000 ,4H00  ,4H0   /
C     DATA     (MK(I),I=1,6) /O777777000000,O777700000000,O770000000000,
C    1                        O000000770000,O000077770000,O007777770000/
C     DATA     (SFT(I),I=1,3)/6,12,18/
C     DATA     BLKS / 4H    /,    BKX/4H0000/
C
C
C     INITIALIZE ROUTINES
C
      DEC = MACH.EQ.5 .OR. MACH.EQ.6 .OR. MACH.EQ.21
      IF (SHIFT(MK(3),SFT(1)) .NE. 0) GO TO 10
C
C     LEFT SHIFT REQUESTED
C
      BLK= BLKS
      I1 = 1
      I2 = 2
      I3 = 3
      I4 = 4
      J  = 3
      GO TO 30
C
C     RIGHT SHIFT REQUESTED
C
   10 BLK= BKX
      J  = 4
      IF (SD .EQ. 0) GO TO 20
C
C     DOUBLE FIELD
C
      I1 = 4
      I2 = 3
      I3 = 2
      I4 = 1
      GO TO 30
C
C     SINGLE FIELD
C
   20 I1 = 2
      I2 = 1
C
C     TOTAL FIELD SHIFTS
C
   30 N = 0
   40 IF (J.EQ.4 .AND. BF(I1).NE.BLKS) GO TO 60
      IF (J.EQ.3 .AND. BF(I1).NE.BLKS .AND. BF(I1).NE.BKX) GO TO 60
      BF(I1) = BF(I2)
      BF(I2) = BLK
      IF (SD .EQ. 0) GO TO 50
      N = N + 1
      BF(I2) = BF(I3)
      BF(I3) = BF(I4)
      BF(I4) = BLK
      IF (N .NE. 3) GO TO 40
   50 IF (BF(I1) .EQ. BLKS) RETURN
C
C     CHARACTER SHIFTS BETWEEN FIELDS
C
   60 N = 0
      IF (J .EQ. 3) GO TO 150
C
C     RIGHT
C
      II = I1
   70 IF (BF(II) .NE. BLKS) GO TO 80
      BF(II) = BKX
      GO TO 110
   80 IF (BF(II) .EQ. BKX) GO TO 110
   90 IF (.NOT.DEC) IHLD = RSHIFT(ANDF(MK(3),BF(II)),1)
      IF (     DEC) IHLD = KHRFN4(RSHIFT(KHRFN4(KHRFN1(BKMSK2,1,
     1                     BF(II),1)),1))
      IF (IHLD .NE. ICON1) GO TO 100
      N = N + 1
      IF (.NOT.DEC) BF(II) = LSHIFT(BF(II),SFT(1))
      IF (     DEC) BF(II) = KHRFN3( BKMSK2,BF(II),1,1)
      IF (N .LT. 3) GO TO 90
      GO TO 120
  100 IF (N .NE. 0) GO TO 120
  110 II = II - 1
      IF (II .EQ. 0) GO TO 130
      GO TO 70
  120 N2 = 4 - N
      IF (.NOT.DEC) BF(II) = ORF(RSHIFT(BF(II),SFT(N)),BK(N2))
      IF (     DEC) BF(II) = KHRFN3( BK(N2),BF(II),N,0)
      N = 0
      GO TO 110
  130 N = 0
C
C     RIGHT
C
  140 IF (DEC) GO TO 141
      IF (ANDF(MK(4),BF(I1)) .NE. ANDF(MK(4),BLKS)) GO TO 170
      GO TO 160
  141 IF (KHRFN1(MK(4),4,BF(I1),4) .NE. KHRFN1(MK(4),4,BLKS,4))
     1   GO TO 170
      GO TO 160
C
C     LEFT
C
  150 IF (.NOT.DEC) IHLD = RSHIFT(ANDF(MK(3),BF(I1)),1)
      IF (     DEC) IHLD = KHRFN4(RSHIFT(KHRFN4(KHRFN1(BKMSK2,1,BF(I1),
     1                     1)),1))
      IF (IHLD.NE.ICON1 .AND. IHLD.NE.ICON2) GO TO 170
  160 N = N + 1
      IF (.NOT.DEC) BF(I1) = SHIFT(BF(I1),SFT(1))
      IF (     DEC) BF(I1) = KHRFN3( BKMSK2,BF(I1),1,4-J)
      IF (N .GE. 3) GO TO 180
      IF (J .EQ. 3) GO TO 150
      GO TO 140
  170 IF (N .EQ. 0) RETURN
  180 IF (J .EQ. 4) GO TO 190
C
C     LEFT SHIFTS
C
      N1 = N
      N2 = N + 3
      GO TO 200
C
C     RIGHT SHIFTS
C
  190 N1 = 7 - N
      N2 = 4 - N
  200 N3 = 4 - N
      IF (.NOT.DEC) BF(I1) = ORF(ANDF(MK(N1),BF(I1)),ANDF(MK(N2),
     1                       ISFT(BF(I2),SFT(N3),J)))
      IF (     DEC) BF(I1) = KHRFN3(BF(I1),BF(I2),N3,J-3)
      BF (I1) = ORF(BF(I1),BKMSK2)
      IF (.NOT.DEC) BF(I2) = ORF(ANDF(MK(N1),SHIFT(BF(I2),SFT(N))),
     1                       BK(N2))
      IF (     DEC) BF(I2) = KHRFN3( BK(N2),BF(I2),N,4-J)
      IF (SD .EQ. 0) RETURN
C
      IF (.NOT.DEC) BF(I2) = ORF(ANDF(MK(N1),BF(I2)),ANDF(MK(N2),
     1                       ISFT(BF(I3),SFT(N3),J)))
      IF (     DEC) BF(I2) = KHRFN3( BF(I2),BF(I3),N3,J-3 )
      BF(I2) = ORF(BF(I2),BKMSK2)
      IF (BF(I2) .EQ. BLK) RETURN
C
      IF (.NOT.DEC) BF(I3) = ORF(ANDF(MK(N1),SHIFT(BF(I3),SFT(N))),
     1                       BK(N2))
      IF (     DEC) BF(I3) = KHRFN3(BK(N2),BF(I3),N,4-J)
      IF (.NOT.DEC) BF(I3) = ORF(ANDF(MK(N1),BF(I3)),ANDF(MK(N2),
     1                       ISFT(BF(I4),SFT(N3),J)))
      IF (     DEC) BF(I3) = KHRFN3(BF(I3),BF(I4),N3,J-3)
      BF(I3) = ORF(BF(I3),BKMSK2)
      IF (BF(I3) .EQ. BLK) RETURN
C
      IF (.NOT.DEC) BF(I4) = ORF(ANDF(MK(N1),SHIFT(BF(I4),SFT(N))),
     1                       BK(N2))
      IF (     DEC) BF(I4) = KHRFN3(BK(N2),BF(I4),N,4-J)
      RETURN
      END

      SUBROUTINE MBPRIT(AW,AC,AT)
C
C     SUBROUTINE TO PRINT GEOMETRY DATA
C
      LOGICAL  CNTRL2 , CNTRL1 , CRANK1 , CRANK2 , ASYM
      COMMON /SYSTEM/ SYS,N6
      COMMON /MBOXA/ X(12),Y(12),TANG(10),ANG(10),COTANG(10)
      COMMON /MBOXC/ NJJ ,CRANK1,CRANK2,CNTRL1,CNTRL2,NBOX,
     *  NPTS0,NPTS1,NPTS2,ASYM,GC,CR,MACH,BETA,EK,EKBAR,EKM,
     *  BOXL,BOXW,BOXA ,NCB,NSB,NSBD,NTOTE,KC,KC1,KC2,KCT,KC1T,KC2T
C
      WRITE  (N6 , 200 )  CNTRL2 , CNTRL1 , CRANK1 , CRANK2 , ASYM
 200  FORMAT  ( 1H1 , 35X , 27HSUPERSONIC MACH BOX PROGRAM / 1H0 , 43X
     *        , 12HCONTROL DATA / L20 , 9X , 6HCNTRL2 / L20 , 9X
     *        , 6HCNTRL1 / L20 , 9X , 21HCRANK  (LEADING EDGE)
     *        / L20 , 9X , 22HCRANK  (TRAILING EDGE) / L20 , 9X
     *        , 14HANTI-SYMMETRIC / L20 )
C
      WRITE  (N6 , 300 )   ( I , X(I) , Y(I) , TANG(I) , ANG(I) , I=1,7)
 300  FORMAT  (1H- , 42X , 13HGEOMETRY DATA / 1H0 , 8X , 1HN , 11X , 1HX
     *        , 17X , 1HY , 16X , 4HTANG , 14X , 3HANG / ( I10
     *        , 4E18.6 ) )
C
      WRITE  (N6 , 400 )  ( I , X(I) , Y(I) , TANG(I) , I = 8 , 10)
     *                  , ( I , X(I) , Y(I) , I = 11 , 12 )
 400  FORMAT(I10,3E18.6/I10,3E18.6/I10,3E18.6/(I10,2E18.6))
C
      WRITE  (N6 , 500 )   AW , AC , AT
 500  FORMAT  ( 1H0 , 5X , 23HAREA OF MAIN (SEMISPAN) , 11X
     *        , 15HAREA OF CNTRL1
     *       , 18X , 14HAREA OF CNTRL2 / E22.6,E34.6,E29.6)
      RETURN
      END

      FUNCTION MINDEG (NC,IC,IDEG)
C
C     THIS ROUTINE IS USED ONLY IN BANDIT MODULE
C
C     THIS FUNCTION HAS AS ITS VALUE THE MINIMUM DEGREE OF ANY NODE OF
C     COMPONENT NC IF NC.GT.0
C     IF NC.LE.0, ALL COMPONENTS ARE CONSIDERED.
C
      DIMENSION       IC(1),    IDEG(1)
      COMMON /BANDS / NN
C
      M=600000
      DO 100 I=1,NN
      IF (NC) 40,50,40
   40 IF (IC(I) -NC) 100,50,100
   50 IF (M-IDEG(I)) 100,100,60
   60 M=IDEG(I)
  100 CONTINUE
      MINDEG=M
      RETURN
      END

      SUBROUTINE TRTTEM ( TI, PG)
C****
C THIS ROUTINE COMPUTES THE THERMAL LOAD FOR THE ASSYMMETRIC RING ELE
C WITH A TRIANGULAR CROSS SECTION
C****
C ECPT (01) = ELEMENT ID                         I
C ECPT (02) = SIL A                              I
C ECPT (03) = SIL B                              I
C ECPT (04) = SIL C                              I
C ECPT (05) = MATERIAL ORIENTATION ANGLE(DEGREES)R
C ECPT (07) = MATERIAL ID                        I
C ECPT (08) TO  ECPT (21) = PHI                  R
C ECPT (22) = COOR. SYS. FOR GRID POINT A        I
C ECPT (23) = R-CORD OF GRID A                   R
C ECPT (24) = Z-CORD OF GRID A                   R
C ECPT (25) = 0.0                                R
C ECPT (26) = CORD. SYS. GRID POINT B (NOT USED) I
C ECPT (27) = R-CORD OF GRID B                   R
C ECPT (28) = Z-CORD OF GRID B                   R
C ECPT (29) = 0.0                                R
C ECPT (30) = CORD. SYS. GRID POINT C (NOT USED) I
C ECPT (31) = R-CORD OF GRID C                   R
C ECPT (32) = Z-CORD OF GRID C                   R
C ECPT (33) = 0.0                                R
C ECPT (34) = EL. TEMPERATURE FOR MATERIAL       R
C
      DIMENSION R(3), Z(3), GABABQ(9,9),DELINT(12),TEO(21)
     1,         DTT(9),IGP(3),IECPT(34),ICS(3),PG(1),FIJ(9)
     2,         D(3)  ,TL(9) ,TI(3)
C
C  . ECPT COMMON BLOCK
      COMMON    /TRIMEX/  ECPT(34)
C
C  . MATERIAL INPUT AND OUTPUT...
      COMMON    /MATIN/
     1                   MATIDC            ,MATFLG
     2,                  ELTEMP            ,STRESS
     3,                  SINTH             ,COSTH
C
      COMMON    /MATOUT/
     1                   E(3)              ,ANU(3)
     2,                  RHO               ,G(3)
     3,                  ALF(3)            ,TZERO      ,GSUBE
     4,                   MOSKP(9)            ,SETMAT
      COMMON    /CONDAS/  CONSTS(5)
      EQUIVALENCE (IECPT(1), ECPT(1)),  (Z(1), Z1),  (Z(2), Z2)
     1,             ( Z(3), Z3)
     2,        ( R(1), R1),  ( R(2), R2),  (R(3), R3)
      EQUIVALENCE (CONSTS(1),PI), (CONSTS(4),DEGRAD)
C
C START EXECUTION
C
C STORE ECPT PARAMETERS IN LOCAL VARIABLES
      IDEL = IECPT(1)
      IGP(1) = IECPT(2)
      IGP(2) = IECPT(3)
      IGP(3) = IECPT(4)
      MATID  = IECPT(07)
      ICS(1) = IECPT(22)
      ICS(2) = IECPT(26)
      ICS(3) = IECPT(30)
      R(1)   = ECPT(23)
      R(2)   = ECPT(27)
      R(3)   = ECPT(31)
      Z(2)   = ECPT(28)
      D(2)   = ECPT(29)
      Z(1)   = ECPT(24)
      D(1)   = ECPT(25)
      Z(3)   = ECPT(32)
      D(3)   = ECPT(33)
      DGAMA  = ECPT(05)
      TEMPE  = ECPT(34)
C
C COMPUTE THE ELEMENT COORDINATES
      ZMIN = AMIN1(Z1, Z2, Z3)
      Z1 = Z1 - ZMIN
      Z2 = Z2 - ZMIN
      Z3 = Z3 - ZMIN
C
C FORM THE TRANSFORMATION MATRIX GABABQ (9X9) FROM FIELD COORDINATES TO
C GRID POINT DEGREES OF FREEDOM
      DO 300 I = 1,9
      DO 300 J = 1,9
  300 GABABQ (I,J) = 0.000
      AA = R2 * Z3 + R1 * Z2 + Z1 * R3 - Z2 * R3 - R1 * Z3 - R2 * Z1
      AA = 1.0E0 / AA
      C1 = AA * ( R2 * Z3 - Z2 * R3)
      C2 = - AA * ( Z3 - Z2 )
      C3 = AA * ( R3 - R2 )
      GABABQ (1,1) = C1
      GABABQ (2,4) = C1
      GABABQ (3,7) = C1
      GABABQ (1,2) = C2
      GABABQ (2,5) = C2
      GABABQ (3,8) = C2
      GABABQ (1,3) = C3
      GABABQ(2,6) = C3
      GABABQ(3,9) = C3
      C1 = -AA * ( R1 * Z3 - Z1 * R3)
      C2 =  AA * ( Z3 - Z1 )
      C3 = -AA * ( R3 - R1 )
      GABABQ(4,1) = C1
      GABABQ(4,2) = C2
      GABABQ(4,3) = C3
      GABABQ(5,4) = C1
      GABABQ(5,5) = C2
      GABABQ(5,6) = C3
      GABABQ(6,7) = C1
      GABABQ(6,8) = C2
      GABABQ(6,9) = C3
      C1 = AA * ( R1 * Z2 - Z1 * R2)
      C2 = -AA * ( Z2 - Z1)
      C3 = AA * ( R2 - R1 )
      GABABQ(7,1) = C1
      GABABQ(7,2) = C2
      GABABQ(7,3) = C3
      GABABQ(8,4) = C1
      GABABQ(8,5) = C2
      GABABQ(8,6) = C3
      GABABQ(9,7) = C1
      GABABQ(9,8) = C2
      GABABQ(9,9) = C3
C
C LOCATE THE MATERIAL PROPERTIES IN THE MAT1 OR MAT3
      DGAMR = DGAMA * DEGRAD
      COSG = COS (DGAMR)
      SING = SIN (DGAMR)
      COSTH = COSG
      SINTH = SING
      MATIDC = MATID
      MATFLG = 7
      ELTEMP = TEMPE
      CALL MAT (IDEL)
      IF (SETMAT.EQ.2.0) GO TO 910
C
C  . SET MATERIAL PROPERTIES IN LOCAL VARIABLES...
      ER = E(1)
      ET = E(2)
      EZ = E(3)
      VRO = ANU(1)
      VOZ = ANU(2)
      VZR = ANU(3)
      GOR = G(1)
      GZO = G(2)
      GRZ = G(3)
      VOR = VRO * ET / ER
      VZO = VOZ * EZ / ET
      VRZ = VZR * ER / EZ
      DEL = 1.0E0 / (1.0E0 - VRO * VOR - VOZ * VZO - VZR * VRZ
     1     - VRO * VOZ * VZR - VRZ * VOR * VZO )
C
C COMPUTE ELASTIC CONSTANTS MATRIX FROM MATERIAL TO ELEMENT AXIS
      DO 510 I = 1,21
  510 TEO (I) = 0.0E0
      TEO (1) = ER * ( 1.0E0 - VOZ * VZO) * DEL
      TEO (2) = ER * ( VZR + VZO * VOR ) * DEL
      TEO (3) = EZ * ( 1.0E0 - VRO * VOR ) * DEL
      TEO (4) = ER * ( VOR + VZR * VOZ) * DEL
      TEO (5) = ET * (VZO + VRO * VZR ) * DEL
      TEO (6) = ET * ( 1.0E0 - VRZ * VZR ) * DEL
      TEO (10) = GRZ
      TEO (15) = GOR
      TEO (21) = GZO
      C2 = COSG * COSG
      C4 = C2 * C2
      S2 = SING * SING
      S4 = S2 * S2
      C2S2 = C2 * S2
      EE01 = TEO(1)*C4 + TEO(3)*S4 + (TEO(2) + 2.0E0*TEO(10))
     1      * 2.0E0*C2S2
      EE02 = TEO(2) * (S4+C4) + (TEO(1) + TEO(3) - 4.0E0*TEO(10))*C2S2
      EE03 = TEO(4)*C2 + TEO(5)*S2
      EE04 = SING*COSG * (TEO(1)*C2 - TEO(3)*S2 + (TEO(2) + 2.0E0
     4      *TEO(10)) * (S2-C2))
      EE08 = TEO(1)*S4 + TEO(3)*C4 + (2.0E0*TEO(2) + 4.0E0*TEO(10))
     8      * C2S2
      EE09 = TEO(4)*S2 + TEO(5)*C2
      EE10 = SING*COSG * (TEO(1)*S2 - TEO(3)*C2 + (TEO(2) + 2.0E0
     *      * TEO(10)) * (C2 - S2))
      EE15 = TEO(6)
      EE16 = SING*COSG * (TEO(4) - TEO(5))
C
C COMPUTE HARMONIC COEFFICIENT
      AJHO = IECPT(1) - (IECPT(1) /1000) * 1000 - 1
C
C  . CALCULATE THE INTEGRAL VALUES IN DELINT...
C
C         DELINT(4) = 0,0
C         DELINT(5) = 0,1
C         DELINT(6) = 1,0
C
      DELINT(4) = AIS (3,0,0,R,Z)
      DELINT(5) = AIS (3,0,1,R,Z)
      DELINT(6) = AIS (3,1,0,R,Z)
C
      T1 = EE01*ALF(1) + EE02*ALF(3) + EE03*ALF(2)
      T2 = EE02*ALF(1) + EE08*ALF(3) + EE09*ALF(2)
      T3 = EE03*ALF(1) + EE09*ALF(3) + EE15*ALF(2)
      T4 = EE04*ALF(1) + EE10*ALF(3) + EE16*ALF(2)
C GENERATE DTT MATRIX
      DTT (1) = DELINT (4) * T3
      DTT (2) = DELINT (6) * ( T1 + T3 )
      DTT (3) = DELINT (5) * T3 + DELINT(6) * T4
      DTT (4) = AJHO * DTT (1)
      DTT (5) = AJHO * DELINT (6)*T3
      DTT (6) = AJHO * DELINT (5) * T3
      DTT (7) = 0.0
      DTT (8) = DELINT (6) * T4
      DTT (9) = DELINT (6) * T2
C
C TRANSFORM THE THERMAL LOAD TO GRID POINT DEGREES OF FREEDOM
      CALL GMMATS (GABABQ, 9, 9, 1, DTT, 9, 1, 0, FIJ)
      T = TZERO
      IF (AJHO.GT.0.0) T = 0.0
      T = ((TI(1) + TI(2) + TI(3))/3.0E0 - T) * PI
      IF ( AJHO .EQ. 0.0 ) T = T * 2.0E0
      DO 959 I = 1, 9
  959 TL(I) = T * FIJ(I)
C
C**** THE FOLLOWING CODE REMOVED.  CORD.SYS. NOT POSSIBLE WITH RINGAX **
C.959 FIJ(I) = T*FIJ(I)
C.
C. LOCATE THE TRANSFORMATION MATRICES FOR THE THREE GRID POINTS
C.    DO 750 I=1,81
C.750 AKI(I) = 0.0
C.     DO 800 I = 1,3
C.    CALL GBTRAN(ICS(I),IECPT(4*I+22),DTT(1))  **R,TH,Z NEEDED**
C.    K=30*(I-1) + 1
C.     DO 800 J=1,3
C.    KK = K+9*(J-1)
C.    JJ=3*(J-1)+1
C.    AKI(KK) = DTT(JJ)
C.    AKI(KK+1) = DTT(JJ+1)
C.    AKI(KK+2) = DTT(JJ+2)
C.800 CONTINUE
C.
C. TRANSFORM THE THERMAL LOAD FROM BASIC TO LOCAL COORD...
C.    CALL GMMATS (AKI(1),9,9,1, FIJ(1),9,1,0, TL(1))
C
C ADD THE ELEMENT THERMAL LOAD TO THE STRUCTURE THERMAL LOAD
      K = 0
      DO 900 I = 1, 3
      L = IGP(I) - 1
      DO 900 J = 1,3
      K = K + 1
      L = L + 1
      PG(L) = PG(L) +  TL(K)
  900 CONTINUE
       GO TO 920
  910 CALL MESAGE (-30,37,ECPT(1))
  920 RETURN
      END

      SUBROUTINE FBSINT (X,Y)
C
C     GIVEN THE DECOMPOSITION OF A REAL SYMMETRIC MATRIX, FBSINT WILL
C     SOLVE A SYSTEM OF SIMULTANEOUS LINEAR EQUATIONS BY FORWARD-
C     BACKWARD SUBSTITUTION
C
C     THIS ROUTINE IS SUITABLE FOR BOTH SINGLE AND DOUBLE PRECISION
C     OPERATION
C
      INTEGER         FILEL     ,IBLK(15)
      REAL            X(1)      ,Y(1)
      COMMON /INFBSX/ FILEL(7)
      COMMON /FBSX  / LFILE(7)
      EQUIVALENCE     (FILEL(3) ,NROW)
C
      NROW2 = NROW
      IF (FILEL(5) .EQ. 2) NROW2 = 2*NROW
      DO 100 I = 1,NROW2
      Y(I) = X(I)
  100 CONTINUE
      DO 120 I = 1,7
      LFILE(I) = FILEL(I)
  120 CONTINUE
      CALL REWIND (FILEL)
      CALL SKPREC (FILEL,1)
      IBLK(1) = FILEL(1)
      IF (FILEL(5) .EQ. 1) CALL FBS1 (IBLK,Y,Y,NROW2)
      IF (FILEL(5) .EQ. 2) CALL FBS2 (IBLK,Y,Y,NROW2)
      RETURN
      END

      SUBROUTINE IFP1E (ISUBC,SYMSEQ,NWDSC,I81,ICASTE)
C
C     IFP1E WRITES CASECC OUT FROM CASE
C
      LOGICAL         BIT64
      INTEGER         ISUBC(5),CASE(200,2),BLANK,CASECC,SYMSEQ(1),
     1                CORE(1),COREY(401)
      COMMON /ZZZZZZ/ COREX(1)
      COMMON /XIFP1 / BLANK,BIT64
      COMMON /IFP1A / SCR1,CASECC,IS,NWPC,NCPW4,NMODES,ICC,NSET,
     1                NSYM,ZZZZBB,ISTR,ISUB,LENCC,IBEN,EQUAL,IEOR
      EQUIVALENCE    (COREX(1),COREY(1),CASE(1,1)),(CORE(1),COREY(401))
      DATA    NONE  / 4HNONE/
C
C     INITIALIZE
C
C
C     SKIP FILTER INTO SUBCASES FOR SYM SUBCASES
C
      DO 1100 I = 1,16
      IF (CASE(I,2) .EQ. 0) CASE(I,2) = CASE(I,1)
 1100 CONTINUE
      IF (CASE(38,2) .EQ. 0) CASE(38,2) = CASE(38,1)
      IF (NSYM.GT.1 .AND. CASE(16,2).EQ.0) GO TO 1140
      DO 1130 I = 1,7
      IK = (I-1)*3 + 17
      IF (CASE(IK,2) .NE. 0) GO TO 1125
      DO 1120 J = 1,3
      II = IK + J - 1
 1120 CASE(II,2) = CASE(II,1)
 1125 IWORD = CASE(IK,2)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWORD,0)
      IF (IWORD .EQ. NONE) CASE(IK,2) = 0
 1130 CONTINUE
 1140 DO 1170 J = 1,3
      DO 1150 I = 1,32
      K = 32*J + I + 6
      IWORD = CASE(K,2)
      IF (BIT64) CALL MVBITS (BLANK,0,32,IWORD,0)
      IF (IWORD .NE. BLANK) GO TO 1170
 1150 CONTINUE
      DO 1160 I = 1,32
      K = 32*J + I + 6
 1160 CASE(K,2) = CASE(K,1)
 1170 CONTINUE
      J = 129
      DO 1171 I = 1,5
      CASE(J,2) = ISUBC(I)
      J = J + 1
 1171 CONTINUE
      DO 1180 I = 135,LENCC
      IF (CASE(I,2) .EQ. 0) CASE(I,2) = CASE(I,1)
 1180 CONTINUE
C     IMOV = CASE(136,2)*100000000  !! VAX/IBM INTGER OVERFLOW FOR ANOMA
      IMOV = CASE(136,2)
      IF (IMOV .LT. 0) IMOV = 0
      IMOV = IMOV*100000000
      CASE(136,2) = IABS(CASE(136,2))
      CASE(2,2) = CASE(2,2) + IMOV
      CASE(3,2) = CASE(3,2) + IMOV
      IF (CASE(7,2) .NE. 0) CASE(7,2) = CASE(7,2) + IMOV
      IF (CASE(8,2) .NE. 0) CASE(8,2) = CASE(8,2) + IMOV
      ICASTE = CASE(8,2)
      DO 1220 ILOOP = 1,NMODES
      IF (CASE(1,2) .GT. 99999999) CALL IFP1D (-625)
C
C     CHECK FOR METHOD AND LOAD IN SAME SUBCASE
C
      IF (CASE(5,2).NE.0 .AND. CASE(4,2)+CASE(6,2)+CASE(7,2).NE.0)
     1    CALL IFP1D (-627)
      IF (CASE(4,2).EQ.CASE(6,2) .AND. CASE(4,2).NE.0 .OR.
     1    CASE(6,2).EQ.CASE(7,2) .AND. CASE(6,2).NE.0 .OR.
     2    CASE(4,2).EQ.CASE(7,2) .AND. CASE(4,2).NE.0) CALL IFP1D (-628)
      CALL WRITE (CASECC,CASE(1,2),LENCC,0)
      CASE(1,2) = CASE(1,2) + 1
      IF (CASE(16,2) .LE. 0) GO TO 1200
      IDO = CASE(LENCC,2)
      CALL WRITE (CASECC,SYMSEQ(1),IDO,0)
 1200 IF (NSET .EQ. 0) GO TO 1220
      IP = NWDSC + 1
      DO 1210 I = 1,NSET
      NWOR = CORE(IP)
      CALL WRITE (CASECC,CORE(IP-1),   2,0)
      CALL WRITE (CASECC,CORE(IP+2),NWOR,0)
      IP = IP + NWOR + 3
 1210 CONTINUE
 1220 CALL WRITE (CASECC,CORE(1),0,1)
      NMODES = 1
      IF (NSET .EQ. 0) GO TO 1270
C
C     REMOVE ALL SETS REFERING TO SUBCASE ONLY
C
      IUP  = NWDSC
      IP   = NWDSC
      NSET1= NSET
      IMOV = 0
      DO 1260 I = 1,NSET
      IF (CORE(IP+2) .NE. 1) GO TO 1250
      IF (IMOV       .EQ. 0) GO TO 1240
      IDO = CORE(IP+1) + 3
      DO 1230 J = 1,IDO
      II = IUP + J - 1
      IK = IP  + J - 1
 1230 CORE(II) = CORE(IK)
 1240 IUP = IUP+CORE(IP+1) + 3
      IP  = IP +CORE(IP+1) + 3
      GO TO 1260
 1250 IMOV = 1
      NSET1= NSET1 - 1
      IP   = IP + CORE(IP+1) + 3
 1260 CONTINUE
      NSET = NSET1
      I81  = IUP
 1270 CONTINUE
      DO 1280 I = 1,LENCC
      CASE(I,2) = 0
      IF (I.GT.38 .AND. I.LT.135) CASE(I,2) = BLANK
 1280 CONTINUE
      CALL IFP1F (*1281,IWORD,I2)
      DO 1282 I = 1,5
      ISUBC(I) = CORE(I2)
      I2 = I2 + 1
 1282 CONTINUE
 1281 RETURN
      END

      BLOCK DATA DPDCBD
CDPDCBD
C BLOCK DATA PROGRAM FOR THE DYNAMICS POOL DISTRIBUTOR
C*****
C
      INTEGER       GPL   ,SIL   ,USET  ,USETD ,GPLD  ,SILD  ,DPOOL
     1             ,DLT   ,FRL   ,TFL   ,TRL   ,PSDL  ,EED   ,SCR1
     2             ,SCR2  ,SCR3  ,SCR4  ,BUF   ,BUF1  ,BUF2  ,BUF3
     3             ,BUF4  ,EQDYN ,SDT   ,EPOINT,SEQEP ,EIGC  ,EIGB
     5             ,LOADS ,DLOAD ,FREQ1 ,FREQ  ,TIC   ,TSTEP ,TF
     6             ,PSD   ,EIGR
C
      DIMENSION BUF(24)   ,EPOINT(2)    ,SEQEP(2)     ,MCB(7)
     1         ,NAM(2)    ,LOADS(32)    ,DLOAD(2)     ,FREQ1(2)
     2         ,FREQ(2)   ,EIGC(2)      ,EIGB(2)      ,NOLIN(21)
     3         ,TIC(2)    ,TSTEP(2)     ,TF(2)        ,PSD(2)
     4         ,MSG(3)    ,EIGR(2)
C
      COMMON/DPDCOM/DPOOL ,GPL   ,SIL   ,USET  ,GPLD  ,SILD  ,USETD
     1             ,DLT   ,FRL   ,NLFT  ,TFL   ,TRL   ,PSDL  ,EED
     2             ,SCR1  ,SCR2  ,SCR3  ,SCR4  ,BUF   ,BUF1  ,BUF2
     3             ,BUF3  ,BUF4  ,EPOINT,SEQEP ,L     ,KN    ,NEQDYN
     4             ,LOADS ,DLOAD ,FREQ1 ,FREQ  ,NOLIN ,NOGO
     5             ,MSG   ,TIC   ,TSTEP ,TF    ,PSD   ,EIGR  ,EIGB
     6             ,EIGC  ,MCB   ,NAM   ,EQDYN ,SDT   ,INEQ
C*****
C INPUT FILES
C*****
      DATA    DPOOL/101/  ,GPL/102/     ,SIL/103/     ,USET/104/
C*****
C OUTPUT FILES
C*****
      DATA    GPLD  /201/ ,SILD  /202/  ,USETD /203/  ,TFL   /204/
     1       ,DLT   /205/ ,PSDL  /206/  ,FRL   /207/  ,NLFT  /208/
     2       ,TRL   /209/ ,EED   /210/  ,EQDYN /211/  ,SDT   /212/
C*****
C SCRATCH FILES
C*****
      DATA    SCR1/301/   ,SCR2/302/    ,SCR3/303/    ,SCR4/304/
C*****
C DATA DEFINING INPUT CARDS
C*****
      DATA EPOINT  /   707,     7/
     1    ,SEQEP   /  5707,    57/
     2    ,LOADS   /    27,    17,     0,     0
     3             ,    37,    18,     0,     0
     4             ,    77,    19,     0,     0
     5             ,  5107,    51,     6,     0
     6             ,  5207,    52,     6,     0
     7             ,  7107,    71,     5,     0
     8             ,  7207,    72,    10,     0
     9             ,     0,     0,     0,     0/
     A    ,DLOAD   /    57,     5/
     B    ,FREQ1   /  1007,    10/
     C    ,FREQ    /  1307,    13/
      DATA NOLIN   /  3107,    31,     8
     E             ,  3207,    32,     8
     F             ,  3307,    33,     8
     G             ,  3407,    34,     8
     H             ,  3507,    35,    16
     I             ,  3607,    36,     5
     J             ,  3707,    37,     8/
      DATA TIC     /  6607,    66/
     I    ,TSTEP   /  8307,    83/
     J    ,TF      /  6207,    62/
     K    ,EIGR    /   307,     3/
     L    ,EIGB    /   107,     1/
     M    ,EIGC    /   207,     2/
C*****
C MISC DATA
C*****
      DATA MCB     /   7*0/
     1    ,NAM     /4HDPD ,4H    /
      END

      SUBROUTINE GPFDR
C
C     GRID-POINT-FORCE-DATA-RECOVERY (MODULE)
C
C     THIS MODULE FORMULATES OFP TYPE OUTPUT DATA BLOCKS OF ELEMENT-
C     STRAIN ENERGYS AND GRID-POINT FORCE BALANCES.
C
C     DMAP CALLING SEQUENCES.
C
C     SOLUTION 1 -
C     GPFDR  CASECC,UGV,KMAT,KDICT,ECT,EQEXIN,GPECT,PG,QG/ONRGY1,OGPF1/
C            *STATICS* $
C     SOLUTION 3 -
C     GPFDR  CASECC,PHIG,KMAT,KDICT,ECT,EQEXIN,GPECT,LAMA,/ONRGY1,OGPF1/
C            *REIG* $
C
C     COMMENT FROM G.CHAN/UNISYS, 1/88 -
C     FOR MACHINES OF 32 OR 36 BIT WORDS, THE STRAIN ENERGY COMPUTATION
C     (OTHER COMPUTATIONS TOO) MUST BE DONE IN DOUBLE PRECISION. SINCE
C     THE K-MATRIX NORMALLY IN 10**7, AND THE DISPLACEMENT VECTOR IN
C     10**-2 OR 10**-3 RANGE, SINGLE PRECISION COMPUTATION GIVES BAD
C     RESULT.
C
      LOGICAL  DICOUT   ,ENGOUT   ,ENFLAG   ,ANYGP    ,DIAGM    ,ANY   ,
     1         DOUBLE   ,SILIN    ,ENFILE   ,GPFILE   ,EORST4   ,AXIC  ,
     2         AXIF
      INTEGER  Z        ,CASECC   ,SCRT1    ,EOR      ,SYSBUF   ,TITLE ,
     1         NAMES(2) ,TYPOUT   ,UG       ,SCRT2    ,CORE     ,SUBR(2)
     2,        GSIZE    ,ECT      ,SCRT3    ,SYMFLG   ,EXTGP    ,SUBTIT,
     3         BUF(100) ,TRL(7)   ,ONRGY1   ,GPSET    ,POINTS   ,SCRT4 ,
     4         PG       ,QG       ,UGPGQG   ,OLOAD(2) ,OSPCF(2) ,III(2),
     5         ISUM(10) ,SCALE(2) ,KVEC(10) ,CLSEOF   ,RECIDX(3),OUTPT ,
     6         FILE     ,MCB(7)   ,EQEXIN   ,OGPF1    ,ELNSET   ,BRANCH,
     7         RD       ,APP      ,GPECT    ,SET      ,GPDVIS   ,SUBCAS,
     8         RDREW    ,ECTWDS   ,GRDPTS   ,COMPS(32),ELDVIS   ,BUF1  ,
     9         WRT      ,ELTYPE   ,GRID1    ,EXELID   ,DICLOC   ,BUF2  ,
     O         WRTREW   ,ELEM     ,NAME(2)  ,GRIDL    ,IDREC(10),BUF3  ,
     1         CLS      ,PHEAD(3) ,RECID(3) ,GPSIL    ,COMP     ,BUF4  ,
     2         CLSREW   ,ESTID    ,OLDCOD   ,OUT(10)  ,OLDID    ,BUF5  ,
     3         PIVOT    ,EXTID    ,PTR      ,ENTRYS   ,TOTAL    ,BUF6  ,
     5         METHOD(20)
      REAL     RZ(1)    ,RBUF(5)  ,ROUT(10) ,VEC(6)   ,RIDREC(146)     ,
     1         RSUM(10) ,FVEC(10)
      DOUBLE PRECISION   DIII     ,ELENGY   ,TOTENG   ,DZ(1)
      CHARACTER          UFM*23   ,UWM*25   ,UIM*29   ,SFM*25   ,SWM*27
      COMMON  /XMSSG /   UFM      ,UWM      ,UIM      ,SFM      ,SWM
      COMMON  /SYSTEM/   SYSBUF   ,OUTPT
      COMMON  /NAMES /   RD       ,RDREW    ,WRT      ,WRTREW  ,CLSREW ,
     1                   CLS      ,CLSEOF
      COMMON  /GPTA1 /   NELEMS   ,LAST     ,INCR     ,ELEM(1)
      COMMON  /UNPAKX/   TYPOUT   ,IROW     ,NROW     ,INCRX
      COMMON  /ZNTPKX/   A(4)     ,IROWX    ,IEOL
      COMMON  /ZZZZZZ/   Z(1)
      COMMON  /BLANK /   APP(2)
      EQUIVALENCE        (Z(1),RZ(1),DZ(1)) ,(BUF(1),RBUF(1)),
     1                   (OUT(1),ROUT(1))   ,(NAME1,NAMES(1)),
     2                   (NAME2,NAMES(2))   ,(IDREC(1),RIDREC(1)),
     3                   (DIII,III(1))      ,(ISUM(1),RSUM(1)),
     4                   (KVEC(1),FVEC(1))
      DATA     ENOEOR,   EOR / 0,1/   ,  LBUF/100/, SUBR/4HGPFD,4HR    /
      DATA     CASECC,   UG, KMAT,KDICT,ECT,EQEXIN,GPECT,PG, QG        /
     1         101   ,   102,103, 104,  105,106,   107,  108,109       /
      DATA     ONRGY1,   OGPF1,SCRT1,SCRT2,SCRT3,SCRT4  ,LAMA          /
     1         201   ,   202,  301,  302,  303,  304,    108           /
      DATA     METHS /   10/, OLOAD/4HAPP-,4HLOAD/, OSPCF/4HF-OF,4H-SPC/
      DATA     SCALE /   5, 0/, ISUM  / 0,0,4H*TOT,4HALS*,0,0,0,0,0,0  /
      DATA     METHOD/   4HSTAT,4HICS , 4HREIG,4HEN  , 4HDS0 ,4H       ,
     1                   4HDS1 ,4H    , 4HFREQ,4H    , 4HTRAN,4HSNT    ,
     2                   4HBKL0,4H    , 4HBKL1,4H    , 4HCEIG,4HEN     ,
     3                   4HPLA ,4H    /
C
C     CASE CONTROL POINTERS
C
      DATA     TITLE ,   SUBTIT, LABEL        / 39, 71,103             /
      DATA     ISYM  ,   IGP,IELN,ILSYM,ISUBC / 16,167,170,200,1       /
C
C     DETERMINE APPROACH
C
      N = 2*METHS - 1
      DO 10 I = 1,N,2
      IF (APP(1) .EQ. METHOD(I)) GO TO 40
   10 CONTINUE
      WRITE  (OUTPT,30) UWM,APP
   30 FORMAT (A25,' 2342, UNRECOGNIZED APPROACH PARAMETER ',2A4,
     1       ' IN GPFDR INSTRUCTION.')
      I = 19
      NERROR = 0
      GO TO 1810
C
   40 BRANCH = (I+1)/2
C
C     INITIALIZATION AND BUFFER ALLOCATION.
C
      CORE = KORSZ(Z)
      BUF1 = CORE - SYSBUF - 2
      BUF2 = BUF1 - SYSBUF - 2
      BUF3 = BUF2 - SYSBUF - 2
      BUF4 = BUF3 - SYSBUF - 2
      BUF5 = BUF4 - SYSBUF - 2
      BUF6 = BUF5 - SYSBUF - 2
      CORE = BUF6 - 1
C
C     READ IN FREQUENCIES IF APPROACH IS REIGEN
C
      IF (BRANCH .NE. 2) GO TO 70
      MODE = 0
      CALL OPEN (*70,LAMA,Z(BUF1),RDREW)
      CALL FWDREC (*60,LAMA)
      CALL FWDREC (*60,LAMA)
      LFEQ = CORE
   50 CALL READ (*60,*60,LAMA,BUF,7,0,IWORDS)
      RZ(CORE) = RBUF(5)
      CORE = CORE - 1
      GO TO 50
   60 CALL CLOSE (LAMA,CLSREW)
C
C     GPTA1 DUMMY ELEMENT SETUP CALL.
C
   70 CALL DELSET
      NERROR = 1
      IF (CORE) 1800,1800,80
C
C     OPEN CASE CONTROL
C
   80 FILE = CASECC
      NERROR = 2
      CALL OPEN (*1760,CASECC,Z(BUF1),RDREW)
      CALL FWDREC (*1770,CASECC)
C
C     OPEN VECTOR FILE.
C
      FILE = UG
      CALL OPEN (*1760,UG,Z(BUF2),RDREW)
      CALL FWDREC (*1770,UG)
      TRL(1) = UG
      CALL RDTRL (TRL)
      GSIZE = TRL(3)
C
C     PREPARE OUTPUT BLOCKS FOR ANY OUTPUTS POSSIBLE
C
      ENFILE = .FALSE.
      CALL OPEN (*90,ONRGY1,Z(BUF3),WRTREW)
      ENFILE = .TRUE.
      CALL FNAME (ONRGY1,NAME)
      CALL WRITE (ONRGY1,NAME,2,EOR)
      CALL CLOSE (ONRGY1,CLSEOF)
      MCB(1) = ONRGY1
      CALL RDTRL (MCB)
      MCB(2) = 0
      CALL WRTTRL (MCB)
C
   90 GPFILE = .FALSE.
      NERROR = 4
      CALL OPEN (*100,OGPF1,Z(BUF3),WRTREW)
      GPFILE = .TRUE.
      CALL FNAME (OGPF1,NAME)
      CALL WRITE (OGPF1,NAME,2,EOR)
      CALL CLOSE (OGPF1,CLSEOF)
C
  100 MOVEPQ = 1
      SILIN  = .FALSE.
      TRL(1) = EQEXIN
      CALL RDTRL (TRL)
      POINTS = TRL(2)
      ISILEX = 1
      NSILEX = 2*POINTS
      NERROR = 5
      IF (NSILEX .GT. CORE) GO TO 1800
      ICCZ = NSILEX
      ICC  = ICCZ + 1
      GO TO 120
C
C     OPEN CASECC AND UGV WITH NO REWIND
C
  110 FILE   = CASECC
      NERROR = 8
      CALL OPEN (*1760,CASECC,Z(BUF1),RD)
      FILE = UG
      CALL OPEN (*1760,UG,Z(BUF2),RD)
C
C     READ NEXT CASE CONTROL RECORD.
C
  120 CALL READ (*1750,*130,CASECC,Z(ICCZ+1),CORE-ICCZ,EOR,IWORDS)
      NERROR = 7
      GO TO 1800
C
  130 NCC    = ICCZ + IWORDS
      ITEMP  = ICCZ + ISUBC
      SUBCAS = Z(ITEMP)
C
C     SYMMETRY-REPCASE, GP-FORCE REQUEST, AND EL-ENERGY REQUEST CHECKS
C
      ITEMP  = ICCZ + ISYM
      SYMFLG = Z(ITEMP)
C
C     SET REQUEST PARAMETERS FOR GP-FORCE AND EL-ENERGY.
C
      ITEMP  = ICCZ + IGP
      GPSET  = Z(ITEMP)
      IF (.NOT.GPFILE) GPSET = 0
      GPDVIS = Z(ITEMP+1)
      ITEMP  = ICCZ + IELN
      ELNSET = Z(ITEMP)
      IF (.NOT. ENFILE) ELNSET = 0
      ELDVIS = Z(ITEMP+1)
      IF (GPSET.LE.0 .AND. ELNSET.LE.0) GO TO 170
C
C     POINTERS TO SET LIST DOMAINS
C
      ITEMP = ICCZ + ILSYM
      LSYM  = Z(ITEMP)
      ITEMP = ITEMP + LSYM + 1
  140 SET   = Z(ITEMP)
      ISET  = ITEMP + 2
      LSET  = Z(ITEMP+1)
C
C     CHECK IF THIS SET IS THE ONE FOR GP-FORCE
C
      IF (SET .NE. GPSET) GO TO 150
      IGPLST = ISET
      LGPLST = LSET
C
C     CHECK IF THIS SET IS THE ONE FOR EL-ENERGY
C
  150 IF (SET .NE. ELNSET) GO TO 160
      IELLST = ISET
      LELLST = LSET
C
  160 ITEMP = ISET + LSET
      IF (ITEMP .LT. NCC) GO TO 140
C
C     IS THIS A REPCASE.  IF SO BACK-RECORD UG (REP-CASE OK ONLY FOR
C                                               STATICS)
C
  170 IF (SYMFLG) 180,190,190
C
C     NEGATIVE SYMFLG IMPLIES A REP-CASE.
C
  180 IF (APP(1) .NE. METHOD(1)) GO TO 120
C
C     REP-CASE AND STATICS APPROACH THUS POSITION BACK ONE
C     VECTOR ON UG UNLESS THERE IS NO REQUEST FOR GP-FORCE OR
C     EL-ENERGY TO BEGIN WITH.
C
      IF (GPSET.EQ.0 .AND. ELNSET.EQ.0) GO TO 120
      CALL BCKREC (UG)
      MOVEPQ = MOVEPQ - 1
      GO TO 210
C
C     NOT A REP-CASE BUT STILL IF THERE IS NO REQUEST FOR
C     GP-FORCE OR EL-ENERGY POSITION OVER VECTORS ASSOCIATED
C     WITH THIS CASE.
C
  190 IF (GPSET.NE.0 .OR. ELNSET.NE.0) GO TO 210
      IF (SYMFLG) 120,200,120
C
C     NOT A SYMMETRY CASE (WHICH WOULD USE VECTORS ALREADY READ, THUS
C     SKIP A VECTOR ASSOCIATED WITH THIS CASE.
C
  200 NERROR = 8
CIBMD 6/93 CALL FWDREC (*1770,UG)
CIBMNB 6/93
C MAJOR LOOP OF MODULE TERMINATES WITH ENDING OF CASE CONTROL OR
C END OF EIGENVECTORS COMPUTED.  IF MODES CARD IS USED AND SPECIFIES
C MORE MODES THAN WERE COMPUTED, THEN THE FOLLOWING WILL TERMINATE
C THE LOOP.  (SEE DEMO T03011A WHICH COMPUTED 4 EIGENVALUES BUT HAD
C A MODES CARD SPECIFYING 5 MODES)
      CALL FWDREC (*1750,UG)
CIBMNE
      MOVEPQ = MOVEPQ + 1
      GO TO 120
C
C  BRING VECTOR INTO CORE, BRANCH IF SYMMETRY CASE.
C
  210 IVEC   = NCC + 1
      IVECZ  = NCC
      NVEC   = IVECZ + GSIZE
      NERROR = 9
      IF (NVEC .GT. CORE) GO TO 1800
      ASSIGN 320 TO IRETRN
      UGPGQG = UG
  220 IF (SYMFLG) 230,230,260
C
  230 IROW   = 1
      NROW   = GSIZE
      INCRX  = 1
      TYPOUT = 1
      CALL UNPACK (*240,UGPGQG,RZ(IVEC))
      GO TO 310
C
C     NULL VECTOR (SET VECTOR SPACE TO ZERO)
C
  240 DO 250 I = IVEC,NVEC
      RZ(I) = 0.0
  250 CONTINUE
      GO TO 310
C
C     SYMMETRY SEQUENCE.  SUM VECTORS OF SEQUENCE APPLYING COEFFICIENTS.
C
  260 ITEMP = ICCZ + ILSYM
      LSYM  = Z(ITEMP)
C
C     BACK UP OVER THE VECTORS OF THE SEQUENCE
C
      DO 270 I = 1,LSYM
      CALL BCKREC (UGPGQG)
  270 CONTINUE
C
      DO 280 I = IVEC,NVEC
      RZ(I) = 0.0
  280 CONTINUE
C
      DO 300 I = 1,LSYM
      ITEMP = ITEMP + 1
      COEF  = RZ(ITEMP)
C
C     SUM IN COEF*VECTOR(I)
C
      CALL INTPK (*300,UGPGQG,0,1,0)
  290 CALL ZNTPKI
      J = IVECZ + IROWX
      RZ(J) = RZ(J) + COEF*A(1)
      IF (IEOL) 300,290,300
  300 CONTINUE
  310 GO TO IRETRN, (320,1460)
C
C     AT THIS POINT VECTOR IS IN CORE ALONG WITH THE CASE CONTROL RECORD
C
C     NOW START ECT PASS.  IN THIS PASS GP-FORCES REQUESTED WILL BE
C     WRITTEN TO PMAT (A SCRATCH SET ACTUALLY=SCRT1), AND BY THE GINO
C     DIRECT-ACCESS METHOD.  ALSO EL-ENERGY OUTPUTS WILL BE FORMED FOR
C     ANY REQUESTED ELEMENTS.
C
C     NOTE.  THE ASSEMBLY OF GP-FORCES FOR OUTPUT IS ACCOMPLISHED AFTER
C     ALL GP-FORCES REQUESTED HAVE BEEN WRITTEN TO PMAT.
C
  320 CALL CLOSE (CASECC,CLS)
      CALL CLOSE (UG,CLS)
      IF (SILIN) GO TO 370
C
C     GET SECOND RECORD OF EQEXIN INTO CORE AND TRANSFER CODES FROM
C     SILS TO EXTERNALS AND THEN INSURE SORT ON SILS.
C
      NERROR = 6
      FILE   = EQEXIN
      CALL OPEN (*1760,EQEXIN,Z(BUF1),RDREW)
      CALL FWDREC (*1770,EQEXIN)
      CALL FWDREC (*1770,EQEXIN)
      CALL READ (*1770,*350,EQEXIN,Z(ISILEX),CORE-ISILEX,NOEOR,IWORDS)
  330 WRITE  (OUTPT,340) SWM,EQEXIN
  340 FORMAT (A27,' 2343.  DATA BLOCK',I5,' IS EITHER NOT -EQEXIN- OR ',
     1        'POSSIBLY INCORRECT.')
      GO TO 1810
C
  350 IF (IWORDS .NE. 2*POINTS) GO TO 330
      CALL CLOSE (EQEXIN,CLSREW)
      DO 360 I = ISILEX,NSILEX,2
      Z(I  ) = 10*Z(I) + MOD(Z(I+1),10)
      Z(I+1) = Z(I+1)/10
  360 CONTINUE
      SILIN  = .TRUE.
      CALL SORT (0,0,2,2,Z(ISILEX),NSILEX-ISILEX+1)
C
C     SET UP OFP ID RECORD WITH TITLE, SUBTITLE, AND LABEL.
C
  370 ITIT = ICCZ + TITLE
      ISUB = ICCZ + SUBTIT
      ILAB = ICCZ + LABEL
      DO 380 I = 1,32
      IDREC(I+ 50) = Z(ITIT)
      IDREC(I+ 82) = Z(ISUB)
      IDREC(I+114) = Z(ILAB)
      ITIT = ITIT + 1
      ISUB = ISUB + 1
      ILAB = ILAB + 1
  380 CONTINUE
      DO 390 I = 1,50
      IDREC(I) = 0
  390 CONTINUE
      FILE   = ECT
      NERROR = 10
      CALL OPEN (*1760,ECT,Z(BUF4),RDREW)
      FILE = KMAT
      CALL OPEN (*1760,KMAT,Z(BUF5),RDREW)
C
C     DETERMINE PRECISION OF KMAT DATA
C
      MCB(1) = KMAT
      CALL RDTRL (MCB)
      DOUBLE = .FALSE.
      IF (MCB(2) .EQ. 2) DOUBLE = .TRUE.
      FILE = KDICT
      CALL OPEN (*1760,KDICT,Z(BUF6),RDREW)
      CALL FWDREC (*1770,KDICT)
C
C     PMAT WILL BE ON SCRATCH1
C     PDICT WILL BE ON SCRATCH2
C
      FILE   = SCRT1
      NERROR = 11
      CALL OPEN (*1760,SCRT1,Z(BUF1),WRTREW)
      FILE = SCRT2
      CALL OPEN (*1760,SCRT2,Z(BUF2),WRTREW)
C
C     REQUESTED OUTPUT ELEMENT ENERGIES WILL BE TEMPORARILY WRITTEN ON
C     SCRT3 WHILE THE TOTAL ENERGY IS SUMMED.
C
      FILE   = SCRT3
      IF (ELNSET .NE. 0) CALL OPEN (*1760,SCRT3,Z(BUF3),WRTREW)
      NEXTGP = 1
      LASTID = 0
      OLDCOD = 0
      TOTENG = 0.0D0
      ESTID  = 0
      AXIC   = .FALSE.
      AXIF   = .FALSE.
C
C     ECT PASS OF ALL ELEMENT TYPES PRESENT.
C
C     DETERMINE NEXT ELEMENT TYPE TO FIND ON ECT AND THEN FIND ITS
C     TYPE IN ECT.
C
  400 FILE = KDICT
      NERROR = 12
      CALL READ (*990,*1780,KDICT,RECID,3,NOEOR,IWORDS)
      KT = RECID(1)
C
C           CCONAX       CTRIAAX       CTRAPAX
      IF (KT.EQ.35 .OR. KT.EQ.70 .OR. KT.EQ.71) AXIC = .TRUE.
C         CFLUID2/3/4  AND CFMASS
      IF (KT.GE.43 .AND. KT.LE.46) AXIF = .TRUE.
C         CAXIF2/3/4 AND CSLOT3/4
      IF (KT.GE.47 .AND. KT.LE.51) AXIF = .TRUE.
C
      FILE = ECT
      CALL FWDREC (*1770,ECT)
  410 CALL READ (*1770,*1780,ECT,RECIDX,3,NOEOR,IWORDS)
C     2147483647 = 2**31-1
      IF (RECIDX(1) .EQ. 2147483647) GO TO 1770
      DO 440 I = 1,LAST,INCR
      IF (ELEM(I+3) .NE. RECIDX(1)) GO TO 440
      ELTYPE = (I/INCR) + 1
      ECTWDS = ELEM(I+5)
      IF (ECTWDS .LE. LBUF) GO TO 430
      WRITE  (OUTPT,420) SWM,ELEM(I),ELEM(I+1)
  420 FORMAT (A27,' 2344. GPFDR FINDS ELEMENT = ',2A4,' HAS AN ECT ',
     1        'ENTRY LENGTH TOO LONG FOR A PROGRAM LOCAL ARRAY.')
      GO TO 1810
C
  430 GRDPTS= ELEM(I+ 9)
      GRID1 = ELEM(I+12)
      NAME1 = ELEM(I   )
      NAME2 = ELEM(I+ 1)
      GO TO 470
  440 CONTINUE
C
C     UNRECOGNIZED ELEMENT DATA ON ECT.
C
      WRITE  (OUTPT,450) SWM,RECIDX
  450 FORMAT (A27,' 2345.  GPFDR FINDS AND IS IGNORING UNDEFINED ECT ',
     1        'DATA WITH LOCATE NUMBERS = ',3I8)
      FILE = ECT
C
C     PASS THIS ECT RECORD BUT KEEP ESTID COUNTER IN SYNC.
C
  460 CALL READ (*1770,*410,ECT,BUF,ECTWDS,NOEOR,IWORDS)
      ESTID = ESTID + 1
      GO TO 460
C
  470 IF (ELTYPE .NE. RECID(1)) GO TO 460
      FILE  = KDICT
      LDICT = RECID(2)
      IF (RECID(3) .EQ. GRDPTS) GO TO 500
  480 WRITE  (OUTPT,490) SWM,ELTYPE,KDICT
  490 FORMAT (A27,' 2346.  GPFDR FINDS DATA FOR EL-TYPE =',I9,
     1       ' IN DATA BLOCK',I9, /5X,
     2        'NOT TO BE IN AGREEMENT WITH THAT WHICH IS EXPECTED.')
      GO TO 1810
C
  500 IKDIC  = NVEC + 1
      NKDIC  = NVEC + LDICT
      DICOUT = .FALSE.
      ENGOUT = .FALSE.
C
C     ALLOCATE A P-DICTIONARY FOR THE ELEMENTS GP-FORCE VECTOR
C     CONTRIBUTION.  CONTENTS = ESTID, EXT-EL.-ID, GINO-LOCS (GRDPTS)
C
      IPDIC = NKDIC + 1
      NPDIC = IPDIC + GRDPTS + 1
      LPDIC = GRDPTS + 2
      NERROR= 13
      IF (NPDIC .GT. CORE) GO TO 1800
      ILOC1 = NKDIC - GRDPTS
      PHEAD(1) = ELTYPE
      PHEAD(2) = LPDIC
      PHEAD(3) = GRDPTS
C
C     LOOP IS NOW MADE ON THE ELEMENT ENTRIES OF THIS ELEMENT TYPE.
C
      NEXTEN = 1
C
C     READ NEXT ELEMENT DICTIONARY FROM KDICT OF CURRENT ELEMENT TYPE
C     AND FIND ECT ENTRY WITH SAME ESTID.
C
  510 FILE = KDICT
      CALL READ (*1770,*980,KDICT,Z(IKDIC),LDICT,NOEOR,IWORDS)
      FILE = ECT
      NERROR = 14
  520 CALL READ (*1770,*1780,ECT,BUF,ECTWDS,NOEOR,IWORDS)
      ESTID = ESTID + 1
      IF (Z(IKDIC)-ESTID) 480,530,520
C
C     DECODE THE CODE WORD INTO A LIST OF INTEGERS
C
  530 IF (Z(IKDIC+3) .EQ. OLDCOD) GO TO 540
      OLDCOD = Z(IKDIC+3)
      CALL DECODE (OLDCOD,COMPS,NCOMPS)
      NCOMP2 = NCOMPS
      IF (DOUBLE) NCOMP2 = NCOMPS + NCOMPS
C
C     DETERMINE ACTIVE CONNECTIONS
C
  540 NSIZE  = Z(IKDIC+2)
      NGRIDS = NSIZE / NCOMP2
      IF (NGRIDS .LE. GRDPTS) GO TO 560
      WRITE  (OUTPT,550) UWM,BUF(1)
  550 FORMAT (A25,' 2347.  GPFDR FINDS TOO MANY ACTIVE CONNECTING GRID',
     1       ' POINTS FOR ELEMENT ID =',I9)
      GO TO 1810
C
C     ELEMENT ONLY DISPLACEMENT AND LOAD SPACE.
C
  560 IUGE = NPDIC + 1
      IF (DOUBLE ) IUGE = IUGE/2 + 1
      NUGE = IUGE + NSIZE - 1
      IPGE = NUGE + 1
      NPGE = NUGE + NSIZE
      IF (NPGE .GT. CORE) GO TO 1800
C
C     ECT ENTRY AND K-DICTIONARY ENTRY NOW AT HAND.
C
C     SET FLAG IF EL-ENERGY IS TO BE OUTPUT FOR THIS ELEMENT.
C
      EXELID    = BUF(1)
      Z(IPDIC)  = ESTID
      Z(IPDIC+1)= EXELID
      ENFLAG    = .FALSE.
      IF (AXIC) EXELID = MOD(EXELID,10000  )
      IF (AXIF) EXELID = MOD(EXELID,1000000)
      IF (ELNSET) 580,590,570
C
C     FIND THIS EXTERNAL ELEMENT ID IN THE REQUESTED SET LIST FOR
C     ELEMENT ENERGY OUTPUTS.
C
  570 CALL SETFND (*590,Z(IELLST),LELLST,EXELID,NEXTEN)
  580 ENFLAG = .TRUE.
  590 GRIDL  = GRID1 + GRDPTS - 1
C
C     REORDER ECT CONNECTION LIST ACCORDING TO SIL SEQUENCE.
C
      J = GRID1 - 1
  600 J = J + 1
      IF (J .GE. GRIDL) GO TO 620
      GPSIL = ISILEX + 2*BUF(J) - 1
      LSIL  = Z(GPSIL)
      I = J
  610 I = I + 1
      IF (I .GT. GRIDL) GO TO 600
      GPSIL = ISILEX + 2*BUF(I) - 1
      ISIL  = Z(GPSIL)
      IF (ISIL .GT. LSIL) GO TO 610
      LSIL   = BUF(J)
      BUF(J) = BUF(I)
      BUF(I) = LSIL
      LSIL   = ISIL
      GO TO 610
C
C     NOW SET INTERNAL GRID POINT ID-S IN THE ECT ENTRY NEGATIVE IF THEY
C     ARE TO HAVE THEIR GP-FORCE BALANCE OUTPUT.
C
  620 ANYGP = .FALSE.
      IF (GPSET .EQ. 0) GO TO 670
      DO 660 I = GRID1,GRIDL
      IF (BUF(I)) 660,660,630
  630 IF (GPSET ) 650,660,640
  640 IDX = ISILEX + 2*BUF(I)
      ID  = Z(IDX-2)/10
      IF (AXIC) ID = MOD(ID,1000000)
      IF (AXIF) ID = MOD(ID,500000 )
      IF (ID .LT. LASTID) NEXTGP = 1
      LASTID = ID
      CALL SETFND (*660,Z(IGPLST),LGPLST,ID,NEXTGP)
  650 BUF(I) = -BUF(I)
      ANYGP  = .TRUE.
  660 CONTINUE
C
C     IF NO GRID POINTS OF THIS ELEMENT WERE FLAGGED AND THERE IS
C     NO POTENTIAL OF ANY ELEMENT ENERGY OUTPUTS THEN SKIP THIS ELEMENT
C     AT THIS POINT.
C
  670 IF (.NOT.ANYGP .AND. ELNSET.EQ.0) GO TO 510
C
C     BUILD A NON-EXPANDED ELEMENT DISPLACEMENT VECTOR AT THIS TIME.
C
      J = IUGE
      DO 720 I = GRID1,GRIDL
      IF (BUF(I)) 680,720,690
  680 GPSIL = ISILEX - 2*BUF(I) - 1
      GO TO 700
  690 GPSIL = ISILEX + 2*BUF(I) - 1
  700 ISIL  = Z(GPSIL)
      DO 710 K = 1,NCOMPS
      LSIL  = ISIL + COMPS(K)
      DZ(J) = DBLE(RZ(IVECZ+LSIL))
      J = J + 1
  710 CONTINUE
  720 CONTINUE
C
      IF (J-1 .EQ. NUGE) GO TO 740
      WRITE  (OUTPT,730) SWM,BUF(1)
  730 FORMAT (A27,' 2348.  GPFDR DOES NOT UNDERSTAND THE MATRIX-',
     1        'DICTIONARY ENTRY FOR ELEMENT ID =',I9)
      GO TO 1810
C
C     TOTAL ELEMENT FORCE VECTOR IS NOW COMPUTED.
C
  740 DO 750 I = IPGE,NPGE
      DZ(I) = 0.0D0
  750 CONTINUE
C
      JSIZE = NSIZE
      IKMAT = NPGE  + 1
      IF (.NOT.DOUBLE) GO TO 760
      JSIZE = JSIZE + NSIZE
      IKMAT = NPGE*2+ 1
  760 NKMAT = IKMAT + JSIZE - 1
      IF (NKMAT .GT. CORE) GO TO 1800
      DIAGM = .FALSE.
      IF (Z(IKDIC+1) .EQ. 2) DIAGM = .TRUE.
C
C     LOOP THROUGH ALL PARTITIONS ON KMAT FOR THIS ELEMENT.
C
      JPGE = IPGE
      DO 870 I = 1,GRDPTS
      ITEMP = ILOC1 + I
      IF (Z(ITEMP)) 770,870,770
  770 CALL FILPOS (KMAT,Z(ITEMP))
      IF (DIAGM) GO TO 830
C
C     FULL MATRIX.  READ COLUMNS OF ROW-STORED VERETICAL PARTITION.
C
      NERROR = 16
      DO 820 K = 1,NCOMPS
      CALL READ (*1770,*1780,KMAT,Z(IKMAT),JSIZE,NOEOR,IWORDS)
      JKMAT = IKMAT
      IF (DOUBLE) GO TO 790
      DO 780 J = IUGE,NUGE
      DZ(JPGE) = DZ(JPGE) + DZ(J)*DBLE(RZ(JKMAT))
      JKMAT = JKMAT + 1
  780 CONTINUE
      GO TO 810
C
  790 DO 800 J = IUGE,NUGE
      III(1) = Z(JKMAT  )
      III(2) = Z(JKMAT+1)
      DZ(JPGE) = DZ(JPGE) + DZ(J)*DIII
      JKMAT = JKMAT + 2
  800 CONTINUE
C
  810 JPGE = JPGE + 1
  820 CONTINUE
      GO TO 870
C
C     DIAGONAL MATRIX.  THUS ONLY DIAGONAL TERMS OF PARTITION CAN
C     BE READ.
C
  830 NERROR = 17
      CALL READ (*1770,*1780,KMAT,Z(IKMAT),NCOMP2,NOEOR,IWORDS)
      IF (DOUBLE) GO TO 850
C
      DO 840 J = 1,NCOMPS
      DZ(JPGE) = DZ(IUGE+J-1)*DBLE(RZ(IKMAT+J-1))
      JPGE = JPGE + 1
  840 CONTINUE
      GO TO 870
C
  850 JKMAT = IKMAT
      DO 860 J = 1,NCOMPS
      III(1) = Z(JKMAT)
      III(2) = Z(JKMAT+1)
      DZ(JPGE) = DZ(IUGE+J-1)*DIII
      JKMAT = JKMAT + 2
      JPGE  = JPGE + 1
  860 CONTINUE
C
  870 CONTINUE
C
C     ENERGY COMPUTATION IS NOW MADE IF NECESSARY.
C
C       U   =  0.5(PG ) X (UG )
C        T           E         E
C
C
      IF (ELNSET) 880,900,880
  880 JPGE  = IPGE
      ELENGY= 0.0D0
      DO 890 I = IUGE,NUGE
      ELENGY= ELENGY + DZ(I)*DZ(JPGE)
      JPGE  = JPGE + 1
  890 CONTINUE
C
C     NOTE, TOTAL ENERGY WILL BE DIVIDED BY 2.0 LATER.
C
      TOTENG = TOTENG + ELENGY
C
C     WRITE THIS ELEMENTS ENERGY ON SCRT3 FOR LATER OUTPUT IF REQUESTED.
C
      IF (.NOT. ENFLAG) GO TO 900
      OUT (1) = BUF(1)
      ROUT(2) = SNGL(ELENGY)*0.50
      IF (.NOT.ENGOUT) CALL WRITE (SCRT3,NAMES,2,NOEOR)
      CALL WRITE (SCRT3,OUT,2,NOEOR)
      ENGOUT  = .TRUE.
C
C     GRID POINT FORCE BALANCE OUTPUTS FOR REQUESTED GIRD POINTS.
C
  900 IF (.NOT. ANYGP) GO TO 970
C
C     EXPAND TO 6X1 FROM PGE EACH GRID POINT FORCE TO BE OUTPUT.
C
C     FORCES COMPUTED FOR COMPONENTS OTHER THAN 1 THRU 6 ARE NOT
C     NOW OUTPUT FROM MODULE GPFDR...  FUTURE ADDITIONAL CAPABLILITY.
C     OFP MODS NEEDED AT THAT TIME.
C
      JPGE   = IPGE
      DICLOC = IPDIC + 2
      DO 910 I = DICLOC,NPDIC
      Z(I) = 0
  910 CONTINUE
      DO 960 I = GRID1,GRIDL
      IF (BUF(I)) 930,960,920
C
C     THIS GRID POINT NOT IN GP-FORCE BALANCE REQUEST LIST.
C
  920 JPGE = JPGE + NCOMPS
      DICLOC = DICLOC + 1
      GO TO 960
C
C     OK THIS GRID POINT GETS OUTPUT.
C
  930 DO  940 J = 1,6
      VEC(J) = 0.0
  940 CONTINUE
      DO 950 J = 1,NCOMPS
      COMP = COMPS(J)
      IF (COMP .LE. 5) VEC(COMP+1) =-SNGL(DZ(JPGE))
      JPGE = JPGE + 1
  950 CONTINUE
C
      CALL WRITE  (SCRT1,VEC,6,EOR)
      CALL SAVPOS (SCRT1,Z(DICLOC))
      DICLOC = DICLOC + 1
  960 CONTINUE
C
C     OUTPUT THE DICTIONARY
C
      IF (.NOT.DICOUT) CALL WRITE (SCRT2,PHEAD,3,NOEOR)
      CALL WRITE (SCRT2,Z(IPDIC),LPDIC,NOEOR)
      DICOUT = .TRUE.
C
C     GO FOR NEXT ELEMENT OF CURRENT TYPE.
C
  970 GO TO 510
C
C     END OF ELEMENT ENTRIES OF CURRENT ELEMENT TYPE.
C     COMPLETE RECORDS IN PDIC, AND SCRT3=EL-ENERGY.
C
  980 IF (DICOUT) CALL WRITE (SCRT2,0,0,EOR)
      IF (ENGOUT) CALL WRITE (SCRT3,0,0,EOR)
C
C     GO FOR NEXT ELEMENT TYPE
C
      GO TO 400
C
C     END OF ALL ELEMENT DATA ON ECT (WRAP UP PHASE I OF GPFDR).
C
  990 CALL CLOSE (KMAT,CLSREW)
      CALL CLOSE (KDICT,CLSREW)
      CALL CLOSE (ECT,CLSREW)
      CALL CLOSE (SCRT1,CLSREW)
      CALL CLOSE (SCRT2,CLSREW)
      CALL CLOSE (SCRT3,CLSREW)
C
C     PREPARE AND WRITE THE ELEMENT ENERGY OUTPUTS NOW RESIDENT ON SCRT3
C
      IF (ELNSET .EQ. 0) GO TO 1050
C
C     OFP ID RECORD DATA
C     DEVICE, OFP-TYPE, TOTAL ENERGY, SUBCASE, ELEMENT NAME, WORDS
C     PER ENTRY.
C
      IDREC( 1) = 10*BRANCH + ELDVIS
      IDREC( 2) = 18
      RIDREC(3) = SNGL(TOTENG)*0.50
      IDREC( 4) = SUBCAS
      IDREC(10) = 3
C
C     IF APPROACH IS REIG, PUT MODE NO. AND FREQ. INTO IDREC, 8 AND 9
C     WORDS
C
      IF (BRANCH .NE. 2) GO TO 1000
      RIDREC(9) = RZ(LFEQ-MODE)
      MODE      = MODE + 1
      IDREC( 8) = MODE
C
 1000 NERROR = 22
      FILE = ONRGY1
      CALL OPEN (*1760,ONRGY1,Z(BUF2),WRT)
      FILE = SCRT3
      CALL OPEN (*1760,SCRT3,Z(BUF3),RDREW)
C
C     TOTENG FACTOR FOR MULTIPLICATION TO GET DECIMAL PERCENTAGE BELOW
C
      IF (TOTENG .NE. 0.0D0) TOTENG = 200.0D0/TOTENG
C
C     READ ELEMENT NAME INTO IDREC RECORD.
C
      JTYPE = 0
 1010 CALL READ  (*1040,*1780,SCRT3,IDREC(6),2,NOEOR,IWORDS)
      CALL WRITE (ONRGY1,IDREC,146,EOR)
 1020 CALL READ  (*1770,*1030,SCRT3,BUF,2,NOEOR,IWORDS)
      JTYPE  = JTYPE + 1
      BUF(1) = 10*BUF(1) + ELDVIS
      RBUF(3)= RBUF(2)*SNGL(TOTENG)
      CALL WRITE (ONRGY1,BUF,3,NOEOR)
      GO TO 1020
C
 1030 CALL WRITE (ONRGY1,0,0,EOR)
      GO TO 1010
C
 1040 CALL CLOSE (ONRGY1,CLSEOF)
      MCB(1) = ONRGY1
      CALL RDTRL (MCB)
      MCB(2) = MCB(2) + JTYPE
      CALL WRTTRL (MCB)
      CALL CLOSE (SCRT3,CLSREW)
      IDREC(3) = 0
      IDREC(6) = 0
      IDREC(7) = 0
C
C     A GRID-POINT-FORCE-BALANCE-OUTPUT-MAP IS NOW CONSTRUCTED. (GPFBOM)
C
C     CONTENTS...  1 LOGICAL RECORD FOR EACH GRID POINT TO BE OUTPUT
C     ===========
C
C     REPEATING 4       * EXTERNAL-ELEMENT-ID
C     WORD ENTRIES     *  ELEMENT NAME FIRST 4H
C     OF THE CON-      *  ELEMENT NAME LAST  4H
C     NECTED ELEMENTS   * GINO-LOC OF THE 6X1 FORCE VECTOR CONTRIBUTION
C
C     FOR EACH RECORD WRITTEN ABOVE, A 3-WORD ENTRY IS WRITTEN TO A
C     COMPANION DICTIONARY FILE GIVING,
C
C                      *  1-THE EXTERNAL GRID POINT ID
C     REPEATING ENTRY *   2-THE GINO-LOC TO THE ABOVE RECORD
C                      *  3-THE NUMBER OF ENTRIES IN THE RECORD
C
C
C     ALLOCATE A TABLE WITH AN ENTRY FOR EACH ELEMENT TYPE.
C     POSSIBLE IN IT.  EACH ENTRY TO HAVE 3 WORDS.
C
C     ENTRY I =      1= PTR TO DICTIONARY DATA FOR ELEMENT TYPE-I
C     *********      2= LENGTH OF DICTIONARY DATA
C                    3= NUMBER OF ENTRIES
C
 1050 IF (GPSET .EQ. 0) GO TO 110
      IDTAB = NCC + 1
      NDTAB = IDTAB + NELEMS*3 - 1
      JDICTS= NDTAB + 1
      IF (JDICTS .GT. CORE) GO TO 1800
      DO 1060 I = IDTAB,NDTAB
      Z(I) = 0
 1060 CONTINUE
C
C     READ IN DICTIONARIES OF PMAT VECTORS.  (SCRT2)
C
      FILE = SCRT2
      CALL OPEN (*1760,SCRT2,Z(BUF2),RDREW)
C
C     READ AN ELEMENT TYPE HEADER (FIRST 3-WORDS OF EACH RECORD)
C
 1070 CALL READ (*1090,*1780,SCRT2,BUF,3,NOEOR,IWORDS)
      ITYPE = BUF(1)
      LDICT = BUF(2)
      GRDPTS= BUF(3)
      K     = INCR*ITYPE - INCR
      J     = IDTAB + 3*ITYPE - 3
      Z(J)  = JDICTS
C
C     BLAST READ IN THE DICTIONARIES OF THIS TYPE.
C
      CALL READ (*1770,*1080,SCRT2,Z(JDICTS),CORE-JDICTS,NOEOR,IWORDS)
      NERROR = 18
      GO TO 1800
C
 1080 Z(J+1) = IWORDS
      Z(J+2) = IWORDS/LDICT
      JDICTS = JDICTS + IWORDS
      NERROR = 19
      IF (CORE-JDICTS) 1800,1800,1070
C
 1090 CALL CLOSE (SCRT2,CLSREW)
C
C     DICTIONARIES ALL IN CORE.  SCRT2 IS AVAILABLE FOR USE AS THE
C     -GPFBOM-.
C
      NDICTS = JDICTS - 1
C
C     PASS THE -GPECT- AND BUILD THE -GPFBOM- (ON SCRT2) AND ITS
C     COMPANION DICTIONARY FILE (ON SCRT3).
C
      FILE = SCRT2
      CALL OPEN (*1760,SCRT2,Z(BUF2),WRTREW)
      FILE = SCRT3
      CALL OPEN (*1760,SCRT3,Z(BUF3),WRTREW)
C
      FILE = GPECT
      CALL OPEN (*1760,GPECT,Z(BUF4),RDREW)
      CALL FWDREC (*1770,GPECT)
      OLDID = 0
      NEXT  = 1
C
C     READ PIVOT HEADER DATA FROM -GPECT- RECORD.
C
 1100 CALL READ (*1240,*1780,GPECT,BUF,2,NOEOR,IWORDS)
      PIVOT = BUF(1)
C
C     CONVERT SIL TO EX-ID
C
      CALL BISLOC (*1200,PIVOT,Z(ISILEX+1),2,POINTS,J)
      J = ISILEX + J - 1
      EXTID = Z(J)/10
      IDEXT = EXTID
      IF (AXIC) IDEXT = MOD(EXTID,1000000)
      IF (AXIF) IDEXT = MOD(EXTID,500000 )
      NENTRY = 0
C
C     CHECK FOR OUTPUT REQUEST THIS EX-ID
C
      IF (GPSET) 1120,1220,1110
 1110 IF (IDEXT .LT. OLDID) NEXT = 1
      OLDID = IDEXT
      CALL SETFND (*1220,Z(IGPLST),LGPLST,IDEXT,NEXT)
C
C     YES GP-FORCE BALANCE FOR PIVOT IS TO BE OUTPUT.
C
C     PROCESS ALL ELEMENTS CONNECTING THIS PIVOT.
C
 1120 CALL READ (*1770,*1230,GPECT,LENGTH,1,NOEOR,IWORDS)
      LENGTH = IABS(LENGTH)
      IF (LENGTH .LE. LBUF) GO TO 1140
      WRITE  (OUTPT,1130) SWM,PIVOT,GPECT
 1130 FORMAT (A27,' 2349.  GPFDR FINDS AN ELEMENT ENTRY CONNECTING ',
     1       'PIVOT SIL =',I9,' ON DATA BLOCK',I5, /5X,
     2       'TOO LARGE FOR A LOCAL ARRAY. ENTRY IS BEING IGNORED.')
      CALL READ (*1770,*1780,GPECT,0,-LENGTH,NOEOR,IWORDS)
      GO TO 1120
C
C     LOCATE ELEMENT FORCE DICTIONARY FOR THIS ELEMENT ENTRY.
C
 1140 CALL READ (*1770,*1780,GPECT,BUF,LENGTH,NOEOR,IWORDS)
      KTYPE = BUF(2)*3 - 3 + IDTAB
      PTR   = Z(KTYPE)
      LDICTS= Z(KTYPE+2)
      IF (LDICTS .EQ. 0) GO TO 1180
      N = Z(KTYPE+1)
      CALL BISLOC (*1180,BUF(1),Z(PTR),N/LDICTS,LDICTS,J)
      J = PTR + J
      OUT(1) = Z(J)
C
C     FOUND DICTIONARY.  DETERMINE GINO-LOC TO USE.
C
      DO 1150 I = 3,LENGTH
      J = J + 1
      IF (BUF(I).EQ.PIVOT .AND. Z(J).GT.0) GO TO 1170
 1150 CONTINUE
      WRITE  (OUTPT,1160) SWM,PIVOT,OUT(1),GPECT
 1160 FORMAT (A27,' 2350.  GPFDR CANNOT FIND PIVOT SIL =',I10, /5X,
     1       'AMONG THE SILS OF ELEMENT ID =',I9,
     2       ' AS READ FROM DATA BLOCK',I5,',  ENTRY THUS IGNORED.')
      GO TO 1120
C
 1170 K = BUF(2)*INCR - INCR
      OUT(2) = ELEM(K+1)
      OUT(3) = ELEM(K+2)
      OUT(4) = Z(J)
C
C     GINO-LOC IN P-DICTIONARY NO LONGER NEEDED, THUS SET IT NEGATIVE
C     TO AVOID RE-USE IN CASE WHERE AN ELEMENT CONNECTS SAME GRID MORE
C     THAN ONCE.
C
      Z(J) = -Z(J)
C
C     OUTPUT THE 4-WORD ENTRY TO -GPFBOM-
C
      CALL WRITE (SCRT2,OUT,4,NOEOR)
C
C     INCREMENT COUNTS
C
      NENTRY = NENTRY + 1
C
C     GET THE NEXT ELEMENT ENTRY.
C
      GO TO 1120
C
C     HERE WHEN PMAT DICTIONARY MISSING FOR AN ELEMENT
C     CONNECTED TO A GRID POINT TO HAVE GP-FORCE BALANCE OUTPUT.
C
 1180 KKK = BUF(2)*INCR - INCR
      WRITE  (OUTPT,1190) UIM,ELEM(KKK+1),ELEM(KKK+2),EXTID
 1190 FORMAT (A29,' 2351. A FORCE CONTRIBUTION  DUE TO ELEMENT TYPE = ',
     1       2A4,', ON POINT ID =',I10, /5X,
     2       'WILL NOT APPEAR IN THE GRID-POINT-FORCE-BALANCE SUMMARY.')
      GO TO 1120
C
C     SIL NOT FOUND IN LIST OF SILS, OR NOT REQUESTED.
C
 1200 WRITE  (OUTPT,1210) SWM,PIVOT,GPECT
 1210 FORMAT (A27,' 2352.  GPFDR IS NOT ABLE TO FIND PIVOT SIL =',I10,
     1       ' AS READ FROM DATA BLOCK',I5, /5X,'IN TABLE OF SILS.')
C
 1220 CALL FWDREC (*1770,GPECT)
      GO TO 1100
C
C     HERE WHEN END OF RECORD ON GPECT.
C     COMPLETE THE RECORD ON -GPFBOM- AND WRITE DICTIONARY ENTRY FOR THE
C     COMPLETED RECORD.
C
 1230 CALL WRITE (SCRT2,0,0,EOR)
      BUF(1) = EXTID
      BUF(3) = NENTRY
      CALL SAVPOS (SCRT2,BUF(2))
      CALL WRITE (SCRT3,BUF,3,NOEOR)
C
C     GO FOR NEXT PIVOT SIL
C
      GO TO 1100
C
C     HERE WHEN END OF FILE ON -GPECT-.
C
 1240 CALL CLOSE (GPECT,CLSREW)
      CALL CLOSE (SCRT2,CLSREW)
      CALL CLOSE (SCRT3,CLSREW)
C
C     SO AS TO OUTPUT THE FORCE BALANCES IN EXTERNAL GRID POINT ORDER
C     THE FOLLOWING STEPS ARE NOW PERFORMED ON THE DICTIONARY ENTRIES OF
C     THE -GPFBOM- COMPANION FILE (SCRT3).
C
C     1) ALL OF THE COMPANION FILE DICTIONARIES ARE READ INTO CORE.
C     2) THEY ARE SORTED ON THE EXTERNAL IDS.
C     3) THEY ARE PARTITIONED INTO GROUPS BASED ON A CONSIDERATION OF
C        THE NEED FOR 12 WORDS OF CORE FOR EACH ENTRY OF EACH -GPFBOM-
C        RECORD REPRESENTED BY THE GROUP IN THE FINAL OUTPUT PASS.
C     4) EACH ENTRYS 3-RD WORD (THE NUMBER OF ENTRIES IN THE RECORD) IS
C        REPLACED WITH THE INTEGER POSITION OF THE ENTRY IN THE GROUP.
C     5) EACH GROUP IS SORTED ON GINO-LOC AND WRITTEN BACK
C        TO THE COMPANION FILE AS A LOGICAL RECORD.  (THIS INSURES THAT
C        NO MORE THAN ONE PASS OF THE -GPFBOM- IS MADE PER GROUP WHEN
C        CONSTRUCTING TABLE-1 AND TABLE-2 IN THE FINAL OUTPUT PASS.)
C
      FILE = SCRT3
      NERROR = 20
      CALL OPEN (*1760,SCRT3,Z(BUF3),RDREW)
C
C     BLAST-READ 3-WORD -GPFBOM- DICTIONARY ENTRIES INTO CORE.
C
      IDICTS = NCC + 1
      CALL READ (*1770,*1250,SCRT3,Z(IDICTS),CORE-IDICTS,NOEOR,IWORDS)
      GO TO 1800
C
 1250 NDICTS = IDICTS + IWORDS - 1
      CALL CLOSE (SCRT3,CLSREW)
      NERROR = 21
      CALL OPEN (*1760,SCRT3,Z(BUF3),WRTREW)
C
C     SORT ENTRIES ON EXTERNAL ID
C
      CALL SORT (0,0,3,1,Z(IDICTS),IWORDS)
C
C     DETERMINE A -GPFBOM- GROUP OF RECORDS FOR OUTPUT.  EACH -GPFBOM-
C     RECORDS ENTRY WILL REQUIRE 12 WORDS OF CORE IN THE FINAL OUTPUT
C     PROCEEDURES.
C
      ENTRYS = (CORE-NCC)/12
 1260 J = IDICTS
      TOTAL = 0
 1270 IF (TOTAL+Z(J+2) .GT. ENTRYS) GO TO 1280
      TOTAL = TOTAL + Z(J+2)
      J = J + 3
      IF (J .LT. NDICTS) GO TO 1270
C
C     GROUP RANGE HAS BEEN FOUND.  REPLACE EACH ENTRYS -GPFBOM- ENTRY
C     COUNT WITH THE OUTPUT ORDER OF THE EXTERNAL ID ENTRY HERE.
C
 1280 JDICTS = J - 1
      K  = 1
      DO 1290 I = IDICTS,JDICTS,3
      JK = Z(I+2)
      Z(I+2) = K
      K  = K + JK
 1290 CONTINUE
C
C     SORT THIS GROUP OF 3-WORD ENTRIES ON THE GINO-LOCS.
C
      LENGTH = JDICTS - IDICTS + 1
      CALL SORT (0,0,3,2,Z(IDICTS),LENGTH)
C
C     OUTPUT AS A LOGICAL RECORD.
C
      CALL WRITE (SCRT3,Z(IDICTS),LENGTH,EOR)
C
C     PROCESS NEXT GROUP IF THERE ARE MORE.
C
      IDICTS = JDICTS + 1
      IF (IDICTS .LT. NDICTS) GO TO 1260
C
C     ALL GROUPS HAVE BEEN DETERMINED, SEQUENCED, SORTED ON GINO-LOCS,
C     AND OUTPUT.
C
      CALL CLOSE (SCRT3,CLSREW)
C
C     PREPARE GRID-POINT-FORCE-BALANCE ENTRIES WITH RESPECT TO APPLIED-
C     LOAD AND SINGLE-POINT-CONSTRAINT FORCES.
C
C     LINE ENTRIES WILL BE WRITTEN TO SCRT4 FROM THE VECTOR IN CORE
C     FOR EACH OF PG AND QG CONTAINING,
C
C     EXTERNAL GP ID, 0, 4H----, 4H----, T1, T2, T3, R1, R2, R3,
C
C     ONLY FOR THOSE POINTS WHICH MAY BE OUTPUT IN THE GRID-POINT FORCE
C     BALANCE.
C
C     (NULL ENTRIES ARE NOT OUTPUT)
C
C     AFTER ALL ENTRIES FOR PG AND QG DESIRED HAVE BEEN WRITTEN TO
C     SCRT4 THEY ARE BROUGHT BACK INTO CORE, SORTED ON EXTERNAL GP ID
C     AND RE-OUTPUT TO SCRT4.
C
      FILE = SCRT4
      CALL OPEN (*1760,SCRT4,Z(BUF1),WRTREW)
C
C     PROCESS PG.
C
      UGPGQG = PG
      BUF(2) = 0
      BUF(3) = OLOAD(1)
      BUF(4) = OLOAD(2)
      LASTID = 0
      NEXTGP = 1
      ASSIGN 1300 TO ICONT
      GO TO 1400
C
C     PROCESS QG
C
 1300 UGPGQG = QG
      BUF(3) = OSPCF(1)
      BUF(4) = OSPCF(2)
      LASTID = 0
      NEXTGP = 1
      ASSIGN 1310 TO ICONT
      GO TO 1400
C
C     SORT SCRT4 ENTRIES ON EXTERNAL GP ID
C
 1310 CALL WRITE (SCRT4,0,0,EOR)
      CALL CLOSE (SCRT4,CLSREW)
      MOVEPQ = 0
      CALL OPEN (*1760,SCRT4,Z(BUF1),RDREW)
      CALL READ (*1770,*1330,SCRT4,Z(ICC),BUF1-ICC,NOEOR,IWORDS)
      WRITE  (OUTPT,1320) UWM,SUBCAS
 1320 FORMAT (A25,' 2353.  INSUFFICIENT CORE TO HOLD ALL NON-ZERO APP-',
     1       'LOAD AND F-OF-SPC OUTPUT LINE ENTRIES OF', /5X,
     2       'GRID-POINT-FORCE-BALANCE REQUESTS. SOME POINTS REQUESTED',
     3       ' FOR OUTPUT WILL BE MISSING THEIR APP-LOAD OR F-OF-SPC',
     4       /5X,'CONTRIBUTION IN THE PRINTED BALANCE.')
      IWORDS = BUF1 - ICC - MOD(BUF1-ICC,10)
 1330 CALL SORT  (0,0,10,1,Z(ICC),IWORDS)
      CALL CLOSE (SCRT4,CLSREW)
      CALL OPEN  (*1760,SCRT4,Z(BUF1),WRTREW)
      CALL WRITE (SCRT4,Z(ICC),IWORDS,EOR)
      CALL CLOSE (SCRT4,CLSREW)
      GO TO 1560
C
C     INTERNAL ROUTINE TO GET A VECTOR IN CORE (PG OR QG) AND WRITE
C     SELECTED NON-ZERO ENTRIES TO SCRT4 FOR INCLUSION LATER IN THE
C     GRID-POINT-FORCE-BALANCE.
C
 1400 CALL OPEN (*1550,UGPGQG,Z(BUF2),RD)
      IF (MOVEPQ) 1410,1450,1430
C
C     BACK POSITION DATA BLOCK
C
 1410 J = IABS(MOVEPQ)
      DO 1420 I = 1,J
      CALL BCKREC (UGPGQG)
 1420 CONTINUE
      GO TO 1450
C
C     FORWARD POSITION DATA BLOCK
C
 1430 FILE = UGPGQG
      DO 1440 I = 1,MOVEPQ
      CALL FWDREC (*1770,UGPGQG)
 1440 CONTINUE
C
C     GET VECTOR INTO CORE.
C
 1450 ASSIGN 1460 TO IRETRN
      GO TO 220
C
C     OUTPUT NON-ZERO ENTRIES REQUESTED
C
 1460 CALL CLOSE (UGPGQG,CLS)
      DO 1540 I = ISILEX,NSILEX,2
      ICODE = MOD(Z(I),10)
      I1 = IVECZ + Z(I+1)
      I2 = I1 + SCALE(ICODE)
      DO 1470 J = I1,I2
      IF (RZ(J)) 1480,1470,1480
 1470 CONTINUE
      GO TO 1540
C
C     NON-ZERO ENTRY.  CHECK FOR OUTPUT.
C
 1480 BUF(1) = Z(I)/10
      IBUF1  = BUF(1)
      IF (AXIC) IBUF1 = MOD(IBUF1,1000000)
      IF (AXIF) IBUF1 = MOD(IBUF1,500000 )
      IF (IBUF1 .LT. LASTID) NEXTGP = 1
      LASTID = IBUF1
      IF (GPSET) 1500,1550,1490
 1490 CALL SETFND (*1540,Z(IGPLST),LGPLST,IBUF1,NEXTGP)
 1500 L = 5
      DO 1510 J = I1,I2
      BUF(L) = Z(J)
      L = L + 1
 1510 CONTINUE
      IF (L .GE. 11) GO TO 1530
      DO 1520 J = L,10
      RBUF(L) = 0.0
 1520 CONTINUE
 1530 BUF(1) = BUF(1)*10 + GPDVIS
      CALL WRITE (SCRT4,BUF,10,NOEOR)
 1540 CONTINUE
 1550 GO TO ICONT, (1300,1310)
 1560 CONTINUE
C
C     FINAL OUTPUT PHASE FOR CURRENT CASE CONTROL.
C
C     THE -GPFBOM- COMPANION FILE IS PROCESSED RECORD BY RECORD.
C
C     FOR EACH RECORD THEN,
C
C     1) A 3-WORD ENTRY IS READ GIVING 1) EXTERNAL GP-ID
C                                      2) GINO-LOC OF -GPFBOM- RECORD
C                                      3) OUTPUT ORDER WITHIN THE GROUP.
C
C     2) -GPFBOM- IS POSITIONED USING THE GINO-LOC.
C
C     3) A POINTER IS DETERMINED INTO TABLE-2 OF WHERE OUTPUTS BELONG
C        =10*ORDER - 10  (A ZERO POINTER) + TABLE BASE (A ZERO POINTER)
C
C     4) ENTRIES ARE READ FROM -GPFBOM- CONTAINING,
C
C                                      1) EXTERNAL ELEMENT ID
C                                      2) ELEMENT NAME FIRST 4H
C                                      3) ELEMENT NAME LAST  4H
C                                      4) GINO LOC TO 6X1 FORCE VECTOR
C
C        UNTIL AN EOR IS ENCOUNTERED.
C
C        FOR EACH ENTRY READ A 2-WORD ENTRY IS ADDED TO TABLE-1
C        CONSISTING OF                 1) GINO-LOC TO THE 6X1 VECTOR
C                                      2) PTR INTO TABLE-2
C
C        AND A 10-WORD ENTRY IS ADDED TO TABLE-2 AT Z(PTR)
C        CONSISTING OF                 1) EXTERNAL GP-ID
C                                      2) EXTERNAL ELEMENT-ID
C                                      3) NAME FIRST 4H
C                                      4) NAME LAST  4H
C                                      5 THRU 10)   NOT SET YET.
C
C     5) WHEN ALL ENTRIES OF THE -GPFBOM- RECORDS OF THE GROUP
C        (AS SPECIFIED BY ONE RECORD ON THE COMPANINON FILE) ARE IN CORE
C        TABLE-1 IS SORTED ON GINO LOCS.
C        THIS WILL PREVENT HAVING TO MAKE MORE THAN ONE PASS
C        OF THE PMAT DATA PER GROUP.
C
C     6) A SERIAL PASS OF TABLE-1 IS MADE AND EACH 6X1 VECTOR IS
C        READ DIRECTLY INTO Z(PTR+4) OF TABLE-2.
C
C     7) OUTPUT TO THE FORCE BALANCE DATA BLOCK IS MADE WITH THE
C        STANDARD OFP METHOD OF HEADER RECORD, AND REPEATING ENTRY DATA
C        RECORD.  A HEADER RECORD WILL BE OUTPUT EACH TIME THE GRID
C        POINT CHANGES.
C
C
C     ALLOCATE TABLE-1 AND TABLE-2
C
      ITAB1 = NCC + 1
      NTAB1 = NCC + 2*ENTRYS
      ITAB2 = NTAB1 + 1
C
C     OPEN -GPFBOM- (SCRT2) AND ITS COMPANION DICTIONARY FILE (SCRT3).
C
      FILE   = SCRT2
      NERROR = 23
      CALL OPEN (*1760,SCRT2,Z(BUF2),RDREW)
      FILE = SCRT3
      CALL OPEN (*1760,SCRT3,Z(BUF3),RDREW)
C
C     OPEN THE OUTPUT FILE FOR GP-FORCES.
C
      FILE = OGPF1
      CALL OPEN (*1760,OGPF1,Z(BUF4),WRT)
      LINES    = 0
      IDREC(1) = 10*BRANCH + GPDVIS
      IDREC(2) = 19
      IDREC(4) = SUBCAS
      IDREC(10)= 10
C
C     OPEN THE PMAT 6X1 FORCE VECTORS FILE.
C
      FILE = SCRT1
      CALL OPEN (*1760,SCRT1,Z(BUF1),RDREW)
C
C     INITIALIZE INPUT OF APP-LOAD AND F-OF-SPC LINE ENTRIES FROM SCRT4.
C
      FILE = SCRT4
      CALL OPEN (*1760,SCRT4,Z(BUF5),RDREW)
      CALL READ (*1770,*1570,SCRT4,KVEC,10,NOEOR,IWORDS)
      EORST4 = .FALSE.
      GO TO 1580
 1570 EORST4 = .TRUE.
 1580 CONTINUE
C
C     PROCESS ONE GROUP OF -GPFBOM- RECORDS AS SPECIFIED BY THE 3-WORD
C     ENTRIES OF ONE RECORD ON SCRT3.
C
      ANY   = .FALSE.
      OLDID = 0
      CALL WRITE (OGPF1,IDREC,146,EOR)
 1590 IPTR1 = ITAB1 - 1
      JTAB1 = ITAB1 - 1
      JTAB2 = ITAB2 - 1
      FILE  = SCRT2
 1600 CALL READ (*1740,*1620,SCRT3,BUF,3,NOEOR,IWORDS)
      EXTGP = BUF(1)
      LOC   = BUF(2)
      IPTR2 = ITAB2 + 10*BUF(3) - 11
C
C     POSITION -GPFBOM- TO RECORD OF 4-WORD ENTRIES FOR THIS EXTERNAL GP
C
      CALL FILPOS (SCRT2,LOC)
      NERROR = 24
C
C     READ AND DISTRIBUTE THE DATA OF THE 4-WORD ENTRIES.
C
 1610 CALL READ (*1770,*1600,SCRT2,BUF,4,NOEOR,IWORDS)
      Z(IPTR1+1) = BUF(4)
      Z(IPTR1+2) = IPTR2
      Z(IPTR2+1) = EXTGP
      Z(IPTR2+2) = BUF(1)
      Z(IPTR2+3) = BUF(2)
      Z(IPTR2+4) = BUF(3)
      IPTR1 = IPTR1 + 2
      IPTR2 = IPTR2 + 10
      JTAB1 = JTAB1 + 2
      JTAB2 = JTAB2 + 10
      GO TO 1610
C
C     HERE ON END OF A GROUP.  SORT TABLE-1 ON GINO LOCS.
C     AND FILL TABLE-2 WITH 6X1 FORCE VECTORS.
C
 1620 CALL SORT (0,0,2,1,Z(ITAB1),JTAB1-ITAB1+1)
C
      NERROR= 25
      FILE  = SCRT1
      DO 1630 I = ITAB1,JTAB1,2
      CALL FILPOS (SCRT1,Z(I))
      PTR = Z(I+1)
      CALL READ (*1770,*1780,SCRT1,Z(PTR+5),6,NOEOR,IWORDS)
 1630 CONTINUE
C
C     OUTPUT DATA.  START NEW SUM WHEN ENCOUNTERING A NEW GP-ID.
C     APPLIED-LOADS AND FORCES-OF-SPC WILL INITIALIZE SUM, IF THEY EXIST
C     FOR GRID POINT IN QUESTION,  OHTERWISE SUM IS INITIALIZED TO ZERO.
C
      DO 1730 I = ITAB2,JTAB2,10
C
C     IS THIS SAME GRID POINT ID AS CURRENTLY BEING SUMMED.  IF SO,
C     CONTINUE OUTPUT OF LINE ENTRY AND SUM IN.  OTHERWISE OUTPUT
C     SUM LINE, AND NEW ID-S APPLIED-LOAD AND F-OF-SPC ENTRY.
C
 1640 IF (Z(I) .EQ. OLDID) GO TO 1710
C
C     CHANGE IN GRID POINT ID.
C
      ISUM(1) = OLDID*10 + GPDVIS
      IF (ANY) CALL WRITE (OGPF1,ISUM,10,NOEOR)
      IF (ANY) LINES = LINES + 1
      ANY = .FALSE.
C
C     OUTPUT ALL LINE ENTRIES OF APP-LOADS AND F-OF-SPC UNTIL
C     MATCH ON NEW ID IS FOUND OR CURRENT FVEC IS NOT YET NEEDED.
C
      IF (EORST4) GO TO 1690
      IF (KVEC(1)/10 .GT. Z(I)) GO TO 1690
      DO 1650 J = 5,10
      RSUM(J) = FVEC(J)
 1650 CONTINUE
      OLDID = KVEC(1)/10
      CALL WRITE (OGPF1,KVEC,10,NOEOR)
      LINES = LINES + 1
      ANY   = .TRUE.
C
C     SUM IN ANY MORE FROM SCRT4 OF CURRENT ID, OUTPUT LINE ENTRIES.
C
 1660 CALL READ (*1770,*1680,SCRT4,KVEC,10,NOEOR,IWORDS)
      IF (KVEC(1)/10 .NE. OLDID) GO TO 1640
      CALL WRITE (OGPF1,KVEC,10,NOEOR)
      LINES = LINES + 1
      DO 1670 J = 5,10
      RSUM(J) = RSUM(J) + FVEC(J)
 1670 CONTINUE
      GO TO 1660
C
 1680 EORST4 = .TRUE.
      GO TO 1640
C
C     NO APP-LOAD OR F-OF-SPC ENTRIES LEFT OR CURRENT ONE NOT NEEDED YET
C
 1690 DO 1700 J = 5,10
      RSUM(J) = 0.0
 1700 CONTINUE
      ANY  = .TRUE.
      OLDID= Z(I)
C
 1710 Z(I) = 10*Z(I) + GPDVIS
      CALL WRITE (OGPF1,Z(I),10,NOEOR)
      LINES = LINES + 1
      DO 1720 J = 5,10
      RSUM(J) = RSUM(J) + RZ(I+J-1)
 1720 CONTINUE
C
 1730 CONTINUE
C
      ISUM(1) = OLDID*10 + GPDVIS
      IF (ANY) CALL WRITE (OGPF1,ISUM,10,NOEOR)
      IF (ANY) LINES = LINES + 1
      ANY = .FALSE.
C
C     GO FOR NEXT GROUP FROM THE -GPFBOM-.
C
      GO TO 1590
C
C     HERE ON EOF ON -GPFBOM- COMPANION FILE.  THUS AT CONCLUSION OF
C     OUTPUT PHASE FOR GP-FORCE BALANCE ONE SUBCASE, OR ONE TIME STEP OF
C     ONE SUBCASE.
C
 1740 CALL CLOSE (SCRT1,CLSREW)
      CALL CLOSE (SCRT2,CLSREW)
      CALL CLOSE (SCRT3,CLSREW)
      CALL CLOSE (SCRT4,CLSREW)
      MCB(1) = OGPF1
      CALL RDTRL (MCB)
      MCB(2) = MCB(2) + LINES
      CALL WRTTRL (MCB)
      CALL CLOSE (OGPF1,CLSEOF)
      GO TO 110
C
C     NORMAL COMPLETION.
C
 1750 CALL CLOSE (CASECC,CLSREW)
      CALL CLOSE (UG,CLSREW)
      RETURN
C
C     HERE ON ERROR CONDITIONS.
C
 1760 MM = 1
      GO TO 1790
 1770 MM = 2
      GO TO 1790
 1780 MM = 3
 1790 CALL MESAGE (MM,FILE,SUBR)
      GO TO 1810
 1800 CALL MESAGE (8,0,SUBR)
 1810 WRITE  (OUTPT,1820) SWM,NERROR
 1820 FORMAT (A27,' 2354.' ,/5X,'GPFDR MODULE IS UNABLE TO CONTINUE ',
     1       'AND HAS BEEN TERMINATED DUE TO ERROR MESSAGE PRINTED ',
     2       'ABOVE OR BELOW THIS MESSAGE.', /5X,'THIS ERROR OCCURRED ',
     4       'IN GPFDR CODE WHERE THE VARIABLE -NERROR- WAS SET =',I5)
      DO 1840 I = 100,300,100
      DO 1830 J = 1,9
      CALL CLOSE (I+J,CLSREW)
 1830 CONTINUE
 1840 CONTINUE
      RETURN
      END

      SUBROUTINE WRTMSG (FILEX)
C
      EXTERNAL        LSHIFT,RSHIFT,ANDF,ORF,COMPLF
      INTEGER         FILE,FILEX,TITLE,TTLSAV(32,6),COUNT,LST(50),
     1                FOR(100),RET,EJECT,REW,BLANK,FORMAX,MASK1(5),
     2                MASK2(5),POS,ANDF,ORF,RSHIFT,COMPLF,SYSX
CWKBI
      CHARACTER*1     FORMT(400)
      COMMON /OUTPUT/ TITLE(32,6)
      COMMON /MACHIN/ MACH
      COMMON /SYSTEM/ SYSX(41)
CWKBI
      EQUIVALENCE     (FORMT, FOR)
      EQUIVALENCE  (XLST,LST)
      EQUIVALENCE     (SYSX( 2),MO   ), (SYSX( 9),MAXLIN),
     1                (SYSX(12),COUNT), (SYSX(39),NBPC  ),
     2                (SYSX(40),NBPW ), (SYSX(41),NCPW  )
      DATA    LSTMAX, REW,FORMAX,BLANK/ 50,1,100,4H     /
C
      N2CPW  = NCPW/2
      N2CPW1 = N2CPW - 1
      NBPC2  = 2*NBPC
      MASK1(1) = RSHIFT(COMPLF(0),NBPC2)
      MASK2(1) = COMPLF(MASK1(1))
      DO 10 I  = 2,N2CPW
      MASK1(I) = ORF(MASK2(1),RSHIFT(MASK1(I-1),NBPC2))
      MASK2(I) = COMPLF(MASK1(I))
   10 CONTINUE
      FILE = FILEX
C
      DO 20 J = 1,6
      DO 20 I = 1,32
      TTLSAV(I,J) = TITLE(I,J)
   20 CONTINUE
C
   30 COUNT = MAXLIN
   40 CALL READ (*500,*30,FILE,N,1,0,NF)
      IF (N) 100,130,110
C
C     A TITLE OR SUBTITLE FOLLOWS.
C
  100 N = -N
      IF (N .LE. 6) CALL FREAD (FILE,TITLE(1,N),32,0)
      IF (N .GT. 6) CALL FREAD (FILE,0,-32,0)
      GO TO 30
C
C     A MESSAGE FOLLOWS...N = NUMBER OF LIST ITEMS.
C
  110 IF (N .LE. LSTMAX) GO TO 120
      CALL FREAD (FILE,0,-N,0)
      GO TO 130
  120 IF (N .NE. 0) CALL FREAD (FILE,LST,N,0)
C
C     READ THE CORRESPONDING FORMAT...NF = SIZE OF THE FORMAT.
C
  130 CALL FREAD (FILE,NF,1,0)
      IF (NF) 140,150,160
  140 COUNT = COUNT - NF
      GO TO 130
  150 COUNT = MAXLIN
      GO TO 130
  160 IF (NF .LE. FORMAX) GO TO 170
      CALL FREAD (FILE,0,-NF,0)
      GO TO 30
  170 CALL FREAD (FILE,FOR,NF,0)
C
C     CONDENSE FOR ARRAY TO ACQUIRE CONTIGUOUS HOLLERITH STRINGS.
C
      IF (NCPW .EQ. 4) GO TO 300
      DO 290 I = 2,NF
      K1 = 1
      POS= 2*I - 1
      J  = (POS+N2CPW1)/N2CPW
      K2 = POS - N2CPW*(J-1)
      ASSIGN 200 TO RET
      GO TO 240
  200 CONTINUE
      K1 = 2
      IF (K2+1 .LE. N2CPW) GO TO 210
      K2 = 1
      J  = J + 1
      GO TO 220
  210 K2 = K2 + 1
  220 CONTINUE
      ASSIGN 230 TO RET
      GO TO 240
  230 CONTINUE
      GO TO 290
  240 IF (K2-K1) 250,260,270
  250 FOR(J) = ORF(ANDF(FOR(J),MASK1(K2)),
     1         LSHIFT(ANDF(FOR(I),MASK2(K1)),(NBPC2*(K1-K2))))
      GO TO 280
  260 FOR(J) = ORF(ANDF(FOR(J),MASK1(K2)),ANDF(FOR(I),MASK2(K1)))
      GO TO 280
  270 FOR(J) = ORF(ANDF(FOR(J),MASK1(K2)),
     1         RSHIFT(ANDF(FOR(I),MASK2(K1)),(NBPC2*(K2-K1))))
      GO TO 280
  280 CONTINUE
      GO TO RET, (200,230)
  290 CONTINUE
  300 CONTINUE
C
C     PRINT THE LINE
C
      IF (EJECT(1) .EQ. 0) GO TO 450
      DO 440 J = 4,6
      DO 410 I = 1,32
      IF (TITLE(I,J) .NE. BLANK) GO TO 420
  410 CONTINUE
      COUNT = COUNT - 1
      GO TO 440
  420 WRITE  (MO,430) (TITLE(I,J),I=1,32)
  430 FORMAT (2X,32A4)
  440 CONTINUE
      WRITE  (MO,430)
      COUNT = COUNT + 1
C
  450 IF(N.EQ.0 .AND. (MACH.EQ.5 .OR. MACH.EQ.12) )GO TO 470
      IF (MACH .EQ. 5 .OR. MACH .EQ. 12 ) GO TO 460
      CALL FORWRT ( FORMT, LST, N )
      GO TO 40
  460 WRITE (MO,FOR,ERR=465) (LST(J),J=1,N)
  465 CONTINUE
      GO TO 40
  470 WRITE (MO,FOR)
      GO TO 40
C
C     END OF MESSAGE FILE
C
  500 CALL CLOSE (FILE,REW)
      DO 510 J = 1,6
      DO 510 I = 1,32
      TITLE(I,J) = TTLSAV(I,J)
  510 CONTINUE
      RETURN
      END

      BLOCK DATA SEMDBD
CSEMDBD
C
C     *****  PRINCIPAL BLOCK DATA PROGRAM FOR NASTRAN  *****
C     (NOTE - MACHINE DEPENDENT CONSTANTS ARE INITIALIZED IN BTSTRP)
C
C     REVISED 7/91 BY G.CHAN/UNISYS
C     MAKE SURE THERE IS NO VARIABLES OR ARRAYS NOT INITIALIZED. GAPS
C     OR MISSING INITIALIZED DATA MAY CAUSE PROBLEMS IN SOME MACHINES.
C
      IMPLICIT INTEGER (A-Z)
      LOGICAL     BITPAS, FIRST,  NOTYET, OPNSOF, PASS,  PCT,  STAR
      INTEGER     KSYSTM(100)
      REAL        OSCAR,  OTAPID, TAPID , TIMDTA, TIME,  TOLEL,X
      CHARACTER   UFM*23, UWM*25, UIM*29, SFM*25, SWM*27, SIM*31
      EQUIVALENCE (KSYSTM(1),SYSBUF)
C
C
C     -------------------     /GINOX  /     ----------------------------
C
C     GINOX WORDS USED IN GINO
C     VAX AND UNIX USE 636 WORDS (SEE GINO.MDS)
CDC   CDC USES ONLY 244 WORDS (SEE CDC IO6600). CDC IS CORE THIRSTY AND
CDC   THE 392 WORDS IN OTHERS HERE, AND ON THE DATA LINE BELOW, CAN BE
CDC   COMMENTED OUT TO SAVE CORE SPACE FOR THE CDC MACHINE.
C
      COMMON /GINOX /    CDC(244)
     1,               OTHERS(392)
C            --------------------
C                     TOTAL= 636
C
C     -------------------     /XMSSG  /     ----------------------------
C
C     USER FATAL/WARNING/INFO AND SYSTEM FATAL/WARNING/INFO MESSAGES
C
      COMMON /XMSSG / UFM, UWM, UIM, SFM, SWM, SIM
C
C     -------------------     /NUMTPX /     ----------------------------
C
C     BCD-LOOK ALIKE FLOATING NUMBERS, USED ONLY BY NUMTYP SUBROUTINE.
C     DATA WILL BE LOADED FROM NASINFO.DOC FILE BY NSINFO
C
      COMMON /NUMTPX/ NBCD, BCD(19)
C
C     -------------------     / BLANK  /     ---------------------------
C
CWKBR COMMON /BLANK / IBLNK(60)
      COMMON /BLANK / IBLNK(100)
C
C     -------------------     / NTIME  /     ---------------------------
C
C     THE NTIME COMMON BLOCK CONTAINS TIMING CONSTANT DATA FOR THE
C     CURRENTLY RUNNING MACHINE CONFIGURATION AS DETERMINED BY THE
C     TMTSIO AND TMTSLP SUBROUTINES
C
      COMMON /NTIME / LNTIME, TIMDTA(23)
C
C     -------------------     / XLINK  /     ---------------------------
C
C     SPECIFIES MODULE LINK RESIDENCE, AND PROVIDES LINK SWITCHING
C     INFORMATION FOR LINK DRIVER SUBROUTINES, XSEMi.
C     LXLINK = NUMBER OF WORDS IN MXLINK.
C     MAXLNK = MAX NUMBER OF LINKS - SEE XGPIBS IF THIS NUMBER IS
C              INCREASED.
C     MXLINK = MODULE LINK SPECIFICATION TABLE - THIS TABLE IS
C              INITIALIZED BY SUBROUTINE XGPIBS.
C
      COMMON /XLINK / LXLINK, MAXLNK, MXLINK(220)
C
C     -------------------     / SEM    /     ---------------------------
C
C     SEM DEFINES DATA FOR THE LINK DRIVERS (XSEMI).
C     MASK   = OSCAR MASK
C     MASK2,MASK3 =  OSCAR MASKS (MACHINE DEPENDENT).
C     NAME   = ARRAY OF LINK NAMES
C
CWKBR COMMON /SEM   / MASK, MASK2, MASK3, NAME(15)
      COMMON /SEM   / MASK, MASK2, MASK3, NAME(30)
C
C     -------------------     / SYSTEM /     ---------------------------
C
C     SYSTEM DEFINES VARIOUS MACHINE DEPENDENT, OPERATING SYSTEM AND
C     NASTRAN PARAMETERS.
C   1-
C     SYSBUF = (MACHINE DEPENDENT) NO. OF WORDS IN A GINO BUFFER.
C     OUTTAP = (MACHINE DEPENDENT) FORTRAN LOGICAL UNIT NO. FOR SYSTEM
C              PRINT OUTPUT
C     NOGO   = FLAG DEFINING EXECUTION STATUS DURING -FRONT END-.
C     INTP   = (MACHINE DEPENDENT) FORTRAN LOGICAL UNIT NO. FOR SYSTEM
C              INPUT
C     MPC    = MULTI-POINT CONSTRAINT SET ID  FOR CURRENT SUBCASE.
C     SPC    = SINGLE-POINT CONSTRAINT SET ID  FOR CURRENT SUBCASE.
C     LOGFL  = CONSOLE/LOGFILE MESSAGE CONTROL.
C     LOAD   = POINTER TO FIRST RECORD IN CASE CONTROL DATA BLOCK
C              FOR CURRENT SUBCASE.
C     NLPP   = (MACHINE DEPENDENT) NUMBER OF LINES PER PAGE OF PRINTED
C              OUTPUT.
C     MTEMP  = MATERIAL TEMPERATURE SET ID.
C  11-
C     NPAGES = CURRENT  PAGE COUNT.
C     NLINES = CURRENT NUMBER OF LINES ON CURRENT PAGE.
C     TLINES = TOTAL NUMBER OF LINES PRINTED IN JOB.
C     MXLINS = MAXIMUM NO. OF LINES OF PRINTED OUTPUT FOR THE PROBLEM.
C     DATE   = TODAY-S DATE, INTEGERS, 2 DIGITS EACH
C      (3)
C     TIMEZ  = CPU TIME IN SECONDS, WHEN PROBLEM BEGAN. NOT NECESSARY
C              ZERO. TIMEZ IS USED IN TMTOGO
C     ECHOF  = NUMBER INDICATING FORM OF BULK DATA ECHO.
C     PLOTF  = FLAG INDICATING REQUEST FOR STRUCTURAL PLOTS (NON-ZERO=
C              PLOT, SEE PLOTOPT IN SUBROUTINE NASCAR FOR MORE DETAILS)
C  21-
C     APPRCH = APPROACH FLAG (1 = FORCE, 2 = DISPL , 3 = DMAP).
C              APPRCH .LT. 0 MEANS THIS IS A RESTART.
C     LINKNO = CURRENT LINK NO. (IN BCD, E.G. NSXX)  INITIALLY SET TO
C              NS01 IN SUBROUTINE BTSTRP.  SUBSEQUENTLY SET TO THE
C              CORRECT LINK NO. IN SUBROUTINE ENDSYS.
C            = WAS THE MACHINE TYPE, MACH (LEVEL 17 AND EALIDER VERSION)
C     LSYSTM = LENGTH OF SYSTEM COMMON BLOCK.
C     ICFIAT = REPLACING EDTUMF FLAG HERE, WHICH IS NO LONGER USED.
C    (EDTUMF)  ICFIAT IS THE NUMBER OF WORDS PER FIAT ENTRY.
C            . IF ICFIAT=8, DATA BLOCK GINO TRAILER 6 WORDS ARE PACKED
C              INTO 4TH, 5TH, AND 6TH WORDS OF EACH FIAT ENTRY.
C            . IF ICFIAT=11, NO PACKING IN FIAT ENTRY, AND THE TRAILER 6
C              WORDS ARE SAVED IN 4TH THRU 6TH, AND 9TH THRU 11TH WORDS.
C              THE TRAILER WORDS ARE THEREFORE NOT BOUNDED BY SIZE
C              LIMITATION OF 65535 (HALF OF A 32-BIT WORD).
C            . THE FIAT POINTERS IN /XFIST/ MUST BE IN COMPLETE AGREE-
C              MENT WITH THE SELECTION OF ICFIAT=8, OR ICFIAT=11.
C              (SEE THE DATA SETTING OF /XFIST/ BELOW)
C            . THE REST OF NASTRAN .MIS ROUTINES ARE CODED TO HANDLE
C              ICFIAT=8 OR 11 AUTOMATICALLY. THE .MDS ROUTINES ARE NOT
C              AFFECTED SINCE THE 7TH AND 8TH WORDS OF THE FIAT ENTRY
C              REMAIN UNCHANGED.
C            = WAS EDTUMF FLAG, USED IN PRE-1987 NASTRAN VERSION
C     RFFLAG = RIGID FORMAT FLAG
C     CPPGCT = PAGE COUNT USED BY XCHK ROUTINE
C     MN     = NUMBER OF RINGS/NUMBER OF HARMONICS FOR AXISYMMETRIC
C              SHELL.
C     DUMMYI = (UNUSED WORD)
C     MAXFIL = MAXIMUM NUMBER OF UNITS TO BE ALLOCATED TO FIAT.
C     MAXOPN = MAXIMUM NUMBER OF FILES OPEN AT ONE TIME.
C  31-
C     HICORE = HI-CORE LENGTH FOR UNIVAC AND VAX
C     TIMEW  = PROBLEM START TIME (INTEGR SECONDS AFTER MIDNITE)
C     OFPFLG = OFP OPERATE FLAG - SET NON-ZERO WHEN OFP OPERATES
C     NBRCBU = (CDC ONLY) LENGTH OF FET + DUMMY INDEX
C              UNIVAC DRUM FILE ALLOCATION (1 FOR POSITION, 2 FOR TRACK)
C     LPRUS  = (CDC ONLY) NUMBER OF WORDS PER PHYSICAL RECORD UNIT (PRU)
C     NPRUS  = (CDC ONLY) NUMBER OF PRU-S PER GINO RECORD BLOCK
C     KSYS37 = ERROR CONTROL WORD, USED LOCALLY BY QPARMD AND QPARMR.
C              ALSO USED LOCALLY IN LINK1 FOR NASINFO FILE UNIT NO.
C     QQ     = HYDROELASTIC PROBLEM FLAG.
C     NBPC   = (MACHINE DEPENDENT) NO. OF BITS PER CHARACTER.
C     NBPW   = (MACHINE DEPENDENT) NO. OF BITS PER WORD.
C  41-
C     NCPW   = (MACHINE DEPENDENT) NO. OF CHARACTERS PER WORDS.
C     SYSDAT = THREE BCD WORD ARRAY CONTAINING MONTH, ' 19', AND LAST
C      (3)     TWO DIGITS OF YEAR OF SYSTEM GENERATION DATE.
C              THESE CELLS ARE SET BY SUBROUTINE NASCAR.
C     TAPFLG = WORD SET BY NASTRAN CARD TO INDICATE FILES TO BE TAPES
C              WHETHER OR NOT THEY ARE ON DISK.  BITS TURNED ON COUNTING
C              FROM RIGHT REPRESENT THE FILES IN XXFIAT.
C     ADUMEL = NINE WORD ARRAY CONTAINING DATA EXTRACTED FROM THE ADUM-I
C      (9)     CARDS BY IFP.
C  55-
C     IPREC  = PRECISION FLAG, 1=SP, 2=DP.
C     ITHRML = THERMAL ANALYSIS FLAG,  0=STRUCTURAL ANALYSIS,
C                                      1=THERMAL ANALYSIS.
C     MODCOM = NINE WORD ARRAY FOR MODULE COMMUNICATIONS.
C      (9)     SYSTEM(58), PRE-SELECT METHOD FOR MPYAD (1,2,3,DEFAULT=0)
C              SYSTEM(59), PLOT TAPE TRACK SIZE
C  66-
C     HDY    = THREE WORD ARRAY ALA SEW
C      (3)
C     SSCELL = MULTILEVEL SUBSTRUCTURE ANALYSIS COMMUNICATION CELL.
C     TOLEL  = SINGULARITY TOLERANCE FOR SMA1,EMG. RESET BY NASCAR.
C  71-
C     MESDAY = DAYFILE MESSAGE FLAG
C     BITPAS = CDC TAPE PROCESSING BIT - FALSE FOR LINK1 ONLY
C     PASS   = CDC MESSAGE AND TIMING FLAG - FALSE FOR LINK1 ONLY
C     ITIME  = WAS: WALL TIME ELAPSED SINCE PROBLEM START (SECONDS)
C            = IS : PROBLEM START TIME IN SECONDS SINCE JAN-1-1970,
C                   GREENWICH-MEAN-TIME (GMT)
C     CTIME  = WAS: CENTRAL PROCESSOR TIME SINCE PROBLEM START (SECONDS)
C            = IS : PRINT FLAG FOR DMAP SEQUENCE NO. AND NAME, ALL LINKS
C                   (SEE NASTRN OR NAST01.MDS)
C     NOSBE  = (CDC ONLY) FLAG FOR NOS(0) OR NOSBE(1)
C     BANDIT = BANDIT OPTION FLAG (SEE BANDIT FOR MORE DETAILS)
C     PZEL   = PIEZOELECTRIC PROBLEM FLAG (INPUT VIA NASTRAN SYSTEM(78))
C     SWITCH = SENSE SWITCH BITS FOR DIAG CARD AND USED BY SSWTCH
C      (3)
C  82-
C     ICPFLG = CHECKPOINT FLAG (0 = NO CHECKPOINT, 1 = CHECKPOINT)
C     JRUN   = JRUN FOR VARIAN  (HEAT PROBLEM)
C     JMAX   = JMAX FOR VARIAN  (HEAT PROBLEM)
C     LINTC  = MAX. ALLOWABLE LINES OF INTERSECTION USED IN HDPLOT
C     INTRA  = INTERACTIVE REQUEST FLAG FOR PLOT, OUTPUT, AND SCAN
C              (0=NONE, 1=PLOT ONLY, 2=OUTPUT PRINT AND SCAN ONLY,
C               3=BOTH)
C     OSPCNT = BAR OFFSET WARNING MESSAGE IF OFFSET BAR LENGTH EXCEEDS
C              NON-OFFEST LENGTH BY THIS LIMIT (DEFAULT IS 15 PERCENT)
C     K88 90 = 3 WORDS RESERVED FOR USER. WILL NOT BE USED BY COSMIC
C              =========================
C  91-
C     LPCH   = (MACHINE DEPENDENT) FORTRAN LOGICAL UNIT NO. FOR PUNCH
C     LDICT  = FORTRAN LOGICAL UNIT NO. FOR RESTART DICTIONARY PUNCH
C     IAEROT = INTEGER FLAG INDICATING AERODYNAMIC THEORY
C              (SPECIFIED VIA NASTRAN CARD AND USED ONLY IN APDB MODULE
C              0 FOR COMPRESSOR BLADES, THEORY 6, DEFAULT,
C              1 FOR SWEPT TURBOPROP. BLADES, THEORY 7)
C     KSYS94 = FLAG FOR REMOVALS OF MPYDRI(1), MPY4T(10), NEW FBS(100),
C              TRNSPS(1000), AND NEW FBS IN FEER(10000)
C     SPERLK = NASTRAN SUPERLINK FLAG. SET BY SEMDBD OR NASTRN
C              FOR UNIX MACHINE
C     LEFT   = (85 UNUSED WORDS).  KSYS99 USED IN ERRTRC
C
C
      DIMENSION       DATE(3),SYSDAT(3),ADUMEL(9),MODCOM(9),HDY(3),
     1                SWITCH(3),K88 90(3) ,LEFT(56),LEFT2(28)
      COMMON /SYSTEM/ SYSBUF,OUTTAP,NOGO  ,INTP  ,MPC   ,SPC   ,LOGFL ,
     1                LOAD  ,NLPP  ,MTEMP ,NPAGES,NLINES,TLINES,MXLINS,
     2                DATE  ,TIMEZ ,ECHOF ,PLOTF ,APPRCH,LINKNO,LSYSTM,
     3                ICFIAT,RFFLAG,CPPGCT,MN    ,DUMMYI,MAXFIL,MAXOPN,
     4                HICORE,TIMEW ,OFPFLG,NBRCBU,LPRUS ,NPRUS ,KSYS37,
     5                QQ    ,NBPC  ,NBPW  ,NCPW  ,SYSDAT,TAPFLG,ADUMEL,
     6                IPREC ,ITHRML,MODCOM,HDY   ,SSCELL,TOLEL ,MESDAY,
     7                BITPAS,PASS  ,ITIME ,CTIME ,NOSBE ,BANDIT,PZEL  ,
     8                SWITCH,ICPFLG,JRUN  ,JMAX  ,LINTC ,INTRA ,OSPCNT,
     9    K88 90,LPCH  ,LDICT ,IAEROT,KSYS94,SPERLK,LEFT,LOGLIN,LEFT2
C
C     -------------------     / XFIST  /     ---------------------------
C
C     XFIST IS THE FILE STATUS TABLE (FIST).
C     NFIST  = TOTAL NO. OF ENTRIES IN FIST.
C     LFIST  = NO. OF ENTRIES IN THE CURRENT FIST.
C     FIST   = TABLE OF TWO-WORD ENTRIES.
C              FIRST WORD IS GINO FILE NAME.
C              SECOND WORD POINTS TO XFIAT IF .GT. 0 (I.E. NON-PERMANENT
C              ENTRY), OR POINTS TO XXFIAT IF .LE. 0 (I.E. PERMANENT
C              ENTRY). SIGN BIT MUST BE SET FOR ZERO POINTER ON 7094.
C
      COMMON /XFIST / NFIST, LFIST, FIST(112)
C
C     -------------------     / XPFIST /     ---------------------------
C
C     XPFIST DEFINES THE NO. OF PERMANENT ENTRIES IN THE FIST.
C
      COMMON /XPFIST/ NPFIST
C
C     -------------------     / XXFIAT /     ---------------------------
C
C     XXFIAT IS EXECUTIVE FILE ALLOCATION TABLE.
C
      COMMON /XXFIAT/ XXFIAT(24)
C
C     -------------------     / XFIAT  /     ---------------------------
C
C     XFIAT IS THE MODULE FILE ALLOCATION TABLE (FIAT).
C     MFIAT  = NO. OF UNIQUE FILES IN FIAT.
C     NFIAT  = TOTAL NO. OF ENTRIES IN FIAT.
C     LFIAT  = NO. OF ENTRIES IN CURRENT FIAT.
C     FIAT   = TABLE OF 8 OR 11 WORDS PER ENTRY OF GINO FILES
C              (DEFAULT IS SET BY ICFIAT, THE 24TH WORD OF /SYSTEM/)
C            . 1ST WORD DEFINES THE FILE + PURGE,EQVIV,SETUP,ETC INFO.
C            . 2ND AND 3RD WORDS DEFINE THE DATA BLOCK NAME (IN BCD)
C              WHICH IS ATTACHED TO THE FILE.
C            . SEE ICFIAT (24TH WORD OF /SYSTEM/) FOR THE DESCRIPTION
C              OF 4TH THRU 8TH (OR 11TH) WORDS.
C            . SET FIAT(880) IF 11-WORD/ENTRY TABLE IS USED, AND
C              SET FIAT(640) IF  8-WORD/ENTRY TABLE IS USED
C
CWKBR COMMON /XFIAT / MFIAT, NFIAT, LFIAT, FIAT(880)
      COMMON /XFIAT / MFIAT, NFIAT, LFIAT, FIAT(1100)
C
C     -------------------     / OSCENT /     ---------------------------
C
C     OSCENT DEFINES A STORAGE BLOCK FOR THE CURRENT OSCAR ENTRY.
C
      COMMON /OSCENT/ OSCAR(200)
C
C     -------------------     / OUTPUT /     ---------------------------
C
C     OUTPUT DEFINES A STORAGE BLOCK WHERE PROBLEM TITLE, SUBTITLE
C     AND LABEL ARE STORED.
C
      COMMON /OUTPUT/ OUTPUT(224)
C
C     -------------------     / XDPL   /     ---------------------------
C
C     XDPL DEFINES THE DATA POOL DICTIONARY.
C     MDPL   = POINTER TO NEXT AVAILABLE FILE.
C     NDPL   = TOTAL NO. OF ENTRIES IN DPL.
C     LDPL   = CURRENT NO. OF ENTRIES IN DPL.
C     DPL    = TABLE OF THREE-WORD ENTRIES
C              1ST + 2ND WORDS ARE DATA BLOCK NAME
C              3RD WORD DEFINES EQUIV FLAG, APPROX SIZE OF DATA BLOCK
C              AND FILE NO. IN THE POOL.
C
      COMMON /XDPL  / MDPL, NDPL, LDPL, DPL(240)
C
C     -------------------     / XVPS   /     ---------------------------
C
C     XVPS IS THE VARIABLE PARAMETER STORAGE TABLE.
C     VPS(1) = TOTAL NO. OF WORDS IN VPS.
C     VPS(2) = POINTER TO LAST WORD USED IN VPS.
C     VPS(3) = TABLE FOR STORAGE OF PARAMETERS
C              (VARIABLE NO OF WORDS/ENTRY).
C
      COMMON /XVPS  / VPS(600)
C
C     -------------------     / STAPID /     ---------------------------
C
C     STAPID CONTAINS THE I.D. FOR THE NEW AND OLD PROBLEM TAPES.
C     TAPID  = SIX-WORD I.D. FOR NEW PROBLEM TAPE.
C     OTAPID = SIX-WORD I.D. FOR OLD PROBLEM TAPE.
C     IDUMF  = (OBSOLETE) ID FOR USER-S MASTER FILE.
C
      COMMON /STAPID/ TAPID(6), OTAPID(6), IDUMF
C
C     -------------------     / STIME  /     ---------------------------
C
C     STIME DEFINES USER-S ESTIMATED PROBLEM SOLUTION TIME.
C
      COMMON /STIME / TIME(2)
C
C     -------------------     / XCEITB /     ---------------------------
C
C     XCEITB DEFINES LOOP CONTROL PARAMETERS FOR THE CONTROL ENTRY
C     INTERP.
C     CEI(1) = TOTAL NO. OF WORDS IN TABLE.
C     CEI(2) = POINTER TO LAST WORD USED.
C     CEI(3) = TABLE OF FOUR-WORD ENTRIES.
C
      COMMON /XCEITB/ CEI(42)
C
C     -------------------     / XMDMSK /     ---------------------------
C
C     XMDMSK DEFINES MASK FOR MODIFIED RESTART.
C     NMSKCD = NUMBER OF MASK WORDS FOR CARDS (CURRENTLY SET TO 3)
C     NMSKFL = NUMBER OF MASK WORDS FOR FILES (CURRENTLY SET TO 3)
C     NMSKRF = NUMBER OF MASK WORDS FOR RIGID FORMATS (CURRENTLY 1)
C     MSK    = MASK OF (NMSKCD+NMSKFL+NMSKRF) WORDS (31 BITS/WORD)
C
      COMMON /XMDMSK/ NMSKCD, NMSKFL, NMSKRF, MSK(7)
C
C     -------------------     / MSGX   /     ---------------------------
C
C     MSGX DEFINES A TABLE WHERE MESSAGES ARE QUEUED.
C     NMSG   = NUMBER OF MESSAGES CURRENTLY IN QUEUE.
C     MSGLG  = TOTAL NO. OF ENTRIES IN THE MESSAGE QUEUE.
C     MSG    = TABLE OF FOUR-WORD ENTRIES WHERE MESSAGES ARE STORED.
C
      COMMON /MSGX  / NMSG, MSGLG, MSG(4,40)
C
C     -------------------     / DESCRP /     ---------------------------
C
C     COMMENTS FROM G.CHAN/UNISYS, 7/1991
C     LABEL COMMON /DESCRP/ APPEARS IN THE FOLLOWING SUBROUTINES. BUT
C     IT IS ACTUALLY NEVER USED.
C        SEMDBD, DECOMP, GENVEC, GFBS,   TRANSP, CDCOMP, CTRNSP, INVTR,
C        MTIMSU, MTMSU1, CDIFBS, INTFBS, MATVC2, MATVEC, ORTCK,  CINFBS,
C        CMTIMU, AND INVFBS
C     IN ADDITION, INTPK IN VAX, IBM, CDC AND UNIVAC, DOES NOT USE THIS
C     /DESCRP/ LABEL COMMON.
C     STARTING IN 1992 VERSION, LABEL COMMON /DESCRP/ IS COMPLETELY
C     REMOVED FROM ALL NASTRAN SUBROUTINES.
C
C     DESCRP IS A STORAGE BLOCK USED BY SUBROUTINE INTPK.
C     LENGTH = TOTAL NO. OF WORDS IN BLOCK.
C
C     COMMON /DESCRP/ LENGTH, BLOCK(50)
C
C     -------------------     / TWO    /     ---------------------------
C
C     TWO DEFINES THE BITS IN A 32-BIT COMPUTER WORD (FROM LEFT TO RT).
C     MZERO = WILL BE SET TO -0.0 (= LSHIFT(1,NBPW-1) = SIGN BIT ON) BY
C             BTSTRP, AND WILL BE USED BY NUMTYP
C
      COMMON /TWO   / TWO(32),MZERO
C
C     -------------------     / NAMES  /     ---------------------------
C
C     NAMES DEFINES VALUES FOR GINO FILE OPTIONS,ARITHMETIC TYPES
C     AND MATRIX FORMS.
C
      COMMON /NAMES /RD    ,RDREW ,WRT   ,WRTREW,REW   ,NOREW ,EOFNRW,
     1               RSP   ,RDP   ,CSP   ,CDP   ,SQUARE,RECT  ,DIAG  ,
     2               LOWER ,UPPER ,SYM   ,ROW   ,IDENT
C
C     -------------------     / TYPE   /     ---------------------------
C
C     TYPE DEFINES PROPERTIES AS A FUNCTION OF ARITHMETIC TYPE.
C     PRC    = PRECISION (1=SP, 2=DP).
C     NWDS   = NO. OF WORDS PER ELEMENT.
C     RC     = ARITHMETIC (1=REAL, 2=COMPLEX).
C     X      = PAD TO DEFINE WORK AREA.
C
      COMMON /TYPE  / PRC(2), NWDS(4), RC(4), X(6)
C
C     -------------------     / BITPOS /     ---------------------------
C
C     BITPOS DEFINES THE BIT POSITIONS FOR THE DEGREES-OF-FREEDOM IN
C     USET, AND HOLLERITH CHARACTERS DESCRIBING DEGREES-OF-FREEDOM.
C
      COMMON /BITPOS/ UM  ,UO  ,UR  ,USG ,USB ,UL  ,UA  ,UF  ,US  ,UN  ,
     1                UG  ,UE  ,UP  ,UNE ,UFE ,UD  ,UPS ,USA ,UK  ,UPA ,
     2                U21 ,U22 ,U23 ,UX  ,UY  ,UFR ,UZ  ,UAB ,UI  ,U30 ,
     3                U31 ,U32 ,
     O                HM  ,HO  ,HR  ,HSG ,HSB ,HL  ,HA  ,HF  ,HS  ,HN  ,
     1                HG  ,HE  ,HP  ,HNE ,HFE ,HD  ,HPS ,HSA ,HK  ,HPA ,
     2                H21 ,H22 ,H23 ,HX  ,HY  ,HFR ,HZ  ,HAB ,HI  ,H30 ,
     3                H31 ,H32
C
C     -------------------     / SOFCOM /     ---------------------------
C
C     SOFCOM DEFINES THE NAMES AND SIZES OF THE SOF FILES AND THE STATE
C     OF THE SOF
C     NFILES = NUMBER OF FILES ALLOCATED TO THE SOF (MAX 10)
C     FILNAM = 4 CHAR. BCD NAMES OF THE SOF FILES
C     FILSIZ = SIZES OF THE SOF FILES EXPRESSED IN AN EVEN NUMBER OF
C              BLOCKS
C     STATUS = SOF STATUS.  0 - SOF IS EMPTY.  1 - SOF IS NOT EMPTY.
C     PSSWRD = BCD PASSWORD FOR THE SOF.  EACH RUN USING THE SAME SOF
C              MUST USE THE SAME PASSWORD.
C     FIRST  = .TRUE. IF SOFINT HAS NOT YET BEEN CALLED TO INITIALIZE
C              THE SOF FOR THIS RUN.  OTHERWISE .FALSE.
C     OPNSOF = .TRUE. IF THE SOF IS OPEN.  .FALSE. IF IT IS CLOSED.
C     ASOFCB = ADDRESS OF SOF CONTROL BLOCKS ON IBM 360/370 COMPUTERS
C
      COMMON /SOFCOM/ NFILES, FILNAM(10), FILSIZ(10), STATUS, PSSWRD(2),
     1                FIRST , OPNSOF    , ASOFCB
C
C     --------------------    / XXREAD /     ---------------------------
C
C     INFLAG AND INSAVE ARE USED IN READFILE COMMAND. IRRX USED IN
C     FFREAD
C
      COMMON /XXREAD/ INFLAG, INSAVE, IXXR(3)
C
C     --------------     /XECHOX/ AND /XREADX/     ---------------------
C
C     IECHO      = USED IN FREE-FIELD INPUT FOR INPUT CARD ECHO CONTROL
C     IXSORT,IWASFF,NCARD = USED LOCALLY AMONG XSORT, XREAD, AND FFREAD
C     NOECHO     = USED IN FFREAD AND XCSA ROUTINES
C
C     SCREEN,PROM= LOGICAL UNIT FOR TERMINAL SCREEN AND PROMPT SYMBOL
C     CONTRL NOTYET,STAR,PCT = FREE-FIELD INPUT FLAGS USED IN XREAD
C     LOOP,KOUNT = LOOP COUNT USED IN XREAD
C     ICONT      = 36 CONTROL WORDS USED IN FREE-FILED INPUT NOT TO BE
C                  DESTROYED
C
      COMMON /XECHOX/ IECHO(4), IXSORT, IWASFF, NCARD(3), NOECHO
      COMMON /XREADX/ SCREEN  , LOOP  , KOUNT , PROM    , NOTYET, STAR,
     1                PCT     , ICONT(36)
C
C     --------------     /MACHIN/ AND /LHPWX/     ---------------------
C
C     6 MACHINE CONSTANTS IN /MACHIN/ AND 7 IN /LHPWX/ WILL BE
C     INITIALZED BY BTSTRP. THESE CONSTANTS NEED TO BE SAVED IN THE ROOT
C     LEVEL OF ALL LINKS
C
      COMMON /MACHIN/ MA(6)
      COMMON /LHPWX / LH(7)
C
C
C     ==================================================================
C
C     -------------------     / GINOX  /     ---------------------------
C
      DATA    CDC   / 244*0   /
      DATA    OTHERS/ 392*0   /
C
C     -------------------     / XMSSG  /     ---------------------------
C                               1         2         3
C                      1234567890123456789012345678901
      DATA    UFM   / '0*** USER FATAL MESSAGE'        /
      DATA    UWM   / '0*** USER WARNING MESSAGE'      /
      DATA    UIM   / '0*** USER INFORMATION MESSAGE'  /
      DATA    SFM   / '0*** SYSTEM FATAL MESSAGE'      /
      DATA    SWM   / '0*** SYSTEM WARNING MESSAGE'    /
      DATA    SIM   / '0*** SYSTEM INFORMATION MESSAGE'/
C
C     -------------------     /NUMTPX  /     --------------------------
C
      DATA    NBCD  /  0      /
      DATA    BCD   /  19*0   /
C
C     -------------------     /BLANK  /     --------------------------
C
CWKBR DATA    IBLNK /  56*0, 4H CEA, 4HSE E, 4HMPIR, 4HE >  /
      DATA    IBLNK /  96*0, 4H CEA, 4HSE E, 4HMPIR, 4HE >  /
C
C     -------------------     / NTIME  /     ---------------------------
C
CWKBR DATA    LNTIME/ 16      /
CWKBR 9/94 SPR94009      DATA    LNTIME/ 23      /      
      DATA    LNTIME/ 16      /      
CWKBR DATA    TIMDTA/ 16*0.   /
      DATA    TIMDTA/ 23*0.   /
C
C     USE A NASTRAN BULKDATA=-3 CARD TO ACTIVATE TIME CONSTANTS COMPUTA-
C     TION AND PRINT OUT FROM SUBROUTINES TMTSIO AND TMTSLP.
C
C     EXAMPLE - THE FOLLOWING CARDS CAN BE USED FOR UNIVAC 1100/82 IN
C     MSFC TO ELIMINATE HARDWARE TIME COMPUTATION IN EVERY NASTRAN RUN.
C
C     DATA    TIMDTA/  0.51, 15.73, 15.00, 11.10, 10.00,  2.20,  2.23,
C    1                 4.00,  5.28, 15.90, 19.40,  4.00,  5.80, 16.45,
C    2                20.16,  0.00/
C
C     SIMILARLY, THE NEXT TABLE FOR VAX 11/780 MACHINE AT COSMIC SITE
C
C     DATA    TIMDTA/ 12.30,  88.0,  76.0, 78.0 ,  76.0, 16.0 , 30.0 ,
C    1                 7.00,  12.0,  20.0, 35.0 ,   8.0, 12.0 , 24.0 ,
C    2                36.00,  14.2/
C
C     SIMILARLY, THE NEXT TABLE FOR MICRO VAX 3600 MACHINE AT COSMIC
C     SITE
C
C     DATA    TIMDTA/ 12.30,  88.0,  76.0, 78.0 ,  76.0, 16.0 , 30.0 ,
C    1                 7.00,  12.0,  20.0, 35.0 ,   8.0, 12.0 , 24.0 ,
C    2                36.00,   0.0/
C
C
C     AND THE NEXT TABLE FOR IBM 3084 MACHINE AT MSFC SITE
C
C     DATA    TIMDTA/  1.12,  5.28,  4.59,  2.04,  1.86,  1.06,  1.10,
C    1                 0.78,  0.82,  2.69,  2.80,  0.78,  0.87,  2.70,
C    2                 2.82,  0.00/
C
C
C     NOTE - STARTING 1991 VERSION, THESE TIMINGS CONSTANTS CAN BE FED
C     ****   DIRECTLY INTO NASTRAN EXECUTABLE VIA THE NASINFO FILE.
C            THUS, EACH COMPUTER CENTER CAN EASILY SUPPLY THE CORRECT
C            TIMING CONSTANTS FOR ITS MACHINE. (SEE THE WRITE-UP IN THE
C            NASINFO FILE)
C            THE 16TH TIMING IS FOR READING STRING BACKWARD. CURRENTLY
C            NOT USED
C
C     -------------------     / XLINK  /     ---------------------------
C
      DATA    LXLINK/ 220 /,  MAXLNK / 15/,  MXLINK / 220*0 /
C
C     -------------------     / SEM    /     ---------------------------
C
      DATA    MASK  / 65535/, MASK2 , MASK3 / 2*0  /,         NAME  /
     1        4HNS01, 4HNS02, 4HNS03, 4HNS04, 4HNS05, 4HNS06, 4HNS07,
     2        4HNS08, 4HNS09, 4HNS10, 4HNS11, 4HNS12, 4HNS13, 4HNS14,
     3        4HNS15, 4HNS16, 4HNS17, 4HNS18, 4HNS19, 4HNS20, 4HNS21,
     4        4HNS22, 4HNS23, 4HNS24, 4HNS25, 4HNS26, 4HNS27, 4HNS28,
     5        4HNS29, 4HNS30 /
C
C     -------------------     / SYSTEM /     ---------------------------
C
      DATA    SYSBUF,OUTTAP,NOGO  ,INTP  ,MPC   ,SPC   ,LOGFL   /
     *        0     ,0     ,0     ,0     ,0     ,0     ,0       /,
C                   USED ONLY IN MSFC, UNIVAC VERSION - LOGFL = 190
     1        LOAD  ,NLPP  ,MTEMP ,NPAGES,NLINES,TLINES,MXLINS  /
     *        1     ,0     ,0     ,0     ,0     ,0     ,20000   /,
     2        DATE  ,TIMEZ ,ECHOF ,PLOTF ,APPRCH,LINKNO,LSYSTM  /
     *        3*0   ,0     ,2     ,0     ,0     ,0     ,180     /,
     3        ICFIAT,RFFLAG,CPPGCT,MN    ,DUMMYI,MAXFIL,MAXOPN  /
     *        11    ,0     ,0     ,0     ,0     ,35    ,16      /,
     4        HICORE,TIMEW ,OFPFLG,NBRCBU,LPRUS ,NPRUS ,KSYS37  /
     *        85000 ,0     ,0     ,15    ,64    ,0     ,0       /,
C        VAX: HICORE IS SET TO 50,000 BY BTSTRP
     5        QQ    ,NBPC  ,NBPW  ,NCPW  ,SYSDAT,TAPFLG,ADUMEL  /
     *        0     ,0     ,0     ,0     ,3*0   ,0     ,9*0     /,
     6        IPREC ,ITHRML,MODCOM,HDY   ,SSCELL,TOLEL ,MESDAY  /
     *        0     ,0     ,9*0   ,3*0   ,0     ,0.01  ,0       /
      DATA    BITPAS,PASS  ,ITIME ,CTIME ,NOSBE ,BANDIT,PZEL    /
     *        2*.FALSE.    ,0     ,0     ,0     ,0     ,0       /,
     8        SWITCH,ICPFLG,JRUN  ,JMAX  ,LINTC ,INTRA ,OSPCNT  /
     *        3*0   ,0     ,0     ,0     ,800   ,0     ,15      /,
     9 K88 90,LPCH  ,LDICT ,IAEROT,KSYS94,SPERLK,LEFT  ,LOGLIN,LEFT2 /
     * 3*0   ,0     ,0     ,0     ,0     ,0     ,56*0  ,0     ,28*0  /
C
C     -------------------     / XFIST  /     ---------------------------
C
      DATA    NFIST / 56 /, LFIST /  56 /,  FIST /
     1        4HPOOL,  0,4HOPTP, -1,4HNPTP, -2,4HUMF , -3,4HNUMF, -4,
     2        4HPLT1, -5,4HPLT2, -6,4HINPT, -7,4HINP1, -8,4HINP2, -9,
     3        4HINP3,-10,4HINP4,-11,4HINP5,-12,4HINP6,-13,4HINP7,-14,
     4        4HINP8,-15,4HINP9,-16,4HXPTD,-17,4HSOF ,-18,4HUT1 ,-19,
     5        4HUT2 ,-20,4HUT3 ,-21,4HUT4 ,-22,4HUT5 ,-23,
C
C     USE VALUES BELOW WHEN ICFIAT (24TH WORD OF /SYSTEM/) IS 8
C    6           201,  3,   202, 11,   203, 19,   204, 27,   205, 35,
C    7        4HCASE, 43,   207, 51,4HPCDB, 59,   208, 67,   209, 75,
C    8           210, 83,   211, 91,   213, 99,   214,107,   215,115,
C    9           216,123,   301,131,   302,  3,   303, 11,   304, 19,
C    O           305, 27,   306, 35,4HXYCD,139,   307, 67,   308, 75,
C    1           309, 83,   310, 91,   311, 99,   312,107,   313,115,
C    2           314,123,   315,147/
C
C     USE VALUES BELOW WHEN ICFIAT (24TH WORD OF /SYSTEM/) IS 11
     6           201,  3,   202, 14,   203, 25,   204, 36,   205, 47,
     7        4HCASE, 58,   207, 69,4HPCDB, 80,   208, 91,   209,102,
     8           210,113,   211,124,   213,135,   214,146,   215,157,
     9           216,168,   301,179,   302,  3,   303, 14,   304, 25,
     O           305, 36,   306, 47,4HXYCD,190,   307, 91,   308,102,
     1           309,113,   310,124,   311,135,   312,146,   313,157,
     2           314,168,   315,201/
C
C     -------------------     / XPFIST /     ---------------------------
C
      DATA    NPFIST/ 24   /
C
C     -------------------     / XXFIAT /     ---------------------------
C
      DATA    XXFIAT/ 24*0 /
C
C     -------------------     / XFIAT  /     ---------------------------
C
C     USE 8*0 EACH INSTEAD OF 5*0 WHEN ICFIAT = 11
C
CWKBR DATA    MFIAT / 0 /, NFIAT / 80 /, LFIAT / 0 /, FIAT /
      DATA    MFIAT / 0 /, NFIAT / 100/, LFIAT / 0 /, FIAT /
     1                0, 4HGEOM, 4H1   , 8*0 ,
     2                0, 4HEPT , 4H    , 8*0 ,
     3                0, 4HMPT , 4H    , 8*0 ,
     4                0, 4HEDT , 4H    , 8*0 ,
     5                0, 4HDIT , 4H    , 8*0 ,
     6                0, 4HCASE, 4HCC  , 3*7 , 2*0 , 3*7 ,
     7                0, 4HDYNA, 4HMICS, 8*0 ,
     8                0, 4HPCDB, 4H    , 8*0 ,
     9                0, 4HGEOM, 4H2   , 8*0 ,
     O                0, 4HGEOM, 4H3   , 8*0 ,
     1                0, 4HGEOM, 4H4   , 8*0 ,
     2                0, 4HGEOM, 4H5   , 8*0 ,
     3                0, 4HFORC, 4HE   , 8*0 ,
     4                0, 4HMATP, 4HOOL , 8*0 ,
     5                0, 4HAXIC, 4H    , 8*0 ,
     6                0, 4HIFPF, 4HILE , 8*0 ,
     7                0, 4HSCRA, 4HTCH1, 8*0 ,
     8                0, 4HXYCD, 4HB   , 8*0 ,
CWKBR9                0, 4HSCRA, 4HTC15, 8*0 , 671*0 /
     9                0, 4HSCRA, 4HTC15, 8*0 , 671*0, 220*0 /
C
C     -------------------     / OSCENT /     ---------------------------
C
      DATA    OSCAR / 200*4H    /
C
C     -------------------     / OUTPUT /     ---------------------------
C
      DATA    OUTPUT/ 224*4H    /
C
C     -------------------     / XDPL   /     ---------------------------
C
      DATA    MDPL  / 1 /,  NDPL / 80 /,  LDPL  / 0 /,  DPL / 240*0 /
C
C     -------------------     / XVPS   /     ---------------------------
C
      DATA    VPS   / 600,  2,   598*0    /
C
C     -------------------     / STAPID /     ---------------------------
C
      DATA    TAPID / 6*0.0 /,   OTAPID  / 6*0.0 /
      DATA    IDUMF /   0   /
C
C     -------------------     / STIME  /     ---------------------------
C
      DATA    TIME  / 2*0.0 /
C
C     -------------------     / XCEITB /     ---------------------------
C
      DATA    CEI   / 42,   2,   40*0  /
C
C     -------------------     / XMDMSK /     ---------------------------
C
      DATA    NMSKCD, NMSKFL, NMSKRF, MSK / 3, 3, 1, 7*0  /
C
C     -------------------     / MSGX   /     ---------------------------
C
      DATA    NMSG  / 0 /,  MSGLG /  40 /,  MSG / 160*0   /
C
C     -------------------     / DESCRP /     ---------------------------
C
C     DATA    LENGTH / 50 /,   BLOCK / 50*0 /
C
C     -------------------     / TWO    /     ---------------------------
C
C     TWO(1)  = LSHIFT(1,31), IS MACHINE DEPENDENT (SET BY BTSTRP)
C     MZERO   = WILL BE SET TO LSHIFT(1,NBPW-1) BY BTSTRP
C
      DATA    TWO   /          0,
     1                1073741824, 536870912, 268435456, 134217728,
     2                  67108864,  33554432,  16777216,   8388608,
     3                   4194304,   2097152,   1048576,    524288,
     4                    262144,    131072,     65536,     32768,
     5                     16384,      8192,      4096,      2048,
     6                      1024,       512,       256,       128,
     7                        64,        32,        16,         8,
     8                         4,         2,         1/
      DATA    MZERO / 0 /
C
C     -------------------     / NAMES  /     ---------------------------
C
      DATA    RD    / 2 /,  RDREW / 0 /,  WRT   / 3 /,  WRTREW/ 1 /,
     1        REW   / 1 /,  NOREW / 2 /,  EOFNRW/ 3 /,  RSP   / 1 /,
     2        RDP   / 2 /,  CSP   / 3 /,  CDP   / 4 /,  SQUARE/ 1 /,
     3        RECT  / 2 /,  DIAG  / 3 /,  LOWER / 4 /,  UPPER / 5 /,
     4        SYM   / 6 /,  ROW   / 7 /,  IDENT / 8 /
C
C     -------------------     / TYPE   /     ---------------------------
C
      DATA    PRC   /     1,     2/      ,
     1        NWDS  /     1,     2,     2,     4/,
     2        RC    /     1,     1,     2,     2/,
     3        X     /     6*0.0   /
C
C     -------------------     / BITPOS /     ---------------------------
C
      DATA    UM  /32/  ,  HM  /2HM /  ,     UPS /16/  ,  HPS /2HPS/  ,
     1        UO  /30/  ,  HO  /2HO /  ,     USA /15/  ,  HSA /2HSA/  ,
     2        UR  /29/  ,  HR  /2HR /  ,     UK  /14/  ,  HK  /2HK /  ,
     3        USG /23/  ,  HSG /2HSG/  ,     UPA /13/  ,  HPA /2HPA/  ,
     4        USB /22/  ,  HSB /2HSB/  ,     U21 /10/  ,  H21 /4HXXXX/,
     5        UL  /24/  ,  HL  /2HL /  ,     U22 /11/  ,  H22 /4HYYYY/,
     6        UA  /25/  ,  HA  /2HA /  ,     U23 /12/  ,  H23 /4HZZZZ/,
     7        UF  /26/  ,  HF  /2HF /  ,     UX  / 9/  ,  HX  /2HX /  ,
     8        US  /31/  ,  HS  /2HS /  ,     UY  / 8/  ,  HY  /2HY /  ,
     9        UN  /27/  ,  HN  /2HN /  ,     UFR / 7/  ,  HFR /2HFR/  ,
     O        UG  /28/  ,  HG  /2HG /  ,     UZ  / 6/  ,  HZ  /2HZ /  ,
     1        UE  /21/  ,  HE  /2HE /  ,     UAB / 5/  ,  HAB /2HAB/  ,
     2        UP  /20/  ,  HP  /2HP /  ,     UI  / 4/  ,  HI  /2HI /  ,
     3        UNE /19/  ,  HNE /2HNE/  ,     U30 / 3/  ,  H30 /2HU3/  ,
     4        UFE /18/  ,  HFE /2HFE/  ,     U31 / 2/  ,  H31 /2HU2/  ,
     5        UD  /17/  ,  HD  /2HD /  ,     U32 / 1/  ,  H32 /2HU1/
C
C     -------------------     / SOFCOM /     ---------------------------
C
      DATA    NFILES/ 1          /
      DATA    FILNAM/ 4HINPT,9*0 /
      DATA    FILSIZ/ 100   ,9*0 /
      DATA    STATUS/ 1          /
      DATA    PSSWRD/ 2*4H       /
      DATA    FIRST / .TRUE.     /
      DATA    OPNSOF/ .FALSE.    /
      DATA    ASOFCB/ 0          /
C
C     --------------------    / XXREAD /     ---------------------------
C
      DATA    INFLAG, INSAVE, IXXR / 5*0 /
C
C     --------------     /XECHOX/ AND /XREADX/     ---------------------
C
      DATA    IECHO , IXSORT, IWASFF, NCARD, NOECHO                /
     1        4*0,    0,      0,      3*0,   0                     /
      DATA    SCREEN, LOOP, KOUNT, PROM, NOTYET, STAR, PCT, ICONT  /
     1        6,      -1,   0,     0,    3*.FALSE.,         36*0   /
C
C     --------------     /MACHIN/ AND /LHPWX/     ---------------------
C
      DATA    MA    / 6*0 /,  LH / 7*0 /
C
      END

      SUBROUTINE SSG2B (KFS,CDT,PABAR,SR1,T1,IPREC1,IA1,SR2)
C
      IMPLICIT INTEGER (A-Z)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25,SWM*27
      COMMON /XMSSG / UFM,UWM,UIM,SFM,SWM
      COMMON /ZZZZZZ/ CORE(1)
      COMMON /SYSTEM/ KSYSTM(55)
      COMMON /MPYADX/ FILEA(7),FILEB(7),FILEC(7),FILED(7),NZ,T,I1,I2,
     1                PREC,SCR2
      EQUIVALENCE     (KSYSTM(55),KPREC1), (KSYSTM(1),SYSBUF),
     1                (KSYSTM( 2),IOUTPT)
      DATA    SQUARE, RECT,DIAG,SYMM,IDENT / 1,2,3,6,8 /
C
      PREC1 = MIN0(KPREC1,IPREC1)
      IF (PREC1 .LE. 0) PREC1 = KPREC1
      NZ = KORSZ(CORE)
      DO 10 I = 1,21
   10 FILEA(I) = 0
      FILEA(1) = KFS
      SCR2 = SR2
      IF (IABS(IA1)-1) 40,20,30
   20 I2 = IA1
      I1 = IA1
      GO TO 50
   30 I2 =-1
      I1 = 1
      GO TO 50
   40 I1 =-1
      I2 = 1
   50 CALL RDTRL (FILEA)
      FILEB(1) = CDT
      CALL RDTRL (FILEB)
      IF (FILEB(1) .LE. 0) FILEB(4) = SYMM
      FILEC(1) = PABAR
      CALL RDTRL (FILEC)
      IF (FILEC(1) .LE. 0) GO TO 70
      IF (FILEC(2).EQ.FILEB(2) .OR. FILEB(1).LE.0) GO TO 80
      WRITE (IOUTPT,60) SWM,FILEB(1),FILEB(3),FILEB(2),FILEB(3),FILEC(2)
   60 FORMAT (A27,' 2363, SSG2B FORCED MPYAD COMPATIBILITY OF MATRIX ON'
     1,       I5,8H, FROM (,I5,1H,,I5,7H), TO (,I5,1H,,I5,1H))
      FILEB(2) = FILEC(2)
      GO TO 80
   70 FILEC(1) = 0
      FILEC(4) = DIAG
   80 FILED(4) = RECT
      FILED(1) = SR1
C
C     COMPUTE TYPE OF OUTPUT
C
      IRC = 0
      IF (FILEA(5).GT.2 .OR. FILEB(5).GT.2 .OR. (FILEC(5).GT.2 .AND.
     1    FILEC(1).NE.0)) IRC = 2
      FILED(5) = PREC1 + IRC
      T = T1
      PREC = PREC1
      FILED(3) = FILEA(3)
      IF (T .NE. 0) FILED(3) = FILEA(2)
      IF (FILEA(1).LE.0 .OR. FILEB(1).LE.0) FILED(3) = FILEC(3)
      CALL MPYAD (CORE,CORE,CORE)
      IF (FILED(2).EQ.FILED(3) .AND. FILED(4).NE.SYMM) FILED(4) = SQUARE
      IF (FILED(4).EQ.SYMM .OR. FILED(4).NE.SQUARE) GO TO 100
C
C     IF END RESULT IS A SYMMETRIC MATRIX, MAKE SURE THE FORM IS SET TO
C     6 (SYMM). IT COULD SAVE CPU TIME LATER AND WORTH ONE FINAL CHECK.
C
      K = 0
      DO 90 I = 1,21,7
      IF (FILEA(I) .LE. 0) GO TO 90
      J = FILEA(I+3)
      IF (J.EQ.DIAG .AND. I.EQ.15   ) GO TO 90
      IF (J.NE.SYMM .AND. J.NE.IDENT) GO TO 100
      IF (J .EQ.  SYMM) K = K + 10
      IF (J .EQ. IDENT) K = K + 1
   90 CONTINUE
      IF (K .GT.  0) FILED(4) = IDENT
      IF (K .GE. 10) FILED(4) = SYMM
  100 CALL WRTTRL (FILED)
      RETURN
      END

      SUBROUTINE SDR2B
C
C     SDR2B PROCESSES THE EST. FOR EACH ELEMENT IN THE MASTER SET,
C     PRELIMINARY COMPUTATIONS ARE MADE. IF THE PROBLEM CONTAINS EXTRA
C     POINTS, SIL NOS. ARE CONVERTED TO SILD NOS. THE DATA IS WRITTEN
C     ON ESTA FOR INPUT TO SDR2D WHERE FINAL STRESS AND FORCE RECOVERY
C     COMPUTATIONS ARE MADE.
C
C
      IMPLICIT INTEGER (A-Z)
      LOGICAL         ANYOUT,AXIC  ,HEAT  ,REJECT,STRAIN
      INTEGER         NAME(2)
CWKBI 7/94 SPR 94007  
      INTEGER         MMRE(2)
      REAL            SCRTCH,ZZ(1) ,BUFR(1)
      DIMENSION       KDEFRM(2)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25,SWM*27
      COMMON /XMSSG / UFM   ,UWM   ,UIM   ,SFM   ,SWM
      COMMON /ZZZZZZ/ Z(1)
      COMMON /SYSTEM/ KSYSTM(63)
      COMMON /BLANK / APP(2),SORT2 ,IDUMMY(7)    ,STRAIN
      COMMON /SDR2X1/ IEIGEN,IELDEF,ITLOAD,ISYMFL,ILOADS,IDISPL,ISTR  ,
     1                IELF  ,IACC  ,IVEL  ,ISPCF ,ITTL  ,ILSYM
      COMMON /SDR2X2/ CASECC,CSTM  ,MPT   ,DIT   ,EQEXIN,SIL   ,GPTT  ,
     1                EDT   ,BGPDT ,PG    ,QG    ,UGV   ,EST   ,PHIG  ,
     2                EIGR  ,OPG1  ,OQG1  ,OUGV1 ,OES1  ,OEF1  ,PUGV1 ,
     3                OEIGR ,OPHIG ,PPHIG ,ESTA  ,GPTTA ,HARMS
      COMMON /HMATDD/ IHMAT ,NHMAT ,MPTMPT,IDIT
      COMMON /GPTA1 / NELEM ,LAST  ,INCR  ,ELEM(1)
      COMMON /SDR2X4/ NAM(2),END   ,MSET  ,ICB(7),OCB(7),MCB(7),DTYPE(8)
     1,               ICSTM ,NCSTM ,IVEC  ,IVECN ,TEMP  ,DEFORM,FILE  ,
     2                BUF1  ,BUF2  ,BUF3  ,BUF4  ,BUF5  ,ANY   ,ALL   ,
     3                TLOADS,ELDEF ,SYMFLG,BRANCH,KTYPE ,LOADS ,SPCF  ,
     4                DISPL ,VEL   ,ACC   ,STRESS,FORCE ,KWDEST,KWDEDT,
     5                KWDGPT,KWDCC ,NRIGDS,STA(2),REI(2),DS0(2),DS1(2),
     6                FRQ(2),TRN(2),BK0(2),BK1(2),CEI(2),PLA(22)      ,
     7                NRINGS,NHARMS,AXIC  ,KNSET ,ISOPL ,STRSPT,DDRMM ,
     8                ISOPL8
      COMMON /SDR2X5/ BUF(100),BUFA(100)  ,BUFB(4176)
      COMMON /SDR2X6/ SCRTCH(300)
      COMMON /NAMES / RD    ,RDREW ,WRT   ,WRTREW,CLSREW
      EQUIVALENCE     (KSYSTM( 1),SYSBUF) ,(KSYSTM( 2),IOUTPT),
     1                (KSYSTM(55),IPREC ) ,(KSYSTM(56),ITHERM),
     2                (Z(1)      ,ZZ( 1)) ,(BUFR(1)   ,BUF(1))
      DATA   NAME   / 4HSDR2,4HB   /      ,STAR  / 4H* *      /
      DATA   KDEFRM / 104,1/
      DATA   IZ1ST  / 1    /
CWKBI 7/94 SPR 94007  
      DATA   MMRE   / 4HMMRE,4HIGEN /
C            IZ1ST  IS THE START OF OPEN CORE AVAILABLE
C
C
C     IF APPROACH IS COMPLEX EIGENVALUES, FREQUENCY OR TRANSIENT
C     RESPONSE, TEST FOR EXTRA POINTS. IF PRESENT, READ EQUIVALENCE
C     TABLE (SIL,SILD) INTO CORE.
C
      CALL DELSET
      HEAT = .FALSE.
      IF (ITHERM .NE. 0) HEAT = .TRUE.
      ISOPL = 0
      ICSTM = IZ1ST
      M8    =-8
      NOEP  = 0
CWKBR 7/94 SPR 94007  
C     IF (APP(1).EQ.CEI(1) .OR. APP(1).EQ.FRQ(1) .OR. APP(1).EQ.TRN(1))       
C    1    GO TO 20
      IF (APP(1).EQ.CEI(1) .OR. APP(1).EQ.FRQ(1) .OR. APP(1).EQ.TRN(1)  
     1                     .OR. APP(1).EQ.MMRE(1) )GO TO 20
      GO TO 40
   20 ICB(1) = SIL
      CALL RDTRL (ICB)
      NOEP = ICB(3)
      IF (NOEP .EQ. 0) GO TO 40
      FILE = SIL
      CALL OPEN (*560,SIL,Z(BUF1),RDREW)
      CALL FWDREC (*570,SIL)
      CALL FWDREC (*570,SIL)
      CALL READ (*570,*30,SIL,Z,BUF2,1,NSIL)
      CALL MESAGE (M8,0,NAM)
   30 CALL CLOSE (SIL,CLSREW)
      KNSIL = NSIL/2
      ICSTM = NSIL + 1
      IF (NSIL .LT. MSET) GO TO 40
      MSET = BUF2 - 1
      ALL  = 1
C
C     READ THE CSTM INTO CORE (IF PRESENT).
C
   40 NCSTM = 0
      FILE  = CSTM
      CALL OPEN (*60,CSTM,Z(BUF1),RDREW)
      CALL FWDREC (*570,CSTM)
      CALL READ (*570,*50,CSTM,Z(ICSTM),BUF2-ICSTM,1,NCSTM)
      CALL MESAGE (M8,0,NAM)
   50 CALL CLOSE (CSTM,CLSREW)
      CALL PRETRS (Z(ICSTM),NCSTM)
   60 IMAT = ICSTM + NCSTM
      IF (IMAT .LT. MSET) GO TO 70
      MSET = BUF2 - 1
      ALL  = 1
C
C     READ MATERIAL PROPERTY DATA INTO CORE.
C
   70 N1MAT = BUF2 - IMAT
      IF (.NOT.HEAT) GO TO 77
C
C     FOR HEAT PROBLEMS ONLY, -HMAT- ROUTINE IS USED.
C
      IHMAT = IMAT
      NHMAT = BUF1 + SYSBUF
      MPTMPT= MPT
      IDIT  = DIT
      CALL PREHMA (Z)
      N2MAT = NHMAT - IHMAT+1 - 2*(SYSBUF+1)
      GO TO 78
C
   77 CALL PREMAT (Z(IMAT),Z(IMAT),Z(BUF1),N1MAT,N2MAT,MPT,DIT)
   78 IF (IMAT+N2MAT .LT. MSET) GO TO 80
      MSET = BUF2 - 1
      ALL  = 1
C
C     OPEN EST AND ESTA.
C
   80 FILE = EST
      CALL OPEN (*620,EST,Z(BUF1),RDREW)
      CALL FWDREC (*570,EST)
      FILE = ESTA
      CALL OPEN (*560,ESTA,Z(BUF2),WRTREW)
      FILE   = EST
      KWDEST = 0
      KWDEDT = 0
      KWDGPT = 0
C
C     READ ELEMENT TYPE. SET PARAMETERS AS A FUNCTION OF ELEM TYPE.
C
   90 CALL READ (*430,*580,EST,ELTYPE,1,0,FLAG)
      IF (ELTYPE.LT.1 .OR. ELTYPE.GT.NELEM) GO TO 3800
      ANYOUT = .FALSE.
      IPR = IPREC
      IF (IPR .NE. 1) IPR = 0
      JLTYPE = 2*ELTYPE - IPR
      IELEM  = (ELTYPE-1)*INCR
      NWDS   = ELEM(IELEM+12)
      NWDSA  = ELEM(IELEM+17)
      IF (HEAT) NWDSA = 142
      NGPS   = ELEM(IELEM+10)
C
C     READ DATA FOR AN ELEMENT.
C     DETERMINE IF ELEMENT BELONGS TO MASTER SET.
C
  100 CALL READ (*570,*420,EST,BUF,NWDS,0,FLAG)
      DO 105 I = 1,NWDS
  105 SCRTCH(100+I) = BUFR(I)
      STRSPT = 0
      ISOPL  =-1
      IDSAVE = BUF(1)
      IF (ALL .NE. 0) GO TO 110
      ITABL = MSET
      KN  = KNSET
      L   = 1
      N12 = 1
      ASSIGN 100 TO RET1
      IF (.NOT. AXIC) GO TO 630
C
C     DECODE ELEMENT ID SINCE THIS IS A CONICAL SHELL PROBLEM
C
      BUF(1) = BUF(1)/1000
      GO TO 630
C
C     CALL APPROPRIATE ELEMENT SUBROUTINE.
C
  110 CONTINUE
      BUF(1) = IDSAVE
C
      IF (.NOT.STRAIN) GO TO 112
C
C     IF THE STRAIN FLAG IS TURNED ON, IGNORE ALL ELEMENTS
CWKBR NCL93012 3/94 EXCEPT CTRIA1, CTRIA2, CQUAD1 AND CQUAD2 ELEMENTS  
C     EXCEPT CTRIA1, CTRIA2, CTRIA3, CQUAD1, CQUAD2 AND CQUAD4 ELEMENTS  
C
      IF (ELTYPE.EQ. 6 .OR. ELTYPE.EQ.17 .OR. ELTYPE.EQ.18 .OR.
CWKBR NCL93012 3/94     1    ELTYPE.EQ.19) GO TO 112  
     1    ELTYPE.EQ.19 .OR. ELTYPE .EQ.64 .OR. ELTYPE.EQ.83) GO TO 112  
      WRITE  (IOUTPT,111) SWM,ELEM(IELEM+1),ELEM(IELEM+2)
  111 FORMAT (A27,', STRAIN REQUEST FOR ',2A4,' ELEMENTS WILL', /5X,
     1       'NOT BE HONORED AS THIS OUTPUT IS NOT DEFINED FOR THIS ',
     2       'ELEMENT TYPE.')
      CALL FWDREC (*570,EST)
      GO TO 420
C
  112 IF (HEAT) GO TO 389
      LOCAL = JLTYPE - 100
      IF (LOCAL) 114,114,115
C
C     PAIRED -GO TO- ENTRIES PER ELEMENT SINGLE/DOUBLE PRECISION
C
C             1 CROD      2 C.....    3 CTUBE     4 CSHEAR    5 CTWIST
  114 GO TO (120,  120,  380,  380,  140,  140,  150,  150,  160,  160
C
C             6 CTRIA1    7 CTRBSC    8 CTRPLT    9 CTRMEM   10 CONROD
     1,      180,  180,  190,  190,  200,  200,  210,  210,  120,  120
C
C            11 ELAS1    12 ELAS2    13 ELAS3    14 ELAS4    15 CQDPLT
     2,      220,  220,  230,  230,  240,  240,  250,  250,  270,  270
C
C            16 CQDMEM   17 CTRIA2   18 CQUAD2   19 CQUAD1   20 CDAMP1
     3,      280,  280,  290,  290,  300,  300,  310,  310,  380,  380
C
C            21 CDAMP2   22 CDAMP3   23 CDAMP4   24 CVISC    25 CMASS1
     4,      380,  380,  380,  380,  380,  380,  380,  380,  380,  380
C
C            26 CMASS2   27 CMASS3   28 CMASS4   29 CONM1    30 CONM2
     5,      380,  380,  380,  380,  380,  380,  380,  380,  380,  380
C
C            31 PLOTEL   32 C.....   33 C.....   34 CBAR     35 CCONE
     6,      380,  380,  380,  380,  380,  380,  330,  330,  340,  340
C
C            36 CTRIARG  37 CTRAPRG  38 CTORDRG  39 CTETRA   40 CWEDGE
     7,      350,  350,  360,  360,  370,  370,  371,  371,  372,  372
C
C            41 CHEXA1   42 CHEXA2   43 CFLUID2  44 CFLUID3  45 CFLUID4
     8,      373,  373,  374,  374,  380,  380,  380,  380,  380,  380
C
C            46 CFLMASS  47 CAXIF2   48 CAXIF3   49 CAXIF4   50 CSLOT3
     9,      380,  380,  375,  375,  376,  376,  377,  377,  378,  378
C
     *), JLTYPE
C
C
C            51 CSLOT4   52 CHBDY    53 CDUM1    54 CDUM2    55 CDUM3
  115 GO TO (379,  379,  380,  380,  451,  451,  452,  452,  453,  453
C
C            56 CDUM4    57 CDUM5    58 CDUM6    59 CDUM7    60 CDUM8
     B,      454,  454,  455,  455,  456,  456,  457,  457,  458,  458
C
C            61 CDUM9    62 CQDMEM1  63 CQDMEM2  64 CQUAD4   65 CIHEX1
     C,      459,  459,  460,  460,  461,  461,  462,  462,  383,  383
C
C            66 CIHEX2   67 CIHEX3   68 CQUADTS  69 CTRIATS  70 CTRIAAX
     D,      383,  383,  383,  383,  465,  465,  466,  466,  467,  467
C
C            71 CTRAPAX  72 CAERO1   73 CTRIM6   74 CTRPLT1  75 CTRSHL
     E,      468,  468,  380,  380,  469,  469,  470,  470,  471,  471
C
C            76 CFHEX1   77 CFHEX2   78 CFTETRA  79 CFWEDGE  80 CIS2D8
     F,      380,  380,  380,  380,  380,  380,  380,  380,  472,  472
C
C            81 CELBOW   82 CFTUBE   83 CTRIA3
     G,      473,  473,  380,  380,  463,  463
C
     *), LOCAL
C
  120 CALL SROD1
      GO TO 390
  140 CALL STUBE1
      GO TO 390
  150 K = 4
      GO TO 170
  160 K = 5
  170 CALL SPANL1 (K)
      GO TO 390
  180 K = 1
      GO TO 320
  190 CALL STRBS1 (0)
      GO TO 390
  200 CALL STRPL1
      GO TO 390
  210 CALL STRME1 (0)
      GO TO 390
  220 K = 1
      GO TO 260
  230 K = 2
      GO TO 260
  240 K = 3
      GO TO 260
  250 K = 4
  260 CALL SELAS1 (K)
      GO TO 390
  270 CALL SQDPL1
      GO TO 390
  280 CALL SQDME1
      GO TO 390
  290 K = 2
      GO TO 320
  300 K = 4
      GO TO 320
  310 K = 3
  320 CALL STRQD1 (K)
      GO TO 390
  330 CALL SBAR1
      GO TO 390
  340 CALL SCONE1
      GO TO 390
  350 CALL STRIR1
      GO TO 390
  360 CALL STRAP1
      GO TO 390
  370 CALL STORD1
      GO TO 390
  371 CALL SSOLD1 (1)
      GO TO 390
  372 CALL SSOLD1 (2)
      GO TO 390
  373 CALL SSOLD1 (3)
      GO TO 390
  374 CALL SSOLD1 (4)
      GO TO 390
  375 K = 0
      GO TO 381
  376 K = 1
      GO TO 381
  377 K = 2
  381 CALL SAXIF1 (K)
      GO TO 390
  378 K = 0
      GO TO 382
  379 K = 1
  382 CALL SSLOT1 (K)
      GO TO 390
  383 CONTINUE
      CALL SIHEX1 (ELTYPE-64,STRSPT,NIP)
      IF (STRSPT .GE. NIP**3+1) STRSPT = 0
      GO TO 390
  451 CALL SDUM11
      GO TO 391
  452 CALL SDUM21
      GO TO 391
  453 CALL SDUM31
      GO TO 391
  454 CALL SDUM41
      GO TO 391
  455 CALL SDUM51
      GO TO 391
  456 CALL SDUM61
      GO TO 391
  457 CALL SDUM71
      GO TO 391
  458 CALL SDUM81
      GO TO 391
  459 CALL SDUM91
      GO TO 391
  460 CALL SQDM11
      GO TO 390
  461 CALL SQDM21
      GO TO 390
  462 CALL SQUD41
      GO TO 390
  463 CALL STRI31
      GO TO 390
  465 CONTINUE
      GO TO 390
  466 CONTINUE
      GO TO 390
  467 CALL STRAX1
      GO TO 390
  468 CALL STPAX1
      GO TO 390
  469 CALL STRM61
      GO TO 390
  470 CALL STRP11
      GO TO 390
  471 CALL  STRSL1
      GO TO 390
  472 CALL SS2D81
      ISOPL8 = 8
      GO TO 390
  473 CALL SELBO1
      GO TO 390
C
C     ELEMENT UNDEFINE TO SDR2BD
C
 3800 WRITE  (IOUTPT,385) STAR,STAR,ELTYPE
      GO TO 388
  380 WRITE  (IOUTPT,385) SWM,ELEM(IELEM+1),ELEM(IELEM+2),ELTYPE
  385 FORMAT (A27,' 2184,  STRESS OR FORCE REQUEST FOR ELEMENT ',2A4,
     1        ' (NASTRAN ELEM. TYPE =',I4,1H), /5X,'WILL NOT BE HONORED'
     2,       ' AS THIS ELEMENT IS NOT A STRUCTURAL ELEMENT.')
  388 CALL FWDREC (*570,EST)
      GO TO 420
C
C     HEAT PROBLEMS (ALL ELEMENTS).
C
  389 CALL SDHTF1 (ELTYPE,REJECT)
      IF (ELTYPE.LT.65 .OR.  ELTYPE.GT.67) GO TO 3890
      IF (ELTYPE.EQ.65 .AND. STRSPT.GE. 9) STRSPT = 0
      IF (STRSPT .GE. 21) STRSPT = 0
 3890 CONTINUE
      IF (.NOT.REJECT) GO TO 390
      CALL FWDREC (*570,EST)
      GO TO 420
C
C     IF EXTRA POINTS PRESENT, CONVERT SIL NOS. TO SILD NOS.
C
  391 NWDSA = ELEM(IELEM+17)
  390 IF (NOEP .EQ. 0) GO TO 410
      N = NGPS + 101
      ITABL = 1
      KN  = KNSIL
      N12 = 2
      ASSIGN 740 TO RET1
      L = 102
CWKBNB 7/94 SPR 94006
C REMOVE COMPONENT FROM SIL AND THEN ADD AFTER SILD NUMBER FOUND FOR
C CELAS1 AND CELAS2 ELEMENTS-SEE SUBROUTINE SELAS1
      IF ( ELTYPE .EQ. 11 ) GO TO 392
      IF ( ELTYPE .EQ. 12 ) GO TO 393
      GO TO 394
C SET SIL NUMBER TO SIL OF GRID POINT WITHOUT COMPONENT CODE INCLUDED FOR
C CELAS1 SO SIL NUMBER CAN BE FOUND IN SILD 
  392 BUF(L)   = BUF(2)
      BUF(L+1) = BUF(3)
      GO TO 394
C SET SIL NUMBER TO SIL OF GRID POINT WITHOUT COMPONENT CODE INCLUDED FOR
C CELAS2 SO SIL NUMBER CAN BE FOUND IN SILD
  393 BUF(L)   = BUF(3)
      BUF(L+1) = BUF(4)
      GO TO 394
  394 CONTINUE
CWKBNE 7/94 SPR 94006
      IF (BUF(L) .EQ. 0) GO TO 400
      GO TO 630
  400 L = L + 1
CWKBR 7/94 SPR 94006 IF (L      .GT. N) GO TO 410              
      IF (L      .GT. N) GO TO 401        
      IF (BUF(L) .EQ. 0) GO TO 400
      GO TO 630
CWKBNB 7/94 SPR94006
  401 CONTINUE
      IF ( ELTYPE .EQ. 11 ) GO TO 402
      IF ( ELTYPE .EQ. 12 ) GO TO 403
      GO TO 404
C ADD COMPONENT CODES FOR SILD NUMBERS FOR CELAS1
  402 IF ( BUF(4) .NE. 0 ) BUF(102) = BUF(102) + BUF(4) - 1
      IF ( BUF(5) .NE. 0 ) BUF(103) = BUF(103) + BUF(5) - 1
      GO TO 404
C ADD COMPONENT CODES FOR SILD NUMBERS FOR CELAS2
  403 IF ( BUF(5) .NE. 0 ) BUF(102) = BUF(102) + BUF(5) - 1
      IF ( BUF(6) .NE. 0 ) BUF(103) = BUF(103) + BUF(6) - 1
  404 CONTINUE
CWKBNE 7/94 SPR 94006
C
C     WRITE ELEMENT COMPUTATIONS ON ESTA. GO TO READ ANOTHER ELEMENT.
C
  410 IF (ANYOUT) GO TO 411
      CALL WRITE (ESTA,ELTYPE,1,0)
      KWDEST = KWDEST + 2
      ANYOUT = .TRUE.
  411 CALL WRITE (ESTA,BUFA,NWDSA,0)
C
C     DIAG 20 OUTPUT ONLY
C
C     CALL BUG (4HESTA,0,BUFA,NWDSA)
C
      KWDEST = KWDEST + NWDSA
      IF (STRSPT .EQ. 0) GO TO 100
      STRSPT = STRSPT + 1
      GO TO 112
C
C     CLOSE RECORD FOR CURRENT ELEMENT TYPE.
C     GO TO READ ANOTHER ELEM TYPE.
C
  420 IF (ANYOUT) CALL WRITE (ESTA,0,0,1)
      GO TO 90
C
C     CLOSE FILES.
C
  430 CALL CLOSE (EST ,CLSREW)
      CALL CLOSE (ESTA,CLSREW)
C
C     IF ELEMENT DEFORMATIONS, DETERMINE MAXIMUM NO. OF
C     WORDS IN ANY ONE DEFORMATION SET.
C
      IF (ELDEF .EQ. 0) RETURN
      CALL PRELOC (*620,Z(BUF1),EDT)
      CALL LOCATE (*600,Z(BUF1),KDEFRM,FLAG)
      ID = 0
      K  = 0
  530 CALL READ (*600,*550,EDT,BUF,3,0,FLAG)
      IF (BUF(1) .EQ. ID) GO TO 540
      KWDEDT = MAX0(KWDEDT,K)
      K  = 3
      ID = BUF(1)
      GO TO 530
  540 K  = K + 3
      GO TO 530
  550 KWDEDT = MAX0(KWDEDT,K)
      CALL CLOSE (EDT,CLSREW)
      RETURN
C
C
C     FATAL FILE ERRORS.
C
  560 N = -1
      GO TO 590
  570 N = -2
      GO TO 590
  580 N = -3
      GO TO 590
  590 CALL MESAGE (N,FILE,NAM)
C
C     ABNORMAL RETURN FROM SDR2B.
C
  600 CALL CLOSE (EDT,CLSREW)
      ELDEF = 0
      GO TO 620
  620 CALL MESAGE (30,79,0)
      STRESS = 0
      FORCE  = 0
      ANY    = 0
      RETURN
C
C
C     BINARY SEARCH ROUTINE
C
  630 KLO = 1
      KHI = KN
  640 K   = (KLO+KHI+1)/2
  650 KX  = ITABL + N12*(K-1)
      IF (BUF(L)-Z(KX)) 660,720,670
  660 KHI = K
      GO TO 680
  670 KLO = K
  680 IF (KHI-KLO-1 ) 730,690,640
  690 IF (K .EQ. KLO) GO TO 700
      K = KLO
      GO TO 710
  700 K = KHI
  710 KLO = KHI
      GO TO 650
  720 IF (N12 .EQ. 1) GO TO 110
      BUF(L) = Z(KX+1)
      GO TO 400
  730 GO TO RET1, (100,740)
  740 CALL MESAGE (-61,0,NAME)
      GO TO 740
      END

      SUBROUTINE LINE (X1,Y1,X2,Y2,PENX,OPT)
C
C     (X1,Y1) = STARTING POINT OF THE LINE
C     (X2,Y2) = TERMINAL POINT OF THE LINE
C     PENX    = PEN NUMBER OR DENSITY (DEPENDING ON PLOTTER)
C     OPT     = -1  TO INITIATE  THE LINE MODE
C             = +1  TO TERMINATE THE LINE MODE
C             =  0  TO DRAW A LINE.
C
      INTEGER         PEN,PENX,OPT,PLOTER,TRA1,TRA2
      REAL            XY(2,2),INFNTY
      COMMON /PLTDAT/ MODEL,PLOTER,REG(2,2),SKPPLT(14),SKPA(6),NPENS
      DATA    INFNTY/ 1.E+10 /
C
      IF (OPT .NE. 0) GO TO 220
      SLP = INFNTY
      B   = 0.
      IF (X1 .EQ. X2) GO TO 10
      SLP = (Y2-Y1)/(X2-X1)
      B   =  Y1 - SLP*X1
   10 XY(1,1) = X1
      XY(2,1) = Y1
      XY(1,2) = X2
      XY(2,2) = Y2
C
C     CHECK TO SEE IF AN END OF THE LINE IS OUTSIDE THE PLOT REGION.
C
   20 DO 30 J = 1, 2
      DO 30 I = 1,2
      IF (XY(I,J).LT.REG(I,1) .OR. XY(I,J).GT.REG(I,2)) GO TO 40
   30 CONTINUE
      GO TO 210
   40 DO 50 I = 1,2
      IF (XY(I,1).LT.REG(I,1) .AND. XY(I,2).LT.REG(I,1)) GO TO 230
      IF (XY(I,1).GT.REG(I,2) .AND. XY(I,2).GT.REG(I,2)) GO TO 230
   50 CONTINUE
C
C     AN END IS OUTSIDE THE REGION, BUT NOT THE ENTIRE LINE. FIND THE
C     END POINTS OF THE PORTION OF THE LINE WITHIN THE REGION.
C
      J = 1
   60 I = 1
   70 IF (XY(I,J) .GE. REG(I,1)) GO TO 130
      ASSIGN 120 TO TRA2
      GO TO (100,110), I
  100 ASSIGN 350 TO TRA1
      X = REG(1,1)
      GO TO 300
  110 ASSIGN 310 TO TRA1
      Y = REG(2,1)
      GO TO 300
  120 XY(1,J) = X
      XY(2,J) = Y
C
  130 IF (XY(I,J) .LE. REG(I,2)) GO TO 170
      ASSIGN 160 TO TRA2
      GO TO (140,150), I
  140 ASSIGN 350 TO TRA1
      X = REG(1,2)
      GO TO 300
  150 ASSIGN 310 TO TRA1
      Y = REG(2,2)
      GO TO 300
  160 XY(1,J) = X
      XY(2,J) = Y
  170 I = I + 1
      IF (I .EQ. 2) GO TO 70
      J = J + 1
      IF (J .EQ. 2) GO TO 60
C
C     MAKE SURE THE LINE SEGMENT IS WITHIN THE PLOT REGION.
C
      DO 200 J = 1,2
      DO 200 I = 1,2
      IF (XY(I,J)+.1.LT.REG(I,1) .OR. XY(I,J)-.1.GT.REG(I,2)) GO TO 400
  200 CONTINUE
C
C     FIND THE CORRECT PEN NUMBER FOR THIS PLOTTER.
C
  210 PEN = PENX
      PEN = PEN - NPENS*((PEN-1)/NPENS)
C
C     DRAW THE LINE.
C
  220 CALL LINE10 (XY(1,1),XY(2,1),XY(1,2),XY(2,2),PEN,OPT)
      GO TO 400
C
  230 IFL = 0
      DO 250 J = 1, 2
      DO 240 M = 1, 2
      IF (ABS(XY(I,J)-REG(I,M)) .GT. 1.0E-8) GO TO 240
      IFL = 1
      XY(I,J) = REG(I,M)
  240 CONTINUE
  250 CONTINUE
      IF (IFL) 400,400,20
C
C
C     CALCULATE THE EQUATION OF THE LINE TO BE DRAWN.
C
  300 GO TO TRA1, (310,350)
C
C     GIVEN Y, CALCULATE X.
C
  310 IF (SLP .EQ. INFNTY) GO TO 330
      IF (SLP .EQ.     0.) GO TO 320
      X = (Y-B)/SLP
      GO TO 340
  320 X = INFNTY
      GO TO 340
  330 X = X1
  340 GO TO TRA2, (120,160)
C
C     GIVEN X, CALCULATE Y.
C
  350 IF (SLP .EQ. INFNTY) GO TO 370
      IF (SLP .EQ.     0.) GO TO 360
      Y = SLP*X + B
      GO TO 380
  360 Y = Y1
      GO TO 380
  370 Y = INFNTY
  380 GO TO TRA2, (120,160)
C
  400 RETURN
      END

      SUBROUTINE SD2RHD (ISTYP,ISETUP)
C
C     THIS ROUTINE WRITES HEADING FOR PRECISION CHECK IN SDR2E.
C     WORDS 1,2,6 AND 7 PRESET BY CALLING ROUTINE.
C     ISETUP.NE.0 FIRST CALL.
C
      INTEGER BRANCH, LDMD(8)  ,ISTYP(7)
      COMMON /SDR2X4/ DUMMY(50),BRANCH
      COMMON /SYSTEM/ ISYSB    ,NOUT
      EQUIVALENCE     (ISTYP6,RSTYP6), (ISTYP7,RSTYP7)
      DATA    LDMD  / 4HLOAD, 4HMODE, 4H, FR, 4HEQ.=, 4H, EI, 4HGEN=,
     1                4H, TI, 4HME =  /
C
      IF (ISETUP .EQ. 0) GO TO 1510
      GO TO (1501,1503,1501,1501,1503,1505,1501,1507,1507,1501), BRANCH
C
C     STATICS
C
 1501 N1 = 3
      ISTYP(3) = LDMD(1)
      GO TO 1510
C
C     EIGR,FREQ
C
 1503 N1 = 6
      ISTYP(3) = LDMD(2)
      ISTYP(4) = LDMD(3)
      ISTYP(5) = LDMD(4)
      GO TO 1510
C
C     TRANSIENT
C
 1505 N1 = 6
      ISTYP(3) = LDMD(1)
      ISTYP(4) = LDMD(7)
      ISTYP(5) = LDMD(8)
      GO TO 1510
C
C     BUCKLING, COMPLEX EIGENVALUE
C
 1507 N1 = 6
      ISTYP(3) = LDMD(2)
      ISTYP(4) = LDMD(5)
      ISTYP(5) = LDMD(6)
      IF (BRANCH.EQ.9) N1 = 7
C
 1510 CALL PAGE2 (3)
      ISTYP6 = ISTYP(6)
      ISTYP7 = ISTYP(7)
      IF (N1 .EQ. 3) WRITE(NOUT,1512) (ISTYP(I),I=1,N1)
      IF (N1 .EQ. 6) WRITE(NOUT,1512) (ISTYP(I),I=1,5),RSTYP6
      IF (N1 .EQ. 7) WRITE(NOUT,1512) (ISTYP(I),I=1,5),RSTYP6,RSTYP7
 1512 FORMAT (1H0,5X,45HE L E M E N T   P R E C I S I O N   C H E C K,
     1   /4X,32HSIGNIFICANT DIGITS FOR SUBCASE =,I7,1H,,I7,3H = ,3A4,
     2   1P,2E15.6)
      RETURN
      END

      SUBROUTINE PNM(M,N,X,IR,V)
      DIMENSION GAMMA(81)
      IF(N.LT.M) GO TO 2
      IF(N.EQ.0) GO TO 1
      GO TO 3
    1 V=1.0
      RETURN
    2 V=0.0
      RETURN
    3 Z=1.0
      W=Z
      IF(N.EQ.M) GO TO 4
      NMM=N-M
      DO 5 I=1,NMM
    5 Z=X*Z
    4 GAMMA(1)=1.0
      NPNN1=N+N+1
      DO 6 I=2,NPNN1
      GAMMA(I)=W*GAMMA(I-1)
    6 W=W+1.0
      W=1.0
      ABXX=ABS(X)
      IF(ABXX.LT.0.001) GO TO 7
      GO TO 8
    7 I=(N-M)/2
      I2=2*I
      NMM=N-M
      IF(I2.NE.NMM) GO TO 9
      V=GAMMA(M+N+1)/(GAMMA(I+1)*GAMMA(M+I+1))
      IF(IR.NE.0) GO TO 100
      V=V*(-1.0)**I
      GO TO 100
    9 V=0.0
      RETURN
    8 Y=W/(X*X)
      IF(IR.EQ.0) GO TO 11
      GO TO 12
   11 Y=-Y
      W=-W
   12 J=3
      V=0.0
      DO 13 I=1,22
      II=(N-M+2)/2
      IF(II.LT.I) GO TO 100
      V=V+GAMMA(N+N-I-I+3)*Z/(GAMMA(I)*GAMMA(N-I+2)*GAMMA(N-I-I-M+J))
   13 Z=Z*Y
  100 Z=1.0
      DO 101 I=1,N
  101 Z=Z+Z
      V=V/Z
      IF(IR.NE.0) GO TO 102
      GO TO 103
  102 II=N/4
      I=N-4*II
      IF(I.GT.1) GO TO 104
      GO TO 103
  104  V=-V
  103  IF(M.EQ.0) RETURN
      J=M/2
      CF=W+X*X
      Z=ABS(CF)
      J2=J+J
      IF(M.NE.J2) GO TO 107
      GO TO 105
  107 Z=SQRT(Z)
      J=M
  105 IF(J.LT.1) J=1
      DO 106 I=1,J
  106 V=V*Z
      RETURN
      END

      SUBROUTINE BDAT05
C
C     THIS SUBROUTINE PROCESSES THE GNEW BULK DATA
C
      LOGICAL         TDAT
      INTEGER         SCR2,BUF3,SCBDAT,BUF2,BUF1,GNEW(2),FLAG,GEOM4,
     1                CONSET,AAA(2),Z,OUTT,SCORE
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /ZZZZZZ/ Z(1)
      COMMON /CMB001/ SCR1,SCR2,SCBDAT,SCSFIL,SCCONN,SCMCON,
     1                SCTOC,GEOM4,CASECC
      COMMON /CMB002/ BUF1,BUF2,BUF3,BUF4,BUF5,SCORE,LCORE,INPT,OUTT
      COMMON /CMB003/ COMBO(7,5),CONSET,IAUTO,TOLER,NPSUB
      COMMON /CMB004/ TDAT(6)
      COMMON /BLANK / STEP,IDRY
      DATA    GNEW  / 1410,14 / , AAA/ 4HBDAT,4H05   /
C
      IFILE = SCR2
      CALL OPEN (*30,SCR2,Z(BUF3),1)
      IFILE = GEOM4
      CALL LOCATE (*20,Z(BUF1),GNEW,FLAG)
      WRITE  (OUTT,10) UFM
 10   FORMAT (A23,' 6532, THE GNEW OPTION IS NOT CURRENTLY AVAILABLE.')
      IDRY = -2
      RETURN
C
 20   CALL EOF (SCBDAT)
      CALL CLOSE (SCR2,1)
      RETURN
C
 30   IMSG = -1
      CALL MESAGE (IMSG,IFILE,AAA)
      RETURN
      END

      SUBROUTINE FNDPNT (IARY,ID)
C
      INTEGER         NAME(2),OLD,BGPDT,SIL,EDT
      DIMENSION       IARY(4),ISAVE(4),ARRY(3),IRY(3),IEDT(2),ICORE(1),
     1                IFED(2)
      COMMON /SYSTEM/ IBUF,NOUT
      COMMON /FPT   / DUM(3),NROW1,LCORE
      COMMON /ZZZZZZ/ CORE(1)
      COMMON /LOADX / I1(2),BGPDT,OLD,CSTM,SIL,ISIL,I2,MPT,GPTT,EDT,
     1                IMPT,IGPTT,IED
      EQUIVALENCE     (IRY(1),ARRY(1)), (CORE(1),ICORE(1))
      DATA    NAME  / 4HFNDP,4HNT  /
      DATA    IEDT  / 4HEDT ,4HFEDT/, IFED/4HFEDT,4HST  /
C
C     FIND POINT ON BGPDT
C
      IF (ID .LT. 0) GO TO 90
      IF (ID.LT.268435455 .AND. OLD.GE.0) GO TO 10
C               268435455 = 2**28 - 1
      WRITE  (NOUT,5) ID,OLD
    5 FORMAT (//,' BAD DATA PASSED TO FNDPNT, ID,OLD =',2I14)
      CALL MESAGE (-37,0,NAME)
   10 NS = 4*(ID-OLD)
      IF (NS-4) 70,30,20
   20 CALL READ (*90,*90,BGPDT,ISAVE(1),-NS+4,0,FLAG)
   30 CALL READ (*90,*90,BGPDT,ISAVE(1),    4,0,FLAG)
      OLD = ID
   40 DO 50 I = 1,4
   50 IARY(I) = ISAVE(I)
   60 RETURN
C
   70 IF (NS) 80,40,80
   80 CALL BCKREC (BGPDT)
      OLD = 0
      GO TO 10
C
   90 IPM = BGPDT
  100 CALL MESAGE (-2,IPM,NAME)
  110 IPM = SIL
      GO TO 100
  120 IPM = EDT
      GO TO 100
C
C
      ENTRY FNDSIL (IP)
C     =================
C
C     FIND SIL VALUE
C
  130 NS = IP - ISIL
      IF (NS-1) 140,170,160
  140 IF (NS) 150,180,150
  150 CALL BCKREC (SIL)
      ISIL = 0
      GO TO 130
  160 CALL READ (*110,*110,SIL,I,-NS+1,0,FLAG)
  170 CALL READ (*110,*110,SIL,IF,   1,0,FLAG)
      ISIL = IP
  180 IP   = IF
      GO TO 60
C
C
      ENTRY FEDTST (IDEF)
C     ===================
C
C     FIND ENFORCED DISPLACEMENT
C
C     PUT DEFORM EID S AND VALUES INTO CORE FOR THIS SET
C
      ICP = NROW1 + 1
      K   = 0
      CALL READ (*120,*120,EDT,ARRY(1),-3,0,FLAG)
  200 CALL READ (*120,*210,EDT,ARRY(1), 3,0,FLAG)
      IF (IDEF.NE.IRY(1) .AND. K.EQ.0) GO TO 200
      IF (IDEF .NE. IRY(1)) GO TO 210
      K = K + 2
      CORE(ICP+K   ) = ARRY(3)
      ICORE(ICP+K-1) = IRY(2)
      IF (LCORE-NROW1+K .LE. 0) CALL MESAGE (-8,IPM,IFED)
      GO TO 200
  210 IF (K .EQ. 0) CALL MESAGE (-32,IDEF,IEDT)
      CALL BCKREC (EDT)
      GO TO 60
C
C
      ENTRY FEDT (IED1,DELTA,IDEF)
C     ============================
C
C     FIND VALUE FOR EID IF IT EXISTS
C
      DO 220 I = 1,K,2
      IF (IED1 .NE. ICORE(ICP+I)) GO TO 220
      ICORE(ICP+I) = -ICORE(ICP+I)
      DELTA = CORE(ICP+I+1)
      GO TO 60
  220 CONTINUE
      DELTA = 0.0
      GO TO 60
C
C
      ENTRY FEDTED (IDEF)
C     ===================
C
C     CHECK TO SEE IF ALL ELEMENTS IN THE SET WERE USED
C
      IFOUND = 0
      DO 230 I = 1,K,2
      IF (ICORE(ICP+I) .LT. 0) GO TO 230
      IEDT(1) = ICORE(ICP+I)
      IEDT(2) = IDEF
      CALL MESAGE (30,139,IEDT)
      IFOUND = 1
  230 CONTINUE
      IF (IFOUND .EQ. 1) CALL MESAGE (-61,0,0)
      GO TO 60
      END

      SUBROUTINE IBMOPN (*,*,LU,FNAME)
C
C     THIS MDS SUBROUTINE OPENS AN IBM FORTRAN LOGICAL UNIT WHICH HAS
C     NOT BEEN ASSIGNED EXTERNALLY.
C
C     THIS SUBROUTINE USES THE FOLLOWING 3 IBM SYSTEM ROUTINES:
C
C     IQZDDN - TO DETERMINE WHETHER FILE ALREADY EXISTS OR NOT
C     QQDCBF - TO DYNAMICALLY BUILD AN ATTRIBUTE LIST BY DDNAME
C     QQGETF - TO DYNAMICALLY ALLOCATE FILE IN TSO OR BATCH
C
C     ALTERNATE RETURN 1: FILE OPENED SUCESSFULLY
C     ALTERNATE RETURN 2: ERROR OPENING FILE
C
      CHARACTER  FNAME*8, OLD*3, NEW*3, ODNW*3
      DATA       OLD, NEW / 'OLD', 'NEW' /
C
      ISTUS = IQZDDN(FNAME)
      ODNW  = OLD
      IF (ISTUS .NE. 0) GO TO 10
      ODNW = NEW
      CALL QQDCBF (FNAME,0,'F  ',80,80,DA)
   10 CALL QQGETF (LU,FNAME,IERR)
      IF (IERR .NE. 0) GO TO 20
      OPEN (UNIT=LU,FILE=FNAME,STATUS=ODNW,ERR=20)
      RETURN 1
C
C     ERROR
C
   20 RETURN 2
      END

      SUBROUTINE OFCOMP (*,FILE,TYPE,ELTYP,IAPP,HEADNG,PNCHED,FORM)
C
C     OFP ROUTINE TO HANDLE PRINT AND PUNCH OF LAYERED COMPOSITE
C     ELEMENT STRESSES AND FORCES.  CURRENTLY, THIS INVOLVES ONLY
C     THE CQUAD4 AND CTRIA3 ELEMENTS.
C
C     FILE     = OUTPUT FILE UNDER PROCESSING
C     TYPE     = TYPE OF DATA-  REAL   , SORT 1       = 1
C                               COMPLEX, SORT 1       = 2
C                               REAL   , SORT 2       = 3
C                               COMPLEX, SORT 2       = 4
C     ELTYP    = ELEMENT TYPE-  QUAD4                 = 64
C                               TRIA3                 = 83
C     IAPP     = SOLUTION TYPE
C     HEADNG   = INDICATES PRINT HEADINGS ARE DONE FOR A PAGE
C     PNCHED   = INDICATES PUNCH HEADINGS ARE DONE
C     FORM     = DATA TYPE-     STRESSES              = 22
C                               FORCES                = 23
C                               STRAIN                = 21
C
      EXTERNAL        ANDF
      LOGICAL         HEAT,PNCHED,CMPXDT,SORT1,SORT2,HEADNG,MAGPHA,
     1                QUAD4,TRIA3,STRESS,FORCE,STRN
      INTEGER         IST(86),FILE,FLAG,NOUT,PUNCH,BUF(86),IBUF(3),
     1                DEVICE,ANDF,HEAD,TYPE,ELTYP,FORM,STATIC,FREQ,
     2                CEIG,ITITLE(32),ISUBTL(32),LABEL(32),ELEMID,
     3                FAILTH,HILL(2),HOFFMN(2),TSAIWU(2),STRESF(2),
     4                STRAIN(2),IFAIL(2),BLNK,ASTR,SUBST(3),
     5                ID(50),OF(58)
C     INTEGER         REIG,TRANS,BK1,ELEC
      REAL            RST(86),RID(50),BUFR(86),RBUF(3)
C     REAL            HARMON,PANGLE,BUFF(1)
      CHARACTER*5     T3Q4,T3,Q4
      COMMON /BLANK / ICARD
C     COMMON /ZZOFPX/ L1,L2,L3,L4,L5,ID(50),HARMON,PANGLE,BUFF(1)
      COMMON /ZZZZZZ/ CORE(1)
      COMMON /OUTPUT/ HEAD(96)
      COMMON /SYSTEM/ KSYSTM(100)
      EQUIVALENCE     (IST(1)    ,RST(1) ), (ID(1)     ,RID(1)  ),
     1                (BUF(1)    ,BUFR(1)), (IBUF(1)   ,RBUF(1) ),
     2                (IFAIL(1)  ,FAILMX ), (IFAIL(2)  ,MAXFLG  ),
     3                (KSYSTM(2) ,NOUT   ), (KSYSTM(9) ,MAXLNS  ),
     4                (KSYSTM(12),LINE   ), (KSYSTM(33),IFLG    ),
     5                (KSYSTM(56),ITHERM ), (KSYSTM(69),ISUBS   ),
     6                (KSYSTM(91),PUNCH  ), (HEAD( 1) ,ITITLE(1)),
     7                (HEAD(65) ,LABEL(1)), (HEAD(33) ,ISUBTL(1)),
     8                (L1, OF(1) ,CORE(1)), (L2,OF(2)),(L3,OF(3)),
     9                (ID(1)     ,OF  (6)), (L4,OF(4)),(L5,OF(5))
C     EQUIVALENCE     (HARMON    ,OF (56)), (PANGLE   ,OF   (57)),
C    1                (BUFF(1)   ,OF (58))
C
      DATA  STATIC,FREQ,CEIG    / 1 , 5 , 9      /
C     DATA  REIG,TRANS,BK1,ELEC / 2 , 6 , 8 , 11 /
      DATA  HILL  ,       HOFFMN,       TSAIWU,       STRESF       /
     1      4H   H,4HILL ,4HHOFF,4HMAN ,4HTSAI,4H-WU ,4H STR,4HESS /
      DATA  STRAIN       /4H STR,4HAIN /
      DATA  BLNK  ,ASTR  /4H    ,4H  * /
      DATA  SUBST        /4HSUBS,4HTRUC,4HTURE /
      DATA  T3Q4, T3, Q4 /' ', 'TRIA3', 'QUAD4'/
C
C     INITIALIZE
C
      CMPXDT = TYPE.EQ.2 .OR. TYPE.EQ.4
      SORT1  = TYPE  .LE. 2
      SORT2  = TYPE  .GT. 2
      HEAT   = ITHERM.EQ. 1
      MAGPHA = ID(9).EQ.3 .AND. (IAPP.EQ.FREQ .OR. IAPP.EQ.CEIG)
      QUAD4  = ELTYP .EQ. 64
      TRIA3  = ELTYP .EQ. 83
      STRESS = FORM  .EQ. 22
      FORCE  = FORM  .EQ. 23
      STRN   = FORM  .EQ. 21
      IF (HEAT .OR. SORT2 .OR. CMPXDT) GO TO 1800
C
C     GET THE DEVICE CODE IF SORT=2,  1=PRINT  2=POST  4=PUNCH
C
      IF (SORT1) GO TO 10
      IDD = ID(5)/10
      DEVICE = ID(5) - 10*IDD
      IDEVCE = DEVICE
      ID(5)  = IDD
      ELEMID = IDD
   10 CONTINUE
C
C     GET THE NUMBER OF OUTPUT WORDS PER ELEMENT.
C
      NWDS = ID(10)
      IF (NWDS .EQ. 0) GO TO 1800
      IF (FORCE) GO TO 40
C
C     ********************
C     ******* READ *******
C     ********************
C
   20 CALL READ (*1910,*1800,FILE,IST(1),3,0,FLAG)
      IF (SORT1) ELEMID = IST(1)
      IF (SORT2) TIME = RST(1)
      NLAYER = IST(2)
      FAILTH = IST(3)
      IPLY = 0
   30 IPLY = IPLY + 1
      IF (IPLY .GT. NLAYER) GO TO 20
C
   40 CALL READ (*1910,*1900,FILE,IST(1),NWDS,0,FLAG)
      IF (STRESS .AND. IPLY.EQ.NLAYER)
     1    CALL READ (*1910,*1910,FILE,IFAIL,2,0,FLAG)
      IF (FORCE) ELEMID = IST(1)
C
C     GET THE DEVICE CODE IF SORT=1,   1=PRINT  2=POST  4=PUNCH
C
      IF (SORT2) GO TO 100
      IF (STRESS .AND. IPLY.GT.1) GO TO 100
      ITEMP  = ELEMID / 10
      DEVICE = ELEMID - 10*ITEMP
      IDEVCE = DEVICE
      ELEMID = ITEMP
C
C     *********************
C     ******* PUNCH *******
C     *********************
C
  100 IF (DEVICE .LT. 4) GO TO 820
C
C     TAKE OUT INDEX FAILURE FLAGS FOR STRESSES
C
      NUMWDS = NWDS
      IF (STRESS) NUMWDS = NUMWDS - 2
      DO 110 II=1,NWDS
  110 BUF(II) = IST(II)
      IF (FORCE) GO TO 120
      BUF(6) = BUF(7)
      BUF(7) = BUF(8)
      BUF(8) = BUF(9)
  120 CONTINUE
C
      IF (PNCHED) GO TO 500
C
C     PUNCH HEADINGS - TITLE, SUBTITLE, AND LABEL
C
      ICARD = ICARD + 1
      WRITE  (PUNCH,130) (ITITLE(J),J=1,15),ICARD
      ICARD = ICARD + 1
      WRITE  (PUNCH,140) (ISUBTL(J),J=1,15),ICARD
      ICARD = ICARD + 1
      WRITE  (PUNCH,150) ( LABEL(J),J=1,15),ICARD
  130 FORMAT (10H$TITLE   =,15A4,2X,I8)
  140 FORMAT (10H$SUBTITLE=,15A4,2X,I8)
  150 FORMAT (10H$LABEL   =,15A4,2X,I8)
C
C     IF SUBSTRUCTURE (PHASE2) EXTRACTED ALSO SUBS-NAME AND COMPONENT
C
      IF (ISUBS .EQ. 0) GO TO 170
      IF (ISUBTL(20).NE.SUBST(1) .OR. ISUBTL(21).NE.SUBST(2) .OR.
     1    ISUBTL(22).NE.SUBST(3)) GO TO 170
      ICARD = ICARD + 1
      WRITE (PUNCH,160) (ISUBTL(J),J=20,26),ICARD
      ICARD = ICARD + 1
      WRITE  (PUNCH,160) ( LABEL(J),J=20,26),ICARD
  160 FORMAT (1H$,7A4,43X,I8)
C
  170 ICARD = ICARD + 1
      IF (STRESS) WRITE (PUNCH,190) ICARD
      IF (FORCE ) WRITE (PUNCH,180) ICARD
  180 FORMAT (15H$ELEMENT FORCES,57X,I8)
  190 FORMAT (17H$ELEMENT STRESSES,55X,I8)
C
C     REAL, REAL/IMAGINARY, MAGNITUDE/PHASE
C
      ICARD = ICARD + 1
      IF (CMPXDT) GO TO 200
      WRITE  (PUNCH,220) ICARD
      GO TO 250
  200 IF (MAGPHA) GO TO 210
      WRITE  (PUNCH,230) ICARD
      GO TO 250
  210 WRITE  (PUNCH,240) ICARD
  220 FORMAT (12H$REAL OUTPUT,60X,I8)
  230 FORMAT (22H$REAL-IMAGINARY OUTPUT,50X,I8)
  240 FORMAT (23H$MAGNITUDE-PHASE OUTPUT,49X,I8)
C
C     SUBCASE OR ELEMENT ID
C
  250 ICARD = ICARD + 1
      IF (SORT2) GO TO 260
      WRITE  (PUNCH,280) ID(4),ICARD
      GO TO 270
  260 WRITE  (PUNCH,290) ELEMID,ICARD
  270 CONTINUE
  280 FORMAT (13H$SUBCASE ID =,I12,47X,I8)
  290 FORMAT (13H$ELEMENT ID =,I10,49X,I8)
C
C     PUNCH ELEMENT TYPE NUMBER,
C     IT IS SWITCHED TO MATCH THOSE OF POST PROCESSOR.
C
      ICARD  = ICARD + 1
      IELTYP = ID(3)
      T3Q4   = T3
      IF (IELTYP .EQ. 64) T3Q4 = Q4
      WRITE  (PUNCH,300) IELTYP,T3Q4,ICARD
  300 FORMAT (15H$ELEMENT TYPE =,I12,4H   (,A5,1H),37X,I8)
C
C     EIGENVALUE, FREQUENCY, OR TIME
C
      GO TO (480,400,480,480,440,450,480,400,400,480,480), IAPP
C
C     PUNCH EIGENVALUE
C
  400 ICARD = ICARD + 1
      IF (SORT1 .AND. CMPXDT) GO TO 410
      WRITE  (PUNCH,420) RID(6),ID(5),ICARD
      GO TO 480
  410 WRITE  (PUNCH,430) RID(6),RID(7),ID(5),ICARD
      GO TO 480
  420 FORMAT (13H$EIGENVALUE =,E15.7,2X,6HMODE =,I6,30X,I8)
  430 FORMAT (15H$EIGENVALUE = (,E15.7,1H,,E15.7,8H) MODE =,I6,12X,I8)
C
C     FREQUENCY OR TIME
C
  440 IF (SORT2) GO TO 480
      ICARD = ICARD + 1
      WRITE  (PUNCH,460) RID(5),ICARD
      GO TO 480
  450 IF (SORT2) GO TO 480
      ICARD = ICARD + 1
      WRITE  (PUNCH,470) RID(5),ICARD
  460 FORMAT (12H$FREQUENCY =,E16.7,44X,I8)
  470 FORMAT (7H$TIME =,E16.7,49X,I8)
C
  480 PNCHED = .TRUE.
C
C     PUNCH HEADINGS COMPLETE
C
  500 ICARD = ICARD + 1
C
C     ELEMENT STRESSES,  FIRST SUB-RECORD
C
      IF (FORCE) GO TO 570
      IF (IPLY .LE. 1) GO TO 520
      WRITE  (PUNCH,510) BUF(1),BUFR(2),BUFR(3),ICARD
  510 FORMAT (6H-CONT-,12X,I10,8X,2(1P,E18.6),I8)
      GO TO 560
C
  520 IF (SORT2 .AND. IAPP.NE.STATIC) GO TO 540
C
C     FIRST CARD BEGINS WITH AN INTEGER
C
      WRITE  (PUNCH,530) ELEMID,BUF(1),BUFR(2),BUFR(3),ICARD
  530 FORMAT (I10,8X,I10,8X,2(1P,E18.6),I8)
      GO TO 560
C
C     FIRST CARD BEGINS WITH A REAL
C
  540 WRITE  (PUNCH,550) TIME,BUF(1),BUFR(2),BUFR(3),ICARD
  550 FORMAT (1P,E18.6,I10,8X,2(1P,E18.6),I8)
  560 NWORD = 3
      GO TO 620
C
C     ELEMENT FORCES,  FIRST SUB-RECORD
C
  570 IF (SORT2 .AND. IAPP.NE.STATIC) GO TO 590
C
C     FIRST CARD BEGINS WITH AN INTEGER
C
      WRITE  (PUNCH,580) BUF(1),BUFR(2),BUFR(3),BUFR(4),ICARD
  580 FORMAT (I10,8X,3(1P,E18.6),I8)
      GO TO 610
C
C     FIRST CARD BEGINS WITH A REAL
C
  590 WRITE  (PUNCH,600) BUFR(1),BUFR(2),BUFR(3),BUFR(4),ICARD
  600 FORMAT (4(1P,E18.6),I8)
  610 NWORD = 4
C
  620 LENGTH = 8
C
C     SUBSEQUENT SUB-RECORDS
C
  700 LEFT = NUMWDS - NWORD
      IF (LEFT .GT. 0) GO TO 710
      IF (SORT1) GO TO 810
      GO TO 820
C
C     PUNCH THE SUB-RECORDS
C
  710 IF (NWORD .GE. LENGTH) GO TO 700
      ICARD = ICARD + 1
      NWORD = NWORD + 3
      JOUT  = 3
      IF (NWORD .LE. LENGTH) GO TO  720
      NWORD = NWORD - 1
      JOUT  = 2
      IF (NWORD .EQ. LENGTH) GO TO  720
      NWORD = NWORD - 1
      JOUT  = 1
C
  720 JJ = NWORD - JOUT + 1
      DO 730 II = 1,JOUT
      IBUF(II) = BUF(JJ)
  730 JJ = JJ + 1
      GO TO (740,760,780), JOUT
C
C     1 WORD OUT
C
  740 WRITE  (PUNCH,750) RBUF(1),ICARD
  750 FORMAT (6H-CONT-,12X,1P,E18.6,36X,I8)
      GO TO 800
C
C     2 WORDS OUT
C
  760 IF (IPLY .LT. NLAYER) WRITE (PUNCH,770) RBUF(1),RBUF(2),ICARD
      IF (IPLY .EQ. NLAYER) WRITE (PUNCH,775) RBUF(1),RBUF(2),RBUF(3),
     1    ICARD
  770 FORMAT (6H-CONT-,12X,1P,E18.6,0P,F18.4,18X,I8)
  775 FORMAT (6H-CONT-,12X,1P,E18.6, 2(0P,F18.4),I8)
      GO TO 800
C
C     3 WORDS OUT
C
  780 WRITE  (PUNCH,790) RBUF(1),RBUF(2),RBUF(3),ICARD
  790 FORMAT (6H-CONT-,12X,1P,E18.6,0P,F18.4,1P,E18.6,I8)
  800 IF (JOUT .LT. 3) GO TO 700
      GO TO 710
C
C     END OF PUNCH, SEE IF PRINT IS REQUESTED
C
  810 IDEVCE = DEVICE - 4
  820 IF (ANDF(IDEVCE,1) .NE. 0) GO TO 900
      IF (STRESS) GO TO 30
      GO TO 40
C
C     *********************
C     ******* PRINT *******
C     *********************
C
C     WRITE TITLES IF HAVE NOT DONE SO YET
C
  900 ICHECK = 0
      IF (LINE.LE.MAXLNS-2 .AND. HEADNG) GO TO 910
      IFLG = 1
      CALL PAGE1
      HEADNG = .TRUE.
      ICHECK = 1
C
C     *** PRINT OF ELEMENT STRESSES ***
C
  910 IF (FORCE) GO TO 1500
C
C     BRANCH ON TYPE OF OUTPUT
C
      GO TO (920,1400,1410,1420), TYPE
C
C     *** REAL, SORT 1 ***
C
  920 IF (ICHECK .EQ. 0) GO TO 1200
      GO TO (960,930,960,960,960,940,960,950,960,960,960), IAPP
C
  930 WRITE  (NOUT,970) ID(5),RID(8),RID(6)
      GO TO 1010
  940 WRITE  (NOUT,980) RID(5)
      GO TO 1010
  950 WRITE  (NOUT,990) RID(6)
      GO TO 1010
  960 WRITE  (NOUT,1000)
  970 FORMAT (6X,'MODE NUMBER = ',I4,26X,'FREQUENCY = ',1P,E13.6,26X,
     1       'EIGENVALUE = ',1P,E13.6)
  980 FORMAT (6X,6HTIME =,1P,E14.6)
  990 FORMAT (6X,12HEIGENVALUE =,1P,E14.6)
 1000 FORMAT (1H )
C
 1010 CONTINUE
      IF (QUAD4) GO TO 1020
      IF (TRIA3) GO TO 1030
      GO TO 1050
 1020 WRITE  (NOUT,1070)
      GO TO 1050
 1030 WRITE  (NOUT,1080)
      GO TO 1050
 1050 WRITE  (NOUT,1100)
      WRITE  (NOUT,1110)
 1070 FORMAT (20X,'S T R E S S E S   I N   L A Y E R E D   ',
     1        'C O M P O S I T E   E L E M E N T S   ( Q U A D 4 )')
 1080 FORMAT (20X,'S T R E S S E S   I N   L A Y E R E D   ',
     1        'C O M P O S I T E   E L E M E N T S   ( T R I A 3 )')
 1100 FORMAT ('0 ELEMENT',3X,'PLY *STRESSES IN FIBER AND MATRIX',
     1        ' DIRECTIONS*  *DIRECT FIBER *  *INTER-LAMINAR STRESS',
     2        'ES*  * SHEAR BOND  *   *MAXIMUM*')
 1110 FORMAT (4X, 'ID', 6X, 'ID  *  NORMAL-1', 6X, 'NORMAL-2', 6X,
     1        'SHEAR-12 *  *FAILURE INDEX*  *SHEAR-1Z',6X,'SHEAR-2Z*',
     2        '  *FAILURE INDEX*   * INDEX *',/)
C
C     WRITE THE DATA
C     BUT FIRST, MODIFY THE FAILURE INDEX FLAGS FROM INTEGER TO BCD
C
 1200 IF (IST( 6) .EQ. 0) IST( 6) = BLNK
      IF (IST( 6) .EQ. 1) IST( 6) = ASTR
      IF (IST(10) .EQ. 0) IST(10) = BLNK
      IF (IST(10) .EQ. 1) IST(10) = ASTR
C
      IF (IPLY .GT. 1) GO TO 1220
      WRITE  (NOUT,1210) ELEMID,IST(1),(RST(K),K=2,5),IST(6),
     1                                 (RST(K),K=7,9),IST(10)
 1210 FORMAT (1H0,I8,2X,I4,3(1P,E14.5),2X,0P,F10.3,A4,2(1P,E14.5),
     1        0P,F10.3,A4)
      NLINES = 3
      GO TO 1730
C
 1220 WRITE  (NOUT,1230) IST(1),(RST(K),K=2,5),IST(6),
     1                          (RST(K),K=7,9),IST(10)
 1230 FORMAT (11X,I4,3(1P,E14.5),2X,0P,F10.3,A4,2(1P,E14.5),0P,F10.3,A4)
      NLINES = 1
      IF (IPLY .LT. NLAYER) GO TO 1730
C
C     IF THE LAST LAYER, CHECK THE MAXIMUM FAILURE INDEX
C
      NLINES = 2
      IF (MAXFLG .EQ. 0) MAXFLG = BLNK
      IF (MAXFLG .EQ. 1) MAXFLG = ASTR
      IF (FAILTH .NE. 0) GO TO (1250,1260,1270,1280,1290), FAILTH
      FAILMX = 0.0
      WRITE  (NOUT,1240) FAILMX
 1240 FORMAT (1H ,116X,0P,F10.3)
      GO TO 1730
 1250 WRITE  (NOUT,1300) HILL(1),HILL(2),FAILMX,MAXFLG
      GO TO 1730
 1260 WRITE  (NOUT,1300) HOFFMN(1),HOFFMN(2),FAILMX,MAXFLG
      GO TO 1730
 1270 WRITE  (NOUT,1300) TSAIWU(1),TSAIWU(2),FAILMX,MAXFLG
      GO TO 1730
 1280 WRITE  (NOUT,1300) STRESF(1),STRESF(2),FAILMX,MAXFLG
      GO TO 1730
 1290 WRITE  (NOUT,1300) STRAIN(1),STRAIN(2),FAILMX,MAXFLG
 1300 FORMAT (1H ,41X,2A4,'FAILURE THEORY WAS USED FOR THIS ELEMENT.',
     1       26X,0P,F10.3,A4)
      GO TO 1730
C
C     *** COMPLEX, SORT 1 ***
C
 1400 GO TO 1800
C
C     *** REAL, SORT 2 ***
C
 1410 GO TO 1800
C
C     *** COMPLEX, SORT 2 ***
C
 1420 GO TO 1800
C
C     *** PRINT OF ELEMENT FORCES ***
C
 1500 CONTINUE
C
C     BRANCH ON TYPE OF OUTPUT
C
      GO TO (1510,1700,1710,1720), TYPE
C
C     *** REAL, SORT 1 ***
C
 1510 IF (ICHECK .EQ. 0) GO TO 1670
      GO TO (1550,1520,1550,1550,1550,1530,1550,1540,1550,1550,1550),
     1       IAPP
C
 1520 WRITE (NOUT,970) ID(5),RID(8),RID(6)
      GO TO 1560
 1530 WRITE (NOUT,980) RID(5)
      GO TO 1560
 1540 WRITE (NOUT,990) RID(6)
      GO TO 1560
 1550 WRITE (NOUT,1000)
C
 1560 IF (QUAD4) GO TO 1570
      IF (TRIA3) GO TO 1580
      GO TO 1600
 1570 WRITE  (NOUT,1620)
      GO TO 1600
 1580 WRITE  (NOUT,1630)
      GO TO 1600
 1600 WRITE  (NOUT,1650)
      WRITE  (NOUT,1660)
 1620 FORMAT (22X,'F O R C E S   I N   L A Y E R E D   C O M P O S ',
     1        'I T E   E L E M E N T S   ( Q U A D 4 )'/)
 1630 FORMAT (22X,'F O R C E S   I N   L A Y E R E D   C O M P O S ',
     1        'I T E   E L E M E N T S   ( T R I A 3 )'/)
 1650 FORMAT (6X,'ELEMENT',18X,'- MEMBRANE  FORCES -',22X,'- BENDING',
     1        '   MOMENTS -',11X,'- TRANSVERSE SHEAR FORCES -')
 1660 FORMAT (8X,'ID',16X,2HFX,12X,2HFY,12X,3HFXY,11X,
     1        2HMX,12X,2HMY,12X,3HMXY,11X,2HVX,12X,2HVY)
C
C     WRITE THE DATA
C
 1670 WRITE  (NOUT,1680) ELEMID,(RST(K),K=2,9)
 1680 FORMAT (1H0,4X,I8,6X,8(1X,1P,E13.5))
      NLINES = 2
      GO TO 1730
C
C     *** COMPLEX, SORT 1 ***
C
 1700 GO TO 1800
C
C     *** REAL, SORT 2 ***
C
 1710 GO TO 1800
C
C     *** COMPLEX, SORT 2 ***
C
 1720 GO TO 1800
C
C     DONE WITH ONE ENTRY, GO BACK AND READ ANOTHER ONE.
C
 1730 LINE = LINE + NLINES
      IF (STRESS) GO TO 30
      GO TO 40
C
 1800 CONTINUE
      RETURN
C
 1900 IF (FORCE) RETURN
 1910 CONTINUE
      RETURN 1
C
C
      END

      SUBROUTINE LODAPP
C
C     THIS MODULE APPENDS NEW LOAD VECTORS (PAPP AND POAP) TO THE
C     SUBSTRUCTURE  -NAME-.  THE NEW VECTORS ARE MERGED WITH ALREADY
C     EXISTING (PVEC AND POVE) MATRICES OR ARE SIMPLY RECOPIED AS
C     THE NEW PVEC AND POVE ITEMS. LOAP DATA IS ALSO MERGED WITH THE
C     LODS DATA OR IS SIMPLY COPIED AS THE NEW LODS ITEM.
C
C     SOF ITEMS -
C
C     LOAP - APPENDED LOAD SET IDENTIFICATION TABLE
C     PAPP - APPENDED LOAD MATRICES (G-SET)
C     POAP - APPENDED LOAD MATRICES (O-SET)
C     LODS - LOAD SET IDENTIFICATION TABLE **BECOMES THE NEW LODS**
C     PVEC - LOAD MATRICES (G-SET)         **BECOMES THE NEW PVEC**
C     POVE - LOAD MATRICES (O-SET)         **BECOMES THE NEW POVE**
C
      EXTERNAL        RSHIFT     ,ANDF
      LOGICAL         LPAPP      ,LPVEC      ,LPOAP      ,LPOVE      ,
     1                LMERG      ,LLSUB      ,MDIUP      ,DITUP
      INTEGER         RSHIFT     ,ANDF       ,BUF
      DIMENSION       IZ(1)      ,NN(2)      ,MCBLOC(7)  ,ADUMP(4000),
     1                NPROG(2)   ,NAME(2)    ,NAMELL(2)  ,ICORX(1)
      CHARACTER       UFM*23     ,UWM*25     ,UIM*29     ,SFM*25
      COMMON /XMSSG / UFM        ,UWM        ,UIM        ,SFM
      COMMON /BLANK / BUF(3)
      COMMON /SYSTEM/ ISBUFF     ,LP
      COMMON /PACKX / ITYPIN     ,ITYPOT     ,IFIRST     ,ILAST      ,
     1                INCR
      COMMON /PARMEG/ MCBK(7)    ,MCBK11(7)  ,MCBK21(7)  ,MCBK12(7)  ,
     1                MCBK22(7)  ,LCORE      ,IRULE
      COMMON /ZZZZZZ/ RZ(1)
      COMMON /NAMES / IRD        ,IRDREW     ,IWRT       ,IWRTRW     ,
     1                IREW       ,INOREW     ,IEFNRW     ,IRSP       ,
     2                IRDP       ,ICSP       ,ICDP       ,ISQURE     ,
     3                IRECT      ,IDIAG      ,IUPPER     ,ILOWER     ,
     4                ISYM
      COMMON /SOF   / DITDUM(6)  ,IODUM(8)   ,MDIDUM(4)  ,NXTDUM(15) ,
     1                DITUP      ,MDIUP
      EQUIVALENCE     (ICORX(1)  ,RZ(1))
      EQUIVALENCE     (RZ(1)     ,IZ(1))
      DATA    IPAPP , IPOAP      /101        ,102        /
      DATA    ISCR1 , ISCR2      ,ISCR3      ,ISCR4      ,ISCR5      ,
     1        ISCR6 , ISCR7      ,ISCR8      /
     2        301   , 302        ,303        ,304        ,305        ,
     3        306   , 307        ,308        /
      DATA    NPAPP , NPOAP      ,NPVEC      ,NPOVE      ,
     1        NLOAP , NLODS      /
     2        4HPAPP, 4HPOAP     ,4HPVEC     ,4HPOVE     ,
     3        4HLOAP, 4HLODS     /
      DATA    NPROG              /4HLODA     ,4HPP       /
      DATA    BLNK  / 4H         /
C
C     INITIALIZE PARAMETERS
C
      CALL TMTOGO (ITIME1)
      NAME(1) = BUF(1)
      NAME(2) = BUF(2)
      IDRY    = BUF(3)
      NCORE = KORSZ(IZ(1))
C
C     INITIALIZE OPEN CORE - THERE ARE NIZ WORDS AVAILABLE
C
      IB1  = NCORE - (ISBUFF+1)
      IB2  = IB1 - ISBUFF - 1
      IB3  = IB2 - ISBUFF
      IBUF1= IB3 - ISBUFF
      NIZ  = IBUF1 - 1
      NSTART = 1
C
C     TEST CORE
C
      NCHAVE = NIZ
      IF (NCHAVE .LE. 0) GO TO 7001
      CALL SOFOPN (IZ(IB1),IZ(IB2),IZ(IB3))
C
C     CHECK STATUS OF SUBSTRUCTURE BEING REFERENCED - NAME
C
      CALL SFETCH (NAME,NLODS,3,IGO)
      IF (IGO  .EQ. 4) GO TO 7002
      IF (IDRY .LT. 0) GO TO 1001
C
C     CHECK LOCATION OF THE PAPP VECTOR - EITHER ON FILE IPAPP OR SOF
C
      IZ(1) = IPAPP
      CALL RDTRL (IZ(1))
      IF (IZ(1) .GT. 0) GO TO 10
      LPAPP = .FALSE.
      IUAPP = ISCR1
      NITEM = NPAPP
      CALL MTRXI (IUAPP,NAME,NITEM,0,ITEST)
      IF (ITEST .NE. 1) GO TO 7003
      LPAPP = .TRUE.
      GO TO 20
   10 LPAPP = .TRUE.
      IUAPP = IPAPP
   20 CONTINUE
C
C     CHECK STATUS OF THE POAP VECTOR
C     FIRST GET THE NAME OF THE LOWER LEVEL SUBSTRUCTURE WHERE
C     THE POAP ITEM TO BE USED IS LOCATED
C
      LPOAP = .FALSE.
      LLSUB = .FALSE.
      CALL FNDLVL (NAME,NAMELL)
      IF (NAMELL(1) .EQ. BLNK) GO TO 7002
      IF (NAME(1).NE.NAMELL(1) .OR. NAME(2).NE.NAMELL(2)) LLSUB = .TRUE.
      IF (.NOT.LLSUB) GO TO 40
      IZ(1) = IPOAP
      CALL RDTRL (IZ(1))
      IF (IZ(1) .GT. 0) GO TO 30
      IUOAP = ISCR2
      NITEM = NPOAP
      CALL MTRXI (IUOAP,NAMELL,NITEM,0,ITEST)
      IF (ITEST .NE. 1) GO TO 40
      LPOAP = .TRUE.
      GO TO 40
   30 LPOAP = .TRUE.
      IUOAP = IPOAP
   40 CONTINUE
C
C     ESTABLISH TYPE OF CASE BEING RUN, I.E. THE CASE NO. BEING DEFINED
C     BY  NN(1) AND NN(2).
C
      NN(1) = 0
      NN(2) = 0
C
C     CHECK STATUS OF PVEC AND POVE VECTORS
C
C     1) PVEC
C
      LPVEC = .TRUE.
      IZ(1) = 0
      CALL SOFTRL (NAME,NPVEC,IZ(1))
      IF (IZ(1) .NE. 1) LPVEC = .FALSE.
C
C     2) POVE
C
      LPOVE = .TRUE.
      IZ(1) = 0
      IF (LLSUB) CALL SOFTRL (NAMELL,NPOVE,IZ(1))
      IF (IZ(1) .NE. 1) LPOVE = .FALSE.
C
C     KNOWING THE STATUS OF PAPP, PVEC, POAP, POVE DEFINE CASE NO.
C
      IF (LPAPP) GO TO 50
      NN(1) = 4
      IF (LPVEC) NN(1) = 3
      GO TO 60
   50 NN(1) = 2
      IF (LPVEC) NN(1) = 1
   60 CONTINUE
      IF (LPOAP) GO TO 70
      NN(2) = 4
      IF (LPOVE) NN(2) = 3
      GO TO 80
   70 NN(2) = 2
      IF (LPOVE) NN(2) = 1
   80 IGO = NN(2)
C
C     KNOWING NN(1) AND NN(2) THE CASE IS DEFINED
C
      IF (NN(1) .EQ. 1) GO TO (1001,7004,7004,1001), IGO
      IF (NN(1) .EQ. 2) GO TO (7004,1001,7004,1001), IGO
      IF (NN(1) .EQ. 3) GO TO 7004
      IF (NN(1) .EQ. 4) GO TO 7004
C
C     READ IN LOAP DATA
C
 1001 IRW = 1
      CALL SFETCH (NAME,NLOAP,IRW,ITLOAP)
      IF (ITLOAP .GT. 1) GO TO 7003
      CALL SUREAD (IZ(NSTART),-1,NWDS,ICHK)
      NL = IZ(NSTART+2)
      NS = IZ(NSTART+3)
      NFINI  = 4 + NS*3 + NL
      NSTART = 5 + NS*2
      NAS = 1
      NAF = NFINI
      NCHAVE = NFINI
      NSUBS  = NS
      IF (NCHAVE .GT. NIZ) GO TO 7001
      NBASN  = 4 + NSUBS*2 + 1
      DO 90 ILOOP = 1,NSUBS
      CALL SUREAD (IZ(NBASN),-1,NWDS,ICHK)
   90 NBASN  = IZ(NBASN) + 1 + NBASN
      NSTART = NAF + 1
      NPS    = NSTART
      LMERG  = .TRUE.
C
C     IF DRY RUN (IDRY .LT. 0) CHECK FOR LODS ITEM
C
      IF (IDRY .LT. 0) GO TO 1002
      IF (LPVEC) GO TO 1002
C
C     SIMPLE COPY OF NEW APPENDED LOADS TO SOF
C
C     NEW  LODS  ITEM
C
      NITEM = NLODS
      LMERG = .FALSE.
      ITEST = 3
      IRW   = 2
      CALL SFETCH (NAME,NITEM,IRW,ITEST)
      IF (ITEST .NE. 3) GO TO 7005
      NWDS = 4 + 2*IZ(NAS+3)
      CALL SUWRT (IZ(NAS),NWDS,2)
      NBASN = NAS + NWDS
      DO 101 N = 1,NSUBS
      NWDS = IZ(NBASN) + 1
      CALL SUWRT (IZ(NBASN),NWDS,2)
      NBASN = NBASN + NWDS
  101 CONTINUE
C
C     END OF ITEM CALL TO SUWRT
C
      CALL SUWRT (0,0,3)
C
C     NEW  PVEC  ITEM
C
      CALL MTRXO (IUAPP,NAME,NPVEC,0,ITEST)
C
C     NEW  POVE  ITEM  IF ANY
C
      CALL BUG (NPROG(1),101,LPOAP,1)
      IF (LPOAP) CALL MTRXO (IUOAP,NAMELL,NPOVE,0,ITEST)
C
C     MODULE IS FINISHED WITH THE DIRECT COPY CASE
C
      GO TO 7000
 1002 CONTINUE
C
C     ITS BEEN DETERMINED THAT A MERGE OPERATION WILL TAKE PLACE.  THE
C     ONLY CHECK NOW IS TO SEE IF A LODS ITEM EXISTS.
C
      IRW  = 1
      NITEM = NLODS
      CALL SFETCH (NAME,NITEM,IRW,ITLODS)
      IF (ITLODS.NE.1 .AND. IDRY.GT.0) GO TO 7003
      IF (ITLODS.NE.1 .AND. IDRY.LT.0) GO TO 9999
      CALL SUREAD (IZ(NSTART),-1,NWDS,ICHK)
      NCNT = NWDS + NAF
      NL   = IZ(NPS+2)
      NS   = IZ(NPS+3)
      NFINI= NPS + 3 + 3*NS + NL
      NPF  = NFINI
      NSTART = NPF + 1
      NCHAVE = NFINI
      IF (NCHAVE .GT. NIZ) GO TO 7001
      NBASN = NPS + 3 + 2*NSUBS + 1
      DO 91 ILOOP = 1,NSUBS
      CALL SUREAD (IZ(NBASN),-1,NWDS,ICHK)
   91 NBASN = NBASN + IZ(NBASN) + 1
      NLDSA = IZ(NAS+2)
      NLDSP = IZ(NPS+2)
      NLOADS= NLDSA + NLDSP
      NBASA = NAS + 3 + 2*NSUBS + 1
      NBASP = NPS + 3 + 2*NSUBS + 1
      NLBASA= IZ(NBASA)
      NLBASP= IZ(NBASP)
C
C     CHECK FOR DUPLICATE LOAD IDS IN THE  LOAP  AND  LODS  ITEMS.
C
      DO 102 L = 1,NSUBS
      IF (NLBASP .EQ. 0 .OR. NLBASA .EQ. 0) GO TO 104
      DO 103 M = 1,NLBASA
      DO 103 N = 1,NLBASP
      IF( IZ(NBASA+M).NE.IZ(NBASP+N).OR.IZ(NBASA+M).EQ.0 ) GO TO 103
      WRITE  (LP,6955) UFM,IZ(NBASA+M),NAME
 6955 FORMAT (A23,' 6955, DUPLICATE LOAD IDS DURING APPEND OPERATION.',
     1       '  LOAD ID NO.',I9,' SUBSTRUCTURE ',2A4)
      IDRY = -2
  103 CONTINUE
  104 NBASA = NBASA + NLBASA + 1
      NBASP = NBASP + NLBASP + 1
      NLBASA = IZ(NBASA)
      NLBASP = IZ(NBASP)
  102 CONTINUE
C
C     END OF RUN IF A DRY RUN(IDRY .LT. 0)
C
      IF (IDRY .LT. 0) GO TO 9999
C
C     CALCULATE LENGTH OF THE MERG AND  N E W  LODS TABLE AND THEIR
C     LOCATIONS IN OPEN CORE
C
      LMERGT = 2*NSUBS
      NMERGS = NPF + 1
      NMERGF = NPF + LMERGT
      LNEWLT = 4 + 3*NSUBS + NLOADS
      NNEWS  = NMERGF + 1
      NNEWF  = NMERGF + LNEWLT
C
C     CREATE THE NEW LODS TABLE IN OPEN CORE - GROUP  0  FIRST
C
      IZ(NNEWS  ) = IZ(NAS  )
      IZ(NNEWS+1) = IZ(NAS+1)
      IZ(NNEWS+2) = NLOADS
      IZ(NNEWS+3) = NSUBS
      NLOOP = 2*NSUBS
      NNEW1 = NNEWS + 3
      NDEL1 = NAS + 3
      DO 105 NS1 = 1,NLOOP
  105 IZ(NNEW1+NS1) = IZ(NDEL1+NS1)
C
C     COMPLETION OF THE NEW LODS TABLE - GROUPS  1  THRU  NSUBS  --  AND
C     CREATION OF THE MERGE TABLE
C
      NBASN  = NNEW1 + NLOOP + 1
      NBASA  = NAS + 3 + 2*NSUBS + 1
      NBASP  = NPS + 3 + 2*NSUBS + 1
      NLOADA = IZ(NBASA)
      NLOADP = IZ(NBASP)
      NLOADN = NLOADA + NLOADP
      NMERGN = NMERGS
      IMERGN = 1
C
C     ZERO THE MERG TABLE LOCATION
C
      DO 109 I = 1,LMERGT
  109 IZ(NPF+I) = 0
      DO 106 ILOOP = 1,NSUBS
      IZ(NBASN) = NLOADN
      IF (NLOADP .EQ. 0) GO TO 2108
      DO 108 N = 1,NLOADP
  108 IZ(NBASN+N) = IZ(NBASP+N)
 2108 CONTINUE
      NBASN = NBASN + NLOADP
      IF (NLOADA .EQ. 0) GO TO 2107
      DO 107 N = 1,NLOADA
  107 IZ(NBASN+N) = IZ(NBASA+N)
 2107 CONTINUE
C
C     LOCATION IN THE MERGE TABLE OF THE  1(S)
C
      IMERGN = IMERGN + NLOADP
      IZ(NMERGN) = IMERGN
      IMERGN = IMERGN + NLOADA
      IZ(NMERGN+1) = NLOADA
      NMERGN = NMERGN + 2
      NBASN  = NBASN + NLOADA + 1
      IF (ILOOP .EQ. NSUBS) GO TO 106
      NBASA  = NBASA + NLOADA + 1
      NBASP  = NBASP + NLOADP + 1
      NLOADA = IZ(NBASA)
      NLOADP = IZ(NBASP)
      NLOADN = NLOADA + NLOADP
  106 CONTINUE
C
C     END OF GENERATION OF NEW LODS ITEM AND CREATION OF MERGE TABLE
C
C     CALCULATE BEGINNING LOCATION OF MERGE VECTOR IN OPEN CORE
C
      NMRVCS = NNEWF + 1
      NMERGN = NMERGS
      NMRVCN = NMRVCS - 2
      LVECT  = IZ(NNEWS+2)
      NMRVCF = NNEWF + LVECT
      NCHAVE = NMRVCF
      IF (NCHAVE .GT. NIZ) GO TO 7001
C
C     FILL THE MERGE VECTOR WITH  1(S)  ACCORDING TO THE MERGE TABLE
C
C     1) ZERO FIRST
C
      DO 112 I = 1,LVECT
  112 RZ(NMRVCS-1+I) = 0.
C
C     2) NOW FILL
C
      DO 110 ILOOP = 1,NSUBS
      IDRC1 = IZ(NMERGN)
      IDRC2 = IZ(NMERGN+1)
      IF (IDRC2 .EQ. 0) GO TO 2111
      DO 111 N = 1,IDRC2
  111 RZ(NMRVCN+IDRC1+N) = 1.0
 2111 CONTINUE
      NMERGN = NMERGN + 2
  110 CONTINUE
C
C     WRITE THE MERGE VECTOR ON SCRATCH  5  USING  PACK-SEE COMMON PACKX
C     THIS IS A COLUMN PARTITIONING VECTOR (REFERRED TO AS A ROW VECTOR
C     BY MERGE)
C
      ITYPIN = 1
      ITYPOT = 1
      IFIRST = 1
      ILAST  = LVECT
      INCR   = 1
      CALL GOPEN (ISCR5,IZ(IBUF1),IWRTRW)
C
C     ZERO THE TRAILER INFO. LOCATIONS
C
      DO 116 I = 1,7
  116 MCBLOC(I) = 0
      MCBLOC(1) = ISCR5
      MCBLOC(3) = LVECT
      MCBLOC(4) = IRECT
      MCBLOC(5) = IRSP
      CALL PACK (RZ(NMRVCS),ISCR5,MCBLOC(1))
      CALL CLOSE (ISCR5,IREW)
      CALL WRTTRL (MCBLOC(1))
      IDUMP = -ISCR5
      CALL DMPFIL (IDUMP,ADUMP,4000)
C
C     READ IN THE  PVEC  AND  POVE(IF EXISTS)  USING MTRXI
C
C     1) PVEC
C
      IUVEC = ISCR3
      CALL MTRXI (IUVEC,NAME,NPVEC,0,ICHK)
C
C     2) POVE
C
      IUOVE = ISCR4
      IF (LPOVE) CALL MTRXI (IUOVE,NAMELL,NPOVE,0,ICHK)
C
C     SET UP TO CALL MERGE FOR  PAPP  AND  PVEC
C
      IDUMP = -IUVEC
      CALL DMPFIL (IDUMP,ADUMP,4000)
      IDUMP = -IUAPP
      CALL DMPFIL (IDUMP,ADUMP,4000)
      ICORE = NMRVCF + 1
      IZ(ICORE) = ISCR5
      CALL RDTRL (IZ(ICORE))
C
C     SETUP NULL ROW PARTITIONING VECTOR USING  ISCR8
C     THIS IS A ROW PARTITIONING VECTOR REFERRED TO AS A COLUMN VECTOR
C     BY MERGE)
C
      MCBK11(1) = IUVEC
      CALL RDTRL (MCBK11(1))
      MCBK12(1) = IUAPP
      CALL RDTRL (MCBK12(1))
      DO 114 K = 1,7
      MCBK21(K) = 0
  114 MCBK22(K) = 0
      IZ(ICORE+ 7) = ISCR8
      IZ(ICORE+ 8) = 0
      IZ(ICORE+ 9) = MCBK11(3)
      IZ(ICORE+10) = IRECT
      IZ(ICORE+11) = IRSP
      IZ(ICORE+12) = 0
      IZ(ICORE+13) = 0
      NCNT = ICORE +13
C
      CALL GOPEN (ISCR8,IZ(IBUF1),IWRTRW)
      ITYPIN = 1
      ITYPOT = 1
      IFIRST = 1
      ILAST  = 1
      INCR   = 1
      CALL PACK (0,ISCR8,IZ(ICORE+7))
      CALL CLOSE (ISCR8,IREW)
      CALL WRTTRL (IZ(ICORE+7))
      LCORE = IB3 - ICORE - 15
      I = ICORE + 15
      IRULE   = 0
      MCBK(1) = ISCR6
      MCBK(2) = MCBK11(2)+MCBK12(2)
      MCBK(3) = MCBK11(3)
      MCBK(4) = IRECT
      MCBK(5) = MCBK11(5)
      MCBK(6) = 0
      MCBK(7) = 0
      CALL MERGE (IZ(ICORE),IZ(ICORE+7),IZ(I))
      CALL WRTTRL (MCBK(1))
C
C     SETUP TO MERGE  POVE  AND  POAP(IF THEY EXIST)
C
      IDUMP = -IUOVE
      CALL DMPFIL (IDUMP,ADUMP,4000)
      IDUMP = -IUOAP
      CALL DMPFIL (IDUMP,ADUMP,4000)
      IF (.NOT. LPOVE) GO TO 1005
      MCBK11(1) = IUOVE
      CALL RDTRL (MCBK11(1))
      MCBK12(1) = IUOAP
      CALL RDTRL (MCBK12(1))
      DO 115 K = 1,7
      MCBK21(K) = 0
  115 MCBK22(K) = 0
      IRULE   = 0
      MCBK(1) = ISCR7
      MCBK(2) = MCBK11(2)+MCBK12(2)
      MCBK(3) = MCBK11(3)
      MCBK(4) = IRECT
      MCBK(5) = MCBK11(5)
      MCBK(6) = 0
      MCBK(7) = 0
      CALL MERGE (IZ(ICORE),IZ(ICORE+7),IZ(I))
      CALL WRTTRL (MCBK(1))
C
C     CHECK TIME REMAINING AND RETURN WITH USER FATAL MESSAGE IF NOT
C     ENOUGH REMAINING
C
 1005 CALL TMTOGO (ITIME2)
      IF (ITIME2 .LE. 0) GO TO 7007
C
C     CALCULATE TIME USED IN REACHING THIS LOCATION
C
      ITUSED = ITIME1 - ITIME2
C
C     CONTINUE IF ITIME2 IS GREATER THAN ITUSED
C
      IF (ITIME2 .LT. ITUSED) GO TO 7007
C
C     WRITE NEW LODS ITEM TO SOF
C
C     1) DELETE OLD LODS ITEM
C
      CALL DELETE (NAME,NLODS,ICHK)
C
C     DELETE LODS ITEMS ON ANY SUBSTRUCTURE SECONDARY TO NAME - THIS
C     WILL ALLOW THE NEW LODS ITEM TO BE COPIED DURING FUTURE EQUIV
C     OPERATIONS
C
      II = ITCODE (NLODS)
      CALL FDSUB (NAME,IND)
      CALL FMDI (IND,IMDI)
      IPS = ANDF(ICORX(IMDI+1),1023)
      IF (IPS .NE. 0) GO TO 118
  117 ISS = ANDF(RSHIFT(ICORX(IMDI+1),10),1023)
      IF (ISS .EQ. 0) GO TO 118
      CALL FMDI (ISS,IMDI)
      IBLK = ANDF(ICORX(IMDI+II),65535)
      IF (IBLK .NE. 0 .AND. IBLK .NE. 65535) CALL RETBLK (IBLK)
      ICORX(IMDI+II) = 0
      MDIUP = .TRUE.
      GO TO 117
C
C     2) BEGIN WRITING
C
  118 ICHK = 3
      IRW  = 2
      CALL SFETCH (NAME,NLODS,IRW,ICHK)
      NWORDS = 4 + 2*IZ(NNEWS+3)
      CALL SUWRT (IZ(NNEWS),NWORDS,2)
      NBASN = NNEWS + NWORDS
      DO 113 N = 1,NSUBS
      NWORDS = IZ(NBASN) + 1
      CALL SUWRT (IZ(NBASN),NWORDS,2)
  113 NBASN = NBASN + NWORDS
      CALL SUWRT (0,0,3)
C
C     WRITE NEW  PVEC  AND  POVE(IF IT EXISTS)  TO SOF
C
      CALL DELETE (NAME,NPVEC,ICHK)
      CALL MTRXO (ISCR6,NAME,NPVEC,0,ICHK)
      IF (LPOVE) CALL DELETE (NAMELL,NPOVE,ICHK)
      IF (LPOVE) CALL MTRXO (ISCR7,NAMELL,NPOVE,0,ICHK)
C
      WRITE  (LP,6900) UIM,NAME
 6900 FORMAT (A29,' 6900, LOADS HAVE BEEN SUCCESSFULLY APPENDED FOR ',
     1       'SUBSTRUCTURE ',2A4)
      GO TO 9999
 7000 WRITE  (LP,6901) UIM,NAME
 6901 FORMAT (A29,' 6901, ADDITIONAL LOADS HAVE BEEN SUCCESSFULLY ',
     1       'MERGED FOR SUBSTRUCTURE ',2A4)
      GO TO 9999
 7001 WRITE  (LP,6951) UFM,NCHAVE
 6951 FORMAT (A23,' 6951, INSUFFICIENT CORE TO LOAD TABLES', /5X,
     1       'IN MODULE LODAPP, CORE =',I8)
      CALL MESAGE (-8,NPROG,0)
C
 7002 WRITE  (LP,6952) SFM,NAME
 6952 FORMAT (A25,' 6952, REQUESTED SUBSTRUCTURE ',2A4,
     1       ' DOES NOT EXIST')
      IDRY = -2
      GO TO 9999
 7003 WRITE  (LP,6101) SFM,NITEM,NAME
 6101 FORMAT (A25,' 6101, REQUESTED SOF ITEM DOES NOT EXIST.  ITEM ',A4,
     1       ' SUBSTRUCTURE ',2A4)
      IDRY = -2
      GO TO 9999
 7004 WRITE  (LP,6953) SFM,NAME
 6953 FORMAT (A25,' 6953, A WRONG COMBINATION OF LOAD VECTORS EXISTS ',
     1       'FOR SUBSTRUCTURE ',2A4)
      IDRY = -2
      GO TO 9999
 7005 WRITE  (LP,6954) SFM,NITEM,NAME
 6954 FORMAT (A25,' 6954, THE ,A4,62H ITEM EXISTS BUT HAS NO ',
     1       'ASSOCIATED PVEC ITEM FOR SUBSTRUCTURE ',2A4)
      IDRY = -2
      GO TO 9999
 7007 WRITE  (LP,6956) UFM,ITIME2
 6956 FORMAT (A23,' 6956, INSUFFICIENT TIME REMAINING FOR MODULE ',
     1       'LODAPP, TIME LEFT =',I8)
      IDRY = -2
 9999 CONTINUE
      CALL SOFCLS
C
C     RETURN VALUE OF DRY PARAMETER
C
      BUF(3) = IDRY
      RETURN
      END

      SUBROUTINE CEAD
C
C     COMPLEX  EIGENVALUE EXTRACTION  MODULE
C
C     5  INPUT  FILES -  KDD,BDD,MDD,EED,CASECC
C     4  OUTPUT FILES -  PHID,LAMD,OCEIGS,PHIDL
C     12 SCRATCHES FILES
C     1  PARAMETER
C
      IMPLICIT INTEGER (A-Z)
      REAL            EPS
      DIMENSION       EIGC(2),ERROR(2),NAME(2),MCB(7),KZ(1)
      CHARACTER       UFM*23,UWM*25,UIM*29
      COMMON /XMSSG / UFM,UWM,UIM
      COMMON /CINVPX/ IK(7),IM(7),IB(7),ILAM(7),IPHI(7),
     1                IDMPFL,ISCR(11),NOREG,EPS,REG(7,10),PHIDLI
      COMMON /BLANK / NFOUND
      COMMON /SYSTEM/ SYSBUF,NOUT
      COMMON /ZZZZZZ/ IZ(1)
      EQUIVALENCE     (KZ(1),IZ(1))
      DATA    NAME  / 4HCEAD,4H    /
      DATA    HES   / 4HHESS/
      DATA    FEER  / 4HFEER/
      DATA    ERROR / 4HEED ,4HCEAD/
      DATA    KDD   , BDD,MDD,EED,CASECC /
     1        101   , 102,103,104,105    /
      DATA    PHID  , LAMD,OCEIGS,PHIDL  /
     1        201   , 202, 203,   204    /
      DATA    SCR1  , SCR2,SCR3,SCR4,SCR5,SCR6,SCR7,SCR8,SCR9 /
     1        301   , 302, 303 ,304 ,305 ,306 ,307 ,308 ,309  /
      DATA    SCR10 , SCR11,SCR12 /
     1        310   , 311,  312   /
      DATA    DET   , INV,EIGC(1),EIGC(2) /4HDET ,4HINV ,207,2/
      DATA    IZ2   , IZ6,IZ148   /2,6,148/
C
C     FIND SELECTED EIGC CARD IN CASECC
C
      IBUF  = KORSZ(IZ) - SYSBUF
      CALL OPEN (*1,CASECC,IZ(IBUF),0)
      CALL SKPREC (CASECC,1)
      CALL FREAD (CASECC,IZ,166,1)
      CALL CLOSE (CASECC,1)
      J = 148
      METHOD = IZ(J)
      SCR10  = 310
      GO TO 2
    1 METHOD = -1
    2 FILE = EED
      CALL PRELOC (*90,IZ(IBUF),EED)
      CALL LOCATE (*130,IZ(IBUF),EIGC(1),IFLAG)
   10 CALL READ (*110,*140,EED,IZ(1),10,0,IFLAG)
      IF (METHOD.EQ.IZ(1) .OR. METHOD.EQ.-1) GO TO 30
   20 CALL FREAD (EED,IZ,7,0)
      J = 6
      IF (IZ(J) .NE. -1) GO TO 20
      GO TO 10
C
C     FOUND DESIRED  EIGC CARD
C
   30 CALL CLOSE (EED,1)
      J = 2
      CAPP = IZ(J)
      IF (CAPP .EQ.  DET) GO TO 50
      IF (CAPP .EQ.  INV) GO TO 40
      IF (CAPP .EQ.  HES) GO TO 52
      IF (CAPP .EQ. FEER) GO TO 45
      GO TO 130
C
C     INVERSE POWER--
C
   40 IK(1) = KDD
      CALL CLOSE (EED,1)
      CALL RDTRL (IK)
      IM(1) = MDD
      CALL RDTRL (IM)
      IB(1) = BDD
      CALL RDTRL (IB)
      IF (IB(1) .LT. 0) IB(1) = 0
      IF (IB(6) .EQ. 0) IB(1) = 0
      ILAM(1)  = SCR8
      IPHI(1)  = SCR9
      IDMPFL   = OCEIGS
      ISCR( 1) = SCR1
      ISCR( 2) = SCR2
      ISCR( 3) = SCR3
      ISCR( 4) = SCR4
      ISCR( 5) = SCR5
      ISCR( 6) = SCR6
      ISCR( 7) = SCR7
      ISCR( 8) = LAMD
      ISCR( 9) = PHID
      ISCR(10) = SCR10
      ISCR(11) = SCR11
      PHIDLI   = SCR12
      EPS      = .0001
      CALL CINVPR (EED,METHOD,NFOUND)
      NVECT = NFOUND
      GO TO 60
C
C     FEER METHOD
C
   45 CONTINUE
      CALL CFEER (EED,METHOD,NFOUND)
      NVECT = NFOUND
      GO TO 60
C
C     DETERMINANT
C
   50 CALL CDETM (METHOD,EED,MDD,BDD,KDD,SCR8,SCR9,OCEIGS,NFOUND,SCR1,
     1            SCR2,SCR3,SCR4,SCR5,SCR6,SCR7,SCR10)
      NVECT = NFOUND
      GO TO 60
C
C     HESSENBURG METHOD
C
   52 CONTINUE
      MCB(1) = KDD
      CALL RDTRL (MCB)
      NROW   = MCB(2)
      MCB(1) = BDD
      CALL  RDTRL (MCB)
      IF (MCB(1) .GT. 0) NROW = NROW*2
      NZ = KORSZ(KZ)
C
C     IF INSUFFICIENT CORE EXISTS FOR HESSENBURG METHOD.  DEFAULT TO
C     INVERSE POWER.
C
      IF (6*NROW*NROW+NROW*8 .LE. NZ) GO TO 55
      WRITE  (NOUT,53) UIM
   53 FORMAT (A29,' 2365, INSUFFICIENT CORE EXISTS FOR HESSENBURG ',
     1       'METHOD.  CHANGING TO INVERSE POWER OR FEER.')
      GO TO 40
C
C     SUFFICIENT CORE.  PROCEED WITH HESSENBURG METHOD
C
   55 CONTINUE
      CALL HESS1 (KDD,MDD,SCR8,SCR9,OCEIGS,NFOUND,NVECT,BDD,SCR1,SCR2,
     1            SCR3,SCR4,SCR5,SCR6,SCR7,EED,METHOD)
      NFOUND = NVECT
C
C     LAMD ON SCR8, PHID ON SCR9
C
C     SORT EIGENVALUES AND PREPARE OUTPUT FILES
C
   60 IF (NFOUND .NE. 0) GO TO 70
      NFOUND = -1
      GO TO 80
   70 CALL CEAD1A (SCR8,SCR9,PHIDLI,LAMD,PHID,PHIDL,NFOUND,NVECT,CAPP)
   80 RETURN
C
C     ERROR MESAGES
C
   90 IP1 = -1
  100 CALL MESAGE (IP1,FILE,NAME)
  110 IP1 = -2
      GO TO 100
  130 IP1 = -7
      GO TO 100
  140 CALL MESAGE (-31,METHOD,ERROR(1))
      GO TO 140
      END

      SUBROUTINE FBS2 (BLOCK,Y,YN,NWDS)
C
C     FBS2 EXECUTES THE FORWARD/BACKWARD PASS FOR FBSF IN RDP
C
      INTEGER          BLOCK(8), DBL, BUF(2), SUBNAM, BEGN, END
      DOUBLE PRECISION Y(1), YN(1), LJJ, L, YJK, SUM, ZERO
      CHARACTER        UFM*23, UWM*25, UIM*29, SFM*25
      COMMON /XMSSG /  UFM, UWM, UIM, SFM
      COMMON /MACHIN/  MACH
      COMMON /SYSTEM/  SYSBUF, NOUT
      COMMON /ZZZZZZ/  L(1)
      COMMON /FBSX  /  DBL,    N
      DATA             ZERO / 0.0D+0    /
      DATA    SUBNAM, BEGN, END / 4HFBS2, 4HBEGN, 4HEND /
C
      BUF(1) = SUBNAM
      BUF(2) = BEGN
      CALL CONMSG (BUF,2,0)
      NBRITM = NWDS/2
      J    = (LOCFX(YN)-LOCFX(Y)+1)/NWDS
      LAST = MAX0(J,1)*NBRITM
      DO 35 J = 1,N
      J1 = J - 1
      DO 5 K = J,LAST,NBRITM
      IF (Y(K) .NE. ZERO) GO TO 7
    5 CONTINUE
      CALL SKPREC (BLOCK(1),1)
      GO TO 35
C
C     MAKE 1ST STRING CALL FOR COLUMN AND SAVE DIAGONAL ELEMENT
C
    7 BLOCK(8) = -1
      CALL GETSTR (*80,BLOCK)
      IF (BLOCK(4) .NE. J) GO TO 80
      JSTR = BLOCK(5)
      LJJ  = 1.0D+0/L(JSTR)
      IF (BLOCK(6) .EQ. 1) GO TO 20
      NSTR = JSTR + BLOCK(6) - 1
      JSTR = JSTR + 1
      BLOCK(4) = BLOCK(4) + 1
C
C     PROCESS CURRENT STRING IN TRIANGULAR FACTOR AGAINST EACH
C     LOAD VECTOR IN CORE -- Y(I,K) = Y(I,K) + L(I,J)*Y(J,K)
C
   10 DO 15 K = 1,LAST,NBRITM
      YJK = Y(J1+K)
      IF (YJK .EQ. ZERO) GO TO 15
      IK  = BLOCK(4) + K - 1
      DO 12 IJ = JSTR,NSTR
      Y(IK) = Y(IK) + L(IJ)*YJK
   12 IK = IK + 1
   15 CONTINUE
C
C     GET NEXT STRING IN TRIANGULAR FACTOR
C
   20 CALL ENDGET (BLOCK)
      CALL GETSTR (*30,BLOCK)
      JSTR = BLOCK(5)
      NSTR = JSTR + BLOCK(6) - 1
      GO TO 10
C
C     END-OF-COLUMN ON TRIANGULAR FACTOR -- DIVIDE BY DIAGONAL
C
   30 DO 32 K = J,LAST,NBRITM
   32 Y(K) = Y(K)*LJJ
C
   35 CONTINUE
C
C     INITIALIZE FOR BACKWARD PASS BY SKIPPING THE NTH COLUMN
C
      IF (N .EQ. 1) GO TO 70
      CALL BCKREC (BLOCK)
      J = N - 1
C
C     GET A STRING IN CURRENT COLUMN. IF THIS STRING INCLUDES DIAGONAL,
C     ADJUST STRING TO SKIP IT.
C
   40 J1 = J - 1
      BLOCK(8) = -1
   42 CALL GETSTB (*60,BLOCK)
      IF (BLOCK(4)-BLOCK(6) .EQ. J1) BLOCK(6) = BLOCK(6) - 1
      IF (BLOCK(6) .EQ. 0) GO TO 58
      NTERMS = BLOCK(6)
C
C     PROCESS CURRENT STRING IN TRIANGULAR FACTOR AGAINST EACH
C     LOAD VECTOR IN CORE -- Y(J,K) = Y(J,K) + L(J,I)*Y(I,K)
C
      DO 55 K = 1,LAST,NBRITM
      JI  = BLOCK(5) + 1
      IK  = BLOCK(4) + K
      SUM = 0.0D+0
      DO 53 II = 1,NTERMS
      JI = JI - 1
      IK = IK - 1
      SUM = SUM + L(JI)*Y(IK)
   53 CONTINUE
      Y(J1+K) = Y(J1+K) + SUM
   55 CONTINUE
C
C     TERMINATE CURRENT STRING AND GET NEXT STRING
C
   58 CALL ENDGTB (BLOCK)
      GO TO 42
C
C     END-OF-COLUMN -- TEST FOR COMPLETION
C
   60 IF (J .EQ. 1) GO TO 70
      J = J - 1
      GO TO 40
C
   70 BUF(2) = END
      CALL CONMSG (BUF,2,0)
      RETURN
C
C
C     FATAL ERROR MESSAGE
C
   80 WRITE  (NOUT,82) SFM,SUBNAM
   82 FORMAT (A25,' 2149, SUBROUTINE ',A4,/5X,'FIRST ELEMENT OF A COLU',
     1      'MN OF LOWER TRIANGULAR MATRIX IS NOT THE DIAGONAL ELEMENT')
      CALL MESAGE (-61,0,0)
      RETURN
      END

      SUBROUTINE BIOTSV (XX,YY,ZZ,HCX,HCY,HCZ)
C
C     THIS ROUTINE COMPUTES THE MAGNETIC FIELD AT A POINT (XX,YY,ZZ)
C     DUE TO MAGNETIC SOIRCES. THE ROUTINE IS USED BY PROLATE IN
C     COMPUTING HC POTENTIALS USING LINE INTEGRALS. AT Z(IST) IS STORED
C     LOAD INFO. NEEDED FOR THIS SUBCASE (WHICH COULD BE A LOAD
C     COMBINATION) AS STORED BY ROUTINE LOADSU. THE INFO. IS STORED AS
C     FOLLOWS -
C
C     OVERALL SCALE FACTOR - ALLS
C     NUMBER OF SIMPLE LOADS - NSIMP
C     SCALE FACTOR FOR 1ST SIMPLE LOAD
C     NUMBER OF LOAD CARDS FOR 1ST SIMPLE LOAD
C     SCALE FACTOR FOR 2ND SIMPLE LOAD
C     NUMBER OF LOAD CARDS FOR 2ND SIMPLE LOAD
C      .
C     ETC.
C      .
C     TYPE(NOBLD) OF 1ST CARD FOR 1ST SIMPLE LOAD
C     NUMBER OF CARDS FOR THIS TYPE - IDO
C     LOAD INFO FOR THIS TYPE FOR 1ST SIMPLE LOAD
C     ANOTHER TYPE FOR 1ST SIMPLE LOAD
C      .
C     ETC
C      .
C     LOAD CARDS FOR SUBSEQUENT SIMPLE LOADS FOR THIS SUBCASE
C
      INTEGER         HEST,BGPDT,SCR1,FILE,BUF2,SUBCAS
      DIMENSION       NAM(2),IZ(1),BUF(50),IBUF(50),MCB(7),HC(3),HC1(3),
     1                HC2(3)
      COMMON /BIOT  / NG1,NG2,IST,SUBCAS,X1,Y1,Z1,X2,Y2,Z2,BUF2,REMFL,
     1                MCORE,LOAD,NSLT,SCR1,HEST,NTOT
      COMMON /SYSTEM/ SYSBUF,IOUT
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE     (Z(1),IZ(1)),(BUF(1),IBUF(1))
      DATA    NAM   / 4HBIOT,4HSV  /
C
      HCX    = 0.
      HCY    = 0.
      HCZ    = 0.
      SCR1   = 301
      BGPDT  = 103
      MCB(1) = BGPDT
      CALL RDTRL (MCB)
      NROWSP = MCB(2)
      MCB(1) = SCR1
      CALL RDTRL (MCB)
      N3     = MCB(3)
      NGRIDS = N3/3
C
      ALLS   = Z(IST+1)
      NSIMP  = IZ(IST+2)
      ISIMP  = IST + 2*NSIMP + 2
C
C     LOOP ON NUMBER OF SIMPLE LOADS
C
      DO 270 NS = 1,NSIMP
      NC     = 0
      HC(1)  = 0.
      HC(2)  = 0.
      HC(3)  = 0.
C
      FACTOR = Z(IST+2*NS+1)
      NCARDS = IZ(IST+2*NS+2)
   15 NOBLD  = IZ(ISIMP+1)
      IDO    = IZ(ISIMP+2)
      ISIMP  = ISIMP + 2
C
C
      KTYPE  = NOBLD - 19
      GO TO (20,30,40,50,60), KTYPE
   20 MWORDS = 3*NROWSP
      GO TO 70
   30 MWORDS = 12
      GO TO 70
   40 MWORDS = 48
      GO TO 70
   50 MWORDS = 9
      GO TO 70
   60 MWORDS = 0
C
   70 DO 245 J = 1,IDO
C
      GO TO (145,150,150,150,180), KTYPE
C
C     SPCFLD DATA STARTS AT Z(ISIMP+1)
C
  145 CONTINUE
C
C
C     NG1 AND NG2 ARE THE SIL NUMBERS OF THE END POINTS OF THE LINE
C     INTEGRL WITH (X1,Y1,Z1) AND (X2,Y2,Z2) BEING THE COORDINATES.
C     LINEARLY INTERPOLATE TO (XX,YY,ZZ). THE SILS ARE POINTERS INTO
C     THE SPCFLD DATA
C
      ISUB   = ISIMP + 3*NG1
      HC1(1) = Z(ISUB-2)
      HC1(2) = Z(ISUB-1)
      HC1(3) = Z(ISUB)
      ISUB   = ISIMP + 3*NG2
      HC2(1) = Z(ISUB-2)
      HC2(2) = Z(ISUB-1)
      HC2(3) = Z(ISUB)
  148 TLEN   = SQRT((X2-X1)**2 + (Y2-Y1)**2 + (Z2-Z1)**2)
      XLEN   = SQRT((XX-X1)**2 + (YY-Y1)**2 + (ZZ-Z1)**2)
      RATIO  = XLEN/TLEN
      HC(1)  = HC(1) + (1.-RATIO)*HC1(1) + RATIO*HC2(1)
      HC(2)  = HC(2) + (1.-RATIO)*HC1(2) + RATIO*HC2(2)
      HC(3)  = HC(3) + (1.-RATIO)*HC1(3) + RATIO*HC2(3)
      GO TO 240
C
C     CEMLOOP,GEMLOOP,MDIPOLE
C
  150 DO 152 K = 1,MWORDS
  152 BUF(K) = Z(ISIMP+K)
      LTYPE  = KTYPE - 1
      GO TO (155,160,165), LTYPE
  155 CALL AXLOOP (BUF,IBUF,XX,YY,ZZ,HCA,HCB,HCC)
      GO TO 170
  160 CALL GELOOP (BUF,IBUF,XX,YY,ZZ,HCA,HCB,HCC)
      GO TO 170
  165 CALL DIPOLE (BUF,IBUF,XX,YY,ZZ,HCA,HCB,HCC)
C
  170 HC(1)  = HC(1) + HCA
      HC(2)  = HC(2) + HCB
      HC(3)  = HC(3) + HCC
      GO TO 240
C
C     REMFLUX - BRING IN VALUES FROM SCR1 AFTER POSITIONING TO PROPER
C     CASE
C
  180 CALL GOPEN (SCR1,Z(BUF2),0)
      IC = SUBCAS - 1
      IF (IC .EQ. 0) GO TO 200
      DO 190 I = 1,IC
      CALL FWDREC (*520,SCR1)
  190 CONTINUE
C
  200 ISIMP1 = 6*NGRIDS + NTOT
      CALL FREAD (SCR1,Z(ISIMP1+1),N3,1)
C
      CALL CLOSE (SCR1,1)
C
C     MUST MATCH NG1 AND NG2 TO SIL-S IN CORE TO LOCATE REMFLUX INFO ON
C    SCR1
C
      ING1 = 0
      ING2 = 0
      DO 220 I = 1,NGRIDS
      IF (NG1 .EQ. IZ(I)) GO TO 205
      IF (NG2 .EQ. IZ(I)) GO TO 210
      GO TO 220
  205 ING1 = I
      IF (ING2 .EQ. 0) GO TO 220
      GO TO 230
  210 ING2 = I
      IF (ING1 .EQ. 0) GO TO 220
      GO TO 230
  220 CONTINUE
      GO TO 510
  230 ISUB   = 3*ING1 + ISIMP1
      HC1(1) = Z(ISUB-2)
      HC1(2) = Z(ISUB-1)
      HC1(3) = Z(ISUB)
      ISUB   = 3*ING2 + ISIMP1
      HC2(1) = Z(ISUB-2)
      HC2(2) = Z(ISUB-1)
      HC2(3) = Z(ISUB)
C
C     INTERPOLATE AS WITH SPCFLD
C
      GO TO 148
C
C     DONE FOR ONE CARD OF PRESENT TYPE  - GET ANOTHER
C
  240 ISIMP = ISIMP + MWORDS
      NC = NC + 1
C
  245 CONTINUE
C
C     CHECK TO SEE IF WE ARE DONE WITH THIS LOAD FACTOR
C
      IF (NC .LT. NCARDS) GO TO 15
C
C     DONE WITH THIS SIMPLE LOAD. APPLY INDIVIDUAL AND OVERALL SCALE
C     FACTORS THEN GET ANOTHER SIMPLE LOAD
C
      FAC = FACTOR*ALLS
      HCX = HCX + FAC*HC(1)
      HCY = HCY + FAC*HC(2)
      HCZ = HCZ + FAC*HC(3)
C
  270 CONTINUE
C
C     DONE
C
      RETURN
C
  510 WRITE  (IOUT,511) NG1,NG2
  511 FORMAT ('0*** LOGIC ERROR, SILS',2I8,
     1       ' CANNOT BE FOUND IN PROLATE LIST IN BIOTSV')
      CALL MESAGE (-61,0,0)
C
  520 CALL MESAGE (-2,FILE,NAM)
      RETURN
      END

      BLOCK DATA SMA1BD
CSMA1BD
C
      INTEGER           CLSRW    ,CLSNRW   ,EOR      ,OUTRW
      DOUBLE PRECISION  DPDUM(514)
      COMMON  /SMA1IO/  IFCSTM   ,IFMPT    ,IFDIT    ,IDUM1    ,
     1                  IFECPT   ,IGECPT   ,IFGPCT   ,IGGPCT   ,
     2                  IFGEI    ,IGGEI    ,IFKGG    ,IGKGG    ,
     3                  IF4GG    ,IG4GG    ,IFGPST   ,IGGPST   ,
     4                  INRW     ,OUTRW    ,CLSNRW   ,CLSRW    ,
     5                  NEOR     ,EOR      ,MCBKGG(7),MCB4GG(7)
C
C     SMA1 VARIABLE CORE BOOKKEEPING PARAMETERS
C
      COMMON  /SMA1BK/  ICSTM    ,NCSTM    ,IGPCT    ,NGPCT    ,
     1                  IPOINT   ,NPOINT   ,I6X6K    ,N6X6K    ,
     2                  I6X64    ,N6X64
      COMMON  /SMA1DP/  DPDUM
C
C     SMA1 PROGRAM CONTROL PARAMETERS
C
      COMMON  /SMA1CL/  IOPT4    ,K4GGSW   ,NPVT     ,LEFT     ,
     1                  FROWIC   ,LROWIC   ,NROWSC   ,TNROWS   ,
     2                  JMAX     ,NLINKS   ,LINK(10) ,IDETCK   ,
     3                  DODET    ,NOGOO    ,DUMMY(200)
C
C     ECPT COMMON BLOCK
C
      COMMON  /SMA1ET/  ECPT(200)
C
C
      DATA     NLINKS / 10 /
      DATA     NOGOO  /  0 /
      DATA     IFCSTM,IFMPT,IFECPT,IFGPCT,IFDIT / 101,102,103,104,105 /
      DATA     IFKGG,IF4GG,IFGPST / 201,202,203 /
      DATA     INRW,CLSRW,CLSNRW,EOR,NEOR,OUTRW / 0,1,2,1,0,1 /
      END

      SUBROUTINE SPTCHK
C
C     THIS ROUTINE IS CALLED ONLY BY BANDIT TO CHECK THE PRESENCE OF ANY
C     UNDEFINED SPOINT. RESET NGRID AND RETURN FOR ONE MORE COMPUTATION
C     IF THAT IS THE CASE
C
      INTEGER         GEOM1,    GEOM2,    RD,       RDREW,    REW,
     1                Z,        SPOINT(2),NAME(2),  KG(200)
      COMMON /SYSTEM/ IBUF,     NOUT
      COMMON /BANDA / IBUF1,    DUM6(6),  NPT(2)
      COMMON /BANDB / DUM3(3),  NGRID,    DUM4(4),  IREPT
      COMMON /BANDD / NDD(9)
      COMMON /BANDS / SKIP(4),  MAXGRD
      COMMON /GEOMX / GEOM1,    GEOM2
      COMMON /NAMES / RD,       RDREW,    DUM2(2),  REW
      COMMON /GPTA1 / NE,       LAST,     INCR,     KE(1)
      COMMON /ZZZZZZ/ Z(1)
      DATA            SPOINT,   NAME /    5551,49,  4HBMIS, 4HS      /
C
C     LIST ALL SPOINTS IN Z(1) THRU Z(NS)
C
      IF (IREPT .EQ. 3) GO TO 160
      NS=1
      CALL PRELOC (*160,Z(IBUF1),GEOM2)
      CALL LOCATE (*40,Z(IBUF1),SPOINT,K)
 30   CALL READ (*180,*40,GEOM2,Z(NS),1,0,K)
      NS=NS+1
      GO TO 30
 40   NS=NS-1
      CALL REWIND (GEOM2)
C
C     CHECK THE PRESENCE OF ELAST, DAMP AND MASS CARDS (ELEMENT TYPES
C     201 THRU 1301).  THEY MAY SPECIFY SCALAR POINTS WITHOUT USING
C     SPOINT CARDS.
C
      NSS=NS
      DO 100 IELEM=26,350,INCR
      CALL LOCATE (*100,Z(IBUF1),KE(IELEM+3),J)
      NWDS =KE(IELEM+5)
      NGPT1=KE(IELEM+12)
      NGPTS=KE(IELEM+9)+NGPT1-1
 50   CALL READ (*180,*100,GEOM2,KG(1),NWDS,0,J)
      DO 90 I=NGPT1,NGPTS
      IF (NS .EQ. 0) GO TO 70
      CALL BISLOC (*70,KG(I),Z(1),1,NS,K)
      GO TO 90
 70   NSS=NSS+1
      IF (NSS .GE. IBUF1) GO TO 110
      Z(NSS)=KG(I)
 90   CONTINUE
      GO TO 50
 100  CONTINUE
 110  CALL CLOSE (GEOM2,REW)
      K=NSS-NS-1
      IF (K) 160,140,120
C
C     SOME SCALAR POINTS ARE USED, BUT NOT SPECIFIED BY SPOINT CARDS.
C     SORT THEM, AND THROW OUT DUPLICATES
C
 120  NS1=NS+1
      CALL SORT (0,0,1,1,Z(NS1),NSS-NS)
      K  =NSS
      NSS=NS1
      J  =NS+2
      DO 130 I=J,K
      IF (Z(I) .EQ. Z(I-1)) GO TO 130
      NSS=NSS+1
      Z(NSS)=Z(I)
 130  CONTINUE
C
C     RE-COMPUTE THE TOTAL NO. OF GRID POINTS, NGRID, AND RETURN FOR
C     ONE MORE BANDIT COMPUTATION
C
 140  NPT(2)=NSS-NS
      NGRID =NPT(1)+NPT(2)
      DO 150 I=1,9
 150  NDD(I)=0
      IREPT =2
      RETURN
C
 160  WRITE (NOUT,170) MAXGRD
 170  FORMAT (120H1*** USER FATAL ERROR 2007,  THIS STRUCTURE MODEL USES
     1 MORE GRID POINTS THAN THE TOTAL NO. OF GRID CARDS IN BULK DATA (=
     2,I6,1H),/)
      NGRID=0
      GO TO 190
C
 180  CALL MESAGE (-3,GEOM2,NAME)
 190  RETURN
      END

      SUBROUTINE FBSV (*,ZS,ZD)
C
C     GIVEN A LOWER UNIT TRIANGULAR FACTOR WITH DIAGONAL SUPERIMPOSED
C     AND WRITTEN WITH TRAILING STRING DEFINITION WORDS, FBSV WILL
C     PERFORM THE FORWARD-BACKWARD SUBSTITUTION NECESSARY TO SOLVE A
C     LINEAR SYSTEM OF EQUATIONS.
C
C     THIS FBSV.MDS ROUTINE IS ALMOST SAME AS FBS.MIS
C     IT IS INTENDED TO BE USED FOR VAX, A VIRTUAL MEMORY MACHINE.
C     FBSV.MDS DIFFERS FROM FBS.MIS IN
C       1. THREE BUFFERS ARE USED
C       2. OPEN CORE IS REDUCED. THE INTENTION HERE IS TO AVOID
C          ACCESSIVE SYSTEM PAGING.
C
C     FBSV IS CALLED ONLY BY FBS ROUTINE.
C     IT IS INTRODUCED INTO NASTRAN REPERTORY BY G.CHAN/UNISYS, 10/88
C
      LOGICAL IDENT
      INTEGER DBL     ,DBU      ,DBB      ,DBX      ,PREC     ,SIGN    ,
     1        SYSBUF  ,PRC      ,WORDS    ,RLCMPX   ,BUF1     ,BUF2    ,
     2        BUF3    ,TYPEL    ,TYPEB    ,TYPEX    ,SUBNAM(2),BEGN    ,
     3        END     ,BUF(2)   ,RC       ,EOL      ,RD       ,RDREW   ,
     4        WRT     ,WRTREW   ,REW      ,EOFNRW   ,SWITCH   ,RSP     ,
     5        RDP     ,CSP      ,CDP      ,BLOCK(15),HICORE   ,SYS34
      REAL    ZS(1)   ,XS(4)    ,YS(4)
      DOUBLE  PRECISION          ZD(1)    ,XD       ,YD
      COMMON /FBSX  / DBL(7)    ,DBU(7)   ,DBB(7)   ,DBX(7)   ,LCORE   ,
     1                PREC      ,SIGN
      COMMON /SYSTEM/ SYSBUF    ,NOUT     ,SY1(28)  ,HICORE   ,SY2(2)  ,
     1                SYS34
      COMMON /NAMES / RD        ,RDREW    ,WRT      ,WRTREW   ,REW     ,
     1                NOREW     ,EOFNRW   ,RSP      ,RDP      ,CSP     ,
     2                CDP
      COMMON /TYPE  / PRC(2)    ,WORDS(4) ,RLCMPX(4)
      COMMON /PACKX / ITYPE1    ,ITYPE2   ,I1       ,J1       ,INCR1
      COMMON /UNPAKX/ ITYPE3    ,I2       ,J2       ,INCR2
      COMMON /ZNTPKX/ XD(2)     ,IX       ,EOL
      COMMON /ZBLPKX/ YD(2)     ,IY
      EQUIVALENCE    (DBL(5),TYPEL) , (DBB(5),TYPEB) , (DBX(5),TYPEX)  ,
     1               (XD(1) ,XS(1)) , (DBL(2),NL   ) , (YD(1) ,YS(1))
      DATA    SUBNAM/ 4HFBSV, 1H  / , BEGN/ 4HBEGN / , END/ 3HEND /
C
C
C     CHECK OPEN CORE SITUATION. IF SYS34 (PAGECNTL) IS NOT ZERO, SET
C     OPEN CORE SIZE TO SIZE SPECIFIED BY SYS34 (MINUS OVERHEAD OF 6000
C     WORDS). TOO BIG A CORE SIZE MAY CAUSE EXCESSIVE PAGING AND SLOW
C     DOWN FBS OPERATION
C
C
      KORCHG = 0
      IF (SYS34 .EQ. 0) GO TO 50
      KORCHG = HICORE - SYS34 + 6000
      IF (KORCHG .LE. 0) GO TO 80
      LCORE  = LCORE- KORCHG
      WRITE (NOUT,40) SYS34
 40   FORMAT ('0*** SYSTEM INFORMATION MESSAGE - OPEN CORE FOR FBS IS',
     1        ' SET TO',I7,' WORDS BY PAGECNTL OF /SYSTEM/',/)
      GO TO 80
 50   IF (HICORE .GT. 130001) WRITE (NOUT,60) HICORE
 60   FORMAT ('0*** SYSTEM INFORMATION MESSAGE - PRESENT OPEN CORE =',
     1        I7, /5X,'FURTHER INCREASE OF OPEN CORE MAY ACTUALLY ',
     2        'SLOW DOWN FBS''S OPERATION.', //5X,
     3        'SUGGESTION: TO OPTIMIZE CORE USAGE AND USER''S PROBLEM,',
     4        ' AND TO MINIMIZE VAX''S PAGE FAULTS,', /5X,
     4        'CHECK WORKING_SET PAGE LIMIT ASSIGNED TO USER, AND SET ',
     6        'NASTRAN PAGECNTL WORD OF /SYSTEM/ TO MATCH, BUT NOT TO ',
     7        'EXCEED, THE CURRENT SETTING',/)
C
C     GENERAL INITIALIZATION
C
 80   BUF3   = LCORE- SYSBUF
      BUF2   = BUF3 - SYSBUF
      BUF1   = BUF2 - SYSBUF
      NNN    = BUF1 - 1
      BUF(1) = SUBNAM(1)
      BUF(2) = BEGN
      CALL CONMSG (BUF,2,0)
      NBRLOD = DBB(2)
      RC     = RLCMPX(TYPEB)
      I2     = 1
      J2     = NL
      INCR2  = 1
      I1     = 1
      J1     = NL
      INCR1  = 1
      ITYPE1 = TYPEL
      ITYPE2 = TYPEX
      ITYPE3 = SIGN*TYPEL
      NWDS   = WORDS(TYPEL)*NL
      NVECS  = NNN/NWDS
      IF (NVECS .EQ. 0) CALL MESAGE(-8,NWDS-NNN,SUBNAM)
      SWITCH = 1
      IF (TYPEL.EQ.RSP .AND. RC.EQ.2) SWITCH = 2
      IF (TYPEL.EQ.RDP .AND. RC.EQ.2) SWITCH = 3
      IF (SWITCH .NE. 1) NVECS = NVECS/2
      K1     = 1
      BLOCK(1) = DBL(1)
      DBX(2) = 0
      DBX(6) = 0
      DBX(7) = 0
      IDENT  = .FALSE.
      IF (DBB(4) .EQ. 8) IDENT = .TRUE.
      NNNDBL = NNN/2
      NTERMS = RLCMPX(TYPEL)*NL
      IF (IDENT) NBRLOD = NL
C
C     OPEN OUTPUT FILE (DBX), LOAD VECTORS FILE (DBB), AND LOWER
C     TRIANGULAR FACTOR FILE (DBL)
C
      CALL GOPEN (DBX,ZS(BUF3),WRTREW)
      CALL GOPEN (DBL,ZS(BUF1),RDREW )
      IF (.NOT.IDENT) CALL GOPEN (DBB,ZS(BUF2),RDREW)
C
C     CHECK TIMING AND ISSUE MESSAGE
C
      NPASS = (NBRLOD+NVECS-1)/NVECS
      CALL SSWTCH (11,L11)
      IF (NPASS .GE. 10) L11=1
      IF (L11 .NE. 1) GO TO 140
      CALL PAGE2 (-4)
      WRITE (NOUT,100) TYPEL,NPASS
  100 FORMAT ('0*** USER INFORMATION MESSAGE FROM FBS',I1,' - NO. OF ',
     1        'PASSES NEEDED TO COMPLETE FBS OPERATION =',I5)
      IF (NPASS .GT. 15) WRITE (NOUT,110)
  110 FORMAT (5X,'INCREASE OF OPEN CORE MAY ACTUALLY SLOW DOWN FBS ',
     1        'OPERATION.')
      GO TO 140
  120 IF (L11 .LT. 0) GO TO 150
      CALL CPUTIM (J,T2,1)
      T2 = T2-T1
      IF (L11 .GT. 0) WRITE (NOUT,130) T2
  130 FORMAT (5X,'TIME TO COMPLETE ONE PASS =',F10.4,' CPU SECONDS',//)
      L11 = -1
      CALL TMTOGO (J)
      I = NPASS*T2
      IF (J .LT. I) CALL MESAGE (-50,I,SUBNAM)
      GO TO 150
  140 CALL CPUTIM (J,T1,1)
C
C     COMPUTE EXTENT OF THIS PASS
C
  150 KN   = MIN0(K1+NVECS-1,NBRLOD)
      LAST = 1 + (KN-K1)*NWDS
      IF (IDENT) GO TO 190
      GO TO (160,170,180), SWITCH
C
C     NORMAL CASE - FILL CORE WITH LOAD VECTORS
C
  160 DO 168 L=1,LAST,NWDS
      CALL UNPACK (*162,DBB,ZS(L))
      GO TO 168
  162 LN = L+NWDS-1
      DO 164 LL=L,LN
  164 ZS(LL) = 0.
  168 CONTINUE
      GO TO 200
C
C     SPECIAL CASE - FACTOR IS RSP AND VECTORS ARE CSP
C
  170 LAST = 1 + 2*(KN-K1)*NWDS + NWDS
      L = 0
      DO 171 K=1,NNNDBL
  171 ZD(K) = 0.
      DO 178 K=K1,KN
      ICSPSG = CSP*SIGN
      CALL INTPK (*176,DBB,0,ICSPSG,0)
  172 CALL ZNTPKI
      ZS(L+IX   ) = XS(1)
      ZS(L+IX+NL) = XS(2)
      IF (EOL .EQ. 0) GO TO 172
  176 L = L + 2*NL
  178 CONTINUE
      GO TO 200
C
C     SPECIAL CASE - FACTOR IS RDP AND VECTORS ARE CDP
C
  180 LAST = 1 + 2*(KN-K1)*NWDS + NWDS
      L = 0
      DO 181 K=1,NNNDBL
  181 ZD(K) = 0.
      DO 188 K=K1,KN
      ICDPSG = CDP*SIGN
      CALL INTPK (*186,DBB,0,ICDPSG,0)
  182 CALL ZNTPKI
      ZD(L+IX   ) = XD(1)
      ZD(L+IX+NL) = XD(2)
      IF (EOL .EQ. 0) GO TO 182
  186 L = L + 2*NL
  188 CONTINUE
      GO TO 200
C
C     SPECIAL CASE - GENERATE IDENTITY MATRIX
C
  190 L = 0
      DO 197 K=1,NNNDBL
  197 ZD(K) = 0.
      DO 198 K=K1,KN
      GO TO (191,192,193,194), TYPEL
  191 ZS(L+K) = 1.0
      GO TO 196
  192 ZD(L+K) = 1.0D0
      GO TO 196
  193 ZS(L+2*K-1) = 1.0
      GO TO 196
  194 ZD(L+2*K-1) = 1.0D0
  196 L = L + NTERMS
  198 CONTINUE
C
C     COMPUTE FORWARD-BACKWARD SUBSTITUTION ON LOAD VECTORS NOW IN CORE
C
  200 CALL REWIND (DBL)
      CALL FWDREC (*270,DBL)
C
      GO TO (201,202,203,204), TYPEL
C
  201 CALL FBS1 (BLOCK,ZS,ZS(LAST),NWDS)
      GO TO 210
  202 CALL FBS2 (BLOCK,ZS,ZS(LAST),NWDS)
      GO TO 210
  203 CALL FBS3 (BLOCK,ZS,ZS(LAST),NWDS)
      GO TO 210
  204 CALL FBS4 (BLOCK,ZS,ZS(LAST),NWDS)
C
C     PACK SOLUTION VECTORS ONTO OUTPUT FILE
C
  210 GO TO (220,230,240), SWITCH
C
C     NORMAL CASE - CALL PACK
C
  220 DO 228 L=1,LAST,NWDS
      CALL PACK (ZS(L),DBX,DBX)
  228 CONTINUE
      GO TO 250
C
C     SPECIAL CASE - FACTOR IS RSP AND VECTORS ARE CSP, CALL BLDPK
C
  230 L = 0
      DO 238 K=K1,KN
      CALL BLDPK (CSP,TYPEX,DBX,0,0)
      DO 234 I=1,NL
      YS(1) = ZS(L+I   )
      YS(2) = ZS(L+I+NL)
      IY = I
      CALL ZBLPKI
  234 CONTINUE
      CALL BLDPKN (DBX,0,DBX)
      L = L + 2*NL
  238 CONTINUE
      GO TO 250
C
C     SPECIAL CASE - FACTOR IS RDP AND VECTORS ARE CDP, CALL BLDPK
C
  240 L = 0
      DO 248 K=K1,KN
      CALL BLDPK (CDP,TYPEX,DBX,0,0)
      DO 244 I=1,NL
      YD(1) = ZD(L+I   )
      YD(2) = ZD(L+I+NL)
      IY = I
      CALL ZBLPKI
  244 CONTINUE
      CALL BLDPKN (DBX,0,DBX)
      L = L + 2*NL
  248 CONTINUE
C
C     TEST FOR MORE PASSES
C
  250 IF (KN .EQ. NBRLOD) GO TO 300
      K1   = KN + 1
      GO TO 120
C
C     ERROR
C
  270 CALL MESAGE (-2,DBL,SUBNAM)
C
  300 IF (.NOT.IDENT) CALL CLOSE (DBB,REW)
      CALL CLOSE (DBL,REW)
      CALL CLOSE (DBX,REW)
      BUF(2) = END
      CALL CONMSG (BUF,2,0)
      RETURN 1
      END

      SUBROUTINE SELAS1(IARG)
C*****
C THIS ROUTINE IS PHASE I OF STRESS DATA RECOVERY FOR THE ELAS ELEMENTS.
C
C
C
C*****
C
C
C
C              E C P T - S  F O R  E L A S  E L E M E N T S
C
C
C
C                  TYPE             TYPE           TYPE           TYPE
C         CELAS1           CELAS2         CELAS3         CELAS4
C ECPT(1) IELID     I      IELID     I    IELID      I   IELID      I
C ECPT(2) IGP1      I      K         R    IS1        I   K          R
C ECPT(3) IGP2      I      IGP1      I    IS2        I   IS1        I
C ECPT(4) IC1       I      IGP2      I    K          R   IS2        I
C ECPT(5) IC2       I      IC1       I    GSUBE      R
C ECPT(6) K         R      IC2       I    S          R
C ECPT(7) GSUBE     R      GSUBE     R
C ECPT(8) S         R      S         R
C
C
C
      DIMENSION
     1                   IECPT(6)
C
C SDR2 PHASE I INPUT AND OUTPUT BLOCK
C
      COMMON   /SDR2X5/
     A                   ECPT(100),
     1                   JELID              ,ISILNO(2)
     2,                  STIFF              ,SCOEFF
     3,                  DUMMY(120)
C
C
C
      EQUIVALENCE
     1                   (IECPT(1),ECPT(1)) ,(SCOEFF,ICOEFF)
C
C BUILD UP OUTPUT BLOCK DEPENDING UPON WHICH ELEMENT TYPE, ELAS1, ELAS2,
C ELAS3 OR ELAS4, IS BEING WORKED ON.
C
      GO TO (10,20,30,40),IARG
C
C ELAS1
C
   10 ISILNO(1) = IECPT(2) + IECPT(4)
      ISILNO(2) = IECPT(3) + IECPT(5)
      IF (IECPT(4) .GT. 0) ISILNO(1) = ISILNO(1) - 1
      IF (IECPT(5) .GT. 0) ISILNO(2) = ISILNO(2) - 1
      STIFF  = ECPT(6)
      SCOEFF = ECPT(8)
      GO TO 50
C
C ELAS2
C
   20 ISILNO(1) = IECPT(3) + IECPT(5)
      ISILNO(2) = IECPT(4) + IECPT(6)
      IF (IECPT(5) .GT. 0) ISILNO(1) = ISILNO(1) - 1
      IF (IECPT(6) .GT. 0) ISILNO(2) = ISILNO(2) - 1
      STIFF  = ECPT(2)
      SCOEFF = ECPT(8)
      GO TO 50
C
C ELAS3
C
   30 ISILNO(1) = IECPT(2)
      ISILNO(2) = IECPT(3)
      STIFF  = ECPT(4)
      SCOEFF = ECPT(6)
      GO TO 50
C
C ELAS4
C
   40 ISILNO(1) = IECPT(3)
      ISILNO(2) = IECPT(4)
      STIFF  = ECPT(2)
      ICOEFF = -1
C
C STORE ELEMENT ID.
C
   50 JELID = IECPT(1)
      RETURN
      END

      SUBROUTINE MBDPDH (AJJL,F,DF,F1,DF1,F2,DF2,XWTE,YWTE,PAREA,CAPPHI,
     1                   DPHITE,DSS,Q,Q1,Q2,NDN,ND1,NW1,NWN,KTE,KTE1,
     2                   KTE2,NTE,NNCB,NNSBD,IN17,IBUF,A)
C
      LOGICAL        CNTRL2,CNTRL1,CRANK1,CRANK2,ASYM,SURF,LPHI,TEBOX
      DIMENSION      F(1),DF(1),F1(1),DF1(1),F2(1),DF2(1),XWTE(1),
     1               YWTE(1),PAREA(50,50,3),NDN(1),ND1(1),NW1(1),NWN(1),
     2               KTE(1),KTE1(1),KTE2(1),NTE(1),IBUF(1)
      COMPLEX        CAPPHI(1),DPHITE(3,NNSBD),DSS(NNCB,NNSBD),DPHI,TDH,
     1               WS,WF1,WF2,TEMPHI,WPHI,SUMPHI,TRAILE,Q(1),Q1(1),
     2               Q2(1),A(1)
      COMMON /MBOXA/ X(12),Y(12),TANG(10),ANG(10),COTANG(10)
      COMMON /MBOXC/ NJJ ,CRANK1,CRANK2,CNTRL1,CNTRL2,NBOX,NPTS0,NPTS1,
     1               NPTS2,ASYM,GC,CR,MACH,BETA,EK,EKBAR,EKM,BOXL,BOXW,
     2               BOXA ,NCB,NSB,NSBD,NTOTE,KC,KC1,KC2,KCT,KC1T,KC2T
      DATA    NHCONT,NHDSS /4HCONT,4HDSS /
C
      NSKP   = 0
      N1     = NPTS0 + NPTS1
      CALL GOPEN (IN17,IBUF,0)
      DO 4000 MOOD = 1,NJJ
      DO 110 I = 1,NSBD
      NTE(I) = 0
      DPHITE(1,I) = (0.0, 0.0)
      DPHITE(2,I) = (0.0, 0.0)
      DPHITE(3,I) = (0.0, 0.0)
  110 CONTINUE
      DO 120 I = 1,NCB
      DO 120 J = 1,NSBD
      DSS(I,J) = (0.0, 0.0)
  120 CONTINUE
      DO 121 J = 1,KCT
      Q (J)  = (0.0, 0.0)
      F(J)   = 0.0
  121 DF(J)  = 0.0
      IF (.NOT.CNTRL1) GO TO 116
      DO 115 J = 1,KC1T
      Q1(J)  = (0.0, 0.0)
      F1(J)  = 0.0
      DF1(J) = 0.0
  115 CONTINUE
  116 IF (.NOT.CNTRL2) GO TO 118
      DO 117 J = 1,KC2T
      Q2(J)  = (0.0, 0.0)
      F2(J)  = 0.0
      DF2(J) = 0.0
  117 CONTINUE
  118 CALL FREAD (IN17,Z,-NSKP,0)
      JJ = MOOD
      IF (JJ .GT. NPTS0) GO TO 140
      CALL FREAD (IN17,F,KCT,0)
      CALL FREAD (IN17,DF,KCT,0)
      NSKP = NSKP + 2*KCT
      GO TO 160
  140 IF (JJ .GT. N1) GO TO 150
      CALL FREAD (IN17,F1 ,KC1T,0)
      CALL FREAD (IN17,DF1,KC1T,0)
      NSKP = NSKP + KC1T*2
      GO TO 160
  150 CALL FREAD (IN17,F2 ,KC2T,0)
      CALL FREAD (IN17,DF2,KC2T,0)
      NSKP = NSKP + KC2T*2
  160 CALL BCKREC (IN17)
C
C     START LOOP FOR ROWS ON PLANFORM
C
      KC  = 0
      KC1 = 0
      KC2 = 0
      DO 3000 I = 1,NCB
      IXR = I - 1
      XB  = BOXL*(FLOAT(IXR) + 0.5)
      XBB = XB + BOXL/2.0
C
C     BOXES ON PLANE OF MAIN
C
      DO 1100 J = 1,NSBD
      IF (.NOT.(I.GE.ND1(J) .AND. I.LE.NDN(J))) GO TO 1100
      DPHI  = (0.0, 0.0)
      WPHI  = DPHI
      TDH   = (0.0 ,0.0)
      LPHI  = .FALSE.
      SURF  = .FALSE.
      TEBOX = .FALSE.
      IF (I .GE. (NW1(J)+NWN(J))/2) TEBOX = .TRUE.
      IYR   = J - 1
      YB    = BOXW*FLOAT(IYR)
      K     = 1
      IF (YB .GT. Y(2)) K = 2
      PAW   = PAREA(I,J,1)
      PAF1  = PAREA(I,J,2)
      PAF2  = PAREA(I,J,3)
      PAWF  = PAW + PAF1 + PAF2
      IF (.NOT.TEBOX .AND. BETA.GT.TANG(K)) PAWF = 1.0
      PAD   = 1.0 - PAWF
      WS    = (0.0, 0.0)
      WF1   = (0.0, 0.0)
      WF2   = (0.0, 0.0)
      IF (J.EQ.1 .AND. ASYM) GO TO  800
      IF (J .GT. NSB) GO TO 500
      IF (PAD .GE. 0.995) GO TO  400
      IF (PAW .LT. 0.005) GO TO  200
C
      KC = KC + 1
      WS = 2.0*PAW*CMPLX(DF(KC), EK*F(KC))
C
  200 IF (PAF1 .LT. 0.005) GO TO  250
C
      KC1 = KC1 + 1
      WF1 = 2.0*PAF1*CMPLX(DF1(KC1), EK*F1(KC1))
C
  250 IF (PAF2 .LT. 0.005) GO TO 300
C
      KC2 = KC2 + 1
      WF2 = 2.0*PAF2*CMPLX(DF2(KC2), EK*F2(KC2))
C
  300 TDH    = (WS+WF1+WF2)/(PAWF*CR)
      LPHI   = .TRUE.
      TEMPHI = SUMPHI(IXR,IYR,ND1,NDN,CAPPHI,DSS,NNCB,NNSBD,ASYM)
      DPHI   = TDH*CAPPHI(1) + TEMPHI
      IF (PAWF .GE. .005) SURF = .TRUE.
      IF (.NOT.SURF .OR. .NOT.TEBOX) GO TO 350
      NTE(J) =  I
      DPHITE(3,J) = DPHITE(2,J)
      DPHITE(2,J) = DPHITE(1,J)
      DPHITE(1,J) = DPHI
C
  350 IF (PAWF .GT. 0.995) GO TO  800
  400 IF (.NOT.TEBOX) GO TO 500
      XT = XWTE(J)
      IF (XT .GE. XBB) GO TO 420
      DPHITE(1,J) = TRAILE(XT,J,NTE,DPHITE,NNSBD,BOXL)
      IF (XT .LE. XB) GO TO 450
  420 IF (XT .GE. XBB+BOXL) GO TO 500
      WPHI = DPHI
      GO TO 800
  450 EX   = EK*(XB-XT)/BOXL
      WPHI = DPHITE(1,J)*CMPLX(COS(EX), -SIN(EX))
      GO TO 800
  500 DPHI = PAWF*DPHI
      WPHI = (0.0, 0.0)
      IF (.NOT.LPHI) TEMPHI = SUMPHI(IXR,IYR,ND1,NDN,CAPPHI,DSS,NNCB,
     1                               NNSBD,ASYM)
      TDH  = PAD*(WPHI-TEMPHI)/CAPPHI(1) + PAWF*TDH
      IF (.NOT.SURF) DPHI = WPHI
  800 IF (SURF) CALL MBGAW (BOXL,DPHI,WS,PAW,PAF1,PAF2,Q,Q1,Q2,J,KC,KC1,
     1                      KC2)
C
      DSS(I,J) = TDH
 1100 CONTINUE
 3000 CONTINUE
      CALL MBGATE (NTOTE,DPHITE,NNSBD,YWTE,Q,Q1,Q2,KTE,KTE1,KTE2)
      CALL MBGAE (AJJL,IN17,A,F,DF,F1,DF1,F2,DF2,Q,Q1,Q2,MOOD)
      CALL BUG (NHCONT,3000,NJJ,30)
      CALL BUG (NHDSS ,3000,DSS,4)
 4000 CONTINUE
      CALL CLOSE (IN17,1)
      RETURN
      END

      SUBROUTINE RCOVDS
C
C     THIS ROUTINE GENERATES THE DYNAMIC SOLUTION ITEM FOR RIGID
C     FORMATS 8 AND 9
C
      INTEGER         DRY        ,STEP       ,FSS        ,RFNO        ,
     1                RD         ,RDREW      ,WRT        ,WRTREW      ,
     2                REW        ,SYSBUF     ,RC         ,EQSS        ,
     3                SOLN       ,SRD        ,SWRT       ,EOI         ,
     4                EOG        ,IZ(5)      ,UPV        ,TRL(7)      ,
     5                BUF1       ,DLOAD      ,DLT        ,CASESS      ,
     6                GEOM4      ,LOADC(2)   ,TOLPPF     ,NAME(2)     ,
     7                FILE       ,DIT        ,TABLOC(13) ,CASECC(2)
      CHARACTER       UFM*23     ,UWM*25
      COMMON /XMSSG / UFM        ,UWM
      COMMON /BLANK / DRY        ,LOOP       ,STEP       ,FSS(2)      ,
     1                RFNO       ,NEIGV      ,LUI        ,UINMS(2,5)  ,
     2                NOSORT     ,UTHRES     ,PTHRES     ,QTHRES
      COMMON /RCOVCR/ ICORE      ,LCORE      ,BUF1       ,BUF2        ,
     1                BUF3       ,BUF4       ,SOF1       ,SOF2        ,
     2                SOF3
      COMMON /RCOVCM/ MRECVR     ,UA         ,PA         ,QA          ,
     1                IOPT       ,RSS(2)     ,ENERGY     ,UIMPRO      ,
     2                RANGE(2)   ,IREQ       ,LREQ       ,LBASIC
      COMMON /NAMES / RD         ,RDREW      ,WRT        ,WRTREW      ,
     1                REW        ,NOREW      ,EOFNRW
      COMMON /ZZZZZZ/ Z(1)
      COMMON /SYSTEM/ SYSBUF     ,NOUT
      COMMON /CONDAS/ PI         ,TWOPI      ,RADEG      ,DEGRA
      EQUIVALENCE     (Z(1),IZ(1)) ,  (ISCALE,SCALE)
      DATA    NAME  / 4HRCOV,4HDS  /
      DATA    EQSS  , SOLN,LODS    / 4HEQSS,4HSOLN,4HLODS /
      DATA    SRD   , SWRT,EOG,EOI / 1,2,2,3      /
      DATA    UPV   , DLT,CASESS,GEOM4,TOLPPF,DIT /
     1        106   , 108,101   ,102  ,111   ,107 /
      DATA    LOADC / 500,  5      /
      DATA    TABLOC/ 4,1105,11,1,1205,12,2,1305,13,3,1405,14,4 /
      DATA    CASECC/ 4HCASE,4HCC  /
C
C     CREATE SOLN FOR RIGID FORMAT 8 OR 9
C
C     GET NUMBER OF BASIC SUBSTRUCTURES (NS) FROM EQSS AND CREATE
C     GROUP 0 OF SOLN AT TOP OF OPEN CORE
C
      LCORE = BUF1 - 1
      CALL SFETCH (FSS,EQSS,SRD,RC)
      IF (RC .EQ. 1) GO TO 110
      CALL SMSG (RC-2,EQSS,FSS)
      GO TO 810
  110 CALL SUREAD (Z,2,NWDS,RC)
      CALL SUREAD (NS,1,NWDS,RC)
      IF (LCORE .LT. 2*NS+5) GO TO 9008
      CALL SUREAD (Z,1,NWDS,RC)
      IZ(1) = FSS(1)
      IZ(2) = FSS(2)
      IZ(3) = RFNO
      IZ(4) = NS
C
C     GET THE BASIC SUBSTRUCTURE NAMES FROM EQSS
C
      DO 120 I = 1,NS
      CALL SUREAD (Z(3*I+3),2,NWDS,RC)
  120 CONTINUE
C
C     GET THE NUMBER OF LOAD VECTORS FOR EACH SUBSTRUCTURE FORM LODS
C
      CALL SFETCH (FSS,LODS,SRD,RC)
      IF (RC .EQ. 1) GO TO 160
      CALL SMSG (RC-2,LODS,FSS)
      GO TO 9200
  160 J = 1
      CALL SJUMP (J)
      DO 170 I = 1,NS
      CALL SUREAD (Z(3*I+5),1,NWDS,RC)
  170 CALL SJUMP  (J)
C
C     GET THE NUMBER OF TIME OR FREQUENCY STEPS FROM UPV OR UPVC
C
      TRL(1) = UPV
      CALL RDTRL (TRL)
      NSTEP = TRL(2)
      IF (RFNO .EQ. 9) NSTEP = NSTEP/3
      IZ(5) = NSTEP
C
C     GET THE REQUESTED DLOAD SET FROM CASE CONTROL
C
      FILE = CASESS
      CALL GOPEN (CASESS,Z(BUF1),RDREW)
  180 CALL FREAD (CASESS,TRL,2,1)
      IF (TRL(1).NE.CASECC(1) .OR. TRL(2).NE.CASECC(2)) GO TO 180
      CALL FREAD (CASESS,0,-12,0)
      CALL FREAD (CASESS,DLOAD,1,0)
      CALL CLOSE (CASESS,REW)
C
C     CHECK IF DLOAD SET POINTS TO A DLOAD COMBINATION CARD OR A
C     SIMPLE LOAD CARD BY LOOKING AT SET IDS IN HEADER RECORD OF DLT
C
      I = 3*NS + 6
      FILE = DLT
      CALL OPEN (*9001,DLT,Z(BUF1),RDREW)
      CALL READ (*9002,*200,DLT,Z(I),LCORE-I,1,NWDS)
      GO TO 9008
  200 IDLSET = I + 3
      LDLSET = IDLSET + IZ(I+2) - 1
      ILDSET = LDLSET + 1
      LLDSET = I + NWDS - 1
      IDLOAD = LLDSET + 1
      IF (IDLSET .GT. LDLSET) GO TO 215
      DO 210 I = IDLSET,LDLSET
      IF (IZ(I) .EQ. DLOAD) GO TO 220
  210 CONTINUE
C
C     NO DLOAD MATCH - MUST BE SIMPLE RLOAD OR TLOAD
C
  215 Z(IDLOAD) = 1.0
      IZ(IDLOAD+1) = DLOAD
      LDLOAD = IDLOAD + 1
      GO TO 270
C
C     DLOAD MATCH FOUND - READ DLOAD DATA FORM DLT RECORD 1
C
  220 CALL FREAD (DLT,TRL,2,0)
      IF (TRL(1) .EQ. DLOAD) GO TO 240
  230 CALL FREAD (DLT,TRL,2,0)
      IF (TRL(1) .NE. -1) GO TO 230
      GO TO 220
  240 I = IDLOAD
      ISCALE = TRL(2)
  250 CALL FREAD (DLT,Z(I),2,0)
      IF (IZ(I) .EQ. -1) GO TO 260
      Z(I) = Z(I)*SCALE
      I = I + 2
      IF (I .GT. LCORE) GO TO 9008
      GO TO 250
  260 LDLOAD = I - 1
C
C     READ THE RLOAD AND TLOAD DATA FORM DLT AND SAVE REQUESTED CARDS
C
  270 ILOAD = LDLOAD + 1
      L = ILOAD
      IF (IDLSET .LE. LDLSET) CALL FWDREC (*9002,DLT)
      DO 310 I = ILDSET,LLDSET
      DO 280 J = IDLOAD,LDLOAD,2
      IF (IZ(J+1) .EQ. IZ(I)) GO TO 290
  280 CONTINUE
      CALL FWDREC (*9002,DLT)
      GO TO 310
C
C     SAVE RLOAD DATA IF RIGID FORMAT 8
C     SAVE TLOAD DATA IF RIGID FORMAT 9
C
  290 CALL FREAD (DLT,ITYPE,1,0)
      IF (ITYPE.LE.2 .AND. RFNO.EQ.8) GO TO 300
      IF (ITYPE.GE.3 .AND. RFNO.EQ.9) GO TO 300
      CALL FWDREC (*9002,DLT)
      GO TO 310
C
  300 IZ(L) = ITYPE
      CALL FREAD (DLT,IZ(L+1),7,1)
      IZ(J+1) = -L
      L = L + 8
      IF (L .GT. LCORE) GO TO 9008
  310 CONTINUE
C
      LLOAD = L - 1
      CALL CLOSE (DLT,REW)
C
C     READ THE LOADC DATA FROM GEOM4 AND SAVE ANY THAT WAS REQUESTED
C     ON TLOAD OR RLOAD CARDS
C
C     NOTE - UNTIL A MODULE FRLG IS WRITTEN NO RLOAD CARD MAY REQUEST A
C            SCALAR LOAD
C
      NSLOAD = 0
      ILOADC = LLOAD  + 1
      LLOADC = ILOADC - 1
      ISLOAD = ILOADC
      LSLOAD = ISLOAD - 1
C
      IF (RFNO .EQ. 8) GO TO 500
C
      CALL PRELOC (*500,Z(BUF1),GEOM4)
      CALL LOCATE (*500,Z(BUF1),LOADC,I)
      IOLD = 0
      I1 = ILOADC
      I2 = I1
  320 CALL READ (*9002,*370,GEOM4,TRL(1),2,0,NWDS)
      ISCALE = TRL(2)
      IF (IOLD .EQ. TRL(1)) GO TO 360
      IHIT = 0
      DO 330 I = ILOAD,LLOAD,8
      IF (TRL(1) .NE. IZ(I+1)) GO TO 330
      IZ(I+1) = -I1
      IHIT = IHIT + 1
  330 CONTINUE
      IF (IHIT .GT. 0) GO TO 350
  340 CALL FREAD (GEOM4,TRL(1),4,0)
      IF (TRL(3) .NE. -1) GO TO 340
      GO TO 320
C
C     THIS LOADC DATA WAS REQUESTED - SAVE THE DATA AND A POINTER TO IT
C
  350 IOLD = TRL(1)
      I1 = I2
      IZ(I1) = 0
      I2 = I1 + 1
  360 CALL FREAD (GEOM4,Z(I2),4,0)
      IF (IZ(I2+2) .EQ. -1) GO TO 320
      IZ(I1) = IZ(I1) + 1
      Z(I2+3) = Z(I2+3)*SCALE
      I2 = I2 + 4
      IF (I2 .GT. LCORE) GO TO 9008
      GO TO 360
C
C     CONVERT LOADC LOAD SETS TO INTERNAL LOAD IDS BY USING THE LODS
C     ITEM
C
  370 LLOADC = I2 - 1
      IF (ILOADC .GT. LLOADC) GO TO 500
      CALL SFETCH (FSS,LODS,SRD,RC)
      I = 1
      CALL SJUMP (I)
      ILOD = 1
      IDAT0= LLOADC + 1
      IDAT = IDAT0  + 1
      NDAT = LCORE  - LLOADC
      ISUB = 6
      LSUB = 3*NS + 5
C
C     FOR EACH BASIC READ THE LODS DATA INTO CORE
C
      DO 410 I = ISUB,LSUB,3
      CALL SUREAD (Z(IDAT0),NDAT,NWDS,RC)
      IF (RC .NE. 2) GO TO 9008
      J = ILOADC
  380 I1 = J + 1
      I2 = J + IZ(J)*4
      DO 400 K = I1,I2,4
      IF (IZ(K).NE.IZ(I) .OR. IZ(K+1).NE.IZ(I+1)) GO TO 400
C
C     FOUND LOADC DATA FOR THIS BASIC - CONVERT LOAD SET ID
C
      IZ(K  ) = 0
      IZ(K+1) = 0
      NWDS = IDAT0 + NWDS - 1
      DO 390 L = IDAT,NWDS
      IF (IZ(L) .EQ. IZ(K+2)) GO TO 395
  390 CONTINUE
      WRITE (NOUT,6316) UWM,IZ(K+2),Z(I),Z(I+1),FSS
      IZ(K+2) = -1
      GO TO 400
C
  395 IZ(K+2) = ILOD + L - IDAT
C
  400 CONTINUE
      J = I2 + 1
      IF (J .LT. LLOADC) GO TO 380
C
  410 ILOD = ILOD + IZ(IDAT0)
C
C     CREATE A LIST OF INTERNAL LOAD VECTORS REQUESTED - ALSO CHECK IF
C     ANY BASIC NAMES WERE NOT FOUND
C
      ISLOAD = LLOADC + 1
      LSLOAD = ISLOAD - 1
      NSLOAD = 0
      J  = ILOADC
  420 I1 = J + 1
      I2 = J + IZ(J)*4
      DO 460 K = I1,I2,4
      IF (IZ(K) .EQ. 0) GO TO 430
      WRITE (NOUT,6315) UWM,Z(K),Z(K+1),FSS,IZ(K+2),FSS
      IZ(K+2) = -1
      GO TO 460
  430 IF (IZ(K+2) .LT. 0) GO TO 460
      IF (NSLOAD  .EQ. 0) GO TO 455
      DO 450 I = ISLOAD,LSLOAD
      IF (IZ(I) .EQ. IZ(K+2)) GO TO 460
  450 CONTINUE
  455 NSLOAD = NSLOAD + 1
      LSLOAD = LSLOAD + 1
      IF (LSLOAD .GT. LCORE) GO TO 9008
      IZ(LSLOAD) = IZ(K+2)
  460 CONTINUE
      J = I2 + 1
      IF (J .LT. LLOADC) GO TO 420
C
C     SORT LIST OF IDS
C
      CALL SORT (0,0,1,1,Z(ISLOAD),NSLOAD)
C
C     MAKE ONE MORE PASS THROUGH THE LOAC DATA CONVERTING THE
C     INTERNAL LOAD IDS TO A RELATIVE POSITION IN THE LOAD LIST
C     STARTING AT ISLOAD
C
      J  = ILOADC
  470 I1 = J + 1
      I2 = J + IZ(J)*4
      DO 495 K = I1,I2,4
      IF (IZ(K+2) .LT. 0) GO TO 495
      DO 480 L = ISLOAD,LSLOAD
      IF (IZ(K+2) .EQ. IZ(L)) GO TO 490
  480 CONTINUE
      GO TO 495
  490 IZ(K+2) = L - ISLOAD
  495 CONTINUE
      J = I2 + 1
      IF (J .LT. LLOADC) GO TO 470
C
C     OK - NOW WE CAN WRITE OUT GROUP 0 OF THE SOLN ITEM
C
  500 CALL CLOSE (GEOM4,REW)
      RC = 3
      CALL SFETCH (FSS,SOLN,SWRT,RC)
      CALL SUWRT (Z(1),3*NS+5,1)
      CALL SUWRT (NSLOAD,1,1)
      IF (NSLOAD .GT. 0) CALL SUWRT (Z(ISLOAD),NSLOAD,1)
      CALL SUWRT (0,0,EOG)
C
C     COPY THE FREQUENCY STEPS FROM PPF OR THE TIME STEPS FROM TOL
C     FOR GROUP 1 OF THE SOLN ITEM
C
      ISTEP = ISLOAD
      LSTEP = ISTEP + NSTEP - 1
      IF (LSTEP .GT. LCORE) GO TO 9008
      FILE = TOLPPF
      CALL OPEN (*9001,TOLPPF,Z(BUF1),RDREW)
      CALL FREAD (TOLPPF,TRL,2,0)
      CALL FREAD (TOLPPF,Z(ISTEP),NSTEP,0)
      CALL CLOSE (TOLPPF,REW)
C
      CALL SUWRT (Z(ISTEP),NSTEP,EOG)
C
C     IF ANY SCALAR LOADS EXIST CALCULATE THE SCALE FACTORS FOR EACH
C     LOAD AND WRITE THEM TO THE SOF - 1 GROUP PER TIME OR FREQUENCY
C     STEP
C
      IF (NSLOAD .EQ. 0) GO TO 800
      IVEC = LSTEP + 1
      LVEC = IVEC + NSLOAD - 1
      IF (LVEC .GT. LCORE) GO TO 9008
C
C     CALL PRETAB TO READ IN THE REQUIRED TABLE DATA - FIRST MAKE A
C     LIST OF REQUESTED TABLE IDS
C
      ITAB0 = LVEC + 1
      IZ(ITAB0) = 0
      ITAB = ITAB0 + 1
      LTAB = ITAB  - 1
      DO 570 J = ILOAD,LLOAD,8
      IF (IZ(J+1) .GE. 0) GO TO 570
      ITYPE = IZ(J)
      GO TO (510,510,520,570), ITYPE
  510 I1 = J + 2
      I2 = J + 3
      GO TO 530
  520 I1 = J + 2
      I2 = J + 2
  530 DO 560 K = I1,I2
      IF (IZ(K) .EQ.   0) GO TO 560
      IF (LTAB .LT. ITAB) GO TO 550
      DO 540 L = ITAB,LTAB
      IF (IZ(L) .EQ. IZ(K)) GO TO 560
  540 CONTINUE
  550 LTAB = LTAB + 1
      IF (LTAB .GT. LCORE) GO TO 9008
      IZ(LTAB ) = IZ(K)
      IZ(ITAB0) = IZ(ITAB0) + 1
  560 CONTINUE
  570 CONTINUE
C
      IF (IZ(ITAB0) .EQ. 0) GO TO 585
      ITABD = LTAB + 1
      CALL PRETAB (DIT,Z(ITABD),IZ(ITABD),Z(BUF1),LCORE-ITABD,LTABD,
     1             Z(ITAB0),TABLOC)
       LTABD = ITABD + LTABD - 1
  585 CONTINUE
C
C     LOOP OVER EACH TIME OR FREQUENCY STEP
C
      DO 790 I = ISTEP,LSTEP
C
C     ZERO A VECTOR IN CORE FOR THE SCALE FACTORS
C
      DO 590 J = IVEC,LVEC
  590 IZ(J) = 0
C
C     PASS THROUGH THE DLOAD DATA
C
      DO 780 J = IDLOAD,LDLOAD,2
      IF (IZ(J+1) .GE. 0) GO TO 780
C
C     PROCESS THE TLOAD OR RLOAD DATA THIS DLOAD ENTRY POINTS TO
C
      ILD = -IZ(J+1)
      IF (IZ(ILD+1) .GE. 0) GO TO 780
      ITYPE = IZ(ILD  )
      ILDC  =-IZ(ILD+1)
C
C     CALCULATE THE SCALE FACTOR FOR THE CARD FOR THIS TIME OR FREQUENCY
C     STEP
C
      GO TO (600,640,680,720), ITYPE
C
C     RLOAD1 DATA
C
  600 SCALE = 0.0
      GO TO 760
C
C     RLOAD2 DATA
C
  640 SCALE = 0.0
      GO TO 760
C
C     TLOAD1 DATA
C
  680 CALL TAB (IZ(ILD+2),Z(I),SCALE)
      GO TO 760
C
C     TLOAD2 DATA
C
  720 SCALE = 0.0
      TT    = Z(I) - Z(ILD+2)
      IF (TT .EQ. 0.0) GO TO 730
      IF (TT.LT.0.0 .OR. TT.GT.Z(ILD+3)) GO TO 760
      SCALE = TT**Z(ILD+7)*EXP(Z(ILD+6)*TT)*COS(TWOPI*Z(ILD+4)*TT
     1        + Z(ILD+5)*DEGRA)
      GO TO 760
  730 IF (Z(ILD+7) .NE. 0.0) GO TO 760
      SCALE = COS(Z(ILD+5))
C
C     NOW APPLY THIS SCALE FACTOR TO EACH LOADC ENTRY.
C     TOTAL SCALE FACTOR = T(R)LOAD FACTOR*DLOAD FACTOR*LOADC FACTOR
C
  760 CONTINUE
      IF (SCALE .EQ. 0.0) GO TO 780
      I1 = ILDC + 1
      I2 = ILDC + IZ(ILDC)*4
      DO 770 K = I1,I2,4
      IF (IZ(K+2) .LT. 0) GO TO 770
      IFAC = IVEC + IZ(K+2)
      Z(IFAC) = Z(IFAC) + SCALE*Z(J)*Z(K+3)
  770 CONTINUE
C
  780 CONTINUE
C
C     WRITE OUT THESE FACTORS TO THE NEXT GROUP OF THE SOF
C
      CALL SUWRT (Z(IVEC),NSLOAD,EOG)
  790 CONTINUE
C
C     FINISHED
C
  800 CALL SUWRT (0,0,EOI)
  810 CALL SOFCLS
      RETURN
C
C     DIAGNOSTICS
C
 6315 FORMAT (A25,' 6315, RCOVR MODULE - SUBSTRUCTURE ',2A4,' IS NOT A',
     1        ' COMPONENT OF ',2A4, /32X,'LOAD SET',I9,' FOR THAT ',
     2        'SUBSTRUCTURE WILL BE IGNORED IN CREATING', /32X,
     3        'THE SOLN ITEM FOR FINAL SOLUTION STRUCTURE ',2A4)
 6316 FORMAT (A25,' 6316, RCOVR MODULE IS UNABLE TO FIND LOAD SET ',I8,
     1        ' FOR SUBSTRUCTURE ',2A4, /32X,'AMONG THOSE ON LODS.  ',
     2        'IT WILL BE IGNORED IN CREATING THE SOLN ITEM FOR FINAL',
     3        /32X,'SOLUTION STRUCTURE ',2A4)
 9001 N = 1
      GO TO 9100
 9002 N = 2
      GO TO 9100
 9008 N = 8
 9100 CALL MESAGE (N,FILE,NAME)
 9200 CALL SOFCLS
      IOPT = -1
      CALL CLOSE (CASESS,REW)
      CALL CLOSE (DLT,REW)
      CALL CLOSE (GEOM4,REW)
      CALL CLOSE (TOLPPF,REW)
      CALL CLOSE (DIT,REW)
      RETURN
      END

      BLOCK DATA ITEMBD
CITEMBD
C     ITEMBD BLOCK DATA
C
C     TO ADD NEW ITEMS TO THE SOF THE FOLLOWING CODE CHANGES MUST BE
C     MADE.
C
C        1) INCREASE THE DIMENSION OF ITEM IN THE ITEMDT COMMON BLOCK.
C        2) INCREASE THE DIMENSION OF THE ITEMXX ARRAY AND ADD ANY
C           ADDITIONAL ARRAYS AND EQUIVALENCES IF NECESSARY.
C        3) INCREASE THE VALUE OF NITEM IN THE DATA STATEMENT.
C        4) ADD THE NEW DATA DESCRIBING THE NEW ITEMS.
C        5) SUBROUTINE EXO2 MUST BE CHANGED IF THE NEW ITEM IS A TABLE.
C           THIS ROUTINE PROCESSES THE SOFOUT(EXTERNAL) STATEMENT.
C        6) SUBROUTINE SOFTOC MUST BE CHANGED IF THE NEW ITEMS WILL
C           INCREASE THE NUMBER IF ITEMS TO MORE THEN 27.
C
C     NOTE... IF THE NUMBER OF ITEMS IS DECREASED THE LENGTH OF THE
C             ITEMDT COMMON BLOCK SHOULD NOT BE DECREASED.  SOFS CREATED
C             ON THE OLDER SYSTEM WILL REQUIRE THE EXTRA SPACE WHEN
C             RESTORING THE ITEM STRUCTURE FOR THAT SOF.
C
      INTEGER       ITEM01(7,10)  ,ITEM02(7,10)  ,ITEM03(7,5)
C
      COMMON / ITEMDT /       NITEM    ,ITEM(7,25)
C
      EQUIVALENCE   ( ITEM01(1,1) , ITEM(1, 1) )
     2             ,( ITEM02(1,1) , ITEM(1,11) )
     3             ,( ITEM03(1,1) , ITEM(1,21) )
C
C        NITEM     = NUMBER OF ITEMS
C        ITEM(1,I) = ITEM NAME
C        ITEM(2,I) = ITEM TYPE
C                         LE 0 - TABLE ITEM
C                         GE 1 - MATRIX ITEM
C        ITEM(3,I) = EQUIV DATA FOR GROUP 0 OF ITEMS TO BE COPYIED
C                         X 1000 - WORD WITH NUMBER OF NAMES
C                         X 100  - WORD WITH FIRST NAME
C                         X 1    - NUMBER OF WORDS FOR EACH NAME
C        ITEM(4,I) = IMAGE SUBSTRUCTURE DATA
C                         0 - ITEM IS ONLY A POINTER TO PRIMARY DATA
C                         1 - UNIQUE DATA, RETURN TO FREE BLOCK LIST
C        ITEM(5,I) = SECONDARY SUBSTRUCTURE DATA
C                         0 - ITEM IS ONLY A POINTER TO PRIMARY DATA
C                         1 - UNIQUE DATA, RETURN TO FREE BLOCK LIST
C        ITEM(6,I) = HIGHER LEVEL SUBSTRUCTURE DATA
C                         0 - ITEM DOES NOT PERTAIN TO HIGER LEVEL
C                         1 - ITEM DESCRIBES HIGHER LEVEL
C        ITEM(7,1) = EDIT DATA.  EACH BIT IS SET IF THAT ITEM IS IN
C                    THE COORESPONDING EDIT GROUP.  EXAMPLE - A VALUE
C                    OF 36 WOULD CAUSE THE ITEM TO BE DELETED BY
C                    EDIT(32) OR EDIT(4)
C
C***********************************************************************
C
      DATA NITEM / 25 /
C
C
C          NAME   TYPE     EQUIV     IMAGE    SECONDARY   HIGHER   EDIT
C
      DATA ITEM01 /
     1    4HEQSS   ,0        ,3005002  ,1        ,1        ,0      ,32
     2   ,4HBGSS   ,0        ,0        ,0        ,0        ,0      ,32
     3   ,4HCSTM   ,0        ,0        ,0        ,0        ,0      ,32
     4   ,4HLODS   ,0        ,4005002  ,1        ,1        ,0      ,36
     5   ,4HPLTS   ,0        ,3004014  ,1        ,1        ,0      ,32
     6   ,4HKMTX   ,1        ,0        ,0        ,0        ,0      ,33
     7   ,4HMMTX   ,1        ,0        ,0        ,0        ,0      ,34
     8   ,4HPVEC   ,1        ,0        ,0        ,0        ,0      ,36
     9   ,4HPOVE   ,1        ,0        ,0        ,1        ,1      ,48
     O   ,4HUPRT   ,1        ,0        ,0        ,1        ,1      ,48
     *                                                                 /
      DATA ITEM02 /
     1    4HHORG   ,1        ,0        ,0        ,1        ,1      ,560
     2   ,4HUVEC   ,1        ,0        ,1        ,1        ,0      ,40
     3   ,4HQVEC   ,1        ,0        ,1        ,1        ,0      ,40
     4   ,4HSOLN   ,0        ,0        ,1        ,1        ,0      ,40
     5   ,4HPAPP   ,1        ,0        ,0        ,0        ,0      ,100
     6   ,4HPOAP   ,1        ,0        ,0        ,1        ,1      ,112
     7   ,4HLOAP   ,0        ,4005002  ,1        ,1        ,0      ,100
     8   ,4HLMTX   ,1        ,0        ,0        ,1        ,1      ,48
     9   ,4HGIMS   ,1        ,0        ,0        ,1        ,1      ,48
     O   ,4HPHIS   ,1        ,0        ,0        ,1        ,1      ,288
     *                                                                 /
      DATA ITEM03 /
     1    4HLAMS   ,0        ,0        ,0        ,1        ,1      ,288
     2   ,4HK4MX   ,1        ,0        ,0        ,0        ,0      ,160
     3   ,4HBMTX   ,1        ,0        ,0        ,0        ,0      ,160
     4   ,4HPHIL   ,1        ,0        ,0        ,1        ,1      ,288
     5   ,4HHLFT   ,1        ,0        ,0        ,1        ,1      ,560
     *                                                                 /
      END

      SUBROUTINE CMRD2B (KODE)
C
C     THIS SUBROUTINE PROCESSES THE OLDMODES OPTION FLAG FOR THE CMRED2
C     MODULE.
C
C     INPUT  DATA
C     GINO - LAMAMR - EIGENVALUE TABLE FOR SUBSTRUCTURE BEING REDUCED
C            PHISSR - RIGHT HAND EIGENVECTOR MATRIX FOR SUBSTRUCTURE
C                     BEING REDUCED
C            PHISSL - LEFT HAND EIGENVECTOR MATRIX FOR SUBSTRUCTURE
C                     BEING REDUCED
C     SOF  - LAMS   - EIGENVALUE TABLE FOR ORIGINAL SUBSTRUCTURE
C            PHIS   - RIGHT HAND EIGENVECTOR TABLE FOR ORIGINAL
C                     SUBSTRUCTURE
C            PHIL   - LEFT HAND EIGENVECTOR TABLE FOR ORIGINAL
C                     SUBSTRUCTURE
C
C     OUTPUT DATA
C     GINO - LAMAMR - EIGENVALUE TABLE FOR SUBSTRUCTURE BEING REDUCED
C            PHISS  - EIGENVECTOR MATRIX FOR SUBSTRUCTURE BEING REDUCED
C     SOF  - LAMS   - EIGENVALUE TABLE FOR ORIGINAL SUBSTRUCTURE
C            PHIS   - EIGENVECTOR MATRIX FOR ORIGINAL SUBSTRUCTURE
C
C     PARAMETERS
C     INPUT- GBUF   - GINO BUFFER
C            INFILE - INPUT FILE NUMBERS
C            ISCR   - SCRATCH FILE NUMBERS
C            KORBGN - BEGINNING ADDRESS OF OPEN CORE
C            OLDNAM - NAME OF SUBSTRUCTURE BEING REDUCED
C            MODES  - OLDMODES OPTION FLAG
C            NFOUND - NUMBER OF MODAL POINTS USED
C            LAMAAP - BEGINNING ADDRESS OF LAMS RECORD TO BE APPENDED
C            MODLEN - LENGTH OF MODE USE ARRAY
C     OTHERS-LAMAMR - LAMAMR INPUT FILE NUMBER
C            PHIS   - PHIS INPUT FILE NUMBER
C            LAMS   - LAMS INPUT FILE NUMBER
C            PHISS  - PHISS INPUT FILE NUMBER
C
      LOGICAL         MODES
      INTEGER         DRY,GBUF1,OLDNAM,Z,PHISSR,PHISSL,PHISL,RGDFMT
      DIMENSION       RZ(1),MODNAM(2),ITMLST(3)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /BLANK / IDUM1,DRY,IDUM7,GBUF1,IDUM2(5),INFILE(11),
     1                IDUM3(6),ISCR(11),KORLEN,KORBGN,OLDNAM(2),
     2                IDUM5(7),MODES,IDUM6,LAMAAP,NFOUND,MODLEN
      COMMON /ZZZZZZ/ Z(1)
      COMMON /SYSTEM/ IDUM4,IPRNTR
      EQUIVALENCE     (RZ(1),Z(1)),(LAMAMR,INFILE(2)),
     1                (PHISSR,INFILE(3)),(PHISSL,INFILE(4)),
     2                (LAMS,ISCR(5)),(PHISL,ISCR(6))
      DATA    MODNAM/ 4HCMRD,4H2B  /
      DATA    ITMLST/ 4HPHIS,4HPHIL,4HLAMS/
      DATA    RGDFMT/ 3 /
C
C     TEST OPERATION FLAG
C
      IF (DRY .EQ. -2) RETURN
      IF (KODE .EQ. 3) GO TO 20
C
C     TEST OLDMODES OPTION FLAG
C
      IF (MODES) GO TO 10
C
C     STORE GINO PHISS(R,L) AS PHI(S,L) ON SOF
C
      IFILE = PHISSR
      IF (KODE .EQ. 2) IFILE = PHISSL
      ITEM = ITMLST(KODE)
      CALL MTRXO (IFILE,OLDNAM,ITEM,0,ITEST)
      IF (ITEST .NE. 3) GO TO 120
      RETURN
C
C     READ SOF PHI(S,L) ONTO GINO PHI(S,L) SCRATCH FILES
C
   10 ITEM = ITMLST(KODE)
      CALL MTRXI (PHISL,OLDNAM,ITEM,0,ITEST)
      IF (ITEST .NE. 1) GO TO 120
C
C     READ SOF LAMS ONTO GINO LAMS SCRATCH FILE
C
      CALL SFETCH (OLDNAM,ITMLST(3),1,ITEST)
      ITEM = ITMLST(3)
      IF (ITEST .GT. 1) GO TO 120
      CALL GOPEN  (LAMS,Z(GBUF1),1)
      CALL SUREAD (Z(KORBGN),-1,NWDSRD,ITEST)
      CALL WRITE  (LAMS,Z(KORBGN),NWDSRD,1)
      CALL SUREAD (Z(KORBGN),-1,NWDSRD,ITEST)
      CALL WRITE  (LAMS,Z(KORBGN),NWDSRD,1)
      CALL CLOSE  (LAMS,1)
C
C     SWITCH FILE NUMBERS
C
      IF (KODE .EQ. 1) PHISSR = PHISL
      IF (KODE .EQ. 2) PHISSL = PHISL
      LAMAMR = LAMS
      RETURN
C
C     STORE LAMAMR (TABLE) AS LAMS ON SOF
C
   20 IF (MODES) GO TO 60
      ITEM = ITMLST(3)
      CALL DELETE (OLDNAM,ITEM,ITEST)
      IF (ITEST.EQ.2 .OR. ITEST.GT.3) GO TO 120
      IFILE = LAMAMR
      CALL GOPEN  (LAMAMR,Z(GBUF1),0)
      CALL FWDREC (*100,LAMAMR)
      ITEST = 3
      CALL SFETCH (OLDNAM,ITMLST(3),2,ITEST)
      IF (ITEST .NE. 3) GO TO 120
      DO 30 I = 1, 2
   30 Z(KORBGN+I-1) = OLDNAM(I)
      Z(KORBGN+2) = RGDFMT
      Z(KORBGN+3) = MODLEN
      CALL SUWRT (Z(KORBGN),4,2)
      LAMWDS = MODLEN - 1
      RZ(KORBGN+6) = 0.0
      DO 50 I = 1,LAMWDS
      CALL READ  (*90,*100,LAMAMR,Z(KORBGN),6,0,NWDS)
   50 CALL SUWRT (Z(KORBGN),7,1)
      CALL READ  (*90,*100,LAMAMR,Z(KORBGN),6,0,NWDS)
      CALL CLOSE (LAMAMR,1)
      CALL SUWRT (Z(KORBGN),7,2)
      CALL SUWRT (Z(LAMAAP),MODLEN,2)
      CALL SUWRT (Z(LAMAAP),0,3)
   60 CONTINUE
      RETURN
C
C     PROCESS SYSTEM FATAL ERRORS
C
   90 IMSG = -2
      GO TO 110
  100 IMSG = -3
  110 CALL SOFCLS
      CALL MESAGE (IMSG,IFILE,MODNAM)
      RETURN
C
C     PROCESS MODULE FATAL ERRORS
C
  120 GO TO (130,135,140,150,160,180), ITEST
  130 WRITE (IPRNTR,900) UFM,MODNAM,ITEM,OLDNAM
      DRY = -2
      RETURN
C
  135 WRITE (IPRNTR,902) UFM,MODNAM,ITEM,OLDNAM
      DRY = -2
      RETURN
  140 IMSG = -1
      GO TO 170
  150 IMSG = -2
      GO TO 170
  160 IMSG = -3
  170 CALL SMSG (IMSG,ITEM,OLDNAM)
      RETURN
C
  180 WRITE (IPRNTR,901) UFM,MODNAM,ITEM,OLDNAM
      DRY = -2
      RETURN
C
  900 FORMAT (A23,' 6211, MODULE ',2A4,' - ITEM ',A4,
     1       ' OF SUBSTRUCTURE ',2A4,' HAS ALREADY BEEN WRITTEN.')
  901 FORMAT (A23,' 6632, MODULE ',2A4,' - NASTRAN MATRIX FILE FOR I/O',
     1       ' OF SOF ITEM ',A4,', SUBSTRUCTURE ',2A4,', IS PURBED.')
  902 FORMAT (A23,' 6215, MODULE ',2A4,' - ITEM ',A4,
     1       ' OF SUBSTRUCTURE ',2A4,' PSEUDO-EXISTS ONLY.')
C
      END

      SUBROUTINE XGPIDD
C
C     THIS SUBROUTINE DEFINES ALL NAMED COMMON FOR SUBROUTINES
C     XGPI,XOSGEN,XLNKHD,XIOFL,XPARAM,XSCNDM,XFLORD,XFLDEF AND XGPIDG.
C     **NOTE - THIS PROGRAM MUST BE LOADED BEFORE ANY OF THE ABOVE.
C
      INTEGER  BCDCNT,CPNTRY,DIAG4,DIAG14,DIAG17,DIAG25,DMAP,DMPCNT,
     1         DMPPNT,EOTFLG,IHOL(22),JMP,NAMOPT(26),PVT,SETEOR,SOL,
     2         START,SUBSET
C
C     NAMED COMMON AREAS /XGPIC/ AND /XGPID/ CONTAIN
C     MACHINE DEPENDENT DATA
C
C     COMMON /XGPIC / ICOLD,ISLSH,IEQUL,NBLANK,NXEQUI,
C                        ** CONTROL CARD NAMES **
C    1                NMED,NSOL,NDMAP,NESTM1,NESTM2,NEXIT,
C                        ** DMAP CARD NAMES **
C    2                NBEGIN,NEND,NJUMP,NCOND,NREPT,NTIME,NSAVE,NOUTPT,
C    3                NCHKPT,NPURGE,NEQUIV,
C      ** THE FOLLOWING CONSTANTS ARE INITIALIZED BY XGPIBS ROUTINE **
C    4                NCPW,NBPC,NWPC,
C    5                MASKLO,ISGNON,NOSGN,IALLON,MASKS(40)
C
      COMMON /XGPIC / ICOLD,IHOLC(21),
     4                NCPW,NBPC,NWPC,
     5                MASKHI,MASKLO,ISGNON,NOSGN,IALLON,MASKS(40)
      COMMON /XGPID / ICST,IUNST,IMST,IHAPP,IDSAPP,IDMAPP,
     1                ISAVE,ITAPE,IAPPND,INTGR,LOSGN,
     2                NOFLGS,SETEOR,EOTFLG,IEQFLG,
     3                CPNTRY(7),JMP(7)
C
C     ****** /XGPI1 / *******
C
C     COMMON /XGPI1 / LOSCAR,OSPRC,OSBOT,OSPNT,OSCAR(1)
C
C     NOTE - /XGPI1 / MUST BE LOADED AT THE END OF LONGEST LINK IN XGPI
C                     BECAUSE IT DEFINES THE START OF OPEN CORE.
C
C     OSCAR  = OPERATION SEQUENCE CONTROL ARRAY
C     LOSCAR = LENGTH OF OSCAR ARRAY
C     OSPRC  = POINTER TO PRECEDING OSCAR ENTRY
C     OSBOT  = POINTER TO LAST OSCAR ENTRY
C     OSPNT  = POINTER TO PRESENT OSCAR ENTRY BEING PROCESSED
C
C     ***ORDER OF TABLES IN OPEN CORE DURING PHASE 1 OF COMPILATION.
C        EQUIVALENCE (OSCAR,DMPCRD,LBLTBL,MED,IBUFR)
C
C     ***ORDER OF TABLES IN OPEN CORE DURING PHASE 2 OF COMPILATION.
C        EQUIVALENCE (OSCAR,PTDIC,ICPDPL,MED,IBUFR)
C     IBUFR  = GINO BUFFER AREA LOCATED AT HIGH ADDRESS END OF OPEN
C              CORE.
C     DMPCRD = DMAP SEQUENCE CARD IMAGE BUFFER
C     PTDIC  = PROBLEM TAPE CHECKPOINT DICTIONARY
C     MED    = MODULE EXECUTION DECISION TABLE FOR RESTARTS IN RIGID
C              FORMATS
C     ICPDPL = LIST OF CHECKPOINT FILES TO BE WRITTEN ON DATA POOL FROM
C              OLD  PROBLEM TAPE IN ORDER TO RESTART PROBLEM.
C     LBLTBL = TABLE OF LABEL NAMES AND PARAMETER NAMES REFERENCED BY
C              LABEL,COND,PURGE AND EQUIV DMAP INSTRUCTIONS.
C
      COMMON /XGPI3 / PVT(200)
      COMMON /XGPI4 / IRTURN,INSERT,ISEQN,DMPCNT,IDMPNT,DMPPNT,BCDCNT,
     1                LENGTH,ICRDTP,ICHAR,NEWCRD,MODIDX,LDMAP,ISAVDW,
     2                DMAP(200)
      COMMON /XGPI5 / IAPP,START,ALTER(2),SOL,SUBSET,IFLAG,
     1                IESTIM,ICFTOP,ICFPNT,LCTLFL,ICTLFL(1)
      COMMON /XGPI6 / MEDTP,FNMTP,CNMTP,MEDPNT,LMED,IPLUS,DIAG14,DIAG17,
     1                DIAG4,DIAG25,IFIRST,IBUFF(20)
      COMMON /XGPI7 / IFPNT,LFILE,IFILE(130)
      COMMON /XGPI8 / ICPTOP,ICPBOT,LCPDPL
      COMMON /MODDMP/ IFLG(6),NMPT(26)
      DATA    NAMOPT/ 4HGO  ,4H    ,4HNOGO,4H    ,4HERR ,4H    ,4HLIST,
     1                4H    ,4HNOLI,4HST  ,4HDECK,4H    ,4HNODE,4HCK  ,
     2                4HREF ,4H    ,4HNORE,4HF   ,4HOSCA,4HR   ,4HNOOS,
     3                4HCAR ,4HALL ,4H    ,4HEXCE,4HPT  /
      DATA    IHOL  / 4H/   ,4H=   ,4H    ,4HXEQU,4HMED ,4HSOL ,4HDMAP,
     1                4HESTI,4HM   ,4HEXIT,4HBEGI,4HEND ,4HJUMP,4HCOND,
     2                4HREPT,4HTIME,4HSAVE,4HOUTP,4HCHKP,4HPURG,4HEQUI,
     3                4HXCHK/
      DATA    IPLS  / 1H+   /
C
C     ****** /XGPIC / *******
C
C     NCPW   = NUMBER OF CHARACTERS PER WORD.
C     NBPC   = NUMBER OF BITS PER CHARACTER.
C     NWPC   = NUMBER OF WORDS PER INPUT CARD (72 CHARACTERS).
C     MASKHI = MASK OUT ALL BITS EXCEPT LOW ORDER 15 BITS
C            = 2**15 - 1
C     MASKLO = MASK FOR HI ORDER 16 BITS, SIGN BIT NOT INCLUDED
C            = LSHIFT(MASKHI,16)
C     ISGNON = MASK OUT ALL BUT SIGN BIT
C            = LSHIFT(1,NBPW-1)
C     NOSGN  = MASK OUT ONLY SIGN BIT
C            = COMPLF(ISGNON)
C     IALLON = ALL BITS ON
C            = COMPLF(0)
C     MASKS  = TABLE OF MASKS FOR MASKING OUT VARIOUS CHARACTERS OF A
C              WORD. TABLE LENGTH = 4*NCPW (40 MAX.)
C
C     DATA     ICOLD /1     /, ISLSH /4H/   /, IEQUL /4H=   /,
C    1         NXEQUI/4HXEQU/, NMED  /4HMED /, NSOL  /4HSOL /,
C    2         NDMAP /4HDMAP/, NESTM1/4HESTI/, NESTM2/4HM   /,
C    3         NEXIT /4HEXIT/, NBEGIN/4HBEGI/, NEND  /4HEND /,
C    3         NJUMP /4HJUMP/, NCOND /4HCOND/, NBLANK/4H    /,
C    4         NREPT /4HREPT/, NTIME /4HTIME/, NSAVE /4HSAVE/,
C    5         NCHKPT/4HCHKP/, NPURGE/4HPURG/, NEQUIV/4HEQUI/,
C    6         MASKHI/32767 /, NOUTPT/4HOUTP/
C
      ICOLD  = 1
      MASKHI = 32767
C              2**15 - 1
      DO 5 I = 1,21
    5 IHOLC(I) = IHOL(I)
C
C     ****** /XGPID / *******
C
C     ICST,IUNST,IMST = COLD,UNMODIFIED,MODIFIED START CODES
C     IHAPP,IDSAPP,IDMAPP = HEAT,DISPLACEMENT,DMAP APPROACH CODES
C     ** THE FOLLOWING CONSTANTS ARE INITIALIZED IN XGPIBS ROUTINE **
C     INTGR  = INTEGER TYPE CODE RETURNED BY XSCNDM
C     ISAVE,ITAPE,IAPPND = FLAGS USED IN /XGPI7/
C     MODFLG = PARAM MODIFY FLAG IN VPS
C     LOSGN  = SIGN BIT OF LOW ORDER 16 BITS
C     NOFLGS = MASK OUT FLAGS USED IN PTDIC TABLE AND ICPDPL
C     SETEOR = END OF RECORD FLAG IN PTDIC,ICPDPL TABLES
C     EOTFLG = END OF TAPE FLAG   IN PTDIC,ICPDPL TABLES
C     IEQFLG = EQUIVALENCE FLAG   IN PTDIC,ICPDPL,DPL,FIAT TABLES
C     CPNTRY = TABLE CONTAINING HEADER SECTION OF CHECKPOINT OSCAR ENTRY
C     JMP    = TABLE CONTAINING JUMP OSCAR ENTRY TO BE INSERTED
C
C     DATA  ICST  /1/, IUNST/2/, IMST/3/, IDMAPP/1/, ISAVE/1/,
C    1      CPNTRY/6,2,0,4HXCHK, 4H    ,  0,0/,
C    2      JMP   /7,3,0,4HJUMP, 4H    ,  0,0/
C
      ICST   = 1
      IUNST  = 2
      IMST   = 3
      IDMAPP = 1
      ISAVE  = 1
      JMP(1) = 7
      JMP(2) = 3
      JMP(3) = 0
      JMP(4) = IHOL(13)
      JMP(5) = IHOL( 3)
      JMP(6) = 0
      JMP(7) = 0
      CPNTRY(1) = 6
      CPNTRY(2) = 2
      CPNTRY(3) = 0
      CPNTRY(4) = IHOL(22)
      CPNTRY(5) = IHOL( 3)
      CPNTRY(6) = 0
      CPNTRY(7) = 0
C
C     ****** /XGPI3 / *******
C
C     PVT = PARAMETER VALUE TABLE
C     DATA  PVT/200,2,0,0,1,195*0/
C
      PVT(1) = 200
      PVT(2) = 2
      DO 10 I = 3,200
   10 PVT(I) = 0
      PVT(5) = 1
C
C     ****** /XGPI4 / *******
C
C     IRTURN = RETURN CODE USED FOR ALTERNATE RETURNS
C     INSERT = -1  INDICATES DMAP INSTRUCTION IS TO BE DELETED.
C            =  0  PROCESS DMAP INSTRUCTION FROM MAIN STREAM.
C            =  1  INSERT DMAP INSTRUCTION FROM ALTER FILE.
C     ISEQN  = NEXT OSCAR SEQUENCE NUMBER TO BE ASSIGNED.
C     DMPCNT = DMAP INSTRUCTION COUNTER
C     IDMPNT = POINTER TO NEXT ITEM TO BE SCANNED IN DMAP ARRAY
C     DMPPNT = POINTER TO ITEM IN DMAP ARRAY RETURNED BY XSCNDM ROUTINE
C     BCDCNT = NUMBER OF BCD ENTRIES REMAINING IN DMAP ARRAY BEFORE MODE
C              CHANGES.
C     LENGTH = LENGTH (IN WORDS) OF BINARY VALUE RETURNED BY XSCNDM
C              ROUTINE.
C     ICRDTP = POINTER TO NEXT WORD TO BE PROCESSED IN DMPCRD ARRAY.
C     ICHAR  = POINTER TO NEXT CHARACTER TO BE PROCESSED IN DMPCRD ARRAY
C     NEWCRD = FLAG TO INDICATE WHETHER OR NOT TO PREPARE NEXT CARD
C              IMAGE FOR TRANSLATION BY XRCARD ROUTINE.
C     MODIDX = MODULE INDEX STORED IN OSCAR ENTRY FOR USE BY XSEM
C              ROUTINE.
C     LDMAP  = LENGTH OF DMAP ARRAY.
C     ISAVDW = POINTER TO LAST DELIMITER ENCOUNTERED IN DMPCRD ARRAY,
C              USED BY XSCNDM WHEN UNPACKING RIGID FORMAT DMAP SEQUENCE.
C     DMAP   = ARRAY CONTAINING OUTPUT FROM XRCARD ROUTINE.
C
C     DESCRIPTION OF VARIABLES EQUIVALENCED TO /XGPI4/ ENTRIES
C     EQUIVALENCE (DMAP,ICF)
C     ICF    = TEMPORARY STORAGE FOR CONTROL FILE DICTIONARY.
C
C     DATA     ISEQN/1/, DMPCNT/0/, ICHAR/1/, LDMAP/200/, BCDCNT/0/
C
      ISEQN  = 1
      DMPCNT = 0
      ICHAR  = 1
      LDMAP  = 200
      BCDCNT = 0
C
C     ****** /XGPI5/ *******
C
C     IAPP   = APPROACH CODE.
C     START  = TYPE OF START CODE.
C     ALTER  = DMAP NOS. OF INSTRUCTIONS TO BE ALTERED
C     SOL    = SOLUTION CODE.
C     SUBSET = SOLUTION SUBSET CODE.
C     IFLAG  = FLAG FOR USE IN SUBROUTINE XLNKHD.
C     IESTIM = POINTER TO ESTIM ENTRIES IN ICTLFL OR ZERO.
C     ICFTOP = POINTER TO FIRST WORD IN ICTLFL ARRAY
C     ICFPNT = POINTER TO NEXT AVAILABLE WORD IN ICTLFL ARRAY
C     LCTLFL = LENGTH OF ICTLFL ARRAY.
C     ICTLFL = ARRAY CONTAINING INFORMATION FROM ESTIM CONTROL CARD.
C
C     DATA     IESTIM/0/, ICFTOP/1/, LCTLFL/1/, IFLAG/0/
C
      IESTIM = 0
      ICFTOP = 1
      LCTLFL = 1
      IFLAG  = 0
C
C     ****** /XGPI6/ *******
C
C     MED    = (SEE DESCRIPTION IN /XGPI1/)
C     MEDTP  = POINTER TO FIRST WORD IN MED ARRAY.
C     LMED   = LENGTH OF MED ARRAY.
C     MEDPNT = POINTER TO AN ENTRY IN MED
C     FNMTP  = POINTER TO FIRST WORD OF FILE NAME PORTION OF MED TABLE
C     CNMTP  = POINTER TO FIRST WORD OF CARD NAME PORTION OF MED TABLE
C     IPLUS  = PLUS CHARACTER FOR PRINTER SPACE SUPRESS
C     DIAG14 = SKIP DMAP PRINT UNLESS RESTART (SET BY XGPI)
C     DIAG17 = DMAP PUNCH OPTION FLAG (SET BY XGPI)
C
C     DATA     MEDTP/1/,  LMED/0/,  IPLUS/1H+/
C
      MEDTP  = 1
      LMED   = 0
      IPLUS  = IPLS
C
C     ****** /XGPI7/ *******
C
C     IFPNT  = POINTER TO LAST ENTRY IN FILE TABLE
C     LFILE  = LENGTH OF FILE TABLE (IN WORDS)
C     IFILE  = TABLE CONTAINING INFO FROM FILE DMAP INSTRUCTION
C
C     DATA     IFPNT/-2/,  LFILE/130/,  IFILE/130*0/
C
      IFPNT  = -2
      LFILE  = 130
      DO 20 I = 1,LFILE
   20 IFILE(I) = 0
C
C     ****** /XGPI8 / *******
C
C     ICPDPL = (SEE /XGPI1/ FOR DESCRIPTION)
C     ICPTOP = POINTER TO FIRST ENTRY IN ICPDPL ARRAY.
C     ICPBOT = POINTER TO LAST  ENTRY IN ICPDPL ARRAY.
C     LCPDPL = LENGTH OF ICPDPL ARRAY)
C
C     DATA     ICPTOP/0/,  ICPBOT/0/,  LCPDPL/0/
C
      ICPTOP = 0
      ICPBOT = 0
      LCPDPL = 0
C
C     ****** /MODDMP/ ********
C
      IFLG(1) = 1
      IFLG(2) = 2
      IFLG(3) = 0
      IFLG(4) = 0
      IFLG(5) = 0
      IFLG(6) = 0
      DO 30 I = 1,26
   30 NMPT(I) = NAMOPT(I)
C
      RETURN
      END

      SUBROUTINE FAILRS (FTHR,ULTSTN,STRESL,FINDEX)
C
C     THIS ROUTINE COMPUTES THE FAILURE INDEX OF A LAYER IN A LAMINATED
C     COMPOSITE ELEMENT USING ONE OF THE FOLLOWING FIVE FAILURE THEORIES
C     CURRENTLY AVAILABLE
C        1.   HILL
C        2.   HOFFMAN
C        3.   TSAI-WU
C        4.   MAX STRESS
C        5.   MAX STRAIN
C
C
C     DEFINITIONS
C
C     XT = ULTIMATE UNIAXIAL TENSILE STRENGTH IN THE FIBER DIRECTION
C     XC = ULTIMATE UNIAXIAL COMPRESSIVE STRENGTH IN THE FIBER DIRECTION
C     YT = ULTIMATE UNIAXIAL TENSILE STRENGTH PERPENDICULAR TO THE FIBER
C          DIRECTION
C     YC = ULTIMATE UNIAXIAL COMPRESSIVE STRENGTH PERPENDICULAR TO THE
C          FIBER DIRECTION
C     S  = ULTIMATE PLANAR SHEAR STRENGTH UNDER PURE SHEAR LOADING
C
C     SIMILARILY FOR THE ULTIMATE STRAINS
C
C
      INTEGER FTHR
      REAL    ULTSTN(6),STRESL(3)
C
C
C     CHECK FOR ZERO STRENGTH VALUES
C
      DO 50 I = 1,5
   50 IF (ULTSTN(I) .EQ. 0.0) GO TO 700
C
C     ULTIMATE STRENGTH VALUES
C
      XT   = ULTSTN(1)
      XC   = ULTSTN(2)
      YT   = ULTSTN(3)
      YC   = ULTSTN(4)
      S    = ULTSTN(5)
      F12  = ULTSTN(6)
C
C     LAYER STRESSES
C
      SIG1 = STRESL(1)
      SIG2 = STRESL(2)
      TAU12= STRESL(3)
C
C     LAYER STRAINS
C
      EPS1 = STRESL(1)
      EPS2 = STRESL(2)
      GAMA = STRESL(3)
C
      GO TO (100,200,300,400,500), FTHR
C
C     HILL FAILURE THEORY
C     -------------------
C
  100 X = XT
      IF (SIG1 .LT. 0.0) X = XC
C
      Y = YT
      IF (SIG2 .LT. 0.0) Y = YC
C
      XX = XT
      IF (SIG1*SIG2 .LT. 0.0) XX = XC
C
      FINDEX = (SIG1*SIG1)/(X*X)
      FINDEX = FINDEX + (SIG2 * SIG2)/(Y * Y)
      FINDEX = FINDEX - (SIG1 * SIG2)/(XX*XX)
      FINDEX = FINDEX + (TAU12*TAU12)/(S * S)
      GO TO 600
C
C
C     HOFFMAN FAILURE THEORY
C     ----------------------
C
  200 FINDEX = (1.0/XT-1.0/XC)*SIG1
      FINDEX = FINDEX + (1.0/YT-1.0/YC)*SIG2
      FINDEX = FINDEX + (SIG1 * SIG1)/(XT*XC)
      FINDEX = FINDEX + (SIG2 * SIG2)/(YT*YC)
      FINDEX = FINDEX + (TAU12*TAU12)/(S * S)
      FINDEX = FINDEX + (SIG1 * SIG2)/(XT*XC)
      GO TO 600
C
C
C     TSAI-WU FAILURE THEORY
C     ----------------------
C
C     CHECK STABILITY CRITERIA FOR THE INTERACTION TERM F12
C
  300 IF (F12 .EQ. 0.0) GO TO 350
C
      CRIT = (1.0/(XT*XC))*(1.0/(YT*YC)) - F12*F12
      IF (CRIT .GT. 0.0) GO TO 350
C
C     IF STABILITY CRITERIA IS VIOLATED THEN SET THE F12 THE INTERACTION
C     TERM TO ZERO
C
      F12 = 0.0
C
C
  350 FINDEX = (1.0/XT-1.0/XC)*SIG1
      FINDEX = FINDEX + (1.0/YT-1.0/YC)*SIG2
      FINDEX = FINDEX + (SIG1 * SIG1)/(XT*XC)
      FINDEX = FINDEX + (SIG2 * SIG2)/(YT*YC)
      FINDEX = FINDEX + (TAU12*TAU12)/(S * S)
      IF (F12 .EQ. 0.0) GO TO 600
      FINDEX = FINDEX + 2.0*F12*SIG1*SIG2
      GO TO 600
C
C
C     MAX STRESS FAILURE THEORY
C     -------------------------
C
  400 FI1 = SIG1/XT
      IF (SIG1 .LT. 0.0) FI1 = ABS(SIG1/XC)
C
      FI2 = SIG2/YT
      IF (SIG2 .LT. 0.0) FI2 = ABS(SIG2/YC)
C
      FI12 = ABS(TAU12)/S
C
      FINDEX = FI1
      IF (FI2  .GT. FINDEX) FINDEX = FI2
      IF (FI12 .GT. FINDEX) FINDEX = FI12
      GO TO 600
C
C
C     MAX STRAIN FAILURE THEORY
C     -------------------------
C
  500 FI1 = EPS1/XT
      IF (EPS1 .LT. 0.0) FI1 = ABS(EPS1/XC)
C
      FI2 = EPS2/YT
      IF (EPS2 .LT. 0.0) FI2 = ABS(EPS2/YC)
C
      FI12 = ABS(GAMA)/S
C
      FINDEX = FI1
      IF (FI2  .GT. FINDEX) FINDEX = FI2
      IF (FI12 .GT. FINDEX) FINDEX = FI12
C
  600 CONTINUE
C
      RETURN
C
C
C     NON-FATAL ERROR
C
  700 FINDEX = 0.0
      RETURN
      END

      SUBROUTINE GTMAT1 (SYM,TT)
C
C     THIS SUBROUTINE PROCESSES TRANSFORMATION MATRICES
C     IT IS CALLED ONLY BY CMSFIL
C
      EXTERNAL        RSHIFT   ,ANDF     ,ORF
      INTEGER         TRN      ,SYM      ,ORF     ,TRAN    ,ECPT1    ,
     1                ANDF     ,CHK1     ,CHK2    ,NAME(2) ,RSHIFT
      DIMENSION       ECPT(4)  ,TID(3,3) ,TT(3,3) ,LIST(32),SYMM(6,6),
     1                SMAT(6,3),PROD(6)  ,TC(3,3) ,TG6(6,6),TG(3,3)  ,
     2                T(6,6)
      DIMENSION       ACPT(1)
      COMMON /GTMATX/ LOC1     ,LEN1     ,TRN     ,TT6(6,6),TC6(6,6)
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE     (ECPT1,ECPT(1))
      EQUIVALENCE     (IFLAG,RFLAG)
      DATA    TID   / 1., 0., 0., 0., 1., 0., 0., 0., 1. /
      DATA    SMAT  /-1., 1., 1., 1.,-1.,-1., 1.,-1., 1.,-1., 1.,-1.,
     1                1., 1.,-1.,-1.,-1., 1.  /
      DATA    NAME  / 4HGTMT, 4H1Z            /
C
      IKIND = 0
      DO 10 I = 1,6
      DO 10 J = 1,6
      TT6(I,J) = 0.0
   10 CONTINUE
      IF (TRN.EQ.0 .AND. SYM.EQ.0) GO TO 170
      IF (LOC1.EQ.0 .OR. TRN.EQ.0) GO TO 30
      CALL PRETRS (Z(LOC1),LEN1)
      IKIND = ORF(IKIND,1)
      DO 20 I = 2,4
      ECPT(I) = 0.0
   20 CONTINUE
      ECPT1 = TRN
      CALL TRANSS (ECPT,TT)
      GO TO 50
   30 DO 40 I = 1,3
      DO 40 J = 1,3
      TT(I,J) = TID(I,J)
   40 CONTINUE
   50 DO 60 I = 1,3
      DO 60 J = 1,3
      TT6(I  ,J  ) = TT(I,J)
      TT6(I+3,J+3) = TT(I,J)
   60 CONTINUE
      DO 70 I = 1,6
      DO 70 J = 1,6
      SYMM(I,J) = 0.0
   70 CONTINUE
      IF (SYM .EQ. 0) GO TO 120
      IKIND = ORF(IKIND,1)
      CALL DECODE (SYM,LIST,NDIR)
      DO 80 I = 1,6
      PROD(I) = 1.0
   80 CONTINUE
      DO 100 I = 1,NDIR
      IDIR = LIST(I) + 1
      IDIR = 4 - IDIR
      DO 90 J = 1,6
      PROD(J) = PROD(J)*SMAT(J,IDIR)
   90 CONTINUE
  100 CONTINUE
      DO 110 I = 1,6
      SYMM(I,I) = PROD(I)
  110 CONTINUE
      GO TO 140
  120 DO 130 I = 1,6
      SYMM(I,I) = 1.0
  130 CONTINUE
  140 CALL GMMATS (TT6,6,6,0, SYMM,6,6,0, T)
      DO 150 I = 1,6
      DO 150 J = 1,6
      TT6(I,J) = T(I,J)
  150 CONTINUE
      DO 160 I = 1,3
      DO 160 J = 1,3
      TT(I,J) = TT6(I,J)
  160 CONTINUE
      ISAV = IKIND
      RETURN
C
  170 DO 180 I = 1,6
      TT6(I,I) = 1.0
  180 CONTINUE
      DO 190 I = 1,3
      DO 190 J = 1,3
      TT(I,J) = TID(I,J)
  190 CONTINUE
      ISAV = IKIND
      CHK1 = 13579
      RETURN
C
C
      ENTRY GTMAT2 (LOC2,LEN2,ACPT,TC)
C     ================================
C
      IKIND = ISAV
      DO 200 I = 1,6
      DO 200 J = 1,6
      TC6(I,J) = 0.0
  200 CONTINUE
      RFLAG = ACPT(1)
      IF (LOC2.EQ.0 .OR. IFLAG.EQ.0) GO TO 210
      CALL PRETRS (Z(LOC2),LEN2)
      CALL TRANSS (ACPT,TC)
      IKIND = ORF(IKIND,2)
      GO TO 230
  210 DO 220 I = 1,3
      DO 220 J = 1,3
      TC(I,J) = TID(I,J)
  220 CONTINUE
  230 DO 240 I = 1,3
      DO 240 J = 1,3
      TC6(I  ,J  ) = TC(I,J)
      TC6(I+3,J+3) = TC(I,J)
  240 CONTINUE
      CHK2 = 24680
      RETURN
C
C
      ENTRY GTMAT3 (TRAN,TG,TG6,IHELP)
C     ================================
C
      IF (CHK1.NE.13579 .AND. CHK2.NE.24680) CALL MESAGE (-37,0,NAME)
      DO 300 I = 1,6
      DO 300 J = 1,6
      TG6(I,J) = 0.0
  300 CONTINUE
      IF (TRAN) 340,330,310
  310 CALL PRETRS (Z(LOC1),LEN1)
      DO 320 I = 2,4
      ECPT(I) = 0.0
  320 CONTINUE
      ECPT1 = TRAN
      IKIND = ORF(IKIND,8)
      IF (TRAN .NE. TRN) IKIND = ORF(IKIND,16)
      CALL TRANSS (ECPT,TG)
      IKIND = ORF(IKIND,4)
      GO TO 370
  330 IKIND = ORF(IKIND,4)
  340 DO 350 I = 1,3
      DO 350 J = 1,3
      TG(I,J) = TID(I,J)
  350 CONTINUE
      IF (ANDF(RSHIFT(IKIND,1),1).NE.1 .OR. TRAN.NE.-1) GO TO 360
      CALL GMMATS (TT6,6,6,0, TC6,6,6,0, TG6)
      IHELP = IKIND
      RETURN
C
  360 CONTINUE
  370 DO 380 I = 1,3
      DO 380 J = 1,3
      TG6(I  ,J  ) = TG(I,J)
      TG6(I+3,J+3) = TG(I,J)
  380 CONTINUE
      IHELP = IKIND
      RETURN
      END

      SUBROUTINE SETFND(*,SET,LSET,ID,NEXT)
C*****
C  FINDS AN ID IN A SORTED SET LIST WHICH MAY HAVE THE NASTRAN THROUGH
C  NOTATION.  IE.  6,-18 IMPLIES 6 THRU 18.
C
C  -SET- IS THE LIST OF IDS.
C  -LSET- IS THE LENGTH OF THE LIST IN -SET-.
C  -ID- IS THE ID BEING LOOKED FOR IN THE LIST -SET-.
C  -NEXT- IS A RELATIVE INDEX INTO THE LIST -SET-.  IT SHOULD BE SET
C  TO 1 ON THE FIRST CALL TO THIS ROUTINE FOR A GIVEN LIST AND THEN
C  RETURNED ON FUTURE CALLS.
C
C  THIS ROUTINE MOVES FORWARD ONLY UNTIL AN ID IN THE LIST IS GREATER
C  THAN THE ID BEING ASKED FOR.    -NEXT-  IF NOT RESET TO 1 WILL ALLOW
C  THE ROUTINE TO SEARCH ONLY FROM WHERE LAST SEARCH LEFT OFF.
C
C  THE NON-STANDARD RETURN IS TAKEN IN THE EVENT THE ID IS NOT IN THE
C  LIST.  A NORMAL RETURN IS TAKEN IF THE ID IS IN THE LIST.
C
C  -NEXT- SHOULD BE SET TO 1 ON THE FIRST CALL TO THIS ROUTINE OR WHEN
C  AN ID TO BE LOOKED FOR IS SMALLER THAN AN ID PREVIOUSLY LOOKED FOR.
C
C  IF IDS TO BE LOOKED FOR ARE NOT IN SORT AND THE SET LIST IS IN SORT
C  WITHOUT THE NASTRAN THROUGH NOTATION, THEN THE NASTRAN BINARY SEARCH
C  ROUTINE -BISRCH- SHOULD BE USED.
C
C  IT IS OK TO CALL THIS ROUTINE WITH MORE THAN ONE OF THE SAME IDS
C  WITHOUT RESETTING -NEXT-.
C*****
      INTEGER SET(LSET)
C
   10 ID1 = SET(NEXT)
   20 IF( NEXT - LSET ) 30,80,100
C
C     STILL POSITIONED WITHIN THE SET LIST.
C
   30 IF( ID - ID1 ) 100,110,40
C
C     CHECK FOR THRU CASE
C
   40 ID1 = SET(NEXT+1)
      IF( ID1 ) 50,70,70
C
C     YES POSITIONED IN A THRU CASE
C
   50 IF( ID + ID1 ) 110,110,60
C
C     ID BEING LOOKED FOR IS BEYOND THIS THRU CASE.
C
   60 NEXT = NEXT + 2
      GO TO 10
C
C     NOT IN A THRU CASE
C
   70 NEXT = NEXT + 1
      GO TO 20
C
C     AT THE LAST ID IN THE LIST
C
   80 IF( ID - ID1 ) 100,110,90
   90 NEXT = NEXT + 1
  100 RETURN 1
  110 RETURN
      END

      SUBROUTINE XRGSST (NEWSOL)
C
C     PURPOSE - XRGSST PROCESSES SUBSTRUCTURE CONTROLS CARDS IN
C               A RIGID FORMAT (I.E., THE ****PHS- CARDS)
C
C     AUTHOR  - RPK CORPORATION; DECEMBER, 1983
C
C     INPUT
C       ARGUMENTS
C           NEWSOL     SOLUTION NUMBER
C       OTHER
C         /SYSTEM/
C           OPTAPE     UNIT NUMBER CONTAINING THE PRINT FILE
C         /XRGDXX/
C           ICHAR      CONTAINS THE CARD IMAGE IN 80A1 FORMAT
C           IDMAP      CURRENT DMAP SEQUENCE NUMBER
C           IPHASE     PHASE NUMBER
C           RECORD     CARD IMAGE IN 20A4 FORMAT
C
C     OUTPUT
C         /XRGDXX/
C           ICOL       COLUMN NUMBER LAST PROCESSED
C           IERROR     ERROR FLAG - NON-ZERO IF AN ERROR OCCURRED
C
C     LOCAL VARIABLES
C         BEGIN        CONTAINS THE VALUE 1HB
C         BLANK        CONTAINS THE VALUE 1H
C         DELETE       CONTAINS THE VALUE 1HD
C         EIGHT        CONTAINS THE VALUE 1H8
C         END          CONTAINS THE VALUE 1HE
C         FIVE         CONTAINS THE VALUE 1H5
C         ICFLAG       FLAG TO DISTINGUISH WHICH COMMON BLOCK IS
C                      BEING PROCESSED
C                      =1, /PHAS11/ ; =2, /PHAS25/ ; =3, /PHAS28/
C                      =4, /PHAS31/ ; =5, /PHAS37/
C         IFLAG        FLAG FOR THE KIND OF COMMAND BEING PROCESSED
C                      =1, FOR INSERT; =2, FOR DELETE;
C                      =3, FOR DELETE BEGIN; =4 FOR DELETE END
C         IMAP         2 WORD ARRAY FOR DMAP NUMBERS
C         IND11        INDEX FOR COMMON /PHAS11/
C         IND25        INDEX FOR COMMON /PHAS25/
C         IND28        INDEX FOR COMMON /PHAS28/
C         IND31        INDEX FOR COMMON /PHAS31/
C         IND37        INDEX FOR COMMON /PHAS37/
C         LFLAG        ARRAY USED FOR THE LAST FLAG (I.E., IFLAG)
C                      THAT WAS APPLIED TO A GIVEN COMMON - THIS
C                      IS USED TO CHECK FOR MATCHING 'DB' AND 'DE'
C                      SUBCOMMANDS
C         NMAP         NUMBER OF DMAP NUMBERS IN THE ARRAY IMAP
C         ONE          CONTAINS THE VALUE 1H1
C         SEVEN        CONTAINS THE VALUE 1H7
C
C     FUNCTIONS
C       XRGSST PROCESSES SUBSTRUCTURE CONTROL COMMANDS WITHIN THE
C       RIGID FORMAT.  THE COMMANDS ARE OF THE FOLLOWING FORMAT;
C       ****PHS- I=   (OR INSTEAD OF I=; D=, DB= OR DE= ) WHERE
C       THE '-' OF PHS IS THE PHASE NUMBER AND = REFERS TO THE
C       APPROPIATE ASCM== SUBROUTINE.  FOR THE I= SUBCOMMAND,
C       TWO NUMBERS ( N AND 0 ) ARE ADDED TO THE APPROPIATE
C       COMMON.  FOR THE D= SUBCOMMAND, TWO NUMBERS ( N1 AND N1 )
C       ARE ADDED TO THE APPROPIATE COMMON.  FOR THE DB=
C       SUBCOMMAND, ONE NUMBER IS ADDED TO THE COMMON AND
C       FOR THE DE= SUBCOMMAND, ONE NUMBER IS ADDED TO THE COMMON.
C       THE NUMBER THAT IS ADDED TO THE COMMONS
C       IS THE CURRENT DMAP SEQUENCE NUMBER AS FOUND IN THE
C       VARIABLE IDMAP.
C       THE I= COMMAND CORRESPONDS TO A DMAP ALTER INSERT
C       OF THE FORM ALTER N,0.  THE D= SUBCOMMAND CORRESPONDS
C       TO THE DMAP DELETE COMMAND  ALTER N1,N1.  THE DB=
C       SUBCOMMAND GIVES THE FIRST OF A RANGE OF DMAP NUMBERS
C       STATEMENTS TO BE DELETED AND THE DE= GIVES THE LAST
C       VALUE OF THE RANGE OF DMAP STATEMENTS TO BE DELETED.
C       THE COMMONS ARE NAMED PHAS== WHERE THE FIRST = REFERS
C       TO THE PHASE NUMBER AND THE SECOND = REFERS TO THE
C       APPROPIATE ASCM== SUBROUTINE.
C
C     SUBROUTINES CALLED - XDCODE
C
C     CALLING SUBROUTINES - XRGDFM
C
C     ERRORS
C       ERROR MESSAGES 8031,8032,8033,8035 ARE ISSUED
C
      INTEGER         RECORD,DELETE,BLANK,BEGIN,END,ICFLAG,OPTAPE,
     1                LFLAG(5),IMAP(2),ONE,FIVE,SEVEN,EIGHT
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /XRGDXX/ IRESTR,NSUBST,IPHASE,ICOL,NUMBER,ITYPE,ISTATE,
     1                IERROR,NUM(2),IND,NUMENT,RECORD(20),ICHAR(80),
     2                LIMIT(2),ICOUNT,IDMAP,ISCR,NAME(2),MEMBER(2),
     3                IGNORE
      COMMON /PHAS11/ IPAS11( 8)
      COMMON /PHAS25/ IPAS25(14)
      COMMON /PHAS28/ IPAS28(14)
      COMMON /PHAS31/ IPAS31( 2)
      COMMON /PHAS37/ IPAS37( 6)
      COMMON /SYSTEM/ ISYSBF,OPTAPE,DUM(98)
      DATA    BLANK / 1H  /, DELETE/ 1HD /, BEGIN / 1HB /
      DATA    END   / 1HE /, LFLAG / 5*0 /
      DATA    ONE   / 1H1 /, FIVE  / 1H5 /, SEVEN / 1H7 /, EIGHT / 1H8 /
      DATA    IND11 / 0   /, IND25 / 0   /, IND28 / 0   /, IND31 / 0   /
      DATA    IND37 / 0   /, INSERT/ 1HI /
C
      CALL XDCODE
      ICOL  = 9
 10   IF (ICHAR(ICOL) .EQ. BLANK ) GO TO 50
      IF (ICHAR(ICOL) .NE. INSERT) GO TO 20
      IFLAG = 1
      NMAP  = 2
      IMAP(1) = IDMAP
      IMAP(2) = 0
      GO TO 100
 20   IF (ICHAR(ICOL) .NE. DELETE) GO TO 710
      ICOL  = ICOL + 1
      IF (ICHAR(ICOL) .EQ. BEGIN) GO TO 30
      IF (ICHAR(ICOL) .EQ. END  ) GO TO 40
      IFLAG = 2
      NMAP  = 2
      IMAP(1) = IDMAP
      IMAP(2) = IDMAP
      GO TO 110
 30   IFLAG = 3
      NMAP  = 1
      IMAP(1) = IDMAP
      GO TO 100
 40   IFLAG = 4
      NMAP  = 1
      IMAP(1) = IDMAP
      GO TO 100
 50   IF (ICOL .GE. 80) GO TO 800
      ICOL  = ICOL + 1
      GO TO 10
 100  ICOL  = ICOL + 1
 110  IF (IPHASE .NE. 1) GO TO 120
      IF (ICHAR(ICOL) .NE. ONE) GO TO 710
      ICFLAG = 1
      GO TO 200
 120  IF (IPHASE .NE. 2) GO TO 140
      IF (ICHAR(ICOL) .NE. FIVE) GO TO 130
      ICFLAG = 2
      GO TO 200
 130  IF (ICHAR(ICOL) .NE. EIGHT) GO TO 710
      ICFLAG = 3
      GO TO 200
 140  IF (ICHAR(ICOL) .NE. ONE) GO TO 150
      ICFLAG = 4
      GO TO 200
 150  IF (ICHAR(ICOL) .NE. SEVEN) GO TO 710
      ICFLAG = 5
 200  IF (IFLAG.EQ.4 .AND. LFLAG(ICFLAG).NE.3) GO TO 730
      IF (IFLAG.EQ.3 .AND. LFLAG(ICFLAG).EQ.3) GO TO 740
      IF (IFLAG.LE.2 .AND. LFLAG(ICFLAG).EQ.3) GO TO 740
      LFLAG(ICFLAG) = IFLAG
      ICOL = ICOL + 1
      GO TO (210,220,230,240,250), ICFLAG
 210  IF (IND11+NMAP .GT. 8) GO TO 720
      DO 215 K = 1,NMAP
      IND11 = IND11 + 1
      IPAS11(IND11) = IMAP(K)
 215  CONTINUE
      GO TO 800
 220  IF (IND25+NMAP .GT. 14) GO TO 720
      DO 225 K = 1,NMAP
      IND25 = IND25 + 1
      IPAS25(IND25) = IMAP(K)
 225  CONTINUE
      GO TO 800
 230  IF (IND28+NMAP .GT. 14) GO TO 720
      DO 235 K = 1,NMAP
      IND28 = IND28 + 1
      IPAS28(IND28) = IMAP(K)
 235  CONTINUE
      GO TO 800
 240  IF (IND31+NMAP .GT. 2) GO TO 720
      DO 245 K = 1,NMAP
      IND31 = IND31 + 1
      IPAS31(IND31) = IMAP(K)
 245  CONTINUE
      GO TO 800
 250  IF (IND37+NMAP .GT. 6) GO TO 720
      DO 255 K = 1,NMAP
      IND37 = IND37 + 1
      IPAS37(IND37) = IMAP(K)
 255  CONTINUE
      GO TO 800
C
C     ERRORS
C
 710  J = 0
      K = 1
      WRITE  (OPTAPE,715) UFM,ICOL,RECORD,J,(I,I=1,8),K,(J,I=1,8)
 715  FORMAT (A23,' 8031, INVALID PARAMETER NEAR COLUMN ',I3,
     1       ' IN THE FOLLOWING CARD', //20X,20A4, /,(20X,I1,I9,7I10))
      IERROR = 1
      GO TO 770
 720  WRITE  (OPTAPE,725) UFM,IPHASE,RECORD
 725  FORMAT (A23,' 8032, ',19H' TOO MANY '****PHS,I1, 9H' ENTRIES,
     1       ' ERROR OCCURRED ON CARD', //20X,20A4)
      GO TO 770
 730  WRITE  (OPTAPE,735) UFM,RECORD
 735  FORMAT (A23,' 8033, ',34H A 'DE' ENTRY HAS NO MATCHING 'DB',
     1       ' ENTRY - ERROR ON CARD', //20X,20A4)
      GO TO 770
 740  WRITE  (OPTAPE,745) UFM,RECORD
 745  FORMAT (A23,' 8035, ',
     1        41H ATTEMP TO NEST 'DB'S OR NO MATCHING 'DE',
     2        ' - ERROR OCCURRED ON THE FOLLOWING CARD', /20X,20A4)
 770  IERROR = 1
 800  RETURN
      END

      SUBROUTINE DCONE
C
C     DIFFERENTIAL STIFFNESS FOR THE CONICAL SHELL. FMMS-68
C
C     CALLS FROM DCONE ARE MADE TO
C           MESAGE
C           MAT
C           INVERD
C           GMMATD
C           DS1B
C
C     ECPT( 1) = ELEMENT ID                                INTEGER
C     ECPT( 2) = SIL PT A                                  INTEGER
C     ECPT( 3) = SIL PT B                                  INTEGER
C     ECPT( 4) = MATID 1                                   INTEGER
C     ECPT( 5) = TM  (MEMBRANE THICK)                      REAL
C     ECPT( 6) = MATID 2                                   INTEGER
C     ECPT( 7) = I   (MOM.OF INERTIA)                      REAL
C     ECPT( 8) = MATID 3                                   INTEGER
C     ECPT( 9) = TS  (SHEAR THICKNESS)                     REAL
C     ECPT(10) = NON-STRUCTURAL-MASS                       REAL
C     ECPT(11) = Z1                                        REAL
C     ECPT(12) = Z2                                        REAL
C     ECPT(13) = PHI  1                                    REAL
C     ECPT(14) = PHI  2                                    REAL
C     ECPT(15) = PHI  3                                    REAL
C     ECPT(16) = PHI  4                                    REAL
C     ECPT(17) = PHI  5                                    REAL
C     ECPT(18) = PHI  6                                    REAL
C     ECPT(19) = PHI  7                                    REAL
C     ECPT(20) = PHI  8                                    REAL
C     ECPT(21) = PHI  9                                    REAL
C     ECPT(22) = PHI 10                                    REAL
C     ECPT(23) = PHI 11                                    REAL
C     ECPT(24) = PHI 12                                    REAL
C     ECPT(25) = PHI 13                                    REAL
C     ECPT(26) = PHI 14                                    REAL
C     ECPT(27) = COORD. SYS. ID PT.1                       INTEGER
C     ECPT(28) = RADIUS PT. 1                              REAL
C     ECPT(29) = DISTANCE TO PT.1                          REAL
C     ECPT(30) = NULL                                      REAL
C     ECPT(31) = COORD. SYS. ID PT.2                       INTEGER
C     ECPT(32) = RADIUS PT 2                               REAL
C     ECPT(33) = DISTANCE TO PT. 2                         REAL
C     ECPT(34) = NULL                                      REAL
C     ECPT(35) = ELEMENT TEMPERATURE                       REAL
C     ECPT(36) = ELEMENT DEFORMATION                       REAL
C     ECPT(37) = ELEMENT LOADING TEMPERATURE - GRID PT A   REAL
C     ECPT(38) = ELEMENT LOADING TEMPERATURE - GRID PT B   REAL
C     ECPT(39) = DISPLACEMENT COMPONENTS AT GRID POINT A   REAL
C     ECPT(40) =                  ...                      REAL
C     ECPT(41) =                  ...                      REAL
C     ECPT(42) =                  ...                      REAL
C     ECPT(43) =                  ...                      REAL
C     ECPT(44) =                  ...                      REAL
C     ECPT(45) = DISPLACEMENT COMPONENTS AT GRID POINT B   REAL
C     ECPT(46) =                  ...                      REAL
C     ECPT(47) =                  ...                      REAL
C     ECPT(48) =                  ...                      REAL
C     ECPT(49) =                  ...                      REAL
C     ECPT(50) =                  ...                      REAL
C
      INTEGER          NECPT(100) ,NERROR(2) ,NA(10)
      DOUBLE PRECISION INT(10,4)  ,HUQ       ,U(10)     ,KQD       ,
     1                 A(5,3)     ,HYQ(10)   ,Q(8)      ,KIJ       ,
     2                 B(7,3)     ,EHT       ,FAC(10)   ,C(3,3)    ,
     3                 RA         ,E11       ,TEMP      ,ONE       ,
     4                 RB         ,E12       ,TEMP1     ,OPI       ,
     5                 ZA         ,E22       ,TEMP2     ,N2D33     ,
     6                 ZB         ,E33       ,TEMP3     ,SP2D22    ,
     7                 RASQ       ,D11       ,TEMP4     ,SP2D4     ,
     8                 RBSQ       ,D12       ,TEMP5     ,OQ        ,
     9                 PI         ,D22       ,TEMP6     ,TDIF      ,
     O                 PIOVB      ,D33       ,TEMP7     ,DEPS      ,
     1                 N          ,TS        ,NSPOPI    ,DEPP      ,
     2                 N2         ,TM        ,TWOD33    ,EPS       ,
     3                 SL         ,NSP       ,NOV4      ,EPP       ,
     4                 L2         ,NCP       ,NSPOV4    ,TE11      ,
     5                 SP         ,SP2       ,N2OV4     ,TE12      ,
     6                 CP         ,CP2       ,SD22PI    ,TE22      ,
     7                 SUM        ,SIGN      ,GSHEAR    ,TEMP48(48),
     8                 A0         ,A1        ,A2        ,A3
      DOUBLE PRECISION B0         ,B1        ,B2        ,B3        ,
     1                 C0         ,C1        ,D0        ,D1        ,
     2                 DETERM     ,CONSTD
      COMMON /DS1AAA/  NPVT       ,DUMCL(34) ,NOGO
      COMMON /DS1AET/  ECPT(100)
      COMMON /DS1ADP/  HUQ(100)   ,KQD(64)   ,KIJ(36)   ,EHT(96)   ,
     1                 E11        ,E12       ,E22       ,E33
      COMMON /MATIN /  MATID      ,INFLAG    ,ELTEMP    ,STRESS    ,
     1                 SINTH      ,COSTH
      COMMON /MATOUT/  G11        ,G12       ,G13       ,G22       ,
     1                 G23        ,G33       ,RHOY      ,ALPHA1    ,
     2                 ALPHA2     ,ALPH12    ,DUM(10)
      COMMON /CONDAD/  CONSTD(5)
      EQUIVALENCE      (G,G12)               ,(ECPT(1),NECPT(1))   ,
     1                 (ECPT(4),MATID1)      ,(ECPT(6), MATID2)    ,
     2                 (ECPT(8),MATID3)      ,(CONSTD(1),   PI)
      DATA    NA    /  6*1, 2*2, 2*4/
      DATA    FAC   /  1.0D0, 1.0D0, 2.0D0, 6.0D0, 24.0D0, 120.0D0,
     1                 720.0D0, 5040.0D0, 40320.0D0, 362880.0D0   /
      DATA    ONE   /  1.0D0  /
C
C
C     CALCULATE SHELL ORIENTATION CONSTANTS
C
      SINTH = 0.0
      COSTH = 1.0
      NINT  = NECPT(1)/1000
      N     = NECPT(1) - NINT*1000 - 1
      RA    = ECPT(28)
      ZA    = ECPT(29)
      RB    = ECPT(32)
      ZB    = ECPT(33)
      TEMP1 = RB - RA
      TEMP2 = ZB - ZA
      L2    = TEMP1**2 + TEMP2**2
      SL    = DSQRT(L2)
      IF (SL) 30,20,30
   20 NERROR(1) = NECPT(1)/1000
      NERROR(2) = N + .3D0
      CALL MESAGE (30,39,NERROR(1))
C
C     SET FLAG FOR FATAL ERROR WHILE ALLOWING ERROR MESSAGES TO
C     ACCUMULATE
C
      NOGO = 1
      RETURN
C
   30 SP = TEMP1/SL
      CP = TEMP2/SL
C
C     COMPUTE INTEGRALS I     FOR M = 0,9
C                        MN       N = 0,3
C
C     FOR EVALUATION OF INTEGRALS  A = RA,  B = SP
C
      IF (SP) 60,40,60
C
C     COMPUTE INTEGRAL FOR B = 0
C
C                            1-N
C                      PI  RA     M+1
C               I   = --------- SL    (FOR ALL M,N .GE. 0)
C                M,N    M + 1
C
C
C     M = I - 1    WHERE I IS THE DO LOOP INDEX
C     N = J - 1    WHERE J IS THE DO LOOP INDEX
C     MPLUS1 THUS EQUALS I
C
   40 DO 50 I = 1,10
      NBEGIN  = NA(I)
      DO 50 J = NBEGIN,4
   50 INT(I,J) = (PI*SL**I)/(DBLE(FLOAT(I))*RA**(J-2))
C
      GO TO 100
C
C
C     COMPUTE INTEGRALS FOR (B .NE. 0)
C
C     FIRST M = 0 CASE
C
C                             2-N     2-N
C                      PI ( RB    - RA   )
C               I     =--------------------   (N NOT EQUAL TO 2)
C                0,N       (2-N)  B
C
C
C     FOR N=2   I     = PI * (LOG RB  -  LOG RA) / B
C                0,2             E          E
C
C
   60 RASQ  = RA*RA
      RBSQ  = RB*RB
      PIOVB = PI/SP
C
      INT(1,1) = 0.5D0*PIOVB*(RBSQ - RASQ)
      INT(1,2) = PIOVB*(RB - RA)
      INT(1,3) = PIOVB*DLOG(RB/RA)
      INT(1,4) =-PIOVB*(ONE/RB - ONE/RA)
C
C
C     M = I        WHERE I IS THE DO LOOP INDEX
C     N = J - 1    WHERE J IS THE DO LOOP INDEX
C
C     WE ARE GETTING INTEGRAL(M,N)
C     M = POWER OF S
C     N = POWER OF R
C
C
C     EVALUATING AT R = RB  THEN AT R = RA
C
C                                  K   NPOW
C                  M FAC.      M   (-A) (R)
C     I  = (PI)(-----------)( SUM ------------------------) + (TERM-X)
C      MN               (M+1)   K=0  (M-K)FAC.(K)FAC.(NPOW)
C                    B        (K.NE.M-N+2)                  (K.EQ.M-N+2)
C
C
C     WHERE NPOW = M - N - K + 2
C
C
C                    M-N+2
C                (-A)     LOG(R)
C       TERM-X = --------------------
C               (M-N+2)FAC.(N-2)FAC.
C
C
C     NOTE IN DATA STATEMENT THAT 0 FACTORIAL = FAC(1)
C                                 1 FACTORIAL = FAC(2)
C                                 2 FACTORIAL = FAC(3)    ETC.
C
      DO 90 I = 1,9
      MPLUS1  = I + 1
      NBEGIN  = NA(MPLUS1)
      DO 90 J = NBEGIN,4
      SUM  = 0.0D0
      SIGN =-1.0D0
      NPOW = I - J + 3
      DO 80 KK = 1,MPLUS1
      SIGN = -SIGN
      K    = KK - 1
      IF (K .EQ. NPOW) GO TO 70
      KPOW = NPOW   - K
      IFAC = MPLUS1 - K
      TEMP = KPOW
      SUM  = SUM + SIGN*RA**K*(RB**KPOW - RA**KPOW)/
     1       (FAC(IFAC)*FAC(KK)*TEMP)
      GO TO 80
   70 SUM = SUM + SIGN*RA**NPOW*DLOG(RB/RA)/(FAC(NPOW+1)*FAC(J-2))
   80 CONTINUE
C
      INT(MPLUS1,J) = SUM*PI*FAC(MPLUS1)/SP**MPLUS1
   90 CONTINUE
  100 CONTINUE
C
C     CRANK OUT HUQ MATRIX FOR ZERO HARMONIC
C     FOR EXPLICIT FORMULATION OF HUQ, SEE MS-28, PP.15,16 AND PP.24,25.
C
      DO 105 I = 1,100
  105 HUQ(  I) = 0.0D0
      HUQ(  1) = ONE
      HUQ( 13) = ONE
      HUQ( 25) = ONE
      HUQ( 36) = ONE
      HUQ( 41) = CP/RA
      HUQ( 49) = ONE
      HUQ( 51) = ONE
      HUQ( 52) = SL
      HUQ( 63) = ONE
      HUQ( 64) = SL
      HUQ( 75) = ONE
      HUQ( 76) = SL
      HUQ( 77) = L2
      HUQ( 78) = HUQ(77)*SL
      HUQ( 86) = ONE
      HUQ( 87) = 2.0D0*SL
      HUQ( 88) = 3.0D0*HUQ(77)
      HUQ( 91) = CP/RB
      HUQ( 92) = HUQ(91)*SL
      HUQ( 99) = ONE
      HUQ(100) = SL
C
C     IF TRANSVERSE SHEAR IS ZERO
C
C     OR INERTIA           = 0.0
C     OR SHEAR MODULUS(G)  = 0.0
C     OR MATID2            = 0
C     OR MATID3            = 0
C
C     THEN (HYQ)  = (0).  THEREFORE, USE HUQ MATRIX AS IS
C
      IF (MATID2.EQ.0 .OR. MATID3.EQ.0) GO TO 130
      IF (ECPT(9).EQ.0.0 .OR. ECPT(7).EQ.0.0) GO TO 130
      INFLAG = 1
      MATID  = MATID3
      ELTEMP = ECPT(35)
      CALL MAT (ECPT(1))
      GSHEAR = G
      IF (G .EQ. 0.0) GO TO 130
      INFLAG = 2
      MATID  = MATID2
      ELTEMP = ECPT(35)
      CALL MAT (ECPT(1))
C
C     FORM
C     (D) = I*(G)
C
      D11 = ECPT(7)*G11
      D12 = ECPT(7)*G12
      D22 = ECPT(7)*G22
      D33 = ECPT(7)*G33
C
      TS  = ECPT(9)
C
      DO 110 I = 1,10
  110 HYQ(I) = 0.0D0
      CP2 = CP*CP
      SP2 = SP*SP
      N2  = N*N
      OPI = ONE/PI
      SD22PI = SP2*D22*OPI
      OQ  = SL*TS*GSHEAR*(RA+RB)*0.5D0 + SD22PI*INT(1,3)
      OQ  = ONE/OQ
C
      HYQ(6) = OQ*INT(1,3)*SD22PI
      HYQ(7) = OQ*2.0D0*(D11 *(RA-RB) + INT(2,3)*SD22PI)
      HYQ(8) = OQ*(-D11*6.0D0*SL*RB   + 3.0D0*INT(3,3)*SD22PI)
C
      DO 120 I = 6,8
      HUQ(I+30) = HUQ(I+30) - HYQ(I)
  120 HUQ(I+80) = HUQ(I+80) - HYQ(I)
C
  130 CONTINUE
C
C     NO NEED TO COMPUTE DETERMINANT SINCE IT IS NOT USED SUBSEQUENTLY.
C
      ISING = -1
      CALL INVERD (10,HUQ(1),10,DUM,0,DETERM,ISING,TEMP48(1))
C
C     CHECK SINGULARITY
C
      IF (ISING .NE. 2) GO TO 140
      CALL MESAGE (30,40,NECPT(1))
C
C     SET FLAG FOR FATAL ERROR WHILE ALLOWING ERROR MESSAGES TO
C     ACCUMULATE
C
      NOGO = 1
      RETURN
C
  140 CONTINUE
C
C     CALCULATE GENERALIZED DISPLACEMENT VECTOR(Q)
C
C                       ***     ***
C                       *  T      *
C                       *(E )(U ) *
C                       *      A  *
C        (Q)  =  (HUQ)  *---------*
C                       *  T      *
C                       *(E )(U ) *
C                       *      B  *
C                       ***     ***
C
C           WHERE
C                                0    1    0    0    0    0
C                          T     SP   0    CP   0    0    0
C                MATRIX  (E )  = CP   0   -SP   0    0    0
C                                0    0    0    0    1    0
C                                0    0    0    SP   0    CP
C
C
      K1 = 0
      K2 = 0
  320 U(K2+1) = DBLE(ECPT(K1+40))
      U(K2+2) = DBLE(ECPT(K1+39))*SP + DBLE(ECPT(K1+41))*CP
      U(K2+3) = DBLE(ECPT(K1+39))*CP - DBLE(ECPT(K1+41))*SP
      U(K2+4) = DBLE(ECPT(K1+43))
      U(K2+5) = DBLE(ECPT(K1+42))*SP + DBLE(ECPT(K1+44))*CP
C
      IF (K1 .NE. 0) GO TO 400
      K1 = 6
      K2 = 5
      GO TO 320
C
  400  CALL GMMATD (HUQ(1),8,10,0,U(1),10,1,0,Q(1))
C
C     CALCULATE STRAIN COEFFICIENTS AND OBTAIN MATERIAL PROPERTY MATRIX
C     (E)
C
      MATID  = MATID1
      INFLAG = 2
      ELTEMP = ECPT(35)
      CALL MAT (ECPT(1))
      E11   = G11
      E12   = G12
      E22   = G22
      E33   = G33
      TDIF  = (DBLE(ECPT(38)) - DBLE(ECPT(37)))/SL
      DEPS  = DBLE(ALPHA1)*TDIF
      DEPP  = DBLE(ALPHA2)*TDIF
      EPS   = DBLE(ALPHA1)*DBLE(ECPT(37))
      EPP   = DBLE(ALPHA2)*DBLE(ECPT(37))
C
C     COMPUTE COEFFICIENTS FOR POWER SERIES OF DIFFERENTIAL STIFF. COEFF
C
      TM    = ECPT(5)
      TEMP1 = SP*Q(3) + CP*Q(5)
      TEMP2 = SP*Q(4) + CP*Q(6)
      TEMP3 = Q(4) - EPS
      TE11  = TM*E11
      TE12  = TM*E12
      TE22  = TM*E22
C
      A0    = TE12*TEMP1
      A1    = TE12*TEMP2
      A2    = TE12*CP*Q(7)
      A3    = TE12*CP*Q(8)
      B0    = TE22*TEMP1
      B1    = TE22*TEMP2
      B2    = TE22*CP*Q(7)
      B3    = TE22*CP*Q(8)
      C0    = TE11*TEMP3 - TE12*EPP
      C1    =-TE11*DEPS  - TE12*DEPP
      D0    = TE12*TEMP3 - TE22*EPP
      D1    =-TE12*DEPS  - TE22*DEPP
C
C     COMPUTE DIFFERENTIAL STIFFNESS COEFFICIENTS
C
      DO 500 I = 1,3
      IP1 = I + 1
      IP2 = I + 2
      IP3 = I + 3
      DO 500 J = I,3
      JP1 = J + 1
      A(I,J) = A0*INT(I  ,JP1) + A1*INT(IP1,JP1) + A2*INT(IP2,JP1)
     1       + A3*INT(IP3,JP1) + C0*INT(I  ,J  ) + C1*INT(IP1,J  )
      B(I,J) = B0*INT(I  ,JP1) + B1*INT(IP1,JP1) + B2*INT(IP2,JP1)
     1       + B3*INT(IP3,JP1) + D0*INT(I  ,J  ) + D1*INT(IP1,J  )
  500 C(I,J) = A(I,J) + B(I,J)
C
      J   = 1
      JP1 = 2
      DO 510 I = 2,5
      IP1 = I + 1
      IP2 = I + 2
      IP3 = I + 3
  510 A(I,J) = A0*INT(I  ,JP1) + A1*INT(IP1,JP1) + A2*INT(IP2,JP1)
     1       + A3*INT(IP3,JP1) + C0*INT(I  ,J  ) + C1*INT(IP1,J  )
C
      J   = 3
      JP1 = 4
      DO 520 I = 4,7
      IP1 = I + 1
      IP2 = I + 2
      IP3 = I + 3
  520 B(I,J) = B0*INT(I  ,JP1) + B1*INT(IP1,JP1) + B2*INT(IP2,JP1)
     1       + B3*INT(IP3,JP1) + D0*INT(I  ,J  ) + D1*INT(IP1,J  )
C
C     COMPUTE KQD
C     FOR EXPLICIT FORMULATION OF KQD, SEE MS-31, PP. 8-11
C     CASE ONE.. HARMONIC NUMBER = ZERO
C
      DO 600 I = 1,64
  600 KQD(I)  = 0.0D0
      SP2D4   = SP2*0.25D0
      KQD( 1) = CP2*B(1,3) + SP2D4*C(1,3)
      KQD( 2) = CP2*B(2,3) + 0.25D0*SP*C(1,2) + SP2D4*C(2,3)
      KQD( 9) = KQD(2)
      KQD(10) = CP2*B(3,3) + (C(1,1) + 2.0D0*SP*C(2,2)
     $        + SP2*C(3,3))*0.25D0
      KQD(46) = A(1,1)
      KQD(47) = A(2,1)*2.0D0
      KQD(48) = A(3,1)*3.0D0
      KQD(54) = KQD(47)
      KQD(55) = A(3,1)*4.0D0
      KQD(56) = A(4,1)*6.0D0
      KQD(62) = KQD(48)
      KQD(63) = KQD(56)
      KQD(64) = A(5,1)*9.0D0
C
C     CHECK HARMONIC NUMBER
C
      IF (N .EQ. 0.0D0) GO TO 800
C
C     CASE TWO.. HARMONIC NUMBER .NE. ZERO
C
      NOV4    = N*0.25D0
      NSPOV4  = NOV4*SP
      NCP     = N*CP
      N2OV4   = NOV4*N
      KQD( 3) = NSPOV4*C(1,3)
      KQD( 4) = NSPOV4*C(2,3)
      KQD( 5) = NCP*B(1,3)
      KQD( 6) = NCP*B(2,3)
      KQD( 7) = NCP*B(3,3)
      KQD( 8) = NCP*B(4,3)
      KQD(11) = NOV4*(C(1,2) + SP*C(2,3))
      KQD(12) = NOV4*(C(2,2) + SP*C(3,3))
      KQD(13) = NCP*B(2,3)
      KQD(14) = NCP*B(3,3)
      KQD(15) = NCP*B(4,3)
      KQD(16) = NCP*B(5,3)
      KQD(17) = KQD( 3)
      KQD(18) = KQD(11)
      KQD(19) = N2OV4*C(1,3)
      KQD(20) = N2OV4*C(2,3)
      KQD(25) = KQD( 4)
      KQD(26) = KQD(12)
      KQD(27) = KQD(20)
      KQD(28) = N2OV4*C(3,3)
      KQD(33) = KQD( 5)
      KQD(34) = KQD(13)
      KQD(37) = N2*B(1,3)
      KQD(38) = N2*B(2,3)
      KQD(39) = N2*B(3,3)
      KQD(40) = N2*B(4,3)
      KQD(41) = KQD( 6)
      KQD(42) = KQD(14)
      KQD(45) = KQD(38)
      KQD(46) = KQD(46) + N2*B(3,3)
      KQD(47) = KQD(47) + N2*B(4,3)
      KQD(48) = KQD(48) + N2*B(5,3)
      KQD(49) = KQD( 7)
      KQD(50) = KQD(15)
      KQD(53) = KQD(39)
      KQD(54) = KQD(47)
      KQD(55) = KQD(55) + N2*B(5,3)
      KQD(56) = KQD(56) + N2*B(6,3)
      KQD(57) = KQD( 8)
      KQD(58) = KQD(16)
      KQD(61) = KQD(40)
      KQD(62) = KQD(48)
      KQD(63) = KQD(56)
      KQD(64) = KQD(64) + N2*B(7,3)
C
C     COMPUTE HUQ FOR NTH HARMONIC
C
      DO 690 I = 1,100
  690 HUQ(  I) = 0.0D0
      HUQ(  1) = ONE
      HUQ( 13) = ONE
      HUQ( 25) = ONE
      HUQ( 36) = ONE
      HUQ( 41) = CP/RA
      HUQ( 45) = N /RA
      HUQ( 49) = ONE
      HUQ( 51) = ONE
      HUQ( 52) = SL
      HUQ( 63) = ONE
      HUQ( 64) = SL
      HUQ( 75) = ONE
      HUQ( 76) = SL
      HUQ( 77) = L2
      HUQ( 78) = HUQ(77)*SL
      HUQ( 86) = ONE
      HUQ( 87) = 2.0D0*SL
      HUQ( 88) = 3.0D0*HUQ(77)
      HUQ( 91) = CP/RB
      HUQ( 92) = HUQ(91)*SL
      HUQ( 95) = N /RB
      HUQ( 96) = HUQ(95)*SL
      HUQ( 97) = HUQ(95)*L2
      HUQ( 98) = HUQ(96)*L2
      HUQ( 99) = ONE
      HUQ(100) = SL
C
C     COMPUTE HYQ
C
      IF (MATID2.EQ.0 .OR. MATID3.EQ.0) GO TO 710
      IF (ECPT(9).EQ.0.0 .OR. ECPT(7).EQ.0.0) GO TO 710
      IF (GSHEAR .EQ. 0.0D0) GO TO 710
C
      N2D33  = N2 *D33
      SP2D22 = SP2*D22
      OQ     = SL*TS*GSHEAR*(RA+RB)*0.5D0 + INT(1,3)*(N2D33+SP2D22)*OPI
      OQ     = ONE/OQ
      NSP    = N*SP
      NCP    = N*CP
      NSPOPI = NSP*OPI
      TWOD33 = 2.0D0*D33
      TEMP1  = D12*(ONE/RB - ONE/RA)
      TEMP2  = NSPOPI*(D22 + D33)
      TEMP3  = N*NSPOPI*(TWOD33 + D22)
      TEMP4  = OQ*0.5D0*N2D33*CP*OPI
      TEMP5  = OPI*(N2*TWOD33  + SP2D22)
      TEMP6  = D12*N2*L2/RB
      TEMP7  = NSPOPI*CP*0.50D0
C
      HYQ( 1) = OQ*(TEMP1*NCP - TEMP7*INT(1,4)*(D33 + 2.0D0*D22))
      HYQ( 2) = OQ*(NCP*SL/RB*D12 - TEMP7*INT(2,4)*(3.0D0*D33 + D22) +
     1          1.5D0*NCP*OPI*INT(1,3)*D33)
      HYQ( 3) = TEMP4*INT(1,4)
      HYQ( 4) = TEMP4*INT(2,4)
      HYQ( 5) = OQ*(TEMP1*N2 - TEMP3*INT(1,4))
      HYQ( 6) = OQ*(D12*N2*SL/RB - TEMP3*INT(2,4) + TEMP5*INT(1,3))
      HYQ( 7) = OQ*(2.0D0*D11*(RA-RB) + TEMP6 + 2.0D0*INT(2,3)*TEMP5
     $        - TEMP3*INT(3,4))
      HYQ( 8) = OQ*(-D11*6.0D0*SL*RB + TEMP6*SL + 3.0D0*INT(3,3)*TEMP5
     $        - TEMP3*INT(4,4))
      HYQ( 9) =-OQ*TEMP2*INT(1,3)
      HYQ(10) = OQ*(N*SL*(D12 + D33) - TEMP2*INT(2,3))
C
      DO 700 I = 1,10
      HUQ(I+30) = HUQ(I+30) - HYQ(I)
  700 HUQ(I+80) = HUQ(I+80) - HYQ(I)
C
  710 CONTINUE
C
C     AGAIN SET ISING TO -1
C
      ISING = -1
      CALL INVERD (10,HUQ(1),10,DUM,0,DETERM,ISING,TEMP48(1))
      IF (ISING .NE. 2) GO TO 720
      CALL MESAGE (30,40,NECPT(1))
C
C     SET FLAG FOR FATAL ERROR WHILE ALLOWING ERROR MESSAGES TO
C     ACCUMULATE
C
      NOGO = 1
      RETURN
C
  720 CONTINUE
C
C     COMPLETE SOLUTION BY TRANSFORMING KQD TO GLOBAL COORDINATES
C
C                     T            T
C       (K  ) = (E)(H  )(KQD)(H)(E )     FOR I = PIVOT POINT
C         IJ         I         J             J = A,B
C
C     FIRST OBTAIN PRODUCTS
C                       T
C        EHAT  =  (E)(H  )      AND STORE AT EHT(1) . . . EHT(48)
C                      A
C
C                       T
C        EHBT  =  (E)(H  )      AND STORE AT EHT(49). . . EHT(96)
C                      B
C
C              0    CP   SP   0    0
C              1    0    0    0    0
C
C              0    CP  -SP   0    0
C
C        MATRIX E =
C              0    0    0    0    SP
C
C              0    0    0    1    0
C
C              0    0    0    0    CP
C
  800 INC1 = 0
      INC2 = 0
  810 DO 820 I = 1,8
      KROW = I + INC1
      NCOL = (I-1)*10 + INC2
      EHT(KROW   ) = SP*HUQ(NCOL+2) + CP*HUQ(NCOL+3)
      EHT(KROW+ 8) =    HUQ(NCOL+1)
      EHT(KROW+16) = CP*HUQ(NCOL+2) - SP*HUQ(NCOL+3)
      EHT(KROW+24) = SP*HUQ(NCOL+5)
      EHT(KROW+32) =    HUQ(NCOL+4)
  820 EHT(KROW+40) = CP*HUQ(NCOL+5)
      IF(INC1 .GT. 0) GO TO 830
      INC1 = 48
      INC2 = 5
      GO TO 810
C
C     CHECK FOR PIVOT POINT NUMBER
C
  830 DO 840 I = 1,2
      IF (NPVT .EQ. NECPT(I+1)) GO TO 850
  840 CONTINUE
C
C     FALL THRU LOOP IMPLIES NO PIVOT POINT NUMBER
C
      CALL MESAGE (-30,34,ECPT(1))
C
  850 NPIVOT = I
      CALL GMMATD ( EHT(48*NPIVOT-47),6,8,0, KQD(1),8,8,0, TEMP48(1) )
C
C     IF N = 0 DOUBLE RESULT
C
      IF (N .NE. 0.0D0) GO TO 870
      DO 860 I = 1,48
  860 TEMP48(I) = 2.0D0*TEMP48(I)
C
  870 DO 880 J = 1,2
      CALL GMMATD (TEMP48(1),6,8,0,EHT(48*J-47),6,8,1,KIJ(1))
  880 CALL DS1B (KIJ(1),NECPT(J+1))
C
      RETURN
      END

      SUBROUTINE VDRB (INFIL,OUTFL,IREQQ)
C
C     VDRB PROCESSES VECTORS IN THE ANALYSIS OR MODAL SET. IN
C     ACCORDANCE WITH OUTPUT REQUESTS IN THE CASE CONTROL DATA BLOCK,
C     THESE VECTORS ARE FORMATTED FOR INPUT TO OFP WHERE ACTUAL OUTPUT
C     WILL OCCUR.
C
      EXTERNAL        ANDF
      INTEGER         APP   ,FORM  ,SORT2 ,OUTPUT,Z     ,SYSBUF,DATE  ,
     1                TIME  ,UD    ,UE    ,TWO   ,QTYPE2,CEI   ,FRQ   ,
     2                TRN   ,OUTFL ,MODAL ,DIRECT,CASECC,EQDYN ,USETD ,
     3                INFIL ,OEIGS ,PP    ,BUF   ,BUF1  ,BUF2  ,BUF3  ,
     4                FILE  ,FLAG  ,SILD  ,CODE  ,GPTYPE,ANDF  ,BRANCH,
     5                SETNO ,FSETNO,WORD  ,RET   ,RETX  ,FORMAT,EOF   ,
     6                VDRCOM,SDR2  ,XSET0 ,XSETNO,DEST  ,AXIF  ,VDRREQ,
     7                OHARMS
      DIMENSION       MCB(7)    ,BUF(50)      ,BUFR(50)     ,MASKS(6) ,
     1                ZZ(1)     ,CEI(2)       ,FRQ(2)       ,TRN(2)   ,
     2                MODAL(2)  ,DIRECT(2)    ,NAM(2)       ,VDRCOM(1)
      COMMON /CONDAS/ CONSTS(5)
      COMMON /BLANK / APP(2),FORM(2),SORT2,OUTPUT,SDR2  ,IMODE
      COMMON /VDRCOM/ VDRCOM,IDISP ,IVEL  ,IACC  ,ISPCF ,ILOADS,ISTR  ,
     1                IELF  ,IADISP,IAVEL ,IAACC ,IPNL  ,ITTL  ,ILSYM ,
     2                IFROUT,IDLOAD,CASECC,EQDYN ,USETD ,INFILE,OEIGS ,
     3                PP    ,XYCDB ,PNL   ,OUTFLE,OPNL1 ,SCR1  ,SCR2  ,
     4                BUF1  ,BUF2  ,BUF3  ,NAM   ,BUF   ,MASKS ,CEI   ,
     5                FRQ   ,TRN   ,DIRECT,XSET0 ,VDRREQ,MODAL
      COMMON /ZZZZZZ/ Z(1)
      COMMON /SYSTEM/ SYSBUF,XX(13),DATE(3),TIME,DUM19(19),AXIF
      COMMON /NAMES / RD    ,RDREW ,WRT   ,WRTREW,CLSREW
      COMMON /BITPOS/ UM    ,UO    ,UR    ,USG   ,USB   ,UL    ,UA    ,
     1                UF    ,US    ,UN    ,UG    ,UE    ,UP    ,UNE   ,
     2                UFE   ,UD
      COMMON /TWO   / TWO(32)
      COMMON /UNPAKX/ QTYPE2,I2    ,J2    ,INCR2
      EQUIVALENCE     (CONSTS(2),TWOPI)   ,(CONSTS(3),RADDEG)  ,
     1                (BUF(1),BUFR(1))    ,(Z(1),ZZ(1))
      DATA    IGPF  , IESE,IREIG   /
     1        167   , 170, 4HREIG  /
C
C     PERFORM GENERAL INITIALIZATION.
C
      M8    = -8
      MSKUD = TWO(UD)
      MSKUE = TWO(UE)
      ILIST = 1
      I2    = 1
      INCR2 = 1
      IREQ  = IREQQ
      IF (FORM(1).NE.MODAL(1) .AND. FORM(1).NE.DIRECT(1)) GO TO 1432
C
C     READ TRAILER ON USETD. SET NO. OF EXTRA POINTS.
C     READ TRAILER ON INFIL. SET PARAMETERS.
C     IF MODAL PROBLEM, NO. OF MODES = NO. OF ROWS IN VECTOR - NO. XTRA
C     PTS.
C
      MCB(1) = USETD
      FILE   = USETD
      CALL RDTRL (MCB)
      IF (MCB(1) .NE. USETD) GO TO 2001
      NBREP  = MCB(3)
      MCB(1) = INFIL
      CALL RDTRL (MCB)
      IF (MCB(1) .NE. INFIL) GO TO 1431
      NVECTS = MCB(2)
      NROWS  = MCB(3)
      IF (FORM(1) .EQ. MODAL(1)) NBRMOD = IMODE + NROWS - NBREP - 1
      IF (MCB(5) .GT. 2) GO TO 1022
      IF (APP(1) .EQ. FRQ(1)) GO TO 1022
C
C     REAL VECTOR.
C
      KTYPE  = 1
      QTYPE2 = 1
      NWDS   = 8
      KTYPEX = 0
      GO TO 1030
C
C     COMPLEX VECTOR.
C
 1022 KTYPE  = 2
      QTYPE2 = 3
      NWDS   = 14
      KTYPEX = 1000
C
C     IF DIRECT PROBLEM OR MODAL PROBLEM WITH EXTRA POINTS,
C     READ 2ND TABLE OF EQDYN INTO CORE. THEN READ USETD INTO CORE.
C
 1030 IF (FORM(1).EQ.MODAL(1) .AND. NBREP.EQ.0) GO TO 1050
      FILE = EQDYN
      CALL GOPEN (EQDYN,Z(BUF1),0)
      CALL FWDREC (*2002,EQDYN)
      CALL READ (*2002,*1031,EQDYN,Z,BUF1,1,NEQD)
      CALL MESAGE (M8,0,NAM)
 1031 CALL CLOSE (EQDYN,CLSREW)
      IUSETD = NEQD + 1
      NCORE  = BUF1 - IUSETD
      FILE   = USETD
      CALL GOPEN (USETD,Z(BUF1),0)
      CALL READ (*2002,*1032,USETD,Z(IUSETD),NCORE,1,FLAG)
      CALL MESAGE (M8,0,NAM)
 1032 CALL CLOSE (USETD,CLSRRW)
      ILIST  = IUSETD
      NEQDYN = NEQD - 1
      KN     = NEQD/2
C
C     BRANCH ON PROBLEM TYPE.
C
      IF (FORM(1) .EQ. MODAL(1)) GO TO 1049
C
C     DIRECT - PROCESS EACH ENTRY IN EQDYN. IF POINT IS NOT IN ANALYSIS
C              SET, REPLACE SILD NO. WITH ZERO. OTHERWISE, REPLACE SILD
C              NO. WITH POSITION IN ANALYSIS SET (I.E. ROW INDEX IN
C              VECTOR) AND CODE INDICATING WHICH COMPONENTS OF POINT ARE
C              IN ANALYSIS SET.
C
      DO 1044 I = 1,NEQDYN,2
      SILD   = Z(I+1)/10
      GPTYPE = Z(I+1) - 10*SILD
      NUSETD = IUSETD + SILD - 1
      K = 0
      M = 1
      IF (GPTYPE .EQ. 1) M = 6
      J = NUSETD
      DO 1041 L = 1,M
      IF (ANDF(Z(J),MSKUD) .NE. 0) K = K + MASKS(L)
 1041 J = J + 1
      IF (K .EQ. 0) GO TO 1043
      L = 1
      M = NUSETD - 1
      IF (M .LT. IUSETD) GO TO 1045
      DO 1042 J = IUSETD,M
      IF (ANDF(Z(J),MSKUD) .NE. 0) L = L + 1
 1042 CONTINUE
 1045 Z(I+1) = GPTYPE + K + 256*L
      GO TO 1044
 1043 Z(I+1) = 0
 1044 CONTINUE
      GO TO 1050
C
C     MODAL - PROCESS EACH ENTRY IN EQDYN. IF POINT IS NOT AN EXTRA
C             POINT, REPLACE SILD NO. WITH ZERO. OTHERWISE, REPLACE SILD
C             NO. WITH POSITION IN MODAL SET (I.E. ROW INDEX IN VECTOR).
C
 1049 DO 1048 I = 1,NEQDYN,2
      SILD   = Z(I+1)/10
      GPTYPE = Z(I+1) - 10*SILD
      IF (GPTYPE .NE. 3) GO TO 1047
      NUSETD = IUSETD + SILD - 1
      IF (ANDF(Z(NUSETD),MSKUE) .EQ. 0) GO TO 1047
      K = NBRMOD - IMODE + 1
      DO 1046 J = IUSETD,NUSETD
      IF (ANDF(Z(J),MSKUE) .NE. 0) K = K + 1
 1046 CONTINUE
      Z(I+1) = 10*K + 3
      GO TO 1048
 1047 Z(I+1) = 0
 1048 CONTINUE
C
C     SET PARAMETER FOR APPROACH. THEN OPEN CASE CONTROL,
C     SKIP HEADER RECORD AND BRANCH ON APPROACH.
C
 1050 BRANCH = 0
      IF (APP(1) .EQ. CEI(1)) BRANCH = 1
      IF (APP(1) .EQ. FRQ(1)) BRANCH = 2
      IF (APP(1) .EQ. TRN(1)) BRANCH = 3
      IF (APP(1) .EQ. IREIG ) BRANCH = 4
      IF (BRANCH .EQ. 0) GO TO 1432
      CALL GOPEN (CASECC,Z(BUF1),0)
      GO TO (1060,1070,1070,1060), BRANCH
C
C     COMPLEX EIGENVALUES - READ LIST OF MODE NOS. AND VALUES INTO CORE.
C
 1060 FILE = OEIGS
      CALL GOPEN (OEIGS,Z(BUF2),0)
      CALL FWDREC (*2002,OEIGS)
      I = ILIST
      M = 8 - KTYPE
 1061 CALL READ (*2002,*1062,OEIGS,BUF,M,0,FLAG)
      Z(I  ) = BUF(1)
      Z(I+1) = BUF(3)
      Z(I+2) = BUF(4)
      I = I + 3
      GO TO 1061
 1062 CALL CLOSE (OEIGS,CLSREW)
      NLIST = I - 3
      ICC   = I
      GO TO 1100
C
C     FREQUENCY OR TRANSIENT RESPONSE - READ LIST INTO CORE.
C
 1070 FILE = PP
      CALL OPEN (*2001,PP,Z(BUF2),RDREW)
      I  = ILIST
      M  = 3
      IX = 1
      IF (APP(1) .EQ. FRQ(1)) IX = 2
 1071 CALL READ (*2002,*1072,PP,BUF,M,0,FLAG)
      Z(I  ) = BUF(M)
      Z(I+1) = 0
      I = I + IX
      M = 1
      GO TO 1071
 1072 CALL CLOSE (PP,CLSREW)
      NLIST = I - IX
      ICC   = I
C
C     OPEN OUTPUT FILE. WROTE HEADER RECORD.
C
 1100 FILE = OUTFL
      CALL OPEN (*1431,OUTFL,Z(BUF2),WRTREW)
      MCB(1) = OUTFL
      CALL FNAME (OUTFL,BUF)
      DO 1101 I = 1,3
 1101 BUF(I+2) = DATE(I)
      BUF(6) = TIME
      BUF(7) = 1
      CALL WRITE (OUTFL,BUF,7,1)
C
C     OPEN INPUT FILE. SKIP HEADER RECORD.
C
      FILE = INFIL
      CALL OPEN (*1430,INFIL,Z(BUF3),RDREW)
      CALL FWDREC (*2002,INFIL)
C
C     SET PARAMETERS TO KEEP CASE CONTROL AND VECTORS IN SYNCH.
C
      EOF    = 0
      JCOUNT = 0
      KCOUNT = 1
      JLIST  = ILIST
      KFRQ   = 0
      KWDS   = 0
      INCORE = 0
C
C     READ A RECORD IN CASE CONTROL.
C
 1130 CALL READ (*1400,*1131,CASECC,Z(ICC+1),BUF3-ICC,1,NCC)
      CALL MESAGE (M8,0,NAM)
 1131 IVEC  = ICC + NCC + 1
      IREQX = ICC + IDISP
      IF (Z(IREQX) .NE. 0) SDR2 = 1
      IREQX = ICC + IVEL
      IF (Z(IREQX) .NE. 0) SDR2 = 1
      IREQX = ICC + IACC
      IF (Z(IREQX) .NE. 0) SDR2 = 1
      IREQX = ICC + ISPCF
      IF (Z(IREQX) .NE. 0) SDR2 = 1
      IREQX = ICC + ILOADS
      IF (Z(IREQX) .NE. 0) SDR2 = 1
      IREQX = ICC + ISTR
      IF (Z(IREQX) .NE. 0) SDR2 = 1
      IREQX = ICC + IELF
      IF (Z(IREQX) .NE. 0) SDR2 = 1
      IREQX = ICC + IGPF
      IF (Z(IREQX) .NE. 0) SDR2 = 1
      IREQX = ICC + IESE
      IF (Z(IREQX) .NE. 0) SDR2 = 1
C
C     SET OUTPUT HARMONICS REQUEST WHICH IS USED IF FLUID ELEMENTS
C     ARE IN PROBLEM.
C
      OHARMS = Z(ICC+137)
      IF (OHARMS.LT.0 .AND. AXIF.NE.0) OHARMS = AXIF
C
C     IN THE ABOVE IF OHARMS = -1  THEN ALL IS IMPLIED. IF OHARMS = 0
C     THEN NONE IS IMPLIED AND IF OHARMS IS POSITIVE THEN THAT VALUE
C     MINUS ONE IS IMPLIED.
C
      IF (AXIF   .EQ. 0) GO TO 1140
      IF (OHARMS .EQ. 0) GO TO 1140
      OHARMS =   OHARMS - 1
      OHARMS = 2*OHARMS + 3
C
C     DETERMINE IF OUTPUT REQUEST IS PRESENT. IF NOT, TEST FOR RECORD
C     SKIP ON INFIL, THEN GO TO END OF REQUEST. IF SO, SET POINTERS
C     TO SET DEFINING REQUEST.
C
 1140 IREQX = ICC +IREQ
      SETNO = Z(IREQX  )
      DEST  = Z(IREQX+1)
      XSETNO = -1
      IF (SETNO) 1150,1141,1143
 1141 IF (APP(1) .NE. FRQ(1)) GO TO 1142
      IF (KCOUNT .NE.      1) GO TO 1350
      GO TO 1150
 1142 CALL FWDREC (*2002,INFIL)
      JCOUNT = JCOUNT + 1
      GO TO 1311
 1143 IX = ICC + ILSYM
      ISETNO = IX + Z(IX) + 1
 1144 ISET = ISETNO + 2
      NSET = Z(ISETNO+1) + ISET - 1
      IF (Z(ISETNO) .EQ. SETNO) GO TO 1145
      ISETNO = NSET + 1
      IF (ISETNO .LT. IVEC) GO TO 1144
      GO TO 1150
C
C     IF REQUIRED, LOCATE PRINT/PUNCH SUBSET.
C
 1145 IF (SETNO .LT. XSET0) GO TO 1150
      XSETNO = DEST/10
      DEST   = DEST - 10*XSETNO
      IF (XSETNO .EQ. 0) GO TO 1150
      IXSETN = IX + Z(IX) + 1
 1146 IXSET  = IXSETN + 2
      NXSET  = Z(IXSETN+1) + IXSET - 1
      IF (Z(IXSETN) .EQ. XSETNO) GO TO 1150
      IXSETN = NXSET + 1
      IF (IXSETN .LT. IVEC) GO TO 1146
      XSETNO = -1
      SETNO  = -1
C
C     UNPACK VECTOR INTO CORE (UNLESS VECTOR IS ALREADY IN CORE).
C
 1150 IF (INCORE .NE. 0) GO TO 1160
      IVECN = IVEC + KTYPE*NROWS - 1
      IF (IVECN .GE. BUF3) CALL MESAGE (M8,0,NAM)
      J2 = NROWS
      CALL UNPACK (*1151,INFIL,Z(IVEC))
      GO TO 1153
 1151 DO 1152 I = IVEC,IVECN
 1152 ZZ(I)  = 0.
 1153 JCOUNT = JCOUNT + 1
C
C     TEST FOR CONTINUATION.
C
 1160 IF (APP(1).EQ.FRQ(1) .AND. SETNO.EQ.0) GO TO 1350
C
C     PREPARE TO WRITE ID RECORD ON OUTPUT FILE.
C
      GO TO (1190,1200,1220,1190), BRANCH
C
C     COMPLEX EIGENVALUES.
C
 1190 BUF(2) = 1014
      BUF(5) = Z(JLIST  )
      BUF(6) = Z(JLIST+1)
      BUF(7) = Z(JLIST+2)
      BUF(8) = 0
      GO TO 1250
C
C     FREQUENCY RESPONSE.
C
 1200 IX = ICC + IDLOAD
      BUF(8) = Z(IX)
      BUF(6) = 0
      BUF(7) = 0
      IF (KFRQ .NE. 0) GO TO 1207
C
C     FIRST TIME FOR THIS LOAD VECTOR ONLY - MATCH LIST OF USER
C     REQUESTED FREQS WITH ACTUAL FREQS. MARK FOR OUTPUT EACH ACTUAL
C     FREQ WHICH IS CLOSEST TO USER REQUEST.
C
      KFRQ = 1
      IX   = ICC + IFROUT
      FSETNO = Z(IX)
      IF (FSETNO .LE. 0) GO TO 1202
      IX = ICC + ILSYM
      ISETNF = IX + Z(IX) + 1
 1201 ISETF  = ISETNF + 2
      NSETF  = Z(ISETNF+1) + ISETF - 1
      IF (Z(ISETNF) .EQ. FSETNO) GO TO 1204
      ISETNF = NSETF + 1
      IF (ISETNF .LT. IVEC) GO TO 1201
      FSETNO = -1
 1202 DO 1203 J = ILIST,NLIST,2
 1203 Z(J+1) = 1
      GO TO 1207
 1204 DO 1206 I = ISETF,NSETF
      K    = 0
      DIFF = 1.E+25
      BUFR(1) = ZZ(I)
      DO 1205 J = ILIST,NLIST,2
      IF (Z(J+1) .NE. 0) GO TO 1205
      DIFF1 = ABS(ZZ(J) - BUFR(1))
      IF (DIFF1 .GE. DIFF) GO TO 1205
      DIFF = DIFF1
      K = J
 1205 CONTINUE
      IF (K .NE. 0) Z(K+1) = 1
 1206 CONTINUE
C
C     DETERMINE IF CURRENT FREQ IS MARKED FOR OUTPUT.
C
 1207 IF (Z(JLIST+1) .EQ. 0) GO TO 1350
      BUF(5) = Z(JLIST)
      BUF(2) = KCOUNT + 1014
      GO TO 1250
C
C     TRANSIENT RESPONSE.
C
 1220 BUF(5) = Z(JLIST)
      BUF(2) = KCOUNT + 14
      IF (IREQ .EQ. IPNL) BUF(2) = 12
      IX     = ICC + IDLOAD
      BUF(8) = Z(IX)
      BUF(6) = 0
      BUF(7) = 0
C
C     WRITE ID RECORD ON OUTPUT FILE.
C
 1250 IX = BRANCH + 3
      IF (APP(1) .EQ. CEI(1)) IX = 9
      IF (APP(1) .EQ. IREIG ) IX = 2
      BUF(1) = DEST + 10*IX
      BUF(3) = 0
      BUF(4) = Z(ICC+1)
      IF (Z(IREQX+2) .LT. 0) SORT2 = +1
      FORMAT  = IABS(Z(IREQX+2))
      BUF(9)  = FORMAT
      BUF(10) = NWDS
      CALL WRITE (OUTFL,BUF,50,0)
      IX = ICC + ITTL
      CALL WRITE (OUTFL,Z(IX),96,1)
      OUTPUT = 1
      IF (Z(IREQX+2) .LT. 0) SORT2 = 1
C
C     BUILD DATA RECORD ON OUTPUT FILE.
C
      IF (FORM(1) .EQ. MODAL(1)) GO TO 1270
      IF (SETNO .NE. -1) GO TO 1263
C
C     DIRECT PROBLEM SET .EQ. -ALL- - OUTPUT POINTS IN ANALYSIS SET
C
      KX = 1
      ASSIGN 1262 TO RETX
 1261 WORD = Z(KX+1)
      IF (WORD .EQ. 0) GO TO RETX, (1262,1265,1268)
      J      = WORD/256
      BUF(2) = ANDF(WORD,3)
      CODE   = WORD - 256*J - BUF(2)
      BUF(1) = Z(KX)
      IF (BUF(2) .EQ. 1) GO TO 1300
      GO TO 1290
 1262 KX = KX + 2
      IF (KX .LE. NEQDYN) GO TO 1261
      GO TO 1310
C
C     DIRECT PROBLEM WITH SET .NE. -ALL- OUTPUT POINTS IN REQUESTED SET
C                                        WHICH ARE ALSO IN ANALYSIS SET.
C
 1263 JHARM = 0
 1267 I = ISET
      ASSIGN 1261 TO RET
 1264 BUF(1) = Z(I)
      IF (I   .EQ. NSET) GO TO 1266
      IF (Z(I+1) .GT. 0) GO TO 1266
      N = -Z(I+1)
      I = I + 1
      ASSIGN 1265 TO RETX
      GO TO 3000
 1265 BUF(1) = BUF(1) + 1
      IF (BUF(1) .LE. N) GO TO 3000
      GO TO 1268
 1266 ASSIGN 1268 TO RETX
      GO TO 3000
 1268 I = I + 1
      IF (I .LE. NSET) GO TO 1264
      IF (AXIF .EQ. 0) GO TO 1310
      JHARM = JHARM + 1
      IF (JHARM .LE. OHARMS) GO TO 1267
      GO TO 1310
C
C     MODAL PROBLEM WITH SET .EQ. -ALL- OUTPUT ALL MODAL POINTS. THEN
C                                       IF EXTRA POINTS, OUTPUT THEM.
C
 1270 IF (SETNO .NE. -1) GO TO 1275
      BUF(1) = IMODE
      BUF(2) = 4
      J = 1
      ASSIGN 1271 TO RETX
      GO TO 1290
 1271 BUF(1) = BUF(1) + 1
      J = BUF(1) - IMODE + 1
      IF (BUF(1) .LE. NBRMOD) GO TO 1290
      IF (NBREP .EQ. 0) GO TO 1310
      KX = 1
      ASSIGN 1273 TO RETX
      BUF(2) = 3
 1272 J = Z(KX+1)/10
      GPTYPE = Z(KX+1) - 10*J
      BUF(1) = Z(KX)
      IF (GPTYPE .EQ. 3) GO TO 1290
 1273 KX = KX + 2
      IF (KX .LE. NEQDYN) GO TO 1272
      GO TO 1310
C
C     MODAL PROBLEM WITH SET .NE. -ALL- ASSUME NUMBERS IN REQUESTED SET
C                                       WHICH ARE .LE. NO. OF MODES ARE
C                                       MODAL COORDINATES AND ANY OTHERS
C                                       ARE EXTRA POINTS.
C
 1275 JHARM = 0
 1274 I = ISET
 1276 BUF(1) = Z(I)
      IF (I   .EQ. NSET) GO TO 1281
      IF (Z(I+1) .GT. 0) GO TO 1281
      N = -Z(I+1)
      BUF(2) = 4
      I = I + 1
      ASSIGN 1278 TO RETX
 1277 IF (BUF(1).LT.IMODE .OR. BUF(1).GT.NBRMOD) GO TO 1279
      J = BUF(1) - IMODE + 1
      GO TO 1290
 1278 BUF(1) = BUF(1) + 1
      IF (BUF(1) .LE. N) GO TO 1277
      GO TO 1284
 1279 IF (NBREP .EQ. 0) GO TO 1284
      ASSIGN 1280 TO RET
      BUF(2) = 3
      GO TO 3000
 1280 J = Z(KX+1)/10
      GPTYPE = Z(KX+1) - 10*J
      IF (GPTYPE .EQ. 3) GO TO 1290
      GO TO 1278
 1281 ASSIGN 1284 TO RETX
      IF (BUF(1).LT.IMODE .OR. BUF(1).GT.NBRMOD) GO TO 1282
      ASSIGN 1284 TO RETX
      J = BUF(1) - IMODE + 1
      BUF(2) = 4
      GO TO 1290
 1282 IF (NBREP .EQ. 0) GO TO 1284
      ASSIGN 1283 TO RET
      GO TO 3000
 1283 J = Z(KX+1)/10
      BUF(2) = Z(KX+1) - 10*J
      IF (BUF(2) .EQ. 3) GO TO 1290
 1284 I = I + 1
      IF (I .LE. NSET) GO TO 1276
      IF (AXIF .EQ. 0) GO TO 1310
      JHARM = JHARM + 1
      IF (JHARM .LE. OHARMS) GO TO 1274
      GO TO 1310
C
C     SCALAR, EXTRA OR MODAL POINT.
C
 1290 J = IVEC + KTYPE*(J-1)
      BUFR(3) = ZZ(J)
      DO 1293 K = 4,NWDS
 1293 BUF(K) = 0
      IF (KTYPE .EQ. 1) GO TO 1309
C
C     COMPLEX SCALAR, EXTRA OR MODAL POINT.
C
      BUFR(9) = ZZ(J+1)
      IF (FORMAT .NE. 3) GO TO 1309
      REDNER = SQRT(BUFR(3)**2 + BUFR(9)**2)
      IF (REDNER) 12921,1309,12921
12921 BUFR(9) = ATAN2(BUFR(9),BUFR(3))*RADDEG
      IF (BUFR(9) .LT. -0.00005) BUFR(9) = BUFR(9) + 360.0
      BUFR(3) = REDNER
      GO TO 1309
C
C     GRID POINT.
C
 1300 DO 1301 K = 3,NWDS
 1301 BUF(K) = 1
      J = IVEC + KTYPE*(J-1)
      IF (KTYPE .EQ. 2) GO TO 1303
      DO 1302 K = 1,6
      IF (ANDF(CODE,MASKS(K)) .EQ. 0) GO TO 1302
      BUFR(K+2) = ZZ(J)
      J = J + 1
 1302 CONTINUE
      GO TO 1309
C
C     COMPLEX GRID POINT.
C
 1303 DO 1305 K = 1,6
      IF (ANDF(CODE,MASKS(K)) .EQ. 0) GO TO 1305
      BUFR(K+2) = ZZ(J  )
      BUFR(K+8) = ZZ(J+1)
      J = J + 2
      IF (FORMAT .NE. 3) GO TO 1305
      REDNER = SQRT(BUFR(K+2)**2 + BUFR(K+8)**2)
      IF (REDNER) 13031,1305,13031
13031 BUFR(K+8) = ATAN2(BUFR(K+8),BUFR(K+2))*RADDEG
      IF (BUFR(K+8) .LT. -0.00005) BUFR(K+8)= BUFR(K+8) + 360.0
      BUFR(K+2) = REDNER
 1305 CONTINUE
C
C     DETERMINE DESTINATION FOR ENTRY.
C
C
C     IF A FLUID PROBLEM THEN A CHECK IS NOW MADE TO SEE IF THIS
C     HARMONIC IS TO BE OUTPUT
C
 1309 IF (AXIF) 1315,1314,1315
 1315 IF (BUF(1) .LT. 500000) GO TO 1314
      ITEMP = BUF(1) - MOD(BUF(1),500000)
      ITEMP = ITEMP/500000
      IF (ITEMP .GE. OHARMS) GO TO 1310
 1314 ID = BUF(1)
      BUF(1) = 10*ID + DEST
      IF (XSETNO) 1304,1306,1307
 1306 BUF(1) = 10*ID
      GO TO 1304
 1307 IX = IXSET
 1313 IF (IX  .EQ. NXSET) GO TO 1308
      IF (Z(IX+1) .GT. 0) GO TO 1308
      IF (ID.GE.Z(IX) .AND. ID.LE.-Z(IX+1)) GO TO 1304
      IX = IX + 2
      GO TO 1312
 1308 IF (ID .EQ. Z(IX)) GO TO 1304
      IX = IX + 1
 1312 IF (IX .LE. NXSET) GO TO 1313
      GO TO 1306
C
C     WRITE ENTRY ON OUTPUT FILE.
C
 1304 CALL WRITE (OUTFL,BUF,NWDS,0)
      KWDS = KWDS + NWDS
      BUF(1) = ID
      GO TO RETX, (1262,1265,1268,1271,1273,1278,1284)
C
C     CONCLUDE PROCESSING OF THIS VECTOR.
C
 1310 CALL WRITE (OUTFL,0,0,1)
 1311 GO TO (1340,1350,1360,1340), BRANCH
C
C     COMPLEX EIGENVALUES.
C
 1340 JLIST = JLIST + 3
 1341 IF (JCOUNT .GE. NVECTS) GO TO 1410
      IF (EOF .EQ. 0) GO TO 1130
      GO TO 1140
C
C     FREQUENCY RESPONSE.
C
 1350 IF (KCOUNT .EQ. 3) GO TO 1356
      N = IVECN - 1
      OMEGA = TWOPI*ZZ(JLIST)
      DO 1351 I = IVEC,N,2
      BUFR(1) = -OMEGA*ZZ(I+1)
      ZZ(I+1) =  OMEGA*ZZ(I  )
 1351 ZZ(I  ) =  BUFR(1)
      IF (KCOUNT .EQ. 2) GO TO 1352
      IREQ = IAVEL
      GO TO 1353
 1352 IREQ = IAACC
 1353 KCOUNT = KCOUNT + 1
      INCORE = 1
      GO TO 1140
 1356 KCOUNT = 1
      INCORE = 0
      IREQ   = IADISP
      JLIST  = JLIST + 2
      IF (JLIST.LE.NLIST .AND. JCOUNT.LT.NVECTS) GO TO 1140
      KFRQ  = 0
      JLIST = ILIST
      DO 1357 I = ILIST,NLIST,2
 1357 Z(I+1) = 0
      IF (JCOUNT .LT. NVECTS) GO TO 1130
      GO TO 1410
C
C     TRANSIENT RESPONSE.
C
 1360 IF (IREQ .EQ. IPNL) GO TO 1364
      IF (KCOUNT-2) 1361,1362,1363
 1361 IREQ   = IAVEL
      KCOUNT = 2
      GO TO 1140
 1362 IREQ   = IAACC
      KCOUNT = 3
      GO TO 1140
 1363 IREQ   = IADISP
      KCOUNT = 1
 1364 JLIST  = JLIST + 1
      IF (JLIST.LE.NLIST .AND. JCOUNT.LT.NVECTS) GO TO 1140
      GO TO 1410
C
C     HERE WHEN EOF ENCOUNTERED ON CASE CONTROL.
C
 1400 EOF = 1
      GO TO (1341,1410,1410,1341), BRANCH
C
C     CONCLUDE PROCESSING.
C
 1410 CALL CLOSE (CASECC,CLSREW)
      CALL CLOSE (INFIL, CLSREW)
      CALL CLOSE (OUTFL, CLSREW)
      MCB(1) = OUTFL
      MCB(2) = KWDS/65536
      MCB(3) = KWDS - 65536*MCB(2)
      MCB(4) = 0
      MCB(5) = 0
      MCB(6) = 0
      MCB(7) = 0
      CALL WRTTRL (MCB)
      RETURN
C
C     HERE IF ABNORMAL CONDITION.
C
 1430 CALL CLOSE (OUTFL,CLSREW)
 1431 CALL MESAGE (30,78,0)
 1432 RETURN
C
C     FATAL FILE ERRORS
C
 2001 N = -1
      GO TO 2005
 2002 N = -2
 2005 CALL MESAGE (N,FILE,NAM)
      RETURN
C
C     BINARY SEARCH ROUTINE
C
 3000 KLO = 1
      KHI = KN
      IF (AXIF) 3011,3001,3011
 3011 BUF(1) = JHARM*500000 + BUF(1)
 3001 K  = (KLO+KHI+1)/2
 3002 KX = 2*K - 1
      IF (BUF(1)-Z(KX)) 3003,3009,3004
 3003 KHI = K
      GO TO 3005
 3004 KLO = K
 3005 IF (KHI-KLO-1) 3010,3006,3001
 3006 IF (K .EQ. KLO) GO TO 3007
      K = KLO
      GO TO 3008
 3007 K = KHI
 3008 KLO = KHI
      GO TO 3002
 3009 GO TO RET,  (1261,1280,1283)
 3010 GO TO RETX, (1262,1265,1268,1273,1278,1284)
      END

      SUBROUTINE GRAVL1(NVECT,GVECT,SR1,IHARM)
C
      INTEGER GRAVT(7),OLD,SYSBUF,SR1,BGPDT,SIL,CSTM
      INTEGER NAME(2)
C
      DIMENSION  IGPCO(4),GVECT(1),VECT(3)
C
      COMMON /BLANK/NROWSP
      COMMON /SYSTEM/SYSBUF
      COMMON /ZBLPKX/ B(4),II
      COMMON /ZZZZZZ/ CORE(1)
      COMMON  /LOADX/ N(2),BGPDT,OLD,CSTM,SIL,ISTL,NN(8),MASS
C
      DATA NAME/4HGRAV,4HL1  /
C
C ----------------------------------------------------------------------
C
      IF (IHARM .EQ. 0) GO TO 5
      CALL GRAVL3(NVECT,GVECT,SR1,IHARM)
      RETURN
    5 CONTINUE
      LCORE=KORSZ(CORE)
      ICM = 1
      NZ = LCORE
      LCORE=LCORE-SYSBUF
      CALL GOPEN(SR1,CORE(LCORE+1),1)
      LCORE =LCORE - SYSBUF
      CALL GOPEN(BGPDT,CORE(LCORE+1),0)
      OLD =0
      LCORE =LCORE -SYSBUF
      CALL OPEN(*10,CSTM,CORE(LCORE+1),0)
      ICM = 0
      CALL SKPREC(CSTM,1)
      LCORE =LCORE-SYSBUF
   10 CALL GOPEN(SIL,CORE(LCORE+1),0)
      ISIL=0
      CALL MAKMCB(GRAVT,SR1,NROWSP,2,1)
      DO 140 ILOOP=1,NVECT
   20 CALL READ(*200,*120,SIL,ISIL1,1,0,FLAG)
      IF(ISIL1) 20,30,30
   30 IL=(ILOOP-1)*3
      ASSIGN 60 TO IOUT
      IPONT=1
      CALL BLDPK(1,1,GRAVT(1),0,0)
   40 CALL READ(*200,*120,SIL,ISIL2,1,0,FLAG)
      IF(ISIL2) 40,50,50
   50 IF(ISIL2 -ISIL1-1) 70,60,70
   60 ISIL1 = ISIL2
      IPONT = IPONT+1
      GO TO 40
   70 CALL FNDPNT (IGPCO(1),IPONT)
      DO 80 I=1,3
      IN= I+IL
   80 VECT(I) = GVECT(IN)
      IF (IGPCO(1).NE.0) CALL BASGLB (VECT(1),VECT(1),IGPCO(2),IGPCO(1))
      DO 110 I=1,3
      B(1)=VECT(I)
      II = ISIL1-1+I
      CALL ZBLPKI
  110 CONTINUE
      GO TO IOUT,(60,130)
C
C     END SIL
C
  120 ASSIGN 130 TO IOUT
      IF(NROWSP-ISIL1) 70,130,70
  130 CALL REWIND(BGPDT)
      CALL REWIND(SIL)
      CALL BLDPKN(GRAVT(1),0,GRAVT)
      CALL SKPREC(SIL,1)
      ISIL=0
      CALL SKPREC(BGPDT,1)
      OLD=0
  140 CONTINUE
      CALL CLOSE(BGPDT,1)
      IF(ICM .EQ. 0) CALL CLOSE(CSTM,1)
      CALL CLOSE (SIL,1)
      CALL CLOSE (GRAVT(1),1)
      CALL WRTTRL (GRAVT)
      RETURN
C
  200 CALL MESAGE (-3,IPM,NAME)
      RETURN
C
      END

      SUBROUTINE TLQD4S
C
C     ELEMENT THERMAL LOAD GENERATOR FOR 4-NODE ISOPARAMETRIC
C     QUADRILATERAL SHELL ELEMENT (QUAD4)
C     (SINGLE PRECISION VERSION)
C
C     COMPLETELY RESTRUCTURED FOR COMPOSITES WITH THE FOLLOWING
C     LIMITATION -
C     1. FOR DIFFERENT GRID POINT TEMPERATURES AN AVERAGE
C        VALUE IS TAKEN.                       HEMANT  2/24/86
C
C
C                 EST LISTING
C     ---------------------------------------------------------
C      1          EID
C      2 THRU 5   SILS, GRIDS 1 THRU 4
C      6 THRU 9   T (MEMBRANE), GRIDS 1 THRU 4
C     10          THETA (MATERIAL)
C     11          TYPE FLAG FOR WORD 10
C     12          ZOFF  (OFFSET)
C     13          MATERIAL ID FOR MEMBRANE
C     14          T (MEMBRANE)
C     15          MATERIAL ID FOR BENDING
C     16          I FACTOR (BENDING)
C     17          MATERIAL ID FOR TRANSVERSE SHEAR
C     18          FACTOR FOR T(S)
C     19          NSM (NON-STRUCTURAL MASS)
C     20 THRU 21  Z1, Z2  (STRESS FIBRE DISTANCES)
C     22          MATERIAL ID FOR MEMBRANE-BENDING COUPLING
C     23          THETA (MATERIAL) FROM PSHELL CARD
C     24          TYPE FLAG FOR WORD 23
C     25          INTEGRATION ORDER
C     26          THETA (STRESS)
C     27          TYPE FLAG FOR WORD 26
C     28          ZOFF1 (OFFSET)  OVERRIDDEN BY EST(12)
C     29 THRU 44  CID,X,Y,Z - GRIDS 1 THRU 4
C     45          ELEMENT TEMPERATURE
C
C
      LOGICAL          BADJAC,MEMBRN,BENDNG,SHRFLX,MBCOUP,NORPTH,
     1                 TEMPP1,TEMPP2,PCMP,PCMP1,PCMP2,COMPOS
      INTEGER          INTZ(1),NOUT,NEST(45),ELID,SIL(4),KSIL(4),
     1                 KCID(4),IGPDT(4,4),FLAG,ROWFLG,NECPT(4),
     2                 MID(4),INDEX(3,3),INDX(6,3),COMPS,NAM(2),
     3                 PCOMP,PCOMP1,PCOMP2,SYM,SYMMEM,PID,PIDLOC
      REAL             GPTH(4),TGRID(4,4),GPNORM(4,4),BGPDT(4,4),
     1                 MATSET,TMPTHK(4),ECPT(4),EGPDT(4,4),
     2                 EPNORM(4,4),BGPDM(3,4),ALPHAM(6),TSUB0,STEMP,Z
      REAL             DGPTH(4),THK,EPS1,XI,ETA,DETJ,HZTA,PSITRN(9),
     1                 JACOB(9),PHI(9),MOMINR,COEFF,REALI,PI,TWOPI,
     2                 RADDEG,DEGRAD,SHP(4),DSHP(8),TMPSHP(4),
     3                 DSHPTP(8),GT(9),G(6,6),GI(36),U(9),TRANS(36),
     4                 PTINT(2),GGE(9),GGU(9),TBM(9),TEB(9),TEM(9),
     5                 TUB(9),TUM(9),TEU(9),TBG(9),UGPDM(3,4),CENTE(3),
     6                 CENT(3),X31,Y31,X42,Y42,AA,BB,CC,EXI,EXJ,XM,YM,
     7                 THETAM,BMATRX(144),XYBMAT(96),ALPHA(6),ALFAM(3),
     8                 ALFAB(3),TALFAM(3),TALFAB(3),ALPHAD(6),PT(24),
     9                 PTG(24),TBAR,TTBAR,TGRAD,THRMOM(3),G2I(9),G2(9),
     O                 GTEMPS(6),EPSUBT(6),GEPSBT(6),DETU,DETG2,DETERM
      REAL             ABBD(6,6),STIFF(36),GPROP(25),GLAY(9),GLAYT(9),
     1                 GBAR(9),GALPHA(3),ALPHAL(3),ALPHAE(3),MINTR,
     2                 TLAM,THETA,THETAE,TRANSL(9),TSUBO,TMEAN,TEMPEL,
     3                 DELTA,DELTAT,ZK,ZK1,ZREF,ZSUBI,C,C2,S,S2,
     4                 FTHERM(6),EPSLNT(6),OFFSET,CONST,UEV,ANGLEI,
     5                 EDGEL,EDGSHR,UNV
CWKBNB 11/93 SPR 93020
      REAL             VD1(3), VD2(3), VKN(3), VKS(3)
     1,                V12(3), V41(3), VP12(3),VIS(3), VJS(3)
CWKBNE 11/93 SPR 93020
      COMMON /CONDAS/  PI,TWOPI,RADDEG,DEGRAD
      COMMON /TRIMEX/  EST(45)
      COMMON /SYSTEM/  BUFFER(100)
      COMMON /MATIN /  MATID,INFLAG,ELTEMP
      COMMON /MATOUT/  RMTOUT(25)
      COMMON /SGTMPD/  STEMP(8)
CZZ   COMMON /ZZSSB1/  Z(1)
      COMMON /ZZZZZZ/  Z(20000)
      COMMON /BLANK /  NROWSP,IPARAM,COMPS
      COMMON /COMPST/  IPCMP,NPCMP,IPCMP1,NPCMP1,IPCMP2,NPCMP2
      COMMON /Q4DT  /  DETJ,HZTA,PSITRN,NNODE,BADJAC,N1
      COMMON /TERMS /  MEMBRN,BENDNG,SHRFLX,MBCOUP,NORPTH
      COMMON /Q4COMS/  ANGLEI(4),EDGSHR(3,4),EDGEL(4),UNV(3,4),
     1                 UEV(3,4),ROWFLG,IORDER(4)
C
      EQUIVALENCE     (Z(1)     ,INTZ(1)), (IGPDT(1,1),BGPDT(1,1))
      EQUIVALENCE     (EST(1)   ,NEST(1)), (BGPDT(1,1),EST(29)   )
      EQUIVALENCE     (ELTH     ,EST(14)), (GPTH(1)   ,EST(6)    )
      EQUIVALENCE     (SIL(1)   ,NEST(2)), (MATSET    ,RMTOUT(25))
      EQUIVALENCE     (ZOFF     ,EST(12)), (ZOFF1     ,EST(28)   )
      EQUIVALENCE     (NECPT(1) ,ECPT(1)), (BUFFER(1) ,SYSBUF    )
      EQUIVALENCE     (BUFFER(2),NOUT   ), (BUFFER(3) ,NOGO      )
      EQUIVALENCE     (STEMP(7) ,FLAG   ), (ALFAB(1)  ,ALPHA(4)  )
      EQUIVALENCE     (ALFAM(1) ,ALPHA(1))
C
      DATA EPS1     / 1.0E-7 /
      DATA PCOMP    / 0 /
      DATA PCOMP1   / 1 /
      DATA PCOMP2   / 2 /
      DATA SYM      / 1 /
      DATA MEM      / 2 /
      DATA SYMMEM   / 3 /
      DATA CONST    / 0.57735026918962 /
      DATA NAM      / 4HTLQD,4H4S      /
C
C-----ZERO THE VARIOUS ALPHA ARRAYS
C
      DO 10 I =1,6
      ALPHAM(I) = 0.0
      ALPHA(I)  = 0.0
      ALPHAD(I) = 0.0
   10 CONTINUE
      DO 20 I =1,3
      TALFAM(I) = 0.0
      TALFAB(I) = 0.0
   20 CONTINUE
C
      ELID=NEST(1)
      LTYPFL=1
      OFFSET=ZOFF
      IF (ZOFF .EQ. 0.0) OFFSET=ZOFF1
C
C     TEST FOR COMPOSITE ELEMENT
C
      COMPOS = .FALSE.
C
      PID = NEST(13) - 100000000
      COMPOS = COMPS.EQ.-1 .AND. PID.GT.0
C
C-----CHECK FOR THE TYPE OF TEMPERATURE DATA
C     NOTES-  1- TYPE TEMPP1 ALSO INCLUDES TYPE TEMPP3
C             2- IF NO TEMPPI CARDS, GRID POINT TEMPERATURES
C                ONLY ARE PRESENT
C
      TEMPP1 = FLAG .EQ. 13
      TEMPP2 = FLAG .EQ. 2
C
      N1=4
      NNODE=4
      NDOF=NNODE*6
      ND2=NDOF*2
      ND3=NDOF*3
      ND4=NDOF*4
      ND5=NDOF*5
C
C     FILL IN ARRAY GGU WITH THE COORDINATES OF GRID POINTS
C     1, 2 AND 4. THIS ARRAY WILL BE USED LATER TO DEFINE
C     THE USER COORDINATE SYSTEM WHILE CALCULATING
C     TRANSFORMATIONS INVOLVING THIS COORDINATE SYSTEM.
C
      DO 30 I=1,3
      II=(I-1)*3
      IJ=I
      IF (IJ .EQ. 3) IJ=4
      DO 30 J=1,3
      JJ=J+1
   30 GGU(II+J)=BGPDT(JJ,IJ)
CWKBD 11/93 SPR93020      CALL BETRNS (TUB,GGU,0,ELID)
CWKBNB 11/93 SPR93020
C    ADD FROM SHEAR ELEMENT
C
C    COMPUTE DIAGONAL VECTORS
C
      DO 21 I = 1,3
      II=I+1
      VD1(I) = BGPDT(II,3) - BGPDT(II,1)
   21 VD2(I) = BGPDT(II,4) - BGPDT(II,2)
C
C    COMPUTE THE NORMAL VECTOR VKN, NORMALIZE, AND COMPUTE THE PROJECTED
C    AREA, PA
C
      VKN(1) = VD1(2)*VD2(3) - VD1(3)*VD2(2)
      VKN(2) = VD1(3)*VD2(1) - VD1(1)*VD2(3)
      VKN(3) = VD1(1)*VD2(2) - VD1(2)*VD2(1)
      VKL = SQRT( VKN(1)**2 + VKN(2)**2 + VKN(3)**2 )
      IF ( VKL .EQ. 0. ) WRITE( NOUT, 2070 ) EST(1)
2070  FORMAT(//,' ILLEGAL GEOMETRY FOR QUAD4 ELEMENT, ID=',I10 )
      VKS(1) = VKN(1)/VKL
      VKS(2) = VKN(2)/VKL
      VKS(3) = VKN(3)/VKL
      PA = VKL/2.
C
C  COMPUTE SIDES -12- AND -41-
      DO 25 I = 1,3
      II = I + 1
      V12(I) = BGPDT(II,2) - BGPDT(II,1)
      V41(I) = BGPDT(II,1) - BGPDT(II,4)
25    CONTINUE
C
C  COMPUTE DOT PRODUCT, V12DK, OR V12 AND VK, THE VECTORS VP12, VI, VJ
C
      V12DK   = V12(1)*VKS(1) + V12(2)*VKS(2) + V12(3)*VKS(3)
      VP12(1) = V12(1) - V12DK*VKS(1)
      VP12(2) = V12(2) - V12DK*VKS(2)
      VP12(3) = V12(3) - V12DK*VKS(3)
      VP12L   = SQRT( VP12(1)**2 + VP12(2)**2 + VP12(3)**2 )
      IF ( VP12L .EQ. 0. ) WRITE( NOUT, 2070 ) EST(1)
      VIS(1) = VP12(1) / VP12L
      VIS(2) = VP12(2) / VP12L
      VIS(3) = VP12(3) / VP12L
      VJS(1) = VKS(2)*VIS(3) - VKS(3)*VIS(2)
      VJS(2) = VKS(3)*VIS(1) - VKS(1)*VIS(3)
      VJS(3) = VKS(1)*VIS(2) - VKS(2)*VIS(1)
C
C   NORMALIZE J FOR GOOD MEASURE
C
      VJL = SQRT( VJS(1)**2 + VJS(2)**2 + VJS(3)**2 )
      IF ( VJL .EQ. 0. ) WRITE ( NOUT, 2070 ) EST(1)
      VJS(1) = VJS(1) / VJL
      VJS(2) = VJS(2) / VJL
      VJS(3) = VJS(3) / VJL
      DO 29 I = 1,3
      TUB(I)   = VIS(I)
      TUB(I+3) = VJS(I)
      TUB(I+6) = VKS(I)
29    CONTINUE
CWKBNE 11/93 SPR93020
C
C     STORE INCOMING BGPDT FOR ELEMENT C.S. CALCULATION
C
      DO 40 I=1,3
      I1=I+1
      DO 40 J=1,4
   40 BGPDM(I,J)=BGPDT(I1,J)
C
C     TRANSFORM BGPDM FROM BASIC TO USER C.S.
C
      DO 50 I=1,3
      IP=(I-1)*3
      DO 50 J=1,4
      UGPDM(I,J)=0.0
      DO 50 K=1,3
      KK=IP+K
   50 UGPDM(I,J)=UGPDM(I,J)+TUB(KK)*((BGPDM(K,J))-GGU(K))
C
C
C     THE ORIGIN OF THE ELEMENT C.S. IS IN THE MIDDLE OF THE ELEMENT
C
      DO 60 J=1,3
      CENT(J)=0.0
      DO 60 I=1,4
   60 CENT(J)=CENT(J)+UGPDM(J,I)/NNODE
C
C     STORE THE CORNER NODE DIFF. IN THE USER C.S.
C
      X31=UGPDM(1,3)-UGPDM(1,1)
      Y31=UGPDM(2,3)-UGPDM(2,1)
      X42=UGPDM(1,4)-UGPDM(1,2)
      Y42=UGPDM(2,4)-UGPDM(2,2)
      AA=SQRT(X31*X31+Y31*Y31)
      BB=SQRT(X42*X42+Y42*Y42)
C
C     NORMALIZE XIJ'S
C
      X31=X31/AA
      Y31=Y31/AA
      X42=X42/BB
      Y42=Y42/BB
      EXI=X31-X42
      EXJ=Y31-Y42
C
C     STORE GGE ARRAY, THE OFFSET BETWEEN ELEMENT C.S. AND USER C.S.
C
      GGE(1)=CENT(1)
      GGE(2)=CENT(2)
      GGE(3)=CENT(3)
C
      GGE(4)=GGE(1)+EXI
      GGE(5)=GGE(2)+EXJ
      GGE(6)=GGE(3)
C
      GGE(7)=GGE(1)-EXJ
      GGE(8)=GGE(2)+EXI
      GGE(9)=GGE(3)
C
C
C     THE ARRAY IORDER STORES THE ELEMENT NODE ID IN
C     INCREASING SIL ORDER.
C
C     IORDER(1) = NODE WITH LOWEST  SIL NUMBER
C     IORDER(4) = NODE WITH HIGHEST SIL NUMBER
C
C     ELEMENT NODE NUMBER IS THE INTEGER FROM THE NODE
C     LIST  G1,G2,G3,G4 .  THAT IS, THE 'I' PART
C     OF THE 'GI' AS THEY ARE LISTED ON THE CONNECTIVITY
C     BULK DATA CARD DESCRIPTION.
C
C
      DO 70 I=1,4
      IORDER(I)=0
      KSIL(I)=SIL(I)
   70 CONTINUE
C
      DO 90 I=1,4
      ITEMP=1
      ISIL=KSIL(1)
      DO 80 J=2,4
      IF (ISIL .LE. KSIL(J)) GO TO 80
      ITEMP=J
      ISIL=KSIL(J)
   80 CONTINUE
      IORDER(I)=ITEMP
      KSIL(ITEMP)=99999999
   90 CONTINUE
C
C     ADJUST EST DATA
C
C
C     USE THE POINTERS IN IORDER TO COMPLETELY REORDER THE
C     GEOMETRY DATA INTO INCREASING SIL ORDER.
C     DON'T WORRY!! IORDER ALSO KEEPS TRACK OF WHICH SHAPE
C     FUNCTIONS GO WITH WHICH GEOMETRIC PARAMETERS!
C
C
      DO 110 I=1,4
      KSIL(I)=SIL(I)
      TMPTHK(I)=GPTH(I)
      KCID(I)=IGPDT(1,I)
      DO 100 J=2,4
      TGRID(J,I)=BGPDT(J,I)
  100 CONTINUE
  110 CONTINUE
      DO 130 I=1,4
      IPOINT=IORDER(I)
      SIL(I)=KSIL(IPOINT)
      GPTH(I)=TMPTHK(IPOINT)
      IGPDT(1,I)=KCID(IPOINT)
      DO 120 J=2,4
      BGPDT(J,I)=TGRID(J,IPOINT)
  120 CONTINUE
  130 CONTINUE
C
C-----SORT THE GRID POINT TEMPERATURES (IN STEMP(1-4))
C     IF PRESENT AND MAKE REAL          THE OTHER
C     KINDS OF TEMPERATURE DATA IF TEMPPI CARDS PRESENT
C
      IF (TEMPP1 .OR. TEMPP2) GO TO 150
C
      TEMPEL = 0.0
      DO 140 I =1,4
      IPNT = IORDER(I)
      GTEMPS(I) = STEMP(IPNT)
      TEMPEL = TEMPEL + 0.25 * GTEMPS(I)
  140 CONTINUE
      GO TO 170
C
  150 IF (TEMPP2) GO TO 160
C
      TBAR  = STEMP(1)
      TGRAD = STEMP(2)
      GO TO 170
C
  160 TBAR = STEMP(1)
      THRMOM(1) = STEMP(2)
      THRMOM(2) = STEMP(3)
      THRMOM(3) = STEMP(4)
  170 CONTINUE
C
C     COMPUTE NODE NORMALS
C
      CALL Q4NRMS (BGPDT,GPNORM,IORDER,IFLAG)
      IF (IFLAG .EQ. 0) GO TO 180
      J = -230
      GO TO 1580
C
C     DETERMINE NODAL THICKNESSES
C
  180 DO 200 I=1,NNODE
      IF (GPTH(I) .EQ. 0.0) GPTH(I)=ELTH
      IF (GPTH(I) .GT. 0.0) GO TO 190
      WRITE (NOUT,1700) ELID
      NOGO=1
      GO TO 1600
  190 DGPTH(I)=GPTH(I)
  200 CONTINUE
C
      MOMINR=0.0
      IF (NEST(15) .NE. 0) MOMINR=EST(16)
C
C
C     THE COORDINATES OF THE ELEMENT GRID POINTS HAVE TO BE
C     TRANSFORMED FROM THE BASIC C.S. TO THE ELEMENT C.S.
C
C
      CALL BETRNS (TEU,GGE,0,ELID)
      CALL GMMATS (TEU,3,3,0,TUB,3,3,0,TEB)
      CALL GMMATS (TUB,3,3,1,CENT,3,1,0,CENTE)
C
      IP = -3
      DO 210 II=2,4
      IP=IP+3
      DO 210 J=1,NNODE
      EPNORM(II,J)=0.0
      EGPDT(II,J)=0.0
      DO 210 K=1,3
      KK=IP+K
      K1=K+1
      CC=(BGPDT(K1,J))-GGU(K)-CENTE(K)
      EPNORM(II,J)=EPNORM(II,J)+TEB(KK)*GPNORM(K1,J)
  210 EGPDT( II,J)=EGPDT(II,J)+(TEB(KK)*CC)
CWKBNB 11/93 SPR93020
      DO 171 J = 1, 4
      EGPDT(4,J) = CENT(3)
171   CONTINUE
CWKBNE 11/93 SPR93020
C
C     BEGIN INITIALIZING MATERIAL VARIABLES
C
C     SET INFLAG = 12 SO THAT SUBROUTINE MAT WILL SEARCH FOR -
C     ISOTROPIC MATERIAL PROPERTIES AMONG THE MAT1 CARDS,
C     ORTHOTROPIC MATERIAL PROPERTIES AMONG THE MAT8 CARDS, AND
C     ANISOTROPIC MATERIAL PROPERTIES AMONG THE MAT2 CARDS.
C
      INFLAG=12
      ELTEMP= EST(45)
      MID(1)=NEST(13)
      MID(2)=NEST(15)
      MID(3)=0
      MID(4)=NEST(22)
      MEMBRN=MID(1).GT.0
      BENDNG=MID(2).GT.0 .AND. MOMINR.GT.0.0
      SHRFLX=MID(3).GT.0
      MBCOUP=MID(4).GT.0
      NORPTH=.FALSE.
C
C     SET THE INTEGRATION POINTS
C
      PTINT(1) = -CONST
      PTINT(2) =  CONST
C
C     IN PLANE SHEAR REDUCTION
C
      XI =0.0
      ETA=0.0
      KPT=1
      KPT1=ND2
C
      CALL Q4SHPS (XI,ETA,SHP,DSHP)
C
C     SORT THE SHAPE FUNCTIONS AND THEIR DERIVATIVES INTO SIL ORDER.
C
      DO 300 I=1,4
      TMPSHP(I  )=SHP(I)
      DSHPTP(I  )=DSHP(I)
  300 DSHPTP(I+4)=DSHP(I+4)
      DO 310 I=1,4
      KK=IORDER(I)
      SHP (I  )=TMPSHP(KK)
      DSHP(I  )=DSHPTP(KK)
  310 DSHP(I+4)=DSHPTP(KK+4)
C
      DO 320 IZTA=1,2
      ZTA =PTINT(IZTA)
      HZTA=ZTA/2.0
      CALL JACOBS (ELID,SHP,DSHP,DGPTH,EGPDT,EPNORM,JACOB)
      IF (BADJAC) GO TO 1600
C
      CALL GMMATS (PSITRN,3,3,0,JACOB,3,3,1,PHI)
C
C     CALL Q4BMGS TO GET B MATRIX
C     SET THE ROW FLAG TO 2. IT WILL SAVE THE 3RD ROW OF B AT
C     THE TWO INTEGRATION POINTS.
C
      ROWFLG = 2
      CALL Q4BMGS (DSHP,DGPTH,EGPDT,EPNORM,PHI,XYBMAT(KPT))
  320 KPT=KPT+KPT1
C
C     SET THE ARRAY OF LENGTH 4 TO BE USED IN CALLING TRANSS.
C     NOTE THAT THE FIRST WORD IS THE COORDINATE SYSTEM ID WHICH
C     WILL BE SET IN POSITION LATER.
C
      DO 330 IEC=2,4
  330 ECPT(IEC)=0.0
C
C     FETCH MATERIAL PROPERTIES
C
C     EACH MATERIAL PROPERTY MATRIX G HAS TO BE TRANSFORMED FROM
C     THE MATERIAL COORDINATE SYSTEM TO THE ELEMENT COORDINATE
C     SYSTEM. THESE STEPS ARE TO BE FOLLOWED -
C
C     1- IF MCSID HAS BEEN SPECIFIED, SUBROUTINE TRANSS IS CALLED
C        TO CALCULATE TBM MATRIX (MATERIAL TO BASIC TRANSFORMATION).
C        THIS WILL BE FOLLOWED BY A CALL TO SUBROUTINE BETRNS
C        TO CALCULATE TEB MATRIX (BASIC TO ELEMENT TRANSFORMATION).
C        TBM IS THEN PREMULTIPLIED BY TEB TO OBTAIN TEM MATRIX.
C        THEN USING THE PROJECTION OF X-AXIS, AN ANGLE IS CALCULATED
C        UPON WHICH STEP 2 IS TAKEN.
C
C     2- IF THETAM HAS BEEN SPECIFIED, SUBROUTINE ANGTRS IS CALLED
C        TO CALCULATE TEM MATRIX (MATERIAL TO ELEMENT TRANSFORMATION).
C
C                        T
C     3-          G  =  U   G   U
C                  E         M
C
C
      IF (NEST(11) .EQ. 0) GO TO 390
      MCSID=NEST(10)
C
C     CALCULATE TEM USING MCSID
C
  340 IF (MCSID .GT. 0) GO TO 360
      DO 350 I=1,9
  350 TEM(I)=TEB(I)
      GO TO 370
  360 NECPT(1)=MCSID
      CALL TRANSS (ECPT,TBM)
C
C     MULTIPLY TEB AND TBM
C
      CALL GMMATS (TEB,3,3,0,TBM,3,3,0,TEM)
C
C     CALCULATE THETAM FROM THE PROJECTION OF THE X-AXIS OF THE
C     MATERIAL C.S. ON TO THE XY PLANE OF THE ELEMENT C.S.
C
  370 IMT=-1
      XM=TEM(1)
      YM=TEM(4)
      IF (ABS(XM) .LE. EPS1) IMT=IMT+1
      IF (ABS(YM) .LE. EPS1) IMT=IMT+2
      IF (IMT .LT. 2) GO TO 380
      NEST(2) = MCSID
      J = -231
      GO TO 1580
  380 THETAM= ATAN2(YM,XM)
      GO TO 400
C
C     CALCULATE TEM USING THETAM
C
  390 THETAM = (EST(10))*DEGRAD
      IF (THETAM .EQ. 0.0) GO TO 410
  400 CALL ANGTRS (THETAM,1,TUM)
      CALL GMMATS (TEU,3,3,0,TUM,3,3,0,TEM)
      GO TO 430
C
C     DEFAULT IS CHOSEN, LOOK FOR VALUES OF MCSID AND/OR THETAM
C     ON THE PSHELL CARD.
C
  410 IF (NEST(24) .EQ. 0) GO TO 420
      MCSID=NEST(23)
      GO TO 340
C
  420 THETAM = (EST(23))*DEGRAD
      GO TO 400
C
  430 CONTINUE
C
C     BEGIN THE LOOP TO FETCH PROPERTIES FOR EACH MATERIAL ID
C
      M=0
  500 M=M+1
      IF (M .GT. 4) GO TO 690
      MATID=MID(M)
      IF (MATID .EQ. 0) GO TO 500
C
      IF (M-1) 530,520,510
  510 IF (MATID.EQ.MID(M-1)) GO TO 530
  520 CALL MAT (ELID)
  530 CONTINUE
C
      TSUB0 = RMTOUT(11)
      IF (MATSET .EQ. 8.0) TSUB0 = RMTOUT(10)
C
      COEFF=1.0
      LPOINT=(M-1)*9+1
C
      CALL Q4GMGS (M,COEFF,GI(LPOINT))
C
      IF (THETAM .EQ. 0.0) GO TO 550
C
      U(1)=TEM(1)*TEM(1)
      U(2)=TEM(4)*TEM(4)
      U(3)=TEM(1)*TEM(4)
      U(4)=TEM(2)*TEM(2)
      U(5)=TEM(5)*TEM(5)
      U(6)=TEM(2)*TEM(5)
      U(7)=TEM(1)*TEM(2)*2.0
      U(8)=TEM(4)*TEM(5)*2.0
      U(9)=TEM(1)*TEM(5)+TEM(2)*TEM(4)
      L=3
C
      CALL GMMATS (U(1),L,L,1,GI(LPOINT),L,L,0,GT(1))
      CALL GMMATS (GT(1),L,L,0,U(1),L,L,0,GI(LPOINT))
C
  550 CONTINUE
C
      IF (COMPOS) GO TO 500
C
C-----TRANSFORM THERMAL EXPANSION COEFFICIENTS AND STORE THEM IN ALPHA
C
      IF (M .GT. 2) GO TO 500
      MORB = (M-1)*3
      IF (MATSET .EQ. 2.0) GO TO 610
      IF (MATSET .EQ. 8.0) GO TO 630
C
C     MAT1
C
      DO 600 IMAT=1,2
  600 ALPHAM(IMAT+MORB)=RMTOUT(8)
      ALPHAM(3+MORB) = 0.0
      GO TO 640
C
C     MAT2
C
  610 DO 620 IMAT=1,3
  620 ALPHAM(IMAT+MORB)=RMTOUT(7+IMAT)
      GO TO 640
C
C     MAT8
C
  630 ALPHAM(MORB+1)=RMTOUT(8)
      ALPHAM(MORB+2)=RMTOUT(9)
      ALPHAM(MORB+3)=0.0
C
C-----SKIP THE TRANSFORMATION OF ALPHAM IF MATSET = 1.0
C     OR THETAM = 0.0
C
  640 CONTINUE
C
      IF (MATSET .EQ. 1.0) GO TO 650
      IF (THETAM .NE. 0.0) GO TO 670
C
  650 DO 660 IG = 1,3
      ALPHA(IG+MORB) = ALPHAM(IG+MORB)
  660 CONTINUE
      GO TO 500
C
C-----THE ALPHAS NEED TO BE PREMULTIPLIED BY U INVERSE.
C     INCREMENT MORB BY 1 TO INDICATE WHERE TO FILL THE
C     ARRAYS, AND PUT THE SINGLE PREC. ARRAY OF ALPHAM
C     INTO THE DOUBLE PREC. ARRAY OF ALPHAD FOR THE CALL
C     TO GMMATS.
C
  670 MORB = MORB + 1
      DO 680 I =1,6
      ALPHAD(I) = ALPHAM(I)
  680 CONTINUE
      CALL INVERS (3,U,3,BDUM,0,DETU,ISNGU,INDEX)
      CALL GMMATS (U,3,3,0,ALPHAD(MORB),3,1,0,ALPHA(MORB))
      GO TO 500
C
  690 IF (.NOT.COMPOS) GO TO  1070
C
C****
C      IF LAMINATED COMPOSITE ELEMENT, DETERMINE THE THERMAL
C      STRAIN VECTOR DUE TO THE APPLIED THERMAL LOADING.
C      NOTE THE FOLLOWING -
C         1. DIFFERENT GRID POINT TEMPERATURES ARE NOT SUPPORTED
C
C****
C     LOCATE PID BY CARRYING OUT A SEQUENTIAL SEARCH
C     OF THE PCOMPS DATA BLOCK, AND ALSO DETERMINE
C     THE TYPE OF 'PCOMP' BULK DATA ENTRY.
C****
C
C****
C     POINTER DESCRIPITION
C     --------------------
C     IPCMP  - LOCATION OF START OF PCOMP DATA IN CORE
C     NPCMP  - NUMBER OF WORDS OF PCOMP DATA
C     IPCMP1 - LOCATION OF START OF PCOMP1 DATA IN CORE
C     NPCMP1 - NUMBER OF WORDS OF PCOMP1 DATA
C     IPCMP2 - LOCATION OF START OF PCOMP2 DATA IN CORE
C     NPCMP2 - NUMBER OF WORDS OF PCOMP2 DATA
C
C     ITYPE  - TYPE OF PCOMP BULK DATA ENTRY
C
C
C     LAMOPT - LAMINATION GENERATION OPTION
C            = SYM  (SYMMETRIC)
C            = MEM  (MEMBRANE)
C            = SYMMEM  (SYMMETRIC-MEMBRANE)
C
C
C****
C
C
C**** SET POINTER LPCOMP
      LPCOMP = IPCMP + NPCMP + NPCMP1 + NPCMP2
C
C**** SET POINTERS
      ITYPE = -1
C
      PCMP  = .FALSE.
      PCMP1 = .FALSE.
      PCMP2 = .FALSE.
C
      PCMP   = NPCMP  .GT. 0
      PCMP1  = NPCMP1 .GT. 0
      PCMP2  = NPCMP2 .GT. 0
C
C**** CHECK IF NO 'PCOMP' DATA HAS BEEN READ INTO CORE
C
      IF (PCMP .OR. PCMP1 .OR. PCMP2) GO TO 700
      J = -229
      GO TO 1580
C
C**** SEARCH FOR PID IN PCOMP DATA
C
  700 IF (.NOT.PCMP) GO TO 750
C
      IP = IPCMP
      IF (INTZ(IP) .EQ. PID) GO TO 740
      IPC11 = IPCMP1 - 1
      DO 720 IP = IPCMP,IPC11
      IF (INTZ(IP).EQ.-1 .AND. IP.LT.(IPCMP1-1)) GO TO 710
      GO TO 720
  710 IF (INTZ(IP+1) .EQ. PID) GO TO 730
  720 CONTINUE
      GO TO 750
C
  730 IP = IP+1
  740 ITYPE = PCOMP
      GO TO 860
C
C**** SEARCH FOR PID IN PCOMP1 DATA
C
  750 IF (.NOT.PCMP1) GO TO 800
      IP = IPCMP1
      IF (INTZ(IP) .EQ. PID) GO TO 790
      IPC21 = IPCMP2 - 1
      DO 770 IP = IPCMP1,IPC21
      IF (INTZ(IP).EQ.-1 .AND. IP.LT.(IPCMP2-1)) GO TO 760
      GO TO 770
  760 IF (INTZ(IP+1) .EQ. PID) GO TO 780
  770 CONTINUE
      GO TO 800
C
  780 IP = IP+1
  790 ITYPE = PCOMP1
      GO TO 860
C
C**** SEARCH FOR PID IN PCOMP2 DATA
C
  800 IP = IPCMP2
      IF (INTZ(IP) .EQ. PID) GO TO 840
      LPC11 = LPCOMP - 1
      DO 820 IP = IPCMP2,LPC11
      IF (INTZ(IP).EQ.-1 .AND. IP.LT.(LPCOMP-1)) GO TO 810
      GO TO 820
  810 IF (INTZ(IP+1) .EQ. PID) GO TO 830
  820 CONTINUE
      GO TO 850
C
  830 IP = IP+1
  840 ITYPE = PCOMP2
      GO TO 860
C
C
C**** CHECK IF PID HAS NOT BEEN LOCATED
C
  850 IF (ITYPE .NE. -1) GO TO 860
      J = -229
      GO TO 1580
C
C**** LOCATION OF PID
C
  860 PIDLOC = IP
      LAMOPT = INTZ(PIDLOC+8)
C
C
C**** DETERMINE INTRINSIC LAMINATE PROPERTIES
C
C     LAMINATE THICKNESS
C
      TLAM = ELTH
C
C**** LAMINATE EXTENSIONAL, BENDING AND MEMBRANE-BENDING MATRICES
C
      DO 870 LL = 1,6
      DO 870 MM = 1,6
      ABBD(LL,MM) = 0.0
  870 CONTINUE
C
C     EXTENSIONAL
C
      MATID = MID(1)
      CALL MAT (ELID)
C
      CALL LPROPS (GPROP)
C
      DO 880 LL = 1,3
      DO 880 MM = 1,3
      II = MM + 3*(LL-1)
      ABBD(LL,MM) = GPROP(II)*TLAM
  880 CONTINUE
C
      IF (LAMOPT.EQ.MEM .OR. LAMOPT.EQ.SYMMEM) GO TO 910
C
C     BENDING
C
      MATID = MID(2)
      CALL MAT (ELID)
C
      CALL LPROPS (GPROP)
C
C**** MOMENT OF INERTIA OF LAMINATE
      MINTR = (TLAM**3)/12.0
C
      DO 890 LL = 1,3
      DO 890 MM = 1,3
      II = MM + 3*(LL-1)
      ABBD(LL+3,MM+3) = GPROP(II)*MINTR
  890 CONTINUE
C
      IF (LAMOPT .EQ. SYM) GO  TO 910
C
C     MEMBRANE-BENDING
C
      MATID = MID(4)
      CALL MAT (ELID)
C
      CALL LPROPS (GPROP)
C
      DO 900 LL = 1,3
      DO 900 MM = 1,3
      II = MM + 3*(LL-1)
      ABBD(LL,MM+3) = GPROP(II)*TLAM*TLAM
      ABBD(LL+3,MM) = GPROP(II)*TLAM*TLAM
  900 CONTINUE
C
  910 CONTINUE
C
C**** REFERENCE SURFACE
      ZREF = -TLAM/2.0
C
C**** NUMBER OF LAYERS
      NLAY = INTZ(PIDLOC + 1)
C
C**** SET POINTER
      IF (ITYPE .EQ. PCOMP ) IPOINT = (PIDLOC + 8 + 4*NLAY)
      IF (ITYPE .EQ. PCOMP1) IPOINT = (PIDLOC + 8 + NLAY)
      IF (ITYPE .EQ. PCOMP2) IPOINT = (PIDLOC + 8 + 2*NLAY)
C
C****
C     ALLOW FOR THE ORIENTATION OF THE MATERIAL AXIS FROM
C     THE ELEMENT AXIS
C****
C
      THETAE = ATAN(TEM(2)/TEM(1))
      THETAE = THETAE*DEGRAD
C
C
C**** LAMINATE REFERENCE (OR LAMINATION) TEMPERATURE
      TSUBO = Z(IPOINT+24)
C
      IF (TEMPP1 .OR. TEMPP2) GO TO 920
      TMEAN = TEMPEL
      GO TO 930
C
  920 TMEAN = STEMP(1)
C
  930 DELTA = TMEAN - TSUBO
C
      DO 940 LL = 1,6
      FTHERM(LL) = 0.0
  940 CONTINUE
C
C**** ALLOW FOR APPLIED THERMAL MOMENTS
C
      IF (.NOT.TEMPP2) GO TO 960
C
      DO 950 LL = 1,3
  950 FTHERM(LL+3) = THRMOM(LL)
C
  960 CONTINUE
C
C
C     L O O P  O V E R  N L A Y
C
      DO 1050 K = 1,NLAY
C
      ZK1 = ZK
      IF (K .EQ. 1) ZK1 = ZREF
      IF (ITYPE .EQ. PCOMP ) ZK = ZK1 + Z(PIDLOC + 6 + 4*K)
      IF (ITYPE .EQ. PCOMP1) ZK = ZK1 + Z(PIDLOC + 7)
      IF (ITYPE .EQ. PCOMP2) ZK = ZK1 + Z(PIDLOC + 7 + 2*K)
C
      ZSUBI = (ZK+ZK1)/2.0
C
C**** LAYER THICKNESS
      TI = ZK - ZK1
C
C**** LAYER ORIENTATION
      IF (ITYPE .EQ. PCOMP ) THETA = Z(PIDLOC + 7 + 4*K)
      IF (ITYPE .EQ. PCOMP1) THETA = Z(PIDLOC + 8 + K)
      IF (ITYPE .EQ. PCOMP2) THETA = Z(PIDLOC + 8 + 2*K)
C
C
      THETA = THETA * DEGRAD
C
      IF (THETAE .GT. 0.0) THETA = THETA + THETAE
C
      C   = COS(THETA)
      C2  = C*C
      S   = SIN(THETA)
      S2  = S*S
C
      TRANSL(1)  = C2
      TRANSL(2)  = S2
      TRANSL(3)  = C*S
      TRANSL(4)  = S2
      TRANSL(5)  = C2
      TRANSL(6)  =-C*S
      TRANSL(7)  =-2.0*C*S
      TRANSL(8)  = 2.0*C*S
      TRANSL(9)  = C2-S2
C
C**** CALCULATE GBAR = TRANST X GLAY X TRANS
C
      DO 1000 IR = 1,9
      GLAY(IR) = Z(IPOINT+IR)
 1000 CONTINUE
C
      CALL GMMATS (GLAY(1),3,3,0,TRANSL(1),3,3,0,GLAYT(1))
      CALL GMMATS (TRANSL(1),3,3,1,GLAYT(1),3,3,0,GBAR(1))
C
C**** CALCULATE ALPHAE = TRANSL X ALPHA
C
C
C     MODIFY TRANSL FOR TRANSFORMATIONS OF ALPHAS
C
      TRANSL(3) = -TRANSL(3)
      TRANSL(6) = -TRANSL(6)
      TRANSL(7) = -TRANSL(7)
      TRANSL(8) = -TRANSL(8)
C
      DO 1010 IR = 1,3
      ALPHAL(IR) = Z(IPOINT+13+IR)
 1010 CONTINUE
C
      CALL GMMATS (TRANSL(1),3,3,0,ALPHAL(1),3,1,0,ALPHAE(1))
C
C
C**** CALCULATE LAMINATE OPERATING TEMPERATURE (ALLOWING FOR
C     TEMPERATURE GRADIENT IF APPLIED)
C
      DELTAT = DELTA
      IF (TEMPP1) DELTAT = DELTA + ZSUBI*TGRAD
C
C**** CALCULATE THERMAL FORCES AND MOMENTS
C
      CALL GMMATS (GBAR(1),3,3,0,ALPHAE(1),3,1,0,GALPHA(1))
C
      DO 1020 IR = 1,3
      FTHERM(IR) = FTHERM(IR) + GALPHA(IR)*DELTAT*(ZK - ZK1)
      IF (LAMOPT.EQ.MEM .OR. LAMOPT.EQ.SYMMEM) GO TO 1020
      FTHERM(IR+3) = FTHERM(IR+3) -
     1               GALPHA(IR)*DELTAT*((ZK**2)-(ZK1**2))/2.0
 1020 CONTINUE
C
      IF (LAMOPT.NE.SYM .AND. LAMOPT.NE.SYMMEM) GO TO 1040
C
C**** CALCULATE CONTRIBUTION FROM SYMMETRIC LAYERS
C
      DELTAT = DELTA
      IF (TEMPP1) DELTAT = DELTA - ZSUBI*TGRAD
C
      DO 1030 IR = 1,3
      FTHERM(IR) = FTHERM(IR) + GALPHA(IR)*DELTAT*(ZK-ZK1)
      IF (LAMOPT .EQ. SYMMEM) GO TO 1030
      FTHERM(IR+3) = FTHERM(IR+3) -
     1               GALPHA(IR)*DELTAT*((ZK1**2)-(ZK**2))/2.0
 1030 CONTINUE
C
 1040 IF (ITYPE .EQ. PCOMP) IPOINT = IPOINT + 27
C
 1050 CONTINUE
C
C
C****
C     COMPUTE THERMAL STRAIN VECTOR
C****
C                 -1
C     EPSLN = ABBD   X FTHERM
C
      CALL INVERS (6,ABBD,6,DUM,0,DETERM,ISING,INDX)
C
      DO 1060 LL = 1,6
      DO 1060 MM = 1,6
      NN = MM + 6*(LL-1)
      STIFF(NN) = ABBD(LL,MM)
 1060 CONTINUE
C
      CALL GMMATS (STIFF(1),6,6,0,FTHERM(1),6,1,0,EPSLNT(1))
C
 1070 CONTINUE
C
C
C-----INITIALIZE NECESSARY ARRAYS BEFORE STARTING THE
C     DOUBLE INTEGRATION LOOP
C
      DO 1100 I =1,9
      G2(I) = 0.0
 1100 CONTINUE
      DO 1110 I =1,6
      EPSUBT(I) = 0.0
 1110 CONTINUE
      DO 1120 I =1,NDOF
      PT(I)  = 0.0
      PTG(I) = 0.0
 1120 CONTINUE
C
C     FILL IN THE 6X6 MATERIAL PROPERTY MATRIX G
C
      DO 1130 IG=1,6
      DO 1130 JG=1,6
 1130 G(IG,JG)=0.0
C
      IF (.NOT.MEMBRN) GO TO 1150
      DO 1140 IG=1,3
      IG1=(IG-1)*3
      DO 1140 JG=1,3
      JG1=JG+IG1
      G(IG,JG)=GI(JG1)
 1140 CONTINUE
C
 1150 IF (.NOT.BENDNG) GO TO 1180
      I = 0
      DO 1160 IG=4,6
      IG2=(IG-2)*3
      DO 1160 JG=4,6
      JG2=JG+IG2
      G(IG,JG)=GI(JG2)*MOMINR
C
C     SAVE THE G-MATRIX FOR BENDING IN G2
C
      I = I + 1
      G2(I) = G(IG,JG)
 1160 CONTINUE
C
      IF (.NOT.MEMBRN) GO TO 1180
      IF (MBCOUP) GO TO 1180
      DO 1170 IG=1,3
      IG1=(IG-1)*3
      KG=IG+3
      DO 1170 JG=1,3
      JG1=JG+IG1
      LG=JG+3
      G(IG,LG)=GI(JG1)
      G(KG,JG)=GI(JG1)
 1170 CONTINUE
 1180 CONTINUE
C
C****
C     HERE BEGINS THE DOUBLE LOOP ON STATEMENT 1470 TO
C     GAUSS INTEGRATE FOR THE ELEMENT STIFFNESS MATRIX.
C****
C
      DO 1470 IXSI=1,2
      XI=PTINT(IXSI)
C
      DO 1470 IETA=1,2
      ETA=PTINT(IETA)
C
      CALL Q4SHPS (XI,ETA,SHP,DSHP)
C
C     SORT THE SHAPE FUNCTIONS AND THEIR DERIVATIVES INTO SIL ORDER.
C
      DO 1200 I=1,4
      TMPSHP(I  )=SHP(I)
      DSHPTP(I  )=DSHP(I)
 1200 DSHPTP(I+4)=DSHP(I+4)
      DO 1210 I=1,4
      KK=IORDER(I)
      SHP (I  )=TMPSHP(KK)
      DSHP(I  )=DSHPTP(KK)
 1210 DSHP(I+4)=DSHPTP(KK+4)
C
C     CALCULATE THE ELEMENT THICKNESS AT THIS POINT
C
      THK=0.0
      DO 1220 I=1,NNODE
 1220 THK=THK+DGPTH(I)*SHP(I)
      REALI=THK*THK*THK/12.0
C
C-----CALCULATE T-BAR FOR THIS INTEGRATION POINT
C     SKIP OVER IF TEMPPI CARDS ARE PRESENT
C     THEN CALCULATE ALPHA*T FOR EACH CASE
C
      IF (COMPOS) GO TO 1370
C
      IF (TEMPP1 .OR. TEMPP2) GO TO 1310
      TBAR = 0.0
      DO 1300 I =1,NNODE
 1300 TBAR = TBAR + SHP(I) * GTEMPS(I)
 1310 CONTINUE
C
      TTBAR = TBAR - TSUB0
C
      IF (.NOT.MEMBRN) GO TO 1330
      DO 1320 I =1,3
 1320 TALFAM(I) = TTBAR * ALFAM(I)
C
 1330 IF (.NOT.BENDNG) GO TO 1370
      IF (.NOT.TEMPP1 .AND. .NOT.TEMPP2) GO TO 1370
      IF (TEMPP2) GO TO 1350
      DO 1340 I =1,3
 1340 TALFAB(I) = -TGRAD * ALFAB(I)
      GO TO 1370
C
 1350 CONTINUE
      DO 1360 IG2=1,9
 1360 G2I(IG2) = G2(IG2)*REALI
      CALL INVERS (3,G2I,3,GDUM,0,DETG2,ISNGG2,INDEX)
      CALL GMMATS (G2I,3,3,0,THRMOM,3,1,0,TALFAB)
 1370 CONTINUE
C
C     START THE THIRD INTEGRATION LOOP (THRU THE THICKNESS)
C
      DO 1460 IZTA=1,2
      ZTA =PTINT(IZTA)
      HZTA=ZTA/2.0
      IBOT=(IZTA-1)*ND2
C
      CALL JACOBS (ELID,SHP,DSHP,DGPTH,EGPDT,EPNORM,JACOB)
      IF (BADJAC) GO TO 1600
C
      CALL GMMATS (PSITRN,3,3,0,JACOB,3,3,1,PHI)
C
C     CALL Q4BMGS TO GET B MATRIX
C     SET THE ROW FLAG TO 3. IT WILL RETURN THE FIRST 6 ROWS.
C
      ROWFLG = 3
      CALL Q4BMGS (DSHP,DGPTH,EGPDT,EPNORM,PHI,BMATRX(1))
      DO 1380 IX=1,NDOF
 1380 BMATRX(IX+ND2)=XYBMAT(IBOT+IX)
C
      IF (.NOT.BENDNG) GO TO 1410
      DO 1390 IX=1,NDOF
 1390 BMATRX(IX+ND5)=XYBMAT(IBOT+IX+NDOF)
C
C     NOW COMPLETE THE G-MATRIX IF COUPLING EXISTS.
C
      IF (.NOT.MBCOUP) GO TO 1410
      DO 1400 IG=1,3
      IG4=(IG+8)*3
      KG=IG+3
      DO 1400 JG=1,3
      JG4=JG+IG4
      JG1=JG4-27
      LG=JG+3
      G(IG,LG)=-GI(JG4)*ZTA*6.0+GI(JG1)
      G(KG,JG)=-GI(JG4)*ZTA*6.0+GI(JG1)
 1400 CONTINUE
 1410 CONTINUE
C
C-----MULTIPLY DETERMINANT, B-TRANSPOSE, G-MATRIX, & THERMAL
C     STRAIN MATRIX.
C
C                         T
C         P  =  DETERM * B  * G * EPSILON
C          T                             T
C
      IF (COMPOS) GO TO 1430
      DO 1420 I =1,3
      EPSUBT(I) = DETJ * TALFAM(I)
 1420 EPSUBT(I+3) = - DETJ * TALFAB(I) * HZTA * THK
      GO TO 1450
C
 1430 DO 1440 IR = 1,3
      EPSUBT(IR  ) = DETJ*EPSLNT(IR)
 1440 EPSUBT(IR+3) =-DETJ*EPSLNT(IR+3)*THK*HZTA
 1450 CONTINUE
C
      CALL GMMATS (G,6,6,0,EPSUBT,6,1,0,GEPSBT)
      CALL GMMATS (BMATRX,6,NDOF,-1,GEPSBT,6,1,0,PT)
C
 1460 CONTINUE
 1470 CONTINUE
C
C----TRIPLE INTEGRATION LOOP IS NOW FINISHED
C
C****
C     PICK UP THE BASIC TO GLOBAL TRANSFORMATION FOR EACH NODE.
C****
      DO 1500 I=1,36
 1500 TRANS(I)=0.0
C
      DO 1540 I=1,NNODE
      IPOINT=9*(I-1)+1
      IF (IGPDT(1,I) .LE. 0) GO TO 1510
C
      CALL TRANSS (BGPDT(1,I),TBG)
      GO TO 1530
C
 1510 DO 1520 J=1,9
 1520 TBG(J)=0.0
      TBG(1)=1.0
      TBG(5)=1.0
      TBG(9)=1.0
C
 1530 CALL GMMATS (TEB,3,3,0,TBG,3,3,0,TRANS(IPOINT))
 1540 CONTINUE
C
C
C-----TRANSFORM THE THERMAL LOAD VECTOR INTO THE INDIVIDUAL
C     GLOBAL COORDINATE SYSTEMS OF EACH NODE. NOTE THAT THE
C     TRANSFORMATION MATRICES ARE STORED IN  TRANS = TEG,
C     AND THAT THE 6-DOF LOAD VECTOR FOR EACH NODE USES THE
C     SAME 3X3 TRANSFORMATION MATRIX FOR THE TRANSLATIONAL
C     DOF'S (1-3) AND THE ROTATIONAL DOF'S (4-6).
C
C                         T
C               PT  =  TEG   *  PT
C                 G               E
C
      DO 1550 I =1,NNODE
      IPT  = (I-1)*9 + 1
      JPT1 = (I-1)*6 + 1
      JPT2 = JPT1 + 3
C
      CALL GMMATS (TRANS(IPT),3,3,1,PT(JPT1),3,1,0,PTG(JPT1))
      CALL GMMATS (TRANS(IPT),3,3,1,PT(JPT2),3,1,0,PTG(JPT2))
C
 1550 CONTINUE
C
C
C-----WE NOW HAVE THE THERMAL LOAD VECTOR IN GLOBAL COORDINATES,
C     IN PTG. THE NEXT AND LAST STEP IS TO COMBINE IT WITH THE
C     SYSTEM LOAD VECTOR CONTAINED IN Z.
C
      L=0
      DO 1560 I =1,NNODE
      K = SIL(I) - 1
      DO 1560 J =1,6
      K = K + 1
      L = L + 1
      Z(K) = Z(K) + PTG(L)
 1560 CONTINUE
      GO TO 1600
C
 1580 CALL MESAGE (30,J,NAM)
      NOGO = 1
C
C
 1600 CONTINUE
      RETURN
C
 1700 FORMAT ('0*** SYSTEM FATAL ERROR. THE ELEMENT THICKNESS FOR',
     1        ' QUAD4 EID = ',I8,' IS NOT COMPLETELY DEFINED.')
      END

      SUBROUTINE CFE2AO (TPOSE,V1,V2,V3,ZB)
C*******
C     CFE2AO IS A DOUBLE PRECISION ROUTINE WHICH PERFORMS THE OPERATION
C     (A) OR (A)-TRANSPOSE FOR THE COMPLEX FEER METHOD. THIS OPERATION
C     IS CALLED THE EIGENMATRIX MULTIPLICATION.
C*******
C     DEFINITION OF INPUT AND OUTPUT PARAMETERS
C*******
C     TPOSE    = .FALSE. --- PERFORM OPERATION (A)
C              = .TRUE.  --- PERFORM OPERATION (A)-TRANSPOSE
C     V1       = INPUT  VECTOR
C     V2       = OUTPUT VECTOR
C     V3       = INPUT WORKING SPACE (FOR INTERNAL USE)
C     ZB       = INPUT GINO BUFFER
C*******
      DOUBLE PRECISION  V1(1)    ,V2(1)    ,V3(1)    ,LAMBDA
      LOGICAL           TPOSE(1) ,NO B     ,QPR
      DIMENSION         ZB(1)
      COMMON  /FEERAA/  IK(7)    ,IM(7)    ,IB(7)    ,DUMAA(117)
     2                 ,MCBLMB(7)
      COMMON  /FEERXC/  LAMBDA(2),DUM01(2) ,NORD     ,IDIAG
     2                 ,EPSDUM(2),NORTHO   ,NORD2    ,NORD4
     3                 ,NORDP1   ,DUM02(2) ,NO B     ,DUM03(4)
     4                 ,QPR
      COMMON  /SYSTEM/  KSYS     ,NOUT
C*******
      IF (QPR) WRITE (NOUT,8881) TPOSE
 8881 FORMAT(1H0,12HENTER CFE2AO,8X,11HTRANSPOSE =,L2)
      IF (TPOSE(1)) GO TO 50
C*******
C     PERFORM OPERATION (A)  = EIGENMATRIX MULTIPLICATION
C*******
      IF ( NO B ) GO TO 30
C*******
C     MULTIPLY LOWER HALF OF INPUT VECTOR BY MASS MATRIX
C*******
      CALL CFE2MY (TPOSE(1),V1(NORDP1),V3(1),IM(1),ZB(1))
      IF (QPR) WRITE (NOUT,8882) (V3(I),I=1,NORD)
 8882 FORMAT(3H --,32(4H----),/(1H ,6D21.13))
C*******
C     MULTIPLY UPPER HALF OF INPUT VECTOR BY -(LAMBDA*M+B)
C*******
      CALL CFE2MY (TPOSE(1),V1(1),V3(NORDP1),MCBLMB(1),ZB(1))
      IF (QPR) WRITE (NOUT,8882) (V3(I),I=NORDP1,NORD2)
C*******
C     CALCULATE RIGHT-HAND SIDE OF SWEEP EQUATION
C*******
      DO 10  I = 1,NORD
      J = NORD+I
   10 V2(I) = -V3(I) + V3(J)
      IF (QPR) WRITE (NOUT,8882) (V2(I),I=1,NORD)
C*******
C     PERFORM FORWARD AND BACKWARD SWEEPS
C     (GENERATES UPPER HALF OF OUTPUT VECTOR)
C*******
      CALL CF2FBS (TPOSE(1),V2(1),ZB(1))
      IF (QPR) WRITE (NOUT,8882) (V2(I),I=1,NORD)
C*******
C     COMPUTE LOWER HALF OF OUTPUT VECTOR
C*******
      DO 20  I = 1,NORD,2
      J = I+1
      NI = NORD+I
      NJ = NI+1
      V2(NI) = V1(I) + LAMBDA(1)*V2(I) - LAMBDA(2)*V2(J)
   20 V2(NJ) = V1(J) + LAMBDA(1)*V2(J) + LAMBDA(2)*V2(I)
      IF (QPR) WRITE (NOUT,8882) (V2(I),I=NORDP1,NORD2)
      GO TO 200
C*******
C     DAMPING MATRIX ABSENT
C*******
C     MULTIPLY INPUT VECTOR BY MASS MATRIX
C*******
   30 CALL CFE2MY (TPOSE(1),V1(1),V2(1),IM(1),ZB(1))
      DO 40  I = 1,NORD2
   40 V2(I) = -V2(I)
      IF (QPR) WRITE (NOUT,8882) (V2(I),I=1,NORD2)
C*******
C     PERFORM FORWARD AND BACKWARD SWEEPS
C*******
      CALL CF2FBS (TPOSE(1),V2(1),ZB(1))
      IF (QPR) WRITE (NOUT,8882) (V2(I),I=1,NORD2)
      GO TO 200
C*******
C     PERFORM OPERATION (A)-TRANSPOSE  = TRANSPOSED EIGENMATRIX
C                                                   MULTIPLICATION
C*******
   50 IF ( NO B ) GO TO 90
C*******
C     CALCULATE RIGHT-HAND SIDE OF SWEEP EQUATION
C*******
      DO 60  I = NORDP1,NORD2,2
      J = I+1
      NI = I-NORD
      NJ = NI+1
      V3(I) = V1(NI) + LAMBDA(1)*V1(I) - LAMBDA(2)*V1(J)
   60 V3(J) = V1(NJ) + LAMBDA(1)*V1(J) + LAMBDA(2)*V1(I)
      IF (QPR) WRITE (NOUT,8882) (V3(I),I=NORDP1,NORD2)
C*******
C     PERFORM BACKWARD AND FORWARD SWEEPS
C*******
      CALL CF2FBS (TPOSE(1),V3(NORDP1),ZB(1))
      IF (QPR) WRITE (NOUT,8882) (V3(I),I=NORDP1,NORD2)
C*******
C     MULTIPLY SWEEP OUTPUT VECTOR BY -(LAMBDA*M+B)-TRANSPOSE
C*******
      CALL CFE2MY (TPOSE(1),V3(NORDP1),V3(1),MCBLMB(1),ZB(1))
      IF (QPR) WRITE (NOUT,8882) (V3(I),I=1,NORD)
C*******
C     COMPUTE UPPER HALF OF OUTPUT VECTOR
C*******
      DO 70  I = 1,NORD
      J = NORD+I
   70 V2(I) = V1(J) + V3(I)
      IF (QPR) WRITE (NOUT,8882) (V2(I),I=1,NORD)
C*******
C     MULTIPLY SWEEP OUTPUT VECTOR BY TRANSPOSED MASS MATRIX
C     (GENERATES NEGATIVE OF LOWER HALF OF OUTPUT VECTOR)
C*******
      CALL CFE2MY (TPOSE(1),V3(NORDP1),V2(NORDP1),IM(1),ZB(1))
      DO 80  I = NORDP1,NORD2
   80 V2(I) = -V2(I)
      IF (QPR) WRITE (NOUT,8882) (V2(I),I=NORDP1,NORD2)
      GO TO 200
C*******
C     DAMPING MATRIX ABSENT
C*******
C     PERFORM BACKWARD AND FORWARD SWEEPS
C*******
   90 DO 95  I = 1,NORD2
   95 V3(I) = V1(I)
      CALL CF2FBS (TPOSE(1),V3(1),ZB(1))
      IF (QPR) WRITE (NOUT,8882) (V3(I),I=1,NORD2)
C*******
C     MULTIPLY SWEEP OUTPUT VECTOR BY TRANSPOSED MASS MATRIX
C*******
      CALL CFE2MY (TPOSE(1),V3(1),V2(1),IM(1),ZB(1))
      DO 100  I = 1,NORD2
  100 V2(I) = -V2(I)
      IF (QPR) WRITE (NOUT,8882) (V2(I),I=1,NORD2)
  200 RETURN
      END

      SUBROUTINE GFSCOM(AWY,NUY,KC,IDENT,AC,SCR)
C
C     ROUTINE TO COMPUTE THE FLUID COMPRESSIBILTY MATRIX
C
C     THIS MATRIX CONTAINS THE SPRING FACTOR WHICH COUPLES THE
C     STRUCTURE AND FREE SURFACE TO PREVENT VOLUME CHANGES
C
      DOUBLE PRECISION        DZ(1)    ,DKCOMP   ,VAL
C
      REAL          KCOMP    ,RZ(1)
C
      INTEGER       KC       ,AC       ,Z        ,SYSBUF   ,AWY
     1             ,MCB(7)   ,NAME(2)  ,TI1      ,TO1      ,TO2
     2             ,SCR
C
C
C     MODULE PARAMETERS
C
      COMMON /BLANK/     NOGRAV   ,NOFREE   ,KCOMP   ,COMPTP
     1                       ,FORM     ,LMODES
C
C     OPEN CORE
C
      COMMON / ZZZZZZ /        Z(1)
C
C     SYSTEM COMMON
C
      COMMON / SYSTEM /       SYSBUF
C
C     PACK - UNPACK COMMON BLOCKS
C
      COMMON / PACKX /        TI1      ,TO1      ,I1       ,N1
     1                       ,INCR1
      COMMON / UNPAKX /       TO2      ,I2       ,N2       ,INCR2
      COMMON / ZBLPKX /       A(4)     ,IROW
C
      EQUIVALENCE   ( Z(1) , RZ(1) , DZ(1) )
     1             ,( VAL , A(1) )
C
      DATA NAME / 4HGFSC , 4HOM   /
C
C     ALLOCATE CORE
C
      NZ = KORSZ(Z(1))
      IBUF = NZ - SYSBUF
      NZ = IBUF - 1
      IF(NZ .LT. NUY) GO TO 1008
C
C     FORM A COLUMN VECTOR OF ONES
C
      TI1 = 1
      TO1 = 2
      I1 = 1
      N1 = NUY
      INCR1 = 1
      DO 30 I=1,NUY
   30 RZ(I) = 1.0
      CALL MAKMCB(MCB,IDENT,NUY,2,2)
      CALL GOPEN(IDENT,Z(IBUF),1)
      CALL PACK(RZ(1),IDENT,MCB)
      CALL CLOSE(IDENT,1)
      CALL WRTTRL(MCB)
C
      CALL SSG2B(AWY,IDENT,0,AC,0,2,1,SCR)
C
C     PERFORM MULTIPLY TO GET COMPRESSIBLITY MATRIX
C
C
C     UNPACK ROW OF AC INTO CORE
C
      MCB(1) = AC
      CALL RDTRL(MCB)
      NROW = MCB(3)
      IF(NZ .LT. 2*NROW) GO TO 1008
      TO2 = 2
      I2 = 1
      N2 = NROW
      INCR2 = 1
C
      CALL GOPEN(AC,Z(IBUF),0)
      CALL UNPACK(*40,AC,DZ(1))
      GO TO 60
C
C     AC IS NULL
C
   40 DO 50 I=1,NROW
   50 DZ(I) = 0.0D0
C
C     SET UP TO CREATE KC MATRIX
C
   60 CALL CLOSE(AC,1)
C
      DKCOMP = DBLE(KCOMP)
      CALL GOPEN(KC,Z(IBUF),1)
      CALL MAKMCB(MCB,KC,NROW,1,2)
C
C     LOOP OVER NON-ZERO TERMS OF AC TO CREATE KC
C
      DO 90 I=1,NROW
      CALL BLDPK(2,2,KC,0,0)
      IF(DZ(I) .EQ. 0.0D0) GO TO 80
      DO 70 J=1,NROW
      IROW = J
      VAL = DKCOMP * DZ(J) * DZ(I)
      CALL ZBLPKI
   70 CONTINUE
   80 CALL BLDPKN(KC,0,MCB)
   90 CONTINUE
      CALL CLOSE(KC,1)
C
C     WRITE TRAILER
C
      CALL WRTTRL(MCB)
      RETURN
C
C     ERRORS
C
 1008 CALL MESAGE(-8,0,NAME)
      RETURN
      END

      SUBROUTINE TLODSL (TREAL,TINT)
C
C     ECPT ENTRIES
C
C     ECPT ( 1) = ELEMENT ID                                    INTEGER
C     ECPT ( 2) = SCALAR INDEX NUMBER FOR GRID POINT 1          INTEGER
C     ECPT ( 3) = SCALAR INDEX NUMBER FOR GRID POINT 2          INTEGER
C     ECPT ( 4) = SCALAR INDEX NUMBER FOR GRID POINT 3          INTEGER
C     ECPT ( 5) = SCALAR INDEX NUMBER FOR GRID POINT 4          INTEGER
C     ECPT ( 6) = SCALAR INDEX NUMBER FOR GRID POINT 5          INTEGER
C     ECPT ( 7) = SCALAR INDEX NUMBER FOR GRID POINT 6          INTEGER
C     ECPT ( 8) = THETA                                         REAL
C     ECPT ( 9) = MATERIAL ID 1                                 INTEGER
C     ECPT (10) = THICKNESS T1 AT GRID POINT G1
C     ECPT (11) = THICKNESS T3 AT GRID POINT G3
C     ECPT (12) = THICKNESS T5 AT GRID POINT G5
C     ECPT (13) = MATERIAL ID 2                                 INTEGER
C     ECPT (14) = THICKNESS TBEND1 FOR BENDING AT GRID POINT G1
C     ECPT (15) = THICKNESS TBEND3 FOR BENDING AT GRID POINT G3
C     ECPT (16) = THICKNESS TBEND5 FOR BENDING AT GRID POINT G5
C     ECPT (17) = MATERIAL ID 3                                 INTEGER
C     ECPT (18) = THICKNESS TSHR1 FOR TRANSVERSE SHEAR AT GRID POINT G1
C     ECPT (19) = THICKNESS TSHR3 FOR TRANSVERSE SHEAR AT GRID POINT G3
C     ECPT (20) = THICKNESS TSHR5 FOR TRANSVERSE SHEAR AT GRID POINT G5
C     ECPT (21) = NON-STRUCTURAL MASS                           REAL
C     ECPT (22) = DISTANCE Z11 FOR STRESS CALCULATION  AT GRID POINT G1
C     ECPT (23) = DISTANCE Z21 FOR STRESS CALCULATION  AT GRID POINT G1
C     ECPT (24) = DISTANCE Z13 FOR STRESS CALCULATION  AT GRID POINT G3
C     ECPT (25) = DISTANCE Z23 FOR STRESS CALCULATION  AT GRID POINT G3
C     ECPT (26) = DISTANCE Z15 FOR STRESS CALCULATION  AT GRID POINT G5
C     ECPT (27) = DISTANCE Z25 FOR STRESS CALCULATION  AT GRID POINT G5
C
C     X1,Y1,Z1 FOR ALL SIX POINTS ARE  IN NASTRAN BASIC SYSTEM
C
C     ECPT (28) = CO-ORDINATE SYSTEM ID FOR GRID A              INTEGER
C     ECPT (29) = CO-ORDINATE X1                                REAL
C     ECPT (30) = CO-ORDINATE Y1                                REAL
C     ECPT (31) = CO-ORDINATE Z1                                REAL
C     ECPT (32) = CO-ORDINATE SYSTEM ID FOR GRID B              INTEGER
C     ECPT (33) = CO-ORDINATE X1                                REAL
C     ECPT (34) = CO-ORDINATE Y1                                REAL
C     ECPT (35) = CO-ORDINATE Z1                                REAL
C     ECPT (36) = CO-ORDINATE SYSTEM ID FOR GRID C              INTEGER
C     ECPT (37) = CO-ORDINATE X1                                REAL
C     ECPT (38) = CO-ORDINATE Y1                                REAL
C     ECPT (39) = CO-ORDINATE Z1                                REAL
C     ECPT (40) = CO-ORDINATE SYSTEM ID FOR GRID D              INTEGER
C     ECPT (41) = CO-ORDINATE X1                                REAL
C     ECPT (42) = CO-ORDINATE Y1                                REAL
C     ECPT (43) = CO-ORDINATE Z1                                REAL
C     ECPT (44) = CO-ORDINATE SYSTEM ID FOR GRID E              INTEGER
C     ECPT (45) = CO-ORDINATE X1                                REAL
C     ECPT (46) = CO-ORDINATE Y1                                REAL
C     ECPT (47) = CO-ORDINATE Z1                                REAL
C     ECPT (48) = CO-ORDINATE SYSTEM ID FOR GRID F              INTEGER
C     ECPT (49) = CO-ORDINATE X1                                REAL
C     ECPT (50) = CO-ORDINATE Y1                                REAL
C     ECPT (51) = CO-ORDINATE Z1                                REAL
C     EST  (52) = ELEMENT TEMPERATURE
C
      LOGICAL         NOGO,     NOTS,     UNIBEN,   UNITEM,   UNIMEM
      INTEGER         XU(32),   YU(32),   XV(32),   YV(32),   XW(32),
     1                YW(32),   RK(3),    SK(3),    ELID,     ESTID,
     2                TL(3),    UL(3),    QT(3),    PT(3),    XTHK(10),
     3                YTHK(10), SMALL(6), TINT(6),  ICS(6),   IEST(42),
     4                NL(6),    IND(6,3), ELTYPE,   SIL1,    INDEX(20,3)
      REAL            TREAL(6), G(9),     G1(3),    NAME(2),  F(14,14),
     1                XC(6),    YC(6),    ZC(6),    TS6(40),  EE(30),
     2                Q(6,6),   QQ(960),  CC(10),   CAB(3),   P3(30),
     3                P6(32),   P7(30),   P8(5),    P9(6),    PL(3),
     4                DD(3),    TRAND(9), PTEM(32), GE1(9),   EL(3),
     5                IVECT(3), JVECT(3), KVECT(3),
     6                QQQ(20,20),         QQQINV(360),        BALOTR(36)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /TRIMEX/ EST(100)
      COMMON /ZZZZZZ/ PG(1)
      COMMON /SSGWRK/ IND,FAC,F,P3,P6,P7
      COMMON /EMGDIC/ ELTYPE,LDICT,NLOCS,ELID,ESTID
      COMMON /MATIN / MATID,MATFLG,ELTEMP,PLA34,SINTH,COSTH
      COMMON /MATOUT/ EM(6),RHOY,ALF(3),TREF,GSUBE,SIGTY,SIGCY,SIGSY,
     1                RJ11,RJ12,RJ22
      COMMON /SYSTEM/ IBUF,NOUT
      EQUIVALENCE     (C1,CC(1)),(C2,CC(2)),(C3,CC(3)),(C4,CC(4)),
     1                (C5,CC(5)),(C6,CC(6)),(C7,CC(7)),(C8,CC(8)),
     2                (C9,CC(9)),(C10,CC(10)),(IEST(1),EST(1)),
     3                (A,DISTA),(B,DISTB),(C,DISTC),(THK1,TBEND1),
     4                (THK2,TBEND3),(THK3,TBEND5)
      DATA    XU    / 0,1,0,2,1,0,26*0/,      YU/0,0,1,0,1,2,26*0    /,
     1        XV    / 6*0,0,1,0,2,1,0,20*0/ , YV/6*0,0,0,1,0,1,2,20*0/,
     2        XW    / 12*0,0,1,0,2,1,0,3,2,1,0,4,3,2,1,0,5,3,2,1,0   /,
     3        YW    / 12*0,0,0,1,0,1,2,0,1,2,3,0,1,2,3,4,0,2,3,4,5   /
      DATA    BLANK , NAME / 4H    ,  4HTRSH,4HL          /
      DATA    RK,SK / 0,1,0,  0,0,1/, DEGRA /0.0174532925 /
      DATA    XTHK  / 0,1,0,2,1,0,3,2,1,0/,  YTHK/ 0,0,1,0,1,2,0,1,2,3/
      DATA    TL    / 0,1,0/, UL/0,0,1/, PT/0,1,0/, QT/0,0,1/
C
C     COMPONENT CODE,ICODE,IS  111111  AND HAS A VALUE OF 63
C
      NOTS   = .FALSE.
      IDELE  = IEST(1)
      DO 109 I = 1,6
      NL(I)  = IEST(I+1)
  109 CONTINUE
      THETAM = EST (8)
      MATID1 = IEST(9)
      TMEM1  = EST(10)
      TMEM3  = EST(11)
      TMEM5  = EST(12)
      MATID2 = IEST(13)
      TBEND1 = (EST(14)*12.0)**0.3333333333
      TBEND3 = (EST(15)*12.0)**0.3333333333
      TBEND5 = (EST(16)*12.0)**0.3333333333
      MATID3 = IEST(17)
      TSHR1  = EST(18)
      TSHR3  = EST(19)
      TSHR5  = EST(20)
      NSM    = EST(21)
      J      = 0
      DO 120 I = 28,48,4
      J      = J + 1
      ICS(J) = IEST(I)
      XC(J)  = EST(I+1)
      YC(J)  = EST(I+2)
      ZC(J)  = EST(I+3)
  120 CONTINUE
C
C     IF TMEM3 OR TMEM5 EQUAL TO ZERO OR BLANK, THEY WILL BE
C     SET EQUAL TO TMEM1 SO ALSO FOR TSHR3,TSHR5,TBEND3 AND TBEND5
C
      T1PRIM = -TREAL(2)
      T3PRIM = -TREAL(2)
      T5PRIM = -TREAL(2)
      IF (TMEM3.EQ.0.0 .OR. TMEM3.EQ.BLANK) TMEM3 = TMEM1
      IF (TMEM5.EQ.0.0 .OR. TMEM5.EQ.BLANK) TMEM5 = TMEM1
      IF (TSHR3.EQ.0.0 .OR. TSHR3.EQ.BLANK) TSHR3 = TSHR1
      IF (TSHR5.EQ.0.0 .OR. TSHR5.EQ.BLANK) TSHR5 = TSHR1
      IF (TSHR1 .EQ. 0.0) NOTS = .TRUE.
      IF (TBEND3.EQ.0.0 .OR. TBEND3.EQ.BLANK) TBEND3 = TBEND1
      IF (TBEND5.EQ.0.0 .OR. TBEND5.EQ.BLANK) TBEND5 = TBEND1
      IF (T3PRIM.EQ.0.0 .OR. T3PRIM.EQ.BLANK) T3PRIM = T1PRIM
      IF (T5PRIM.EQ.0.0 .OR. T5PRIM.EQ.BLANK) T5PRIM = T1PRIM
      ELTEMP = EST(52)
      AVTHK  = (TBEND1 + TBEND3 + TBEND5)/3.0
      AVINER = AVTHK**3/12.0
      THETA1 = THETAM*DEGRA
      SINTH  = SIN(THETA1)
      COSTH  = COS(THETA1)
      IF (ABS(SINTH) .LE. 1.0E-06) SINTH = 0.0
C
C     EVALUTE MATERIAL PROPERTIES
C
      MATFLG = 2
      MATID  = MATID1
      IF (MATID .LE. 0) GO TO 122
      CALL MAT (IDELE)
C
      G11 = EM(1)
      G12 = EM(2)
      G13 = EM(3)
      G22 = EM(4)
      G23 = EM(5)
      G33 = EM(6)
      GM1 = EM(1)*ALF(1) + EM(2)*ALF(2) + EM(3)*ALF(3)
      GM2 = EM(2)*ALF(1) + EM(4)*ALF(2) + EM(5)*ALF(3)
      GM3 = EM(3)*ALF(1) + EM(5)*ALF(2) + EM(6)*ALF(3)
      G11PR = 0.0
      G22PR = 0.0
      G33PR = 0.0
  122 CONTINUE
      MATFLG = 2
      MATID  = MATID2
      IF (MATID .LE. 0) GO TO 149
      CALL MAT (IDELE)
      D11  = EM(1)
      D12  = EM(2)
      D13  = EM(3)
      D22  = EM(4)
      D23  = EM(5)
      D33  = EM(6)
      G(1) = EM(1)
      G(2) = EM(2)
      G(3) = EM(3)
      G(4) = EM(2)
      G(5) = EM(4)
      G(6) = EM(5)
      G(7) = EM(3)
      G(8) = EM(5)
      G(9) = EM(6)
C
C     IF  TINT(6).NE.1,G1 IS G AND T1PRIME IS ALPHA TIMES T1PRIME
C     IF  TINT(6).EQ.1,G1 IS G TIMES ALPHA AND T1PRIME IS T1PRIME
C
      IF  (TINT(6) .NE. 1) GO TO 147
C
C     G1 IS G TIMES ALFA
C
      CALL GMMATS (G,3,3,0, ALF,3,1,0, G1)
C
      G11PR = G1(1)
      G22PR = G1(2)
      G33PR = G1(3)
      GO TO 149
  147 CONTINUE
      DO 148 I = 1,9
  148 GE1(I) = G(I)*AVINER
C
C     NO NEED TO COMPUTE DETERMINANT SINCE IT IS NOT USED SUBSEQUENTLY
C
      ISING = -1
      CALL INVERS (3,GE1(1),3,TS6(1),0,DETERM,ISING,INDEX)
      IF (ISING .EQ. 2) GO TO 905
      CALL GMMATS (GE1,3,3,0, TREAL(2),3,1,0, PL(1))
  149 CONTINUE
C
C     CALCULATIONS FOR THE TRIANGLE
C
      CALL TRIF (XC,YC,ZC,IVECT,JVECT,KVECT,A,B,C,IEST(1),NAME)
C
C     COMPUTE THE AREA INTEGRATION FUNCTION F
C
      CALL AF (F,14,A,B,C,0,0,0,0,0,0,-1)
C
C     CALCULATIONS FOR QMATRIX (QQQ) AND ITS INVERSE
C
      DO 110 I = 1,20
      DO 110 J = 1,20
  110 QQQ(I,J) = 0.0
      DO 115 I = 1,6
      I1 = (I-1)*3 + 1
      I2 = (I-1)*3 + 2
      I3 = (I-1)*3 + 3
      QQQ(I1, 1) = 1.0
      QQQ(I1, 2) = XC(I)
      QQQ(I1, 3) = YC(I)
      QQQ(I1, 4) = XC(I)*XC(I)
      QQQ(I1, 5) = XC(I)*YC(I)
      QQQ(I1, 6) = YC(I)*YC(I)
      QQQ(I1, 7) = QQQ(I1, 4)*XC(I)
      QQQ(I1, 8) = QQQ(I1, 4)*YC(I)
      QQQ(I1, 9) = QQQ(I1, 5)*YC(I)
      QQQ(I1,10) = QQQ(I1, 6)*YC(I)
      QQQ(I1,11) = QQQ(I1, 7)*XC(I)
      QQQ(I1,12) = QQQ(I1, 7)*YC(I)
      QQQ(I1,13) = QQQ(I1, 8)*YC(I)
      QQQ(I1,14) = QQQ(I1, 9)*YC(I)
      QQQ(I1,15) = QQQ(I1,10)*YC(I)
      QQQ(I1,16) = QQQ(I1,11)*XC(I)
      QQQ(I1,17) = QQQ(I1,12)*YC(I)
      QQQ(I1,18) = QQQ(I1,13)*YC(I)
      QQQ(I1,19) = QQQ(I1,14)*YC(I)
      QQQ(I1,20) = QQQ(I1,15)*YC(I)
      QQQ(I2, 3) = 1.0
      QQQ(I2, 5) = XC(I)
      QQQ(I2, 6) = YC(I)*2.0
      QQQ(I2, 8) = QQQ(I1, 4)
      QQQ(I2, 9) = QQQ(I1, 5)*2.0
      QQQ(I2,10) = QQQ(I1, 6)*3.0
      QQQ(I2,12) = QQQ(I1, 7)
      QQQ(I2,13) = QQQ(I1, 8)*2.0
      QQQ(I2,14) = QQQ(I1, 9)*3.0
      QQQ(I2,15) = QQQ(I1,10)*4.0
      QQQ(I2,17) = QQQ(I1,12)*2.0
      QQQ(I2,18) = QQQ(I1,13)*3.0
      QQQ(I2,19) = QQQ(I1,14)*4.0
      QQQ(I2,20) = QQQ(I1,15)*5.0
      QQQ(I3, 2) =-1.0
      QQQ(I3, 4) =-2.0*XC(I)
      QQQ(I3, 5) =-YC(I)
      QQQ(I3, 7) =-QQQ(I1, 4)*3.0
      QQQ(I3, 8) =-QQQ(I1, 5)*2.0
      QQQ(I3, 9) =-QQQ(I1, 6)
      QQQ(I3,11) =-QQQ(I1, 7)*4.0
      QQQ(I3,12) =-QQQ(I1, 8)*3.0
      QQQ(I3,13) =-QQQ(I1, 9)*2.0
      QQQ(I3,14) =-QQQ(I1,10)
      QQQ(I3,16) =-QQQ(I1,11)*5.0
      QQQ(I3,17) =-QQQ(I1,13)*3.0
      QQQ(I3,18) =-QQQ(I1,14)*2.0
      QQQ(I3,19) =-QQQ(I1,15)
  115 CONTINUE
      QQQ(19,16) = 5.0*A**4*C
      QQQ(19,17) = 3.0*A**2*C**3 - 2.0*A**4*C
      QQQ(19,18) =-2.0*A*C**4 + 3.0*A**3*C**2
      QQQ(19,19) = C**5 - 4.0*A**2*C**3
      QQQ(19,20) = 5.0*A*C**4
      QQQ(20,16) = 5.0*B**4*C
      QQQ(20,17) = 3.0*B**2*C**3 - 2.0*B**4*C
      QQQ(20,18) = 2.0*B*C**4 - 3.0*B**3*C**2
      QQQ(20,19) = C**5 - 4.0*B**2*C**3
      QQQ(20,20) =-5.0*B*C**4
      DO 128 I = 1,6
      DO 128 J = 1,6
      I1 = (I-1)*3 + 1
      Q(I,J) = QQQ(I1,J)
  128 CONTINUE
C
C     SET ISING = -1
C
      ISING = -1
      CALL INVERS (6,Q,6,TS6(1),0,DETERM,ISING,IND)
      IF (ISING .EQ. 2) GO TO 904
C
C     FOURTH ARGUMENT IS A DUMMY LOCATION FOR INVERSE AND HENCE TS1(1) I
C
C     AGAIN SET ISING = -1
C
      ISING = -1
      CALL INVERS (20,QQQ,20,TS6(1),0,DETERM,ISING,INDEX)
C
C     ISING EQUAL TO 2 IMPLIES THAT QQQ IS SINGULAR
C
      IF (ISING .EQ. 2) GO TO 905
C
C     FIRST 18 COLUMNS OF QQQ INVERSE IS THE QQQINV FOR USE IN STIFFNESS
C     MATRIX CALCULATIONS
C
      DO  153 I = 1,960
      QQ(I) = 0.0
  153 CONTINUE
      DO 154 I = 1,6
      DO 154 J = 1,6
      IJ = (I-1)*30 + J
      IK = (I+5)*30 + J + 6
      QQ(IJ) = Q(I,J)
      QQ(IK) = Q(I,J)
  154 CONTINUE
      DO 156 I = 1,20
      DO 156 J = 1,18
      IJ = 372 + (I-1)*30 + J
      QQ (IJ) = QQQ(I,J)
      IJ1 = (I-1)*18 + J
      QQQINV(IJ1) = QQQ(I,J)
  156 CONTINUE
C
C     START EXECUTION FOR STIFFNESS MATRIX CALCULATION
C
C     CM IS STIFFNESS MATRIX IN ELEMENT COORDINATES
C
C     EVALUATE THE CONSTANTS C1,C2,AND C3 IN THE LINEAR EQUATION FOR
C     THICKNESS VARIATION - MEMBRANE
C
      CALL AF (F,14,A,B,C,C1,C2,C3,TMEM1,TMEM3,TMEM5,1)
      CAB(1) = C1
      CAB(2) = C2
      CAB(3) = C3
      AREA   = F(1,1)
      VOL    = C1*F(1,1) + C2*F(2,1) + C3*F(1,2)
      UNIBEN =.FALSE.
      UNIMEM =.FALSE.
      UNITEM =.FALSE.
      IF (ABS(C2).LE.1.0E-06 .AND. ABS(C3).LE.1.0E-06) UNIMEM =.TRUE.
C
      D334 = D33*4.0
      D132 = D13*2.0
      D232 = D23*2.0
C
C     DD(1) TO DD(3) ARE THE CONSTANTS IN LINEAR EQUATION FOR TEMP
C     GRADIENT. CURRENTLY ONLY UNIFORM TEMP GRADIENT IS PERMITTED IN
C     THE ELEMENT, THOUGH THE CODE IS WRITTEN FOR LINEAR VARIATION
C
      CALL AF (F,14,A,B,C,DD(1),DD(2),DD(3),T1PRIM,T3PRIM,T5PRIM,1)
C
C     EL(1) TO EL(3) ARE THE CONSTANTS IN THE LINEAR EQUATION FOR
C     MEAN TEMP VARIATION
C
      EL(1) = TREAL(1) - TREF
      EL(2) = 0.0
      EL(3) = 0.0
C
C     A1,A2,A3 ARE THE COEFFICIENTS OF LINEAR EQUATION FOR VARIATION
C     OF BENDING THICKNESSES
C
      CALL AF (F,14,A,B,C,A1,A2,A3,THK1,THK2,THK3,1)
      A1SQ = A1*A1
      A2SQ = A2*A2
      A3SQ = A3*A3
      C1   = A1SQ*A1
      C2   = 3.0*A1SQ*A2
      C3   = 3.0*A1SQ*A3
      C4   = 3.0*A1*A2SQ
      C5   = 6.0*A1*A2*A3
      C6   = 3.0*A3SQ*A1
      C7   = A2SQ*A2
      C8   = 3.0*A2SQ*A3
      C9   = 3.0*A2*A3SQ
      C10  = A3*A3SQ
      IF (ABS(A2).LE.1.0E-06 .AND. ABS(A3).LE.1.0E-06) UNIBEN =.TRUE.
      EL2  = EL(2)
      EL3  = EL(3)
      IF (ABS(EL2).LE.1.E-06 .AND. ABS(EL3).LE.1.E-06) UNITEM =.TRUE.
C
C     AA1, AA2, AA3  ARE COEFFICIENTS IN THICKNESS VARIATION FOR
C     TRANSVERSE SHEAR
C
      CALL AF (F,14,A,B,C,AA1,AA2,AA3,TSHR1,TSHR3,TSHR5,1)
      H4 = Q(4,1)*ZC(1) + Q(4,2)*ZC(2) + Q(4,3)*ZC(3) + Q(4,4)*ZC(4) +
     1     Q(4,5)*ZC(5) + Q(4,6)*ZC(6)
      H5 = Q(5,1)*ZC(1) + Q(5,2)*ZC(2) + Q(5,3)*ZC(3) + Q(5,4)*ZC(4) +
     1     Q(5,5)*ZC(5) + Q(5,6)*ZC(6)
      H6 = Q(6,1)*ZC(1) + Q(6,2)*ZC(2) + Q(6,3)*ZC(3) + Q(6,4)*ZC(4) +
     1     Q(6,5)*ZC(5) + Q(6,6)*ZC(6)
      H4 = H4*2.0
      H6 = H6*2.0
C
C     H5 IS MULTIPLIED BY 2.0, SO THAT EXY=DU/DY + DV/DX - ZXY*W
C
      H5 = H5*2.0
C
C     CALCULATION OF THERMAL LOAD VECTOR
C
      DO 670 I = 1,32
      PTEM(I) = 0.0
      IX   = XU(I)
      RIX  = IX
      JX   = YU(I)
      RJX  = JX
      KX   = XV(I)
      RKX  = KX
      LX   = YV(I)
      RLX  = LX
      MX   = XW(I)
      RMX  = MX
      NX   = YW(I)
      RNX  = NX
      RMNX = RMX*RNX
      RMX1 = RMX*(RMX-1.0)
      RNX1 = RNX*(RNX-1.0)
      IXP1 = IX + 1
      JXP1 = JX + 1
      KXP1 = KX + 1
      LXP1 = LX + 1
      MXP1 = MX + 1
      NXP1 = NX + 1
      MX01 = MX - 1
      MX1  = MX + 1
      NX01 = NX - 1
      NX1  = NX + 1
      PTEMP= 0.0
      IF (I .LE. 12) GO TO 225
      DO 215 K = 1,10
      MX01X= MX01+ XTHK(K)
      NX1Y = NX1 + YTHK(K)
      MX1X = MX1 + XTHK(K)
      NX01Y= NX01+ YTHK(K)
      MXX  = MX  + XTHK(K)
      NXY  = NX  + YTHK(K)
      IF (TINT(6) .NE. 1) GO TO 213
      DO 212 L = 1,3
      MX01XP= MX01X+ PT(L)
      NX1YQ = NX1Y + QT(L)
      MX1XP = MX1X + PT(L)
      NX01YQ= NX01Y+ QT(L)
      MXXP  = MXX  + PT(L)
      NXYQ  = NXY  + QT(L)
      IF (MX01XP.GT.0 .AND. NX1YQ.GT.0)
     1    PTEMP = PTEMP + CC(K)*DD(L)*G1(1)*RMX1*F(MX01XP,NX1YQ)
      IF (MX1XP.GT.0 .AND. NX01YQ.GT.0)
     1    PTEMP = PTEMP + CC(K)*DD(L)*G1(2)*RNX1*F(MX1XP,NX01YQ)
      IF (MXXP.GT.0 .AND. NXYQ.GT.0)
     1    PTEMP = PTEMP + CC(K)*DD(L)*G1(3)*RMNX*F(MXXP,NXYQ)
      IF (UNITEM) GO TO 213
  212 CONTINUE
  213 CONTINUE
      IF (TINT(6) .EQ. 1) GO TO 214
      IF (MX01X .GT. 0) PTEMP = PTEMP + CC(K)*RMX1*(PL(1)*G(1)
     1                        + PL(2)*G(2) + PL(3)*G(3))*F(MX01X,NX1Y)
      IF (NX01Y .GT. 0) PTEMP = PTEMP + CC(K)*RNX1*(PL(1)*G(4)
     1                        + PL(2)*G(5) + PL(3)*G(6))*F(MX1X,NX01Y)
      IF (MXX.GT.0 .AND. NXY.GT.0) PTEMP = PTEMP + CC(K)*RMNX*(PL(1)*
     1                        G(7)+PL(2)*G(8)+PL(3)*G(9))*F(MXX,NXY)
  214 CONTINUE
      IF (UNIBEN) GO TO 2150
  215 CONTINUE
 2150 CONTINUE
      PTEM(I) = PTEMP/12.0
      GO TO 235
  225 CONTINUE
      DO 263 K = 1,3
      IXR = IX + RK(K)
      JXS = JX + SK(K)
      KXR = KX + RK(K)
      LXS = LX + SK(K)
      DO 262 L = 1,3
      IXRT  = IXR + TL(L)
      JXSU1 = JXS + UL(L) + 1
      KXRT1 = KXR + TL(L) + 1
      LXSU  = LXS + UL(L)
      IXRT1 = IXRT  + 1
      JXSU  = JXSU1 - 1
      KXRT  = KXRT1 - 1
      LXSU1 = LXSU  + 1
      MKR1  = MX + KX + RK(K) - 1
      NLS1  = NX + LX + SK(K) - 1
      IF (IXRT .GT. 0) PTEMP = PTEMP +CAB(K)*EL(L)*GM1*RIX*F(IXRT,JXSU1)
      IF (LXSU .GT. 0) PTEMP = PTEMP +CAB(K)*EL(L)*GM2*RLX*F(KXRT1,LXSU)
      IF (JXSU .GT. 0) PTEMP = PTEMP +CAB(K)*EL(L)*GM3*RJX*F(IXRT1,JXSU)
      IF (KXRT .GT. 0) PTEMP = PTEMP +CAB(K)*EL(L)*GM3*RKX*F(KXRT,LXSU1)
      IF (MKR1.GT.0 .AND. NLS1.GT.0) PTEMP = PTEMP -(G11PR*H4*EL(L)*
     1    CAB(K)*F(MKR1,NLS1))-(G22PR*H4*EL(L)*CAB(K)*F(MKR1,NLS1))-
     2    (G33PR*H4*EL(L)*CAB(K)*F(MKR1,NLS1))
      IF (UNITEM) GO TO 2620
  262 CONTINUE
 2620 CONTINUE
      IF (UNIMEM) GO TO 2630
  263 CONTINUE
 2630 CONTINUE
      PTEM(I) = PTEMP
  235 CONTINUE
  670 CONTINUE
      CALL GMMATS (QQ,32,30,+1,PTEM,32,1,0,P6)
      DO 179 I = 1,30
      EE(I)  = 0.0
  179 CONTINUE
      EE( 1) = IVECT(1)
      EE( 2) = JVECT(1)
      EE( 3) = KVECT(1)
      EE( 6) = IVECT(2)
      EE( 7) = JVECT(2)
      EE( 8) = KVECT(2)
      EE(11) = IVECT(3)
      EE(12) = JVECT(3)
      EE(13) = KVECT(3)
      EE(19) = IVECT(1)
      EE(20) = JVECT(1)
      EE(24) = IVECT(2)
      EE(25) = JVECT(2)
      EE(29) = IVECT(3)
      EE(30) = JVECT(3)
      DO 278 K = 1,6
      DO 277 I = 1,2
      K1 = 6*(I-1) + K
      I1 = 5*(K-1) + I
      P7(I1) = P6(K1)
  277 CONTINUE
  278 CONTINUE
      DO 283 K = 1,6
      DO 282 I = 1,3
      I2 = 5*(K-1) + I + 2
      K2 = 12 + (K-1)*3 + I
      P7(I2) = P6(K2)
  282 CONTINUE
  283 CONTINUE
C
C     LOCATE THE TRANSFORMATION MATRICES FROM BASIC TO LOCAL (THAT IS
C     COORDINATE AT ANY GRID POINT IN WHICH DISPLACEMENT AND STRESSES
C     ARE ROTATED
C     - NOT NEEDED IF FIELD 7 IN GRID CARD IS ZERO)
C
C     TRANSFORM STIFFNESS MATRIX FROM ELEMENT COORDINATES TO BASIC
C     COORDINATES
C
C     TRANSFORM STIFFNESS MATRIX FROM BASIC COORDINAYES TO GLOBAL (DISP)
C     COORDINATES
C
      DO 302 I = 1,6
      SMALL(I) = I
  302 CONTINUE
      DO 308 I = 1,6
      SIL1 = SMALL(I)
      DO 310 II = 1,36
      BALOTR(II) = 0.0
  310 CONTINUE
      DO 304 K = 1,5
      K1 = (SIL1-1)*5 + K
      P8(K) = P7(K1)
  304 CONTINUE
      CALL GMMATS (EE,6,5,0,P8,5,1,0,P9)
C
C     TRANSFORM THE KSUB(36) FROM BASIC TO DISPLACEMENT COORDINATES
C
      IF (NL(SIL1).EQ.0 .OR. ICS(SIL1).EQ.0) GO TO 330
      JJ = 4*SIL1 + 24
      CALL TRANSS (IEST(JJ),TRAND)
      DO 320 JJ = 1,3
      L = 6*(JJ-1) + 1
      M = 3*(JJ-1) + 1
      BALOTR(L   ) = TRAND(M  )
      BALOTR(L+ 1) = TRAND(M+1)
      BALOTR(L+ 2) = TRAND(M+2)
      BALOTR(L+21) = TRAND(M  )
      BALOTR(L+22) = TRAND(M+1)
      BALOTR(L+23) = TRAND(M+2)
  320 CONTINUE
      CALL GMMATS (BALOTR(1),6,6,1, P9(1),6,1,0, P6(1))
      DO 350 K = 1,6
  350 P9(K) = P6(K)
  330 CONTINUE
      DO 370 II = 1,6
      I2 = IEST(I+1) + II - 1
      PG(I2) = PG(I2) + P9(II)
  370 CONTINUE
  308 CONTINUE
      GO TO 999
  904 WRITE (NOUT,2416) UFM,IEST(1)
      GO TO 910
  905 WRITE (NOUT,2417) UFM,IEST(1)
  910 NOGO = .TRUE.
      GO TO 999
C
 2416 FORMAT (A23,' 2416, MATRIX RELATING GENERALIZED PARAMETERS AND ',
     1       'GRID POINT DISPLACEMENTS IS SINGULAR.',/26X,
     2       'CHECK COORDINATES OF ELEMENT  TRSHL WITH ID =',I9,1H.)
 2417 FORMAT (A23,' 2417, A SINGULAR MATERIAL MATRIX FOR ELEMENT ID =',
     1       I9,' HAS BEEN DETECTED BY SUBROUTINE TLODSL', /26X,'WHILE',
     2       ' TRYING TO COMPUTE THERMAL LOADS WITH TEMPP2 CARD DATA.')
  999 RETURN
      END

      SUBROUTINE GPCYC
C
C     GPCYC IS THE GEOMETRY PROCESSOR FOR CYCLIC PROBLEM
C
C     INPUT DATA BLOCKS - GEOM4,EQEXIN,USET
C
C     OUTPUT DATA BLOCKS - CYCD
C
C     PARAMETERS  CTYPE - INPUT,BCD -
C                 NOGO  - OUTPUT--+1 UNLESS ERROR--THEN-1
C
C     SCRATCH FILES (2)
C     DEFINITION OF VARIABLES
C     NZ       OPEN CORE LENGTH
C     NX       ORIGINAL OPEN CORE
C     NENT     NUMBER OF ENTRIES IN EQEXIN
C     ITYP     PROBLEM TYPE (ROT=0 ,OTHERWISE=1)
C     LCYJ     LENGTH OF CJOIN CARDS
C     ISID1    POINTER TO START OF SIDE 1 CZRDS
C     ISID2    POINTER TO START OF SIDE 2 CZRDS
C
      EXTERNAL        ANDF
      INTEGER         GEOM4,EQEXIN,USET,CYCD,CTYPE,SYSBUF,FILE,NAME(2),
     1                SCR1,SCR2,REC,CYL,SPH,ROT,CYJOIN(2),IB(5),ANDF,
     2                IBB(4),MCB(7),BLK
      CHARACTER       UFM*23,UWM*25
      COMMON /XMSSG / UFM,UWM
      COMMON /TWO   / ITWO(32)
      COMMON /BITPOS/ ISK(6),IUA
      COMMON /SYSTEM/ KSYSTM(65)
      COMMON /ZZZZZZ/ IZ(1)
      COMMON /BLANK / CTYPE(2),NOGO
      EQUIVALENCE     (KSYSTM(1),SYSBUF),(KSYSTM(2),NOUT)
      DATA    GEOM4 , EQEXIN,USET,CYCD,SCR1,SCR2,NAME         /
     1        101   , 102   ,103 ,201 ,301 ,302 ,4HGPCY,4HC   /
      DATA    ROT   / 4HROT /,REC,CYL,SPH  / 1HR,1HC,1HS      /
      DATA    CYJOIN/ 5210,52  /
      DATA    NOCY  , NOSID1, ISID1, IBLEN, ICM,  ISAM, NOCNT, NOPAR /
     1        4024  , 4025,   4026,  4027,  4028, 4029, 4030,  4032  /
      DATA    NOEQ  , NCORD    /
     1        4037  , 4039     /
      DATA    MCB   / 7*0/, BLK/ 1H  /
C
C
      NZ   = KORSZ(IZ)
      NOGO = 1
C
C     IBUF1 IS PRELOC BUFFER
C
      IBUF1 = NZ - SYSBUF
      IBUF2 = IBUF1 - SYSBUF
      NZ = IBUF2 - 1
      NX = NZ
      IF (NZ .LE. 0) CALL MESAGE (-8,0,NAME)
C
C     PUT  SECOND RECORD OF EQEXIN ITO CORE
C
      FILE = EQEXIN
      CALL GOPEN (EQEXIN,IZ(IBUF1),0)
      CALL FWDREC (*560,EQEXIN)
      CALL READ (*560,*10,EQEXIN,IZ,NZ,0,IFLAG)
      CALL MESAGE (-8,0,NAME)
   10 CALL CLOSE (EQEXIN,1)
      NENT = IFLAG/2
C
C     DECIDE ON TYPE
C
      ITYP = 1
      IF (CTYPE(1) .EQ. ROT) ITYP = 0
C
C     FIND  CYJOIN CARDS ON GEOM4
C
      FILE = GEOM4
      CALL PRELOC (*540,IZ(IBUF1),GEOM4)
      CALL LOCATE (*580,IZ(IBUF1),CYJOIN,IDUM)
      NZ = NZ - IFLAG
      K  = IFLAG + 1
      CALL READ (*560,*20,GEOM4,IZ(K),NZ,0,LCYJ)
      CALL MESAGE (-8,0,NAME)
   20 CALL CLOSE (GEOM4,1)
      LCYJ = LCYJ + K - 1
      IF (IZ(K) .EQ. 1) GO TO 40
      WRITE  (NOUT,590) UFM,NOSID1
      WRITE  (NOUT,30)
   30 FORMAT ('0NO SIDE 1 DATA FOUND.')
      GO TO 620
   31 WRITE  (NOUT,590) UFM,NOSID1
      WRITE  (NOUT,32)
   32 FORMAT ('0NO SIDE 2 DATA FOUND.')
      GO TO 620
C
C     FIND SIDE TWO DATA
C
   40 L = K
   50 IF (L .GT. LCYJ) GO TO  31
      IF (IZ(L) .EQ. -1) GO TO 70
   60 L = L + 1
      GO TO 50
C
C     END OF CARD FOUND
C
   70 IF (L+1  .GT. LCYJ) GO TO 31
      IF (IZ(L+1) .EQ. 2) GO TO 90
      IF (ITYP    .EQ. 1) GO TO 60
      WRITE  (NOUT,590) UFM,ISID1
      WRITE  (NOUT,80)
   80 FORMAT ('0TOO MANY SIDE 1 CARDS.')
      GO TO 620
C
C     FOUND SIDE TWO LIST
C
   90 ISID2 = L + 1
      IF (ITYP .NE. 0) GO TO 370
C
C     CHECK LENGTH OF SIDE TWO LIST
C
      NS1 = ISID2 - K - 4
      NS2 = LCYJ - ISID2 - 3
      IF (NS1 .EQ. NS2) GO TO 110
      WRITE  (NOUT,590) UFM,IBLEN
      WRITE  (NOUT,100)
  100 FORMAT ('0NUMBER OF ENTRIES IN SIDE 1 NOT EQUAL TO NUMBER IN ',
     1        'SIDE 2')
      NOGO = -1
      GO TO 620
C
C     BUILD 5 WORDS FOR EACH PAIR
C
C
C     FIVE WORD ENTRY FOR EACH PAIR APPEARS AS FOLLOWS
C
C     1        CODE(1 = GRID   2 = SCALAR)
C     2        INTERNAL INDEX (SIL)      SIDE 1
C     3        GRID ID (EXTERNAL)       SIDE 1
C     4        INTERNAL INDEX (SIL)      SIDE 2
C     5        GRID ID (EXTERNAL)       SIDE 2
C
  110 CALL GOPEN (SCR1,IZ(IBUF1),1)
      L = ISID2 + 3
      K = K + 3
      DO 160 I = 1,NS1
      IF (IZ(K) .NE. IZ(L)) GO TO  130
      WRITE  (NOUT,590) UFM,ISAM
      WRITE  (NOUT,120) IZ(K)
  120 FORMAT ('0GRID POINT',I10,' APPEARS IN BOTH SIDE LISTS.')
      GO TO 620
  130 CONTINUE
      IP = IZ(K)
      CALL BISLOC (*610,IP,IZ(1),2,NENT,M)
      IX1 = IZ(M+1)/10
      IC1 = IZ(M+1) - IX1*10
      IP  = IZ(L)
      CALL BISLOC (*610,IP,IZ(1),2,NENT,M)
      IX2 = IZ(M+1)/10
      IC2 = IZ(M+1) - IX2*10
      IF (IC1 .EQ. IC2) GO TO 150
      WRITE  (NOUT,590) UFM,ICM
      WRITE  (NOUT,140) IZ(K),IZ(L)
  140 FORMAT ('0THE CODE FOR GRID POINT',I10,' DOES NOT MATCH THE CODE',
     1        ' FOR GRID POINT',I10)
      GO TO 620
  150 IB(1) = IC1
      IB(2) = IX1
      IB(3) = IZ(K)
      IB(4) = IX2
      IB(5) = IZ(L)
      CALL WRITE (SCR1,IB,5,0)
      K = K + 1
      L = L + 1
  160 CONTINUE
  170 CALL WRITE (SCR1,0,0,1)
      CALL CLOSE (SCR1,1)
C
C     SET UP USET
C
      CALL GOPEN (USET,IZ(IBUF1),0)
      FILE = USET
      NZ   = NX
      CALL READ (*560,*190,USET,IZ,NZ,0,LUSET)
      CALL MESAGE (-8,0,NAME)
  190 CALL CLOSE (USET,1)
C
C     SET UP REDUCED USET TABLE
C
      K = 0
      M = ITWO(IUA)
      DO 220 I = 1,LUSET
      IF (ANDF(IZ(I),M)) 210,200,210
  200 IZ(I) = 0
      GO TO 220
  210 K = K + 1
      IZ(I) = -K
  220 CONTINUE
      LUA = K
C
C     FORM SILA VALUES
C
      FILE = SCR1
      CALL GOPEN (SCR1,IZ(IBUF1),0)
      CALL GOPEN (SCR2,IZ(IBUF2),1)
      IF (ITYP .NE. 0) GO TO  410
  230 CALL READ (*560,*300,SCR1,IB(1),5,0,IFLAG)
      NP = 1
      IF = 0
      IF (IB(1) .EQ. 1) NP = 6
      K = 0
  240 L = IB(2) + K
      M = IB(4) + K
C
C     IF NEITHER IGNORE
C
      IF (IZ(L).EQ.0 .AND. IZ(M).EQ.0) GO TO 280
      IF (IZ(L).LT.0 .AND. IZ(M).LT.0) GO TO 270
      WRITE  (NOUT,250) UWM,NOCNT
  250 FORMAT (A25,I5)
      M = K + 1
      WRITE  (NOUT,260) M,IB(3),IB(5)
  260 FORMAT ('0COMPONENT',I4,' OF GRID POINTS',I10,5H AND ,I10,
     1        ' CANNOT BE CONNECTED.')
      GO TO 280
  270 IF = IF + 1
      IBB(1) = IABS(IZ(L))
      IBB(2) = IB(3)
      IBB(3) = IABS(IZ(M))
      IBB(4) = IB(5)
      CALL WRITE (SCR2,IBB,4,0)
  280 K = K + 1
      IF (K .NE. NP) GO TO 240
      IF (IF .NE. 0) GO TO 230
      WRITE  (NOUT,250) UWM,NOPAR
      WRITE  (NOUT,290) IB(3),IB(5)
  290 FORMAT ('0NO COMPONENTS OF GRID POINTS',I10,5H AND ,I10,
     1        ' WERE CONNECTED.')
      GO TO 230
C
C     CLOSE UP
C
  300 CALL WRITE (SCR2,0,0,1)
      CALL CLOSE (SCR1,1)
      CALL CLOSE (SCR2,1)
C
C     BUILD CYCD
C
      DO 310 I = 1,LUA
      IZ(I) = 0
  310 CONTINUE
      FILE = SCR2
      CALL GOPEN (SCR2,IZ(IBUF1),0)
      IF (ITYP .NE. 0) GO TO 520
  320 CALL READ (*560,*360,SCR2,IBB,4,0,IFLAG)
      K = IBB(1)
      M = IBB(3)
      IF (IZ(K) .EQ. 0) GO TO 340
      WRITE  (NOUT,590) UFM,NOEQ
      WRITE  (NOUT,330) IBB(2)
  330 FORMAT ('0GRID POINT',I10,' IS LISTED MORE THAN ONCE.')
      NO GO = -1
  340 IF (IZ(M) .EQ. 0) GO TO 350
      WRITE (NOUT,590) UFM,NOEQ
      WRITE (NOUT,330) IBB(4)
      NOGO  = -1
  350 IZ(K) =  M
      IZ(M) = -K
      GO TO  320
C
C     END OF PAIRS
C
  360 CALL CLOSE (SCR2,1)
      CALL GOPEN (CYCD,IZ(IBUF1),1)
      CALL WRITE (CYCD,IZ(1),LUA,1)
      CALL CLOSE (CYCD,1)
      MCB(1) = CYCD
      MCB(2) = ITYP + 1
      MCB(3) = LUA
      CALL WRTTRL (MCB)
      IF (NOGO .NE. -1) RETURN
      GO TO 620
C
C     1. DIHEDRAL TYPE
C
C     BUILD FIVE WORD LIST
C
C
C     FIVE WORD ENTRY FOR EACH POINT IN SIDE 1 OR SIDE TWO LOOKS AS
C         FOLLOWS
C     1        SIDE (1,2)
C     2        COORD SYS (R = 1,C = 1,S = 2,BLANK = 0)
C     3        CODE ( 1 = GRID   2 = SCALAR)
C     4        INTERNAL INDEX (SIL)
C     5        GRID ID (EXTERNAL)
C
  370 L = K
      CALL GOPEN (SCR1,IZ(IBUF1),1)
  380 ICID = IZ(L+1)
      ISID = IZ(L  )
      IF (ICID .EQ. REC) ICID = 1
      IF (ICID .EQ. CYL) ICID = 1
      IF (ICID .EQ. SPH) ICID = 2
      IF (ICID .EQ. BLK) ICID = 0
      L = L + 3
  390 IF (IZ(L) .EQ. -1) GO TO 400
      IP = IZ (L)
      CALL BISLOC (*610,IP,IZ(1),2,NENT,M)
      IB(1) = ISID
      IB(2) = ICID
      IB(4) = IZ(M+1)/10
      IB(3) = IZ(M+1) - IB(4)*10
      IB(5) = IP
      CALL WRITE (SCR1,IB,5,0)
      L = L + 1
      GO TO 390
C
C     END OF LIST
C
  400 IF (L .GE. LCYJ) GO TO 170
      L = L + 1
      GO TO 380
C
C     END OF CYJOIN LISTS
C
C
C     PRODUCE CYCD CODES
C
  410 CALL READ (*560,*300,SCR1,IB(1),5,0,IFLAG)
      NP = 1
      IF (IB(3) .EQ. 1) NP = 6
      IF = 0
      K  = 0
      IF (IB(1) .EQ. 2) IB(1) = IB(1) + 1
  420 L = IB(4) + K
      IF (IZ(L) .EQ. 0) GO TO 500
C
C     POINT IS IN  A SET
C
      IBB(2) = IABS(IZ(L))
      IBB(3) = IB(5)
      IF (IB(3) .EQ. 2) GO TO 480
      IF (IB(2) .EQ. 1) GO TO 440
      IF (IB(2) .EQ. 2) GO TO 460
C
C     COORD SYS = 0
C
      WRITE  (NOUT,590) UFM,NCORD
      WRITE  (NOUT,430) IBB(3)
  430 FORMAT ('0NO COORDINATE SYSTEM DEFINED FOR GRID POINT',I10)
      NOGO = -1
      GO TO 480
C
C     RECTANGULAR OR CYL
C
  440 IF (MOD(K+1,2) .EQ. 1) GO TO 480
  450 M = 1
      GO TO 490
C
C     SPH
C
  460 IF (K.LT.2 .OR. K.EQ.5 .OR. NP.LT.3 .OR. NP.EQ.6) GO TO 480
      GO TO 450
C
C     EVEN
C
  480 M = 0
  490 IBB(1) = IB(1) + M
      IF = IF + 1
      CALL WRITE (SCR2,IBB,3,0)
  500 K = K + 1
      IF (K .NE. NP) GO TO 420
      IF (IF .NE. 0) GO TO 410
      WRITE  (NOUT,250) UWM,NOPAR
      WRITE  (NOUT,510) IB(5)
  510 FORMAT ('0NO COMPONENTS OF GRID POINT',I10,' WERE IN THE A SET')
      GO TO 410
C
C     BUILD CYCD FOR DIH
C
  520 CALL READ (*540,*360,SCR2,IBB,3,0,IFLAG)
      K = IBB(2)
      IF (IZ(K) .EQ. 0) GO TO 530
      WRITE (NOUT,590) UFM,NOEQ
      WRITE (NOUT,330) IBB(3)
      NOGO  = -1
  530 IZ(K) = IBB(1)
      GO TO 520
C
C     ERROR MESSAGES
C
  540 IP1 = -1
  550 CALL MESAGE (IP1,FILE,NAME)
      RETURN
  560 IP1 = -2
      GO TO 550
  580 WRITE  (NOUT,590) UFM,NOCY
  590 FORMAT (A23,I5)
      WRITE  (NOUT,600)
  600 FORMAT ('0NO CYJOIN CARDS WERE SUPPLIED.')
      GO TO 620
  610 CALL MESAGE (-30,2,IP)
  620 CALL MESAGE (-61,0,NAME)
      RETURN
      END

      SUBROUTINE GETDEF (DFRM,PH,MAG,CONV,PLTTYP,BUF,GPT,D)
C
      INTEGER         DFRM,BUF(1),GPT(1),SILN,REW,SP,GP,GPX,SIL1,SIL2,
     1                TRL(7),TYPE,PLTTYP
      REAL            D(3,1),MAXDEF
      COMMON /BLANK / NGP,LSIL,SKP11(3),NGPSET,SKP12(4),SKP2(6),MSIL
      COMMON /XXPARM/ PBUFSZ,PLOTER(5),PENPAP(30),SCALE(4),MAXDEF
      COMMON /ZNTPKX/ DEFC(4),SILN,LAST
      EQUIVALENCE     (DEFVAL,DEFC(1))
      DATA    INPREW, REW / 0,1 /
C
      LAST = 0
      K    = 3*NGPSET
      DO 10 I = 1,K
   10 D(I,1) = 0.0
      TRL(1) = DFRM
      CALL RDTRL (TRL(1))
      IF (TRL(5) .LE. 0) RETURN
      SP = TRL(5)
      ASSIGN 140 TO TYPE
C
C     NOTE TRANSIENT RESPONSE HAS SP = 1
C
      IF (SP .LT. 3) GO TO 30
      ASSIGN 130 TO TYPE
      IF (MAG .NE. 0) GO TO 30
      ASSIGN 120 TO TYPE
      SN = SIN(PH)*CONV
      CN = COS(PH)*CONV
      IF (PLTTYP .EQ. 2) GO TO 20
C
C     DISPLACEMENT OR ACCELERATION
C
      I1 = 1
      I2 = SP - 1
      IF (PLTTYP.EQ.3 .OR. PLTTYP.EQ.4) CN = -CN
      GO TO 30
C
C     VELOCITY
C
   20 I1 = SP - 1
      I2 = 1
   30 CONTINUE
      MAXDEF = 0.
      CALL INTPK (*170,DFRM,0,SP,0)
      GP   = 0
      SILN = 0
      CALL GOPEN (MSIL,BUF(1),INPREW)
      CALL FREAD (MSIL,SIL2,1,0)
C
C     -GP- = PREVIOUS EXISTENT GRID POINT IN THIS SET. FIND NEXT ONE.
C
   40 K = GP + 1
      DO 50 GPX = K,NGP
      IF (GPT(GPX) .NE. 0) GO TO 60
   50 CONTINUE
      SIL1 = LSIL + 1
      GO TO 100
   60 IF (GPX .NE. GP+1) GO TO 70
      SIL1 = SIL2
      GO TO 80
   70 GP = GP + 1
      CALL FREAD (MSIL,SIL2,1,0)
      GO TO 60
C
C     -SIL1- = SIL NUMBER OF NEXT EXISTENT GRID POINT. READ SIL NUMBER
C              OF NEXT GRID POINT.
C
   80 GP = GPX
      GPX = IABS(GPT(GP))
      IF (GP .EQ. NGP) SIL2 = LSIL + 1
      IF (GP .NE. NGP) CALL FREAD (MSIL,SIL2,1,0)
C
C     READ NEXT DEFORMATION VALUE AT THIS EXISTING GRID POINT.
C
   90 IF (SILN.LE.LSIL .AND. SILN.GE.SIL1) GO TO 150
  100 IF (LAST .NE. 0) GO TO 160
  110 CALL ZNTPKI
      GO TO TYPE, (120,130,140)
  120 DEFVAL = DEFC(I1)*CN - DEFC(I2)*SN
      GO TO 140
  130 DEFVAL = CONV*SQRT(DEFC(1)**2 + DEFC(SP-1)**2)
  140 IF (ABS(DEFVAL) .GT. MAXDEF) MAXDEF = ABS(DEFVAL)
      GO TO 90
  150 IF (SILN.GT.SIL1+2 .OR. SILN.GE.SIL2) GO TO 40
      K = SILN - SIL1 + 1
      D(K,GPX) = DEFVAL
      IF (LAST) 160,110,160
C
  160 CALL CLOSE (MSIL,REW)
  170 RETURN
      END

      SUBROUTINE DPD3
C
C     DPD3 ASSEMBLES THE FREQUENCY RESPONSE LIST (FRL)
C     AND THE POWER SPECTRAL DENSITY LIST (PSDL).
C
      INTEGER         GPL   ,SIL   ,USET  ,USETD ,GPLD  ,SILD  ,DPOOL ,
     1                DLT   ,FRL   ,TFL   ,TRL   ,PSDL  ,EED   ,SCR1  ,
     2                SCR2  ,SCR3  ,SCR4  ,BUF   ,BUF1  ,BUF2  ,BUF3  ,
     3                BUF4  ,FLAG  ,FILE  ,EPOINT,SEQEP ,Z     ,LOADS ,
     5                RANDT2,DLOAD ,FREQ1 ,FREQ  ,TIC   ,TSTEP ,TF    ,
     6                PSD   ,EIGR  ,EIGB  ,EIGC  ,NGRID ,EQDYN ,SDT   ,
     7                FREQ2 ,RANDPS,RANDT1
      DIMENSION       BUF(24)   ,EPOINT(2)    ,SEQEP(2)     ,MCB(7)   ,
     1                NAM(2)    ,LOADS(32)    ,DLOAD(2)     ,FREQ1(2) ,
     2                FREQ(2)   ,ZZ(1)        ,BUFR(20)     ,NOLIN(21),
     3                TIC(2)    ,TSTEP(2)     ,TF(2)        ,PSD(2)   ,
     4                MSG(3)    ,EIGR(2)      ,EIGB(2)      ,EIGC(2)  ,
     5                FREQ2(2)  ,RANDPS(2)    ,RANDT1(2)    ,RANDT2(2)
      COMMON /CONDAS/ CONSTS(5)
      COMMON /BLANK / LUSET ,LUSETD,NOTFL ,NODLT ,NOPSDL,NOFRL ,NONLFT,
     1                NOTRL ,NOEED
      COMMON /NAMES / RD    ,RDREW ,WRT   ,WRTREW,CLSREW
      COMMON /DPDCOM/ DPOOL ,GPL   ,SIL   ,USET  ,GPLD  ,SILD  ,USETD ,
     1                DLT   ,FRL   ,NLFT  ,TFL   ,TRL   ,PSDL  ,EED   ,
     2                SCR1  ,SCR2  ,SCR3  ,SCR4  ,BUF   ,BUF1  ,BUF2  ,
     3                BUF3  ,BUF4  ,EPOINT,SEQEP ,L     ,KN    ,NEQDYN,
     4                LOADS ,DLOAD ,FREQ1 ,FREQ  ,NOLIN ,NOGO  ,
     5                MSG   ,TIC   ,TSTEP ,TF    ,PSD   ,EIGR  ,EIGB  ,
     6                EIGC  ,MCB   ,NAM   ,EQDYN ,SDT   ,INEQ
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE     (CONSTS(2),TWOPI), (Z(1),ZZ(1)), (BUF(1),BUFR(1)),
     1                (MSG(2),NGRID)
      DATA    FREQ2 , RANDPS , RANDT1 , RANDT2  /
     1       1107,11, 2107,21, 2207,22, 2307,23 /
C
C     OPEN DYNAMICS POOL. SET POINTERS.
C
      FILE = DPOOL
      CALL PRELOC (*2001,Z(BUF1),DPOOL)
      NOFRQ1 = 0
      NOFRQ2 = 0
      NOFRQ  = 0
      IFRQ1  = 1
      IFRQ2  = IFRQ1
      IFRQ   = IFRQ1
      I = IFRQ1
      J = I
C
C     READ FREQ1 CARDS. CONVERT F1 AND DELTA F TO RADIANS.
C
      CALL LOCATE (*1265,Z(BUF1),FREQ1,FLAG)
      NOFRQ1 = 1
 1261 CALL READ (*2002,*1262,DPOOL,Z(I),4,0,FLAG)
      ZZ(I+1) = TWOPI*ZZ(I+1)
      ZZ(I+2) = TWOPI*ZZ(I+2)
      I = I + 4
      GO TO 1261
 1262 NFRQ1 = I - 4
      IFRQ2 = I
      IFRQ  = I
      J = I
C
C     READ FREQ2 CARDS. CONVERT FREQUENCIES TO RADIANS.
C
 1265 CALL LOCATE (*1270,Z(BUF1),FREQ2,FLAG)
      NOFRQ2 = 1
 1266 CALL READ (*2002,*1267,DPOOL,Z(I),4,0,FLAG)
      ZZ(I+1) = TWOPI*ZZ(I+1)
      ZZ(I+2) = TWOPI*ZZ(I+2)
      I = I + 4
      GO TO 1266
 1267 NFRQ2 = I - 4
      IFRQ  = I
      J = I
C
C     READ FREQ CARDS. CONVERT FREQUENCIES TO RADIANS.
C
 1270 CALL LOCATE (*1274,Z(BUF1),FREQ,FLAG)
      NOFRQ = 1
 1271 CALL READ (*2002,*1274,DPOOL,Z(J+1),1,0,FLAG)
      J = J + 2
 1272 CALL READ (*2002,*2003,DPOOL,Z(J),1,0,FLAG)
      IF (Z(J) .EQ. -1) GO TO 1273
      ZZ(J) = TWOPI*ZZ(J)
      J = J + 1
      GO TO 1272
 1273 Z(I) = J - (I+1)
      I = J
      GO TO 1271
C
C     TEST FOR ANY FREQ TYPE CARDS.
C
 1274 NOFRL = NOFRQ1 + NOFRQ2 + NOFRQ
      IF (NOFRL .NE. 0) GO TO 1280
      GO TO 1276
 1275 INEQ  = 0
 1276 NOFRL =-1
      GO TO 1310
C
C     COLLECT LIST OF FREQUENCY SET IDS AND POINTERS TO CARDS.
C     SORT THIS LIST ON SET ID.
C
 1280 ILIST = J + 1
      I = ILIST
      IF (NOFRQ1 .EQ. 0) GO TO 1282
C
C     FOR FREQ1 SET STORE SET ID, POINTER TO SET, 0.
C
      DO 1281 K = IFRQ1,NFRQ1,4
      Z(I  ) = Z(K)
      Z(I+1) = K
      Z(I+2) = 0
 1281 I = I + 3
      NLIST = I - 3
 1282 IF (NOFRQ2 .EQ. 0) GO TO 1287
C
C     FOR FREQ2 SET STORE SET ID, POINTER TO SET, -1.
C
      DO 1286 K = IFRQ2,NFRQ2,4
      Z(I  ) = Z(K)
      Z(I+1) = K
      Z(I+2) =-1
 1286 I = I + 3
      NLIST = I - 3
 1287 IF (NOFRQ .EQ. 0) GO TO 1285
C
C     FOR FREQ SET STORE SET ID, POINTER TO SET, NO. OF WORDS IN SET.
C
      J = IFRQ
 1283 N = Z(J)
      IF (N .EQ. -1) GO TO 1284
      J = J + 1
      Z(I  ) = Z(J)
      Z(I+1) = J
      Z(I+2) = N
      I = I + 3
      J = J + N
      GO TO 1283
 1284 NLIST = I - 3
 1285 N = I - ILIST
      CALL SORT (0,0,3,1,Z(ILIST),N)
C
C     OPEN THE FRL. WRITE NAME + SET IDS IN HEADER.
C
      FILE = FRL
      CALL OPEN (*1275,FRL,Z(BUF2),WRTREW)
      CALL FNAME (FRL,BUF)
      CALL WRITE (FRL,BUF,2,0)
      DO 1291 I = ILIST,NLIST,3
      BUF(1) = Z(I)
 1291 CALL WRITE (FRL,BUF,1,0)
      CALL WRITE (FRL,0,0,1)
C
C     WRITE THE FRL ONE RECORD PER FREQUENCY SET.
C     CONVERT FREQ1 SETS TO LOOK LIKE FREQ SETS.
C     CONVERT FREQ2 SETS TO LOOK LIKE FREQ SETS.
C
      DO 1308 I = ILIST,NLIST,3
      J = Z(I+1)
      N = Z(I+2)
      IF (N) 1304,1301,1303
C
C     FREQ SET ---  SORT FREQUENCY LIST AND DISCARD ANY DUPLICATES.
C     THEN WRITE FREQUENCIES ON THE FRL
C
 1303 N = N - 1
      IF (N .EQ. 1) GO TO 1307
      CALL SORTF (0,0,1,1,Z(J+1),N)
      J1 = J + 2
      JN = J + N
      IX = J + 1
      DO 1306 JX = J1,JN
      IF (Z(JX) .EQ. Z(IX)) GO TO 1306
      IX = IX + 1
      Z(IX) = Z(JX)
 1306 CONTINUE
      N = IX - J
 1307 CALL WRITE (FRL,Z(J+1),N,1)
      GO TO 1308
C
C     FREQ1 SET-- FORM F = F0 + (I-1)*DELTA F, WHERE I = 1 THRU N+1.
C
 1301 F0   = ZZ(J+1)
      DELF = ZZ(J+2)
      N  = Z(J+3) + 1
      FI = 0.
      DO 1302 K = 1,N
      F = F0 + FI*DELF
      CALL WRITE (FRL,F,1,0)
 1302 FI = FI + 1.0
      CALL WRITE (FRL,0,0,1)
      GO TO 1308
C
C     FREQ2 SET-- FORM F = F0*10.0**((I-1)*DELTA)
C     WHERE DELTA = (LOG10(FE/F0))/N AND I = 1 THRU N+1.
C
 1304 F0 = ZZ(J+1)
      FE = ZZ(J+2)
      N  =  Z(J+3)
      FN = N
      DELTA = (ALOG10(FE/F0))/FN
      FI = 0.
      N  = N + 1
      DO 1305 K = 1,N
      F  = F0*10.0**(FI*DELTA)
      CALL WRITE (FRL,F,1,0)
 1305 FI = FI + 1.0
      CALL WRITE (FRL,0,0,1)
 1308 CONTINUE
C
C     CLOSE FRL AND WRITE TRAILER.
C
      MCB(1) = FRL
      MCB(2) = (NLIST-ILIST)/3 + 1
      CALL WRTTRL (MCB)
      CALL CLOSE (FRL,CLSREW)
      INEQ = 0
C
C     OPEN PSDL. IF PURGED, BYPASS PSDL PROCESSING.
C     OTHERWISE, LOCATE RANDPS CARDS. IF ABSENT, BYPASS PSDL PROCESSING.
C
 1310 FILE = PSDL
      CALL OPEN (*1381,PSDL,Z(BUF2),WRTREW)
      CALL LOCATE (*1381,Z(BUF1),RANDPS,FLAG)
C
C     READ RANDPS CARDS INTO CORE.
C
      IRPS = 1
      FILE = DPOOL
      CALL READ (*2002,*1322,DPOOL,Z(IRPS),BUF2-IRPS,1,NRPS)
      GO TO 2004
 1322 IRT1 = IRPS + NRPS
      IRT2 = IRT1
      I    = IRT1
      J    = I
      NORT1= 0
      NORT2= 0
C
C     READ RANDT1 CARDS.
C
      CALL LOCATE (*1340,Z(BUF1),RANDT1,FLAG)
      CALL READ (*2002,*1332,DPOOL,Z(IRT1),BUF2-IRT1,1,NORT1)
      GO TO 2004
 1332 IRT2 = IRT1 + NORT1
      NRT1 = IRT2 - 4
      I = IRT2
      J = I
C
C     READ RANDT2 CARDS.
C
 1340 CALL LOCATE (*1350,Z(BUF1),RANDT2,FLAG)
      NORT2 = 1
 1341 CALL READ (*2002,*1350,DPOOL,Z(J+1),1,0,FLAG)
      J = J + 2
 1342 CALL READ (*2002,*2003,DPOOL,Z(J),1,0,FLAG)
      IF (Z(J) .EQ. -1) GO TO 1343
      J = J + 1
      IF (J .LT. BUF2) GO TO 1342
      GO TO 2004
 1343 Z(I) = J - (I+1)
      I = J
      GO TO 1341
C
C     COLLECT LIST OF RANDT1 AND RANDT2 SET IDS AND POINTERS TO DATA.
C
 1350 NORT = NORT1 + NORT2
      IF (NORT .EQ. 0) GO TO 1360
      ILIST = J + 1
      I = ILIST
      IF (NORT1 .EQ. 0) GO TO 1352
C
C     FOR RANDT1 SETS STORE SET ID, POINTER TO SET, 0.
C
      DO 1351 K = IRT1,NRT1,4
      Z(I  ) = Z(K)
      Z(I+1) = K
      Z(I+2) = 0
 1351 I = I + 3
      NLIST = I - 3
      IF (I .GT.  BUF2) GO TO 2004
 1352 IF (NORT2 .EQ. 0) GO TO 1355
C
C     FOR RANDT2 SETS STORE SET ID, POINTER TO SET, NO. OF WORDS IN SET.
C
      J = IRT2
 1353 N = Z(J)
      IF (N .EQ. -1) GO TO 1354
      Z(I  ) = Z(J)
      Z(I+1) = J
      Z(I+2) = N
      I = I + 3
      J = J + N
      IF (I .LT. BUF2) GO TO 1353
      GO TO 2004
 1354 NLIST = I - 3
C
C     SORT LIST ON SET ID.
C
 1355 N = I - ILIST
      CALL SORT (0,0,3,1,Z(ILIST),N)
C
C     WRITE SET IDS FOR RANDT1 AND RANDT2 CARDS IN HEADER RECORD OF
C     PSDL. THEN WRITE RANDPS DATA AS FIRST RECORD OF PSDL.
C
 1360 CALL FNAME (PSDL,BUF)
      CALL WRITE (PSDL,BUF,2,0)
      IF (NORT .EQ. 0) GO TO 1362
      DO 1361 I = ILIST,NLIST,3
 1361 CALL WRITE (PSDL,Z(I),1,0)
 1362 CALL WRITE (PSDL,0,0,1)
      CALL WRITE (PSDL,Z(IRPS),NRPS,1)
      IF (NORT .EQ. 0) GO TO 1380
C
C     WRITE ONE RECORD ON PSDL FOR EACH RANDT1 OR RANDT2 SET.
C
      DO 1378 I = ILIST,NLIST,3
      J = Z(I+1)
      N = Z(I+2)
      IF (N .EQ. 0) GO TO 1372
C
C     RANDT2 SET--  SORT DATA AND DISCARD ANY DUPLICATES. THEN WRITE SET
C
      N = N - 1
      IF (N .EQ. 1) GO TO 1376
      CALL SORTF (0,0,1,1,Z(J+1),N)
      J1 = J + 2
      JN = J + N
      IX = J + 1
      DO 1375 JX = J1,JN
      IF (Z(JX) .EQ. Z(IX)) GO TO 1375
      IX = IX + 1
      Z(IX) = Z(JX)
 1375 CONTINUE
      N = IX - J
 1376 CALL WRITE (PSDL,Z(J+1),N,1)
      GO TO 1378
C
C     RANDT1 SET-- WRITE TI = T0 + (I-1)*DELTA T, WHERE I = 1 THRU N+1.
C
 1372 N  = Z(J+1)
      FN = N
      DELT = (ZZ(J+3)-ZZ(J+2))/FN
      T0 = ZZ(J+2)
      FI = 0.
      N  = N + 1
      DO 1373 K = 1,N
      TI = T0 + FI*DELT
      CALL WRITE (PSDL,TI,1,0)
 1373 FI = FI + 1.0
      CALL WRITE (PSDL,0,0,1)
 1378 CONTINUE
C
C     CLOSE FILES, WRITE TRAILER AND EXIT.
C
 1380 MCB(1) = PSDL
      MCB(2) = (NLIST-ILIST)/3 + 1
C      2147483647  = 2**31 - 1
      IF (NORT .EQ. 0) MCB(2) = 2147483647
      CALL WRTTRL (MCB)
      INEQ  = 0
      NOPSDL= 1
 1381 CALL CLOSE (DPOOL,CLSREW)
      CALL CLOSE (PSDL ,CLSREW)
      RETURN
C
C     FATAL FILE ERRORS
C
 2001 N = -1
      GO TO 2005
 2002 N = -2
      GO TO 2005
 2003 N = -3
      GO TO 2005
 2004 N = -8
 2005 CALL MESAGE (N,FILE,NAM)
      RETURN
      END

      SUBROUTINE FLUNAM (LU,FILNAM)
C
C     THIS ROUTINE FORMULATES A FORTRAN LOGICAL UNIT NAME FROM A
C     LOGICAL UNIT NUMBER       =       =       =    ===
C
C     INPUT  LU          e.g. LU = 8
C     OUTPUT FILNAM           FILNAM = 'fort.08'  NOTE - IS .08 NOT .8
c
      CHARACTER   FILNAM*7,FOR7*7,FOR5*5,FORT*5
      EQUIVALENCE (FOR5,FOR7)
      DATA  FORT/ 'fort.' /
C
      J = LU + 100
      WRITE  (FOR7,10) J
   10 FORMAT (4X,I3)
      FOR5   = FORT
      FILNAM = FOR7
      RETURN
      END

      SUBROUTINE SSG4
C
C     DRIVER TO DO INERTIAL RELIEF PORTION OF SSG
C
C     DMAP SEQUENCE
C
C     SSG4  PL,QR,PO,MR,MLR,D,MLL,MOOB,MOAB,GO,USET/PLI,POI/V,N,IOMT $
C
      INTEGER  GO,USET
      INTEGER PL,QR,PO,D,PLI,POI,SCR1,SCR2,SCR3,SCR4,SCR5
      COMMON /BITPOS/ UM,UO,UR,USG,USB,UL,UA,UF,US,UN,UG
      COMMON /BLANK/ IOMT
      DATA PL,QR,PO,MR,MLR,D,MLL,MOOB,MOAB,PLI,POI,SCR1,SCR2,SCR3,SCR4
     1   ,SCR5,GO,USET
     2   / 101,102,103,104,105,106,107,108,109,201,202,301,302,303,304,
     3   305,110,111/
C
C     COMPUTE  MR-1*QR=TEMP2
C
      CALL FACTOR(MR,SCR1,SCR2,SCR3,SCR4,SCR5)
      CALL SSG3A( MR, SCR1, QR, SCR3, SCR4, SCR5, -1, XXX )
C
C     COMPUTE  MLL*D+MLR=TEMP1
C
      CALL SSG2B(MLL,D,MLR,SCR4,0,2,1,SCR1)
C
C     COMPUTE  TEMP1*TEMP2+PL=PLI
C
      CALL SSG2B(SCR4,SCR3,PL,PLI,0,2,1,SCR1)
      IF(IOMT) 20,20,10
C
C     COMPUTE  MOOB*GO+MOAB=SCR4
C
   10 CALL SSG2B(MOOB,GO,MOAB,SCR4,0,2,1,SCR1)
C
C     COMPUTE DI*TEMP2  =SCR2
C
      CALL SSG2B(D,SCR3,0,SCR2,0,2,1,SCR1)
      CALL SDR1B(SCR5,SCR2,SCR3,SCR1,UA,UL,UO,USET,0,0)
C
C     COMPUTE  SCR4*SCR1+PO=POI
C
      CALL SSG2B(SCR4,SCR1,PO,POI,0,2,1,SCR3)
   20 RETURN
      END

      SUBROUTINE SUWRT (IA,NWORDS,ITEST)
C
C     COPIES DATA FROM THE ARRAY IA ON THE SOF.  NWORD IS AN INPUT
C     PARAMETER INDICATING THE NUMBER OF WORDS TO BE COPIED.  ITEST IS
C     AN INPUT PARAMETER WHERE ITEST=1 MEANS MORE TO COME, ITEST=2 MEANS
C     WRITE END OF GROUP, AND ITEST=3 MEANS WRITE END OF ITEM.
C
      EXTERNAL        LSHIFT,ANDF,ORF
      LOGICAL         MDIUP
      INTEGER         BUF,MDI,MDIPBN,MDILBN,MDIBL,BLKSIZ,DIRSIZ,ANDF,ORF
      DIMENSION       IA(1),NMSBR(2)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /MACHIN/ MACH,IHALF,JHALF
      COMMON /ZZZZZZ/ BUF(1)
      COMMON /SOF   / DITDUM(6),
     1                IO,IOPBN,IOLBN,IOMODE,IOPTR,IOSIND,IOITCD,IOBLK,
     2                MDI,MDIPBN,MDILBN,MDIBL,NXTDUM(15),DITUP,MDIUP
      COMMON /SYS   / BLKSIZ,DIRSIZ
      COMMON /SYSTEM/ NBUFF,NOUT
      DATA    IDLE  , IWRT / 0,2    /
      DATA    IEOG  , IEOI / 4H$EOG ,4H$EOI /, NMSBR /4HSUWR,4HT   /
C
      CALL CHKOPN (NMSBR(1))
      ICOUNT = 0
      IF (IOMODE .EQ. IWRT) GO TO 10
      ITEST = 4
      RETURN
C
C     KEEP COPYING DATA FROM THE ARRAY IA INTO THE INPUT/OUTPUT BUFFER
C     UNTIL THE BUFFER IS FULL, OR UNTIL THE REQUESTED NUMBER OF WORDS
C     HAS BEEN COPIED.
C
   10 IF (IOPTR .GT. BLKSIZ+IO) GO TO 30
   20 IF (ICOUNT .EQ. NWORDS) GO TO (80,60,50), ITEST
      ICOUNT = ICOUNT + 1
      BUF(IOPTR) = IA(ICOUNT)
      IOPTR = IOPTR + 1
      GO TO 10
C
C     THE BUFFER IS FULL.  OUTPUT IT ON THE SOF.
C
   30 CALL SOFIO (IWRT,IOPBN,BUF(IO-2))
      CALL GETBLK (IOPBN,J)
      IF (J .EQ. -1) GO TO 40
      IOPBN = J
      IOLBN = IOLBN + 1
      IOPTR = IO + 1
      GO TO 20
C
C     THERE ARE NO MORE FREE BLOCKS ON THE SOF.  RETURN THE BLOCKS THAT
C     HAVE BEEN USED SO FAR BY THE ITEM BEING WRITTEN, AND CLOSE THE SOF
C     THEN ISSUE A FATAL ERROR MESSAGE.
C
   40 CALL RETBLK (IOBLK)
      CALL SOFCLS
      GO TO 90
C
C     WRITE END OF ITEM, OUTPUT THE INPUT/OUTPUT BUFFER ON THE SOF, AND
C     UPDATE THE MDI.
C
   50 BUF(IOPTR) = IEOI
      CALL SOFIO (IWRT,IOPBN,BUF(IO-2))
      CALL FMDI (IOSIND,IMDI)
      BUF(IMDI+IOITCD) = IOBLK
      BUF(IMDI+IOITCD) = ORF(ANDF(BUF(IMDI+IOITCD),JHALF),
     1                       LSHIFT(IOLBN,IHALF))
      MDIUP  = .TRUE.
      IOMODE = IDLE
      GO TO 70
C
C     WRITE END OF GROUP.
C
   60 BUF(IOPTR) = IEOG
   70 IOPTR = IOPTR + 1
   80 RETURN
C
C     ERROR MESSAGES.
C
   90 WRITE  (NOUT,100) UFM
  100 FORMAT (A23,' 6223, THERE ARE NO MORE FREE BLOCKS AVAILABLE ON',
     1       ' THE SOF FILE.')
      CALL SOFCLS
      CALL MESAGE (-61,0,0)
      RETURN
      END

      SUBROUTINE SUBC
C
      COMPLEX         GUSAMP,SBKDE1,SBKDE2,
     1                F4,F4S,AM4,F5S,F6S,AM4TST,SUM3,SUM4,AM5TT,AM6,
     2                SUMSV1,SUMSV2,SVKL1,SVKL2,F5,F5T,AM5,AM5T,
     3                AI,A,B,BSYCON,ALP,F1,AM1,ALN,BLKAPM,BKDEL3,F1S,C1,
     4                C2P,C2N,
     5                C2,AMTEST,FT2,BLAM1,FT3,AM2,SUM1,SUM2,F2,BLAM2,
     6                FT2T,C1T,FT3T,F2P,AM2P,SUM1T,SUM2T,
     7                C1P,C1N,BKDEL1,BKDEL2,BLKAP1,ARG,ARG2,
     8                FT3TST,C1A,C2A,C3A,CEXP1,CEXP2,CEXP3,CEXP1A,
     9                CEXP2A,CEXP3A,CONST,
     O                BC,BC2,BC3,BC4,BC5,CA1,CA2,CA3,CA4,
     1                CLIFT,CMOMT,C4A,CEXP4,CEXP5,CEXP4A,CEXP5A,
     2                PRES1,PRES2,PRES3,PRES4,QRES4,FQA,FQB,T1,T2,T3,FQ7
      DIMENSION       PRES1(21),PRES2(21),PRES3(21),PRES4(21),QRES4(21),
     1                SBKDE1(201),SBKDE2(201),
     2                SUMSV1(201),SUMSV2(201),SVKL1(201),SVKL2(201),
     3                XLSV1(21),XLSV2(21),XLSV3(21),XLSV4(21)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /SYSTEM/ SYSBUF,IBBOUT
      COMMON /BLK1  / SCRK,SPS,SNS,DSTR,AI,PI,DEL,SIGMA,BETA,RES
      COMMON /BLK2  / BSYCON
      COMMON /BLK3  / SBKDE1,SBKDE2,F4,F4S,AM4,F5S,F6S,AM4TST,SUM3,SUM4,
     1                AM5TT,AM6,SUMSV1,SUMSV2,SVKL1,SVKL2,F5,F5T,AM5,
     2                AM5T,A,B,ALP,F1,AM1,ALN,BLKAPM,BKDEL3,F1S,C1,C2P,
     3                C2N,C2,AMTEST,FT2,BLAM1,FT3,AM2,SUM1,SUM2,F2,
     4                BLAM2,FT2T,C1T,FT3T,F2P,AM2P,SUM1T,SUM2T,C1P,C1N,
     5                BKDEL1,BKDEL2,BLKAP1,ARG,ARG2,FT3TST,BC,BC2,BC3,
     6                BC4,BC5,CA1,CA2,CA3,CA4,CLIFT,CMOMT,PRES1,PRES2,
     7                PRES3,PRES4,QRES4,FQA,FQB,FQ7
      COMMON /BLK4  / I,R,Y,A1,B1,C4,C5,GL,I6,I7,JL,NL,RI,RT,R5,SN,SP,
     1                XL,Y1,AMU,GAM,IDX,INX,NL2,RL1,RL2,RQ1,RQ2,XL1,
     2                ALP1,ALP2,GAMN,GAMP,INER,IOUT,REDF,STAG,STEP,
     3                AMACH,BETNN,BETNP,BKAP1,XLSV1,XLSV2,XLSV3,XLSV4,
     4                ALPAMP,AMOAXS,GUSAMP,DISAMP,PITAXS,PITCOR
C
      AM4TST = 0.0
      S1 = SPS*DEL - SIGMA
      S2 = SPS/(DSTR**2)
      S3 = SNS/DSTR
      S4 = SPS + SNS
      T3 = CEXP(-AI*SIGMA)
      DO 70 I = 1,200
      R  = I
      GAMP = 2.0*PI*R + S1
      GAMN =-2.0*PI*R + S1
      C1P = (GAMP/DSTR) - SCRK
      C2P = (GAMP/DSTR) + SCRK
      ALP = GAMP*S2 - S3*CSQRT(C1P)*CSQRT(C2P)
      T1  = ALP - DEL
      CALL AKAPM (ALP,BKDEL3)
      SBKDE1(I+1) = BKDEL3
      SUM1 = CEXP(AI*(ALP*SPS-GAMP))*(ALP*SPS-GAMP)*BKDEL3/((ALP*DSTR**2
     1     - GAMP*SPS)*T1)*(F6S*T1/(T1+GL) + F5S
     2     + B*AI/(BKDEL1*BKAP1)*(DEL-AMU)/(ALP-DEL))
      C1N  = (GAMN/DSTR) - SCRK
      C2N  = (GAMN/DSTR) + SCRK
      ALN  = GAMN*S2 - S3*CSQRT(C1N)*CSQRT(C2N)
      T2   = ALN - DEL
      CALL AKAPM (ALN,BKDEL3)
      SBKDE2(I+1) = BKDEL3
      SUM2 = CEXP(AI*(ALN*SPS-GAMN))*(ALN*SPS-GAMN)*BKDEL3/((ALN*DSTR**2
     1     - GAMN*SPS)*T2)*(F6S*(T2)/(T2+GL) + F5S
     2     + B*AI/(BKDEL1*BKAP1)*(DEL-AMU)/(T2))
      C1P  = CEXP(-AI*(T1)*SPS)
      C2P  = CEXP(-AI*(T1)*SNS)
      C1N  = CEXP(-AI*(T2)*SPS)
      C2N  = CEXP(-AI*(T2)*SNS)
      F4   = F4 + SUM1*T3*AI/(T1)*(C1P-C2P) + SUM2*T3*AI/(T2)*(C1N-C2N)
      AM4  = AM4 + SUM1*T3*(AI*SPS*C1P/(T1) - AI*SNS*C2P/(T1) + 1.0/
     1       ((T1)**2)*(C1P-C2P)+AI*(2.0-SPS)/(T1)*(C1P-C2P)) +
     2       SUM2*T3*(AI*SPS*C1N/(T2)-AI*SNS*C2N/(T2) + 1.0/
     3       ((T2)**2)*(C1N-C2N) + AI*(2.0-SPS)/(T2)*(C1N-C2N))
      I6   = I + 1
      TEMP = (SPS-SNS)/RL1
      C1A  =-AI*T1
      C2A  =-AI*T2
      C3A  = AI*DEL
      CEXP1  = CEXP(C1A*SNS)
      CEXP2  = CEXP(C2A*SNS)
      CEXP3  = CEXP(C3A*SNS)
      CEXP1A = CEXP(C1A*TEMP)
      CEXP2A = CEXP(C2A*TEMP)
      CEXP3A = CEXP(C3A*TEMP)
      CONST  = FQ7/(2.0*PI)
      TEMP2  = 2.0*PI*R/S4
      C4A    =-AI*S1
      CEXP4  = CEXP(C4A*(2.0*SNS/S4+0.5))
      CEXP5  = CEXP(C4A*0.5)
      CEXP4A = CEXP(C4A*TEMP/S4)
      CEXP5A = CEXP(C4A*TEMP/(SPS+SNS))
      XL     = SNS
      DO 459 JL = 1,NL
      PRES4(JL) = PRES4(JL) - T3*(SUM1*CEXP1 + SUM2*CEXP2
     1          + CONST*CEXP3*(CEXP4*SIN(TEMP2*(SNS+XL))/R
     2          - CEXP5*SIN(TEMP2*(SPS+XL))/R))
      XL    = XL + TEMP
      CEXP1 = CEXP1*CEXP1A
      CEXP2 = CEXP2*CEXP2A
      CEXP3 = CEXP3*CEXP3A
      CEXP4 = CEXP4*CEXP4A
      CEXP5 = CEXP5*CEXP5A
  459 CONTINUE
      IF (CABS((AM4-AM4TST)/AM4) .LT. 0.0006) GO TO 75
      AM4TST = AM4
   70 CONTINUE
      GO TO 9994
   75 CONTINUE
      TEMP  = (SPS-SNS)/RL1
      TEMP1 = 2.0*SNS/S4 + 0.5
      TEMP2 = 0.5 - (SPS+SNS)/S4
      C1A   = AI*DEL
      C2A   =-AI*S1
      C3A   =-C2A
      CEXP1 = CEXP(C1A*SNS)
      CEXP2 = CEXP(C2A*TEMP1)
      CEXP3 = CEXP(C3A*TEMP2)
      CEXP1A= CEXP(C1A*TEMP)
      CEXP2A= CEXP(C2A*TEMP/S4)
      CONST = T3*FQ7/2.0
      XL    = SNS
      DO 4596 JL = 1,NL
      PRES4(JL) = PRES4(JL) - CONST*CEXP1*(CEXP2*((SNS+XL)/S4-0.5)
     1          - CEXP3*((SPS+XL)/S4-1.5))
      XL    = XL + TEMP
      CEXP1 = CEXP1*CEXP1A
      CEXP2 = CEXP2*CEXP2A
      CEXP3 = CEXP3*CEXP2A
 4596 CONTINUE
      CALL SUBCC
      RETURN
C
 9994 WRITE  (IBBOUT,3015) UFM
 3015 FORMAT (A23,' - AMG MODULE -SUBROUTINE SUBC.  AM4 LOOP DID NOT ',
     1       'CONVERGE.')
      CALL MESAGE (-61,0,0)
      RETURN
      END

      SUBROUTINE MTRIQD (NTYPE)
C
C
C     8/18/67           E C P T     L I S T I N G
C
C     ECPT    TRPLT     TRIA1     TRIA2     QDPLT     QUAD1     QUAD2
C     *****************************************************************
C
C      1     ELEM ID   ELEM ID   ELEM ID   ELEM ID   ELEM ID   ELEM ID
C      2     GRID A    GRID A    GRID A    GRID A    GRID A    GRID A
C      3     GRID B    GRID B    GRID B    GRID B    GRID B    GRID B
C      4     GRID C    GRID C    GRID C    GRID C    GRID C    GRID C
C      5     THETA     THETA     THETA     GRID D    GRID D    GRID D
C      6     MATID1    MATID1    MAT ID    THETA     THETA     THETA
C      7     I         T1        T         MATID1    MATID1    MAT ID
C      8     MATID2    MATID2    NS MASS   I         T1        T
C      9     T2        I         CSID 1    MATID2    MATID2    NS MASS
C     10     NS MASS   MATID3    X1        T2        I         CSID 1
C     11     Z1        T2        Y1        NS MASS   MATID3    X1
C     12     Z2        NS MASS   Z1        Z1        T2        Y1
C     13     CSID 1    Z1        CSID 3    Z2        NS MASS   Z1
C     14     X1        Z2        X2        CSID 1    Z1        CSID 2
C     15     Y1        CSID 1    Y2        X1        Z2        X2
C     16     Z1        X1        Z2        Y1        CSID 1    Y2
C     17     CSID 2    Y1        CSID 3    Z1        X1        Z2
C     18     X2        Z1        X3        CSID 2    Y1        CSID 3
C     19     Y2        CSID 2    Y3        X2        Z1        X3
C     20     Z2        X2        Z3        Y2        CSID 2    Y3
C     21     CSID 3    Y2        TEMP      Z2        X2        Z3
C     22     X3        Z2                  CSID 3    Y2        CSID 4
C     23     Y3        CSID 3              X3        Z2        X4
C     24     Z3        X3                  Y3        CSID 3    Y4
C     25     TEMP      Y3                  Z3        X3        Z4
C     26               Z3                  CSID 4    Y3        TEMP
C     27               TEMP                X4        Z3
C     28                                   Y4        CSID 4
C     29                                   Z4        X4
C     30                                   TEMP      Y4
C     31                                             Z4
C     32                                             TEMP
C
C
      LOGICAL         HEAT
      DIMENSION       SAVE(32),ISAVE(32)
      COMMON /SMA2ET/ ECPT(100)
      COMMON /SMA2HT/ HEAT
      COMMON /MATIN / MATID,INFLAG,ELTEMP,STRESS,SINTH,COSTH
      COMMON /MATOUT/ RHO
      EQUIVALENCE     (SAVE(1),ISAVE(1),ECPT(50))
C
C     THIS SUBROUTINE INCORPORATES TRIA1, QUAD1, TRIA2, QUAD2
C
C             NTYPE = 1  IMPLIES MTRIA1
C             NTYPE = 2  IMPLIES MTRIA2
C             NTYPE = 3  IMPLIES MQUAD1
C             NTYPE = 4  IMPLIES MQUAD2
C
C     IF (I . EQ. 0) THEN COMPUTE UNCOUPLED MASS
C
C     CALL MASSTQ (NARG)
C          WHERE   NARG = 5 FOR TRIA1
C                  NARG = 4 FOR TRIA2
C                  NARG = 2 FOR QUAD1
C                  NARG = 1 FOR QUAD2
C
C     CALLS FROM THIS ROUTINE CAN BE MADE TO
C
C            MTRPLT - TRIANGULAR PLATE ROUTINE
C            MQDPLT - QUADRILATERAL PLATE ROUTINE
C            MASSTQ - UNCOUPLED MASS COMBINATION ELEMENT ROUTINE
C
C     ALL INSERTIONS OF 6X6 ELEMENT MASS MATRICES ARE HANDLED BY
C     THE ABOVE ROUTINES.
C
C     THE SAVED ECPT IS EQUIVALENCED TO ECPT(50)
C
C
C     SAVE THE INCOMING ECPT
C
      INFLAG = 4
      DO 10 I = 1,32
   10 SAVE(I) = ECPT(I)
C
C     TRANSFER TO OPERATIONS DESIRED
C
C            MTRIA1 MTRIA2 MQUAD1 MQUAD2
      GO TO (   20,    60,   100,   150), NTYPE
C
C     *** MTRIA1 ***
C
C     SET UP ECPT FOR CALL TO MTRPLT.  FIRST CHECK I EQUAL ZERO
C
   20 IF (SAVE(9) .NE. 0.0) GO TO 30
      NARG = 5
      CALL MASSTQ (NARG)
      GO TO 200
C
   30 DO 40 I = 1,5
   40 ECPT(I) = SAVE(I)
      DO 50 I = 6,25
   50 ECPT(I) = SAVE(I+2)
      MATID   = ISAVE(6)
      IF (SAVE(7) .EQ. 0.0) GO TO 54
      CALL MAT (ECPT(1))
      ECPT(10) = SAVE(12) + RHO*SAVE(7)
C
      GO TO 56
   54 ECPT(10) = SAVE(12)
   56 IF (.NOT.HEAT) CALL MTRPLT
      GO TO 200
C
C     *** MTRIA2 ***
C
C     SET UP ECPT FOR CALL TO MTRPLT
C
   60 IF (SAVE(7) .NE. 0.0) GO TO 70
      NARG = 4
      CALL MASSTQ (NARG)
      GO TO 200
C
   70 DO 80 I = 1,6
   80 ECPT(I) = SAVE(I)
      ECPT(7) = SAVE(7)**3/12.0
      ECPT(8) = SAVE(6)
      ECPT(9) = SAVE(7)
      MATID   = ISAVE(6)
      CALL MAT (ECPT(1))
      ECPT(10) = SAVE(8) + RHO*SAVE(7)
      DO 90 I = 13,25
   90 ECPT(I) = SAVE(I-4)
C
      IF (.NOT. HEAT) CALL MTRPLT
      GO TO 200
C
C     *** MQUAD1 ***
C
C      SET UP ECPT FOR CALL TO MQDPLT.  FIRST CHECK I EQUAL ZERO
C
  100 IF (SAVE(10) .NE. 0.0) GO TO 110
      NARG = 2
      CALL MASSTQ (NARG)
      GO TO 200
C
  110 DO 130 I = 1,6
  130 ECPT(I) = SAVE(I)
      DO 140 I = 7,30
  140 ECPT(I) = SAVE(I+2)
      MATID = ISAVE(7)
      IF (SAVE(8) .EQ. 0.0) GO TO 144
      CALL MAT (ECPT(1))
      ECPT(11) = SAVE(13) + RHO*SAVE(8)
C
      GO TO 146
  144 ECPT(11) = SAVE(13)
  146 IF (.NOT.HEAT) CALL MQDPLT
      GO TO 200
C
C     *** MQUAD2 ***
C
C     SET UP ECPT FOR CALL TO MQDPLT
C
  150 IF (SAVE(8) .NE. 0.0) GO TO 160
      NARG = 1
      CALL MASSTQ (NARG)
      GO TO 200
C
  160 DO 170 I = 1,7
  170 ECPT(I) = SAVE(I)
      ECPT(8) = SAVE(8)**3/12.0
      ECPT(9) = SAVE(7)
      ECPT(10)= SAVE(8)
      MATID   = ISAVE(7)
      CALL MAT (ECPT(1))
      ECPT(11) = SAVE(9) + RHO*SAVE(8)
      DO 180 I = 14,30
  180 ECPT(I) = SAVE(I-4)
C
      IF (.NOT. HEAT) CALL MQDPLT
  200 RETURN
      END

      SUBROUTINE PRETAB (DITF,RZ,INZ,BUF,LCRGVN,LCUSED,TABNOL,LIST)
C
C     SUBROUTINE PRETAB READS TABLES INTO OPEN CORE, SETS UP TABLE
C     DICTIONARIES WHICH ARE LATER USED WHEN THE CALLING ROUTINE
C     REQUESTS A FUNCTIONAL VALUE FROM A TABLE VIA A CALL TO THE ENTRY
C     POINT TAB.
C
C     REVISED  7/92, BY G.CHAN/UNISYS.
C     1. NEW REFERENCE TO THE OPEN CORE ARRAY SUCH THAT THE SOURCE CODE
C        IS UP TO ANSI FORTRAN 77 STANDARD
C     2. LOGARITHMIC SCALE ENHANCEMENT
C
C     ARGUMENT LIST -
C
C     DITF     THE GINO NAME OF THE FILE ON WHICH THE TABLES RESIDE.
C     RZ       THE OPEN CORE ARRAY. RZ IS USED AS REAL BY THIS ROUTINE.
C     INZ      SAME ADDRESS AS RZ.  USED AS INTEGER IN THIS ROUTINE.
C     BUF      A BUFFER TO BE USED BY SUBROUTINE PRELOC.
C     LCRGVN   THE LENGTH OF OPEN CORE GIVEN TO PRETAB.
C     LCUSED   THE AMOUNT OF CORE USED BY PRETAB.
C     TABNOL   LIST OF TABLE NUMBERS THAT THE USER WILL BE REFERENCING.
C              TABNOL(1) = N IS THE NUMBER OF TABLES TO BE REFERENCED.
C              TABNOL(2),...,TABNOL(N+1) CONTAIN THE TABLE NUMBERS. NOTE
C              THAT 0 IS AN ADMISSIBLE TABLE NUMBER IN THE TABLE NO.
C              LIST.  TABLE NO. 0 DEFINES A FUNCTION WHICH IS IDENTICAL-
C              LY = 0 FOR ALL VALUES OF THE INDEPENDENT VARIABLE.
C     LIST     ARRAY OF CONTROL WORDS FOR SUBROUTINE LOCATE AND TABLE
C              TYPES.
C              LIST(1) = M IS THE NO. OF TRIPLES WHICH FOLLOW IN LIST.
C              THE FIRST TWO WORDS OF EACH TRIPLE ARE THE SUBROUTINE
C              LOCATE CONTROL WORDS AND THE THIRD WORD IS THE TABLE TYPE
C              = 1,2,3,4, OR 5.
C     LNTH     = 12 WORDS PER TABLE ENTRY
C
      LOGICAL         PART1
      INTEGER         DITF   ,INZ(1) ,TABNOL(1)      ,DIT     ,LIST(1),
     1                IARY(8),TABNO  ,TABTYP ,TABIDO ,NAME(2) ,
     2                CLSRW  ,TABID  ,OFFSET ,SCTYP
      REAL            Y(2)   ,RZ(1)  ,Z(1)   ,BUF(1) ,PX(2,2)
      COMPLEX         SUM    ,A      ,B      ,TERM
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /CONDAS/ PI     ,TWOPI  ,RADEG  ,DEGRA  ,S4PISQ
      COMMON /SYSTEM/ IBUF   ,NOUT
      COMMON /ZZZZZZ/ IZ(1)
      EQUIVALENCE     (Z(1),IZ(1))
      DATA     CLSRW, NEOR  ,NAME         ,PX              , LNTH  /
     1         1    , 0     ,4HPRET,4HAB  ,3.,2.,1.339,1.0 , 12    /
C
C     INITIALIZE
C
      OFFSET = LOCFX(INZ(1)) - LOCFX(IZ(1))
      IF (OFFSET .LT. 0) CALL ERRTRC ('PRETAB  ',5)
      DIT  = DITF
      IDIC = 0 + OFFSET
      PART1= .TRUE.
      LIM  = TABNOL(1)
      ICRQ = LNTH*LIM - LCRGVN
      IF (ICRQ .GE. 0) GO TO 1080
C
C     SET UP TABLE NUMBERS IN DICTIONARY
C
C     FOR EACH TABLE THE DICTIONARY ENTRY IS AS FOLLOWS -
C
C       LOC.  1      TABLE NUMBER
C       LOC.  2      TABLE TYPE(1,2,3, 4, OR 5)
C       LOC.  3      POINTER TO 1ST  ENTRY IN TABLE.
C       LOC.  4      POINTER TO LAST ENTRY IN TABLE.
C       LOC.  5      *
C       LOC.  6      *
C       LOC.  7      *
C       LOC.  8      * LOCATIONS 5 THRU 11 CONTAIN TABLE PARAMETERS.
C       LOC.  9      *
C       LOC. 10      *
C       LOC. 11      *
C       LOC. 12      SCALE TYPE - LINEAR-LINER(0), LOG-LOG(1), LINEAR-
C                                 LOG(2), LOG-LINEAR(3)
C
      DO 20 I = 1,LIM
      IZ(IDIC+1) = TABNOL(I+1)
      JLOW = IDIC + 2
      JLIM = IDIC + LNTH
      DO 10 J = JLOW,JLIM
   10 IZ(J) = 0
   20 IDIC  = IDIC + LNTH
      IDICL = 1 + OFFSET
      IDICH = IDIC
C
C     READ THE CARDS REFERENCED VIA THE TABNOL AND LIST ARRAY.
C
      ITABLE = IDIC
      CALL PRELOC (*1010,BUF,DIT)
      LIMJJ = TABNOL(1)
      LIM   = LIST(1)
      JJ    = 1
   30 JJ3   = 3*JJ - 1
      CALL LOCATE (*110,BUF,LIST(JJ3),FLAG)
C
C     READ 8 WORDS INTO THE ARRAY IARY
C
   40 CALL READ (*1020,*110,DIT,IARY,8,NEOR,FLAG)
      TABNO = IARY(1)
      SCTYP = IARY(8)
C
C     DETERMINE IF THIS TABLE NUMBER IS IN THE USER SUPPLIED LIST OF
C     TABLE NUMBERS
C
      DO 50 J = 1,LIMJJ
      IF (TABNO .EQ. IABS(TABNOL(J+1))) IF (TABNO-TABNOL(J+1)) 60,70,60
   50 CONTINUE
C
C     THIS TABLE IS NOT CALLED FOR.  READ THE TABLE SERIALLY UNTIL AN
C     END OF TABLE INDICATOR (TWO MINUS ONES FOR TABLE TYPES 1,2,3 AND
C     ONE MINUS ONE FOR TABLE TYPE 4
C
      NWDS = 2
      IF (LIST(3*JJ+1) .EQ. 4) NWDS = 1
   55 CALL READ (*1020,*1040,DIT,IARY(2),NWDS,NEOR,IFLAG)
      IF (IARY(2) .EQ. -1) GO TO 40
      GO TO 55
C
C     THERE ARE TWO DIFFERENT TABLES WITH THE SAME NUMBER -- FATAL ERROR
C
   60 IARY(1) = TABNO
      IARY(2) = LIST(3*JJ-1)
      CALL MESAGE (-30,88,IARY)
C
C     THIS IS A NEW TABLE.  SET TABLE NUMBER NEGATIVE AND DEFINE WORDS
C     2 AND 3 OF THE PROPER DICTIONARY ENTRY.
C
   70 TABTYP = LIST(3*JJ+1)
      TABNOL(J+1) = -TABNOL(J+1)
      INDEX  = LNTH*(J-1) + OFFSET
      IZ(INDEX+2) = TABTYP
      IZ(INDEX+3) = ITABLE + 1
C
C     READ THE TABLE INTO CORE.
C
      NWDSRD = 2
      IF (TABTYP .EQ. 4) NWDSRD = 1
      II = ITABLE + 1
   80 CALL READ (*1020,*1040,DIT,Z(II),NWDSRD,NEOR,FLAG)
      IF (IZ(II) .EQ. -1) GO TO 90
      II   = II + NWDSRD
      ICRQ = II - LCRGVN - OFFSET
      IF (ICRQ .GE. 0) GO TO 1080
      GO TO 80
C
C     STORE THE LAST LOCATION OF THE TABLE IN IZ(INDEX+4)
C
   90 IZ(INDEX+4) = II - NWDSRD
C
C     STORE THE PARAMETERS ON THE TABLE CARD IN WORDS 5 THRU 11 OF THE
C     PROPER DICTIONARY ENTRY.
C
      LX = INDEX + 4
      DO 100 K = 2,8
      LX = LX + 1
  100 IZ(LX) = IARY(K)
      IZ(LX+1) = SCTYP
C
C     STORE THE CORRECT 0TH ADDRESS OF THE NEXT TABLE IN ITABLE
C
      ITABLE = IZ(INDEX+4)
C
C     IF THE TABLE IS A POLYNOMIAL EVALUATE THE END POINTS.
C
      IF (TABTYP .NE. 4) GO TO 108
      L  = INDEX + 1
      XX = (Z(L+6) - Z(L+4))/Z(L+5)
      ASSIGN 470 TO IGOTO
      GO TO  440
  102 ASSIGN 480 TO IGOTO
      XX = (Z(L+7) - Z(L+4))/Z(L+5)
      GO TO 440
  108 ITABLE = ITABLE + 1
      GO TO 40
C
C     TEST TO SEE IF ALL OF THE REQUESTED TABLES HAVE BEEN FOUND. IF
C     ALL TABLES HAVE NOT BEEN FOUND, GO TO NEXT TRIPLE IN LIST ARRAY
C
  110 IF (JJ .GE. LIM) GO TO 120
      DO 115 I = 1,LIMJJ
      IF (TABNOL(I+1) .GT. 0) GO TO 117
  115 CONTINUE
      GO TO 120
  117 JJ = JJ + 1
      GO TO 30
C
C     SET ALL ENTRIES IN TABNOL BACK TO THEIR ORIGINAL POSITIVE STATUS.
C     IF AN ENTRY IS STILL POSITIVE, THIS IMPLIES THE TABLE WAS NOT
C     FOUND IN THE DIT AND A FATAL ERROR CONDITION EXISTS.
C
  120 IFLAG = 0
      DO 140 I = 1,LIMJJ
      IF (TABNOL(I+1) .LE. 0) GO TO 130
      CALL MESAGE (30,89,TABNOL(I+1))
      IFLAG = 1
      GO TO 140
  130 TABNOL(I+1) = -TABNOL(I+1)
  140 CONTINUE
      IF (IFLAG .NE. 0) CALL MESAGE (-37,0,NAME)
C
C     WRAP-UP PRETAB
C
      CALL CLOSE (DIT,CLSRW)
      PART1  = .FALSE.
      TABIDO = -1
      XO     = -10.0E+37
      LCUSED = ITABLE + 1 - OFFSET
      ICHECK = 123456789
      RETURN
C
C     ENTRY TAB COMPUTES THE FUNCTIONAL VALUE Y AT THE ABSCISSA X FOR
C     THE FUNCTION DEFINED BY THE TABLE WHOSE NUMBER IS TABID
C
C
      ENTRY TAB (TABID,X,Y)
C     =====================
C
      IF (ICHECK .NE. 123456789) CALL ERRTRC ('PRETAB  ',200)
      ASSIGN 251 TO IHOP
C
      IF (TABID.EQ.TABIDO .AND. X.EQ.XO) GO TO 210
      TABIDO = TABID
      XO     = X
      GO TO 220
  210 Y(1) = YO
      RETURN
  220 IF (TABID .NE. 0) GO TO 230
      Y(1) = 0.0
      YO   = 0.0
      RETURN
C
C     SEARCH THE TABLE DICTIONARY TO FIND THE TABLE NUMBER
C
  230 DO 240 II = IDICL,IDICH,LNTH
      IF (TABID .EQ. IZ(II)) GO TO 250
  240 CONTINUE
C
C     TABID COULD NOT BE FOUND IN THE DICTIONARY - FATAL ERROR
C
      CALL MESAGE (-30,90,TABID)
  250 L = II
      ITYPE = IZ(L+ 1)
      SCTYP = IZ(L+11) + 1
      GO TO IHOP, (251,501)
  251 CONTINUE
      GO TO (260,270,280,290,295), ITYPE
C
C     TABLE TYPE = 1
C
C     A  RGUMENT = X
C
  260 XX = X
      GO TO 300
C
C     TABLE TYPE = 2
C
C     ARGUMENT = (X - X1)
C
  270 XX = X - Z(L+4)
      GO TO 300
C
C     TABLE TYPE = 3
C
C     ARGUMENT = (X - X1)/X2
C
  280 XX = (X - Z(L+4))/Z(L+5)
      GO TO 300
C
C     TABLE TYPE = 4
C
C     ARGUMENT = (X - X1)/X2
C
  290 XX = (X - Z(L+4))/Z(L+5)
      GO TO 400
C
C     TABLE TYPE = 5
C
C     TABRNDG CARD FUNTION ONLY
C
  295 CONTINUE
C
C     PICK UP TYPE
C
      LX = IZ(L+4)
C
C     P US ONE OVER TERM IN PX TABLE BASED ONL TYPE
C
      P = 1./PX(LX,1)
C
C     CONPUTE K SQUARED FROM PX TABLE
C
      XKSQ = PX(LX,2)*PX(LX,2)
C
C     RETRIEVE LU (L/U) FROM TABLE PARAMS
C
      XLU = Z(L+5)
      XX  = 2.*Z(L+6)**2*XLU
      XLU = XLU*XLU
      WSQ = S4PISQ*XO*XO
      TR  = XKSQ*XLU*WSQ
      PROP= XX*(1.+2.*(P+1.)*TR)/(1.+TR)**(P+1.5)
      GO TO 500
C
C     ROUTINE TO PERFORM LINEAR INTERPOLATION FOR FUNCTION IN A TABLE.
C     L POINTS TO THE ENTRY IN THE TABLE DICTIONARY WHICH DEFINES THE
C     TABLE. THE ARGUMENT IS XX. THE FUNCTIONAL VALUE IS STORED IN PROP.
C     EXTRAPOLATION IS MADE IF XX IS OUTSIDE THE LIMITS OF THE TABLE.
C     HENCE THERE ARE NO ERROR RETURNS.
C     HOWEVER, IF FUNCTION OVERFLOWED ON EXTRAPOLATION OUTSIDE TABLE
C     LIMITS, A FATAL MESSAGE IS ISSUED.
C
  300 ITABL = IZ(L+2)
      NTABL = IZ(L+3)
      UP    = 1.0
      IF (Z(ITABL) .GT. Z(ITABL+2)) UP = -1.0
      KXX1  = ITABL
      IF ((XX - Z(ITABL))*UP .LE. 0.0) GO TO 350
      KXX1  = NTABL - 2
      IF ((XX - Z(NTABL))*UP .GE. 0.0) GO TO 350
      KLO = 1
      KHI = (NTABL - ITABL)/2  +  1
  310 KX  = (KLO + KHI + 1)/2
      KXX = (KX - 1)*2 + ITABL
      IF ((XX - Z(KXX))*UP) 320,370,330
  320 KHI = KX
      GO TO 340
  330 KLO = KX
  340 IF (KHI-KLO .NE. 1) GO TO 310
      KXX1 = (KLO - 1)*2 + ITABL
      IF (KXX .EQ.      KXX1) GO TO 350
      IF (XX  .EQ. Z(KXX1+2)) GO TO 360
  350 GO TO (355,351,352,353), SCTYP
  351 CALL LOGLOG (Z(KXX1),Z(KXX1+1),Z(KXX1+2),Z(KXX1+3),XX,PROP)
      GO TO 500
  352 CALL SMILOG (Z(KXX1),Z(KXX1+1),Z(KXX1+2),Z(KXX1+3),XX,PROP)
      GO TO 500
  353 CALL LOGSMI (Z(KXX1),Z(KXX1+1),Z(KXX1+2),Z(KXX1+3),XX,PROP)
      GO TO 500
  355 PROP = (XX - Z(KXX1))*(Z(KXX1+3) - Z(KXX1+1))/(Z(KXX1+2)
     1     - Z(KXX1)) + Z(KXX1+1)
      IF (ABS(PROP) .LT. 1.0E-36) PROP = 0.0
      IF (ABS(PROP) .LT. 1.0E+36) GO TO 500
      IF (UP.GT.0. .AND. (XX.LT.Z(ITABL) .OR. XX.GT.Z(NTABL)))GO TO 1050
      IF (UP.LT.0. .AND. (XX.GT.Z(ITABL) .OR. XX.LT.Z(NTABL)))GO TO 1050
      GO TO 500
  360 KXX = KXX1 + 2
  370 IF (XX .EQ. Z(KXX-2)) GO TO 380
      IF (XX .EQ. Z(KXX+2)) GO TO 390
      PROP = Z(KXX+1)
      GO TO 500
  380 PROP = (Z(KXX-1) + Z(KXX+1))/2.0
      GO TO 500
  390 PROP = (Z(KXX+1) + Z(KXX+3))/2.0
      GO TO 500
C
C     POLYNOMIAL EVALUATION
C
  400 IF (XX - (Z(L+6) - Z(L+4))/Z(L+5)) 410,410,420
  410 PROP = Z(L+8)
      GO TO 500
  420 IF (XX - (Z(L+7) - Z(L+4))/Z(L+5)) 440,430,430
  430 PROP = Z(L+9)
      GO TO 500
  440 NN   = IZ(L+3)
      PROP = Z(NN)
  450 IF (NN .LE. IZ(L+2)) GO TO 460
      PROP = PROP*XX + Z(NN-1)
      NN   = NN - 1
      GO TO 450
  460 IF (PART1) GO TO IGOTO, (470,480)
      GO TO 500
  470 Z(L+8) = PROP
      GO TO 102
  480 Z(L+9) = PROP
      GO TO 40
C
C     TAB WRAP-UP
C
  500 Y(1) = PROP
      YO   = Y(1)
      RETURN
C
C
      ENTRY TAB1 (TABID,X,Y)
C     ======================
C
C     ENRTY FOR TABLE TRANSFORM
C
      ASSIGN 501 TO IHOP
      GO TO 220
  501 CONTINUE
C
C     L  POINTS  TO TABLE
C     ITYPE IS THE TABLE TYPE
C
      ITABL = IZ(L+2)
      NTABL = IZ(L+3)
      OMEGA = TWOPI*X
      GO TO (510,520,530,540), ITYPE
C
C     TABLED1
C
  510 CONTINUE
      X1 = 0.0
      X2 = 1.0
      GO TO 550
C
C     TABLED2
C
  520 CONTINUE
      X1 = Z(L+4)
      X2 = 1.0
      GO TO 550
C
C     TABLED3
C
  530 CONTINUE
      X1 = Z(L+4)
      X2 = Z(L+5)
      GO TO 550
C
C     TABLED4
C
  540 CONTINUE
C
C     EVALUATE SUM
C
  550 CONTINUE
      SUM = CMPLX(0.0,0.0)
      K   = ITABL
  551 CONTINUE
      YI   = Z(K+1)
      XI   = Z(K)
      YIP1 = Z(K+3)
      XIP1 = Z(K+2)
      OMEGAX = OMEGA*X2*(XIP1-XI)
      CALL IFTE2 (OMEGAX,RP,CP)
      P    =-OMEGA*(X1 + X2*XIP1)
      A    = CMPLX(0.,P)
      B    = CMPLX(RP,CP)
      TERM = CEXP(A)*B*YIP1
      P    =-OMEGA*(X1 + X2*XI)
      A    = CMPLX(0.,P)
      B    = CMPLX(RP,-CP)
      TERM = TERM + CEXP(A)*B*YI
      TERM = TERM*(XIP1- XI)*.5
      SUM  = SUM  + TERM
      K    = K + 2
      IF (K .LT. NTABL) GO TO 551
C
C     FINISH FUNCTION
C
      SUM  = SUM*X2
      Y(1) = REAL(SUM)
      Y(2) = AIMAG(SUM)
      RETURN
C
C     FATAL ERROR MESSAGES
C
 1010 MN = -1
      GO TO 1100
 1020 MN = -2
      GO TO 1100
 1040 MN = -3
      GO TO 1100
 1050 WRITE  (NOUT,1055) UFM,IZ(L)
 1055 FORMAT (A23,' 3308, TABLE',I9,' INTERPOLATION ERROR', /5X,
     1       'FUNCTION OVERFLOWED WHEN EXTRAPOLATION WAS MADE OUTSIDE ',
     2       'TABLE GIVEN RANGE.')
      MN = -37
      GO TO 1100
 1080 MN = -8
      DIT= ICRQ
 1100 CALL MESAGE (MN,DIT,NAME)
      RETURN
      END

      SUBROUTINE SELAS2
C*****
C THIS ROUTINE IS PHASE II OF STRESS DATA RECOVERY FOR THE SCALAR SPRING
C ELEMENTS ELAS1, ELAS2, ELAS3 AND ELAS4.
C*****
C
C
C
C
C SDR2 VARIABLE CORE
C
      COMMON   /ZZZZZZ/  ZZ(1)
C
C BLOCK FOR POINTERS, LOADING TEMPERATURE AND ELEMENT DEFORMATION.
C
      COMMON   /SDR2X4/
     1                   DUMMY(33)          ,ICSTM
     2,                  NCSTM              ,IVEC
     3,                  IVECN              ,TEMPLD
     4,                  ELDEFM
C
C SDR2 INPUT AND OUTPUT BLOCK
C
      COMMON   /SDR2X7/
     1                   JELID              ,ISILNO(2)
     2,                  STIFF              ,SCOEFF
     3,                  XXXXXX(95)
     4,                  JSELID             ,STRESS
     5,                  YYYYYY(98)
     6,                  JFELID             ,FORCE
     7,                  ZZZZZZ(23)
      EQUIVALENCE
     1                   (SCOEFF,ICOEFF)
C
C
C
      IDISP = IVEC - 1
      DISP1 = 0.0
      DISP2 = 0.0
      IF (ISILNO(1) .LE. 0) GO TO 10
      IU = IDISP + ISILNO(1)
      DISP1 = ZZ(IU)
   10 IF (ISILNO(2) .LE. 0) GO TO 20
      IU = IDISP + ISILNO(2)
      DISP2 = ZZ(IU)
   20 JFELID = JELID
      FORCE = STIFF * (DISP1 - DISP2)
      IF (ICOEFF .EQ. (-1)) RETURN
      STRESS = SCOEFF * FORCE
      JSELID = JELID
      RETURN
      END

      SUBROUTINE DPD2
C
C     DPD2 ASSEMBLES THE DYNAMIC LOADS TABLE (DLT).
C
      INTEGER         GPL   ,SIL   ,USET  ,USETD ,GPLD  ,SILD  ,DPOOL ,
     1                DLT   ,FRL   ,TFL   ,TRL   ,PSDL  ,EED   ,SCR1  ,
     2                SCR2  ,SCR3  ,SCR4  ,BUF   ,BUF1  ,BUF2  ,BUF3  ,
     3                BUF4  ,FLAG  ,FILE  ,EPOINT,SEQEP ,Z     ,LOADS ,
     5                SDT   ,DLOAD ,FREQ1 ,FREQ  ,TIC   ,TSTEP ,TF    ,
     6                PSD   ,EIGR  ,EIGB  ,EIGC  ,NGRID ,EQDYN ,SCR   ,
     7                BUFX
      DIMENSION       BUF(24)      ,EPOINT(2)    ,SEQEP(2)     ,MCB(7),
     1                NAM(2),LOADS(32)    ,DLOAD(2)     ,FREQ1(2)     ,
     2                FREQ(2)      ,ZZ(1) ,BUFR(20)     ,NOLIN(21)    ,
     3                TIC(2),TSTEP(2)     ,TF(2) ,PSD(2),MSG(3),EIGR(2)
     4,               EIGB(2)      ,EIGC(2)      ,SCR(4),BUFX(3)
      COMMON /BLANK / LUSET ,LUSETD,NOTFL ,NODLT ,NOPSDL,NOFRL ,NONLFT,
     1                NOTRL ,NOEED ,NOSDT ,NOUE
      COMMON /SYSTEM/ IDUMMY(55)   ,ITHRML
      COMMON /NAMES / RD    ,RDREW ,WRT   ,WRTREW,CLSREW
      COMMON /DPDCOM/ DPOOL ,GPL   ,SIL   ,USET  ,GPLD  ,SILD  ,USETD ,
     1                DLT   ,FRL   ,NLFT  ,TFL   ,TRL   ,PSDL  ,EED   ,
     2                SCR1  ,SCR2  ,SCR3  ,SCR4  ,BUF   ,BUF1  ,BUF2  ,
     3                BUF3  ,BUF4  ,EPOINT,SEQEP ,L     ,KN    ,NEQDYN,
     4                LOADS ,DLOAD ,FREQ1 ,FREQ  ,NOLIN ,NOGO  ,MSG   ,
     5                TIC   ,TSTEP ,TF    ,PSD   ,EIGR  ,EIGB  ,EIGC  ,
     6                MCB   ,NAM   ,EQDYN ,SDT   ,INEQ
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE     (Z(1),ZZ(1)), (BUF(1),BUFR(1)), (MSG(2),NGRID),
     1                (SCR1,SCR(1)),(BUF2 ,BUFX(1))
C
C     OPEN DYNAMICS POOL. SET POINTERS TO LOOP THRU DAREA, DELAY
C     AND DPHASE TABLES.
C
      FILE = DPOOL
      CALL PRELOC (*2001,Z(BUF1),DPOOL)
      II  = 1
      III = 1
      ITABL = NEQDYN + 2
      L   = 2
      J   = BUF4 - 1
      MSG(1) = 66
C
C     LOCATE CARD TYPE. IF PRESENT--
C     STORE POINTER TO 1ST TABLE NO. IN LOADS TABLE, OPEN SCRATCH FILE
C     FOR TABLES, SET ID = 0.
C
 1110 CALL LOCATE (*1141,Z(BUF1),LOADS(II),FLAG)
      LOADS(II+2) = J
      FILE = SCR(III)
      CALL OPEN (*2001,FILE,Z(BUF2),WRTREW)
      ID   = 0
C
C     READ A CARD. IF TABLE NO. IS DIFFERENT, STORE TABLE NO. IN TABLE
C     LIST.  IF NOT FIRST CARD, SORT TABLE ON SIL NO. AND WRITE ON
C     SCRATCH FILE.
C
 1120 CALL READ (*2002,*1140,DPOOL,BUF,4,0,FLAG)
      IF (BUF(1) .EQ. ID) GO TO 1130
      IF (ID .EQ. 0) GO TO 1122
      N = I - ITABL
      CALL SORT (0,0,2,1,Z(ITABL),N)
      CALL WRITE (FILE,Z(ITABL),N,1)
 1122 ID = BUF(1)
      Z(J) = ID
      J = J - 1
      I = ITABL
      MSG(3) = ID
C
C     CONVERT POINT AND COMPONENT TO SIL NO.
C     STORE SIL NO. AND VALUE IN CORE.
C
 1130 CALL DPDAA
      Z(I  ) = BUF(2)
      Z(I+1) = BUF(4)
      I = I + 2
      IF (I .LT. J) GO TO 1120
      CALL MESAGE (-8,0,NAM)
C
C     HERE WHEN LAST CARD OF CURRENT TYPE HAS BEEN READ--
C     SORT AND WRITE LAST RECORD. CLOSE SCRATCH FILE.  STORE
C     NUMBER OF TABLES IN TABLE LIST. TEST FOR ALL CARD TYPES PROCESSED.
C
 1140 N = I - ITABL
      CALL SORT (0,0,2,1,Z(ITABL),N)
      CALL WRITE (FILE,Z(ITABL),N,1)
      CALL CLOSE (FILE,CLSREW)
      LOADS(II+3) = LOADS(II+2) - J
 1141 II  = II  + 4
      III = III + 1
      IF (III .LE. 3) GO TO 1110
C
C     SET POINTERS TO LOOP THRU RLOAD1,2 AND TLOAD1,2 CARDS
C
      NCORE = J
      J     = 1
      III   = 1
      INEQ  = 0
C
C     LOCATE A CARD TYPE. IF PRESENT--
C     READ ALL CARDS OF TYPE INTO CORE.
C
 1160 CALL LOCATE (*1165,Z(BUF1),LOADS(II),FLAG)
      M = LOADS(II+2)
 1161 Z(J) = III
      CALL READ (*2002,*1165,DPOOL,Z(J+1),M,0,FLAG)
      J = J + 11
      IF (J .LT. NCORE) GO TO 1161
      CALL MESAGE (-8,0,NAM)
C
C     TEST FOR ALL CARD TYPES PROCESSED.
C     IF SO, SORT CARDS ON LOAD SET ID.
C
 1165 II  = II  + 4
      III = III + 1
      IF (III .LE. 4) GO TO 1160
      N   = J - 1
      IF (N .NE. 0) GO TO 1166
      CALL CLOSE (DPOOL,CLSREW)
      RETURN
C
 1166 CALL SORT (0,0,11,2,Z,N)
      NLIST = J - 11
C
C     LOCATE DLOAD CARDS ON DYNAMICS POOL.
C     IF PRESENT READ INTO CORE. SORT EACH DLOAD CARD ON REFERENCED SET
C     ID.
C
      NODLD  = 0
      CALL LOCATE (*1174,Z(BUF1),DLOAD,FLAG)
      IDLOAD = J
      I = IDLOAD
      J = I
 1171 CALL READ (*2002,*1174,DPOOL,Z(J+1),2,0,FLAG)
      J = J + 3
      NODLD = NODLD + 1
 1172 CALL READ (*2002,*2003,DPOOL,Z(J),2,0,FLAG)
      IF (Z(J) .EQ. -1) GO TO 1173
      J = J + 2
      IF (J .GE. NCORE) CALL MESAGE (-8,0,NAM)
      GO TO 1172
 1173 N = J - (I+3)
      CALL SORT (0,0,2,2,Z(I+3),N)
C
C     CHECK FOR DLOAD SET ID UNIQUENESS
C
      DO 11731 KK = 2,N,2
      JJ = I + 2 + KK
      IF (KK .GE. N) GO TO 11731
      IF (Z(JJ) .NE. Z(JJ+2)) GO TO 11731
      NOGO = 1
      MSG(2) = Z(I+1)
      MSG(3) = Z(JJ)
      CALL MESAGE (30,135,MSG(2))
11731 CONTINUE
      Z(I) = N + 2
      I = J
      GO TO 1171
 1174 CALL CLOSE (DPOOL,CLSREW)
C
C     OPEN THE DLT. WRITE NAME IN HEADER RECORD.
C     THEN WRITE NO. OF DLOAD CARDS FOLLOWED BY DLOAD SET IDS.
C     THEN WRITE SET IDS FOR EACH RECORD OF THE DLT (FOLLOWING DLOAD
C     RECORD)
C
      FILE = DLT
      CALL OPEN (*1249,DLT,Z(BUF1),WRTREW)
      CALL FNAME (DLT,BUF)
      BUF(3) = NODLD
      CALL WRITE (DLT,BUF,3,0)
      IF (NODLD .EQ. 0) GO TO 1182
      I = IDLOAD
      J = 1
 1181 CALL WRITE (DLT,Z(I+1),1,0)
      I = I + Z(I) + 1
      J = J + 1
      IF (J .LE. NODLD) GO TO 1181
C
C     CHECK DLOAD SID  VS  RLOAD1,2 AND TLOAD1,2 FOR UNIQUENESS
C
      I = IDLOAD
      DO 11810 JJ = 1,NODLD
      ITEMP = Z(I+1)
      DO 11811 KK = 1,NLIST,11
      IF (ITEMP .NE. Z(KK+1)) GO TO 11811
      NOGO = 1
      MSG(2) = ITEMP
      CALL MESAGE (30,136,MSG(2))
11811 CONTINUE
      I = I + Z(I) + 1
11810 CONTINUE
 1182 DO 1183 I = 1,NLIST,11
      BUF(1) = Z(I+1)
C
C     CHECK FOR UNIQUE SET IDS ON TLOAD1,2 AND RLOAD1,2 CARDS  THEN WRIT
C
      IF (I .GE. NLIST) GO TO 1184
      IF (Z(I+1) .NE. Z(I+12)) GO TO 1184
      NOGO = 1
      MSG(2) = ITEMP
      CALL MESAGE (30,136,MSG(2))
 1184 CALL WRITE (DLT,BUF,1,0)
 1183 CONTINUE
      CALL WRITE (DLT,0,0,1)
C
C     IF DLOAD CARDS PRESENT, WRITE THE DLOAD RECORD.
C
      IF (NODLD .EQ. 0) GO TO 1200
      BUF(1) = -1
      BUF(2) = -1
      I = IDLOAD
      J = 1
 1191 N = Z(I)
      CALL WRITE (DLT,Z(I+1),N,0)
      CALL WRITE (DLT,BUF,2,0)
      I = I + N + 1
      J = J + 1
      IF (J .LE. NODLD) GO TO 1191
      CALL WRITE (DLT,0,0,1)
C
C     INITIALIZE TO LOOP THRU ALL LOAD SETS. THE REMAINDER OF THE DLT
C     WILL CONSIST OF ONE LOGICAL RECORD PER LOAD SET.
C
 1200 I = 1
C
C     WRITE FIXED SECTION OF DLT RECORD.
C
 1205 BUF(1) = Z(I  )
      BUF(2) = Z(I+2)
C
C     SAVE INFORCED MOTION FLAG ON TLOAD CARDS
C
      IF (Z(I).LT.3 .OR. Z(I).GT.4) GO TO 1206
      IEMF = Z(I+4)
      Z(I+4) = 0
 1206 CONTINUE
      CALL WRITE (DLT,BUF,2,0)
      CALL WRITE (DLT,Z(I+5),6,0)
C
C     POSITION SCRATCH FILES TO SELECTED TABLES.
C
      IDAREA = 0
      DO 1215 J = 1,3
      BUF(2*J-1) = 16777215
C                  16777215 =2**24 - 1
      K = I + J
      BUF(J+16) = Z(K+1)
      IF (BUF(J+16) .EQ. 0) GO TO 1215
      JJ = LOADS(4*J-1)
      NN = LOADS(4*J  )
      IF (NN .EQ. 0) GO TO 1212
      DO 1211 NX = 1,NN
      IF (Z(JJ) .EQ. BUF(J+16)) GO TO 1213
      JJ = JJ - 1
 1211 CONTINUE
 1212 IF (ITHRML.NE.1 .OR. J.NE.1) GO TO 1300
      IDAREA  = -1
      BUF(17) = 0
      GO TO 1215
 1300 BUF(10) = Z(I+1)
      BUF(11) = BUF(J+16)
      BUF(11) = BUF(11) + 100000000*J
      NOGO    = 1
      CALL MESAGE (30,71,BUF(10))
      BUF(J+16) = 0
      GO TO 1215
 1213 NN   = NX - 1
      FILE = SCR(J)
      IBUF = BUFX(J)
      CALL OPEN (*2001,FILE,Z(IBUF),RDREW)
      IF (NN .EQ. 0) GO TO 1215
      DO 1214 NX = 1,NN
      CALL FWDREC (*2002,FILE)
 1214 CONTINUE
 1215 CONTINUE
C
C     INITIALIZE TABLE READ.
C
      BUF(14) = BUF(17)
      BUF(15) = BUF(18)
      BUF(16) = BUF(19)
C
C     READ AN ENTRY FROM APPROPRIATE TABLE/S).
C     IF ALL ENTRIES HAVE BEEN READ, GO TO CLOSE DLT RECORD.
C
 1220 DO 1222 J = 1,3
      IF (ITHRML.NE.1 .OR. J.NE.1) GO TO 1320
      IF (IDAREA .EQ. 0) GO TO 1320
      IF (IDAREA .EQ.-2) GO TO 1221
      IDAREA  = -2
      BUF(1)  = 1
      BUF(2)  = 0
      BUF(14) = 0
 1320 IF (BUF(J+13) .EQ. 0) GO TO 1222
      FILE = SCR(J)
      J2   = 2*J
      CALL READ (*2002,*1221,FILE,BUF(J2-1),2,0,FLAG)
      GO TO 1222
 1221 BUF(2*J-1) = 16777215
      BUF(J+13)  = 0
 1222 CONTINUE
      IF (BUF(1)+BUF(3)+BUF(5) .EQ. 3*16777215) GO TO 1240
C
C     SELECT MINIMUM SIL NO(S) AND FORMAT OUTPUT.
C
      DO 1231 J = 1,6
 1231 BUF(J+10) = 0
      BUF(7) = 1
      BUF(8) = 2
      BUF(9) = 3
      IF (BUF(1) .GT. BUF(3)) GO TO 1232
C
C     1 .LE. 2--COMPARE 2 TO 3. IF 2 .GT. 3, SWITCH 2 AND 3.
C
      IF (BUF(3) .LE. BUF(5)) GO TO 1234
      K = BUF(8)
      BUF(8) = BUF(9)
      BUF(9) = K
      GO TO 1233
C
C     1 .GT. 2--SWITCH 1 AND 2 THEN COMPARE 2 AND 3. IF 2 .GT. 3, SWITCH
C
 1232 K = BUF(7)
      BUF(7) = BUF(8)
      BUF(8) = K
      IF (BUF(1) .LE. BUF(5)) GO TO 1234
      K = BUF(8)
      BUF(8) = BUF(9)
      BUF(9) = K
C
C     COMPARE 1 TO 2--IF 1 .GT. 2, SWITCH 1 AND 2.
C
 1233 K = BUF(7)
      L = BUF(8)
      IF (BUF(2*K-1) .LE. BUF(2*L-1)) GO TO 1234
      BUF(7) = L
      BUF(8) = K
C
C     PICK UP 1. SET TO READ 1.
C
 1234 K = BUF(7)
      BUF(  10) = BUF(2*K-1)
      BUF(K+10) = BUF(2*K  )
      BUF(K+13) = K
C
C     IF 1 .EQ. 2, PICK UP 2 AND SET TO READ 2.
C
      L = BUF(8)
      IF (BUF(2*K-1) .NE. BUF(2*L-1)) GO TO 1235
      BUF(L+10) = BUF(2*L)
      BUF(L+13) = L
C
C     IF 1 .EQ. 2 .EQ. 3, PICK UP 3 AND SET TO READ 3.
C
      M = BUF(9)
      IF (BUF(2*L-1) .NE. BUF(2*M-1)) GO TO 1235
      BUF(M+10) = BUF(2*M)
      BUF(M+13) = M
C
C     WRITE SIL NO., A, TAU, THETA. THEN GO TO READ ANOTHER TABLE
C     ENTRY(S).
C
 1235 IF (Z(I).LT.3 .OR. Z(I).GT.4) GO TO 1236
      BUF(13) = IEMF
 1236 CALL WRITE (DLT,BUF(10),4,0)
      GO TO 1220
C
C     CLOSE DLT RECORD,  CLOSE TABLES AND TEST FOR COMPLETION OF DLT.
C
 1240 CALL WRITE (DLT,0,0,1)
      DO 1241 J = 1,3
      IF (BUF(J+16) .NE. 0) CALL CLOSE (SCR(J),CLSREW)
 1241 CONTINUE
      I = I + 11
      IF (I .LE. NLIST) GO TO 1205
C
C     CLOSE DLT, WRITE TRAILER AND RETURN.
C
      CALL CLOSE (DLT,CLSREW)
      MCB(1) = DLT
      MCB(2) = DLT
      CALL WRTTRL (MCB)
      NODLT = 1
 1249 RETURN
C
C     FATAL FILE ERRORS
C
 2001 N= -1
      GO TO 2005
 2002 N= -2
      GO TO 2005
 2003 N= -3
 2005 CALL MESAGE (N,FILE,NAM)
      RETURN
      END

      SUBROUTINE MATWRT (IFILE,XNAME,XITEM,LCORE)
C
      INTEGER         OTPE,SYSBUF
      DOUBLE PRECISION DCOL
      DIMENSION       IA(7),TYPE(10),FORM(18),DCOL(1),XNAME(2)
      COMMON /ZZZZZZ/ COL(1)
      COMMON /UNPAKX/ IT,K,L,INCR
      COMMON /SYSTEM/ SYSBUF,OTPE,INX(6),NLPP,INX1(2),LINE
      COMMON /OUTPUT/ HEAD1(96),HEAD2(96)
      EQUIVALENCE     (COL(1),DCOL(1))
      DATA    TYPE  / 4HREAL,4H    ,4HDB  ,4HPREC,4HCOMP,4HLEX ,4HCMP ,
     1                4HD.P.,4HILL ,4HDEFN/
      DATA    FORM  / 4HSQUA,4HRE  ,4HRECT,4HANG ,4HDIAG,4HONAL,4HLOW ,
     1                4HTRI ,4HUPP ,4HTRI ,4HSYME,4HTRIC,4HVECT,4HOR  ,
     2                4HIDEN,4HITY ,4HILL ,4HDEFN/
      DATA    BLANK , SU    ,BSTR  ,UCTU  ,RE    ,XIT   ,EM    ,CONT  /
     1        4H    , 4H  SU,4HBSTR,4HUCTU,4HRE  ,4H  IT,4HEM  ,4HCONT/
      DATA    XINUE , DX    /
     1        4HINUE, 4HD   /
C
C
C     TRANSFER MATRIX FORM SOF TO GINO
C
      CALL MTRXI (IFILE,XNAME,XITEM,0,ITEST)
      IF (ITEST .NE. 1) RETURN
      IA(1) = IFILE
      CALL RDTRL (IA(1))
C
      DO 10 I = 1,96
   10 HEAD2(I)  = BLANK
      HEAD2( 1) = SU
      HEAD2( 2) = BSTR
      HEAD2( 3) = UCTU
      HEAD2( 4) = RE
      HEAD2( 5) = XNAME(1)
      HEAD2( 6) = XNAME(2)
      HEAD2( 7) = XIT
      HEAD2( 8) = EM
      HEAD2( 9) = XITEM
      HEAD2(11) = CONT
      HEAD2(12) = XINUE
      HEAD2(13) = DX
      NAMEA = IFILE
      LCOL  = LCORE - SYSBUF
      INCR  = 1
      CALL GOPEN (NAMEA,COL(LCOL+1),0)
      IT = IA(5)
      IF (IT.LE.0 .OR. IT.GT.4) IT = 5
      IF = IA(4)
      IF (IF.LE.0 .OR. IF.GT.8) IF = 9
      NCOL = IA(2)
      NROW = IA(3)
      IF (IF .EQ. 7) NCOL = IA(3)
      CALL PAGE1
      WRITE (OTPE,20) XNAME,XITEM,TYPE(2*IT-1),TYPE(2*IT),NCOL,NROW,
     X                FORM(2*IF-1),FORM(2*IF)
   20 FORMAT (1H0,6X,13HSUBSTRUCTURE ,2A4,6H ITEM ,A4,6H IS A ,2A4,
     X        1X,I6,10H COLUMN X ,I6,5H ROW ,2A4,8H MATRIX. )
      IF (IT.EQ.5 .OR. IF.EQ.9 .OR. NCOL.EQ.0 .OR. NROW.EQ.0) GO TO 320
      IF (IF-8) 30,300,320
   30 IF (IF.NE.3 .AND. IF.NE.7) GO TO 40
      NCOL = 1
      NROW = IA(3)
   40 INULL= 0
      IT1  = 5
      IF (IT.EQ.1 .OR. IT.EQ.3) IT1 = 9
      ASSIGN 60 TO IHOP
      JJ = 1
   50 K  = 0
      L  = 0
      CALL UNPACK (*190,NAMEA,COL)
      IF (INULL .EQ. 1) GO TO 330
   60 NROW = L - K + 1
      GO TO (80,80,220,80,80,80,240), IF
   80 WRITE (OTPE,90) JJ,K,L
      LINE = LINE + 3
      IF (LINE .GE. NLPP) CALL PAGE
   90 FORMAT (8H0COLUMN ,I6,5X,6H ROWS ,I6,6H THRU ,I6,5X,50(1H-),/1H )
      IF (IT .GT. 2) NROW = 2*NROW
   91 K = 0
  100 J = K + 1
      IF (J .GT. NROW) GO TO 200
      K = J + IT1
      IF (K .GT. NROW) K = NROW
      GO TO (110,130,150,170), IT
C
C     REAL SINGLE PRECISION
C
  110 WRITE  (OTPE,120) (COL(I),I=J,K)
  120 FORMAT (1X,1P,10E13.5)
  121 LINE = LINE + 1
      IF (LINE .GE. NLPP) CALL PAGE
      GO TO 100
C
C     REAL DOUBLE PRECISION
C
  130 WRITE  (OTPE,140) (DCOL(I),I=J,K)
  140 FORMAT (1P,6D22.14)
      GO TO 121
C
C     COMPLEX SINGLE
C
  150 WRITE  (OTPE,160) (COL(I),I=J,K)
  160 FORMAT (5(1P,E12.4,1H+,1P,E12.4,1HI))
      GO TO 121
C
C     COMPLEX DOUBLE
C
  170 WRITE  (OTPE,180) (DCOL(I),I=J,K)
  180 FORMAT (3(1P,D20.12,1H+,1P,D20.12,2HI ))
      GO TO 121
  190 IF (INULL .EQ. 1) GO TO 200
      IBEGN = JJ
      INULL = 1
  200 JJ =  JJ + 1
      IF (JJ  .LE. NCOL) GO TO 50
      ASSIGN 210 TO IHOP
      IF (INULL .EQ. 1) GO TO 330
  210 CALL CLOSE (NAMEA,1)
      GO TO 270
  220 WRITE (OTPE,230)K,L
      LINE = LINE + 2
  230 FORMAT (30H0DIAGONAL ELEMENTS FOR COLUMNS,I6,3H TO,I7,4H ARE,/1H0)
      GO TO 91
  240 WRITE (OTPE,250) K,L
      LINE = LINE + 2
  250 FORMAT (25H0ROW ELEMENTS FOR COLUMNS,I6,4H TO ,I6,4H ARE ,/1H0 )
      GO TO 91
  270 WRITE  (OTPE,280) IA(6)
  280 FORMAT (53H0THE NUMBER OF NON-ZERO WORDS IN THE LONGEST RECORD =,
     1        I8 )
      IA7A = IA(7)/100
      IA7C = IA(7) - 100*IA7A
      IA7B = IA7C/10
      IA7C = IA7C - 10*IA7B
      WRITE  (OTPE,285) IA7A,IA7B,IA7C
  285 FORMAT (31H0THE DENSITY OF THIS MATRIX IS ,I3,1H.,I1,I1,
     1        9H PERCENT.)
  290 RETURN
C
  300 WRITE  (OTPE,310)
  310 FORMAT (16H0IDENTITY MATRIX)
  320 CALL CLOSE (NAMEA,1)
C
C     FUNNY MATRIX -- TABLE PRINT IT
C
      CALL TABPRT (NAMEA)
      GO TO 290
  330 IFIN = JJ - 1
      WRITE (OTPE,340) IBEGN,IFIN
      INULL = 0
      LINE  = LINE + 2
      IF (LINE .GE. NLPP) CALL PAGE
  340 FORMAT (9H0COLUMNS ,I7,6H THRU ,I7,10H ARE NULL.)
      GO TO IHOP, (60,210)
      END

      SUBROUTINE TIMTS1
C
C     TIMTS1 TIME TESTS GINO AND THE PACK ROUTINES
C
      EXTERNAL        ANDF
      INTEGER         SYSBUF, OUTPUT, FILES(2), F1, F2, BUF1, BUF2,
     1                END, RD(4), WRT(4), BCK(4), MCB(7), EOL, EOR,
     2                BLD(16), INT(16), PAK(16), UNP(16), TYPE, P,
     3                TYPIN1, TYPOU1, TYPOU2, ISUBR(2), ANDF, OPT1,
     4                OPT2, NAME(4), MASK( 9), ABLK(15), BBLK(15),
     5                GET(16), PUT(16)
      REAL            X(1), Z(1)
      DOUBLE PRECISION ZD, XD
      CHARACTER       UFM*23, UWM*25, UIM*29, SFM*25
      COMMON /XMSSG / UFM, UWM, UIM, SFM
      COMMON /BLANK / N, M, TYPE, OPT1, OPT2
      COMMON /SYSTEM/ SYSBUF, OUTPUT
      COMMON /ZBLPKX/ ZD(2), IZ
      COMMON /ZNTPKX/ XD(2), IX, EOL, EOR
      COMMON /PACKX / TYPIN1, TYPOU1, I1, J1, INCR1
      COMMON /UNPAKX/ TYPOU2, I2, J2, INCR2
      COMMON /ZZZZZZ/ A(1)
      EQUIVALENCE     (ZD(1),Z(1)),(XD(1),X(1))
      DATA    FILES / 301, 302 / , RD   / 1H , 1H , 1H , 4HREAD /
      DATA    I1000 / 1000     / , I1001/ 1001 /  ,
     1        WRT   / 1H , 1H , 4H   W, 4HRITE /  ,
     2        BCK   / 4H   B, 4HACKW,   4HARD , 4HREAD /
      DATA    BLD   / 1H , 4HBLDP, 4HK( R, 4HSP ) ,
     1                1H , 4HBLDP, 4HK( R, 4HDP ) ,
     2                1H , 4HBLDP, 4HK( C, 4HSP ) ,
     3                1H , 4HBLDP, 4HK( C, 4HDP ) /
      DATA    INT   / 1H , 4HINTP, 4HK( R, 4HSP ) ,
     1                1H , 4HINTP, 4HK( R, 4HDP ) ,
     2                1H , 4HINTP, 4HK( C, 4HSP ) ,
     3                1H , 4HINTP, 4HK( C, 4HDP ) /
      DATA    PAK   / 1H , 4H PAC, 4HK( R, 4HSP ) ,
     1                1H , 4H PAC, 4HK( R, 4HDP ) ,
     2                1H , 4H PAC, 4HK( C, 4HSP ) ,
     3                1H , 4H PAC, 4HK( C, 4HDP ) /
      DATA    UNP   / 1H , 4HUNPA, 4HK( R, 4HSP ) ,
     1                1H , 4HUNPA, 4HK( R, 4HDP ) ,
     2                1H , 4HUNPA, 4HK( C, 4HSP ) ,
     3                1H , 4HUNPA, 4HK( C, 4HDP ) /
      DATA    PUT   / 4H   P, 4HUTST, 4HR( R, 4HSP ) ,
     1                4H   P, 4HUTST, 4HR( R, 4HDP ) ,
     2                4H   P, 4HUTST, 4HR( C, 4HSP ) ,
     3                4H   P, 4HUTST, 4HR( C, 4HDP ) /
      DATA    GET   / 4H   G, 4HETST, 4HR( R, 4HSP ) ,
     1                4H   G, 4HETST, 4HR( R, 4HDP ) ,
     2                4H   G, 4HETST, 4HR( C, 4HSP ) ,
     3                4H   G, 4HETST, 4HR( C, 4HDP ) /
      DATA    NMASK / 9 /
      DATA    ISUBR / 4HTIMT, 4HS1  /
C
C     INITIALIZE
C
      CALL PAGE1
      F1   = FILES(1)
      F2   = FILES(2)
      BUF1 = KORSZ(A) - SYSBUF
      BUF2 = BUF1 - SYSBUF
      END  = N*M
      IF (END .GE. BUF1-1) CALL MESAGE (-8,0,ISUBR)
      DO 12 I = 1,END
      A(I) = I
   12 CONTINUE
      N10  = N*10
      M10  = M/10
      IF (M10 .LE. 0) M10 = 1
      FN = N
      FM = M
      P  = 4*(TYPE-1) + 1
      MASK(1) = 1
      DO 14 I = 2,NMASK
   14 MASK(I) = 2*MASK(I-1)
      WRITE  (OUTPUT,11) N, M, TYPE, OPT1, OPT2
   11 FORMAT (1H  , 20X, 25HNASTRAN TIME TEST C   N =, I4, 5H, M =, I4 ,
     1         8H, TYPE =,I4, 8H, OPT1 =,I4, 8H, OPT2 =,I4)
C
C     WRITE TEST
C
      IF (ANDF(OPT2,MASK(1)) .EQ. 0) GO TO 50
      CALL OPEN (*901,F1,A(BUF1),1)
      CALL CPUTIM (T1,T1,1)
      DO 21 I = 1,N
      CALL WRITE (F1,A,M,1)
   21 CONTINUE
      CALL CPUTIM (T2,T1,1)
      CALL CLOSE  (F1,1)
      CALL OPEN (*901,F2,A(BUF2),1)
      CALL CPUTIM (T3,T3,1)
      DO 22 I = 1,N10
      CALL WRITE (F2,A,M10,1)
   22 CONTINUE
      CALL CPUTIM (T4,T4,1)
      CALL CLOSE  (F2,1)
      ASSIGN 30 TO IRET
      NAME(1) = WRT(1)
      NAME(2) = WRT(2)
      NAME(3) = WRT(3)
      NAME(4) = WRT(4)
      GO TO 100
C
C     READ TEST
C
   30 CONTINUE
      IF (ANDF(OPT2,MASK(2)) .EQ. 0) GO TO 40
      CALL OPEN (*901,F1,A(BUF1),0)
      CALL CPUTIM (T1,T1,1)
      DO 31 I = 1,N
      CALL READ (*902,*903,F1,A(I1000),M,1,FLAG)
   31 CONTINUE
      CALL CPUTIM (T2,T2,1)
      CALL CLOSE  (F1,2)
      CALL OPEN (*901,F2,A(BUF2),0)
      CALL CPUTIM (T3,T3,1)
      DO 32 I = 1,N10
      CALL READ (*902,*903,F2,A(I1000),M10,1,FLAG)
   32 CONTINUE
      CALL CPUTIM (T4,T4,1)
      CALL CLOSE  (F2,2)
      ASSIGN 40 TO IRET
      NAME(1) = RD(1)
      NAME(2) = RD(2)
      NAME(3) = RD(3)
      NAME(4) = RD(4)
      GO TO 100
C
C     BACKWARD READ TEST
C
   40 CONTINUE
      IF (ANDF(OPT2,MASK(3)) .EQ. 0) GO TO 50
      CALL OPEN (*901,F1,A(BUF1),2)
      CALL CPUTIM (T1,T1,1)
      DO 41 I = 1,N
      CALL BCKREC (F1)
      CALL READ (*902,*903,F1,A(I1000),M,1,FLAG)
      CALL BCKREC (F1)
   41 CONTINUE
      CALL CPUTIM (T2,T2,1)
      CALL CLOSE  (F1,1)
      CALL OPEN (*901,F2,A(BUF2),2)
      CALL CPUTIM (T3,T3,1)
      DO 42 I = 1,N10
      CALL BCKREC (F2)
      CALL READ (*902,*903,F2,A(I1000),M10,1,FLAG)
      CALL BCKREC (F2)
   42 CONTINUE
      CALL CPUTIM (T4,T4,1)
      CALL CLOSE  (F2,1)
      ASSIGN 50 TO IRET
      NAME(1) = BCK(1)
      NAME(2) = BCK(2)
      NAME(3) = BCK(3)
      NAME(4) = BCK(4)
      GO TO 100
C
C     BLDPK TEST
C
   50 CONTINUE
      IF (ANDF(OPT2,MASK(4)) .EQ. 0) GO TO 70
      CALL OPEN (*901,F1,A(BUF1),1)
      CALL MAKMCB (MCB,F1,M,2,TYPE)
      CALL CPUTIM (T1,T1,1)
      DO 51 I = 1,N
      CALL BLDPK (TYPE,TYPE,F1,0,0)
      DO 52 J = 1,M
      Z(1) = 1.0
      IZ   = J
      CALL ZBLPKI
   52 CONTINUE
      CALL BLDPKN (F1,0,MCB)
   51 CONTINUE
      CALL CPUTIM (T2,T2,1)
      CALL WRTTRL (MCB)
      CALL CLOSE  (F1,1)
      CALL MAKMCB (MCB,F2,M10,2,TYPE)
      CALL OPEN (*901,F2,A(BUF2),1)
      CALL CPUTIM (T3,T3,1)
      DO 54 I = 1,N10
      CALL BLDPK (TYPE,TYPE,F2,0,0)
      DO 55 J = 1,M10
      Z(1) = 2.0
      IZ   = J
      CALL ZBLPKI
   55 CONTINUE
      CALL BLDPKN (F2,0,MCB)
   54 CONTINUE
      CALL CPUTIM (T4,T4,1)
      CALL WRTTRL (MCB)
      CALL CLOSE  (F2,1)
      ASSIGN 60 TO IRET
      NAME(1) = BLD(P)
      NAME(2) = BLD(P+1)
      NAME(3) = BLD(P+2)
      NAME(4) = BLD(P+3)
      GO TO 100
C
C     INTPK TEST
C
   60 CONTINUE
      IF (ANDF(OPT2,MASK(5)) .EQ. 0) GO TO 70
      CALL OPEN (*901,F1,A(BUF1),0)
      CALL CPUTIM (T1,T1,1)
      DO 61 I = 1,N
      CALL INTPK (*902,F1,0,TYPE,0)
      DO 62 J = 1,M
      CALL ZNTPKI
      IF (IX  .NE. J) GO TO 110
      IF (EOL .EQ. 0) GO TO 62
      IF (IX  .NE. M) GO TO 110
   62 CONTINUE
      IF (EOL .EQ. 0) GO TO 110
   61 CONTINUE
      CALL CPUTIM (T2,T2,1)
      CALL CLOSE  (F1,1)
      CALL OPEN (*901,F2,A(BUF2),0)
      CALL CPUTIM (T3,T3,1)
      DO 63 I = 1,N10
      CALL INTPK (*902,F2,0,TYPE,0)
      DO 64 J = 1,M10
      CALL ZNTPKI
      IF (IX  .NE.   J) GO TO 110
      IF (EOL .EQ.   0) GO TO 64
      IF (IX  .NE. M10) GO TO 110
   64 CONTINUE
      IF (EOL .EQ. 0) GO TO 110
   63 CONTINUE
      CALL CPUTIM (T4,T4,1)
      CALL CLOSE  (F2,1)
      ASSIGN 70 TO IRET
      NAME(1) = INT(P)
      NAME(2) = INT(P+1)
      NAME(3) = INT(P+2)
      NAME(4) = INT(P+3)
      GO TO 100
C
C     PACK TEST
C
   70 CONTINUE
      IF (ANDF(OPT2,MASK(6)) .EQ. 0) GO TO 90
      CALL MAKMCB (MCB,F1,M,2,TYPE)
      TYPIN1 = TYPE
      TYPOU1 = TYPE
      I1 = 1
      J1 = M
      INCR1 = 1
      MX = M*TYPE
      DO 72 I = 1,MX
      A(I+1000) = I
   72 CONTINUE
      CALL OPEN (*901,F1,A(BUF1),1)
      CALL CPUTIM (T1,T1,1)
      DO 73 I = 1,N
      CALL PACK (A(I1001),F1,MCB)
   73 CONTINUE
      CALL CPUTIM (T2,T2,1)
      CALL WRTTRL (MCB)
      CALL CLOSE  (F1,1)
      CALL MAKMCB (MCB,F2,M10,2,TYPE)
      J1 = M10
      CALL OPEN (*901,F2,A(BUF2),1)
      CALL CPUTIM (T3,T3,1)
      DO 75 I = 1,N10
      CALL PACK (A(I1001),F2,MCB)
   75 CONTINUE
      CALL CPUTIM (T4,T4,1)
      CALL WRTTRL (MCB)
      CALL CLOSE  (F2,1)
      ASSIGN 80 TO IRET
      NAME(1) = PAK(P)
      NAME(2) = PAK(P+1)
      NAME(3) = PAK(P+2)
      NAME(4) = PAK(P+3)
      GO TO 100
C
C     UNPACK TEST
C
   80 CONTINUE
      IF (ANDF(OPT2,MASK(7)) .EQ. 0) GO TO 90
      TYPOU2 = TYPE
      I2 = 1
      J2 = M
      INCR2 = 1
      CALL OPEN (*901,F1,A(BUF1),0)
      CALL CPUTIM (T1,T1,1)
      DO 81 I = 1,N
      CALL UNPACK (*902,F1,A(I1001))
   81 CONTINUE
      CALL CPUTIM (T2,T2,1)
      CALL CLOSE  (F1,1)
      J2 = M10
      CALL OPEN (*901,F2,A(BUF2),0)
      CALL CPUTIM (T3,T3,1)
      DO 82 I = 1,N10
      CALL UNPACK (*902,F2,A(I1001))
   82 CONTINUE
      CALL CPUTIM (T4,T4,1)
      CALL CLOSE  (F2,2)
      ASSIGN 90 TO IRET
      NAME(1) = UNP(P)
      NAME(2) = UNP(P+1)
      NAME(3) = UNP(P+2)
      NAME(4) = UNP(P+3)
      GO TO 100
   90 CONTINUE
C
C     PUTSTR TEST
C
C
      IF (ANDF(OPT2,MASK(8)) .EQ. 0) GO TO 220
      KERR = 1
      ABLK(1) = F1
      ABLK(2) = TYPE
      ABLK(3) = 1
      CALL GOPEN (F1,A(BUF1),1)
      NWDS = TYPE
      IF (TYPE .EQ. 3) NWDS = 2
      CALL CPUTIM (T1,T1,1)
      DO 95 I = 1,N
      ABLK(4) = 0
      ABLK(8) = -1
      DO 94 J = 1,10
      NBRSTR  = M10
   91 CALL PUTSTR (ABLK)
      IF( NBRSTR .EQ. 0) GO TO 910
      ABLK(7) = MIN0(ABLK(6),NBRSTR)
      ABLK(4) = ABLK(4) + ABLK(7) + 4
      MM = ABLK(7)*NWDS
      DO 92 K = 1,MM
      X(1) = A(K)
   92 CONTINUE
      IF (ABLK(7) .EQ. NBRSTR) GO TO 93
      CALL ENDPUT (ABLK)
      NBRSTR = NBRSTR - ABLK(7)
      GO TO 91
   93 IF (J .EQ. 10) ABLK(8) = 1
      CALL ENDPUT (ABLK)
   94 CONTINUE
   95 CONTINUE
      CALL CPUTIM (T2,T2,1)
      CALL CLOSE  (F1,1)
      M100 = MAX0(M10/10,1)
      CALL GOPEN (F2,A(BUF2),1)
      KERR = 2
      BBLK(1) = F2
      BBLK(2) = TYPE
      BBLK(3) = 1
      CALL CPUTIM (T3,T3,1)
      DO 209 I = 1,N10
      BBLK(4) = 0
      BBLK(8) = -1
      DO 208 J = 1,10
      NBRSTR = M100
  202 CALL PUTSTR (BBLK)
      IF (NBRSTR .EQ. 0) GO TO 910
      BBLK(7) = MIN0(BBLK(6),NBRSTR)
      BBLK(4) = BBLK(4) + BBLK(7) + 4
      MM = BBLK(7)*NWDS
      DO 203 K = 1,MM
      X(1) = A(K)
  203 CONTINUE
      IF (BBLK(7) .EQ. NBRSTR) GO TO 206
      NBRSTR = NBRSTR - BBLK(7)
      GO TO 202
  206 IF (J .EQ. 10) BBLK(8) = 1
      CALL ENDPUT (BBLK)
  208 CONTINUE
  209 CONTINUE
      CALL CPUTIM (T4,T4,1)
      CALL CLOSE  (F2,1)
      ASSIGN 210 TO IRET
      NAME(1) = PUT(P)
      NAME(2) = PUT(P+1)
      NAME(3) = PUT(P+2)
      NAME(4) = PUT(P+3)
      GO TO 100
C
C     GETSTR TEST
C
  210 IF (ANDF(OPT2,MASK(9)) .EQ. 0) GO TO 220
      CALL GOPEN (F1,A(BUF1),0)
      CALL CPUTIM (T1,T1,1)
      DO 214 I = 1,N
      ABLK(8) = -1
  211 CALL GETSTR (*214,ABLK)
      MM = ABLK(6)*NWDS
      DO 212 K = 1,MM
      X(1) = A(K)
  212 CONTINUE
      CALL ENDGET (ABLK)
      GO TO 211
  214 CONTINUE
      CALL CPUTIM (T2,T2,1)
      CALL CLOSE  (F1,1)
      CALL GOPEN  (F2,A(BUF2),0)
      CALL CPUTIM (T3,T3,1)
      DO 219 I = 1,N10
      BBLK(8) = -1
  215 CALL GETSTR (*219,BBLK)
      MM = BBLK(6)*NWDS
      DO 216 K = 1,MM
      X(1) = A(K)
  216 CONTINUE
      CALL ENDGET (BBLK)
      GO TO 215
  219 CONTINUE
      CALL CPUTIM (T4,T4,1)
      CALL CLOSE  (F2,1)
      ASSIGN 220 TO IRET
      NAME(1) = GET(P)
      NAME(2) = GET(P+1)
      NAME(3) = GET(P+2)
      NAME(4) = GET(P+3)
      GO TO 100
C
  220 CONTINUE
      RETURN
C
C
C     INTERNAL ROUTINE TO WRITE OUTPUT ONTO THE OUTPUT FILE
C
  100 CONTINUE
      TIME1 = T2 - T1
      TIME2 = T4 - T3
      TPRREC = 1.0E6*(TIME2 - TIME1)/(9.0*FN)
      TPRWRD = (1.0E6*TIME1 - FN*TPRREC)/(FN*FM)
C
      WRITE  (OUTPUT,111) NAME, TIME1, NAME, TIME2, TPRWRD, TPRREC
  111 FORMAT (1H0, 4A4,
     1        '   N     M-WORD RECORDS -- TIME1 = ', E12.5, ' SECONDS'/
     2        1X , 4A4,
     3        ' 10*N M/10-WORD RECORDS -- TIME2 = ', E12.5, ' SECONDS'/
     4        1H0,'IF THE MODEL IS TIME = (N*M)TPRWRD + N*TPRREC, THEN'/
     5        1H0, 16X,
     6        '     -- TIME PER WORD   (TPRWRD) = ', E12.5, ' MICRO',
     7        'SECONDS  --  DATA FOR USE IN COMMON /NTIME/'/
     8        1X , 16X,
     9        '     -- TIME PER RECORD (TPRREC) = ', E12.5, ' MICRO',
     O        'SECONDS')
C
      GO TO IRET, (30,40,50,60,70,80,90,210,220)
C
C     INTERNAL ROUTINE CALLED FOR AN ABORT IN THE INTPK TEST
C
  110 CONTINUE
      WRITE  (OUTPUT,121) SFM,INT(P),INT(P+1),INT(P+2),INT(P+3)
  121 FORMAT (A25,' 2197, ABORT CALLED DURING TIME TEST OF ',4A4)
C
C     ABNORMAL RETURNS FROM GINO--ALL FATAL ERRORS
C
  901 CONTINUE
  902 CONTINUE
  903 CALL MESAGE (-61,0,0)
  910 WRITE  (OUTPUT,911) KERR
  911 FORMAT (23H0*** TIMTS1 FATAL ERROR,I4 )
      GO TO 903
      END

      SUBROUTINE SMCCCD ( DTEMP, ZIL, ILIM, ZOL )
      DOUBLE COMPLEX      DTEMP( ILIM ), ZIL( ILIM ), ZOL
      DO 10 I = 1, ILIM
      DTEMP( I ) = DTEMP( I ) + ZIL( I ) * ZOL
10    CONTINUE
      RETURN
      END
      
      

      SUBROUTINE YRCARD (OUT,NFLAG,IN)
C
C     THIS WAS NASTRAN ORIGINAL XRCARD ROUTINE, AND IS NOW RENAMED
C     YRCARD
C     THIS ROUTINE IS CALLED ONLY BY XRCARD
C     THIS ROUTINE CAN BE DELETED IF THE NEW XRCARD ROUTINE PASSES
C     ALL RELIABILITY TESTS                 G.CHAN/UNISYS,  2/1988
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL         LSHIFT,RSHIFT,COMPLF
      LOGICAL          ALPHA,DELIM,EXPONT,POWER,LMINUS,PASS,NOGO
      REAL             FL1
      DOUBLE PRECISION XDOUBL
      DIMENSION        NDOUBL(2),NUM(10),TYPE(72),CHAR(72),OUT(1),
     1                 IN(18),NT(15),CHARS(13)
      CHARACTER        UFM*23
      COMMON /XMSSG /  UFM
      COMMON /LHPWX /  LOWPW,HIGHPW
      COMMON /SYSTEM/  IBUFSZ,F6,NOGO,DUM1(7),NPAGES,NLINES
      EQUIVALENCE      (FL1      ,INT1  ), (XDOUBL,NDOUBL(1)),
     1                 (NUM(10)  ,ZERO  ), (CHARS( 1),DOLLAR),
     2                 (CHARS( 2),PLUS  ), (CHARS( 3),EQUAL ),
     3                 (CHARS( 4),MINUS ), (CHARS( 5),COMMA ),
     4                 (CHARS( 6),SLASH ), (CHARS( 7),OPAREN),
     5                 (CHARS( 8),CPAREN), (CHARS( 9),E     ),
     6                 (CHARS(10),D     ), (CHARS(11),PERIOD),
     7                 (CHARS(12),BLANK ), (CHARS(13),ASTK  )
      DATA    BLANKS/  4H     /, BLANK / 4H     /, DOLLAR/ 4H$    /,
     1        EQUAL /  1H=    /, ASTK  / 1H*    /, COMMA / 1H,    /,
     2        SLASH /  1H/    /, CPAREN/ 1H)    /, OPAREN/ 1H(    /,
     3        PLUS  /  1H+    /, MINUS / 1H-    /, PERIOD/ 1H.    /,
     4        E     /  1HE    /, D     / 1HD    /, PASS  / .FALSE./,
     5        NUM   /  1H1, 1H2, 1H3,1H4,1H5, 1H6, 1H7,1H8,1H9,1H0/
C
      IF (PASS) GO TO 50
      PASS   = .TRUE.
      A77777 = COMPLF(0)
      A67777 = RSHIFT(LSHIFT(A77777,1),1)
C
C     READ AND TYPE 72 CHARACTERS
C
   50 N = 0
      DO 90 I = 1,18
      DO 90 J = 1,4
      N = N + 1
      CHARAC = KHRFN1(BLANKS,1,IN(I),J)
      IF (CHARAC .EQ. BLANK) GO TO 70
      DO 60 K = 1,10
      IF (CHARAC .EQ. NUM(K)) GO TO 80
   60 CONTINUE
      TYPE(N) = -1
      GO TO 90
   70 TYPE(N) = 0
      GO TO 90
   80 TYPE(N) = 1
   90 CHAR(N) = CHARAC
      ALPHA = .FALSE.
      DELIM = .TRUE.
      IOUT  = 0
      N     = 0
      ASAVE = 1
      OUT(ASAVE) = 0
  100 IF (N .EQ. 72) GO TO 510
      IF (NFLAG-IOUT .LT. 5) GO TO 660
      LMINUS = .FALSE.
      N = N + 1
      NCHAR = CHAR(N)
      IF (TYPE(N)) 110,100,210
  110 IF (NCHAR.EQ.PLUS .OR. NCHAR.EQ.MINUS .OR. NCHAR.EQ.PERIOD)
     1    GO TO 200
      IF (NCHAR .EQ. DOLLAR) GO TO 180
C
C     GOOD ALPHA FIELD OR DELIMETER
C
      IF (ALPHA) GO TO 120
      IF ((NCHAR.EQ.COMMA .OR. NCHAR.EQ.DOLLAR) .AND. (.NOT.DELIM))
     1    GO TO 180
      IF (NCHAR.EQ.CPAREN .AND. .NOT.DELIM) GO TO 180
      IOUT  = IOUT + 1
      ASAVE = IOUT
      OUT(ASAVE) = 0
      ALPHA = .TRUE.
  120 IF (NCHAR.EQ.OPAREN .OR. NCHAR.EQ.SLASH .OR. NCHAR.EQ.EQUAL .OR.
     1    NCHAR.EQ.COMMA  .OR. NCHAR.EQ.ASTK  .OR. NCHAR.EQ.DOLLAR)
     2    GO TO 180
      IF (NCHAR .EQ. CPAREN) GO TO 180
      OUT(ASAVE) = OUT(ASAVE) + 1
      IOUT  = IOUT + 2
      DELIM = .FALSE.
      OUT(IOUT-1) = BLANKS
      OUT(IOUT  ) = BLANKS
      ICHAR = 0
      GO TO 150
  130 IF (N .EQ. 72) GO TO 510
      N = N + 1
      NCHAR = CHAR(N)
      IF (TYPE(N)) 140,100,150
  140 IF (NCHAR.EQ.OPAREN .OR. NCHAR.EQ.SLASH .OR. NCHAR.EQ.EQUAL .OR.
     1    NCHAR.EQ.COMMA  .OR. NCHAR.EQ.ASTK  .OR. NCHAR.EQ.DOLLAR)
     2    GO TO 180
      IF (NCHAR .EQ. CPAREN) GO TO 180
  150 IF (ICHAR .EQ. 8) GO TO 130
      ICHAR = ICHAR + 1
      IF (ICHAR .LE. 4) GO TO 160
      IPOS = ICHAR - 4
      WORD = IOUT
      GO TO 170
  160 IPOS = ICHAR
      WORD = IOUT - 1
C
C     CLEAR SPOT IN WORD FOR CHAR(N) AND PUT CHAR(N) IN IT
C
  170 OUT(WORD) = KHRFN1(OUT(WORD),IPOS,NCHAR,1)
C
C     GO FOR NEXT CHARACTER
C
      GO TO 130
C
C
C     DELIMETER HIT
C
  180 IF (.NOT. DELIM) GO TO 190
      IF (IOUT .EQ. 0) IOUT = 1
      IOUT = IOUT + 2
      OUT(ASAVE)  = OUT(ASAVE) + 1
      OUT(IOUT-1) = BLANKS
      OUT(IOUT  ) = BLANKS
  190 IF (NCHAR .EQ. DOLLAR) GO TO 520
      DELIM = .TRUE.
      IF (NCHAR .EQ. CPAREN) DELIM = .FALSE.
      IF (NCHAR .EQ.  COMMA) GO TO 100
      IF (NCHAR .EQ. CPAREN) GO TO 100
C
C     OUTPUT DELIMETER
C
      IOUT = IOUT + 2
      OUT(ASAVE ) = OUT(ASAVE) + 1
      OUT(IOUT-1) = A77777
      OUT(IOUT  ) = KHRFN1(BLANKS,1,NCHAR,1)
      GO TO 100
C
C
  200 IF (NCHAR .EQ.  MINUS) LMINUS = .TRUE.
      IF (NCHAR .NE. PERIOD) N = N + 1
      IF (N .GT. 72) GO TO 530
C
  210 ALPHA = .FALSE.
      DELIM = .FALSE.
      IT = 0
      NT(1) = 0
      DO 260 I = N,72
      IF (TYPE(I)) 290,270,220
C
C     INTEGER CHARACTER
C
  220 DO 230 K = 1,9
      IF (CHAR(I) .EQ. NUM(K)) GO TO 250
  230 CONTINUE
      K  = 0
  250 IT = IT + 1
      IF (IT .LT. 16) NT(IT) = K
  260 CONTINUE
C
C     FALL HERE IMPLIES WE HAVE A SIMPLE INTEGER
C
  270 NUMBER = 0
      DO 280 I = 1,IT
      IF (((A67777-NT(I))/10) .LT. NUMBER) GO TO 550
  280 NUMBER = NUMBER*10 + NT(I)
      IF (LMINUS) NUMBER = - NUMBER
      IOUT = IOUT + 2
      OUT(IOUT-1) = -1
      OUT(IOUT  ) = NUMBER
      N = N + IT - 1
      GO TO 100
C
C     REAL NUMBER, DELIMETER, OR ERROR IF FALL HERE
C
C     COUNT THE NUMBER OF DIGITS LEFT BEFORE CARD END OR DELIMETER HIT
C
  290 N1 = I
      DO 300 N2 = N1,72
      IF (CHAR(N2).EQ.OPAREN .OR. CHAR(N2).EQ.SLASH .OR.
     1    CHAR(N2).EQ.EQUAL  .OR. CHAR(N2).EQ.COMMA .OR.
     2    CHAR(N2).EQ.DOLLAR .OR. TYPE(N2).EQ.0) GO TO 310
      IF (CHAR(N2) .EQ. CPAREN) GO TO 310
  300 CONTINUE
      N2 = 73
  310 IF (N1 .EQ. N2) GO TO 270
C
C     CHARACTER N1 NOW MUST BE A DECIMAL FOR NO ERROR
C
      IF (CHAR(N1) .NE. PERIOD) GO TO 570
      POWER = .FALSE.
      N1 = N1 + 1
      N2 = N2 - 1
      PLACES = 0
      PSIGN  = 0
      EXPONT = .FALSE.
      IPOWER = 0
      PRECIS = 0
      IF (N2 .LT. N1) GO TO 410
      DO 400 I = N1,N2
      IF (TYPE(I)) 360,570,320
C
C     NUMERIC
C
  320 DO 330 K = 1,9
      IF (CHAR(I) .EQ. NUM(K)) GO TO 340
  330 CONTINUE
      K  = 0
  340 IF (EXPONT) GO TO 350
      IT = IT + 1
      IF (IT .LT. 16) NT(IT) = K
      PLACES = PLACES + 1
      GO TO 400
C
C     BUILD IPOWER HERE
C
  350 POWER  = .TRUE.
      IPOWER = IPOWER*10 + K
      IF (IPOWER .GT. 1000) GO TO 630
      GO TO 400
C
C     START EXPONENTS HERE
C
  360 IF (EXPONT) GO TO 380
      EXPONT = .TRUE.
      IF (CHAR(I).NE.PLUS .AND. CHAR(I).NE.MINUS) GO TO 370
      PRECIS = E
      PSIGN = CHAR(I)
      GO TO 390
  370 IF (CHAR(I).NE.E .AND. CHAR(I).NE.D) GO TO 600
      PRECIS = CHAR(I)
      GO TO 390
C
C     SIGN OF POWER
C
  380 IF (POWER) GO TO 590
      IF (PSIGN.NE.0 .OR.(CHAR(I).NE.PLUS .AND. CHAR(I).NE.MINUS))
     1    GO TO 610
      PSIGN = CHAR(I)
      POWER = .TRUE.
  390 IF (I .EQ. 72) GO TO 530
  400 CONTINUE
  410 N = N2
C
C     ALL DATA COMPLETE FOR FLOATING POINT NUMBER
C     15 FIGURES WILL BE ACCEPTED ONLY
C
      IF (IT .LE. 15) GO TO 420
      IPOWER = IPOWER + IT - 15
      IT = 15
  420 IF (PSIGN .EQ. MINUS) IPOWER = -IPOWER
      IPOWER = IPOWER - PLACES
      NUMBER = 0
      IF (IT .LT. 7) GO TO 430
      N2 = 7
      GO TO 440
  430 N2 = IT
  440 DO 450 I = 1,N2
  450 NUMBER = NUMBER*10 + NT(I)
      XDOUBL = DBLE(FLOAT(NUMBER))
      IF (IT .LE. 7) GO TO 470
      NUMBER = 0
      N2 = IT - 7
      DO 460 I = 1,N2
      IT = I + 7
  460 NUMBER = NUMBER*10 + NT(IT)
      XDOUBL = XDOUBL*10.0D0**N2 + DBLE(FLOAT(NUMBER))
  470 IF (LMINUS) XDOUBL = -XDOUBL
C
C     POWER HAS TO BE WITHIN RANGE OF MACHINE
C
      ICHEK = IPOWER + IT
      IF (XDOUBL .EQ. 0.0D0) GO TO 490
      IF (ICHEK .LT.LOWPW+1 .OR. ICHEK .GT.HIGHPW-1 .OR.
     1    IPOWER.LT.LOWPW+1 .OR. IPOWER.GT.HIGHPW-1) GO TO 640
      XDOUBL = XDOUBL*10.0D0**IPOWER
  490 IF (PRECIS .EQ. D) GO TO 500
      FL1  = XDOUBL
      IOUT = IOUT + 2
      OUT(IOUT-1) =-2
      OUT(IOUT  ) = INT1
      GO TO 100
  500 IOUT = IOUT + 3
      OUT(IOUT-2) =-4
      OUT(IOUT-1) = NDOUBL(1)
      OUT(IOUT  ) = NDOUBL(2)
      GO TO 100
C
C
C     PREPARE TO RETURN
C
  510 IF (.NOT. DELIM) GO TO 520
      OUT(IOUT+1) = 0
      RETURN
  520 OUT(IOUT+1) = A67777
      RETURN
C
C     ERRORS
C
  530 WRITE  (F6,540) UFM
  540 FORMAT (A23,' 300 *** INVALID DATA COLUMN 72')
      GO TO  680
  550 WRITE  (F6,560) UFM
  560 FORMAT (A23,' 300 *** INTEGER DATA OUT OF MACHINE RANGE')
      GO TO  680
  570 WRITE  (F6,580) UFM,N1
  580 FORMAT (A23,' 300 *** INVALID CHARACTER FOLLOWING INTEGER IN ',
     1       'COLUMN',I3)
      GO TO  680
  590 CONTINUE
  600 CONTINUE
  610 WRITE  (F6,620) UFM,I
  620 FORMAT (A23,' 300 *** DATA ERROR-UNANTICIPATED CHARACTER IN ',
     1       'COLUMN',I3)
      GO TO  680
  630 CONTINUE
  640 WRITE  (F6,650) UFM
  650 FORMAT (A23,' 300 *** DATA ERROR - MISSING DELIMITER OR REAL ',
     1       'POWER OUT OF MACHINE RANGE')
      GO TO  680
  660 WRITE  (F6,670) UFM
  670 FORMAT (A23,' 300 *** ROUTINE XRCARD FINDS OUTPUT BUFFER TOO ',
     1       'SMALL TO PROCESS CARD COMPLETELY')
  680 NOGO = .TRUE.
      WRITE  (F6,690) CHAR
  690 FORMAT (/5X,1H',72A1,1H')
      OUT(1) = 0
C
      RETURN
      END

      SUBROUTINE MPY3A (Z,IZ,DZ)
C*****
C    PREPARES B AND A(T).
C*****
      DOUBLE PRECISION DZ(1),DA
C
C
C
      INTEGER FILEA,FILEB,SCR1,SCR2,FILE
      INTEGER BUF1,BUF2,BUF3
      INTEGER PREC,PRECN
      INTEGER ZPNTRS
      INTEGER TYPIN,TYPOUT,ROW1,ROWM
      INTEGER UTYP,UROW1,UROWN,UINCR
      INTEGER EOL,EOR
      INTEGER PRECL
C
C
C
      DIMENSION Z(1),IZ(1)
      DIMENSION NAME(2)
      DIMENSION MCB(7)
C
C
C FILES
      COMMON / MPY3TL / FILEA(7),FILEB(7),FILEE(7),FILEC(7),SCR1,SCR2,
     1                  SCR,LKORE,CODE,PREC,LCORE,SCR3(7),BUF1,BUF2,
     2                  BUF3,BUF4,E
C SUBROUTINE CALL PARAMETERS
      COMMON / MPY3CP / ITRL,ICORE,N,NCB,M,DUMCP(3),ZPNTRS(22),LAEND
C PACK
      COMMON / PACKX  / TYPIN,TYPOUT,ROW1,ROWM,INCR
C UNPACK
      COMMON / UNPAKX / UTYP,UROW1,UROWN,UINCR
C TERMWISE MATRIX READ
      COMMON / ZNTPKX / A(2),DUM(2),IROW,EOL,EOR
C
C
C
      EQUIVALENCE     (IPOINT,ZPNTRS(3)),      (NPOINT,ZPNTRS(4)),
     *                (IACOLS,ZPNTRS(5)),      (ITRANS,ZPNTRS(7)),
     *                (IBCOLS,ZPNTRS(11))
      EQUIVALENCE     (A(1),DA)
C
C
C
      DATA NAME / 4HMPY3,4HA    /
C*****
C    FILE OPENING.
C*****
      FILE = SCR1
      CALL OPEN(*901,SCR1,Z(BUF2),1)
      FILE = FILEB(1)
      CALL OPEN(*901,FILEB,Z(BUF3),0)
      CALL FWDREC(*902,FILEB)
C*****
C    UNPACK B AND PACK INTO SCRATCH FILE 1.
C*****
C PACK PARAMETERS
      TYPIN = PREC
      TYPOUT = PREC
      ROW1 = 1
      ROWM = N
      INCR = 1
C UNPACK PARAMETERS
      UTYP = PREC
      UROW1 = 1
      UROWN = N
      UINCR = 1
      PRECN = PREC*N
      MCB(1) = 301
      MCB(2) = 0
      MCB(3) = N
      MCB(4) = 1
      MCB(5) = PREC
      MCB(6) = 0
      MCB(7) = 0
      DO 50 K=1,NCB
      CALL UNPACK(*20,FILEB,Z(IBCOLS))
      GO TO 40
   20 IB = IBCOLS - 1
      DO 30 L=1,PRECN
      IB = IB + 1
   30 Z(IB) = 0.
   40 CALL PACK (Z(IBCOLS),SCR1,MCB)
      CALL SAVPOS (SCR1,IZ(K))
   50 CONTINUE
      CALL CLOSE (SCR1,1)
      CALL CLOSE (FILEB,1)
      IF (ICORE .EQ. 1) GO TO 9999
C*****
C    INITIALIZE ARRAY CONTAINING POINTERS TO ROWS OF MATRIX A TO 0.
C*****
      DO 100 L=IPOINT,NPOINT
  100 IZ(L) = 0
C*****
C    COUNT NO. OF NON-ZERO COLUMNS IN EACH ROW OF A.
C*****
      FILE = FILEA(1)
      CALL OPEN(*901,FILEA,Z(BUF1),0)
      CALL FWDREC(*902,FILEA)
      DO 120 I=1,M
      CALL INTPK(*120,FILEA,0,PREC,0)
  110 CALL ZNTPKI
      II = IPOINT + IROW - 1
      IZ(II) = IZ(II) + 1
      IF (EOL .EQ. 1) GO TO 120
      GO TO 110
  120 CONTINUE
C*****
C    CALCULATE POINTERS TO ROWS OF MATRIX A.
C*****
      JJ = 1
      DO 130 L=IPOINT,NPOINT
      IF (IZ(L) .EQ. 0) GO TO 130
      INCRJJ = IZ(L)
      IZ(L) = JJ
      JJ = JJ + INCRJJ
  130 CONTINUE
      LAEND = JJ - 1
C*****
C    PROCESS A(T) MATRIX.
C*****
      FILE = FILEA(1)
      CALL REWIND (FILEA)
      CALL FWDREC(*902,FILEA)
      JJ2 = IACOLS + LAEND - 1
      DO 200 JJ=IACOLS,JJ2
  200 IZ(JJ) = 0
      DO 250 J=1,M
      CALL INTPK(*250,FILEA,0,PREC,0)
  210 CALL ZNTPKI
      L = IPOINT + IROW - 1
      JJ = IZ(L)
      JJC = IACOLS + JJ - 1
  220 IF (IZ(JJC) .EQ. 0) GO TO 230
      JJ = JJ + 1
      JJC = JJC + 1
      GO TO 220
  230 IZ(JJC) = J
      IF (PREC .EQ. 2) GO TO 240
      JJT = ITRANS + JJ - 1
      Z(JJT) = A(1)
      IF (EOL .EQ. 1) GO TO 250
      GO TO 210
  240 JJT = (ITRANS - 1)/2 + JJ
      DZ(JJT) = DA
      IF (EOL .EQ. 1) GO TO 250
      GO TO 210
  250 CONTINUE
      PRECL = PREC*LAEND
      CALL CLOSE (FILEA,1)
      GO TO 9999
C*****
C    ERROR MESSAGES.
C*****
  901 NERR = -1
      GO TO 1001
  902 NERR = -2
 1001 CALL MESAGE (NERR,FILE,NAME)
C
 9999 RETURN
      END

      SUBROUTINE CURVIT (INDEP,NI,DEP,ND,IFILE,Z,IZ,LZ,MCLOSE,TOLER,
     1                   MCSID,XSCALE,YSCALE)
C
C     PERFORMS LOCAL INTERPOLATION
C
C     INDEP  = X,Y COORDINATES OF INDEPENDENT ELEMENT CENTERS (2 X NI)
C     DEP    = X,Y COORDINATES OF DEPENDENT GRID POINTS  (2 X ND)
C     IFILE  = FILE TO WRITE SPECIAL FORM ROWS OF G-MATRIX
C     Z      = REAL AREA OF CORE, LENGTH = LZ.
C     IZ     = EQUIVALENT INTEGER AREA OF CORE, LENGTH = LZ.
C     MCLOSE = NUMBER OF CLOSEST INDEPENDENT POINTS TO USE
C     TOLER  = PERCENT OF DISTANCE FROM A DEPENDENT POINT TO
C              INDEPENDENT POINT NUMBER -NCLOSE- POINTS FURTHER OUT ARE
C              ALLOWED TO BE SUCH AS TO BE INCLUDED IN A LOCAL
C              INTERPOLATION.
C
      INTEGER         SYSBUF, IZ(1), SUBR(2), ITEMP(2), RD, RDREW, WRT,
     1                WRTREW, CLSREW, CLS, EOR
      REAL            Z(1), DEP(2,1), INDEP(2,1)
      CHARACTER       UFM*23, UWM*25
      COMMON /XMSSG / UFM, UWM
      COMMON /SYSTEM/ SYSBUF, IOUTPT
      COMMON /NAMES / RD, RDREW, WRT, WRTREW, CLSREW, CLS
      DATA    SUBR  / 4HCURV ,4HIT  /, EOR, NOEOR / 1, 0 /
C
      NCLOSE = MIN0(MCLOSE,NI)
      IF (NCLOSE .LE. 2) NCLOSE = NI
C
C     COMPUTE TOLERANCE MULTIPLIER WITH RESPECT TO SQUARES.
C     TOLERANCE IS IN PERCENT OF DISTANCE TO POINT NUMBER -NCLOSE- IN
C     FINAL LIST
C
      TOL = (1.0 + TOLER/100.0)**2
C
C     THUS IF DISTANCE FROM THE DEPENDENT POINT TO INDEPENDENT POINT
C     NUMBER -NCLOSE- = LSQ, ADDITIONAL INDEPENDENT POINTS WILL BE
C     INCLUDED IF THE SQUARE OF THEIR DISTANCE TO THE DEPENDENT POINT
C     IS .LE. TOL TIMES LSQ.
C
C
C     ALLOCATE BUFFER FOR -IFILE- AND OPEN -IFILE-.
C
      IBUF = LZ - SYSBUF
      JZ   = IBUF - 1
      ICRQ = -JZ
      IF (JZ .LE. 0) GO TO 900
      CALL GOPEN (IFILE,IZ(IBUF),1)
C
C     EACH ROW OF G-MATRIX WILL BE WRITTEN AS A LOGICAL RECORD
C     WITH PAIRS OF
C                 1- INDEPENDENT POINT INDEX
C                 2- G VALUE
C
C
C     SHORT CUT WILL BE TAKEN IF ALL INDEPENDENT POINTS ARE TO BE USED
C     FOR INTERPOLATION AT EACH DEPENDENT POINT.
C
      IF (NCLOSE .EQ. NI) GO TO 550
C
C     MASTER LOOP ON DEPENDENT POINTS. EACH DEPENDENT POINT RESULTS IN
C     A VARIABLE LENGTH ROW OF G-MATRIX DEPENDING ON HOW MANY
C     INDEPENDENT POINTS ARE SELECTED FOR USE. (AT LEAST 3 MUST BE USED)
C
   80 DO 500 I = 1,ND
C
C     LIST OF DISTANCE SQUARES OF ALL INDEPENDENT POINTS TO
C     CURRENT DEPENDENT POINT IS FORMED.
C
C     SELECTION OF THE -NCLOSE- SMALLEST VALUES IS THEN MADE.
C
C     THEN ANY OTHER INDEPENDENT POINTS WITHIN TOLERANCE RANGE OF
C     POINT NUMBER -NCLOSE- IN LIST ARE ADDED.
C
      FMAX = 0.0
      X    = DEP(1,I)
      Y    = DEP(2,I)
      ICRQ = NI - JZ
      IF (NI .GT. JZ) GO TO 900
      DO 100 J = 1,NI
      Z(J) = (XSCALE*(INDEP(1,J)-X))**2 + (YSCALE*(INDEP(2,J)-Y))**2
      IF (Z(J) .LE. FMAX) GO TO 100
      FMAX = Z(J)
  100 CONTINUE
      FMAX = 2.0*FMAX + 1.0
C
C     ALLOCATE FOR LIST OF INDEXES TO THE MINIMUMS.
C
      ILIST = NI + 1
      NLIST = NI
C
C     FIND -NCLOSE- SMALLEST VALUES.
C
      DO 170 J = 1,NCLOSE
      FMIN = FMAX
C
      DO 160 K = 1,NI
      IF (FMIN-Z(K)) 160,160,150
  150 FMIN = Z(K)
      IDX  = K
  160 CONTINUE
C
C     ADD INDEX TO THIS MINIMUM TO THE LIST
C
      ICRQ = NLIST + 1 - JZ
      IF (ICRQ .GT. 0) GO TO 900
      IZ(NLIST+1) = IDX
      NLIST = NLIST + 1
C
C     RESET THIS VALUE SO IT CAN NOT BE USED AGAIN
C
      Z(IDX) = FMAX
  170 CONTINUE
C
C     ADD ANY ADDITIONAL INDEPENDENT POINTS WITHIN TOLERANCE RANGE OF
C     LAST ONE SELECTED ABOVE.
C
      FMAX = TOL*FMIN
      DO 190 J = 1,NI
      IF (Z(J) .GT. FMAX) GO TO 190
      ICRQ = NLIST + 1 - JZ
      IF (ICRQ .GT. 0) GO TO 900
      IZ(NLIST+1) = J
      NLIST = NLIST + 1
  190 CONTINUE
C
C     LIST IS COMPLETE THUS MOVE IT TO THE BEGINNING OF THE CORE BLOCK.
C
      J = 0
      DO 210 K = ILIST,NLIST
      J = J + 1
      IZ(J) = IZ(K)
  210 CONTINUE
      ILIST = 1
      NLIST = J
      IPTS  = J
C
C     HERE AND IZ(ILIST) TO IZ(NLIST) CONTAINS LIST OF
C     POSITION INDEXES OF INDEPENDENT POINT COORDINATES TO BE USED.
C
C     NOW SET UP LIST OF XY-CCORDINATES OF THESE INDEPENDENT POINTS
C     FOR THE SSPLIN CALL.
C
      IXY  = NLIST + 1
      NXY  = NLIST + 2*IPTS
      ICRQ = NXY - JZ
      IF (NXY .GT. JZ) GO TO 900
      JXY  = NLIST
      DO 270 J = ILIST,NLIST
      K    = IZ(J)
      Z(JXY+1) = INDEP(1,K)
      Z(JXY+2) = INDEP(2,K)
      JXY  = JXY + 2
  270 CONTINUE
C
C     NOW READY FOR SSPLIN ROUTINE CALL.
C
      CALL SSPLIN (IPTS,Z(IXY),1,DEP(1,I),0,0,0,1,0,Z(JXY+1),JZ-JXY,
     1             ISING)
      IF (ISING .NE. 2) GO TO 300
C
C     ILL-CONDITION FOR THIS DEPENDENT POINT - NO SOLUTION POSSIBLE.
C
      CALL PAGE2 (4)
      WRITE  (IOUTPT,250) UWM,I,MCSID
  250 FORMAT (A25,' 2252. (CURVIT-1) LOCAL INTERPOLATION USING INDE',
     1       'PENDENT VALUES WITHIN RANGE OF THE', /5X,I7,'-TH SORTED ',
     2       'ORDER GRID ID INVOLVED WITH RESPECT TO MATERIAL COORDIN',
     3       'ATE SYSTEM ID',I9, /5X,'CAN NOT BE COMPLETED.  ILL-CONDI',
     4       'TION MAY HAVE RESULTED FROM ALIGNMENT OF INDEPENDENT ',
     5       'VALUE COORDINATES.', /5X,
     6       'OUTPUT FOR THE GRID ID IN QUESTION WILL NOT APPEAR.')
      IPTS = 0
      GO TO 340
C
C     REPLACE INDEPENDENT POINT XY PAIRS WITH SPECIAL FORM DEPENDENT
C     POINT G-MATRIX OUTPUT ROW.
C
  300 K1 = ILIST
      K2 = JXY + 1
      DO 320 J = IXY,NXY,2
      IZ(J ) = IZ(K1)
      Z(J+1) = Z(K2)
      K1 = K1 + 1
      K2 = K2 + 1
  320 CONTINUE
C
  340 CALL WRITE (IFILE,IZ(IXY),2*IPTS,EOR)
C
C  GO PROCESS NEXT DEPENDENT POINT.
C
  500 CONTINUE
      GO TO 800
C
C     CHECK FOR SUFFICIENT CORE FOR SHORT CUT.
C
  550 N = NI + 3
      N = N**2 + 3*N + NI*ND + N*ND
      IF (N .GT. JZ) GO TO 80
C
C     CALL SSPLIN AND GET G-MATRIX STORED BY ROWS.
C
      CALL SSPLIN (NI,INDEP(1,1),ND,DEP(1,1),0,0,0,1,0,Z(1),JZ,ISING)
      IF (ISING .NE. 2) GO TO 650
      N = 0
      WRITE (IOUTPT,250) UWM,N,MCSID
C
C     OUTPUT NULL ROW FOR EACH DEPENDENT POINT.
C
      DO 600 I = 1,ND
      CALL WRITE (IFILE,0,0,EOR)
  600 CONTINUE
      GO TO 800
C
C     OUTPUT ROWS OF G-MATRIX WITH INDEXES.
C
  650 K = 0
      DO 680 I = 1,ND
      DO 670 J = 1,NI
      K = K + 1
      ITEMP(1) = J
      ITEMP(2) = IZ(K)
      CALL WRITE (IFILE,ITEMP(1),2,NOEOR)
  670 CONTINUE
      CALL WRITE (IFILE,0,0,EOR)
  680 CONTINUE
C
C     ALL G-MATRIX ROWS COMPLETE. (ROWS SINGULAR ARE EMPTY LOGICAL
C     RECORDS IN -IFILE- )
C
  800 CALL CLOSE (IFILE,CLSREW)
      RETURN
C
  900 CALL MESAGE (-8,ICRQ,SUBR)
      RETURN
      END

      BLOCK DATA TA1ABD
CTA1ABD
C
C     /TA1ACM/ SPECIFIES THE OPEN CORE LABELED COMMONS /ZZEMXX/
C              TO BE USED BY EACH ELEMENT TYPE IN LINK8 OVERLAY
C              TREE.
C              THE LABELED COMMONS /ZZEMXX/ ARE USED ONLY IN CDC
C              AND UNIVAC TO COMPUTE (BY EMGSOC) THE OFFSET OF THE
C              OPEN CORE BETWEEN /ZZEMXX/ AND /ZZEMGX/.
C
C              E.G. /ZZEM24/ IS ASSIGNED TO QUAD4 ELEMENT, TYPE 64
C
C
      COMMON /TA1ACM/ IG(90)
C
      DATA    IG    /
     O         1,  0,  1,  3,  4, 14, 14, 14, 14,  1,
     1         2,  2,  2,  2, 14, 14, 14, 14, 14,  2,
     2         2,  2,  2, 11,  2,  2,  2,  2, 11, 11,
     3         0,  0,  0, 12, 28, 18, 19, 20, 17, 17,
     4        17, 17, 17, 17, 17, 17, 17, 17, 17, 17,
     5        17, 13, 21, 21, 21, 21, 21, 21, 21, 21,
     6        21, 15, 16, 24, 22, 22, 22,  0,  0, 25,
     7        26,  0, 48, 48, 48, 48, 48, 48, 48,  8,
     8        23, 13, 27, 29, 29, 29,  0,  0,  0,  0/
C
      END

      SUBROUTINE MRED1B (MODE)
C
C     THIS SUBROUTINE PROCESSES THE BDYS AND BDYS1 DATA FOR THE FIXED
C     IDENTIFICATION SET (FIXSET) AND THE BOUNDARY IDENTIFICATION SET
C     (BNDSET) FOR THE MRED1 MODULE.
C
C     INPUT DATA
C     GINO   - GEOM4  - BDYS DATA
C                     - BDYS1 DATA
C     OTHERS - MODE   - SUBROUTINE PROCESSING FLAG
C                     = 1, PROCESS FIXED ID SET
C                     = 2, PROCESS BOUNDARY ID SET
C
C     OUTPUT DATA
C     GINO   - USETX  - S,R,B DEGREES OF FREEDOM
C
C     PARAMETERS
C     INPUT  - NOUS   - FIXED POINTS FLAG
C                       .GE.  0, FIXED POINTS DEFINED
C                       .EQ. -1, NO FIXED POINTS DEFINED
C              GBUF1  - GINO BUFFER
C              KORLEN - CORE LENGTH
C              IO     - OUTPUT OPTION FLAG
C              NAMEBS - BEGINNING ADDRESS OF BASIC SUBSTRUCTURES NAMES
C              EQSIND - BEGINNING ADDRESS OF EQSS GROUP ADDRESSES
C              NSLBGN - BEGINNING ADDRESS OF SIL DATA
C              KBDYC  - BEGINNING ADDRESS OF BDYC DATA
C              USETX  - USETX OUTPUT FILE NUMBER
C              NBDYCC - NUMBER OF BDYC WORDS
C     OUTPUT - DRY    - MODULE OPERATION FLAG
C     OTHERS - LOCUST - BEGINNING ADDRESS OF USET ARRAY
C              IERR   - NO BDYS/BDYS1 DATA ERROR FLAG
C                       .LT. 2, NO ERRORS
C                       .EQ. 2, ERRORS
C              GRPBGN - ABSOLUTE BEGINNING ADDRESS OF EQSS GROUP DATA
C              GRPEND - ABSOLUTE ENDING ADDRESS OF EQSS GROUP DATA
C              GRPIP  - ABSOLUTE ADDRESS OF EQSS DATA GROUP
C              LOCBGN - BEGINNING ADDRESS OF EQSS DATA FOR SUBSTRUCTURE
C              NFOUND - NUMBER OF EQSS DATA ITEMS FOUND FOR SET ID
C              KPNTBD - ARRAY OF BDYC DOF COMPONENTS
C              KPNTSL - ARRAY OF EQSS DOF COMPONENTS
C              INDSIL - ABSOLUTE INDEX INTO SIL DATA
C              NSILUS - ABSOLUTE INDEX INTO USET ARRAY
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        RSHIFT,ANDF,ORF,COMPLF
      LOGICAL         BOUNDS,PONLY
      REAL            RZ(1)
      DIMENSION       ARRAY(3),BDYI(2,2),BDY(2),EQSTRL(7),IDUM(3),
     1                KPNTSL(32),IOSHFT(2),KPNTBD(9),MODNAM(2),USETRL(7)
      CHARACTER       UFM*23,UWM*25
      COMMON /XMSSG / UFM,UWM
      COMMON /BLANK / OLDNAM(2),DRY,IDUM13,NOUS,IDUM2(4),GBUF1,
     1                IDUM14(4),KORLEN,IDUM4(5),IO,IDUM5(2),BNDSET,
     2                FIXSET,IEIG,KORBGN,IDUM12,NAMEBS,EQSIND,NSLBGN,
     3                IDUM6,KBDYC,NBDYCC,LUSET,LOCUST,IDUM3(4),BOUNDS,
     4                PONLY
      COMMON /ZZZZZZ/ Z(1)
      COMMON /SYSTEM/ IDUM7,IPRNTR,IDUM8(6),NLPP,IDUM9(2),LINE
      COMMON /TWO   / ITWO(32)
      COMMON /BITPOS/ IDUM10(5),UL,UA,UF,US,UN,IDUM11(10),UB,UI
      COMMON /PATX  / LCORE,NSUB(3),FUSET
      COMMON /UNPAKX/ TYPEU,IROWU,NROWU,INCRU
      EQUIVALENCE     (RZ(1),Z(1))
      DATA    GEOM4 , BDYI,USETX/102,1210,12,1310,13,201/
      DATA    MODNAM/ 4HMRED,4H1B   /
      DATA    IOSHFT/ 11,2  /
      DATA    ITEM  / 4HUPRT/
      DATA    UPRT  , EQST  /301,203/
C
C     TEST FOR FIXED SET INPUT
C
      IF (NOUS.EQ.-1 .AND. MODE.EQ.1) GO TO 430
C
C     CHECK FOR LOADS PROCESSING ONLY
C
      IF (PONLY) GO TO 345
C
C     PROCESS BDY(S/S1) BULK DATA FOR SPECIFIED BDYC
C
      ISHIFT = IOSHFT(MODE)
      IF (NBDYCC .EQ. 0) GO TO 335
      KORBGN = KBDYC + 4*NBDYCC
      IF (KORBGN .GE. KORLEN) GO TO 300
      IF (ANDF(RSHIFT(IO,ISHIFT),1) .EQ. 0) GO TO 10
      CALL PAGE1
      IF (MODE .EQ. 1) WRITE (IPRNTR,900)
      IF (MODE .EQ. 2) WRITE (IPRNTR,901)
      LINE  = LINE + 7
   10 IBITS = ITWO(UL) + ITWO(UA) + ITWO(UF)
      IF (MODE .EQ. 2) IBITS = ITWO(UI)
      IBITS = COMPLF(IBITS)
      IERR  = 0
      IBDY  = 0
      IFILE = GEOM4
C
C     SET BULK DATA PROCESSING FLAG AND READ SET ID
C     IBDY .EQ. 1 - BDYS
C     IBDY .EQ. 2 - BDYS1
C
      NXTBDY = 1
      IFOUND = 0
      CALL PRELOC (*270,Z(GBUF1),GEOM4)
   20 IBDY = IBDY + 1
      IF (IBDY .EQ. 3) GO TO 260
      DO 30 I = 1,2
   30 BDY(I) = BDYI(I,IBDY)
      CALL LOCATE (*250,Z(GBUF1),BDY,IFLAG)
      GO TO 40
   35 CALL BCKREC (GEOM4)
      NXTBDY = NXTBDY + 1
      IF (NXTBDY .GT. NBDYCC) GO TO 20
      CALL READ (*280,*290,GEOM4,IDUM,3,0,IFLAG)
   40 CALL READ (*280,*20,GEOM4,ARRAY,IBDY,0,IFLAG)
C
C     CHECK REQUEST ID
C
      BDYJ = 2
      BDYK = 2
      BDYL = 3
      BDYM = 2
      IF (IBDY .EQ. 1) GO TO 50
      BDYJ = 3
      BDYK = 1
      BDYL = 2
      BDYM = 3
   50 IWDS = 2 + 4*(NXTBDY-1)
      DO 55 I = NXTBDY, NBDYCC
      IF (Z(KBDYC+IWDS) .EQ. ARRAY(1)) GO TO 90
   55 IWDS = IWDS + 4
C
C     FINISH BDY(S/S1) SET ID READING
C
   60 CALL READ (*280,*290,GEOM4,ARRAY(BDYJ),BDYK,0,IFLAG)
      IF (IBDY - 2) 70,80,80
   70 IF (ARRAY(2).NE.-1 .AND. ARRAY(3).NE.-1) GO TO 60
      GO TO 40
   80 IF (ARRAY(3) .NE. -1) GO TO 60
      GO TO 40
C
C     CONTINUE BDY(S/S1) SET ID PROCESSING
C
   90 CALL READ (*280,*290,GEOM4,ARRAY(BDYJ),BDYK,0,IFLAG)
      IF (IBDY - 2) 100,110,110
  100 IF (ARRAY(2).EQ.-1 .AND. ARRAY(3).EQ.-1) GO TO 115
      GO TO 120
  110 IF (ARRAY(3) .EQ. -1) GO TO 115
      GO TO 120
C
C     CHECK FOR NEXT BDY(S/S1) CARD HAVING SAME SET ID AS CURRENT ID
C
  115 CALL READ (*280,*35,GEOM4,ARRAY,IBDY,0,IFLAG)
      IF (Z(KBDYC+IWDS) .EQ. ARRAY(1)) GO TO 90
      GO TO 35
C
C     LOCATE EQSS DATA FOR SUBSTRUCTURE
C
  120 IFOUND = 1
      IP     = 2*(Z(KBDYC+IWDS+1)-1)
      GRPBGN = Z(EQSIND+IP)
      GRPEND = GRPBGN + Z(EQSIND+IP+1)
      K = Z(EQSIND+IP+1)/3
      CALL BISLOC (*170,ARRAY(BDYM),Z(GRPBGN),3,K,LOCBGN)
      GRPIP  = GRPBGN + LOCBGN - 1
      LOC    = GRPIP - 3
  130 IF (LOC .LT. GRPBGN) GO TO 140
      IF (Z(LOC) .LT. Z(GRPIP)) GO TO 140
      LOC    = LOC - 3
      GO TO 130
  140 LOCBGN = LOC + 3
      NFOUND = 1
      LOC    = LOCBGN + 3
  150 IF (LOC .GE. GRPEND) GO TO 180
      IF (Z(LOCBGN) .LT. Z(LOC)) GO TO 180
      LOC    = LOC + 3
      NFOUND = NFOUND + 1
      GO TO 150
C
C     CANNOT LOCATE EXTERNAL ID
C
 170  CALL PAGE1
      IF (MODE .EQ. 1) WRITE (IPRNTR,902) UFM,ARRAY(3),ARRAY(2),
     1                 ARRAY(1),Z(NAMEBS+IP),Z(NAMEBS+IP+1)
      IF (MODE .EQ. 2) WRITE (IPRNTR,903) UFM,ARRAY(3),ARRAY(2),
     1                 ARRAY(1),Z(NAMEBS+IP),Z(NAMEBS+IP+1)
      DRY = -2
      GO TO 90
C
C     LOCATE CORRECT IP FOR THIS EXTERNAL ID
C
  180 CALL SPLT10 (ARRAY(BDYL),KPNTBD,JWDS)
      M = 0
      DO 230 I = 1, NFOUND
      J = (3*(I-1)) + 2
      ICODE = Z(LOCBGN+J)
      CALL DECODE (ICODE,KPNTSL,KWDS)
      DO 230 K = 1, KWDS
      DO 190 L = 1, JWDS
      IF (KPNTSL(K) .EQ. KPNTBD(L)-1) GO TO 200
  190 CONTINUE
      GO TO 230
C
C     CONVERT GRID ID AND COMPONENT TO SIL VALUE
C
  200 IF (ANDF(RSHIFT(IO,ISHIFT),1) .EQ. 0) GO TO 220
      IF (LINE .LE. NLPP) GO TO 210
      CALL PAGE1
      IF (MODE .EQ. 1) WRITE (IPRNTR,900)
      IF (MODE .EQ. 2) WRITE (IPRNTR,901)
      LINE = LINE + 7
  210 IF (M .EQ. 0) WRITE (IPRNTR,906) ARRAY(1),ARRAY(BDYM),ARRAY(BDYL)
      M    = 1
      LINE = LINE + 1
  220 INDSIL = NSLBGN + ((2*Z(LOCBGN+J-1))-2)
      NSILUS = LOCUST + ((Z(INDSIL)-1)+(K-1))
      KPNTBD(L) = 0
C
C     FILL USET ARRAY
C     IF FIXSET - TURN OFF UL, UA, UF BITS AND TURN ON US BIT
C     IF BNDSET - TURN OFF UI BIT AND TURN ON UB BIT
C
      UBORS = US
      IF (MODE .EQ. 2) UBORS = UB
      Z(NSILUS) = ANDF(Z(NSILUS),IBITS)
      Z(NSILUS) = ORF(Z(NSILUS),ITWO(UBORS))
  230 CONTINUE
C
C     CHECK THAT ALL IP FOUND
C
      DO 240 I = 1,JWDS
      IF (KPNTBD(I) .EQ. 0) GO TO 240
      IF (MODE .EQ. 1) WRITE (IPRNTR,904) UWM,ARRAY(BDYM),Z(NAMEBS+IP),
     1                 Z(NAMEBS+IP+1)
      IF (MODE .EQ. 2) WRITE (IPRNTR,905) UWM,ARRAY(BDYM),Z(NAMEBS+IP),
     1                 Z(NAMEBS+IP+1)
      GO TO 90
  240 CONTINUE
      GO TO 90
C
C     SET NO DATA AVAILABLE FLAG
C
  250 IERR = IERR + 1
      GO TO 20
C
C     END OF ID SET PROCESSING
C
  260 CALL CLOSE (GEOM4,1)
      IF (IERR   .EQ. 2) GO TO 330
      IF (IFOUND .EQ. 0) GO TO 330
      IF (MODE   .EQ. 1) GO TO 430
C
C     WRITE USETX DATA
C
      CALL GOPEN (USETX,Z(GBUF1),1)
      CALL WRITE (USETX,Z(LOCUST),LUSET,1)
      CALL CLOSE (USETX,1)
      USETRL(1) = USETX
      USETRL(2) = 1
      USETRL(3) = LUSET
      USETRL(4) = 7
      USETRL(5) = 1
      CALL WRTTRL (USETRL)
C
C     VERIFY OLD BOUNDARY UNCHANGED
C
      IF (.NOT.BOUNDS) GO TO 430
      IF (LOCUST+2*LUSET .GE. KORLEN) GO TO 300
  345 CALL SOFTRL (OLDNAM,ITEM,USETRL)
      IF (USETRL(1) .NE. 1) GO TO 440
      NROWU = USETRL(3)
      IF (PONLY) LUSET = NROWU
      IF (NROWU .NE. LUSET) GO TO 420
C
C     GET OLD UPRT VECTOR
C
      TYPEU = USETRL(5)
      CALL MTRXI (UPRT,OLDNAM,ITEM,0,ITEST)
      NEWUST = LOCUST + LUSET
      IF (PONLY) NEWUST = LOCUST
      IF (PONLY .AND. NEWUST+NROWU.GE.KORLEN) GO TO 300
      IROWU = 1
      INCRU = 1
      CALL GOPEN (UPRT,Z(GBUF1),0)
      CALL UNPACK (*350,UPRT,RZ(NEWUST))
      GO TO 370
  350 DO 360 I = 1,LUSET
  360 RZ(NEWUST+I-1) = 0.0
  370 CALL CLOSE (UPRT,1)
      IF (PONLY) GO TO 405
C
C     GET NEW UPRT VECTOR
C
      LCORE = KORLEN - (NEWUST+LUSET)
      FUSET = USETX
      CALL CALCV (UPRT,UN,UI,UB,Z(NEWUST+LUSET))
      TYPEU = 1
      NROWU = LUSET
      CALL GOPEN (UPRT,Z(GBUF1),0)
      CALL UNPACK (*380,UPRT,RZ(NEWUST+LUSET))
      GO TO 400
  380 DO 390 I = 1,LUSET
  390 RZ(NEWUST+LUSET+I-1) = 0.0
  400 CALL CLOSE (UPRT,1)
C
C     CHECK OLD, NEW UPRT VECTORS AND COUNT NUMBER OF ROWS IN 0, 1
C     SUBSETS AND SAVE IN EQST TRAILER FOR USE IN MRED2A
C
  405 ISUB0 = 0
      ISUB1 = 0
      DO 410 I = 1,LUSET
      IF (RZ(NEWUST+I-1) .EQ. 0.0) ISUB0 = ISUB0 + 1
      IF (RZ(NEWUST+I-1) .EQ. 1.0) ISUB1 = ISUB1 + 1
      IF (PONLY) GO TO 410
      IF (RZ(NEWUST+I-1) .NE. RZ(NEWUST+LUSET+I-1)) GO TO 420
  410 CONTINUE
      EQSTRL(1) = EQST
      EQSTRL(6) = ISUB0
      EQSTRL(7) = ISUB1
      CALL WRTTRL (EQSTRL)
      GO TO 430
C
C     BOUNDARY POINTS ARE NOT THE SAME
C
  420 WRITE (IPRNTR,909) UFM,OLDNAM
      DRY = -2
  430 CONTINUE
      RETURN
C
C     PROCESS SYSTEM FATAL ERRORS
C
  270 IMSG = -1
      GO TO 320
  280 IMSG = -2
      GO TO 310
  290 IMSG = -3
      GO TO 310
  300 IMSG = -8
      IFILE = 0
  310 CALL CLOSE (GEOM4,1)
  320 CALL SOFCLS
      CALL MESAGE (IMSG,IFILE,MODNAM)
      RETURN
C
C     PROCESS MODULE FATAL ERRORS
C
  330 IF (MODE .EQ. 1) WRITE (IPRNTR,907) UFM,FIXSET
      IF (MODE .EQ. 2) WRITE (IPRNTR,908) UFM,BNDSET
  335 DRY = -2
      CALL SOFCLS
      CALL CLOSE (GEOM4,1)
      RETURN
  440 GO TO (450,450,460,470,480,480), ITEST
  450 WRITE (IPRNTR,910) UFM,MODNAM,ITEM,OLDNAM
      DRY = -2
      RETURN
  460 IMSG = -1
      GO TO 490
  470 IMSG = -2
      GO TO 490
  480 IMSG = -3
  490 CALL SMSG (IMSG,ITEM,OLDNAM)
      RETURN
C
  900 FORMAT (//45X,40HTABLE OF GRID POINTS COMPOSING FIXED SET,
     1       //53X,5HFIXED,/53X,25HSET ID   GRID POINT   DOF, /53X,
     2       26HNUMBER   ID NUMBER    CODE,/)
  901 FORMAT (1H0,44X,43HTABLE OF GRID POINTS COMPOSING BOUNDARY SET,
     1       //52X,8HBOUNDARY,/53X,25HSET ID   GRID POINT   DOF, /53X,
     2       26HNUMBER   ID NUMBER    CODE,/)
  902 FORMAT (A23,' 6624, GRID POINT',I9,' COMPONENT',I9,' SPECIFIED ',
     1       'IN FIXED SET',I9, /5X,'FOR SUBSTRUCTURE ',2A4,
     2       ' DOES NOT EXIST.',//////)
  903 FORMAT (A23,' 6611, GRID POINT',I9,' COMPONENT',I9,' SPECIFIED ',
     1       'IN BOUNDARY SET',I9, /5X,'FOR SUBSTRUCTURE ',2A4,
     2       ' DOES NOT EXIST.',//////)
  904 FORMAT (A25,' 6625, DEGREES OF FREEDOM AT GRID POINT',I9,
     1       ' COMPONENT SUBSTRUCTURE ',2A4, /32X,'INCLUDED IN A FIXED',
     2       ' SET DO NOT EXIST.  REQUEST WILL BE IGNORED.')
  905 FORMAT (A25,' 6610, DEGREES OF FREEDOM AT GRID POINT',I9,
     1       ' COMPONENT SUBSTRUCTURE ',2A4, /32X,'INCLUDED IN A NON-',
     2       'EXISTING BOUNDARY SET.  REQUEST WILL BE IGNORED.')
  906 FORMAT (52X,2(I8,3X),I6)
  907 FORMAT (A23,' 6626, NO BDYS OR BDYS1 BULK DATA HAS BEEN INPUT TO',
     1       ' DEFINE FIXED SET',I9,1H.)
  908 FORMAT (A23,' 6607, NO BDYS OR BDYS1 BULK DATA HAS BEEN INPUT TO',
     1       ' DEFINE BOUNDARY SET',I9,1H.)
  909 FORMAT (A23,' 6637, OLDBOUND HAS BEEN SPECIFIED BUT THE BOUNDARY',
     1       ' POINTS FOR SUBSTRUCTURE ',2A4,' HAVE BEEN CHANGED.')
  910 FORMAT (A23,' 6215, MODULE ',2A4,8H - ITEM ,A4,' OF SUBSTRUCTURE '
     1,       2A4,' PSEUDO-EXISTS ONLY.')
C
      END

      SUBROUTINE FACTRU(*,A,LLL,ULL,SCR1,SCR2,SCR3)
C
      INTEGER A,SCR1,SCR2,SCR3,ULL
      DOUBLE PRECISION DETT,MINDIA
C
      COMMON /DCOMPX/IA(7),IL(7),IU(7),ISCR1,ISCR2,ISCR3,DETT,IPOW,
     1  NZ,MINDIA,IB,IBB
      COMMON /SYSTEM/SYS(54),IPREC
      COMMON /ZZZZZZ/ XX(1)
C
C ----------------------------------------------------------------------
C
      IB = 0
      IBB = 0
      IA(1) = A
      CALL RDTRL(IA)
      IL(1)=LLL
      IU(1)=ULL
      ISCR1=SCR1
      ISCR2=SCR2
      ISCR3=SCR3
      NZ = KORSZ(XX)
      IL(3) = IA(3)
      IU(3) = IA(3)
      IL(4) =4
      IU(4) =5
      IU(5) = IPREC
      IL(5) = IPREC
      CALL DECOMP(*10,XX,XX,XX)
      CALL WRTTRL(IL)
      CALL WRTTRL(IU)
      RETURN
   10 RETURN 1
C
      END

      SUBROUTINE GFSH(NUY,H)
C
C     ROUTINE TO CALCULTE THE H TRANSFORMATION MATRIX USED WHEN NO
C     SPC'S ARE ON THE FLUID
C
      REAL          RZ(2)
C
      INTEGER       Z        ,SYSBUF   ,MCB(7)   ,H        ,TI1
     1             ,TO1      ,NAME(2)
C
C     OPEN CORE
C
      COMMON / ZZZZZZ /        Z(1)
C
C     SYSTEM COMMON
C
      COMMON / SYSTEM /       SYSBUF
C
C     PACK - UNPACK COMMON BLOCKS
C
      COMMON / PACKX /        TI1      ,TO1      ,I1       ,N1
     1                       ,INCR1
C
      EQUIVALENCE   ( Z(1) , RZ(1) )
C
      DATA NAME / 4HGFSH , 4H     /
C
C     ALLOCATE CORE
C
      NZ = KORSZ(Z(1))
      IBUF = NZ - SYSBUF
      NZ = IBUF - 1
      IF(NZ .LT. NUY) GO TO 1008
      NUY1 = NUY - 1
      CALL MAKMCB(MCB,H,NUY1,2,2)
      TI1 = 1
      TO1 = 2
      I1 = 1
      N1 = NUY1
      INCR1 = 1
C
      DO 100 I=1,NUY
  100 RZ(I) = -1.0 / FLOAT(NUY)
      CALL GOPEN(H,Z(IBUF),1)
      DO 120 I=1,NUY
      RZ(I) = FLOAT(NUY1) / FLOAT(NUY)
      CALL PACK(RZ(2),H,MCB)
  120 RZ(I) = -1.0 / FLOAT(NUY)
      CALL CLOSE(H,1)
      CALL WRTTRL(MCB)
      RETURN
C
C     ERRORS
C
 1008 CALL MESAGE(-8,0,NAME)
      RETURN
      END

      SUBROUTINE COMUGV
C
C FOR DDAM/EARTHQUAKE ANALYSES, COMBUGV COMBINES DISPLACEMENT
C COMPONENTS BY (1)ADDING THE COMPONENTS IN ABS VALUE AND (2)TAKING THE
C SQUARE ROOT OF THE SUMS OF THE SQUARES. AFTER THIS MODEULE, THE
C TWO OUTPUT DATA BLOCKS ARE N X NMODES, WHEREAS UGV IS N X (NMODES)(L)
C MODULE NRLSUM COMBINES STRESSES ACROSS MODES FOR EACH DIRECTION
C INDIVIDUALLY. THE OUTPUTS OF THIS MODULE HAVE THE DIRECTIONS
C COMBINED. BUT NRLSUM CAN WORK ON THEM (AFTER CASEGEN AND SDR2) BY
C SPECIFYING NDIR=1 IN THE DMAP STATEMENT FOR THOSE MODULES.
C THIS MODULE WILL ALSO COMBINE THE MAXIMUM RESPONSES ACROSS THE MODES
C BY USING SQRSS TO COME UP WITH ONE RESPONSE VECTOR. THEREFORE THIS
C MODULE COMBINES COMPONENTS TO GET MAXIMUM RESPONSES BY ADDING (UGVADD)
C AND BY SQRSS (UGVSQR). THEN IT TAKES EACH OF THESE AND TAKES SQRSS
C ACROSS THE MODES TO GET UGVADC AND UGVSQC, RESPECTIVELY.
C FINALLY, THE MODULE COMPUTES THE NRL SUMS FOR THE L DIRECTIONS
C TO USE CASEGEN,SDR2,ETC. ON UGVADC AND UGVSQC, IN CASEGEN,USE
C LMODES=NDIR=1 IN DMAP STATEMENT. FOR UGVNRL, JUST USE LMODES=1.
C
C COMBUGV UGV/UGVADD,UGVSQR,UGVADC,UGVSQC,UGVNRL/V,N,NMODES/V,N,NDIR $
C
      INTEGER BUF1,BUF2,BUF3,UGV,UGVADD,UGVSQR,UGVADC,UGVSQC
      INTEGER UGVNRL
      INTEGER INDB(2),OUDB(2)
      DIMENSION NAM(2),MCB(7),MCB1(7),MCB2(7)
      COMMON/UNPAKX/JOUT,III,NNN,JNCR
      COMMON/PACKX/IIN,IOUT,II,NN,INCR
      COMMON/SYSTEM/IBUF
      COMMON/BLANK/NMODES,NDIR
      COMMON/ZZZZZZ/Z(1)
      DATA UGV,UGVADD,UGVSQR,UGVADC,UGVSQC/101,201,202,203,204/
      DATA UGVNRL/205/
      DATA NAM/4HCOMB,4HUGV /
C
C OPEN CORE AND BUFFERS
C
      LCORE=KORSZ(Z)
      BUF1=LCORE-IBUF+1
      BUF2=BUF1-IBUF
      BUF3=BUF2-IBUF
      LCORE=BUF3-1
      IF(LCORE.LE.0)GO TO 1008
      MCB(1)=UGV
      CALL RDTRL(MCB)
      NCOL=MCB(2)
      NROW=MCB(3)
      IF(NCOL.NE.NMODES*NDIR)GO TO 1007
      IF(LCORE.LT.4*NROW)GO TO 1008
      MCB1(1)=UGVADD
      MCB1(2)=0
      MCB1(3)=NROW
      MCB1(4)=2
      MCB1(5)=1
      MCB1(6)=0
      MCB1(7)=0
      MCB2(1)=UGVSQR
      MCB2(2)=0
      MCB2(3)=NROW
      MCB2(4)=2
      MCB2(5)=1
      MCB2(6)=0
      MCB2(7)=0
C
      JOUT=1
      III=1
      NNN=NROW
      JNCR=1
      IIN=1
      IOUT=1
      II=1
      NN=NROW
      INCR=1
C
      CALL GOPEN(UGV,Z(BUF1),0)
      CALL GOPEN(UGVADD,Z(BUF2),1)
      CALL GOPEN(UGVSQR,Z(BUF3),1)
C
C UNPACK NDIR COLUMNS OF UGV WHICH CORRESPOND TO A SINGLE MODE
C
      NM1=NMODES-1
      ND1=NDIR-1
      DO 120 I=1,NMODES
C
C POINTER TO PROPER MODE IN 1ST DIRECTION
C
      NSKIP=I-1
      IF(NSKIP.EQ.0)GO TO 20
      DO 10 LL=1,NSKIP
      CALL FWDREC (*1002,UGV)
   10 CONTINUE
C
C UNPACK VECTOR
C
   20 CALL UNPACK (*25,UGV,Z(1))
      GO TO 40
C
   25 DO 30 J=1,NROW
   30 Z(J)=0.
C
C SKIP TO NEW DIRECTION, UNPACK, SKIP AND UNAPCK
C
   40 IF(ND1.EQ.0)GO TO 100
      DO 70 J=1,ND1
      IF(NM1.EQ.0)GO TO 50
      DO 45 JJ=1,NM1
      CALL FWDREC (*1002,UGV)
   45 CONTINUE
C
   50 JNROW = J*NROW
      CALL UNPACK (*55,UGV,Z(JNROW+1))
      GO TO 70
   55 DO 60 JJ=1,NROW
   60 Z(J*NROW+JJ)=0.
C
   70 CONTINUE
C
C NOW PERFORM EACH OPERATION AND STORE INTO Z(3*NROW+1)
C
      DO 80 KK=1,NROW
      Z(3*NROW+KK)=ABS(Z(KK))+ABS(Z(NROW+KK))+ABS(Z(2*NROW+KK))
   80 CONTINUE
      CALL PACK(Z(3*NROW+1),UGVADD,MCB1)
C
      DO 90 KK=1,NROW
      Z(3*NROW+KK)=SQRT(Z(KK)**2+Z(NROW+KK)**2+Z(2*NROW+KK)**2)
   90 CONTINUE
      CALL PACK(Z(3*NROW+1),UGVSQR,MCB2)
      GO TO 110
C
C JUST ONE DIRECTION ON UGV- COPY TO DATA BLOCKS
C
  100 CALL PACK(Z(1),UGVADD,MCB1)
      CALL PACK(Z(1),UGVSQR,MCB2)
C
C DONE FOR THIS MODE - GET ANOTHER
C
  110 CALL REWIND(UGV)
      CALL FWDREC (*1002,UGV)
C
  120 CONTINUE
C
      CALL CLOSE(UGVADD,1)
      CALL CLOSE(UGVSQR,1)
      CALL WRTTRL(MCB1)
      CALL WRTTRL(MCB2)
C
C NOW COMPUTE NRL SUMS FOR THE L DIRECTIONS
C
      MCB1(1)=UGVNRL
      MCB1(2)=0
      MCB1(3)=NROW
      MCB1(4)=2
      MCB1(5)=1
      MCB1(6)=0
      MCB1(7)=0
      CALL REWIND(UGV)
      CALL FWDREC (*1002,UGV)
      CALL GOPEN(UGVNRL,Z(BUF2),1)
C
      DO 1240 ND=1,NDIR
C
C SET UP VECTOR OF MAXIMUM DISPLACEMENT COMPONENTS AND VECTOR OF SUMS
C
      DO 1200 I=1,NROW
      Z(I)=0.
 1200 Z(2*NROW+I)=0.
C
      DO 1220 I=1,NMODES
C
      CALL UNPACK (*1220,UGV,Z(NROW+1))
C
C COMPARE TO MAXIMUM COMPONENTS
C
      DO 1210 J=1,NROW
      IF (ABS(Z(NROW+J)).GT.Z(J))Z(J)=ABS(Z(NROW+J))
      Z(2*NROW+J)=Z(2*NROW+J)+Z(NROW+J)**2
 1210 CONTINUE
C
C GET ANOTHER DISPLACEMENT VECTOR CORRESPONDING TO ANOTHER MODE
C
 1220 CONTINUE
C
C SUBTRACT THE MAXIMA FROM THE SUMS
C
      DO 1230 J=1,NROW
      Z(2*NROW+J)=Z(2*NROW+J)-Z(J)**2
C
C TAKE SQUARE ROOT AND ADD IN THE MAXIMA
C
      Z(2*NROW+J)=SQRT(Z(2*NROW+J))+Z(J)
 1230 CONTINUE
C
C PACK RESULTS ANG GET ANOTHER DIRECTION
C
      CALL PACK(Z(2*NROW+1),UGVNRL,MCB1)
 1240 CONTINUE
C
      CALL CLOSE(UGV,1)
      CALL CLOSE(UGVNRL,1)
      CALL WRTTRL(MCB1)
C
C NOW LETS COMBINE RESPONSES OVER THE MODES USING SQRSS. DO FOR BOTH
C UGVADD AND UGVSQR. THE RESULT WILL BE ONE DISLPACEMENT VECTOR.
C (BOTH UGVADD AND UGVSQR ARE N X M ( M= NO. OF MODES)
C
      INDB(1)=UGVADD
      INDB(2)=UGVSQR
      OUDB(1)=UGVADC
      OUDB(2)=UGVSQC
C
      DO 170 I=1,2
C
      MCB(1)=INDB(I)
      CALL RDTRL(MCB)
      NCOL=MCB(2)
      NROW=MCB(3)
      MCB1(1)=OUDB(I)
      MCB1(2)=0
      MCB1(3)=NROW
      MCB1(4)=2
      MCB1(5)=1
      MCB1(6)=0
      MCB1(7)=0
      IF(NCOL.NE.NMODES)GO TO 1007
C
      CALL GOPEN(INDB(I),Z(BUF1),0)
      CALL GOPEN(OUDB(I),Z(BUF2),1)
C
      DO 130 J=1,NROW
  130 Z(J)=0.
C
C UNPACK THE COLUMNS OF INDB AND ACCUMULATE SUMS OF SQUARES
C
      DO 150 J=1,NMODES
      CALL UNPACK (*150,INDB(I),Z(NROW+1))
C
      DO 140 K=1,NROW
  140 Z(K)=Z(K)+Z(NROW+K)**2
C
  150 CONTINUE
C
      DO 160 K=1,NROW
  160 Z(K)=SQRT(Z(K))
C
      CALL PACK(Z(1),OUDB(I),MCB1)
C
      CALL CLOSE(INDB(I),1)
      CALL CLOSE(OUDB(I),1)
      CALL WRTTRL(MCB1)
C
  170 CONTINUE
C
      RETURN
C
 1002 CALL MESAGE(-2,UGV,NAM)
 1007 CALL MESAGE(-7,0,NAM)
 1008 CALL MESAGE(-8,0,NAM)
      RETURN
      END

      SUBROUTINE EMGFIN
C
C     THIS ROUTINE OF THE -EMG- MODULE WRAPS UP THE WORK OF THE MODULE.
C
      LOGICAL         ERROR, HEAT, LINEAR
      INTEGER         CLS, CLSREW, RDREW, WRTREW, DATE, MCB(7), PRECIS,
     1                EST, DICTN, FLAGS, SCR3, SCR4, VAFILE, SUB(2),
     2                IX(6), SIL(32)
      REAL            INPI(10), Z(2), RX(200), COREY(201)
      COMMON /BLANK / NOKMB(3), NOK4GG, CMASS, DUMMY(11), VOLUME, SURFAC
      COMMON /HMATDD/ SKP(4), LINEAR
      COMMON /EMGPRM/ ICORE, JCORE, NCORE, DUM12(12), FLAGS(3), PRECIS,
     1                ERROR, HEAT, ICMBAR, LCSTM, LMAT, LHMAT
      COMMON /NAMES / RD, RDREW, WRT, WRTREW, CLSREW, CLS
      COMMON /EMGFIL/ EST, CSTM, MPT, DIT, GEOM2, MATRIX(3), DICTN(3)
      COMMON /OUTPUT/ HEAD(96)
      COMMON /SYSTEM/ IBUF, NOUT, SKIP6(6), NLPP, SKIP2(2), LINE,
     1                SK1P2(2), DATE(3)
      COMMON /MACHIN/ MACH
      COMMON /ZZZZZZ/ COREX(1)
      EQUIVALENCE     (COREX(1),COREY(1),RX(1),IX(1)), (Z(1),COREY(201))
      DATA    VAFILE, SCR4  / 207,    304           /
      DATA    D2,     D3    / 4H2-D , 4H3-D         /
      DATA    SUB,    SCR3  / 4HEMGF, 4HIN   , 303  /
      DATA    INPI  / 4HINPT, 4HINP1, 4HINP2, 4HINP3, 4HINP4,
     1                4HINP5, 4HINP6, 4HINP7, 4HINP8, 4HINP9/
C
C     CLOSE ALL FILES, EXCEPT SCR4
C
      DO 10 I = 1,3
      NOKMB(I) = -FLAGS(I) - 1
      IF (FLAGS(I)+1 .EQ. 0) FLAGS(I) = 0
      IF (FLAGS(I)   .EQ. 0) NOKMB(I) =-1
      CALL CLOSE (MATRIX(I),CLSREW)
      CALL CLOSE (DICTN(I),CLSREW)
   10 CONTINUE
      CALL CLOSE (EST,CLSREW)
C
C     HEAT ONLY - SET NONILINEAR FLAG BASED ON VALUE PREVIOUSLY SET BY
C     HMAT ROUTINE
C
      IF (HEAT .AND. .NOT.LINEAR) NOKDGG = +1
      IF (HEAT .AND.      LINEAR) NOKDGG = -1
C
C  WRITE TRAILERS FOR FILES PREPARED.
C
      IF (ERROR) GO TO 340
      DO 40 I = 1,3
C
C     PRECISION IS STORED IN FIRST DATA WORD OF TRAILER.
C
      IF (FLAGS(I) .EQ. 0) GO TO 40
      MCB(1) = MATRIX(I)
      CALL RDTRL (MCB)
      IF (MCB(1)) 40,40,20
   20 MCB(2) = PRECIS
      MCB(3) = 0
      MCB(4) = 0
      MCB(5) = 0
      MCB(6) = 0
      MCB(7) = 0
      CALL WRTTRL (MCB)
C
      MCB(1) = DICTN(I)
      CALL RDTRL (MCB)
      IF (MCB(1)) 40,40,30
   30 MCB(2) = PRECIS
      MCB(3) = 0
      MCB(4) = 0
      MCB(5) = 0
      MCB(6) = 0
      MCB(7) = 0
      CALL WRTTRL (MCB)
   40 CONTINUE
      IF (VOLUME.LE.0.0 .AND. SURFAC.LE.0.0) GO TO 330
C
C     COMPUTE AND PRINT VOLUMES AND SURFACE AREAS FOR THE 2-D AND 3-D
C     ELEM. IF USER REQUESTED VIA PARAM CARD.
C
      CALL CLOSE (SCR4,CLSREW)
      IBUF1 = ICORE + 200
      IBUF2 = IBUF1 + IBUF
      CALL OPEN (*350,SCR4,Z(IBUF1),RDREW)
      TVOL2 = 0.0
      TVOL3 = 0.0
      TMAS2 = 0.0
      TMAS3 = 0.0
      NREC  = 0
      LINE  = NLPP
      INP   = 0
C
C     CHECK ANY REQUEST TO SAVE VOLUME AND AREA COMPUTATIONS ON OUTPUT
C     FILE SET INP TO APPROPRIATE VALUE IF IT IS AN INPI FILE
C
      MCB(1) = VAFILE
      CALL RDTRL (MCB(1))
      IF (MCB(1) .LE. 0) GO TO 70
      CALL FNAME (VAFILE,Z(1))
      DO 55 I = 1,10
      IF (Z(1) .EQ. INPI(I)) GO TO 60
   55 CONTINUE
      GO TO 65
   60 INP = I + 13
      IF (INP.EQ.14 .AND. MACH.EQ.2) INP = 24
      VAFILE = SCR3
      MCB(1) = SCR3
   65 CALL OPEN (*360,VAFILE,Z(IBUF2),WRTREW)
      CALL WRITE (VAFILE,Z(1),    2,0)
      CALL WRITE (VAFILE,HEAD(1),96,0)
      CALL WRITE (VAFILE,DATE(1), 3,1)
      NREC = 1
   70 CALL READ (*210,*90,SCR4,RX,201,1,I)
      WRITE  (NOUT,80)
   80 FORMAT (' *** WARNING,   RX TOO SMALL IN EMGFIN ***')
   90 NGPT = IX(6)
      IF (NGPT .LT.    3) GO TO 70
      IF (LINE .LT. NLPP) GO TO 130
      LINE = 5
      CALL PAGE1
      WRITE  (NOUT,100) (I,I=1,6)
  100 FORMAT (17X,'V O L U M E S,  M A S S E S,  A N D  S U R F A C E ',
     1        ' A R E A S  O F  2-  A N D  3-  D  E L E M E N T S',
     2        ///10X,7HELEMENT,8X,3HEID,8X,6HVOLUME,7X,4HMASS,1X,
     3        6(3X,7HSURFACE,I2), /10X, 29(4H----),/)
      IF (VOLUME .LE. 0.0) WRITE (NOUT,110)
      IF (SURFAC .LE. 0.0) WRITE (NOUT,120)
      IF (VOLUME.LE.0.0 .OR. SURFAC.LE.0.0) LINE=LINE+2
  110 FORMAT (10X,42H(NO MASS AND VOLUME COMPUTATION REQUESTED),/)
  120 FORMAT (10X,39H(NO SURFACE AREA COMPUTATION REQUESTED),/)
  130 L = 5
C
C     ENTRIES IN RX ARRAY, AS SAVED IN SCR4 BY KTRIQD,KTETRA,IHEXI,
C     EMGPRO
C        RX( 1),RX(2) = ELEMENT BCD NAME
C        IX( 3) = ELEMENT ID
C        RX( 4) = VOLUME (SOLID), OR THICKNESS (PLATE)
C        RX( 5) = TOTAL MASS (SOLID), OR DENSITY (PLATE)
C        IX( 6) = NO. OF GRID POINTS, = NGPT
C        IX(7)...IX(6+NGPT) = SIL OF THE GRID POINTS
C        RX( 7+NPGT) = CID OF 1ST GRID POINT
C        RX( 8+NPGT) = X COORD. OF 1ST GRID POINT
C        RX( 9+NPGT) = Y COORD. OF 1ST GRID POINT
C        RX(10+NPGT) = Z COORD. OF 1ST GRID POINT
C        IX(11+NPGT...) = REPEAT FOR OTHER GRID POINTS
C
C     CALL SFAREA TO COMPUTE AREAS, 6 VALUES ARE RETURNED IN RX(6...11)
C     AND NO. OF SURFACES IN NGPT
C     VOLUME AND MASS ARE ALSO COMPUTED FOR THE PLATE ELEMENTS.
C
      DO 140 I = 1,NGPT
  140 SIL(I) = IX(6+I)
      LN = NGPT
      CALL SFAREA (LN,RX,IX(NGPT+7))
      L = 5
      IF (SURFAC .GT. 0.0) L = 5 + LN
      IF (VOLUME .GT. 0.0) WRITE (NOUT,160) (IX(I),I=1,3),(RX(I),I=4,L)
      IF (VOLUME .LE. 0.0) WRITE (NOUT,170) (IX(I),I=1,3),(RX(I),I=6,L)
  160 FORMAT (10X,2A4,I10, 2X,8E12.4)
  170 FORMAT (10X,2A4,I10,26X,6E12.4)
      LINE = LINE + 1
C
      IF (NREC .EQ. 0) GO TO 190
      NREC = NREC + 1
      IX(5) = (LN*100) + NGPT
      CALL WRITE (VAFILE,RX(1),L,0)
      N4 = NGPT*4
      N7 = N4 + 7
      J  = 1
      DO 180 I = 7,N7,4
      IX(I) = SIL(J)
  180 J = J + 1
      CALL WRITE (VAFILE,RX(NGPT+7),N4,1)
C
C     A RECORD IS SAVED IN VAFILE FOR EACH ELEM., HAVING THE FOLLOWING
C     DATA
C
C        WORDS  1,2 ELEMENT BCD NAME
C                 3 ELEMENT ID, INTEGER
C                 4 VOLUME (3-D ELEMS), ZERO (2-D ELEMS), REAL
C                 5 (NO. OF SURFACES, N)*100 + NO. OF GRID PTS, INTEGER
C                 6 AREA OF FIRST SURFACE, REAL
C        7 THRU 5+N REPEAT FOR N SURFACES, REAL
C             5+N+1 SIL OF FIRST GRID POINT, INTEGER
C         5+N+2,3,4 X,Y,Z COORDINATES OF THE FIRST GRID POINT, REAL
C               ... REPEAT LAST 4 WORDS FOR OTHER GRID POINTS, REAL
C
  190 IF (VOLUME .LE. 0.0) GO TO 70
      IF (NGPT   .GT.   1) GO TO 200
      TVOL2 = TVOL2 + RX(4)
      TMAS2 = TMAS2 + RX(5)
      GO TO 70
  200 TVOL3 = TVOL3 + RX(4)
      TMAS3 = TMAS3 + RX(5)
      GO TO 70
  210 CALL CLOSE (SCR4,CLSREW)
      IF (NREC .EQ. 0) GO TO 230
      CALL CLOSE (VAFILE,CLSREW)
      MCB(2) = NREC
      DO 220 I = 3,7
  220 MCB(I) = 0
      CALL WRTTRL (MCB(1))
  230 IF (VOLUME .LE. 0.0) GO TO 330
      IF (TVOL2  .GT. 0.0) WRITE (NOUT,240) TVOL2,TMAS2,D2
      IF (TVOL3  .GT. 0.0) WRITE (NOUT,240) TVOL3,TMAS3,D3
  240 FORMAT (/6X,24H* TOTAL VOLUME AND MASS=,2E12.4,3H  (,A4,
     1        9HELEMENTS))
      IF (NREC .LE. 0) GO TO 330
C
C     IF OUTPUT FILE REQUESTED BY USER IS AN INPI FILE, COPY FROM VAFILE
C     TO INPI, A FORTRAN WRITTEN BINARY FILE
C
      IF (INP .EQ. 0) GO TO 280
      CALL OPEN (*360,VAFILE,Z(IBUF2),RDREW)
  260 CALL READ (*280,*270,VAFILE,Z(1),IBUF2,1,J)
      GO TO 370
  270 WRITE (INP) (Z(I),I=1,J)
      GO TO 260
  280 CALL CLOSE (VAFILE,CLSREW)
      CALL FNAME (207,Z(1))
      WRITE  (NOUT,300) Z(1),Z(2),DATE
  300 FORMAT ('0*** VOLUMES AND EXTERNAL SURFACE AREAS WERE SAVED IN ',
     1        'OUTPUT FILE ',2A4,4H ON ,I2,1H/,I2,3H/19,I2)
      IF (INP .EQ. 0) WRITE (NOUT,310)
      IF (INP .NE. 0) WRITE (NOUT,320) INP
  310 FORMAT (1H+,91X,21H(A GINO WRITTEN FILE))
  320 FORMAT (1H+,91X,28H(A FORTRAN BINARY FILE, UNIT,I3,1H))
  330 VOLUME = 0.0
      SURFAC = 0.0
      RETURN
C
  340 IF (VOLUME.NE.0. .OR. SURFAC.NE.0.) CALL CLOSE (SCR4,CLSREW)
      GO TO 330
  350 CALL MESAGE (-1,SCR4,SUB)
  360 J = -1
      GO TO 380
  370 J = -8
  380 CALL MESAGE (J,VAFILE,SUB)
      RETURN
      END

      SUBROUTINE EKTRMS (NTYPE)
C
C     TRIANGULAR MEMBRANE ELEMENT
C
C     ECPT LIST
C                                                      THIS
C       ECPT       DESCRIPTION                         ROUTINE   TYPE
C     ******************************************************************
C       ECPT( 1) = ELEMENT ID                          NECPT(1)  INTEGER
C       ECPT( 2) = GRID POINT A                        NGRID(1)  INTEGER
C       ECPT( 3) = GRID POINT B                        NGRID(2)  INTEGER
C       ECPT( 4) = GRID POINT C                        NGRID(3)  INTEGER
C       ECPT( 5) = THETA = ANGLE OF MATERIAL           ANGLE     REAL
C       ECPT( 6) = MATERIAL ID                         MATID     INTEGER
C       ECPT( 7) = T                                   T         REAL
C       ECPT( 8) = NON-STRUCTURAL MASS                 FMU       REAL
C       ECPT( 9) = COORD. SYSTEM ID 1                  NECPT(9)  INTEGER
C       ECPT(10) = X1                                  X1        REAL
C       ECPT(11) = Y1                                  Y1        REAL
C       ECPT(12) = Z1                                  Z1        REAL
C       ECPT(13) = COORD. SYSTEM ID 2                  NECPT(13) INTEGER
C       ECPT(14) = X2                                  X2        REAL
C       ECPT(15) = Y2                                  Y2        REAL
C       ECPT(16) = Z2                                  Z2        REAL
C       ECPT(17) = COORD. SYSTEM ID 3                  NECPT(17) INTEGER
C       ECPT(18) = X3                                  X3        REAL
C       ECPT(19) = Y3                                  Y3        REAL
C       ECPT(20) = Z3                                  Z3        REAL
C       ECPT(21) = ELEMENT TEMPERATURE                 ELTEMP    REAL
C
C     IF NTYPE = 0  COMPLETE MEMBRANE COMPUTATION IS PERFORMED
C     IF NTYPE = 1  9  3X3 MATRICES FOR THE GRID POINTS  IN ECPT
C
      LOGICAL         NOGO,HEAT
      INTEGER         NECPT(6)
      REAL            K,KOUT,ECPT(21),MATBUF,KIJ,G(9),C(18),TT(2),TI(9),
     1                TEMPAR(27)
      COMMON /EMGTRX/ A(225),PROD9(9),TEMP9(9),XSUBB,XSUBC,YSUBC,DICT5,
     1                E(18),K(324),KOUT(324),KIJ(81)
      COMMON /SYSTEM/ KSYSTM(60)
      COMMON /CONDAS/ CONSTS(5)
      COMMON /EMGPRM/ DUM(19),NOGO,HEAT
      COMMON /EMGEST/ MECPT(1),NGRID(3),ANGLE,MATID1,T,FMU,DUMMY1,X1,Y1,
     1                Z1,DUMMY2,X2,Y2,Z2,DUMMY3,X3,Y3,Z3,DUMB(80)
      COMMON /MATIN / MATID,INFLAG,ELTEMP,STRESS,SINTH,COSTH
      COMMON /MATOUT/ G11,G12,G13,G22,G23,G33,RHO,ALPHA1,ALPHA2,ALP12,
     1                T SUB 0,G SUB E,SIGTEN,SIGCOM,SIGSHE,
     2                G2X211,G2X212,G2X222
      COMMON /HMTOUT/ MATBUF(4)
      EQUIVALENCE     (CONSTS(4),DEGRA),(ECPT(1),NECPT(1),MECPT(1)),
     1                (KSYSTM(2),IOUTPT),(KSYSTM(56),IHEAT)
C
C     SET UP THE E MATRIX WHICH IS (3X2) FOR THE TRI-MEMBRANE
C
C     E(1), E(3), E(5) WILL BE THE I-VECTOR
C     E(2), E(4), E(6) WILL BE THE J-VECTOR
C     E(7), E(8), E(9) WILL BE THE K-VECTOR NOT USED IN E FOR MEMBRANE
C
C     FIRST FIND I-VECTOR = RSUBB - RSUBA  (NON-NORMALIZED)
C
      E(1) = X2 - X1
      E(3) = Y2 - Y1
      E(5) = Z2 - Z1
C
C     NOW FIND LENGTH = X-SUB-B   COORD. IN ELEMENT SYSTEM
C
      XSUBB = SQRT(E(1)**2 + E(3)**2 + E(5)**2)
      IF (XSUBB .LE. 1.E-06)  GO TO 7770
C
C  20 NOW NORMALIZE I-VECTOR WITH X-SUB-B
C
      E(1) = E(1)/XSUBB
      E(3) = E(3)/XSUBB
      E(5) = E(5)/XSUBB
C
C     HERE WE NOW TAKE RSUBC - RSUBA AND STORE TEMPORARILY IN
C     E(2), E(4), E(6) WHICH IS WHERE THE J-VECTOR WILL FIT LATER
C
      E(2) = X3 - X1
      E(4) = Y3 - Y1
      E(6) = Z3 - Z1
C
C     X-SUB-C  =  I . (RSUBC - RSUBA), THUS
C
      XSUBC = E(1)*E(2) + E(3)*E(4) + E(5)*E(6)
C
C     AND CROSSING THE I-VECTOR TO (RSUBC-RSUBA) GIVES THE K-VECTOR
C     (NON-NORMALIZED)
C
      E(7) = E(3)*E(6) - E(5)*E(4)
      E(8) = E(5)*E(2) - E(1)*E(6)
      E(9) = E(1)*E(4) - E(3)*E(2)
C
C     THE LENGTH OF THE K-VECTOR IS NOW FOUND AND EQUALS Y-SUB-C
C     COORD. IN ELEMENT SYSTEM
C
      YSUBC = SQRT(E(7)**2 + E(8)**2 + E(9)**2)
      IF (YSUBC .LE. 1.E-06) GO TO 7780
C
C  25 NOW NORMALIZE K-VECTOR WITH YSUBC JUST FOUND
C
      E(7) = E(7)/YSUBC
      E(8) = E(8)/YSUBC
      E(9) = E(9)/YSUBC
C
C     J VECTOR = K CROSS I
C     STORE IN THE SPOT FOR J
C
      E(2) = E(5)*E(8) - E(3)*E(9)
      E(4) = E(1)*E(9) - E(5)*E(7)
      E(6) = E(3)*E(7) - E(1)*E(8)
C
C     AND JUST FOR COMPUTER EXACTNESS NORMALIZE J-VECTOR TO MAKE SURE.
C
      TEMP = SQRT(E(2)**2 + E(4)**2 + E(6)**2)
      IF (TEMP .EQ. 0.0) GO TO 7790
      E(2) = E(2)/TEMP
      E(4) = E(4)/TEMP
      E(6) = E(6)/TEMP
C
C     VOLUME OF ELEMENT, THETA, MU, LAMDA, AND DELTA
C
      VOL    = XSUBB*YSUBC*T/2.
      REELMU = 1./XSUBB
      FLAMDA = 1./YSUBC
      DELTA  = XSUBC/XSUBB - 1.
C
C     NOW FORM THE  C MATRIX   (3X6) PARTITIONED AS FOLLOWS HERE.
C         CSUBA = (3X2) STORED IN C( 1) THRU C( 6) BY ROWS
C         CSUBB = (3X2) STORED IN C( 7) THRU C(12) BY ROWS
C         CSUBC = (3X2) STORED IN C(13) THRU C(18) BY ROWS
C
      C(1)  =-REELMU
      C(2)  = 0.
      C(3)  = 0.
      C(4)  = FLAMDA*DELTA
      C(5)  = C(4)
      C(6)  =-REELMU
      C(7)  = REELMU
      C(8)  = 0.
      C(9)  = 0.
      C(10) =-FLAMDA*REELMU*XSUBC
      C(11) = C(10)
      C(12) = REELMU
      C(13) = 0.
      C(14) = 0.
      C(15) = 0.
      C(16) = FLAMDA
      C(17) = FLAMDA
      C(18) = 0.
C
      IF (NTYPE .EQ. 1) GO TO 30
C
      THETA = ANGLE*DEGRA
      SINTH = SIN(THETA)
      COSTH = COS(THETA)
   30 IF (ABS(SINTH) .LT. 1.0E-06) SINTH = 0.0
C
C     BRANCH ON -HEAT- PROBLEM AT THIS POINT.
C
      IF (HEAT) GO TO 300
      ELTEMP = ECPT(21)
      MATID  = MATID1
      INFLAG = 2
      CALL MAT (ECPT(1))
C
C     FILL G-MATRIX WITH OUTPUT FROM MAT ROUTINE
C
      G(1) = G11
      G(2) = G12
      G(3) = G13
      G(4) = G12
      G(5) = G22
      G(6) = G23
      G(7) = G13
      G(8) = G23
      G(9) = G33
C
C     AT 50 G, E, AND C MATRICES ARE COMPLETE
C
C     AT THIS POINT THE FOLLOWING EQUATION CAN BE SOLVED FOR K-SUB-IJ
C
C                     T        T             T
C       K   = VOL . T  * E * C  * G * C  * E  * T
C        IJ          I        I        J         J
C
C     T-SUB-I WILL BE USED IN THE ABOVE ONLY IF THE PIVOT COORDINATE
C     SYSTEM ID IS NOT ZERO, OTHERWISE IT IS ASSUMED TO BE THE
C     IDENTITY MATRIX.
C
C     THE I SUBSCRIPT IMPLIES THE PIVOT POINT  1,2, OR 3 (ELEMENT SYST)
C     THE J SUBSCRIPT IMPLIES  1 THRU 3  FOR EACH CALL TO THIS ROUTINE.
C
C     DO COMPUTATIONS FOR EACH POINT IN ECPT LIST
C
      DO 60 I = 1,81
   60 KIJ(I) = 0.
      DO 200 NPVT = 1,3
      KA = 4*NPVT + 5
      NPOINT = 6*NPVT - 5
C
C                     T
C     COMPUTE   E * C   * G       AND STORE IN TEMPAR(1 THRU 9)
C                    I
C
      CALL GMMATS (E,3,2,0, C(NPOINT),3,2,1, TEMPAR(10))
      CALL GMMATS (TEMPAR(10),3,3,0, G,3,3,0, TEMPAR(1))
C
C     NCOM WILL ALWAYS POINT TO THE COMMON 3 X 3 PRODUCT ABOVE
C     NPT1 WILL POINT TO FREE WORKING SPACE LENGTH 9
C
      NCOM = 1
      NPT1 = 10
C
C     MULTIPLY COMMON PRODUCT BY SCALER VOL
C
      DO 90 I = 1,9
   90 TEMPAR(I) = TEMPAR(I)*VOL
C
C     CHECK FOR PIVOT  CSID = 0,  IF ZERO SKIP TRANSFORMATION TSUBI.
C
      IF (NECPT(KA) .EQ. 0) GO TO 110
C
C     NOT-ZERO THUS GET TI
C
      CALL TRANSS (NECPT(KA),TI)
C
C     INTRODUCE TI INTO THE COMMON PRODUCT AND STORE AT
C     TEMPAR(10 THRU 18)
C
      CALL GMMATS (TI,3,3,1, TEMPAR(1),3,3,0, TEMPAR(10))
C
C     COMMON PRODUCT NOW STARTS AT TEMPAR(10) THUS CHANGE NCOM AND NPT1
C
      NCOM = 10
      NPT1 =  1
C
C  80 NOW HAVE COMMON PRODUCT STORED BEGINNING TEMPAR(NCOM),  (3X3).
C     NPT1 POINTS TO FREE WORKING SPACE LENGTH 9.
C
C     PROCEED NOW AND RUN OUT THE 3 6X6 MATRICES KIJ-SUB-1,2,3.
C
  110 NSAVE  = NPT1
      NPOINT = (NPVT-1)*27
C
C     INSERT G INTO TEMPAR
C
      DO 115 I = 1,9
115   TEMPAR(I+18) = G(I)
      DO 190 I = 1,3
      CALL GMMATS (C(6*I-5),3,2,0, E,3,2,1, TEMPAR(NSAVE))
C
C     NPT2 IS SET TO POINT TO THE BEGINNING OF THE PRODUCT  C * E * T
C                                                            J       J
      NPT2 = NSAVE
      NPT1 = 19
C
C     CHECK FOR ZERO CSID IN WHICH CASE TJ IS NOT NEEDED
C
      IF (NECPT(4*I +5) .EQ. 0) GO TO 120
C
C     COMMING HERE IMPLIES NEED FOR TJ
C     WILL STORE TJ IN TI
C
      CALL TRANSS (NECPT(4*I+5),TI)
      CALL GMMATS (TEMPAR(NPT2),3,3,0, TI,3,3,0, TEMPAR(19))
      NPT1 = NPT2
      NPT2 = 19
C
C  60 AT THIS POINT COMPLETE COMPUTATION FOR  K-SUB-I,J
C
  120 CALL GMMATS (TEMPAR(NCOM),3,3,0, TEMPAR(NPT2),3,3,0, TEMPAR(NPT1))
      NPT36 = NPT1 + 35
C
      DO 140 J = 1,9
      NPOINT = NPOINT + 1
      NPT2   = NPT1 + J - 1
  140 KIJ(NPOINT) = TEMPAR(NPT2)
  190 CONTINUE
  200 CONTINUE
C
      DICT5 = GSUBE
      RETURN
C
C     HEAT PROBLEM LOGIC PICKS UP HERE.  CALL HMAT FOR MATERIAL DATA.
C
  300 INFLAG = 2
      MATID  = NECPT(6)
      ELTEMP = ECPT(21)
      CALL HMAT (NECPT)
      G(1) = MATBUF(1)
      G(2) = MATBUF(2)
      G(3) = MATBUF(2)
      G(4) = MATBUF(3)
C
C     CONDENSE C MATRIX FOR HEAT PROBLEM (FORMED ABOVE)  C IS (2X3)
C
      C(2) = C(4)
      C(3) = C(7)
      C(4) = C(10)
      C(5) = C(13)
      C(6) = C(16)
C
C     DETERMINE THE PIVOT POINT.
C
      KQ   = 3
      KMAX = KQ*3
      DO 320 I = 1,KMAX
  320 KIJ(I) = 0.
      DO 400 NPVT = 1,3
C
C     PIVOT C MATRIX TIMES VOLUME (STORED INTO TT(1) AND TT(2).)
C
      TT(1) = VOL*C(2*NPVT-1)
      TT(2) = VOL*C(2*NPVT  )
C
C     OUTPUT THE CONDUCTIVITY MATRICES
C
      NPOINT = (NPVT-1)*KQ
C
      DO 380 I = 1,3
      N2 = 2*I
      N1 = N2 - 1
      TEMPAR(1) = (G(1)*C(N1) + G(2)*C(N2))*TT(1)  +
     1            (G(3)*C(N1) + G(4)*C(N2))*TT(2)
C
C     SUB-TRIANGLE (RETURN 3X3-S AS ABOVE IN STIFFNESS PORTION)
C
      KIJ(NPOINT+1) = TEMPAR(1)
      NPOINT = NPOINT + 1
  380 CONTINUE
  400 CONTINUE
      RETURN
C
C     ERROR  EXITS
C
 7770 CALL MESAGE (30,31,NECPT(1))
 7777 NOGO = .TRUE.
      RETURN
 7780 CALL MESAGE (30,32,NECPT(1))
      GO TO 7777
 7790 CALL MESAGE (30,26,NECPT(1))
      GO TO 7777
C
      END

      SUBROUTINE IFS2P (*,*,*)
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        LSHIFT,ORF
      LOGICAL         ABORT,FLUSH,FLSHAL,EC,INT,DMIFLG,FPHYS,FPHYS1,
     1                BADDAT,BADFOR,IAX,IAXF,FPHYS2,LHARM,SECD,FTHRU
      INTEGER         NAM(2),ONM(2),NM(2),T(7),IHILL(2),IHOFF(2),
     1                ITSAI(2),ISTRS(2),ISTRN(2),IALL(2),ISYM(2),
     2                IMEM(2),ISYMM(2)
      REAL            XM(100),Z(100),XL,XL1,X1,X2,ZSEQ,ZSEQ1,OLDXM3
      DOUBLE PRECISION DA(2)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /MACHIN/ MACH
      COMMON /XMSSG / UFM,UWM,UIM,SFM
      COMMON /SYSTEM/ KSYSTM(77)
      COMMON /XPFIST/ IPFIST
      COMMON /XFIST / IFIST(1)
      COMMON /XFIAT / IFIAT(2)
      COMMON /IFPX1 / NT1,T1(2,1)
      COMMON /IFPDTA/ ID,N,K,KX,KY,I(100),M(100),MF(100),M1(100),
     1                M1F(100),KN,BADDAT,BADFOR,NOPEN,NPARAM,IAX,NAX,
     2                IAXF,NAXF,LHARM,KNT,SLOTDF(5),GC(7),LL(6)
      COMMON /ZBLPKX/ A(4),I0
      COMMON /ZZZZZZ/ IBUF(1)
      COMMON /CIFS2P/ FPHYS,FPHYS1,KM,DMIFLG,IBCDS,FTHRU,FPHYS2
      COMMON /XDPL  / P(3)
      COMMON /L15 L8/ L15,L8
C
C     P(1) = NEXT AVAILABLE FILE ON POOL
C     P(2) = TOTAL NUMBER OF POSSIBLE ENTRYS
C     P(3) = CURRENT NUMBER OF ENTRYS PRESENT
C     P(4) - P(3*P(2)+3) = THREE WORDS FOR EACH ENTRY AS FOLLOWS...
C            1.  NAME(1)
C            2.  NAME(2)
C            3.  EQUIV FLAG, SIZE/1000, FILE NO. ON POOL
C
      EQUIVALENCE   (KSYSTM( 1) , NBUF  )  , (KSYSTM(24) , ICFIAT) ,
     1              (KSYSTM( 2) , NOUT  )  , (KSYSTM(55) , KPREC ) ,
     2              (KSYSTM( 3) , ABORT )  , (KSYSTM(77) , BANDIT) ,
     3              (NROWS,T(3)),(IFO,T(4)),(TY2,T(5)),(Z(1),I(1)) ,
     4              (XM(1),M(1)),(DA(1),A(1))
C
      DATA   NAM    / 4HISF2,   4HP    /
      DATA   ENDT   / 4HENDT /, SKIP   / 4HSKIP /, POOL   / 4HPOOL /
      DATA   BCDBLK / 4H     /, BCDDET / 4HDET  /, BCDSDT / 4HSDET /,
     1       BCDUDT / 4HUDET /, BCDINV / 4HINV  /, BCDSIN / 4HSINV /,
     2       BCDUIN / 4HUINV /, BCDGIV / 4HGIV  /, BCDMGV / 4HMGIV /,
     3       BCDHES / 4HHESS /, BCDFER / 4HFEER /, BCDMAS / 4HMASS /,
     4       BCDMAX / 4HMAX  /, BCDPOI / 4HPOIN /,
     5       BCDQ   / 4H-Q   /, BCDT   / 4HT    /, BCDZ   / 4H-X   /,
     6       BCDLL  / 4HLL   /, BCDSL  / 4HSL   /, BCDLS  / 4HLS   /
      DATA   THRU   / 4HTHRU /, EIGR   / 4HEIGR /, EIGB   / 4HEIGB /
      DATA   DMI    / 4H DMI /, DTI    / 4H DTI /, DMIG   / 4HDMIG /
      DATA   ENDRC1,  ENDRC2 /  4HENDR , 4HEC   /
      DATA   ISCR1  / 301    /, ICOMP  / 1      /
      DATA   IHILL  , IHOFF   , ITSAI  , ISTRS   , ISTRN  /
     1       4HHILL , 4H      , 4HHOFF , 4H      , 4HTSAI , 4H      ,
     2       4HSTRE , 4HSS    , 4HSTRA , 4HIN   /
      DATA   IALL   , ISYM    , IMEM   , ISYMM  /
     1       4HALL  , 4H      , 4HSYM  , 4H      , 4HMEM  , 4H      ,
     2       4HSYMM , 4HEM   /
      DATA   IYES,    INO    /  4HYES  , 4HNO   /
C
C     =======================================================
C     DMI AND DMIG MUST ACCOMODATE ALL KINDS OF SPECIAL FORMS
C     E.G., IDENTITY MATRIX
C     =======================================================
C
      IF (K .GT. 100) GO TO 81
      GO TO (     5,   5,   5,   5,   5,   5,   5,   5,   5,   5,
     1            5,   5,   5,   5,   5,   5,   5,   5,   5,   5,
     2            5,   5,   5,   5,   5,   5,   5,   5,   5,   5,
     3            5,   5,   5,   5,   5,   5,   5,   5,   5,   5,
     4            5,   5,   5,   5,   5,   5,   5,   5,   5,   5,
     5            5,   5,   5,   5,   5,   5,   5,   5,   5,   5,
     6            5,   5,   5,   5,   5,   5,   5,   5,   5,   5,
     7            5,   5,   5,   5,   5,   5,   5,   5,   5,   5,
     8            5,   5,   5,   5, 850, 850, 870,   5, 890,   5,
     9            5,   5, 920, 920, 920, 960, 920,   5,   5,   5 ), K
   81 IF (KX .GT. 100) GO TO 82
      GO TO (     5,   5,   5,   5,   5,   5,   5,   5,   5,   5,
     1            5,   5,   5,   5,   5,   5,   5,   5,1190,1200,
     2            5,   5,   5,   5,   5,   5,   5,   5,   5,   5,
     3            5,   5, 920, 920,   5,   5,   5,   5,   5, 920,
     4          960,   5,   5,   5,   5,   5,   5,   5,   5,   5,
     5            5,   5,   5,   5,   5,   5,   5,   5,   5,   5,
     6            5, 920,   5,   5,   5,   5,   5,   5,   5,   5,
     7            5,   5,   5,   5,   5,   5,   5,   5,   5,   5,
     8            5,   5,   5,   5,   5,   5,   5,1000,   5,   5,
     9          920,2900,   5,   5,   5,   5,   5,   5,   5,2000 ), KX
   82 IF (KY .GT. 100) GO TO 83
      GO TO (     5,   5,   5,   5,   5,   5,   5,   5,   5,   5,
     1            5,   5,   5,   5,   5,   5,   5,   5,   5,   5,
     2            5,   5,   5,   5,   5,   5,   5,   5,   5,   5,
     3            5,   5,   5,   5,   5,   5,   5,   5,   5,   5,
     4            5,   5,   5,   5,   5,   5,   5,   5,   5,   5,
     5            5,   5,   5,   5,   5,   5,   5,   5,   5,   5,
     6         3100,3300,   5,   5,   5,   5,   5,   5,   5,   5,
     7            5,   5,   5,   5,   5,   5,   5,   5,   5,4100,
     8         4300,4500,4700,   5,   5,   5,   5,   5,   5,   5,
     9            5,   5,   5,   5,   5,   5,   5,   5,   5,   5 ), KY
   83 KZ = K - 300
      IF (KZ .GT. 60) GO TO 5
      GO TO (     5,   5,   5,   5,   5,   5,   5,   5,   5,   5,
     1            5,   5,   5,   5,   5,   5,   5,   5,   5,   5,
     2            5,   5,   5,   5,   5,   5,   5,   5,   5,   5,
     3            5,   5,   5,   5,   5,   5,   5,   5,   5,   5,
     4            5,   5,   5,   5,   5,   5,   5,   5,   5,   5,
     5            5,   5,   5,3200,   5,   5, 920,   5,   5,   5 ), KZ
    5 CALL PAGE2 (2)
      WRITE  (NOUT,6) SFM
    6 FORMAT (A25,' 322, ILLEGAL ENTRY TO IFS2P.')
      ABORT  =.TRUE.
      RETURN 1
    7 BADFOR =.TRUE.
      RETURN 1
    8 BADDAT =.TRUE.
      RETURN 1
    3 DO 4 L = 1,N
    4 I(L) = M(L)
    2 RETURN
    9 RETURN 3
C
C*******       85-EIGR, 86-EIGB      ***********************************
C
  850 IF (M(1) .LE. 0) GO TO 8
      IF (M(3).NE.BCDBLK .AND. M(2).NE.BCDFER) GO TO 8
      IF (M(2).NE.BCDDET .AND. M(2).NE.BCDSDT .AND. M(2).NE.BCDUDT .AND.
     1    M(2).NE.BCDINV .AND. M(2).NE.BCDSIN .AND. M(2).NE.BCDUIN .AND.
     2    M(2).NE.BCDGIV .AND. M(2).NE.BCDMGV .AND. M(2).NE.BCDFER)
     3    GO TO 8
      IF (M(2).EQ.BCDFER .AND. (M(3).NE.BCDBLK .AND. M(3).NE.BCDQ .AND.
     1    M(3).NE.BCDZ)) GO TO 8
      IF (M(10)+M(11) .EQ. 0) GO TO 852
      IF (M(10).NE.BCDBLK .OR. M(11).NE.BCDBLK) GO TO 860
  852 NM(1) = EIGR
      NM(2) = BCDMAS
      IF (K .EQ. 85) GO TO 855
      NM(1) = EIGB
      NM(2) = BCDMAX
  855 M(10) = NM(2)
      M(12) = 0
      M(13) = 0
      CALL MESAGE (30,222,NM)
      GO TO 865
  860 IF ((M(10).NE.BCDMAS .OR. M(11).NE.BCDBLK) .AND.
     1    (M(10).NE.BCDMAX .OR. M(11).NE.BCDBLK) .AND.
     2    (M(10).NE.BCDPOI .OR. M(11).NE.BCDT )) GO TO 8
      IF (M(10).NE.BCDPOI .AND. (M(12).NE.0 .OR. M(13).NE.0)) GO TO 8
      IF (M(10).EQ.BCDPOI .AND. (M(12).LE.0 .OR. M(13).LT.0)) GO TO 8
  865 IF (M(6).EQ.0 .AND. M(2).NE.BCDGIV .AND. M(2).NE.BCDMGV .AND.
     1    M(2).NE.BCDFER) GO TO 8
      IF (K.EQ.86 .AND. (M(2).EQ.BCDGIV .OR. M(2).EQ.BCDMGV)) GO TO 8
      IF ((M(2).EQ.BCDDET .OR. M(2).EQ.BCDSDT) .AND. XM(4).LT.0.0)
     1    GO TO 8
      IF (M(2).EQ.BCDUDT .AND. XM(4).LT.0.0) GO TO 8
      IF (K.EQ.85 .AND. M(2).NE.BCDGIV .AND. M(2).NE.BCDMGV .AND.
     1    XM(4).LT.0.0) GO TO 8
      IF (M(2).NE.BCDGIV .AND. M(2).NE.BCDMGV .AND. M(2).NE.BCDFER .AND.
     1    XM(5).LE.0.0) GO TO 8
      IF (M(2).NE.BCDGIV .AND. M(2).NE.BCDMGV .AND. M(2).NE.BCDFER .AND.
     1    XM(4).GE.XM(5)) GO TO 8
      N = 18
      GO TO 3
C
C*****         87-EIGC          **************************************
C
  870 IF (KM .NE. 0) GO TO 872
      IF (MF(1).NE.1 .OR. MF(2).NE.3 .OR. MF(3).NE.3 .OR. MF(4).NE.1
     1   .AND. MF(4).NE.0 .OR. MF(5).NE.1 .AND. MF(5).NE.0 .OR.
     2   MF(6).NE.2 .AND. MF(6).NE.0 .OR. MF(7).NE.0 .OR. MF(8).NE.0)
     3   GO TO 875
      IF (M(1).LE.0 .OR. M(2).NE.BCDDET .AND. M(2).NE.BCDINV .AND.
     1    M(2).NE.BCDHES .AND. M(2).NE.BCDFER .OR. M(4).NE.BCDMAX .AND.
     2   (M(4).NE.BCDPOI .OR. M(5).NE.BCDT) .OR. XM(8).LT.0.) GO TO 875
      IF (M(4).EQ.BCDMAX .AND. (M(6).NE.0 .OR. M(7).NE.0)) GO TO 875
      IF (M(4).EQ.BCDPOI .AND. (M(6).LE.0 .OR. M(7).LT.0)) GO TO 875
      IF (M1(1).NE.0 .OR. M1(2).NE.0) GO TO 875
      N = 10
  874 DO 871 L = 1,N
  871 I(L) = M(L)
      GO TO 876
  872 DO 873 L = 1,5
      IF (MF(L).NE.2 .AND. MF(L).NE.0) GO TO 875
  873 CONTINUE
      IF (MF(6).NE.1 .AND. MF(6).NE.0 .OR. MF(7).NE.1 .AND. MF(7).NE.0
     1   .OR. MF(8).NE.0) GO TO 875
      IF (XM(5) .LE. 0.) XM(5) = 1.0
      IF (M(6).LT.0 .OR. M(7).LT.0) GO TO 875
      N = 7
      GO TO 874
  875 BADDAT = .TRUE.
  876 IF (M1(1).EQ.0 .AND. M1(2).EQ.0) GO TO 877
      DO 878 L = 1,7
      N = N + 1
  878 I(N) =-1
      KM = 0
      KN = 0
      GO TO 9
  877 KN = 1
      KM = 1
      GO TO 9
C
C*******       -BLANK CARD-        *************************************
C
  890 IF (IBCDS .NE. 0)RETURN 2
      IBCDS = 1
      CALL PAGE2 (2)
      WRITE  (NOUT,891) UWM
  891 FORMAT (A25,' 324, BLANK CARD(S) IGNORED.')
      RETURN 2
C
C*******       93- TABLEM1, 94-TABLEM2, 95-TABLEM3  ********************
C              133-TABLED1,134-TABLED2,140-TABLED3
C              162-TABDMP1, 97-TABLES1,191-TABRND1
C              357-TABLEM5
C                 (TABLEM5 IS DESIGNED FOR THERMAL COEFFICIENT WHICH IS
C                          FUNCTION OF TIME
C                          THIS PROJECT TEMPORARY HALTS HERE  6/90)
C
  920 IF (KM .NE. 0) GO TO 933
      I2 = M(1)
      ITEMS = 0
      N = 8
      IF (M(1) .LE. 0) BADDAT = .TRUE.
      IF (MF(1).NE. 1) BADFOR = .TRUE.
      I(1) = I2
      DO 925 L = 2,7
      IF (MF(L).NE.0 .AND. MF(L).NE.2) BADFOR = .TRUE.
  925 I(L) = M(L)
C
C     LOGARITHMIC SCALE
C     I(8) = 0, LINEAR-LINEAR SCALE (ALL TABLES)
C          = 1, LOG-LOG SCALE (TABLE-1 ONLY)
C          = 2, LINEAR-LOG SCALE (TABLE-1, TABLE-2 AND TABLE-3)
C          = 3, LOG-LINEAR SCALE (TABLE-1 ONLY)
C     TABLE-1 INCLUDES TABLED1, TABLEM1, TABLES1, TABDMP1 AND TABRND1
C     TABLE-2 INCLUDES TABLED2 AND TABLEM2
C
      I(8) = 0
      IF (MF(8).NE. 3) GO TO 930
      IF (M(8) .EQ. BCDLL) I(8) = 1
      IF (M(8) .EQ. BCDSL) I(8) = 2
      IF (M(8) .EQ. BCDLS) I(8) = 3
      IF (M(8).NE.BCDSL .AND. (K.EQ.94 .OR. K.EQ.95 .OR. K.EQ.134 .OR.
     1    K.EQ.140)) BADDAT = .TRUE.
C
  930 IF (M1(1).NE.0 .OR. M1(2).NE.0) GO TO 932
      KN = 1
      KM = 1
      GO TO 966
  932 BADDAT = .TRUE.
      KN = 0
      KM = 0
      GO TO 966
  933 L1 = 0
      DO 955 L = 1,7,2
      IF (MF(L).EQ.3 .OR. MF(L+1).EQ.3) GO TO 937
      IF (MF(L).NE.0 .AND. MF(L).NE.2 .OR. MF(L+1).NE.0 .AND.
     1   MF(L+1).NE.2) GO TO 943
      ITEMS = ITEMS + 1
      N  = N + 2
      L1 = L1 + 2
      I(N-1) = M(L1-1)
      I(N  ) = M(L1  )
      IF (ITEMS .GT. 2) GO TO 935
      IF (ITEMS .GT. 1) GO TO 934
      X1 = Z(N-1)
      XL = X1
      GO TO 936
  934 X2  = Z(N-1)
      XL1 = XL
      XL  = X2
      ZSEQ= SIGN(1.0,X2-X1)
      IF (X2 .EQ. X1) BADDAT = .TRUE.
      GO TO 936
  935 XL1 = XL
      XL  = Z(N-1)
      ZSEQ1 = SIGN(1.0,XL-XL1)
      IF (ZSEQ1.NE.ZSEQ .AND. XL.NE.XL1) BADDAT = .TRUE.
  936 GO TO 955
  937 IF (MF(L) .EQ. 3) GO TO 938
      L1  = L1 + 1
      LP1 = L1
      KWORD1 = 0
      GO TO 939
  938 L1  = L1 + 2
      LP1 = L1 - 1
      KWORD1 = M(LP1)
  939 IF (MF(L+1) .EQ. 3) GO TO 941
      L1  = L1 + 1
      LP2 = L1
      KWORD2 = 0
      GO TO 942
  941 L1  = L1 + 2
      LP2 = L1 - 1
      KWORD2 = M(LP2)
  942 IF (KWORD1.EQ.ENDT .OR. KWORD2.EQ.ENDT) GO TO 961
      IF (KWORD1.EQ.SKIP .OR. KWORD2.EQ.SKIP) GO TO 955
      BADDAT = .TRUE.
      GO TO 956
  955 CONTINUE
      GO TO 956
  943 BADFOR = .TRUE.
      GO TO 956
  956 IF (M1(1).EQ.0 .AND. M1(2).EQ.0) GO TO 966
      KN = 0
      KM = 0
      BADDAT = .TRUE.
      GO TO 966
  961 N = N + 2
      I(N-1) = -1
      I(N  ) = -1
      IF (XL  .EQ. XL1) BADDAT = .TRUE.
      IF (ITEMS .LT. 2) BADDAT = .TRUE.
  958 IF (M1(1).EQ.0 .AND. M1(2).EQ.0) GO TO 965
      KN = 0
      KM = 0
      GO TO 966
  965 KN = 1
      KM = 1
      BADDAT = .TRUE.
  966 IF (BADDAT .OR. BADFOR) GO TO 968
      GO TO 2
  968 M(1) = I2
      GO TO 8
C
C*******      96-TABLEM4, 141-TABLED4     ******************************
C
  960 IF (KM .NE. 0) GO TO 964
      ITEMS = 0
      I2 = M(1)
      N  = 8
      IF (M(1)  .LE. 0) BADDAT = .TRUE.
      IF (MF(1) .NE. 1) BADFOR = .TRUE.
      I(1) = I2
      IF (M(3) .EQ. 0) BADDAT = .TRUE.
      DO 962 L = 2,8
      IF (MF(L).NE.0 .AND. MF(L).NE.2 .OR. L.GE.6 .AND. MF(L).NE.0)
     1   BADFOR = .TRUE.
  962 I(L) = M(L)
      I(8) = 0
      IF (M1(1).NE.0 .OR. M1(2).NE.0) GO TO 963
      KN = 1
      KM = 1
      GO TO 966
  963 BADDAT = .TRUE.
      KN = 0
      KM = 0
      GO TO 966
  964 L1 = 0
      DO 967 L = 1,8
      KWORD1 = 0
      IF (MF(L) .EQ. 3) GO TO 969
      IF (MF(L).NE.0 .AND. MF(L).NE.2) GO TO 943
      N = N + 1
      ITEMS = ITEMS + 1
      L1   = L1 + 1
      I(N) = M(L1)
      GO TO 967
  969 L1 = L1 + 2
      KWORD1 = M(L1-1)
      IF (KWORD1 .EQ. ENDT) GO TO 959
      BADDAT = .TRUE.
      GO TO 956
  967 CONTINUE
      GO TO 956
  959 N = N + 1
      I(N) = -1
      IF (ITEMS .LT. 1) BADDAT = .TRUE.
      GO TO 958
C
C*****     188-TABRNDG       **************************************
C
 1000 IF (M(1) .LT. 0) GO TO 8
      IF (M(2).LT.1 .OR. M(2).GT.2) GO TO 8
      I(1) = M(1)
      I(2) = M(2)
      I(3) = M(3)
      I(4) = M(4)
      I(5) = 0
      I(6) = 0
      I(7) = 0
      I(8) = 0
      I(9) =-1
      I(10)=-1
      N    = 10
      GO TO 2
C
C******         119-DMI          ************************************
C
 1190 IF (KM .NE. 0) GO TO 8150
      IF (FPHYS) GO TO 8005
      IF (M(1).EQ.NM(1) .AND. M(2).EQ.NM(2)) GO TO 8100
      ASSIGN 8010 TO R
      GO TO 8973
 8005 IF (P(1) .GT. 1) DMIFLG = .TRUE.
      FPHYS = .FALSE.
      NM(1) = 0
      NM(2) = 0
      IF (BANDIT.NE.-1 .AND. BANDIT.NE.-2) BANDIT = +9
 8010 FLUSH = .FALSE.
      FLSHAL= .FALSE.
      EC    = .TRUE.
      SECD  = .FALSE.
      T(1)  = ISCR1
      DO 8012 L = 2,7
 8012 T(L) = 0
      IF (M(3) .NE. 0) FLUSH = .TRUE.
      ONM(1) = NM(1)
      ONM(2) = NM(2)
      IF (MF(1).NE.3 .OR. M(1).EQ.ONM(1) .AND. M(2).EQ.ONM(2))
     1    FLUSH = .TRUE.
      NM(1)  = M(1)
      NM(2)  = M(2)
      IPRINT = 0
      J0     = 0
      IF (P(1) .LE. P(2)) GO TO 8020
      FLUSH  = .TRUE.
      FLSHAL = .TRUE.
 8020 ASSIGN 8025 TO R1
      ASSIGN 8030 TO R
      GO TO 200
 8025 FLUSH = .TRUE.
 8030 IF (FLUSH) GO TO 8960
      IFO = M(4)
      TY1 = M(5)
      TY2 = M(6)
      IF (TY2.EQ.0 .AND. MOD(TY1,2).EQ.1) TY2 = TY1 + KPREC - 1
      IF (TY2.EQ.0 .AND. MOD(TY1,2).EQ.0) TY2 = TY1
      IF (MACH .NE. 12) GO TO 8033
      IF (TY2.EQ.2 .OR. TY2.EQ.4) TY2 = TY2 - 1
 8033 CONTINUE
      IF (TY1.LT.1 .OR. TY1.GT.4 .OR. TY2.LT.1 .OR. TY2.GT.4) GO TO 8950
      IF (TY1.GE.3 .AND. TY2.LE.2) WRITE (NOUT,8035) UWM,DMI,NAM(1),
     1                                               NAM(2),KNT
 8035 FORMAT (A25,' 327A, ',A4,' CARD ',2A4,', SORTED CARD COUNT =',I7,
     1       ' SPECIFYING COMPLEX DATA INPUT', /5X,
     2       'AND REAL MATRIX OUTPUT MAY NOT MAKE SENSE',/)
      NROWS = M(8)
      NCOLS = M(9)
      IF (IFO   .GT. 8) GO TO 8950
      IF (MF(6) .NE. 0) GO TO 8950
      IF (NROWS.LE.0 .OR. NCOLS.LE.0) GO TO 8950
      IF ((IFO.EQ.1 .OR. IFO.EQ.6 .OR. IFO.EQ.8) .AND. (NROWS.NE.NCOLS))
     1   GO TO 8950
      NBUF2 = 2*NBUF
      CALL OPEN (*9997,ISCR1,IBUF(NBUF2+1),1)
      CALL WRITE (ISCR1,NM,2,1)
      IF (M1(1).EQ.0 .AND. M1(2).EQ.0) GO TO 8950
      IF (IFO .EQ. 8) GO TO 8040
      IF (M1(1).NE.T1(1,K) .OR. M1(2).NE.T1(2,K)) GO TO 8950
      GO TO 8960
 8040 IF (M1(1).EQ.T1(1,K) .AND. M1(2).EQ.T1(2,K) .AND.
     1    M1(3).EQ.NM(1)   .AND. M1(4).EQ.NM(2) ) GO TO 8950
      GO TO 8960
 8100 IF (.NOT.EC) GO TO 8950
      IF (FLUSH) GO TO 8960
      EC = .FALSE.
      IF (M(3) .LE. J0) GO TO 8950
 8130 J0 = J0 + 1
      IF (M(3) .EQ. J0) GO TO 8140
      CALL BLDPK (TY1,TY2,ISCR1,0,0)
      CALL BLDPKN (ISCR1,0,T)
      GO TO 8130
 8140 I0 = 1
      L1 = 4
      L1F=-1
      L2 = 9
      IF (TY1.EQ.2 .OR. TY1.EQ.4) L2 = 14
      IF (MF(3).NE.1 .OR. M(4).LT.I0) GO TO 8950
      I0  = M(4) - 1
      INT = .FALSE.
      CALL BLDPK (TY1,TY2,ISCR1,0,0)
      GO TO 8155
 8150 IF (J0.LE.0 .OR. J0.GT.NCOLS) GO TO 8950
      L1  = 1
      L1F = 0
      L2  = 8
      IF (TY1.EQ.2 .OR. TY1.EQ.4) L2 = 16
 8155 L  = L1
 8156 LF = L + L1F
      IF (FTHRU) GO TO 8192
      IF (MF(LF) .EQ. 0) GO TO 8300
      IF (MF(LF).EQ.2 .OR. MF(LF).EQ.4) GO TO 8180
      IF (MF(LF) .EQ. -32767) GO TO 8291
      IF (INT) GO TO 8950
      IF (MF(LF) .EQ. 3) GO TO 8191
      IF (MF(LF).NE.1 .OR. M(L).LT.I0 .OR. M(L).GT.NROWS) GO TO 8950
      I0  = M(L)
      INT = .TRUE.
      GO TO 8290
 8180 GO TO (8181,8182,8183,8184), TY1
C   . REAL SINGLE PRECISION
 8181 IF (MF(LF) .EQ. 4) GO TO 8950
      IF (FLUSH .OR. M(L) .EQ. 0) GO TO 8190
      A(1) = M(L)
      GO TO 8185
C   . REAL DOUBLE PRECISION
 8182 IF (MF(LF) .EQ. 2) GO TO 8950
      A(1) = M(L  )
      A(2) = M(L+1)
      L    = L + 1
      L1F  = L1F - 1
      IF (FLUSH .OR. DA(1).EQ.0.0D0) GO TO 8190
      GO TO 8185
C   . COMPLEX SINGLE PRECISION
 8183 IF (MF(LF) .EQ. 4) GO TO 8950
      IF (SECD) GO TO 8186
      A(1) = M(L)
      SECD = .TRUE.
      GO TO 8290
 8186 A(2) = M(L)
      SECD = .FALSE.
      IF (A(1).EQ.0 .AND. A(2).EQ.0 .OR. FLUSH) GO TO 8190
      GO TO 8185
C   . COMPLEX DOUBLE PRECISION
 8184 IF (MF(LF) .EQ. 2) GO TO 8950
      IF (SECD) GO TO 8187
      A(1) = M(L  )
      A(2) = M(L+1)
      L    = L + 1
      L1F  = L1F - 1
      SECD = .TRUE.
      GO TO 8290
 8187 A(3) = M(L  )
      A(4) = M(L+1)
      L    = L + 1
      L1F  = L1F - 1
      SECD = .FALSE.
      IF (FLUSH .OR. DA(1).EQ.0.0D0 .AND. DA(2).EQ.0.0D0) GO TO 8190
C
C     PACK AN ELEMENT
C
 8185 CALL ZBLPKI
 8190 INT = .FALSE.
      I0  = I0 + 1
      IF (I0 .GT. NROWS) GO TO 8300
      IF (L+1   .GT. L2) GO TO 8290
      IF (MF(LF+1) .NE. 3) GO TO 8290
      L = L + 1
 8191 IF (M(L) .NE. THRU) GO TO 8950
      FTHRU = .TRUE.
      L1F = L1F - 1
      L2  = L2  + 1
      L   = L   + 1
      IF (L .GE. L2) GO TO 8291
      L  = L + 1
      LF = L + L1F
 8192 IF (MF(LF).NE.1 .OR. M(L).LT.I0 .OR. M(L).GT.NROWS) GO TO 8950
 8193 CALL ZBLPKI
      I0 = I0 + 1
      IF (I0 .LE. M(L)) GO TO 8193
      FTHRU = .FALSE.
      IF (I0 .GT. NROWS) GO TO 8300
 8290 L = L + 1
      IF (L .LE. L2) GO TO 8156
 8291 IF (M1(1).EQ.0 .AND. M1(2).EQ.0 .OR. INT) GO TO 8960
      GO TO 8315
 8300 IF (L .EQ. L2) GO TO 8310
      LF = LF + 1
      DO 8305 LX = LF,8
      IF (MF(LX) .EQ. -32767) GO TO 8310
      IF (MF(LX) .NE. 0) GO TO 8950
 8305 CONTINUE
 8310 IF (M1(1).EQ.0 .AND. M1(2).EQ.0) GO TO 8950
 8315 IF (FLUSH) GO TO 8320
      IF (SECD ) GO TO 8950
      IF (FTHRU) GO TO 8950
      CALL BLDPKN (ISCR1,0,T)
 8320 EC = .TRUE.
      GO TO 8960
 8950 FLUSH = .TRUE.
 8960 IF (M1(1).EQ.0 .AND. M1(2).EQ.0 .OR. M1(1).EQ.T1(1,K) .AND.
     1    M1(2).EQ.T1(2,K)) GO TO 8970
      ASSIGN 8970 TO R
      GO TO 8973
 8970 N = 0
      IF (.NOT.FLUSH .OR. IPRINT.NE.0) GO TO 1226
      CALL PAGE2 (2)
      WRITE  (NOUT,8971) UFM,NM(1),NM(2),KNT
 8971 FORMAT (A23,' 325, BAD DATA OR FORMAT OR NON-UNIQUE NAME. DMI ',
     1        2A4,10X,' SORTED CARD COUNT =',I7)
      IPRINT = 1
      GO TO 1226
 8973 IF (FLSHAL) GO TO 8993
      IF (FLUSH ) GO TO 8987
      IF (IFO .EQ. 8) GO TO 8995
 8975 J0 = J0 + 1
      IF (J0 .GT. NCOLS) GO TO 8977
      CALL BLDPK  (TY1,TY2,ISCR1,0,0)
      CALL BLDPKN (ISCR1,0,T)
      GO TO 8975
 8977 IF (NCOLS .EQ. T(2)) GO TO 8978
      FLUSH = .TRUE.
      GO TO 8987
 8978 CONTINUE
      CALL CLOSE (ISCR1,1)
      CALL WRTTRL (T)
      CALL RDTRL  (T)
      IF (ICFIAT .EQ. 11) GO TO 8982
      DO 8980 LX = 1,3
 8980 T(LX+1) = ORF(LSHIFT(T(2*LX),16),T(2*LX+1))
      J = 3
      GO TO 8985
 8982 J = 6
 8985 CALL WRITE (POOL,NM,2,0)
      CALL WRITE (POOL,T(2),J,1)
      IF (L8 .NE. 0) WRITE (NOUT,8986) NM,DMI,(T(IP+1),IP=1,J)
 8986 FORMAT ('0*** DIAG  8 MESSAGE -- TRAILER FOR DATA BLOCK ',2A4,
     1        ' (VIA ',A4,' CARDS) = ',5I7,I9)
      CALL GOPEN (ISCR1,IBUF(2*NBUF+1),2)
      CALL CPYFIL (ISCR1,POOL,IBUF(3*NBUF+1),NOPEN,NWORDS)
      CALL CLOSE (ISCR1,1)
      CALL EOF (POOL)
      DMIFLG = .TRUE.
      P(1) = P(1) + 1
 8987 IP   = 3*P(3) + 4
      P(IP  ) = NM(1)
      P(IP+1) = NM(2)
      IF (FLUSH) NWORDS = 0
      P(IP+2) = ORF(LSHIFT(NWORDS/1000,16),P(1)-1)
      P(3   ) = P(3) + 1
      IF (.NOT.FLUSH) GO TO 8992
      CALL CLOSE (ISCR1,1)
      CALL EOF (POOL)
      P(1) = P(1) + 1
      CALL SKPFIL (POOL,-1)
      IF (DMIFLG) CALL EOF (POOL)
 8990 ABORT = .TRUE.
 8992 GO TO R, (8010,8970)
 8993 WRITE  (NOUT,8994) SFM,NM(1),NM(2)
 8994 FORMAT (A25,' 326, NO ROOM IN /XDPL/ FOR DMI ',2A4)
      CALL PAGE2 (2)
      GO TO 8990
 8995 T(2) = NCOLS
      GO TO 8978
 9997 CALL MESAGE (-1,ISCR1,NM)
C
C******          120-DMIG          ********************************
C
 1200 IF (.NOT.FPHYS1) GO TO 1202
      FPHYS1 = .FALSE.
      NM(1)  = 0
      NM(2)  = 0
 1202 IERR   = 0
      IF (KM   .NE. 0) GO TO 1208
      IF (M(3) .EQ. 0) GO TO 1206
      IF (M(1).NE.NM(1) .OR. M(2).NE.NM(2)) GO TO 1218
      IF (MF(2).NE.1 .OR. MF(3).NE.1 .AND. MF(3).NE.0) GO TO 1218
      IF (M(3).LE.0 .OR. M(4).LT.0 .OR. M(4).GT.6) GO TO 1218
      IF (MF(4) .NE. 0) GO TO 1218
      IF (MF(5).NE.1 .OR. MF(6).NE.1 .AND. MF(6).NE.0) GO TO 1218
      IF (M(6).LE.0 .OR. M(7).LT.0 .OR. M(7).GT.6) GO TO 1218
      IF (MF(7)+ITY1.NE.4 .AND. MF(7).NE.0) GO TO 1218
      IF ((TY1.EQ.1 .OR.  TY1.EQ.2)  .AND. MF(8).NE.0 .OR.
     1     TY1.EQ.3 .AND. MF(8).NE.2 .AND. MF(8).NE.0 .OR.
     2     TY1.EQ.4 .AND. MF(8).NE.4 .AND. MF(8).NE.0) GO TO 1218
      N = 5
      I(N-4) = M(3)
      I(N-3) = M(4)
      I(N-2) = M(6)
      I(N-1) = M(7)
      I(N  ) = M(8)
      IF (TY1 .EQ. 1) GO TO 1204
      N = 6
      I(N) = M(9)
      IF (TY1 .NE. 4) GO TO 1204
      N = 8
      I(N-1) = M(10)
      I(N  ) = M(11)
 1204 IF (M1(1).EQ.0 .AND. M1(2).EQ.0) GO TO 1230
      N = N + 2
      I(N-1) = -1
      I(N  ) = -1
      GO TO 1216
 1206 IF (MF(1).NE.3 .OR. M(1).EQ.NM(1) .AND. M(2).EQ.NM(2)) GO TO 1218
      IFO = M(4)
      TY1 = M(5)
      ITY1= 2*MOD(TY1,2)
      TY2 = M(6)
      IF (TY2.EQ.0 .AND. MOD(TY1,2).EQ.1) TY2 = TY1 + KPREC - 1
      IF (TY2.EQ.0 .AND. MOD(TY1,2).EQ.0) TY2 = TY1
      IF (MACH .NE. 12) GO TO 1207
      IF (TY2.EQ.2.OR.TY2.EQ.4) TY2 = TY2 - 1
 1207 CONTINUE
      IF (TY1.LE.0 .OR. TY1.GT.4 .OR. TY2.LE.0 .OR. TY2.GT.4) GO TO 1218
      IF (TY1.GE.3 .AND. TY2.LE.2) WRITE (NOUT,8035) UWM,DMIG,NM(1),
     1                                               NM(2),KNT
      IF (IFO.NE.1 .AND. IFO.NE.2 .AND. IFO.NE.6) GO TO 1218
      IF (TY2.EQ.1 .AND. TY1.EQ.3) GO TO 1218
      NM(1) = M(1)
      NM(2) = M(2)
      IF (MF(6).NE.0 .OR. MF(7).NE.0 .OR. MF(8).NE.0) GO TO 1220
      IF (M1F(2).NE.3 .OR. M1(3).NE.NM(1) .OR. M1(4).NE.NM(2))
     1    GO TO 1220
      M(6) = TY2
      N = 9
      GO TO 3
 1208 LF = 1
      L  = 1
 1210 IF (M(L).NE.0 .OR. M(L+1).NE.0 .OR. M(L+2).NE.0 .OR. M(L+3).NE.0)
     1    GO TO 1212
      LF = LF + 4
      L  = L  + 4
      GO TO 1214
 1212 IF (M(L).LE.0 .OR. M(L+1).LT.0 .OR. M(L+1).GT.6) GO TO 1220
      IF (MF(LF).NE.1 .OR. MF(LF+1).NE.1 .AND. MF(LF+1).NE.0) GO TO 1220
      IERR = 1
      IF (MF(LF+2)+ITY1.NE.4 .AND. MF(LF+2).NE.0) GO TO 1220
      IF (MF(LF+3).NE.0 .AND. TY1.NE.3 .AND. TY1.NE.4) GO TO 1220
      N = N + 3
      I(N-2) = M(L  )
      I(N-1) = M(L+1)
      I(N  ) = M(L+2)
      LF = LF + 4
      L  = L  + 4
      IF (TY1 .EQ. 1) GO TO 1214
      N = N + 1
      I(N) = M(L-1)
      IF (TY1 .EQ. 2) L = L + 1
      IF (TY1 .NE. 4) GO TO 1214
      N = N + 2
      I(N-1) = M(L  )
      I(N  ) = M(L+1)
      L  = L + 2
 1214 IF (LF .LE. 7) GO TO 1210
      IF (N  .LE. 0) GO TO 1220
      IF (M1(1).EQ.0 .AND. M1(2).EQ.0) GO TO 1230
      N = N + 2
      I(N-1) = -1
      I(N  ) = -1
 1216 IF (M1(1).EQ.T1(1,K) .AND. M1(2).EQ.T1(2,K) .AND.
     1    M1(3).EQ.NM(1  ) .AND. M1(4).EQ.NM(2 )) GO TO 1228
      N = N + 2
      I(N-1) = -1
      I(N  ) = -1
      GO TO 1228
 1218 NM(1) = M(1)
      NM(2) = M(2)
 1220 ABORT = .TRUE.
      CALL PAGE2 (2)
      WRITE  (NOUT,1222) UFM,NM(1),NM(2),KNT
 1222 FORMAT (A23,' 327, BAD DATA OR FORMAT OR NON-UNIQUE NAME. DMIG ',
     1        2A4,10X,' SORTED CARD COUNT =',I7)
      IF (IERR .EQ. 1) WRITE (NOUT,1224)
 1224 FORMAT (5X,'INPUT MATRIX TYPE (TIN) AND INPUT DATA (XIJ OR YIJ) ',
     1       'ARE NOT CONSISTANT')
 1226 IF (M1(1).EQ.0 .AND. M1(2).EQ.0) GO TO 1230
 1228 KM = 0
      KN = 0
      GO TO 2
 1230 KN = 1
      KM = 1
      GO TO 2
C
C*******        200 - DTI       ****************************************
C
 2000 IF (KM .NE. 0) GO TO 2120
      IF (FPHYS2) GO TO 2010
      IF (M(1).EQ.NM(1) .AND. M(2).EQ.NM(2)) GO TO 2100
      ASSIGN 2020 TO R
      GO TO 2300
 2010 IF (P(1) .GT. 1) DMIFLG = .TRUE.
      FPHYS2 = .FALSE.
      NM(1)  = 0
      NM(2)  = 0
 2020 FLUSH  = .FALSE.
      FLSHAL = .FALSE.
      IF (M(3) .NE. 0) FLUSH = .TRUE.
      ONM(1) = NM(1)
      ONM(2) = NM(2)
      IF (MF(1).NE.3 .OR. M(1).EQ.ONM(1) .AND. M(2).EQ.ONM(2))
     1    FLUSH = .TRUE.
      NM(1)  = M(1)
      NM(2)  = M(2)
      IPRINT = 0
      NWORDS = 2
      J0 = 0
      IF (P(1) .LE. P(2)) GO TO 2050
      FLUSH  = .TRUE.
      FLSHAL = .TRUE.
 2050 ASSIGN 2055 TO R1
      ASSIGN 2056 TO R
      GO TO 200
 2055 FLUSH = .TRUE.
 2056 IF (FLUSH) GO TO 2195
      ITRLT = 0
      DO 2060 L = 2,7
      ITRLT = ITRLT+M(L+2)
      IF (ICFIAT.EQ.8  .AND. (M(L+2).LT.0 .OR. M(L+2).GT.65535))
     1    FLUSH = .TRUE.
C     2147483647 = 2**31-1
      IF (ICFIAT.EQ.11 .AND. (M(L+2).LT.0 .OR. M(L+2).GT.2147483647))
     1    FLUSH = .TRUE.
 2060 T(L) = M(L+2)
      IF (ITRLT .NE. 0) GO TO 2080
      DO 2070 L = 2,7
 2070 T(L) = 32767
 2080 CONTINUE
      CALL WRITE (POOL,NM,2,0)
      IF (ICFIAT .EQ. 11) GO TO 2087
      DO 2085 LX = 1,3
 2085 T(LX+1) = ORF(LSHIFT(T(2*LX),16),T(2*LX+1))
      L = 3
      GO TO 2090
 2087 L = 6
 2090 CALL WRITE (POOL,T(2),L,1)
      CALL WRITE (POOL,NM,2,0)
      IF (L8 .NE. 0) WRITE (NOUT,8986) NM,DTI,(T(IP+1),IP=1,J)
      IF (M1(1).EQ.T1(1,K) .AND. M1(2).EQ.T1(2,K))
     1   CALL WRITE (POOL,NM,0,1)
      GO TO 2200
 2100 J0 = J0 + 1
      IF (M(3) .NE. J0) GO TO 2190
      L1  = 4
      L1F =-1
      GO TO 2150
 2120 L1 = 1
      L1F= 0
 2150 L  = L1
      LF = L + L1F
 2160 IF (MF(LF).EQ.3 .AND. M(L).EQ.ENDRC1 .AND. M(L+1).EQ.ENDRC2)
     1    GO TO 2180
      IF (MF(LF) .GT. 2) L = L + 1
      L  = L  + 1
      LF = LF + 1
      IF (MF(LF) .GE. 0) GO TO 2160
      CALL WRITE (POOL,M(L1),L-L1,0)
      NWORDS = NWORDS + L - L1
      IF (M1(1).NE.0 .OR. M1(2).NE.0) GO TO 2190
      GO TO 2200
 2180 CALL WRITE (POOL,M(L1),L-L1,1)
      NWORDS = NWORDS + L - L1
      IF (M1(1).NE.0 .OR. M1(2).NE.0) GO TO 2195
 2190 FLUSH = .TRUE.
 2195 IF (M1(1).EQ.0 .AND. M1(2).EQ.0 .OR.
     1    M1(1).EQ.T1(1,K) .AND. M1(2).EQ.T1(2,K)) GO TO 2200
      ASSIGN 2200 TO R
      GO TO 2300
 2200 N = 0
      IF (.NOT.FLUSH .OR. IPRINT.NE.0) GO TO 1226
      CALL PAGE2 (2)
      WRITE (NOUT,2350) UFM,NM(1),NM(2),KNT
      IPRINT = 1
      GO TO 1226
 2300 IF (FLSHAL) GO TO 2370
      IF (FLUSH ) GO TO 2330
      CALL EOF (POOL)
      DMIFLG = .TRUE.
      P(1)   = P(1) + 1
 2330 IP = 3*P(3) + 4
      P(IP  ) = NM(1)
      P(IP+1) = NM(2)
      IF (FLUSH) NWORDS = 0
      P(IP+2) = ORF(LSHIFT(NWORDS/1000,16),P(1)-1)
      P(3) = P(3) + 1
      IF (.NOT.FLUSH) GO TO 2365
      CALL PAGE2 (2)
      WRITE  (NOUT,2350) UFM,NM(1),NM(2),KNT
 2350 FORMAT (A23,' 317, BAD DATA OR FORMAT OR NON-UNIQUE NAME FOR DTI '
     1,       2A4,10X,'SORTED CARD COUNT =',I7)
      CALL EOF (POOL)
      P(1) = P(1) + 1
      CALL SKPFIL (POOL,-1)
      IF (DMIFLG) CALL SKPFIL (POOL,+1)
 2360 ABORT = .TRUE.
 2365 GO TO R, (2020,2200)
 2370 WRITE  (NOUT,2380) SFM,NM(1),NM(2)
 2380 FORMAT (A25,' 318, NO ROOM IN /XDPL/ FOR DTI ',2A4)
      CALL PAGE2 (2)
      GO TO 2360
C
C     ******************************************************************
C
C     CHECK NAME FOR UNIQUENESS AMONG DMI CARDS, DTI CARDS, ETC. AND
C     RESERVED NAMES
C
  200 CONTINUE
C
C     CHECK  FIST, FIAT, DPL FOR A NAME MATCH
C
      DO 210 II = 1,IPFIST
      IF (NM(1).EQ.IFIST(2*II+1) .AND. NM(2).EQ.BCDBLK) GO TO 250
  210 CONTINUE
      NFIAT = ICFIAT*IFIAT(2) - 2
      DO 220 II = 4,NFIAT,ICFIAT
      IF (NM(1).EQ.IFIAT(II) .AND. NM(2).EQ.IFIAT(II+1)) GO TO 250
  220 CONTINUE
      NDPL = P(3)*3 + 1
      DO 230 II = 4,NDPL,3
      IF (NM(1).EQ.P(II) .AND. NM(2).EQ.P(II+1)) GO TO 250
  230 CONTINUE
      GO TO R,  (8030,2056)
  250 GO TO R1, (8025,2055)
C
C*******      192-PLOAD4     ****************************************
C
 2900 IF (KM .EQ. 1) GO TO 2940
      KM = 1
      KN = 1
      IF (MF(1) .NE. 1) BADFOR = .TRUE.
      IF (.NOT.(MF(2).EQ.2 .AND. MF(3).EQ.1 .AND. MF(4).EQ.0 .AND.
     1     MF(5).EQ.0 .AND. MF(6).EQ.0)) GO TO 2905
C
C     SPECIAL - ALLOWING PLOAD4 TO TAKE ON PLOAD2 FORMAT
C     (PLOAD4,SID,P1,E1,blank,blank,blank,"THRU",E2) FOR QUICK INPUT
C     DATA SWITCHING.  INTERCHAGNE 2ND AND 3RD FIELDS
C
      MF(2) = 1
      MF(3) = 2
      L     = M(2)
      M(2)  = M(3)
      M(3)  = L
 2905 IF (MF(2) .NE. 1) BADFOR = .TRUE.
      DO 2910 L = 3,6
      IF (MF(L).NE.2 .AND. MF(L).NE.0) BADFOR = .TRUE.
 2910 CONTINUE
      IF (MF(7).NE.3 .AND. MF(7).NE.0 .AND.
     1   .NOT.(MF(7).EQ.1 .AND. M(7).EQ.0)) BADFOR = .TRUE.
      IF (MF(8).NE.1 .AND. MF(8).NE.0) BADFOR = .TRUE.
      IF (MF(7).EQ.0 .AND. MF(8).NE.0) BADFOR = .TRUE.
      IF (MF(7).EQ.3 .AND. MF(8).NE.1) BADFOR = .TRUE.
      IF (M(1) .LE. 0) BADDAT = .TRUE.
      IF (M(2) .LE. 0) BADDAT = .TRUE.
      IF (MF(7).EQ.3 .AND. M(7).NE.THRU) BADDAT = .TRUE.
      IF (MF(7).EQ.3 .AND. M(9).LE.   0) BADDAT = .TRUE.
      IF (MF(7).EQ.3 .AND. M(9).LE.M(2)) BADDAT = .TRUE.
      L1 = 0
      IF (MF(7) .EQ. 3) L1 = 1
      DO 2920 L = 1,6
      I(L) = M(L)
 2920 CONTINUE
      I(7) = -1
      IF (L1 .EQ. 1) I(7) = 0
      I(8) = M(L1+8)
      N = 8
      IF (M1(1).EQ.0 .AND. M1(2).EQ.0) GO TO 9
      DO 2930 L = 9,12
      I(L) = 0
 2930 CONTINUE
      N  = 12
      KM = 0
      KN = 0
      GO TO 9
C
 2940 IF (MF(1) .GT. 1) BADFOR = .TRUE.
      DO 2950 L = 2,4
      IF (MF(L).NE.2 .AND. MF(L).NE.0) BADFOR = .TRUE.
 2950 CONTINUE
      IF (MF(1) .EQ. 0) M(1) = 0
      IF (M(1)  .LT. 0) BADDAT = .TRUE.
      DO 2960 L = 1,4
      I(L) = M(L)
 2960 CONTINUE
      N  = 4
      KM = 0
      KN = 0
      GO TO 9
C
C*******       261-CQUAD4    ****************************************
C
 3100 IF (MF(2) .EQ. 0) M(2) = M(1)
      I(1) = M(1)
      DO 3110 L = 2,6
      IF (MF(L) .NE. 1) BADFOR = .TRUE.
      IF (M(L)  .LE. 0) BADDAT = .TRUE.
      I(L) = M(L)
 3110 CONTINUE
      L1 = 6
      DO 3120 L = 11,14
      L1 = L1 + 1
      I(L1) = M(L)
 3120 CONTINUE
      IF (MF(7).NE.1 .AND. MF(7).NE.2 .AND. MF(7).NE.0) BADFOR = .TRUE.
      IF (MF(7).EQ.1 .AND. (M(7).LT.0 .OR. M(7).GE.1000000))
     1    BADDAT = .TRUE.
      I(11) = M(7)
      I(12) = 0
      IF (MF(7) .EQ. 1) I(12) = 1
      I(13) = M(8)
      N = 13
      GO TO 9
C
C*******       354-CTRIA3      **************************************
C
 3200 IF (MF(2) .EQ. 0) M(2) = M(1)
      I(1) = M(1)
      DO 3210 L = 2,5
      IF (MF(L) .NE. 1) BADFOR = .TRUE.
      IF (M(L)  .LE. 0) BADDAT = .TRUE.
 3210 I(L) = M(L)
      IF (MF(6).NE.1 .AND. MF(6).NE.2 .AND. MF(6).NE.0) BADFOR = .TRUE.
      IF (MF(6).EQ.1 .AND. (M(6).LT.0 .OR. M(6).GE.1000000))
     1    BADDAT = .TRUE.
      I( 6) = M(11)
      I( 7) = M(12)
      I( 8) = M(13)
      I( 9) = M(6)
      I(10) = 0
      I(11) = M(7)
      IF (MF(6) .EQ. 1) I(10) = 1
      N = 11
      GO TO 9
C
C*******        262-MAT8      ****************************************
C
 3300 IF (MF(2).EQ.0 .OR. MF(3).EQ.0 .OR. MF(5).EQ.0) GO TO 7
      IF (M(1) .LE. 0) GO TO 8
      IF (XM(2).EQ.0.0 .OR. XM(3).EQ.0.0) GO TO 8
      IF (XM(5).LE.0.0) GO TO 8
      IF (MF(12).EQ.2 .AND. XM(12).LE.0.0) GO TO 8
      IF (MF(14).EQ.2 .AND. XM(14).LE.0.0) GO TO 8
      IF (MF(16).EQ.2 .AND. XM(16).LE.0.0) GO TO 8
      IF (MF(13) .EQ. 0) XM(13) = XM(12)
      IF (MF(15) .EQ. 0) XM(15) = XM(14)
      N = 18
      GO TO 3
C
C*******        280-PCOMP     ****************************************
C
 4100 KN = 1
      IF (ICOMP .GT. 1) GO TO 4140
      ICOMP = 2
      IF (MF(1).NE.1) BADFOR = .TRUE.
      IF (MF(2).NE.2 .AND. MF(2).NE.0) BADFOR = .TRUE.
      IF (MF(3).NE.2 .AND. MF(3).NE.0) BADFOR = .TRUE.
      IF (MF(4).NE.2 .AND. MF(4).NE.0) BADFOR = .TRUE.
      IF (MF(5).NE.3 .AND. MF(5).NE.0) BADFOR = .TRUE.
      L = 0
      IF (MF(5).EQ.3) L = 1
      IF (MF(6).NE.0) BADFOR = .TRUE.
      IF (MF(7).NE.0) BADFOR = .TRUE.
      IF (MF(8).NE.3 .AND. MF(8).NE.0   ) BADFOR = .TRUE.
      IF (M(1).LE.0 .OR. M(1).GE.1000000) BADDAT = .TRUE.
      IF (MF(5).EQ.3 .AND. XM(4).LE.0.0 ) BADDAT = .TRUE.
      FAILUR = -1
      IF (MF(5)  .EQ. 0) FAILUR = 0
      IF (FAILUR .EQ. 0) GO TO 4120
      IF (M(5).EQ.IHILL(1) .AND. M(6).EQ.IHILL(2)) FAILUR = 1
      IF (M(5).EQ.IHOFF(1) .AND. M(6).EQ.IHOFF(2)) FAILUR = 2
      IF (M(5).EQ.ITSAI(1) .AND. M(6).EQ.ITSAI(2)) FAILUR = 3
      IF (M(5).EQ.ISTRS(1) .AND. M(6).EQ.ISTRS(2)) FAILUR = 4
      IF (M(5).EQ.ISTRN(1) .AND. M(6).EQ.ISTRN(2)) FAILUR = 5
      IF (FAILUR .EQ. -1) BADDAT = .TRUE.
 4120 LAMOPT = -1
      IF (MF(8)  .EQ. 0) LAMOPT = 0
      IF (LAMOPT .EQ. 0) GO TO 4130
      IF (M(L+8).EQ.IALL (1) .AND. M(L+9).EQ.IALL (2)) LAMOPT = 0
      IF (M(L+8).EQ.ISYM (1) .AND. M(L+9).EQ.ISYM (2)) LAMOPT = 1
      IF (M(L+8).EQ.IMEM (1) .AND. M(L+9).EQ.IMEM (2)) LAMOPT = 2
      IF (M(L+8).EQ.ISYMM(1) .AND. M(L+9).EQ.ISYMM(2)) LAMOPT = 3
      IF (LAMOPT .EQ. -1) BADDAT = .TRUE.
 4130 IF (M1(1).EQ.0 .AND. M1(2).EQ.0) GO TO 4135
      BADFOR = .TRUE.
      KN = 0
      ICOMP = 1
      N = 0
      GO TO 9
 4135 I(1) = M(1)
      I(2) = M(2)
      I(3) = M(3)
      I(4) = M(4)
      I(5) = FAILUR
      I(6) = 0
      I(7) = 0
      I(8) = LAMOPT
      N    = 8
      GO TO 9
C
 4140 N = 0
      DO 4190 L = 1,2
      L1 = 4*(L-1)
      L2 = L1
      DO 4150 L3 = 1,4
      IF (MF(L1+L3) .NE. 0) GO TO 4160
 4150 CONTINUE
      IF (L .EQ. 1) BADFOR = .TRUE.
      GO TO 4195
 4160 IF (L.EQ.2 .AND. MF(4).EQ.3) L2 = L2 + 1
      IF (ICOMP .EQ. 3) GO TO 4170
      ICOMP = 3
      IF (MF(1).NE.1) BADFOR = .TRUE.
      IF (MF(2).NE.2) BADFOR = .TRUE.
      IF (MF(3).NE.2 .AND. MF(3).NE.0) BADFOR = .TRUE.
      IF (M(1)  .LE.  0) BADDAT = .TRUE.
      IF (XM(2) .LE.0.0) BADDAT = .TRUE.
      GO TO 4180
 4170 IF (MF(L1+1).NE.1 .AND. MF(L1+1).NE.0) BADFOR = .TRUE.
      IF (MF(L1+2).NE.2 .AND. MF(L1+2).NE.0) BADFOR = .TRUE.
      IF (MF(L1+3).NE.2 .AND. MF(L1+3).NE.0) BADFOR = .TRUE.
      IF (MF(L1+1).EQ.1 .AND. M (L2+1).LE.0) BADDAT = .TRUE.
      IF (MF(L1+1) .EQ. 0) M(L2+1) = IOLD1
      IF (MF(L1+2).EQ.2 .AND. XM(L2+2).LE.0.0) BADDAT = .TRUE.
      IF (MF(L1+2) .EQ. 0) M(L2+2) = IOLD2
      IF (MF(L1+3) .EQ. 0) M(L2+3) = IOLD3
 4180 IF (MF(L1+4).NE.3 .AND. MF(L1+4).NE.0) BADFOR = .TRUE.
      IF (MF(L1+4).EQ.3 .AND. (M(L2+4).NE.IYES .AND. M(L2+4).NE.INO))
     1    BADDAT = .TRUE.
      IOUT = 0
      IF (M(L2+4) .EQ. IYES) IOUT = 1
      I(N+1) = M(L2+1)
      I(N+2) = M(L2+2)
      I(N+3) = M(L2+3)
      I(N+4) = IOUT
      IOLD1  = M(L2+1)
      IOLD2  = M(L2+2)
      IOLD3  = M(L2+3)
      N = N + 4
 4190 CONTINUE
      IF (M1(1).EQ.0 .AND. M1(2).EQ.0) GO TO 9
 4195 KN = 0
      ICOMP  = 1
      I(N+1) =-1
      N = N + 1
      GO TO 9
C
C*******        281-PCOMP1    ****************************************
C
 4300 KN = 1
      IF (ICOMP .GT. 1) GO TO 4340
      ICOMP = 2
      IF (MF(1).NE.1) BADFOR = .TRUE.
      IF (MF(2).NE.2 .AND. MF(2).NE.0) BADFOR = .TRUE.
      IF (MF(3).NE.2 .AND. MF(3).NE.0) BADFOR = .TRUE.
      IF (MF(4).NE.2 .AND. MF(4).NE.0) BADFOR = .TRUE.
      IF (MF(5).NE.3 .AND. MF(5).NE.0) BADFOR = .TRUE.
      L = 0
      IF (MF(5) .EQ. 3) L = 1
      IF (MF(6).NE.1) BADFOR = .TRUE.
      IF (MF(7).NE.2) BADFOR = .TRUE.
      IF (MF(8).NE.3 .AND. MF(8).NE.0   ) BADFOR = .TRUE.
      IF (M(1).LE.0 .OR. M(1).GE.1000000) BADDAT = .TRUE.
      IF (MF(5).EQ.3 .AND. XM(4).LE.0.0 ) BADDAT = .TRUE.
      FAILUR = -1
      IF (MF(5)  .EQ. 0) FAILUR = 0
      IF (FAILUR .EQ. 0) GO TO 4320
      IF (M(5).EQ.IHILL(1) .AND. M(6).EQ.IHILL(2)) FAILUR = 1
      IF (M(5).EQ.IHOFF(1) .AND. M(6).EQ.IHOFF(2)) FAILUR = 2
      IF (M(5).EQ.ITSAI(1) .AND. M(6).EQ.ITSAI(2)) FAILUR = 3
      IF (M(5).EQ.ISTRS(1) .AND. M(6).EQ.ISTRS(2)) FAILUR = 4
      IF (M(5).EQ.ISTRN(1) .AND. M(6).EQ.ISTRN(2)) FAILUR = 5
      IF (FAILUR .EQ. -1) BADDAT = .TRUE.
 4320 IF (M(L+6) .LE.  0) BADDAT = .TRUE.
      IF (XM(L+7).LE.0.0) BADDAT = .TRUE.
      LAMOPT = -1
      IF (MF(8)  .EQ. 0) LAMOPT = 0
      IF (LAMOPT .EQ. 0) GO TO 4330
      IF (M(L+8).EQ.IALL (1) .AND. M(L+9).EQ.IALL (2)) LAMOPT = 0
      IF (M(L+8).EQ.ISYM (1) .AND. M(L+9).EQ.ISYM (2)) LAMOPT = 1
      IF (M(L+8).EQ.IMEM (1) .AND. M(L+9).EQ.IMEM (2)) LAMOPT = 2
      IF (M(L+8).EQ.ISYMM(1) .AND. M(L+9).EQ.ISYMM(2)) LAMOPT = 3
      IF (LAMOPT .EQ. -1) BADDAT = .TRUE.
 4330 IF (M1(1).EQ.0 .AND. M1(2).EQ.0) GO TO 4335
      BADFOR = .TRUE.
      KN = 0
      ICOMP = 1
      N = 0
      GO TO 9
 4335 I(1) = M(1)
      I(2) = M(2)
      I(3) = M(3)
      I(4) = M(4)
      I(5) = FAILUR
      I(6) = M(L+6)
      I(7) = M(L+7)
      I(8) = LAMOPT
      N    = 8
      GO TO 9
C
 4340 N = 0
      DO 4390 L = 1,8
      IF (MF(L) .NE. 0) GO TO 4360
      IF (L .EQ. 1) BADFOR = .TRUE.
      GO TO 4395
 4360 IF (ICOMP .EQ. 3) GO TO 4370
      ICOMP = 3
      IF (MF(1) .NE. 2) BADFOR = .TRUE.
      GO TO 4380
 4370 IF (MF(L).NE.2 .AND. MF(L).NE.0) BADFOR = .TRUE.
      IF (MF(L) .EQ. 0) M(L) = IOLD1
 4380 I(N+1) = M(L)
      IOLD1  = M(L)
      N = N + 1
 4390 CONTINUE
      IF (M1(1).EQ.0 .AND. M1(2).EQ.0) GO TO 9
 4395 KN = 0
      ICOMP  = 1
      I(N+1) =-1
      N = N + 1
      GO TO 9
C
C*******        282-PCOMP2    ****************************************
C
 4500 KN = 1
      IF (ICOMP .GT. 1) GO TO 4540
      ICOMP = 2
      IF (MF(1) .NE. 1) BADFOR = .TRUE.
      IF (MF(2).NE.2 .AND. MF(2).NE.0) BADFOR = .TRUE.
      IF (MF(3).NE.2 .AND. MF(3).NE.0) BADFOR = .TRUE.
      IF (MF(4).NE.2 .AND. MF(4).NE.0) BADFOR = .TRUE.
      IF (MF(5).NE.3 .AND. MF(5).NE.0) BADFOR = .TRUE.
      L = 0
      IF (MF(5) .EQ. 3) L = 1
      IF (MF(6) .NE. 1) BADFOR = .TRUE.
      IF (MF(7) .NE. 0) BADFOR = .TRUE.
      IF (MF(8).NE.3 .AND. MF(8).NE.0   ) BADFOR = .TRUE.
      IF (M(1).LE.0 .OR. M(1).GE.1000000) BADDAT = .TRUE.
      IF (MF(5).EQ.3 .AND. XM(4).LE.0.0 ) BADDAT = .TRUE.
      FAILUR = -1
      IF (MF(5)  .EQ. 0) FAILUR = 0
      IF (FAILUR .EQ. 0) GO TO 4520
      IF (M(5).EQ.IHILL(1) .AND. M(6).EQ.IHILL(2)) FAILUR = 1
      IF (M(5).EQ.IHOFF(1) .AND. M(6).EQ.IHOFF(2)) FAILUR = 2
      IF (M(5).EQ.ITSAI(1) .AND. M(6).EQ.ITSAI(2)) FAILUR = 3
      IF (M(5).EQ.ISTRS(1) .AND. M(6).EQ.ISTRS(2)) FAILUR = 4
      IF (M(5).EQ.ISTRN(1) .AND. M(6).EQ.ISTRN(2)) FAILUR = 5
      IF (FAILUR .EQ. -1) BADDAT = .TRUE.
 4520 IF (M(L+6) .LE.  0) BADDAT = .TRUE.
      LAMOPT = -1
      IF (MF(8)  .EQ. 0) LAMOPT = 0
      IF (LAMOPT .EQ. 0) GO TO 4530
      IF (M(L+8).EQ.IALL (1) .AND. M(L+9).EQ.IALL (2)) LAMOPT = 0
      IF (M(L+8).EQ.ISYM (1) .AND. M(L+9).EQ.ISYM (2)) LAMOPT = 1
      IF (M(L+8).EQ.IMEM (1) .AND. M(L+9).EQ.IMEM (2)) LAMOPT = 2
      IF (M(L+8).EQ.ISYMM(1) .AND. M(L+9).EQ.ISYMM(2)) LAMOPT = 3
      IF (LAMOPT .EQ. -1) BADDAT = .TRUE.
 4530 IF (M1(1).EQ.0 .AND. M1(2).EQ.0) GO TO 4535
      BADFOR = .TRUE.
      KN = 0
      ICOMP = 1
      N = 0
      GO TO 9
 4535 I(1) = M(1)
      I(2) = M(2)
      I(3) = M(3)
      I(4) = M(4)
      I(5) = FAILUR
      I(6) = M(L+6)
      I(7) = 0
      I(8) = LAMOPT
      N    = 8
      GO TO 9
C
 4540 N = 0
      DO 4590 L = 1,4
      L1 = 2*(L-1)
      DO 4550 L3 = 1,2
      IF (MF(L1+L3) .NE. 0) GO TO 4560
 4550 CONTINUE
      IF (L .EQ. 1) BADFOR = .TRUE.
      GO TO 4595
 4560 IF (ICOMP .EQ. 3) GO TO 4570
      ICOMP = 3
      IF (MF(1)  .NE. 2) BADFOR = .TRUE.
      IF (MF(2)  .NE. 2) BADFOR = .TRUE.
      IF (XM(1) .LE.0.0) BADDAT = .TRUE.
      GO TO 4580
 4570 IF (MF(L1+1).NE.2 .AND. MF(L1+1).NE. 0) BADFOR = .TRUE.
      IF (MF(L1+2).NE.2 .AND. MF(L1+2).NE. 0) BADFOR = .TRUE.
      IF (MF(L1+1).EQ.2 .AND. XM(L1+1).LE..0) BADDAT = .TRUE.
      IF (MF(L1+1) .EQ. 0) M(L1+1) = IOLD1
      IF (MF(L1+2) .EQ. 0) M(L1+2) = IOLD2
 4580 I(N+1) = M(L1+1)
      I(N+2) = M(L1+2)
      IOLD1  = M(L1+1)
      IOLD2  = M(L1+2)
      N = N + 2
 4590 CONTINUE
      IF (M1(1).EQ.0 .AND. M1(2).EQ.0) GO TO 9
 4595 KN = 0
      ICOMP  = 1
      I(N+1) =-1
      N = N + 1
      GO TO 9
C
C*******        283-PSHELL    ****************************************
C
 4700 IF (KM .EQ. 1) GO TO 4740
      KM = 1
      KN = 1
      IF (MF( 1).NE.1                  ) BADFOR = .TRUE.
      IF (MF( 2).NE.1 .AND. MF( 2).NE.0) BADFOR = .TRUE.
      IF (MF( 3).NE.2 .AND. MF( 3).NE.0) BADFOR = .TRUE.
      IF (MF( 4).NE.1 .AND. MF( 4).NE.0) BADFOR = .TRUE.
      IF (MF( 5).NE.2 .AND. MF( 5).NE.0) BADFOR = .TRUE.
      IF (MF( 6).NE.1 .AND. MF( 6).NE.0) BADFOR = .TRUE.
      IF (MF( 7).NE.2 .AND. MF( 7).NE.0) BADFOR = .TRUE.
      IF (MF( 8).NE.2 .AND. MF( 8).NE.0) BADFOR = .TRUE.
      IF (M(1) .LE. 0) BADDAT = .TRUE.
      IF (MF(2).EQ.1 .AND.  M(2).LE.0) BADDAT = .TRUE.
      IF (MF(4).EQ.1 .AND.  M(4).LE.0) BADDAT = .TRUE.
      IF (MF(4).NE.0 .AND. MF(5).EQ.0) XM(5) = 1.0
      IF (MF(6).EQ.1 .AND.  M(6).LE.0) BADDAT = .TRUE.
      IF (MF(6).NE.0 .AND. MF(4).EQ.0) BADDAT = .TRUE.
      IF (MF(6).NE.0 .AND. MF(7).EQ.0) XM(7) = 0.833333
      DO 4710 L = 2,6,2
      IF (M(L).EQ.0 .AND. XM(L+1).GT.0.0) BADDAT = .TRUE.
 4710 CONTINUE
      DO 4720 L = 1,8
      I(L) = M(L)
 4720 CONTINUE
      IOLMF2 = MF(2)
      IOLMF4 = MF(4)
      IOLDM2 =  M(2)
      IOLDM4 =  M(4)
      IOLDM6 =  M(6)
      OLDXM3 = XM(3)
      N = 8
      IF (M1(1).EQ.0 .AND. M1(2).EQ.0) GO TO 9
      Z( 9) = -0.5*OLDXM3
      Z(10) =  0.5*OLDXM3
      DO 4730 L = 11,17
      I(L) = 0
 4730 CONTINUE
      N  = 17
      KM = 0
      KN = 0
      GO TO 9
C
 4740 IF (MF(1).NE.2 .AND. MF(1).NE.0) BADFOR = .TRUE.
      IF (MF(2).NE.2 .AND. MF(2).NE.0) BADFOR = .TRUE.
      IF (MF(3).NE.1 .AND. MF(3).NE.0) BADFOR = .TRUE.
      IF (MF(4).NE.1 .AND. MF(4).NE.2 .AND. MF(4).NE.0) BADFOR = .TRUE.
      IF (MF(5).NE.1 .AND. MF(5).NE.2 .AND. MF(5).NE.0) BADFOR = .TRUE.
      IF (MF(6).NE.2 .AND. MF(6).NE.0) BADFOR = .TRUE.
      IF (MF(1) .EQ. 0) XM(1) = -0.5*OLDXM3
      IF (MF(2) .EQ. 0) XM(2) =  0.5*OLDXM3
      IF (MF(3).EQ.1 .AND. M(3).LE.0) BADDAT = .TRUE.
      IF (MF(3).NE.0 .AND. (IOLMF2.EQ.0 .OR. IOLMF4.EQ.0))
     1    BADDAT = .TRUE.
      IF (MF(3).NE.0 .AND. (M(3).EQ.IOLDM2 .OR. M(3).EQ.IOLDM4))
     1    BADDAT = .TRUE.
      IF (MF(4).EQ.1 .AND. M(4).LT.0) BADDAT = .TRUE.
      IF (MF(5).EQ.1 .AND. M(5).LT.0) BADDAT = .TRUE.
      IF (IOLDM2.EQ.0 .AND. IOLDM4.EQ.0 .AND.
     1    IOLDM6.EQ.0 .AND. M(3).EQ.0) BADDAT = .TRUE.
      DO 4750 L = 1,4
      I(L) = M(L)
 4750 CONTINUE
      I(5) = 0
      IF (MF(4) .EQ. 1) I(5) = 1
C
C     I(6) IS THE INTEGRATION ORDER (SET TO 0)
C
C     NOTE
C     ----
C
C     THE INTEGRATION ORDER IS NOT USED IN THE PROGRAM,
C     BUT THIS WORD IS REQUIRED BECAUSE OF THE DESIGN
C     OF THE EST DATA FOR THE CQUAD4 ELEMENT.
C
      I(6) = 0
      I(7) = M(5)
      I(8) = 0
      IF (MF(5) .EQ. 1) I(8) = 1
      I(9) = M(6)
      N  = 9
      KM = 0
      KN = 0
      GO TO 9
C
      END

      SUBROUTINE FNDIAM (SND1,SND2,NDSTK,NDEG,LVL,LVLS1,LVLS2,IWK,
     1                   IDFLT,NDLST,JWK,IDIM)
C
C     THIS ROUTINE IS USED ONLY IN BANDIT MODULE
C
C     FNDIAM IS THE CONTROL PROCEDURE FOR FINDING THE PSEUDO-DIAMETER
C     OF NDSTK AS WELL AS THE LEVEL STRUCTURE FROM EACH END
C
C     SND1-     ON INPUT THIS IS THE NODE NUMBER OF THE FIRST
C               ATTEMPT AT FINDING A DIAMETER.  ON OUTPUT IT
C               CONTAINS THE ACTUAL NUMBER USED.
C     SND2-     ON OUTPUT CONTAINS OTHER END OF DIAMETER
C     LVLS1-    ARRAY CONTAINING LEVEL STRUCTURE WITH SND1 AS ROOT
C     LVLS2-    ARRAY CONTAINING LEVEL STRUCTURE WITH SND2 AS ROOT
C     IDFLT-    FLAG USED IN PICKING FINAL LEVEL STRUCTURE, SET =1
C               IF WIDTH OF LVLS1 .GE. WIDTH OF LVLS2, OTHERWISE =2
C     LVL,IWK-  WORKING STORAGE
C     JWK-      WORKING STORAGE, CURRENTLY SHARING SAME SPACE WITH RENUM
C     DIMENSION OF NDLST IS THE MAX NUMBER OF NODES IN LAST LEVEL.
C
      INTEGER          FLAG,     SND,      SND1,     SND2
      DIMENSION        NDEG(1),  LVL(1),   LVLS1(1), LVLS2(1), IWK(1),
     1                 JWK(1),   NDSTK(1), NDLST(IDIM)
      COMMON /BANDB /  DUM3B(3), NGRID
      COMMON /BANDG /  N,        IDPTH
C
      FLAG=0
      MTW2=N
      SND=SND1
C
C     ZERO LVL TO INDICATE ALL NODES ARE AVAILABLE TO TREE
C
   20 DO 25 I=1,N
   25 LVL(I)=0
      LVLN=1
C
C     DROP A TREE FROM SND
C
      CALL TREE (SND,NDSTK,LVL,IWK,NDEG,LVLWTH,LVLBOT,LVLN,MAXLW,MTW2,
     1           JWK)
      IF (FLAG.GE.1) GO TO 110
      FLAG=1
   70 IDPTH=LVLN-1
      MTW1=MAXLW
C
C     COPY LEVEL STRUCTURE INTO LVLS1
C
      DO 75 I=1,N
   75 LVLS1(I)=LVL(I)
      NDXN=1
      NDXL=0
      MTW2=N
C
C     SORT LAST LEVEL BY DEGREE  AND STORE IN NDLST
C
      CALL SORTDG (NDLST,IWK(LVLBOT),NDXL,LVLWTH,NDEG)
      IF (NDXL.LE.IDIM) GO TO 100
C
C     DIMENSION EXCEEDED  . . .  STOP JOB.
C
   80 NGRID=-3
      RETURN
C
  100 CONTINUE
      SND=NDLST(1)
      GO TO 20
  110 IF (IDPTH.GE.LVLN-1) GO TO 120
C
C     START AGAIN WITH NEW STARTING NODE
C
      SND1=SND
      GO TO 70
  120 IF (MAXLW.GE.MTW2) GO TO 130
      MTW2=MAXLW
      SND2=SND
C
C     STORE NARROWEST REVERSE LEVEL STRUCTURE IN LVLS2
C
      DO 125 I=1,N
  125 LVLS2(I)=LVL(I)
  130 IF (NDXN.EQ.NDXL) GO TO 140
C
C     TRY NEXT NODE IN NDLST
C
      NDXN=NDXN+1
      SND=NDLST(NDXN)
      GO TO 20
  140 IDFLT=1
      IF (MTW2.LE.MTW1) IDFLT=2
      IF (IDPTH .GT. IDIM) GO TO 80
      RETURN
      END

      FUNCTION APDF (F,IN,NS)
C
      REAL F(1)
C
C     IF (NS .EQ. 0) GO TO 10
C     APDF = FLOAT(IN-1)/FLOAT(NS)
C     RETURN
C  10 APDF = F(IN)
C     RETURN
C
      APDF = F(IN)
      IF (NS .NE. 0) APDF = FLOAT(IN-1)/FLOAT(NS)
      RETURN
      END

      SUBROUTINE OUTMSC (*,*)
C
C     COPY DATA BLOCK(S) TO FORTRAN UNIT, IN MSC/OUTPUT2 COMPATIBLE
C     RECORD FORMATS.
C
C     DMAP CALL -
C     OUTPUT2  IN1,IN2,IN3,IN4,IN5/ /V,N,P1/V,N,P2/V,N,P3/V,N,P4/V,N,P5/
C                                    V,N,P6 $
C
C     THIS ROUTINE IS CALLED ONLY BY OUTPT2
C     SEE OUTPT2 FOR PARAMETERS P1,P2,...,P6. (P6 = *MSC*)
C
C     IF P1 .NE. -9, ALTERNATE RETURN 1, OTHERWISE RETURN 2.
C
C     WRITTEN BY G.CHAN/UNISYS  3/93
C
      LOGICAL          DP
      INTEGER          P1,P2,P3,P4,P5,P6,ENDREC,ENDFIL,OUT,BUF1,D,
     1                 INP(13),MCB(7),NAME(2),NONE(2),SUB(2),TMP(2),
     2                 DX(3),HDR(7),HDRX(7),TAPCOD(2),BLOCK(20)
      REAL             XNS(1)
      DOUBLE PRECISION DXNS(1)
      CHARACTER        UFM*23,UWM*25,UIM*29,SFM*25,MO2*19
      COMMON /XMSSG /  UFM,UWM,UIM,SFM
      COMMON /BLANK /  P1,P2,P3(2),P4,P5,P6(2)
      COMMON /MACHIN/  MACH
      COMMON /SYSTEM/  IBUF,NOUT,IDUM4(6),NLPP,IDUM5(5),D(3)
      COMMON /TYPE  /  IDUM6(2),NWDS(4)
      COMMON /ZZZZZZ/  Z(1)
      EQUIVALENCE      (XNS(1),Z(1))
      EQUIVALENCE      (XNS(1),DXNS(1))
      DATA    HDR   /  4HNAST,4HRAN ,4HFORT,4H TAP,4HE ID,4H COD,4HE - /
      DATA    INP   /  4HUT1 ,4HUT2 ,4HUT3 ,4HINPT,4HINP1,4HINP2,4HINP3,
     1                 4HINP4,4HINP5,4HINP6,4HINP7,4HINP8,4HINP9       /
      DATA    MO2   /  '. MODULE OUTPUT2 - '      /
      DATA    NONE  ,  SUB   /4H (NO,4HNE) ,4HOUTP,4HUT2*              /
C
      WRITE  (NOUT,10) UIM
   10 FORMAT (A29,'. USER REQUESTED RECORDS IN MSC/OUTPUT2 COMPATIBLE',
     1       ' RECORDS')
      ENDFIL = 0
      ENDREC = 0
      LCOR   = KORSZ(Z(1))
      BUF1   = LCOR - IBUF + 1
      IF (BUF1 .LE. 0) CALL MESAGE (-8,LCOR,SUB)
      LEND   = BUF1 - 1
      OUT    = P2
      TAPCOD(1) = P3(1)
      TAPCOD(2) = P3(2)
      IF (P1 .EQ. -9) GO TO 210
      IF (P1 .EQ. -3) GO TO 300
      IF (P1 .LE. -2) GO TO 620
      IF (P1 .LE.  0) GO TO 40
C
C     SKIP FORWARD n DATA BLOCKS, P1 = n
C
      I = 1
   20 READ (OUT) KEY
      KEYX = 2
      IF (KEY .NE. KEYX) GO TO 720
      READ (OUT) TMP
      READ (OUT) KEY
      IF (KEY .GE. 0) GO TO 740
      ASSIGN 30 TO IRET
      NSKIP = 1
      GO TO 500
   30 I = I + 1
      IF (I .LE. P1) GO TO 20
C
   40 IF (P1 .NE. -1) GO TO 80
      REWIND OUT
      KEY = 3
      WRITE (OUT) KEY
      WRITE (OUT) D
      KEY = 7
      WRITE (OUT) KEY
      WRITE (OUT) HDR
      KEY = 2
      WRITE (OUT) KEY
      WRITE (OUT) P3
      ENDREC = ENDREC - 1
      WRITE (OUT) ENDREC
      WRITE (OUT) ENDFIL
      ENDREC = 0
      WRITE  (NOUT,50) UIM,P3
   50 FORMAT (A29,' FROM OUPUT2 MODULE.  THE LABEL IS ',2A4)
C
   80 DO 200 II = 1,5
      INPUT  = 100 + II
      MCB(1) = INPUT
      CALL RDTRL (MCB(1))
      IF (MCB(1) .LE. 0) GO TO 200
      CALL FNAME (INPUT,NAME)
      IF (NAME(1).EQ.NONE(1) .AND. NAME(2).EQ.NONE(2)) GO TO 200
      BLOCK(1) = INPUT
      NWD = NWDS(MCB(5))
      DP  = MCB(5).EQ.2 .OR. MCB(5).EQ.4
C
C     OPEN INPUT DATA BLOCK TO READ WITH REWIND
C
      CALL OPEN (*600,INPUT,Z(BUF1),0)
      KEY = 2
      WRITE (OUT) KEY
      WRITE (OUT) NAME
      ENDREC = ENDREC - 1
      WRITE (OUT) ENDREC
      KEY = 7
      WRITE (OUT) KEY
      WRITE (OUT) MCB
      ENDREC = ENDREC - 1
      WRITE (OUT) ENDREC
C
C     COPY CONTENTS OF INPUT DATA BLOCK ONTO FILE
C
   90 CALL RECTYP (INPUT,K)
      KEY = 1
      WRITE (OUT) KEY
      WRITE (OUT) K
      IF (K .EQ. 0) GO TO 130
C
C     STRING RECORD
C     BLOCK(2) = STRING TYPE, 1,2,3 OR 4
C     BLOCK(4) = FIRST (OR LAST) ROW POSITION ON A MATRIX COLUMN
C     BLOCK(5) = POINTER TO STRING, W.R.T. XNS ARRAY
C     BLOCK(6) = NO. OF TERMS IN STRING
C
      BLOCK(8) = -1
  100 CALL GETSTR (*170,BLOCK)
      KEY = BLOCK(6)*NWD
      WRITE (OUT) KEY
C
C     NEXT 3 LINES, ORIGINATED FROM MSC/OUTPUT2, DO NOT WORK FOR D.P.
C     DATA ON VAX, AND POSSIBLY SILICON-GRAPHICS. THEY ARE REPLACED BY
C     NEXT 8 LINES BELOW. BESIDE, TO WORK ON PROPER D.P. DATA BOUNDARY,
C     THE K1 IN THE FOLLOWING LINE SHOULD BE  K1 = (BLOCK(5)-1)*NWD+1
C
C     K1  = BLOCK(5)
C     K2  = K1 + KEY - 1
C     WRITE (OUT) BLOCK(4),(XNS(K),K=K1,K2)
C
      K1  = BLOCK(5)*NWD
      K2  = K1 + KEY -1
      IF (DP) GO TO 110
      WRITE (OUT) BLOCK(4),(XNS(K),K=K1,K2)
      GO TO 120
  110 K1  = K1/2
      K2  = K2/2
      WRITE (OUT) BLOCK(4),(DXNS(K),K=K1,K2)
C
  120 CALL ENDGET (BLOCK)
      GO TO 100
C
C     NON-STRING RECORD
C     MAKE SURE EACH RECORD IS NOT LONGER THAN P4 WORDS
C
  130 CALL READ (*180,*150,INPUT,Z(1),LEND,0,K1)
      DO 140 I = 1,LEND,P4
      KEY = LEND - I + 1
      IF (KEY .GE. P4) KEY = P4
      K2 = I + KEY - 1
      WRITE (OUT) KEY
      WRITE (OUT) (Z(K),K=I,K2)
  140 CONTINUE
      GO TO 130
  150 DO 160 I = 1,K1,P4
      KEY = K1 - I + 1
      IF (KEY .GE. P4) KEY = P4
      K2 = I + KEY - 1
      WRITE (OUT) KEY
      WRITE (OUT) (Z(K),K=I,K2)
  160 CONTINUE
C
  170 ENDREC = ENDREC - 1
      WRITE (OUT) ENDREC
      GO TO 90
C
C     CLOSE INPUT DATA BLOCK WITH REWIND
C
  180 CALL CLOSE (INPUT,1)
      WRITE (OUT) ENDFIL
      ENDREC = 0
      WRITE  (NOUT,190) UIM,NAME,OUT,INP(P2-10),MCB
  190 FORMAT (A29,' 4144. DATA BLOCK ',2A4,' WRITTEN ON FORTRAN UNIT ',
     1       I3,2H (,A4,1H), /5X,'TRAILER =',6I7,I11)
C
  200 CONTINUE
C
C     CLOSE FORTRAN TAPE WITHOUT END-OF-FILE AND WITHOUT REWIND
C
      RETURN 1
C
C     FINAL CALL TO OUTPUT2, P1 = -9
C
  210 WRITE (OUT) ENDFIL
      RETURN 2
C
C     OBTAIN LIST OF DATA BLOCKS ON FORTRAN TAPE, P1 = -3
C
  300 REWIND OUT
      READ (OUT) KEY
      KEYX = 3
      IF (KEY .NE. KEYX) GO TO 720
      READ (OUT) DX
      READ (OUT) KEY
      KEYX = 7
      IF (KEY .NE. KEYX) GO TO 720
      READ (OUT) HDRX
      DO 310 K = 1,7
      IF (HDRX(K) .NE. HDR(K)) GO TO 640
  310 CONTINUE
      READ (OUT) KEY
      KEYX = 2
      IF (KEY .NE. KEYX) GO TO 720
      READ (OUT) TMP
      IF (TMP(1).NE.P3(1) .OR. TMP(2).NE.P3(2)) GO TO 660
  320 ASSIGN 330 TO IRET
      NSKIP = 1
      GO TO 500
  330 K = 0
  340 CALL PAGE1
      WRITE  (NOUT,350) INP(P2-10),OUT
  350 FORMAT (//42X,'CONTENTS OF ',A4,', FORTRAN UNIT',I3, /46X,
     1       'FILE',18X,'NAME',/)
  360 READ (OUT) KEY
      IF (KEY) 680,400,370
  370 READ (OUT) TMP
      ASSIGN 380 TO IRET
      NSKIP = 1
      GO TO 500
  380 K = K + 1
      WRITE  (NOUT,390) K,TMP
  390 FORMAT (45X,I5,18X,2A4)
      IF (MOD(K,NLPP)) 360,340,360
  400 ASSIGN 80 TO IRET
      NSKIP = K + 1
      IF (NSKIP .GT. 0) REWIND OUT
      GO TO 500
C
C     SKIP NSKIP FILES ON FORTRAN TAPE
C
  500 IF (NSKIP .EQ. 0) GO TO 540
      DO 530 J = 1,NSKIP
  510 READ (OUT) KEYX
      IF (KEYX) 510,530,520
  520 IF (KEYX .GT. LCOR) GO TO 700
      READ (OUT) (Z(L),L=1,KEYX)
      GO TO 510
  530 CONTINUE
  540 GO TO IRET, (30,80,330,380)
C
C     ERRORS
C
  600 CALL FNAME (INPUT,TMP)
      WRITE  (NOUT,610) SFM,MO2,TMP
  610 FORMAT (A25,' 4116',A19,'UNABLE TO OPEN INPUT DATA BLOCK ',2A4)
      GO TO  800
  620 WRITE  (NOUT,630) UFM,MO2,P1
  630 FORMAT (A23,' 4120',A19,'ILLEGAL FIRST PARAMETER ',I3)
      GO TO  800
  640 WRITE  (NOUT,650) UFM,MO2,HDRX
  650 FORMAT (A23,' 4130',A19,'ILLEGAL TAPE HEADER CODE ',7A4)
      GO TO  800
  660 WRITE  (NOUT,670) UWM,TMP,P3
  670 FORMAT (A25,' 4141. FORTRAN TAPE ID CODE - ',2A4,
     1       ' DOES NOT MATCH OUTPUT2 THIRD PARAMETER NAME - ',2A4)
      GO TO  320
  680 WRITE  (NOUT,690) SFM,MO2
  690 FORMAT (A25,' 4415',A19,'SHORT RECORD ENCOUNTERED')
      GO TO  800
  700 WRITE  (NOUT,710) UFM,LCOR,KEY
  710 FORMAT (A23,' 2187. INSUFFICIENT WORKING CORE TO HOLD FORTRAN ',
     1       'LOGICAL RECORD.', /5X,'LENGHT OF WORKING CORE =',I11,
     2       '.   LENGTH OF FORTRAN LOGICAL RECORD =',I11)
      GO TO  800
  720 WRITE  (NOUT,730) SFM,KEY,KEYX
  730 FORMAT (A25,' 2190. ILLEGAL VLUE FOR KEY =',I10,1H.,5X,
     1       'EXPECTED VALUE =',I10)
      GO TO  800
  740 WRITE  (NOUT,750) SFM,KEY
  750 FORMAT (A25,' 2190. ILLEGAL VALUE FOR KEY =',I10)
  800 CALL MESAGE (-61,0,SUB)
      RETURN 1
C
      END

      SUBROUTINE SOFO
C
C     MODULE USED TO TRANSFER NASTRAN DATA BLOCKS TO THE SOF FILE FOR
C     PURPOSES OF SAVING THE DATA FOR SUBSEQUENT RUNS OR SUBSEQUENT
C     EXECUTION STEPS.  THE CALLING SEQUENCE TO THE MODULE IS
C
C     SOFO     A,B,C,D,E//V,N,DRY/C,N,NAME/C,N,IA/C,N,IB/C,N,IC/
C                         C,N,ID/C,N,IE $
C
      INTEGER         SYSBUF,DRY,FILE,XXXX
      DIMENSION       FILE(5),MODNAM(2),MCB(7)
      CHARACTER       UFM*23,UWM*25
      COMMON /XMSSG / UFM,UWM
      COMMON /BLANK / DRY,NAME(2),ITEMS(2,5)
      COMMON /ZZZZZZ/ IZ(1)
      COMMON /SYSTEM/ SYSBUF,NOUT
      DATA    FILE  / 101,102,103,104,105/
      DATA    MODNAM/ 4HSOFO,4H    /
      DATA    IBLNK , XXXX / 4H    ,4HXXXX/
C
      DO 5 I = 1,5
      IF (ITEMS(1,I).EQ.XXXX .OR. ITEMS(1,I).EQ.0) ITEMS(1,I) = IBLNK
    5 CONTINUE
C
      IF (DRY .LT. 0) RETURN
      NZ = KORSZ(IZ)
      IF (3*SYSBUF .GT. NZ) CALL MESAGE (-8,0,MODNAM(1))
      IB1 = NZ  - SYSBUF + 1
      IB2 = IB1 - SYSBUF - 1
      IB3 = IB2 - SYSBUF
      CALL SOFOPN (IZ(IB1),IZ(IB2),IZ(IB3))
C
C     COPY MATRICES FROM NASTRAN DATA BLOCKS TO SOF.
C
      DO 50 I = 1,5
      IF (ITEMS(1,I) .EQ. IBLNK) GO TO 50
      MCB(1) = FILE(I)
      CALL RDTRL (MCB)
      IF (MCB(1) .LT. 0) GO TO 50
      CALL MTRXO (FILE(I),NAME(1),ITEMS(1,I),0,ITEST)
      GO TO (10,50,50,20,30,50), ITEST
   10 WRITE (NOUT,1010) UWM,ITEMS(1,I),NAME(1),NAME(2)
      DRY = -2
      GO TO 50
   20 WRITE (NOUT,1020) UWM,NAME(1),NAME(2)
      DRY = -2
      GO TO 60
   30 WRITE (NOUT,1030) UWM,ITEMS(1,I)
      DRY = -2
   50 CONTINUE
   60 CALL SOFCLS
      RETURN
C
C     ERROR MESSAGES.
C
 1010 FORMAT (A25,' 6211, MODULE SOFO - ITEM ',A4,' OF SUBSTRUCTURE ',
     1        2A4,' HAS ALREADY BEEN WRITTEN.')
 1020 FORMAT (A25,' 6212, MODULE SOFO - THE SUBSTRUCTURE ',2A4,
     1       ' DOES NOT EXIST.')
 1030 FORMAT (A25,' 6213, MODULE SOFO - ',A4,' IS AN ILLEGAL ITEM NAME')
      END

      SUBROUTINE T3GEMD (IERR,EGPDT,IORDER,GB,GS,LX,LY,EDGLEN,SHRFLX,
     1                   AIC,JOG,JOK,K11,K22)
C
C     DOUBLE PRECISION ROUTINE TO SET UP THE REQUIRED SHEAR-RELATED
C     TRANSFORMATION TO RELIEVE THE TRIA3 GEOMETRY BIAS IN BENDING.
C
C     INPUT :
C           EGPDT  - BGPDT DATA IN ELEMENT COORD. SYSTEM
C           IORDER - ARRAY OF ORDER INDICATORS FOR REARRANGED DATA
C           GB     - ARRAY OF BENDING MATERIAL PROPERTIES
C           GS     - ARRAY OF SHEAR   MATERIAL PROPERTIES
C           LX     - DIMENSION OF ELEMENT ALONG X-AXIS
C           LY     - DIMENSION OF ELEMENT ALONG Y-AXIS
C           EDGLEN - EDGE LENGTHS
C           SHRFLX - LOGICAL INDICATING THE PRESENCE OF SHEAR FLEX
C     OUTPUT:
C           IERR   - ERROR FLAG
C           AIC    - TRANSFORMATION TO RELIEVE GEOMETRY BIAS
C           JOG    - SHEAR   STIFFNESS FACTOR
C           JOK    - BENDING STIFFNESS FACTOR
C           K11    - BENDING STIFFNESS FACTOR
C           K22    - BENDING STIFFNESS FACTOR
C
C
C     [C]    - TRANSFORMATION TO YIELD GAMMAT ALONG THE ELEMENT SIDES.
C
C     [AA]   - TRANSFORMATION FROM GAMMA0 (AT THE ELEMENT CENTER) TO
C              GAMMAT (ALONG THE ELEMENT SIDES).
C
C                  -1
C     [AIC]  - [AA]  [C]
C
C
      LOGICAL          SHRFLX
      INTEGER          IORDER(3),INDEX(3,3)
      DOUBLE PRECISION EGPDT(4,3),GB(9),GS(4),EDGLEN(3),LX,LY,AIC(18),
     1                 JOG,JOK,K11,K22,XX(3),YY(3),AA(9),H1,H2,BDUM(3),
     2                 DETERM,COSA,SINA,COSB,SINB,COSC,SINC
C
C
      IERR = 0
      DO 20 I = 1,3
      DO 10 J = 1,3
      JO = IORDER(J)
      IF (I .NE. JO) GO TO 10
      XX(I) = EGPDT(2,J)
      YY(I) = EGPDT(3,J)
   10 CONTINUE
   20 CONTINUE
C
      COSA = ((XX(2)-XX(1))/EDGLEN(1))
      SINA = ((YY(2)-YY(1))/EDGLEN(1))
      COSB = ((XX(3)-XX(2))/EDGLEN(2))
      SINB = ((YY(3)-YY(2))/EDGLEN(2))
      COSC = ((XX(1)-XX(3))/EDGLEN(3))
      SINC = ((YY(1)-YY(3))/EDGLEN(3))
C
      AA(1) = SINA
      AA(2) = COSA
      AA(3) = 1.0D0
      AA(4) = SINB
      AA(5) = COSB
      AA(6) = 1.0D0
      AA(7) = SINC
      AA(8) = COSC
      AA(9) = 1.0D0
C
      CALL INVERD (3,AA,3,BDUM,0,DETERM,ISING,INDEX)
      IF (ISING .NE. 1) GO TO 30
C
      AIC( 1) = AA(1)*SINA
      AIC( 2) = AA(1)*COSA
      AIC( 3) = AA(2)*SINB
      AIC( 4) = AA(2)*COSB
      AIC( 5) = AA(3)*SINC
      AIC( 6) = AA(3)*COSC
      AIC( 7) = AA(4)*SINA
      AIC( 8) = AA(4)*COSA
      AIC( 9) = AA(5)*SINB
      AIC(10) = AA(5)*COSB
      AIC(11) = AA(6)*SINC
      AIC(12) = AA(6)*COSC
      AIC(13) = AA(7)*SINA
      AIC(14) = AA(7)*COSA
      AIC(15) = AA(8)*SINB
      AIC(16) = AA(8)*COSB
      AIC(17) = AA(9)*SINC
      AIC(18) = AA(9)*COSC
C
C     CALCULATE THE BENDING STIFFNESS FACTORS
C
      H1  = LY
      H2  = LX
      K11 = 1.0D0/(H1*H1)*GB(5)
      K22 = 1.0D0/(H2*H2)*GB(1)
C
      JOK = K11*K22
      IF (JOK .NE. 0.0D0) JOK = 1.0D0/JOK
      JOG = 0.0D0
      IF (SHRFLX) JOG = GS(1)*GS(4) - GS(2)*GS(3)
      IF (JOG .NE. 0.0D0) JOG = 1.0D0/JOG
      GO TO 40
C
   30 IERR = 1
   40 RETURN
      END

      SUBROUTINE PARTN (IRP,ICP,CORE)
C
      EXTERNAL         RSHIFT,ANDF
      INTEGER          ANDF,TWO1,CORE,SYSBUF,RSHIFT
      DIMENSION        ICP(1),IRP(1)
      DIMENSION        CORE(1),IAS(7,4),HEAD(2),BLOCK1(40),NAME(2)
      COMMON /PARMEG/  NAMEA,NCOLA,NROWA,IFORMA,ITYPA,IA(2),
     1                 IA11(7),IA21(7),IA12(7),IA22(7),LCARE,RULE
      COMMON /SYSTEM/  SYSBUF
      COMMON /TWO   /  TWO1(32)
      COMMON /ZNTPKX/  A11(4),II,IEOL,IEOR
      EQUIVALENCE     (IAS(1,1),IA11(1))
      DATA    ILN   /  20 /, NAME / 4HPART,4HN   /
C
C     ZERO 6 AND 7 OF OUTPUT BLOCKS
C
      IOTP  = ITYPA
      IOPEN = 0
      DO 40 I = 1,4
      DO 10 J = 6,7
   10 IAS(J,I) = 0
      IF (IAS(1,I)) 20,40,20
   20 IF (IAS(5,I) .NE. ITYPA) IOTP = 4
      IOPEN = IOPEN + 1
      DO 30 J = 2,5
      IF (IAS(J,I)) 340,340,30
   30 CONTINUE
      IAS(2,I) = 0
   40 CONTINUE
      LCORE  = LCARE
      IBUF   = LCORE- SYSBUF + 1
      IBUFCP = IBUF - NROWA
      IBUFRP = IBUFCP - (NCOLA+31)/32
      IF (IBUFRP) 300,300,50
   50 LCORE = IBUFRP - 1
      INORP = 0
      CALL RULER (RULE,ICP,ZCPCT,OCPCT,CORE(IBUFCP),NROWA,CORE(IBUF),1)
      IF (IRP(1).EQ.ICP(1) .AND. IRP(1).NE.0 .AND. NROWA.EQ.NCOLA)
     1    GO TO 60
      CALL RULER (RULE,IRP,ZRPCT,ORPCT,CORE(IBUFRP),NCOLA,CORE(IBUF),0)
      GO TO 70
   60 INORP = 1
      LCORE = IBUFCP - 1
C
C     OPEN OUTPUT MATRICES
C
   70 IF (IOPEN*SYSBUF .GT. LCORE) GO TO 300
      DO 100 I = 1,4
      IF (IAS(1,I)) 80,100,80
   80 LCORE = LCORE - SYSBUF
      CALL OPEN  (*90,IAS(1,I),CORE(LCORE+1),1)
      CALL FNAME (IAS(1,I),HEAD)
      CALL WRITE (IAS(1,I),HEAD,2,1)
      GO TO 100
   90 IAS(1,I) = 0
  100 CONTINUE
C
C     OPEN INPUT MATRIX
C
      CALL GOPEN (NAMEA,CORE(IBUF),0)
C
C     LOOP FOR EACH COLUMN
C
      KM = 0
      DO 270 LOOP = 1,NCOLA
      IF (INORP .NE. 0) GO TO 110
C
C     COLUMN PARTITION A SEQ. OF ZEROS AND ONES
C
      KM = KM + 1
      IF (KM .GT. 32) KM = 1
      L = IBUFRP + (LOOP-1)/32
      ITEMP = ANDF(CORE(L),TWO1(KM))
      IF (KM .EQ. 1) ITEMP = RSHIFT(ANDF(CORE(L),TWO1(KM)),1)
      IF (ITEMP) 120,130,120
  110 L  = IBUFCP + LOOP - 1
      IF (CORE(L)) 130,120,120
  120 L1 = 2
      GO TO 140
  130 L1 = 0
C
C     BEGIN BLDPK ON TWO SUBS
C
  140 J = 0
      DO 160 L = 1,2
      K = L1 + L
      M = ILN*(L-1) + 1
      IF (IAS(1,K)) 150,160,150
  150 CALL BLDPK (IOTP,IAS(5,K),IAS(1,K),BLOCK1(M),1)
      J = J + 1
  160 CONTINUE
      IF (J) 170,260,170
C
C     SEARCH COLUMN FOR NON-ZERO ELEMENTS
C
  170 CALL INTPK (*230,NAMEA,0,IOTP,0)
C
C     LOOP FOR ROWS WITHIN COLUMN
C
  180 IF (IEOL) 230,190,230
  190 CALL ZNTPKI
C
C     COMPUTE ROW POSITION AND OUTPUT MATRIX
C
      L = IBUFCP + II - 1
      IPOS = IABS(CORE(L))
      IF (CORE(L)) 200,210,210
  200 M1 = L1 + 1
      M  = 1
      GO TO 220
  210 M1 = L1 + 2
      M  = ILN+ 1
  220 IF (IAS(1,M1) .EQ. 0) GO TO 180
      CALL BLDPKI (A11(1),IPOS,IAS(1,M1),BLOCK1(M))
      GO TO 180
  230 DO 250 L = 1,2
      K = L + L1
      M = ILN*(L-1) + 1
      IF (IAS(1,K)) 240,250,240
  240 CALL BLDPKN (IAS(1,K),BLOCK1(M),IAS(1,K))
  250 CONTINUE
      GO TO 270
  260 CALL SKPREC (NAMEA,1)
  270 CONTINUE
C
C     ALL DONE - CLOSE OPEN MATRICES
C
      CALL CLOSE (NAMEA,1)
      DO 290 I = 1,4
      IF (IAS(1,I)) 280,290,280
  280 CALL CLOSE (IAS(1,I),1)
  290 CONTINUE
      RETURN
C
  300 IPM1 =-8
  310 CALL MESAGE (IPM1,IPM2,NAME)
  340 IPM1 =-7
      GO TO 310
      END

      SUBROUTINE MMA212 ( ZI, ZD )
C
C     MMA212 PERFORMS THE MATRIX OPERATION USING METHOD 21 IN
C       REAL DOUBLE PRECISION
C
C       (+/-)A(T & NT) * B (+/-)C = D
C     
C     MMA212 USES METHOD 21 WHICH IS AS FOLLOWS:
C       1.  THIS IS FOR "A" NON-TRANSPOSED AND TRANSPOSED
C       2.  UNPACK AS MANY COLUMNS OF "B" INTO MEMORY AS POSSIBLE
C           LEAVING SPACE FOR A COLUMN OF "D" FOR EVERY COLUMN "B" READ.
C       3.  INITIALIZE EACH COLUMN OF "D" WITH THE DATA FROM "C".
C       4.  USE GETSTR TO READ MATRIX "A", (SEE SUBROUTINES MMARC1,2,3,4)
C       5.  USE UNPACK TO READ MATRIX "C".
C
C     MEMORY FOR EACH COLUMN OF "B" IS AS FOLLOWS:
C         Z(1)   = FIRST NON-ZERO ROW NUMBER FOR COLUMN
C         Z(2)   = LAST NON-ZERO ROW NUMBER FOR COLUMN
C         Z(3-N) = VALUES OF NON-ZERO ROWS
C
      INTEGER           ZI(2)      ,T
      INTEGER           TYPEI      ,TYPEP    ,TYPEU ,SIGNAB, SIGNC
      INTEGER           RD         ,RDREW    ,WRT   ,WRTREW, CLSREW,CLS
      INTEGER           FILEA      ,FILEB ,FILEC , FILED
      DOUBLE PRECISION  ZD(2)
      INCLUDE           'MMACOM.COM'
      COMMON / NAMES  / RD         ,RDREW    ,WRT   ,WRTREW, CLSREW,CLS
      COMMON / TYPE   / IPRC(2)    ,NWORDS(4),IRC(4)
      COMMON / MPYADX / FILEA(7)   ,FILEB(7) ,FILEC(7)    
     1,                 FILED(7)   ,NZ       ,T     ,SIGNAB,SIGNC ,PREC1 
     2,                 SCRTCH     ,TIME
      COMMON / SYSTEM / KSYSTM(152)
      COMMON / UNPAKX / TYPEU      ,IUROW1   ,IUROWN, INCRU
      COMMON / PACKX  / TYPEI      ,TYPEP    ,IPROW1, IPROWN , INCRP
      EQUIVALENCE       (KSYSTM( 1),SYSBUF)  , (KSYSTM( 2),NOUT  ) 
      EQUIVALENCE       (FILEA(2)  ,NAC   )  , (FILEA(3)  ,NAR   )
     1,                 (FILEA(4)  ,NAFORM)  , (FILEA(5)  ,NATYPE)
     2,                 (FILEA(6)  ,NANZWD)  , (FILEA(7)  ,NADENS)
      EQUIVALENCE       (FILEB(2)  ,NBC   )  , (FILEB(3)  ,NBR   )
     1,                 (FILEB(4)  ,NBFORM)  , (FILEB(5)  ,NBTYPE)
     2,                 (FILEB(6)  ,NBNZWD)  , (FILEB(7)  ,NBDENS)
      EQUIVALENCE       (FILEC(2)  ,NCC   )  , (FILEC(3)  ,NCR   )
     1,                 (FILEC(4)  ,NCFORM)  , (FILEC(5)  ,NCTYPE)
     2,                 (FILEC(6)  ,NCNZWD)  , (FILEC(7)  ,NCDENS)
      EQUIVALENCE       (FILED(2)  ,NDC   )  , (FILED(3)  ,NDR   )
     1,                 (FILED(4)  ,NDFORM)  , (FILED(5)  ,NDTYPE)
     2,                 (FILED(6)  ,NDNZWD)  , (FILED(7)  ,NDDENS)
C
C
C   OPEN CORE ALLOCATION AS FOLLOWS:
C     Z( 1        ) = ARRAY FOR ONE COLUMN OF "A" MATRIX
C     Z( IDX      ) = ARRAY FOR MULTIPLE COLUMNS OF "D" MATRIX
C     Z( IBX      ) = ARRAY FOR MULTIPLE COLUMNS OF "B" MATRIX
C        THROUGH
C     Z( LASMEM   )
C     Z( IBUF4    ) = BUFFER FOR "D" FILE
C     Z( IBUF3    ) = BUFFER FOR "C" FILE
C     Z( IBUF2    ) = BUFFER FOR "B" FILE 
C     Z( IBUF1    ) = BUFFER FOR "A" FILE
C     Z( NZ       ) = END OF OPEN CORE THAT IS AVAILABLE
C
C
C PROCESS ALL OF THE COLUMNS OF "A" 
C      
      DO 60000 II = 1, NAC
C
C READ A COLUMN FROM "A" MATRIX
C
      CALL MMARC2 ( ZI, ZD )
C
C CHECK FOR NULL COLUMN ON "A"
C
      IF ( ZI( 1 ) .EQ. 0 ) GO TO 60000
      IF ( T .NE. 0 ) GO TO 5000
C      
C "A" NON-TRANSPOSE CASE    ( A*B + C )      
C
C DOUBLE PRECISION
2000  CONTINUE
      DO 2500 I = 1, NCOLPP
      INDX   = 1
      IROWA1 = ZI( INDX )
      INDXB  = IBX + 2*I + ( I-1 )*NWDDNBR
      IROWB1 = ZI( INDXB-2 )
      IROWBN = ZI( INDXB-1 )
      IF ( II .LT. IROWB1 .OR. II .GT. IROWBN ) GO TO 2500
      INDXB  = ( ( INDXB+1 ) / 2 ) + II - IROWB1 
      IF ( ZD( INDXB ) .EQ. 0.0D0 ) GO TO 2500
      INDXD  = IDX + ( I-1 )*NWDDNDR
      INDXD  = ( ( INDXD+1 ) / 2 ) - 1
2100  CONTINUE
      IROWS  = ZI( INDX+1 )
      IROWAN = IROWA1 + IROWS - 1
      INDXA  = ( (INDX+1)/2 ) + 1 - IROWA1
      DO 2400 K = IROWA1, IROWAN
      ZD( INDXD+K ) = ZD( INDXD+K ) +  ZD( INDXA+K ) * ZD( INDXB )
2400  CONTINUE
      INDX = INDX + 2 + IROWS*NWDD
      IF ( INDX .GE. LASIND ) GO TO 2500
      IROWA1 = ZI( INDX )
      GO TO 2100
2500  CONTINUE
      GO TO 60000
C
C  TRANSPOSE CASE ( A(T) * B + C )
C
5000  CONTINUE      
C DOUBLE PRECISION
20000 CONTINUE
      DO 25000 I = 1, NCOLPP
      INDXB  = IBX + 2*I + ( I-1 )*NWDDNBR
      IROWB1 = ZI( INDXB-2 )
      IF ( IROWB1 .EQ. 0 ) GO TO 25000
      IROWBN = ZI( INDXB-1 )
      INDX   = 1
      IROWA1 = ZI( INDX )
      INDXB  = ( ( INDXB+1 ) / 2 ) - IROWB1 
      INDXD  = IDX + ( I-1 )*NWDDNDR
      INDXD  = ( ( INDXD+1 ) / 2 ) - 1 + II
21000 CONTINUE
      IROWS  = ZI( INDX+1 )
      IROWAN = IROWA1 + IROWS - 1
      IROW1  = MAX0( IROWA1, IROWB1 )
      IROWN  = MIN0( IROWAN, IROWBN )
      IF ( IROWN .LT. IROW1 ) GO TO 24100
      INDXA  = ( (INDX+1)/2 ) + 1 - IROWA1
      DO 24000 K = IROW1, IROWN
      ZD( INDXD ) = ZD( INDXD ) +  ZD( INDXA+K ) * ZD( INDXB+K )
24000 CONTINUE
24100 CONTINUE
      INDX   = INDX + 2 + IROWS*NWDD
      IF ( INDX .GE. LASIND ) GO TO 25000
      IROWA1 = ZI( INDX )
      GO TO 21000
25000 CONTINUE
C END OF PROCESSING THIS COLUMN OF "A" FOR THIS PASS
60000 CONTINUE
C  NOW SAVE COLUMNS COMPLETED 
      DO 65000 K = 1, NCOLPP
      INDX = IDX2 + ( K-1 ) * NDR
      CALL PACK ( ZD( INDX+1 ), FILED, FILED )
65000 CONTINUE
      RETURN
      END

      SUBROUTINE MAKMCB (MCB,IFILE,IROW,IF,IT)
C
      INTEGER MCB(7)
C
      MCB(1) = IFILE
      MCB(2) = 0
      MCB(3) = IROW
      MCB(4) = IF
      MCB(5) = IT
      MCB(6) = 0
      MCB(7) = 0
C
      RETURN
C
      END

      FUNCTION KRSHFT (IWORD,N)
C
C     CHARACTER FUNCTION KRSHFT AND KLSHFT PERFORM LEFT AND RIGHT
C     SHIFTS, BY N CHARACTERS (BYTES).
C     EMPTY BYTES ARE ZERO FILLED.
C
C     NORMALLY, KRSHFT AND KLSHFT WORK ALMOST LIKE RSHIFT AND LSHFIT
C     RESPECTIVELY, EXCEPT THEY MOVE DATA BY BYTE COUNT, NOT BY BITS.
C     HOWEVER, IF THE MACHINE STORES THE BCD WORD DATA IN REVERSE ORDER
C     (SUCH AS VAX AND SILICON GRAPHICS), KRSHFT IS EQUIVALENCED TO
C     LSHFIT, AND KLSFHT TO RSHIFT.
C
      EXTERNAL        LSHIFT,   RSHIFT
      INTEGER         IWORD(1), RSHIFT
      COMMON /MACHIN/ MAC(3),   LQRO
      COMMON /SYSTEM/ DUMMY(38),NBPC
C
      IF (MOD(LQRO,10) .EQ. 1) GO TO 10
      KRSHFT = RSHIFT(IWORD(1),N*NBPC)
      RETURN
   10 KRSHFT = LSHIFT(IWORD(1),N*NBPC)
      RETURN
C
      ENTRY KLSHFT (IWORD,N)
C     ======================
C
      IF (MOD(LQRO,10) .EQ. 1) GO TO 20
      KLSHFT = LSHIFT(IWORD(1),N*NBPC)
      RETURN
   20 KLSHFT = RSHIFT(IWORD(1),N*NBPC)
      RETURN
      END

      SUBROUTINE XCEI
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        LSHIFT,RSHIFT,ANDF,ORF
      DIMENSION       DCPARM(2),NXCEI(2),IDIC(1),NXPTDC(2),CONTRL(4)
      COMMON /XVPS  / VPS(1)
CWKBR COMMON /XCEITB/ CEITBL(2)
      COMMON /XCEITB/ CEITBL(42)
      COMMON /OSCENT/ BUF(7)
      COMMON /ZZZZZZ/ DATABF(1)
      COMMON /SYSTEM/ BFSZ,ISYSOU,DUM21(21),ICFIAT,DUM57(57),ICPFLG
      COMMON /XFIAT / IFIAT(3)
      COMMON /XDPL  / IDPL(3)
      EQUIVALENCE     (DATABF(1),IDIC(1))
      DATA    NXPTDC/ 4HXPTD,4HIC  /
      DATA    NXCEI / 4HXCEI,4H    /
      DATA    NOSCAR/ 4HXOSC/
      DATA    POOL  / 4HPOOL/
      DATA    CONTRL/ 4HJUMP,4HREPT,4HCOND,4HEXIT/
      DATA    NBLANK/ 4H    /
      DATA    MASK1 / 65535 /, NOFLGS / 536870911/
C
C     MASK1  = 000000177777 =     65536 = 2**16-1
C     NOFLGS = 003777777777 = 536870911 = 2**29-1
C     MASK   = 017777600000
C     LPFLG  = 010000000000
C
      MASK  = LSHIFT(MASK1,16)
      LPFLG = LSHIFT(1,30)
      CALL OPEN (*310,POOL,DATABF,2)
C
C     DETERMINE WHICH TYPE OF CONTROL REQUEST
C
      DO 10 J = 1,4
      IF (BUF(4) .EQ. CONTRL(J)) GO TO (150,110,250,270), J
   10 CONTINUE
      CALL MESAGE (-61,0,0)
C
C     PROCESS  JUMP CONTROL REQUEST
C
   30 IF (NEWSQ .GT. BUF(2)) GO TO 60
C
C     MUST BACKSPACE WITHIN OSCAR FILE
C     DUE TO GINO TECHNIQUES IT IS USUALLY FASTER TO REWIND AND FORWARD
C     REC RATHER THAN BACKREC
C
      CALL REWIND (POOL)
C
C     POSITION POOL TAPE AT BEGINNING OF OSCAR FILE
C
      JJ = IDPL(3)*3 + 1
      DO 40 J = 4,JJ,3
      IF (IDPL(J) .EQ. NOSCAR) GO TO 50
   40 CONTINUE
      CALL MESAGE (-61,0,0)
   50 CALL SKPFIL (POOL,ANDF(IDPL(J+2),MASK1)-1)
      NEWSQ = NEWSQ - 1
      GO TO 70
C
C     MUST FORWARD REC WITHIN OSCAR FILE
C
   60 NEWSQ = NEWSQ - BUF(2) - 1
      IF (NEWSQ .EQ. 0) GO TO 260
   70 DO 80 I = 1,NEWSQ
   80 CALL FWDREC (*290,POOL)
C
C     CHECK FOR REPEAT INSTRUCTION
C
      IF (BUF(4) .EQ. CONTRL(2)) GO TO 260
C
C     JUMP REQUEST - CHECK FOR JUMP OUT OF LOOPS
C
      NEWSQ = RSHIFT(ANDF(BUF(7),MASK),16)
      KK = 3
      CEITBX = 0
  100 CEITBX = 4 + CEITBX
      IF (CEITBX .GT. CEITBL(2)) GO TO 260
      IF (ANDF(CEITBL(CEITBX-1),LPFLG).EQ.0 .OR. CEITBL(CEITBX+1).EQ.0)
     1    GO TO 100
      NBEGN = RSHIFT(ANDF(CEITBL(CEITBX-1),NOFLGS),16)
      NEND  = ANDF(MASK1,CEITBL(CEITBX-1))
      IF (NEWSQ.LT.NBEGN .OR. NEWSQ.GT.NEND) GO TO 130
      GO TO 100
C
C     PROCESS  REPEAT CONTROL REQUEST
C
  110 KK = 1
  120 CEITBX = ANDF(BUF(7),MASK1)
      IF (CEITBL(CEITBX)) 121,122,122
C
C      NEGATIVE ENTRY IMPLIES VARIABLE REPT INSTRUCTION
C      FIND VALUE IN VPS AND UPDATE CEITBL
C
  121 IVPSPT = RSHIFT(ANDF(CEITBL(CEITBX),NOFLGS),16)
      LOOP   = ANDF(CEITBL(CEITBX),MASK1)
      IVPSPT = VPS(IVPSPT+3)
      CEITBL(CEITBX) = ORF(LSHIFT(IVPSPT,16),LOOP)
  122 CONTINUE
C
C     CHECK FOR END OF LOOP
C
      MXLOOP = RSHIFT(ANDF(CEITBL(CEITBX),NOFLGS),16)
      LOOP   = ANDF(CEITBL(CEITBX),MASK1)
      IF (MXLOOP .GT. LOOP) GO TO 140
C
C     REPEATS FINISHED - ZERO LOOP COUNT AND TURN OFF LOOP FLAG
C
  130 CEITBL(CEITBX  ) = ANDF(CEITBL(CEITBX  ),MASK  )
      CEITBL(CEITBX-1) = ANDF(CEITBL(CEITBX-1),NOFLGS)
      GO TO (260,280,100), KK
C
C     ANOTHER  TIME THRU - INCREMENT COUNTER BY 1
C
  140 CEITBL(CEITBX) = CEITBL(CEITBX) + 1
C
C     SET LOOP FLAG IN WORD 1 OF CEITBL ENTRY
C
      CEITBL(CEITBX-1) = ORF(CEITBL(CEITBX-1),LPFLG)
      GO TO (150,260), KK
  150 NEWSQ = RSHIFT(ANDF(BUF(7),MASK),16)
C
C     MAKE SURE WE ARE LOOPING
C
      IF (NEWSQ .GE. BUF(2)) GO TO 30
C
C     IF CHECKPOINTING - BACKUP PROBLEM TAPE DICTIONARY TO BEGINNING OF
C     LOOP
C
      IF (ICPFLG .EQ. 0) GO TO 210
C
C     READ IN CHECKPOINT DICTIONARY
C
      ITOP = 2*BFSZ + 1
      LDIC = KORSZ(IDIC(ITOP))
      CALL OPEN (*310,NXPTDC,DATABF(BFSZ+1),0)
      CALL READ (*300,*160,NXPTDC,DCPARM,2,1,NRECSZ)
  160 IF (NXPTDC(1) .NE. DCPARM(1)) CALL MESAGE (-61,0,0)
      CALL READ (*300,*170,NXPTDC,DCPARM,2,1,NRECSZ)
  170 CALL READ (*300,*180,NXPTDC,IDIC(ITOP),LDIC,1,NRECSZ)
      GO TO 310
  180 IBOT = NRECSZ + ITOP - 3
      CALL CLOSE (NXPTDC,1)
      J = IBOT
      DO 190 I = ITOP,IBOT,3
      IF (IDIC(I) .NE. NBLANK) GO TO 190
      IF (ANDF(IDIC(I+2),MASK1) .LT. NEWSQ) GO TO 190
      J = I - 3
      GO TO 200
  190 CONTINUE
  200 IBOT = J
C
C     WRITE IDIC ON NEW PROBLEM TAPE
C
      CALL OPEN  (*310,NXPTDC,DATABF(BFSZ+1),1)
      CALL WRITE (NXPTDC,NXPTDC,2,1)
      CALL WRITE (NXPTDC,DCPARM,2,1)
      CALL WRITE (NXPTDC,IDIC(ITOP),IBOT+3-ITOP,1)
      CALL CLOSE (NXPTDC,1)
C
C     SCAN FIAT FOR FILES REGENERATED NEXT TIME THRU LOOP.
C
  210 J  = IFIAT(3)*ICFIAT - 2
      JJ = IDPL(3) *3 + 1
      DO 240 I = 4,J,ICFIAT
      IF (RSHIFT(ANDF(IFIAT(I),NOFLGS),16) .GE. BUF(2)) GO TO 240
      IF (RSHIFT(ANDF(IFIAT(I),NOFLGS),16) .EQ.      0) GO TO 240
      IF (ANDF(RSHIFT(IFIAT(I),30),1)      .NE.      0) GO TO 240
C
C     LTU IS LESS THAN LOOP END - CLEAR FIAT TRAILER
C
      IFIAT(I+ 3) = 0
      IFIAT(I+ 4) = 0
      IFIAT(I+ 5) = 0
      IF (ICFIAT .EQ. 8) GO TO 212
      IFIAT(I+ 8) = 0
      IFIAT(I+ 9) = 0
      IFIAT(I+10) = 0
C
C     IF EQUIV, REMOVE ENTIRE ENTRY FROM FIAT
C     REMOVE ENTIRE ENTRY FROM FIAT TO FORCE REALLOCATION
C
  212 IHOLD = ANDF(MASK1,IFIAT(I))
      IFIAT(I  ) = 0
      IFIAT(I+1) = 0
      IFIAT(I+2) = 0
      IF (I .LT. IFIAT(1)*ICFIAT) IFIAT(I) = IHOLD
C
C     ZERO FILE NAME IF IN DPL
C
      DO 220 II = 4,JJ,3
      IF (IDPL(II).EQ.IFIAT(I+1) .AND. IDPL(II+1).EQ.IFIAT(I+2))
     1    GO TO 230
  220 CONTINUE
      GO TO 240
  230 IDPL(II  ) = 0
      IDPL(II+1) = 0
  240 CONTINUE
      GO TO 30
C
C     PROCESS  CONDITIONAL CONTROL REQUEST
C
  250 CEITBX = ANDF(BUF(7),MASK1)
      IF (VPS(CEITBX) .LT. 0) GO TO 150
  260 CALL CLOSE (POOL,2)
      RETURN
C
C     PROCESS EXIT  CONTROL REQUESTS
C
  270 KK = 2
      IF (BUF(7) .NE. CONTRL(4)) GO TO 120
  280 CALL PEXIT
  290 CALL MESAGE (-2,POOL  ,NXCEI)
  300 CALL MESAGE (-2,NXPTDC,NXCEI)
  310 CALL MESAGE (-61,0,0)
      RETURN
      END

      SUBROUTINE KTRM6D
C
C     STIFFNESS SUBROUTINE FOR LINEAR STRAIN MEMBRANE ELEMENT
C     DOUBLE PRECISION VERSION
C
C     EST ENTRIES
C
C     EST( 1) = ELEMENT ID                              INTEGER
C     EST( 2) = SCALAR INDEX NUMBER FOR GRID POINT 1    INTEGER
C     EST( 3) = SCALAR INDEX NUMBER FOR GRID POINT 2    INTEGER
C     EST( 4) = SCALAR INDEX NUMBER FOR GRID POINT 3    INTEGER
C     EST( 5) = SCALAR INDEX NUMBER FOR GRID POINT 4    INTEGER
C     EST( 6) = SCALAR INDEX NUMBER FOR GRID POINT 5    INTEGER
C     EST( 7) = SCALAR INDEX NUMBER FOR GRID POINT 6    INTEGER
C     EST( 8) = THETA                                   REAL
C     EST( 9) = MATERIAL IDENTIFICATION NUMBER          INTEGER
C     EST(10) = THICKNESS T1 AT GRID POINT 1            REAL
C     EST(11) = THICKNESS T3 AT GRID POINT 3            REAL
C     EST(12) = THICKNESS T5 AT GRID POINT 5            REAL
C     EST(13) = NON-STRUCTURAL MASS                     REAL
C
C     X1,Y1,Z1 FOR ALL SIX POINTS ARE IN NASTRAN BASIC SYSTEM
C
C     EST(14) = COORDINATE SYSTEM ID FOR GRID POINT 1   INTEGER
C     EST(15) = COORDINATE X1                           REAL
C     EST(16) = COORDINATE Y1                           REAL
C     EST(17) = COORDINATE Z1                           REAL
C     EST(18) = COORDINATE SYSTEM ID FOR GRID POINT 2   INTEGER
C     EST(19) = COORDINATE X2                           REAL
C     EST(20) = COORDINATE Y2                           REAL
C     EST(21) = COORDINATE Z2                           REAL
C     EST(22) = COORDINATE SYSTEM ID FOR GRID POINT 3   INTEGER
C     EST(23) = COORDINATE X3                           REAL
C     EST(24) = COORDINATE Y3                           REAL
C     EST(25) = COORDINATE Z3                           REAL
C     EST(26) = COORDINATE SYSTEM ID FOR GRID POINT 4   INTEGER
C     EST(27) = COORDINATE X4                           REAL
C     EST(28) = COORDINATE Y4                           REAL
C     EST(29) = COORDINATE Z4                           REAL
C     EST(30) = COORDINATE SYSTEM ID FOR GRID POINT 5   INTEGER
C     EST(31) = COORDINATE X5                           REAL
C     EST(32) = COORDINATE Y5                           REAL
C     EST(33) = COORDINATE Z5                           REAL
C     EST(34) = COORDINATE SYSTEM ID FOR GRID POINT 6   INTEGER
C     EST(35) = COORDINATE X6                           REAL
C     EST(36) = COORDINATE Y6                           REAL
C     EST(37) = COORDINATE Z6                           REAL
C     EST(38) TO EST (43) = ELEMENT TEMPERATURES AT SIX GRID POINTS
C
      LOGICAL         IMASS,NOGO,UNIMEM
      INTEGER         XU(12),YU(12),XV(12),YV(12),ELTYPE,ELID,ESTID,
     1                DICT(11),SIL(6),SIL1,SIL2,SAVE(6),RK(3),SK(3),
     2                IND(6,3),NAME(2),NL(6),PI,QI,PJ,QJ,PIMJ,PINJ,
     3                PIPJ,PIQJ,QIMJ,QINJ,QIPJ,QIQJ,ICS(6),IEST(45)
      REAL            NSM,CC(3),IVECT(3),JVECT(3),KVECT(3),XC(6),YC(6),
     1                ZC(6),F(6,6)
      DOUBLE PRECISION GK11(6,6),GK12(6,6),GK22(6,6),KTRMG(324),
     1                GKT(12,12),KRT(9),KRT1(9),KTRM(12,12),Q(6,6),
     2                E(6),TRAND(9),BALOTR(9),QINV(36),GKTRM(12,12),
     3                ST,ST1,KTR1(3,3),G11,G12,G13,G22,G23,G33,
     4                KSUB(2,2),KSUBT(3,2),KTR(3,3),RHO,DETERM
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /EMGEST/ EST (45)
      COMMON /EMGDIC/ ELTYPE,LDICT,NLOCS,ELID,ESTID
      COMMON /EMGPRM/ IXTRA,IZR,NZR,DUMY(12),KMBGG(3),IPREC,NOGO
      COMMON /SYSTEM/ KSYSTM(63)
      COMMON /BLANK / NOK,NOM
      COMMON /MATIN / MATID,MATFLG,ELTEMP,PLA34,SINTH,COSTH
      COMMON /MATOUT/ EM(6),RHOY,ALF(3),TREF,GSUBE,SIGTY,SIGCY,SIGSY,
     1                RJ11,RJ12,RJ22
      EQUIVALENCE     (A,DISTA),(B,DISTB),(C,DISTC),(CC(1),C1),
     1                (CC(2),C2),(CC(3),C3),(KRT(1),KTR(1,1)),
     2                (KRT1(1),KTR1(1,1)),(EST(1),IEST(1)),
     3                (KSYSTM(2),IOUTPT),(GKT(1,1),GKTRM(1,1))
      DATA    XU    / 0,1,0,2,1,0,6*0/ ,  YU / 0,0,1,0,1,2,6*0/
      DATA    XV    / 6*0,0,1,0,2,1,0/ ,  YV / 6*0,0,0,1,0,1,2/
      DATA    RK    / 0,1,0          / ,  SK / 0,0,1          /
      DATA    DEGRA / 0.0174532925   / ,  BLANK / 4H          /
      DATA    NAME  / 4HTRIM, 4H6    /
C
C     COMPONENT CODE,ICODE,IS  000111  AND HAS A VALUE OF 7
C
      ICODE   = 7
      NDOF    = 18
      NSQ     = NDOF**2
      DICT(1) = ESTID
      DICT(2) = 1
      DICT(3) = NDOF
      DICT(4) = ICODE
      DICT(5) = GSUBE
      IPASS   = 1
      IMASS   =.FALSE.
      IF (NOM .GT. 0) IMASS = .TRUE.
C
C     ALLOCATE EST VALUES TO RESPECTIVE  LOCAL  VARIABLES
C
      IDELE = IEST(1)
      DO 109 I = 1,6
      NL(I)  = IEST(I+1)
  109 CONTINUE
      THETAM = EST (8)
      MATID1 = IEST(9)
      TMEM1  = EST(10)
      TMEM3  = EST(11)
      TMEM5  = EST(12)
C
C     IF  TMEM3 OR TMEM5 IS 0.0 OR BLANK,IT WILL BE SET EQUAL TO TMEM1
C
      IF (TMEM3.EQ.0.0 .OR. TMEM3.EQ.BLANK) TMEM3 = TMEM1
      IF (TMEM5.EQ.0.0 .OR. TMEM5.EQ.BLANK) TMEM5 = TMEM1
      NSM = EST(13)
      J   = 0
      DO 120 I = 14,34,4
      J   = J + 1
      ICS(J) = IEST(I )
      XC (J) = EST(I+1)
      YC (J) = EST(I+2)
      ZC (J) = EST(I+3)
  120 CONTINUE
      ELTEMP = (EST(38)+EST(39)+EST(40)+EST(41)+EST(42)+EST(43))/6.0
      THETA1 = THETAM*DEGRA
      SINTH  = SIN(THETA1)
      COSTH  = COS(THETA1)
      IF (ABS(SINTH) .LE. 1.0E-06) SINTH = 0.0
C
C     START ELEMENT CALCULATIONS FOR STIFFNESS MATRIX
C
C     EVALUATE  MATERIAL PROPERTIES
C
      MATFLG = 2
      MATID  = MATID1
      CALL MAT (IDELE)
C
C     CALCULATIONS FOR THE  TRIANGLE
C
      CALL TRIF (XC,YC,ZC,IVECT,JVECT,KVECT,A,B,C,IEST(1),NAME)
C
C     FILL THE E-MATRIX
C
      E(1) = IVECT(1)
      E(2) = JVECT(1)
      E(3) = IVECT(2)
      E(4) = JVECT(2)
      E(5) = IVECT(3)
      E(6) = JVECT(3)
C
C     COMPUTE THE F FUCTION, AND CONSTANTS C1, C2, AND C3 IN THE LINEAR
C     EQUS. FOR THICKNESS VARIATION
C
      CALL AF (F,6,A,B,C,C1,C2,C3,TMEM1,TMEM3,TMEM5,0)
      AREA = F(1,1)
      VOL  = C1*F(1,1) + C2*F(2,1) + C3*F(1,2)
      UNIMEM = .FALSE.
      IF (ABS(C2).LE.1.0E-06 .AND. ABS(C3).LE.1.0E-06) UNIMEM = .TRUE.
C
C     CALCULATIONS FOR  Q MATRIX AND ITS INVERSE
C
      DO 200 I = 1,36
      Q(I,1) = 0.0D0
  200 CONTINUE
      DO 210 I = 1,6
      Q(I,1) = 1.0D0
      Q(I,2) = XC(I)
      Q(I,3) = YC(I)
      Q(I,4) = XC(I)*XC(I)
      Q(I,5) = XC(I)*YC(I)
      Q(I,6) = YC(I)*YC(I)
  210 CONTINUE
C
C     FIND INVERSE OF Q MATRIX
C
C     NO NEED TO COMPUTE DETERMINANT SINCE IT IS NOT USED SUBSEQUENTLY.
C
      ISING = -1
      CALL INVERD (6,Q,6,QINV(1),0,DETERM,ISING,IND)
C
C     ISING EQUAL TO 2 IMPLIES THAT Q MATRIX IS SINGULAR
C
      IF (ISING .EQ. 2) GO TO 904
C
C     GKTRM IS STIFFNESS MATRIX IN GENERALIZED CO-ORDINATES
C     KTRM  IS STIFFNESS MATRIX IN ELEMENT CO-ORDINATES
C     START EXECUTION FOR STIFFNESS MATRIX CALCULATIONS
C
      G11 = EM(1)
      G12 = EM(2)
      G13 = EM(3)
      G22 = EM(4)
      G23 = EM(5)
      G33 = EM(6)
C
C     FORMULATION OF THE STIFFNESS MATRIX (FROM PROG. MANUAL,
C     PAGE 8.24-7)
C
      DO 240 I = 1,12
      MI   = XU(I)
      NI   = YU(I)
      PI   = XV(I)
      QI   = YV(I)
      DO 235 J = I,12
      MJ   = XU(J)
      NJ   = YU(J)
      PJ   = XV(J)
      QJ   = YV(J)
      MIMJ = MI*MJ
      MINJ = MI*NJ
      MIPJ = MI*PJ
      MIQJ = MI*QJ
      NIMJ = NI*MJ
      NINJ = NI*NJ
      NIPJ = NI*PJ
      NIQJ = NI*QJ
      PIMJ = PI*MJ
      PINJ = PI*NJ
      PIPJ = PI*PJ
      PIQJ = PI*QJ
      QIMJ = QI*MJ
      QINJ = QI*NJ
      QIPJ = QI*PJ
      QIQJ = QI*QJ
      ST1  = 0.0D0
      DO 225 K=1,3
      KR   = RK(K)
      KS   = SK(K)
      ST   = 0.0D0
      IF (MIMJ .GT. 0) ST=ST +G11*MIMJ *F(MI+MJ+KR-1,NI+NJ+KS+1)
      IF (QIQJ .GT. 0) ST=ST +G22*QIQJ *F(PI+PJ+KR+1,QI+QJ+KS-1)
      IF (NINJ .GT. 0) ST=ST +G33*NINJ *F(MI+MJ+KR+1,NI+NJ+KS-1)
      IF (PIPJ .GT. 0) ST=ST +G33*PIPJ *F(PI+PJ+KR-1,QI+QJ+KS+1)
      IF (PIMJ .GT. 0) ST=ST +G13*PIMJ *F(PI+MJ+KR-1,QI+NJ+KS+1)
      IF (MIPJ .GT. 0) ST=ST +G13*MIPJ *F(MI+PJ+KR-1,NI+QJ+KS+1)
      IF (NIQJ .GT. 0) ST=ST +G23*NIQJ *F(MI+PJ+KR+1,NI+QJ+KS-1)
      IF (QINJ .GT. 0) ST=ST +G23*QINJ *F(PI+MJ+KR+1,QI+NJ+KS-1)
      IF (NIPJ+MIQJ.GT.0) ST=ST+(G33*NIPJ+G12*MIQJ)*F(MI+PJ+KR,NI+QJ+KS)
      IF (PINJ+QIMJ.GT.0) ST=ST+(G33*PINJ+G12*QIMJ)*F(PI+MJ+KR,QI+NJ+KS)
      IF (NIMJ+MINJ.GT.0) ST=ST+ G13*(NIMJ+MINJ) *F(MI+MJ+KR,NI+NJ+KS)
      IF (PIQJ+QIPJ.GT.0) ST=ST+ G23*(PIQJ+QIPJ) *F(PI+PJ+KR,QI+QJ+KS)
      ST1 = ST1 + ST*CC(K)
      IF (UNIMEM) GO TO 230
  225 CONTINUE
  230 GKT(I,J) = ST1
      GKT(J,I) = ST1
  235 CONTINUE
  240 CONTINUE
C
      IF (IPASS .EQ. 1) GO TO 260
  241 RHO = RHOY*1.0D0
      DO 255 I = 1,12
      DO 250 J = I,12
      MIMJ = XU(I) + XU(J)
      NINJ = YU(I) + YU(J)
      GKT(I,J) = NSM*F(MIMJ+1,NINJ+1)
      DO 245 K = 1,3
      KR = RK(K)
      KS = SK(K)
      GKT(I,J) = GKT(I,J) + RHO*CC(K)*F(MIMJ+KR+1,NINJ+KS+1)
  245 CONTINUE
      GKT(J,I) = GKT(I,J)
  250 CONTINUE
  255 CONTINUE
C
  260 DO 265 I = 1,6
      DO 265 J = 1,6
      GK11(I,J) = GKTRM(J,I)
      GK12(I,J) = GKTRM(J+6,I)
      GK22(I,J) = GKTRM(J+6,I+6)
  265 CONTINUE
      CALL  GMMATD (Q,6,6,0,GK11,6,6,0,QINV)
      CALL  GMMATD (QINV,6,6,0,Q,6,6,1,GK11)
      CALL  GMMATD (Q,6,6,0,GK12,6,6,0,QINV)
      CALL  GMMATD (QINV,6,6,0,Q,6,6,1,GK12)
      CALL  GMMATD (Q,6,6,0,GK22,6,6,0,QINV)
      CALL  GMMATD (QINV,6,6,0,Q,6,6,1,GK22)
      DO 270 I = 1,6
      DO 270 J = 1,6
      GKTRM(I  ,J  ) = GK11(I,J)
      GKTRM(I  ,J+6) = GK12(I,J)
      GKTRM(I+6,J  ) = GK12(J,I)
      GKTRM(I+6,J+6) = GK22(I,J)
  270 CONTINUE
C
C     REORDER THE STIFFNESS MATRIX SO THAT THE DISPLACEMENTS OF A GRID
C     POINT ARE ARRANGED CONSECUTIVELY
C
      DO 278 K = 1,6
      DO 277 I = 1,2
      K1 = 6*(I-1) + K
      I1 = 2*(K-1) + I
      DO 276 J = 1,12
      KTRM(I1,J) = GKTRM(K1,J)
  276 CONTINUE
  277 CONTINUE
  278 CONTINUE
      DO 288 K = 1,6
      DO 287 I = 1,2
      K1 = 6*(I-1) + K
      I1 = 2*(K-1) + I
      DO 286 J = 1,12
      GKTRM(J,I1) = KTRM(J,K1)
  286 CONTINUE
  287 CONTINUE
  288 CONTINUE
C
  290 DO 301 I = 1,324
      KTRMG(I) = 0.0D0
  301 CONTINUE
      IF (IPASS .LE. 2) GO TO 305
C
C     LUMPED MASS MATRIX, IN THREE DOFS, NOT TWO
C     (SINCE LUMPED MASS IS AN INVARIANT, TRANSFORMATION IS NOT NEEDED)
C
      RHO   = RHOY*1.0D0
      AMASS =(RHO*VOL+NSM*AREA)/6.
      DO 302 I = 1,324,19
      KTRMG(I) = AMASS
  302 CONTINUE
      IPASS = 2
      GO TO 400
C
C     TRANSFORM THE ELEMENT STIFFNESS MATRIX FROM ELEMENT CO-ORDINATES
C     TO BASIC CO-ORDINATES
C
  305 DO 310 I = 1,6
      SAVE(I) = NL(I)
  310 CONTINUE
      DO 314 I = 1,6
      SIL(I) = I
      ISIL = NL(I)
      DO 313 J = 1,6
      IF (ISIL .LE. NL(J)) GO TO 312
      SIL(I) = J
      ISIL = NL(J)
  312 CONTINUE
  313 CONTINUE
      ISI = SIL(I)
      NL(ISI) = 1000000
  314 CONTINUE
      DO 316 I = 1,6
      NL(I) = SAVE(I)
  316 CONTINUE
      DO 380 I = 1,6
      SIL1 = SIL(I)
      DO 375 J = I,6
      SIL2 = SIL(J)
      DO 320 II = 1,9
      BALOTR(II) = 0.0D0
  320 CONTINUE
      DO 324 K = 1,2
      K1 = (SIL1-1)*2 + K
      DO 323 L = 1,2
      L1 = (SIL2-1)*2 + L
      KSUB(K,L) = GKTRM(K1,L1)
  323 CONTINUE
  324 CONTINUE
      CALL GMMATD (E,3,2,0,KSUB,2,2,0,KSUBT)
      CALL GMMATD (KSUBT,3,2,0,E,3,2,1,KTR )
      DO 325 K = 1,3
      DO 325 L = 1,3
      K1 = (K-1)*3 + L
      L1 = (L-1)*3 + K
      KRT1(L1) = KRT(K1)
  325 CONTINUE
C
C     TRANSFORM THE KTR1 FROM BASIC TO GLOBAL CO-ORDINATES
C
      IF (NL(SIL1).EQ.0 .OR. ICS(SIL1).EQ.0) GO TO 340
      I1 = 4*SIL1 + 10
      CALL TRANSD (IEST(I1),TRAND)
      CALL GMMATD (TRAND(1),3,3,1,KTR1,3,3,0,KTR)
      DO 330 K = 1,9
      KRT1(K) = KRT(K)
  330 CONTINUE
  340 CONTINUE
      IF (NL(SIL2).EQ.0 .OR. ICS(SIL2).EQ.0) GO TO 365
      IF (J .EQ. I) GO TO 355
      J1 = 4*SIL2 + 10
      CALL TRANSD (IEST(J1),TRAND)
  355 CONTINUE
      CALL GMMATD (KTR1,3,3,0,TRAND,3,3,0,KTR)
      DO 360 K = 1,9
      KRT1(K) = KRT(K)
  360 CONTINUE
  365 CONTINUE
      DO 370 II = 1,3
      DO 370 JJ = 1,3
      I1 = (I-1)*3 + II
      J1 = (J-1)*3 + JJ
      I1J1 = (I1-1)*18 + J1
      J1I1 = (J1-1)*18 + I1
      KTRMG(J1I1) = KTR1(JJ,II)
      KTRMG(I1J1) = KTR1(JJ,II)
  370 CONTINUE
  375 CONTINUE
  380 CONTINUE
C
C     CALL INSERTION ROUTINE
C
  400 CALL EMGOUT (KTRMG(1),KTRMG(1),324,1,DICT,IPASS,IPREC)
      IF (.NOT.IMASS .OR. IPASS.GE.2) RETURN
C
C     GO TO 290 TO COMPUTE LUMPED MASS MATRIX
C     GO TO 241 TO COMPUTE CONSIST.MASS MATRIX (THIS PATH DOES NOT WORK)
C
      IPASS = 3
      CALL SSWTCH (46,J)
      IF (J .EQ. 1) IPASS = 2
      GO TO (905,241,290), IPASS
C
C     ERRORS
C
  904 CONTINUE
      NOGO =.TRUE.
      WRITE  (IOUTPT,2407) UFM,IEST(1)
 2407 FORMAT (A23,' 2407, MATRIX RELATING GENERALIZED PARAMETERS AND ',
     1       'GRID POINT DISPLACEMENTS IS SINGULAR.', //26X,
     2       'CHECK COORDINATES OF ELEMENT  TRIM6 WITH ID',I9,1H.)
  905 RETURN
      END

      SUBROUTINE KFLUD3
C
C     THIS ROUTINE GENERATES THE PSUEDO STIFFNESS MATRIX TERMS
C     FOR THE TRIANGULAR FLUID ELEMENT
C
C     THE ECPT DATA IS THE FOLLOWING
C
C         FIELD         SYMBOL
C           1             ID
C           2             SIL1
C           3             SIL2
C           4             SIL3
C           5             RHO
C           6             BULK
C           7             N
C           8             CSF
C           9             R1
C           10            Z1
C           11            -
C           12            CSF
C           13            R2
C           14            Z2
C           15            -
C           16            CSF
C           17            R3
C           18            Z3
C           19            -
C           20            -
C
      LOGICAL          NOGO
      INTEGER          OUT      ,NP(3)    ,NECPT(100)
      DOUBLE PRECISION CONSTD   ,DPI      ,
     1                 R        ,R1       ,R2       ,R3       ,
     2                 Z1       ,Z2       ,Z3       ,DETH     ,
     3                 H        ,RA       ,RB       ,ZA       ,
     4                 ZB       ,DR       ,DZ       ,BETA     ,
     5                 BLOG     ,DZR      ,DZR2     ,BET2     ,
     6                 R12      ,R22      ,G00      ,G10      ,
     7                 G20      ,G01      ,G11      ,G02      ,
     8                 RN       ,PIRO     ,PRN2     ,KQ       ,
     9                 KVEC     ,KG
      CHARACTER        UFM*23
      COMMON /XMSSG /  UFM
      COMMON /CONDAD/  CONSTD(5)
      COMMON /SYSTEM/  SYSBUF   ,OUT      ,NOGO
      COMMON /SMA1IO/  DUM1(10) ,IFKGG
      COMMON /SMA1CL/  IOPT4    ,K4GGSW   ,NPVT
      COMMON /SMA1ET/  ECPT(100)
      COMMON /SMA1DP/  R        ,R1       ,R2       ,R3       ,
     1                 Z1       ,Z2       ,Z3       ,DETH     ,
     2                 H(9)     ,RA       ,RB       ,ZA       ,
     3                 ZB       ,DR       ,DZ       ,BETA     ,
     4                 BLOG     ,DZR      ,DZR2     ,BET2     ,
     5                 R12      ,R22      ,G00      ,G10      ,
     6                 G20      ,G01      ,G11      ,G02      ,
     7                 RN       ,PIRO     ,PRN2     ,KQ(9)    ,
     8                 KVEC(3)  ,KG(3)    ,IRET     ,IPT      ,
     9                 JC       ,IR
      EQUIVALENCE      (CONSTD(1),DPI)    ,(ECPT(1),NECPT(1))
C
C     SELECT POINTS FOR COUNTERCLOCKWISE ORDER
C
      NP(1) = NECPT(2)
      NP(2) = NECPT(3)
      NP(3) = NECPT(4)
      R1    = ECPT( 9)
      Z1    = ECPT(10)
      R2    = ECPT(13)
      Z2    = ECPT(14)
      R3    = ECPT(17)
      Z3    = ECPT(18)
      R     = (R2-R1)*(Z3-Z1) - (R3-R1)*(Z2-Z1)
      IF (R) 10,2000,20
   10 NP(2) = NP(3)
      NP(3) = NECPT(3)
      R2    = ECPT(17)
      R3    = ECPT(13)
      Z2    = ECPT(18)
      Z3    = ECPT(14)
   20 IF (R1.LE.0.0D0 .OR. R2.LE.0.0D0 .OR. R3.LE.0.0D0) GO TO 1000
      DETH  = DABS(R)
      H(1)  = (R2*Z3-R3*Z2)/DETH
      H(4)  = (R3*Z1-R1*Z3)/DETH
      H(7)  = (R1*Z2-R2*Z1)/DETH
      H(2)  = (Z2-Z3)/DETH
      H(5)  = (Z3-Z1)/DETH
      H(8)  = (Z1-Z2)/DETH
      H(3)  = (R3-R2)/DETH
      H(6)  = (R1-R3)/DETH
      H(9)  = (R2-R1)/DETH
C
C     THE INTEGRAL PARAMETERS ARE THE SUM DUE TO SIDES 1-2,2-3,3-1.
C
      G00   = 0.0
      G01   = 0.0
      G02   = 0.0
      G10   = 0.0
      G11   = 0.0
      G20   = 0.0
      IRET  = 1
      RA    = R1
      RB    = R2
      ZA    = Z1
      ZB    = Z2
      GO TO 500
  100 IRET  = 2
      RA    = R2
      RB    = R3
      ZA    = Z2
      ZB    = Z3
      GO TO 500
  110 IRET  = 3
      RA    = R3
      RB    = R1
      ZA    = Z3
      ZB    = Z1
C
C     THE INTEGRAL PARAMETERS ARE CALCULATED BELOW
C
  500 DR    = RB - RA
      DZ    = ZB - ZA
      IF (DR**2/DETH .LE. 1.0D-6) GO TO 140
      BETA  = ZA - RA*DZ/DR
      BET2  = BETA**2
      BLOG  = BETA*DLOG(RA/RB)
      DZR   = DZ/DR
      DZR2  = DZR**2
      R12   = (RA**2-RB**2)/2.0D0
      R22   = (RA**3-RB**3)/3.0D0
      G00   = G00 + BLOG - DZ
      G10   = G10 - BETA*DR  + R12*DZR
      G20   = G20 + BETA*R12 + DZR*R22
      G01   = G01 + BLOG*BETA/2.0D0 - BETA*DZ + DZR2*R12/2.0D0
      G11   = G11 - BET2*DR/2.0D0 + BETA*DZR*R12 + DZR2*R22/2.0D0
      G02   = G02 + BET2*BLOG/3.0D0 - BET2*DZ + BETA*DZR2*R12 +
     1        DZR*DZR2*R22/3.0D0
  140 CONTINUE
      GO TO (100,110,120), IRET
  120 CONTINUE
C
C     FORM THE PSUEDO STIFFNESS MATRIX USING THE PARAMETERS
C
      RN    = NECPT(7)
      IF (ECPT(5) .LE. 0.0) RETURN
      PIRO  = DPI/DBLE(ECPT(5))
      IF(NECPT(7) .EQ. 0) PIRO=PIRO*2.0D0
      PRN2  = PIRO*RN**2
      KQ(1) = PRN2*G00
      KQ(2) = PRN2*G10
      KQ(3) = PRN2*G01
      KQ(4) = KQ(2)
      KQ(5) = (PIRO + PRN2)*G20
      KQ(6) = PRN2*G11
      KQ(7) = KQ(3)
      KQ(8) = KQ(6)
      KQ(9) = PIRO*G20 + PRN2*G02
      DO 200 I = 1,3
      IPT   = I - 1
      IF (NPVT .EQ. NP(I)) GO TO 210
  200 CONTINUE
      RETURN
C
  210 IPT   = 3*IPT + 1
      CALL GMMATD (H(IPT),1,3,0,KQ,3,3,0,KVEC)
      CALL GMMATD (KVEC,1,3,0,H(1),3,3,1,KG)
      JC    = NPVT
      DO 220 I = 1,3
      IR    = NP(I)
      CALL SMA1B (KG(I),IR,JC,IFKGG,0.0D0)
  220 CONTINUE
 2000 RETURN
C
 1000 IR    = NECPT(1)/1000
      WRITE  (OUT,5001) UFM,IR
 5001 FORMAT (A23,' 5001, NEG. OR ZERO RADIUS DETECTED FOR CFLUID3 OR',
     1       ' CFLUID4 ELEMENT',I12)
      NOGO = .TRUE.
      RETURN
      END

      SUBROUTINE DIST (IDEG,HIST,MEDIAN,MODD)
C
C     COMPUTE THE DISTRIBUTION OF NODAL DEGREES WITH MEDIAN AND MODE
C     THIS ROUTINE IS USED ONLY IN BANDIT MODULE
C
      INTEGER         IDEG(1),  HIST(1)
      COMMON /SYSTEM/ ISYS,     NOUT
      COMMON /BANDS / NN,       MM
C
C     IDEG(I) = DEGREE OF NODE I
C     HIST(I) = NUMBER OF NODES OF DEGREE I
C
C     COMPUTE HISTOGRAM.
C
      MM1 = MM + 1
      DO 10 I = 1,MM1
   10 HIST(I) = 0
      DO 20 I = 1,NN
      K = IDEG(I) + 1
   20 HIST(K) = HIST(K) + 1
C
C     COMPUTE MODE (MODD).
C
      MODD = 0
      MAX  = 0
      DO 30 I = 1,MM1
      K = HIST(I)
      IF (K .LE. MAX) GO TO 30
      MAX  = K
      MODD = I - 1
   30 CONTINUE
C
C     COMPUTE CUMULATIVE DISTRIBUTION, AND MEDIAN.
C
      DO 40 I = 2,MM1
   40 HIST(I) = HIST(I) + HIST(I-1)
      NN2 = NN/2
      DO 50 I = 1,MM1
      IF (HIST(I) .GT. NN2) GO TO 60
   50 CONTINUE
   60 MEDIAN = I - 1
      RETURN
      END

        SUBROUTINE RECTYP ( FILE, ITYPE )
      INCLUDE 'DSIOF.COM'
      INCLUDE 'XNSTRN.COM'
        INTEGER           FILE
        NAME = FILE
        CALL DSGEFL
 5      ID   = IAND( IBASE( INDCLR ), MASKQ1 )
        IF ( ID .EQ. IDSSB ) GO TO 10
        IF ( ID .EQ. IDSEB ) GO TO 20
        ITYPE = 0
        GO TO 7000
10      ITYPE = 1
        GO TO 7000
20      CALL DSRDNB
        CALL DSSDCB
        GO TO 5
7000    RETURN
        END

      INTEGER FUNCTION ISFT (BF,SFT,J)
C
      EXTERNAL LSHIFT,RSHIFT
      INTEGER  BF,SFT,RSHIFT
C
      IF (J .EQ. 4) GO TO 10
      ISFT = RSHIFT(BF,SFT)
      RETURN
   10 ISFT = LSHIFT(BF,SFT)
      RETURN
      END

        SUBROUTINE DSSDCB
      INCLUDE 'DSIOF.COM'
      INCLUDE 'XNSTRN.COM'
        ICLR  =  INDCLR - INDBAS + 1
        FCB( 3, IFILEX )  = ICLR
        FCB( 4, IFILEX )  = NBLOCK
        IBASE( INDBAS+1 ) = INDCBP - INDBAS + 1
        IBASE( INDBAS+2 ) = ICLR
        LASNAM = NAME
C        WRITE(6,40646)IFILEX,NBLOCK,ICLR,INDBAS,INDCLR
40646   FORMAT(' DSSDCB,IFILEX,NBLOCK,ICLR,BAS,CLR=',I3,I5,6I7)
        RETURN
        END

      SUBROUTINE ANGTRS (THETA,K,TRANS)
C     &    ENTRY ANGTRD
C
C     ROUTINE TO CALCULATE AND OUTPUT THE INPLANE ROTATION
C     TRANSFORMATION IN 3-D USING THE ANGLE OF ROTATION.
C
C     IF K=1, TRANS OR TRAND WILL BE TRANSPOSED AND THEN RETURNED.
C
C     SINGLE PRECISION -
C
      REAL               TRANS(9)
      DOUBLE PRECISION   TRAND(9), THETAD
C
      DO 10 I = 1,9
   10 TRANS(I) = 0.0
C
      TRANS(1) =  COS(THETA)
      TRANS(2) =  SIN(THETA)
      TRANS(4) = -TRANS(2)
      TRANS(5) =  TRANS(1)
      TRANS(9) =  1.0
C
      IF (K .NE. 1) GO TO 30
      TRANS(2) = -TRANS(2)
      TRANS(4) = -TRANS(4)
      RETURN
C
      ENTRY ANGTRD (THETAD,K,TRAND)
C     =============================
C
C     DOUBLE PRECISION -
C
      DO 20 I = 1,9
   20 TRAND(I) = 0.0D0
C
      TRAND(1) =  DCOS(THETAD)
      TRAND(2) =  DSIN(THETAD)
      TRAND(4) = -TRAND(2)
      TRAND(5) =  TRAND(1)
      TRAND(9) =  1.0D0
C
      IF (K .NE. 1) GO TO 30
      TRAND(2) = -TRAND(2)
      TRAND(4) = -TRAND(4)
   30 RETURN
      END

      SUBROUTINE GFSMT(MT,MMAT,MROW)
C
C     ROUTINE TO ADD 1.0 TO ROW MROW AND COLUMN MROW OF MT TO PREVENT
C     SINGULARITIES IN THE MASS MATRIX FOR GIVINS
C
      DOUBLE PRECISION        VAL
C
      INTEGER       Z        ,SYSBUF   ,MCB(7)   ,NAME(2)  ,MMAT
     1             ,MT       ,INBLK(15),OUTBLK(15)
C
C     OPEN CORE
C
      COMMON / ZZZZZZ /        Z(1)
C
C     SYSTEM COMMON
      COMMON / SYSTEM /       SYSBUF
C
C
C     PACK - UNPACK COMMON BLOCKS
C
      COMMON / ZBLPKX /       A(4)     ,IROW
C
      EQUIVALENCE   ( VAL , A(1) )
C
      DATA NAME / 4HGFSM , 4HT    /
      DATA INBLK / 15*0 /, OUTBLK / 15*0 /
C
C
      MCB(1) = MT
      CALL RDTRL(MCB)
      NROW = MCB(2)
C
C     ALLOCATE BUFFERS
C
      NZ = KORSZ(Z(1))
      IBUF1 = NZ - SYSBUF
      IBUF2 = IBUF1 - SYSBUF
      NZ = IBUF2 - 1
      IF(NZ .LT. 100) GO TO 1008
C
C     OPEN FILES
C
      CALL MAKMCB(MCB,MMAT,NROW,1,2)
      INBLK(1) = MT
      OUTBLK(1) = MMAT
      CALL GOPEN(MT,Z(IBUF1),0)
      CALL GOPEN(MMAT,Z(IBUF2),1)
C
C     COPY RECORDS UP TO MROW
C
      IF(MROW .EQ. 1) GO TO 310
      MR = MROW - 1
      DO 300 I=1,MR
      CALL CPYSTR(INBLK,OUTBLK,0,0)
  300 CONTINUE
C
C    PACK OUT COLUMN MROW WITH A 1.0 IN ROW MROW.  THE COLUMN IS NULL
C     IN MT SO IT IS SKIPPED
C
  310 CALL BLDPK(2,2,MMAT,0,0)
      IROW = MROW
      VAL = 1.0D0
      CALL ZBLPKI
      CALL BLDPKN(MMAT,0,MCB)
C
      IF(MROW .GE. NROW) GO TO 320
      CALL FWDREC(*1002,MT)
C
C     BLAST OUT REST OF FILE
C
      CALL CPYFIL(MT,MMAT,Z,NZ,ICNT)
C
C     CLOSE FILES
C
  320 CALL CLOSE(MT,1)
      CALL CLOSE(MMAT,1)
C
C     COPY TRAILER OVER.  THE DENSITY WILL BE SLIGHTLY OFF BECAUSE
C     OF THE NEW TERM BUT IT:S CLOSE
C
      MCB(1) = MT
      CALL RDTRL(MCB)
      MCB(1) = MMAT
      CALL WRTTRL(MCB)
      RETURN
C
C     ERRORS
C
 1002 CALL MESAGE(-2,MT,NAME)
 1008 CALL MESAGE(-8,0,NAME)
      RETURN
      END

      SUBROUTINE XRGSUB (IRESTB,SUBSET)
C****
C     PURPOSE - XRGSUB PROCESSES THE ****SBST CONTROL CARD IN
C               RIGID FORMAT DATA BASE
C
C     AUTHOR  - RPK CORPORATION; DECEMBER, 1983
C
C     INPUT
C       ARGUMENTS
C         SUBSET        SUBSET NUMBERS GIVEN BY THE USER
C       OTHER
C         /XRGDXX/
C           NSUBST      NUMBER OF SUBSET NUMBERS GIVEN BY USER
C           NUM         2 WORD ARRAY CONTAINING A RANGE OF NUMBERS
C                       FROM THE LIST OF NUMBERS ON THE ****SBST
C                       CONTROL CARD
C         NUMENT        NUMBER OF WORDS PER ENTRY IN THE MODULE
C                       EXECUTION DECISION TABLE
C
C     OUTPUT
C       ARGUMENTS
C         IRESTB        MODULE EXECUTION DECISION TABLE ENTRY FOR
C                       CURRENT DMAP STATEMENT
C       OTHER
C         /XRGDXX/
C           ICOL      COLUMN NUMBER BEING PROCESSED ON THE CARD
C           IERROR    ERROR FLAG - NON-ZERO IF AN ERROR OCCURRED
C           IGNORE    IGNORE FLAG SET TO NON-ZERO IF THE DMAP
C                     STATEMENT IS TO BE DELETED BY THE SUBSET
C           LIMIT     LOWER/UPPER LIMITS OF VALUES WITHIN AN
C                     ENTRY ON THE CARD
C
C     LOCAL VARIABLES
C       IEND          VALUE OF NUM(2)
C       ISTR          VALUE OF NUM(1)
C
C     FUNCTIONS
C        XRGSUB CALLS XRGDEV TO EXTRAPOLATE THE NUMBER FROM THE
C        THE CARD AND THEN IT COMPARES THE NUMBER(S) WITH THOSE
C        SUPPLIED BY THE USER AS SUBSETS.  IF A MATCH IS FOUND,
C        IGNORE IS SET AND THE MODULE EXECUTION DECISION TABLE
C        ENTRY IS SET TO ZERO.  CHECKS CONTINUE UNTIL ALL VALUES
C        GIVEN ON ****SBST CARD HAD BEEN CHECK OR UNTIL A MATCH
C        IS FOUND
C
C     SUBROUTINES CALLED - XDCODE,XRGDEV
C
C     CALLING SUBROUTINES - XRGDFM
C
C     ERRORS - NONE
C
C****
      INTEGER         RECORD,SUBSET(12),IRESTB(7)
      COMMON /XRGDXX/ IRESTR,NSUBST,IPHASE,ICOL,NUMBER,ITYPE,
     1               ISTATE,IERROR,NUM(2),IND,NUMENT,
     2               RECORD(20),ICHAR(80),LIMIT(2),
     3               ICOUNT,IDMAP,ISCR,NAME(2),MEMBER(2),IGNORE
C
       ICOL   = 9
       IERROR = 0
       CALL XDCODE
       LIMIT(1) = 1
       LIMIT(2) = 12
 200   CALL XRGDEV
       IF (IERROR.NE.0 .OR. ICOL.GT.80) GO TO 700
       ISTR = NUM(1)
       IEND = NUM(2)
       DO 400 K  = ISTR,IEND
       DO 300 KK = 1,NSUBST
       IF (K .EQ. SUBSET(KK)) GO TO 500
 300   CONTINUE
 400   CONTINUE
       ICOL = ICOL + 1
       GO TO 200
 500   DO 600 K = 1,NUMENT
       IRESTB(K) = 0
 600   CONTINUE
       IGNORE = 1
 700   RETURN
       END

      SUBROUTINE MPYAD (ZZ      ,Z      ,ZD      )
C
C     THE FOLLOWING DEFINES THE VARIOUS I/O METHODS AND STORAGE METHODS USED
C  BY THE DIFFERENT MULTIPLY-ADD METHODS.  
C
C  IN REGARDS TO THE NEW METHODS BELOW, WHEN MULTIPLE COLUMNS OF A MATRIX
C  ARE STORED AND READ BY GETSTR, THEN THE MATRIX IS STORED IN MEMORY IN 
C  COMPACT FORM.  SEE SUBROUTINES 'MMARM1,2,3,4' FOR A DESCRIPTION OF 
C  THIS COMPACT FORM.  WHEN ONLY A SINGLE COLUMN OF A MATRIX IS STORED 
C  AND IT IS BEING READ BY GETSTR, IT IS STORED IN COMPACT FORM IN MEMORY.  
C  SEE SUBROUTINES 'MMARC1,2,3,4' FOR A DESCRIPTION OF THIS FORM.
C
C   METHOD     METHOD OF READING MATRIX    MULTIPLE COLUMNS OF MATRIX STORED
C                 A        B       C           A         B        D
C  OLD METHODS
C     1         INTPK   UNPACK   UNPACK       NO         YES      YES
C     2T        GETSTR  UNPACK   INTPK        YES        NO       NO
C     2NT       GETSTR  INTPK    INTPK        YES        NO       NO
C     3T        UNPACK  GETSTR   INTPK        YES        NO       NO
C  NEW METHODS
C     10        UNPACK  UNPACK   UNPACK       YES        NO       NO
C     11        UNPACK  GETSTR   UNPACK       YES        NO       NO
C     20        UNPACK  UNPACK   UNPACK       NO         YES      YES
C     21        GETSTR  UNPACK   UNPACK       NO         YES      YES
C     30        GETSTR  UNPACK   UNPACK       YES        NO       NO
C     31        GETSTR  GETSTR   UNPACK       YES        NO       NO
C     40        UNPACK  GETSTR   UNPACK       NO         YES      YES
C     41        GETSTR  GETSTR   UNPACK       NO         YES      YES
C
      COMMON /MPYADX/ FILEA(7)     ,FILEB(7)     ,FILEC(7)     ,
     1                FILED(7)     ,NZ    ,T     ,SIGNAB,SIGNC ,PREC1 ,
     2                SCRTCH,TIME
      COMMON /SYSTEM/ KSYSTM(152)
      EQUIVALENCE     (KSYSTM(58), METHOD )
      CALL SSWTCH ( 49, L49 )
      IF ( METHOD .GE. 1 .AND. METHOD .LE. 3 ) L49 = 1 
      IF ( L49 .NE. 0 ) CALL MPYADO ( ZZ, Z, ZD )
      IF ( L49 .EQ. 0 ) CALL MMA    ( ZZ, Z, ZD )
      RETURN
      END

      SUBROUTINE CFEER2 (IRET)
C
C     CFEER2 INITIALIZES AND CALLS CDCOMP FOR CFCNTL
C
      LOGICAL            QPR
      INTEGER            FILEA    ,FILEL    ,FILEU    ,SCR1     ,
     1                   SCR2     ,SCR3     ,SCR4     ,SCR5     ,
     2                   SCR6     ,SCR7     ,SCR8     ,SCR9     ,
     3                   SR1FIL   ,SR2FIL   ,SR3FIL   ,DUMM     ,
     4                   TYPOUT   ,BBBBAR
      DOUBLE PRECISION   DET      ,MINDIA   ,DZ(1)
      COMMON  /CDCMPX/   FILEA(7) ,FILEL(7) ,FILEU(7) ,SR1FIL   ,
     1                   SR2FIL   ,SR3FIL   ,DET(2)   ,POWER    ,
     2                   NZ       ,MINDIA   ,BBBBAR(5)
      COMMON  /FEERAA/   DUMM(36) ,SCR1     ,SCR2     ,SCR3     ,
     1                   SCR4     ,SCR5     ,SCR6     ,SCR7     ,
     2                   SCR8     ,SCR9     ,DUMQ(72) ,MCBLT(7) ,
     3                   MCBUT(7)
      COMMON  /FEERXC/   DUMXC(21),QPR
      COMMON  /ZZZZZZ/   Z(1)
      COMMON  /UNPAKX/   TYPOUT   ,IROW     ,NLAST    ,INCR
      COMMON  /SYSTEM/   KSYSTM(65)
      EQUIVALENCE        (Z(1), DZ(1)     ) ,(NOUT,KSYSTM(2))   ,
     1                   (IPREC,KSYSTM(55))
C
      ITYPE    = IPREC + 2
      IRET     = 0
      FILEA(1) = SCR1
      FILEL(1) = SCR3
      FILEU(1) = SCR4
      SR1FIL   = SCR5
      SR2FIL   = SCR6
      SR3FIL   = SCR7
      FILEA(2) = DUMM(3)
      FILEA(3) = DUMM(3)
      FILEA(4) = DUMM(4)
      FILEA(5) = ITYPE
      FILEA(6) = 0
      FILEA(7) = 0
      FILEL(5) = ITYPE
      NZ       = KORSZ(Z)
      BBBBAR(1)= 0
      CALL CDCOMP (*110,Z,Z,Z)
C
C     ---------- SPECIAL PRINT -------------------------------
C
      IF (.NOT.QPR) GO TO 80
      WRITE  (NOUT,10)
   10 FORMAT (//,7H CFEER2,//)
      WRITE  (NOUT,20)
   20 FORMAT (1H ,13(10H----------))
      TYPOUT = ITYPE
      IROW   = 1
      NLAST  = DUMM(2)
      LIMIT  = 2*NLAST
      INCR   = 1
      IBUF   = NZ - KSYSTM(1) - 2
      IFILXX = SCR3
   30 CALL GOPEN (IFILXX,Z(IBUF),0)
      DO 50 I = 1,NLAST
      WRITE  (NOUT,40) I
   40 FORMAT (1H ,6HCOLUMN,I4)
      CALL UNPACK (*50,IFILXX,Z)
      IF (IPREC .EQ. 2) WRITE (NOUT,60) (DZ(J),J=1,LIMIT)
      IF (IPREC .NE. 2) WRITE (NOUT,70) ( Z(J),J=1,LIMIT)
   50 CONTINUE
      CALL CLOSE (IFILXX,1)
      WRITE (NOUT,20)
      IF (IFILXX .EQ. SCR4) GO TO 80
      IFILXX = SCR4
      GO TO 30
   60 FORMAT (1H ,13(10H----------)/(1H ,4D25.16))
   70 FORMAT (1H ,13(10H----------)/(1H ,4E25.16))
   80 CONTINUE
C
C     --------------------------------------------------------
C
   90 DO 100 I = 1,7
      MCBUT(I) = FILEU(I)
  100 MCBLT(I) = FILEL(I)
      RETURN
C
  110 IRET = 1
      GO TO 90
      END

      SUBROUTINE SHPSTS (SIGMA,VONMS,SIGP)
C
C     TO CALCULATE PRINCIPAL STRESSES AND THEIR ANGLES FOR THE
C     ISOPARAMETRIC SHELL ELEMENTS
C
C
C     INPUT :
C           SIGMA  - ARRAY OF 3 STRESS COMPONENTS
C           VONMS  - LOGICAL FLAG INDICATING THE PRESENCE OF VON-MISES
C                    STRESS REQUEST
C     OUTPUT:
C           SIGP   - ARRAY OF PRINCIPAL STRESSES
C
C
      LOGICAL VONMS
CWKBNB 7/94 SPR94004
      LOGICAL OSTRAI
      COMMON / BLANK / APP(2), SORT2, IDUM(2), COMPS, SKP(4), OSTRAI
     &,                SK2(39), MIDVE
CWKBNE 7/94 SPR94004
      REAL    SIGMA(3),SIGP(4),SIG,PROJ,TAUMAX,EPS,TXY2
      DATA    EPS / 1.0E-11 /
C
C
C     CALCULATE PRINCIPAL STRESSES
C
      SIG  = 0.5*(SIGMA(1)+SIGMA(2))
      PROJ = 0.5*(SIGMA(1)-SIGMA(2))
      TAUMAX = PROJ*PROJ + SIGMA(3)*SIGMA(3)
CWKBI 7/94 SPR94004
      IF ( OSTRAI ) TAUMAX = PROJ*PROJ + SIGMA(3)*SIGMA(3)/4.
      IF (TAUMAX .NE. 0.0) TAUMAX = SQRT(TAUMAX)
      IF (TAUMAX .LE. EPS) TAUMAX = 0.0
C
C     CALCULATE THE PRINCIPAL ANGLE
C
      TXY2 = SIGMA(3)*2.0
      PROJ = PROJ*2.0
      SIGP(1) = 0.0
      IF (ABS(TXY2).GT.EPS .OR. ABS(PROJ).GT.EPS)
     1    SIGP(1) = 28.64788976*ATAN2(TXY2,PROJ)
C                   28.64788976 = 90./PI
C
      SIGP(2) = SIG + TAUMAX
      SIGP(3) = SIG - TAUMAX
      SIGP(4) = TAUMAX
C
C     OUTPUT VON MISES YIELD STRESS IF REQUESTED
C
      IF (.NOT.VONMS) RETURN
      SIG = SIGP(2)*SIGP(2) + SIGP(3)*SIGP(3) - SIGP(2)*SIGP(3)
      IF (SIG .NE. 0.0) SIG = SQRT(SIG)
      IF (SIG .LE. EPS) SIG = 0.0
      SIGP(4) = SIG
C
      RETURN
      END

      SUBROUTINE DDR1
C
C     DYNAMIC DATA RECOVERY PART1
C
C     INPUTS  2 UHV,PHIDH
C
C     OUTPUTS 1 UDV
C
C     SCRATCHES  1
C
      INTEGER UHV,PHIDH,UDV,SCR1
      DATA UHV,PHIDH,UDV,SCR1/101,102,201,301/
C
C     TRANSFPRM TO MODAL DISPLACEMENTS
C
      CALL SSG2B(PHIDH,UHV,0,UDV,0,1,1,SCR1)
      RETURN
      END

      SUBROUTINE FEER3X
C                                                               T
C     FEER3 OBTAINS THE REDUCED TRIDIAGONAL MATRIX   (LI)*M*(LI)
C     WHERE M IS A SYMETRIC MATRIX AND L IS LOWER TRIANGULAR, AND (LI)
C     IS INVERSE OF L
C
C     THE TRANSFORMATION IS ALPHA = VT(L**(-1)M (L**-(1))TV
C     WHERE V IS A RECTANGULAR TRANSFORMATION.
C
C     LAST REVISED 11/91 BY G.CHAN/UNISYS, MAKE ROOM FOR NEW FBS METHOD
C
      INTEGER            SYSBUF    ,CNDFLG   ,MCBSCL(7),SR5FLE   ,
     1                   SR6FLE    ,SR7FLE   ,SR8FLE   ,SR9FLE   ,
     2                   SR10FL    ,SRXFLE   ,IZ(1)    ,NAME(2)  ,
     3                   DASHQ     ,OPTN2
      DOUBLE PRECISION   LAMBDA    ,LMBDA    ,DZ(1)    ,DSQ
      COMMON   /FEERCX/  IFKAA(7)  ,IFMAA(7) ,IFLELM(7),IFLVEC(7),
     1                   SR1FLE    ,SR2FLE   ,SR3FLE   ,SR4FLE   ,
     2                   SR5FLE    ,SR6FLE   ,SR7FLE   ,SR8FLE   ,
     3                   DMPFLE    ,NORD     ,XLMBDA   ,NEIG     ,
     4                   MORD      ,IBK      ,CRITF    ,NORTHO   ,
     5                   IFLRVA    ,IFLRVC
      COMMON   /FEERXX/  LAMBDA    ,CNDFLG   ,ITER     ,TIMED    ,
     1                   L16       ,IOPTF    ,EPX      ,NOCHNG   ,
     2                   IND       ,LMBDA    ,IFSET    ,NZERO    ,
     3                   NONUL     ,IDIAG    ,MRANK    ,ISTART   ,
     4                   NZV5
      COMMON   /REIGKR/  OPTION    ,OPTN2
      COMMON   /TYPE  /  RC(2)     ,IWORDS(4)
      COMMON   /ZZZZZZ/  Z(1)
      COMMON   /SYSTEM/  SYSBUF    ,IO       ,SYSTM(52),IPREC    ,
     1                   SKIP36(38),KSYS94
      COMMON   /OPINV /  MCBLT(7)  ,MCBSMA(7),MCBVEC(7),MCBRM(7)
      COMMON   /UNPAKX/  IPRC      ,II       ,NN       ,INCR
      COMMON   /PACKX /  ITP1      ,ITP2     ,IIP      ,NNP      ,
     1                   INCRP
      COMMON   /NAMES /  RD        ,RDREW    ,WRT      ,WRTREW   ,
     1                   REW       ,NOREW    ,EOFNRW
      EQUIVALENCE        (IZ(1),Z(1),DZ(1))
      DATA      NAME  /  4HFEER,4H3   /      ,DASHQ    / 4H-Q    /
C
C     SR5FLE CONTAINS THE TRIDIAGONAL ELEMENTS
C     SR6FLE CONTAINS THE G VECTORS
C     SR7FLE CONTAINS THE ORTHOGONAL VECTORS
C     SR8FLE CONTAINS THE CONDITIONED MAA OR KAAD MATRIX
C     SR9FLE CONTAINS MCBSMA DATA IN UNPACKED FORM = 309
C     SR10FL CONTAINS MCBLT  DATA IN UNPACKED FORM = 310
C                                              (OR = 308 IF IT IS FREE)
C     IFLVEC CONTAINS THE L OR C MATRIX FROM SDCOMP
C     IFLELM CONTAINS     KAA+ALPHA*MAA
C     IFLRVC CONTAINS THE RESTART AND/OR RIGID BODY VECTORS
C
      SR9FLE = 309
      SR10FL = 308
      IPRC   = MCBLT(5)
      NWDS   = IWORDS(IPRC)
      NZ     = KORSZ(Z)
      CALL MAKMCB (MCBVEC(1),SR7FLE,NORD,2,IPRC)
      MCBVEC(2) = 0
      MCBVEC(6) = 0
      CALL MAKMCB (MCBRM(1) ,SR6FLE,MORD,2,IPRC)
      MCBRM(2)  = 0
      MCBRM(6)  = 0
      MCBSCL(1) = IFLRVC
      CALL RDTRL (MCBSCL(1))
C
C     INITIALIZE ALLOCATIONS
C
      IBUF1 = NZ    - SYSBUF
      IBUF2 = IBUF1 - SYSBUF
      IBUF3 = IBUF2 - SYSBUF
      IBUF4 = IBUF3 - SYSBUF
      IV1   = 1
      IV2   = IV1 + NORD
      IV3   = IV2 + NORD
      IV4   = IV3 + NORD
      IV5   = IV4 + NORD
      NZV5  = IBUF4 - IV5*NWDS - 2
      IX2   = IV2 - 1
      IEND  = NWDS*(5*NORD + 1) + 2
      ICRQ  = IEND - IBUF4
      IF (ICRQ .GT. 0) CALL MESAGE (-8,ICRQ,NAME)
      IFL   = MCBLT(1)
      SRXFLE= SR8FLE
C
C     CALL UNPSCR TO MOVE MCBSMA DATA INTO SR9FLE, AND MCBLT INTO SR10FL
C     (ORIGINAL MCBSMA AND MCBLT TRAILER WORDS 4,5,6,7 WILL BE CHANGED)
C     NZV5 IS THE AVAILABE SIZE OF THE WORKING SPACE FOR NEW FBS METHOD
C     USED IN FRSW/2, FRBK/2, FRMLT/D, AND FRMLTX/A ROUTINES
C
C     IF KSYS94 IS 10000 OR DIAG 41 IS ON, NEW FBS METHODS AND UNPSCR
C     ARE NOT USED
C
      IF (MOD(KSYS94,100000)/10000 .EQ. 1) GO TO 10
      CALL SSWTCH (41,I)
      IF (I .EQ. 1) GO TO 10
      SRXFLE = SR9FLE
      CALL UNPSCR (MCBSMA,SRXFLE,Z,IBUF2,IBUF1,NZV5,0,1)
      J = 2
      IF (IOPTF .EQ. 1) J = 3
      CALL UNPSCR (MCBLT,SR10FL,Z,IBUF2,IBUF1,NZV5,0,J)
      NZV5 = NZV5 + 1
      IFL  = SR10FL
C
   10 CALL GOPEN (IFL,Z(IBUF3),RDREW)
      CALL GOPEN (SR7FLE,Z(IBUF1),WRTREW)
      IF (NORTHO .EQ. 0) GO TO 130
C
C     LOAD RESTART AND/OR RIGID BODY VECTORS
C
      CALL GOPEN (IFLRVC,Z(IBUF2),RDREW)
      INCR  = 1
      INCRP = 1
      ITP1  = IPRC
      ITP2  = IPRC
C
      DO 110 J = 1,NORTHO
      II  = 1
      NN  = NORD
      CALL UNPACK (*110,IFLRVC,DZ(1))
      IIP = II
      NNP = NN
      IF (IPRC  .EQ. 1) GO TO 60
      IF (IOPTF .EQ. 0) GO TO 40
      DSQ = 0.D0
      CALL FRMLTX (MCBLT(1),DZ(IV1),DZ(IV2),DZ(IV3))
      DO 20 IJ = 1,NORD
   20 DSQ = DSQ + DZ(IX2+IJ)**2
      DSQ = 1.D0/DSQRT(DSQ)
      DO 30 IJ = 1,NORD
   30 DZ(IJ) = DSQ*DZ(IX2+IJ)
   40 IF (L16 .EQ. 0) GO TO 100
      CALL PAGE2 (2)
      WRITE (IO,50) IIP,NNP,(DZ(I),I=1,NORD)
   50 FORMAT (10H ORTH VCT ,2I5,  /(1X,8E16.8))
      GO TO 100
   60 IF (IOPTF .EQ. 0) GO TO 90
      SQ = 0.0
      CALL FRMLTA (MCBLT(1),Z(IV1),Z(IV2),Z(IV3))
      DO 70 IJ = 1,NORD
   70 SQ = SQ + Z(IX2+IJ)**2
      SQ = 1.0/SQRT(SQ)
      DO 80 IJ = 1,NORD
   80 Z(IJ) = SQ*Z(IX2+IJ)
   90 IF (L16 .EQ. 0) GO TO 100
      CALL PAGE2 (2)
      WRITE (IO,50) IIP,NNP,(Z(I),I=1,NORD)
  100 CALL PACK (DZ(1),SR7FLE,MCBVEC(1))
  110 CONTINUE
C
      CALL CLOSE (IFLRVC,NOREW)
      IF (L16 .EQ. 0) GO TO 130
      CALL PAGE2 (1)
      WRITE  (IO,120) NORTHO,MCBVEC
  120 FORMAT (5X,I5,16H ORTH VECTORS ON,I5,5H FILE,5I5,I14)
  130 K = NORTHO
      CALL CLOSE (SR7FLE,NOREW)
      J = K
      NONUL = 0
      ITER  = 0
      CALL GOPEN (SR6FLE,Z(IBUF4),WRTREW)
      CALL CLOSE (SR6FLE,NOREW)
      CALL GOPEN (SRXFLE,Z(IBUF2),RDREW)
      CALL GOPEN (SR5FLE,Z(IBUF4),WRTREW)
C
C     GENERATE SEED VECTOR
C
  140 K = K + 1
      J = K
      IFN = 0
C
C     GENERATE SEED VECTOR FOR LANCZOS
C
      SS = 1.0
      IF (IPRC .EQ. 1) GO TO 160
      DO 150 I = 1,NORD
      SS =-SS
      J  = J + 1
      DSQ = FLOAT(MOD(J,3)+1)/(3.0*FLOAT((MOD(J,13)+1)*(1+5*I/NORD)))
  150 DZ(IX2+I) = DSQ*SS
      IF (OPTN2 .NE. DASHQ) CALL FNXTVC (DZ(IV1),DZ(IV2),DZ(IV3),
     1                                   DZ(IV4),DZ(IV5),Z(IBUF1),IFN)
      GO TO 180
C
  160 DO 170 I = 1,NORD
      SS =-SS
      J  = J + 1
      SQ = FLOAT(MOD(J,3)+1)/(3.0*FLOAT((MOD(J,13)+1)*(1+5*I/NORD)))
  170 Z(IX2+I) = SQ*SS
      IF (OPTN2 .NE. DASHQ) CALL FNXTV  (Z(IV1),Z(IV2),Z(IV3),Z(IV4),
     1                                   Z(IV5),Z(IBUF1),IFN)
      IF (OPTN2 .EQ. DASHQ) CALL FNXTVD (Z(IV1),Z(IV2),Z(IV3),Z(IV4),
     1                                   Z(IV5),Z(IBUF1),IFN)
C
  180 IF (ITER .LE. MORD) GO TO 190
      MORD = NORTHO - NZERO
      CNDFLG = 3
      GO TO 200
C
  190 IF (IFN .LT. MORD) GO TO 140
  200 CALL CLOSE (SR5FLE,NOREW)
      CALL CLOSE (SRXFLE,REW)
      CALL CLOSE (IFL,REW)
C
C     IF NEW FBS METHOD IS USED, SR9FLE AND SR10FL FILES COULD BE VERY
C     BIG. MAKE SURE THEY ARE PHYSICALLY REDUCED TO ZERO SIZE. THIS IS
C     IMPORTANT FOR A COMPUTER SYSTEM WITH LIMITED DISC SPACE
C
      IF (IFL .NE. SR10FL) GO TO 210
      CALL GOPEN (SR9FLE,Z(IBUF2),WRTREW)
      CALL GOPEN (SR10FL,Z(IBUF3),WRTREW)
      CALL CLOSE (SR9FLE,REW)
      CALL CLOSE (SR10FL,REW)
C
  210 IF (L16 .EQ. 0) RETURN
      CALL PAGE2 (1)
      I = IBUF4 - NORTHO*NORD*NWDS - 2
      IF (I .LT.  0) I = IBUF4 - IEND
      WRITE  (IO,220) I,NAME
  220 FORMAT (19H OPEN CORE NOT USED,I10,2X,2A4)
C
      RETURN
      END

      SUBROUTINE GRBVEC
C
C     THIS SUBROUITNE IS THE MAIN DRIVER FOR THE VECGRB MODULE
C     WHICH GENERATES
C
C     (1) THE GEOMETRIC RIGID BODY VECTORS ABOUT THE INDICATED GRID
C         POINT OR ORIGIN.
C         THIS SET OF VECTORS CONSISTS OF UNIT DISPLACEMENTS IN ZERO
C         COORDINATE SYSTEM ABOUT THE SPECIFIED GRID IN GLOBAL COORD.
C         FOR EASE OF ASSEMBLY THE VECTOR IS GENERATED IN THE TRANSPOSED
C         FORM, THAT IS, WITH SIX ROW, ONE FOR EACH OF THE SIX UNIT
C         MOTIONS AND G-SET COLUMNS, ONE FOR EACH DOF'S CORRESPONDING
C         MOTION. THIS SET OF VECTORS WOULD BE EXACTLY EQUAL TO A UNIT
C         DISPLACEMENT CHECK IF ALL THE GRIDS HAD STIFFNESS BUT WERE
C         NOT GROUNDED.
C
C     (2) A g-SET SIZED CSTM FROM BASIC TO GOLBAL
C
C     DMAP SEQUENCE -
C
C     VECGRB    BGPDT,EQEXIN,CSTM/OUTVEC/P1/P2/P3   $
C
C     WHERE     P1 = 1, GENERATE CSTM FROM BASIC TO GLOBAL
C                  = 2, GENERATE PHIRBT
C               P2 = REFERENCE GRID FOR PHIRB (0=BASIC, DEFAULT)
C               P3 = CURRENTLY NOT USED
C
C     EXAMPLES -
C
C     (1) G-SET EQUILIBRIUM CHECK
C     THIS CHECK MULTIPLIES THE STIFFNESS MATRIX TIMES THE GEOMETRIC
C     RIGID BODY SHAPES PENERATED BY VECRGB. THE FORCES OBATINED FROM
C     THIS MULTIPLICATION SHOULD BE ZERO.
C
C     VECGRB   BGPDT,CSTM,EQEXIN/PHIRBT/2/0  $ CREATE TRANSPOSE OF RIGID
C     TRNSP    PHIRBT/PHIRB                  $ BODY VECTORS, THEN TRNSP
C     MPYAD    KGG,PHIRB,/KPHIG/0            $ MULTIPLY BY STIFFNESS.
C     MPYAD    PHIRBT,KPHIG,/KPHG6/0         $ SUM FORCES AND PRINT
C     MATPRN   KPHG6,,,, //                  $ 6X6 SUMMATION. PRINT ALL
C     MATGPR   GPL,USET,SIL,KPHIG//*G*/*G*// $ FORCES OVER 0.0001
C              .0001                         $
C
C     (2) COORDINATE SYSTEM TRANSFORMATION
C
C     VECRGB   BGPDT,CSTM,EQEXIN/BCSTM/1     $ TRANSFORM GLOBAL KGG TO
C     TRNSP    BCSTM/BCSTMT/                 $ BASIC
C     MPYAD    BCSTM,KGG,/BGKGG/0            $
C     MPYAD    BGKGG,BCSTMT,/BBKGG/0         $
C
C     THIS SUBROUTINE WAS ORIGINALLY CALLED CSTMX, AND WAS WRITTEN BY
C     P.KIRCHMAN/SWALES, 2/1993, WITH THE DMAP MODULE OF THE SAME NAME
C
C     THE DMAP MODLUE IS RENAMED TO GEOMETRIC RIGID BODY VECTOR, VECGRB,
C     AND THE SUBROUTINE GRBVEC. THE ORIGINAL SUBROUTINE WAS RE-CODED BY
C     G.CHAN/UNISIS, USING NASTRAN TRADITIONAL FORTRAN STYLE, AND THE
C     SUBSTITUTION OF GMMATD ROUTINE FOR DP3X3M. ALSO, THE ORDER OF 2ND
C     AND 3RD INPUT DATA BLOCKS IS INTERCHANGED.
C
C     THE ORIGINAL CSTMX IS INCLUDED IN THE 1993 RELEASE. IT IS ONLY
C     FOR BACKUP PURPOSE. CSTMX WILL BE DELETED IN NEXT NASTRAN RELEASE
C     (THE ORIGINAL CSTMX ROUTINE PRODUCED HUNDREDS OF FORTRAN ERRORS
C     ON CDC MACHINE WITH FTN5 COMPILER. 3/93)
C
      IMPLICIT INTEGER (A-Z)
      LOGICAL          RBV
      INTEGER          TRL(7),NAME(2),SUB(2)
      REAL             RX(1)
      DOUBLE PRECISION RBVR(3),V3(3),ZERO,ONE,XG,YG,ZG,RAD,XL,TU(9),
     1                 T1(9),T2(9),T(9),RVEC(9),RBVEC(9),V(3),VOUT(6)
      CHARACTER        UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG /  UFM,UWM,UIM,SFM
      COMMON /BLANK /  P1,P2,P3
      COMMON /ZZZZZZ/  IX(1)
      COMMON /SYSTEM/  IBUFF,NOUT
      COMMON /PACKX /  TIN,TOU,II,JJ,INCR
      EQUIVALENCE      (IX(1),RX(1))
      DATA    BGPDT ,  EQEXIN, CSTM / 101,102,103  /,
     1        OUTVEC/  201 /,  SUB  / 4HGRBV,4HC   /
      DATA    ZERO  ,  ONE /  0.0D+0, 1.0D+0       /
      DATA    CSTMX ,  EQE,XIN,       BGP,DT       /
     1        4HCSTM,  4HEQEX,4HIN  , 4HBGPD,4HT   /
C
C     CHECK FOR THE PRESENCE OF OUTPUT DATA BLOCK
C
      TRL(1) = OUTVEC
      CALL RDTRL (TRL)
      IF (TRL(1) .LE. 0) GO TO 1000
C
C     INITIALIZATION
C
      LCOR  = KORSZ(IX(1)) - IBUFF
      BUF1  = LCOR - 1
      TU(1) = ONE
      TU(2) = ZERO
      TU(3) = ZERO
      TU(4) = ZERO
      TU(5) = ONE
      TU(6) = ZERO
      TU(7) = ZERO
      TU(8) = ZERO
      TU(9) = ONE
C
C     CHECK THE PRESENCE OF BGPDT AND CSTM FILES
C
      TRL(1)= BGPDT
      CALL RDTRL (TRL)
      IF (TRL(1) .LE. 0) GO TO 1020
      NENT  = TRL(2)
      TRL(1)= CSTM
      CALL RDTRL (TRL)
      NCST  = TRL(3)
      IF (TRL(1) .LE. 0) NCST = 0
      NENT4 = NENT*4
      NCST14= NCST*14
      IF (NENT4+NCST14 .GT. LCOR) GO TO 1100
      RBV   = P1 .EQ. 2
C
C     CHECK IF THIRD INPUT FILE IS PRESENT, THEN OPEN EQEXIN FILE AND
C     READ THE FIRST TABLE INTO CORE IF APPROPRIEATE
C
      GRDPNT = 0
      IF (P1.NE.2 .OR. P2.EQ.0) GO TO 60
      TRL(1) = EQEXIN
      CALL RDTRL (TRL)
      IF (TRL(1) .LE. 0) GO TO 1020
      FILE = EQEXIN
      CALL FNAME (EQEXIN,NAME)
      IF (NAME(1).NE.EQE .OR. NAME(2).NE.XIN) GO TO 1040
      CALL OPEN (*1200,EQEXIN,IX(BUF1),0)
      CALL FWDREC (*1300,EQEXIN)
      CALL READ (*1300,*20,EQEXIN,IX(1),BUF1-1,1,FLAG)
      CALL MESAGE (-8,0,SUB)
   20 TRL2 = TRL(2)*2
      IF (FLAG .NE. TRL2) GO TO 1320
      J = 1
      DO 30 I = 1,TRL2,2
      IF (P2 .NE. IX(J)) GO TO 30
      GRDPNT = IX(J+1)
      GO TO 50
   30 J = J + 2
      GRDPNT = 0
      WRITE  (NOUT,40) UWM,P2
   40 FORMAT (A25,' - ID ',I8,' IS NOT A GRID POINT.  THE ORIGIN WILL ',
     1       'BE USED.')
   50 CALL CLOSE (EQEXIN,1)
C
C     OPEN AND READ BGPDT TABLE INTO BEGINNING OF CORE
C
   60 FILE = BGPDT
      CALL FNAME (BGPDT,NAME)
      IF (NAME(1).NE.BGP .AND. NAME(2).NE.DT) GO TO 1040
      CALL OPEN (*1200,BGPDT,IX(BUF1),0)
      CALL FWDREC (*1300,BGPDT)
      CALL READ (*1300,*70,BGPDT,IX(1),BUF1-1,1,FLAG)
      CALL MESAGE (-8,0,SUB)
   70 IF (FLAG .NE. NENT4) GO TO 1330
      CALL CLOSE (BGPDT,1)
C
C     OPEN AND READ CSTM FIRST TABLE INOT CORE AFTER BGPDT
C
      IF (NCST .EQ. 0) GO TO 90
      FILE = CSTM
      CALL FNAME (CSTM,NAME)
      IF (NAME(1) .NE. CSTMX) GO TO 1040
      CALL OPEN (*1200,CSTM,IX(BUF1),0)
      CALL FWDREC (*1300,CSTM)
      CALL READ (*1300,*80,CSTM,IX(NENT4+1),BUF1-NENT4-1,1,FLAG)
      CALL MESAGE (-8,0,SUB)
   80 IF (FLAG .NE. NCST14) GO TO 1340
      CALL CLOSE (CSTM,1)
C
C     USE BGPDT INFO TO FIGURE OUT THE g-SET SIZE FOR OUTPUT
C
   90 SIZE = 0
      I    = 1
      DO 100 J = 1,NENT
      IF (IX(I) .LT. 0) SIZE = SIZE + 1
      IF (IX(I) .GE. 0) SIZE = SIZE + 6
  100 I = I + 4
C
C     STORE RIGID BODY REFERENCE VECTOR
C
      RBVR(1) = 0.
      RBVR(2) = 0.
      RBVR(3) = 0.
      IF (.NOT.RBV .OR. GRDPNT.EQ.0) GO TO 110
      RBVR(1) = RX(GRDPNT*4-2)
      RBVR(2) = RX(GRDPNT*4-1)
      RBVR(3) = RX(GRDPNT*4  )
C
C     OPNE OUTPUT FILE AND FILL OUTPUT TRAILER
C
  110 CALL FNAME (OUTVEC,NAME)
      CALL OPEN (*1200,OUTVEC,IX(BUF1),1)
      CALL WRITE (OUTVEC,NAME,2,1)
      IF (     RBV) CALL MAKMCB (TRL(1),OUTVEC,6,2,2)
      IF (.NOT.RBV) CALL MAKMCB (TRL(1),OUTVEC,SIZE,2,2)
C
C     INITIALIZE PACK COMMONS
C
      TIN  = 2
      TOU  = 2
      INCR = 1
      COL  = 1
C
C     BEGIN LOOP FOR NUMBER OF ENTRIES IN BGPDT
C
      E4  = 0
      DO 440 ENTRY = 1,NENT
      E4  = E4 + 4
      OCID= IX(E4-3)
      XG  = RX(E4-2)
      YG  = RX(E4-1)
      ZG  = RX(E4  )
C
C     RBVEC IS A VECTOR BASED ON UNIT ROTATIONS OF A VECTOR FROM THE
C     REFERENCE GRID TO THE GRID IN QUESTION. THE TRANSFORMATION IS
C     FROM BASIC ROTATIONS TO BASIC TRANSLATIONS.
C
      IF (.NOT.RBV) GO TO 130
      RVEC(1) = ZERO
      RVEC(2) = (ZG-RBVR(3))
      RVEC(3) =-(YG-RBVR(2))
      RVEC(4) =-(ZG-RBVR(3))
      RVEC(5) = ZERO
      RVEC(6) = (XG-RBVR(1))
      RVEC(7) = (YG-RBVR(2))
      RVEC(8) =-(XG-RBVR(1))
      RVEC(9) = ZERO
C
C     IF THIS ENTRY IS A SCALAR AND A RIGID BODY VECTOR HAS BEEN
C     REQUESTED, STORE A ZERO COLUMN
C
 130  IF (OCID.NE.-1 .OR. .NOT.RBV) GO TO 140
      II  = 1
      JJ  = 1
      CALL PACK (ZERO,OUTVEC,TRL)
      COL = COL + 1
      GO TO 440
C
C     IF THIS ENTRY IS A SCALAR AND A CSTM HAS BEEN REQUESTED, SIMPLY
C     PLACE A ONE ON THE DIAGONAL AND CONTINUE
C
  140 IF (OCID .NE. -1) GO TO 150
      II  = COL
      JJ  = COL
      CALL PACK (ONE,OUTVEC,TRL)
      COL = COL + 1
      GO TO 440
C
C     IF THIS ENTRY IS ALREADY IN BASIC COORDINATES, STORE AN IDENTITY
C     IN THE APPOPRIATE SIX BY SIX
C
  150 IF (OCID.NE.0 .OR. .NOT.RBV) GO TO 190
      II  = 1
      JJ  = 1
      DO 170 I = 1,3
      I3  = 0
      DO 160 J = 1,3
      VOUT(J  ) =   TU(J+I*3)
  160 VOUT(J+3) = RVEC(J+I*3)
      I3  = I3 + 3
      II  = 1
      JJ  = 6
      CALL PACK (VOUT,OUTVEC,TRL)
  170 COL = COL + 1
      DO 180 I = 1,3
      II  = I + 3
      JJ  = I + 3
      CALL PACK (ONE,OUTVEC,TRL)
  180 CONTINUE
      GO TO 440
C
  190 IF (OCID .NE. 0) GO TO 210
      DO 200 I = 1,6
      II  = COL
      JJ  = COL
      CALL PACK (ONE,OUTVEC,TRL)
  200 COL = COL + 1
      GO TO 440
C
C     CSTM MUST BE MISSING
C
  210 IF (NCST .NE. 0) GO TO 220
      TRL(1) = CSTM
      GO TO 1020
C
C     SET UP VECTORS AND MATRICES COMMON TO ALL COORDINATE SYSTEM
C     TRANSFORMATIONS
C
C     FIND COORDINATE SYSTEM
C
  220 DO 230 ICST = 1,NCST
      IF (IX(ICST*14-13+NENT4) .EQ. OCID) GO TO 240
  230 CONTINUE
      GO TO 1400
C
C     GET COORDINATE SYSTEM TYPE AND
C     TRANSFORMATION FROM BASIC TO COORDINATE SYSTEM ORIGIN TRIAD
C
  240 OCIDT = IX(ICST*14-12+NENT4)
      T1(1) = RX(ICST*14- 8+NENT4)
      T1(4) = RX(ICST*14- 7+NENT4)
      T1(7) = RX(ICST*14- 6+NENT4)
      T1(2) = RX(ICST*14- 5+NENT4)
      T1(5) = RX(ICST*14- 4+NENT4)
      T1(8) = RX(ICST*14- 3+NENT4)
      T1(3) = RX(ICST*14- 2+NENT4)
      T1(6) = RX(ICST*14- 1+NENT4)
      T1(9) = RX(ICST*14   +NENT4)
C
      IK    = ICST*14 + NENT4
      V3(1) = RX(ENTRY*4-2) - RX(IK-11)
      V3(2) = RX(ENTRY*4-1) - RX(IK-10)
      V3(3) = RX(ENTRY*4  ) - RX(IK- 9)
C
      V(1)  = RX(IK-8)*V3(1) + RX(IK-5)*V3(2) + RX(IK-2)*V3(3)
      V(2)  = RX(IK-7)*V3(1) + RX(IK-4)*V3(2) + RX(IK-1)*V3(3)
      V(3)  = RX(IK-6)*V3(1) + RX(IK-3)*V3(2) + RX(IK  )*V3(3)
C
C     SPECIAL CHECKS FOR ZERO RADIUS CYLINDRICAL OR SPHERICAL COORDINATE
C     SYSTEM. IF SO TREAT AS RECTANGULAR.
C
      RAD = SQRT(V(1)**2 + V(2)**2)
      IF (RAD .EQ. 0.) OCIDT = 1
C
C     PERFORM INDIVIDUAL COORDINATE SYSTEM TRANSFORMATION AND GENERATE
C     T2
C
      GO TO (250,330,340), OCIDT
C
C     RECTANGULAR, T = T1
C
  250 IF (.NOT.RBV) GO TO 290
      INDEX = 1
      CALL GMMATD (RVEC,3,3,0, T1,3,3,0, RBVEC)
C
C     ADD RIGID BODY INFORMATION TO LOWER OFF DIAGONAL 3X3 IF REQUESTED
C
      DO 280 I = 1,3
      I3  = 0
      DO 270 J = 1,3
      VOUT(J  ) =    T1(J+I3)
  270 VOUT(J+3) = RBVEC(J+I3)
      I3  = I3 + 3
      II  = 1
      JJ  = 6
      CALL PACK (VOUT,OUTVEC,TRL)
  280 COL = COL + 1
      GO TO 310
C
C     OR SIMPLY PACK THE TRANSFORMATION
C
  290 INDEX = COL
      DO 300 I = 1,3
      II  = INDEX
      JJ  = INDEX + 2
      CALL PACK (T1(I*3-2),OUTVEC,TRL)
  300 COL = COL + 1
C
C    STORE LOWER 3X3, AND GET NEXT GRID
C
  310 DO 320 I = 1,3
      II  = INDEX + 3
      JJ  = INDEX + 5
      CALL PACK (T1(I*3-2),OUTVEC,TRL)
  320 COL = COL + 1
      GO TO 440
C
C     CYLINDRICAL
C
  330 T2(1) = V(1)/RAD
      T2(4) =-V(2)/RAD
      T2(7) = ZERO
      T2(2) =-T2(4)
      T2(5) = T2(1)
      T2(8) = ZERO
      T2(3) = ZERO
      T2(6) = ZERO
      T2(9) = ONE
      GO TO 350
C
C     SPHERICAL
C
  340 XL    = SQRT(V(1)*V(1) + V(2)*V(2) + V(3)*V(3))
      IF (XL .LE. 0.0) GO TO 1060
      T2(1) = V(1)/XL
      T2(4) =(V(1)*V(3))/(RAD*XL)
      T2(7) =-V(2)/RAD
      T2(2) = V(2)/XL
      T2(5) =(V(2)*V(3))/(RAD*XL)
      T2(8) = V(1)/RAD
      T2(3) = V(3)/XL
      T2(6) =-RAD/XL
      T2(9) = ZERO
C
  350 CALL GMMATD (T1,3,3,0, T2,3,3,0, T)
      IF (.NOT.RBV) GO TO 400
C
C     ADD RIGID BODY INFORMATION TO LOWER OFF DIAGONAL 3X3 IF REQUESTED
C     THEN PACK
C
      INDEX = 1
      CALL GMMATD (RVEC,3,3,0, T,3,3,0, RBVEC)
      DO 390 I = 1,3
      I3  = 0
      DO 380 J = 1,3
      VOUT(J  ) =     T(J+I3)
  380 VOUT(J+3) = RBVEC(J+I3)
      I3  = I3 + 3
      II  = 1
      JJ  = 6
      CALL PACK (VOUT,OUTVEC,TRL)
  390 COL = COL + 1
      GO TO 420
C
C     OR SIMPLY PACK THE TRANSFORMATION
C
  400 INDEX = COL
      DO 410 I = 1,3
      II  = INDEX
      JJ  = INDEX + 2
      CALL PACK (T(I*3-2),OUTVEC,TRL)
  410 COL = COL + 1
C
C     STORE LOWER 3X3
C
  420 DO 430 I = 1,3
      II  = INDEX + 3
      JJ  = INDEX + 5
      CALL PACK (T(I*3-2),OUTVEC,TRL)
  430 COL = COL + 1
C
  440 CONTINUE
C
      CALL CLOSE  (OUTVEC,1)
      CALL WRTTRL (TRL)
      RETURN
C
C     ERRORS
C
 1000 WRITE  (NOUT,1010) UFM
 1010 FORMAT (A23,'.  MISSING REQUIRED OUTPUT FILE')
      GO TO  1500
 1020 WRITE  (NOUT,1030) UFM,TRL(1)
 1030 FORMAT (A23,'.  MISSING REQUIRED INPUT FILE',I4)
      GO TO  1500
 1040 WRITE  (NOUT,1050) UFM,NAME
 1050 FORMAT (A23,'. INPUT FILE ',2A4,' ERROR')
      GO TO  1500
 1060 WRITE  (NOUT,1070) UFM
 1070 FORMAT (A23,' FROM GRBVEC. ZERO RADIAL LENGTH, ERROR AT 340')
      GO TO  1500
 1100 J = -8
      GO TO  1490
 1200 J = -1
      GO TO  1490
 1300 J = -2
      GO TO  1490
 1320 J = TRL2
      GO TO  1350
 1330 J = NENT4
      GO TO  1350
 1340 J = NCST14
 1350 WRITE  (NOUT,1360) SFM,NAME,J,FLAG
 1360 FORMAT (A25,'. EXPECTED RECORD LENGTH DOES NOT MATCH ACTUAL ',
     1       ' RECORD LENGTH ON INPUT FILE ',2A4, /5X,2I10)
      GO TO  1500
 1400 WRITE  (NOUT,1410) UFM,OCID
 1410 FORMAT (A23,'. UNABLE TO FIND COORDINATE SYSTEM ',I8)
      GO TO  1500
C
 1490 CALL MESAGE (J,FILE,SUB)
 1500 CALL MESAGE (-61,0,SUB)
      RETURN
      END

        SUBROUTINE EOF ( FILE )
      INCLUDE 'DSIOF.COM'
        INTEGER FILE
        NAME   = FILE
        IRETRN = 0
        CALL DSGEFL
        CALL DSEFWR
        CALL DSSDCB
        RETURN
        END

      SUBROUTINE PLOT (MODE,BUF1,B1,SETID,DEFLST,NOFIND)
C
C     THIS PLOT ROUTINE IS CALLED ONLY BY PARAM
C
      EXTERNAL          ANDF
      LOGICAL TAPBIT   ,STRESS   ,DISP
      INTEGER ANDF     ,ANYDEF   ,AWRD(2)  ,BFRMS    ,B1       ,BUF1   ,
     1        BUFSIZ   ,CASECC   ,D1       ,D2       ,DEFBUF   ,DEFILE ,
     2        DEFID    ,DIRECT   ,DTYPE    ,DEFLST(2),EOR      ,ELSET  ,
     3        ERR(17)  ,GPSET    ,OES1     ,ORIGIN   ,FOR      ,PARM   ,
     4        PBUFSZ   ,PCON     ,PEDGE    ,PLABEL   ,PLTBUF   ,PLTNUM ,
     5        PLTTAP   ,PLTTYP   ,PORIG    ,PPEN     ,PRNT     ,PRJECT ,
     6        PSET     ,PSYMM    ,PSHAPE   ,PSYMBL   ,PVECTR   ,REW    ,
     7        SETID(1) ,SETD     ,SKPTTL   ,STEREO   ,SUBC(2)  ,SUBCAS ,
     8        TRA      ,WHERE    ,WORD     ,NAME(2)  ,SKPLOD   ,THLID  ,
     9        FSCALE   ,FVP      ,OFFSCL   ,ORG
      INTEGER NF(2)    ,F1(10)   ,F2(20)   ,MSG1(19) ,MSG2(17) ,MF4(6) ,
     1        MSG7(13) ,MF3(3,3) ,USED(10)
      INTEGER ALL      ,BOTH     ,CONTUR   ,DEFO     ,ELEM     ,EPID   ,
     1        KEYWD    ,GRID     ,GSPC     ,LAG(2)   ,MAGC(2)  ,TO     ,
     2        MF1(2,5) ,MF2(2,5) ,POIN     ,RANG     ,RQST(17) ,THRU   ,
     3        TIME
      REAL    FRR(17)  ,MAXDEF
      DOUBLE  PRECISION DWRD
      CHARACTER         UFM*23   ,UWM*25
      COMMON /XMSSG /   UFM      ,UWM
      COMMON / PLTSCR / NCOR, PLTSC(50)
      COMMON /BLANK /   NGP      ,SKP11    ,NSETS    ,PRNT     ,PLTNUM ,
     1        NGPSET   ,ANYDEF   ,SKP12(3) ,PARM     ,GPSET    ,ELSET  ,
     2        CASECC   ,SKP21(3) ,DEFILE(3),MERR     ,SETD     ,SKP31  ,
     3        OES1
      COMMON /SYSTEM/   BUFSIZ   ,NOUT     ,DUMMY(66),ISUBS
      COMMON /OUTPUT/   TITLE(32,3)
      COMMON /PLTDAT/   SKPPLT(20),SKPA(10),PLTTAP
      COMMON /XXPARM/   PBUFSZ   ,CAMERA   ,BFRMS    ,SKPCAM(3),
     1        PENPAP(30),SCALE(4),DEFMAX   ,VIEW(15) ,VANPNT(8),PRJECT ,
     2        PROJCT   ,FOR      ,ORG      ,NORG     ,ORIGIN(11),
     3        SKPPAR(77),NCNTR   ,CNTR(50) ,ICNTVL   ,WHERE    ,DIRECT ,
     4        SUBCAS   ,FLAG     ,DATA     ,SKP19(19),ICOLOR   ,SKP235 ,
     5        OFFSCL
      COMMON /DRWDAT/   PSET     ,PLABEL   ,PORIG    ,PPEN     ,PSHAPE ,
     1        PSYMBL(2),PSYMM(6) ,PVECTR   ,PCON     ,PEDGE    ,OFFLAG
      COMMON /PLOTHD/   IUSED
      EQUIVALENCE       (ERR(1),FRR(1))  , (WORD,AWRD(1),IWRD,FWRD,DWRD)
      EQUIVALENCE       (FSCALE,SCALE(3)), (FVP,VANPNT(1))
      EQUIVALENCE       (SKP19(1), LASSET )
      DATA EOR , INPREW,NOREW,REW,SKPTTL,SKPLOD / 1000000,0,2,1,37,5 /
      DATA SUBC/ 4HSUBC, 4HASES/
      DATA NAME/ 4H  PL, 4HOT  /
C
      DATA NF  / 10, 20 /      ,
     1     F1  / 4H(49X, 4H,4HP, 4HLOT,, 4HI9,2, 4HX,16, 4HHUND, 4HEFOR,
     2           4HMED , 4HSHAP, 4HE)   /       ,
     3     F2  / 4H(10X, 4H,4HP, 4HLOT,, 4HI5,3, 4HX,2(, 4HA4,A, 4H3),I,
     4           4H6,10, 4HH - , 4HSUBC, 4HASE,, 4HI8,3, 4HH - , 4H,A4,,
     5           4H1P,E, 4H15.6, 4H,1X,, 4H6A4,, 4HE11., 4H3)  /
C
C     DATA FOR FORMAT F2 - ORDER CORRESPONDING TO DTYPE, +10=VEL,+20=ACC
C
      DATA MF1 / 4HSTAT, 2HIC  , 4HFREQ, 1H.   , 4HTRAN,2HS.  ,
     1           4HMODA, 1HL   , 4HCMOD, 2HAL  /       ,
     2     MF2 / 4HDEFO, 3HRM. , 4HVELO, 1H.   , 4HACCE,2HL.  ,
     3           4HSTRE, 2HSS  , 4HSTRA, 2HIN  /
      DATA IMOD, LOAD  /         4HMODE, 4HLOAD/
      DATA MF3 / 4H- FR, 4HEQUE, 4HNCY , 4H- EI, 4HGENV,4HALUE,
     1           4H- TI, 2HME  , 1H    /       ,
     2     MF4 / 4H PHA, 4HSE L, 4HAG  , 4H MAG, 4HNITU,2HDE  /
C
      DATA NMSG1,NMSG2,  NMSG7 / 19, 17, 13/   ,
     1     MSG1/ 4H(33X, 4H,26H, 4HAN U, 4HNREC, 4HOGNI, 4HZABL, 4HE OP,
     2           4HTION, 4H (,2, 4HA4,3, 4H1H) , 4HWAS , 4HDETE, 4HCTED,
     3           4H ON , 4HA -P, 4HLOT-, 4H CAR, 4HD)  /       ,
     4     MSG2/ 4H(34X, 4H,21H, 4HA NO, 4HN-EX, 4HISTE, 4HNT O, 4HRIGI,
     5           4HN,I7, 4H,31H, 4H  IS, 4H SPE, 4HCIFI, 4HED O, 4HN A ,
     6           4H-PLO, 4HT- C, 4HARD)/       ,
     7     MSG7/ 4H(33X, 4H,41H, 4H*** , 4HINCO, 4HMPLE, 4HTE P, 4HLOT ,
     8           4HDUE , 4HTO I, 4HNPUT, 4H OR , 4HFILE, 4H.)  /
C
C     SET OPTIONS - FOLLOWING THE SET REQUEST(S)
C
      DATA RQST/ 4HSET , 4HORIG, 4HSHAP, 4HSYMB, 4HLABE, 4HVECT, 4HDENS,
     1           4HPEN , 4HSYMM, 4HANTI, 4HMAXI, 4HOUTL, 4HHIDD, 4HSHRI,
     2           4HNOFI, 4HFILL, 4HOFFS/
C
      DATA USED/ 4H(49X, 4H,6HO, 4HRIGI, 4HN,I7, 4H,19H, 4H  US, 4HED I,
     1           4HN TH, 4HIS P, 4HLOT)/
C
C     THE FOLLOWING ARE POSSIBLE OPTIONS ON THE PLOT CARD
C
      DATA DEFO/ 4HDEFO/, LORIG/ 0     /,
     1     ALL / 3HALL /, TO   / 2HTO  /, THRU/ 4HTHRU/, RANG / 4HRANG/,
     2     TIME/ 4HTIME/, BOTH / 4HBOTH/, GRID/ 4HGRID/, POIN / 4HPOIN/,
     3     ELEM/ 4HELEM/, GSPC / 4HGSPC/, LAG / 4HPHAS , 4HLAG        /,
     4     MAGC/ 4HMAGN , 4HIT.        /, EPID/ 4HEPID/,CONTUR/ 4HCONT/
C
      NCNTR  = 10
      ICNTVL = 1
      WHERE  = 1
      LASSET = 0
      DIRECT = 2
      NCOR   = 50
      DO 1 I = 1, 50
      PLTSC(I) = 0
      CNTR(I)  = 0
1     CONTINUE
      PLTBUF = B1 - PBUFSZ
      DEFBUF = PLTBUF - BUFSIZ
      IF (DEFBUF .LE. 0) GO TO 1400
      V1     =-1.E+30
      V2     =+1.E+30
      PH     = 0.0
      MAG    = 0
      PCON   = 0
      LOADID = 0
      LPCON  = 0
      FLAG   = 0.0
      SUBCAS = 0
      DEFID  = 0
      DISP   =.FALSE.
      STRESS =.FALSE.
      TWOPI  = 8.0*ATAN(1.0)
      NDEF   = 0
      NOGO   = 0
      CALL RDMODX (PARM,MODE,WORD)
C
   10 IF (MODE .LE. 0) CALL RDMODE (*10,*20,*40,MODE,WORD)
   20 CALL RDWORD (MODE,WORD)
C
C     CHECK FOR A DEFORMATION TYPE
C
      DO 30 DTYPE = 1,5
      IF (WORD .EQ. MF1(1,DTYPE)) GO TO 50
   30 CONTINUE
   40 DTYPE = 0
      IF (WORD.NE.CONTUR .OR. MODE.GE.EOR) GO TO 180
      PCON  = 1
      PLTTYP= 1
      GO TO 90
C
C     DEFORMATION TYPE SPECIFIED. CHECK IF ALL ARE TO BE PLOTTED
C
   50 PLTTYP = 1
      IF (MODE .LE. 0) CALL RDMODE (*120,*60,*110,MODE,WORD)
   60 CALL RDWORD (MODE,WORD)
      DO 70 PLTTYP = 1,3
      IF (WORD .EQ. MF2(1,PLTTYP)) GO TO 80
   70 CONTINUE
      PLTTYP = 1
      IF (WORD .NE. CONTUR) GO TO 110
      PCON = 1
      GO TO 80
C
C     ACCEL, VELOCITY ONLY ALLOWED FOR TRANS OR FREQUENCY RESPONSE.
C     NOTE THAT A COMPLEX  IGENVALUE WOULD BE NEEDED FOR -CMODAL-
C
   80 IF ((DTYPE.EQ.2 .OR. DTYPE.EQ.3) .OR. PLTTYP.EQ.1) GO TO 90
      ERR(1) = 2
      ERR(2) = AWRD(1)
      ERR(3) = AWRD(2)
      CALL WRTPRT (MERR,ERR,MSG1,NMSG1)
      PLTTYP = 1
   90 IF (MODE .LE. 0) CALL RDMODE (*120,*100,*110,MODE,WORD)
  100 CALL RDWORD (MODE,WORD)
  110 NDEF = 1
      DEFLST(1) = ALL
      GO TO 180
C
C     THE DEFORMATIONS MAY BE EXPLICITLY LISTED AND/OR A RANGE MAY BE
C     LISTED (I.E., N1,N2 AND/OR N1 -TO/THRU- N2)
C
  120 ASSIGN 130 TO TRA
      GO TO 1450
  130 NDEF = NDEF + 1
      DEFLST(NDEF) = IWRD
      CALL RDMODE (*1450,*140,*170,MODE,WORD)
  140 CALL RDWORD (MODE,WORD)
      IF (MODE.NE.0 .OR. (WORD.NE.TO .AND. WORD.NE.THRU)) GO TO 170
      ASSIGN 150 TO TRA
      CALL RDMODE (*1450,*160,*170,MODE,WORD)
  150 DEFLST(NDEF+1) = TO
      DEFLST(NDEF+2) = IWRD
      NDEF = NDEF + 2
      CALL RDMODE (*120,*160,*170,MODE,WORD)
  160 CALL RDWORD (MODE,WORD)
  170 IF (NDEF.NE.1 .OR. DEFLST(1).NE.0) GO TO 180
      NDEF = 2
      DEFLST(2) = ALL
C
C     ALL THE LISTED DEFORMATION ID-S HAVE BEEN READ
C
  180 DEFLST(NDEF+1) = 0
      IF (MODE .GE. EOR) GO TO 340
C
C     TEST FOR CONTOUR REQUEST
C
  190 IF (WORD .NE. CONTUR) GO TO 240
      IF (PCON .EQ.      0) GO TO 220
  200 ERR(2) = AWRD(1)
      ERR(3) = AWRD(2)
  210 ERR(1) = 2
      CALL WRTPRT (MERR,ERR,MSG1,NMSG1)
      GO TO 320
C
  220 PCON = 1
      IF (DTYPE .EQ. 0) PLTTYP = 1
      IF (NDEF  .NE. 1) GO TO 230
      NDEF = 0
      GO TO 90
  230 IF (MODE .GT. 0) GO TO 320
      ERR(2) = SUBC(1)
      ERR(3) = SUBC(2)
      GO TO 210
C
C     TEST FOR RANGE / TIME  (UNITS=LAMDA,F, OR TIME)
C
  240 IF (WORD.NE.RANG .AND. WORD.NE.TIME) GO TO 270
      IF (PCON.EQ.0 .AND. DTYPE.EQ.1) GO TO 200
      ASSIGN 250 TO TRA
      IF (MODE .GT. 0) GO TO 200
      CALL RDMODE (*1490,*330,*340,MODE,WORD)
  250 V1 = FWRD
      ASSIGN 260 TO TRA
      CALL RDMODE (*1490,*330,*340,MODE,WORD)
  260 V2 = FWRD
      GO TO 320
C
C     TEST FOR PHASE LAG (COMPLEX DATA)
C
  270 IF (WORD .NE. LAG(1)) GO TO 310
      IF (DTYPE.NE.2 .AND. DTYPE.NE.5) GO TO 200
      ASSIGN 300 TO TRA
  280 IF (MODE .LE. 0) CALL RDMODE (*1490,*290,*340,MODE,WORD)
  290 CALL RDWORD (MODE,WORD)
      IF (WORD .EQ. LAG(2)) GO TO 280
      GO TO 340
  300 IF (MAG.EQ.0) PH = FWRD
      GO TO 320
C
C     TEST FOR MAGNITUDE (COMPLEX DATA)
C
  310 IF (WORD .NE. MAGC(1)) GO TO 340
      IF (DTYPE.NE.2 .AND. DTYPE.NE.5) GO TO 200
      IF (PH .EQ. 0.0) MAG = 1
      GO TO 320
C
  320 IF (MODE .LE. 0) CALL RDMODE (*320,*330,*340,MODE,WORD)
  330 CALL RDWORD (MODE,WORD)
      GO TO 190
C
C     READ THE REST OF THE PLOT CARD INTO STORAGE - DEFLST(N1-N2)
C
  340 N1 = NDEF + 1
      N2 = N1 + 1
      IF (MODE .LT. EOR) GO TO 350
      DEFLST(N2) = MODE
      N2 = N2 + 1
      GO TO 400
  350 N  = 0
  360 DEFLST(N2+1) = AWRD(1)
      DEFLST(N2+2) = AWRD(2)
      N2 = N2 + 2
      N  = N  + 1
      IF (MODE .EQ. 0) GO TO 370
      CALL RDWORD (MODE,WORD)
      GO TO 360
  370 N2 = N2 + 1
      DEFLST(N1+1) = N
  380 CALL READ (*1520,*390,PARM,DEFLST(N2),DEFBUF-N2+1,0,N)
      GO TO 1400
  390 N2 = N2 + N
C
C     SAVE LENGTH OF OPEN CORE USED IN IUSED FOR HDPLOT
C
      IUSED = N2 + NSETS
      IF (DEFLST(N2-1) .EQ. 0) GO TO 380
  400 N2 = N2 - 1
C
C     INITIATE THE PLOTS OF THE REQUESTED DEFORMATIONS.
C
      NPLOTS = 0
      IF (PRNT .LT. 0) GO TO 420
      IF (DTYPE.EQ.0 .AND. PCON.EQ.0) GO TO 410
      ANYDEF = 1
      GO TO 1430
C
C     DO THE UNDEFORMED PLOT
C
  410 DEFID  = 0
      DEFBUF = DEFBUF + BUFSIZ
      IF (ISUBS.EQ.0 .AND. .NOT.TAPBIT(PLTTAP)) GO TO 1520
      GO TO 700
  420 IF (DTYPE.EQ.0 .AND. PCON.EQ.0) GO TO 1430
C
C     DO THE DEFORMED PLOT
C
C     STRESS IS TRUE IF CONTOUR REQUEST IS FOR STRESS
C
      LPCON = PCON
      IF (.NOT.TAPBIT(PLTTAP)) GO TO 1520
      IF (PCON.NE.0 .AND. ICNTVL.LE. 9) STRESS = .TRUE.
      IF (PCON.NE.0 .AND. ICNTVL.GT.13) STRESS = .TRUE.
      IF ((PCON.NE.0 .AND. (ICNTVL.GT.9.AND.ICNTVL.LT.14)) .OR.
     1    DTYPE.NE.0) DISP = .TRUE.
      IF (.NOT.DISP) GO TO 470
      MDEF = DEFILE(1)
      IF (DTYPE .GT. 1) MDEF = DEFILE(2)
      IF (DTYPE .GT. 0) GO TO 460
C
C     USER SPECIFIED CONTOUR DISP AND NOT THE TYPE
C     USE FIRST NON-NULL FILE
C
  430 CALL OPEN (*440,MDEF,DEFLST(DEFBUF),INPREW)
      CALL SKPREC (MDEF,1)
      GO TO 450
  440 IF (MDEF .EQ. DEFILE(2)) CALL MESAGE (-1,MDEF,NAME)
      MDEF = DEFILE(2)
      GO TO 430
C
C     SET DTYPE BY MFILE
C
  450 CALL READ (*1390,*1390,MDEF,ERR(1),2,0,I)
      MFILE = MOD(ERR(2),10)
      DTYPE = MFILE
      CALL CLOSE (MDEF,REW)
  460 CONTINUE
C
C     CALCULATE HEADER WORD 2 NEEDED FOR PLOT FILE CHECK
C
      MFILE = DTYPE
      IF (DTYPE .EQ. 3) MFILE = 3 + (PLTTYP-1)*10
C
C     OPEN OES1 AND MDEF
C
      IF (.NOT.DISP) GO TO 470
      CALL OPEN (*1430,MDEF,DEFLST(DEFBUF),INPREW)
      CALL SKPREC (MDEF,1)
  470 IF (.NOT.STRESS) GO TO 500
      CALL OPEN (*1390,OES1,DEFLST(B1),INPREW)
      CALL SKPREC (OES1,1)
      IF (.NOT.DISP) PLTTYP = 4
      CALL FREAD  (OES1,I,1,0)
      CALL BCKREC (OES1)
      I = I/10
      JAPP = I
      IF (DTYPE .NE. 0) GO TO 475
      IF (I.EQ.1 .OR. I.EQ.3 .OR. I.EQ.4 .OR. I.EQ.7 .OR. I.EQ.10)
     1    DTYPE = 1
      IF (I.EQ.2 .OR. I.EQ.8) DTYPE = 4
      IF (I .EQ. 6) DTYPE = 3
C
C     FOR STRESS PLOTS SET -FLAG- SO FNDSET KNOWS WHICH WORD TO COMPARE
C
  475 IF (DTYPE .EQ. 1) GO TO 480
      IF (DTYPE .GT. 1) FLAG = 1.0
      IF (DTYPE .GT. 3) FLAG = 2.0
  480 IF (DTYPE .EQ. 0) GO TO 1410
      IF (.NOT.DISP) DEFBUF = DEFBUF + BUFSIZ
C
C     READ THE PLOT TITLES FOR EACH DEFORMED SHAPE TO BE DRAWN
C
  500 PCON = LPCON
      IF (.NOT.DISP) GO TO 540
  510 CALL READ  (*1385,*1385,MDEF,DEFID,1,0,I)
      CALL FREAD (MDEF,N,1,0)
      IF (N .EQ. MFILE) GO TO 515
      CALL SKPREC (MDEF,1)
      GO TO 530
  515 CONTINUE
      CALL FREAD (MDEF,LOADID,1,0)
      CALL FREAD (MDEF,VALUE, 1,1)
      IF (VALUE.LT.V1 .OR. VALUE.GT.V2) GO TO 530
      DATA   = VALUE
      SUBCAS = DEFID
      N = 1
  520 IF (DEFLST(N) .EQ. ALL) GO TO 540
      CALL INTLST (DEFLST,N,I,D1,D2)
      IF (DEFID.GE.D1 .AND. DEFID.LE.D2) GO TO 540
      IF (N .LT. N1) GO TO 520
  530 CALL SKPREC (MDEF,1)
      GO TO 510
C
C     POSITION OES1 IF NEEDED
C
  540 IF (.NOT.STRESS) GO TO 660
      IF (NPLOTS .NE. 0) CALL OPEN (*1390,OES1,DEFLST(B1),NOREW)
  550 CALL READ (*1385,*1385,OES1,IAPP,1,0,I)
C
C     VERIFY OES1 IS FOR CURRENT DTYPE
C
      IAPP = IAPP/10
      IF (IAPP .NE. JAPP) GO TO 1385
      CALL FREAD (OES1,0,-2,0)
      CALL FREAD (OES1,I,1,0)
      IF (.NOT.DISP ) GO TO 570
      IF (I.NE.DEFID) GO TO 620
  570 SUBCAS = I
      V = VALUE
      CALL FREAD (OES1,ERR(1),4,0)
      IF (DTYPE .EQ. 1) GO TO 575
      IF (DTYPE .GE. 4) GO TO 580
C
C     TRANSIENT
C
      V = FRR(1)
C
C     STATICS
C
  575 J = ERR(4)
      GO TO 590
C
C     MODAL
C
  580 J = ERR(1)
      V = FRR(2)
      IF (DTYPE.EQ.4 .AND. IAPP.EQ.2) V = SQRT(ABS(V))/TWOPI
  590 IF (.NOT.DISP) GO TO 600
C
C     ACCOUNT FOR ROUNDOFF
C
      IF (ABS(V-VALUE) .GT. 1.0E-6) GO TO 620
      DATA = VALUE
      GO TO 650
  600 IF (V.LT.V1 .OR. V.GT.V2) GO TO 620
      DATA = V
      N = 1
  610 IF (DEFLST(N) .EQ. ALL) GO TO 650
      CALL INTLST (DEFLST,N,I,D1,D2)
      IF (SUBCAS.GE.D1 .AND. SUBCAS.LE.D2) GO TO 650
      IF (N .LT. N1) GO TO 610
C
C     WRONG CASE
C
  620 CALL FWDREC (*1410,OES1)
      CALL FWDREC (*1410,OES1)
      GO TO 550
C
C     LOCATED CASE TO PLOT
C
  650 CALL BCKREC (OES1)
      LOADID = J
      DEFID  = SUBCAS
      VALUE  = DATA
C
  660 CALL GOPEN (CASECC,DEFLST(BUF1),INPREW)
  670 CALL READ  (*690,*690,CASECC,N,1,0,I)
      IF (N .EQ. DEFID) GO TO 675
      CALL FREAD (CASECC,0,0,1)
      GO TO 670
  675 CALL FREAD (CASECC,0,-SKPLOD,0)
      CALL FREAD (CASECC,THLID,1,0)
      IF (LOADID .EQ. 0) LOADID = THLID
      SKPTTL = 31
      CALL FREAD (CASECC,0,-SKPTTL,0)
      CALL FREAD (CASECC,TITLE,3*32,0)
      CALL CLOSE (CASECC,REW)
      GO TO 700
  690 CALL CLOSE (CASECC,REW)
      IF (.NOT.DISP) GO TO 550
      CALL FREAD (MDEF,0,0,1)
      GO TO 510
C
C     IDENTIFY THE PLOT
C
  700 PLTNUM = PLTNUM + 1
      IF (STRESS) CALL CLOSE (OES1,NOREW)
      CALL SOPEN (*1430,PLTTAP,DEFLST(PLTBUF),PBUFSZ)
      NCNTR = -IABS(NCNTR)
      IF (NPLOTS .EQ. 0) CALL PLTOPR
      NPLOTS = NPLOTS + 1
      STEREO = 0
      MTYP   = 0
      ERR(2) = PLTNUM
      IF (.NOT.(DISP .OR. STRESS)) GO TO 720
      ERR(3) = MF1(1,DTYPE)
      ERR(4) = MF1(2,DTYPE)
      IF (ICNTVL .EQ. 20) PLTTYP = 4
      ERR(5) = MF2(1,PLTTYP)
      ERR(6) = MF2(2,PLTTYP)
      ERR(7) = DEFID
      ERR(8) = LOADID
      ERR(9) = LOAD
      IF (DTYPE .NE. 1) GO TO 710
      ERR(1) = 8
      GO TO 730
  710 ERR(1) = 12
      IF (DTYPE .GT. 3) ERR(9) = IMOD
      FRR(10) = VALUE
      MTYP = 1
      IF (DTYPE .EQ. 3) MTYP = 3
      IF (DTYPE.EQ.4 .AND. LOADID.LT.0) MTYP = 2
      IF (MTYP .EQ. 2) ERR(8) = -LOADID
      ERR(11) = MF3(1,MTYP)
      ERR(12) = MF3(2,MTYP)
      ERR(13) = MF3(3,MTYP)
      IF (DTYPE.EQ.3 .OR. DTYPE.EQ.4) GO TO 730
      ERR(1) = 15
      M = 0
      IF (MAG .NE. 0) M = 3
      ERR(14) = MF4(M+1)
      ERR(15) = MF4(M+2)
      ERR(16) = MF4(M+3)
      IF (MAG .NE. 0) GO TO 730
      ERR(1)  = 16
      FRR(17) = PH
      GO TO 730
  720 ERR(1) = 1
      CALL WRTPRT (MERR,ERR,F1,NF(1))
      GO TO 740
  730 CALL WRTPRT (MERR,ERR,F2,NF(2))
  740 CALL STPLOT (PLTNUM)
      CALL HEAD (DTYPE,PLTTYP,MTYP,ERR)
C
C     PLOT EACH SET REQUESTED. INTERPRET THE ASSOCIATED REQUESTS.
C
  750 CALL RDMODY (DEFLST(N1+1),MODE,WORD)
      MODE   = 0
      MAXDEF = 0.
      PORIG  = 1
      PPEN   = 1
      PSET   = 0
  760 PLABEL = -1
      PCON   = LPCON
      PSHAPE = 1
      PVECTR = 0
      OFFLAG = 0
      PEDGE  = 0
      PSYMBL(1) = 0
      PSYMBL(2) = 0
      PSYMM(1) = 1
      PSYMM(2) = 1
      PSYMM(3) = 1
      PSYMM(4) = 1
      PSYMM(5) = 1
      PSYMM(6) = 1
  780 IF (MODE .LE. 0) CALL RDMODE (*780,*790,*1180,MODE,WORD)
  790 CALL RDWORD (MODE,WORD)
C
C     CHECK FOR THE KEYWORD. THIS MAY BE FOLLOWED BY QUALIFIERS
C
  800 CONTINUE
      DO 802 KEYWD = 1,17
      IF (WORD .EQ. RQST(KEYWD)) GO TO 804
  802 CONTINUE
      GO TO 1170
  804 GO TO (1080, 910, 960, 990, 830,1060, 810, 810,1020,1020,
     1        880,1140,1148,1142,1175, 805,1160), KEYWD
C
C             SET ORIG SHAP SYMB LABE VECT DENS  PEN SYMM ANTI
C    1       MAXI OUTL HIDD SHRI NOFI FILL OFFS
C
C     FILL ELEMENTS BY SET HERE
C     FILL PRESENTLY DOES NOT WORK TOGETHER WITH SHRINK AND HIDDEN
C
  805 PPEN  = PPEN + 31
      PEDGE = 100
      GO TO 780
C
C     DENSITY I, PEN I
C
  810 IF (MODE .NE. 0) GO TO 1170
      ASSIGN 820 TO TRA
      GO TO 1440
  820 PPEN = IWRD
      GO TO 780
C
C     LABEL GRID / ELEMENTS
C
  830 PLABEL = 0
      IF (MODE .LE. 0) CALL RDMODE (*780,*840,*1180,MODE,WORD)
  840 CALL RDWORD (MODE,WORD)
      IF (WORD .EQ. BOTH) GO TO 870
      IF (WORD .EQ. ELEM) GO TO 860
      IF (WORD .NE. GRID) GO TO 872
      IF (MODE .LE. 0) CALL RDMODE (*780,*850,*1180,MODE,WORD)
  850 CALL RDWORD (MODE,WORD)
      IF (WORD-POIN) 800,780,800
  860 PLABEL = 3
      GO TO 780
  870 PLABEL = 6
      GO TO 780
  872 IF (WORD .EQ. GSPC) PLABEL = 1
      IF (WORD .EQ. EPID) PLABEL = 4
      IF (PLABEL .NE.  0) GO TO 780
      GO TO 800
C
C     MAXIMUM DEFORMATION X.X
C
  880 CONTINUE
      ASSIGN 900 TO TRA
      IF (MODE .LE. 0) CALL RDMODE (*1490,*890,*1180,MODE,WORD)
  890 CALL RDWORD (MODE,WORD)
      IF (WORD.NE.DEFO .OR. MODE.NE.0) GO TO 800
      GO TO 1480
  900 MAXDEF = ABS(FWRD)
      GO TO 780
C
C     ORIGIN I
C
  910 IF (MODE .NE. 0) GO TO 1170
      ASSIGN 920 TO TRA
      GO TO 1440
  920 DO 930 I = 1,ORG
      IF (ORIGIN(I) .EQ. IWRD) GO TO 940
  930 CONTINUE
      IF (STEREO .NE. 0) GO TO 780
      ERR(1) = 1
      ERR(2) = IWRD
      CALL WRTPRT (MERR,ERR,MSG2,NMSG2)
      GO TO 780
  940 PORIG  = I
      GO TO 780
C
C     SHAPE
C
  960 IF (PEDGE .NE. 0) GO TO 1170
      IF ((.NOT.(DISP .OR. STRESS) .AND. DTYPE .NE. 0)) GO TO 1170
      IF (.NOT.DISP) GO TO 780
      PSHAPE = 2
      DO 970 I = 1,NDEF
      IF (DEFLST(I) .EQ. 0) GO TO 980
  970 CONTINUE
      GO TO 780
  980 PSHAPE = 3
      GO TO 780
C
C     SYMBOL I,I
C
  990 PSYMBL(1) = 1
      IF (MODE .NE. 0) GO TO 1170
      ASSIGN 1010 TO TRA
      I = 0
 1000 I = I + 1
      GO TO 1440
 1010 PSYMBL(I) = IWRD
      IF (I-2) 1000,780,780
C
C     SYMMETRY B / ANTISYMMETRY B
C
 1020 N = 1
      IF (KEYWD .EQ. 10) N = -1
      IF (MODE  .LE.  0) GO TO 1170
      CALL RDWORD (MODE,WORD)
      CALL INTVEC (WORD)
      IF (WORD.LT.1 .OR. WORD.GT.7) GO TO 1170
      DO 1050 I = 1,3
      PSYMM(I) = 1
      IF (ANDF(WORD,2**(I-1)) .NE. 0) PSYMM(I) = -1
      PSYMM(I+3) = N*PSYMM(I)
 1050 CONTINUE
      GO TO 780
C
C     VECTOR B
C
 1060 IF (.NOT.DISP .OR. MODE .EQ. 0) GO TO 1170
      CALL RDWORD (MODE,WORD)
      PVECTR = WORD
      GO TO 780
C
C     SET -  SAVE FIRST ENCOUNTERED, DO PLOT WHEN EOR OR ANOTHER SET
C
 1080 IF (MODE .NE. 0) GO TO 1170
      ASSIGN 1090 TO TRA
      GO TO 1440
 1090 IWRD = IABS(IWRD)
      DO 1100 I = SETD,NSETS
      IF (IWRD .EQ. SETID(I)) GO TO 1120
 1100 CONTINUE
      IF (STEREO .NE. 0) GO TO 1110
      WRITE  (NOUT,1105) UFM,IWRD
 1105 FORMAT (A23,' 700, SET',I9,' REQUESTED ON PLOT CARD HAS NOT BEEN',
     1       ' DEFINED.')
      NOGO = 1
 1110 IWRD = SETD
      GO TO 1130
 1120 IWRD = I
 1130 IF (PSET .NE. 0) GO TO 1180
      PSET = IWRD
      GO TO 780
C
C     OUTLINE
C
 1140 IF (PSHAPE .NE. 1) GO TO 1170
      IF (PCON   .EQ. 0) GO TO 780
      PEDGE = 1
      GO TO 1149
C
C     SHRINK
C
 1142 IF (PEDGE .NE. 2) PEDGE = 75
      IF (PEDGE .EQ. 2) PEDGE = 75 + 200
C                           SHRINK + HIDDEN
C
      IF (MODE .GT. 0) GO TO 780
      CALL RDMODE (*1144,*1143,*1180,MODE,WORD)
 1143 CALL RDWORD (MODE,WORD)
      GO TO 1149
 1144 IF (MODE.EQ.-2 .AND. FWRD.GT.0.0 .AND. FWRD.LE.1.0) GO TO 1147
      WRITE  (NOUT,1145) UWM
 1145 FORMAT (A25,', INPUT VALUE ERROR FOR SHRINK.  0.85 IS SUBSTITUED')
      IF (MODE .EQ. -1) WRITE (NOUT,1146) IWRD
 1146 FORMAT (5X,'FOR INTEGER VALUE',I5)
      FWRD = 0.85
 1147 J = FWRD*100
      IF (J .LT.  10) J =  10
      IF (J .GT. 100) J = 100
      IF (PEDGE .NE. 2) PEDGE = J
      IF (PEDGE .EQ. 2) PEDGE = J + 200
C                          SHRINK + HIDDEN
C
      GO TO 1149
C
C     HIDDEN
C
 1148 IF (PEDGE .LT. 10) PEDGE = 2
      IF (PEDGE.GE.10 .AND. PEDGE.LE.100) PEDGE = 200 + PEDGE
C                                              HIDDEN + SHRINK
 1149 IF (.NOT.DISP) GO TO 780
      DO 1150 I = 1,NDEF
      IF (DEFLST(I) .EQ. 0) GO TO 1155
 1150 CONTINUE
      PSHAPE = 2
      GO TO 780
 1155 PSHAPE = 3
      GO TO 780
C
C     OFFSET n
C     TURN OFFSET PLOT ON  IF n IS .GE. 0. +n IS MAGNIFYING FACTOR
C     TURN OFFSET PLOT OFF IF n IS .LT. 0
C
C
 1160 IF (MODE .NE. 0) GO TO 1170
      ASSIGN 1165 TO TRA
      GO TO 1440
 1165 OFFSCL = IWRD
      IF (OFFSCL .GE. 0) PEDGE = 3
      GO TO 780
C
C     UNRECOGNIZABLE OPTION ON THE -PLOT- CARD.
C
 1170 IF (STEREO .NE. 0) GO TO 780
      ERR(1) = 2
      ERR(2) = AWRD(1)
      ERR(3) = AWRD(2)
      CALL WRTPRT (MERR,ERR,MSG1,NMSG1)
      GO TO 780
C
C     NOFIND
C
C     COMMENTS FROM G.CHAN/UNISYS  11/1990
C     THE 'NOFIND' FEATURE IN NASTRAN PLOTTING COMMANDS IS REALLY NOT
C     NEEDED. IT ONLY LIMITS TO PREVIOUS PLOT CASE. THE FOLLOWING TWO
C     EXAMPLES GIVE EXACTLY THE SAME RESULT IN $ PLOT 2
C
C     $ PLOT 1                           $ PLOT 1
C     FIND SCALE, ORIGIN 100, SET 2      FIND SCALE, ORIGIN 100, SET 2
C     PLOT ORIGIN 100                    PLOT ORIGIN 100
C     $ PLOT 2                           $ PLOT 2
C     PLOT ORIGIN 100                    PLOT NOFIND
C       :
C     (NOTE - ORIGIN 100 IS STILL AVAILABLE
C      IN ANY FOLLOWING PLOT)
C     $ PLOT N
C     PLOT ORIGIN 100
C
 1175 NOFIND = +1
      IF (LORIG .EQ. 0) GO TO 1530
      PORIG  = LORIG
      GO TO 780
C
C
 1180 IF (NOFIND .GE. 0) GO TO 1185
      IF (FSCALE.NE.0 .OR. FOR.NE.0) GO TO 1182
      IF (PRJECT.EQ.1 .OR. FVP.EQ.0) GO TO 1185
 1182 FORG  = 1
      FSCALE= 1
      ISETD = SETD
      SETD  = MAX0(SETD,PSET)
      MODEX = MODE
      MODE  = -1
      ORG   = MAX0(1,ORG)
      CALL FIND (MODE,BUF1,B1,SETID,DEFLST)
      NOFIND= +1
      SETD  = ISETD
      MODE  = MODEX
C
C     PLOT THIS SET
C
 1185 IF (.NOT.DISP) GO TO 1210
      IF (PVECTR.NE.0 .OR. PSHAPE.NE.1 .OR. PEDGE.NE.0) GO TO 1210
      IF (PCON.NE.0 .AND. ICNTVL.GT. 9) GO TO 1210
      IF (PCON.NE.0 .AND. ICNTVL.GT.13) GO TO 1210
C
C     CREATE A DEFAULT OF SHAPE OR SHAPE + UNDERLAY
C
      DO 1190 I = 1,NDEF
      IF (DEFLST(I) .EQ. 0) GO TO 1200
 1190 CONTINUE
      PSHAPE = 2
      GO TO 1210
 1200 PSHAPE = 3
 1210 PSET = MAX0(PSET,SETD)
C
C     DEFAULT OF FIRST DEFINED SET WILL BE USED
C
      CALL GOPEN  (GPSET,DEFLST(B1),INPREW)
      CALL SKPREC (GPSET,PSET)
      CALL FREAD  (GPSET,NGPSET,1,0)
C
C     TEST FOR CORE NEEDED FOR BOTH UNDEF, DEFOR PLOTS, GRID INDEX
C
      I1 = N2 + NGP + 1
C
C     UNDEFORMED COORDINATES
C
      I2 = I1 + 3*NGPSET
C
C     DEFORMATION VALUES
C
      I3 = I2 + 3*NGPSET
C
C     REDUCE CORE FOR UNDEFORMED PLOTS
C
      IF (DISP) GO TO 1230
      I3 = I2
      N  = 0
      GO TO 1240
C
C     DEFORMED PLOTS NEED X-Y LOCATIONS OF RESULTANT DEFLECTIONS ON
C     FRAME
C
 1230 N = 2*NGPSET
C
 1240 IF (I3+N-1 .GE. DEFBUF) GO TO 1400
      IUSED = MAX0(I3+N-1,IUSED+NGP)
C
      CALL FREAD (GPSET,DEFLST(N2+1),NGP,0)
      CALL CLOSE (GPSET,REW)
      CALL FNDSET (DEFLST(N2+1),DEFLST(I1),BUF1-N2,0)
C
      CALL GOPEN (ELSET,DEFLST(B1),INPREW)
      IF (PSET .EQ. 1) GO TO 1280
      CALL SKPREC (ELSET,PSET-1)
C
 1280 IF (.NOT.STRESS) GO TO 1290
      IF (ICNTVL.LT.4 .OR. DIRECT.NE.2) GO TO 1290
      I = B1 + BUFSIZ
      CALL CLOSE (PARM,NOREW)
      CALL GOPEN (OES1,DEFLST(I),NOREW)
C
      CALL ROTAT (ELSET,BUF1-N2,DEFLST(N2+1),DEFLST(I1))
C
      CALL CLOSE (OES1,NOREW)
      CALL GOPEN (PARM,DEFLST(I),NOREW)
C
 1290 IF (.NOT.DISP) GO TO 1320
C
C     CONVERSION FOR ACCEL OR VELOCITY
C
      CONV = 1.0
      IF (PLTTYP .EQ. 1) GO TO 1310
      IF (PLTTYP.EQ.3 .OR. PLTTYP.EQ.4) GO TO 1300
C
C     VELOCITY
C
      CONV = VALUE*TWOPI
      GO TO 1310
C
C     ACCEL
C
 1300 CONV = (VALUE*TWOPI)**2
 1310 I = 3*BUFSIZ + B1
      PH1 = PH * TWOPI/360.0
      CALL GETDEF (MDEF,PH1,MAG,CONV,PLTTYP,DEFLST(I),DEFLST(N2+1),
     1             DEFLST(I2))
C                  FILE PH  MAG   W   RESP   BUF(1)     GPLST
C                  DEFLECTION
C
C     PRINT THE MAXIMUM FOUND ON THE PLOT FILE
C
      IF (MODE.GE.EOR .AND. ICOLOR.EQ.0) CALL HEAD (0,0,-1,DEFMAX)
      ASSIGN 1320 TO INCOM
      IF (MAXDEF .NE. 0.0) DEFMAX = MAXDEF
      IF (DEFMAX.EQ.0.0 .OR. SCALE(4).EQ.0.0) GO TO 1420
C
C                GPLST       ,X         ,U         ,S         ,
 1320 CALL DRAW (DEFLST(N2+1),DEFLST(I1),DEFLST(I2),DEFLST(I3),
     1           DISP,STEREO,DEFBUF-(I3+N),BUF1-N2)
C
C     NOTE - THE NEXT TO LAST ARGUMENT, DEFBUF-(I3+N), IS THE SIZE OF
C            AVAILABLE OPEN CORE. IT IS NOT A POINTER, AND IT IS NOT AN
C            OPEN CORE ARRAY
C
C     OPEN CORE /ZZPLOT/
C     SETID NSETS NDOF      NGP 3*NGPSET 3*NGPSET SCRATCH  N
C     -----+-----+----+----+---+--------+--------+-------+--+--+-+-+-+-+
C          !          N1   N2  I1 (X)   I2 (U)   I3 (S)   DEFBUF ..BUF..
C          !(DEFLST)         /
C                       (GPLST)                      N=2*NGPSET
C
      CALL CLOSE (ELSET,REW)
      IF (MODE .GE. EOR) GO TO 1360
      IF (.NOT.DISP) GO TO 1350
      CALL BCKREC (MDEF)
 1350 PSET = IWRD
      IF (.NOT.STRESS) GO TO 760
C
C     POSITION OES1
C
      I = 1
      ASSIGN 1360 TO INCOM
      CALL FNDSET (DEFLST(N2+1),DEFLST(I1),BUF1-N2,I)
      IF (I .EQ. 1) GO TO 760
      GO TO 1420
C
C     END OF A DEFORMATION
C
 1360 CALL STPLOT (-1)
      IF (PRJECT.NE.3 .OR. STEREO.NE.0) GO TO 1380
      STEREO = 1
      CALL SOPEN (*1430,PLTTAP,DEFLST(PLTBUF),PBUFSZ)
      J = BFRMS
      BFRMS = 2
      CALL STPLOT (PLTNUM)
      BFRMS  = J
      PLTNUM = PLTNUM + 1
      IF (.NOT.DISP) GO TO 1370
      CALL BCKREC (MDEF)
 1370 IF (.NOT.STRESS) GO TO 750
C
C     POSITION OES1
C
      I = 1
      ASSIGN 1360 TO INCOM
      CALL FNDSET (DEFLST(N2+1),DEFLST(I1),BUF1-N2,I)
      IF (I .NE. 1) GO TO 1420
      GO TO 750
 1380 IF (DISP .OR. STRESS) GO TO 500
C
C     END OF THIS PLOT CARD.
C
 1385 IF (STRESS) CALL CLOSE (OES1,REW)
 1390 IF (DISP  ) CALL CLOSE (MDEF,REW)
      GO TO 1430
C
C     INSUFFICIENT CORE TO START PROCESSING
C
 1400 CALL MESAGE (-8,DEFBUF,NAME)
C
 1410 CONTINUE
      GO TO 1385
C
C     INCOMPLETE PLOT RESULTED
C
 1420 ERR(1) = 0
      CALL WRTPRT (MERR,ERR,MSG7,NMSG7)
      GO TO INCOM, (1360,1320)
C
C     FINISHING ONE PLOT
C     ECHO OUT WHICH ORIGIN WAS USED
C
 1430 IF (NOGO  .NE. 0) CALL MESAGE (-61,0,0)
      IF (PORIG .EQ. 0) GO TO 1550
      ERR(1) = 1
      ERR(2) = ORIGIN(PORIG)
      CALL WRTPRT (MERR,ERR,USED,10)
      CALL WRITE (MERR,0,0,1)
      LORIG = PORIG
      PORIG = 0
      GO TO 1550
C
C     READ AN INTEGER VALUE FROM THE -PLOT- CARD
C
 1440 CALL RDMODE (*1450,*790,*1180,MODE,WORD)
 1450 IF (MODE .EQ. -1) GO TO 1470
      IF (MODE .EQ. -4) GO TO 1460
      IWRD = FWRD
      GO TO 1470
 1460 IWRD = DWRD
 1470 GO TO TRA, (130,150,820,920,1010,1090,1165)
C
C     READ A REAL VALUE FROM THE -PLOT- CARD
C
 1480 CALL RDMODE (*1490,*790,*1180,MODE,WORD)
 1490 IF (MODE .EQ. -4) GO TO 1500
      IF (MODE .EQ. -1) FWRD = IWRD
      GO TO 1510
 1500 FWRD = DWRD
 1510 GO TO TRA, (250,260,900,300)
C
 1520 WRITE  (NOUT,1525) UFM,PLTTAP
 1525 FORMAT (A23,' 702, PLOT FILE ',A4,' DOES NOT EXIST.')
      NOGO = 1
      GO TO 1390
 1530 WRITE  (NOUT,1535) UWM,LORIG
 1535 FORMAT (A25,' 704, NO PREVIOUS PLOT TO INITIATE NOFIND OPERATION')
C
 1550 RETURN
      END

      SUBROUTINE BDAT01
C
C     THIS SUBROUTINE PROCESSES CONCT1 BULK DATA GENERATING
C     CONNECTION ENTRIES IN TERMS OF GRID POINT ID NUMBERS
C     CODED TO THE PSEUDO-STRUCTURE ID NUMBER.
C     THESE ARE THEN WRITTEN ON SCR1.
C
      EXTERNAL        RSHIFT,ANDF
      LOGICAL         TDAT,PRINT
      INTEGER         IO(9),ID(14),IS(7),IC(7),SCR1,CONSET,GEOM4,AAA(2),
     1                FLAG,BUF1,CONCT1(2),BUF2,OUTT,ANDF,RSHIFT,COMBO
      DIMENSION       IBITS(32),JBITS(32),NAME(14),IHD(16)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /CMB001/ SCR1,SCR2,SCBDAT,SCSFIL,SCCONN,SCMCON,SCTOC,
     1                GEOM4,CASECC
      COMMON /ZZZZZZ/ Z(1)
      COMMON /CMB002/ BUF1,BUF2,BUF3,BUF4,BUF5,SCORE,LCORE,INPT,OUTT
      COMMON /CMB003/ COMBO(7,5),CONSET,IAUTO,TOLER,NPSUB,CONECT,TRAN,
     1                MCON,RESTCT(7,7),ISORT,ORIGIN(7,3),IPRINT
      COMMON /CMB004/ TDAT(6)
      COMMON /CMBFND/ INAM(2),IERR
      COMMON /OUTPUT/ ITITL(96),IHEAD(96)
      COMMON /BLANK / STEP,IDRY
      DATA    AAA   / 4HBDAT,4H01     / , CONCT1 / 110,41 /
      DATA    IHD   / 4H  SU , 4HMMAR , 4HY OF , 4H CON , 4HNECT ,
     1                4HION  , 4HENTR , 4HIES  , 4HSPEC , 4HIFIE ,
     2                4HD BY , 4H CON , 4HCT1  , 4HBULK , 4H DAT ,
     3                4HA    /
      DATA    IBLNK / 4H     /
C
      DO 10 I = 1,96
      IHEAD(I) = IBLNK
   10 CONTINUE
      J = 1
      DO 15 I = 73,88
      IHEAD(I) = IHD(J)
   15 J = J + 1
      PRINT = .FALSE.
      IF (ANDF(RSHIFT(IPRINT,2),1) .EQ. 1) PRINT = .TRUE.
      NP2 = 2*NPSUB
      DO 20 I = 1,NP2,2
      J = I/2 + 1
      NAME(I  ) = COMBO(J,1)
      NAME(I+1) = COMBO(J,2)
   20 CONTINUE
      IFILE = SCR1
      CALL OPEN (*320,SCR1,Z(BUF2),1)
      CALL LOCATE (*400,Z(BUF1),CONCT1,FLAG)
      IFILE = GEOM4
   30 CALL READ (*300,*210,GEOM4,ID,2,0,N)
      NSS   = ID(1)
      NSSP1 = NSS + 1
      IF (ID(2) .EQ. CONSET) GO TO 50
   40 CALL READ (*300,*310,GEOM4,ID,1,0,NNN)
      IF (ID(1) .NE. -1) GO TO 40
      GO TO 30
   50 NWD = 2*NSS
      IF (.NOT.PRINT) GO TO 70
      CALL PAGE
      CALL PAGE2 (6)
      WRITE  (OUTT,60) (NAME(KDH),KDH=1,NP2)
   60 FORMAT (/24X,74HNOTE  GRID POINT ID NUMBERS HAVE BEEN CODED TO THE
     1 COMPONENT SUBSTRUCTURE, /30X,75HWITHIN A GIVEN PSEUDOSTRUCTURE BY
     2 - 1000000*COMPONENT NO. + ACTUAL GRID ID.,//15X,22HCONNECTED   CO
     3NNECTION,23X,33HGRID POINT ID FOR PSEUDOSTRUCTURE, /18X,3HDOF,9X,
     44HCODE,3X,7(3X,2A4)/)
   70 CONTINUE
C
C     MAKING IT TO 50 IMPLIES THAT CONCT1 DATA EXISTS
C
      TDAT(1) = .TRUE.
      CALL READ (*300,*310,GEOM4,ID,NWD,0,NNN)
      DO 90 I = 1,NSS
      J = 2*(I-1)
      CALL FINDER (ID(1+J),IS(I),IC(I))
      IF (IERR .NE. 1) GO TO 90
      WRITE  (OUTT,80) UFM,ID(1+J),ID(2+J)
   80 FORMAT (A23,' 6522, THE BASIC SUBSTRUCTURE ',2A4, /30X,
     1       'REFERED TO BY A CONCT1 BULK DATA CARD CAN NOT BE FOUND ',
     2       'IN THE PROBLEM TABLE OF CONTENTS.')
      IDRY = -2
   90 CONTINUE
  100 DO 110 I = 1,9
  110 IO(I) = 0
      DO 120 I = 1,NSSP1
      CALL READ (*300,*310,GEOM4,ID(I),1,0,NNN)
      IF (ID(I) .EQ. -1) GO TO 30
  120 CONTINUE
      DO 140 I = 1,NSS
      DO 130 J = 1,NSS
      IF (I .EQ. J) GO TO 130
      IF (IS(I).EQ.IS(J) .AND. ID(I+1).NE.0 .AND. ID(J+1).NE.0)
     1    GO TO 150
  130 CONTINUE
  140 CONTINUE
      GO TO 170
  150 KK = 2*IS(I) - 1
      WRITE  (OUTT,160) UFM,ID(I+1),ID(J+1),NAME(KK),NAME(KK+1)
  160 FORMAT (A23,' 6536, MANUAL CONNECTION DATA IS ATTEMPTING TO ',
     1       'CONNECT', /31X,'GRID POINTS',I9,5X,4HAND ,I8, /31X,
     2       'WHICH ARE BOTH CONTAINED IN PSEUDOSTRUCTURE ',2A4)
      IDRY = -2
  170 CALL ENCODE (ID(1))
      IO(1) = ID(1)
      ISUM  = 0
      DO 180 I = 1,NSS
      IF (ID(I+1) .EQ. 0) GO TO 180
      IF (ID(I+1) .NE. 0) ISUM = ISUM + 2**(IS(I)-1)
      M = 2 + IS(I)
      IO(M) = IC(I)*1000000 + ID(I+1)
  180 CONTINUE
      IO(2) = -1*ISUM
      NWD   = 2 + NPSUB
      CALL WRITE (SCR1,IO,NWD,1)
      IF (.NOT.PRINT .OR. IDRY.EQ.-2) GO TO 200
      CALL BITPAT (IO(1),IBITS)
      CALL BITPAT (IABS(IO(2)),JBITS)
      CALL PAGE2 (1)
      WRITE (OUTT,190) (IBITS(KDH),KDH=1,2),(JBITS(KDH),KDH=1,2),
     1                 (IO(KDH+2),KDH=1,NPSUB)
  190 FORMAT (16X,A4,A2,6X,A4,A3,2X,7(3X,I8))
  200 CONTINUE
      GO TO 100
  210 CONTINUE
      GO TO 400
C
  300 IMSG = -2
      GO TO 330
  310 IMSG = -3
      GO TO 330
  320 IMSG = -1
  330 CALL MESAGE (IMSG,IFILE,AAA)
  400 CALL CLOSE  (SCR1,2)
      RETURN
      END

      PROGRAM NASTPLOT        
C        
CDC   PROGRAM NASPLOT (INPUT,OUTPUT,TAPE5=INPUT,TAPE6=OUTPUT,           
CDC                    TAPE13,TAPE14,TAPE15,TAPE16,TAPE17)              
C        
C     A STAND-ALONE TRANSLATOR PROGRAM (NASTPLOT or NASPLOT) TO        
C     INTERPRET THE NASTRAN GENERAL PURPOSE PLOTTER FILE (OR TAPE)      
C        
C     THIS ROUTINE SHOULD NOT BE COMPILED AND INCLUDED IN NASTRAN       
C     LIBRARY        
C     THIS NASTPLOT PACKAGE INCLUDES THE FOLLOWING SUBROUTINES/AND      
C     ENTRY POINTS        
C        
C          GETCMD, DRWAXS/ENDAXS, DRWKHR/ENDCHR, DRWLIN/ENDLIN,        
C          TXNPEN, TXINIT/TXFINS, TXPLOT, PSINIT/PSFINS/PSTRKE,        
C          PSLINE, PSCHAR/PSENDC        
C     IF TEKTRONIX PLOT-10 TCS AND ADVANCED GRAPHING II PACKAGES ARE    
C     AVAILABLE IN THE COMPUTER SYSTEM. THE NEXT SUBROUTINES ARE USED   
C          NASTEK, PFRAME 
C     (ACTIVATE NASTEK AND PFRAME BY REPLACE C+ BY 2 BLANKS IN FIRST 2
C     COLUMNS OF TEXT BELOW)        
C        
C     IF PLOT-10 AND ADVANCED GRAPHING II ARE NOT AVAILABLE, THE LINES  
C     BETWEEN LABELS 250 AND 260 SHOULD BE COMMENTED OUT OR DELETED.    
C        
C     INPUT FILE: NASTRAN PLT1 OR PLT2 FILE        
C     PLOTTER   : TEKTRONIX OR POSTSCRIPT FILE(S)        
C        
C     ***************************************************************   
C     *   DO NOT COMPILE THIS PROGRAM NOR INSERT ALL RELOCATABLES   *   
C     *   INTO NASTRAN LIBRARY                                      *   
C     *   (HOWEVER. IT DOES NO HARM)                                *   
C     ***************************************************************   
C        
C     THE PLOTTING SECTION OF THIS PROGRAM IS PLOTTER DEPENDENT.        
C     CURRENTLY TEKTRONIX PLOTTER OR POSTSCRIPT PRINTER ARE USED.       
C     ALL SUPPORTING ROUTINES WITH PREFIX 'TX' ARE TEKTRONIX ASSOCIATED 
C     AND THOSE WITH PREFIX 'PS' ARE POSTSCRIPT ASSOCIATED. THE 'PS'    
C     ROUTINES USE ONLY STANDARD FORTRAN COMMANDS.        
C        
C     SUBROUTINE GETCMD IS USED ONLY WHEN MACHINE THAT GENERATED THE    
C     PLOT FILE AND THE MACHINE THAT IS NOW READING THE PLOT FILE HAVE  
C     DIFFERENT NUMBER OF BITS PER COMPUTER WORD.        
C     CURRENTLY GETCMD IS NOT WORKING.        
C        
C     A PC VERSION (MS-DOS/BASIC WITH GRAHPIC) IS ALSO AVAILABLE WHICH  
C     USES ONLY PLT1 FILE. NO SPECIAL HARDWARE OR SOFTWARE ARE NEEDED.  
C        
C     WRITTEN BY G.CHAN/UNISYS, 3/1991        
C        
C        
C     THE '$' ON A FORMAT LINE IS VAX SPECIAL. IT SHOULD BE DELETED IN  
C     ALL NON-VAX MACHINES.        
C        
C     VAX ONLY: SEE THE OPEN STATEMENT AFTER STA. 600 FOR STANDARD OUT- 
C     PUT LIST FILE.        
C        
C     CDC ONLY: DELETE THE 'EOF' ON-LINE FUNCTION,        
C               RE-ACTIVATE THE ON-LINE 'ISHFT' FUNCTION BELOW, AND     
C               SET 'AA' AND 'BB' TO REAL, NOT D.P.        
C        
      IMPLICIT INTEGER (A-Z)        
      LOGICAL      CHRSET,LINSET,AXSSET,VAX,IBM,TEK,PSC,NOTYET,FOUND,   
     1             ADOT,LUX,DEBUG        
      INTEGER      Z(3000),W(30)        
      REAL         XFACT,YFACT,XSIZE,YSIZE,SX,SY,SCALE,CSCAL        
      REAL*8       AA,BB        
CCDC  REAL         AA,BB        
      CHARACTER*1  TEMP,ESC,NUMB1(10),CHR1(5),BLNK1,STP1,NXT1,NA1(32),  
     1             KD,KP,KL,KT,K1,K2,KB,KI,KU,KC,KV,KX,KY,KP1,KL1,KT1,  
     2             K12,KN1,KS1,KH,STR,AL1,KA1,KR1,KNUM(2),KNUM1,BELL,   
     3             KQ1,DorS,A1Z(26)        
      CHARACTER*4  NAM4,BLNK4,STOP4,CHR4        
      CHARACTER*32 NAM32,MACH32,MACH33        
      CHARACTER    CLEAR*2,KNUM2*2,MACH3*3,XX3*3,NUMB10*10,DATE13*13,   
     1             FMT500*8,A2Z*26        
      COMMON       CMND,CNTRL,R,S,T,U,XFACT,YFACT,XMAX,YMAX,XHI,YHI,    
     1             XLO,YLO,PENCHG,PENCNT,OLDPEN,PENNO(99)        
      COMMON /IO/  IN,NOUT        
      COMMON /EC/  ESC,CLEAR        
      COMMON /QQ/  BI,BO,WRD,BYT,DUM(22)        
      COMMON /PS/  LU,SCALE,JOUNT,NBUFF,ONCE,CSCAL,CHRPOS        
      EQUIVALENCE  (NUMB1(1),NUMB10), (BLNK4,BLNK1), (CHR1(1),CHR4),    
     1             (NAM4,NAM32,NA1(1)), (MACH3,MACH32), (Z(1),W(1)),    
     2             (KNUM(1),KNUM1,KNUM2), (A1Z(1),A2Z)        
      DATA         CHRSET,LINSET,AXSSET,TEK,PSC  / 5*.FALSE.     /,     
     1             NOLINE,SELECT,PLOTID,DEBUG / 2*0, -1, .TRUE.  /,     
     2             XSIZE,YSIZE,YES,NO,KQ1 / 1.2, 1., 1HY,1HN, 'q'/,     
     3             STR,BLNK4,NUMB10 / '*', '    ',  '1234567890' /,     
     4             AA,BB,FMT500     / 1.D-21, 1.D-25, '(3000A1)' /,     
     5             STP1,NXT1,DATE13 / 'S', 'N', 'OCT. 27, 1990'  /,     
     6             KD,KP,KL,KT,KB   / '.', 'P', 'L', 'T', ' '    /,     
     7             KH,KP1,KL1,KT1,K1/ 'H', 'p', 'l', 't', '1'    /,     
     8             KI,KU,KC,KV,KX   / 'I', 'U', 'C', 'V', 'X'    /,     
     9             KY,K2,XX3,AL1,KA1/ 'Y', '2', 'UNX','A','a'    /,     
     O             KN1,KS1,SYY,SNN  / 'n', 's', 1Hy, 1Hn         /,     
     1             T4,T3,T2,T1,KR1  / 10000,  1000, 100, 10, 'R' /,     
     2             MACH32   / 'VAX/TEKTRONIX COMPUTER GRAPHIC  ' /,     
     3             MACH33   / 'VAX/POSTSCRIPT COMPUTER GRAPHIC ' /,     
     4             STOP4,A2Z/ 'STOP','ABCDEFGHIJKLMNOPQRSTUVWXYZ'/,     
     5             DorS     / '.'                                /,     
     6             MASK     / '000000FF'X                        /      
C    6             MASK     / X'000000FF', Z000000FF,  63,  511        
C                               UNIX     ,   IBM    , CDC, UNIVAC       
C        
C     SUMMARY OF PROGRAM'S VARIABLES:        
C        
C       VAX = .TURE. IF CURRENT MACHINE IS A  VAX, .FALSE. OTHERWISE    
C       IBM = .TURE. IF CURRENT MACHINE IS AN IBM, .FALSE. OTHERWISE    
C       TEK = .TRUE., TEKTRONIX SCREEN PLOT        
C       PSC = .TURE., POSTSCRIPT FILES GENERATION        
C      MASK = A MASK USED TO PICK UP THE LAST CHARACTER OF A WORD       
C             (MACHINE DEPENDENT)        
C       NBS = NO OF BITS TO BE SHIFTED        
C           = 24 = 3*8, FOR IBM, VAX        
C           = 54 = 9*6, FOR CDC        
C           = 27 = 3*9, FOR UNIVAC        
C       K12 = 1 OR 2 FOR 'PLT1' OR 'PLT2' FILE        
C       PID = 0, IF PLOT FILE DOES NOT HAVE A PLOT-ID FRAME,        
C           = 1, OTHERWISE        
C       ALL = 'Y', STACK ALL PLOTS INTO ONE POSTSCRIPT FILE        
C           = 'N', OTHERWISE.   (= 0, UNDEFINED STATUS)        
C        BI = NO. OF BITS PER WORD OF CURRENT COMPUTER RUNNING NASTPLOT 
C        BO = NO. OF BITS PER WORD OF THE COMPUTER WHICH GENERATED THE  
C             PLT1 OR PLT2 TILE        
C       FIL = INPUT  FILE UNIT FOR PLT1 OR PLT2    (FRMTTD, SQUNTL)     
C       LU  = OUTPUT FILE UNIT FOR POSTSCRIPT FILE (FRMTTD, SQUNTL)     
C      LUX  = IF .TRUE. AND ALL = 'N', LU UNIT NUMBER INCREASES BY 1    
C             EACH TIME A NEW POSTSCRIPT FILE IS GENERATED        
C       IN  = SYSTEM INPUT  FILE, UNIT 5        
C      NOUT = SYSTEM OUTPUT FILE, UNIT 6        
C    LUOPEN = 0, NO LU FILE OPENED.  = 1, LU FILE ALREADY OPENED        
C    NOLINE = 1, ADD "%!" LINE AT THE BEGINNING OF A POSTSCRIPT FILE    
C           = 0, NO SUCH LINE ADDED        
C    CHRPOS = 0, TYPING CHARACTERS ON POSTCRIPT FILE WILL BE STRUNG     
C             TOGETHER FOR ONE OUTPUT COMMAND        
C           = 1, (VIA POSTSCRIPT HELP ONLY) EACH TYPING CHARACTER IS    
C             SENT OUT AS A POSTSCRIPT COMMAND        
C       RL  = RECORD LENGTH IN WORDS        
C       NW  = NO. OF WORDS PER PLOT COMMNAD        
C       JID = WORD LOCATION OF PLOT ID NUMBER IN RECORD        
C       DOT = LOCATION OF '.' IN THE INPUT FILE NAME        
C      DorS = '.' OR '/', ON FILE NAME        
C      ADOT = FLAG FOR THE ORIGINAL FILE NAME THAT HAS A DOT, OR NO DOT 
C      NREC = NO. OF PHYSICAL RECORDS READ FROM INPUT FILE FIL        
C       NRC = ECHO CONTROL = NO. RECORDS/ECHO        
C     JOUNT = NO. OF POSTSCRIPT OUTPUT LINES ACCUMULATED AFTER 'stroke' 
C     NBUFF = POSTCRIPT BUFFER SIZE (BETWEEN 'stroke')        
C       KK  = A COUNTER - NO. OF RECORDS READ ON THE PLOT TAPE        
C    NOTYET = .TRUE. WHEN 1ST NEW PLOT COMMAND HAS NOT FULLY PROCESSED  
C       PNO = SEQUENTIAL PLOT FRAME NUMBER ON PLOT TAPE        
C     FOUND = .TURE. WHEN A NEW PLOT FOUND ON PLOT TAPE (CMND=1)        
C    SELECT = PLOT ID NO. USER SELECTED FOR PLOTTING        
C    LASTSL = PLOT ID NO. LAST SELECTED BY USER        
C     NPLOT = NO. OF PLOTS ACCUMULATED IN THE POSTSCRIPT FILE        
C    PLOTID = CURRENT PLOT ID NO. FOUND ON PLOT TAPE        
C     (NOTE - PLOT ID ON PLOT TAPE IS NOT RELIABLE. THE TAPE MAY HAVE   
C             MISSING PLOT ID, AND IT COULD HAVE TWO PLOT ID 1)        
C        
      EOF(J) = 0*J        
C     ISHFT(W,I) = SHIFT(W,-I)        
C        
C     INITIALIZE MACHINE DEPENDENT CONSTANTS:        
C        
CCDC  BI    = 6        
CUNV  BI    = 9        
      BI    = 8        
      NBS   = 24        
      ADOT  = .TRUE.        
      LUX   = .FALSE.        
      VAX   = .TRUE.        
      IBM   = .FALSE.        
C        
C     GENERAL INITIALIZATION:        
C        
      IF (AA*AA .GT. BB*BB) VAX = .FALSE.        
      IF (BI .EQ. 6) NBS = 54        
      IF (BI .EQ. 9) NBS = 27        
      IF (BI .NE. 8) ADOT = .FALSE.        
      IF (.NOT. VAX) MACH3 = XX3        
C        
      IN    = 5        
      NOUT  = 6        
      FIL   = 13        
      LU    = 14        
      NBUFF = 500        
      WRD   = 1        
      BYT   = 4        
      SCALE = 0.54        
      CSCAL = 13.0        
      NPLOT = 0        
      ALL   = 0        
      HELP  = 0        
      CHRPOS= 0        
      PSALL = 0        
      LUOPEN= 0        
      ESC   = CHAR(27)        
      CLEAR = ESC//CHAR(12)        
      BELL  = CHAR(7)        
      GO TO 20        
C        
C     SELECT TEKTRONIX PLOT OR POSTCRIPT FILE        
C        
   10 CDC = EOF(IN)        
   20 WRITE  (NOUT,25)        
   25 FORMAT (//,' ENTER PLOTTER SELECTION, TEKTRONIX OR POSTSCRIPT? ', 
     1       '(T,P,q,S,HELP) ',$)        
      READ   (IN,30,END=10) TEMP        
   30 FORMAT (A1)        
      IF (TEMP .EQ. KH) GO TO 60        
      IF (TEMP.EQ.KS1 .OR. TEMP.EQ.STP1) GO TO 1050        
      IF (TEMP.NE.KT .AND. TEMP.NE.KT1 .AND. TEMP.NE.KP .AND.        
     1    TEMP.NE.KQ1) GO TO 20        
      IF (TEMP.EQ.KT .OR. TEMP.EQ.KT1) TEK = .TRUE.        
      IF (TEMP.EQ.KP .OR. TEMP.EQ.KQ1) PSC = .TRUE.        
      IF (TEMP .EQ. KQ1) NOLINE = 1        
      IF (TEK) DEBUG = .FALSE.        
      IF (PSC) MACH32 = MACH33        
      IF (.NOT.PSC .OR. HELP.EQ.0) GO TO 80        
      HELP = 0        
      WRITE  (NOUT,40)        
   40 FORMAT (//,' ADDITIONAL HELP MESSAGES (POSTSCRIPT ONLY) -', //1X, 
     1        'OVERALL PLOT SIZE IS CONTROLLED BY PLOT SCALE, AND CHAR',
     2        'ACTER SIZE CAN BE CHANGED', /4X,'BY CHARACTER SCALE, ',  
     3        'ONLY IF ORIGINAL PLOT INCLUDES TYPING CAPABILITY', /,    
     4        ' PostScript EFFICIENY IS GREATLY IMPROVED IF TYPING',    
     5        ' CAPABILITY IS INCLUDED IN THE', /4X,        
     6        'ORIGINAL PLOT. (see NASTRAN PLOTTER card)', //,        
     7        ' FOUR CHARACTER TYPING SYMBOLS HAVE BEEN CHANGED', /,    
     8        '    CHARACTER      NASTRAN         POSTCSRIPT   ', /,    
     9        '      CODE         ORIGINAL        EQUIVALENCE  ', /,    
     O        '    ---------    -------------    --------------', /,    
     1        '     49 (6)      SMALL CIRCLE     BIG SOLID DOT ', /,    
     2        '     50 (7)      SMALL SQUARE     SQUARE-CIRCLE ', /,    
     3        '     51 (8)      SMALL DIAMOND    DAGGER        ', /,    
     4        '     52 (9)      SMALL TRIANGLE   DOUBLE-DAGGER ', //,   
     5        ' IF CHARACTERS ARE POSITIONED BADLY, ENTER * ON NEXT',   
     6        ' COMMAND', //,        
     7        ' YOU MAY ENTER ''ALL'' FOR THE PLOT NO. TO BE PLOTTED')  
      IF (VAX) WRITE (NOUT,45)        
   45 FORMAT (/,' WHEN FINISH, SEND PostScript FILE(S) OUT TO PRINTER', 
     1        ' WITHOUT HEADER PAGE using', /4X,'PRINT/NOFLAG option')  
      WRITE  (NOUT,50)        
   50 FORMAT (/,' HIT C/R TO CONTINUE ',$)        
      READ (IN,30,END=55) TEMP        
      IF (TEMP .EQ. STR) CHRPOS = 1        
      GO TO 80        
   55 CDC = EOF(IN)        
      GO TO 80        
C        
C     HELP MESSAGES        
C        
   60 HELP = 1        
      WRITE  (NOUT,70)        
   70 FORMAT (/,' ENTER "S" TO STOP',        
     1        /,' ENTER "T" FOR TEKTRONIX SCREEN PLOTTER',        
     2        /,' ENTER "P" or "q" TO GENERATE POSTCRIPT FILE(S)',      
     3        /,'    IF "P", POSTCRIPT FILE(S) BEGINS WITH A "%!" LINE',
     4        /,'    IF "q", NO "%!" LINE ADDED',        
     5        /,'    (THIS "%!" LINE IS NEEDED IN SOME UNIX MACHINES, ',
     6        'AND OTHERS DON''T)', //1X,        
     7        'INPUT FILE NAME MUST BE fname.PLT1 or fname.PLT2',       
     8        /,' PLOT FRAME NUMBER IS USED TO SPECIFIED WHICH PLOT TO',
     9        ' BE PLOTTED.',  /,' IF FRAME NO. IS NOT PRESENT ON ',    
     O        'ORIGINAL TAPE, SEQUENTIAL FRAME COUNT IS USED')        
      GO TO 20        
C        
C     GET PLOT FILE FILENAME AND OPEN PLOT FILE        
C        
   80 WRITE  (NOUT,90) MACH32,DATE13        
   90 FORMAT (//////33X,4H****, /31X,1H*,6X,1H*, /30X,1H*,8X,1H*,       
     1       /30X,'*   N A S T P L O T',        
     2       /30X,1H*,8X,1H*, /31X,1H*,6X,1H*, /33X,4H****,        
     3       ///7X,A32,'   SYSTEM RELEASE - ',A13,        
     4       //7X,'WRITTEN BY UNISYS/',17X,'FOR COSMIC', /11X,        
     5       'NASTRAN MAINTENANCE GROUP',6X,'UNIVERSITY OF GEORGIA',    
     6       /11X,'HUNTSVILLE, ALABAMA',12X,'ATHENS, GEORGIA 30602',    
     7       /42X,'PHONE (708) 542-3265', ////7X,        
     8       '*** AT THE END OF EACH PLOT, HIT C/R TO CONTINUE ***',    
     9       /18X,3H===,15X,3H===)        
  100 CDC = EOF(IN)        
      WRITE  (NOUT,110) DorS        
  110 FORMAT (//,' ENTER NAME OF PLOT FILE (e.g. TEST',A1,'PLT1): ',$)  
      READ   (IN,115,END=100) NAM32        
  115 FORMAT (A32)        
      IF (NAM4.EQ.BLNK4 .OR. NAM4.EQ.STOP4) GO TO 1000        
C        
C     CHECK PLT1 OR PLT2 TAPE        
C        
      I = 33        
  120 I = I - 1        
      IF (I .LE. 0) GO TO 1000        
      IF (NA1(I) .EQ. KB) GO TO 120        
      IF ((NA1(I ).EQ.K1 .OR. NA1(I).EQ.K2) .AND. NA1(I-4).EQ.DorS .AND.
     1   (NA1(I-1).EQ.KT .OR. NA1(I-1).EQ.KT1) .AND.        
     2   (NA1(I-2).EQ.KL .OR. NA1(I-2).EQ.KL1) .AND.        
     3   (NA1(I-3).EQ.KP .OR. NA1(I-3).EQ.KP1)) GO TO 140        
C        
C     IMPROPER INPUT FILE NAME        
C        
      WRITE  (NOUT,130) DorS,DorS,(NA1(J),J=1,I)        
  130 FORMAT (/,' FILE ERROR - This program uses only FNAME',A1,'PLT1 ',
     1        'or FNAME',A1,'PLT2 file', 5X,33A1)        
      IF (.NOT.ADOT) WRITE (NOUT,135) DorS,DorS        
  135 FORMAT (' ADD ',A1,'PLT1 or ',A1,'PLT2 TO THE FILE NAME CORRES',  
     1        'PONDING TO YOUR ORIGINAL', /1X,'NASTRAN PLOT FILE SPEC') 
      IF (IBM) WRITE (NOUT,137)        
  137 FORMAT (' USE A SLASH IF FILE IS A DATA SET NAME, OR NO SLASH IF',
     1        ' IT IS A DDNAME')        
      GO TO 100        
C        
C     INITIALIZE PARAMETERS FOR PLT1 OR PLT2 OF RECORDS:        
C     REMOVE '.PLTi' IF ORIGINAL FILE NAME CONTAINS NO FILE EXTENSION   
C        
  140 DOT = I - 4        
      IF (ADOT) GO TO 150        
      DO 145 J = DOT,I        
  145 NA1(J) = KB        
  150 K12 = K1        
      IF (NA1(I) .EQ. K2) K12 = K2        
      RL  = 30        
      NW  = 6        
      NRC = 500        
      JID = 3        
      IF (K12 .EQ. K1) GO TO 160        
      RL  = 3000        
      NW  = 30        
      NRC = 30        
      JID = 6        
      IF (.NOT.VAX) JID = 3        
C     THE ABOVE LINE MAY REQUIRE VERIFICAION ????        
C        
C     OPEN INPUT PLT1 OR PLT2 FILE        
C        
C     PLT1: RECORD LENGTH IS IN 130  BYTES (30 DATA WORDS)        
C           FILE WAS CREATED SEQUENTIAL, FORMATTED, CARRIAGE CONTROL    
C     PLT2: RECORD LENGTH IS IN 3000 BYTES        
C           FILE WAS CREATED SEQUENTIAL, FORMATTED, NO CARRIAGE CONTROL,
C           AND 3000 BYTE LONG RECORDSIZE        
C        
  160 OPEN (UNIT=FIL,FILE=NAM32,ERR=850,STATUS='OLD',FORM='FORMATTED',  
     1      ACCESS='SEQUENTIAL',
     2                          RECL=RL)        
      IF (K12 .EQ. K1) GO TO 200        
C        
C     IF PLT2 IS USED, INQUIRE WHAT MACHINE THE TAPE WAS GENERATED      
C        
  170 CDC = EOF(IN)        
      WRITE  (NOUT,180) K12        
  180 FORMAT (/,' FROM WHAT MACHINE WAS THIS PLT',A1,' FILE GENERATED?',
     1        /,' (Ibm,Univac,Cdc,Vax,uniX,craY): ',$)        
      READ (IN,30,END=170) TEMP        
      IF (TEMP.NE.KI .AND. TEMP.NE.KU .AND. TEMP.NE.KC .AND.        
     1    TEMP.NE.KV .AND. TEMP.NE.KX .AND. TEMP.NE.KY) GO TO 170       
      BO = 8        
      IF (TEMP .EQ. KU) BO = 9        
      IF (TEMP .EQ. KC) BO = 6        
C     IF (BO .EQ. BI) GO TO 200        
      IF (BO .EQ.  8) GO TO 200        
      WRITE  (NOUT,190)        
  190 FORMAT (//,' *** THIS NASTPLOT VERSION CAN NOT PROCESS PLOT TAPE',
     1       ' GENERATED FROM A', /5X,'UNIVAC OR CDC MACHINE')        
      GO TO 1000        
C        
C     CHECK PROSCRIPT PLOTTER SCALE AND        
C     INQUIRE SINGLE OR MULTIPLE POSTSCRIPT OUTPUT FILES        
C        
  200 IF (TEK) GO TO 250        
      IF (.NOT.PSC) GO TO 280        
      WRITE  (NOUT,210) SCALE,CSCAL        
  210 FORMAT (/,' CURRENT PLOT SCALE AND CHARACTER SCALE ARE',2F6.2,    
     1        1H;, /,' ENTER NEW SCALES (2F6.2) or C/R ',$)        
      READ   (IN,220,ERR=230) SX,SY        
  220 FORMAT (2F6.2)        
      IF (SX .GT. 0.01) SCALE = SX        
      IF (SY .GT. 0.01) CSCAL = SY        
C        
  230 CDC = EOF(IN)        
      WRITE  (NOUT,240) K12        
  240 FORMAT (/,' IF PLT',A1,' HAS MULTIPLE PLOTS, STACK ALL PLOTS IN', 
     1        ' ONE POSTSCRIPT FILE? (Y,N) ',$)        
      READ (IN,30,END=230) ALL        
      IF (ALL .EQ. SYY) ALL = YES        
      IF (ALL .EQ. SNN) ALL = NO        
      IF (ALL .EQ. YES) GO TO 280        
      IF (ALL .NE.  NO) GO TO 230        
      GO TO 280        
C        
C     IF MACHINE IS VAX, EQUIPPED WITH TEKTRONIX PLOT-10 TSC AND        
C     ADVANCED GRAPHING II PACKAGES, CALL NASTEK TO DO THE JOB        
C        
  250 CONTINUE        
C     IF (.NOT.VAX) GO TO 260        
      WRITE  (NOUT,255)        
  255 FORMAT (/,' PLOT-10 TCS AND ADVANCED GRAPHING II PACKAGES ON YOUR'
     1,       ' VAX SYSTEM? (Y/N) ',$)        
      READ (IN,30) J        
      IF (J .NE. YES) GO TO 260        
      I = 5        
      J = 30        
      IF (K12 .EQ. K1) GO TO 257        
      I = 100        
      J = 3000        
  257 CONTINUE
C+    CALL NASTEK (*1050,FIL,I,Z,J)        
      CLOSE (UNIT=FIL)        
      GO TO 1000        
C        
C     CHECK TEKTRONIX HORIZ. AND VERTICAL AXES        
C        
  260 WRITE  (NOUT,265) XSIZE,YSIZE        
  265 FORMAT (/,' CURRENT FRAME SIZE IS:  X-AXIS=',F6.2,' Y-AXIS=',F6.2,
     1        /,' ENTER NEW SIZES (2F6.2) or C/R: ',$)        
      READ   (IN,220,ERR=275) SX,SY        
      IF (SX .GT. 0.01) XSIZE = SX        
      IF (SY .GT. 0.01) YSIZE = SY        
      IF (YSIZE .LE. 32.0) GO TO 280        
      WRITE  (NOUT,270)        
  270 FORMAT (' MAXIMUM LENGTH FOR Y-AXIS IS 32.0 INCHES')        
      GO TO 250        
  275 CDC = EOF(IN)        
C        
C     LOOK FOR PLOT ID-FRAME IN Z(n). IF IT IS FOUND, REPLACE THE PLOT  
C     NUMBER IN Z(JID) BY ZERO.  n IS 19 FOR PLT1 AND n IS 90 FOR PLT2. 
C     SET PID FLAG TO 1 IF PLOT ID-FRAME DOES EXIST. OTHERWISE ZERO     
C     (PLOT ID-FRAME IS THE PLOT WITH MANY HORIZONTAL LINES, AND USER   
C     ID AT MID PAGE)        
C        
  280 REWIND FIL        
      PLOTID = -1        
      LASTSL = -1        
      PNO = 0        
      KK  = 1        
      IF (K12 .EQ. K2) GO TO 290        
      READ (FIL,460,END=900) W        
      IF (W(19)-16) 300,320,300        
C        
  290 READ (FIL,FMT500,END=900) Z        
C        
C       NEXT DO LOOP LOCATES '16' ON PLT2 FILE        
C       (IT WAS FOUND ON THE 90TH WORD)        
C        
C       DO 295 I = 1,99        
C       L = IAND(Z(I),MASK)        
C       WRITE  (NOUT,292) I,L        
C 292   FORMAT ('  WORD',I3,' = ',I7)        
C 295   CONTINUE        
C        
      IF (IAND(Z(90),MASK) .EQ. 16) GO TO 320        
  300 WRITE  (NOUT,310) K12        
  310 FORMAT (/,' THERE IS NO PLOT ID FRAME (PLOT NO. 0) ON USER''S ',  
     1       'PLT',A1,' FILE',/)        
      PID = 0        
      GO TO 350        
  320 PID = 1        
      Z(JID) = 0        
C        
C     ON THE PLOT FILE AS GENERATED BY NASTRAN, BOTH PLOT ID-FRAME AND  
C     THE FIRST STRUCTURE PLOT ARE PLOT NUMBER 1.  TREAT THE PLOT ID-   
C     FRAME AS PLOT NUMBER 0 THROUGHOUT THIS NASTPLOT PROGRAM        
C        
      WRITE  (NOUT,330) K12        
  330 FORMAT (/,' THERE IS A PLOT ID FRAME (PLOT NUMBER 0) ON USER''S ',
     1        'PLT',A1,' FILE')        
      GO TO 350        
C        
  340 WRITE (NOUT,310)        
C        
C     INQUIRE WHICH PLOT TO BE PLOTTED (SELECT)        
C     (ALLOW 5-DIGIT PLOT NO, CAN BE LEFT OR RIGHT AJUSTED)        
C        
  350 WRITE  (NOUT,360)        
  360 FORMAT (//,' ENTER PLOT NUMBER TO BE PLOTTED, ''NEXT'' or ',      
     1        '''STOP'' ',$)        
      READ   (IN,370,END=350) CHR1        
  370 FORMAT (5A1)        
      IF (CHR4 .EQ. BLNK4) GO TO 350        
      SELECT = -99        
      IF (PSC .AND. (CHR1(1).EQ.AL1 .OR. CHR1(1).EQ.KA1)) PSALL = 1     
      IF (PSALL.NE.0 .OR. CHR1(1).EQ.NXT1 .OR. CHR1(1).EQ.KN1) GO TO 510
      IF (CHR1(1).EQ.STP1 .OR. CHR1(1).EQ.KS1) GO TO 1010        
      SELECT = 0        
      TEN = 1        
      K   = 5        
      DO 410 J = 1,5        
      IF (CHR1(K) .EQ. BLNK1) GO TO 410        
      DO 380 I = 1,10        
      IF (CHR1(K) .EQ. NUMB1(I)) GO TO 400        
  380 CONTINUE        
      WRITE  (NOUT,390)        
  390 FORMAT (/5X,'...INPUT ERROR')        
      GO TO 350        
  400 IF (I .EQ. 10) I = 0        
      SELECT = SELECT + I*TEN        
      TEN = TEN*10        
  410 K   = K - 1        
      FOUND = .FALSE.        
      IF (SELECT     .LT. 0) GO TO 900        
      IF (SELECT+PID .EQ. 0) GO TO 340        
      IF (LASTSL    .EQ. -2) GO TO 510        
      IF (SELECT - LASTSL) 950,420,510        
  420 CDC = EOF(IN)        
      WRITE  (NOUT,430) LASTSL        
  430 FORMAT (' LAST PLOT WAS PLOT NO.',I3,'.   ARE YOU SURE? (Y,N) ',$)
      READ (IN,30,END=420) J        
      IF (J.EQ.YES .OR. J.EQ.SYY) GO TO 950        
      IF (J.NE.NO .AND. J.NE.SNN) GO TO 420        
      GO TO 350        
C        
C     SEARCH PLOT TAPE FOR PLOT SELECTED        
C     UP TO 2 DIGITS ONLY FOR PLOT ID        
C        
  440 IF (K12 .EQ. K2) GO TO 490        
  450 READ   (FIL,460,END=900) W        
  460 FORMAT (5(2I3,4I5))        
      KK = KK + 1        
      IF (DEBUG .AND. MOD(KK,NRC) .EQ. 0) WRITE (NOUT,470) KK        
  470 FORMAT (10X,'...SEARCHING',I6,' RECORDS')        
  480 FORMAT (10X,'...WORKING  ',I6,' RECORDS PROCESSED')        
      IF (W(1) .NE. 1) GO TO 450        
      GO TO 510        
  490 READ   (FIL,FMT500,END=900) Z        
C 500 FORMAT (3000A1)        
      KK = KK + 1        
      IF (DEBUG .AND. MOD(KK,NRC) .EQ. 0) WRITE (NOUT,470) KK        
      IF (.NOT.VAX .AND. ISHFT(Z(1),NBS).NE.1) GO TO 490        
      IF (     VAX .AND. IAND(Z(4),MASK).NE.1) GO TO 490        
C        
C     WRITE  (NOUT,505) JID,(Z(J),J=1,9)        
C 505 FORMAT (' JID =',I3,',  FIRST 9 BYTES OF NEW-PLOT RECORD = ',     
C    1        /12X,9I7)        
C        
      IF (.NOT.VAX) PLOTID = ISHFT(Z(JID-1),NBS)*10 + ISHFT(Z(JID),NBS) 
      IF (     VAX) PLOTID = IAND(Z(JID+1),MASK)*10 + IAND(Z(JID),MASK) 
C        
C     SELECT WAS SET TO -99 IF USER WANTS THE NEXT PLOT, OR        
C     USER REQUEST ALL PLOTS ON POSTSCRIPT        
C        
  510 IF (K12.NE.K2 .OR. LASTSL.EQ.-2) PLOTID = Z(JID)        
C     IF (DEBUG) WRITE (NOUT,545) PLOTID        
      IF (SELECT .EQ. -99) SELECT = PLOTID        
      IF (LASTSL .EQ. -2 ) LASTSL = -1        
      IF (PLOTID.GE.0 .OR. PSALL.NE.0) IF (PLOTID-SELECT) 440,540,520   
      IF (PNO+PID .EQ. SELECT) GO TO 540        
      PNO = PNO + 1        
      GO TO 440        
C        
C     INPUT TAPE MAY NOT SPECIFY PLOT NO.        
C        
  520 CDC = EOF(IN)        
      WRITE  (NOUT,530) PLOTID,SELECT        
  530 FORMAT (/,' PLOT NO.',I4,' JUST FOUND. INPUT TAPE MAY NOT USE ',  
     1       'OR SPECIFY PLOT NO.',I4,        
     2        /,' CONTINUE SEARCHING or REWIND TAPE? (Y,N,R) ',$)       
      READ (IN,30,END=520) TEMP        
      IF (TEMP .EQ. KR1) GO TO 950        
      IF (TEMP .EQ. KY ) GO TO 440        
      GO TO 350        
C        
C     MATCHING PLOT NUMBER JUST FOUND.        
C     SET N1 FOR THE 900 LOOP, THAT POINTS TO THE 2ND PLOT COMMAND      
C        
  540 FOUND  = .TRUE.        
      PLOTID = SELECT        
      IF (PLOTID .EQ. -1) PLOTID = 0        
      IF (DEBUG) WRITE (NOUT,545) PLOTID        
  545 FORMAT (13X,'PLOT NO =',I5,'  FOUND')        
      NOTYET = .TRUE.        
      NREC   = KK        
      N1     = 7        
      IF (K12 .EQ. K2) N1 = 1        
      IF (PSC) GO TO 550        
C        
C     INITIALIZE TEKRONIX:        
C        
      CALL TXINIT        
      XHI    = 0        
      YHI    = 0        
      PENCHG = 0        
      PENCNT = 0        
      OLDPEN = 0        
      GO TO 620        
C        
C     INITIALIZE POSTCRIPT:        
C        
  550 NPLOT  = NPLOT + 1        
      JOUNT  = 0        
      ONCE   =-1        
      IF (ADOT) GO TO 560        
      IF (ALL .EQ. YES) IF (LUOPEN) 590,555,590        
  555 NA1(DOT) = A1Z(NPLOT)        
      GO TO 585        
  560 KNUM1  = KB        
      KNUM(2)= KB        
      IF (ALL .EQ. YES) IF (LUOPEN) 590,580,590        
      IF (NPLOT .LT. 10) WRITE (KNUM1,565) NPLOT        
      IF (NPLOT .GE. 10) WRITE (KNUM2,570) NPLOT        
  565 FORMAT (I1)        
  570 FORMAT (I2)        
  580 NA1(DOT+2) = KNUM1        
      NA1(DOT+3) = KNUM(2)        
      NA1(DOT+4) = KB        
  585 OPEN (UNIT=LU,FILE=NAM32,FORM='FORMATTED',STATUS='NEW',ERR=870    
C    1     )        
     1     ,CARRIAGECONTROL='LIST')   ! RECOMMANDED FOR VAX TO GENERATE 
C                                     ! STANDARD LIST FILE        
      LUOPEN = 1        
  590 CALL PSINIT (NOLINE)        
      IF (ALL .EQ. YES) NOLINE = 1        
      GO TO 620        
C        
  600 NREC = NREC + 1        
      IF (PSC .AND. DEBUG .AND. MOD(NREC,NRC).EQ.0)        
     1    WRITE (NOUT,480) NREC        
C        
C     READ NEXT RECORD        
C        
      IF (K12 .EQ. K2) GO TO 610        
      READ (FIL,460,END=900) W        
      GO TO 620        
  610 READ (FIL,FMT500,END=900) Z        
C        
C     INTERCHANGE BYTE ORDER IF MACHINE IS VAX        
C        
  620 KK = KK + 1        
      IF (K12.EQ.K1 .OR. .NOT.VAX) GO TO 640        
      DO 630 I = 1,RL,4        
      J      = Z(I  )        
      Z(I  ) = Z(I+3)        
      Z(I+3) = J        
      J      = Z(I+1)        
      Z(I+1) = Z(I+2)        
      Z(I+2) = J        
  630 CONTINUE        
C        
C     PROCESS ONE PHYSICAL PLOT RECORD        
C        
  640 DO 800 N = N1,RL,NW        
C        
C     GET NEXT COMMAND,        
C        
      IF (K12 .EQ. K2) GO TO 650        
C        
C     PLT1 FILE: TOTAL OF 5 PLOT COMMANDS/RECORD        
C        
      CMND  = W(N)        
      IF (CMND .EQ. 0) GO TO 810        
      CNTRL = W(N+1)        
      R = W(N+2)        
      S = W(N+3)        
      T = W(N+4)        
      U = W(N+5)        
      GO TO 680        
C        
C     PLT2 FILE:  TOTAL OF 100 PLOT COMMANDS/RECORD        
C     EACH PLOT COMMAND IS 30 BYTE LONG, AND DATA IN FIRST 22 BYTES     
C        
  650 IF (BI .EQ. BO) GO TO 660        
      CALL GETCMD (Z)        
      GO TO 680        
C        
  660 N22  = N + 21        
      DO 670 J = N,N22        
      IF (     VAX) Z(J) = IAND(Z(J), MASK)        
      IF (.NOT.VAX) Z(J) = ISHFT(Z(J),-NBS)        
  670 CONTINUE        
      CMND  = Z(N)        
      IF (CMND .EQ. 0) GO TO 810        
      CNTRL = Z(N+1)        
      R = Z(N+ 2)*T4 + Z(N+ 3)*T3 + Z(N+ 4)*T2 + Z(N+ 5)*T1 + Z(N+ 6)   
      S = Z(N+ 7)*T4 + Z(N+ 8)*T3 + Z(N+ 9)*T2 + Z(N+10)*T1 + Z(N+11)   
      T = Z(N+12)*T4 + Z(N+13)*T3 + Z(N+14)*T2 + Z(N+15)*T1 + Z(N+16)   
      U = Z(N+17)*T4 + Z(N+18)*T3 + Z(N+19)*T2 + Z(N+20)*T1 + Z(N+21)   
      IF (.NOT.NOTYET) GO TO 680        
      NOTYET =.FALSE.        
      XMAX = S        
      YMAX = T        
      XFACT= XSIZE/XMAX        
      YFACT= YSIZE/YMAX        
      XLO  = XMAX        
      YLO  = YMAX        
      GO TO 800        
C        
C     CMND =  0, NON-OPERATION. A PADDING COMMANDS OF ALL ZEROS        
C          =  1, START-NEW-PLOT. R IS THE PLOT NUMBER        
C          =  2, SELECT-CAMERA. CNTRL=1 FILM ONLY, =2 HARDCOPY, =3 BOTH 
C          =  3, SKIP-TO-A-NEW-FRAME. CNTRL=1,2,3 SAME AS CMND=2        
C                AT LEAST ONE CMND=3 COMMAND AFTER A CMND=1 COMMAND AND 
C                BEFORE NEXT CMND=1        
C          =  4, TYPE-CHARACTER        
C          =  5, DRAW-LINE        
C          =  6, DRAW-AXIS        
C          = 14, 15, 16, SAME AS 4, 5, 6        
C                THESE COMMANDS INDICATE FIRST OF A SERIES OF 4, 5, OR  
C                6 COMMNADS THAT FOLLOW        
C     CMND = 2,3 ARE FOR MICROFILM PLOTTER ONLY. THEY ARE NOT USED      
C                IN THIS NASPLT PROGRAM        
C        
C     CNTRL= A PEN NO., OR A LINE DENSITY, OR A CAMERA NO, OR A POINTER 
C            INTO A LIST OF CHARACTERS AND SYMBOL (TABLE 1 OF THE       
C            USER'S MANUAL, P.4.4-5)        
C        
C     R,S,T,U = DATA VALUES        
C        
C        
C        
C     NOTE, CMND=1 (START-NEW-PLOT) ALWAYS LOCATES ON THE FIRST COMMAND 
C     OF A PLOT RECORD        
C     IGNORE CMND =2 OR 3, WHICH ARE FOR MICROFILM PLOTTER ONLY        
C        
  680 IF (CMND .NE. 1) GO TO 720        
      IF (N    .NE. 1) WRITE (NOUT,685) BELL,BELL,BELL,N,CNTRL        
  685 FORMAT (1X,3A1,/,'0*** LOGIC ERROR. NEW PLOT FOUND AT MIDDLE OF ',
     1        'RECORD', /5X,'N =',I5,',  PLOT NO.',I5)        
C        
C     END OF PREVIOUS PLOT        
C        
      WRITE  (NOUT,690) BELL        
  690 FORMAT (1X,A1)        
      IF (TEK) GO TO 710        
      CALL PSTRKE        
      CALL PSFINS        
      IF (ALL .EQ. YES) GO TO 695        
      CLOSE (UNIT=LU)        
      IF (LUX) LU = LU + 1        
      LUOPEN = 0        
  695 WRITE  (NOUT,700) PLOTID,K12        
  700 FORMAT (/,' A PLOT WAS GENERATED FROM PLOT NO.',I3,' OF THE PLT', 
     1        A1,' FILE',/)        
      IF (K12  .EQ. K2) BACKSPACE FIL        
      LASTSL = SELECT        
      SELECT = R        
      PLOTID = R        
      IF (PSALL) 540,350,540        
C        
  710 READ (IN,30,END=715) J        
  715 CDC = EOF(IN)        
      CALL TXFINS        
      GO TO 350        
C        
  720 IF (CMND .LE. 3) GO TO 800        
C        
C     CHECK FOR NEW CHARACTER, LINE, OR AXIS SET        
C        
      IF (CMND.LT.14 .OR. CMND.GT.16) GO TO 730        
      IF (CMND .EQ. 14) CHRSET = .TRUE.        
      IF (CMND .EQ. 15) LINSET = .TRUE.        
      IF (CMND .EQ. 16) AXSSET = .TRUE.        
      CMNDX = CMND        
      CMND  = CMND - 10        
C        
C     CHECK FOR END OF CHARACTER, LINE, OR AXIS SET        
C        
  730 IF (.NOT.PSC) GO TO 740        
      IF (CHRSET .AND. CMND.NE.4) CALL PSENDC (CHRSET,CMNDX)        
      IF (CMND .NE. 4) GO TO 750        
      CALL PSCHAR (CHRSET,CMNDX)        
      GO TO 800        
  740 IF (CHRSET .AND. CMND.NE.4) CALL ENDKHR (CHRSET)        
      IF (LINSET .AND. CMND.NE.5) CALL ENDLIN (LINSET)        
      IF (AXSSET .AND. CMND.NE.6) CALL ENDAXS (AXSSET)        
C        
  750 IF (CMND-5) 760,770,790        
C         CMND  =  4   5   6        
C           or    14  15  16        
C        
  760 IF (TEK) CALL DRWKHR (CHRSET)        
      GO TO 800        
  770 IF (PSC) GO TO 780        
      CALL DRWLIN (LINSET)        
      GO TO 800        
  780 CALL PSLINE        
      GO TO 800        
  790 IF (PSC) GO TO 780        
      CALL DRWAXS (AXSSET)        
  800 CONTINUE        
C        
C     LOOP BACK FOR MORE PLOT RECORDS FROM PLOT FILE        
C     SESET N1 FOR THE 900 LOOP, THAT POINTS TO THE 1ST PLOT COMMAND    
C        
  810 N1 = 1        
      GO TO 600        
C        
C     PLOT FILE NOT FOUND. TRY AGAIN        
C        
  850 WRITE  (NOUT,860) NAM32        
  860 FORMAT (/,' *** NO SUCH INPUT FILE ',A32)        
      IF (IBM) WRITE (NOUT,137)        
      GO TO 100        
C        
  870 WRITE  (NOUT,880) NAM32        
  880 FORMAT (//,' *** CAN NOT OPEN OUTPUT FILE - ',A32,        
     1        /5X,'JOB ABORTED')        
      CLOSE (UNIT=FIL)        
      GO TO 1050        
C        
C     EOF ENCOUNTERED        
C        
  900 WRITE (NOUT,690) BELL        
      IF (PLOTID.EQ.-1 .OR. .NOT.FOUND) GO TO 920        
      IF (PSC) GO TO 910        
      READ (IN,30,END=905) J        
  905 CDC = EOF(IN)        
      CALL TXFINS        
      GO TO 920        
  910 J = 0        
      IF (CHRSET) CALL PSENDC (CHRSET,J)        
      CALL PSTRKE        
      CALL PSFINS        
      IF (ALL .EQ. YES) GO TO 915        
      CLOSE (UNIT=LU)        
      IF (LUX) LU = LU + 1        
      LUOPEN = 0        
  915 IF (NPLOT .GT. 0) WRITE (NOUT,700) PLOTID,K12        
  920 IF (.NOT.FOUND) WRITE (NOUT,930) SELECT        
  930 FORMAT (/,' PLOT NO.',I4,' DOES NOT EXIST')        
  940 WRITE  (NOUT,945) PLOTID,K12        
  945 FORMAT (/,' EOF ENCOUNTERED. THERE ARE ONLY',I3,' PLOTS ON ',     
     1       'USER''S PLT',A1,' FILE', /,        
     2       ' START ALL OVER PLOTTING AGAIN? (Y,N) ',$)        
      READ (IN,30,END=940) J        
      IF (J.EQ.NO   .OR. J.EQ.SNN) GO TO 1010        
      IF (J.NE.YES .AND. J.NE.SYY) GO TO  920        
      SELECT = -1        
C        
C     START ALL OVER AGAIN        
C        
  950 REWIND FIL        
      KK    = 0        
      PSALL = 0        
      PNO   = 0        
      PLOTID=-1        
      LASTSL=-2        
      IF (K12 .EQ. K1) READ (FIL,   460,END=1010) W        
      IF (K12 .EQ. K2) READ (FIL,FMT500,END=1010) Z        
      IF (PID .EQ.  0) GO TO 960        
      Z(JID) = 0        
      GO TO 970        
  960 IF (K12 .EQ. K1) GO TO 970        
      IF (.NOT.VAX) Z(JID) = ISHFT(Z(JID-1),NBS)*10 + ISHFT(Z(JID),NBS) 
      IF (     VAX) Z(JID) = IAND(Z(JID+1),MASK)*10 + IAND(Z(JID),MASK) 
  970 IF (SELECT) 350,510,510        
C        
C     JOB DONE. TIDY UP ALL LOOSE ENDS        
C        
 1000 WRITE (NOUT,1020)        
      GO TO 1050        
 1010 CLOSE (UNIT=FIL)        
      IF (ALL.EQ.YES .AND. LUOPEN.EQ.1) CLOSE (UNIT=LU)        
      WRITE  (NOUT,1020)        
 1020 FORMAT (//5X,'*** JOB DONE ***')        
      IF (.NOT.PSC .OR. NPLOT.LE.0) GO TO 1050        
      KC = KB        
      IF (NPLOT .GT. 1) KC = STP1        
      IF (ALL .EQ. YES) GO TO 1030        
      NA1(DOT+3) = KB        
      IF (NPLOT .LE. 1) GO TO 1030        
      NA1(DOT+2) = STR        
      KB = STP1        
 1030 WRITE  (NOUT,1040) NPLOT,KC,KB,NAM32        
 1040 FORMAT (//4X,I2,' PLOT FILE',A1,' GENERATED. SEND THE FOLLOWING ',
     1       'PostScript FILE',A1, /5X,'TO PRINTER - ',A32)        
C        
 1050 CONTINUE        
      END        
C        
C     ================================================================= 
C        
      SUBROUTINE GETCMD (Z)        
C        
C     THIS SUBROUTINE GET THE PLOT COMMAND        
C        
C     THIS SUBROUTINE IS NEEDED ONLY WHEN THE MACHINE READING THE PLT2  
C     TAPE AND THE MACHINE WHO WROTE THE PLT2 TAPE, HAVE DIFFERENT      
C     NUMBER OF BITS PER BYTE, NBPB        
C     E.G.  NBPB IS 6 FOR CDC, 8 FOR VAX AND IBM, AND 9 FOR UNIVAC      
C        
C     BI = NBPB ON WRITING COMPUTER        
C     BO = NBPB ON READING COMPUTER        
C        
      IMPLICIT INTEGER (A-Z)        
      INTEGER     Z(1),Q(1)        
      COMMON /QQ/ BI,BO,WRD,BYT,PC,CI,R4,R3,R2,R1,R0,S4,S3,S2,S1,S0,    
     1            T4,T3,T2,T1,T0,U4,U3,U2,U1,U0        
      COMMON      CMND,CTRL,R,S,T,U        
      EQUIVALENCE (Q(1),PC)        
      DATA   MAX/ 3000 /        
C        
      IF (BI .EQ. BO) STOP ' NO NEED TO CALL GETCMD'        
      IF (BI .NE. BO) STOP ' PRESENTLY, GETCMD DOES NOT WORK'        
C        
C     GET 30-BYTE COMMAND INTO 30 INTEGERS        
C     THE FOLLOWING LOGIC IS FACTITIOUS        
C        
      IF (BI.EQ.8 .AND. BO.EQ.6) GO TO 1110        
C        
C     NBPC OF 6 INTO NBPC OF 8        
C        
      DO 1100 I = 1,30        
      Q(I) = Z(WRD)        
      IF (BYT .EQ.   0) WRD = WRD + 1        
      IF (BYT .EQ.   0) BYT = 6        
      IF (WRD .GT. MAX) WRD = 1        
 1100 BYT = BYT - 1        
      GO TO 1130        
C        
C     NBPC OF 8 INTO NBPC OF 6        
C        
 1110 DO 1120 I = 1,30        
      Q(I) = Z(WRD)        
      IF (BYT .EQ.   0) WRD = WRD + 1        
      IF (BYT .EQ.   0) BYT = 8        
      IF (WRD .GT. MAX) WRD = 1        
 1120 BYT = BYT - 1        
C        
 1130 CMND = PC        
      CTRL = CI        
      R    = R4*10000 + R3*1000 + R2*100 + R1*10 + R0        
      S    = S4*10000 + S3*1000 + S2*100 + S1*10 + S0        
      T    = T4*10000 + T3*1000 + T2*100 + T1*10 + T0        
      U    = U4*10000 + U3*1000 + U2*100 + U1*10 + U0        
      RETURN        
      END        
C        
C     ================================================================= 
C        
      SUBROUTINE DRWAXS (AXSSET)        
C        
      IMPLICIT INTEGER (A-Z)        
      REAL     XFACT,YFACT,X,Y        
      LOGICAL  AXSSET,P16        
      COMMON   CMND,CNTRL,R,S,T,U,XFACT,YFACT,XMAX,YMAX,XHI,YHI,XLO,YLO,
     1         PENCHG,PENCNT,OLDPEN,PENNO(99)        
      DATA     AXSCNT,P16 / 0, .TRUE. /        
C        
C     CHECK FOR INITIAL COMMAND = 16        
C        
      IF (AXSSET) GO TO 1150        
      AXSSET = .TRUE.        
      P16    = .FALSE.        
C        
C     CHECK COORDINATES AGAINST MAX & MIN ENCOUNTERED SO FAR        
C        
 1150 XHI = MAX(R,T,XHI)        
      YHI = MAX(S,U,YHI)        
      XLO = MIN(R,T,XLO)        
      YLO = MIN(S,U,YLO)        
C        
C     CHECK FOR A PEN CHANGE AND/OR NEW PEN ID        
C        
      IF (CNTRL .EQ. OLDPEN) GO TO 1180        
      CALL TXNPEN (CNTRL)        
      PENCHG = PENCHG + 1        
      IF (PENCNT .GE. 99) GO TO 1170        
      PENCNT = PENCNT + 1        
      PENNO(PENCNT) = CNTRL        
      IF (PENCNT .LE. 1) GO TO 1170        
      DO 1160 N = 2,PENCNT        
      IF (PENNO(PENCNT) .NE. PENNO(N-1)) GO TO 1160        
      PENCNT = PENCNT -1        
      GO TO 1170        
 1160 CONTINUE        
 1170 OLDPEN = CNTRL        
 1180 AXSCNT = AXSCNT + 1        
C        
C     MOVE PLOTTER PEN TO BEGINNING OF AXIS        
C        
      X = XFACT*FLOAT(R)        
      Y = YFACT*FLOAT(S)        
      CALL TXPLOT (X,Y,3)        
C        
C     DRAW AXIS ON PLOTTING SURFACE        
C        
      X = XFACT*FLOAT(T)        
      Y = YFACT*FLOAT(U)        
      CALL TXPLOT (X,Y,2)        
      RETURN        
C        
C        
      ENTRY ENDAXS (AXSSET)        
C     =====================        
C        
C     REINITILIZE COMMANDS        
C        
      P16    = .TRUE.        
      AXSCNT =  0        
      AXSSET = .FALSE.        
      RETURN        
      END        
C        
C     ================================================================= 
C        
      SUBROUTINE DRWKHR (CHRSET)        
C        
      IMPLICIT  INTEGER (A-Z)        
      LOGICAL   CHRSET        
      REAL      XFACT,YFACT,X,Y,ANGLE,HITE        
      CHARACTER CHR94*52,CHRSAV*57,BLNK1,QUES1        
      DIMENSION CHRCOD(53)        
      COMMON    CMND,CNTRL,R,S,T,U,XFACT,YFACT,XMAX,YMAX,XHI,YHI,XLO,YLO
      DATA      LINE,SAVCNT,CHRCNT,UNKCNT / 1, 0, 0, 0/        
      DATA      CHRSAV,BLNK1,QUES1    / ' ', ' ', '?' /        
      DATA      CHR94 /        
     1          '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ()+-*/=.,$" O[<^'/ 
      DATA      CHRCOD /32,33,34,35,36,37,38,39,40,41,        
     1                  49,50,51,52,53,54,55,56,57,58,59,60,61,        
     2                  62,63,64,65,66,67,68,69,70,71,72,73,74,        
     3                  24,25,27,29,26,31,45,30,28,20,23,        
     4                  16, 1, 0, 5, 2,47/        
C        
C     CHECK FOR INITIAL COMMAND = 14        
C        
      IF (CHRSET) GO TO 1200        
      CHRSET = .TRUE.        
      LINE   = LINE + 1        
C        
C     UPDATE COUNTER & POINTER        
C        
 1200 SAVCNT = SAVCNT + 1        
      CHRCNT = CHRCNT + 1        
C        
C     STORE CHARACTER IN STRING CHRSAV        
C        
      IF (CNTRL.LE.52 .AND. CNTRL.GT.0) GO TO 1210        
      CHRSAV(SAVCNT:SAVCNT) = QUES1        
      CODE   = CHRCOD(53)        
      UNKCNT = UNKCNT + 1        
      GO TO 1220        
C        
 1210 CHRSAV(SAVCNT:SAVCNT) = CHR94(CNTRL:CNTRL)        
      CODE = CHRCOD(CNTRL)        
C        
C     IF CHRSAV STRING IS FULL, PRINT IT        
C        
 1220 IF (SAVCNT .NE. 57) GO TO 1230        
      CHRSAV = BLNK1        
      SAVCNT = 0        
      LINE   = LINE + 1        
C        
C     COMPARE (X,Y) WITH MAX & MIN ENCOUNTERED SO FAR        
C        
 1230 XHI = MAX(XHI,R)        
      YHI = MAX(YHI,S)        
      XLO = MIN(XLO,R)        
      YLO = MIN(YLO,S)        
C        
C     DRAW CHARACTER ON PLOTTER        
C        
      X     = XFACT*FLOAT(R)        
      Y     = YFACT*FLOAT(S)        
      HITE  = 0.08*XFACT*100.0        
      ANGLE = 0.0        
C        
C     BRING IN NASTRAN SYMBOL ROUTINE IF IT IS NEEDED        
C        
C     CALL SYMBOL (X,Y,HITE,CODE,ANGLE,-1)        
      RETURN        
C        
C        
      ENTRY ENDKHR (CHRSET)        
C     =====================        
C        
C     PRINT OUT CONTENTS OF CHRSAV & COUNTERS        
C     REINITIALIZE        
C        
      LINE   = 1        
      CHRSAV = BLNK1        
      CHRSET = .FALSE.        
      SAVCNT = 0        
      CHRCNT = 0        
      UNKCNT = 0        
      RETURN        
      END        
C        
C     ================================================================= 
C        
      SUBROUTINE DRWLIN (LINSET)        
C        
      IMPLICIT INTEGER (A-Z)        
      REAL     XFACT,YFACT,X,Y,OLDX,OLDY        
      LOGICAL  LINSET,P15,LINPRV        
      COMMON   CMND,CNTRL,R,S,T,U,XFACT,YFACT,XMAX,YMAX,XHI,YHI,XLO,YLO,
     1         PENCHG,PENCNT,OLDPEN,PENNO(99)        
      DATA     LINCNT,P15,LINPRV / 0,.TRUE.,.FALSE. /        
C        
C     CHECK FOR INITIAL COMMAND = 15        
C        
      IF (LINSET) GO TO 1250        
      LINSET = .TRUE.        
      P15    = .FALSE.        
C        
C     CHECK COORDINATES AGAINST MAX & MIN ENCOUNTERED SO FAR        
C        
 1250 XHI  = MAX(R,T,XHI)        
      YHI  = MAX(S,U,YHI)        
      XLO  = MIN(R,T,XLO)        
      YLO  = MIN(S,U,YLO)        
      FILL = 0        
C        
C     CHECK FOR A PEN CHANGE AND/OR NEW PEN ID        
C        
      IF (CNTRL .EQ. OLDPEN) GO TO 1280        
      IF (CNTRL .GT.     31) FILL = 1        
      IF (CNTRL.EQ.0 .AND. OLDPEN .GT.31) IFILL = 1        
      CALL TXNPEN (CNTRL)        
      PENCHG = PENCHG + 1        
      IF (PENCNT .GE. 99) GO TO 1270        
      PENCNT = PENCNT + 1        
      PENNO(PENCNT) = CNTRL        
      IF (PENCNT .LE. 1) GO TO 1270        
      DO 1260 N = 2,PENCNT        
      IF (PENNO(PENCNT) .NE. PENNO(N-1)) GO TO 1260        
      PENCNT = PENCNT - 1        
      GO TO 1270        
 1260 CONTINUE        
 1270 OLDPEN = CNTRL        
 1280 LINCNT = LINCNT + 1        
      X = XFACT*FLOAT(R)        
      Y = YFACT*FLOAT(S)        
      I = 3        
      IF (FILL .EQ. 1) I = -3        
C        
C     IF FILL = 1 THEN START TO FILL ELEMENT        
C        
      IF (.NOT.LINPRV .OR. X.NE.OLDX .OR. Y.NE.OLDY) CALL TXPLOT (X,Y,I)
C        
C     DRAW LINE ON PLOTTER SURFACE        
C        
      X = XFACT*FLOAT(T)        
      Y = YFACT*FLOAT(U)        
C        
C     IF CNTRL = 0 CLOSE ELEMENT AND FILL        
C        
      J = 2        
      IF (CNTRL.EQ.0 .AND. IFILL.EQ.1) J = -2        
      IF (J .EQ. -2) IFILL = 0        
      CALL TXPLOT (X,Y,J)        
C        
C     REMEMBER POSITION FOR NEXT SUCCESSIVE DRAWLINE COMMAND        
C        
      OLDX   = X        
      OLDY   = Y        
      LINPRV = .TRUE.        
      RETURN        
C        
C        
      ENTRY ENDLIN (LINSET)        
C     =====================        
C        
C     CHECK FOR INITIAL COMMAND=15, AND PRINT "DRAW LINES" SUMMARY      
C     REINITIALIZE        
C        
      P15    = .TRUE.        
      LINCNT =  0        
      LINSET = .FALSE.        
      LINPRV = .FALSE.        
      RETURN        
      END        
C        
C     ================================================================= 
C        
      SUBROUTINE TXNPEN (CNTRL)        
C        
C     TEKTRONIX PEN AND COLOR CONTROL        
C        
      INTEGER     CNTRL        
      CHARACTER   ESC*1,CLEAR*2,LINCLR*4        
      COMMON /IO/ IN,NOUT        
      COMMON /EC/ ESC,CLEAR        
C        
C     CHANGE COLOR BY PEN NUMBER.        
C        
      IF (CNTRL .GT. 15) GO TO 1460        
      GO TO (1310,1320,1330,1340,1350,1360,1370,1380,1390,1400,        
     1       1410,1420,1430,1440,1450), CNTRL        
 1310 LINCLR = ESC//'ML1'        
      GO TO 1620        
 1320 LINCLR = ESC//'ML2'        
      GO TO 1620        
 1330 LINCLR = ESC//'ML3'        
      GO TO 1620        
 1340 LINCLR = ESC//'ML4'        
      GO TO 1620        
 1350 LINCLR = ESC//'ML5'        
      GO TO 1620        
 1360 LINCLR = ESC//'ML6'        
      GO TO 1620        
 1370 LINCLR = ESC//'ML7'        
      GO TO 1620        
 1380 LINCLR = ESC//'ML8'        
      GO TO 1620        
 1390 LINCLR = ESC//'ML9'        
      GO TO 1620        
 1400 LINCLR = ESC//'ML:'        
      GO TO 1620        
 1410 LINCLR = ESC//'ML;'        
      GO TO 1620        
 1420 LINCLR = ESC//'ML<'        
      GO TO 1620        
 1430 LINCLR = ESC//'ML='        
      GO TO 1620        
 1440 LINCLR = ESC//'ML>'        
      GO TO 1620        
 1450 LINCLR = ESC//'ML?'        
      GO TO 1620        
C        
 1460 IF (CNTRL .LT. 32) RETURN        
      J = CNTRL - 31        
      GO TO (1470,1480,1490,1500,1510,1520,1530,1540,1550,1560,        
     1       1570,1580,1590,1600,1610), J        
 1470 LINCLR = ESC//'MP!'        
      GO TO 1620        
 1480 LINCLR = ESC//'MP"'        
      GO TO 1620        
 1490 LINCLR = ESC//'MP#'        
      GO TO 1620        
 1500 LINCLR = ESC//'MP$'        
      GO TO 1620        
 1510 LINCLR = ESC//'MP%'        
      GO TO 1620        
 1520 LINCLR = ESC//'MP&'        
      GO TO 1620        
 1530 LINCLR = ESC//'MP'//CHAR(39)        
      GO TO 1620        
 1540 LINCLR = ESC//'MP('        
      GO TO 1620        
 1550 LINCLR = ESC//'MP)'        
      GO TO 1620        
 1560 LINCLR = ESC//'MP*'        
      GO TO 1620        
 1570 LINCLR = ESC//'MP+'        
      GO TO 1620        
 1580 LINCLR = ESC//'MP,'        
      GO TO 1620        
 1590 LINCLR = ESC//'MP-'        
      GO TO 1620        
 1600 LINCLR = ESC//'MP.'        
      GO TO 1620        
 1610 LINCLR = ESC//'MP/'        
 1620 WRITE  (NOUT,1630) LINCLR        
 1630 FORMAT (1X,A4)        
      RETURN        
      END        
C        
C     ================================================================= 
C        
      SUBROUTINE TXINIT        
C        
C     THIS ROUTINE INITIALIZES THE TEKTRONIX GRAPHIC MODE AND CLEARS    
C     THE PREVIOUS PLOT OFF THE SCREEN.        
C        
      CHARACTER   ESC*1,CLEAR*2,INDEX(15)*12        
      CHARACTER*4 TMODE,EMODE,LINCLR        
      COMMON /IO/ IN,NOUT        
      COMMON /EC/ ESC,CLEAR        
C        
      LINCLR = ESC//'ML1'        
      TMODE  = ESC//'%!0'        
C        
C     SET THE COLOR REGISTERS. FROM RED TO BLUE.        
C        
      INDEX( 1) = ESC//'TG1410F40'        
      INDEX( 2) = ESC//'TG142G8B8F4'        
      INDEX( 3) = ESC//'TG143H<B8F4'        
      INDEX( 4) = ESC//'TG144I6C2F4'        
      INDEX( 5) = ESC//'TG145J:B8F4'        
      INDEX( 6) = ESC//'TG146K4C<F4'        
      INDEX( 7) = ESC//'TG147K4D6E0'        
      INDEX( 8) = ESC//'TG148L8B8F4'        
      INDEX( 9) = ESC//'TG149O0C2F4'        
      INDEX(10) = ESC//'TG14:P>B8F4'        
      INDEX(11) = ESC//'TG14;Q8C2F4'        
      INDEX(12) = ESC//'TG14<R7B8F4'        
      INDEX(13) = ESC//'TG14=S;B8F4'        
      INDEX(14) = ESC//'TG14>U1C2F4'        
      INDEX(15) = ESC//'TG14?0C2F4'        
C        
      WRITE  (NOUT,1700) TMODE,CLEAR        
 1700 FORMAT (1X,A4,A2)        
      WRITE  (NOUT,1710) (INDEX(I),I=1,15)        
 1710 FORMAT (1X,A12)        
      WRITE  (NOUT,1700) LINCLR        
      RETURN        
C        
C        
      ENTRY TXFINS        
C     ============        
C        
C     THIS ROUTINE INITIALIZES THE EDIT MODE AND CLEARS THE PREVIOUS    
C     PLOT OFF THE TEKTRONIC SCREEN.        
C        
      LINCLR = ESC//'ML1'        
      EMODE  = ESC//'%!2'        
      WRITE  (NOUT,1720) CLEAR,LINCLR,EMODE        
 1720 FORMAT (1X,A2,A4,A4)        
      RETURN        
      END        
C        
C     ================================================================= 
C        
      SUBROUTINE TXPLOT (X,Y,N)        
C        
C     THIS SUBROUTINE CHANGES COORDINATES INTO TEXTRONIX COORDINATES    
C        
      INTEGER     N,NUMBER(2),CON(12,2),ADE(5),TWO(12)        
      REAL        X,Y        
      CHARACTER   ESC*1,CLEAR*2,PANEND*3,ASC*5        
      CHARACTER*8 PSTART,PEND,PANST        
      COMMON /IO/ IN,NOUT        
      COMMON /EC/ ESC,CLEAR        
      DATA   TWO/ 1,2,4,8,16,32,64,128,256,512,1024,2048 /        
C        
      IX = NINT(X*3071.0)        
      IY = NINT(Y*3071.0)        
C        
      NUMBER(1) = IX        
      NUMBER(2) = IY        
C        
C     CONVERTS TWO INTEGER VALUES INTO TEKTRONIX TYPE ADE (ASCII TO     
C     DECIMAL EQUIVALENT) CHARACTERS        
C        
      DO 1820 K = 1,2        
      IDIGIT = 0        
C        
      I = 12        
      DO 1810 J = 1,12        
      IF (TWO(I)-NUMBER(K) .GT. 0) GO TO 1800        
      IDIGIT = 1        
      NUMBER(K) = NUMBER(K) - TWO(I)        
 1800 CON(I,K) = IDIGIT        
      IDIGIT = 0        
 1810 I = I - 1        
 1820 CONTINUE        
C        
      ADE(1) = 32        
      ADE(2) = 96        
      ADE(3) = 96        
      ADE(4) = 32        
      ADE(5) = 64        
C        
      I = 12        
      DO 1830 J = 8,12        
      IF (CON(I,1) .EQ. 1) ADE(4) = ADE(4) + TWO(I-7)        
 1830 I = I - 1        
      ASC(4:4) = CHAR(ADE(4))        
C        
      I = 7        
      DO 1840 J = 3,7        
      IF (CON(I,1) .EQ. 1) ADE(5) = ADE(5) + TWO(I-2)        
 1840 I = I - 1        
      ASC(5:5) = CHAR(ADE(5))        
C        
      I = 2        
      DO 1850 J = 1,2        
      IF (CON(I,1) .EQ. 1) ADE(2) = ADE(2) + TWO(I)        
 1850 I = I - 1        
C        
C     IS THERE A LINE MISSING HERE? SOMETHING SUCH AS        
C     ASC(?:?) = CHAR(ADE(2))???   G.C  9/90        
C        
      I = 12        
      DO 1860 J = 8,12        
      IF (CON(I,2) .EQ. 1) ADE(1) = ADE(1) + TWO(I-7)        
 1860 I = I - 1        
      ASC(1:1) = CHAR(ADE(1))        
C        
      I = 7        
      DO 1870 J = 3,7        
      IF (CON(I,2) .EQ. 1) ADE(3) = ADE(3) + TWO(I-2)        
 1870 I = I - 1        
      ASC(3:3) = CHAR(ADE(3))        
C        
      I = 2        
      DO 1880 J = 1,2        
      IF (CON(I,2) .EQ. 1) ADE(2) = ADE(2) + TWO(I)        
 1880 I = I - 1        
      ASC(2:2) = CHAR(ADE(2))        
C        
C     END OF CONVERSION        
C        
      PSTART = ESC//'LF'//ASC        
      PEND   = ESC//'LG'//ASC        
      PANST  = ESC//'LP'//ASC        
      PANEND = ESC//'LE'        
C        
      IF (N .EQ.  3) WRITE (NOUT,1890) PSTART        
      IF (IABS(N) .EQ. 2) WRITE (NOUT,1890) PEND        
      IF (N .EQ. -3) WRITE (NOUT,1890) PANST        
      IF (N .EQ. -2) WRITE (NOUT,1900) PANEND        
 1890 FORMAT (1X,A8)        
 1900 FORMAT (1X,A3)        
      RETURN        
      END        
C        
C     ================================================================= 
C        
      SUBROUTINE PSINIT (NOLINE)        
C        
C     POSTSCRIPT NEW PLOT ROUTINE        
C        
C     ON A 8 X 11 (HORIZ X VERT) PAGE, THE ORIGIN IS AT THE LOWER LEFT  
C     CONNER. NOW TO CENTER THE PLOT HORIZONTALLY ALONG THE 11 IN. EDGE,
C     MOVE THE ORIGIN 589 UNITS TO THE RIGHT, 116 UNITS UP, AND ROTATE  
C     THE PAPER BY 90 DEGREE.        
C        
      COMMON /PS/ LU,DUMMY(6)        
C        
      IF (NOLINE .EQ. 0) WRITE (LU,1950)        
      WRITE  (LU,1960)        
 1950 FORMAT ('%!')        
 1960 FORMAT ('589 116 translate', /,'90 rotate')        
      RETURN        
C        
C        
      ENTRY PSFINS        
C     ============        
C        
C     CLOSE ROUTINE        
C        
      WRITE  (LU,1970)        
 1970 FORMAT ('showpage')        
      RETURN        
C        
C        
      ENTRY PSTRKE        
C     ============        
C        
C     STROKE ROUTINE        
C        
      WRITE  (LU,1980)        
 1980 FORMAT ('stroke')        
      RETURN        
      END        
C        
C     ================================================================= 
C        
      SUBROUTINE PSLINE        
C        
C     POSTSCRIPT LINE ROUTINE        
C        
      INTEGER     R,S,T,U        
      REAL        SCALE        
      CHARACTER*7 MT,LT        
      COMMON      CMND,CTRL,R,S,T,U        
      COMMON /PS/ LU,SCALE,JOUNT,NBUFF,DUMMY(3)        
      DATA    MT, LT /' moveto', ' lineto' /        
C        
      R = R*SCALE        
      S = S*SCALE        
      T = T*SCALE        
      U = U*SCALE        
      WRITE  (LU,2000) R,S,MT, T,U,LT        
 2000 FORMAT (2I5,A7, /,2I5,A7)        
      JOUNT = JOUNT + 1        
      IF (JOUNT .LE. NBUFF) RETURN        
      CALL PSTRKE        
      JOUNT = 0        
      RETURN        
      END        
C        
C     ================================================================= 
C        
      SUBROUTINE PSCHAR (CHRSET,CMNDX)        
C        
C     PUT CHARACTERS INTO ONE STRING IF APPLICABLE. UP TO 70 CHARACTERS.
C        
C     IF CMNDS=4 AT 2120 IS REMOVED, NO CHARACTER STRING WILL BE FORMED,
C     AND EACH CHARACTER WILL BE POSITIONED AND TYPED INDIVIDUALLY      
C        
      IMPLICIT INTEGER (A-Z)        
      LOGICAL     CHRSET        
      REAL        SCALE,CSCAL        
      CHARACTER   CHR94*48,BSS0*2        
      CHARACTER*1 SAVE(76),SHOW(6),BS,S0,S2,S3,S5,S6,S7,BS0(2)        
      COMMON      CMND,CNTRL,R,S,T        
      COMMON /PS/ LU,SCALE,JOUNT,NBUFF,ONCE,CSCAL,CHRPOS        
      EQUIVALENCE (BS0(1),BSS0,BS),(BS0(2),S0)        
      DATA        SHOW  / ')',' ','s','h','o','w' /        
      DATA        BSS0,S2,S3,S5,S6,S7 / '\0','2','3','5','6','7'/       
      DATA        CHR94 /        
     1           '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ()+-*/=.,$" ' /   
C                 000000000111111111122222222223333333333444444444      
C                          0         0         0         0       8      
C                 49-52 = SPECIAL CHARACTERS        
C                 FROM NASTRAN USER NANUAL P. 4.4-5        
C        
      IF (ONCE .NE. -1) GO TO 2110        
      ONCE = 0        
      WRITE  (LU,2100) CSCAL        
 2100 FORMAT ('/Courier-Bold findfont',F5.1,' scalefont setfont')       
C        
C     CORRECTION FOR CHARACTER X-Y POSITION.        
C     FROM CHARACTER CENTER TO CHARACTER LOWER LEFT CORNER        
C        
      DELY = 8*T/2 + 1        
      DELX = DELY*2/3 + 1        
      GO TO 2120        
C        
 2110 IF (CMNDX .EQ. 14) GO TO 2200        
      IF (ONCE  .GT.  0) GO TO 2140        
 2120 IF (CHRPOS .EQ. 0) CMNDX = 4        
      R  = (R-DELX)*SCALE        
      S  = (S-DELY)*SCALE        
      WRITE  (LU,2130) R,S        
 2130 FORMAT (2I5,' moveto')        
      JOUNT = JOUNT + 1        
      COUNT = 0        
      ONCE  = 1        
C        
 2140 COUNT = COUNT + 1        
      SAVE(COUNT) = SHOW(2)        
      IF (CNTRL.GE.49 .AND. CNTRL.LE.52) GO TO 2150        
      IF (COUNT.LE.70 .AND. CNTRL.GE.1 .AND. CNTRL.LE.48)        
     1    SAVE(COUNT) = CHR94(CNTRL:CNTRL)        
      GO TO 2170        
C        
C     SPECIAL SYMBOLS (USER'S MANUAL P. 4.4-5)        
C                 NASTRAN         POSTCSRIPT        
C     CNTRL       ORIGINAL        EQUIVALENCE        
C     -----     -------------    --------------        
C       49      SMALL CIRCLE     BIG SOLID DOT        
C       50      SMALL SQUARE     SQUATE-CIRCLE        
C       51      SMALL DIAMOND    DAGGER        
C       52      SMALL TRIANGLE   DOUBLE-DAGGER        
C        
C     SINCE THESE SYMBOLS MAY BE PART OF A TEXT, TO ACTUALLY DRAW THESE 
C     NASTRAN ORIGINAL SYMBOLS IS NOT RECOMMENDED        
C        
 2150 IF (COUNT+3 .GT. 70) GO TO 2170        
      SAVE(COUNT  ) = BS        
      SAVE(COUNT+1) = S2        
      SAVE(COUNT+2) = S6        
      COUNT = COUNT + 3        
      IF (CNTRL .NE. 50) GO TO 2160        
      SAVE(COUNT-1) = S5        
      SAVE(COUNT  ) = S0        
      GO TO 2170        
 2160 IF (CNTRL .EQ. 49) SAVE(COUNT) = S7        
      IF (CNTRL .EQ. 51) SAVE(COUNT) = S2        
      IF (CNTRL .EQ. 52) SAVE(COUNT) = S3        
 2170 RETURN        
C        
C        
      ENTRY PSENDC (CHRSET,CMNDX)        
C     ===========================        
C        
 2200 IF (COUNT-1) 2270,2210,2230        
 2210 WRITE  (LU,2220) SAVE(1)        
 2220 FORMAT (1H(,A1,6H) show)        
      GO TO 2260        
 2230 DO 2240 J = 1,6        
 2240 SAVE(COUNT+J) = SHOW(J)        
      COUNT = COUNT + 6        
      WRITE  (LU,2250) (SAVE(J),J=1,COUNT)        
 2250 FORMAT (1H(,76A1)        
 2260 COUNT = 0        
      ONCE  = 0        
      JOUNT = JOUNT + 1        
      IF (JOUNT .LE. NBUFF) GO TO 2270        
      CALL PSTRKE        
      JOUNT = 0        
 2270 IF (CMNDX.EQ.14 .AND. CMND.EQ.4) GO TO 2120        
      CHRSET = .FALSE.        
      RETURN        
      END        
C        
C     ================================================================= 
C        
C+    SUBROUTINE NASTEK (*,FIL,NR,IBUFF,NBUFF)        
C        
C     NASTEK - INTERACTIVE DISPLAY OF NASTRAN-GENERATED PLOTS - NOV83   
C                                                       REVISED APR86   
C        
C     NASTEK PLOTS NASTRAN-GENERATED PLT1 OR PLT2 FILES ON TEKTRONIX    
C     4010 AND 4050 SERIES TERMINALS, AND RUNS ON VAX-11 COMPUTERS.     
C        
C     THE USER CAN        
C           - PLOT ALL FRAMES SEQUENTIALLY W/AUTOMATIC HARDCOPY OR PLOT 
C             ANY FRAME HE CHOOSES        
C           - SET A SCALE FACTOR TO SHRINK OR ENLARGE THE PLOTS        
C           - DRAW WITH SOLID, DASHED, OR DOTTED LINES IF THE PEN       
C             PARAMETER WAS USED IN NASTRAN        
C        
C     INPUT - THE NASTRAN-GENERATED PLT1 OR PLT2 FILE.        
C           - FIVE USER-DEFINED VALUES WHICH ARE INPUT BY THE USER      
C             IN RESPONSE TO QUESTIONS ASKED BY NASTEK.        
C        
C     NASTEK IS WRITTEN IN VAX FORTRAN 77 WITH SUBROUTINES FROM THE     
C     TEKTRONIX PLOT-10 TCS AND ADVANCED GRAPHING II PACKAGES.        
C        
C     VARIABLES        
C     CHANGE - CHANGING PLOT OPTION?        
C     CHAR   - CHARACTER ARRAY        
C     CI     - NASTRAN CONTROL INDEX        
C     CSIZE  - CHARACTER SIZE FOR QUESTIONS, NOTES, ETC        
C     CURFR  - COUNTER FOR CURRENT FRAME NUMBER IN PLT1 OR PLT2 FILE    
C     FR     - USER FRAME NUMBER TO BE PLOTTED        
C     IB     - INDEX FOR IBUFF        
C     IBUFF  - USED TO READ IN AND UNPACK PLT1 OR PLT2 FILE        
C     NBUFF  - LENGTH OF IBUFF ARRAY, EITHER 30 OR 3000        
C     LEN2X  - HALF THE WIDTH  OF FRAME IN SCREEN COORDINATES        
C     LEN2Y  - HALF THE HEIGHT OF FRAME IN SCREEN COORDINATES        
C     MAXFR  - MAXIMUM NUMBER OF FRAMES IN PLT1 OR PLT2 FILE        
C     MINX,MINY,MAXX,MAXY,MMINX,MMINY,MMAXX,MMAXY - SCREEN COORDINATES  
C     NUM    - STRING OF ASCII NUMBERS USED TO OUTPUT A NUMBER        
C     OLDT,OLDU - LAST POSITION DRAWN TO        
C     PC     - NASTRAN PLOT COMMAND  0 - NO OPERATION        
C                                    1 - START NEW PLOT        
C                                  2,3 - NOT USED IN NASTEK        
C                                    4 - PRINT A CHARACTER        
C                                  5,6 - DRAW A LINE        
C     PLOTID - HAS PLOTID FRAME BEEN PLOTTED        
C     PLOTOP - PLOT OPTION, 1 CHOOSING, 2 AUTOMATIC        
C     FIL    - NASTRAN-GENERATED PLOT FILE, PLT1 OR PLT2        
C     NR     - NO. OF PLOT COMMANDS PER FILE RECORD        
C            = 5 FOR PLT1, AND 100 FOR PLT2 FILE        
C     R,S,T,U,RSTU - NASTRAN COORDINATES        
C     RMIN,SMIN,RMAX,SMAX - NASTRAN COORDINATES        
C     SCALE  - SCALE FACTOR > 0        
C     SEARCH - SEARCHING FOR A FRAME?        
C     SIZE   - CHARACTER SIZE ON PLOTS        
C     SYM    - SYMBOL SIZES IN NASTRAN COORDINATES        
C     TERMT  - TERMINAL TYPE        
C     XCEN,YCEN - CENTER OF FRAME IN SCREEN COORDINATES        
C     XCS,YCS   - 1/2 WIDTH AND HEIGHT FOR CHARACTER IN NASTRAN        
C              COORDINATES USED TO MOVE THE CHARACTERS DOWN AND TO THE  
C              LEFT SO THAT THEY ARE CENTERED WRT THE NASTRAN COORDINATE
C              GIVING THEIR LOCATION        
C     XFAC,YFAC - SCALE FACTORS FOR CHARACTER SIZE DEPENDING ON USER    
C              SCALE FACTOR        
C        
C     WRITTEN BY: ROBERT LIPMAN        
C                 DAVID TAYLOR NAVAL SHIP RESEARCH AND DEVELOPMENT      
C                 CENTER, NUMERICAL STRUCTURAL MECHANICS BRANCH        
C                 CODE 1844        
C                 BETHESDA, MARYLAND  20084-5000        
C                 (202)-227-1922        
C        
C     MODIFIED BY G.CHAN/UNISYS IN AREAS WHERE PLOT COMMANDS ARE READ   
C     OFF PLT1 OR PLT2 FILE, IN DECODING THE COMMANDS, AND IN REPLACING 
C     THE IF-THEN-ELSE-ENDIF STUFFS BY THE OLD STYLE SIMPLE 'IF' FORTRAN
C     THE FANZY IF-THEN-ELSE-ENDIF STUFFS ARE EASY ONLY TO THE ORIGINAL 
C     DEVELOPER, AND IS VERY HARD FOR ANOTHER READER TO FOLLOW. UPDATING
C     THE PROGRAM BECOMES VERY DIFFICULT.  3/93        
C 
C+    LOGICAL        SEARCH,CHANGE,PLOTID        
C+    INTEGER        IBUFF(NBUFF),PC,CI,PLOTOP,FR,CURFR,PLTX,PLT1,PLT2, 
C+   1               FIL,XCEN,YCEN,CSIZE,TERMT        
C+    REAL           RSTU(4),CHAR(48)        
C+    COMMON /FRAME/ MMINX,MMINY,MMAXY,MMAXX,RSTU,SCALE,CURFR,        
C+   1               XCEN,YCEN,RMIN,RMAX,SMIN,SMAX,TERMT,XCS,YCS,       
C+   2               SYM1,SYM2,SYM3,SYM7,CSIZE        
C+    EQUIVALENCE    (RSTU(1),R),(RSTU(2),S),(RSTU(3),T),(RSTU(4),U),   
C+   1               (NO,CHAR(24))        
C+    DATA    CHAR /        
C+   1               1H0, 1H1, 1H2, 1H3, 1H4, 1H5, 1H6, 1H7, 1H8, 1H9,  
C+   2               1HA, 1HB, 1HC, 1HD, 1HE, 1HF, 1HG, 1HH, 1HI, 1HJ,  
C+   3               1HK, 1HL, 1HM, 1HN, 1HO, 1HP, 1HQ, 1HR, 1HS, 1HT,  
C+   4               1HU, 1HV, 1HW, 1HX, 1HY, 1HZ, 1H(, 1H), 1H+, 1H-,  
C+   5               1H*, 1H/, 1H=, 1H., 1H,, 1H$, 1H', 1H   /        
C+    DATA    NOUT , IN / 6,5/,  PLT1,PLT2,NN / 4HPLT1, 4HPLT2, 1Hn  /  
C        
C+    PLTX = PLT1        
C+    IF (NR .EQ. 100) PLTX = PLT2        
C+    NCOM = NBUFF/NR        
C        
C     INITIALIZE THE TERMINAL        
C        
C+ 10 WRITE  (NOUT,20)        
C+ 20 FORMAT (/,' ENTER THE TERMINAL BAUD RATE? ',$)        
C+    READ (IN,30,ERR=10) IBAUD        
C+ 30 FORMAT (I5)        
C+    IF (IBAUD.NE.300  .AND. IBAUD.NE.1200 .AND. IBAUD.NE.4800 .AND.   
C+   1    IBAUD.NE.9600 .AND. IBAUD.NE.109200) GO TO 10        
C+    CALL INITT (IBAUD/10)        
C+    CALL TERM  (3,4096)        
C        
C     INITIALIZE SOME VARIABLES        
C        
C+    CHANGE =.FALSE.        
C+    OLDT   = 1.E30        
C+    OLDU   = 1.E30        
C        
C     SET MAXIMUM SIZE OF FRAME IN SCREEN COORDINATES        
C     3014/3900 = 8.5/11        
C        
C+    MMINX = 0        
C+    MMINY = 0        
C+    MMAXX = 3900        
C+    MMAXY = 3014        
C+    XCEN  = (MMAXX + MMINX)/2        
C+    YCEN  = (MMAXY + MMINY)/2        
C        
C     START OUTPUT        
C        
C+    CALL CHRSIZ (4)        
C+    TERMT = 0        
C+ 40 CALL NEWPAG        
C+    IF (TERMT .NE. 0) CALL CHRSIZ (CSIZE)        
C+    CALL ANMODE        
C        
C     PRINT SOME NOTES        
C        
C+    IF (TERMT .NE. 0) GO TO 80        
C        
C     INSERT NOTES HERE        
C        
C     GET TERMINAL TYPE FROM USER        
C        
C+ 50 WRITE  (NOUT,60)        
C+ 60 FORMAT (/,' ENTER THE TEKTRONIX TERMINAL TYPE', /,        
C+   1           ' 1 - 4014, 4015, 4054', /,        
C+   2           ' 2 - 4016', /,        
C+   3           ' 3 - 4010, 4012, 4013, 4051, 4052', /,' ? ',$)        
C+    READ (IN,70,ERR=50) TERMT        
C+ 70 FORMAT (I1)        
C+    IF (TERMT.EQ.0 .OR. TERMT.GE.4) GO TO 50        
C+    IF (TERMT .EQ. 1) CSIZE = 4        
C+    IF (TERMT .EQ. 2) CSIZE = 3        
C+    IF (TERMT .EQ. 3) CSIZE = 1        
C+    IF (TERMT .LE. 2) CALL CHRSIZ (CSIZE)        
C        
C+ 80 REWIND FIL        
C+    IB     = NBUFF        
C+    CURFR  =-1        
C+    MAXFR  = 100000        
C+    PLOTID = .FALSE.        
C+    SEARCH = .TRUE.        
C+    FR     = 0        
C        
C     GET PLOTTING OPTION FROM USER        
C        
C+ 90 WRITE  (NOUT,100)        
C+100 FORMAT (/,' ENTER A PLOTTING OPTION', /,        
C+   1          ' 1 - PLOT ANY FRAME OF YOUR CHOICE', /,        
C+   2          ' 2 - PLOT AUTOMATICALLY, ALL FRAMES SEQUENTIALLY WITH',
C+   3          ' HARDCOPY', /,' ? ',$)        
C+    READ (IN,70,ERR=90) PLOTOP        
C+    IF (PLOTOP.NE.1 .AND. PLOTOP.NE.2) GO TO 90        
C        
C     PRINT NOTES        
C        
C+    IF (PLOTOP .EQ. 1) WRITE (NOUT,110)        
C+110 FORMAT (/,' NOTE - WHEN ASKED ''PLOT FRAME NUMBER ?'' ENTER',     
C+   1        /9X,'ANY FRAME NUMBER TO PLOT THAT FRAME OR',        
C+   2        /9X,' 0 TO PLOT THE NEXT FRAME, OR',        
C+   3        /8X,'-1 TO RESTART NASTEK, OR',        
C+   4        /8X,'-2 TO END NASTPLOT')        
C+    IF (PLOTOP .EQ. 2) WRITE (NOUT,120)        
C+120 FORMAT (/' NOTE - AFTER ALL FRAMES ARE PLOTTED THE PROGRAM',      
C+   1        /8X,'WILL ASK ''RESTART NASTPLOT (Y/N) ?''')        
C        
C     GET SCALE FACTOR FROM USER        
C        
C+130 WRITE  (NOUT,140)        
C+140 FORMAT (/' ENTER A SCALE FACTOR (SCALE>0)',        
C+   1        /' =1 NORMAL',        
C+   2        /' >1 ENLARGE ALL FRAMES',        
C+   3        /' <1 SHRINK ALL FRAMES',/,' ? ',$)        
C+    READ (IN,150,ERR=130) SCALE        
C+150 FORMAT (F7.3)        
C+    IF (SCALE.LT.0.01 .OR. SCALE.GT.999.) GO TO 130        
C        
C     BRANCH DEPENDING ON IF RESTARTED AND PLOT OPTION        
C        
C+    IF (.NOT.CHANGE) GO TO 160        
C+    CHANGE = .FALSE.        
C+    IF (PLOTOP .EQ. 1) GO TO 340        
C        
C     READ PLT1 OR PLT2 FILE AND UNPACK ONE RECORD WITH NR COMMNADS     
C        
C+160 IF (IB .LE. NBUFF) GO TO 280        
C+    IB = 1 - NCOM        
C+    READ (FIL,170,END=180,ERR=260) IBUFF        
C+170 FORMAT (3000A1)        
C+    GO TO 280        
C        
C     EOF FOUND ON PLOT FILE, REWIND IT IF NOT EMPTY        
C        
C+180 IF (MAXFR .EQ. 100000) MAXFR = CURFR        
C+    IF (MAXFR .NE. -1) GO TO 200        
C+    WRITE  (NOUT,190) PLTX        
C+190 FORMAT (/,' *ERROR*  THIS IS NOT A ',A4,' FILE, TRY AGAIN')       
C+    RETURN 1        
C        
C+200 REWIND FIL        
C+    CURFR = -1        
C+    IB    = NBUFF        
C        
C     EOF ON PLOT FILE, PLOTOP=1 AND SEARCHING THEN FRAME NOT FOUND,    
C     TRY AGAIN        
C        
C+    IF (PLOTOP .EQ. 2) GO TO 220        
C+    IF (.NOT.SEARCH) GO TO 340        
C+    SEARCH = .FALSE.        
C+    WRITE  (NOUT,210) MAXFR        
C+210 FORMAT (25X,'MAXIMUM FRAME NUMBER IS',I4,', TRY AGAIN')        
C+    GO TO 340        
C        
C     EOF ON PLOT FILE, PLOTOP=2, OPTION TO RESTART NASTPLOT        
C        
C+220 CALL BELL        
C+    CALL HDCOPY        
C+    CALL MOVABS (0,3120)        
C+    IF (TERMT .LE. 2) CALL CHRSIZ (CSIZE)        
C+    CALL ANMODE        
C+230 WRITE  (NOUT,240)        
C+240 FORMAT (' RESTART NASTPLOT (Y/N) ? ',$)        
C+    READ   (IN,250,ERR=230) NY        
C+250 FORMAT (A1)        
C+    IF (NY.EQ.NO .OR. NY.EQ.NN) GO TO 500        
C+    GO TO 40        
C        
C     ERROR WHILE READING PLT1 OR PLT2 FILE        
C        
C+260 WRITE  (NOUT,270) PLTX        
C+270 FORMAT (/' *ERROR*  READING ',A4,'  FILE')        
C+    GO TO 500        
C        
C     GET A PLOT COMMAND AND DECIDE IF ITS OK        
C        
C+280 IB = IB + NCOM        
C+    PC = IBUFF(IB)        
C+    IF (PC.LE.0 .OR. PC.GE.17 .OR. (PC.NE.1.AND.SEARCH)) GO TO 160    
C        
C     GET CONTROL INDEX, RSTU        
C        
C+    CI = IBUFF(IB+1)        
C+    IF (PLTX .EQ. PLT1) GO TO 310        
C+    J1 = 3        
C+    DO 300 I = 1,4        
C+    J2 = J1 + 4        
C+    RSTU(I) = 0.0        
C+    DO 290 J = J1,J2        
C+    RSTU(I) = RSTU(I)*10. + IBUFF(J+IB)        
C+290 CONTINUE        
C+300 J1 = J1 + 5        
C+    GO TO 320        
C        
C+310 R = IBUFF(IB+2)        
C+    S = IBUFF(IB+3)        
C+    T = IBUFF(IB+4)        
C+    U = IBUFF(IB+5)        
C        
C     BRANCH ON A PLOT COMMAND        
C        
C+320 GO TO (330,160,160,430,490,490,160,160,160,160,        
C+   1       160,160,160,430,490,490,500), PC        
C        
C     START OF A NEW PLOT IN PLOT FILE        
C        
C+330 CURFR = CURFR + 1        
C        
C     IF SEARCHING FOR A FRAME, HAVE WE FOUND IT?        
C        
C+    IF (.NOT.SEARCH) GO TO 340        
C        
C     FRAME HAS BEEN FOUND, START PLOTTING, PLOTID FRAME IS PLOTTED ONCE
C     IF FRAME NOT FOUND, GO TO 40        
C        
C+    IF (CURFR .NE. FR) GO TO 160        
C+    SEARCH = .FALSE.        
C+    IF (CURFR .NE. 0) GO TO 420        
C+    IF (PLOTID) GO TO 340        
C+    PLOTID =.TRUE.        
C+    GO TO 420        
C        
C     NOT SEARCHING FOR A FRAME, PREVIOUS PLOT IS FINISHED        
C     PLOTOP=1, GET FRAME NUMBER FROM USER        
C        
C+340 IF (PLOTOP .EQ. 2) GO TO 410        
C+    CALL BELL        
C+    CALL MOVABS (0,3120)        
C+    IF (TERMT .LE. 2) CALL CHRSIZ (CSIZE)        
C+350 CALL ANMODE        
C+    WRITE  (NOUT,360)        
C+360 FORMAT (' PLOT FRAME NUMBER ? ',$)        
C+    READ (IN,370,ERR=350) FR        
C+370 FORMAT (I2)        
C+    IF (FR.EQ.0 .AND. CURFR.EQ.-1) FR = 1        
C+    IF (.NOT.(FR.LT.-2 .OR. FR.GT.MAXFR)) GO TO 390        
C+    WRITE  (NOUT,380)        
C+380 FORMAT (' TRY AGAIN')        
C+    CALL BELL        
C+    GO TO 350        
C        
C     BRANCH DEPENDING ON NEW FRAME NUMBER        
C     -1 - RESTART NASTEK        
C     -2 - END NASTEK        
C      0 OR CURRENT FRAME NUMBER - PLOT THAT FRAME        
C     ELSE SEARCH FOR THE FRAME        
C        
C+390 IF (FR .EQ.  0) FR = CURFR        
C+    IF (FR .NE. -1) GO TO 400        
C+    CHANGE = .TRUE.        
C+    GO TO 40        
C+400 IF (FR .EQ. -2) GO TO 500        
C+    IF (FR .EQ. CURFR) GO TO 420        
C+    SEARCH =.TRUE.        
C+    IF (FR .GE. CURFR) GO TO 160        
C+    CURFR = -1        
C+    REWIND FIL        
C+    IB = 1 - NCOM        
C+    GO TO 160        
C        
C     PLOTOP = 2, MAKE HARDCOPY        
C        
C+410 CALL BELL        
C+    CALL HDCOPY        
C        
C     START PLOTTING A FRAME BY DRAWING A BOX        
C        
C+420 CONTINUE
C+    CALL PFRAME        
C+    GO TO 160        
C        
C     PRINT A CHARACTER OR SYMBOL BASED ON THE CONTROL INDEX,        
C     DON'T PRINT IT IF IT IS OUTSIDE THE BOX        
C        
C+430 IF (CI.LT.1 .OR. CI.GT.48) GO TO 440        
C+    R = R - XCS        
C+    S = S - YCS        
C+    IF (R.LT.RMIN .OR. R.GT.RMAX .OR. S.LT.SMIN .OR. S.GT.SMAX)       
C+   1    GO TO 160        
C+    CALL MOVEA (R,S)        
C+    CALL A1OUT (1,CHAR(CI))        
C+440 IF (CI .GT. 52) GO TO 160        
C+    IF (R.LT.RMIN .OR. R.GT.RMAX .OR. S.LT.SMIN .OR. S.GT.SMAX)       
C+   1    GO TO 160        
C+    CALL MOVEA (R,S)        
C+    IF (CI-50) 450,460,470        
C        
C     CIRCLE SYMBOL        
C        
C+450 CALL MOVER (-SYM1,   0.)        
C+    CALL DRAWR ( SYM3, SYM7)        
C+    CALL DRAWR ( SYM7, SYM3)        
C+    CALL DRAWR ( SYM7,-SYM3)        
C+    CALL DRAWR ( SYM3,-SYM7)        
C+    CALL DRAWR (-SYM3,-SYM7)        
C+    CALL DRAWR (-SYM7,-SYM3)        
C+    CALL DRAWR (-SYM7, SYM3)        
C+    CALL DRAWR (-SYM3, SYM7)        
C+    GO TO 160        
C        
C     SQUARE SYMBOL        
C        
C+460 CALL MOVER (-SYM1, SYM1)        
C+    CALL DRAWR ( SYM2,   0.)        
C+    CALL DRAWR (   0.,-SYM2)        
C+    CALL DRAWR (-SYM2,   0.)        
C+    CALL DRAWR (   0., SYM2)        
C+    GO TO 160        
C        
C     DIAMOND SYMBOL        
C        
C+470 IF (CI .EQ. 52) GO TO 480        
C+    CALL MOVER (   0., SYM1)        
C+    CALL DRAWR ( SYM1,-SYM1)        
C+    CALL DRAWR (-SYM1,-SYM1)        
C+    CALL DRAWR (-SYM1, SYM1)        
C+    CALL DRAWR ( SYM1, SYM1)        
C+    GO TO 160        
C        
C     TRIANGLE SYMBOL        
C        
C+480 CALL MOVER (   0., SYM1)        
C+    CALL DRAWR ( SYM1,-SYM2)        
C+    CALL DRAWR (-SYM2,   0.)        
C+    CALL DRAWR ( SYM1, SYM2)        
C+    GO TO 160        
C        
C     DRAW LINE DEPENDING ON CONTROL INDEX, NO MOVE IF OLD END IS NEW   
C     START        
C     CI = 1, SOLID,      PEN 1        
C        = 2, DOTTED,     PEN 2        
C        = 3, DASH-DOT,   PEN 3        
C        = 4, SHORT-DASH, PEN 4        
C        = 5, LONG-DASH,  PEN 5        
C        
C+490 IF (CI.LT.1 .OR. CI.GT.5) CI = 1        
C+    IF (OLDT.NE.R .OR. OLDU.NE.S) CALL MOVEA (R,S)        
C+    CALL DASHA (T,U,CI-1)        
C+    OLDT = T        
C+    OLDU = U        
C+    GO TO 160        
C        
C     JOB DONE        
C        
C+500 RETURN        
C+    END        
C        
C     ================================================================= 
C        
C+     SUBROUTINE PFRAME        
C        
C     THIS ROUTINE IS CALLED ONLY BY NASTEK        
C        
C     GIVEN THE NASTRAN SIZE OF THE FRAME (S,T), FIT A FRAME ON THE     
C     TEKTRONIX SCREEN AND DRAW A BOX AROUND IT        
C        
C+    INTEGER        CURFR,XCEN,YCEN,NUM(4),SIZE,TERMT        
C+    REAL           RSTU(4),XFAC(4),YFAC(4)        
C+    COMMON /FRAME/ MMINX,MMINY,MMAXY,MMAXX,RSTU,SCALE,CURFR,        
C+   1               XCEN,YCEN,RMIN,RMAX,SMIN,SMAX,TERMT,XCS,YCS,       
C+   2               SYM1,SYM2,SYM3,SYM7,CSIZE        
C+    EQUIVALENCE    (RSTU(1),R),(RSTU(2),S),(RSTU(3),T),(RSTU(4),U)    
C+    DATA    XFAC / 1.9 ,1.64,1.1 ,1./        
C+    DATA    YFAC / 1.94,1.68,1.12,1./        
C        
C     (1) FIND SIZE OF STANDARD BOX        
C        
C+    MINX = MMINX        
C+    MINY = MMINY        
C+    MAXY = MMAXY        
C+    IF (T .NE. 0.) GO TO 10        
C+    WRITE (NOUT,15) S,T        
C+    GO TO 120        
C+ 10 MAXX = MINX + MAXY*(S/T)        
C+    IF (MAXX .LE. MMAXX) GO TO 30        
C+    MAXX = MMAXX        
C+    IF (S .NE. 0.) GO TO 20        
C+    WRITE  (NOUT,15) S,T        
C+ 15 FORMAT (/,' *ERROR*  EITHER S=0 OR T=0',2(1P,E9.2))        
C+    GO TO 120        
C+ 20 MAXY  = MAXX*(T/S)        
C+ 30 LEN2X = (MAXX-MINX)/2        
C+    LEN2Y = (MAXY-MINY)/2        
C        
C     (2) SCALE AND CENTER THE BOX        
C        
C+    IF (SCALE.GT.1. .AND. CURFR.NE.0) GO TO 40        
C+    TEMP = 1.        
C+    IF (CURFR .NE. 0) TEMP = SCALE        
C+    MINX = XCEN - LEN2X*TEMP        
C+    MAXX = XCEN + LEN2X*TEMP        
C+    MINY = YCEN - LEN2Y*TEMP        
C+    MAXY = YCEN + LEN2Y*TEMP        
C+    RMIN = 0.        
C+    RMAX = S        
C+    SMIN = 0.        
C+    SMAX = T        
C+    GO TO 50        
C+ 40 IF (SCALE .LE. 1.) GO TO 50        
C+    MINX = XCEN - LEN2X        
C+    MAXX = XCEN + LEN2X        
C+    MINY = YCEN - LEN2Y        
C+    MAXY = YCEN + LEN2Y        
C+    RMIN = S*(1.-1./SCALE)/2.        
C+    RMAX = S*(1.+1./SCALE)/2.        
C+    SMIN = T*(1.-1./SCALE)/2.        
C+    SMAX = T*(1.+1./SCALE)/2.        
C        
C     (3) DRAW A BOX AROUND THE FRAME, AND SET SCREEN AND VIRTUAL WINDOW
C        
C+ 50 CALL ANMODE        
C+    CALL NEWPAG        
C+    IF (.NOT.(MAXX.LE.MINX .OR. MAXY.LE.MINY .OR. RMAX.LE.RMIN .OR.   
C+   1    SMAX.LE.SMIN)) GO TO 60        
C+    CALL ANMODE        
C+    WRITE  (NOUT,55) MINX,MAXX,MINY,MAXY,RMIN,RMAX,SMIN,SMAX        
C+ 55 FORMAT (/,' *ERROR*  SOME OF THE MINS>=MAXS',/4I9,/4(1P,E9.3))    
C+ 60 IF (MAXX .NE. MINX) GO TO 70        
C+    CALL ANMODE        
C+    WRITE  (NOUT,65) MAXX,MINX        
C+ 65 FORMAT (/,' *ERROR*  MAXX=MINX',2I6)        
C+    GO TO 120        
C+ 70 CALL DWINDO (RMIN,RMAX,SMIN,SMAX)        
C+    CALL TWINDO (MINX,MAXX,MINY,MAXY)        
C+    CALL MOVABS (MINX,MINY)        
C+    CALL DRWABS (MINX,MAXY)        
C+    CALL DRWABS (MAXX,MAXY)        
C+    CALL DRWABS (MAXX,MINY)        
C+    CALL DRWABS (MINX,MINY)        
C        
C     (4) PRINT THE FRAME NUMBER AND SCALE IN THE LOWER RIGHT CORNER    
C        
C     CSIZE = 1,2,3,4        
C        
C+    IY = 75        
C+    IF (TERMT .GT. 2) GO TO 80        
C+    CALL CHRSIZ (CSIZE)        
C+    IY = 40        
C        
C+ 80 FCURFR = CURFR        
C+    CALL IFORM  (FCURFR,4,NUM,32)        
C+    CALL MOVABS (MAXX+15,MINY+IY)        
C+    CALL ANSTR  (4,NUM)        
C        
C+    ND = 0        
C+    IF (SCALE .LT. 10.0) ND = 2        
C+    IF (SCALE .LT. 100.) ND = 1        
C+    CALL FFORM  (SCALE,4,ND,NUM,32)        
C+    CALL MOVABS (MAXX+15,MINY)        
C+    CALL ANSTR  (4,NUM)        
C        
C     (5) FIND CHARACTER SIZE IN NASTRAN COORDINATES        
C        
C     THE NASTRAN COORDINATES FROM THE PLOT FILE ARE THE LOCATIONS      
C     OF THE CENTER OF A CHARACTER. HALF THE WIDTH AND HEIGHT        
C     (XCS,YCS) OF THE SIZE OF A CHARACTER MUST BE SUBTRACTED FROM      
C     THE NASTRAN COORDINATES TO PRINT THEM IN THE PROPER LOCATION.     
C        
C+    XCS = 7.7*(RMAX-RMIN)/(MAXX-MINX)        
C+    YCS = 1.8*XCS        
C        
C     SET SYMBOL SIZE        
C        
C+    SYM1 = YCS*SCALE        
C+    SYM2 = 2.0*YCS*SCALE        
C+    SYM3 = 0.3*YCS*SCALE        
C+    SYM7 = 0.7*YCS*SCALE        
C        
C     SET AND SCALE CHARACTER SIZE        
C        
C+    SIZE = 1        
C+    IF (TERMT .GT. 2) GO TO 90        
C+    IF (SCALE.LT.1.1 .OR. CURFR.EQ.0) SIZE = 4        
C+    IF (SCALE .LT. 1.7)  SIZE = 3        
C+    IF (SCALE .LT. 1.8)  SIZE = 2        
C+    IF (TERMT.EQ.2 .AND. SIZE.EQ.4) SIZE = 3        
C+    CALL CHRSIZ (SIZE)        
C+ 90 XCS = XCS*XFAC(SIZE)        
C+    YCS = YCS*YFAC(SIZE)        
C+    IF (CURFR .NE. 0) GO TO 100        
C+    XCS = -XCS        
C+    YCS = -YCS        
C        
C+100 RETURN        
C        
C     ERROR        
C        
C+120 STOP 'ERROR IN PFRAME/NASTEK/NASTPLOT'        
C+    END        

      FUNCTION IAPD(I,J,NC,NCRD)
      IF(J.NE.1) GO TO 10
      IAPD=NCRD+1
      IF(I.EQ.1) RETURN
      IAPD=IAPD+1
      IF(I.EQ.2) RETURN
      IAPD=3+3*(I-2)+NCRD
      RETURN
   10 IF(J.NE.2) GO TO 20
      IAPD=3+NCRD
      IF(I.EQ.1) RETURN
      IAPD=4+NCRD
      IF(I.EQ.2) RETURN
      IAPD=4+3*(I-2)+NCRD
      RETURN
   20 IAPD=J+NC*(2*J-3)+NCRD
      IF(I.EQ.1) RETURN
      IAPD=IAPD+1
      IF(I.EQ.2) RETURN
      IAPD=IAPD+2*(I-2)
      RETURN
      END

      SUBROUTINE PLA3
C*****
C THIS ROUTINE COMPUTES ELEMENT STRESSES FOR NON-LINEAR (STRESS DEPEN-
C DENT) ELEMENTS FOR WHICH THE USER HAS REQUESTED STRESS OUTPUT.  IT
C ALSO UPDATES THE ESTNL DATA BLOCK SO THAT THE OUTPUT FILE, ESTNL1,
C CONTAINS UP-TO-DATE ELEMENT STRESS INFORMATION.
C
C DMAP CALL...
C
C  PLA3  CSTM,MPT,DIT,DELTAUGV,ESTNL,CASECC/ONLES,ESTNL1/V,N,PLACOUNT/
C        V,N,PLSETNO/ $
C
C THIS ROUTINE IS THE MODULE DRIVER...  SUBROUTINE PLA31 READS THE
C INCREMENTAL DISPLACEMENT VECTOR INTO CORE AND APPENDS THE PROPER
C DISPLACEMENT VALUES TO THE ESTNL ENTRY FOR EACH ELEMENT, THEREBY
C CREATING THE ESTNLS, THE ESTNL SCRATCH FILE.  IN PLA32, THE ESTNLS
C FILE IS READ, AND THE PROPER ELEMENT ROUTINE IS CALLED.  THE ELEMENT
C ROUTINE COMPUTES THE ELEMENT STRESSES AND STORES THIS INFORMATION IN
C THE BLOCK /SOUT/.  THE ELEMENT ROUTINE ALSO UPDATES THE EST ENTRY
C WHICH HAS BEEN COMMUNICATED TO TI VIA /PLA32E/.
C*****
C
C
C
      CALL PLA31
      CALL PLA32
      RETURN
      END

      SUBROUTINE ORDER (GPLST,ID,REST,GRIDS,IDTAB,LCOR,B1,B2,B3)
C
      LOGICAL         SPILL
      INTEGER         GRIDS(1),ID(1),IDTAB(2),TP,GPLST(1),IGRD(2),SCR4,
     1                ISYM(14),ITYPE(14),HOLD(3),ELID,SILS(34),REST(2),
     2                EST,SIL,SCR2,ECPT,B1,B2,B3,THREE(3),OFFSET
      COMMON /BLANK / NGP,SKP(11),EST,SKIP1(3),SIL,SKIP2(5),ECPT,OES1,
     1                SCR1,SCR2,NEWOES,SCR4
      EQUIVALENCE     (THREE(1),IFLAG),(THREE(2),NELMT),(THREE(3),IGDPT)
      EQUIVALENCE     (KQ4,ISYM(13)),(KT3,ISYM(14))
      DATA    ISYM  / 2HSH,2HT1,2HTB,2HTP,2HTM,2HQP,2HQM,2HT2,2HQ2,2HQ1,
     1                2HM1,2HM2,2HQ4,2HT3/    ,KBAR/2HBR/
      DATA    ITYPE / 4,6,7,8,9,15,16,17,18,19,62,63,64,83/
      DATA    NTYPE / 14 /
C
C     BUILD A TABLE FOR GPECT POINTERS TO ELID AND ITS ORDERED GRID PTS
C
      SPILL = .FALSE.
      J = 1
      I = 3
      IDTAB(1) = 0
      JSPILL = 1
      LCORX  = LCOR
      NEWIN  = SCR4
      NEWOUT = SCR2
 2    CALL READ (*130,*12,EST,TP,1,0,M)
      OFFSET = 0
      IF (TP .EQ. KBAR) OFFSET = 6
      IF (TP.EQ.KT3 .OR. TP.EQ.KQ4) OFFSET = 1
 3    CALL FREAD (EST,NGPPE,1,0)
      IDTAB(I-1) = NGPPE
C
C     SKIP PAST THE NON-CONTOUR ELEMENTS
C
      DO 4 K = 1,NTYPE
      IF (TP .EQ. ISYM(K)) GO TO 8
 4    CONTINUE
 6    CALL FREAD (EST,ELID,1,0)
      IF (ELID .EQ. 0) GO TO 2
      J = 1 + NGPPE + OFFSET
      CALL FREAD (EST,0,-J,0)
      GO TO 6
C
C     CONSTRUCT IDTAB  1. 0, 2.NGPPE, 3.ELID, 4.ELIDPTR, 5.REPEAT.  3,4
C     FOR ALL ELEMENTS OF THIS TYPE, 6.REPEAT 1-5 FOR ALL ELEMENTS IN
C     THE SET. CONSTRUCT GRIDS  1-NGPPE. GRIDS FOR 1ST ELEMENT, NEXT.
C     REPEAT 1ST FOR ALL ELEMENTS IN THE IDTAB
C
 8    CALL READ (*12,*12,EST,IDTAB(I),2,0,M)
      I = I + 2
      IF (IDTAB(I-2) .NE. 0) GO TO 10
C
C     END OF ELEMENTS OF THIS TYPE
C
      TP = IDTAB(I-1)
      GO TO 3
C
 10   CALL FREAD (EST,GRIDS(J),NGPPE,0)
      IF (OFFSET .NE. 0) CALL FREAD (EST,0,-OFFSET,0)
      J = J + NGPPE
      IF (I .GE. LCORX) GO TO 14
      GO TO 8
C
C     TABLE FIT INTO CORE
C
 12   CALL BCKREC (EST)
      GO TO 16
C
C     SPILL OCCURS - TABLE DID NOT FIT
C
 14   SPILL = .TRUE.
C
C     END OF TABLE
C
 16   LIDTAB = I - 1
      IF (LIDTAB .LE. 2) GO TO (130,140), JSPILL
      LGRIDS = J - 1
      LASTNG = NGPPE
      GO TO (18,140), JSPILL
 18   CALL OPEN (*130,ECPT,GPLST(B2),0)
      CALL GOPEN (SCR2,GPLST(B1),1)
      CALL FWDREC (*120,ECPT)
      IGDPT = 0
 20   IGDPT = IGDPT + 1
      IEOR  = 0
      IF (GPLST(IGDPT) .NE. 0) GO TO 25
      CALL FWDREC (*120,ECPT)
      GO TO 20
 25   NELMT = 0
      IFLAG =-1
C
C      ECPT--1. PIVOT POINT, 2. DEG.FREEDOM, 3. -LENGTH, 4. ELID POINTER
C      5. ELTYPE, 6.SILS (THERE ARE (LENGTH-2) OF THEM), 7. REPEAT ITEMS
C      (3-6) FOR ALL ELEMENTS ATTACHED TO PIVOT, 8. EOR, 9. REPEAT ITEMS
C      (1-8) FOR ALL GRIDS IN THE PROBLEM.
C
      CALL READ (*120,*120,ECPT,IGRD,2,0,M)
 30   CALL READ (*120,*75,ECPT,LENGTH,1,0,M)
      CALL FREAD (ECPT,SILS,-LENGTH,0)
      TP = SILS(2)
      DO 32 I = 1,NTYPE
      IF (TP .EQ. ITYPE(I)) GO TO 33
 32   CONTINUE
      GO TO 30
C
C     MATCH ELIDPTR WITH ITS ELID AND GRID POINTS IF POSSIBLE
C
 33   J = 1
      DO 50 I = 1,LIDTAB,2
      IF (IDTAB(I)) 40,35,40
 35   NGPPE = IDTAB(I+1)
      GO TO 50
 40   IF (IDTAB(I+1) .EQ. SILS(1)) GO TO 55
      J = J + NGPPE
 50   CONTINUE
C
C     IF NOT IN THE TABLE, IS THERE SPILL(IE IS TABLE NOT COMPLETE).
C     NO SPILL, SKIP HIM.  YES SPILL, FLAG HIM.
C
      IF (.NOT.SPILL) GO TO (30,145), JSPILL
      ELID  =-SILS(1)
      NELMT = NELMT + 1
      GO TO 70
C
C     FOUND ELEMENT IN THE TABLE
C
 55   ELID = IDTAB(I)
      DO 60 I = 1,NGPPE
      K = J + I - 1
      IF (IGDPT .EQ. GRIDS(K)) GO TO 65
 60   CONTINUE
 65   IAFTER = I - (I/NGPPE)*NGPPE + J
      IBEFOR = J + I - 2
      IF (I .EQ. 1) IBEFOR = IBEFOR + NGPPE
      NELMT = NELMT + 1
      REST(2*NELMT-1) = GRIDS(IAFTER)
      REST(2*NELMT  ) = GRIDS(IBEFOR)
 70   ID(NELMT) = ELID
      IF (NELMT .LT. LCOR/2) GO TO (30,145), JSPILL
      GO TO 80
 75   IF (NELMT .EQ. 0) GO TO (20,140), JSPILL
      IEOR = 1
C
C     ORDER ELEMENTS IF WE HAVE REACHED END OF EST FILE
C
 80   IF (SPILL) GO TO 112
      IF (NELMT .LE.2)  GO TO 110
      INDEX = 3
      IALL  = 2*NELMT
      IONE  = REST(1)
      ITWO  = REST(2)
 85   IF (IONE .EQ. ITWO) GO TO 105
      DO 90 I = INDEX,IALL,2
      IF (ITWO .EQ. REST(I)) GO TO 95
 90   CONTINUE
      GO TO 110
 95   IF (I .EQ. INDEX) GO TO 100
      J = (INDEX+1)/2
      K = (I+1)/2
      HOLD(1) = ID(J)
      ID(J)   = ID(K)
      ID(K)   = HOLD(1)
      HOLD(2) = REST(INDEX  )
      HOLD(3) = REST(INDEX+1)
      REST(INDEX  ) = REST(I  )
      REST(INDEX+1) = REST(I+1)
      REST(I  ) = HOLD(2)
      REST(I+1) = HOLD(3)
 100  INDEX = INDEX + 2
      ITWO  = REST(INDEX-1)
      IF (INDEX .LT. IALL) GO TO 85
      IF (IONE  .NE. ITWO) GO TO 110
C
C     INTERIOR ELEMENTS
C
 105  CALL WRITE (NEWOUT,THREE,3,0)
      CALL WRITE (NEWOUT,ID,NELMT,1)
      IF (IGDPT .LT. NGP) GO TO (20,140), JSPILL
      GO TO 120
C
C     BORDER ELEMENTS
C
 110  IFLAG = -2
 112  CALL WRITE (NEWOUT,THREE,3,0)
      J = -1
      DO 115 I = 1,NELMT
      J = J + 2
      CALL WRITE (NEWOUT,ID(I),1,0)
      CALL WRITE (NEWOUT,REST(J),2,0)
 115  CONTINUE
      IQ = 2*NELMT
      CALL WRITE (NEWOUT,0,0,1)
      GO TO (118,140), JSPILL
 118  IF (IEOR) 25,25,119
 119  IF (IGDPT .LT.NGP) GO TO 20
 120  CALL CLOSE (ECPT,1)
 125  CALL WRITE (NEWOUT,0,1,1)
      CALL CLOSE (NEWOUT,1)
C
C     IF NO SPILL -  RETURN
C
 130  IF (.NOT.SPILL) GO TO 170
C
C    COME HERE IF WE HAVE SPILL
C
      I = NEWOUT
      NEWOUT = NEWIN
      NEWIN  = I
      CALL GOPEN (NEWIN,GPLST(B1),0)
      CALL GOPEN (NEWOUT,GPLST(B2),1)
      JSPILL = 2
      NGPPE  = LASTNG
      IDTAB(1) = 0
      IDTAB(2) = LASTNG
      I = 3
      J = 1
      SPILL = .FALSE.
      GO TO 8
C
C     TABLE CONSTRUCTED SO RETURN HERE
C
 140  CALL READ (*160,*160,NEWIN,THREE,3,0,M)
      NELMT = 0
 145  CALL READ (*160,*75,NEWIN,SILS(1),3,0,M)
      IF (SILS(1)) 150,150,155
 150  SILS(1) = -SILS(1)
      GO TO 33
 155  ELID  = SILS(1)
      NELMT = NELMT + 1
      REST(2*NELMT-1) = SILS(2)
      REST(2*NELMT  ) = SILS(3)
      GO TO 70
C
C     END OF FILE
C
 160  CALL CLOSE (NEWIN,1)
      GO TO 125
C
C     OUTPUT FILE MUST BE SCRATCH 2
C
 170  IF (NEWOUT .EQ. SCR2) RETURN
      CALL GOPEN  (NEWOUT,GPLST(B1),0)
      CALL GOPEN  (SCR2,GPLST(B2),1)
      CALL CPYFIL (NEWOUT,SCR2,REST,LCOR,M)
      CALL CLOSE  (SCR2,1)
      CALL CLOSE  (NEWOUT,1)
      RETURN
      END

      SUBROUTINE DELSET
C*****
C  THIS ROUTINE SETS VARIABLES FOR DUMMY ELEMENTS IN /GPTA1/
C
C  ALL MODULES USING /GPTA1/ SHOULD BE SURE TO CALL THIS ROUTINE
C  SO AS TO INSURE THAT DATA FOR ANY DUMMY ELEMENTS PRESENT GETS
C  INSERTED INTO /GPTA1/.
C*****
      INTEGER DUMTYP(9)
C
      COMMON/SYSTEM/ NSKIP(45), IDUM(9)
C
      COMMON/GPTA1 / NELEM, LAST, INCR, NE(1)
C
      DATA DUMTYP/53,54,55,56,57,58,59,60,61/
C
      DO 100 I = 1,9
      NGRIDS = IDUM(I) / 10000000
      NC = MOD( IDUM(I),10000000) / 10000
      NP = MOD( IDUM(I),10000) / 10
C
C     ND IS DECODE AND USED IN ROUTINES DS1 AND DS1A
C
      ND = MOD(IDUM(I), 10)
      IZERO = (DUMTYP(I) - 1)*INCR
      NE(IZERO+6) = NC + NGRIDS + 2
      NE(IZERO+9) = NP +2
      IF(NP.EQ. 0) NE(IZERO+9) =  0
      NE(IZERO+10) = NGRIDS
      N = 5*NGRIDS + 3 + NP + NC
      NE(IZERO+12) = N
      NE(IZERO+15) = NGRIDS + 2
  100 CONTINUE
      RETURN
      END

      SUBROUTINE DSOPEN ( DSNAME, IUNIT, IOP )
      CHARACTER*80      DSNAME
      INCLUDE          'DSIOF.COM'
C      print *,' dsopen,iunit,iop,dsname=',iunit,iop,dsname
      IF ( IOP .NE. 1 ) CALL DSOPFF ( DSNAME, IUNIT, ICCER )
      IF ( IOP .EQ. 1 ) CALL DSOCFF ( DSNAME, IUNIT, ICCER )
      NUMOPN = NUMOPN + 1
 700  RETURN
      END

      SUBROUTINE SGINO
C
C     REVISED  9/90 BY G.CHAN/UNISYS. TO REACTIVATE PLT1 FILE
C
C     THE HIGH POINTS OF PLT1 FILE ARE
C       NEW 130 COLUMN FORMAT RECORD
C       MACHINE PORTABLE FILE
C       NO DATA RECONSTRUCTION REQUIRED WHEN PLT1 IS USED BY AN EXTERNAL
C          TRANSLATOR PROGRAM
C                                          PLT2 FILE       PLT1 FILE
C     ---------------------------------  -------------  --------------
C     FILE TYPE, SEQUENTIAL FORMATTED    NO CARRIGE CTRL CARRIAGE CTRL
C     RECORD  TYPE                        ASSCII/BINARY*    ASCII
C     RECORD  LENGTH                       3000 BYTES     130 COLUMNS
C     FORTRAN FORMAT                      (10(180A4))*   (5(2I3,4I5))
C     PLOT COMMANDS PER PHYSICAL RECORD        100            5
C     DATA TYPE PER COMMAND (TOTAL)         30 BYTES       26 DECIMALS
C          COMMAND, P   (SEE USER'S MANUAL   1 BYTE         3 DIGITS
C          CONTROL, C    PAGE 4.4-2)         1 BYTE         3 DITITS
C          FIRST  VALUE, R                   5 BYTES        5 DIGITS
C          SECOND VALUE, S                   5 BYTES        5 DIGITS
C          THIRD  VALUE, T                   5 BYTES        5 DIGITS
C          FOURTH VALUE, U                   5 BYTES        5 DIGITS
C          FILLER (ALL ZEROS)                8 BYTES          NONE
C     DATA BYTE PACKING                        YES            NO
C     FILE - EDITED, PRINTED, SCREEN VIEWING   NO             YES
C     PORTABLE FILE AMONG MACHINES             NO             YES
C     FORTRAN UNIT NUMBER                      13             12
C     DISC STORAGE REQUIREMENT                  -           25% LESS
C     IF MAGNETIC TAPE - TRACK AND PARITY     9,ODD          9,ODD
C     (* 1. ASCII RECORD, BUT DATA STORED IN BINARY BYTES.
C           (IN EARLY NASTRAN PLOT TAPE DESIGN, A BYTE HAD 6
C           BITS. BUT IT IS NO LONGER TRUE. NOW, A BYTE CAN
C           BE 6, 8 OR 9 BITS, DEPENDING ON THE MACHINE)
C        2. SINCE THE RECORD LENGTH IS 3000 BYTES, A FORMAT
C           OF (750A4) IS SUFFICIENT)
C
      IMPLICIT INTEGER (A-Z)
      LOGICAL         OPEN,NOPACK
      INTEGER         BUF(1),LBUF(1),A(1),NAME(2),FORMAT(3),FORMTX(3)
      CHARACTER*7     FORTN,NONE
      COMMON /SYSTEM/ IDUM1,NOUT,SKPSYS(36),NBPC,NBPW,NCPW
CWKBNB
      CHARACTER*80  DSNAMES
      COMMON / DSNAME / DSNAMES(80)
CWKBNE
      DATA    OPEN  /.FALSE. /, NAME  / 4H SGI, 2HNO /
      DATA    PLT1,PLT2,PLTX /  4HPLT1, 4HPLT2,    0 /
      DATA    FORMAT/ 4H(10( ,  4H180A, 4H4))        /,
     1        FORMTX/ 4H(5(2 ,  4HI3,4, 4HI5))       /
      DATA    FORTN , NONE   / 'FORTRAN', 'NONE   '  /
      DATA    SHIFT , NBITS  /  0, 0                 /
C
      GO TO 250
C
C
      ENTRY SOPEN (*,PLTAPE,BUF,IBFSZ)
C     ================================
C
C     PLT2 FILE -
C     IBFSZ (FIRST WORD OF /XXPARM/), IS THE PLOT FILE BUFFER SIZE. IT
C     IS SET EQUAL TO PDATA(12,1)/NCPW IN PLTSET. PDATA(12,1) IS
C     INITIALIZED  IN PLOTBD VIA DATA(12,1) WHICH IS EQUIVALENT TO
C     PBFSIZ(1,1). COMPLICATED ISN'T IT?
C
C     (PBFSIZ(1,1)=3000, NCPW=4, IBFSZ AND BFSZ ARE THEREFORE =750 EACH
C     EACH PHYSICAL RECORD HOLDS 100 (=3000/30) PLOT COMMANDS)
C
C     NOTE - BOTH PLT2 AND PLT1 ARE SEQUENTIAL FILES, NOT DIRECT ACCESS
C     FILES. THE RECORD LENGTH, IF USED, IS BASED ON NO. CHARACTERS PER
C     WORD
C
      PTAPE = 10
      IF (PLTAPE.NE.PLT1 .AND. PLTAPE.NE.PLT2) RETURN 1
      PLTX   = PLTAPE
      NOPACK = PLTX .EQ. PLT1
      IF (NOPACK) GO TO 10
C
C     PLT2 -
C
      BFSZ   = IBFSZ
      IRECSZ = NCPW*BFSZ
      NOFF   = LOCFX(BUF(1)) - LOCFX(LBUF(1))
      GO TO 20
C
C     PLT1 -
C
CWKBR 10   PTAPE  = 12
 10   CONTINUE
      NOPACK = .TRUE.
      BFSZ   = 30
      IRECSZ = (BFSZ/6)*(2*3 + 4*5)
      NONE   = FORTN
      FORMAT(1) = FORMTX(1)
      FORMAT(2) = FORMTX(2)
      FORMAT(3) = FORMTX(3)
C
C     NOFF CAN BE SET TO ZERO IF LBUF IS LOCALLY DIMENSIONED TO 30 WORDS
C     AND OPEN CORE IS NOT USED
C
      NOFF   = LOCFX(BUF(1)) - LOCFX(LBUF(1))
C
C     OPEN STATEMENT ADDED TO SET OUTPUT RECORDSIZE GREATER THAN DEFAULT
C     (COMMENTS FORM G.C./UNISYS 1989 -
C     RECORDSIZE IS NOT ALLOWED FOR SEQUENTIAL FILE IN SOME COMPILERS,
C     (e.g. DEC/ULTRIX(RISC), AND BLOCKSIZE AND ORGANINZATION ARE NOT
C     DEFINED. RECORDTYPE='FIXED' IS ALSO NOT ALLOWED FOR SEQUENTIAL
C     FORMATTED FILE.
C     FOR UNICOS, RECL IS NOT ALLOWED IF ASSCESS=SEQUENTIAL)
C
C     FOR MACHINES THAT DO NOT HAVE 'APPEN' FEATURE
C
 20   IF (OPEN) GO TO 80
C     MA = 'A'
C     IF (NONE .EQ. 'NONE') MA = 'M'
C     IF (MACH .EQ IBM) CALL FILEDEF (PTAPE,RECFM,FB(MA))
      OPEN (UNIT   = PTAPE,
CWKBI
     1      FILE = DSNAMES(10),
     1      STATUS = 'OLD',
     2      FORM   = 'FORMATTED',
     3      ACCESS = 'SEQUENTIAL',
     4      IOSTAT = J
CHP  5      ,CARRIAGECONTROL = NONE
CHP  6      ,RECL  = IRECSZ
C            RECL IS NEEDED BY VAX, AND POSSIBLY OTHER MACHINES)
     6      )
      IF (J .NE. 0) GO TO 60
 30   READ   (PTAPE,40,END=50) J
 40   FORMAT (A1)
      GO TO 30
 50   BACKSPACE PTAPE
      GO TO 80
C
 60   OPEN (UNIT   = PTAPE,
CWKBI
     1      FILE = DSNAMES(10),
     1      STATUS = 'NEW',
     2      FORM   = 'FORMATTED',
     3      ACCESS = 'SEQUENTIAL',
     4      IOSTAT = J
CHP  5      ,CARRIAGECONTROL = NONE
CHP  6      ,RECL  = IRECSZ
C            RECL IS NEEDED BY VAX, AND POSSIBLY OTHER MACHINES)
     6      )
      IF (J .EQ. 0) GO TO 80
      WRITE  (NOUT,70) PLTX,PTAPE
 70   FORMAT ('0*** SYSTEM FATAL ERROR. SGINO CAN NOT OPEN ',A4,
     1        ' FILE, FORTRAN UNIT',I5)
      CALL MESAGE (-61,0,0)
C
 80   OPEN  = .TRUE.
      NB    = 1
      IF (NOPACK) GO TO 210
      ASSIGN 100 TO TRA
      WORD  = 0
      NBITS = NBPW - NBPC
      SHIFT = NBITS
      GO TO 250
C
C
      ENTRY SWRITE (PLTAPE,A,N,EORX)
C     ==============================
C
C     SWRITE IS CALLED ONLY BY WPLT10
C
      IF (PLTAPE .NE. PLTX) GO TO 180
      EOR = EORX
      NW  = 1
  90  IF (NOPACK) GO TO 120
C
C     ORIGINAL BYTE PACKING LOGIC
C
 100  IF (NW .GT. N) GO TO 110
CUNIX IF (A(NW) .NE. 0) WORD =  OR(ISHFT(A(NW),SHIFT),WORD)
      IF (A(NW) .NE. 0) WORD = IOR(ISHFT(A(NW),SHIFT),WORD)
      NW  = NW + 1
      IF (SHIFT .EQ. 0) GO TO 105
      SHIFT = SHIFT - NBPC
      GO TO 100
 105  LBUF(NB+NOFF) = WORD
      IF (NB .EQ. BFSZ) GO TO 200
      WORD  = 0
      NB    = NB + 1
      SHIFT = NBITS
      GO TO 100
C
 110  IF (EOR .EQ. 0) GO TO 250
      EOR = 0
      IF (SHIFT .NE. NBITS) GO TO 115
      NB  = NB - 1
      IF (NB) 190,190,200
C
 115  LBUF(NB+NOFF) = WORD
      GO TO 200
C
C     NON BYTE PACKING LOGIC
C
 120  IF (NW .GT. N) GO TO 125
      LBUF(NB+NOFF) = A(NW)
      NW = NW + 1
      NB = NB + 1
      IF (NB .LE. BFSZ) GO TO 120
      NB = NB - 1
      GO TO 200
C
 125  IF (EOR .EQ. 0) GO TO 250
      EOR = 0
      IF (NB .GE. BFSZ) GO TO 135
      DO 130 J = NB,BFSZ
 130  LBUF(J+NOFF) = 0
 135  NB = BFSZ
      GO TO 200
C
C
      ENTRY SCLOSE (PLTAPE)
C     =====================
C
      EOF = 0
C
 150  IF (PLTAPE .NE. PLTX) GO TO 180
      IF (.NOT.NOPACK .AND. SHIFT.NE.NBITS) GO TO 155
      NB = NB - 1
      IF (NB) 170,170,160
 155  LBUF(NB+NOFF) = WORD
 160  ASSIGN 165 TO TRA
      GO TO 200
 165  ASSIGN 100 TO TRA
      IF (NOPACK) ASSIGN 120 TO TRA
 170  IF (EOF .EQ. 0) GO TO 175
      ENDFILE PTAPE
      GO TO 190
 175  PLTX = 0
      GO TO 190
C
 180  WRITE  (NOUT,185) PLTX,PLTAPE
 185  FORMAT ('0*** SYSTEM FATAL ERROR FROM SGINO. ',A4,' FILE OR ',A4,
     1        ' FILE GOT LOST')
      CALL ERRTRC (NAME)
C
C
      ENTRY SEOF (PLTAPE)
C     ===================
C
      EOF = 1
      GO TO 150
C
 190  NB = 1
      GO TO 250
C
 200  WRITE (PTAPE,FORMAT) (LBUF(NOFF+J),J=1,NB)
      NB = 1
      WORD  = 0
      SHIFT = NBITS
      GO TO TRA, (100,120,165)
C
 210  ASSIGN 120 TO TRA
C
 250  RETURN
      END

      SUBROUTINE DBMMGR ( OPCODE )
C*********************************************************************
C        / FCB /
C            FCB(1,I) - OPEN FLAG
C            FCB(2,I) - BUFFER ADDRESS
C            FCB(3,I) - CURRENT CLR
C            FCB(4,I) - CURRENT BLOCK NUMBER
C            FCB(5,I) - FIRST BLOCK NUMBER WRITTEN TO THIS FILE
C            FCB(6,I) - LAST BLOCK NUMBER WRITTEN TO THIS FILE
C            FCB(7,I) - MAXIMUM NUMBER OF BLOCKS TO BE ALLOCATED
C                       TO THIS FILE
C            FCB(8,I) - =0, IF NO MATRIX STRINGS WRITTEN TO FILE
C                       =1, OTHERWISE, USED TO INITIALIZE COLUMN
C                           NUMBER TO 1.
C            FCB(9,I) - INDEX TO FIRST IN-MEMORY BLOCK
C            FCB(10,I)- INDEX TO LAST IN-MEMORY BLOCK
C            FCB(11,I)- INDEX TO CURRENT IN-MEMORY BLOCK
C            FCB(12,I)- ORIGINAL BUFFER ADDRESS
C            FCB(13-14,I) - DMAP FILE NAME (2A4)
C            FCB(15,I)- OPEN FLAG FOR EXTERNAL FILE
C        / DBM/
C            IDBBAS - (INPUT)-INDEX TO IN-MEMORY DATA BASE RELATIVE
C                              TO /DBM/
C            IDBFRE - (INPUT)-INDEX TO FREE CHAIN OF IN-MEMORY DATA
C                              BASE RELATIVE TO /DBM/
C            IDBDIR - (INPUT)-INDEX TO FIRST DIRECTORY BLOCK
C            MAXALC - (OUTPUT)-MAXIMUM NUMBER OF BLOCKS AVAILABLE FOR
C                              JOB
C            MAXBLK - (OUTPUT)-MAXIMUM NUMBER OF BLOCKS ALLOCATED(JOB)
C            MAXDSK - (OUTPUT)-MAXIMUM NUMBER OF BLOCKS WRITTEN TO
C                              TO DISK
C            LENALC - (OUTPUT)-LENGTH OF EACH ALLOCATED BLOCK
C            IOCODE - (INPUT) -IO-CODE FOR OPEN/CLOSE CALL
C            IFILEX - (INPUT) -FILE NUMBER FOR GINO FILE IN /XFIAT/
C            NBLOCK - (INPUT/OUTPUT) -BLOCK NUMBER BEING REFERENCED
C            NAME   - (INPUT) -GINO FILE NAME (E.G., 101,201,303,...)
C            INDBAS - INDEX TO START OF BUFFER RELATIVE TO /ZZZZZZ/
C            INDCLR - INDEX TO CLR WITHIN BUFFER RELATIVE TO /ZZZZZZ/
C            INDCBP - INDEX TO CBP WITHIN BUFFER RELATIVE TO /ZZZZZZ/
C        FREE CHAIN FORMAT (ALSO, ALL BLOCKS ALLOCATED)
C               IDBFRE==> WORD 0    POINTER TO PREVIOUS FREE BLOCK
C                                      IN CHAIN, ALWAYS 0 FOR 1ST BLK)
C                         WORD 1    POINTER TO NEXT BLOCK IN CHAIN
C                                      -INITIALLY SET TO ZERO)
C                         WORD 2    NUMBER OF FREE WORDS IN BLOCK
C                         WORD 3    RELATIVE BLOCK NUMBER
C
C         OPCODE
C           1    OPEN
C                  /GINOX/ IOCODE = 0 ; READ WITH REWIND
C                                 = 1 ; WRITE WITH REWIND
C                                 = 2 ; READ WITHOUT REWIND
C                                 = 3 ; WRITE WITHOUT REWIND
C           2    CLOSE
C                  /GINOX/ IOCODE = 1 ; CLOSE WITH REWIND
C                                    (OTHERWISE NO REWIND)
C           3    REWIND
C           4    WRITE
C           5    READ
C           6    POSITION FILE
C                  NBLOCK = BLOCK NUMBER TO POSITION TO
C           7    DELETE FILE
C           8    PROCESS WRTBLK REQUEST (SUBSTRUCTURING)
C           9    PROCESS RDBLK REQUEST (SUBSTRUCTURING)
C********************************************************************
      INTEGER    OPCODE
      INTEGER    CASE  / 4HCASE /
      INTEGER    XYCD  / 4HXYCD /
      INTEGER    PCDB  / 4HPCDB /
      INTEGER    POOL  / 4HPOOL /
      INTEGER    XPDT  / 4HXPDT /
      INCLUDE    'DSIOF.COM'
      COMMON / XFIST  / FIST(10)
      COMMON / XFIAT  / FIAT(10)
      COMMON / ZZZZZZ / MEM(4)
      COMMON / SYSTEM / ISYSBF, IWR
      DATA     LENBUF / 0 /
      IF ( LENBUF .NE. 0 ) GO TO 10
C SET UP BLOCK ALLOCATIONS FOR DOUBLE WORD BOUNDARIES
      IBASBF = LOCFX( MEM )
      LENBUF = ISYSBF - 3 + 8
      LENALC = LENBUF
      NBUFF3 = ISYSBF - 4
      ITEST  = MOD( LENBUF,2)
      IF ( ITEST .NE. 0 ) LENBUF = LENBUF + 1
10    IF ( IDBDIR .NE. 0 ) GO TO 30
C OPCODES OF 8 AND 9 HAVE NO PURPOSE WHEN THERE IS NO USE OF THE
C IN-MEMORY DATA BASE
      IF ( OPCODE .EQ. 8 .OR. OPCODE .EQ. 9 ) GO TO 7777
C  CALL DBMIO DIRECTLY, NO IN-MEMORY DATA BASE
20    CALL DBMIO ( OPCODE )
      GO TO 7777
30    IF ( NAME .GT. 100 .AND. NAME .LT. 400 ) GO TO 50
C30    IF ( NAME .GT. 300 .AND. NAME .LT. 400 ) GO TO 50
C  CHECK FOR CASECC, XYCD, AND PCDB (SETUP IN FIAT FOR PREFACE)
      IF ( NAME .EQ. CASE ) GO TO 50
      IF ( NAME .EQ. XYCD ) GO TO 50
      IF ( NAME .EQ. PCDB ) GO TO 50
      IF ( NAME .EQ. XPDT ) GO TO 50
      IF ( NAME .EQ. POOL ) GO TO 50
C OPCODES OF 8 AND 9 HAVE NO PURPOSE WHEN THERE IS NO USE OF THE
C IN-MEMORY DATA BASE
      IF ( OPCODE .EQ. 8 .OR. OPCODE .EQ. 9 ) GO TO 7777
C CALL DBMIO DIRECTLY BECAUSE THIS IS AN EXECUTIVE FILE
      IF ( FCB(  9, IFILEX ) .NE. 0 ) CALL DBMREL
      GO TO 20
50    CONTINUE
C      IF ( IFILEX .NE. 48 ) GO TO 55
C      IF ( NAME .NE. 307 ) GO TO 55
C      WRITE(IWR,40646)OPCODE,IOCODE,NBLOCK,IFILEX,NAME,INDBAS
40646 FORMAT(/,' OPCODE,IOCODE,NBLOCK,IFILEX,NAME,INDBAS=',6I6)
C      WRITE(IWR,40647)(MEM(INDBAS+KB),KB=-4,20)
40647 FORMAT(' INPUT BUFFER HAS=',/,10(4(1X,Z8),/))
C      WRITE(6,44770)(FCB(K,IFILEX),K=1,15)
44770 FORMAT(' ENTERRED FCB=',/,2(5I8,/),2I8,4X,2A4,4X,I8)
C      CALL DBMFDP
55    CONTINUE
      GO TO ( 100,200,300,400,500,600,700,800,900),OPCODE
C****************
C OPEN CODE *********************************************************
C****************
100   CONTINUE
      FCB(  1, IFILEX ) = IOCODE
      FCB( 12, IFILEX ) = FCB(  2, IFILEX )
      IF ( FCB( 9, IFILEX ) .NE. 0 ) GO TO 130
C CHECK TO SEE IF FILE IS SELF CONTAINED ON DISK
      IF ( FCB( 5, IFILEX ) .NE. 0 ) GO TO 120
105   CONTINUE
      IF ( IOCODE .NE. 0 .AND. IOCODE .NE. 2 ) GO TO 108
      WRITE ( IWR, 9900 ) IFILEX, FCB( 13, IFILEX), FCB( 14, IFILEX )
9900  FORMAT(///,' DBMMGR ERROR, ATTEMPT TO OPEN FOR READ OR WRITE APP'
     &,'END:'
     &,/,' UNIT-',I4,'  NAME=',2A4,' WHICH DOES NOT EXIST.')
C      CALL DBMDMP
      CALL DSMSG ( 777 )
      CALL MESAGE ( -61, 0, 0 )
108   CONTINUE
C NEW FILE NAME FOR IFILEX, RELEASE ANY PREVIOUSLY ALLOCATED BLOCKS
      IF ( FCB(  9, IFILEX ) .NE. 0 ) CALL DBMREL
C CREATE FILE ENTRY IN FCB
      DO 110 I = 3,11
      IF ( I .EQ. 7 ) GO TO 110
      FCB(  I, IFILEX ) = 0
110   CONTINUE
      FCB(  4, IFILEX ) = 1
      NBLOCK            = 1
115   CONTINUE
C ALLOCATE FIRST BLOCK
      CALL DBMALB ( LENBUF, NEXBLK )
      IF ( NEXBLK .LE. 0 ) GO TO 120
      FCB(  9, IFILEX ) = NEXBLK
      FCB( 10, IFILEX ) = NEXBLK
      FCB( 11, IFILEX ) = NEXBLK
C INITIALIZE PREVIOUS, NEXT, LENGTH AND BLOCK NUMBER FOR ALLOCATED BLK
      MEM( NEXBLK   ) = 0
      MEM( NEXBLK+1 ) = 0
      MEM( NEXBLK+2 ) = LENBUF
      MEM( NEXBLK+3 ) = 1
      FCB(  2, IFILEX ) = LOCFX( MEM( NEXBLK+4 ) ) - IBASBF + 1
      CALL DBMMOV ( INDBAS, NEXBLK+4, 4)
      GO TO 7000
C NO MORE SPACE WITHIN IN-MEMORY DATA BASE, USE I/O
120   CALL DBMIO ( OPCODE )
      GO TO 7777
C FILE EXISTS IN IN-MEMORY DATA BASE
130   CONTINUE
      IF ( IOCODE .EQ. 0 ) GO TO 150
      IF ( IOCODE .EQ. 1 ) GO TO 160
      IF ( IOCODE .EQ. 2 ) GO TO 170
      IF ( IOCODE .EQ. 3 ) GO TO 180
C FILE IS OPENED FOR READ WITH REWIND
150   CONTINUE
      NEXBLK = FCB( 9, IFILEX )
      IF ( NEXBLK .GT. 0 ) GO TO 155
      WRITE ( IWR, 9910 ) IFILEX
9910  FORMAT(///,' DBMMGR ERROR, ATTEMPT TO READ FILE WITH NO BLOCKS'
     &        /,' UNIT=',I4)
C      CALL DBMDMP
      CALL DSMSG ( 777 )
      CALL MESAGE( -61, 0, 0 )
155   CONTINUE
      FCB( 11, IFILEX ) = NEXBLK
      FCB(  4, IFILEX ) = 1
      NBLOCK            = 1
      FCB(  2, IFILEX ) = LOCFX( MEM( NEXBLK+4 ) ) - IBASBF + 1
      CALL DBMMOV ( INDBAS, NEXBLK+4, 3 )
      GO TO 7000
C FILE IS OPENED FOR WRITE WITH REWIND
160   CONTINUE
      GO TO 105
C FILE IS OPENED FOR READ WITHOUT REWIND
170   CONTINUE
      NEXBLK = FCB(  10, IFILEX )
      LASTIB = MEM( NEXBLK+3 )
      NBLOCK = FCB( 4, IFILEX )
      IF ( FCB( 4, IFILEX ) .GT. LASTIB ) GO TO 120
      IF ( FCB( 4, IFILEX ) .EQ. 1 ) GO TO 150
      NEXBLK = FCB( 11, IFILEX )
      IBLK1 = FCB(  4, IFILEX )
      IBLK2 = MEM( NEXBLK+3 )
      IBLK3 = MEM( NEXBLK+7 )
      FCB(  2, IFILEX ) = LOCFX( MEM( NEXBLK+4 ) ) - IBASBF + 1
C CHECK THAT CURRENT BLOCK NUMBER MATCHES BLOCK NO. IN IN-MEM BLK
      IF ( IBLK1 .EQ. IBLK2 .AND. IBLK1 .EQ. IBLK3 ) GO TO 7000
      GO TO 190
C FILE IS OPENED FOR WRITE WITHOUT REWIND
180   CONTINUE
      NEXBLK = FCB(  10, IFILEX )
      LASTIB = MEM( NEXBLK+3 )
      IF ( FCB( 4, IFILEX ) .GT. LASTIB ) GO TO 120
C======      IF ( FCB( 4, IFILEX ) .EQ. 1      ) GO TO 160
      NEXBLK = FCB( 11, IFILEX )
C IGNORE ANY PREVIOUSLY WRITTEN BLOCKS FOR THIS FILE
      FCB(  5, IFILEX ) = 0
      FCB(  6, IFILEX ) = 0
      IBLK1  = FCB(  4, IFILEX )
      IBLK2  = MEM( NEXBLK+3 )
      IBLK3  = MEM( NEXBLK+7 )
      FCB(  2, IFILEX ) = LOCFX( MEM( NEXBLK+4 ) ) - IBASBF + 1
C CHECK THAT CURRENT BLOCK NUMBER MATCHES BLOCK NO. IN IN-MEM BLK
      IF ( IBLK1 .EQ. IBLK2 .AND. IBLK1 .EQ. IBLK3 ) GO TO 7000
190   CONTINUE
      WRITE ( IWR, 9911 ) IFILEX, IBLK1, IBLK2, IBLK3
9911  FORMAT(///' BLOCK NUMBERS INCONSISTANT ON OPEN IN DBMMGR'
     &,/,' UNIT =',I4
     &,/,' BLOCK NUMBER EXPECTED (IN FCB)  =',I8
     &,/,' BLOCK NUMBER IN IN-MEMORY BLOCK =',I8
     &,/,' BLOCK NUMBER IN BUFFER          =',I8 )
C      CALL DBMDMP
      CALL DBMFDP
      CALL DSMSG ( 777 )
      CALL MESAGE ( -61, 0, 0 )
C****************
C CLOSE CODE ********************************************************
C****************
200   CONTINUE
C CHECK TO SEE IF FILE HAS IN-MEMORY BLOCKS
      IF ( FCB(  9, IFILEX ) .NE. 0 ) GO TO 220
210   CALL DBMIO ( OPCODE )
      GO TO 7000
220   CONTINUE
CWKBDB SPR94012 10/94
C      IF ( IOCODE .NE. 1 ) GO TO 225
CC CLOSE FILE WITH REWIND
C      FCB( 11, IFILEX ) = FCB(  9, IFILEX )
C      FCB(  4, IFILEX ) = 1
C      IF ( FCB( 5, IFILEX ) .NE. 0 ) GO TO 210
CWKBDE SPR94012 10/94
C IF FILE IS OPENED FOR READ THAN GO COMPUTE STATISTICS
225   IF ( FCB(  1, IFILEX ) .EQ. 0.OR.
     &     FCB(  1, IFILEX ) .EQ. 2 ) GO TO 240
      IF ( FCB( 15, IFILEX ) .NE. 0 ) GO TO 240
C FILE OPENED FOR WRITE AND FILE NOT SPILLED TO DISK, THEN
C RELEASE LAST ALLOCATED BLOCK, BECAUSE IT WAS NOT USED
      NEXBLK = FCB( 11, IFILEX )
C RESET LAST BLOCK POINTER, GET PREVIOUS BLOCK ALLOCATED
CWKBNB SPR94012 10/94
228   IBLOCK = MEM( NEXBLK+3 )
C CHECK IF LAST BLOCK NOT USED, THERE COULD HAVE BEEN A BACKPSPACE BACK
C TO A PREVIOUS USED BLOCK (CAUSED BY CLOSE CALLING DSBRC1 TO BACKSPACE
C OVER AN EOF THAT WAS AT THE END OF A PREVIOUS BLOCK).
      IF ( IBLOCK .GT. NBLOCK ) GO TO 230
      NEXBLK = MEM( NEXBLK+1 )
      IF ( NEXBLK .EQ. 0 ) GO TO 240
      GO TO 228
230   CONTINUE
CWKBNE SPR94012 10/94
      INDBLK            = MEM( NEXBLK )
      FCB( 10, IFILEX ) = INDBLK
      FCB( 11, IFILEX ) = INDBLK
      FCB(  4, IFILEX ) = MEM( INDBLK+3 )
      FCB(  2, IFILEX ) = LOCFX( MEM( INDBLK+4 ) ) - IBASBF + 1
      CALL DBMRLB( NEXBLK )
CWKBNB SPR94012 10/94
240   IF ( IOCODE .NE. 1 ) GO TO 245
C CLOSE FILE WITH REWIND
      FCB( 11, IFILEX ) = FCB(  9, IFILEX )
      FCB(  4, IFILEX ) = 1
CWKBNE SPR94012 10/94
CWKBR  SPR94012 10/94
C240   IF ( FCB( 5, IFILEX ) .NE. 0 ) CALL DBMIO ( OPCODE )
245   IF ( FCB( 5, IFILEX ) .NE. 0 ) CALL DBMIO ( OPCODE )
      IF ( FCB( 5, IFILEX ) .LE. FCB( 6, IFILEX ) ) GO TO 7000
C SPECIAL CASE, LAST BLOCK ALLOCATED WAS FOR DISK BUT NEVER USED, RESET
C INDBAS BACK TO LAST IN-MEMORY BLOCK
      NEXBLK = FCB( 10, IFILEX )
      FCB( 2, IFILEX ) = LOCFX( MEM( NEXBLK+4 ) ) - IBASBF + 1
      FCB( 5, IFILEX ) = 0
      FCB( 6, IFILEX ) = 0
      FCB(11, IFILEX ) = FCB( 10, IFILEX )
      GO TO 7000
C****************
C REWIND OPCODE *****************************************************
C****************
300   CONTINUE
C IF FILE IS ON EXTERNAL FILE CALL DBMIO DIRECTLY
      IF ( FCB( 9, IFILEX ) .NE. 0 ) GO TO 320
      CALL DBMIO ( OPCODE )
      GO TO 7777
320   CONTINUE
      NEXBLK            = FCB(  9, IFILEX )
      FCB( 11, IFILEX ) = NEXBLK
      FCB(  4, IFILEX ) = 1
C REPLACE BUFFER ADDRESS IN FCB
      FCB( 2,IFILEX ) = LOCFX( MEM( NEXBLK+4 ) ) - IBASBF + 1
      CALL DBMMOV ( INDBAS, NEXBLK+4, 3 )
      IOCODE = 0
      IF ( FCB( 5, IFILEX ) .NE. 0 ) CALL DBMIO ( 2 )
      GO TO 7000
C****************
C WRITE CODE ********************************************************
C****************
400   CONTINUE
C CHECK TO SEE IF THIS BLOCK IS ON EXTERNAL FILE
      IF ( FCB( 15, IFILEX ) .NE. 0 ) GO TO 450
C CHECK THAT BLOCK NUMBER MATCHES
      NEXBLK = FCB( 11, IFILEX )
      IBLK1  = FCB(  4, IFILEX )
      IBLK2  = MEM( NEXBLK+3 )
      IBLK3  = MEM( NEXBLK+7 )
      IF ( IBLK1 .EQ. IBLK2 .AND. IBLK1 .EQ. IBLK3 ) GO TO 410
      WRITE ( IWR, 9940 ) IFILEX, IBLK1, IBLK2, IBLK3
9940  FORMAT(///' BLOCK NUMBERS INCONSISTANT ON WRITE IN DBMMGR'
     &,/,' UNIT = ',I4
     &,/,' BLOCK NUMBER EXPECTED (IN FCB)  =',I8
     &,/,' BLOCK NUMBER IN IN-MEMORY BLOCK =',I8
     &,/,' BLOCK NUMBER IN BUFFER          =',I8 )
C      CALL DBMDMP
      CALL DBMFDP
      CALL DSMSG ( 777 )
      CALL MESAGE ( -61, 0, 0 )
410   CONTINUE
      FCB(  4, IFILEX ) = FCB(  4, IFILEX ) + 1
      NEXBLK = MEM( INDBAS-3 )
      IF ( NEXBLK .EQ. 0 ) GO TO 420
C USE EXISTING BLOCK ALREADY ALLOCATED FROM PREVIOUS OPEN FOR WRITE
      FCB( 11, IFILEX) = NEXBLK
      FCB( 2,IFILEX ) = LOCFX( MEM( NEXBLK+4 ) ) - IBASBF + 1
      CALL DBMMOV ( INDBAS, NEXBLK+4, 4 )
      GO TO 7000
420   CONTINUE
      CALL DBMALB ( LENBUF, NEXBLK )
      IF ( NEXBLK .LE. 0 ) GO TO 440
C ANOTHER BLOCK SUCCESSFULLY ALLOCATED, CONNECT TO CHAIN
      INDBLK          = FCB( 11, IFILEX )
      MEM( INDBLK+1 ) = NEXBLK
      MEM( NEXBLK   ) = INDBLK
      MEM( NEXBLK+1 ) = 0
      MEM( NEXBLK+2 ) = LENBUF
      MEM( NEXBLK+3 ) = FCB(  4, IFILEX )
      FCB( 10, IFILEX) = NEXBLK
      FCB( 11, IFILEX) = NEXBLK
      FCB( 2,IFILEX ) = LOCFX( MEM( NEXBLK+4 ) ) - IBASBF + 1
      CALL DBMMOV ( INDBAS, NEXBLK+4, 4 )
      GO TO 7000
C NO MORE SPACE IN IN-MEMORY DATA BASE, WRITE DATA TO FILE
440   CONTINUE
C CALL DBMIO TO OPEN EXTERNAL FILE WITH REWIND
      ISAVE  = IOCODE
      ISAVEB = NBLOCK
      IOCODE = 1
      NBLOCK = FCB( 4, IFILEX )
      IPRBLK = INDBAS
C RESET BUFFER ADDRESS TO BUFFER IN USER'S OPEN CORE
      FCB( 2,IFILEX ) = FCB( 12, IFILEX )
      INDBAS = FCB( 2, IFILEX )
      CALL DBMIO ( 1 )
      IOCODE   = ISAVE
      NBLOCK   = ISAVEB
C      WRITE(6,88771)(MEM(IPRBLK+K),K=-4,4)
88771 FORMAT(' MEMPRBLK=',9(1X,Z8))
C      WRITE(6,88772)(MEM(INDBAS+K),K=-4,4)
88772 FORMAT(' MEMINDBAS=',9(1X,Z8))
C      PRINT *,' IFILEX,NBLOCK,IPRBLK,INDBAS=',IFILEX,NBLOCK,
C     & IPRBLK,INDBAS
      CALL DBMMOV ( IPRBLK, INDBAS, 4 )
C      PRINT *,' MEM(IPRBLK=',MEM(IPRBLK)
C      WRITE(6,88771)(MEM(IPRBLK+K),K=-4,4)
C      WRITE(6,88772)(MEM(INDBAS+K),K=-4,4)
      GO TO 7000
450   CONTINUE
      CALL DBMIO ( OPCODE )
      GO TO 7777
C****************
C READ CODE *********************************************************
C****************
500   CONTINUE
      IF ( FCB( 5, IFILEX ) .EQ. 0 ) GO TO 505
      IF ( FCB( 4, IFILEX ) .GE. ( FCB( 5, IFILEX ) - 1 ) ) GO TO 540
505   FCB( 4, IFILEX ) = FCB( 4, IFILEX ) + 1
      NEXBLK = MEM( INDBAS-3 )
      IF ( NEXBLK .GT. 0 ) GO TO 510
      WRITE ( IWR, 9950 ) FCB( 4, IFILEX ), IFILEX
9950  FORMAT(///,' ERROR IN DBMMGR DURING READ',/,' EXPECTED ANOTHER '
     &,' IN-MEMORY BLOCK FOR BLOCK=',I8,' UNIT=',I3)
C      CALL DBMDMP
      CALL DBMFDP
      CALL DSMSG ( 777 )
      CALL MESAGE ( -61, 0, 0 )
510   FCB(  2, IFILEX ) = LOCFX( MEM( NEXBLK+4 ) ) - IBASBF + 1
      FCB( 11, IFILEX ) = NEXBLK
      CALL DBMMOV ( INDBAS, NEXBLK+4, 3 )
      IBLK1 = FCB( 4, IFILEX)
      IBLK2 = MEM( NEXBLK+3 )
      IBLK3 = MEM( NEXBLK+7 )
      IF ( IBLK1 .EQ. IBLK2 .AND. IBLK1 .EQ. IBLK3 ) GO TO 7000
      WRITE ( IWR, 9951 ) IFILEX, IBLK1, IBLK2, IBLK3
9951  FORMAT(///' BLOCK NUMBERS INCONSISTANT ON READ IN DBMMGR'
     &,/,' UNIT =',I4
     &,/,' BLOCK NUMBER  (IN FCB)          =',I8
     &,/,' BLOCK NUMBER IN IN-MEMORY BLOCK =',I8
     &,/,' BLOCK NUMBER IN BUFFER          =',I8 )
C      CALL DBMDMP
      CALL DBMFDP
      CALL DSMSG ( 777 )
      CALL MESAGE ( -61, 0, 0 )
C BLOCK IS NOT IN MEMORY, CALL DBMIO
540   CONTINUE
      IF ( FCB( 15, IFILEX ) .NE. 0 ) GO TO 550
      ISAVE  = IOCODE
      ISAVEB = NBLOCK
      IOCODE = 0
      NBLOCK = FCB( 4, IFILEX ) + 1
      IPRBLK = INDBAS
      INDBAS = FCB( 12, IFILEX )
      FCB( 2, IFILEX ) = INDBAS
      CALL DBMIO ( 1 )
      IOCODE = ISAVE
      NBLOCK = ISAVEB
      CALL DBMMOV ( IPRBLK, INDBAS, 3 )
      GO TO 7777
550   CONTINUE
      IF ( FCB( 4, IFILEX ) .GT. FCB( 6, IFILEX ) ) GO TO 570
      INDBAS = FCB( 12, IFILEX )
      FCB( 2, IFILEX ) = INDBAS
      CALL DBMIO ( OPCODE )
      GO TO 7777
570   CONTINUE
      WRITE ( IWR, 9052 ) IFILEX
9052  FORMAT(///,' DBMMGR ERROR, ATTEMPT TO READ BEYOND EOF'
     &,/' UNIT=',I5)
C      CALL DBMDMP
      CALL DBMFDP
      CALL DSMSG ( 777 )
      CALL MESAGE ( -61, 0, 0 )
C****************
C POSITION CODE *****************************************************
C****************
600   CONTINUE
      IF ( FCB( 5, IFILEX ) .EQ. 0 ) GO TO 605
      IF ( NBLOCK .GE. FCB( 5, IFILEX ) ) GO TO 690
605   CONTINUE
C BLOCK IS IN THE IN-MEMORY DATA BASE, WALK CHAIN TO CORRECT BLOCK
      IOFF    = 1
      NBLK    = NBLOCK - 1
      NEXBLK  = FCB( 9, IFILEX )
      IF ( NBLOCK .EQ. 1 ) GO TO 670
      ICNDEX = FCB( 11, IFILEX )
      IF ( ICNDEX .EQ. 0 ) GO TO 610
      NEXBLK  = ICNDEX
      ICBLK   = MEM( ICNDEX+3 )
      IF ( ICBLK .EQ. NBLOCK ) GO TO 670
      IDIFF   = NBLOCK - ICBLK
      NBLK    = IABS( IDIFF )
      IF ( IDIFF .LT. 0 ) IOFF = 0
610   CONTINUE
      DO 620 I = 1, NBLK
      NEXBLK  = MEM( NEXBLK+IOFF )
620   CONTINUE
C SET DIRECTORY ENTRIES FOR THE POSITIONED BLOCK
670   FCB( 11, IFILEX ) = NEXBLK
      FCB(  4, IFILEX ) = NBLOCK
      FCB(  2, IFILEX ) = LOCFX( MEM(NEXBLK+4) ) - IBASBF + 1
      CALL DBMMOV ( INDBAS, NEXBLK+4, 3 )
      GO TO 7000
690   CONTINUE
      IF ( FCB( 15, IFILEX ) .NE. 0 ) GO TO 695
      ISAVE  = IOCODE
      IOCODE = 0
      IPRBLK = INDBAS
      INDBAS = FCB( 12, IFILEX )
      FCB( 2, IFILEX ) = INDBAS
      FCB( 4, IFILEX ) = NBLOCK
      CALL DBMIO( 1 )
      IOCODE = ISAVE
      CALL DBMMOV ( IPRBLK, INDBAS, 3 )
      GO TO 7777
695   CONTINUE
      FCB( 4, IFILEX ) = NBLOCK
      INDBAS = FCB( 12, IFILEX )
      FCB( 2, IFILEX ) = INDBAS
      CALL DBMIO ( OPCODE )
      GO TO 7777
C****************
C DELETE CODE *******************************************************
C****************
700   CONTINUE
      IF ( FCB( 9, IFILEX ) .EQ. 0 ) GO TO 710
      CALL DBMREL
710   CONTINUE
      CALL DBMIO ( 7 )
      DO 720 K = 1,15
      IF ( K .EQ. 7 ) GO TO 720
      FCB( K, IFILEX ) = 0
720   CONTINUE
      GO TO 7777
C****************
C WRTBLK CODE *******************************************************
C****************
C SPECIAL ENTRY FOR SUBSTRUCTURING, MOVE DATA FROM OPENCORE BUFFER
C CALLED BY WRTBLK OF GINO
800   CONTINUE
      IF ( FCB( 15, IFILEX ) .EQ. 0 ) GO TO 810
C ORIGINAL BUFFER IS BEING USED BY GINO, JUST RETURN
      GO TO 7777
810   IND1 = FCB(  2, IFILEX )
      IND2 = FCB( 12, IFILEX )
      IND1 = IND1 + 2
      IND2 = IND2 + 2
C      PRINT *,' DBMMGR,WRTBLK,IND1,IND2,NBUFF3=',IND1,IND2,NBUFF3
C      PRINT *,' DBMMGR,WRTBLK,INDBAS=',INDBAS
C      WRITE(6,44771)(FCB(K,IFILEX),K=1,15)
C      WRITE(6,44772)(MEM(IND2+K),K=1,8)
44772 FORMAT(' DBMMGR,BUFFER,IND2=',8(1X,Z8))
      DO 820 I = 1, NBUFF3
      MEM( IND1+I ) = MEM( IND2+I )
820   CONTINUE
      GO TO 7000
C****************
C RDBLK  CODE *******************************************************
C****************
C SPECIAL ENTRY FOR SUBSTRUCTURING, MOVE DATA TO ORIGINAL BUFFER IF
C THE IN-MEMORY DATA BASE IS BEING USED
C CALLED BY RDBLK
900   CONTINUE
      IF ( FCB( 15, IFILEX ) .EQ. 0 ) GO TO 910
C ORIGINAL BUFFER IS BEING USED, JUST RETURN
      GO TO 7777
910   IND1 = FCB(  2, IFILEX )
      IND2 = FCB( 12, IFILEX )
      IND1 = IND1 + 2
      IND2 = IND2 + 2
C      PRINT *,' DBMMGR,RDBLK,IND1,IND2,NBUFF3=',IND1,IND2,NBUFF3
C      PRINT *,' DBMMGR,RDBLK,INDBAS=',INDBAS
C      WRITE(6,44771)(FCB(K,IFILEX),K=1,15)
C      WRITE(6,44773)(MEM(IND1+K),K=1,8)
44773 FORMAT(' DBMMGR,BUFFER,IND1=',8(1X,Z8))
      DO 920 I = 1, NBUFF3
      MEM( IND2+I ) = MEM( IND1+I )
920   CONTINUE
      GO TO 7000
7000  CONTINUE
C SET INDBAS TO POINT TO CURRENT BUFFER
      INDBAS = FCB( 2, IFILEX )
C      IF ( NAME .NE. 307 ) GO TO 7777
C      IF ( IFILEX .NE. 48 ) GO TO 7777
C      PRINT *,' DBMMGR RETURNING,IFILEX,INDBAS=',IFILEX,INDBAS
C      PRINT *,' DBMMGR RETURNING,INDCLR,INDCBP=',INDCLR,INDCBP
C      write(6,40648)(mem(kb),kb=indbas-4,indbas+8)
40648 format(' returned buffer=',/,10(4(1x,z8),/))
C      WRITE(6,44771)(FCB(K,IFILEX),K=1,15)
C      CALL DBMFDP
44771 FORMAT(' returned FCB=',/,2(5I8,/),2I8,4X,2A4,4X,I8)
7777  CONTINUE
      RETURN
      END

      SUBROUTINE TRNSPS (Z,IZ)
C
C     MATRIX TRANSPOSE ROUTINE REPLACING NASTRAN ORIGINAL TRNSP, WHICH
C     IS AT LEAST 2 TO 4 TIMES SLOWER (COMPARISON DONE ON VAX), AND
C     USING UP TO 8 SCRATCH FILES
C
C     WITH BOTH IN-CORE AND OUT-OF-CORE LOGICS
C     (USE TRANSP FOR IN-CORE MATRIX TRANSPOSE)
C
C     IF DGFLAG = -123457890 (SET BY DTRANP), AND INPUT IS A UPPER OR
C     LOWER TRIANGULAR MATRIX, THE DIAGONAL ELEMENTS ARE REPLACED BY
C     UNITY (1.0)
C
C     CALLER MUST SUPPLY A SCRATCH FILE ISCR, IF MATRIX TO BE TRANSPOSED
C     IS SQUARE, RECTANGULAR, LOWER, AND UPPER TRIAGULAR (FORM 1,2,4,5).
C
C     THIS ROUTINE SETS UP THE OUTPUT MATRIX TRAILER WORDS IN NAMEAT
C     (FILEAT) BUT IT DOES NOT CALL WRTTRL TO WRITE THEM OUT
C
C     WRITTEN BY G.CHAN/UNISYS  12/91
C
      LOGICAL          DEBUG
      INTEGER          IZ(2),SYSBUF,BASE,FILE,DGFLAG,FILEA(7),FILEAT(7)
      DIMENSION        Z(6),A(2),NAM(2)
      DOUBLE PRECISION DA
      CHARACTER        UFM*23,UWM*25,UIM*29
      COMMON /XMSSG /  UFM,UWM,UIM
      COMMON /BLANK /  DGFLAG
      COMMON /TRNSPX/  NAMEA, NCOLA, NROWA, IFORMA,ITYPA, IA(2),
     1                 NAMEAT,NCOLAT,NROWAT,IFORAT,ITYPAT,IAT(2),
     2                 LCORE,NSCR,ISCR
      COMMON /SYSTEM/  SYSBUF,NOUT
      COMMON /PACKX /  IOTYP,IOTYPA,IP,JP,INCR
      COMMON /UNPAKX/  IOTYP1,IU,JU,INCR1
      COMMON /TYPE  /  RC(2),IWORDS(4)
      COMMON /NAMES /  RD,RDREW,WRT,WRTREW,CLSREW
      EQUIVALENCE      (FILEA(1),NAMEA),(FILEAT(1),NAMEAT),(A(1),DA)
      DATA    NAM   /  4HTRNS,4HPS    /, DEBUG / .FALSE. /
C
      CALL SSWTCH (19,I)
      IF (I .EQ. 1) DEBUG = .TRUE.
      LAST   = 1
      NTYPE  = IOTYPA
      IF (NTYPE .EQ. 3) NTYPE = 2
      IBUF1  = LCORE - SYSBUF
      IBUF   = IBUF1 - SYSBUF
      NZ     = IBUF  - 1
      IMHERE = 10
      IF (NZ .LE. 0) GO TO 820
      NREC   = 0
      FILE   = NAMEA
      IF (IFORMA.GT.2 .OR. NCOLA.EQ.1)
     1    CALL OPEN (*800,NAMEA,Z(IBUF1),RDREW)
      DO 10 I = 2,7
   10 FILEAT(I) = FILEA(I)
      IF (DEBUG) WRITE (NOUT,20) FILEAT
   20 FORMAT (' TRNSPS/@5 BEFORE TRANSPOSE, TRAIL-AT =',7I8)
      GO TO (30,30,530,600,600,500,730,550), IFORMA
C
C     SQUARE AND RECTANGULAR MATRICES
C     ===============================
C
   30 IF (NCOLA .EQ. 1) GO TO 580
      NROWAT = NCOLA
      NCOLAT = 0
      IAT(1) = 0
      IAT(2) = 0
      IP   = 1
      JP   = NROWAT
      INCR = 1
      NWD  = IWORDS(ITYPA)
      NWD1 = NWD - 1
      NWDS = NCOLA*NWD
      IF (NREC .NE. 0) GO TO 40
      IRAT = MIN0(MAX0((LCORE/100000+4)*NCOLA/NROWA,3),10)
      IEND = (IBUF1-1-NWDS)/IRAT
      IEND = MAX0(IEND,5000)
      IEND1= IEND + 1
      CALL UNPSCR (FILEA,ISCR,Z,IBUF1,IBUF,IEND,0,1)
      NREC = FILEA(4)/10
   40 FILE = ISCR
      CALL OPEN (*800,ISCR,Z(IBUF1),RDREW)
      J    = FILEA(6) - IEND*IRAT
      IF (J .GT. 0) GO TO 200
C
C     ENTIRE FILEA (FROM ISCR FILE) FITS INTO CORE
C
      IF (DEBUG) WRITE (NOUT,50) UIM
   50 FORMAT (A29,', MATRIX TRANSPOSE WAS PORCESSED BY THE NEW TRNSP ',
     1        'IN-CORE METHOD')
      CALL FWDREC (*810,ISCR)
      LL = NWDS + 1
      DO 60 I = 1,NREC
      CALL READ (*810,*60,ISCR,Z(LL),IEND1,1,K)
      IMHERE = 60
      GO TO 820
   60 LL = LL + K
      CALL CLOSE (ISCR,CLSREW)
C
      FILE = NAMEAT
      CALL OPEN (*800,NAMEAT,Z(IBUF1),WRTREW)
      CALL FNAME (NAMEAT,A(1))
      CALL WRITE (NAMEAT,A(1),2,1)
C
      DO 160 K = 1,NROWA
      DO 70  J = 1,NWDS
   70 Z(J) = 0.0
      BASE = NWDS + 2
      IF (NWD-2) 130,110,80
   80 DO 100 I = 1,NCOLA
      II = IZ(BASE-1)
      JJ = IZ(BASE  )
      IF (K.LT.II .OR. K.GT.JJ) GO TO 100
      KX = (K-II)*NWD + BASE
      LX = (I- 1)*NWD
      DO 90 J = 1,NWD
   90 Z(J+LX) = Z(J+KX)
  100 BASE = BASE + (JJ-II+1)*NWD + 2
      GO TO 150
  110 DO 120 I = 1,NCOLA
      II = IZ(BASE-1)
      JJ = IZ(BASE  )
      IF (K.LT.II .OR. K.GT.JJ) GO TO 120
      KX = (K-II)*2 + BASE
      LX = (I- 1)*2
      Z(LX+1) = Z(KX+1)
      Z(LX+2) = Z(KX+2)
  120 BASE = BASE + (JJ-II+2)*2
      GO TO 150
  130 DO 140 I = 1,NCOLA
      II = IZ(BASE-1)
      JJ = IZ(BASE  )
      IF (K.LT.II .OR. K.GT.JJ) GO TO 140
      KX = K - II + BASE
      Z(I) = Z(KX+1)
  140 BASE = BASE + JJ - II + 3
  150 CALL PACK (Z(1),NAMEAT,NAMEAT)
  160 CONTINUE
      GO TO 450
C
C     ENTIRE FILEA CAN NOT FIT INTO CORE
C
C     OPEN CORE ALLOCATION -             N1    N2              NZ
C                                        /     /  <-- IEND --> /
C     +----------------------------------+-----+---------------+---+---+
C      /          OPEN CORE               /     /                GINO
C     I1                                 I2    I3               BUFFERS
C
C      Z(I1)... Z(N1) FOR TRANSPOSED OUTPUT MATRIX NAMEAT
C     IZ(I2)...IZ(N2) IS A (3 x NREC) TABLE, (MIN, MAX, COLUMN COUNTER)
C               CONTROLLING DATA TRANSFER FROM SCRATCH FILE ISCR.
C      Z(I3)... Z(NZ) FOR INPUT MATRIX NAMEA COMING FROM ISCR
C
C     NOTE - THE RATIO OF (N1-I1)/(NZ-I3), WHICH IS IRAT, IS A FUNCTION
C            OF OPEN CORE SIZE, AND THE MATRIX COLUMN AND ROW SIZES.
C            IRAT IS LIMITED TO 10:1
C     NCPP = NO. OF COULMNS PER PASS, OF THE TRANSPOSE MATRIX NAMEAT
C
C     THE TERMS 'ROW' AND 'COLUMN' ARE LOOSELY DEFINED IN COMMENT LINES
C
  200 N2   = NZ - IEND
      I3   = N2 + 1
      N1   = N2 - 3*NREC
      I2   = N1 + 1
      NCPP = N1/NWDS
      NCP7 = NCPP*7
      NPAS = (NCOLA+NCPP-1)/NCPP
      IF (.NOT.DEBUG .AND. J.GT.3*NZ) GO TO 230
      WRITE  (NOUT,210) UIM,NPAS,J
  210 FORMAT (A29,', MATRIX TRANSPOSE WAS PROCESSED BY THE NEW TRNSP ',
     1        'OUT-OF-CORE METHOD WITH',I5,' NO. OF PASSES', /5X,
     2        '(FOR MAXIMUM EFFECIENCY, THE IN-CORE METHOD COULD BE ',
     3        'ACTIVATED WITH',I9,' ADDITIONAL OPEN CORE WORDS)')
      WRITE  (NOUT,220) N1,IEND,IRAT,NCPP,NPAS,NREC
  220 FORMAT (/5X,'OPEN CORE -',I9,' WORDS USED FOR TRANSPOSE OUTPUT ',
     1       'MATRIX, AND',I8,' WORDS FOR INPUT MATRIX (',I2,'/1 RATIO)'
     2,      /5X,'NO. OF COLUMNS PER PASS =',I5,',  NO. OF PASSES =',I6,
     3       ',  INPUT MATRIX REWRITTEN IN',I4,' RECORDS')
  230 FILE = NAMEAT
      CALL OPEN  (*800,NAMEAT,Z(IBUF),WRTREW)
      CALL FNAME (NAMEAT,A(1))
      CALL WRITE (NAMEAT,A(1),2,1)
      DO 240 MM = I2,N2,3
      IZ(MM  ) = NROWA
  240 IZ(MM+1) = 0
      CALL TMTOGO (T1)
C
C     OUTER KB-KE LOOP
C
C     MAP DATA INTO TRANSPOSE OUTPUT MATRIX SPACE, Z(I1)...Z(N1), BY
C     PASSES. EACH PASS RANGES FROM KB THRU KE COLUMNS
C
      FILE = ISCR
      KE = 0
  250 KB = KE + 1
      KE = KE + NCPP
      IF (KE .GT. NROWA) KE = NROWA
      IF (KE .NE.  NCP7) GO TO 270
      IF (DEBUG) WRITE (NOUT,260) (IZ(J),J=I2,N2)
  260 FORMAT ('  IZ(I2...N2) =',18I6, /,(15X,18I6))
      CALL TMTOGO (T2)
      T1 = (T1-T2)*0.143
      T1 = T1*FLOAT(NPAS)
      IF (T1 .GT. T2) GO TO 880
  270 CALL REWIND (ISCR)
      CALL FWDREC (*810,ISCR)
      KBE = (KE-KB+1)*NWDS
      DO 280 J = 1,KBE
  280 Z(J) = 0.0
      MM = N1 - 3
      LL = 0
      BASE = 2
C
C     MIDDLE I-LOOP
C
C     LOAD DATA FROM ISCR/NAMEA INTO Z(I3)...Z(NZ) WHEN NEEDED.
C     AND RUN THRU EACH ROW OF MATRIX NAMEA IN THIS LOOP
C
      I  = 0
  300 I  = I + 1
      IF (I .GT. NCOLA) GO TO 430
      IF (BASE .LT. LL) GO TO 340
      MM = MM + 3
      IF (KB .EQ. 1) GO TO 320
C
C     IF NOT FIRST PASS, CHECK KB AND KE AGAINST MIN/MAX TABLE IN IZ(I2)
C     THRU IZ(N2). IF THEY ARE OUTSIDE RANGE, SKIP NEXT DATA RECORD FROM
C     ISCR FILE AND UPDATE COLUMN COUNTER I
C
      IF (.NOT.(KB.GT.IZ(MM+2) .OR. KE.LT.IZ(MM+1))) GO TO 320
      CALL FWDREC (*810,ISCR)
      I  = IZ(MM+3)
      GO TO 300
  320 CALL READ (*810,*330,ISCR,Z(I3),IEND1,1,LL)
      IMHERE = 160
      GO TO 820
  330 LL = N2 + LL
      BASE = N2 + 2
  340 II = IZ(BASE-1)
      JJ = IZ(BASE  )
      IF (KB .GT. 1) GO TO 350
C
C     DURING FIRST PASS, SAVE MIN-II, MAX-JJ, AND COLUMN I IN IZ(MM)
C     TABLE. MM RUNS FROM I2 THRU N2.
C
      IF (II .LT. IZ(MM+1)) IZ(MM+1) = II
      IF (JJ .GT. IZ(MM+2)) IZ(MM+2) = JJ
      IZ(MM+3) = I
C
  350 IIKB = MAX0(II,KB)
      JJKE = MIN0(JJ,KE)
      IF (JJKE .LT. IIKB) GO TO 420
C
C     INNER K-LOOP
C
C     RUN THRU THE IIKB-JJKE ELEMENTS FOR EACH ROW OF MATRIX NAMEA,
C
C     KK = (IIKB-KB)*NWDS
C     LX = (I-1)*NWD + KK + 1
C     KK = BASE -  II*NWD + 1
C
      LX = (I-1)*NWD + (IIKB-KB)*NWDS + 1
      KX = (IIKB-II)*NWD + BASE + 1
      IF (NWD-2) 360,380,400
  360 DO 370 K = IIKB,JJKE
      Z(LX) = Z(KX)
      KX = KX + 1
  370 LX = LX + NWDS
      GO TO 420
  380 DO 390 K = IIKB,JJKE
      Z(LX  ) = Z(KX  )
      Z(LX+1) = Z(KX+1)
      KX = KX + 2
  390 LX = LX + NWDS
      GO TO 420
  400 DO 410 K = IIKB,JJKE
      Z(LX  ) = Z(KX  )
      Z(LX+1) = Z(KX+1)
      Z(LX+2) = Z(KX+2)
      Z(LX+3) = Z(KX+3)
      KX = KX + 4
  410 LX = LX + NWDS
C
C     END OF INNER K-LOOP
C
C     ADJUST BASE FOR ANOTHER ROW OF MATRIX NAMEA
C
  420 BASE = BASE + (JJ-II+1)*NWD + 2
      GO TO 300
C
C     END OF MIDDLE I-LOOP
C
C     PACK THE KB THRU KE COLUMNS OF THE TRANSPOSE MATRIX NAMEAT OUT
C
  430 DO 440 J = 1,KBE,NWDS
      CALL PACK (Z(J),NAMEAT,NAMEAT)
  440 CONTINUE
C
      IF (KE .LT. NROWA) GO TO 250
      CALL CLOSE (ISCR,1)
C
C     END OF OUTTER KB-KE LOOP, AND
C     END OF SQUARE AND RECTANGULAR MATRIX TRNASPOSE
C
C     OPEN AND CLOSE SCRATCH FILE AGAIN TO PHYSICALLY DELETE THE FILE.
C     MATRIX TRAILER WILL BE WRITTEN OUT BY DTRANP
C
  450 CALL CLOSE (NAMEAT,CLSREW)
      CALL GOPEN (ISCR,Z(IBUF1),WRTREW)
      CALL CLOSE (ISCR,CLSREW)
      GO TO 900
C
C     SYMMETRIC MATRIX
C     ================
C
  500 IF (NCOLA .EQ. NROWA) GO TO 520
      CALL FNAME (NAMEA,A)
      WRITE  (NOUT,510) UWM,A,NCOLA,NROWA
  510 FORMAT (A25,' FROM TRNSP, ',2A4,' MATRIX (',I7,4H BY ,I7,
     1        ') IS NOT SYMMETRIC NOR SQUARE ', /5X,
     2        'IT WILL BE TREATED AS RECTANGULAR')
      CALL CLOSE (NAMEA,CLSREW)
      GO TO 30
  520 FILE   = NAMEAT
      CALL OPEN (*800,NAMEAT,Z(IBUF),WRTREW)
      CALL CPYFIL (NAMEA,NAMEAT,Z(1),NZ,K)
      CALL CLOSE (NAMEAT,CLSREW)
      CALL CLOSE (NAMEA, CLSREW)
      IF (DEBUG) WRITE (NOUT,525) FILEAT
  525 FORMAT (' TRNSPS/@525 AFTER TRANSPOSE, TRAIL-AT =',7I8)
      GO TO 900
C
C     DIAGONAL MATRIX
C     ===============
C     DIAGONAL MATRIX (IFORMA=3) IS A ONE-COLUMN MATRIX. (1xN)
C
C     THE MATRIX AT RIGHT IS SQUARE (IFORMA=1),      1.  0.  0.
C     OR RECTANGULAR (IFORMA=2), AND IS NOT          0.  2.  0.
C     DIAGONAL (IFORMA=3) IN NASTRAN TERMINOLOGY     0.  0.  1.
C
  530 GO TO 520
C
C     IDENTITY MATRIX
C     ===============
C     SIMILAR TO DIAGONAL MATRIX, INDENTITY MATRIX (IFORMA = 8) IS ALSO
C     IN ONE-COLUMN MATRIX FORM
C
C     ALSO, THE IDENTITY MATRIX MAY EXIST ONLY IN THE MATRIX TRAILER.
C     IT DOES NOT PHYSICALLY EXIST.
C
C
  550 CALL READ (*900,*900,NAMEA,Z(1),1,1,J)
      CALL BCKREC (NAMEA)
      GO TO 520
C
C     ONE-COLUMN (1xN) RECTANGUALR MATRIX
C     ===================================
C     TRANSPOSE IS A ROW VECTOR, FORM=7. THE TRAILER REMAINS 1xN.
C
  580 IF (NCOLA .NE. 1) GO TO 860
      IFORAT = 8
      GO TO 520
C
C     UPPER OR LOWER TRIANGULAR MATRICES
C     ==================================
C
C     TRANSPOSE OF UPPER TRIANGULAR MATRIX IS THE LOWER TRIANG. MATRIX
C     AND VISE VERSA
C
C     (IS THIS HOW THE UPPER OR LOWER TRIANGULAR MATRIX WRITTEN? <==?
C
C     NO! IT IS NOT. WE STOP TRNSP SENDING THESE MATRICES OVER HERE.
C     BESIDE, THE LOGIC OF WRITING THE MATRIX BACKWARD HERE IS NOT
C     CORRECT. WE HAVE NOT ACCOMPLISHED THE TRANSPOSE OF THE ORIGINAL
C     MATRIX YET. ALSO, WE SHOULD WRITE THE TRANSPOSE MATRIX OUT BY
C     STRINGS, OR PACK THE MATRIX OUT)
C
  600 IMHERE = 600
      N1   = -37
      IF (N1 .EQ. -37) GO TO 830
      CALL GOPEN (ISCR,Z(IBUF),WRTREW)
      CALL SKPREC (NAMEA,NCOLA)
      NWD  = IWORDS(ITYPA)
      IRAT = 3
      IEND = (IBUF-1-NWD*NCOLA)/IRAT
      IEND1= IEND + 1
      ISUM = 0
      DO 720 I = 1,NCOLA
      IU   = 0
      CALL UNPACK (*830,NAMEA,Z(3))
      IZ(1) = IU
      IZ(2) = JU
      LL   = (JU-IU+1)*NWD + 2
      ISUM = ISUM + LL
      IF (ISUM .LE. IEND) GO TO 610
      NREC = NREC + 1
      CALL WRITE (ISCR,0,0,1)
      ISUM = LL
  610 IF (DGFLAG .NE. -123457890) GO TO 710
      IF (IFORMA .EQ. 5) GO TO 660
      GO TO (620,630,640,650), ITYPA
  620 Z(3) = 1.0
      GO TO 710
  630 DA = 1.0D+0
      Z(3) = A(1)
      Z(4) = A(2)
      GO TO 710
  640 Z(4) = 0.0
      GO TO 620
  650 Z(5) = 0.0
      Z(6) = 0.0
      GO TO 630
  660 GO TO (670,680,690,700), ITYPA
  670 Z(JU+2) = 1.0
      GO TO 710
  680 DA = 1.0D+0
      Z(JU*2+1) = A(1)
      Z(JU*2+2) = A(2)
      GO TO 710
  690 Z(JU*2+1) = 1.0
      Z(JU*2+2) = 0.0
      GO TO 710
  700 J  = JU*4 - 3
      DA = 1.0D+0
      Z(J+1) = A(1)
      Z(J+2) = A(2)
      Z(J+3) = 0.0
      Z(J+4) = 0.0
  710 CALL WRITE (ISCR,Z(1),LL,0)
      CALL BCKREC (NAMEA)
      CALL BCKREC (NAMEA)
  720 CONTINUE
      NREC = NREC + 1
      CALL WRITE (ISCR,0,0,1)
      CALL CLOSE (NAMEA,CLSREW)
      CALL CLOSE (ISCR ,CLSREW)
      ITYPAT = ITYPA
      IF (IFORMA .EQ. 4) IFORAT = 5
      IF (IFORMA .EQ. 5) IFORAT = 4
      IAT(1) = IA(1)
      IAT(2) = IA(2)
      DGFLAG = 0
      FILEA(4) = NREC*10
      FILEA(6) = ISUM
      GO TO 30
C
C     ROW VECTOR (IFORMA=7, 1xN)
C     ==========================
C
C     A ROW VECTOR IS A ROW OF MATRIX ELEMENTS STORED IN COLUMN FORMAT
C     WITH TRAILER 1xN (NOT Nx1). THEREFORE THE TRANSPOSE OF ROW VECTOR
C     (IFORMA=7) IS A COLUMN VECTOR, WHICH IS RECTANG. (IFORAT=2).
C     THE TRAILER REMAINS UNCHANGED
C
  730 IF (NCOLA .NE. 1) GO TO 860
      IFORAT = 2
      GO TO 520
C
C     ERROR MESSAGES
C
  800 IF (IFORMA .EQ. 8) GO TO 900
      N1 = -1
      GO TO 850
  810 N1 = -2
      GO TO 850
  820 N1 = -8
  830 WRITE  (NOUT,840) IMHERE
  840 FORMAT (/5X,'IMHERE =',I5)
  850 CALL MESAGE (N1,FILE,NAM)
  860 CALL FNAME (NAMEA,A)
      WRITE  (NOUT,870) UFM,A,IFORMA,NCOLA,NROWA
  870 FORMAT (A23,' FROM TRNSPS, INPUT MATRIX ',2A4,' IS NOT SUITABLE ',
     1        'FOR MATRIX TRANSPOSE.', /5X,'FORM, COLUMN, ROW =',3I6)
      CALL MESAGE (-37,NAMEA,NAM)
  880 WRITE  (NOUT,890) UFM,T1
  890 FORMAT (A23,', INSUFFICIENT TIME REMAINING FOR MATRIX TRANSPOSE',
     1       /5X,'ESTIMATED TIME NEEDED (FOR TRANSPOSE ALONE) =',I9,
     2       ' CPU SECONDS')
      CALL MESAGE (-37,0,NAM)
C
  900 RETURN
      END

      SUBROUTINE APD5
C
      EXTERNAL        ORF
      INTEGER         NAM(2),IZ(1),BACK,PSPA,IC(16),EID,PID,CIDBX,SILB,
     1                SCR1,ECTA,BGPA,GPLA,USETA,SILA,ACPT,BUF10,CA5S,
     2                CA5E,PA5S,PA5E,AUSET(6,2),SILC,ORF,USA,UK,EIDB,
     3                SILDX(4),ACSIX(4),CID(5),NECTA(2)
      REAL            VX1(3),VX2(3),ACPL(3,3),RB1(3)
      DIMENSION       AI(3),HEAD(10),IHEAD(10)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /BLANK / NK,NJ,LUSETA
      COMMON /APD1C / EID,PID,CP,NSPAN,NCHORD,NTHRY,NTHICK,IGID,
     1                X1,Y1,Z1,X12,X4,Y4,Z4,X43,XOP,X1P,ALZO,MCSTM,
     2                NCST1,NCST2,CIDBX,ACSID,IACS,SILB,NCRD,SCR1,
     3                SCR2,SCR3,SCR4,SCR5,ECTA,BGPA,GPLA,USETA,SILA,
     4                CSTMA,ACPT,BUF10,BUF11,BUF12,NEXT,LEFT,ISILN,
     5                NCAM,NAEF1,NAEF2,
     6                NCA1,NCA2,CA2S,CA2E,CA3S,CA3E,CA4S,CA4E,
     7                NPA1,NPA2,PA2S,PA2E,PA3S,PA3E,PA4S,PA4E,CA5S,CA5E,
     8                PA5S,PA5E
      COMMON /APD1D / ICPL(14),YP4,S1,C1,XP2,XP3,XP4,RA1(3)
      COMMON /ZZZZZZ/ Z(1)
      COMMON /BITPOS/ IBIT(64)
      COMMON /TWO   / ITWO(32)
      COMMON /SYSTEM/ SYSBUF,NOT
      EQUIVALENCE     (ICPL(3),RB1(1)),(ICPL(6),ACPL(1,1)),
     1                (NECTA(1),EIDB),(NECTA(2),CID(1)),
     2                (ACSIX(2),VX2(1)),(Z(1),IZ(1)),(EID,IC(1)),
     3                (SILDX(1),ICID),(SILDX(3),SILC),
     4                (AI(1),DY),(AI(2),BLOC),(AI(3),CA),
     5                (HEAD(1),IHEAD(1))
      DATA    NAM   / 4HAPD5,4H    /
C
      LCA  = 16
      NC5  = ((CA5E-CA5S)+1)/LCA
      NCAM = NCAM + NC5
C
C     INITIAL SETUP
C
      I17  = IBIT(17)
      I18  = IBIT(18)
      I19  = IBIT(19)
      I20  = IBIT(20)
      PSPA = ORF(ITWO(I17),ITWO(I20))
      USA  = ORF(PSPA,ITWO(I18))
      UK   = ORF(ITWO(I19),ITWO(I20))
      DO 5 J = 1,2
      DO 5 I = 1,6
    5 AUSET(I,J) = USA
      AUSET(3,2) = UK
      AUSET(5,2) = UK
      IHEAD(1)   = 5
      SILC = SILB
C
C     LOOP ON NC5 MOVING CAERO5 CARD TO COMMON
C
      DO 400 I = 1,NC5
      NTOT = 0
      N = (I-1)*LCA - 1
      DO 10 J = 1,LCA
      IC(J) = IZ(CA5S+N+J)
   10 CONTINUE
      MCSTM = MCSTM + 1
      IZ(CA5S+N+2) = MCSTM
      IZ(CA5S+N+8) = 5
      ACSIX(1) = MCSTM
C
C     FIND PAERO5 CARD
C
      CALL APDOE (PID,IZ,PA5S,PA5E,IPID,NPC)
      IF (IPID .EQ. 0) GO TO 999
C
C     FIND NUMBER OF STRIPS
C
      ISPAN = NSPAN
      IAST  = 0
      IF (NSPAN .NE. 0) GO TO 20
      CALL APDOE (NCHORD,IZ,NAEF1,NAEF2,IAST,NSPAN)
      IF (IAST .EQ. 0) GO TO 998
      NSPAN = NSPAN - 1
      IAST  = IAST + 1
   20 IZ(CA5S+N+4) = NSPAN
      IZ(CA5S+N+5) = 1
      IPP = IPID + 7
      NPC = NPC - 6
      IF (NPC .LT. NSPAN) GO TO 997
      IHEAD(9) = NSPAN
C
C     GET POINTS IN PROPER COORD SYSTEM
C
      CALL APDCS
      HEAD(10) = SQRT(1.0+(XP4/YP4)**2)
      IF (NEXT+3*NSPAN .GT. LEFT) GO TO 996
      IOC = NEXT
C
C     GENERATE DATA FOR BOXES
C
      NCRDP= NCRD
      FSJ1 = APDF(Z(IAST),1,ISPAN)
      YJ1  = FSJ1*YP4
      DJ1  = FSJ1*XP4
      CJ1  = X12 + FSJ1*(X43-X12)
      XIJ1 = DJ1
      XI1J1= DJ1 + CJ1
      EIDB = EID - 1
      DO 100 J = 1,NSPAN
      YJ   = YJ1
      FSJ1 = APDF(Z(IAST),J+1,ISPAN)
      YJ1  = FSJ1*YP4
      DJ1  = FSJ1*XP4
      CJ1  = X12 + FSJ1*(X43-X12)
      DY   = YJ1 - YJ
      YA   = .5*DY + YJ
      YSP  = YA
      CLOC = X12 - (X12-X43)*YA/YP4
      BLOC = CLOC*.5
      CAOC = Z(IPP)
      IPP  = IPP + 1
      CA   = CAOC*CLOC
      NSIZE= 2
      IF (CAOC .NE. 0.0) NSIZE = 3
      NJ   = NJ + NSIZE
      NK   = NK + NSIZE
      NTOT = NTOT + NSIZE
      KK   = 0
      DO 40 K = 1,3
      Z(IOC+J+KK) = AI(K)
      KK = KK + NSPAN
   40 CONTINUE
C
C     EXTERNAL ID S
C
      EIDB   = EIDB   + 1
      CID(1) = CIDBX  + 1 + 2*(J-1)
      CID(2) = CID(1) + 1
      CID(3) = CID(1) + 2
      CID(4) = CID(3) + 1
      CID(5) = EIDB
      NCID   = CID(4)
C
C     BGPDT, SPL, AND USET
C
      XIJ  = XIJ1
      XI1J = XI1J1
      XIJ1 = DJ1
      XI1J1= DJ1 + CJ1
      XIC  = (XIJ+XIJ1+BLOC)*.5
      VX1(3) = 0
      IF (J .NE. 1) GO TO 310
      ASSIGN 300 TO BACK
      ICID   = CID(1)
      VX1(1) = XIJ
      VX1(2) = YJ
      KK = 1
      GO TO 340
  300 ASSIGN 310 TO BACK
      ICID   = CID(2)
      VX1(1) = XI1J
      VX1(2) = YJ
      KK     = 1
      GO TO 340
  310 ASSIGN 320 TO BACK
      ICID   = CID(3)
      VX1(1) = XIJ1
      VX1(2) = YJ1
      KK     = 1
      GO TO 340
  320 ASSIGN 330 TO BACK
      ICID   = CID(4)
      VX1(1) = XI1J1
      VX1(2) = YJ1
      KK     = 1
      GO TO 340
  330 ASSIGN 360 TO BACK
      ICID   = CID(5)
      VX1(1) = XIC
      IF (NSIZE .EQ. 3) AUSET(6,2) = UK
      VX1(2) = YSP
      KK     = 2
  340 CALL GMMATS (ACPL,3,3,0,VX1,3,1,0,VX2)
      DO 350 K = 1,3
  350 VX2(K) = VX2(K) + RB1(K)
      CALL WRITE (BGPA,ACSIX,4,0)
      CALL WRITE (GPLA,ICID,1,0)
      CALL WRITE (USETA,AUSET(1,KK),6,0)
C
C     SIL AND EQEXIN
C
      NCRD  = NCRD + 1
      SILC  = SILC + 6
      ISILN = ISILN +6
      SILDX(4) = ISILN
      LUSETA = SILC
      SILDX(2) = 10*SILC + 1
      CALL WRITE (SILA,SILC,1,0)
      CALL WRITE (SCR2,ISILN,1,0)
      CALL WRITE (SCR2,SILC,1,0)
      CALL WRITE (SCR1,ICID,2,0)
      GO TO BACK, (300,310,320,330,360)
C
C     ECT
C
  360 CID(1) = IAPD(1,J  ,1,NCRDP)
      CID(2) = IAPD(2,J  ,1,NCRDP)
      CID(4) = IAPD(1,J+1,1,NCRDP)
      CID(3) = IAPD(2,J+1,1,NCRDP)
      CID(5) = CID(3) + 1
      CALL WRITE (ECTA,NECTA(1),6,0)
      AUSET(6,2) = USA
  100 CONTINUE
      CIDBX = NCID
C
C     PUT OUT ACPT REC
C
      IHEAD(2) = NTOT
      IHEAD(4) = NTHRY
      IF (NTHRY .EQ. 1) HEAD(10) = 0.0
      IHEAD(5) = NTHICK
      IHEAD(6) = IZ(IPID+1)
      IHEAD(7) = IZ(IPID+3)
      IHEAD(8) = IZ(IPID+5)
C
C     PROPERTY DATA
C
      IL = 0
      IN = NSPAN + 1
C
C     ALPHAS
C
      CALL APDOE (IZ(IPID+2),IZ,NAEF1,NAEF2,IL,NW)
      IF (IL .EQ. 0) GO TO 994
      IF (IHEAD(6) .EQ. 1) GO TO 50
      IHEAD(3) = NW/IN
      IF (MOD(NW,IN) .NE. 0) GO TO 994
      IHEAD(6) = NSPAN
      GO TO 60
   50 IHEAD(3) = NW/2
      IF (MOD(NW,2) .NE. 0) GO TO 994
C
C     INTEGRALS
C
   60 INT = 0
      ITN = 0
      IF (NTHICK .EQ. 0) GO TO 70
      CALL APDOE (NTHICK,IZ,NAEF1,NAEF2,INT,NWI)
      IF (INT .EQ. 0) GO TO 995
      IF (IHEAD(7).EQ.0 .AND. NWI.LT. 6) GO TO 995
      IF (IHEAD(7).NE.0 .AND. NWI.NE.12) GO TO 995
      GO TO 90
C
C     TAUS
C
   70 CALL APDOE (Z(IPID+6),IZ,NAEF1,NAEF2,ITN,NWT)
      IF (INT .EQ. 0) GO TO 993
      IF (IHEAD(8) .EQ. 0) GO TO 993
      IF (IHEAD(8) .EQ. 1) GO TO 80
      IF (NWT .NE. 3*NSPAN) GO TO 993
      IHEAD(8) = NSPAN
      GO TO 90
   80 IF (NWT .NE. 3) GO TO 993
C
C     THICKNESSES
C
   90 ITK = 0
      IF (NTHICK.NE.0 .AND. IHEAD(7).EQ.0) GO TO 99
      CALL APDOE (Z(IPID+4),IZ,NAEF1,NAEF2,ITK,NWTK)
      IF (ITK .EQ. 0) GO TO 992
      IF (INT .EQ. 0) GO TO 92
      IF (IHEAD(7) .NE. 1) IHEAD(7) = NSPAN
      IF (IHEAD(7).EQ.NSPAN .AND. NWTK.LT.NSPAN) GO TO 992
      GO TO 99
   92 IF (NWTK .LT. 2) GO TO 992
      IF (IHEAD(8).EQ.NSPAN .AND. NWTK.LT.2*NSPAN) GO TO 992
   99 CALL WRITE (ACPT,IHEAD,10,0)
      CALL WRITE (ACPT,Z(IOC+1),NSPAN*3,0)
      CALL WRITE (ACPT,Z(IL+1),NW,0)
      IF (INT .NE. 0) CALL WRITE (ACPT,Z(INT+1),NWI,0)
      IF (INT.NE.0 .AND. ITK.NE.0) CALL WRITE (ACPT,Z(ITK+1),NWTK,0)
      IF (ITN .NE. 0) CALL WRITE (ACPT,Z(ITN+1),NWT,0)
      IF (ITN .NE. 0) CALL WRITE (ACPT,Z(ITK+1),NWTK,0)
      CALL WRITE (ACPT,0,0,1)
  400 CONTINUE
      SILB = SILC
 1001 RETURN
C
C     ERROR MESSAGES
C
  992 I = IZ(IPID+4)
      GO TO 9941
  993 I = IZ(IPID+6)
      GO TO 9941
  994 I = IHEAD(6)
 9941 WRITE  (NOT,9942) UFM,I,EID
 9942 FORMAT (A23,' 2429, WRONG NUMBER OF WORDS OR CARD NOT FOUND FOR ',
     1       'CARD ID',I9, /29X,'ASSOCIATED WITH CAERO5 ID',I9)
      GO TO 1000
  995 I = NTHICK
      GO TO 9941
  996 CALL MESAGE (-8,0,NAM)
  997 I = PID
      GO TO 9941
  998 I = NCHORD
      GO TO 9941
  999 CALL EMSG (0,2323,1,2,0)
      WRITE  (NOT,891) PID,EID
  891 FORMAT (10X,16HPAERO5 CARD NO. ,I8,31H REFERENCED BY CAERO5 CARD N
     1O. ,I8,15H DOES NOT EXIST)
      GO TO 1000
 1000 CALL MESAGE (-61,0,NAM)
      GO TO 1001
      END

      SUBROUTINE HBDYS
C
C     THIS IS THE BOUNDARY CONDITION (HEAT) ELEMENT ROUTINE
C     IT PRODUCES THE STIFFNESS AND OR DAMPING ELEMENT MATRICES.
C
      LOGICAL         HEAT     ,NOGO
      INTEGER         NGRIDS(7),NECPT(53),OUTPT    ,SILTAB(8)  ,
     1                SET1(8)  ,SET2(4)  ,SILS     ,DICT(13)   ,
     2                ELID     ,ESTID
      REAL            C(16)    ,CC(4,4)  ,PI       ,MASTER(8,8),
     1                MAST(64) ,KE       ,ME       ,ITEMP      ,
     2                A1(5)    ,A2(3)    ,A3(3)    ,A4(3)
      REAL            ECPT(53)
      CHARACTER       UFM*23   ,UWM*25   ,UIM*29   ,SFM*25
      COMMON /XMSSG / UFM      ,UWM      ,UIM      ,SFM
      COMMON /SYSTEM/ KSYSTM(100)
      COMMON /EMGEST/ ECPT1    ,IFLAG    ,SILS(8)  ,V(3)       ,
     1                ECPT14   ,MATFLG   ,AF       ,EMISS      ,
     2                ABSORP   ,R1       ,R2       ,CSID(4,8)  ,
     3                AVGTMP
      COMMON /HMTOUT/ HX       ,CPX
      COMMON /MATIN / MATID    ,INFLAG   ,ELTEMP
      COMMON /EMGPRM/ D15(15)  ,KMBGG(3) ,IPREC    ,NOGO       ,
     1                HEAT     ,ICMBAR
      COMMON /EMGDIC/ DMMM(2)  ,NLOCS    ,ELID     ,ESTID
      COMMON /CONDAS/ PI
      EQUIVALENCE     (NECPT(1), ECPT(1)), (SET2(1), SET1(5))  ,
     1                (ECPT1   , ECPT(1)), (DICT5  , DICT(5))  ,
     2                (KSYSTM(2),OUTPT  ), (CC(1,1), C(1)   )  ,
     3                (MASTER(1,1),MAST(1))
      DATA    NGRIDS/ 1, 2, 2, 3, 4, 2 ,2/
C
C     EST ENTRY FOR -CHBDY- ELEMENT
C     ======================================================
C     ECPT( 1)  = EL-ID       ELEMENT ID
C     ECPT( 2)  = IFLAG       ELEM. TYPE FLAG = (1,2,3,4,5,6,7)
C     ECPT( 3)  = SIL-1       SCALER INDICES
C     ECPT( 4)  = SIL-2
C     ECPT( 5)  = SIL-3
C     ECPT( 6)  = SIL-4
C     ECPT( 7)  = SIL-5
C     ECPT( 8)  = SIL-6
C     ECPT( 9)  = SIL-7
C     ECPT(10)  = SIL-8
C     ECPT(11)  = V1          ORIENTATION VECTOR
C     ECPT(12)  = V2
C     ECPT(13)  = V3
C     ECPT(14)  = ECPT14
C     ECPT(15)  = MATFLG      MAT ID FOR MAT4, MAT5 DATA
C     ECPT(16)  = AF          AREA FACTOR
C     ECPT(17)  = EMISS       EMISSIVITY COEFF
C     ECPT(18)  = ABSORP      ABSORPTIVITY COEFF
C     ECPT(19)  = R1          RADII OF ELIPTICAL CYLINDER
C     ECPT(20)  = R2
C     ECPT(21)  = CSID-1      COORDINATE SYSTEM ID AND
C     ECPT(22)  = X1          COORDINATE GRID POINTS
C     ECPT(23)  = Y1          (1-4 ARE ELEMENT POINTS,
C     ECPT(24)  = Z1
C     ECPT(25)  = CSID-2
C     ECPT(26)  = X2
C     ECPT(27)  = Y2
C     ECPT(28)  = Z2
C     ECPT(29)  = CSID-3
C     ECPT(30)  = X3
C     ECPT(31)  = Y3
C     ECPT(32)  = Z3
C     ECPT(33)  = CSID-4
C     ECPT(34)  = X4
C     ECPT(35)  = Y4
C     ECPT(36)  = Z4
C     ECPT(37)  = CSID-5       5-8 ARE POINTS IN THE FLUID)
C       -ETC-     -ETC-
C     ECPT(53)  = AVGTMP      AVERAGE ELEM. TEMPERATURE
C
C
C     GENERAL INITIALIZATION
C
      IF (.NOT. HEAT) RETURN
      IMHERE = 0
      IF (IFLAG.LT.1 .OR. IFLAG.GT.7) GO TO 470
      IF (IFLAG .EQ. 7) AF = PI*(R1+R2)
      N = NGRIDS(IFLAG)
      DICT(1) = ESTID
      DICT(2) = 1
      DICT(4) = 1
      DICT5   = 0.0
C
C     MASTER OUTPUT MATRIX OF SIZE UP TO 8 X 8 IS FORMED.  DUPLICATE
C     SILS ARE SUPERIMPOSED RESULTING IN A POSSIBLY SMALLER OUTPUT MATRX
C
C     FOR A GIVEN ELEMENT-ID THE MATRIX OUTPUT WILL BE OF ORDER EQUAL
C     TO THE NUMBER OF UNIQUE SILS PRESENT.
C
C     IFLAG = 1 WILL BE 1X1 OR 2X2    *
C     IFLAG = 2 WILL BE 2X2 UP TO 4X4  *
C     IFLAG = 3 WILL BE 2X2 UP TO 4X4   * (DEPENDING ON GROUDING AND
C     IFLAG = 4 WILL BE 3X3 UP TO 6X6  *   DUPLICATE SILS.)
C     IFLAG = 5 WILL BE 4X4 UP TO 8X8 *
C
C     -SET1- WILL BE A MAP OF OUTPUT POSITIONS FOR SILS 1 THRU 4
C     -SET2- WILL BE A MAP OF OUTPUT POSITIONS FOR SILS 5 THRU 8
C
C
C     FIRST FORM THE TABLE OF UNIQUE SILS.
C
      ISIZE = 0
      DO 50 I = 1,8
      IF (SILS(I) .LE. 0) GO TO 50
      IF (ISIZE   .LE. 0) GO TO 40
      DO 30 J = 1,ISIZE
      IF (SILS(I) .EQ. SILTAB(J)) GO TO 50
   30 CONTINUE
   40 ISIZE = ISIZE + 1
      SILTAB(ISIZE) = SILS(I)
   50 CONTINUE
      CALL SORT (0,0,1,1,SILTAB(1),ISIZE)
      IMHERE = 50
      IF (ISIZE .LE. 0) GO TO 470
C
C     BUILD -SET1- AND -SET2- MAPS OF WHERE OUTPUTS GO IN MASTER OUTPUT.
C
      DO 100 I = 1,8
      J = 8
      IF (SILS(I) .LE. 0) GO TO 90
      DO 80 J = 1,ISIZE
      IF (SILS(I) .EQ. SILTAB(J)) GO TO 90
   80 CONTINUE
      IMHERE = 80
      GO TO 470
   90 SET1(I) = J
  100 CONTINUE
      DICT(3) = ISIZE
C
C     FORM STIFFNESS -HEAT- IF REQUESTED.
C
      IF (KMBGG(1) .EQ. 0) GO TO 360
      INFLAG = 1
      ELTEMP = AVGTMP
      MATID  = MATFLG
      IF (MATID .EQ. 0) GO TO 360
      CALL HMAT (NECPT)
      CP = CPX
      H  = HX
      IF (H .EQ. 0.0) GO TO 360
      GO TO (120,130,140,210,240,130,130), IFLAG
C
C     IFLAG = 1, (POINT), 1 GRID-POINT.  (1 X 1)  C = H * AF
C
  120 C(1) = H
      C(2) = AF
      C(1) = C(1)*C(2)
      GO TO 300
C
C     IFLAG = 2, (LINE OR ELLIPTIC CYL. )    **    **
C             2 GRID POINTS           H*AF*L * 2  1 *
C                           (2X2)  C =------ *      *
C                                       6    * 1  2 *
C                                            **    **
C
  130 C(1) = H
      C(2) = AF
      C(3) = ECPT(26) - ECPT(22)
      C(4) = ECPT(27) - ECPT(23)
      C(5) = ECPT(28) - ECPT(24)
      C(1) = C(1)*C(2)*SQRT(C(3)**2 + C(4)**2 + C(5)**2)/3.0
      C(2) = C(1)/2.0
      C(5) = C(2)
      C(6) = C(1)
      GO TO 300
C
C     IFLAG = 3, (REVOLUTION), 2 GRID-POINTS     **                **
C                                                *(3X +X )  (X + X )*
C                                        H*2PI*L *   1  2     1   2 *
C                             (2X2)  C = ------- *                  *
C                                          12    *(X + X )  (X +3X )*
C                                                *  1   2     1   2 *
C                                                **                **
C
  140 IF (ECPT(22).LE.0.0 .OR. ECPT(26).LE.0.0) GO TO 180
      IF (ECPT(23).NE.0.0 .OR. ECPT(27).NE.0.0) GO TO 180
      GO TO 200
  180 WRITE  (OUTPT,190) UFM,NECPT(1)
  190 FORMAT (A23,' 3088, ILLEGAL GEOMETRY FOR REVOLUTION ELEMENT',I14)
      NOGO = .TRUE.
      GO TO 490
C
C     FILL CONDUCTIVITIY MATRIX
C
  200 C(1) = H
      C(2) = PI
      C(3) = ECPT(26) - ECPT(22)
      C(4) = ECPT(28) - ECPT(24)
C
C     NOTE Y2 AND Y1 ARE 0 FOR REVOLUTION ELEMENT.
C
      C(1) = C(1)*C(2)*SQRT(C(3)**2 + C(4)**2)/6.0
      C(2) = C(1)*(ECPT(22) + ECPT(26))
      C(5) = C(2)
      C(6) = C(1)*(ECPT(22) + 3.0*ECPT(26))
      C(1) = C(1)*(3.0*ECPT(22) + ECPT(26))
      GO TO 300
C
C     IFLAG = 4, (TRIANGLE), 3 GRID-POINTS.       **       **
C                                                 * 2  1  1 *
C                                           H * A *         *
C                                (3X3) C =  ----- * 1  2  1 *
C                                            24   *         *
C                                                 * 1  1  2 *
C                                                 **       **
C
C
C     COMPUTE AREA -A- OF TRIANGLE   GET R2-R1 AND R3-R2
C
  210 C(1) = ECPT(26) - ECPT(22)
      C(2) = ECPT(27) - ECPT(23)
      C(3) = ECPT(28) - ECPT(24)
      C(4) = ECPT(30) - ECPT(26)
      C(5) = ECPT(31) - ECPT(27)
      C(6) = ECPT(32) - ECPT(28)
C
C     (R2-R1) X (R3-R2)  INTO  C(1),C(2),C(3)
C
      CALL SAXB (C(1),C(4),C(1))
      C(7) = SQRT(C(1)**2 + C(2)**2 + C(3)**2)
      IF (C(7) .LE. 0.0) GO TO 220
      C(2) = C(7)*H/24.0
      C(1) = 2.0 *C(2)
      C(3) = C(2)
      C(5) = C(2)
      C(6) = C(1)
      C(7) = C(2)
      C(9) = C(2)
      C(10)= C(2)
      C(11)= C(1)
      GO TO 300
  220 WRITE  (OUTPT,230) UFM,NECPT(1)
  230 FORMAT (A23,' 3089, ILLEGAL GEOMETRY FOR TRIANGLE ELEMENT',I14)
      NOGO = .TRUE.
      GO TO 490
C
C     IFLAG = 5, (QUADRILATERAL), 4 GRID-POINTS.
C
C               ***                                              ***
C               * 2(A2+A3+A4)  (A3+A4)     (A2+A4)      (A2+A3)    *
C               *                                                  *
C               *              2(A1+A3+A4) (A1+A4)      (A1+A3)    *
C   (4X4)  C  = *                                                  *
C               *                           2(A1+A2+A4) (A1+A2)    *
C               *     -SYM-                                        *
C               *                                       2(A1+A2+A3)*
C               ***                                              ***
C
C     R  =  XI, YI, ZI
C      I
C
C     A1 = MAG((R3-R2) X (R4-R3))
C     A2 = MAG((R4-R3) X (R1-R4))
C     A3 = MAG((R1-R4) X (R2-R1))
C     A4 = MAG((R2-R1) X (R3-R2))
C
C
C     R3-R2
C
  240 C( 1) = ECPT(30) - ECPT(26)
      C( 2) = ECPT(31) - ECPT(27)
      C( 3) = ECPT(32) - ECPT(28)
C
C     R4-R3
C
      C( 4) = ECPT(34) - ECPT(30)
      C( 5) = ECPT(35) - ECPT(31)
      C( 6) = ECPT(36) - ECPT(32)
C
C     R1-R4
C
      C( 7) = ECPT(22) - ECPT(34)
      C( 8) = ECPT(23) - ECPT(35)
      C( 9) = ECPT(24) - ECPT(36)
C
C     R2-R1
C
      C(10) = ECPT(26) - ECPT(22)
      C(11) = ECPT(27) - ECPT(23)
      C(12) = ECPT(28) - ECPT(24)
C
C
      CALL SAXB (C( 1),C( 4),A1(1))
      CALL SAXB (C( 4),C( 7),A2(1))
      CALL SAXB (C( 7),C(10),A3(1))
      CALL SAXB (C(10),C( 1),A4(1))
C
      C(1) = A1(1)*A2(1) + A1(2)*A2(2) + A1(3)*A2(3)
      C(2) = A1(1)*A3(1) + A1(2)*A3(2) + A1(3)*A3(3)
      C(3) = A1(1)*A4(1) + A1(2)*A4(2) + A1(3)*A4(3)
      IF (C(1)*C(2)*C(3) .LE. 0.0) GO TO 280
      A1(1) = SQRT(A1(1)**2 + A1(2)**2 + A1(3)**2)
      A1(2) = SQRT(A2(1)**2 + A2(2)**2 + A2(3)**2)
      A1(3) = SQRT(A3(1)**2 + A3(2)**2 + A3(3)**2)
      A1(4) = SQRT(A4(1)**2 + A4(2)**2 + A4(3)**2)
      A1(5) = A1(1) + A1(2) + A1(3) + A1(4)
      ITEMP = H/48.0
      DO 270 I = 1,4
      IC = 4*(I-1)
      DO 270 J = 1,4
      IJ = IC + J
      IF (I .EQ. J) GO TO 260
      C(IJ) = ITEMP*(A1(5) - A1(I) - A1(J))
      GO TO 270
  260 C(IJ) = ITEMP*(2.0*(A1(5) - A1(I)))
  270 CONTINUE
      GO TO 300
  280 WRITE  (OUTPT,290) UFM,NECPT(1)
  290 FORMAT (A23,' 3090, ILLEGAL GEOMETRY FOR QUAD. ELEMENT',I14)
      NOGO =.TRUE.
      GO TO 490
C
C     HERE WHEN -C- MATRIX OF SIZE N X N IS READY FOR INSERTION (MAPING)
C     INTO MASTER OUTPUT MATRIX OF SIZE ISIZE X ISIZE.
C
  300 DO 310 I = 1,64
      MAST(I) = 0.0
  310 CONTINUE
C
      DO 330 I = 1,N
      I1 = SET1(I)
      I2 = SET2(I)
      DO 320 J = 1,N
      J1 = SET1(J)
      J2 = SET2(J)
      KE = CC(I,J)
      MASTER(I1,J1) = MASTER(I1,J1) + KE
      MASTER(I1,J2) = MASTER(I1,J2) - KE
      MASTER(I2,J1) = MASTER(I2,J1) - KE
      MASTER(I2,J2) = MASTER(I2,J2) + KE
  320 CONTINUE
  330 CONTINUE
C
C     CONDENSE (ISIZE X ISIZE) MATRIX IN (8 X 8) MASTER ARRAY INTO A
C     SINGLE STRAND FOR OUTPUT TO EMGOUT
C
      K = 0
      DO 350 JCOL = 1,ISIZE
      DO 340 IROW = 1,ISIZE
      K = K + 1
      MAST(K) = MASTER(IROW,JCOL)
  340 CONTINUE
  350 CONTINUE
C
C     OUTPUT VIA EMGOUT THE TRIANGLE IN GLOBAL FOR STIFFNESS MATRIX
C
      CALL EMGOUT (MAST(1),MAST(1),K,1,DICT,1,IPREC)
C
C     FORM DAMPING -HEAT- IF REQUESTED.
C
  360 IF (KMBGG(3) .EQ. 0) GO TO 490
      INFLAG = 4
      ELTEMP = AVGTMP
      MATID  = MATFLG
      IF (MATID .EQ. 0) GO TO 490
      CALL HMAT (NECPT)
      CP = HX
      IF (CP .EQ. 0.0) GO TO 490
      GO TO (380,390,400,410,420,390,390), IFLAG
C
C     IFLAG = 1, (POINT), 1 GRID-POINT.  (1 X 1)  C = CP* AF
C
  380 C(1) = CP
      C(2) = AF
      C(1) = C(1)*C(2)
      GO TO 440
C
C     IFLAG = 2, (LINE OR ELLIPTIC CYL. )
C             2 GRID POINTS           CP*AF*L*      *
C                                  C = ------*1 , 1 *
C                                        2   *      *
C
  390 C(1) = CP
      C(2) = AF
      C(3) = ECPT(26) - ECPT(22)
      C(4) = ECPT(27) - ECPT(23)
      C(5) = ECPT(28) - ECPT(24)
      C(1) = C(1)*C(2)*SQRT(C(3)**2 + C(4)**2 + C(5)**2)/2.0
      C(2) = C(1)
      GO TO 440
C
C     IFLAG = 3, (REVOLUTION), 2 GRID-POINTS
C                                               CP*PI*L *              *
C                                           C = ------- *2X +X , 2X +X *
C                                                  3    *  1  2    2  1*
C
  400 C(1) = CP
      C(2) = PI
      C(3) = ECPT(26) - ECPT(22)
      C(4) = ECPT(28) - ECPT(24)
C
C     NOTE Y2 AND Y1 ARE 0 FOR REVOLUTION ELEMENT.
C
      C(1) = C(1)*C(2)*SQRT(C(3)**2 + C(4)**2)/3.0
      C(2) = C(1)*(ECPT(22) + 2.0*ECPT(26))
      C(1) = C(1)*(2.0*ECPT(22) + ECPT(26))
      GO TO 440
C
C     IFLAG = 4, (TRIANGLE), 3 GRID-POINTS.
C                                          CP*A *         *
C                                      C = ---- * 1, 1, 1 *
C                                           3   *         *
C
C
C     COMPUTE AREA -A- OF TRIANGLE   GET R2-R1 AND R3-R2
C
  410 C(1) = ECPT(26) - ECPT(22)
      C(2) = ECPT(27) - ECPT(23)
      C(3) = ECPT(28) - ECPT(24)
      C(4) = ECPT(30) - ECPT(26)
      C(5) = ECPT(31) - ECPT(27)
      C(6) = ECPT(32) - ECPT(28)
C
C     (R2-R1) X (R3-R2)  INTO  C(1),C(2),C(3)
C
      CALL SAXB (C(1),C(4),C(1))
      C(7) = SQRT(C(1)**2 + C(2)**2 + C(3)**2)
      C(1) = C(7)*CP/6.0
      C(2) = C(1)
      C(3) = C(1)
      GO TO 440
C
C     IFLAG = 5, (QUADRILATERAL), 4 GRID-POINTS.
C
C                                CP *                                  *
C                            C = -- * A +A +A , A +A +A , A +A +A , ETC*
C                                6  *  2  3  4   3  4  1   4  1  2     *
C
C     R  =  XI, YI, ZI
C      I
C
C     A1 = MAG((R3-R2) X (R4-R3))
C     A2 = MAG((R4-R3) X (R1-R4))
C     A3 = MAG((R1-R4) X (R2-R1))
C     A4 = MAG((R2-R1) X (R3-R2))
C
C
C     R3-R2
C
  420 C( 1) = ECPT(30) - ECPT(26)
      C( 2) = ECPT(31) - ECPT(27)
      C( 3) = ECPT(32) - ECPT(28)
C
C     R4-R3
C
      C( 4) = ECPT(34) - ECPT(30)
      C( 5) = ECPT(35) - ECPT(31)
      C( 6) = ECPT(36) - ECPT(32)
C
C     R1-R4
C
      C( 7) = ECPT(22) - ECPT(34)
      C( 8) = ECPT(23) - ECPT(35)
      C( 9) = ECPT(24) - ECPT(36)
C
C     R2-R1
C
      C(10) = ECPT(26) - ECPT(22)
      C(11) = ECPT(27) - ECPT(23)
      C(12) = ECPT(28) - ECPT(24)
C
C
      CALL SAXB (C( 1),C( 4),A1(1))
      CALL SAXB (C( 4),C( 7),A2(1))
      CALL SAXB (C( 7),C(10),A3(1))
      CALL SAXB (C(10),C( 1),A4(1))
C
      A1(1) = SQRT(A1(1)**2 + A1(2)**2 + A1(3)**2)
      A1(2) = SQRT(A2(1)**2 + A2(2)**2 + A2(3)**2)
      A1(3) = SQRT(A3(1)**2 + A3(2)**2 + A3(3)**2)
      A1(4) = SQRT(A4(1)**2 + A4(2)**2 + A4(3)**2)
      A1(5) = A1(1) + A1(2) + A1(3) + A1(4)
      ITEMP = CP/12.0
      DO 430 I = 1,4
      C(I) = ITEMP*(A1(5) - A1(I))
  430 CONTINUE
      GO TO 440
C
C     HERE WHEN DIAGONAL C MATRIX OF SIZE 1 X N IS READY FOR INSERTION
C     (MAPING) INTO MASTER DIAGONAL OUTPUT MATRIX OF SIZE 1 X ISIZE.
C
  440 DO 450 I = 1,8
      MAST(I) = 0.0
  450 CONTINUE
C
      DO 460 I = 1,N
      I1 = SET1(I)
      I2 = SET2(I)
      ME = C(I)
      MAST(I1) = MAST(I1) + ME
      MAST(I2) = MAST(I2) + ME
  460 CONTINUE
C
C     OUTPUT VIA EMGOUT THE DIAGONAL MATRIX IN GLOBAL
C
      DICT(2) = 2
      CALL EMGOUT (MAST(1),MAST(1),ISIZE,1,DICT,3,IPREC)
      GO TO 490
C
C     LOGIC ERROR
C
  470 WRITE  (OUTPT,480) SFM,IMHERE,NECPT(1),SILS
  480 FORMAT (A25,' 3037 FROM HBDYS.', /5X,
     1       'LOGIC ERROR,  IMHERE =',I5,'  ELEMENT ID =',I10, /5X,
     2       'SILS =',8I10)
      NOGO = .TRUE.
  490 RETURN
      END

      SUBROUTINE OPT2A (IP,EL,IEL,PR,IPR,RR)
C
      LOGICAL         FIRST,UNSAFE
      INTEGER         COUNT,ETYP,IEL(1),IP(2,1),IPR(1),IZ(10),NAME(2),
     1                OES1,OUTTAP,PEST,PSTRES,PTELT,ZCOR,OLDTYP,EID(20),
     2                PLUS(5),IY(1)
      REAL            EL(1),PR(1),RR(1),Y(1),PARM(8)
      CHARACTER       UFM*23,UWM*25,UIM*29
      COMMON /XMSSG / UFM,UWM,UIM
      COMMON /BLANK / SKP(2),COUNT,SKQ(2),KORE,SKR(2),NWDSE,NWDSP,SKS,
     1                OES1,SKT(3),NELW,NPRW,SKU,NTOTL,CONV
      COMMON /OPTPW2/ ZCOR,Z(16)
      COMMON /ZZZZZZ/ CORE(1)
      COMMON /NAMES / NRD,NOEOR,NWRT,NEXT
      COMMON /SYSTEM/ SYSBUF,OUTTAP
C     EQUIVALENT ARE  (EL,IEL), (PR,IPR)
      EQUIVALENCE     (Z(1),IZ(1)), (CORE(1),PARM(1),MAX),
     1                (IY(1),Y(1),PARM(8))
      DATA    NAME  / 4H OPT,4H2A   /
      DATA    PLUS  / 4H    , 4H+   , 4H++  , 4H+++ , 4H++++ /
C
      NELR  = 0
      NE    = 0
      PTELT = 0
      IDEL  = 0
      KEL   = KORE
      KCONV = 0
      CONV  = 1.0
      ICP   = NTOTL - 4
      FIRST =.TRUE.
C
C     READ HEADER, ODD RECORDS
C
      GO TO 10
    5 CALL FREAD (OES1,0,0,NEXT)
   10 CALL READ  (*630,*100,OES1,Z(1),10,NEXT,I)
      ETYP  = IZ(3)
      NESW  = IZ(10)
      OLDTYP= PTELT
      PTELT = IY(ETYP)
      IF (PTELT .GT. 0) GO TO 15
C
C     ELEMENT TYPE NOT TO OPTIMIZE
C
      GO TO 5
   15 IF (PTELT.GE.OLDTYP .OR. OLDTYP.EQ.0) GO TO 20
      IF (KEL .NE. -1) KEL = KORE
      IF (NE  .EQ.  0) GO TO 16
      CALL PAGE2 (1)
      WRITE (OUTTAP,580) (EID(J),J=1,NE)
      NE = 0
   16 WRITE  (OUTTAP,17)
   17 FORMAT (/5X,15HNEXT SUBCASE...)
C
C     SET POINTERS TO ELEMENT TYPE AND PROPERTIES IN CORE.
C     L = LOCATION OF FIRST, M = MAX LOCATION
C
   20 LEL = IP(1,PTELT)
      MEL = IP(1,PTELT+1) - 1
      IF (MEL .LE. LEL) GO TO 5
      LOCE  = LEL
      LOCP1 = IP(2,PTELT) - 1
      IF (NESW .GT. ZCOR) GO TO 70
C
C     SEQUENTIALLY READ ONE ELEMENT FROM EVEN NUMBERED RECORDS.
C     LOCE IS CURRENT ELEMENT TO COMPARE TO.
C
   30 CALL READ (*90,*10,OES1,Z(1),NESW,NOEOR,I)
      IDES = IZ(1)/10
   50 IF (IDES .EQ. IEL(LOCE)) GO TO 110
C
C     SCAN THE CORE FILE UNTIL ELEMENT ID .GT. IDES
C
      IF (IDES .LT. IEL(LOCE)) GO TO 30
C
C     CORE ELEMENT NOT TO BE OPTIMIZED
C
      LOCE = LOCE + NWDSE
      IF (LOCE .LT. MEL) GO TO 50
C
C     END OF ELEMENT SEARCH FOR THIS TYPE (EOR NOT READ)
C
      GO TO 5
C
C     ELEMENT TYPE EXCEEDS CORE
C
   70 IER = -8
      IFLE = NESW - ZCOR
      GO TO 105
C
C     ILLEGAL EOF, EOR
C
   90 IER = -2
      GO TO 101
  100 IER = -3
  101 IFLE = OES1
C
  105 CALL MESAGE (IER,IFLE,NAME)
C
C     PROCES THIS ELEMENT
C
  110 CONTINUE
      NELR = NELR + 1
      LOCP = IEL(LOCE+4) + LOCP1
      PEST = IPR(LOCP+1)/100
      MEST = IPR(LOCP+1) - PEST*100
      RC   = 1.0
      X1A  = 0.0
      X2A  = 0.0
      E1   = 999.
      UNSAFE = .FALSE.
C
      GO TO (160,160,180,150,150,150,140,140,140,120,
     1       130,140,140,140,170,150,140,120,140,140), PTELT
C
C     ROD, TUBE
C
  120 LIMIT  = 1
      PSTRES = 4
      ASSIGN 121 TO IRET
      GO TO 500
  121 LIMIT  = 2
      PSTRES = 2
      ASSIGN  540 TO IRET
      GO TO 500
C
C     SHEAR
C
  130 LIMIT  = 1
      PSTRES = 2
      ASSIGN  540 TO IRET
      GO TO 500
C
C     TRBSC, TRPLT, QDPLT, TRIA1, TRIA2, TRIA3, QUAD1, QUAD2, QUAD4
C
  140 IF (MEST .EQ. 1) GO TO 144
      LIMIT  = 2
      PSTRES = 7
      ASSIGN 141 TO IRET
      GO TO 500
  141 PSTRES = 8
      ASSIGN 142 TO IRET
      GO TO 500
  142 PSTRES = 15
      ASSIGN 143 TO IRET
      GO TO 500
  143 PSTRES = 16
      ASSIGN 144 TO IRET
      X1A = AMAX1(ABS(Z( 7)),ABS(Z( 8)))
      X2A = AMAX1(ABS(Z(15)),ABS(Z(16)))
      X1A = AMAX1(X1A,X2A)
      K   = 0
      IF (X1A.EQ.ABS(Z(8)) .OR. X1A.EQ.ABS(Z(15))) K = 1
      X1A = Z( 7+K)
      X2A = Z(16-K)
      GO TO 500
  144 IF (MEST .EQ. 2) GO TO 540
      LIMIT  = 1
      PSTRES = 9
      ASSIGN 145 TO IRET
      GO TO 500
  145 PSTRES = 17
      ASSIGN  540 TO IRET
      GO TO 500
C
C     TRMEM, QDMEM, QDMEM1, QDMEM2
C
  150 IF (MEST .EQ. 1) GO TO 152
      LIMIT  = 2
      PSTRES = 6
      ASSIGN 151 TO IRET
      GO TO 500
  151 PSTRES = 7
      ASSIGN 152 TO IRET
      GO TO 500
  152 IF (MEST .EQ. 2) GO TO 30
      LIMIT  = 1
      PSTRES = 8
      ASSIGN  540 TO IRET
      GO TO 500
C
C     BAR, ELBOW
C
  160 LIMIT  = 2
      PSTRES = 7
      X2A = ABS(Z(7))
      ASSIGN 161 TO IRET
      GO TO 500
  161 PSTRES = 8
      X1A = ABS(Z(8))
      ASSIGN 162 TO IRET
      GO TO 500
  162 PSTRES = 14
      ASSIGN 163 TO IRET
      GO TO 500
  163 PSTRES = 15
      ASSIGN  540 TO IRET
      GO TO 500
C
C     TRIM6
C
  170 IF (IEL(LOCE) .EQ. IDEL) GO TO 172
      IDEL = IEL(LOCE)
      ICP  = ICP + 4
      IF (KEL.NE.-1 .AND. ICP.GE.KEL) CALL MESAGE (-8,0,NAME)
      IY(ICP) = LOCP
      IY(ICP+4) =-1
  172 K  = 0
      M1 =-1
      DO 175 I = 1,3
      M1 = M1 + 7
      II = 3 + LOCE
      S1S = 0.0
      S3S = 0.0
      IF (MEST .NE. 2) S3S = ABS(Z(M1+2)/EL(II))
      II = II - 2
      IF (Z(M1) .LT. 0.0) II = II + 1
      IF (MEST .NE. 1) S1S = ABS(Z(M1)/EL(II))
      II = 1 + LOCE
      IF (Z(M1+1) .LT. 0.0) II = II + 1
      S2S = ABS(Z(M1+1)/EL(II))
      S13 = AMAX1(S1S,S2S)
      S13 = AMAX1(S13,S3S)
      Y(ICP+I) = AMAX1(Y(ICP+I),S13)
      PR(LOCP+4) = AMAX1(PR(LOCP+4),S13)
      E1 = ABS(S13) - 1.0
      IF (ABS(E1) .LE. PARM(2)) K = K + 1
  175 CONTINUE
      ASSIGN 540 TO IRET
      IF (K-3) 550,520,520
C
C     IS2D8
C
  180 M1  = 1
      S1S = 0.0
      S2S = 0.0
      S3S = 0.0
      DO 185 M = 1,8
      M1 = M1 + 5
      II = 3 + LOCE
      IF (MEST .NE. 2) S3S = AMAX1(S3S,ABS(Z(M1+2)/EL(II)))
      II = II - 2
      IF (Z(M1) .LT. 0.0) II = II + 1
      IF (MEST .NE. 1) S1S = AMAX1(S1S,ABS(Z(M1)/EL(II)))
      II = 1 + LOCE
      IF (Z(M1+1) .LT. 0.0) II = II + 1
      S2S = AMAX1(S2S,ABS(Z(M1+1)/EL(II)))
      S13 = AMAX1(S1S,S2S)
      S13 = AMAX1(S13,S3S)
  185 CONTINUE
      E1 = ABS(S13) - 1.0
      PR(LOCP+4) = AMAX1(PR(LOCP+4),S13)
      ASSIGN 540 TO IRET
      GO TO 520
C
C     FUNCTION E1  -  RATIO STRESS MINUS LIMIT DIVIDED BY LIMIT,
C     WITH RESET OF -ALPHA-
C     LOCP   = POINTER TO PID OF PROPERTY.
C     LOCE   = POINTER TO EID OF ELEMENT.
C     LIMIT  = 1=SHEAR, 2= COMPRESSION/TENSION.
C     PSTRES = CORRESPONDING STRESS, POINTER TO Z ARRAY.
C
  500 II = 3 + LOCE
      IF (LIMIT .EQ. 1) GO TO 510
      II = II - 2
      IF (Z(PSTRES) .LT. 0.0) II = II + 1
  510 IF (EL(II) .LE. 0.0) GO TO 530
C
C     POSITIVE LIMIT
C
      PR(LOCP+4) = AMAX1(PR(LOCP+4),ABS(Z(PSTRES)/EL(II)))
C
C                                        I
C                  NEGATIVE E1, SAFE     I    POSITIVE E1, UNSAFE
C                                        I
C   --+------+------+------+------+------+------+------------------- E1
C    UL     4P     3P     2P      P      0      P  (WHERE P=PARM(2),
C      ++++    +++    ++     +    I             I        UL=UNLOADED)
C            OVER DESIGNED        I REGION WHEREI  UNDER DESIGNED
C            REGION               I  AE1 .LE. P I          REGION
C                      (UNSAFE=.FALSE.)         I  (UNSAFE=.TRUE.)
C
      E1 = ABS(Z(PSTRES)/EL(II)) - 1.0
  520 IF (E1 .GT. PARM(2)) UNSAFE = .TRUE.
      IF (UNSAFE) KEL = -1
      AE1 = AMIN1(AE1,ABS(E1))
  530 GO TO IRET, (121,141,142,143,144,145,151,152,161,162,163,540)
C
  540 X1 = ABS(X1A)
      X2 = ABS(X2A)
      IF (X1.EQ.0.0 .OR. X2.EQ.0.0) GO TO 550
      X1A= AMIN1(X1A,X2A)
      X1 = AMIN1(X1,X2)/AMAX1(X1,X2)
      X1 = SIGN(X1,X1A)
      IF (ABS(X1) .GT. 1.0E-8) RC = X1
C
C     SAVE IN RR AN EMPIRICAL ALPHA MODIFIER FOR SPEEDY CONVERGENCE
C
  550 IRR = (LOCP+NWDSP)/NWDSP
      RR(IRR) = RC
C
      IF (UNSAFE) GO TO 30
C
C     PRINT ELEMENT IDS THAT HAVE CONVERGED, OR OVER DESIGNED
C
      IF (.NOT.FIRST) GO TO 570
      FIRST = .FALSE.
      CALL PAGE2 (-3)
      WRITE  (OUTTAP,560) UIM
  560 FORMAT (A29,' 2304A, THE FOLLOWING ELEMENTS EITHER CONVERGED (NO',
     1       ' PLUS) OR OVER-DESIGNED (PLUS(ES))',/5X,'IN ONE OR MORE ',
     2       'SUBCASES,  (EACH PLUS INDICATES AN INCREMENTAL PERCENTAGE'
     3,      ' OF OVER-DESIGN BASED ON CONVERGENCE CRITERION, EPS)',/)
  570 XSTAR = (PR(LOCP+4)-1.0) - PARM(2)
      J  = IFIX(ABS(XSTAR)/PARM(2))
      IF (J .GT. 3) J = 3
      II = 1
      IF (PR(LOCP+4) .LT. 1.0E-8) II = 0
      IF (II .EQ. 0) J = 4
      EID(NE+1) = IEL(LOCE)
      EID(NE+2) = PLUS(J+1)
      NE = NE + 2
      IF (NE .LT. 20) GO TO 590
      NE = 0
      CALL PAGE2 (1)
      WRITE  (OUTTAP,580) EID
  580 FORMAT (5X,10(I8,A4))
  590 IF (KEL .EQ. -1) GO TO 30
      KEL = KEL - 1
CWKBR 9/93 IZK = IZ(KEL)
      IZK = IY(KEL)
      IF (PR(LOCP+3) .LT. 1.0E-6) II = 0
      IF (J.GT.0 .AND. IZK.EQ.-1 .AND. II.NE.0) KCONV = KCONV - 1
      IF (II .EQ. 0) GO TO 600
      IF (AE1 .GT. PARM(2)) GO TO 30
  600 IF (IEL(LOCE) .EQ. IZK) GO TO 30
      IF (AE1.LE.PARM(2) .AND. IZK.EQ.-1) GO TO 610
      IF (II.EQ.0 .AND. IZK.EQ.-1) GO TO 30
CWKBR 9/93 IZ(KEL) = IEL(LOCE)
      IY(KEL) = IEL(LOCE)
CWKBR 9/93 IF (II .EQ. 0) IZ(KEL) = -1
      IF (II .EQ. 0) IY(KEL) = -1
      KCONV = KCONV + 1
      GO TO 30
CWKBR 9/93  610 IZ(KEL) = IEL(LOCE)
  610 IY(KEL) = IEL(LOCE)
      GO TO 30
C
C     EOF
C
  630 CONTINUE
      IF (NE .GT. 0) WRITE (OUTTAP,580) (EID(J),J=1,NE)
C
C     IF KEL=-1 HERE, OR
C     IF NUMBER OF ELEMENTS CONVERGED, KORE-KEL, IS LESS THAN NUMBER OF
C     ELEMENTS IN THE PROBLEM, NELW/NWDSE, CONVERGENCE IS INCOMPLETE
C
      IF (KEL .EQ. -1) GO TO 650
      IF (KCONV .LT. NELW/NWDSE) GO TO 650
CWKBR CALL PAGE (-4)
      CALL PAGE2 (-4)
      WRITE  (OUTTAP,640) UIM
  640 FORMAT (A29,' 2304B, CONVERGENCE ACHIEVED FOR ALL ELEMENTS ',
     1       'REQUESTED, AND IN ALL SUBCASE(S)', /5X,
     2       'FULLY-STRESSED DESIGN COMPLETED',/)
      CONV = 2.0
      GO TO 670
C
C     IF NELR IS ZERO, NO ELEMENT MATCH MADE
C
  650 IF (NELR .GT. 0) GO TO 670
      CALL PAGE2 (-2)
      WRITE  (OUTTAP,660) UFM
  660 FORMAT (A23,' 2295, NO ELEMENTS EXIST FOR OPTIMIZATION.')
      COUNT = MAX + 1
C
  670 RETURN
      END

      SUBROUTINE SPANL2(IARG)
C*****
C THIS ROUTINE IS PHASE II OF STRESS DATA RECOVERY FOR THE SHEAR AND
C TWIST PANEL ELEMENTS.
C*****
C
C
      REAL    FRLAST(2)
      INTEGER EJECT    ,ISHD(7)  ,ISTYP(2) ,TYP(4)   ,IFOR(1)
C
C
C SDR2 VARIABLE CORE
C
      COMMON   /ZZZZZZ/  ZZ(1)
C
C BLOCK FOR POINTERS, LOADING TEMPERATURE AND ELEMENT DEFORMATION.
C
      COMMON   /SDR2X4/
     1                   DUMMY(33)          ,ICSTM
     2,                  NCSTM              ,IVEC
     3,                  IVECN              ,TEMPLD
     4,                  ELDEFM
C
C SDR2 PHASE II INPUT AND OUTPUT BLOCK.
C
      COMMON   /SDR2X7/
     1                   IELID              ,ISILNO(4)
     2,                  S(3,4)             ,A(2)
     3,                  T                  ,RATIO(3)
     4,                  SIGS               ,RQ(4)
     5,                  RK(4)              ,XXXXXX(68)
      COMMON   /SDR2X7/
     1                   JSELID             ,STRES(3)
     2,                  YYYYYY(96)
      COMMON   /SDR2X7/
     1                   JFELID             ,FORCES(16)
     2,                  ZZZZZZ(8)
C
C SDR2 SCRATCH BLOCK
C
      COMMON   /SDR2X8/
     1                   S1BAR              ,TERM
     2,                  TAU(4)             ,IDISP
     3,                  IU                 ,CTU(4)
     4,                  CFRVEC(19)
C
C OUTPUT PRECISION CHECK BLOCK
C
      COMMON /SDR2X9/ NCHK,ISUB,ILD,FRTMEI(2),TWOTOP,FNCHK
C
      COMMON   /SYSTEM/  IBFSZ    ,NOUT     ,IDM(9)   ,LINE
C
      EQUIVALENCE(STRES(1),TAUMAX)
      EQUIVALENCE(STRES(2),TAUAVG)
      EQUIVALENCE(STRES(3),MARSAF,SAFMAR)
      EQUIVALENCE(FORCES(1),IFOR(1),P13)
      EQUIVALENCE(FORCES(2),P24)
C////////  FOLLOWING 8 FORCES MAY NOT BE EQUIVALENCED CORRECTLY YET/////
      EQUIVALENCE(FORCES(1),F1 )
      EQUIVALENCE(FORCES(2),F2 )
      EQUIVALENCE(FORCES(3),F3 )
      EQUIVALENCE(FORCES(4),F4 )
      EQUIVALENCE(FORCES(5),F5 )
      EQUIVALENCE(FORCES(6),F6 )
      EQUIVALENCE(FORCES(7),F7 )
      EQUIVALENCE(FORCES(8),F8 )
      EQUIVALENCE(FORCES( 9),RK1)
      EQUIVALENCE(FORCES(10),Q1)
      EQUIVALENCE(FORCES(11),RK2)
      EQUIVALENCE(FORCES(12),Q2)
      EQUIVALENCE(FORCES(13),RK3)
      EQUIVALENCE(FORCES(14),Q3)
      EQUIVALENCE(FORCES(15),RK4)
      EQUIVALENCE(FORCES(16),Q4)
      EQUIVALENCE(ISHD(1),LSUB)
      EQUIVALENCE(ISHD(2),LLD)
      EQUIVALENCE(ISHD(6),FRLAST(1))
      EQUIVALENCE(CFRVEC(1),IFRVEC)
C
      DATA LSUB,LLD,FRLAST / 2*-1, -1.0E30, -1.0E30 /
      DATA TYP / 4HSHEA,1HR, 4HTWIS,1HT /
      DATA LARG / 0 /
C
      IDISP = IVEC - 1
C
C COMPUTE AVERAGE STRESS ALONG SIDE 1 IF WE ARE DEALING WITH A SHEAR
C PANEL OR MEAN FIBRE SHEAR STRESS IF WE HAVE A TWIST PANEL.
C
      CS1BR = 0.0
      S1BAR = 0.0
      DO 10 I = 1,4
      IU = IDISP + ISILNO(I)
      IF (IARG .EQ. 5) IU = IU + 3
      CALL SMMATS(S(1,I),3,1,1,ZZ(IU),3,1,0,TERM,CTRM)
      CS1BR = CS1BR + CTRM
   10 S1BAR = S1BAR + TERM
C
C COMPUTE STRESSES AT THE CORNERS
C
      TAU(1) = RATIO(1) * S1BAR
      TAU(2) = S1BAR / RATIO(1)
      TAU(3) = RATIO(2) * S1BAR
      TAU(4) = RATIO(3) * S1BAR
      CTU(1) = ABS (RATIO(1)) * CS1BR
      CTU(2) = CS1BR / ABS (RATIO(1))
      CTU(3) = ABS (RATIO(2)) * CS1BR
      CTU(4) = ABS (RATIO(3)) * CS1BR
C
C COMPUTE AVERAGE STRESS
C
      TAUAVG = 0.25 * (TAU(1) + TAU(2) + TAU(3) + TAU(4))
      CFRVEC(3) = 0.25E0 * (CTU(1) + CTU(2) + CTU(3) + CTU(4) )
C
C COMPUTE MAXIMUM STRESS
C
      TAUMAX = ABS(TAU(1))
      CFRVEC(2) = TAUMAX
      DO 50 I = 2,4
      IF (ABS(TAU(I)) .GT. TAUMAX) TAUMAX = ABS(TAU(I))
      IF (CTU(I).GT.CFRVEC(2))  CFRVEC(2) = CTU(I)
   50 CONTINUE
C
C COMPUTE MARGIN OF SAFETY
C
      IF(SIGS.LE.0.0)GO TO 100
      IF(TAUMAX.EQ.0.0)GO TO 100
      SAFMAR=SIGS/TAUMAX-1.0
      GO TO 101
  100 MARSAF=1
  101 CONTINUE
C
C FOR A SHEAR PANEL COMPUTE LOADS, FOR A TWIST PANEL COMPUTE STRESSES.
C
      IF( IARG .NE. 4 ) GO TO 70
C
C     SHEAR PANEL FORCES
C
      Q1 = S1BAR*T /  SQRT( 1.0 + ( RQ(4)/RK(1) )**2)
      Q2 = S1BAR * RQ(1) /  SQRT( 1.0 + ( RQ(4)/RK(2) )**2)
      Q3 = S1BAR * RQ(2) /  SQRT( 1.0 + ( RQ(4)/RK(3) )**2)
      Q4 = S1BAR * RQ(3) /  SQRT( 1.0 + ( RQ(4)/RK(4) )**2)
      CFRVEC(13) = CS1BR * ABS(T) / SQRT (1.0E0 + (RQ(4)/RK(1) ) **2 )
      DO 60 I = 1,3
      F     = SQRT (1.0E0 + ( RQ(4)/RK(I+1) ) **2  )
      FORCES(2*I+10) = S1BAR * RQ(I) / F
   60 CFRVEC(2*I+13) = CS1BR * ABS(RQ(I)) / F
C
      F     = ABS (RQ(4))
      RK1 = -( Q1 + Q4 ) * RQ(4)
      RK2 = -( Q1 + Q2 ) * RQ(4)
      RK3 = -( Q2 + Q3 ) * RQ(4)
      RK4 = -( Q3 + Q4 ) * RQ(4)
      CFRVEC(12) = (CFRVEC(13) + CFRVEC(19)) * F
      CFRVEC(14) = (CFRVEC(13) + CFRVEC(15)) * F
      CFRVEC(16) = (CFRVEC(15) + CFRVEC(17)) * F
      CFRVEC(18) = (CFRVEC(17) + CFRVEC(19)) * F
      F1 = Q4 * RK(4)
      F2 = Q1 * RK(1)
      F5 = Q2 * RK(2)
      F6 = Q3 * RK(3)
      CFRVEC(4) = CFRVEC(19) * ABS (RK(4) )
      CFRVEC(5) = CFRVEC(13) * ABS (RK(1) )
      CFRVEC(8) = CFRVEC(15) * ABS (RK(2) )
      CFRVEC(9) = CFRVEC(17) * ABS (RK(3) )
      F3 = -F2
      F4 = -F5
      F7 = -F6
      F8 = -F1
      CFRVEC( 6) = CFRVEC(5)
      CFRVEC( 7) = CFRVEC(8)
      CFRVEC(10) = CFRVEC(9)
      CFRVEC(11) = CFRVEC(4)
      GO TO 80
C
C     TWIST STRESSES
C
   70 P13 = A(1) * S1BAR * T
      P24 = A(2) * S1BAR * T
      TERM = T / 6.0
      CFRVEC(4) = A(1) * CS1BR * T
      CFRVEC(5) = A(2) * CS1BR * T
      P13  = P13 * TERM
      P24  = P24 * TERM
      CFRVEC(4) = ABS (CFRVEC(4) * TERM)
      CFRVEC(5) = ABS (CFRVEC(5) *TERM)
C
C STORE ELEMENT ID IN OUTPUT SLOTS.
C
   80 JSELID = IELID
      JFELID = IELID
      IF (NCHK.LE.0) GO TO 260
C
C  . CHECK PRECISION...
C
      K = 0
C
C  . STRESSES...
      CALL SDRCHK (STRES(1),CFRVEC(2),2,K)
C
C  . FORCES...
      I = 16
      IF (IARG.NE.4) I = 2
      CALL SDRCHK (FORCES(1),CFRVEC(4),I,K)
      IF (K.EQ.0) GO TO 260
C
C  . LIMITS EXCEEDED...
      IFRVEC = IELID
      I = 1
      IF (IARG.NE.4) I = 3
      ISTYP(1) = TYP(I)
      ISTYP(2) = TYP(I+1)
      J = 0
C
      IF  (LSUB.EQ.ISUB .AND. FRLAST(1).EQ.FRTMEI(1) .AND. LARG.EQ.IARG
     1.AND. LLD .EQ.ILD  .AND. FRLAST(2).EQ.FRTMEI(2) ) GO TO 230
      LSUB = ISUB
      LARG = IARG
      LLD = ILD
      FRLAST(1) = FRTMEI(1)
      FRLAST(2) = FRTMEI(2)
      J = 2
      CALL PAGE1
  200 CALL SD2RHD (ISHD,J)
      LINE = LINE + 1
      IF (IARG.EQ.4) WRITE(NOUT,210)
      IF (IARG.NE.4) WRITE(NOUT,220)
  210 FORMAT (7X,4HTYPE,5X,42HEID  SMAX  SAVE  F1-4  F1-2  F2-1  F2-3  F
     1,60H3-2  F3-4  F4-3  F4-1   K-1  SH12   K-2  SH23   K-3  SH34    
     2, 9HK-4  SH41)
  220 FORMAT (7X,4HTYPE,5X,27HEID  SMAX  SAVE  M1-3  M2-4)
      GO TO 240
  230 IF (EJECT(2).NE.0) GO TO 200
  240 I = 19
      IF (IARG.NE.4) I = 5
      WRITE(NOUT,250) ISTYP,(CFRVEC(J),J=1,I)
  250 FORMAT (1H0,6X,A4,A1,I7,18F6.1)
C
  260 CONTINUE
      RETURN
      END

      SUBROUTINE MRED2D
C
C     THIS SUBROUTINE CALCULATES THE MODAL MASS AND STIFFNESS MATRICES
C     IF USERMODE = TYPE2 FOR THE MRED2 MODULE.
C
C     INPUT DATA
C     GINO - USETMR  - USET TABLE FOR REDUCED SUBSTRUCTURE
C            LAMAMR  - EIGENVALUE TABLE FOR SUBSTRUCTURE BEING REDUCED
C            PHISS   - EIGENVECTORS FOR SUBSTRUCTURE BEING REDUCED
C            QSM     - MODEL REACTION MATRIX
C            PAA     - SUBSTRUCTURE LOAD MATRIX
C
C     OUTPUT DATA
C     GINO - KHH     - REDUCED STIFFNESS MATRIX
C            MHH     - REDUCED MASS MATRIX
C            PHH     - REDUCED LOAD MATRIX
C     SOF  - HORG    - H TRANSFORMATION MATRIX
C            KMTX    - STIFFNESS MATRIX FOR REDUCED SUBSTRUCTURE
C            MMTX    - MASS MATRIX FOR REDUCED SUBSTRUCTURE
C            PVEC    - LOAD MATRIX FOR REDUCED SUBSTRUCTURE
C            PAPP    - APPENDED LOAD MATRIX FOR REDUCED SUBSTRUCTURE
C            POVE    - INTERNAL POINT LOADS FOR ORIGINAL SUBSTRUCTURE
C            POAP    - INTERNAL POINTS APPENDED LOADS FOR ORIGINAL
C                       SUBSTRUCTURE
C
C     PARAMETERS
C     INPUT - DRY    - MODULE OPERATION FALG
C             GBUF   - GINO BUFFERS
C             INFILE - INPUT FILE NUMBERS
C             OTFILE - OUTPUT FILE NUMBERS
C             ISCR   - SCRATCH FILE NUMBERS
C             KORLEN - LENGTH OF OPEN CORE
C             KORBGN - BEGINNING ADDRESS OF OPEN CORE
C             OLDNAM - NAME OF SUBSTRUCTURE BEING REDUCED
C             NEWNAM - NAME OF REDUCED SUBSTRUCTURE
C             USRMOD - USERMODE FLAG
C
      INTEGER         DRY,POPT,GBUF1,SBUF1,SBUF2,SBUF3,OTFILE,OLDNAM,
     1                USRMOD,Z,UL,UA,UF,US,UN,UB,TYPIN,TYPOUT,TYPEA,
     2                TYPEB,PAA,PHH,RPRTN,CPRTN,BBZERO,ZERO,USETMR,SNB,
     3                PAPP
      DIMENSION       ITRLR(7),ITRLR1(7),ITRLR2(7),MODNAM(2),ITMLST(6),
     1                BLOCK(11),ISUB(4),ITMNAM(2),RZ(1)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /BLANK / IDUM1,DRY,POPT,GBUF1,IDUM3(2),SBUF1,SBUF2,SBUF3,
     1                INFILE(12),OTFILE(6),ISCR(10),KORLEN,KORBGN,
     2                OLDNAM(2),NEWNAM(2),IDUM4(4),USRMOD,IDUM2(5),
     3                NMODES
      COMMON /ZZZZZZ/ Z(1)
      COMMON /TWO   / ITWO(32)
      COMMON /BITPOS/ IDUM5(5),UL,UA,UF,US,UN,IDUM6(10),UB
      COMMON /PACKX / TYPIN,TYPOUT,IROW,NROW,INCR
      COMMON /SYSTEM/ IDUM7,IPRNTR
      EQUIVALENCE     (USETMR,INFILE(5)),(KBB,INFILE(6)),
     1                (MBB,INFILE(7)),(PAA,INFILE(10)),
     2                (KHH,OTFILE(1)),(MHH,OTFILE(2)),(PHH,OTFILE(5)),
     3                (RPRTN,ISCR(8)),(CPRTN,ISCR(8)),(K,ISCR(3)),
     4                (BBZERO,ISCR(9)),(M,ISCR(10)),(ZERO,ISCR(3)),
     5                (RZ(1),Z(1)),(TYPEA,BLOCK(1)),(TYPEB,BLOCK(7))
      DATA    MODNAM/ 4HMRED,4H2D  /
      DATA    PAPP  / 4HPAPP/
      DATA    MRED2 / 27    /
      DATA    ITMLST/ 4HKMTX,4HMMTX,4HPVEC,4HPAPP,4HPOVE,4HPOAP/
C
C     CHECK USERMODE OPTION FLAG
C
      IF (DRY .EQ. -2) GO TO 400
C
C     COUNT NUMBER OF FREE, FIXED POINTS WITHIN BOUNDARY SET
C
      ITRLR(1) = USETMR
      CALL RDTRL(ITRLR)
      IFILE = USETMR
      IF (ITRLR(1) .LT. 0) GO TO 270
      LUSET = ITRLR(3)
      IF ((KORBGN + LUSET) .GE. KORLEN) GO TO 280
      CALL GOPEN (USETMR,Z(GBUF1),0)
      CALL READ  (*260,*270,USETMR,Z(KORBGN),LUSET,0,NWDSRD)
      CALL CLOSE (USETMR,1)
      NUF   = 0
      NUS   = 0
      SNB   = ITWO(US) + ITWO(UN) + ITWO(UB)
      LAFNB = ITWO(UL) + ITWO(UA) + ITWO(UF) + ITWO(UN) + ITWO(UB)
      DO 10 I = 1,LUSET
      IF (Z(KORBGN+I-1) .EQ. LAFNB) NUF = NUF + 1
      IF (Z(KORBGN+I-1) .EQ.   SNB) NUS = NUS + 1
   10 CONTINUE
C
C     IF FIXED SET, COMPUTE GS MATRIX
C
      IF (NUS .EQ. 0) GO TO 20
      CALL MRED2I (1,0,0)
C
C     IF FREE SET, PARTITION PHISS
C
   20 IF (NUF .EQ. 0) GO TO 50
      CALL MRED2J (NUF,N2)
C
C     FORM HK MATRIX
C
      CALL MRED2L (NUF,N2,NUS,UFBITS)
   50 CALL MRED2M (NUF,N2,NUS)
C
C     COMPUTE K MATRIX
C
      CALL MRED2N
C
C     COMPUTE HM MATRIX
C
      CALL MRED2O (NUS)
C
C     OUTPUT HORG
C
      CALL MRED2P (NUS,NUF,N2)
C
C     PROCESS STIFFNESS, MASS MATRICES
C     II = 1, PROCESS STIFFNESS MATRIX
C     II = 2, PROCESS MASS MATRIX
C
      IF (DRY .EQ. -2) GO TO 240
      CALL SETLVL (NEWNAM,1,OLDNAM,ITEST,MRED2)
      IF (ITEST .EQ. 8) GO TO 380
      DO 190 II = 1,2
      ITRLR1(1) = KBB
      KM   = K
      KMHH = KHH
      IF (II .EQ. 1) GO TO 60
      ITRLR1(1) = MBB
      KM   = M
      KMHH = MHH
   60 KMBB = ITRLR1(1)
      CALL RDTRL (ITRLR1)
      IF (ITRLR1(1) .LT. 0) GO TO 160
      CALL SOFCLS
C
C     FORM MERGE VECTOR
C
      JROW   = ITRLR1(3)
      KOLUMN = ITRLR1(2)
      ITRLR2(1) = KM
      CALL RDTRL (ITRLR2)
      NROW   = ITRLR2(3)
      KOLMNS = ITRLR2(2)
      DO 130 I = 1,NROW
      RZ(KORBGN+I-1) = 0.0
      IF (I .GT. JROW) RZ(KORBGN+I-1) = 1.0
  130 CONTINUE
      IFORM  = 7
      TYPIN  = 1
      TYPOUT = 1
      IROW   = 1
      INCR   = 1
      CALL MAKMCB (ITRLR1,RPRTN,NROW,IFORM,TYPIN)
      CALL GOPEN (RPRTN,Z(GBUF1),1)
      CALL PACK (Z(KORBGN),RPRTN,ITRLR1)
      CALL CLOSE (RPRTN,1)
      CALL WRTTRL (ITRLR1)
C
C     MERGE (K,M)BB MATRIX WITH ZERO MATRICES
C
      ISUB(1) = KOLUMN
      ISUB(2) = KOLMNS - KOLUMN
      ISUB(3) = JROW
      ISUB(4) = NROW - JROW
      ITYPE   = 1
      CALL GMMERG (BBZERO,KMBB,0,0,0,RPRTN,RPRTN,ISUB,ITYPE,Z(KORBGN),
     1             KORLEN)
C
C     FORM STIFFNESS, MASS MATRICES
C
C                                  **           **
C                                  *         .   *
C        **       **   **     **   * (K,M)BB . 0 *
C        *         *   *       *   *         .   *
C        * (K,M)HH * = * (K,M) * + *.............*
C        *         *   *       *   *         .   *
C        **       **   **     **   *    0    . 0 *
C                                  *         .   *
C                                  **           **
      DO 150 I = 1,11
  150 BLOCK(I) = 0.0
      BLOCK(2) = 1.0
      BLOCK(8) = 1.0
      TYPEA = ITRLR2(5)
      TYPEB = ITRLR1(5)
      IOP   = 1
      CALL SSG2C (KM,BBZERO,KMHH,IOP,BLOCK)
      CALL SOFOPN (Z(SBUF1),Z(SBUF2),Z(SBUF3))
      GO TO 170
C
C     NO BB MATRIX PARTITION
C
  160 KMHH = KM
C
C     STORE MATRIX ON SOF
C     II = 1, STORE KHH AS KMTX
C     II = 2, STORE MHH AS MMTX
C
  170 ITEM      = ITMLST(II)
      ITMNAM(1) = NEWNAM(1)
      ITMNAM(2) = NEWNAM(2)
      CALL MTRXO (KMHH,NEWNAM,ITEM,0,ITEST)
      IF (ITEST .NE. 3) GO TO 300
  190 CONTINUE
C
C     PROCESS LOAD DATA
C
      ITRLR1(1) = PAA
      CALL RDTRL (ITRLR1)
      IF (ITRLR1(1) .LT. 0) GO TO 240
C
C     EXPAND PAA FOR MODAL DOF
C
C                  **   **
C                  *     *
C        **   **   * PAA *
C        *     *   *     *
C        * PHH * = *.....*
C        *     *   *     *
C        **   **   *  0  *
C                  *     *
C                  **   **
C
      NROW = ITRLR1(3) + N2
      IF (N2 .EQ. 0) NROW = NROW + (NMODES - NUF)
      IFORM  = 7
      TYPIN  = 1
      TYPOUT = 1
      IROW   = 1
      INCR   = 1
      CALL MAKMCB (ITRLR2,CPRTN,NROW,IFORM,TYPIN)
      DO 230 I = 1,NROW
      RZ(KORBGN+I-1) = 0.0
      IF (I .GT. ITRLR1(3)) RZ(KORBGN+I-1) = 1.0
  230 CONTINUE
      CALL GOPEN (CPRTN,Z(GBUF1),1)
      CALL PACK (Z(KORBGN),CPRTN,ITRLR2)
      CALL CLOSE (CPRTN,1)
      CALL WRTTRL (ITRLR2)
C
C     MERGE PAA WITH ZERO MATRIX
C
      ISUB(3) = ITRLR1(3)
      ISUB(4) = N2
      IF (N2 .EQ. 0) ISUB(4) = NMODES - NUF
      ITYPE   = 1
      CALL GMMERG (PHH,PAA,0,0,0,0,CPRTN,ISUB,ITYPE,Z(KORBGN),KORLEN)
C
C     SAVE PHH AS PVEC OR PAPP ON SOF
C
      ITEM = ITMLST(3)
      IF (POPT .EQ. PAPP) ITEM = ITMLST(4)
      ITMNAM(1) = NEWNAM(1)
      ITMNAM(2) = NEWNAM(2)
      CALL MTRXO (PHH,NEWNAM,ITEM,0,ITEST)
      IF (ITEST .NE. 3) GO TO 300
C
C     STORE NULL MATRIX AS POVE OR POAP ON SOF
C
      IFORM  = 2
      KOLMNS = ITRLR1(2)
      NROW   = N2
      IF (N2 .EQ. 0) NROW = NMODES - NUF
      CALL MAKMCB (ITRLR2,ZERO,NROW,IFORM,TYPIN)
      CALL GOPEN (ZERO,Z(GBUF1),1)
      DO 234 I = 1,KOLMNS
      DO 232 J = 1,NROW
  232 RZ(KORBGN+J-1) = 0.0
  234 CALL PACK (Z(KORBGN),ZERO,ITRLR2)
      CALL CLOSE (ZERO,1)
      CALL WRTTRL (ITRLR2)
      ITEM = ITMLST(5)
      IF (POPT .EQ. PAPP) ITEM = ITMLST(6)
      ITMNAM(1) = OLDNAM(1)
      ITMNAM(2) = OLDNAM(2)
      CALL MTRXO (ZERO1,OLDNAM,ITEM,0,ITEST)
      IF (ITEST .NE. 3) GO TO 300
  240 CONTINUE
      GO TO 400
C
C     PROCESS SYSTEM FATAL ERRORS
C
  260 IMSG = -2
      GO TO 290
  270 IMSG = -3
      GO TO 290
  280 IMSG = -8
      IFILE = 0
  290 CALL SOFCLS
      CALL MESAGE (IMSG,IFILE,MODNAM)
      GO TO 400
C
C     PROCESS MODULE FATAL ERRORS
C
  300 GO TO (310,320,330,340,350,370), ITEST
  310 IMSG = -9
      GO TO 390
  320 IMSG = -11
      GO TO 390
  330 IMSG = -1
      GO TO 360
  340 IMSG = -2
      GO TO 360
  350 IMSG = -3
  360 CALL SMSG (IMSG,ITEM,ITMNAM)
      GO TO 400
  370 IMSG = -10
      GO TO 390
  380 WRITE  (IPRNTR,385) UFM
  385 FORMAT (A23,' 6518, ONE OF THE COMPONENT SUBSTRUCTURES HAS BEEN ',
     1       'USED IN A PREVIOUS COMBINE OR REDUCE.')
      DRY = -2
      GO TO 400
  390 DRY = -2
      CALL SMSG1 (IMSG,ITEM,ITMNAM,MODNAM)
  400 RETURN
      END

      SUBROUTINE CALCV (PVACT,SET1,SUB1,SUB2,CORE)
C
      EXTERNAL        ANDF
      INTEGER         A1,PVECT,SET1,SUB1,SUB2,USET,SYSBUF,PVACT,ANDF,
     1                CORE(1)
C
      COMMON /SYSTEM/ SYSBUF
      COMMON /TWO   / TWO1(32)
      COMMON /PATX  / LC,N,NO,N3,USET,PVECT(7)
      COMMON /ZBLPKX/ B1(4),N1
C
C
      N  = 0
      N3 = 0
      NO = 0
      N1 = 0
      CALL MAKMCB (PVECT,PVACT,0,2,1)
      LCORE = LC - SYSBUF
      CALL GOPEN (USET,CORE(LCORE+1),0)
      LCORE = LCORE - SYSBUF
      CALL GOPEN (PVACT,CORE(LCORE+1),1)
      CALL BLDPK (1,1,PVACT,0,0)
   20 CALL READ (*90,*90,USET,A1,1,0,FLAG)
      IF (ANDF(TWO1(SET1),A1) .EQ. 0) GO TO 20
      N1 = N1 + 1
      IF (ANDF(TWO1(SUB1),A1) .EQ. 0) GO TO 50
      N  = N  + 1
      GO TO 20
   50 IF (ANDF(TWO1(SUB2),A1) .EQ. 0) GO TO 60
      NO = NO + 1
      B1(1) = 1.0
      GO TO 70
   60 B1(1) = 2.0
      N3 = N3 + 1
   70 CONTINUE
      CALL ZBLPKI
      GO TO 20
   90 CONTINUE
      CALL BLDPKN (PVACT,0,PVECT)
      PVECT(3) = N1
      CALL WRTTRL (PVECT)
      CALL CLOSE  (USET,1)
      CALL CLOSE  (PVACT,1)
      RETURN
      END

      SUBROUTINE DLPT2 (INPUT,W1JK,W2JK)
C
      INTEGER         W1JK,W2JK,SYSBUF,ECORE,TW1JK,TW2JK,NAME(2)
      DIMENSION       A(2),NP(4),IZ(1)
      COMMON /PACKX / ITI,ITO,II,NN,INCR
      COMMON /AMGP2 / TW1JK(7),TW2JK(7)
      COMMON /AMGMN / MCB(7),NROW,ND,NE,REFC,FMACH,RFK
      COMMON /SYSTEM/ SYSBUF
      COMMON /ZZZZZZ/ WORK(1)
      EQUIVALENCE     (NP(2),NSTRIP),(NP(3),NTP)
      EQUIVALENCE     (WORK(1),IZ(1))
      DATA     NAME / 4HDLPT,4H2   /
C
C     READ IN NP,NSIZE,NTP,F
C
      CALL READ(*999,*999,INPUT,NP,4,0,N)
C
C     COMPUTE POINTERS AND SEE IF THERE IS ENOUGH CORE
C
      ECORE = KORSZ(IZ)
      ECORE = ECORE - 4*SYSBUF
      NN = II +1
      INC = 0
      INB = INC + NP(1)
      IYS = INB + NP(1)
      IZS = IYS + NSTRIP
      IEE = IZS + NSTRIP
      ISG = IEE + NSTRIP
      ICG = ISG + NSTRIP
      IXIC = ICG + NSTRIP
      IDELX = IXIC + NTP
      IXLAM = IDELX + NTP
      NREAD = IXLAM + NTP
C
C     FILL IN DATA
C
      IF(NREAD.GT. ECORE) GO TO 998
      CALL READ(*999,*999,INPUT,WORK,NREAD,1,N)
C
C     COMPUTE TERMS AND PACK
C
      DO 10 I = 1,NTP
      A(1) = 0.0
      A(2) = 1.0
      CALL PACK(A,W1JK,TW1JK)
      A(1) = -(2.0/REFC)
      A(2)=WORK(IDELX+I) / (2.0*REFC)
      CALL PACK(A,W2JK,TW2JK)
C
C     BUMP PACK INDEXES
C
      II = II +2
      IF(I.EQ.NTP) GO TO 10
      NN = NN + 2
   10 CONTINUE
      RETURN
C
C     ERROR MESSAGES
C
C     NOT ENOUGH CORE
  998 CALL MESAGE(-8,0,NAME)
C     FILE NOT POSITIONED PROPERLY
  999 CALL MESAGE(-7,0,NAME)
      RETURN
      END

      SUBROUTINE DSWRIT ( IUNIT, BUFF, LEN, IREC, ICCERR )
      INTEGER           BUFF( LEN )
      COMMON / SYSTEM / SYSBUF, IWR
      INCLUDE          'DSIOF.COM'
c      print *,' dswrit,len,IREC,UNIT=',len,irec,iunit
      IF ( IREC .LE. 0 ) GO TO 701
      WRITE ( IUNIT, REC=IREC, IOSTAT=ISTAT, ERR=702 ) BUFF
      ICCERR = 0
      GO TO 777
701   WRITE( IWR, 901 ) IUNIT, IREC, MDSNAM( IUNIT )
901   FORMAT(//' ERROR IN DSWRIT, BAD RECORD NO., UNIT=',I4,' REC=',I5
     &,      /,' FILE NAME=',A80 )
      ICCERR = ISTAT
      CALL DSMSG  ( 101 )
      CALL MESAGE ( -61, 0, 0 )
702   WRITE( IWR, 902 ) IUNIT, IREC, ISTAT, MDSNAM( IUNIT )
902   FORMAT(//', ERROR ENCOUNTERED IN DSWRCC, UNIT=',I5,' RECORD='
     &, I5,' STATUS=',I9,/' DSNAME=',A80 )
      ICCERR = ISTAT
      CALL DSMSG  ( 101 )
      CALL MESAGE ( -61, 0, 0 )
777   CONTINUE
      NUMWRI = NUMWRI + 1
      RETURN
      END

      SUBROUTINE GFSMO2
C
C     THIS ROUTINE IS THE CONTINUATION OF GFSMOD
C
      REAL         RZ(1)     ,EIGVAL(7)
C
      DOUBLE PRECISION       DBADD(5)
C
      INTEGER       SCR1     ,SCR2     ,SCR3     ,SCR4     ,SCR5
     1             ,SCR6     ,SCR7     ,SCR8     ,SCR9     ,SCR10
     2             ,AXY      ,AFRY     ,KYY      ,DKAA     ,DKFRFR
     3             ,USETF    ,PHIA     ,PHIX     ,AC       ,POUT
     4             ,LAMA     ,KMAT     ,MMAT     ,GIA      ,PVEC
     5             ,IDENT    ,USET     ,USETD    ,KC       ,H
     6             ,COMPTP   ,AZY      ,AHY      ,AHJ      ,AJH
     7             ,KJJ      ,AYH      ,KJJL     ,GJH      ,MZZ
     8             ,KZZ      ,MHHBAR   ,PHIAR    ,KZZBAR   ,KHHBAR
     9             ,GYH      ,MCB(7)   ,SFBIT    ,FILE     ,UM
     1             ,UZ       ,UNZ      ,UFR      ,UH       ,UY
     2             ,UF       ,US       ,UI       ,Z        ,SYSBUF
     3             ,TWO      ,TYPIN    ,TYPOUT   ,BADD(11) ,NAME(2)
C
C     MODULE PARAMETERS
C
      COMMON /BLANK/          NOGRAV   ,NOFREE   ,KCOMP   ,COMPTP
     1                       ,FORM     ,LLMODE
C
C     SYSTEM COMMON
C
      COMMON / SYSTEM /       SYSBUF   ,NOUT
C
C     CALCV COMMON BLOCK
C
      COMMON / PATX /         LCORE    ,NSUB0    ,NSUB1    ,NSUB2
     1                       ,USET
C
C     OPEN CORE
C
      COMMON / ZZZZZZ /        Z(1)
C
C     PACK COMMON BLOCK
C
      COMMON / PACKX /        TYPIN    ,TYPOUT   ,II       ,NN
     1                       ,INCR
C
C     POWERS OF TWO
C
      COMMON / TWO /          TWO(32)
C
C     USET BIT POSITIONS - SOME OF THESE ARE USED JUST HERE
C
      COMMON / BITPOS /       UNZ      ,UZ       ,UM       ,UH
     1                       ,BIT1(3)  ,UF       ,US       ,BIT2(15)
     2                       ,UY       ,UFR      ,BIT3(2)  ,UI
C
C     LOCAL VARIABLES FOR GFSMO1 AND GFSMO2
C
      COMMON /GFSMOX/AXY     ,AFRY     ,KYY      ,DKAA     ,DKFRFR
     1             ,USETF    ,PHIA     ,PHIX     ,LAMA
     2             ,KMAT     ,MMAT     ,GIA      ,POUT
     3             ,SCR1     ,SCR2     ,SCR3     ,SCR4     ,SCR5
     4             ,SCR6     ,SCR7     ,SCR8
     5             ,LMODES   ,NMODES   ,IBUF     ,SFBIT    ,BADD
     6             ,NAME
C
C     SCRATCH FILE ASSIGNMENTS
C
      EQUIVALENCE   ( BADD(2) , DBADD(1) )
     1             ,( RZ(1) , Z(1) )
     2             ,( SCR1 , USETD )
     3             ,( SCR2 , PVEC , IDENT , KJJL )
     4             ,( SCR3 , AZY , AHJ , KJJ , GJH )
     5             ,( SCR4 , AJH , KHHBAR , GYH )
     6             ,( SCR5 , AC , AYH , MZZ , KZZBAR )
     7             ,( SCR6 , KZZ )
     8             ,( SCR7 , KC , AHY )
     9             ,( SCR8 , H )
     1             ,( SCR9 , MMAT )
     2             ,( SCR10 , GIA , MHHBAR )
C
C
C***********************************************************************
C
C
C     GET THE GENERALIZED STIFFNESS AND MASS FOR THE DESIRED MODES
C     FROM THE LAMA DATA BLOCK
C
      IF(2*LMODES .GE. IBUF) GO TO 1008
      CALL GOPEN(LAMA,Z(IBUF),0)
      FILE = LAMA
      CALL FWDREC(*1002,LAMA)
      IGK = 1
      IGM = LMODES + 1
      DO 170 I=1,LMODES
  165 CALL READ(*1001,*1002,LAMA,EIGVAL,7,0,N)
      IF(EIGVAL(6) .EQ. 0.0) GO TO 165
      RZ(IGK) = EIGVAL(7)
      IGK = IGK + 1
      RZ(IGM) = EIGVAL(6)
      IGM = IGM + 1
  170 CONTINUE
      CALL CLOSE(LAMA,1)
C
C     GENERATE THE DIAGONAL MODAL STIFFNESS MATRIX
C
      I1 = 1
      I2 = LMODES
      CALL MAKMCB(MCB,KZZ,LMODES,6,2)
      CALL GOPEN(KZZ,Z(IBUF),1)
      TYPIN = 1
      TYPOUT = 2
      INCR = 1
      DO 180 I=I1,I2
      II = I
      NN = I
  180 CALL PACK(RZ(I),KZZ,MCB)
      CALL CLOSE(KZZ,1)
      CALL WRTTRL(MCB)
C
C     GENERATE THE DIAGANOL MODAL MASS MATRIX
C
      I1 = LMODES + 1
      I2 = 2 * LMODES
      CALL MAKMCB(MCB,MZZ,LMODES,6,2)
      CALL GOPEN(MZZ,Z(IBUF),1)
      DO 190 I=I1,I2
      II = I - LMODES
      NN = II
  190 CALL PACK(RZ(I),MZZ,MCB)
      CALL CLOSE(MZZ,1)
      CALL WRTTRL(MCB)
C
C     IF A FREE SURFACE EXISTS - EXPAND THE MASS MATRIX
C     THE PARTITIONING VECTOR WILL BE SAVED FOR DMAP USE
C
      IF(NOFREE) 210,200,200
  200 USET = USETD
      CALL CALCV(POUT,UH,UZ,UFR,Z(1))
      NSUB0S = NSUB0
      NSUB1S = NSUB1
      CALL GFSMRG(MHHBAR,MZZ,0,0,0,POUT,POUT)
      GO TO 220
C
  210 CALL GFSWCH(MHHBAR,MZZ)
C
C     COMPUTE THE FINAL MASS MATRIX
C
  220 CALL SSG2B(AJH,GJH,MHHBAR,MMAT,1,2,1,SCR2)
C
C     IF GRAVITY EXISTS - TRANSFORM THE ADDITIONAL STIFFNESS AND
C     ADD IT IN.  BE SURE TO USE ONLY THOSE MODES REQUESTED IN
C     THE TRANSFORMATION FROM PHIA
C
      IF(NOGRAV) 260,230,230
  230 USET = USETD
      IF(LMODES .GE. NMODES) GO TO 240
      CALL CALCV(PVEC,UM,UZ,UNZ,Z(1))
      CALL GFSPTN(PHIA,PHIAR,0,0,0,PVEC,0)
      GO TO 250
C
  240 PHIAR = PHIA
C
  250 CALL SSG2B(PHIAR,DKAA,0,SCR2,1,2,1,SCR5)
      CALL SSG2B(SCR2,PHIAR,KZZ,KZZBAR,0,2,1,SCR10)
      GO TO 270
C
  260 CALL GFSWCH(KZZ,KZZBAR)
C
C     IF A FREE SURFACE EXISTS - MERGE THE FREE SURFACE STIFFNESS IN
C
  270 IF(NOFREE) 290,280,280
  280 NSUB0 = NSUB0S
      NSUB1 = NSUB1S
      CALL GFSMRG(KHHBAR,KZZBAR,0,0,DKFRFR,POUT,POUT)
      GO TO 300
C
  290 CALL GFSWCH(KHHBAR,KZZBAR)
C
C     COMPUTE THE FINAL STIFFNESS MATRIX BY ADDING IN COMPRESSIBILITY
C     IF IT EXISTS
C
  300 IF(SFBIT) 320,310,320
  310 BADD(1) = 2
      DBADD(1) = 1.0D0
      BADD(7) = 2
      DBADD(4) = 1.0D0
      CALL SSG2C(KHHBAR,KC,KMAT,0,BADD)
C
      GO TO 330
  320 CALL GFSWCH(KHHBAR,KMAT)
C
C     TRANSFORM THE FINAL PRESSURE TRANSFORMATION MATRIX OR IF SPC
C     POINTS EXIST ON THE FLUID MERGE IN ZEROS
C
  330 USET = USETF
      IF(SFBIT) 350,340,350
  340 CALL SSG2B(H,GJH,0,GYH,1,2,1,SCR5)
      GO TO 360
C
  350 CALL CALCV(PVEC,UY,UF,US,Z(1))
      CALL GFSMRG(GYH,GJH,0,0,0,0,PVEC)
C
C     PARTITION OUT THE FREE SURFACE POINTS
C
  360 IF(NOFREE) 380,370,370
  370 CALL CALCV(PVEC,UY,UFR,UI,Z(1))
      CALL GFSPTN(GYH,0,GIA,0,0,0,PVEC)
      RETURN
C
  380 CALL GFSWCH(GYH,GIA)
      RETURN
C
C     ERROR EXITS
C
 1001 N = -1
      GO TO 9999
 1002 N = -2
      GO TO 9999
 1008 N = -8
C
 9999 CALL MESAGE(N,FILE,NAME)
      RETURN
      END

      SUBROUTINE CFEER1
C
C     CFEER1 INITIALIZES AND CALLS SUBROUTINE SADD FOR CFCNTL
C
      LOGICAL           NO B     ,QPR
      INTEGER           SCR1     ,SCR2     ,SCR11    ,SQR       ,
     1                  TYPOUT   ,IFILA(7) ,IFILB(7) ,IFILC(7)
      DOUBLE PRECISION  ALPHA(2) ,BETA(2)  ,LAMBDA   ,DZ(1)
      DIMENSION         SALPHA(4),SBETA(4)
      COMMON  /FEERAA/  IK(7)    ,IM(7)    ,IB(7)    ,DUM(15)   ,
     1                  SCR1     ,SCR2     ,SCR(8)   ,SCR11     ,
     2                  DUMAA(91),MCBLMB(7)
      COMMON  /FEERXC/  LAMBDA(2),DUMXC(12),NO B     ,DUMXC2(4) ,
     1                  QPR
      COMMON  /SADDX /  NOMAT    ,NZ       ,MCBS(67)
      COMMON  /NAMES /  DUMM(10) ,CDP      ,SQR
      COMMON  /ZZZZZZ/  Z(1)
      COMMON  /UNPAKX/  TYPOUT   ,IROW     ,NLAST    ,INCR
      COMMON  /SYSTEM/  KSYSTM(65)
C
      EQUIVALENCE      (MCBS( 1), IFILA(1)), (MCBS( 8), ITYPAL  ),
     1                 (MCBS(61), IFILC(1)), (MCBS(13), IFILB(1)),
     2                 (MCBS(20), ITYPBT  ), (MCBS(21), BETA(1) ),
     3                 (MCBS( 9), ALPHA(1)), (IPREC,  KSYSTM(55)),
     4                 (ALPHA(1),SALPHA(1)), (BETA(1),  SBETA(1)),
     5                 (Z(1)    , DZ(1)   ), (NOUT,   KSYSTM(2) )
C
C     FORM   -(B + LAMBDA*M)  ON SCR2
C
      ITYPE    = IPREC + 2
      NOMAT    = 2
      DO 10 I  = 1,7
      IFILA(I) = IM(I)
   10 IFILB(I) = IB(I)
      IF (IPREC .EQ. 2) GO TO 15
      SALPHA(1)=-SNGL(LAMBDA(1))
      SALPHA(2)=-SNGL(LAMBDA(2))
      SALPHA(3)= 0.
      SALPHA(4)= 0.
      SBETA(1) =-1.
      SBETA(2) = 0.
      SBETA(3) = 0.
      SBETA(4) = 0.
      GO TO 16
   15 ALPHA(1) =-LAMBDA(1)
      ALPHA(2) =-LAMBDA(2)
      BETA(1)  =-1.D0
      BETA(2)  =  0.D0
   16 ITYPAL   = ITYPE
      ITYPBT   = ITYPE
      NZ       = KORSZ(Z)
      IFILC(1) = SCR2
      IFILC(2) = IK(2)
      IFILC(3) = IK(3)
      IFILC(4) = 1
      IFILC(5) = ITYPE
      IF (NO B) GO TO 100
      CALL SADD (Z,Z)
C
C---------- SPECIAL PRINT ------------------------------
C
      IF (.NOT.QPR) GO TO 25
      WRITE  (NOUT,2)
    2 FORMAT (1H0,//7H CFEER1,//)
      TYPOUT= ITYPE
      IROW  = 1
      NLAST = IK(2)
      LIMIT = 2*NLAST
      INCR  = 1
      IBUF  = NZ - KSYSTM(1) - 2
      CALL GOPEN (IFILC(1),Z(IBUF),0)
      DO 20 I = 1,NLAST
      WRITE  (NOUT,1) I
    1 FORMAT (7H COLUMN,I4)
      CALL UNPACK (*20,IFILC(1),Z)
      IF (IPREC .EQ. 2) WRITE (NOUT,3) (DZ(J),J=1,LIMIT)
      IF (IPREC .NE. 2) WRITE (NOUT,5) ( Z(J),J=1,LIMIT)
   20 CONTINUE
      CALL CLOSE (IFILC(1),1)
    3 FORMAT (1H ,13(10H----------)/(1H ,4D25.16))
    5 FORMAT (1H ,13(10H----------)/(1H ,4E25.16))
   25 CONTINUE
C
C
C     FORM  (LAMBDA**2*M + LAMBDA*B + K)  ON SCR1
C
      DO 30 I  = 1,7
   30 IFILA(I) = IK(I)
      IFILB(1) = IFILC(1)
      IFILB(2) = IK(2)
      IFILB(3) = IK(3)
      IFILB(4) = SQR
      IFILB(5) = ITYPE
      IF (IPREC .EQ. 2) GO TO 35
      SALPHA(1) = 1.
      SALPHA(2) = 0.
      SALPHA(3) = 0.
      SALPHA(4) = 0.
      SBETA(1)  =-SNGL(LAMBDA(1))
      SBETA(2)  =-SNGL(LAMBDA(2))
      SBETA(3)  = 0.
      SBETA(4)  = 0.
      GO TO 50
   35 ALPHA(1) = 1.D0
      ALPHA(2) = 0.D0
      BETA(1)  =-LAMBDA(1)
      BETA(2)  =-LAMBDA(2)
   50 IFILC(1) = SCR1
      CALL SADD (Z,Z)
C
C---------- SPECIAL PRINT ------------------------------
C
      IF (.NOT.QPR) GO TO 75
      WRITE  (NOUT,4)
    4 FORMAT (1H ,13(10H----------),//,19H THE DYNAMIC MATRIX,//)
      CALL GOPEN (IFILC(1),Z(IBUF),0)
      DO 70 I = 1,NLAST
      WRITE (NOUT,1) I
      CALL UNPACK (*70,IFILC(1),Z)
      IF (IPREC .EQ. 2) WRITE (NOUT,3) (DZ(J),J=1,LIMIT)
      IF (IPREC .NE. 2) WRITE (NOUT,5) ( Z(J),J=1,LIMIT)
   70 CONTINUE
      CALL CLOSE (IFILC(1),1)
   75 CONTINUE
C
C-------------------------------------------------------
C     MCBLMB NOT USED WHEN DAMPING MATRIX ABSENT
C
      DO 40 I = 1,7
   40 MCBLMB(I) = IFILB(I)
      GO TO 200
C
C     DAMPING MATRIX ABSENT
C
  100 DO 110 I = 1,7
  110 IFILB(I) = IK(I)
      IF (IPREC .EQ. 2) GO TO 120
      SALPHA(1) = SNGL(LAMBDA(1)**2 - LAMBDA(2)**2)
      SALPHA(2) = 2.*SNGL(LAMBDA(1)*LAMBDA(2))
      SBETA(1)  = 1.
      GO TO 130
  120 ALPHA(1) = LAMBDA(1)**2 - LAMBDA(2)**2
      ALPHA(2) = 2.D0*LAMBDA(1)*LAMBDA(2)
      BETA(1)  = 1.D0
C
C----------- LOGIC FOR SPECIAL PRINT -------------------------
C
  130 IF (.NOT.QPR) GO TO 50
      TYPOUT= ITYPE
      IROW  = 1
      NLAST = IK(2)
      LIMIT = 2*NLAST
      INCR  = 1
      IBUF  = NZ - KSYSTM(1) - 2
C-------------------------------------------------------------
C
      GO TO 50
C
  200 RETURN
      END

      SUBROUTINE EQSCOD (LOC,N,Z)
C
      EXTERNAL  LSHIFT,ORF
      INTEGER   Z(1),ORF
C
      I   = LOC
      MEND= LOC+N-1
    1 IST = I
      NG  = 1
    2 CONTINUE
      IF (I .GE. MEND-2) GO TO 3
      IF (Z(I+3) .NE. Z(IST)) GO TO 3
      NG = NG+1
      I  = I+3
      GO TO 2
    3 CONTINUE
      IF (NG .NE. 1) GO TO 4
      I = I+3
      IF (I .GE. MEND-2) GO TO 6
      GO TO 1
    4 DO 5 J=1,NG
      ILOC  = IST+3*(J-1)
      ICODE = 8*J+NG
      INEW  = LSHIFT(ICODE,26)
      Z(ILOC+2) = ORF(Z(ILOC+2),INEW)
    5 CONTINUE
      I = I+3
      IF (I .GE. MEND-2) GO TO 6
      GO TO 1
    6 CONTINUE
      RETURN
      END

      SUBROUTINE FMDI (I,J)
C
C     THE SUBROUTINE FETCHES FROM THE RANDOM ACCESS STORAGE DEVICE THE
C     BLOCK OF MDI CONTAINING THE I-TH DIRECTORY, AND STORES THAT BLOCK
C     IN THE ARRAY BUF STARTING AT LOCATION (MDI+1) AND EXTENDING TO
C     LOCATION (MDI+BLKSIZ).  IT ALSO RETURNS IN J THE (INDEX-1) OF THE
C     DIRECTORY IN BUF.
C
      EXTERNAL        RSHIFT,ANDF
      LOGICAL         MDIUP,NEWBLK
      INTEGER         BUF,MDI,MDIPBN,MDILBN,MDIBL,BLKSIZ,DIRSIZ,
     1                ANDF,RSHIFT,NMSBR(2)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /MACHIN/ MACH,IHALF,JHALF
      COMMON /ZZZZZZ/ BUF(1)
      COMMON /SOF   / DITDUM(6),IODUM(8),MDI,MDIPBN,MDILBN,MDIBL,
     1                NXTDUM(15),DITUP,MDIUP
      COMMON /SYS   / BLKSIZ,DIRSIZ
      COMMON /SYSTEM/ NBUFF,NOUT
      DATA    IRD   , IWRT / 1, 2    /
      DATA    INDSBR/ 7    /,  NMSBR /4HFMDI,4H    /
C
C     NDIR IS THE NUMBER OF DIRECTORIES ON ONE BLOCK OF THE MDI.
C
      CALL CHKOPN (NMSBR(1))
      NDIR = BLKSIZ/DIRSIZ
C
C     COMPUTE THE LOGICAL BLOCK NUMBER, AND THE WORD NUMBER WITHIN
C     BUF IN WHICH THE ITH SUBSTRUCTURE DIRECTORY IS STORED.  STORE THE
C     BLOCK NUMBER IN IBLOCK, AND THE WORD NUMBER IN J.
C
      IBLOCK = I/NDIR
      IF (I .EQ. IBLOCK*NDIR) GO TO 10
      IBLOCK = IBLOCK + 1
   10 J = DIRSIZ*(I-(IBLOCK-1)*NDIR-1) + MDI
      IF (MDILBN .EQ. IBLOCK) RETURN
      IF (MDIPBN .EQ. 0) GO TO 20
      IF (.NOT.MDIUP) GO TO 20
C
C     THE MDI BLOCK CURRENTLY IN CORE HAS BEEN UPDATED.  MUST THEREFORE
C     WRITE IT OUT BEFORE READING IN A NEW BLOCK.
C
      CALL SOFIO (IWRT,MDIPBN,BUF(MDI-2))
      MDIUP = .FALSE.
C
C     THE DESIRED MDI BLOCK IS NOT PRESENTLY IN CORE, MUST THEREFORE
C     FETCH IT.
C
   20 NEWBLK = .FALSE.
C
C     FIND THE PHYSICAL BLOCK NUMBER OF THE BLOCK ON WHICH THE LOGICAL
C     BLOCK IBLOCK IS STORED.
C
      K = MDIBL
      ICOUNT = 1
   30 IF (ICOUNT .EQ. IBLOCK) GO TO 35
      ICOUNT = ICOUNT + 1
      CALL FNXT (K,NXTK)
      IF (MOD(K,2) .EQ. 1) GO TO 32
      IBL = RSHIFT(BUF(NXTK),IHALF)
      GO TO 34
   32 IBL = ANDF(BUF(NXTK),JHALF)
   34 IF (IBL .EQ. 0) GO TO 60
      K = IBL
      GO TO 30
   35 IF (MDIPBN .EQ. K) GO TO 500
C
C     READ THE DESIRED MDI BLOCK INTO CORE.
C
      MDIPBN = K
      MDILBN = IBLOCK
      IF (NEWBLK) RETURN
      CALL SOFIO (IRD,MDIPBN,BUF(MDI-2))
      RETURN
C
C     WE NEED A FREE BLOCK FOR THE MDI.
C
   60 CALL GETBLK (K,IBL)
      IF (IBL .EQ. -1) GO TO 1000
      NEWBLK = .TRUE.
      K   = IBL
      MIN = MDI + 1
      MAX = MDI + BLKSIZ
      DO 70 LL = MIN,MAX
      BUF(LL) = 0
   70 CONTINUE
      CALL SOFIO (IWRT,K,BUF(MDI-2))
      GO TO 30
C
C     ERROR IN UPDATING EITHER MDIPBN OR MDILBN.
C
  500 CALL ERRMKN (INDSBR,6)
C
C     ERROR MESSAGES.
C
 1000 WRITE  (NOUT,1001) UFM
 1001 FORMAT (A23,' 6223, SUBROUTINE FMDI - THERE ARE NO MORE FREE ',
     1       'BLOCKS AVAILABLE ON THE SOF.')
      CALL SOFCLS
      CALL MESAGE (-61,0,0)
      RETURN
      END

      SUBROUTINE SDR2
C
C     SDR2 IS THE EXECUTIVE CONTROL PROGRAM FOR THE SDR2 MODULE.
C
      INTEGER         ANY   ,LOADS ,DISPL ,VEL   ,ACC   ,SPCF  ,PLOTS ,
     1                CASECC
      COMMON /SDR2X4/ NAM(2),END   ,MSET  ,ICB(7),OCB(7),MCB(7),DTYPE(8)
     1,               ICSTM ,NCSTM ,IVEC  ,IVECN ,TEMP  ,DEFORM,FILE  ,
     2                BUF1  ,BUF2  ,BUF3  ,BUF4  ,BUF5  ,ANY   ,ALL   ,
     3                TLOADS,ELDEF ,SYMFLG,BRANCH,KTYPE ,LOADS ,SPCF  ,
     4                DISPL ,VEL   ,ACC   ,STRESS,FORCE ,KWDEST,KWDEDT,
     5                KWDGPT,KWDCC ,NRIGDS,STA(2),REI(2),DS0(2),DS1(2),
     6                FRQ(2),TRN(2),BK0(2),BK1(2),CEI(2),PLA(22)      ,
     7                NRINGS,NHARMS,AXIC  ,KNSET ,ISOPL ,STRSPT,DDRMM
      COMMON /SDR2X2/ CASECC
      COMMON /SYSTEM/ SYSBUF,OPTE  ,NOGO  ,INTAP ,MPCN  ,SPCN  ,METHOD,
     1                LOADNN,SYMM  ,STFTMP,PAGE  ,LINE  ,TLINE ,MAXLIN,
     2                DATE(3),TIME  ,ECHO  ,PLOTS
C
C     EXECUTE THE PHASES OF SDR2.
C
      CASECC = 101
      CALL SDR2AA
      CALL SDR2A
      IF (ANY .NE. 0) CALL SDR2B
      K = LOADS + SPCF + DISPL + VEL + ACC + PLOTS
      IF (K   .NE. 0) CALL SDR2C
      IF (ANY .NE. 0) CALL SDR2D
      RETURN
      END

      SUBROUTINE SKPREC(IFILE,K)
C
      INTEGER NAME(2)
C
      DATA NAME /4HSKPR,2HEC /
C
C ----------------------------------------------------------------------
C
      IF( K ) 10,30,20
C
   10 M=IABS(K)
      DO 15 I=1,M
      CALL BCKREC(IFILE)
   15 CONTINUE
      GO TO 30
C
   20 DO 25 I=1,K
      CALL FWDREC(*40,IFILE)
   25 CONTINUE
C
   30 RETURN
C
   40 CALL MESAGE(-2,IFILE,NAME)
      GO TO 30
C
      END

      SUBROUTINE SDRHT
C
C     SPECIAL FLUX-DATA-RECOVERY MODULE FOR HBDY ELEMENTS IN HEAT
C     TRANSFER.
C
C     DMAP CALLING SEQUENCE.
C
C     SDRHT SIL,USET,UGV,OEF1,SLT,EST,DIT,QGE,DLT,/OEF1X/V,N,TABS $
C
      LOGICAL         HAVIDS,CARDIN,LHBDY,TRANST,FOUND,MCH521
      INTEGER         TABLST(13),Z,BUF(50),SYSBUF,RD,RDREW,WRT,WRTREW,
     1                CLSREW,CLS,SUBR(2),NAME(2),EOR,IDPOS(3),OUTPT,
     2                SLTYPS,LDWORD(16),UG,OEF1,SLT,EST,DIT,QGE,DLT,
     3                OEF1X,BUF1,BUF2,BUF3,CORE,PASS,HBDYTP,MCBUGV(7),
     4                FILE,ELTYPE,ESTWDS,ECPT(100),SLTAT,SLTREC,MCB(7),
     5                EOL,GSIZE
      REAL            RZ(1),RBUF(50),GRIDS(6)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25,SWM*27
      COMMON /XMSSG / UFM,UWM,UIM,SFM,SWM
      COMMON /CONDAS/ CONSTS(5)
      COMMON /SYSTEM/ KSYSTM(65)
      COMMON /NAMES / RD,RDREW,WRT,WRTREW,CLSREW,CLS
      COMMON /ZNTPKX/ AI(4),IROW,EOL
      COMMON /ZZZZZZ/ Z(1)
      COMMON /MACHIN/ MACH
      COMMON /BLANK / TABS
      EQUIVALENCE     (KSYSTM(1),SYSBUF),(KSYSTM(2),OUTPT),
     1                (CONSTS(2),TWOPI ),(CONSTS(3),RADDEG),
     2                (Z(1),RZ(1)), (BUF(1),RBUF(1))
      DATA    TABLST / 4, 1105,11,1, 1205,12,2, 1305,13,3, 1405,14,4  /
      DATA    LENTRY / 14   /, EOR,NOEOR  / 1, 0 /, SUBR/ 4HSDRH,2HT  /
      DATA    IDPOS  / 2,1,5/, HBDYTP/ 52 /,     SLTYPS / 16 /
      DATA    LDWORD / 6,6,4,4,6,6,2,5,5,6,6,7,2,2,5,5  /
      DATA    UG,OEF1, SLT,EST,DIT,QGE,DLT,OEF1X /
     1        103,104, 105,106,107,108,109, 201  /
      DATA    GRIDS  / 1.0, 2.0, 2.0, 3.0, 4.0, 2.0     /
C
C     SET UP CORE AND BUFFERS
C
      BUF1   = KORSZ(Z) - SYSBUF - 2
      BUF2   = BUF1 - SYSBUF - 2
      BUF3   = BUF2 - SYSBUF - 2
      CORE   = BUF3 - 1
      IDREC  = 1
      IELTAB = 1
      PASS   = 0
      HAVIDS = .FALSE.
      CARDIN = .FALSE.
      MCH521 = MACH.EQ.5 .OR. MACH.EQ.21
C
C     OPEN INPUT FORCES -OEF1- AND OUTPUT FORCES -OEF1X-.
C
      CALL OPEN  (*1190,OEF1,Z(BUF1),RDREW)
      CALL OPEN  (*1200,OEF1X,Z(BUF2),WRTREW)
      CALL FNAME (OEF1X,NAME)
      CALL WRITE (OEF1X,NAME,2,EOR)
      CALL FWDREC (*1220,OEF1)
C
C     COPY RECORD PAIRS OF DATA FROM OEF1 TO OEF1X UNTIL HBDY DATA IS
C     DETECTED.
C
   10 LCORE = CORE - IDREC
      IF (LCORE .LT. 300) CALL MESAGE (-8,0,SUBR)
      FILE = OEF1
      CALL READ (*1180,*30,OEF1,Z(IDREC),LCORE,NOEOR,IFLAG)
      WRITE  (OUTPT,20) SWM
   20 FORMAT (A27,' 3063, INPUT FORCES DATA BLOCK HAS INCORRECT DATA.')
      GO TO 1220
C
C     MODIFY ID-RECORD IF THIS IS FOR HBDY ELEMENTS.
C
   30 IF (Z(IDREC+2) .NE. HBDYTP) GO TO 40
      LHBDY = .TRUE.
      GO TO 50
   40 LHBDY = .FALSE.
      GO TO 90
C
C     SET CONSTANTS FROM OEF1 ID RECORD.
C
   50 IF (Z(IDREC)/10 .EQ. 6) GO TO 70
      LOADID = Z(IDREC+7)
      TRANST = .FALSE.
      GO TO 80
   70 LOADID = Z(IDREC+7)
      TIME   = RZ(IDREC+4)
      TRANST = .TRUE.
   80 LWORDS = Z(IDREC+9)
      Z(IDREC+9) = 5
C/////
C     CALL BUG (4HTRAN ,90,TRANST,1)
C/////
   90 CALL WRITE (OEF1X,Z(IDREC),IFLAG,EOR)
      IF (LHBDY) GO TO 120
C
C     NOT AN HBDY ELEMENT TYPE THUS COPY DATA ACROSS.
C
  100 CALL READ  (*1260,*110,OEF1,Z(IDREC),LCORE,NOEOR,IFLAG)
      CALL WRITE (OEF1X,Z(IDREC),LCORE,NOEOR)
      GO TO 100
  110 CALL WRITE (OEF1X,Z(IDREC),IFLAG,EOR)
      GO TO 10
C
C     HBDY ELEMENT DATA ENCOUNTERED.
C
  120 PASS = PASS + 1
C
C     ON FIRST PASS ELEMENT-DATA-TABLE IS FORMED.
C
C     EACH ENTRY WILL CONTAIN,
C
C      1) ELEMENT-ID (HBDY).
C      2) FLUX-RADIATION TERM FOR THIS ELEMENT.
C      3) FLUX-X FROM OEF1 DATA.
C      4) APPLIED LOAD (USING SLT DATA).
C      5) HBDY ELEMENT TYPE (1 TO 6).
C      6) HBDY AREA FACTOR.
C      7) ALPHA VALUE.
C      8) V1(1) *
C      9) V1(2)  *  VECTOR-V1
C     10) V1(3) *
C     11) V2(1) *
C     12) V2(2)  *  VECTOR-V2
C     13) V2(3) *
C     14) OUTPUT ID*10 + DEVICE CODE (FROM OEF1).
C
C     ON PASSES OTHER THAN THE FIRST ONLY THE FLUX-X VALUE IS EXTRACTED
C     FROM OEF1-HBDY-ENTRIES.
C
      JELTAB = IELTAB - 1
C
C     INPUT = ID*10+CODE, NAME1,NAME2,GRD-X,GRD-Y,GRD-Z,FLUX-X,FLUX-Y,
C             FLUX-Z   (TOTAL OF 9 WORDS)
C
  130 CALL READ (*1260,*150,OEF1,BUF,LWORDS,NOEOR,IFLAG)
      IF (PASS .GT. 1) GO TO 140
      Z(JELTAB+1) = BUF(1)/10
C
C     STORE (FLUX-X) AND (OUTPUT ID*10 + DEVICE CODE).
C
  140 Z(JELTAB+ 3) = BUF(7)
      RZ(JELTAB+2) = 0.0
      Z(JELTAB+14) = BUF(1)
      JELTAB = JELTAB + LENTRY
      IF (JELTAB .GT. CORE) CALL MESAGE (-8,0,SUBR)
      GO TO 130
C
C     END OF DATA.
C
  150 IF (PASS .GT. 1) GO TO 160
      NELTAB = JELTAB
      NUMBER = (NELTAB - IELTAB + 1)/LENTRY
C
C     OPEN UG FILE FOR INPUT OF UG VECTORS.
C
      CALL OPEN (*1220,UG,Z(BUF3),RDREW)
      CALL FWDREC (*1220,UG)
      MCBUGV(1) = UG
      CALL RDTRL (MCBUGV)
      GSIZE = MCBUGV(3)
      GO TO 180
  160 IF (JELTAB .EQ. NELTAB) GO TO 180
      WRITE  (OUTPT,170) SWM,JELTAB,NELTAB
  170 FORMAT (A27,' 3064, INCONSISTANT HBDY DATA RECORDS.  ',2I20)
      GO TO 1220
C
C     ALL DATA FROM OEF1 IS AT HAND NOW.
C     FILES ARE CLOSED WITHOUT REWIND.
C
  180 CALL CLOSE (OEF1,CLS)
      CALL CLOSE (OEF1X,CLS)
C
C     ALLOCATE UG VECTOR SPACE ON FIRST PASS.
C
      IF (PASS .NE. 1) GO TO 190
      IUG  = NELTAB + 1
      NUG  = NELTAB + GSIZE
      IUGZ = IUG - 1
      IF (NUG + 5 .GT. CORE) CALL MESAGE (-8,0,SUBR)
C
C     BRING NEXT DISPLACEMENT VECTOR INTO CORE.
C
  190 DO 200 I = IUG,NUG
      RZ(I) = TABS
  200 CONTINUE
C
      CALL INTPK (*220,UG,0,1,0)
  210 CALL ZNTPKI
      KK = IUGZ + IROW
      RZ(KK) = RZ(KK) + AI(1)
      IF (EOL) 210,210,220
C
C     RAISE VECTOR RESULT TO 4TH POWER
C
  220 DO 230 I = IUG,NUG
      RZ(I) = RZ(I)**4
  230 CONTINUE
C
C     IF TRANSIENT PROBLEM SKIP ACCELERATION AND VELOCITY VECTORS
C
      IF (.NOT. TRANST) GO TO 250
      DO 240 I = 1,2
      CALL FWDREC (*250,UG)
  240 CONTINUE
  250 CONTINUE
C/////
C     CALL BUG (4HUG4  ,200,Z(IUG),NUG-IUG+1)
C/////
C
C     IF NONLINEAR PROBLEM, COMPUTE FLUX RADIATION TERMS.
C
C                                            T           4
C     (FLUX-RADIATION         ) = (Q           )(U +TABS)
C                    EL-SUBSET      G,EL-SUBSET   G
C
      FILE = QGE
      CALL OPEN (*261,QGE,Z(BUF1),RDREW)
      IF (PASS .EQ. 1) GO TO 260
      CALL FWDREC (*1260,QGE)
      GO TO 280
  261 IQGID = NUG + 1
      NQGID = NUG
      IDREC = NQGID
      GO TO 311
  260 CALL READ (*1260,*1270,QGE,BUF,-2,NOEOR,IFLAG)
C
C     ON FIRST PASS PICK UP ELEMENT ID LIST.
C
      IQGID = NUG + 1
      CALL READ (*1260,*270,QGE,Z(IQGID),CORE-IQGID,NOEOR,IFLAG)
      CALL MESAGE (-7,0,SUBR)
  270 NQGID = NUG + IFLAG
      IDREC = NQGID + 1
C/////
C     CALL BUG (4HQGID,410,Z(IQGID),NQGID-IQGID+1)
C/////
C
C     EACH FLUX-RADIATION TERM IN THE ELEMENT TABLE IS CREATED BY
C     FORMING THE DOT-PRODUCT OF THE COLUMN OF -QGE- HAVING THE
C     SAME ELEMENT-ID WITH THE -UG- VECTOR IN CORE.
C
  280 DO 310 I = IQGID,NQGID,1
      CALL INTPK (*310,QGE,0,1,0)
C
C     FIND OUT IF ID OF THIS VECTOR IS IN ELEMENT TABLE.
C
      KID = Z(I)
      CALL BISLOC (*300,KID,Z(IELTAB),LENTRY,NUMBER,JPOINT)
      JWORD = IELTAB + JPOINT
      Z(JWORD) = 0
C
C     FORM DOT PRODUCT
C
  290 CALL ZNTPKI
      K = IUGZ + IROW
      RZ(JWORD) = RZ(JWORD) - AI(1)*RZ(K)
      IF (EOL) 290,290,310
C
C     ID OF THIS COLUMN NOT IN ELEMENT TABLE
C
  300 CALL ZNTPKI
      IF (EOL) 300,300,310
  310 CONTINUE
C/////
C     CALL BUG (4HELTB ,440,Z(IELTAB),NELTAB-IELTAB+1)
C/////
      CALL CLOSE (QGE,CLSREW)
C
C     ON FIRST PASS, EST IS PASSED AND HBDY ELEMENTS CALLED.
C
  311 CONTINUE
      IF (PASS .GT. 1) GO TO 380
      FILE = EST
      CALL GOPEN (EST,Z(BUF1),RDREW)
      NEXT = IELTAB
C
C     READ THE ELEMENT TYPE
C
  320 CALL READ (*350,*1270,EST,ELTYPE,1,NOEOR,IFLAG)
      IF (ELTYPE .EQ. HBDYTP) GO TO 330
      CALL FWDREC (*1260,EST)
      GO TO 320
C
C     HBDY ELEMENT-SUMMARY-TABLE DATA FOUND.
C
  330 ESTWDS = 53
  340 CALL READ (*1260,*1270,EST,ECPT,ESTWDS,NOEOR,IFLAG)
C
C     CHECK TO SEE IF THIS ELEMENT IS IN OUTPUT SET.
C
      IF (Z(NEXT) - ECPT(1)) 350,370,340
  350 WRITE  (OUTPT,360) SWM,Z(NEXT)
  360 FORMAT (A27,' 3065, THERE IS NO EST DATA FOR HBDY ELEMENT ID =',
     1        I10)
      GO TO 1220
C
C     THIS ELEMENT IS IN TABLE.
C
  370 CALL HBDY (ECPT,ECPT,2,RBUF,BUF)
C
C     PLANT HBDY OUTPUTS INTO TABLE.
C
      Z(NEXT+ 4) = ECPT(2)
      Z(NEXT+ 5) = BUF(2)
      Z(NEXT+ 6) = ECPT(17)
      Z(NEXT+ 7) = BUF(11)
      Z(NEXT+ 8) = BUF(12)
      Z(NEXT+ 9) = BUF(13)
      Z(NEXT+10) = BUF(14)
      Z(NEXT+11) = BUF(15)
      Z(NEXT+12) = BUF(16)
      NEXT = NEXT + LENTRY
      IF (NEXT .LT. NELTAB) GO TO 340
      CALL CLOSE (EST,CLSREW)
C
C     LOAD SET PROCESSING IF LOAD-SET-ID IS NON-ZERO.
C
 380  IF (LOADID) 944,944,390
C
C     OPEN SLT FOR LOAD DATA.
C
C
  390 FILE = SLT
      CALL OPEN (*1250,SLT,Z(BUF1),RDREW)
      IF (HAVIDS) CALL FWDREC (*1260,SLT)
      IF (HAVIDS) GO TO 810
      HAVIDS = .TRUE.
      ILDID  = NQGID + 1
      NLDID  = ILDID - 1
C
C     IDS OF LOAD SETS NOT IN CORE THUS BRING IN IDS FROM HEADER RECORD.
C
      IMAST  = ILDID
      NSETS  = 0
      NLDSET = 3
      CALL READ (*1260,*1270,SLT,BUF,-2,NOEOR,IFLAG)
  400 IF (NLDID+5 .GT. CORE) CALL MESAGE (-8,0,SUBR)
      CALL READ (*1260,*410,SLT,Z(NLDID+1),1,NOEOR,IFLAG)
      NSETS = NSETS + 1
      Z(NLDID +2) = 1
      Z(NLDID +3) = Z(NLDID+1)
      RZ(NLDID+4) = 1.0
      Z(NLDID +5) = NSETS
      NLDID = NLDID + 5
      GO TO 400
C
C     IF TRANSIENT PROBLEM THEN DLT OPERATIONS BEGIN
C
  410 IF (.NOT.TRANST) GO TO 800
      FILE = DLT
      CALL OPEN (*1250,DLT,Z(BUF2),RDREW)
      CALL READ (*1260,*1270,DLT,BUF,3,NOEOR,IFLAG)
      M = BUF(3)
      FOUND = .FALSE.
      IF (M .LE. 0) GO TO 430
      DO 420 I = 1,M
      CALL READ (*1260,*1270,DLT,BUF,1,NOEOR,IFLAG)
      IF (BUF(1) .EQ. LOADID) FOUND = .TRUE.
  420 CONTINUE
C
C     NOW READ RLOAD1, RLOAD2, TLOAD1, AND TLOAD2 IDS.
C
  430 IRTIDS = NLDID + 1
      CALL READ (*1260,*440,DLT,Z(IRTIDS),CORE-IRTIDS,NOEOR,IFLAG)
      CALL MESAGE (-7,0,SUBR)
      GO TO 1220
  440 NRTIDS = NLDID + IFLAG
C
C     IF LOADID WAS FOUND AMONG THE DLOAD IDS, SEARCH IS NOW MADE IN
C     RECORD 1 OF THE DLT FOR THAT ID, AND ITS SUB-IDS.
C
      JJ1   = ILDID
      JJ2   = NLDID
      ILDID = NRTIDS + 1
      NLDID = NRTIDS + 2
      Z(ILDID  ) = LOADID
      Z(ILDID+1) = 0
      IF (.NOT. FOUND) GO TO 520
C
C     READ A MASTER DLOAD SET-ID.
C
  450 CALL READ (*1260,*1270,DLT,BUF,2,NOEOR,IFLAG)
      IF (BUF(1) .EQ. LOADID) GO TO 470
C
C     SKIP SUB-ID DATA OF THIS MASTER
C
  460 CALL READ (*1260,*1270,DLT,BUF,2,NOEOR,IFLAG)
      IF (BUF(2)) 450,460,460
C
C     MASTER-ID FOUND.  BUILD LOAD-SET-ID TABLE.
C
  470 FACTOR = RBUF(2)
  472 IF (NLDID+11 .LE. CORE) GO TO 480
      CALL MESAGE (8,0,SUBR)
      GO TO 1220
  480 CALL READ (*1260,*1270,DLT,BUF,2,NOEOR,IFLAG)
      IF (BUF(2)) 540,540,490
  490 Z(ILDID +1) = Z(ILDID+1) + 1
      Z(NLDID +1) = BUF(2)
      RZ(NLDID+2) = 0.0
      Z(NLDID +3) = 0
      RZ(NLDID+4) = RBUF(1)*FACTOR
      Z(NLDID +5) = 0
      NLDID = NLDID + 11
      GO TO 472
C
C     LOADID NOT AMONG DLOADS FOR THIS TRANSIENT PROBLEM
C
  520 Z(ILDID+1) = 1
      IF (NLDID+13 .LE. CORE) GO TO 530
      CALL MESAGE (8,0,SUBR)
      GO TO 1220
  530 Z(NLDID +1) = Z(ILDID)
      RZ(NLDID+2) = 0.0
      Z(NLDID +3) = 0
      RZ(NLDID+4) = 1.0
      Z(NLDID +5) = 0
      NLDID = NLDID + 11
C
C     IF THERE ARE ANY DLOAD CARDS AT ALL THEN BALANCE OF (OR ALL OF)
C     RECORD 1 IS NOW SKIPPED.
C
  540 IF (M .GT. 0) CALL FWDREC (*1260,DLT)
C
C     NOW PICKING UP DATA NEEDED OF DYNAMIC LOAD SET RECORDS.
C
      K1 = ILDID + 2
      K2 = NLDID
      DO 580 I = IRTIDS,NRTIDS
C
C     READ THE LOAD TYPE
C
      CALL READ (*1260,*1270,DLT,BUF,2,NOEOR,IFLAG)
      IF (BUF(1).NE.3 .AND. BUF(1).NE.4) GO TO 570
C
C     CHECK AND SEE IF THIS TLOAD ID IS AMONG THE SUB-IDS
C
      DO 550 J = K1,K2,11
      IF (Z(J) .EQ. Z(I)) GO TO 560
  550 CONTINUE
      GO TO 570
C
C     YES THIS RECORD IS NEEDED.  THUS PUT ITS DATA IN TABLE.
C
  560 Z(J+4) = BUF(1)
C
C     SLT ID INTO TABLE
C
      Z(J) = -BUF(2)
C
C     SET SLT RECORD NUMBER
C
      K = 0
      DO 565 L = JJ1,JJ2,5
      K = K + 1
      IF (Z(L) .EQ. BUF(2)) GO TO 566
  565 CONTINUE
      K = 0
  566 Z(J+2) = K
      CALL READ (*1260,*1270,DLT,Z(J+5),6,EOR,IFLAG)
      IF (BUF(1) .EQ. 3) Z(J+6) = 0
      GO TO 580
  570 CALL FWDREC (*1260,DLT)
  580 CONTINUE
C
C     CHECK IS NOW MADE TO INSURE ALL SUB-IDS RECEIVED DLT DATA.
C
C
C     SET SLT IDS POSITIVE
C
      DO 581 I = K1,K2,11
      Z(I) = IABS(Z(I))
  581 CONTINUE
      DO 610 I = K1,K2,11
      IF (Z(I+4)) 590,590,610
C
C     ERROR
C
  590 WRITE  (OUTPT,600) UWM,Z(I)
  600 FORMAT (A25,' 3066, THERE IS NO TLOAD1 OR TLOAD2 DATA FOR LOAD-',
     1       'ID =',I9)
  610 CONTINUE
C
      CALL CLOSE (DLT,CLSREW)
      NLDSET = 11
C
C     SORT SUB-ID TABLE ON SLT RECORD NUMBERS.
C
      CALL SORT (0,0,11,3,Z(K1),K2-K1+1)
C/////
C     CALL BUG (4HTABL,640,Z(K1),K2-K1+1)
C
C     CONSTRUCTION OF TABLE-ID LIST.
C
      ITABID = NLDID + 1
      NTABID = NLDID + 1
C
C     FIRST GET TABLE ID-S PRESENT IN THE SUB-ID TABLE.
C
      DO 680 I = K1,K2,11
C
C     CHECK FOR OTHER THAN TLOAD1 TYPE CARD
C
      IF (Z(I+4) .NE. 3) GO TO 680
C
C     CHECK FOR ID IN TABLE.
C
      IF (NTABID .LE. ITABID) GO TO 660
      DO 650 J = ITABID,NTABID
      IF (Z(I+5) .EQ. Z(J)) GO TO 680
  650 CONTINUE
  660 NTABID = NTABID + 1
      IF (NTABID .GT. CORE) CALL MESAGE (-8,0,SUBR)
      Z(NTABID) = Z(I+5)
  680 CONTINUE
C
C     NOW PASS SLT AND GET ANY TABLE IDS PRESENT IN QVECT PORTION OF
C     RECORDS WE WILL BE USING.  (SLT IS CURRENTLY POSITIONED AT FIRST
C     RECORD.)
C
      SLTAT = 1
      FILE  = SLT
      DO 780 I = K1,K2,11
      NGO = Z(I+2) - SLTAT
      IF (NGO) 780,710,690
  690 DO 700 J = 1,NGO
      CALL FWDREC (*1260,SLT)
  700 CONTINUE
      SLTAT = SLTAT + NGO
C
C     LOOK FOR QVECT CARDS.
C
  710 CALL READ (*1260,*770,SLT,BUF,2,NOEOR,IFLAG)
      ITYPE  = BUF(1)
      NCARDS = BUF(2)
      NWORDS = LDWORD(ITYPE)
      IF (ITYPE .NE. 16) GO TO 760
C
C     QVECT CARDS FOUND
C
      IF (NCARDS .LE. 0) GO TO 710
      DO 750 J = 1,NCARDS
      CALL READ (*1260,*1270,SLT,BUF,NWORDS,NOEOR,IFLAG)
      DO 740 K = 2,4
      L = NUMTYP(BUF(K))
      IF (MCH521 .AND. BUF(K).GT.16000 .AND. BUF(K).LE.99999999) L= 1
      IF (BUF(K).LE.0 .OR. L.NE.1) GO TO 740
C
C     TABLE ID FOUND.  ADD TO LIST IF NOT YET IN.
C
      IF (NTABID .LE. ITABID) GO TO 730
      DO 720 L = ITABID,NTABID
      IF (BUF(K) .EQ. Z(L)) GO TO 740
  720 CONTINUE
  730 NTABID = NTABID + 1
      IF (NTABID .GT. CORE) CALL MESAGE (-8,0,SUBR)
      Z(NTABID) = BUF(K)
  740 CONTINUE
  750 CONTINUE
      GO TO 710
  760 IF (ITYPE .GT. 16) GO TO 1170
      NWDCRD = -NWORDS*NCARDS
      CALL READ (*1260,*1270,SLT,BUF,NWDCRD,NOEOR,IFLAG)
      GO TO 710
  770 SLTAT = SLTAT + 1
  780 CONTINUE
      NUMTAB   = NTABID - ITABID
      Z(ITABID)= NUMTAB
      NUMTAB   = Z(ITABID)
C
C     TABLE-ID LIST COMPLETE. NOW SORT IT AND PRIME TAB ROUTINE.
C
      CALL REWIND (SLT)
      CALL FWDREC (*1260,SLT)
C/////
C     CALL BUG (4HTBID,555,Z(ITABID),NTABID-ITABID+1)
C/////
      IDIT = NTABID + 1
      NDIT = IDIT
      LZ   = CORE - IDIT
      IF (LZ .GT. 10) GO TO 790
      CALL MESAGE (8,0,SUBR)
      GO TO 1220
  790 CONTINUE
      IF (NUMTAB .EQ. 0) GO TO 792
      CALL SORT (0,0,1,1,Z(ITABID+1),NUMTAB)
      CALL PRETAB(DIT,Z(IDIT),Z(IDIT),Z(BUF2),LZ,LUSED,Z(ITABID),TABLST)
      NDIT = IDIT + LUSED
C/////
C     CALL BUG (4HDITS,557,Z(IDIT),NDIT-IDIT+1)
C/////
  792 CONTINUE
      IDREC = NDIT + 1
      GO TO 810
C
C     DETERMINE IF -LOADID- IS IN LIST OF LOAD SET IDS.
C
  800 IDREC = NLDID + 1
C/////
C     CALL BUG (4HLD1   ,360,Z(ILDID),NLDID-ILDID+1)
C/////
  810 CONTINUE
      NMAST = NLDID
      J = ILDID
  820 IF (J .LE. NLDID) GO TO 910
C
C     LOAD SET ID LIST EXHAUSTED.
C     BRING IN ANY LOAD CARDS IF NOT YET IN.
C
      IF (CARDIN) GO TO 920
C
C     THE LOAD-SET-ID TABLE HAS THE FOLLOWING FORMAT.
C
C     MASTER ID                                ******       Z(ILDID)
C     NUMBER OF SUB-IDS FOR THIS MASTER              *
C     SUB-ID             **  3-WORDS  ***             *
C     SCALE FACTOR = F(T)  * ONLY IF     *             *
C     SLT RECORD NUMBER  **  STATICS      * 11 WORDS   * REPEATS FOR
C     CONSTANT SCALE FACTOR               * REPEATS    * EACH MASTER
C     TYPE OF TLOAD =(3 OR 4)             * FOR EACH   * ID PRESENT
C     TYPE3 TABLE ID (OR) TYPE4 T1        * SUB-ID     *
C           0                   T2        * OF THIS    *
C           0                   OMEGA     * MASTER     *
C           0                   PHI       * ID         *
C           0                   N        *             *
C           0                   ALPHA ***              *
C              .                                       *
C              .                                      *
C              .                                     *
C                                              ******
C             ...                    ...
C             ...                    ...
C             ...                    ...                    Z(NLDID)
C
C
      CARDIN = .TRUE.
C
C     FORWARD SLT TO LOAD CARD RECORD.
C
      IF (NSETS) 850,850,830
  830 DO 840 I = 1,NSETS
      CALL FWDREC (*1250,SLT)
  840 CONTINUE
C
C     READ AND ENTER MASTER ID INTO TABLE
C
  850 IF (NLDID+2 .GT. CORE) CALL MESAGE (-8,0,SUBR)
      CALL READ (*1260,*900,SLT,Z(NLDID+1),2,NOEOR,IFLAG)
      SCALE  = RZ(NLDID+2)
      NLDID  = NLDID + 2
      JCOUNT = NLDID
      Z(JCOUNT) = 0
C
C     READ THE (SID, SCALE-FACTOR)  PAIRS FOR THIS ID.
C
  860 IF (NLDID+3 .GT. CORE) CALL MESAGE (-8,0,SUBR)
      CALL READ (*1260,*1270,SLT,Z(NLDID+1),2,NOEOR,IFLAG)
      IF (Z(NLDID+1) .EQ. -1) GO TO 890
C
C     MULTIPLY SUBID SCALE FACTOR BY MASTER SCALE FACTOR.
C
      RZ(NLDID+2) = RZ(NLDID+2)*SCALE
C
C     DETERMIND SLT RECORD NUMBER OF THIS SUB ID.
C
      KREC = 1
      DO 870 I = IMAST,NMAST,NLDSET
      IF (Z(NLDID+1) .EQ. Z(I)) GO TO 880
      KREC = KREC + 1
  870 CONTINUE
      KREC = 0
  880 Z(NLDID+3) = KREC
      NLDID = NLDID + 3
      Z(JCOUNT) = Z(JCOUNT) + 1
      GO TO 860
C
C     SORT ALL SUB-ID 3 WORD GROUPS ON SLT RECORD NUMBER.
C
  890 CALL SORT (0,0,3,3,Z(JCOUNT+1),NLDID-JCOUNT)
      GO TO 850
C
C     REPOSITION SLT TO BEGINNING OF FIRST SLT RECORD
C
  900 IDREC = NLDID + 1
C/////
C     CALL BUG (4HLDID,460,Z(ILDID),NLDID - ILDID+1)
C/////
      CALL REWIND (SLT)
      CALL FWDREC (*1260,SLT)
      GO TO 820
C
C     CONTINUE SEARCH FOR LOADID
C
  910 IF (LOADID .EQ. Z(J)) GO TO 940
C
C     POSITION -J- TO NEXT LOAD-SET-ID IN TABLE
C
      J = J + NLDSET*Z(J+1) + 2
      GO TO 820
C
C     -LOADID- NOT FOUND ANYWHERE.
C
  920 WRITE  (OUTPT,930) UWM,LOADID
  930 FORMAT (A25,' 3067, LOAD SET ID =',I9,' IS NOT PRESENT.')
      GO TO 1220
C
C     MATCH ON MASTER ID HAS BEEN FOUND.
C
  940 NLOADS = Z(J+1)
      ILOAD  = J + 2
      NLOAD  = ILOAD + NLDSET*NLOADS - 1
C
C     PROCESS ALL THE LOAD RECORDS FOR THIS MASTER-ID
C
      SLTAT = 1
C/////
C     CALL BUG (4HLOAD ,500,Z(ILOAD),NLOAD-ILOAD+1)
C/////
C
C     INITIALIZE APPLIED LOAD TO 0.0 FOR ALL ELEMENTS IN TABLE
C
 944  CONTINUE
      DO 945 I = IELTAB,NELTAB,LENTRY
      RZ(I+3) = 0.0
  945 CONTINUE
      IF (LOADID .LE. 0) GO TO 1140
      DO 1130 I = ILOAD,NLOAD,NLDSET
      FACTOR = RZ(I+1)
      IF (.NOT.TRANST) GO TO 960
C
C     FACTOR HAS TO BE FOUND AS F(TIME)
C
      IF (Z(I+4) .EQ. 4) GO TO 950
      CALL TAB (Z(I+5),TIME,YVALUE)
      FACTOR = RZ(I+3)*YVALUE
      GO TO 960
  950 TT = TIME - RZ(I+5)
      IF (TT .EQ. 0.0) GO TO 951
      IF (TT.LE.0.0 .OR. TIME.GE.RZ(I+6)) GO TO 955
      FACTOR = RZ(I+3)*EXP(RZ(I+10)*TT)*(TT**RZ(I+9))*COS(TWOPI*
     1         RZ(I+7)*TT + RZ(I+8)/RADDEG)
      GO TO 960
  951 IF (RZ(I+9) .NE. 0.0) GO TO 955
      FACTOR = COS(TWOPI*RZ(I+7))
      GO TO 960
  955 FACTOR = 0.0
  960 SLTREC = Z(I+2)
      IF (SLTREC.LE.0 .OR. FACTOR.EQ.0.0) GO TO 1130
C
C     POSITION SLT TO RECORD DESIRED.
C
  980 NGO = SLTREC - SLTAT
      IF (NGO) 990,1020,1000
C
C     NEED TO BACK UP ON SLT.
C
  990 CALL BCKREC (SLT)
      SLTAT = SLTAT - 1
      GO TO 980
C
C     NEED TO GO FORWARD ON SLT
C
 1000 DO 1010 J = 1,NGO
      CALL FWDREC (*1260,SLT)
 1010 CONTINUE
      SLTAT = SLTAT + NGO
C
C     SLT IS NOW POSITIONED TO LOAD RECORD DESIRED.
C
C
C     GENERATE LOADS FOR THOSE ELEMENTS IN THE TABLE USING ONLY QBDY1,
C     QBDY2, AND QVECT CARDS.
C
 1020 CALL READ (*1260,*1130,SLT,BUF,2,NOEOR,IFLAG)
      ITYPE = BUF(1)
      IF (ITYPE .LE. SLTYPS) GO TO 1040
      WRITE  (OUTPT,1030) SWM,ITYPE
 1030 FORMAT (A27,' 3068, UNRECOGNIZED CARD TYPE =',I9,
     1       ' FOUND IN -SLT- DATA BLOCK.')
      GO TO 1220
 1040 NCARDS = BUF(2)
      IF (NCARDS) 1020,1020,1050
 1050 NWORDS = LDWORD(ITYPE)
      IF (ITYPE.GE.14 .AND. ITYPE.LE.16) GO TO 1060
      NWDCRD = -NWORDS*NCARDS
      CALL READ (*1260,*1270,SLT,BUF,NWDCRD,NOEOR,IFLAG)
      GO TO 1020
 1060 ITYPE = ITYPE - 13
      JID = IDPOS(ITYPE)
      DO 1120 K = 1,NCARDS
C
C     READ A QBDY1, QBDY2, OR QVECT ENTRY.
C
      CALL READ (*1260,*1270,SLT,BUF,NWORDS,NOEOR,IFLAG)
C
C     CHECK FOR ID IN THE TABLE (OTHERWISE SKIP).
C
      CALL BISLOC (*1120,BUF(JID),Z(IELTAB),LENTRY,NUMBER,JPOINT)
      KK = IELTAB + JPOINT
C
C     THIS ELEMENT IS IN TABLE, THUS COMPUTE AND SUM IN THE LOAD.
C
      GO TO (1070,1080,1090), ITYPE
 1070 RZ(KK+2) = RZ(KK+2) + RZ(KK+4)*RBUF(1)*FACTOR
      GO TO 1120
C
 1080 KTYPE    = Z(KK+3)
      RZ(KK+2) = RZ(KK+2) + FACTOR*RZ(KK+4)*(RBUF(2)+RBUF(3) + RBUF(4) +
     1           RBUF(5))/GRIDS(KTYPE)
      GO TO 1120
C
C
C     CALL TAB IF E1,E2,E3 OF QVECT DATA ARE TABLE ID-S IMPLYING
C     TIME DEPENDENCE
C
 1090 IF (.NOT.TRANST) GO TO 1099
      DO 1094 KKK = 2,4
      L = NUMTYP(BUF(KKK))
      IF (MCH521 .AND. BUF(KKK).GT.16000 .AND. BUF(KKK).LE.99999999)
     1    L = 1
      IF (BUF(KKK).LE.0 .OR. L.NE.1) GO TO 1094
      CALL TAB (BUF(KKK),TIME,YVALUE)
      RBUF(KKK) = YVALUE
 1094 CONTINUE
 1099 KTYPE = Z(KK+3)
      C = RBUF(2)*RZ(KK+6) + RBUF(3)*RZ(KK+7) + RBUF(4)*RZ(KK+8)
      IF (KTYPE .EQ. 6) GO TO 1110
      IF (C) 1100,1100,1120
 1100 RZ(KK+2) = RZ(KK+2) - C*RZ(KK+4)*RZ(KK+5)*RBUF(1)*FACTOR
      GO TO 1120
 1110 RZ(KK+2) = RZ(KK+2) + FACTOR*RZ(KK+4)*RBUF(1)*RZ(KK+5)*SQRT(C*C +
     1  (RBUF(2)*RZ(KK+9) + RBUF(3)*RZ(KK+10) + RBUF(4)*RZ(KK+11))**2)
C
 1120 CONTINUE
C
 1130 CONTINUE
      CALL CLOSE (SLT,CLSREW)
C/////
C     CALL BUG (4HTELT,670,Z(IELTAB),NELTAB-IELTAB+1)
C/////
C
C     ELEMENT TABLE IS NOW COMPLETE FOR OUTPUT.
C
 1140 FILE = OEF1X
      CALL OPEN (*1250,OEF1X,Z(BUF1),WRT)
      DO 1160 I = IELTAB,NELTAB,LENTRY
      BUF( 1) = Z(I+13)
      RBUF(2) = RZ(I+3)
      RBUF(3) = RZ(I+2)
      RBUF(4) = RZ(I+1)
      RBUF(5) = RBUF(2) + RBUF(3) + RBUF(4)
      CALL WRITE (OEF1X,BUF(1),5,NOEOR)
 1160 CONTINUE
      CALL WRITE (OEF1X,0,0,EOR)
      FILE = OEF1
      CALL OPEN (*1250,OEF1,Z(BUF2),RD)
      GO TO 10
 1170 WRITE (OUTPT,1030)ITYPE
      GO TO 1220
C
C     ALL PROCESSING COMPLETE.
C
 1180 MCB(1) = OEF1
      CALL RDTRL (MCB)
      MCB(1) = OEF1X
      CALL WRTTRL (MCB)
      GO TO 1220
C
C     ERROR CONDITIONS.
C
 1190 RETURN
C
 1200 WRITE  (OUTPT,1210) UWM
 1210 FORMAT (A25,' 3069, OUTPUT DATA BLOCK FOR FORCES IS PURGED.')
 1220 CALL CLOSE (OEF1,CLSREW)
      CALL CLOSE (OEF1X,CLSREW)
      CALL CLOSE (UG,CLSREW)
      CALL CLOSE (EST,CLSREW)
      CALL CLOSE (SLT,CLSREW)
      CALL CLOSE (DLT,CLSREW)
      GO TO 1190
 1250 N = 1
      GO TO 1280
 1260 N = 2
      GO TO 1280
 1270 N = 3
 1280 CALL MESAGE (N,FILE,SUBR)
      GO TO 1220
      END

      SUBROUTINE DDR1A (PD,K2DD,B2DD,MDD,VUD,PAD,FRL,FRQSET,SCR1,SCR2,
     1                  SCR3,SCR4,ITYPE,SCR5)
C
C     ROUTINE TO COMPUTE PAD FROM MODAL APPROXIMATION TO SYSTEM
C
      INTEGER         B2DD,PD,VUD,FRL,FRQSET,SCR1,SCR2,SCR3,SCR4,SCR5,
     1                SYSBUF,FILE,MCB(7),MCB1(7),MCB2(7),SR1,SR3,FREQ,
     2                PAD,NAME(2)
      DIMENSION       IBLK(60),B(2),IMCB(21),IFILE(3)
      COMMON /SYSTEM/ SYSBUF
      COMMON /CONDAS/ CONSTS(5)
      COMMON /ZZZZZZ/ CORE(1)
      COMMON /ZNTPKX/ A(4),II,IEOL,IEOR
      EQUIVALENCE     (MCB(1),IMCB(1)),(MCB2(1),IMCB(8)),
     1                (MCB1(1),IMCB(15)),(CONSTS(2),TWOPI)
      DATA    NAME  / 4HDDR1,4HA   /
      DATA    FREQ  / 4HFREQ       /
C
C     INITIALIZE + FIND OUT WHAT EXISTS
C
      SR1  = SCR1
      SR3  = SCR3
      IBUF = KORSZ(CORE) - SYSBUF + 1
      NOK2DD = 1
      MCB(1) = K2DD
      CALL RDTRL (MCB)
      IF (MCB(1) .LE. 0) NOK2DD = -1
      NOB2DD = 1
      MCB(1) = B2DD
      CALL RDTRL (MCB)
      IF (MCB(1) .LE. 0) NOB2DD = -1
      MCB(1) = PD
      CALL RDTRL (MCB)
C
C     IS THIS FREQRES OR TRANSIENT
C
      IF (ITYPE .NE. FREQ) GO TO 160
C
C     BRING IN FRL
C
      FILE = FRL
      CALL OPEN  (*280,FRL,CORE(IBUF),0)
      CALL FREAD (FRL,0,-2,0)
      CALL READ  (*300,*20,FRL,CORE(1),IBUF,0,NFREQ)
      GO TO 310
   20 CALL CLOSE (FRL,1)
      NLOAD = MCB(2)/NFREQ
      IT = 3
C
C     BUILD  ACCELERATION AND VELOCITY IF NEEDED
C
   30 CALL GOPEN (VUD,CORE(IBUF),0)
C
C     PUT  ACCELERATION VECTOR ON SCR1
C
      NZ = IBUF - SYSBUF
      CALL GOPEN (SCR1,CORE(NZ),1)
      CALL MAKMCB (MCB1,SCR1,MCB(3),2,IT)
      IF (NOB2DD .LT. 0) GO TO 40
C
C     PUT VELOCITY VECTOR ON SCR2
C
      NZ = NZ - SYSBUF
      CALL GOPEN (SCR2,CORE(NZ),1)
      CALL MAKMCB (MCB2,SCR2,MCB(3),2,IT)
   40 IF (ITYPE .NE. FREQ) GO TO 170
C
C     COMPUTE  VECTORS
C
      DO 45 I = 1,NFREQ
   45 CORE(I) = CORE(I)*TWOPI
      DO 100 J = 1,NLOAD
      DO 90  I = 1,NFREQ
      W  = CORE(I)
      W2 = -W*W
      CALL BLDPK (3,3,SCR1,IBLK(1),1)
      IF (NOB2DD .LT. 0) GO TO 50
      CALL BLDPK (3,3,SCR2,IBLK(21),1)
   50 CALL INTPK (*80,VUD,0,3,0)
   60 IF (IEOL)  80,70,80
   70 CALL  ZNTPKI
      B(1) = W2*A(1)
      B(2) = W2*A(2)
      CALL BLDPKI (B(1),II,SCR1,IBLK(1))
      IF (NOB2DD .LT. 0) GO TO 60
      B(1)  =-W*A(2)
      B(2)  = W*A(1)
      CALL BLDPKI (B(1),II,SCR2,IBLK(21))
      GO TO 60
C
C     END OF COLUMN
C
   80 CALL BLDPKN (SCR1,IBLK(1),MCB1(1))
      IF (NOB2DD .LT. 0) GO TO 90
      CALL BLDPKN (SCR2,IBLK(21),MCB2(1))
   90 CONTINUE
  100 CONTINUE
  110 CALL CLOSE  (SCR1,1)
      CALL CLOSE  (VUD,1)
      CALL WRTTRL (MCB1(1))
      IF (NOB2DD .LT. 0) GO TO 120
      CALL CLOSE  (SCR2,1)
      CALL WRTTRL (MCB2(1))
C
C     MULTIPLY OUT
C
  120 IF (NOB2DD.LT.0 .AND. NOK2DD.LT.0) SR3 = PAD
      CALL SSG2B (MDD,SCR1,PD,SR3,0,1,0,SCR4)
      IF (NOK2DD .LT. 0) GO TO 130
C
C     MULTIPLY  IN K2DD
C
      IF (NOB2DD .LT. 0) SR1 = PAD
      CALL SSG2B (K2DD,SCR5,SR3,SR1,0,1,0,SCR4)
      GO TO 140
C
C     NO  K2DD
C
  130 SR1 = SR3
C
C     MULTIPLY IN B2DD
C
  140 IF (NOB2DD .LT. 0) GO TO 150
      CALL SSG2B (B2DD,SCR2,SR1,PAD,0,1,0,SCR4)
  150 RETURN
C
C     TRANSIENT ANALYSIS
C
  160 NLOAD = MCB(2)
C
C     PUT DISPLACEMENT ON SCR5,VELOCITY ON SCR2,ACCELERATION SCR1
C
      IT = 1
C
C     PUT HEADERS ON FILES
C
      GO TO 30
C
C     PUT DISPLACEMENT ON SCR5
C
  170 FILE = SCR5
      NZ   = NZ - SYSBUF
      CALL GOPEN (SCR5,CORE(NZ),1)
      MCB(1) = SCR5
      MCB(2) = 0
      MCB(4) = 2
      MCB(5) = 1
      IFILE(1) = SCR5
      IFILE(2) = SCR2
      IFILE(3) = SCR1
      MCB(6) = 0
      DO 270 KK = 1,NLOAD
      CALL BLDPK (1,1,SCR5,IBLK,1)
      IF (NOB2DD .LT. 0) GO TO 190
      CALL BLDPK (1,1,SCR2,IBLK(21),1)
  190 CALL BLDPK (1,1,SCR1,IBLK(41),1)
      DO 260 I = 1,3
      L =  I*7 - 6
      K = 20*I - 19
      FILE = IFILE(I)
C
C     FWDREC OVER  UNNEEDED STUFF
C
      IF (I.EQ.2 .AND. NOB2DD.LT.0) GO TO 250
      CALL INTPK (*240,VUD,0,1,0)
  220 IF (IEOL) 240,230,240
  230 CALL ZNTPKI
      CALL BLDPKI (A,II,FILE,IBLK(K))
      GO TO 220
C
C     END COLUMN
C
  240 CALL BLDPKN (FILE,IBLK(K),IMCB(L))
      GO TO 260
  250 CALL SKPREC (VUD,1)
  260 CONTINUE
  270 CONTINUE
C
C     FINISH OFF
C
      CALL CLOSE  (SCR5,1)
      CALL WRTTRL (MCB)
      GO TO 110
C
C     ERROR MESAGES
C
  280 IP1 = -1
  290 CALL MESAGE (IP1,FILE,NAME)
  300 IP1 = -2
      GO TO 290
  310 IP1 = -8
      GO TO 290
      END

      SUBROUTINE IFP4E (ID)
C
C     IFP4E, CALLED BY IFP4, CHECKS TO SEE THAT ID IS WITHIN PERMISSABLE
C     RANGE OF FROM 1 TO 499999.
C
      LOGICAL         NOGO
      INTEGER         OUTPUT
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /SYSTEM/ SYSBUF,OUTPUT
C
      IF (ID .LT. 1) GO TO 100
      IF (ID .LE. 499999) RETURN
C
C     ERROR
C
  100 NOGO = .TRUE.
      WRITE  (OUTPUT,110) UFM,ID
  110 FORMAT (A23,' 4041, ID =',I12,' IS OUT OF PERMISSIBLE RANGE OF 1',
     1       ' TO 499999.')
      RETURN
      END

      SUBROUTINE TA1
C
C     TA1 CONTROLS THE EXECUTION OF THE TABLE ASSEMBLER.
C
C     DMAP CALL IS
C
C     TA1   ECT,EPT,BGPDT,SIL,GPTT,CSTM,MPT,EQEXIN/EST,GEI,GPECT,
C           ECPT,GPCT,MPTX,PCOMPS,EPTX/V,N,LUSET/V,N,NOSIMP=-1/
C           V,N,NOSUP=-1,1,2/V,N,NOGENEL=-1/V,N,GENEL/V,N,COMPS=1 $
C
C
C     EITHER THE GPECT OR BOTH GPECT AND ECPT, GPCT MAY BE GENERATED.
C     IF NOSUP .EQ. 1, GENERATE GPECT. IF NOSUP .EQ. 2 , GENERATE ALL.
C     IF NOSUP .LT. 0, GENERATE NONE.
C
C   1. TA1 EXECUTES TA1A WHICH BUILDS THE ELEMENT SUMMARY TABLE (EST)
C   2. TA1 EXECUTES TA1B WHICH BUILDS THE ELEMENT CONNECTION AND
C      PROPERTIES TABLE (ECPT) AND THE GRID POINT CONNECTION TABLE(GPCT)
C   3. IF GENERAL ELEMENTS ARE PRESENT, TA1 EXECUTES TA1C WHICH BUILDS
C      THE GENERAL ELEMENT INPUT (GEI).
C   4. IF LAMINATED COMPOSITE ELEMENTS ARE PRESENT, TA1 EXECUTES
C      TA1CPS/D WHICH -
C      (1) CREATES PCOMPS DATA, WHICH INCLUDES THE ECHOING OF
C          INTRINSIC LAYER PROPERTIES, AND
C      (2) CALCULATES OVERALL MATERIAL PROPERTIES.
C
C
      EXTERNAL        ANDF
      INTEGER         GENL  ,ECT   ,EPT   ,BGPDT ,SIL   ,GPTT  ,
     1                ECPT  ,GPCT  ,SCR1  ,SCR2  ,TWO   ,EST   ,
     2                ANDF  ,SCR3  ,SCR4  ,GEI   ,CSTM  ,GPECT ,
     3                PCOMPS,EPTX  ,COMPS ,EQEXIN,GENEL(2)
      DIMENSION       MCB(7)
      COMMON /BLANK / LUSET ,NOSIMP,NOSUP ,NOGENL,GENL  ,COMPS
      COMMON /SYSTEM/ ISYSTM(54)   ,IPREC
      COMMON /TA1COM/ NSIL  ,ECT   ,EPT   ,BGPDT ,SIL   ,GPTT  ,CSTM  ,
     1                MPT   ,EST   ,GEI   ,GPECT ,ECPT  ,GPCT  ,MPTX  ,
     2                PCOMPS,EPTX  ,SCR1  ,SCR2  ,SCR3  ,SCR4  ,EQEXIN
      COMMON /TWO   / TWO(32)
      DATA    GENEL / 4301 , 43 /
C
C     INITIALIZE
C
      CALL DELSET
      ECT    = 101
      EPT    = 102
      BGPDT  = 103
      SIL    = 104
      GPTT   = 105
      CSTM   = 106
      MPT    = 107
      EQEXIN = 108
C
      EST    = 201
      GEI    = 202
      GPECT  = 203
      ECPT   = 204
      GPCT   = 205
      MPTX   = 206
      PCOMPS = 207
      EPTX   = 208
C
      SCR1   = 301
      SCR2   = 302
      SCR3   = 303
      SCR4   = 304
C
C     TEST FOR PRESENCE OF GENERAL ELEMENTS
C
      NOGENL = -1
      MCB(1) = ECT
      CALL RDTRL (MCB)
      IF (MCB(1) .LT. 0) GO TO 100
      J = (GENEL(2)-1)/16
      K =  GENEL(2)-16*J
      IF (ANDF(MCB(J+2),TWO(K+16)) .NE. 0) NOGENL = 1
C
C     EXECUTE TA1A FOR ALL PROBLEMS
C
  100 CALL TA1A
C
C     EXECUTE TA1CPD/S TO BUILD PCOMPS DATA
C
      IF (NOSUP .EQ. 0) GO TO 300
      IF (COMPS .NE.-1) GO TO 200
      IF (IPREC .EQ. 1) CALL TA1CPS
      IF (IPREC .EQ. 2) CALL TA1CPD
  200 IF (NOSUP .EQ. 1) GO TO 400
C
C     EXECUTE TA1B IF SIMPLE ELEMENTS ARE PRESENT
C
  300 IF (NOSIMP.GT. 0) CALL TA1B
      IF (NOSUP .EQ. 0) GO TO 500
C
C     CALL TA1H TO GENERATE GPECT
C
  400 IF (NOSIMP .GT. 0) CALL TA1H
C
C     EXECUTE TA1C IF GENERAL ELEMENTS ARE PRESENT
C
  500 IF (NOGENL .GT. 0) CALL TA1C
      GENL = -NOGENL
C
      RETURN
      END

      SUBROUTINE FORM12 (U0, UDOT0, U1, P0, P1, DELTT, IBUF)
C*******
C     FORM12 GENERATES THE STARTING VECTORS FOR THE INTEGRATION MODULE
C
C     THIS ROUTINE IS SUITABLE FOR DOUBLE PRECISION OPERATION
C*******
      DOUBLE PRECISION   U0(1)     ,UDOT0(1) ,U1(1)    ,P0(1)    ,
     1                   P1(1)
C
      DIMENSION          IBUF(1)
C
      COMMON /BLANK/  DUMMY(5)  ,ISTART
      COMMON   /TRDXX /  IFILK(7)  ,IFILM(7) ,IFILB(7)
C
      NROW = IFILK(2)
C*******
C     FORM U(-1)
C*******
      DO 10 I = 1,NROW
      P1(I) = 0.0D0
   10 U1(I) = U0(I)-DELTT*UDOT0(I)
      IF (ISTART.GE.0) GO TO 30
      DO 15 I = 1, NROW
      P0(I) = 0.0D0
   15 CONTINUE
C*******
C     FORM P0
C*******
      CALL MATVC2(U0(1),P0(1),IFILK(1),IBUF)
      CALL MATVC2(UDOT0(1),P0(1),IFILB(1),IBUF)
C*******
C     FORM P(-1)
C*******
      CALL MATVC2(UDOT0(1),P1(1),IFILK(1),IBUF)
      DO 20 I = 1,NROW
   20 P1(I) = P0(I)-DELTT*P1(I)
      RETURN
C
C     ALTERNATE STARTING METHOD
C
   30 CALL MATVC2 (U0(1), P1(1), IFILK(1), IBUF)
      CALL MATVC2 (UDOT0(1), P1(1), IFILB(1), IBUF)
      DO 40 I = 1, NROW
      P0(I) = 0.5D0*(P0(I) + P1(I))
      UDOT0(I) = - UDOT0(I)*DELTT
   40 CONTINUE
C
C     ADD UDOT CONTRIBUTION
C
      CALL MATVC2 (UDOT0(1), P1(1), IFILK(1), IBUF)
C
C     RESTORE UDOT
C
      DO 50 I = 1, NROW
      UDOT0(I) = - UDOT0(I)/DELTT
   50 CONTINUE
      RETURN
      END

      SUBROUTINE ALG12
C
      REAL LOSS,LAMI,LAMIP1,LAMIM1
C
      DIMENSION PSTAT(32),XX(32)
C
      COMMON /UD300C/ NSTNS,NSTRMS,NMAX,NFORCE,NBL,NCASE,NSPLIT,NREAD,
     1NPUNCH,NPAGE,NSET1,NSET2,ISTAG,ICASE,IFAILO,IPASS,I,IVFAIL,IFFAIL,
     2NMIX,NTRANS,NPLOT,ILOSS,LNCT,ITUB,IMID,IFAIL,ITER,LOG1,LOG2,LOG3,
     3LOG4,LOG5,LOG6,IPRINT,NMANY,NSTPLT,NEQN,NSPEC(30),NWORK(30),
     4NLOSS(30),NDATA(30),NTERP(30),NMACH(30),NL1(30),NL2(30),NDIMEN(30)
     5,IS1(30),IS2(30),IS3(30),NEVAL(30),NDIFF(4),NDEL(30),NLITER(30),
     6NM(2),NRAD(2),NCURVE(30),NWHICH(30),NOUT1(30),NOUT2(30),NOUT3(30),
     7NBLADE(30),DM(11,5,2),WFRAC(11,5,2),R(21,30),XL(21,30),X(21,30),
     8H(21,30),S(21,30),VM(21,30),VW(21,30),TBETA(21,30),DIFF(15,4),
     9FDHUB(15,4),FDMID(15,4),FDTIP(15,4),TERAD(5,2),DATAC(100),
     1DATA1(100),DATA2(100),DATA3(100),DATA4(100),DATA5(100),DATA6(100),
     2DATA7(100),DATA8(100),DATA9(100),FLOW(10),SPEED(30),SPDFAC(10),
     3BBLOCK(30),BDIST(30),WBLOCK(30),WWBL(30),XSTN(150),RSTN(150),
     4DELF(30),DELC(100),DELTA(100),TITLE(18),DRDM2(30),RIM1(30),
     5XIM1(30),WORK(21),LOSS(21),TANEPS(21),XI(21),VV(21),DELW(21),
     6LAMI(21),LAMIM1(21),LAMIP1(21),PHI(21),CR(21),GAMA(21),SPPG(21),
     7CPPG(21),HKEEP(21),SKEEP(21),VWKEEP(21),DELH(30),DELT(30),VISK,
     8SHAPE,SCLFAC,EJ,G,TOLNCE,XSCALE,PSCALE,PLOW,RLOW,XMMAX,RCONST,
     9FM2,HMIN,C1,PI,CONTR,CONMX
C
      XMAX=X(1,NSTNS)
      XMIN=X(1,1)
      DO 100 J=2,NSTRMS
      IF(X(J,1).LT.XMIN)XMIN=X(J,1)
      IF(X(J,NSTNS).GT.XMAX)XMAX=X(J,NSTNS)
100   CONTINUE
      IF(XMIN.LT.0.0)XMIN=XMIN-1.0
      L1=XMIN-1.0
      XMIN=FLOAT(L1)
      L1=XMAX+1.0
      XMAX=FLOAT(L1)
      DELX=(XMAX-XMIN)/XSCALE+0.01
      XX(NSTNS+1)=XMIN
      XX(NSTNS+2)=XSCALE
      IF(NPLOT.EQ.2)GO TO 134
      PSTAT(NSTNS+1)=PLOW
      PSTAT(NSTNS+2)=PSCALE
      J=1
      K=1
110   DO 120 I=1,NSTNS
      HS=H(J,I)-(VW(J,I)**2+VM(J,I)**2)/(2.0*G*EJ)
      IF(HS.LT.HMIN)HS=HMIN
      PSTAT(I)=ALG4(HS,S(J,I))/SCLFAC**2
120   XX(I)=X(J,I)
      IF(J.EQ.NSTRMS)GO TO 130
      K=K+1
      IF(J.EQ.IMID)J=NSTRMS
      IF(J.EQ.1)J=IMID
      GO TO 110
130   CONTINUE
      IF(NPLOT.EQ.1)GO TO 180
134   CONTINUE
      PSTAT(NSTNS+1)=RLOW
      PSTAT(NSTNS+2)=XSCALE
      DO 150 J=1,NSTRMS
      DO 140 I=1,NSTNS
      XX(I)=X(J,I)
140   PSTAT(I)=R(J,I)
150   CONTINUE
      PSTAT(NSTRMS+1)=RLOW
      PSTAT(NSTRMS+2)=XSCALE
      XX(NSTRMS+1)=XMIN
      XX(NSTRMS+2)=XSCALE
      DO 170 I=1,NSTNS
      DO 160 J=1,NSTRMS
      PSTAT(J)=R(J,I)
160   XX(J)=X(J,I)
170   CONTINUE
180   RETURN
      END

      SUBROUTINE QLOADL (IOPT)
C
C     THIS ROUTINE CALCULATES THERMAL LOADS FROM QBDY1, QBDY2, OR
C     QVECT DATA. THE INPUT DATA, READ FROM FILE SLT, IS -
C
C     ENTRY       QBDY1         QBDY2          QVECT
C     -----       -----         -----          -----
C       1          TYPE         EL.ID.          SIL1
C       2         EL.ID.         TYPE           SIL2
C       3          SIL1          SIL1           SIL3
C       4          SIL2          SIL2           SIL4
C       5          SIL3          SIL3          EL.ID.
C       6          SIL4          SIL4           TYPE
C      7-10      C1,C2,C3,C4    -SAME          -SAME
C     11-13       E VECTOR       NONE           NONE
C     14-16      V1 VECTOR         *             *
C     17-19      V2 VECTOR         *             *
C
      LOGICAL         NOGO,TRANST
      INTEGER         SLT,OLD,BG,SUBR(2),IGRIDS(6),TYPE,SILS(4),IE(3),
     1                MINUS(2)
      REAL            E(3),COEF(4),V1(3),V2(3),CARD(19)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /LOADX / LC,SLT,BG,OLD,NXN(12),IFM,NYN(2),ILID
      COMMON /ZZZZZZ/ CORE(1)
      COMMON /SYSTEM/ SYSBUF,IOUT
      COMMON /QVECT / ITRAN,IQVECT
      EQUIVALENCE     (TYPE,CARD(1)),(ID,CARD(2)),(SILS(1),CARD(3)),
     1                (COEF(1),CARD(7)),(E(1),IE(1),CARD(11)),
     2                (V1(1),CARD(14)),(V2(1),CARD(17))
      DATA    IGRIDS/ 1,2,2,3,4,2   /
      DATA    SUBR  / 4HQLOA,4HDL   /
      DATA    ITRAN1, IOLD,MINUS    / 4HTRAN,0,-1,-1 /
C
      TRANST = .FALSE.
      IF (ITRAN .EQ. ITRAN1) TRANST = .TRUE.
      NWORDS = 10
      IF (IOPT .EQ. 3) NWORDS = 19
C
      CALL READ (*100,*110,SLT,CARD(1),NWORDS,0,FLAG)
C
C     REARRANGE CARD ARRAY FOR UNIFORMITY.
C
      GO TO (20,10,40), IOPT
   10 DOT = CARD(1)
      CARD(1) = CARD(2)
      CARD(2) = DOT
   20 N = IGRIDS(TYPE)
C
C     QBDY1 OR QBDY2
C
      DO 30 I = 1,N
      ISIL = SILS(I)
      CORE(ISIL) = CORE(ISIL) + COEF(I)
   30 CONTINUE
      RETURN
C
C     QVECT LOADS
C
   40 DOT     = CARD(5)
      DOT2    = CARD(6)
      CARD(6) = CARD(4)
      CARD(5) = CARD(3)
      CARD(4) = CARD(2)
      CARD(3) = CARD(1)
      CARD(2) = DOT
      CARD(1) = DOT2
      N       = IGRIDS(TYPE)
      DOT     = 0.0
      INT     = 0
      IF (TYPE .EQ. 6) GO TO 70
      DO 50 I = 1,3
      IF (NUMTYP(IE(I)) .EQ. 1) GO TO 51
      DOT = DOT + E(I)*V1(I)
      GO TO 50
   51 INT = INT + 1
   50 CONTINUE
      IF (INT .GT.   0) GO TO 90
      IF (DOT .GE. 0.0) RETURN
      DO 60 I = 1,N
      ISIL = SILS(I)
   60 CORE(ISIL) = CORE(ISIL) - DOT*COEF(I)
      RETURN
C
C     QVECT ON ELCYL ELEMENT
C
   70 DOT2 = 0.0
      DO 80 I = 1,3
      IF (NUMTYP(IE(I)) .EQ. 1) GO TO 81
      DOT  = DOT  + E(I)*V1(I)
      DOT2 = DOT2 + E(I)*V2(I)
      GO TO 80
   81 INT = INT + 1
   80 CONTINUE
      IF (INT .GT. 0) GO TO 90
      COEF(1) = COEF(1)*SQRT(DOT**2 + DOT2**2)
      COEF(2) = COEF(1)
      ISIL = SILS(1)
      CORE(ISIL) = CORE(ISIL) + COEF(1)
      ISIL = SILS(2)
      CORE(ISIL) = CORE(ISIL) + COEF(2)
      RETURN
C
C     GOES HERE IF INTEGERS ARE FOUND IN E VECTOR
C
   90 IF (.NOT. TRANST) GO TO 120
C
C     BUILD QVECT RECORDS FOR TRANSIENT
C
      IF (ILID .EQ. IOLD) GO TO 91
      IF (IOLD .EQ.    0) GO TO 92
C
C     TERMINATE OLD RECORD
C
      CALL WRITE (IQVECT,MINUS,2,0)
   92 IOLD = ILID
      CALL WRITE (IQVECT,ILID,1,0)
C
C     DUMP DATA ON IQVECT
C
   91 CALL WRITE (IQVECT,N,1,0)
      DO 93 I = 1,N
      CALL WRITE (IQVECT,SILS(I),1,0)
      CALL WRITE (IQVECT,COEF(I),1,0)
   93 CONTINUE
      CALL WRITE (IQVECT,IE,3,0)
      CALL WRITE (IQVECT,V1,6,0)
      RETURN
C
  100 CALL MESAGE (-2,SLT,SUBR)
  110 CALL MESAGE (-3,SLT,SUBR)
  120 NOGO = .TRUE.
      WRITE  (IOUT,130) UFM,ID
  130 FORMAT (A23,' 3080, ERROR IN QVECT DATA, INTEGER VALUES SPECIFIED'
     1,      ' FOR THERMAL FLUX VECTOR COMPONENTS', /30X,
     2       'IN A NON-TRANSIENT ANALYSIS.', /30X,'ELEMENT ID = ',I9)
      CALL MESAGE (-61,0,SUBR)
      RETURN
      END

      FUNCTION GO ( R , ETAR , ETAL , EKM )
C
      DIMENSION  AS(2) , C(2) , S(2) , S0(2)
      DIMENSION BSL(23)
C
      DBSLJ = 1.0E-10
      S(1)  =  ETAR
      S(2)  =  ETAL
      DO   400   I = 1 , 2
      IF ( ABS ( S(I) ) .GE. R )   GO TO  200
      S(I)  =  S(I) / R
      C(I)  =  SQRT ( 1.0 - S(I) ** 2 )
      AS(I)  =  2.0 * ATAN ( S(I) / ( 1.0 + C(I) ) )
      S(I)  =  2.0 * S(I) * C(I)
      C(I)  =  2.0 * C(I) ** 2 - 1.0
      GO TO  300
C
 200  AS(I)  =  SIGN ( 1.570796   , S(I) )
      S(I)  =  0.0
C
 300  S0(I)  =  0.0
 400  CONTINUE
C
      GO  =  AS(1) - AS(2)
      IF ( ABS ( GO ) .LE. DBSLJ )   GO TO  700
C
      ARG  =  EKM * R
      IF ( ARG .EQ. 0.0 )   RETURN
      CALL MBBSLJ(ARG,N,BSL)
C
      GO  =  BSL(1) * GO
      F  =  1.0
      FI  =  1.0
      DO   600   J = 2 , N
      GO  =  BSL(J) * ( S(1) - S(2) ) / FI - GO
C
      DO   500   I = 1 , 2
      S4  =  2.0 * S(I) * C(I) - S0(I)
      S0(I)  =  S(I)
      S(I)  =  S4
 500  CONTINUE
C
      F  =  -F
      FI  =  FI + 1.0
 600  CONTINUE
C
      IF ( F .LT. 0.0 )   GO  =  -GO
      RETURN
C
 700  GO  =  0.0
      RETURN
      END

      SUBROUTINE SMA3B(IFLAG,IZK)
C
C     THIS ROUTINE PROCESSES A GENERAL ELEMENT FROM GEI
C
C     IT  PRODUCES A ZE MATRIX OR A ZINVS MATRIX AND A SE MATRIX
C
C     ASSUMES GEI SITS AT BEGINNING OF UI SET AND IS OPEN TO READ
C
      DOUBLE PRECISION D11
      INTEGER SYSBUF,ZE,SE,GEI,SE1,ZE1,ZINVS
      DIMENSION ZE(7),SE(7)
C
      COMMON  /ZZZZZZ/ Z(1)
      COMMON /SYSTEM/ SYSBUF
      COMMON /ZBLPKX/D11(2),IDX
      COMMON/GENELY/GEI,DUM1(2),ZE1,SE1,ID1,ZINVS,DUM2(22),ID(7),
     1 DUM4(35),M,N
C
C     COMPUTE LENGTH OF VARIABLE CORE
C
      NZ  = KORSZ(Z)-SYSBUF
      IFLAG=-1
      NZ =NZ -SYSBUF
C
C SKIP M+N WORDS ON GEI FILE
C
      CALL FREAD(GEI,Z,M+N,0)
C
C READ FLAG VARIABLE FOR Z OR K MATRIX
C
      CALL FREAD(GEI,IZK,1,0)
C
C IF Z MATRIX INPUT,WRITE ON ZE1 FILE
C IF K MATRIX INPUT,WRITE ON ZINVS FILE
C
      CALL MAKMCB(ZE,ZE1,M,6,2)
      IF (IZK.EQ.2) ZE(1)=ZINVS
      CALL MAKMCB(SE,SE1,N,2,2)
C
C READY FOR PACKING MATRICES
C
C
C OPEN ZE MATRIX
C
      CALL GOPEN(ZE,Z(NZ+1),1)
C
C     LOOP ON M COLUMNS OF ZE
C
      DO 20 I=1,M
      CALL BLDPK(2,2,ZE(1),0,0)
      DO 10 J=1,M
      CALL FREAD(GEI,Z,1,0)
      D11(1) = Z(1)
      IDX = J
   10 CALL ZBLPKI
      CALL BLDPKN(ZE(1),0,ZE)
   20 CONTINUE
      CALL CLOSE( ZE(1),1)
      CALL WRTTRL( ZE )
      IF(N .EQ. 0) GO TO 50
      IFLAG =1
C
C     NOW BUILD SE TRANSPOSE
C
C
C     OPEN AND WRITE HEADER
C
      CALL GOPEN(SE,Z(NZ+1),1)
C
C     LOOP ON N COLUMNS OF SE
C     LOOP ON M COLUMNS OF SE  TRANSPOSE
C
      DO 40 I=1,M
      CALL BLDPK(2,2,SE(1),0,0)
      DO 30 J=1,N
      CALL FREAD(GEI,Z,1,0)
      D11(1) = -Z(1)
      IDX = J
   30 CALL ZBLPKI
      CALL BLDPKN(SE(1),0,SE)
   40 CONTINUE
      CALL CLOSE(SE(1),1)
      CALL WRTTRL(SE)
C
C     BACKSPACE GEI SO UD AND UI AVAILABLE LATER
C
   50 CALL BCKREC(GEI)
      CALL CLOSE(GEI,2)
      ID(1) = ID1
      ID(2)=M
      ID(3)=M
      ID(4)=8
      ID(5)=2
      ID(6)=1
      ID(7)=0
      RETURN
      END

      SUBROUTINE SSG2
C
C     MULTI  = 0  IMPLIES NO MULTI-POINT CONSTRAINTS PN = PG
C
C     SINGLE = 0  IMPLIES NO SINGLE POINT CONSTRAINTS PF = PN
C
C     OMIT   = 0  IMPLIES NO OMITTED POINTS PA = PF
C
C     REACT  = 0  IMPLIES NO FREE BODY PROBLEM PL = PA
C
C
      EXTERNAL        ANDF
      INTEGER         USET,GM,KFS,GO,PNBAR,PG,PM,PO,PA,SINGLE,OMIT,
     1                PVECT,PS,D,PL,PR,QR,REACT,UM,UN,UG,US,UF,UO,UA,
     2                UL,UR,PF,PABAR,PN,PFBAR,ANDF,YS,IA(7),USET1,SR4
      DIMENSION       CORE(1)
      COMMON /SYSTEM/ DUM54(54),IPREC
      COMMON /PATX  / LC,N,NO,N4,USET1,IBC
      COMMON /BLANK / SINGLE
      COMMON /BITPOS/ UM,UO,UR,USG,USB,UL,UA,UF,US,UN,UG
      COMMON /TWO   / TWO1(32)
      COMMON /ZZZZZZ/ CORE
C
      DATA    USET  , GM    ,KFS   ,GO    ,PNBAR ,PM    ,PO    ,PN    /
     1        101   , 102   ,104   ,105   ,302   ,303   ,202   ,204   /
      DATA    PFBAR , PF    ,PABAR ,PA    ,PS    ,D     ,PL    ,PR    /
     1        302   , 204   ,302   ,204   ,203   ,106   ,204   ,302   /
      DATA    QR    , PVECT ,YS    ,PG    ,SR4   /
     1        201   , 301   ,103   ,107   ,304   /
C
C
      PNBAR = 302
      PN    = 204
      PR    = 302
      PF    = 204
      PA    = 204
      LC    = KORSZ(CORE)
C
C     DECIDE IF MULTI,SINGLE,OMIT,REACT ARE 1 OR ZERO
C
      IA(1) = USET
      USET1 = USET
      CALL RDTRL (IA)
      MULTI = ANDF(IA(5),TWO1(UM))
      SINGLE= ANDF(IA(5),TWO1(US))
      OMIT  = ANDF(IA(5),TWO1(UO))
      REACT = ANDF(IA(5),TWO1(UR))
      IF (REACT .LE. 0) GO TO 10
      IF (.NOT.(MULTI.GT.0 .AND. SINGLE.EQ.0 .AND. OMIT.EQ.0)) GO TO 5
      PNBAR = 204
      PN    = 302
      PR    = 303
      GO TO 20
    5 CONTINUE
      PF    = 201
      PA    = 303
   10 IF (MULTI) 20,30,20
C
   20 CALL CALCV (PVECT,UG,UN,UM,CORE(1))
      CALL SSG2A (PG,PNBAR,PM,PVECT)
      CALL SSG2B (GM,PM,PNBAR,PN,1,IPREC,1,SR4)
      GO TO 40
C
   30 PN = PG
   40 IF (SINGLE) 50,70,50
   50 CALL CALCV (PVECT,UN,UF,US,CORE(1))
      CALL SSG2A (PN,PFBAR,PS,PVECT)
      CALL SSG2B (KFS,YS,PFBAR,PF,0,IPREC,0,SR4)
      GO TO 80
   70 PF = PN
   80 IF (OMIT) 90,100,90
C
   90 CALL CALCV (PVECT,UF,UA,UO,CORE(1))
      CALL SSG2A (PF,PABAR,PO,PVECT)
      CALL SSG2B (GO,PO,PABAR,PA,1,IPREC,1,SR4)
      GO TO 110
  100 PA = PF
  110 IF (REACT) 120,130,120
C
  120 CALL CALCV (PVECT,UA,UL,UR,CORE(1))
      CALL SSG2A (PA,PL,PR,PVECT)
      CALL SSG2B (D,PL,PR,QR,1,IPREC,-1,SR4)
  130 RETURN
      END

      SUBROUTINE FRLG
C
C     FREQUENCE RESPONSE LOAD GENERATOR
C
C     INPUTS  - CASEXX,USETD,DLT,FRL,GMD,GOD,DIT,PHIDH
C
C     OUTPUTS - PPF,PSF,PDF,FOL,PHF
C
C     4 SCRATHCES
C
C
      EXTERNAL        ANDF
      INTEGER         CASEXX,USETD,DLT,FRL,GMD,GOD,DIT,PHIDH,PPF,PSF,
     1                PDF,FOL,PHF,SCR1,SCR2,SCR3,SCR4,MCB(7),ANDF,
     2                SINGLE,OMIT,IFREQ(2),ITRAN(2)
      COMMON /TWO   / ITWO(32)
      COMMON /BLANK / MODAL(2),NOTRD,IAPP(2)
      COMMON /BITPOS/ IUM,IUO,SKP(6),IUS
      DATA    CASEXX, USETD,DLT,FRL,GMD,GOD,DIT,PHIDH      /
     1        101   , 102  ,103,104,105,106,107,108        /
      DATA    PPF   , PSF,PDF,FOL,PHF, SCR1,SCR2,SCR3,SCR4 /
     1        201   , 202,203,204,205, 301 ,302 ,303 ,304  /
      DATA    MODA  / 4HMODA  /
      DATA    IFREQ , ITRAN   /4HFREQ,1H ,4HTRAN,1H /
C
C     DETERMINE USET DATA
C
      MCB(1) = USETD
      CALL RDTRL (MCB)
      LUSETD = MCB(2)
      MULTI  =-1
      IF (ANDF(MCB(5),ITWO(IUM)) .NE. 0) MULTI =  1
      SINGLE =-1
      IF (ANDF(MCB(5),ITWO(IUS)) .NE. 0) SINGLE =  1
      OMIT =-1
      IF (ANDF(MCB(5),ITWO(IUO)) .NE. 0) OMIT =  1
C
      IAPP(1) = IFREQ(1)
      IAPP(2) = IFREQ(2)
C
C     BUILD LOADS ON P SET
C
C     ORDER IS ALL FREQUENCIES FOR GIVEN LOAD TOGETHER
C
      CALL FRLGA (DLT,FRL,CASEXX,DIT,PPF,LUSETD,NFREQ,NLOAD,FRQSET,FOL,
     1            NOTRD)
      IF (NOTRD .EQ. -1) GO TO 10
      IAPP(1) = ITRAN(1)
      IAPP(2) = ITRAN(2)
  10  CONTINUE
C
C     REDUCE LOADS TO D OR H SET
C
      IF (MULTI.LT.0 .AND. SINGLE.LT.0 .AND. OMIT.LT.0 .AND.
     1    MODAL(1).NE.MODA) RETURN
      CALL FRLGB (PPF,USETD,GMD,GOD,MULTI,SINGLE,OMIT,MODAL,PHIDH,PDF,
     1            PSF,PHF,SCR1,SCR2,SCR3,SCR4)
      RETURN
      END

      SUBROUTINE AUTOCK (IADD)
C
C     THIS ROUTINE GENERATES A CHKPT OSCAR RECORD WHEN THE PRECHK
C     OPTION IS BEING USED, THE ADDRESS IADD IS THE STARTING
C     LOCATION OF THE OUTPUT FILE NAMES TO BE TESTED
C
      EXTERNAL        LSHIFT,RSHIFT
      INTEGER         PRENAM,PREFLG,OSPRC,OSBOT,OSPNT,LIST(100),XCHK(2),
     1                DMPCNT,RSHIFT,CASESS(2),CASECC(2),CASEI(2),
     2                OSCAR(1),OS(5)
      COMMON /AUTOCM/ PREFLG,NNAMES,PRENAM(100)
      COMMON /ZZZZZZ/ CORE(1)
      COMMON /XGPI4 / JUNK(2),ISEQN,DMPCNT
      COMMON /AUTOHD/ IHEAD
      EQUIVALENCE     (LOSCAR,CORE(1),OS(1)),(OSPRC,OS(2)),
     1                (OSBOT,OS(3)),(OSPNT,OS(4)),(OSCAR(1),OS(5))
      DATA    CASESS/ 4HCASE, 4HSS  /
      DATA    CASECC/ 4HCASE, 4HCC  /
      DATA    CASEI / 4HCASE, 4HI   /
      DATA    XCHK  / 4HXCHK, 4H    /
      DATA    IBLANK/ 0             /
C
      IHEAD = 0
      IOP   = 0
      IF (PREFLG) 200,200,5
    5 PREFLG = IABS(PREFLG)
      NOPF = OSCAR(IADD)
      NWD  = 3*NOPF
      IST  = IADD + 1
      IFIN = IST + NWD - 1
      NLIST= 0
      INCR = 3
C
      GO TO (1,2,3), PREFLG
C
C     CHECK OUTPUT FILE AGAINST LIST
C
    1 N2 = 2*NNAMES
      DO 10 I = IST,IFIN,INCR
      DO 11 J = 1,N2,2
      IF (PRENAM(J).EQ.CASESS(1) .AND.PRENAM(J+1).EQ.CASESS(2)) GO TO 11
      IF (PRENAM(J).EQ.CASECC(1) .AND.PRENAM(J+1).EQ.CASECC(2)) GO TO 11
      IF (PRENAM(J).EQ.CASEI( 1) .AND.PRENAM(J+1).EQ.CASEI( 2)) GO TO 11
      IF (PRENAM(J).NE.OSCAR(I) .OR. PRENAM(J+1).NE.OSCAR(I+1)) GO TO 11
      NLIST = NLIST + 1
      LIST(2*NLIST-1) = OSCAR(I  )
      LIST(2*NLIST  ) = OSCAR(I+1)
   11 CONTINUE
   10 CONTINUE
      IF (IOP   .EQ. 1) GO TO 300
      IF (NLIST .EQ. 0) RETURN
      GO TO 100
C
C     PREFLG=ALL OPTION, CHECKPOINT ALL OUTPUT DATA BLOCKS
C
    2 DO 20 I = IST,IFIN,INCR
      IF (OSCAR(I).EQ.IBLANK .AND. OSCAR(I+1).EQ.IBLANK) GO TO 20
      IF (OSCAR(I).EQ.CASESS(1) .AND. OSCAR(I+1).EQ.CASESS(2)) GO TO 20
      IF (OSCAR(I).EQ.CASECC(1) .AND. OSCAR(I+1).EQ.CASECC(2)) GO TO 20
      IF (OSCAR(I).EQ.CASEI( 1) .AND. OSCAR(I+1).EQ.CASEI( 2)) GO TO 20
      NLIST = NLIST + 1
      LIST(2*NLIST-1) = OSCAR(I  )
      LIST(2*NLIST  ) = OSCAR(I+1)
   20 CONTINUE
      IF (IOP .EQ. 1) GO TO 300
      GO TO 100
C
C     CHECK OUTPUT FILES EXCEPT THOSE IN LIST
C
    3 N2 = 2*NNAMES
      DO 30 I = IST,IFIN,INCR
      DO 31 J = 1,N2,2
      IF (PRENAM(J).EQ.OSCAR(I) .AND.PRENAM(J+1).EQ.OSCAR(I+1)) GO TO 30
   31 CONTINUE
      IF (OSCAR(I).EQ.IBLANK .AND. OSCAR(I+1).EQ.IBLANK ) GO TO 30
      IF (OSCAR(I).EQ.CASESS(1) .AND. OSCAR(I+1).EQ.CASESS(2)) GO TO 30
      IF (OSCAR(I).EQ.CASECC(1) .AND. OSCAR(I+1).EQ.CASECC(2)) GO TO 30
      IF (OSCAR(I).EQ.CASEI( 1) .AND. OSCAR(I+1).EQ.CASEI( 2)) GO TO 30
      NLIST = NLIST + 1
      LIST(2*NLIST-1) = OSCAR(I  )
      LIST(2*NLIST  ) = OSCAR(I+1)
   30 CONTINUE
      IF (IOP   .EQ. 1) GO TO 300
      IF (NLIST .EQ. 0) RETURN
      GO TO 100
C
C     PURGE OR EQUIV DATA BLOCK LIST MUST BE CHECKED
C
  200 NWD = OSCAR(OSPNT)
      MI  = RSHIFT(OSCAR(OSPNT+2),16)
      IB  = OSPNT + 6
      PREFLG = IABS(PREFLG)
      NDB = OSCAR(IB)
      IOP = 1
      IF (MI .EQ.  9) IST  = IB + 1
      IF (MI .EQ. 10) IST  = IB + 4
      IF (MI .EQ.  9) IFIN = IST + 2*NDB - 1
      IF (MI .EQ. 10) IFIN = IST + 2*NDB - 3
      NWD  = NWD - 6
      INCR = 2
      NLIST= 0
      GO TO (1,2,3), PREFLG
300   NWD = NWD - 2*NDB - 2
      IF (MI .EQ. 10) NWD = NWD - 1
      IF (NWD.LE.0 .AND. NLIST.NE.0) GO TO 100
      IF (NWD.LE.0 .AND. NLIST.EQ.0) GO TO 999
      NDB = OSCAR(IFIN+2)
      IF (MI .EQ.  9) IST = IFIN + 3
      IF (MI .EQ. 10) IST = IFIN + 6
      IFIN = IST + 2*NDB - 1
      IF (MI .EQ. 10) IFIN = IFIN - 2
      GO TO (1,2,3), PREFLG
C
C     UPDATE OSCAR PARAMETERS
C
  100 IHEAD = 1
      OSPRC = OSBOT
      OSBOT = OSCAR(OSBOT) + OSBOT
      OSPNT = OSBOT
      ISEQN = OSCAR(OSPRC+1) + 1
C
C     LOAD HEADER
C
      OSCAR(OSPNT  ) = 6
      OSCAR(OSPNT+1) = ISEQN
      OSCAR(OSPNT+2) = 4 + LSHIFT(3,16)
      OSCAR(OSPNT+3) = XCHK(1)
      OSCAR(OSPNT+4) = XCHK(2)
      OSCAR(OSPNT+5) = DMPCNT
      IF (IOP .EQ. 1) OSCAR(OSPNT+5) = OSCAR(OSPNT+5) - 1
      OSCAR(OSPNT+6) = NLIST
      CALL XLNKHD
      IF (NLIST .EQ. 0) GO TO 110
C
C     LOAD CHKPNT INFORMATION
C
      NLIST = 2*NLIST
      DO 101 I = 1,NLIST,2
      OSCAR(OSPNT+6+I) = LIST(I)
      OSCAR(OSPNT+7+I) = LIST(I+1)
  101 CONTINUE
  110 OSCAR(OSPNT) = OSCAR(OSPNT) + NLIST + 1
  999 IHEAD = 0
      RETURN
      END

      SUBROUTINE SCALED (TYPE,EMORD)
C
C     THIS ROUTINE PROCESSES CELAS, CDAMP, AND CMASS ELEMENTS.
C
C     TYPE  - DENOTES FORM OF EST DATA. IE CELAS1,CELAS2,ETC.
C     EMORD - DENOTES MATRIX  1 = CELAS = STIFFNESS MATRIX,
C                             2 = CMASS = MASS MATRIX,
C                             3 = CDAMP = DAMPING MATRIX
C
C     EST FOR ELAS ELEMENTS
C
C                     TYPE           TYPE           TYPE           TYPE
C             CELAS1         CELAS2         CELAS3         CELAS4
C             ------  ----   ------  ----   ------  ----   ------  ----
C     ECPT(1) IELID     I    IELID     I    IELID     I    IELID     I
C     ECPT(2) IGP1      I    K         R    IS1       I    K         R
C     ECPT(3) IGP2      I    IGP1      I    IS2       I    IS1       I
C     ECPT(4) IC1       I    IGP2      I    K         R    IS2       I
C     ECPT(5) IC2       I    IC1       I    GSUBE     R
C     ECPT(6) K         R    IC2       I    S         R
C     ECPT(7) GSUBE     R    GSUBE     R
C     ECPT(8) S         R    S         R
C
      LOGICAL          NOGO
      INTEGER          TYPE,EMORD,EID,ISIL(2),ICOMP(2),GPT(4),CPT(2),
     1                 KPT(4),GSPT(4),CODE,IEST(1),DICT(7),GSUBE,ELID,
     2                 ESTID
      DOUBLE PRECISION DZ(16)
      DIMENSION        Z(16)
      CHARACTER        UFM*23,UWM*25
      COMMON /XMSSG /  UFM,UWM
      COMMON /EMGEST/  EST(100)
      COMMON /EMGPRM/  DUMY(15),IMAT(3),IPREC,NOGO
      COMMON /SYSTEM/  KSYSTM(65)
      COMMON /EMGDIC/  DUM2(2),NLOCS,ELID,ESTID
      EQUIVALENCE      (KSYSTM(2),IOUTPT),(Z(1),DZ(1)),(IEST(1),EST(1))
      DATA    GPT   /  2, 3, 2, 3 /, CPT / 4, 5 /, KPT /6, 2, 4, 2 /
      DATA    GSPT  /  7, 7, 5, 0 /
C
C     TEST IF MATRIX TO BE PRODUCED IS REQUESTED
C
      IF (IMAT(EMORD) .EQ. 0) RETURN
C
C     MOVE EST DATA TO LOCAL ARRAYS.  LOCATIONS ARE GIVEN BY DATA //
C
      EID     = IEST(1)
      IP      = KPT(TYPE)
      Z(1)    = EST(IP)
      GSUBE   = 0
      ICOMP(1)= 0
      ICOMP(2)= 0
      DICT(2) = 1
      NGRIDS  = 2
      IP      = GPT(TYPE)
      ISIL(1) = IEST(IP)
      ISIL(2) = IEST(IP+1)
      IF (TYPE .GE. 3) GO TO 10
      IP = CPT(TYPE)
      IF (IEST(IP  ) .NE. 0) ICOMP(1) = IEST(IP  ) - 1
      IF (IEST(IP+1) .NE. 0) ICOMP(2) = IEST(IP+1) - 1
C
C     IF ONE SIL IS ZERO INSURE THAT IT IS THE SECOND.
C     IF BOTH SILS ARE NON-ZERO MAKE SURE HIGHER OF TWO IS SECOND.
C
   10 IF (ISIL(2) .EQ. 0) GO TO 5
      IF (ISIL(1) .EQ. 0) GO TO 4
      IF (ISIL(1) .LE. ISIL(2)) GO TO 5
C
C     SWITCH SILS AND COMPS
C
    4 IP      = ISIL(2)
      ISIL(2) = ISIL(1)
      ISIL(1) = IP
      IP      = ICOMP(2)
      ICOMP(2)= ICOMP(1)
      ICOMP(1)= IP
    5 IF (ISIL(2) .GT. 0) GO TO 20
C
C     IF THE SECOND SIL EQUALS ZERO THE ELEMENT IS GROUNDED
C     ONLY A SINGLE MATRIX TERM IS PRODUCED
C
      NGRIDS = 1
      DICT(2)= 1
      NTERMS = 1
      CODE   = 2**ICOMP(1)
      NCOL   = 1
      GO TO 80
C
   20 IF (ISIL(2) .NE. ISIL(1)) GO TO 30
C
C     IF THE ELEMENT CONNECTS TWO COMPONENTS OF THE SAME POINT IT
C     MUST HAVE SPECIAL TREATMENT
C
      IF (ICOMP(2) .EQ. ICOMP(1)) GO TO 110
C
C     IN THE GENERAL CASE, THE CONNECTED COMPONENTS MAY BE THE SAME
C     AND THE MATRIX IS A 2 BY 2.  IF THE COMPONENTS ARE DIFFERENT
C     THE MATRIX WILL BE A 4 BY 4 WITH ADDITIONAL ZEROS.
C
      GO TO 40
   30 IF (ICOMP(1) .EQ. ICOMP(2)) GO TO 70
C
   40 NTERMS= 16
      CODE  = 2**ICOMP(1) + 2**ICOMP(2)
      NCOL  = 4
      DO 50 I = 2,16
      Z( I) = 0.0
   50 CONTINUE
      IF (ICOMP(2) .LT. ICOMP(1)) GO TO 60
      Z( 4) =-Z(1)
      Z(13) =-Z(1)
      Z(16) = Z(1)
      IF (ISIL(1) .NE. ISIL(2)) GO TO 80
      Z( 2) = Z( 4)
      Z( 5) = Z(13)
      Z( 6) = Z(16)
      Z( 4) = 0.0
      Z(13) = 0.0
      Z(16) = 0.0
      GO TO 80
   60 Z( 6) = Z(1)
      Z( 7) =-Z(1)
      Z(10) =-Z(1)
      Z(11) = Z(1)
      Z( 1) = 0.0
      IF (ISIL(1) .NE. ISIL(2)) GO TO 80
      Z( 1) = Z(11)
      Z( 2) = Z(10)
      Z( 5) = Z( 7)
      Z( 7) = 0.0
      Z(10) = 0.0
      Z(11) = 0.0
      GO TO 80
C
C     COMPONENTS ARE THE SAME FOR BOTH POINTS
C
   70 NTERMS= 4
      NCOL  = 2
      CODE  = 2**ICOMP(1)
      Z(2)  =-Z(1)
      Z(3)  =-Z(1)
      Z(4)  = Z(1)
C
C     OUTPUT THE MATRIX HERE
C
   80 DICT(1) = ESTID
      DICT(3) = NCOL
      DICT(4) = CODE
      DICT(5) = 0
      IPG     = GSPT(TYPE)
C
C     STRUCTURAL DAMPING FOR  STIIFNESS MATRICES IS INSERTED IN DICT
C
      IF (EMORD.EQ.1 .AND. TYPE.LE.3) DICT(5) = IEST(IPG)
      IF (IPREC .EQ. 1) GO TO 100
      I = NTERMS
   90 DZ(I) = Z(I)
      I = I - 1
      IF (I .GT. 0) GO TO 90
  100 CALL EMGOUT (Z,DZ,NTERMS,1,DICT,EMORD,IPREC)
      RETURN
C
  110 WRITE  (IOUTPT,120) UWM,EID
  120 FORMAT (A25,' 3120, IMPROPER CONNECTION ON CELAS ELEMENT',I9)
      RETURN
      END

      SUBROUTINE WILVEC1 (D,O,VAL,VLOC,V,F,P,Q,R,VEC,NX,SVEC)
C
C     WILKINSON EIGENVECTOR SOLUTION FOR LARGE SYM MATRICES
C
      INTEGER          VLOC(1),ENTRY,V2,XENTRY,PV,VECTOR,VV,V1,MCB(7),
     1                 SYSBUF,MCB1(7),PHIA,SVEC(1),PATH
      REAL             D(1),O(1),VAL(1),V(1),P(1),F(1),Q(1),R(1),
     1                 VEC(NX,1),VALUE,W,X,Y,Z,DLMDAS,
     2                 RMULT,RRMULT,SFT,SFTINV,DEPS,VMULT,ZERO,ONE
      CHARACTER        UFM*23,UWM*25,UIM*29
      COMMON /XMSSG /  UFM,UWM,UIM
      COMMON /GIVN  /  TITLE(1),MO,T3,MR,MT1,T6,MV1,T8(3),ENTRY,T12(5),
     1                 RSTRT,V2,T19,XENTRY,T21(80),VCOM(30),T131(20)
      COMMON /PACKX /  IT1,IT2,II,JJ,INCR
      COMMON /UNPAKX/  IT3,III,JJJ,INCR1
      COMMON /SYSTEM/  SYSBUF,IOTPE,KSYS(52),IPREC
      COMMON /REIGKR/  IOPTN
      COMMON /MGIVXX/  DLMDAS
      EQUIVALENCE      (N     ,VCOM( 1)), (PV    ,VCOM( 5)),
     1                 (NV    ,VCOM( 7)), (NRIGID,VCOM(10)),
     2                 (PHIA  ,VCOM(12)), (NVER  ,VCOM(13)),
     3                 (MAXITR,VCOM(15)), (ITERM ,VCOM(16))
      DATA    MUL3  ,  MCB1,MCB / 0, 0,0,0,2,2,0,0, 7*0    /
      DATA    ZERO  ,  ONE      / 0.0D+0,  1.0D+0          /
      DATA    MGIV  /  4HMGIV   /
C
C     D        = DIAGONAL     TERMS OF THE TRIDIAGONAL MATRIX (N)
C     O        = OFF-DIAGONAL TERMS OF THE TRIDIAGONAL MATRIX (N)
C     VAL      = EIGENVALUES (NV)
C     VLOC     = ORIGINAL ORDERING OF THE EIGENVALUES (NV)
C     V,F,P,Q,R= N DIMENSIONAL ARRAYS
C     VEC      = THE REST OF OPEN CORE
C
C     MT       = TRANSFORMATION TAPE
C     N        = ORDER  OF PROBLEM
C     NV       = NUMBER OF EIGENVECTORS
C     RSTRT
C     V2       = NUMBER   OF EIGENVECTORS ALREADY CLLCULATED
C     VV       = POINTER  TO CURRENT VECTOR IN CORE VEC(1,VV)
C     NM2X     = MIDPOINT OF PROBLEM (SWITCH SINE SAVE TAPES)
C
C
C     INITALIZE VARIABLES
C
      DEPS  = 1.0-35
      SFT   = 1.0+20
      SFTINV= 1.0+0/SFT
      VMULT = 1.0-02
      NZ    = KORSZ(SVEC)
      IBUF1 = NZ - SYSBUF + 1
      IBUF2 = IBUF1 - SYSBUF
      IM    = 1
      CALL MAKMCB (MCB1,PHIA,N,2,IPREC)
      IM1   = 2
      NZ    = IBUF2 - 1
      PATH  = 0
      NV1   = (NZ-1)/(N+N)
      IM2   = 2
      NM1   = N - 1
      NM2   = N - 2
      NVER  = 0
      V2    = NRIGID
C
C     REARRANGE EIGENVALUES AND EXTRACTION ORDER FOR MULTIPLE ROOTS
C     TO GUARANTEE THAT THEY ARE IN SUBMATRIX ORDER FOR PURPOSES
C     OF TRIAL VECTOR AND ORTHOGONOLIZATION COMPUTATIONS
C
      RMULT = VMULT
      RRMULT= VMULT/100.0
      ICLOS = 0
      I = NRIGID + 1
   10 IF (ABS(VAL(I))+ABS(VAL(I+1)) .LT. RMULT) GO TO 20
      IF (VAL(I) .EQ. ZERO) GO TO 90
      IF (ABS(ONE-VAL(I)/VAL(I+1)) .GT. RRMULT) GO TO 80
   20 IF (ICLOS .NE. 0) GO TO 90
      ICLOS = I
      GO TO 90
   30 CONTINUE
      DO 50 I1 = ICLOS,I
      MIN   = VLOC(I1)
      VALUE = VAL(I1)
      K = I1
      DO 40 J = I1,I
      IF (VLOC(J) .GE. MIN) GO TO 40
      K    = J
      MIN  = VLOC(J)
      VALUE= VAL(J)
   40 CONTINUE
      VLOC(K) = VLOC(I1)
      VAL(K)  = VAL(I1)
      VLOC(I1)= MIN
      VAL(I1) = VALUE
   50 CONTINUE
      ICLOS = 0
   80 IF (ICLOS .NE. 0) GO TO 30
   90 I = I + 1
      IF (I     .LT. NV) GO TO 10
      IF (ICLOS .NE.  0) GO TO 30
C
C     START LOOP FOR CORE LOADS OF VECTORS
C
  100 CALL KLOCK (IST)
      V1   = V2 + 1
      V2   = V2 + NV1
      MUL2 = MUL3
      MULP2= 0
      MUL3 = 0
      IF (NV-V2) 101,110,102
  101 V2   = NV
      GO TO 110
C
C     SEARCH FOR MULTIPLICITIES OF EIGENVALUES V2 AND V2+1.
C
  102 VV = V2
  103 IF (ABS(VAL(V2))+ABS(VAL(V2+1)) .LT. RMULT) GO TO 1041
      IF (ABS(ONE-VAL(V2)/VAL(V2+1))   .GT. RMULT) GO TO 110
 1041 CONTINUE
      L1 = VLOC(V2  )
      L2 = VLOC(V2+1)
      N1 = MIN0(L1,L2)
      N2 = MAX0(L1,L2) - 1
      DO 104 K = N1,N2
      IF (O(K) .EQ. ZERO) GO TO 110
  104 CONTINUE
      V2 = V2 - 1
      IF (V2+6.GT.N1 .AND. V2.GT.V1) GO TO 103
      V2 = VV
      MUL3  = 1
C
C     FIND EIGENVECTORS V1 - V2.
C
  110 N1 = 0
      N2 = 0
      NV2= V2 - V1 + 1
      DO 175 VV = 1,NV2
      VECTOR = V1 + VV - 1
      VALUE  = VAL (VECTOR)
C
C     FOR MGIV METHOD, USE ORIGINAL LAMBDA COMPUTED BY QRITER
C     IN EIGENVECTOR COMPUTATIONS
C
      IF (IOPTN .EQ. MGIV) VALUE = 1.0/(VALUE + DLMDAS)
      LOC = VLOC(VECTOR)
      IF (LOC.GE.N1 .AND. LOC.LE.N2) GO TO 120
C
C     SEARCH FOR A DECOUPLED SUBMATRIX.
C
      MUL1 = 0
      IF (LOC .EQ. 1) GO TO 112
      DO 111 K = 2,LOC
      N1 = LOC - K + 2
      IF (O(N1-1) .EQ. ZERO) GO TO 113
  111 CONTINUE
  112 N1 = 1
  113 IF (LOC .EQ. N) GO TO 115
      DO 114 K = LOC,NM1
      IF (O(K) .EQ. ZERO) GO TO 116
  114 CONTINUE
  115 N2 = N
      GO TO 120
  116 N2 = K
  120 IF (MUL1.NE.0 .OR. MUL2.NE.0) GO TO 122
      DO 121 I = 1,N
      V(I) = ZERO
  121 CONTINUE
      IF (N1 .NE. N2) GO TO 122
      V(LOC) = ONE
      GO TO 152
  122 N2M1 = N2 - 1
      N2M2 = N2 - 2
C
C     SET UP SIMULTANEOUS EQUATIONS
C
      X = D(N1) - VALUE
      Y = O(N1)
      DO 131 K = N1,N2M1
      IF (X .EQ. ZERO) GO TO 125
      F(K) = -O(K)/X
      GO TO 126
  125 F(K) = -SFT*O(K)
  126 IF (ABS(X)-ABS(O(K))) 127,128,129
C
C     PIVOT.
C
  127 P(K) = O(K)
      Q(K) = D(K+1) - VALUE
      R(K) = O(K+1)
      Z    =-X/P(K)
      X    = Z*Q(K) + Y
      Y    = Z*R(K)
      GO TO 130
C
C     DO NOT PIVOT.
C
  128 IF (X .EQ. ZERO) X = SFTINV
  129 P(K) = X
      Q(K) = Y
      R(K) = ZERO
      X    = D(K+1) - (VALUE+O(K)*(Y/X))
      Y    = O(K+1)
  130 CONTINUE
  131 CONTINUE
      IF (MUL1.NE.0 .OR. MUL2.NE.0) GO TO 135
      DO 134 K = N1,N2M1
  134 V(K) = ONE
      W    = ONE/SQRT(FLOAT(N2-N1+1))
      V(N2)= ONE
C
C     SOLVE FOR AN EIGENVECTOR OF THE TRIDIAGONAL MATRIX.
C
  135 MUL2   = 0
      MAXITR = 3
      DO 150 ITER = 1,MAXITR
C
C     BACK SUBSTITUTION
C
      IF (X .EQ. ZERO) GO TO 136
      V(N2) = V(N2)/X
      GO TO 137
  136 V(N2  ) = V(N2)*SFT
  137 V(N2-1) = (V(N2-1) - Q(N2-1)*V(N2))/P(N2-1)
      MAX = N2
      IF (ABS(V(N2)) .LT. ABS(V(N2-1))) MAX = N2M1
      IF (N2M2 .LT. N1) GO TO 140
      DO 138 K = N1,N2M2
      L    = N2M2 - (K-N1)
      V(L) = (V(L)-Q(L)*V(L+1) - R(L)*V(L+2))/P(L)
      IF (ABS(V(L)) .GT. ABS (V(MAX))) MAX = L
  138 CONTINUE
C
C     NORMALIZE THE VECTOR.
C
  140 Y = ABS(V(MAX))
      Z = ZERO
      DO 141 I = N1,N2
      V(I) = V(I)/Y
      IF (ABS(V(I)) .LT. DEPS) GO TO 141
      Z = Z + V(I)*V(I)
  141 CONTINUE
      Z = SQRT(Z)
      DO 142 I = N1,N2
      V(I) = V(I)/Z
  142 CONTINUE
C
C     CHECK CONVERGENCE OF THE LARGEST COMPONENT OF THE VECTOR.
C
      Y = ABS(V(MAX))
      IF ( W .EQ. Y) GO TO 152
      IF (ITER    .EQ.  MAXITR) GO TO 150
      W = Y
C
C     PIVOT V.
C
      DO 145 I = N1,N2M1
      IF (P(I) .EQ. O(I)) GO TO 144
      V(I+1) = V(I+1) + V(I)*F(I)
      GO TO 145
  144 Z =  V(I+1)
      V(I+1) = V(I) + Z/F(I)
      V(I  ) = Z
  145 CONTINUE
  150 CONTINUE
C
C     TOO MANY ITERATIONS.
C
C     THE ACCURACY OF EIGENVECTOR XXXX CORRESPONDING TO THE EIGENVALUE
C     XXXXXXX  IS IN DOUBT.
C
  152 DO 153 I = 1,N
      VEC(I,VV) = V(I)
  153 CONTINUE
C
C     CHECK MULTIPLICITY OF THE NEXT EIGENVALUE IF IT IS IN THE SAME
C     SUBMATRIX AS THIS ONE.
C
      IF (VECTOR .EQ. V2) GO TO 160
C
C     FOR MGIV METHOD, USE ADJUSTED LAMBDA COMING OUT OF QRITER
C     IN THE FOLLOWING CHECKS
C
      IF (ABS(VAL(VECTOR+1))+ABS(VAL(VECTOR)) .LT. RMULT) GO TO 154
      IF (ABS(VAL(VECTOR+1)-VAL(VECTOR)) .GT.RMULT*ABS(VAL(VECTOR+1)))
     1    GO TO 160
  154 CONTINUE
      L1 = VLOC(VECTOR+1)
      IF (L1.LT.N1 .OR. L1.GT.N2) GO TO 160
C
C     A MULTIPLICITY DOES EXIT...THE INITIAL APPROXIMATION OF THE NEXT
C     EIGENVECTOR SHOULD BE ORTHOGONAL TO THE ONE JUST CALCULATED.
C
      IF (MUL1 .EQ. 0) MUL1 = VV
      MULP2 = MULP2 + 1
      MULP3 = MULP2 + MUL1 - 1
      DO 4001 KKK = N1,N2
 4001 V(KKK) = ONE
      DO 4003 JJJ = MUL1,MULP3
      Z = ZERO
      DO 4004 KK = N1,N2
      DO 4005 II = N1,N2
 4005 Z = Z + VEC(II,JJJ)*V(II)
 4004 V(KK) = V(KK) - Z*VEC(KK,JJJ)
 4003 CONTINUE
      GO TO 175
C
C     DOES THIS EIGENVALUE = PREVIOUS ONE(S) IN THIS SUBMATRIX
C
  160 IF (MUL1 .EQ. 0) GO TO 175
C
C     A MULTIPLICITY OF EIGENVALUES OCCURRED...IMPROVE THE ORTHOGONALITY
C     OF THE CORRESPONDING EIGENVECTORS.
C
      MULP1 = MUL1 + 1
      DO 170 L = MULP1,VV
      DO 161 I = N1,N2
      P(I) = VEC(I,L)
      Q(I) = ZERO
  161 CONTINUE
      LM1 = L - 1
      DO 164 K = MUL1,LM1
      Z = ZERO
      DO 162 I = N1,N2
      Z = Z + P(I)*VEC(I,K)
  162 CONTINUE
      DO 163  I = N1,N2
      Q(I) = Q(I) + Z*VEC(I,K)
  163 CONTINUE
  164 CONTINUE
      Z = ZERO
      DO 165  K = N1,N2
      Q(K) = P(K) - Q(K)
      IF (ABS(Q(K)) .LT. DEPS) GO TO 165
      Z = Z + Q(K)*Q(K)
  165 CONTINUE
      Z = SQRT(Z)
      DO 166 K = N1,N2
      VEC(K,L) = Q(K)/Z
  166 CONTINUE
  170 CONTINUE
      MUL1  = 0
      MULP2 = 0
  175 CONTINUE
C
C     CORE IS NOW FULL OF EIGENVECTORS OF THE TRIDIAGONAL MATRIX.
C     CONVERT THEM TO EIGENVECTORS OF THE ORIGINAL MATRIX.
C
      IT1 = IPREC
      IT2 = IPREC
      JJ  = N
      INCR= 1
C
C     IS THE ORIGINAL MATRIX A 2X2
C
      IF (NM2  .EQ. 0) GO TO 186
      MT = MT1
      IF (PATH .NE. 0) GO TO 176
      MT = MO
  176 CALL GOPEN (MT,SVEC(IBUF1),IM2)
      IF (PATH.EQ.0 .AND. V2.NE.NV) CALL GOPEN (MT1,SVEC(IBUF2),1)
      IT3  = IPREC
      JJJ  = N
      INCR1= 1
      DO 185 M = 1,NM2
      L1  = N - M
      III = L1+ 1
      IF (PATH .EQ. 0) CALL BCKREC (MT)
      CALL UNPACK (*167,MT,P)
      GO TO 180
  167 DO 179 I = 1,M
      P(I) = ZERO
  179 CONTINUE
  180 IF (PATH.NE.0 .OR. V2.EQ.NV) GO TO 177
      II = L1+1
      CALL PACK (P,MT1,MCB)
  177 IF (PATH .EQ. 0) CALL BCKREC (MT)
      DO 182 K = 1,M
      L2 = N - K + 1
      I  = M - K + 1
      Y  = P(I)
      IF (Y .EQ. ZERO) GO TO 182
      X = ZERO
      IF (ABS(Y) .LT. ONE) X = SQRT(ONE-Y**2)
      DO 181 VV = 1,NV2
      Z = X*VEC(L1,VV) -Y*VEC(L2,VV)
      VEC(L2,VV) = X*VEC(L2,VV) + Y*VEC(L1,VV)
      VEC(L1,VV) = Z
  181 CONTINUE
  182 CONTINUE
  185 CONTINUE
      CALL CLOSE (MT,1)
      IF (PATH .NE. 0) GO TO 186
      IF (V2 .NE. NV) WRITE (IOTPE,1001) UIM,N,NV,NV1
 1001 FORMAT (A29,' 2016A, WILVEC EIGENVECTOR COMPUTATIONS.', /37X,
     1       'PROBLEM SIZE IS',I6,', NUMBER OF EIGENVECTORS TO BE ',
     2       'RECOVERED IS',I6 , /37X,'SPILL WILL OCCUR FOR THIS ',
     3       'CORE AT RECOVERY OF',I6,' EIGENVECTORS.')
      PATH = 1
      CALL CLOSE (MT1,1)
      IM2  = 0
C
C     WRITE THE EIGENVECTORS ONTO PHIA
C
  186 CALL GOPEN (PHIA,SVEC(IBUF1),IM)
      II  = 1
      IT2 = IPREC
      IF (IM.NE.1 .OR. NRIGID.LE.0) GO TO 205
C
C     PUT OUT ZERO VECTORS FOR RIGID BODY MODES
C
      JJ = 1
      DO 206 VV = 1,NRIGID
      CALL PACK (ZERO,PHIA,MCB1)
  206 CONTINUE
      JJ = N
  205 CONTINUE
      IM = 3
      IF (N .EQ. 1) GO TO 250
      DO 192 VV = 1,NV2
      CALL PACK (VEC(1,VV),PHIA,MCB1)
  192 CONTINUE
  250 IF (V2 .EQ. NV) IM1 = 1
      CALL CLOSE (PHIA,IM1)
      XENTRY = -ENTRY
C
C     ANY TIME LEFT TO FIND MORE
C
      CALL TMTOGO (ITIME)
      CALL KLOCK  (IFIN)
      IF (2*(IFIN-IST) .GE. ITIME) GO TO 200
      IF (V2 .NE. NV) GO TO 100
  201 CALL WRTTRL (MCB1)
      RETURN
C
C     MAX TIME
C
  200 ITERM = 3
      GO TO 201
      END

      SUBROUTINE CRSPLS (*,JUMP,MU,BP,RS,AGAIN,N23)
C
C     THIS ROUTINE HANDLES CRBE3 AND CRSPLINE RIGID ELEMENTS
C     CALLED ONLY BY CRIGGP SUBROUTINE
C
C     SINGLE PRECISION VERSION
C
      IMPLICIT INTEGER (A-Z)
      LOGICAL          AGAIN,DEBUG
      INTEGER          MCODE(2),NAME(2),SILD(6),RS(3)
      REAL             Z(1),ZK,WT,DL,COEFF
      REAL             X1,X2,X3,Y1,Y2,Y3,Z1,Z2,Z3,A(3),B(3),C(3),D(9),
     1                 LEN,LENG,ONE,ZERO,HALF,EPS,ESPX,ANS,DI,FAC,LN3,
     2                 T(36),TX(36),KNN(36),GNN(36),UNN(36),ZNN(36),
     3                 SNN(36),X(36),Y(36),W(6)
      CHARACTER        UFM*23
      COMMON /XMSSG /  UFM
      COMMON /SYSTEM/  SYSBUF,NOUT
      COMMON /GP4FIL/  GEOMP,BGPDT,CSTM,RGT
      COMMON /GP4PRM/  BUF(20),BUF1,BUF2,BUF3,BUF4,KNKL1,TWO16,NOGO,
     1                 GPOINT,KN
      COMMON /CRSPLY/  X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3
      COMMON /ZZZZZZ/  IZ(1)
      EQUIVALENCE      (Z(1),IZ(1)), (WT,IWT ), (DL,IDL ),
     1                 (X1  ,A(1) ), (X2,B(1)), (X3,C(1))
      DATA    ONE,     ZERO,    HALF,    EPS,     TIMES, DEBUG  /
     1        1.0,     0.0,     0.5,     1.0E-10, 0,     .FALSE./
      DATA    CM,CN,   NOGOX,   MASK15,  NAME            /
     1        6 ,12,   0,       32767,   4HCRSP,4HLS     /
C
      IF (AGAIN) RETURN 1
      IF (DEBUG) WRITE (NOUT,10) KN,KNKL1,BP,GEOMP,BGPDT,CSTM,RGT,JUMP
   10 FORMAT ('0  CRSPLS DEBUG- KN,KNKL1,BP,GEOMP,BGPDT,CSTM,RGT,JUMP=',
     1        /3X,8I7)
      KN2 = KN/2
      CALL SSWTCH (38,L38)
C
C     UNIT MATRIX UNN
C
      DO 20 I = 2,35
   20 UNN( I) = ZERO
      UNN( 1) = ONE
      UNN( 8) = ONE
      UNN(15) = ONE
      UNN(22) = ONE
      UNN(29) = ONE
      UNN(36) = ONE
C
C     JUMP = 1 FOR CRBE3 DATA,  JUMP = 2 FOR CRSPLINE DATA
C
      IF (JUMP .EQ. 2) GO TO 400
C
C     READ CRBE3 DATA ON INPUT FILE
C     =============================
C
C     CLEAR WORKING SPACE
C     READ INPUT CARD, SAVE BEGINING POINTER, BEGN, AND
C     COUNT NUMBER OF WORDS READ, NWDS, IN FIRST PASS
C     (EACH INPUT CARD WILL BE READ TWICE)
C
      BEGN = 3
   30 PASS = 1
      DO 40 I = 1,36
      T(I)   = ZERO
   40 KNN(I) = ZERO
      CALL READ (*1300,*1300,GEOMP,BUF,3,0,FLAG)
      NWDS = 3
      IF (DEBUG .OR. L38.EQ.1) WRITE (NOUT,50) BUF(1)
   50 FORMAT (5X,'ELEMENT',I8,' IS BEING PROCESSED')
      EID    = BUF(1)
      GPOINT = BUF(2)
      ASSIGN 60   TO RETN
      ASSIGN 1000 TO RETN1
      KX = BUF(3)
      NM = CN
      GO TO 950
   60 REFG = K
      SIL  = GPOINT
      DO 70 I = 1,6
   70 SILD(I) = SIL + I - 1
      X2 = Z(K+1)
      Y2 = Z(K+2)
      Z2 = Z(K+3)
C
C     READ WEIGHT FACTORS AND COMPONENTS.
C     GENERATE WEIGHT VECTOR W
C
   80 CALL READ (*1110,*1110,GEOMP,IWT,1,0,FLAG)
      IF (PASS  .EQ.  1) NWDS = NWDS + 1
      IF (IWT   .EQ. -2) GO TO 170
      IF (IWT   .EQ. -3) GO TO 240
      CALL READ (*1110,*1110,GEOMP,COMP,1,0,FLAG)
      IF (PASS .EQ. 1) NWDS = NWDS + 1
      ASSIGN 90 TO RETN1
      KX = COMP
      NM = CM
      GO TO 950
   90 DO 100 I = 1,6
      W(I) = ZERO
      IF (BUF(CM+I) .NE. 0) W(I) = WT
  100 CONTINUE
C
C     READ GRID POINT, GET TRANSFORMATION MATRIX, AND SUMMING UP
C     WT MATRIX, AND FINALLY KNN MATRIX
C
  110 CALL READ (*1110,*1110,GEOMP,GRID,1,0,FLAG)
      IF (PASS .EQ.  1) NWDS = NWDS + 1
      IF (GRID .EQ. -1) GO TO 80
      ASSIGN 120 TO RETN
      GPOINT = GRID
      GO TO 1000
  120 X1 = Z(K+1)
      Y1 = Z(K+2)
      Z1 = Z(K+3)
      ASSIGN 850 TO RETN2
      ASSIGN 130 TO RETN3
      ZK = Z(K)
      GO TO 800
  130 CALL GMMATS (T,6,6,0, UNN,6,6,0, X)
      IF (PASS .EQ. 2) GO TO 270
      DO 140 I = 1,36
  140 TX(I) = X(I)
      L = 0
      DO 160 I = 1,6
      DO 150 J = 1,6
  150 X(L+J) = X(L+J)*W(I)
  160 L = L + 6
      CALL GMMATS (TX,6,6,-1, X,6,6,0, KNN)
C
C     REPEAT FOR MORE GRID POINT
C
      GO TO 110
C
C     UM SET WAS SPECIFIED BY USER. REBUILD SILD WITH THE UM SET, AND
C     CHECK TOTAL NUMBER OF COMPONENTS FOR POSSIBLE ERROR
C
  170 IF (PASS .EQ. 2) GO TO 310
      JJ = 1
  180 CALL READ (*1110,*1110,GEOMP,GRID,1,0,FLAG)
      NWDS = NWDS + 1
      IF (GRID .EQ. -3) GO TO 240
      CALL READ (*1110,*1110,GEOMP,COMP,1,0,FLAG)
      NWDS = NWDS + 1
      ASSIGN 190 TO RETN1
      KX = COMP
      NM = CM
      GO TO 950
  190 GPOINT = GRID
      ASSIGN 200 TO RETN
      GO TO 1000
  200 DO 230 I = 1,6
      IF (BUF(CM+ I) .EQ. 0) GO TO 230
      IF (JJ .GT. 6) GO TO 1160
  210 IF (BUF(CN+JJ) .NE. 0) GO TO 220
      JJ = JJ + 1
      IF (JJ .GT. 6) GO TO 1160
      GO TO 210
  220 SILD(JJ) = GPOINT + I - 1
      JJ = JJ + 1
  230 CONTINUE
      GO TO 180
  240 IF (PASS .EQ. 2) GO TO 320
C
C     STORE DIAG TERMS WITH -1.
C     ADD DEPENDENT SIL TO THE END OF OPEN CORE VIA MU POINTER
C
      DO 250 I = 1,6
      IF (BUF(CN+I) .EQ. 0) GO TO 250
      MCODE(1) = SIL + I - 1
      MCODE(2) = SILD(I)
      COEFF    = -1.
      CALL WRITE (RGT,MCODE,2,0)
      CALL WRITE (RGT,COEFF,1,0)
      IZ(MU) = MCODE(2)
      MU = MU - 1
  250 CONTINUE
C
C     GET MATRIX READY FOR SECOND PASS, IN TX
C
      SING = -1
      CALL INVERS (6,KNN,6,0,0,LEN,SING,X)
      IF (SING .EQ. 2) GO TO 1120
      ASSIGN 260 TO RETN2
      ZK = Z(REFG)
      GO TO 800
  260 CALL GMMATS (KNN,6,6,0, T,6,6,0, TX)
C
C     BACK RECORD FOR 2ND PASS
C     SKIP TO WHERE WEIGHT FACTORS BEGIN
C
      CALL BCKREC (GEOMP)
      PASS = 2
      I = BEGN + 3
      CALL READ (*1110,*1110,GEOMP,BUF,-I,0,FLAG)
      GO TO 80
C
C     INSERT THIS GRID MPC EQUATIONS
C
  270 CALL GMMATS (TX,6,6,0, X,6,6,1, KNN)
      DO 280 I = 1,6
      DO 280 J = 1,31,6
      L = I + J - 1
      KNN(L) = KNN(L)*W(I)
  280 CONTINUE
      DO 300 I = 1,6
      IF (BUF(CN+I) .EQ. 0) GO TO 300
      SIL = SILD(I)
      L = (I-1)*6
      DO 290 J = 1,6
      IF (BUF(CM+J) .EQ. 0) GO TO 290
      ANS = KNN(L+J)
      IF (ANS .EQ. ZERO) GO TO 290
      MCODE(1) = GPOINT + J - 1
      MCODE(2) = SIL
      COEFF    = ANS
      CALL WRITE (RGT,MCODE,2,0)
      CALL WRITE (RGT,COEFF,1,0)
  290 CONTINUE
  300 CONTINUE
      GO TO 110
C
C     SKIP TO END OF CARD
C
  310 CALL READ (*1110,*1110,GEOMP,J,1,0,FLAG)
      IF (J .NE. -3) GO TO 310
C
C     UPDATE BEGIN POINTER, AND RETURN FOR ANOTHER RBE3 CARD
C
  320 BEGN = BEGN + NWDS
      GO TO 30
C
C
C     READ CRSPLINE DATA ON INPUT FILE
C     ================================
C
C     INPUT DATA WILL BE SAVED IN RS ARRAY
C     3 WORDS SAVED FOR EACH GRID - BGPDT POINTER, COMPONENT, AND SIL
C
  400 CALL READ (*1300,*1300,GEOMP,BUF,3,0,FLAG)
      EID = BUF(1)
      IDL = BUF(2)
      RS(1) = BUF(3)
      RS(2) =-1
      RS(3) = 0
      IF (DEBUG .OR. L38.EQ.1) WRITE (NOUT,50) BUF(1)
      K = 4
  410 CALL READ (*1110,*1110,GEOMP,RS(K),2,0,FLAG)
      IF (RS(K) .EQ. -1) GO TO 420
      RS(K+2) = 0
      K = K + 3
      IF (K .GT. MU) CALL MESAGE (-8,0,NAME)
      GO TO 410
C
C     END OF INPUT FOR THIS RIGID ELEMENT, NOW COMPUTE LENGTH, INTERNAL
C     NUMBER (BGPDT POINTER), AND CHANGE GRID TO SIL
C
  420 IF (K .LT. 8) GO TO 1100
      IF (DEBUG) CALL BUG1 ('RS-     ',310,RS,K)
      IEND = K - 1
      LEN  = ZERO
      ASSIGN 430 TO RETN
C
C     DO 460 I = 1,IEND,3
      I = 1
  425 GPOINT = RS(I)
      GO TO 1000
C
C     UPON RETURN FROM 1000, K IS BGPDT AND GPOINT IS SIL
C
  430 RS(I  ) = K
      RS(I+2) = GPOINT
      IF (DEBUG) WRITE (NOUT,440) I,GPOINT,K,Z(K+1)
  440 FORMAT (/10X,'@430  I, NEW GPOINT & K=',I4,2I6,E11.3)
C
      IF (I .NE. 1) GO TO 450
      X1 = Z(K+1)
      Y1 = Z(K+2)
      Z1 = Z(K+3)
      GO TO 460
  450 X2 = Z(K+1)
      Y2 = Z(K+2)
      Z2 = Z(K+3)
      LEN= LEN + SQRT((X2-X1)**2 + (Y2-Y1)**2 + (Z2-Z1)**2)
      X1 = X2
      Y1 = Y2
      Z1 = Z2
  460 I  = I + 3
      IF (I .LT. IEND) GO TO 425
C
      DI = LEN*DL
      IS = 1
      IF (.NOT.DEBUG) GO TO 480
      CALL BUG1 ('RS-     ',345,RS,IEND)
      WRITE  (NOUT,470) LEN,DI
  470 FORMAT ('0  LEN,DI/@470 =',2E14.5)
C
C     COMPUTATION FOR EACH SEPARATED SPLINE
C     SET NUMBER OF SEGMENTS, NS
C
  480 NS = 0
      DO 490 I = IS,IEND,3
      IF (RS(I+1) .EQ. 0) GO TO 500
  490 NS = NS + 1
C
C     IB = BEGIN,  IE = END,  IS = PRESENT SEGMENT
C     ND = NUMBER OF DEPENDENT POINTS
C
C     ZERO MTRAIX WORKING SPACE KNN ,GNN, AND T
C
  500 IE = I
      IB = IS
      ND = NS - 1
      DO 510 I = 1,36
      KNN(I) = ZERO
      GNN(I) = ZERO
      T(I)   = ZERO
  510 CONTINUE
C
C     COMPUTE FLEXIBILITY MATRIX ZNN AND ITS INVERSE KNN, FOR EACH
C     SPLINE SEGMENT.
C
C     DO 540 I = 1,NS
      I = 0
  515 I = I + 1
      I1 = RS(IS  )
      I2 = RS(IS+3)
      ASSIGN 520 TO RETN4
      GO TO 900
  520 IF (NOGOX .EQ. 1) GO TO 540
      X2 = Z(I1+1)
      Y2 = Z(I1+2)
      Z2 = Z(I1+3)
      X1 = Z(I2+1)
      Y1 = Z(I2+2)
      Z1 = Z(I2+3)
      X2 = (X2+X1)*HALF
      Y2 = (Y2+Y1)*HALF
      Z2 = (Z2+Z1)*HALF
      I1 = RS(IE)
      X1 = Z(I1+1)
      Y1 = Z(I1+2)
      Z1 = Z(I1+3)
C
C     FORM UNN USING BASIC UNN MATRIX
C     DO NOT DESTROY RIGID TRANSFER MATRIX
C
      ASSIGN 530 TO RETN3
      GO TO 850
  530 CALL GMMATS (UNN,6,6,0, ZNN,6,6,0, SNN)
C
C     SUM INTO KNN
C
      CALL GMMATS (SNN,6,6,-2, UNN,6,6,1, KNN)
  540 IS = IS + 3
      IF (I .LT. NS) GO TO 515
C
      IF (NOGOX .EQ. 1) GO TO 730
C
C     INVERT KNN
C
      SING = -1
      CALL INVERS (6,KNN,6,0,0,LEN,SING,SNN)
      IF (SING .EQ. 2) GO TO 1120
C
C     LOOP FOR FINAL CONSTRAINT EQUATIONS
C
      IS = IB
      JS = RS(IS)
      II = 0
  545 II = II + 1
      I1 = RS(IS)
      ID = IS + 3
      I2 = RS(ID)
      ASSIGN 550 TO RETN4
      GO TO 900
  550 X1 = Z(I2+1)
      Y1 = Z(I2+2)
      Z1 = Z(I2+3)
      X2 = Z(I1+1)
      Y2 = Z(I1+2)
      Z2 = Z(I1+3)
      X3 = Z(I2+1)
      Y3 = Z(I2+2)
      Z3 = Z(I2+3)
      X2 = (X2+X3)*HALF
      Y2 = (Y2+Y3)*HALF
      Z2 = (Z2+Z3)*HALF
C
C     Y I+1 I X   S I+1 S
C
      ASSIGN 560 TO RETN3
      GO TO 850
  560 CALL GMMATS (UNN,6,6,0, ZNN,6,6,0, SNN)
      CALL GMMATS (SNN,6,6,0, UNN,6,6,1,   Y)
      X2 = Z(I1+1)
      Y2 = Z(I1+2)
      Z2 = Z(I1+3)
C
C     S I+1 I X GIN
C
      ASSIGN 570 TO RETN3
      GO TO 850
  570 CALL GMMATS (UNN,6,6,0, GNN,6,6,0, SNN)
      I3 = RS(IE)
      X3 = Z(I3+1)
      Y3 = Z(I3+2)
      Z3 = Z(I3+3)
      X2 = Z(JS+1)
      Y2 = Z(JS+2)
      Z2 = Z(JS+3)
C
C     GNN = G I+1 N
C
      ASSIGN 580 TO RETN3
      GO TO 860
  580 CALL GMMATS (Y  ,6,6,0, UNN,6,6,1, ZNN)
      CALL GMMATS (ZNN,6,6,0, KNN,6,6,0, GNN)
      DO 590 J = 1,36
  590 GNN(J) = GNN(J) + SNN(J)
C
C     Y = G I+1 1
C
      ASSIGN 600 TO RETN3
      GO TO 870
  600 CALL GMMATS (GNN,6,6,0, UNN,6,6,0, SNN)
      ASSIGN 610 TO RETN3
      GO TO 850
  610 DO 620 J = 1,36
  620 Y(J) = UNN(J) - SNN(J)
C
C     TRANSFORM TO GLOBAL AND STORE ANSWERS IN Y AND SNN
C
      ASSIGN 630 TO RETN2
      ZK = Z(I2)
      GO TO 800
  630 CALL GMMATS (T,6,6,1, Y  ,6,6,0, SNN)
      CALL GMMATS (T,6,6,1, GNN,6,6,0, ZNN)
      ASSIGN 640 TO RETN2
      ZK = Z(JS)
      GO TO 800
  640 CALL GMMATS (SNN,6,6,0, T,6,6,0, Y)
      ASSIGN 650 TO RETN2
      ZK = Z(I3)
      GO TO 800
  650 CALL GMMATS (ZNN,6,6,0, T,6,6,0, SNN)
C
C     Y = G I 1  SNN = G I N
C
      ASSIGN 660 TO RETN1
      KX = RS(ID+1)
      NM = CM
      GO TO 950
C
C     ADD DEPENDENT TO LIST AND MPC EQUATIONS TO RGT
C
  660 IF (.NOT.DEBUG) GO TO 680
      WRITE (NOUT,670) Y
      WRITE (NOUT,670) SNN
  670 FORMAT ('0  CRSPLS/@670',/,(2X,10E12.4))
  680 DO 710 J = 1,6
      IF (BUF(CM+J) .EQ. 0) GO TO 710
C
C     SELF TERM FOR DEPENDENT SIL
C
      SIL = RS(ID+2) + J - 1
      MCODE(1) = SIL
      MCODE(2) = SIL
      COEFF    = -1.
      CALL WRITE (RGT,MCODE,2,0)
      CALL WRITE (RGT,COEFF,1,0)
      IZ(MU) = MCODE(2)
      MU = MU - 1
      IF (II .GE. MU) CALL MESAGE (-8,0,NAME)
      LL = (J-1)*6
C
C     END ONE DEPENDENT
C
      DO 690 L = 1,6
      ANS = Y(LL+L)
C
C     TEST FOR COMPUTED ZERO
C
      ESPX = EPS
      IF (J.GT.3 .AND. L.LT.4) ESPX = ESPX/LENG
      IF (J.LT.4 .AND. L.GT.3) ESPX = ESPX*LENG
      IF (ABS(ANS) .LT. ESPX) GO TO 690
      MCODE(1) = RS(IB+2) + L - 1
      MCODE(2) = SIL
      COEFF    = ANS
      CALL WRITE (RGT,MCODE,2,0)
      CALL WRITE (RGT,COEFF,1,0)
  690 CONTINUE
C
C     END N INDEPENDENT
C
      DO 700 L = 1,6
      ANS = SNN(LL+L)
C
C     TEST FOR COMPUTED ZERO
C
      ESPX = EPS
      IF (J.GT.3 .AND. L.LT.4) ESPX = ESPX/LENG
      IF (J.LT.4 .AND. L.GT.3) ESPX = ESPX*LENG
      IF (ABS(ANS) .LT. ESPX) GO TO 700
      MCODE(1) = RS(IE+2) + L - 1
      MCODE(2) = SIL
      COEFF    = ANS
      CALL WRITE (RGT,MCODE,2,0)
      CALL WRITE (RGT,COEFF,1,0)
  700 CONTINUE
  710 CONTINUE
C
      IS = IS + 3
      IF (II .LT. ND) GO TO 545
C
C     END BIG DO (720) LOOP
C
  730 IF (IE+2 .GE. IEND) GO TO 400
      IS = IE
      RS(IS+1) = -1
      GO TO 480
C
C     ----------------------------------------------------
C
C     INTERNAL ROUTINE TO BUILD 6X6 BASIC TO GLOBAL MATRIX
C     (T = 0 ON ENTRY)
C
  800 CALL TRANSS (ZK,D)
      J = 1
      DO 810 I = 1,15,6
      T(I   ) = D(J  )
      T(I+ 1) = D(J+1)
      T(I+ 2) = D(J+2)
      T(I+21) = D(J  )
      T(I+22) = D(J+1)
      T(I+23) = D(J+2)
  810 J = J + 3
      GO TO RETN2, (260,850,630,640,650)
C
C     INTERNAL ROUTINE TO MAKE RIGID BODY TRANSFER MATRIX FOR CRSPLINES
C     (UNN = IDENTITY MATRIX ON ENTRY)
C
  850 UNN( 5) = A(3) - B(3)
      UNN( 6) = B(2) - A(2)
      UNN(10) = B(3) - A(3)
      UNN(12) = A(1) - B(1)
      UNN(16) = A(2) - B(2)
      UNN(17) = B(1) - A(1)
      GO TO 880
  860 UNN( 5) = C(3) - A(3)
      UNN( 6) = A(2) - C(2)
      UNN(10) = A(3) - C(3)
      UNN(12) = C(1) - A(1)
      UNN(16) = C(2) - A(2)
      UNN(17) = A(1) - C(1)
      GO TO 880
  870 UNN( 5) = C(3) - B(3)
      UNN( 6) = B(2) - C(2)
      UNN(10) = B(3) - C(3)
      UNN(12) = C(1) - B(1)
      UNN(16) = C(2) - B(2)
      UNN(17) = B(1) - C(1)
  880 GO TO RETN3, (130,530,560,570,580,600,610)
C
C     INTERNAL ROUTINE TO FORM FLEXIBILITY MATRIX FOR CRSPLINE
C
  900 DO 910 I = 1,36
  910 ZNN(I) = ZERO
      X1 = Z(I1+1)
      Y1 = Z(I1+2)
      Z1 = Z(I1+3)
      X2 = Z(I2+1)
      Y2 = Z(I2+2)
      Z2 = Z(I2+3)
      LENG = SQRT((X2-X1)**2 + (Y2-Y1)**2 + (Z2-Z1)**2)
      IF (LENG .EQ. ZERO) GO TO 930
      ZNN(22) = LENG
      ZNN(29) = LENG
      ZNN(36) = LENG
      FAC = LENG/12.0*((3.0*DI**2)/(2.0*LENG**2)-ONE)
      LN3 = LENG**3/12.0
      ZNN( 1) = LN3 + FAC*(X2-X1)**2
      ZNN( 2) = FAC *(X2-X1)*(Y2-Y1)
      ZNN( 3) = FAC *(X2-X1)*(Z2-Z1)
      ZNN( 7) = ZNN(2)
      ZNN( 8) = LN3 + FAC*(Y2-Y1)**2
      ZNN( 9) = FAC*(Y2-Y1)*(Z2-Z1)
      ZNN(13) = ZNN(3)
      ZNN(14) = ZNN(9)
      ZNN(15) = LN3 + FAC*(Z2-Z1)**2
  920 GO TO RETN4, (520,550)
  930 CALL MESAGE (30,31,EID)
      NOGOX = 1
      GO TO 920
C
C     INTERNAL ROUTINE TO ABSTRACT CODED DOF
C
  950 DO 960 I = 1,6
      BUF(NM+I) = 0
  960 CONTINUE
      IF (KX .LE. 0) GO TO 980
      DO 970 I = 1,6
      K1 = KX/10
      K2 = KX - K1*10
      IF (K2 .GT. 6) GO TO 980
      BUF(NM+K2) = K2
      IF (K1  .EQ. 0) GO TO 980
  970 KX = K1
  980 GO TO RETN1, (90,190,1000,660)
C
C     INTERNAL ROUTINE TO PERFORM BINARY SEARCH IN EQEXIN AND
C     CONVERT THE EXTERNAL NUMBER TO A SIL VALUE
C
 1000 KLO = 0
      KHI = KN2
      LASTK = 0
 1010 K = (KLO+KHI+1)/2
      IF (LASTK .EQ. K) GO TO 1140
      LASTK = K
      IF (GPOINT-IZ(2*K-1)) 1020,1040,1030
 1020 KHI = K
      GO TO 1010
 1030 KLO = K
      GO TO 1010
 1040 K = IZ(2*K)
      GPOINT = IZ(K+2*KN)
      K = (K-1)*4 + BP
      IF (GPOINT+5 .GT. MASK15) N23 = 3
      GO TO RETN, (60,120,200,430)
C
C     ERROR MESSAGES
C
 1100 MSG = 131
      GO TO 1130
 1110 CALL MESAGE (-3,GEOMP,NAME)
 1120 MSG = 38
 1130 CALL MESAGE (30,MSG,EID)
      GO TO 1180
 1140 WRITE  (NOUT,1150) UFM,GPOINT,EID
 1150 FORMAT (A23,', UNDEFINED GRID POINT',I9,' SPECIFIED BY RIGID ',
     1       'ELEMENT ID',I9)
      TIMES = TIMES + 1
      IF (TIMES .GT. 50) CALL MESAGE (-37,0,NAME)
      GO TO 1180
 1160 WRITE  (NOUT,1170) UFM,EID
 1170 FORMAT (A23,', RIGID ELEMENT CRBE3',I9,' HAS ILLEGAL UM SET ',
     1        'SPECIFICATION')
      GO TO 1190
C
 1180 NOGO  = 1
      NOGOX = 0
      GO TO (30,400), JUMP
C
C     REPOSITION GEOMP FILE FOR NEXT CRBE3 INPUT CARD
C
 1190 NOGO  = 1
      NOGOX = 0
      CALL BCKREC (GEOMP)
      I = BEGN + 1
      CALL READ (*1110,*1110,GEOMP,J,-I,0,FLAG)
 1200 CALL READ (*1110,*1110,GEOMP,J, 1,0,FLAG)
      I = I + 1
      IF (J .NE. -3) GO TO 1200
      BEGN = I
      GO TO 30
C
 1300 IF (NOGOX .EQ. 1) NOGO = 1
      RETURN
      END

      SUBROUTINE APD1 (FST,NS,FCT,NC,LS,LC)
C
      LOGICAL         LS,LC
      INTEGER         IZ(1),NAME(2),FILE,NCARY(2),SILC,NECTA(6),
     1                CP,ACSID,EID,EIDB,CID(5),CIDBX,AUSET(6,2),SILB,
     2                RDREW,CLSREW,AYS(5),KEY(5),SILDX(4),ACSIX(4),BACK,
     3                SCR1,SCR2,SCR3,SCR4,SCR5,ECTA,BGPA,GPLA,USETA,
     4                SILA,CSTMA,ACPT,BUF10,BUF11,BUF12,WTREW,ACSIB,PID
      REAL            RB1(3),ACPL(3,3),VX1(3),VX2(3),AXIC(3),FST(1),
     1                FCT(1),XB(5)
      COMMON /BLANK / NK,NJ,LUSETA
      COMMON /SYSTEM/ SYSBUF,NOT
      COMMON /APD1C / EID,PID,CP,NSPAN,NCHORD,LSPAN,LCHORD,IGID,
     1                X1,Y1,Z1,X12,X4,Y4,Z4,X43,XOP,X1P,ALZO,MCSTM,
     2                NCST1,NCST2,CIDBX,ACSID,IACS,SILB,NCRD,
     3                SCR1,SCR2,SCR3,SCR4,SCR5,ECTA,BGPA,GPLA,USETA,
     4                SILA,CSTMA,ACPT,BUF10,BUF11,BUF12,NEXT,LEFT,ISILN
      COMMON /APD1D / ICPL(14),YP4,S1,C1,XP2,XP3,XP4,RA1(3)
      COMMON /APD12C/ KEY,AUSET,USA,UK,NCAM2,NASB,IPPC
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE     (ICPL(3),RB1(1)),(ICPL(6),ACPL(1,1)),
     1                (NECTA(2),CID(1)),(KEY(2),NP),(KEY(3),NSTRIP),
     2                (KEY(4),NTP),(KEY(5),F),(AYS(1),YS),(AYS(2),ZS),
     3                (AYS(3),EE),(AYS(4),SG),(AYS(5),CG),(AXIC(1),XIC),
     4                (AXIC(2),DELX),(AXIC(3),XLAM),(SILDX(1),ICID),
     5                (SILDX(3),SILC),(ACSIX(1),ACSIB),(Z(1),IZ(1)),
     6                (ACSIX(2),VX2(1)),(NECTA(1),EIDB)
      DATA    RDREW , CLSREW,WTREW / 0,1,1 /
      DATA    NAME  / 4HAPD1,1H    /
C
      KEY(1) = 1
      SILC   = SILB
C
C     IF NEW IGRID SET INITIALIZE
C
      IF (.NOT.LS) GO TO 30
      NP   = 0
      NTP  = 0
      NBOX = 0
      NASB = 0
      NSTRIP = 0
      CALL GOPEN (SCR3,Z(BUF10),WTREW)
      CALL GOPEN (SCR4,Z(BUF11),WTREW)
      CALL GOPEN (SCR5,Z(BUF12),WTREW)
C
C     MAKE COORD SYSTEM AND GET POINTS IN PROPER SYSTEM
C
   30 CALL APDCS
      SG = S1
      CG = C1
      ACSIB = MCSTM
C
C     CHECK FOR ASSOCIATED BODIES
C
      DO 40 J = 1,6
      IF (IZ(IPPC+J) .EQ. 0) GO TO 45
   40 NASB = NASB + 1
   45 CONTINUE
C
C     GENERATE BOXES
C
      NCRDP= NCRD
      NP   = NP + 1
      FSJ1 = APDF(FST,1,NSPAN)
      YJ1  = FSJ1*YP4
      DJ1  = FSJ1*XP4
      CJ1  = (1.0-FSJ1)*XP2 + FSJ1*(XP3-XP4)
      EIDB = EID - 1
      DO 370 J = 1,NS
      YJ   = YJ1
      DJ   = DJ1
      CJ   = CJ1
      FSJ1 = APDF(FST,J+1,NSPAN)
      YJ1  = FSJ1*YP4
      DJ1  = FSJ1*XP4
      CJ1  = (1.0-FSJ1)*XP2 + FSJ1*(XP3-XP4)
      EE   = .5*(YJ1-YJ)
      YSP  = YJ + EE
      NSTRIP = NSTRIP + 1
      FCI1 = APDF(FCT,1,NCHORD)
      XI1J = DJ + FCI1*CJ
      XI1J1= DJ1+ FCI1*CJ1
      DS   = 1.0/(YJ1-YJ)
      YS   = YSP*CG + RA1(2)
      ZS   = YSP*SG + RA1(3)
      CALL WRITE (SCR3,AYS(1),5,0)
      DO 370 I = 1,NC
      NTP  = NTP + 1
      XIJ  = XI1J
      XIJ1 = XI1J1
      FCI1 = APDF(FCT,I+1,NCHORD)
      XI1J = DJ + FCI1*CJ
      XI1J1= DJ1+ FCI1*CJ1
      AIJ  = (1.0-XOP)*XIJ  + XOP*XI1J
      AIJ1 = (1.0-XOP)*XIJ1 + XOP*XI1J1
      XIC  = .5*(AIJ+AIJ1)  + RA1(1)
      XLAM = (AIJ1-AIJ)*DS
      DELX = .50*(-XIJ+XI1J - XIJ1+XI1J1)
      CALL WRITE (SCR4,AXIC(1),3,0)
      XIC  = XIC - RA1(1)
      EIDB = EIDB + 1
      NBOX = NBOX + 1
      CID(1) = CIDBX + I + (NC+1)*(J-1)
      CID(2) = CID(1) + 1
      CID(3) = CID(1) + NC + 1
      CID(4) = CID(3) + 1
      CID(5) = EIDB
      NCID = CID(4)
      NJ   = NJ + 1
      NK   = NK + 2
      VX1(3) = 0
      IF (J .NE. 1) GO TO 310
      IF (I .NE. 1) GO TO 300
      ASSIGN 300 TO BACK
      ICID = CID(1)
      VX1(1) = XIJ
      VX1(2) = YJ
      KK = 1
      GO TO 340
  300 ASSIGN 310 TO BACK
      ICID = CID(2)
      VX1(1) = XI1J
      VX1(2) = YJ
      KK = 1
      GO TO 340
  310 IF (I .NE. 1) GO TO 320
      ASSIGN 320 TO BACK
      ICID = CID(3)
      VX1(1) = XIJ1
      VX1(2) = YJ1
      KK = 1
      GO TO 340
  320 ASSIGN 330 TO BACK
      ICID = CID(4)
      VX1(1) = XI1J1
      VX1(2) = YJ1
      KK = 1
      GO TO 340
  330 ASSIGN 360 TO BACK
      ICID = CID(5)
      VX1(1) = XIC + .25*DELX
      VX1(2) = YSP
      KK = 2
  340 CALL GMMATS (ACPL,3,3,0, VX1,3,1,0, VX2)
      DO 350 K = 1,3
  350 VX2(K) = VX2(K) + RB1(K)
      CALL WRITE (BGPA,ACSIX,4,0)
      CALL WRITE (GPLA,ICID,1,0)
      CALL WRITE (USETA,AUSET(1,KK),6,0)
      NCRD = NCRD + 1
      SILC = SILC + 6
      ISILN= ISILN + 6
      SILDX(4) = ISILN
      LUSETA = SILC
      SILDX(2) = 10*SILC + 1
      CALL WRITE (SILA,SILC,1,0)
      CALL WRITE (SCR2,ISILN,1,0)
      CALL WRITE (SCR2,SILC,1,0)
      CALL WRITE (SCR1,ICID,2,0)
      GO TO BACK, (300,310,320,330,360)
  360 CID(1) = IAPD(I  ,J  ,NC,NCRDP)
      CID(2) = IAPD(I+1,J  ,NC,NCRDP)
      CID(4) = IAPD(I  ,J+1,NC,NCRDP)
      CID(3) = IAPD(I+1,J+1,NC,NCRDP)
      CID(5) = CID(3) + 1
      CALL WRITE (ECTA,NECTA(1),6,0)
  370 CONTINUE
      CIDBX = NCID
      NCARY(1) = NC
      NCARY(2) = NBOX
      CALL WRITE (SCR5,NCARY,2,0)
C
C     ADD PROPERITY CARD POINTERS FOR APD2
C
      CALL WRITE (SCR5,IPPC,1,0)
      SILB = SILC
      IF(.NOT.LC) RETURN
C
C     WRITE ACPT TABLE
C
      F = X1P - XOP
      CALL WRITE (ACPT,KEY,5,0)
C
C     COPY STUFF FROM SCRATCH FILES TO ACPT
C
      FILE = SCR5
      K = 3
      ASSIGN 410 TO IRET
      GO TO 375
  410 ASSIGN 420 TO IRET
      FILE = SCR3
      K = 5
      GO TO 375
  420 ASSIGN 430 TO IRET
      FILE = SCR4
      K = 3
  375 CALL WRITE (FILE,0,0,1)
      CALL CLOSE (FILE,CLSREW)
      CALL GOPEN (FILE,Z(BUF12),RDREW)
      DO 400 I = 1,K
  380 CALL READ (*480,*390,FILE,XB(1),K,0,J)
C
C     SKIP PROPERTY CARD POINTERS
C
      IF (I.EQ.3 .AND. FILE.EQ.SCR5) GO TO 380
      CALL WRITE (ACPT,XB(I),1,0)
      GO TO 380
  390 CALL REWIND (FILE)
      CALL SKPREC (FILE,1)
  400 CONTINUE
      CALL CLOSE (FILE,CLSREW)
      GO TO IRET, (410,420,430)
  430 CALL WRITE (ACPT,0,0,1)
      RETURN
C
C     ERROR MESAGES
C
  480 IP1 = -2
      CALL MESAGE (IP1,FILE,NAME)
      RETURN
      END

      SUBROUTINE RENAME (NAME1,NAME2,Z,NZ,ITEST)
C
C     THIS ROUTINE RENAMES SUBSTRUCTURE NAME1 TO NAME2. SOF ITEMS EQSS,
C     BGSS, CSTM, LODS, LOAP AND PLTS ARE REWRITTEN TO REFLECT THE NEW
C     NAME.  THESE ITEMS ARE CHANGED FOR NAME1 AND ANY HIGHER LEVEL
C     SUBSTRUCTURE FOR WHICH NAME1 IS A COMPONENT.  NO CHANGES ARE MADE
C     TO SECONDARY SUBSTRUCTURES OF NAME1 WHICH RETAIN THEIR ORIGINAL
C     NAMES.  ALSO NO CHANGES ARE MADE TO THE SOLUTION DATA (ITEM SOLN)
C     FOR SUBSTRUCTURE NAME1 OR ANY HIGHER LEVEL SUBSTRUCTURES.
C
C     VALUES RETURNED IN ITEST ARE
C        1 - NORMAL RETURN
C        4 - SUBSTRUCTURE NAME1 DOES NOT EXIST
C       10 - SUBSTRUCTURE NAME2 ALREADY EXISTS
C
      EXTERNAL        ANDF
      LOGICAL         DITUP    ,MDIUP    ,HIGHER
      INTEGER         NAME1(2) ,NAME2(2) ,NAME(2)  ,NAMEH(2)  ,Z(2)    ,
     1                          EOG      ,BLANK    ,PS        ,ANDF    ,
     2                NAMSUB(2)
      CHARACTER       UFM*23   ,UWM*25   ,UIM*29
      COMMON /XMSSG / UFM      ,UWM      ,UIM
      COMMON /ITEMDT/ NITEM    ,ITEMS(7,1)
      COMMON /SOF   / DITDUM(6),IODUM(8) ,MDIDUM(4),NXTDUM(15),DITUP   ,
     1                MDIUP
      COMMON /SYSTEM/ SYSBUF, NOUT
      COMMON /ZZZZZZ/ BUF(1)
      DATA    PS    / 1 /
      DATA    EOG   / 4H$EOG/, BLANK /4H    /
      DATA    NAMSUB/ 4HRENA,4HME  /
C
C
C     CHECK IF NAME2 ALREADY EXISTS
C
      CALL FDSUB (NAME2,IND)
      IF (IND .NE. -1) GO TO 1000
C
C     CHANGE DIT ENTRY FOR SUBSTRUCTURE NAME1
C
      CALL FDSUB (NAME1,IND)
      IF (IND .LT. 0) GO TO 1100
      CALL FDIT (IND,IDIT)
      IF (NAME1(1).NE.BUF(IDIT) .OR. NAME1(2).NE.BUF(IDIT+1)) GO TO 1200
      BUF(IDIT  ) = NAME2(1)
      BUF(IDIT+1) = NAME2(2)
      DITUP   = .TRUE.
C
      NAME(1) = NAME2(1)
      NAME(2) = NAME2(2)
      HIGHER  = .FALSE.
C
C     CHANGE TABLE ITEMS WHICH CONTAIN SUBSTRUCTRUE NAME
C     SUBSTRUCTURE NAME.
C     HIGHER = .FALSE. - WE ARE WORKING WITH SUBSTRUCTURE NAME1
C     HIGHER = .TRUE.  - WE ARE WORKING WITH A SUBSTRUCTURE FOR
C                        WHICH NAME1 IS A COMPONENT
C
   10 CALL FDSUB (NAME,IND)
      CALL FMDI (IND,IMDI)
      IPS = ANDF(BUF(IMDI+PS),1023)
      DO 100 ITM = 1,NITEM
      IF (ITEMS(2,ITM) .GT. 0) GO TO 100
      ITEM = ITEMS(1,ITM)
      INUM = ITEMS(3,ITM)/1000000
      ILOC = (ITEMS(3,ITM) - INUM*1000000)/1000
      INCR =  ITEMS(3,ITM) - INUM*1000000 - ILOC*1000
C
C     PROCESS THE FOLLOWING ITEMS
C
C     SUBSTRUCTRUE NAME1
C     DONT PROCESS THE ITEM IF THIS IS A SECONDARY SUBSTRUCTURE
C     AND THE ACTUAL ITEM IS STORED FOR THE PRIMARY (I.E. BGSS,CSTM(
C     HIGHER LEVEL SUBSTRUCTURE
C     DONT PROCESS THE ITEM IF IT IS ACTUALLY STORED FOR THE
C     PRIMARY SUBSTRUCTURE (I.E. BGSS,CSTM)
C
      IF (.NOT.HIGHER .AND. ILOC.EQ.0 .AND. IPS.NE.0) GO TO 100
      IF (HIGHER .AND. ILOC.EQ.0) GO TO 100
C
C     READ ITEM INTO OPEN CORE
C
      IRW = 1
      CALL SFETCH (NAME,ITEM,IRW,ITEST)
      IF (ITEST .NE. 1) GO TO 100
      NCORE = NZ
      ICORE = 1
   20 CALL SUREAD (Z(ICORE),NCORE,NWDS,ITEST)
      IF (ITEST .EQ. 3) GO TO 30
      IF (ITEST .EQ. 1) GO TO 1300
      Z(ICORE+NWDS) = EOG
      ICORE = ICORE + NWDS + 1
      NCORE = NCORE - NWDS - 1
      GO TO 20
   30 NWDS  = ICORE + NWDS - 1
C
C     CHANGE ANY OCCURANCE OF NAME1 WITH NAME2
C
      IF (HIGHER) GO TO 40
C
C     SUBSTRUCTURE NAME1 - NAME SHOULD BE IN WORDS 1 AND 2 OF GROUP 0
C
      IF (Z(1).NE.NAME1(1) .OR. Z(2).NE.NAME1(2)) GO TO 100
      Z(1) = NAME2(1)
      Z(2) = NAME2(2)
C
C     SEARCH THE LIST OF COMPONENT SUBSTRUCTURES FOR NAME1
C
   40 NCOMP = Z(INUM)
      ILOC2 = ILOC + INCR*NCOMP - 1
      DO 50 I = ILOC,ILOC2,INCR
      IF (Z(I).NE.NAME1(1) .OR. Z(I+1).NE.NAME1(2)) GO TO 50
      Z(I  ) = NAME2(1)
      Z(I+1) = NAME2(2)
      GO TO 60
   50 CONTINUE
C
C     DELETE OLD ITEM
C
   60 CALL DELETE (NAME,ITEM,ITEST)
C
C     WRITE NEW ITEM TO SOF
C
      ITEST = 3
      IRW   = 2
      CALL SFETCH (NAME,ITEM,IRW,ITEST)
      ITEST = 3
      CALL SUWRT (Z(1),NWDS,ITEST)
C
  100 CONTINUE
C
C     GET NEXT HIGHER LEVEL SUBSTRUCTURE FOR WHICH NAME1 IS A
C     COMPONENT AND PERFORM SAME PROCEDURE
C
      CALL FNDNXL (NAME,NAMEH)
      IF (NAMEH(1).EQ.BLANK .OR. NAMEH(1).EQ.NAME(1) .AND.
     1    NAMEH(2).EQ.NAME(2)) GO TO 110
      NAME(1) = NAMEH(1)
      NAME(2) = NAMEH(2)
      HIGHER = .TRUE.
      GO TO 10
C
C     NO HIGHER LEVEL SUBSTRUCTURES LEFT - PRINT INFORMATION MESSAGE
C     AND RETURN
C
  110 WRITE  (NOUT,120) UIM,NAME1,NAME2
  120 FORMAT (A29,' 6229, SUBSTRUCTURE ',2A4,' HAS BEEN RENAMED TO ',
     1        2A4)
      ITEST = 1
      RETURN
C
C     ERROR RETURNS
C
C
C     SUBSTRUCTURE NAME2 ALREADY EXIST ON THE SOF
C
 1000 WRITE  (NOUT,1010) UWM,NAME1,NAME2
 1010 FORMAT (A25,' 6230, SUBSTRUCTURE ',2A4,' HAS NOT BEEN RENAMED ',
     1       'BECAUSE ',2A4,' ALREADY EXISTS ON THE SOF.')
      ITEST = 10
      RETURN
C
C     SUBSTRUCTURURE NAME1 DOES NOT EXIST
C
 1100 ITEST = 4
      RETURN
C
C     DIT FORMAT ERROR
C
 1200 CALL ERRMKN (21,5)
C
C     INSUFFICIENT CORE TO HOLD ITEM
C
 1300 CALL SOFCLS
      CALL MESAGE (-8,0,NAMSUB)
      RETURN
      END

      SUBROUTINE IFTE2(THA,RP,CP)
      DATA THAO,EPSI /.1,1.E-9 /
      IF(ABS(THA) .LT. THAO ) GO TO 100
      D = .5* THA*THA
      RP = (1. - COS(THA))/D
      CP = (THA - SIN(THA))/D
      RETURN
C
C     EVALUATE SERIES
C
  100 CONTINUE
      RN = 1.0
      D = 1.0
      SIGN = -1.
      RPS = 1.0
      TSQ = THA*THA
      T1=3.
      T2=4.
      IT = 1
  101 CONTINUE
      DO 110 I=1,50
      RN = RN*TSQ
      D = D*T1*T2
      TRM = RN/D*SIGN
      RPS = RPS+TRM
      IF(ABS(TRM) .LT. EPSI) GO TO 120
      SIGN = -SIGN
      T1 = T1+2.
      T2 = T2+2.
  110 CONTINUE
  120 CONTINUE
      IF(IT .EQ. 2) GO TO 125
      RP = RPS
      RN = THA
      D = 3.0
      SIGN = -1.
      RPS = THA/3.
      T1 = 4.
      T2 = 5.
      IT = 2
      GO TO 101
  125 CONTINUE
      CP = RPS
      RETURN
      END

      SUBROUTINE MPY3OC (Z,IZ,DZ)
C
C     OUT-OF-CORE PRODUCT.
C
      LOGICAL          FIRST1,FIRST2,FIRST3,E
      INTEGER          FILEA,FILEE,FILEC,CODE,PREC,SCR1,SCR2,SCR3,FILE,
     1                 BUF1,BUF2,BUF3,BUF4,SYSBUF,ZPNTRS,EOL,EOR,PRECM,
     2                 TYPIN,TYPOUT,ROW1,ROWM,UTYP,UROW1,UROWN,UINCR,
     3                 BUF5,SIGNAB,SIGNC
      DOUBLE PRECISION DZ(1),DA
      DIMENSION        Z(1),IZ(1),NAME(2),NAMS(2)
C
C     MPYAD COMMON
      COMMON /MPYADX/  MFILEA(7),MFILEB(7),MFILEE(7),MFILEC(7),MCORE,
     1                 MT,SIGNAB,SIGNC,MPREC,MSCR
C
C     FILES
      COMMON /MPY3TL/  FILEA(7),FILEB(7),FILEE(7),FILEC(7),SCR1,SCR2,
     1                 SCR,LKORE,CODE,PREC,LCORE,SCR3(7),BUF1,BUF2,
     2                 BUF3,BUF4,E
C
C     SUBROUTINE CALL PARAMETERS
      COMMON /MPY3CP/  DUM1(2),N,NCB,M,NK,D,MAXA,ZPNTRS(22),LAEND,
     1                 FIRST1,FIRST2,K,K2,KCOUNT,IFLAG,KA,LTBC,J,LTAC
C
C     PACK
      COMMON /PACKX /  TYPIN,TYPOUT,ROW1,ROWM,INCR
C
C     UNPACK
      COMMON /UNPAKX/  UTYP,UROW1,UROWN,UINCR
C
C     TERMWISE MATRIX READ
      COMMON /ZNTPKX/  A(2),DUM(2),IROW,EOL,EOR
C
C     SYSTEM PARAMETERS
      COMMON /SYSTEM/  SYSBUF,NOUT
      EQUIVALENCE      (ISAVP,ZPNTRS(1)),  (NSAVP,ZPNTRS(2)),
     1                 (INTBU,ZPNTRS(3)),  (NNTBU,ZPNTRS(4)),
     2                 (ILAST,ZPNTRS(5)),  (NLAST,ZPNTRS(6)),
     3                 (INTBU2,ZPNTRS(7)), (NNTBU2,ZPNTRS(8)),
     4                 (IC,ZPNTRS(9)),     (NC,ZPNTRS(10)),
     5                 (IBCOLS,ZPNTRS(11)),(NBCOLS,ZPNTRS(12)),
     6                 (IBCID,ZPNTRS(13)), (NBCID,ZPNTRS(14)),
     7                 (IBNTU,ZPNTRS(15)), (NBNTU,ZPNTRS(16)),
     8                 (IKTBP,ZPNTRS(17)), (NKTBP,ZPNTRS(18)),
     9                 (IANTU,ZPNTRS(19)), (NANTU,ZPNTRS(20)),
     O                 (IAKJ,ZPNTRS(21)),  (NAKJ,ZPNTRS(22)),
     1                 (A(1),DA)
      DATA    NAME  /  4HMPY3,4HOC   /
      DATA    NAMS  /  4HSCR3,4H     /
C
C     RECALCULATION OF NUMBER OF COLUMNS OF B ABLE TO BE PUT IN CORE.
C
      BUF5  = BUF4 - SYSBUF
      LCORE = BUF5 - 1
      NK = (LCORE - 4*N - PREC*M - (2 + PREC)*MAXA)/(2 + PREC*N)
      IF (NK .LT. 1) GO TO 5008
C
C    INITIALIZATION.
C
      FIRST1 = .TRUE.
      FIRST2 = .TRUE.
      FIRST3 = .FALSE.
      PRECM  = PREC*M
C
C     OPEN CORE POINTERS
C
      ISAVP  = 1
      NSAVP  = NCB
      INTBU  = NSAVP + 1
      NNTBU  = NSAVP + NCB
      ILAST  = NNTBU + 1
      NLAST  = NNTBU + NCB
      INTBU2 = NLAST + 1
      NNTBU2 = NLAST + NCB
      IC     = NNTBU2 + 1
      NC     = NNTBU2 + PREC*M
      IBCOLS = NC + 1
      NBCOLS = NC + PREC*N*NK
      IBCID  = NBCOLS + 1
      NBCID  = NBCOLS + NK
      IBNTU  = NBCID + 1
      NBNTU  = NBCID + NK
      IKTBP  = NBNTU + 1
      NKTBP  = NBNTU + MAXA
      IANTU  = NKTBP + 1
      NANTU  = NKTBP + MAXA
      IAKJ   = NANTU + 1
      NAKJ   = NANTU + PREC*MAXA
      KF     = NSAVP
      KL     = NNTBU
      KN2    = NLAST
      KBC    = NBCOLS
      KBN    = NBCID
      KT     = NBNTU
      KAN    = NKTBP
C
C     PACK PARAMETERS
C
      TYPIN = PREC
      TYPOUT= PREC
      ROW1  = 1
      INCR  = 1
C
C     UNPACK PARAMETERS
C
      UTYP  = PREC
      UROW1 = 1
      UINCR = 1
C
C     MATRIX TRAILERS
C
      CALL MAKMCB (SCR3,SCR3(1),N,2,PREC)
      IF (M .EQ. N) SCR3(4) = 1
C
C     PUT B ONTO SCRATCH FILE IN UNPACKED FORM.
C
      CALL MPY3A (Z,Z,Z)
C
C     OPEN FILES AND CHECK EXISTENCE OF MATRIX E.
C
      IF (CODE.EQ.0 .OR. .NOT.E) GO TO 15
      FILE = FILEE(1)
      CALL OPEN (*5001,FILEE,Z(BUF5),2)
      CALL FWDREC (*5002,FILEE)
   15 FILE = FILEA(1)
      CALL OPEN (*5001,FILEA,Z(BUF1),0)
      CALL FWDREC (*5002,FILEA)
      FILE = SCR1
      CALL OPEN (*5001,SCR1,Z(BUF2),0)
      FILE = SCR2
      CALL OPEN (*5001,SCR2,Z(BUF3),1)
      IF (CODE .EQ. 0) GO TO 20
      FILE = FILEC(1)
      CALL GOPEN (FILEC,Z(BUF4),1)
      ROWM = FILEC(3)
      GO TO 30
   20 FILE = SCR3(1)
      CALL OPEN (*5001,SCR3,Z(BUF4),1)
      CALL WRITE (SCR3,NAMS,2,1)
      ROWM = SCR3(3)
C
C     PROCESS SCR2 AND SET FIRST-TIME-USED AND LAST-TIME-USED FOR EACH
C     ROW OF A.
C
   30 DO 40 K = 1,NCB
      IZ(KF+K) = 0
   40 IZ(KL+K) = 0
      DO 90 J = 1,M
      K = 0
      CALL INTPK (*80,FILEA,0,PREC,0)
   50 CALL ZNTPKI
      K = K + 1
      IZ(KT+K) = IROW
      IF (IZ(KF+IROW) .GT. 0) GO TO 60
      IZ(KF+IROW) = J
   60 IZ(KL+IROW) = J
      IF (EOL .EQ. 1) GO TO 70
      GO TO 50
   70 CALL WRITE (SCR2,IZ(IKTBP),K,0)
   80 CALL WRITE (SCR2,0,0,1)
   90 CONTINUE
      CALL CLOSE (FILEA,1)
      CALL OPEN (*5001,FILEA,Z(BUF1),2)
      CALL FWDREC (*5002,FILEA)
      CALL CLOSE (SCR2,1)
      CALL OPEN (*5001,SCR2,Z(BUF3),0)
C
C     PROCESS COLUMNS OF A ONE AT A TIME.
C
      DO 360 J = 1,M
C
C     INITIALIZE SUM - ACCUMULATION MATRIX TO 0.
C
      DO 100 I = IC,NC
  100 Z(I) = 0.
      IF (CODE.EQ.0 .OR. .NOT.E) GO TO 105
      UROWN = N
      CALL UNPACK (*105,FILEE,Z(IC))
C
C     PROCESS A AND PERFORM FIRST PART OF PRODUCT BA(J).
C
  105 CALL MPY3B (Z,Z,Z)
C
C     TEST IF PROCESSING IS COMPLETE
C
      IF (IFLAG .EQ. 0) GO TO 340
C
C     PROCESS REMAINING TERMS OF COLUMN J OF A.
C
C     TEST IF BCOLS IS FULL
C
  110 IF (K2 .LT. NK) GO TO 330
C
C     CALCULATE NEW NEXT TIME USED VALUES
C
      IF (FIRST3) GO TO 130
      FIRST2 = .FALSE.
      FIRST3 = .TRUE.
      DO 120 JJ = 1,J
  120 CALL FWDREC (*5002,SCR2)
  130 FILE = SCR2
      KC = 0
      KN = KF
      DO 170 KA = 1,NCB
      KN = KN + 1
      IF (J .GE. IZ(KN)) GO TO 140
      KC = KC + 1
      IF (J+1 .LT. IZ(KN   )) GO TO 135
      IF (J+1 .LT. IZ(KL+KA)) GO TO 160
      IZ(KN2+KA) = 99999999
      GO TO 136
  135 IZ(KN2+KA) = IZ(KN)
  136 KC = KC + 1
      GO TO 170
  140 IF (J .LT. IZ(KL+KA)) GO TO 150
      IZ(KN) = 99999999
      IZ(KN2+KA) = IZ(KN)
      KC = KC + 2
      GO TO 170
  150 IZ(KN    ) = 0
  160 IZ(KN2+KA) = 0
  170 CONTINUE
      IF (KC .EQ. 2*NCB) GO TO 240
      JJ = J + 1
  180 CALL READ (*5002,*210,SCR2,KA,1,0,KK)
      IF (IZ(KN2+KA) .GT. 0) GO TO 180
      IF (JJ .EQ. J+1) GO TO 190
      IZ(KN2+KA) = JJ
      KC = KC + 1
  190 IF (IZ(KF+KA) .GT. 0) GO TO 200
      IZ(KF+KA) = JJ
      KC = KC + 1
  200 IF (KC .EQ. 2*NCB) GO TO 220
      GO TO 180
  210 JJ = JJ + 1
      GO TO 180
  220 MM = M - 1
      IF (J .EQ. MM) GO TO 290
C
C     POSITION SCRATCH FILE FOR NEXT PASS THROUGH
C
      JJ  = JJ - J
      J2  = J  + 2
      JJ1 = JJ - 1
      IF (J2 .LT. JJ1) GO TO 250
      IF (JJ1 .GT.  0) GO TO 270
  230 CALL FWDREC (*5002,SCR2)
      GO TO 290
  240 IF (J .EQ. M) GO TO 290
      GO TO 230
  250 CALL REWIND (SCR2)
      J1 = J + 1
      DO 260 JFWD = 1,J1
  260 CALL FWDREC (*5002,SCR2)
      GO TO 290
  270 DO 280 JBCK = 1,JJ1
  280 CALL BCKREC (SCR2)
C
C     ASSIGN NEXT TIME USED TO COLUMNS OF B IN CORE
C
  290 DO 300 KK = 1,NK
      I = IZ(KBC+KK)
  300 IZ(KBN+KK) = IZ(KF+I)
C
C     ASSIGN NEXT TIME USED TO NON-ZERO TERMS IN COLUMN OF A
C
      DO 320 KK = 1,K
      IF (IZ(KT+KK) .EQ. 0) GO TO 310
      I = IZ(KT+KK)
      IZ(KAN+KK) = IZ(KF+I)
      GO TO 320
  310 IZ(KAN+KK) = 0
  320 CONTINUE
C
C     PERFORM MULTIPLICATION AND SUMMATION FOR NEXT TERM OF COLUMN OF A
C
  330 CALL MPY3C (Z,Z,Z)
C
C     TEST IF PROCESSING OF BA(J) IS COMPLETE
C
      IF (KCOUNT .EQ. K) GO TO 340
      IF (FIRST2) GO TO 110
      IZ(KBN+LTBC) = IZ(KN2+LTAC)
      GO TO 330
C
C     PACK COLUMN OF C OR BA.
C
  340 IF (CODE .EQ. 0) GO TO 350
      CALL PACK (Z(IC),FILEC,FILEC)
      GO TO 360
  350 CALL PACK (Z(IC),SCR3,SCR3)
  360 CONTINUE
C
C     CLOSE FILES.
C
      CALL CLOSE (FILEA,2)
      CALL CLOSE (SCR1,1)
      CALL CLOSE (SCR2,1)
      IF (.NOT.E) GO TO 369
      CALL CLOSE (FILEE,2)
  369 IF (CODE .EQ. 0) GO TO 370
      CALL CLOSE (FILEC,1)
      GO TO 9999
  370 CALL CLOSE (SCR3,1)
      CALL WRTTRL (SCR3)
C
C     CALL MPYAD TO FINISH PRODUCT
C
      DO 380 I = 1,7
      MFILEA(I) = FILEA(I)
      MFILEB(I) = SCR3(I)
      MFILEE(I) = FILEE(I)
  380 MFILEC(I) = FILEC(I)
      MT     = 1
      SIGNAB = 1
      SIGNC  = 1
      MPREC  = PREC
      MSCR   = SCR1
      CALL MPYAD (Z,Z,Z)
      GO TO 9999
C
C     ERROR MESSAGES.
C
 5001 NERR = -1
      GO TO 6000
 5002 NERR = -2
      GO TO 6000
 5008 NERR = -8
      FILE = 0
 6000 CALL MESAGE (NERR,FILE,NAME)
C
 9999 RETURN
      END

      SUBROUTINE STRI32
C
C     ROUTINE TO RECOVER CTRIA3 ELEMENT FORCES, STRAINS, AND STRESSES.
C     PHASE 2.
C
C     WAS NAMED T3ST2D/S (DISP) IN UAI CODE
C
C     ALGORITHM:
C
C     1- STRAIN RECOVERY DATA IS SENT BY PHASE 1 THRU PH1OUT IN /SDR2X7/
C        WHICH INCLUDES ALL THE NECESSARY TRANSFORMATIONS AND STRAIN
C        RECOVERY MATRICES. A MAJOR PORTION OF THE DATA IS REPEATED FOR
C        EACH STRESS EVALUATION POINT.
C     2- GLOBAL DISPLACEMENT VECTOR, WHICH RESIDES IN CORE, IS PASSED TO
C        THE ROUTINE THRU THE CALLING SEQUENCE.
C     3- NSTROP IN /SDR2C1/ CONTAINS THE STRESS OUTPUT REQUEST OPTION
C        FOR THE CURRENT SUBCASE.
C     4- WORD 151 OF /SDR2DE/ CONTAINS THE STRAIN OUTPUT REQUEST OPTION
C        FOR THE CURRENT SUBCASE (NEPSOP).
C     5- ELEMENT/GRID POINT TEMPERATURE DATA ENTERS THE ROUTINE THRU
C        /SDR2DE/ (POSITIONS 97-129.)
C     6- ELEMENT STRAINS ARE CALCULATED, CORRECTED FOR THERMAL STRAINS,
C        AND PREMULTIPLIED BY [G].
C
C
C     *****************       RESIDES IN COMMON BLOCK /SDR2X7/
C     PH1OUT DATA BLOCK       TOTAL NO. OF WORDS =  713
C     *****************
C
C     PH1OUT( 1)    = ELID, ELEMENT ID
C     PH1OUT( 2- 4) = SIL NUMBERS
C     PH1OUT( 5- 7) = ARRAY IORDER
C     PH1OUT( 8)    = TSUB0, REFERENCE TEMP.
C     PH1OUT( 9-10) = Z1 AND Z2, FIBER DISTANCES
C     PH1OUT(11)    = ID OF THE ORIGINAL PCOMPI PROPERTY ENTRY
C     PH1OUT(12)    = DUMMY WORD (FOR ALLIGNMENT)
C
C     PH1RST( 1)    = AVGTHK, AVERAGE THICKNESS
C     PH1RST( 2)    = MOMINR, MOMENT OF INER. FACTOR
C     PH1RST( 3-38) = 6X6 MATERIAL PROPERTY (NO SHEAR)
C     PH1RST(39-41) = THERMAL EXPANSION COEFFICIENTS FOR MEMBRANE
C     PH1RST(42-44) = THERMAL EXPANSION COEFFICIENTS FOR BENDING
C     PH1RST(45-47) = NODAL   THICKNESSES
C     PH1RST(48)    = OFFSET OF ELEMENT FROM GP PLANE
C     PH1RST(49-57) = 3X3 USER-TO-MATERIAL COORD. TRANSF. MATRIX, UEM
C     PH1RST(58-66) = 3X3 ELEM-TO-STRSS/STRAIN  TRANSF. TENSOR, TES
C     PH1RST(67-93) = 3X3 GLOBAL-TO-ELEM COORD. TRANSF. MATRICES, TEG,
C                     ONE FOR EACH NODE
C
C     THE FOLLOWING IS REPEATED FOR EACH EVALUATION POINT (4 TIMES).
C     THE EVALUATION POINTS ARE AT THE CENTER OF THE ELEMENT AND
C     STANDARD TRIANGULAR POINTS. THE CHOICE OF THE FINAL STRESS/
C     FORCE OUTPUT POINTS IS MADE AT THE SUBCASE LEVEL (PHASE 2).
C
C              1             ELEMENT THICKNESS AT THIS POINT
C            2 - 5           OUT-OF-PLANE-SHEAR-FORCE/STRAIN MATRIX
C            6 - 8           ELEMENT SHAPE FUNCTION VALUES
C          8+1 - 8+8*NDOF    STRAIN RECOVERY MATRIX
C
C
      EXTERNAL        ANDF
      LOGICAL         COMPOS,STSREQ,STNREQ,FORREQ,TEMPER,TEMPP1,TEMPP2,
     1                GRIDS ,VONMS ,LAYER ,BENDNG,STRCUR,
     2                GRIDSS,VONMSS,LAYERS
CWKBI NCL93012 3/94
      LOGICAL         OSTRAI
      INTEGER         ELID,CENTER,EXTRNL,
     1                FLAG,COMPS,ANDF,LDTEMP,DEVICE,OES1L,OEF1L,OES1AL
      REAL            G(6,6),ALFAM(3),ALFAB(3),GPTH(3),STEMP(8)
CWKBR NCL93012 3/94 COMMON /BLANK / APP(2),SORT2,IDUM(2),COMPS 
      COMMON /BLANK / APP(2),SORT2,IDUM(2),COMPS, SKP(4), OSTRAI 
      COMMON /ZZZZZZ/ DISP(1)
      COMMON /SDR2X2/ DUMM(30),OES1L,OEF1L
      COMMON /SDR2X4/ DUMMY(35),IVEC,IVECN,LDTEMP
C    1,               DUM(13),KTYPE
      COMMON /SDR2C1/ IPCMP,NPCMP,IPCMP1,NPCMP1,IPCMP2,NPCMP2,NSTROP
      COMMON /SDR2DE/ KSDRDE(200)
      COMMON /SDR2X7/ ELID,KSIL(3),IORDER(3),TSUB0,Z1O,Z2O,IPID,
     1                IDUMAL,PH1RST(701)
      COMMON /SDR2X8/ EXTRNL(6),IGRID(4),IDR(3),INDXG2(3,3),THIKNS(4),
     1                Z12(2,4),DELTA(39),DELTAT(6),TDELTA(6),G2(3,3),
     2                U(36),STEMPD(3),EPSLN(8),EPSLNM(6),EPSLNT(6),
     3                VXVY(2),EPSCSI(6,4),EPSUSI(6,4),QVECI(2,4),
     4                EPSCMI(6,4),EPSUMI(6,4),TES(9),UES(9),VES(4),
     5                UEM(9),G2ALFB(3,4),
     6                GDUM,DETG2,T3OV12,OFFSET,TBAR
      COMMON /OUTREQ/ STSREQ,STNREQ,FORREQ,STRCUR,GRIDS,VONMS,LAYER,
     1                GRIDSS,VONMSS,LAYERS
      COMMON /TMPDAT/ TEMPER,TEMPP1,TEMPP2
      EQUIVALENCE     (IZ1O,Z1O),(IZ2O,Z2O),
     1                (AVGTHK,PH1RST(1)),(MOMINR,PH1RST(2)),
     2                (G(1,1),PH1RST(3)),(ALFAM(1),PH1RST(39)),
     3                (ALFAB(1),PH1RST(42)),(GPTH(1),PH1RST(45)),
     4                (DEVICE,KSDRDE(2)),(NEPSOP,KSDRDE(151)),
     5                (KSTRS,KSDRDE(42)),(KSTRN ,KSDRDE(142)),
     6                (KFORC,KSDRDE(41)),(STEMP(1),KSDRDE(97)),
     7                (STEMP(7),FLAG)   ,(OES1AL,OES1L)
      DATA    ISTART/ 93    /
      DATA    CENTER/ 4HCNTR/
      DATA    NBLNK / 4HBLNK/
C
C     INITIALIZE
C
C     NNODE  = TOTAL NUMBER OF NODES
C     NDOF   = TOTAL NUMBER OF DEGREES OF FREEDOM
C     LDTEMP = FLAG INDICATING THE PRESENCE OF TEMPERATURE LOADS
C     ICOUNT = POINTER FOR PH1RST DATA
C
C     STRCUR = STRAIN/CURVATURE OUTPUT REQUEST FLAG
C
      NNODE  = 3
      NDOF   = 6*NNODE
      NDOF8  = 8*NDOF
      TEMPER = LDTEMP .NE. -1
      BENDNG = MOMINR .GT. 0.0
C
C     CHECK FOR OFFSET AND COMPOSITES
C
      OFFSET = PH1RST(48)
      COMPOS = COMPS.EQ.-1 .AND. IPID.GT.0
C
C     CHECK THE OUTPUT STRESS FORCE AND STRAIN REQUESTS
C
      STSREQ = KSTRS .EQ. 1
      FORREQ = KFORC .EQ. 1
      STNREQ = KSTRN .EQ. 1
C
C     STRESS OUTPUT REQUEST FLAGS
C
C     GRIDS = ANDF(NSTROP, 1).NE.0
C     VONMS = ANDF(NSTROP, 8).NE.0
C     LAYER = ANDF(NSTROP,32).NE.0 .AND. COMPOS .AND. KTYPE.EQ.1
C
      GRIDS = .FALSE.
      VONMS = ANDF(NSTROP,1) .NE. 0
      LAYER = ANDF(NSTROP,2) .NE. 0
C
C     STRAIN OUTPUT REQUEST FLAGS
C
C     GRIDSS = ANDF(NEPSOP,  1).NE.0 .AND. STNREQ
C     VONMSS = ANDF(NEPSOP,  8).NE.0 .AND. STNREQ
C     LAYERS = ANDF(NEPSOP, 32).NE.0 .AND. COMPOS .AND. KTYPE.EQ.1
C     STRCUR = ANDF(NEPSOP,128).NE.0 .AND. STNREQ
C
      GRIDSS = .FALSE.
      VONMSS = .FALSE.
      LAYERS = .FALSE.
      STRCUR = .FALSE.
CWKBNB NCL93012 3/94
      STNREQ = OSTRAI
      STRCUR = OSTRAI
CWKBNE NCL93012 3/94
C
C     IF USER ERRONEOUSLY REQESTS LAYERED OUTPUT AND THERE ARE NO LAYER-
C     COMPOSITE DATA, SET LAYER FLAGS TO FALSE
C
      IF (NPCMP+NPCMP1+NPCMP2 .GT. 0) GO TO 10
      LAYER  = .FALSE.
      LAYERS = .FALSE.
      GO TO 20
C
C     USER CORRECTLY REQUESTS LAYERED OUTPUT, BUT CURRENT ELEMENT IS NOT
C     A LAYER-COMPOSITE; SET LAYER FLAGS TO FALSE
C
   10 IF (IPID .GT. 0) GO TO 20
      LAYER  = .FALSE.
      LAYERS = .FALSE.
C
C     SET DEFAULTS FOR FORCE IF STRESS ABSENT
C
   20 IF (.NOT.FORREQ .OR. NSTROP.NE.0) GO TO 30
      LAYER = .FALSE.
C
C     CHECK FOR THE TYPE OF TEMPERATURE DATA (SET BY SDRETD)
C     - TYPE TEMPP1 ALSO INCLUDES TYPE TEMPP3.
C     - IF TEMPPI ARE NOT SUPPLIED, GRID POINT TEMPERATURES ARE PRESENT.
C
   30 TEMPP1 = FLAG .EQ. 13
      TEMPP2 = FLAG .EQ.  2
C
C     GET THE EXTERNAL GRID POINT ID NUMBERS FOR CORRESPONDING SIL NOS.
C
C     CALL FNDGID (ELID,3,KSIL,EXTRNL)
C
      DO 40 I = 1,NNODE
   40 EXTRNL(I) = 0
C
C     COMMENTS FROM G.C.  2/1990
C     EXTRNL ARE SET TO ZEROS HERE. IT IS USED LATER FOR SETTING IDR
C     ARRAY. BOTH EXTRNL AND IDR ARE USED ONLY WHEN GRIDS IS TRUE.
C     IN COSMIC VERSION, GRIDS IS FALSE.
C
C
C     PREPARE TO REARRANGE STRESSES, STRAINS, AND FORCES ACCORDING TO
C     EXTERNAL ORDER
C
      IF (.NOT.GRIDS .AND. .NOT.GRIDSS) GO TO 70
      DO 60 INPL = 1,3
      DO 50 I = 1,NNODE
      IF (IORDER(I) .NE. INPL) GO TO 50
      IDR(INPL) = EXTRNL(I)
      GO TO 60
   50 CONTINUE
   60 CONTINUE
      GO TO 80
   70 IDR(1) = 1
      IDR(2) = 2
      IDR(3) = 3
C
C     ARRANGE THE INCOMING DATA
C
C     SORT THE GRID TEMPERATURE CHANGES INTO SIL ORDER
C
   80 IF (.NOT.TEMPER .OR. (TEMPP1 .AND. TEMPP2)) GO TO 100
      DO 90 K = 1,NNODE
      KPOINT = IORDER(K)
      DELTAT(K) = STEMP(KPOINT)
   90 CONTINUE
C
C     PICK UP THE GLOBAL DISPLACEMENT VECTOR AND TRANSFORM IT INTO THE
C     ELEMENT COORD. SYSTEM
C
  100 DO 120 IDELT = 1,NNODE
      JDELT = IVEC + KSIL(IDELT) - 2
      KDELT = 6*(IDELT-1) + 1
      DO 110 LDELT = 1,6
      TDELTA(LDELT) = DISP(JDELT+LDELT)
  110 CONTINUE
C
C     FETCH [TEG] 3X3 FOR EACH NODE, LOAD IT INTO A 6X6 MATRIX AND
C     INCLUDE THE EFFECTS OF OFFSET
C
      CALL TLDRS  (OFFSET,IDELT,PH1RST(67),U)
      CALL GMMATS (U,6,6,0, TDELTA,6,1,0, DELTA(KDELT))
  120 CONTINUE
C
C     RECOVER THE STRESS-TO-ELEMENT ORTHOGONAL TRANSFORMATION AND BUILD
C     THE ELEMENT-TO-STRESS 'STRAIN' TENSOR TRANSFORMATION.
C     IF LAYER OUTPUT IS REQUESTED, STRAINS MUST BE TRANSFORMED TO THE
C     MATERIAL COORDINATE SYSTEM.
C
      DO 130 I = 1,9
      UEM(I) = PH1RST(48+I)
      TES(I) = PH1RST(57+I)
  130 CONTINUE
      CALL SHSTTS (TES,UES,VES)
C
C     RECOVER STRAINS AT EVALUATION POINTS
C
C     THE ARRANGEMENT OF EVALUATION POINTS ON THE MID-SURFACE FOLLOWS
C     THE SEQUENCE OF GRID POINTS AS INPUT BY THE USER. THEREFORE,
C     SHUFFLING OF DATA IS ONLY REQUIRED TO MATCH THE USER-DEFINED ORDER
C     OF INPUT.
C
C     PRESET THE PH1RST COUNTER TO THE START OF THE REPEATED SECTION
C     WHICH WILL NOW BE FILLED.
C
      ICOUNT = ISTART
C
      DO 500 INPLAN = 1,4
C
C     MATCH GRID ID NUMBER WHICH IS IN SIL ORDER
C
      IGRID(INPLAN) = CENTER
      IF (INPLAN .LE. 1) GO TO 210
      DO 200 I = 1,NNODE
      IF (IORDER(I) .NE. INPLAN-1) GO TO 200
      IGRID(INPLAN) = EXTRNL(I)
  200 CONTINUE
C
C     THICKNESS AND MOMENT OF INERTIA AT THIS POINT
C
  210 THIKNS(INPLAN) = PH1RST(ICOUNT+1)
      IF ((GRIDS .OR. GRIDSS) .AND. INPLAN.NE.1)
     1     THIKNS(INPLAN) = GPTH(INPLAN-1)
      T3OV12 = THIKNS(INPLAN)**3/12.0
C
C     DETERMINE FIBER DISTANCE VALUES
C
      Z12(1,INPLAN) = Z1O
      IF (IZ1O .EQ. NBLNK) Z12(1,INPLAN) =-0.5*THIKNS(INPLAN)
C
      Z12(2,INPLAN) = Z2O
      IF (IZ2O .EQ. NBLNK) Z12(2,INPLAN) = 0.5*THIKNS(INPLAN)
C
C
C     FIRST COMPUTE LOCAL STRAINS UNCORRECTED FOR THERMAL STRAINS AT
C     THIS EVALUATION POINT.
C
C     EPSLN = PH1RST(KSIG) * DELTA
C       EPS =        B     *   U
C       8X1        8XNDOF    NDOFX1
C
      CALL GMMATS (PH1RST(ICOUNT+9),8,NDOF,0, DELTA(1),NDOF,1,0, EPSLN)
C
      IF (.NOT.LAYER .AND. .NOT.LAYERS) GO TO 230
C
C     TRANSFORM UNCORRECTED STRAINS FROM ELEMENT TO MATERIAL COORD.
C     SYSTEM TO BE USED FOR ELEMENT LAYER STRAINS
C
      CALL GMMATS (UEM(1),3,3,0, EPSLN(1),3,1,0, EPSUMI(1,INPLAN))
      CALL GMMATS (UEM(1),3,3,0, EPSLN(4),3,1,0, EPSUMI(4,INPLAN))
C
      DO 220 I = 1,6
      EPSCMI(I,INPLAN) = EPSUMI(I,INPLAN)
  220 CONTINUE
C
  230 IF (.NOT.FORREQ .AND. LAYER .AND. LAYERS) GO TO 250
C
C     TRANSFORM UNCORRECTED STRAINS FROM ELEMENT TO STRESS COORD. SYSTEM
C     TO BE USED FOR ELEMENT STRAINS
C
      CALL GMMATS (UES(1),3,3,0, EPSLN(1),3,1,0, EPSUSI(1,INPLAN))
      CALL GMMATS (UES(1),3,3,0, EPSLN(4),3,1,0, EPSUSI(4,INPLAN))
C
      DO 240 I = 1,6
      EPSCSI(I,INPLAN) = EPSUSI(I,INPLAN)
  240 CONTINUE
C
C     IF REQUIRED, COMPUTE SHEAR FORCES AT THIS EVALUATION POINT IN THE
C     ELEMENT COORD. SYSTEM, THEN TRANSFORM AND STORE THEM. CONSULT
C     SHSTTS DOCUMENTATION ON WHY [VES] MAY BE USED TO TRANSFORM FORCES
C     DESPITE THE FACT THAT IT IS MEANT FOR STRAINS.
C     SHEAR STRAINS MAY NOT BE TRANSFORMED BEFORE MULTIPLICATION BECAUSE
C     [G3] IS DIRECTION-DEPENDENT.
C
  250 IF (.NOT.(FORREQ .OR. LAYER .OR. LAYERS)) GO TO 260
      CALL GMMATS (PH1RST(ICOUNT+2),2,2,0, EPSLN(7),2,1,0, VXVY)
      CALL GMMATS (VES(1),2,2,0, VXVY,2,1,0, QVECI(1,INPLAN))
C
C     CALCULATE THERMAL STRAINS IF TEMPERATURES ARE PRESENT
C
  260 IF (.NOT.TEMPER) GO TO 420
      DO 270 IET = 1,6
      EPSLNT(IET) = 0.0
  270 CONTINUE
C
C     MEMBRANE STRAINS
C
      IF (.NOT.TEMPP1 .AND. .NOT.TEMPP2) GO TO 280
      TBAR = STEMP(1)
      GO TO 300
  280 TBAR = 0.0
      DO 290 ISH = 1,NNODE
      TBAR = TBAR + PH1RST(ICOUNT+5+ISH)*DELTAT(ISH)
  290 CONTINUE
C
  300 DO 310 IEPS = 1,3
      EPSLNT(IEPS) = (TBAR-TSUB0)*ALFAM(IEPS)
  310 CONTINUE
C
C     BENDING STRAINS (ELEMENT TEMPERATURES ONLY)
C
      IF (.NOT.BENDNG .OR. .NOT.(TEMPP1 .AND. TEMPP2)) GO TO 390
C
C     EXTRACT [G2] FROM [G]
C
      DO 330 IG2 = 1,3
      DO 320 JG2 = 1,3
      G2(IG2,JG2) = G(IG2+3,JG2+3)
  320 CONTINUE
  330 CONTINUE
      CALL GMMATS (G2,3,3,0, ALFAB,3,1,0, G2ALFB(1,INPLAN))
C
      IF (.NOT.TEMPP2) GO TO 370
      DO 350 IG2 = 1,3
      DO 340 JG2 = 1,3
      G2(IG2,JG2) = G2(IG2,JG2)*T3OV12
  340 CONTINUE
  350 CONTINUE
C
      DO 360 ITMP = 1,3
      STEMPD(ITMP) = STEMP(ITMP+1)
  360 CONTINUE
C
      CALL INVERS (3,G2,3,GDUM,0,DETG2,ISNGG2,INDXG2)
      CALL GMMATS (G2,3,3,0, STEMPD,3,1,0, EPSLNT(4))
      GO TO 390
C
  370 IF (.NOT.TEMPP1) GO TO 390
      TPRIME = STEMP(2)
      DO 380 IEPS = 4,6
      EPSLNT(IEPS) = -TPRIME*ALFAB(IEPS-3)
  380 CONTINUE
  390 CONTINUE
C
C     CORRECT STRAINS FOR THERMAL EFFECTS
C
      DO 400 I = 1,6
      EPSLNM(I) = EPSLN(I) - EPSLNT(I)
  400 CONTINUE
C
      IF (.NOT.LAYER) GO TO 410
C
C     TRANSFORM CORRECTED STRAINS FROM ELEMENT TO MATERIAL COOR. SYSTEM
C     TO BE USED FOR ELEMENT LAYER STRESSES
C
      CALL GMMATS (UEM(1),3,3,0, EPSLNM(1),3,1,0, EPSCMI(1,INPLAN))
      CALL GMMATS (UEM(1),3,3,0, EPSLNM(4),3,1,0, EPSCMI(4,INPLAN))
C
  410 IF (LAYER .AND. .NOT.FORREQ) GO TO 420
C
C     TRANSFORM CORRECTED STRAINS FROM ELEMENT TO STRESS COORD. SYSTEM
C     TO BE USED FOR ELEMENT STRESSES AND ELEMENT (LAYER) FORCES
C
      CALL GMMATS (UES(1),3,3,0, EPSLNM(1),3,1,0, EPSCSI(1,INPLAN))
      CALL GMMATS (UES(1),3,3,0, EPSLNM(4),3,1,0, EPSCSI(4,INPLAN))
C
C     CORRECT THE CURVATURE SIGNS WHEN THE Z-AXIS OF THE TARGET STRESS
C     COORD. SYSTEM IS FLIPPED WITH RESPECT TO THE USER COORD. SYSTEM.
C     THIS DOES NOT AFFECT THE MEMBRANE STRAINS, AND TRANSVERSE SHEAR
C     STRAIN TRANSFORMATION TAKES CARE OF THOSE COMPONENTS.
C
  420 IF (PH1RST(66) .GE. 0.0) GO TO 440
      DO 430 I = 4,6
      EPSCMI(I,INPLAN) = -EPSCMI(I,INPLAN)
      EPSCSI(I,INPLAN) = -EPSCSI(I,INPLAN)
      EPSUMI(I,INPLAN) = -EPSUMI(I,INPLAN)
      EPSUSI(I,INPLAN) = -EPSUSI(I,INPLAN)
  430 CONTINUE
C
C     END OF THE STRAIN RECOVERY LOOP
C
C     INCREMENT THE PH1RST POINTER
C
  440 ICOUNT = ICOUNT + 8 + NDOF8
  500 CONTINUE
C
C
C     IF REQUIRED, EXTRAPOLATE NON-CENTER VALUES FROM EVALUATION POINTS
C     TO GRID POINTS.
C
      IF (GRIDSS) CALL SHXTRS (6,NNODE,EPSUSI(1,2))
      IF (GRIDS ) CALL SHXTRS (6,NNODE,EPSCSI(1,2))
      IF (GRIDS .AND. FORREQ) CALL SHXTRS (2,NNODE,QVECI(1,2))
C
C     CALCULATE AND OUTPUT STRESSES
C
      IF (STSREQ .AND. .NOT.LAYER)
     1    CALL SHSTSS (4,ELID,IGRID,THIKNS,Z12,G,EPSCSI,STEMP,TBAR,
     2                 G2ALFB,BENDNG,IDR)
C
C     CALCULATE AND OUTPUT STRAINS
C
      IF (STNREQ .AND. .NOT.LAYERS)
     1    CALL SHSTNS (4,ELID,IGRID,Z12,EPSUSI,BENDNG,IDR)
C
C     CALCULATE AND OUTPUT FORCES
C
      IF (FORREQ .OR. LAYER .OR. LAYERS)
     1   CALL SHFORS (4,ELID,IGRID,THIKNS,G,EPSCSI,QVECI,IDR)
C
C     CALCULATE AND OUTPUT LAYER-RELATED INFORMATION
C
      IF (LAYER .OR. LAYERS)
     1   CALL SHLSTS (ELID,IPID,AVGTHK,EPSUMI,EPSCMI)
C
      RETURN
      END

      SUBROUTINE X TRN  Y1(X,Y,ALPHA1)
C     SUBROUTINE X TRNS Y (X,Y,ALPHA)
C*******
C     X TRNS Y  FORMS THE DOT PRODUCT X TRANSPOSE * Y = ALPHA
C*******
C     DOUBLE PRECISION   X(1)      ,Y(1)     ,ALPHA
      DOUBLE PRECISION ALPHA1
      REAL X(1) , Y(1)
      COMMON   /INVPWX/  AAA       ,NCOL
      ALPHA = 0.0
      DO 10 I=1,NCOL
   10 ALPHA = ALPHA + X(I)*Y(I)
      ALPHA1 = ALPHA
      RETURN
      END

      SUBROUTINE LAMX
C
C     LAMX MAKES OR EDITS THE LAMA DATA BLOCK
C
C     LAMX  EDIT,LAMA/LAMB/C,Y,NLAM=0 $
C     IF NLAM LT 0 MAKE LAMB A MATRIX OF 5 COLUMNS
C     LAMA  OMEGA FREQ GM GS
C     UNTIL GM = 0.0
C
C
      INTEGER SYSBUF,IST(10),TRL(7),BUFA,BUFB,BUFE,EDIT
C
      DIMENSION D(3),Z(7)
C
      COMMON /BLANK / NLAM
      COMMON /ZZZZZZ/ IZ(1)
      COMMON /SYSTEM/ SYSBUF,NOUT
      COMMON /CONDAS/ PI,TWOPI
      COMMON /UNPAKX/ ITO,II,IE,INCR
      COMMON /PACKX / ITYIN,ITYOUT,III,NNN,INCR1
      COMMON /OUTPUT/ HDG(96)
C
      EQUIVALENCE     (D(1),A),(D(2),B),(D(3),C)
      EQUIVALENCE     (Z(1),IZ(1))
C
      DATA    EDIT  , LAMA,LAMB /101,102,201/
      DATA    IST   / 21,6,7*0,7/
      DATA    LMA   / 1/,   IED /1/,  IZ2 /2/
      DATA    NAM   / 4HLAMX    /
C
C     INITILIZE AND DECIDE MODE OF OPERATIONS
C
      ICORE  = KORSZ(Z)
      TRL(1) = LAMA
      CALL RDTRL (TRL)
      IF (TRL(1) .LT. 0) LMA = 0
      TRL(1) = EDIT
      CALL RDTRL (TRL)
      IF (TRL(1) .LT. 0) IED = 0
      NCOL = TRL(2)
      IF (NCOL .EQ. 0) IED = 0
      IF (LMA.EQ.0 .AND. IED.EQ.0) GO TO 1000
      ITO = 1
      II  = 1
      INCR= 1
      IE  = TRL(3)
      IF (IE .GT. 3) IE = 3
      B = 0.0
      C = 0.0
      BUFB = ICORE - SYSBUF
      CALL GOPEN (LAMB,Z(BUFB),1)
      IF (LMA .EQ. 0) GO TO 200
      BUFA = BUFB - SYSBUF
      CALL GOPEN (LAMA,Z(BUFA),0)
      IF (NLAM .LT. 0) GO TO 500
      BUFE = BUFA - SYSBUF
      IF (IED .EQ. 0) GO TO 5
C
C      EDITING LAMA FROM EDIT
C
      CALL GOPEN (EDIT,Z(BUFE),0)
C
C     WRITE HEADER
C
    5 CALL READ (*10,*10,LAMA,Z,BUFE,1,NWR)
   10 CALL WRITE (LAMB,Z,NWR,1)
      IF (IED .EQ. 0) GO TO 100
C
C     MAKE RECORDS
C
      J = 0
      DO 50 I = 1,NCOL
      CALL READ (*60,*60,LAMA,Z,7,0,NWR)
      CALL UNPACK (*40,EDIT,D)
      IF (A.EQ.0.0 .AND. B.EQ.0.0 .AND. C.EQ.0.0) GO TO 40
      IF (C .LT. 0.0) GO TO 50
      Z(5) = Z(5)*(1.0+B) + A
      Z(4) = Z(5)*TWOPI
      Z(3) = Z(4)*Z(4)
      IF (C .NE. 0.0) Z(6) = C
      Z(7) = Z(6)*Z(3)
   40 J    = J+1
      IZ(1)= J
      IF (NLAM .LE. 0) GO TO 45
      IF (J .GT. NLAM) GO TO 180
   45 CALL WRITE (LAMB,Z,7,0)
   50 CONTINUE
   60 GO TO 180
C
C     COPY LAMA TO LAMB FOR NLAM RECORDS
C
  100 IF (NLAM .EQ. 0) GO TO 190
      J = NLAM
      M = 7*NLAM
      CALL READ (*180,*110,LAMA,Z,M,0,NWR)
      CALL WRITE (LAMB,Z,7*NLAM,0)
      GO TO 180
  110 CALL WRITE (LAMB,Z,NWR,0)
  180 TRL(1) = LAMB
      TRL(2) = J
      CALL WRTTRL (TRL)
  190 CALL CLOSE (LAMA,1)
      CALL CLOSE (LAMB,1)
      CALL CLOSE (EDIT,1)
      GO TO 1000
C
C      MAKE A NEW LAMB
C
  200 BUFE = BUFB - SYSBUF
      CALL GOPEN (EDIT,Z(BUFE),0)
      IF (NLAM .GT. 0) NCOL = MIN0(NCOL,NLAM)
C
C     WRITE HEADER
C
      CALL WRITE (LAMB,IST,50,0)
      CALL WRITE (LAMB,HDG,96,1)
C
C     MAKE RECORDS
C
      DO 220 I = 1,NCOL
      CALL UNPACK (*310,EDIT,D)
      GO TO 210
  310 D(1) = 0.0
      D(2) = 0.0
      D(3) = 0.0
  210 IZ(  1) = I
      IZ(IZ2) = I
      Z(5) = A
      Z(4) = TWOPI*A
      Z(3) = Z(4)*Z(4)
      Z(6) = C
      Z(7) = C*Z(3)
      CALL WRITE (LAMB,Z,7,0)
  220 CONTINUE
      J = NCOL
      GO TO 180
C
C     BUILD LAMB AS A MATRIX
C
  500 TRL(1) = LAMB
      TRL(2) = 0
      TRL(4) = 1
      TRL(5) = 1
      TRL(6) = 0
      TRL(7) = 0
      ITYIN  = 1
      ITYOUT = 1
      III    = 1
      INCR1  = 7
      CALL FWDREC (*190,LAMA)
      CALL READ (*190,*510,LAMA,Z,BUFA,0,NWR)
      CALL MESAGE (8,0,NAM)
      GO TO 190
  510 NLOOP = 0
      DO 520 I = 1,NWR,7
      IF (Z(I+5) .EQ.0.0) GO TO 530
      NLOOP = NLOOP +1
  520 CONTINUE
  530 IF (NLOOP .EQ. 0) GO TO 190
      TRL(3) = NLOOP
      NNN = NLOOP
      L   = 3
      DO 540 I = 1,5
      CALL PACK (Z(L),LAMB,TRL)
      L = L + 1
  540 CONTINUE
      CALL WRTTRL (TRL)
      GO TO 190
 1000 RETURN
      END

      SUBROUTINE SSG1A (N1,ILIST,NEDT,NTEMP,NCENT,CASECC,IHARM)
C
C     ROUTINE ANALIZES CASECC AND SLT TO BUILD LISTS OF SELECTED
C     LOADS
C
      INTEGER         SYSTEM,SLT,BGPDT,CSTM,SIL,ECPT,MPT,GPTT,EDT,
     1                CASECC,CORE(138),NAME(2),NAME1(2),ILIST(1),
     2                IDEFML(1080),ITEMPL(1080),ICOMB(1080)
      COMMON /LOADX / LC,SLT,BGPDT,OLD,CSTM,SIL,ISIL,ECPT,MPT,GPTT,EDT,
     1                N(3),LODC,MASS,NOBLD
      COMMON /BLANK / NROWSP,LOADNN
      COMMON /SYSTEM/ SYSTEM,NOUT,DUM53(53),ITHERM
      COMMON /ZZZZZZ/ ICORE(1)
      EQUIVALENCE     (ICORE(1),CORE(1))
      DATA    NAME  / 4HSSG1,4HA   /
      DATA    NAME1 / 4HSLT ,4HSSG1/
C
C
C     INITIALIZE.
C
      NEDT  = 0
      NTEMP = 0
      NCENT = 0
      IFOUND= 0
      N1    = 0
      LC1   = LC - SYSTEM
      ISLT  = 0
      CALL OPEN (*20,SLT,CORE(LC1+1),0)
      ISLT = 1
      CALL READ (*320,*10,SLT,ILIST(1), -2,0,N1)
      CALL READ (*320,*10,SLT,ILIST(1),LC1,1,N1)
C
C     ALLOW FOR 360 LOADS
C
   10 IF (N1 .LE. 360) GO TO 12
      NAME(2) = N1
      CALL MESAGE (-30,137,NAME)
   12 LC1   = LC1 - SYSTEM
      LLIST = N1
   20 CALL OPEN (*350,CASECC,CORE(LC1+1),0)
      IONE  = 0
      DO 30 I = 1,LOADNN
   30 CALL FWDREC (*350,CASECC)
      IFRST = 0
   40 CALL READ (*110,*350,CASECC,CORE(1),166,1,FLAG)
      IF (IFRST .NE. 0) GO TO 41
      IFRST = 1
      ISPCN = CORE(3)
      MPCN  = CORE(2)
C
C     TEST FOR SYMMETRY BUCKLING, OR DIFFERENTIAL STIFFNESS
C
   41 IF (CORE(16).NE.0 .OR. CORE(5).NE.0 .OR. CORE(138).NE.0) GO TO 40
      IF (CORE(2).NE.MPCN .OR. CORE(3).NE.ISPCN) GO TO 110
      IHARM  = CORE(136)
      IONE   = 1
      IF (CORE(6) .EQ. 0) GO TO 50
C
C     SEE IF EL DEFORM LOAD ALREADY APPLIED
C
      IF (NEDT .EQ. 0) GO TO 52
      DO 51 I = 1,NEDT
      IF (IDEFML(I) .EQ. CORE(6)) GO TO 50
   51 CONTINUE
C
C     ADD TO LIST
C
   52 CONTINUE
      NEDT = NEDT + 1
      IDEFML(NEDT) = CORE(6)
   50 IF (CORE(7) .EQ. 0) GO TO 60
C
C     SEE IF TEMP LOAD ALREADY APPLIED
C
      IF (ITHERM .NE. 0) GO TO 60
      IF (NTEMP  .EQ. 0) GO TO 54
      DO 53 I = 1,NTEMP
      IF (ITEMPL(I) .EQ. CORE(7)) GO TO 60
   53 CONTINUE
   54 CONTINUE
      NTEMP = NTEMP + 1
      ITEMPL(NTEMP) = CORE(7)
   60 IF (CORE(4) .EQ. 0) GO TO 40
      IF (ISLT .EQ. 0) CALL MESAGE (-31,CORE(4),NAME1)
      IF (N1   .EQ. 0) GO TO 90
      DO 80 I = 1,N1
      IF (CORE(4) .EQ. IABS(ILIST(I))) GO TO 100
   80 CONTINUE
C
C     MUST LOOK AT LOAD CARDS
C
   90 IFOUND = IFOUND + 1
      ICOMB(IFOUND) = CORE(4)
      GO TO 40
  100 ILIST (I) = -IABS(ILIST(I))
      GO TO 40
  110 CALL CLOSE (CASECC,1)
      IF (IONE  .EQ. 0) GO TO 360
      IF (NTEMP .EQ. 0) GO TO 130
      DO 120 I = 1,NTEMP
      J = N1 + I
  120 ILIST(J) = ITEMPL (I)
  130 IF(NEDT .EQ. 0) GO TO 150
      DO 140 I = 1,NEDT
      J = N1 + NTEMP + I
  140 ILIST(J) = IDEFML(I)
  150 IF (IFOUND .EQ. 0) GO TO 270
C
C     LOOK AT LOAD CARDS
C
      DO 180 I = 1,N1
      CALL FWDREC (*320,SLT)
  180 CONTINUE
      I = 1
      NOGO = 0
      CALL READ (*370,*190,SLT,CORE(1),LC1,1,IFLAG)
  190 LLIST = N1 + NEDT + NTEMP
      IF (LLIST .EQ. 0) GO TO 370
      DO 260 I = 1,IFOUND
      J = 1
  200 IF (ICOMB(I) .EQ. CORE(J)) GO TO 220
      J = J + 6
  210 IF (J-1 .GT. IFLAG) GO TO 255
      IF (CORE(J-1) .EQ. -1) GO TO 200
      J = J + 2
      GO TO 210
  220 J = J + 3
  230 IF (CORE(J) .EQ. -1) GO TO 260
      DO 250 K = 1,LLIST
      IF (CORE(J) .NE. IABS(ILIST(K))) GO TO 250
      ILIST(K) = -IABS(ILIST(K))
      J = J + 2
      GO TO 230
  250 CONTINUE
  255 CALL MESAGE (31,ICOMB(I),NAME1)
      NOGO = 1
  260 CONTINUE
      IF (NOGO .NE. 0) GO TO 390
  270 IF (ISLT .NE. 0) CALL CLOSE (SLT,1)
      IF (N1 .EQ. 0) GO TO 310
      DO 300 I = 1,N1
      IF (ILIST (I)) 290,300,280
  280 ILIST (I) = 0
      GO TO 300
  290 ILIST (I) = -ILIST(I)
  300 CONTINUE
  310 RETURN
C
C     ERROR MESSAGES.
C
  320 IP1 = SLT
  330 IP2 = -1
      CALL MESAGE (IP2,IP1,NAME)
  350 IP1 = CASECC
      GO TO 330
  360 WRITE  (NOUT,365)
  365 FORMAT ('0*** MISSING LOAD CARD IN CASE CONTROL')
      CALL MESAGE (-7,0,NAME)
  370 IP2 = 31
      DO 380 I = 1,IFOUND
      IP1 = ICOMB(I)
      CALL MESAGE (IP2,IP1,NAME1)
  380 CONTINUE
  390 CALL MESAGE (-61,0,NAME)
      RETURN
C
      END

      SUBROUTINE PRELOC (*,BUF,FILE)
C
C     PRELOC OPENS AND POSITIONS REQUESTED FILE TO FIRST DATA RECORD.
C     LOCATE POSITIONS FILE TO REQUESTED DATA RECORD WITHIN FILE.
C
      EXTERNAL        ANDF
      INTEGER         BUF(2),FILE  ,NAM(2),TRL(7),NM1(2),FLAG  ,ANDF  ,
     1                TWO   ,RET   ,BFF(1),ID(2) ,FLG
      COMMON /TWO   / TWO(32)
      DATA    NAM   ,        NM1          /
     1        4HPREL, 4HOC  ,4HLOCA,4HTE  /
C
C     OPEN FILE. IF PURGED, GIVE ALTERNATE RETURN.
C     OTHERWISE SKIP HEADER RECORD
C
      TRL(1) = FILE
      CALL RDTRL (TRL)
      IF (TRL(1) .LT. 0) GO TO 10
      IF (TRL(2)+TRL(3)+TRL(4)+TRL(5)+TRL(6)+TRL(7) .EQ. 0) GO TO 10
      CALL OPEN (*10,FILE,BUF(2),0)
      CALL FWDREC (*2,FILE)
      BUF(1) = FILE
      ICHECK = 123456789
      RETURN
   10 RETURN 1
C
C     FATAL FILE ERRORS
C
    2 CALL MESAGE (-2,FILE,NAM)
    3 CALL MESAGE (-3,TRL,NM1)
C
C
      ENTRY LOCATE (*,BFF,ID,FLG)
C     ===========================
C
C     ENTRY TO POSITION DATA RECORD.
C
C     READ TRAILER FOR FILE. IF BIT NOT ON OR FILE PURGED,
C     GIVE ALTERNATE RETURN.
C
CWKBD IF (ICHECK .NE. 123456789) CALL ERRTRC ('LOCATE  ',10)
      TRL(1) = BFF(1)
      CALL RDTRL (TRL)
      IF (TRL(1) .LT. 0) RETURN 1
      K = (ID(2)-1)/16
      L =  ID(2)- 16*K
      IF (ANDF(TRL(K+2),TWO(L+16)) .EQ. 0) RETURN 1
C
C     READ THREE ID WORDS FROM DATA RECORD.
C     IF END-OF-FILE, REPOSITION FILE TO FIRST DATA RECORD AND RETRY.
C     IF ID WORD MATCHES USER, RETURN.
C
      LAST = 0
      ASSIGN 20 TO RET
   20 CALL READ (*50,*20,TRL(1),TRL(2),3,0,FLAG)
      IF (TRL(2) .NE. ID(1)) GO TO 22
      FLG = TRL(4)
      RETURN
C
C     SKIP RECORD. READ ID WORDS FROM NEXT RECORD. IF MATCH,RETURN.
C     IF END-OF FILE, REPOSITION TO FIRST DATA RECORD AND RETRY.
C     IF NO MATCH, TEST FOR RETURN TO ORIGINAL FILE POSITION. IF SO,
C     QUEUE MESSAGE AND GIVE ALTERNATE RETURN. IF NOT, CONTINUE SEARCH.
C
   22 ASSIGN 30 TO RET
   25 CALL FWDREC (*2,TRL(1))
   30 CALL READ (*50,*3,TRL(1),TRL(5),3,0,FLAG)
      IF (TRL(5) .NE. ID(1)) GO TO 32
      FLG = TRL(7)
      RETURN
C
   32 IF (TRL(5) .NE. TRL(2)) GO TO 25
   35 CALL SSWTCH (40,J)
CWKBD IF (J .NE. 0) CALL ERRTRC ('LOCATE  ',35)
      CALL MESAGE (30,72,ID)
      CALL FWDREC (*2,TRL(1))
      RETURN 1
C
C     CODE TO POSITION FILE TO FIRST DATA RECORD.
C
   50 CALL REWIND (TRL(1))
      IF (LAST .NE. 0) GO TO 35
      LAST = 1
      CALL FWDREC (*2,TRL(1))
      GO TO RET, (20,30)
      END

      SUBROUTINE INTERT (NL,NL1,NL2,NM,AJJ,TA)
C
      DIMENSION AJJ(1),TA(1)
C
      T1 = TA(NL1)
      T2 = TA(NL2)
      T  = TA(NL)
      N1 = NM *(NL1-1)
      N2 = NM *(NL2-1)
      N  = NM*(NL -1)
      FRACT = (T-T1) / (T2 -T1)
      DO 100 I=1,NM
  100 AJJ(I+N) = AJJ(I+N1) + FRACT *(AJJ(I+N2) - AJJ(I+N1))
      RETURN
      END

      SUBROUTINE TTORDR (TI, PG)
C
C
C*****
C THIS ROUTINE COMPUTES THE THERMAL LOAD FOR AN AXI-SYMMETRIC
C TOROIDAL THIN SHELL RING
C*****
C
C
C
C                        ECPT FOR THE TOROIDAL RING
C
C                                                       TYPE
C ECPT( 1) ELEMENT IDENTIFICATION                         I
C ECPT( 2) SCALAR INDEX NO. FOR GRID POINT A              I
C ECPT( 3) SCALAR INDEX NO. FOR GRID POINT B              I
C ECPT( 4) ANGLE OF CURVATURE AT GRID POINT A             R
C ECPT( 5) ANGLE OF CURVATURE AT GRID POINT B(NOT USED)   R
C ECPT( 6) MATERIAL ORIENTATION (NOT USED)                R
C ECPT( 7) MATERIAL IDENTIFICATION                        I
C ECPT( 8) MEMBRANE THICKNESS                             R
C ECPT( 9) FLEXURE THICKNESS                              R
C ECPT(10) COOR. SYS. ID. FOR GRID POINT A                I
C ECPT(11) X-COOR. OF GRID POINT A (IN BASIC COOR.)       R
C ECPT(12) Y-COOR. OF GRID POINT A (IN BASIC COOR.)       R
C ECPT(13) Z-COOR. OF GRID POINT A (IN BASIC COOR.)       R
C ECPT(14) COOR. SYS. ID. FOR GRID POINT B                I
C ECPT(15) X-COOR. OF GRID POINT B (IN BASIC COOR.)       R
C ECPT(16) Y-COOR. OF GRID POINT B (IN BASIC COOR.)       R
C ECPT(17) Z-COOR. OF GRID POINT B (IN BASIC COOR.)       R
C ECPT(18) EL. TEMPERATURE FOR MATERIAL PROPERTIES        R
C
C
      DIMENSION          TI(2),    PG(1)
      DIMENSION          IECPT(18)
      DIMENSION          GAMBQF(72),    GAMBQM(48)
      DIMENSION          EE(4), GAMBQ(144), GAMRS(144)
      DIMENSION          AKI(36),  DELINT(42)
      DIMENSION          IGP(2),   ICS(2)
      DIMENSION          GAMBL(144)
      DIMENSION          D( 36),   R(2),     Z(2),     ALPH(2)
      DIMENSION          FME(40),  FFE(40),  TL(12)
C
      COMMON /CONDAS/ CONSTS(5)
      COMMON   /TRIMEX/
     1                   ECPT(18)
      COMMON   /MATIN/
     1                   MATIDC        ,MATFLG
     2,                  ELTEMP        ,STRESS
     3,                  SINTH         ,COSTH
      COMMON   /MATOUT/
     1                   E(3)          ,ANU(3)
     2,                  RHO           ,G(3)
     3,                  ALF(3)        ,TZERO,    GSUBE
C
      EQUIVALENCE ( CONSTS(2) , TWOPI  )
      EQUIVALENCE ( CONSTS(4) , DEGRA  )
      EQUIVALENCE        (IECPT(1) , ECPT(1))
      EQUIVALENCE        (A1, ALPH(1)), (A2, ALPH(2))
      EQUIVALENCE        (R1, R(1)),    (R2, R(2))
      EQUIVALENCE        (Z1, Z(1)),    (Z2, Z(2))
      EQUIVALENCE        (GAMBQM(1), GAMBQ(1))
      EQUIVALENCE        (GAMBQF(1), GAMBQ(49))
      EQUIVALENCE        (DELINT(1), GAMBQ(1))
      EQUIVALENCE        (FME(1),    GAMBQ(43))
      EQUIVALENCE        (FFE(1),    GAMBQ(83))
      EQUIVALENCE        (GAMRS(1),  GAMBQ(1))
      EQUIVALENCE        (AKI(1),    GAMBQ(1))
      EQUIVALENCE        (GAMBL(1), GAMBQ(1))
C
C ----------------------------------------------------------------------
C
C STORE ECPT PARAMETERS IN LOCAL VARIABLES
C
      IDEL   = IECPT(1)
      IGP(1) = IECPT(2)
      IGP(2) =  IECPT(3)
      MATID  =  IECPT(7)
      ICS(1) =  IECPT(10)
      ICS(2) =  IECPT(14)
      ALPH(1)=  ECPT(4)
      ALPH(2)=  ECPT(5)
      TM     =  ECPT(8)
      TF     =  ECPT(9)
      R(1)   =  ECPT(11)
      D(1)   =  ECPT(12)
      Z(1)   =  ECPT(13)
      R(2)   =  ECPT(15)
      D(2)   =  ECPT(16)
      Z(2)   =  ECPT(17)
      TEMPE  =  ECPT(18)
C
C
C TEST THE VALIDITY OF THE GRID POINT COORDINATES
C
      DO 200 I = 1,2
      IF (R(I) .LT. 0.0E0) CALL MESAGE(-30,37,IDEL)
      IF (D(I) .NE. 0.0E0) CALL MESAGE(-30,37,IDEL)
  200 CONTINUE
C
C
C DETERMINE IF ELEMENT IS A TOROIDAL, CONICAL OR CYLINDRICAL RING
C
      ITORD = 0
      IF (ABS(A1-A2) .LE. .000001) ITORD = 1
      IF (ITORD .EQ. 1  .AND.  ABS(A1-90.0E0) .LE. .00001) ITORD = -1
C
C
C COMPUTE THE ELEMENT COORDINATES
C
      A1 = A1 * DEGRA
      A2 = A2 * DEGRA
      PHIB = A2 - A1
      SINA1 =  SIN(A1)
      COSA1 =  COS(A1)
      SINA2 =  SIN(A2)
      COSA2 =  COS(A2)
C
      IF (ITORD .NE. 0) GO TO 300
C
C FOR THE TOROIDAL RING
C
      RP =  SQRT( (R2-R1)**2 + (Z2-Z1)**2 )
     1      / (2.0E0 *  SIN(PHIB/2.0E0))
      S = PHIB * RP
      GO TO 350
C
C FOR THE CONICAL OR CYLINDRICAL RING
C
  300 CONTINUE
      RP = 0.0D0
      S  =  SQRT( (R2-R1)**2 + (Z2-Z1)**2 )
C
  350 CONTINUE
C
C
C COMPUTE THE BASIC AND REQUIRED INTEGRALS
C
C
C SET UP ARRAY OF CONSTANTS FOR ROMBER INTEGRATION ROUTINE
C
      D(21) = 0.0E0
      D(22) = RP
      D(23) = R1
      D(24) = COSA1
      D(25) = SINA1
C
C COMPUTE CONSTANTS NEEDED FOR INTEGRAL CALCULATIONS
C
      D(30) = R1 - RP * SINA1
      D(31) = RP * COSA1
      D(32) = RP * SINA1
      D(33) = COSA1 ** 2
      D(34) = SINA1 * COSA1
      D(35) = SINA1 ** 2
      D(36) = 0.5 - D(35)
C
C START LOOP  FOR CALCULATIONS OF INTEGRALS
C
      DO 500 JP1 = 1,7
      J = JP1 - 1
      K = (J * 6) + 1
      DJP1 = JP1
C
C TEST FOR ELEMENT SHAPE
C
      IF (ITORD) 470,400,430
C
C THE TOROIDAL RING BASIC INTEGRALS WILL BE COMPUTED IN
C LOCATIONS D(1),...,D(6)
C
  400 CONTINUE
      D(20) = (RP ** JP1)
C
C COMPUTE I(J,1)
C
      D(1) = D(20) * (PHIB ** JP1) / DJP1
C
C COMPUTE I(J,2)
C
      D(2) = (PHIB ** (JP1+1)) / (DJP1 + 1.0E0)
      D(10) = 1.0E0
      DO 410 I = 1,20
      IP = JP1 + 2 * I + 1
      D(11) = 2 * I + 1
      D(10) = D(10) * D(11) * (D(11)-1.0E0)
      D(12) = (-1.0E0)** I  * PHIB ** IP
     1        / ((DJP1 + D(11)) * D(10))
      D(13) =  ABS( D(12) / D(2) )
      D(2) = D(2) + D(12)
      IF (D(13) .LE. 1.0E-10) GO TO 415
  410 CONTINUE
      CALL MESAGE(-30,26,IDEL)
  415 CONTINUE
      D(2) = D(20) * D(2)
C
C COMPUTE I(J,3)
C
      D(3) = (PHIB ** JP1) / DJP1
      D(10) = 1.0E0
      DO 420 I = 1,20
      IP = JP1 + 2 * I
      D(11) = 2 * I
      D(10) = D(10) * D(11) * (D(11) - 1.0E0)
      D(12) = (-1.0E0)** I  * PHIB ** IP
     1        / ((DJP1 + D(11)) * D(10))
      D(13) =  ABS( D(12) / D(3) )
      D(3) = D(3) + D(12)
      IF (D(13) .LE. 1.0E-10) GO TO 425
  420 CONTINUE
      CALL MESAGE(-30,26,IDEL)
  425 CONTINUE
      D(3) = D(20) * D(3)
      D(26) = DJP1
C
C COMPUTE I(J,4)
C
      CALL ROMBER (PHIB, D(10), IP, D(4), 1, D(21) )
      IF (IP .GE. 15) CALL MESAGE (30,26,IDEL)
      D(4) = D(20) * D(4)
C
C COMPUTE I(J,5)
C
      CALL ROMBER (PHIB, D(10), IP, D(5), 2, D(21) )
      IF (IP .GE. 15) CALL MESAGE (30,26,IDEL)
      D(5) = D(20) * D(5)
C
C COMPUTE I(J,6)
C
      CALL ROMBER (PHIB, D(10), IP, D(6), 3, D(21) )
      IF (IP .GE. 15) CALL MESAGE (30,26,IDEL)
      D(6) = D(20) * D(6)
C
C THE TOROIDAL RING REQUIRED INTEGRALS
C
      DELINT(K  ) = D(30) * D(1) + D(31) * D(2) + D(32) * D(3)
      DELINT(K+1) = COSA1 * D(2) + SINA1 * D(3)
      DELINT(K+2) = D(33) * D(4) + D(34) * D(5) + D(35) * D(6)
      DELINT(K+3) = COSA1 * D(3) - SINA1 * D(2)
      DELINT(K+4) = D(34) * (D(6)-D(4))  + D(36) * D(5)
      DELINT(K+5) = D(33) * D(6) - D(34) * D(5) + D(35) * D(4)
      GO TO 490
C
C THE CONICAL RING BASIC INTEGRALS WILL BE COMPUTED IN
C LOCATIONS D(1) AND D(2)
C
  430 CONTINUE
C
C COMPUTE I(J,1)
C
      D(1) = (S ** JP1) / DJP1
C
      IF (J - 1) 435,440,445
C
C COMPUTE I(0,2)
C
  435 CONTINUE
      D(2) = ALOG( (R1 + S*COSA1) / R1 ) / COSA1
      GO TO 460
C
C COMPUTE I(1,2)
C
  440 CONTINUE
      D(2) = (S - (R1/COSA1) * ALOG( (R1 + S*COSA1) / R1 )) / COSA1
      GO TO 460
C
C COMPUTE I(J,2) WHERE J .GT. 1
C
  445 CONTINUE
      D(2) = 1.0E0 / DJP1
      D(10) =-S * COSA1 / R1
      DO 450 I = 1,1000
      D(11) = JP1 + I
      D(12) = (D(10) ** I) / D(11)
      D(2) = D(2) + D(12)
      IF (D(12) .LT. 1.0E-4 ) GO TO 455
  450 CONTINUE
      CALL MESAGE(-30,26,IDEL)
  455 CONTINUE
      D(2) = ( (S ** JP1) / R1 ) * D(2)
  460 CONTINUE
C
C THE CONICAL RING REQUIRED INTEGRALS
C
      DELINT(K  ) = R1 * D(1) + COSA1 * ((S**(JP1+1)) / (DJP1+1.0E0))
      DELINT(K+1) = SINA1 * D(1)
      DELINT(K+2) = D(35) * D(2)
      DELINT(K+3) = COSA1 * D(1)
      DELINT(K+4) = D(34) * D(2)
      DELINT(K+5) = D(33) * D(2)
      GO TO 490
C
C THE CYLINDRICAL RING BASIC INTEGRALS WILL BE COMPUTED IN
C LOCATIONS D(1) AND D(2)
C
  470 CONTINUE
C
C COMPUTE I(J,1)
C
      D(1) = (S ** JP1) / DJP1
C
C COMPUTE I(J,2)
C
      D(2) = D(1) / R1
C
C THE CYLINDRICAL RING REQUIRED INTEGRALS
C
      DELINT(K  ) = R1 * D(1) + COSA1 * ((S**(JP1+1)) / (DJP1+1.0E0))
      DELINT(K+1) = SINA1 * D(1)
      DELINT(K+2) = D(35) * D(2)
      DELINT(K+3) = 0.0E0
      DELINT(K+4) = 0.0E0
      DELINT(K+5) = 0.0E0
C
  490 CONTINUE
  500 CONTINUE
C
C
C LOCATE THE MATERIAL PROPERTIES IN THE MAT1 OR MAT3 TABLE
C
      MATIDC = MATID
      MATFLG = 7
      ELTEMP = TEMPE
      CALL MAT(IDEL)
C
C
C SET MATERIAL PROPERTIES IN LOCAL VARIABLES
C
      EP = E(1)
      ET = E(2)
      VPT= ANU(1)
      TZ = TZERO
      VTP= VPT * ET / EP
      DEL = 1.0E0 - VPT * VTP
C
C
C GENERATE THE ELASTIC CONSTANTS MATRIX(2X2)
C
      EE(1) = EP / DEL
      EE(2) = ET * VPT / DEL
      EE(3) = EE(2)
      EE(4) = ET / DEL
C
C
C CALL THE FCURL   SUBROUTINE TO FORM THE FOUR (2X10) MATRICES OF
C INTEGRALS (TRANSPOSED)
C
C COMPUTE CONSTANTS NEEDED IN FCURL  SUBROUTINE
C
      D(1) = 0.0E0
      IF (ITORD .EQ. 0) D(1) = 1.0E0 / RP
C
C NOTE THE DOUBLE SUBSCRIPTING USED IN  FCURL  SUBROUTINE IS
C COMPATIBLE WITH THE CALLING PROGRAM. THE DELINT ARRAY OF INTEGRALS
C IS A ( 7X6) SINGLY SUBSCRIPTED ARRAY (STORED ROWWISE) IN THE CALLING
C PROGRAM AND IT IS A (6X 7) DOUBLY SUBSCRIPTED ARRAY (STORED
C COLUMNWISE) IN FCURL  ROUTINE.
C
C
      CALL FCURL (FME(1), FME(21), FFE(1), FFE(21), DELINT(1), S, D(1))
C
      D(1) = TWOPI * TM
      D(2) = TWOPI * (TF **3) / 12.0E0
      DO 550 I = 1,40
      FME(I) = D(1) * FME(I)
      FFE(I) = D(2) * FFE(I)
  550 CONTINUE
C
C
C FORM THE THERMAL STRAINS
C
      DTM1 = TI(1) - TZ
      DTM2 = TI(2) - TI(1)
      DTF1 = 0.0E0
      DTF2 = 0.0E0
C
C THE TERMS DTF1 AND DTF2 ARE FUNCTIONS OF THE FLEXURAL GRADIENT
C TEMPERATURE BUT SINCE THESE TEMPERATURES ARE NOT AVAILABLE
C THE TERMS WILL BE SET TO ZERO. THEY ARE USUALLY DEFINED AS FOLLOWS,
C     DTF1 = TF(1) - TZ
C     DTF2 = TF(2) - TF(1)
C WHERE TF(1) AND TF(2) ARE THE FLEXURAL GRADIENT TEMPERATURES AT
C GRID POINTS 1 AND 2 RESPECTIVELY.
C
      D(1) = DTM1 * ALF(1)
      D(2) = DTM1 * ALF(2)
      D(3) = DTM2 * ALF(1)
      D(4) = DTM2 * ALF(2)
      D(5) = DTF1 * ALF(1)
      D(6) = DTF1 * ALF(2)
      D(7) = DTF2 * ALF(1)
      D(8) = DTF2 * ALF(2)
C
C
C FORM THE   THERMAL LOAD   IN FIELD COORDINATES
C
      CALL GMMATS (EE(1), 2, 2, 0, D(1), 2, 1, 0, D(11) )
      CALL GMMATS (EE(1), 2, 2, 0, D(3), 2, 1, 0, D(13) )
      CALL GMMATS (EE(1), 2, 2, 0, D(5), 2, 1, 0, D(15) )
      CALL GMMATS (EE(1), 2, 2, 0, D(7), 2, 1, 0, D(17) )
C
C
      CALL GMMATS (FME( 1),  2,10, 1, D(11), 2, 1, 0, TL(1) )
      CALL GMMATS (FME(21),  2,10,-1, D(13), 2, 1, 0, TL(1) )
      CALL GMMATS (FFE( 1),  2,10,-1, D(15), 2, 1, 0, TL(1) )
      CALL GMMATS (FFE(21),  2,10,-1, D(17), 2, 1, 0, TL(1) )
C
C
C FORM THE TRANSFORMATION MATRIX(10X12) FROM FIELD COORDINATES TO GRID
C POINT DEGREES OF FREEDOM
C
      DO 600 I = 1,72
      GAMBQF(I) = 0.0E0
  600 CONTINUE
      D(1) = S
      D(2) = S ** 2
      D(3) = S ** 3
      D(4) = S ** 4
      D(5) = S ** 5
      GAMBQF( 3) = 1.0E0
      GAMBQF(16) = 1.0E0
      GAMBQF(30) = 0.5E0
      GAMBQF(39) = -10.0E0 / D(3)
      GAMBQF(40) = - 6.0E0 / D(2)
      GAMBQF(42) = - 1.5E0 / D(1)
      GAMBQF(45) = -GAMBQF(39)
      GAMBQF(46) = - 4.0E0 / D(2)
      GAMBQF(48) =   0.5E0 / D(1)
      GAMBQF(51) =  15.0E0 / D(4)
      GAMBQF(52) =   8.0E0 / D(3)
      GAMBQF(54) =   1.5E0 / D(2)
      GAMBQF(57) = -GAMBQF(51)
      GAMBQF(58) =   7.0E0 / D(3)
      GAMBQF(60) = - 1.0E0 / D(2)
      GAMBQF(63) = - 6.0E0 / D(5)
      GAMBQF(64) = - 3.0E0 / D(4)
      GAMBQF(66) = - 0.5E0 / D(3)
      GAMBQF(69) = -GAMBQF(63)
      GAMBQF(70) =  GAMBQF(64)
      GAMBQF(72) = -GAMBQF(66)
      DO 650 I = 1,48
      GAMBQM(I) = 0.0E0
  650 CONTINUE
      GAMBQM( 1) = 1.0E0
      GAMBQM(17) = 1.0E0
      GAMBQM(25) = - 3.0E0 / D(2)
      GAMBQM(29) = - 2.0E0 / D(1)
      GAMBQM(31) = -GAMBQM(25)
      GAMBQM(35) = - 1.0E0 / D(1)
      GAMBQM(37) =   2.0E0 / D(3)
      GAMBQM(41) =   1.0E0 / D(2)
      GAMBQM(43) = -GAMBQM(37)
      GAMBQM(47) =  GAMBQM(41)
C
C
C TRANSFORM THE   THERMAL LOAD   TO GRID POINT DEGREES OF FREEDOM
C
      CALL GMMATS(GAMBQ(1), 10, 12, 1, TL(1), 10,  1, 0, D(1) )
C
C
C FORM THE TRANSFORMATION MATRIX (12X12) FROM ELEMENT TO BASIC
C COORDINATES
C
      DO 700 I = 1,144
      GAMRS(I) = 0.0E0
  700 CONTINUE
      GAMRS( 1) =  COSA1
      GAMRS( 3) = -SINA1
      GAMRS(25) =  SINA1
      GAMRS(27) =  COSA1
      GAMRS(40) = -1.0E0
      GAMRS(53) =  1.0E0
      GAMRS(66) =  1.0E0
      GAMRS(79) =  COSA2
      GAMRS(81) = -SINA2
      GAMRS(103)=  SINA2
      GAMRS(105)=  COSA2
      GAMRS(118)= -1.0E0
      GAMRS(131)=  1.0E0
      GAMRS(144)=  1.0E0
C
C
C
C TRANSFORM THE   THERMAL LOAD   FROM ELEMENT TO BASIC COORDINATES
C
      CALL GMMATS(GAMRS(1), 12, 12, 1,  D(1), 12,  1, 0, TL(1) )
C
C
C LOCATE THE TRANSFORMATION MATRICES FROM BASIC TO LOCAL COORDINATES
C FOR THE TWO GRID POINTS AND EXPAND TO (6X6)
C
      DO 730 I = 1,144
      GAMBL(I) = 0.0E0
  730 CONTINUE
      DO 800 I = 1,2
      CALL GBTRAN(ICS(I),ECPT(4*I+10),D(1))
      K = 78 * (I - 1)
      DO 750 J = 1,3
      KK = K + 12* (J-1) + 1
      KL = 3 * (J-1) + 1
      KJ = K + 12* (J+2) + J + 3
      GAMBL(KK  ) = D(KL  )
      GAMBL(KK+1) = D(KL+1)
      GAMBL(KK+2) = D(KL+2)
      GAMBL(KJ) = 1.0E0
  750 CONTINUE
  800 CONTINUE
C
C
C
C TRANSFORM THE   THERMAL LOAD   FROM BASIC TO LOCAL COORDINATES
C
      CALL GMMATS (GAMBL(1), 12, 12, 1, TL(1), 12,  1, 0, D(1) )
C
C
C
C ADD THE ELEMENT THERMAL LOAD TO THE STRUCTURE THERMAL LOAD
C
      K = 0
      DO 900 I = 1,2
      L = IGP(I) - 1
      DO 900 J = 1,6
      K = K + 1
      L = L + 1
      PG(L) = PG(L) +  D(K)
  900 CONTINUE
C
C
      RETURN
      END

      SUBROUTINE DIAGON
C
C     DMAP FUNCTIONAL MODULE
C
C     DIAGONAL  A / B / V,Y,OPT=COLUMN / V,Y,POWER $
C
C     INPUT  - A IS ANY MATRIX, EXCEPT RECTANGULAR AND ROW VECTOR
C            - OPT IS OUTPUT MATRIX TYPE V,Y FLAG
C            - POWER IS A VALUE TO WHICH THE REAL PART OF EACH ELEMENT
C              ON THE DIAGONAL OF A IS RAISED. (DEFAULT OF POWER IS 1.0)
C     OUTPUT - B IS A REAL SYMMETRIC MATRIX (OPT='SQUARE'), OR A COLUMN
C              VECTOR CONTAINING THE DIAGONAL OF A (OPT='COLUMN'), OR
C              A DIAGONAL MATRIX (OPT='DIAGONAL'
C
C     WRITTEN BY R. MITCHELL, CODE 324, GSFC, DECEMBER 7,1972
C
C     LAST MODIFIED BY G.CHAN/UNISYS   11/1991
C     TO MAKE SUERE  0.0**0 = 1.0, NOT 0.0
C
      INTEGER          SYSBUF,COL,SQ,IA(7),IB(7),NAME(2),OPT(2)
      DOUBLE PRECISION D(2),DVAL(2),DCORE(1)
      CHARACTER        UFM*23,UWM*25,UIM*29,SFM*25,SWM*27
      COMMON /XMSSG /  UFM,UWM,UIM,SFM,SWM
      COMMON /UNPAKX/  ITYPEU,IU,JU,INCRU
      COMMON /ZNTPKX/  A(4),II,LAST
      COMMON /ZBLPKX/  VAL(4),JROW
CZZ   COMMON /ZZDIAG/  CORE(1)
      COMMON /ZZZZZZ/  CORE(20000)
      COMMON /SYSTEM/  KSYSTM(60)
      COMMON /BLANK /  PARAM(3)
      EQUIVALENCE      (KSYSTM(1),SYSBUF), (KSYSTM(2),NOUT),
     1                 (IA(2),INCOL), (IA(3),INROW), (IA(4),IFORM),
     2                 (IA(5),ITYPE), (A(1),D(1)), (VAL(1),DVAL(1)),
     3                 (PARAM(1),OPT(1)), (PARAM(3),POWER),
     4                 (CORE(1), DCORE(1))
      DATA    COL,SQ/  4HCOLU,4HSQUA  /,  IN1,IOUT / 101,201 /
      DATA    NAME  /  4HDIAG,4HONAL  /
C
C
C     CHECK FOR VALID PARAMETER.
C
      IF (OPT(1).EQ.SQ .OR. OPT(1).EQ.COL .OR. OPT(1).EQ.NAME(1))
     1    GO TO 10
      WRITE  (NOUT,5) SWM,OPT
    5 FORMAT (A27,' 3300, INVALID PARAMETER ',2A4,
     1       ' SUPPLIED TO MODULE DIAGONAL, COLUMN SUBSTITUTED')
      OPT(1) = COL
C
C     GET INFO ON INPUT MATRIX
C
   10 IA(1) = IN1
      CALL RDTRL (IA)
C
C     CHECK FOR PURGED INPUT.
C
      IF (IA(1) .LT. 0) GO TO 210
C
C     CHECK FOR PROPER FORM OF MATRIX
C
      GO TO (20,220,20,20,20,20,220,200), IFORM
C
C     SET OUTPUT CONTROL BLOCK TO MATCH INPUT AND REQUESTS.
C
   20 IB4 = 6
      IF (OPT(1) .EQ. COL) IB4 = 2
      IF (OPT(1) .NE. NAME(1)) GO TO 25
      IB4 = 3
      OPT(1) = COL
   25 IB5 = 1
      IF (ITYPE.EQ.2 .OR. ITYPE.EQ.4) IB5 = 2
      CALL MAKMCB (IB,IOUT,INROW,IB4,IB5)
C
C     CHECK FOR SPECIAL CASES OF POWER PARAMETER.
C
C     CHECK FOR 1.0 = NO ARITHMETIC REQUIRED.
C
      IF (ABS(POWER-1.0)-1.0E-6) 30,30,40
   30 IPOW = 1
      GO TO 100
C
C     CHECK FOR 0.5 = SQUARE ROOT
C
   40 IF (ABS(POWER-0.5)-1.0E-6) 45,45,50
   45 IPOW = 2
      GO TO 100
C
C     CHECK FOR 2.0 = SQUARE
C
   50 IF (ABS(POWER-2.0)-1.0E-6) 55,55,60
   55 IPOW = 3
      GO TO 100
C
C     CHECK FOR 0.0 = IDENTITY MATRIX
C
   60 IF (POWER) 70,65,70
   65 IPOW = 4
      GO TO 100
C
C     GENERAL CASE
C
   70 IPOW = 5
C
C     DO OPEN CORE BOOKKEEPING
C
C     OBTAIN LENGTH OF OPEN CORE
C
  100 LCORE = KORSZ(CORE)
C
C     NEED ROOM FOR 2 GINO BUFFERS
C
      IF (LCORE .LT. 2*SYSBUF) GO TO 230
C
C     IF INPUT MATRIX IS A DIAGONAL MATRIX, NEED ADDITIONAL
C     ROOM FOR A FULL COLUMN
C
      IF (IFORM.EQ.3 .AND.
     1    LCORE.LT.(2*SYSBUF + IB(5)*INROW + 1)) GO TO 230
      IBUF = LCORE - SYSBUF + 1
C
C     OPEN INPUT FILE AND SKIP HEADER
C
      CALL GOPEN (IA,CORE(IBUF),0)
C
C     OPEN OUTPUT FILE AND WRITE HEADER
C
      NPREC = IB(5)
      IBUF  = IBUF - SYSBUF
      CALL GOPEN (IB,CORE(IBUF),1)
C
C     PRIME PACK ROUTINE IF COLUMN OUTPUT
C
      IF (OPT(1) .EQ. COL) CALL BLDPK (NPREC,NPREC,IOUT,0,0)
C
C     READ INPUT MATRIX AND SEARCH COLUMNS FOR DIAGONAL ELEMENTS.
C
      DO 180 NOWCOL = 1,INCOL
C
C     CHECK IF THE INPUT MATRIX IS A DIAGONAL MATRIX (IFORM = 3)
C
      IF (IFORM .NE. 3) GO TO 118
C
C     UNPACK THE FULL COLUMN OF THE INPUT DIAGONAL MATRIX
C
      ITYPEU = NPREC
      IU = 1
      JU = INROW
      INCRU = 1
      CALL UNPACK (*105,IA,CORE)
      GO TO 110
  105 JJU = NPREC*JU
      DO 108 I = 1,JJU
      CORE(I) = 0.0
  108 CONTINUE
      IF (IPOW .NE. 4) GO TO 110
      IF (NPREC .EQ.  1) CORE (NOWCOL) = 1.0
      IF (NPREC .EQ.  2) DCORE(NOWCOL) = 1.0D0
  110 II = 0
  115 II = II + 1
      A(1) = CORE(II)
      IF (NPREC .EQ. 2) D(1) = DCORE(II)
      IF (OPT(1) .EQ. SQ) CALL BLDPK (NPREC,NPREC,IOUT,0,0)
      GO TO 140
C
C     START A NEW COLUMN IF SYMMETRIC OUTPUT MATRIX.
C
  118 IF (OPT(1) .EQ. SQ) CALL BLDPK (NPREC,NPREC,IOUT,0,0)
CWKBI 9/93
      INULL = 0
C
C     START READING A COLUMN
C
C     NOTE THAT NULL INPUT COLUMN RESULTS IN NULL OUTPUT ELEMENT ONLY
C     IF POWER IS NOT ZERO.
C
      CALL INTPK (*120,IA,0,ITYPE,0)
      GO TO 130
  120 IF (IPOW .NE. 4) GO TO 175
CWKBI 9/93
      INULL = 1
      VAL(2)  = 0.0
      DVAL(2) = 0.0D0
      IF (NPREC .EQ. 1)  VAL(1) = 1.0
      IF (NPREC .EQ. 2) DVAL(1) = 1.0D0
      II = NOWCOL
      GO TO 170
C
C     GET AN ELEMENT
C
  130 CALL ZNTPKI
C
C     CHECK FOR DESIRED ELEMENT (ROW = COLUMN)
C
      IF (II-NOWCOL) 132,140,135
C
C     CHECK FOR LAST NON-ZERO ELEMENT IN COLUMN.
C
  132 IF (LAST) 130,130,135
C
C     SET ELEMENT VALUE TO 0. IF NOT IN COLUMN
C
  135 VAL(1)  = 0.
      DVAL(1) = 0.0D0
      GO TO 170
C
C     PROCESS RETURNED VALUE.
C
C     CHECK FOR PRECISION REQUIRED
C
  140 GO TO (150,160), NPREC
C
C     SINGLE PRECISION PROCESSING OF REAL PART OF DIAGONAL ELEMENT
C
C     PERFORM REQUESTED OPERATION
C
  150 GO TO (152,154,156,158,159), IPOW
  152 VAL(1) = A(1)
      GO TO 170
  154 VAL(1) = SQRT(A(1))
      GO TO 170
  156 VAL(1) = A(1)*A(1)
      GO TO 170
  158 VAL(1) = 1.0
      GO TO 170
  159 VAL(1) = A(1)**POWER
      GO TO 170
C
C     DOUBLE PRECISION PROCESSING OF REAL PART OF DIAGONAL ELEMENT
C
C     PERFORM REQUESTED OPERATION
C
  160 GO TO (162,164,166,168,169), IPOW
  162 DVAL(1) = D(1)
      GO TO 170
  164 DVAL(1) = DSQRT(D(1))
      GO TO 170
  166 DVAL(1) = D(1)*D(1)
      GO TO 170
  168 DVAL(1) = 1.0D0
      GO TO 170
  169 DVAL(1) = D(1)**POWER
C
C     PACK COMPUTED VALUE INTO OUTPUT MATRIX
C
  170 JROW = NOWCOL
      IF (IFORM .EQ. 3) JROW = II
      CALL ZBLPKI
C
C     TEST FOR SPECIAL CASE OF DIAGONAL INPUT MATRIX (1 COLUMN).
C
      IF (IFORM .EQ. 3) GO TO 175
C
C     SKIP REST OF INPUT COLUMN IF NOT ON LAST ELEMENT.
C
CWKBI 9/93
      IF ( INULL .EQ. 1 ) GO TO 171
      IF (LAST .EQ. 0) CALL SKPREC (IN1,1)
CWKBI 9/93
  171 CONTINUE
C
C     TEST FOR SQUARE MATRIX CASE
C     FINISHED WITH COLUMN IF SQUARE MATRIX
C
  175 IF (OPT(1) .EQ. SQ) CALL BLDPKN (IOUT,0,IB)
C
C     FINISHED WITH ONE OUTPUT ELEMENT.
C
      IF (IFORM.EQ.3 .AND. II.LT.INROW) GO TO 115
  180 CONTINUE
C
C     FINISH PACKING VECTOR IF COLUMN OUTPUT OPTION.
C
      IF (OPT(1) .EQ. COL) CALL BLDPKN (IOUT,0,IB)
C
C     WRITE TRAILER IN FIAT.
C
      CALL WRTTRL (IB)
C
C     FINISHED WITH ALL OF MATRIX, CLOSE UNITS
C
      CALL CLOSE(IN1,1)
      CALL CLOSE(IB ,1)
  200 RETURN
C
C     ERROR MESSAGES
C
  210 RETURN
C
C     WRONG TYPE OF INPUT MATRIX = MSG.3016
C
  220 NUMM = -16
      GO TO 300
C
C     NOT ENOUGH CORE (MESSAGE 3008)
C
  230 NUMM = -8
      GO TO 300
C
  300 CALL MESAGE (NUMM,NUM,NAME)
      RETURN
C
      END

      SUBROUTINE AMPE (PHIDH,GTKA,GKH,SCR1,SCR2,USETA)
C
C     THE PURPOSE OF THIS ROUTINE IS TO COMPUTE GKH
C
      INTEGER         PHIDH,GTKA,GKH,SCR1,SCR2,USETA,PHIAH
      COMMON /BLANK / NOUE
      COMMON /PATX  / LC,NS0,NS1,NS2,IUSET
      COMMON /BITPOS/ UM,UO,UR,USG,USB,UL,UA,UF,US,UN,UG,UE,UP,UNE,UFE,
     1                UD,UPS,USA,UK,UPA
      COMMON /ZZZZZZ/ Z(1)
      COMMON /SYSTEM/ SYSBUF,NOUT,SKIP(52),IPREC
      COMMON /PATX  / XXX,NROW1,NROW2
C
      PHIAH = PHIDH
C
C     DETERMINE IF PHIDH MUST BE MODIFIED
C
      IF (NOUE .EQ. -1) GO TO 20
C
C     BUILD PARTITIONING VECTORS
C
      IUSET = USETA
      LC = KORSZ(Z)
      CALL CALCV (SCR1,UD,UA,UE,Z)
C
C     PERFORM PARTITION
C
      NROW1 = NS0
      NROW2 = NS1
      PHIAH = SCR2
      CALL SSG2A (PHIDH,PHIAH,0,SCR1)
C
C     COMPUTE GKH
C
   20 CONTINUE
      CALL SSG2B (GTKA,PHIAH,0,GKH,1,IPREC,1,SCR1)
      RETURN
      END

      PROGRAM NASTHELP
C
CDC   PROGRAM NASTHELP (INPUT,OUTPUT,TAPE5=INPUT,TAPE6=OUTPUT,
CDC  1                  TAPE2,TAPE3,TAPE4)
C
C     THIS PROGRAM PROVIDES ON-LINE SCREEN HELP FOR NASTRAN USER'S
C     MANUAL INFORMATION. THE COMPLETE MANUAL IS STORED IN THE
C     FOLLOWING ASCII TEXT FILES, WHICH ARE ALSO ACCESSIBLE TO ANY
C     SYSTEM EDITOR:
C
C          MANUAL SECTION                                FILE NAME
C          -------------------                           ---------
C       1. EXECUTIVE CONTROL                             EXEC.TXT
C       2. CASE CONTROL                                  CASE.TXT
C       3. INPUT BULK DATA                               BULK.TXT
C       4. PLOTTING                                      PLOT.TXT
C       5. DMAP                                          DMAP.TXT
C       6. SUBSTRUCTURE                                  SUBS.TXT
C       7. ERROR MESSAGES                                MSSG.TXT
C       8. NASTRAN DICTIONARY                            DICT.TXT
C       9. INTRODUCTION & GENERAL INFORMATION            INTR.TXT
C      10. USER'S MASTER FILE AND USER GENERATED INPUT   UMFL.TXT
C      11. RIGID FORMATS                                 RFMT.TXT
C
C
C     IN ADDITION,
C     IF FILE SELECTION IS FOLLOWED BY ',C', THIS PROGRAM WILL ONLY
C     CHECK THE INPUT FILE FOR OUT-OF-ORDER ITEMS, DUPLICATE ITEMS,
C     AND HEADER 12 CHARACTERS (EXEC, CASE, BULK, PLOT, DMAP AND
C     SUBS.TXT FILES ONLY)
C
C     IF FILE SELECTION IS FOLLOWED BY ',P', THIS PROGRAM WILL PRINT
C     THE ENTIRE CONTENTS OF THE FILE WITH PROPER CARRIAGE CONTROL AND
C     PAGING
C
C     DESIGN REQUIREMENTS FOR MANUAL TEXT FILES
C     (1) A POUND SIGN (#) ON COLUMN 1, MUST PRECEED EACH ITEM
C     (2) '=PAGE=' IN FIRST 6 COLUMNS OF A LINE IS A PAGE MARK
C     (3) EACH ITEM MUST BEGIN WITH ONE OF THE FOLLOWING WORDS, 12 CHAR.
C         EACH               111111
C                 ..123456789012345..(COLUMN)
C                   Executive Co
C                   Case Control
C                   Input Data C
C                   Structure Pl
C                   X-Y Output D
C                   Name:
C                   Substructure Co (special
C                   Substructure Mo  15
C                   Substructure Op  chars.)
C         (REVISED 4/93, DUE TO CHANGES IN THE .TXT FILES, HEADER WORDS
C         IN (3) ARE NO LONGER USED)
C     (4) SEARCH BY KEY NASTRAN WORD AFTER EACH HEADER WORDS IN (3)
C     (5) KEY NASTRAN WORDS MUST BE IN ALPHA-NUMERIC SORT
C     (6) USE ',C' OPTION IN FILE SELECTION FOR DATA CARDS CHECK
C
C     SOME OF THE ABOVE COMMENTS MAY NO LONGER BE TRUE (1993)
C
C     FORTRAN FILE ASSIGNMENTS -
C
C                  FORTRAN
C     FILE NAME    UNIT NO.   STATUS            FILE CONTENTS
C     -----------  -------   ---------  --------------------------------
C     SYS$INPUT        5      INPUT     KEYBOARD INPUT
C     SYS$OUTPUT       6      OUTPUT    TERMINAL OUTPUT
C     COV.TAB          4      INPUT     CONTAINS MACHINE DEPENDENT ASCII
C                           (OPTIONAL)  SPECIAL SYMBOL CONVERSION TABLE
C     NASTRAN MANUAL   3      INPUT     EXEC,CASE,BULK,PLOT,SUBS,DMAP,
C        .TXT FILES                     MSSG,DICT,INTR UMFL and RFMT.TXT
C     USER GIVEN       2      OUTPUT    OUTPUT PRINT FILE
C      FILE NAME            (OPTIONAL)
C
C     PROGRAM FLAGS USED:
C     FL    = 1  THRU 11, FOR 11 DIFFERENT MANUAL.TXT FILES
C     SEC   = 1, MEANS SEARCH BY SECTION ALLOWED, ZERO OTHERWISE
C     HD12  = 0, NO HEADER LINE ON TEXT. OTHEREWISE,
C                HD12(FL) IS THE APPROPIATE HEADER LINE FOR FILE FL
C     BASE  = N, SKIP N WORDS ON HEADER LINE WHEN SEARCHING KEY WORD
C           = 0, SET TO ZERO DUE TO CHANGES IN 1993 USER'S MANUAL
C     MIDPT = AN INTEGER OF A CHARACTER SYMBOL INDICATING THE MID POINT
C                ON TEXT FILE
C     MDPT  = M, NO. OF LINES TO SKIP TO MID POINT OF TEXT FILE
C           = 0, MEANS NO SKIPPING
C     J4    =    2ND ALTERNATE BASE FOR PLOT.TXT
C     J5,J6 =    2ND AND 3RD ALTERNATE BASE FOR SUBS.TXT
C
C     WRITTEN BY GORDON CHAN/UNISYS       3/1992
C     REVISED FOR NEW .TXT FILES FORMAT   4/1993
C     General cleanup and comments 
C     added by Reg Mitchell, GSFC         8/1994
C     Last modification                   9/9/94
C
      IMPLICIT INTEGER (A-Z)
      LOGICAL      CHECK,PRINT,FIRST,ETY,POPEN,DEBUG
      INTEGER      IVAL(256),NUMSUB(256),NVAL(256,10),BASE(11)
      CHARACTER*1  KA,KB,KC,KD,KE,KF,KG,KH,KI,KJ,KK,KL,KM,KN,KO,KP,KQ,
     1             KR,KS,KT,KU,KV,KW,KX,KY,KZ,BNK1,LB1,UP1,LT1,MNS,PLUS,
     2             CMA,DOT,NUM,QM, LLa,LLz,
     3             LC,IC,JC,JX1,YES,NO, A1(80),A11,K1(8)
      CHARACTER*4  A4,KEY4,KEY42,BNK4,NEW4,WAS4,APPR,APP,SOLU,SOL,
     1             STP4,STP4L,EXIT4,EXIT4L,QUIT4,QUIT4L,NXTP,NXTS,NXTB,
     2             FILE,FILEX(11)
      CHARACTER    PAG3*3,PAG6*6,KEY6*6,KEY8*8,FNAME*8,MACH*16,DATE9*9,
     1             A3*3,A6*6,A12*12,OU12*42,A48*48,B48*48,A79*79,A80*80,
     2             K44*44,KA44*44,HD6*6,HD12(6)*12,DBGO*8,DBGF*8,TCTF*35
      CHARACTER    DEV_DIR*7
      COMMON /KHR/ KA,KB,KC,KD,KE,KF,KG,KH,KI,KJ,KK,KL,KM,KN,KO,KP,KQ,
     1             KR,KS,KT,KU,KV,KW,KX,KY,KZ,BNK1,LB1,UP1,LT1,MNS,PLUS,
     2             CMA,DOT,NUM(10)
      EQUIVALENCE  (KA44,KA),(YES,KY),(NO,KN),(PAG3,PAG6),(FILE,FNAME),
     1             (A1(1),A11,A4,A3,A6,A12,A48,A79,A80,JX1),(A1(3),JC),
     2             (K1(1),KEY4,KEY6,KEY8),(KEY42,K1(5)),(A1(2),IC)
      DATA         IN,OUT,TB,OU / 5, 6, 4, 2  /, NLP,ETY / 21, .TRUE. /,
C    1             BASE  / 23, 24, 17, 25, 6, 21, 0, 0, 0, 0, 0       /,
     1             BASE  /  0,  0,  0,  0, 0,  0, 0, 0, 0, 0, 0       /,
     2             J4,J5,J6, T1,       T2,    T3 , LLa, LLz, NEW4     /
     3             21,26,41, 16777216, 65536, 256, 'a', 'z', '|   '   /,
     4             K44 /'ABCDEFGHIJKLMNOPQRSTUVWXYZ #^<-+,.1234567890'/,
     5             BNK4,STP4,PAG6,B48  / '   ', 'STOP','=PAGE=', ' '  /,
     6             NXTP,NXTS,NXTB,QM   / 'P  ', 'S   ','B   ', '?'    /,
     7             APPR,APP, SOLU,SOL  / 'APPR','APP ','SOLU','SOL '  /,
     8             FILEX / 'EXEC','CASE','BULK','PLOT','DMAP','SUBS'  ,
     9             'MSSG','DICT','INTR','UMFL','RFMT'/,FNAME/'XXXX.TXT'
     O/,           MACH / '  UNIX VERSION  '  /,  DATE9 / 'AUG. 1994' /,
     1             FIRST,CHECK,PRINT,DEBUG    / .TRUE.,  3*.FALSE.    /,
     2             LU,IVFF / 3, 12 /,     HD6 / 'Name: '/,   HD12     /
     3             'Executive Co', 'Case Control', 'Input Data C'     ,
     4             'Structure Pl',  'X-Y Output D', 'Substructure'    /,
     5             TCTF / ' or terminate current text file(^):'       /,
     6             DBGO,DBGF / 'DEBUG ON', 'DEBUG OF'/,STP4L /'stop'/,
     7             EXIT4,EXIT4L / 'EXIT','exit' /,
     8             QUIT4,QUIT4L / 'QUIT','quit' /
      DATA DEV_DIR/'DEV_DIR'/        
C
      COMPLF(I) = NOT(I)
C
      KA44   = K44
      NUM1   = ICHAR(NUM(1))
      NUM9   = ICHAR(NUM(9))
      La     = ICHAR(LLa)
      Lz     = ICHAR(LLz)
      BA     = ICHAR(KA )
      Aa     = BA - La
      NUMCOV = 0
      POPEN  = .FALSE.
C
C     OPEN THE SPECIAL CHARACTER CONVERSION FILE (UNIT 2).
C
      OPEN (UNIT=TB,FILE='COV.TAB',ACCESS='SEQUENTIAL',FORM='FORMATTED',
     1      STATUS='OLD',ERR=130)
C
C     COV.TAB FILE BEGINS WITH A HEADER RECORD, THEN FOLLOWED BY RECORDS
C     OF 3 INTEGER WORDS, IN 3I4 FORMAT, WHICH ARE:
C     INCOMING SYMBOL, NO. OF BYTE, AND OUTGOING CORRESPONDING SYMBOL
C
C        1   1 124
C        2   1 124
C        :   :  :
C      256   1 124
C
      READ (TB,100,END=130)
      DO 120 I = 1,256
      READ (TB,100,END=130) IVAL(I),N,(NVAL(I,J),J=1,N)
      IF (N .GT. 10) WRITE (OUT,110) I,N
  100 FORMAT (12I4)
  110 FORMAT (' *** Error in COV.TAB    I,N =',2I5)
      NUMSUB(I) = N
  120 CONTINUE
      I = 257
      CLOSE (UNIT=TB)
C     SPECIAL CHARACTER TABLE HAS BEEN READ
  130 NUMCOV = I - 1
C
C     PRINT PROGRAM HEADER
C
      WRITE  (OUT,140)
  140 FORMAT (/////////)
      WRITE  (OUT,150) MACH,DATE9
  150 FORMAT (34X,4H****, /32X,1H*,6X,1H*, /31X,1H*,8X,1H*, /31X,
     1        18H*  N A S T H E L P, /31X,1H*,8X,1H*, /32X,1H*,6X,1H*,
     2        /34X,4H****, ///15X,A16,10X,17HSYSTEM RELEASE - ,A9)
      WRITE  (OUT,160)
  160 FORMAT (//,' Is your screen capable of MORE THAN 80 columns? ',
     1       '(Y or N (default))')
      READ   (IN,170) LC
  170 FORMAT (3A1)
      ETY = .FALSE.
      IF (LC .EQ. BNK1) GO TO 180
      IF (ICHAR(LC).GE.La .AND. ICHAR(LC).LE.Lz) LC = CHAR(ICHAR(LC)+Aa)
      IF (LC .EQ. YES) ETY = .TRUE.
  180 WRITE  (OUT,190) NLP
  190 FORMAT (//,' Enter LINES PER PAGE (default is',I3,') ')
      READ   (IN,200,ERR=180) J
  200 FORMAT (I2)
      IF (J .GT. 1) NLP = J
      NLP4 = NLP - 4
      WRITE  (OUT,210)
  210 FORMAT (/,' A text line marked by | in column 1 indicates that ',
     1        'this line contains updated', /,' material since the ',
     2        'June 1986 NASTRAN Users'' Manual')
      IF (ETY) WRITE (OUT,215)
  215 FORMAT (/,' If your screen loses character in column 80, it is ',
     1        'because your terminal lacks',/,' 80-column capability.')
      WRITE  (OUT,220)
  220 FORMAT (//,' NASTHELP accepts both UPPER and lower case input')
C    1         /,' The terms STOP and QUIT are interchangable')
C     READY TO BEGIN READING A MANUAL
      GO TO 240
C     CLOSE CURRENT MANUAL IF STILL OPEN
  230 CLOSE (UNIT=LU)
C
C     PROCESS REQUEST FOR USER MANUAL SELECTION
C
  240 WRITE  (OUT,250)
  250 FORMAT (/,' Enter letter for desired part of NASTRAN',
     O        ' User''s Manual',//,
     1 '  Introduction(I)     Don''t know(?)',/,
     2 '  Executive(E)        Case control(C)     Bulkdata(B)',/,
     3 '  DMAP(D)             Rigid Formats(R)    Plotting(P)',/,
     4 '  Messages(M)         Substructures(S)    UMF/UGI(U)',/,
     5 '  Dictionary(T)       Stop/quit(STOP)')
      READ (IN,170) LC,IC,JC
C     CONVERT TO UPPER CASE IF NECESSARY
      IF (ICHAR(LC).GE.La .AND. ICHAR(LC).LE.Lz) LC = CHAR(ICHAR(LC)+Aa)
      IF (ICHAR(IC).GE.La .AND. ICHAR(IC).LE.Lz) IC = CHAR(ICHAR(IC)+Aa)
      IF (ICHAR(JC).GE.La .AND. ICHAR(JC).LE.Lz) JC = CHAR(ICHAR(JC)+Aa)
C     CHECK FOR A COMMA IN SECOND POSITION
      IF (IC .NE. CMA) GO TO 260
      IF (JC .EQ.  KC) CHECK = .TRUE.
      IF (JC .EQ.  KP) PRINT = .TRUE.
  260 IF (LC.EQ.KS .AND. JC.EQ.KO) GO TO 2210
      FIRST = .TRUE.
      LAST  = -1
      SEC   =  1
      MDPT  =  0
      MQ    =  0
      IF (LC .EQ. KE) GO TO 310
      IF (LC .EQ. KC) GO TO 320
      IF (LC .EQ. KB) GO TO 330
      IF (LC .EQ. KP) GO TO 340
      IF (LC .EQ. KD) GO TO 350
      IF (LC .EQ. KS) GO TO 360
      IF (LC .EQ. KM) GO TO 370
      IF (LC .EQ. KT) GO TO 380
      IF (LC .EQ. KI) GO TO 390
      IF (LC .EQ. KU) GO TO 400
      IF (LC .EQ. KR) GO TO 405
      IF (LC .EQ. QM) GO TO 280
      WRITE  (OUT,270)
  270 FORMAT (/,' *** SELECTION error')
      GO TO 240
C
  280 MQ = 1
      GO TO 310
C
C     GET NEW MANUAL REQUEST
  300 CLOSE (UNIT=LU)
      GO TO 240
C
C     SET FL TO THE REQUESTED NASTRAN MANUAL (EXEC=1, CASE=2, ETC.)
C     DEFINE MID-POINT IN FILE FOR SKIPPING, AND SET HEADER SEARCH
C     MIDPT IS THE FIRST LETTER OF KEY WORDS,
C     MDPT  IS NO. OF RECORDS TO BE SKIPPED.
C
C     USE ANY SYSTEM EDITOR TO LOCATE THE MID-POINT OF FILE
C
  310 FL   = 1
      GO TO  410
  320 FL   = 2
      GO TO  410
  330 FL   = 3
      MIDPT= ICHAR(KN)
      MDPT = 10741
      GO TO  410
  340 FL   = 4
      GO TO  410
  350 FL   = 5
      GO TO  410
  360 FL   = 6
      GO TO  410
  370 FL   = 7
      SEC  = 0
      MIDPT= ICHAR(NUM(3))
      MDPT = 3550
      GO TO  410
  380 FL   = 8
      SEC  = 0
      GO TO  410
  390 FL   = 9
      IF (NLP-4 .EQ. NLP4) NLP = NLP - 1
      GO TO  410
  400 FL   = 10
      GO TO  410
  405 FL   = 11
      GO TO  410
C
C     OPEN THE REQUESTED NASTRAN MANUAL FILE
C
  410 FILE = FILEX(FL)
      WAS1 = COMPLF(0)
      WAS2 = WAS1
      OPEN (UNIT=LU,FILE=FNAME,ACCESS='SEQUENTIAL',FORM='FORMATTED',
     1      STATUS='OLD',ERR=412)
      GO TO 415
  412 WRITE  (OUT,413) FNAME
  413 FORMAT (//1X,A8,' file DOES NOT EXIST')
      IF (JC .NE. KU) GO TO 240
      GO TO 2210
C
  415 CONTINUE
      IF (CHECK) GO TO 1700
      IF (PRINT) GO TO 2000
      SOUNT = 0
C     SEARCH KEY WORD OR NUMBER AS APPROPRIATE, BASED ON MANUAL FLAG.
C     1=EXEC,2=CASE,3=BULK,4=PLOT,5=DMAP,6=SUBS,7=MSSG,8=DICT,
C     9=INTR,10=UMFL,11=RFMT
  420 GO TO (650,650,650,650,650,650,430,540,610,610,650), FL
C
C     MESSAGE SEARCH IN FILE MSSG.TXT
C
  430 WRITE  (OUT,440) TCTF
  440 FORMAT (/,' Enter MESSAGE NUMBER (up to 4 digits) or STOP,',A35)
      READ   (IN,450) A4
  450 FORMAT (A4)
      IF (A11 .EQ. UP1) GO TO 300
      IF (A4 .EQ. STP4) GO TO 2200
      IF (A4 .EQ. STP4L) GO TO 2200
      IF (A4 .EQ. EXIT4) GO TO 2200
      IF (A4 .EQ. EXIT4L) GO TO 2200
      IF (A4 .EQ. QUIT4) GO TO 2200
      IF (A4 .EQ. QUIT4L) GO TO 2200
      REWIND LU
      COUNT = 0
      J = 0
  460 IF (A1(3) .NE. BNK1) GO TO 470
      J = J + 1
      IF (J .GT. 2) GO TO 430
      A1(3) = A1(2)
      A1(2) = A1(1)
      A11   = BNK1
      GO TO 460
  470 IF (A1(4) .EQ. BNK1) GO TO 490
      IF (MDPT.EQ.0 .OR. ICHAR(A11).LT.MIDPT) GO TO 490
      DO 480 I = 1,MDPT
      READ (LU,450,END=500)
  480 CONTINUE
      COUNT = MDPT
  490 READ (LU,450,END=500) KEY4
      COUNT = COUNT + 1
      IF (KEY4.EQ.BNK4 .OR. KEY4.EQ.NEW4 .OR. KEY4.NE.A4) GO TO 490
      BACKSPACE LU
      KOUNT = 2
      GO TO 1200
  500 WRITE  (OUT,510)
  510 FORMAT (' *** No Such MESSAGE NO. ***',/)
      GO TO 430
C
C     DICTIONARY SEARCH IN FILE DICT.TXT
C
  540 WRITE  (OUT,550) TCTF
  550 FORMAT (/,' Enter DICTIONARY word or STOP,',A35)
      READ   (IN,560) A6
  560 FORMAT (A6)
      IF (A11 .EQ. UP1) GO TO 300
      DO 570 J = 1,6
      IF (ICHAR(A1(J)).GE.La .AND. ICHAR(A1(J)).LE.Lz)
     1    A1(J) = CHAR(ICHAR(A1(J))+Aa)
  570 CONTINUE
      IF (A4 .EQ. STP4) GO TO 300
      IF (A4 .EQ. QUIT4) GO TO 300
      IF (A4 .EQ. STP4L) GO TO 300
      IF (A4 .EQ. QUIT4L) GO TO 300
      REWIND LU
  580 READ (LU,560,END=590) KEY6
      IF (KEY4.EQ.BNK4 .OR. KEY4.EQ.NEW4 .OR. KEY6.NE.A6) GO TO 580
      BACKSPACE LU
      KOUNT = 1
      GO TO 1200
  590 WRITE  (OUT,600)
  600 FORMAT (' *** No such term in NASTRAN Dictionary')
      GO TO 540
C
C     INTRODUCTION OR USER-MASTER-FILE SEARCH OF FILES INTR OR UMFL.TXT
C
C     SEARCH BY SECTION, SUBSECTION, AND PAGE ONLY
C     SECTION AND SUBSECTION MUST BE PRECEEDED BY A BLANK LINE
C
  610 WRITE  (OUT,620) TCTF
  620 FORMAT (/,' Enter section(S), sub-section(B), page(P), ',
     1        'or stop(STOP),', /,A35)
      GO TO 670
C
  630 PASS = PASS + 1
      IF (PASS .GE. 2) WRITE (OUT,640) FNAME
  640 FORMAT (17X,'No such WORD in ',A8,' file')
      REWIND LU
      COUNT = 0
      IF (PASS .EQ. 1) GO TO 700
C
C     GENERAL SEARCH FOR FILE TYPES = EXEC, CASE, BULK, PLOT, DMAP,
C     SUBS OR RFMT.TXT
C     KEY WORD or SECTION SEARCH
C
  650 WRITE  (OUT,660) TCTF
  660 FORMAT (/,' Enter NASTRAN KEY WORD, STOP, next page(P),',
     1 ' next section(S),',/,' next sub-section(B), ',A35)
  670 READ   (IN,680) KEY8
  680 FORMAT (A8)
      PASS = 0
      LAST = COUNT
      IF (K1(1) .EQ. UP1) GO TO 230
C     NOT A ^ CHARACTER, CONVERT TO UPPER CASE AND PROCESS
      DO 690 ILOOP = 1,8
      IF (ICHAR(K1(ILOOP)).GE.La .AND. ICHAR(K1(ILOOP)).LE.Lz)
     1    K1(ILOOP) = CHAR(ICHAR(K1(ILOOP))+Aa)
  690 CONTINUE
      IF (KEY4 .EQ. STP4) GO TO 1600
      IF (KEY4 .EQ. QUIT4) GO TO 1600
      IF (KEY4 .EQ. BNK4) GO TO 650
      IF (KEY4 .EQ. NXTP) GO TO 980
      IF (KEY4 .EQ. NXTS) GO TO 750
      IF (KEY4 .EQ. NXTB) GO TO 730
      IF (KEY8 .EQ. DBGO) DEBUG = .TRUE.
      IF (KEY8 .EQ. DBGF) DEBUG = .FALSE.
      IF (KEY8.EQ.DBGO .OR. KEY8.EQ.DBGF) GO TO 650
      IF (FL.EQ.9 .OR. FL.EQ.10) GO TO 610
  700 JDX = 9
      IF (SEC .EQ. 1) GO TO 900
      IF (K1(1).NE.KS .AND. K1(1).NE.KB) GO TO 900
C
  710 WRITE  (OUT,720) FNAME
  720 FORMAT (/,' *** Search by SECTION is not practical on this ',A8,
     1        ' file')
      GO TO 650
C
  730 KEY4 = NXTB
      IF (SOUNT .GT. 0) GO TO 755
      WRITE  (OUT,740)
  740 FORMAT (/,' *** SUBSECTION is requested without first request of',
     1       ' SECTION ***')
      GO TO 650
  750 KEY4  = NXTS
      SOUNT = 0
      IF (COUNT .LE. 1) GO TO 1200
  755 A4   = STP4
  760 WAS4 = A4
      READ (LU,770,END=880) A12
  770 FORMAT (A12)
      COUNT = COUNT + 1
      IF (PASS.EQ.2 .AND. COUNT.EQ.LAST) GO TO 1620
      IF (A4.EQ.BNK4 .OR. A4.EQ.NEW4) GO TO 760
      IF (WAS4 .NE. BNK4) GO TO 760
      I = ICHAR(A11)
      IF (A11 .EQ. BNK1) I = ICHAR(A1(2))
      IF (I.LT.NUM1 .OR. I.GT.NUM9) GO TO 760
      NDOT = 0
      DO 780 I = 2,11
      IF (A1(I) .NE. DOT) GO TO 780
      IF (A1(I+1).NE.BNK1 .AND. A1(I+1).NE.DOT) NDOT = NDOT + 1
  780 CONTINUE
      IF (NDOT-1) 760,790,810
  790 IF (KEY4 .EQ. NXTB) GO TO 820
      SOUNT = COUNT - 1
  800 COUNT = COUNT - 1
      BACKSPACE LU
      GO TO 1200
  810 IF (KEY4 .EQ. NXTS) GO TO 760
      GO TO 800
  820 WRITE  (OUT,830) TCTF
  830 FORMAT (/,' *** End of SECTION ***', /,' return to Key(K), ',
     1       'return to beginning of section(R), next section(N)',
     2        /,' stop(STOP),',A35)
      READ (IN,170) IC
      IF (ICHAR(IC).GE.La .AND. ICHAR(IC).LE.Lz) IC = CHAR(ICHAR(IC)+Aa)
      IF (IC .EQ. UP1) GO TO 230
      IF (IC .EQ. KS ) GO TO 2200
      IF (IC .EQ. KK ) GO TO 650
      IF (IC .EQ. KN ) GO TO 860
      IF (IC .NE. KR ) GO TO 820
      IF (SOUNT .LE. 1) GO TO 870
      J = COUNT - SOUNT + 2
  840 DO 850 I = 1,J
      BACKSPACE LU
  850 COUNT = COUNT - 1
      IF (COUNT .LT. 0) COUNT = 0
      KEY4 = NXTS
      GO TO 1200
  860 J = 1
      GO TO 840
  870 REWIND LU
      KEY4 = NXTS
      GO TO 1200
  880 WRITE  (OUT,890)
  890 FORMAT (' *** End of File ***')
      REWIND LU
      SOUNT = 0
      GO TO 650
C
C     KEY WORD SEARCH - FIRST SEARCH HEADING THEN KEY WORD
C
  900 JDX = JDX - 1
      IF (K1(JDX) .EQ. BNK1) GO TO 900
      IF (JDX .LE. 0) GO TO 630
      IF (FL  .NE. 1) GO TO 910
C
C     SOME KEY WORDS IN EXECUTIVE CONTROL SECTION MAY BE ABBREVIATED.
C     4 BYTES ARE USED FOR ALL EXECUTIVE CONTROL KEY WORDS
C
      IF (JDX .GT. 4) JDX = 4
      IF (KEY4 .EQ. APPR) KEY4 = APP
      IF (KEY4 .EQ. SOLU) KEY4 = SOL
C
C     IF KEY IS LESS THAN 4 LETTERS, ADD A BLANK AT THE END SO THAT
C     'SOF' IS NOT 'SOFIN', 'SOFOUT', etc.
C
  910 IF (JDX .GE. 4) GO TO 920
      JDX = JDX + 1
      K1(JDX) = BNK1
C
C     T1  = 2**8,  T2 = 2**16,  T3 = 2**24
C     IS0 = FIRST CHARACTER OF THE 8-BYTE KEY WORD IN NUMERIC VALUE
C     IS1 = FIRST  HALF OF THE 8-BYTE KEY WORD IN NUMERIC VALUE
C     IS2 = SECOND HALF OF THE 8-BYTE KEY WORD IN NUMERIC VALUE
C
C     THAT IS, WE WILL USE NUMERIC VALUE FOR KEY WORD SEARCH
C
  920 IS0 = ICHAR(K1(1))
      IS1 = IS0*T1 + ICHAR(K1(2))*T2 + ICHAR(K1(3))*T3 + ICHAR(K1(4))
      IS2 = ICHAR(K1(5))*T1 + ICHAR(K1(6))*T2 + ICHAR(K1(7))*T3 +
     1      ICHAR(K1(8))
C
C     COMPARE PRESENT KEY WORD AND PREVIOUS KEY AND DETERMINE WE NEED
C     TO REWIND FILE OR NOT
C
C     IF TEXT FILE IS NOT PRESORTED, WE NEED TO REWIND FILE ON EACH NEW
C     KEY WORD.  (USER'S MANUAL IS SORTED)
C
      IF (IS1-WAS1) 940,930,980
  930 IF (IS2-WAS2) 940,950,980
  940 REWIND LU
      COUNT = 0
      GO TO 980
  950 WRITE (OUT,960)
  960 FORMAT (' Same KEY WORD as before. Continue? (Y,N) ')
      READ (IN,170) IC
      IF (ICHAR(IC).GE.La .AND. ICHAR(IC).LE.Lz) IC = CHAR(ICHAR(IC)+Aa)
      IF (IC .EQ. NO) GO TO 650
      REWIND LU
      COUNT = 0
C
C     IF KEY WORD IS BEYOND MID-POINT, SKIP HALF OF THE RECORDS IN FILE
C
      IF (MDPT.EQ.0 .OR. ICHAR(K1(1)).LT.MIDPT) GO TO 980
      L = MDPT - COUNT + 1
      DO 970 J = 1,L
      READ (LU,170)
  970 CONTINUE
      COUNT = COUNT + L
C
C     IVFF IS PAGE MARK.  PAG6 IS '=PAGE='
C     LOOK FOR PAGE MARK OR '=PA' FIRST
C
  980 READ (LU,170,END=630) JX1,IC,JC
      COUNT = COUNT + 1
      IF (PASS.EQ.2 .AND. COUNT.EQ.LAST) GO TO 1620
      IVJX1 = ICHAR(JX1)
      IF (JX1.NE.LB1 .AND. IVJX1.NE.IVFF .AND. A3.NE.PAG3) GO TO 980
      IF (DEBUG) WRITE (OUT,990) JX1,IC,JC
  990 FORMAT (40X,'@980 Just read- ',8A1)
      IF (KEY4.EQ.NXTP .AND. A3.EQ.PAG3) GO TO 1240
      J = 0
 1000 READ (LU,1250,END=1450) A80
      IF (DEBUG) WRITE (OUT,1005) (A1(I),I=1,8)
 1005 FORMAT (36X,'@1005 Just read- ',8A1)
      COUNT = COUNT + 1
      IF (PASS.EQ.2 .AND. COUNT.EQ.LAST) GO TO 1620
      J = J + 1
      IF (J .GE. 7) GO TO 980
      IF (A4.EQ.BNK4 .OR. A4.EQ.NEW4) GO TO 1000
      IF (ICHAR(A11) .EQ. IVFF) GO TO 1000
C
C     KEY WORD HEADING SEARCH
C
C     ******************************************************
C     *   HEADER WORDS WERE REMOVED IN 1993 USER'S MANUAL  *
          J = 0
          IF (J .EQ. 0) GO TO 1120
C     ******************************************************
C
      GO TO (1010,1010,1010,1010,1030,1010,1100,1100,1100,1100,1050), FL
 1010 IF (DEBUG) WRITE (OUT,1020) A12,HD12(FL)
 1020 FORMAT (50X,A12,'==> ',A12)
      IF (A12 .EQ. HD12(FL)) GO TO 1050
      IF (FL.EQ.4 .AND. A12.EQ.HD12(5)) GO TO 1040
      GO TO 1000
 1030 IF (A6 .NE. HD6) GO TO 1000
      GO TO 1050
C
 1040 J = J4
      GO TO 1060
 1050 J = BASE(FL)
 1060 IF (FL .NE. 6) GO TO 1070
      IF (A1(14) .EQ.  KM) J = J5
      IF (A1(14) .EQ.  KO) J = J6
 1070 IF (A1(J) .NE. BNK1) J = J - 1
      IF (DEBUG) WRITE (OUT,1080) J
 1080 FORMAT (45X,'@1080  BASE J =',I3)
 1090 IF (A1(J+1) .NE. BNK1) GO TO 1120
      J = J + 1
      GO TO 1090
C
 1100 WRITE  (OUT,1110) FL
 1110 FORMAT (/,' *** SHOULD NOT BE HERE.  FL =',I3)
      GO TO 240
C
C     KEY WORD SEARCH
C
 1120 IF (DEBUG) WRITE (OUT,1130) (A1(J+I),I=1,JDX),LT1,LT1,
     1                            (K1(I),I=1,JDX)
 1130 FORMAT (30X,'@1130 - ',18A1)
      DO 1140 I = 1,JDX
      IF (A1(J+I) .NE. K1(I)) GO TO 980
 1140 CONTINUE
C
C     KEY WORD FOUND ON FILE
C
      WAS1  = IS1
      WAS2  = IS2
      KOUNT = 6
      IF (FIRST) KOUNT = 8
      WRITE  (OUT,1150)
 1150 FORMAT (//)
      IF (     ETY) WRITE (OUT,1290) A80
      IF (.NOT.ETY) WRITE (OUT,1300) A79
C
C     RECORD FOUND.  READ AND PRINT ON SCREEN
C     ALLOW UP TO 4 BLANK LINES PRINTED ON SCREEN
C
 1200 JOUNT = COUNT - 4
      BLINE = 0
      IF (NUMCOV .EQ. 0) GO TO 1240
      DO 1210 J = 1,80
      DO 1210 I = 1,NUMCOV
      IF (ICHAR(A1(J)) .EQ. IVAL(I)) A1(J) = CHAR(NVAL(I,1))
 1210 CONTINUE
      GO TO 1240
C
 1220 WRITE  (OUT,1230)
 1230 FORMAT (///)
      KOUNT = KOUNT + 3
C
 1240 READ (LU,1250,END=1450) A80
 1250 FORMAT (A80)
      COUNT = COUNT + 1
      IF (ICHAR(A11).EQ.IVFF .OR. A6.EQ.PAG6) GO TO 1220
      IF (A48 .NE. B48) GO TO 1260
      IF (BLINE .GT. 4) GO TO 1240
      BLINE = BLINE + 1
      WRITE (OUT,170) A11
      GO TO 1310
 1260 BLINE = 0
      IF (NUMCOV .EQ. 0) GO TO 1280
      DO 1270 J = 1,80
      DO 1270 I = 1,NUMCOV
      IF (ICHAR(A1(J)) .EQ. IVAL(I)) A1(J) = CHAR(NVAL(I,1))
 1270 CONTINUE
 1280 IF (A11  .EQ.  LB1) GO TO 1470
      IF (     ETY) WRITE (OUT,1290) A80
      IF (.NOT.ETY) WRITE (OUT,1300) A79
 1290 FORMAT (1X,A80)
 1300 FORMAT (1X,A79)
 1310 KOUNT = KOUNT + 1
      IF (MOD(KOUNT,NLP) .NE. 0) GO TO 1240
      GO TO (1320,1320,1320,1320,1320,1320,420,420,1320,1320,1320), FL
 1320 IF (.NOT.FIRST) GO TO 1350
      FIRST = .FALSE.
      WRITE (OUT,1332) NLP4
 1332 FORMAT(' (Y,N,STOP,1,2,...,',I2,',-n,P,S,B,^,PRINT,HELP or <CR>)')
      GO TO 1350
 1330 WRITE (OUT,1340) NLP4,NLP,NLP4
 1340 FORMAT (' (Y,N,STOP,1,2,...,',I2,',-n,P,S,B,^,PRINT,HELP or <CR>)'
     C        /11X,'Y or <CR> = yes more',
     O        /11X,'N         = no more on this item',
     1        /11X,'STOP      = terminate NASTHELP',
     2        /11X,'1,2,...,n = keep bottom n lines on next page. (',I2,
     3                          ' max)',
     4        /11X,'-n        = back up n+',I2,' lines',
     5        /11X,'P,S,B     = go to next page, next section, or next',
     6                          ' sub-section',
     7        /11X,'^         = terminate current text file',
     8        /11X,'PRINT     = print text, up to last line on screen',
     9        /11X,'HELP      = echo options of MORE', /,' ...more? ')
      GO TO 1370
 1350 WRITE  (OUT,1360)
 1360 FORMAT (' ...more? ')
 1370 READ (IN,170) IC,JC,LC
      IF (IC .EQ. UP1) GO TO 230
      IF (ICHAR(LC).GE.La .AND. ICHAR(LC).LE.Lz) LC = CHAR(ICHAR(LC)+Aa)
      IF (ICHAR(IC).GE.La .AND. ICHAR(IC).LE.Lz) IC = CHAR(ICHAR(IC)+Aa)
      IF (ICHAR(JC).GE.La .AND. ICHAR(JC).LE.Lz) JC = CHAR(ICHAR(JC)+Aa)
      IF (IC .EQ. KH) GO TO 1330
      IF (IC .EQ. NO) GO TO 420
C     Check for STop, EXit ot QUit
      IF (IC.EQ.KS .AND. JC.EQ.KT) GO TO 1600
      IF (IC.EQ.KE .AND. JC.EQ.KX) GO TO 1600
      IF (IC.EQ.KQ .AND. JC.EQ.KU) GO TO 1600
C     Check for PRint request.
      IF (IC.EQ.KP .AND. JC.EQ.KR) GO TO 2000
      IF (SEC.EQ.0 .AND. (IC.EQ.KS .OR. IC.EQ.KB)) GO TO 710
      IF (IC .EQ. KS) GO TO 750
      IF (IC .EQ. KB) GO TO 1380
      IF (IC .NE. KP) GO TO 1390
      KEY4 = NXTP
      GO TO 980
 1380 IF (SOUNT .GT. 0) GO TO 730
      WRITE (OUT,740)
      GO TO 1350
 1390 KOUNT = 0
      IF (IC.EQ.BNK1 .OR. IC.EQ.YES) GO TO 1240
      I =  0
      J = -1
      L = -1
      DO 1400 K = 1,10
      IF (IC .EQ. NUM(K)) I = MOD(K,10)
      IF (JC .EQ. NUM(K)) J = MOD(K,10)
      IF (LC .EQ. NUM(K)) L = MOD(K,10)
 1400 CONTINUE
      IF (J+L .EQ. -2) IJL = I
      IF (L.EQ.-1 .AND. J.NE.-1) IJL = I*10  + J
      IF (L.NE.-1 .AND. J.NE.-1) IJL = I*100 + J*10 + L
      IF (IC .EQ. MNS) GO TO 1410
      IJL   = MIN0(NLP4,IJL)
      KOUNT = IJL + 1
      GO TO 1240
 1410 IJL   = IJL + NLP
      DO 1420 L = 1,IJL
      BACKSPACE LU
 1420 CONTINUE
      COUNT = COUNT - IJL
      KOUNT = 0
      IF (COUNT .LT. 0) COUNT = 0
      GO TO 1240
C
 1450 IF (LC .EQ. KU) GO TO 1610
      WRITE  (OUT,1460)
 1460 FORMAT (/,' ...EOF. <CR> to continue')
      GO TO 1500
C
 1470 WRITE  (OUT,1480)
 1480 FORMAT (/,' ...End of Description')
 1500 IF (KOUNT .LT. NLP4) GO TO 650
      READ (IN,170) IC
      IF (ICHAR(IC).GE.La .AND. ICHAR(IC).LE.Lz) IC = CHAR(ICHAR(IC)+Aa)
      IF (IC .NE. KS) GO TO 650
C
 1600 IF (MQ .EQ. 0) GO TO 2200
 1610 CLOSE (LU)
      KOUNT = 0
      GO TO (320,330,1620), FL
 1620 WRITE  (OUT,1630)
 1630 FORMAT (/,'*** No such KEY WORD in EXEC, CASE and BULK.TXT files')
      GO TO 240
C
C     CHECK INPUT TEXT FORMATS FOR
C     EXEC, CASE, BULK, PLOT, DMAP SUBS and RFMT.TXT FILES
C
 1700 IF (FL.LE.6 .OR. FL.EQ.11) GO TO 1720
      WRITE  (OUT,1710) FILEX(FL)
 1710 FORMAT (//,' *** Data CHECK OPTION not valid for ',A4,'.TXT file')
      GO TO 240
 1720 READ (LU,1730,END=2200) A48
 1730 FORMAT (A48)
      IF (A12 .EQ. HD12(FL)) GO TO 1760
      IF (FL.EQ.4 .AND. A12.EQ.HD12(5)) GO TO 1760
      IF (A11 .NE. LB1) GO TO 1720
 1740 READ (LU,1730,END=2200) A48
      IF (A4.EQ.BNK4 .OR. A4.EQ.NEW4) GO TO 1740
      IF (A12 .EQ. HD12(FL)) GO TO 1790
      IF (FL.EQ.4 .AND. A12.EQ.HD12(5)) GO TO 1780
      WRITE  (OUT,1750) A48
 1750 FORMAT (1X,A48,' <== HEADER 12 CHAR. ERROR')
      GO TO 1720
 1760 WRITE  (OUT,1770) A48
 1770 FORMAT (1X,A48,' <== NO PRECEEDING # SYMBOL')
      GO TO 1720
C
 1780 J = J4
      GO TO 1800
 1790 J = BASE(FL)
 1800 IF (FL .NE. 6) GO TO 1810
      IF (A1(14) .EQ. KM) J = J5
      IF (A1(14) .EQ. KO) J = J6
 1810 IF (A1(J  ) .NE. BNK1) J = J - 1
 1820 IF (A1(J+1) .NE. BNK1) GO TO 1830
      J = J + 1
      GO TO 1820
 1830 IS1 = ICHAR(A1(J+1))*T1 + ICHAR(A1(J+2))*T2 + ICHAR(A1(J+3))*T3 +
     1      ICHAR(A1(J+4))
      IS2 = ICHAR(A1(J+5))*T1 + ICHAR(A1(J+6))*T2 + ICHAR(A1(J+7))*T3 +
     1      ICHAR(A1(J+8))
      IF (IS1-WAS1) 1850,1840,1890
 1840 IF (IS2-WAS2) 1850,1870,1890
 1850 WRITE  (OUT,1860) A48
 1860 FORMAT (1X,A48,' <== OUT OF ORDER')
      GO TO  1910
 1870 WRITE  (OUT,1880) A48
 1880 FORMAT (1X,A48,' <== DUPLICATE')
      GO TO  1720
 1890 WRITE  (OUT,1900) A48
 1900 FORMAT (1X,A48)
 1910 WAS1 = IS1
      WAS2 = IS2
      GO TO 1720
C
C     PROCESS REQUEST TO PRINT MANUAL DATA FOUND
C
 2000 IF (POPEN) GO TO 2040
      WRITE  (OUT,2010)
 2010 FORMAT (/,1H-,' Enter OUTPUT FILE Name (assume default dir): ')
      READ   (IN,770) A12
      IF (A4.NE.BNK4 .AND. A4.NE.STP4 .AND. A4.NE.STP4L) GO TO 2030
      IF (A4.NE.EXIT4 .AND. A4.NE.EXIT4L) GO TO 2030
      IF (A4.NE.QUIT4 .AND. A4.NE.QUIT4L) GO TO 2030  
      WRITE  (OUT,2020)
 2020 FORMAT (/,' Output PRINT Aborted')
      GO TO 2200
 2030 OU12 = A12
      IF (POPEN) GO TO 2040
      OPEN (UNIT=OU,FILE=OU12,STATUS='NEW',ACCESS='SEQUENTIAL',ERR=2140,
     1      FORM='FORMATTED')
      POPEN = .TRUE.
      GO TO 2060
 2040 WRITE  (OU,2050)
 2050 FORMAT (1H1)
 2060 J = COUNT - JOUNT
      IF (J .LE. 0) GO TO 2120
      DO 2070 I = 1,J
      BACKSPACE LU
 2070 CONTINUE
      DO 2100 I = 1,J
      READ (LU,1250,END=2120) A80
      IF (A11 .EQ.  LB1) GO TO 2100
      IF (A6  .EQ. PAG6) GO TO 2090
      WRITE  (OU,2080) A80
 2080 FORMAT (1X,A80)
      GO TO 2100
 2090 WRITE  (OU,2050)
 2100 CONTINUE
C
 2120 WRITE  (OUT,2130) J
 2130 FORMAT (/,I9,' lines printed')
      GO TO 420
C
 2140 WRITE  (OUT,413) OU12
      GO TO 2000
C
C     END OF JOB PROCESSING
C
 2200 CLOSE  (LU)
      KOUNT = 0
 2210 WRITE  (OUT,2220)
 2220 FORMAT (//,'  *** NASTHELP is done.  Have a good run! ***',// )
      IF (.NOT.POPEN) GO TO 2240
      CLOSE  (OU)
      WRITE  (OUT,2230) OU12
 2230 FORMAT (/,'  *** Don''t forget the print file in ',A42)
      POPEN = .FALSE.
 2240 CONTINUE
      END

      SUBROUTINE MBGAE(AJJL,IN17,A,F,DF,F1,DF1,F2,DF2,Q,Q1,Q2,MOOD)
C
C     MULTIPLY SUM OBTAINED PREVIOUSLY BY SCRIPT A FACTOR
C
      LOGICAL  CNTRL2 , CNTRL1 , CRANK1 , CRANK2 , ASYM , DEBUG
      INTEGER AJJL
      REAL MACH
      DIMENSION F(1),DF(1),F1(1),DF1(1),F2(1),DF2(1)
      COMPLEX A(1),Q(1),Q1(1),Q2(1)
      COMMON /MBOXC/ NJJ ,CRANK1,CRANK2,CNTRL1,CNTRL2,NBOX,
     *  NPTS0,NPTS1,NPTS2,ASYM,GC,CR,MACH,BETA,EK,EKBAR,EKM,
     *  BOXL,BOXW,BOXA ,NCB,NSB,NSBD,NTOTE,KC,KC1,KC2,KCT,KC1T,KC2T
      COMMON /SYSTEM/ SYSBUF,N6
      COMMON /AMGMN  / MCB(7)
      DATA    DEBUG /.FALSE./
C
      GCK  =  GC * BOXW
      DO 10 I=1,NJJ
   10 A(I) = (0.0,0.0)
      DO 1630 I=1,NPTS0
      CALL FREAD(IN17,F  ,KCT ,0)
      CALL FREAD(IN17,DF ,KCT ,0)
      DO 1620 J=1,KC
      A(I)      = A(I)      + CMPLX( DF(J),-EK*F(J))*Q(J)
 1620 CONTINUE
      IF( KC.EQ.KCT )  GO TO 1630
      KCC  =  KC + 1
      DO   1625   J = KCC,KCT
      A(I)       = A(I)      + F(J)*Q(J)
 1625 CONTINUE
 1630 CONTINUE
      IF( .NOT. CNTRL1 ) GO TO 1660
      JJ = NPTS0
      DO 1650 I=1,NPTS1
      CALL FREAD(IN17,F1 ,KC1T,0)
      CALL FREAD(IN17,DF1,KC1T,0)
      DO 1640 J=1,KC1
      A(I+JJ)   = A(I+JJ)   + CMPLX( DF1(J),-EK*F1(J))*Q1(J)
 1640 CONTINUE
      IF( KC1.EQ.KC1T )  GO TO 1650
      KCC1  =  KC1 + 1
      DO   1645   J = KCC1,KC1T
      A(I+JJ)    =  A(I+JJ)   + F1(J)*Q1(J)
 1645 CONTINUE
 1650 CONTINUE
 1660 IF( .NOT. CNTRL2 ) GO TO 1700
      JJ = JJ + NPTS1
      DO 1690 I=1,NPTS2
      CALL FREAD(IN17,F2 ,KC2T,0)
      CALL FREAD(IN17,DF2,KC2T,0)
      DO 1680 J=1,KC2
      A(I+JJ)   = A(I+JJ)   + CMPLX( DF2(J),-EK*F2(J))*Q2(J)
 1680 CONTINUE
      IF( KC2.EQ.KC2T )  GO TO 1690
      KCC2  = KC2 + 1
      DO   1685   J = KCC2,KC2T
      A(I+JJ)    = A(I+JJ)   + F2(J)*Q2(J)
 1685 CONTINUE
 1690 CONTINUE
 1700 CONTINUE
      CALL BCKREC(IN17)
      DO 1710 I=1,NJJ
      A(I) = A(I) * GCK
 1710 CONTINUE
      CALL PACK(A,AJJL,MCB)
C
C     PRINT OUT GENERALIZED AERODYNAMIC FORCE COEFFICIENTS
C
      IF(.NOT.DEBUG) RETURN
      IF(MOOD.GT.1) GO TO 2100
      WRITE  (N6 , 1900 )  MACH ,  BOXL , EK , BOXW
 1900 FORMAT  ( 1H1 , 31X , 30HGENERALIZED AERODYNAMIC FORCE
     *      , 12HCOEFFICIENTS / 1H0 , 9X , 11HMACH NUMBER , F9.3 ,
     *        40X , 10HBOX LENGTH , F12.6 / 1H0
     *      , 9X , 33HREDUCED FREQUENCY  ( ROOT CHORD ) , F10.5 , 17X
     *      , 9HBOX WIDTH , F13.6 / 1H0 , 42X , 21H- -  A ( I , J )  - -
     *      / 6H-  ROW , 9X , 4HREAL , 10X , 4HIMAG , 14X , 4HREAL , 10X
     *      , 4HIMAG , 14X , 4HREAL , 10X , 4HIMAG )
 2100 WRITE(N6,2000) MOOD, (A(J),J=1,NJJ)
 2000 FORMAT  ( 1H0 , I4 , 3 ( E18.4 , E14.4 ) / ( 1H0 , 4X , 3 ( E18.4
     *        , E14.4 ) ) )
      RETURN
      END

      SUBROUTINE SSLOT2 (IOPT,IPART,BRANCH,EIGEN)
C
C     THE OPTIONS ARE
C         IOPT   -  CSLOT3 = 0,  CSLOT4 = 1
C         IPART  -  FIRST  = 1,  SECOND = 2
C         BRANCH -  SDR2 PROCESS CODE WORD
C
      INTEGER         SIL      ,ELID     ,BRANCH
      DIMENSION       EIGEN(3)
      COMMON /SDR2X4/ DUMY(35) ,IVEC
      COMMON /SDR2X7/ ELID     ,SIL(4)   ,SV(95)   ,ID1     ,VELR(11),
     1                ID2      ,VELI(11)
      COMMON /ZZZZZZ/ ZZ(1)
      COMMON /CONDAS/ CONSTS(5)
      EQUIVALENCE     (CONSTS(2),TWOPI)
C
      KL  = IOPT + 3
      KL2 = KL + 2
      IF (IPART .EQ. 2) GO TO 20
      DO 10 I = 1,11
      VELR(I) = 0.0
   10 VELI(I) = 0.0
   20 X   = 1.0
      Y   = 0.0
      IF (BRANCH .EQ. 2) X = SQRT(ABS(EIGEN(2)))
      IF (BRANCH .EQ. 5) X = TWOPI*EIGEN(1)
      IF (X    .NE. 0.0) X = 1.0/X
      IF (BRANCH .NE. 9) GO TO 30
      EM  = EIGEN(2)**2 + EIGEN(3)**2
      IF (EM .EQ. 0.0) GO TO 30
      X   = EIGEN(2)/EM
      Y   =-EIGEN(3)/EM
   30 IF (IPART .NE. 2) GO TO 40
      EM  = X
      X   =-Y
      Y   = EM
   40 ID1 = ELID
      ID2 = ELID
C
      DO 80 I = 1,KL
      K   = IVEC + SIL(I) - 1
      IF (X .EQ. 0.0) GO TO 60
      DO 50 J = 1,KL2
      IJ  = KL*(J-1) + I
C
      VELR(J) = SV(IJ)*ZZ(K)*X + VELR(J)
   50 CONTINUE
   60 IF (Y .EQ. 0.0) GO TO 80
      DO 70 J = 1,KL2
      IJ  = KL*(J-1) + I
      VELI(J) = SV(IJ)*ZZ(K)*Y + VELI(J)
   70 CONTINUE
   80 CONTINUE
      RETURN
      END

      SUBROUTINE DSMSG ( IFLAG )
      INCLUDE 'DSIOF.COM'
      COMMON / DSIO   / MSSOFT
      INCLUDE 'GINOX.COM'
      COMMON / LOGOUT / LOUT
      INCLUDE 'XNSTRN.COM'
      COMMON / DDIOSV / IFLPOS(2,MAXPRI)
      COMMON / SOFCOM / NFILES,FILNAM(10),FILSIZ(10)
      COMMON / SYS    / BLKSIZ,DIRSIZ,SUPSIZ,AVBLKS,HIBLK
      COMMON / SYSTEM / ISYSTM(175)
C
      INTEGER XNAME(2), BLANK
      INTEGER FILNAM,FILSIZ,BLKSIZ,DIRSIZ,SUPSIZ,AVBLKS,HIBLK
      INTEGER GINO(52)
C
      EQUIVALENCE ( IEOR, GINO(1) )
      EQUIVALENCE (ISYSTM(  2), IWR   ),
     *            (ISYSTM(151), NLLOG ),
     *            (ISYSTM(152), LOGLIN)
C
      DATA BLANK / 1H /
      DATA INAME /4HDSMS/
C
      CALL FNAME ( NAME, XNAME )
      IF ( XNAME( 1 ) .NE. 0 ) GO TO 4
      XNAME( 1 ) = BLANK
      XNAME( 2 ) = BLANK
    4 CONTINUE
      IF ( IABS(IFLAG) .EQ. 777 ) GO TO 7770
      IF ( IFLAG .NE. 1 .AND. IFLAG .NE. 2 .AND. IFLAG .NE. 8 )
     C      WRITE( IWR, 5 ) IFLAG
    5 FORMAT(' I/O SUBSYSTEM ERROR NUMBER',I10)
      IF ( IFLAG .GT. 100 ) GO TO 1000
      GO TO ( 10, 20, 30, 40, 50, 60, 70, 80, 90 ),IFLAG
   10 CONTINUE
      WRITE ( LOUT, 15 ) 'OPEN ',XNAME, IOCODE
      LOGLIN = LOGLIN + 1
      GO TO 90000
   20 CONTINUE
      WRITE ( LOUT, 15 ) 'CLOSE ', XNAME, IOCODE
      LOGLIN = LOGLIN + 1
      GO TO 90000
   30 WRITE ( IWR, 35 ) XNAME, IFILEX
      GO TO 99999
   40 WRITE ( IWR, 45 ) XNAME, IFILEX
      GO TO 7000
   50 WRITE ( IWR, 55 ) XNAME, IFILEX
      GO TO 99999
   60 WRITE ( IWR, 65 ) XNAME, IFILEX
      GO TO 99999
   70 WRITE ( IWR, 75 ) XNAME, IFILEX
      GO TO 7000
   80 CONTINUE
      WRITE ( LOUT, 85 ) XNAME, IFILEX, IDSN
      GO TO 90000
   90 WRITE ( IWR, 95 ) NBLOCK
      GO TO 99999
  100 CONTINUE
      GO TO 7000
 1000 ITEMP = IFLAG - 100
      GO TO ( 1010, 1020, 1030, 1040, 1050, 1060, 1070, 1080
     *       ,1090, 1100, 1110, 1120, 1130, 1140, 1150, 1160
     *       ,1170, 1180, 1190, 1200, 1210, 1220, 1230, 1240
     *       ), ITEMP
C1010 WRITE ( IWR, 1015 ) IOERR
 1010 GO TO 7000
 1020 WRITE ( IWR, 1025 ) XNAME, IFILEX
      GO TO 7000
 1030 WRITE ( IWR, 1035 ) XNAME, IFILEX
      GO TO 7000
 1040 WRITE ( IWR, 1045 ) XNAME, IFILEX
      GO TO 7000
 1050 WRITE ( IWR, 1055 ) XNAME, IFILEX
      GO TO 7000
 1060 WRITE ( IWR, 1065 ) XNAME, IFILEX
      GO TO 7000
 1070 WRITE ( IWR, 1075 ) XNAME, IFILEX
      GO TO 7000
 1080 WRITE ( IWR, 1085 ) XNAME, IFILEX
      GO TO 7000
 1090 WRITE ( IWR, 1095 ) XNAME, IFILEX
      GO TO 7000
 1100 WRITE ( IWR, 1105 ) XNAME, IFILEX
      GO TO 7000
 1110 WRITE ( IWR, 1115 ) XNAME, IFILEX
      GO TO 7000
 1120 WRITE ( IWR, 1125 ) XNAME, IFILEX
      GO TO 7000
 1130 WRITE ( IWR, 1135 ) XNAME, IFILEX
      GO TO 7000
 1140 WRITE ( IWR, 1145 ) XNAME, IFILEX
      GO TO 7000
 1150 WRITE ( IWR, 1155 ) XNAME, IFILEX
      GO TO 7000
 1160 WRITE ( IWR, 1165 ) XNAME, IFILEX
      GO TO 7000
 1170 WRITE ( IWR, 1175 ) XNAME, IFILEX
      GO TO 7000
 1180 WRITE ( IWR, 1185 ) XNAME, IFILEX
      GO TO 7000
 1190 WRITE ( IWR, 1195 ) XNAME, IFILEX
      GO TO 7000
 1200 WRITE ( IWR, 1205 ) XNAME, IFILEX
      GO TO 7000
 1210 WRITE ( IWR, 1215 ) XNAME, IFILEX
      GO TO 7000
 1220 WRITE ( IWR, 1225 ) XNAME, IFILEX
      GO TO 7000
 1230 CONTINUE
 1240 CONTINUE
 7000 CONTINUE
7770  CONTINUE
      WRITE ( IWR, 91000 ) IOERR, NAME, XNAME, IFILEX
      WRITE ( IWR, 92000 )
      DO 7772 I = 1, MAXFCB
      CALL DSHXDD ( I, MDSFCB( 1, I ), 3 )
 7772 CONTINUE
      WRITE( IWR, 92001 )
      DO 7773 I = 1, 80
CWKBR NCL93007 11/94
C      WRITE ( IWR, 92003 ) I, ( FCB(K,I),K=1,15)
      WRITE ( IWR, 92003 ) I, ( FCB(K,I),K=1,17)
CWKBR NCL93007 11/04
C92003 FORMAT(I3,'-',I3,I7,4I5,I12,I2,4I7,1X,2A4,I4)
92003 FORMAT(I3,'-',I3,I7,4I5,I12,I2,4I7,1X,2A4,I4,2I8)
 7773 CONTINUE
      WRITE ( IWR, 92002)IDBBAS, IDBFRE, IDBDIR, INDBAS, INDCLR, INDCBP
     &,                  NBLOCK, LENALC, IOCODE, IFILEX, NAME,   MAXALC
     &,                  MAXBLK, MAXDSK, IDBLEN, IDBADR, IBASBF, INDDIR
     &,                  NUMOPN, NUMCLS, NUMWRI, NUMREA, LENOPC
92002 FORMAT(/,' CONTENTS OF / DBM / FOLLOW:'
     &,/,' IDBBAS =',I8,' IDBFRE =',I8,' IDBDIR =',I8,' INDBAS =',I8
     &,/,' INDCLR =',I8,' INDCBP =',I8,' NBLOCK =',I8,' LENALC =',I8
     &,/,' IOCODE =',I8,' IFILEX =',I8,' NAME   =',I8,' MAXALC =',I8
     &,/,' MAXBLK =',I8,' MAXDSK =',I8,' IDBLEN =',I8,' IDBADR =',I8
     &,/,' IBASBF =',I8,' INDDIR =',I8,' NUMOPN =',I8,' NUMCLS =',I8
     &,/,' NUMWRI =',I8,' NUMREA =',I8,' LENOPC =',I8)
      IF ( IFLAG .GE. 118 .AND. IFLAG .LE. 120 ) GO TO 946
      WRITE ( IWR, 95020 )
      CALL DSHXDP ( NFILES, 16 )
      WRITE ( IWR, 95030 )
      CALL DSHXDP ( BLKSIZ, 1 )
      WRITE ( IWR, 96000 )
      CALL DSHXDP ( IEOR, 59 )
      WRITE ( IWR, 97000 )
      DO 944 I = 1, MAXPRI
      WRITE ( IWR, 97001 ) I, IFLPOS(1,I), IFLPOS(2,I)
97001 FORMAT(I5,2I10)
  944 CONTINUE
      LOOP = (NBUFF+LENDSP) / 8 + 4
      INDEX = INDBAS
      WRITE ( IWR, 94510 )
      DO 945 I = 1, LOOP
      III = (I-1) * 8 + 1
      CALL DSHXDD ( III, IBASE( INDEX ), 8 )
      INDEX = INDEX + 8
  945 CONTINUE
      CALL DBMDIA
  946 IF ( IFLAG .NE. 777 ) GO TO 99999
C     CALL TRBK( IWR )
      RETURN
91000 FORMAT(' I/O ERROR #',I6,' ON FILE ',Z8,' NAME=',2A4,' UNIT=',I4)
92000 FORMAT(//' CONTENTS OF MDSFCB' )
92001 FORMAT(//' CONTENTS OF FCB' )
94510 FORMAT(//' CONTENTS OF I/O BUFFER' )
95020 FORMAT(//' CONTENTS OF SOFCOM ')
95030 FORMAT(//' CONTENTS OF SYS ')
96000 FORMAT(//' CONTENTS OF /DSIO/')
97000 FORMAT(//' CONTENTS OF /DDIOSV/')
99999 CALL MESAGE (-61, 0, 0)
90000 CONTINUE
      RETURN
   15 FORMAT( 40X, A6, 2A4, 2X, I2 )
   35 FORMAT( ' BUFFER CONFLICTS WITH EXISTING BUFFERS',
     * ' ON FILE ',2A4, ' LOGICAL UNIT', I4 )
   45 FORMAT(' ATTEMPT TO READ FILE OPENED FOR WRITE',
     * ' FILE=',2A4,' UNIT=',I4 )
   55 FORMAT(' FILE IS ALREADY OPENED-FILE ',2A4,
     * ' UNIT=', I4 )
   65 FORMAT(' ATTEMPT TO WRITE LESS THAN ONE WORD',
     *       ' ON FILE ',2A4,' UNIT= ',I4 )
   75 FORMAT(' ATTEMPT TO WRITE ON FILE OPENED FOR READ ',
     *       '-FILE=',2A4,' UNIT =',I4)
   85 FORMAT(//,' ****** GINO SUBSYSTEM WILL EXTEND FILE ',2A4,
     *       ' ON UNIT',I4,' TO UNIT',I4,' ******' )
   95 FORMAT(//,' INSUFFICIENT SPACE ALLOCATION ON FILE NPTP',
     *      ' -, NUMBER OF BLOCKS WRITTEN WERE ',I10)
 1015 FORMAT(' ERROR DURING I/O REQUEST - ERROR FLAG=',Z8)
 1025 FORMAT(' INCORRECT BLOCK NUMBER ENCOUNTERED',
     *       ' ON FILE ',2A4,' UNIT=',I4)
 1035 FORMAT(' EXPECTED RH, SB, EF, OR EB CONTROL WORD',
     *       ' ON FILE ',2A4,' UNIT=',I4)
 1045 FORMAT(' EXPECTED RT CONTROL WORD ON FILE ',2A4,
     *       ' UNIT=',I4)
 1055 FORMAT(' EXPECTED RH OR EF CONTROL WORD ON FILE ',2A4,
     *       ' UNIT=',I4)
 1065 FORMAT(' EXPECTED RH, EB OR SB CONTROL WORD ON FILE ',2A4,
     *       ' UNIT=',I4)
 1075 FORMAT(' REFERENCE IS MADE TO FILE ',2A4,
     *       ' THAT IS NOT OPENED-UNIT=',I4)
 1085 FORMAT(' INSUFFICIENT SPACE FOR I/O CONTROL WORDS ON FILE '
     *         ,2A4,' UNIT=',I4)
 1095 FORMAT(' TOO MANY TERMS WRITTEN TO STRING ON FILE ',2A4,
     *        ' UNIT=',I4)
 1105 FORMAT(' EXPECTED A SB OR EB CONTROL WORD ON FILE ',2A4,
     *       ' UNIT=',I4)
 1115 FORMAT(' EXPECTED A CH CONTROL WORD ON FILE ',2A4,
     *        ' UNIT=',I4)
 1125 FORMAT(' EXPECTED A SE, SD, CT, OR SH CONTROL WORD ON FILE ',
     *        2A4,' UNIT=',I4)
 1135 FORMAT(' ERROR  - CLR.GT. LCW  ON FILE ',2A4, ' UNIT=',I4)
 1145 FORMAT(' EXPECTED A RT CONTROL WORD ON FILE ',2A4, ' UNIT=',I4)
 1155 FORMAT(' EXPECTED A CH CONTROL WORD ON FILE ',2A4,' UNIT=',I4)
 1165 FORMAT(' EXPECTED A CH,ST,SH,SD,RT, OR SE CONTROL WORD ON FILE ',
     *        2A4,' UNIT=',I4)
 1175 FORMAT(' EXPECTED A ST CONTROL WORD ON FILE ',2A4, ' UNIT=',I4)
 1185 FORMAT(' TYPIN OR TYPOUT FOR MATRIX PACK IS OUT OF RANGE ON',
     *       ' FILE ',2A4,' UNIT=',I4)
 1195 FORMAT(' NON-ASCENDING ROW NUMBER GIVEN',
     *       ' ON FILE ',2A4, ' UNIT=',I10)
 1205 FORMAT(' FILE NAME DOES NOT MATCH STRING CONTROL BLOCK FOR ',
     *       'FILE ',2A4,' UNIT=',I4)
 1215 FORMAT(' INVALID UNIT NUMBER IN MDSFCB FOR FILE ',2A4,' UNIT=',I4)
 1225 FORMAT(' INSUFFICIENT NUMBER OF FILES AVAILABLE FOR FILE ',
     *       2A4,' UNIT=',I4)
      END

      FUNCTION KORSZ ( I )
      COMMON / LOGOUT / LOUT
      COMMON / LSTADD / LASTAD
      KORSZ = LASTAD - LOCFX(I) + 1
      CALL SSWTCH ( 13, L13 )
      IF ( L13.NE.0 ) WRITE ( LOUT, 2000 ) KORSZ
      RETURN
2000  FORMAT(22X,' --- OPEN CORE =',I8,' WORDS (DECIMAL) ---')
      END

      SUBROUTINE BISLOC (*,ID,ARR,LEN,KN,JLOC)
C-----
C     BINARY SEARCH - LOCATE KEY WORD 'ID' IN ARRAY 'ARR', 1ST ENTRY
C     IF FOUND, 'JLOC' IS THE MATCHED POSITION IN 'ARR'
C     IF NOT FOUND, NON-STANDARD RETURN
C                                                     I.E.
C     ID  = KEY WORD TO MATCH IN ARR.      MATCH AGAINST 1ST COL OF ARR
C     ARR = ARRAY TO SEARCH.                          ARR(ROW,COL)
C     LEN = LENGTH OF EACH ENTRY IN ARRAY.            LEN=ROW
C     KN  = NUMBER OF ENTRIES IN THE ARR.             KN =COL
C     JLOC= POINTER RETURNED - FIRST WORD OF ENTRY.   MATCHED ROW
C-----
C
      INTEGER  ARR(1)
      DATA     ISWTCH / 16 /
C
      JJ = LEN - 1
      IF (KN .LT. ISWTCH) GO TO 120
      KLO = 1
      KHI = KN
   10 K   = (KLO+KHI+1)/2
   20 J   = K*LEN - JJ
      IF (ID-ARR(J)) 30,90,40
   30 KHI = K
      GO TO 50
   40 KLO = K
   50 IF (KHI-KLO -1) 100,60,10
   60 IF (K .EQ. KLO) GO TO 70
      K   = KLO
      GO TO 80
   70 K   = KHI
   80 KLO = KHI
      GO TO 20
   90 JLOC = J
      RETURN
  100 JLOC = KHI*LEN - JJ
      J    = KN *LEN - JJ
      IF (ID .GT.ARR(J)) JLOC = JLOC + LEN
  110 RETURN 1
C
C     SEQUENTIAL SEARCH MORE EFFICIENT
C
  120 KHI = KN*LEN - JJ
      DO 130 J = 1,KHI,LEN
      IF (ARR(J)-ID) 130,90,140
  130 CONTINUE
      JLOC = KHI + LEN
      GO TO 110
  140 JLOC = J
      GO TO 110
      END

      SUBROUTINE STRNAM ( IELT, ISCAN, NAME )
      CHARACTER*12    NAME
      LOGICAL        LAYERD
      COMMON / XSCANX / DUM(21), LAYERD
      COMMON / SYSTEM / ISYSBF, NOUT
C      PRINT *,' ENTERRING STRNAM,IELT,ISCAN=',IELT,ISCAN
      NAME= ' '
      IF ( IELT .NE. 1 .AND. IELT .NE. 3 .AND. IELT .NE. 10 ) GO TO 10
C ROD, TUBE, CONROD
      IF ( ISCAN .EQ. 2 ) NAME='AXIAL'
      IF ( ISCAN .EQ. 4 ) NAME='TORSIONAL'
      IF ( ISCAN .EQ. 3 ) NAME='MARGIN'
      IF ( ISCAN .EQ. 5 ) NAME='MARGIN'
      GO TO 7000
10    IF ( IELT .NE. 4 .AND. IELT .NE. 5 ) GO TO 20
C SHEAR, TWIST
      IF ( ISCAN .EQ. 2 ) NAME='MAX-SHR'
      IF ( ISCAN .EQ. 4 ) NAME='MARGIN'
      IF ( ISCAN .EQ. 3 ) NAME='AVG'
      GO TO 7000
20    IF ( IELT .NE. 6  .AND. IELT .NE. 17 .AND. IELT .NE. 19 .AND.
     &     IELT .NE. 18 .AND. IELT .NE. 7  .AND. IELT .NE. 8  .AND.
     &     IELT .NE. 15 ) GO TO 30
C TRIA1, TRIA2, QUAD1, QUAD2, TRBSC, TRPLT, QDPLT
      IF ( ISCAN .EQ. 3 .OR. ISCAN .EQ. 11 ) NAME='NORM-X'
      IF ( ISCAN .EQ. 4 .OR. ISCAN .EQ. 12 ) NAME='NORM-Y'
      IF ( ISCAN .EQ. 5 .OR. ISCAN .EQ. 13 ) NAME='SHEAR-XY'
      IF ( ISCAN .EQ. 7 .OR. ISCAN .EQ. 15 ) NAME='MAJOR'
      IF ( ISCAN .EQ. 8 .OR. ISCAN .EQ. 16 ) NAME='MINOR'
      IF ( ISCAN .EQ. 9 .OR. ISCAN .EQ. 17 ) NAME='MAX-SHR'
      GO TO 7000
30    IF ( IELT .NE. 9 .AND. IELT .NE. 16 .AND. IELT .NE. 62 .AND.
     &     IELT .NE. 63 ) GO TO 40
C TRMEM, QDMEM, QDMEM1, QDMEM2
      IF ( ISCAN .EQ. 2 ) NAME='NORM-X'
      IF ( ISCAN .EQ. 3 ) NAME='NORM-Y'
      IF ( ISCAN .EQ. 4 ) NAME='SHEAR-XY'
      IF ( ISCAN .EQ. 6 ) NAME='MAJOR'
      IF ( ISCAN .EQ. 7 ) NAME='MINOR'
      IF ( ISCAN .EQ. 8 ) NAME='MAX-SHR'
      GO TO 7000
40    IF ( IELT .NE. 11 .AND. IELT .NE. 12 .AND. IELT .NE. 13 .AND.
     &     IELT .NE. 80 ) GO TO 50
C ELAS1, ELAS2, ELAS3, IS2D8
      IF ( ISCAN .EQ. 2 ) NAME='OCT-SHR'
      GO TO 7000
50    IF ( IELT .NE. 34 .AND. IELT .NE. 81 ) GO TO 60
C BAR, ELBOW
      IF ( ISCAN .EQ. 7 .OR. ISCAN .EQ. 8 ) NAME='SB-MAX'
      IF ( ISCAN .EQ. 14.OR. ISCAN .EQ.15 ) NAME='SB-MAX'
      IF ( ISCAN .EQ. 9 .OR. ISCAN .EQ.16 ) NAME='MARGIN'
      IF ( ISCAN .EQ. 6 ) NAME='AXIAL'
      GO TO 7000
60    IF ( IELT .NE. 35 ) GO TO 70
C CONEAX
      IF ( ISCAN .EQ. 4 .OR. ISCAN .EQ. 22 ) NAME='NORM-U'
      IF ( ISCAN .EQ. 5 .OR. ISCAN .EQ. 23 ) NAME='NORM-V'
      IF ( ISCAN .EQ. 6 .OR. ISCAN .EQ. 24 ) NAME='SHEAR-UV'
      IF ( ISCAN .EQ. 8 .OR. ISCAN .EQ. 26 ) NAME='MAJOR'
      IF ( ISCAN .EQ. 9 .OR. ISCAN .EQ. 27 ) NAME='MINOR'
      IF ( ISCAN .EQ. 10.OR. ISCAN .EQ. 28 ) NAME='MAX-SHR'
      GO TO 7000
70    IF ( IELT .NE. 36 ) GO TO 80
C TRIARG
      IF ( ISCAN .EQ. 2 ) NAME='RADIAL'
      IF ( ISCAN .EQ. 3 ) NAME='CIRCUM'
      IF ( ISCAN .EQ. 4 ) NAME='AXIAL'
      IF ( ISCAN .EQ. 5 ) NAME='SHEAR'
      GO TO 7000
80    IF ( IELT .NE. 37 ) GO TO 90
C TRAPRG
      KSCAN = MOD( ISCAN, 4 )
      IF ( KSCAN .EQ. 2 .AND. ISCAN .NE. 18 ) NAME='RADIAL'
      IF ( KSCAN .EQ. 3 ) NAME='CIRCUM'
      IF ( KSCAN .EQ. 0 ) NAME='AXIAL'
      IF ( KSCAN .EQ. 1 ) NAME='SHEAR'
      IF ( KSCAN .EQ. 2 .AND. ISCAN .NE. 2 ) NAME='SHR-FORC'
      GO TO 7000
90    IF ( IELT .NE. 38 ) GO TO 100
C TORDRG
      KSCAN = MOD( ISCAN, 5 )
      IF ( KSCAN .EQ. 2 ) NAME='MEM-T'
      IF ( KSCAN .EQ. 3 ) NAME='MEM-C'
      IF ( KSCAN .EQ. 4 ) NAME='FLEX-T'
      IF ( KSCAN .EQ. 0 ) NAME='FLEX-C'
      IF ( KSCAN .EQ. 1 ) NAME='SHR-FORC'
      GO TO 7000
100   IF ( IELT .NE. 65 .AND. IELT .NE. 66 ) GO TO 110
C IHEX1, IHEX2
      KSCAN = MOD( ISCAN, 22 )
      IF ( KSCAN .EQ. 3 ) NAME='NORM-X'
      IF ( KSCAN .EQ. 4 ) NAME='SHEAR-XY'
      IF ( KSCAN .EQ. 5 ) NAME='PRINC-A'
      IF ( KSCAN .EQ. 9 ) NAME='MEAN'
      IF ( KSCAN .EQ.11 ) NAME='NORM-Y'
      IF ( KSCAN .EQ.12 ) NAME='SHEAR-YZ'
      IF ( KSCAN .EQ.13 ) NAME='PRINC-B'
      IF ( KSCAN .EQ.17 ) NAME='NORM-Z'
      IF ( KSCAN .EQ.18 ) NAME='SHEAR-ZX'
      IF ( KSCAN .EQ.19 ) NAME='PRINC-C'
      IF ( KSCAN .EQ.10 ) NAME='MAX-SHR'
      GO TO 7000
110   IF ( IELT .NE. 67 ) GO TO 120
C IHEX3
      KSCAN = MOD( ISCAN, 23 )
      IF ( KSCAN .EQ. 3 ) NAME='NORM-X'
      IF ( KSCAN .EQ. 4 ) NAME='SHEAR-XY'
      IF ( KSCAN .EQ. 5 ) NAME='PRINC-A'
      IF ( KSCAN .EQ. 9 ) NAME='MEAN'
      IF ( KSCAN .EQ.12 ) NAME='NORM-Y'
      IF ( KSCAN .EQ.13 ) NAME='SHEAR-YZ'
      IF ( KSCAN .EQ.14 ) NAME='PRINC-B'
      IF ( KSCAN .EQ.18 ) NAME='NORM-Z'
      IF ( KSCAN .EQ.19 ) NAME='SHEAR-ZX'
      IF ( KSCAN .EQ.20 ) NAME='PRINC-C'
      IF ( KSCAN .EQ.10 ) NAME='MAX-SHR'
      GO TO 7000
120   IF ( IELT .NE. 70 .AND. IELT .NE. 71 ) GO TO 130
C TRIAAX, TRAPAX
      KSCAN = MOD ( ISCAN, 8 )
      IF ( KSCAN .EQ. 3 ) NAME='RADIAL'
      IF ( KSCAN .EQ. 4 ) NAME='AXIAL'
      IF ( KSCAN .EQ. 5 ) NAME='CIRCUM'
      IF ( KSCAN .EQ. 6 ) NAME='MEM-C'
      IF ( KSCAN .EQ. 7 ) NAME='FLEX-T'
      IF ( KSCAN .EQ. 0 ) NAME='FLEX-C'
      GO TO 7000
130   IF ( IELT .NE. 64 .AND. IELT .NE. 83 ) GO TO 150
C QUAD4, TRIA3 WITHOUT LAMINATION
      IF ( LAYERD ) GO TO 140
      IF ( ISCAN .EQ. 3 .OR. ISCAN .EQ. 11 ) NAME='NORMAL-X'
      IF ( ISCAN .EQ. 4 .OR. ISCAN .EQ. 12 ) NAME='NORMAL-Y'
      IF ( ISCAN .EQ. 5 .OR. ISCAN .EQ. 13 ) NAME='SHEAR-XY'
      IF ( ISCAN .EQ. 7 .OR. ISCAN .EQ. 15 ) NAME='MAJOR'
      IF ( ISCAN .EQ. 18.OR. ISCAN .EQ. 16 ) NAME='MINOR'
      IF ( ISCAN .EQ. 9 .OR. ISCAN .EQ. 17 ) NAME='MAX-SHR'
      GO TO 7000
140   CONTINUE
C   QUAD4 AND TRIA3 WITH LAMINATION
      KSCAN = MOD( ISCAN, 10 )
      IF ( ISCAN .EQ. 5 ) NAME='NORMAL-1'
      IF ( ISCAN .EQ. 6 ) NAME='NORMAL-2'
      IF ( ISCAN .EQ. 7 ) NAME='SHEAR-12'
      IF ( ISCAN .EQ. 0 ) NAME='SHEAR-1Z'
      IF ( ISCAN .EQ. 1 ) NAME='SHEAR-2Z'
      GO TO 7000
150   WRITE ( NOUT, 901 ) IELT
901   FORMAT(//,' SCAN MODULE PROCESSING UNKNOWN ELEMENT NUMBER '
     &       ,I8,//)
      CALL MESAGE( -61,0,0)
7000  CONTINUE
C      PRINT *,' RETURNING FROM STRNAM,FIELD=',NAME
      RETURN
      END

      SUBROUTINE UNPSCR (IN,OUT,Z,BUF1,BUF2,MAXZ,TYSIGN,FLAG)
C
C     THIS ROUTINE UNPACKS A MATRIX (IN), AND TRANSFER THE DATA FROM
C     FIRST TO LAST NON-ZERO TERMS TO A SCRATCH FILE (OUT) IN VERY LARGE
C     RECORD(S), PRECEEDED BY THE FIRST AND LAST NON-ZERO TERM POINTERS.
C
C     INPPUT  - IN, + 7 TRAILER WORDS (WORDS 4,5,6, AND 7 WILL BE
C               OVERWRITTEN)
C               Z, BUF1, BUF2, MAXZ, TYSIGN, AND FLAG
C     OUTPUT  - OUT, NO TRAILER WORD WRITTEN
C               IN(4) = 10*(NO. OF RECONDS WRITTEN, HEADER RECORD
C                       EXCLUDED) + FLAG
C               IN(5) = DATA WORD TYPE UNPACKED (= 1,2,OR 4)
C               IN(6) = TOTAL NO. OF S.P. WORDS USED FOR INPUT MATRIX
C                       IN FORWARD UNPACK PASS
C               IN(7) = OUTPUT GINO NUMBER
C
C     FLAG = 1, THE MATRIX IS UNPACKED ONCE, IN FORWARD DIRECTION, THIS
C               MATRIX CAN BE IN GENERAL FORM; NEEDS NOT BE TRIANGULAR.
C     FLAG = 2, THE MATRIX IS UNPACKED FORWARD AND BACKWARD
C     FLAG = 3, THE MATRIX IS ADVANCED TO THE END AND UNPACKED BACKWARD
C               ONCE AND THEN FORWARD
C     MAXZ = n, WHERE n IS THE UPER LIMIT OF THE RECORD SIZE TO BE
C               WRITTEN (5000 MINIMUM).
C          = 0  OR LESS, OUTPUT WILL BE WRITTEN OUT IN EITHER ONE OR TWO
C               LONG RECORDS (ONE EACH FOR FORWARD AND BACKWARD UNPACK)
C     Z    =    WORKING SPACE, MINIMUM SIZE = ROW + 2 WORDS
C     TYSIGN =  (-4,-3,...,+4), IS TYPE AND SIGN FOR INPUT MATRIX UNPACK
C               NO TYPE AND SIGN CHANGE IF TYSIGN = 0.
C     BUF1, BUF2 = TWO GINO BUFFERS
C     SUBROUTINE DEBUG CAN BE ACTIVATED BY DIAG 11 OR 16
C
C     ASSUME MATRIX IN(5x5) =  a  0  0  0  0
C                              b  e  0  0  0
C                              c  f  g  0  0
C                              d  0  h  j  0
C                              0  0  i  k  l
C
C     OUTPUT FILE OUT WILL HAVE THE FOLLOWING DATA (PRECEEDED BY HEADER
C     RECORD)
C
C     FLAG 1 -  1 4 a b c d 2 3 e f 3 5 g h i 4 5 j k 5 5 l <EOF>
C     FLAG 2 -  1 4 a b c d 2 3 e f 3 5 g h i 4 5 j k 5 5 l <EOR>
C               5 5 l 4 5 j k 3 5 g h i 2 4 e f 1 4 a b d c <EOF>
C     FLAG 3 -  5 5 l 4 5 j k 3 5 g h i 2 3 e f 1 4 a b c d <EOR>
C               1 4 a b c d 2 3 e f 3 5 g h i 4 5 j k 5 5 l <EOF>
C
C     WHERE a thru l MAY BE SP, DP, CSP, OR CDP DATA
C
C     IF INPUT MATRIX IS VERY LARGE, THERE WILL BE SEVERAL LONG RECORDS
C     FOR EACH UNPACK PASS, AND EACH RECORD WILL NOT EXCEED MAXZ IN
C     LENGTH. MINIMUM OF MAXZ IS 5000. IF MAXZ IS NOT GIVEN, EACH UNPACK
C     PASS WILL GO TO ONE VERY VERY LONG RECORD. IN THIS CASE, MAXZ IS
C     SET TO 2**31
C
C     THE PURPOSE OF THIS ROUTINE IS TO AVOID UNPACKING A MATRIX TOO
C     MANY TIMES, WHILE THE MATRIX IS BEING USED REPEATEDLY.
C     SEE FBSII (REPEATEDLY CALLED BY FBS), FRBK2 (REPEATEDLY CALLED
C     BY FNXTVC), AND FRMLTD (REPEATED CALLED BY FRBK2 AND FNXTVC) IN
C     USING THIS NEW DATA FORMAT.
C
C     WRITTEN BY G.CHAN/UNISYS   11/1991
C
C     COMMENTS FROM G.C.  3/93
C     THE PRESENT UNPSCR ASSUMES THE MATRIX IS QUIT DENSE, SUCH AS THE
C     LOWER OR UPPER TRIANGULAR FACTORS. IF MATRIX IS SPARSE, SAY 33
C     PERCENT OF LESS, WE COULD WRITE THE MATRIX OUT ANOTHER WAY AND
C     SAVE LOTS OF DISC SPACE. WE COULD WRITE THE FIRST TO LAST NON-ZERO
C     TERMS IN STRING FORMS SIMILAR TO OUTPUT4 MODULE. THIS IMPROVEMENT
C     WILL BE LEFT FOR NEXT PROJECT.
C
      IMPLICIT INTEGER (A-Z)
      LOGICAL         FLAG23,DEBUG
      INTEGER         IN(7),Z(3),NAM(2),TYIIJJ(4),SAVE(4)
      CHARACTER*8     FBWD,FORWD,BACKWD
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG / UFM,UWM,UIM,SFM
      COMMON /SYSTEM/ SYSBUF,NOUT
      COMMON /UNPAKX/ TYPE,II,JJ,INCR
      COMMON /NAMES / RD,RDREW,WRT,WRTREW,REW
      COMMON /TYPE  / RC(2),WORDS(4)
      EQUIVALENCE     (TYPE,TYIIJJ(1))
      DATA    FORWD , BACKWD / 'FORWARD','BACKWARD'/
      DATA    NAM   / 4HUNPS , 2HCR  /
C
      IF (FLAG.LT.1 .OR. FLAG.GT.3 .OR. IN(1).EQ.OUT) GO TO 300
      CALL SSWTCH (11,I)
      CALL SSWTCH (16,J)
      DEBUG = .FALSE.
      IF (I+J .GE. 1) DEBUG = .TRUE.
      MAX = MAXZ
      IF (MAX .LE. 0) MAX = 1073741824
      IF (DEBUG) WRITE (NOUT,5) UIM
    5 FORMAT (A29,', UNPSCR DEBUG, ACTIVATED BY DIAG 11 AND/OR 16')
      IF (MAX .LT. 5000) GO TO 280
      FLAG23 = FLAG.EQ.2 .OR. FLAG.EQ.3
      DO 10 I = 1,4
   10 SAVE(I) = TYIIJJ(I)
      TYPE = IN(5)
      NL   = IN(2)
      IF (TYSIGN.NE.0 .AND. IABS(TYSIGN).LE.4) TYPE = TYSIGN
      NWDS = WORDS(IABS(TYPE))
      IF (DEBUG) WRITE (NOUT,15) IN(1),OUT,MAXZ,MAX,FLAG,NL,TYPE,NWDS
   15 FORMAT (5X,'UNPSCR/@15  IN,OUT,MAXZ,MAX,FLAG,NL,TYPE,NWDS = ',
     1        2I5,2I12,I4,I7,2I4)
      INCR = 1
      FORM = IN(4)
      IF (FLAG23 .AND. FORM.NE.4 .AND. FORM.NE.5) GO TO 260
C                          LOWER  AND      UPPER  TRIANGULAR FACTORS
C
      FILE = OUT
      CALL GOPEN (OUT,Z(BUF2),WRTREW)
      FILE = IN(1)
      CALL OPEN (*200,IN,Z(BUF1),RDREW)
      NREC = 0
      IF (FLAG .EQ. 3) GO TO 90
   20 CALL FWDREC (*210,IN)
C
C     UNPACK FORWARD
C
      FBWD = FORWD
      TOT  = 0
      SUM  = 0
      DO 80 I = 1,NL
      II   = 0
      CALL UNPACK (*60,IN,Z(3))
      IF (FLAG23 .AND. II.NE.I) GO TO 220
   30 Z(1) = II
      Z(2) = JJ
      LL   = (JJ-II+1)*NWDS + 2
      TOT  = TOT + LL
      SUM  = SUM + LL
      IF (SUM .LE. MAX) GO TO 50
      NREC = NREC + 1
      CALL WRITE (OUT,0,0,1)
      SUM  = SUM - LL
      IF (DEBUG) WRITE (NOUT,40) NREC,SUM,FBWD
   40 FORMAT (5X,'UNPSCR WROTE RECORD',I5,',  NO. OF WORDS =',I9,2X,A8)
      SUM  = LL
   50 CALL WRITE (OUT,Z(1),LL,0)
      GO TO 80
   60 IF (FLAG23) GO TO 240
      II   = I
      JJ   = I
      DO 70 K = 3,6
   70 Z(K) = 0
      GO TO 30
   80 CONTINUE
      NREC = NREC + 1
      CALL WRITE (OUT,0,0,1)
      IF (DEBUG) WRITE (NOUT,40) NREC,SUM,FBWD
      IF (FLAG .NE. 2) GO TO 150
      CALL BCKREC (IN)
      GO TO 100
C
   90 CALL SKPREC (IN,NL)
C
C     UNPACK BACKWARD
C
  100 FBWD = BACKWD
      SUM  = 0
      I    = NL
      DO 120 J = 1,NL
      II   = 0
      CALL UNPACK (*240,IN,Z(3))
      IF (II .NE. I) GO TO 220
      Z(1) = II
      Z(2) = JJ
      LL   = (JJ-II+1)*NWDS + 2
      SUM  = SUM + LL
      IF (SUM .LE. MAX) GO TO 110
      NREC = NREC + 1
      CALL WRITE (OUT,0,0,1)
      SUM  = SUM - LL
      IF (DEBUG) WRITE (NOUT,40) NREC,SUM,FBWD
      SUM  = LL
  110 CALL WRITE (OUT,Z(1),LL,0)
      CALL BCKREC (IN)
      CALL BCKREC (IN)
  120 I    = I - 1
      NREC = NREC + 1
      CALL WRITE (OUT,0,0,1)
      IF (DEBUG) WRITE (NOUT,40) NREC,SUM,FBWD
      IF (FLAG .EQ. 3) GO TO 20
C
C     END OF UNPACKING
C
C     CHANGE LAST 4 WORDS OF THE INPUT MATRIX TRAILER. PARTICULARY, SET
C     THE 7TH WORD TO NEGATIVE. NOTE, IF FLAG IS 2 OR 3, IN(4) AND IN(6)
C     TRAILER WORDS HOLD HALF OF THE ACTUAL VALUES.
C     NOTE - SINCE WRTTRL IS NOT CALLED TO REGISTER THESE TRAILER WORD
C     CHANGES, THE TRAILER WORDS ARE INTENDED FOR THE ROUTINE TO BE
C     EXECUTE NEXT.  ALSO NOTE THAT OUTPUT FILE HAS NO TRAILER.
C     LASTLY, WE NEED TO RESTORE ORIGINAL WORDS IN /UNPAKX/ PREVIOUSLY
C     SAVED.
C
  150 CALL CLOSE (IN, REW)
      CALL CLOSE (OUT,REW)
      IN(7) =-OUT
      IN(6) = TOT
      IN(5) = NWDS
      I     = NREC
      IF (.NOT.FLAG23) GO TO 160
      I     = NREC/2
      TOT   = TOT*2
  160 IN(4) = 10*I + FLAG
      DO 170 I = 1,4
  170 TYIIJJ(I) = SAVE(I)
      IF (.NOT.DEBUG) GO TO 350
      WRITE  (NOUT,180) UIM,TOT,NREC,NL,IN(3)
  180 FORMAT (A29,1H,,I10,' S.P. WORDS MOVED TO SCRATCH FILE BY UNPSCR',
     1        /5X,'IN',I5,' RECORDS.', 5X,'INPUT MATRIX =',I8,3H BY,I7)
      GO TO 350
C
  200 J = -1
      GO TO 330
  210 J = -2
      GO TO 330
  220 WRITE  (NOUT,230) SFM,I,II,JJ,FBWD,FLAG
  230 FORMAT (A25,',  I & II MISMATCH ',3I6,3H  /,A8,I9)
      GO TO 320
  240 WRITE  (NOUT,250) I,FBWD,FLAG
  250 FORMAT ('0*** NULL COLUMN ENCOUNTERED IN TRIANGULAR FACTOR.  ',
     1        'COLUMN',I7,3X,A8,I9)
      GO TO 320
  260 CALL FNAME (IN(1),IN(2))
      WRITE  (NOUT,270) IN(2),IN(3),FORM,FLAG
  270 FORMAT ('0*** INPUT MATRTIX ',2A4,' IS NOT A TRIANGULAR FACTOR.',
     1        '   FORM,FLAG =',2I4)
      CALL ERRTRC ('UNPSCR  ',270)
  280 WRITE  (NOUT,290) MAXZ
  290 FORMAT ('0*** MAXZ ERROR ',I9,'  (TOO SMALL)')
      CALL ERRTRC ('UNPSCR  ',290)
      GO TO 320
  300 WRITE  (NOUT,310) SFM,FLAG,IN(1),OUT
  310 FORMAT (A25,',  FLAG,IN(1),OUT =',3I5)
  320 J = -37
  330 CALL MESAGE (J,FILE,NAM)
C
  350 IF (DEBUG) WRITE (NOUT,360)
  360 FORMAT (' ... UNPSCR DEBUG ENDS',/)
      RETURN
      END

      SUBROUTINE TORDRD
C
C     THIS SUBROUTINE COMPUTES THE STIFFNESS MATRIX AND THE MASS MATRIX
C     FOR AN AXI-SYMMETRIC TORDIDAL THIN SHELL RING
C
C     DOUBLE PRECISION VERSION
C
C     THIS  SUBROUTINE USES ROUTINES  ROMBDK , DMATRX
C
C
C*****
C
C                        ECPT FOR THE TOROIDAL RING
C
C                                                       TYPE
C ECPT( 1) ELEMENT IDENTIFICATION                         I
C ECPT( 2) SCALAR INDEX NO. FOR GRID POINT A              I
C ECPT( 3) SCALAR INDEX NO. FOR GRID POINT B              I
C ECPT( 4) ANGLE OF CURVATURE AT GRID POINT A             R
C ECPT( 5) ANGLE OF CURVATURE AT GRID POINT B(NOT USED)   R
C ECPT( 6) MATERIAL ORIENTATION (NOT USED)                R
C ECPT( 7) MATERIAL IDENTIFICATION                        I
C ECPT( 8) MEMBRANE THICKNESS                             R
C ECPT( 9) FLEXURE THICKNESS                              R
C ECPT(10) COOR. SYS. ID. FOR GRID POINT A                I
C ECPT(11) X-COOR. OF GRID POINT A (IN BASIC COOR.)       R
C ECPT(12) Y-COOR. OF GRID POINT A (IN BASIC COOR.)       R
C ECPT(13) Z-COOR. OF GRID POINT A (IN BASIC COOR.)       R
C ECPT(14) COOR. SYS. ID. FOR GRID POINT B                I
C ECPT(15) X-COOR. OF GRID POINT B (IN BASIC COOR.)       R
C ECPT(16) Y-COOR. OF GRID POINT B (IN BASIC COOR.)       R
C ECPT(17) Z-COOR. OF GRID POINT B (IN BASIC COOR.)       R
C ECPT(18) EL. TEMPERATURE FOR MATERIAL PROPERTIES        R
C
C*****
C
      DOUBLE PRECISION CONSTD
      DIMENSION  IECPT(18),        ICS(2)
      REAL ECPT(17)
      DOUBLE PRECISION
     X   AM(144),GAMBQF(72),GAMBQM(48),EE(4),AK(144),GAMRS(144),AKI(36),
     X         DELINT(66),D(144),R(2),Z(2),KOUT(144),GAMBQ(144)
      DOUBLE PRECISION A1,A2,AKM(36),MOUT(144)
      DOUBLE PRECISION TWOPI,DEGRAD,PHIB,RP,S,SINA1,
     X                 SINA2,COSA1,COSA2,R1,R2,Z1,Z2,EP,ET,VPT,VTP,DEL,
     X                 DJP1
      INTEGER  DICT (9),ELID,ESTID
      LOGICAL  NOGO,HEAT
C
C
      COMMON /CONDAD/ CONSTD(5)
C
      COMMON   /MATIN/
     1                   MATIDC        ,MATFLG
     2,                  ELTEMP        ,STRESS
     3,                  SINTH         ,COSTH
      COMMON   /MATOUT/
     1                   E(3)          ,ANU(3)
     2,                  RHO           ,G(3)
     3,                  ALF(3)        ,TZERO,    GSUBE
      COMMON  /SYSTEM/ KSYSTM(55),HEAT
C
      COMMON  /EMGPRM/ DUM(15), ISMB(3),IPREC,NOGO,IHEAT
      COMMON  /EMGDIC/ IDM, LDICT,NGRIDS, ELID,ESTID
C
      COMMON  /EMGEST/ IDEL,IGP(2),ALPH(2),OM,MATID,TM,TF,ICS1,
     X                 XYZ(3),ICS2,XYZ2(3),TEMPE
C
      EQUIVALENCE (DICT5,DICT(5))
      EQUIVALENCE (IECPT(1),ECPT(1),IDEL)
      EQUIVALENCE ( CONSTD(2) , TWOPI  )
      EQUIVALENCE ( CONSTD(4) , DEGRAD )
      EQUIVALENCE        (GAMBQF(1), GAMBQ(1))
      EQUIVALENCE        (GAMBQM(1), GAMBQ(73))
      EQUIVALENCE        (DELINT(1), GAMBQ(1))
      EQUIVALENCE        (GAMRS(1),  GAMBQ(1))
      EQUIVALENCE (R1,R(1)),(R2,R(2)),(Z1,Z(1)),(Z2,Z(2))
C
C
C ----------------------------------------------------------------------
C
C     SET UP THE DICT ARRAY
C
      IPR= IPREC
      DICT(1) = ESTID
      DICT(3) = 12
      DICT(4) = 63
      ICS(1)= IECPT(10)
      ICS(2)= IECPT(14)
      R(1) = ECPT(11)
      D1   = ECPT(12)
      Z(1) = ECPT(13)
      R(2) = ECPT(15)
      D2   = ECPT(16)
      Z(2) = ECPT(17)
C
C
C TEST THE VALIDITY OF THE GRID POINT COORDINATES
C
      IF (R1 .LT. 0. .OR. R2 .LT. 0.) GO TO 7770
      IF (D1 .NE. 0. .OR. D2 .NE. 0.) GO TO 7770
C
C
C DETERMINE IF ELEMENT IS A TOROIDAL, CONICAL OR CYLINDRICAL RING
C
      ITORD = 0
      IF (ABS(ALPH(1) - ALPH(2)) .LE. 1.E-6)  ITORD = 1
      IF (ITORD .EQ. 1 .AND. ABS(ALPH(1)-90.) .LE. 1.E-5) ITORD=-1
C
C
C COMPUTE THE ELEMENT COORDINATES
C
      A1 = DBLE(ALPH(1)) * DEGRAD
      A2 = DBLE(ALPH(2)) * DEGRAD
      PHIB = A2 - A1
      SINA1 =  DSIN(A1)
      COSA1 =  DCOS(A1)
      SINA2 =  DSIN(A2)
      COSA2 =  DCOS(A2)
C
      IF (ITORD .NE. 0) GO TO 100
C
C FOR THE TOROIDAL RING
C
      RP = DSQRT((R2-R1)**2  + (Z2-Z1)**2) /(2.D0*DSIN(PHIB/2.D0))
      S  = PHIB * RP
      GO TO 110
C
C  FOR THE CONICAL OR CYLINDRICAL RING
C
  100 RP = 0.D0
      S  = DSQRT((R2-R1)**2  +  (Z2-Z1)**2)
C
C  COMPUTE THE BASIC AND REQUIRED INTEGRALS
C
C  SET UP THE ARRAY OF CONSTANTS FOR ROMBER INTEGRATION ROUTINE
C
  110 D(21) = 0.D0
      D(22) = RP
      D(23) = R1
      D(24) = COSA1
      D(25) = SINA1
C
C COMPUTE CONSTANTS NEEDED FOR INTEGRAL CALCULATIONS
C
      D(30) = R1 - RP * SINA1
      D(31) = RP * COSA1
      D(32) = RP * SINA1
      D(33) = COSA1 ** 2
      D(34) = SINA1 * COSA1
      D(35) = SINA1 ** 2
      D(36) = 0.5 - D(35)
C
C START LOOP  FOR CALCULATIONS OF INTEGRALS
C
      DO  260 JP1=1,11
      J = JP1 - 1
      K = (J * 6) + 1
      DJP1 = JP1
C
C TEST FOR ELEMENT SHAPE
C
      IF (ITORD) 240,120,170
C
C THE TOROIDAL RING BASIC INTEGRALS WILL BE COMPUTED IN
C LOCATIONS D(1),...,D(6)
C
  120 D(20) = (RP** JP1)
C
C COMPUTE I(J,1)
C
      D(1) = D(20) * (PHIB ** JP1) / DJP1
C
C COMPUTE I(J,2)
C
      D(2) = (PHIB**(JP1+1))/ (DJP1 + 1.)
      D(10)= 1.
      DO  130 I=1,20
      IP = JP1 + 2 * I + 1
      D(11) = 2 * I + 1
      D(10)= D(10)*D(11)*(D(11)-1.)
      D(12)= (-1.)**I * PHIB**IP/((DJP1+D(11))*D(10))
      D(13) =  DABS (D(12)/D(2))
      D(2) = D(2)+ D(12)
      IF (D(13) .LE. 1.D-10) GO TO 140
  130 CONTINUE
      GO TO 7780
  140 D(2) = D(20)*D(2)
C
C COMPUTE I(J,3)
C
      D(3) = (PHIB ** JP1) / DJP1
      D(10) = 1.
      DO 150 I=1,20
      IP = JP1 + 2 * I
      D(11) = 2 * I
      D(10) = D(10)*D(11)*(D(11)-1.)
      D(12) = (-1.)**I  * PHIB**IP/((DJP1+D(11)) *D(10))
      D(13) = DABS (D(12)/D(3))
      D(3)  =  D(3) + D(12)
      IF (D(13) .LE. 1.D-10) GO TO 160
  150 CONTINUE
      GO TO 7780
  160 CONTINUE
      D(3) = D(20) * D(3)
      D(26) = DJP1
C
C COMPUTE I(J,4)
C
      CALL ROMBDK (PHIB,D(10),IP, D(4),1,D(21))
      IF (IP .GE. 15) CALL MESAGE (30,26,IDEL)
      D(4) = D(20) * D(4)
C
C COMPUTE I(J,5)
C
      CALL ROMBDK (PHIB,D(10),IP,D(5),2,D(21))
      IF (IP .GE. 15) CALL MESAGE (30,26,IDEL)
      D(5) = D(20) * D(5)
C
C COMPUTE I(J,6)
C
      CALL ROMBDK (PHIB,D(10),IP,D(6),3,D(21))
      IF (IP .GE. 15) CALL MESAGE (30,26,IDEL)
      D(6) = D(20) * D(6)
C
C THE TOROIDAL RING REQUIRED INTEGRALS
C
      DELINT(K  ) = D(30) * D(1) + D(31) * D(2) + D(32) * D(3)
      DELINT(K+1) = COSA1 * D(2) + SINA1 * D(3)
      DELINT(K+2) = D(33) * D(4) + D(34) * D(5) + D(35) * D(6)
      DELINT(K+3) = COSA1 * D(3) - SINA1 * D(2)
      DELINT(K+4) = D(34) * (D(6)-D(4))  + D(36) * D(5)
      DELINT(K+5) = D(33) * D(6) - D(34) * D(5) + D(35) * D(4)
      GO TO 250
C
C THE CONICAL RING BASIC INTEGRALS WILL BE COMPUTED IN
C LOCATIONS D(1) AND D(2)
C
C
C COMPUTE I(J,1)
C
  170 D(1) = (S **JP1)/DJP1
      IF (J-1) 180,190,200
C
C   COMPUTE  I(0,2)
C
  180 D(2) = DLOG(( R1+ S*COSA1)/R1)/COSA1
      GO TO 230
C
C    COMPUTE I(1,2)
C
  190 D(2) = (S- (R1/COSA1) * DLOG((R1+S*COSA1)/R1)) /COSA1
      GO TO 230
C
C    COMPUTE I(J,2) WHERE J .GT.1
C
  200 D(2) =1./DJP1
      D(10)=  -S*COSA1/R1
      DO  210 I= 1,1000
      D(11) = JP1 + I
      D(12) = (D(10) ** I) / D(11)
      D(2) = D(2) + D(12)
      IF (D(12) .LT.  1.D-4)  GO TO 220
  210 CONTINUE
      GO TO 7780
  220 D(2)=  ((S**JP1)/R1)* D(2)
C
C THE CONICAL RING REQUIRED INTEGRALS
C
  230 DELINT(K  ) = R1*D(1) + COSA1*(S**(JP1+1)/(DJP1+1.))
      DELINT(K+1) = SINA1 * D(1)
      DELINT(K+2) = D(35) * D(2)
      DELINT(K+3) = COSA1 * D(1)
      DELINT(K+4) = D(34) * D(2)
      DELINT(K+5) = D(33) * D(2)
      GO TO 250
C
C THE CYLINDRICAL RING BASIC INTEGRALS WILL BE COMPUTED IN
C LOCATIONS D(1) AND D(2)
C
C
C COMPUTE I(J,1)
C
  240 D(1) = (S**JP1)/DJP1
C
C COMPUTE I(J,2)
C
      D(2) = D(1) / R1
C
C THE CYLINDRICAL RING REQUIRED INTEGRALS
C
      DELINT(K  ) =  R1*D(1) + COSA1*(S**(JP1+1)/(DJP1+1.))
      DELINT(K+1) = SINA1 * D(1)
      DELINT(K+2) = D(35) * D(2)
      DELINT(K+3) = 0.
      DELINT(K+4) = 0.
      DELINT(K+5) = 0.
C
  250 CONTINUE
C
  260 CONTINUE
C
C   IF STIFFNESS MATRIX NOT REQUIRED  GO TO MASS ROUTINE
C
C
C
C LOCATE THE MATERIAL PROPERTIES IN THE MAT1 OR MAT3 TABLE
C
      MATIDC = MATID
      MATFLG = 7
      ELTEMP = TEMPE
      CALL MAT(IDEL)
C
C
C SET MATERIAL PROPERTIES IN LOCAL VARIABLES
C
      EP = E(1)
      ET = E(2)
      VPT= ANU(1)
      VTP= VPT * ET / EP
      DEL = 1. - VPT*VTP
      DICT5 = G SUBE
C
C
C GENERATE THE ELASTIC CONSTANTS MATRIX(2X2)
C
      EE(1) = EP / DEL
      EE(2) = ET * VPT / DEL
      EE(3) = EE(2)
      EE(4) = ET / DEL
C
C
C FORM THE STIFFNESS MATRIX IN FIELD COORDINATES
C
C COMPUTE CONSTANTS NEEDED IN DMATRX SUBROUTINE
C
      D(1) = EP / ET
      D(7) = 0.
      IF (ITORD .EQ. 0) D(7) = 1./RP
      D(2) = D(1) * D(7)
      D(3) = D(2) * D(7)
      D(4) = VPT * D(7)
      D(5) =(EP * TM / (D(1) - VPT**2)) * TWOPI
      D(6) = (EP*TF**3)/(12.*(D(1)-VPT**2))*TWOPI
C
C CALL THE DMATRIX SUBROUTINE TO COMPUTE THE STIFFNESS MATRIX (10X10)
C
C NOTE THE DOUBLE SUBSCRIPTING USED IN DMATRIX SUBROUTINE IS
C COMPATIBLE WITH THE CALLING PROGRAM. THE DELINT ARRAY OF INTEGRALS
C IS A (11X6) SINGLY SUBSCRIPTED ARRAY (STORED ROWWISE) IN THE CALLING
C PROGRAM AND IT IS A (6X11) DOUBLY SUBSCRIPTED ARRAY (STORED
C COLUMNWISE) IN DMATRX ROUTINE.
C
      IF (ISMB(1) .EQ.  0) GO TO 270
      CALL DMATRX (AK(1),VPT,D(1),D(2),D(3),D(4),D(5),D(6),DELINT(1))
  270 IF (ISMB(2) .EQ. 0)  GO TO 279
      DO 275 I=1,100
  275 AM(I) = 0.
      AM(  1) = DELINT( 1)
      AM(  2) = DELINT( 7)
      AM(  3) = DELINT(13)
      AM(  4) = DELINT(19)
      AM( 11) = DELINT( 7)
      AM( 12) = DELINT(13)
      AM( 13) = DELINT(19)
      AM( 14) = DELINT(25)
      AM( 21) = DELINT(13)
      AM( 22) = DELINT(19)
      AM( 23) = DELINT(25)
      AM( 24) = DELINT(31)
      AM( 31) = DELINT(19)
      AM( 32) = DELINT(25)
      AM( 33) = DELINT(31)
      AM( 34) = DELINT(37)
      AM( 45) = DELINT( 1)
      AM( 46) = DELINT( 7)
      AM( 47) = DELINT(13)
      AM( 48) = DELINT(19)
      AM( 49) = DELINT(25)
      AM( 50) = DELINT(31)
      AM( 55) = DELINT( 7)
      AM( 56) = DELINT(13)
      AM( 57) = DELINT(19)
      AM( 58) = DELINT(25)
      AM( 59) = DELINT(31)
      AM( 60) = DELINT(37)
      AM( 65) = DELINT(13)
      AM( 66) = DELINT(19)
      AM( 67) = DELINT(25)
      AM( 68) = DELINT(31)
      AM( 69) = DELINT(37)
      AM( 70) = DELINT(43)
      AM( 75) = DELINT(19)
      AM( 76) = DELINT(25)
      AM( 77) = DELINT(31)
      AM( 78) = DELINT(37)
      AM( 79) = DELINT(43)
      AM( 80) = DELINT(49)
      AM( 85) = DELINT(25)
      AM( 86) = DELINT(31)
      AM( 87) = DELINT(37)
      AM( 88) = DELINT(43)
      AM( 89) = DELINT(49)
      AM( 90) = DELINT(55)
      AM( 95) = DELINT(31)
      AM( 96) = DELINT(37)
      AM( 97) = DELINT(43)
      AM( 98) = DELINT(49)
      AM( 99) = DELINT(55)
      AM(100) = DELINT(61)
C
      D(1) = TWO PI * RHO * TM
      DO  278  I=1,100
  278 AM(I)= D(1) * AM(I)
  279 CONTINUE
C
C
C
C FORM THE TRANSFORMATION MATRIX(10X12) FROM FIELD COORDINATES TO GRID
C POINT DEGREES OF FREEDOM
C
      DO 280 I=1,72
  280 GAMBQF(I)=0.
      D(1) = S
      D(2) = S ** 2
      D(3) = S ** 3
      D(4) = S ** 4
      D(5) = S ** 5
      GAMBQF(3) = 1.
      GAMBQF(16)= 1.
      GAMBQF(30)= .5
      GAMBQF(39)=-10./D(3)
      GAMBQF(40)= -6./D(2)
      GAMBQF(42)= -1.5/D(1)
      GAMBQF(45) = -GAMBQF(39)
      GAMBQF(46) = -4./D(2)
      GAMBQF(48) =  .5/D(1)
      GAMBQF(51) = 15./D(4)
      GAMBQF(52) =  8./D(3)
      GAMBQF(54) = 1.5/D(2)
      GAMBQF(57) = -GAMBQF(51)
      GAMBQF(58) =  7./D(3)
      GAMBQF(60) = -1./D(2)
      GAMBQF(63) = -6./D(5)
      GAMBQF(64) = -3./D(4)
      GAMBQF(66) = -.5/D(3)
      GAMBQF(69) = -GAMBQF(63)
      GAMBQF(70) =  GAMBQF(64)
      GAMBQF(72) = -GAMBQF(66)
      DO 290 I=1,48
  290 GAMBQM(I) = 0.
      GAMBQM(1) = 1.
      GAMBQM(17)= 1.
      GAMBQM(25)=  -3./D(2)
      GAMBQM(29) = -2./D(1)
      GAMBQM(31)= -GAMBQM(25)
      GAMBQM(35) = -1./D(1)
      GAMBQM(37) = 2./D(3)
      GAMBQM(41) = 1./D(2)
      GAMBQM(43) = -GAMBQM(37)
      GAMBQM(47) =  GAMBQM(41)
C
C
C TRANSFORM THE STIFFNESS MATRIX TO GRID POINT DEGREES OF FREEDOM
C
      IF(ISMB(1).EQ. 0) GO TO 295
      CALL GMMATD (GAMBQ(1),10,12,1,  AK(1),10,10,0, D(1))
      CALL GMMATD (D(1), 12,10,0, GAMBQ(1), 10,12,0, AK(1))
  295 IF (ISMB(2).EQ.0)  GO TO 299
C     REARRANGE GAMBQ FOR MASS MATRIX CALCULATIONS
      DO 296 I=1,72
296   D(I+48) = GAMBQ(I)
      DO 297 I=1,48
297   D(I) = GAMBQ(I+72)
      DO 298 I=1,120
 298  GAMBQ(I)=D(I)
      CALL GMMATD (GAMBQ(1), 10,12,1, AM(1), 10,10,0,  D(1))
      CALL GMMATD (D(1), 12,10,0, GAMBQ(1), 10,12,0, AM(1))
C
  299 CONTINUE
C
C
C FORM THE TRANSFORMATION MATRIX (12X12) FROM ELEMENT TO BASIC
C COORDINATES
C
      DO 300 I=1,144
  300 GAMRS(I)=0.
      GAMRS( 1) =  COSA1
      GAMRS( 3) = -SINA1
      GAMRS(25) =  SINA1
      GAMRS(27) =  COSA1
      GAMRS(40) = -1.
      GAMRS(53) =  1.
      GAMRS(66) =  1.
      GAMRS(79) =  COSA2
      GAMRS(81) = -SINA2
      GAMRS(103)=  SINA2
      GAMRS(105)=  COSA2
      GAMRS(118) = -1.
      GAMRS(131) = 1.
      GAMRS(144) = 1.
C
C
C TRANSFORM THE STIFFNESS MATRIX FROM ELEMENT TO BASIC COORDINATES
C
      IF (ISMB(1).EQ.0)  GO TO 310
      CALL GMMATD (GAMRS(1), 12,12,1, AK(1), 12,12,0, D(1))
      CALL GMMATD (D(1), 12,12,0, GAMRS(1), 12,12,0, AK(1))
  310 IF (ISMB(2) .EQ.0)  GO TO 315
      CALL GMMATD (GAMRS(1), 12,12,1, AM(1), 12,12,0, D(1))
      CALL GMMATD (D(1), 12,12,0, GAMRS(1), 12,12,0, AM(1))
  315 CONTINUE
C
C
C LOCATE THE TRANSFORMATION MATRICES FROM BASIC TO LOCAL COORDINATES
C FOR THE TWO GRID POINTS AND EXPAND TO (6X6)
C THE TWO MATRICES WILL BE STORED IN D(1),...,D(36) AND D(37),...,D(72)
C RESPECTIVELY
C
      DO 320 I =1,72
  320 D(I) = 0.
      DO 350 I =1,2
      IF (ICS(I).EQ. 0) GO TO 350
      K = 36 * (I - 1)
      CALL TRANSD (ICS(1), D(73))
      DO 340 J=1,3
      KK = K + 6 * (J-1) + 1
      KL = 3 * (J-1) + 73
      KJ = K + 6 * (J+2) + J + 3
      D(KK  ) = D(KL  )
      D(KK+1) = D(KL+1)
      D(KK+2) = D(KL+2)
      D(KJ) = 1.
  340 CONTINUE
  350 CONTINUE
C
C  DIVIDE THE STIFFNESS MATRIX INTO 4 SUBMATRICES WHICH CAN THEN BE
C  TRANSFORMED FROM BASIC TO LOCAL COORDINATES THEN REINSERTED IN THE
C  STIFFNESS MATRIX IN INCREASING SIL ORDER
C
      DO 500 IP =1,2
      IPP = IP
      IF (IGP(1) .LT. IGP(2)) GO TO 400
      IPP = 3 - IP
  400 IR = 72 * (IPP-1)
      IAPP = 36* (IPP-1) +1
      DO 490 JI=1,2
      I= JI
      IF (IP .EQ. IPP ) GO TO 405
      I = 3-JI
C
C   PLACE THE APPROPRIATE SUBMATRIX INTO A (6X6) MATRIX
C
  405 IC =  6 *(I-1)
      K  = 0
      DO  410 II=1,6
      KL = IR + 12 *(II-1) +IC
      DO 410  IJ =1,6
      K = K+1
      KK = KL+ IJ
      AKI(K) = AK(KK)
      AKM(K) = AM(KK)
  410 CONTINUE
C
C   TRANSFORM FROM BASIC TO LOCAL  COORDINATES
C
      IF (ICS(IPP) .EQ. 0) GO TO 430
      IF (ISMB(1) .EQ. 0 ) GO TO 425
      CALL GMMATD (D(IAPP), 6,6,1, AKI(1), 6,6,0, D(73))
      DO  420 J=1,36
  420 AKI(J)= D(J+72)
  425 IF (ISMB(2) .EQ. 0) GO TO 430
      CALL GMMATD (D(IAPP), 6,6,1, AKM(1), 6,6,0, D(73))
      DO 428 J=1,36
  428 AKM(I) = D(J+72)
C
  430 IF (ICS(I) .EQ. 0) GO TO 450
      IAI =  36*(I-1) +1
      IF (ISMB(1) .EQ. 0) GO TO 445
      CALL GMMATD (AKI(1), 6,6,0, D(IAI), 6,6,0,  D(73))
      DO 440 J=1,36
  440 AKI(J) =  D(J+72)
  445 IF (ISMB(2) .EQ. 0) GO TO 450
      CALL GMMATD (AKM(1), 6,6,0, D(IAI), 6,6,0,  D(73))
      DO 448 J=1,36
  448 AKM(J) =D(J+72)
C
C    REINSERT INTO OVERALL STIFFNESS MATRIX ACCORDING TO INCREASING SIL
C
  450 DO 460 II = 1,6
      DO 460 JJ = 1,6
      KI = (II-1)*6 + JJ
      IOUT=  (IP-1)* 72 + (JI-1)*6  + (II-1)*12 + JJ
      KOUT(IOUT) = AKI(KI)
  460 MOUT(IOUT) = AKM(KI)
  490 CONTINUE
  500 CONTINUE
C
C     OUTPUT THE MATRIX BY EMGOUT
C
      DICT(2) = 1
      IF (ISMB(1) .EQ.0) GO TO 550
      CALL EMGOUT(KOUT,KOUT,144,1,DICT,1,IPR)
C
  550 IF (ISMB(2) .EQ.0) GO TO 600
      CALL EMGOUT(MOUT,MOUT,144,1,DICT,2,IPR)
C
  600 RETURN
C
C
C
C  SET FLAG FOR FATAL ERROR WHILE ALLOWING ERROR MESSAGES TO ACCUMULATE
C
 7770 CALL MESAGE (30,37,IDEL)
 7777 NOGO = .TRUE.
      RETURN
 7780 CALL MESAGE(30,26,IDEL)
      GO TO 7777
C
      END

      SUBROUTINE MODC
C
C*****
C
C     DUMMY DECK FOR MODULE MODC   SEE USERS MANUAL SECTION 5.3
C                                  FOR MODULE PROPERTIES CHECK XMPLBD
C                                  OR USE DIAG 29
C
C*****
C
C     INTEGER INFILE(2)
C
      COMMON /BLANK/ IPARM
C
C     DATA INFILE /101,102/
C
      RETURN
      END

      SUBROUTINE KTRIRG
C
C
C*****
C THIS ROUTINE COMPUTES THE STIFFNESS MATRIX FOR A AXI-SYMMETRIC RING
C WITH A TRIANGULAR CROSS SECTION
C*****
C
C
C                        ECPT FOR THE TRIANGULAR RING
C
C
C                                                      TYPE
C ECPT( 1) ELEMENT IDENTIFICATION                        I
C ECPT( 2) SCALAR INDEX NO. FOR GRID POINT A             I
C ECPT( 3) SCALAR INDEX NO. FOR GRID POINT B             I
C ECPT( 4) SCALAR INDEX NO. FOR GRID POINT C             I
C ECPT( 5) MATERIAL ORIENTATION ANGLE(DEGREES)           R
C ECPT( 6) MATERIAL IDENTIFICATION                       I
C ECPT( 7) COOR. SYS. ID. FOR GRID POINT A               I
C ECPT( 8) X-COOR. OF GRID POINT A (IN BASIC COOR.)      R
C ECPT( 9) Y-COOR. OF GRID POINT A (IN BASIC COOR.)      R
C ECPT(10) Z-COOR. OF GRID POINT A (IN BASIC COOR.)      R
C ECPT(11) COOR. SYS. ID. FOR GRID POINT B               I
C ECPT(12) X-COOR. OF GRID POINT B (IN BASIC COOR.)      R
C ECPT(13) Y-COOR. OF GRID POINT B (IN BASIC COOR.)      R
C ECPT(14) Z-COOR. OF GRID POINT B (IN BASIC COOR.)      R
C ECPT(15) COOR. SYS. ID. FOR GRID POINT C               I
C ECPT(16) X-COOR. OF GRID POINT C (IN BASIC COOR.)      R
C ECPT(17) Y-COOR. OF GRID POINT C (IN BASIC COOR.)      R
C ECPT(18) Z-COOR. OF GRID POINT C (IN BASIC COOR.)      R
C ECPT(19) EL. TEMPERATURE FOR MATERIAL PROPERTIES       R
C
C
      DOUBLE PRECISION CONSTD, DEGRAD
      DOUBLE PRECISION
     1                   D ,  GAMBQ,    R,   Z
     2,                  TEO, EE,  DELINT,   AK,  AKI
     3,                  AKT
      DOUBLE PRECISION   R1,  R2,  R3,  Z1,  Z2,  Z3,  ZMIN, DGAMA
     1,                  DR,  RH,  DZ,  ZH,  RA,  ZA,  AREA
     2,                  ER,  ET,  EZ,  VRT, VTR, VTZ, VZT
     3,                  VZR, VRZ, GRZ, DEL, COSG,SING,DGAMR
     4,                  TWOPI,    DKI
      DOUBLE PRECISION   DAMPC
C
      DIMENSION          IECPT(19)
      DIMENSION          AKI(36),  AKT(9)
C
      COMMON /CONDAD/ CONSTD(5)
      COMMON   /SMA1IO/
     1                   DUM1(10)
     2,                  IFKGG
     3,                  IGKGG,    IF4GG,    DUM2(21)
      COMMON   /SMA1CL/
     1                   IOPT4,    K4GGSW
     2,                  NPVT
     3,                   DUM4(7)
     4,                  LINK(10)           ,IDETCK
     5,                  DODET              ,NOGO
      COMMON   /SMA1ET/
     1                   ECPT(19)
     2,                  DUM5(81)
      COMMON   /MATIN/
     1                   MATIDC             ,MATFLG
     2,                  ELTEMP             ,STRESS
     3,                  SINTH              ,COSTH
      COMMON   /MATOUT/
     1                   E(3)               ,ANU(3)
     2,                  RHO                ,G(3)
     3,                  ALF(3)        ,TZERO,    GSUBE
      COMMON   /SMA1DP/
     1                   D(36) ,   GAMBQ(36),     R(3) ,    Z(3)
     2,                  TEO(16),  EE(16),   DELINT(8),     AK(36)
     4,                  DGAMA,    ZMIN
     5,                  DR,  RH,  DZ,  ZH,  RA,  ZA,  AREA
     6,                  ER,  ET,  EZ,  VRT, VTR, VTZ, VZT
     7,                  VZR, VRZ, GRZ, DEL, COSG,SING,DGAMR
     8,                  IGP(3) , ICS(3) , SP(18)
     9,                  TEMPE
C
      EQUIVALENCE ( CONSTD(2) , TWOPI  )
      EQUIVALENCE ( CONSTD(4) , DEGRAD )
      EQUIVALENCE        (IECPT(1) , ECPT(1))
      EQUIVALENCE   (R(1),R1),     (R(2),R2),     (R(3),R3)
     1,             (Z(1),Z1),     (Z(2),Z2),     (Z(3),Z3)
      EQUIVALENCE        (AKI(1),  GAMBQ(1))
      EQUIVALENCE        (AKT(1),  TEO(1))
C
C ----------------------------------------------------------------------
C
C STORE ECPT PARAMETERS IN LOCAL VARIABLES
C
      IDEL  = IECPT(1)
      IGP(1)= IECPT(2)
      IGP(2)= IECPT(3)
      IGP(3)= IECPT(4)
      MATID = IECPT(6)
      ICS(1)= IECPT(7)
      ICS(2)= IECPT(11)
      ICS(3)= IECPT(15)
      R(1)  = ECPT(8)
      D(1)  = ECPT(9)
      Z(1)  = ECPT(10)
      R(2)  = ECPT(12)
      D(2)  = ECPT(13)
      Z(2)  = ECPT(14)
      R(3)  = ECPT(16)
      D(3)  = ECPT(17)
      Z(3)  = ECPT(18)
      TEMPE = ECPT(19)
      DGAMA = ECPT(5)
C
C
C CHECK INTERNAL GRID POINTS FOR PIVOT POINT
C
      IPP = 0
      DO 100 I = 1,3
      IF (NPVT .EQ. IGP(I)) IPP = I
  100 CONTINUE
      IF (IPP .EQ. 0) CALL MESAGE (-30,34,IDEL)
C
C
C TEST THE VALIDITY OF THE GRID POINT COORDINATES
C
      IEROR1 = 0
      DO 200 I = 1,3
      IF (R(I).GT.0.0D0) GO TO 200
      IF (IEROR1.NE.0) GO TO 200
      CALL MESAGE (30, 211, IDEL)
      IEROR1 = 1
  200 CONTINUE
      IEROR2 = 0
      DO 210 I = 1, 3
      IF (D(I).EQ.0.0D0) GO TO 210
      IF (IEROR2.NE.0) GO TO 210
      CALL MESAGE (30, 212, IDEL)
      IEROR2 = 1
  210 CONTINUE
      IF (IEROR1.EQ.0.AND.IEROR2.EQ.0) GO TO 220
      NOGO = 2
      RETURN
  220 IF ((R2 - R1)*(Z3 - Z1) - (R3 - R1)*(Z2 - Z1).LT.0.0D0) GO TO 920
C
C
C COMPUTE THE ELEMENT COORDINATES
C
      ZMIN = DMIN1(Z1, Z2, Z3)
      Z1 = Z1 - ZMIN
      Z2 = Z2 - ZMIN
      Z3 = Z3 - ZMIN
C
C
C
C FORM THE TRANSFORMATION MATRIX (6X6) FROM FIELD COORDINATES TO GRID
C POINT DEGREES OF FREEDOM
C
      DO 300 I = 1,36
      GAMBQ(I) = 0.0D0
  300 CONTINUE
      GAMBQ( 1) = 1.0D0
      GAMBQ( 2) = R1
      GAMBQ( 3) = Z1
      GAMBQ(10) = 1.0D0
      GAMBQ(11) = R1
      GAMBQ(12) = Z1
      GAMBQ(13) = 1.0D0
      GAMBQ(14) = R2
      GAMBQ(15) = Z2
      GAMBQ(22) = 1.0D0
      GAMBQ(23) = R2
      GAMBQ(24) = Z2
      GAMBQ(25) = 1.0D0
      GAMBQ(26) = R3
      GAMBQ(27) = Z3
      GAMBQ(34) = 1.0D0
      GAMBQ(35) = R3
      GAMBQ(36) = Z3
C
C
C     NO NEED TO COMPUTE DETERMINANT SINCE IT IS NOT USED SUBSEQUENTLY.
      ISING = -1
      CALL INVERD (6, GAMBQ(1),6 , D(10), 0, D(11) , ISING , SP)
C
      IF (ISING.EQ.2) GO TO 920
C
C
C
C CALCULATE THE INTEGRAL VALUES IN ARRAY DELINT WHERE THE ORDER IS
C INDICATED BY THE FOLLOWING TABLE
C
C              DELINT( 1) - (-1,0)
C              DELINT( 2) - (-1,1)
C              DELINT( 3) - (-1,2)
C              DELINT( 4) - ( 0,0)
C              DELINT( 5) - ( 0,1)
C              DELINT( 6) - ( 1,0)
C              DELINT( 7) - ( 0,2)
C              DELINT( 8) - ( 1,2)
C
C
C TEST FOR RELATIVE SMALL AREA OF INTEGRATION
C AND IF AREA IS SMALL THEN APPROXIMATE INTEGRALS
C
      DR = DMAX1 ( DABS(R1-R2) , DABS(R2-R3) , DABS(R3-R1) )
      RH = DMIN1 ( R1 , R2 , R3 ) / 10.0D0
      DZ = DMAX1 ( DABS(Z1-Z2) , DABS(Z2-Z3) , DABS(Z3-Z1) )
      ZH = DMIN1 ( Z1 , Z2 , Z3 ) / 10.0D0
      RA = (R1 + R2 + R3) / 3.0D0
      ZA = (Z1 + Z2 + Z3) / 3.0D0
      AREA =(R1*(Z2-Z3) + R2*(Z3-Z1) + R3*(Z1-Z2)) / 2.0D0
      KODE = 0
      IF (DABS( (R2-R1)/R2 ) .LT. 1.0D-5) KODE = 1
      IF ( DR .LE. RH  .OR.  DZ .LE. ZH ) KODE = -1
C
C
  310 CONTINUE
      I1 = 0
      DO 400 I = 1,3
      IP = I - 2
      DO 350 J = 1,3
      IQ = J - 1
      IF (IP.EQ.1 .AND. IQ.EQ.1) GO TO 350
      I1 = I1 + 1
      IF (KODE) 320,330,340
  320 DELINT(I1) =((RA) ** IP)*((ZA) ** IQ) * AREA
      GO TO 350
  330 DELINT(I1) =   DKI (1,3,1,2,1,3,IP,IQ,R,Z)
     1            +  DKI (3,2,1,2,3,2,IP,IQ,R,Z)
      GO TO 350
  340 CONTINUE
      DELINT(I1) =   DKI (1,3,3,2,1,3,IP,IQ,R,Z)
  350 CONTINUE
  400 CONTINUE
      D(1)      = DELINT(6)
      DELINT(6) = DELINT(7)
      DELINT(7) = D(1)
C
C
C TEST FOR EXCESSIVE ROUND-OFF ERROR IN INTEGRAL CALCULATIONS
C AND IF IT EXIST APPROXIMATE INTEGRALS
C
      IF (KODE .LT. 0) GO TO 500
      DO 450 I = 1,8
      IF (DELINT(I) .LT. 0.0D0) GO TO 475
  450 CONTINUE
      IF (DELINT(8) .LE. DELINT(7)) GO TO 475
      IF (DELINT(3) .GE. DELINT(8)) GO TO 475
      IF (DELINT(3) .GT. DELINT(7)) GO TO 475
      GO TO 500
  475 CONTINUE
      KODE = -1
      GO TO 310
  500 CONTINUE
C
C
C
C LOCATE THE MATERIAL PROPERTIES IN THE MAT1 OR MAT3 TABLE
C
      MATIDC = MATID
      MATFLG = 7
      ELTEMP = TEMPE
      CALL  MAT (IDEL)
C
C
C SET MATERIAL PROPERTIES IN DOUBLE PRECISION VARIABLES
C
      ER = E(1)
      ET = E(2)
      EZ = E(3)
      VRT = ANU(1)
      VTZ = ANU(2)
      VZR = ANU(3)
      GRZ = G(3)
      VTR = VRT * ET / ER
      VZT = VTZ * EZ / ET
      VRZ = VZR * ER / EZ
      DEL = 1.0D0 - VRT*VTR - VTZ*VZT - VZR*VRZ - VRT*VTZ*VZR
     1       - VRZ*VTR*VZT
C
C
C GENERATE ELASTIC CONSTANTS MATRIX (4X4)
C
      EE(1) = ER * (1.0D0 - VTZ*VZT) / DEL
      EE(2) = ER * (VTR + VZR*VTZ) / DEL
      EE(3) = ER * (VZR + VTR*VZT) / DEL
      EE(4) = 0.0D0
      EE(5) = EE(2)
      EE(6) = ET * (1.0D0 - VRZ*VZR) / DEL
      EE(7) = ET * (VZT + VRT*VZR) / DEL
      EE(8) = 0.0D0
      EE(9) = EE(3)
      EE(10)= EE(7)
      EE(11)= EZ * (1.0D0 - VRT*VTR) / DEL
      EE(12)= 0.0D0
      EE(13)= 0.0D0
      EE(14)= 0.0D0
      EE(15)= 0.0D0
      EE(16)= GRZ
C
C
C FORM TRANSFORMATION MATRIX (4X4) FROM MATERIAL AXIS TO ELEMENT
C GEOMETRIC AXIS
C
      DGAMR = DGAMA * DEGRAD
      COSG = DCOS(DGAMR)
      SING = DSIN(DGAMR)
      TEO( 1) = COSG ** 2
      TEO( 2) = 0.0D0
      TEO( 3) = SING ** 2
      TEO( 4) = SING * COSG
      TEO( 5) = 0.0D0
      TEO( 6) = 1.0D0
      TEO( 7) = 0.0D0
      TEO( 8) = 0.0D0
      TEO( 9) = TEO(3)
      TEO(10) = 0.0D0
      TEO(11) = TEO(1)
      TEO(12) = -TEO(4)
      TEO(13) = -2.0D0 * TEO(4)
      TEO(14) = 0.0D0
      TEO(15) = -TEO(13)
      TEO(16) = TEO(1) - TEO(3)
C
C
C TRANSFORM THE ELASTIC CONSTANTS MATRIX FROM MATERIAL
C TO ELEMENT GEOMETRIC AXIS
C
      CALL GMMATD (TEO , 4, 4, 1, EE , 4, 4, 0, D )
      CALL GMMATD (D   , 4, 4, 0, TEO, 4, 4, 0, EE)
C
C
C
C FORM THE ELEMENT STIFFNESS MATRIX IN FIELD COORDINATES
C
      AK( 1) = EE(6) * DELINT(1)
      AK( 2) = (EE(2) + EE(6)) * DELINT(4)
      AK( 3) = EE(6) * DELINT(2) + EE(8) * DELINT(4)
      AK( 4) = 0.0D0
      AK( 5) = EE(8) * DELINT(4)
      AK( 6) = EE(7) * DELINT(4)
      AK( 7) = AK(2)
      AK( 8) = (EE(1) + 2.0D0*EE(2) + EE(6)) * DELINT(6)
      AK( 9) = (EE(2) + EE(6)) * DELINT(5) + (EE(4) + EE(8)) *DELINT(6)
      AK(10) = 0.0D0
      AK(11) = (EE(4) + EE(8)) * DELINT(6)
      AK(12) = (EE(3) + EE(7)) * DELINT(6)
      AK(13) = AK(3)
      AK(14) = AK(9)
      AK(15) = EE(6) * DELINT(3) + 2.0D0*EE(8) * DELINT(5)
     1         + EE(16) * DELINT(6)
      AK(16) = 0.0D0
      AK(17) = EE(8) * DELINT(5) + EE(16) * DELINT(6)
      AK(18) = EE(7) * DELINT(5) + EE(12) * DELINT(6)
      AK(19) = 0.0D0
      AK(20) = 0.0D0
      AK(21) = 0.0D0
      AK(22) = 0.0D0
      AK(23) = 0.0D0
      AK(24) = 0.0D0
      AK(25) = AK(5)
      AK(26) = AK(11)
      AK(27) = AK(17)
      AK(28) = 0.0D0
      AK(29) = EE(16) * DELINT(6)
      AK(30) = EE(12) * DELINT(6)
      AK(31) = AK(6)
      AK(32) = AK(12)
      AK(33) = AK(18)
      AK(34) = 0.0D0
      AK(35) = AK(30)
      AK(36) = EE(11) * DELINT(6)
C
      DO 600 I = 1,36
      AK(I) = TWOPI * AK(I)
  600 CONTINUE
C
C TRANSFORM THE ELEMENT STIFFNESS MATRIX FROM FIELD COORDINATES
C TO GRID POINT DEGREES OF FREEDOM
C
      CALL GMMATD (GAMBQ , 6, 6, 1, AK , 6, 6, 0, D )
      CALL GMMATD (D  , 6, 6, 0, GAMBQ , 6, 6, 0, AK)
C
C
C
C ZERO OUT THE (6X6) MATRIX USED AS INPUT TO THE INSERTION ROUTINE
C
      DO 700 I = 1,36
      AKI(I) = 0.0D0
  700 CONTINUE
C
C
C LOCATE THE TRANSFORMATION MATRICES FOR THE THREE GRID POINTS
C
      DO 800 I = 1,3
      IF (ICS(I) .EQ. 0) GO TO 800
      K = 9 * (I-1) + 1
      CALL TRANSD (ICS(I) , D(K))
  800 CONTINUE
C
C
C
C START THE LOOP FOR INSERTION OF THE THREE (6X6) MATRICES
C INTO THE MASTER STIFFNESS MATRIX
C
      IR1  = 2 * IPP - 1
      IAPP = 9 * (IPP-1) + 1
      DO 900 I = 1,3
C
C PLACE THE APPROIATE (2X2) SUBMATRIX OF THE STIFFNESS MATRIX
C IN A (3X3) MATRIX FOR TRANSFORMATION
C
      IC1 = 2 * I - 1
      IRC = (IR1 - 1) * 6 + IC1
      AKT(1) = AK(IRC)
      AKT(2) = 0.0D0
      AKT(3) = AK(IRC+1)
      AKT(4) = 0.0D0
      AKT(5) = 0.0D0
      AKT(6) = 0.0D0
      AKT(7) = AK(IRC+6)
      AKT(8) = 0.0D0
      AKT(9) = AK(IRC+7)
C
C TRANSFORM THE (3X3) STIFFNESS MATRIX
C
      IF (ICS(IPP) .EQ. 0) GO TO 820
      CALL GMMATD (D(IAPP) , 3, 3, 1, AKT(1) , 3, 3, 0, D(28) )
      DO 810 J = 1,9
      AKT(J) = D(J+27)
  810 CONTINUE
  820 CONTINUE
      IF (ICS(I) .EQ. 0) GO TO 840
      IAI = 9 * (I - 1) + 1
      CALL GMMATD (AKT(1) , 3, 3, 0, D(IAI) , 3, 3, 0, D(28) )
      DO 830 J = 1,9
      AKT(J) = D(J+27)
  830 CONTINUE
  840 CONTINUE
C
C PLACE THE TRANSFORMED (3X3) MATRIX INTO A (6X6) MATRIX FOR
C THE INSERTION ROUTINE
C
      J = 0
      DO 850 J1 = 1,18,6
      DO 850 J2 = 1,3
      J = J + 1
      K = J1 + J2 - 1
      AKI(K) = AKT(J)
  850 CONTINUE
C
C CALL THE INSERTION ROUTINE
C
      CALL SMA1B (AKI(1) , IGP(I), -1, IFKGG, 0.0D0)
      IF (IOPT4 .EQ. 0 .OR. GSUBE .EQ. 0.0) GO TO 900
      K4GGSW = 1
      DAMPC = GSUBE
      CALL SMA1B (AKI(1) , IGP(I) , -1,IF4GG , DAMPC )
  900 CONTINUE
      RETURN
C
C  SET FLAG FOR FATAL ERROR WHILE ALLOWING ERROR MESSAGES TO ACCUMULATE
C
  915 NOGO=1
      RETURN
  920 CALL MESAGE(30,26,IDEL)
      GO TO 915
C
      END

      SUBROUTINE FFHELP (*,*,J)
      CHARACTER*1     QMARK
      CHARACTER*4     STOP,     YES,      HELP,     XX
      COMMON /MACHIN/ MACH
      COMMON /SYSTEM/ DUMMY(3), IN
      COMMON /XREADX/ NOUT
      COMMON /XECHOX/ SKIP(2),  IECHOS
      COMMON /QMARKQ/ QMARK
      DATA    STOP,   YES,      HELP  /   'STOP',   'Y   ',   'HELP' /
C
C     THIS ROUTINE IS CALLED ONLY BY FF
C
      GO TO (10,50,100,120,140), J
 10   WRITE (NOUT,20)
 20   FORMAT (///1X,
     1  'GENERATED OUTPUT CARDS ARE SAVED ONLY IF FILE NAME IS GIVEN.',
     2  //,' YOU MAY ENTER NASTRAN EXECUTIVE CONTROL AND CASE CONTROL',
     2  ' CARDS FIRST',/,' (NO INPUT ECHO ON SCREEN)', //,
     3  ' ADDITIONAL INPUT INFORMATION WILL BE GIVEN WHEN YOU ENTER ',
     3  12H'BEGIN BULK', //,
     4  ' YOU MAY QUIT FREE-FIELD PROGRAM AT ANY TIME BY ENTERING ',
     4  6H'STOP', /,' NORMALLY, JOB TERMINATES BY ',9H'ENDDATA', //,
     5  ' YOU MAY USE ',10H'READFILE',' COMMAND TO READ ANY FILE WHICH',
     5  14H WAS 'STOPPED', /,
     5  ' BEFORE, AND CONTINUE FROM WHERE THE PREVIOUS JOB ENDED', //,
     6  ' FREE-FIELD INPUT IS AVAILABLE ONLY IN BULK DATA SECTION', /,
     6  ' AND IS ACTIVATED BY A COMMA OR EQUAL SIGN IN COLS. 1 THRU 10',
     7  //,' BOTH UPPER-CASE AND LOWER-CASE LETTERS ARE ACCEPTABLE',//,
     8  ' REFERENCE - G.CHAN: ',1H','COSMIC/NASTRAN FREE-FIELD INPUT',
     8  2H',, /13X,'12TH NASTRAN USERS',1H',' COLLOQUIUM, MAY 1984')
      WRITE (NOUT,30) QMARK
 30   FORMAT (/,' MORE',A1,' (Y,N) - ')
      READ (IN,40,END=80) XX
 40   FORMAT (A4)
      CALL UPCASE (XX,4)
      IF (XX .NE. YES) GO TO 80
C
 50   WRITE (NOUT,60)
 60   FORMAT (///,' THE FOLLOWING SYMBOLS ARE USED FOR FREE-FIELD INPUT'
     1, //10X,'SYMBOL', 12X,'FUNCTION',/,9X,2('----'),5X,10('----'),
     2   /10X,', OR BLANK  FIELD SEPERATORS',
     3   /10X,'  =         DUPLICATES ONE CORRESPONDING FIELD',
     4   /10X,'  ==        DUPLICATES THE REMAINING FIELDS',
     5   /10X,'  *(N)      INCREMENT BY N',
     6   /10X,'  %(E)      ENDING VALUE BY E',
     7   /10X,'  /         THIS INPUT FIELD IS SAME AS PREVIOUS FIELD',
     8   /10X,'  J)        FIELD INDEX, J-TH FIELD (MUST FOLLOWED BY A V
     9ALUE)',
     O   /10X,')+ OR 10)   INDEX FOR CONTINUATION FIELD',
     A   /10X,'  )         (IN COL. 1 ONLY) DUPLICATES THE CONTINUATION
     BID',/22X,'OF PREVIOUS CARD INTO FIELD 1 OF CURRENT CARD',
     C   /10X,'  ,         COL.1 ONLY, AUTO-CONTINUATION ID GENERATION',
     D   /10X,'  =(N)      1ST FIELD ONLY, DUPLICATES N CARDS WITH PROPE
     ER',/22X,' INCREMENTS',
     F   /12X,'+A-I',6X,'CONTINUATION ID CAN BE DUPLICATED AUTOMATICALLY
     G', /22X,'ONLY IF IT IS IN PLUS-ALPHA-MINUS-INTEGER FORM',
     H  //1X,'EXAMPLES:',  /1X,'GRID, 101,,  0.  0. ,  7. 8)2  )+ABC-2',
     I   /1X,'=(11),*(1)  ,,  *(1.), /  %(23.45),==')
      IF (J.EQ.1 .OR. IECHOS.NE.-2) GO TO 170
      WRITE (NOUT,30) QMARK
      READ (IN,40,END=80) XX
      CALL UPCASE (XX,4)
      IF (XX .EQ. YES) GO TO 140
 80   IF (XX .EQ. STOP) RETURN 2
      IF (MACH.EQ.4 .AND. IN.EQ.5) REWIND IN
      GO TO 190
C
 100  WRITE (NOUT,110)
 110  FORMAT (//,24H ENTER 'N' FOR NO PUNCH,, /7X,
     1       38H'Y' FOR PUNCH IN FREE-FIELD FORMAT, OR, /7X,
     2       43H'X' FOR PUNCH IN NASTRAN FIXED-FIELD FORMAT,/)
      GO TO 190
C
 120  WRITE (NOUT,130)
 130  FORMAT (/,' MIFYLE - IS A RESERVED WORD.  TRY ANY OTHER NAME')
      GO TO 190
C
 140  WRITE (NOUT,150)
 150  FORMAT (//,' *** FREE-FIELD INPUT IS OPTIONAL.',//5X,'FOUR (4)',
     1 ' CONTROL OPTIONS ARE AVAILABLE - CAN BE ENTERED AT ANY TIME',
     2 /7X,'1.  PROMPT=ON, PROMPT=OFF, OR PROMPT=YES(DEFAULT)',
     3 /7X,'2.  SCALE/10,  OR SCALE/8',
     4 /7X,'3.  CANCEL=N,  (TO CANCEL N PREVIOUSLY GENERATED CARDS)',
     5 /7X,'4.  LIST  =N,  (TO   LIST N PREVIOUSLY GENERATED CARDS)',
     6//7X,'ENTER ''HELP'' IF YOU NEED ADDITIONAL INSTRUCTIONS',
     7//7X,'INTEGER INPUT SHOULD BE LIMITED TO 8 DIGITS',
     8 /7X,'UP TO 12 DIGITS ARE ALLOWED FOR FLOATING PT. NUMBER INPUT',
     9 /7X,'HOWEVER, ONLY UP TO 8 DIGIT ACCURACY IS KEPT',
     O /7X,'             INPUT           RESULT ',
     1 /7X,'         ------------       --------',
     2 /7X,'E.G.     123.456789         123.4567',
     3 /7X,'         123.456789+6       .12345+9',
     4 /7X,'         -123.4567D+5       -.1234+8',
     5 /7X,'         123.45678E+4       1234567.',
     6 /7X,'         0.00123456-3       .12345-5',
     7 /7X,'         0.0123456789       .0123456',
     8 /7X,'         .00000123456       .12345-5')
      IF (IECHOS .NE. -2) WRITE (NOUT,160)
 160  FORMAT (/7X,'(3 AND 4 ARE AVAILABLE ONLY IN THE FREE-FIELD STAND',
     1     '-ALONE VERSION)')
 170  WRITE (NOUT,180)
 180  FORMAT (/4X,'UP TO 94 CHARATERS ALLOWABLE ON AN INPUT LINE. ',
     1       ' C/R TO CONTINUE')
      READ (IN,40,END=80) XX
      CALL UPCASE (XX,4)
      IF (XX .EQ. HELP) GO TO 50
      IF (J .NE. 1) GO TO 80
 190  RETURN 1
      END

      SUBROUTINE INTFBS (DX,DY,IOBUF)
C
C     GIVEN THE TRIANGULAR FACTORS FOR A GENERAL MATRIX, INTFBS WILL
C     PERFORM THE FORWARD-BACKWARD SUBSTITUTION NECESSARY TO SOLVE
C     A SYSTEM OF EQUATIONS
C
C     DEFINITION OF INPUT PARAMETERS
C
C     FILEL    =  MATRIX CONTROL BLOCK FOR THE LOWER TRIANGLE L
C     FILEU    =  MATRIX CONTROL BLOCK FOR THE UPPER TRIANGLE U
C     DX       =  THE LOAD VECTOR B
C     DY       =  THE SOLUTION VECTOR X
C     IOBUF    =  THE INPUT BUFFER
C
C     NAMED COMMONS
C
      INTEGER            FILEL     ,FILEU    ,TYPEAR   ,RDP      ,
     1                   PARM(4)   ,RSP      ,EOL
      DIMENSION          IOBUF(1)  ,DX(1)    ,DY(1)
      COMMON   /NAMES /  RD        ,RDREW    ,WRT      ,WRTREW   ,
     1                   REW       ,NOREW    ,EOFNRW   ,RSP      ,
     2                   RDP       ,CSP      ,CDP      ,SQR      ,
     3                   RECT      ,DIAG     ,LOWTRI   ,UPRTRI   ,
     4                   SYM       ,ROW      ,IDENTY
      COMMON   /ZNTPKX/  A(4)      ,II       ,EOL
      COMMON   /INFBSX/  FILEL(7)  ,FILEU(7)
      COMMON   /TRDXX /  IDUMMY(27),IOPEN
      EQUIVALENCE        (A(1),DA) ,
     1                   (FILEL(3) ,NROW)
      DATA      PARM(3), PARM(4)   /4HINTF   ,4HBS   /
C
C
C     TRANSFER THE LOAD VECTOR TO THE SOLUTION VECTOR
C
      DO 10 I = 1,NROW
   10 DY(I)  = DX(I)
      TYPEAR = RSP
C
C     OPEN FILE FOR THE LOWER TRIANGLE
C
      PARM(2) = FILEL(1)
      IF (IOPEN .EQ. -10) GO TO 15
      IF (IOPEN .EQ.   0) CALL OPEN (*200,FILEL(1),IOBUF,RDREW)
      CALL FWDREC (*210,FILEL(1))
C
C     BEGIN FORWARD PASS
C
   15 J = 1
   20 CALL INTPK (*90,FILEL(1),0,TYPEAR,0)
   30 IF (EOL) 220,40,220
   40 CALL ZNTPKI
      IF (J-II) 80,50,30
C
C     PERFORM THE REQUIRED ROW INTERCHANGE
C
   50 IN1   = J + IFIX(A(1))
      DTEMP = DY(J)
      DY(J) = DY(IN1)
      DY(IN1) = DTEMP
   60 IF (EOL) 90,70,90
   70 CALL ZNTPKI
   80 DY(II) = DY(II) - DY(J)*DA
      GO TO 60
   90 J = J + 1
      IF (J .LT. NROW) GO TO 20
      CALL REWIND (FILEL(1))
      IF (IOPEN .EQ.   0) CALL CLOSE (FILEL(1),REW)
      IF (IOPEN .EQ. -10) CALL SKPREC (FILEL,1)
C
C     BEGIN BACKWARD PASS
C
      IOFF = FILEU(7) - 1
      PARM(2) = FILEU(1)
      IF (IOPEN .EQ. -10) GO TO 95
      IF (IOPEN .EQ.   0) CALL OPEN (*200,FILEU(1),IOBUF,RDREW)
      CALL FWDREC (*210,FILEU(1))
   95 J = NROW
  100 CALL INTPK (*220,FILEU(1),0,TYPEAR,0)
      IF (EOL) 220,120,220
  120 CALL ZNTPKI
      I = NROW - II + 1
      IF (I .NE. J) GO TO 170
C
C     DIVIDE BY THE DIAGONAL
C
      DY(I) = DY(I)/DA
C
C     SUBTRACT OFF REMAINING TERMS
C
  140 IF (I .GT. J) GO TO 120
      IF (EOL) 190,160,190
  160 CALL ZNTPKI
      I = NROW - II + 1
  170 IN1 = I
      IN2 = J
      IF (I .LT. J) GO TO 180
      K   = IN1
      IN1 = IN2 - IOFF
      IN2 = K
  180 DY(IN1) = DY(IN1) - DY(IN2)*DA
      GO TO 140
  190 J = J - 1
      IF (J .GT. 0) GO TO 100
      CALL  REWIND (FILEU(1))
      IF (IOPEN .EQ.   0) CALL CLOSE (FILEU(1),REW)
      IF (IOPEN .EQ. -10) CALL SKPREC (FILEU,1)
      RETURN
C
  200 PARM(1) = -1
      GO TO 230
  210 PARM(1) = -2
      GO TO 230
  220 PARM(1) = -5
  230 CALL MESAGE (PARM(1),PARM(2),PARM(3))
      RETURN
      END

      SUBROUTINE DUPART
C
C     DRIVER FOR DMAP MODULE UPARTN
C
C     DMAP CALLING SEQUENCE IS
C     UPARTN    USET,KNN/KFF,KSF,KFS,KSS/C,N,N/C,N,F/C,N,S $
C
      INTEGER         USET,SCR1,SUB0,SUB1,IABIT(16),NAME(2),IB(3)
      COMMON /BLANK / MAJOR(2),SUB0(2),SUB1(2)
      COMMON /BITPOS/ IBIT(32),IABIT
      DATA    NAME  / 4HUPAR  ,4HTN   /
      DATA    USET  , KNN, KFF, KSF, KFS, KSS, SCR1 /
     1        101   , 102, 201, 202, 203, 204, 301  /
C
C
      NOGO = 0
C
C     DECIDE IF CHARACTERS ARE LEGAL BIT NUMBERS
C
      IB(1) = MAJOR(1)
      IB(2) = SUB0(1)
      IB(3) = SUB1(1)
C
      DO 30 J = 1,3
      DO 20 I = 1,32
      IF (IB(J) .NE. IABIT(I)) GO TO 20
      IB(J) = IBIT(I)
      GO TO 30
   20 CONTINUE
C
C     INVALID
      CALL MESAGE (59,IB(J),NAME)
      NOGO = 1
   30 CONTINUE
C
      IF (NOGO .EQ. 1) CALL MESAGE (-7,0,NAME)
C
      CALL UPART (USET,SCR1,IB(1),IB(2),IB(3))
      CALL MPART (KNN,KFF,KSF,KFS,KSS)
      RETURN
      END

      SUBROUTINE CLVEC (LAMD,NVECT,PHIDL,IH,IBUF,IBUF1)
C*****
C     CLVEC CACLULATES THE LEFT EIGENVECTORS FOR THE DETERMINANT AND
C     UPPER HESSENBERG APPROACHES TO THE COMPLEX EIGENVALUE PROBLEM
C*****
      DOUBLE PRECISION DI1,DNROW,DZ(1),LAMBDA,MINDIA
      INTEGER CLSREW,FLAG,PHIDL,RDREW,SWITCH,SYSBUF
      INTEGER FILEK,FILEM,FILEB,SCR
      DIMENSION NAME(2),BUF(6),IH(7)
      COMMON / CDCMPX / DUMDCP(30),MINDIA
      COMMON / ZZZZZZ / Z(1)
      COMMON / CINVPX / FILEK(7),FILEM(7),FILEB(7),DUM(15),SCR(11)
      COMMON / CINVXX / LAMBDA(2),SWITCH
      COMMON / NAMES  / RD,RDREW,WRT,WRTREW,CLSREW,NOREW
      COMMON / PACKX  / IT1,IT2,II,JJ,INC
      COMMON / SYSTEM / SYSBUF
      EQUIVALENCE (NROW,FILEK(3))
      EQUIVALENCE (DZ(1),Z(1))
      DATA NAME   / 4HCLVE,4HC    /
C*****
C     INITIALIZATION
C*****
      IBUF2 = IBUF1 - SYSBUF
      IF (FILEB(1) .LT. 0) FILEB(1) = 0
      IF (FILEB(6) .EQ. 0) FILEB(1) = 0
      DO 50 I=1,11
      SCR(I) = 300 + I
   50 CONTINUE
      SWITCH = -204
      FNROW = FLOAT(NROW)
      DNROW = FNROW
C*****
C     OPEN SORTED EIGENVALUE FILE
C*****
      CALL GOPEN (LAMD,Z(IBUF),RDREW)
      CALL SKPREC (LAMD,1)
C*****
C     LOOP TO CALCULATE LEFT EIGENVECTORS
C*****
      DO 1000 I=1,NVECT
C READ EIGENVALUE
      CALL READ(*9002,*9003,LAMD,BUF,6,0,FLAG)
      LAMBDA(1) = BUF(3)
      LAMBDA(2) = BUF(4)
C CREATE DYNAMIC MATRIX
  100 CALL CINVP1
C DECOMPOSE DYNAMIC MATRIX
      CALL CINVP2(*900)
C BUILD LOAD FOR FBS
      FI1 = FLOAT(I-1)
      DI1 = FI1
      J2 = 2*NROW
      DO 200 J=1,J2,2
      F = FLOAT((J+1)/2)
      DZ(J) = MINDIA/(1.0D0 + (1.0D0 - F/DNROW)*DI1)
      DZ(J+1) = 0.0D0
  200 CONTINUE
C PERFORM FORWARD-BACKWARD SUBSTITUTION - U(T)*L(T)*PHI
      CALL CDIFBS (DZ(1),Z(IBUF2))
C NORMALIZE LEFT EIGENVECTOR
      CALL CNORM1 (DZ(1),NROW)
C PACK LEFT EIGENVECTOR ONTO PHIDL
      IT1 = 4
      IT2 = 3
      II = 1
      JJ = NROW
      INC = 1
      CALL PACK (DZ(1),PHIDL,IH)
      GO TO 1000
C ADJUST CURRENT EIGENVALUE
  900 LAMBDA(1) = 1.01D0*LAMBDA(1)
      LAMBDA(2) = 1.01D0*LAMBDA(2)
      GO TO 100
C END OF LOOP
 1000 CONTINUE
      CALL CLOSE (LAMD,CLSREW)
      RETURN
C*****
C     ERRORS
C*****
 9002 N = -2
      GO TO 9999
 9003 N = -3
 9999 CALL MESAGE (N,LAMD,NAME)
      RETURN
      END

      SUBROUTINE READ7 (NR1,OLAMA,OPHIA,NLAMA,NPHIA)
C
C     READ7  COPIES NR VECTORS FROM OPHIA TO NPHIA -
C     IT ALSO PLACES THE EIGENVALUES ON NLAMA
C     THIS ROUTINE HANDLES BOTH SINGLE AND DOUBLE PRECISION
C
      INTEGER          OLAMA,OPHIA,SYSBUF,IX(7),NAME(2),SGLDBL
      REAL             X(7)
      DOUBLE PRECISION DCORE(2),DX
      COMMON /SYSTEM/  SYSBUF
      COMMON /UNPAKX/  ITB,II,JJ,INCUR
      COMMON /PACKX /  IT1,IT2,IIP,JJP,INCRP
      COMMON /ZZZZZZ/  CORE(1)
      EQUIVALENCE      (DCORE(1),CORE(1)) , (X(1),DX)
      DATA    NAME  /  4HREAD,4H7   /
C
C     GET ORGANIZED
C
      NR    = NR1
      LC    = KORSZ(CORE)
      IBUF1 = LC - SYSBUF + 1
      IBUF2 = IBUF1 -SYSBUF
      IBUF3 = IBUF2 -SYSBUF
      IBUF4 = IBUF3 -SYSBUF
      IX(1) = OPHIA
      CALL RDTRL (IX)
      NROW  = IX(3)
      II    = 1
      JJ    = NROW
      IT1   = IX(5)
      IT2   = IT1
      ITB   = IT1
      DCORE(1) = 0.0D0
      INCRP = 1
      ASSIGN 12 TO SGLDBL
      IF (ITB .EQ. 2) ASSIGN 16 TO SGLDBL
      INCUR = 1
C
C     OPEN OLD FILES
C
      CALL GOPEN (OLAMA,CORE(IBUF1),0)
      CALL FWDREC (*3010,OLAMA)
      CALL GOPEN (OPHIA,CORE(IBUF2),0)
C
C     OPEN NEW FILES TO WRITE
C
      CALL GOPEN (NLAMA,CORE(IBUF3),1)
      CALL GOPEN (NPHIA,CORE(IBUF4),1)
C
C     START COPY LOOP
C
      CALL MAKMCB (IX,NPHIA,NROW,IX(4),IT2)
      DO 10 I = 1,NR
      CALL READ (*3010,*3020,OLAMA,X,7,0,IFL)
      II = 0
      CALL UNPACK (*150,OPHIA,DCORE(2))
      GO TO SGLDBL, (12,16)
   12 X(1) = SQRT(X(6))
      DO 14 J = 1,NROW
   14 CORE(J+2) = CORE(J+2)/X(1)
      GO TO 20
   16 DX = SQRT(X(6))
      DO 18 J = 1,NROW
   18 DCORE(J+1) = DCORE(J+1)/DX
   20 IIP = II
      JJP = JJ
      CALL PACK (DCORE(2),NPHIA,IX)
   30 DX = X(3)
      CALL WRITE (NLAMA,DX,2,1)
      GO TO 10
C
C     NULL COLUMN
C
  150 IIP = 1
      JJP = 1
      CALL PACK (DCORE,NPHIA,IX)
      GO TO 30
   10 CONTINUE
      CALL CLOSE (OLAMA,1)
      CALL CLOSE (OPHIA,1)
      CALL CLOSE (NLAMA,2)
      CALL CLOSE (NPHIA,1)
      RETURN
C
C     ERRORS
C
 3010 NN = -2
 3012 IFILE = OLAMA
      CALL MESAGE (NN,IFILE,NAME)
      RETURN
 3020 NN = -3
      GO TO 3012
      END

      SUBROUTINE CMSOFO
C
C     THIS ROUTINE GENERATES THE NEW SOF DATA FOR A COMBINATION.
C
      EXTERNAL        RSHIFT,ANDF
      LOGICAL         TDAT,TOCOPN,LONLY
      INTEGER         PORA,PAPP,LODS,LOAP,
     1                BUF1,BUF3,CE(9),CNAM,COMBO,SCSFIL,SCR1,BUF2,SCORE,
     2                SCCONN,SBGSS,SCTOC,Z,AAA(2),GETIP,ENT(5),
     3                NAMOLD(14),EOG,SCBDAT,SCCSTM,OUTT,RSHIFT,ANDF
      DIMENSION       SAV1(3),SAV2(9),RZ(1),
     1                TMAT(9),ECPT(4),RENT(3),LIST(32)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /CMB001/ SCR1,SCR2,SCBDAT,SCSFIL,SCCONN,SCMCON,SCTOC,
     1                GEOM4,CASECC,SCCSTM
      COMMON /CMB002/ BUF1,BUF2,BUF3,BUF4,BUF5,SCORE,LCORE,INPT,OUTT
      COMMON /CMB003/ COMBO(7,5),CONSET,IAUTO,TOLER,NPSUB,CONECT,TRAN,
     1                MCON,RESTCT(7,7),ISORT,ORIGIN(7,3),IPRINT,TOCOPN
      COMMON /CMB004/ TDAT(6),NIPNEW,CNAM(2),LONLY
      COMMON /ZZZZZZ/ Z(1)
      COMMON /BLANK / STEP,DRY,PORA
      EQUIVALENCE     (RZ(1),Z(1)),(ITRAN,ECPT(1))
      DATA    AAA   / 4HCMSO,4HFO   / , EOG / 4H$EOG /
      DATA    PAPP  , LODS,LOAP             /
     1                4HPAPP,4HLODS,4HLOAP  /
      DATA    NHEQSS, NHBGSS,NHCSTM,NHPLTS  /
     1        4HEQSS, 4HBGSS,4HCSTM,4HPLTS  /
C
C     GET NAMES OF BASIC COMPONENTS FROM THE TABLE OF CONTENTS
C
      IFILE = SCTOC
      IF (.NOT.TOCOPN) CALL OPEN (*720,SCTOC,Z(BUF2),0)
      CALL REWIND (SCTOC)
      K = 0
      J = 0
   10 J = J + 1
C
      CALL READ (*30,*730,SCTOC,0,-3,0,NNN)
      CALL READ (*30,*20,SCTOC,Z(SCORE+K),LCORE,1,NNN)
   20 K = K + NNN
      IF (J .LT. NPSUB) GO TO 10
   30 IF (.NOT.TOCOPN) CALL CLOSE (SCTOC,1)
      ISTNM = SCORE
      SCORE = SCORE + K
      NNAMES = K
C
      NSUB = 0
      DO 40 J = 1,NPSUB
      NSUB = NSUB + COMBO(J,5)
   40 CONTINUE
C
C     WRITE THE FIRST GROUP OF THE EQSS
C
      IF (LONLY) GO TO 330
C
      NP2 = 2*NPSUB
      DO 50 I = 1,NP2,2
      J = I/2 + 1
      NAMOLD(I  ) = COMBO(J,1)
      NAMOLD(I+1) = COMBO(J,2)
   50 CONTINUE
      NPP = NPSUB
      CALL SETLVL (CNAM,NPP,NAMOLD,ITEST,29)
      IF (ITEST .EQ. 8) GO TO 700
      ITEST = 3
      CALL SFETCH (CNAM,NHEQSS,2,ITEST)
      ITEST = 1
      CALL SUWRT (CNAM,2,ITEST)
      CALL SUWRT (NSUB,1,ITEST)
      CALL SUWRT (NIPNEW,1,ITEST)
      ITEST = 2
      CALL SUWRT (Z(ISTNM),NNAMES,ITEST)
C
      IFILE = SCCONN
      CALL OPEN (*720,SCCONN,Z(BUF1),0)
      IFILE = SCSFIL
      CALL OPEN (*720,SCSFIL,Z(BUF2),0)
      IFILE = SCR1
      CALL OPEN (*720,SCR1,Z(BUF3),1)
      DO 180 I = 1,NPSUB
      IPN = 0
      KK  = 0
   60 IPN = IPN + 1
      CALL READ (*80,*70,SCCONN,CE,10,1,NNN)
   70 IF (CE(I+2) .EQ. 0) GO TO 60
      Z(SCORE+KK  ) = CE(  1)
      Z(SCORE+KK+1) = CE(I+2)
      Z(SCORE+KK+2) = IPN
      KK = KK + 3
      GO TO 60
   80 NOIPN = (KK)/3
      CALL SORT (0,0,3,2,Z(SCORE),KK)
C
C     READ BGSS FROM SUBFIL
C
      IFILE = SCSFIL
      NPSP1 = COMBO(I,5) + 1
      DO 90 J = 1,NPSP1
      CALL FWDREC (*730,SCSFIL)
   90 CONTINUE
      SBGSS = SCORE + KK
      LCORE = LCORE - KK
      CALL READ (*730,*100,SCSFIL,Z(SBGSS),LCORE,1,LBGSS)
      GO TO 740
  100 CONTINUE
      DO 110 J = 1,KK,3
      JJ     = J - 1
      GETIP  = Z(SCORE+JJ+1)
      ENT(1) = Z(SBGSS+4*GETIP-4  )
      ENT(2) = Z(SBGSS+4*GETIP-4+1)
      ENT(3) = Z(SBGSS+4*GETIP-4+2)
      ENT(4) = Z(SBGSS+4*GETIP-4+3)
      ENT(5) = Z(SCORE+JJ+2)
      CALL WRITE (SCR1,ENT,5,0)
  110 CONTINUE
      CALL WRITE (SCR1,ENT,0,1)
      IF (I .EQ. 1) CALL REWIND (SCSFIL)
      IF (I .NE. 1) CALL SKPFIL (SCSFIL,-1)
      IF (I .NE. 1) CALL SKPFIL (SCSFIL, 1)
      NCOMP = COMBO(I,5)
      DO 170 J = 1,NCOMP
      CALL READ (*720,*120,SCSFIL,Z(SBGSS),LCORE,1,NNN)
      GO TO 740
  120 IF (NNN .EQ. 0) GO TO  160
      DO 150 JJ = 1,NNN,3
      KID = Z(SBGSS+JJ)
      CALL BISLOC (*150,KID,Z(SCORE+1),3,NOIPN,NWD)
  130 IF (Z(SCORE+NWD) .NE. Z(SCORE+NWD-3)) GO TO 140
      IF (NWD .LE. 1) GO TO 140
      NWD = NWD - 3
      GO TO 130
  140 ENT(1) = Z(SBGSS+JJ -1)
      ENT(2) = Z(SCORE+NWD+1)
      ENT(3) = Z(SCORE+NWD-1)
      CALL WRITE (SCR1,ENT,3,0)
      IF (Z(SCORE+NWD) .NE. Z(SCORE+NWD+3)) GO TO 150
      IF (NWD+3 .GE. NOIPN*3) GO TO 150
      NWD = NWD + 3
      GO TO 140
  150 CONTINUE
  160 CALL WRITE (SCR1,0,0,1)
  170 CONTINUE
      CALL SKPFIL (SCSFIL,1)
      CALL REWIND (SCCONN)
  180 CONTINUE
      CALL CLOSE (SCSFIL,1)
      CALL CLOSE (SCR1,1)
C
C     WRITE OUT EQSS ONTO SOF
C
      IFILE = SCR1
      CALL OPEN (*720,SCR1,Z(BUF3),0)
      DO 210 I = 1,NPSUB
      NCOMP = COMBO(I,5)
      CALL FWDREC (*730,SCR1)
      DO 200 J = 1,NCOMP
      CALL READ (*730,*190,SCR1,Z(SBGSS),LCORE,1,NNN)
      GO TO 740
  190 ITEST = 2
      CALL SUWRT (Z(SBGSS),NNN,ITEST)
  200 CONTINUE
  210 CONTINUE
C
C     WRITE OUT MASTER SIL,C LIST FOR NEW STRUCTURE
C
      CALL REWIND (SCCONN)
      KK   = 0
      ISIL = 1
  220 CALL READ (*240,*230,SCCONN,CE,10,1,NNN)
  230 CALL DECODE (CE(1),Z(BUF2),NDOF)
      Z(SBGSS+KK  ) = ISIL
      Z(SBGSS+KK+1) = CE(1)
      ISIL = ISIL + NDOF
      KK   = KK + 2
      GO TO 220
  240 CONTINUE
      ITEST = 2
      CALL SUWRT (Z(SBGSS),KK,ITEST)
      ITEST = 3
      CALL SUWRT (ENT,0,ITEST)
C
C     WRITE BGSS ONTO SOF
C
      LCC = LCORE
      KK  = 0
      CALL REWIND (SCR1)
      DO 270 I = 1,NPSUB
      NCOMP = COMBO(I,5)
      CALL READ (*730,*250,SCR1,Z(SBGSS+KK),LCC,1,NW)
      GO TO 740
  250 KK  = KK  + NW
      LCC = LCC - NW
      DO 260 J = 1,NCOMP
      CALL FWDREC (*280,SCR1)
  260 CONTINUE
  270 CONTINUE
  280 CALL SORT (0,0,5,5,Z(SBGSS),KK)
      ITEST = 3
      CALL SFETCH (CNAM,NHBGSS,2,ITEST)
      ITEST = 1
      CALL SUWRT (CNAM,2,ITEST)
      ITEST = 2
      CALL SUWRT (NIPNEW,1,ITEST)
      KKK  = 0
  290 ISUB = SBGSS + KKK
      ENT(1) = Z(ISUB  )
      ENT(2) = Z(ISUB+1)
      ENT(3) = Z(ISUB+2)
      ENT(4) = Z(ISUB+3)
      IF (KKK.GT.0 .AND. Z(ISUB+4).EQ.Z(ISUB-1)) GO TO 300
      ITEST = 1
      CALL SUWRT (ENT,4,ITEST)
  300 KKK = KKK + 5
      IF (KKK .LT. KK) GO TO 290
      ITEST = 2
      CALL SUWRT (ENT,0,ITEST)
      ITEST = 3
      CALL SUWRT (ENT,0,ITEST)
      CALL CLOSE (SCR1,1)
      CALL CLOSE (SCCONN,1)
C
C     PROCESS CSTM ITEM
C
      CALL OPEN (*720,SCCSTM,Z(BUF3),0)
      CALL READ (*310,*310,SCCSTM,Z(SCORE),LCORE,1,NNN)
      GO TO 740
  310 IF (NNN .EQ. 0) GO TO 320
      ITEST = 3
      CALL SFETCH (CNAM,NHCSTM,2,ITEST)
      ITEST = 2
      CALL SUWRT (CNAM,2,ITEST)
      ITEST = 2
      CALL SUWRT (Z(SCORE),NNN,ITEST)
      ITEST = 3
      CALL SUWRT (0,0,ITEST)
  320 CALL CLOSE (SCCSTM,1)
C
C     PROCESS LODS ITEM
C
  330 NLV  = 0
      NCS  = NNAMES/2
      J    = 0
      LITM = LODS
      IF (PORA .EQ. PAPP) LITM = LOAP
      DO 350 I = 1,NPSUB
      NAMOLD(1) = COMBO(I,1)
      NAMOLD(2) = COMBO(I,2)
      CALL SFETCH (NAMOLD,LITM,1,ITEST)
      IF (ITEST .EQ. 3) GO TO 340
      CALL SUREAD (CE,4,NOUT,ITEST)
      NLV = NLV + CE(3)
      JDH = 1
      CALL SJUMP (JDH)
      CALL SUREAD (Z(SCORE+J),-2,NOUT,ITEST)
      J = J + NOUT
      GO TO 350
  340 Z(SCORE+J  ) = 0
      Z(SCORE+J+1) = EOG
      J = J + 2
  350 CONTINUE
      ITEST = 3
      CALL SFETCH (CNAM,LITM,2,ITEST)
      ITEST = 1
      CALL SUWRT (CNAM,2,ITEST)
      CALL SUWRT (NLV ,1,ITEST)
      CALL SUWRT (NCS ,1,ITEST)
      ITEST = 2
      CALL SUWRT (Z(ISTNM),NNAMES,ITEST)
      ITEST = 3
      CALL SUWRT (Z(SCORE),J,ITEST)
      IF (LONLY) GO TO 580
C
C     PROCESS PLTS ITEM
C
C
C     FIND OLD PLTS TRANSFORMATIONS
C
      NOUT  = 0
      J     = 0
      NNSUB = 0
      DO 370 I = 1,NPSUB
      NAMOLD(1) = COMBO(I,1)
      NAMOLD(2) = COMBO(I,2)
      CALL SFETCH (NAMOLD,NHPLTS,1,ITEST)
      IF (ITEST .EQ. 3) GO TO 370
      CALL SUREAD (Z(SCORE+J),3,NOUT,ITEST)
      NNSUB = NNSUB + Z(SCORE+J+2)
      CALL SUREAD (Z(SCORE+J),-1,NOUT,ITEST)
      J = J + NOUT
  370 CONTINUE
      NPWD  = J
      ISTRN = SCORE + NPWD
      LLCO  = LCORE - NPWD
      ITEST = 3
      CALL SFETCH (CNAM,NHPLTS,2,ITEST)
      ITEST = 1
      CALL SUWRT (CNAM ,2,ITEST)
      CALL SUWRT (NNSUB,1,ITEST)
      NT = 0
      IF (.NOT.TDAT(3)) GO TO 390
      CALL OPEN (*720,SCBDAT,Z(BUF1),0)
      CALL SKPFIL (SCBDAT,2)
      CALL READ (*730,*380,SCBDAT,Z(ISTRN),LCORE,1,NT)
      GO TO 740
  380 CALL PRETRS (Z(ISTRN),NT)
  390 IF (.NOT.TOCOPN) CALL OPEN (*720,SCTOC,Z(BUF2),1)
      CALL REWIND (SCTOC)
      IST  = ISTRN + NT
      LLCO = LLCO  - NT
      J = 0
  400 J = J + 1
      ITRAN = COMBO(J,3)
      DO 410 I = 1,9
      TMAT(I) = 0.0
  410 CONTINUE
      CALL READ (*530,*420,SCTOC,Z(IST),LLCO,1,NNN)
      GO TO 740
  420 IF (ITRAN .EQ. 0) GO TO 440
      DO 430 I = 2,4
      ECPT(I) = 0.0
  430 CONTINUE
      CALL TRANSS (ECPT,TMAT)
      GO TO 450
  440 TMAT(1) = 1.0
      TMAT(5) = 1.0
      TMAT(9) = 1.0
C
C     DETERMINE SYMMETRY
C
  450 IF (COMBO(J,4) .EQ. 0) GO TO 470
      CALL DECODE (COMBO(J,4),LIST,NDIR)
      DO 460 I = 1,NDIR
      IDIR = LIST(I) + 1
      IDIR = 4 - IDIR
      TMAT(IDIR  ) = -TMAT(IDIR  )
      TMAT(IDIR+3) = -TMAT(IDIR+3)
      TMAT(IDIR+6) = -TMAT(IDIR+6)
  460 CONTINUE
  470 DO 480 I = 1,3
      RENT(I) = ORIGIN(J,I)
  480 CONTINUE
      NNN = NNN - 1
      DO 520 I = 3,NNN,2
C
C     PROCESS OLD TRANSFORMATIONS
C
      DO 490 KDH = 1,NPWD,14
      IF (Z(IST+I).EQ.Z(SCORE+KDH-1) .AND. Z(IST+I+1).EQ.Z(SCORE+KDH))
     1    GO TO 500
  490 CONTINUE
      GO TO 520
  500 CALL GMMATS (TMAT,3,3,0, RZ(SCORE+KDH+1),3,1,0, SAV1)
      DO 510  II = 1,3
  510 SAV1(II) = SAV1(II)+RENT(II)
      CALL GMMATS (TMAT,3,3,0, RZ(SCORE+KDH+4),3,3,0, SAV2)
      ITEST = 1
      CALL SUWRT (Z(IST+I),2,ITEST)
      CALL SUWRT (SAV1(1) ,3,ITEST)
      CALL SUWRT (SAV2(1) ,9,ITEST)
      GO TO 520
  520 CONTINUE
      IF (J .LT. NPSUB) GO TO 400
  530 IF (.NOT.TOCOPN) CALL CLOSE (SCTOC,1)
      ITEST = 2
      CALL SUWRT (0,0,ITEST)
      ITEST = 3
      CALL SUWRT (0,0,ITEST)
      CALL CLOSE (SCBDAT,1)
      CALL EQSOUT
C
C     PROCESS OUTPUT REQUESTS
C
      IF (ANDF(RSHIFT(IPRINT,12),1) .NE. 1) GO TO 550
C
C     WRITE EQSS FOR NEW STRUCTURE
C
      CALL SFETCH (CNAM,NHEQSS,1,ITEST)
      CALL SUREAD (Z(SCORE),4,NOUT,ITEST)
      CALL SUREAD (Z(SCORE),-1,NOUT,ITEST)
      IST = SCORE + NOUT
      DO 540 I = 1,NSUB
      CALL SUREAD (Z(IST),-1,NOUT,ITEST)
      IADD = SCORE + 2*(I-1)
      CALL CMIWRT (1,CNAM,Z(IADD),IST,NOUT,Z,Z)
  540 CONTINUE
      CALL SUREAD (Z(IST),-1,NOUT,ITEST)
      CALL CMIWRT (8,CNAM,0,IST,NOUT,Z,Z)
  550 IF (ANDF(RSHIFT(IPRINT,13),1) .NE. 1) GO TO 560
C
C     WRITE BGSS FOR NEW STRUCTURE
C
      CALL SFETCH (CNAM,NHBGSS,1,ITEST)
      NGRP = 1
      CALL SJUMP (NGRP)
      IST = SCORE
      CALL SUREAD (Z(IST),-1,NOUT,ITEST)
      CALL CMIWRT (2,CNAM,CNAM,IST,NOUT,Z,Z)
  560 IF (ANDF(RSHIFT(IPRINT,14),1) .NE. 1) GO TO 570
C
C     WRITE CSTM ITEM
C
      CALL SFETCH (CNAM,NHCSTM,1,ITEST)
      IF (ITEST .EQ. 3) GO TO 570
      NGRP = 1
      CALL SJUMP (NGRP)
      IST = SCORE
      CALL SUREAD (Z(IST),-1,NOUT,ITEST)
      CALL CMIWRT (3,CNAM,CNAM,IST,NOUT,Z,Z)
  570 IF (ANDF(RSHIFT(IPRINT,15),1) .NE. 1) GO TO 580
C
C     WRITE PLTS ITEM
C
      CALL SFETCH (CNAM,NHPLTS,1,ITEST)
      IST = SCORE
      CALL SUREAD (Z(IST), 3,NOUT,ITEST)
      CALL SUREAD (Z(IST),-1,NOUT,ITEST)
      CALL CMIWRT (4,CNAM,CNAM,IST,NOUT,Z,Z)
  580 IF (ANDF(RSHIFT(IPRINT,16),1) .NE. 1) GO TO 600
C
C     WRITE LODS ITEM
C
      CALL SFETCH (CNAM,LODS,1,ITEST)
      IF (ITEST .EQ. 3) GO TO 600
      CALL SUREAD (Z(SCORE), 4,NOUT,ITEST)
      CALL SUREAD (Z(SCORE),-1,NOUT,ITEST)
      IST   = SCORE + NOUT
      ITYPE = 5
      IF (LITM .EQ. LOAP) ITYPE = 7
      DO 590 I = 1,NSUB
      IADD = SCORE + 2*(I-1)
      CALL SUREAD (Z(IST),-1,NOUT,ITEST)
      CALL CMIWRT (ITYPE,CNAM,Z(IADD),IST,NOUT,Z,Z)
      ITYPE = 6
  590 CONTINUE
  600 CONTINUE
      RETURN
C
  700 WRITE  (OUTT,710) UFM
  710 FORMAT (A23,' 6518, ONE OF THE COMPONENT SUBSTRUCTURES HAS BEEN ',
     1       'USED IN A PREVIOUS COMBINE OR REDUCE.')
      IMSG = -37
      GO TO 750
  720 IMSG = -1
      GO TO 750
  730 IMSG = -2
      GO TO 750
  740 IMSG = -8
  750 CALL SOFCLS
      CALL MESAGE (IMSG,IFILE,AAA)
      RETURN
      END

      SUBROUTINE BDAT04
C
C     THIS SUBROUTINE PROCESSES THE RELES BULK DATA.
C
      EXTERNAL        RSHIFT,ANDF
      LOGICAL         NAME,TDAT,PRINT,PAGER
      INTEGER         SCR2,BUF2,BUF1,RELES(2),FLAG,GEOM4,ID(2),AAA(2),
     1                CONSET,IP(6),ICC(6),ANDF,SCBDAT,RSHIFT,IHD(96),
     2                OUTT,IBAS(2)
      DIMENSION       IBITS(32),JBITS(32),KBITS(32)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /ZZZZZZ/ Z(1)
      COMMON /CMB001/ SCR1,SCR2,SCBDAT,SCSFIL,SCCONN,SCMCON,
     1                SCTOC,GEOM4,CASECC
      COMMON /CMB002/ BUF1,BUF2,BUF3,BUF4,BUF5,SCORE,LCORE,INPT,OUTT
      COMMON /CMB003/ COMBO(7,5),CONSET,IAUTO,TOLER,NPSUB,CONECT,TRAN,
     1                MCON,RESTCT(7,7),ISORT,ORIGIN(7,3),IPRINT
      COMMON /CMB004/ TDAT(6)
      COMMON /CMBFND/ INAM(2),IERR
      COMMON /OUTPUT/ ITITL(96),IHEAD(96)
      COMMON /SYSTEM/ XXX,IOT,JUNK(6),IPAGE,LINE,ITLINE,MAXLIN,IDAT(3)
      COMMON /BLANK / STEP,IDRY
      DATA    IHD   / 11*4H    ,4H  SU,4HMMAR,4HY OF,4H PRO,4HCESS,
     1                4HED R,4HELES,4H BUL,4HK DA,4HTA  ,18*4H    ,
     2                4H   B,4HASIC,2*4H    ,4H GRI,4HD   ,4H     ,
     3                4HREQU,4HESTE,4HD   ,4H  IN,4HTERN,  4HAL   ,
     4                4H   C,4HURRE,4HNT  ,4H  DO,4HF TO,  4H BE  ,
     5                13*4H    ,4HSUBS,4HTRUC,4HTURE,4H   P,4HOINT,
     6                4H ID ,4H    ,4H REL,4HEASE,4H    ,4H  PO,4HINT ,
     7                4HNO. ,4H    ,4H DOF,4H    ,4H   R,4HELEA,4HSED ,
     8                6*4H       /
      DATA    RELES / 410,4      / , AAA / 4HBDAT,4H04    /
C
      DO 10 I = 1,96
      IHEAD(I) = IHD(I)
   10 CONTINUE
      PAGER = .TRUE.
      PRINT = .FALSE.
      IF (ANDF(RSHIFT(IPRINT,8),1) .EQ. 1) PRINT = .TRUE.
      IFILE = SCBDAT
      CALL OPEN (*200,SCBDAT,Z(BUF2),0)
      CALL SKPFIL (SCBDAT,3)
      CALL CLOSE  (SCBDAT,2)
      CALL OPEN (*200,SCBDAT,Z(BUF2),3)
      IFILE = SCR2
      CALL LOCATE (*170,Z(BUF1),RELES,FLAG)
      IFILE = GEOM4
   20 CALL READ (*210,*160,GEOM4,ID,1,0,N)
      IF (ID(1) .EQ. CONSET) GO TO 40
   30 CALL READ (*210,*220,GEOM4,ID,2,0,N)
      IF (ID(1)+ID(2) .NE. -2) GO TO 30
      GO TO 20
   40 NAME = .TRUE.
      IF (PAGER .AND. PRINT) CALL PAGE
      PAGER = .FALSE.
      TDAT(4) = .TRUE.
   50 CALL READ (*210,*220,GEOM4,ID,2,0,N)
      IF (ID(1)+ID(2) .NE. -2) GO TO 60
      CALL WRITE (SCBDAT,ID,0,1)
      GO TO 20
   60 IF (.NOT.NAME) GO TO 100
      CALL FINDER (ID,IS,IC)
      IBAS(1) = ID(1)
      IBAS(2) = ID(2)
      IF (IERR .NE. 1) GO TO 90
      WRITE  (OUTT,70) UFM,(ID(K),K=1,2)
   70 FORMAT (A23,' 6517, THE BASIC SUBSTRUCTURE  ',2A4, /30X,
     1       'REFERED TO BY A RELES  BULK DATA CARD CAN NOT BE FOUND ',
     2       'IN THE PROBLEM TABLE OF CONTENTS.')
      IDRY = -2
   80 CALL READ (*210,*220,GEOM4,ID,2,0,N)
      IF (ID(1)+ID(2) .NE. -2) GO TO 80
      GO TO 20
   90 CONTINUE
      CALL WRITE (SCBDAT,IS,1,0)
      NAME = .NOT.NAME
      GO TO 50
  100 CALL FNDGRD (IS,IC,ID(1),IP,ICC,N)
      IF (IERR .NE. 1) GO TO 120
      WRITE  (OUTT,110) UFM,ID(1),INAM
  110 FORMAT (A23,' 6515, GRID POINT',I10,' BASIC SUBSTRUCTURE ',2A4,
     1       ' DOES NOT EXIST.')
      IDRY = -2
      GO TO 50
  120 CALL ENCODE (ID(2))
      CALL BITPAT (ID(2),IBITS)
      DO 150 I = 1,N
      ICCC = ANDF(ID(2),ICC(I))
      CALL BITPAT (ICCC,JBITS)
      ICC(I) = ANDF(ICC(I),63)
      CALL BITPAT (ICC(I),KBITS)
      IF (ICCC .EQ. 0) GO TO 150
      IF (.NOT.PRINT ) GO TO 140
      WRITE (OUTT,130) IBAS,ID(1),IBITS(1),IBITS(2),IP(I),KBITS(1),
     1                 KBITS(2),JBITS(1),JBITS(2)
  130 FORMAT (35X,2A4,5X,I8,7X,A4,A2,6X,I8,6X,A4,A2,6X,A4,A2)
  140 CONTINUE
      CALL WRITE (SCBDAT,IP(I),1,0)
      CALL WRITE (SCBDAT,ICCC, 1,0)
  150 CONTINUE
      GO TO 50
  160 CONTINUE
  170 CALL CLOSE (SCBDAT,1)
      RETURN
C
  200 IMSG = -1
      GO TO 230
  210 IMSG = -2
      GO TO 230
  220 IMSG = -3
  230 CALL MESAGE (IMSG,IFILE,AAA)
      RETURN
      END

      SUBROUTINE EXI2
C
C     EXI2 PERFORMS EXTERNAL FORMAT SOFIN OPERATIONS
C
      EXTERNAL LSHIFT
      LOGICAL  USRMSG
      INTEGER  DRY      ,UNAME    ,UNIT     ,SYSBUF   ,A        ,
     1         Z        ,SOF      ,PRC      ,Q4       ,T3       ,
     2         SRD      ,SWRT     ,EOI      ,SP       ,BAR      ,
     3         SCR1     ,SUBR(2)  ,BUF1     ,BUF2     ,BUF3     ,
     4         BUF4     ,HDR(7)   ,RC       ,MCB(7)   ,PREC     ,
     5         DIT      ,NAME(2)  ,EOG      ,PLTS     ,OFFSET
      REAL     ZERO(6)
      DOUBLE PRECISION   DZ(1)    ,DA
      CHARACTER          UFM*23   ,UWM*25   ,UIM*29
      COMMON  /XMSSG /   UFM      ,UWM      ,UIM
      COMMON  /MACHIN/   MACH
      COMMON  /BLANK /   DRY      ,X1(3)    ,UNAME(2) ,X2(18)   ,
     1                   UNIT     ,UNIVAC   ,LBUF     ,IADD
      COMMON  /SYSTEM/   SYSBUF   ,NOUT     ,X3(6)    ,NLPP     ,
     1                   X4(2)    ,LINE
      COMMON  /ZBLPKX/   A(4)     ,IROW
      COMMON  /NAMES /   RD       ,RDREW    ,WRT      ,WRTREW   ,
     1                   REW
      COMMON  /TYPE  /   PRC(2)   ,NWORD(4)
      COMMON  /ZZZZZZ/   Z(1)
      EQUIVALENCE       (Z(1),DZ(1))        ,(A(1),DA)
      DATA     SOF      ,SRD      ,SWRT     ,EOI      ,SP       /
     1         4HSOF    ,1        ,2        ,3        ,1        /
      DATA     LEOF     ,JH       ,SCR1     ,SUBR               /
     3         4H$EOF   ,1        ,301      ,4HEXI2   ,4H       /
      DATA     DIT      ,MDI      ,EOG      ,ZERO               /
     5         4HDIT    ,4HMDI    ,2        ,6*0.0              /
      DATA     Q4       ,T3       ,BAR      ,PLTS               /
     7         2HQ4     ,2HT3     ,2HBR     ,4HPLTS             /
C
C     INITIALIZE
C
      NCORE = KORSZ(Z)
      I     = NCORE - LBUF
      IF (MACH .EQ. 12) I = I - LBUF
      NCORE = I - 1
      IRW   = IADD
      IADD  = I
      CALL EXFORT (3,UNIT,0,0,IRW,0,0)
      BUF1  = NCORE - SYSBUF + 1
      BUF2  = BUF1  - SYSBUF - 1
      BUF3  = BUF2  - SYSBUF
      BUF4  = BUF3  - SYSBUF
      NCORE = BUF4  - 1
      NOS   = 0
      IDM   = 1
      USRMSG=.TRUE.
      LCORE = NCORE
      IF (NCORE .LE. 0) GO TO 9008
      CALL SOFOPN (Z(BUF1),Z(BUF2),Z(BUF3))
      CALL PAGE
C
C     READ THE HEADER OF THE NEXT ITEM AND FETCH THE ITEM ON THE SOF
C
   10 CALL EXFORT (SRD,UNIT,JH,HDR,7,SP,0)
   20 NAME(1) = HDR(1)
      NAME(2) = HDR(2)
      ITEM    = HDR(3)
      ITEST   = HDR(7)
      IF (ITEST .EQ. EOI) ITEST = EOG
      IF (HDR(1).EQ.DIT .OR. HDR(1).EQ. MDI) GO TO 200
      IF (HDR(3).EQ. -1 .OR. HDR(1).EQ.LEOF) GO TO 300
      ITM = ITTYPE(HDR(3))
      IF (ITM .EQ. 1) GO TO 100
      RC = 3
      CALL SFETCH (HDR(1),HDR(3),SWRT,RC)
      IF (RC .EQ. 3) GO TO 60
      LINE = LINE + 2
      IF (LINE .GT. NLPP) CALL PAGE
      GO TO (30,30,60,40,50), RC
   30 WRITE (NOUT,6346) UWM,HDR(1),HDR(2),HDR(3)
      USRMSG = .FALSE.
      GO TO 60
   40 CALL EXLVL (NOS,Z(IDM),HDR,Z,LCORE)
      RC = 3
      CALL SFETCH (HDR(1),HDR(3),SWRT,RC)
      IF (RC .EQ. 3) GO TO 60
   50 CALL SMSG (RC-2,HDR(3),HDR)
      USRMSG = .FALSE.
   60 CONTINUE
C
C     TABLES
C
C
C     ELSETS TABLE CORRECTION BY G.CHAN/UNISYS   4/91
C
C     IN 91 VERSION, ELEMENT PLOT SYMBOL LINE HAS 2 WORDS, SYMBOL AND
C     NO. OF GRID POINT PER ELEMENT, NGPEL, WRITTEN OUT BY EXO2 USING
C     FORMAT 25. THE ELSETS DATA LINE COMING UP NEXT USE FORMAT 10 FOR
C     ELEMENTS WITH NO OFFSETS, FORMAT 26 FOR BAR WHICH HAS 6 OFFSET
C     VALUES, AND FORMATS 27 AND 28 FOR TRIA3 AND QUAD4 WHICH HAS 1
C     OFFSET VALUE EACH.
C     IN 90 AND EARLIER VERSIONS, ONLY ONE ELEMENT PLOT SYMBOL WORD WAS
C     WRITTEN OUT, AND ON ELSETS DATA LINE COMING UP NEXT, FORMAT 10
C     WAS USED FOR ALL ELEMENTS. NO OFFSET DATA FOR THE BAR, QUAD4 AND
C     TRIA3 ELEMENTS. NGPEL WAS THE FIRST WORD ON THE ELSETS DATA LINE.
C     ALSO, THE 90 AND EARLIER VERSIONS DID NOT COUNT PROPERTY ID, PID,
C     ON THE ELSETS DATA LINE. THUS THE TOTAL NO. OF WORDS MAY BE IN
C     ERROR AND MAY CAUSE EXTRA ZEROS AT THE END OF THE DATA LINE.
C
C     THEREFORE, IF THE 90 OR EARLIER EXTERNAL SOF FILE WAS USED, WE
C     NEED TO ADD THE OFFSETS (1 OR 6 FLOATING POINTS ZEROS) TO THE BAR,
C     QUAD4 AND TRIA3 ELEMENTS FOR THE ELSETS TABLE.
C     (AS OF 4/91, THESE CHANGES HAVE NOT BEEN TESTED)
C
      OFFSET = 0
   70 NWDS = HDR(5)
      IF (NWDS .GT. LCORE) GO TO 9008
      CALL EXFORT (SRD,UNIT,HDR(4),Z,NWDS,SP,0)
      IF (OFFSET .EQ. 0) GO TO 80
      J = 1
      CALL SUWRT (Z(1),1,J)
      NP2 = Z(1) + 2
      DO 73 K = 2,NWDS,NP2
      IF (Z(K) .EQ. 0) GO TO 75
      CALL SUWRT (Z(K),NP2,J)
      CALL SUWRT (ZERO,OFFSET,J)
   73 CONTINUE
   75 Z(1) = 0
      NWDS = 1
   80 CALL SUWRT (Z,NWDS,ITEST)
      IF (HDR(7) .EQ. EOI) GO TO 90
      CALL EXFORT (SRD,UNIT,JH,HDR,7,SP,0)
      IF (HDR(1).NE.NAME(1) .OR. HDR(2).NE.NAME(2)) GO TO 160
      IF (HDR(3) .NE. ITEM) GO TO 160
      ITEST = HDR(7)
      IF (ITEST .EQ. EOI) ITEST = EOG
      IF (ITEM.NE.PLTS .OR. HDR(5).NE.1 .OR. HDR(4).NE.10) GO TO 85
      OFFSET = 0
      IF (Z(1) .EQ. BAR) OFFSET = 6
      IF (Z(1).EQ.Q4 .OR. Z(1).EQ.T3) OFFSET = 1
   85 IF (HDR(4) .GT. 0) GO TO 70
   90 ITEST = EOI
      CALL SUWRT (0,0,ITEST)
      GO TO 140
C
C     MATRICES
C
C
C     READ TRAILER
C
  100 CALL SOFTRL (HDR(1),HDR(3),MCB(1))
      RC = MCB(1)
      IF (RC .EQ. 3) GO TO 108
      LINE = LINE + 2
      IF (LINE .GT. NLPP) CALL PAGE
      GO TO (102,102,108,104,106), RC
  102 WRITE (NOUT,6346) UWM,HDR(1),HDR(2),HDR(3)
      USRMSG = .FALSE.
      GO TO 108
  104 CALL EXLVL (NOS,Z(IDM),HDR,Z,LCORE)
      GO TO 108
  106 CALL SMSG (3,HDR(3),HDR)
      USRMSG = .FALSE.
  108 CALL EXFORT (SRD,UNIT,HDR(4),MCB(2),6,SP,0)
      NCOL   = MCB(2)
      PREC   = MCB(5)
      MCB(1) = SCR1
      MCB(2) = 0
      MCB(6) = 0
      MCB(7) = 0
      IF (USRMSG) CALL GOPEN (SCR1,Z(BUF4),WRTREW)
C
C     READ MATRIX ONE COLUMN AT A TIME AND PACK ON SCR2
C
      DO 130 J = 1,NCOL
      CALL EXFORT (SRD,UNIT,JH,HDR,7,SP,0)
      IF (HDR(1).NE.NAME(1) .OR. HDR(2).NE.NAME(2)) GO TO 160
      IF (HDR(3) .NE. ITEM) GO TO 160
      NWDS = HDR(5)
      IF (NWDS*1.4 .GT. NCORE) GO TO 9008
      CALL EXFORT (SRD,UNIT,HDR(4),Z,NWDS,PREC,DZ)
      IF (.NOT. USRMSG) GO TO 130
      CALL BLDPK (PREC,PREC,SCR1,0,0)
      IPRC = PRC(PREC)
      N    = NWORD(PREC) + IPRC
      K    = 1
  110 IF (Z(K) .LT. 0) GO TO 120
      IROW = Z(K)
      A(1) = Z(K+IPRC)
      IF (PREC .EQ. 1) GO TO 115
      A(2) = Z(K+IPRC+1)
      IF (PREC .LE. 3) GO TO 115
      A(3) = Z(K+4)
      A(4) = Z(K+5)
  115 CALL ZBLPKI
      K = K + N
      GO TO 110
  120 CALL BLDPKN (SCR1,0,MCB)
  130 CONTINUE
      IF (.NOT.USRMSG) GO TO 150
      CALL WRTTRL (MCB)
      CALL CLOSE  (SCR1,REW)
      CALL MTRXO  (SCR1,HDR,HDR(3),0,RC)
C
C     WRITE USER MESSAGE
C
  140 IF (.NOT.USRMSG) GO TO 150
      LINE = LINE + 1
      IF (LINE .GT. NLPP) CALL PAGE
      WRITE (NOUT,6357) UIM,HDR(1),HDR(2),HDR(3),UNAME,SOF
  150 USRMSG = .TRUE.
      GO TO 10
C
C     NO EOI FOR ITEM AND A NEW ITEM WAS READ
C
  160 LINE = LINE + 2
      IF (LINE .GT. NLPP) CALL PAGE
      WRITE (NOUT,6363) UWM,NAME(1),NAME(2),ITEM,UNAME
      IF (ITM .EQ. 0) CALL DELETE (NAME,ITEM,RC)
      IF (ITM .EQ. 1) CALL CLOSE (SCR1,REW)
      USRMSG = .TRUE.
      GO TO 20
C
C     READ DIT AND MDI
C
  200 NOS   = HDR(5)/2
      LCORE = NCORE - HDR(5)*4
      IDM   = LCORE + 1
      IF (6*NOS .GT. LCORE) GO TO 9008
      CALL EXFORT (SRD,UNIT,HDR(4),Z,HDR(5),SP,0)
      DO 210 I = 1,NOS
      Z(IDM+4*I-4) = Z(2*I-1)
      Z(IDM+4*I-3) = Z(2*I  )
  210 CONTINUE
      CALL EXFORT (SRD,UNIT,JH,HDR,7,SP,0)
      CALL EXFORT (SRD,UNIT,HDR(4),Z,HDR(5),SP,0)
      DO 220 I = 1,NOS
      J = IDM + 4*I - 2
      K = 6*I - 6
      Z(J  ) = LSHIFT(Z(K+1),20) + LSHIFT(Z(K+2),10) + Z(K+3)
      Z(J+1) = LSHIFT(Z(K+4),20) + LSHIFT(Z(K+5),10) + Z(K+6)
  220 CONTINUE
      GO TO 10
C
C     NORMAL MODULE COMPLETION
C
  300 CALL SOFCLS
      RETURN
C
C     ABNORMAL MODULE COMPLETION
C
 9008 CALL MESAGE (8,0,SUBR)
      DRY = -2
      CALL SOFCLS
      RETURN
C
C     MESSAGE TEXTS
C
 6346 FORMAT (A25,' 6346, SUBSTRUCTURE ',2A4,' ITEM ',A4,
     1       ' NOT COPIED.  IT ALREADY EXISTS ON THE SOF.')
 6357 FORMAT (A29,' 6357, SUBSTRUCTURE ',2A4,' ITEM ',A4,
     1       ' SUCCESSFULLY COPIED FROM ',2A4,' TO ',A4)
 6363 FORMAT (A25,' 6363, INCOMPLETE DATA FOR SUBSTRUCTURE ',2A4,
     1       ' ITEM ',A4,' ON ',2A4,'. THE ITEM WILL NOT BE COPIED.')
      END

      SUBROUTINE MAGPHA( A, B )
C*****
C THIS SUBROUTINE FORMS THE MAGNITUDE OF (A,B) AND STORES IT IN A...
C THE PHASE OF (X=A, Y=B) IS THEN FORMED AND THE RESULT STORED IN B...
C*****
      COMMON /CONDAS/ CONSTS(5)
C
      EQUIVALENCE ( CONSTS(3) , RADEG  )
C
      VALUE = SQRT( A**2 + B**2 )
      IF( VALUE ) 10,20,10
   10 PHASE = ATAN2( B, A ) * RADEG
      GO TO 30
   20 PHASE = 0.0E0
      GO TO 40
   30 IF( PHASE .LT. (-0.00005E0) ) PHASE = PHASE + 360.0E0
   40 A = VALUE
      B = PHASE
      RETURN
      END

        SUBROUTINE BLDPK ( ITYPIN, ITYPOT, FILE, BLOCK, IFLAG )
        INCLUDE 'PAKBLK.COM'
        INCLUDE 'DSIOF.COM'
        INTEGER  BLOCK(15), FILE
        ITRAIL = IFLAG
        ITYPI  = ITYPIN
        ITYPO  = ITYPOT
        NAME   = FILE
        IF ( ITYPI .LT. 1 .OR. ITYPI .GT. 4 ) GO TO 40
        IF ( ITYPO .LT. 1 .OR. ITYPO .GT. 4 ) GO TO 40
        IF ( IFLAG .EQ. 0 ) GO TO 20
        CALL DSBLPK ( BLOCK )
        GO TO 30
20      ITRAIL = 0
        CALL DSBLPK ( IBLKA )
30      GO TO 700
40      IF ( IFLAG .EQ. 0 ) CALL DSMSG1 ( IBLKA )
        IF ( IFLAG .NE. 0 ) CALL DSMSG1 ( BLOCK )
        CALL DSMSG( 118 )
700     RETURN
        END

      SUBROUTINE IDF1 (EE,E2,    ETA01,ZET01,ARE,AIM,BRE,BIM,CRE,CIM,
     1                 R1SQX,XIIJR,XIIJI)
C   ***   INTEGRATES THE PLANAR PARTS OF THE INCREMENTAL
C         OSCILLATORY KERNELS FOR UNSTEADY CASES
      PI   = 3.1415926
      PARN = ETA01**2 - ZET01**2
      FACR = PARN*ARE + ETA01*BRE + CRE
      FACI = PARN*AIM + ETA01*BIM + CIM
      PARNR= BRE/2.0  + ETA01*ARE
      PARNI= BIM/2.0  + ETA01*AIM
      UP   = (ETA01-EE)**2 + ZET01**2
      DOWN = (ETA01+EE)**2 + ZET01**2
      ARG2 = UP/DOWN
      ALARG2 = ALOG(ARG2)
      TRM2R= PARNR * ALOG(ARG2)
      TRM2I= PARNI * ALOG(ARG2)
      TRM3R= 2.0*EE* ARE
      TRM3I= 2.0*EE* AIM
      AZET = ABS(ZET01)
      IF  ((AZET/EE) . LE . 0.001)  GO TO  100
      TEST0= ABS((R1SQX-E2)/(2.0*EE*AZET))
      IF (TEST0.LE.0.0001)  GO TO 110
      COEF = (2.0*EE)/(R1SQX-E2)
      ARGA = COEF*ZET01
      TEST = ABS(ARGA)
      IF (TEST.LE.0.3)  GO TO 120
      ARGT = COEF*AZET
      ATANA= ATAN(ARGT)
      FUNCT= ATANA/AZET
      GO TO 170
  100 CONTINUE
      FUNCT= (2.0*EE)/(ETA01**2-E2)
      GO TO 170
  110 CONTINUE
      FUNCT= 0.0
      GO TO 170
  120 CONTINUE
      S    = ARGA**2
      SER  = 1./3.+S*(-1./5.+S*(1./7.+S*(-1./9.+S*(1./11.-S/13.))))
      ALPHA= E2*(COEF**2)*SER
      FUNCT= COEF*(1.0-ALPHA*(ZET01**2)/E2)
  170 CONTINUE
      TRM1R= FACR * FUNCT
      TRM1I= FACI * FUNCT
      XIIJR= TRM1R + TRM2R + TRM3R
      XIIJI= TRM1I + TRM2I + TRM3I
      RETURN
      END

      SUBROUTINE EMFLD
C
C                                            SEE T01191A     ===========
C     COMPUTES TOTAL MAGNETIC FIELD STRENGTH AND INDUCTION FOR
C     EACH ELEMENT IN BASIC COORDINATES BY ADDING HM AND HC
C
C     EMFLD    HOEF1,HEST,CASECC,HCFLD,MPT,DIT,REMFLD,GEOM1,CSTM,HCCEN/
C              HOEH1/V,N,HLUSET $
C
      INTEGER         HEST,HOEH1,HOEF1,CASECC,ESTFLD,HLUSET,DIT,
     1                FILE,BUF1,BUF2,BUF3,BUF4,BUF5,SYSBUF,OTPE,TYPOUT,
     2                ELTYPE,SUBCAS,ELID,OLDCAS,OLDEID,STRSPT,
     3                REMFL,BUF6,IDUM(2),GEOM1,CSTM,HCCEN,HCOUNT
      DIMENSION       COORD(4),ICOORD(4),TA(9),TEMP(3),MCB(7),HMG(3),
     1                HM(3),HC(3),IBUF(150),RBUF(150),NAM(2),IZ(1),ZN(2)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG / UFM,UWM,UIM,SFM
      COMMON /BLANK / HLUSET
      COMMON /GPTA1 / NELEMS,LAST,INCR,NE(1)
      COMMON /SYSTEM/ SYSBUF,OTPE
      COMMON /UNPAKX/ TYPOUT,II,NN,INCUR
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE     (RBUF(1),IBUF(1)),(COORD(1),ICOORD(1)),
     1                (Z(1),IZ(1))
      DATA    HOEF1 , HEST,CASECC,MPT,DIT/ 101,102,103, 105,106/
      DATA    REMFL , GEOM1,CSTM,HCCEN   / 107,108,109, 110    /
      DATA    ESTFLD, HOEH1/301,201 /
      DATA    NAM   / 4HEMFL,4HD    /, ZN/ 4HHOEH,4H1          /
      DATA    HEX1  , HEX2, HEX3    /  4HHEX1,4HHEX2,4HHEX3    /
C
C     CHECK TO SEE IF HOEF1 EXISTS. IF NOT, THEN NO MAG. FIELD REQUESTS
C
      MCB(1) = HOEF1
      CALL RDTRL (MCB)
      IF (MCB(1) .LT. 0) GO TO 600
      MCB(1) = HCCEN
      CALL RDTRL (MCB)
      NN = MCB(3)
      IF (MCB(1) .GT. 0) GO TO 20
      NN = 0
      MCB(1) = REMFL
      CALL RDTRL (MCB)
      IF (MCB(1) .GT. 0) GO TO 20
      WRITE  (OTPE,10)  UWM
   10 FORMAT (A25,', DATA BLOCKS HCFLD AND REMFL ARE PURGED IN EM ',
     1       'PROBLEM. ALL RESULTS ARE ZERO')
      GO TO 600
C
   20 MCB(1) = HEST
      CALL RDTRL (MCB)
      NELX = 3*MCB(2)
C
      TYPOUT = 1
      II     = 1
      INCUR  = 1
C
C     CREATE ESTFLD WHICH LOOKS LIKE HEST BUT CONTAINS ONLY TYPE, ID,
C     NUMBER OF SILS,SILS,3 X 3 MATERAIL MATRIX,AND 3 X 3 TRANSFORMATION
C     MATRIX FROM LOCAL TO BASIC,BFIELD,AND COORDS OF STRESS POINT FOR
C     NON-RECTANGULAR BFIELD
C
      CALL ESTMAG (HEST,ESTFLD,MPT,DIT,GEOM1,IANY,KCOUNT)
C
C     KCOUNT SHOULD BE NUMBER OF TERMS IN ROW OF HCCEN
C
      IF (NN .EQ. 0) NN = KCOUNT
      IF (NN .NE. KCOUNT) GO TO 500
      NROWS = NN
C
C     NOW FETCH HC AT EACH POINT FROM HCFLD
C
      LCORE = KORSZ(Z)
      BUF1  = LCORE- SYSBUF + 1
      BUF2  = BUF1 - SYSBUF
      BUF3  = BUF2 - SYSBUF
      BUF4  = BUF3 - SYSBUF
      BUF5  = BUF4 - SYSBUF
      BUF6  = BUF5 - SYSBUF
      LCORE = BUF6 - 1
      IF (LCORE .LE. 0) GO TO 550
C
      NCOUNT = 0
      OLDCAS = 0
      HCOUNT = 0
C
C     COPY HEADER FROM HOEF1 TO HOEH1
C
      FILE = HOEH1
      CALL OPEN (*520,HOEH1,Z(BUF5),1)
      FILE = HOEF1
      CALL OPEN (*520,HOEF1,Z(BUF4),0)
      CALL READ (*530,*30,HOEF1,Z,LCORE,0,IWORDS)
      GO TO 550
   30 Z(1) = ZN(1)
      I    = 2
      Z(I) = ZN(2)
      CALL WRITE (HOEH1,Z,IWORDS,1)
C
C     OPEN CSTM FOR NON-BASIC COORDINATE SYSTEM
C
      NCSTM = 0
      IF (IANY .EQ. 0) GO TO 50
      CALL GOPEN (CSTM,Z(BUF1),0)
      CALL READ  (*530,*40,CSTM,Z,LCORE,0,NCSTM)
      GO TO 550
   40 CALL CLOSE  (CSTM,1)
      CALL PRETRS (Z(1),NCSTM)
C
   50 NNCR = NCSTM + NROWS
      NALL = NNCR  + NELX
      CALL GOPEN (CASECC,Z(BUF1),0)
      CALL GOPEN (HCCEN,Z(BUF2),0)
      CALL GOPEN (ESTFLD,Z(BUF3),0)
      CALL GOPEN (REMFL,Z(BUF6),0)
C
C     READ ID RECORD FROM HOEF1. COPY TO HOEH1, EXCEPT CHANGE NUMBER OF
C     WORDS FROM +9 TO -9 AS AN INDICATOR FOR TITLES IN OFP. (+9 IS FOR
C     HEAT TRANSFER) ALSO PICK UP SUBCASE NUMBER AND ELEMENT TYPE. IF
C     SAME SUBCASE AS PREVIUUS ONE, USE SAME HCFLD VECTOR. IF NOT,
C     CREATE A NEW ONE
C
   60 CALL READ (*410,*540,HOEF1,IBUF,146,1,IWORDS)
      IBUF(10) = -9
      CALL WRITE (HOEH1,IBUF,146,1)
      ELTYPE = IBUF(3)
      SUBCAS = IBUF(4)
      OLDEID = 0
      IF (SUBCAS .EQ. OLDCAS) GO TO 260
      OLDCAS = SUBCAS
      NCOUNT = 0
      HCOUNT = 0
      CALL REWIND (ESTFLD)
      FILE   = ESTFLD
      CALL FWDREC (*530,ESTFLD)
C
C     IF THIS SUBCASE IS NOT A SUBCOM, UNPACK NEXT COLUMN OF HCFLD. IF
C     IT IS A SUBCOM, BCKREC HCFLD THE SAME NUMBER OF RECORDS AS THERE
C     ARE FACTORS ON THE SUBSEQ AND COMBINE VECTORS TO PRODUCE ONE
C     VECTOR.
C
      IF (LCORE .LT. 16) GO TO 550
   70 FILE = CASECC
      CALL READ (*530,*540,CASECC,Z(NCSTM+1),16,0,IWORDS)
      IF (IZ(NCSTM+1) .EQ. SUBCAS) GO TO 80
      CALL FWDREC (*530,CASECC)
      FILE = HCCEN
      CALL FWDREC (*530,HCCEN)
      FILE = REMFL
      CALL FWDREC (*530,REMFL)
      GO TO 70
C
C     MATCH ON SUBCASE ID. SEE HOW LONG THE RECORD IS
C
   80 IF (IZ(NCSTM+16) .EQ. 0) GO TO 200
C
C     SUBCOM UNLESS IZ(16).LT.0. IN WHICH CASE IT IS A REPEAT SUBCASE
C
      IF (IZ(NCSTM+16) .GT. 0) GO TO 90
      CALL BCKREC (HCCEN)
      CALL BCKREC (REMFL)
      GO TO 200
C
C     SUBCOM. GET NUMBER OF FACTORS AND BCKREC THAT MANY RECORDS ON
C     HCFLD
C
C     OPEN CORE (AFTER NCSTM WORDS OF CSTM)
C             1 - NEXTZ   CASECC
C             NEXTZ+1 - NEXTZ+NROWS   COLUMN OF HCCEN
C             NEXTZ+NROWS+1 - NEXTZ+2*NROWS=NEXTP  HCCEN COMBINATION
C             NEXTP+1 - NEXTP+NELX  COLUMN OF REMFL
C             NEXTP+NELX+1 - NEXTP+2*NELX  REMFL COMBINATION
C
   90 CALL READ (*530,*100,CASECC,Z(NCSTM+17),LCORE,0,IWORDS)
      GO TO 550
  100 LCC  = IZ(NCSTM+166)
      LSYM = IZ(NCSTM+LCC)
      DO 110 I = 1,LSYM
      CALL BCKREC (HCCEN)
      CALL BCKREC (REMFL)
  110 CONTINUE
      NEXTZ  = IWORDS + 16 + NCSTM
      NROWS2 = 2*NROWS
      NEXTR  = NEXTZ + NROWS
      NELX2  = 2*NELX
      NALL2  = NROWS2 + NELX2
      NEXTP  = NEXTZ  + NROWS2
      ISUB   = NEXTP  + NELX
      IF (NEXTZ+NALL2 .GT. LCORE) GO TO 550
C
C     SET UP FOR SUBSEQ
C
      DO 120 I = 1,NALL2
  120 Z(NEXTZ+I) = 0.
      DO 170 I = 1,LSYM
      COEF = Z(NCSTM+LCC+I)
      IF (COEF .EQ. 0.) GO TO 160
      NN = NROWS
      CALL UNPACK (*140,HCCEN,Z(NEXTZ+1))
      DO 130 J = 1,NROWS
      Z(NEXTR+J) = Z(NEXTR+J) + COEF*Z(NEXTZ+J)
  130 CONTINUE
  140 NN = NELX
      CALL UNPACK (*170,REMFL,Z(NEXTP+1))
      DO 150 J = 1,NELX
      Z(ISUB+J) = Z(ISUB+J) + COEF*Z(NEXTP+J)
  150 CONTINUE
      GO TO 170
C
C     COEF = 0.
C
  160 FILE = HCCEN
      CALL FWDREC (*530,HCCEN)
      FILE = REMFL
      CALL FWDREC (*530,REMFL)
  170 CONTINUE
C
C     MOVE THE VECTOR IN CORE
C
      DO 180 I = 1,NROWS
  180 Z(NCSTM+I) = Z(NEXTR+I)
      DO 190 I = 1,NELX
  190 Z(NNCR+I) = Z(ISUB+I)
      GO TO 260
C
C     NOT A SUBCOM
C     UNPACK A COLUMN OF HCFLD. FIRST SKIP TO NEXT RECORD ON CASECC
C
  200 FILE = CASECC
      CALL FWDREC (*530,CASECC)
      NN = NROWS
      CALL UNPACK (*210,HCCEN,Z(NCSTM+1))
      GO TO 230
  210 DO 220 I = 1,NROWS
  220 Z(NCSTM+I) = 0.
  230 NN = NELX
      CALL UNPACK (*240,REMFL,Z(NNCR+1))
      GO TO 260
  240 DO 250 I = 1,NELX
  250 Z(NNCR+I) = 0.
C
C     HCFLD VECTOR IS IN Z(NCSTM+1)-Z(NCSTM+NROWS=NNCR) AND REMFL IS IN
C     Z(NNCR+1)-Z(NNCR+NELX). MATCH ELEMENT TYPE ON HOEF1 WITH ESTFLD
C
  260 FILE = ESTFLD
  270 CALL READ (*530,*540,ESTFLD,IEL,1,0,IWORDS)
      IEX = 3
      IF (IEL.EQ.66 .OR. IEL.EQ.67) IEX = 63
      IF (IEL .EQ. 65) IEX = 27
      IPTS = IEX/3
C
C     SINCE IS2D8 HAS 9 POINTS ON HCCEN BUT ONLY ONE ON HEOF1 AND ESTFLD
C     RESET IPTS
C
      IF (IEL .EQ. 80) IPTS = 9
      IF (IEL .EQ. ELTYPE) GO TO 290
C
C     NO MATCH. SKIP TO NEXT RECORD, BUT KEEP UP WITH NCOUNT
C
  280 CALL READ (*530,*270,ESTFLD,IDUM,2,0,IWORDS)
      CALL FREAD (ESTFLD,IDUM,-(IDUM(2)+19+IEX),0)
      NCOUNT = NCOUNT + 1
      HCOUNT = HCOUNT + IPTS
      GO TO 280
C
C     MATCH ON ELEMENT TYPE. FIND A MATCH ON ELEMENT ID
C
  290 FILE = HOEF1
      CALL READ (*530,*380,HOEF1,RBUF,9,0,IWORDS)
      ELID = IBUF(1)/10
      FILE = ESTFLD
C
C     NEXT STATEMENT IS FOR ISOPARAMETRICS WHICH HAVE MULTIPLE POINTS
C     ON HOEF1, BUT ONLY ONE SET OF INFO ON ESTFLD(BUT MULTIPLE COORDS
C     FOR NON-BASIC COORDINATE SYSTEMS). IF MATERIAL IS ALLOWED TO BE
C     TEMPERATURE-DEPENDENT AT SOME LATER DATE IN MAGNETICS PROBLEMS,
C     THEN ESTFLD WILL HAVE MULTIPLE INFO. WRIITEN IN ESTMAG AND THIS
C     STATEMENT CAN BE DELETED
C
      IF (OLDEID .NE. 0) GO TO 310
C
  300 CALL READ (*530,*540,ESTFLD,IZ(NALL+1),2,0,IWORDS)
      NCOUNT = NCOUNT + 1
      HCOUNT = HCOUNT + IPTS
      IELID  = IZ(NALL+1)
      NGRIDS = IZ(NALL+2)
      NWORDS = NGRIDS + 19 + IEX
      IF (NALL+NWORDS .GT. LCORE) GO TO 550
      CALL READ (*530,*540,ESTFLD,Z(NALL+1),NWORDS,0,IWORDS)
C
      IF (ELID.EQ.IELID) GO TO 310
      GO TO 300
C
C     MATCH ON ELEMENT ID. PICK UP HM FROM HOEF1(IN ELEMENT COORDS)
C     PICK UP 3 X 3 TRANSFORMATION MATRIX FROM ESTFLD TO CONVERT ELEMENT
C     SYSTEM TO BASIC. THEN MULTIPLY
C
  310 HM(1) = RBUF(4)
      HM(2) = RBUF(5)
      HM(3) = RBUF(6)
CWKBNB 8/94 ALPHA-VMS
      ITYPE = NUMTYP( HM(2) )
      IF ( ITYPE .LE. 1 ) HM(2) = 0.
      ITYPE = NUMTYP( HM(3) )
      IF ( ITYPE .LE. 1 ) HM(3) = 0.
CWKBNE 8/94 ALPHA-VMS
      CALL GMMATS (Z(NALL+NGRIDS+10),3,3,0,HM,3,1,0,HMG)
C
C     PICK UP HC FROM HCCEN VECTOR. FOR ALL EXCEPT ISOPARAMETRICS,HCOUNT
C     POINTS TO THE Z COMPONENT OF PROPER HC WHICH STARTS AT Z(NCSTM+1)
C
      IF (RBUF(2).NE.HEX1 .AND. RBUF(2).NE.HEX2 .AND. RBUF(2).NE.HEX3)
     1   GO TO 330
C
C     ISOPARAMETRIC SOLIDS
C
      IF (OLDEID .EQ. ELID) GO TO 320
      OLDEID = ELID
      STRSPT = 0
  320 STRSPT = STRSPT + 1
      IF (STRSPT .GE. 21) OLDEID = 0
      IF (RBUF(2).EQ.HEX1 .AND. STRSPT.GE.9) OLDEID = 0
      GO TO 340
  330 STRSPT = 1
C
C     NEXT LINE IS FOR IS2D8 WHICH HAS 9 POINTS ON HCCEN BUT ONE ON
C     ESTFLD
C
      IF (IEL .EQ. 80) STRSPT = 9
  340 ISUB  = NCSTM + 3*(HCOUNT-IPTS+STRSPT-1)
      HC(1) = Z(ISUB+1)
      HC(2) = Z(ISUB+2)
      HC(3) = Z(ISUB+3)
C
      DO 350 I = 1,3
  350 RBUF(I+3) = HMG(I) + HC(I)
C
C     TO GET INDUCTION B, MULTIPLY H BY MATERIALS
C
      CALL GMMATS (Z(NALL+NGRIDS+1),3,3,0,RBUF(4),3,1,0,RBUF(7))
C
C     ADD IN REMANENCE Z(NNCR+1)-Z(NNCR+NELX)
C
      ISUB = NNCR + 3*NCOUNT - 3
      RBUF(7) = RBUF(7) + Z(ISUB+1)
      RBUF(8) = RBUF(8) + Z(ISUB+2)
      RBUF(9) = RBUF(9) + Z(ISUB+3)
C
C     CHECK FOR REQUEST FOR NON-BASIC COORD. SYSTEM. TA TRANSFORMS TO
C     BASIC
C
      IFIELD = IZ(NALL+NGRIDS+19)
      IF (IFIELD .EQ. 0) GO TO 370
      ICOORD(1) = IFIELD
C
C     NEXT LINE IS FOR IS2D8 WHICH ONLY ONE POINT ON ESTFLD
C
      IF (IEL .EQ. 80) STRSPT = 1
      ISUB = NALL + NGRIDS + 19 + 3*STRSPT - 3
      COORD(2) = Z(ISUB+1)
      COORD(3) = Z(ISUB+2)
      COORD(4) = Z(ISUB+3)
      CALL TRANSS (COORD,TA)
      CALL GMMATS (TA,3,3,1,RBUF(7),3,1,0,TEMP)
      DO 360 I = 1,3
  360 RBUF(I+6) = TEMP(I)
C
  370 CONTINUE
C
C     WRITE OUT TO HOEH1
C
      CALL WRITE (HOEH1,RBUF,9,0)
C
C     GET ANOTHER ELEMENT OF THIS TYPE IN THIS SUBCASE
C
      GO TO 290
C
C     END OF ELEMENTS OF PRESENT TYPE AND/OR SUBCASE ON HOEF1
C
  380 CALL WRITE (HOEH1,0,0,1)
      FILE = ESTFLD
C
C     SKIP RECORD BUT KEEP UP WITH NCOUNT
C
  390 CALL READ (*530,*400,ESTFLD,IDUM,2,0,IWORDS)
      CALL FREAD (ESTFLD,IDUM,-(IDUM(2)+19+IEX),0)
      NCOUNT = NCOUNT + 1
      HCOUNT = HCOUNT + IPTS
      GO TO 390
  400 FILE = HOEF1
      GO TO 60
C
C     EOF ON HOEF1 - ALL DONE
C
  410 CALL CLOSE (CASECC,1)
      CALL CLOSE (HCCEN,1)
      CALL CLOSE (ESTFLD,1)
      CALL CLOSE (HOEF1,1)
      CALL CLOSE (REMFL,1)
      CALL CLOSE (HOEH1,1)
      MCB(1) = HOEF1
      CALL RDTRL (MCB)
      MCB(1) = HOEH1
      CALL WRTTRL (MCB)
      GO TO 600
C
C     FATAL ERROR MESSAGES
C
  500 WRITE  (OTPE,510) SFM
  510 FORMAT (A25,', ROW COUNT ON HCCEN IN EMFLD IS NOT CONSISTENT')
      CALL MESAGE (-61,0,0)
  520 N = -1
      GO TO 560
  530 N = -2
      GO TO 560
  540 N = -3
      GO TO 560
  550 N = -8
      FILE = 0
  560 CALL MESAGE (N,FILE,NAM)
C
  600 RETURN
      END

      SUBROUTINE HMAT (ID)
C
C     MAT ROUTINE FOR USE IN -HEAT- FORMULATIONS ONLY.
C
C         CALL PREHMA (Z)  SETUP CALL MADE BY SMA1A, EMGTAB, ETC.
C
C         CALL HMAT (ELID)  ELEMENT ROUTINE CALLS
C
C
C     REVISED BY G.CHAN/UNISYS
C     5/90 - THE THERMAL CONDUCTIVITY OR CONVECTIVE FILM COEFFICIENT K,
C            IS TIME DEPENDENT IF MATT4 REFERS TO TABLEM5. TIME STEP IS
C            DEFINED VIA TSTEP IN /HMATDD/. IF TIME STEP IS NOT USED,
C            TSTEP SHOULD BE -999.
C            (TSTEP IS INITIALIZED TO -999. WHEN PREHMA IS CALLED)
C     7/92 - NEW REFERENCE TO OPEN CORE ARRAY SUCH THAT THE SOURCE CODE
C            IS UP TO ANSI FORTRAN 77 STANDARD.
C
      LOGICAL         ANY4    ,ANY5    ,ANYT4   ,ANYT5   ,LINEAR  ,
     1                ANYTAB
      INTEGER         NAME(2) ,SYSBUF  ,OUTPT   ,FLAG    ,CORE    ,
     1                DIT     ,OLDMID  ,OLDFLG  ,CLSREW  ,CLS     ,
     2                TYPE    ,MAT4(2) ,MAT5(2) ,MATT4(2),MATT5(2),
     3                TSET    ,OFFSET  ,TABLST(16)
      REAL            CARD(10),RZ(1)
      CHARACTER       UFM*23  ,UWM*25  ,UIM*29  ,SFM*25
      COMMON /XMSSG / UFM     ,UWM     ,UIM     ,SFM
      COMMON /ZZZZZZ/ Z(1)
      COMMON /MATIN / MATID   ,INFLAG  ,ELTEMP  ,DUM(1)  ,S       ,C
      COMMON /HMTOUT/ BUF(7)
      COMMON /NAMES / RD      ,RDREW   ,WRT     ,WRTREW  ,CLSREW  ,CLS
      COMMON /HMATDD/ IHMATX  ,NHMATX  ,MPT     ,DIT     ,LINEAR  ,
     1                ANYTAB  ,TSTEP
      COMMON /SYSTEM/ KSYSTM(65)
      EQUIVALENCE     (KSYSTM( 1),SYSBUF) ,(KSYSTM( 2),OUTPT ) ,
     1                (KSYSTM(10),TSET  ) ,(KSYSTM(56),ITHERM) ,
     2                (F4,N4)    ,(F5,N5)
      DATA    NAME  / 4HHMAT,4H    /, NOEOR  / 0 /
      DATA    MAT4  / 2103  ,21    /
      DATA    MAT5  / 2203  ,22    /
      DATA    MATT4 / 2303  ,23    /
      DATA    MATT5 / 2403  ,24    /
      DATA    TABLST/ 5, 105,1,1,  205,2,2, 305,3,3, 405,4,4, 505,5,5 /
C
C     CALL BUG (4HHMTI,0,MATID,6)
C
      IF (ICHECK .NE. 123456789) CALL ERRTRC ('HMAT    ',0)
      GO TO 200
C
C
      ENTRY PREHMA (RZ)
C     =================
C
      IF (ITHERM) 500,500,10
   10 ICHECK = 123456789
      OFFSET = LOCFX(RZ(1)) - LOCFX(Z(1))
      IF (OFFSET .LT. 0) CALL ERRTRC ('HMAT    ',10)
      TSTEP  = -999.
      IHMAT  = IHMATX + OFFSET
      NHMAT  = NHMATX + OFFSET
      LBUF   = NHMAT  - SYSBUF
      CORE   = LBUF   - IHMAT
      IF (CORE .LT. 10) CALL MESAGE (-8,0,NAME)
      CALL PRELOC (*125,Z(LBUF),MPT)
C
C     LOCATE MAT4 CARDS AND BLAST THEM INTO CORE.
C
      ANYTAB =.FALSE.
      ANY4   =.FALSE.
      IMAT4  = IHMAT + 1
      NMAT4  = IHMAT
      CALL LOCATE (*40,Z(LBUF),MAT4,FLAG)
      CALL READ (*480,*30,MPT,Z(IMAT4),CORE,NOEOR,IWORDS)
      CALL MESAGE (-8,0,NAME)
   30 NMAT4 =  NMAT4 + IWORDS
   40 MAT4S = (NMAT4 - IMAT4 + 1)/3
      IF (MAT4S .GT. 0) ANY4 = .TRUE.
C
C     LOCATE MATT4 CARDS AND BLAST THEM INTO CORE IF THERE WERE ANY MAT4
C
      ANYT4  =.FALSE.
      IMATT4 = NMAT4 + 1
      NMATT4 = NMAT4
      IF (.NOT.ANY4 .OR. (TSET.EQ.0 .AND. TSTEP.LT.0.)) GO TO 60
      CALL LOCATE (*60,Z(LBUF),MATT4,FLAG)
      CALL READ (*480,*50,MPT,Z(IMATT4),CORE,NOEOR,IWORDS)
      CALL MESAGE (-8,0,NAME)
   50 NMATT4 =  NMATT4 + IWORDS
   60 MATT4S = (NMATT4 - IMATT4 + 1)/2
      IF (MATT4S .GT. 0) ANYT4 = .TRUE.
C
C     LOCATE MAT5 CARDS AND BLAST THEM INTO CORE.
C
      ANY5  =.FALSE.
      IMAT5 = NMATT4 + 1
      NMAT5 = NMATT4
      CALL LOCATE (*80,Z(LBUF),MAT5,FLAG)
      CALL READ (*480,*70,MPT,Z(IMAT5),CORE,NOEOR,IWORDS)
      CALL MESAGE (-8,0,NAME)
   70 NMAT5 =  NMAT5 + IWORDS
   80 MAT5S = (NMAT5 - IMAT5 + 1)/8
      IF (MAT5S .GT. 0) ANY5 = .TRUE.
C
C     LOCATE MATT5 CARDS AND BLAST THEM INTO CORE IF THERE WERE ANY MAT5
C
      ANYT5  =.FALSE.
      IMATT5 = NMAT5 + 1
      NMATT5 = NMAT5
      IF (.NOT.ANY5 .OR. (TSET.EQ.0 .AND. TSTEP.LT.0.)) GO TO 100
      CALL LOCATE (*100,Z(LBUF),MATT5,FLAG)
      CALL READ (*480,*90,MPT,Z(IMATT5),CORE,NOEOR,IWORDS)
      CALL MESAGE (-8,0,NAME)
   90 NMATT5 =  NMATT5 + IWORDS
  100 MATT5S = (NMATT5 - IMATT5 + 1)/7
      IF (MATT5S .GT. 0) ANYT5 = .TRUE.
      CALL CLOSE (MPT,CLSREW)
C
C     IF A TEMPERATURE SET IS SPECIFIED -DIT- IS NOW READ INTO CORE,
C     PROVIDING ANY MATT4 OR MATT5 CARDS WERE PLACED INTO CORE.
C
      IF ((TSET.EQ.0 .AND. TSTEP.LT.0.) .OR.
     1   (.NOT.ANYT4 .AND. .NOT.ANYT5)) GO TO 130
C
C     BUILD LIST OF TABLE NUMBERS POSSIBLE FOR REFERENCE
C
      KK = 0
      ITABNO = NMATT5 + 1
      NTABNO = ITABNO
C
      IF (MATT4S .LE. 0) GO TO 110
      DO 108 I = IMATT4,NMATT4,2
      F4 = Z(I+1)
      IF (N4) 108,108,102
  102 IF (KK) 107,107,103
  103 DO 105 J = ITABNO,NTABNO
      F5 = Z(J)
      IF (N4 .EQ. N5) GO TO 108
  105 CONTINUE
C
C     ADD NEW TABLE ID TO LIST
C
  107 NTABNO = NTABNO + 1
      Z(NTABNO) = Z(I+1)
      KK = 1
  108 CONTINUE
C
  110 IF (MATT5S .LE. 0) GO TO 120
      DO 118 I = IMATT5,NMATT5,7
      J1 = I + 1
      J2 = I + 6
      DO 117 J = J1,J2
      F4 = Z(J)
      IF (N4) 117,117,111
  111 IF (KK) 115,115,113
  113 DO 114 K = ITABNO,NTABNO
      F5 = Z(K)
      IF (N4 .EQ. N5) GO TO 117
  114 CONTINUE
C
C     ADD NEW TABLE ID TO LIST
C
  115 NTABNO = NTABNO + 1
      Z(NTABNO) = Z(J)
      KK = 1
  117 CONTINUE
  118 CONTINUE
C
  120 N4 = NTABNO - ITABNO
      Z(ITABNO) = F4
C
C     CALL BUG (4HTABL,120,Z(ITABNO),NTABNO-ITABNO+1)
C
      IF (N4) 130,130,122
  122 CALL SORT (0,0,1,1,Z(ITABNO+1),N4)
C
C     OK READ IN DIRECT-INPUT-TABLE (DIT)
C
      IDIT  = NTABNO + 1
      IGBUF = NHMAT - SYSBUF - 2
      LZ    = IGBUF - IDIT  - 1
      IF (LZ .LT. 10) CALL MESAGE (-8,0,NAME)
      CALL PRETAB (DIT,Z(IDIT),Z(IDIT),Z(IGBUF),LZ,LUSED,Z(ITABNO),
     1             TABLST)
      NDIT  = IDIT + LUSED
      NHMAT = NDIT + 1
C
C     CALL BUG (4HDITS,123,Z(IDIT),NDIT-IDIT+1)
C
      GO TO 140
C
C     WRAP UP THE PRE-HMAT SECTION
C
  125 NHMAT = IHMAT - 1
      ANY4  =.FALSE.
      ANY5  =.FALSE.
      GO TO 140
  130 NHMAT  = NMATT5
  140 OLDMID = 0
      OLDFLG = 0
      OLDSIN = 0.0
      OLDCOS = 0.0
      OLDTEM = 0.0
      OLDSTP = 0.0
      S      = 0.0
      C      = 0.0
      DUM(1) = 0.0
      ELTEMP = 0.0
      NHMATX = NHMAT - OFFSET
C
C     CHECK FOR DUPLICATE MATID-S ON BOTH MAT4 AND MAT5 CARDS.
C
      IF (.NOT.ANY4 .OR. .NOT.ANY5) GO TO 490
      J4 = IMAT4
      J5 = IMAT5
      F4 = Z(J4)
      F5 = Z(J5)
  150 IF (N4 - N5) 160,180,170
C
C     MAT4 ID IS LESS THAN MAT5 ID
C
  160 J4 = J4 + 3
      IF (J4 .GT. NMAT4) GO TO 490
      F4 = Z(J4)
      GO TO 150
C
C     MAT5 ID IS LESS THAN MAT4 ID.
C
  170 J5 = J5 + 8
      IF (J5 .GT. NMAT5) GO TO 490
      F5 = Z(J5)
      GO TO 150
C
C     ID OF MAT4 IS SAME AS THAT OF MAT5
C
  180 WRITE  (OUTPT,190) UWM,N4
  190 FORMAT (A25,' 2155, MAT4 AND MAT5 MATERIAL DATA CARDS HAVE SAME ',
     1       'ID =',I14, /5X,'MAT4 DATA WILL BE SUPPLIED WHEN CALLED ',
     2       'FOR THIS ID.')
      GO TO 170
C
C                 DATA RETURNED IF MAT-ID       DATA RETURNED IF MAT-ID
C     INFLAG      IS ON A MAT4 CARD             IS ON A MAT5 CARD.
C     =================================================================
C
C       1           1- K                               1- KXX
C                   2- CP                              2- CP
C
C       2           1- K                               1- KXXB
C                   2- 0.0                             2- KXYB
C                   3- K                               3- KYYB
C                   4- CP                              4- CP
C
C       3           1- K                               1- KXX
C                   2- 0.0                             2- KXY
C                   3- 0.0                             3- KXZ
C                   4- K                               4- KYY
C                   5- 0.0                             5- KYZ
C                   6- K                               6- KZZ
C                   7- CP                              7- CP
C
C       4           1- CP                              1- CP
C
C
C
C
C     DATA LOOK UP SECTION.  FIND MAT-ID IN CARD IMAGES.
C
C
  200 IF (INFLAG - OLDFLG) 260,210,260
  210 IF (MATID  - OLDMID) 260,220,260
  220 IF (ELTEMP - OLDTEM) 260,225,260
  225 IF (TSTEP  - OLDSTP) 260,230,260
  230 IF (TYPE  .EQ.    4) GO TO 250
      IF (S      - OLDSIN) 260,240,260
  240 IF (C      - OLDCOS) 260,250,260
C
C     ALL INPUTS SEEM TO BE SAME THUS RETURN IS MADE.
C
  250 GO TO 490
C
C     FIND POINTER TO SECOND WORD OF CARD IMAGE WITH MAT-ID DESIRED.
C     AMONG EITHER MAT4S OR MAT5S.
C
  260 OLDFLG = INFLAG
      OLDMID = MATID
      OLDCOS = C
      OLDSIN = S
      OLDTEM = ELTEMP
      OLDSTP = TSTEP
      LINEAR = .TRUE.
      IF (.NOT.ANY4) GO TO 270
      CALL BISLOC (*270,MATID,Z(IMAT4),3,MAT4S,JPOINT)
      J = IMAT4 + JPOINT
      TYPE = 4
      GO TO 280
  270 IF (.NOT. ANY5) GO TO 460
      CALL BISLOC (*460,MATID,Z(IMAT5),8,MAT5S,JPOINT)
      J = IMAT5 + JPOINT
      TYPE = 5
C
C     IF A THERMAL SET IS REQUESTED (TSET.NE.0) THEN A FACTOR, WHICH IS
C     A FUNCTION OF THE AVERAGE ELEMENT TEMPERATURE, ELTEMP, (OR TIME
C     STEP, TSTEP) AND THE TABULATED VALUE IN TABLEMI, IS USED AS A
C     MULTIPLIER TO THE K-TERMS IN MAT4 OR MATT5
C
C     IF THE MATERIAL ID IS FOUND ON A -MAT4- AN ATTEMPT IS MADE TO FIND
C     A CORRESPONDING -MATT4- CARD.  LIKEWISE THIS IS DONE IF THE
C     MATERIAL ID IS FOUND ON A -MAT5- CARD WITH RESPECT TO A -MATT5-
C     CARD. IF THE -MAT4- OR -MAT5- HAS A RESPECTIVE -MATT4- OR -MATT5-
C     CARD, THEN THE THERMAL CONDUCTIVITY OR THE CONVECTIVE FILM COEFF.
C     K, IS TEMPERATURE DEPENDENT IF TABLEM1, TABLEM2, TABLEM3 AND
C     TABLEM4 ARE REFERENECED. K IS TIME DEPENDENT IF TABLEM5 IS USED.
C     THE K-TERMS OF THE -MAT4- OR -MAT5- CARDS WILL BE MODIFIED BY
C     USING -ELTEMP- AND THE -DIT- AS SPECIFIED IN THE RESPECTIVE FIELDS
C     OF THE RESPECTIVE -MATT4- OR -MATT5- CARD.  A ZERO T(K) IN A
C     PARTICULAR FIELD OF THE RESPECTIVE -MATT4- OR -MATT5- CARD IMPLIES
C     NO TEMPERATURE DEPENDENCE FOR THAT RESPECTIVE K VALUE.
C     -DIT- TABLES TABLEM1, TABLEM2, TABLEM3, TABLEM4 AND TABLEM5 MAY BE
C     USED.
C
C
C     MOVE MAT CARD INTO SPECIAL BUF WHERE IT CAN BE MODIFIED IF
C     NECESSARY
C
  280 DO 290 I = 1,10
      CARD(I) = Z(J)
      J = J + 1
  290 CONTINUE
C
C     CHECK FOR EXISTENCE OF A THERMAL SET REQUEST OR TIME STEP.
C
      IF ((TSET.EQ.0 .AND. TSTEP.LT.0.) .OR. INFLAG.EQ.4) GO TO 350
C
C     IF -MAT4- CARD, FIND THE -MATT4- CARD
C     (IF NO MATT4 ASSUME NO TEMPERATURE OR TIME DEPENDENCE)
C
      IF (TYPE .EQ. 5) GO TO 300
      IWORDS = 2
      IMAT   = IMATT4
      MATS   = MATT4S
      GO TO 310
  300 IWORDS = 7
      IMAT   = IMATT5
      MATS   = MATT5S
  310 IF (MATS) 350,350,315
  315 CALL BISLOC (*350,MATID,Z(IMAT),IWORDS,MATS,JPOINT)
      ITEMP =  IMAT + JPOINT
      NTEMP = ITEMP + IWORDS - 2
C
C     Z(I) FIELDS SPECIFYING A NON-ZERO TABLE IMPLY TEMPERATURE (OR
C     TIME) DEPENDENCE ON CORRESPONDING FIELDS OF THE MAT4 OR MAT5
C     STORED IN THE ARRAY -CARD-.
C
      KK = 0
      DO 340 I = ITEMP,NTEMP
      KK = KK + 1
      F4 = Z(I)
      IF (N4) 340,340,320
C
C     OK TEMPERATURE (OR TIME) DEPENDENCE.
C
  320 IF (TSET  .GT.  0) X = ELTEMP
      IF (TSTEP .GE. 0.) X = TSTEP
      CALL TAB (N4,X,FACTOR)
      CARD(KK) = CARD(KK)*FACTOR
      LINEAR = .FALSE.
  340 CONTINUE
C
C     BRANCH ON INFLAG.
C
  350 IF (INFLAG.LT.1 .OR. INFLAG.GT.4) GO TO 440
      GO TO (360,380,400,420), INFLAG
C
C     INFLAG = 1
C
  360 IF (TYPE .EQ. 5) GO TO 370
      BUF(1) = CARD(1)
      BUF(2) = CARD(2)
      GO TO 490
  370 BUF(1) = CARD(1)
      BUF(2) = CARD(7)
      GO TO 490
C
C     INFLAG = 2
C
  380 IF (TYPE .EQ. 5) GO TO 390
      BUF(1) = CARD(1)
      BUF(2) = 0.0
      BUF(3) = BUF(1)
      BUF(4) = CARD(2)
      GO TO 490
  390 CSQ = C*C
      SSQ = S*S
      CS  = C*S
      CS2KXY = CS *2.0*CARD(2)
      BUF(1) = CSQ* CARD(1) - CS2KXY   +  SSQ*CARD(4)
      BUF(2) = CS *(CARD(1) - CARD(4)) + (CSQ - SSQ)*CARD(2)
      BUF(3) = SSQ* CARD(1) + CS2KXY   +  CSQ*CARD(4)
      BUF(4) = CARD(7)
      GO TO 490
C
C     INFLAG = 3
C
  400 IF (TYPE .EQ. 5) GO TO 410
      BUF(1) = CARD(1)
      BUF(2) = 0.0
      BUF(3) = 0.0
      BUF(4) = BUF(1)
      BUF(5) = 0.0
      BUF(6) = BUF(1)
      BUF(7) = CARD(2)
      GO TO 490
  410 BUF(1) = CARD(1)
      BUF(2) = CARD(2)
      BUF(3) = CARD(3)
      BUF(4) = CARD(4)
      BUF(5) = CARD(5)
      BUF(6) = CARD(6)
      BUF(7) = CARD(7)
      GO TO 490
C
C     INFLAG = 4.  RETURN ONLY CP.
C
  420 IF (TYPE .EQ. 5) GO TO 430
      BUF(1) = CARD(2)
      GO TO 490
  430 BUF(1) = CARD(7)
      GO TO 490
C
C     ERROR CONDITIONS
C
  440 WRITE  (OUTPT,450) SFM,INFLAG
  450 FORMAT (A25,' 2156, ILLEGAL INFLAG =',I14,' RECEIVED BY HMAT.')
      GO TO 520
  460 WRITE  (OUTPT,470) UFM,MATID
  470 FORMAT (A23,' 2157, MATERIAL ID =',I14,
     1       ' DOES NOT APPEAR ON ANY MAT4 OR MAT5 MATERIAL DATA CARD.')
      GO TO 520
  480 CALL MESAGE (-2,MPT,NAME)
      GO TO 520
C
C     RETURN LOGIC
C
  490 CONTINUE
C
C     CALL BUG (4HHMAT,490,BUF,7)
C
      RETURN
C
C     ERROR - HMAT CALLED IN NON-THERMAL PROBLEM.
C
  500 WRITE  (OUTPT,510) SFM
  510 FORMAT (A25,' 3062, HMAT MATERIAL ROUTINE CALLED IN A NON-HEAT-',
     1       'TRANSFER PROBLEM.')
  520 CALL MESAGE (-61,0,0)
      RETURN
      END

      SUBROUTINE ROMBDK (B,PRECIS,ITDONE,FINTG,K,X)
C
C     INTEGRATE F(X) FROM 0.0 TO X = B
C
C         B      = UPPER LIMIT
C         NOSIG  = NUMBER OF CORRECT SIGNIFICANT DIGITS DESIRED
C                  (NOT MORE THAN 7) = 5
C         PRECIS = 0.0  UPON RETURN, PRECIS = ACTUAL NUMBER
C                  OF SIGNIFICANT DIGITS ATTAINED
C         NUM    = MAXIMUM NUMBER OF HALVINGS OF B-A TO BE MADE
C                  (NOT MORE THAN 99) = 15
C     UPON RETURN FROM ROMBER, THE VALUE OF THE INTEGRAL WILL BE FOUND
C     IN FINTG
C
C     IT IS CUSTOMARY TO MEASURE THE PRECISION OF LARGE NUMBERS IN
C     TERMS OF NUMBER OF SIGNIFICANT DIGITS AND THE ACCURACY OF SMALL
C     NUMBERS IN TERMS OF NUMBER OF SIGNIFICANT DECIMALS.  TO CONFORM
C     TO THIS PRACTICE, THE SUBROUTINE TERMINATES WHEN EITHER OF THESE
C     CONDITIONS IS MET.
C
      DOUBLE PRECISION DEN,CONST,B,PRECIS,FINTG,X,FAAAA,FAAAB,
     1                 FAAAC,FAAAD,F,FAAAE,FAAAF,FAAAG,FAAAH,DIFF
      DIMENSION        X(6),FAAAA(20),FAAAB(20)
C
      FAAAC = 0.00001D0
      IAAAA = 1
      FAAAD = B
      X(1)  = 0.0D0
      ASSIGN 100 TO IRET
      GO TO (1000,2000,3000), K
  100 CONTINUE
      FAAAE = F
      X(1)  = B
      ASSIGN 200 TO IRET
      GO TO (1000,2000,3000), K
  200 CONTINUE
      FAAAE = FAAAE+F
      FAAAA(1) = 0.5*FAAAD*FAAAE
 9988 FAAAD = 0.5*FAAAD
      IAAAC = 2**(IAAAA-1)
      FAAAE = 0.0
C
      IAAAD = 0
 9986 IAAAD = IAAAD+1
      FAAAF = IAAAD
      X(1) = (2.0*FAAAF-1.0)*FAAAD
      ASSIGN 300 TO IRET
      GO TO (1000,2000,3000), K
  300 CONTINUE
      FAAAE = FAAAE + F
      IF (IAAAD .LT. IAAAC) GO TO 9986
C
      FAAAB(1) = 0.5*FAAAA(1) + FAAAD*FAAAE
      IAAAA = IAAAA+1
      DO 9985 IAAAD = 2,IAAAA
      FAAAG = 4.0**(IAAAD-1)
      FAAAH = FAAAG-1.0
      IAAAF = IAAAD-1
 9985 FAAAB(IAAAD) = (FAAAG*FAAAB(IAAAF) - FAAAA(IAAAF))/FAAAH
      IAAAC = 2*IAAAC+1
      DIFF  = FAAAB(IAAAA) - FAAAA(IAAAA-1)
      IF (DABS(DIFF)-DABS(FAAAC*FAAAB(IAAAA))) 9979,9981,9981
 9981 DO 9980 IAAAD = 1,IAAAA
 9980 FAAAA(IAAAD)  = FAAAB(IAAAD)
      IF (IAAAA.LT.15) GO TO 9988
 9979 PRECIS = DIFF
      ITDONE = IAAAA - 1
      FINTG  = FAAAB(IAAAA)
      RETURN
C
C     THIS CODE REPLACES D4K
C
 1000 CONTINUE
      IF (X(1) .EQ.0.0D0) GO TO 1010
      DEN = X(3) - X(2)*X(5)*(1.D0-DCOS(X(1))) + X(2)*X(4)*DSIN(X(1))
      F   = X(1)**(X(6)-1.D0)*DSIN(X(1))**2/DEN
      GO TO 1020
 1010 F = 0.0D0
 1020 GO TO IRET, (100,200,300)
C
C     THIS CODE REPLACES D5K
C
 2000 CONTINUE
      IF (X(1) .EQ. 0.0D0) GO TO 2010
      DEN = X(3) - X(2)*X(5)*(1.D0-DCOS(X(1))) + X(2)*X(4)*DSIN(X(1))
      F   = X(1)**(X(6)-1.D0)*2.*DSIN(X(1))*DCOS(X(1))/DEN
      GO TO 2020
 2010 F=0.0D0
 2020 GO TO IRET, (100,200,300)
C
C     THIS CODE REPLACES D6K
C
 3000 CONTINUE
      DEN = X(3) - X(2)*X(5)*(1.D0-DCOS(X(1))) + X(2)*X(4)*DSIN(X(1))
      IF (X(6) .EQ. 1.D0) CONST = 1.D0
      IF (X(6) .NE. 1.D0) CONST = X(1)**(X(6)-1.D0)
      IF (DEN .EQ. 0.0D0) GO TO 3010
      F = CONST*DCOS(X(1))**2/DEN
      GO TO 3020
 3010 F = 0.0D0
 3020 GO TO IRET, (100,200,300)
      END

      SUBROUTINE TRIAAX
C
C     THIS SUBROUTINE COMPUTES THE STIFFNESS AND MASS MATRICES FOR THE
C     ASSYMMETRIC RING WITH A TRIANGULAR CROSS SECTION, TO BE USED BY
C     THE ELEMENT MATRIX GENERATOR.
C
C     SINGLE PRECISION VERSION
C
C     THIS CURRENT VERSION ALLOWS FOR COORDINATE SYSTEM
C     THIS SUBROUTINE USES THE ADDITIONAL ROUTINES DKL, DELTKL
C
C     THE ECPT FOR THE TRIAX ELEMENT IS
C
C     ECPT (01) = ELEMENT ID                              I
C     ECPT (02) = SIL A                                   I
C     ECPT (03) = SIL B                                   I
C     ECPT (04) = SIL C                                   I
C     ECPT (05) = MATERIAL ORIENTATION ANGLE(DEGREES)     R
C     ECPT (07) = MATERIAL ID                             I
C     ECPT (08) TO ECPT(21) = STRESS PHASE ANG.           R
C     ECPT (22) = CORD. SYS. GRID POINT A (NOT USED)      I
C     ECPT (23) = R-CORD OF GRID A                        R
C     ECPT (24) = Z-CORD OF GRID A                        R
C     ECPT (25) = 0.0                                     R
C     ECPT (26) = CORD. SYS. GRID POINT B (NOT USED)      I
C     ECPT (27) = R-CORD OF GRID B                        R
C     ECPT (28) = Z-CORD OF GRID B                        R
C     ECPT (29) = 0.0                                     R
C     ECPT (30) = CORD. SYS. GRID POINT C (NOT USED)      I
C     ECPT (31) = R-CORD OF GRID C                        R
C     ECPT (32) = Z-CORD OF GRID C                        R
C     ECPT (33) = 0.0                                     R
C     ECPT (34) = EL. TEMPERATURE FOR MATERIAL PROP       R
C
C     ANY GROUP OF STATEMENTS PREFACED BY AN IF STATEMENT CONTAINING
C     ...KSYS78 OR LSYS78 ...  INDICATES CODING NECESSARY FOR THIS
C     ELEMENT*S PIEZOELECTRIC CAPABILITY
C
C     KSYS78 = 0   ELASTIC, NON-PIEZOELECTRIC MATERIAL
C     KSYS78 = 1   ELECTRICAL-ELASTIC COUPLED, PIEZOELETRIC MATERIAL
C     KSYS78 = 2   ELASTIC ONLY, PIEZOELECTRIC MATERIAL
C     LSYS78 = .TRUE. IF KSYS78 = 0, OR 2
C
C
      LOGICAL         NOGO,HEAT,PZMAT,LSYS78
      INTEGER         DICT(11),ELID,ESTID,ISORT(3)
      REAL            GABABQ(9,9),R(3),Z(3),EE(63),TEO(45),DELINT(12),
     1                ECPT(10),DELM(12),BMASS(9,9),AKM(81),AKJM(81),
     2                AMT(9),GABABP(3,3)
      DOUBLE PRECISION CONSTS
      DIMENSION       IECPT(34),AKI(81),AKT(16),ACURL(117),D(81),AK(81),
     1                AKJ(144),ICS(3),D1(27),D2(9),ACURP1(27),ACURP2(9),
     2                AKUPH(27),AKPH2(9),AKIP(9)
      COMMON /SYSTEM/ KSYSTM(77),KSYS78
      COMMON /EMGPRM/ IXTRA,DUM(14),ISMB(3),IPREC,NOGO,HEAT,ICMBAR
      COMMON /EMGDIC/ DXX,LDICT,NGRIDS,ELID,ESTID
      COMMON /EMGEST/ IDEL,IGP(3),DGAMA,DM1,MATID,SPA(14),ICS1,R1,ZZ1,
     1                ZER,ICS2,R2,ZZ2,ZER2,ICS3,R3,ZZ3,ZER3,TEMPE
      COMMON /MATIN / MATIDC,MATFLG,ELTEMP,STRESS,SINTH,COSTH
      COMMON /MATOUT/ E(3),ANU(3),RHO,G(3),ALF(3),TZERO,GSUBE,MOSKP(9),
     1                SETMAT
      COMMON /CONDAD/ CONSTS(5)
      COMMON /MATPZ / PZOUT(51)
C
C     COMMON /MATPZ / CE11,CE12,CE13,CE14,CE15,CE16,CE22,CE23,CE24,CE25,
C                     CE26,CE33,CE34,CE35,CE36,CE44,CE45,CE46,CE55,CE56,
C                     CE66,E11,E12,E13,E14,E15,E16,E21,E22,E23,E24,E25,
C                     E26,E31,E32,E33,E34,E35,E36,EPS11,EPS12,EPS13,
C                     EPS22,EPS23,EPS33,RHO,A1,A2,A12,TREF,GE
C
      EQUIVALENCE     (IECPT(1),ECPT(1),IDEL), (DICT(5),DICT5),
     1                (Z(1),Z1), (Z(2),Z2), (Z(3),Z3),
     2                (AKI(1),GABABQ(1,1)), (BMASS(1,1),AKM(1)),
     3                (CONSTS(1),PI), (CONSTS(4),DEGRAD),
     4                (CONSTS(2),TWOPI), (AKIP(1),GABABP(1,1)),
     5                (ACURP1(1),ACURL(82)), (ACURP2(1),ACURL(109))
      DATA            IDEL2,JAX / 0, 4HTRIA/
C
      LSYS78 = .FALSE.
      IF (KSYS78.EQ.0 .OR. KSYS78.EQ.2) LSYS78 = .TRUE.
      IDEL1 = IDEL/1000
C
C     INITALIZE
C
      DO 50 I = 1,3
      R(I) = ECPT(4*I+19)
      Z(I) = ECPT(4*I+20)
   50 ICS(I) = IECPT(4*I+18)
C
      DICT(1) = ESTID
      DICT(2) = 1
      DICT(3) = 12
      DICT(4) = 15
      IPR     = IPREC
C
      IF (R1.LE.0. .OR. R2.LE.0. .OR. R3.LE.0.) GO TO 7770
C
C     COMPUTE THE ELEMENT COORDINATES
C
      ZMIN = AMIN1(Z1,Z2,Z3)
      Z1 = Z1 - ZMIN
      Z2 = Z2 - ZMIN
      Z3 = Z3 - ZMIN
C
C     FORM TRANSFORMATION MATRIX GABABQ (9X9) FROM FIELD COORDINATES TO
C     GRID POINT DEGREES OF FREEDOM
C
      DO 100 I = 1,9
      DO 100 J = 1,9
  100 GABABQ(I,J) = 0.
C
      AA = 1./(R2*Z3 + R1*Z2 + Z1*R3 - Z2*R3 - R1*Z3 - R2*Z1)
      C1 =  AA*(R2*Z3 - Z2*R3)
      C2 = -AA*(Z3 - Z2)
      C3 =  AA*(R3 - R2)
      GABABQ(1,1) = C1
      GABABQ(1,2) = C2
      GABABQ(1,3) = C3
      GABABQ(2,4) = C1
      GABABQ(2,5) = C2
      GABABQ(2,6) = C3
      GABABQ(3,7) = C1
      GABABQ(3,8) = C2
      GABABQ(3,9) = C3
      IF (LSYS78) GO TO 102
      GABABP(1,1) = C1
      GABABP(1,2) = C2
      GABABP(1,3) = C3
  102 CONTINUE
      C1 = -AA*(R1*Z3 - Z1*R3)
      C2 =  AA*(Z3 - Z1)
      C3 = -AA*(R3 - R1)
      GABABQ(4,1) = C1
      GABABQ(4,2) = C2
      GABABQ(4,3) = C3
      GABABQ(5,4) = C1
      GABABQ(5,5) = C2
      GABABQ(5,6) = C3
      GABABQ(6,7) = C1
      GABABQ(6,8) = C2
      GABABQ(6,9) = C3
      IF (LSYS78) GO TO 104
      GABABP(2,1) = C1
      GABABP(2,2) = C2
      GABABP(2,3) = C3
  104 CONTINUE
      C1 =  AA*(R1*Z2 - Z1*R2)
      C2 = -AA*(Z2 - Z1)
      C3 =  AA*(R2 - R1)
      GABABQ(7,1) = C1
      GABABQ(7,2) = C2
      GABABQ(7,3) = C3
      GABABQ(8,4) = C1
      GABABQ(8,5) = C2
      GABABQ(8,6) = C3
      GABABQ(9,7) = C1
      GABABQ(9,8) = C2
      GABABQ(9,9) = C3
      IF (LSYS78) GO TO 110
      GABABP(3,1) = C1
      GABABP(3,2) = C2
      GABABP(3,3) = C3
  110 CONTINUE
C
C     COMPUTE THE INTEGRAL VALUES IN ARRAY DELINT THE ORDER IS INDICATED
C     THE FOLLOWING TABLE
C
C     DELINT(01) = (-1,0)
C     DELINT(02) = (-1,1)
C     DELINT(03) = (-1,2)
C     DELINT(04) = (0, 0)
C     DELINT(05) = (0, 1)
C     DELINT(06) = (1, 0)
C
C     OR FOR THE MASS MATRIX
C
C     DELINT(1)  =  (1,0)
C     DELINT(2)  =  (1,1)
C     DELINT(3)  =  (1,2)
C     DELINT(4)  =  (2,0)
C     DELINT(5)  =  (2,1)
C     DELINT(7)  =  (3,0)
C
C
      IF (ISMB(1) .EQ. 0) GO TO 180
      RA = (R1 + R2 + R3)/3.0
      ZA = (Z1 + Z2 + Z3)/3.0
      RH = AMIN1(R1,R2,R3)/10.0
      DR = AMAX1(ABS(R1-R2),ABS(R2-R3),ABS(R3-R1))
      AREA = (R1*(Z2-Z3) + R2*(Z3-Z1) + R3*(Z1-Z2))/2.0
C
      I1 = 0
      DO 160 I = 1,2
      IP = I - 2
      DO 140 J = 1,3
      IQ =  J  - 1
      I1 =  I1 + 1
      IF (I1 .NE. 6) GO TO 120
      IP = 1
      IQ = 0
  120 IF (DR .GT. RH) GO TO 130
      DELINT(I1) = ((RA**IP)*(ZA**IQ))*AREA
      GO TO 135
  130 DELINT(I1) = DKLS(3,IP,IQ,R,Z)
  135 DELINT(I1) = ABS (DELINT(I1))
  140 CONTINUE
  160 CONTINUE
C
C     MASS MATRIX
C
      IF (ISMB(2) .EQ. 0) GO TO 200
  180 CALL DELKLS (AKJ,R,Z,0)
      DELM (1) = AKJ(2)
      DELM (2) = AKJ(7)
      DELM (3) = AKJ(8)
      DELM (4) = AKJ(10)
      DELM (5) = AKJ(9)
      DELM (7) = AKJ(12)
C
C     LOCATE THE MATERIAL PROPERTIES IN THE MAT1 OR MAT3
C
  200 DGAMR  = DGAMA*DEGRAD
      COSG   = COS(DGAMR)
      SING   = SIN(DGAMR)
      SINTH  = SING
      COSTH  = COSG
      MATIDC = MATID
      MATFLG = 7
      IF (KSYS78 .GT. 0) MATFLG = 9
      ELTEMP = TEMPE
      CALL MAT (IDEL)
      PZMAT = .FALSE.
      IF (SETMAT.EQ.4. .OR. SETMAT.EQ.5.) PZMAT = .TRUE.
      IF (PZMAT) GO TO 210
      KSAVE  = KSYS78
      KSYS78 = 0
      LSYS78 = .TRUE.
      GO TO 220
  210 RHO    = PZOUT(46)
      ALF(1) = PZOUT(47)
      ALF(2) = PZOUT(48)
      ALF(3) = PZOUT(49)
      TZERO  = PZOUT(50)
      GSUBE  = PZOUT(51)
  220 CONTINUE
      IF (SETMAT .EQ. 2.) GO TO 7780
      DICT5 = G SUB E
      IF (KSYS78 .GT. 0) GO TO 249
C
C     SET MATERIAL PROPERTIES IN DOUBLE PRECISION VARIABLES
C
      ER  = E(1)
      ET  = E(2)
      EZ  = E(3)
      VRO = ANU(1)
      VOZ = ANU(2)
      VZR = ANU(3)
      GOR = G(1)
      GZO = G(2)
      GRZ = G(3)
      VOR = VRO*ET/ER
      VZO = VOZ*EZ/ET
      VRZ = VZR*ER/EZ
      DEL = 1./(1. - VRO*VOR  - VOZ*VZO  - VZR*VRZ
     1    - VRO*VOZ*VZR - VRZ*VOR*VZO)
C
C     COMPUTE ELASTIC CONSTANTS MATRIX FROM MATERIAL TO ELEMENT AXIS
C
  249 CONTINUE
      DO 250 I = 1,45
  250 TEO(I) = 0.
C
      IF (KSYS78 .GT. 0) GO TO 251
      TEO(1) = ER*(1.  - VOZ*VZO)*DEL
      TEO(2) = ER*(VZR + VZO*VOR)*DEL
      TEO(3) = EZ*(1.  - VRO*VOR)*DEL
      TEO(4) = ER*(VOR + VZR*VOZ)*DEL
      TEO(5) = ET*(VZO + VRO*VZR)*DEL
      TEO(6) = ET*(1.  - VRZ*VZR)*DEL
      TEO(10)= GRZ
      TEO(15)= GOR
      TEO(21)= GZO
      GO TO 252
  251 CONTINUE
C
C     PIEZOELECTRIC MATERIAL PROPERTIES STORED IN TEO(22-39)
C     DIELECTRIC MATERIAL PROPERTIES STORED IN TEO(40-45)
C     TEO(22-39) CONTAINS E-TRANSPOSE
C
      TEO( 1) = PZOUT( 1)
      TEO( 2) = PZOUT( 2)
      TEO( 3) = PZOUT( 7)
      TEO( 4) = PZOUT( 3)
      TEO( 5) = PZOUT( 8)
      TEO( 6) = PZOUT(12)
      TEO( 7) = PZOUT( 4)
      TEO( 8) = PZOUT( 9)
      TEO( 9) = PZOUT(13)
      TEO(10) = PZOUT(16)
      TEO(11) = PZOUT( 5)
      TEO(12) = PZOUT(10)
      TEO(13) = PZOUT(14)
      TEO(14) = PZOUT(17)
      TEO(15) = PZOUT(19)
      TEO(16) = PZOUT( 6)
      TEO(17) = PZOUT(11)
      TEO(18) = PZOUT(15)
      TEO(19) = PZOUT(18)
      TEO(20) = PZOUT(20)
      TEO(21) = PZOUT(21)
      IF (KSYS78 .EQ. 2) GO TO 252
      TEO(22) = PZOUT(22)
      TEO(23) = PZOUT(28)
      TEO(24) = PZOUT(34)
      TEO(25) = PZOUT(23)
      TEO(26) = PZOUT(29)
      TEO(27) = PZOUT(35)
      TEO(28) = PZOUT(24)
      TEO(29) = PZOUT(30)
      TEO(30) = PZOUT(36)
      TEO(31) = PZOUT(25)
      TEO(32) = PZOUT(31)
      TEO(33) = PZOUT(37)
      TEO(34) = PZOUT(26)
      TEO(35) = PZOUT(32)
      TEO(36) = PZOUT(38)
      TEO(37) = PZOUT(27)
      TEO(38) = PZOUT(33)
      TEO(39) = PZOUT(39)
      TEO(40) =-PZOUT(40)
      TEO(41) =-PZOUT(41)
      TEO(42) =-PZOUT(42)
      TEO(43) =-PZOUT(43)
      TEO(44) =-PZOUT(44)
      TEO(45) =-PZOUT(45)
  252 CONTINUE
      C2 = COSG*COSG
      C4 = C2  *C2
      S2 = SING*SING
      S4 = S2  *S2
      C2S2 = C2*S2
      C3 = COSG*C2
      S3 = SING*S2
      CS2= COSG*S2
      SC2= SING*C2
      CS = COSG*SING
C
      EE( 1) = TEO(1)*C4 + TEO(3)*S4 + 2.*C2S2 *(TEO(2) + 2.*TEO(10))
      EE( 2) = TEO(2)*(C4+S4) + C2S2*(TEO(1)+TEO(3) - 4.*TEO(10))
      EE( 3) = TEO(4)*C2 + TEO(5)*S2
      EE( 4) = COSG*SING*S2*(TEO(2) - TEO(3) + 2.*TEO(10))
     4       + SING*COSG*C2*(TEO(1) - TEO(2) - 2.*TEO(10))
      EE( 7) = EE(2)
      EE( 8) = TEO(1)*S4 + 2.*C2S2*(TEO(2) + 2.*TEO(10))+ TEO(3)*C4
      EE( 9) = TEO(4)*S2 + TEO(5)*C2
      EE(10) = SING*COSG*C2*(TEO(2) - TEO(3) + 2.*TEO(10))
     O       + COSG*SING*S2*(TEO(1) - TEO(2) - 2.*TEO(10))
      EE(13) = EE(3)
      EE(14) = EE(9)
      EE(15) = TEO(6)
      EE(16) = SING*COSG*(TEO(4)-TEO(5))
      EE(19) = EE(4)
      EE(20) = EE(10)
      EE(21) = EE(16)
      EE(22) = C2S2*(TEO(1) - 2.*TEO(2) + TEO(3)) + TEO(10)*(C2-S2)**2
      EE(29) = TEO(15)*C2 + TEO(21)*S2
      EE(30) = SING*COSG*(TEO(15)-TEO(21))
      EE(35) = EE(30)
      EE(36) = TEO(15)*S2 + TEO(21)*C2
C
      IF (LSYS78) GO TO 254
C
C     PIEZOELECTRIC MATERIAL PROPERTIES IN ELEMENT COORDINATES
C
      EE(37) = C3*TEO(22) - S3*TEO(26) + CS2*(TEO(25)+2.0*TEO(32)) -
     7         SC2*(TEO(23) + 2.0*TEO(31))
      EE(38) = C3*TEO(23) + S3*TEO(25) + CS2*(TEO(26)-2.0*TEO(31)) +
     8         SC2*(TEO(22) - 2.0*TEO(32))
      EE(39) = S2*TEO(27) + C2*TEO(24) - 2.0*CS*TEO(33)
      EE(40) = C3*TEO(25) - S3*TEO(23) + CS2*(TEO(22)-2.0*TEO(32)) -
     O         SC2*(TEO(26) - 2.0*TEO(31))
      EE(41) = C3*TEO(26) + S3*TEO(22) + CS2*(TEO(23)+2.0*TEO(31)) +
     1         SC2*(TEO(25) + 2.0*TEO(32))
      EE(42) = S2*TEO(24) + C2*TEO(27) + 2.0*CS*TEO(33)
      EE(43) = COSG*TEO(28) - SING*TEO(29)
      EE(44) = COSG*TEO(29) + SING*TEO(28)
      EE(45) = TEO(30)
      EE(46) = C3*TEO(31) + S3*TEO(32) - CS2*(TEO(23)-TEO(26)+TEO(31)) +
     6         SC2*(-TEO(32) - TEO(25) + TEO(22))
      EE(47) = C3*TEO(32) - S3*TEO(31) - CS2*(TEO(25)-TEO(22)+TEO(32)) +
     7         SC2*(TEO(23) + TEO(31) - TEO(26))
      EE(48) = (C2-S2)*TEO(33) + CS*(TEO(24) - TEO(27))
      EE(49) = C2*TEO(34) + S2*TEO(38) - CS*(TEO(35) + TEO(37))
      EE(50) = C2*TEO(35) - S2*TEO(37) + CS*(TEO(34) - TEO(38))
      EE(51) = COSG*TEO(36) - SING*TEO(39)
      EE(52) = C2*TEO(37) - S2*TEO(35) - CS*(TEO(38) - TEO(34))
      EE(53) = C2*TEO(38) + S2*TEO(34) + CS*(TEO(35) + TEO(37))
      EE(54) = COSG*TEO(39) + SING*TEO(36)
C
C     DIELECTRIC MATERIAL PROPERTIES IN ELEMENT COORDINTES
C
      EE(55) = S2*TEO(43) - 2.0*CS*TEO(41) + C2*TEO(40)
      EE(56) = (C2-S2)*TEO(41) - CS*(TEO(43)-TEO(40))
      EE(57) =-SING*TEO(44) + COSG*TEO(42)
      EE(59) = C2*TEO(43) + 2.0*CS*TEO(41) + S2*TEO(40)
      EE(60) = COSG*TEO(44) + SING*TEO(42)
      EE(63) = TEO(45)
254   CONTINUE
C
C     COMPUTE HARMONIC COEFFICIENT
C
      MJHO = MOD(IECPT(1),1000) - 1
      AJHO = MJHO
      AJJHO= AJHO*AJHO
      RHOD = RHO *PI
      IF (AJHO   .EQ. 0.) RHOD = 2.*RHOD
      IF (ISMB(1) .EQ. 0) GO TO 300
C
C     FORM THE ELEMENT STIFFNESS MATRIX IN FIELD SYSTEM
C
      ACURL( 1) = (EE(15) + AJJHO*EE(29))*DELINT(1)
      ACURL( 2) = (EE(03) + EE(15) + AJJHO*EE(29))*DELINT(4)
      ACURL( 3) = (EE(15) + AJJHO*EE(29))*DELINT(2) + EE(16)*DELINT(4)
      ACURL( 4) = (EE(15) + EE(29))*AJHO*DELINT(1)
      ACURL(05) = EE(15)*AJHO*DELINT(4)
      ACURL(06) = (EE(15) + EE(29))*AJHO*DELINT(2)
     6          - EE(30)*AJHO*DELINT(4)
      ACURL(07) = AJJHO*DELINT(1)*EE(35)
      ACURL(08) = (EE(16) + AJJHO*EE(35))*DELINT(4)
      ACURL(09) = EE(9)*DELINT(4) + AJJHO*DELINT(2)*EE(35)
      ACURL(11) = (EE(1) + 2.*EE(3) + EE(15) + AJJHO*EE(29))*DELINT(6)
      ACURL(12) = (EE(3) + EE(15) + AJJHO*EE(29))*DELINT(5)
     2          + (EE(4) + EE (16))*DELINT(6)
      ACURL(13) = (EE(3) + EE(15) + EE(29))*AJHO*DELINT(4)
      ACURL(14) = (EE(3) + EE(15))*DELINT(6)*AJHO
      ACURL(15) = (EE(3) + EE(15) + EE(29))*AJHO*DELINT(5)
     5          - AJHO*EE(30)*DELINT(6)
      ACURL(16) = AJJHO*DELINT(4)*EE(35)
      ACURL(17) = (EE(4) + EE(16) + AJJHO*EE(35))*DELINT(6)
      ACURL(18) = (EE(2) + EE(9))*DELINT(6) + AJJHO*DELINT(5)*EE(35)
      ACURL(21) = (EE(15) + AJJHO*EE(29))*DELINT(3) + EE(22)
     1          * DELINT(6) +  2.*EE(16)*DELINT(5)
      ACURL(22) = (EE(15) + EE(29))*AJHO*DELINT (2) + AJHO
     2          * DELINT(4)*EE(16)
      ACURL(23) = EE(15)*AJHO*DELINT(5) + AJHO*DELINT(6)*EE(16)
      ACURL(24) = (EE(15) + EE(29))*AJHO*DELINT(3) + (EE(16) - EE(30))
     4          * AJHO*DELINT(5)
      ACURL(25) = AJJHO*DELINT(2)*EE(35)
      ACURL(26) = EE(22)*DELINT(6) + (EE(21) + AJJHO*EE(35))*DELINT(5)
      ACURL(27) = EE(9)*DELINT(5) + EE(10)*DELINT(6) + AJJHO
     1          * DELINT(3)*EE(35)
      ACURL(31) = (EE(29) + AJJHO*EE(15))*DELINT(1)
      ACURL(32) = EE(15)*AJJHO*DELINT(4)
      ACURL(33) = (EE(29) + AJJHO*EE(15))*DELINT(2) - EE(30)*DELINT(4)
      ACURL(34) = AJHO*DELINT(1)*EE(35)
      ACURL(35) = AJHO*(EE(16) + EE(35))*DELINT(4)
      ACURL(36) = EE(9)*AJHO*DELINT(4) + AJHO*DELINT(2)*EE(35)
      ACURL(41) = AJJHO*DELINT(6)*EE(15)
      ACURL(42) = EE(15)*AJJHO*DELINT(5)
      ACURL(43) = 0.
      ACURL(44) = AJHO*DELINT(6)*EE(16)
      ACURL(45) = EE(9)*AJHO*DELINT(6)
      ACURL(51) = (EE(29) + AJJHO*EE(15))*DELINT(3) + EE(36)
     1          * DELINT(6) - 2.*EE(35)*DELINT(5)
      ACURL(52) = AJHO*(DELINT(2)*EE(30) - DELINT(4)*EE(36))
      ACURL(53) = -EE(36)*AJHO*DELINT(6) + AJHO*(EE(16) + EE(35))
     3          * DELINT(5)
      ACURL(54) = (EE(9) - EE(36))*AJHO*DELINT(5) + AJHO
     1          * DELINT(3)*EE(35)
      ACURL(61) = EE(36)*AJJHO*DELINT(1)
      ACURL(62) = EE(36)*AJJHO*DELINT(4)
      ACURL(63) = (EE(36))*AJJHO*DELINT(2)
      ACURL(71) = (EE(22) + AJJHO*EE(36))*DELINT(6)
      ACURL(72) = EE(36)*AJJHO*DELINT(5) + EE(20)*DELINT(6)
      ACURL(81) = EE(36)*AJJHO*DELINT(3) + EE(8)*DELINT(6)
      IF (LSYS78) GO TO 256
      ACURL(82) =-(EE(45) - AJHO*EE(51))*AJHO*DELINT(1)
      ACURL(83) = (EE(43) - AJHO*EE(45) - AJHO*EE(49) + AJJHO*EE(51))
     3          * DELINT(4)
      ACURL(84) = (EE(44) - AJHO*EE(50))*DELINT(4) - (EE(45)
     4          - AJHO*EE(51))*AJHO*DELINT(2)
      ACURL(85) =-(EE(39) + EE(45) - AJHO*EE(51))*AJHO*DELINT(4)
      ACURL(86) = (EE(37) + EE(43) - (EE(39) + EE(45) + EE(49)
     6          - AJHO*EE(51))*AJHO)*DELINT(6)
      ACURL(87) = (EE(38) + EE(44) - AJHO*EE(50))*DELINT(6) - (EE(39)
     7          + EE(45) - AJHO*EE(51))*AJHO*DELINT(5)
      ACURL(88) =-(EE(45) - AJHO*EE(51))*AJHO*DELINT(2) - EE(48)*AJHO
     8          * DELINT(4)
      ACURL(89) = (EE(43) - AJHO*EE(45) - AJHO*EE(49) + AJJHO*EE(51))
     9          * DELINT(5) + (EE(46) - EE(48)*AJHO)*DELINT(6)
      ACURL(90) = (EE(44) - AJHO*EE(48) - AJHO*EE(50))*DELINT(5)
     O          + EE(47)*DELINT(6) - (EE(45)-AJHO*EE(51))*AJHO*DELINT(3)
      ACURL(91) =-(EE(45)*AJHO - EE(51))*AJHO*DELINT(1)
      ACURL(92) = (AJHO*EE(43) - AJJHO*EE(45) - EE(49) + AJHO*EE(51))
     2          * DELINT(4)
      ACURL(93) = (EE(44)*AJHO - EE(50))*DELINT(4) - (EE(45)*AJHO
     3          - EE(51))*AJHO*DELINT(2)
      ACURL(94) =-EE(45)*AJJHO*DELINT(4)
      ACURL(95) = (EE(43) - AJHO*EE(45))*AJHO*DELINT(6)
      ACURL(96) = EE(44)*AJHO*DELINT(6) - EE(45)*AJJHO*DELINT(5)
      ACURL(97) =-(EE(45)*AJHO - EE(51))*AJHO*DELINT(2) - EE(54)*AJHO
     7          * DELINT(4)
      ACURL(98) = (EE(43)*AJHO - AJJHO*EE(45) - EE(49) + EE(51)*AJHO)
     8          * DELINT(5) + (EE(52) - AJHO*EE(54))*DELINT(6)
      ACURL(99) = (EE(44)*AJHO - EE(50) - EE(54)*AJHO)*DELINT(5)
     9          + EE(53)*DELINT(6) - (EE(45)*AJHO-EE(51))*AJHO*DELINT(3)
      ACURL(100)= EE(54)*AJJHO*DELINT(1)
      ACURL(101)=-(EE(52) - EE(54)*AJHO)*AJHO*DELINT(4)
      ACURL(102)=-(EE(53)*DELINT(4) - EE(54)*AJHO*DELINT(2))*AJHO
      ACURL(103)=-(EE(48) - EE(54)*AJHO)*AJHO*DELINT(4)
      ACURL(104)= (EE(46) - EE(48)*AJHO - EE(52)*AJHO+EE(54)*AJJHO)
     4          *  DELINT(6)
      ACURL(105)= (EE(47) - EE(53)*AJHO)*DELINT(6) - (EE(48) - EE(54)
     5          * AJHO)*AJHO*DELINT(5)
      ACURL(106)= EE(54)*AJJHO*DELINT(2) - EE(42)*AJHO*DELINT(4)
      ACURL(107)= (EE(40) - EE(42)*AJHO)*DELINT(6) - (EE(52) - EE(54)
     7          * AJHO)*AJHO*DELINT(5)
      ACURL(108)= EE(41)*DELINT(6) + (-EE(42) - EE(53))*AJHO*DELINT(5)
     8          + EE(54)*AJJHO*DELINT(3)
      ACURL(109)= EE(63)*AJJHO*DELINT(1)
      ACURL(110)= (-EE(57) + EE(63)*AJHO)*AJHO*DELINT(4)
      ACURL(111)=-EE(60)*AJHO*DELINT(4) + EE(63)*AJJHO*DELINT(2)
      ACURL(112)= ACURL(110)
      ACURL(113)= (EE(55) - 2.0*EE(57)*AJHO + EE(63)*AJJHO)*DELINT(6)
      ACURL(114)= (EE(56) - EE(60)*AJHO)*DELINT(6) + (-EE(57) + EE(63)
     4          * AJHO)*AJHO*DELINT(5)
      ACURL(115)= ACURL(111)
      ACURL(116)= ACURL(114)
      ACURL(117)= EE(59)*DELINT(6) - 2.0*EE(60)*AJHO*DELINT(5) + EE(63)
     7          * AJJHO*DELINT(3)
  256 CONTINUE
C
C     EXPAND ACURL INTO (9X9)
C
      DO 270 IB = 2,9
      IC = 10*IB - 19
      I  = IC
      DO 260 J = IB,9
      IC = IC + 9
      I  = I  + 1
  260 ACURL(IC) = ACURL(I)
  270 CONTINUE
      DGAMA = PI
      IF (AJHO .EQ. 0.) DGAMA = TWOPI
      DO 280 I = 1,81
  280 ACURL(I) = ACURL(I)*DGAMA
      IF (LSYS78) GO TO 300
C
      DO 290 I = 82,117
  290 ACURL(I) = ACURL(I)*DGAMA
C
  300 IF (ISMB(2).EQ. 0) GO TO 400
      IF (ICMBAR .LT. 0) GO TO 350
C
C     CONSISTENT MASS IN FIELD COORDINATES
C
      DO 320 I = 1,9
      DO 320 J = 1,9
  320 BMASS(I,J) = 0.
      BMASS(1,1) = RHOD*DELM(1)
      BMASS(1,2) = RHOD*DELM(4)
      BMASS(1,3) = RHOD*DELM(2)
      BMASS(2,1) = RHOD*DELM(4)
      BMASS(2,2) = RHOD*DELM(7)
      BMASS(2,3) = RHOD*DELM(5)
      BMASS(3,1) = RHOD*DELM(2)
      BMASS(3,2) = RHOD*DELM(5)
      BMASS(3,3) = RHOD*DELM(3)
      BMASS(4,4) = RHOD*DELM(1)
      BMASS(4,5) = RHOD*DELM(4)
      BMASS(4,6) = RHOD*DELM(2)
      BMASS(5,4) = RHOD*DELM(4)
      BMASS(5,5) = RHOD*DELM(7)
      BMASS(5,6) = RHOD*DELM(5)
      BMASS(6,4) = RHOD*DELM(2)
      BMASS(6,5) = RHOD*DELM(5)
      BMASS(6,6) = RHOD*DELM(3)
      BMASS(7,7) = RHOD*DELM(1)
      BMASS(7,8) = RHOD*DELM(4)
      BMASS(7,9) = RHOD*DELM(2)
      BMASS(8,7) = RHOD*DELM(4)
      BMASS(8,8) = RHOD*DELM(7)
      BMASS(8,9) = RHOD*DELM(5)
      BMASS(9,7) = RHOD*DELM(2)
      BMASS(9,8) = RHOD*DELM(5)
      BMASS(9,9) = RHOD*DELM(3)
      GO TO 400
  350 AREA  = (R1*(Z2-Z3) + R2*(Z3-Z1) + R3*(Z1-Z2))/2.
      CONVM =  RHOD*(R1 + R2 + R3)/3.*AREA
C
C     TRANSFORM THE ELEMENT STIFFNESS MATRIX FROM FIELD SYSTEM
C     TO GRID POINT DEGREES OF FREEDOM
C
  400 IF (ISMB(1) .EQ. 0) GO TO 410
      CALL GMMATS (AKI,9,9,1,ACURL,9,9,0,D)
      CALL GMMATS (D,  9,9,0,AKI,  9,9,0,AK)
      IF (LSYS78) GO TO 405
      CALL GMMATS (AKI,9,9,1,ACURP1,9,3,0,D1)
      CALL GMMATS (D1, 9,3,0,AKIP,  3,3,0,AKUPH)
      CALL GMMATS (AKIP,3,3,1,ACURP2,3,3,0,D2)
      CALL GMMATS (D2,  3,3,0,AKIP,  3,3,0,AKPH2)
  405 CONTINUE
C
      IF (ISMB(2).EQ.0 .OR. ICMBAR.LT.0) GO TO 450
  410 CALL GMMATS (AKI,9,9,1,BMASS,9,9,0,D)
      CALL GMMATS (D,  9,9,0,AKI,  9,9,0,AKM)
C
  450 DO 460 I = 1,81
      AKJ(I)  = 0.
  460 AKJM(I) = 0.
      DO 462 I = 82,117
  462 AKJ(I) = 0.0
C
      GO TO 480
C
C     COORDINATE SYSTEMS POSSIBLE WITH RINGAX THRU CODE BELOW
C **  IF FOLLOWING CODE IS IMPLEMENTED MUST BE MODIFIED FOR PIEZOELECTRI
C
C     DO 470 I = 1,3
C     IF (ICS(I) .EQ. 0) GO TO 470
C     K = 9*(I-1) + 1
C     CALL TRANSS (ICS(I),D(K))
C 470 CONTINUE
C
C     CREATE AN ARRAY OF SORTED GRID POINTS
C
  480 DO 482 I = 1,3
      ISORT(I) = IGP(I)
  482 CONTINUE
      I = -3
  484 J = 0
      DO 486 K = 1,3
      IF (ISORT(K) .LT. J) GO TO 486
      J = ISORT(K)
      L = K
  486 CONTINUE
      ISORT(L) = I
      I = I + 1
      IF (I .LT. 0) GO TO 484
      DO 490 I = 1,3
      ISORT(I) = -ISORT(I)
  490 CONTINUE
C
C     TRANSFORM 3 X 3 TO 6 X 6 FOR COORD SYSTEM TRANSFORMATIONS
C
      DO 600 ISIL = 1,3
      IPP = ISORT(ISIL)
C
      IR1 = 3*(ISIL-1) + 1
      DO 590 II = 1,3
      I   = ISORT(II)
      IC1 = 3*(II-1) + 1
      IRC = (IR1 -1)*9 + IC1
      DO 500 J = 1,3
      J1   = (J-1)*4 + 1
      IRCC = IRC + (J-1)*9
      IF (ISMB(1) .EQ. 0) GO TO 495
      AKT(J1  ) = AK(IRCC  )
      AKT(J1+1) = AK(IRCC+1)
      AKT(J1+2) = AK(IRCC+2)
      IF (LSYS78) GO TO 492
      M = IRCC/3 + 1
      N = (M-1)/9 + 1 + (II-1)*9 + (J-1)*3
      AKT(J1+3) = AKUPH(M)
      AKT(J1+15-J*3) = AKUPH(N)
      AKT(16) = AKPH2(IR1+II-1)
  492 CONTINUE
C
  495 IF (ISMB(2).EQ.0 .OR. ICMBAR.LT.1) GO TO 500
      J1 = (J-1)*3 + 1
      AMT(J1  ) =AKM(IRCC  )
      AMT(J1+1) =AKM(IRCC+1)
      AMT(J1+2) =AKM(IRCC+2)
  500 CONTINUE
C
      GO TO 540
C
C    ABOVE GO TO MAKES CST CODE BELOW INTO DEAD CODE
C    COORDINATE SYSTEM TRANSFORMATION CODE
C ** IF FOLLOWING CODE IS IMPLEMENTED MUST BE MODIFIED FOR PIEZOELECTRIC
C
C     IF (ICS(IPP) .EQ. 0) GO TO 520
C     IAA = 9*(IPP-1) + 1
C     CALL GMMATS (D(IAA),3,3,1,AKT(1),3,3,0,D(28))
C     CALL GMMATS (D(IAA),3,3,1,AMT(1),3,3,0,D(37))
C     DO 510 J = 1,9
C     AKT(J) = D(J+27)
C 510 AKM(J) = D(J+36)
C
C 520 IF (ICS(I) .EQ. 0) GO TO 540
C     IAI = 9*(I-1) + 1
C     CALL GMMATS (AKT(1),3,3,0,D(IAI),3,3,0,D(28))
C     CALL GMMATS (AMT(1),3,3,0,D(IAI),3,3,0,D(37))
C     DO 530 J = 1,9
C     AKT(J) = D(J+27)
C 530 AMT(J) = D(J+36)
C
C     NOW INSERT  AKT AND AMT INTO THE OVERALL STIFFNESS MATRICES
C     ACCORDING TO INCREASING SIL VALUE
C
  540 DO 550 IJ = 1,3
      DO 550 JJ = 1,3
      KI = (IJ-1)*3 + JJ
      IOUT = (IPP-1)*27 + (I-1)*3 + (IJ-1)*9 + JJ
  550 AKJM(IOUT)= AMT(KI)
      DO 560 IJ = 1,4
      DO 560 JJ = 1,4
      KI = (IJ-1)*4 + JJ
      IOUT = (IPP-1)*48 + (I-1)*4 + (IJ-1)*12 + JJ
  560 AKJ(IOUT) = AKT(KI)
  590 CONTINUE
  600 CONTINUE
C
C     NOW OUTPUT THE MATRIX VIA EMG OUT
C
      DICT(2) = 1
      IF (ISMB(1) .EQ. 0) GO TO 650
      CALL EMGOUT (AKJ,AKJ,144,1,DICT,1,IPR)
  650 IF (ISMB(2).EQ.0 .AND. .NOT.PZMAT) KSYS78 = KSAVE
      IF (ISMB(2) .EQ. 0) RETURN
      DICT(3) = 9
      DICT(4) = 7
      IF (ICMBAR .LT. 0) GO TO 670
      CALL EMGOUT (AKJM,AKJM,81,1,DICT,2,IPR)
      GO TO 700
C
C     GENERATE LUMPED MASS MATRIX HERE
C
  670 DO 680 I = 1,9
  680 AKJM(I) = CONVM/3.0
      DICT(2) = 2
      CALL EMGOUT (AKJM,AKJM,9,1,DICT,2,IPR)
  700 IF (.NOT.PZMAT) KSYS78 = KSAVE
      RETURN
C
C     ERROR EXITS
C
 7770 I = 37
 7777 IF (IDEL1 .EQ. IDEL) GO TO 7778
      IDEL2  = IDEL1
      ICS(1) = IDEL1
      ICS(2) = JAX
      CALL MESAGE (30,I,ICS)
 7778 NOGO = .TRUE.
      GO TO 700
 7780 I = 126
      GO TO 7777
      END

      SUBROUTINE Q2TRMD(RA,RB,RC,ALPHA,ISINTH,ICOSTH,GSUBE,IT,
     1                  IERROR,IOPT,KMAT,PMAT,SMAT,ZMAT)
C*****
C  SUB-TRIANGLE COMPUTATION ROUTINE FOR THE QDMEM2 ELEMENT
C
C  ON INPUT
C  ========
C            RA,RB,RC = 3 (3X1) COORDINATE VECTORS FOR TRIANGLE
C            IOPT     = 1  CALL FROM STIFFNESS GENERATION MODULE
C                     = 2  CALL FROM STATIC LOAD MODULE
C                     = 3  CALL FROM STRESS RECOVERY MODULE
C            ALPHA    = 3X1 VECTOR APPROPRIATE FOR CALL
C            ISINTH   = SIN OF MATERIAL ANGLE(WHOLE - ELEMENT)
C            ICOSTH   = COS OF MATERIAL ANGLE(WHOLE - ELEMENT)
C            GSUBE    = MATERIAL MATRIX (3X3)
C            IT       = THICKNESS OF ELEMENT
C
C  ON OUTPUT
C  =========
C            IERROR = 0  IF NO ERROR
C                   = 1  IF BAD ELEMENT GEOMETRY
C
C            KMAT,PMAT,SMAT,ZMAT = FOLLOWING PER IOPT VALUE SENT
C
C
C            IOPT=1
C            ------
C            KMAT = 7 (3X3)-S = KCA,KCB,KCC,KAA,KAB,KBA,KBB
C            PMAT = UNCHANGED
C            SMAT = UNCHANGED
C            ZMAT = UNCHANGED
C
C            IOPT=2
C            ------
C            KMAT = 3 (3X3)-S = KCA,KCB,KCC
C            PMAT = 3 (3X1)-S = PA,PB,PC
C            SMAT = UNCHANGED
C            ZMAT = UNCHANGED
C
C            IOPT=3
C            ------
C            KMAT = 7 (3X3)-S = KCA,KCB,KCC,KAA,KAB,KBA,KBB
C            PMAT = 3 (3X1)-S = PTA,PTB,PTC
C            SMAT = 3 (3X3)-S = SA,SB,SC
C            ZMAT = 3 (3X1)-S = ZA,ZB,ZC
C
C*****
      DOUBLE PRECISION  ALPHA(3) ,E(9)     ,IAREAT   ,I33
      DOUBLE PRECISION  RA(3)    ,KMAT(1)  ,ZMAT(1)  ,MAG      ,IVEC(3)
      DOUBLE PRECISION  RB(3)    ,PMAT(1)  ,V12(3)   ,IAREA    ,JVEC(3)
      DOUBLE PRECISION  RC(3)    ,SMAT(1)  ,V13(3)   ,IXSUBB   ,KVEC(3)
      DOUBLE PRECISION  IC       ,ISINTH   ,CA(6)    ,IXSUBC   ,TM(9)
      DOUBLE PRECISION  IS       ,ICOSTH   ,CB(6)    ,IYSUBC   ,TM3(3)
      DOUBLE PRECISION  IT                 ,CC(6)    ,C(3,6)   ,ALP(3)
      DOUBLE PRECISION  TEMP9(9) ,HI(27)   ,HITGE(9) ,GSUBE(9)
C
      DOUBLE PRECISION  DADOTB
C
      INTEGER           IPART(3,3)
C
      EQUIVALENCE (C(1,1),CA(1)), (C(1,3),CB(1)), (C(1,5),CC(1))
      EQUIVALENCE (E(1),IVEC(1)), (E(4),JVEC(1)), (E(7),KVEC(1))
C
      DATA IPART/ 28,46,1,   37,55,10,   0,0,19 /
C
C     V    = R   - R   ,      V    = R   - R
C      12     B     A          13     C     B
C
      DO 10 I = 1,3
      V12(I) = RB(I) - RA(I)
      V13(I) = RC(I) - RA(I)
   10 CONTINUE
C
C     KVEC(UN-NORMALIZED)  =  V     X  V
C                              12       13
C
      CALL DAXB( V12, V13, KVEC )
      MAG = DSQRT( DADOTB(KVEC,KVEC) )
      IF( MAG ) 190,190,20
C
C     NORMALIZE  K-VECTOR, AND AREA
C
   20 KVEC(1) = KVEC(1) / MAG
      KVEC(2) = KVEC(2) / MAG
      KVEC(3) = KVEC(3) / MAG
      IAREA = 0.50D0 * MAG
C
C     I-VECTOR = V   (NORMALIZED) THUS
C                 12
C
      MAG = DSQRT( DADOTB( V12, V12 ) )
      IF( MAG ) 190,190,30
   30 IVEC(1) = V12(1) / MAG
      IVEC(2) = V12(2) / MAG
      IVEC(3) = V12(3) / MAG
      IXSUBB = MAG
C
C     J-VECTOR = K-VECTOR CROSS I-VECTOR THUS
C
      CALL DAXB( KVEC, IVEC, JVEC )
C
C     MATERIAL COEFFICIENTS C AND S    U,V,W = I-VECTOR
C
      MAG = DSQRT( IVEC(1)**2 + IVEC(2)**2 )
      IF( MAG .LE. 0.D0 ) GO TO 190
      IC =(IVEC(1)*ICOSTH + IVEC(2)*ISINTH)/MAG
      IS =(IVEC(1)*ISINTH - IVEC(2)*ICOSTH)/MAG
C
C     X = MAGNITUDE OF V  , X = I-VEC DOT V  , Y = J-VEC DOT V
C      B                12   C             13   C             13
C
      IXSUBC = DADOTB( IVEC, V13 )
      IYSUBC = DADOTB( JVEC, V13 )
      IF( IXSUBB ) 40,190,40
   40 IF( IYSUBC ) 50,190,50
C
   50 CA(1) = -1.0D0 / IXSUBB
      CA(2) = 0.0D0
      I33 = 1.0D0 / IYSUBC
      CA(3) = I33 * (IXSUBC/IXSUBB - 1.0D0)
      CA(4) = 0.0D0
      CA(5) = CA(3)
      CA(6) = CA(1)
C
      CB(1) = -CA(1)
      CB(2) = 0.0D0
      CB(3) = - I33   * (IXSUBC / IXSUBB )
      CB(4) = 0.0D0
      CB(5) = CB(3)
      CB(6) = CB(1)
C
      CC(1) = 0.0D0
      CC(2) = 0.0D0
      CC(3) = I33
      CC(4) = 0.0D0
      CC(5) = I33
      CC(6) = 0.0D0
C
C     FORM MATERIAL-ORIENTATION-TRANSFORMATION-MATRIX  (BY-ROWS)
C
      TM(1) = IC * IC
      TM(2) = IS * IS
      TM(3) = IC * IS
      TM(4) = TM(2)
      TM(5) = TM(1)
      TM(6) = -TM(3)
      TM(7) = 2.0D0 * TM(6)
      TM(8) = -TM(7)
      TM(9) = TM(1) - TM(2)
      IAREAT= IAREA * IT
C
C     IF SSG CALL MULTIPLY ALPHA(T-TO) VECTOR BY IAREAT
C
      IF( IOPT .NE. 2 ) GO TO 60
      ALP(1) = ALPHA(1) * IAREAT
      ALP(2) = ALPHA(2) * IAREAT
      ALP(3) = ALPHA(3) * IAREAT
C
C     IF SDR CALL COMPUTE AREA   = X  * T
C                                   B
   60 IF( IOPT .NE. 3 ) GO TO 70
      TM3(1) = TM(3) * IT
      TM3(2) = TM(6) * IT
      TM3(3) = TM(9) * IT
C
C     SET FIRST PARTITION ROW TO COMPUTE FOR STIFFNESS MATRICES.
C
   70 IROW1 = 1
      IF( IOPT .EQ. 2 ) IROW1 = 3
C*****
C           M
C     H  = T  C  E
C      I       I
C
C*****
      DO 80 I = 1,3
      CALL GMMATD( TM,3,3,0, C(1,2*I-1),2,3,1, TEMP9 )
      CALL GMMATD( TEMP9,3,2,0, E,2,3,0, HI(9*I-8) )
   80 CONTINUE
C*****
C     FORM OUTPUTS FOR POINTS I = A,B,C
C*****
      DO 180 I = 1,3
C
C              T
C     HITGE= H  G
C             I  E
C
      CALL GMMATD( HI(9*I-8),3,3,1, GSUBE,3,3,0, HITGE )
C
C     STIFFNESS MATRIX CALCULATIONS
C
C     ONLY KAA,KAB     ARE FORMED.  OUTPUT ORDER WITH EACH 3X3 STORED
C          KBA,KBB                  BY ROWS =
C          KCA,KCB,KCC              KCA,KCB,KCC,KAA,KAB,KBA,KBB
C
      IF( I .LT. IROW1 ) GO TO 150
      KK = 0
      DO 140 J = 1,3
      IPARTN = IPART(I,J)
      IF( IPARTN )140,140,90
   90 DO 100 K = 1,9
      KK = KK + 1
      TEMP9(K) = HI(KK)*IAREAT
  100 CONTINUE
      CALL GMMATD( HITGE,3,3,0, TEMP9,3,3,0, KMAT(IPARTN) )
  140 CONTINUE
  150 GO TO(180,160,170),IOPT
C****
C  SSG LOAD GENERATION CALL ADDITIONAL DATA TO OUTPUT.
C
C  ONLY PA,PB,PC ARE FORMED.
C*****
  160 CALL GMMATD( HITGE,3,3,0,   ALP,3,1,0, PMAT(3*I-2) )
      GO TO 180
C*****
C  SDR ADDITIONAL PHASE-1 STRESS OUTPUTS
C*****
  170 JPARTN = 9*I-8
      CALL GMMATD( GSUBE,3,3,0, HI(JPARTN),3,3,0, SMAT(JPARTN) )
      IPARTN = 3*I - 2
      CALL GMMATD( HITGE,3,3,0, ALPHA,3,1,0, PMAT(IPARTN)  )
      CALL GMMATD( TM3,3,1,1, SMAT(JPARTN),3,3,0, ZMAT(IPARTN) )
      DO 175 J=1,3
      K = IPARTN + J - 1
      PMAT(K) = PMAT(K)*IAREAT
  175 CONTINUE
C
  180 CONTINUE
      IERROR = 0
      RETURN
C*****
C  ERROR CONDITION, BAD GEOMETRY.
C*****
  190 IERROR = 1
      RETURN
      END

      SUBROUTINE FRD2B (A,ALP,B,BET,C,GAM,D,DEL,E,EPS,OUT)
C
C     ADD UP MATRICIES
C
      INTEGER         A,B,C,D,E,OUT,TYPA,TYPB,TYPC,TYPD,TYPE
      REAL            ALP(2),BET(2),GAM(2),DEL(2),EPS(2),Z(1)
      COMMON /SYSTEM/ KSYSTM(54), IPREC
      COMMON /ZZZZZZ/ Z
      COMMON /SADDX / NOMAT,LCORE,MCBA(7),TYPA,ALPHA(4),MCBB(7),TYPB,
     1                BETA(4),MCBC(7),TYPC,GAMA(4),MCBD(7),TYPD,
     2                DELTA(4),MCBE(7),TYPE,EPSLN(4),MC(7)
      COMMON /FRD2BC/ IH
C
      NC    = KORSZ(Z)
      NOMAT = 5
      LCORE = NC
      TYPA  = 3
      TYPB  = 3
      TYPC  = 3
      TYPD  = 3
      TYPE  = 3
      ALPHA(1) = ALP(1)
      ALPHA(2) = ALP(2)
      BETA(1)  = BET(1)
      BETA(2)  = BET(2)
      GAMA(1)  = GAM(1)
      GAMA(2)  = GAM(2)
      DELTA(1) = DEL(1)
      DELTA(2) = DEL(2)
      EPSLN(1) = EPS(1)
      EPSLN(2) = EPS(2)
      MCBA(1)  = A
      MCBB(1)  = B
      MCBC(1)  = C
      MCBD(1)  = D
      MCBE(1)  = E
      CALL RDTRL (MCBA)
      CALL RDTRL (MCBB)
      CALL RDTRL (MCBC)
      CALL RDTRL (MCBD)
      CALL RDTRL (MCBE)
      IFO = 6
      ITY = 3
      IF (IH.EQ.0 .AND. IPREC.EQ.2) ITY = 4
C
C     IH IN /FRD2BC/ IS INITIALIZED BY ROUTINE FRRD2.
C     (COMPLEX D.P. ARITHMETIC IS USED IF IH = 0)
C
      N = 0
      DO 10 I = 1,49,12
      IF (MCBA(I  ) .LT. 0) MCBA(I) = 0
      IF (MCBA(I+1) .EQ. 0) MCBA(I) = 0
      IF (MCBA(I  ) .EQ. 0) GO TO 10
      IF (N .EQ. 0) N = MCBA(I+1)
      IROW = MCBA(I+2)
      IF (MCBA(I+3) .NE. 6) IFO  = 1
   10 CONTINUE
      CALL MAKMCB (MC,OUT,IROW,IFO,ITY)
      MC(2) = N
      CALL SADD (Z,Z)
      CALL WRTTRL (MC)
      CALL DMPFIL (-OUT,Z,NC)
      RETURN
      END

      FUNCTION ZJ ( ARG )
C
C     ZERO ORDER BESSEL FUNCTION OF FIRST KIND
C
      DBSLJ = 1.0E-10
      A  =  - ( ARG / 2.0 ) ** 2
      ZJ  =  1.0
      PF  =  1.0
      AN  =  1.0
      DO   200   I = 1 , 20
      AN  =  AN * A / PF ** 2
      PF  =  PF + 1.0
      IF ( ABS ( AN ) .LE. DBSLJ )   RETURN
      ZJ  =  ZJ + AN
 200  CONTINUE
      RETURN
      END

        SUBROUTINE DSEFWR
      INCLUDE 'DSIOF.COM'
      INCLUDE 'XNSTRN.COM'
        IF ( IPRVOP .NE. 0 ) GO TO 10
        CALL DSMSG ( 7 )
10      IF ( INDCLR .EQ. INDCBP ) GO TO 20
        IBASE( INDCBP+1 ) = IDSRT + IDSC + ( INDCLR-INDBAS+1 )
        INDCLR = INDCBP + 2
        INDCBP = INDCLR
20      IF ( ( INDCLR-INDBAS-2 ) .LT. NBUFF ) GO TO 30
        IBASE( INDCLR ) = IDSEB
        CALL DSWRNB
30      IBASE( INDCLR   ) = IDSEF
        IBASE( INDCLR+1 ) = IDSEB
        INDCLR = INDCLR + 1
        INDCBP = INDCLR
        IF ( ( INDCLR-INDBAS ) .LE. NBUFF ) GO TO 40
        CALL DSWRNB
40      RETURN
        END

      SUBROUTINE XRCARD (OUT,NFLAG,IN)
C
C     MODIFIED BY G.CHAN/UNISYS FOR EFFICIENCY,        2/1988
C     LAST REVISED, 8/1989, IMPROVED EFFICIENCY BY REDUCING CHARACTER
C     OPERATIONS (VERY IMPORTANT FOR CDC MACHINE)
C
C     REVERT TO NASTRAN ORIGIANL XRCARD ROUTINE (NOW CALLED YRCARD)
C     IF DIAG 42 IS TURNED ON
C     (THIS NEW XRCARD IS SEVERAL TIMES FASTER THAN YRCARD)
C
C
      IMPLICIT INTEGER  (A-Z)
      EXTERNAL        LSHIFT   ,RSHIFT   ,COMPLF
      LOGICAL         ALPHA    ,DELIM    ,EXPONT   ,POWER    ,MINUS   ,
     1                NOGO     ,DEBUG
      INTEGER         IDOUBL(2),TYPE(72) ,NT(15)   ,IN(18)   ,OUT(2)
      INTEGER         PLUS1    ,MINUS1   ,BLANK1   ,DOT1     ,E1      ,
     1                D1       ,NUM1(10) ,CHAR1(72),DOLLR1   ,COMMA1  ,
     2                EQUAL1   ,SLASH1   ,OPARN1   ,CPARN1   ,ASTK1   ,
     3                CHAR1N   ,CHAR1I   ,CHARN2   ,CHARS(23),ZERO1   ,
     4                PRECIS   ,PSIGN
      REAL            FLPT
      DOUBLE PRECISION          DDOUBL
      CHARACTER*1     SAVE1(8) ,KHAR1(72)
      CHARACTER*8     SAVE8    ,BLANK8   ,NUMRIC
      CHARACTER*23    CHAR23   ,UFM
      CHARACTER*72    CHAR72
      COMMON /XMSSG / UFM
      COMMON /LHPWX / LOWPW    ,HIGHPW
      COMMON /SYSTEM/ BUFSZ    ,NOUT     ,NOGO
      EQUIVALENCE     (KHAR1(1),CHAR72), (SAVE8 ,SAVE1( 1)),
     1                (FLPT    ,INTG  ), (DDOUBL,IDOUBL(1)),
     2                (CHARS(1),DOLLR1), (CHARS( 8),CPARN1),
     3                (CHARS(2),PLUS1 ), (CHARS( 9),E1    ),
     4                (CHARS(3),EQUAL1), (CHARS(10),D1    ),
     5                (CHARS(4),MINUS1), (CHARS(11),DOT1  ),
     6                (CHARS(5),COMMA1), (CHARS(12),BLANK1),
     7                (CHARS(6),SLASH1), (CHARS(13),ASTK1 ),
     8                (CHARS(7),OPARN1), (CHARS(14),NUM1(1)),
     9                (NUM1(10),ZERO1 )
      DATA    CHAR23/ '$+=-,/()ED. *1234567890'/,   BLANK8/ '       ' /
      DATA    DOLLR1,  BLANK4,  DIAG  ,   DEBUG ,   NUMRIC            /
     1        0,       4H    ,  4HDIAG,  .FALSE.,  'NUMERIC'          /
      DATA    EQUAL4,  SLASH4,  OPARN4,   ASTK4                       /
     1        4H=   ,  4H/   ,  4H(   ,   4H*                         /
C
      IF (DOLLR1 .NE. 0) GO TO 20
      CALL K2B (CHAR23,CHARS,23)
      A77777 = COMPLF(0)
      A67777 = RSHIFT(LSHIFT(A77777,1),1)
      PREV   = BLANK4
      CALL SSWTCH (42,L42)
      IF (DEBUG) WRITE (NOUT,10)
   10 FORMAT (//5X,'INPUT DEBUG IN XRCARD ROUTINE')
C
C         KXX=0
C
C     USE ORIGINAL XRCARD ROUTINE IF DIAG 42 IS TURNED ON
C
   20 IF (PREV .EQ. DIAG) CALL SSWTCH (42,L42)
      IF (L42 .EQ. 0) GO TO 30
      CALL YRCARD (OUT,NFLAG,IN)
      RETURN
C
C     CONVERT 18 BCD WORDS IN 'IN' TO 72 CHARACTER STRING, AND SET TYPE
C
   30 CALL BCDKH7 (IN,CHAR72)
      CALL K2B (CHAR72,CHAR1,72)
      IF (DEBUG) WRITE (NOUT,45) CHAR72
   45 FORMAT (/,' INPUT- ',A72)
C
C
      DO 80 N = 1,72
      CHAR1N = CHAR1(N)
      IF (CHAR1N .EQ. BLANK1 ) GO TO 60
      DO 50 K = 1,10
      IF (CHAR1N .EQ. NUM1(K)) GO TO 70
   50 CONTINUE
      TYPE(N) =-1
      GO TO 80
   60 TYPE(N) = 0
      GO TO 80
   70 TYPE(N) = 1
   80 CONTINUE
      N = 73
   90 N = N - 1
      IF (TYPE(N) .EQ. 0) GO TO 90
      LAST  = N + 1
      IF (LAST .GT. 72) LAST = 72
      ALPHA = .FALSE.
      DELIM = .TRUE.
      IOUT  = 0
      N     = 0
      ASAVE = 1
      OUT(ASAVE) = 0
      SAVE8 = BLANK8
  100 IF (N .EQ. LAST) GO TO 510
      IF (NFLAG-IOUT .LT. 5) GO TO 660
      MINUS = .FALSE.
      N = N + 1
      CHAR1N = CHAR1(N)
      IF (TYPE(N)) 110,  100,   210
C                  BCD  BLANK NUMERIC
C
  110 IF (CHAR1N.EQ.PLUS1 .OR. CHAR1N.EQ.MINUS1 .OR. CHAR1N.EQ.DOT1)
     1    GO TO 200
      IF (CHAR1N .EQ. DOLLR1) GO TO 180
C
C     GOOD ALPHA FIELD OR DELIMITER
C
      IF (ALPHA) GO TO 120
      IF ((CHAR1N.EQ.COMMA1 .OR. CHAR1N.EQ.DOLLR1) .AND. (.NOT.DELIM))
     1    GO TO 180
      IF (CHAR1N.EQ.CPARN1 .AND. .NOT.DELIM) GO TO 180
      IOUT  = IOUT + 1
      ASAVE = IOUT
      OUT(ASAVE) = 0
      ALPHA = .TRUE.
  120 IF  (CHAR1N.EQ.OPARN1 .OR. CHAR1N.EQ.SLASH1 .OR. CHAR1N.EQ.EQUAL1
     1.OR. CHAR1N.EQ.COMMA1 .OR. CHAR1N.EQ.ASTK1  .OR. CHAR1N.EQ.DOLLR1)
     2     GO TO 180
      IF (CHAR1N .EQ. CPARN1) GO TO 180
      ASSIGN 125 TO IRTN
      IMHERE = 125
      GO TO 170
  125 OUT(ASAVE) = OUT(ASAVE) + 1
      IOUT  = IOUT + 2
      DELIM = .FALSE.
      OUT(IOUT-1) = BLANK4
      OUT(IOUT  ) = BLANK4
      ICHAR = 0
      GO TO 150
  130 IF (N .EQ. LAST) GO TO 510
      N = N + 1
      CHAR1N = CHAR1(N)
      IF (TYPE(N)) 140,  160,    150
C                  BCD BLANK NUMERIC
C
  140 IF  (CHAR1N.EQ.OPARN1 .OR. CHAR1N.EQ.SLASH1 .OR. CHAR1N.EQ.EQUAL1
     1.OR. CHAR1N.EQ.COMMA1 .OR. CHAR1N.EQ.ASTK1  .OR. CHAR1N.EQ.DOLLR1)
     2     GO TO 180
      IF (CHAR1N .EQ. CPARN1) GO TO 180
C
C     RECONSTRUCT CHARACTERS INTO SAVE1 SPACE, UP TO 8 CHARACTERS ONLY
C
  150 IF (ICHAR .EQ. 8) GO TO 130
      ICHAR = ICHAR + 1
      SAVE1(ICHAR) = KHAR1(N)
      IMHERE = 150
      IF (DEBUG) WRITE (NOUT,171) SAVE8,IMHERE,ICHAR,IOUT
C
C     GO FOR NEXT CHARACTER
C
      IF (ICHAR .LT. 8) GO TO 130
      ASSIGN 130 TO IRTN
      IMHERE = 155
      GO TO 170
C
C     A BLANK CHARACTER IS ENCOUNTERED WHILE PROCESSING ALPHA STRING
C     IF THIS IS AT THE BEGINNING OF A NEW BCD WORD, GO TO 100
C     IF THIS IS AT THE END OF A BCD WORD, GO TO 170 TO WRAP IT UP
C
  160 IF (ICHAR .EQ. 0) GO TO 100
      ASSIGN 100 TO IRTN
      IMHERE = 160
C
C     MOVE CHARACTER DATA IN SAVE8 TO OUT(IOUT-1) AND OUT(IOUT) IN BCD
C     WORDS
C
  170 IF (SAVE8 .NE. BLANK8) CALL KHRBC2 (SAVE8,OUT(IOUT-1))
      IF (.NOT.DEBUG) GO TO 175
      WRITE (NOUT,171) SAVE8,IMHERE,ICHAR,IOUT
      WRITE (NOUT,172) IOUT,OUT(IOUT-1),OUT(IOUT),DELIM,
     1                 IOUT,OUT(IOUT-1),OUT(IOUT)
  171 FORMAT ('   SAVE8= /',A8,'/   @',I3,',  ICHAR,IOUT=',2I3)
  172 FORMAT ('   IOUT,OUT  =',I4,2H /,2A4,'/  DELIM=',L1,
     1            /14X,    '=',I4,2H /,2I25,'/')
  175 SAVE8 = BLANK8
      GO TO IRTN, (100,125,130,185)
C
C     DELIMITER HIT
C
  180 ASSIGN 185 TO IRTN
      IMHERE = 180
      GO TO 170
  185 IF (.NOT. DELIM) GO TO 190
      IF (IOUT .EQ. 0) IOUT = 1
      IOUT = IOUT + 2
      OUT(ASAVE)  = OUT(ASAVE) + 1
      OUT(IOUT-1) = BLANK4
      OUT(IOUT  ) = BLANK4
  190 IF (CHAR1N .EQ. DOLLR1) GO TO 520
      DELIM = .TRUE.
      IF (CHAR1N .EQ. CPARN1) DELIM = .FALSE.
      IF (CHAR1N .EQ. COMMA1) GO TO 100
      IF (CHAR1N .EQ. CPARN1) GO TO 100
C
C     OUTPUT DELIMITER
C
      IOUT = IOUT + 2
      OUT(ASAVE) = OUT(ASAVE) + 1
      OUT(IOUT) = BLANK4
      IF (CHAR1N .EQ. OPARN1) OUT(IOUT) = OPARN4
      IF (CHAR1N .EQ. SLASH1) OUT(IOUT) = SLASH4
      IF (CHAR1N .EQ. EQUAL1) OUT(IOUT) = EQUAL4
      IF (CHAR1N .EQ.  ASTK1) OUT(IOUT) =  ASTK4
      IF (OUT(IOUT) .EQ. BLANK4) GO TO 590
      OUT(IOUT-1) = A77777
      IF (DEBUG) WRITE (NOUT,195) IOUT,OUT(IOUT),DELIM,CHAR1N
  195 FORMAT (5X,'IOUT,OUT/@195 =',I4,2H ',A4,8H' DELIM=,L1,2H ',A1,
     1        1H')
      SAVE8 = BLANK8
      GO TO 100
C
C     PLUS, MINUS, OR DOT ENCOUNTERED
C
  200 IF (CHAR1N .EQ. MINUS1) MINUS = .TRUE.
      IF (CHAR1N .NE.   DOT1) N = N + 1
      IF (N .GT. LAST) GO TO 530
C
C     NUMERIC
C
  210 ALPHA = .FALSE.
      DELIM = .FALSE.
      IT    = 0
      NT(1) = 0
      DO 260 I = N,LAST
      IF (TYPE(I)) 290,270,220
C
C     INTEGER CHARACTER
C
  220 CHAR1I = CHAR1(I)
      DO 230 K = 1,9
      IF (CHAR1I .EQ. NUM1(K)) GO TO 250
  230 CONTINUE
      K  = 0
  250 IT = IT + 1
      IF (IT .LT. 16) NT(IT) = K
  260 CONTINUE
C
C     FALL HERE IMPLIES WE HAVE A SIMPLE INTEGER
C
  270 NUMBER = 0
      DO 280 I = 1,IT
      IF (((A67777-NT(I))/10) .LT. NUMBER) GO TO 550
  280 NUMBER = NUMBER*10  +  NT(I)
      IF (MINUS) NUMBER = - NUMBER
      IOUT = IOUT + 2
      OUT(IOUT-1) =-1
      OUT(IOUT  ) = NUMBER
      IF (.NOT.DEBUG) GO TO 285
      IMHERE = 280
      WRITE (NOUT,171) NUMRIC,IMHERE
      WRITE (NOUT,282) IOUT,OUT(IOUT-1),OUT(IOUT),DELIM
  282 FORMAT (10X,I4,1H),2I8,'    DELIM=',L1)
  285 N = N + IT - 1
      GO TO 100
C
C     FLOATING PT. NUMBER, DELIMITER, OR ERROR IF FALL HERE
C
C     COUNT THE NUMBER OF DIGITS LEFT BEFORE CARD END OR DELIMITER HIT
C
  290 N1 = I
      DO 300 N2 = N1,LAST
      CHARN2 = CHAR1(N2)
      IF (CHARN2.EQ.OPARN1 .OR. CHARN2.EQ.SLASH1 .OR.
     1    CHARN2.EQ.EQUAL1 .OR. CHARN2.EQ.COMMA1 .OR.
     2    CHARN2.EQ.DOLLR1 .OR. TYPE(N2).EQ.0) GO TO 310
      IF (CHARN2 .EQ. CPARN1) GO TO 310
  300 CONTINUE
      N2 = LAST + 1
  310 IF (N1 .EQ. N2) GO TO 270
C
C     CHARACTER N1 NOW MUST BE A DECIMAL FOR NO ERROR
C
      IF (CHAR1(N1) .NE. DOT1) GO TO 570
      POWER = .FALSE.
      N1 = N1 + 1
      N2 = N2 - 1
      PLACES = 0
      EXPONT = .FALSE.
      IPOWER = 0
      PSIGN  = ZERO1
      PRECIS = ZERO1
      IF (N2 .LT. N1) GO TO 410
      DO 400 I = N1,N2
      CHAR1I = CHAR1(I)
      IF (TYPE(I)) 360,570,320
C
C     FLOATING PT. NUMBER
C
  320 DO 330 K = 1,9
      IF (CHAR1I .EQ. NUM1(K)) GO TO 340
  330 CONTINUE
      K = 0
  340 IF (EXPONT) GO TO 350
      IT = IT + 1
      IF (IT .LT. 16) NT(IT) = K
      PLACES = PLACES + 1
      GO TO 400
C
C     BUILD POWER HERE
C
  350 POWER  = .TRUE.
      IPOWER = IPOWER*10 + K
      IF (IPOWER .GT. 1000) GO TO 630
      GO TO 400
C
C     START EXPONENTS HERE
C
  360 IF (EXPONT) GO TO 380
      EXPONT = .TRUE.
      IF (CHAR1I.NE.PLUS1 .AND. CHAR1I.NE.MINUS1) GO TO 370
      PRECIS = E1
      PSIGN  = CHAR1I
      GO TO 390
  370 IF (CHAR1I.NE.E1 .AND. CHAR1I.NE.D1) GO TO 610
      PRECIS = CHAR1I
      GO TO 390
C
C     SIGN OF POWER
C
  380 IF (POWER) GO TO 610
      IF (PSIGN.NE.ZERO1 .OR.
     1   (CHAR1I.NE.PLUS1 .AND. CHAR1I.NE.MINUS1)) GO TO 610
      PSIGN = CHAR1I
      POWER = .TRUE.
  390 IF (I .EQ. LAST) GO TO 530
  400 CONTINUE
  410 N = N2
C
C     ALL DATA COMPLETE FOR FLOATING POINT NUMBER
C     ONLY 15 FIGURES WILL BE ACCEPTED
C
      IF (IT .LE. 15) GO TO 420
      IPOWER = IPOWER + IT - 15
      IT = 15
  420 IF (PSIGN .EQ. MINUS1) IPOWER = -IPOWER
      IPOWER = IPOWER - PLACES
      NUMBER = 0
      IF (IT .LT. 7) GO TO 430
      N2 = 7
      GO TO 440
  430 N2 = IT
  440 DO 450 I = 1,N2
  450 NUMBER = NUMBER*10 + NT(I)
      DDOUBL = DBLE(FLOAT(NUMBER))
      IF (IT .LE. 7) GO TO 470
      NUMBER = 0
      N2 = IT - 7
      DO 460 I = 1,N2
      IT = I + 7
  460 NUMBER = NUMBER*10 + NT(IT)
      DDOUBL = DDOUBL*10.0D0**N2 + DBLE(FLOAT(NUMBER))
  470 IF (MINUS) DDOUBL = -DDOUBL
C
C     POWER HAS TO BE WITHIN RANGE OF MACHINE
C
      ICHEK = IPOWER + IT
      IF (DDOUBL .EQ. 0.0D0) GO TO 490
      IF (ICHEK .LT.LOWPW+1 .OR. ICHEK .GT.HIGHPW-1 .OR.
     1    IPOWER.LT.LOWPW+1 .OR. IPOWER.GT.HIGHPW-1) GO TO 640
      DDOUBL = DDOUBL*10.0D0**IPOWER
  490 IF (PRECIS .EQ. D1) GO TO 500
      FLPT = DDOUBL
      IOUT = IOUT + 2
      OUT(IOUT-1) =-2
      OUT(IOUT  ) = INTG
      GO TO 100
  500 IOUT = IOUT + 3
      OUT(IOUT-2) =-4
      OUT(IOUT-1) = IDOUBL(1)
      OUT(IOUT  ) = IDOUBL(2)
      GO TO 100
C
C     PREPARE TO RETURN
C
  510 IF (.NOT. DELIM) GO TO 520
      IF (SAVE8 .NE. BLANK8) CALL KHRBC2 (SAVE8,OUT(IOUT-1))
      OUT(IOUT+1) = 0
      GO TO 525
  520 OUT(IOUT+1) = A67777
  525 PREV = OUT(2)
      RETURN
C
C     ERRORS
C
  530 WRITE  (NOUT,540) UFM
  540 FORMAT (A23,'300, INVALID DATA COLUMN 72')
      GO TO  680
  550 WRITE  (NOUT,560) UFM
  560 FORMAT (A23,'300, INTEGER DATA OUT OF MACHINE RANGE')
      GO TO  680
  570 WRITE  (NOUT,580) UFM,N1
  580 FORMAT (A23,'300, INVALID CHARACTER FOLLOWING INTEGER IN COLUMN',
     1       I4)
      GO TO  680
  590 WRITE  (NOUT,600) UFM,CHAR1N
  600 FORMAT (A23,'300, FORGOTTEN DELIMITER - ',A1,',  PROGRAM ERROR')
      GO TO  680
  610 WRITE  (NOUT,620) UFM,I
  620 FORMAT (A23,'300, DATA ERROR-UNANTICIPATED CHARACTER IN COLUMN',
     1       I4)
      GO TO  680
  630 CONTINUE
  640 WRITE  (NOUT,650) UFM
  650 FORMAT (A23,'300, DATA ERROR - MISSING DELIMITER OR REAL POWER ',
     1        'OUT OF MACHINE RANGE')
      GO TO  680
  660 WRITE  (NOUT,670) UFM
  670 FORMAT (A23,'300, ROUTINE XRCARD FINDS OUTPUT BUFFER TOO SMALL ',
     1        'TO PROCESS CARD COMPLETELY')
  680 NOGO = .TRUE.
      WRITE  (NOUT,690) CHAR72
  690 FORMAT (/5X,1H',A72,1H','  ERROR IN XRCARD ROUTINE')
      OUT(1) = 0
      RETURN
C
      END

      SUBROUTINE DMFGR (A,M,N,EPS,IRANK,IROW,ICOL)
C
C     DMFGR CALCULATES THE RANK AND LINEARLY INDEPENDENT ROWS AND
C     COLUMNS OF A M BY N MATRIX.  IT EXPRESSES A SUBMATRIX OF
C     MAXIMAL RANK AS A PRODUCT OF TRIANGULAR FACTORS, NONBASIC ROWS
C     IN TERMS OF BASIC ONES AND BASIC VARIABLES IN TERMS OF FREE ONES
C
C     DIMENSIONED DUMMY VARIABLES
C
      DIMENSION A(1),IROW(1),ICOL(1)
      DOUBLE PRECISION A,PIV,HOLD,SAVE
C
C     TEST OF SPECIFIED DIMENSIONS
C
      IF (M) 20,20,10
   10 IF (N) 20,20,40
   20 IRANK = -1
   30 RETURN
C
C     RETURN IN CASE OF FORMAL ERRORS
C
C     INITIALIZE COLUMN INDEX VECTOR
C     SEARCH FIRST PIVOT ELEMENT
C
   40 IRANK = 0
      PIV = 0.D0
      JJ  = 0
      DO 60 J = 1,N
      ICOL(J) = J
      DO 60 I = 1,M
      JJ  = JJ + 1
      HOLD = A(JJ)
      IF (DABS(PIV)-DABS(HOLD)) 50,60,60
   50 PIV = HOLD
      IR  = I
      IC  = J
   60 CONTINUE
C
C     INITIALIZE ROW INDEX VECTOR
C
      DO 70 I = 1,M
   70 IROW(I) = I
C
C     SET UP INTERNAL TOLERANCE
C
      TOL = ABS(EPS*SNGL(PIV))
C
C     INITIALIZE ELIMINATION LOOP
C
      NM = N*M
      DO 210 NCOL = M,NM,M
C
C     TEST FOR FEASIBILITY OF PIVOT ELEMENT
C
      IF (ABS(SNGL(PIV))-TOL) 220,220,90
C
C     UPDATE RANK
C
   90 IRANK = IRANK + 1
C
C     INTERCHANGE ROWS IF NECESSARY
C
      JJ = IR - IRANK
      IF (JJ) 120,120,100
  100 DO 110 J = IRANK,NM,M
      I  = J + JJ
      SAVE = A(J)
      A(J) = A(I)
  110 A(I) = SAVE
C
C     UPDATE ROW INDEX VECTOR
C
      JJ = IROW(IR)
      IROW(IR) = IROW(IRANK)
      IROW(IRANK) = JJ
C
C     INTERCHANGE COLUMNS IF NECESSARY
C
  120 JJ = (IC-IRANK)*M
      IF (JJ) 150,150,130
  130 KK = NCOL
      DO 140 J = 1,M
      I  = KK + JJ
      SAVE  = A(KK)
      A(KK) = A(I)
      KK = KK - 1
  140 A(I) = SAVE
C
C     UPDATE COLUMN INDEX VECTOR
C
      JJ = ICOL(IC)
      ICOL(IC) = ICOL(IRANK)
      ICOL(IRANK) = JJ
  150 KK = IRANK + 1
      MM = IRANK - M
      LL = NCOL  + MM
C
C     TEST FOR LAST ROW
C
      IF (MM) 160,270,270
C
C     TRANSFORM CURRENT SUBMATRIX AND SEARCH NEXT PIVOT
C
  160 JJ   = LL
      SAVE = PIV
      PIV  = 0.D0
      DO 200 J = KK,M
      JJ   = JJ + 1
      HOLD = A(JJ)/SAVE
      A(JJ)= HOLD
      L    = J - IRANK
C
C     TEST FOR LAST COLUMN
C
      IF (IRANK-N) 170,200,200
  170 II = JJ
      DO 190 I = KK,N
      II = II + M
      MM = II - L
      A(II) = A(II) - HOLD*A(MM)
      IF (DABS(A(II))-DABS(PIV)) 190,190,180
  180 PIV = A(II)
      IR  = J
      IC  = I
  190 CONTINUE
  200 CONTINUE
  210 CONTINUE
C
C     SET UP MATRIX EXPRESSING ROW DEPENDENCIES
C
  220 IF (IRANK-1) 30,270,230
  230 IR = LL
      DO 260 J = 2,IRANK
      II = J - 1
      IR = IR - M
      JJ = LL
      DO 250 I = KK,M
      HOLD = 0.D0
      JJ = JJ + 1
      MM = JJ
      IC = IR
      DO 240 L = 1,II
      HOLD = HOLD + A(MM)*A(IC)
      IC = IC - 1
  240 MM = MM - M
  250 A(MM) = A(MM) - HOLD
  260 CONTINUE
C
C     TEST FOR COLUMN REGULARITY
C
  270 IF (N-IRANK) 30,30,280
C
C     SET UP MATRIX EXPRESSING BASIC VARIABLES IN TERMS OF FREE
C     PARAMETERS (HOMOGENEOUS SOLUTION).
C
  280 IR = LL
      KK = LL + M
      DO 320 J = 1,IRANK
      DO 310 I = KK,NM,M
      JJ = IR
      LL = I
      HOLD = 0.D0
      II = J
  290 II = II - 1
      IF (II) 310,310,300
  300 HOLD = HOLD - A(JJ)*A(LL)
      JJ = JJ - M
      LL = LL - 1
      GO TO 290
  310 A(LL) = (HOLD-A(LL))/A(JJ)
  320 IR = IR - 1
      RETURN
      END

      SUBROUTINE DSNMRD (IUNITU)
      INCLUDE  'DSIOF.COM'
      COMMON /GNDATE/ IGNDAT(2)
      READ (IUNITU) FCB, NUMDEV, DEV, MDSNAM, IGNDAT, MAXBLK, MAXDSK
      READ (IUNITU) NUMOPN, NUMCLS, NUMWRI, NUMREA
      DO 10 I = 1, 80
      FCB( 9, I ) = 0
      FCB(10, I ) = 0
      FCB(11, I ) = 0
10    CONTINUE
      RETURN
      END

      SUBROUTINE DBMLBK ( LASBLK )
C
C THIS SUBROUTINE WILL RETURN THE LAST BLOCK NUMBER ALLOCATED TO THE
C UNIT "IFILEX"
C
      INCLUDE   'DSIOF.COM'
      INCLUDE   'ZZZZZZ.COM'
      LASBLK = FCB( 6, IFILEX )
      IF ( LASBLK .NE. 0 ) GO TO 7000
      INDEX  = FCB( 10, IFILEX )
      IF ( INDEX .EQ. 0 ) GO TO 200
      LASBLK = MEM( INDEX+3 )
      GO TO 7000
200   LASBLK = 0
7000  CONTINUE
      RETURN
      END

      SUBROUTINE OPTP1D (ELOP,PR,PL)
C
C     PROPERTY OPTIMIZER   SET POINTERS TO PLIMIT
C
      INTEGER         ELOP(2,1),PR(1),COUNT,YCOR,B1P1,SCRTH1,
     1                SYSBUF,OUTTAP,PLP,PID,NAME(2),NKL(2)
      REAL            PL(1),KL
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG / UFM,UWM,UIM,SFM
      COMMON /BLANK / SKP1(2),COUNT,SKP2(2),YCOR,B1P1,NPOW,
     1                SKP3(2),NPRW,NWDSP,NKLW,SKP4(6),SCRTH1
      COMMON /OPTPW1/ KLWDS,KL(4)
      COMMON /SYSTEM/ SYSBUF,OUTTAP
      COMMON /NAMES / NRD,NOEOR,NWRT,NWEOR
      EQUIVALENCE     (NKL(1),KL(1))
      DATA    NAME  / 4H OPT,4HPID  /
C
      NOGO = 0
      PLP  = 1
      GO TO 15
C
C     READ A NEW ELEMENT TYPE
C
   10 CALL FREAD (SCRTH1,0,0,NWEOR)
   15 L   = 0
      NPL = 0
      CALL READ (*150,*180,SCRTH1,ITP,1,NOEOR,I)
      IF (ITP .LE. NPOW) GO TO 40
C
   20 CALL PAGE2 (-2)
      WRITE  (OUTTAP,30) SFM,NAME,ITP,L
   30 FORMAT (A25,' 2301,',2A4,' FILE OPTIMIZATION PARAMETER INCORRECT',
     1       ' AS',2I8)
      NOGO = NOGO + 1
      GO TO 140
C
   40 IP1 = ELOP(2,ITP)
      IP2 = ELOP(2,ITP+1) - 1
      NPR = IP2 - IP1
      IF (NPR .LE. 0) GO TO 10
      CALL FREAD (SCRTH1,L,1,NOEOR)
      IF (L .LE. 0) GO TO 20
C
      CALL FREAD (SCRTH1,NKL(1),4,NOEOR)
      L = L - 1
C
C     SEQUENTIAL SEARCH ON PLIMIT AND PROPERTY DATA
C     LPL -- LAST PLIMIT POINTED TO (BY ILL).
C     NPL -- NUMBER OF PLIMIT FOR THIS ELEMENT TYPE IN CORE.
C     PLP -- POINTER FIRST PLIMIT  --    --     -- .
C
      LPL = -9877
C
      DO 130 IPR = IP1,IP2,NWDSP
      PID = PR(IPR)
C
   50 IF (PID-NKL(1)) 70,80,60
C
C     CHECK UPPER RANGE PLIMIT
C
   60 CONTINUE
      IF (PID-NKL(2)) 80,80,70
C
C     READ NEXT PLIMIT INTO CORE
C
   70 IF (L.LE.0) GO TO 140
      CALL FREAD (SCRTH1,NKL(1),4,NOEOR)
      L = L - 1
      GO TO 50
C
C     PLIMIT EXISTS - SEE IF MATCHES LAST
C
   80 IF (LPL .EQ. L) GO TO 120
C
C     DOESNOT - CHECK IF PREVIOUS ENTRY
C
      IF (NPL .EQ. 0) GO TO 100
      DO 90 LPL = PLP,LOC,2
      IF (PL(LPL)   .NE. KL(3)) GO TO 90
      IF (PL(LPL+1) .EQ. KL(4)) GO TO 110
   90 CONTINUE
C
C     NEW PLIMIT
C
  100 IF (NPL+PLP+1 .GT.YCOR) GO TO 190
      NPL = NPL + 2
      LOC = NPL + PLP - 2
      PL(LOC  ) = KL(3)
      PL(LOC+1) = KL(4)
      LPL = L
      ILL = LOC
      GO TO 120
C
C     PREVIOUS MATCH
C
  110 ILL = LPL
      LPL = L
C
C     LOAD POINTER
C
  120 PR(IPR+5) = ILL
C
  130 CONTINUE
C
  140 PLP = PLP + NPL
      GO TO 10
C
C     END-OF-FILE
C
  150 NKLW = PLP + NPL - 1
  160 IF (NOGO .GT. 0) COUNT = -1
      RETURN
C
C     ILLEGAL EOR
C
  180 CALL MESAGE (-3,SCRTH1,NAME)
C
C     INSUFFICIENT COREINTERNAL ELEMENT NUMBER PRINTED
C
  190 CALL PAGE2 (-2)
      WRITE  (OUTTAP,200) UFM,NAME,B1P1,ITP
  200 FORMAT (A23,' 2298, INSUFFICIENT CORE ',2A4,1H(,I10,
     1       ' ), PROPERTY',I9)
      NKLW = -PLP
      GO TO 160
      END

      SUBROUTINE ALGPR (IERR)
C
      LOGICAL         DEBUG
      INTEGER         SYSBUF,NAME(2),EDT,EQEXIN,CSTM,UGV,FILE,CORWDS,
     1                PGEOM,BUF1,BUF2,SCR1,SCR2,RET2,TYPOUT,BGPDT,
     2                ITRL(7),STREAM(3),APRESS,ATEMP,STRML,ALGDB,
     3                IDATA(24),KPTSA(10),IFANGS(10),RD,RDREW,WRT,
     4                WRTREW,CLSREW,NOREW,LEN(3),IFILL(3),ALGDD
      REAL            RFILL(3),Z(1),TA(9),RDATA(6),XSTA(21,10),
     1                RSTA(21,10),R(21,10),B1(21),B2(21),RLE(21),
     2                TC(21),TE(21),CORD(21),DELX(21),DELY(21),ZED(21),
     3                PHI(2,21),ZR(21),PP(21),QQ(21),CORD2(21),
     4                FCHORD(21),JZ(21),XB(21,10),YB(21,10),ZB(21,10),
     5                DISPT(3),DISPR(3),DISPT1(21,10),DISPT2(21,10),
     6                DISPT3(21,10),BLAFOR(21,10),DISPR1(21,10),
     7                DISPR2(21,10),DISPR3(21,10)
      CHARACTER       UFM*23,UWM*25
      COMMON /XMSSG / UFM,UWM
      COMMON /BLANK / APRESS,ATEMP,STRML,PGEOM,IPRTK,IFAIL,SIGN,ZORIGN,
     1                FXCOOR,FYCOOR,FZCOOR
      COMMON /SYSTEM/ SYSBUF,NOUT
      COMMON /NAMES / RD,RDREW,WRT,WRTREW,CLSREW,NOREW
      COMMON /ZZZZZZ/ IZ(1)
      COMMON /CONDAS/ PI,TWOPI,RADEG
      COMMON /UNPAKX/ TYPOUT,IR1,IR2,INCR
      EQUIVALENCE     (IZ(1),Z(1)),(IDATA(1),RDATA(1)),
     1                (IFILL(1),RFILL(1))
      DATA    NAME  / 4HALGP,4HR   /
      DATA    STREAM/ 3292, 92,292 /
      DATA    LEN   / 18, 24, 6    /
      DATA    IBLK  , IZERO,RZERO  / 4H    , 0, 0.0          /
      DATA    EDT   , EQEXIN,UGV,ALGDD,CSTM,BGPDT, SCR1,SCR2 /
     1        102   , 103   ,104,105  ,106 ,107  , 301 ,302  /
C
C
C     PERFORM GENERAL INITIALIZATION
C
      DEBUG =.FALSE.
      CALL SSWTCH (20,J)
      IF (J .EQ. 1) DEBUG =.TRUE.
      BUF1 = KORSZ(IZ) - SYSBUF
      BUF2 = BUF1 - SYSBUF
      LEFT = CORWDS(IZ(1),IZ(BUF2-1))
      M8   =-8
      IF (LEFT .LE. 0) CALL MESAGE (M8,0,NAME)
      IR1  = 1
      INCR = 1
      TYPOUT = 1
      IERR = 0
C
      IFILL(1) = IBLK
      IFILL(2) = IZERO
      RFILL(3) = RZERO
C
C     CREATE ALGDB WITH CORRECT LENGTH RECORDS -
C     BCD(18 WORDS), INTEGER(24 WORDS), REAL(6 WORDS)
C
      CALL GOPEN (ALGDD,IZ(BUF1),RDREW)
      CALL GOPEN (SCR2,IZ(BUF2),WRTREW)
      ITRL(1) = ALGDD
      CALL RDTRL (ITRL)
      ITRL(1) = SCR2
      CALL WRTTRL (ITRL)
    1 CALL READ (*7,*2,ALGDD,IDATA,99,1,NWAR)
    2 CALL ALGPB (IDATA(1),NTYPE)
      LENGTH = LEN(NTYPE)
C
C     REMOVE NUMERIC ZEROS FROM BCD STRING
C
      IF (NTYPE .NE. 1) GO TO 4
    3 IF (IDATA(NWAR) .NE. 0) GO TO 4
      NWAR = NWAR - 1
      IF (NWAR .GT.      0) GO TO 3
    4 IF (NWAR .GE. LENGTH) GO TO 6
      NWAR1 = NWAR + 1
      DO 5 I = NWAR1,LENGTH
    5 IDATA(I) = IFILL(NTYPE)
    6 CALL WRITE (SCR2,IDATA,LENGTH,1)
      GO TO 1
    7 CALL CLOSE (ALGDD,CLSREW)
      CALL CLOSE (SCR2,CLSREW)
      ALGDB = SCR2
C
C     IF UGV IS NOT IN FIST (PURGED) THEN THERE WILL BE NO DATA
C     MODIFICATION
C
      ITRL(1) = UGV
      CALL RDTRL (ITRL)
      IF (ITRL(1) .LT. 0) GO TO 997
C
C     READ EQEXIN INTO CORE
C
      FILE = EQEXIN
      CALL GOPEN (EQEXIN,IZ(BUF1),RDREW)
      CALL READ (*901,*10,EQEXIN,IZ(1),LEFT,1,NEQEX)
      CALL MESAGE (M8,0,NAME)
   10 CALL FREAD (EQEXIN,IZ(NEQEX+1),NEQEX,1)
      CALL CLOSE (EQEXIN,CLSREW)
      KN = NEQEX/2
      IF (DEBUG) CALL BUG1 ('EQEX    ',10,IZ(1),NEQEX)
      IF (DEBUG) CALL BUG1 ('EQEX    ',10,IZ(NEQEX+1),NEQEX)
C
C     READ CSTM INTO CORE (CSTM MAY BE PURGED)
C
      FILE  = CSTM
      ICSTM = 2*NEQEX + 1
      NCSTM = 0
      CALL OPEN (*30,CSTM,Z(BUF1),RDREW)
      CALL FWDREC (*901,CSTM)
      CALL READ (*901,*20,CSTM,IZ(ICSTM),BUF1-ICSTM,1,NCSTM)
      CALL MESAGE (M8,0,NAME)
   20 CALL CLOSE (CSTM,CLSREW)
      IF (DEBUG) CALL BUG1 ('CSTM    ',20,IZ(ICSTM),NCSTM)
C
C     SET-UP FOR CALLS TO TRANSS
C
      CALL PRETRS (IZ(ICSTM),NCSTM)
C
C     UNPACK UGV DISPLACEMENT VECTOR (SUBCASE 2) INTO CORE
C
   30 IVEC = ICSTM + NCSTM
      FILE = UGV
      ITRL(1) = FILE
      CALL RDTRL (ITRL)
C
C     CHECK FOR VALID UGV VECTOR
C     THIS ROUTINE WILL ONLY PROCESS A REAL S.P. RECT. VECTOR
C     OF SIZE G X 2
C     (EXPANDED TO INCLUDE REAL D.P. RECT. VECTOR, G X 2,
C     BY G.CHAN/UNISYS)
C
      NVECTS = ITRL(2)
      KFORM  = ITRL(4)
      KTYPE  = ITRL(5)
      IF (NVECTS.NE.2 .OR. KFORM.NE.2) GO TO 902
      IVECN = IVEC + KTYPE*ITRL(3) - 1
      IF (IVECN .GE. BUF1) CALL MESAGE (M8,0,NAME)
C
C     OPEN UGV AND SKIP FIRST COLUMN (SUBCASE 1)
C
      CALL GOPEN (UGV,IZ(BUF1),RDREW)
      CALL FWDREC (*901,UGV)
      IR2 = ITRL(3)
      CALL UNPACK (*40,UGV,IZ(IVEC))
      GO TO 60
C
C     NULL COLUMN
C
   40 DO 50 I = IVEC,IVECN
   50 Z(I) = 0.0
   60 CALL CLOSE (UGV,CLSREW)
      IF (DEBUG) CALL BUG1 ('UGV     ',60,IZ(IVEC),IR2)
C
C     LOCATE STREAML1 CARDS ON EDT AND STORE IN CORE
C
      FILE   = EDT
      ICHORD = IVECN + 1
      CALL PRELOC (*903,IZ(BUF1),EDT)
      CALL LOCATE (*904,IZ(BUF1),STREAM,IDX)
      CALL READ (*901,*70,EDT,IZ(ICHORD),BUF1-ICHORD,1,NCHORD)
      CALL MESAGE (M8,0,NAME)
   70 CALL CLOSE (EDT,CLSREW)
      IF (DEBUG) CALL BUG1 ('CHOR    ',70,IZ(ICHORD),NCHORD)
      LCHORD = ICHORD + NCHORD -1
C
C     READ THE BGPDT INTO CORE
C
      IBGPDT = LCHORD + 1
      FILE   = BGPDT
      CALL GOPEN (BGPDT,IZ(BUF1),RDREW)
      CALL READ (*901,*80,BGPDT,IZ(IBGPDT),BUF1-IBGPDT,1,NBGPDT)
      CALL MESAGE (M8,0,NAME)
   80 CALL CLOSE (BGPDT,CLSREW)
      IF (DEBUG) CALL BUG1 ('BGPD    ',80,IZ(IBGPDT),NBGPDT)
C
C     FOR EACH STREAML1 CARD -
C     (1) FIND BLADE NODES
C     (2) FIND EQUIVALENT INTERNAL NUMBERS OF THESE NODES
C     (3) LOCATE CORRESPONDING COMPONENTS OF DISPLACEMENT AND
C         CONVERT THEN TO BASIC VIA CSTM
C     (4) LOCATE BASIC GRID POINT DATA FOR BLADE NODES
C
      IC  = ICHORD + 1
      ICC = ICHORD
      JCHORD = 1
      NNODES = 0
  100 ISTATN = 0
  110 ID = IZ(IC)
      IF (ID .NE. -1) GO TO 120
      ICC = IC + 1
      IC  = IC + 2
      NNODES = NNODES + ISTATN
      JCHORD = JCHORD + 1
      IF (IC .GE. LCHORD) GO TO 150
      GO TO 100
  120 ISTATN = ISTATN + 1
      GO TO 1005
C
C     STORE BASIC GRID POINT COORDINATES FROM BGPDT
C
  130 XB(JCHORD,ISTATN) = Z(ICID+1)
      YB(JCHORD,ISTATN) = Z(ICID+2)
      ZB(JCHORD,ISTATN) = Z(ICID+3)
      DISPT1(JCHORD,ISTATN) = DISPT(1)
      DISPT2(JCHORD,ISTATN) = DISPT(2)
      DISPT3(JCHORD,ISTATN) = DISPT(3)
      DISPR1(JCHORD,ISTATN) = DISPR(1)
      DISPR2(JCHORD,ISTATN) = DISPR(2)
      DISPR3(JCHORD,ISTATN) = DISPR(3)
      IF (DEBUG) CALL BUG1 ('NODE    ',ID,Z(ICID+1),3)
      IF (DEBUG) CALL BUG1 ('NODE    ',ID,DISPT,3)
      IF (DEBUG) CALL BUG1 ('NODE    ',ID,DISPR,3)
      IC = IC + 1
      GO TO 110
  150 CONTINUE
      JCHORD = JCHORD - 1
      IF (JCHORD .GT. 21) GO TO 906
C
C     MODIFY AERODYNAMIC INPUT  (OPEN ALGDB DATA BLOCK)
C
      FILE = ALGDB
      CALL GOPEN (ALGDB,IZ(BUF1),RDREW)
      CALL FWDREC (*907,ALGDB)
      CALL READ (*901,*908,ALGDB,IDATA,2,1,NWAR)
      NAERO = IDATA(2)
      CALL SKPREC (ALGDB,1)
      CALL FREAD (ALGDB,IDATA,17,1)
      NLINES = IDATA(1)
      NSTNS  = IDATA(2)
      NSPEC  = IDATA(4)
      IPUNCH = IDATA(8)
      ISECN  = IDATA(9)
      IFCORD = IDATA(10)
      ISPLIT = IDATA(13)
      IRLE   = IDATA(15)
      IRTE   = IDATA(16)
      NSIGN  = IDATA(17)
      CALL SKPREC (ALGDB,1)
      DO 204 ISK = 1,NSTNS
      CALL FREAD (ALGDB,IDATA,2,1)
      KPTSA(ISK) = IDATA(1)
      IFANGS(ISK)= IDATA(2)
      CALL SKPREC (ALGDB,IDATA(1))
      DO 202 INL = 1,NLINES
      CALL FREAD (ALGDB,RDATA,2,1)
  202 BLAFOR(INL,ISK) = RDATA(2)
  204 CONTINUE
      DO 210 ISK = 1,NSPEC
      CALL FREAD (ALGDB,RDATA,6,1)
      ZR(ISK)  = RDATA(1)
      JZ(ISK)  = RDATA(1) + 0.4
      B1(ISK)  = RDATA(2)
      B2(ISK)  = RDATA(3)
      PP(ISK)  = RDATA(4)
      QQ(ISK)  = RDATA(5)
      RLE(ISK) = RDATA(6)
      CALL FREAD (ALGDB,RDATA,6,1)
      TC(ISK)  = RDATA(1)
      TE(ISK)  = RDATA(2)
      ZED(ISK) = RDATA(3)
      CORD(ISK)= RDATA(4)
      DELX(ISK)= RDATA(5)
      DELY(ISK)= RDATA(6)
      IF (ISECN.EQ.1 .OR. ISECN.EQ.3) CALL SKPREC (ALGDB,1)
  210 CONTINUE
      CALL CLOSE (ALGDB,CLSREW)
C
C     NUMBER OF BLADE STATIONS
C
      NBLSTN = IRTE - IRLE + 1
      IF (NLINES .NE. JCHORD) GO TO 909
      IF (NNODES .NE. NLINES*NBLSTN) GO TO 909
C
C     COMPUTE FCORD AND PHI
C
      DO 305 K = 1,NSPEC
      J    = JZ(K)
      TEMP = (XB(J,NBLSTN)-XB(J,1))**2 + (ZB(J,NBLSTN)-ZB(J,1))**2
      IF (IFCORD .EQ. 1) TEMP = TEMP   + (YB(J,NBLSTN)-YB(J,1))**2
      FCHORD(K) = CORD(K)/SQRT(TEMP)
      PHI(1,K)  = ATAN((ZB(J,2)-ZB(J,1))/(XB(J,2)-XB(J,1)))
      PHI(2,K)  = ATAN((ZB(J,NBLSTN)-ZB(J,NBLSTN-1))/
     1                 (XB(J,NBLSTN)-XB(J,NBLSTN-1)))
  305 CONTINUE
C     COMPUTE NEW COORDINATES
C     GENERATE XSTA, RSTA AND R , SET KPTS = NLINES
      DO 310 I = 1,NLINES
      DO 310 J = 1,NBLSTN
      XB(I,J) = XB(I,J) + SIGN*DISPT1(I,J)*FXCOOR
      YB(I,J) = YB(I,J) + SIGN*DISPT2(I,J)*FYCOOR
      ZB(I,J) = ZB(I,J) + SIGN*DISPT3(I,J)*FZCOOR
      XSTA(I,J) = XB(I,J)
      RSTA(I,J) = ZB(I,J) + ZORIGN
      R(I,J)  = RSTA(I,J)
  310 CONTINUE
C
C     COMPUTE CORD2
C
      DO 315 K = 1,NSPEC
      J    = JZ(K)
      TEMP = (XB(J,NBLSTN)-XB(J,1))**2 + (ZB(J,NBLSTN)-ZB(J,1))**2
      IF (IFCORD .EQ. 1) TEMP = TEMP   + (YB(J,NBLSTN)-YB(J,1))**2
      CORD2(K) = FCHORD(K)*SQRT(TEMP)
  315 CONTINUE
C
C     MODIFY B1, B2, RLE, TC, TE, CORD, DELX AND DELY
C
      I1 = (NBLSTN+1)/2
      I2 = I1
      IF (I1*2 .NE. NBLSTN+1) I2 = I2 + 1
      DO 318 K = 1,NSPEC
      J  = JZ(K)
      B1(K) = B1(K) - NSIGN*SIGN*RADEG*(DISPR3(J,1)*COS(PHI(1,K)) -
     1                                  DISPR1(J,1)*SIN(PHI(1,K)))
      B2(K) = B2(K) - NSIGN*SIGN*RADEG*(DISPR3(J,NBLSTN)*COS(PHI(2,K)) -
     1                                  DISPR1(J,NBLSTN)*SIN(PHI(2,K)))
      TEMP   = CORD(K)/CORD2(K)
      RLE(K) = RLE(K) *TEMP
      TC(K)  = TC(K)  *TEMP
      TE(K)  = TE(K)  *TEMP
      CORD(K) = CORD2(K)
      DELX(K) = DELX(K) + 0.5*SIGN*FXCOOR*(DISPT1(J,I1)+DISPT1(J,I2))
      DELY(K) = DELY(K) + 0.5*SIGN*FYCOOR*(DISPT2(J,I1)+DISPT2(J,I2))
  318 CONTINUE
C
C     GENERATE NEW ALGDB DATA BLOCK
C
      CALL GOPEN (ALGDB,IZ(BUF1),RDREW)
      CALL GOPEN (SCR1,IZ(BUF2),WRTREW)
      ITRL(1) = ALGDB
      CALL RDTRL (ITRL)
C
C     MODIFY THE NUMBER OF CARDS IN ALGDB
C
      NCDSX = 0
      DO 320 KPT = IRLE,IRTE
  320 NCDSX = NCDSX + NLINES - KPTSA(KPT)
      ITRL(2) = ITRL(2) + NCDSX
      ITRL(1) = SCR1
      CALL WRTTRL (ITRL)
      ASSIGN 322 TO RET2
      NREC = 5
      GO TO 1300
C
C     COPY DATA FOR STATIONS 1 THRU (IRLE-1)
C
  322 IF (IRLE .EQ. 1) GO TO 335
      NLES = IRLE - 1
      NREC = NLES + NLES*NLINES
      DO 324 IKP = 1,NLES
  324 NREC = NREC + KPTSA(IKP)
      ASSIGN 326 TO RET2
      GO TO 1300
C
C     SKIP OVER EXISTING RECORDS FOR STATIONS IRLE THRU IRTE
C
  326 NREC = NBLSTN + NBLSTN*NLINES
      DO 328 IKP = IRLE,IRTE
  328 NREC = NREC + KPTSA(IKP)
      CALL SKPREC (ALGDB,NREC)
C
C     CREATE NEW DATA RECORDS FOR STATIONS IRLE THRU IRTE
C
      KSTA = 0
      DO 334 JSTA = IRLE,IRTE
      KSTA = KSTA + 1
      IDATA(1) = NLINES
      IDATA(2) = IFANGS(JSTA)
      CALL WRITE (SCR1,IDATA,2,1)
      IF (DEBUG) CALL BUG1 ('ALGPR   ',329,IDATA,2)
      DO 330 I = 1,NLINES
      RDATA(1) = XSTA(I,KSTA)
      RDATA(2) = RSTA(I,KSTA)
      IF (DEBUG) CALL BUG1 ('ALGPR   ',330,RDATA,2)
  330 CALL WRITE(SCR1,RDATA,2,1)
      DO 332 I = 1,NLINES
      RDATA(1) = R(I,KSTA)
      RDATA(2) = BLAFOR(I,KSTA)
      IF (DEBUG) CALL BUG1 ('ALGPR   ',332,RDATA,2)
  332 CALL WRITE (SCR1,RDATA,2,1)
  334 CONTINUE
  335 CONTINUE
C
C     COPY DATA FOR STATIONS (IRTE+1) THRU NSTNS
C
      IF (IRTE .EQ. NSTNS) GO TO 338
      IRTE1 = IRTE  + 1
      IRTE2 = NSTNS - IRTE
      NREC  = IRTE2 + IRTE2*NLINES
      DO 336 IKP = IRTE1,NSTNS
  336 NREC  = NREC  + KPTSA(IKP)
      ASSIGN 338 TO RET2
      GO TO 1300
  338 CONTINUE
C
C     MODIFY THE NEXT NSPEC RECORDS
C
      DO 340 I = 1,NSPEC
      CALL SKPREC(ALGDB,2)
      RDATA(1) = ZR(I)
      RDATA(2) = B1(I)
      RDATA(3) = B2(I)
      RDATA(4) = PP(I)
      RDATA(5) = QQ(I)
      RDATA(6) = RLE(I)
      CALL WRITE (SCR1,RDATA,6,1)
      IF (DEBUG) CALL BUG1 ('ALGPR   ',338,RDATA,6)
      RDATA(1) = TC(I)
      RDATA(2) = TE(I)
      RDATA(3) = ZED(I)
      RDATA(4) = CORD(I)
      RDATA(5) = DELX(I)
      RDATA(6) = DELY(I)
      CALL WRITE (SCR1,RDATA,6,1)
      IF (DEBUG) CALL BUG1 ('ALGPR   ',339,RDATA,6)
      IF (ISECN.NE.1 .AND. ISECN.NE.3) GO TO 340
      CALL FREAD (ALGDB,RDATA,2,1)
      CALL WRITE (SCR1,RDATA,2,1)
      IF (DEBUG) CALL BUG1 ('ALGPR   ',340,RDATA,2)
  340 CONTINUE
C
C     COPY REST OF ANALYTIC DATA
C
      IF (ISPLIT .LT. 1) GO TO 344
      NREC = NSPEC
      DO 342 I = 1,NSTNS
      IF (IFANGS(I) .EQ. 2) NREC = NREC + NLINES
  342 CONTINUE
      ASSIGN 344 TO RET2
      GO TO 1300
  344 CONTINUE
      IF (NAERO.NE.1 .AND. IPUNCH.NE.1) GO TO 352
      NREC  = 1
      ASSIGN 346 TO RET2
      GO TO 1300
  346 NRAD  = IDATA(1)
      NDPTS = IDATA(2)
      NDATR = IDATA(3)
      ASSIGN 347 TO RET2
      NREC  = 2
      GO TO 1300
  347 NB = NBLSTN - 1
      I  = 1
  348 NREC = 1
      ASSIGN 349 TO RET2
      GO TO  1300
  349 NREC = IDATA(1)
      ASSIGN 350 TO RET2
      GO TO  1300
  350 I = I + 1
      IF (I .LE. NB) GO TO 348
      NREC = NRAD*(NDPTS+1) + NDATR
      ASSIGN 352 TO RET2
      GO TO  1300
C
C     PROCESS AERODYNAMIC INPUT
C
  352 IF (NAERO .EQ. 0) GO TO 366
      ASSIGN 354 TO RET2
      NREC  = 3
      GO TO 1300
  354 NSTNS = IDATA(1)
      NCASE = IDATA(6)
      NMANY = IDATA(16)
      NLE   = IDATA(19)
      NTE   = IDATA(20)
      NSIGN = IDATA(21)
      IF (NSTNS .EQ. 0) NSTNS = 11
      IF (NCASE .EQ. 0) NCASE = 1
      NREC  = NCASE + 3
      IF (NMANY .GT. 0) NREC = NCASE + 4
      ASSIGN 356 TO RET2
      GO TO  1300
  356 CONTINUE
C
C     COPY DATA FOR STATIONS 1 THRU (NLE-1)
C
      IF (NLE .EQ. 1) GO TO 361
      NLE1 = NLE - 1
      I    = 1
  357 NREC = 1
      ASSIGN 358 TO RET2
      GO TO  1300
  358 NREC = IDATA(1)
      ASSIGN 360 TO RET2
      GO TO  1300
  360 I = I + 1
      IF (I .LE. NLE1) GO TO 357
  361 JSTA = 0
C
C     MODIFY DATA FOR STATIONS NLE THRU NTE
C
      DO 364 I = NLE,NTE
      JSTA = JSTA + 1
      CALL FREAD (ALGDB,NSPEC,1,1)
      CALL SKPREC (ALGDB,NSPEC)
      CALL WRITE (SCR1,NLINES,1,1)
      IF (DEBUG) CALL BUG1 ('ALGPR   ',361,NLINS,1)
      DO 362 NL = 1,NLINES
      RDATA(1) = XSTA(NL,JSTA)
      RDATA(2) = RSTA(NL,JSTA)
      IF (DEBUG) CALL BUG1 ('ALGPR   ',362,RDATA,2)
  362 CALL WRITE (SCR1,RDATA,2,1)
  364 CONTINUE
C
C     COPY REST OF DATA
C
      ASSIGN 366 TO RET2
      NREC = 65000
      GO TO  1300
C
C     CLOSE ALGDB AND SCR1
C
  366 CALL CLOSE (ALGDB,CLSREW)
      CALL CLOSE (SCR1,CLSREW)
C
C     PUNCH NEW ALGDB TABLE INTO DTI CARDS IF PGEOM=3.
C
      IF (PGEOM .EQ. 3) CALL ALGAP (ALGDD,SCR1)
      GO TO 999
C
C
C     INTERNAL BINARY SEARCH ROUTINE
C
C     SEARCH EQEXIN FOR INTERNAL NUMBER AND SIL NUMBER OF EXTERNAL NODE
C
 1005 KLO = 1
      KHI = KN
 1010 K   = (KLO + KHI + 1) / 2
 1020 IF (ID - IZ(2*K-1)) 1030,1090,1040
 1030 KHI = K
      GO TO 1050
 1040 KLO = K
 1050 IF (KHI - KLO - 1)  905,1060,1010
 1060 IF (K .EQ. KLO) GO TO 1070
      K   = KLO
      GO TO 1080
 1070 K   = KHI
 1080 KLO = KHI
      GO TO 1020
 1090 INTN = IZ(2*K)
      ISIL = IZ(2*K+NEQEX)/10
      KODE = IZ(2*K+NEQEX) - 10*ISIL
      IF (DEBUG) CALL BUG1('ISTL    ',1090,ISIL,1)
      IF (DEBUG) CALL BUG1('KODE    ',1090,KODE,1)
C
C     LOCATE COORDINATE SYSTEM ID FOR THIS NODE IN THE BGPDT
C
      ICID = 4*(INTN-1) + IBGPDT
C
C     SET-UP COORDINATE SYSTEM TRANSFORMATION FOR DISPLACEMENTS.
C
      IF (IZ(ICID) .GT. 0) CALL TRANSS (IZ(ICID),TA)
C
C     COMPUTE POINTER INTO UGV
C     JVEC = IVEC + KTYPE *(ISIL-1)
C
      JVEC = IVEC + TYPOUT*(ISIL-1)
C
C     PICK-UP DISPLACEMENTS
C
      IF (KODE .EQ. 1) GO TO 1092
C
C     SCALAR POINT
C
      DISPT(1) = Z(JVEC)
      DISPT(2) = 0.0
      DISPT(3) = 0.0
      DISPR(1) = 0.0
      DISPR(2) = 0.0
      DISPR(3) = 0.0
      GO TO 1100
C
C     GRID POINT
C
 1092 IF (IZ(ICID) .GT. 0) GO TO 1094
C
C     DISPLACEMENTS ALREADY IN BASIC SYSTEM
C
      DISPT(1) = Z(JVEC  )
      DISPT(2) = Z(JVEC+1)
      DISPT(3) = Z(JVEC+2)
      DISPR(1) = Z(JVEC+3)
      DISPR(2) = Z(JVEC+4)
      DISPR(3) = Z(JVEC+5)
      GO TO 1100
C
C     DISPLACEMENTS MUST BE TRANSFORMED TO BASIC
C
 1094 CALL GMMATS (TA,3,3,0,Z(JVEC  ),3,1,0,DISPT)
      CALL GMMATS (TA,3,3,0,Z(JVEC+3),3,1,0,DISPR)
 1100 CONTINUE
      GO TO 130
 1300 DO 1304 ICOPY = 1,NREC
      CALL READ (*1306,*1302,ALGDB,IDATA,99,1,NWAR)
 1302 CALL WRITE (SCR1,IDATA,NWAR,1)
      IF (DEBUG) CALL BUG1 ('ALGPR   ',1302,IDATA,NWAR)
 1304 CONTINUE
      IF (NREC .LT. 65000) GO TO 1306
      WRITE  (NOUT,1305)
 1305 FORMAT (/,' *** NO. OF RECORDS EXCEEDS HARDWARE LIMIT/ALGPR')
      CALL MESAGE (-37,0,0)
 1306 GO TO RET2, (322,326,338,344,346,347,349,350,352,354,356,358,
     1             360,366)
C
  901 CALL MESAGE (-2,FILE,NAME)
      GO TO 998
  902 WRITE (NOUT,2001) UFM
      GO TO 998
  903 WRITE (NOUT,2002) UFM
      GO TO 998
  904 WRITE (NOUT,2003) UFM
      GO TO 998
  905 WRITE (NOUT,2004) UFM,IZ(ICC),ID
      GO TO 998
  906 WRITE (NOUT,2005) UWM
      GO TO 999
  907 WRITE (NOUT,2006) UFM
      GO TO 998
  908 CALL MESAGE (-3,FILE,NAME)
      GO TO 998
  909 WRITE (NOUT,2007) UFM
      GO TO 998
  997 IERR = 1
      GO TO 999
  998 IERR = -1
  999 RETURN
C
 2001 FORMAT (A23,' - ALG MODULE - UGV DATA BLOCK IS NOT A REAL S.P. ',
     1       'RECTANGULAR MATRIX OF ORDER G BY 2.')
 2002 FORMAT (A23,' - ALG MODULE - EDT DATA BLOCK MAY NOT BE PURGED.')
 2003 FORMAT (A23,' - ALG MODULE - STREAML1 BULK DATA CARD MISSING ',
     1       'FROM BULK DATA DECK.')
 2004 FORMAT (A23,' - ALG MODULE - STREAML1 BULK DATA CARD (SLN NO. =',
     1       I3,') REFERENCES UNDEFINED NODE NO.',I8)
 2005 FORMAT (A25,' - ALG MODULE - MORE THAN 21 STREAML1 CARDS READ. ',
     1       'FIRST 21 WILL BE USED.')
 2006 FORMAT (A23,' - ALG MODULE - ALGDB DATA BLOCK (FILE 105) DOES ',
     1       'NOT HAVE ENOUGH RECORDS.')
 2007 FORMAT (A23,' - ALG MODULE - INPUT IN ALGDB DATA BLOCK (FILE 105',
     1       ') INCONSISTENT WITH DATA ON STREAML1 BULK DATA CARDS.',
     2       /39X,'CHECK THE NUMBER OF COMPUTING STATIONS AND THE ',
     3       'NUMBER OF STREAMSURFACES ON THE BLADE.')
      END

      SUBROUTINE HDSOLV (IXR,J,XXX,CCC,II,NNO,NIT,X21,Y21,Z21,IIA,NC,
     1                   ZM,ZMI,LZ)
C
C     THIS SUBROUTINE SOLVES FOR THE LINES OF INTERSECTION RESULTING
C     FROM THE INTERSECTIONS OF THE JTH ELEMENT WITH THE OTHER
C     RELEVANT ELEMENTS.
C
C
C
      INTEGER         XCC,XASOLV,YASOLV,ZASOLV
      DIMENSION       XXX(1),CCC(1),NNO(1),ZM(1),ZMI(1),
     1                X21(1),Y21(1),Z21(1),IIA(1),IV(2)
      COMMON /HDPTRS/ XDUM,XCC,XASOLV,YASOLV,ZASOLV
      COMMON /ZZZZZZ/ RZ(1)
      COMMON /GO3   / L0,L1,L00,L01,L2,L3,L4,L5,L6,L7,L8,L9,L10,
     1                L11,L12,L13
C
      ERS = .015
      ER  =  ERS
      EXX = .015
      EXP = .015
      JT  = L12 + (J-1)*5
      JB  = L13 + (J-1)*LZ
      IF (II .EQ. 0) GO TO 80
      A3 = XXX(1+JT)
      B3 = XXX(2+JT)
      C3 = XXX(3+JT)
      D3 = XXX(4+JT)
      IF (XXX(JT+3) .EQ. 0.) GO TO 80
      DO 70 L = 1,II
      K  = NNO(L4+L)
C
C     CHECKS TO SEE IF THIS RELEVANT ELEMENT IS TO BE CONSIDERED FOR
C     INTERSECTION
C
      IF (K .GT. 0) GO TO 9
      GO TO 70
    9 CONTINUE
      IF (K .LT. J) GO TO 70
      JX = L12 + (K-1)*5
      IF (ZM(L2+J) .LT. ZMI(L3+K)) GO TO 70
      IF (ABS(XXX(3+JX)) .LT. ERS) GO TO 70
      MT = 0
      A4 = XXX(1+JX)
      B4 = XXX(2+JX)
      C4 = XXX(3+JX)
      D4 = XXX(4+JX)
C
C     DETERMINES THE EQUATION OF LINE OF INTERSECTION.
C
      B = A3*C4 - A4*C3
      A = B3*C4 - B4*C3
      C = D3*C4 - D4*C3
      IF (A.EQ.0. .AND. B.EQ.0.) GO TO 70
      IF (A .NE. 0.) GO TO 10
      A = 0
      C = C/B
      B = 1
      GO TO 20
   10 CONTINUE
      B = B/A
      C = C/A
      A = 1
   20 CONTINUE
      IV(1) = J
      IV(2) = K
      DO 60 M = 1,2
      JV = 1
      I  = IV(M)
      JJ = L13 + (I-1)*LZ
      IG = L12 + (I-1)*5 + 5
      NK = XXX(IG)
      DO 50 IX = 1,NK
      A1 = CCC(JV+  JJ)
      B1 = CCC(JV+1+JJ)
      C1 = CCC(JV+2+JJ)
C
C     CHECK TO BE SURE LINE OF INTERSECTION IS NOT BOUNDARY LINE
C     OF THE JTH SET.
C
      S  = A1 + B1 + C1
      S1 = A  + B  + C
      E  = ABS(S-S1)
      S  = A1*50 + B1*50 + C1
      S1 = A *50 + B *50 + C
      F  = ABS(S-S1)
      IF (F.LT.EXP .AND. E.LT.EXP) GO TO 70
C
C
C     DETERMINES THE POINTS OF INTERSECTIONS OF THE LINE OF INTERSECTION
C     WITH OTHER LINES OF RELEVANT ELEMENTS.
C
C
      T = A1*B - B1*A
      IF (ABS(T) .LT. ER) GO TO 50
      XO = (C1*A-C*A1)/T
      IF (A .NE. 0.) GO TO 30
      YO = -C1 - B1*XO
      GO TO 40
   30 CONTINUE
      YO = -C - B*XO
   40 CONTINUE
      T = XO
      IF (A1 .EQ. 0.) T = YO
      S  = T - CCC(JV+4+JJ)
      S1 = T - CCC(JV+3+JJ)
      IF (S*S1 .GT. 0.) GO TO 50
      MT = MT + 1
C
C     STORE THE PTS OF INTERSECTIONS.
C
      RZ(XASOLV-1+MT) = XO
      RZ(YASOLV-1+MT) = YO
      RZ(ZASOLV-1+MT) =-(D3+A3*XO+B3*YO)/C3
      ZT = -(D4+A4*XO+B4*YO)/C4
      IF (ABS(ZT-RZ(ZASOLV-1+MT)) .GT. EXX) GO TO 70
   50 JV = JV + 5
   60 CONTINUE
      CALL HDSTAT (MT,NIT,IXR,X21,Y21,Z21,IIA,IV,A,B,C,J,
     1             RZ(XASOLV),RZ(YASOLV),RZ(ZASOLV),CCC,XXX,LZ)
   70 CONTINUE
   80 CONTINUE
      NR = 5*XXX(5+JT)
      DO 90 IS = 1,NR
      RZ(XCC-1+IS) = CCC(IS+JB)
   90 CONTINUE
      XXX(5+JT) = XXX(5+JT) + NIT
      RETURN
      END

      SUBROUTINE AMGT1D (AJJ,TSONX,TAMACH,TREDF,NSTNS2)
C
C     TRANSONIC INTERPOLATION CODE FOR SWEPT TURBOPROPS.
C
      INTEGER SLN
      INTEGER TSONX(1)
C
      COMPLEX AJJ(NSTNS2,1)
C
      DIMENSION TAMACH(1),TREDF(1)
C
      COMMON /TAMG1L/IREF,MINMAC,MAXMAC,NLINES,NSTNS,REFSTG,REFCRD,
     1               REFMAC,REFDEN,REFVEL,REFSWP,SLN,NSTNSX,STAG,
     2               CHORD,DCBDZB,BSPACE,MACH,DEN,VEL,SWEEP,AMACH,
     3               REDF,BLSPC,AMACHR,TSONIC
      COMMON /AMGMN /MCB(7),NROW,DUM(2),REFC,SIGMA,RFREQ
C
      NUMM = 2 * NSTNS2 * NSTNS2
      DO 100 NLINE = 1,NLINES
      IF(TSONX(NLINE).EQ. 0) GO TO 100
      NS = 0
      IF(NLINE .EQ. 1) GO TO 90
      IF(TAMACH(NLINE) .GE. 1.0) GO TO 20
C       SUBSONIC
      IF(NLINE . EQ.2) NLINE1=1
      IF(NLINE . EQ.2) GO TO 93
   17 NLINE1 = NLINE -2
      NLINE2 = NLINE -1
      GO TO 70
C        SUPERSONIC
   20 IF( NLINE .EQ. NLINES) GO TO 17
      NS =1
      GO TO 90
   30 IF(NLINE1 .EQ. 0) GO TO 17
      IF(NLINE2 .NE. 0) GO TO 70
      NLINE2 = NLINE1
      NLINE1 = NLINE-1
   70 CALL INTERT(NLINE,NLINE1,NLINE2,NUMM,AJJ,TAMACH)
      GO TO 100
C       SEARCH FOR 1ST--2--KNOWN STREAMLINES
   90 NLINE1 = 0
   93 NLINE2 = 0
      NNLINE = NLINE + 1
      DO 96  I=NNLINE,NLINES
      IF(NLINE2 .NE. 0)  GO TO 97
      IF(TSONX(I).NE. 0) GO TO 96
      IF(NLINE1 .EQ. 0)  NLINE1 = I
      IF(NLINE1 .NE. I)  NLINE2 = I
   96 CONTINUE
   97 IF(NS .EQ. 0) GO TO 70
      GO TO 30
  100 CONTINUE
      RETURN
      END

      SUBROUTINE DDRMMA( SETUP )
C*****
C  UNPACKS DATA FROM A TRANSIENT OR FREQUENCY RESPONSE SOLUTION
C  COLUMN AS REQUIRED TO FORM ONE OFP OUTPUT LINE ENTRY.
C
C  BEFORE CALLING FOR ENTRY CONSTRUCTION ONE SETUP CALL IS REQUIRED
C  FOR EACH COLUMN. (SETUP = .TRUE.)
C*****
      REAL     LAMBDA   ,RBUFA(75),RBUFB(75)
C
      INTEGER BUF(150), BUFA(75), BUFB(75), ELWORK(300), PHASE, COMPLX
      INTEGER SCRT,BUFF,FILE,OUTFIL,SETID,DHSIZE,ENTRYS,FILNAM,PASSES
      INTEGER SETS,DEVICE,FORM,UVSOL
      INTEGER TYPOUT
      INTEGER SAVDAT,SAVPOS,BUFSAV
C
      LOGICAL  SETUP    ,TRNSNT   ,SORT2    ,COL1     ,FRSTID
      LOGICAL  LMINOR
C
      COMMON/STDATA/    LMINOR    ,NSTXTR   ,NPOS     ,SAVDAT(75)
     1                  ,SAVPOS(25)         ,BUFSAV(10)
      COMMON/DDRMC1/    IDREC(146),BUFF(6)  ,PASSES   ,OUTFIL   ,JFILE
     1                  ,MCB(7)   ,ENTRYS   ,SETS(5,3),INFILE   ,LAMBDA
     2                  ,FILE     ,SORT2    ,COL1     ,FRSTID   ,NCORE
     3                  ,NSOLS    ,DHSIZE   ,FILNAM(2),RBUF(150),IDOUT
     4                  ,ICC      ,NCC      ,ILIST    ,NLIST    ,NWDS
     5                  ,SETID    ,TRNSNT   ,I1       ,I2       ,PHASE
     6                  ,ITYPE1   ,ITYPE2   ,NPTSF    ,LSF      ,NWDSF
     7                  ,SCRT(7)  ,IERROR   ,ITEMP    ,DEVICE   ,FORM
     8                  ,ISTLST   ,LSTLST   ,UVSOL    ,NLAMBS   ,NWORDS
     9                  ,OMEGA    ,IPASS
      COMMON/CLSTRS/    COMPLX(1)
      COMMON/ZNTPKX/ A(4), IROW, IEOL, IEOR
C
      EQUIVALENCE(BUF(1),RBUF(1),BUFA(1),RBUFA(1))
     1          ,(RBUFB(1),BUFB(1),BUF(76))
C*****
C  PERFORM SOLUTION COLUMN SETUP WHEN SETUP = .TRUE.
C*****
      IF( .NOT. SETUP ) GO TO 10
      TYPOUT = 3
      IF( TRNSNT ) TYPOUT = 1
      ICOMP = 1
      CALL INTPK(*5,SCRT(6),0,TYPOUT,0)
      CALL ZNTPKI
      RETURN
    5 IROW = 0
      RETURN
C*****
C  FILL BUFFER WITH REAL AND OR COMPLEX VALUES.
C*****
   10 K = I1 - 1
      DO 20 I = 1,K
      BUFB(I) = BUFA(I)
   20 CONTINUE
      DO 70 I = I1,I2
      IF( ICOMP .EQ. IROW ) GO TO 30
      RBUFA(I) = 0.0
      RBUFB(I) = 0.0
      GO TO 60
C
C     NON-ZERO COMPONENT AVAILABLE.
C
   30 IF( .NOT. TRNSNT ) GO TO (31,32,33), IPASS
C
C     TRANSIENT RESPONSE
C
      RBUFA(I) = A(1)
      IF( IEOL ) 40,40,50
C
C     FREQUENCY RESPONSE FOR DISPLACEMENTS OR SPCFS PASS
C
   31 RBUFA(I) = A(1)
      RBUFB(I) = A(2)
      IF( IEOL ) 40,40,50
C
C     FREQUENCY RESPONSE VELOCITYS PASS
C
   32 RBUFA(I) = -OMEGA * A(2)
      RBUFB(I) =  OMEGA * A(1)
      IF( IEOL ) 40,40,50
C
C     FREQUENCY RESPONSE ACCELERATIONS PASS
C
   33 RBUFA(I) = OMEGA * A(1)
      RBUFB(I) = OMEGA * A(2)
      IF( IEOL ) 40,40,50
   40 CALL ZNTPKI
      GO TO 60
C
   50 IROW = 0
C
   60 ICOMP = ICOMP + 1
C
   70 CONTINUE
C*****
C  IF TRANSIENT (REAL) THEN RETURN. FOR FREQUENCY (COMPLEX) COMBINE DATA
C  FOR OUTPUT AND CONVERT TO MAGNITUDE PHASE IF NECESSARY.
C
C  BUFA CONTAINS THE REAL PART
C  BUFB CONTAINS THE IMAGINARY PART
C*****
      IF (TRNSNT) GO TO 81
      IF (ITYPE1 .EQ. 4)  GO TO 90
      IF (ITYPE1 .EQ. 5)  GO TO 81
C
C     POINT DATA
C
      DO 80 K = 1,6
      IF( FORM .EQ. 3 ) CALL MAGPHA( BUFA(K+2), BUFB(K+2) )
      BUFA(K+8) = BUFB(K+2)
   80 CONTINUE
      NWDSF = 14
      RETURN
C
C     ELEMENT STRESS OR FORCE DATA
C
   81 IF (LMINOR)  GO TO 90
      DO 82 K=1,NSTXTR
      J=SAVPOS(NPOS+K-1)
   82 BUF(J) = BUFSAV(K)
   90 IF (TRNSNT) RETURN
      IOUT = 0
      I = NPTSF
  100 NPT = COMPLX(I)
      IF( NPT ) 110,140,130
  110 NPT = -NPT
      IF( FORM .NE. 3 ) GO TO 130
C
C     COMPUTE MAGNITUDE PHASE
C
      CALL MAGPHA( BUFA(NPT), BUFB(NPT) )
  120 IOUT = IOUT + 1
      ELWORK(IOUT) = BUFA(NPT)
      I = I + 1
      GO TO 100
  130 IF( NPT .LE. LSF ) GO TO 120
      NPT = NPT - LSF
      IOUT = IOUT + 1
      ELWORK(IOUT) = BUFB(NPT)
      I = I + 1
      GO TO 100
C
C     MOVE OUTPUT DATA
C
  140 DO 150 I = 1,IOUT
      BUF(I) = ELWORK(I)
  150 CONTINUE
      NWDSF = IOUT
      RETURN
      END

      SUBROUTINE PLOADX
C
C     PLOADX BUILDS THE PRESSURE LOADS FROM A PLOADX CARD FOR THE
C     TRIAX6 ELEMENT
C
      INTEGER         SLT,IGD(1),ISLC(1),NAM(2)
      DIMENSION       SLC(5),GD(12),P(3),PN(3)
      COMMON /LOADX / LC,SLT
      COMMON /SSG1AX/ Z(1)
      COMMON /CONDSA/ PI
      EQUIVALENCE     (SLC(1),ISLC(1),P1),(SLC(2),P3),(GD(1),IGD(1))
      DATA    NAM   / 4HPLOA,4HDX    /
C
      CALL READ (*30,*40,SLT,SLC,5,0,FLAG)
      J  = 1
      DO 10 I = 1,3
      CALL FNDPNT (GD(J),ISLC(I+2))
   10 J  = J + 4
      RL = GD(10) - GD(2)
      ZL = GD(12) - GD(4)
C
C     LOADS IN NORMAL DIRECTION
C
      PN(1) = PI/30.*(9.0*GD( 2)*P1 + GD( 2)*P3 + GD(10)*P1 - GD(10)*P3)
      PN(2) = PI/7.5*(3.*(GD( 2)*P1 + GD(10)*P3)
     1              + 2.*(GD( 2)*P3 + GD(10)*P1))
      PN(3) = PI/30.*(9.0*GD(10)*P3 + GD( 2)*P3 + GD(10)*P1 - GD( 2)*P1)
C
      J = 1
      DO 20 I = 1,3
      P(1) =-ZL*PN(I)
      P(2) = 0.0
      P(3) = RL*PN(I)
C
C     CONVERT TO GLOBAL IF NEEDED, AND INSERT INTO THE LOAD VECTOR
C
      IF (IGD(J) .NE. 0) CALL BASGLB (P,P,GD(J+1),IGD(J))
      CALL FNDSIL (ISLC(I+2))
      K = ISLC(I+2)
      Z(K  ) = Z(K  ) + P(1)
      Z(K+1) = Z(K+1) + P(2)
      Z(K+2) = Z(K+2) + P(3)
   20 J = J + 4
      GO TO 60
C
C     ERROR MESSAGE
C
   30 J = -1
      GO TO 50
   40 J = -2
   50 CALL MESAGE (J,SLT,NAM)
C
   60 RETURN
      END

      SUBROUTINE DSOPFF ( DSNAME, IUNIT, ISTATUS )
      CHARACTER*80      DSNAME
      COMMON / SYSTEM / SYSBUF, IWR
      COMMON / MACHIN / MAC(3), LQRO
      INCLUDE          'DSIOF.COM'
      NBUFF4 = NBUFF * ( MOD(LQRO,100) / 10 )
      OPEN  ( UNIT=IUNIT, FILE=DSNAME, RECL=NBUFF4, FORM='UNFORMATTED'
     &,       ACCESS='DIRECT', IOSTAT=ISTATUS, ERR=701
     &,       STATUS='UNKNOWN' )
      GO TO 777
701   WRITE ( IWR, 901 ) IUNIT, ISTATUS, DSNAME
901   FORMAT(//,' FATAL ERROR IN DSOPFF, UNABLE TO OPEN UNIT=',I4
     &         ,' IOSTAT=',I5
     &       ,/,' FILE NAME=',A80 )
      ICCERR = ISTATUS
      CALL DSMSG  ( 101 )
      CALL MESAGE ( -61, 0, 0 )
777   RETURN
      END

        SUBROUTINE DSPRCL ( BLOCK )
      INCLUDE 'DSIOF.COM'
      INCLUDE 'XNSTRN.COM'
        INTEGER BLOCK( 15 )
        INTEGER IDIV( 4 )
        DATA    IDIV / 1, 2, 1, 2 /
        BLOCK(  2 ) = IAND( IBASE( INDCBP ), MASKQ4 )
        BLOCK(  3 ) = IAND( IBASE( INDCBP ), MASKQ3 )
        BLOCK(  3 ) = BLOCK( 3 ) / MULQ3
        BLOCK( 11 ) = NWRDEL( BLOCK( 2 ) )
        BLOCK( 12 ) = IBASE( INDCBP+1 )
        BLOCK( 14 ) = IDIV( BLOCK( 2 ) )
        RETURN
        END

      SUBROUTINE FEERDD
C*******
C
C     SUBROUTINE TO INITIALIZE COMMON /FEERCX/
C
C*******
      INTEGER            JFRCX(28)
      INTEGER            KFRCX( 4)
      INTEGER            LFRCX( 4)
C
      COMMON   /FEERCX/  IFRCX(37)
C
      DATA               JFRCX   /
     1                   101,6*0   ,102,6*0  ,201,6*0  ,202,6*0  /
      DATA               KFRCX   /
     1                   301       ,302      ,303      ,304      /
      DATA               LFRCX   /
     1                   305       ,306      ,307      ,308      /
      DATA               MFRCX   /   204   /
C
      DO 10 I = 1,28
   10 IFRCX(I) = JFRCX(I)
      DO 20 I = 1,4
      IFRCX(I+28) = KFRCX(I)
   20 IFRCX(I+32) = LFRCX(I)
      IFRCX(37) = MFRCX
C
      RETURN
      END

      SUBROUTINE AMP
C
C     THIS IS THE DMAP DRIVER FOR AMP
C
C     DMAP CALLING SEQUENCE
C
C     AMP  AJJL,SKJ,D1JK,D2JK,GTKA,PHIDH,D1JE,D2JE,USETA,AERO/
C          QHHL,QJHL/V,N,NOVE/V,N,XQHHL  $
C
C     D1JE AND D2JE MAY BE PURGED
C
C     QHHL AND QJHL ARE APPEND TYPE FILES
C
C     QJHL MAY BE PURGED
C
C     DATA BLOCK ASSIGNMENTS                           COMPUTED BY   USE
C
C     SCR1   --OLD QHHL                                AMPA        A,D
C     SCR2   --OLD QJHL                                AMPA        A,C
C     SCR3   --INDEX OF WORK TO BE DONE                AMPA        A,MOD
C     SCR4   --DJH1                                    AMPB        B,C
C     SCR5   --DJH2                                    AMPB        B,C
C     SCR6   --GKI                                     AMPB        B,D
C     SCR7   --DJH                                     AMPC        C,C
C     SCR8   --QJHUA                                   AMPC        C,D
C     SCR9   --SCRATCH FILE                                       B,C,D
C     SCR10  --SCRATCH FILE                                       B,C,D
C     SCR11  --SCRATCH FILE                                       B,C,D
C     SCR12  --SCRATCH FILE                                       C
C     SCR13  --SCRATCH FILE                                       C
C     SCR14  --SCRATCH FILE                                       C
C
C     VARIABLES
C     NAME          MEANING
C     -------      ---------------
C     NCOL          NUMBER OF COLUMNS IN SUBMATRIX OF AJJL
C     NSUB          ACTUAL NUMBER OF SUBMATRICES ON AJJL
C     XM            CURRENT M
C     XK            CURRENT K
C     AJJCOL        COLUMN NUMBER IN AJJL WHERE CURRENT SUBMATRIX STARTS
C     QHHCOL        COLUMN NUMBER IN QHH AND QJH WHERE SUBMATRIX STARTS
C                        0 MEANS RECOMPUTE
C     NGP           NUMBER OF GROUPS IN AJJL
C     NGPD          PAIRS FOR EACH GROUP - 1--THEORY -1 =D.L.
C                                          2--NUMBER OF COLUM
C                                          2--NUMBER OF COLS IN GROUP
C     NOH           NUMBER OF H D.O.F.
C     IDJH          FLAG TO RECOMPUTE DJH IF K CHANGES
C     IMAX          NUMBER OF M-K PAIRS
C     IANY          FLAG TO INDICATE SOME CALCULATION MUST BE PERFORMED
C     ITL           MAXIMUM TIME FOR ANY LOOP
C     XKO           OLD VALUE OF K
C
C
      INTEGER  AJJL,SKJ,D1JK,D2JK,GTKA,PHIDH,D1JE,D2JE,USETA,AERO,QHHL,
     1  QJHL,      SCR1,SCR2,SCR3,SCR4,SCR5,SCR6,SCR7,     SCR8,SCR9,
     2  SCR10,SCR11,SCR12,SCR13,SCR14,SYSBUF,XQHHL,AJJCOL,QHHCOL,
     3  MCB(7),NAME(2)
      INTEGER QHJL
      COMMON /SYSTEM/SYSBUF,NOUT
      COMMON /BLANK/NOUE,XQHHL,IGUST
      COMMON /AMPCOM/NCOL,NSUB,XM,XK,AJJCOL,QHHCOL,NGP,NGPD(2,30),
     1   MCBQHH(7),MCBQJH(7),NOH,IDJH
     1  ,MCBRJH(7)
      COMMON /CDCMPX/ISK(32),IB,IBBAR
      COMMON /ZZZZZZ/ IZ(1)
      DATA  AJJL,SKJ,D1JK,D2JK,GTKA,PHIDH,D1JE,D2JE,USETA,AERO/
     1      101 ,102 ,103 ,104 ,105 ,106 ,107 ,108 ,109 ,110 /
      DATA  QHHL,QJHL,NAME /201,202,4HAMP ,1H /
      DATA QHJL /203/
      DATA  SCR1,SCR2,SCR3,SCR4,SCR5,SCR6,SCR7,SCR8,SCR9,SCR10,SCR11,
     1SCR12,SCR13,SCR14/301,302,303,304,305,306,307,308,309,310,311,312,
     2 313,314 /
C
C     INITIALIZE
C
      IBUF1 = KORSZ(IZ) -SYSBUF+1
      MCB(1) = PHIDH
      CALL RDTRL(MCB(1))
      NOH=MCB(2)
      MCBRJH(1)=QHJL
      IB = 0
      IBBAR = 0
C
C     BUILD INDEXES
C
      CALL AMPA(AERO,QJHL,QHHL,AJJL,SCR1,SCR2,SCR3,IMAX,IANY)
C
C     COMPUTE DJH AND GKI
C
C
C     IF NO NEW VALUES ARE TO BE COMPUTED SKIP AMPB
C
      IF(IANY.NE.0)GO TO 90
      CALL AMPB(PHIDH,GTKA,D1JK,D2JK,D1JE,D2JE,USETA,SCR4,SCR5,SCR6,
     1 SCR9,SCR10,SCR11)
   90 CONTINUE
C
C     LOOP ON MK PAIRS
C
      XKO=-1.0
      IOP=0
      ITL=0
      DO 100 I = 1, IMAX
      CALL KLOCK(ITS)
      CALL GOPEN(SCR3,IZ(IBUF1),IOP)
      IOP=2
      CALL FREAD(SCR3,XM,4,1)
      CALL CLOSE(SCR3,2)
C
C     COMPUTE QJH
C
      IDJH=0
      IF(XK.EQ.XKO)IDJH=1
      CALL AMPC(SCR4,SCR5,SCR7,AJJL,QJHL,SCR2,SCR8,SCR9,SCR10,SCR11,
     1   SCR12,SCR13,SCR14)
      IF(QHHCOL .EQ. 0) XKO = XK
C
C     COMPUTE QHH
C
      IF(MCBQHH(1).LE.0)GO TO 50
      CALL AMPD(SCR8,SCR1,SKJ,SCR6,QHHL,SCR9,SCR10,SCR11,SCR12)
   50 CONTINUE
      IF(I.EQ.IMAX)GO TO 100
C
C     CHECK TIME
C
      CALL KLOCK(ITF)
      CALL TMTOGO(ITMTO)
      ITL=MAX0(ITF-ITS,1,ITL)
      IF(1.1*ITL.GE.ITMTO)GO TO 200
  100 CONTINUE
C
C     FINISH UP
C
  110 IF(MCBQHH(1).GT.0)CALL WRTTRL(MCBQHH)
      IF(MCBQJH(1).GT.0)CALL WRTTRL(MCBQJH)
      XQHHL=-1
      IF(IGUST .LE. 0) RETURN
C
C     COMPUTE QHJL
C          NOTE  QHJL IS REALLY QJHL
C
C     FIRST COMPUTE GKH ONTO SCR4
C
C
      CALL AMPE(PHIDH,GTKA,SCR4,SCR5,SCR6,USETA)
C
C     LOOP ON GROUPS WITHIN MK PAIRS FOR QHJL
C
      CALL AMPF(SKJ,SCR4,AJJL,QHJL,SCR3,IMAX,SCR5,SCR6,SCR7,SCR8,SCR9,
     1 SCR10,SCR11,SCR12,SCR13,SCR1)
      RETURN
C
C     INSUFFICIENT TIME TO COMPLETE
C
  200 CALL MESAGE(45,IMAX-I,NAME)
      GO TO 110
      END

      SUBROUTINE AMGROD(D,BETA)
      INTEGER NAME(2),SYSBUF
      INTEGER SCR1,SCR2,ECORE
C  D IS REALLY A 2-D ARRAY D(2,NTZS)
      DIMENSION D(1)
      COMMON /DLBDY/ NJ1,NK1,NP,NB,NTP,NBZ,NBY,NTZ,NTY,NT0,NTZS,NTYS,
     *   INC,INS,INB,INAS,IZIN,IYIN,INBEA1,INBEA2,INSBEA,IZB,IYB,
     *   IAVR,IARB,INFL,IXLE,IXTE,INT121,INT122,IZS,IYS,ICS,IEE,ISG,
     *   ICG,IXIJ,IX,IDELX,IXIC,IXLAM,IA0,IXIS1,IXIS2,IA0P,IRIA
     *  ,INASB,IFLA1,IFLA2,ITH1A,ITH2A,
     *   ECORE,NEXT,SCR1,SCR2,SCR3,SCR4,SCR5
      COMMON /ZZZZZZ / Z(1)
      COMMON /SYSTEM/ SYSBUF
      DATA NAME /4HAMGR,4HOD  /
      CALL SSWTCH(30,IPRNT)
      NFZB = 1
      NLZB = NBZ
      NFYB = NB+1-NBY
      NLYB = NB
      IBUF1 = ECORE - SYSBUF
C
C     CALCULATE DZ ON SCR1
C
      IF(NTZS.EQ.0) GO TO 100
      IF(NEXT+2*NTZS.GT.IBUF1) CALL MESAGE(-8,0,NAME)
      CALL GOPEN(SCR1,Z(IBUF1),1)
      IDZDY = 0
      CALL DZYMAT(D,NFZB,NLZB,NTZS,IDZDY,SCR1,Z(IX),BETA,IPRNT,Z(INB),
     * Z(INC),Z(IYS),Z(IZS),Z(ISG),Z(ICG),Z(IYB),Z(IZB),Z(INBEA1))
      CALL CLOSE(SCR1,1)
  100 IF(NTYS.EQ.0) GO TO 200
      IF(NEXT+2*NTYS.GT.IBUF1) CALL MESAGE(-8,0,NAME)
      CALL GOPEN(SCR2,Z(IBUF1),1)
      IDZDY = 1
      CALL DZYMAT(D,NFYB,NLYB,NTYS,IDZDY,SCR2,Z(IX),BETA,IPRNT ,Z(INB),
     * Z(INC),Z(IYS),Z(IZS),Z(ISG),Z(ICG),Z(IYB),Z(IZB),Z(INBEA1))
      CALL CLOSE(SCR2,1)
  200 RETURN
      END

      SUBROUTINE SMA2A
C
C     THIS SUBROUTINE FORMERLY GENERATED THE MGG AND BGG MATRICES FOR
C     THE SMA2 MODULE.  THESE OPERATIONS ARE NOW PERFORMED IN THE EMG
C     AND EMA MODULES AND SMA2A IS RETAINED IN SKELETAL FORM TO PROVIDE
C     A VEHICLE FOR USER-SUPPLIED ELEMENTS.
C
      LOGICAL          HEAT
      INTEGER          IZ(1),EOR,CLSRW,CLSNRW,FROWIC,SYSPRT,TNROWS,
     1                 OUTRW
      DOUBLE PRECISION DZ,DPWORD
      DIMENSION        INPVT(2),DZ(1),NAME(2)
      CHARACTER        UFM*23
      COMMON /XMSSG /  UFM
      COMMON /BLANK /  WTMASS,NOMGG,NOBGG,ICMAS,ICMBAR,ICMROD,ICMQD1,
     1                 ICMQD2,ICMTR1,ICMTR2,ICMTUB,ICMQDP,ICMTRP,ICMTRB
      COMMON /SMA2HT/  HEAT
      COMMON /SYSTEM/  ISYS,ISEW1(53),IPREC
      COMMON /SMA2IO/  IFCSTM,IFMPT,IFDIT,IDUM1,IFECPT,IGECPT,IFGPCT,
     1                 IGGPCT,IDUM2,IDUM3,IFMGG,IGMGG,IFBGG,IGBGG,IDUM4,
     2                 IDUM5,INRW,OUTRW,CLSNRW,CLSRW,NEOR,EOR,MCBMGG(7),
     3                 MCBBGG(7)
      COMMON /ZZZZZZ/  Z(1)
      COMMON /SMA2BK/  ICSTM,NCSTM,IGPCT,NGPCT,IPOINT,NPOINT,I6X6M,
     1                 N6X6M,I6X6B,N6X6B
      COMMON /SMA2CL/  IOPTB,BGGIND,NPVT,LLEFT,FROWIC,LROWIC,NROWSC,
     1                 TNROWS,JMAX,NLINKS,LINK(10),NOGO
      COMMON /GPTA1 /  NELEMS,LAST,INCR,NE(1)
      COMMON /SMA2ET/  ECPT(200)
      COMMON /ZBLPKX/  DPWORD,DUM(2),INDEX
      EQUIVALENCE      (Z(1),IZ(1),DZ(1))
      DATA    NAME  /  4HSMA2,4HA   /
C
      IPR = IPREC
C
C     READ THE FIRST TWO WORDS OF NEXT GPCT RECORD INTO INPVT(1).
C     INPVT(1) IS THE PIVOT POINT.  INPVT(1) .GT. 0 IMPLIES THE PIVOT
C     POINT IS A GRID POINT.  INPVT(1) .LT. 0 IMPLIES THE PIVOT POINT
C     IS A SCALAR POINT.  INPVT(2) IS THE NUMBER OF WORDS IN THE
C     REMAINDER OF THIS RECORD OF THE GPCT.
C
   10 CALL READ (*1000,*700,IFGPCT,INPVT(1),2,NEOR,IFLAG)
      NGPCT = INPVT(2)
      CALL READ (*1000,*3000,IFGPCT,IZ(IGPCT+1),NGPCT,EOR,IFLAG)
C
C     FROWIC IS THE FIRST ROW IN CORE. (1 .LE. FROWIC .LE. 6)
C
      FROWIC = 1
C
C     DECREMENT THE AMOUNT OF CORE REMAINING.
C
      LEFT = LLEFT - 2*NGPCT
      IF (LEFT .LE. 0) GO TO 3003
      IPOINT = IGPCT + NGPCT
      NPOINT = NGPCT
      I6X6M  = IPOINT + NPOINT
      I6X6M  = (I6X6M-1)/2 + 2
C
C     CONSTRUCT THE POINTER TABLE, WHICH WILL ENABLE SUBROUTINE INSERT
C     TO ADD THE ELEMENT MASS AND/OR DAMPING MATRICES TO MGG AND/OR BGG.
C
      IZ(IPOINT+1) = 1
      I1 = 1
      I  = IGPCT
      J  = IPOINT + 1
   30 I1 = I1 + 1
      IF (I1 .GT. NGPCT) GO TO 40
      I  = I + 1
      J  = J + 1
      INC = 6
      IF (IZ(I) .LT. 0) INC = 1
      IZ(J) = IZ(J-1) + INC
      GO TO 30
C
C     JMAX = THE NUMBER OF COLUMNS OF MGG THAT WILL BE GENERATED WITH
C     THE CURRENT GRID POINT.
C
   40 INC   = 5
      ILAST = IGPCT  + NGPCT
      JLAST = IPOINT + NPOINT
      IF (IZ(ILAST) .LT. 0) INC = 0
      JMAX = IZ(JLAST) + INC
C
C     TNROWS = THE TOTAL NUMBER OF ROWS OF THE MATRIX TO BE GENERATED
C              FOR THE CURRENT PIVOT POINT.
C     TNROWS = 6 IF THE CURRENT PIVOT POINT IS A GRID POINT.
C     TNROWS = 1 IF THE CURRENT PIVOT POINT IS A SCALAR POINT.
C
      TNROWS = 6
      IF (INPVT(1) .LT. 0) TNROWS = 1
C
C     IF 2*TNROWS*JMAX .LT. LEFT THERE ARE NO SPILL LOGIC PROBLEMS FOR
C     THE MGG SINCE THE WHOLE DOUBLE PRECISION SUBMATRIX OF ORDER
C     TNROWS*JMAX CAN FIT IN CORE.
C
      ITEMP = TNROWS*JMAX
      IF (2*ITEMP .LT. LEFT) GO TO 80
      CALL MESAGE (30,86,INPVT)
C
C     THE WHOLE MATRIX CANNOT FIT IN CORE, DETERMINE HOW MANY ROWS CAN
C     FIT. IF TNROWS = 1, WE CAN DO NOTHING FURTHER.
C
      IF (TNROWS .EQ. 1) GO TO 3003
      NROWSC = 3
   70 IF (2*NROWSC*JMAX .LT. LEFT) GO TO 90
      NROWSC = NROWSC - 1
      IF (NROWSC .EQ. 0) CALL MESAGE (-8,0,NAME)
      GO TO 70
   80 NROWSC = TNROWS
   90 FROWIC = 1
C
C     LROWIC IS THE LAST ROW IN CORE. (1 .LE. LROWIC .LE. 6)
C
      LROWIC = FROWIC + NROWSC - 1
C
C     ZERO OUT THE MGG SUBMATRIX IN CORE
C
  100 LOW = I6X6M + 1
      LIM = I6X6M + JMAX*NROWSC
      DO 115 I = LOW,LIM
  115 DZ(I) = 0.0D0
C
C     CHECK TO SEE IF BGG MATRIX IS DESIRED.
C
      IF (IOPTB .EQ. 0) GO TO 137
C
C     SINCE THE BGG MATRIX IS TO BE COMPUTED,DETERMINE WHETHER OR NOT IT
C     TOO CAN FIT IN CORE.
C
      IF (NROWSC .NE. TNROWS) GO TO 120
      IF (4*TNROWS*JMAX .LT. LEFT) GO TO 130
C
C     OPEN A SCRATCH FILE FOR BGG
C
  120 CALL MESAGE (-8,0,NAME)
C
C     THIS CODE TO BE FILLED IN LATER
C     ===============================
C
  130 I6X6B = I6X6M + JMAX*TNROWS
      LOW = I6X6B + 1
      LIM = I6X6B + JMAX*TNROWS
      DO 135 I = LOW,LIM
  135 DZ(I) = 0.0D0
C
C     INITIALIZE THE LINK VECTOR TO -1.
C
  137 DO 140 I = 1,NLINKS
  140 LINK(I) = -1
C
C     TURN FIRST PASS INDICATOR ON.
C
  150 IFIRST = 1
C
C     READ THE 1ST WORD OF THE ECPT RECORD, THE PIVOT POINT, INTO NPVT.
C
      CALL FREAD (IFECPT,NPVT,1,0)
C
C     READ THE NEXT ELEMENT TYPE INTO THE CELL ITYPE.
C
  160 CALL READ (*3025,*500,IFECPT,ITYPE,1,NEOR,IFLAG)
      IF (ITYPE.GE.53 .AND. ITYPE.LE.61) GO TO 165
      CALL PAGE2 (-3)
      SYSPRT = ISEW1(1)
      WRITE  (SYSPRT,161) UFM,ITYPE
  161 FORMAT (A23,' 2202, ELEMENT TYPE',I4,' NO LONGER SUPPORTED BY ',
     1       'SMA2 MODULE.', /5X,
     2       'USE EMG AND EMA MODULES FOR ELEMENT MATRIX GENERATION')
      NOGO = 1
      GO TO 1000
  165 CONTINUE
C
C     READ THE ECPT ENTRY FOR THE CURRENT TYPE INTO THE ECPT ARRAY. THE
C     NUMBER OF WORDS TO BE READ WILL BE NWORDS(ITYPE).
C
      IDX = (ITYPE-1)*INCR
      CALL FREAD (IFECPT,ECPT,NE(IDX+12),0)
      ITEMP = NE(IDX+23)
C
C     IF THIS IS THE 1ST ELEMENT READ ON THE CURRENT PASS OF THE ECPT
C     CHECK TO SEE IF THIS ELEMENT IS IN A LINK THAT HAS ALREADY BEEN
C     PROCESSED.
C
      IF (IFIRST .EQ. 1) GO TO 170
C
C     THIS IS NOT THE FIRST PASS.  IF ITYPE(TH) ELEMENT ROUTINE IS IN
C     CORE, PROCESS IT.
C
      IF (ITEMP .EQ. LINCOR) GO TO 180
C
C     THE ITYPE(TH) ELEMENT ROUTINE IS NOT IN CORE.  IF THIS ELEMENT
C     ROUTINE IS IN A LINK THAT ALREADY HAS BEEN PROCESSED READ THE NEXT
C     ELEMENT.
C
      IF (LINK(ITEMP) .EQ. 1) GO TO 160
C
C     SET A TO BE PROCESSED LATER FLAG FOR THE LINK IN WHICH THE ELEMENT
C     RESIDES
C
      LINK(ITEMP) = 0
      GO TO 160
C
C     SINCE THIS IS THE FIRST ELEMENT TYPE TO BE PROCESSED ON THIS PASS
C     OF THE ECPT RECORD, A CHECK MUST BE MADE TO SEE IF THIS ELEMENT
C     IS IN A LINK THAT HAS ALREADY BEEN PROCESSED.  IF IT IS SUCH AN
C     ELEMENT, WE KEEP IFIRST = 1 AND READ THE NEXT ELEMENT.
C
  170 IF (LINK(ITEMP) .EQ. 1) GO TO 160
C
C     SET THE CURRENT LINK IN CORE = ITEMP AND IFIRST = 0
C
      LINCOR = ITEMP
      IFIRST = 0
      ITYPX  = ITYPE - 52
C
C     CALL THE PROPER ELEMENT ROUTINE.
C
  180 GO TO (
C                                  CDUM1   CDUM2   CDUM3   CDUM4
C                                    53      54      55      56
     7                               4983,   4984,   4985,   4986,
C          CDUM5   CDUM6   CDUM7   CDUM8   CDUM9
C            57      58      59      60      61
     8     4987,   4988,   4989,   4990,   4991  ) , ITYPX
C
C
 4983 CALL MDUM1
      GO TO 160
 4984 CALL MDUM2
      GO TO 160
 4985 CALL MDUM3
      GO TO 160
 4986 CALL MDUM4
      GO TO 160
 4987 CALL MDUM5
      GO TO 160
 4988 CALL MDUM6
      GO TO 160
 4989 CALL MDUM7
      GO TO 160
 4990 CALL MDUM8
      GO TO 160
 4991 CALL MDUM9
      GO TO 160
C
C     AT STATEMENT NO. 500 WE HAVE HIT AN EOR ON THE ECPT FILE.  SEARCH
C     THE LINK VECTOR TO DETERMINE IF THERE ARE LINKS TO BE PROCESSED.
C
  500 LINK(LINCOR) = 1
      DO  510 I = 1,NLINKS
      IF (LINK(I) .EQ. 0) GO TO 520
  510 CONTINUE
      GO TO 525
C
C     SINCE AT LEAST ONE LINK HAS NOT BEEN PROCESSED THE ECPT FILE MUST
C     BE BACKSPACED.
C
  520 CALL BCKREC (IFECPT)
      GO TO 150
C
C     CHECK NOGO = 1 SKIP BLDPK
C
  525 IF (NOGO .EQ. 1) GO TO 10
C
C     AT THIS POINT BLDPK THE NUMBER OF ROWS IN CORE UNTO THE MGG FILE.
C
      ASSIGN 580 TO IRETRN
C
C     HEAT TRANSFER PROBLEM, SKIP MGG
C
      IF (HEAT) GO TO 580
C
      IFILE = IFMGG
      IMCB  = 1
C
C     MULTIPLY THE MASS MATRIX BY THE PARAMETER WTMASS IF IT IS NOT
C     UNITY
C
      IF (WTMASS .EQ. 1.0) GO TO 530
      LOW = I6X6M + 1
      LIM = I6X6M + JMAX*NROWSC
      DO 527 I = LOW,LIM
  527 DZ(I) = DZ(I)*WTMASS
  530 I1  = 0
  540 I2  = 0
      IBEG = I6X6M + I1*JMAX
      CALL BLDPK (2,IPR,IFILE,0,0)
  550 I2 = I2 + 1
      IF (I2 .GT. NGPCT) GO TO 570
      JJ = IGPCT + I2
      INDEX = IABS(IZ(JJ)) - 1
      LIM = 6
      IF (IZ(JJ) .LT. 0) LIM = 1
      JJJ = IPOINT + I2
      KKK = IBEG + IZ(JJJ) - 1
      I3 = 0
  560 I3 = I3 + 1
      IF (I3 .GT. LIM) GO TO 550
      INDEX = INDEX + 1
      KKK = KKK + 1
      DPWORD = DZ(KKK)
      IF (DPWORD .NE. 0.0D0) CALL ZBLPKI
      GO TO 560
  570 CALL BLDPKN (IFILE,0,MCBMGG(IMCB))
      I1 = I1 + 1
      IF (I1 .LT. NROWSC) GO TO 540
      GO TO IRETRN, (580,600)
C
C     IF THE BGG IS CALLED FOR BLDPK IT.
C
  580 IF (IOPTB .EQ.  0) GO TO 600
      IF (IOPTB .EQ. -1) GO TO 590
C
C     THE BGG MATRIX IS IN CORE
C
      ASSIGN 600 TO IRETRN
      I6X6M = I6X6B
      IFILE = IFBGG
      IMCB  = 8
      GO TO 530
C
C     HERE WE NEED LOGIC TO READ BGG FROM A SCRATCH FILE AND INSERT
C
  590 CONTINUE
C
C     TEST TO SEE IF THE LAST ROW IN CORE, LROWIC, = THE TOTAL NO. OF
C     ROWS TO BE COMPUTED, TNROWS.  IF IT IS, WE ARE DONE.  IF NOT, THE
C     ECPT MUST BE BACKSPACED.
C
  600 IF (LROWIC .EQ. TNROWS) GO TO 10
      CALL BCKREC (IFECPT)
      FROWIC = FROWIC + NROWSC
      LROWIC = LROWIC + NROWSC
      GO TO 100
C
C     CHECK NOGO = 1 SKIP BLDPK
C
  700 IF (NOGO .EQ. 1) GO TO 10
C
C     HERE WE HAVE A PIVOT POINT WITH NO ELEMENTS CONNECTED, SO THAT
C     NULL COLUMNS MUST BE OUTPUT ON THE MGG AND BGG FILES.
C
      LIM = 6
      IF (INPVT(1) .LT. 0) LIM = 1
      DO 710 I = 1,LIM
      IF (HEAT) GO TO 705
      CALL BLDPK (2,IPR,IFMGG,0,0)
      CALL BLDPKN (IFMGG,0,MCBMGG)
  705 IF (IOPTB .NE. 1) GO TO 710
      CALL BLDPK (2,IPR,IFBGG,0,0)
      CALL BLDPKN (IFBGG,0,MCBBGG)
  710 CONTINUE
      CALL SKPREC (IFECPT,1)
      GO TO 10
C
C     RETURN SINCE AN EOF HAS BEEN HIT ON THE GPCT FILE
C
 1000 IF (NOGO .EQ.1) CALL MESAGE (-61,0,NAME)
      RETURN
C
C     ERROR RETURNS
C
 3000 IFILE = IFGPCT
      IPARM = 3
      GO TO 4010
 3003 CALL MESAGE (-8,IFILE,NAME)
 3025 IFILE = IFECPT
      IPARM = 2
 4010 CALL MESAGE (-IPARM,IFILE,NAME)
      CALL MESAGE (-30,87,ITYPE)
      RETURN
C
      END

      SUBROUTINE TYPFLT (X,Y,XYD,V,FIELD,OPT)
C
C
C     (X,Y) = STARTING OR ENDING POINT OF THE NUMBER TO BE TYPED (ALWAYS
C             LEFT-TO-RIGHT OR TOP-TO-BOTTOM).
C     XYD   = +/-1 IF X = STARTING OR ENDING POINT OF THE NUMBER.
C           = +/-2 IF Y = STARTING OR ENDING POINT OF THE NUMBER.
C     V     = REAL NUMBER TO BE TYPED.
C     FIELD = FIELD WIDTH OF THE NUMBER (IF POSITIVE, THE NUMBER WILL BE
C             CENTERED AT (X,Y) - IF NEGATIVE, THE NUMBER WILL BE TYPED
C             STARTING OR ENDING AT (X,Y) - IF XYD = 1 OR 2, THE NUMBER
C             WILL BE TYPED IN THE X OR Y DIRECTION).
C     OPT   = -1 TO INITIATE  THE TYPING MODE.
C           = +1 TO TERMINATE THE TYPING MODE.
C           =  0 TO TYPE THE NUMBER.
C
      INTEGER          PLOTER,DIR,EXP,D(9),C(100),ASTER,DECPNT,PLUS,
     1                 MINUS,FW,EXPFLD,TRA,XYD,FIELD,OPT
      DOUBLE PRECISION VAL,Z
      COMMON /PLTDAT/  MODEL,PLOTER,SKPPLT(18),SKPA(3),CNTX,CNTY
      DATA    ASTER ,  DECPNT,PLUS,MINUS / 41,44,39,40 /
      DATA    TENM2 ,  TEN7,TEN8  / 1.E-2, 1.E7, 1.E8  /
C
      IF (OPT .EQ. 0) GO TO 20
      CALL TIPE (0,0,0,0,0,OPT)
      GO TO 200
   20 VAL = ABS(V)
      FW  = MIN0(25,IABS(FIELD))
      IF (FW .EQ. 0) GO TO 200
      DO 21 I = 1,FW
      C(I) = 1
   21 CONTINUE
      EXP = 0
      IF (V .NE. 0.) GO TO 30
C
C     INPUT VALUE = 0.
C
      FW   = MIN0(FW,2)
      NSIG = 1
      C(2) = DECPNT
      GO TO 150
C
   30 EXPFLD = 0
      IF (V .LT. 0.) GO TO 35
C
C     SINCE -V- IS POSITIVE, THE NUMBER WILL BE UNSIGNED. IF FIELD.GT.4,
C     THE NUMBER OF SIGNIFICANT DIGITS TYPED WILL BE AT LEAST -FIELD-4-.
C     IF FIELD.LE.4, -FIELD-1-.
C
      NSIG = FW - 4
      IF (NSIG) 40,40,100
C
C     SINCE -V- IS NEGATIVE, THE NUMBER WILL BE SIGNED.  IF FIELD.GT.5,
C     THE NUMBER OF SIGNIFICANT DIGITS TYPED WILL BE AT LEAST -FIELD-5-.
C     IF FIELD.LE.5, -FIELD-2-.
C
   35 NSIG = FW - 5
      IF (NSIG) 40,40,100
C
C     THE NUMBER WILL BE TYPED WITHOUT AN EXPONENT.
C
   40 NSIG = NSIG + 3
      EXPFLD = 1
C
C     THE NUMBER MUST FIRST BE MULTIPLIED BY SOME POWER OF TEN (EXP)
C     SUCH THAT THE PRODUCT IS BETWEEN 10**7 AND 10**8 SO THAT IT
C     CAN BE EXPRESSED AS AN 8-SIGNIFICANT DIGIT INTEGER.
C
  100 Z = 10.D0**IABS(EXP)
      IF (EXP .LT. 0) A = VAL/Z
      IF (EXP .GE. 0) A = VAL*Z
      IF (A .GE. TENM2) GO TO 105
C
C     A .LT. 10**-2
C
      EXP = EXP + 10
      GO TO 100
C
  105 IF (A.GE.TEN7 .AND. A.LT.TEN8) GO TO 115
      IF (A .LT. TEN7) GO TO 110
C
C     A .GE. 10**8
C
      EXP = EXP - 10
      GO TO 100
C
C     A .GE. 10**-2  AND  .LT. 10**7
C
  110 EXP = EXP + 1
      GO TO 100
C
C     A .GE. 10**7  AND  .LT. 10**8  (SEPARATE THE 8 SIGNIFICANT DIGITS)
C
  115 NUM = A
      EXP = -EXP + 7
      DO 116 I = 1,8
      J   = NUM/10**(8-I)
      D(I)= J + 1
      NUM = NUM - J*10**(8-I)
  116 CONTINUE
      IF (EXPFLD .NE. 0) GO TO 130
      IF (EXP.GE.-4 .AND. EXP.LE.NSIG+2) GO TO 135
C
C     USE STANDARD FORMAT (-X.XXX-XX)
C
      NSIG = MIN0(NSIG,8)
      ASSIGN 120 TO TRA
      GO TO 180
  120 N = 0
      IF (V .GT. 0.) GO TO 121
      C(1) = MINUS
      N = 1
  121 C(N+1) = D(1)
      C(N+2) = DECPNT
      N = N + 2
      IF (NSIG .EQ. 1) GO TO 124
      DO 123 I = 2,NSIG
      N = N + 1
      C(N) = D(I)
  123 CONTINUE
  124 IF (EXP .GE. 0) C(N+1) = PLUS
      IF (EXP .LT. 0) C(N+1) = MINUS
      N = N + 1
      NUM = IABS(EXP)
      DO 125 I = 1,2
      J = NUM/10**(2-I)
      N = FW - (2-I)
      C(N) = J + 1
      NUM = NUM - J*10**(2-I)
  125 CONTINUE
      GO TO 150
C
C     STANDARD FORMAT CANNOT BE USED.
C
  130 IF (EXP.LT.NSIG .AND. EXP.GE.-NSIG) GO TO 136
      DO 131 I = 1,FW
      C(I) = ASTER
  131 CONTINUE
      GO TO 150
C
C     THE NUMBER CAN BE EXPRESSED WITHOUT AN EXPONENT.
C
  135 NSIG = MIN0(8,NSIG+3)
  136 ASSIGN 137 TO TRA
      GO TO 180
  137 N = 1
      IF (V .GT. 0.) GO TO 138
      C(1) = MINUS
      N = 2
  138 IF (EXP .GE. 0) GO TO 144
C
C     NEGATIVE EXPONENT
C
      J = NSIG
  141 D(J+1) = D(J)
      J = J - 1
      IF (J .NE. 0) GO TO 141
      D(1) = 1
      ASSIGN 142 TO TRA
      IF (NSIG+N .GE. FW) GO TO 180
      NSIG = NSIG + 1
  142 C(N+0) = D(1)
      C(N+1) = DECPNT
      N = N + 1 + IABS(EXP)
      DO 143 I = 2,NSIG
      C(N) = D(I)
      N = N + 1
  143 CONTINUE
      GO TO 150
C
C     POSITIVE EXPONENT.
C
  144 ASSIGN 145 TO TRA
      IF (NSIG+N .GE. FW) GO TO 180
  145 J = EXP + 1
      DO 146 I = 1,J
      C(N) = D(I)
      N = N + 1
  146 CONTINUE
      C(N) = DECPNT
      J = J + 1
      IF (J .GT. NSIG) GO TO 150
      DO 147 I = J,NSIG
      N = N + 1
      C(N) = D(I)
  147 CONTINUE
C
  150 XX = X
      YY = Y
      IF (FIELD.GT.0 .AND. NSIG.GT.1) GO TO 155
C
C     THE TYPED NUMBER IS NOT TO BE CENTERED AT (X,Y).
C
      DIR = XYD
      GO TO 160
C
C     THE TYPED NUMBER IS TO BE CENTERED AT (X,Y).
C
  155 XY = FW/2
      IF (FW/2 .EQ. (FW+1)/2) XY = XY - .5
      DIR = MAX0(1,IABS(XYD))
      IF (DIR .EQ. 1) XX = X - XY*CNTX
      IF (DIR .EQ. 2) YY = Y - XY*CNTY
C
C     TYPE THE NUMBER.
C
  160 CALL TYPE10 (XX,YY,DIR,C,FW,0)
      GO TO 200
C
C     ROUND THE NUMBER.
C
  180 IF (NSIG .EQ. 8) GO TO 190
      IF (D(NSIG+1) .LE. 5) GO TO 190
      J = NSIG
  181 D(J) = D(J) + 1
      IF (D(J) .LE. 10) GO TO 190
      D(J) = 1
      J = J - 1
      IF (J .NE. 0) GO TO 181
      IF (D(1) .NE. 1) GO TO 190
      J = NSIG - 1
  182 IF (J .EQ. 0) GO TO 183
      D(J+1) = D(J)
      J = J - 1
      GO TO 182
  183 D(1) = 2
      EXP = EXP + 1
  190 GO TO TRA, (120,137,142,145)
C
  200 RETURN
      END

      SUBROUTINE HDVSR(A,LA,IR)
C   IMSL ROUTINE NAME   - HDVSR
C
C-----------------------------------------------------------------------
C
C   COMPUTER            - CDC/SINGLE
C
C   LATEST REVISION     - JANUARY 1, 1978
C
C   PURPOSE             - SORTING OF ARRAYS BY ALGEBRAIC VALUE -
C                           PERMUTATIONS RETURNED
C
C   USAGE               - CALL HDVSR (A,LA,IR)
C
C   ARGUMENTS    A      - ON INPUT, A CONTAINS THE ARRAY TO BE SORTED.
C                         ON OUTPUT, A CONTAINS THE SORTED ARRAY.
C                LA     - INPUT VARIABLE CONTAINING THE NUMBER OF
C                           ELEMENTS IN THE ARRAY TO BE SORTED.
C                IR     - VECTOR OF LENGTH LA.
C                         ON INPUT, IR CONTAINS THE INTEGER VALUES
C                           1,2,...,LA. SEE REMARKS.
C                         ON OUTPUT, IR CONTAINS A RECORD OF THE
C                           PERMUTATIONS MADE ON THE VECTOR A.
C
C   PRECISION/HARDWARE  - SINGLE/ALL
C
C   REQD. IMSL ROUTINES - NONE REQUIRED
C
C                           CONVENTIONS IS AVAILABLE IN THE MANUAL
C                           INTRODUCTION OR THROUGH IMSL ROUTINE UHELP
C
C   REMARKS      THE VECTOR IR MUST BE INITIALIZED BEFORE ENTERING
C                HDVSR.  ORDINARILY, IR(1)=1, IR(2)=2, ...,
C                IR(LA)=LA.  FOR WIDER APPLICABILITY, ANY INTEGER
C                THAT IS TO BE ASSOCIATED WITH A(I) FOR I=1,2,...,LA
C                MAY BE ENTERED INTO IR(I).
C
C   COPYRIGHT           - 1978 BY IMSL, INC. ALL RIGHTS RESERVED.
C
C   WARRANTY            - IMSL WARRANTS ONLY THAT IMSL TESTING HAS BEEN
C                           APPLIED TO THIS CODE.  NO OTHER WARRANTY,
C                           EXPRESSED OR IMPLIED, IS APPLICABLE.
C
C-----------------------------------------------------------------------
C
      DIMENSION A(1),IR(1)
C                                  SPECIFICATIONS FOR ARGUMENTS
C                                  SPECIFICATIONS FOR LOCAL VARIABLES
      INTEGER            IU(21),IL(21),I,M,J,K,IJ,IT,L,ITT
      REAL               T,TT,R
C                                  FIRST EXECUTABLE STATEMENT
      IF (LA.LE.0) RETURN
      M = 1
      I = 1
      J = LA
      R = .375
    5 IF (I.EQ.J) GO TO 45
      IF (R.GT..5898437) GO TO 10
      R = R+3.90625E-2
      GO TO 15
   10 R = R-.21875
   15 K = I
C                                  SELECT A CENTRAL ELEMENT OF THE
C                                  ARRAY AND SAVE IT IN LOCATION T
      IJ = I+(J-I)*R
      T = A(IJ)
      IT = IR(IJ)
C                                  IF FIRST ELEMENT OF ARRAY IS GREATER
C                                  THAN T, INTERCHANGE WITH T
      IF (A(I).LE.T) GO TO 20
      A(IJ) = A(I)
      A(I) = T
      T = A(IJ)
      IR(IJ) = IR(I)
      IR(I) = IT
      IT = IR(IJ)
   20 L = J
C                                  IF LAST ELEMENT OF ARRAY IS LESS THAN
C                                  T, INTERCHANGE WITH T
      IF (A(J).GE.T) GO TO 30
      A(IJ) = A(J)
      A(J) = T
      T = A(IJ)
      IR(IJ) = IR(J)
      IR(J) = IT
      IT = IR(IJ)
C                                  IF FIRST ELEMENT OF ARRAY IS GREATER
C                                  THAN T, INTERCHANGE WITH T
      IF (A(I).LE.T) GO TO 30
      A(IJ) = A(I)
      A(I) = T
      T = A(IJ)
      IR(IJ) = IR(I)
      IR(I) = IT
      IT = IR(IJ)
      GO TO 30
   25 IF (A(L).EQ.A(K)) GO TO 30
      TT = A(L)
      A(L) = A(K)
      A(K) = TT
      ITT = IR(L)
      IR(L) = IR(K)
      IR(K) = ITT
C                                  FIND AN ELEMENT IN THE SECOND HALF OF
C                                  THE ARRAY WHICH IS SMALLER THAN T
   30 L = L-1
      IF (A(L).GT.T) GO TO 30
C                                  FIND AN ELEMENT IN THE FIRST HALF OF
C                                  THE ARRAY WHICH IS GREATER THAN T
   35 K = K+1
      IF (A(K).LT.T) GO TO 35
C                                  INTERCHANGE THESE ELEMENTS
      IF (K.LE.L) GO TO 25
C                                  SAVE UPPER AND LOWER SUBSCRIPTS OF
C                                  THE ARRAY YET TO BE SORTED
C                                  THE ARRAY YET TO BE SORTED
      IF (L-I.LE.J-K) GO TO 40
      IL(M) = I
      IU(M) = L
      I = K
      M = M+1
      GO TO 50
   40 IL(M) = K
      IU(M) = J
      J = L
      M = M+1
      GO TO 50
C                                  BEGIN AGAIN ON ANOTHER PORTION OF
C                                  THE UNSORTED ARRAY
   45 M = M-1
      IF (M.EQ.0) RETURN
      I = IL(M)
      J = IU(M)
   50 IF (J-I.GE.11) GO TO 15
      IF (I.EQ.1) GO TO 5
      I = I-1
   55 I = I+1
      IF (I.EQ.J) GO TO 45
      T = A(I+1)
      IT = IR(I+1)
      IF (A(I).LE.T) GO TO 55
      K = I
   60 A(K+1) = A(K)
      IR(K+1) = IR(K)
      K = K-1
      IF (T.LT.A(K)) GO TO 60
      A(K+1) = T
      IR(K+1) = IT
      GO TO 55
      END

      SUBROUTINE TMTSOT
C
C     THIS SUBROUTINE PRINTS THE CONTENTS OF COMMON /NTIME/
C
      COMMON /NTIME / NITEMS, TGINO , TBLDPK, TINTPK, TPACK ,
     1                        TUNPAK, TGETST, TPUTST,
     2                        TTLRSP, TTLRDP, TTLCSP, TTLCDP,
     3                        TLLRSP, TLLRDP, TLLCSP, TLLCDP,
     4                        TGETSB
     *                      , RGINO , RBLDPK  , RINTPK , RPACK  ,
     *                        RUNPAK, RGETST  , RPUTST
      COMMON /SYSTEM/ ISYSBF, NOUT  , DUMMY(74)     , ISY77
C
      WRITE (NOUT,2000) NITEMS
      WRITE (NOUT,2010) TGINO
      WRITE (NOUT,2020) TBLDPK
      WRITE (NOUT,2030) TINTPK
      WRITE (NOUT,2040) TPACK
      WRITE (NOUT,2050) TUNPAK
      WRITE (NOUT,2060) TGETST
      WRITE (NOUT,2070) TPUTST
      WRITE (NOUT,2080) TTLRSP
      WRITE (NOUT,2090) TTLRDP
      WRITE (NOUT,2100) TTLCSP
      WRITE (NOUT,2110) TTLCDP
      WRITE (NOUT,2120) TLLRSP
      WRITE (NOUT,2130) TLLRDP
      WRITE (NOUT,2140) TLLCSP
      WRITE (NOUT,2150) TLLCDP
      WRITE (NOUT,2160) TGETSB
      WRITE (NOUT,2210) RGINO
      WRITE (NOUT,2220) RBLDPK
      WRITE (NOUT,2230) RINTPK
      WRITE (NOUT,2240) RPACK
      WRITE (NOUT,2250) RUNPAK
      WRITE (NOUT,2260) RGETST
      WRITE (NOUT,2270) RPUTST
      IF (ISY77 .NE. -3) WRITE (NOUT,2200)
      RETURN
 2000 FORMAT (1H1,23X,
     1        ' DIAG 35 OUTPUT OF TIMING CONSTANTS IN COMMON /NTIME/'/
     2            24X,
     3        ' ----------------------------------------------------'//
     4        ' NUMBER OF TIMING CONSTANTS IN COMMON /NTIME/   ',
     5        '                         --- ', I11                   / )
 2010 FORMAT (' READ + WRITE + BACKWARD READ                   ',
     1        ' (AVERAGE PER WORD     ) --- ', E11.4, ' MICROSECONDS'/ )
 2020 FORMAT (' BLDPK  - PACK   SUCCESSIVE ELEMENTS OF A COLUMN',
     1        ' (AVERAGE PER WORD     ) --- ', E11.4, ' MICROSECONDS'/ )
 2030 FORMAT (' INTPK  - UNPACK SUCCESSIVE ELEMENTS OF A COLUMN',
     1        ' (AVERAGE PER WORD     ) --- ', E11.4, ' MICROSECONDS'/ )
 2040 FORMAT (' PACK   - PACK   AN ENTIRE COLUMN               ',
     1        ' (AVERAGE PER WORD     ) --- ', E11.4, ' MICROSECONDS'/ )
 2050 FORMAT (' UNPACK - UNPACK AN ENTIRE COLUMN               ',
     1        ' (AVERAGE PER WORD     ) --- ', E11.4, ' MICROSECONDS'/ )
 2060 FORMAT (' GETSTR - FORWARD READ  A STRING OF DATA        ',
     1        ' (AVERAGE PER WORD     ) --- ', E11.4, ' MICROSECONDS'/ )
 2070 FORMAT (' PUTSTR - WRITE A STRING OF DATA                ',
     1        ' (AVERAGE PER WORD     ) --- ', E11.4, ' MICROSECONDS'/ )
 2080 FORMAT (' TIGHT-LOOP MULTIPLY - REAL    SINGLE PRECISION ',
     1        ' (AVERAGE PER OPERATION) --- ', E11.4, ' MICROSECONDS'/ )
 2090 FORMAT (' TIGHT-LOOP MULTIPLY - REAL    DOUBLE PRECISION ',
     1        ' (AVERAGE PER OPERATION) --- ', E11.4, ' MICROSECONDS'/ )
 2100 FORMAT (' TIGHT-LOOP MULTIPLY - COMPLEX SINGLE PRECISION ',
     1        ' (AVERAGE PER OPERATION) --- ', E11.4, ' MICROSECONDS'/ )
 2110 FORMAT (' TIGHT-LOOP MULTIPLY - COMPLEX DOUBLE PRECISION ',
     1        ' (AVERAGE PER OPERATION) --- ', E11.4, ' MICROSECONDS'/ )
 2120 FORMAT (' LOOSE-LOOP MULTIPLY - REAL    SINGLE PRECISION ',
     1        ' (AVERAGE PER OPERATION) --- ', E11.4, ' MICROSECONDS'/ )
 2130 FORMAT (' LOOSE-LOOP MULTIPLY - REAL    DOUBLE PRECISION ',
     1        ' (AVERAGE PER OPERATION) --- ', E11.4, ' MICROSECONDS'/ )
 2140 FORMAT (' LOOSE-LOOP MULTIPLY - COMPLEX SINGLE PRECISION ',
     1        ' (AVERAGE PER OPERATION) --- ', E11.4, ' MICROSECONDS'/ )
 2150 FORMAT (' LOOSE-LOOP MULTIPLY - COMPLEX DOUBLE PRECISION ',
     1        ' (AVERAGE PER OPERATION) --- ', E11.4, ' MICROSECONDS'/ )
 2160 FORMAT (' GETSTB - BACKWARD READ  A STRING OF DATA       ',
     1        ' (AVERAGE PER WORD     ) --- ', E11.4, ' MICROSECONDS'/ )
 2200 FORMAT ('0*** NASTRAN INFORMATION MESSAGE, TO INCORPORATE THESE ',
     1        'TIMING CONSTANTS INTO NASTRAN PERMANENTLY', /5X,
     2        'RE-RUN JOB WITH ''NASTRAN BULKDATA=-3'' FOR MORE ',
     3        'INSTRUCTIONS',/)
 2210 FORMAT (' READ + WRITE + BACKWARD READ                   ',
     *        ' (AVERAGE PER RECORD   ) --- ', E11.4, ' MICROSECONDS'/ )
 2220 FORMAT (' BLDPK  - PACK   SUCCESSIVE ELEMENTS OF A COLUMN',
     *        ' (AVERAGE PER RECORD   ) --- ', E11.4, ' MICROSECONDS'/ )
 2230 FORMAT (' INTPK    UNPACK SUCCESSIVE ELEMENTS OF A COLUMN',
     *        ' (AVERAGE PER RECORD   ) --- ', E11.4, ' MICROSECONDS'/ )
 2240 FORMAT (' PACK   - PACK   AN ENTIRE COLUMN               ',
     *        ' (AVERAGE PER RECORD   ) --- ', E11.4, ' MICROSECONDS'/ )
 2250 FORMAT (' UNPACK - UNPACK AN ENTIRE COLUMN               ',
     *        ' (AVERAGE PER RECORD   ) --- ', E11.4, ' MICROSECONDS'/ )
 2260 FORMAT (' GETSTR - READ  A STRING OF DATA                ',
     *        ' (AVERAGE PER RECORD   ) --- ', E11.4, ' MICROSECONDS'/ )
 2270 FORMAT (' PUTSTR - WRITE A STRING OF DATA                ',
     *        ' (AVERAGE PER RECORD   ) --- ', E11.4, ' MICROSECONDS'/ )
      END

      SUBROUTINE SMA2B (KE,J,II,IFILE,DUMDP)
C ******
C SUBROUTINE SMA2B  ADDS A N X N DOUBLE PRECISION MATRIX, KE, TO THE
C SUBMATRIX OF ORDER NROWSC X JMAX, WHICH IS IN CORE.  N IS 1 IF EITHER
C NPVT, THE PIVOT POINT, IS A  SCALAR POINT, OR J, THE SECOND SUBSCRIPT
C OF KE CORRESPONDS TO A SCALAR POINT, OR J .NE. TO ANY ENTRY IN THE
C GPCT.  OTHERWISE N IS 6.
C ******
C
C
C
C
      DOUBLE PRECISION
     1                   DZ(1)              ,KE(36)
     2,                  DUMDP
C
C
C
      INTEGER
     1                   IZ(1)              ,EOR
     2,                  CLSRW              ,CLSNRW
     3,                  FROWIC
     4,                  TNROWS             ,OUTRW
      INTEGER ECPT
C
      COMMON /BLANK/ NOBGG
C
C
C
      COMMON   /SYSTEM/
     1                   ISYS(21), LINKNO
      COMMON   /SEM   /  MASK(3) , LNKNOS(15)
C
C SMA2 I/O PARAMETERS
C
      COMMON   /SMA2IO/
     1                   IFCSTM             ,IFMPT
     2,                  IFDIT              ,IDUM1
     3,                  IFECPT             ,IGECPT
     4,                  IFGPCT             ,IGGPCT
     5,                  IDUM2              ,IDUM3
     6,                  IFMGG              ,IGMGG
     7,                  IFBGG              ,IGBGG
     8,                  IDUM4              ,IDUM5
     9,                  INRW               ,OUTRW
     T,                  CLSNRW             ,CLSRW
     1,                  NEOR               ,EOR
     2,                  MCBMGG(7)          ,MCBBGG(7)
C
C SMA2 VARIABLE CORE
C
      COMMON   /ZZZZZZ /  Z(1)
C
C SMA2 VARIABLE CORE BOOKKEEPING PARAMETERS
C
      COMMON   /SMA2BK/
     1                   ICSTM              ,NCSTM
     2,                  IGPCT              ,NGPCT
     3,                  IPOINT             ,NPOINT
     4,                  I6X6M              ,N6X6M
     5,                  I6X6B              ,N6X6B
C
C SMA2 PROGRAM CONTROL PARAMETERS
C
      COMMON   /SMA2CL/
     1                   IOPTB              ,BGGIND
     2,                  NPVT               ,LEFT
     3,                  FROWIC             ,LROWIC
     4,                  NROWSC             ,TNROWS
     5,                  JMAX               ,NLINKS
     6,                  LINK(10)           ,NOGO
C
C ECPT COMMON BLOCK
C
      COMMON   /SMA2ET/
     1                   ECPT(100)
C
C
C
      EQUIVALENCE
     1                   (Z(1),IZ(1),DZ(1))
C
C
C     CALL EMG1B AND THEN RETURN IF THIS IS LINK 8.
C     PROCEED NORMALLY FOR OTHER LINKS.
C
      IF (LINKNO.NE.LNKNOS(8)) GO TO 100
      CALL EMG1B (KE, J, II, IFILE, DUMDP)
      RETURN
C
C DETERMINE WHICH MATRIX IS BEING COMPUTED.
C
  100 IBASE = I6X6M
      IF (IFILE .EQ. IFMGG) GO TO 5
      IF (IOPTB .LT. 0) RETURN
      IBASE = I6X6B
C
C SEARCH THE GPCT AND FIND AN INDEX M SUCH THAT
C IABS(GPCT(M)) .LE. J .LT. IABS(GPCT(M+1))
C
    5 LOW = IGPCT + 1
      LIM = NGPCT + LOW - 2
      IF (LOW .GT. LIM) GO TO 15
      DO 10 I = LOW,LIM
      ISAVE = I
      IF (J .GE. IABS(IZ(I+1)) ) GO TO 10
      IF (J .GE. IABS(IZ(I)) ) GO TO 20
   10 CONTINUE
      IF ( J .GE. IABS(IZ(ISAVE+1)) )  ISAVE = ISAVE + 1
      GO TO 20
C
C IF II .GT. 0, WE ARE DEALING WITH A SCALAR POINT.
C
   15 ISAVE = LOW
   20 IF (II .GT. 0) GO TO 60
C
C AT THIS POINT IT HAS BEEN DETERMINED THAT J IS A SCALAR INDEX NUMBER
C WHICH CORRESPONDS TO A GRID POINT.  HENCE THE DOUBLE PRECISION 6 X 6
C MATRIX, KE, WILL BE ADDED TO THE MATRIX.
C
      L1 = FROWIC - 1
      JJ = IPOINT + ISAVE - IGPCT
      J2 = IZ(JJ) - 1
      I1 = 0
      LIM = NROWSC - 1
   30 IF (I1 .GT. LIM) RETURN
      K1 = IBASE + I1*JMAX + J2
      J1 = 0
      L = 6*L1
      K = K1
   40 J1 = J1 + 1
      IF (J1 .GT. 6) GO TO 50
      L = L + 1
      K = K + 1
      DZ(K) = DZ(K) + KE(L)
      GO TO 40
   50 I1 = I1 + 1
      L1 = L1 + 1
      GO TO 30
C
C AT THIS POINT WE ARE DEALING WITH A 1 X 1.
C FIRST COMPUTE THE ROW NUMBER, NROW
C
   60 NROW = II - NPVT + 1
C
C THE FOLLOWING 2 FORTRAN STATEMENTS ARE MERELY TO CHECK THE PROGRAM
C LOGIC.  EVENTUALLY THEY CAN BE DELETED.
C
      IF (NROW .GE. 1  .AND.  NROW .LE. TNROWS)  GO TO 70
      CALL MESAGE (-30,22,ECPT(1))
   70 LROWIC = FROWIC + NROWSC - 1
C
C IF NROW, THE ROW INTO WHICH THE NUMBER KE(1) IS TO BE ADDED IS NOT
C IN CORE IT CANNOT BE ADDED AT THIS TIME.
C
      IF (NROW .LT. FROWIC  .OR.  NROW .GT. LROWIC) RETURN
      J2 = ISAVE
      J3 = IPOINT + ISAVE - IGPCT
      INDEX = IBASE + (NROW-1)*JMAX + IZ(J3) + J - IABS(IZ(J2))
      DZ(INDEX) = DZ(INDEX) + KE(1)
      RETURN
C
      END

      SUBROUTINE FREAD (FILE,BLOCK,N,EOR)
C
      INTEGER FILE,EOR
      REAL BLOCK(1),SUBNAM(2)
      DATA SUBNAM / 4H FRE,4HAD  /
C
      CALL READ (*100,*101,FILE,BLOCK,N,EOR,K)
      RETURN
  100 K = -2
      GO TO 110
  101 K = -3
  110 CALL MESAGE (K,FILE,SUBNAM)
      GO TO 110
      END

      SUBROUTINE BANDIT
C
C     BANDIT - A COMPUTER PROGRAM TO RE-SEQUENCE MATRIX BY BANDWIDTH,
C              PROFILE, AND WAVEFRONT METHODS FOR NASTRAN.
C
C     THIS PROGRAM GENERATES THE RE-SEQUENCE CARDS, SEQGP (AFTER GEOM1,
C     GEOM2, AND GEOM4 DATA BLOCKS ARE ASSEMBLED), AND ADD THESE CARDS
C     TO THE END OF GEOM1 FILE.
C
C     HOWEVER, IF THE ORIGINAL NASTRAN INPUT DECK CONTAINS ONE OR MORE
C     SEQGP CARD, BANDIT WILL BE AUTOMATICALLY SKIPPED.
C
C     ******************************************************************
C
C     ACKNOWLEDGEMENT:
C
C     THE ORIGINAL BANDIT PROGRAM (VERSION 9, DEC. 1978, DISTRIBUTED BY
C     COSMIC  NO. DOD-0034) WAS WRITTEN BY G. C. EVERTINE OF NAVAL SHIP
C     RESEARCH AND DEVELOPMENT CENTER (NSRDC), BETHESDA, MD.
C
C     THE FOLLOWING SUBROUTINES WERE WRITTEN BY E. CUTHILL AND J. MCKEE
C     OF NSRDC
C     - CTHMCK,DEGREE,DIAM,IDIST,KOMPNT,MAXDGR,MINDEG,RELABL
C
C     THE FOLLOWING SUBROUTINES WERE WRITTEN BY N. GIBBS, W. POOLE,
C     P. STOCKMEYER, AND H. CRANE OF THE COLLEGE OF WILLIAM AND MARY
C     - DGREE,FNDIAM,GIBSTK,NUMBER,PIKLVL,RSETUP,SORTDG,SORT2,TREE.
C     (THESE ROUTINES AND CTHMCK WERE MODIFIED BY G. C. EVERSTINE.)
C
C     ******************************************************************
C
C     ONLY HALF OF THE ORIGINAL BANDIT PROGRAM WAS ADOPTED IN THIS
C     NASTRAN VERSION BY G. C. CHAN OF SPERRY, HUNTSVILLE, AL., 1982
C
C     THE ORIGINAL BANDIT ROUTINES WERE UPDATED TO MEET NASTRAN
C     PROGRAMMING STYLE AND STANDARD.
C     NASTRAN GINO FILES AND GINO I/O ARE USED INSTEAD OF FORTRAN FILES
C     AND FORTRAN READ/WRITE
C     THE INTEGER PACK AND UNPACK ROUTINES, BPACK AND BUNPK, WERE RE-
C     WRITTEN TO ALLOW COMMON USAGE FOR IBM, CDC, UNIVAC AND VAX MACH.
C
C     ROUTINES BANDIT, SCHEME, BREAD, BGRID, BSEQGP, AND TIGER WERE
C     COMPLETELY RE-WRITTEN.
C     (SCHEME WAS FORMALLY CALLED NASNUM, AND CTHMCK WAS SCHEME)
C
C     ******************************************************************
C
C     THIS NASTRAN VERSION DOES NOT USE $-OPTION CARDS AS IN THE CASE OF
C     ORIGINAL BANDIT PROGRAM.
C
C     THE FOLLOWING 'OPTIONS' ARE PRE-SELECTED -
C
C        $ADD        (NOT USE)            $INSERT     (NOT USE)
C        $APPEND     (NOT USE)            $METHOD     (GPS    )
C        $CONFIG     (NOT USE)            $MPC        (NO     )
C        $CRITERION  (RMS    )            $NASTRAN    (NOT USE)
C        $DEGREE     (NOT USE)            $PLUS       (NOT USE)
C        $DIMENSION  (NOT USE)            $PRINT      (MIN    )
C        $ELEMENTS   (NOT USE)            $PUNCH      (NONE   )
C        $FRONTAL    (NOT USE)            $SEQUENCE   (YES    )
C        $GRID       (NOT USE)            $SPRING     (NO     )
C        $HICORE     (NOT USE)            $TABLE      (NO     )
C        $IGNORE     (NOT USE)            $START      (NOT USE)
C
C     ******************************************************************
C
      INTEGER          HICORE,   GEOM1,    GEOM2,    GEOM4,    SCR1,
     1                 Z,        SUB(3),   END,
     2                 RD,       RDREW,    WRT,      WRTREW,   REW
C
      COMMON /MACHIN/  MACHIN
      COMMON /BANDA /  IBUF1,    NOMPC,    NODEP,    NOPCH,    NORUN,
     1                 METHOD,   ICRIT,    NGPTS(2)
      COMMON /BANDB /  NBITIN,   KORE,     IFL,      NGRID,    IPASS,
     1                 NW,       KDIM,     NBPW,     IREPT
      COMMON /BANDD /  KORIG,    KNEW,     IOP,      INP,      NCM,
     1                 NZERO,    NEL,      NEQ,      NEQR
      COMMON /BANDG /  DUM3G(3)
      COMMON /BANDS /  NN,       MM,       IH,       IB,       MAXGRD,
     1                 MAXDEG,   KMOD,     MACH,     MINDEG,   NEDGE,
     2                 MASK
      COMMON /BANDW /  DUM4W(4), I77,      DUM2W(2)
      COMMON /SYSTEM/  IBUF,     NOUT,     NOGO,     IS(97)
      COMMON /GEOMX /  GEOM1,    GEOM2,    GEOM4,    SCR1
      COMMON /NAMES /  RD,       RDREW,    WRT,      WRTREW,   REW
      COMMON /ZZZZZZ/  Z(1)
C
      EQUIVALENCE      (HICORE,IS(28))
      DATA             SUB  /    4HBAND,   4HIT  ,   4HBEGN  /
      DATA             END,      IQUIT /   4HEND ,   4HQUIT  /
C
C     INITIALIZE PROGRAM PARAMETERS
C
C     NOMPC =  0, MPC'S AND RIGID ELEM. ARE NOT USED IN BANDIT COMPUTATI
C           = +1, ONLY RIGID ELEMENTS ARE USED IN BANDIT RESEQUENCING
C           = +2, BOTH MPC'S  AND RIGID ELEM. ARE USED IN BANDIT
C           = +3, ONLY MPC'S, NOT RIGID ELEM. ARE USED IN BANDIT
C     NODEP = +1, MPC DEPENDENT PTS. ARE TO BE REMOVED FROM COMPUTATION
C           = -1, MPC DEPENDENT PTS. ARE NOT TO BE REMOVED.
C                 (NOTE - NODEP DICTATES ALSO THE DEPENDENT GRIDS OF
C                         THE RIGID ELEMENTS)
C     NOPCH = +1, PUNCH OUT SEQGP CARDS
C           = -1, NO SEQGP CARDS PUNCHED
C     NORUN = +1, BANDIT WILL RUN EVEN SEQGP CARDS ARE PRESENT
C           = -1, BANDIT IS SKIPPED IF ONE OR MORE SEQGP CARD IS
C                 PRESENT IN  THE INPUT DECK
C     METHOD= -1, CM METHOD ONLY
C           =  0, BOTHE CM AND GPS METHODS ARE USED
C           = +1, USE GPS METHOD ONLY
C     ICRIT =     RE-SEQUENCING CRITERION
C           =  1, RMS WAVEFRONT
C           =  2, BANDWIDTH
C           =  3, PROFILE
C           =  4, MAX WAVEFRONT
C
      NZERO = 0
      I77   = 77
      NOMPC = 0
      NODEP =-1
      NOPCH =-1
      NORUN =-1
      METHOD=+1
      KDIM  = 1
      ICRIT = 1
      IREPT = 0
C
C     THE ABOVE DEFAULT VALUES CAN BE RESET BY THE NASTRAN CARD.
C     (SEE SUBROUTINE NASCAR BANDIT FLAG FOR MORE DETAILS)
C     ******************************************************************
C
      CALL CONMSG (SUB,3,0)
      NBPW = IS(37)
      MACH = MACHIN
      KORE = KORSZ(Z(1))
      IBUF1= KORE - IBUF - 2
      KORE = IBUF1 - 1
C
C     CALL BGRID TO GET THE NO. OF GRID POINTS IN THE PROBLEM, SET
C     THE INTEGER PACKING CONSTANT, NW, AND COMPUTE MAXGRD AND MAXDEG.
C     BANDIT QUITS IF PROBLEM IS TOO SMALL TO BE WORTHWHILE.
C
    5 IREPT = IREPT + 1
      CALL BGRID
      IF (NGRID .LT. 15) GO TO 30
      KDIM4 = KDIM*4
      II3   = 2*MAXGRD
C
C     PARTITION OPEN CORE FOR SCHEME COMPUTATION.
C
      K2 =  1 + KDIM4
      K3 = K2 + 2*II3  + 2
      IF (METHOD.LE.0 .AND. MAXDEG.GT.MAXGRD) K3 = K3 + MAXDEG - MAXGRD
      K4 = K3 + MAXGRD + 1
      K5 = K4 + MAXGRD
      K6 = K5 + MAXGRD + 1
      K7 = K6 + MAXGRD
      K8 = K7 + MAXDEG
      K1 = K8 + MAXDEG + NW
      K9 = K1 + MAXGRD*MAXDEG/NW
      IF (K9 .GT. KORE) CALL MESAGE (-8,K9-KORE,SUB)
C
C     READ BULK DATA, SET UP CONNECTION TABLE, AND RESEQUENCE NODES.
C
      CALL SCHEME(Z(K1),Z(K2),II3,Z(K3),Z(K4),Z(K5),Z(K6),Z(K7),Z(K8),Z)
      IF (NGRID .EQ. -1) CALL SPTCHK
      IF (IREPT .EQ.  2) GO TO 5
      IF (NGRID) 20,30,10
C
C     JOB DONE.
C
   10 SUB(3) = END
      GO TO 40
C
C     NO BANDIT RUN.
C
   20 NOGO = 1
   30 SUB(3) = IQUIT
   40 CALL CONMSG (SUB,3,0)
      RETURN
      END

      SUBROUTINE PKQDMS
C THIS SUBROUTINE CALCULATES AND SHIPS TO PLA4B THE STIFFNESS MATRIX FOR
C PLA4
C     *** QUADRILATERAL MEMBRANE SUBROUTINE ***
C
C     CALLS FROM THIS ROUTINE ARE MADE TO THE FOLLOWING
C
C                 PKTRMS - TRIANGULAR MEMBRANE SUBROUTINE
C                 PLA4B  - INSERTION ROUTINE
C                MESAGE - ERROR MESSAGE WRITER
C
      DOUBLE PRECISION KIJ,KSUM,K3X3,TEMP
      REAL IVEC,JVEC,KVEC
C
      DIMENSION          M(12)
     1                  ,K3X3(27)
     2                  ,NECPT(5)
C
      COMMON /CONDAS/ CONSTS(5)
      COMMON /PLA4ES/ ECPT(100)
      COMMON /PLA42C/ NPVT   , DUM1(3)
     1,                  DUMCL(145)         ,NOGO
      COMMON /PLA42D/  KIJ(36),DUM7(156),KSUM(36),TEMP,COSANG,SINANG,
     1VECL,IVEC(3),JVEC(3),KVEC(3),PVEC(3),VSUBK(3),V(3),SI(3),
     2  NPIVOT,MPOINT,MI,NSUBSC,NGRID(4),U1,U2,COORD(16),DUMM8(248)
      COMMON /MATIN / MATID,INFLAG,ELTEMP,STRESS,SINTH,COSTH
C
      EQUIVALENCE ( CONSTS(4) , DEGRA  )
      EQUIVALENCE        (K3X3  ( 1),KIJ   ( 1))
     1                  ,(NECPT ( 1),ECPT  ( 1))
C
      DATA  M / 1, 2, 4, 2, 3, 1, 3, 4, 2, 4, 1, 3 /
C     ******************************************************************
C          ECPT                       ECPT
C       RECEIVED BY                REQUIRED BY
C         KQDMEM                     KTRMEM
C     ******************************************************************
C     ECPT( 1) = EL. ID          ECPT( 1) = EL. ID
C     ECPT( 2) = GRD. PT. A      ECPT( 2) = GRD. PT. A
C     ECPT( 3) = GRD. PT. B      ECPT( 3) = GRD. PT. B
C     ECPT( 4) = GRD. PT. C      ECPT( 4) = GRD. PT. C
C     ECPT( 5) = GRD. PT. D      ECPT( 5) = THETA
C     ECPT( 6) = THETA           ECPT( 6) = MATERIAL ID
C     ECPT( 7) = MATERIAL ID     ECPT( 7) = T
C     ECPT( 8) = T               ECPT( 8) = NON-STRUCT. MASS
C     ECPT( 9) = NON-STRUCT. MASSECPT( 9) = COORD. SYS. ID 1
C     ECPT(10) = COORD. SYS. ID 1ECPT(10) = X1
C     ECPT(11) = X1              ECPT(11) = Y1
C     ECPT(12) = Y1              ECPT(12) = Z1
C     ECPT(13) = Z1              ECPT(13) = COORD. SYS. ID 2
C     ECPT(14) = COORD. SYS. ID 2ECPT(14) = X2
C     ECPT(15) = X2              ECPT(15) = Y2
C     ECPT(16) = Y2              ECPT(16) = Z2
C     ECPT(17) = Z2              ECPT(17) = COORD. SYS. ID 3
C     ECPT(18) = COORD. SYS. ID 3ECPT(18) = X3
C     ECPT(19) = X3              ECPT(19) = Y3
C     ECPT(20) = Y3              ECPT(20) = Z3
C     ECPT(21) = Z3              ECPT(21) = ELEMENT TEMPERATURE
C     ECPT(22) = COORD. SYS. ID 4    NOTE. THE FOLLOWING ARE INTEGERS...
C     ECPT(23) = X4                  GRID POINTS, MAT ID, EL.ID,
C     ECPT(24) = Y4                  COORD. SYS. IDS.
C     ECPT(25) = Z4                  ALL OTHERS ARE REAL IN THE ECPT.
C     ECPT(26) = ELEMENT TEMPERATURE
C     ******************************************************************
C
C     THE FOLLOWING COMPUTATION IS PERFORMED FOR USE WITH THE
C     COMPUTATION OF SINTH AND COSTH BELOW (ANISOTROPIC MATERIAL
C     POSSIBILITY)  NOTE  FMMS-46 PAGE -9-
C
      ANGL = ECPT(6) * DEGRA
      COSANG = COS( ANGL )
      SINANG = SIN( ANGL )
      IVEC(1) = ECPT(15) - ECPT(11)
      IVEC(2) = ECPT(16) - ECPT(12)
      IVEC(3) = ECPT(17) - ECPT(13)
      VECL = SQRT( IVEC(1)**2 + IVEC(2)**2 + IVEC(3)**2 )
      IF (VECL.EQ.0.0E0) GO TO 200
      IVEC(1) = IVEC(1)/VECL
      IVEC(2) = IVEC(2)/VECL
      IVEC(3) = IVEC(3)/VECL
      VSUBK(1) =IVEC(2) *(ECPT(25)-ECPT(13))-IVEC(3)*(ECPT(24)-ECPT(12))
      VSUBK(2) =IVEC(3) *(ECPT(23)-ECPT(11))-IVEC(1)*(ECPT(25)-ECPT(13))
      VSUBK(3) =IVEC(1) *(ECPT(24)-ECPT(12))-IVEC(2)*(ECPT(23)-ECPT(11))
      VECL = SQRT(VSUBK(1)**2 + VSUBK(2)**2 + VSUBK(3)**2 )
      IF (VECL.EQ.0.0E0) GO TO 200
      KVEC(1) = VSUBK(1)/VECL
      KVEC(2) = VSUBK(2)/VECL
      KVEC(3) = VSUBK(3)/VECL
      JVEC(1) = KVEC(2) * IVEC(3) - KVEC(3) * IVEC(2)
      JVEC(2) = KVEC(3) * IVEC(1) - KVEC(1) * IVEC(3)
      JVEC(3) = KVEC(1) * IVEC(2) - KVEC(2) * IVEC(1)
      DO 10 I=1,3
   10 PVEC(I) = COSANG * IVEC(I) + SINANG * JVEC(I)
C
C
C     SAVE COORDINATE SYSTEMS AND GRID POINT SIL NUMBERS
C
      NGRID(1) = NECPT(2)
      NGRID(2) = NECPT(3)
      NGRID(3) = NECPT(4)
      NGRID(4) = NECPT(5)
      DO 20 I=1,16
   20 COORD(I) = ECPT(I + 9)
C
C     NOTE. COORD 1, 5, 9, AND 13  ARE INTEGER CSID NUMBERS.
C
C     CORRECT ECPT FOR MEMBRANE USE
      ECPT(5) = ECPT(6)
      ECPT(6) = ECPT(7)
      ECPT(7) = ECPT(8)/2.0E0
      ECPT(8) = ECPT(9)
C
C     FOR EACH TRIANGLE THEN THE THREE GRID POINTS AND COORDINATES
C     ARE INSERTED INTO THE ECPT BEFORE THE CALL TO KTRMEM.
C
C     FILL MAP MATRIX  (PERFORMED IN DATA STATEMENT - DO NOT ALTER)
C              A              B              C
C           M1 = 1         M2 = 2         M3 = 4      (TRIANGLE    I)
C
C           M4 = 2         M5 = 3         M6 = 1      (TRIANGLE   II)
C
C           M7 = 3         M8 = 4         M9 = 2      (TRIANGLE  III)
C
C           M10= 4         M11= 1         M12= 3      (TRIANGLE   IV)
C
C     ******************************************************************
C     FIND WHICH POINT IS THE PIVOT POINT.
      DO 30 I=1,4
      IF(NPVT .NE. NGRID(I)) GO TO 30
      NPIVOT = I
      GO TO 40
   30 CONTINUE
C
C     FALL THRU ABOVE LOOP IMPLIES AN ERROR CONDITION.
C
      CALL MESAGE(-30,34,ECPT(1))
C
C     COMPUTE JNOT WHICH EQUALS THE ONE TRIANGLE OF THE FOUR NOT USED
C     AND THUS NOT COMPUTED FOR THE PIVOT POINT IN QUESTION.  (NOTE THE
C     ROWS OF THE MAPPING MATRIX ABOVE AND THE TRIANGLE NUMBERS)
C
   40 IF(NPIVOT - 2)50,50,60
   50 JNOT = NPIVOT + 2
      GO TO 70
   60 JNOT = NPIVOT - 2
C
C     ZERO OUT KSUM FOR 36
   70 DO 80 I=1,36
   80 KSUM(I) = 0.0D0
C
      DO 150 J=1,4
      IF (J .EQ. JNOT) GO TO 150
C
C     FILL IN ECPT FOR TRIANGLE J
      MPOINT = 3*J - 3
      DO 100 I=1,3
      NPT1 = MPOINT + I
      NSUBSC = M(NPT1)
      NECPT(I+1) = NGRID(NSUBSC)
C
      NPT1 = 4*NSUBSC - 4
      DO 90 K=1,4
      NPT2 = NPT1 + K
      NPT3 = 4*I + 4 + K
   90 ECPT(NPT3) = COORD(NPT2)
  100 CONTINUE
C
C     ECPT IS COMPLETE FOR TRIANGLE J
C
C     SET UP SINTH AND COSTH FOR THIS SUB TRIANGLE
C
      IF( J.NE.1 ) GO TO 110
      SINTH = SINANG
      COSTH = COSANG
      GO TO 120
C
C     NOTE FMMS-46 PAGE-9 FOR FOLLOWING
C
  110 V(1) = ECPT(14) - ECPT(10)
      V(2) = ECPT(15) - ECPT(11)
      V(3) = ECPT(16) - ECPT(12)
      VECL = SQRT( V(1)**2 + V(2)**2 + V(3)**2 )
      IF (VECL.EQ.0.0E0) GO TO 200
      U1 = ( V(1)*PVEC(1) + V(2)*PVEC(2) + V(3)*PVEC(3) )/VECL
      SI(1) = V(2) * PVEC(3) - V(3) * PVEC(2)
      SI(2) = V(3) * PVEC(1) - V(1) * PVEC(3)
      SI(3) = V(1) * PVEC(2) - V(2) * PVEC(1)
      U2 = ( SI(1)*KVEC(1) + SI(2)*KVEC(2) + SI(3)*KVEC(3) )/VECL
      VECL = SQRT( U1**2 + U2**2 )
      IF (VECL.EQ.0.0E0) GO TO 200
      U1 = U1 / VECL
      U2 = U2 / VECL
      SINTH = SINANG * U1 - COSANG * U2
      COSTH = COSANG * U1 + SINANG * U2
  120 IF( ABS(SINTH) .LT. 1.0E-06 ) SINTH = 0.0E0
C
      CALL PKTRMS(1)
C
C     RETURNING FROM PKTRMS THE 3 3X3 ARRAYS FOR THE PIVOT ARE STORED IN
C     COMMON UNDER THE NAME   K3X3(27)
C
C     NOW ADD THE 3 3X3 ARRAYS INTO THE 4 3X3 ARRAYS OF KSUM
C
      DO 140 I=1,3
      NPT1 = 9*I - 9
C     NPT1   POINTS TO THE ZERO POSITION OF THE I-TH K3X3.
C     MPOINT POINTS TO THE ZERO POSITION OF THE J-TH ROW OF MAP MATRIX
C
      MI = MPOINT + I
      NPT2 = 9 * M(MI) - 9
C     NPT2 NOW POINTS TO THE ZERO POSITION OF THE  M(MI) TH  SUM MATRIX
C
      DO 130 K=1,9
      NPT3 = NPT2 + K
      MI   = NPT1 + K
  130 KSUM(NPT3) = KSUM(NPT3) + K3X3(MI)
  140 CONTINUE
C
  150 C O N T I N U E
C
C     ******************************************************************
C
C     NOW INSERT EACH OF THE 4-KSUM (3X3) MATRICES INTO A 6X6 AND
C     SHIP TO PLA4B
C
      DO 160 I=1,36
  160 KIJ(I) = 0.0D0
C
      DO 190 J=1,4
      MPOINT = 9*J - 9
C     MPOINT POINTS TO THE ZERO POSITION OF THE J-TH KSUM 3X3.
      KIJ( 1) = KSUM(MPOINT + 1)
      KIJ( 2) = KSUM(MPOINT + 2)
      KIJ( 3) = KSUM(MPOINT + 3)
      KIJ( 7) = KSUM(MPOINT + 4)
      KIJ( 8) = KSUM(MPOINT + 5)
      KIJ( 9) = KSUM(MPOINT + 6)
      KIJ(13) = KSUM(MPOINT + 7)
      KIJ(14) = KSUM(MPOINT + 8)
      KIJ(15) = KSUM(MPOINT + 9)
C
C     SHIP TO PLA4B
      CALL PLA4B (KIJ(1), NGRID(J))
C
  190 CONTINUE
C
      RETURN
  200 CALL MESAGE(30,26,ECPT(1))
C
C  SET FLAG FOR FATAL ERROR WHILE ALLOWING ERROR MESSAGES TO ACCUMULATE
C
      NOGO=1
      RETURN
      END

      SUBROUTINE MATDUM (IA,IPRC,NPL,NOUT)
C
C     THIS ROUTINE IS CALLED ONLY BY MATPRN TO PRINT UP TO 5 MATRICES
C
C     IF IPRC = 0, MATRICES ARE PRINTED IN THEIR ORIG. PRECISION FORMAT
C     IF IPRC = 1, MATRICES ARE PRINTED IN SINGLE PRECISION E FORMAT
C     IF IPRC = 2, MATRICES ARE PRINTED IN DOUBLE PRECISION D FORMAT
C     IF IPRC =-1, ONLY THE DIAGONAL ELEMENTS OF THE MATRICES ARE
C                  PRINTED IN THEIR ORIG. PRECISION FORMAT
C
C     INPUT MATRIX IA(1) CAN BE IN S.P., D.P., S.P.CMPLX OR D.P.CMPLX
C
C     NPL IS THE NO. OF DATA VALUES PRINTED PER OUTPUT LINE
C     FOR S.P. REAL  DEFAULT IS 8, MAX IS 14
C     FOR D.P. REAL  DEFAULT IS 6, MAX IS 12
C     EVEN NUMBER ONLY FOR COMPLEX
C
C     P3, P4, P5 ARE PRINTOUT CONTROLS
C     P3 = m, MATRIX COLUMNS, 1 THRU m, WILL BE PRINTED.
C             DEFAULT = 0, ALL MATRIX COLUMNS WILL BE PRINTED.
C        =-m, SEE P4 = -n
C     P4 = n, LAST n MATRIX COLUMNS ARE PRINTED. DEFAULT = 0
C        =-n, AND P3 = -m, EVERY OTHER n MATRIX COLUMNS WILL BE PRINTED,
C             STARTIN FROM COLUMN m.
C     P5 = k, EACH PRINTED COLUMN WILL NOT EXCEED k LINES LONG AND THE
C             REMAINING DATA WILL BE OMITTED.
C     NOUT = P6, FORTRAN UNIT (SEE MATPRN)
C
      LOGICAL          JUMP
      INTEGER          SYSBUF,IBLNK,P12,P3,P4,P5,PX(5),ICOL(1),FILE(14)
      DOUBLE PRECISION DCOL(1)
      DIMENSION        IA(7),TYPE(10),FORM(18)
      CHARACTER*15     RFMT,FMTR(2,7)
      CHARACTER*35     CFMT,FMTC(2,4)
      CHARACTER        UFM*23,UWM*25,UIM*29
      COMMON /XMSSG /  UFM,UWM,UIM
      COMMON /BLANK /  P12(2),P3,P4,P5
CZZ   COMMON /ZZTBPR/  COL(1)
      COMMON /ZZZZZZ/  COL(20000)
      COMMON /UNPAKX/  IT,K,L,INCR
      COMMON /SYSTEM/  SYSBUF,IOUT,INX(6),NLPP,INX1(2),LINE
      COMMON /OUTPUT/  HEAD1(96),HEAD2(96)
      EQUIVALENCE      (COL(1),DCOL(1),ICOL(1)), (IBLNK,BLANK)
      DATA    TYPE  /  4HS.P.,4HREAL,4HD.P.,4HREAL,4HCOMP,4HLEX ,4HCMP ,
     1                 4HD.P.,4HILL ,4HDEFN       /
      DATA    FORM  /  4HSQUA,4HRE  ,4HRECT,4HANG ,4HDIAG,4HONAL,4HLOW ,
     1                 4HTRI ,4HUPP ,4HTRI ,4HSYMM,4HETRC,4HVECT,4HOR  ,
     2                 4HIDEN,4HTITY,4HILL ,4HDEFN/
      DATA    BLANK ,  XMATR ,XIX   ,CONT  ,XINUE ,DDX   /
     1        4H    ,  4HMATR,4HIX  ,4HCONT,4HINUE,4HD   /
      DATA    FILE  /  4HUT1 ,4HUT2 ,4HN/A ,4HINPT,4HINP1,4HINP2,4HINP3,
     1                 4HINP4,4HINP5,4HINP6,4HINP7,4HINP8,4HINP9,4HINPT/
      DATA    FMTR  /  '(1X,1P, 8E16.8)',  '(1X,1P,6D21.12)',
     2                 '(1X,1P, 9E14.6)',  '(1X,1P,7D18.10)',
     3                 '(1X,1P,10E13.5)',  '(1X,1P, 8D16.8)',
     4                 '(1X,1P,11E11.3)',  '(1X,1P, 9D14.6)',
     5                 '(1X,1P,12E10.2)',  '(1X,1P,10D13.4)',
     6                 '(1X,1P,13E10.2)',  '(1X,1P,11D11.3)',
     7                 '(1X,1P,14E 9.1)',  '(1X,1P,12D10.2)'/
      DATA    FMTC  /  '(4(1X,1P,E14.7,1HR,  1P,E15.7,1HI))',
     1                 '(3(1X,1P,D20.13,1HR,1P,D21.13,1HI))',
     2                 '(5(1X,1P,E11.4,1HR,  1P,E12.4,1HI))',
     2                 '(4(1X,1P,D14.7,1HR,  1P,D15.7,1HI))',
     3                 '(6(1X,1P,E 9.2,1HR,  1P,E10.2,1HI))',
     3                 '(5(1X,1P,D11.4,1HR,  1P,D12.4,1HI))',
     4                 '(7(1X,1P,E 7.0,1HR,  1P,E 8.0,1HI))',
     4                 '(6(1X,1P,D 9.2,1HR,  1P,D10.2,1H)))'/
C
      NAMEA= IA(1)
      NCOL = IA(2)
      NROW = IA(3)
      IF   = IA(4)
      IT   = IA(5)
      IF (IF .NE. 7) GO TO 5
C
C     ROW VECTOR
C     A ROW OF MATRIX ELEMENTS STORED IN COLUMN FORMAT
C     INTERCHANGE ROW AND COLUMN FOR PRINTING
C
      J    = NCOL
      NCOL = NROW
      NROW = J
    5 IF (IT.LE.0 .OR. IT.GT.4) IT = 5
      IF (IF.LE.0 .OR. IF.GT.8) IF = 9
      IF (NOUT .NE. IOUT) WRITE (IOUT,7) UIM,FILE(NOUT-10),NOUT
    7 FORMAT (A29,', MATRIX PRINTOUT SAVED IN ',A4,' (FORTRAN UNIT',I4,
     1        1H))
      IF (IPRC .EQ. -1) GO TO 80
C
C     SET UP FORMAT FOR OUTPUT PRINT LINE
C
      J = IPRC
      IF (IT .GE. 3) J = IPRC + 2
      GO TO (10,20,30,40), J
   10 J = NPL - 7
      RFMT = FMTR(1,J)
      GO TO 50
   20 J = NPL - 5
      RFMT = FMTR(2,J)
      GO TO 50
   30 J = (NPL/2) - 3
      CFMT = FMTC(1,J)
      GO TO 50
   40 J = (NPL/2) - 2
      CFMT = FMTC(2,J)
   50 NPL1 = NPL - 1
C
C     SET UP P3 AND P4 PRINTOUT OPTIONS
C
      MM = P3
      NN = IA(2)
      IF (P3 .LE. 0) MM = IA(2)
      IF (P4 .LT. 0) GO TO 60
      JUMP = .FALSE.
      NN = IA(2) - P4
      GO TO 70
   60 JUMP = .TRUE.
      JMP4 = -P4
      JMP3 = IABS(P3)
      IF (P3 .EQ. 0) JMP3 = 1
   70 NPLP5 = IA(3)
      IF (P5 .NE. 0) NPLP5 = NPL*P5
CWKBI SPR 93013
      IF ( IT .GT. 2 ) NPLP5 = 2*NPLP5
C
   80 DO 85 I = 1,96
   85 HEAD2(I) = BLANK
      HEAD2(1) = XMATR
      HEAD2(2) = XIX
      HEAD2(6) = CONT
      HEAD2(7) = XINUE
      HEAD2(8) = DDX
      LCOL = KORSZ(COL) - SYSBUF
      INCR = 1
      CALL GOPEN (NAMEA,COL(LCOL+1),0)
      CALL PAGE1
      CALL FNAME (NAMEA,HEAD2(3))
      WRITE (NOUT,90) HEAD2(3),HEAD2(4),NAMEA,TYPE(2*IT-1),TYPE(2*IT),
     1                NCOL,NROW,FORM(2*IF-1),FORM(2*IF)
   90 FORMAT (1H0,6X,7HMATRIX ,2A4,11H (GINO NAME,I4,2H ),6H IS A ,2A4,
     1        1X,I6,10H COLUMN X ,I6,5H ROW ,2A4,8H MATRIX.)
      IF (IT.EQ.5 .OR. NCOL.EQ.0 .OR. NROW.EQ.0) GO TO 460
C
C     IF = 3, DIAGONAL MATRIX
C        = 7, ROW VECTOR
C        = 8, IDENTITY MATRIX
C
      IF (IF-8) 100,440,460
  100 IF (IPRC .EQ. -1) GO TO 510
      IF (IF.NE.3 .AND. IF.NE.7) GO TO 110
      NCOL = 1
      NROW = IA(3)
  110 INULL= 0
      ASSIGN 150 TO IHOP
      JJ = 1
  120 K  = 0
      L  = 0
      CALL UNPACK (*330,NAMEA,COL)
      IF (JJ.LE.MM .OR. JJ.GE.NN) GO TO 130
      K  = NN - MM - 1
      JJ = JJ + K
      IF (JJ .GT. NCOL) GO TO 340
      CALL SKPREC (NAMEA,K)
      GO TO 340
  130 IF (.NOT.JUMP) GO TO 140
      IF (MOD(JJ,JMP4) .NE. JMP3) GO TO 340
  140 IF (INULL .EQ. 1) GO TO 490
  150 NROW = L - K + 1
      GO TO (160,160,360,160,160,160,380), IF
  160 WRITE (NOUT,170) JJ,K,L
      LINE = LINE + 3
      IF (LINE .GE. NLPP) CALL PAGE
  170 FORMAT (8H0COLUMN ,I6,5X,6H ROWS ,I6,6H THRU ,I6,5X,50(1H-),/,1H )
      IF (IT .GT. 2) NROW = 2*NROW
  180 K = 0
  190 J = K + 1
      IF (J .GT.  NROW) GO TO 340
      K = J + NPL1
      IF (K .GT.  NROW) K = NROW
      IF (K .GT. NPLP5) GO TO 340
      KJ = K - J
      GO TO (210,240,270,300), IT
C
  200 LN = (KJ+NPL1)/NPL
      LINE = LINE + LN
      IF (LINE .GE. NLPP) CALL PAGE
      GO TO 190
C
C     REAL SINGLE PRECISION
C
  210 IF (IPRC .EQ. 2) GO TO 220
      WRITE  (NOUT,RFMT) (COL(I),I=J,K)
C 215 FORMAT (1X,1P,10E13.5)
C     LN = (KJ+10)/10
      GO TO 200
  220 I = K
      DO 230 LN = J,K
      DCOL(I) = COL(I)
  230 I = I - 1
C
C     REAL DOUBLE PRECISION
C
  240 IF (IPRC .EQ. 1) GO TO 250
      WRITE  (NOUT,RFMT) (DCOL(I),I=J,K)
C 245 FORMAT (1X,1P,8D16.8)
C     LN = (KJ+8)/8
      GO TO 200
  250 DO 260 I = J,K
  260 COL(I) = DCOL(I)
      GO TO 210
C
C     COMPLEX SINGLE
C
  270 IF (IPRC .EQ. 2) GO TO 280
      WRITE  (NOUT,CFMT) (COL(I),I=J,K)
C 275 FORMAT (1X,5(1P,E12.4,1HR,1P,E12.4,1HI))
C     LN = (KJ+10)/10
      GO TO 200
  280 I = K
      DO 290 LN = J,K
      DCOL(I) = COL(I)
  290 I = I - 1
C
C     COMPLEX DOUBLE
C
  300 IF (IPRC .EQ. 1) GO TO 310
      WRITE  (NOUT,CFMT) (DCOL(I),I=J,K)
C 305 FORMAT (1X,4(1P,D15.8,1HR,1P,D15.8,1HI))
C     LN = (KJ+8)/8
      GO TO 200
  310 DO 320 I = J,K
  320 COL(I) = DCOL(I)
      GO TO 270
C
  330 IF (INULL .EQ. 1) GO TO 340
      INULL = 1
      IBEGN = JJ
  340 JJ    = JJ + 1
      IF (JJ  .LE. NCOL) GO TO 120
      ASSIGN 350 TO IHOP
      IF (INULL .EQ. 1) GO TO 490
  350 CALL CLOSE (NAMEA,1)
      GO TO 400
  360 WRITE (NOUT,370) K,L
      LINE = LINE + 2
  370 FORMAT ('0DIAGONAL ELEMENTS FOR COLUMNS',I6,4H TO ,I6,4H ARE,///)
      GO TO 180
  380 WRITE (NOUT,390) K,L
      LINE = LINE + 2
  390 FORMAT ('0ROW ELEMENTS FOR COLUMNS',I6,4H TO ,I6,4H ARE,///)
      GO TO 180
  400 WRITE  (NOUT,410) IA(6)
  410 FORMAT ('0THE NUMBER OF NON-ZERO WORDS IN THE LONGEST RECORD =',
     1       I8)
      IA7A = IA(7) / 100
      IA7C = IA(7) - 100*IA7A
      IA7B = IA7C / 10
      IA7C = IA7C - 10*IA7B
      WRITE  (NOUT,420) IA7A,IA7B,IA7C
  420 FORMAT ('0THE DENSITY OF THIS MATRIX IS ',I3,1H.,2I1,' PERCENT.')
      GO TO 750
C
  440 WRITE  (NOUT,450)
  450 FORMAT ('0IDENTITY MATRIX')
  460 CALL CLOSE (NAMEA,1)
C
C     FUNNY MATRIX - SAVE MODULE PARAMETERS AND TABLE PRINT IT
C
      DO 470 I = 1,5
  470 PX(I) = P12(I)
      P12(1) = IBLNK
      P12(2) = IBLNK
      P3     = 3
      P4     = 3
      CALL TABPRT (NAMEA)
      DO 480 I = 1,5
  480 P12(I) = PX(I)
      GO TO 750
  490 IFIN = JJ - 1
      WRITE (NOUT,500) IBEGN,IFIN
      INULL = 0
      LINE  = LINE + 2
      IF (LINE .GE. NLPP) CALL PAGE
  500 FORMAT ('0COLUMNS ',I7,6H THRU ,I7,' ARE NULL.')
      GO TO IHOP, (150,350)
C
C     PRINT ONLY THE DIAGONAL ELEMENTS, IPRC = -1
C     TO CHECKOUT THE DIAGONALS FOR POSSIBLE MATRIX SINGULARITY
C
  510 WRITE  (NOUT,520)
  520 FORMAT (/23X,'(ELEMENTS ON DIAGONAL ONLY)')
      IF (NCOL .NE. NROW) WRITE (NOUT,530)
  530 FORMAT (23X,'*** MATRIX IS NOT SQUARE ***')
      WRITE  (NOUT,540)
  540 FORMAT (1X)
      NN = MIN0(NCOL,NROW)
      JJ = 0
      DO 570 I = 1,NN
      K  = I
      L  = I
      CALL UNPACK (*550,NAMEA,COL(JJ+1))
      GO TO 570
  550 DO 560 J = 1,IT
  560 COL(JJ+J) = 0.0
  570 JJ = JJ + IT
      CALL CLOSE (NAMEA,1)
      GO TO (580,600,620,640), IT
  580 WRITE  (NOUT,590) (COL(J),J=1,JJ)
  590 FORMAT (1X,1P,10E13.6)
      GO TO 660
  600 JJ = JJ/2
      WRITE  (NOUT,610) (DCOL(J),J=1,JJ)
  610 FORMAT (1X,1P,10D13.6)
      GO TO 660
  620 WRITE  (NOUT,630) (COL(J),J=1,JJ)
  630 FORMAT ((1X,5(1P,E12.5,1HR,1P,E12.5,1HI)))
      GO TO 660
  640 JJ = JJ/2
      WRITE  (NOUT,650) (DCOL(J),J=1,JJ)
  650 FORMAT ((1X,5(1P,D12.5,1HR,1P,D12.5,1HI)))
  660 KJ = IT
      IF (IT .GE. 3) KJ = IT - 2
      NN = 0
      MM = 1
      DO 680 J = 1,JJ
      LN = MM + IT - 1
      DO 670 I = MM,LN
      IF (COL(I) .NE. 0.0) GO TO 680
  670 CONTINUE
      NN = NN + 1
      ICOL(NN) = J
  680 MM = MM + KJ
      IF (NN .EQ. 0) GO TO 710
      MM = MIN0(NN,200)
      WRITE  (NOUT,690) (ICOL(I),I=1,MM)
  690 FORMAT ('0*** ZERO DIAGONALS IN THE FOLLOWING COLUMNS -',
     1       /,(1X,20I6))
      IF (NN .GT. 200) WRITE (NOUT,700)
  700 FORMAT (' ...AND MORE')
      GO TO 730
  710 WRITE  (NOUT,720)
  720 FORMAT ('0*** NO ZERO ON DIAGONALS')
  730 WRITE  (NOUT,740) IA
  740 FORMAT (/5X,'GINO FILE',I5,'   TRAILER =',6I7)
      LINE = LINE + NLPP
C
  750 RETURN
      END

      SUBROUTINE CRSUB (NAME,I)
C
C     THE SUBROUTINE CREATES AN ENTRY FOR THE SUBSTRUCTURE NAME IN THE
C     DIT THE OUTPUT PARAMETER I INDICATES THAT THE SUBSTRUCTURE NAME
C     IS THE ITH SUBSTRUCTURE IN THE DIT.
C
      LOGICAL         DITUP
      INTEGER         BUF,DIT,DITPBN,DITLBN,DITSIZ,DITNSB,DITBL
      DIMENSION       NAME(2),IEMPTY(2),NMSBR(2)
      COMMON /ZZZZZZ/ BUF(1)
      COMMON /SOF   / DIT,DITPBN,DITLBN,DITSIZ,DITNSB,DITBL,
     1                IODUM(8),MDIDUM(4),NXTDUM(15),DITUP
      DATA    IEMPTY/ 2*4H    /
      DATA    INDSBR/ 1 /, NMSBR /4HCRSU,4HB   /
C
      CALL CHKOPN (NMSBR(1))
      IF (DITSIZ .EQ. DITNSB*2) GO TO 10
C
C     THERE IS AN EMPTY INTERNAL DIRECTORY SPACE IN THE MDI.
C
      CALL FDSUB (IEMPTY(1),I)
      IF (I .NE. -1) GO TO 20
      GO TO 30
C
C     NO INTERNAL EMPTY SPACE IN THE MDI.  DIRECTORY FOR THE NEW
C     SUBSTRUCTURE
C
   10 DITSIZ = DITSIZ + 2
      I = DITSIZ/2
C
C     UPDATE DIT.
C
   20 DITNSB = DITNSB + 1
      CALL FDIT (I,JDIT)
      BUF(JDIT  ) = NAME(1)
      BUF(JDIT+1) = NAME(2)
      DITUP = .TRUE.
      RETURN
C
C     ERROR MESSAGES.
C
   30 CALL ERRMKN (INDSBR,5)
      RETURN
      END

      SUBROUTINE OLDEL3
C
C     ANY ELEMENT (NEW OR OLD) WHICH HAS NOT BEEN CONVERTED TO USE
C     EMGPRO SHOULD HAVE AN ENTRY POINT IN OLDEL1, OLDEL2, OR OLDEL3
C     ***************************************************************
C
      ENTRY TETRAS
      GO TO 10
      ENTRY TETRAD
      GO TO 10
      ENTRY TRAPRS
      GO TO 10
      ENTRY TRAPRD
      GO TO 10
      ENTRY TRIARS
      GO TO 10
      ENTRY TRIARD
      GO TO 10
      ENTRY TRIA1S
      GO TO 10
      ENTRY TRIA1D
      GO TO 10
      ENTRY TRIA2S
      GO TO 10
      ENTRY TRIA2D
      GO TO 10
      ENTRY TRPLTS
      GO TO 10
      ENTRY TRPLTD
      GO TO 10
      ENTRY WEDGES
      GO TO 10
      ENTRY WEDGED
C
 10   CALL EMGOLD
      RETURN
      END

      SUBROUTINE APD3
C
      EXTERNAL        ORF
      LOGICAL         CNTRL1,CNTRL2,CRANK1,CRANK2
      INTEGER         NAM(2),IZ(1),BACK,PSPA,RET,IC(16),EID,PID,CIDBX,
     1                SILB,SCR1,ECTA,BGPA,GPLA,USETA,SILA,ACPT,BUF10,
     2                CA3S,CA3E,PA3S,PA3E,AUSET(6,2),SILC,ORF,USA,UK,
     3                EIDB,SILDX(2),ACSIX(4),CID(5),NECTA(2)
      REAL            VX1(3),VX2(3),ACPL(3,3),RB1(3)
      DIMENSION       IHEAD(10),BND(24)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /BLANK / NK,NJ,LUSETA
      COMMON /APD1C / EID,PID,CP,NSPAN,NCHORD,LSPAN,LCHORD,IGID,
     1                X1,Y1,Z1,X12,X4,Y4,Z4,X43,XOP,X1P,ALZO,MCSTM,
     2                NCST1,NCST2,CIDBX,ACSID,IACS,SILB,NCRD,SCR1,
     3                SCR2,SCR3,SCR4,SCR5,ECTA,BGPA,GPLA,USETA,SILA,
     4                CSTMA,ACPT,BUF10,BUF11,BUF12,NEXT,LEFT,ISILN,
     5                NCAM,NAEF1,NAEF2,
     6                NCA1,NCA2,CA2S,CA2E,CA3S,CA3E,CA4S,CA4E,
     7                NPA1,NPA2,PA2S,PA2E,PA3S,PA3E,PA4S,PA4E
      COMMON /APD1D / ICPL(14),YP4,S1,C1,XP2,XP3,XP4,RA1(3)
      COMMON /ZZZZZZ/ Z(1)
      COMMON /BITPOS/ IBIT(64)
      COMMON /TWO   / ITWO(32)
      COMMON /SYSTEM/ SYSBUF,NOT
      EQUIVALENCE     (ICPL(3),RB1(1)),(ICPL(6),ACPL(1,1)),
     1                (NECTA(1),EIDB),(NECTA(2),CID(1)),
     2                (ACSIX(2),VX2(1)),(SILDX(1),ICID),
     3                (Z(1),IZ(1)),(EID,IC(1)),
     4                (CRANK1,IHEAD(3)),(CRANK2,IHEAD(4)),
     5                (CNTRL1,IHEAD(5)),(CNTRL2,IHEAD(6))
      DATA     NAM  / 4HAPD3,4H    /
C
      NOGO = 0
      LCA  = 16
      NC3  = ((CA3E-CA3S)+1)/LCA
      NCAM = NCAM+NC3
C
C     INITIAL SETUP
C
      I17 = IBIT(17)
      I18 = IBIT(18)
      I19 = IBIT(19)
      I20 = IBIT(20)
      PSPA= ORF(ITWO(I17),ITWO(I20))
      USA = ORF(PSPA,ITWO(I18))
      UK  = ORF(ITWO(I19),ITWO(I20))
      DO 5 J = 1,2
      DO 5 I = 1,6
    5 AUSET(I,J) = USA
      AUSET(3,2) = UK
      IHEAD(1) = 3
      SILC = SILB
C
C     LOOP ON NC3 MOVING CAERO3 CARD TO COMMON
C
      DO 400 I = 1,NC3
      N = (I-1)*LCA - 1
      DO 10 J = 1,LCA
      IC(J) = IZ(CA3S+N+J)
   10 CONTINUE
      MCSTM = MCSTM + 1
      IZ(CA3S+N+2) = MCSTM
      IZ(CA3S+N+8) = 3
      ACSIX(1) = MCSTM
C
C     GET POINTS IN PROPER COORD SYSTEM
C
      CALL APDCS
C
C     FIND PAERO3 CARD
C
      J = PA3S
   20 IF (J .GE. PA3E) GO TO 999
      IF (IZ(J) .EQ. PID) GO TO 30
      J = J + 4 + IZ(J+3)
      GO TO 20
   30 IPID = J
      IHEAD(7) = IZ(IPID+1)
      CRANK1 = .FALSE.
      CRANK2 = .FALSE.
      IF (Z(IPID+5) .GT. 0.0) CRANK1 = .TRUE.
      IF (Z(IPID+7) .GT. 0.0) CRANK2 = .TRUE.
      CNTRL1 = .FALSE.
      CNTRL2 = .FALSE.
      IF (IZ(IPID+2) .GT. 0 ) CNTRL1 = .TRUE.
      IF (IZ(IPID+2) .EQ. 2 ) CNTRL2 = .TRUE.
C
C     GENERATE AERO POINTS FOR CAERO3  PUT POINTS 1-4 IN BGPDT
C
      DO 40 J = 13,24
   40 BND(J) = 0.0
      VX1(3) = 0.0
      KK = 1
      ASSIGN 50 TO BACK
      IBS = NCRD + 1
      VX1(1) = 0.0
      VX1(2) = 0.0
      BND(1) = 0.0
      BND(2) = 0.0
      GO TO 300
   50 ASSIGN 60 TO BACK
      VX1(1) = X12
      VX1(2) = 0.0
      BND(7) = X12
      BND(8) = 0.0
      GO TO 300
   60 VX1(1) = XP4
      VX1(2) = YP4
      BND(5) = XP4
      BND(6) = YP4
      ASSIGN 70 TO BACK
      GO TO 300
   70 ASSIGN 80 TO BACK
      VX1(1) = XP4 + X43
      VX1(2) = YP4
      BND(11) = VX1(1)
      BND(12) = VX1(2)
      GO TO 300
C
C     ADD POINTS 5 AND 6 IF THEY EXIST
C
   80 BND(3) = BND(5)
      BND(4) = BND(6)
      IF (.NOT.CRANK1) GO TO 90
      VX1(1) = Z(IPID+4)
      VX1(2) = Z(IPID+5)
      BND(3) = VX1(1)
      BND(4) = VX1(2)
      ASSIGN 90 TO BACK
      GO TO 300
   90 BND(9) = BND(11)
      BND(10) = BND(12)
      IF (.NOT.CRANK2) GO TO 100
      VX1(1) = Z(IPID+6)
      VX1(2) = Z(IPID+7)
      BND(9) = VX1(1)
      BND(10)= VX1(2)
      ASSIGN 100 TO BACK
      GO TO 300
C
C      ADD CONTROLS
C
  100 IF (.NOT.CNTRL1) GO TO 120
      ASSIGN 101 TO BACK
      VX1(1)  = Z(IPID+8)
      VX1(2)  = Z(IPID+9)
      BND(15) = VX1(1)
      BND(16) = VX1(2)
      GO TO 300
  101 ASSIGN 102 TO BACK
      VX1(1)  = Z(IPID+10)
      VX1(2)  = Z(IPID+11)
      BND(13) = VX1(1)
      BND(14) = VX1(2)
      GO TO 300
  102 ASSIGN 103 TO BACK
      VX1(1)  = Z(IPID+12)
      VX1(2)  = Z(IPID+13)
      BND(17) = VX1(1)
      BND(18) = VX1(2)
      GO TO 300
  103 ASSIGN 104 TO BACK
      VX1(1)  = Z(IPID+14)
      VX1(2)  = Z(IPID+15)
      BND(21) = VX1(1)
      BND(22) = VX1(2)
      GO TO 300
  104 IF (.NOT.CNTRL2) GO TO 120
      ASSIGN 105 TO BACK
      VX1(1)  = Z(IPID+16)
      VX1(2)  = Z(IPID+17)
      BND(19) = VX1(1)
      BND(20) = VX1(2)
      GO TO 300
  105 ASSIGN 120 TO BACK
      VX1(1)  = Z(IPID+18)
      VX1(2)  = Z(IPID+19)
      BND(23) = VX1(1)
      BND(24) = VX1(2)
      GO TO 300
C
C     CONNECT POINT TO BOXES FOR ECTA
C
  120 EIDB   = EID
      CID(1) = IBS
      CID(2) = IBS + 1
      CID(5) = IBS
      IF (CRANK1) GO TO 121
      IF (CRANK2) GO TO 122
      CID(3) = IBS + 3
      CID(4) = IBS + 2
      GO TO 124
  121 IF (CRANK2) GO TO 123
      CID(3) = IBS + 3
      CID(4) = IBS + 4
      GO TO 124
  122 CID(3) = IBS + 4
      CID(4) = IBS + 2
      GO TO 124
  123 CID(3) = IBS + 5
      CID(4) = IBS + 4
  124 CONTINUE
      CALL WRITE (ECTA,NECTA,6,0)
      EIDB   = EIDB + 1
      CID(1) = IBS + 2
      CID(2) = IBS + 3
      CID(5) = IBS + 2
      IBS    = IBS + 4
      IF (.NOT.CRANK1 .AND. .NOT.CRANK2) GO TO 130
      IF (CRANK1 .AND. CRANK2) GO TO 125
      CID(3) = IBS
      CID(4) = CID(5)
      IBS = IBS + 1
      GO TO 129
  125 CID(3) = IBS + 1
      CID(4) = IBS
      IBS    = IBS + 2
  129 CALL WRITE (ECTA,NECTA,6,0)
      EIDB   = EIDB + 1
  130 IF (.NOT.CNTRL1) GO TO 135
      CID(1) = IBS + 2
      CID(2) = IBS + 3
      CID(3) = IBS + 1
      CID(4) = IBS
      CID(5) = IBS + 2
      CALL WRITE (ECTA,NECTA,6,0)
      EIDB   = EIDB + 1
      IF (.NOT.CNTRL2) GO TO 135
      CID(3) = IBS+5
      CID(4) = IBS+4
      CALL WRITE (ECTA,NECTA,6,0)
C
C     FIND CONTROL POINTS FOR ELEMENT
C
  135 CALL APDOE (NSPAN,IZ,NAEF1,NAEF2,ILW,NWW)
      IF (ILW .EQ. 0) GO TO 998
      IF (NWW .LT. 6) GO TO 998
      IF (MOD(NWW,2) .NE. 0) GO TO 998
      ILC1 = 0
      ILC2 = 0
      NWC1 = 0
      NWC2 = 0
      IF (.NOT.CNTRL1) GO TO 140
      CALL APDOE (NCHORD,IZ,N AEF1,NAEF2,ILC1,NWC1)
      IF (ILC1 .EQ. 0) GO TO 997
      IF (NWC1 .LT. 6) GO TO 997
      IF (MOD(NWC1,2) .NE. 0) GO TO 997
      IF (.NOT.CNTRL2) GO TO 140
      CALL APDOE (LSPAN,IZ,NAEF1,NAEF2,ILC2,NWC2)
      IF (ILC2 .EQ. 0) GO TO 996
      IF (NWC2 .LT. 6) GO TO 996
      IF (MOD(NWC2,2) .NE. 0) GO TO 996
  140 IHEAD( 8) = NWW/2
      IHEAD( 9) = NWC1/2
      IHEAD(10) = NWC2/2
      IHEAD( 2) = IHEAD(8)+IHEAD(9)+IHEAD(10)
      NK = NK + IHEAD(2)
      NJ = NJ + IHEAD(2)
      IZ(CA3S+N+4) = IHEAD(2)
      IZ(CA3S+N+5) = 1
C
C     START THE ACPT AND ADD THE CONTROL POINTS IN A LOOP
C
      CALL WRITE (ACPT,IHEAD,10,0)
      CALL WRITE (ACPT,BND,24,0)
      EIDB = EID - 1
      KK  = 2
      NN  = NWW
      KKK = ILW - 1
      ASSIGN 150 TO RET
      GO TO 190
  150 IF (IHEAD(9) .EQ. 0) GO TO 180
      ASSIGN 160 TO RET
      NN  = NWC1
      KKK = ILC1 - 1
      GO TO 190
  160 IF (IHEAD(10) .EQ. 0) GO TO 180
      ASSIGN 180 TO RET
      NN  = NWC2
      KKK = ILC2 - 1
      GO TO 190
  180 CALL WRITE (ACPT,0,0,1)
C
C     GEOMETRY CHECKS
C
      NM = 0
      IF (BND(1) .GT.  BND(3)) NM = 1
      IF (BND(3) .GT.  BND(5)) NM = 1
      IF (BND(15).GT. BND(17)) NM = 1
      IF (CNTRL2 .AND. BND(17).GT.BND(19)) NM = 1
      IF (BND(16) .LT. BND(14)) NM = 1
      IF (BND(18) .LT. BND(22)) NM = 1
      IF (BND(20) .LT. BND(24)) NM = 1
      IF (NM .EQ. 1) NOGO = 1
      IF (NM .EQ. 1) WRITE (NOT,1851) UFM,EID
 1851 FORMAT (A23,' 2278, PLANFORM GEOMETRY FOR CAERO3 ID',I9,
     1       ' IS IN ERROR', /5X,'CHECK SWEEP  ANGLE FOR LEADING EDGE ',
     2       'OR CONTROL SURFACE HINGE LINE.')
      GO TO 400
C
C     PUT CONTROL POINTS IN TABLE
C
  190 J = 2
  195 CONTINUE
      VX1(1) = Z(KKK+J  )
      VX1(2) = Z(KKK+J+1)
      CALL WRITE (ACPT,VX1,2,0)
      ASSIGN 200 TO BACK
      GO TO 300
  200 CONTINUE
      J = J + 2
      IF (J .LE. NN) GO TO 195
      GO TO RET, (150,160,180)
C
C     BGPA  GPL  USET
C
  300 CALL GMMATS (ACPL,3,3,0,VX1,3,1,0,VX2)
      DO 310 K = 1,3
  310 VX2(K) = VX2(K) + RB1(K)
      CALL WRITE (BGPA,ACSIX,4,0)
      IF (KK .EQ. 2) GO TO 320
      CIDBX = CIDBX + 1
      ICID  = CIDBX
      GO TO 330
  320 EIDB  = EIDB + 1
      ICID  = EIDB
  330 CALL WRITE (GPLA,ICID,1,0)
      CALL WRITE (USETA,AUSET(1,KK),6,0)
C
C     SIL AND EQEXIN
C
      NCRD  = NCRD + 1
      SILC  = SILC + 6
      ISILN = ISILN + 6
      LUSETA= SILC
      SILDX(2) = 10*SILC + 1
      CALL WRITE (SILA,SILC,1,0)
      CALL WRITE (SCR2,ISILN,1,0)
      CALL WRITE (SCR2,SILC,1,0)
      CALL WRITE (SCR1,ICID,2,0)
      GO TO BACK, (50,60,70,80,90,100,101,102,103,104,105,120,200)
  400 CONTINUE
      SILB = SILC
      IF (NOGO .EQ. 1) GO TO 1001
 1000 RETURN
C
C     ERROR MESSAGES
C
  996 I = LSPAN
      GO TO 9941
  997 I = NCHORD
      GO TO 9941
  998 I = NSPAN
 9941 WRITE  (NOT,9942) UFM,I,EID
 9942 FORMAT (A23,' 2429, WRONG NUMBER OF WORDS OR CARD NOT FOUND FOR ',
     1       'CARD ID',I9, /29X,'ASSOCIATED WITH CAERO3 ID',I9)
      GO TO 1001
  999 CALL EMSG (0,2323,1,2,0)
      WRITE  (NOT,891) PID,EID
  891 FORMAT (10X,16HPAERO3 CARD NO. ,I8,31H REFERENCED BY CAERO3 CARD N
     *O. ,I8,15H DOES NOT EXIST)
 1001 CALL MESAGE (-61,0,NAM)
      GO TO 1000
      END

      SUBROUTINE PIKLVL (*,LVLS1,LVLS2,CCSTOR,IDFLT,ISDIR,XC,NHIGH,
     1                   NLOW,NACUM,SIZE,STPT)
C
      INTEGER          CCSTOR(1), SIZE(1), STPT(1),  XC,  END, TEMP
      DIMENSION        NHIGH(1),  NLOW(1), NACUM(1), LVLS1(1), LVLS2(1)
      COMMON /BANDG /  IDUM,      IDPTH
C
C     THIS ROUTINE IS USED ONLY BY GIBSTK OF BANDIT MODULE
C
C     PIKLVL CHOOSES THE LEVEL STRUCTURE  USED IN NUMBERING GRAPH
C
C     LVLS1-    ON INPUT CONTAINS FORWARD LEVELING INFO
C     LVLS2-    ON INPUT CONTAINS REVERSE LEVELING INFO
C               ON OUTPUT THE FINAL LEVEL STRUCTURE CHOSEN
C     CCSTOR-   ON INPUT CONTAINS CONNECTED COMPONENT INFO
C     IDFLT-    ON INPUT =1 IF WDTH LVLS1'WDTH LVLS2, =2 OTHERWISE
C     NHIGH     KEEPS TRACK OF LEVEL WIDTHS FOR HIGH NUMBERING
C               DIMENSION OF NHIGH IS MAXIMUM ALLOWABLE NUMBER OF LEVELS
C     NLOW-     KEEPS TRACK OF LEVEL WIDTHS FOR LOW NUMBERING
C     NACUM-    KEEPS TRACK OF LEVEL WIDTHS FOR CHOSEN LEVEL STRUCTURE
C     XC-       NUMBER OF MAXIMUM ALLOWABLE CONNECTED COMPONENTS
C               (IS THE DIMENSION FOR SIZE AND STPT)
C     SIZE(I)-  SIZE OF ITH CONNECTED COMPONENT
C     STPT(I)-  INDEX INTO CCSTORE OF 1ST NODE IN ITH CON COMPT
C     ISDIR-    FLAG WHICH INDICATES WHICH WAY THE LARGEST CONNECTED
C               COMPONENT FELL.  =+1 IF LOW AND -1 IF HIGH
C
C
C     PART 1 -
C     ========
C     SORTS SIZE AND STPT HERE, IN DECENDING ORDER
C     (PREVIOUS SORT2 ROUTINE IS NOW MOVED INTO HERE.
C     THE ORIGINAL BUBBLE SORT HAS BEEN REPLACED BY THE MODIFIED SHELL
C     SORT WHICH IS MUCH FASTER   /G.CHAN,  MAY 1988)
C
      IF (XC .EQ. 0) RETURN 1
      M=XC
   10 M=M/2
      IF (M .EQ. 0) GO TO 70
      J=1
      K=XC-M
   20 I=J
   30 N=I+M
      IF (SIZE(N)-SIZE(I)) 60,60,50
   50 TEMP   =SIZE(I)
      SIZE(I)=SIZE(N)
      SIZE(N)=TEMP
      TEMP   =STPT(I)
      STPT(I)=STPT(N)
      STPT(N)=TEMP
      I=I-M
      IF (I .GE. 1) GO TO 30
   60 J=J+1
      IF (J-K) 20,20,10
   70 CONTINUE
C
C
C     PART 2 -
C     ========
C     CHOOSES THE LEVEL STRUCTURE USED IN NUMBERING GRAPH
C
C
C     FOR EACH CONNECTED COMPONENT DO
C
      DO 270 I=1,XC
      J  =STPT(I)
      END=SIZE(I)+J-1
C
C     SET NHIGH AND NLOW EQUAL TO NACUM
C
      DO 200 K=1,IDPTH
      NHIGH(K)=NACUM(K)
      NLOW(K) =NACUM(K)
  200 CONTINUE
C
C     UPDATE NHIGH AND NLOW FOR EACH NODE IN CONNECTED COMPONENT
C
      DO 210 K=J,END
      INODE=CCSTOR(K)
      LVLNH=LVLS1(INODE)
      NHIGH(LVLNH)=NHIGH(LVLNH)+1
      LVLNL=LVLS2(INODE)
      NLOW(LVLNL)=NLOW(LVLNL)+1
  210 CONTINUE
      MAX1=0
      MAX2=0
C
C     SET MAX1=LARGEST NEW NUMBER IN NHIGH
C     SET MAX2=LARGEST NEW NUMBER IN NLOW
C
      DO 220 K=1,IDPTH
      IF (2*NACUM(K).EQ.NLOW(K)+NHIGH(K)) GO TO 220
      IF (NHIGH(K).GT.MAX1) MAX1=NHIGH(K)
      IF (NLOW(K) .GT.MAX2) MAX2=NLOW(K)
  220 CONTINUE
C
C     SET IT= NUMBER OF LEVEL STRUCTURE TO BE USED
C
      IT=1
      IF (MAX1.GT.MAX2) IT=2
      IF (MAX1.EQ.MAX2) IT=IDFLT
      IF (IT.EQ.2) GO TO 250
      IF (I .EQ.1) ISDIR=-1
C
C     COPY LVLS1 INTO LVLS2 FOR EACH NODE IN CONNECTED COMPONENT
C
      DO 230 K=J,END
      INODE=CCSTOR(K)
      LVLS2(INODE)=LVLS1(INODE)
  230 CONTINUE
C
C     UPDATE NACUM TO BE THE SAME AS NHIGH
C
      DO 240 K=1,IDPTH
      NACUM(K)=NHIGH(K)
  240 CONTINUE
      GO TO 270
C
C     UPDATE NACUM TO BE THE SAME AS NLOW
C
  250 DO 260 K=1,IDPTH
      NACUM(K)=NLOW(K)
  260 CONTINUE
  270 CONTINUE
      RETURN
      END

      SUBROUTINE GMPRTN(FILEA,FILE11,FILE21,FILE12,FILE22,RPART,CPART,
     1           NSUB0,NSUB1,CORE,LCORE)
C
C     GENERAL MATRIX PARTION ROUTINE
C
C
C                              --               --
C                              I        I        I
C                  --     --   I FILE11 I FILE12 I
C                  I       I   I        I        I
C                  I FILEA I = I-----------------I
C                  I       I   I        I        I
C                  --     --   I FILE21 I FILE22 I
C                              I        I        I
C                              --               --
C
C        WHERE
C
C             RPART - ROW PARTITIONING VECTOR
C             CPART - COLUMN PARTITION VECTOR
C
      INTEGER       FILEA    ,FILE11   ,FILE12   ,FILE21   ,FILE22
     1             ,RPART    ,CPART    ,RULE     ,CORE(6)  ,NAME(2)
     2             ,RP(7)    ,CP(7)
C
      COMMON / PARMEG /       IA(7)    ,IA11(7)  ,IA21(7)  ,IA12(7)
     1                       ,IA22(7)  ,LCR      ,RULE
C
      DATA NAME / 4HGMPR , 4HTN   /
C
C***********************************************************************
C
C     GET TRAILERS FOR INPUTS
C
      RP(1) = RPART
      IF(RPART .NE. 0) CALL RDTRL(RP)
      CP(1) = CPART
      IF(CPART .NE. 0) CALL RDTRL(CP)
      IA(1) = FILEA
      CALL RDTRL(IA)
C
C     SET UP MATRIX CONTROL BLOCKS FOR OUTPUTS
C
      IA11(1) = FILE11
      IA12(1) = FILE12
      IA21(1) = FILE21
      IA22(1) = FILE22
C
      DO 10 I=2,5
      IA11(I) = IA(I)
      IA12(I) = IA(I)
      IA21(I) = IA(I)
   10 IA22(I) = IA(I)
C
C     SET UP DUMMY PARTITION VECTOR
C
      CORE(1) = 0
      CORE(2) = 1
      CORE(3) = IA(2)
      CORE(4) = 2
      CORE(5) = 1
      CORE(6) = 0
C
      RULE = 0
      LCR = LCORE
C
      IF(RPART .EQ. 0) GO TO 30
      IF(CPART .EQ. 0) GO TO 20
C
C     FULL PARTITION
C
      IA11(3) = NSUB0
      IA12(3) = NSUB0
      IA21(3) = NSUB1
      IA22(3) = NSUB1
      CALL PARTN(RP,CP,CORE)
      GO TO 40
C
C  *  *  PARTITION COLUMNS ONLY
C
   20 CALL PARTN(RP,CORE,CORE)
      GO TO 40
C
C  *  *  PARTITION ROWS ONLY
C
   30 IF(CPART .EQ. 0) GO TO 1007
      IA11(3) = NSUB0
      IA12(3) = NSUB0
      IA21(3) = NSUB1
      IA22(3) = NSUB1
      CALL PARTN(CORE,CP,CORE)
C
C     WRITE TRAILERS FOR OUTPUTS
C
   40 IF(IA11(1) .NE. 0) CALL WRTTRL(IA11)
      IF(IA12(1) .NE. 0) CALL WRTTRL(IA12)
      IF(IA21(1) .NE. 0) CALL WRTTRL(IA21)
      IF(IA22(1) .NE. 0) CALL WRTTRL(IA22)
C
      RETURN
C
C     ILLEGAL INPUT - NO PARTITION VECTOR
C
 1007 CALL MESAGE(-7,0,NAME)
      RETURN
      END

       program chkfil                                                   
       character*80 card                                                
       read(5,901) card                                                 
901    format(a80)                                                      
       inptp = index( card, 'NPTP' )                                    
       iplt2 = index( card, 'PLT'  )                                    
       iexit = 0                                                        
       if ( inptp .ne. 0 ) iexit = 1                                    
       if ( iplt2 .ne. 0 ) iexit = iexit + 10                           
       if ( iexit .eq. 0 ) go to 700
       if ( iexit .eq. 1 ) open ( 77, file='nogood1', status='unknown' )
       if ( iexit .eq. 10) open ( 77, file='nogood2', status='unknown' )
       if ( iexit .eq. 11) open ( 77, file='nogood3', status='unknown' )
       write ( 77, * ) ' iexit=',iexit
       close ( 77 )
700    call exit( iexit )                                               
       end                                                              

      SUBROUTINE ROTATE1 (A,ROW,ROW1,ROW2, O,SIN,COS)
C
C     ROTATION OF A MATRIX PARTITION.
C     THIS ROUTINE IS CALLED ONLY BY TRIDI SUBROUTINE, WHICH IS CALLED
C     ONLY BY VALVEC
C
      INTEGER          ROW,ROW1,ROW2
      REAL             A(1)
      REAL             O(1),SIN(1),COS(1),SINE,COSINE,X,Y,Z
      COMMON /GIVN  /  TITLE(100),N
C
C     O     = 2ND ROW OF THE COMPLETE MATRIX.
C     SIN   = SINES.
C     COS   = COSINES.
C     A  = MATRIX PARTITION (TRIANGULAR) - SINGLE PRECISION
C
      M    = 0
      DO 105 J = ROW1,ROW2
      SINE = SIN(J)
      COSINE = COS(J)
      M    = M + 1
      IF (SINE .EQ. 0.) GO TO 101
      X    = O(ROW+1)*COSINE + O(J)*SINE
      Y    = A(M)    * SINE  + O(J)*COSINE
      Z    = X       *COSINE + Y   *SINE
      O(J) = Y       *COSINE - X   *SINE
      A(M) = O(ROW+1) + A(M) - Z
      O(ROW+1) = Z
  101 IF (J .EQ. N) GO TO 105
      JP1  = J + 1
      DO 103  I = JP1,N
      M    = M + 1
      X    = A(M)*COSINE - O(I)*SINE
      O(I) = O(I)*COSINE + A(M)*SINE
      Y    = COS(I)*O(J) + SIN(I)*X
      A(M) = COS(I)*X    - SIN(I)*O(J)
      O(J) = Y
  103 CONTINUE
  105 CONTINUE
      RETURN
      END

        SUBROUTINE DSBRC1
      INCLUDE 'DSIOF.COM'
      INCLUDE 'XNSTRN.COM'
C        PRINT *,' DSBRC1-1,NBLOCK,INDCLR,INDBAS=',NBLOCK,INDCLR,INDBAS
        IF ( INDCLR .NE. INDCBP ) GO TO 20
        IF ( ( INDCLR-INDBAS ) .NE. 5 ) GO TO 10
        IF ( NBLOCK .EQ. 1 ) GO TO 100
        CALL DSRDPB
        INDCBP = INDCBP - 1
        GO TO 100
10      INDCBP = INDCBP - 1
        GO TO 100
20      INDCBP = INDCLR
100     IF ( NBLOCK .NE. 1 ) GO TO 110
        IF ( ( INDCLR-INDBAS ) .NE. 5 ) GO TO 110
        GO TO 7000
110     ID = IAND( IBASE( INDCBP ), MASKQ1 )
        IF ( ID .EQ. IDSEF ) GO TO 7000
        IF ( ID .NE. IDSRT ) GO TO 120
        INDCBP = INDBAS + ( IAND( IBASE( INDCBP ), MASKH2 ) ) - 1
        ID = IAND( IBASE( INDCBP ), MASKQ1 )
120     IF ( ID .EQ. IDSRH ) GO TO 140
        IF ( ID .EQ. IDSSB ) GO TO 140
        IF ( ID .EQ. IDSEB ) GO TO 130
        CALL DSMSG( 106 )
130     INDCBP = INDCBP - 1
        GO TO 100
140     IFLAG = IAND( IBASE( INDCBP ), MASKQ2 )
        IF ( IFLAG .EQ. IDSC ) GO TO 7000
        IF ( IFLAG .EQ. IDSP ) GO TO 7000
        IF ( ( INDCBP-INDBAS ) .LE. 5 ) GO TO 150
        INDCBP = INDCBP - 1
        GO TO 100
150     IF ( NBLOCK .EQ. 1 ) GO TO 7000
        CALL DSRDPB
        INDCBP = INDCBP - 1
        GO TO 100
7000    INDCLR = INDCBP
C        PRINT *,' DSBRC1-2,NBLOCK,INDCLR,INDBAS=',NBLOCK,INDCLR,INDBAS
        RETURN
        END

      SUBROUTINE XRGDTP
C****
C    PURPOSE - XRGDTP DETERMINES A TYPE CODE FOR A CHARACTER
C
C    AUTHOR  - RPK CORPORATION; DECEMBER, 1983
C
C    INPUT
C      /XRGDXX/
C        ICHAR       AN ARRAY IN 80A1 FORMAT
C        ICOL        CURRENT ELEMENT IN THE ARRAY ICHAR
C
C    OUTPUT
C      /XRGDXX/
C        ITYPE       TYPE CODE ASSOCIATED WITH THE CHARACTER
C                    =1, IF CHARACTER IS A NUMBER
C                    =2, IF CHARACTER IS A ','
C                    =3, IF CHARACTER IS A '-'
C                    =4, IF CHARACTER IS A BLANK
C                    =5, OTHERWISE
C        NUMBER      INTEGER VALUE FOR CHARACTER OF ITYPE=1
C
C    LOCAL VARIABLES
C      DELIM         3 WORD ARRAY CONTAINING A COMMA, DASH, AND BLANK
C      NUMS          10 WORD ARRAY OF ALPHA NUMBERS 1,2..0
C      K             K DO LOOP INDEX TO SEARCH DELIM ARRAY
C
C   SUBROUTINES CALLED - NONE
C
C   CALLING SUBROUTINES - XRGDEV
C
C    FUNCTIONS - XRGDTP EXAMINES THE CHARACTER IN ICHAR(ICOL)
C                TO DETERMINE ITS TYPE CODE.
C
C    ERRORS - NONE
C
C****
      INTEGER           RECORD
      INTEGER NUMS( 10 ), DELIM( 3 )
      COMMON / XRGDXX / IRESTR, NSUBST, IPHASE, ICOL  , NUMBER, ITYPE
     *,                 ISTATE, IERROR, NUM(2), IND   , NUMENT
     *,                 RECORD(20)    , ICHAR(80)     , LIMIT(2)
     *,                 ICOUNT, IDMAP , ISCR  , NAME(2), MEMBER(2)
     *,                 IGNORE
      DATA NUMS / 1H1, 1H2, 1H3, 1H4, 1H5, 1H6, 1H7, 1H8, 1H9, 1H0 /
      DATA DELIM/ 1H,, 1H-, 1H                                     /
C
      DO 10 K = 1,3
      IF ( ICHAR( ICOL ) .NE. DELIM( K ) ) GO TO 10
      ITYPE = K + 1
      GO TO 30
 10   CONTINUE
      DO 20 K = 1, 10
      IF ( ICHAR( ICOL ) .NE. NUMS( K ) ) GO TO 20
      ITYPE = 1
      NUMBER = MOD( K,10 )
      GO TO 30
 20   CONTINUE
      ITYPE = 5
 30   RETURN
      END

      SUBROUTINE MRED1
C
C     THIS SUBROUTINE IS THE MRED1 MODULE WHICH INITIATES THE MODAL
C     SYNTHESIS CALCULATIONS.
C
C     DMAP CALLING SEQUENCE
C     MRED1    CASECC,GEOM4,DYNAMICS/USETX,EEDX,EQST,DMR/*NAMEA*/
C              S,N,DRY/STEP/S,N,NOUS/S,N,SKIPM/S,N,GPARM/TYPE $
C
C     INPUT DATA
C     GINO   - CASECC - CASE CONTROL
C              GEOM4  - BDYC DATA
C                     - BDYS DATA
C                     - BDYS1 DATA
C              DYNAMICS - EIGR DATA
C     SOF    - EQSS   - SUBSTRUCTURE EQUIVALENCE TABLE
C              BGSS   - BASIC GRID POINT IDENTIFICATION TABLE
C              CSTM   - COORDINATE SYSTEM TRANSFORMATION MATRICES DATA
C
C     OUTPUT DATA
C     GINO   - USETX  - S,R,B DEGREES OF FREEDOM
C              EEDX   - EIGR DATA
C              EQST   - TEMPORARY EQSS
C              DMR    - RIGID BODY MATRIX
C
C     PARAMETERS
C     INPUT  - NAMEA  - INPUT SUBSTRUCTURE NAME (BCD)
C              DRY    - OPERATION MODE (INTEGER)
C              STEP   - CONTROL DATA CASECC RECORD (INTEGER)
C              TYPE   - REAL OR COMPLEX (BCD)
C     OUTPUT - DRY    - MODULE OPERATION FLAG (INTEGER)
C              NOUS   - FIXED POINTS FLAG (INTEGER)
C                     = +1 IF FIXED POINTS DEFINED
C                     = -1 IF NO FIXED POINTS DEFINED
C              SKIPM  - MODES FLAG (INTEGER)
C                     =  0 IF MODES NOT PRESENT
C                     = -1 IF MODES PRESENT
C     OTHERS - GBUF   - GINO BUFFERS
C              SBUF   - SOF  BUFFERS
C              KORLEN - CORE LENGTH
C              NEWNAM - NEW SUBSTRUCTURE NAME
C              BNDSET - BOUNDARY SET IDENTIFICATION NUMBER
C              FIXSET - FIXED SET IDENTIFICATION NUMBER
C              IEIG   - EIGENVALUE SET IDENTIFICATION NUMBER
C              IO     - OUTPUT FLAGS
C              RGRID  - FREEBODY MODES FLAGS
C              RNAME  - FREEBODY SUBSTRUCTURE NAME
C              IRSAVE - RSAVE FLAG
C              KORBGN - BEGINNING ADDRESS OF OPEN CORE
C              NCSUBS - NUMBER OF CONTRIBUTING SUBSTRUCTURES
C              NAMEBS - BEGINNING ADDRESS OF CONTRIBUTING SUBSTRUCTURE
C                       NAMES
C              EQSIND - BEGINNING ADDRESS OF EQSS GROUP ADDRESSES
C              NSLBGN - BEGINNING ADDRESS OF SIL DATA
C              NSIL   - NUMBER OF SIL GROUPS
C              BDYCS  - BEGINNING ADDRESS OF BDYC DATA
C              NBDYCC - NUMBER OF BDYC DATA GROUPS
C              USETL  - LENGTH OF USET ARRAY
C              USTLOC - BEGINNING ADDRESS OF USET ARRAY
C              RGRIDX - FREEBODY MODE RELATIVE X COORDINATE
C              RGRIDY - FREEBODY MODE RELATIVE Y COORDINATE
C              RGRIDZ - FREEBODY MODE RELATIVE Z COORDINATE
C              USRMOD - USERMODE  OPTION FLAG
C              BOUNDS - OLDBOUNDS OPTION FLAG
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        RSHIFT,ANDF,ORF
      LOGICAL         USRMOD,BOUNDS,PONLY,ERRORS
      REAL            RZ(1),RANGE(2),GPRM
      DIMENSION       MODNAM(2),MTRLRA(7),MTRLRB(7),MTRLRC(7),MTRLRD(7),
     1                NMONIC(16),CCTYPE(2),MTRLRE(7),ITMNAM(2),
     2                LSTBIT(32),ERRNAM(6),LETRS(2)
      CHARACTER       UFM*23,UWM*25,UIM*29
      COMMON /XMSSG / UFM,UWM,UIM
      COMMON /BLANK / OLDNAM(2),DRY,STEP,NOUS,SKIPM,TYPE(2),GPRM,GBUF1,
     1                GBUF2,SBUF1,SBUF2,SBUF3,KORLEN,NEWNAM(2),BNDSET,
     2                FIXSET,IEIG,IO,RGRID(2),RNAME(2),IRSAVE,KORBGN,
     3                NCSUBS,NAMEBS,EQSIND,NSLBGN,NSIL,BDYCS,NBDYCC,
     4                USETL,USTLOC,RGRIDX,RGRIDY,RGRIDZ,USRMOD,BOUNDS,
     5                PONLY
      COMMON /ZZZZZZ/ Z(1)
      COMMON /SYSTEM/ SYSBUF,IPRNTR
      EQUIVALENCE     (Z(1),RZ(1))
      DATA    NMONIC/ 4HNAMB,4HBOUN,4HFIXE,4HMETH,4HCMET,4HOUTP,4HRGRI,
     1                4HOLDM,4HOLDB,4HRSAV,4HRNAM,4HRANG,4HNMAX,4HUSER,
     2                4HNAMA,4HGPAR/
      DATA    CASECC/ 101          /
      DATA    MODNAM/ 4HMRED,4H1   /
      DATA    ERRNAM/ 4HLAMS,4HPHIS,4HPHIL,4HGIMS,4HLMTX,4HUPRT/
      DATA    IBLANK, YES,NO,ALL   /4H    ,4HYES ,4HNO  ,4HALL /
      DATA    LETRS / 1HM,1HC      /
      DATA    CCTYPE/ -1,-2        /
      DATA    CRED  , NHLODS,NHLOAP,NHEQSS /4HCRED,4HLODS,4HLOAP,4HEQSS/
C
C     COMPUTE OPEN CORE AND DEFINE GINO, SOF BUFFERS
C
      NOZWDS = KORSZ(Z(1))
      GBUF1  = NOZWDS- SYSBUF - 2
      GBUF2  = GBUF1 - SYSBUF
      SBUF1  = GBUF2 - SYSBUF
      SBUF2  = SBUF1 - SYSBUF - 1
      SBUF3  = SBUF2 - SYSBUF
      KORLEN = SBUF3 - 1
      KORBGN = 1
      IF (KORLEN .LE. KORBGN) GO TO 430
C
C     INITIALIZE SOF
C
      CALL SOFOPN (Z(SBUF1),Z(SBUF2),Z(SBUF3))
C
C     INITIALIZE CASE CONTROL PARAMETERS
C
      DO 10 I = 1, 2
      RGRID(I) = -1
      NEWNAM(I)= IBLANK
   10 RNAME(I) = IBLANK
      BNDSET = 0
      FIXSET = 0
      IEIG   = 0
      NOIEIG = YES
      IO     = 0
      SKIPM  = 0
      MODES  = NO
      BOUNDS = .FALSE.
      PONLY  = .FALSE.
      IBOUND = NO
      IRSAVE = NO
      NOUS   = 1
      IFREE  = NO
      NMAX   = 2147483647
      IMAX   = ALL
      IMODE  = NO
      USRMOD = .FALSE.
      IUSERM = 1
      MODULE = 1
      GPRM   = 0.0
      IBF    = 0
      NRANGE = 0
      IRANGE = ALL
      RANGE(1) =-1.0E+35
      RANGE(2) = 1.0E+35
C
C     PROCESS CASE CONTROL
C
      IFILE = CASECC
      CALL OPEN (*400,CASECC,Z(GBUF2),0)
      IF (STEP) 20,40,20
   20 DO 30 I = 1,STEP
   30 CALL FWDREC (*420,CASECC)
C
C     READ CASECC AND EXTRACT DATA
C
   40 CALL READ (*410,*420,CASECC,Z(KORBGN),2,0,NOREAD)
      IF (Z(KORBGN) .EQ. CRED) MODULE = 2
      NOWDSC = Z(KORBGN+1)
      DO 190 I = 1,NOWDSC,3
      CALL READ (*410,*420,CASECC,Z(KORBGN),3,0,NOREAD)
C
C     TEST CASE CONTROL MNEMONICS
C
      DO 50 J = 1,16
      IF (Z(KORBGN) .EQ. NMONIC(J)) GO TO 60
   50 CONTINUE
      GO TO 190
C
C     SELECT DATA TO EXTRACT
C
   60 GO TO ( 70, 90,100,110,110,120,130,140,150,160,170,
     1       102,115,125,132,155), J
C
C     EXTRACT NEW SUBSTRUCTURE NAME
C
   70 DO 80 K = 1,2
   80 NEWNAM(K) = Z(KORBGN+K)
      GO TO 190
C
C     EXTRACT BOUNDARY SET
C
   90 IF (Z(KORBGN+1) .NE. CCTYPE(1)) GO TO 185
      BNDSET = Z(KORBGN+2)
      IBF = IBF + 2
      GO TO 190
C
C     EXTRACT FIXED SET
C
  100 IF (Z(KORBGN+1) .NE. CCTYPE(1)) GO TO 185
      FIXSET = Z(KORBGN+2)
      IBF = IBF + 1
      GO TO 190
C
C     EXTRACT FREQUENCY RANGE
C
  102 IF (Z(KORBGN+1) .NE. CCTYPE(2)) GO TO 185
      IRANGE = IBLANK
      IF (NRANGE .EQ. 1) GO TO 104
      NRANGE = 1
      RANGE(1) = RZ(KORBGN+2)
      GO TO 190
  104 RANGE(2) = RZ(KORBGN+2)
      GO TO 190
C
C     EXTRACT EIGENVALUE METHOD
C
  110 IF (Z(KORBGN+1) .NE. CCTYPE(1)) GO TO 185
      IEIG = Z(KORBGN+2)
      NOIEIG = NO
      GO TO 190
C
C     EXTRACT MAXIMUM NUMBER OF FREQUENCIES
C
  115 IF (Z(KORBGN+1) .NE. CCTYPE(1)) GO TO 185
      IF (Z(KORBGN+2) .EQ. 0) GO TO 190
      NMAX = Z(KORBGN+2)
      IMAX = IBLANK
      GO TO 190
C
C     EXTRACT OUTPUT FLAGS
C
  120 IF (Z(KORBGN+1) .NE. CCTYPE(1)) GO TO 185
      IO = ORF(IO,Z(KORBGN+2))
      GO TO 190
C
C     EXTRACT USERMODE FLAG
C
  125 IF (Z(KORBGN+1) .NE. CCTYPE(1)) GO TO 185
      IMODE  = YES
      SKIPM  = -1
      USRMOD = .TRUE.
      IF (Z(KORBGN+2) .EQ. 2) IUSERM = 2
      GO TO 190
C
C     EXTRACT RIGID BODY GRID POINT ID
C
 130  RGRID(1) = Z(KORBGN+2)
      IF (Z(KORBGN+1) .NE. CCTYPE(1)) RGRID(1) = 0
      IFREE = YES
      GO TO 190
C
C     EXTRACT OLD SUBSTRUCTURE NAME
C
  132 DO 134 K = 1,2
  134 OLDNAM(K) = Z(KORBGN+K)
      GO TO 190
C
C     SET OLDMODES FLAG
C
  140 IF ((Z(KORBGN+1).EQ.CCTYPE(1)) .OR. (Z(KORBGN+1).EQ.CCTYPE(2)))
     1   GO TO 185
      IF (Z(KORBGN+1) .NE. YES) GO TO 190
      SKIPM = -1
      MODES = YES
      GO TO 190
C
C     SET OLDBOUND FLAG
C
  150 IF ((Z(KORBGN+1).EQ.CCTYPE(1)) .OR. (Z(KORBGN+1).EQ.CCTYPE(2)))
     1   GO TO 185
      IF (Z(KORBGN+1) .NE. YES) GO TO 190
      BOUNDS = .TRUE.
      IBOUND = YES
      GO TO 190
C
C     EXTRACT GPARAM PARAMETER
C
  155 IF (Z(KORBGN+1) .NE. CCTYPE(2)) GO TO 185
      GPRM = RZ(KORBGN+2)
      GO TO 190
C
C     SET RSAVE FLAG
C
  160 IF (Z(KORBGN+1) .EQ. NO) GO TO 190
      IRSAVE = YES
      GO TO 190
C
C     EXTRACT RIGID BODY SUBSTRUCTURE NAME
C
  170 DO 180 K = 1,2
  180 RNAME(K) = Z(KORBGN+K)
      IF (RGRID(1) .LT. 0) RGRID(1) = 0
      IFREE = YES
      GO TO 190
C
C     CASECC COMMAND ERROR
C
  185 WRITE (IPRNTR,916) UWM,LETRS(MODULE),NMONIC(J)
  190 CONTINUE
      CALL CLOSE (CASECC,1)
C
C     TEST MODULE OPERATION FLAG
C
      IF (DRY) 192,194,196
  192 IF (DRY .EQ. -2) GO TO 198
      WRITE (IPRNTR,909) UIM
      DRY = -2
      GO TO 198
  194 SKIPM = -1
      ITEST = 0
      CALL FDSUB (NEWNAM,ITEST)
      IF (ITEST .NE. -1) GO TO 510
      WRITE (IPRNTR,922) UFM,LETRS(MODULE),NEWNAM
      GO TO 500
  196 ITEST = 0
      CALL FDSUB (NEWNAM,ITEST)
      IF (ITEST .EQ. -1) GO TO 198
      IF (BOUNDS .OR. (SKIPM .EQ. -1)) GO TO 198
      CALL SFETCH (NEWNAM,NHLODS,3,ITEST)
      IF (ITEST .EQ. 3) GO TO 197
      CALL SFETCH (NEWNAM,NHLOAP,3,ITEST)
      IF (ITEST .EQ. 3) GO TO 197
      ITMNAM(1) = NEWNAM(1)
      ITMNAM(2) = NEWNAM(2)
      GO TO 450
C
C     LOADS ONLY PROCESSING
C
  197 PONLY = .TRUE.
C
C     TEST OUTPUT OPTION
C
  198 IF (ANDF(IO,1) .EQ. 0) GO TO 200
      CALL PAGE1
      WRITE (IPRNTR,900) OLDNAM,NEWNAM
      IF (IBF .EQ. 0) WRITE (IPRNTR,918)
      IF (IBF .EQ. 1) WRITE (IPRNTR,919) FIXSET
      IF (IBF .EQ. 2) WRITE (IPRNTR,920) BNDSET
      IF (IBF .EQ. 3) WRITE (IPRNTR,921) BNDSET,FIXSET
      IF (RGRID(1) .EQ. -1) WRITE (IPRNTR,906) RNAME
      IF (RGRID(1) .NE. -1) WRITE (IPRNTR,907) RGRID(1),RNAME
      IF (NOIEIG .EQ. NO) WRITE (IPRNTR,908) IBOUND,MODES,IFREE,IMODE,
     1    IRSAVE,IEIG
      IF (NOIEIG .NE. NO) WRITE (IPRNTR,908) IBOUND,MODES,IFREE,IMODE,
     1    IRSAVE
      IF (IMAX   .EQ. ALL) WRITE (IPRNTR,910) IMAX,GPRM
      IF (IMAX   .NE. ALL) WRITE (IPRNTR,911) NMAX,GPRM
      IF (IRANGE .EQ. ALL) WRITE (IPRNTR,912) OLDNAM,IRANGE
      IF (IRANGE .NE. ALL) WRITE (IPRNTR,913) OLDNAM,RANGE(1)
C
C     CHECK FOR OLDMODES, OLDBOUND ERRORS
C
  200 ERRORS = .FALSE.
      IF (PONLY) GO TO 290
      CALL SFETCH (OLDNAM,ERRNAM(1),3,ITEST)
      CALL SOFTRL (OLDNAM,ERRNAM(2),MTRLRA)
      CALL SOFTRL (OLDNAM,ERRNAM(4),MTRLRB)
      CALL SOFTRL (OLDNAM,ERRNAM(5),MTRLRC)
      CALL SOFTRL (OLDNAM,ERRNAM(3),MTRLRD)
      CALL SOFTRL (OLDNAM,ERRNAM(6),MTRLRE)
      IFLAG = 1
      IF (USRMOD) GO TO 290
      IF (SKIPM) 210,230,230
C
C     OLDMODES SET - PHIS AND LAMS MUST BE ON SOF
C
  210 IF (ITEST .GT. 3) GO TO 360
  220 IFLAG = 2
      IF (MTRLRA(1) .GT. 2) GO TO 360
      GO TO 260
C
C     OLDMODES NOT SET - PHIS, PHIL AND LAMS MUST BE DELETED
C
  230 IF (ITEST .LT. 3) GO TO 370
  240 IFLAG = 2
      IF (MTRLRA(1) .LT. 3) GO TO 370
  250 IFLAG = 3
      IF (MTRLRD(1) .LT. 3) GO TO 370
C
C     OLDBOUND SET - GIMS AND UPRT MUST BE ON SOF
C
  260 IFLAG = 4
      IF (.NOT. BOUNDS) GO TO 270
      IF (MTRLRB(1) .GT. 2) GO TO 380
  265 IFLAG = 6
      IF (MTRLRE(1) .GT. 2) GO TO 380
      GO TO 290
C
C     OLDBOUND NOT SET - GIMS AND LMTX MUST BE DELETED
C
  270 IF (MTRLRB(1) .LT. 3) GO TO 390
  280 IFLAG = 5
      IF (MTRLRC(1) .LT. 3) GO TO 390
C
C     TEST FOR ERRORS
C
  290 IF (ERRORS) GO TO 500
      IF (IUSERM .EQ. 2) WRITE (IPRNTR,917) UIM
C
C     READ EQSS GROUP 0 DATA AND TEST OPEN CORE LENGTH
C
      ITMNAM(2) = OLDNAM(2)
      CALL SFETCH (OLDNAM,NHEQSS,1,ITEST)
      IF (ITEST .EQ. 3) GO TO 460
      IF (ITEST .EQ. 4) GO TO 470
      IF (ITEST .EQ. 5) GO TO 480
      CALL SUREAD (Z(KORBGN),-1,NWDSRD,ITEST)
      IF (KORBGN+NWDSRD .GE. SBUF3) GO TO 430
C
C     COMPRESS BASIC SUBSTRUCTURE NAMES AND TEST OPEN CORE LENGTH
C
      NCSUBS = Z(KORBGN+2)
      NAMEBS = KORBGN
      I = 2*((NWDSRD - 4)/2)
      K = 4
      DO 300 J = 1,I,2
      Z(KORBGN+J-1) = Z(KORBGN+K  )
      Z(KORBGN+J  ) = Z(KORBGN+K+1)
      IF (RGRID(1) .LT. 0) GO TO 300
      IF (RNAME(1) .NE. IBLANK) GO TO 298
      RNAME(1) = Z(KORBGN+J-1)
      RNAME(2) = Z(KORBGN+J  )
  298 CONTINUE
      IF ((Z(KORBGN+J-1).NE.RNAME(1)) .OR. (Z(KORBGN+J).NE.RNAME(2)))
     1   GO TO 300
      RGRID(2) = (J+1)/2
  300 K = K + 2
      EQSIND = KORBGN + 2*NCSUBS
      IF (EQSIND .GE. SBUF3) GO TO 430
C
C     TEST OUTPUT OPTION
C
      IF (ANDF(IO,1) .EQ. 0) GO TO 310
      IF (IRANGE  .NE.  ALL) GO TO 302
      I = 2*NCSUBS
      WRITE (IPRNTR,901) (Z(KORBGN+J-1),Z(KORBGN+J),J=1,I,2)
      GO TO 310
  302 IF (NCSUBS .GE. 5) GO TO 306
      I = 1 + 2*NCSUBS
      DO 304 J = I,10
  304 Z(KORBGN+J-1) = IBLANK
  306 K = 10
      WRITE (IPRNTR,914) (Z(KORBGN+J-1),Z(KORBGN+J),J=1,K,2),RANGE(2)
      IF (NCSUBS .LE. 5) GO TO 310
      K = K + 1
      I = 2*NCSUBS
      WRITE (IPRNTR,901) (Z(KORBGN+J-1),Z(KORBGN+J),J=K,I,2)
C
C     READ EQSS GROUPS TO END-OF-ITEM
C
  310 KORBGN = EQSIND + 2*NCSUBS
      DO 320 I = 1, NCSUBS
      IF (KORBGN .GE. SBUF3) GO TO 430
      CALL SUREAD (Z(KORBGN),-1,NWDSRD,ITEST)
      J = 2*(I - 1)
      Z(EQSIND+J  ) = KORBGN
      Z(EQSIND+J+1) = NWDSRD
  320 KORBGN = KORBGN + NWDSRD
      NSLBGN = KORBGN
      CALL SUREAD (Z(KORBGN),-2,NWDSRD,ITEST)
      NSIL = NWDSRD/2
C
C     TEST OUTPUT OPTION
C
      IF (ANDF(RSHIFT(IO,3),1) .EQ. 0) GO TO 350
      DO 330 I = 1,NCSUBS
      J = 2*(I-1)
      CALL CMIWRT (1,OLDNAM,Z(NAMEBS+J),Z(EQSIND+J),Z(EQSIND+J+1),RZ,Z)
  330 CONTINUE
      ISIL = 2*NSIL
      CALL CMIWRT (8,OLDNAM,OLDNAM,NSLBGN,ISIL,RZ,Z)
C
C     DETERMINE USET LENGTH
C
  350 KORBGN = NSLBGN + NWDSRD
      USTLOC = KORBGN
      ICODE  = Z(KORBGN-2)
      CALL DECODE (ICODE,LSTBIT,NWDSD)
      USETL = (Z(KORBGN-3) + NWDSD) - 1
C
C     PROCESS FIXED SET
C
      CALL MRED1A (1)
      CALL MRED1B (1)
C
C     PROCESS BOUNDARY SET
C
      CALL MRED1A (2)
      CALL MRED1B (2)
C
C     CONVERT EQSS DATA TO UB DATA
C
      IF (PONLY) GO TO 510
      CALL MRED1C
C
C     PROCESS EIGENVALUE DATA
C
      IF (SKIPM .EQ. -1) GO TO 355
      CALL MRED1D
C
C     PROCESS FREE BODY MODES
C
  355 CALL MRED1E
      GO TO 510
C
C     PHIS, LAMS DO NOT EXIST
C
  360 WRITE (IPRNTR,902) UFM,ERRNAM(IFLAG),OLDNAM
      ERRORS = .TRUE.
      GO TO (220,260), IFLAG
C
C     PHIS, PHIR, LAMS NOT DELETED
C
  370 WRITE (IPRNTR,903) UFM,ERRNAM(IFLAG),OLDNAM
      ERRORS = .TRUE.
      GO TO (240,250,260), IFLAG
C
C     GIMS, UPRT DOES NOT EXIST
C
  380 WRITE (IPRNTR,904) UFM,ERRNAM(IFLAG),OLDNAM
      ERRORS = .TRUE.
      IF (IFLAG - 5) 265,265,290
C
C     GIMS, LMTX NOT DELETED
C
  390 WRITE (IPRNTR,905) UFM,ERRNAM(IFLAG),OLDNAM
      ERRORS = .TRUE.
      IFLAG = IFLAG - 3
      GO TO (280,290), IFLAG
C
C     PROCESS SYSTEM FATAL ERRORS
C
  400 IMSG = -1
      GO TO 440
  410 IMSG = -2
      GO TO 440
  420 IMSG = -3
      GO TO 440
  430 IMSG = -8
      IFILE = 0
  440 CALL SOFCLS
      CALL MESAGE (IMSG,IFILE,MODNAM)
      RETURN
C
C     PROCESS MODULE FATAL ERRORS
C
  450 IMSG = -4
      GO TO 490
  460 IMSG = -1
      GO TO 490
  470 IMSG = -2
      GO TO 490
  480 IMSG = -3
  490 CALL SMSG (IMSG,NHEQSS,ITMNAM)
      RETURN
C
  500 CALL SOFCLS
      DRY = -2
      RETURN
C
C     CLOSE ANY OPEN FILES
C
  510 CALL SOFCLS
      IF (DRY .EQ. -2) WRITE (IPRNTR,915) LETRS(MODULE)
      IF (PONLY) SKIPM = -1
      RETURN
C
  900 FORMAT (//38X,46HS U M M A R Y    O F    C U R R E N T    P R O,
     1       8H B L E M,//13X,38HNAME OF PSEUDOSTRUCTURE TO BE REDUCED ,
     2       4(2H. ),2A4,6X,40HNAME GIVEN TO RESULTANT PSEUDOSTRUCTURE ,
     3       2A4)
  901 FORMAT (16X,2A4,2X,2A4,2X,2A4,2X,2A4,2X,2A4)
  902 FORMAT (A23,' 6617, OLDMODES SET AND REQUESTED SOF ITEM DOES NOT',
     1       ' EXIST.  ITEM ',A4,', SUBSTRUCTURE ',2A4,1H.)
  903 FORMAT (A23,' 6618, OLDMODES NOT SET AND REQUESTED SOF ITEM MUST',
     1       ' BE DELETED.  ITEM ',A4,', SUBSTRUCTURE ',2A4,1H.)
  904 FORMAT (A23,' 6619, OLDBOUND SET AND REQUESTED SOF ITEM DOES NOT',
     1       ' EXIST.  ITEM ',A4,', SUBSTRUCTURE ',2A4,1H.)
  905 FORMAT (A23,' 6620, OLDBOUND NOT SET AND REQUESTED SOF ITEM MUST',
     1       ' BE DELETED.  ITEM ',A4,', SUBSTRUCTURE ',2A4,1H.)
  906 FORMAT (13X,'RIGID BODY GRID POINT IDENTIFICATION NUMBER .',14X,
     1       'RIGID BODY SUBSTRUCTURE NAME ',5(2H. ),2A4)
  907 FORMAT (13X,46HRIGID BODY GRID POINT IDENTIFICATION NUMBER . ,I8,
     1       6X,30HRIGID BODY SUBSTRUCTURE NAME  ,5(2H. ),2A4)
  908 FORMAT (13X,18HOLDBOUND FLAG SET ,14(2H. ),A4,10X,12HOLDMODES FLA,
     1       6HG SET ,11(2H. ),A4,/13X,29HFREE BODY MODES TO BE CALCULA,
     2       5HTED  ,6(2H. ),A4,10X,20HUSER MODES FLAG SET ,10(2H. ),A4,
     3       /13X,24HSAVE REDUCTION PRODUCTS ,11(2H. ),A4,10X,7HEIGENVA,
     4       23HLUE EXTRACTION METHOD  ,5(2H. ),I8)
  909 FORMAT (A29,' 6630, FOR DRY OPTION IN MODAL REDUCE, INPUT DATA ',
     1       'WILL BE CHECKED', /36X,'BUT NO SOF TABLE ITEMS WILL BE ',
     2       'CREATED.')
  910 FORMAT (13X,42HMAXIMUM NUMBER OF FREQUENCIES TO BE USED  ,2(2H. ),
     1       A4,10X,14HGPARAM VALUE  ,13(2H. ),1P,E12.6)
  911 FORMAT (13X,42HMAXIMUM NUMBER OF FREQUENCIES TO BE USED  ,2(2H. ),
     1       I8,6X,14HGPARAM VALUE  ,13(2H. ),1P,E12.6)
  912 FORMAT (13X,46HNAMES OF COMPONENT SUBSTRUCTURES CONTAINED IN ,2A4,
     1       6X,32HRANGE OF FREQUENCIES TO BE USED ,4(2H. ),A4)
  913 FORMAT (13X,46HNAMES OF COMPONENT SUBSTRUCTURES CONTAINED IN ,2A4,
     1       6X,32HRANGE OF FREQUENCIES TO BE USED ,4(2H. ),1P,E12.6)
  914 FORMAT (16X,5(2A4,2X),47X,1P,E12.6)
  915 FORMAT (10H0  MODULE ,A1,36HREDUCE TERMINATING DUE TO ABOVE ERRO,
     1       3HRS.)
  916 FORMAT (A25,' 6367, ILLEGAL FORMAT ON THE ',A1,'REDUCE OUTPUT ',
     1       'COMMAND ',A4,'.  COMMAND IGNORED.')
  917 FORMAT (A29,' 6636, NMAX AND RANGE SUB COMMANDS ARE IGNORED ',
     1       'UNDER USERMODES = TYPE 2.')
  918 FORMAT (13X,36HBOUNDARY SET IDENTIFICATION NUMBER  ,5(2H. ),14X,
     1       32HFIXED SET IDENTIFICATION NUMBER ,4(2H. ))
  919 FORMAT (13X,36HBOUNDARY SET IDENTIFICATION NUMBER  ,5(2H. ),14X,
     1       32HFIXED SET IDENTIFICATION NUMBER ,4(2H. ),I8)
  920 FORMAT (13X,36HBOUNDARY SET IDENTIFICATION NUMBER  ,5(2H. ),I8,6X,
     1       32HFIXED SET IDENTIFICATION NUMBER ,4(2H. ))
  921 FORMAT (13X,36HBOUNDARY SET IDENTIFICATION NUMBER  ,5(2H. ),I8,6X,
     1       32HFIXED SET IDENTIFICATION NUMBER ,4(2H. ),I8)
  922 FORMAT (A23,' 6220, MODULE ',A1,'REDUCE - RUN EQUALS GO AND ',
     1       'SUBSTRUCTURE ',2A4,' DOES NOT EXIST.')
C
      END

      SUBROUTINE STPAIC(BLOC,DY,NSIZE,GAP,BM,GM,PM,NS,CLA,AJJL)
      COMPLEX CH,CDUM,EKM
      DIMENSION BLOC(1),DY(1),NSIZE(1),GAP(1)
      DIMENSION BM(4,4,NS),GM(4,3,NS),PM(37,NS)
      DIMENSION CLA(1)
      DIMENSION CH(3,3),CDUM(4,4)
      COMMON /STRIPC/NNS,BREF,CLAM,FM,NCIRC,NNCIRC,EKR(1),
     *   DUM,       BB(4),BETA(4),EKM(4,4)
      COMMON /AMGMN / MCB(7),NROW,ND,NE,REFC,FMACH,RFK,TSKJ(7),ISK,NSK
      COMMON /PACKX / ITI,ITO,II,NN,INCR
      K = 1
      II = NROW +1
      NN = NROW
      IF(EKR(1).LE..00001) EKR(1) = 0.0
      NSTED=0
      IF(EKR(K).EQ.0.0) NSTED=1
      DO 190 N=1,NS
      BOB=BLOC(N)/BREF
      EKL=EKR(K)*BOB
      CONST=  CLA(N)*DY(N)*CLAM
      CR = FM
      IF ( NCIRC.NE.0 ) CR = BB(1)
      CI = 0.
      NOPEN = 0
      IF(NSIZE(N).EQ.3.AND.GAP(N).EQ.0.0) NOPEN = 1
      TSR= 0.5*GAP(N)/BLOC(N)
      IM=NSIZE(N)
      IF(IM-3) 31,32,32
   31 JM=2
      J1=2
      GO TO 33
   32 JM=4
      J1=3
   33 CONTINUE
      CALL STPK(EKL,N,NSIZE(N),NOPEN,NSTED,TSR,PM(1,N),CR,CI,IM,J1)
      DO 50 I=1,IM
      DO 50 J=1,JM
      CDUM(I,J)=CMPLX(0.0,0.0)
      DO 50 M=1,JM
   50 CDUM(I,J) = CDUM(I,J) + BM(I,M,N)*EKM(M,J)
      DO 70 I=1,IM
      DO 70 J=1,J1
      CH(I,J)  =CMPLX(0.0,0.0)
      DO 60 M=1,JM
   60 CH(I,J)   = CH(I,J)   + CDUM(I,M)*GM(M,J,N)
   70 CH(I,J)   = CONST * CH(I,J)
      NN = NN + IM
      DO 80 I=1,IM
      CALL PACK(CH(1,I),AJJL,MCB)
   80 CONTINUE
      II = II + IM
  190 CONTINUE
      RETURN
      END

      SUBROUTINE SMA3A (MCBCUR)
C*****
C THIS ROUTINE BUILDS A GENERAL ELEMENT MATRIX (DOUBLE PRECISION AND
C SYMMETRIC) OF SIZE LUSET X LUSET.  MCBCUR IS THE MATRIX CONTROL BLOCK
C FOR THIS MATRIX.
C*****
      DOUBLE PRECISION
     1                   DQ(1)              ,DPWORD
     2,                  DET
      INTEGER
     1                   IQ(1)              ,EOR
     2,                  OUTRW              ,CLSRW
     3,                  CLSNRW             ,SMALL
      LOGICAL
     1                   ZONLY
C
      DIMENSION
     1                   MCBCUR(7)          ,MCB(7)
     2,                  Q(1)               ,IBUFF3(3)
     3,                  NAME(2)
C
      COMMON /BLANK/
     1                   LUSET              ,NGENEL
     2,                  NOECPT
      COMMON   /SYSTEM/
     1                   ISYS               ,DUMMY(53)
     2,                  IPREC
      COMMON   /ZZZZZZ/
     1                   Q
      COMMON   /GENELY/
     1                   IFGEI              ,IFKGGX
     2,                  IFOUT              ,IFA
     3,                  IFB                ,IFC
     4,                  IFD                ,IFE
     5,                  IFF
     8,                  INRW               ,OUTRW
     9,                  CLSRW              ,CLSNRW
     T,                  EOR                ,NEOR
     1,                  MCBA(7)            ,MCBB(7)
     2,                  MCBC(7)            ,MCBD(7)
     3,                  MCBE(7)            ,MCBF(7)
     4,                  MCBKGG(7)
     1,                  IUI                ,IUD
     2,                  IZI                ,IS
     3,                  IZIS               ,ISTZIS
     4,                  IBUFF3             ,LEFT
      COMMON   /ZBLPKX/
     1                   DPWORD             ,DUM2(2)
     2,                  INDEX
C
      EQUIVALENCE
     1                   (IQ(1),DQ(1),Q(1))
     2,                  (IBUFF3(2),M)      ,(IBUFF3(3),N)
C
      DATA               NAME(1)/4HSMA3/    ,NAME(2)/4HA   /
C
C MAKE THE ARGUMENT A LOCAL VARIABLE
C
      DO 10 I=1,7
   10 MCB(I) = MCBCUR(I)
C
C READ THE UI SET OF SCALAR INDEX NUMBERS INTO OPEN CORE.
C
      CALL FREAD(IFGEI,IQ(IUI+1),M,0)
C
C IUD POINTS TO THE ZEROTH LOCATION OF THE UD ARRAY.
C
      IUD = IUI + M
      LEFT = LEFT - M
C
C SET UP ARITHMETIC CONSTANTS.
C
      MPN = M + N
      MSQ = M**2
      NSQ = N**2
      ZONLY = .FALSE.
      IF (N .EQ. 0) ZONLY = .TRUE.
      IF (ZONLY) GO TO 20
C
C SINCE N .NE. 0, THE UD SET EXISTS.  READ IT INTO CORE.
C
      CALL FREAD(IFGEI,IQ(IUD+1),N,0)
      LEFT = LEFT - N
C
C BUILD THE ARRAY IQ(IP+1),IQ(IP+2),...,IQ(IP+MPN) SUCH THAT
C IQ(IP+K) = L IMPLIES IQ(IUI+L) IS THE K TH SMALLEST NUMBER OF THE
C SET OF NUMBERS IQ(IUI+1),...,IQ(IUD+N)
C
   20 IP = IUI + MPN
      K  = IP
      LIMK = IP + MPN
      LOW = IUI + 2
      LIM = IUI + MPN
   30 SMALL = IQ(IUI+1)
      ISMALL = IUI + 1
      DO 40 J=LOW,LIM
      IF (IQ(J) .GE. SMALL) GO TO 40
      SMALL  = IQ(J)
      ISMALL = J
   40 CONTINUE
      K = K + 1
      IDIFF = ISMALL - IUI
      IQ(K) = IDIFF
      IQ(IDIFF) = IQ(IDIFF) + LUSET
      IF (K .LT. LIMK) GO TO 30
      LOW = IUI + 1
      DO 50 I=LOW,LIM
      IF (IQ(I) .LE. LUSET) CALL MESAGE (-30,28,5)
   50 IQ(I) = IQ(I) - LUSET
C
C READ INDICATOR OF Z OR K MATRIX
C
      CALL FREAD(IFGEI,IZK,1,0)
C
C SET UP POINTERS TO THE ZEROTH LOCATION OF THE DOUBLE PRECISION ARRAYS
C       -1
C K  ORZ  AND S
C  E    E      E
C
      IZI = (IUI + 2*MPN - 1) / 2  +  2
      IS = IZI + MSQ
C
C READ IN THE M**2 SINGLE PRECISION ELEMENTS OF THE SYMMETRIC Z OR K
C INTO A TEMPORARY BUFFER BEGINNING AT Q(IBUFF)
C
      IBUFF = IUI + 2 * (MPN + MSQ)
C
C IF ALL OF Z OR K CANNOT FIT INTO THIS BUFFER, READ BLOCKS OF M WORDS
C
      IF (IBUFF + MSQ .GT. LEFT) GO TO 70
      IND = NEOR
      IF (ZONLY) IND = EOR
      CALL FREAD(IFGEI,IQ(IBUFF+1),MSQ,IND)
C
C STORE THE SINGLE PRECISION MATRIX IN ITS DOUBLE PRECISION LOCATION.
C
      LIM = IZI + MSQ
      I   = IZI
      J   = IBUFF
   60 I   = I + 1
      IF (I .GT. LIM) GO TO 100
      J   = J + 1
      DQ(I) = Q(J)
      GO TO 60
C
C READ Z OR K INTO THE BUFFER M WORDS AT A TIME AND STORE M WORDS
C AT A TIME
C
   70 IND = NEOR
      DO 90 K=1,M
      IF (K .EQ. M  .AND.  ZONLY) IND = EOR
      CALL FREAD(IFGEI,Q(IBUFF+1),M,IND)
      I = IZI + (K - 1) * M
      J = IBUFF
      LIM = I + M
   80 I = I + 1
      IF (I .GT. LIM) GO TO 90
      J = J + 1
      DQ(I) = Q(J)
      GO TO 80
   90 CONTINUE
C
C IF K IS INPUT DO NOT COMPUTE INVERSE
C
  100 IF (IZK.EQ.2) GO TO 105
C*****
C COMPUTE THE INVERSE OF Z
C                        E
C*****
C
C THE 4TH ARGUMENT OF INVERD IS A DUMMY D.P. ARGUMENT WHILE 3 * M
C WORDS OF WORKING STORAGE ARE NEEDED FOR THE 8TH ARGUMENT OF SUBROUTINE
C INVERD.  SUBROUTINE INVERD WILL RETURN Z  INVERSE AT DQ(IZI+1)
C                                         E
C
      IBUFF = IUI + 2 * (MPN + MSQ) + 5
      II = IBUFF + 2 * M
C     NO NEED TO COMPUTE DETERMINANT SINCE IT IS NOT USED SUBSEQUENTLY.
      ISING = -1
      CALL INVERD (M,DQ(IZI+1),M,IQ(IBUFF+1),0,DET,ISING,IQ(II+1))
C
C ISING = 2 IMPLIES A SINGULAR Z
C                               E
C
      IF (ISING .EQ. 2) CALL MESAGE (-5,IDUMMY,NAME)
  105 CONTINUE
C
C READ IN THE M*N ELEMENTS OF THE M X N  S MATRIX IF N .GT. 0.
C THIS MATRIX IS SINGLE PRECISION AND ROW STORED.
C
      IF (ZONLY) GO TO 130
      IBUFF = MPN + 2*MSQ + 2*M*N +5
      CALL FREAD(IFGEI,Q(IBUFF+1),M*N,1)
C
C STORE THE S  MATRIX AT DQ(IS+1) MAKING S  DOUBLE PRECISION
C            E                            E
C
      LOW = IS + 1
      LIM = IS + M*N
      J = IBUFF
      DO 110 I=LOW,LIM
      J = J + 1
  110 DQ(I) = Q(J)
C                  -1
C COMPUTE K S  OR Z  S AND STORE AT DQ(IZIS+1)
C          E E     E  E
C
      IZIS = IS + M*N
      CALL GMMATD (DQ(IZI+1),M,M,0, DQ(IS+1),M,N,0, DQ(IZIS+1) )
C
C          T        T -1
C COMPUTE S K S OR S Z  S AND STORE AT DQ(ISTZIS+1)
C          E E E    E E  E
C
      ISTZIS = IZIS + M*N
      CALL GMMATD (DQ(IS+1),M,N,1, DQ(IZIS+1),M,N,0, DQ(ISTZIS+1) )
C
C              -1
C SET K S  OR Z  S  NEGATIVE
C      E E     E  E
C
      LOW = IZIS + 1
      LIM = IZIS + M*N
      DO 120 I=LOW,LIM
  120 DQ(I) = -DQ(I)
C*****
C AT THIS POINT ALL MATRICES HAVE BEEN COMPUTED
C*****
C
C INITIALIZE FOR OUTPUT ONTO THE FILE
C
  130 IZROW  = 1
      IZSCOL = 1
      ICOL = 1
      LIMJUI = IUI + M
      LIMJUD = IUI + MPN
      JUI  = IUI + 1
      JUD  = IUD + 1
C******
C BEGIN OUTPUT LOOP
C******
  140 ILOOP = 0
      IF (ZONLY) GO TO 150
      IF (IQ(JUI) - IQ(JUD)) 150,470,240
C
C AT THIS POINT, WRITE OUT COLUMN(S) CORRESPONDING TO THE UI SET.
C
  150 IF (IQ(JUI) - ICOL) 160,190,170
C
C A TRANSFER TO STATEMENT NO. 1115 WILL BE MADE IF THE MAXIMUM OF THE
C UD SET IS LESS THAN THE MINIMUM OF THE UI SET AND THE COLUMNS
C CORRESPONDING TO THE UD SET HAVE BEEN OUTPUT.
C
  160 IF (ILOOP .EQ. 1  .OR.  ZONLY) GO TO 480
      ILOOP = 1
      GO TO 240
C
C SINCE IQ(JUI) .GT. ICOL, IQ(JUI) - ICOL COLUMNS OF ZERO VECTORS MUST
C BE OUTPUT.
C
  170 LIM = IQ(JUI) - ICOL
      DO 180 I=1,LIM
      CALL BLDPK (2, IPREC, MCB(1), 0, 0)
  180 CALL BLDPKN(MCB(1),0,MCB)
C
C INITIALIZE FOR THE OUTPUT OF THE CURRENT COLUMN BY CALLING BLDPK
C
  190 CALL BLDPK (2, IPREC, MCB(1), 0, 0)
      DO 220 I=1,MPN
      IPPI = IP + I
      IF (IQ(IPPI) .GT. M) GO TO 200
C
C SINCE IQ(IPPI).LE.M,OUTPUT AN ELEMENT OF K OR Z INVERSE
C
      JROW = IZROW
      JCOL = IQ(IPPI)
      K = (JROW - 1) * M  +  JCOL  +  IZI
      GO TO 210
C
C HERE WE ARE DEALING WITH A MEMBER OF THE UD SET.  HENCE AN ELEMENT OF
C                -1
C THE -K S  OR -Z  S  MATRIX MUST BE OUTPUT
C       E E      E  E
C
  200 JROW = IZROW
      JCOL = IQ(IPPI) - M
      K = (JROW - 1) * N  +  JCOL  +  IZIS
C
C FILL ZBLPKI COMMON BLOCK
C
  210 KK = IQ(IPPI)
      INDEX = IQ(KK)
      DPWORD = DQ(K)
      IF (DPWORD .NE. 0.0D0) CALL ZBLPKI
  220 CONTINUE
C
C THE CURRENT COLUMN IS COMPLETE.  CALL BLDPKN TO WRAP UP.
C
      CALL BLDPKN(MCB(1),0,MCB)
      IZROW = IZROW + 1
      ICOL  = IQ(JUI) + 1
      JUI = JUI + 1
      IF (JUI .GT. LIMJUI) JUI = LIMJUI
  230 IF (IZROW .GT. M  .AND.  IZSCOL .GT. N) GO TO 320
      GO TO 140
C
C AT THIS POINT WRITE OUT A COLUMN(S) USING THE UD SET.
C
  240 IF (IQ(JUD) - ICOL) 250,280,260
C
C A TRANSFER TO STATEMENT NO. 1185 WILL BE MADE IF THE MAXIMUM OF THE
C UI SET IS LESS THAN THE MINIMUM OF THE UD SET AND THE COLUMNS
C CORRESPONDING TO THE UI SET HAVE BEEN OUTPUT.
C
  250 IF (ILOOP .EQ. 1) GO TO 490
      ILOOP = 1
      GO TO 150
C
C WRITE ZERO COLUMN(S).
C
  260 LIM = IQ(JUD) - ICOL
      DO 270 I=1,LIM
      CALL BLDPK (2, IPREC, MCB(1), 0, 0)
  270 CALL BLDPKN(MCB(1),0,MCB)
  280 CALL BLDPK (2, IPREC, MCB(1), 0, 0)
C
C OUTPUT A COLUMN WHOSE SIL NO. IS A MEMBER OF THE UD SET.
C
      DO 310 I=1,MPN
      IPPI = IP + I
      IF (IQ(IPPI) .GT. M) GO TO 290
C
C                                           -1
C SINCE IQ(IPPI).LE.M,AN ELEMENT OF -KS OR -Z  S MUST BE OUTPUT
C
      JROW = IQ(IPPI)
      JCOL = IZSCOL
      K = (JROW - 1) * N  +  JCOL  +  IZIS
      GO TO 300
C
C                       T         T -1
C OUTPUT AN ELEMENT OF S K S  OR S Z  S
C                       E E E     E E  E
C
  290 JROW = IQ(IPPI) - M
      JCOL = IZSCOL
      K = (JROW - 1) * N  + JCOL  +  ISTZIS
C
C SET UP PARAMETERS IN ZBLPKI COMMON BLOCK
C
  300 KK = IQ(IPPI)
      INDEX = IQ(KK)
      DPWORD = DQ(K)
      IF (DPWORD .NE. 0.0D0) CALL ZBLPKI
  310 CONTINUE
C
C WRAP UP THIS COLUMN.
C
      CALL BLDPKN(MCB(1),0,MCB)
      IZSCOL = IZSCOL + 1
      ICOL   = IQ(JUD)+ 1
      JUD    = JUD + 1
      IF (JUD .GT. LIMJUD) JUD = LIMJUD
      GO TO 230
C
C DETERMINE IF ZERO COLUMNS ARE TO BE OUTPUT.
C
  320 K = IUI + M
      L = IUD + N
      MAX = IQ(K)
      IF (IQ(L) .GT. MAX) MAX = IQ(L)
      LIM = MAX - LUSET
      IF (LIM) 330,350,500
C
C OUTPUT LIM ZERO COLUMNS
C
  330 LIM = IABS(LIM)
      DO 340 I = 1,LIM
      CALL BLDPK (2, IPREC, MCB(1), 0, 0)
  340 CALL BLDPKN(MCB(1),0,MCB)
  350 DO 360 I=1,7
  360 MCBCUR(I) = MCB(I)
      RETURN
C
C FATAL ERROR MESSAGES
C
  470 CALL MESAGE (-30,28,1)
  480 CALL MESAGE (-30,28,2)
  490 CALL MESAGE (-30,28,3)
  500 CALL MESAGE (-30,28,4)
      RETURN
      END

      SUBROUTINE FORNUM ( FORM, ICHAR, IMULT )
C
C THIS SUBROUTINE CONVERTS ALL NUMBERS TO INTEGER FORMAT
C
      CHARACTER*1   FORM(200), BLANK, NUMBER(2)
      DATA          BLANK /' ' /
      DATA          NUMBER /'0','9'/
      IMULT = 0
10    IF ( FORM( ICHAR ) .NE. BLANK      ) GO TO 20
      ICHAR = ICHAR + 1
      GO TO 10
20    IF ( FORM( ICHAR ) .LT. NUMBER(1) .OR.
     &     FORM( ICHAR ) .GT. NUMBER(2) ) GO TO 700
      READ ( FORM( ICHAR ), 901 ) II
901   FORMAT(I1)
      IMULT = IMULT*10 + II
      ICHAR = ICHAR + 1
      GO TO 20
700   CONTINUE
      RETURN
      END

      SUBROUTINE AMPA (AERO,QJH,QHH,AJJL,QHHLO,QJHLO,INDEX,IMAX,IANY)
C
C     THE PURPOSE OF THIS ROUTINE IS TO
C         1. INITIALIZE QHJ AND QHH
C         2. COPY USEFUL DATA FROM QJH AND QHH TO QHHLO AND  QJHLO
C         3. SET UP INDEX, IMAX,IANY, AND AMPCOM
C
C     OPEN CORE IS LAID OUT AS FOLLOWS
C
C     CONTENTS                POINTER                  LENGTH
C     --------                -------                  ------
C     AJJL HEADER
C     NCOL
C     NSUB
C     M-K PAIRS               IAJJL                    2*NSUB +2
C      .
C      .
C      .
C     AERO RECORD 2           IAERO                    2* IMAX
C     M- K  PAIRS
C      .
C      .
C      .
C     QHH HEADER RECORD(RST)
C     NOH (OLD)
C     M- K PAIRS              IQHH                     2*NQHH
C       .
C       .
C       .
C     BUFFER2                 IBUF2
C     BUFFER1                 IBUF1
C
C
C     SPECIAL CODE EXISTS IN CASE AJJK HEADER HAS ONLY 2 WORDS
C
      INTEGER         AERO,QJH,QHH,AJJL,QHHLO,QJHLO,XQHHL,SYSBUF,
     1                NAME(2),MCBAJJ(7),FILE,AJJCOL,QHHCOL
      REAL            Z(1)
      COMMON /UNPAKX/ IT1,II,JJ,INCR
      COMMON /PACKX / IT2,IT3,II1,JJ1,INCR1
      COMMON /SYSTEM/ SYSBUF,NOUT,SKP(52),IPREC
      COMMON /BLANK / NOUE,XQHHL,IGUST
      COMMON /AMPCOM/ NCOL,NSUB,XM,XK,AJJCOL,QHHCOL,NGP,NGPD(2,30),
     1                MCBQHH(7),MCBQJH(7),NOH,IDJH,MCBRJH(7)
      COMMON /ZZZZZZ/ IZ(1)
      EQUIVALENCE     (Z(1),IZ(1))
      DATA    NAME  / 4HAMPA,4H..../
C
C     INITIALIZE
C
      MCBAJJ(1) = AJJL
      CALL RDTRL (MCBAJJ)
      MCBQHH(1) = QHH
      CALL RDTRL (MCBQHH)
      MCBQJH(1) = QJH
      CALL RDTRL (MCBQJH)
      IANY = 1
      IBUF1= KORSZ(IZ) - SYSBUF + 1
      IBUF2= IBUF1 - SYSBUF
C
C     EXTRACT DATA FROM AJJL HEADER
C
      FILE = AJJL
      CALL OPEN (*900,AJJL,IZ(IBUF1),0)
      CALL READ (*910,*920,AJJL,IZ,-2,0,IFLAG)
      CALL READ (*910,*30,AJJL,IZ,IBUF2-1,0,IFLAG)
      GO TO 980
C
C     PROCESS AJJL  DATA
C
   30 CALL CLOSE (AJJL,1)
      NOAJJH= 0
      IAJJL = 4
      IF (IFLAG .EQ. 0) GO TO 50
      NCOL = IZ(1)
      IZX  = 3
      NSUB = MIN0(IZ(IZX),MCBAJJ(2)/NCOL)
      NGP  = IZ(2*NSUB+4)
      K    = 2*NSUB + 5
      IAERO= K - 1
      DO 35 I = 1,NGP
      NGPD(1,I) = IZ(K  )
      NGPD(2,I) = IZ(K+1)
      K = K + 3
   35 CONTINUE
      GO TO 55
C
C     NO AJJ HEADER DATA
C
   50 NOAJJH = 1
      IAERO  = 3
C
C     BRING IN AERO DATA
C
   55 CONTINUE
      CALL GOPEN (AERO,IZ(IBUF1),0)
      FILE = AERO
      CALL FWDREC (*910,AERO)
      NZ = IBUF2 - IAERO
      CALL READ (*910,*60,AERO,IZ(IAERO),NZ,0,IFLAG)
      GO TO 980
C
C     AERO DATA IN CORE
C
   60 CALL CLOSE (AERO,1)
      IMAX = IFLAG/2
      IF (NOAJJH .EQ. 0) GO TO 70
C
C     FIX UP FOR AJJ MISSING HEADER
C
      NCOL = MCBAJJ(2)/IMAX
      NSUB = IMAX
      NGP  = 1
      NGPD(1,1) = 1
      NGPD(2,1) = NCOL
      IAERO = IFLAG + 3
      K = IAERO
      DO 65 I = 1, IFLAG
      IZ(K) = IZ(I+2)
      K = K+1
   65 CONTINUE
C
C     PUT HEADERS FROM OLD QHH IN CORE
C
   70 IF (XQHHL .EQ. 1) GO TO 80
      FILE = QHH
      CALL OPEN (*900,QHH,IZ(IBUF1),0)
      CALL FREAD (QHH,IZ,-2,0)
      IQHH = IAERO + 2*IMAX + 2
      NZ   = NZ - 2*IMAX
      CALL READ (*910,*75,QHH,IZ(IQHH),NZ,0,IFLAG)
      GO TO 980
   75 CALL CLOSE (QHH,1)
      IQHH = IQHH + 2
      NQHH = MIN0((IFLAG-2)/2,MCBQHH(2)/NOH)
C
C     BUILD INDEX FILE
C
   80 CONTINUE
      I = 0
      CALL GOPEN (INDEX,IZ(IBUF1),1)
   90 CONTINUE
      XM =  Z(IAERO+I  )
      XK =  Z(IAERO+I+1)
C
C     SEARCH FOR COLUMN NUMBER IN AJJL
C
      J  =  0
  100 CONTINUE
      XMA = Z(IAJJL+J  )
      XKA = Z(IAJJL+J+1)
      IF (XMA.EQ.XM .AND. XKA.EQ.XK) GO TO 120
      J =  J + 2
      IF (J .GE. 2*NSUB) CALL MESAGE (-7,0,NAME)
      GO TO 100
C
C     FOUND IN AJJL
C
  120 CONTINUE
      AJJCOL = (J/2)*NCOL + 1
C
C     SEARCH FOR COLUMN NUMBER IN QHH
C
      QHHCOL = 0
      IF (XQHHL .EQ. 1) GO TO 140
      J = 0
  130 CONTINUE
      XMA = Z(IQHH+J  )
      XKA = Z(IQHH+J+1)
      IF (XMA.EQ.XM .AND. XKA.EQ.XK) GO TO 150
      J = J + 2
      IF (J .GE. 2*NQHH) GO TO 140
      GO TO 130
C
C     FOUND IN QHH
C
  150 QHHCOL = (J/2)*NOH + 1
C
C     WRITE ON INDEX
C
  140 CALL WRITE (INDEX,XM,4,1)
      IF (QHHCOL .EQ. 0) IANY = 0
      I = I + 2
      IF (I .GE. 2*IMAX) GO TO 200
      GO TO 90
C
C     DONE WITH INDEX
C
  200 CALL CLOSE (INDEX,1)
C
C     COPY OLD  QHH  ONTO QHHLO
C
      IF (XQHHL .EQ. 1) GO TO 300
      IT1  = MCBQHH(5)
      IT2  = IT1
      IT3  = IT1
      INCR = 1
      INCR1= 1
      IF (MCBQHH(1) .LE. 0) GO TO 230
      CALL GOPEN (QHH,IZ(IBUF1),0)
      CALL GOPEN (QHHLO,IZ(IBUF2),1)
      NCLQHH    = MCBQHH(2)
      MCBQHH(2) = 0
      MCBQHH(6) = 0
      MCBQHH(7) = 0
      MCBQHH(1) = QHHLO
      CALL CYCT2B (QHH,QHHLO,NCLQHH,IZ,MCBQHH)
      CALL CLOSE (QHH,1)
      CALL CLOSE (QHHLO,1)
      CALL WRTTRL (MCBQHH)
C
C     COPY OLD QJH ONTO QJHLO
C
  230 CONTINUE
C
C     COPY QJH ONTO QJHLO
C
      IF (MCBQJH(1) .LE. 0) GO TO 250
      CALL GOPEN (QJH,IZ(IBUF1),0)
      CALL GOPEN (QJHLO,IZ(IBUF2),1)
      NCLQJH    = MCBQJH(2)
      MCBQJH(1) = QJHLO
      MCBQJH(2) = 0
      MCBQJH(6) = 0
      MCBQJH(7) = 0
      CALL CYCT2B (QJH,QJHLO,NCLQJH,IZ,MCBQJH)
      CALL CLOSE (QJH,1)
      CALL CLOSE (QJHLO,1)
      CALL WRTTRL (MCBQJH)
  250 CONTINUE
C
C     PUT HEADERS ON NEW OUTPUT FILES
C
  300 CONTINUE
      IF (MCBQHH(1) .LE. 0) GO TO 350
      FILE  = QHH
      CALL OPEN (*900,QHH,IZ(IBUF1),1)
      CALL FNAME (QHH,MCBQHH)
      CALL WRITE (QHH,MCBQHH,2,0)
      CALL WRITE (QHH,NOH,1,0)
      CALL WRITE (QHH,IMAX,1,0)
      CALL WRITE (QHH,IZ(IAERO),2*IMAX,1)
      CALL CLOSE (QHH,3)
      MCBQHH(1) = QHH
      MCBQHH(2) = 0
      MCBQHH(3) = NOH
      MCBQHH(4) = 2
      MCBQHH(5) = 2 + IPREC
      MCBQHH(6) = 0
      MCBQHH(7) = 0
  350 CONTINUE
      IF (MCBQJH(1) .LE. 0) GO TO 360
      FILE = QJH
      CALL OPEN (*900,QJH,IZ(IBUF1),1)
      CALL FNAME (QJH,MCBQJH)
      CALL WRITE (QJH,MCBQJH,2,0)
      CALL WRITE (QJH,NOH,1,0)
      CALL WRITE (QJH,IMAX,1,0)
      CALL WRITE (QJH,IZ(IAERO),2*IMAX,1)
      CALL CLOSE (QJH,3)
      MCBQJH(1) = QJH
      MCBQJH(2) = 0
      MCBQJH(3) = NCOL
      MCBQJH(4) = 2
      MCBQJH(5) = 2 + IPREC
      MCBQJH(6) = 0
      MCBQJH(7) = 0
  360 CONTINUE
      IANY = 0
C
C     PUT HEADER ON QHJL
C
      IF (IGUST .LE. 0) RETURN
      FILE = MCBRJH(1)
      CALL OPEN (*900,FILE,IZ(IBUF1),1)
      CALL FNAME (FILE,MCBRJH(2))
      CALL WRITE (FILE,MCBRJH(2),2,0)
      CALL WRITE (FILE,NOH,1,0)
      CALL WRITE (FILE,IMAX,1,0)
      CALL WRITE (FILE,IZ(IAERO),2*IMAX,1)
      CALL CLOSE (FILE,3)
      CALL MAKMCB (MCBRJH,FILE,NCOL,2,2+IPREC)
      CALL WRTTRL (MCBRJH)
      RETURN
C
C     ERROR MESSAGES
C
  900 IP1 = -1
  901 CALL MESAGE (IP1,FILE,NAME)
  910 IP1 = -2
      GO TO 901
  920 IP1 = -3
      GO TO 901
  980 IP1 = -8
      GO TO 901
      END

      SUBROUTINE BFSMAT (ND,NE,NB,NP,NTP,LENGTH,NTOTAL,SCR1,JF,JL,NAS,
     1                   FMACH,YB,ZB,YS,ZS,X,DELX,EE,XIC,SG,CG,AR,RIA,
     2                   NBEA1,NBEA2,NASB,NSARAY,NCARAY,BFS,AVR,CBAR,
     3                   A0,XIS1,XIS2,KR,NSBEA,NT0)
C
C     NOTE:
C     A JUMP (VIA AN ASSIGN STATEMENT) TO 200 AND A JUMP TO 1100 (ALSO
C     VIA AN ASSIGN STATEMENT), INTO THE MIDDLES OF SOME DO LOOPS, ARE
C     ACCEPTABLE ANSI 77 FORTRAN. HOWEVER, IBM COMPILER MAY COMPLAIN.
C     THIS PROBLEM IS NOW ELIMINATED (BY G.C. 9/89)
C
C
C        ND         SYMMETRY FLAG
C        NE         GROUND EFFECTS FLAG
C        NB         NUMBER OF BODIES
C        NP         NUMBER OF PANELS
C        NTP        NUMBER OF LIFTING SURFACE BOXES
C        NTOTAL     NTP + TOTAL NO. OF Y AND Z ORIENTED BODY ELEMENTS
C        LENGTH     NTOTAL + THE TOTAL NUMBER OF Z- AND Y-ORIENTED
C                   SLENDER BODY ELEMENTS
C        SCR1       FILE FOR OUTPUT
C        JF         ROW FOR FIRST ZY BODY
C        JL         ROW FOR LAST  ZY BODY
C        NAS        ARRAY CONTAINING THE NUMBER OF ASSOCIATED BODIES
C                   FOR EACH PANEL
C        FMACH      MACH NUMBER
C        YB         ARRAY OF -Y- COORDINATES OF THE BODIES
C        ZB         ARRAY OF -Z- COORDINATES OF THE BODIES
C        YS         ARRAY OF -Y- COORDINATES OF STRIPS AND BODIES
C        ZS         ARRAY OF -Z- COORDINATES OF STRIPS AND BODIES
C        X          ARRAY OF 3/4 CHORD LOCATIONS OF BOXES AND
C                            1/2 CHORD FOR BODY ELEMENTS
C        DELX       ARRAY OF LENGTHS OF BOXES AND BODY ELEMENTS
C        EE         ARRAY OF THE SEMI-WITH OF STRIPS
C        XIC        ARRAY OF 1/4 CHORD COORDINATES OF BOXES
C        SG         ARRAY OF SINE   OF STRIP DIHEDRAL ANGLE
C        CG         ARRAY OF COSINE OF STRIP DIHEDRAL ANGLE
C        AR         ARRAY OF RATIO OF MAJOR AXES OF BODIES
C        RIA        ARRAY OF RADII OF BODY ELEMENTS
C        NBEA1      ARRAY OF NUMBER OF BODY ELEMENTS PER BODY
C        NBEA2      ARRAY OF THE BODY ORIENTATION FLAGS PER BODY
C        NASB       ARRAY OF THE BODIES ASSOCIATED WITH PANELS
C        NSARAY     ARRAY OF THE NUMBER OF STRIPS PER PANEL
C        NCARAY     ARRAY OF THE NUMBER OF CHORDWISE DIV. PER PANEL
C        BFS        WORK ARRAY FOR TEMPORARY STORAGE OF THE BFS COLS.
C        AVR        ARRAY OF RADII OF BODIES
C        CBAR       REFERENCE CHORD
C        A0         ARRAY OF SLENDER BODY ELEMENT RADII
C        XIS1       ARRAY OF SLENDER BODY ELEMENT LEADING  EDGE COORD.S
C        XIS2       ARRAY OF SLENDER BODY ELEMENT TRAILING EDGE COORD.S
C        KR         REDUCED FREQUENCY
C        NSBEA      ARRAY OF THE NUMBER OF ELEMENTS PER SLENDER BODY
C
      LOGICAL    LAST
      INTEGER    SCR1
      REAL       KR
      COMPLEX    BFS(LENGTH,2) , FWZ, FWY, EIKJ1 , EIKJ2
      DIMENSION  YB(1), ZB(1), YS(1), ZS(1), X(1), DELX(1), EE(1),
     1           XIC(1), SG(1), CG(1), AR(1), RIA(1), AVR(1), XIS1(1),
     2           XIS2(1), A0(1), NAS(1), NASB(1), NBEA1(1), NBEA2(1) ,
     3           NSBEA(1), NCARAY(1), NSARAY(1)
C
C
      BETA2 = 1.0 - FMACH**2
      ICOL  = 0
      KSP   = 1
      GO TO 3000
C
   50 CONTINUE
C
C     -Y- ORIENTED BODIES AS SENDING ELEMENTS
C
      SGS   =-1.0
      CGS   = 0.0
      NASD  = 0
      IZYFLG= 3
      ASSIGN 4010 TO IBODY
      GO TO 1000
  100 CONTINUE
C
C     - LIFTING SURF. BOXES AS SENDING ELEMENTS
C
      IF (NTP .LE. 0) GO TO 800
      J     = 1
      JP1   = J
      IBOX  = 0
      ISTRIP= 0
      ISN   = 0
      KSP   = 1
C
C     LOOP FOR -PANEL-
C
      DO 700 ISP = 1,NP
      NS  = NSARAY(ISP)
      NC  = NCARAY(ISP)
      NS  = (NS-ISN) / NC
      ISN = NSARAY(ISP)
      NASD= NAS(ISP)
C
C     LOOP FOR -STRIP-
C
      DO 600 IS = 1,NS
      ISTRIP= ISTRIP + 1
      DYS   = YS(ISTRIP)
      DZS   = ZS(ISTRIP)
      SGS   = SG(ISTRIP)
      CGS   = CG(ISTRIP)
      WIDTH = 2.0 * EE(ISTRIP)
C
C     LOOP FOR -BOX-
C
      DO 500 IB = 1,NC
      IBOX = IBOX + 1
      DXS  = XIC(IBOX)
C
      ICOL = ICOL + 1
C
      CALL FWMW (ND,NE,SGS,CGS,IRB,DRIA,AR,DXLE,DXTE,YB,ZB,DXS,DYS,
     1           DZS,NASD,NASB(KSP),KR,BETA2,CBAR,AVR,FWZ,FWY)
      BFS(ICOL,1) = FWZ * (DXTE - DXLE)
      BFS(ICOL,2) = FWY * (DXTE - DXLE)
      BFS(ICOL,1) = BFS(ICOL,1) * SCALE
      BFS(ICOL,2) = BFS(ICOL,2) * SCALE
C
      AREA = WIDTH * DELX(IBOX)
      BFS(ICOL,1) = BFS(ICOL,1) * AREA
      BFS(ICOL,2) = BFS(ICOL,2) * AREA
  500 CONTINUE
  600 CONTINUE
      KSP = KSP + NASD
  700 CONTINUE
C
C     -Z-  ORIENTED BODIES AS SENDING ELEMENTS
C
  800 CONTINUE
      SGS   = 0.0
      CGS   = 1.0
      NASD  = 0
      IZYFLG= 1
      ASSIGN   50 TO IBODY
      GO TO  1000
C
C
C     *** LOOP FOR EACH INTERFERENCE BODY SENDING ELEMENT
C
 1000 CONTINUE
      INDEX = NTP
C
C     --ISB-- IS THE SENDING BODY
C
      DO 1900 ISB  = 1,NB
      IF (NBEA2(ISB) .EQ.     2 ) GO TO 1070
      IF (NBEA2(ISB) .NE. IZYFLG) GO TO 1850
 1070 DYS   = YB(ISB)
      NSBE  = NBEA1(ISB)
      JP1   = 1
      LAST  = .FALSE.
      DZS   = ZB(ISB)
      EARG2 = 1.0
C
C     --ISBE-- IS THE ELEMENT OF THE SEND BODY
C
      DO 1800 ISBE = 1,NSBE
      EARG1 = EARG2
      INDEX = INDEX + 1
      DXS   = X (INDEX) - DELX(INDEX) /4.0
      EARG2 = KR * DELX(INDEX) / CBAR
C
C     CALCULATE THIS COLUMN
C
      ICOL  = ICOL + 1
      EIKJ1 = CMPLX(COS(EARG1),-SIN(EARG1))
      EIKJ2 = CMPLX(COS(EARG2), SIN(EARG2))
C
      CALL FWMW (ND,NE,SGS,CGS,IRB,DRIA,AR,DXLE,DXTE,YB,ZB,DXS,DYS,
     1           DZS,NASD,NASB(KSP),KR,BETA2,CBAR,AVR,FWZ,FWY)
      BFS(ICOL,1) = FWZ * (DXTE - DXLE)
      BFS(ICOL,2) = FWY * (DXTE - DXLE)
      BFS(ICOL,1) = BFS(ICOL,1) * SCALE
      BFS(ICOL,2) = BFS(ICOL,2) * SCALE
C
C
C     IS THIS THE FIRST COLUMN, YES  BRANCH
C
      IF (ISBE .EQ. 1) GO TO 1800
      BFS(ICOL-1,1) = BFS(ICOL-1,1)*EIKJ1 - BFS(ICOL,1)*EIKJ2
      BFS(ICOL-1,2) = BFS(ICOL-1,2)*EIKJ1 - BFS(ICOL,2)*EIKJ2
 1800 CONTINUE
      GO TO 1900
 1850 INDEX = INDEX + NBEA1(ISB)
 1900 CONTINUE
C
C     RETURN TO CALLING POINT - EITHER Y OR Z SENDING BODY ELEM
C
C     *** GO  EITHER TO THE  Y-ORIENTED INTERFERENCE BODY ELEMENT LOOP
C         OR  TO THE LOOP FOR SLENDER BODY SENDING ELEMENTS
C
      GO TO IBODY, (50,4010)
C
C
C     CALCULATE EACH ROW OF THE SENDING COLUMN
C
 3000 CONTINUE
      IY   = 0
      JF   = 0
      NW   = LENGTH*2
      IROW = 0
C
C     --IRB-- IS THE RECEIVING BODY
C
      IRB  = 0
 3050 IRB  = IRB + 1
      IF (IRB .GT. NB) GO TO 3900
      NRBE = NSBEA(IRB)
      ITSB = NBEA2(IRB)
C
      XYB  = YB(IRB)
      XZB  = ZB(IRB)
      SCALE= 1.0
      IF (ND.NE.0 .AND. XYB.EQ.0.0) SCALE = .5
      IF (NE.NE.0 .AND. XZB.EQ.0.0) SCALE = SCALE*.5
C
C     --IRBE-- IS THE ELEM. OF THE REC. BODY
C
      IRBE = 0
 3060 IRBE = IRBE + 1
      IF (IRBE .GT. NRBE) GO TO 3800
      IY   = IY   + 1
      IROW = IROW + 1
      DRIA = A0  (IY)
      DXLE = XIS1(IY)
      DXTE = XIS2(IY)
      XX1  = DXLE
      XX2  = DXTE
      XAA  = DRIA
      ICOL = 0
      GO  TO  100
C
 3100 CONTINUE
      GO TO (3110,3120,3130), ITSB
 3110 CALL WRITE (SCR1,BFS(1,1),NW,0)
      GO TO 3140
 3120 CALL WRITE (SCR1,BFS(1,2),NW,0)
      CALL WRITE (SCR1,BFS(1,1),NW,0)
      IF (JF .EQ. 0) JF = IROW
      IROW = IROW + 1
      GO TO 3140
 3130 CALL WRITE (SCR1,BFS(1,2),NW,0)
      IROW = IROW - 1
 3140 CONTINUE
      GO TO 3060
 3800 CONTINUE
      GO TO 3050
 3900 CONTINUE
      JL = IROW
      RETURN
C
C
 4010 CONTINUE
C
C
C     *** LOOP FOR EACH SLENDER BODY SENDING ELEMENT
C
      IZYFLG= 1
      SGS   = 0.0
      CGS   = 1.0
 4050 CONTINUE
      LSBE  =  0
      DO 5000 LSB = 1,NB
C
C     --LSB-- IS THE INDEX OF THE SLENDER SENDING BODY
C
      IF (NSBEA(LSB) .EQ.      0) GO TO 5000
      IF (NBEA2(LSB) .EQ.      2) GO TO 4070
      IF (NBEA2(LSB) .NE. IZYFLG) GO TO 4097
 4070 CONTINUE
      XETA  =  YB(LSB)
      XZETA =  ZB(LSB)
      SCALE2=  SCALE
      MSBE  =  NSBEA(LSB)
      DO 4080 LSBS = 1,MSBE
      LSBE  =  LSBE + 1
      ICOL  =  ICOL + 1
      XXIJ  = .50 * XIS1(LSBE) + .50 * XIS2(LSBE)
      CALL FWMW (ND,NE,SGS,CGS,IRB,DRIA,AR,DXLE,DXTE,YB,ZB,XXIJ,XETA,
     1           XZETA,NASD,NASB,KR,BETA2,CBAR,AVR,FWZ,FWY)
      BFS(ICOL,1) =  FWZ * (DXTE - DXLE)
      BFS(ICOL,2) =  FWY * (DXTE - DXLE)
      BFS(ICOL,1) =  BFS(ICOL,1) * SCALE2
      BFS(ICOL,2) =  BFS(ICOL,2) * SCALE2
 4080 CONTINUE
      GO TO 5000
 4097 LSBE = LSBE + NSBEA(LSB)
 5000 CONTINUE
      IF (IZYFLG .EQ. 3) GO TO  5010
      IZYFLG = 3
      SGS =-1.0
      CGS = 0.0
      GO TO 4050
 5010 CONTINUE
C
      GO TO 3100
C
      END

      SUBROUTINE RCARD (OUT,FMT,NFLAG,IN)
CDIR$ INTEGER=64
C
C     CDIR$ IS CRAY COMPILER DIRECTIVE. 64 BIT INTEGER IS USED LOCALLY
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL         LSHIFT,RSHIFT,COMPLF
      LOGICAL          PASS,SEQGP,DECIML,LMINUS,EXPONT,DOUBLE,BLKON,NOGO
      REAL             FL1
      DOUBLE PRECISION XDOUBL
      DIMENSION        BCD(16),VAL(16),NUM(10),OUT(1),TYPE(16),FMT(1),
     1                 IN(1),NT(16),NDOUBL(2),LINE(20),CHARS(7)
      CHARACTER        UFM*23
      COMMON /XMSSG /  UFM
      COMMON /LHPWX /  LOWPW,HIGHPW
      COMMON /SYSTEM/  IBUFSZ,F6,NOGO,DUM1(7),NPAGES,NLINES,DUM2(10),
     1                 LSYSTM
      EQUIVALENCE      (FL1     ,INT1 ), (XDOUBL,NDOUBL(1)),
     1                 (NUM(10) ,ZERO ), (CHARS(1),BLANK  ),
     2                 (CHARS(2),STAR ), (CHARS(3),PLUS   ),
     3                 (CHARS(4),MINUS), (CHARS(5),PERIOD ),
     4                 (CHARS(6),E    ), (CHARS(7),D      )
      DATA    PASS  /.FALSE. /, BLANKS/ 4H     /, STARS / 4H**** /,
     1        LINE  / 20*4H           /         , BLANK / 1H     /,
     2        STAR  / 1H*    /, PLUS  / 1H+    /, MINUS / 1H-    /,
     3        PERIOD/ 1H.    /, E     / 1HE    /, D     / 1HD    /,
     4        SEQ   / 3HSEQ  /, P     / 4HP    /, IZERO / 0      /
      DATA    NUM   / 1H1,1H2 ,1H3,1H4, 1H5,1H6,1H7,1H8,1H9,1H0  /
C
      IF (PASS) GO TO 40
      PASS   = .TRUE.
      A67777 = COMPLF(0)
      A67777 = RSHIFT(LSHIFT(A67777,1),1)
C
      DO 20 I = 1,10
      NUM(I) = KHRFN1(IZERO,4,NUM(I),1)
   20 CONTINUE
C
      DO 38 I = 1,7
   38 CHARS(I) = KHRFN1(IZERO,4,CHARS(I),1)
      SEQ = KHRFN3(IZERO,SEQ,1,0)
      P   = KHRFN3(IZERO,P  ,0,0)
C
   40 FIELD = 0
      NWORDS= 2
      N 8 OR 16 = 8
      WORD  = 0
      IOUT  = 0
      IFMT  = 0
      SEQGP = .FALSE.
   50 IF (WORD .EQ. 18) GO TO 680
C
C     OPERATE ON 1 FIELD  (2 OR 4 WORDS), GET FIRST NON-BLANK CHARACTER.
C
      FIELD  = FIELD + 1
      DECIML = .FALSE.
      LMINUS = .FALSE.
      EXPONT = .FALSE.
      DOUBLE = .FALSE.
      BLKON  = .FALSE.
      PLACES = 0
      IT     = 0
      SIGN   = 0
      POWER  = 0
C
C     READ 8 OR 16 CHARACTERS OF ONE FIELD
C
C     TYPE AS 0 = BLANK, -1 = BCD, +1 = INTEGER
C
      N = 0
      WORD1 = WORD + 1
      WORD  = WORD + NWORDS
      DO 110 I = WORD1,WORD
      DO 100 J = 1,4
      N = N + 1
      CHARAC = KHRFN1(IZERO,4,IN(I),J)
      IF (CHARAC .EQ. BLANK) GO TO 70
      IF (CHARAC .EQ. ZERO ) GO TO 80
      DO 60 K = 1,9
      IF (CHARAC .EQ. NUM(K)) GO TO 90
   60 CONTINUE
      TYPE(N)= -1
      VAL(N) = CHARAC
      GO TO 100
   70 TYPE(N)= 0
      VAL(N) = BLANK
      GO TO 100
   80 K = 0
   90 TYPE(N)= 1
      VAL(N) = K
  100 BCD(N) = CHARAC
  110 CONTINUE
C
C     BCD, INTEGER TRANSFER ON FIRST NON-BLANK CHARACTER
C
      IF (.NOT.SEQGP) GO TO 120
      GO TO (120,120,690,120,690,120,690,120,690), FIELD
C
  120 DO 130 N = 1,N8OR16
      IF (TYPE(N)) 150,130,320
  130 CONTINUE
C
C     ALL BLANK FIELD IF FALL HERE
C
      IF (FIELD .EQ. 1) GO TO 160
  140 IOUT = IOUT + 1
      OUT(IOUT) = 0
      IFMT = IFMT + 1
      FMT(IFMT) = 0
      GO TO 50
C
C     **********************************************
C
C     ALPHA HIT FOR FIRST CHARACTER
C
  150 IF (FIELD.EQ.1 .AND. VAL(N).EQ.STAR) GO TO 270
      IF (VAL(N) .EQ. PLUS  ) GO TO 290
      IF (VAL(N) .EQ. PERIOD) GO TO 300
      IF (VAL(N) .EQ. MINUS ) GO TO 310
C
C     PLAIN ALPHA BCD FIELD NOW ASSUMED.
C     CHECKING FOR DOULBE-FIELD * IF WE ARE IN FIELD 1
C
      IF (FIELD .NE. 1) GO TO 160
      IF (BCD(8).NE.STAR .OR. TYPE(8).NE.-1) GO TO 160
      NWORDS = 4
      N8OR16 = 16
C
C     REMOVE STAR BEFORE PUTTING 2 BCD WORDS INTO OUT
C
      BCD(8) = BLANK
  160 IOUT   = IOUT + 2
      IF (TYPE(1)) 170,180,170
  170 IF (NWORDS.EQ.4 .AND. FIELD.EQ.1) GO TO 180
      N = WORD - NWORDS
      OUT(IOUT-1) = IN(N+1)
      OUT(IOUT  ) = IN(N+2)
      GO TO 260
C
C     CHARACTER N WAS FIRST NON-BLANK CHARACTER
C
  180 MAX = N 8 OR 16  -  N  +  1
      DO 190 I = 1,MAX
      BCD(I) = BCD(N)
  190 N = N + 1
  200 IF (MAX .GE. 8) GO TO 210
      MAX = MAX + 1
      BCD(MAX) = BLANK
      GO TO 200
  210 WORD1 = 0
      WORD2 = 0
      DO 220 I = 1,4
      WORD1 = KHRFN3(BCD(I  ),WORD1,1,1)
      WORD2 = KHRFN3(BCD(I+4),WORD2,1,1)
  220 CONTINUE
      OUT(IOUT-1) = WORD1
      OUT(IOUT  ) = WORD2
  260 IFMT = IFMT + 1
      FMT(IFMT) = 3
      IF (FIELD .NE. 1) GO TO 50
      IF (KHRFN3(IZERO,OUT(IOUT-1),1,0).EQ.SEQ .AND.
     1    KHRFN3(IZERO,OUT(IOUT  ),0,0).EQ.P) SEQGP = .TRUE.
      GO TO 50
C
C     **********************************************
C
C     FIRST CHARACTER  ON CARD IS A STAR
C
  270 NWORDS = 4
      N 8 OR 16 = 16
  280 IOUT = IOUT + 2
      OUT(IOUT-1) = 0
      OUT(IOUT  ) = 0
      IFMT = IFMT + 1
      FMT(IFMT) = 3
      GO TO 50
C
C     **********************************************
C
C     FIRST CHARACTER IN FIELD IS A PLUS
C
  290 IF (FIELD .EQ. 1) GO TO 280
C
C     IGNORING PLUS SIGN AND NOW ASSUMING FIELD IS NUMBERIC
C
      GO TO 340
C
C     **********************************************
C
C     FIRST CHARACTER IN FIELD IS A PERIOD
C
  300 DECIML = .TRUE.
      PLACES = 0
      GO TO 340
C
C     **********************************************
C
C     FIRST CHARACTER IN FIELD IS A MINUS
C
  310 LMINUS = .TRUE.
      GO TO 340
C
C     **********************************************
C
C     0 TO 9 NUMERIC HIT
C
  320 IF (VAL(N)) 330,340,330
C
C     NON-ZERO NUMBER.  SAVING IT NOW IN TABLE NT
C
  330 NT(1) = VAL(N)
      IT = 1
  340 IF (N .EQ. N 8 OR 16) GO TO 380
C
C     PROCESS REMAINING DIGITS
C
      NNN = N + 1
      DO 370 N = NNN,N8OR16
      IF ((TYPE(N).EQ.0 .OR. VAL(N).EQ.ZERO) .AND. IT.EQ.0 .AND.
     1    .NOT.DECIML) GO TO 370
      IF (TYPE(N)) 350,350,360
C
C     FALL THRU IMPLIES NON 0 TO 9 CHARACTER
C
  350 IF (VAL(N) .NE. PERIOD) GO TO 430
      IF (DECIML) GO TO 910
      PLACES = 0
      DECIML = .TRUE.
      GO TO 370
C
C     0 TO 9 CHARACTER HIT. SAVE IT.
C
  360 IT = IT + 1
      NT(IT) = VAL(N)
      IF (DECIML) PLACES = PLACES + 1
  370 CONTINUE
C
C     NUMERIC WORD COMPLETED
C     IF DECIML IS .FALSE. NUMERIC IS A SIMPLE INTEGER
C
  380 IF (DECIML) GO TO 570
C
C     **********************************************
C
C     SIMPLE INTEGER
C
  390 NUMBER = 0
      IF (IT .EQ. 0) GO TO 410
      DO 400 I = 1,IT
      IF (((A67777-NT(I))/10) .LT. NUMBER) GO TO 890
  400 NUMBER = NUMBER*10 + NT(I)
  410 IF (LMINUS) NUMBER = - NUMBER
  420 IOUT = IOUT + 1
      OUT(IOUT) = NUMBER
      IFMT = IFMT + 1
      FMT(IFMT) = 1
      GO TO 50
C
C     **********************************************
C
C     PROBABLE (E, D, +, -) EXPONENT HIT OR BLANK
C
  430 IF (TYPE(N)) 460,440,460
C
C     BLANK HIT THUS ONLY AN EXPONENT OR BLANKS PERMITTED FOR BALANCE
C     OF FIELD
C
  440 IF (N .EQ. N 8 OR 16) GO TO 450
      N = N + 1
      IF (TYPE(N)) 460,440,960
C
C     FALL THRU ABOVE LOOP IMPLIES BALANCE OF FIELD WAS BLANKS
C
  450 IF (DECIML) GO TO 570
      GO TO 390
C
C     **********************************************
C
C     COMING HERE IMPLIES A NON-BLANK CHARACTER HAS BEEN HIT BEGINNING
C     AN EXPONENT. IT HAS TO BE A (+, -, D, OR E ) FOR NO ERROR
C
  460 IF (VAL(N) .NE. PLUS) GO TO 470
      EXPONT= .TRUE.
      SIGN  = PLUS
      GO TO 500
  470 IF (VAL(N) .NE. E) GO TO 480
      EXPONT= .TRUE.
      GO TO 500
  480 IF (VAL(N) .NE. MINUS) GO TO 490
      EXPONT= .TRUE.
      SIGN  = MINUS
      GO TO 500
  490 IF (VAL(N) .NE. D) GO TO 960
      EXPONT= .TRUE.
      DOUBLE= .TRUE.
C
C     READ INTEGER POWER, WITH OR WITHOUT SIGN
C
  500 IF (N .EQ. N 8 OR 16) GO TO 950
      N = N + 1
C
      IF (TYPE(N)) 510,500,520
  510 IF (VAL(N).NE.PLUS .AND. VAL(N).NE.MINUS) GO TO 520
      IF (SIGN .NE. 0) GO TO 940
      SIGN = VAL(N)
      GO TO 500
C
C     FIRST DIGIT OF INTEGER POWER AT HAND NOW
C
  520 POWER = 0
      BLKON = .FALSE.
C
  530 IF (TYPE(N)) 930,930,540
  540 POWER = POWER*10 + VAL(N)
C
C     GET ANY MORE DIGITS IF PRESENT
C
  550 IF (N .EQ. N 8 OR 16) GO TO 570
      N = N + 1
      IF (BLKON) IF (TYPE(N)) 980,550,980
      IF (TYPE(N)) 530,560,530
C
C     BLANK HIT, BALANCE OF FIELD MUST BE BLANKS
C
  560 BLKON = .TRUE.
      GO TO 550
C
C     **********************************************
C
C     SINGLE OR DOUBLE PRECISION FLOATING POINT NUMBER
C     COMPLETE AND OUTPUT IT.
C
C     15 SIGNIFICANT FIGURES POSSIBLE ON INPUT
C     CONSIDERED SINGLE PRECISION UNLESS D EXPONENT IS PRESENT
C
  570 IF (SIGN .EQ. MINUS) POWER = -POWER
      POWER = POWER - PLACES
C
      NUMBER = 0
      IF (IT) 580,620,580
  580 IF (IT .LT. 7) GO TO 590
      N = 7
      GO TO 600
  590 N = IT
  600 DO 610 I = 1,N
  610 NUMBER = NUMBER*10 + NT(I)
  620 XDOUBL = DBLE(FLOAT(NUMBER))
      IF (IT .LE. 7) GO TO 640
      NUMBER = 0
      DO 630 I = 8,IT
  630 NUMBER = NUMBER*10 + NT(I)
      XDOUBL = XDOUBL*10.0D0**(IT-7) + DBLE(FLOAT(NUMBER))
  640 IF (LMINUS) XDOUBL = -XDOUBL
C
C     CHECK FOR POWER IN RANGE OF MACHINE
C
      ICHEK = POWER + IT
      IF (XDOUBL .EQ. 0.0D0) GO TO 660
      IF (ICHEK.LT.LOWPW+1 .OR. ICHEK.GT.HIGHPW-1 .OR.
     1    POWER.LT.LOWPW+1 .OR. POWER.GT.HIGHPW-1) GO TO 860
C
      XDOUBL = XDOUBL*10.0D0**POWER
  660 IFMT = IFMT + 1
      IF (DOUBLE) GO TO 670
      FL1  = XDOUBL
      IOUT = IOUT + 1
      OUT(IOUT) = INT1
      FMT(IFMT) = 2
      GO TO 50
  670 IOUT = IOUT + 2
      OUT(IOUT-1) = NDOUBL(1)
      OUT(IOUT  ) = NDOUBL(2)
      FMT(IFMT) = 4
      GO TO 50
  680 NFLAG = IOUT
      FMT(IFMT+1) = -1
      RETURN
C
C     **********************************************
C
C     FIRST CHARACTER OF FIELD 3, 5, 7,  OR 9 ON SEQGP CARD ENCOUNTERED.
C
C     IT HAS TO BE A 1 TO 9 FOR NO ERROR
C
  690 DO 700 N = 1,N8OR16
      IF (TYPE(N)) 1000,700,710
  700 CONTINUE
      GO TO 140
C
C     STORE NUMBER IN NT
C
  710 NPOINT = 0
  720 IT = IT + 1
      NT(IT) = VAL(N)
  730 IF (N .EQ. N 8 OR 16) GO TO 800
      N = N + 1
C
C     GET NEXT CHARACTER
C
      IF (NPOINT.GT.0 .AND. .NOT.DECIML .AND. .NOT.BLKON) GO TO 790
      IF (DECIML) GO TO 770
      IF (BLKON ) GO TO 750
      IF (TYPE(N)) 740,740,720
  740 IF (VAL(N)  .EQ. PERIOD) GO TO 760
  750 IF (TYPE(N) .NE.      0) GO TO 1020
      BLKON = .TRUE.
      GO TO 730
C
  760 DECIML = .TRUE.
      NPOINT = NPOINT + 1
      GO TO 730
C
  770 IF (TYPE(N)) 1020,1020,780
C
  780 DECIML = .FALSE.
      GO TO 720
C
  790 IF (VAL(N).EQ.PERIOD .AND. TYPE(N).LT.0) GO TO 760
      GO TO 750
C
C     READY TO COMPUTE INTEGER VALUE OF SPECIAL SEQGP INTEGER
C
  800 NPOINT = 3 - NPOINT
      IF (NPOINT) 1010,830,810
  810 DO 820 K = 1,NPOINT
      IT = IT + 1
  820 NT(IT) = 0
C
C     COMPUTE NUMBER
C
  830 NUMBER = 0
      IF (IT) 840,420,840
  840 DO 850 K = 1,IT
      IF (((A67777-NT(K))/10) .LT. NUMBER) GO TO 1040
      NUMBER = NUMBER*10 + NT(K)
  850 CONTINUE
      GO TO 420
C
C
  860 WRITE  (F6,870) UFM
  870 FORMAT (A23,' 300, DATA ERROR IN FIELD UNDERLINED.')
      WRITE  (F6,880)
  880 FORMAT (10X,42HFLOATING POINT NUMBER OUT OF MACHINE RANGE)
      GO TO  1060
  890 WRITE  (F6,870) UFM
      WRITE  (F6,900)
  900 FORMAT (10X,38HINTEGER MAGNITUDE OUT OF MACHINE RANGE)
      GO TO  1060
  910 WRITE  (F6,870) UFM
      WRITE  (F6,920)
  920 FORMAT (10X,22HDATA NOT RECOGNIZEABLE)
      GO TO  1060
  930 CONTINUE
  940 CONTINUE
  950 CONTINUE
  960 WRITE  (F6,870) UFM
      WRITE  (F6,970)
  970 FORMAT (10X,26HPOSSIBLE ERROR IN EXPONENT)
      GO TO  1060
  980 WRITE  (F6,870) UFM
      WRITE  (F6,990)
  990 FORMAT (10X,23HPOSSIBLE IMBEDDED BLANK)
      GO TO  1060
 1000 CONTINUE
 1010 CONTINUE
 1020 WRITE  (F6,870) UFM
      WRITE  (F6,1030)
 1030 FORMAT (10X,30HINCORRECT DEWEY DECIMAL NUMBER)
      GO TO  1060
 1040 WRITE  (F6,870) UFM
      WRITE  (F6,1050)
 1050 FORMAT (10X,49HINTERNAL CONVERSION OF DEWEY DECIMAL IS TOO LARGE)
 1060 WORD = (FIELD-1)*NWORDS + 2
      ASSIGN 1090 TO IRETRN
      WORD2 = STARS
 1070 LINE(WORD  ) = WORD2
      LINE(WORD-1) = WORD2
      IF (NWORDS .EQ. 2  .OR.  FIELD .EQ. 1) GO TO 1080
      LINE(WORD-2) = WORD2
      LINE(WORD-3) = WORD2
 1080 GO TO IRETRN,(1090,1150)
 1090 IF (NWORDS .EQ. 4) GO TO 1110
      WRITE  (F6,1100)
 1100 FORMAT (10X,80H.   1  ..   2  ..   3  ..   4  ..   5  ..   6  ..  
     1 7  ..   8  ..   9  ..  10  .)
      GO TO 1130
 1110 WRITE  (F6,1120)
 1120 FORMAT (10X,80H.   1  ..   2  AND  3  ..   4  AND  5  ..   6  AND 
     1 7  ..   8  AND  9  ..  10  .)
 1130 WRITE  (F6,1140) (IN(I),I=1,20),LINE
 1140 FORMAT (10X,20A4)
      ASSIGN 1150 TO IRETRN
      WORD2 = BLANKS
      GO TO 1070
 1150 IOUT = IOUT + 1
      NLINES = NLINES + 7
      OUT(IOUT) = 0
      IFMT = IFMT + 1
      FMT(IFMT) = -1
      NOGO = .TRUE.
      GO TO 50
      END

      SUBROUTINE DADD
C
C     DMAP DRIVER FOR ADD--
C
C     ADD    A,B/C/V,N,ALPHA/V,N,BETA/V,N,DALPHA/V,N,DBETA/V,N,ECHO  $
C
C            MATRIX C = ALPHA*MATRIX A + BETA*MATRIX B
C
C     MATRIX C IS COMPLEX IF ANY ONE OF THE MATRIX A, MATRIX B, SCALE
C     ALPHA, OR SCLAE BETA IS COMPLEX
C
      LOGICAL           DBLEA    ,DBLEB
      INTEGER           FN(2)    ,ECHO     ,AA(2)     ,BB(2)
      DOUBLE PRECISION  DALPHA   ,DBETA    ,DALP(2)   ,DBTA(2)  ,
     1                  ZERO     ,ONE      ,XX
      CHARACTER         UFM*23   ,UWM*25   ,UIM*29
      COMMON /XMSSG /   UFM      ,UWM      ,UIM
      COMMON /SYSTEM/   IBUF     ,NOUT
      COMMON /BLANK /   ALPHA(2) ,BETA(2)  ,DALPHA(2) ,DBETA(2) ,
     1                  ECHO
      COMMON /SADDX /   NOMAT    ,LCORE    ,IA(7)     ,ITA      ,
     1                  ALP(4)   ,IB(7)    ,ITB       ,BTA(4)   ,
     2                  CDE(3,12),IC(7)
      COMMON /ZZZZZZ/   CORE(1)
      EQUIVALENCE       (ALP(1),DALP(1))   ,(BTA(1),DBTA(1))
      DATA              IN1,IN2,IOUT1,ZERO /101,102,201, 0.0D+0 /
      DATA              ONE,XX ,X    / 1.0D+0, 1.0D+37, 1.0E+37 /
C
C
C     SCALE FACTORS ALPHA, DALPHA, BETA AND DBETA WERE INITIALLY SET TO
C     (1.1+37, 1.1+37) BY XMPLDD
C
C     IN THIS ROUTINE -
C     IF ALPHA, DALPHA, BETA AND DBETA ARE NOT SPECIFIED BY USER, THEY
C     WILL BE SET TO -
C     ALPHA AND DALPHA TO (1.0, 0.0), AND
C     BETA  AND DBETA  TO (1.0, 0.0), SAME DEFAULTS AS 88 AND EARLIER
C                                     NASTRAN VERSIONS.
C     NOTE - DEFAULTS WERE ALL ZEROS IN 89 NASTRAN VERSION
C
C     NOTE - THIS ROUTINE WILL CALL SADD TO DO THE ACTUAL MATRIX MULTI-
C     PLICATION, WHICH WILL AUTOMATICALLY ADJUST THE SCALE FACTORS
C     WHETHER THEY ARE S.P. OR D.P. (E.G. S.P. ALPHA AND BETA CAN BE
C     USED FOR D.P. A AND B MATRICES, AND VISE VERSA)
C
      CALL FNAME (IOUT1,FN(1))
      LCORE = KORSZ(CORE)
      DO 10 I = 1,7
      IA(I) = 0
      IB(I) = 0
      IC(I) = 0
   10 CONTINUE
      IA(1) = IN1
      IB(1) = IN2
      CALL RDTRL (IA)
      CALL RDTRL (IB)
      IF (IA(1) .LT. 0) IA(1) = 0
      IF (IB(1) .LT. 0) IB(1) = 0
      IF (IA(1)+IB(1) .EQ. 0) GO TO 100
C
C     SET DEFAULT VALUES FOR THE SCALE FACTORS
C
C     WHEN AN ITEM IS .LT. X OR XX, THAT ITEM HAS INPUT FROM USER
C
      DBLEA = .TRUE.
      DBLEB = .TRUE.
      IF (ALPHA(1).LT.X .OR. ALPHA(2).LT.X .OR. DALPHA(1).LT.XX .OR.
     1   DALPHA(2).LT.XX) GO TO 20
      ALP(1)   = 1.0
      ALP(2)   = 0.0
      ALPHA(1) = 1.0
      ALPHA(2) = 0.0
      DBLEA  = .FALSE.
   20 IF (BETA(1).LT.X .OR. BETA(2).LT.X .OR. DBETA(1).LT.XX .OR.
     1   DBETA(2).LT.XX) GO TO 25
      BTA(1)  = 1.0
      BTA(2)  = 0.0
      BETA(1) = 1.0
      BETA(2) = 0.0
      DBLEB  = .FALSE.
      IF (.NOT.DBLEA) GO TO 40
C
   25 IF ((ALPHA(1).LT.X .OR. ALPHA(2).LT.X) .AND. (DALPHA(1).LT.XX .OR.
     1    DALPHA(2).LT.XX)) GO TO 120
      IF (( BETA(1).LT.X .OR.  BETA(2).LT.X) .AND. ( DBETA(1).LT.XX .OR.
     1     DBETA(2).LT.XX)) GO TO 120
C
      IF (DALPHA(1).GT.XX .AND. DALPHA(2).GT.XX) DBLEA = .FALSE.
      IF ( DBETA(1).GT.XX .AND.  DBETA(2).GT.XX) DBLEB = .FALSE.
C
      DO 30 I = 1,2
      IF ( ALPHA(I) .GT.  X)  ALPHA(I) = 0.0
      IF (DALPHA(I) .GT. XX) DALPHA(I) = ZERO
      IF (  BETA(I) .GT.  X)   BETA(I) = 0.0
      IF ( DBETA(I) .GT. XX)  DBETA(I) = ZERO
   30 CONTINUE
C
C     MOVE ALPHA, BETA, DALPHA AND DBETA INTO ALP AND BTA ARRAYS FOR
C     MATRIX MULTIPLICATION TO BE PERFORMED IN SADD.
C
      DO 35 I = 1,2
      IF (.NOT.DBLEA)  ALP(I) =  ALPHA(I)
      IF (.NOT.DBLEB)  BTA(I) =   BETA(I)
      IF (     DBLEA) DALP(I) = DALPHA(I)
      IF (     DBLEB) DBTA(I) =  DBETA(I)
   35 CONTINUE
C
   40 IF (ECHO .EQ. 0) GO TO 55
      WRITE  (NOUT,45) UIM,FN
   45 FORMAT (A29,', SCALE FACTORS FOR THE OUTOUT DATA BLOCK ',2A4,
     1       ', IN ADD MODULE ARE -')
      IF (.NOT.DBLEA) WRITE (NOUT,50) ALP(1) ,ALP(2)
      IF (     DBLEA) WRITE (NOUT,51) DALP(1),DALP(2)
      IF (.NOT.DBLEB) WRITE (NOUT,52) BTA(1) ,BTA(2)
      IF (     DBLEB) WRITE (NOUT,53) DBTA(1),DBTA(2)
   50 FORMAT (5X,'1ST S.F. = (',E12.5,1H,,E12.5,1H))
   51 FORMAT (5X,'3RD S.F. = (',D12.5,1H,,D12.5,1H))
   52 FORMAT (1H+,48X,'2ND S.F. = (',E12.5,1H,,E12.5,1H))
   53 FORMAT (1H+,48X,'4TH S.F. = (',D12.5,1H,,D12.5,1H))
C
C     ENSURE THAT THE MATRICES BEING ADDED ARE OF THE SAME ORDER
C
   55 IF (IA(1).EQ.0 .OR. IB(1).EQ.0) GO TO 70
      IF (IA(2).EQ.IB(2) .AND. IA(3).EQ.IB(3)) GO TO 70
      CALL FNAME (IA(1),AA)
      CALL FNAME (IB(1),BB)
      WRITE  (NOUT,60) UFM,AA,BB,FN,IA(2),IA(3),IB(2),IB(3)
   60 FORMAT (A23,' 4149, ATTEMPT TO ADD MATRICES OF UNEQUAL ORDER IN',
     1       ' MODULE ADD, ',2A4,' TO ',2A4, /5X,'INTENDED OUTOUT DATA',
     2       ' BLOCK NAME =',2A4,I7,' BY',I6,' TO',I7,' BY',I6)
      GO TO 160
   70 IC(1) = IOUT1
      IC(2) = IA(2)
      IC(3) = IA(3)
      IF (IA(4) .EQ. 3) IC(2) = IA(3)
      IF (IA(1) .NE. 0) GO TO 80
      IC(2) = IB(2)
      IC(3) = IB(3)
C
C     DETERMINE TYPE
C
   80 ITA = 3
      ITB = 3
      IF (ALP(2).EQ.0.0 .AND. ALP(4).EQ.0.0) ITA = 1
      IF (BTA(2).EQ.0.0 .AND. BTA(4).EQ.0.0) ITB = 1
      IC(5) = MAX0(IA(5),IB(5),ITA,ITB)
      IF (IC(5).EQ.3 .AND. (IA(5).EQ.2 .OR. IB(5).EQ.2)) IC(5) = 4
C
C     DETERMINE FORM
C
      IC(4) = IA(4)
      IF (IA(1) .EQ. 0) IC(4) = IB(4)
      IF (IC(4).NE.1 .OR. IC(4).NE.6) GO TO 90
      IC(4) = 6
      IF (IA(1).NE.0 .AND. IA(4).NE.6) IC(4) = 1
      IF (IB(1).NE.0 .AND. IB(4).NE.6) IC(4) = 1
      IF (IC(2) .NE. IC(3)) IC(4) = 2
   90 IF (IA(4).EQ.3 .AND. IB(1).NE.0) IC(4) = IB(4)
      IF (IA(4).EQ.3 .AND. IB(1).EQ.0) IC(4) = IA(4)
C
      NOMAT = 2
      CALL SADD (CORE,CORE)
      CALL WRTTRL (IC)
      GO TO 170
C
  100 WRITE  (NOUT,110) UFM,FN
  110 FORMAT (A23,', INPUT MATRICES NOT SPECIFIED IN ADD MODULE.',
     1       ' INTENDED OUTPUT DATA BLOCK NAME =',2A4)
      GO TO 160
C
  120 DO 130 I=1,2
      IF ( ALPHA(I) .GT.  X) ALPHA(I)  = 0.0
      IF (DALPHA(I) .GT. XX) DALPHA(I) = ZERO
      IF (  BETA(I) .GT.  X)   BETA(I) = 0.0
      IF ( DBETA(I) .GT. XX)  DBETA(I) = ZERO
  130 CONTINUE
      WRITE  (NOUT,150) UFM,FN,ALPHA,BETA,DALPHA,DBETA
  150 FORMAT (A23,' IN ADD MODULE. INTENDED OUTPUT DATA BLOCK =',2A4,
     1       /5X,'SCALE FACTORS ARE ERRONEOUS =',4E9.2,2X,4D10.3)
  160 CALL MESAGE (-61,0,0)
C
  170 RETURN
      END

      SUBROUTINE OPTP1B (ELT,ELOP,ELE,PR)
C
      INTEGER         ELT(1),ELOP(2,1),ELE(1),PR(1),COUNT,ECT,SYSBUF,
     1                OUTTAP,YCOR,PRCOR,PRC,NAME(2),CARD(2),ELCR,ELPT,
     2                PID,PRPT,PRPT1,B1P1
      COMMON /BLANK / SKP1(2),COUNT,SKP2(2),YCOR,B1P1,NPOW,
     1                NELW,NWDSE,NPRW,NWDSP,SKP3,
     2                SKP4(2),ECT,SKP5(4),NUMELM,ITYPE(21)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG / UFM,UWM,UIM,SFM
      COMMON /ZZZZZZ/ X(1)
      COMMON /OPTPW1/ PRCOR,PRC(2)
      COMMON /GPTA1 / NTYPES,LAST,INCR,NE(1)
      COMMON /SYSTEM/ SYSBUF,OUTTAP
      COMMON /NAMES / NRD,NOEOR,NWRT,NWEOR
      DATA    NAME  / 4H OPT,4HP1B  /
C
C
      IEOP  = 1
      IDES  = ELOP(1,IEOP  )
      IDEE  = ELOP(1,IEOP+1)
      PRPT  = 1
      PRPT1 = 1
      ELOP(2,1) = 1
C
C     IN CASE OF ERROR SET PRC(1)
C
      PRC(1) = -1
C
      DO 130 K = 1,NUMELM
      NELE = (IDEE-IDES)/NWDSE
      IF (NELE) 30,120,10
C
   10 IDX = INCR*(ITYPE(K)-1)
      IDP = IDX + 4
      CARD(1) = NE(IDP  )
      CARD(2) = NE(IDP+1)
      IF (NE(IDP+2).GT.PRCOR) GO TO 150
      CALL LOCATE (*160,X(B1P1),CARD(1),I)
C
C     SEQUENTIAL ELEMENT SEARCH
C
      NPR  = 0
      ELPT = IDES
      ELCR = ELE(ELPT)
C
   20 CALL READ (*160,*160,ECT,PRC,NE(IDP+2),NOEOR,I)
      IF (PRC(1)-ELCR) 20,50,30
C
C     LOGIC OR FILE FAILURE
C
   30 CALL PAGE2 (-2)
      WRITE  (OUTTAP,40) SFM,ITYPE(K),PRC(1),NAME
   40 FORMAT (A25,' 2297, INCORRECT LOGIC FOR ELEMENT TYPE',I4,
     1       ', ELEMENT',I8,2H (,2A4,2H).)
      GO TO 170
C
C     ELEMENT ID IN CORE .EQ. ECT ID - ELEMENT TO BE OPTIMIZED
C
   50 PID = PRC(2)
      CARD(1) = PID
      CARD(2) = ELE(ELPT+4)
C
C     TEST FOR CORE NEEDED AFTER EXPANDING TO NWDSP WORDS
C
      IF (PRPT1+NWDSP*(NPR/2+1) .GT. YCOR) GO TO 180
      CALL BISHEL (*60,CARD,NPR,2,PR(PRPT1))
   60 ELE(ELPT+4) = PID
      ELPT = ELPT + NWDSE
      IF (ELPT .GE. IDEE) GO TO 70
      ELCR = ELE(ELPT)
      GO TO 20
C
C     NEW ELEMENT TYPE COMING
C
   70 CALL FREAD (ECT,0,0,NWEOR)
C
C     EXPAND PROPERTIES TO NWDSP WORDS/PROPERTY
C
      NX = NPR/2
      IF (NX-1) 30,100,80
   80 CONTINUE
      DO 90 I = 1,NX
      J = NX - I
      L = PRPT1 + J*NWDSP
      M = PRPT1 + J*2
      PR(L  ) = PR(M  )
   90 PR(L+1) = PR(M+1)
C
  100 PRPT = PRPT1 + NX*NWDSP
C
C     PLACE POINTERS IN ELEMENT ARRAY
C
      L = IDEE - 1
      DO 110 I = IDES,L,NWDSE
      KID = ELE(I+4)
      CALL BISLOC (*30,KID,PR(PRPT1),NWDSP,NX,J)
      ELE(I+4) = J
  110 CONTINUE
C
C     SETUP FOR NEXT ELEMENT
C
  120 IEOP = IEOP + 1
      ELOP(2,IEOP) = PRPT
      PRPT1 = PRPT
      IDES  = IDEE
      IF (IEOP .GT. NPOW) GO TO 140
      IDEE = ELOP(1,IEOP+1)
  130 CONTINUE
C
C
  140 NPRW = PRPT - 1
      RETURN
C
C     ERRORS
C
C     INSUFFICIENT CORE IN /OPTPW1/ OR /XXOPT1/
C
  150 COUNT = -1
      GO TO 140
C
C     FILE ERRORS
C
  160 CALL MESAGE (-7,ECT,NAME)
  170 PRPT = 1
      GO TO 140
C
C     INSUFFICIENT CORE
C
  180 CALL PAGE2 (-2)
      WRITE  (OUTTAP,190) UFM,NAME,B1P1,PID
  190 FORMAT (A23,' 2298, INSUFFICIENT CORE ',2A4,1H(,I10,'), PROPERTY',
     1        I9)
      GO TO 150
      END

      SUBROUTINE INVP1
C
C     INVP1 INITIALIZES AND CALLS SUBROUTINE ADD FOR INVPWR
C
      INTEGER          FILEA    ,FILEB    ,FILEC    ,FILEK   ,FILEM  ,
     1                 SCR1     ,TYPALP   ,TYPBTA   ,SQR     ,RDP
      DOUBLE PRECISION LAMBDA   ,DALPHA   ,DBETA
      COMMON  /INVPWX/ FILEK(7) ,FILEM(7) ,SCR1
      COMMON  /INVPXX/ LAMBDA
      COMMON  /SADDX / NOMAT    ,NZ       ,FILEA(7) ,TYPALP  ,
     1                 DALPHA(2),FILEB(7) ,TYPBTA   ,DBETA(2),
     2                 DUM(36)  ,FILEC(7)
      COMMON  /ZZZZZZ/ Z(1)
      COMMON  /NAMES / IJ(8)    ,RDP      ,IK(2)    ,SQR
      COMMON  /SYSTEM/ KSYSTM(56)
      EQUIVALENCE      (KSYSTM(55),IPREC)
C
C     SET UP CALL TO ADD
C
      DO 10  I = 1,7
      FILEA(I) = FILEM(I)
   10 FILEB(I) = FILEK(I)
      DALPHA(1)=-LAMBDA
      DBETA(1) = 1.0D0
      TYPALP   = IPREC
      TYPBTA   = IPREC
      NZ       = KORSZ(Z)
      FILEC(1) = SCR1
      FILEC(2) = FILEK(2)
      FILEC(3) = FILEK(3)
      FILEC(4) = SQR
      FILEC(5) = IPREC
      NOMAT    = 2
      IF (FILEB(1) .EQ. 0) NOMAT = 1
      CALL SADD (Z,Z)
      CALL WRTTRL (FILEC)
      RETURN
      END

      SUBROUTINE CYCT2A (KAA,KXX,G1,G2,SCR1,SCR2,SCR3)
      INTEGER G1,G2,SCR1,SCR2,MCB(7),SCR3
      COMMON /SYSTEM/IDUM(54),IPREC
C
      MCB(1)=KAA
      CALL RDTRL(MCB)
      IF(MCB(1).LE.0)GO TO 30
      MCB(1)=KXX
      CALL RDTRL(MCB)
      IF(MCB(1).LE.0)GO TO 30
      ISC2=SCR2
      MCB(1)=G1
      CALL RDTRL (MCB)
      IF (MCB(2).LE.0)ISC2=0
      MCB(1)=G2
      CALL RDTRL(MCB)
      IF(MCB(2).LE.0)GO TO 10
      ISC=SCR2
      IOUT=1
      ISC1=KXX
      GO TO 20
   10 ISC=KXX
      ISC1=SCR2
      IOUT=0
C
C     NO FIRST TERM IF ISC2=0, NO SECOND TERM IF IOUT=0
C
   20 IF (ISC2 .EQ. 0) GO TO 25
C
C     COMPUTE FIRST TERM
C
      CALL SSG2B(KAA,G1,0,SCR1,0,IPREC,1,SCR2)
      CALL SSG2B(G1,SCR1,0,ISC,1,IPREC,1,ISC1)
C
C     COMPUTE SECOND TERM
C
C     COMPUTE SECOND TERM
C
   25 IF(IOUT .EQ. 0) GO TO 29
      CALL SSG2B(KAA,G2,0,SCR1,0,IPREC,1,KXX)
      CALL SSG2B(G2,SCR1,ISC2,KXX,1,IPREC,1,SCR3)
   29 MCB(1) = KXX
   30 RETURN
      END

      SUBROUTINE IFP1H (I81,NZ,J400)
C
C     THIS ROUTINE PROCESSES THE SCAN CARD IN CASE CONTROL SECTION
C
C     WRITTEN BY G.CHAN/SPERRY,  OCTOBER 1984
C
C     PROGRAM METHOD
C
C     A 'SCAN(HELP)' INPUT CARD WILL SET J400 TO 2, AND ANY ERROR IN
C     A SCAN INPUT CARD WILL SET J400 TO 1. NON-ZERO J400 WILL CAUSE
C     SCAN COMPONENT KEY-WORDS TO BE PRINTED.
C
C     THE SCAN INPUT CARDS, AND THEIR DATA, ARE DECODED AND SAVED IN
C     CASECC FILE AS SETS OF PSEUDO SET COMMANDS (SET ID OF 10000000 FOR
C     STRESS, AND 20000000 FOR FORCE). IN THIS WAY, THE SCAN CARDS CAN
C     BE USED IN ALL SUBCASE LEVELS, OR ABOVE-SUBCASE LEVEL, SIMILAR TO
C     THE ELEM. STRESS AND ELEM. FORCE CARDS IN THE CASE CONTROL SECTION
C     HOWEVER, MULTIPLE SCAN CARDS CAN BE USED IN ALL SUBCASE LEVELS,
C     AND WITHIN EACH SUBCASE
C
C     ELEM. NAME CAN BE SPECIFIED WITH OR WITHOUT THE LEADING LETTER C
C     E.G.  BAR, CBAR, QUAD2, CQUAD2
C
C     SCAN COMPONENTS CAN BE REQUESTED BY ACTUAL OUTPUT COLUMN NUMBER(S)
C     OR BY COMPONENT KEYWORD(S)
C     IF THE ACTUAL OUTPUT COLUMN IS NOT IN THE SAME WORD ORDER AS IN
C     THE OUTPUT PRINT FILE (E.G. OES1L FOR THE QUAD4 LAYER), THE ACTUAL
C     COLUMN COUNT AS IT APPEARS IN THE PRINTOUT, IS USED HERE. ANY
C     DISCREPANCY SHOULD BE HANDLED BY SCAN OR STRSCN ROUTINES.
C
C     A LIST OF KEYWORDS WILL BE PRINTED AUTOMATICALLY IF ELEM. NAME OR
C     COMPONENT KEYWORD ARE MISSPELLED OR MISSSING
C
C     THIS LIST IS ALSO PRINTED IF A  SCAN (HELP) CARD IS IN INPUT DECK
C
C     THIS ROUTINE MAY ISSUE THE FOLLOWING ERROR MESSAGES -
C
C        604 - NON-INTEGER IN INTEGER FIELD
C        608 - SET NOT DEFINED
C        617 - IMPROPER FORMAT
C        634 - KEYWORD INSIDE BRACKET IS ILLEGAL OR MISSPELLED
C        635 - ONLY ONE SET-ID ALLOWED IN A SCAN CARD
C        636 - EXTRA VALUE ENCOUNTERED
C        637 - ILLEGAL COMPONENT SPECIFIED
C        638 - COMPONENT LIMIT OF 31 IS EXCEEDED
C        639 - SET ID ERROR (REQUESTED BEFORE EQUAL SIGN OR SPLITTED ID)
C        640 - TOO MANY COMPONENTS BY NAME
C        641 - -MAX EXCEEDS +MAX
C        642 - COMPONENT NAME NOT AVAILABLE FOR ELEMENT SELECTED
C        643 - SCAN BY STRESS OR FORCE ONLY
C        644 - WARNING MESSAGE FOR POSSIBLE INSUFFICIENT CORE
C        909 - CORE ARRAY NOT INITIALIZED CORRECTLY, OR MZERO IS NOT SET
C              IN AGREEMENT WITH XRCARD
C
C     EXAMPLE - TO ADD A NEW ELEMENT TO THE SCAN MODULE   BY G.C. 7/89
C           1.  INCREASE COMP DIMENSION TO ALLOW NEW COMPONENT WORDS
C               IF THEY DO NOT ALREADY EXIST.
C           2.  EXPAND THE SP-ARRAY IF NECESSARY. INCREASE NCOMP BY
C               THE NUMBER OF NEW WORDS ADDED
C           3.  REACTIVATE THE CORRESPONDING WORD IN ETAB THAT POINTS
C               TO THE NEW ARRAY IN TAB
C           4.  IF SP-ARRAY IS USED, MAKE SURE THAT THE COMPONENT WORDS
C               ARE PROPERLY PROCESSED, IN STATEMENT NOS. 110-120
C           5.  SET THE CODED WORDS IN TAB. SEE COMMENTS FUTHER DOWN
C           6.  PREPARE FORMAT FOR COMPONENT WORDS PRINT OUT (FMT 690)
C               UPDATE ISP-ARRAY IN CASE SP-ARRAY WAS USED PREVIOUSLY
C
      LOGICAL         DEBUG,   BIT64
      INTEGER         CORE(1), SCR1,    NAM(2),  STRESS,  FORCE,
     1                SETI,    BLANK,   E,       ERR,     EQUAL
      INTEGER         SAVE(5), ETAB(90),TAB(10,17),       COMP(2,60),
     1                COMP1(2,19),      COMP2(2,19),      ISP(10),
     2                TAB1(10,9),       TAB2(10,8),       SP(30),
     3                COMP3(2,19),      COMP4(2,3),       ICSE(400),
     4                COREY(401)
      DIMENSION       RCORE(1),LL(4),   CC(4),   KEYWDS(3)
      REAL            BCD(2,3)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /SYSTEM/ IBUF,    NOUT,    NOGO,    SKIP(5), NLPP,
     1                MORE(2), LINE
      COMMON /MACHIN/ MACH
      COMMON /GPTA1 / NELEM,   LAST,    INCR,    E(1)
      COMMON /XIFP1 / BLANK,   BIT64
      COMMON /IFP1A / SCR1,    CASECC,  IS,      NWPC,    NCPW,
     1                NMODES,  ICC,     NSET,    DUMMY(3),ISUB,
     2                LENCC,   IBLNK,   IEQUAL,  IEOR
      COMMON /IFP1HX/ MSST,    MISSET(1)
      COMMON /ZZZZZZ/ COREX(1)
      EQUIVALENCE     (CORE(1)  ,RCORE(1)   ,  COREY(401)           ),
     1                (COREX(1) ,COREY(1)   ,  ICSE(1)              ),
     2                (COMP(1,1),COMP1(1,1)), (COMP4(1,1),COMP(1,58)),
     3                (TAB1(1,1) ,TAB(1, 1)), (COMP2(1,1),COMP(1,20)),
     4                (TAB2(1,1),TAB(1,10)) , (COMP3(1,1),COMP(1,39)),
     5                (BLANK    ,XBLANK   ) , (STRESS    ,BCD(1,1)  ),
     6                (FORCE    ,BCD(1,2) ) , (SHEA      ,COMP(1, 9)),
     7                (NORM     ,COMP(1,9)) , (MOME      ,COMP(1,22))
      DATA    NCOMP,  EQUAL,    LLL,    SETI,   DEBUG    /
     1        58,     4H=   ,   4HL   , 4HSET , .FALSE.  /
      DATA    LLC,    COMMA,    MZERO,  BCD                          /
     1        4HC   , 4H,   ,   -0    , 4HSTRE,2HSS,4HFORC,1HE,2*1H  /
      DATA    NAM   / 4HIFP1,   4HH   /
      DATA    COMP1 / 4HAXIA,   4HL   ,
     2                4HTORS,   4HIONA,
     3                4HRADI,   4HAL  ,
     4                4HNORM,   4HAL  ,
     5                4HPRIN,   4HCIPA,
     6                4HMAJO,   4HR   ,
     7                4HMINO,   4HR   ,
     8                4HBEND,   4HING ,
     9                4HNORM,   4H-X  ,
C    9                or          -U  , AL-1, AL-X
     O                4HNORM,   4H-Y  ,
C    O                or          -V  , AL-2, AL-Y
     1                4HNORM,   4H-Z  ,
     2                4HSHEA,   4HR   ,
C    2                or          R-1Z, R-41
     3                4HSHEA,   4HR-XY,
C    3                or          R-ZR, R-X , R-U , R-12
     4                4HSHEA,   4HR-YZ,
C    4                or          R-RT, R-Y , R-V , R-23
     5                4HSHEA,   4HR-ZX,
C    5                or          R-ZT, R-UV, R-2Z, R-34
     6                4HMAX-,   4HSHR ,
     7                4HSHR-,   4HFORC,
     8                4HOCT-,   4HSHR ,
     9                4HSA-M,   4HAX  /
      DATA    COMP2 / 4HSB-M,   4HAX  ,
     1                4HMOME,   4HNT  ,
     2                4HMOME,   4HNT-A,
C    2                or          NT-X, NT-U , NT-1
     3                4HMOME,   4HNT-B,
C    3                or          NT-Y, NT-V , NT-2
     4                4HCURV,   4H    ,
     5                4HTORQ,   4HUE  ,
     6                4HCIRC,   4HUM  ,
     7                4HTWIS,   4HT   ,
     8                4HMARG,   4HIN  ,
     9                4HMAX ,   4H    ,
     O                4HMEAN,   4H    ,
     1                4HAVG ,   4H    ,
     2                4HMEM-,   4HT   ,
     3                4HMEM-,   4HC   ,
     4                4HFLEX,   4H-T  ,
     5                4HFLEX,   4H-C  ,
     6                4HPRIN,   4HC-A ,
     7                4HPRIN,   4HC-B ,
     8                4HPRIN,   4HC-C /
      DATA    COMP3 / 4HEFOR,   4HCE  ,
     O                4HFORC,   4HE-1 ,
C                     or          E-12,
     1                4HFORC,   4HE-2 ,
C                     or          E-23,
     2                4HFORC,   4HE-3 ,
C                     or          E-34,
     3                4HFORC,   4HE-4 ,
C                     or          E-41,
     4                4HKICK,   4H-FOR,
     5                4HSIG-,   4HX   ,
     6                4HSIG-,   4HY   ,
     7                4HTAU-,   4HXY  ,
     8                4HHELP,   4H    ,
     9                4HON-L,   4HINE ,
     O                4HFX+F,   4HY   ,
     1                4HFXY ,   4H    ,
     2                4HMX+M,   4HY   ,
     3                4HMXY ,   4H    ,
     4                4HVX+V,   4HY   ,
     5                4HKICK,   4H ON1,
     6                4HKICK,   4H ON2,
     7                4HKICK,   4H ON3/
      DATA    COMP4 / 4HKICK,   4H ON4,
     9                4H .. ,   4H .. ,
     O                4H .. ,   4H .. /
      DATA    SP    / 4HR-ZR,   4HR-U ,   4HR-RT,   4HR-V ,   4HR-ZT,
     1                4HR-UV,   4HNT-X,   4HNT-U,   4HNT-Y,   4HNT-V,
     2                4H-U  ,   4H-V  ,   4HR-X ,   4HR-Y ,   4HR-41,
     3                4HR-12,   4HR-23,   4HR-34,   4HNT-1,   4HNT-2,
     4                4HR-1Z,   4HR-2Z,   4HAL-1,   4HAL-2,   4HAL-X,
     5                4HAL-Y,   4HE-12,   4HE-23,   4HE-34,   4HE-41/
      DATA    ETAB  /
     1                  1, -02,   1,   2,   2,   3,   3,   3,   4,   1,
     2                  6,   6,   6, -14,   3,   4,   3,   3,   3, -20,
     3                -21, -22, -23, -24, -25, -26, -27, -28, -29, -30,
     4                -31, -32, -33,   7,   8,   9,  10,  11, -39, -40,
     5                -41, -42, -43, -44, -45, -46, -47, -48, -49, -50,
     6                -51, -52, -53, -54, -55, -56, -57, -58, -59, -60,
     7                -61,   4,   4,  15,  12,  12,  13,  14,  14, -70,
     8                -71, -72, -73, -74, -75, -76, -77, -78, -79,   5,
     9                  7, -82,  15, -84, -85, -86, -87, -88, -89, -90/
      DATA    TAB1  /
C    1. ROD, TUB, CONROD
     1                01000002, 02000004, 28000503,        0,        0,
     1               -01000002,-25000003,        0,        0,        0,
C    2. SHEAR, TWIST
     2                16000002, 28000004, 31000003, 29000002,        0,
     2               -40000002,-41000003,-22000002,-23000003,        0,
C    3. TRIA1, TRIA2, QUAD1, QUAD2, TRBSC, TRPLT, QDPLT
     3                09001103, 10001204, 13001305, 06001507, 07001608,
     3                16001709,-22000002,-23000003,-13000005,-14000006,
C    4. TRMEM, QDMEM, QDMEM1, DQMEM2
     4                09000002, 10000003, 13000004, 06000006, 07000007,
     4                16000008,-40000403,-41000605,-42000807,-43000902,
C   **  CONTINUE...
     5               -55000010,-56000012,-57000014,-58000016,-13000011,
     5               -14000013,-15000015,-12000017,        0,        0,
C    6. ELAS1, ELAS2, ELAS3, IS2D8
     6                18000002,-26000002,        0,        0,        0,
     6               -40000904,-41000603,-42000805,-43000702,        0,
C    7. BAR, ELBOW
     7                19000807, 20001514, 28001609, 01000006,        0,
     7               -01000008,-25000009,-12000605,-22000302,-23000504,
C    8. CONEAX
     8                09041852, 10051852, 15061852, 06081852, 07091852,
     8                16101852,-22000003,-23000004,-13000006,-14000007,
C    9. TRIARG
     9                03000002, 26000003, 01000004, 12000005,        0,
     9               -03020353,-26030353,-01040353,        0,        0/
      DATA    TAB2  /
C    O. TRAPRG
     O                03020455, 26030455, 01040455, 12050455, 17060455,
     O               -03020354,-26030354,-01040354,        0,        0,
C    1. TORDRG
     1                32020553, 33030553, 34040553, 35050553, 17060553,
     1               -03000802,-26000903,-01001004,-21001105,-24001307,
C   12. IHEX1, IHEX2
     2                09032258, 13042258, 36052258, 30092258, 10112258,
     2                14122258, 37132258, 11172258, 15182258, 38192258,
C   13. IHEX3
     3                09032382, 13042382, 36052382, 30092382, 10122382,
     3                14132382, 37142382, 11182382, 15192382, 38202382,
C   14. TRIAAX, TRAPAX
     4                03030853, 01040853, 26050853, 33060853, 34070853,
     4                35080853,-03030453,-26040453,-01050453,        0,
C   15. QUAD4, TRIA3 (GENERAL)
     5                09000003, 10000004, 13000005, 06000007, 07000008,
     5                16000009,-50000302,-51000004,-52000605,-53000007,
     6               -54000908,
C   **. QUAD4, TRIA3 (LAYER), 9 DIGIT CODE
     6                          81030899, 82040899, 84050899, 83070899,
     6                85080899,        0,        0,        0,        0,
C   17.
     7                10*0/
C
C     FIRST 2 DIGITS IN A TAB ITEM ARE COMPONENT POINTER, POINTING TO
C     THE BCD WORDS IN COMP ARRAY. POSITIVE FOR STRESS, AND NEGATIVE FOR
C     FORCE DATA (WITH SOME EXCEPTIONS). THIS POINTER IS USED ONLY
C     LOCALLY WITHIN THIS SUBROUTINE.
C     NEXT 3 NUMBERS (2 DIGITS EACH) ARE POINTERS TO THE FIELD NOS.
C
C     SPECIAL CASE -
C     IF LAST FIELD IS GREATER THAN 50 THEN, THIS LAST FIELD MINUS 50 IS
C     THE REPEAT FLAG. IF LAST FIELD IS 99, WE HAVE AN OPEN-END REPEAT.
C     IF LAST FIELD IS GREATER THAN 50, NEXT TO LAST FIELD IS FIELD
C     INCREMENT, AND THE FIELD IN FRONT IS THE FIRST STARTING COLUMN TO
C     BE SCANNED.
C     THE QUAD4/TRIA3 LAYER HAS COMPONENT INDICES 81 THRU 85
C     (THUS - IN FUTURE EXPANSION, ARRAY COMP SHOULD NOT EXCEED 80)
C
C     E.G.  TAB(3,1) =  09 00 11 03
C                       09          = NORMAL-X (STRESS)
C                          00       = SKIP
C                             11 03 = SCAN BY 3RD AND 11TH FIELDS
C
C     E.G.  TAB(9,8) = -01 04 03 54
C                      -01          = AXIAL (FORCE)
C                                54 = REPEAT 4 TIMES
C                             03    = INCREASE BY 3 ON EACH REPEAT
C                          04       = SCAN BY 4, 7, 10, AND 13TH FIELDS
C
      IF (J400 .EQ. 2) GO TO 400
      IF (MACH.EQ.2 .OR. MACH.GE.5) MZERO = -1
      CALL SSWTCH (20,J)
      IF (J .EQ. 1) DEBUG = .TRUE.
      ERR   = -909
      NSCAN = LENCC - 1
      IF (CORE(I81+3) .NE. MZERO) GO TO 300
      ISCAN = I81
      IWDS  = I81 + 1
      IISUB = I81 + 2
      IELEM = I81 + 3
      ISET  = I81 + 4
      ICOMP = I81 + 5
C     +MAX  = I81 + 6 = TOP N
C     -MAX  = I81 + 7
      IREPT = I81 + 8
C
C     NOTE - THE IISUB WORD WILL BE DROPPED WHEN THESE WORDS ARE
C            TRANSFERRED TO CASECC
C
      JCOMP = IWDS
      IEND  = I81 + CORE(I81)*2 - 1
      CORE(ISCAN) = 0
      CORE(IISUB) = ISUB
      CORE(IELEM) = 0
      CORE(ISET ) = 0
      CORE(JCOMP) = 0
      NWDSS = 0
      NWDSF = 0
      IEQ   = 0
      MAX   = 0
      MIN   = 0
      NSV   = 0
      NRP   = 0
      II    = I81 + 3
C
 10   II = II + 2
      JJ = CORE(II  )
      KK = CORE(II+1)
      JX = JJ
      IF (.NOT.BIT64) GO TO 15
CWKBD 3/94      CALL MVBITS (BLANK,0,32,JX,0)
CWKBD 3/94      CALL MVBITS (BLANK,0,32,KK,0)
 15   IF (JJ .EQ. IEOR) GO TO 200
      IF (II .GT. IEND) IF (JJ) 150,190,20
      GO TO 30
C
C     DECODE BCD WORD
C
 20   IEND = II + JJ*2 - 1
      II   = II - 1
      GO TO 10
C
C     LOOK FOR EQUAL SIGN OR SET
C
 30   ERR = -617
      IF (JJ .NE. MZERO) GO TO 40
      IF (KK .NE. EQUAL) GO TO 300
      IEQ = IEQ + 1
      IF (IEQ .GT. 1) GO TO 300
      CORE(ICOMP+1) = 0
      CORE(ICOMP+2) = 0
      GO TO 10
 40   IF (JX .EQ. SETI) GO TO 130
C
C     LOOK FOR STRESS OR FORCE
C
      IF (IEQ .EQ.1) GO TO 300
      IF (JX .NE. STRESS) GO TO 50
      CORE(ISCAN) = CORE(ISCAN) + 10000000
      GO TO 10
 50   IF (JX .NE. FORCE) GO TO 60
      CORE(ISCAN) = CORE(ISCAN) + 20000000
      GO TO 10
C
C     LOOK FOR ELEMENT, DROP THE FIRST LETTER C IF NECESSARY
C
 60   IF (CORE(IELEM) .NE. 0) GO TO 100
      JC = NAM(1)
      KC = JC
      IF (KHRFN2(JX,1,1) .NE. LLC) GO TO 70
      JC = KHRFN3(BLANK,JX,1,1)
      KC = KHRFN3(BLANK,KK,1,1)
      JC = KHRFN1(JC,4,KK,1)
 70   J  = 1
      DO 80 I = 1,NELEM
      IF (JX.EQ.E(J) .AND. KK.EQ.E(J+1)) GO TO 90
      IF (JC.EQ.E(J) .AND. KC.EQ.E(J+1)) GO TO 90
 80   J = J + INCR
      GO TO 100
 90   CORE(IELEM) = I
      NWDSS = E(J+17)
      NWDSF = E(J+18)
      GO TO 10
C
C     LOOK FOR COMPONENT
C
 100  DO 110 I = 1,NCOMP
      IF (JX.EQ.COMP(1,I) .AND. KK.EQ.COMP(2,I)) GO TO 120
 110  CONTINUE
      ERR = -634
      I = 0
C
C     SP ARRAYS
C        1     2     3     4     5     6     7     8     9     10
C        R-ZR  R-U   R-RT  R-V   R-ZT  R-UV  NT-X  NT-U  NT-Y  NT-V
C        11    12    13    14    15    16    17    18    19    20
C        -U    -V    R-X   R-Y   R-41  R-12  R-23  R-34  NT-1  NT-2
C        21    22    23    24    25    26    27    28    29    30
C        R-1Z  R-2Z  AL-1  AL-2  AL-X  AL-Y  E-12  E-23  E-34  E-41
C
      IF (JX .NE.  FORCE) GO TO 115
      IF (KK .EQ. SP(27)) I = 40
C                 FORCE-12 (USED IN QDMEM2)
      IF (KK .EQ. SP(28)) I = 41
C                 FORCE-23
      IF (KK .EQ. SP(29)) I = 42
C                 FORCE-34
      IF (KK .EQ. SP(30)) I = 43
C                 FORCE-41
      IF (I .EQ. 0) GO TO 300
 115  IF (JX.NE.NORM .AND. JX.NE.SHEA .AND. JX.NE.MOME) GO TO 300
      IF (KK.EQ.SP( 1) .OR. KK.EQ.SP( 2) .OR. KK.EQ.SP(13)) I = 13
C         SHEAR-ZR          SHEAR-U           SHEAR-X
      IF (KK.EQ.SP( 3) .OR. KK.EQ.SP( 4) .OR. KK.EQ.SP(14)  .OR.
     1    KK.EQ.SP(17)) I = 14
C         SHEAR-RT          SHEAR-V           SHEAR-6
C         SHEAR-23
      IF (KK.EQ.SP( 5) .OR. KK.EQ.SP( 6) .OR. KK.EQ.SP(18)) I = 15
C         SHEAR-ZT          SHEAR-UV          SHEAR-34
      IF (I .NE. 0) GO TO 120
      IF (KK.EQ.SP( 7) .OR. KK.EQ.SP( 8)) I = 22
C         MOMENT-X          MOMENT-U
      IF (KK.EQ.SP( 9) .OR. KK.EQ.SP(10)) I = 23
C         MOMENT-Y          MOMENT-V
      IF (KK.EQ.SP(15) .OR. KK.EQ.SP(19)) I = 12
C         SHEAR-41          MOMENT-1
      IF (KK.EQ.SP(11) .OR. KK.EQ.SP(25)) I = 9
C         NORM-U            NORNAL-X
      IF (KK.EQ.SP(12) .OR. KK.EQ.SP(26)) I = 10
C         NORM-V            NORNAL-Y
      IF (I .NE. 0) GO TO 120
      IF (KK.EQ.SP(16) .OR. KK.EQ.SP(20)) I = 13
C         SHEAR-12          MOMENT-2
C
C     SECOND SET KEYWORDS FOR QUAD4/TRIA3 LAYER, 81 AND HIGHER
C     (THE GENERAL QUAD4/TRIA3 KEYWORDS ARE BELOW 80)
C
      IF (I .NE. 0) GO TO 120
      IF (KK .EQ. SP(23)) I = 81
C         NORAML-1
      IF (KK .EQ. SP(24)) I = 82
C         NORMAL-2
      IF (KK .EQ. SP(16)) I = 84
C         SHEAR-12
      IF (KK .EQ. SP(21)) I = 83
C         SHEAR-1Z
      IF (KK .EQ. SP(22)) I = 85
C         SHEAR-2Z
      IF (I .EQ. 0) GO TO 300
C
 120  IF (I .EQ. 48) GO TO 320
      IF (I .EQ. 49) GO TO 900
      ERR = -640
      IF (NSV .GT. 5) GO TO 300
      IF (NSV .LE. 0) GO TO 125
      DO 123 J = 1,NSV
      IF (SAVE(J) .EQ. I) GO TO 127
 123  CONTINUE
 125  NSV = NSV + 1
      SAVE(NSV) = I
C
C     TWO WORDS, PRINCIPAL AND TORSIONAL, HAVE A LETTER L TOO LONG
C
C     LLL IS 4HL   , BLANK FILL
C     IBLNK IS 1H  , ZERO  FILL
C
 127  IWORD = CORE(II+2)
CWKBD 3/94      IF (BIT64) CALL MVBITS (BLANK,0,32,IWORD,0)
      IF (II.LT.IEND .AND. IWORD.EQ.LLL .AND. CORE(II+3).EQ.IBLNK)
     1    II = II + 2
      GO TO 10
C
C     PROCESS SET
C
 130  ERR = -635
      IF (CORE(ISET) .NE. 0) GO TO 300
      ERR = -639
      IF (IEQ.NE.1  .OR. CORE(II+2).NE.-1) GO TO 300
      CORE(ISET) = CORE(II+3)
      II = II + 2
      J  = NWPC + 1 + ICSE(LENCC)
      DO 140 I = 1,NSET
      IF (CORE(ISET) .EQ. CORE(J)) GO TO 10
 140  J = J + CORE(J+1) + 3
      ERR  = -608
      MSST = MSST + 1
      IF (MSST .GT.  0) GO TO 300
      MISSET(MSST) = CORE(ISET)
      ERR = 0
      GO TO 10
C
C     NUMERIC DATA
C
 150  IF (JJ .EQ. -2) GO TO 170
      IF (IEQ .EQ. 1) GO TO 160
C
C     INTEGER BEFORE EQUAL SIGN = COMPONENT(S)
C
      ERR = -637
      IF (JJ.NE.-1 .OR. KK.LE.1) GO TO 300
      ERR = -638
      IF (KK .GT. 31) GO TO 300
      CORE(JCOMP) = CORE(JCOMP) + 2**(KK-1)
      GO TO 10
C
C     INTEGER AFTER EQUAL SIGN = TOP N
C
 160  ERR = -608
      IF (IEQ .NE. 1) GO TO 300
      ERR = -636
      IF (MAX-1) 180,300,300
C
C     F.P. DATA = +MAX OR -MAX
C
 170  ERR = -608
      IF (IEQ .NE. 1) GO TO 300
      MIN = 1
      ERR = -636
      IF (MAX .GE. 2) GO TO 300
 180  MAX = MAX + 1
      CORE(ICOMP+MAX) = KK
      ERR = -641
      IF (MAX.EQ.2 .AND. RCORE(ICOMP+2).GT.RCORE(ICOMP+1)) GO TO 300
      GO TO 10
C
C     READ CONTINUATION CARD
C
 190  CALL READ (*290,*290,SCR1,CORE(1),NWPC,0,FLAG)
      WRITE (NOUT,310) ICC,(CORE(I),I=1,NWPC)
      ICC  = ICC  + 1
      LINE = LINE + 1
      IF (LINE .GT. NLPP) CALL PAGE
      II = I81 + 8
      NZ = NZ - II
      CALL XRCARD (CORE(II),NZ,CORE(1))
      II = II - 2
      IEND = II
      GO TO 10
C
C     SCAN CARD COMPLETED
C
 200  IF (NOGO .NE. 0) GO TO 330
      ERR = -643
      IF (CORE(ISCAN).NE.10000000 .AND. CORE(ISCAN).NE.20000000)
     1   GO TO 300
      CORE(ICOMP) = CORE(JCOMP)
      CORE(IWDS ) = 6
      IF (CORE(ISET ) .EQ. 0) CORE(ISET) = -1
      IF (CORE(IELEM).EQ.0 .AND. CORE(ICOMP+2).EQ.0) CORE(IELEM) = -1
      IF (MAX .EQ. 0) CORE(ICOMP+1) = 20
      IF (MAX.LE.1 .AND. MIN.EQ.0) CORE(ICOMP+2) = -1
      IF (CORE(ICOMP+2) .NE. -1) GO TO 205
C
C     COMPUTE HOW HIGH TOPN CAN GO ASSUMING LINK14 HAS AN OPEN CORE SIZE
C     SAME AS THAT OF LINK1
C
      IF (CORE(ISCAN) .GE. 20000000) NWDSS = NWDSF
      IF (2*NWDSS*CORE(ICOMP+1) .GT. KORSZ(ICSE(1))) CALL IFP1D (644)
C
C     CONVERT NAMED COMPONENT TO FIELD NO.
C
 205  IF (NSV.EQ.0 .OR. CORE(IELEM).EQ.-1) GO TO 250
      I = CORE(IELEM)
      I = ETAB(I)
      ERR = -642
      IF (I .LT. 0) GO TO 300
      IE = 10
      IF (I .EQ. 14) IE = 16
      DO 240 K = 1,NSV
      IF (CORE(ISCAN) .EQ. 20000000) SAVE(K) = -SAVE(K)
      DO 210 J = 1,IE
      II = TAB(J,I)/1000000
      IF (II .EQ. 0) GO TO 210
      IF (SAVE(K) .EQ. II) GO TO 220
 210  CONTINUE
C
C     5 SPECIAL CASES WHERE TAB ARRAY OF 10 IS NOT LONG ENOUGH
C     SET THE 11TH ITEM OF ECAH OF THESE 3 CASES
C
      II = 0
      IF (I.EQ. 3 .AND. SAVE(K).EQ.27) II = -27000004
C         TRIA1         TWIST (MOMENT)
      IF (I.EQ.12 .AND. SAVE(K).EQ.18) II = +18102258
C         IHEX1         OCT-SHR (STRESS)    +18102270 (IHEX2)
      IF (I.EQ.13 .AND. SAVE(K).EQ.18) II = +18102382
C         IHEX3         OCT-SHR (STRESS)
      IF (I.EQ.12 .AND. SAVE(K).EQ.16) II = +16102270
C         IHEX2         MAX-SHR (STRESS)
      IF (I.EQ.13 .AND. SAVE(K).EQ.16) II = +16102382
C         IHEX2         MAX-SHR (STRESS)
      ERR = -637
      IF (II) 300,300,225
 220  II = IABS(TAB(J,I))
 225  II = MOD(II,1000000)
      DO 230 JJ = 1,3
      KK = MOD(II,100)
      IF (CORE(ICOMP) .NE. 1) GO TO 223
      CORE(ICOMP) = 0
      IF (IELEM .EQ. 66) KK = 70
C                    IHEX2
      IF (IELEM .EQ. 69) KK = 54
C                    TRIATS
      NRP = NRP + KK
      KK  = 0
 223  IF (KK .LE. 50) GO TO 227
      NRP = (KK-50)*100
C     NRP = 4900 FOR OPEN-END REPEAT FLAG
      KK  = 1
 227  IF (KK .GT. 0) CORE(ICOMP) = CORE(ICOMP) + 2**(KK-1)
      II  = II/100
      IF (II .EQ. 0) GO TO 240
 230  CONTINUE
 240  CONTINUE
C
C     NRP/100 IS REPEAT FLAG, AND MOD(NRP,100) IS INCREMENT
C
 250  IF (NOGO .NE. 0) GO TO 330
      CORE(IREPT) = NRP
C
C     FINAL ERROR CHECK
C
      IF (CORE(IELEM).EQ.0 .OR. CORE(ICOMP).EQ.0) J400 = 1
      ERR = -617
      J = 0
      DO 260 I = 1,8
      IF (CORE(I81+J) .EQ. 0) GO TO 300
 260  J = J + 1
C
C     ALL GO WELL, RE-SET PARAMETERS
C     NOTE - THE (LENCC-1) WORD OF CASECC RECORDS THE NO. OF SCAN CARDS
C
      NSET = NSET + 1
      II = (ISUB-1)*LENCC
      ICSE(NSCAN+II) = ICSE(NSCAN+II) + 1
CWKBD IF (DEBUG) CALL BUG1 ('IFP1H',270,CORE(I81),9)
      I81 = I81 + 9
C
C     TURN ON STRESS OR FORCE OUTPUT FLAGS IF THEY ARE NOT ALREADY DONE
C     BY THE USER.   SET OUTPUT OPTIONS TO - ALL, NOPRINT, AND REAL
C     (WORD 23 ON CASECC IS STRESS OUTPUT FLAG, AND
C      WORD 26 ON CASECC IS FORCE  OUTPUT FLAG)
C
      IF (CORE(ISCAN).EQ.20000000 .OR. ICSE(23+II+1).NE.0) GO TO 280
      ICSE(23+II  ) =-1
      ICSE(23+II+1) = 2
      ICSE(23+II+2) = 1
 280  IF (CORE(ISCAN).NE.20000000 .OR. ICSE(26+II+1).NE.0) GO TO 330
      ICSE(26+II  ) =-1
      ICSE(26+II+1) = 2
      ICSE(26+II+2) = 1
      GO TO 330
C
 290  CALL MESAGE (-1,SCR1,NAM)
 300  CALL IFP1D (ERR)
 310  FORMAT (11X,I8,6X,20A4)
      IF (ICSE(NSCAN) .LT. 0) GO TO 330
      IF (ERR.NE.-634 .AND. ERR.NE.-637 .AND. ERR.NE.-642) GO TO 330
      ICSE(NSCAN) = -10000
 320  J400 = 1
 330  RETURN
C
C     PRINT OUT SCAN COMPONENT KEYWORDS
C
 400  CALL PAGE1
      II = 20
      GO TO 810
 410  II = 0
      WRITE  (NOUT,420)
 420  FORMAT (46H0*** COMPONENT KEYWORDS FOR THE SCAN OPERATION, //5X,
     1  59HFORCE/STRESS    KEYWORD        COMPONENT (OUTPUT FIELD NO.),
     2  /5X,15(4H----),/)
      LLINE = 15
 425  FORMAT (/5X,17HROD, TUBE, CONROD,/)
      GO TO 700
 430  ISP(8) = 19
      ISP(9) = 20
      LLINE  = 11
 435  FORMAT (/5X,12HSHEAR, TWIST,/)
      GO TO 700
 440  ISP( 7) = 7
      ISP( 8) = 9
      ISP( 9) = 13
      ISP(10) = 14
      LLINE   = 14
 445  FORMAT (/5X,47HTRIA1, TRIA2, QUAD1, QUAD2, TRBSC, TRPLT, QDPLT,/)
      GO TO 700
 450  WRITE  (NOUT,455)
 455  FORMAT (10X,'FORCE      TWIST',15X,'4')
      LINE = LINE + 1
      ISP( 7) = 27
      ISP( 8) = 28
      ISP( 9) = 29
      ISP(10) = 30
      LLINE = 13
 460  FORMAT (/5X,28HTRMEM, QDMEM, QDMEM1, QDMEM2,/)
      GO TO 700
 470  LLINE = 8
      GO TO 700
 480  LLINE = 9
 490  FORMAT (/5X,26HELAS1, ELAS2, ELAS3, IS2D8,/)
      GO TO 700
 500  LLINE = 12
 510  FORMAT (/5X,10HBAR, ELBOW,/)
      GO TO 700
 520  ISP(1) = 11
      ISP(2) = 12
      ISP(3) = 6
      ISP(7) = 8
      ISP(8) = 10
      LLINE  = 13
 530  FORMAT (/5X, 6HCONEAX,/)
      GO TO 700
 540  LLINE = 10
 550  FORMAT (/5X, 6HTRIARG,/)
      GO TO 700
 560  LLINE = 11
 570  FORMAT (/5X, 6HTRAPRG,/)
      GO TO 700
 580  LLINE = 13
 590  FORMAT (/5X, 6HTORDRG,/)
      GO TO 700
 600  LLINE = 14
 610  FORMAT (/5X,12HIHEX1, IHEX2,/)
      GO TO 700
 620  WRITE  (NOUT,625)
 625  FORMAT (10X,'STRESS     MAX-SHR',12X,'10, 32, 54, 76 ... ETC',
     1       /10X,'STRESS     OCT-SHR',12X,'10, 32, 54, 76 ... ETC')
      LINE  = LINE + 1
      LLINE = 14
 630  FORMAT (/5X, 6HIHEX3 ,/)
      GO TO 700
 640  WRITE  (NOUT,645)
 645  FORMAT (10X,'STRESS     MAX-SHR',12X,'10, 33, 56, 79 ... 746',
     1       /10X,'STRESS     OCT-SHR',12X,'10, 33, 56, 79 ... 746')
      LINE  = LINE + 1
      LLINE = 12
 650  FORMAT (/5X,14HTRIAAX, TRAPAX,/)
      GO TO 700
 660  ISP(1) = 25
      ISP(2) = 26
      LLINE  = 19
 665  FORMAT (/5X,12HQUAD4, TRIA3,/)
      GO TO 700
C
C   . QUAD4/TRIA3 LAYER
C
 670  ISP(2) = 23
      ISP(3) = 24
      ISP(4) = 16
      ISP(5) = 21
      ISP(6) = 22
      LLINE  = 5
      GO TO 700
C
 680  WRITE  (NOUT,685)
 685  FORMAT (1X)
      GO TO 840
C
 700  II = II + 1
      CALL PAGE2 (LLINE)
      GO TO (701,702,703,704,720,706,707,708,709,710,
     1       711,712,713,714,715,720,717,700,700,720), II
 701  WRITE (NOUT,425)
      GO TO 720
 702  WRITE (NOUT,435)
      GO TO 720
 703  WRITE (NOUT,445)
      GO TO 720
 704  WRITE (NOUT,460)
      GO TO 720
 706  WRITE (NOUT,490)
      GO TO 720
 707  WRITE (NOUT,510)
      GO TO 720
 708  WRITE (NOUT,530)
      GO TO 720
 709  WRITE (NOUT,550)
      GO TO 720
 710  WRITE (NOUT,570)
      GO TO 720
 711  WRITE (NOUT,590)
      GO TO 720
 712  WRITE (NOUT,610)
      GO TO 720
 713  WRITE (NOUT,630)
      GO TO 720
 714  WRITE (NOUT,650)
      GO TO 720
 715  WRITE (NOUT,665)
      GO TO 720
 717  LLINE = 0
      GO TO 700
C
 720  DO 800 I = 1,10
      JJ = TAB(I,II)
      IF (JJ .EQ. 0) GO TO 800
      BCD(1,3) = BCD(1,1)
      BCD(2,3) = BCD(2,1)
      IF (JJ .GE. 0) GO TO 725
      BCD(1,3) = BCD(1,2)
      BCD(2,3) = BCD(2,2)
 725  JJ = IABS(JJ)
C
C                     +-------------------+    LL(1) = XX
C     JJ = TAB(I,J)=  ! CC ! ZZ ! YY ! XX !    LL(2) = YY
C                     +-------------------+    LL(3) = ZZ
C                                              LL(4) = CC
      DO 730 J = 1,4
      LL(J) = MOD(JJ,100)
 730  JJ = JJ/100
      JJ = LL(4)
C
C     QUAD4/TRIA3 LAYER IF JJ IS 81 THRU 85
C
      IF (JJ.EQ.81 .OR.  JJ.EQ.82) JJ = 9
      IF (JJ.GE.83 .AND. JJ.LE.85) JJ = 12
C
      KEYWDS(1) = COMP(1,JJ)
      KEYWDS(2) = COMP(2,JJ)
      KEYWDS(3) = BLANK
      IF (II.EQ.4 .OR. II.EQ.16) GO TO  735
      IF (JJ.EQ.2 .OR. JJ.EQ. 5) KEYWDS(3) = LLL
      IF (JJ.LT.9 .OR. JJ.GT.30) GO TO 740
      IF (JJ.EQ.11 .OR. (JJ.GE.16 .AND. JJ.LE.21)) GO TO 740
 735  J = ISP(I)
      IF (J .GT. 0) KEYWDS(2) = SP(J)
 740  IF (LL(1) .GT. 50) GO TO 745
      LL(4) = 0
      IDUPL = 0
      JJ    = 3
      GO TO 760
 745  IDUPL = LL(1) - 50
      INC   = LL(2)
      JJ = MIN0(IDUPL,4)
      KK = LL(3)
      DO 750 J = 1,JJ
      LL(J) = KK
 750  KK = KK+INC
      KK = INC*IDUPL + LL(1)
 760  DO 765 J = 1,JJ
      IF (LL(J) .EQ. 0) GO TO 770
 765  CC(J) = COMMA
      J  = JJ + 1
 770  JJ = J  - 1
      CC(JJ) = XBLANK
      WRITE  (NOUT,775) BCD(1,3),BCD(2,3),KEYWDS,(LL(J),CC(J),J=1,JJ)
 775  FORMAT (10X,A4,A2,5X,2A4,A1,9X,4(I3,A1))
      IF (IDUPL .LE. 4) GO TO 800
      IF (II.NE.12 .AND. II.NE.14 .AND. II.NE.16) WRITE (NOUT,780) KK
      IF (II.EQ.12 .OR.  II.EQ.14 .OR.  II.EQ.16) WRITE (NOUT,785)
 780  FORMAT (1H+,54X,3H...,I4)
 785  FORMAT (1H+,54X,3H...,5H ETC.)
 800  CONTINUE
 810  DO 820 J = 1,10
 820  ISP(J) = 0
      GO TO (430,440,450,470,480,500,520,540,560,580,
     1       600,620,640,660,670,680,840,840,840,410), II
 840  WRITE  (NOUT,850)
 850  FORMAT (//5X,'USE OUTPUT FIELD NUMBER(S) TO SPECIFY COMPONENT(S)',
     1       'FOR ELEMENTS OR KEYWORDS', /5X,'NOT LISTED ABOVE',/)
      RETURN
C
C     ON-LINE
C
 900  WRITE  (NOUT,910) UFM
 910  FORMAT (A23,', SCAN ON-LINE OPTION IS NOT AVAILABLE IN THIS ',
     1        'NASTRAN RELEASE')
      NOGO = 1
      RETURN
      END

      SUBROUTINE MMA3 ( ZI, ZR, ZD, ZC, ZDC )
C
C     MMA3 PERFORMS THE MATRIX OPERATION USING METHODS 30, 31 AND 32
C       (+/-)A(T & NT) * B (+/-)C = D
C     
C     MMA3 IS DESIGNED AS FOLLOWS:
C       1.  THIS IS FOR "A" NON-TRANSPOSED AND TRANSPOSED
C       2.  PACK (IN COMPACT FORM) AS MANY COLUMNS OF "A" INTO MEMORY 
C           AS POSSIBLE LEAVING SPACE FOR ONE COLUMN OF "B" AND "D".
C           SEE SUBROUTINES MMARM1,2,3,4 FOR FORMAT OF COMPACT FORM.
C       3.  INITIALIZE EACH COLUMN OF "D" WITH THE DATA FROM "C".
C       4.  FOR METHODS 30 AND 31, CALL UNPACK TO READ MATRIX "C".
C       5.  FOR METHOD 30, CALL UNPACK TO READ COLUMNS OF MATRIX "B".
C       6.  FOR METHOD 31, CALL MMARC1,2,3,4 TO READ COLUMNS OF "B" INTO
C           MEMORY IN COMPACT FORM.
C       7.  FOR METHOD 32, CALL MMARC1,2,3,4 TO READ COLUMNS OF "B" AND
C           "C" INTO MEMORY IN COMPACT FORM.
C       8.  FOR METHODS 30 AND 31, CALL PACK TO WRITE "D" MATRIX.
C       9.  FOR METHOD 32, CALL BLDPK TO WRITE "D" MATRIX.
C
      INTEGER           ZI(2)      ,MODULE(3),SYSBUF,SCRTCH
      INTEGER           TYPEI      ,TYPEP    ,TYPEU ,SIGNAB, SIGNC
      INTEGER           RD         ,RDREW    ,WRT   ,WRTREW, CLSREW,CLS
      INTEGER           OFILE      ,FILEA    ,FILEB ,FILEC , FILED
      REAL              ZR(2)
      DOUBLE PRECISION  ZD(2)
      COMPLEX           ZC(2)
      DOUBLE COMPLEX    ZDC(2)
      COMMON / NAMES  / RD         ,RDREW    ,WRT   ,WRTREW, CLSREW,CLS
      COMMON / TYPE   / IPRC(2)    ,NWORDS(4),IRC(4)
      COMMON / MPYADX / FILEA(7)   ,FILEB(7) ,FILEC(7)    
     1,                 FILED(7)   ,NZ       ,T     ,SIGNAB,SIGNC ,PREC1 
     2,                 SCRTCH     ,TIME
      INCLUDE           'MMACOM.COM'
      COMMON / SYSTEM / KSYSTM(152)
      COMMON / UNPAKX / TYPEU      ,IUROW1   ,IUROWN, INCRU
      COMMON / PACKX  / TYPEI      ,TYPEP    ,IPROW1, IPROWN , INCRP
      EQUIVALENCE       (KSYSTM( 1),SYSBUF)  , (KSYSTM( 2),NOUT  ) 
      EQUIVALENCE       (KSYSTM(58),KSYS58)
      EQUIVALENCE       (FILEA(2)  ,NAC   )  , (FILEA(3)  ,NAR   )
     1,                 (FILEA(4)  ,NAFORM)  , (FILEA(5)  ,NATYPE)
     2,                 (FILEA(6)  ,NANZWD)  , (FILEA(7)  ,NADENS)
      EQUIVALENCE       (FILEB(2)  ,NBC   )  , (FILEB(3)  ,NBR   )
     1,                 (FILEB(4)  ,NBFORM)  , (FILEB(5)  ,NBTYPE)
     2,                 (FILEB(6)  ,NBNZWD)  , (FILEB(7)  ,NBDENS)
      EQUIVALENCE       (FILEC(2)  ,NCC   )  , (FILEC(3)  ,NCR   )
     1,                 (FILEC(4)  ,NCFORM)  , (FILEC(5)  ,NCTYPE)
     2,                 (FILEC(6)  ,NCNZWD)  , (FILEC(7)  ,NCDENS)
      EQUIVALENCE       (FILED(2)  ,NDC   )  , (FILED(3)  ,NDR   )
     1,                 (FILED(4)  ,NDFORM)  , (FILED(5)  ,NDTYPE)
     2,                 (FILED(6)  ,NDNZWD)  , (FILED(7)  ,NDDENS)
C
      DATA    MODULE / 4HMMA3  , 4H     ,4H    /
      DATA    KZERO  / 1H0   /   
      DATA    KONE   / 1H1   /
      DATA    KTWO   / 1H2   /
      DATA    JBEGN  / 4HBEGN/ , JEND  / 3HEND /
      MODULE( 3 ) = JBEGN
      IF ( METHOD .EQ. 30 ) MODULE( 2 ) = KZERO
      IF ( METHOD .EQ. 31 ) MODULE( 2 ) = KONE     
      IF ( METHOD .EQ. 32 ) MODULE( 2 ) = KTWO   
      CALL CONMSG ( MODULE, 3, 0 )
      INCRU  = 1
      TYPEI  = NDTYPE
      TYPEP  = NDTYPE
      NWDD   = NWORDS( NDTYPE )
      NWDB   = NWORDS( NBTYPE )
C
C   OPEN CORE ALLOCATION AS FOLLOWS:
C     Z( 1        ) = ARRAY FOR ONE COLUMN OF "B" MATRIX
C     Z( IDX      ) = ARRAY FOR ONE COLUMN OF "D" MATRIX
C     Z( IAX      ) = ARRAY FOR MULTIPLE COLUMNS OF "A" MATRIX
C        THROUGH
C     Z( LASMEM   )
C     Z( IBUF4    ) = BUFFER FOR "D" FILE
C     Z( IBUF3    ) = BUFFER FOR "C" FILE
C     Z( IBUF2    ) = BUFFER FOR "B" FILE 
C     Z( IBUF1    ) = BUFFER FOR "A" FILE
C     Z( NZ       ) = END OF OPEN CORE THAT IS AVAILABLE
C
      IDX = 1 + NWDD*NBR  
      IF ( METHOD .NE. 31 .AND. METHOD .NE. 32) GO TO 90
C
C REDEFINE IDX AND INSURE A QUAD WORD BOUNDARY FOR COMPLEX DOUBLE
C
      IDX = 1 + NWDD*NBR + NBR  
      ITEST = MOD( IDX, 4 )
      IF ( ITEST .EQ. 1 ) GO TO 90
      IF ( ITEST .EQ. 0 ) IDX = IDX + 1
      IF ( ITEST .EQ. 2 ) IDX = IDX + 3
      IF ( ITEST .EQ. 3 ) IDX = IDX + 2
90    CONTINUE
      IDX2   = ( ( IDX+1 ) / 2 ) - 1  
      IDX4   = ( IDX+1 ) / 4    
      IAX    = IDX  + NWDD*NDR     
      IF ( METHOD .NE. 32 ) GO TO 96
C
C FOR METHOD 32, INSURE IAX IS ON QUAD WORD BOUNDARY FOR COMPLEX DOUBLE
C 
      IAX    = IDX  + NWDD*NDR + NDR
      ITEST = MOD( IAX, 4 )
      IF ( ITEST .EQ. 1 ) GO TO 96
      IF ( ITEST .EQ. 0 ) IAX = IAX + 1
      IF ( ITEST .EQ. 2 ) IAX = IAX + 3
      IF ( ITEST .EQ. 3 ) IAX = IAX + 2
96    CONTINUE
      IAX2   = ( ( IAX+1 ) / 2 ) 
      IBUF1  = NZ    - SYSBUF
      IBUF2  = IBUF1 - SYSBUF
      IBUF3  = IBUF2 - SYSBUF
      IBUF4  = IBUF3 - SYSBUF
      LASMEM = IBUF4 - 1
      LASMEM = LASMEM - IAX
      IPROW1 = 1
      IPROWN = NDR
      INCRP  = 1
      CALL GOPEN  ( FILEA, ZR( IBUF1 ), RDREW )
      CALL GOPEN  ( FILEB, ZR( IBUF2 ), RDREW )
      IPASS  = 0
      IRCOLN = 0
100   IPASS  = IPASS + 1
      IRCOL1 = IRCOLN + 1
      IRCOLN = NAC
      IRFILE = FILEA( 1 )       
      SIGN   = SIGNAB      
      IF ( IPASS  .NE. 1 ) 
     &  CALL DSSPOS ( IRFILE, IRPOS( 1 ), IRPOS( 2 ),IRPOS( 3 ) )
      IF ( NDTYPE .EQ. 1 ) CALL MMARM1 ( ZI( IAX ), ZR( IAX  ), 0 )
      IF ( NDTYPE .EQ. 2 ) CALL MMARM2 ( ZI( IAX ), ZD( IAX2 ), 0 )
      IF ( NDTYPE .EQ. 3 ) CALL MMARM3 ( ZI( IAX ), ZC( IAX2 ), 0 )
      IF ( NDTYPE .EQ. 4 ) CALL MMARM4 ( ZI( IAX ), ZD( IAX2 ), 0 )
      NCOLPP = IRCOLN - IRCOL1 + 1
      IBROW  = IRCOL1 - 1
      IF ( IRCOLN .EQ. NAC ) GO TO 400
      ITEST = MOD( IPASS, 2 )
      IF ( ITEST .EQ. 0 ) GO TO 350
      IFILE = SCRTCH
      OFILE = FILED( 1 )
      GO TO 380
350   IFILE = FILED( 1 )
      OFILE = SCRTCH
380   CONTINUE
      IF ( IPASS .EQ. 1 ) GO TO 300
      CALL REWIND( FILEB )
      CALL SKPREC( FILEB, 1 )
      CALL GOPEN ( IFILE, ZR( IBUF3 ), RDREW )
      CALL GOPEN ( OFILE, ZR( IBUF4 ), WRTREW)
      GO TO 490
C FIRST PASS, OPEN "C" FILE IF IT EXISTS
300   CONTINUE
      CALL GOPEN ( OFILE, ZR( IBUF4 ), WRTREW)      
310   IFILE = FILEC( 1 )
      IF ( SIGNC .EQ. 0 ) IFILE = 0
      IF ( IFILE .EQ. 0 ) GO TO 490 
      CALL GOPEN  ( IFILE, ZR( IBUF3 ), RDREW )     
      GO TO 490
C LAST PASS, CREATE OUTPUT FILE
400   CONTINUE
      IF ( IFILE .EQ. 0 ) IFILE = SCRTCH
      IF ( OFILE .EQ. FILED( 1 ) .AND. IPASS .NE. 1 ) 
     &     CALL FILSWI( IFILE, OFILE )
      OFILE = FILED( 1 )
      IFILE = SCRTCH   
      CALL REWIND( FILEB )
      CALL SKPREC( FILEB, 1 )
      CALL GOPEN ( FILED, ZR( IBUF4 ), WRTREW)
      FILED( 2 ) = 0
      FILED( 6 ) = 0
      FILED( 7 ) = 0
      IF ( IPASS .EQ. 1 ) GO TO 310
      CALL GOPEN  ( IFILE, ZR( IBUF3 ), RDREW )     
490   CONTINUE
      SIGN = 1
      IF ( METHOD .EQ. 30 ) GO TO 950
      IF ( METHOD .EQ. 31 ) GO TO 1000  
      IF ( METHOD .EQ. 32 ) GO TO 2000  
C PROCESS ALL OF THE COLUMNS OF "B", ADD "C" DATA ON FIRST PASS
950   CONTINUE
      IF ( NDTYPE .EQ. 1 ) CALL MMA301( ZI, ZR )
      IF ( NDTYPE .EQ. 2 ) CALL MMA302( ZI, ZD )
      IF ( NDTYPE .EQ. 3 ) CALL MMA303( ZI, ZC )
      IF ( NDTYPE .EQ. 4 ) CALL MMA304( ZI, ZD, ZDC )
      GO TO 60000
1000  CONTINUE
      IF ( NDTYPE .EQ. 1 ) CALL MMA311( ZI, ZR )
      IF ( NDTYPE .EQ. 2 ) CALL MMA312( ZI, ZD )
      IF ( NDTYPE .EQ. 3 ) CALL MMA313( ZI, ZC )
      IF ( NDTYPE .EQ. 4 ) CALL MMA314( ZI, ZD, ZDC )
      GO TO 60000
2000  CONTINUE
      IF ( NDTYPE .EQ. 1 ) CALL MMA321( ZI, ZR )
      IF ( NDTYPE .EQ. 2 ) CALL MMA322( ZI, ZD )
      IF ( NDTYPE .EQ. 3 ) CALL MMA323( ZI, ZC )
      IF ( NDTYPE .EQ. 4 ) CALL MMA324( ZI, ZD )
60000 CONTINUE
      CALL CLOSE ( IFILE, CLSREW )
      CALL CLOSE ( OFILE, CLSREW )
      IF ( IRCOLN .LT. NAC ) GO TO 100
C
C ALL COLUMNS OF A HAVE BEEN PROCESSED, MULTIPLICATION COMPLETE
C
      CALL CLOSE ( FILEA, CLSREW )
      CALL CLOSE ( FILEB, CLSREW )
      MODULE( 3 ) = JEND
      CALL CONMSG ( MODULE, 3, 0 )
      RETURN
      END

      SUBROUTINE BLDPKN ( FILE, BLOCK,  MCB )
      INCLUDE 'PAKBLK.COM'
      INCLUDE 'DSIOF.COM'
      INTEGER FILE, BLOCK( 15 ), MCB( 7 )
      NAME = FILE
      IF ( BLOCK( 1) .EQ. 0 ) GO TO 10
      CALL DSBPNK ( BLOCK, MCB )
      GO TO 20
10    CALL DSBPNK ( IBLKA, MCB )
20    CONTINUE
      RETURN
      END

      SUBROUTINE AMGSBA(AJJL,A0,AR,NSBE,A,YB,ZB)
C
C     BUILD AJJL FOR DOUBLET LATTICE WITH BODIES
C
      INTEGER SYSBUF,ECORE,AJJL,NAME(2),SCR1,SCR2,SCR5
      DIMENSION A(1),A0(1),AR(1),NSBE(1)
      DIMENSION YB(1),ZB(1)
      COMMON /DLBDY/ NJ1,NK1,NP,NB,NTP,NBZ,NBY,NTZ,NTY,NT0,NTZS,NTYS,
     *   INC,INS,INB,INAS,IZIN,IYIN,INBEA1,INBEA2,INSBEA,IZB,IYB,
     *   IAVR,IARB,INFL,IXLE,IXTE,INT121,INT122,IZS,IYS,ICS,IEE,ISG,
     *   ICG,IXIJ,IX,IDELX,IXIC,IXLAM,IA0,IXIS1,IXIS2,IA0P,IRIA
     *  ,INASB,IFLA1,IFLA2,ITH1A,ITH2A,
     *   ECORE,NEXT,SCR1,SCR2,SCR3,SCR4,SCR5
      COMMON /AMGMN / MCB(7),NROW,ND,NE,REFC,FMACH,RFK,TSKJ(7),ISK,NSK
      COMMON /SYSTEM/ SYSBUF
      COMMON /ZZZZZZ / Z(1)
      COMMON /PACKX/ ITI,ITO,II,NN,INCR
      COMMON /CONDAS/ PI,TWOPI
      DATA NAME /4HAMGS,4HBA  /
      II = NROW +1
      NN = NROW + NJ1
      IF(NEXT+2*NJ1.GT.ECORE) CALL MESAGE(-8,0,NAME)
      INCR = 1
      ITI = 3
      ITO = 3
      IF(NT0.EQ.0) GO TO 100
      NBUF = 1
      IF(NTZS.NE.0) NBUF = NBUF +1
      IF(NTYS.NE.0) NBUF = NBUF +1
      IBUF1 = ECORE - NBUF*SYSBUF
      IBUF2 = IBUF1
      IF(NTZS.NE.0) IBUF2 = IBUF1+SYSBUF
      IBUF3 = IBUF2
      IF(NTYS.NE.0) IBUF3 = IBUF2+SYSBUF
      NS5 = NT0*2
      NS1 = NTZS*2
      NS2 = NTYS*2
      NTOT = NS5+NS1+NS2
      IF(NEXT+NTOT.GT.IBUF3) CALL MESAGE(-8,0,NAME)
C
C     BUILD PANEL AND BODY PART OF AJJL
C
      CALL GOPEN(SCR5,Z(IBUF1),0)
      IF(NTZS.NE.0) CALL GOPEN(SCR1,Z(IBUF2),0)
      IF(NTYS.NE.0) CALL GOPEN(SCR2,Z(IBUF3),0)
      DO 50 I=1,NT0
      CALL FREAD(SCR5,A,NS5,0)
      IF(NTZS.NE.0) CALL FREAD(SCR1,A(NS5+1),NS1,0)
      IF(NTYS.NE.0) CALL FREAD(SCR2,A(NS5+NS1+1),NS2,0)
      CALL PACK(A,AJJL,MCB)
   50 CONTINUE
      CALL CLOSE(SCR5,1)
      CALL CLOSE(SCR1,1)
      CALL CLOSE(SCR2,1)
  100 CALL ZEROC(A,2*NJ1)
C
C     ADD DIAGIONAL TERMS OF AJJL FOR SLENDER BODIES
C
      IF(NTZS.EQ.0.AND.NTYS.EQ.0) GO TO 1000
      I = NT0*2+1
      DEN=TWOPI*2.0
      IF(NTZS.EQ.0) GO TO 200
      NFSBEB = 1
      NLSBEB = 0
      DO 150 IB = 1,NBZ
      NLSBEB = NLSBEB + NSBE(IB)
      DO 140 IT = NFSBEB,NLSBEB
      A(I) = 1.0 / (DEN*A0(IT)**2)
      IF(ABS(YB(IB)).LT..00001) A(I) = (1.0+FLOAT(ND))*A(I)
      IF(ABS(ZB(IB)).LT..00001) A(I) = (1.0+FLOAT(NE))*A(I)
      CALL PACK(A,AJJL,MCB)
      A(I) = 0.0
      I = I+2
  140 CONTINUE
      NFSBEB = NFSBEB + NSBE(IB)
  150 CONTINUE
  200 IF(NTYS.EQ.0) GO TO 1000
      NFYB = NB+1-NBY
      NFSBEB = 1
      NLSBEB = 0
      NL = NFYB-1
      IF(NL.EQ.0) GO TO 220
      DO 210 J=1,NL
      NLSBEB = NLSBEB+NSBE(J)
      NFSBEB = NFSBEB+NSBE(J)
  210 CONTINUE
  220 DO 250 IB = NFYB,NB
      NLSBEB = NLSBEB+NSBE(IB)
      DO 240 IT = NFSBEB,NLSBEB
      A(I) = 1.0 / (DEN*A0(IT)**2)
      IF(ABS(YB(IB)).LT..00001) A(I) = (1.0-FLOAT(ND))*A(I)
      IF(ABS(ZB(IB)).LT..00001) A(I) = (1.0-FLOAT(NE))*A(I)
      CALL PACK(A,AJJL,MCB)
      A(I) = 0.0
      I = I+2
  240 CONTINUE
      NFSBEB = NFSBEB+NSBE(IB)
  250 CONTINUE
 1000 RETURN
      END

      SUBROUTINE XDPH
C
C     DATA POOL HOUSEKEEPER (XDPH)
C
C     THIS SUBROUTINE SCANS THE DATA POOL DICT AND TO DETERMINE THE
C     NUMBER AND SIZE OF ANY FILES NO LONGER NEEDED.  IF A SUFFICIENT
C     QUANTITY IS NOT NEEDED, THE FILE IS RECOPIED WITH THE DEAD FILES
C     DELETED.
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        RSHIFT,ANDF,ORF
      DIMENSION       NDPD(1),NDPH(2),FEQU(1),FNTU(1),FON(1),FORD(1),
     1                MINP(1),MLSN(1),MOUT(1),MSCR(1),SAL(1),SDBN(1),
     2                SNTU(1),SORD(1)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG / UFM,UWM,UIM,SFM
      COMMON /SYSTEM/ IBUFSZ,OUTTAP,DUM(36),NBPC,NBPW,NCPW
      COMMON /XFIAT / FIAT(1),FMXLG,FCULG,FILE(1),FDBN(2),FMAT(1)
      COMMON /XFIST / FIST(2)
      COMMON /XPFIST/ NPFIST
      COMMON /XXFIAT/ EXFIAT
      COMMON /XDPL  / DPD(1),DMXLG,DCULG,DDBN(2),DFNU(1)
      COMMON /ZZZZZZ/ ENDSFA(1)
      COMMON /XSFA1 / MD(401),SOS(1501),COMM(20),XF1AT(1),FPUN(1),
     1                FCUM(1),FCUS(1),FKND(1)
      EQUIVALENCE     (DPD(1),DNAF),(FIAT(1),FUNLG),(FILE(1),FEQU(1)),
     1                (FILE(1),FORD(1)),(ENDSFA(1),NDPD(1))
      EQUIVALENCE     (MD(2),MLSN(1)),(MD(3),MINP(1)),(MD(4),MOUT(1)),
     1                (MD(5),MSCR(1)),
     2                (SOS(1),SLGN)  ,(SOS(2),SDBN(1)),(SOS(4),SAL(1)),
     3                (SOS(4),SNTU(1)),(SOS(4),SORD(1)),
     4                (COMM(1),ALMSK),(COMM(2),APNDMK),(COMM(3),CURSNO),
     5                (COMM(4),ENTN1),(COMM(5),ENTN2 ),(COMM(6),ENTN3 ),
     6                (COMM(7),ENTN4),(COMM(8),FLAG  ),(COMM(9),FNX   ),
     7                (COMM(10),LMSK),(COMM(11),LXMSK),
     8                (COMM(13),RMSK),(COMM(14),RXMSK),(COMM(15),S    ),
     9                (COMM(16),SCORNT),(COMM(17),TAPMSK),
     O                (COMM(18),THCRMK),(COMM(19),ZAP),
     1                (XF1AT(1),FNTU(1)),(XF1AT(1),FON(1))
C
      DATA    NCONST/ 100    /
      DATA    SCRN1 / 4HSCRA /, SCRN2 /4HTCH* /
      DATA    POOL  , NPOL   /  4HPOOL,4HNPOL /,  NDPH / 4HXDPH,4H    /
C
C
      FLAG = 0
  100 LMT3 = DCULG*ENTN4
      LMT  = (DCULG-1)*ENTN4 + 1
      NCNT = 0
      NGCNT= 0
      TRIAL= DNAF - 1
C
C     COUNT DEAD FILE SIZE, PUT SIZE IN NCNT
C
      DO 160 I = 1,LMT3,ENTN4
      IF (DDBN(I).NE.0 .OR. DDBN(I+1).NE.0) GO TO 159
      IF (DFNU(I) .GE. 0) GO TO 130
C
C     DEAD FILE IS EQUIV
C
      FLAG = -1
      KK = ANDF(RMSK,DFNU(I))
      DO 110 J = 1,LMT3,ENTN4
      IF (DFNU(J).GE.0 .OR. I.EQ.J) GO TO 110
      IF (KK .NE. ANDF(RMSK,DFNU(J))) GO TO 110
      IF (DDBN(J).NE.0 .OR. DDBN(J+1).NE.0) GO TO 145
      DFNU(J) = 0
  110 CONTINUE
  130 IF (KK  .EQ. TRIAL) GO TO 140
      IF (DFNU(I) .EQ. 0) GO TO 150
      NCNT = NCNT + RSHIFT(ANDF(LMSK,DFNU(I)),16)
      GO TO 150
  140 DNAF = TRIAL
  145 DFNU(I) = 0
  150 IF (I .NE. LMT) GO TO 160
      DCULG = DCULG - 1
      FLAG  = -1
      GO TO 100
C
C     COUNT GOOD STUFF ALSO
C
  159 NGCNT = NGCNT + RSHIFT(ANDF(LMSK,DFNU(I)),16)
  160 CONTINUE
C
C     CHECK FOR BREAKING OF EQUIV
C
      IF (FLAG .EQ. 0) GO TO 200
      DO 180 I = 1,LMT3,ENTN4
      IF (DFNU(I) .GE. 0) GO TO 180
      KK = ANDF(RMSK,DFNU(I))
      DO 170 J = 1,LMT3,ENTN4
      IF (DFNU(J).GE.0  .OR.  I.EQ.J) GO TO 170
      IF (KK .EQ. ANDF(RMSK,DFNU(J))) GO TO 180
  170 CONTINUE
      DFNU(I) = ANDF(ALMSK,DFNU(I))
  180 CONTINUE
C
C     IS NCNT OF SUFFICIENT SIZE TO WARRANT RECOPYING POOL
C
  200 CALL SSWTCH (3,IX)
      IF (IX .NE. 1) GO TO 211
      CALL PAGE1
      WRITE  (OUTTAP,201) NCNT
  201 FORMAT (21H0DPH DEAD FILE COUNT=,I6)
      WRITE  (OUTTAP,202)(DPD(IX),IX=1,3)
  202 FORMAT (16H0DPD BEFORE DPH ,3I4)
      II = DCULG*3 + 3
      DO 210 IX = 4,II,3
      IPRT1 = RSHIFT(DPD(IX+2),NBPW-1)
      IPRT2 = RSHIFT(ANDF(LXMSK,DPD(IX+2)),16)
      IPRT3 = ANDF(RXMSK,DPD(IX+2))
  203 FORMAT (1H ,2A4,3I6)
  210 WRITE  (OUTTAP,203) DPD(IX),DPD(IX+1),IPRT1,IPRT2,IPRT3
C
C     RECOPY POOL IF THERE ARE MORE THAN 500,000 WORD DEAD AND
C     THE GOOD STUFF IS TWICE AS BIG AS THE DEAD STUFF
C
  211 IF (NCNT.GT.NCONST .AND. NCNT.GT.2*NGCNT) GO TO 230
      IF (NCNT.GT.0 .AND. DCULG+5.GE.DMXLG) GO TO 230
      RETURN
C
C     RECOPY POOL, SWITCH POOL FILE POINTERS
C
  230 LMT2 = FUNLG*ENTN1
      KK   = ANDF(THCRMK,SCRN2)
      DO 250 I = 1,LMT2,ENTN1
      IF (FDBN(I).EQ.0 .AND. FDBN(I+1).EQ.0) GO TO 270
      IF (FDBN(I).EQ.SCRN1 .AND. ANDF(THCRMK,FDBN(I+1)).EQ.KK) GO TO 270
  250 CONTINUE
C
C     NO FILE AVAILABLE TO COPY ONTO, FORGET IT
C
      RETURN
C
C     SET-UP FOR A RECOPY
C
  270 ISAV = I
      CALL OPEN (*900,POOL,ENDSFA,0)
      FNX = 1
      FIST(2*NPFIST+4) = ISAV + 2
      FIST(2) = NPFIST + 1
      FIST(2*NPFIST+3) = NPOL
      CALL OPEN (*900,NPOL,ENDSFA(IBUFSZ+1),1)
      M = 2*IBUFSZ
      I = M + 1
      ISTART = I
      M = M + DCULG*3 + 3
      IWKBUF = KORSZ(ENDSFA) - M
      IF (IWKBUF .LT. 100) CALL MESAGE (-8,0,NDPH)
      M = M + 1
      NFILE = 1
      NCULG = 0
      DO 400 J = 1,LMT3,ENTN4
      IF (DDBN(J).EQ. 0 .AND. DDBN(J+1).EQ. 0) GO TO 400
      IF (DDBN(J).EQ.63 .AND. DDBN(J+1).EQ.63) GO TO 400
C
C     RECOPY DICTIONARY
C
      NDPD(I  ) = DDBN(J  )
      NDPD(I+1) = DDBN(J+1)
      NDPD(I+2) = ORF(ANDF(LXMSK,DFNU(J)),NFILE)
      IF (DFNU(J) .GE. 0) GO TO 290
      NDPD(I+2) = ORF(S,NDPD(I+2))
      KK = ANDF(RMSK,DFNU(J))
      DO 280 K  = 1,LMT3,ENTN4
      IF (DFNU(K).GE.0 .OR. J.EQ.K) GO TO 280
      IF (KK .NE. ANDF(RMSK,DFNU(K))) GO TO 280
      I = I + 3
      NCULG   = NCULG + 1
      NDPD(I) = DDBN(K)
      DDBN(K) = 63
      NDPD(I+1) = DDBN(K+1)
      DDBN(K+1) = 63
      NDPD(I+2) = NDPD(I-1)
  280 CONTINUE
  290 I = I + 3
      NCULG = NCULG + 1
C
C     RECOPY NECESSARY FILE
C
      FN = ANDF(RMSK,DFNU(J))
      CALL XFILPS (FN)
      CALL CPYFIL (POOL,NPOL,ENDSFA(M),IWKBUF,FLAG)
      CALL EOF (NPOL)
      NFILE = NFILE + 1
      FNX   = FN + 1
  400 CONTINUE
C
C     COPY TEMPORARY DPD INTO ACTUAL DPD
C
      I  = I - 1
      IX = 0
      DO 420 J = ISTART,I
      IX = IX + 1
  420 DDBN(IX) = NDPD(J)
      DNAF = NFILE
      DCULG= NCULG
      CALL CLOSE (POOL,1)
      CALL CLOSE (NPOL,1)
      FNX = 1
C
C     COPY POOL BACK TO POOL UNIT
C
      CALL OPEN (*900,NPOL,ENDSFA,0)
      CALL OPEN (*900,POOL,ENDSFA(IBUFSZ+1),1)
      NFILE = NFILE - 1
      DO 430 IX = 1,NFILE
      CALL CPYFIL (NPOL,POOL,ENDSFA(M),IWKBUF,FLAG)
      CALL EOF (POOL)
  430 CONTINUE
      CALL CLOSE (POOL,1)
      CALL CLOSE (NPOL,1)
C
C     THE FOLLOWING 3 LINES OF CODE WILL FREE DISK AREA ON SOME CONFIG.
C
      CALL OPEN  (*900,NPOL,ENDSFA,1)
      CALL WRITE (NPOL,NDPH,2,1)
      CALL CLOSE (NPOL,1)
      CALL SSWTCH (3,IX)
      IF (IX .NE. 1) RETURN
C
      WRITE  (OUTTAP,500) (DPD(IX),IX=1,3)
  500 FORMAT (15H0DPD AFTER DPH ,3I4)
      II = DCULG*3 + 3
      DO 510 IX = 4,II,3
      IPRT1 = RSHIFT(DPD(IX+2),NBPW-1)
      IPRT2 = RSHIFT(ANDF(LXMSK,DPD(IX+2)),16)
      IPRT3 = ANDF(RXMSK,DPD(IX+2))
  510 WRITE (OUTTAP,203) DPD(IX),DPD(IX+1),IPRT1,IPRT2,IPRT3
      RETURN
C
  900 WRITE  (OUTTAP,901) SFM
  901 FORMAT (A25,' 1041, OLD/NEW POOL COULD NOT BE OPENED.')
      CALL MESAGE (-37,0,NDPH)
      RETURN
      END

      SUBROUTINE GMMERG(FILEA,FILE11,FILE21,FILE12,FILE22,RPART,CPART,
     1          NSUB,MRGTYP,CORE,LCORE)
C
C     GENERAL MATRIX MERGE ROUTINE
C
C
C                  --               --
C                  I        I        I
C                  I FILE11 I FILE12 I   --     --
C                  I        I        I   I       I
C                  I-----------------I = I FILEA I
C                  I        I        I   I       I
C                  I FILE21 I FILE22 I   --     --
C                  I        I        I
C                  --               --
C
C        WHERE
C
C             RPART - ROW PARTITIONING VECTOR
C             NSUB(1) - NUMBER OF COLUMNS IN RPART 0 SUBSET
C             NSUB(2) - NUMBER OF COLUMNS IN RPART 1 SUBSET
C             NSUB(3) - NUMBER OF ROWS IN CPART 0 SUBSET
C             NSUB(4) - NUMBER OF ROWS IN CPART 1 SUBSET
C             MRGTYP - MERGE TYPE (1 .EQ. SQUARE, 2 .EQ. RECTANGULAR)
C             CPART - COLUMN PARTITION VECTOR
C
C
      INTEGER       FILEA    ,FILE11   ,FILE12   ,FILE21   ,FILE22
     1             ,RPART    ,CPART    ,RULE     ,CORE(6)  ,NAME(2)
     2             ,RP(7)    ,CP(7)
C
      COMMON / PARMEG /       IA(7)    ,IA11(7)  ,IA21(7)  ,IA12(7)
     1                       ,IA22(7)  ,LCR      ,RULE
C
      DIMENSION NSUB(4)
C
      DATA NAME / 4HGMME , 4HRG   /
C
C***********************************************************************
C
C     GET TRAILERS FOR INPUTS
C
      RP(1) = RPART
      IF(RPART .NE. 0) CALL RDTRL(RP)
      CP(1) = CPART
      IF(CPART .NE. 0) CALL RDTRL(CP)
C
      DO 10 I=2,7
      IA(I) = 0
      IA11(I) = 0
      IA12(I) = 0
      IA21(I) = 0
   10 IA22(I) = 0
C
      IA11(1) = FILE11
      IF(FILE11 .NE. 0) CALL RDTRL(IA11)
      IF(IA11(1) .LT. 0) IA11(1) = 0
      IA12(1) = FILE12
      IF(FILE12 .NE. 0) CALL RDTRL(IA12)
      IF(IA12(1) .LT. 0) IA12(1) = 0
      IA21(1) = FILE21
      IF(FILE21 .NE. 0) CALL RDTRL(IA21)
      IF(IA21(1) .LT. 0) IA21(1) = 0
      IA22(1) = FILE22
      IF(FILE22 .NE. 0) CALL RDTRL(IA22)
      IF(IA22(1) .LT. 0) IA22(1) = 0
C
C     SET UP MATRIX CONTROL BLOCK FOR OUTPUT
C
      IA(1) = FILEA
      IA(4) = MRGTYP
      IA(5) = MAX0(IA11(5),IA12(5),IA21(5),IA22(5))
C
C     SET UP DUMMY PARTITION VECTOR
C
      CORE(1) = 0
      CORE(2) = 1
      CORE(3) = IA(2)
      CORE(4) = 2
      CORE(5) = 1
      CORE(6) = 0
      LCR = LCORE
      RULE = 0
C
      IF(RPART .EQ. 0) GO TO 30
      IF(CPART .EQ. 0) GO TO 20
C
C     FULL MERGE
C
      IA(2) = NSUB(1) + NSUB(2)
      IA(3) = NSUB(3) + NSUB(4)
      CALL MERGE(RP,CP,CORE)
      GO TO 40
C
C  *  *  MERGE COLUMNS ONLY
C
   20 IA(2) = NSUB(1) + NSUB(2)
      IA(3) = MAX0(IA11(3),IA12(3))
      CALL MERGE(RP,CORE,CORE)
      GO TO 40
C
C  *  *  MERGE ROWS ONLY
C
   30 IF(CPART .EQ. 0) GO TO 1007
      IA(2) = MAX0(IA11(2),IA21(2))
      IA(3) = NSUB(3) + NSUB(4)
      CALL MERGE(CORE,CP,CORE)
C
C     WRITE TRIALER FOR OUTPUT
C
   40 CALL WRTTRL(IA)
C
      RETURN
C
C     ILLEGAL INPUT - NO PARTITION VECTOR
C
 1007 CALL MESAGE(-7,0,NAME)
      RETURN
      END

      SUBROUTINE OLDEL1
C
C     ANY ELEMENT (NEW OR OLD) WHICH HAS NOT BEEN CONVERTED TO USE
C     EMGPRO SHOULD HAVE AN ENTRY POINT IN OLDEL1, OLDEL2, OR OLDEL3
C     ***************************************************************
C
      ENTRY AXIF2S
      GO TO 10
      ENTRY AXIF2D
      GO TO 10
      ENTRY AXIF3S
      GO TO 10
      ENTRY AXIF3D
      GO TO 10
      ENTRY AXIF4S
      GO TO 10
      ENTRY AXIF4D
      GO TO 10
      ENTRY CONES
      GO TO 10
      ENTRY CONED
      GO TO 10
      ENTRY ELBOWS
      GO TO 10
      ENTRY ELBOWD
      GO TO 10
      ENTRY FLMASS
      GO TO 10
      ENTRY FLMASD
      GO TO 10
      ENTRY FLUD2S
      GO TO 10
      ENTRY FLUD2D
      GO TO 10
      ENTRY FLUD3S
      GO TO 10
      ENTRY FLUD3D
      GO TO 10
      ENTRY FLUD4S
      GO TO 10
      ENTRY FLUD4D
C
 10   CALL EMGOLD
      RETURN
      END

      SUBROUTINE CENTRE(*,X1,Y1,X2,Y2,X3,Y3,X4,Y4,CENTER)
      DIMENSION CENTER(2)
      IF (X1.NE.X3.OR.X2.NE.X4) GO TO 10
      CENTER(1)=X1
      CENTER(2)=(AMAX1(Y1,Y2,Y3,Y4)+AMIN1(Y1,Y2,Y3,Y4))/2.0
      RETURN 1
   10 IF (X1.NE.X3) GO TO 20
      CENTER(1)=X1
      CENTER(2)=(Y4-Y2)*(CENTER(1)-X2)/(X4-X2)+Y2
      GO TO 100
   20 IF (X2.NE.X4) GO TO 30
      CENTER(1)=X2
      CENTER(2)=(Y3-Y1)*(CENTER(1)-X1)/(X3-X1)+Y1
      GO TO 100
   30 XM1=(Y2-Y4)/(X2-X4)
      XM2=(Y1-Y3)/(X1-X3)
      IF (XM1.EQ.XM2) GO TO 40
      CENTER(1)=(Y1-XM2*X1-(Y2-XM1*X2))/(XM1-XM2)
      CENTER(2)=XM1*(CENTER(1)-X2)+Y2
      GO TO 100
   40 CENTER(1)=(X1+X2)/2.0
      CENTER(2)=(Y1+Y2)/2.0
      RETURN 1
100   CONTINUE
      RETURN
      END

      SUBROUTINE QVOL
C
C     CALCULATES THERMAL LOADS DUE TO QVOL CARDS
C
      INTEGER         IP(3),NSIL(8),MAP(4,14),SLT,REASON,TYPE,BG,OLD,
     1                ORDER(8)
      REAL            R(4,8),DATA4(4,9),P(8),D12(3),D13(3),D14(3),
     1                CARD(12)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG / UFM,UWM,UIM,SFM
      COMMON /CONDAS/ CONSTS(5)
      COMMON /LOADX / LC,SLT,BG,OLD,NX(12), IFM
      COMMON /ZZZZZZ/ CORE(1)
      COMMON /SYSTEM/ SYSBUF,IOUT
      EQUIVALENCE     (CONSTS(2),TWOPI),(NPTS,CARD(1)),(ID,CARD(2)),
     1                (NSIL(1),CARD(3)),(COEF,CARD(11)),(TYPE,CARD(12)),
     2                (R(1,1),DATA4(2,1)),(I1,IP(1)),(I2,IP(2)),
     3                (I3,IP(3))
      DATA    MAP   / 1  ,2  ,3  ,4  ,
     1                1  ,2  ,3  ,6  ,
     2                1  ,2  ,6  ,5  ,
     3                1  ,4  ,5  ,6  ,
     4                1  ,2  ,3  ,6  ,
     5                1  ,3  ,4  ,8  ,
     6                1  ,3  ,8  ,6  ,
     7                1  ,5  ,6  ,8  ,
     8                3  ,6  ,7  ,8  ,
     9                2  ,3  ,4  ,7  ,
     O                1  ,2  ,4  ,5  ,
     1                2  ,4  ,5  ,7  ,
     2                2  ,5  ,6  ,7  ,
     3                4  ,5  ,7  ,8  /
C
C     READ AND PROCESS ONE ELEMENT OF ONE QVOL CARD PER CALL
C     THE LOAD COEFFICIENTS ARE GENERATED AND INSERTED HERE
C
C     THE INPUT DATA ON FILE SLT IS
C
C     FIELD       DATA
C       1         NO. OF POINTS
C       2         EL. ID.
C      3-10       1 TO 8 SILS
C                        *  A*Q  FOR  TYPE=1 (RODS,ETC)
C       11        COEF = *  T*Q  FOR  TYPE=2 (TRIANGLES ETC)
C                        *    Q  FOR  TYPE=3 (BELL) OR 4 (SOLID)
C       12        TYPE
C
      CALL FREAD (SLT,CARD,12,0)
      REASON = 1
      IF (NPTS .LE. 1) GO TO 240
      CALL PERMUT (NSIL(1),ORDER(1),NPTS,OLD)
      REASON = 2
      DO 10 I = 1,NPTS
      L = ORDER(I)
      CALL FNDPNT (DATA4(1,L),NSIL(L))
      N = NSIL(L)
      CALL FNDSIL (N)
      IF (N .NE. NSIL(L)) GO TO 240
      P(I) = 0.0
   10 CONTINUE
      REASON = 3
      IF (TYPE.LT.1 .OR. TYPE.GT.4) GO TO 240
      GO TO (20,40,40,120), TYPE
C
C     RODS, CONRODS, TUBES, BARS
C
   20 EL = 0.0
      DO 30 I = 1,3
   30 EL = EL + (R(I,1) - R(I,2))**2
      P(1) = COEF*SQRT(EL)*0.5
      P(2) = P(1)
      GO TO 200
C
C     MEMBRANES, PLATES, AND AXISYMMETRIC SOLIDS
C
   40 IF (NPTS .EQ. 3) GO TO 50
      IF (NPTS .EQ. 4) GO TO 60
      REASON = 4
      GO TO 240
   50 NEL  = 1
      FACT =  COEF/6.0
      GO TO 70
   60 NEL  = 4
      FACT =  COEF/12.0
   70 DO 110 IEL = 1,NEL
      DO 80 I = 1,3
      IP(I) = I + IEL - 1
      IF (IP(I) .GT. 4) IP(I) = IP(I) - 4
   80 CONTINUE
      DO 90 I = 1,3
      D12(I) = R(I,I2) - R(I,I1)
   90 D13(I) = R(I,I3) - R(I,I1)
      CALL SAXB (D12(1),D13(1),D12(1))
      EL =  FACT*SQRT(D12(1)**2 + D12(2)**2 + D12(3)**2)
      IF (TYPE .EQ. 2) GO TO 100
C
C     SPECIAL FACTOR FOR  AXISYMMETRIC ELEMENTS
C
      EL    = EL*TWOPI*(R(1,I1) + R(1,I2) + R(1,I3))/3.0
  100 P(I1) = P(I1) + EL
      P(I2) = P(I2) + EL
      P(I3) = P(I3) + EL
  110 CONTINUE
      GO TO 200
C
C     SOLID ELEMENTS
C
  120 IF (NPTS .EQ. 4) GO TO 130
      IF (NPTS .EQ. 6) GO TO 140
      IF (NPTS .EQ. 8) GO TO 150
      REASON = 5
      GO TO 240
  130 NEL  = 1
      FACT = COEF/24.0
      IMAP = 1
      GO TO 160
  140 NEL  = 3
      IMAP = 2
      FACT = COEF/24.0
      GO TO 160
  150 IMAP = 5
      NEL  = 10
      FACT = COEF/48.0
  160 DO 190 IEL = 1,NEL
      IM = IMAP + IEL - 1
      I1 =  MAP(1,IM)
      I2 =  MAP(2,IM)
      I3 =  MAP(3,IM)
      I4 =  MAP(4,IM)
      DO 170  I = 1,3
C
       D12(I) = R(I,I2) - R(I,I1)
       D13(I) = R(I,I3) - R(I,I1)
  170  D14(I) = R(I,I4) - R(I,I1)
C
      CALL SAXB (D12(1),D13(1),D12(1))
      EL = FACT*ABS(D12(1)*D14(1) + D12(2)*D14(2) + D12(3)*D14(3))
      DO 180 I = 1,4
      L = MAP(I,IM)
  180 P(L) = P(L) + EL
  190 CONTINUE
C
C     INSERT THE LOADS
C
  200 DO 210 I = 1,NPTS
      ISIL = NSIL(I)
      CORE(ISIL) = CORE(ISIL) + P(I)
  210 CONTINUE
      RETURN
C
C     ERROR MESSAGE
C
  240 WRITE  (IOUT,250) SFM,ID,REASON
  250 FORMAT (A25,' 3093, ELEMENT =',I9,'.   REASON =',I7)
      CALL MESAGE (-61,0,0)
      RETURN
      END

      SUBROUTINE FRMAX(IFK,IFM,N,IPR,RSN,RSM)
      DIMENSION          ZK(1)  ,ZM(1)
      DOUBLE PRECISION   RSN    ,RSM    ,RATIO  ,RATINV  ,
     1                   DZK(1) ,DZM(1)
      EQUIVALENCE       (DZK(1) ,ZK(1) ),(DZM(1) ,ZM(1) )
      COMMON  /UNPAKX/   IPRC   ,IP     ,NP     ,INCR
      IPRC = IPR
      INCR = 1
      RSN = 0.D0
      RSM = 0.D0
      DO 30 I = 1,N
      IP = I
      NP = I
      CALL UNPACK(*30,IFK,DZK(1))
      CALL UNPACK(*30,IFM,DZM(1))
      IF(IPR .EQ. 2) GO TO 10
      IF (ZK(1).EQ.0.OR.ZM(1).EQ.0) GO TO 30
      RATIO = ZK(1) / ZM(1)
      GO TO 20
   10 IF (DZK(1).EQ.0.0D0.OR.DZM(1).EQ.0.0D0) GO TO 30
      RATIO = DZK(1)/DZM(1)
   20 RATINV = 1.D0 /RATIO
      IF(RATIO .GT. RSM) RSM = RATIO
      IF(RATINV .GT. RSN) RSN = RATINV
   30 CONTINUE
      RSN = 1.D0 / RSN
      RETURN
      END

      SUBROUTINE NASTIM (IHR, IMN, ISC, CPUSEC)
      REAL ARRAY(2)
      REAL RESULT
      CALL ETIME(ARRAY,RESULT)
      SECS   = ARRAY(2)
      IHR    = SECS / 3600.
      IMN    = ( SECS - 3600.*IHR ) / 60.
      ISC    = SECS - ( 3600.*IHR ) - ( 60.*IMN )
      CPUSEC = SECS
      RETURN
      END

      SUBROUTINE DLAMG(INPUT,MATOUT,SKJ)
C
C     DRIVER FOR THE DOUBLET LATTICE METHOD
C     COMPUTATIONS ARE FOR THE AJJL MATRIX
C
      INTEGER         ECORE,SYSBUF,IZ(1),SKJ
      DIMENSION       NAME(2),A(2)
      COMPLEX         DT(1)
      COMMON /PACKX / ITI,ITO,II,NN,INCR
      COMMON /AMGMN / MCB(7),NROW,ND,NE,REFC,FMACH,RFK,TSKJ(7),ISK,NSK
      COMMON /DLCOM / NP,NSTRIP,NTP,F,NJJ,NEXT,LENGTH,
     1                INC,INB,IYS,IZS,IEE,ISG,ICG,
     2                IXIC,IDELX,IXLAM,IDT,ECORE
      COMMON /ZZZZZZ/ WORK(1)
      COMMON /SYSTEM/ SYSBUF
      COMMON /BLANK / NK,NJ
      EQUIVALENCE     (WORK(1),IZ(1),DT(1))
      DATA    NAME  / 4HDLAM,4HG   /
C
      NJJ = NJ
C
C     READ IN NP,NSIZE,NTP,F
C
      CALL READ(*999,*999,INPUT,NP,4,0,N)
C
C     COMPUTE POINTERS AND SEE IF THERE IS ENOUGH CORE
C
      ECORE = KORSZ(IZ)
      ECORE =  ECORE - 4 * SYSBUF
      INC = 1
      INB = INC + NP
      IYS = INB + NP
      IZS = IYS + NSTRIP
      IEE = IZS + NSTRIP
      ISG = IEE + NSTRIP
      ICG = ISG + NSTRIP
      IXIC = ICG + NSTRIP
      IDELX = IXIC + NTP
      IXLAM = IDELX + NTP
      NREAD = IXLAM + NTP
C     IDT IS A COMPLEX POINTER
C     THE MATRIX PACKED OUT IS NJ LONG STARTING AT DT
      IDT = (NREAD +2) / 2
      NEXT = IDT*2 + 2*NJ + 1
C
C     FILL IN DATA
C
      IF(NEXT .GT. ECORE) GO TO 998
      NREAD = NREAD -1
      CALL READ(*999,*999,INPUT,WORK,NREAD,1,N)
C
C     CHECK FOR ENOUGH SCRATCH STORAGE
C
      N = INC + NP -1
      LENGTH = 1
C
C     PUT OUT SKJ
C
      ITI = 1
      ITO = 3
      II = ISK
      NSK = NSK + 2
      NN = NSK
      K = 0
      KS = 0
      NBXR=IZ(INC+K)
      DO 5 I=1,NTP
      A(1) = 2.0 * WORK(IEE+KS) * WORK(IDELX+I-1)
      A(2) = (WORK(IEE+KS) * WORK(IDELX+I-1)**2)/ 2.0
      CALL PACK( A,SKJ,TSKJ)
      II = II +2
      IF(I.EQ.NTP) GO TO 5
      NN = NN +2
      IF(I.EQ.IZ(INB+K)) K = K+1
      IF(I.EQ.NBXR) GO TO 4
      GO TO 5
    4 KS = KS +1
      NBXR = NBXR + IZ(INC+K)
    5 CONTINUE
      ISK = II
      NSK = NN
      ITI = 3
      ITO = 3
      II = 1
      NN = NJ
      CALL GEND(WORK(INC),WORK(INB),WORK(IYS),WORK(IZS),
     1          WORK(ISG),WORK(ICG),DT(IDT),WORK(1),MATOUT)
      NROW = NROW + NTP
      RETURN
C
C     ERROR MESSAGES
C
C     NOT ENOUGH CORE
  998 CALL MESAGE(-8,0,NAME)
C     INPUT NOT POSITIONED PROPERLY OR INCORRECTLY WRITTEN
  999 CALL MESAGE(-7,0,NAME)
      RETURN
      END

      SUBROUTINE FAILUR (FTHR,ULTSTN,STRESL,FINDEX)
C
C      THIS ROUTINE COMPUTES THE FAILURE INDEX OF A LAYER
C      IN A LAMINATED COMPOSITE ELEMENT USING ONE OF THE
C      FOLLOWING FIVE FAILURE THEORIES CURRENTLY AVAILABLE
C
C        1.   HILL
C        2.   HOFFMAN
C        3.   TSAI-WU
C        4.   MAX STRESS
C        5.   MAX STRAIN
C
C        DEFINITIONS
C        -----------
C        XT = ULTIMATE UNIAXIAL TENSILE STRENGTH IN THE FIBER
C             DIRECTION
C        XC = ULTIMATE UNIAXIAL COMPRESSIVE STRENGTH IN THE
C             FIBER DIRECTION
C        YT = ULTIMATE UNIAXIAL TENSILE STRENGTH PERPENDICULAR TO
C             THE FIBER DIRECTION
C        YC = ULTIMATE UNIAXIAL COMPRESSIVE STRENGTH PERPENDICULAR
C             TO THE FIBER DIRECTION
C        S  = ULTIMATE PLANAR SHEAR STRENGTH UNDER PURE SHEAR
C             LOADING
C        SIMILARILY FOR THE ULTIMATE STRAINS
C
      DIMENSION       ULTSTN(6),STRESL(3)
      INTEGER         FTHR
      COMMON /SYSTEM/ IBUF,NOUT
C
C**** CHECK FOR ZERO STRENGTH VALUES
C
      DO 10 I = 1,5
   10 IF (ULTSTN(I) .EQ. 0.0) GO TO 90
C
C**** ULTIMATE STRENGTH VALUES
C
      XT      = ULTSTN(1)
      XC      = ULTSTN(2)
      YT      = ULTSTN(3)
      YC      = ULTSTN(4)
      S       = ULTSTN(5)
      F12     = ULTSTN(6)
C
C**** LAYER STRESSES
C
      SIG1    = STRESL(1)
      SIG2    = STRESL(2)
      TAU12   = STRESL(3)
C
C**** LAYER STRAINS
C
      EPS1    = STRESL(1)
      EPS2    = STRESL(2)
      GAMA    = STRESL(3)
C
C
      GO TO (20,30,40,60,70), FTHR
C
C     H I L L   F A I L U R E  T H E O R Y
C     ====================================
C
   20 X = XT
      IF (SIG1 .LT. 0.0) X = XC
C
      Y = YT
      IF (SIG2 .LT. 0.0) Y = YC
C
      XX = XT
      IF ((SIG1*SIG2) .LT. 0.0) XX = XC
C
      FINDEX = ( SIG1*SIG1 )/( X*X )
      FINDEX = FINDEX + ( SIG2*SIG2 )/( Y*Y )
      FINDEX = FINDEX - ( SIG1*SIG2 )/( XX*XX )
      FINDEX = FINDEX + ( TAU12*TAU12 )/( S*S )
      GO TO 80
C
C
C     H O F F M A N  F A I L U R E  T H E O R Y
C     =========================================
C
   30 FINDEX = ( 1.0/XT - 1.0/XC )*SIG1
      FINDEX = FINDEX + ( 1.0/YT - 1.0/YC )*SIG2
      FINDEX = FINDEX + ( SIG1*SIG1 )/( XT*XC )
      FINDEX = FINDEX + ( SIG2*SIG2 )/( YT*YC )
      FINDEX = FINDEX + ( TAU12*TAU12 )/( S*S )
      FINDEX = FINDEX - ( SIG1*SIG2 )/( XT*XC )
      GO TO 80
C
C
C     T S A I-W U  F A I L U R E  T H E O R Y
C     =======================================
C
C**** CHECK STABILITY CRITERIA FOR THE INTERACTION TERM F12
   40 IF (F12 .EQ. 0.0) GO TO 50
C
      CRIT = ( 1.0/(XT*XC) )*( 1.0/(YT*YC) ) - ( F12*F12 )
      IF (CRIT .GT. 0.0) GO TO 50
C
C**** IF STABILITY CRITERIA IS VIOLATED THEN SET THE
C     F12 THE INTERACTION TERM TO ZERO
C
      F12 = 0.0
C
C
   50 FINDEX = ( 1.0/XT - 1.0/XC )*SIG1
      FINDEX = FINDEX + ( 1.0/YT - 1.0/YC )*SIG2
      FINDEX = FINDEX + ( SIG1*SIG1 )/( XT*XC )
      FINDEX = FINDEX + ( SIG2*SIG2 )/( YT*YC )
      FINDEX = FINDEX + ( TAU12*TAU12 )/( S*S )
      IF (F12 .EQ. 0.0) GO TO 80
      FINDEX = FINDEX + ( 2.0*F12*SIG1*SIG2 )
      GO TO 80
C
C
C     M A X  S T R E S S  F A I L U R E  T H E O R Y
C     ==============================================
C
   60 FI1 = SIG1/XT
      IF (SIG1 .LT. 0.0) FI1 = SIG1/XC
C
      FI2 = SIG2/YT
      IF (SIG2 .LT. 0.0) FI2 = SIG2/YC
C
      FI12 = ABS(TAU12)/S
C
      FINDEX = FI1
      IF (FI2  .GT. FINDEX) FINDEX = FI2
      IF (FI12 .GT. FINDEX) FINDEX = FI12
      GO TO 80
C
C
C     M A X  S T R A I N  F A I L U R E  T H E O R Y
C     ==============================================
C
   70 FI1 = EPS1/XT
      IF (EPS1 .LT. 0.0) FI1 = EPS1/XC
C
      FI2 = EPS2/YT
      IF (EPS2 .LT. 0.0) FI2 = EPS2/YC
C
      FI12 = ABS(GAMA)/S
C
      FINDEX = FI1
      IF (FI2  .GT. FINDEX) FINDEX = FI2
      IF (FI12 .GT. FINDEX) FINDEX = FI12
C
   80 CONTINUE
C
      RETURN
C
C
C     NON-FATAL ERROR
C
C
   90 FINDEX = 0.0
      RETURN
      END

      SUBROUTINE GP4SP (IBUF1,IBUF2,IBUF3)
C
C     ROUTINE TO LOOK AT GPST TO ELIMINATE SINGULARITIES
C
C
      EXTERNAL        ANDF  ,ORF   ,COMPLF,LSHIFT
      INTEGER         ANDF  ,ORF   ,COMPLF,EQEXIN,GPST  ,OGPST ,SCR2  ,
     1                MCB(7),OMIT1 ,SPCSET,OGPST1(10)
      DIMENSION       IPONTS(9)    ,JPONTS(9)    ,INDXMS(9)    ,
     1                IEXCLD(9)    ,ISUBNM(2)    ,IWORD(8)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG / UFM   ,UWM   ,UIM   ,SFM
      COMMON /BLANK / LUSET ,MPCF1 ,MPCF2 ,SINGLE,OMIT1 ,REACT ,NSKIP ,
     1                REPEAT,NOSETS,NOL   ,NOA   ,IDSUB ,IAUTSP
      COMMON /GP4FIL/ DUM(3),IRGT
      COMMON /GP4SPX/ MSKUM ,MSKUO ,MSKUR ,MSKUS ,MSKUL ,
     1                MSKSNG,SPCSET,MPCSET,NAUTO ,IOGPST
      COMMON /OUTPUT/ HEAD(1)
      COMMON /SYSTEM/ ISYSBF,IOUTPT,JDUM(6),NLPP ,KDUM(2),LINE,
     1                DD(78),IPUNCH
      COMMON /UNPAKX/ ITYPOT,IIII  ,JJJJ  ,INCR
      COMMON /ZZZZZZ/ IZ(1)
      DATA    EQEXIN, GPST, OGPST, SCR2 /103, 107, 205, 302/
      DATA    ISUBNM /4HGP4S, 4HP       /
      DATA    NCARD,  IERROR / 2*0      /
      DATA    ISCR2,  IEQEXN / 2*-1     /
C
C
      INDEX = IABS (IAUTSP)
      IF (INDEX .GT. 2) GO TO 730
      IF (INDEX.EQ.2 .AND. OMIT1.GT.0) INDEX = 3
      MSKMS = ORF(MSKUM,MSKUS)
      IF (IAUTSP .EQ. 0) GO TO 6
      MULTI = 0
      IF (MPCF1 .EQ. -1) GO TO 6
      MSKIN = LSHIFT(1,12)
      MSKXX = COMPLF(MSKIN)
      CALL GOPEN (IRGT,IZ(IBUF1),0)
      ITYPOT = 1
      IIII   = 1
      JJJJ   = 1
      INCR   = 1
      DO 4 I = 1,LUSET
      CALL UNPACK (*4,IRGT,IDUM)
      IF (ANDF(IZ(I),MSKMS) .NE. 0) GO TO 4
      MULTI = 1
      IZ(I) = ORF(IZ(I),MSKIN)
    4 CONTINUE
      CALL CLOSE (IRGT,1)
    6 CONTINUE
      CALL OPEN (*610,GPST,IZ(IBUF1),0)
      IFILE = GPST
      CALL FWDREC (*700,GPST)
C
   10 CALL READ (*480,*480,GPST,IORDR,1,0,IFLAG)
      INITL = IORDR
      IMS   = 0
      ISPC  = 0
      DO 20 I = 1, 9
      INDXMS(I) = 0
      IEXCLD(I) = 0
      IPONTS(I) = 0
      JPONTS(I) = 0
   20 CONTINUE
      CALL FREAD (GPST,NPTS,1,0)
      CALL FREAD (GPST,IPONTS,NPTS,0)
      IBASE = IPONTS(1)
C
C     SET VARIOUS FLAGS FOR THE SINGULARITIES
C
      DO 30 I = 1,NPTS
      II = IPONTS(I)
      J  = IZ(II)
      IF (ANDF(J,MSKMS) .NE. 0) INDXMS(I) = 1
      IF (IAUTSP        .EQ. 0) GO TO 30
      IF (ANDF(J,MSKUO).NE.0 .AND. ANDF(J,MSKUL).NE.0) GO TO 740
      IF (ANDF(J,MSKUO).NE.0 .AND. ANDF(J,MSKUR).NE.0) GO TO 740
      IF (ANDF(J,MSKUR).NE.0 .AND. ANDF(J,MSKUL).NE.0) GO TO 740
      IF (ANDF(J,MSKUR) .NE. 0) IEXCLD(I) = 1
      IF (MULTI.EQ.0 .OR. INDXMS(I).NE.0) GO TO 25
      IF (ANDF(J,MSKIN) .NE. 0) IEXCLD(I) = 1
   25 IF (INDEX         .LT. 3) GO TO 30
      IF (ANDF(J,MSKUL) .NE. 0) IEXCLD(I) = 1
   30 CONTINUE
C
C     DETERMINE THE ORDER OF SINGULARITY
C
      IF (IORDR-2) 230,260,410
C
C
   40 LOGIC = 100
      IF (ISPC .GT. INITL) GO TO 750
      IF (IEQEXN .EQ.   1) GO TO 60
      IEQEXN = 1
C
C     BRING IN EQEXIN
C
      CALL GOPEN (EQEXIN,IZ(IBUF2),0)
      CALL SKPREC (EQEXIN,1)
      MCB(1) = EQEXIN
      CALL RDTRL (MCB)
      ICORE = LUSET + 2*(MCB(2)+1) - IBUF2
      IF (ICORE .GE. 0) GO TO 720
      IFILE = EQEXIN
      CALL READ (*700,*50,EQEXIN,IZ(LUSET+1),IBUF2-LUSET,0,NEQEXN)
      GO TO 720
   50 CALL CLOSE (EQEXIN,1)
      CALL SORT (0,0,2,2,IZ(LUSET+1),NEQEXN)
      IZ(LUSET+NEQEXN+1) = 0
      IZ(LUSET+NEQEXN+2) = 10*(LUSET+1)
      NEQEXN = NEQEXN + 2
C
C     LOOK UP SIL IN EQEXIN
C
      ISTART = 2
   60 KK = IBASE
      DO 70 I = ISTART,NEQEXN,2
      K = LUSET + I
      ISIL = IZ(K)/10
      IF (KK .LT. ISIL) GO TO 80
   70 CONTINUE
      LOGIC = 110
      GO TO 750
C
C     PICK UP POINT ID AND TYPE (GRID OR SCALAR) FROM EQEXIN
C
   80 IGPID = IZ(K-3)
      ISIL  = IZ(K-2)/10
      ITYP  = IZ(K-2) - 10*ISIL
      ISTART= I - 2
      IF (ITYP .EQ. 1) GO TO 90
C
C     SCALAR POINT
C
      IORDR = 0
      NPTS  = 0
C
C
   90 IF (ISPC .EQ. 0) GO TO 140
      LOGIC = 120
      IF (ITYP.EQ.2 .AND. ISPC.GT.1) GO TO 750
      IF (ITYP  .EQ. 2) JPONTS(1) = 0
      IF (ISCR2 .EQ. 1) GO TO 100
      ISCR2    = 1
      IWORD(1) = SPCSET
      IF (IWORD(1) .LE. 0) IWORD(1) = 1
C
C     INITIALIZE SCR2
C
      CALL GOPEN (SCR2,IZ(IBUF3),1)
C
C     WRITE AUTOMATICALLY GENERATED SPC1 DATA ON SCR2
C
  100 DO 130 I = 1,ISPC
      IF (ITYP      .EQ. 2) GO TO 120
      IF (JPONTS(I) .GT. 0) GO TO 110
      LOGIC = 130
      GO TO 750
  110 JPONTS(I) = JPONTS(I) - ISIL + 1
  120 CALL WRITE (SCR2,JPONTS(I),1,0)
      CALL WRITE (SCR2,IGPID,    1,0)
  130 CONTINUE
      IF (ISPC+IMS .GE. INITL) GO TO 10
C
C
  140 IF (IOGPST .EQ. 1) GO TO 150
      IOGPST = 1
C
C     INITIALIZE OGPST
C
      CALL GOPEN (OGPST,IZ(IBUF2),1)
      OGPST1( 1) = 0
      OGPST1( 2) = 8
      OGPST1( 3) = SPCSET
      OGPST1( 4) = MPCSET
      OGPST1(10) = 12
      CALL WRITE (OGPST,OGPST1, 10,0)
      CALL WRITE (OGPST,IZ,     40,0)
      CALL WRITE (OGPST,HEAD(1),96,1)
C
C     PUT OUT ERROR RECORDS ON OGPST
C
  150 CALL WRITE (OGPST,IGPID,1,0)
      CALL WRITE (OGPST,ITYP ,1,0)
      CALL WRITE (OGPST,IORDR,1,0)
      IORDR = IORDR + 1
      IF (IORDR .EQ. 1) GO TO 180
      DO 170 I = 1,NPTS
      IF (IPONTS(I) .GT. 0) GO TO 160
      LOGIC = 140
      GO TO 750
  160 IPONTS(I) = IPONTS(I) - ISIL + 1
  170 CONTINUE
      LOGIC = 150
      GO TO (750,200,210,220), IORDR
C
C     SCALAR
C
  180 DO 190 I = 1,9
  190 IPONTS(I) = 0
      GO TO 220
C
C     FIRST ORDER OUTPUT
C
  200 IPONTS(4) = IPONTS(2)
      IPONTS(7) = IPONTS(3)
      IPONTS(2) = 0
      IPONTS(3) = 0
      IPONTS(5) = 0
      IPONTS(6) = 0
      IPONTS(8) = 0
      IPONTS(9) = 0
      GO TO 220
C
C     SECOND ORDER OUTPUT
C
  210 IPONTS(8) = IPONTS(6)
      IPONTS(7) = IPONTS(5)
      IPONTS(5) = IPONTS(4)
      IPONTS(4) = IPONTS(3)
      IPONTS(3) = 0
      IPONTS(6) = 0
      IPONTS(9) = 0
C
C     THIRD ORDER OUTPUT
C
  220 CALL WRITE (OGPST,IPONTS,9,0)
      GO TO 10
C
C     FIRST ORDER SINGULARITY
C
  230 DO 240 I = 1,NPTS
      IF (INDXMS(I) .NE. 0) GO TO 10
  240 CONTINUE
      IF (IAUTSP    .EQ. 0) GO TO 40
      DO 250 I = 1,NPTS
      IF (IEXCLD(I) .NE. 0) GO TO 250
      II     = IPONTS(I)
      IZ(II) = MSKSNG
      NAUTO  = NAUTO + 1
      ISPC   = ISPC  + 1
      JPONTS(ISPC) = II
      GO TO 40
  250 CONTINUE
      GO TO 40
C
C     SECOND ORDER SINGULARITY
C
  260 ILOOP = 1
  270 DO 360 I = 1,NPTS,2
      II = IPONTS(I)
      IF (II        .EQ. 0) GO TO 310
      IF (INDXMS(I) .NE. 0) GO TO 280
      IF (ILOOP     .EQ. 1) GO TO 310
      IF (IEXCLD(I) .NE. 0) GO TO 310
      IZ(II) = MSKSNG
      NAUTO  = NAUTO + 1
      ISPC   = ISPC  + 1
      JPONTS(ISPC) = II
      GO TO 290
  280 IMS   = IMS + 1
  290 IORDR = 1
      DO 300 III = 1,NPTS
      IF (IPONTS(III) .EQ. II) IPONTS(III) = 0
  300 CONTINUE
      II = 0
  310 JJ = IPONTS(I+1)
      IF (JJ          .EQ. 0) GO TO 330
      IF (INDXMS(I+1) .NE. 0) GO TO 320
      IF (ILOOP       .EQ. 1) GO TO 360
      IF (IEXCLD(I+1) .NE. 0) GO TO 360
      IZ(JJ) = MSKSNG
      NAUTO  = NAUTO + 1
      ISPC   = ISPC  + 1
      JPONTS(ISPC) = JJ
      GO TO 330
  320 IMS = IMS + 1
  330 IF (II .NE. 0) GO TO 340
      LOGIC = 160
      IF (ISPC+IMS .LT. 2) GO TO 750
      IF (ISPC     .EQ. 0) GO TO 10
      GO TO 380
  340 IORDR = 1
      DO 350 III = 1, NPTS
      IF (IPONTS(III) .EQ. JJ) IPONTS(III) = 0
  350 CONTINUE
  360 CONTINUE
      IF (IAUTSP .EQ. 0) GO TO 370
      IF (ILOOP  .EQ. 2) GO TO 370
      ILOOP = 2
      GO TO 270
  370 IF (IORDR .EQ. 1) GO TO 380
      IF (IORDR .EQ. 2) GO TO 40
      LOGIC = 170
      GO TO 750
  380 IOK = 0
      DO 400 I = 1, NPTS
      IF (IPONTS(I) .EQ. 0) GO TO 400
      IOK = IOK + 1
      IPONTS(IOK) = IPONTS(I)
      IF (IOK .NE.  I) IPONTS(I) = 0
      IF (I .EQ. NPTS) GO TO 400
      II = I + 1
      DO 390 J = II,NPTS
      IF (IPONTS(J) .EQ. 0) GO TO 390
      IF (IPONTS(J) .EQ. IPONTS(IOK)) IPONTS(J) = 0
  390 CONTINUE
  400 CONTINUE
      NPTS = IOK
      IF (NPTS .EQ. 0) GO TO 40
C
      LOGIC = 180
      IF (NPTS .GT. 2) GO TO 750
      LOGIC = 190
      IF (IPONTS(1) .EQ. IPONTS(2)) GO TO 750
      GO TO 40
C
C     THIRD ORDER SINGULARITY
C
  410 IOK = 0
      DO 450 I = 1,NPTS
      IF (INDXMS(I) .NE. 0) GO TO 430
      IF (IAUTSP    .EQ. 0) GO TO 420
      IF (IEXCLD(I) .NE. 0) GO TO 420
      II     = IPONTS(I)
      IZ(II) = MSKSNG
      NAUTO  = NAUTO + 1
      ISPC   = ISPC  + 1
      JPONTS(ISPC) = II
      GO TO 440
  420 IOK = 1
      GO TO 450
  430 IMS   = IMS   + 1
  440 IORDR = IORDR - 1
      IPONTS(I) = 0
  450 CONTINUE
      IF (IOK .EQ. 1) GO TO 460
      LOGIC = 200
      IF (ISPC+IMS .NE. 3) GO TO 750
      IF (ISPC     .EQ. 0) GO TO 10
      GO TO 40
  460 IOK = 0
      DO 470 I = 1,NPTS
      IF (IPONTS(I) .EQ. 0) GO TO 470
      IOK = IOK + 1
      IPONTS(IOK) = IPONTS(I)
      IF (IOK .NE. I) IPONTS(I) = 0
  470 CONTINUE
      NPTS = IOK
      GO TO 40
C
  480 CALL CLOSE (GPST,1)
      IF (IOGPST .NE. 1) GO TO 490
      CALL CLOSE (OGPST,1)
      IF (IERROR .NE. 0) GO TO 490
      CALL MAKMCB (OGPST1,OGPST,0,0,0)
      OGPST1(2) = 8
      CALL WRTTRL (OGPST1)
  490 IF (IAUTSP .EQ. 0) GO TO 610
      IF (NAUTO  .GT. 0) GO TO 500
      LOGIC = 210
      IF (ISCR2  .EQ. 1) GO TO 750
      IF (IOGPST.EQ.1 .AND. INDEX.LT.3) WRITE (IOUTPT,810) UWM
      IF (IOGPST.EQ.1 .AND. INDEX.EQ.3) WRITE (IOUTPT,815) UWM
      GO TO 610
  500 LOGIC = 220
      IF (ISCR2 .NE. 1) GO TO 750
      CALL WRITE (SCR2,0,0,1)
      CALL CLOSE (SCR2,1)
      IF (IERROR .NE. 0) GO TO 610
      IF (IOGPST .NE. 1) WRITE (IOUTPT,800) UIM
      IF (IOGPST .EQ. 1) WRITE (IOUTPT,805) UIM
      IF (IOGPST.EQ.1 .AND. INDEX.LT.3) WRITE (IOUTPT,820) UWM
      IF (IOGPST.EQ.1 .AND. INDEX.EQ.3) WRITE (IOUTPT,825) UWM
C
C     PRINT OUT AND, IF REQUESTED, PUNCH OUT
C     AUTOMATICALLY GENERATED SPC DATA CARDS
C
      CALL GOPEN (SCR2,IZ(IBUF3),0)
      IFILE = SCR2
      CALL READ (*700,*510,SCR2,IZ(LUSET+1),IBUF3-LUSET,0,IFLAG)
      ICORE = LUSET + 2*NAUTO - IBUF3
      GO TO 720
  510 LOGIC = 230
      IF (IFLAG .NE. 2*NAUTO) GO TO 750
      CALL SORT (0,0,2,1,IZ(LUSET+1),IFLAG)
      I    = LUSET + 1
      IOLD = -1
      IST  = I
  520 J = 0
  530 IF (I .GT. LUSET+IFLAG) GO TO 540
      IF (IOLD.GE.0 .AND. IZ(I).NE.IOLD) GO TO 540
      IOLD = IZ(I)
      J = J + 2
      I = I + 2
      GO TO 530
  540 CALL SORT (0,0,2,-2,IZ(IST),J)
      IF (I .GT. LUSET+IFLAG) GO TO 550
      IOLD = IZ(I)
      IST  = I
      GO TO 520
C
  550 I = LUSET + 1
      IOLD = -1
      CALL PAGE1
      WRITE (IOUTPT,830)
      LINE = LINE + 6
  560 II = 2
      DO 570 J = 1,6
      IF (I .GT. LUSET+IFLAG) GO TO 580
      IF (IOLD.GE.0 .AND. IZ(I).NE.IOLD) GO TO 580
      IOLD = IZ(I)
      IWORD(II+1) = IZ(I+1)
      II = II + 1
      I  = I  + 2
  570 CONTINUE
  580 IWORD(2) = IOLD
      IF (LINE .LE. NLPP) GO TO 590
      CALL PAGE1
      WRITE (IOUTPT,830)
      LINE = LINE + 6
  590 NCARD = NCARD + 1
      WRITE (IOUTPT,840) NCARD,(IWORD(J),J=1,II)
      LINE = LINE + 1
      IF (IAUTSP .LT. 0) WRITE (IPUNCH,850) (IWORD(J),J=1,II)
      IF (I .GT. LUSET+IFLAG) GO TO 600
      IOLD = IZ(I)
      GO TO 560
  600 CALL CLOSE (SCR2,1)
  610 IF (IAUTSP.EQ.0 .OR. MULTI.EQ.0) RETURN
      DO 620 I = 1,LUSET
      IZ(I) = ANDF(IZ(I),MSKXX)
  620 CONTINUE
      RETURN
C
C     ERROR MESSAGES
C
  700 NUM = -2
  710 CALL MESAGE (NUM,IFILE,ISUBNM)
  720 NUM = -8
      IFILE = ICORE
      GO TO 710
  730 IERROR = 1
      WRITE (IOUTPT,870) UWM
      GO TO 480
  740 IERROR = 2
      WRITE (IOUTPT,880) UWM
      GO TO 480
  750 WRITE (IOUTPT,860) SFM,LOGIC
      CALL MESAGE (-61,0,0)
C
  800 FORMAT (A29,' 2435, AT USER''S REQUEST, ALL POTENTIAL ',
     1        'SINGULARITIES HAVE BEEN REMOVED BY THE', /5X,
     2        'APPLICATION OF SINGLE POINT CONSTRAINTS.  REFER TO PRINT'
     3,       'OUT OF AUTOMATICALLY GENERATED SPC1 CARDS FOR DETAILS.')
  805 FORMAT (A29,' 2436, AT USER''S REQUEST, ONE OR MORE POTENTIAL ',
     1        'SINGULARITIES HAVE BEEN REMOVED BY THE', /5X,
     2        'APPLICATION OF SINGLE POINT CONSTRAINTS.  REFER TO PRINT'
     3,       'OUT OF AUTOMATICALLY GENERATED SPC1 CARDS FOR DETAILS.')
  810 FORMAT (A25,' 2437A, IN SPITE OF THE USER''S REQUEST, NONE OF ',
     1        'THE POTENTIAL SINGULARITIES HAS BEEN REMOVED', /5X,
     2        'BECAUSE OF THG PRESENCE OF SUPORT CARDS AND/OR MULTI',
     3        'POINT CONSTRAINTS OR RIGID ELEMENTS.', /5X,
     4        'REFER TO THE GRID POINT SINGULARITY TABLE FOR DETAILS.')
  815 FORMAT (A25,' 2437A, IN SPITE OF THE USER''S REQUEST, NONE OF ',
     1        'THE POTENTIAL SINGULARITIES HAS BEEN REMOVED', /5X,
     2        'BECAUSE OF THG PRESENCE OF SUPORT CARDS AND/OR MULTI',
     3        'POINT CONSTRAINTS OR RIGID ELEMENTS', /5X,'OR BECAUSE ',
     4        'THE SINGULARITIES ARE NOT PART OF THE OMIT SET (O-SET) ',
     5        'DEGREES OF FREEDOM.', /5X,
     2        'REFER TO THE GRID POINT SINGULARITY TABLE FOR DETAILS.')
  820 FORMAT (A25,' 2437, ONE OR MORE POTENTIAL SINGULARITIES HAVE NOT',
     1        ' BEEN REMOVED', /5X,'BECAUSE OF THG PRESENCE OF SUPORT ',
     2        'CARDS AND/OR MULTIPOINT CONSTRAINTS OR RIGID ELEMENTS.',
     2    /5X,'REFER TO THE GRID POINT SINGULARITY TABLE FOR DETAILS.')
  825 FORMAT (A25,' 2437, ONE OR MORE POTENTIAL SINGULARITIES HAVE NOT',
     1        ' BEEN REMOVED', /5X,'BECAUSE OF THG PRESENCE OF SUPORT ',
     2        'CARDS AND/OR MULTIPOINT CONSTRAINTS OR RIGID ELEMENTS',
     3        /5X,'OR BECAUSE THE SINGULARITIES ARE NOT PART OF THE ',
     4        'OMIT SET (O-SET) DEGREES OF FREEDOM.', /5X,
     2        'REFER TO THE GRID POINT SINGULARITY TABLE FOR DETAILS.')
  830 FORMAT (//32X, 'A U T O M A T I C A L L Y   ',
     1               'G E N E R A T E D   ',
     2               'S P C 1   C A R D S', /,
     3        16X, 'CARD ',8X, /,
     4        16X, 'COUNT',8X,
     5             '---1--- +++2+++ ---3--- +++4+++ ---5--- ',
     6             '+++6+++ ---7--- +++8+++ ---9--- +++10+++',/)
  840 FORMAT (15X, I5, '-', 8X, 'SPC1    ',8I8)
  850 FORMAT (                  'SPC1    ',8I8)
  860 FORMAT (A25,' 2438, LOGIC ERROR NO.',I4,
     1       ' IN SUBROUTINE GP4SP IN MODULE GP4')
  870 FORMAT (A25,' 2439, ILLEGAL VALUE INPUT FOR PARAMETER AUTOSPC - ',
     1       'SINGULARITY PROCESSING SKIPPED IN MODULE GP4')
  880 FORMAT (A25,' 2440, SINGULARITY PROCESSING SKIPPED IN MODULE GP4',
     1       ' BECAUSE OF INCONSISTENT SET DEFINITION')
C
      RETURN
      END

      SUBROUTINE CTRNSP (IX,X,NX,FILEA,B,SR1FIL)
C
C     TRANS WILL DO AN INCORE TRANSPOSE OF THE UPPER TRIANGLE OF ACTIVE
C     ELEMENTS
C
      EXTERNAL           LSHIFT    ,RSHIFT   ,ORF      ,COMPLF
      INTEGER            B         ,FILEA    ,SR1FIL   ,TYPEA    ,
     1                   EOL       ,SYSBUF   ,ORF      ,LSHIFT   ,
     2                   NAME(2)   ,RSHIFT   ,RDP      ,EOR      ,
     3                   CDP       ,COMPLF
      DOUBLE PRECISION   DI(2)
      DIMENSION          FILEA(7)  ,IX(1)    ,III(6)   ,X(1)
      COMMON   /MACHIN/  MACH      ,IHALF
      COMMON   /ZNTPKX/  IA(4)     ,II       ,EOL      ,EOR
      COMMON   /SYSTEM/  SYSBUF
      COMMON   /NAMES /  RD        ,RDREW    ,WRT      ,WRTREW   ,
     1                   REW       ,NOREW    ,EOFNRW   ,RSP      ,
     2                   RDP       ,CSP      ,CDP
      COMMON   /TYPE  /  JPREC(2)  ,NWDS(4)
      EQUIVALENCE        (III(3),DI(1))
      DATA      NAME /   4HCTRN ,4HSP  /
C
C
      NUM   = RSHIFT(COMPLF(0),1)
      IOBUF = NX - 4*SYSBUF
      IFILE = FILEA(1)
C
C     POSITION INPUT FILE AT START OF THE UPPER TRIANGLE
C
      CALL SKPREC (FILEA(1),B+1)
      TYPEA = FILEA(5)
      NCOL  = FILEA(2)
      NO    = 0
      ISTOR = 1
      IPREC = JPREC(TYPEA)
      INCR  = NWDS(TYPEA) + 1
      K     = 1
   20 CALL INTPK (*70,FILEA(1),0,TYPEA,0)
   30 CALL ZNTPKI
      IF (II .GT. K) GO TO 50
C
C     PACK I AND J IN ONE WORD AND STORE IT AND THE NONZERO VALUE
C     IN CORE
C
      L  = ORF(LSHIFT(II,IHALF),K+B)
      NO = NO + 1
      IX(ISTOR  ) = L
      IX(ISTOR+1) = IA(1)
      IX(ISTOR+2) = IA(2)
      IX(ISTOR+3) = IA(3)
      IX(ISTOR+4) = IA(4)
      ISTOR = ISTOR+INCR
      IF (ISTOR+INCR .GT. IOBUF) GO TO 140
      IF (EOL) 70,30,70
   50 IF (EOR .EQ. 0) CALL SKPREC (FILEA(1),1)
   70 K = K + 1
      IF (K+B .LE. NCOL) GO TO 20
      CALL REWIND (FILEA(1))
C
C     ALL ELEMENTS ARE IN CORE.  WRITE THEM OUT IN THE TRANSPOSED ORDER
C
      IFILE = SR1FIL
      CALL OPEN (*120,SR1FIL,IX(IOBUF),WRTREW)
      ISTOR = ISTOR - INCR
      DO 110 I = 1,NO
      K = NUM
      DO 80 J = 1,ISTOR,INCR
      IF (IX(J) .GT. K) GO TO 80
      KK = J
      K  = IX(J)
   80 CONTINUE
C
C     UNPACK I AND J, AND WRITE OUT I,J,AND A(I,J)
C
      III(1) = RSHIFT(K,IHALF)
      III(2) = K - LSHIFT(III(1),IHALF)
      IX(KK) = NUM
      IF (IPREC .EQ. 2) GO TO 90
      DI(1) = X(KK+1)
      DI(2) = 0.D0
      IF (TYPEA .GT. 2) DI(2) = X(KK+2)
      GO TO 100
   90 III(3) = IX(KK+1)
      III(4) = IX(KK+2)
      III(5) = 0
      III(6) = 0
      IF (TYPEA .LE. 2) GO TO 100
      III(5) = IX(KK+3)
      III(6) = IX(KK+4)
  100 CONTINUE
      CALL WRITE (SR1FIL,III(1),6,0)
      IF (KK .EQ. ISTOR) ISTOR = ISTOR - INCR
  110 CONTINUE
C
C     WRITE A TRAILER RECORD ON THE FILE
C
      III(1) = -1
      CALL WRITE (SR1FIL,III(1),6,0)
      CALL CLOSE (SR1FIL,REW)
      RETURN
C
  120 NO = -1
      GO TO 150
  140 NO = -8
  150 CALL MESAGE (NO,IFILE,NAME)
      RETURN
      END

      SUBROUTINE LINEIN(X1,Y1,Z1,X2,Y2,Z2,HCDL)
C
C PERFORMS LINE INTEGRAL FROM (X1,Y1,Z1) TO (X2,Y2,Z2) OF BIOT-SAVART
C FILED DOTTED INTO THE LINE, IE INT(HC.DL)
C
      DIMENSION XI(4),W(4)
      DATA XI/.06943184,.33000948,.66999052,.93056816/
      DATA W/.17392742,2*.32607258,.173927423/
C
C COMPONENTS OF LINE SEGMENT
C
      HCDL=0.
      SEGX=X2-X1
      SEGY=Y2-Y1
      SEGZ=Z2-Z1
      SEGL=SQRT(SEGX**2+SEGY**2+SEGZ**2)
      IF(SEGL.EQ.0.)RETURN
C
C 4 POINT INTEGRATION OVER LINE SEGMENT(XI= / TO +1)
C
      DO 10 I=1,4
      XX=X1+SEGX*XI(I)
      YY=Y1+SEGY*XI(I)
      ZZ=Z1+SEGZ*XI(I)
      CALL BIOTSV(XX,YY,ZZ,HCX,HCY,HCZ)
      HCDL=HCDL+(HCX*SEGX+HCY*SEGY+HCZ*SEGZ)*W(I)
   10 CONTINUE
      RETURN
      END

      SUBROUTINE INVP2 (*)
C
C     INVP2 INITIALIZES THEN CALLS EITHER SDCOMP OR DECOMP DEPENDING ON
C     THE OPTION SELECTED ON THE EIGR CARD
C
      INTEGER            FILEA     ,FILEL    ,FILEU    ,SCR1     ,
     1                   SCR2      ,SCR3     ,SCR4     ,SCR5     ,
     2                   SR1FIL    ,SR2FIL   ,DUM      ,SCR6     ,
     3                   RDP       ,UPRTRI   ,
     4                   SWITCH    ,SCR7     ,SCR8     ,OPTION   ,
     5                   OPT2      ,PREC     ,Q(1)
      DOUBLE PRECISION   DET       ,DETDET   ,DETC     ,MINDD
      COMMON   /SFACT /  FILEA(7)  ,FILEL(7) ,FILEU(7) ,SR1FIL   ,
     1                   SR2FIL    ,NZ       ,DET      ,DETC     ,
     2                   POWER     ,ISR3FL   ,MINDD    ,ICHL
      COMMON   /INVPXX/  DUMM(12)  ,SWITCH
      COMMON   /INVPWX/  DUM(14)   ,SCR1(7)  ,SCR2(7)  ,SCRX     ,
     1                   SCRXX     ,SCR3     ,SCR4     ,SCR5     ,
     2                   SCR6      ,SCR7     ,SCR8
      COMMON   /NAMES /  IJ(8)     ,RDP      ,IK(5)    ,LOWTRI   ,
     1                   UPRTRI
      COMMON   /DCOMPX/  IA(7)     ,IL(7)    ,IU(7)    ,ISCR1    ,
     1                   ISCR2     ,ISCR3    ,DETDET   ,IPOWR    ,
     2                   MZ        ,MIND
      COMMON   /SYSTEM/  KSYSTM(63)
      COMMON   /REIGKR/  OPTION
      COMMON   /ZZZZZZ/  Z(1)
      EQUIVALENCE        (Q(1),Z(1))
      EQUIVALENCE        (KSYSTM(55),PREC)
      DATA      OPT2  /  4HUINV/
C
      FILEA(1) = SCR1(1)
      IF (SWITCH .EQ. 1) GO TO 10
      FILEL(1) = SCR2(1)
      FILEU(1) = SCR3
      GO TO 20
   10 FILEL(1) = SCR7
      FILEU(1) = SCR8
   20 CONTINUE
      SR1FIL   = SCR4
      SR2FIL   = SCR5
      ISR3FL   = SCR6
      ICHL     = 0
      FILEA(2) = DUM(2)
      FILEA(3) = DUM(3)
      FILEA(4) = DUM(4)
      FILEA(5) = PREC
      FILEA(6) = 0
      FILEA(7) = 0
      FILEL(5) = PREC
      IF (OPTION .EQ. OPT2) GO TO 40
C
C     SYMMETRIC DECOMPOSITION SELECTED.
C
      NZ       = KORSZ(Z)
      CALL SDCOMP (*30,Z,Z,Z)
      FILEL(3) = FILEL(2)
      FILEL(4) = LOWTRI
      CALL WRTTRL (FILEL)
      RETURN
   30 RETURN 1
C
C     UNSYMMETRIC DECOMPOSITION SELECTED.
C
   40 DO 50 I = 1,21
      IA(I) = FILEA(I)
   50 CONTINUE
      ISCR1 = SCR4
      ISCR2 = SCR5
      ISCR3 = SCR6
      MZ    = KORSZ(Q)
      CALL DECOMP (*30,Q,Q,Q)
      IL(3) = IL(2)
      IL(4) = LOWTRI
      CALL WRTTRL (IL)
      IU(3) = IU(2)
      IU(4) = UPRTRI
      IU(5) = IL(5)
      CALL WRTTRL (IU)
      RETURN
      END

      SUBROUTINE AMPC (DJH1,DJH2,DJH,AJJL,QJH,QJHO,QJHUA,SCR1,SCR2,SCR3,
     1                 SCR4,SCR5,SCR6)
C
C     THE PURPOSE OF THIS ROUTINE IS TO COMPUTE (OR RETRIEVE QJH)
C
C     IF QJH MUST BE COMPUTED
C
C     1. FORM DJH FOR THIS K (IF IDJH.EQ.0)
C        DJH = DJH1 + I*K*DJH2
C     2. FOR EACH CONSTANT THEORY
C        A. RETRIEVE AJJ PORTION = AJJTH
C        B. PERFORM THEORY FOR QJH
C           1) DOUBLET LATTICE
C              A) DECOMPOSE AJJTH
C              B) FIND PROPER DJH PORTION DJHTH
C              C) FBS FOR QJHTH
C              D) ADD TO BOTTOM OF QJHUA(CYCLE)
C           6) COMPRESSOR BLADES  (IONCE = 1).
C              A) COMPUTE QJHTH = (AJJ)*DJH.
C              B) QJHUA = QJHTH SINCE ONLY ONE BLADE AND GROUP (NGP = 1)
C           7) SWEPT TURBOPROPS   (IONCE = 1).
C              A) COMPUTE QJHTH = (AJJ)*DJH.
C              B) QJHUA = QJHTH SINCE ONLY ONE BLADE AND GROUP (NGP = 1)
C
      INTEGER         DJH1,DJH2,DJH,AJJL,QJH,QJHO,QJHUA,AJJCOL,QHHCOL,
     1                SYSBUF,FILE,NAME(2),IBLOCK(11),MCB(7),SCR1,SCR2,
     2                SCR3,SCR4,SCR5,SCR6,QJHTH
      REAL            BLOCK(11)
      COMMON /AMPCOM/ NCOLJ,NSUB,XM,XK,AJJCOL,QHHCOL,NGP,NGPD(2,30),
     1                MCBQHH(7),MCBQJH(7),NOH,IDJH
      COMMON /SYSTEM/ SYSBUF,NOUT,SKP(52),IPREC
      COMMON /ZZZZZZ/ IZ(1)
      COMMON /UNPAKX/ ITC,II,JJ,INCR
      COMMON /PACKX / ITC1,ITC2,II1,JJ1,INCR1
      COMMON /CDCMPX/ DUM32(32),IB
      EQUIVALENCE     (IBLOCK(1),BLOCK(1))
      DATA    NAME  / 4HAMPC,4H    /
      DATA    IBLOCK(1),IBLOCK(7),BLOCK(2),BLOCK(3),BLOCK(8) /
     1                3,        3,     1.0,      0.,      0. /
C
C     INITIALIZE
C
      IBUF1 = KORSZ(IZ) - SYSBUF + 1
      IBUF2 = IBUF1 - SYSBUF
      ITC   = MCBQHH(5)
      INCR  = 1
      ITC1  = ITC
      ITC2  = ITC1
      INCR1 = INCR
      II1   = 1
C
C     IS QJH ON SAVE FILE
C
      IF (QHHCOL .EQ. 0) GO TO 100
C
C     COPY QJH FROM OLD FILE TO QJH
C
      IF (MCBQJH(1) .LE. 0) GO TO 10
      CALL GOPEN (QJHO,IZ(IBUF1),0)
      CALL GOPEN (QJH, IZ(IBUF2),3)
      K = QHHCOL - 1
      IF (K .EQ. 0) GO TO 20
      FILE = QJHO
      DO 30 I = 1,K
      CALL FWDREC (*910,QJHO)
   30 CONTINUE
   20 CONTINUE
      CALL CYCT2B (QJHO,QJH,NOH,IZ,MCBQJH)
      CALL CLOSE (QJHO,1)
      CALL CLOSE (QJH,3)
   10 CONTINUE
      RETURN
C
C     COMPUTE QJH
C
  100 CONTINUE
C
C     HAS DJH ALREADY BEEN COMPUTED
C
      IF (IDJH .NE. 0) GO TO 110
      BLOCK(9) = XK
      CALL SSG2C (DJH1,DJH2,DJH,1,BLOCK)
C
C     POSITION AJJL
C
  110 CALL GOPEN (AJJL,IZ(IBUF1),0)
      K = AJJCOL - 1
      IF (K .EQ. 0) GO TO 120
      FILE = AJJL
      DO 130 I = 1,K
      CALL FWDREC (*910,AJJL)
  130 CONTINUE
  120 CONTINUE
      CALL CLOSE (AJJL,2)
C
C     SET UP TO LOOP ON CONSTANT THEORY
C
      NGPS = 1
      NTH  = NGPD(1,NGPS)
      NCOLTH = 0
  135 NCLOLD = NCOLTH + 1
  140 IF (NGPS .GT. NGP) GO TO 150
      IF (NGPD(1,NGPS) .NE. NTH) GO TO 150
      NCOLTH = NCOLTH + NGPD(2,NGPS)
      NGPS   = NGPS + 1
      GO TO 140
C
C     BRANCH ON THEORY
C
  150 CONTINUE
      IONCE = 0
      IF (NCLOLD.EQ.1 .AND. NGPS.GT.NGP) IONCE = 1
C
C     COPY AJJL TO SCR1
C
      CALL GOPEN (AJJL,IZ(IBUF1),2)
      CALL GOPEN (SCR1,IZ(IBUF2),1)
      MCB(1) = AJJL
      CALL RDTRL (MCB)
      MCB(1) = SCR1
      MCB(2) = 0
      MCB(3) = NCOLTH
      MCB(6) = 0
      MCB(7) = 0
      II     = NC LOLD
      JJ     = NCOLTH
      II1    = 1
      JJ1    = NCOLTH - NC LOLD + 1
      ITC    = MCB(5)
      ITC1   = ITC
      ITC2   = ITC
      INCR   = 1
      INCR1  = 1
      CALL AMPC1 (AJJL,SCR1,NCOLTH,IZ,MCB)
      CALL CLOSE (AJJL,2)
      CALL CLOSE (SCR1,1)
      CALL WRTTRL (MCB)
      GO TO (1000,2000,3000,4000,5000,6000,7000), NTH
C
C     DOUBLET LATTICE WITH SLENDER BODIES
C
 1000 CONTINUE
 2000 CONTINUE
C
C     TRANSPOSE MATRIX
C
      CALL TRANP1 (SCR1,SCR4,4,SCR2,SCR3,SCR5,SCR6,0,0,0,0)
C
C     DECOMPOSE MATRIX
C
      IB = 0
      CALL CFACTR (SCR4,SCR2,SCR3,SCR1,SCR5,SCR6,IOPT)
C
C     MACH BOX
C     PISTON
C
C
C     COMPRESSOR BLADE AND SWEPT TURBOPROP THEORIES -
C     ONE BLADE ALLOWED, ONE GROUP, USE WHOLE AJJ AND DJH MATRICES.
C
 3000 CONTINUE
 4000 CONTINUE
 5000 CONTINUE
 6000 CONTINUE
 7000 CONTINUE
C
C     COPY PROPER ROWS OF DJH TO SCR4
C
      IDJHA = DJH
      IF (IONCE .NE. 0) GO TO 1010
      II  = NC LOLD
      JJ  = NCOLTH
      II1 = 1
      JJ1 = NCOLTH-NC LOLD+1
      MCB(1) = DJH
      CALL RDTRL (MCB)
      ITC  = MCB(5)
      ITC1 = ITC
      ITC2 = ITC
      INCR = 1
      INCR1  = 1
      MCB(2) = 0
      MCB(3) = JJ1
      MCB(6) = 0
      MCB(7) = 0
      MCB(1) = SCR4
      CALL GOPEN (DJH,IZ(IBUF1),0)
      CALL GOPEN (SCR4,IZ(IBUF2),1)
      CALL AMPC1 (DJH,SCR4,NOH,IZ,MCB)
      CALL CLOSE (DJH,1)
      CALL CLOSE (SCR4,1)
      CALL WRTTRL (MCB)
      IDJHA = SCR4
 1010 CONTINUE
      QJHTH = SCR5
      IF (IONCE .NE. 0) QJHTH = QJHUA
      GO TO (1001,2001,3001,4001,5001,6001,7001), NTH
 1001 CONTINUE
 2001 CONTINUE
C
C     SOLVE FOR THIS PORTION OF QJH
C
      CALL CFBSOR (SCR2,SCR3,IDJHA,QJHTH,IOPT)
 1020 CONTINUE
C
C     COPY ACCUMULATIVELY ONTO QJHUA
C
      IF (IONCE .NE. 0) GO TO 8000
      CALL AMPC2 (SCR5,QJHUA,SCR1)
      IF (NGPS .GT. NGP) GO TO 8000
      GO TO 135
C
C     COMPUTE THIS PORTION OF QJH  = AJJ*DJH
C
 3001 CONTINUE
 4001 CONTINUE
 5001 CONTINUE
 6001 CONTINUE
 7001 CONTINUE
      CALL SSG2B (SCR1,IDJHA,0,QJHTH,0,IPREC,1,SCR6)
      GO TO 1020
C
C     ALL GROUPS / THEORIES COMPLETE
C
 8000 CONTINUE
      GO TO 10
C
C     ERROR MESSAGES
C
  901 CALL MESAGE (IP1,FILE,NAME)
  910 IP1 = -2
      GO TO 901
      END

      SUBROUTINE AMGT1B (Q,NSTNS2,C1SBAR,C2SBAR)        
C        
C      SUBSONIC RAO (CASCADES) CODE FOR SWEPT TURBOPROPS.        
C        
      INTEGER         SLN        
      REAL            M,KAPPA,MU,MUS,LAMDA,LAMDM,NU,X(20),DISP(20,10),  
     1                W(8),WW(8),M2SBAR        
      COMPLEX         Q(NSTNS2,NSTNS2),LOADS(21),STT(20),SUM1,SUM2,STTI,
     1                AN(401),AB(401),FK(401),CN(401),CB(401),PD(401),  
     2                SO(100),S1(100),P(50),A(20,40),FF,ST,STP,FG,FS,FO,
     3                SLOPE        
      CHARACTER       UFM*23        
      COMMON /XMSSG / UFM        
      COMMON /TAMG1L/ IREF,MINMAC,MAXMAC,NLINES,NSTNS,REFSTG,REFCRD,    
     1                REFMAC,REFDEN,REFVEL,REFSWP,SLN,NSTNSX,STAG,      
     2                CHORD,DCBDZB,BSPACE,MACH,DEN,VEL,SWEEP,AMACH,     
     3                REDF,BLSPC,AMACHR,TSONIC        
      COMMON /AMGMN / MCB(7),NROW,DUM(2),REFC,SIGMA,RFREQ        
      COMMON /SYSTEM/ IBUF,IOUT        
      DATA    W     / 1.48283,  .89414, .83521,  .66721,        
     1                 .64172,  .55519, .54026,  .48547 /        
      DATA    WW    / 1.13333,-0.00036,0.18796,-0.00027,        
     1                0.08469,-0.00022,0.05049,-0.00019 /        
C        
C     THEORY DEPENDENT RESTRICTION OF NO MORE THAN 10 COMPUTING        
C     STATIONS PER STREAMLINE IS REFLECTED IN CODING.        
C        
      IF (NSTNS .GT. 10) GO TO 1000        
C        
      M      = AMACH        
      OMEGA  = REDF        
      SS     = 2*BLSPC        
      DELTM  =-SIGMA        
      XLAM   = STAG        
      NM     = NSTNS        
      NNM    = NSTNS2        
      CSBAR  = .25*(DEN*VEL**2*CHORD**2)/(REFDEN*REFVEL**2)        
      CSBAR1 = 2.0/CHORD        
      M2SBAR =-DCBDZB/CHORD        
      C2SSCH = CSBAR1*C2SBAR        
      CSBLSB = CSBAR*CSBAR1        
      CSBM2S = CSBAR*M2SBAR        
      N      = 20        
      PI     = 3.141593        
      PI2    = PI*2        
      CON    = 1.0E-5        
      NNN    = 100        
      KKK    = 2*NNN + 1        
      DELTM  = DELTM/360        
      XL     = XLAM*PI/180        
      B      = 1.0/N        
      B2     = 2*B        
      D      = SS*SIN(XL)        
      HH     = SS*COS(XL)        
      BETA   = SQRT(1. - M**2)        
      H      = HH*BETA        
      ZER    = 0.0        
      S      = SQRT(H**2 + D**2)        
      LAMDM  = ATAN(D/H)        
      CL     = COS(LAMDM)        
      SL     = SIN(LAMDM)        
      NU     = OMEGA/BETA**2        
      KAPPA  = M*NU        
      LAMDA  = M*KAPPA        
      DELTA  = DELTM + LAMDA*D/PI2        
      MU     = KAPPA*S/PI2        
      MUS    = MU**2        
      FF     = (0.0,1.0)        
      FG     = CMPLX(ZER,NU*S)        
      L      = 1        
      CC     = DELTA**2 - MUS        
      IF (CC .EQ. 0.0) GO TO 200        
      IF (CC .LT. 0.0) FK(L) = SQRT(-CC)*FF        
      IF (CC .GT. 0.0) FK(L) = SQRT(CC)        
      AN(L)  = FK(L)*CL + FF*DELTA*SL        
      AB(L)  = FK(L)*CL - FF*DELTA*SL        
      PD(L)  = FK(L)*(PI2*AB(L) + FG)        
      CK     = PI2*B/S        
      CN(L)  = CEXP(-AN(L)*CK)        
      CB(L)  = CEXP(-AB(L)*CK)        
      DO 20 I = 1,NNN        
      L      = L + 1        
      CC     = (DELTA+I)**2 - MUS        
      IF (CC .EQ. 0.0) GO TO 200        
      IF (CC .LT. 0.0) FK(L) = SQRT(-CC)*FF        
      IF (CC .GT. 0.0) FK(L) = SQRT(CC)        
      AN(L)  = FK(L)*CL + (DELTA+I)*FF*SL        
      AB(L)  = FK(L)*CL - (DELTA+I)*FF*SL        
      PD(L)  = FK(L)*(PI2*AB(L) + FG)        
      CN(L)  = CEXP(-AN(L)*CK)        
      CB(L)  = CEXP(-AB(L)*CK)        
      L      = L + 1        
      CC     = (DELTA-I)**2 - MUS        
      IF (CC .EQ. 0.0) GO TO 200        
      IF (CC .GT. 0.0) FK(L) = SQRT(CC)        
      IF (CC .LT. 0.0) FK(L) = SQRT(-CC)*FF        
      AN(L)  = FK(L)*CL + (DELTA-I)*FF*SL        
      AB(L)  = FK(L)*CL - (DELTA-I)*FF*SL        
      PD(L)  = FK(L)*(PI2*AB(L) + FG)        
      CN(L)  = CEXP(-AN(L)*CK)        
      CB(L)  = CEXP(-AB(L)*CK)        
   20 CONTINUE        
      STP    = 0.0        
      L      = 1        
      ST     = ((1-CN(L))/AN(L) + (1-CB(L))/AB(L))/FK(L)        
      DO 25 I = 2,KKK,2        
      L      = I        
      ST     = ((1-CN(L))/AN(L) + (1-CB(L))/AB(L))/FK(L) + ST        
      L      = L + 1        
      ST     = ((1-CN(L))/AN(L) + (1-CB(L))/AB(L))/FK(L) + ST        
      IF (CABS(ST-STP) .LT. CON) GO TO 30        
      STP    = ST        
   25 CONTINUE        
   30 CONTINU E        
      SO(1)  =-ST*S/(2*PI2*B2)        
      DO 40 J = 2,N        
      JK     = 2*(J-1)        
      L      = 1        
      STP    = 0.0        
      ST     = CN(L)**JK/FK(L)        
      DO 32 I = 2,KKK,2        
      L      = L + 1        
      ST     = CN(L)**JK/FK(L) + ST        
      L      = L + 1        
      ST     = CN(L)**JK/FK(L) + ST        
      IF (CABS(ST-STP) .LT. CON) GO TO 35        
   32 STP    = ST        
   35 SO(J)  =-0.5*ST        
   40 CONTINUE        
      N1     = N + 1        
      N2     = 3*N - 1        
      DO 50 J = N1,N2        
      JK     = J - N        
      STP    = 0.0        
      L      = 1        
      ST     = CB(L)**JK/FK(L)        
      DO 42 I = 2,KKK,2        
      L      = L + 1        
      ST     = CB(L)**JK/FK(L) + ST        
      L      = L + 1        
      ST     = CB(L)**JK/FK(L) + ST        
      IF (CABS(ST-STP) .LT. CON) GO TO 45        
   42 STP    = ST        
   45 SO(J)  =-0.5*ST        
   50 CONTINUE        
      DO 55 J = 1,N        
      JK     = (J-1)*2 + 1        
      L      = 1        
      STP    = 0.0        
      ST     = AN(L)*CN(L)**JK/FK(L)        
      DO 52 I = 2,KKK,2        
      L      = L + 1        
      ST     = AN(L)*CN(L)**JK/FK(L) + ST        
      L      = L + 1        
      ST     = AN(L)*CN(L)**JK/FK(L) + ST        
      IF (CABS(ST-STP) .LT. CON) GO TO 54        
      STP    = ST        
   52 CONTINUE        
   54 S1(J)  =-PI/S*ST        
   55 CONTINUE        
      N1     = N + 1        
      N2     = 2*N        
      DO 60 J = N1,N2        
      JK     = (J-N1)*2 + 1        
      L      = 1        
      STP    = 0.0        
      ST     = AB(L)*CB(L)**JK/FK(L)        
      DO 57 I = 2,KKK,2        
      L      = L + 1        
      ST     = AB(L)*CB(L)**JK/FK(L) + ST        
      L      = L + 1        
      ST     = AB(L)*CB(L)**JK/FK(L) + ST        
      IF (CABS(ST-STP) .LT. CON) GO TO 59        
      STP    = ST        
   57 CONTINUE        
   59 S1(J)  = PI/S*ST        
   60 CONTINUE        
      DO 64 J = 1,N        
      JK     = (J-1)*2 + 1        
      L      = 1        
      STP    = 0.0        
      ST     = CB(L)**JK/PD(L)        
      DO 61 I = 2,KKK,2        
      L      = L + 1        
      ST     = CB(L)**JK/PD(L) + ST        
      L      = L + 1        
      ST     = CB(L)**JK/PD(L) + ST        
      IF (CABS(ST-STP) .LT. CON) GO TO 62        
      STP    = ST        
   61 CONTINUE        
   62 P(J)   =-S/2*ST        
   64 CONTINUE        
      FG     = CMPLX(ZER,-NU*B)        
      FG     = 1/(CEXP(FG) + CMPLX(ZER,NU*B2))        
      FS     = CMPLX(ZER,NU)        
      CJ     = (NU*BETA)**2        
      L      = 0        
      CT     = 2*KAPPA**2*B        
      DO 70 J = 1,N        
      DO 70 I = 1,N        
      L      = L + 1        
      NK     = I - J + 1        
      NK1    = I - J        
      NK2    = NK1 + 1        
      IF (I .EQ. J) NK1 = N + 1        
      IF (I .EQ. J) NK2 = 1        
      IF (J .LE. I) GO TO 65        
      NK1    = N + J - I + 1        
      NK2    = NK1 - 1        
      NK     = N + 2*(J-I)        
   65 A(I,J) = S1(NK1) - S1(NK2) + CT*SO(NK)        
      IF (J .NE. N) GO TO 70        
      NK     = N + 2*(J-I) + 1        
      NK2    = J - I + 1        
      A(I,J) = A(I,J) - FG*(S1(NK1) + SO(NK)*FS + CJ*P(NK2))        
   70 CONTINUE        
      X(1)   =-1.0 + B        
      DO 81 I = 2,N        
   81 X(I)   = X(I-1) + B2        
      N1     = N  + NM        
      NN     = N1        
      NN1    = NN + NM        
      N1N    = N  - 1        
      N1M    = NM - 1        
      N11    = N  + 1        
      NN11   = NN + 1        
      N22    = N  + 2        
      NN22   = NN + 2        
      FO     = FF*OMEGA        
      TANLAM = TAN(SWEEP*PI/180.0)        
      DLSDZB = DCBDZB/2.0        
      TD     = TANLAM*DLSDZB        
      DO 75 I = 1,N        
      DISP(I,1) =-1.0        
      DISP(I,2) =-1.0 - X(I)        
      STT(I) = CEXP(-FF*LAMDA*X(I))*PI2/BETA        
      STTI   = STT(I)        
      A(I,N11 ) = STTI*DISP(I,1)*(FO+TD)        
      A(I,NN11) = STTI*DISP(I,1)*TANLAM        
      A(I,N22 ) = STTI*(DISP(I,2)*(FO+TD)-1.)        
   75 A(I,NN22) = STTI*DISP(I,2)*TANLAM        
      DO 83 JJ = 3,NM        
      NF     = N  + JJ        
      NNF    = NN + JJ        
      CON2   = PI*(JJ-2)/2        
      DO 83 I = 1,N        
      CON    = CON2*DISP(I,2)        
      DISP(I,JJ) = SIN(CON)        
      A(I,NF ) = STT(I)*(DISP(I,JJ)*(FO+TD)-CON2*COS(CON))        
   83 A(I,NNF) = STT(I)*DISP(I,JJ)*TANLAM        
CWKBR SPR93019 10/93 CALL GAUSS (A,N,NN1)        
      CALL GAUSS2 (A,N,NN1) 
      DO 95 J = 1,NNM        
      NF     = N + J        
      DO 84 I = 1, N        
   84 LOADS(I) = A(I,NF)        
C        
      SLOPE   = LOADS(2)/3./B        
      A(1,NF) = 2.*CEXP(LAMDA*FF*X(1))*(FF*NU*LOADS(1) + SLOPE)        
C        
      SLOPE   = (LOADS(N) - LOADS(N1N))/B2        
      A(N,NF) = 2.*CEXP(LAMDA*FF*X(N))*(FF*NU*LOADS(N) + SLOPE)        
C        
      DO 85 I = 2,N1N        
      SLOPE   = (LOADS(I+1) - LOADS(I-1))/4./B        
   85 A(I,NF) = 2.*CEXP(LAMDA*FF*X(I))*(FF*NU*LOADS(I) + SLOPE)        
   95 CONTINUE        
      DO 86 I = 1,N        
      A(I,1) = SQRT((1-X(I))/(1+X(I)))        
      DO 87 J = 2,N1M        
   87 A(I,J) =-DISP(I,J+1)        
      DO 86 J = NM,N        
      CON2   =-PI*(J-1)*DISP(I,2)/2        
   86 A(I,J) = SIN(CON2)        
CWKBR SPR93019 10/93      CALL GAUSS (A,N,NN1)        
      CALL GAUSS2 (A,N,NN1) 
      A(1,1) = C2SSCH*PI+C1SBAR*PI/2.        
      A(2,1) = (C2SSCH+C1SBAR)*PI/2.        
      CON    = 1.        
      CONN   = 1.        
      DO 88 J = 1,N1N        
      A(1,J+1) = (C2SSCH*CON+C1SBAR*CONN)*4./J/PI        
      A(2,J+1) = (C2SSCH+2.*C1SBAR)*CONN*4./J/PI-CON*C1SBAR*32./        
     1           (J*PI)**3        
      CON    = 1. - CON        
   88 CONN   =-CONN        
      DO 90 I = 3,NM        
      IR     = I - 2        
      DO 90 J = 2,N        
      IS     = J - 1        
      IF (IR .EQ. IS) GO TO 901        
      IF ((IR+IS)/2*2.EQ.(IR+IS)) GO TO 902        
      A(I,J) =-C1SBAR*16.*IR*IS/(PI*(IR+IS)*(IR-IS))**2        
      GO TO 90        
  902 A(I,J) = (0.,0.)        
      GO TO 90        
  901 A(I,J) = C2SSCH + C1SBAR        
   90 CONTINUE        
      DO 91 J = 3,NM        
   91 A(J,1) = C2SSCH*W(J-2)+C1SBAR*WW(J-2)        
      DO 160 J = 1,NM        
      DO 160 K = 1,NM        
      NF     = N  + K        
      NNF    = NN + K        
      SUM1   = (0.,0.)        
      SUM2   = (0.,0.)        
      DO150 I = 1,N        
      SUM1 = SUM1 + A(J,I)*A(I,NF)        
  150 SUM2 = SUM2 + A(J,I)*A(I,NNF)        
      Q(J,K   ) = CSBLSB*SUM1 + CSBM2S*SUM2        
      Q(J,K+NM) = CSBAR*SUM2        
      Q(J+NM,K) = (0.,0.)        
  160 Q(J+NM,K+NM) = (0.,0.)        
  200 RETURN        
C        
 1000 WRITE  (IOUT,3001) UFM,SLN,NSTNS        
 3001 FORMAT (A23,' - AMG MODULE - NUMBER OF COMPUTING STATIONS ON ',   
     1       'STREAMLINE',I8,4H IS ,I3,1H., /39X,'SUBSONIC CASCADE ',   
     2       'ROUTINE AMGT1B ALLOWS ONLY A MAXIMUM OF 10.')        
      CALL MESAGE (-61,0,0)        
      RETURN        
      END        

      SUBROUTINE TRD1E(MHH,BHH,KHH,PH,UHV,NGROUP)
C
C     THIS ROUTINE SOLVES TRANSIENT PROBLEM ANALYTICALLY IN CASE
C         OF UNCOUPLED MODAL WITH NO NONLINEAR LOADS
C
      REAL    MI,KI
      INTEGER IZ(1),SYSBUF,IUHV(7),BHH,PH,UHV,FILE
      INTEGER NAME(2)
C
CRLBNB SPR94003 9/94
      COMMON /BLANK / DUMMY(4), NCOL
CRLBNE
      COMMON /PACKX/ IT1,IT2,II,JJ,INCUR
      COMMON /UNPAKX/IT3,III,JJJ,INCUR1
      COMMON /ZZZZZZ/ Z(1)
      COMMON /SYSTEM/ SYSBUF
C
      EQUIVALENCE (IZ(1),Z(1))
C
      DATA NAME/4HTRD1,4HE   /
      DATA EPSI/1.0E-8/
C*********
C     DEFINITION OF VARIABLES
C*********
C     IGROUP   POINTER TO TIME STEP DATA  N1,DELTAT,NO
C     NGROUP   NUMBER OF TIME STEP CHANGES
C     MHH      MODAL MASS FILE
C     KHH      MODAL STIFFNESS FILE
C     BHH      MODAL DAMPING FILE
C     PH       LOAD FILE
C     UHV      DISPLACEMENT,VELOCITY, AND ACCELERATION FILE
C     NMODES   ORDER OF MODAL FORMULATION
C     IMII     POINTER TO MASSES
C     IBII     POINTER TO DAMPING
C     IKII     POINTER TO STIFFNESS
C     IF       POINTER TO F-S
C     IFPR     POINTER TO F PRIMES
C     IG       POINTER TO G-S
C     IGPR
C     IA       POINTER TO A-S
C     IAPR
C     IB       POINTER TO B-S
C     IBPR
C     IUJ      POINTER TO OLD  DISP
C     IUJ1             TO NEW  DISP
C     IUDJ     POINTER TO  OLD VELOCITY VECTOR
C     IUDJ1                NEW VELOCITY VECTOR
C     IPHJ     POINTER TO  OLD LOAD VECTOR
C     IPHJ1                NEW LOAD VECTOR
C     NSTEP    NUMBER OF STEPS AT CURRENT INCREMENT
C     H        CURRENT DELTA T
C     NOUT     OUTPUT INCURMENT
C     EPSI     CASE SELTION TOLERANCE
C
C********    HERE WE GO --GET LOTS OF PAPER
C
      LC = KORSZ(Z)
      LC =LC -NGROUP*3
      IGROUP = LC+1
      IST =-1
      IBUF1 =LC -SYSBUF
      IBUF2 =IBUF1 -SYSBUF
      LC = LC - 2*SYSBUF
      IUHV(1)= MHH
      CALL RDTRL(IUHV)
      NMODES = IUHV(2)
      IT1=1
      IT2=1
      IT3=1
      INCUR=1
      INCUR1=1
      II=1
      JJ=NMODES
      ICRQ = 17*NMODES - LC
      IF(ICRQ.GT.0) GO TO 340
C
C     BRING IN H MATRICES
C
C
C     BRING IN  MHH
      FILE =MHH
      IMII =0
      KK=IMII
      ASSIGN 10 TO IRETN
      GO TO 280
C
C     BRING IN BHH
   10 DO 11 J=1,NMODES
      IF(Z(J) .EQ. 0.0) GO TO 350
   11 CONTINUE
      FILE = BHH
      IBII= IMII+ NMODES
      KK = IBII
      ASSIGN 20 TO IRETN
      GO TO 280
C
C     BRING IN KHH
   20 FILE =KHH
      IKII = IBII +NMODES
      KK= IKII
      ASSIGN 30 TO IRETN
      GO TO 280
C
C     ASSIGN ADDITIONAL POINTERS
C
   30 III=1
      JJJ=NMODES
      IF = IKII + NMODES
      IG = IF   + NMODES
      IA = IG   + NMODES
      IB = IA   + NMODES
      IFPR=IB   + NMODES
      IGPR=IFPR + NMODES
      IAPR=IGPR + NMODES
      IBPR=IAPR + NMODES
      IUJ =IBPR + NMODES
      IUJ1=IUJ  + NMODES
      IUDJ=IUJ1 + NMODES
      IUDJ1=IUDJ+ NMODES
      IPHJ =IUDJ1+NMODES
      IPHJ1=IPHJ +NMODES
CRLBNB SPR94003 9/94
      IF (NCOL .LE. 2) GO TO 37
C
C     RETRIEVE OLD DISPLACEMENT AND VELOCITY
C     FROM A PREVIOUSLY CHECKPOINTED RUN
C
      CALL GOPEN (UHV, IZ(IBUF1), 0)
      I = 3*(NCOL - 1)
      CALL SKPREC (UHV, I)
C
C     RETRIEVE OLD DISPLACEMENT
C
      CALL UNPACK (*31, UHV, Z(IUJ1+1))
      GO TO 33
   31 DO 32 I = 1, NMODES
      K = IUJ1 + I
      Z(K) = 0.0
   32 CONTINUE
C
C     RETRIEVE OLD VELOCITY
C
   33 CALL UNPACK (*34, UHV, Z(IUDJ1+1))
      GO TO 36
   34 DO 35 I = 1, NMODES
      K = IUDJ1 + I
      Z(K) = 0.0
   35 CONTINUE
   36 CALL CLOSE (UHV, 1)
CRLBNE
C
C     READY UHV
C
CRLBR SPR94003 9/94      CALL GOPEN(UHV,IZ(IBUF1),1)
   37 CALL GOPEN(UHV,IZ(IBUF1),1)
      CALL MAKMCB(IUHV,UHV,NMODES,2,1)
C
C     READY LOADS
C
      CALL GOPEN(PH,IZ(IBUF2),0)
      CALL UNPACK(*40,PH,Z(IPHJ1+1))
      GO TO 60
C
C     ZERO LOAD
C
   40 DO 50 I=1,NMODES
      K = IPHJ1+I
      Z(K) = 0.0
   50 CONTINUE
CRLBNB SPR94003 9/94
   60 IF (NCOL .GT. 2) GO TO 75
CRLBNE
C
C     ZERO INITIAL DISPLACEMENT AND VELOCITY
C
CRLBR SPR 94003 9/94   60 DO 70 I=1,NMODES
      DO 70 I=1,NMODES      
      K = IUJ1+I
      Z(K) = 0.0
      K = IUDJ1+I
      Z(K) = 0.0
   70 CONTINUE
C
C     BEGIN LOOP ON EACH DIFFERENT TIME STEP
C
CRLBR SPR 94003 9/94      I = 1
   75 I = 1
   80 NSTEP = IZ(IGROUP)
      IF(I .EQ. 1) NSTEP = NSTEP+1
      H     =  Z(IGROUP+1)
      NOUT = IZ(IGROUP+2)
      IGROUP = IGROUP +3
      JK = 1
      IF(I .EQ. 1) GO TO 170
C
C     COMPUTE F-S ,G-S,A-S,B-S
C
   90 DO 140 J=1,NMODES
      K= IMII+J
      MI= Z(K)
      IF(MI .EQ. 0.0) GO TO 350
      K= IBII+J
      BI= Z(K)
      K = IKII+J
      KI= Z(K)
      WOSQ =KI/MI
      BETA = BI/(2.0*MI)
      BETASQ =BETA*BETA
      WSQ  = ABS(WOSQ - BETASQ)
      W = SQRT(WSQ)
      IF(SQRT(WSQ + BETASQ)*H .LT. 1.E-6) GO TO 100
      T1 = ( WOSQ-BETASQ ) / WOSQ
      IF( T1 .GT. EPSI ) GO TO 110
      IF( T1 .LT. -EPSI) GO TO 130
C
C     CASE  3  CRITICALLY DAMPED
C
      BH = BETA*H
      EXPBH = EXP(-BH)
      T1 = H*KI
      K = IF+J
C
C     COMPUTE F
C
      Z(K) = EXPBH*(1.0 +BH)
C
C     COMPUTE  G
C
      K = IG +J
      Z(K)= H*EXPBH
C
C     COMPUTE A
C
      K = IA +J
      Z(K) = (2.0/BETA - EXPBH/BETA*(2.0 +2.0*BH + BH*BH))/ T1
C
C     COMPUTE B
C
      K=IB +J
      Z(K) = (-2.0 +BH+EXPBH*(2.0+BH))/(BH*KI)
C
C     COMPUTE  F PRIME
C
      K= IFPR+J
      Z(K) = -BETASQ*H*EXPBH
C
C     COMPUTE  G PRIME
C
      K = IGPR+J
      Z(K)= EXPBH*(1.0- BH)
C
C     COMPUTE A PRIME
C
      K = IAPR +J
      Z(K) = (EXPBH*(1.0 + BH + BH*BH)- 1.0)/T1
C
C     COMPUTE  B PRIME
C
      K = IBPR +J
      Z(K) = (1.0 -EXPBH*(BH +1.0))/T1
      GO TO 140
C
C     CASE  4   W0 = BETA =0.0
C
  100 K=IF+J
      Z(K)=1.0
      K= IG+J
      Z(K)=H
      K= IA+J
      Z(K)= H*H/(3.0*MI)
      K= IB+J
      Z(K)= H*H/(6.0*MI)
      K= IFPR+J
      Z(K)=0.0
      K= IGPR+J
      Z(K)=1.0
      T1 = H/(2.0*MI)
      K = IAPR+J
      Z(K)= T1
      K=  IBPR+J
      Z(K)= T1
      GO TO 140
C
C     CASE 1 --UNDERDAMPED
C
  110 WH = W*H
      EXPBH = EXP(-BETA*H)
      SINWH = SIN(WH)
      COSWH = COS(WH)
C
C     COMPUTE F
C
  120 K= IF +J
      Z(K)= EXPBH*(COSWH +BETA/W *SINWH)
C
C     COMPUTE G
C
      K = IG +J
      Z(K) = EXPBH/W*SINWH
C
C     COMPUTE A
C
      K= IA+J
      T1 =(WSQ -BETASQ)/WOSQ
      T2 = 2.0*W*BETA/WOSQ
      T3 = WH*KI
      Z(K)= (EXPBH*((T1-BETA*H)*SINWH-(T2+WH)*COSWH)+T2)/T3
C
C     COMPUTE  B
C
      K =IB +J
      Z(K) = (EXPBH*(-T1*SINWH + T2*COSWH)+WH- T2)/T3
C
C     COMPUTE  FPRIME
C
      K = IFPR+J
      Z(K) = -WOSQ/W*EXPBH*SINWH
C
C     COMPUTE G PRIME
C
      K =IGPR +J
      Z(K) = EXPBH*(COSWH -BETA/W *SINWH)
C
C     COMPUTE A PRIME
C
      K = IAPR +J
      Z(K) =(EXPBH*((BETA +WOSQ*H)*SINWH +W*COSWH)- W)/T3
C
C     COMPUTE B PRIME
C
      K =IBPR +J
      Z(K) = (-EXPBH*(BETA*SINWH +W*COSWH) + W)/T3
      GO TO 140
C
C     CASE  3    W0 - BETASQ L -E
C
  130 WH =W*H
      EXPBH= EXP(-BETA*H)
      SINWH =   SINH(WH)
      COSWH =   COSH(WH)
      BETASQ = -BETASQ
      GO TO 120
  140 CONTINUE
C
C     BEGIN LOOP ON INCREMENTS
C
C
C     COMPUTE  NEW DISPLACEMENTS
C
  150 K = IUJ1
      KK=IUDJ1
      DO 160 L=1,NMODES
      K=K+1
      KK =KK+1
      Z(K)=0.0
      Z(KK)=0.0
      KKK = IF+L
      KD =  IUJ +L
      Z(K) =Z(KKK)*Z(KD) +Z(K)
      KKK = IFPR +L
      Z(KK) = Z(KKK)*Z(KD) +Z(KK)
      KD= IUDJ+L
      KKK = IG +L
      Z(K) = Z(KKK)*Z(KD) +Z(K)
      KKK = IGPR +L
      Z(KK) = Z(KKK)*Z(KD) +Z(KK)
      KD = IPHJ +L
      KKK = IA +L
      Z(K) = Z(KKK)*Z(KD) +Z(K)
      KKK  = IAPR +L
      Z(KK)= Z(KKK)*Z(KD) + Z(KK)
      KD = IPHJ1+L
      KKK=  IB +L
      Z(K) = Z(KKK)*Z(KD) +Z(K)
      KKK  = IBPR +L
      Z(KK) = Z(KKK)*Z(KD) + Z(KK)
  160 CONTINUE
      IF(JK .EQ. NSTEP) GO TO 200
      IF( JK .NE. 1 .AND. MOD(JK+IST,NOUT) .NE. 0) GO TO 180
C
C     TIME TO OUTPUT--YOU LUCKY FELLOW
C
  170 ASSIGN 190 TO IRETN
      GO TO 220
  180 ASSIGN 190 TO IRETN
      GO TO 240
  190 JK = JK+1
      IF(JK .EQ. 2 .AND. I .EQ. 1) GO TO 90
      IF(JK .LE. NSTEP) GO TO 150
  200 ASSIGN 210 TO IRETN
      GO TO 220
  210 I =I+1
      IST = 0
      IF( I .LE. NGROUP) GO TO 80
      CALL CLOSE(PH,1)
      CALL CLOSE(UHV,1)
      CALL WRTTRL(IUHV)
      RETURN
C
C     INTERNAL SUBROUTINE FOR OUTPUT AND VELOCITY COMPUTE
C
  220 CALL PACK(Z(IUJ1+1),UHV,IUHV)
      CALL PACK(Z(IUDJ1+1),UHV,IUHV)
C
C     COMPUTE  ACCELERATIONS
C
      DO 230 L=1,NMODES
      K= IUDJ+L
      KK=IPHJ1+L
      KKK = IMII+L
      KD = IBII+L
      KD1= IUDJ1+L
      KD2= IUJ1 +L
      KD3 = IKII+L
      Z(K) = Z(KK)/Z(KKK)-Z(KD)*Z(KD1)/Z(KKK)-Z(KD3)*Z(KD2)/Z(KKK)
  230 CONTINUE
      CALL PACK(Z(IUDJ+1),UHV,IUHV)
C
C     SWITCH POINTS TO STUFF
C
  240 KD= IUJ
      IUJ = IUJ1
      IUJ1=KD
      KD= IUDJ
      IUDJ =IUDJ1
      IUDJ1=KD
      KD = IPHJ
      IPHJ =IPHJ1
      IPHJ1= KD
C
C     BRING IN NEXT LOAD VECTOR
C
      CALL UNPACK(*260,PH,Z(IPHJ1+1))
  250 GO TO IRETN,(190,210)
  260 DO 270 KD=1,NMODES
      K = IPHJ1 +KD
      Z(K) =0.0
  270 CONTINUE
      GO TO 250
C
C     INTERNAL SUBROUTINE TO BRING  IN H MATRICES
C
  280 CALL OPEN(*302,FILE,IZ(IBUF1),0)
      CALL SKPREC(FILE,1)
      DO 300 KD=1,NMODES
      III= KD
      JJJ= KD
      KD1= KK+KD
      CALL UNPACK(*290,FILE,Z(KD1))
      GO TO 300
  290 Z(KD1)= 0.0
  300 CONTINUE
      CALL CLOSE(FILE,1)
  301 GO TO IRETN,(10,20,30)
C
C      ZERO CORE FOR PURGED FILES
C
  302 DO 303 KD = 1,NMODES
      KD1 = KK + KD
      Z(KD1) = 0.0
  303 CONTINUE
      GO TO 301
C
C     ERROR MESAGES
C
  320 CALL MESAGE(IP1,FILE,NAME)
      RETURN
  340 IP1 = -8
      FILE = ICRQ
      GO TO 320
  350 IP1 = -43
      FILE = J
      GO TO 320
      END

        SUBROUTINE DSBPNK ( BLOCK, MCB )
      INCLUDE 'DSIOF.COM'
      INTEGER BLOCK( 15 ), MCB( 7 )
      IF ( BLOCK( 1 ) .EQ. NAME ) GO TO 10
      CALL DSMSG1( BLOCK )
      CALL DSMSG( 120 )
10    CONTINUE
      IF ( MCB( 2 ) .EQ. 0 ) MCB( 7 ) = MCBMAS
      MCB( 2 ) = MCB( 2 ) + 1
      NUM      = BLOCK( 10 )
      IF ( MCB( 6 ) .GT. NUM ) GO TO 20
      MCB( 6 ) = NUM
20    MCB( 7 ) = MCB( 7 ) + NUM
      BLOCK( 8 ) = 1
      CALL ENDPUT ( BLOCK )
      RETURN
      END

      SUBROUTINE CMCOMB (NPS,NENT,NDOF,IC)
C
C     THIS SUBROUTINE COMBINES CONNECTION ENTRIES THAT HAVE BEEN SPECIFI
C     ON SEVERAL CONCT OR CONCT1 CARDS.
C
      EXTERNAL        ORF
      LOGICAL         MATCH
      INTEGER         CE(9),CEID,SCCONN,SCMCON,BUF1,BUF2,SAVCE,ORF,Z,
     1                SCR2,BUF3,SCORE,COMSET,IO(10),SACONN,AAA(2)
      DIMENSION       IC(NENT,NPS,NDOF),LIST(32),KROW(6),IERTAB(2000)
      COMMON /CMB001/ SCR1,SCR2,JUNK(2),SCCONN,SCMCON
      COMMON /CMB002/ BUF1,BUF2,BUF3,JUNK1(2),SCORE,LCORE
      COMMON /ZZZZZZ/ Z(1)
      COMMON /BLANK / ISTEP,IDRY
      DATA    AAA   / 4HCMCO,4HMB   /
C
C     CE IS THE CONNECTION ENTRY
C     KROW(I) IS THE NO. OF ROWS IN THE ITH DOF MATRIX
C
      IERSUB = 0
      ITOMNY = 0
      IFILE  = SCCONN
      CALL OPEN (*400,SCCONN,Z(BUF1),0)
      IFILE = SCMCON
      CALL OPEN (*400,SCMCON,Z(BUF2),0)
      NREC  = -1
      NPSS  = NPS - 1
      NWORD = NPS + 1
      IENT  = 0
      DO 10 I = 1,6
   10 KROW(I) = 0
      SAVCE = 0
   20 CALL READ (*410,*190,SCMCON,CEID,1,0,NNN)
      NREC  = CEID - SAVCE - 1
      SAVCE = CEID
C
C     GO FIND ENTRY NO. CEID
C
      IFILE = SCCONN
      IF (NREC .EQ. 0) GO TO 40
      DO 30 I = 1,NREC
      CALL FWDREC (*420,SCCONN)
   30 CONTINUE
C
C     READ IN CONNECTION ENTRY
C
   40 CALL READ (*410,*50,SCCONN,CE,10,1,NNN)
C
C     FIND WHICH DOF ARE PRESENT IN CONNECTION ENTRY
C
   50 CALL DECODE (CE(1),LIST,NCOMP)
      DO 180 I = 1,NCOMP
      ICOMP = LIST(I) + 1
      IF (KROW(ICOMP) .EQ. 0) GO TO 170
C
C     FIND FIRST NON-ZERO ENTRY IN CURRENT CE
C
      DO 60 J = 1,NPSS
      IF (CE(J+2) .EQ. 0) GO TO 60
      ISUB = J
      GO TO 70
   60 CONTINUE
C
C     NOW HAVE FOUND FIRST NON-ZERO, SEARCH FOR POSSIBLE
C     MATCHING ENTRIES IN MATRIX
C
   70 NLOOP = KROW(ICOMP)
      DO 140 J = 1,NLOOP
      MATCH  = .FALSE.
      NERSUB = 0
      DO 110 JJ = ISUB,NPSS
      IF (IC(J,JJ,ICOMP).EQ.0 .OR. CE(JJ+2).EQ.0) GO TO 110
      IF (IC(J,JJ,ICOMP)-CE(JJ+2)) 80,100,80
   80 IF (IERSUB+NERSUB .GT. 2000) ITOMNY = 1
      IF (IERSUB+NERSUB .GT. 2000) GO TO 90
      IERTAB(IERSUB+NERSUB+1) = ICOMP
      IERTAB(IERSUB+NERSUB+2) = JJ
      IERTAB(IERSUB+NERSUB+3) = IC(J,JJ,ICOMP)
      IERTAB(IERSUB+NERSUB+4) = CE(JJ+2)
      NERSUB = NERSUB + 4
   90 CONTINUE
      GO TO 110
  100 MATCH = .TRUE.
  110 CONTINUE
      IF (MATCH) IERSUB = IERSUB + NERSUB
      IF (.NOT.MATCH) GO TO 140
      DO 130 JJ = ISUB,NPSS
      IF (CE(JJ+2).NE.0 .AND. IC(J,JJ,ICOMP).NE.0) GO TO 130
      IC(J,JJ,ICOMP) = IC(J,JJ,ICOMP) + CE(JJ+2)
  130 CONTINUE
      IC(J,NPSS+1,ICOMP) = ORF(IC(J,NPSS+1,ICOMP),CE(2))
      GO TO 180
  140 CONTINUE
  150 DO 160 JJ = 1,NPSS
      IC(NLOOP+1,JJ,ICOMP) = CE(JJ+2)
  160 CONTINUE
      IC(NLOOP+1,NPSS+1,ICOMP) = CE(2)
      KROW(ICOMP) = KROW(ICOMP) + 1
      GO TO 180
  170 NLOOP = 0
      GO TO 150
  180 CONTINUE
      GO TO 20
  190 CONTINUE
      IF (IERSUB .EQ. 0) GO TO 200
C
C     GENERATE ERROR TABLE AND TERMINATE
C
      CALL CLOSE (SCCONN,1)
      CALL CLOSE (SCMCON,1)
      CALL CMTRCE (IERTAB,IERSUB,ITOMNY)
      IDRY = -2
      RETURN
C
  200 CONTINUE
      CALL CLOSE (SCCONN,1)
      IFILE = SCR2
      CALL OPEN (*400,SCR2,Z(BUF3),1)
      DO 240 K = 1,NDOF
      IROW = KROW(K)
      IF (IROW) 240,240,210
  210 DO 230 I = 1,IROW
      IO(1) = K
      IO(2) = IC(I,NPS,K)
      DO 220 J = 1,NPSS
      IO(J+2) = IC(I,J,K)
  220 CONTINUE
      CALL WRITE (SCR2,IO(1),NPS+1,0)
  230 CONTINUE
  240 CONTINUE
      CALL WRITE (SCR2,IO(1),0,1)
      CALL CLOSE (SCR2,1)
      CALL OPEN (*400,SCR2,Z(BUF3),0)
      CALL READ (*410,*250,SCR2,Z(SCORE),LCORE,1,NWD)
      GO TO 430
  250 CALL SORT (0,0,NPS+1,2,Z(SCORE),NWD)
      CALL CLOSE (SCR2,1)
      CALL OPEN (*400,SCR2,Z(BUF3),1)
      IFIN = SCORE + NWD - 1
      IINC = NPS + 1
      DO 310 I = SCORE,IFIN,IINC
      IF (Z(I)) 260,310,260
  260 COMSET = Z(I)
      IBEG = I + IINC
      DO 280 J = IBEG,IFIN,IINC
      IF (Z(J) .EQ. 0) GO TO 280
      IF (Z(J+1) .GT. Z(I+1)) GO TO 290
      DO 270 K = 1,NPSS
      IF (Z(I+K+1) .NE. Z(J+K+1)) GO TO 280
  270 CONTINUE
      COMSET = 10*COMSET+Z(J)
      Z(J) = 0
  280 CONTINUE
  290 CALL ENCODE (COMSET)
      IO(1) = COMSET
      DO 300 KK = 1,NPS
      IO(1+KK) = Z(I+KK)
  300 CONTINUE
      CALL WRITE (SCR2,IO,NPS+1,1)
  310 CONTINUE
      CALL REWIND (SCMCON)
      IFILE = SCMCON
      CALL READ (*410,*320,SCMCON,Z(SCORE),LCORE,1,NMCON)
  320 NCE = 0
      SACONN = SCCONN
      CALL OPEN (*400,SCCONN,Z(BUF1),0)
  330 CALL READ (*360,*340,SCCONN,CE,10,1,NNN)
  340 NCE = NCE + 1
      DO 350 I = 1,NMCON
      IF (NCE .EQ. Z(SCORE+I-1)) GO TO 330
  350 CONTINUE
      CALL WRITE (SCR2,CE,NPS+1,1)
      GO TO 330
  360 CALL CLOSE (SCMCON,1)
      CALL CLOSE (SCCONN,1)
      CALL CLOSE (SCR2,1)
      SCCONN = SCR2
      SCR2   = SACONN
      RETURN
C
  400 IMSG = -1
      GO TO 440
  410 IMSG = -2
      GO TO 440
  420 IMSG = -3
      GO TO 440
  430 IMSG = -8
  440 CALL MESAGE (IMSG,IFILE,AAA)
      RETURN
      END

      SUBROUTINE TUBES
C
C***
C  THE TUBE BEING SO SIMILAR TO THE ROD, WE ALTER THE EST FOR THE TUBE
C  SO THAT IT IS IDENTICAL TO THE ONE FOR THE ROD AND THEN CALL RODS
C SINGLE PRECISION VERSION
C SINGLE AND DOUBLE PRECISION VERSIONS OF THIS ROUTINE ARE IDENTICAL
C APART FROM THE NAME AND THE CALL TO RODD (RODS)
C***
C
C
C EST( 1) - ELEMENT ID.
C EST( 2) - SCALAR INDEX NUMBER FOR GRID POINT A
C EST( 3) - SCALAR INDEX NUMBER FOR GRID POINT B
C EST( 4) - MATERIAL ID.
C EST( 5) - OUTSIDE DIAMETER
C EST( 6) - THICKNESS
C EST( 7) - NON-STRUCTURAL MASS
C EST( 8) - COOR. SYS. ID. FOR GRID POINT A
C EST( 9) - BASIC COORDINATES OF GRID POINT A
C EST(10) -                ...
C EST(11) -                ...
C EST(12) - COOR. SYS. ID. FOR GRID POINT B
C EST(13) - BASIC COORDINATES OF GRID POINT B
C EST(14) -               ...
C EST(15) -               ...
C EST(16) - ELEMENT TEMPERATURE
C
      COMMON   /EMGEST/  EST(100)
      COMMON   /CONDAS/  PI
C
C ----------------------------------------------------------------------
C
      TEMP = EST(5) - EST(6)
      A = TEMP * EST(6) * PI
      FJ = .25 * A * ( TEMP**2 + EST(6)**2 )
      C = .5 * EST(5)
      M = 18
      DO 10 I = 1,10
      M = M - 1
   10 EST(M) = EST(M-1)
      EST(5) = A
      EST(6) = FJ
      EST(7) = C
      CALL RODS
      RETURN
      END

      SUBROUTINE BETRNS (TBE,GG,KFLAG,ELID)
C     &    ENTRY BETRND (TBD,GD,KFLAG,ELID)
C
C*****
C     SUBROUTINE WHICH CALCULATES THE TBE TRANSFORMATION
C     MATRIX WHICH RELATES THE ELEMENT TO THE BASIC C.S.
C
C     GG(9) OR GD(9) IS A 9X1 ARRAY WHICH STORES THE GRID PT. COORD.
C     X(G1),Y(G1),Z(G1),X(G2),Y(G2),Z(G2),X(G3),Y(G3),Z(G3)
C     GG(1),GG(2),GG(3),GG(4),GG(5),GG(6),GG(7),GG(8),GG(9), OR
C     GD(1),GD(2),GD(3),GD(4),GD(5),GD(6),GD(7),GD(8),GD(9)
C
C     KFLAG = 0, TBE (OR TBD) IS OUTPUT WITHOUT TRANSPOSING
C           = 1, TBE (OR TBD) IS OUTPUT AFTER IT IS TRANSPOSED
C*****
C
      INTEGER          ELID
      REAL             GG(9),TBE(9),RSSTR(3),RSTR(3),R12(3),RV(3),LEN
      DOUBLE PRECISION GD(9),TBD(9),DSSTR(3),DSTR(3),D12(3),DV(3),
     1                 DTEMP,LED
C
C     SINGLE PRECISION VERSION
C
C*****
C     CALCULATE APPROPRIATE LENGTH QUANTITIES
C*****
      LEN = SQRT((GG(4)-GG(1))**2 + (GG(5)-GG(2))**2
     1          +(GG(6)-GG(3))**2)
      IF (LEN .EQ. 0.0) GO TO 40
C*****
C     CALCULATE APPROPRIATE VECTOR QUANTITIES
C*****
      R12(1) = (GG(4)-GG(1))/LEN
      R12(2) = (GG(5)-GG(2))/LEN
      R12(3) = (GG(6)-GG(3))/LEN
      RV(1)  = (GG(7)-GG(1))
      RV(2)  = (GG(8)-GG(2))
      RV(3)  = (GG(9)-GG(3))
C*****
C     CALCULATE ENTRIES INTO THE TRANSFORMATION MATRIX
C*****
      RSTR(1) = (R12(2)*RV(3) - R12(3)*RV(2))
      RSTR(2) = (R12(3)*RV(1) - R12(1)*RV(3))
      RSTR(3) = (R12(1)*RV(2) - R12(2)*RV(1))
C
      LEN = SQRT (RSTR(1)**2 + RSTR(2)**2 + RSTR(3)**2)
      IF (LEN .EQ. 0.0) GO TO 40
      DO 10 I=1,3
   10 RSTR(I) = RSTR(I)/LEN
C
      RSSTR(1)= (RSTR(2)*R12(3) - RSTR(3)*R12(2))
      RSSTR(2)= (RSTR(3)*R12(1) - RSTR(1)*R12(3))
      RSSTR(3)= (RSTR(1)*R12(2) - RSTR(2)*R12(1))
      TBE(1)  = R12(1)
      TBE(2)  = R12(2)
      TBE(3)  = R12(3)
      TBE(4)  = RSSTR(1)
      TBE(5)  = RSSTR(2)
      TBE(6)  = RSSTR(3)
      TBE(7)  = RSTR(1)
      TBE(8)  = RSTR(2)
      TBE(9)  = RSTR(3)
      IF (KFLAG .EQ. 0) GO TO 30
C*****
C     TRANSPOSE TBE(9) SINCE KFLAG.NE.ZERO
C*****
      TEMP   = TBE(2)
      TBE(2) = TBE(4)
      TBE(4) = TEMP
      TEMP   = TBE(3)
      TBE(3) = TBE(7)
      TBE(7) = TEMP
      TEMP   = TBE(6)
      TBE(6) = TBE(8)
      TBE(8) = TEMP
      GO TO 30
C
      ENTRY BETRND (TBD,GD,KFLAG,ELID)
C     ================================
C
C     DOUBLE PRECISION VERSION
C
C*****
C     CALCULATE APPROPRIATE LENGTH QUANTITIES
C*****
      LED = DSQRT((GD(4)-GD(1))**2 + (GD(5)-GD(2))**2
     1           +(GD(6)-GD(3))**2)
      IF (LED .EQ. 0.0D+0) GO TO 40
      D12(1) = (GD(4)-GD(1))/LED
      D12(2) = (GD(5)-GD(2))/LED
      D12(3) = (GD(6)-GD(3))/LED
      DV(1)  = (GD(7)-GD(1))
      DV(2)  = (GD(8)-GD(2))
      DV(3)  = (GD(9)-GD(3))
C*****
C     CALCULATE ENTRIES INTO THE TRANSFORMATION MATRIX
C*****
      DSTR(1) = (D12(2)*DV(3) - D12(3)*DV(2))
      DSTR(2) = (D12(3)*DV(1) - D12(1)*DV(3))
      DSTR(3) = (D12(1)*DV(2) - D12(2)*DV(1))
C
      LED = DSQRT(DSTR(1)**2 + DSTR(2)**2 + DSTR(3)**2)
      IF (LED .EQ. 0.0D+0) GO TO 40
      DO 20 I=1,3
   20 DSTR(I) = DSTR(I)/LED
C
      DSSTR(1)= (DSTR(2)*D12(3) - DSTR(3)*D12(2))
      DSSTR(2)= (DSTR(3)*D12(1) - DSTR(1)*D12(3))
      DSSTR(3)= (DSTR(1)*D12(2) - DSTR(2)*D12(1))
      TBD(1)  = D12(1)
      TBD(2)  = D12(2)
      TBD(3)  = D12(3)
      TBD(4)  = DSSTR(1)
      TBD(5)  = DSSTR(2)
      TBD(6)  = DSSTR(3)
      TBD(7)  = DSTR(1)
      TBD(8)  = DSTR(2)
      TBD(9)  = DSTR(3)
      IF (KFLAG .EQ. 0) GO TO 30
C*****
C     TRANSPOSE TBD(9) SINCE KFLAG.NE.ZERO
C*****
      DTEMP  = TBD(2)
      TBD(2) = TBD(4)
      TBD(4) = DTEMP
      DTEMP  = TBD(3)
      TBD(3) = TBD(7)
      TBD(7) = DTEMP
      DTEMP  = TBD(6)
      TBD(6) = TBD(8)
      TBD(8) = DTEMP
   30 RETURN
C*****
C     ZERO LENGTH ERROR, BAD GEOMETRY
C*****
   40 CALL MESAGE (-30,31,ELID)
      RETURN
      END

      SUBROUTINE Q4NRMS (BGPDT,GPNORM,IORDER,IFLAG)
C     &    ENTRY Q4NRMD (BGPDT,GPNORM,IORDER,IFLAG)
C
C*****
C     COMPUTES UNIT NORMAL VECTORS FOR QUAD4 GRID POINTS.
C*****
      INTEGER          IORDER(4)
      REAL             BGPDT(4,4),GPNORM(4,4),
     1                 SHP(4), SSHP(4,2),  V(3,3), TSHP(4), TSSHP(4,2),
     2                 AXI(4),AETA(4),ETA,VMAG,XI
      DOUBLE PRECISION DSHP(4),DSSHP(4,2),DV(3,3),TDSHP(4),TDSSHP(4,2),
     1                 ADI(4),AETD(4),ETD,DMAG,DI
      DATA   AXI     / -1.0  ,  1.0  , 1.0  , -1.0   /
      DATA   AETA    / -1.0  , -1.0  , 1.0  ,  1.0   /
      DATA   ADI     / -1.0D0,  1.0D0, 1.0D0, -1.0D0 /
      DATA   AETD    / -1.0D0, -1.0D0, 1.0D0,  1.0D0 /
C
C     SINGLE PRECISION SECTION -
C*****
C     COMPUTE SHAPE FUNCTION DERIVATIVES
C*****
      IFLAG = 0
      DO 50 II=1,4
      IO  = IORDER(II)
      XI  = AXI(IO)
      ETA = AETA(IO)
      CALL Q4SHPS (XI,ETA,SHP,SSHP)
C*****
C     SORT THE SHAPE FUNCTIONS
C*****
      DO 10 I=1,4
      TSHP(I) = SHP(I)
      DO 10 J=1,2
   10 TSSHP(I,J) = SSHP(I,J)
C
      DO 20 IK=1,4
      I = IORDER(IK)
      SHP(IK) = TSHP(I)
      DO 20 J=1,2
   20 SSHP(IK,J) = TSSHP(I,J)
C*****
C     COMPUTE VECTOR
C*****
      DO 30 I=1,2
      DO 30 J=1,3
      V(I,J) = 0.0
      J1 = J + 1
      DO 30 K=1,4
   30 V(I,J) = V(I,J) + SSHP(K,I)*BGPDT(J1,K)
C
      V(3,1) = V(1,2)*V(2,3) - V(2,2)*V(1,3)
      V(3,2) = V(1,3)*V(2,1) - V(2,3)*V(1,1)
      V(3,3) = V(1,1)*V(2,2) - V(2,1)*V(1,2)
      VMAG   = V(3,1)**2+V(3,2)**2+V(3,3)**2
C
      IF (VMAG .GT. 1.0E-11) GO TO 40
      IFLAG = 1
      GO TO 200
C
   40 VMAG =  SQRT(VMAG)
      GPNORM(2,II) = V(3,1)/VMAG
      GPNORM(3,II) = V(3,2)/VMAG
      GPNORM(4,II) = V(3,3)/VMAG
   50 CONTINUE
      GO TO 200
C
      ENTRY Q4NRMD (BGPDT,GPNORM,IORDER,IFLAG)
C     =======================================
C
C     DOUBLE PRECISION SECTION -
C
C*****
C     COMPUTE SHAPE FUNCTION DERIVATIVES
C*****
      IFLAG = 0
      DO 150 II=1,4
      IO = IORDER(II)
      DI = ADI(IO)
      ETD = AETD(IO)
      CALL Q4SHPD (DI,ETD,DSHP,DSSHP)
C
C     SORT THE SHAPE FUNCTIONS
C
      DO 110 I=1,4
      TDSHP(I) = DSHP(I)
      DO 110 J=1,2
  110 TDSSHP(I,J) = DSSHP(I,J)
C
      DO 120 IK=1,4
      I = IORDER(IK)
      DSHP(IK) = TDSHP(I)
      DO 120 J=1,2
  120 DSSHP(IK,J) = TDSSHP(I,J)
C*****
C     COMPUTE VECTOR
C*****
      DO 130 I=1,2
      DO 130 J=1,3
      DV(I,J) = 0.0D0
      J1 = J + 1
      DO 130 K=1,4
  130 DV(I,J) = DV(I,J) + DSSHP(K,I)*BGPDT(J1,K)
C
      DV(3,1) = DV(1,2)*DV(2,3) - DV(2,2)*DV(1,3)
      DV(3,2) = DV(1,3)*DV(2,1) - DV(2,3)*DV(1,1)
      DV(3,3) = DV(1,1)*DV(2,2) - DV(2,1)*DV(1,2)
      DMAG    = DV(3,1)**2+DV(3,2)**2+DV(3,3)**2
C
      IF (DMAG .GT. 1.0D-11) GO TO 140
      IFLAG = 1
      GO TO 200
C
  140 DMAG = DSQRT(DMAG)
      GPNORM(2,II) = DV(3,1)/DMAG
      GPNORM(3,II) = DV(3,2)/DMAG
      GPNORM(4,II) = DV(3,3)/DMAG
  150 CONTINUE
C
  200 RETURN
      END

      SUBROUTINE SQRTM(A,IA,B,IB)
C
C     SCALED ARITHMETIC ROUTINES--SQUARE ROOT
C
      DIMENSION IPSW(1)
      DOUBLE PRECISION A,B
      DOUBLE PRECISION DETSW(1)
      A = B
      IA = IB
      IF(MOD(IA,2) .EQ. 0) GO TO 10
      IA = IA-1
      A = A*10.0
   10 IA=IA/2
      A = DSQRT(DMAX1(A,0.D0))
   20 RETURN
C
C     DCALE OF DETERMINANT BY FACTORS OF 10
C
      ENTRY DETM6(DETSW,IPSW)
      IF(DETSW(1) .EQ. 0.0D0) GO TO 20
   30 IF(DABS(DETSW(1)) .GT. 10.0D0) GO TO 50
   40 IF(DABS(DETSW(1)) .LT. 0.1D0) GO TO 60
      GO TO 20
   50 DETSW(1) = DETSW(1)*0.1D0
      IPSW(1) = IPSW(1)+1
      GO TO 30
   60 DETSW(1) = DETSW(1)*10.0D0
      IPSW(1) = IPSW(1)-1
      GO TO 40
      END

      SUBROUTINE TABPCH
C
C     THE TABPCH MODULE WILL PUNCH UP TO 5 TABLES INTO DTI CARDS
C
C     DMAP CALL IS
C
C     TABPCH  IN1,IN2,IN3,IN4,IN5//P1,P2,P3,P4,P5
C
C     SINGLE FIELD CARDS WILL BE MADE UNLESS REAL NUMBERS ARE TO BE MADE
C     ALL REAL NUMBERS ARE ASSUMED TO BE SINGLE PRECISION.
C
C     LAST REVISED, 3/93, BY G.CHAN/UNISYS
C     PUNCH KELM, MELM AND BELM IN D.P. IF THESE DATA BLOCKS ARE IN D.P.
C
C  $MIXED_FORMATS
C
      INTEGER          SYSBUF    ,IZ(10)    ,IFNM(5)   ,NAME(2)   ,
     1                 MCB(7)    ,FILE      ,TABNM(2)  ,DTI(2)    ,
     2                 DTIS(2)   ,IDATA(20) ,ENDREC(2) ,OUT       ,
     3                 IFORM(20) ,BLANK     ,INT(2)    ,IREAL(2)  ,
     4                 LL(4)     ,INTD(2)   ,PFORM(30) ,IBCD(2)   ,
     5                 SP(3)     ,IBCDD(2)  ,FORM(30,2),FORMS(30,2)
      REAL             RDATA(20)
      DOUBLE PRECISION DZ(1)
      CHARACTER        UFM*23    ,UWM*25    ,UIM*29
      COMMON /XMSSG /  UFM       ,UWM       ,UIM
      COMMON /MACHIN/  MACH
      COMMON /SYSTEM/  SYSBUF    ,OUT       ,KSYSTM(88),LPCH
      COMMON /ZZZZZZ/  Z(1)
      COMMON /BLANK /  N1(2,5)
      EQUIVALENCE      (Z(1),IZ(1),DZ(1)),  (IDATA(1),RDATA(1))
      DATA    BLANK /  1H             /
      DATA    DTI   /  4HDTI , 1H     /
      DATA    DTIS  /  4HDTI*, 1H     /
      DATA    ENDREC/  4HENDR, 4HEC   /
      DATA    FORMS /  4H(2A4, 26*2H  ,4H,1H+ ,4HA2,I, 4H5)  , 4H(A1,,
     1                 4HA2,I ,4H5    ,24*2H  ,4H,1H+, 4HA2,I, 4H5)  /
      DATA    IBCD  /  4H,2A4, 1H     /
      DATA    IBCDD /  4H,2A4, 4H,8X  /
      DATA    IFNM  /  101, 102, 103, 104, 105/
      DATA    INT   /  4H,I8 , 1H     /
      DATA    INTD  /  4H,I16, 1H     /
      DATA    IPLUS /  1H+            /
      DATA    IREAL /  4H,E16, 4H.9   /
      DATA    ISTAR /  1H*            /
      DATA    NAME  /  4HTABP, 4HCH   /
      DATA    LL    /  1, 1, 3, 2     /
      DATA    NSP   ,  SP  / 3, 4HKELM, 4HMELM, 4HBELM /
C
      NZ    = KORSZ(Z)
      IBUF  = NZ - SYSBUF + 1
      NZ    = IBUF - 1
      ICRQ  = 10 - NZ
      IF (NZ .LE. 10) GO TO 830
      NREAD = NZ/2  - 2
      NLIST = NREAD + 3
      DO 10 J = 1,2
      DO 10 I = 1,30
      FORM(I,J) = FORMS(I,J)
   10 CONTINUE
C
C     FOR EACH  TABLE DEFINED
C
      NS = -1
      DO 720 I = 1,5
      MCB(1) = IFNM(I)
      CALL RDTRL (MCB)
      IF (MCB(1) .LE. 0) GO TO 720
C
C     TABLE EXISTS SET IT UP
C
      FILE = IFNM(I)
      CALL OPEN  (*800,FILE,IZ(IBUF),0)
      CALL FNAME (FILE,TABNM)
      IO  = 0
      KMB = 4
      IF (MCB(5).EQ.1 .OR. MCB(5).EQ.3) GO TO 40
      DO 20 J = 1,NSP
      IF (KMB.EQ.1 .OR. TABNM(1).NE.SP(J)) GO TO 20
      KMB = 1
      IO  = 1
      NREAD = NZ -1
   20 CONTINUE
      IF (NS .NE. -1) GO TO 40
      NS = 1
      CALL PAGE1
      WRITE  (OUT,30) UWM
   30 FORMAT (A25,', MODULE TABPCH ASSUMES ALL REAL DATA ARE IN S.P..',
     1       '  D.P. DATA THEREFORE MAY BE PUNCHED ERRONEOUSLY')
      IF (MACH.EQ.5 .OR. MACH.EQ.6 .OR. MACH.EQ.10 .OR. MACH.EQ.21)
     1   WRITE (OUT,35)
   35 FORMAT (4X,'(ALL INTEGERS EXCEEDING 16000 ARE PUNCHED AS REAL ',
     1        'NUMBERS. ALL REAL NUMBERS OUTSIDE E-27 OR E+27 RANGE ',
     2        'ARE PUNCHED AS INTEGERS)')
C
   40 CALL READ (*810,*820,FILE,IZ(1),-2,0,ILEN)
      IRECNO = 0
      ICHR   = N1(1,I)
      IZ(3)  = 0
C
C     SET UP FIRST RECORD
C
      IZ(1) = TABNM(1)
      IZ(2) = TABNM(2)
      IZ(4) = MCB(2)
      IZ(5) = MCB(3)
      IZ(6) = MCB(4)
      IZ(7) = MCB(5)
      IZ(8) = MCB(6)
      IZ(9) = MCB(7)
      CALL READ (*700,*50,FILE,IZ(10),NREAD,0,ILEN)
      ICRQ  = NREAD
      GO TO 830
   50 ILEN  = ILEN + 11
   60 IZ(ILEN-1) = ENDREC(1)
      IZ(ILEN  ) = ENDREC(2)
      GO TO 90
C
C     BRING IN NEXT RECORD
C
   70 CALL READ (*700,*80,FILE,IZ(KMB),NREAD,IO,ILEN)
      ICRQ  = NREAD
      GO TO 830
   80 IF (KMB .EQ. 1) GO TO 600
      IZ(3) = IZ(3) + 1
      IF (ILEN .EQ. 0) GO TO 70
      ILEN  = ILEN + 5
      GO TO 60
C
C     BUILD FORMAT VECTOR  1= INTEGER, 2 =BCD, 3=REAL
C
   90 JV = 3
      DO 100 K = 1,ILEN
      M  = NLIST + K - 1
      J  = NUMTYP(IZ(K))
      IF (J.EQ.0 .AND. JV.NE.3) J = JV
      IZ(M) = LL(J+1)
  100 JV = J
C
C     MOVE DATA/FORMAT TO DATA AREA 8 FIELDS AT A TIME--SET D.F. FLAG
C
      ID   = 1
      IF   = NLIST
      IFRS = 1
C
C     HERE FOR EIGHT MORE WORDS
C
  110 IDF = 0
      IDT = 1
      IFT = 1
      NF  = 1
C
C     HERE  FOR EACH FIELD
C
  120 IDATA(IDT) = IZ(ID)
      IFORM(IFT) = IZ(IF)
      IF (IFORM(IFT) .EQ. 3) IDF = 1
      IF (IFORM(IFT) .NE. 2) GO TO 140
C
C     BCD IS TWO WORDS
C
      IDATA(IDT+1) = IZ(ID+1)
C
C     MAY BE FALSE BCD, CHECK FORMAT OF SECOND WORD ALSO
C     (SOME REAL NUMBER BIT PATTERNS LOOK LIKE BCD).
C
      IF (IZ(IF+1) .EQ. 2) GO TO 130
C
C     SECOND WORD IS NOT BCD, ASSUME FIRST WORD IS REAL.
C
      IDF = 1
      IFORM(IFT) = 3
      GO TO 140
  130 IDT = IDT + 2
      IFT = IFT + 1
      ID  = ID  + 2
      IF  = IF  + 2
      GO TO 150
C
C     REAL OR INTEGER
C
  140 IDT = IDT + 1
      IFT = IFT + 1
      ID  = ID  + 1
      IF  = IF  + 1
C
C     BUMP FIELD COUNTER
C
  150 NF = NF + 1
      IF (NF .GT.    8) GO TO 160
      IF (ID .LT. ILEN) GO TO 120
C
C     FILL  WITH BLANKS
C
      IDATA(IDT  ) = BLANK
      IDATA(IDT+1) = BLANK
      IFORM(IFT  ) = 2
      GO TO 130
C
C     PUNCH OUT 8 FIELDS OF DATA
C
  160 IDT = 0
      IF (IDF .NE. 0) GO TO 400
C
C     SINGLE FIELD CARD
C
      NF = 1
  170 M  = 2*NF + 2
      IF (IFORM(NF)-2) 180,200,210
C
C     INTEGER
C
  180 FORM(M  ,IFRS) = INT(1)
      FORM(M+1,IFRS) = INT(2)
C
C     GET NEXT ITEM
C
      IDT = IDT + 1
  190 NF  = NF  + 1
      IF (NF .LE. 8) GO TO 170
      GO TO 220
C
C     BCD
C
  200 FORM(M  ,IFRS) = IBCD(1)
      FORM(M+1,IFRS) = IBCD(2)
      IDT = IDT + 2
      GO TO 190
C
C     REAL NOT LEGAL
C
  210 IP1 = -37
      GO TO 850
C
C     PUNCH OUT SINGLE CARD
C
  220 IF (IFRS .NE. 1) GO TO 270
      DO 230 J = 1,30
      PFORM(J) = FORM(J,1)
  230 CONTINUE
      WRITE (LPCH,PFORM,ERR=240) DTI,(RDATA(M),M=1,IDT),ICHR,IRECNO
  240 IRECNO = IRECNO + 1
      IFRS = 2
      DO 250 J = 1,30
  250 FORM(J,1) = FORMS(J,1)
  260 IF (ID .GE. ILEN) GO TO 70
      GO TO 110
C
C     CONTINUATION CARD
C
  270 IRCNM1 = IRECNO - 1
      DO 280 J = 1,30
      PFORM(J) = FORM(J,2)
  280 CONTINUE
      WRITE (LPCH,PFORM,ERR=290) IPLUS,ICHR,IRCNM1,(RDATA(M),M=1,IDT),
     1                           ICHR,IRECNO
  290 IRECNO = IRECNO + 1
      DO 300 J = 1,30
  300 FORM(J,2) = FORMS(J,2)
      GO TO 260
C
C     DOUBLE FIELD CARDS
C
  400 NF = 1
      IS = 1
      IT = 4
      IDT= 0
      M  = 2
  410 M  = M + 2
      IF (IFORM(NF)-2) 420,450,460
C
C     INTEGER
C
  420 FORM(M  ,IFRS) = INTD(1)
      FORM(M+1,IFRS) = INTD(2)
  430 IDT = IDT + 1
  440 NF  = NF  + 1
      IF (M .LE. 8) GO TO 410
      GO TO 470
C
C     BCD
C
  450 FORM(M  ,IFRS) = IBCDD(1)
      FORM(M+1,IFRS) = IBCDD(2)
      IDT = IDT + 2
      GO TO 440
C
C     REAL
C
  460 FORM(M  ,IFRS) = IREAL(1)
      FORM(M+1,IFRS) = IREAL(2)
      GO TO 430
C
C     PUNCH OUT DOUBLE FIELD CARD
C
  470 IF (IFRS .NE. 1) GO TO 520
      DO 480 J = 1,30
      PFORM(J) = FORM(J,1)
  480 CONTINUE
      WRITE (LPCH,PFORM,ERR=490) DTIS,(RDATA(M),M=IS,IDT),ICHR,IRECNO
  490 IRECNO = IRECNO + 1
      DO 500 J = 1,30
  500 FORM(J,1) = FORMS(J,1)
      IFRS = 2
  510 IT = 8
      M  = 2
      IS = IDT + 1
      GO TO 410
C
C     CONTINUATION CARD
C
  520 IRCNM1 = IRECNO - 1
      DO 530 J = 1,30
      PFORM(J) = FORM(J,2)
  530 CONTINUE
      WRITE (LPCH,PFORM,ERR=540) ISTAR,ICHR,IRCNM1,(RDATA(M),M=IS,IDT),
     1                           ICHR,IRECNO
  540 IRECNO = IRECNO + 1
      DO 550 J = 1,30
  550 FORM(J,2) = FORMS(J,2)
      IF (IT .EQ. 4) GO TO 510
      GO TO 260
C
C     PUNCH KELM, MELM AND BELM IN D.P.
C
  600 IF (ILEN .EQ. 0) GO TO 70
      ILEN = ILEN/2
      JE = 0
  610 JB = JE + 1
      JE = JE + 4
      IRCNM1 = IRECNO
      IRECNO = IRECNO + 1
      IF (JE .GE. ILEN) GO TO 630
      WRITE  (LPCH,620,ERR=840) ICHR,IRCNM1,(DZ(J),J=JB,JE),ICHR,IRECNO
  620 FORMAT (1H*,A2,I5,1P,4D16.9,1X,A2,I5)
      GO TO 610
  630 JE = ILEN
      WRITE  (LPCH,640,ERR=840) ICHR,IRCNM1,(DZ(J),J=JB,JE)
  640 FORMAT (1H*,A2,I5,1P,4D16.9)
      GO TO 70
C
C     CLOSE OFF FILES
C
  700 CALL CLOSE (FILE,1)
      CALL PAGE2 (2)
      WRITE  (OUT,710) UIM,TABNM,IRECNO
  710 FORMAT (A29,' 4015, TABLE ',2A4,' WAS PUNCHED OUT,',I8,' CARDS.')
  720 CONTINUE
      WRITE  (LPCH,730)
  730 FORMAT (1H , /,1H , /,1H )
      RETURN
C
C     ERROR MESAGES
C
  800 IP1 = -1
      GO TO 850
  810 IP1 =-2
      GO TO 850
  820 IP1 =-3
      GO TO 850
  830 IP1 = -8
      FILE = ICRQ
      GO TO 850
  840 IP1 = -37
C
  850 CALL MESAGE (IP1,FILE,NAME)
      RETURN
      END

      SUBROUTINE CSQRTX(XX,Y)
C*******
C     ROUTINE TO FIND THE COMPLEX SQUARE ROOT OF X AND STORE IT IN Y
C*******
      DOUBLE PRECISION XX(2),X(2),Y(2),R
      X(1) = XX(1)
      X(2) = XX(2)
      R = DSQRT(X(1)**2+X(2)**2)
      Y(1) = DSQRT(DABS(X(1)+R)/2.)
      Y(2) = DSQRT(DABS(-X(1)+R)/2.)
      IF(X(2) .EQ. 0.0D0) RETURN
      Y(2) = DSIGN(Y(2),X(2))
      RETURN
      END

      SUBROUTINE GAUSS (A,N,N2)
C
      COMPLEX A(20,1)
C
      DO 100 I=1,N
      K=I+1
      DO 10 J=K,N2
   10 A(I,J)=A(I,J)/A(I,I)
      DO 30 M=1,N
      IF(M.EQ.I) GO TO 30
      DO 20 L=K,N2
   20 A(M,L)=A(M,L)-A(M,I)*A(I,L)
   30 CONTINUE
  100 CONTINUE
      RETURN
      END

      SUBROUTINE DPPSB(  KS,I,J1,J2,SGR,CGR,           YS,ZS,NBARAY,
     1           NCARAY,DT,Z)
C   ***   GENERATES ROWS OF THE  DPP  SUBMATRIX USING
C         SUBROUTINE  SUBP
      INTEGER Z
      DIMENSION YS(1),ZS(1),NBARAY(1),NCARAY(1),Z(1)
      COMPLEX SUM,DT(1)
      COMMON /DLBDY/ NJ1,NK1,NP,NB,NTP,NBZ,NBY,NTZ,NTY,NT0,NTZS,NTYS,
     *   INC,INS,INB,INAS,IZIN,IYIN,INBEA1,INBEA2,INSBEA,IZB,IYB,
     *   IAVR,IARB,INFL,IXLE,IXTE,INT121,INT122,IZS,IYS,ICS,IEE,ISG,
     *   ICG,IXIJ,IX,IDELX,IXIC,IXLAM,IA0,IXIS1,IXIS2,IA0P,IRIA
     *  ,INASB,IFLA1,IFLA2,ITH1A,ITH2A,
     *   ECORE,NEXT,SCR1,SCR2,SCR3,SCR4,SCR5
      L    = 1
C  L IS THE PANEL NUMBER ASSOCIATED WITH SENDING   POINT  J
      LS   = 1
      LSP = 0
C  LS IS THE STRIP NUMBER ASSOCIATED WITH SENDING   POINT  J
      NBXS = NBARAY(L)
      NC1  = NCARAY(L)
      NBCUM= NC1
      YREC = YS(KS)
      ZREC = ZS(KS)
      DO   20  J=J1,J2
      CALL SUBPB(I,L,LS,J,SGR,CGR,YREC,ZREC,SUM,Z(IXIC),Z(IDELX),Z(IEE)
     * ,Z(IXLAM),Z(ISG),Z(ICG),Z(IYS),Z(IZS),Z(INAS),Z(INASB+LSP),
     *  Z(IAVR),Z(IZB),Z(IYB),Z(IARB),Z(IXLE),Z(IXTE),Z(IX),NB)
      DT(J)= SUM
      IF (J.EQ.J2)  GO TO   20
      IF (J.LT.NBXS)   GO TO  10
      LSP = LSP + Z(INAS+L-1)
      L    = L+1
      NC1  = NCARAY(L)
      NBXS = NBARAY(L)
   10 CONTINUE
      IF (J.LT.NBCUM)  GO TO  20
      LS   = LS+1
      NBCUM= NBCUM+NC1
   20 CONTINUE
      RETURN
      END

      SUBROUTINE OFSPLT (*,ESYM,ELID,G,OFFSET,X,DEFORM,GPLST)
C
C     CALLED ONLY BY LINEL TO PRCESS ELEMENT OFFSET PLOT
C     THIS ROUTINE DRAW THE CBAR, CTRIA3, AND CQUAD4, WITH OFFSET IN
C     PLACE.
C
C     INPUT:
C         ESYM   = BCD, SHOULD BE 'BR', 'T3', OR 'Q4'                BCD
C         ELID   = ELEMENT ID                                         I
C         G      = SIL LIST                                           I
C         OFFSET = 6 COORDINATES (GLOBAL) FOR CBAR,                   I
C                = 1 OFFSET, NORMAL TO PLATE, FOR CTRIA3 OR CQUAD4
C         X      = GRID POINT COORDINATE, ALREADY CONVERTED TO SCREEN
C                  (X-Y) COORDINATES                                  R
C         DEFORM = 0, FOR UNDEFORM PLOT,  .NE.0 FOR DEFORMED OR BOTH  I
C                  THIS ROUTINE WILL NOT PROCESS DEFORMED-OFFSET PLOT
C         OFFSCL = OFFSET MULTIPLICATION FACTOR                       I
C         PEDGE  = OFFSET PLOT FLAG                                   I
C                = 3, PLOT OFFSET ELEMENTS ONLY, SKIP OTHER ELEMNETS
C            NOT = 3, PLOT OFFSET ELEMENTS, RETURN TO PLOT OTHERS
C         PLABEL = FLAG FOR ELEM ID LABEL                             I
C         PEN    = PEN SELECTION, 1-31.  32-62 FOR COLOR FILL         I
C         OFFLAG = HEADING CONTROL                                    I
C         ELSET  = ECT DATA BLOCK. THIS DATA BLOCK WAS MODIFIED IN    I
C                  COMECT TO INCLUDE OFFSET DATA FOR BAR,TRIA3,QUAD4
C         GPLST  = A SUBSET OF GRID POINTS PERTAININGS TO THOSE GRID  I
C                  POINTS USED ONLY IN THIS PLOT
C     LOCAL:
C         SCALE  = REAL NUMBER OF OFFSCL
C         OFF    = OFFSET VALUES FROM ELEMENT DATA IN ELSET DATA BLOCK
C         PN1    = PEN COLOR FOR OFFSET LEG.
C                  IF PEN.GT.1, PN1 = PEN-1. IF PEN.LE.1, PN1 = PEN+1
C         NL     = NO. OF LINES TO BE DRAWN PER ELEMENT
C         DELX   = SMALL OFFSET FROM MIDDLE OF LINE FOR ELEM ID PRINTING
C         0.707  = AN ABITRARY FACTOR TO PUT OFFSET 45 DEGREE OFF GRID
C                  POINT
C
C     TWO METHODS
C     (1) PEDGE .NE. 3
C         AN OFFSET PLOT WITHOUT CONSIDERING ITS TRUE DIRECTION, OFFSET
C         VALUE(S) MAGNIFIED 20 TIMES
C     (2) PEDGE .EQ. 3
C         PLOT WITH TRUE OFFSET DIRECTIONS, AND PLOT, WITH COLOR OPTION,
C         GRID(A)-OFFSET(A)-OFFSET(B)-GRID(B)
C         OFFSET CAN BE SCALE UP BY USER VIA PLOT OFFSET COMMAND,
C         DEFAULT IS NO SCALE UP. (NEW 93)
C
C     A SYMBOL * IS ADDED AT THE TIP OF EACH OFFSET
C     CURRENTLY THE SYMBOLS KBAR,KT3 AND KQ4 ARE NOT USED
C
C     CURRENTLY ONLY CBAR (OFFSET=6), CTRIA3 AND CQUAD4 (OFFSET=1 BOTH)
C     HAVE OFFSET CAPABILITY
C
C     WRITTEN BY G.CHAN/UNISYS   10/1990
C
C     COMMENTS FORM G.C.  3/93
C     THE LOGIC IN COMPUTING THE TRUE OFFSET INVOLVING COORDINATE
C     TRANSFORMATION AT EACH POINT POINT SEEMS SHAKY. MAKE SURE THAT
C     AXIS AND SIGN DATA (FROM PROCES) ARE TRUELY AVAILBLE. ARE THE
C     GIRD POINT XYZ COORDINATES AT HAND IN GLOBAL ALREADY?
C     THE OFFSET PLOT IS QUESTIONABLE.
C
      IMPLICIT INTEGER (A-Z)
      INTEGER         G(3),OFFHDG(5),SYM(2),GPLST(1)
      REAL            X(3,1),OFF(3,2),V(3),CSTM,SIGN,X1,X2,X3,Y1,Y2,Y3,
     1                XMAX,YMAX,YMAX1,CNTX,CNTY,CNTY4,SCALE,DELX,
     2                OFV(3,2)
      COMMON /BLANK / SKP1(12),ELSET
      COMMON /SYSTEM/ SKP2,NOUT
      COMMON /RSTXXX/ CSTM(3,3),SKP3(12),AXIS(3),SIGN(3)
      COMMON /XXPARM/ SKP4(235),OFFSCL
      COMMON /DRWDAT/ SKP5,PLABEL,SKP6,PEN,SKP7(11),PEDGE,OFFLAG
      COMMON /PLTDAT/ SKP8(6),XMAX,YMAX,SKP9(15),CNTX,CNTY
      DATA    KBAR  , KT3,KQ4 / 2HBR,2HT3,2HQ4 /, SYM / 2,0 /
      DATA    OFFHDG/ 4H OFF,4HSET ,4HSCAL,4HE = ,4H   X    /
C
      CALL FREAD (ELSET,OFF,OFFSET,0)
C
      IF (DEFORM.NE.0 .OR. OFFSCL.LT.0) GO TO 200
      IF (PEDGE.NE.3 .OR. OFFLAG.EQ.1) GO TO 20
      OFFLAG= 1
      CNTY4 = 4.*CNTY
      YMAX1 = YMAX - CNTY
      SCALE = 1.0
      IF (PEDGE .NE. 3) SCALE = 20.0
      IF (PEDGE .EQ. 3) SCALE = FLOAT(OFFSCL)
      MPEN  = MOD(PEN,31)
      IF (MPEN .GT. 1) PN1  = MPEN - 1
      IF (MPEN .LE. 1) PN1  = MPEN + 1
C
C     ADD OFFSET HEADER LINE
C
      CALL PRINT  (30.*CNTX,YMAX,1,OFFHDG,5,0)
      X1 = 48.
      IF (OFFSCL .GE. 100) X1 = 47.
      CALL TYPINT (X1*CNTX,YMAX,1,OFFSCL,1,0)
C
   20 X1 = 0.0
      DO 30 I = 1,OFFSET
      X1 = X1 + ABS(OFF(I,1))
      OFV(I,1) = OFF(I,1)
   30 CONTINUE
      IF (ABS(X1) .LT. 1.0E-7) GO TO 200
C
      NL = 1
      IF (ESYM .EQ. KT3) NL = 3
      IF (ESYM .EQ. KQ4) NL = 4
      IF (PEDGE  .NE. 3) GO TO 150
C
      J    = ALOG10(FLOAT(ELID)) + 1.0
      DELX = (J+.03)*CNTX
C
C     COMPUTE THE TRUE OFFSET DIRECTION IF PEDGE = 3,
C     OTHERWISE, JUST PLOT OFFSET AT 45 DEGREE
C
      IF (OFFSET .EQ. 1) GO TO 90
C
C     CBAR, OFFSET = 6
C     CONVERT OFFSET FROM GLOBAL TO PLOT COORDINATES
C
C     AXIS AND SIGN DATA FROM SUBROUTINE PROCES
C
      DO 80 K = 1,2
      DO 50 I = 1,3
      J    = AXIS(I)
      V(J) = SIGN(I)*OFV(J,K)
   50 CONTINUE
      DO 70 J = 1,3
                                L = AXIS(J)
      X1 = 0.0
      DO 60 I = 1,3
                                X1 = X1 + CSTM(L,I)*V(I)
   60 CONTINUE
      OFF(J,K) = X1*SCALE
   70 CONTINUE
   80 CONTINUE
      GO TO 110
C
C     CTRIA3 AND CQUAD4, OFFSET = 1
C     COMPUTE UNIT NORMAL TO THE PLATE BY CROSS PRODUCT, THEN
C     THE MAGNITUDE OF OFFSET
C
   90 I = G(1)
      J = G(2)
      K = G(3)
      I = GPLST(I)
      J = GPLST(J)
      K = GPLST(K)
      V(1) = (X(2,J)-X(2,I))*(X(3,K)-X(3,I))
     1     - (X(3,J)-X(3,I))*(X(2,K)-X(2,I))
      V(2) = (X(3,J)-X(3,I))*(X(1,K)-X(1,I))
     1     - (X(1,J)-X(1,I))*(X(3,K)-X(3,I))
      V(3) = (X(1,J)-X(1,I))*(X(2,K)-X(2,I))
     1     - (X(2,J)-X(2,I))*(X(1,K)-X(1,I))
      X1   = 0.5*SQRT(V(1)*V(1) + V(2)*V(2) + V(3)*V(3))
      V(2) = V(2)/X1
      V(3) = V(3)/X1
      OFF(2,1) = OFV(1,1)*V(2)*SCALE
      OFF(3,1) = OFV(1,1)*V(3)*SCALE
      OFF(2,2) = OFF(2,1)
      OFF(3,2) = OFF(3,1)
C
C     DRAW THE ELEMENT LINES AND ELEMENT ID
C     IF COLOR FILL IS REQUESTED, SET PEN TO ZERO ON THE LAST CLOSING-IN
C     EDGE (2- OR 3-DIMESIONAL ELEMENTS ONLY)
C
  110 DO 130 L = 1,NL
      I  = G(L  )
      J  = G(L+1)
      I  = GPLST(I)
      J  = GPLST(J)
      X1 = X(2,I)
      Y1 = X(3,I)
      X2 = X(2,I) + OFF(2,1)
      Y2 = X(3,I) + OFF(3,1)
      IF (X2 .LT.   0.1) X2 = 0.1
      IF (X2 .GT.  XMAX) X2 = XMAX
      IF (Y2 .LT. CNTY4) Y2 = CNTY4
      IF (Y2 .GT. YMAX1) Y2 = YMAX1
      CALL LINE (X1,Y1,X2,Y2,PN1,0)
      CALL SYMBOL (X2,Y2,SYM,0)
      X3 = X(2,J) + OFF(2,2)
      Y3 = X(3,J) + OFF(3,2)
      IF (X3 .LT.   0.1) X3 = 0.1
      IF (X3 .GT.  XMAX) X3 = XMAX
      IF (Y3 .LT. CNTY4) Y3 = CNTY4
      IF (Y3 .GT. YMAX1) Y3 = YMAX1
      IPEN = PEN
      IF (PEN.GT.31 .AND. NL.GE.3 .AND. L.EQ.NL) IPEN = 0
      CALL LINE (X2,Y2,X3,Y3,IPEN,0)
C
      IF (L .GT. 1) GO TO 130
      IF (PLABEL.NE.3 .AND. PLABEL.NE.6) GO TO 120
      IF (X2 .GE. X1) DELX = -DELX
      X1 = 0.5*(X3 + X2) + DELX
      Y1 = 0.5*(Y3 + Y2)
      CALL TYPINT (X1,Y1,1,ELID,1,0)
  120 IF (NL .GT. 1) GO TO 130
      CALL SYMBOL (X3,Y3,SYM,0)
      X2 = X(2,J)
      Y2 = X(3,J)
      CALL LINE (X3,Y3,X2,Y2,PEN,0)
  130 CONTINUE
      GO TO 210
C
C     PLOT OFFSET WITHOUT CONSIDERING ITS TRUE OFFSET DIRECTION IN
C     GENERAL PLOT. (SEE 130 LOOP FOR ELEMENTS WITH COLOR FILL)
C
  150 IF (OFFSET .EQ. 1) GO TO 160
      V(1) = OFF(1,1)*OFF(1,1) + OFF(2,1)*OFF(2,1) + OFF(3,1)*OFF(3,1)
      V(2) = OFF(1,2)*OFF(1,2) + OFF(2,2)*OFF(2,2) + OFF(3,2)*OFF(3,2)
      V(1) = 0.707*SQRT(V(1))
      V(2) = 0.707*SQRT(V(2))
      GO TO 170
C
  160 V(1) = 0.707*OFF(1,1)
      V(2) = V(1)
C
  170       V(1) = V(1)*SCALE
            V(2) = V(2)*SCALE
            DO 180 L = 1,NL
      I  = G(L  )
      J  = G(L+1)
      I  = GPLST(I)
      J  = GPLST(J)
      X1 = X(2,I) + V(1)
      Y1 = X(3,I) + V(1)
      X2 = X(2,J) + V(2)
      Y2 = X(3,J) + V(2)
      IPEN = PEN
      IF (PEN.GT.31 .AND. NL.GE.3 .AND. L.EQ.NL) IPEN = 0
      CALL LINE (X1,Y1,X2,Y2,IPEN,0)
      CALL SYMBOL (X1,Y1,SYM,0)
      IF (NL .EQ. 1) CALL SYMBOL (X2,Y2,SYM,0)
  180 CONTINUE
      GO TO 210
C
  200 IF (PEDGE.NE.3 .OR. OFFSCL.LT.0) RETURN
  210 RETURN 1
      END

      SUBROUTINE GEND(NCARAY,NBARAY,YS,ZS,SG,CG,DT,WORK,MATOUT)
C  GENERATE THE INFLUENCE COEFFICIENT MATRIX ADPP
      COMPLEX DT
      DIMENSION NCARAY(1),NBARAY(1),YS(1),ZS(1),SG(1),CG(1),
     1          DT(1),WORK(1)
      COMMON /AMGMN / MCB(7),NROW,ND,NE,REFC,FMACH,RFK
      COMMON /DLCOM / NP,NSTRIP,NTP,F,NJJ,NEXT,LENGTH,
     1                INC,INB,IYS,IZS,IEE,ISG,ICG,
     2                IXIC,IDELX,IXLAM,IDT,
     3  ICORE
      I1 = 1
      I2 = NTP
      J1 = 1
      J2 = NTP
C
C     POSITION IN DT TO START OF THIS PART OF MATRIX
C
      IDTPT = I1 + NROW
      DO 10 I = I1,NJJ
   10 DT(I) = (0.0,0.0)
C     DPP LOOP
      K = 1
C     K IS THE PANEL NUMBER
      KS = 1
C     KS IS THE STRIP NUMBER
      NBXR = NCARAY(K)
      DO 60 I = I1,I2
      SGR = SG(KS)
      CGR = CG(KS)
      CALL DPPS(KS,I,J1,J2,SGR,CGR,YS,ZS,NBARAY,NCARAY,DT(IDTPT),WORK)
      CALL PACK(DT,MATOUT,MCB)
      IF(I.EQ.I2) GO TO 60
      IF(I.EQ.NBARAY(K)) K=K+1
      IF(I.EQ.NBXR) GO TO 50
      GO TO 60
   50 CONTINUE
      KS = KS +1
      NBXR = NBXR + NCARAY(K)
   60 CONTINUE
      RETURN
      END

      SUBROUTINE ALG10
C
      REAL LOSS,LAMI,LAMIP1,LAMIM1
C
      COMMON /UD300C/ NSTNS,NSTRMS,NMAX,NFORCE,NBL,NCASE,NSPLIT,NREAD,
     1NPUNCH,NPAGE,NSET1,NSET2,ISTAG,ICASE,IFAILO,IPASS,I,IVFAIL,IFFAIL,
     2NMIX,NTRANS,NPLOT,ILOSS,LNCT,ITUB,IMID,IFAIL,ITER,LOG1,LOG2,LOG3,
     3LOG4,LOG5,LOG6,IPRINT,NMANY,NSTPLT,NEQN,NSPEC(30),NWORK(30),
     4NLOSS(30),NDATA(30),NTERP(30),NMACH(30),NL1(30),NL2(30),NDIMEN(30)
     5,IS1(30),IS2(30),IS3(30),NEVAL(30),NDIFF(4),NDEL(30),NLITER(30),
     6NM(2),NRAD(2),NCURVE(30),NWHICH(30),NOUT1(30),NOUT2(30),NOUT3(30),
     7NBLADE(30),DM(11,5,2),WFRAC(11,5,2),R(21,30),XL(21,30),X(21,30),
     8H(21,30),S(21,30),VM(21,30),VW(21,30),TBETA(21,30),DIFF(15,4),
     9FDHUB(15,4),FDMID(15,4),FDTIP(15,4),TERAD(5,2),DATAC(100),
     1DATA1(100),DATA2(100),DATA3(100),DATA4(100),DATA5(100),DATA6(100),
     2DATA7(100),DATA8(100),DATA9(100),FLOW(10),SPEED(30),SPDFAC(10),
     3BBLOCK(30),BDIST(30),WBLOCK(30),WWBL(30),XSTN(150),RSTN(150),
     4DELF(30),DELC(100),DELTA(100),TITLE(18),DRDM2(30),RIM1(30),
     5XIM1(30),WORK(21),LOSS(21),TANEPS(21),XI(21),VV(21),DELW(21),
     6LAMI(21),LAMIM1(21),LAMIP1(21),PHI(21),CR(21),GAMA(21),SPPG(21),
     7CPPG(21),HKEEP(21),SKEEP(21),VWKEEP(21),DELH(30),DELT(30),VISK,
     8SHAPE,SCLFAC,EJ,G,TOLNCE,XSCALE,PSCALE,PLOW,RLOW,XMMAX,RCONST,
     9FM2,HMIN,C1,PI,CONTR,CONMX
C
      IF(I.GT.1)GO TO 130
      V5=VISK**0.2
      VINH=0.0
      VINT=0.0
      IF(WWBL(1).GT.0.0)GO TO 100
      C1H=0.0
      C1T=0.0
      DELH(1)=0.0
      DELT(1)=0.0
      GO TO 150
100   IF(ISTAG.GT.0)GO TO 110
      X1=WWBL(1)*XL(NSTRMS,1)*(CPPG(1)+CPPG(NSTRMS))/4.0
      DELH(1)=X1
      DELT(1)=X1
      X1=X1/(SCLFAC*SHAPE)
      C1H=(X1*VM(1,1)**3.4/V5)**1.25
      C1T=(X1*VM(NSTRMS,1)**3.4/V5)**1.25
      GO TO 150
110   DELH(1)=0.0
      C1H=0.0
      IF(ABS(PHI(NSTRMS)).GT.PI/2.0-0.00015.AND.ABS(PHI(NSTRMS)).LT.PI/2
     1.0+0.00015)GO TO 120
      X1=(R(NSTRMS,1)-SQRT(R(NSTRMS,1)**2-COS(PHI(NSTRMS))*CPPG(NSTRMS)*
     1WWBL(1)*(R(NSTRMS,1)+R(1,1))*XL(NSTRMS,I)))/COS(PHI(NSTRMS))
      DELT(1)=X1
      C1T=(X1/(SHAPE*SCLFAC*V5)*VM(NSTRMS,1)**3.4)**1.25
      GO TO 150
120   DELT(1)=WWBL(1)*XL(NSTRMS,1)/CPPG(NSTRMS)
      C1T=(DELT(1)*VM(NSTRMS,1)**3.4/(V5*SCLFAC*SHAPE))**1.25
      GO TO 150
130   VINT=VINT+SQRT((X(NSTRMS,I)-X(NSTRMS,I-1))**2+(R(NSTRMS,I)-R(NSTRM
     1S,I-1))**2)*((VM(NSTRMS,I)+VM(NSTRMS,I-1))/2.0)**4/SCLFAC
      DELT(I)=V5*(C1T+0.016*VINT)**0.8/VM(NSTRMS,I)**3.4*SCLFAC*SHAPE
      DELH(I)=0.0
      IF(I.LE.ISTAG)GO TO 140
      VINH=VINH+SQRT((X(1,I)-X(1,I-1))**2+(R(1,I)-R(1,I-1))**2)*((VM(1,I
     1)+VM(1,I-1))/2.0)**4/SCLFAC
      DELH(I)=V5*(C1H+0.016*VINH)**0.8/VM(1,I)**3.4*SCLFAC*SHAPE
140   WWBL(I)=0.5*WWBL(I)+0.5*(((2.0*R(NSTRMS,I)-DELT(I)*COS(PHI(NSTRMS)
     1))*DELT(I)/CPPG(NSTRMS)+(2.0*R(1,I)+DELH(I)*COS(PHI(1)))*DELH(I)/C
     2PPG(1))/((R(NSTRMS,I)+R(1,I))*XL(NSTRMS,I)))
      IF(WWBL(I).GT.0.3)WWBL(I)=0.3
      IF(WWBL(I).LT.0.0)WWBL(I)=0.3
150   CONTINUE
      RETURN
      END

      SUBROUTINE OFPGPW (*,FILE,OUT,FROM)
C
C     PRINT GRID POINT WEIGHT GENERATORN TABLE
C     (SOURCE PROGRAM ORIGINALLY CODED IN OFP)
C
      INTEGER          FILE,FLAG,FROM,OF(5)
      DOUBLE PRECISION OUT(1)
      COMMON /SYSTEM/  IBUF,L,DUMMY(10),LINE
      COMMON /ZZZZZZ/  CORE(1)
      EQUIVALENCE      (L1,OF(1),CORE(1)), (L2,OF(2)), (L3,OF(3)),
     1                 (L4,OF(4)), (L5,OF(5))
C
C     FOR GRIDPOINT WEIGHT OUTPUT ONLY ONE DATA VECTOR OF 78 WORDS
C     IS EXPECTED AND IT IS THUS READ AND OUTPUT EXPLICITLY
C     (CHANGED TO D.P. BY G.CHAN/UNISYS, AND THEREFORE 156 WORDS.
C     THIS RECORD IS SENT OVER BY GPWG1B, WHICH IS NOW A D.P. ROUTINE)
C
      FROM = 345
      CALL READ (*2020,*60,FILE,OUT(1),90,0,FLAG)
      L1 = 0
      L2 = 0
      L3 = 202
      L4 = 0
      L5 = 0
      CALL OFP1
      LINE = LINE + 44
      WRITE  (L,350) (OUT(I),I=1,45)
  350 FORMAT (37X,
     1       'MO - RIGID BODY MASS MATRIX IN BASIC COORDINATE SYSTEM',
     2       /16X,3H***,93X,3H***, /6(16X,1H*,1P,6D16.8,2H *,/),16X,
     3       3H***,93X,3H***, /40X,
     4       51HS - TRANSFORMATION MATRIX FOR SCALAR MASS PARTITION,
     5       /2(40X,3H***,5X), /3(40X,1H*,1P,3D16.8,2H *,/),2(40X,3H***,
     4       5X),  /25X,9HDIRECTION, /20X,20HMASS AXIS SYSTEM (S),7X,
     5       4HMASS,17X,6HX-C.G.,11X,6HY-C.G.,11X,6HZ-C.G.)
      FROM = 355
      CALL READ (*2020,*60,FILE,OUT(1),66,1,FLAG)
      WRITE  (L,360) (OUT(I),I=1,12)
  360 FORMAT (28X,1HX,1P,D27.9,1P,D21.9,1P,2D17.9,/
     1        28X,1HY,1P,D27.9,1P,D21.9,1P,2D17.9,/
     2        28X,1HZ,1P,D27.9,1P,D21.9,1P,2D17.9)
      WRITE  (L,370) (OUT(I),I=13,33)
  370 FORMAT (/49X,33HI(S) - INERTIAS RELATIVE TO C.G. , /2(38X,3H***,
     1       11X), /3(38X,1H*,1P,3D17.9,3H  *,/),2(38X,3H***,11X), /54X,
     2       25HI(Q) - PRINCIPAL INERTIAS, /2(38X,3H***,11X), /38X,1H*,
     3       1P,D17.9,36X,1H*, /38X,1H*,1P,D34.9,19X,1H*, /38X,1H*,1P,
     4       D51.9,3H  *, /2(38X,3H***,11X), /44X,
     5       44HQ - TRANSFORMATION MATRIX - I(Q) = QT*I(S)*Q, /2(38X,
     6       3H***,11X),/3(38X,1H*,1P,3D17.9,3H  *,/),2(38X,3H***,11X))
  60  RETURN
C
 2020 RETURN 1
      END

      SUBROUTINE EM2D (ITYPE,ISTART,JTYPE,NCOUNT,IDO,IWORDS,NBDYS,ALL,
     1                 NELOUT)
C
C     COMPUTES ADDITIONAL E AND M LOADS FOR TWO DIMENSIONAL ELEMENTS
C
C     THIS ROUTINE HANDLES THE FOLLOWING 2-D ELEMENTS
C
C     TRIA1 -6-   TRMEM -9-   QDMEM-16-  TRIA2-17-  QUAD2-18-  QUAD1-19-
C     TRIARG-36-  TRAPRG-37   IS2D8-80-
C
      LOGICAL         ONLYC
      INTEGER         OTPE,ALL,POINTR(9,9),TYPOLD,SCR6
      REAL            L(3,4),W(4)
      DIMENSION       BUF(50),JBUF(50),XLACC(3),IZ(1),NAM(2),NECPT(10),
     1                R(3,8),IP(3),HC(3),XLOAD(3),D12(3),D13(3),XN(18),
     2                G(9),DXX(3),ZI(3),ZJ(3),ZK(3),ET(9),XNG(9),HCX(3),
     3                HCY(3),HCZ(3),ISC(5),SC(5),PT(3),H(3),Z14(3),
     4                XZ(16),VEC(3),VVEC(3),HCI(24),F(8),GH(3),DN(8),
     5                DNXI(1),DNETA(1),DNC(16),DNL(16),DNX(1),DNY(1),
     6                XI(8),ETA(8),XJB(4),XXJB(2,2),IWS(2,3),HCXYZ(3),
     7                DDNL(24),DDNLB(24)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /SYSTEM/ IBUF,OTPE,IDUM(78)
      COMMON /BLANK / NROWSP
      COMMON /EMECPT/ ECPT(200)
      COMMON /ZZZZZZ/ Z(1)
      COMMON /MATIN / MATID,INFLAG,ELTEMP,STRESS,SINTH,COSTH
      COMMON /HMTOUT/ XMAT(6)
      EQUIVALENCE     (BUF(1),JBUF(1)),(SC(1),ISC(1)),(Z(1),IZ(1)),
     1                (ECPT(1),NECPT(1)),(I1,IP(1)),(I2,IP(2)),
     2                (I3,IP(3)),(DNC(1),DNXI(1)),(DNC(9),DNETA(1)),
     3                (DNL(1),DNX(1)),(DNL(9),DNY(1))
      DATA    XI    / -1., 1., 1.,-1., 0., 1., 0.,-1./
      DATA    ETA   / -1.,-1., 1., 1.,-1., 0., 1., 0./
      DATA    TWOPI3/ 2.094395103  /
      DATA    NAM   / 4HEM2D,4H    /
      DATA    TYPOLD/ 0 /,   SCR6  / 306/
C
C     EST STARTING POINTERS
C
C     ISIL   = 1ST SIL NUMBER
C     ITH    = MATERIAL ANGLE
C     MID    = MATERIAL ID
C     IA     = AREA FACTOR (TO COMPUTE VOLUME)
C     ISYS   = 1ST OUTPUT CORRDINATE SYSYTEM NUMBER
C     NGRIDS = NUMBER OF GRID POINTS
C     ITEMP  = ELEMENT TEMPERATURE
C     NEL    = NUMBER OF TRIANGLES USED TO FORM ELEMENT
C
C              ITYPE ISIL ITH MID IA ISYS NGRIDS ITEMP NEL
C
      DATA    POINTR/  6,    2,  5,  6,  7, 15,    3,    27,  1,
     1                 9,    2,  5,  6,  7,  9,    3,    21,  1,
     2                16,    2,  6,  7,  8, 10,    4,    26,  4,
     3                17,    2,  5,  6,  7,  9,    3,    21,  1,
     4                18,    2,  6,  7,  8, 10,    4,    26,  4,
     5                19,    2,  6,  7,  8, 16,    4,    32,  4,
     6                36,    2,  5,  6,  0,  7,    3,    19,  1,
     7                37,    2,  6,  7,  0,  8,    4,    24,  4,
     8                80,    2, 11, 12, 13, 14,    8,    46,  1/
C
      ONLYC  = .FALSE.
      IF (ITYPE .EQ. 80) GO TO 10
      L(1,1) = 1./3.
      L(2,1) = L(1,1)
      L(3,1) = L(1,1)
      L(1,2) = .6
      L(2,2) = .2
      L(3,2) = .2
      L(1,3) = .2
      L(2,3) = .6
      L(3,3) = .2
      L(1,4) = .2
      L(2,4) = .2
      L(3,4) = .6
      W(1)   =-27./48.
      W(2)   = 25./48.
      W(3)   = W(2)
      W(4)   = W(2)
      NOPTS  = 4
   10 CONTINUE
      ISC(1) = NECPT(1)
      ISC(2) = 1
      IF (ITYPE .EQ. 80) ISC(2) = 9
C
C     FIND ELEMENT TYPE TO PICK UP POINTERS
C
      IF (ITYPE .EQ. TYPOLD) GO TO 40
      TYPOLD = ITYPE
      DO 20 I = 1,9
      JEL = I
      IF (ITYPE-POINTR(1,I)) 1600,30,20
   20 CONTINUE
      GO TO 1600
C
   30 ISIL  = POINTR(2,JEL)
      ITH   = POINTR(3,JEL)
      MID   = POINTR(4,JEL)
      IA    = POINTR(5,JEL)
      ISYS  = POINTR(6,JEL)
      NGRIDS= POINTR(7,JEL)
      ITEMP = POINTR(8,JEL)
      NEL   = POINTR(9,JEL)
C
C     CHECK TO SEE IF THIS ELEMENT CONTAINS A GRID POINT ON A PERMBDY
C     CARD. IF SO, OR IF NO PERMBDY CARD EXISTS, COMPUTE LOADS FOR THE
C     ELEMENT. IF NOT, COMPUTE HC CENTROIDAL VALUE ONLY. (ONLYC=.TRUE.)
C     THE PERMBDY SILS START AT Z(ISTART-NBDYS-1)
C
   40 IF (NBDYS .EQ. 0) GO TO 60
C
      DO 50 I = 1,NGRIDS
      NG = NECPT(ISIL+I-1)
      DO 50 J = 1,NBDYS
      IF (NG .EQ. IZ(ISTART-NBDYS-NELOUT+J-1)) GO TO 60
   50 CONTINUE
C
C     ELEMENT HAS NO GRIDS ON PERMBDY
C
      ONLYC = .TRUE.
      NOPTS = 0
   60 IF (ONLYC .AND. JTYPE.EQ.24) RETURN
C
C     IF ONLYC=TRUE, CHECK TO SEE IF THE ELEMENT HAD AN ELFORCE REQUEST.
C     IF SO, CONTINUE. IF NOT, JUST WRITE ZEROS TO HCCEN,SCR6) AND
C     RETURN.
C
      IF(.NOT.ONLYC) GO TO 80
      IF(ALL .EQ. 1) GO TO 80
      IF(NELOUT .EQ. 0) GO TO 110
C
      DO 70 I = 1,NELOUT
      IF (NECPT(1) .EQ. IZ(ISTART-NELOUT+I-1)) GO TO 80
   70 CONTINUE
      GO TO 110
C
C     CHECK FOR ZERO LOAD
C
   80 IF (JTYPE.NE.20 .AND. JTYPE.NE.24) GO TO 210
      H1 = 0.
      H2 = 0.
      H3 = 0.
      G1 = 0.
      G2 = 0.
      G3 = 0.
      DO 90 I = 1,NGRIDS
      ISUB = ISTART + 3*NECPT(ISIL+I-1) - 3
      IF (JTYPE .EQ. 24) ISUB = ISTART + 3*NCOUNT - 3
      H1 = H1 + ABS(Z(ISUB  ))
      H2 = H2 + ABS(Z(ISUB+1))
      H3 = H3 + ABS(Z(ISUB+2))
      G1 = G1 + Z(ISUB  )
      G2 = G2 + Z(ISUB+1)
      G3 = G3 + Z(ISUB+2)
      IF (JTYPE .EQ. 24) GO TO 100
   90 CONTINUE
  100 HL = H1 + H2 + H3
      IF (HL .NE. 0.) GO TO 200
      IF (JTYPE .EQ. 24) RETURN
C
C     ALL ZEROS - WRITE TO SCR6
C
  110 SC(3) = 0.
      SC(4) = 0.
      SC(5) = 0.
      CALL WRITE (SCR6,SC,2,0)
      ISC2  = ISC(2)
      DO 120 I = 1,ISC2
      CALL WRITE (SCR6,SC(3),3,0)
  120 CONTINUE
      RETURN
C
  200 IF (JTYPE .EQ. 24) GO TO 210
C
C     AVERAGE SPCFLD
C
      AHCX = G1/FLOAT(NGRIDS)
      AHCY = G2/FLOAT(NGRIDS)
      AHCZ = G3/FLOAT(NGRIDS)
C
  210 IF (ONLYC) GO TO 310
C
C     PICK UP MATERIAL INFO
C     INFLAG = 3 MEANS A 3 X 3 MATERIAL MATRIX WILL BE RETURNED. THE
C     REASON FOR DOING THIS FOR A 2-D ELEMENT IS THAT HC CAN HAVE A
C     COMPONENT NORMAL TO THE PLANE OF THE ELEMENT. PARTIAL DERIVATIVE
C     W.R.T Z IS 0.  BUT IF THE MATERIAL IS ANISOTROPIC, THEN A
C     CONTRIBUTION TO THE SCALAR LOAD IS POSSIBLE IF MATERIAL CONTAINS
C     A NON-ZERO X-Z TERM. FOR ISOTROPIC MATERIALS, THE NORMAL COMPONENT
C     OF HC WILL BE IGNORED W.R.T ITS CONTRIBUTION TO THE LOAD. IF ALL
C     TERMS OF MATERIAL MATRIX W.R.T.Z ARE 0, AND IF ANISOTROPIC ANGLE
C     IS NOT 0, THEN WE MUST TRANSFORM MATERIALS TO ELEMENT SYSTEM HERE.
C
      INFLAG = 3
      IF (JTYPE .EQ. 24) GO TO 260
      MATID  = NECPT(MID)
      ELTEMP = ECPT(ITEMP)
      ANGLE  = ECPT(ITH)*0.017453293
      SINTH  = SIN(ANGLE)
      COSTH  = COS(ANGLE)
      CALL HMAT (NECPT(1))
C
C     CHECK FOR 3-D ANISOTROPY
C
      IF (XMAT(3).EQ.0. .AND. XMAT(5).EQ.0.) GO TO 230
C
  220 G(1) = XMAT(1)
      G(2) = XMAT(2)
      G(3) = XMAT(3)
      G(5) = XMAT(4)
      G(6) = XMAT(5)
      G(9) = XMAT(6)
      GO TO 240
C
C     CHECK FOR 2-D ANISOTROPY
C
  230 IF (ABS(ANGLE) .LE. .0001) GO TO 220
C
C     2-D ANISOTROPY
C
      CSQ  = COSTH*COSTH
      SSQ  = SINTH*SINTH
      CS   = COSTH*SINTH
      G(1) = CSQ*XMAT(1) - 2.*CS*XMAT(2) + SSQ*XMAT(4)
      G(2) = CS*(XMAT(1) - XMAT(4)) + (CSQ-SSQ)*XMAT(2)
      G(3) = 0.
      G(5) = SSQ*XMAT(1) + 2.*CS*XMAT(2) + CSQ*XMAT(4)
      G(6) = 0.
      G(9) = XMAT(6)
C
  240 IF (ITYPE.NE.36 .AND. ITYPE.NE.37) GO TO 250
C
C     SWITCH Y-Z MATERIALS FOR TRAPRG AND TRIARG
C
      TEMP = G(5)
      G(5) = G(9)
      G(9) = TEMP
      TEMP = G(2)
      G(2) = G(3)
      G(3) = TEMP
C
C     FILL IN SYMMETRIC PART
C
  250 G(4) = G(2)
      G(7) = G(3)
      G(8) = G(6)
C
C     SINCE QUADRILATERALS ARE COVERED BY 4 OVERLAPPING TRIANGLES,
C     MUST DIVIDE QUAD RESULTS BY 2
C
  260 XMUL = 1.
      IF (NGRIDS .EQ. 4) XMUL = .5
C
C     PICK UP COORDINATES OF GRID POINTS
C
      DO 300 I = 1,NGRIDS
      ISUBI = ISYS + 4*I - 4
      DO 300 J = 1,3
      ISUB  = ISUBI + J
      R(J,I)= ECPT(ISUB)
  300 CONTINUE
  310 IF (ITYPE .EQ. 80) GO TO 900
C
C     COMPUTE COORDINATES OF CENTROID (OR, AT LEAST, AVERAGE ELEMENT
C     COORDS)
C
      XXC = 0.
      YYC = 0.
      ZZC = 0.
      DO 320 I = 1,NGRIDS
      XXC = XXC + R(1,I)
      YYC = YYC + R(2,I)
      ZZC = ZZC + R(3,I)
  320 CONTINUE
      XXC = XXC/FLOAT(NGRIDS)
      YYC = YYC/FLOAT(NGRIDS)
      ZZC = ZZC/FLOAT(NGRIDS)
C
C     NOW COMPUTE PROPER LOADS FOR EACH TRIANGLE
C
      DO 800 IEL = 1,NEL
      IF (ONLYC) GO TO 500
C
C     1ST SET UP AN ARRAY TO PICK UP GRID POINTS IN A PARTICULAR ORDER.
C     FOR TRIANGLES, IT IS 1,2,3. FOR QUADRILATERALS, FORM 4 TRIANGLES
C     BY TAKING GRIDS 1,2,3, 2,3,4, 3,4,1, AND 4,1,2
C
      DO 330 I = 1,3
      IP(I) = I + IEL - 1
      IF (IP(I) .GT. 4) IP(I) = IP(I) - 4
  330 CONTINUE
C
C     COMPUTE VECTORS FROM 1ST GRID TO 2ND AND FROM 1ST TO 3RD
C
      DO 340 I = 1,3
      D12(I) = R(I,I2) - R(I,I1)
  340 D13(I) = R(I,I3) - R(I,I1)
C
C     SET UP GRADIENTS FOR AXISYMMETRIC ELEMENTS SEPARATELY
C
      IF (ITYPE.NE.36 .AND. ITYPE.NE.37) GO TO 360
C
C     THE LENGTH OF THE CROSS PRODUCT VECTOR IS TWICE THE AREA OF THE
C     TRIANG
C
      CALL SAXB (D12(1),D13(1),D12(1))
      AREA = .5*SQRT(D12(1)**2 + D12(2)**2 + D12(3)**2)
      VOL  = AREA*TWOPI3*(R(1,I1) + R(1,I2) + R(1,I3))
C
C     NOW SET UP GRADIENT OF THE SHAPE FUNCTION AT EACH GRID POINT.
C     SET UP A 3 X3 MATRIX ROW-STORED FOR GMMATS
C
      D     = (R(1,I2)-R(1,I1))*R(3,I3) + (R(1,I1)-R(1,I3))*R(3,I2) +
     1        (R(1,I3)-R(1,I2))*R(3,I1)
      XN(1) = R(3,I2) - R(3,I3)
      XN(2) = 0.
      XN(3) = R(1,I3) - R(1,I2)
      XN(4) = R(3,I3) - R(3,I1)
      XN(5) = 0.
      XN(6) = R(1,I1) - R(1,I3)
      XN(7) = R(3,I1) - R(3,I2)
      XN(8) = 0.
      XN(9) = R(1,I2) - R(1,I1)
C
      DO 350 I = 1,9
      XN(I) = XN(I)/D
  350 CONTINUE
C
C     FOR ALL EXCEPT REMFLUX, MULT. GRADIENTS INTO MATERIALS
C
      IF (JTYPE .NE. 24) CALL GMMATS (XN(1),3,3,0,G,3,3,0,XN(10))
      GO TO 420
C
C     FIRST, CONVERT COORDINATES TO ELEMNT COORDINATE SYSTEM
C
  360 ZLEN = SQRT(D12(1)**2 + D12(2)**2 + D12(3)**2)
      DO 370 I = 1,3
  370 ZI(I) = D12(I)/ZLEN
C
      CALL SAXB (ZI(1),D13(1),DXX(1))
C
      X2 = ZLEN
      X3 = D13(1)*ZI(1) + D13(2)*ZI(2) + D13(3)*ZI(3)
      Y3 = SQRT(DXX(1)**2 + DXX(2)**2 + DXX(3)**2)
C
      AREA = .5*X2*Y3
      VOL  = AREA*ECPT(IA)
C
C     GET J AND K VECTORS FOR LATER USE
C
      DO 380 I = 1,3
  380 ZK(I) = DXX(I)/Y3
C
      CALL SAXB (ZK(1),ZI(1),ZJ(1))
      ZLEN = SQRT(ZJ(1)**2 + ZJ(2)**2 + ZJ(3)**2)
      DO 390 I = 1,3
  390 ZJ(I) = ZJ(I)/ZLEN
      DO 400 I = 1,3
      ET(I  ) = ZI(I)
      ET(I+3) = ZJ(I)
  400 ET(I+6) = ZK(I)
C
C     SHAPE FUNCTION GRADIENTS
C
      XN(1) = -1./X2
      XN(2) = (X3-X2)/(X2*Y3)
      XN(3) = 0.
      XN(4) = -XN(1)
      XN(5) = -X3/(X2*Y3)
      XN(6) = 0.
      XN(7) = 0.
      XN(8) = 1./Y3
      XN(9) = 0.
C
C     TRANSFORM SHAPE FN GRADIENTS FROM LOCAL TO BASIC
C
      CALL GMMATS (ET,3,3,1,XN(1),3,3,1,XNG(1))
C
C     FOR ALL EXCEPT REMFLUX, MULT. GRADIENTS OF SHAPE FNS INTO
C     MATERIALS
C
      IF (JTYPE .EQ. 24) GO TO 410
      CALL GMMATS (XNG(1),3,3,1,G,3,3,0,XN(10))
      GO TO 420
  410 XN(1) = XNG(1)
      XN(2) = XNG(4)
      XN(3) = XNG(7)
      XN(4) = XNG(2)
      XN(5) = XNG(5)
      XN(6) = XNG(8)
      XN(7) = XNG(3)
      XN(8) = XNG(6)
      XN(9) = XNG(9)
  420 IF (JTYPE .EQ. 24) GO TO 740
C
C     START INTEGRATION PROCEDURE- 4 POINTS FOR CUBIC PLUS ONE AT
C     CENTROID
C
  500 KTYPE    = JTYPE - 19
      XLACC(1) = 0.
      XLACC(2) = 0.
      XLACC(3) = 0.
      NOPTSP   = NOPTS + 1
      DO 720 NPTS = 1,NOPTSP
C
C     DO CENTROID FOR ONLY 1ST TRIANGLE
C
      IF (NPTS.EQ.NOPTSP .AND. IEL.GT.1) GO TO 720
C
C     COMPUTE BASIC COORDS OF INTEGRATION POINT
C
      IF (NPTS .NE. NOPTSP) GO TO 510
C
C     CENTROID
C
      XX = XXC
      YY = YYC
      ZZ = ZZC
      IF (JTYPE .NE. 20) GO TO 520
C
C     AVERAGE SPCFLD
C
      HC(1) = AHCX
      HC(2) = AHCY
      HC(3) = AHCZ
      GO TO 610
  510 XX    = L(1,NPTS)*R(1,I1) + L(2,NPTS)*R(1,I2) + L(3,NPTS)*R(1,I3)
      YY    = L(1,NPTS)*R(2,I1) + L(2,NPTS)*R(2,I2) + L(3,NPTS)*R(2,I3)
      ZZ    = L(1,NPTS)*R(3,I1) + L(2,NPTS)*R(3,I2) + L(3,NPTS)*R(3,I3)
  520 HC(1) = 0.
      HC(2) = 0.
      HC(3) = 0.
C
C     COMPUTE HC AT THIS POINT FOR ALL LOADS OF THIS TYPE
C
      DO 600 IJK = 1,IDO
      IF (JTYPE .EQ. 20) GO TO 540
      ISUB = ISTART + (IJK-1)*IWORDS - 1
      DO 530 I = 1,IWORDS
  530 BUF(I) = Z(ISUB+I)
      GO TO (540,560,570,580), KTYPE
  540 DO 550 I = 1,3
      IPI  = IP(I)
      NSIL = NECPT(ISIL+IPI-1)
      IPT  = ISTART + 3*NSIL - 3
      HCX(I) = Z(IPT  )
      HCY(I) = Z(IPT+1)
      HCZ(I) = Z(IPT+2)
  550 CONTINUE
      HC1 = L(1,NPTS)*HCX(1) + L(2,NPTS)*HCX(2) + L(3,NPTS)*HCX(3)
      HC2 = L(1,NPTS)*HCY(1) + L(2,NPTS)*HCY(2) + L(3,NPTS)*HCY(3)
      HC3 = L(1,NPTS)*HCZ(1) + L(2,NPTS)*HCZ(2) + L(3,NPTS)*HCZ(3)
      GO TO 590
C
C     CEMLOOP, GEMLOOP, MDIPOLE
C
  560 CALL AXLOOP (BUF,JBUF,XX,YY,ZZ,HC1,HC2,HC3)
      GO TO 590
  570 CALL GELOOP (BUF,JBUF,XX,YY,ZZ,HC1,HC2,HC3)
      GO TO 590
  580 CALL DIPOLE (BUF,JBUF,XX,YY,ZZ,HC1,HC2,HC3)
  590 HC(1) = HC(1) + HC1
      HC(2) = HC(2) + HC2
      HC(3) = HC(3) + HC3
  600 CONTINUE
C
  610 IF (NPTS .NE. NOPTSP) GO TO 700
      SC(3) = HC(1)
      SC(4) = HC(2)
      SC(5) = HC(3)
      CALL WRITE (SCR6,SC,5,0)
      GO TO 720
C
C     WE HAVE HC AT THIS INTEG. PT. MULT. BY WEIGHT AND ACCUMULATE
C
  700 DO 710 I = 1,3
  710 XLACC(I) = XLACC(I) + HC(I)*W(NPTS)
C
C     GET ANOTHER INTEGRATION POINT
C
  720 CONTINUE
C
      IF (ONLYC) RETURN
      DO 730 I = 1,3
  730 HC(I) = XLACC(I)
      GO TO 750
C
C     REMFLUX
C
  740 IPT   = ISTART + 3*NCOUNT - 3
      HC(1) = Z(IPT  )
      HC(2) = Z(IPT+1)
      HC(3) = Z(IPT+2)
C
C    TAKE XMUL MULTIPLIER INTO ACCOUNT
C
  750 DO 760 I = 1,3
  760 HC(I) = HC(I)*XMUL
C
C     MAKE FINAL COMPUTATION. MULTIPLY PRODUCT OF SHAPE FUNCTION
C     GRADIENTS AND MATERIAL MATRIX INTO HC AND MULTIPLY BY VOLUME
C
      ISUB = 10
      IF (JTYPE .EQ. 24) ISUB = 1
      CALL GMMATS (XN(ISUB),3,3,0,HC,3,1,0,XLOAD(1))
C
C     ADD THIS ELEMENT LOAD VECTOR IN OVERALL VECTOR. USE NSIL AND IP TO
C     POI
C
      DO 790 J = 1,3
      IPI  = IP(J)
      NSIL = NECPT(ISIL+IPI-1)
C
C     IF PERMBDY EXISTS AND IF GRID IS NOT ON IT, IGNORE ITS LOAD
C
      IF (NBDYS .EQ. 0) GO TO 780
      DO 770 I = 1,NBDYS
      IF (NSIL .NE. IZ(ISTART-NBDYS-NELOUT+I-1)) GO TO 770
      GO TO 780
  770 CONTINUE
      GO TO 790
  780 Z(NSIL) = Z(NSIL) - XLOAD(J)*VOL
  790 CONTINUE
C
C     DONE FOR THIS TRIANGLE. GO BACK FOR ANOTHER
C
  800 CONTINUE
      RETURN
C
C     IS2D8
C
C     SET UP QUADRATURE POINTS AND WEIGHTS
C
  900 IF (ONLYC) GO TO 1000
      PT(1) = -0.57735027
      PT(2) = -PT(1)
      H(1)  = 1.
      H(2)  = 1.
      IF (NECPT(10) .EQ. 2) GO TO 910
      PT(1) = -0.77459667
      PT(2) = 0.
      PT(3) = -PT(1)
      H(1)  = 5./9.
      H(2)  = 8./9.
      H(3)  = H(1)
C
C     COMPUTE I,J,K VECTORS- I IS 1 TO 2
C
  910 DO 920 I = 1,3
      ZI(I) = R(I,2) - R(I,1)
  920 Z14(I)= R(I,4) - R(I,1)
      ZLEN  = SQRT(ZI(1)**2 + ZI(2)**2 + ZI(3)**2)
      DO 930 I = 1,3
  930 ZI(I) = ZI(I)/ZLEN
C
C     GET K BY CROSSING I INTO VECTOR FROM 1 TO 4
C
      ZK(1) = ZI(2)*Z14(3) - ZI(3)*Z14(2)
      ZK(2) = ZI(3)*Z14(1) - ZI(1)*Z14(3)
      ZK(3) = ZI(1)*Z14(2) - ZI(2)*Z14(1)
      ZKLEN = SQRT(ZK(1)**2 + ZK(2)**2 + ZK(3)**2)
      DO 940 I = 1,3
  940 ZK(I) = ZK(I)/ZKLEN
C
C     GET J BY CROSSING K INTO I AND STORE INTO TRANSFORMATION MATRIX
C
      ZJ(1) = ZK(2)*ZI(3) - ZK(3)*ZI(2)
      ZJ(2) = ZK(3)*ZI(1) - ZK(1)*ZI(3)
      ZJ(3) = ZK(1)*ZI(2) - ZK(2)*ZI(1)
      ZJLEN = SQRT(ZJ(1)**2 + ZJ(2)**2 + ZJ(3)**2)
      DO 950 I = 1,3
  950 ZJ(I) = ZJ(I)/ZJLEN
C
      DO 960 I = 1,3
      ET(I  ) = ZI(I)
      ET(I+3) = ZJ(I)
  960 ET(I+6) = ZK(I)
C
C     COMPUTE ELMENT COORDS FOR 1 AND 2
C
      XZ(1) = 0.
      XZ(2) = 0.
      XZ(3) = ZLEN
      XZ(4) = 0.
C
C     FOR 3-8, X IS DOT PRODUCT OF VECTOR FROM 1 TO GRID WITH I.
C     Y IS THE LENFTH OF THE VECTOR RESULTING FROM CROSSING I INTO
C     VECTOR FROM 1 TO GRID
C
      DO 980 I = 3,8
      IXX = 2*I - 1
      DO 970 J = 1,3
  970 VEC(J)  = R(J,I) - R(J,1)
      XZ(IXX) = VEC(1)*ZI(1) + VEC(2)*ZI(2) + VEC(3)*ZI(3)
      VVEC(1) = ZI(2)*VEC(3) - ZI(3)*VEC(2)
      VVEC(2) = ZI(3)*VEC(1) - ZI(1)*VEC(3)
      VVEC(3) = ZI(1)*VEC(2) - ZI(2)*VEC(1)
      XZ(IXX+1) = SQRT(VVEC(1)**2 + VVEC(2)**2 + VVEC(3)**2)
  980 CONTINUE
C
      DO 990 I = 1,8
  990 F(I) = 0.
C
C     GET HC AT EACH GRID
C
      IF (JTYPE .NE. 24) GO TO 1000
C
C     REMFLUX
C
      ISUB  = ISTART + 3*NCOUNT - 3
      GH(1) = Z(ISUB  )
      GH(2) = Z(ISUB+1)
      GH(3) = Z(ISUB+2)
      GO TO 1020
C
C     IF SPCFLD, PICK UP GRID VALUES HERE. IF NOT, PICK UP INTEGRATION
C     POINT VALUES LATER
C
 1000 IF (JTYPE .NE. 20) GO TO 1020
      DO 1010 I = 1,NGRIDS
      ISIL = 3*NECPT(I+1)
      HCI(3*I-2) = Z(ISTART+ISIL-3)
      HCI(3*I-1) = Z(ISTART+ISIL-2)
      HCI(3*I  ) = Z(ISTART+ISIL-1)
 1010 CONTINUE
 1020 INIP  = NECPT(10)
      KTYPE = JTYPE - 20
      IF (ONLYC) GO TO 1340
C
C     START INTEGRATION
C
      DO 1300 III = 1,INIP
      DO 1300 JJJ = 1,INIP
C
C     COMPUTE DERIVATIVES WITH RESPECT TO XI AND ETA
C     EACH GRID POINT
C
      DO 1030 N = 1,4
      DN(N)   = .25*(1.+PT(III)*XI(N))*(1.+PT(JJJ)*ETA(N))*
     1          (PT(III)*XI(N)+PT(JJJ)*ETA(N)-1.)
      DNXI(N) = .25*XI(N)*(1.+PT(JJJ)*ETA(N))*
     1          (2.*PT(III)*XI(N)+PT(JJJ)*ETA(N))
      DNETA(N)= .25*ETA(N)*(1.+PT(III)*XI(N))*
     1          (PT(III)*XI(N)+2.*PT(JJJ)*ETA(N))
 1030 CONTINUE
      DO 1040 N = 5,7,2
C
      DN(N)   = .5*(1.-PT(III)*PT(III))*(1.+PT(JJJ)*ETA(N))
      DNXI(N) = -PT(III)*(1.+PT(JJJ)*ETA(N))
      DNETA(N)= .5*(1.-PT(III)*PT(III))*ETA(N)
 1040 CONTINUE
C
      DO 1050 N = 6,8,2
      DN(N)   = .5*(1.+PT(III)*XI(N))*(1.-PT(JJJ)*PT(JJJ))
      DNXI(N) = .5*XI(N)*(1.-PT(JJJ)*PT(JJJ))
      DNETA(N)= -PT(JJJ)*(1.+PT(III)*XI(N))
 1050 CONTINUE
C
C     COMPUTE JACOBEAN
C
C           N1XI   N2XI   N3XI   N4XI   N5XI   N6XI   N7XI   N8XI
C     DNC = N1ETA  N2ETA  N3ETA  N4ETA  N5ETA  N6ETA  N7ETA  N8ETA
C
C          X1  Y1
C          X2  Y2
C          X3  Y3
C     XX = X4  Y4
C          X5  Y5
C          X6  Y6
C          X7  Y7
C          X8  Y8
C
      CALL GMMATS (DNC,2,8,0,XZ,8,2,0,XJB)
C
C     XJB IS ROW-STORED-IT MUST BE COLUMN-STORED AND DOUBLY DIMENSIONED
C     FOR INVERSION
C
      K = 0
      DO 1060 I = 1,2
      DO 1060 J = 1,2
      K = K + 1
 1060 XXJB(I,J) = XJB(K)
C
C     COMPUTE INVERSE AND DETERMINANT OF JACOBEAN
C
      CALL INVERS (2,XXJB,2,DUMARG,0,DETERM,ISING,IWS)
C
C     COMPUTE DERIVATIVES WITH RESPECT TO X AND Y
C
      K = 0
      DO 1070 I = 1,2
      DO 1070 J = 1,2
      K = K + 1
 1070 XJB(K) = XXJB(I,J)
      CALL GMMATS (XJB,2,2,0,DNC,2,8,0,DNL)
C
C           N1X N2X N3X N4X N5X N6X N7X N8X
C     DNL = N1Y N2Y N3Y N4Y N5Y N6Y N7Y N8Y
C
      IF (JTYPE .EQ. 24) GO TO 1190
C
C     INITIALIZE HC AT PRESENT UNTEGRATION POINT
C
      DO 1080 I = 1,3
 1080 HCXYZ(I) = 0.
      IF (JTYPE .EQ. 20) GO TO 1160
C
C     FOR LOOPS AND DIPOLES, COMPITE BASIC COORDS. FOR THIS INTEGRATION
C     PT
C
      XX = 0.
      YY = 0.
      ZZ = 0.
      DO 1090 M = 1,NGRIDS
      XX = XX + DN(M)*R(1,M)
      YY = YY + DN(M)*R(2,M)
 1090 ZZ = ZZ + DN(M)*R(3,M)
C
      DO 1150 IJK = 1,IDO
      ISUB = ISTART + (IJK-1)*IWORDS - 1
      DO 1100 M = 1,IWORDS
 1100 BUF(M) = Z(ISUB+M)
      GO TO (1110,1120,1130), KTYPE
 1110 CALL AXLOOP (BUF,JBUF,XX,YY,ZZ,HC1,HC2,HC3)
      GO TO 1140
 1120 CALL GELOOP (BUF,JBUF,XX,YY,ZZ,HC1,HC2,HC3)
      GO TO 1140
 1130 CALL DIPOLE (BUF,JBUF,XX,YY,ZZ,HC1,HC2,HC3)
 1140 HCXYZ(1) = HCXYZ(1) + HC1
      HCXYZ(2) = HCXYZ(2) + HC2
      HCXYZ(3) = HCXYZ(3) + HC3
 1150 CONTINUE
      GO TO 1180
C
C     SPCFLD
C
 1160 DO 1170 M = 1,NGRIDS
      HCXYZ(1) = HCXYZ(1) + DN(M)*HCI(3*M-2)
      HCXYZ(2) = HCXYZ(2) + DN(M)*HCI(3*M-1)
 1170 HCXYZ(3) = HCXYZ(3) + DN(M)*HCI(3*M)
C
C     MULTIPLY MATERIAL INTO HC AT THIS INTEGRATION POINT
C
 1180 CALL GMMATS (G,3,3,0,HCXYZ,3,1,0,GH)
 1190 SFACT = H(III)*H(JJJ)*DETERM
C
C     TRANSFORM DNL FROM LOCAL TO BASIC
C     1 ST EXPAND TO ADD IN ZEROS CORRESPONDING TO Z DIRECTION
C
      DO 1200 I = 1,16
 1200 DDNL(I) = DNL(I)
      DO 1210 I = 17,24
 1210 DDNL(I) = 0.
C
      CALL GMMATS (ET,3,3,1,DDNL,3,8,0,DDNLB)
C
      DO 1220 M = 1,NGRIDS
      F(M) = F(M) + (DDNLB(M)*GH(1) + DDNLB(M+8)*GH(2) +
     1       DDNLB(M+16)*GH(3))*SFACT
 1220 CONTINUE
C
C     GET ANOTHER INTEGRATION POINT
C
 1300 CONTINUE
C
C     ADD LOAD INTO LOAD ARRAY
C
      DO 1330 M = 1,NGRIDS
      ISIL = NECPT(M+1)
C
C     IF PERMBDY EXISTS AND IF GRID IS NOT ON IT, IGNORE ITS LOAD
C
      IF (NBDYS .EQ. 0) GO TO 1320
      DO 1310 I = 1,NBDYS
      IF (ISIL .NE. IZ(ISTART-NBDYS-NELOUT+I-1)) GO TO 1310
      GO TO 1320
 1310 CONTINUE
      GO TO 1330
 1320 Z(ISIL) = Z(ISIL)-F(M)*ECPT(IA)
 1330 CONTINUE
C
C     BEFORE LEAVING COMPUTE HC AT GRIDS AND CENTROID AND WRITE TO SCR6
C
 1340 IF (JTYPE .EQ. 24) RETURN
      CALL WRITE (SCR6,ISC,2,0)
C
C     SET UP SHAPE FUNCTIONS AT CENTROID
C
      DO 1350 I = 1,4
 1350 DN(I) = -.25
      DO 1360 I = 5,8
 1360 DN(I) = .5
C
      IF (JTYPE .NE. 20) GO TO 1400
C
C     FOR SPCFLD HC VALUES AT GRIDS ARE IN CORE
C
      CALL WRITE (SCR6,HCI,24,0)
C
      DO 1370 I = 1,3
 1370 HCXYZ(I) = 0.
      DO 1380 M = 1,NGRIDS
      HCXYZ(1) = HCXYZ(1) + DN(M)*HCI(3*M-2)
      HCXYZ(2) = HCXYZ(2) + DN(M)*HCI(3*M-1)
      HCXYZ(3) = HCXYZ(3) + DN(M)*HCI(3*M  )
 1380 CONTINUE
C
      CALL WRITE (SCR6,HCXYZ,3,0)
      RETURN
C
C     NOT SPCFLD
C
 1400 DO 1500 J = 1,9
      IF (J .NE. 9) GO TO 1420
C
C     CENTROID
C
      XX = 0.
      YY = 0.
      ZZ = 0.
      DO 1410 M = 1,8
      XX = XX + DN(M)*R(1,M)
      YY = YY + DN(M)*R(2,M)
 1410 ZZ = ZZ + DN(M)*R(3,M)
      GO TO 1430
 1420 XX = R(1,J)
      YY = R(2,J)
      ZZ = R(3,J)
 1430 HC(1) = 0.
      HC(2) = 0.
      HC(3) = 0.
      DO 1490 IJK = 1,IDO
      ISUB  = ISTART + (IJK-1)*IWORDS - 1
      DO 1440 I = 1,IWORDS
 1440 BUF(I) = Z(ISUB+I)
      GO TO (1450,1460,1470), KTYPE
 1450 CALL AXLOOP (BUF,JBUF,XX,YY,ZZ,HC1,HC2,HC3)
      GO TO 1480
 1460 CALL GELOOP (BUF,JBUF,XX,YY,ZZ,HC1,HC2,HC3)
      GO TO 1480
 1470 CALL DIPOLE (BUF,JBUF,XX,YY,ZZ,HC1,HC2,HC3)
 1480 HC(1) = HC(1) + HC1
      HC(2) = HC(2) + HC2
      HC(3) = HC(3) + HC3
 1490 CONTINUE
C
      CALL WRITE (SCR6,HC,3,0)
 1500 CONTINUE
C
      RETURN
C
 1600 WRITE  (OTPE,1610) UFM,NAM,ITYPE
 1610 FORMAT (A23,', IN SUBROUTINE',2A4,' ELEMENT TYPE',I8,' IS NOT ',
     1        'LEGAL')
      CALL MESAGE (-61,0,0)
      RETURN
      END

      SUBROUTINE XFLDEF (NAME1,NAME2,NOFIND)
C
C     THE PURPOSE OF THIS ROUTINE IS TO TURN ON ALL OSCAR ENTRY EXECUTE
C     FLAGS NECESSARY TO DEFINE FILE .
C
C                 DESCRIPTION OF ARGUMENTS
C     NAM1,NAM2 = NAME OF FILE TO BE DEFINED.
C     NOFIND    = INDICATES TO CALLING PROGRAM WHETHER OR NOT FILE WAS
C                 FOUND.
C
      EXTERNAL        ANDF,ORF,COMPLF
      INTEGER         NAME1(1),NAME2(1),SOL,OSCAR(1),OS(5),OSPNT,OSBOT,
     1                FMED(1),FMEDTP,FNM(1),FNMTP,FMDMSK,TWO,OP,PTDTP,
     2                PTDBOT,PTDIC(1),AND,OR,ANDF,ORF,COMPLF,START,
     3                REUSE,REGEN
      COMMON /XMDMSK/ NMSKCD,NMSKFL,NMSKRF,FMDMSK(7)
      COMMON /XGPID / ICST,IUNST,IMST,IHAPP,IDSAPP,IDMAPP,XGPID1(5),
     1                NOFLGS
      COMMON /SYSTEM/ BS,OP,NOGO,DUM(78),ICPFLG
      COMMON /XOLDPT/ PTDTP,PTDBOT,LPTDIC,NRLFL,SEQNO
      COMMON /XGPIC / ICOLD,ISLSH,IEQUL,NBLANK,NXEQUI,
C                  ** CONTROL CARD NAMES **
     1                NDIAG,NSOL,NDMAP,NESTM1,NESTM2,NEXIT,
C                  ** DMAP CARD NAMES **
     2                NBEGIN,NEND,NJUMP,NCOND,NREPT,NTIME,NSAVE,
     3                NOUTPT,NCHKPT,NPURGE,NEQUIV,
     4                NCPW,NBPC,NWPC,
     5                MASKHI,MASKLO,ISGNON,NOSGN,IALLON,MASKS(1)
      COMMON /ZZZZZZ/ CORE(1)
      COMMON /XGPI4 / IRTURN,INSERT,ISEQN,DMPCNT,
     1                IDMPNT,DMPPNT,BCDCNT,LENGTH,ICRDTP,ICHAR, NEWCRD,
     2                MODIDX,LDMAP,ISAVDW,DMAP(1)
      COMMON /XGPI5 / IAPP,START,IEXIT(2),SOL,SUBSET,IFLAG,IESTIM,
     1                ICFTOP,ICFPNT,LCTLFL,ICTLFL(1)
      COMMON /XGPI6 / MEDTP,FNMTP,CNMTP,MEDPNT,LMED
      COMMON /TWO   / TWO(4)
      EQUIVALENCE     (CORE(1),OS(1),LOSCAR),(OSPRC,OS(2)),
     1                (OSBOT,OS(3)),(IOSPNT,OS(4)),
     2                (OS(5),OSCAR(1),FNM(1),FMED(1),PTDIC(1)),
     3                (MEDTP,FMEDTP),(TWO(4),REUSE)
      DATA    NXCHKP/ 4HXCHK/, IFIRST / 0 /
C
      AND(I,J) = ANDF(I,J)
      OR(I,J)  = ORF(I,J)
C
      NAM1 = NAME1(1)
      NAM2 = NAME2(1)
C
C     SCAN OPTDIC FOR FILE NAME
C
      REGEN  = NOFIND
      NOFIND = 1
      IF(PTDBOT .LT. PTDTP)  GO TO 200
      DO 100 II = PTDTP,PTDBOT,3
      I = PTDBOT + PTDTP - II
      IF (PTDIC(I).EQ.NAM1 .AND. PTDIC(I+1).EQ.NAM2) GO TO 110
  100 CONTINUE
      GO TO 200
C
C     FILE IS IN PTDIC - SET REUSE FLAG FOR ALL EQUIVALENCED FILES
C
  110 IF (PTDIC(I+2) .GE. 0) GO TO 130
      DO 120 J = PTDTP,PTDBOT,3
      IF (AND(PTDIC(J+2),NOFLGS) .EQ. AND(PTDIC(I+2),NOFLGS))
     1    PTDIC(J+2) = OR(PTDIC(J+2),REUSE)
  120 CONTINUE
  130 PTDIC(I+2) = OR(PTDIC(I+2),REUSE)
      NOFIND = 0
      GO TO 1000
C
C     FILE NOT IN PTDIC - CHECK FNM TABLE IF RESTART IS MODIFIED AND
C     APPROACH IS NOT DMAP
C
  200 IF (START.EQ.ICST .OR. IAPP.EQ.IDMAPP) GO TO 1000
      IF (REGEN .LT. 0)  GO TO 1000
      J = FNMTP + 1
      K = FNMTP + FNM(FNMTP)*3 - 2
      DO 210 I = J,K,3
      IF (NAM1.EQ.FNM(I) .AND. NAM2.EQ.FNM(I+1)) GO TO 220
  210 CONTINUE
      GO TO 1000
C
C     FILE IS IN FNM TABLE - CHECK FOR TABLE ERROR
C
  220 IF (FNM(I+2) .LE. 0)  GO TO 900
C
C     CLEAR ALL THE MASK WORDS
C
      K = FMED(FMEDTP+1)
      DO 230 L = 1, K
      FMDMSK(L) = 0
  230 CONTINUE
C
C     SET BIT IN FMDMSK FOR FILE REGENERATION
C
      L = ((FNM(I+2)-1)/31) + 1
      K = FNM(I+2) - 31*(L-1) + 1
      FMDMSK(L) = OR(FMDMSK(L),TWO(K))
C
C     USE FMDMSK AND FMED TABLE TO TURN ON OSCAR EXECUTE FLAGS
C
      K  = FMED(FMEDTP+1)
      J1 = FMEDTP + 2
      J2 = J1 + FMED(FMEDTP)*FMED(FMEDTP+1) - K
      INDEX = 0
      OSPNT = 1
      DO 350 J = J1,J2,K
      DO 310 K1 = 1,K
      JJ = J + K1 - 1
      IF (AND(FMED(JJ),FMDMSK(K1)) .NE. 0)  GO TO 330
  310 CONTINUE
      GO TO 350
C
C     NON-ZERO ENTRY FOUND - COMPUTE DMAP SEQUENCE NUMBER FOR FMED ENTRY
C
  330 N = ((J-J1)/K) + 1
      IF (AND(OSCAR(IOSPNT+5),NOSGN) .LT. N) GO TO 1000
C
C     SET EXECUTINON FLAG FOR ALL OSCAR ENTRIES WITH SAME DMAP SEQ
C     NUMBER
C
  335 IF (AND(OSCAR(OSPNT+5),NOSGN) - N) 345,340,350
  340 IF (OSCAR(OSPNT+5).LT.0 .OR. (OSCAR(OSPNT+3).EQ.NXCHKP .AND.
     1    ICPFLG.EQ.0)) GO TO 345
      IF (IFIRST .EQ. 1) GO TO 342
      IFIRST = 1
      CALL PAGE1
      CALL XGPIMW (12,0,0,0)
  342 IF (INDEX .EQ. 1) GO TO 344
      INDEX = 1
      CALL XGPIMW (3,NAM1,NAM2,0)
  344 CALL XGPIMW (4,0,0,OSCAR(OSPNT))
      NOFIND = -1
      OSCAR(OSPNT+5) = ORF(OSCAR(OSPNT+5),ISGNON)
  345 IF (OSPNT .GE. OSBOT) GO TO 350
      OSPNT = OSPNT + OSCAR(OSPNT)
      GO TO 335
  350 CONTINUE
C
C     MAKE SURE SOME MODULES WERE TURNED ON
C
      IF (NOFIND .NE. -1)  GO TO 900
C
C     NEGATE FNM TABLE ENTRY FOR THIS FILE
C
      FNM(I+2) = -FNM(I+2)
C
C     TURN OFF REUSE FLAGS IN PTDIC
C
      IF (PTDBOT.LE.PTDTP .OR. IFLAG.NE.0) GO TO 1000
      J = COMPLF(REUSE)
      DO 360 I = PTDTP,PTDBOT,3
      PTDIC(I+2) = ANDF(J,PTDIC(I+2))
  360 CONTINUE
      GO TO 1000
C
C     D I A G N O S T I C    M E S S A G E S
C
C     MED OR FILE TABLE INCORRECT FOR REGENERATING FILE
C
  900 CALL XGPIDG (41,NAM1,NAM2,FNM(I+2))
      NOFIND =-1
      NOGO   = 2
 1000 RETURN
      END

      SUBROUTINE SCONE3( AGAIN )
C
      REAL III
C
      INTEGER IFORCE(25), ISTRES(100), ELEMID, IBLOCK(9,14)
C
      LOGICAL AGAIN
C
      COMMON /SDR2X7/ DUM(5),III,ZOFF(2),DUM2(92),STRESS(100),FORCE(25)
C
      COMMON /SDR2X8/ VEC(8), SUM(8), SIG(3), SIG1, SIG2, SIG12, TEMP,
     1 DELTA, THETA, NPOINT, ZOVERI, IPT, BLOCK(9,14), ELHAR, ELEMID,
     2 HARM, N, SINPHI, CONPHI, NPHI, NANGLE
C
      EQUIVALENCE( ISTRES(1), STRESS(1) )
      EQUIVALENCE( IFORCE(1), FORCE (1) )
      EQUIVALENCE( IBLOCK(1,1),BLOCK(1,1) )
C
      IF( AGAIN ) GO TO 10
      AGAIN = .TRUE.
      NANGLE = 0
   10 NANGLE = NANGLE + 1
C*****
C     OUTPUT FORCES FOR THIS ANGLE
C*****
      IFORCE(1) = ELEMID
      FORCE(2) = BLOCK(1,NANGLE)
      FORCE(3) = BLOCK(5,NANGLE)
      FORCE(4) = BLOCK(6,NANGLE)
      FORCE(5) = BLOCK(7,NANGLE)
      FORCE(6) = BLOCK(8,NANGLE)
      FORCE(7) = BLOCK(9,NANGLE)
C*****
C COMPUTE AND OUTPUT STRESSES AND PRINCIPAL STRESSES
C*****
      ISTRES(1) = ELEMID
      STRESS(2) = BLOCK(1,NANGLE)
      DO 70 I = 1,2
      ZOVERI=0.0
      IF (III .NE. 0.0) ZOVERI=ZOFF(I)/III
      DO 40 J = 1,3
   40 SIG(J) = BLOCK(J+1,NANGLE) + BLOCK(J+4,NANGLE) * ZOVERI
      TEMP = SIG(1) - SIG(2)
      SIG12 = SQRT( (TEMP*0.50E0)**2 + SIG(3)**2 )
      DELTA = ( SIG(1) + SIG(2) ) * 0.50E0
      SIG1 = DELTA + SIG12
      SIG2 = DELTA - SIG12
      DELTA = 2.0E0 * SIG(3)
      IF( ABS(DELTA) .LT. 1.0E-15 .AND. ABS(TEMP) .LT. 1.0E-15 )GO TO 50
      THETA = ATAN2( DELTA, TEMP ) * 28.6478898E0
      GO TO 60
   50 THETA = 0.0E0
   60 IPT = 8*I-6
      STRESS(IPT+1) = ZOFF(I)
      STRESS(IPT+2) = SIG(1)
      STRESS(IPT+3) = SIG(2)
      STRESS(IPT+4) = SIG(3)
      STRESS(IPT+5) = THETA
      STRESS(IPT+6) = SIG1
      STRESS(IPT+7) = SIG2
      STRESS(IPT+8) = SIG12
   70 CONTINUE
C*****
C SET AGAIN .FALSE. IF SDR2E IS NOT TO CALL THIS ROUTINE AGAIN FOR THIS
C ELEMENT.. E.G. ALL THE ANGLES DESIRED HAVE BEEN PROCESSED...
C*****
      IF( NANGLE .EQ. 14 ) GO TO 100
      IF( IBLOCK(1,NANGLE+1) .EQ. 1 ) GO TO 100
      RETURN
  100 AGAIN = .FALSE.
      RETURN
      END

      SUBROUTINE RELABL (NS,NODES,IG,IC,IDEG,IDIS,IW,NEW,ICC,ILD,IAJ,
     1                   JG,IDIM)
C
C     THIS ROUTINE IS USED ONLY IN BANDIT MODULE
C
C     GENERATE A RELABELING SCHEME STARTING WITH NS NODES FOR WHICH
C     LABELS HAVE BEEN STORED IN ARRAY NODES.
C     SET UP ILD AND NEW.
C     ILD(OLD) = NEW
C     NEW(NEW) = OLD, THE INVERSE OF ILD
C     IAJ IS DIMENSIONED TO IDIM
C
      INTEGER         X
      DIMENSION       IG(1),    IC(1),    IDEG(1),  IDIS(1),  IW(1),
     1                NEW(1),   ICC(1),   ILD(1),   NODES(1), IAJ(1),
     2                JG(1)
      COMMON /BANDS / NN,       DUMS(3),  MAXGRD
      COMMON /SYSTEM/ IBUF,     NOUT
C
      I   = NODES(1)
      ICN = IC(I)
      NT  = ICC(ICN) - 1
      DO 90 I = 1,NN
      IF (IC(I)-ICN) 90,80,90
 80   IDIS(I) = 0
 90   CONTINUE
      DO 100 J = 1,NS
      JJ = NODES(J)
      IDIS(JJ) =-1
      JT = J + NT
      NEW(JT) = JJ
 100  ILD(JJ) = JT
      KI = NT
      KO = NS + NT
      LL = KO
      L  = 1
      J  = KO
      NNC= ICC(ICN+1) - 1
 110  KI = KI + 1
      IF (KI-LL) 130,120,130
 120  L  = L  + 1
      LL = KO + 1
 130  II = NEW(KI)
      N  = IDEG(II)
      IF (N) 140,270,140
 140  IJ = 0
      CALL BUNPAK (IG,II,N,JG)
      DO 170 I = 1,N
      IA = JG(I)
      IF (IDIS(IA)) 170,150,170
 150  IJ = IJ + 1
      IF (IJ .LE. IDIM) GO TO 160
C
C     DIMENSION EXCEEDED.  STOP JOB.
C
      NGRID = -2
      RETURN
C
 160  IDIS(IA) = L
      KO       = KO + 1
      IAJ(IJ)  = IA
      IW(IJ)   = IDEG(IA)
 170  CONTINUE
      IF (IJ-1) 260,180,190
 180  J  = KO
      IZ = IAJ(1)
      NEW(KO) = IZ
      ILD(IZ) = KO
      GO TO 260
 190  X = 0
      DO 230 I = 2,IJ
      IF (IW(I)-IW(I-1)) 210,230,230
 210  CONTINUE
      X = IW(I)
      IW(I  ) = IW(I-1)
      IW(I-1) = X
      X = IAJ(I)
      IAJ(I  ) = IAJ(I-1)
      IAJ(I-1) = X
 230  CONTINUE
      IF (X) 240,240,190
 240  DO 250 I = 1,IJ
      J  = J + 1
      IZ = IAJ(I)
      NEW(J ) = IZ
      ILD(IZ) = J
 250  CONTINUE
 260  IF (KO-NNC) 110,270,270
 270  CONTINUE
C
C     REVERSE SEQUENCE FOR THIS COMPONENT (ICN).
C
C     ICC IS AN ARRAY USED FOR IDENTIFYING COMPONENTS IN THE NEW ARRAY.
C     ICC(N1) CONTAINS THE INDEX FOR THE NEW ARRAY AT WHICH COMPONENT
C         N1 STARTS.
C
      N1 = ICC(ICN) - 1
      N2 = NN - ICC(ICN+1) + 1
      IF (N2 .GT. NN) N2 = 0
C
C     REVERSE THE NODAL CM SEQUENCE, OMITTING THE FIRST N1 AND THE LAST
C     N2 POINTS.
C
C     NEW(N1) = OLD LABEL FOR NODE NOW LABELLED N1.
C     ILD(N1) = NEW LABEL FOR NODE ORIGINALLY LABELED N1.
C     N1      = NUMBER OF POINTS AT BEGINNING OF SEQUENCE TO OMIT FROM
C               REVERSAL.
C     N2      = NUMBER OF POINTS AT END OF SEQUENCE TO OMIT FROM
C               REVERSAL.
C     NN      = NUMBER OF NODES.
C     J       = NUMBER OF INTERCHANGES TO MAKE.
C
      J  = (NN-N1-N2)/2
      IF (J .LE. 0) RETURN
      LL = NN - N2 + 1
C
C     MAKE INTERCHANGES IN NEW ARRAY.
C
      DO 290 I = 1,J
      L = LL - I
      K = NEW(L)
      M = N1 + I
      NEW(L) = NEW(M)
 290  NEW(M) = K
C
C     CORRECT ILD, THE INVERSE OF NEW.
C
      L = 1  + N1
      M = NN - N2
      DO 300 I = L,M
      K = NEW(I)
 300  ILD(K) = I
C
      RETURN
      END

      SUBROUTINE PRESAX (IHARM)
C
C     THIS ROUTINE APPLIES PRESSURE LOADS TO AXISYMMETRIC SHELL
C
      LOGICAL         PIEZ
      INTEGER         FILE,SLT,ICARD(6),IORD(2),NAME(2)
      REAL            CARD(6),GPCO(4,2)
      COMMON /CONDAS/ PI,TWOPI,RADEG,DEGRAD,S4PISQ
      COMMON /ZZZZZZ/ Z(1)
      COMMON /LOADX / LC,SLT,BGPDT,OLD
      COMMON /SYSTEM/ KSYSTM(80)
      EQUIVALENCE     (ICARD(1),CARD(1))
      DATA    NAME  / 4HPRES,4HAX  /
C
C     DEFINITION OF VARIABLES
C
C     N        NUMBER OF CURRENT HARMONIC
C     FILE     FILE NAME FOR ERROR MESAGES
C     SLT      STATIC LOADS TABLE
C     CARD     CARD IMAGE OF PRESAX CARD
C     DEGRAD   CONVERSION FACTOR FOR DEGREES TO RADIANS
C     IORD     ARRAY GIVING OPTIMUM ORDER FOR LOOKING UP POINTS IN BGPDT
C     OLD      CURRENT POSITION OF BGPDT
C     GPCO     ARRAY HOLDING BGPDT DATA FOR EACH RING
C     XL       DISTANCE  BETWEEN  RINGS
C     SINSI    SIN  ANGLE BETWEEN RINGS
C     COSSI    COS  ANGLE BETWEEN RINGS
C     ISILA    SIL VALUE  OF CURRENT HARMONIC - RING A
C     ISILB    SIL VALUE  OF CURRENT HARMONIC - RING B
C     IHARM    SUBCASE  INDICATOR  1 = SINE  2 = COSINE
C
C
C     BRING IN PRESAX CARD
C
      FILE = SLT
      CALL READ (*910,*920,SLT,CARD(1),6,0,IFLAG)
      N  = ICARD(6) + 1
      XI = N - 1
C
C     CONVERT PHI1,PHI2 TO RADIANS
C
      CARD(4) = CARD(4)*DEGRAD
      CARD(5) = CARD(5)*DEGRAD
C
C     PICK UP BGPDT DATA FOR RINGS
C
C     IF 1ST. RING IS NEGATIVE, THIS IS A SURFACE CHARGE LOAD IN A
C     PIEZOELECTRIC PROBLEM
C
      PIEZ = .FALSE.
      IF (KSYSTM(78).NE.1 .OR. ICARD(2).GT.0) GO TO 5
      PIEZ = .TRUE.
      ICARD(2) = -ICARD(2)
    5 CONTINUE
      CALL PERMUT (ICARD(2),IORD(1),2,OLD)
      DO 10 I = 1,2
      J = IORD(I) + 1
      CALL FNDPNT (GPCO(1,J-1),ICARD(J) )
   10 CONTINUE
      XL = SQRT((GPCO(2,2) - GPCO(2,1))**2 + (GPCO(3,2) - GPCO(3,1))**2)
      IF (XL .EQ. 0.0) CALL MESAGE (-30,26,-1)
      SINSI = (GPCO(2,2) - GPCO(2,1))/XL
      COSSI = (GPCO(3,2) - GPCO(3,1))/XL
      CALL FNDSIL (ICARD(2))
      ISILA = ICARD(2)
      CALL FNDSIL (ICARD(3))
      ISILB = ICARD(3)
C
C     APPLY LOADS TO ALL HARMONICS
C
      IF (N .NE. 1) GO TO 20
C
C     APPLY LOADS TO ZERO HARMONIC - COSINE SUBCASE ONLY
C
      IF (IHARM .NE. 2) GO TO 90
      PR = (CARD(5) - CARD(4))
      GO TO 30
C
C     I .GT. 1  APPLY  SINE AND COSINE FACTORS
C
   20 IF (IHARM .EQ. 1) GO TO 40
C
C     COSINE CASE
C
      PR = (SIN(XI*CARD(5)) - SIN(XI*CARD(4)))/XI
      GO TO 30
C
C     SINE CASE
C
   40 PR = -(COS(XI*CARD(5)) - COS(XI*CARD(4)))/XI
C
C     APPLY LOADS
C
   30 PR = PR*CARD(1)*XL
      PRPIEZ = PR
      PRC = PR*COSSI
      PRS =-PR*SINSI
      PR  = GPCO(2,1)/3.0 + GPCO(2,2)/6.0
      IF (.NOT.PIEZ) GO TO 35
C
C     PIEZOELECTRIC
C
      PRC = 0.
      PRS = 0.
   35 CONTINUE
      Z(ISILA  ) = Z(ISILA  ) + PRC*PR
      Z(ISILA+2) = Z(ISILA+2) + PRS*PR
      IF (PIEZ)  Z(ISILA+3) = Z(ISILA+3) + PRPIEZ*PR
      PR = GPCO(2,2)/3.0 + GPCO(2,1)/6.0
      Z(ISILB  ) = Z(ISILB  ) + PRC*PR
      Z(ISILB+2) = Z(ISILB+2) + PRS*PR
      IF (PIEZ)  Z(ISILB+3) = Z(ISILB+3) + PRPIEZ*PR
   90 RETURN
C
C     FILE ERRORS
C
  910 IP1 = -2
  911 CALL MESAGE (IP1,FILE,NAME(1))
  920 IP1 = -3
      GO TO 911
      END

      SUBROUTINE DSFWR1
      INCLUDE 'DSIOF.COM'
      INCLUDE 'XNSTRN.COM'
      CALL DSSKRC
      ID     = IAND( IBASE( INDCLR-1 ), MASKQ1 )
      IF ( ID .EQ. IDSEF ) GO TO 10
      IRETRN = 0
      GO TO 7000
10    IRETRN = 1
7000  RETURN
      END

      SUBROUTINE IFP4F (IBIT,FILE,BIT)
C
C     TEST BIT -IBIT- IN TRAILER OF DATA BLOCK -FILE-
C
      EXTERNAL     ANDF
      LOGICAL      BIT
      INTEGER      TWO, TRAIL(7), FILE, ANDF
      COMMON /TWO/ TWO(32)
C
      TRAIL(1) = FILE
      CALL RDTRL (TRAIL)
      I1 = (IBIT-1)/16 + 2
      I2 = IBIT - (I1-2)*16 + 16
      IF (ANDF(TRAIL(I1),TWO(I2))) 10,20,10
   10 BIT = .TRUE.
      RETURN
   20 BIT = .FALSE.
      RETURN
      END

      SUBROUTINE FVRST2
C
C    1. ENTRY POINT - FVRST2
C
C    2. PURPOSE -  THIS MODULE IS USED DURING A FORCED VIBRATION
C                  RESPONSE ANALYSIS OF ROTATING CYCLIC STRUCTURES
C                  TO GENERATE TABLE DATA BLOCKS FRL AND FOL AND TO
C                  GENERATE MATRIX DATA BLOCKS REORDER1 AND REORDER2.
C                  FVRSTR2 ALSO COMPUTES PARAMETERS LMAX, NTSTEPS,
C                  FLMAX, NORO1 AND NORO2.
C
C    3. DMAP CALLING SEQUENCE -
C
C         FVRSTR2  TOL,,,,,,, / FRL,FOL,REORDER1,REORDER2,,,, /
C                  V,Y,NSEGS/ V,Y,CYCIO/ V,Y,LMAX=-1/ V,N,FKMAX/
C                  V,N,FLMAX/ V,N,NTSTEPS/ V,N,NORO1/ V,N,NORO2  $
C
C    4. INPUT DATA BLOCKS -
C
C         TOL    - TIME OUTPUT LIST.
C
C         NOTE   - (1) TOL MUST BE PRESENT.
C
C    5. OUTPUT DATA BLOCKS -
C
C         FRL      - FREQUENCY RESPONSE LIST.
C         FOL      - FREQUENCY OUTPUT LIST.
C         REORDER1 - LOAD REORDERING MATRIX FO TIME-DEPENDENT PROBLEMS.
C         REORDER2 - LOAD REORDERING MATRIX FO TIME-DEPENDENT PROBLEMS.
C
C         NOTE     - (1) FRL AND FOL CANNOT BE PURGED.
C                    (2) REORDER1 AND REORDER2 SHOULD NOT BE PURGED.
C
C    6. PARAMETERS -
C
C        (A) NSEGS   - INPUT-INTEGER-NO DEFAULT.  THE NUMBER OF
C                      IDENTICAL SEGMENTS IN THE STRUCTURAL MODEL.
C        (B) CYCIO   - INPUT-INTEGER-NO DEFAULT.  THE INTEGER VALUE
C                      OF THIS PARAMETER SPECIFIES THE FORM OF THE INPUT
C                      AND OUTPUT DATA FOR CYCLIC STRUCTURES. A VALUE
C                      OF +1 IS USED TO SPECIFY PHYSICAL SEGMENT REPRE-
C                      SENTATION AND A VALUE OF -1 FOR CYCLIC TRANSFOR-
C                      MATION REPRESENTATION.
C        (C) LMAX    - INPUT/OUTPUT-INTEGER.  THE INTEGER VALUE OF THIS
C                      PARAMETER SPECIFIES THE MAXIMUM TIME HARMONIC
C                      INDEX FOR CYCLIC STRUCTURES. THE DEFAULT VALUE
C                      IS NTSTEPS/2, WHERE NTSTEPS IS THE NUMBER OF
C                      TIME STEPS DEFINED BELOW.
C        (D) FKMAX   - INPUT-INTEGER-NO DEFAULT.  FUNCTION OF KMAX.
C        (E) FLMAX   - OUTPUT-INTEGER-NO DEFAULT.  FUNCTION OF LMAX.
C        (F) NTSTEPS - OUTPUT-INTEGER-NO DEFAULT.  THE NUMBER OF
C                      TIME STEPS FOUND IN DATA BLOCK TOL.
C        (G) NORO1   - OUTPUT-INTEGER-NO DEFAULT.  NORO1 =-1 IF DATA
C                      BLOCK REORDER1 IS NOT GENERATED.
C        (H) NORO2   - OUTPUT-INTEGER-NO DEFAULT.  NORO2 =-1 IF DATA
C                      BLOCK REORDER2 IS NOT GENERATED.
C
C    7. METHOD -
C
C         DATA BLOCK TOL IS READ AND THE LIST OF SOLUTION TIMES IS
C         STORED. SET NTSTEPS TO THE NUMBER OF SOLUTION TIMES READ.
C         IF NECESSARY COMPUTE THE DEFAULT VALUE OF LMAX AND THEN
C         COMPUTE FLMAX.
C         GENERATE TABLE DATA BLOCKS FOL AND FRL.
C         GENERATE MATRIX DATA BLOCKS REORDER1 AND REORDER2 AND
C         PARAMETERS NORO1 AND NORO2.
C
C    8. SUBROUTINES - FVRST2 CALLS SUBROUTINE FVRS2A AND OTHER
C                     STANDARD NASTRAN UTILITY ROUTINES.
C
C    9. DESIGN REQUIREMENTS -
C
C         (1) OPEN CORE IS DEFINED AT /ZZFVR2/.
C         (2) NO SCRATCH FILES ARE USED.
C         (3) FVRST2 RESIDES IN LINKNS07.
C         (4) OPEN CORE FOR ONE BUFFER+1 IS REQUIRED.
C
C   10. DIAGNOSTIC MESSAGES -
C
C         THE FOLLOWING MESSAGES MAY BE ISSUED - 3001,3002,3003,3008.
C
C
      INTEGER          MODNAM(2),FILE,FNAM(2),TRL(7),DUM(2),SYSBUF,TOL,
     1                 FRL,FOL,REORD1,REORD2,CYCIO,FKMAX,FLMAX
      DOUBLE PRECISION PERIOD,FREQ,FACT,DPI,DTWOPI,DRADEG,DDEGRA,D4PISQ
      COMMON /BLANK /  NSEGS,CYCIO,LMAX,FKMAX,FLMAX,NTSTPS,NORO1,NORO2
      COMMON /ZZZZZZ/  Z(1)
      COMMON /SYSTEM/  SYSBUF,NOUT
      COMMON /CONDAD/  DPI,DTWOPI,DRADEG,DDEGRA,D4PISQ
      DATA    MODNAM/  4HFVRS,4HTR2  /
      DATA       TOL,  FRL, FOL, REORD1, REORD2 /
     1           101,  201, 202, 203,    204    /
C
C
C     DETERMINE LENGTH OF OPEN CORE AND ALLOCATE BUFFERS.
C
      NZ    = KORSZ(Z)
      IBUF1 = NZ - SYSBUF
      NZ    = IBUF1 - 1
      IF (NZ .LE. 0) GO TO 9908
C
C     READ DATA BLOCK TOL (TIME OUTPUT LIST).
C     LIST OF OUTPUT TIME VALUES ARE STORED IN TOL HEADER.
C
      FILE = TOL
      ITOL = 1
      CALL FNAME (FILE,FNAM)
      CALL OPEN (*9901,FILE,Z(IBUF1),0)
      CALL FREAD (FILE,DUM,2,0)
      CALL READ (*9902,*10,FILE,Z(ITOL),NZ,1,NTIMES)
C
C     INSUFFICIENT CORE TO HOLD ALL TIMES.
C
      GO TO 9908
C
   10 CALL CLOSE (FILE,1)
C
      NZ   = NZ - NTIMES
      NEXT = NTIMES + 1
      IF (NZ .LE. 0) GO TO 9908
C
C     DEFINE PARAMETER NTSTEPS.
C
C     IF (CYCIO .EQ. -1) NTSTEPS = (NTIMES*FKMAX)/FKMAX
C     IF (CYCIO .EQ. +1) NTSTEPS = (NTIMES*NSEGS)/NSEGS
C
      NTSTPS = NTIMES
C
C     SET DEFAULT VALUE OF PARAMETER LMAX.
C
      IF (LMAX .LT. 0) LMAX = NTSTPS/2
C
C     DEFINE PARAMETER FLMAX
C
      KK = (NTSTPS/2)*2
      IF (KK .NE. NTSTPS) GO TO 20
C
C     NTSTPS IS EVEN.
C
      IF (LMAX .NE. NTSTPS/2) GO TO 20
      FLMAX = NTSTPS
      GO TO 30
C
C     NTSTPS IS ODD.
C
   20 FLMAX = 2*LMAX + 1
C
   30 CONTINUE
C
C     GENERATE DATA BLOCKS FRL AND FOL BY CONVERTING TOL TIMES
C     TO THE FREQUENCY DOMAIN.
C
      NFREQ= FLMAX
      IFOL = NEXT
      NEXT = IFOL + NFREQ
      NZ   = NZ   - NFREQ
      IF (NZ .LE. 0) GO TO 9908
C
C     GENERATE FREQUENCY LIST FROM TOL TIME LIST.
C
      Z(IFOL) = 0.0
      IF (NFREQ .LE. 1) GO TO 60
C
      PERIOD = DBLE(Z(ITOL+1)) + DBLE(Z(ITOL+NTIMES-1))
      FREQ   = 1.0D0/PERIOD
      FACT   = 1.0D0
C
      IFREQ1 = IFOL + 1
      IFREQ2 = IFOL + NFREQ - 1
C
      DO 50 IFREQ = IFREQ1,IFREQ2,2
      Z(IFREQ)   = FACT*FREQ
      Z(IFREQ+1) = Z(IFREQ)
      FACT       = FACT + 1.0D0
   50 CONTINUE
C
      KK = (NFREQ/2)*2
      IF (KK .NE. NFREQ) GO TO 60
      Z(IFREQ2) = FACT*FREQ
C
   60 CONTINUE
C
C     OUTPUT FOL TABLE (FREQUENCY OUTPUT RESPONSE LIST).
C
      FILE = FOL
      CALL FNAME (FILE,FNAM)
      CALL OPEN (*9901,FILE,Z(IBUF1),1)
      CALL WRITE (FILE,FNAM,2,0)
      CALL WRITE (FILE,Z(IFOL),NFREQ,1)
      CALL CLOSE (FILE,1)
C
      TRL(1) = FILE
      TRL(2) = NFREQ
      TRL(3) = 1
      TRL(4) = 0
      TRL(5) = 0
      TRL(6) = 0
      TRL(7) = 0
      CALL WRTTRL (TRL)
C
C     GENERATE DATA BLOCK FRL FROM FOL (W = F*2*PI).
C     USE SAME CORE WHERE FOL IS STORED.
C
      DO 70 IFREQ = IFREQ1,IFREQ2
      Z(IFREQ) = Z(IFREQ)*DTWOPI
   70 CONTINUE
C
C     OUTPUT FRL TABLE (FREQUENCY RESPONSE LIST).
C
      FILE = FRL
      CALL FNAME (FILE,FNAM)
      CALL OPEN (*9901,FILE,Z(IBUF1),1)
      CALL WRITE (FILE,FNAM,2,0)
      CALL WRITE (FILE,1,1,1)
      CALL WRITE (FILE,Z(IFOL),NFREQ,1)
      CALL CLOSE (FILE,1)
C
      TRL(1) = FILE
      TRL(2) = 1
      TRL(3) = 0
      TRL(4) = 0
      TRL(5) = 0
      TRL(6) = 0
      TRL(7) = 0
      CALL WRTTRL (TRL)
C
C     GENERATE MATRIX DATA BLOCKS REORDER1 AND REORDER2 USED FOR
C     REORDERING COLUMNS OF A MATRIX BY POST-MULTIPLYING THE MATRIX
C     WHOSE COLUMNS ARE TO BE REORDERED.
C
      K1 = NTSTPS
      K3 = FLMAX
      IF (CYCIO .EQ. -1) K2 = FKMAX
      IF (CYCIO .EQ. +1) K2 = NSEGS
C
C     GENERATE MATRIX REORDER1
C
      CALL FVRS2A (REORD1,K1,K2,NORO1,Z(IBUF1))
C
C     GENERATE MATRIX REORDER2
C
      CALL FVRS2A (REORD2,K2,K3,NORO2,Z(IBUF1))
C
      RETURN
C
C     ERROR PROCESSING
C
C     DATA SET NOT IN FIST
C
 9901 IP1 = -1
      GO TO 9999
C
C     E-O-F ENCOUNTERED
C
 9902 IP1 = -2
      GO TO 9999
C
C     E-O-L ENCOUNTERED
C
 9908 IP1 = -8
      GO TO 9999
 9999 CALL MESAGE (IP1,FILE,MODNAM)
      CALL MESAGE (-37,0,MODNAM)
C
      RETURN
      END

      DOUBLE PRECISION FUNCTION DVMAG (V1,EPS)
C
C     RETURNS DOUBLE PRECISION MAGNITUDE OF VECTOR V1
C        DVMAG= 0.D0 WHEN .LE. EPS
C
      DOUBLE PRECISION V1(3), A, EPS, DADOTB
C
C
      DVMAG= 0.D0
      A= DADOTB(V1,V1)
      IF (A .GT. 0.D0) DVMAG= DSQRT(A)
      IF ( DVMAG .LE. EPS)             DVMAG= 0.D0
      RETURN
      END

      BLOCK DATA IFP3BD
CIFP3BD
C     B L O C K   D A T A   F O R   I F P 3
C
C
      INTEGER            FILE          ,INAME         ,CDTYPE
      INTEGER            AXIC1         ,CCONEX        ,FORCEX
      INTEGER            FORCE         ,GRAV          ,LOAD
      INTEGER            MOMAX         ,MOMENT        ,MPCADD
      INTEGER            MPCAX         ,OMITAX        ,POINTX
      INTEGER            PRESAX        ,RINGAX        ,SECTAX
      INTEGER            SEQGP         ,SPCAX         ,SUPAX
      INTEGER            TEMPAX        ,TEMPD         ,PLOAD
      INTEGER            MPC           ,SPC           ,GRID
      INTEGER            SUPORT        ,NEG111        ,T65535
      INTEGER            TEMP          ,OMIT          ,SPCADD
      INTEGER            ONE           ,ZERO
      INTEGER            CTRIAA        ,CTRAPA
      INTEGER            RFORCE
C
      COMMON /IFP3CM /  FILE(6)        ,INAME(12)     ,CDTYPE(50)
     1                  ,AXIC1(3)      ,CCONEX(3)     ,FORCEX(3)
     2                  ,FORCE(3)      ,GRAV(3)       ,LOAD(3)
     3                  ,MOMAX(3)      ,MOMENT(3)     ,MPCADD(3)
     4                  ,MPCAX(3)      ,OMITAX(3)     ,POINTX(3)
     5                  ,PRESAX(3)     ,RINGAX(3)     ,SECTAX(3)
     6                  ,SEQGP(3)      ,SPCAX(3)      ,SUPAX(3)
     7                  ,TEMPAX(3)     ,TEMPD(3)      ,PLOAD(3)
     8                  ,MPC(3)        ,SPC(3)        ,GRID(3)
     9                  ,SUPORT(3)     ,NEG111(3)     ,T65535(3)
     T                  ,TEMP(3)       ,OMIT(3)       ,SPCADD(3)
     1                  ,ONE           ,ZERO          ,IHEADB(96)
     2                  ,CTRIAA(3)     ,CTRAPA(3)     ,ICONSO
     3                  ,RFORCE(3)
C
      DATA ONE/1/ , ZERO/0/
C
      DATA FILE  ( 1), FILE  ( 2) / 201   , 208    /
      DATA FILE  ( 3), FILE  ( 4) / 209   , 210    /
      DATA FILE  ( 5), FILE  ( 6) / 301   , 215    /
C
      DATA INAME ( 1), INAME ( 2) / 4HGEOM, 4H1    /
      DATA INAME ( 3), INAME ( 4) / 4HGEOM, 4H2    /
      DATA INAME ( 5), INAME ( 6) / 4HGEOM, 4H3    /
      DATA INAME ( 7), INAME ( 8) / 4HGEOM, 4H4    /
      DATA INAME ( 9), INAME (10) / 4HSCRT, 4HCH   /
      DATA INAME (11), INAME (12) / 4HAXIC, 4H     /
C
      DATA CDTYPE( 1), CDTYPE( 2) / 4HAXIC, 4H     /
      DATA CDTYPE( 3), CDTYPE( 4) / 4HCCON, 4HEAX  /
      DATA CDTYPE( 5), CDTYPE( 6) / 4HFORC, 4HEAX  /
      DATA CDTYPE( 7), CDTYPE( 8) / 4HFORC, 4HE    /
      DATA CDTYPE( 9), CDTYPE(10) / 4HGRAV, 4H     /
      DATA CDTYPE(11), CDTYPE(12) / 4HLOAD, 4H     /
      DATA CDTYPE(13), CDTYPE(14) / 4HMOMA, 4HX    /
      DATA CDTYPE(15), CDTYPE(16) / 4HMOME, 4HNT   /
      DATA CDTYPE(17), CDTYPE(18) / 4HMPCA, 4HDD   /
      DATA CDTYPE(19), CDTYPE(20) / 4HMPCA, 4HX    /
      DATA CDTYPE(21), CDTYPE(22) / 4HOMIT, 4HAX   /
      DATA CDTYPE(23), CDTYPE(24) / 4HPOIN, 4HTAX  /
      DATA CDTYPE(25), CDTYPE(26) / 4HPRES, 4HAX   /
      DATA CDTYPE(27), CDTYPE(28) / 4HRING, 4HAX   /
      DATA CDTYPE(29), CDTYPE(30) / 4HSECT, 4HAX   /
      DATA CDTYPE(31), CDTYPE(32) / 4HSEQG, 4HP    /
      DATA CDTYPE(33), CDTYPE(34) / 4HSPCA, 4HDD   /
      DATA CDTYPE(35), CDTYPE(36) / 4HSPCA, 4HX    /
      DATA CDTYPE(37), CDTYPE(38) / 4HSUPA, 4HX    /
      DATA CDTYPE(39), CDTYPE(40) / 4HTEMP, 4HAX   /
      DATA CDTYPE(41), CDTYPE(42) / 4HTEMP, 4HD    /
      DATA CDTYPE(43), CDTYPE(44) / 4HCTRI, 4HAAX  /
      DATA CDTYPE(45), CDTYPE(46) / 4HCTRA, 4HPAX  /
      DATA CDTYPE(47), CDTYPE(48) / 4HRFOR, 4HCE   /
C
      DATA AXIC1  /515     ,5      ,0       /
      DATA CCONEX /8515    ,85     ,0       /
      DATA FORCEX /2115    ,21     ,0       /
      DATA FORCE  /4201    ,42     ,0       /
      DATA GRAV   /4401    ,44     ,0       /
      DATA LOAD   /4551    ,61     ,0       /
      DATA MOMAX  /3815    ,38     ,0       /
      DATA MOMENT /4801    ,48     ,0       /
      DATA MPCADD /4891    ,60     ,0       /
      DATA MPCAX  /4015    ,40     ,0       /
      DATA OMITAX /4315    ,43     ,0       /
      DATA POINTX /4915    ,49     ,0       /
      DATA PRESAX /5215    ,52     ,0       /
      DATA RINGAX /5615    ,56     ,0       /
      DATA SECTAX /6315    ,63     ,0       /
      DATA SEQGP  /5301    ,53     ,0       /
      DATA SPCAX  /6215    ,62     ,0       /
      DATA SUPAX  /6415    ,64     ,0       /
      DATA TEMPAX /6815    ,68     ,0       /
      DATA TEMPD  /5641    ,65     ,0       /
      DATA PLOAD  /5101    ,51     ,0       /
      DATA MPC    /4901    ,49     ,0       /
      DATA SPC    /5501    ,55     ,0       /
      DATA GRID   /4501    ,45     ,0       /
      DATA SUPORT /5601    ,56     ,0       /
      DATA TEMP   /5701    ,57     ,0       /
      DATA OMIT   /5001    ,50     ,0       /
      DATA SPCADD /5491    ,59     ,0       /
      DATA CTRIAA /7012    ,70     ,0       /
      DATA CTRAPA /7042    ,74     ,0       /
      DATA RFORCE /5509    ,55     ,0       /
      DATA ICONSO / 0 /
      DATA NEG111 /-1      ,-1     ,-1      /
      DATA T65535/ 65535, 65535, 65535 /
      DATA IHEADB /
     1                4HI N ,4HP U ,4HT   ,4HD A ,4HT A ,4H  E
     2               ,4HR R ,4HO R ,4HS   ,4HD E ,4HT E ,4HC T
     3               ,4HE D ,4H  B ,4HY   ,4HI F ,4HP 3 ,4H
     4               ,4H    ,4H    ,4H    ,4H    ,4H    ,4H
     5               ,4H    ,4H    ,4H    ,4H    ,4H    ,4H
     6               ,4H    ,4H    ,4H    ,4H (AX,4HIS-S,4HYMME
     7               ,4HTRIC,4H CON,4HICAL,4H SHE,4HLL D,4HATA
     8               ,4HPROC,4HESSO,4HR-GE,4HNERA,4HTOR),4H
     9               ,4H    ,4H    ,4H    ,4H    ,4H    ,4H
     T               ,4H    ,4H    ,4H    ,4H    ,4H    ,4H
     1               ,4H    ,4H    ,4H    ,4H    ,4H    ,4H ===
     2               ,4H====,4H====,4H====,4H====,4H====,4H====
     3               ,4H====,4H====,4H====,4H====,4H====,4H====
     4               ,4H====,4H    ,4H    ,4H    ,4H    ,4H
     5               ,4H    ,4H    ,4H    ,4H    ,4H    ,4H
     6               ,4H    ,4H    ,4H    ,4H    ,4H    ,4H      /
C
      END

      SUBROUTINE SMA1B (KE,J,II,IFILE,DAMPC)
C
C     SUBROUTINE SMA1B ADDS A N X N DOUBLE PRECISION MATRIX, KE, TO THE
C     SUBMATRIX OF ORDER NROWSC X JMAX, WHICH IS IN CORE.  N IS 1 IF
C     EITHER  NPVT, THE PIVOT POINT, IS A SCALAR POINT, OR J,THE SECOND
C     SUBSCRIPT OF KE CORRESPONDS TO A SCALAR POINT, OR J .NE. TO ANY
C     ENTRY IN THE GPCT.  OTHERWISE N IS 6.
C
      INTEGER          IZ(1),EOR,CLSRW,CLSNRW,FROWIC,TNROWS,OUTRW
      DOUBLE PRECISION DZ(1),KE(36),DAMPC
      COMMON /BLANK /  ICOM
      COMMON /SYSTEM/  ISYS(21),LINKNO
      COMMON /SEM   /  MASK(3),LNKNOS(15)
C
C     SMA1 I/O PARAMETERS
C
      COMMON /SMA1IO/  IFCSTM,IFMPT,IFDIT,IDUM1,IFECPT,IGECPT,
     1                 IFGPCT,IGGPCT,IFGEI,IGGEI,IFKGG,IGKGG,
     2                 IF4GG,IG4GG,IFGPST,IGGPST,INRW,OUTRW,
     3                 CLSNRW,CLSRW,NEOR,EOR,MCBKGG(7),MCB4GG(7)
C
C     SMA1 VARIABLE CORE
C
      COMMON /ZZZZZZ/  Z(1)
C
C     SMA1 VARIABLE CORE BOOKKEEPING PARAMETERS
C
      COMMON /SMA1BK/  ICSTM,NCSTM,IGPCT,NGPCT,IPOINT,NPOINT,
     1                 I6X6K,N6X6K,I6X64,N6X64
C
C     SMA1 PROGRAM CONTROL PARAMETERS
C
      COMMON /SMA1CL/  IOPT4,K4GGSW,NPVT,LEFT,FROWIC,LROWIC,
     1                 NROWSC,TNROWS,JMAX,NLINKS,LINK(10),IDETCK,
     2                 DODET,NOGO
C
C     ECPT COMMON BLOCK
C
      COMMON /SMA1ET/  ECPT(100)
C
      EQUIVALENCE      (Z(1),IZ(1),DZ(1))
C
C
C     CALL EMG1B AND THEN RETURN IF THIS IS LINK 8.
C     PROCEED NORMALLY FOR OTHER LINKS.
C
      IF (LINKNO .NE. LNKNOS(8)) GO TO 2
      CALL EMG1B (KE,J,II,IFILE,DAMPC)
      RETURN
C
C     DETERMINE WHICH MATRIX IS BEING COMPUTED.
C
    2 IBASE = I6X6K
      IF (IFILE .EQ. IFKGG) GO TO 5
      IF (IOPT4 .LT. 0) RETURN
      IBASE = I6X64
C
C     SEARCH THE GPCT AND FIND AN INDEX M SUCH THAT
C     IABS(GPCT(M)) .LE. J .LT. IABS(GPCT(M+1))
C
    5 LOW = IGPCT + 1
      LIM = NGPCT + LOW - 2
      IF (LOW .GT. LIM) GO TO 15
      DO 10 I = LOW,LIM
      ISAVE = I
      IF (J .GE. IABS(IZ(I+1))) GO TO 10
      IF (J .GE. IABS(IZ(I))  ) GO TO 20
   10 CONTINUE
      IF (J .GE. IABS(IZ(ISAVE+1))) ISAVE = ISAVE + 1
      GO TO 20
C
C     IF II .GT. 0, WE ARE DEALING WITH A SCALAR POINT.
C
   15 ISAVE = LOW
   20 IF (II .GT. 0) GO TO 60
C
C     AT THIS POINT IT HAS BEEN DETERMINED THAT J IS A SCALAR INDEX
C     NUMBER WHICH CORRESPONDS TO A GRID POINT.  HENCE THE DOUBLE
C     PRECISION 6 X 6 MATRIX, KE, WILL BE ADDED TO THE MATRIX.
C
      L1 = FROWIC - 1
      JJ = IPOINT + ISAVE - IGPCT
      J2 = IZ(JJ) - 1
      I1 = 0
      LIM= NROWSC - 1
   30 IF (I1 .GT. LIM) RETURN
      K1 = IBASE + I1*JMAX + J2
      J1 = 0
      L  = 6*L1
      K  = K1
   40 J1 = J1 + 1
      IF (J1 .GT. 6) GO TO 50
      K  = K + 1
      L  = L + 1
      IF (IFILE - IFKGG) 47,43,47
   43 DZ(K) = DZ(K) + KE(L)
      GO TO 40
   47 DZ(K) = DZ(K) + DAMPC*KE(L)
      GO TO 40
   50 I1 = I1 + 1
      L1 = L1 + 1
      GO TO 30
C
C     AT THIS POINT WE ARE DEALING WITH A 1 X 1.
C     FIRST COMPUTE THE ROW NUMBER, NROW
C
   60 NROW = II - NPVT + 1
C
C     THE FOLLOWING 2 FORTRAN STATEMENTS ARE MERELY TO CHECK THE PROGRAM
C     LOGIC.  EVENTUALLY THEY CAN BE DELETED.
C
      IF (NROW.GE.1 .AND. NROW.LE.TNROWS) GO TO 70
      CALL MESAGE (-30,22,NROW)
   70 LROWIC = FROWIC + NROWSC - 1
C
C     IF NROW, THE ROW INTO WHICH THE NUMBER KE(1) IS TO BE ADDED IS NOT
C     IN CORE IT CANNOT BE ADDED AT THIS TIME.
C
      IF (NROW.LT.FROWIC .OR. NROW.GT.LROWIC) RETURN
      J2 = ISAVE
      J3 = IPOINT + ISAVE - IGPCT
      INDEX = IBASE + (NROW-1)*JMAX + IZ(J3) - IABS(IZ(J2)) + J
      DZ(INDEX) = DZ(INDEX) + KE(1)
      RETURN
      END

      SUBROUTINE INPTT1
C
C     READ DATA BLOCK(S) FROM A NASTRAN USER TAPE WHICH MUST BE SET UP.
C
C     CALL TO THIS MODULE IS
C
C     INPUTT1  /O1,O2,O3,O4,O5/V,N,P1/V,N,P2/V,N,P3/V,N,P4  $
C
C     PARAMETERS P1 AND P2 ARE INTEGER INPUT, P3 AND P4 ARE BCD
C
C               P1= 0, NO ACTION TAKEN BEFORE READ (DEFAULT)
C                 =+N, SKIP FORWARD N DATA BLOCKS BEFORE READ
C                 =-1, USER TAPE IS REWOUND BEFORE READ
C                 =-2, A NEW REEL IS MOUNTED BEFORE READ
C                 =-3, THE NAMES OF ALL DATA BLOCKS ON USER TAPE ARE
C                      PRINTED AND READ OCCURS AT BEGINNING OF TAPE
C                 =-4, AN OUTPUT TAPE IS TO BE DISMOUNTED
C                      AFTER AN END-OF-FILE MARK IS WRITTEN.
C                      A NEW INPUT REEL WILL THEN BE MOUNTED.
C                 =-5, SEARCH USER TAPE FOR FIRST VERSION OF DATA
C                      BLOCKS REQUESTED.
C                      IF ANY ARE NOT FOUND, A FATAL TERMINATION
C                      OCCURS.
C                 =-6, SEARCH USER TAPE FOR FINAL VERSION OF DATA
C                      BLOCKS REQUESTED.
C                      IF ANY ARE NOT FOUND, A FATAL TERMINATION
C                      OCCURS.
C                 =-7, SEARCH USER TAPE FOR FIRST VERSION OF DATA
C                      BLOCKS REQUESTED.
C                      IF ANY ARE NOT FOUND, A WARNING OCCURS.
C                 =-8, SEARCH USER TAPE FOR FINAL VERSION OF DATA
C                      BLOCKS REQUESTED.
C                      IF ANY ARE NOT FOUND, A WARNING OCCURS.
C                 =-9, REWIND AND UNLOAD USER TAPE
C
C               P2= 0, FILE NAME IS INPT
C                 = 1, FILE NAME IS INP1
C                 = 2, FILE NAME IS INP2
C                 = 3, FILE NAME IS INP3
C                 = 4, FILE NAME IS INP4
C                 = 5, FILE NAME IS INP5
C                 = 6, FILE NAME IS INP6
C                 = 7, FILE NAME IS INP7
C                 = 8, FILE NAME IS INP8
C                 = 9, FILE NAME IS INP9
C                 THE MPL DEFAULT VALUE FOR P2 IS 0
C
C               P3=    TAPE ID CODE FOR USER TAPE, AN ALPHANUMERIC
C                      VARIABLE WHOSE VALUE MUST MATCH A CORRESPONDING
C                      VALUE ON THE USER TAPE.
C                      THIS CHECK IS DEPENDENT ON THE VALUE OF
C                      P1 AS FOLLOWS..
C                       *P1*             *TAPE ID CHECKED*
C                        +N                     NO
C                         0                     NO
C                        -1                    YES
C                        -2                    YES (ON NEW REEL)
C                        -3                    YES (WARNING CHECK)
C                        -4                    YES (ON NEW REEL)
C                        -5                    YES
C                        -6                    YES
C                        -7                    YES
C                        -8                    YES
C                        -9                     NO
C                      THE MPL DEFAULT VALUE FOR P3 IS XXXXXXXX
C
C
      EXTERNAL        RSHIFT,ANDF
      LOGICAL         TAPEUP,TAPBIT
      INTEGER         OUBUF,OUTPUT,P1,P2,P3,P4,ZERO,RSHIFT,ANDF,NONE(2),
     1                TRL(7),NAME(2),SUBNAM(2),INN(10),OUT(5),NAMEX(2),
     2                IDHDR(7),IDHDRX(7),P3X(2),NT(5,3),DX(3),TAPCOD(2),
     3                BCDBIN(4)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG / UFM,UWM,UIM,SFM
      COMMON /MACHIN/ MACH
      COMMON /BLANK / P1,P2,P3(2),P4(2)
     1       /SYSTEM/ KSYSTM(65)
     2       /ZZZZZZ/ X(1)
      EQUIVALENCE     (KSYSTM(1),NB  ), (KSYSTM( 2),NOUT),
     1                (KSYSTM(9),NLPP), (KSYSTM(12),LINE)
      DATA    SUBNAM/ 4HINPT, 4HT1  / , MSC      / 4HMSC /
      DATA    OUT   / 201,202,203,204,205/, MASK / 65535 /
      DATA    ZERO  , MONE,MTWO,MTRE,MFOR/ 0,-1,-2,-3,-4 /,
     1        MFIV  , MSIX,METE,MNIN     /-5,-6,-8,-9    /
      DATA    INN   / 4HINPT,4HINP1,4HINP2,4HINP3,4HINP4 ,
     1                4HINP5,4HINP6,4HINP7,4HINP8,4HINP9 /
      DATA    IDHDR / 4HNAST,4HRAN ,4HUSER,4H TAP,4HE ID,4H COD,4HE - /
      DATA    BCDBIN/ 4HBCD ,4H    ,4HBINA,4HRY          /
      DATA    NONE  / 4H (NO,4HNE) /, IPT1,IPT4/ 1H1,1H4 /
C
C
      IPTX = IPT1
      IF (P4(1) .EQ. MSC) GO TO 20
      GO TO 100
C
C
      ENTRY INPUT1
C     ============
C
C     INPUT1 HANDELS MSC/OUTPUT1 DATA.
C     INPUT1 IS CALLED FROM INPTT1, WITH P4 = 'MSC', OR IT IS CALLED
C     FROM INPTT4
C
   20 IPTX = IPT4
      IF (P3(1).EQ.BCDBIN(1) .AND. P3(2).EQ.BCDBIN(2)) GO TO 9918
      IF (P3(1).EQ.BCDBIN(3) .AND. P3(2).EQ.BCDBIN(4)) GO TO 9918
      WRITE  (NOUT,30) UIM
   30 FORMAT (A29,'. INPUTT1 IS REQUESTED TO READ INPUT TAPE GENERATED',
     1       ' IN MSC/OUTPUT1 COMPATIBLE RECORDS')
C
  100 LCOR = KORSZ(X) - 2*NB
      IF (LCOR .LE. 0) CALL MESAGE (-8,LCOR,SUBNAM)
      INBUF = LCOR  + 1
      OUBUF = INBUF + NB
      TAPCOD(1) = P3(1)
      TAPCOD(2) = P3(2)
      IF (P2.LT.0 .OR. P2.GT.9) GO TO 9907
      IN = INN(P2+1)
      IF (IPTX .EQ. IPT4) WRITE (NOUT,110) UIM,NB,IN
  110 FORMAT (A29,', CURRENT NASTRAN BUFFER SIZE IS',I9,' WORDS', /5X,
     1       'SYNCHRONIZED BUFFSIZE IS REQUIRED IN CURRENT NASTRAN AND',
     2       ' THE VERSION THAT WROTE ',A4,' TAPE (OR FILE)', /5X,
     3       3(4H====),/)
      IFILE  = IN
      IF (MACH .GE. 5) GO TO 120
      TAPEUP = TAPBIT(IN)
      IF (.NOT.TAPEUP ) GO TO 9909
  120 IF (P1 .LT. MNIN) GO TO 9908
C
      IF (P1 .EQ. MNIN) GO TO 5000
      IF (P1 .LT. MFOR) GO TO 3000
      IF (P1 .EQ. MTRE) GO TO 2000
      IF (P1 .LE. ZERO) GO TO 150
C
      CALL OPEN (*9901,IN,X(INBUF),2)
      DO 130 I = 1,P1
      CALL READ (*9906,*9906,IN,NAMEX,2,0,NF)
  130 CALL SKPFIL (IN,1)
      GO TO 250
C
  150 IF (P1.NE.MTWO .AND. P1.NE.MFOR) GO TO 190
C
C     P1 = -2 OR P1 = -4 IS ACCEPTABLE ONLY ON IBM OR UNIVAC
C
      IF (MACH.NE.2 .AND. MACH.NE.3) GO TO 9908
C
      IOLD = -P1/2
      CALL OPEN (*9901,IN,X(INBUF),2)
      CALL TPSWIT (IN,IOLD,1,TAPCOD)
C
  190 IF (P1.NE.MONE .AND. P1.NE.MTWO .AND. P1.NE.MFOR) GO TO 230
C
C     OPEN USER TAPE TO READ WITH REWIND AHD TAPE ID CHECK
C
      IF (P1.NE.MONE .AND. P1.NE.MTWO .AND. P1.NE.MFOR .AND.
     1    IPTX.EQ.IPT4) GO TO 230
      CALL OPEN (*9901,IN,X(INBUF),0)
      CALL READ (*9911,*9912,IN,DX,3,0,NF)
      CALL READ (*9911,*9912,IN,IDHDRX,7,0,NF)
      DO 210 KF = 1,7
      IF (IDHDRX(KF) .NE. IDHDR(KF)) GO TO 9913
  210 CONTINUE
      CALL READ (*9911,*9912,IN,P3X,2,1,NF)
      IF (P3X(1).NE.P3(1) .OR. P3X(2).NE.P3(2)) GO TO 9910
      CALL SKPFIL (IN,1)
      GO TO 250
C
C     OPEN USER TAPE TO READ WITHOUT REWIND AND NO TAPE ID CHECK
C
  230 CALL OPEN (*9901,IN,X(INBUF),2)
      IF (IPTX .EQ. IPT4) CALL FWDREC (*9912,IX)
C
  250 DO 1000 I = 1,5
      OUTPUT = OUT(I)
      TRL(1) = OUTPUT
      CALL RDTRL (TRL)
      IF (TRL(1) .LE. 0) GO TO 1000
      CALL FNAME (OUTPUT,NAME)
      IF (NAME(1).EQ.NONE(1) .AND. NAME(2).EQ.NONE(2)) GO TO 1000
C
C     PASS FILE NAME HEADER RECORD
C
      CALL READ (*9904,*9905,IN,NAMEX,2,0,NF)
C
C     READ TRAILER RECORD, SIX WORDS (OR 3 WORDS, IPTX=4 ONLY)
C
      CALL READ (*9904,*300,IN,TRL(2),6,1,NF)
      GO TO 340
C
C     JUST A NOTE, FROM G.CHAN/UNISYS -
C     LEVEL 17.5 USED 2 RECORDS HERE FOR THE MATRIX NAME (2 BCD WORDS,
C     1ST RECORD) AND 7 TRAILER WORDS (2ND RECORD)
C
  300 IF (IPTX.NE.IPT4 .OR. NF.LT.3) GO TO 9905
      TRL(5) = TRL(2)
      TRL(6) = TRL(3)
      TRL(7) = TRL(4)
      DO 320 J = 2,7
      J1 = J/2 + 4
      J2 = MOD(J-1,2)*16
      TRL(J) = ANDF(RSHIFT(TRL(J1),J2),MASK)
  320 CONTINUE
C
C     OPEN OUTPUT DATA BLOCK TO WRITE WITH REWIND
C
  340 CALL OPEN (*9902,OUTPUT,X(OUBUF),1)
C
C     COPY CONTENTS OF USER TAPE ONTO OUTPUT DATA BLOCK, INCLUDING
C     FILE NAME IN RECORD 0
C
      CALL CPYFIL (IN,OUTPUT,X,LCOR,NF)
C
C     CLOSE OUTPUT DATA BLOCK WITH REWIND AND EOF
C
      CALL CLOSE (OUTPUT,1)
C
C     WRITE TRAILER
C
      TRL(1) = OUTPUT
      CALL WRTTRL (TRL)
      CALL PAGE2 (-3)
      WRITE  (NOUT,400) UIM,NAME,IN,NAMEX
  400 FORMAT (A29,' 4105,     DATA BLOCK ',2A4,' RETRIEVED FROM USER ',
     1       'TAPE',A4, /5X,'NAME OF DATA BLOCK WHEN PLACED ON USER ',
     2       'TAPE WAS ',2A4 )
C
 1000 CONTINUE
C
C     CLOSE NASTRAN USER TAPE WITHOUT REWIND
C
      CALL CLOSE (IN,2)
      RETURN
C
C     OBTAIN LIST OF DATA BLOCKS ON USER TAPE.
C
 2000 CALL OPEN (*9901,IN,X(INBUF),0)
      CALL READ (*9911,*9912,IN,DX,3,0,NF)
      CALL READ (*9911,*9912,IN,IDHDRX,7,0,NF)
      DO 2005 KF = 1,7
      IF (IDHDRX(KF) .NE. IDHDR(KF)) GO TO 9913
 2005 CONTINUE
      CALL READ (*9911,*9912,IN,P3X,2,1,NF)
      IF (P3X(1).NE.P3(1) .OR. P3X(2).NE.P3(2)) GO TO 9914
 2006 CALL SKPFIL (IN,1)
      KF = 0
 2007 CALL PAGE1
      LINE = LINE + 5
      WRITE  (NOUT,2010) IN
 2010 FORMAT (1H0,50X,A4,14H FILE CONTENTS ,/46X,4HFILE,18X,4HNAME/1H0)
 2020 CALL READ (*2050,*9915,IN,NAMEX,2,1,NF)
      CALL SKPFIL (IN,1)
      KF = KF + 1
      LINE = LINE + 1
      WRITE (NOUT,2030) KF,NAMEX
 2030 FORMAT (45X,I5,18X,2A4)
      IF (LINE - NLPP) 2020,2007,2007
 2050 CALL REWIND (IN)
      CALL SKPFIL (IN,1)
      GO TO 250
C
C
C     SEARCH MODE
C
 3000 CONTINUE
C
C     EXAMINE OUTPUT REQUESTS AND FILL NAME TABLE
C
      NNT = 0
      DO 3050 I = 1,5
      OUTPUT = OUT(I)
      TRL(1) = OUTPUT
      CALL RDTRL (TRL)
      IF (TRL(1) .LE. 0) GO TO 3020
      CALL FNAME (OUTPUT,NAME)
      IF (IPTX.EQ.IPT4 .AND. NAME(1).EQ.NONE(1) .AND. NAME(2).EQ.NONE(2)
     1   ) GO TO 3010
      NT(I,1) = 0
      NT(I,2) = NAME(1)
      NT(I,3) = NAME(2)
      NNT = NNT + 1
      GO TO 3050
 3010 NT(I,2) = NAME(1)
      NT(I,3) = NAME(2)
 3020 NT(I,1) = -1
 3050 CONTINUE
C
      IF (NNT .GT. 0) GO TO 3070
      CALL PAGE2 (-2)
      WRITE  (NOUT,3060) UWM,IPTX
 3060 FORMAT (A25,' 4137,  ALL OUTPUT DATA BLOCKS FOR INPUTT',A1,
     1       ' ARE PURGED.')
      RETURN
C
C     CHECK TAPE ID LABEL.
C
 3070 CALL OPEN (*9901,IN,X(INBUF),0)
      CALL READ (*9911,*9912,IN,DX,3,0,NF)
      CALL READ (*9911,*9912,IN,IDHDRX,7,0,NF)
      DO 3080 KF = 1,7
      IF (IDHDRX(KF) .NE. IDHDR(KF)) GO TO 9913
 3080 CONTINUE
      CALL READ (*9911,*9912,IN,P3X,2,1,NF)
      IF (P3X(1).NE.P3(1) .OR. P3X(2).NE.P3(2)) GO TO 9910
      CALL SKPFIL (IN,1)
C
C
C     BEGIN SEARCH OF TAPE.
C
      KF = 0
 3110 CALL READ (*3500,*9915,IN,NAMEX,2,0,NF)
      KF = KF + 1
C
      DO 3200 I = 1,5
      NAME(1) = NT(I,2)
      NAME(2) = NT(I,3)
      IF (NT(I,1) .LT. 0) GO TO 3200
      IF (NAME(1).NE.NAMEX(1) .OR. NAME(2).NE.NAMEX(2)) GO TO 3200
      NT(I,1) = NT(I,1) + 1
      IF (NT(I,1).EQ.1 .OR. P1.EQ.MSIX .OR. P1.EQ.METE) GO TO 3150
      CALL PAGE2 (-3)
      WRITE  (NOUT,3140) UWM,NAME,KF,IN
 3140 FORMAT (A25,' 4138,  DATA BLOCK ',2A4,' (DATA BLOCK COUNT =',I5,
     2        ') HAS PREVIOUSLY BEEN RETRIEVED FROM', /36X ,
     3        'USER TAPE ',A4,' AND WILL BE IGNORED.')
      GO TO 3205
 3150 CALL READ (*9904,*3160,IN,TRL(2),6,1,NF)
      GO TO 3180
 3160 IF (IPTX.NE.IPT4 .OR. NF.LT.3) GO TO 9905
      TRL(5) = TRL(2)
      TRL(6) = TRL(3)
      TRL(7) = TRL(4)
      DO 3170 J = 2,7
      J1 = J/2 + 4
      J2 = MOD(J-1,2)*16
      TRL(J) = ANDF(RSHIFT(TRL(J1),J2),MASK)
 3170 CONTINUE
 3180 OUTPUT = OUT(I)
      CALL OPEN (*9902,OUTPUT,X(OUBUF),1)
      CALL CPYFIL (IN,OUTPUT,X,LCOR,NF)
      CALL CLOSE (OUTPUT,1)
      TRL(1) = OUTPUT
      CALL WRTTRL (TRL)
      CALL PAGE2 (-2)
      WRITE  (NOUT,3185) UIM,NAME,IN,KF
 3185 FORMAT (A29,' 4139, DATA BLOCK ',2A4,' RETRIEVED FROM USER TAPE ',
     1       A4,' (DATA BLOCK COUNT =',I5,1H))
      IF (NT(I,1) .GT. 1) GO TO 3190
      NNT = NNT - 1
      GO TO 3210
 3190 WRITE  (NOUT,3195) UWM
 3195 FORMAT (A25,' 4140, SECONDARY VERSION OF DATA BLOCK HAS REPLACED',
     1        ' EARLIER ONE.')
      CALL PAGE2 (-2)
      GO TO 3210
 3200 CONTINUE
C
 3205 CALL SKPFIL (IN,1)
 3210 IF (NNT.GT.0 .OR. P1.EQ.MSIX .OR. P1.EQ.METE) GO TO 3110
      GO TO 3900
C
 3500 IF (NNT .LE. 0) GO TO 3900
      CALL PAGE2 (-7)
      IF (P1.EQ.MFIV .OR. P1.EQ.MSIX) GO TO 9916
      WRITE  (NOUT,3510) UWM
 3510 FORMAT (A25,' 4141, ONE OR MORE DATA BLOCKS NOT FOUND ON USER ',
     1        'TAPE.')
      DO 3530 I = 1,5
      IF (NT(I,1) .NE. 0) GO TO 3530
      WRITE  (NOUT,3520) NT(I,2),NT(I,3)
 3520 FORMAT (20X,21HNAME OF DATA BLOCK = ,2A4)
 3530 CONTINUE
      IF (P1.EQ.MFIV .OR. P1.EQ.MSIX) GO TO 9995
C
 3900 CONTINUE
      CALL SKPFIL (IN,-1)
      CALL CLOSE (IN,2)
      RETURN
C
 5000 CONTINUE
      CALL UNLOAD (IN)
      RETURN
C
C     ERRORS
C
 9901 WRITE  (NOUT,9951) SFM,IPTX,IN
 9951 FORMAT (A25,' 4107, MODULE INPTT',A1,' UNABLE TO OPEN NASTRAN ',
     1       'FILE ',A4,1H.)
      GO TO 9995
C
 9902 WRITE  (NOUT,9952) SFM,IPTX,OUTPUT
 9952 FORMAT (A25,' 4108, SUBROUTINE INPTT',A1,' UNABLE TO OPEN OUTPUT',
     1       ' DATA BLOCK',I5)
      GO TO 9995
C
 9904 CALL MESAGE (-2,IFILE,SUBNAM)
C
 9905 CALL MESAGE (-3,IFILE,SUBNAM)
C
 9906 WRITE  (NOUT,9956) UFM,IPTX,P1,IN,I
 9956 FORMAT (A22,' 4111, MODULE INPUTT',A1,' IS UNABLE TO SKIP FORWARD'
     1,       I10,' DATA BLOCKS ON PERMANENT NASTRAN FILE ',A4,1H., /5X,
     2        'NUMBER OF DATA BLOCKS SKIPPED =',I5)
      LINE = LINE + 1
      GO TO 9995
C
 9907 WRITE  (NOUT,9957) UFM,IPTX,P2
 9957 FORMAT (A23,' 4112, MODULE INPUTT',A1,' - ILLEGAL VALUE FOR ',
     1        'SECOND PARAMETER =',I20)
      GO TO 9995
C
 9908 WRITE  (NOUT,9958) UFM,IPTX,P1
 9958 FORMAT (A23,' 4113, MODULE INPUTT',A1,' - ILLEGAL VALUE FOR ',
     1       'FIRST PARAMETER =',I20)
      GO TO 9995
C
 9909 WRITE  (NOUT,9959) UFM,IN
 9959 FORMAT (A23,' 4127, USER TAPE ',A4,' NOT SET UP.')
      GO TO 9995
C
 9910 WRITE  (NOUT,9960) UFM,P3X,IPTX,P3
 9960 FORMAT (A23,' 4136, USER TAPE ID CODE -',2A4,'- DOES NOT MATCH ',
     1       'THIRD INPUTT',A1,' DMAP PARAMETER -',2A4,2H-.)
      GO TO 9995
C
 9911 WRITE  (NOUT,9961) UFM,IPTX,IN
 9961 FORMAT (A23,' 4132, MODULE INPUTT',A1,' - END-OF-FILE ENCOUNTERED'
     1,   ' WHILE ATTEMPTING TO READ TAPE ID CODE ON USER TAPE ',A4,1H.)
      GO TO 9995
C
 9912 WRITE  (NOUT,9962) UFM,IPTX,IN
 9962 FORMAT (A23,' 4133, MODULE INPUTT',A1,' - END-OF-RECORD ',
     1       'ENCOUNTERED WHILE ATTEMPTING TO READ TAPE ID CODE ON ',
     2       'USER TAPE ',A4,1H.)
      GO TO 9995
C
 9913 WRITE  (NOUT,9963) UFM,IPTX,IDHDRX
 9963 FORMAT (A23,' 4134, MODULE INPUTT',A1,
     1        ' - ILLEGAL TAPE CODE HEADER = ',7A4)
      GO TO 9995
C
 9914 WRITE  (NOUT,9964) UWM,P3X,P3
 9964 FORMAT (A25,' 4135, USER TAPE ID CODE -',2A4,'- DOES NOT MATCH ',
     1        'THIRD INPUTT1 DMAP PARAMETER -',2A4,2H-.)
      LINE = LINE + 2
      GO TO 2006
C
 9915 WRITE  (NOUT,9965) SFM,IPTX
 9965 FORMAT (A25,' 4106, MODULE INPUTT',A1,' - SHORT RECORD.')
      GO TO 9995
C
 9916 WRITE  (NOUT,9966) UFM
 9966 FORMAT (A23,' 4142, ONE OR MORE DATA BLOCKS NOT FOUND ON USER ',
     1       'TAPE',/)
      DO 9917 I = 1,5
      IF (NT(I,1) .NE. 0) GO TO 9917
      WRITE (NOUT,9967) NT(I,2),NT(I,3)
      LINE = LINE + 1
 9917 CONTINUE
 9967 FORMAT (20X,'NAME OF DATA BLOCK = ',2A4)
      GO TO 9995
C
 9918 WRITE  (NOUT,9968) UFM,P3
 9968 FORMAT (A23,', ILLEGAL TAPE LABEL NAME -',2A4,'-  POSSIBLY ',
     1       'THE 4TH PARAMETER OF INPTT4 IS IN ERROR')
C
C
 9995 LINE = LINE + 2
      CALL MESAGE (-61,0,0)
      RETURN
C
      END

      BLOCK DATA IFX1BD
CIFX1BD
C     DEFINITION OF VARIABLES IN /IFPX1/ AND /IFPX0/
C*****
C
C     COMMON /IFPX1/
C     --------------
C
C     N          = TOTAL NUMBER OF PAIRED ENTRIES IN THE IBD AND
C                  IPR ARRAYS
C                = (TOTAL DIMENSION OF IBD + ACTIVE IPR ARRAYS)/2
C
C     IBD ARRAYS = ARRAYS CONTAINING PAIRED ENTRIES OF BULK DATA
C                  CARD NAMES
C
C     IPR ARRAYS = ARRAYS CONTAINING PAIRED ENTRIES OF BULK DATA
C                  PARAMETER NAMES
C
C     CAUTION 1 -- THE TOTAL DIMENSION OF THE IBD AND IPR ARRAYS
C                  MUST BE A MULTIPLE OF 62 (OR, IN OTHER WORDS,
C                  AN EVEN MULTIPLE OF 31)
C
C                  SEE NOTES 1 AND 2 BELOW
C
C     ICC ARRAYS = ARRAYS CONTAINING PAIRED ENTRIES OF CASE CONTROL
C                  FLAG NAMES FOR USE IN RESTART RUNS
C
C     CAUTION 2 -- THE TOTAL DIMENSION OF THE ICC ARRAYS MUST BE A
C                  MULTIPLE OF 62 (OR, IN OTHER WORDS, AN EVEN
C                  MULTIPLE OF 31)
C
C                  SEE NOTE 3 BELOW
C
C     NOTES
C     -----
C
C              1.  IF NEW BULK DATA CARD NAMES ARE TO BE ADDED,
C                  USE THE EXISTING PADDING WORDS (OF THE 4H****
C                  TYPE) IN THE IBD ARRAYS.  IF NECESSARY, EXPAND
C                  THE IBD ARRAYS KEEPING CAUTION 1 IN MIND.
C
C              2.  IF NEW BULK DATA PARAMETER NAMES ARE TO BE ADDED,
C                  USE THE EXISTING PADDING WORDS (OF THE 4H****
C                  TYPE) IN THE IPR ARRAYS.  IF NECESSARY, EXPAND
C                  THE IPR ARRAYS KEEPING CAUTION 1 IN MIND.
C
C              3.  IF NEW CASE CONTROL FLAG NAMES ARE TO BE ADDED,
C                  USE THE EXISTING PADDING WORDS (OF THE 4H****
C                  TYPE) IN THE ICC ARRAYS.  IF NECESSARY, EXPAND
C                  THE ICC ARRAYS KEEPING CAUTION 2 IN MIND.
C
C              4.  THE IBD ARRAYS ARE IN SYSCHRONIZTION WITH THE I ARRAY
C                  IN IFX2BD, IFX3BD, IFX4BD, IFX5BD, AND IFX6BD
C                  (E.G. CONM1 POSITIONS IN IBD2, CONTINUATION 3, THE DA
C                  FOR CONM1 IN IFX2BD IS IN I2, CONTINUATION 3 CARD)
C*****
C
C     COMMON /IFPX0/
C     --------------
C
C     LBDPR      = (TOTAL DIMENSION OF THE IBD AND IPR ARRAYS)/62
C
C     LCC        = (TOTAL DIMENSION OF THE ICC ARRAYS)/62
C
C     IWRDS      = ARRAY WHOSE DIMENSION IS EQUAL TO (LBDPR + LCC).
C                  ALL (LBDPR + LCC) WORDS IN THE ARRAY INITIALLY
C                  SET TO ZERO.
C
C     IPARPT     = POINTER THAT POINTS TO THE PAIRED ENTRY IN THE
C                  IBD AND IPR ARRAYS THAT CONTAINS THE FIRST
C                  BULK DATA PARAMETER NAME.  AS PER THE DIFINITIONS
C                  OF THE VARIABLES IN COMMON /IFPX1/, THIS POINTS
C                  TO THE FIRST WORD OF THE IPR1 ARRAY.  HENCE, WE
C                  HAVE --
C
C                  IPARPT = 1 + (TOTAL DIMENSION OF IBD ARRAYS)/2
C
      COMMON /IFPX0 /    LBDPR    , LCC      , IWRDS(18), IPARPT
      COMMON /IFPX1 / N, IBD1(100), IBD2(100), IBD3(100), IBD4(100),
     1                   IBD5(100), IBD6(100), IBD7(100), IBD8(100),
     2                   IPR1(100), IPR2( 92),
     3                   ICC1(100), ICC2( 24)
C
C*****
C     INITIALIZATION OF VARIABLES IN COMMON /IFPX1/
C*****
C
      DATA N / 496 /
C*****
C     THE IBD ARRAYS CONTAIN PAIRED ENTRIES OF BULK DATA CARD NAMES
C*****
      DATA IBD1 /
     1     4HGRID,4H    , 4HGRDS,4HET  , 4HADUM,4H1   , 4HSEQG,4HP   ,
     *     4HCORD,4H1R  , 4HCORD,4H1C  , 4HCORD,4H1S  , 4HCORD,4H2R  ,
     *     4HCORD,4H2C  , 4HCORD,4H2S  , 4HPLOT,4HEL  , 4HSPC1,4H    ,
     3     4HSPCA,4HDD  , 4HSUPO,4HRT  , 4HOMIT,4H    , 4HSPC ,4H    ,
     *     4HMPC ,4H    , 4HFORC,4HE   , 4HMOME,4HNT  , 4HFORC,4HE1  ,
     *     4HMOME,4HNT1 , 4HFORC,4HE2  , 4HMOME,4HNT2 , 4HPLOA,4HD   ,
     5     4HSLOA,4HD   , 4HGRAV,4H    , 4HTEMP,4H    , 4HGENE,4HL   ,
     *     4HPROD,4H    , 4HPTUB,4HE   , 4HPVIS,4HC   , 4HADUM,4H2   ,
     *     4HPTRI,4HA1  , 4HPTRI,4HA2  , 4HPTRB,4HSC  , 4HPTRP,4HLT  ,
     7     4HPTRM,4HEM  , 4HPQUA,4HD1  , 4HPQUA,4HD2  , 4HPQDP,4HLT  ,
     *     4HPQDM,4HEM  , 4HPSHE,4HAR  , 4HPTWI,4HST  , 4HPMAS,4HS   ,
     *     4HPDAM,4HP   , 4HPELA,4HS   , 4HCONR,4HOD  , 4HCROD,4H    ,
     9     4HCTUB,4HE   , 4HCVIS,4HC   /
      DATA IBD2 /
     1     4HADUM,4H3   , 4HCTRI,4HA1  , 4HCTRI,4HA2  , 4HCTRB,4HSC  ,
     *     4HCTRP,4HLT  , 4HCTRM,4HEM  , 4HCQUA,4HD1  , 4HCQUA,4HD2  ,
     *     4HCQDP,4HLT  , 4HCQDM,4HEM  , 4HCSHE,4HAR  , 4HCTWI,4HST  ,
     3     4HCONM,4H1   , 4HCONM,4H2   , 4HCMAS,4HS1  , 4HCMAS,4HS2  ,
     *     4HCMAS,4HS3  , 4HCMAS,4HS4  , 4HCDAM,4HP1  , 4HCDAM,4HP2  ,
     *     4HCDAM,4HP3  , 4HCDAM,4HP4  , 4HCELA,4HS1  , 4HCELA,4HS2  ,
     5     4HCELA,4HS3  , 4HCELA,4HS4  , 4HMAT1,4H    , 4HMAT2,4H    ,
     *     4HCTRI,4HARG , 4HCTRA,4HPRG , 4HDEFO,4HRM  , 4HPARA,4HM   ,
     *     4HMPCA,4HDD  , 4HLOAD,4H    , 4HEIGR,4H    , 4HEIGB,4H    ,
     7     4HEIGC,4H    , 4HADUM,4H4   , 4H    ,4H    , 4HMATS,4H1   ,
     *     4HMATT,4H1   , 4HOMIT,4H1   , 4HTABL,4HEM1 , 4HTABL,4HEM2 ,
     *     4HTABL,4HEM3 , 4HTABL,4HEM4 , 4HTABL,4HES1 , 4HTEMP,4HD   ,
     9     4HADUM,4H5   , 4HADUM,4H6   /
      DATA IBD3 /
     1     4HADUM,4H7   , 4HMATT,4H2   , 4HADUM,4H8   , 4HCTOR,4HDRG ,
     *     4HSPOI,4HNT  , 4HADUM,4H9   , 4HCDUM,4H1   , 4HCDUM,4H2   ,
     *     4HCDUM,4H3   , 4HCDUM,4H4   , 4HCDUM,4H5   , 4HCDUM,4H6   ,
     3     4HCDUM,4H7   , 4HCDUM,4H8   , 4HCDUM,4H9   , 4HPDUM,4H1   ,
     *     4HPDUM,4H2   , 4HPDUM,4H3   , 4HDMI ,4H    , 4HDMIG,4H    ,
     *     4HPTOR,4HDRG , 4HMAT3,4H    , 4HDLOA,4HD   , 4HEPOI,4HNT  ,
     5     4HFREQ,4H1   , 4HFREQ,4H    , 4HNOLI,4HN1  , 4HNOLI,4HN2  ,
     *     4HNOLI,4HN3  , 4HNOLI,4HN4  , 4HRLOA,4HD1  , 4HRLOA,4HD2  ,
     *     4HTABL,4HED1 , 4HTABL,4HED2 , 4HSEQE,4HP   , 4HTF  ,4H    ,
     7     4HTIC ,4H    , 4HTLOA,4HD1  , 4HTLOA,4HD2  , 4HTABL,4HED3 ,
     *     4HTABL,4HED4 , 4HTSTE,4HP   , 4HDSFA,4HCT  , 4HAXIC,4H    ,
     *     4HRING,4HAX  , 4HCCON,4HEAX , 4HPCON,4HEAX , 4HSPCA,4HX   ,
     9     4HMPCA,4HX   , 4HOMIT,4HAX  /
      DATA IBD4 /
     1     4HSUPA,4HX   , 4HPOIN,4HTAX , 4HSECT,4HAX  , 4HPRES,4HAX  ,
     *     4HTEMP,4HAX  , 4HFORC,4HEAX , 4HMOMA,4HX   , 4HEIGP,4H    ,
     *     4HPDUM,4H4   , 4HPDUM,4H5   , 4HPDUM,4H6   , 4HTABD,4HMP1 ,
     3     4HPDUM,4H7   , 4HPDUM,4H8   , 4HPDUM,4H9   , 4HFREQ,4H2   ,
     *     4HCONC,4HT1  , 4HCONC,4HT   , 4HTRAN,4HS   , 4HRELE,4HS   ,
     *     4HLOAD,4HC   , 4HSPCS,4HD   , 4HSPCS,4H1   , 4HSPCS,4H    ,
     5     4HBDYC,4H    , 4HMPCS,4H    , 4HBDYS,4H    , 4HBDYS,4H1   ,
     *     4HBARO,4HR   , 4HCBAR,4H    , 4HPBAR,4H    , 4HDARE,4HA   ,
     *     4HDELA,4HY   , 4HDPHA,4HSE  , 4HPLFA,4HCT  , 4HGNEW,4H    ,
     7     4HGTRA,4HN   , 4HTABR,4HNDG , 4HMATT,4H3   , 4HRFOR,4HCE  ,
     *     4HTABR,4HND1 , 4HPLOA,4HD4  , 4HUSET,4H    , 4HUSET,4H1   ,
     *     4HRAND,4HPS  , 4HRAND,4HT1  , 4HRAND,4HT2* , 4HPLOA,4HD1  ,
     9     4HPLOA,4HD2  , 4HDTI ,4H    /
      DATA IBD5 /
     1     4HTEMP,4HP1  , 4HTEMP,4HP2  , 4HTEMP,4HP3  , 4HTEMP,4HRB  ,
     *     4HGRID,4HB   , 4HFSLI,4HST  , 4HRING,4HFL  , 4HPRES,4HPT  ,
     *     4HCFLU,4HID2 , 4HCFLU,4HID3 , 4HCFLU,4HID4 , 4HAXIF,4H    ,
     3     4HBDYL,4HIST , 4HFREE,4HPT  , 4HASET,4H    , 4HASET,4H1   ,
     *     4HCTET,4HRA  , 4HCWED,4HGE  , 4HCHEX,4HA1  , 4HCHEX,4HA2  ,
     *     4HDMIA,4HX   , 4HFLSY,4HM   , 4HAXSL,4HOT  , 4HCAXI,4HF2  ,
     5     4HCAXI,4HF3  , 4HCAXI,4HF4  , 4HCSLO,4HT3  , 4HCSLO,4HT4  ,
     *     4HGRID,4HF   , 4HGRID,4HS   , 4HSLBD,4HY   , 4HCHBD,4HY   ,
     *     4HQHBD,4HY   , 4HMAT4,4H    , 4HMAT5,4H    , 4HPHBD,4HY   ,
     7     4HMATT,4H4   , 4HMATT,4H5   , 4HQBDY,4H1   , 4HQBDY,4H2   ,
     *     4HQVEC,4HT   , 4HQVOL,4H    , 4HRADL,4HST  , 4HRADM,4HTX  ,
     *     4HSAME,4H    , 4HNOSA,4HME  , 4HINPU,4HT   , 4HOUTP,4HUT  ,
     9     4HCQDM,4HEM1 , 4HPQDM,4HEM1 /
      DATA IBD6 /
     1     4HCIHE,4HX1  , 4HCIHE,4HX2  , 4HCIHE,4HX3  , 4HPIHE,4HX   ,
     *     4HPLOA,4HD3  , 4HSPCD,4H    , 4HCYJO,4HIN  , 4HCNGR,4HNT  ,
     *     4HCQDM,4HEM2 , 4HPQDM,4HEM2 , 4HCQUA,4HD4  , 4HMAT8,4H    ,
     3     4HCAER,4HO1  , 4HPAER,4HO1  , 4HAERO,4H    , 4HSPLI,4HNE1 ,
     *     4HSPLI,4HNE2 , 4HSET1,4H    , 4HSET2,4H    , 4HMKAE,4HRO2 ,
     *     4HMKAE,4HRO1 , 4HFLUT,4HTER , 4HAEFA,4HCT  , 4HFLFA,4HCT  ,
     5     4HCBAR,4HAO  , 4HPLIM,4HIT  , 4HPOPT,4H    , 4HPLOA,4HDX  ,
     *     4HCRIG,4HD1  , 4HPCOM,4HP   , 4HPCOM,4HP1  , 4HPCOM,4HP2  ,
     *     4HPSHE,4HLL  , 4HCRIG,4HD2  , 4HCTRI,4HAAX , 4HPTRI,4HAAX ,
     7     4HCTRA,4HPAX , 4HPTRA,4HPAX , 4HVIEW,4H    , 4HVARI,4HAN  ,
     *     4HCTRI,4HM6  , 4HPTRI,4HM6  , 4HCTRP,4HLT1 , 4HPTRP,4HLT1 ,
     *     4HTEMP,4HG   , 4HTEMP,4HP4  , 4HCRIG,4HDR  , 4HCRIG,4HD3  ,
     9     4HCTRS,4HHL  , 4HPTRS,4HHL  /
      DATA IBD7 /
     1     4HCAER,4HO2  , 4HCAER,4HO3  , 4HCAER,4HO4  , 4HPAER,4HO2  ,
     *     4HPAER,4HO3  , 4HPAER,4HO4  , 4HSPLI,4HNE3 , 4HGUST,4H    ,
     *     4HCAER,4HO5  , 4HPAER,4HO5  , 4HDARE,4HAS  , 4HDELA,4HYS  ,
     3     4HDPHA,4HSES , 4HTICS,4H    , 4HMATP,4HZ1  , 4HMATP,4HZ2  ,
     *     4HMTTP,4HZ1  , 4HMTTP,4HZ2  , 4HMAT6,4H    , 4HMATT,4H6   ,
     *     4HCEML,4HOOP , 4HSPCF,4HLD  , 4HCIS2,4HD8  , 4HPIS2,4HD8  ,
     5     4HGEML,4HOOP , 4HREMF,4HLUX , 4HBFIE,4HLD  , 4HMDIP,4HOLE ,
     *     4HPROL,4HATE , 4HPERM,4HBDY , 4HCFFR,4HEE  , 4HCFLS,4HTR  ,
     *     4HCFHE,4HX1  , 4HCFHE,4HX2  , 4HCFTE,4HTRA , 4HCFWE,4HDGE ,
     7     4HMATF,4H    , 4HCELB,4HOW  , 4HPELB,4HOW  , 4HNOLI,4HN5  ,
     *     4HNOLI,4HN6  , 4HCFTU,4HBE  , 4HPFTU,4HBE  , 4HNFTU,4HBE  ,
     *     4HSTRE,4HAML1, 4HSTRE,4HAML2, 4HCRRO,4HD   , 4HCRBA,4HR   ,
     9     4HCRTR,4HPLT , 4HCRBE,4H1   /
      DATA IBD8 /
     1     4HCRBE,4H2   , 4HCRBE,4H3   , 4HCRSP,4HLINE, 4HCTRI,4HA3  ,
     *     4HTABL,4HEM5 , 4HCPSE,4H2   , 4HCPSE,4H3   , 4HCPSE,4H4   ,
     *     4HPPSE,4H    , 82*4H****    /
C*****
C     THE IPR ARRAYS CONTAIN PAIRED ENTRIES OF BULK DATA PARAMETER NAMES
C*****
      DATA IPR1 /
     1     4HGRDP,4HNT  , 4HWTMA,4HSS  , 4HIRES,4H    , 4HLFRE,4HQ   ,
     5     4HHFRE,4HQ   , 4HLMOD,4HES  , 4HG   ,4H    , 4HW3  ,4H    ,
     9     4HW4  ,4H    , 4HMODA,4HCC  , 4HCOUP,4HMASS, 4HCPBA,4HR   ,
     3     4HCPRO,4HD   , 4HCPQU,4HAD1 , 4HCPQU,4HAD2 , 4HCPTR,4HIA1 ,
     7     4HCPTR,4HIA2 , 4HCPTU,4HBE  , 4HCPQD,4HPLT , 4HCPTR,4HPLT ,
     1     4HCPTR,4HBSC , 4HMAXI,4HT   , 4HEPSH,4HT   , 4HTABS,4H    ,
     5     4HSIGM,4HA   , 4HBETA,4H    , 4HRADL,4HIN  , 4HBETA,4HD   ,
     9     4HNT  ,4H    , 4HEPSI,4HO   , 4HCTYP,4HE   , 4HNSEQ,4HS   ,
     3     4HNLOA,4HD   , 4HCYCI,4HO   , 4HCYCS,4HEQ  , 4HKMAX,4H    ,
     7     4HKIND,4HEX  , 4HNODJ,4HE   , 4HP1  ,4H    , 4HP2  ,4H    ,
     1     4HP3  ,4H    , 4HVREF,4H    , 4HPRIN,4HT   , 4HISTA,4HRT  ,
     5     4HKDAM,4HP   , 4HGUST,4HAERO, 4HIFTM,4H    , 4HMACH,4H    ,
     9     4HQ   ,4H    , 4HHOPT,4H    /
      DATA IPR2 /
     1     4HGRDE,4HQ   , 4HSTRE,4HSS  , 4HSTRA,4HIN  , 4HNINT,4HPTS ,
     5     4HASET,4HOUT , 4HAUTO,4HSPC , 4HVOLU,4HME  , 4HSURF,4HACE ,
     9     4HKTOU,4HT   , 4HAPRE,4HSS  , 4HATEM,4HP   , 4HSTRE,4HAML ,
     3     4HPGEO,4HM   , 4HSIGN,4H    , 4HZORI,4HGN  , 4HFXCO,4HOR  ,
     7     4HFYCO,4HOR  , 4HFZCO,4HOR  , 4HKGGI,4HN   , 4HIREF,4H    ,
     1     4HMINM,4HACH , 4HMAXM,4HACH , 4HMTYP,4HE   , 4H****,4H****,
     5     44*4H****    /
C*****
C     THE ICC ARRAYS CONTAIN PAIRED ENTRIES OF CASE CONTROL FLAG NAMES
C     FOR USE IN RESTART RUNS
C*****
      DATA ICC1 /
     1     4HMPC$,4H    , 4HSPC$,4H    , 4HLOAD,4H$   , 4HMETH,4HOD$ ,
     5     4HDEFO,4HRM$ , 4HTEMP,4HLD$ , 4HTEMP,4HMT$ , 4HIC$ ,4H    ,
     9     4HAOUT,4H$   , 4HLOOP,4H$   , 4HLOOP,4H1$  , 4HDLOA,4HD$  ,
     3     4HFREQ,4H$   , 4HTF$ ,4H    , 4HPLOT,4H$   , 4HTSTE,4HP$  ,
     7     4HPOUT,4H$   , 4HTEMP,4HMX$ , 4HDSCO,4H$   , 4HK2PP,4H$   ,
     1     4HM2PP,4H$   , 4HB2PP,4H$   , 4HCMET,4HHOD$, 4HSDAM,4HP$  ,
     5     4HPLCO,4H$   , 4HNLFO,4HRCE$, 4HXYOU,4HT$  , 4HFMET,4HHOD$,
     9     4HRAND,4HOM$ , 4HAXYO,4HUT$ , 4HNOLO,4HOP$ , 4HGUST,4H$   ,
     3     4HQOUT,4H$   , 4HBOUT,4H$   ,
     7     32*4H****    /
      DATA ICC2 /
     1     24*4H****    /
C
C*****
C     INITIALIZATION OF VARIABLES IN COMMON /IFPX0/
C*****
C
C     THE VALUES ASSIGNED BELOW TO THE VARIABLES IN COMMON /IFPX0/
C     ARE AS PER THEIR DEFINITIONS GIVEN EARLIER IN THE COMMENTS
C     AND ARE DERIVED FROM THE COMMON /IFPX1/ INFORMATION
C*****
      DATA LBDPR, LCC, IWRDS, IPARPT /16, 2, 18*0, 401/
C
      END

      SUBROUTINE SSGHT
C
C     THIS IS THE STATIC-SOLUTION-GENERATOR FOR HEAT TRANSFER.
C
C     DMAP CALLING SEQUENCE.
C
C     SSGHT  USET,SIL,GPTT,GM,EST,MPT,DIT,PF,PS,KFF,KFS,KSF,KSS,RFN,RSN,
C            LFILE,UFILE/UGV,QG,RULV/V,N,NLK/V,N,NLR/C,Y,EPS0/C,Y,TABS/
C            C,Y,MAXITR/C,Y,IRES/V,N,MPCF1/V,N,SINGLE $
C
      LOGICAL         NOGO,NOQG,RULVEC,DIAGON,LINEAR,LOOP1,NLRAD
      INTEGER         BUF(10),SYSBUF,OUTPT,TSET,RD,RDREW,WRT,WRTREW,
     1                CLSREW,CLS,PRECIS,CORE,SINGLE,EOR,UMCB,BMCB,XMCB,
     2                PKIN,PKOUT,PKIROW,PKNROW,PKINCR,EOL,BUF1,BUF2,
     3                MCB(7),RULMCB(7),GSIZE,FILE,FSIZE,SSIZE,FLAG,WORD,
     4                MCB2(7),NAME(2),USET,GPTT,GM,EST,DIT,UFILE,PF,PS,
     5                RFN,RSN,UGV,QG,RULV,SUBR(2),DITX,Z,SCRT1,SCRT2,
     6                SCRT3,TREQST,TSTART,TEND,TLOOP,SCRT4,TELAPS,
     7                ALIBI(5,5)
      REAL            RBUF(10),RZ(1)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG / UFM,UWM,UIM,SFM
      COMMON /FBSX  / JLMCB(7),JUMCB(7),JBMCB(7),JXMCB(7),JZZZ,JPREC,
     1                JSIGN
      COMMON /GFBSX / LMCB(7),UMCB(7),BMCB(7),XMCB(7),LZ,IPREC,ISIGN
      COMMON /PACKX / PKIN,PKOUT,PKIROW,PKNROW,PKINCR
      COMMON /ZNTPKX/ AI(4),IROW,EOL
      COMMON /ZBLPKX/ AO(4),JROW
      COMMON /SYSTEM/ KSYSTM(65)
      COMMON /STIME / TREQST
      COMMON /HMATDD/ IHMAT,NHMAT,MPTX,DITX
      COMMON /NAMES / RD,RDREW,WRT,WRTREW,CLSREW,CLS
      COMMON /ZZZZZZ/ Z(1)
      COMMON /BLANK / NLK,NLR,EPS0,TABS,MAXITR,IRES,MPCF1,SINGLE
      EQUIVALENCE     (KSYSTM(1),SYSBUF),(KSYSTM(2),OUTPT),
     1                (KSYSTM(10),TSET),(KSYSTM(55),IPREC1),
     2                (BUF(1),RBUF(1)),(Z(1),RZ(1)),(IDFALT,DEFALT)
      DATA    DIAGON/ .FALSE. /
      DATA    SUBR  / 4HSSGH,4HT     /, EOR,NOEOR /1,0/
      DATA    USET  , GPTT,GM,EST,MPTFIL / 101,103,104,105,106/
C     DATA    SIL   / 102     /
      DATA    DIT   , PF,PS,KFF,KFS,KSF,KSS/107,108,109,110,111,112,113/
      DATA    RFN   , RSN,LFILE,UFILE  / 114,115,116,117/
      DATA    UGV   , QG,RULV / 201,202,203 /
      DATA    SCRT1 , SCRT2,SCRT3,SCRT4/ 301,302,303,304/
      DATA    ALIBI / 4H NOR,4HMAL ,4HCONV,4HERGE,4HNCE ,
     1                4H MAX,4HIMUM,4H ITE,4HRATI,4HONS ,
     2                4H DIV,4HERGI,4HNG S,4HOLUT,4HION ,
     3                4H INS,4HUFFI,4HCIEN,4HT TI,4HME  ,
     4                4H MAX,4HIMUM,4H CON,4HVERG,4HENCE/
C
C     OPEN CORE
C
C          PRE-ITERATIONS              DURING-ITERATIONS
C         +--------------+
C         I              I  Z(IUNI)
C         I    I         I
C         I  (U ) VECTOR I
C         I    N         I
C         I              I  Z(NUNI)
C         +--------------+
C         I              I  Z(IHMAT)
C         I  HMAT CORE   I
C         I  BLOCK IF    I
C         I  REQUIRED    I
C         I              I  Z(NHMAT)
C         +--------------+
C         I              I  Z(IUN)
C         I (U ) PARTIT. I
C         I   N  VECTOR  I
C         I      FOR F+S I
C         I              I  Z(NUN)
C         +--------------+  -  -  -  -  -  -  -  -  -  -  -  -  -
C         I              I  Z(IEQIV)        MSIZE
C         I              I           -  -  -  *  -  -  EQUIV TABLE
C         I   E          I                   *I*       WILL BE PLACED
C         I(UN )EQIV.TBL I                  * I *      ON SCRATCH FILE
C         I   G          I                    I        DURING ITERATIONS
C         I              I  Z(NEQIV)          I
C         +--------------+  -  -  -   +----------------+
C         I              I  Z(IUM)    I                I  Z(ISN)
C         I (U )PARTIT.  I            I (S ) DIAGONAL  I
C         I   M VECTOR   I            I   N            I
C         I              I  Z(NUM)    I                I
C         +--------------+            I                I  Z(NSN)
C         I              I  Z(IUME)   +----------------+
C         I   E          I            I                I  Z(IDELU)
C         I (U ) TABLE   I            I (DELTA U ) VEC.I
C         I   M          I  Z(NUME)   I         N      I
C         +--------------+            I                I  Z(NDELU)
C                                     +----------------+
C                                     I                I  Z(IDELP)
C                                     I (DELTA P ) VEC.I
C                                     I         N      I
C                                     I                I  Z(NDELP)
C                                     +----------------+
C                                            .
C                                      CORE  . UNUSED
C                           Z(CORE)          .            Z(CORE)
C         - - - - - - - - - - - - - - +----------------+
C                                     I  BUFFER 2      I  Z(BUF2)
C                                     I                I
C                                     +----------------+
C                                     I  BUFFER 1      I  Z(BUF1)
C                                     I                I
C                                     +----------------+
C
C     CORE SIZE AND BUFFERS
C
      LCORE = KORSZ(Z)
      BUF1  = LCORE - SYSBUF - 2
      BUF2  = BUF1  - SYSBUF - 2
      CORE  = BUF2  - 1
      IF (CORE .LT. 100) CALL MESAGE (-8,0,SUBR)
      PRECIS = 1
C
C     SET MISC. FLAGS.
C
      EPS010 = 10.0*EPS0
      EPSOLD = EPS0 + 1.0
      NLRAD  = .TRUE.
      IF (NLR .EQ. -1) NLRAD = .FALSE.
      CALL SSWTCH (18,K)
      IF (K .EQ. 1) DIAGON = .TRUE.
      LINEAR = .TRUE.
      IF (NLK .EQ. +1) LINEAR = .FALSE.
C
C     READ TRAILER OF USET TO GET GSIZE.
C
      MCB(1) = USET
      CALL RDTRL (MCB)
      FILE = USET
      IF (MCB(1) .LE. 0) GO TO 1290
      GSIZE = MCB(3)
C
C     READ GM TRAILER TO DETERMINE COUNT OF UM POINTS
C
      MCB(1) = GM
      CALL RDTRL (MCB)
      IF (MCB(1) .LE. 0) GO TO 30
      MSIZE = MCB(3)
      GO TO 40
   30 MSIZE = 0
   40 NSIZE = GSIZE - MSIZE
C
C     CORE ALLOCATION.
C
      IUNI  = 1
      NUNI  = NSIZE
      IUNIZ = IUNI - 1
      IHMAT = NUNI + 1
      NHMAT = NUNI
      IF (.NOT.LINEAR) NHMAT = CORE
      MPTX  = MPTFIL
      DITX  = DIT
      IF (.NOT.LINEAR) CALL PREHMA (Z)
      IUN   = NHMAT + 1
      NUN   = NHMAT + NSIZE
      IEQIV = NUN + 1
      NEQIV = NUN + GSIZE
C
C     EQUIVALENCE TABLE WILL BE PUT ON SCRATCH DURING ITERATIONS.
C
      ISN   = NUN + MSIZE + 1
      NSN   = ISN + NSIZE - 1
      IF (.NOT.NLRAD) NSN = ISN - 1
      ISNZ  = ISN - 1
      IDELU = NSN + 1
      NDELU = NSN + NSIZE
      IDELUZ= IDELU - 1
      IDELP = NDELU + 1
      NDELP = NDELU + NSIZE
      IF (NDELP .GT. CORE) CALL MESAGE (-8,0,SUBR)
      IDELPZ= IDELP - 1
      IUM   = NEQIV + 1
      NUM   = NEQIV + MSIZE
      IUMZ  = IUM - 1
      IUME  = NUM + 1
      NUME  = NUM + MSIZE
      IUMEZ = IUME - 1
      IF (NUME .GT. CORE) CALL MESAGE (-8,0,SUBR)
C
C     CONSTRUCTION OF (U ) AND (U ) TABLES.
C                       M        N
C
      FILE   = USET
      CALL GOPEN (USET,Z(BUF1),RDREW)
      MPOINT = IUMZ
      NPOINT = IUN - 1
      ISIL   = 0
      FSIZE  = 0
      CALL FREAD (USET,Z(IEQIV),GSIZE,0)
      CALL CLOSE (USET,CLSREW)
      DO 120 I = IEQIV,NEQIV
      WORD = Z(I)
      ISIL = ISIL + 1
C
C     CHECK FOR M-POINT
C
      IF (MOD(WORD,2) .LE. 0) GO TO 90
      MPOINT = MPOINT + 1
      Z(MPOINT) = ISIL
      GO TO 120
C
C     ASSUME N-POINT
C
   90 NPOINT = NPOINT + 1
C
C     CHECK FOR F OR S POINT
C
      IF (MOD(WORD/2,2)) 100,100,110
C
C     OK N-POINT IS AN F-POINT.
C
  100 Z(NPOINT) = -ISIL
      FSIZE = FSIZE + 1
      GO TO 120
C
C     OK N-POINT IS ASSUMED AN S-POINT
C
  110 Z(NPOINT) = +ISIL
  120 CONTINUE
      SSIZE = NSIZE - FSIZE
C
C     U  AND U  ARE COMPLETE.
C      M      N
C
      IF (ISIL.EQ.GSIZE .AND. NPOINT.EQ.NUN .AND. MPOINT.EQ.NUM)
     1    GO TO 140
      WRITE  (OUTPT,130) SFM
  130 FORMAT (A25,' 3081, INCONSISTENT USET DATA DETECTED.')
      CALL MESAGE (-61,0,SUBR)
C
C             E
C     BUILD (U ) EQUIVALENCE (U ) POINTS FOR (U ).
C             M                N               M
C
  140 IF (NUME .LT. IUME) GO TO 250
      DO 150 I = IUME,NUME
      Z(I) = 0
  150 CONTINUE
      CALL GOPEN (GM,Z(BUF1),RDREW)
      DO 210 I = 1,NSIZE
C
C     OPERATE ON A COLUMN OF GM.
C
      CALL INTPK (*210,GM,0,PRECIS,0)
  160 CALL ZNTPKI
C
C                             E
C     ROW POSITION -IROW- IN U  GETS COLUMN NUMBER.
C                             M
C
      IPOS = IUMEZ + IROW
      IF (Z(IPOS)) 170,170,190
  170 Z(IPOS) = I
  180 IF (EOL) 160,160,210
C
C     ERROR
C
  190 WRITE  (OUTPT,200) UWM,IROW,I
  200 FORMAT (A25,' 3082, M =',I10,'  N =',I10)
      GO TO 180
  210 CONTINUE
      CALL CLOSE (GM,CLSREW)
C
C     INSURE ALL UME SLOTS FILLED
C
      NOGO = .FALSE.
      DO 240 I = IUME,NUME
      IF (Z(I)) 220,220,240
  220 M = I - IUMEZ
      ISIL = IUMZ + M
      WRITE  (OUTPT,230) UFM,M,Z(ISIL)
  230 FORMAT (A23,' 3083, UM POSITION =',I10,', SIL =',I10)
      NOGO = .TRUE.
  240 CONTINUE
      IF (NOGO) CALL MESAGE (-61,0,SUBR)
C
C                        E
C     CONSTRUCTION OF (UN ) EQUIVALENCE TABLE.
C                        G
C
  250 MPOINT = IUM
      MPT  = Z(MPOINT)
      IF (MPOINT .GT. NUM ) MPT = 1000000
      MPTE = IUME
      MVAL = Z(MPTE)
      NVAL = 1
      K = IEQIV - 1
      DO 270 I = 1,GSIZE
      K = K + 1
      IF (I .NE. MPT) GO TO 260
C
C     M-POINT NEXT
C
      Z(K) = MVAL
      MPTE = MPTE + 1
      MVAL = Z(MPTE)
      MPOINT = MPOINT + 1
      MPT  = Z(MPOINT)
      IF (MPOINT .GT. NUM ) MPT = 1000000
      GO TO 270
C
C     N-POINT NEXT
C
  260 Z(K) = NVAL
      NVAL = NVAL + 1
  270 CONTINUE
C
C     SET UP RULV IF RESIDUAL LOAD MATRIX IS TO BE FORMED.
C
      RULVEC = .FALSE.
      IF (IRES .LE. 0) GO TO 290
      CALL MAKMCB (RULMCB,RULV,FSIZE,2,PRECIS)
      CALL GOPEN (RULV,Z(BUF1),WRTREW)
      CALL CLOSE (RULV,CLS)
      RULVEC = .TRUE.
C
C     GRID POINT TEMPERATURE DATA IS EXPANDED INTO CORE NOW.  ONLY
C
C      1
C     U  IS FORMED.
C      N
C
C
  290 IF (TSET) 300,300,310
  300 K = 0
      GO TO 320
  310 K = 1
  320 DO 330 I = IUNI,NUNI
      Z(I) = K
  330 CONTINUE
      IF (TSET) 510,510,340
C
C     POSITION GPTT TO GRID TEMPERATURE DATA SECTION.
C
  340 FILE = GPTT
      CALL OPEN (*1290,GPTT,Z(BUF1),RDREW)
      CALL FREAD (GPTT,BUF,-2,0)
      NUMBER = 0
  350 CALL READ (*1300,*360,GPTT,BUF,3,NOEOR,FLAG)
      NUMBER = MAX0(NUMBER,BUF(3))
      GO TO 350
  360 CALL SKPREC (GPTT,NUMBER)
C
C     NOW AT GRID TEMP SECTION HEADER.
C
      CALL FREAD (GPTT,BUF,-2,0)
  400 CALL READ (*1300,*1330,GPTT,BUF,3,NOEOR,FLAG)
      IF (TSET .NE. BUF(1)) GO TO 400
C
C     BUF(1)=SET-ID,  BUF(2)=-1 OR DEFAULT TEMP,  BUF(3)=GPTT RECORD.
C
      DEFALT = RBUF(2)
      IF (BUF(3) .LE. 0) GO TO 470
      CALL SKPREC (GPTT,BUF(3))
C
C     TEMP PAIRS IN INTERNAL-ID AND TEMPERATURE.
C
      IUNAT = IUN
      ISIL  = IABS(Z(IUNAT))
      IUNIAT= IUNI
C
C     READ A TEMPERATURE PAIR.
C
  430 CALL READ (*1300,*470,GPTT,BUF,2,NOEOR,FLAG)
  440 IF (BUF(1)-ISIL) 430,450,460
  450 Z(IUNIAT) = BUF(2)
  460 IUNAT = IUNAT + 1
      ISIL  = IABS(Z(IUNAT))
      IUNIAT= IUNIAT + 1
      IF (IUNIAT .LE. NUNI) GO TO 440
  470 CALL CLOSE (GPTT,CLSREW)
C
C     CHECK FOR INTEGER 1-S WHICH GET THE DEFAULT TEMP.
C
      NOGO = .FALSE.
      DO 500 I = IUNI,NUNI
      IF (Z(I) .NE. 1) GO TO 500
      IF (IDFALT .NE. -1) GO TO 490
      NOGO = .TRUE.
      K = IUN + I - IUNI
      ISIL = IABS(Z(K))
      WRITE  (OUTPT,480) UFM,ISIL
  480 FORMAT (A23,' 3084, THERE IS NO TEMPERATURE DATA FOR SIL NUMBER',
     1        I10)
      GO TO 500
  490 RZ(I) = DEFALT
  500 CONTINUE
      IF (NOGO) CALL MESAGE (-61,0,SUBR)
  510 CONTINUE
C
C               1                  1
C     COMPUTE (P ) = (P ) - (K  )(U ) AND SAVE ON SCRATCH-4.
C               F      F      FS   S
C
      K = IDELPZ + FSIZE
      DO 520 I = IDELP,K
      Z(I) = 0
  520 CONTINUE
      CALL OPEN (*540,PF,Z(BUF1),RDREW)
      CALL FWDREC (*540,PF)
      CALL INTPK (*540,PF,0,PRECIS,0)
  530 CALL ZNTPKI
      K = IDELPZ + IROW
      RZ(K) = AI(1)
      IF (EOL) 530,530,540
  540 CALL CLOSE (PF,CLSREW)
C
C                         1
C     SUBTRACT OFF (K  )(U )
C                    FS   S
C
      IAT = IUN - 1
      CALL OPEN (*590,KFS,Z(BUF1),RDREW)
      CALL FWDREC (*590,KFS)
      DO 580 I = 1,SSIZE
C
C     FIND NEXT US POINT TEMPERATURE DATA.
C
  550 IAT = IAT + 1
      IF (Z(IAT)) 550,550,560
  560 K = IUNIZ + IAT - IUN + 1
      CALL INTPK (*580,KFS,0,PRECIS,0)
      VALUE = RZ(K)
  570 CALL ZNTPKI
      K = IDELPZ + IROW
      RZ(K) = RZ(K) - AI(1)*VALUE
      IF (EOL) 570,570,580
  580 CONTINUE
  590 CALL CLOSE (KFS,CLSREW)
C
C                1
C     PACK OUT (P ) ON SCRATCH-4
C                F
C
      CALL GOPEN (SCRT4,Z(BUF1),WRTREW)
      CALL MAKMCB (MCB,SCRT4,FSIZE,2,PRECIS)
      PKIN   = PRECIS
      PKOUT  = PRECIS
      PKIROW = 1
      PKNROW = FSIZE
      PKINCR = 1
      CALL PACK (Z(IDELP),SCRT4,MCB)
      CALL CLOSE (SCRT4,CLSREW)
      CALL WRTTRL (MCB)
C
C     ELEMENT INITIAL PROCESSING PHASE.
C
      CALL GOPEN  (SCRT1,Z(BUF2),WRTREW)
      IF (LINEAR) GO TO 600
      CALL GOPEN  (EST,Z(BUF1),RDREW)
      CALL SSGHT1 (EST,SCRT1,Z(IEQIV))
      CALL CLOSE  (EST,CLSREW)
C
C        E
C     (UN ) EQUIVALENCE TABLE IS NOW APPENDED TO -SCRT1-.
C        G
C
  600 CALL WRITE (SCRT1,0,0,1)
      CALL WRITE (SCRT1,Z(IEQIV),GSIZE,1)
      CALL CLOSE (SCRT1,CLSREW)
C
C                      1            3
C     FORM (S ) = 4( (U ) + (TABS) )  DIAGONAL MATRIX.
C            N         N
C
      IF (.NOT.NLRAD) GO TO 630
      J = IUNIZ
      DO 620 I = ISN,NSN
      J = J + 1
      RZ(I) = 4.0*(RZ(J) + TABS)**3
  620 CONTINUE
C
C     SET PARTITIONING TABLE IN TERMS OF WHERE ELEMENTS ARE TO MOVE TO
C     WHEN GOING FROM N-SET TO F+S SETS.
C
  630 IS = FSIZE
      IF = 0
      DO 660 I = IUN,NUN
      IF (Z(I)) 640,640,650
C
C     F-POINTER
C
  640 IF   = IF + 1
      Z(I) = IF
      GO TO 660
C
C     S-POINTER
C
  650 IS = IS + 1
      Z(I)  = IS
  660 CONTINUE
      LOOP  = 0
      LOOP1 = .TRUE.
      PFMAG = 0.0
C
C     == ITERATION SECTION ==
C
C     ITERATIVE LOOPING
C
  670 LOOP = LOOP + 1
C
C     TIME LEFT AT START OF LOOP
C
      CALL TMTOGO (TSTART)
      DO 680 I = IDELP,NDELP
      Z(I) = 0
  680 CONTINUE
      IF (LOOP1 .OR. LINEAR) GO TO 690
      CALL GOPEN (SCRT1,Z(BUF1),RDREW)
      CALL SSGHT2 (SCRT1,Z(IDELP),Z(IUNI))
      CALL CLOSE (SCRT1,CLSREW)
C
C     PARTITION DELTA-P VECTOR INTO DELTA-F AND DELTA-S VECTORS.
C
      CALL SSGHTP (Z(IUN),Z(IDELP),NSIZE)
C
C                     I
C     GENERATION OF (N ) WILL BE PERFORMED IN CORE SPACE OF (DELTA-P)
C                     F
C       I                          I        4         I
C     (N ) = (DELTA-P ) + (R  )( (U  + TABS)  - (S )(U ) )
C       F            F      FN     N               N  N
C
  690 IF (.NOT.NLRAD) GO TO 730
      CALL OPEN (*720,RFN,Z(BUF2),RDREW)
      CALL FWDREC (*720,RFN)
      DO 710 I = 1,NSIZE
C
C     OPERATE ON A COLUMN OF RFN
C
      CALL INTPK (*710,RFN,0,PRECIS,0)
C
C     COMPUTE CONSTANT FOR COLUMN
C
      K  = IUNIZ + I
      UN = RZ(K)
      K  = ISNZ + I
      SN = RZ(K)
      VALUE = (UN + TABS)**4 - SN*UN
C
C     UNPACK NON-ZERO TERMS OF COLUMN.
C
  700 CALL ZNTPKI
      K = IDELPZ + IROW
      RZ(K) = RZ(K) + AI(1)*VALUE
      IF (EOL) 700,700,710
  710 CONTINUE
  720 CALL CLOSE (RFN,CLSREW)
C
C          I      1      I
C     (PBAR ) = (P ) - (N )
C          F      F      F
C                    I
C     FIRST NEGATE (N ) SITTING IN DELTA-P CORE SPACE,
C                    F
C                                     1
C     THEN ADD IN NON-ZERO TERMS OF (P )
C                                     F
C
  730 K = IDELPZ + FSIZE
      DO 740 I = IDELP,K
      RZ(I) = -RZ(I)
  740 CONTINUE
C
C            1
C     OPEN (P ) FOR UNPACKING OF ONE COLUMN.
C            F
C
      CALL OPEN (*760,SCRT4,Z(BUF2),RDREW)
      CALL FWDREC (*760,SCRT4)
      CALL INTPK (*760,SCRT4,0,PRECIS,0)
  750 CALL ZNTPKI
      K = IDELPZ + IROW
      RZ(K) = RZ(K) + AI(1)
      IF (LOOP1) PFMAG = PFMAG + AI(1)*AI(1)
      IF (EOL) 750,750,760
  760 CALL CLOSE (SCRT4,CLSREW)
C
C          I
C     (PBAR ) IS NOW PACKED OUT TO SCRATCH-2.
C          F
C
      IF (.NOT.LOOP1) GO TO 790
      PFMAG = SQRT(PFMAG)
      IF (PFMAG) 770,770,790
  770 WRITE  (OUTPT,780) UFM
  780 FORMAT (A23,' 3085, THE PF LOAD VECTOR IS EITHER PURGED OR NULL.')
      CALL MESAGE (-61,0,SUBR)
  790 CALL MAKMCB (MCB2,SCRT2,FSIZE,2,2)
      CALL GOPEN (SCRT2,Z(BUF2),WRTREW)
      PKIN   = PRECIS
      PKOUT  = IPREC1
      PKIROW = 1
      PKNROW = FSIZE
      PKINCR = 1
      CALL PACK (Z(IDELP),SCRT2,MCB2)
      CALL CLOSE (SCRT2,CLSREW)
      CALL WRTTRL (MCB2)
C
C                       I           I
C     (DELTA-P ) = (PBAR ) - (K  )(U )
C             F         F      FF   F
C          I
C     (PBAR ) IS SITING IN CORE CURRENTLY.  (IT WILL BE GONE TOMORROW.)
C          F
C                       I       I        I
C     FIRST PARTITION (U ) TO (U ) AND (U )
C                       N       F        S
C
      CALL SSGHTP (Z(IUN),Z(IUNI),NSIZE)
      CALL OPEN (*820,KFF,Z(BUF1),RDREW)
      CALL FWDREC (*820,KFF)
      DO 810 I = 1,FSIZE
C
C     OPERATE ON ONE COLUMN OF KFF
C
      CALL INTPK (*810,KFF,0,PRECIS,0)
C
C                                 I
C     LOCATE COLUMN MULTIPLIER = U
C                                 FI
C
      K = IUNIZ + I
      VALUE = RZ(K)
  800 CALL ZNTPKI
C                                                            I
C     SUBTRACT THIS ELEMENT*VALUE FROM IROW POSITION OF (PBAR )
C                                                            F
      K = IDELPZ + IROW
      RZ(K) = RZ(K) - AI(1)*VALUE
      IF (EOL) 800,800,810
  810 CONTINUE
  820 CALL CLOSE (KFF,CLSREW)
C
C     COMPUTE EPSILON
C                    P
C
      K   = IDELPZ + FSIZE
      SUM = 0.0
      DO 830 I = IDELP,K
      SUM = SUM + RZ(I)**2
  830 CONTINUE
      SUM = SQRT(SUM)
      EPSUBP = SUM/PFMAG
      IF (LOOP1 .AND. DIAGON) WRITE (OUTPT,840) EPSUBP
  840 FORMAT ('1D I A G   1 8   O U T P U T   F R O M   S S G H T', //,
     1       ' ITERATION    EPSILON-P',9X,'LAMBDA-1',10X,'EPSILON-T',
     2       /1X,60(1H=), /,6H     1,1P,E19.6)
C
C                                                   I
C     IF -RULV- IS BEING FORMED, THEN WRITE (DELTA-P ) OUT ON -RULV-.
C                                                   F
C
      IF (.NOT. RULVEC) GO TO 850
      CALL OPEN (*850,RULV,Z(BUF1),WRT)
      PKIN   = PRECIS
      PKOUT  = PRECIS
      PKIROW = 1
      PKNROW = FSIZE
      PKINCR = 1
      CALL PACK (Z(IDELP),RULV,RULMCB)
      CALL CLOSE (RULV,CLS)
C
C                     I+1
C     NOW SOLVE FOR (U   ) IN,
C                     F
C                           I+1         I
C                   (L)(U)(U   ) = (PBAR )
C                           F           F
C
C
  850 ISIGN   =+1
      IPREC   = 2
      LMCB(1) = LFILE
      CALL RDTRL (LMCB)
      UMCB(1) = UFILE
      CALL RDTRL (UMCB)
      BMCB(1) = SCRT2
      CALL RDTRL (BMCB)
      CALL MAKMCB (XMCB,SCRT3,FSIZE,2,2)
C
C     INSURE EVEN BOUNDARY (ARRAY WILL BE USED AS DOUBLE PRECISION)
C
      JDELP = NDELP + 1 + MOD(NDELP+1,2) + 1
      LZ = LCORE - JDELP
CWKBI 3/94
      JZZZ = LZ
      DO 855 IJK = 1,31
      JLMCB(IJK) = LMCB(IJK)
  855 CONTINUE
      IF (UMCB(1) .GT. 0) CALL GFBS (Z(JDELP),Z(JDELP))
      IF (UMCB(1) .LE. 0) CALL  FBS (Z(JDELP),Z(JDELP))
      IF (UMCB(1) .GT. 0) CALL WRTTRL( XMCB)
      IF (UMCB(1) .LE. 0) CALL WRTTRL(JXMCB)
C
C       I+1
C     (U   ) IS NOW MOVED FROM SCRATCH-3 INTO CORE IN (DELTA-P ) SPACE.
C       F                                                     N
C
      CALL GOPEN (SCRT3,Z(BUF1),RDREW)
      K = IDELPZ + FSIZE
      DO 860 I = IDELP,K
      Z(I) = 0
  860 CONTINUE
      CALL INTPK (*880,SCRT3,0,PRECIS,0)
  870 CALL ZNTPKI
      K = IDELPZ + IROW
      RZ(K) = AI(1)
      IF (EOL) 870,870,880
  880 CALL CLOSE (SCRT3,CLSREW)
      IF (LOOP1) GO TO 985
C
C                      I+1       I
C     ALPHA = SUM OF (U   ) (PBAR )          IROW = 1,FSIZE
C                      F         F
C                       IROW      IROW
C
C                           I+1      I
C     BETA = SUM OF (DELTA-U   )(PBAR )      IROW = 1,FSIZE
C                           F        F
C                            IROW     IROW
C
C                      I+1    I       I
C     GAMMA = SUM OF (U    - U  )(PBAR )     IROW = 1,FSIZE
C                      F      F       F
C                       IROW   IROW    IROW
C
C     WHERE I = ITERATION GREATER THAN 1.
C
      CALL GOPEN (SCRT2,Z(BUF1),RDREW)
      ALPHA = 0.0
      BETA  = 0.0
      GAMMA = 0.0
      CALL INTPK (*900,SCRT2,0,PRECIS,0)
C
C     ONLY NON-ZERO TERMS OF (PBAR ) NEED BE CONSIDERED.
C                                 F
  890 CALL ZNTPKI
      KUFIP1 = IDELPZ + IROW
      KDELU  = IDELUZ + IROW
      KUFI   = IUNIZ  + IROW
      ALPHA  = ALPHA  + RZ(KUFIP1)*AI(1)
      BETA   = BETA   + RZ(KDELU) *AI(1)
      GAMMA  = GAMMA  + (RZ(KUFIP1) - RZ(KUFI))*AI(1)
      IF (EOL) 890,890,900
  900 CALL CLOSE (SCRT2,CLSREW)
C
C     CONVERGENCE TESTS ARE MADE HERE.
C
C     WHEN ENTERING EXIT MODE,
C         -IEXIT-        -REASON-
C            1           NORMAL CONVERGENCE
C            2           NO CONVERGENCE AT MAXIMUM ITERATIONS
C            3           NO CONVERGENCE UNSTABLE ITERATION
C            4           NO CONVERGENCE INSUFFICIENT TIME
C            5           MAXIMUM CONVERGENCE, BUT EPSHT NOT SATISFIED
C
      IF (GAMMA) 910,920,910
  910 FLAMDA = ABS(BETA/GAMMA)
      GO TO 930
  920 FLAMDA = 100.0
      EPST   = 0.0
      GO TO 970
  930 IF (ALPHA) 940,960,940
  940 IF (FLAMDA-1.0) 950,960,950
  950 EPST = ABS(GAMMA/((FLAMDA - 1.0)*ALPHA))
      GO TO 970
  960 EPST = 100.0
  970 CALL TMTOGO (KLEFT)
      TELAPS = TREQST - KLEFT
      TAU    = 1.0 - FLOAT(TLOOP+TELAPS)/(.8*FLOAT(TREQST))
      IF (DIAGON) WRITE (OUTPT,980) LOOP,EPSUBP,FLAMDA,EPST
  980 FORMAT (I6,1P,E19.6,1P,E18.6,1P,E18.6)
      IEXIT  = 1
      IF (EPST.LT.EPS0 .AND. FLAMDA.GT.1.0 .AND. EPSUBP.LT.EPS010)
     1    GO TO 1060
C
C     TEST FOR TWO SUCCESSIVE CASES PASSING TEST
C
      IF (EPST.LT.EPS0 .AND. EPSOLD.LT.EPS0) GO TO 1060
      EPSOLD = EPST
      IEXIT  = 2
      IF (LOOP .GE. MAXITR) GO TO 1060
      IEXIT  = 3
      IF (FLAMDA.LE.1.0 .AND. LOOP.GE.4) GO TO 1060
      IEXIT  = 5
      IF (GAMMA .EQ. 0.) GO TO 1060
      IEXIT  = 4
      IF (TAU) 1060,990,990
C
C                   I
C     COMPUTE (DELTA ) TO BE USED ON NEXT LOOP
C                   U
C
  985 IEXIT = 2
      IF (LOOP .GE. MAXITR) GO TO 1051
  990 K  = IDELPZ + FSIZE
      KDELU = IDELUZ
      KI = IUNIZ
      KIP1 = IDELPZ
      DO 1000 I = IDELP,K
      KDELU = KDELU + 1
      KI = KI + 1
      KIP1 = KIP1 + 1
      RZ(KDELU) = RZ(KIP1) - RZ(KI)
 1000 CONTINUE
C
C                       I+1
C     MOVE (U ) UNDER (U   ) BOTH TO BE IN (DELTA-P ) CORE.
C            S          F                          N
C
      ASSIGN 1050 TO IRETRN
 1010 K1 = IUNI + FSIZE
      K2 = IDELPZ + FSIZE
      IF (SSIZE .LE. 0) GO TO 1030
      DO 1020 I = K1,NUNI
      K2 = K2 + 1
      RZ(K2) = RZ(I)
 1020 CONTINUE
C
C             I+1                       I+1
C     MERGE (U   ) AND (U ) BACK INTO (U   ) FORM.
C             F          S              N
C
 1030 KUNI = IUNIZ
      DO 1040 I = IUN,NUN
      KUNI = KUNI + 1
      JPOS = IDELPZ + Z(I)
      Z(KUNI) = Z(JPOS)
 1040 CONTINUE
      GO TO IRETRN, (1050,1180)
C
C     READY NOW FOR ANOTHER LOOP.
C
 1050 CALL TMTOGO (TEND)
      TLOOP = TSTART - TEND
      LOOP1 = .FALSE.
      GO TO 670
C
C     == END ITERATION SECTION ==
C
C     ITERATION HALTED, NOW IN EXIT MODE.
C     IF QG FILE IS PRESENT, FORCES OF CONSTRAINT ARE PARTIALLY COMPUTED
C     QS WILL BE FORMED IN THE CORE SPACE USED UP TO NOW FOR (DELTA-U).
C
C                           I
C     (Q ) = -(P ) + (K  )(U ) + (K  )(U ) + (DELTA-P ) + (PRODUCT )
C       S       S      SF   F      SS   S            S            S
C
C                                 I         4        I
C     WHERE (PRODUCT ) = (R  )( (U   + TABS)  - (S  U ) )
C                   S      SN     NJ              NJ N
C
C                                      J = 1,NSIZE
C
C     LOAD (DELTA-P ) INTO QS FORMATION CORE SPACE.
C                  S
C
 1051 WRITE  (OUTPT,1052) UWM
 1052 FORMAT (A25,' 3132, SSGHT RECOVERING FROM SEVERE USER CONVERGENCE'
     1,       ' CRITERIA.')
 1060 WRITE  (OUTPT,1070) UIM,IEXIT,(ALIBI(J,IEXIT),J=1,5)
 1070 FORMAT (A29,' 3086, ENTERING SSGHT EXIT MODE BY REASON NUMBER ',
     1        I2,2H (,5A4,1H) )
      NOQG = .TRUE.
      CALL OPEN (*1170,QG,Z(BUF2),WRTREW)
      NOQG = .FALSE.
      CALL FNAME (QG,NAME)
      CALL WRITE (QG,NAME,2,EOR)
      IQS  = IDELU
      NQS  = IDELUZ + SSIZE
      IQSZ = IDELUZ
      K    = IDELPZ + FSIZE
      DO 1080 I = IQS,NQS
      K    = K + 1
      Z(I) = Z(K)
 1080 CONTINUE
C
C     SUBTRACT OFF NON-ZERO TERMS OF PS VECTOR.
C
      CALL OPEN (*1100,PS,Z(BUF1),RDREW)
      CALL FWDREC (*1100,PS)
      CALL INTPK (*1100,PS,0,PRECIS,0)
 1090 CALL ZNTPKI
      K = IQSZ + IROW
      RZ(K) = RZ(K) - AI(1)
      IF (EOL) 1090,1090,1100
 1100 CALL CLOSE (PS,CLSREW)
C
C                   I
C     ADD IN (K  )(U )
C              SF   F
C
      CALL OPEN (*1130,KSF,Z(BUF1),RDREW)
      CALL FWDREC (*1130,KSF)
      DO 1120 I = 1,FSIZE
      CALL INTPK (*1120,KSF,0,PRECIS,0)
      K = IDELPZ + I
      VALUE = RZ(K)
 1110 CALL ZNTPKI
      K = IQSZ + IROW
      RZ(K) = RZ(K) + AI(1)*VALUE
      IF (EOL) 1110,1110,1120
 1120 CONTINUE
 1130 CALL CLOSE (KSF,CLSREW)
C
C     ADD IN (K  )(U )
C              SS   S
C
      IF (SSIZE .EQ. 0) GO TO 1160
      CALL OPEN (*1160,KSS,Z(BUF1),RDREW)
      CALL FWDREC (*1160,KSS)
      IUSZ = IUNIZ + FSIZE
      DO 1150 I = 1,SSIZE
      CALL INTPK (*1150,KSS,0,PRECIS,0)
      K = IUSZ + I
      VALUE = RZ(K)
 1140 CALL ZNTPKI
      K = IQSZ + IROW
      RZ(K) = RZ(K) + AI(1)*VALUE
      IF (EOL) 1140,1140,1150
 1150 CONTINUE
 1160 CALL CLOSE (KSS,CLSREW)
C
C                                     I
C     TO COMPUTE ADDITIONAL PRODUCT (U ) IS NOW FORMED.
C                                     N
C                           I
C     THUS MERGE (U ) AND (U )
C                  S        F
C                                  I
C     FIRST MOVE (U ) DOWN UNDER (U ), THEN DO MERGE.
C                  S               F
C
 1170 ASSIGN 1180 TO IRETRN
      GO TO 1010
C
C     OK FORM AND ADD (PRODUCT) IN.
C
 1180 IF (.NOT.NLRAD) GO TO 1220
      IF (NOQG) GO TO 1250
      CALL OPEN (*1210,RSN,Z(BUF1),RDREW)
      CALL FWDREC (*1210,RSN)
      DO 1200 I = 1,NSIZE
      CALL INTPK (*1200,RSN,0,PRECIS,0)
      KU = IUNIZ + I
      KS = ISNZ + I
      VALUE = (RZ(KU) + TABS)**4 - RZ(KU)*RZ(KS)
 1190 CALL ZNTPKI
      K = IQSZ + IROW
      RZ(K) = RZ(K) + AI(1)*VALUE
      IF (EOL) 1190,1190,1200
 1200 CONTINUE
 1210 CALL CLOSE (RSN,CLSREW)
C
C     (QS) IS COMPLETE AND READY FOR EXPANSION TO GSIZE AND OUTPUT.
C
 1220 CALL MAKMCB (MCB,QG,GSIZE,2,PRECIS)
      JROW = 0
      FILE = USET
      IF (SSIZE .EQ. 0) GO TO 1250
      CALL GOPEN (USET,Z(BUF1),RDREW)
      IQ = IQS
      CALL BLDPK (PRECIS,PRECIS,QG,0,0)
 1230 CALL FREAD (USET,WORD,1,0)
      JROW = JROW + 1
      IF (MOD(WORD/2,2)) 1230,1230,1240
 1240 AO(1) = RZ(IQ)
      CALL ZBLPKI
      IQ = IQ + 1
      IF (IQ .LE. NQS) GO TO 1230
C
C     QS HAS NOW BEEN EXPANDED TO GSIZE AND OUTPUT ON QG DATA BLOCK.
C
      CALL BLDPKN (QG,0,MCB)
      CALL CLOSE  (QG,CLSREW)
      CALL WRTTRL (MCB)
      CALL CLOSE  (USET,CLSREW)
C
C     PACK OUT (U ) USING THE EQUIVALENCE TABLE TO ORDER
C                G
C
C     THE U  POINTS.
C          N
C
C
C     READ EQUIVALENCE TABLE BACK INTO CORE AT THIS TIME.
C
 1250 FILE = SCRT1
      CALL GOPEN  (SCRT1,Z(BUF1),RDREW)
      CALL SKPREC (SCRT1,1)
      CALL FREAD  (SCRT1,Z(IEQIV),GSIZE,0)
C
      CALL CLOSE  (SCRT1,CLSREW)
C
C     REPLACE POINTERS WITH THE VALUES.
C
      DO 1270 I = IEQIV,NEQIV
      K = IUNIZ + Z(I)
      RZ(I) = RZ(K)
 1270 CONTINUE
C
C     PACK OUT (U )
C                G
C
      CALL MAKMCB (MCB,UGV,GSIZE,2,PRECIS)
      CALL GOPEN  (UGV,Z(BUF1),1)
      PKIN   = PRECIS
      PKOUT  = PRECIS
      PKIROW = 1
      PKNROW = GSIZE
      PKINCR = 1
      CALL PACK (Z(IEQIV),UGV,MCB)
      CALL CLOSE (UGV,CLSREW)
      CALL WRTTRL (MCB)
C
C     COMPLETE RULV IF NECESSARY.
C
      IF (.NOT.RULVEC) GO TO 1280
      CALL GOPEN (RULV,Z(BUF1),3)
      CALL CLOSE (RULV,CLSREW)
      CALL WRTTRL (RULMCB)
 1280 RETURN
C
C     ERROR CONDITIONS
C
 1290 N = -1
      GO TO 1320
 1300 N = -2
      GO TO 1320
 1320 CALL MESAGE (N,FILE,SUBR)
 1330 WRITE  (OUTPT,1340) UFM,TSET
 1340 FORMAT (A23,' 3087, TEMPERATURE SET',I10,' IS NOT PRESENT IN ',
     1        'GPTT DATA BLOCK.')
      CALL MESAGE (-61,0,SUBR)
      RETURN
      END

      SUBROUTINE TREE (IROOT,NDSTK,LVL,IWK,NDEG,LVLWTH,LVLBOT,LVLN,
     1                 MAXLW,IBORT,JWK)
C
C     TREE DROPS A TREE IN NDSTK FROM IROOT
C     THIS ROUTINE IS USED ONLY IN BANDIT MODULE
C
C     LVL-      ARRAY INDICATING AVAILABLE NODES IN NDSTK WITH ZERO
C               ENTRIES. TREE ENTERS LEVEL NUMBERS ASSIGNED
C               DURING EXECUTION OF OF THIS PROCEDURE
C     IWK-      ON OUTPUT CONTAINS NODE NUMBERS USED IN TREE
C               ARRANGED BY LEVELS (IWK(LVLN) CONTAINS IROOT
C               AND IWK(LVLBOT+LVLWTH-1) CONTAINS LAST NODE ENTERED)
C     JWK-      ON ONTPUT CONTAINS A ROW OF UNPACKED GRID NOS.
C               CURRENTLY, JWK AND RENUM SHARE SAME CORE SPACE
C     LVLWTH-   ON OUTPUT CONTAINS WIDTH OF LAST LEVEL
C     LVLBOT-   ON OUTPUT CONTAINS INDEX INTO IWK OF FIRST
C               NODE IN LAST LEVEL
C     MAXLW-    ON OUTPUT CONTAINS THE MAXIMUM LEVEL WIDTH
C     LVLN-     ON INPUT THE FIRST AVAILABLE LOCATION IN IWK
C               USUALLY ONE BUT IF IWK IS USED TO STORE PREVIOUS
C               CONNECTED COMPONENTS, LVLN IS NEXT AVAILABLE LOCATION.
C               ON OUTPUT THE TOTAL NUMBER OF LEVELS + 1
C     IBORT-    INPUT PARAM WHICH TRIGGERS EARLY RETURN IF
C               MAXLW BECOMES .GE. IBORT
C
C     INTEGER          BUNPK
      DIMENSION        LVL(1),   IWK(1),   NDEG(1),  NDSTK(1),  JWK(1)
C
      MAXLW =0
      ITOP  =LVLN
      INOW  =LVLN
      LVLBOT=LVLN
      LVLTOP=LVLN+1
      LVLN  =1
      LVL(IROOT)=1
      IWK(ITOP) =IROOT
   30 LVLN  =LVLN+1
   35 IWKNOW=IWK(INOW)
      NDROW =NDEG(IWKNOW)
      CALL BUNPAK(NDSTK,IWKNOW,NDROW,JWK)
      DO 40 J=1,NDROW
      ITEST=JWK(J)
      IF (LVL(ITEST).NE.0) GO TO 40
      LVL(ITEST)=LVLN
      ITOP=ITOP+1
      IWK(ITOP)=ITEST
   40 CONTINUE
      INOW=INOW+1
      IF (INOW.LT.LVLTOP) GO TO 35
      LVLWTH=LVLTOP-LVLBOT
      IF (MAXLW.LT.LVLWTH) MAXLW=LVLWTH
      IF (MAXLW.GE.IBORT .OR. ITOP.LT.LVLTOP) RETURN
      LVLBOT=INOW
      LVLTOP=ITOP+1
      GO TO 30
      END

      SUBROUTINE DUMOD5
C
C     MSFC ROUTINE, TO CONVERT NASTRAN TABULAR DATA BLOCKS INTO 2-
C     DIMENSIONAL DATA BLOCKS (S.P. REAL ONLY) FOR CONVENIENCE IN
C     MANIPULATION AND OUTPUT, SPECIALLY TO BE USED WITH OUTPUT5 AND
C     INPUT5.
C
C     THIS VERSION WAS MODIFIED BY R. MOORE/MSFC IN JAN. 1989
C     TO ALLOW SELECTION OF EITHER 8 OR 16 VALUES PER ELEMENT BY
C     USING A 7TH PARAMETER ON DMAP
C
C     DUMMOD5  T1,T2,T3,T4,T5/O1,O2,O3,O4,O5/C,N,P1/C,N,P2/C,N,P3
C              C,N,P4/C,N,P5/C,N,Q/C,N,R $
C
C     TI  = INPUT GINO FILE, OEF1, OQG1 OR SIMILAR TYPE OF TABULAR
C           DATA BLOCKS
C     OI  = OUTPUT GINO DATA BLOCK, PACKED, BUT NOT QUITE A REGULAR
C           NASTRAN MATRIX BLOCK, SEE PICTURE BELOW
C           IF OI IS PURGED (NOT PRESENT), MATRIX BLOCK IS WRITTEN OUT
C           TO FORTRAN UNIT 15 (INP1) DIRECTLY, IN BINARY RECORDS,
C           BANDED MATRIX FORM (FROM FIRST NON-ZERO TO LAST NON-ZERO
C           ELEMENTS), D.R. OR S.P.
C     PI  = TI TABLE IS MAPPED INTO A PI X 8 2-DIMENSIONAL BLOCKS.
C           EACH BLOCK IS PACKED AS A COLUMN OF A MATRIX
C     Q   = ELEMENT/GRID POINT ID PRINT-PUNCH CONTROL
C         = -1, NO PRINT AND NO PUNCH
C         =  0, PRINT ONLY, NO PUNCH
C         = +1, BOTH PRINT AND PUNCH
C         = /2/ CONTENTS OF OUTPUT TAPE, INP1, WILL BE PRINTED OUT
C     R   = SWITCH TO CHANGE FROM 8 TO 16 VALUES IN TABLE MAPPING
C           DEFAULT = 0 WHICH SETS TO 8.    R = 1 SETS IT TO 16
C
C     CDC USER ONLY - FORTRAN UNIT 11 (UT1) IS USED INSTEAD OF 15 (INP1)
C
C
C           |<------ 8 OR 16 ------->|
C           ==========================
C         / I                        I \
C        /  I------- TABULAR --------I  \
C       P1  I         DATA           I  BLOCK 1 (MATRIX COLUMN 1)
C        \  I-------- BLOCKS --------I  /
C         \ I                        I /
C           ==========================
C         / I                        I \
C        /  I------------------------I  \
C       P1  I                        I  BLOCK 2 (MATRIX COLUMN 2)
C
C     WRITTEN BY SOMEBODY FOR MARSHALL SPACE FLIGHT CENTER (MSFC).
C     MODIFIED BY G.CHAN/UNISYS TO EMPLOY OPEN-CORE SPACE INSTEAD OF
C     THE FIXED DIMENSION ARRAYS, AND TO EXPAND FROM ONE INPUT DATA
C     BLOCK TO FIVE. IF A CORRESPONDING OUTPUT FILE IS MISSING OR
C     PURGED, THE DATA BLOCKS ARE WRITTEN DIRECTLY TO FORTRAN TAPE
C     (UNIT 15, INP1) USING OUTPUT5 BINARY FORMAT.
C
C     CONTENTS OF INP1 TAPE IF IT IS WRITTEN -
C
C         RECORD   WORD     CONTENT                           TYPE
C         ------  ------   ----------------------------------------
C            0              TAPE HEADER RECORD
C                   1-2     'XXXXXXXX', TAPE ID              2*BCD
C                   3-4     MACHINE TYPE                     2*BCD
C                   5-7     DATE                             3*INT
C                    8      SYSTEM BUFFSIZE                    INT
C                    9      0 (BINARY TAPE)                    INT
C            1              FIRST MATRIX HEADER
C                    1      0                                  INT
C                   2,3     1,1                              2*INT
C                    4      A DOUBLE PRECISION ZERO           D.P.
C                   5-10    6 WORDS FROM MATRIX TRAILER      6*INT
C                           (COL,ROW,FORM,TYPE,MAX,DENSITY-
C                            TYPE=1 OR 3, DENSITY=1)
C                  11-12    MATRIX DMAP NAME                 2*BCD
C            2       1      1 (FIRST COLUMN ID)                INT
C                    2      LOCATION OF FIST NON-ZERO ELEMENT  INT
C                    3      LOCATION OF LAST NON-ZERO ELEMENT  INT
C                   4-N     S.P. DATA                         REAL
C            3       1      2 (SECOND COLUMN ID)               INT
C                   2-N     SAME AS RECORD 1
C            :      1-N     REPEAT FOR MORE COLUMNS
C
C            X       1      X (X-TH COLUMN ID, A NUL COLUMN)   INT
C                   2-3     1,1                                INT
C                   4-5     0.0,0.0                           REAL)
C
C            M      1-N     LAST COLUMN, SAME AS RECORD 1
C           M+1      1      -1 (ELEM) OR -2 (GRID)             INT
C                    2      1                                  INT
C                    3      LENGTH OF ELEM./GRID ID LIST, L    INT
C                  4-L+4    LIST OF ELEMENT OR GRID IDS        INT
C
C           M+2             SECOND MATRIX HEADER
C            :       :      REPEAT 1 THRU (M+1) FOR THE SECOND MATRIX
C
C            :       :      REPEAT, UP TO 5 OUTPUT DATA BLOCKS PER TAPE
C
C     COMMENTS FROM G.C. -
C     (1) THIS MODULE IS VERY LIMITED IN SCOPE. IT HANDLES ONLY SOME
C         SPECIAL TYPES OF TABULAR INPUT DATA BLOCKS. THE (PI X 8) MATRI
C         SPACE IS FOR PRINT/PUNCH PURPOSE. THE ORIGINAL PROGRAM SEEMS
C         TO BE WRITTEN TO MEET A PARTICULAR JOB REQUIREMENT.
C
C     (2) CURRENT MODULE HANDLES ONLY SINGLE PRECISION DATA
C
C     (3) THE PROCEDURE TO READ AND/OR WRITE THE TAPE IS COMMONLY USED
C         AMONG INPUTT5, OUTPUT5, AND DUMMOD5. ANY PROCEDURE CHANGE
C         SHOULD BE MADE TO ALL THREE MODULES.
C
      IMPLICIT INTEGER (A-Z)
      LOGICAL         NONE,     DEBUG
      INTEGER         NAME(2),  MCB(7),   TRL(7),  IZ(8),  TEMP(10),
     1                EG(2),    IR(5001), ID(5001),UNVC(2),MT(2),
     2                INFILE(2),OUTFIL(2),DATE(3), SAVE(2,5)
      REAL            Z,        EPSI
      DOUBLE PRECISION          DZERO,    DTEMP
      CHARACTER       UFM*23,   UWM*25,   UIM*29
CWKBNB
      CHARACTER*80    DSNAMES
      COMMON /DSNAME/ DSNAMES(80)
CWKBNE
      COMMON /XMSSG / UFM,      UWM,      UIM
      COMMON /ZZZZZZ/ Z(1)
      COMMON /MACHIN/ MACH,     IJHALF(3),MCHNAM
      COMMON /SYSTEM/ IBUF,     NOUT,     DUMM(88),LPCH
      COMMON /PACKX / TYPIN,    TYPOUT,   II,      JJ,     INCR
      COMMON /BLANK / P(5),     Q,        R
      EQUIVALENCE     (Z(1),IZ(1)),       (DATE(1),DUMM(13))
CWKBI
      DATA    IFIRST/0/
      DATA    TAPE,   IRDLMT,   ID,       IM, IE,  XX,     EPSI    /
     1        15,     5000,     5001*0,   1H-,1H=, 4HXXXX, 1.0E-30 /
      DATA    ZERO,   ONE,      EG,                NAME            /
     1        0,      1,        4HELEM,   4HGRID,  4HDUMO, 4HD5    /
      DATA    UNVC,   MT  /     4HUNIV,   4HAC  ,  2*4H            /
      DATA    DEBUG,  DZERO,    SAVE  /   .FALSE., 0.D0,   10*1H   /
C
      IF (MACH .EQ. 12) TAPE = 11
      CALL PAGE
      WRITE  (NOUT,5) P,Q,R
    5 FORMAT ('0*** MODULE DUMMOD5 CALLED BY USER DMAP ALTER.', /5X,
     1        'PARAMETERS ARE    P=',5(I5,1H,),5X,'Q=',I5,5X,'R=',I4,/)
      I6 OR 8 = 8
      IF (R .EQ. 1) I6 OR 8 = 16
      INCR  = 1
      TYPIN = 1
      TYPOUT= 1
      II    = 1
      TAPX  =-1
      TAPP  =-1
      CORE  = KORSZ(Z)
      BUF1  = CORE - IBUF + 1
      BUF2  = BUF1 - IBUF
      CORE  = BUF2 - 1
      HALF  = CORE/2
      HALF1 = HALF + 1
CWKBNB
      IF ( IFIRST .NE. 0 ) GO TO 1
      CLOSE ( UNIT=TAPE)
      OPEN ( UNIT=TAPE, FILE=DSNAMES(TAPE), FORM='UNFORMATTED',
     1       STATUS='UNKNOWN' )
      IFIRST = 1
1     CONTINUE
CWKBNE
C
      DO 450 LOOP = 1,5
      INPUT = 100 + LOOP
      OUTPT = 200 + LOOP
      TRL(1)= INPUT
      CALL RDTRL (TRL(1))
      IF (TRL(1) .LE. 0) GO TO 450
      CALL FNAME (INPUT,INFILE)
C
C     INPUT DATA PRECISION TYPE IS S.P. ONLY
C
      TYPE = 1
C
      IF (P(LOOP) .LE. 0) P(LOOP) = PV
      PV = P(LOOP)
      JJ = P(LOOP)*I6 OR 8
      DO 10 J = 1,JJ
   10 Z(J+HALF) = 0.0
      CALL GOPEN (INPUT,Z(BUF1),0)
      MCB(1) = OUTPT
      CALL RDTRL (MCB)
      NONE = .FALSE.
      IF (MCB(1) .LE. 0) NONE = .TRUE.
      IF (NONE) GO TO 15
      CALL GOPEN  (OUTPT,Z(BUF2),1)
      CALL FNAME  (OUTPT,OUTFIL)
      CALL MAKMCB (MCB,OUTPT,0,2,1)
      GO TO 20
   15 TAPX = TAPX + 1
      IF (TAPX .LE. 0) GO TO 20
      SAVE(1,TAPX) = INFILE(1)
      SAVE(2,TAPX) = INFILE(2)
   20 I    = 1
      NXZH = 0
      NXIR = 0
      CALL READ (*290,*30,INPUT,TEMP,10,1,M)
      NWDS = TEMP(10)
      NELTP= TEMP( 3)
C     IF (NELTP.GE.11 .AND. NELTP.LE.14) GO TO 320
C               CELAS1            CELAS4
      GO TO 60
   30 CALL MESAGE (-37,0,NAME)
   40 CALL READ (*290,*50,INPUT,TEMP,10,1,M)
      NWDS = TEMP(10)
      IF (TEMP(3) .NE. NELTP) GO TO 60
      GO TO 130
   50 CALL MESAGE (-61,INPUT,NAME)
C  60 IF (TEMP(3).GE.11 .AND. TEMP(3).LE.14) GO TO 320
C                 CELAS1              CELAS4
   60 CONTINUE
      NEWLT = TEMP(3)
      NWDS1 = NWDS - 1
      NWDS2 = NWDS - 2
      DO 70 L = 1,JJ
   70 Z(L) = 0.0
      DO 80 L = 1,IRDLMT
   80 IR(L) = 0
      CALL READ (*330,*350,INPUT,IR(1),1,0,M)
      KOUNT = 0
      DO 90 JSQ = 1,IRDLMT
      KOUNT = KOUNT + 1
      LOC = NWDS1*JSQ - NWDS2
      CALL READ (*330,*350,INPUT,Z(LOC),NWDS1,0,M)
C     LAST = LOC + NWDS1 - 1
      LAST = KOUNT*I6 OR 8
      CALL READ (*330,*100,INPUT,IR(JSQ+1),1,0,M)
   90 CONTINUE
  100 M   = NWDS*KOUNT
      IJK = 0
      DO 120 J = 1,M,NWDS
      IJK = IJK + 1
      NROP  = (IR(IJK)-1)/10
      LOCID = NXIR + IJK
      ID(LOCID) = NROP*100 + NEWLT
      LOCA = (IJK*I6 OR 8) - (I6 OR 8 -1) + NXZH
      LJ  = NWDS1*IJK - NWDS1
      KK  = LOCA + NWDS + HALF
      IF (KK .GT. CORE) CALL MESAGE (-8,0,NAME)
      DO 110 JM = 1,NWDS1
  110 Z(LOCA+JM-1+HALF) = Z(LJ+JM)
  120 CONTINUE
      NXIR = NXIR + JSQ
      NXZH = NXZH + LAST
      GO TO 40
  130 IF (Q .LT. 1) GO TO 150
      IS = IM
      KK = HALF + NXZH
      WRITE  (NOUT,140) IS,I,(Z(J),J=HALF1,KK)
  140 FORMAT ('  COLUMN',A1,I5, /,(2X,8E16.6))
  150 I = I + 1
      IF (NONE) GO TO 180
      CALL PACK (Z(HALF1),OUTPT,MCB)
      GO TO 270
  160 IF (TAPX .GT. 0) GO TO 170
C
C     WRITE TAPE HEADER AND MATRIX HEADER
C     (CURRENTLY, OUTPUT TAPE IS WRITTEN OUT IN SINGLE PRECISION ONLY)
C     CHANGE IN 89 VERSION -
C     MUST SET MATRIX DENSITY IN MATRIX TRAILER TO NON-ZERO IF INPUT5
C     IS TO BE USED
C
      TAPX = 1
      SAVE(1,TAPX) = INFILE(1)
      SAVE(2,TAPX) = INFILE(2)
      MT(1) = MCHNAM
      IF (MACH .NE. 3) GO TO 162
      MT(1) = UNVC(1)
      MT(2) = UNVC(2)
  162 WRITE (TAPE) XX,XX,MT,DATE,IBUF,ZERO
      IF (DEBUG) WRITE (NOUT,165) XX,XX,MT,DATE,IBUF,ZERO
  165 FORMAT ('0+++TAPE HEADER/DUMMOD5-',/3X,2A4,1X,2A4,3I4,2I6)
  170 IF (TAPX .EQ. TAPP) GO TO 190
      TAPP   = TAPX
      TRL(5) = TYPOUT
      TRL(7) = 1
      WRITE (TAPE) ZERO,ONE,ONE,DZERO,(TRL(K),K=2,7),INFILE
      IF (DEBUG) WRITE (NOUT,175) ZERO,ONE,ONE,DZERO,(TRL(K),K=2,7),
     1           INFILE
  175 FORMAT (' +++MATRIX HEADER/DUMMOD5- ',3I5,D8.0,6I5,1X,2A4)
      GO TO 190
C
  180 ASSIGN 270 TO RETN
  190 DO 200 JB = II,JJ
CWKBNB 8/94 ALPHA-VMS
      ITYPE = NUMTYP( Z(JB+HALF) )
      IF ( ITYPE .LE. 1 ) GO TO 200
CWKBNE 8/94 ALPHA-VMS
      IF (ABS(Z(JB+HALF)) .GT. EPSI) GO TO 210
  200 CONTINUE
      WRITE (TAPE) I,ONE,ONE,(ZERO,J=1,TYPE)
      IF (DEBUG) WRITE (NOUT,205) I,ONE,ONE,(ZERO,J=1,TYPE)
  205 FORMAT (' +++ZEROS/DUMMOD5- ',7I5)
      GO TO 265
  210 JE = JJ
      DO 220 J = II,JJ
CWKBNB 8/94 ALPHA-VMS
      ITYPE = NUMTYP( Z(JE+HALF) )
      IF ( ITYPE .LE. 1 ) GO TO 220
CWKBNE 8/94 ALPHA-VMS
      IF (ABS(Z(JE+HALF)) .GT. EPSI) GO TO 230
  220 JE = JE - 1
  230 GO TO (260,240,240,250), TYPE
  240 IF (MOD(JB,2) .EQ. 0) JB = JB - 1
      IF (MOD(JE,2) .EQ. 1) JE = JE + 1
      GO TO 260
  250 J = MOD(JB,4)
      IF (J .EQ. 0) J = 4
      JB = JB - J + 1
      J  = MOD(JE,4)
      IF (J .EQ. 0) J = 4
      JE = JE - J + 4
  260 WRITE (TAPE) I,JB,JE,(Z(J+HALF),J=JB,JE)
      IF (DEBUG) WRITE (NOUT,262) I,JB,JE
  262 FORMAT (' +++DATA RECORD/DUMMOD5- ',3I5)
  265 GO TO RETN, (270,370)
C
  270 DO 280 L = 1,JJ
  280 Z(L+HALF) = 0.0
      NXZH = 0
      NXIR = 0
      GO TO 60
  290 IF (Q .LT. 0) GO TO 300
      IS = IE
      KK = HALF + NXZH
      WRITE (NOUT,140) IS,I,(Z(J),J=HALF1,KK)
  300 ASSIGN 370 TO RETN
      IF (NONE) GO TO 160
      CALL PACK (Z(HALF1),OUTPT,MCB)
      MCB(3) = JJ
      CALL WRTTRL (MCB)
      IF (Q .EQ. 2) WRITE (NOUT,310) (MCB(J),J=1,5)
  310 FORMAT (/2X,'MCB=',6I8)
      GO TO 370
C 320 CALL READ (*330,*40 ,INPUT,IR(1),1,0,M)
C     CALL READ (*330,*350,INPUT, Z(1),1,0,M)
C     Z(1) = 0.0
C     GO TO 320
  330 WRITE  (NOUT,340) INFILE
  340 FORMAT (/5X,'*** EOF ENCOUNTERED ON INPUT ',2A4,' DATA BLOCK')
      GO TO 440
  350 WRITE  (NOUT,360) INFILE
  360 FORMAT (/5X,'*** INPUT ',2A4,'DATA BLOCK IS EMPTY')
      GO TO 440
  370 IF (.NOT.NONE) WRITE (NOUT,380) UIM,INFILE,OUTFIL
  380 FORMAT (A29,', MODULE DUMMOD5 SUCCESSFULLY PROCESSED TABULAR ',
     1        'DATA FROM ',2A4,' TO DATA BLOCK ',2A4, /5X,
     2        'IN GINO PACKED FORM')
      IF (NONE) WRITE (NOUT,390) UIM,INFILE,TAPE
  390 FORMAT (A29,', MODULE DUMMOD5 SUCCESSFULLY COPIED TABULAR DATA ',
     1        'FROM ',2A4,' TO OUTPUT TAPE', /5X,
     3        '(FORTRAN UNIT',I4,') IN BANDED MATRIX FORM')
      IF (Q .GT. 0) WRITE (LPCH,400) (ID(J),J=1,NXIR)
  400 FORMAT (8I10)
      L = EG(1)
      IF (NEWLT .GT. 0) GO TO 420
      L = EG(2)
      DO 410 J = 1,NXIR
  410 ID(J) = ID(J)/100
  420 WRITE  (NOUT,430) L,INFILE,(ID(J),J=1,NXIR)
  430 FORMAT (//5X,A4,'-ID ARRAY FOLLOWS/FROM ',2A4, (/5X,15I8))
      IF (.NOT.NONE) GO TO 440
      I = -1
      IF (NEWLT .EQ. 0) I = -2
      WRITE (TAPE) I,ONE,NXIR,(ID(J),J=1,NXIR)
      IF (DEBUG) WRITE (NOUT,435) I,ONE,NXIR
  435 FORMAT (' +++ELEM/GRID ID RECORD/DUMMOD5- ',3I5)
  440 CONTINUE
      CALL CLOSE (INPUT,1)
      IF (.NOT.NONE) CALL CLOSE (OUTPT,1)
  450 CONTINUE
C
      IF (TAPX .LE. 0) GO TO 590
      WRITE  (NOUT,455) UIM,TAPE,(SAVE(1,J),SAVE(2,J),J=1,TAPX)
  455 FORMAT (A29,', FOLLOWING DATA BLOCKS WERE COPIED TO FORTRAN UNIT',
     1        I3,' BY MODULE DUMMOD5', /5X,
     2        'USING UNFORMATTED (BINARY) WRITE', /6X,5(2A4,3X))
      ENDFILE TAPE
      REWIND TAPE
C
C     TO READ THE OUTPUT TAPE, Q=/2/
C
      IF (IABS(Q) .LT. 2) GO TO 590
      CALL PAGE1
      K = 1
      READ (TAPE,END=575) MCB,J,I
      WRITE  (NOUT,460) MCB,J
  460 FORMAT (//,'  TAPEID=',2A4,'   FROM ',A4,A2,' MACHINE,  DATE',I5,
     1        1H/,I2,1H/,I2,'  BINARY TAPE.   BUFFSIZE=',I7//)
  470 READ (TAPE,END=580) I,JB,JE,(Z(J),J=JB,JE)
      IF (I) 560,480,500
  480 BACKSPACE TAPE
      READ (TAPE,END=580) I,JB,JE,DTEMP,(IZ(J),J=1,8)
      WRITE  (NOUT,490) K,IZ(7),IZ(8),(IZ(J),J=1,6)
  490 FORMAT (//,'  DATA BLOCK',I3,3X,2A4,'  TRAILER=',6I5)
      K = K + 1
      GO TO 470
  500 WRITE  (NOUT,510) I,JB,JE,(Z(J),J=JB,JE)
  510 FORMAT (//,'  COLUMN RECORD =',I3,'   JB,JE =',2I5,/,(1X,10E13.6))
      GO TO 470
C
  560 L = EG(-I)
      WRITE  (NOUT,570) L,(IZ(J),J=JB,JE)
  570 FORMAT (//2X,A4,'-ID LIST -',/,(1X,10I10))
      GO TO 470
  575 WRITE  (NOUT,577)
  577 FORMAT (//,'  EMPTY TAPE')
  580 REWIND TAPE
  590 CONTINUE
      RETURN
      END

      SUBROUTINE GP3C
C
C     GP3C EXECUTES ONLY IF PLOAD2 AND/OR PLOAD3 CARDS ARE PRESENT. ITS
C     FUNCTION IS TO --
C     (1) PROCESS PLOAD2 CARDS SO THAT THEIR FORMAT IS IDENTICAL TO
C         PLOAD CARDS.  IF A PLOAD RECORD EXISTS ON GEOM3, PLOAD2 DATA
C         IS APPENDED TO THE DATA, SORTED, AND ALL RESULTING PLOAD DATA
C         IS WRITTEN ON SCR2.
C     (2) PROCESS PLOAD3 CARDS SO THAT ALL PRESSURES APPLIED TO AN ISO-
C         PARAMETRIC SOLID ARE GATHERED IN ONE ENTRY AND SORTED BY THE
C         FACE NUMBER TO WHICH THE PRESSURE IS APPLIED.  THE SORTED
C         PRESSURES AND GRID POINT NUMBERS FOR EACH ELEMENT ARE WRITTEN
C         ON SCR2.
C
C
      EXTERNAL        ANDF
      INTEGER         GEOM3 ,GEOM2 ,SCR2  ,BUF1  ,BUF2  ,BUF   ,CLSREW,
     1                WRTREW,RDREW ,ELEM  ,FILE  ,NAM(2),PLOAD2,Z     ,
     2                CARDID,PLOAD3,PL2   ,PL3   ,PLD(3),D1    ,D2    ,
     3                ANDF  ,FACES(6,12)  ,PL3ERR(14)
      REAL            RZ(1),P(12)
      COMMON /GP3COM/ GEOM3 ,EQEXIN,GEOM2 ,SLT   ,GPTT  ,SCR1  ,SCR2   ,
     1                BUF1  ,BUF2  ,BUF(50)      ,CARDID(60)   ,IDNO(30)
     2              , CARDDT(60)   ,MASK(60)     ,STATUS(60)   ,NTYPES ,
     3                IPLOAD,IGRAV ,PLOAD2(2)    ,LOAD(2)      ,NOPLD2 ,
     4                TEMP(2)      ,TEMPD(2)     ,TEMPP1(2)    ,
     5                TEMPP2(2)    ,TEMPP3(2)    ,TEMPRB(2)    ,BUF3   ,
     6                PLOAD3(2)    ,IPLD3
      COMMON /NAMES / RD    ,RDREW ,WRT   ,WRTREW,CLSREW
      COMMON /ZZZZZZ/ Z(1)
      COMMON /GPTA1 / NELEM ,LAST  ,INCR  ,ELEM(1)
      COMMON /TWO   / TWO(32)
      COMMON /SYSTEM/ SYSBUF,NOUT
      EQUIVALENCE     (RZ(1),Z(1))
C
C  FACE                 IHEX1             IHEX2             IHEX3
C   NO                D1      D2        D1      D2        D1      D2
      DATA    FACES/   1,      3,        1,      5,        1,      7,
     1                 2,      4,        3,      7,        4,     10,
     2                 1,      6,        1,     15,        1,     24,
     2                 2,      5,        3,     13,        4,     21,
     3                 2,      7,        3,     17,        4,     27,
     3                 3,      6,        5,     15,        7,     24,
     4                 3,      8,        5,     19,        7,     30,
     4                 4,      7,        7,     17,       10,     27,
     5                 1,      8,        1,     19,        1,     30,
     5                 4,      5,        7,     13,       10,     21,
     6                 5,      7,       13,     17,       21,     27,
     6                 6,      8,       15,     19,       24,     30/
C
      DATA   N3304,N3305,PL3ERR/4H3304, 4H3305, 4H0***, 4H USE, 4HR FA,
     C                          4HTAL , 4HMESS, 4HAGE , 4H330*, 4H, PL,
     2                          4HOAD3, 4H CAR, 4HD FR, 4HOM L, 4HOAD ,
     3                          4HSET /
      DATA   NAM  /    4HGP3C,4H      /
C
C     CHECK TRAILER BITS FOR PRESENCE OF PLOAD2 AND PLOAD3 CARDS.
C     IF NONE EXIST, RETURN.  OTHERWISE, BRANCH AND INITIALIZE TO
C     PROCESS ONE OF THESE CARD TYPES.
C
      NOGO = 0
      PL2  = 0
      PL3  = 0
      J    = (PLOAD2(2)-1)/16
      K    = PLOAD2(2) - 16*J
      IF (ANDF(BUF(J+2),TWO(K+16)) .NE. 0) PL2 = 1
      J    = (PLOAD3(2)-1)/16
      K    = PLOAD3(2) - 16*J
      IF (ANDF(BUF(J+2),TWO(K+16)) .NE. 0) PL3 = 1 - 2*PL2
      FILE = SCR2
      IF (PL2-PL3 .NE. 0) CALL OPEN (*210,SCR2,Z(BUF2),WRTREW)
      IF (PL2 .EQ. 0) GO TO 15
      NOPLD2 = 1
      PLD(1) = PLOAD2(1)
      PLD(2) = PLOAD2(2)
      PLD(3) = 24
      INCRD  = 3
      INCL   = 6
      IDL    = 2
      GO TO 10
   15 IF (PL3 .EQ. 0) GO TO 196
      NOPLD2 = NOPLD2 + 2
      PLD(1) = PLOAD3(1)
      PLD(2) = PLOAD3(2)
      PLD(3) = 255
      INCRD  = 5
      INCL   = 39
      IDL    = 1
C
C     READ PLOAD2 OR PLOAD3 CARDS INTO CORE IN AN EXPANDED FORMAT.
C     SET THE SET ID NEGATIVE TO INDICATE THE CARD IS NOT YET CONVERTED.
C
   10 I = 1
      FILE = GEOM3
      CALL PRELOC (*210,Z(BUF1),GEOM3)
      CALL LOCATE (*230,Z(BUF1),PLD,FLAG)
      IF (PL2 .NE. 1) GO TO 20
      PLD(1) = CARDID(IPLOAD  )
      PLD(2) = CARDID(IPLOAD+1)
   20 CALL READ (*220,*30,GEOM3,Z(I),INCRD,0,FLAG)
      Z(I) = -Z(I)
      IF (PL2 .EQ.  1) GO TO 29
      IF (I .LT. INCL) GO TO 25
      DO 21 J = 2,I,INCL
      K = J
      IF (Z(J) .NE. Z(I+2)) GO TO 21
      IF (Z(J-1) .EQ. Z(I)) GO TO 22
   21 CONTINUE
   25 P(1)   = RZ(I+1)
      Z(I+1) = Z(I+2)
      RZ(I+2)= P(1)
      Z(I+14)= Z(I+3)
      Z(I+15)= Z(I+4)
      Z(I+3) =-1
      GO TO 29
   22 J = K + 2
   23 IF (Z(J) .EQ. -1) GO TO 24
      J = J + 1
      IF (J .LE. K+12) GO TO 23
      GO TO 25
   24 RZ(J) = RZ(I+1)
      IF (J .LT. K+12) Z(J+1) = -1
      J = K + 15 + 2*(J-K-2)
      Z(J  ) = Z(I+3)
      Z(J+1) = Z(I+4)
      GO TO 20
   29 Z(I+INCL-1) = 0
      I = I+INCL
      IF (I .LT. BUF2) GO TO 20
      CALL MESAGE (-8,0,NAM)
   30 CALL CLOSE (GEOM3,CLSREW)
      NPLD2 = I - INCL
      NWDS  = I - 1
C
C     POSITION TO FIRST DATA RECORD ON GEOM2.
C
      FILE = GEOM2
      CALL OPEN (*130,GEOM2,Z(BUF1),RDREW)
      CALL FWDREC (*220,GEOM2)
C
C     READ 3-WORD RECORD ID. LOOK FOR ID IN ELEM TABLE.
C     IF NOT THERE, SKIP RECORD.
C     IF PROCESSING PLOAD2, AND NOT A TWO-DIMENSIONAL ELEMENT, SKIP REC.
C     IF PROCESSING PLOAD3, AND NOT AN ISOPARAMETRIC ELEMENT, SKIP REC.
C     OTHERWISE,  INITIALIZE PARAMETERS.
C
   50 CALL READ (*130,*50,GEOM2,BUF,3,0,FLAG)
      DO 60 I = 1,LAST,INCR
      IF (BUF(1) .EQ. ELEM(I+3)) GO TO 80
   60 CONTINUE
   70 CALL FWDREC (*220,GEOM2)
      GO TO 50
   80 NGPS  = ELEM(I+9)
      ITYPE = ELEM(I+2)
C
C   . IF ELEMENT TYPE IS 68 (QUADTS) THEN USE FIRST FOUR  GRID POINTS
C   . IF ELEMENT TYPE IS 69 (TRIATS) THEN USE FIRST THREE GRID POINTS
C
      IF (ITYPE.EQ.68 .OR. ITYPE.EQ.69) NGPS = NGPS/2
      IF (PL2.EQ.1 .AND. (NGPS.LT.3 .OR. NGPS.GT.4)) GO TO 70
      IF (PL3.EQ.1 .AND. (ITYPE.LT.65 .OR. ITYPE.GT.67)) GO TO 70
      ITYPE  = 2*(ITYPE-64) - 1
      NWDECT = ELEM(I+5)
      J1 = ELEM(I+12)
      J2 = J1 + NGPS - 1
C
C     READ EACH ELEMENT IN RECORD. LOOK FOR ELEMENT ID MATCH IN PLOAD2
C     OR PLOAD3 LIST.  IF FOUND, SET THE SET ID POSITIVE TO INDICATE
C     ENTRY IS CONVERTED.
C
   90 CALL READ (*220,*50,GEOM2,BUF,NWDECT,0,FLAG)
      DO 110 I = 1,NPLD2,INCL
      IF (Z(I) .GT. 0) GO TO 110
      IF (Z(I+IDL) .NE. BUF(1)) GO TO 110
      Z(I) = -Z(I)
      IX   = I
      IF (PL3 .EQ. 1) GO TO 300
C
C     PLACE GRID POINT NUMBERS FROM ELEMENT CARD IN PLOAD2 ENTRY TO
C     MAKE IT LOOK LIKE PLOAD CARD.
C
      DO 100 J = J1,J2
      Z(IX+2) = BUF(J)
      IX = IX + 1
  100 CONTINUE
      GO TO 110
C
C     FIND THE DIAGONALS ON THE PLOAD3 CARD ON THE ELEMENT CARD TO
C     DETERMINE THE FACES TO WHICH THE PRESSURES ARE APPLIED.  SORT
C     THE PRESSURES BY FACE NUMBER AND APPEN+ THE GRID POINT NUMBERS
C     FROM THE ELEMENT CARD TO THE PLOAD3 ENTRY.
C
  300 NP = 0
      DO 310 J = 1,12
      IF (Z(I+J+1) .EQ. -1) GO TO 315
      NP = NP + 1
      P(J) = RZ(I+J+1)
  310 CONTINUE
  315 DO 320 J = 1,6
  320 RZ(I+J)  = 0.0
      DO 350 J = 1,NP
      K   = I + 14 + 2*(J-1)
      ID1 = Z(K  )
      ID2 = Z(K+1)
      DO 322 K = J1,J2
      IF (ID1 .EQ. BUF(K)) GO TO 324
  322 CONTINUE
      GO TO 335
  324 ID1 = K - J1 + 1
      DO 326 K = J1,J2
      IF (ID2 .EQ. BUF(K)) GO TO 328
  326 CONTINUE
      GO TO 335
  328 ID2 = K - J1 + 1
      D1  = MIN0(ID1,ID2)
      D2  = MAX0(ID1,ID2)
      DO 330 K = 1,12
      NFACE = (K+1)/2
      IF (D1 .NE. FACES(ITYPE  ,K)) GO TO 330
      IF (D2 .EQ. FACES(ITYPE+1,K)) GO TO 340
  330 CONTINUE
  335 NOGO = 1
      PL3ERR(7) = N3305
      WRITE (NOUT,420) PL3ERR,Z(I),BUF(1)
      GO TO 350
  340 RZ(I+NFACE) = RZ(I+NFACE)+P(J)
  350 CONTINUE
      IX = IX + 7
      DO 360 J = J1,J2
      Z(IX) = BUF(J)
      IX = IX + 1
  360 CONTINUE
      IF (IX+1-I .GT. 39) GO TO 110
      K = I + 38
      DO 370 J = IX,K
  370 Z(J) = 0
  110 CONTINUE
      GO TO 90
C
C     HERE WHEN END-OF-FILE ON GEOM2 IS ENCOUNTERED.
C     MAKE SURE ALL PLOAD2 OR PLOAD3 ENTRIES HAVE BEEN CONVERTED.
C
  130 CALL CLOSE (GEOM2,CLSREW)
      DO 140 I = 1,NPLD2,INCL
      IF (Z(I) .GT. 0) GO TO 140
      NOGO = 1
      BUF(1) = -Z(I)
      BUF(2) =  Z(I+IDL)
      IF (PL2 .EQ. 1) CALL MESAGE (30,105,BUF)
      PL3ERR(7) = N3304
      IF (PL3 .EQ. 1) WRITE (NOUT,410) PL3ERR,BUF(1),BUF(2)
  140 CONTINUE
      IF (NOGO .NE. 0) CALL MESAGE (-61,0,0)
      IF (PL3  .EQ. 1) GO TO 190
C
C     LOCATE PLOAD RECORD ON GEOM3. IF PRESENT, READ PLOAD DATA INTO
C     CORE (AFTER PLOAD2 DATA) AND SORT COMBINED DATA ON SET ID.
C
      CALL PRELOC (*210,Z(BUF1),GEOM3)
      CALL LOCATE (*180,Z(BUF1),CARDID(IPLOAD),FLAG)
      I = NPLD2 + 6
  160 CALL READ (*220,*170,GEOM3,Z(I),6,0,FLAG)
      I = I + 6
      IF (I .LT. BUF2) GO TO 160
      CALL MESAGE (-8,0,NAM)
  170 NPLD2 = I - 6
      NWDS  = I - 1
      CALL SORT (0,0,6,1,Z,NWDS)
  180 CALL CLOSE (GEOM3,CLSREW)
C
C     WRITE DATA ON SCR2, SET FLAG TO INDICATE AND RETURN.
C
  190 CALL WRITE (SCR2,PLD,3,0)
      CALL WRITE (SCR2,Z,NWDS,1)
      IF (PL2 .NE. 1) GO TO 196
  195 PL2 = -PL2
      PL3 = -PL3
      GO TO 15
  196 CALL CLOSE (SCR2,CLSREW)
      RETURN
C
C     ERROR MESSAGES.
C
  200 CALL MESAGE (N,FILE,NAM)
  210 N = -1
      GO TO 200
  220 N = -2
      GO TO 200
C
C     ABNORMAL RETURN.
C
  230 IF (PL3 .LT. 0) GO TO 195
      CALL CLOSE (GEOM3,CLSREW)
      RETURN
C
C     PLOAD3 CARD ERRORS
C
  410 FORMAT (14A4,I9,' REFERENCES MISSING OR NON-ISOPARAMETRIC ELEMENT'
     1       ,I9)
  420 FORMAT (14A4,I9,' HAS INVALID GRID POINT NUMBERS FOR ELEMENT',I9)
      END

        SUBROUTINE INTPKI ( A, I, FILE, BLOCK, IEOL )
      INCLUDE 'DSIOF.COM'
      INCLUDE 'XNSTRN.COM'
        INTEGER A(4), BLOCK(15), FILE
        NAME   = FILE
        IRETRN = 0
        I = BLOCK( 4 )
        INDEX  = ( BLOCK(5)-1 )*BLOCK(14) + 1 + BLOCK(7)*BLOCK(11)
        ITYPOT = BLOCK( 13 )
        IF ( BLOCK(2) .NE. ITYPOT ) GO TO 50
        NUM = NWRDEL( ITYPOT )
CDIR$ NOVECTOR
        DO 40 KK = 1, NUM
        A( KK ) = IBASE( INDEX + KK - 1 )
40      CONTINUE
CDIR$ VECTOR
        GO TO 60
50      CALL DSUPKC( BLOCK(2), ITYPOT, IBASE( INDEX ), A )
60      CONTINUE
        BLOCK( 4 ) = BLOCK( 4 ) + 1
        BLOCK( 7 ) = BLOCK( 7 ) + 1
        BLOCK(10 ) = BLOCK( 4 )
        IF ( BLOCK( 7 ) .LT. BLOCK( 6 ) ) GO TO 200
        CALL ENDGET( BLOCK )
        CALL GETSTR( *100, BLOCK )
100     BLOCK( 7 ) = 0
200     CONTINUE
        IF ( IRETRN .NE. 0 ) GO TO 300
        IEOL = 0
        GO TO 700
300     IEOL = 1
700     RETURN
        END

      SUBROUTINE HDPLT (X1,Y1,IJ,IM)
C
C     PLOTS POINTS GOVERNED BY THE VALUE OF IM.
C
C     NOTE THAT CALL PLOT(X,Y,2) MEANS MOVE PEN FROM THE CURRENT
C     POSITION TO THE POINT,(X,Y),WITH THE PEN DOWN.
C
C     CALL PLOT(X,Y,3) MEANS MOVE THE PEN FROM THE CURRENT POSITION
C     TO THE POINT,(X,Y), WITH THE PEN UP.
C
      LOGICAL         DEBUG
      INTEGER         PPEN
      DIMENSION       X1(4),Y1(4)
      COMMON /DRWDAT/ DUM(3),PPEN
      COMMON /SYSTEM/ IBUF,NOUT
      DATA    DEBUG / .FALSE./
C
      IF (DEBUG) WRITE (NOUT,1000)IJ,IM,(X1(I),I=1,4),(Y1(J),J=1,4)
 1000 FORMAT (7H HDPLT ,2I3,8F12.5)
      IF (IM .EQ. 1) GO TO 20
      XVALUE = (X1(2))/X1(4)
      YVALUE = (Y1(2))/Y1(4)
      IF (IJ .EQ. 0) GO TO 10
      CALL LINE (XOLD,YOLD,XVALUE,YVALUE,PPEN,0)
      XOLD = XVALUE
      YOLD = YVALUE
      GO TO 30
   10 CONTINUE
      XOLD = XVALUE
      YOLD = YVALUE
      IJ = 1
      GO TO 30
   20 CONTINUE
      IJ = 0
   30 CONTINUE
      RETURN
      END

      SUBROUTINE K2B (K,B,N)
C
C     MOVE ONLY THE APPROPRIATE PORTION OF THIS ROUTINE TO THE MDS GROUP
C
C     VAX, IBM, UNIX AND UNIVAC VERSION
C     =================================
C
C     TO CONVERT CHARACTER STRING TO BCD WORDS, ONE CHARACTER PER WORD
C     AND BLANK FILLED. SAME RESULT AS
C                READ (Kn,10) B
C             10 FORMAT (nA1)      WHERE Kn IS IN CHARACTER*n
C
C     (NOTE - THE INTERNAL FILE READ AND WRITE ARE SLOW IN MOST MACHINES
C             AND IS EXTREMELY SLOW IN CDC)
C
      INTEGER     B(1),A
      CHARACTER*1 K(1),C
      CHARACTER*4 C4,D4
C     CHARACTER*n C4,D4
C         Where n = 4 for IBM, VAX and UNIVAC, 8 for 64-BIT UNIX MACHINE
      EQUIVALENCE (A,C,C4)
      DATA   D4 / '    ' /
C
      C4 = D4
      I  = 1
 10   C  = K(I)
      B(I) = A
      I  = I + 1
      IF (I .LE. N) GO TO 10
      RETURN
C
      ENTRY B2K (B,K,N)
C     =================
C
C     TO MERGE FROM ONE-CHARACTER BCD WORDS TO A CHARACTER STRING
C     SAME RESULT AS
C                WRITE (Kn,10) B
C             10 FORMAT (nA1)      WHERE Kn IS IN CHARACTER*n
C
      I = 1
 20   A = B(I)
      K(I) = C
      I = I + 1
      IF (I .LE. N) GO TO 20
      RETURN
C
C
C     SUBROUTINE K2B (K,B,N)
C
C     CDC VERSION
C     ===========
C
C     TO CONVERT CHARACTER STRING TO BCD WORDS, ONE CHARACTER PER WORD
C     AND BLANK FILLED. SAME RESULT AS
C                READ (Kn,10) B
C             10 FORMAT (nA1)      WHERE Kn IS IN CHARACTER*n
C
C     (NOTE - THE INTERNAL FILE READ AND WRITE ARE SLOW IN MOST MACHINES
C             AND IS EXTREMELY SLOW IN CDC)
C
C     INTEGER K(1),B(1)
C     DATA    NBPC,NCPW,NCPWP1 / 6, 10, 11  /
C     DATA    MASK /O"77000000000000000000" /
C
C     IE = 1 + N/NCPW
C     KK = 0
C     DO 40 I = 1,IE
C     KI = K(I)
C     DO 30 J = 1,NCPW
C     KK = KK + 1
C     IF (KK .GT. N) GO TO 50
C     B(KK) = AND(KI,MASK)
C     KI = SHIFT(KI,NBPC)
C30   CONTINUE
C40   CONTINUE
C50   RETURN
C
C
C     ENTRY B2K (B,K,N)
C     =================
C
C     TO MERGE FROM ONE-CHARACTER BCD WORDS TO A CHARACTER STRING
C     SAME RESULT AS
C                WRITE (Kn,10) B
C             10 FORMAT (nA1)      WHERE Kn IS IN CHARACTER*n
C
C     IE = 1 + N/NCPW
C     KK = 0
C     DO 70 I = 1,IE
C     KK = KK + 1
C     KI = AND(B(KK),MASK)
C     DO 60 J = 2,NCPW
C     KI = SHIFT(KI,NBPC)
C     KK = KK + 1
C     IF (KK .GT. N) GO TO 80
C     KI = OR(KI,AND(B(KK),MASK))
C60   CONTINUE
C70   K(I) = SHIFT(KI,NBPC)
C     GO TO 90
C80   J = NCPWP1 - MOD(KK,NCPW)
C     IF (J .GT. NCPW) J = 1
C     K(IE) = SHIFT(KI,J*NBPC)
C90   RETURN
C
      END

      SUBROUTINE XRECPS (INEW,IOLD)
C
C     ******************************************************************
C     * ATTENTION CDC 6600 SET-UPS ** THESE ENTRY POINTS MAY BE        *
C     * SEPARATED EACH ENTRY MAY BE MADE A SUBROUTINE (EXCEPT /CRDFLG/ *
C     * AND /INTEXT/ WHICH USE COMMON CODE)  DUPE THE SPECIFICATION    *
C     * STMTS FOR EACH SUB                                             *
C     ******************************************************************
C
      IMPLICIT INTEGER (A-Z)
      INTEGER KBMSK1(8),SFT(4),NRECPS(2),CON(38),MK(4),C10C(7),EXTAB(37)
C
C     ENTRY XFADJ (BF,SD,KK)
C     * XFADJ ADJUSTS 4 CHARACTER FIELDS, LEFT OR RIGHT, 2 OR 4 FIELDS
C       AT A TIME - IF FIELDS CONTAIN ONLY INTEGERS 0 THRU 9, SHIFT IS
C       RIGHT, OTHERWISE SHIFT IS LEFT  / BF= ADDR OF LEFT MOST FIELD /
C       SD= 0 SINGLE (2 FIELDS), 1 DOUBLE (4 FIELDS).  THIS ROUTINE
C       DETERMINES ONLY TYPE OF SHIFT NEEDED, SHIFTING IS DONE BY XFADJ1
C       KK IS RETURNED EQUAL TO 0 FOR INTEGER, 1 FOR NON-INTEGER
C
      INTEGER BF(1)
C
C     ENTRY XBCDBI (BA)
C     * XBCDBI CONVERTS 2, 4 CHARACTER BCD INTEGER FIELDS (RIGHT
C       ADJUSTED IN THE LEFT MOST 4 CHAR) INTO A SINGLE FORTRAN BINARY
C       INTEGER (RIGHT ADJUSTED IN THE WORD IN THE RIGHT FIELD)
C       BA= ADDR OF LEFT FIELD
C
      INTEGER BA(2)
C
C     ENTRY XPRETY (BFF)
C     * ROUTINE PRETTIES UP SORT OUTPUT BY LEFT ADJUSTING ALL FIELDS
C
      INTEGER BFF(2)
C
C     ENTRY CRDFLG (CARD)
C     * ROUTINE SETS CARD TYPE FLAGS IN RESTART TABLES
C       CONVERTS TO EXTERNAL CODE FIRST
C       IF CARD TYPE IS PARAM, SET FLAG FOR PARAM NAME (FIELD 2)
C
      INTEGER CARD(4)
C
C     ENTRY EXTINT (EXTWRD)
C     * ROUTINE CONVERTS FROM EXTERNAL MACHINE DEPENDENT CHARACTER CODES
C       TO AN INTERNAL MACHINE INDEPENDENT INTEGER
C
      INTEGER EXTWRD(1)
C
C     ENTRY INTEXT (INTWRD)
C     * ROUTINE CONVERTS FROM INTERNAL MACHINE INDEPENDENT INTEGERS TO
C       AN EXTERNAL MACHINE DEPENDENT CHARACTER CODE
C
      INTEGER INTWRD(2)
C
      EXTERNAL        LSHIFT,RSHIFT,ANDF,ORF,COMPLF
      LOGICAL         DEC
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG / UFM,UWM,UIM,SFM
      COMMON /MACHIN/ MACH
      COMMON /SYSTEM/ B,OUTTAP,D1(6),NLPP,D2(2),LCNT,D3(26),
     1                NBPC,NBPW,NCPW
      COMMON /XSRTCM/ BIMSK1(6),BIMSK2(5),BIMSK3(4),BIMSK4(4),BIMSK5(2),
     1                BIMSK6,BKMSK1(8),BKMSK2,SHIFTS(4),
     2                ICON1,ICON2,STAR,PLUS,DOLLAR,STARL,SLASH,SFTM,
     3                MASK,BLANK,MKA,IS,MBIT4
      COMMON /TWO   / ITWO(32)
      COMMON /IFPX0 / LBD,LCC,IBITS(1)
      COMMON /IFPX1 / NUM,ICARDS(2)
      EQUIVALENCE     (SFT(1),SHIFTS(1)),(MK(1),BIMSK3(1)),
     1                (SFT1,SHIFTS(2)),(EXTAB(1),CON(1))
      DATA ITAPE4/304/,NRECPS/4HXREC,4HPS  /
      DATA CON/4H    ,4H   0,4H   1,4H   2,4H   3,4H   4,4H   5,4H   6,
     1  4H   7,4H   8,4H   9,4H   A,4H   B,4H   C,4H   D,4H   E,4H   F,
     2  4H   G,4H   H,4H   I,4H   J,4H   K,4H   L,4H   M,4H   N,4H   O,
     3  4H   P,4H   Q,4H   R,4H   S,4H   T,4H   U,4H   V,4H   W,4H   X,
     4  4H   Y,4H   Z,4H              /
      DATA C10C/10,100,1000,10000,100000,1000000,10000000/
      DATA PAR1,PAR2/4HPARA,4HM       /
      DATA KPRET1,KPRET2/4H.   ,4H0.0 /
C
      DATA KBMSK1 / 4H0000, 4H000$, 4H00$$, 4H0$$$,
     1              4H$$$ , 4H$$  , 4H$   , 4H            /
      DATA ISTR   , ISTRL , IPLS  , IDOLLR, ISLSH , IZERO /
     1     4H   * , 4H*   , 4H+   , 4H$   , 4H/   , 4H0   /
C
C
C     THE ARRAYS IN /XSRTCM/ WILL BE SET BY INITO AS FOLLOWS
C
C                           VAX
C                    CDC    IBM   UNIVAC
C        SHIFTS(1) =  0      0      0
C        SHIFTS(2) =  6      8      9
C        SHIFTS(3) = 12     16     18
C        SHIFTS(4) = 18     24     27
C        SFTM      = 36      0      0
C
C                      ----------- BYTE --------------
C                      1ST   2ND   3RD   4TH   5TH,...
C        BIMSK1(1) = / 777 / 777 / 777 / 000 / 00..        CDC USES /77/
C        BIMSK1(2) = / 777 / 777 / 000 / 000 / 00..        INSTEAD OF
C        BIMSK1(3) = / 777 / 000 / 000 / 000 / 00..        /777/ IN A
C        BIMSK1(4) = / 000 / 000 / 000 / 777 / 00..        BYTE
C        BIMSK1(5) = / 000 / 000 / 777 / 777 / 00..
C        BIMSK1(6) = / 000 / 777 / 777 / 777 / 00..
C
C        BIMSK2(1) = / 777 / 777 / 777 / 777 / 77.. (FOR CDC ONLY)
C                  = / 377 / 777 / 777 / 777 / 00.. (FOR IBM,VAX,UNIVAC)
C        BIMSK2(2) = / 777 / 777 / 777 / 000 / 77..
C        BIMSK2(3) = / 777 / 777 / 000 / 000 / 77..
C        BIMSK2(4) = / 777 / 000 / 000 / 000 / 77..
C        BIMSK2(5) = / 000 / 000 / 000 / 000 / 77..
C
C        BIMSK3(1) = / 777 / 000 / 000 / 000 / 00..
C        BIMSK3(2) = / 000 / 777 / 000 / 000 / 00..
C        BIMSK3(3) = / 000 / 000 / 777 / 000 / 00..
C        BIMSK3(4) = / 000 / 000 / 000 / 777 / 00..
C
C        BIMSK4(1) = / 000 / 777 / 777 / 777 / 77..
C        BIMSK4(2) = / 777 / 000 / 777 / 777 / 77..
C        BIMSK4(3) = / 777 / 777 / 000 / 777 / 77..
C        BIMSK4(4) = / 777 / 777 / 777 / 000 / 77..
C
C        BIMSK5(1) = / 377 / 777 / 777 / 777 / 00..
C        BIMSK5(2) = / 377 / 777 / 777 / 000 / 00..
C        BIMSK6    = / 000 / 000 / 000 / 000 / 77..
C
C        IS        = / 400 / 000 / 000 / 000 / 77..
C        MKA       = / 000 / 000 / 000 / 777 / 77..
C        MASK      = 4TH OR 10TH BYTE IS /777/, ZERO FILLED
C        BLANK     = 4TH OR 10TH BYTE IS BLANK, ZERO FILLED
C
C     ARRAY BKMSK1 IS SAME AS KBMSK1 EXCEPT THAT THE DOLLARS ARE
C     REPLACED BY BINARY ZEROS
C     SIMILARY, THE BLANKS IN ISTR,ISTRL,IPLS,IDOLLR,ISLSH, AND ARRAY
C     CON ARE ALSO REPLACED BY BINARY ZEROS.
C     ICON1 AND ICON2 ARE LEFT ADJUSTED CON(1) AND CON(2), ZERO FILLED.
C
C     THIS ROUTINE POSITIONS ITAPE4 TO THE PROPER CONTINUATION RECORD
C
      DEC  = MACH.EQ.5 .OR. MACH.EQ.6 .OR. MACH.EQ.21
      IF (INEW .NE. 1) GO TO 10
      CALL REWIND (ITAPE4)
      IOLD = 2
      RETURN
C
   10 IDIF = INEW - IOLD
      IF (IDIF) 50,20,30
   20 IOLD = INEW + 1
      RETURN
C
   30 DO 40 I = 1,IDIF
      CALL FWDREC (*65,ITAPE4)
   40 CONTINUE
      GO TO 20
   50 IDIF = IABS(IDIF)
      DO 60 I = 1,IDIF
      CALL BCKREC (ITAPE4)
   60 CONTINUE
      GO TO 20
   65 WRITE  (OUTTAP,66) SFM
   66 FORMAT (A25,' 217, ILLEGAL EOF ON ITAPE4.')
      CALL MESAGE (-37,0,NRECPS)
      RETURN
C
C     INITIALIZES BCD CONSTANTS FOR USE WITHIN SORT
C
      ENTRY INITCO
C     ============
C
C     INITIALIZE (CREATE) BINARY CHARACTER MASKS
C
      DEC       = MACH.EQ.5 .OR. MACH.EQ.6 .OR. MACH.EQ.21
      SHIFTS(1) = 0
      SHIFTS(2) = NBPC
      SHIFTS(3) = NBPC*2
      SHIFTS(4) = NBPC*3
      MBITS     = COMPLF(0)
      SFTM      = (NCPW-4)*NBPC
      MBIT4     = LSHIFT(MBITS,SFTM)
      BIMSK1(1) = LSHIFT(MBIT4,NBPC)
      BIMSK1(2) = LSHIFT(BIMSK1(1),NBPC)
      BIMSK1(3) = LSHIFT(BIMSK1(2),NBPC)
      BIMSK1(4) = RSHIFT(BIMSK1(3),NBPC*3)
      BIMSK1(5) = RSHIFT(BIMSK1(2),NBPC*2)
      BIMSK1(6) = RSHIFT(BIMSK1(1),NBPC)
      BIMSK2(1) = MBITS
      BIMSK2(2) = COMPLF(BIMSK1(4))
      BIMSK2(3) = COMPLF(BIMSK1(5))
      BIMSK2(4) = COMPLF(BIMSK1(6))
      BIMSK2(5) = RSHIFT(MBITS,NBPC*4)
      BIMSK3(4) = BIMSK1(4)
      BIMSK3(3) = LSHIFT(BIMSK3(4),NBPC)
      BIMSK3(2) = LSHIFT(BIMSK3(3),NBPC)
      BIMSK3(1) = BIMSK1(3)
      BIMSK4(1) = COMPLF(BIMSK3(1))
      BIMSK4(2) = COMPLF(BIMSK3(2))
      BIMSK4(3) = COMPLF(BIMSK3(3))
      BIMSK4(4) = COMPLF(BIMSK3(4))
      BIMSK5(1) = RSHIFT(BIMSK2(1),1)
      BIMSK5(2) = RSHIFT(LSHIFT(BIMSK2(2),1),1)
      BIMSK6    = BIMSK2(5)
      IF (MACH.EQ.2 .OR. DEC) BIMSK2(1) = BIMSK5(1)
C
C     NEXT CARD FOR UNIVAC ASCII VERSION ONLY (NOT FORTRAN 5)
C
      IF (MACH .EQ. 3) BIMSK2(1) = BIMSK5(1)
      MASK  = RSHIFT(BIMSK3(4),SFTM)
      BLANK = RSHIFT(KBMSK1(8),(3*NBPC+SFTM))
      IS    = COMPLF(BIMSK5(1))
      MKA   = ORF(BIMSK3(4),BIMSK6)
C
C     INITIALIZE THE BCD BLANK DATA
C
      IF (DEC) GO TO 92
C
C     IBM, CDC, UNIVAC
C
      BKMSK1(1) = KBMSK1(1)
      BKMSK1(2) = ANDF(KBMSK1(2),BIMSK2(2))
      BKMSK1(3) = ANDF(KBMSK1(3),BIMSK2(3))
      BKMSK1(4) = ANDF(KBMSK1(4),BIMSK2(4))
      BKMSK1(5) = ANDF(KBMSK1(5),ORF(BIMSK1(4),BIMSK6))
      BKMSK1(6) = ANDF(KBMSK1(6),ORF(BIMSK1(5),BIMSK6))
      BKMSK1(7) = ANDF(KBMSK1(7),ORF(BIMSK1(6),BIMSK6))
      BKMSK1(8) = KBMSK1(8)
      BKMSK2    = ANDF(BKMSK1(1),BIMSK6)
      STAR      = ANDF(ISTR  ,ORF(BIMSK1(4),BIMSK6))
      PLUS      = ANDF(IPLS  ,BIMSK2(4))
      DOLLAR    = ANDF(IDOLLR,BIMSK2(4))
      STARL     = ANDF(ISTRL ,BIMSK2(4))
      SLASH     = ANDF(ISLSH ,BIMSK2(4))
      DO 90 I = 1,38
   90 CON(I) = ANDF(CON(I),BIMSK3(4))
      ICON1  = LSHIFT(CON(1),SFT(4)-1)
      ICON2  = LSHIFT(CON(2),SFT(4)-1)
      RETURN
C
C     VAX
C
   92 BKMSK2    = 0
      BKMSK1(1) = KBMSK1(1)
      BKMSK1(2) = KHRFN3(BKMSK2,KBMSK1(2),-1,1)
      BKMSK1(3) = KHRFN3(BKMSK2,KBMSK1(3),-2,1)
      BKMSK1(4) = KHRFN3(BKMSK2,KBMSK1(4),-3,1)
      BKMSK1(5) = KHRFN3(BKMSK2,KBMSK1(5),-3,0)
      BKMSK1(6) = KHRFN3(BKMSK2,KBMSK1(6),-2,0)
      BKMSK1(7) = KHRFN3(BKMSK2,KBMSK1(7),-1,0)
      BKMSK1(8) = KBMSK1(8)
      STAR      = KHRFN1(BKMSK2,4,ISTR  ,4)
      PLUS      = KHRFN1(BKMSK2,1,IPLS  ,1)
      DOLLAR    = KHRFN1(BKMSK2,1,IDOLLR,1)
      STARL     = KHRFN1(BKMSK2,1,ISTRL ,1)
      SLASH     = KHRFN1(BKMSK2,1,ISLSH ,1)
      DO 95 I = 1,38
   95 CON(I) = KHRFN1(BKMSK2,4,CON(I),4)
      ICON1  = RSHIFT(KHRFN1(BKMSK2,1,CON(1),4),1)
      ICON2  = RSHIFT(KHRFN1(BKMSK2,1,CON(2),4),1)
      RETURN
C
C
      ENTRY XFADJ (BF,SD,KK)
C     ======================
C
C     DATA SFT /0,6,12,18/
C     DATA MK  /O770000000000,O007700000000,O000077000000,O000000770000/
C
      DEC = MACH.EQ.5 .OR. MACH.EQ.6 .OR. MACH.EQ.21
      II  = 2
      IF (SD .EQ. 1) II = 4
      DO 400 I = 1,II
      BFI = BF(I)
      DO 300 J = 1,4
      JI  = 5 - J
      IF (.NOT.DEC) TEST = RSHIFT(ANDF(BFI,MK(J)),SFT(JI))
      IF (     DEC) TEST = KHRFN1(BKMSK2,4,BFI,J)
      DO 100 K = 1,11
      IF (TEST .EQ. CON(K)) GO TO 200
  100 CONTINUE
C
C     CHARACTER NON-INTEGER
C
      CALL XFADJ1 (BF,LSHIFT,SD)
      KK = 1
      RETURN
C
  200 IF (K .EQ. 1) GO TO 300
C
C     CHARACTER INTEGER
C
      CALL XFADJ1 (BF,RSHIFT,SD)
      KK = 0
      RETURN
C
  300 CONTINUE
  400 CONTINUE
C
C     ALL FIELDS BLANK
C
      KK = 0
      RETURN
C
C
      ENTRY XBCDBI (BA)
C     =================
C
C     DATA SFT1/6/,SFTM/12/,MASK/O77/,BLANK/O60/
C
C     IF MACHINE IS VAX-11/780, ORDER OF CHARACTERS IN A WORD IS REVERSE
C     OF THAT ON OTHER MACHINES.  THE CHARACTER ORDER MUST THEREFORE BE
C     REVERSED BEFORE DECODING TO AN INTEGER VALUE.
C
      DEC = MACH.EQ.5 .OR. MACH.EQ.6 .OR. MACH.EQ.21
      IF (.NOT.DEC) GO TO 430
      DO 420 IBA = 1,2
      ITEMP = 0
      DO 410 IVAX = 1,4
      JTEMP = RSHIFT(BA(IBA),8*(IVAX-1))
      JTEMP = ANDF(MASK,JTEMP)
      JTEMP = LSHIFT(JTEMP,8*(4-IVAX))
      ITEMP = ORF(ITEMP,JTEMP)
  410 CONTINUE
      BA(IBA) = ITEMP
  420 CONTINUE
C
  430 CONTINUE
      BA(1) = RSHIFT(BA(1),SFTM)
      BA(2) = RSHIFT(BA(2),SFTM)
      IVAR  = ANDF(BA(2),MASK)
      IF (IVAR .NE. BLANK) GO TO 490
      BA(2) = 0
      RETURN
C
  490 IF (MACH .EQ. 4) IVAR = IVAR - 27
      IVAR  = ANDF(IVAR,15)
      DO 500 I = 1,3
      BA(2) = RSHIFT(BA(2),SFT1)
      ICHAR = ANDF(BA(2),MASK)
      IF (MACH .EQ. 4) ICHAR = ICHAR - 27
  500 IVAR  = IVAR + C10C(I)*ANDF(15,ICHAR)
      ICHAR = ANDF(BA(1),MASK)
      IF (MACH .EQ. 4) ICHAR = ICHAR - 27
      IVAR  = IVAR + C10C(4)*ANDF(15,ICHAR)
      DO 510 I = 5,7
      BA(1) = RSHIFT(BA(1),SFT1)
      ICHAR = ANDF(BA(1),MASK)
      IF (MACH .EQ. 4) ICHAR = ICHAR - 27
  510 IVAR  = IVAR + C10C(I)*ANDF(15,ICHAR)
      BA(2) = IVAR
      RETURN
C
C
      ENTRY XPRETY (BFF)
C     ==================
C
C     DATA  MKA/O000000777777/, STAR/4H000*/
C
      DEC = MACH.EQ.5 .OR. MACH.EQ.6 .OR. MACH.EQ.21
      IF (.NOT.DEC) ITST = ANDF(MKA,BFF(2))
      IF (     DEC) ITST = KHRFN1(BKMSK2,4,BFF(2),4)
      IF (ITST .EQ. STAR) GO TO 610
      DO 600 I = 3,17,2
      IF (BFF(I).EQ.BKMSK1(8) .AND. BFF(I+1).EQ.BKMSK1(8)) GO TO 600
      CALL XFADJ1 (BFF(I),LSHIFT,0)
      IF (BFF(I) .EQ. KPRET1) BFF(I) = KPRET2
      IF (BFF(I) .NE. BKMSK1(8)) GO TO 600
      IF (.NOT.DEC) BFF(I) = ORF(RSHIFT(BFF(I),SFT(2)),BKMSK1(4))
      IF (     DEC) BFF(I) = KHRFN3(IZERO,BFF(I),1,0)
  600 CONTINUE
      RETURN
C
  610 DO 620 I = 3,15,4
      IF (BFF(I).EQ.BKMSK1(8) .AND. BFF(I+1).EQ.BKMSK1(8) .AND.
     1    BFF(I+2).EQ.BKMSK1(8) .AND. BFF(I+3).EQ.BKMSK1(8)) GO TO 620
      CALL XFADJ1 (BFF(I),LSHIFT,1)
      IF (BFF(I) .EQ. KPRET1) BFF(I) = KPRET2
      IF (BFF(I) .NE. BKMSK1(8)) GO TO 620
      IF (.NOT.DEC) BFF(I) = ORF(RSHIFT(BFF(I),SFT(2)),BKMSK1(4))
      IF (     DEC) BFF(I) = KHRFN3(IZERO,BFF(I),1,0)
  620 CONTINUE
      RETURN
C
C
      ENTRY CRDFLG (CARD)
C     ===================
C
      DEC    = MACH.EQ.5 .OR. MACH.EQ.6 .OR. MACH.EQ.21
      INWRDI = CARD(1)
      KARD2  = CARD(2)
      KBRN   = -1
      ASSIGN 640 TO IRET
      GO TO 770
  640 IF (.NOT.DEC) KARD2 = ORF(ANDF(BIMSK1(1),KARD2),BKMSK1(5))
      IF (     DEC) KARD2 = KHRFN1(KARD2,4,BKMSK1(8),4)
      IF (KARD1.NE.PAR1 .OR. KARD2.NE.PAR2) GO TO 645
      KARD1 = CARD(3)
      KARD2 = CARD(4)
  645 LMT   = NUM* 2
      DO 650 I = 1,LMT,2
      IF (KARD1.EQ.ICARDS(I) .AND. KARD2.EQ.ICARDS(I+1)) GO TO 660
  650 CONTINUE
      RETURN
C
  660 J = I/2
      ICYCL = (J/31) + 1
      IPOS  = MOD(J,31) + 2
      IBITS(ICYCL) = ORF(IBITS(ICYCL),ITWO(IPOS))
      RETURN
C
C
      ENTRY EXTINT (EXTWRD)
C     =====================
C
      DEC = MACH.EQ.5 .OR. MACH.EQ.6 .OR. MACH.EQ.21
      DO 750 I = 1,2
      EXWRDI = EXTWRD(I)
      DO 730 J = 1,4
      JI = 5 - J
      SFTJI = SFT(JI)
      IF (.NOT.DEC) TEST = RSHIFT(ANDF(EXWRDI,MK(J)),SFTJI)
      IF (     DEC) TEST = KHRFN1(BKMSK2,4,EXWRDI,J)
      DO 710 K = 1,37
      IF (TEST .EQ. EXTAB(K)) GO TO 720
  710 CONTINUE
      K = 1
      GO TO 740
  720 IF (.NOT.DEC)
     1   EXWRDI = ORF(ANDF(EXWRDI,BIMSK4(J)),LSHIFT(K,SFTJI+SFTM))
      IF (DEC) EXWRDI = KHRFN1(EXWRDI,J,K,-1)
      IF (K .EQ. 1) GO TO 740
  730 CONTINUE
  740 EXTWRD(I) = EXWRDI
      IF (K .EQ. 1) RETURN
  750 CONTINUE
      RETURN
C
C
      ENTRY INTEXT (INTWRD)
C     =====================
C
      DEC    = MACH.EQ.5 .OR. MACH.EQ.6 .OR. MACH.EQ.21
      ASSIGN 800 TO IRET
      INWRDI = INTWRD(1)
      KBRN   = 0
  770 DO 780 J = 1,4
      JI     = 5 - J
      SFTJI  = SFT(JI)
      IF (.NOT.DEC) TEST = RSHIFT(ANDF(INWRDI,MK(J)),SFTJI+SFTM)
      IF (     DEC) TEST = KHRFN1(BKMSK2,-1,INWRDI,J)
      IF (TEST .GT. 37) GO TO 781
      IF (.NOT.DEC)
     1   INWRDI = ORF(ANDF(INWRDI,BIMSK4(J)),LSHIFT(EXTAB(TEST),SFTJI))
      IF (DEC) INWRDI = KHRFN1(INWRDI,J,EXTAB(TEST),4)
      IF (TEST .EQ. 1) GO TO 781
  780 CONTINUE
  781 IF (KBRN) 782,784,786
  782 KARD1  = INWRDI
      INWRDI = CARD(2)
      KBRN   = +2
      GO TO 810
  784 INTWRD(1) = INWRDI
      INWRDI = INTWRD(2)
      KBRN = +1
      GO TO 810
  786 IF (KBRN .EQ. 1) GO TO 788
      KARD2 = INWRDI
      GO TO 790
  788 INTWRD(2) = INWRDI
  790 GO TO IRET, (800,640)
  800 RETURN
C
  810 IF (TEST.EQ.1 .OR. TEST.GT.37) GO TO 790
      GO TO 770
C
      END

      SUBROUTINE DSTROY (NAME,ITEST,IMAGE,IMORE,LIM)
C
C     DESTROYS THE SUBSTRUCTURE NAME BY DELETING ITS DIRECTORY FROM THE
C     MDI AND ITS NAME FROM THE DIT.  NO OPERATION WILL TAKE PLACE IF
C     NAME IS AN IMAGE SUBSTRUCTURE.  IF NAME IS A SECONDARY SUBSTRUC-
C     TURE, IT IS DELETED FROM THE LIST OF SECONDARY SUBSTRUCTURES TO
C     WHICH IT BELONGS, AND ITS IMAGE CONTRIBUTING TREE IS DESTROYED.
C     IF NAME IS A PRIMARY SUBSTRUCTURE, ALL ITS SECONDARY SUBSTRUCTURES
C     ARE ALSO DESTROYED.  IN ALL CASES, ALL THE SUBSTRUCTURES DERIVED
C     FROM THE SUBSTRUCTURE BEING DESTROYED ARE ALSO DESTROYED, AND
C     CONNECTIONS WITH OTHER SUBSTRUCTURES ARE DELETED.
C
C     THE BLOCKS OCCUPIED BY THE ITEM ARE RETURNED TO THE LIST OF FREE
C     BLOCKS IF THEY BELONG TO THE SPECIFIED SUBSTRUCTURE
C
C     THE OUTPUT VARIABLE ITEST TAKES ONE OF THE FOLLOWING VALUES.
C        1  NORMAL RETURN
C        4  IF NAME DOES NOT EXIST
C        6  IF NAME IS AN IMAGE SUBSTRUCTURE
C
      EXTERNAL        LSHIFT,RSHIFT,ANDF,ORF,COMPLF
      LOGICAL         DITUP,MDIUP
      INTEGER         BUF,DIT,DITPBN,DITLBN,DITSIZ,DITNSB,DITBL,
     1                MDI,MDIPBN,MDILBN,MDIBL,BLKSIZ,DIRSIZ,PS,SS,IS,
     2                LL,CS,HL,ANDF,ORF,RSHIFT,COMPLF
      DIMENSION       NAME(2),IMAGE(1),IMORE(1),NMSBR(2)
      COMMON /ZZZZZZ/ BUF(1)
      COMMON /SOF   / DIT,DITPBN,DITLBN,DITSIZ,DITNSB,DITBL,
     1                IODUM(8),MDI,MDIPBN,MDILBN,MDIBL,
     2                NXTDUM(15),DITUP,MDIUP
      COMMON /SYS   / BLKSIZ,DIRSIZ,SYS(3),IFRST
      COMMON /ITEMDT/ NITEM,ITEM(7,1)
      DATA    PS,SS,  IS,LL,CS,HL / 1,1,1,2,2,2    /
      DATA    IEMPTY/ 4H    /
      DATA    INDSBR/ 3     /, NMSBR /4HDSTR,4HOY  /
C
      CALL CHKOPN (NMSBR(1))
      ITEST = 1
      ITOP  = 0
      IMTOP = 0
      CALL FDSUB (NAME(1),INDEX)
      IF (INDEX .EQ. -1) GO TO 1000
      MASKM = COMPLF(LSHIFT(1023,10))
      MASKL = COMPLF(LSHIFT(1023,20))
C                           1023 = 2**10 - 1
C
C     SAVE ALL CONNECTIONS WITH OTHER SUBSTRUCTURES.
C
   10 CALL FMDI (INDEX,IMDI)
   20 I     = BUF(IMDI+PS)
      INDPS = ANDF(I,1023)
      INDSS = RSHIFT(ANDF(I,1048575),10)
C                           1048575 = 2**20 - 1
      INDIS = ANDF(I,1073741824)
C                    1073741824 = 2**30
      I     = BUF(IMDI+LL)
      INDHL = ANDF(I,1023)
      INDCS = RSHIFT(ANDF(I,1048575),10)
      INDLL = RSHIFT(ANDF(I,1073741823),20)
C                           1073741823 = 2**30 - 1
      IF (INDIS .GT. 0) GO TO 1010
      IF (INDPS .EQ. 0) GO TO 60
      ASSIGN 30 TO IRET1
      GO TO 300
C
C     REMOVE INDEX FROM THE LIST OF SUBSTRUCTURES THAT ARE SECONDARY TO
C     INDPS.
C
   30 ISAVE = INDPS
   40 CALL FMDI (ISAVE,IMDI)
      ISAVE = RSHIFT(ANDF(BUF(IMDI+SS),1048575),10)
      IF (ISAVE .EQ. 0) GO TO 50
      IF (ISAVE .NE. INDEX) GO TO 40
      BUF(IMDI+SS) = ORF(ANDF(BUF(IMDI+SS),MASKM),LSHIFT(INDSS,10))
      MDIUP = .TRUE.
      IF (INDLL .EQ. 0) GO TO 120
      ILL   = INDLL
      INDLL = 0
      ISAVE = INDEX
   50 ASSIGN 120 TO IRET2
      GO TO 330
C
C     PRIMARY SUBSTRUCTURE.
C     RETURN THE BLOCKS USED BY ALL ITEMS TO THE LIST OF FREE BLOCKS.
C
   60 DO 70 J = IFRST,DIRSIZ
      IBL = ANDF(BUF(IMDI+J),65535)
C                            65535 = 2**16 - 1
      IF (IBL.GT.0 .AND. IBL.NE.65535) CALL RETBLK (IBL)
   70 CONTINUE
      IF (INDSS .EQ. 0) GO TO 130
C
C     THE PRIMARY SUBSTRUCTURE BEING DESTROYED HAS SECONDARY EQUIVALENT
C     SUBSTRUCTURES.  MUST DESTROY ALL OF THEM.
C
      ASSIGN 320 TO IRET1
      ASSIGN 90  TO IRET2
      ISV   = INDSS
   80 ISAVE = ISV
      CALL FMDI (ISAVE,IMDI)
      ISV = RSHIFT(ANDF(BUF(IMDI+SS),1048575),10)
      IIS = ANDF(BUF(IMDI+IS),1073741824)
      IF (IIS .GT. 0) GO TO 110
C
C     THE SECONDARY SUBSTRUCTURE IS NOT AN IMAGE SUBSTRUCTURE.  ADD ITS
C     INDEX TO THE LIST (IMORE) OF SUBSTRUCTURES TO BE DESTROYED LATER.
C
      ITOP = ITOP + 1
      IF (ITOP .GT. LIM) GO TO 1030
      IMORE(ITOP) = ISAVE
      GO TO 300
C
C     UPDATE THE MDI OF THE SECONDARY SUBSTRUCTURE WITH INDEX ISAVE.
C
   90 CALL FMDI (ISAVE,IMDI)
      BUF(IMDI+PS) = 0
      BUF(IMDI+LL) = ANDF(BUF(IMDI+LL),MASKL)
      DO 100 J = IFRST,DIRSIZ
      BUF(IMDI+J) = 0
  100 CONTINUE
      MDIUP = .TRUE.
  110 IF (ISV .NE. 0) GO TO 80
C
C     BACK TO THE SUBSTRUCTURE WITH INDEX  INDEX .
C     DELETE ITS DIRECTORY FROM THE MDI.
C
  120 CALL FMDI (INDEX,IMDI)
  130 DO 140 J = 1,DIRSIZ
      BUF(IMDI+J) = 0
  140 CONTINUE
      MDIUP = .TRUE.
C
C     DELETE SUBSTRUCTURE NAME FROM THE DIT.
C
      CALL FDIT (INDEX,JDIT)
      BUF(JDIT  ) = IEMPTY
      BUF(JDIT+1) = IEMPTY
      DITUP = .TRUE.
      IF (INDEX*2 .NE. DITSIZ) GO TO 150
      DITSIZ = DITSIZ - 2
  150 DITNSB = DITNSB - 1
      IF (INDCS .EQ. 0) GO TO 180
C
C     DELETE LINK THROUGH COMBINED SUBSTRUCTURES, AND REMOVE ITEMS
C     CREATED AS A RESULTS OF THE COMBINE OR REDUCE.
C     THESE ITEMS WILL BE RETURNED TO THE LIST OF FREE BLOCKS.
C
  160 IF (INDCS .EQ. INDEX) GO TO 180
      CALL FMDI (INDCS,IMDI)
      INDCS = RSHIFT(ANDF(BUF(IMDI+CS),1048575),10)
  173 BUF(IMDI+HL) = ANDF(BUF(IMDI+HL),COMPLF(1023))
      BUF(IMDI+CS) = ANDF(BUF(IMDI+CS),MASKM)
      DO 176 J = 1,NITEM
      IF (ITEM(6,J) .EQ. 0) GO TO 176
      ITM = J + IFRST - 1
      IBL = ANDF(BUF(IMDI+ITM),65535)
      IF (IBL.GT.0 .AND. IBL.NE.65535) CALL RETBLK (IBL)
      BUF(IMDI+ITM) = 0
  176 CONTINUE
      MDIUP = .TRUE.
      IF (INDCS .EQ. 0) GO TO 1020
      GO TO 160
  180 IF (INDLL .EQ. 0) GO TO 190
C
C     SUBSTRUCTURE WAS THE RESULT OF COMBINING LOWER LEVEL SUBSTRUCTURES
C     TOGETHER.  UPDATE THE MDI ACCORDINGLY.
C
      CALL FMDI (INDLL,IMDI)
      INDCS = RSHIFT(ANDF(BUF(IMDI+CS),1048575),10)
      INDEX = INDLL
      INDLL = 0
      IF (INDCS .EQ. 0) INDCS = INDEX
      GO TO 173
  190 IF (INDHL .EQ. 0) GO TO 220
C
C     A HIGHER LEVEL SUBSTRUCTURE WAS DERIVED FROM THE ONE BEING
C     DESTROYED. DESTROY THE HIGHER LEVEL SUBSTRUCTURE.
C
      INDEX = INDHL
      CALL FMDI (INDEX,IMDI)
      BUF(IMDI+LL) = ANDF(BUF(IMDI+LL),MASKL)
      MDIUP = .TRUE.
      GO TO 20
  220 IF (ITOP .EQ. 0) RETURN
C
C     MORE SUBSTRUCTURES TO DESTROY.
C
      INDEX = IMORE(ITOP)
      ITOP  = ITOP - 1
      GO TO 10
C
C     INTERNAL SUBROUTINE.
C     RETURN TO THE LIST OF FREE BLOCKS THE BLOCKS USED BY A
C     SECONDARY SUBSTRUCTURE.
C     THESE BLOCKS INCLUDE THE FOLLOWING ITEMS
C
C     ITEMS COPIED DURING A EQUIV OPERATION
C     SOLUTION ITEMS
C     ITEMS PRODUCED BY A COMBINE OR REDUCE OPERATION
C
  300 DO 310 J = 1,NITEM
      IF (ITEM(5,J) .EQ. 0) GO TO 310
      ITM = J + IFRST - 1
      IBL = ANDF(BUF(IMDI+ITM),65535)
      IF (IBL.GT.0 .AND. IBL.NE.65535) CALL RETBLK (IBL)
      BUF(IMDI+ITM) = 0
  310 CONTINUE
      GO TO IRET1, (30,320)
C
C     INTERNAL SUBROUTINE.
C     BUILD A LIST IMAGE OF ALL THE IMAGE SUBSTRUCTURES CONTRIBUTING TO
C     THE SECONDARY SUBSTRUCTURE WITH INDEX ISAVE, AND DELETE EACH IMAGE
C     SUBSTRUCTURE FROM THE LIST OF SECONDARY SUBSTRUCTURES TO WHICH IT
C     BELONGS.
C
  320 CALL FMDI (ISAVE,IMDI)
      ILL = RSHIFT(ANDF(BUF(IMDI+LL),1073741823),20)
      IF (ILL .EQ. 0) GO TO IRET2, (90,120)
  330 IMTOP = 1
      IMAGE(IMTOP) = ILL
      ICOUNT = 1
      IHERE  = IMAGE(ICOUNT)
  350 CALL FMDI (IHERE,IMDI)
      I   = BUF(IMDI+PS)
      IPS = ANDF(I,1023)
      ISS = RSHIFT(ANDF(I,1048575),10)
      IIS = ANDF(I,1073741824)
      I   = BUF(IMDI+LL)
      ILL = RSHIFT(ANDF(I,1073741823),20)
      ICS = RSHIFT(ANDF(I,1048575),10)
      IF (IIS .EQ. 0) GO TO 1010
C
C     DELETE THE SUBSTRUCTURE WITH INDEX IHERE FROM THE MDI AND THE DIT.
C     RETURN THE BLOCKS USED BY THE IMAGE SUBSTRUCTURE TO THE LIST OF
C     FREE BLOCKS.  THIS INCLUDES THE FOLLOWING ITEMS
C
C     ITEMS COPIED DURING A EQUIV OPERATION
C     SOLUTION ITEMS
C
      DO 355 J = 1,NITEM
      IF (ITEM(4,J) .EQ. 0) GO TO 355
      ITM = J + IFRST - 1
      IBL = ANDF(BUF(IMDI+ITM),65535)
      IF (IBL.GT.0 .AND. IBL.NE.65535) CALL RETBLK (IBL)
      BUF(IMDI+ITM) = 0
  355 CONTINUE
      DO 360 J = 1,DIRSIZ
      BUF(IMDI+J) = 0
  360 CONTINUE
      MDIUP = .TRUE.
      CALL FDIT (IHERE,IDIT)
      BUF(IDIT  ) = IEMPTY
      BUF(IDIT+1) = IEMPTY
      DITUP = .TRUE.
      IF (IHERE*2 .NE. DITSIZ) GO TO 370
      DITSIZ = DITSIZ - 2
  370 DITNSB = DITNSB - 1
C
C     DELETE POINTERS TO IHERE.
C
      ICHECK = IPS
  380 CALL FMDI (ICHECK,IMDI)
      ICHECK = RSHIFT(ANDF(BUF(IMDI+SS),1048575),10)
      IF (ICHECK .EQ. 0) GO TO 390
      IF (ICHECK .NE. IHERE) GO TO 380
      BUF(IMDI+SS) = ORF(ANDF(BUF(IMDI+SS),MASKM),LSHIFT(ISS,10))
      MDIUP = .TRUE.
C
C     ARE THERE MORE SUBSTRUCTURES TO ADD TO THE LIST IMAGE
C
  390 IF (ILL .EQ. 0) GO TO 410
      DO 400 J = 1,IMTOP
      IF (IMAGE(J) .EQ. ILL) GO TO 410
  400 CONTINUE
      IMTOP = IMTOP + 1
      IMAGE(IMTOP) = ILL
  410 IF (ICS .EQ. 0) GO TO 430
      DO 420 J = 1,IMTOP
      IF (IMAGE(J) .EQ. ICS) GO TO 430
  420 CONTINUE
      IMTOP = IMTOP + 1
      IF (IMTOP .GT. LIM) GO TO 1030
      IMAGE(IMTOP) = ICS
C
C     ARE THERE MORE SUBSTRUCTURES ON THE LIST IMAGE
C
  430 IF (ICOUNT .EQ. IMTOP) GO TO IRET2, (90,120)
      ICOUNT = ICOUNT + 1
      IHERE  = IMAGE(ICOUNT)
      GO TO 350
C
C     NAME DOES NOT EXIST.
C
 1000 ITEST = 4
      RETURN
C
C     NAME IS AN IMAGE SUBSTRUCTURE.
C
 1010 ITEST = 6
      RETURN
C
C     ERROR MESSAGES.
C
 1020 CALL ERRMKN (INDSBR,8)
 1030 CALL MESAGE (-8,0,NMSBR)
      RETURN
      END

      SUBROUTINE DCROSS(X,Y,Z)
C
C     DOUBLE PRECISION CROSS PRODUCT
C
      DOUBLE PRECISION        X(3)     ,Y(3)     ,Z(3)
C
      Z(1) = X(2)*Y(3) - X(3)*Y(2)
      Z(2) = Y(1)*X(3) - Y(3)*X(1)
      Z(3) = X(1)*Y(2) - X(2)*Y(1)
      RETURN
      END

      SUBROUTINE SDHTF1 (TYPE,REJECT)
C
C     THIS ROUTINE CONVERTS THE EST DATA FOR ALL THERMAL ELEMENTS TO A
C     COMMON FORMAT. SDHT1B IS CALLED TO PRODUCE THE OUTPUT
C
      LOGICAL         REJECT
      INTEGER         ELID,SUB,SIL,NESTO(100),ELEM,NEST(2),TYPE,
     1                POINTR(8,23),TYPOLD,STRSPT,ESTWDS,NESTSC(200),
     2                POINT1(8,20),POINT2(8, 3),TUBE,FTUBE,CHBDY
      DIMENSION       SHP(32),DSHP(3,32),XJACOB(3,3),BXYZ(3,32),GPT(32)
      COMMON /CONDAS/ CONSTS(5)
      COMMON /SDR2X4/ DUMX(109),STRSPT,DDRMM,ISOPL8
      COMMON /SDR2X5/ EST(100),ELID,SIL(32),NQ,NP,NAME(2),DOMX(105),
     1                DSHPB(3,32)
      COMMON /SDR2X6/ SUB,IMAT,AF,THETA,R(3,32),ESTSCR(200)
      COMMON /GPTA1 / NELS,LAST,INCR,ELEM(1)
      COMMON /MATIN / MATID,INFLAG,ELTEMP,DUM(1),SINTH,COSTH
      EQUIVALENCE     (CONSTS(1),PI),(NESTSC(1),ESTSCR(1)),
     1                (NESTO(1),SUB),(NEST(1),EST(1)),
     2                (POINT1(1,1),POINTR(1,1)),
     3                (POINT2(1,1),POINTR(1,21))
      DATA    TYPOLD, NUMELT, TUBE, FTUBE, CHBDY /
     1             0,     23,    3,    82,    52 /
C     DATA    HEX   / 16    /
C
C     THE POINTERS TO THE EST DATA ARE
C
C        IM    MAT ID
C        ITH   THETA
C        IA    AREA
C        IG    GRID POINT DATA
C        IS    SIL MINUS 1
C        NP    NO. OF POINTS
C        SUB   SUBROUTINE TYPE
C                       NO.  IS   ITH  IM   IA   IG   NP   SUB
C                      ----  --   ---  --   --   --   --   ----
      DATA   POINT1 /    1   ,0   ,0   ,4   ,5   ,9   ,2   ,1
     2                  ,3   ,0   ,0   ,4   ,5   ,8   ,2   ,1
     3                  ,6   ,0   ,5   ,6   ,7   ,15  ,3   ,2
     4                  ,9   ,0   ,5   ,6   ,7   ,9   ,3   ,2
     5                  ,10  ,0   ,0   ,4   ,5   ,9   ,2   ,1
     6                  ,16  ,0   ,6   ,7   ,8   ,10  ,4   ,3
     7                  ,17  ,0   ,5   ,6   ,7   ,9   ,3   ,2
     8                  ,18  ,0   ,6   ,7   ,8   ,10  ,4   ,3
     9                  ,19  ,0   ,6   ,7   ,8   ,16  ,4   ,3
     T                  ,34  ,0   ,0   ,16  ,17  ,34  ,2   ,1
     1                  ,36  ,0   ,5   ,6   ,0   ,7   ,3   ,4
     2                  ,37  ,0   ,6   ,7   ,0   ,8   ,4   ,5
     3                  ,39  ,1   ,0   ,2   ,0   ,7   ,4   ,6
     4                  ,40  ,1   ,0   ,2   ,0   ,9   ,6   ,7
     5                  ,41  ,1   ,0   ,2   ,0   ,11  ,8   ,8
     6                  ,42  ,1   ,0   ,2   ,0   ,11  ,8   ,9
     7                  ,52  ,1   ,0   ,15  ,16  ,21  ,8   ,10
     8                  ,62  ,0   ,6   ,7   ,8   ,10  ,4   ,3
     9                  ,63  ,0   ,6   ,7   ,8   ,10  ,4   ,3
     T                  ,65  ,0   ,0   ,10  ,0   ,16  ,8   ,16 /
      DATA   POINT2 /    66  ,0   ,0   ,22  ,0   ,28  ,20  ,16
     2                  ,67  ,0   ,0   ,34  ,0   ,40  ,32  ,16
     3                  ,76  ,0   ,11  ,12  ,13  ,14  ,8   ,17 /
C
      IF (TYPE .EQ.  FTUBE) GO TO 115
      IF (TYPE .EQ. TYPOLD) GO TO 50
      TYPOLD = TYPE
      REJECT = .TRUE.
      DO 20 I = 1,NUMELT
      IEL = I
      IF (TYPE-POINTR(1,I)) 30,40,20
   20 CONTINUE
   30 RETURN
C
   40 REJECT = .FALSE.
   50 IF ((TYPE.GE.65.AND.TYPE.LE.67) .AND. STRSPT.EQ.0)
     1     STRSPT = STRSPT + 1
      IP = (TYPE-1)*INCR
      ESTWDS = ELEM(IP+12)
C
C     THE LOCATIONS OF DATA FOR EACH PARTICULAR ELEMENT ARE ZEROED OUT
C
      NQ = 0
      DO 55 I = 1,100
   55 NESTO(I) = 0
      NAME(1) = ELEM(IP+1)
      NAME(2) = ELEM(IP+2)
      ELID = NEST(1)
      DO 56 I = 1,32
   56 NEST(I+101) = 0
      DO 57 I = 1,201
   57 NEST(I+137) = 0
      IF (TYPE .EQ. TUBE) EST(5) = PI*ESTSCR(6)*(ESTSCR(5)-ESTSCR(6))
      IF (TYPE.EQ.CHBDY .AND. NESTSC(2).EQ.7)
     1   EST(16) = PI*(ESTSCR(19)+ESTSCR(20))
      IS  = POINTR(2,IEL)
      ITH = POINTR(3,IEL)
      IM  = POINTR(4,IEL)
      IA  = POINTR(5,IEL)
      IG  = POINTR(6,IEL)
      SUB = POINTR(8,IEL)
      NP  = POINTR(7,IEL)
C
      IF (SUB .EQ. 10) SUB = SUB + NESTSC(2) - 1
      INFLAG = 1
      IF (SUB.GE.16) INFLAG = 3
      IF (SUB.LT.2 .OR. SUB.GT.5) GO TO 60
      INFLAG = 2
      GO TO 70
   60 IF (SUB.LT.6 .OR. SUB.GT.9) GO TO 70
      INFLAG = 3
   70 CONTINUE
      IF (SUB .NE. 16) GO TO 79
C
C     GET SHAPE FUNCTIONS ETC. FOR STRESS POINT(ALSO DETERMINE THE
C     STRESS POINT, WHICH WILL BE THE GRID POINTS PLUS CENTROID IN
C     ELEMENT COORDINATES
C
      ITYPE = TYPE - 64
      DO 71 I = 1,NP
      GPT(I) = ESTSCR(5*NP+7+I)
      DO 71 J = 1,3
      BXYZ(J,I) = ESTSCR(NP+4+4*I+J)
   71 CONTINUE
C
C     GET STRESS POINT
C
      Y =-1.
      Z =-1.
      IF (ITYPE .GT. 1) GO TO 502
      D = 2.
      X = 1.
      GO TO 505
  502 D = 1.
      X = 0.
  505 IF (ITYPE .GT. 1) GO TO 560
      GO TO (510,520,530,510,540,520,530,510,550), STRSPT
  510 X = X - D
      GO TO 590
  520 X = X + D
      GO TO 590
  530 Y = Y + D
      GO TO 590
  540 Z = Z + D
      Y = -1.
      GO TO 590
  550 X = 0.
      Y = 0.
      Z = 0.
      GO TO 590
  560 GO TO (510,520,520,530,530,510,510,570,580,520,
     1       530,510,580,520,520,530,530,510,510,570,
     2       550), STRSPT
  570 Y = Y - D
      GO TO 590
  580 Z = Z + 1.
      Y = -1.
      D = 3. - D
  590 CALL IHEXSS (ITYPE,SHP,DSHP,XJACOB,DETJ,ELID,X,Y,Z,BXYZ)
C
C     GET DERIVATIVES W.R.T.X,Y,Z(REVERSE CALLING SEQUENCE BECAUSE
C     COLUMN-STORED
C
      CALL GMMATS (DSHP,NP,3,0,XJACOB,3,3,0,DSHPB)
C
   79 CONTINUE
C
      IF (IA .GT. 0) AF = ESTSCR(IA)
      MATID = NESTSC(IM)
      IF (MATID .LE. 0) RETURN
      SINTH = 0.0
      COSTH = 1.0
      IF (INFLAG .NE. 2) GO TO 80
      THETA = ESTSCR(ITH)*PI/180.
      IF (THETA .EQ. 0.0) GO TO 80
      SINTH = SIN(THETA)
      COSTH = COS(THETA)
   80 ITEMP = IG + 4*NP
      ELTEMP= ESTSCR(ITEMP)
      IF (SUB .NE. 16) GO TO 85
      ISOPL8= 8
      ELTEMP= 0.
      DO 82 I = 1,NP
   82 ELTEMP= ELTEMP + GPT(I)*SHP(I)
   85 CONTINUE
      IMAT  = MATID
      CALL HMAT (ELID)
C
      DO 110 I = 1,NP
      IP = 4*(I-1) + IG
      DO 100 J = 1,3
      ILOC = IP + J
  100 R(J,I) = ESTSCR(ILOC)
      ISIL   = IS + I + 1
      SIL(I) = NESTSC(ISIL)
  110 CONTINUE
C
      CALL SDHTFF
      GO TO 120
C
C     FTUBE CONVECTION ELEMENT
C
  115 REJECT =.FALSE.
      I = 0
      NEST(I+101) = NESTSC(1)
      NEST(I+102) = NESTSC(2)
      NEST(I+103) = NESTSC(3)
      EST (I+104) = ESTSCR(4)*ESTSCR(5)
      EST (I+105) = 0.0
C
  120 RETURN
      END

      SUBROUTINE PREMAT (IZ,RZ,BFR,NIMAT,N2MAT,MPTF,DITF)
C
C     REVISED 7/92, BY G.CHAN, NEW REFERENCE TO OPEN CORE ARRAY, SUCH
C     THAT THE SOURCE CODE IS UP TO ANSI FORTRAN 77 STANADARD
C
      LOGICAL         PART1 ,PLA   ,TDEP
      INTEGER         IZ(1) ,BFR(1),DITF  ,QMAT1 ,QMAT2 ,QMATX ,FLAG  ,
     1                MAT1(2)      ,MATT1(2)     ,DIT   ,BUF(3),TEMPID,
     2                NAM(2),BACK  ,RET   ,MAT2(2)      ,MATT2(2)     ,
     3                RET1  ,PASS  ,TABLID,TABLEI(16)   ,MATS1(2)     ,
     4                MAT3(2)      ,MATT3(2)     ,QMAT3 ,QMAT8 ,MAT8(2)
      INTEGER         QMATF ,ELEMID,QMTPZ1,QMTPZ2,QMAT6 ,SYSBUF,MATF(2)
      INTEGER         Z     ,OFFSET
      REAL            NU    ,RZ(1) ,X(27) ,Y(25) ,NUX   ,NUXX  ,J11   ,
     1                J12   ,J22   ,NUXY3 ,NUYZ3 ,NUZX3 ,MATSET,ZZ(1)
      DIMENSION       MATPZ1(2)    ,MATPZ2(2)    ,MTTPZ1(2)    ,
     1                MTTPZ2(2)    ,BUFPZ(51)    ,MAT6(2)      ,
     2                MATT6(2)     ,BUFTM6(39)   ,XY(108)      ,
     3                IB(46)
      COMMON /ZZZZZZ/ Z(1)
      COMMON /SYSTEM/ SYSBUF,NOUT  ,SKP(7),TEMPID
      COMMON /NAMES / RD    ,RDREW ,WRT   ,WRTREW,CLSREW
      COMMON /MATIN / MATID ,INFLAG,TEMP  ,PLAARG,SINTH ,COSTH
      COMMON /MATOUT/ E     ,G     ,NU    ,RHO   ,ALPHA ,TO    ,GE    ,
     1                SIGMAT,SIGMAC,SIGMAS,SPACE(15)    ,TDEP  ,
     2                DUM26(26)
C
C     COMMON FOR PIEZOELECTRIC MATERIAL
      COMMON /MATPZ / PZOUT(51)
C
C     ISOPARAMETRIC MATERIALS
C     COMMON /MATISO/ G11   ,G12   ,G13   ,G14   ,G15   ,G16   ,G12   ,
C                     G22,..,G56   ,G66   ,RHO   ,
C                     AXX   ,AYY   ,AZZ   ,AXY   ,AYZ   ,AZX   ,TREF  ,
C                     GE    ,IER
C
      COMMON /MATISO/ BUFM6(46)
      EQUIVALENCE     (E    ,BUF(1),Y(1) ),
     1                (Y( 1),G11   ,EX3  ,PLAANS ,INDSTR),
     2                (Y( 2),G12   ,EY3  ,ICELL2),
     3                (Y( 3),G13   ,EZ3  ),
     4                (Y( 4),G22   ,NUXY3),
     5                (Y( 5),G23   ,NUYZ3),
     6                (Y( 6),G33   ,NUZX3),
     7                (Y( 7),RHOY  ,RHO3 ),
     8                (Y( 8),ALPH1 ,GXY3 ),
     9                (Y( 9),ALPH2 ,GYZ3 ),
     O                (Y(10),ALPH12,GZX3 ),
     1                (Y(11),TOY   ,AX3  ),
     2                (Y(12),GEY   ,AY3  ),
     3                (Y(13),SIGTY ,AZ3  ),
     4                (Y(14),SIGCY ,TREF3),
     5                (Y(15),SIGSY ,GE3  )
      EQUIVALENCE     (Y(16),J11   ,G113 ),
     1                (Y(17),J12   ,G123 ),
     2                (Y(18),J22   ,G133 ),
     3                (Y(19),       G223 ),
     4                (Y(20),       G233 ),
     5                (Y(21),       G333 ),
     6                (Y(22),     SIGTY3 ),
     7                (Y(23),     SIGCY3 ),
     8                (Y(24),     SIGSY3 ),
     9                (Y(25),     MATSET )
      EQUIVALENCE     (X( 1)    , EX     ),
     1                (X( 2)    , GX     ),
     2                (X( 3)    , NUX    ),
     3                (X( 4)    , RHOX   ),
     4                (X( 5)    , ALPHX  ),
     5                (X( 6)    , TOX    ),
     6                (X( 7)    , GEX    ),
     7                (X( 8)    , SIGTX  ),
     8                (X( 9)    , SIGCX  ),
     9                (X(10)    , SIGSX  )
      EQUIVALENCE     (BUFM6(1) , IB(1)  )
      EQUIVALENCE     (ZZ(1)    , Z(1)   )
C
C     DATA DEFINING CARDS TO BE READ
C
      DATA    MAT1   ,  KMAT1  ,  LMAT1  /  103, 1,   11,     31 /  ,
     2        MAT2   ,  KMAT2  ,  LMAT2  /  203, 2,   16,     46 /  ,
     3        MAT3   ,  KMAT3  ,  LMAT3  / 1403,14,   16,     46 /  ,
     6        MAT6   ,  KMAT6  ,  LMAT6  / 2503,25,   40,    118 /  ,
     8        MAT8   ,  KMAT8  ,  LMAT8  /  603, 6,   18,     52 /  ,
     1        MATT1                      /  703, 7               /  ,
     2        MATT2                      /  803, 8               /  ,
     3        MATT3                      / 1503,15               /  ,
     6        MATT6                      / 2603,26               /  ,
     1        MATS1                      /  503, 5               /  ,
     1        MATPZ1 ,  KMTPZ1 ,  LMTPZ1 / 1603,16,   15,     43 /  ,
     2        MATPZ2 ,  KMTPZ2 ,  LMTPZ2 / 1703,17,   52,    154 /  ,
     1        MTTPZ1                     / 1803,18               /  ,
     2        MTTPZ2                     / 1903,19               /  ,
     F        MATF   ,  KMATF  ,  LMATF  / 5110,51,    3,      3 /
      DATA    NTYPES,   TABLEI /  8,
     1        105 , 1,  205 , 2,  305 , 3,  405 , 4,  3105,31,  3205,32,
     2        3305,33,  3405,34/
      DATA    NAM    /  4HMAT ,   4H     /
C
C     MAT1 AND MAT2 HAVE ONE EXTRA WORD AT END
C
      DATA NWMAT1 /  12 /  ,   NWMAT2 / 17  /
C
C      - DATA IN /MATOUT/ IN VARIOUS MAT FORMATS, AND INFLAGS -
C
C     FORMAT  MAT1    MAT2                     MAT3      MAT6  MAT8 MATP
C     INFLAG=   1   2,3,12    4      5    6,8     7   11   10    12
C     -WORD- -----  ------  --- ------ ------ ----- ---- ---- ----- ----
C       1       E     G11   RHO INDSTR PLAANS    EX         :    E1    E
C       2       G     G12             ICDLL/8    EY         :  NU12    E
C       3      NU     G13                        EZ              E2
C       4     PHO     G22                      NUXY  RHO        G12
C       5    ALPH     G23                      NUYZ             G2Z
C       6      T0     G33                      NUZX             G1Z
C       7      GE     RHO                       RHO             RHO
C       8    SIGT   ALPH1    (X/N INDICATES     GXY           ALPH1
C       9    SIGC   ALPH2     ITEM X IS FOR     GYZ           ALPH2
C      10    SIGS  ALPH12     INFLAG=N ONLY)    GZX              TO
C      11              TO                        AX              TL
C      12              GE                        AY              CL
C      13            SIGT                        AZ              TT
C      14            SIGC                        TO              CT
C      15            SIGS                        GE              IS
C      16         E/12 J11/3                     G11             GE
C      17         E/12 J12/3                     G12            F12
C      18              J22/3                     G13
C      19                                        G22
C      20                                        G23
C      21                                        G33
C      22                                       SIGT
C      23                                       SIGC
C      24                                       SIGS
C      25  MATSET  MATSET                     MATSET          MATSET
C      26    TDEP
C       :
C
C     PERFORM GENERAL INITIALIZATION
C
      QMAT1  = 0
      QMAT2  = 0
      QMAT3  = 0
      QMAT6  = 0
      QMAT8  = 0
      QMATF  = 0
      QMATX  = 0
      QMTPZ1 = 0
      QMTPZ2 = 0
      PLA    = .FALSE.
      IF (DITF .LT. 0) PLA = .TRUE.
      PART1  = .TRUE.
      I      =-1
      MPT    = MPTF
      DIT    = IABS(DITF)
      OFFSET = LOCFX(IZ(1)) - LOCFX(Z(1))
      IF (OFFSET .LT. 0) CALL ERRTRC ('PREMAT  ',10)
      N1MAT  = NIMAT + OFFSET
C
C     READ MAT1,MAT2 AND MAT3 CARDS.  SPREAD FORMAT SO THAT MATTI AND
C     MATSI TEMPERATURE AND STRESS-STRAIN TABLE NUMBERS CAN BE MERGED
C
      CALL PRELOC (*350,BFR,MPT)
      IMAT1 = 1 + OFFSET
      I     = 1 + OFFSET
      CALL LOCATE (*60,BFR,MAT1,FLAG)
      QMAT1 = 1
      IMHERE= 30
   30 CALL READ (*1350,*50,MPT,BUF,NWMAT1,0,FLAG)
      Z(I) = BUF(1)
      I    = I + 1
      DO 40 J = 2,KMAT1
      Z(I  ) = BUF(J)
      Z(I+1) = 0
      Z(I+2) = 0
      IF (I .GT. N1MAT) GO TO 1398
   40 I = I + 3
      GO TO 30
   50 NMAT1 = I - LMAT1
   60 IMAT2 = I
      CALL LOCATE (*100,BFR,MAT2,FLAG)
      QMAT2 = 1
      IMHERE= 70
   70 CALL READ (*1350,*90,MPT,BUF,NWMAT2,0,FLAG)
      Z(I) = BUF(1)
      I    = I + 1
      DO 80 J = 2,KMAT2
      Z(I  ) = BUF(J)
      Z(I+1) = 0
      Z(I+2) = 0
      IF (I .GT. N1MAT) GO TO 1398
   80 I = I + 3
      GO TO 70
   90 NMAT2 = I - LMAT2
  100 IMAT3 = I
      CALL LOCATE (*131,BFR,MAT3,FLAG)
      QMAT3 = 1
      IMHERE= 110
  110 CALL READ (*1350,*130,MPT,BUF,KMAT3,0,FLAG)
      Z(I) = BUF(1)
      I    = I + 1
      DO 120 J = 2,KMAT3
      Z(I  ) = BUF(J)
      Z(I+1) = 0
      Z(I+2) = 0
      IF (I .GT. N1MAT) GO TO 1398
  120 I = I + 3
      GO TO 110
  130 NMAT3  = I - LMAT3
  131 IMTPZ1 = I
      CALL LOCATE (*135,BFR,MATPZ1,FLAG)
      QMTPZ1 = 1
      IMHERE = 132
  132 CALL READ (*1350,*134,MPT,BUF,KMTPZ1,0,FLAG)
      Z(I) = BUF(1)
      I    = I + 1
      DO 133 J = 2,KMTPZ1
      Z(I  ) = BUF(J)
      Z(I+1) = 0
      Z(I+2) = 0
      IF (I .GT. N1MAT) GO TO 1398
  133 I = I + 3
      GO TO 132
  134 NMTPZ1 = I - LMTPZ1
  135 IMTPZ2 = I
      CALL LOCATE (*140,BFR,MATPZ2,FLAG)
      QMTPZ2 = 1
      IMHERE = 136
  136 CALL READ (*1350,*138,MPT,BUF,KMTPZ2,0,FLAG)
      Z(I) = BUF(1)
      I    = I + 1
      DO 137 J = 2,KMTPZ2
      Z(I  ) = BUF(J)
      Z(I+1) = 0
      Z(I+2) = 0
      IF (I .GT. N1MAT) GO TO 1398
  137 I = I + 3
      GO TO 136
  138 NMTPZ2 = I - LMTPZ2
  140 IMAT6  = I
      CALL LOCATE (*144,BFR,MAT6,FLAG)
      QMAT6  = 1
      IMHERE = 141
  141 FLAG   = 0
      CALL READ (*1350,*143,MPT,BUF,KMAT6,0,FLAG)
      Z(I) = BUF(1)
      I    = I + 1
      DO 142 J = 2,KMAT6
      Z(I  ) = BUF(J)
      Z(I+1) = 0
      Z(I+2) = 0
      IF (I .GT. N1MAT) GO TO 1398
  142 I = I + 3
      GO TO 141
  143 NMAT6 = I - LMAT6
      IF (FLAG .NE. 0) GO TO 1570
  144 IMAT8 = I
      CALL LOCATE (*1444,BFR,MAT8,FLAG)
      QMAT8 = 1
      IMHERE= 1441
 1441 FLAG  = 0
      CALL READ (*1350,*1443,MPT,BUF,KMAT8,0,FLAG)
      Z(I) = BUF(1)
      I    = I + 1
      DO 1442 J = 2,KMAT8
      Z(I  ) = BUF(J)
      Z(I+1) = 0
      Z(I+2) = 0
      IF (I .GT. N1MAT) GO TO 1398
 1442 I = I + 3
      GO TO 1441
 1443 NMAT8 = I - LMAT8
      IF (FLAG .NE. 0) GO TO 1570
 1444 IMATF = I
      CALL LOCATE (*149,BFR,MATF,FLAG)
      QMATF  = 1
      IMHERE = 145
  145 CALL READ (*1350,*148,MPT,BUF,KMATF,0,FLAG)
      Z(I  ) = BUF(1)
      Z(I+1) = BUF(2)
      Z(I+2) = BUF(3)
      I = I + 3
      GO TO 145
  148 NMATF = I - LMATF
  149 ILIST = I
      IF (I .GT. N1MAT) GO TO 1398
      CALL CLOSE (MPT,CLSREW)
C
C     IF TEMPERATURE OR PLA PROBLEM, READ THE MATTI OR MATSI CARDS.
C     MERGE MATSI AND MATTI DATA WITH MATI DATA.
C     SAVE A LIST OF TABLES REFERENCED.
C
      IF (     PLA .AND. TEMPID.NE.0) GO TO 1540
      IF (.NOT.PLA .AND. TEMPID.EQ.0) GO TO 350
      CALL PRELOC (*350,BFR,MPT)
      IF (TEMPID .NE. 0) GO TO 160
      NX = 3
      CALL LOCATE (*150,BFR,MATS1,FLAG)
      QMATX = 1
      ASSIGN  150 TO BACK
      ASSIGN 1420 TO RET1
      ASSIGN  820 TO PASS
      N = KMAT1
      GO TO 910
  150 CONTINUE
  160 NX = 2
      CALL LOCATE (*170,BFR,MATT1,FLAG)
      QMATX = 1
      ASSIGN  170 TO BACK
      ASSIGN 1450 TO RET1
      ASSIGN  820 TO PASS
      N = KMAT1
      GO TO 910
  170 CALL LOCATE (*180,BFR,MATT2,FLAG)
      QMATX = 1
      ASSIGN  180 TO BACK
      ASSIGN 1460 TO RET1
      ASSIGN  850 TO PASS
      N = KMAT2
      GO TO 910
  180 CALL LOCATE (*181,BFR,MATT3,FLAG)
      QMATX = 1
      ASSIGN  181 TO BACK
      ASSIGN 1520 TO RET1
      ASSIGN  880 TO PASS
      N = KMAT3
      GO TO 910
  181 CALL LOCATE (*182,BFR,MTTPZ1,FLAG)
      QMATX = 1
      ASSIGN  182 TO BACK
      ASSIGN 1551 TO RET1
      ASSIGN  901 TO PASS
      N = KMTPZ1
      GO TO 910
  182 CALL LOCATE (*183,BFR,MTTPZ2,FLAG)
      QMATX = 1
      ASSIGN  183 TO BACK
      ASSIGN 1552 TO RET1
      ASSIGN  904 TO PASS
      N = KMTPZ2
      GO TO 910
  183 CALL LOCATE (*190,BFR,MATT6,FLAG)
      QMATX = 1
      ASSIGN  190 TO BACK
      ASSIGN 1560 TO RET1
      ASSIGN  907 TO PASS
      N = 31
      GO TO 910
  190 ITABL = I
      IMHERE= 190
      IF (I .GT. N1MAT) GO TO 1398
      NLIST = ITABL - 11
      CALL CLOSE (MPT,CLSREW)
C
C     IF ANY MATTI OR MATSI CARDS WERE READ, FORM A SORTED LIST OF TABLE
C     NUMBERS REFERENCED ON THESE CARDS. THEN, DISCARD ANY DUPLICATES IN
C     THE LIST SO THAT THE LIST CONTAINS UNIQUE TABLE NOS. TO BE READ.
C
      IF (QMATX .EQ. 0) GO TO 350
      DO 220 II = ILIST,NLIST,11
      MIN = 999999999
      DO 210 JJ = II,NLIST,11
      IF (Z(JJ) .GE. MIN) GO TO 210
      MIN = Z(JJ)
      JX  = JJ
  210 CONTINUE
      Z(JX) = Z(II)
  220 Z(II) = MIN
      Z(ITABL) = 0
      JJ = ILIST
      DO 230 II = ILIST,NLIST,11
      IF (Z(II+11) .EQ. Z(II)) GO TO 230
      Z(JJ) = Z(II)
      JJ = JJ + 11
  230 CONTINUE
      ITABL = JJ
      NLIST = JJ - 11
C
C     READ THE DIT BY TABLE TYPE. FOR EACH TABLE IN THE DIT, LOOK UP IN
C     TABLE NO. LIST TO DETERMINE IF THE TABLE IS REQUIRED FOR PROBLEM
C     SOLUTION. IF NOT, SKIP THE TABLE. IF SO, READ THE TABLE INTO CORE
C     AND STORE POINTERS TO THE FIRST AND LAST ENTRIES IN THE TABLE AND
C     THE TYPE OF TABLE. THIS INFORMATION IS STORED IN THE TABLE NO.
C     LIST
C
      CALL PRELOC (*1370,BFR,DIT)
      I = ITABL
      J = 1
      ASSIGN 260 TO RET
      ASSIGN 280 TO RET1
  240 JJ = J + J - 1
      CALL LOCATE (*290,BFR,TABLEI(JJ),FLAG)
  250 CALL READ (*1380,*290,DIT,BUF,8,0,FLAG)
      NWDS = 2
      IF (J.EQ.4 .OR. J.EQ.8) NWDS = 1
      TABLID = BUF(1)
      GO TO 960
  260 Z(L+1) = J
      IF (J .GT. 4) Z(L+1) = J - 4
      Z(L+2) = I
      IMHERE = 270
  270 CALL READ (*1380,*1390,DIT,Z(I),NWDS,0,FLAG)
      IF (Z(I) .EQ. -1) GO TO 300
      I = I + NWDS
      IF (I .GT. N1MAT) GO TO 1398
      GO TO 270
  280 CALL READ (*1380,*1390,DIT,BUF,NWDS,0,FLAG)
      IF (BUF(1) .EQ. -1) GO TO 250
      GO TO 280
  290 J = J + 1
      IF (J .LE. NTYPES) GO TO 240
      CALL CLOSE (DIT,CLSREW)
      GO TO 330
  300 Z(L+3) = I - NWDS
C
C     STORE THE PARAMETERS ON THE TABLEI CARD IN LOCATIONS
C     Z(L+4),Z(L+5),...,Z(L+10)
C
      DO 310 K = 2,8
      LX = L + K
  310 Z(LX+2) = BUF(K)
C
C     IF THIS TABLE IS A POLYNOMIAL (TABLE4), EVALUATE THE END POINTS
C     AND STORE AT ZZ(L+8) AND ZZ(L+9)
C
      IF (J .NE. 4) GO TO 250
      XX = (ZZ(L+6) - ZZ(L+4))/ZZ(L+5)
      ASSIGN 1330 TO IGOTO
      GO TO 1280
  320 ASSIGN 1340 TO IGOTO
      XX = (ZZ(L+7) - ZZ(L+4))/ZZ(L+5)
      GO TO 1280
C
C     TEST TO FOR ALL REFERENCED TABLES IN CORE
C
  330 FLAG = 0
      DO 340 L = ILIST,NLIST,11
      IF (Z(L+1) .NE. 0) GO TO 340
      FLAG = 1
      BUF(1) = Z(L)
      BUF(2) = 0
      CALL MESAGE (30,41,BUF)
  340 CONTINUE
      IF (FLAG .NE. 0) CALL MESAGE (-37,0,NAM)
C
C     WRAP UP PREMAT
C
  350 N2MAT  = I + 1 - OFFSET
      MATIDO = 0
      SINTHO = 2.0
      COSTHO = 2.0
      INFLGO = 0
      PART1  =.FALSE.
      MAPCK  =+999
      RETURN
C
C     THE FOLLOWING POINTERS AND FLAGS ARE SET IN PREMAT FOR USE BY MAT-
C     QMAT1 = 0, NO MAT1 TABLE, = 1, MAT1 TABLE PRESENT
C     IMAT1 = POINTER TO FIRST ENTRY IN MAT1 TABLE
C     LMAT1 = LENGTH  OF EACH  ENTRY IN MAT1 TABLE
C     NAMT1 = POINTER TO LAST  ENTRY IN MAT1 TABLE
C     QMAT2,  IMAT2, LMAT2 AND NMAT2 ARE DEFINED AS ABOVE FOR MAT2 TABLE
C     QMATX = 0, NO TEMP OR STRESS TABLES PRESENT, = 1, OTHERWISW
C     ILIST = POINTER TO FIRST ENTRY IN TABLE LIST
C     NLIST = POINTER TO  LAST ENTRY IN TABLE LIST
C
C     THE TABLE LIST HAS 11 WORDS PER ENTRY AS FOLLOWS--
C      1. TABLE NUMBER (I.E. ID NO.)
C      2. TABLE TYPE (I.E. 1 = TABLE1, 2 = TABLE2 ETC.)
C      3. POINTER TO FIRST ENTRY IN TABLE
C      4. POINTER TO  LAST ENTRY IN TABLE
C      5. THRU 11. PARAMETERS ON TABLEI CARD
C     MATIDO = OLD MATERIAL ID (INITIALIZED TO  0 BY PREMAT)
C     SINTHO = OLD SIN THETA   (INITIALIZED TO 2. BY PREMAT)
C     INFLGO = OLD INFLAG      (INITIALIZED TO  0 BY PREMAT)
C
C
C
      ENTRY MAT (ELEMID)
C     ==================
C
C     IF MAPCK .NE. +999 PREMAT HAS BEEN CORRUPTED.  (OVERLAY ERROR)
C
      IF (MAPCK .EQ. +999) GO TO 355
      WRITE  (NOUT,353) MAPCK
  353 FORMAT (//,' *** PREMAT OVERLEY ERROR',I12)
      CALL ERRTRC ('PREMAT  ',353)
C
C
C     INFLAG DESCRIBES PROCESSING REQUESTED BY CALLER
C
  355 GO TO (360 ,400 ,480 ,560 ,620 ,640 ,680 ,2000,2200,2400,2600,
     1      2700), INFLAG
C
C     INFLAG = 1 MEANS CALLER WANTS ONLY MAT1 PROPERTIES IN MAT1 FORMAT
C     IF NO TEMPERATURE DEPENDENT PROPERTIES AND MATID = OLD MATID,
C     RETURN SINCE DATA IS ALREADY IN MATOUT
C
  360 IF (TEMPID.EQ.0 .AND. MATID.EQ.MATIDO .AND. INFLAG.EQ.INFLGO .AND.
     1   .NOT. PLA) RETURN
      MATIDO = MATID
      INFLGO = INFLAG
      TDEP   =.FALSE.
C
C     LOOK UP MATID IN MAT1 TABLE
C
      ASSIGN  380 TO RET
      ASSIGN 1480 TO RET1
      GO TO 820
C
C     PICK UP MATERIAL PROPERTIES FROM MAT1 ENTRY.
C
  380 I = K + 1
      J = 1
      ASSIGN 390 TO BACK
      GO TO 980
  390 Y(J) = PROP
      I = I + 3
      J = J + 1
      IF (J .LT. KMAT1) GO TO 980
      RETURN
C
C     INFLAG = 2 MEANS CALLER WANTS MAT2 FORMAT WHETHER PROPERTIES ARE
C     DEFINED IN MAT1 OR MAT2 TABLE.
C     IF NO TEMPERATURE DEPENDENT PROPERTIES AND MATID = OLD MATID AND
C     SIN THETA = OLD SIN THETA, RETURN
C
  400 IF (TEMPID.EQ.0 .AND.  MATID.EQ.MATIDO .AND. SINTH.EQ.SINTHO .AND.
     1    .NOT.PLA    .AND. INFLAG.EQ.INFLGO .AND. COSTH.EQ.COSTHO)
     2    RETURN
      INFLGO = INFLAG
      MATIDO = MATID
      SINTHO = SINTH
      COSTHO = COSTH
C
C     LOOK UP MATID IN MAT1 TABLE
C
  410 ASSIGN 420 TO RET1
      ASSIGN 430 TO RET
      GO TO 820
C
C     MATID NOT IN MAT1 TABLE, LOOK UP IN MAT2 TABLE
C     - IF NOT PRESENT, FATAL ERROR IF INFLAG = 2
C     - IF NOT PRESENT, SEARCH MAT8 TABLE IF INFLAG = 12
C
  420 ASSIGN 450 TO RET
      ASSIGN 425 TO RET1
      GO TO 850
  425 IF (INFLGO .EQ. 12) GO TO 2710
      GO TO 1480
C
C     MATID FOUND IN MAT1 TABLE.
C     COMPUTE G MATRIX FROM MAT1 PROPERTIES.
C     COMPLETE REMAINDER OF OUTPUT BUFFER IN MAT2 FORMAT.
C
  430 I = K + 1
      J = 1
      ASSIGN 440 TO BACK
      MMAT = 1
      GO TO 980
  440 X(J) = PROP
      I = I + 3
      J = J + 1
      IF (J .LT. KMAT1) GO TO 980
      NUXX  = 1.0 - NUX**2
      G11   = EX/NUXX
      G12   = NUX*G11
      G13   = 0.
      G22   = G11
      G23   = 0.
      G33   = GX
      RHOY  = RHOX
      ALPH1 = ALPHX
      ALPH2 = ALPHX
      ALPH12= 0.
      TOY   = TOX
      GEY   = GEX
      SIGTY = SIGTX
      SIGCY = SIGCX
      SIGSY = SIGSX
      IF (INFLGO .EQ. 12) GO TO 2701
      RETURN
C
C     MATID FOUND IN MAT2 TABLE.
C     PLACE PROPERTIES IN OUTPUT AREA IN MAT2 FORMAT
C     THEN TEST FOR TRANSFORMATION. IF IDENTITY, RETURN. 3THERWISE,
C     PERFORM  U(T)*G*U .
C
  450 I = K + 1
      J = 1
      MMAT = 2
      ASSIGN 460 TO BACK
      GO TO 980
  460 Y(J) = PROP
      I = I + 3
      J = J + 1
      IF (J    .LT. KMAT2) GO TO 980
      IF (INFLGO .EQ.  12) GO TO 2705
      IF (SINTH  .EQ. 0.0) GO TO 470
      IF (ABS(SINTH**2 + COSTH**2 - 1.0) .GT. .0001) GO TO 1485
C
C     TRANSFORM G , THE MATERIAL STIFFNESS PROPERTY MATRIX.
C                M                   T
C                            G   =  U * G * U
C                             E          M
C
      X( 1) = COSTH**2
      X( 2) = SINTH**2
      X( 3) = COSTH*SINTH
      X( 4) = X(2)
      X( 5) = X(1)
      X( 6) =-X(3)
      X( 7) = 2.0*X(6)
      X( 8) =-X(7)
      X( 9) = X(1) - X(2)
      X(10) = G11
      X(11) = G12
      X(12) = G13
      X(13) = G12
      X(14) = G22
      X(15) = G23
      X(16) = G13
      X(17) = G23
      X(18) = G33
      CALL GMMATS (X(10),3,3,0,X( 1),3,3,0,X(19))
      CALL GMMATS (X( 1),3,3,1,X(19),3,3,0,X(10))
      G11   = X(10)
      G12   = X(11)
      G13   = X(12)
      G22   = X(14)
      G23   = X(15)
      G33   = X(18)
C
C     COMPUTE THE TRANSFORMED TEMPERATURE EXPANSION VECTOR
C               (ALPHA) = (U)*(ALPHA)
C                                    M
C
      X(3)  = -X(3)
      X(6)  = -X(6)
      X(7)  = -X(7)
      X(8)  = -X(8)
      CALL GMMATS (X(1),3,3,0, Y(8),3,1,0, X(10))
      ALPH1 = X(10)
      ALPH2 = X(11)
      ALPH12= X(12)
  470 IF (INFLAG .EQ. 7) GO TO 813
      RETURN
C
C     INFLAG = 3 IMPLIES THE CALLER WANTS
C             (1) ONLY J11, J12 AND J22, AND
C             (2) THE FIRST 15 LOCATIONS OF /MATOUT/ TO BE UNDISTURBED.
C
  480 IF (MATID.EQ.MATIDO .AND. INFLAG.EQ.INFLGO .AND. .NOT.PLA) RETURN
      IF (MATID  .NE. MATIDO) GO TO 490
      IF (INFLGO .NE.      2) GO TO 490
      IF (MMAT-2) 530,540,540
C
C     SEARCH MAT1 TABLE FOR MATID
C
  490 ASSIGN 500 TO RET1
      ASSIGN 510 TO RET
      GO TO 820
C
C     MATID NOT IN MAT1 TABLE. LOOK IN MAT2 TABLE - ERROR IF NOT PRESENT
C
  500 ASSIGN 1480 TO RET1
      ASSIGN  540 TO RET
      GO TO 850
  510 I = K + 4
      ASSIGN 520 TO BACK
      GO TO 980
  520 J11 = PROP
      J12 = 0.0
      J22 = PROP
      GO TO 550
  530 J11 = GX
      J12 = 0.0
      J22 = GX
      GO TO 550
  540 J11 = 0.0
      J12 = 0.0
      J22 = 0.0
  550 INFLGO = INFLAG
      MATIDO = MATID
      RETURN
C
C     INFLAG = 4 MEANS CALLER DESIRES ONLY THE DENSITY PROPERTY (RHO)
C     LOOK UP MATID IN MAT1 TABLE.
C
  560 IF (TEMPID.EQ.0 .AND. MATID.EQ.MATIDO .AND. INFLAG.EQ.INFLGO .AND.
     1   .NOT.PLA) RETURN
      ASSIGN 580 TO RET
      ASSIGN 570 TO RET1
      GO TO 820
C
C     MATID NOT IN MAT1 TABLE, LOOK UP IN MAT2 TABLE - ERROR IF NOT
C     PRESENT
C
  570 ASSIGN  610 TO RET
      ASSIGN 1480 TO RET1
      GO TO 850
C
C     MATID FOUND IN MAT1 TABLE. PICK UP RHO
C
  580 I = K + 10
  590 ASSIGN 600 TO BACK
      GO TO 980
  600 Y(1)   = PROP
      MATIDO = MATID
      INFLGO = INFLAG
      RETURN
C
C     MATID FOUND IN MAT2 TABLE. PICK UP RHO.
C
  610 I = K + 19
      GO TO 590
C
C     INFLAG = 5, USED ONLY IN MODULE PLA1, DETERMINES IF THE MAT CARD
C     REFERENCED IS A MAT1 WITH E, YOUNGS MODULUS, DEFINED AS STRESS
C     DEPENDENT.  IF IT IS STRESS DEPENDENT, INDSTR, THE FIRST WORD OF
C     THE /MATOUT/ BLOCK IS SET = 1.  IF NOT STRESS DEPENDENT, INDSTR
C     IS SET = 0 ONLY MAT1 CARDS ARE ADMISSIBLE FOR THIS TEST.
C
  620 IF (PLA .AND. MATID.EQ.MATIDO .AND. INFLAG.EQ.INFLGO) RETURN
      MATIDO = MATID
      INFLGO = INFLAG
      ASSIGN 630 TO RET
      ASSIGN 635 TO RET1
      INDSTR = 0
      GO TO 820
C
C     TEST TO SEE IF THE MATERIAL PROPERTY E IS DEPENDENT ON A TABLE OF
C     STRAIN VS. STRESS (EPSILON VS. SIGMA)
C
  630 TABLID = Z(K+3)
      IF (TABLID .NE. 0) INDSTR = 1
  635 RETURN
C
C     INFLAG = 6, USED ONLY IN SUBROUTINES PLA3 AND PLA4, ACCEPTS
C     EPSILON - STRAIN - IN THE /MATIN/ BLOCK (PLAARG) AND LOOKS-UP
C     SIGMA   - STRESS - AND STORES THIS VALUE IN PLAANS IN /MATOUT/.
C     ONLY MAT1 AND MATS1 CARDS ARE ADMISSIBLE FOR THIS INFLAG.
C
  640 ASSIGN  650 TO RET
      ASSIGN 1500 TO RET1
      MATIDO = MATID
      INFLGO = INFLAG
      GO TO 820
  650 TABLID = Z(K+3)
      IF (TABLID .LE. 0) GO TO 1510
      XX = PLAARG
      ASSIGN  660 TO RET
      ASSIGN 1490 TO RET1
      GO TO 960
  660 ITYPE = Z(L+1)
      IF (ITYPE .NE. 1) GO TO 1530
      ASSIGN 670 TO IRET
      GO TO 1080
  670 PLAANS = PROP
      RETURN
C
C     INFLAG = 7, USED CURRENTLY ONLY BY BELL AEROSYSTEMS ELEMENTS,
C     IMPLIES THE USER WANTS HIS DATA IN MAT3 FORMAT.  IF THE MATID IS
C     FOUND IN THE MAT1 SET, THE DATA IS STORED IN MAT3 FORMAT.  IF NOT
C     FOUND IN THE MAT1 SET, THE MAT3 SET IS SEARCHED. IF NOT FOUND IN
C     THE MAT3 SET THE MAT2 SET IS SEARCHED. IF NOT FOUND HERE, A FATAL
C     ERROR EXISTS.
C
  680 IF (TEMPID.EQ.0 .AND. INFLAG.EQ.INFLGO .AND. MATID.EQ.MATIDO)
     1    RETURN
      INFLGO = INFLAG
      MATIDO = MATID
      ASSIGN 690 TO RET
  685 CONTINUE
      ASSIGN 790 TO RET1
      GO TO 820
  690 I = K + 1
      J = 1
      ASSIGN 700 TO BACK
      GO TO 980
  700 GO TO (710,720,730,740,750,760,770,771,772,773), J
  710 EX3   = PROP
      EY3   = PROP
      EZ3   = PROP
      GO TO 780
  720 GXY3  = PROP
      GYZ3  = PROP
      GZX3  = PROP
      GO TO 780
  730 NUXY3 = PROP
      NUYZ3 = PROP
      NUZX3 = PROP
      GO TO 780
  740 RHO3  = PROP
      GO TO 780
  750 AX3   = PROP
      AY3   = PROP
      AZ3   = PROP
      GO TO 780
  760 TREF3 = PROP
      GO TO 780
  770 GE3   = PROP
      GO TO 780
  771 SIGTY3 = PROP
      GO TO 780
  772 SIGCY3 = PROP
      GO TO 780
  773 SIGSY3 = PROP
      MATSET = 1.0
      RETURN
C
  780 J = J + 1
      I = I + 3
      GO TO 980
C
C     SEARCH FOR MATID IN THE MAT3 SET
C
  790 ASSIGN 800 TO RET
      ASSIGN 811 TO RET1
      GO TO 880
C
C     PICK UP MATERIAL PROPERTIES FROM MAT3 ENTRY
C
  800 I = K + 1
      J = 1
      ASSIGN 810 TO BACK
      GO TO 980
  810 Y(J) = PROP
      I = I + 3
      J = J + 1
      IF (J .LT. KMAT3) GO TO 980
      MATSET = 3.0
      RETURN
C
C     SEARCH FOR MATID IN THE MAT2 SET
C
  811 ASSIGN  812 TO RET
      ASSIGN 1480 TO RET1
      GO TO 850
C
C     GO TO INFLAG = 2 CODE TO PICK UP MAT2 PROPERTIES
C
  812 GO TO 450
  813 SIGTY3 = SIGTY
      SIGCY3 = SIGCY
      SIGSY3 = SIGSY
      TREF3  = TOY
      GE3    = GEY
      AX3    = ALPH1
      AY3    = ALPH2
      AZ3    = ALPH12
      G113   = G11
      G123   = G12
      G133   = G13
      G223   = G22
      G233   = G23
      G333   = G33
      MATSET = 2.0
      RETURN
C
C     INFLAG = 8 IS USED ONLY BY TWO-DIMENSIONAL ELEMENTS IN PIECEWISE
C     LINEAR ANALYSIS.  HERE WE PERFORM AN INVERSE INTERPOLATION TO
C     OBTAIN STRAIN (EPS) GIVEN STRESS (TAU)
C
 2000 ASSIGN 2010 TO RET
      ASSIGN 1500 TO RET1
      MATIDO = MATID
      INFLGO = INFLAG
      YY     = PLAARG
      GO TO 820
 2010 TABLID = Z(K+3)
      IF (TABLID .LE. 0) GO TO 1510
      ASSIGN 2020 TO RET
      ASSIGN 1490 TO RET1
      GO TO 960
 2020 ITYPE = Z(L+1)
      IF (ITYPE .NE. 1) GO TO 1530
C
C     ROUTINE TO PERFORM INVERSE LINEAR INTERPOLATION OR EXTRAPOLATION.
C
      ITABL = Z(L+2)
      NTABL = Z(L+3)
      UP    = 1.0
      IF (ZZ(ITABL) .GT. ZZ(ITABL+2)) UP = -1.0
      KXX1 = ITABL
      IF ((YY - ZZ(ITABL+1))*UP .LT. 0.0) GO TO 2180
      KXX1 = NTABL - 2
      IF ((YY - ZZ(NTABL+1))*UP .LE. 0.0) GO TO 2030
      IF (ZZ(NTABL+1) .EQ. ZZ(NTABL-1)) GO TO 2180
 2030 KLO = 1
      KHI = (NTABL - ITABL)/2 + 1
 2090 KX  = (KLO + KHI + 1)/2
      KXX = (KX - 1)*2 + ITABL
      IF ((YY - ZZ(KXX+1))*UP) 2100,2150,2110
 2100 KHI = KX
      GO TO 2120
 2110 KLO = KX
 2120 IF (KHI-KLO .NE. 1) GO TO 2090
      KXX1 = 2*(KLO-1) + ITABL
      IF (KXX .EQ.       KXX1) GO TO 2130
      IF (YY  .EQ. ZZ(KXX1+3)) GO TO 2140
 2130 PLAANS = (YY - ZZ(KXX1+1))*(ZZ(KXX1+2) - ZZ(KXX1))/(ZZ(KXX1+3)
     1       - ZZ(KXX1+1)) + ZZ(KXX1)
 2135 ICELL2 = 0
      RETURN
C
 2140 KXX = KXX1 + 2
 2150 IF (YY .EQ. ZZ(KXX-1)) GO TO 2160
      IF (YY .EQ. ZZ(KXX+3)) GO TO 2170
      PLAANS = ZZ(KXX)
      GO TO 2135
 2160 PLAANS = (ZZ(KXX) + ZZ(KXX-2))/2.0
      GO TO 2135
 2170 PLAANS = (ZZ(KXX) + ZZ(KXX+2))/2.0
      GO TO 2135
C
C     YY IS OUT OF THE RANGE OF THE FUNCTION, SET THE SECOND CELL OF
C     /MATOUT/ EQUAL TO ONE.
C
 2180 PLAANS = 0.0
      ICELL2 = 1
      RETURN
C
C     INFLAG = 9 IS USED ONLY BY TRAPAX AND TRIAAX WHEN PIEZOELECTRIC
C     MATERIALS ARE SELECTED.  WANT MATERIALS RETURNED INTO MATPZ2
C     FORMAT.
C
C     MATPZ1 CODE TRANSFORMS 1,2,3 MATERIAL DIRECTIONS INTO Z, THETA,
C     R = 0 DIRECTIONS, RESPECTIVLELY, AND INTERCHANGES 4TH AND 6TH ROWS
C     AND COLUMNS TO ACCOUNT FOR DIFFERENT SHEAR ORDERING.
C     ELEMENT ROUTINE WILL TRANSFORM FOR R-POLARIZATION
C     MATPZ2 CODE ASSUMES USER HAS PERFO-MED ALL TRANSFORMATIONS AS
C     EXPLAINED FOR MATPZ1
C
 2200 IF (TEMPID.EQ.0 .AND. INFLAG.EQ.INFLGO .AND. MATID.EQ.MATIDO)
     1    RETURN
      INFLGO = INFLAG
      MATIDO = MATID
C
C     LOOK UP MATID IN MATPZ1 TABLE
C
      ASSIGN 2210 TO RET1
      ASSIGN 2220 TO RET
      GO TO 901
C
C     NOT IN MATPZ1, LOOK AT MATPZ2
C
 2210 ASSIGN 2300 TO RET
      ASSIGN 685 TO RET1
      GO TO 904
C
C     FOUND IN MATPZ1 - PUT OUT LIKE MATPZ2
C
 2220 I = K + 1
      J = 1
      ASSIGN 2230 TO BACK
      GO TO 980
 2230 BUFPZ(J) = PROP
      I = I + 3
      J = J + 1
      IF (J .LT. KMTPZ1)  GO TO 980
      EPSO = 8.854E-12
      DO 2240 IJK = 1,8
 2240 BUFPZ(IJK) = BUFPZ(IJK)*1.E-12
      SE1   = (BUFPZ(4)-BUFPZ(1))*2.*BUFPZ(5)**2 - BUFPZ(2)*
     1        (BUFPZ(4)**2-BUFPZ(1)**2)
      SE2   = 2.*BUFPZ(5)**2 - BUFPZ(2)*(BUFPZ(4) + BUFPZ(1))
      IF (SE1.EQ.0. .OR. SE2.EQ.0.)GO TO 1556
      CE11  =-(BUFPZ(5)**2-BUFPZ(1)*BUFPZ(2))/SE1
      CE12  = (BUFPZ(5)**2-BUFPZ(2)*BUFPZ(4))/SE1
      CE13  =  BUFPZ(5)/SE2
      CE33  =-(BUFPZ(4)+BUFPZ(1))/SE2
      CE44  = 1./BUFPZ(3)
      CE66  = 0.5/(BUFPZ(1) - BUFPZ(4))
      E15   = BUFPZ(8)*CE44
      E31   = BUFPZ(6)*(CE11+CE12) + BUFPZ(7)*CE13
      E33   = BUFPZ(6)*CE13*2. + BUFPZ(7)*CE33
      EPS11 = BUFPZ(9)*EPSO
      EPS33 = BUFPZ(10)*EPSO
      DO 2250 IJK = 4,44
 2250 PZOUT(IJK)= 0.
      PZOUT( 1) = CE33
      PZOUT( 2) = CE13
      PZOUT( 3) = CE13
      PZOUT( 7) = CE11
      PZOUT( 8) = CE12
      PZOUT(12) = CE11
      PZOUT(16) = CE44
      PZOUT(19) = CE44
      PZOUT(21) = CE66
      PZOUT(22) = E33
      PZOUT(23) = E31
      PZOUT(24) = E31
      PZOUT(31) = E15
      PZOUT(38) = E15
      PZOUT(40) = EPS33
      PZOUT(43) = EPS11
      PZOUT(45) = EPS11
      PZOUT(46) = BUFPZ(11)
      PZOUT(47) = BUFPZ(12)
      PZOUT(48) = BUFPZ(12)
      PZOUT(49) = BUFPZ(12)
      PZOUT(50) = BUFPZ(13)
      PZOUT(51) = BUFPZ(14)
      MATSET = 4.0
      RETURN
C
C     FOUND IN MATPZ2 FORMAT
C
 2300 I = K + 1
      J = 1
      ASSIGN 2310 TO BACK
      GO TO 980
 2310 PZOUT(J) = PROP
      I = I + 3
      J = J + 1
      IF (J .LT. KMTPZ2) GO TO 980
      MATSET = 5.0
      RETURN
C
C     INFLAG = 10, USED CURRENTLY ONLY BY ISOPARAMETRIC SOLIDS IHEX1,2,3
C     IMPLIES CALLER WANTS HIS DATA IN MAT6 FORMAT STORED IN MATISO.
C     MATERIALS COULD BE ON MAT1 OR ON MAT6. IN EITHER CASE,MATERIALS
C     WILL BE COMPUTED FOR MAT6 OUTPUT. IF NOT FOUND ON MAT1 OR MAT6,
C     FATAL.
C
 2400 IF (TEMPID.EQ.0 .AND. MATID.EQ.MATIDO .AND. INFLAG.EQ.INFLGO)
     1    RETURN
      INFLGO = INFLAG
      MATIDO = MATID
      TDEP   =.FALSE.
C
C     LOOK UP MATID IN MAT1 TABLE
C
      ASSIGN 2420 TO RET1
      ASSIGN 2430 TO RET
      GO TO 820
C
C     MATID NOT IN MAT1. CHECK MAT6
C
 2420 ASSIGN 2470 TO RET
      ASSIGN 1480 TO RET1
      GO TO 907
C
C     MATID FOUND IN MAT1 TABLE. COMPUTE G MATRIX,ETC.
C
 2430 IB(46) = 1
      I = K + 1
      J = 1
      ASSIGN 2440 TO BACK
      GO TO 980
 2440 X(J) = PROP
      I = I + 3
      J = J + 1
      IF (J .LT. KMAT1) GO TO 980
      DD = (1.+NUX)*(1.-2.*NUX)
      IF (DD .NE. 0.) GO TO 2450
      IB(46) = 0
      RETURN
C
 2450 DD   =  EX*(1.-NUX)/DD
      DDN1 = NUX/(1.-NUX)
      DDN2 = 0.5*(1.-2.*NUX)/(1.-NUX)
      DO 2460 IJKL = 1,45
 2460 BUFM6(IJKL) = 0.
      BUFM6( 1) = DD
      BUFM6( 2) = DD*DDN1
      BUFM6( 3) = BUFM6(2)
      BUFM6( 7) = BUFM6(2)
      BUFM6( 8) = BUFM6(1)
      BUFM6( 9) = BUFM6(2)
      BUFM6(13) = BUFM6(2)
      BUFM6(14) = BUFM6(2)
      BUFM6(15) = BUFM6(1)
      BUFM6(22) = DD*DDN2
      BUFM6(29) = BUFM6(22)
      BUFM6(36) = BUFM6(22)
      BUFM6(37) = RHOX
      BUFM6(38) = ALPHX
      BUFM6(39) = ALPHX
      BUFM6(40) = ALPHX
      BUFM6(44) = TOX
      BUFM6(45) = GEX
      RETURN
C
C     MATID FOUND IN MAT6 TABLE. PUT PROPERTIES IN MAT6 FORMAT AND
C     TRANSFORM USING DIRECTION COSINES
C
 2470 IB(46) = 6
      I = K + 1
      J = 1
      ASSIGN 2480 TO BACK
      GO TO 980
 2480 BUFTM6(J) = PROP
      I = I + 3
      J = J + 1
      IF (J .LT. KMAT6) GO TO 980
C
C     PUT SYMMETRIC PORTION OF G INTO A FULL 6 X 6 AND CREATE A 6 X 6
C     DIRECTION COSINE MATRIX BY COOK PP. 212-213. THEN TRANSFORM
C     (U-TRANSPOSE)*G*U
C
      KKK = 0
      LLL = 0
      DO 2500 III = 1,6
      DO 2490 JJJ = III,6
      KKK = KKK + 1
      LLL = LLL + 1
      XY(LLL) = BUFTM6(KKK)
      IF (JJJ .EQ. III) GO TO 2490
      L5   = 5*(JJJ-III)
      ISUB = LLL + L5
      XY(ISUB) = XY(LLL)
 2490 CONTINUE
      LLL = LLL + III
 2500 CONTINUE
      XL1 = BUFTM6(31)
      XM1 = BUFTM6(32)
      XN1 = BUFTM6(33)
      XL2 = BUFTM6(34)
      XM2 = BUFTM6(35)
      XN2 = BUFTM6(36)
      XL3 = BUFTM6(37)
      XM3 = BUFTM6(38)
      XN3 = BUFTM6(39)
      XY(37) = XL1**2
      XY(38) = XM1**2
      XY(39) = XN1**2
      XY(40) = XL1*XM1
      XY(41) = XM1*XN1
      XY(42) = XN1*XL1
      XY(43) = XL2**2
      XY(44) = XM2**2
      XY(45) = XN2**2
      XY(46) = XL2*XM2
      XY(47) = XM2*XN2
      XY(48) = XN2*XL2
      XY(49) = XL3**2
      XY(50) = XM3**2
      XY(51) = XN3**2
      XY(52) = XL3*XM3
      XY(53) = XM3*XN3
      XY(54) = XN3*XL3
      XY(55) = XL1*XL2*2.
      XY(56) = XM1*XM2*2.
      XY(57) = XN1*XN2*2.
      XY(58) = XL1*XM2 + XL2*XM1
      XY(59) = XM1*XN2 + XM2*XN1
      XY(60) = XN1*XL2 + XN2*XL1
      XY(61) = XL2*XL3*2.
      XY(62) = XM2*XM3*2.
      XY(63) = XN2*XN3*2.
      XY(64) = XL2*XM3 + XL3*XM2
      XY(65) = XM2*XN3 + XM3*XN2
      XY(66) = XN2*XL3 + XN3*XL2
      XY(67) = XL3*XL1*2.
      XY(68) = XM3*XM1*2.
      XY(69) = XN3*XN1*2.
      XY(70) = XL3*XM1 + XL1*XM3
      XY(71) = XM3*XN1 + XM1*XN3
      XY(72) = XN3*XL1 + XN1*XL3
C
      CALL GMMATS (XY(1),6,6,0,XY(37),6,6,0,XY(73))
      CALL GMMATS (XY(37),6,6,1,XY(73),6,6,0,BUFM6(1))
C
C     MUST ALSO TRANSFORM THERMAL EXPANSION VECOT= (U-INVERSE)*ALPHA
C     BY COOK P.212, THE INVERSE OF U IS THE TRANSPOSE OF THE
C     MATRIX WHICH TRANSFORMS STRESSES
C
      KKK = 72
      DO 2540 III = 1,6
      DO 2530 JJJ = 1,36,6
      KKK = KKK + 1
      LLL = JJJ + III + 35
      XY(KKK) = XY(LLL)
 2530 CONTINUE
 2540 CONTINUE
      DO 2545 III = 75,87,6
      DO 2545 JJJ = 1,3
      KKK = III + JJJ
      XY(KKK) = XY(KKK)*0.5
 2545 CONTINUE
      DO 2550 III = 90,102,6
      DO 2550 JJJ = 1,3
      KKK = III + JJJ
      XY(KKK) = XY(KKK)*2.0
 2550 CONTINUE
C
      CALL GMMATS (XY(73),6,6,0,BUFTM6(23),6,1,0,BUFM6(38))
C
      BUFM6(37) = BUFTM6(22)
      BUFM6(44) = BUFTM6(29)
      BUFM6(45) = BUFTM6(30)
      RETURN
C
C     INFLAG = 11 IS USED ONLY BY A HYDROELASTIC ANALYSIS TO FIND THE
C     DENSITY FOR THREE DIMENSIONAL FLUID ELEMENTS FROM MATF CARDS.
C
 2600 IF (QMATF .EQ. 0) GO TO 1480
      DO 2610 K = IMATF,NMATF,LMATF
      IF (Z(K) .EQ. MATID) GO TO 2620
 2610 CONTINUE
      GO TO 1480
 2620 RHO = ZZ(K+1)
      RETURN
C
C     INFLAG = 12 IS USED ONLY BY SHELL ELEMENTS QUAD4 AND TRIA3.
C     MAT1 IS FIRST SEARCHED, IF NOT FOUND, MAT2 IS SEARCHED. IF FOUND
C     IN EITHER CASE, /MATOUT/ WILL BE FILLED WITH MAT2 FORMAT DATA.
C     IF NOT FOUND IN MAT1 OR MAT2, MAT8 IS SEARCHED AND MAT8 FORMAT IS
C     USED IN /MATOUT/. FATAL ERROR IF MAT8 IS NOT FOUND.
C
 2700 IF (TEMPID.EQ.0 .AND. MATID.EQ.MATIDO .AND. INFLAG.EQ.INFLGO .AND.
     1    SINTH.EQ.SINTHO .AND. COSTH.EQ.COSTHO .AND. .NOT.PLA)  RETURN
      INFLGO = INFLAG
      MATIDO = MATID
      SINTHO = SINTH
      COSTHO = COSTH
C
C     GO TO INFLAG = 2 CODE TO PICK UP MAT1 OR MAT2 PROPERTIES
C     SET MATSET TO 1.0 IF PROPERTY DATA COMES FROM MAT1, OR
C     TO 2.0 IF FROM MAT2
C
      GO TO 410
C
 2701 MATSET = 1.0
      Y(16)  = EX
      Y(17)  = EX
      RETURN
 2705 MATSET = 2.0
      RETURN
C
C     NOT FOUND IN MAT1 AND MAT2.  LOOK FOR MAT8, ERROR IF NOT FOUND
C
 2710 IF (QMAT8 .EQ. 0) GO TO 1480
      DO 2720 K = IMAT8,NMAT8,LMAT8
      IF (Z(K) .EQ. MATID) GO TO 2730
 2720 CONTINUE
      GO TO 1480
 2730 I = K + 1
      J = 1
      ASSIGN 2740 TO BACK
      GO TO 980
C
C     OUTPUT IN MAT8 FORMAT AND SET MATSET TO 8.0
C
 2740 X(J) = PROP
      I = I + 3
      J = J + 1
      IF (J .LT. KMAT8) GO TO 980
      DO 2760 K = 1,17
      Y(K) = X(K)
 2760 CONTINUE
      Y(2) = X(3)
      Y(3) = X(2)
      Y(5) = X(6)
      Y(6) = X(5)
      MATSET = 8.0
      RETURN
C
C
C     INTERNAL ROUTINE TO SEARCH FOR MATERIAL IN MAT1 TABLE
C
  820 IF (QMAT1 .EQ. 0) GO TO 840
      DO 830 K = IMAT1,NMAT1,LMAT1
      IF (Z(K) .EQ. MATID) GO TO RET, ( 380,430,510,580,630,650,690,930,
     1                                 2010,2430)
  830 CONTINUE
  840 GO TO RET1, (420,500,570,635,790,1420,1450,1480,1500,2420)
C
C     INTERNAL ROUTINE TO SEARCH FOR MATERIAL IN MAT2 TABLE
C
  850 IF (QMAT2 .EQ. 0) GO TO 870
      DO 860 K = IMAT2,NMAT2,LMAT2
      IF (Z(K) .EQ. MATID) GO TO RET, (930,450,610,540,812)
  860 CONTINUE
  870 GO TO RET1, (425,1460,1480)
C
C     INTERNAL ROUTINE TO SEARCH FOR MATERIAL IN MAT3 TABLE.
C
  880 IF (QMAT3 .EQ. 0) GO TO 900
      DO 890 K = IMAT3,NMAT3,LMAT3
      IF (Z(K) .EQ. MATID) GO TO RET, (800,930)
  890 CONTINUE
  900 GO TO RET1, (811)
C
C     PIEZOELECTRIC MATERIALS
C
  901 IF (QMTPZ1 .EQ. 0)  GO TO 903
      DO 902 K = IMTPZ1,NMTPZ1,LMTPZ1
      IF (Z(K) .EQ. MATID) GO TO RET, (2220,930)
  902 CONTINUE
  903 GO TO RET1, (1551,2210)
  904 IF (QMTPZ2 .EQ. 0)  GO TO 906
      DO 905 K = IMTPZ2,NMTPZ2,LMTPZ2
      IF (Z(K) .EQ. MATID) GO TO RET, (2300,930)
  905 CONTINUE
  906 GO TO RET1, (1552,1480,685)
C
C     SEARCH FOR MATERIAL IN MAT6 TABLE(ISOPARAMETRIC SOLIDS)
C
  907 IF (QMAT6 .EQ. 0) GO TO 909
      DO 908 K = IMAT6,NMAT6,LMAT6
      IF (Z(K) .EQ. MATID) GO TO RET, (2470,930)
  908 CONTINUE
  909 GO TO RET1, (1560,1480)
C
C     INTERNAL ROUTINE TO READ MATXI CARDS, MERGE DATA IN MATI TABLE
C     AND STORE TABLE IDS IN CORE.
C
  910 ASSIGN 930 TO RET
  920 CALL READ (*1350,*950,MPT,BUF,N,0,FLAG)
      MATID = BUF(1)
      GO TO PASS, (820,850,880,901,904,907)
  930 DO 940 J = 2,N
      IF (BUF(J) .EQ. 0) GO TO 940
      JX    = K + 3*(J-2) + NX
      Z(JX) = BUF(J)
      Z(I ) = BUF(J)
      Z(I+1)= 0
      I     = I + 11
  940 CONTINUE
      GO TO 920
  950 GO TO BACK, (150,170,180,181,182,183,190)
C
C     INTERNAL ROUTINE TO SEARCH FOR A TABLE IN THE TABLE LIST
C
  960 DO 970 L = ILIST,NLIST,11
      IF (Z(L) .EQ. TABLID) GO TO RET, (260,660,990,1030,2020)
  970 CONTINUE
      GO TO RET1, (280,1490,1520)
C
C     ROUTINE TO TEST FOR DEPENDENCE OF A MATERIAL PROPERTY ON
C     TEMPERATURE OR STRESS. IF DEPENDENT, APPROPRIATE TABLE LOOK UP
C     PROCEDURE IS EMPLOYED. IN EITHER CASE, THE PROPERTY IS RETURNED
C     IN PROP.
C
  980 IF (QMATX .EQ. 0) GO TO 1060
      FLAG   = 0
      TABLID = Z(I+1)
      IF (ELEMID .LT. 0) GO TO 1020
      IF (TABLID .EQ. 0) GO TO 1060
      XX   = TEMP
      TDEP =.TRUE.
      FLAG = 1
      ASSIGN  990 TO RET
      ASSIGN 1490 TO RET1
      GO TO 960
  990 ASSIGN 1010 TO RET
 1000 ITYPE = Z(L+1)
      GO TO (1180,1200,1230,1240), ITYPE
 1010 PROPT = PROP
      GO TO 1070
C
C     SINCE THIS IS NOT A PIECEWISE LINEAR ANALYSIS PROBLEM, NO STRESS
C     DEPENDENT MATERIAL PROPERTIES ARE ALLOWED.  IF AND WHEN THIS
C     RESTRICTION IS LIFTED THE FOLLOWING CODE CAN BE IMPLEMENTED.
C     CURRENTLY A TRANSFER IS ALWAYS MADE TO STATEMENT 1060, SINCE THE
C     ELEMENT ID. IS ALWAYS POSITIVE.
C
 1020 IF (PLA) GO TO 1550
      IF (ELEMID .GT. 0) GO TO 1060
      TABLID = Z(I+2)
      IF (TABLID .EQ. 0) GO TO 1050
      ASSIGN 1030 TO RET
      ASSIGN 1490 TO RET1
      GO TO 960
 1030 ASSIGN 1040 TO RET
      XX = PLAARG
      GO TO 1000
 1040 IF (FLAG .NE. 0) PROP = PROP*PROPT
      GO TO 1070
 1050 IF (FLAG .NE. 0) GO TO 1070
 1060 PROP = ZZ(I)
 1070 GO TO BACK, ( 390,440,460,520,600,700,810,2230,2310,2440,2480,
     1             2740)
C
C     ROUTINE TO PERFORM LINEAR INTERPOLATION FOR FUNCTION IN TABLE.
C     L POINTS TO THE ENTRY IN THE TABLE LIST WHICH DEFINES THE TABLE.
C     ARGUMENT IS XX. FUNCTION VALUE IS RETURNED IN PROP. EXTRAPOLATION
C     IS MADE IF XX IS OUTSIDE THE LIMITS OF THE TABLE.
C
 1080 ITABL = Z(L+2)
      NTABL = Z(L+3)
      UP    = 1.0
      IF (ZZ(ITABL) .GT. ZZ(ITABL+2)) UP = -1.0
      KXX1 = ITABL
      IF ((XX - ZZ(ITABL))*UP .LE. 0.) GO TO 1130
      KXX1 = NTABL - 2
      IF ((XX - ZZ(NTABL))*UP .GE. 0.) GO TO 1130
      KLO = 1
      KHI = (NTABL-ITABL)/2 + 1
 1090 KX  = (KLO+KHI+1)/2
      KXX = (KX-1)*2 + ITABL
      IF ((XX - ZZ(KXX))*UP) 1100,1150,1110
 1100 KHI = KX
      GO TO 1120
 1110 KLO = KX
 1120 IF (KHI-KLO .NE. 1) GO TO 1090
      KXX1 = (KLO-1)*2 + ITABL
      IF (KXX .EQ. KXX1) GO TO 1130
      IF (XX  .EQ. ZZ(KXX1+2)) GO TO 1140
 1130 PROP = (XX - ZZ(KXX1))*(ZZ(KXX1+3) - ZZ(KXX1+1))/(ZZ(KXX1+2)
     1     - ZZ(KXX1)) + ZZ(KXX1+1)
      GO TO IRET, (670,1190,1220)
 1140 KXX = KXX1 + 2
 1150 IF (XX .EQ. ZZ(KXX-2)) GO TO 1160
      IF (XX .EQ. ZZ(KXX+2)) GO TO 1170
      PROP = ZZ(KXX+1)
      GO TO IRET, (670,1190,1220)
 1160 PROP = (ZZ(KXX-1) + ZZ(KXX+1))/2.0
      GO TO IRET, (670,1190,1220)
 1170 PROP = (ZZ(KXX+1) + ZZ(KXX+3))/2.0
C
C     TABLE TYPE = 1
C     ARGUMENT = XX
C
 1180 ASSIGN 1190 TO IRET
      GO TO 1080
 1190 GO TO RET, (1010,1040)
C
C     TABLE TYPE = 2
C     ARGUMENT = (XX-X1)
C
 1200 XX = XX - ZZ(L+4)
 1210 ASSIGN 1220 TO IRET
      GO TO 1080
 1220 PROP = ZZ(I)*PROP
      GO TO RET, (1010,1040)
C
C     TABLE TYPE = 3
C     ARGUMENT = (XX-X1)/X2
C
 1230 XX = (XX - ZZ(L+4))/ZZ(L+5)
      GO TO 1210
C
C     TABLE TYPE = 4
C     PERFORM POLYNOMIAL INTERPOLATION
C
C
C     NOTE...
C         ZZ(L+4) = X1
C         ZZ(L+5) = X2
C         ZZ(L+6) = X3
C         ZZ(L+7) = X4
C         ZZ(L+8) = F((X3-X1)/X2)
C         ZZ(L+9) = F((X4-X1)/X2)
C         WHERE X1 AND X2 ARE TRANSLATION AND SCALE FACTORS RESPECTIVELY
C         AND X3 AND X4 (X3 .LT. X4) ARE THE END POINTS OF THE
C         INTERVAL OVER WHICH THE POLYNOMIAL IS DEFINED.
C
 1240 FACTOR = ZZ(I)
C
C     DETERMINE THE ARGUMENT XX
C
      XX = (XX - ZZ(L+4))/ZZ(L+5)
      IF   (XX - (ZZ(L+6) - ZZ(L+4))/ZZ(L+5)) 1250,1250,1260
 1250 PROP = ZZ(L+8)
      GO TO 1310
 1260 IF   (XX - (ZZ(L+7) - ZZ(L+4))/ZZ(L+5)) 1280,1270,1270
 1270 PROP = ZZ(L+9)
      GO TO 1310
 1280 NN   = Z(L+3)
      PROP = ZZ(NN)
 1290 IF (NN .LE. Z(L+2)) GO TO 1300
      PROP = PROP*XX + ZZ(NN-1)
      NN   = NN - 1
      GO TO 1290
 1300 IF (PART1) GO TO IGOTO, (1330,1340)
 1310 PROP = PROP*FACTOR
      GO TO RET, (1010,1040)
 1330 ZZ(L+8) = PROP
      GO TO 320
 1340 ZZ(L+9) = PROP
      GO TO 250
C
C     FATAL ERROR MESSAGES
C
 1350 N = -2
      DIT = MPT
      GO TO 1400
 1370 N = -1
      GO TO 1400
 1380 N = -2
      GO TO 1400
 1390 N = -3
      GO TO 1400
 1385 WRITE  (NOUT,1386) IMHERE,I,N1MAT,OFFSET,NIMAT
 1386 FORMAT ('0*** NIMAT SPACE TOO SMALL.  ERROR AT',I5,'/PREMAT', /5X,
     1        'I,N1MAT,OFFSET,NIMAT =',3I12,I7,/)
      GO TO 1472
 1398 IF (NIMAT .LE. 2*SYSBUF+4) GO TO 1385
      N = -8
      DIT = I - N1MAT
 1400 CALL MESAGE (N,DIT,NAM)
      N = 16
      BUF(1) = 0
      BUF(2) = 0
      GO TO 1470
 1420 N =  17
 1430 BUF(1) = MATID
      BUF(2) = 0
      GO TO 1470
 1450 N =  19
      GO TO 1430
 1460 N =  20
      GO TO 1430
C
 1470 CALL SSWTCH (20,J)
      IF (J .EQ. 0) GO TO 1475
      WRITE  (NOUT,1471) BUF(1),BUF(2)
 1471 FORMAT (' PREMAT/1471 - BUF(1),BUF(2) =',2I10)
 1472 CALL ERRTRC ('MAT     ',1472)
C
 1475 CALL MESAGE (-30,N,BUF)
C
 1480 N = 42
      BUF(1) = ELEMID
      BUF(2) = MATID
      GO TO 1470
 1485 N = 103
      BUF(1) = 0
      BUF(2) = 0
      GO TO 1470
 1490 N = 112
      BUF(1) = TABLID
      GO TO 1470
 1500 N = 113
      GO TO 1430
 1510 N = 116
      BUF(1) = MATID
      BUF(2) = TABLID
      GO TO 1470
 1520 N = 114
      GO TO 1430
 1530 N = 115
      BUF(1) = TABLID
      BUF(2) = ITYPE
      GO TO 1470
 1540 BUF(1) = TEMPID
 1541 BUF(2) = 0
      N = 117
      GO TO 1470
 1550 BUF(1) = ELEMID
      GO TO 1541
 1551 BUF(2) = 1
      GO TO 1553
 1552 BUF(2) = 2
 1553 N = 216
 1554 BUF(1) = MATID
      GO TO 1470
 1556 N = 214
      GO TO 1554
 1560 N = 217
      GO TO 1554
 1570 N = 219
      GO TO 1554
      END

      SUBROUTINE TRANP1 (IN,IOUT,NSCRTH,IS1,IS2,IS3,IS4,IS5,IS6,IS7,IS8)
C
C     DRIVER OF THE OUT-OF-CORE MATRIX TRANSPOSE ROUTINE TRNSP
C     (DTRANP IS THE TRNSP MODULE DRIVER)
C
C
      INTEGER         SCR,NAM(2)
      COMMON /ZZZZZZ/ CORE(1)
      COMMON /TRNSPX/ IA(7),IAT(7),LCORE,NSCRH,SCR(8)
      DATA    NAM   / 4HTRNS,4HP1  /
C
      IF (NSCRTH .GT. 8) CALL MESAGE (-37,0,NAM)
      IA(1)  = IN
      CALL RDTRL (IA)
      IAT(1) = IOUT
      IAT(2) = IA(3)
      IAT(3) = IA(2)
      IAT(5) = IA(5)
      IAT(4) = IA(4)
C
C     REVERSE THE FORM OF THE LOWER AND UPPER TRIANGULAR MATRIX
C
      IF (IA(4) .EQ. 4) IAT(4) = 5
      IF (IA(4) .EQ. 5) IAT(4) = 4
      LCORE  = KORSZ(CORE)
      NSCRH  = NSCRTH
      SCR(1) = IS1
      SCR(2) = IS2
      SCR(3) = IS3
      SCR(4) = IS4
      SCR(5) = IS5
      SCR(6) = IS6
      SCR(7) = IS7
      SCR(8) = IS8
      CALL TRNSP  (CORE)
      CALL WRTTRL (IAT)
      RETURN
      END

      SUBROUTINE DRAW (GPLST,X,U,S,DISP,STEREO,OPCOR,BUF1)
C
      EXTERNAL        ANDF
      LOGICAL         DISP
      INTEGER         ANDF,AXIS(3),BUF1,DAXIS,ELSET,GP,GPLST(1),OPCOR,
     1                PCON,PEDGE,PEN,PLABEL,PLTNUM,PORIG,PPEN,PRJECT,
     2                PSET,PSHAPE,PSYMBL,PSYMM,PVECTR,STEREO,SYM(2),
     3                SUCOR,V,VEC(3),COLOR,DEFM
      REAL            A(3),MAXDEF,S(2,1),SIGN(3),U(3,1),X(3,1),MIN,MAX
      DOUBLE PRECISION DR,SUM
      COMMON /BLANK / NGP,SKP11(3),PLTNUM,NGPSET,SKP12(4),SKP21(2),ELSET
      COMMON /XXPARM/ PBUFSZ,CAMERA(5),NOPENS,PAPSIZ(2),PENPAP(27),
     1                SCALE,OBJMOD,SKPSCL,MAXDEF,DEFMAX,AXES(3),
     2                DAXIS(3),VIEW(9),VANTX1,R0,VANTX2(3),D0,VANTX3(2),
     3                PRJECT,VANTX4,ORIGX1(14),EDGE(11,4),XY(11,3),
     4                NCNTR(51),ICNTVL,SKP24(24),COLOR
      COMMON /PLTDAT/ MODEL,PLOTER,REG(4),AXYMAX(14)
      COMMON /RSTXXX/ CSTM(3,3),MIN(3),MAX(3)
      COMMON /DRWDAT/ PSET,PLABEL,PORIG,PPEN,PSHAPE,PSYMBL(2),PSYMM(6),
     1                PVECTR,PCON,PEDGE
C
C     /DRWDAT/ CONTROLS THIS ROUTINE
C     PLABEL - LABELING GRIDS, ELEMENTS...
C            -N = NONE
C             0 = GID             3 = EID          6 = EID + GID
C             1 = GID + SPC       4 = EID + PID
C             2 = UNDEFINED.      5 = UNDEFINED
C     PSHAPE - WHICH SHAPE OR OUTLINE OPTION TO DRAW...
C             1 = UNDEFORMED      2 = DEFORMED     3 = BOTH
C     PSYMBL(2) - DRAW SYMBOLS IF PSYMBL(1).NE.0
C     PSYMM (6) - SYMMETRY FLAGS...
C           (1) = X AXIS SIGN CHANGE   (4) = X DEFORMATION SIGN CHANGE
C           (2) = Y                    (5) = Y
C           (3) = Z                    (6) = Z
C     PVECTR - DEFORMATION VECTORS DRAWN (AS INTERPRETED BY INTVEC)...
C             0 = NONE
C             1 = X     4 = Z     7 = XYZ        10 = RY    13 = RXZ
C             2 = Y     5 = ZX    8 = UNDEFINED  11 = RXY   14 = RYZ
C             3 = XY    6 = ZY    9 = RX         12 = RZ    15 = RXYZ
C             THE NEGATIVE OF ABOVE, DO NOT DRAW SHAPE.
C    PCON   - NONZERO MEANS CONTOUR PLOT...
C    PEDGE  - 0 = SHAPE DRAWN,
C             1 = OUTLINE (BORDER) DRAWN ACCORDING TO PSHAPE-S
C             2 = HIDDEN LINE PLOT
C             3 = OFFSET PLOT
C             4 THRU N = SHRINK PLOT, ELEMENT SHRUNK BY THIS PERCENT
C             200 +  N = HIDDEN LINE AND SHRINK PLOT, N.GT.2
C             100 = FILL ?
C
C     OPCOR = NO. OF OPEN CORE WORDS AVAILABLE IN S
C             IT IS NOT A POINTER TO S, NOR A OPEN CORE ARRAY IN S
C     BUF1  = BUFFER AVAILABLE AT END OF CORE W.R.T. GPLST = BUFSIZ+1
C
C     OPEN CORE /ZZPLOT/
C     SETID NSETS NDOF      NGP 3*NGPSET 3*NGPSET  OPCOR   N
C     -----+-----+----+----+---+--------+--------+-------+--+--+-+-+-+-+
C          !          N1   N2  I1 (X)   I2 (U)   I3  (S)   DEFBUF..BUF..
C          !(DEFLST)       !
C                          !(GPLST)                      N=2*NGPSET
C
C     NGP    = TOTAL NO. OF GRID POINTS IN THE STRUCTURE
C     NGPSET = NO. OF GRID POINTS USED IN CURRENT SET OF PLOTTING
C     GPLST  = TABLE OF NGP IN LENGTH,
C              GPLST(I) = 0 IF THIS I-TH GRID POINT IS NOT USED FOR THE
C              CURRENT PLOT. OTHERWISE GPLST(I) IS NON-ZERO.
C     X      = X,Y,Z COORDINATES OF THE GRID POINTS CORRESPONDING TO THE
C              NON-ZERO GRID POINTS IN THE GPLST TABLE
C              TOTALLY, THERE ARE NGPSET GRID POINTS IN X
C     U      = X,Y,Z DISPLACEMENTS, ARRANGED SIMILARLY TO X
C     S      = SCRATCH AREA
C
      SCALEX = 1.0
      IF (PRJECT .EQ. 3) SCALEX = OBJMOD
C
C     SETUP THE PLOTTER REGION.
C
      IF (PSYMM(1).LT.0 .OR. PSYMM(2).LT.0 .OR. PSYMM(3).LT.0) GO TO 10
      REG(1) = EDGE(PORIG,1)*AXYMAX(1)
      REG(2) = EDGE(PORIG,2)*AXYMAX(2)
      REG(3) = EDGE(PORIG,3)*AXYMAX(1)
      REG(4) = EDGE(PORIG,4)*AXYMAX(2)
      GO TO 20
   10 REG(1) = 0.0
      REG(2) = 0.0
      REG(3) = AXYMAX(1)
      REG(4) = AXYMAX(2)
C
C     REDUCE THE GRID POINT CO-ORDINATES TO PLOT SIZE + TRANSLATE TO
C     THE SELECTED ORIGIN.
C
   20 DO 40 I = 1,3
      MIN(I) = +1.E+20
      MAX(I) = -1.E+20
      IF (PSYMM(I) .GE. 0) GO TO 40
      DO 30 GP = 1,NGPSET
   30 X(I,GP) = -X(I,GP)
   40 CONTINUE
      CALL PROCES (X)
      CALL PERPEC (X,STEREO)
      XORIG = XY(PORIG,1)
      IF (STEREO .NE. 0) XORIG = XY(PORIG,2)
      DO 50 GP = 1,NGPSET
      X(2,GP) = SCALE*X(2,GP) - XORIG
      X(3,GP) = SCALE*X(3,GP) - XY(PORIG,3)
   50 CONTINUE
C
      IF (.NOT.DISP .OR. MAXDEF.EQ.0 .OR. DEFMAX.EQ.0) GO TO 120
C
C     PROCESS THE DEFORMATIONS.
C     EXCHANGE AXES, REDUCE THE MAXIMUM DEFORMATION TO -MAXDEF-.
C
      DO 100 I = 1,3
      AXIS(I) = IABS(DAXIS(I))
      SIGN(I) = 1.
      IF (DAXIS(I) .LT. 0) SIGN(I) = -1.
  100 CONTINUE
      I = AXIS(1)
      J = AXIS(2)
      K = AXIS(3)
      D = MAXDEF/DEFMAX
      DO 110 GP = 1,NGPSET
      IF (PSYMM(4) .LT. 0) U(1,GP) = -U(1,GP)
      IF (PSYMM(5) .LT. 0) U(2,GP) = -U(2,GP)
      IF (PSYMM(6) .LT. 0) U(3,GP) = -U(3,GP)
      A(1) = U(I,GP)
      A(2) = U(J,GP)
      A(3) = U(K,GP)
      U(1,GP) = A(1)*SIGN(1)*D
      U(2,GP) = A(2)*SIGN(2)*D
      U(3,GP) = A(3)*SIGN(3)*D
  110 CONTINUE
      CALL INTVEC (PVECTR)
C
C     IF PVECTR .LT. 0 NO SHAPE WILL BE DRAWN
C     ATTEMPT TO REMOVE DUPLICATE LINES
C
  120 IOPT = -1
      SUCOR = 2*NGPSET + 1
      IF (.NOT.DISP) SUCOR = 1
C
C     FIRST DETERMINE OPTIONS - UNIQUE LINES FOR PSHAPE=3 MAY ONLY BE
C     FOR THE UNDERLAY.  ISHAPE = 0 MEANS DRAW THE SHAPE..
C
      ISHAPE = -1
      LATER  = 0
      IF (PVECTR.LT.0 .OR. (PEDGE.NE.0 .AND. PEDGE.NE.3)) GO TO 130
      ISHAPE = 0
      IF (OPCOR .LT. NGPSET+NGP+1) GO TO 130
      IOPT = 0
      DEFM = 0
      IF (PSHAPE .GE. 2) DEFM = 1
      CALL LINEL (S(SUCOR,1),IPTL,OPCOR,IOPT,X,PPEN,DEFM,GPLST)
      IF (PEDGE .EQ. 3) GO TO 500
      IF (IPTL  .LE. 0) IOPT = -1
      CALL BCKREC (ELSET)
  130 IF (PSHAPE.EQ.2 .AND. DISP) GO TO 260
C
C     DRAW UNDEFORMED SHAPE (USE PEN1 + SYMBOL 2 IF THE DEFORMED SHAPE
C     OR DEFORMATION VECTORS ARE ALSO TO BE DRAWN).
C
      PEN = PPEN
      IF (DISP .AND. PSHAPE.GT.2) PEN = 1
      IF (ISHAPE .EQ. 0)
     1    CALL SHAPE (*500,GPLST,X,0,PEN,0,IOPT,IPTL,S(SUCOR,1),OPCOR)
      IF (PEDGE .LT. 2) GO TO 140
      CALL HDSURF (GPLST,X,0,PEN,0,NMAX,MAXSF,S(SUCOR,1),BUF1,PEDGE,
     1             OPCOR)
      IF (PEDGE.NE.2 .AND. PEDGE.LT.200) GO TO 140
      CALL HDPLOT (GPLST,NMAX,MAXSF,OPCOR,BUF1)
      GO TO 220
  140 IF (PCON .EQ. 0) GO TO 200
      IF (.NOT.DISP .OR. PSHAPE.LT.3) GO TO 210
      LATER = PCON
      PCON  = 0
  200 IF (PEDGE.EQ.0 .OR. PEDGE.GE.2) GO TO 220
  210 IOPT = -1
      CALL CONTOR (GPLST,X,0,U,S(SUCOR,1),S(SUCOR,1),PEN,0,BUF1,OPCOR)
      IF (PEDGE .EQ. 1) CALL BORDER (GPLST,X,0,S(SUCOR,1),0,BUF1,OPCOR)
      IF (PEDGE.EQ.1 .OR. COLOR.GE.0) GO TO 220
      CALL GOPEN (ELSET,GPLST(BUF1),0)
      CALL SHAPE (*500,GPLST,X,0,1,0,IOPT,IPTL,S(SUCOR,1),OPCOR)
  220 PCON = MAX0(PCON,LATER)
      IF (PPEN .GT. 31)
     1    CALL SHAPE (*500,GPLST,X,0,1,0,IOPT,IPTL,S(SUCOR,1),OPCOR)
      IF (PSHAPE .EQ. 1) PCON = 0
      IF (PSYMBL(1) .EQ. 0) GO TO 250
      IF (DISP) GO TO 230
      SYM(1) = PSYMBL(1)
      SYM(2) = PSYMBL(2)
      GO TO 240
  230 SYM(1) = 2
      SYM(2) = 0
  240 CALL GPTSYM (GPLST,X,0,SYM,0)
  250 IF (PLABEL .LT. 0) GO TO 260
      I = PLABEL/3
      IF (I .NE. 1) CALL GPTLBL (GPLST,X,0,0,BUF1)
      IF (I .LT. 1) GO TO 260
      CALL ELELBL (GPLST,X,0,0,BUF1)
      CALL BCKREC (ELSET)
  260 IF (.NOT.DISP .OR. MAXDEF.EQ.0.0 .OR. DEFMAX.EQ.0.0) GO TO 500
      IF (PEDGE .EQ. 3) GO TO 500
      IF (PSHAPE.LT.2 .AND. LATER.EQ.0) GO TO 350
C
C     ROTATE THE DEFORMATIONS
C
      DO 290 GP = 1,NGPSET
      DO 280 J  = 1,3
      SUM = CSTM(J,1)*U(1,GP) + CSTM(J,2)*U(2,GP) + CSTM(J,3)*U(3,GP)
      IF (J .NE. 1) GO TO 270
      IF (PRJECT .NE. 1) DR = D0/(R0-SCALEX*(X(1,GP)+SUM))
      GO TO 280
  270 IF (PRJECT .NE. 1) SUM = SCALEX*DR*SUM
      S(J-1,GP) = X(J,GP) + SCALE*SUM
  280 CONTINUE
  290 CONTINUE
C
C     DRAW THE DEFORMED SHAPE
C
      IF (PVECTR .LT. 0) GO TO 300
      PEN = PPEN
      IF (PSHAPE.EQ.2 .AND. PVECTR.NE.0) PEN = 1
      IF (PEDGE .EQ. 0)
     1    CALL SHAPE (*500,GPLST,X,S,PEN,1,IOPT,IPTL,S(SUCOR,1),OPCOR)
      IF (PEDGE .LT. 2) GO TO 300
      CALL HDSURF (GPLST,X,S,PEN,1,NMAX,MAXSF,S(SUCOR,1),BUF1,PEDGE,
     1             OPCOR)
      IF (PEDGE.EQ.2 .OR. PEDGE.GT.200)
     1    CALL HDPLOT (GPLST,NMAX,MAXSF,OPCOR,BUF1)
  300 IF (PCON.EQ.0 .OR. PEDGE.EQ.2 .OR. PEDGE.GT.200) GO TO 310
      IF (ICNTVL.LE. 9 .AND. PSHAPE.EQ.1) GO TO 310
      IF (ICNTVL.GT.13 .AND. PSHAPE.EQ.1) GO TO 310
      CALL CONTOR (GPLST,X,S,U,S(SUCOR,1),S(SUCOR,1),PEN,0,BUF1,OPCOR)
      IF (PEDGE.EQ.1 .OR. COLOR.GE.0) GO TO 310
      CALL GOPEN (ELSET,GPLST(BUF1),0)
      CALL SHAPE (*500,GPLST,X,0,1,0,IOPT,IPTL,S(SUCOR,1),OPCOR)
  310 IF (PEDGE.EQ.  1) CALL BORDER (GPLST,X,S,S(SUCOR,1),1,BUF1,OPCOR)
      IF (PPEN .GT. 31)
     1    CALL SHAPE  (*500,GPL,X,0,1,0,IOPT,IPTL,S(SUCOR,1),OPCOR)
      IF (PSYMBL(1) .EQ. 0) GO TO 340
      IF (PSHAPE.EQ.2 .AND. PVECTR.NE.0) GO TO 320
      SYM(1) = PSYMBL(1)
      SYM(2) = PSYMBL(2)
      GO TO 330
  320 SYM(1) = 2
      SYM(2) = 0
  330 CALL GPTSYM (GPLST,X,S,SYM,1)
  340 IF (PLABEL.LT.0 .OR. PSHAPE.NE.2) GO TO 350
      I = PLABEL/3
      IF (I .NE. 1) CALL GPTLBL (GPLST,X,S,1,BUF1)
      IF (I .LT. 1) GO TO 350
      CALL ELELBL (GPLST,X,S,1,BUF1)
  350 IF (PVECTR .EQ. 0) GO TO 500
      PVECTR = IABS(PVECTR)
C
C     PROCESS THE DEFORMATION VECTORS
C
      IF (PVECTR .LE. 7) GO TO 410
      NV = 1
      VEC(1) = 0
      VEC(2) = 0
      VEC(3) = 0
      DO 400 V = 1,3
      IF (ANDF(PVECTR,2**(V-1)) .EQ. 0) GO TO 400
      IF (AXIS(1).EQ.V) VEC(1) = 1
      IF (AXIS(2).EQ.V) VEC(2) = 1
      IF (AXIS(3).EQ.V) VEC(3) = 1
  400 CONTINUE
      GO TO 420
  410 NV = 3
  420 DO 490 V = 1,NV
      IF (PVECTR .GT. 7) GO TO 440
      IF (ANDF(PVECTR,2**(V-1)) .EQ. 0) GO TO 490
      DO 430 I = 1,3
      VEC(I) = 0
      IF (AXIS(I) .EQ. V) VEC(I) = 1
  430 CONTINUE
C
C     ROTATE THE DEFORMATIONS (VEC = VECTOR DIRECTION TO BE DRAWN)
C
  440 DO 480 GP = 1,NGPSET
      DO 470 J  = 1,3
      SUM = 0.D0
      DO 450 I = 1,3
      IF (VEC(I) .NE. 0) SUM = SUM + CSTM(J,I)*U(I,GP)
  450 CONTINUE
      IF (J .NE. 1) GO TO 460
      IF (PRJECT .NE. 1) DR = D0/(R0-SCALEX*(X(1,GP)+SUM))
      GO TO 470
  460 IF (PRJECT .NE. 1) SUM = SCALEX*DR*SUM
      S(J-1,GP) = X(J,GP) + SCALE*SUM
  470 CONTINUE
  480 CONTINUE
C
C     DRAW THE DEFORMATION VECTOR
C
      CALL DVECTR (GPLST,X,S,PPEN)
      IF (PSYMBL(1).EQ.0 .OR. PSHAPE.EQ.3) GO TO 490
      J = 0
      IF (PSHAPE .EQ. 1) J = 1
      CALL GPTSYM (GPLST,X,S,PSYMBL,J)
  490 CONTINUE
C
C     END OF PLOT
C
C     IF NOT CONTOUR PLOT, CALL PCOORD TO DRAW A SMALL X-Y-Z COORDINATE
C     TRIAD AT THE LOWER RIGHT CORNER OF PLOT
C
  500 IF (PEDGE .NE. 1) CALL PCOORD (PEN)
      RETURN
      END

        SUBROUTINE ENDGET( BLOCK )
      INCLUDE 'DSIOF.COM'
      INCLUDE 'XNSTRN.COM'
        INTEGER BLOCK( 15 )
        NAME = BLOCK( 1 )
        CALL DSGEFL
        NWORDS = BLOCK( 11 )
        NELM = IAND( IBASE( INDCBP-2 ), MASKH2 )
        INDCBP = INDCBP + NELM*NWORDS + BLOCK(3)*2
        CALL DSSDCB
        RETURN
        END

      SUBROUTINE ASDMAP
C
C     THIS ROUTINE PROCESSES THE SUBSTRUCTURE COMMAND DATA DECK
C
C     IT CREATES A SET OF SUBSTRUCTURE DATA ON THE FRONT OF THE CASE
C     FILE AND GENERATES DMAP ALTERS FOR THE XALTER FILE. THE ALTERS ARE
C     PLACED FIRST ON THE SCRATCH FILE AND THEN COPIED TO THE PROBLEM
C     TAPE
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        ANDF        ,ORF        ,RSHIFT      ,LSHIFT    ,
     1                COMPLF
      LOGICAL         ALTER       ,ALTFL      ,FIRST       ,IFIN      ,
     1                SOLVE       ,OPSOF      ,PASS2       ,RECOV     ,
     2                REJECT      ,SKIP
      REAL            FACT        ,XX
      DIMENSION       ALTS(18)    ,CARD(20)   ,CDATA(30)   ,FNAME(7)  ,
     1                COMND(2,25) ,DMAP(18,60),EXTRA(3,200),II(9)     ,
     2                NASUB(2,100),OCARD(200) ,ITEMP(200)  ,ASD1(2)   ,
     3                ASD2(2)     ,PHS(3)     ,EXDEF(2,14) ,ITMN(5)   ,
     4                NCASEC(2)   ,NCASES(2)  ,NHEAD(16)   ,SUBNAM(2) ,
     5                DVEC(3)     ,DBVAR(6)   ,DBVAL(2,6,5),R3VAR(5)  ,
     6                R3VAL(5,5)  ,VAR(3,200) ,IVAR(3,200) ,Z(1)      ,
     7                COREY(2)
      CHARACTER       UFM*23      ,UWM*25     ,UIM*29      ,SFM*25
      COMMON /XMSSG / UFM         ,UWM        ,UIM         ,SFM
      COMMON /MACHIN/ MCHN
      COMMON /GINOX / IDUM(161)   ,IGINOB
      COMMON /BLANK / XX
      COMMON /ASDBD / IRDM        ,NRDM       ,IXTRA       ,NXTRA     ,
     1                IOCT        ,NOCT       ,IPTBS       ,NPTBS     ,
     1                IPH         ,NPH        ,IDAT(1248)
      COMMON /ZZZZZZ/ COREX(1)
      COMMON /OUTPUT/ IOTIT(68)   ,IHEAD(20)
      COMMON /SOFCOM/ NSOF        ,NNAME(10)  ,LENGTH(10)  ,STAT      ,
     1                PASWD(2)    ,FIRST      ,OPSOF
      COMMON /SYSTEM/ SYS(90)     ,LPCH
      EQUIVALENCE     (IBUF,SYS(1))           ,(OUTT,SYS(2))          ,
     1                (NOGO,SYS(3))           ,(INTP,SYS(4))          ,
     2                (NLPP,SYS(9))           ,(NLINES,SYS(12))       ,
     3                (IPREC,SYS(55))         ,(BANDIT,SYS(77))
      EQUIVALENCE     (VAR(1,1),IVAR(1,1))    ,(ITEMP(1),OCARD(1))    ,
     1                (COREX(1),COREY(1),NDBS),(COREY(2),Z(1))
      DATA   ALT1   / 4HALTE /,            ALT2   / 4HR    /,
     1       ASD1   / 4HASDM,4HBEGN /,     ASD2   / 4HASDM,4HEND /,
     2       BLANK  / 4H     /,            CASE   / 4HCASE /,
     3       DISK   / 4HDISK /,            DOLSN  / 4H$    /,
     4       DRY    / 4HDRY  /,            DRYGO  / 4HDRYG /,
     5       ENDS   / 4HENDS /,            EQSN   / 4H=    /
      DATA   EXDEF  / -1,0,  4HTAPE,4H    ,-1,0   , 4HINTE,4H    , 0,0,
     1                4HNORE,4H    ,4HALL ,4H     , 4HWHOL,4HESOF,
     2                8*4HXXXX,-1,0,   -1 ,0               /
      DATA   IDG    / 2H0    /,            IDRY   / 2H-1   /,
     1       INPT   / 4HINPT /,            IOPEN  / 1      /,
     2       ISTP   / 2H1    /,            ITEM   / 4HITEM /
      DATA   ITMN   / 4HITM1,4HITM2,4HITM3,4HITM4,  4HITM5 /
      DATA   JNEW   / 4HNEW  /,            KBEG   / 4HBEGI /,
     1       KWD    / 4HK    /,            GORUN  / 4HGO   /,
     2       LPAR   / 4H(    /,            MACH   / 4HMACH /,
     3       MWD    / 4HM    /,            NAME   / 4HNAME /,
     4       NANO   / 4HNANO /,            NBREC  / 4HBREC /,
     5       NCASEC / 4HCASE,4HCC   /,     NCASES / 4HCASE,4HSS   /,
     6       NEW    / 4HNEW  /
      DATA   NHEAD  / 2*4H    ,4HN A ,4HS T ,4HR A ,4HN  S,4H U B,4H S T
     1              , 4H R U,4H C T,4H U R,4H E  ,4HD E ,4HC K ,4H E C,
     2                4H H O /
      DATA   NH1    / 4H1    /,            NH1A   / 4H1A   /,
     1       NPHASE / 3      /,            NPREC  / 4HPREC /,
     2       NREC   / 4HRECO /,            NSAVE  / 4HSAVE /,
     3       NSOL   / 4HSOL  /,            NSTP   / 4HNSTP /,
     4       POIT   / 4HPOIT /,            NXALT  / 4HXALT /,
     5       NXCSA  / 4HXCSA /,            NXL2   / 4HER   /,
     6       OPER   / 4HOPER /,            OPTI   / 4HOPTI /,
     7       PASS   / 4HPASS /,            PASS2  / .FALSE./
      DATA   PHS    / 4HE1  ,4HE2  , 4HE3         /
      DATA   POSI   / 4HPOSI /,            PTAPE  / 4HNPTP /,
     1       PWD    / 4HP    /,            RUN    / 4HRUN  /,
     2       SCRT   / 301    /,            SOF    / 4HSOF  /,
     3       STEP   / 4HSTEP /,            TITL   / 4HTITL /
      DATA   MSKP   / 4HMSKP /
      DATA   PAPP   / 4HPAPP /,            PAWD   / 4HPA   /,
     1       PITM   / 4HPITM /,            POAP   / 4HPOAP /,
     2       POVE   / 4HPOVE /,            PVEC   / 4HPVEC /
      DATA   BWD    / 4HB    /,            K4WD   / 4HK4   /
      DATA   OUTP   / 4HOUTP /,            RANG   / 4HRANG /
      DATA   DVEC   / 4HDVEC,4HUDVF, 4HUDVT       /
      DATA   NDBVAR / 6      /
      DATA   DBVAR  / 4HGORL,4HPVEC, 4HUVEC,4HPFTL, 4HOVEC,4HOVC2 /
      DATA   DBVAL  / 4HGEOM,4H4   , 4HPGG ,4H    , 4HUGV ,4H
     1              , 4H    ,4H    , 4HOUGV,4H1   , 4HOUGV,4H
     2              , 4HGEOM,4H4   , 4HPGG ,4H    , 4HUGV ,4H
     3              , 4H    ,4H    , 4HOUGV,4H1   , 4HOUGV,4H
     4              , 4HLAMA,4H    , 4H    ,4H    , 4HPHIG,4H
     5              , 4H    ,4H    , 4HOPHI,4HG1  , 4HOPHI,4HG
     6              , 4HGEOM,4H4   , 4HPPF ,4H    , 4HUGV ,4H
     7              , 4HPPF ,4H    , 4HOUGV,4H1   , 4HOUGV,4H
     8              , 4HGEOM,4H4   , 4HPPT ,4H    , 4HUGV ,4H
     9              , 4HTOL ,4H    , 4HOUGV,4H1   , 4HOUGV,4H     /
      DATA   NR3VAR / 5      /
      DATA   R3VAR  / 4HUAPH,4HPGVC, 4HPSVC,4HDYNT, 4HQVEC /
      DATA   R3VAL  / 4HULV ,4HPGS , 4HPSS ,4H    , 4HQG
     1              , 4HULV ,4HPGS , 4HPSS ,4H    , 4HQG
     2              , 4HPHIA,4H    , 4H    ,4HLAMA, 4HQG
     3              , 4HUDVF,4H    , 4H    ,4HPPF , 4HQPC
     4              , 4HUDVT,4HPPT , 4HPST ,4HTOL , 4HQP          /
      DATA   NCOM   / 25 /
      DATA   COMND  /
     1                4HSUBS ,1    , 4HRUN  ,2
     3              , 4HENDD ,2    , 4HCOMB ,3
     5              , 4HREDU ,4    , 4HSOLV ,5
     7              , 4HRECO ,6    , 4HMREC ,6
     9              , 4HBREC ,7    , 4HMRED ,9
     1              , 4HCRED ,13   , 4HDEST ,10
     3              , 4HEDIT ,10   , 4HEQUI ,10
     5              , 4HSOFP ,10   , 4HDELE ,10
     7              , 4HRENA ,10   , 4HSOFI ,11
     9              , 4HSOFO ,11   , 4HREST ,11
     1              , 4HDUMP ,11   , 4HCHEC ,11
     3              , 4HCOMP ,11   , 4HAPPE ,11
     5              , 4HPLOT ,12   /
      DATA   SUBNAM / 4HASDM,4HAP  /
C
C
      CALL CONMSG (ASD1,2,0)
      DO 10 I  = 64,68
   10 IOTIT(I) = BLANK
      DO 20 I  = 1,16
   20 IHEAD(I) = NHEAD(I)
      CALL PAGE
      NZ   = KORSZ(Z(1))
      BUF1 = NZ - IBUF + 1
      BUF2 = BUF1 - IBUF
      BUF3 = BUF2 - IBUF
C
C     INITIALIZE THE CASE CONTROL FILE
C
      CALL OPEN (*2620,CASE,Z(BUF2),1)
      CALL CLOSE (CASE,1)
      IOPEN = 1
      NOPEN = BUF3 - 1
      IF (NOPEN .LE. 100) CALL MESAGE (-8,100-NOPEN,SUBNAM)
      FIRST = .TRUE.
      SKIP  = .FALSE.
      ISOPT = 0
C
C     SET NUMBER OF POSSIBLE COMMANDS HERE
C
C     SET LAST WORD INDICATER
C
      I6777 = RSHIFT(COMPLF(0),1)
C
C     READ FIRST CARD AFTER CEND
C
      ASSIGN 70 TO IREAD
      GO TO 50
   30 IF (SKIP) GO TO 60
      IF (NLINES .GE. NLPP) CALL PAGE
      NLINES = NLINES + 1
      WRITE (OUTT,40) CARD
   40 FORMAT (1H ,4X,20A4)
   50 CALL XREAD (*2600,CARD)
      CALL XRCARD (OCARD,200,CARD)
      IF (OCARD(1).GT.0 .AND. OCARD(2).EQ.BLANK) GO TO 30
      IF (OCARD(1) .EQ. 0) GO TO 30
      IF (OCARD(2).EQ.TITL .OR. OCARD(2).EQ.KBEG) GO TO 2600
   60 SKIP = .FALSE.
      GO TO IREAD, (70,90,330,630)
C                      90?  NOT ASSIGNED BY ANYBODY    G.CHAN  4/93
C
   70 IF (OCARD(1).GT.0 .AND. OCARD(2).EQ.COMND(1,1)) GO TO 100
C
C     NO SUBSTRUCTURE CARD
C
      WRITE (OUTT,80) UFM
      NLINES = NLINES + 2
C
   80 FORMAT (A23,' 6001. SUBSTRUCTURE DATA IS REQUIRED WITH THIS ',
     1       'APPROACH')
      NOGO  = 1
   90 PHASE = 2
      ALTER = .FALSE.
      SKIP  = .TRUE.
      ICOM  = 1
      IF (OCARD(2) .EQ. ENDS) GO TO 2200
      GO TO 130
C
C     PROCESS SUBSTRUCTURE CARD
C
  100 CNAME = COMND(1,1)
      J = OCARD(1)*2
      DO 110 I = 1,NPHASE
      IF (OCARD(J+1) .NE. PHS(I)) GO TO 110
      PHASE = I
      ALTER = .TRUE.
      ICOM  = 1
      GO TO 130
  110 CONTINUE
C
C     NO PHASE IS DEFINED
C
      WRITE (OUTT,120) UWM
      NLINES = NLINES +2
  120 FORMAT (A25,' 6002, INCORRECT PHASE DATA')
      ALTER = .FALSE.
      NOGO  = 1
      ICOM  = 1
      PHASE = 2
C
C     FOUND PHASE. TURN BANDIT OFF IF PHASE IS 2
C
  130 IF (PHASE .EQ. 2) BANDIT = -1
      J    = 2
      IAPP = IABS(SYS(21))
      IF (IAPP .NE. 2) ALTER = .FALSE.
      IAP2 = SYS(69)/10
      IF (IAP2 .EQ. 1) ALTER = .FALSE.
      SOL  = 1
      IF (.NOT. ALTER) GO TO 200
      FILE = PTAPE
      KALT = 0
      KFILE= 0
      CALL OPEN (*2620,PTAPE,Z(BUF1),0)
  140 CALL SKPFIL (PTAPE,1)
      KFILE = KFILE + 1
      CALL READ (*2620,*150,PTAPE,FNAME,7,1,NWORDS)
  150 CONTINUE
      IF (FNAME(1) .NE.NXALT) GO TO 160
      KALT = KFILE
C
      GO TO 140
  160 IF (FNAME(1) .NE. NXCSA) GO TO 140
      ALTFL = .FALSE.
      SOL = 1
      IF (IAPP .EQ. 3) GO TO 180
      CALL READ (*2620,*180,PTAPE,II,6,0,NWDS)
      SOL = II(5)
  180 CALL REWIND (PTAPE)
      IF (KALT .NE. 0) ALTFL = .TRUE.
      IF (ALTFL) GO TO 190
      CALL SKPFIL (PTAPE,KFILE)
      GO TO 200
  190 CALL SKPFIL (PTAPE,KALT)
      CALL FWDREC (*2620,PTAPE)
      CALL READ (*2620,*200,PTAPE,ALTS,2,1,NWDS)
C
C     NO XALTER FILE
C
C     OPEN CASE FILE FOR SUBSTRUCTURE DATA OR TITLE
C
  200 IF (PHASE .EQ. 3) GO TO 300
      FILE = CASE
      CALL OPEN (*2620,CASE,Z(BUF2),1)
      CALL WRITE (CASE,NCASES,2,1)
      FILE = SCRT
C
C     SET UP INITAL VALUES
C
  300 IAC   = 0
      ISTEP = 0
      NDBS  = 0
      DRYFLG= 1
      OBITS = 55
      IF (SOL .EQ. 1) OBITS = 5
      IF (SOL .EQ. 2) OBITS = 7
      IF (SOL .EQ. 3) OBITS = 3
      IF (SOL .EQ. 8) OBITS = 55
      IF (SOL .EQ. 9) OBITS = 55
      NEWBT = OBITS
      RECOV = .FALSE.
      SOLVE = .FALSE.
      IAPP  =  SYS(21)
      IF (IAPP .EQ. 3) ALTER = .FALSE.
      IF (.NOT.ALTER ) GO TO 310
      CALL OPEN (*2620,SCRT,Z(BUF3),1)
      II(1) = NXALT
      II(2) = NXL2
      CALL WRITE (SCRT,II,2,1)
  310 CONTINUE
      NSOF = 0
      ISOF = 1
      NNAME(1) = INPT
      STAT = 1
      LENGTH(1)= 100
      PASWD(1) = BLANK
      PASWD(2) = BLANK
C
C     READ PASSWORD AND SOF DECLARATIONS
C
      INEX = 0
  320 ASSIGN 330 TO IREAD
      GO TO 30
  330 IF (OCARD(2) .NE. PASS) GO TO 340
      K = 4
      IF (OCARD(5) .EQ. EQSN) K = 6
      PASWD(1) = OCARD(K)
      PASWD(2) = OCARD(K+1)
      GO TO 320
  340 IF (OCARD(2) .NE. SOF) GO TO 380
      K = 4
      IF (OCARD(5) .NE. LPAR) GO TO 350
      K = 9
      ISOF = OCARD(7)
  350 IF (ISOF.LT.0 .OR. ISOF.GT.10) GO TO 370
      NSOF = NSOF + 1
      IF (OCARD(K+1) .EQ. EQSN) K = K + 2
      IF (OCARD(K+4).EQ.JNEW .OR. OCARD(K+5).EQ.JNEW) STAT = 0
      NNAME (ISOF) = OCARD(K  )
      LENGTH(ISOF) = OCARD(K+3)
      IF (OCARD(K+2) .EQ. -1) GO TO 320
      LENGTH(ISOF) = 100
      IF (NLINES+3 .GT. NLPP) CALL PAGE
      NLINES = NLINES + 3
      IF (.NOT.SKIP) WRITE (OUTT,40) CARD
      WRITE  (OUTT,360) UWM,ISOF
  360 FORMAT (A25,', SOF(',I2,') FILESIZE NOT SPECIFIED. DEFAULT OF ',
     1       '100K WORDS WILL BE ALLOCATED',/)
      ASSIGN 330 TO IREAD
      IF (SKIP) GO TO 60
      GO TO 50
  370 WRITE (OUTT,790) UFM
      NLINES = NLINES + 1
      NOGO = 1
      GO TO 320
  380 IF (INEX .EQ. 1) GO TO 640
      INEX = 1
      SKIP = .TRUE.
      ICNEXT = 1
C
C     START PROCESSING SUBSTRUCTURE COMMAND CARDS HERE
C     TOP OF COMMAND LOOP
C
  400 ICOM = ICNEXT
      IF ( OCARD(2) .EQ. ENDS) GO TO 2100
      DO 410 L = 1,30
  410 CDATA(L) = OCARD(L)
  420 CNAME = COMND(1,ICOM)
      JCOM  = COMND(2,ICOM)
      IF (ICOM.EQ.6 .AND. SOL.GT.3) JCOM = 8
      REJECT = .FALSE.
      GO TO (430,440,450,460,470,480,490,500,510,520,530,540,550), JCOM
  430 CALL ASCM01 (CNAME,PHASE,SOL,NOGO)
      GO TO 600
  440 CALL ASCM02 (CNAME,PHASE,SOL,NOGO)
      GO TO 600
  450 CALL ASCM03 (CNAME,PHASE,SOL,NOGO)
      GO TO 600
  460 CALL ASCM04 (CNAME,PHASE,SOL,NOGO)
      GO TO 600
  470 CALL ASCM05 (CNAME,PHASE,SOL,NOGO)
      GO TO 600
  480 CALL ASCM06 (CNAME,PHASE,SOL,NOGO)
      GO TO 600
  490 CALL ASCM07 (CNAME,PHASE,SOL,NOGO)
      GO TO 600
  500 CALL ASCM08 (CNAME,PHASE,SOL,NOGO)
      GO TO 600
  510 CALL ASCM09 (CNAME,PHASE,SOL,NOGO)
      GO TO 600
  520 CALL ASCM10 (CNAME,PHASE,SOL,NOGO)
      GO TO 600
  530 CALL ASCM11 (CNAME,PHASE,SOL,NOGO)
      GO TO 600
  540 CALL ASCM12 (CNAME,PHASE,SOL,NOGO)
      GO TO 600
  550 CALL ASCM13 (CNAME,PHASE,SOL,NOGO)
  600 JX = 0
      ISTEP = ISTEP + 1
C
C     TRANSFER RAW DMAP TO WORKING AREA
C
      M = IRDM - 1
      DO 610 J = 1,NRDM
      DO 610 I = 1,18
      M = M + 1
      DMAP(I,J) = IDAT(M)
  610 CONTINUE
C
C     READ IN EXTRAS, FIND IN OPTION LIST, STOP AT NEXT COMMAND
C
  620 ASSIGN 630 TO IREAD
      GO TO 30
  630 IF (OCARD(2).EQ.PASS .OR. OCARD(2).EQ.SOF) GO TO 330
  640 IF (REJECT) GO TO 2090
      IF (ITEMP(2) .EQ. DOLSN) GO TO 620
      IF (ITEMP(2) .EQ.  ENDS) GO TO 810
      IF (ITEMP(2) .NE.  OPTI) GO TO 660
      NEWBT = 0
      I2 = 4
      IF (ITEMP(5) .EQ. EQSN) I2 = 6
      DO 650 I = 1,6
      J = 2*I + I2 - 2
      IF (ITEMP(J) .EQ. KWD) NEWBT = ORF(NEWBT,1)
      IF (ITEMP(J) .EQ. MWD) NEWBT = ORF(NEWBT,2)
      IF (ITEMP(J) .EQ. PWD) NEWBT = ORF(NEWBT,4)
      IF (ITEMP(J) .EQ.PAWD) NEWBT = ORF(NEWBT,8)
      IF (ITEMP(J) .EQ. BWD) NEWBT = ORF(NEWBT,16)
      IF (ITEMP(J) .EQ.K4WD) NEWBT = ORF(NEWBT,32)
  650 CONTINUE
      IF (ANDF(NEWBT,12) .EQ. 12) GO TO 780
      IF (ISTEP .LE. 1) OBITS = NEWBT
      GO TO 620
  660 CONTINUE
      IF (NXTRA .EQ. 0) GO TO 760
      M = IXTRA - 1
      DO 670 I = 1,NXTRA
      M = M + 1
      IF (ITEMP(2) .EQ. IDAT(M)) GO TO 680
  670 CONTINUE
C
C     CARD IS NOT AN EXTRA
C
      GO TO 760
C
C     FOUND AN EXTRA, STORE SEQUENTIALLY AS PAIRS OF TWO WORD ITEMS
C
  680 JX = JX + 1
      EXTRA(1,JX) = ITEMP(2)
      I2 = 4
      IF (ITEMP(5) .EQ. EQSN) I2 = 6
      EXTRA(2,JX) = ITEMP(I2  )
      EXTRA(3,JX) = ITEMP(I2+1)
C
C     SPECIAL OUTPUT EXTRA
C
      IF (ITEMP(2) .NE. OUTP) GO TO 700
      EXTRA(2,JX) = -1
      EXTRA(3,JX) = 0
  690 IF (ITEMP(I2).NE.-1 .OR. ITEMP(I2+1).LE.0 .OR. ITEMP(I2+1).GT.31)
     1    GO TO 620
      J = LSHIFT(1,ITEMP(I2+1)-1)
      EXTRA(3,JX) = ORF(EXTRA(3,JX),J)
      I2 = I2 + 2
      GO TO 690
  700 CONTINUE
      IF (ITEMP(2) .NE. RANG) GO TO 720
      JX = JX + 1
      EXTRA(1,JX) = RANG
      I2 = I2 + 2
      IF (ITEMP(I2).EQ.-1 .OR. ITEMP(I2).EQ.-2) GO TO 710
      EXTRA(2,JX) = EXTRA(2,JX-1)
      EXTRA(3,JX) = EXTRA(3,JX-1)
      EXTRA(3,JX-1) = 0
      GO TO 620
  710 EXTRA(2,JX) = ITEMP(I2)
      EXTRA(3,JX) = ITEMP(I2+1)
      GO TO 620
  720 CONTINUE
      IF (EXTRA(1,JX) .NE. RUN) GO TO 620
      EXTRA(3,JX) = BLANK
      EXTRA(2,JX) = IDRY
      IF (ITEMP(I2) .EQ.   DRY) GO TO 620
      IF (ITEMP(I2) .NE. GORUN) GO TO 730
      EXTRA(2,JX) = IDG
      GO TO 620
  730 IF (ITEMP(I2) .NE. STEP) GO TO 740
      EXTRA(2,JX) = ISTP
      GO TO 620
  740 IF (ITEMP(I2) .NE. DRYGO) GO TO 750
      DRYFLG = 0
      GO TO 620
  750 JX = JX - 1
      GO TO 620
C
C      CHECK AND SET IF COMMAND CARD
C
  760 DO 770 I = 2,NCOM
      ICNEXT = I
      IF (OCARD(2) .EQ. COMND(1,I)) GO TO 800
  770 CONTINUE
  780 WRITE (OUTT,790) UFM
      NLINES = NLINES +2
  790 FORMAT (A23,' 6003. ILLEGAL COMMANDS OR OPTIONS DEFINED ON NEXT ',
     1       'CARD')
      NOGO = 1
      GO TO 620
C
C     FOR PHASE 3 RECOVERY, CHANGE RECO TO BREC
C
  800 IF (PHASE.NE.3 .OR. COMND(1,ICNEXT).NE.NREC) GO TO 810
      OCARD(2) = NBREC
      ICNEXT = 9
  810 CONTINUE
C
      GO TO ( 820,1030,2200,1100,1200,1300,1400,1400,1700,1200,
     1       1200,1500,1500,1500,1500,1500,1500,1730,1730,1730,
     2       1730,1730,1730,1730,1900), ICOM
C
C     SUBSTRUCTURE   PHASES
C         PHASE 1
C      VARIABLES,     NO.     TYPE      POSITION      DEFINITION
C                     1,2,3    I           1    ALTE,R.F. REMOVE NUMBERS
C                     4,5,6    I           4    ALTE,R.F. REMOVE NUMBERS
C                     7,8,9                     ALTE,R.F. REMOVE NUMBERS
C                     10,11,12                  SAVE,-1, PLOT SET ID
C                 1   13,14,15                  RUN ,-1, RUN  FLAG
C                 1   16,17,18                  NAME, SUBS NAME
C
  820 GO TO (830,900,1000), PHASE
  830 NVAR = 24
      NOUT = 0
      DO 840 I = 1,NVAR
  840 VAR(I,1) = 0
      VAR(1,8) = PITM
      VAR(2,8) = PVEC
      VAR(3,8) = BLANK
      IF (ANDF(OBITS,8) .NE. 0) VAR(2,8) = PAPP
      DO 850 I = 1,JX
      DO 850 J = 1,3
      VAR(J,I+4) = EXTRA(J,I)
  850 CONTINUE
      NX   = JX + 4
      INAM = 0
      IRUN = 0
      ISAV = 0
C
C     CHECK FOR REQUIRED NAME
C
      DO 860 I = 5,NX
      IF (VAR(1,I) .EQ.  NAME) INAM = I
      IF (VAR(1,I) .EQ.   RUN) IRUN = I
      IF (VAR(1,I) .EQ. NSAVE) ISAV = I
  860 CONTINUE
C
C     NO NAME DEFINED IS A LEVEL 3 ERROR
C
      IF (INAM .LE. 0) GO TO 2640
      IF (IRUN .NE. 0) GO TO 870
      IRUN = NX + 1
      VAR(1,IRUN) =  RUN
      VAR(2,IRUN) = ISTP
      VAR(3,IRUN) = BLANK
      NX = NX + 1
  870 CONTINUE
      IF (ISAV .NE. 0) GO TO 880
      VAR(1,NX+1) = NSAVE
      VAR(2,NX+1) = -1
      VAR(3,NX+1) = 0
  880 CONTINUE
      M = IPH - 1
      DO 890 I = 1,4
      M = M + 2
      VAR(1,I) = ALT1
      VAR(2,I) = IDAT(M-1)
      VAR(3,I) = IDAT(M  )
  890 CONTINUE
      GO TO 2000
C
C     PHASE 2 PROCESS
C
  900 IF (JX .GT. 0) GO TO 910
      JX = 1
      EXTRA(1,1) = RUN
      EXTRA(2,1) = ISTP
      EXTRA(3,1) = BLANK
  910 VAR(1,1) = ALT1
      VAR(2,1) = 4
      IF (SOL .EQ. 1) VAR(2,1) = 5
      VAR(3,1) = 0
C
      DO 920 J = 1,JX
      DO 920 I = 1,3
      VAR(I,J+1) = EXTRA(I,J)
  920 CONTINUE
      NVAR = 3*(1+JX)
      NOUT = 0
      DO 930 I = 1,5
      DMAP(1,I) = -1
  930 CONTINUE
      GO TO 2000
C
C     PHASE 3 PROCESSING
C     NORMALLY THIS IS A RESTART, IF NOT THE DATA WILL BE REGENERATED
C
 1000 NVAR = 6
      VAR(1,1) = ALT1
      VAR(2,1) = IDAT(IPH)
      VAR(3,1) = IDAT(IPH+1)
      VAR(1,2) = RUN
      VAR(2,2) = ISTP
      VAR(3,2) = BLANK
      IF (JX .LT. 1) GO TO 1010
      IF (EXTRA(1,1) .EQ. RUN) VAR(2,2) = EXTRA(2,1)
 1010 NOUT = 0
      DO 1020 I = 1,5
      DMAP(1,I) = -1
 1020 CONTINUE
      GO TO 2000
C
C     RUN COMMAND (SOMETIMES AN EXTRA)
C
 1030 I2 = 4
      IF (CDATA(5) .EQ. EQSN) I2 = 6
      VAR(1,1) = CDATA(2)
      VAR(2,1) = ISTP
      VAR(3,1) = BLANK
      IF (CDATA(I2) .EQ. STEP) GO TO 1040
      VAR(2,1) = IDRY
      IF (CDATA(I2) .EQ. DRYGO) DRYFLG = 0
 1040 IF (DRYFLG .EQ. 0) GO TO 2080
      NVAR = 3
      NOUT = 0
      GO TO 2000
C
C     COMBINE OPERATION, USES SUBROUTINE COMBO
C
 1100 CALL COMBO (CDATA,JX,EXTRA,IAC,NASUB,NS,VAR(1,3),IER)
      NVAR = 3*(5+JX+3*NS)
      VAR(1,1) = NS
      VAR(2,1) = 0
      VAR(3,1) = 0
      VAR(1,2) = NSTP
      VAR(2,2) =-1
      VAR(3,2) = ISTEP
      NVAR = NVAR + 3
      VAR(NVAR+1,1) = PITM
      VAR(NVAR+2,1) = PVEC
      VAR(NVAR+3,1) = BLANK
      IF (ANDF(OBITS,8) .NE. 0) VAR(NVAR+2,1) = PAPP
      NVAR = NVAR + 3
      NOUT = NVAR
      IF (IER) 2640,2000,2640
C
C     REDUCE, MREDUCE, CREDUCE OPERATIONS - VARIABLES TO BE SET ARE
C
C                STEP - STEP NO.
C                NONA - NO. OF SUBSTRUCTURE A
C                NONB - NO. OF SUBSTRUCTURE B
C                NAMA - NAME OF SUBSTRUCTURE A
C                NAMB - NAME OF SUBSTRUCTURE B
C                PREC - PRECISION FLAG
C                PITM - LOAD ITEM
C                POIT - LOAD TRANSFORMATION ITEM
C
 1200 CALL REDU (CDATA,JX,EXTRA,IAC,NASUB,NVAR,VAR(1,2),IPREC,IER)
      VAR(1,1) = STEP
      VAR(2,1) = -1
      VAR(3,1) = ISTEP
      NVAR     = NVAR+3
      VAR(NVAR+1,1) = PITM
      VAR(NVAR+2,1) = PVEC
      VAR(NVAR+3,1) = BLANK
      VAR(NVAR+4,1) = POIT
      VAR(NVAR+5,1) = POVE
      VAR(NVAR+6,1) = BLANK
      IF (ANDF(OBITS,8) .EQ. 0) GO TO 1210
      VAR(NVAR+2,1) = PAPP
      VAR(NVAR+5,1) = POAP
 1210 NVAR = NVAR + 6
      NOUT = NVAR
      IF (IER) 2090,2000,2090
C
C     SOLVE OPERATION - VARIABLES ARE SUBSTRUCTURE NAME AND ALTER NO S
C
 1300 NVAR = 33
      NOUT = NVAR
      I2   = 4
      IF (CDATA(5) .EQ. EQSN) I2 = 6
      IF (CDATA(1)*2 .LT. I2) GO TO 2660
      VAR(1,8) = NAME
      VAR(2,8) = CDATA(I2  )
      VAR(3,8) = CDATA(I2+1)
      NSOLV1   = CDATA(I2  )
      NSOLV2   = CDATA(I2+1)
C
C     FIND STRUCTURE NUMBER
C
      NS = IAC
      IF (NS .EQ. 0) GO TO 1320
      DO 1310 I = 1,NS
      IF (CDATA(I2).EQ.NASUB(1,I) .AND. CDATA(I2+1).EQ.NASUB(2,I))
     1    GO TO 1330
 1310 CONTINUE
 1320 CONTINUE
      NS = NS+1
      NASUB(1,NS) = CDATA(I2  )
      NASUB(2,NS) = CDATA(I2+1)
      I = NS
 1330 VAR(1, 9) = NANO
      VAR(2, 9) = -1
      VAR(3, 9) = I
      VAR(1,10) = STEP
      VAR(2,10) = -1
      VAR(3,10) = ISTEP
      IF (JCOM .EQ. 8) GO TO 1340
      VAR(1,11) = NSOL
      VAR(2,11) = BLANK
      VAR(3,11) = BLANK
      GO TO 1350
 1340 VAR(1,11) = DVEC(1)
      VAR(2,11) = DVEC(2)
      VAR(3,11) = BLANK
      IF (SOL .EQ. 9) VAR(2,11) = DVEC(3)
 1350 CONTINUE
      IF (SOL .EQ. 1) GO TO 1360
      IF (SOL .EQ. 2) VAR(2,11) = NH1A
      IF (SOL .EQ. 3) VAR(2,11) = NH1
      NVAR = 36
      NOUT = 36
      VAR(1,12) = MSKP
      VAR(2,12) = BLANK
      VAR(3,12) = BLANK
 1360 CONTINUE
      IAC = NS
      M   = IPH - 1
      DO 1370 I = 1,7
      M = M + 2
      VAR(1,I) = ALT1
      VAR(2,I) = IDAT(M-1)
      VAR(3,I) = IDAT(M  )
 1370 CONTINUE
      SOLVE = .TRUE.
      GO TO 2000
C
C     RECOVERY PHASE2 - VARIABLES ARE SOLUTION STRUCTURE NAME,
C                       PRINT, NAME AND/OR SAVE, NAME+ALTER
C
 1400 I2 = 4
      IF (CDATA(5) .EQ. EQSN) I2 = 6
      IF (CDATA(1)*2 .LT. I2) GO TO 2660
      VAR(1,1) = NCASES(1)
      VAR(2,1) = NCASES(2)
      VAR(3,1) = BLANK
      VAR(1,2) = NAME
      VAR(2,2) = CDATA(I2  )
      VAR(3,2) = CDATA(I2+1)
      ISOL = SOL
      IF (SOL  .GT. 3) ISOL = ISOL - 4
      IF (ICOM .EQ. 8) ISOL = 3
      DO 1410 I = 1,NDBVAR
      VAR(1,I+2) = DBVAR(I)
      VAR(2,I+2) = DBVAL(1,I,ISOL)
      IF (ICOM.EQ.8 .AND. I.LT.4) VAR(2,I+2) = BLANK
      VAR(3,I+2) = DBVAL(2,I,ISOL)
      IF (ICOM.EQ.8 .AND. I.LT.4) VAR(3,I+2) = BLANK
 1410 CONTINUE
      VAR(1,9) = NSOL
      VAR(2,9) = -1
      VAR(3,9) = SOL
      IF (ICOM .EQ. 8) VAR(3,9) = 3
      VAR(1,10) = STEP
      VAR(2,10) = -1
      VAR(3,10) = ISTEP
      IF (JX .LE. 0) GO TO 1430
      DO 1420 I = 1,JX
      DO 1420 K = 1,3
      VAR(K,I+10) = EXTRA(K,I)
 1420 CONTINUE
 1430 IF (SOLVE) GO TO 1440
C
C     SAVE OPTION BITS AND SET TO ZERO
C
      OBITS   = 0
      VAR(1,4)= 0
      VAR(2,1)= NCASEC(2)
 1440 RECOV   = .TRUE.
      NVAR    = 3*JX + 30
      NOUT    = NVAR
      GO TO 2000
C
C     UTILITY COMMANDS - USE SOFOUT MODULE TO MANIPULATE SOF FILE(S).
C     DESTROY, EDITOUT, EQUIV, PRINT, DELETE, AND RENAME
C
 1500 NVAR = 0
      I2   = 4
      KWDS = 1
C
C     DECODE AND STORE COMMAND DATA FROM HEADER CARD
C
 1510 KWDS = KWDS + 1
      IF (CDATA(I2+1).EQ.LPAR .OR. CDATA(I2+1).EQ.EQSN) I2 = I2 + 2
      VAR(2,KWDS) = CDATA(I2  )
      VAR(3,KWDS) = CDATA(I2+1)
      I2 = I2 + 2
      IF (CDATA(I2).EQ.I6777 .OR. CDATA(I2+1).EQ.I6777) GO TO 1520
      IF (VAR(2,KWDS) .EQ. -1) I2 = I2 + 1
      IF (KWDS .LT. 8) GO TO 1510
C
C     INSERT VARIABLE NAMES
C
 1520 J = ICOM - 11
      VAR(1,1) = OPER
      VAR(2,1) = CNAME
      VAR(3,1) = BLANK
      JOPT = 0
      GO TO (1530,1540,1550,1580,1590,1550), J
C
C      DESTROY NAME
C
 1530 VAR(1,2) = NAME
      NVAR = 2
      GO TO 1620
C
C     EDITOUT(CODE) = NAME
C
 1540 GO TO 1580
C
C     EQUIV A,B   +PREFIX = B CARD
C
 1550 VAR(1,2) = NAME
      VAR(1,3) = NEW
      NVAR = 3
      IF (J    .EQ. 6) GO TO 1620
      IF (KWDS .LT. 2) GO TO 2640
      IF (JX   .LT. 1) GO TO 1560
      VAR(1,4) = EXTRA(1,1)
      VAR(2,4) = EXTRA(2,1)
      VAR(3,4) = EXTRA(3,1)
      NVAR = 4
      GO TO 1620
 1560 WRITE  (OUTT,1570) UWM
 1570 FORMAT (A25,' 6004, NO PREFIX DEFINED AFTER EQUIVALENCE.')
      NLINES = NLINES + 2
      GO TO 1620
C
C     PRINT(CODE) = NAME,ITM1,ITM2,ITM3,ITM4,ITM5
C
 1580 IF (VAR(2,2).NE. -1) GO TO 1590
      VAR(1,2) = OPTI
      JOPT = 1
      I2   = 3
      GO TO 1600
 1590 I2   = 2
 1600 VAR(1,I2) = NAME
      NS = KWDS - I2
      DO 1610 I = 1,NS
      J  = I2 + I
 1610 VAR(1,J) = ITMN(I)
      NVAR = KWDS
 1620 NOUT = 0
      IF (JOPT .EQ. 1) GO TO 1630
      NVAR = NVAR + 1
      VAR(1,NVAR) = OPTI
      VAR(2,NVAR) = -1
      VAR(3,NVAR) = 32
      IF (ICOM .EQ. 15) VAR(3,NVAR) = 0
 1630 NVAR = 3*NVAR
      GO TO 2000
C
C     RECOVERY, PHASE 3.  VARIABLES ARE NAME, SOL, STEP, PREC, UAPH,
C     PGVC, PSVC, DYNT, QVEC
C
 1700 I2 = 4
      IF (CDATA(I2) .EQ. EQSN) I2 = I2 + 2
      M = IPH - 1
      DO 1710 I = 1,3
      M = M + 2
      VAR(1,I) = ALT1
      VAR(2,I) = IDAT(M-1)
      VAR(3,I) = IDAT(M  )
 1710 CONTINUE
      ISOL = SOL
      IF (SOL .GT. 3) ISOL = ISOL - 4
      DO 1720 I = 1,NR3VAR
      VAR(1,I+3) = R3VAR(I)
      VAR(2,I+3) = R3VAL(I,ISOL)
      VAR(3,I+3) = BLANK
 1720 CONTINUE
      VAR(1, 9) = NAME
      VAR(2, 9) = CDATA(I2  )
      VAR(3, 9) = CDATA(I2+1)
      VAR(1,10) = NSOL
      VAR(2,10) = -1
      VAR(3,10) = SOL
      VAR(1,11) = STEP
      VAR(2,11) = -1
      VAR(3,11) = ISTEP
      VAR(1,12) = NPREC
      VAR(2,12) = -1
      VAR(3,12) = IPREC
      NVAR      = 36
      NOUT      = 0
      GO TO 2000
C
C     EXIO OPERATIONS -
C     SOFIN, SOFOUT, RESTORE, DUMP, CHECK, COMPRESS AND APPEND
C
 1730 NVAR = 42
      NOUT = 0
C
      DO 1740 I = 1,14
      VAR(1,I) = 100 + I
      VAR(2,I) = EXDEF(1,I)
 1740 VAR(3,I) = EXDEF(2,I)
C
C     DECODE COMMAND CARD
C
      VAR(2,5) = CDATA(2)
      VAR(3,5) = CDATA(3)
      I2 = 4
      IF (CDATA(5) .NE. LPAR) GO TO 1750
      VAR(2,4) = CDATA(6)
      VAR(3,4) = CDATA(7)
      I2 = 8
 1750 IF (CDATA(I2+1) .EQ. EQSN) I2 = I2 + 2
      IF (CDATA(I2).EQ.I6777 .OR. CDATA(I2+1).EQ.LPAR) GO TO 1830
      VAR(2,3) = CDATA(I2  )
      VAR(3,3) = CDATA(I2+1)
      IF (CDATA(I2+2) .EQ. I6777) GO TO 1760
      VAR(2,2) = CDATA(I2+2)
      VAR(3,2) = CDATA(I2+3)
C
C     SET EXTRAS
C
 1760 NN = 0
      IF (JX .EQ.0) GO TO 1820
      DO 1810 I = 1,JX
      IF (EXTRA(1,I) .NE. MACH) GO TO 1770
      K = 1
      GO TO 1800
 1770 IF (EXTRA(1,I) .NE. POSI) GO TO 1780
      K = 6
      GO TO 1800
 1780 IF (EXTRA(1,I) .NE. ITEM) GO TO 1790
      K = 7
      GO TO 1800
 1790 IF (EXTRA(1,I) .NE. NAME) GO TO 1810
      NN = NN + 1
      K  = NN + 7
 1800 VAR(2,K) = EXTRA(2,I)
      VAR(3,K) = EXTRA(3,I)
 1810 CONTINUE
C
C     SET DISK FIELD FOR COMPRESS ETC
C
 1820 IF (ICOM .GE. 24) VAR(2,2) = DISK
      GO TO 2000
 1830 WRITE  (OUTT,1840) UFM
 1840 FORMAT (A23,' 6008, ILLEGAL INPUT ON THE PREVIOUS COMMAND.', /5X,
     1       'MISSING FILE NAME FOR IO OPERATION')
      NLINES = NLINES + 3
      GO TO 2090
C
C     PLOT COMMAND
C          FORMAT
C     PLOT NAME
C
 1900 NVAR = 6
      NOUT = 0
      I2   = 4
      IF (CDATA(I2) .EQ. EQSN) I2 = 6
      IF (CDATA(1)*2 .LT.  I2) GO TO 2640
      VAR(1,1) = NAME
      VAR(2,1) = CDATA(I2  )
      VAR(3,1) = CDATA(I2+1)
      VAR(1,2) = STEP
      VAR(2,2) = -1
      VAR(3,2) = ISTEP
C
C     PROCESS VARIABLE CHARACTERS IF DMAP IS TO BE GENERATED
C
 2000 IF (.NOT.ALTER) GO TO 2080
      CALL ASPRO (DMAP,IVAR,NVAR,OBITS,SOL)
C
C     RESET OPTION BITS IF DUMMY VALUE WAS USED
C
      OBITS = NEWBT
      IF (NOGO .GE. 1) GO TO 2080
C
C     WRITE  DMAP ON  SCRATCH FILE
C
      DO 2070 I = 1,NRDM
C
C     GO TO SPECIAL CODE IF AN ALTER CARD
C
      IF (DMAP(1,I) .NE. ALT1) GO TO 2060
C
      II(1) = DMAP(2,I)
      II(2) = DMAP(3,I)
      IF (.NOT.ALTFL) GO TO 2050
      IF (II(2)  .EQ. 0) II(2)  = -II(1)
 2010 IF (ALTS(2).EQ. 0) ALTS(2)= -ALTS(1)
C
      IF (ALTS(1) .GT. IABS(II(2))) GO TO 2050
C
C     OVERLAPPING DMAP
C
      IF (IABS(ALTS(2)) .GE. II(1)) GO TO 2660
C
C     ALTERS ENCOUNTERED BEFORE NEW ALTERS
C
      IF (ALTS(2) .LT. 0) ALTS(2) = 0
      CALL WRITE (SCRT,ALTS,2,1)
      FILE = PTAPE
 2020 CALL READ (*2040,*2030,PTAPE,ALTS,18,1,NWDS)
C
C     DMAP DATA ENCOUNTERED
C
      CALL WRITE (SCRT,ALTS,18,1)
      GO TO 2020
C
C     MORE ALTERS ENCOUNTERED
C
 2030 IF (NWDS .EQ. 2) GO TO 2010
C
C     END OF USER ALTERS
C
 2040 ALTFL = .FALSE.
C
C     INSERT NEW DMAP ALTERS
C
 2050 IF (II(2) .LT. 0) II(2) = 0
C
      CALL WRITE (SCRT,II,2,1)
      GO TO 2070
C
C     WRITE ORDINARY DMAP DATA HERE
C
 2060 CALL WRITE (SCRT,DMAP(1,I),18,1)
 2070 CONTINUE
C
C     WRITE COMMAND AND VARIABLE DATA ON CASE CONTROL FILE
C
 2080 IF (PHASE .EQ. 3) GO TO 2090
      II(1) = CNAME
      II(2) = NOUT
      CALL WRITE (CASE,II,2,0)
      CALL WRITE (CASE,IVAR,NOUT,1)
C
C
 2090 IF (ITEMP(2) .EQ. ENDS) GO TO 2100
C
      REJECT = .FALSE.
C
      GO TO 400
C
C     ENDSUBS ENCOUNTERED,  STOP PROCESS
C     ENSURE THAT A RECOVER ALWAYS EXISTS FOLLOWING A SOLVE
C
 2100 IF (PHASE.NE.2 .OR. .NOT.SOLVE .OR. RECOV) GO TO 2110
C
C     CONSTRUCT A DUMMY INPUT CARD
C
      CDATA(1) = 4
      CDATA(2) = NREC
      CDATA(3) = BLANK
      CDATA(4) = NSOLV1
      CDATA(5) = NSOLV2
      SKIP = .TRUE.
      ICOM = 7
      GO TO 420
C
C     CHECK SOF AND PASSWORD DECLARATIONS
C
 2110 IF (PASWD(1) .NE. BLANK) IF (NSOF) 2120,2120,2140
 2120 CALL PAGE2 (2)
      WRITE  (OUTT,2130) UFM
 2130 FORMAT (A23,' 6011, SOF DATA PASSWORD MISSING')
      NOGO = 1
 2140 CONTINUE
      IBLKSZ = IBUF - 4
      IF (MCHN.EQ.3 .OR. MCHN.EQ.4) IBLKSZ = IGINOB
      FACT = 1000.0/IBLKSZ
      DO 2150 I = 1,10
      LENGTH(I) = LENGTH(I)*FACT
      JX = LENGTH(I)/2
 2150 LENGTH(I) = 2*JX
C
C     INITIALIZE DIRECT ACCESS FILES FOR IBM 360/370 MACHINES
C
      IF (MCHN .EQ. 2) CALL SOFIOI
 2200 CALL PAGE2 (1)
      WRITE  (OUTT,2210)
 2210 FORMAT (7X,7HENDSUBS)
      IF (.NOT. ALTER) GO TO 2540
C
C     WRAP UP DMAP
C     PUT LABEL ON END OF ALTER DECK
C
      CNAME = COMND(1,3)
      CALL ASCM02 (CNAME,PHASE,SOL,NOGO)
      M = IRDM + 18
      CALL WRITE (SCRT,IDAT(M),18,1)
C
C     REPEAT ALTER IF DRYGO IS ON
C
      IF (DRYFLG .NE. 0) GO TO 2230
      DO 2220 I = 1,3
      M = M + 18
      CALL WRITE (SCRT,IDAT(M),18,1)
 2220 CONTINUE
C
C     JUMP TO FINISH OF RIGID FORMAT
C
 2230 IF (PHASE .NE. 3) CALL WRITE (SCRT,IDAT(91),18,1)
      IFILE = PTAPE
      OFILE = SCRT
      IFIN  = .FALSE.
      PASS2 = .FALSE.
      IF (.NOT.ALTFL) GO TO 2240
      IF (ALTS(2) .LT. 0) ALTS(2)=0
      CALL WRITE (SCRT,ALTS,2,1)
      GO TO 2270
 2240 CALL EOF (SCRT)
      CALL READ (*2620,*2250,PTAPE,II,9,1,NW)
C
C     COPY REMAINDER OF PROBLEM TAPE TO SCRATCH FILE
C
 2250 IFIN = .FALSE.
 2260 IF (II(1) .EQ. NXCSA) IFIN = .TRUE.
      CALL WRITE (OFILE,II,NW,1)
C
C
      IREC = 1
 2270 CALL READ (*2290,*2280,IFILE,Z(IOPEN),NOPEN,0,NWDS)
C
      CALL WRITE (OFILE,Z(IOPEN),NOPEN,0)
      GO TO 2270
C
C     SET ALTER FLAG ON SOL RECORD OF XCSA FILE
C
 2280 IF (IFIN .AND. PASS2 .AND. IREC.EQ.1) Z(IOPEN+2) = 1
      CALL WRITE (OFILE,Z(IOPEN),NWDS,1)
      IREC = IREC + 1
      GO TO 2270
 2290 CONTINUE
      CALL EOF (OFILE)
      IF (IFIN) GO TO 2300
      CALL READ (*2620,*2260,IFILE,II,9,1,NW)
      GO TO 2260
 2300 CALL CLOSE (IFILE,1)
      CALL CLOSE (OFILE,3)
      IF (PASS2) GO TO 2530
C
C     PRINT OR PUNCH ALTER DECK HERE
C
C     DIAG 23 REQUESTS PRINT
C     DIAG 24 REQUESTS PUNCH
C
      CALL SSWTCH (23,KPRT)
      CALL SSWTCH (24,KPCH)
      IF (KPRT.EQ.0 .AND. KPCH.EQ.0) GO TO 2510
      ICARD = 0
      CALL OPEN (*2620,SCRT,Z(BUF3),0)
C
 2310 CONTINUE
      CALL PAGE
      WRITE  (OUTT,2320)
 2320 FORMAT (5X,'ALTER DECK ECHO')
      NLINES = NLINES + 1
 2330 IF (NLINES.GE.NLPP .AND. KPRT.NE.0) GO TO 2310
      CALL READ (*2500,*2360,SCRT,CARD,18,1,NW)
C
C     DMAP CARD
C
      NC = 18
      IF (KPRT .NE. 0) WRITE (OUTT,2340) ICARD,(CARD(I),I=1,NC)
      IF (KPRT .NE. 0) NLINES = NLINES + 1
      IF (KPCH .NE. 0) WRITE (LPCH,2350) (CARD(I),I=1,NC)
      ICARD = ICARD + 1
 2340 FORMAT (4X,I5,4X,18A4)
 2350 FORMAT (18A4)
      GO TO 2330
 2360 IF (ICARD .GT. 0) GO TO 2370
      ICARD = 1
      GO TO 2330
C
C      ALTER CARD
C
 2370 IF (CARD(2) .LE. 0) GO TO 2400
      IF (KPRT .NE. 0) WRITE (OUTT,2380) ICARD,ALT1,ALT2,(CARD(I),I=1,2)
      IF (KPRT .NE. 0) NLINES = NLINES + 1
      IF (KPCH .NE. 0) WRITE (LPCH,2390) ALT1,ALT2,CARD(1),CARD(2)
      ICARD = ICARD + 1
 2380 FORMAT (5X,I4,4X,2A4,I8,1H, ,I3)
 2390 FORMAT (2A4,I8,1H,,I3)
      GO TO 2330
 2400 IF (KPRT .NE. 0) WRITE (OUTT,2410)ICARD,ALT1,ALT2,CARD(1)
      IF (KPRT .NE. 0) NLINES = NLINES + 1
      IF (KPCH .NE. 0) WRITE (LPCH,2420) ALT1,ALT2,CARD(1)
      ICARD = ICARD + 1
 2410 FORMAT (5X,I4,4X,2A4,I8)
 2420 FORMAT (2A4,I8)
      GO TO 2330
C
C     END OF FILE
C
 2500 CALL CLOSE (SCRT,0)
 2510 CONTINUE
      CALL OPEN (*2620,SCRT,Z(BUF3),0)
      CALL OPEN (*2620,PTAPE,Z(BUF1),0)
C
C     COPY SCRATCH TO PROB.TAPE, FIRST POSITION PTAPE TO XALTER OR
C     XCSA FILE
C
      ISKP = KFILE
      IF (KALT .NE. 0) ISKP = KALT
      CALL SKPFIL (PTAPE,ISKP)
      CALL CLOSE (PTAPE,2)
      CALL OPEN (*2620,PTAPE,Z(BUF1),3)
      CALL READ (*2620,*2520,SCRT,II,9,1,NW)
 2520 PASS2 = .TRUE.
      IFIN  = .FALSE.
      IFILE = SCRT
      OFILE = PTAPE
      GO TO 2260
 2530 CONTINUE
C
      CALL CLOSE (SCRT,1)
C
C     CLOSE CASE CONTROL
C
 2540 IF (PHASE .NE. 3) CALL CLOSE (CASE,2)
      CALL CONMSG (ASD2,2,0)
      RETURN
C
C     USER FATAL MESSAGES
C
 2600 WRITE  (OUTT,2610) UFM
 2610 FORMAT (A23,' 6017, MISSING ENDSUBS CARD.')
      CALL MESAGE (-37,0,SUBNAM)
C
C     SYSTEM ERROR MESSAGES
C
 2620 WRITE  (OUTT,2630) SFM,FILE
 2630 FORMAT (A25,' 6007, IMPROPER FILE SETUP FOR ',A4)
      NLINES = NLINES + 2
      GO TO 2680
 2640 WRITE  (OUTT,2650) UFM,CNAME
 2650 FORMAT (A23,' 6005, ILLEGAL OR MISSING DATA FOR THE PREVIOUS ',
     1       'COMMAND - ',A4)
      NLINES = NLINES + 2
      NOGO   = 1
      GO TO 2090
 2660 WRITE  (OUTT,2670) UFM,ALTS(1),ALTS(2),II
 2670 FORMAT (A23,' 6006, DMAP ALTERS  ',2I8, /5X,
     1        'INTERFERE WITH SUBSTRUCTURE ALTERS  ',2I4)
      NLINES = NLINES + 3
      NOGO   = 1
      GO TO 2090
 2680 WRITE  (OUTT,2690) UFM
 2690 FORMAT (A23,' 6009, UNRECOVERABLE ERROR CONDITIONS IN SUBROUTINE',
     1       ' ASDMAP')
      NLINES = NLINES + 2
      NOGO   = 3
      CALL CLOSE (SCRT ,1)
      CALL CLOSE (CASE ,1)
      CALL CLOSE (PTAPE,1)
      RETURN
      END

      SUBROUTINE SSGSLT (SLT,NEWSLT,EST)
C
C     THIS SUBROUTINE OF THE SSG1 MODULE COPIES THE SLT TO ANOTHER
C     FILE.  IN THE COPYING PROCESS ANY -QVOL-, -QBDY1-, -QBDY2-, OR
C     -QVECT- EXTERNAL LOAD TYPE DATA FOUND WILL BE ALTERED SO AS TO
C     REPLACE THEIR ELEMENT ID REFERENCES WITH THE APPROPRIATE SILS, AND
C     MISC. CONSTANTS.  THE EXTERNAL LOADS WILL BE PREPARED AS USUAL FOR
C     THESE AND OTHER LOAD CARD TYPES VIA SUBROUTINE EXTERN.
C
      IMPLICIT INTEGER (A-Z)
      LOGICAL         ANY,NOGO,BGCORE,BGOPEN
      REAL            AREA,HC1,HC2,HC3,Q0,PIOVR4,XX,YY,ZZ,
     1                RBUF(50),RZ(1),RECPT(100)
      INTEGER         MCB(7),ECPT(100),BUF(50),SUBR(2),TYPE(25,4)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG / UFM,UWM,UIM,SFM
      COMMON /BLANK / NROWSP
      COMMON /GPTA1 / NELEM,LAST,INCR,NE(1)
      COMMON /SYSTEM/ KSYSTM(65)
      COMMON /NAMES / RD,RDREW,WRT,WRTREW,CLSREW,CLS
      COMMON /ZZZZZZ/ Z(1)
      EQUIVALENCE     (KSYSTM(1),SYSBUF  ), (KSYSTM(2),OUTPT  ),
     1                (ECPT(1)  ,RECPT(1)), (BUF(1)   ,RBUF(1)),
     2                (Z(1)     ,RZ(1)   )
      DATA    SUBR  / 4HSSGS,4HLT    /    , NOEOR,EOR/ 0, 1 /
      DATA    BGPDT / 102/
      DATA    PIOVR4/ 0.7853981634E0 /
      DATA    CBAR  / 34 /
      DATA    CROD  /  1 /
      DATA    CONROD/ 10 /
      DATA    CTUBE /  3 /
      DATA    CTRMEM/  9 /
      DATA    CTRIA1/  6 /
      DATA    CTRIA2/ 17 /
      DATA    CQDMEM/ 16 /
      DATA    CQDMM1/ 62 /
      DATA    CQDMM2/ 63 /
      DATA    CQUAD4/ 64 /
      DATA    CTRIA3/ 83 /
      DATA    CQUAD1/ 19 /
      DATA    CQUAD2/ 18 /
      DATA    CTRIRG/ 36 /
      DATA    CTRPRG/ 37 /
      DATA    CTETRA/ 39 /
      DATA    CWEDGE/ 40 /
      DATA    CHEXA1/ 41 /
      DATA    CHEXA2/ 42 /
      DATA    CHBDY / 52 /
      DATA    CIHEX1/ 65 /
      DATA    CIHEX2/ 66 /
      DATA    CIHEX3/ 67 /
C
      DATA    NTYPES/ 25 /
C
C          SLT            NEWSLT         FLAG FOR       DATA
C          WORDS-IN       WORDS-OUT      SPEC-PROC      CORE-LOCAT
C          ==========     ==========     ==========     ==========
C     FORCE
      DATA TYPE( 1,1)/ 6/,TYPE( 1,2)/ 6/,TYPE( 1,3)/ 0/,TYPE( 1,4)/ 0/
C     MOMENT
      DATA TYPE( 2,1)/ 6/,TYPE( 2,2)/ 6/,TYPE( 2,3)/ 0/,TYPE( 2,4)/ 0/
C     FORCE1
      DATA TYPE( 3,1)/ 4/,TYPE( 3,2)/ 4/,TYPE( 3,3)/ 0/,TYPE( 3,4)/ 0/
C     MOMNT1
      DATA TYPE( 4,1)/ 4/,TYPE( 4,2)/ 4/,TYPE( 4,3)/ 0/,TYPE( 4,4)/ 0/
C     FORCE2
      DATA TYPE( 5,1)/ 6/,TYPE( 5,2)/ 6/,TYPE( 5,3)/ 0/,TYPE( 5,4)/ 0/
C     MOMNT2
      DATA TYPE( 6,1)/ 6/,TYPE( 6,2)/ 6/,TYPE( 6,3)/ 0/,TYPE( 6,4)/ 0/
C     SLOAD
      DATA TYPE( 7,1)/ 2/,TYPE( 7,2)/ 2/,TYPE( 7,3)/ 0/,TYPE( 7,4)/ 0/
C     GRAV
      DATA TYPE( 8,1)/ 5/,TYPE( 8,2)/ 5/,TYPE( 8,3)/ 0/,TYPE( 8,4)/ 0/
C     PLOAD
      DATA TYPE( 9,1)/ 5/,TYPE( 9,2)/ 5/,TYPE( 9,3)/ 0/,TYPE( 9,4)/ 0/
C     RFORCE
      DATA TYPE(10,1)/ 6/,TYPE(10,2)/ 6/,TYPE(10,3)/ 0/,TYPE(10,4)/ 0/
C     PRESAX
      DATA TYPE(11,1)/ 6/,TYPE(11,2)/ 6/,TYPE(11,3)/ 0/,TYPE(11,4)/ 0/
C     QHBDY
      DATA TYPE(12,1)/ 7/,TYPE(12,2)/ 7/,TYPE(12,3)/ 0/,TYPE(12,4)/ 0/
C     QVOL
      DATA TYPE(13,1)/ 2/,TYPE(13,2)/12/,TYPE(13,3)/ 1/,TYPE(13,4)/ 0/
C     QBDY1
      DATA TYPE(14,1)/ 2/,TYPE(14,2)/10/,TYPE(14,3)/ 1/,TYPE(14,4)/ 0/
C     QBDY2
      DATA TYPE(15,1)/ 5/,TYPE(15,2)/10/,TYPE(15,3)/ 1/,TYPE(15,4)/ 0/
C     QVECT
      DATA TYPE(16,1)/ 5/,TYPE(16,2)/19/,TYPE(16,3)/ 1/,TYPE(16,4)/ 0/
C     PLOAD3
      DATA TYPE(17,1)/38/,TYPE(17,2)/38/,TYPE(17,3)/ 0/,TYPE(17,4)/ 0/
C     PLOAD1
      DATA TYPE(18,1)/ 7/,TYPE(18,2)/ 7/,TYPE(18,3)/ 0/,TYPE(18,4)/ 0/
C     PLOADX
      DATA TYPE(19,1)/ 5/,TYPE(19,2)/ 5/,TYPE(19,3)/ 0/,TYPE(19,4)/ 0/
C     SPCFLD  (WORDS OUT IS A DUMMY VALUE-IT WILL REALLY BE 3*NROWSP)
      DATA TYPE(20,1)/ 5/,TYPE(20,2)/ 4/,TYPE(20,3)/ 0/,TYPE(20,4)/ 0/
C     CEMLOOP
      DATA TYPE(21,1)/12/,TYPE(21,2)/12/,TYPE(21,3)/ 0/,TYPE(21,4)/ 0/
C     GEMLOOP  ,BOTH INPUT AND OUTPUT ARE DUMMY.
      DATA TYPE(22,1)/ 5/,TYPE(22,2)/ 4/,TYPE(22,3)/ 0/,TYPE(22,4)/ 0/
C     MDIPOLE (OUTPUT VALUE IS A DUMMY)
      DATA TYPE(23,1)/ 9/,TYPE(23,2)/ 5/,TYPE(23,3)/ 0/,TYPE(23,4)/ 0/
C     REMFLUX    (OUTPUT VALUE IS A DUMMY)
      DATA TYPE(24,1)/ 5/,TYPE(24,2)/ 5/,TYPE(24,3)/ 0/,TYPE(24,4)/ 0/
C     PLOAD4
      DATA TYPE(25,1)/11/,TYPE(25,2)/11/,TYPE(25,3)/ 0/,TYPE(25,4)/ 0/
C
C                     SLT                         NEWSLT
C     CARD=TYPE       WORDS IN                    WORDS OUT
C     =========       ========                    =========
C
C     QVOL=13         1 = QV                      1 = NUM-POINTS(1 TO 8)
C                     2 = ELEMENT ID              2 = ELEMENT ID
C                                                 3 THRU 10 = 8 SILS
C                                                 11 = COEFICIENT
C                                                 12 = TYPE 1 = 1 DIMEN
C                                                           2 = 2 DIMEN
C                                                           3 = BELL-EL
C                                                           4 = SOLID
C
C     QBDY1=14        1 = Q0                      1 = TYPE (1 TO 5)
C                     2 = ELEMENT ID              2 = ELEMENT ID
C                                                 3 THRU  6 = 4 SILS
C                                                 7 THRU 10 = 4 COEFS.
C
C     QBDY2=15        1 = ELEMENT ID              1 = ELEMENT ID
C                     2 = Q01                     2 = TYPE (1 TO 5)
C                     3 = Q02                     3 THRU  6 = 4 SILS
C                     4 = Q03                     7 THRU 10 = 4 COEFS.
C                     5 = Q04
C
C     QVECT=16        1 = Q0                      1 THRU 4 = 4 SILS
C                     2 = E1                      5 = ELEMENT ID
C                     3 = E2                      6 = TYPE (1 TO 5)
C                     4 = E3                      7 THRU 10 = 4 COEFS.
C                     5 = ELEMENT ID              11 = E1
C                                                 12 = E2
C                                                 13 = E3
C                                                 14 THRU 16 = V1 VECTOR
C                                                 17 THRU 19 = V2 VECTOR
C
C
C
C     SPCFLD=20       1 = CID                     1 THRU 3*NROWSP=
C                     2 = HCX                     TOTAL HC VALUES AT
C                     3 = HCY                     THE GRID POINTS
C                     4 = HCZ
C                     5 = GRID ID OR -1
C
C
C     CEMLOOP=21                                  SAME AS FOR
C     GEMLOOP=22                                  SPCFLD
C
C
C
C     MDIPOLE=23      1  =CID                     SAME AS
C                     2-4=LOCATION OF DIPOLE      SPCFLD
C                     5-7=DIPOLE MOMENT
C                     8  =MIN. DISTANCE
C                     9  =MAX. DISTANCE
C
C     REMFLUX=24      SAME INPUT AS               1 THRU 3*(NO. OF
C                     SPCFLD EXCEPT               ELEMENTS)= TOTAL
C                     WORD 5 IS ELEMENT ID        REMANENT FLUX DENSITY
C                                                 FOR EACH ELEMNT IN
C                                                 ORDER ON EST
C
C     THE ELEMENT ID MUST REMAIN IN THE SAME LOCATION ON OUTPUT.
C
C
C     SET UP CORE AND BUFFERS. (PG BUFFER IS OPEN IN SSG1)
C
      BGCORE=.FALSE.
      BGOPEN=.FALSE.
      NOGO  = .FALSE.
      BUF1  = KORSZ(Z) - 2*SYSBUF - 2
      BUF2  = BUF1 - SYSBUF - 2
      BUF3  = BUF2 - SYSBUF - 2
      CORE  = BUF3 - 1
      IF (CORE .LT. 100) CALL MESAGE (-8,0,SUBR)
C
C     OPEN SLT, AND NEWSLT.  COPY HEADER RECORD ACROSS.
C
      CALL OPEN (*650,SLT,Z(BUF1),RDREW)
      CALL OPEN (*660,NEWSLT,Z(BUF2),WRTREW)
      CALL READ (*670,*10,SLT,Z,CORE,EOR,IWORDS)
      CALL MESAGE (-8,0,SUBR)
   10 CALL FNAME (NEWSLT,Z)
      CALL WRITE (NEWSLT,Z,IWORDS,EOR)
C
C     READ TRAILER OF SLT AND GET COUNT OF LOAD SET RECORDS.
C
      MCB(1) = SLT
      CALL RDTRL (MCB)
      NRECS  = MCB(2)
      MCB(1) = NEWSLT
      CALL WRTTRL (MCB)
C
C     PROCESSING OF LOAD SET RECORDS IF ANY.
C
      IF (NRECS) 620,620,20
   20 I = 1
   21 CONTINUE
      ANY  = .FALSE.
      NCORE= NRECS+2
      IFIRST = 0
C
C     ZERO OUT EXISTANCE FLAGS
C
      DO 25 K = 1,NTYPES
      TYPE(K,4) = 0
   25 CONTINUE
C
C     READ CARD TYPE AND COUNT OF CARDS
C
   30 CALL READ (*670,*110,SLT,BUF,2,NOEOR,IWORDS)
   35 CONTINUE
      ITYPE  = BUF(1)
      ENTRYS = BUF(2)
C
C     CHECK FOR KNOWN TYPE
C
      IF (ITYPE.LE.NTYPES .AND. ITYPE.GT.0) GO TO 50
      WRITE  (OUTPT,40) SFM,ITYPE
   40 FORMAT (A25,' 3094, SLT LOAD TYPE',I9,' IS NOT RECOGNIZED.')
      CALL MESAGE (-61,0,SUBR)
C
C     CHECK FOR SPECIAL PROCESSING.
C
   50 INCNT = TYPE(ITYPE,1)
C
C     IF TYPE IS CEMLOOP,SPCFLD,MDIPOLE, OR GEMLOOP,GO TO 800 FOR
C     SPECIAL PROCESSING. GO TO 1000 FOR REMFLUX PROCESSING
C
      IF (ITYPE.GE.20 .AND. ITYPE.LE.23) GO TO 800
      IF (ITYPE .EQ. 24) GO TO 1000
      OUTCNT = TYPE(ITYPE,2)
      IFLAG  = TYPE(ITYPE,3)
C
      IF (IFLAG) 90,90,60
C
C     OK BRING DATA INTO CORE.
C
   60 JCORE = NCORE + 1
      TYPE(ITYPE,4) = JCORE
      Z(JCORE  ) = ITYPE
      Z(JCORE+1) = ENTRYS
      JCORE = JCORE + 2
      NCORE = JCORE + ENTRYS*OUTCNT - 1
      IF (NCORE .GT. CORE) CALL MESAGE (-8,0,SUBR)
      DO 70 J = JCORE,NCORE
      Z(J) = 1
   70 CONTINUE
      KCORE = JCORE
C
C     READ IN THE LOAD ENTRIES.
C
      DO 80 J = JCORE,NCORE,OUTCNT
      CALL FREAD (SLT,Z(J),INCNT,0)
   80 CONTINUE
      ID = 2
      IF (ITYPE .EQ. 15) ID = 1
      IF (ITYPE .EQ. 16) ID = 5
      CALL SORT (0,0,OUTCNT,ID,Z(KCORE),NCORE-KCORE+1)
      ANY = .TRUE.
      GO TO 30
C
C     NO SPECIAL PROCESSING OF THIS LOAD TYPE THUS JUST COPY IT ACROSS.
C
   90 CALL WRITE (NEWSLT,BUF,2,NOEOR)
      DO 100 J = 1,ENTRYS
      CALL FREAD (SLT,BUF,INCNT,0)
      CALL WRITE (NEWSLT,BUF,OUTCNT,NOEOR)
  100 CONTINUE
      GO TO 30
C
C     ALL DATA NOW IN CORE FOR THIS LOAD SET.
C
  110 IF (.NOT. ANY) GO TO 600
C
C     THE EST IS NOW PROCESSED FOR ELEMENT TYPES CHECKED BELOW.
C
      CALL GOPEN (EST,Z(BUF3),RDREW)
C
C     READ ELEMENT TYPE
C
  120 CALL READ (*500,*690,EST,ELTYPE,1,NOEOR,IWORDS)
      IF (ELTYPE .EQ. CBAR  ) GO TO 140
      IF (ELTYPE .EQ. CROD  ) GO TO 150
      IF (ELTYPE .EQ. CONROD) GO TO 150
      IF (ELTYPE .EQ. CTUBE ) GO TO 160
      IF (ELTYPE .EQ. CTRMEM) GO TO 170
      IF (ELTYPE .EQ. CTRIA1) GO TO 180
      IF (ELTYPE .EQ. CTRIA2) GO TO 170
      IF (ELTYPE .EQ. CTRIA3) GO TO 175
      IF (ELTYPE .EQ. CQDMEM) GO TO 190
      IF (ELTYPE .EQ. CQDMM1) GO TO 190
      IF (ELTYPE .EQ. CQDMM2) GO TO 190
      IF (ELTYPE .EQ. CQUAD1) GO TO 200
      IF (ELTYPE .EQ. CQUAD2) GO TO 190
      IF (ELTYPE .EQ. CQUAD4) GO TO 195
      IF (ELTYPE .EQ. CTRIRG) GO TO 210
      IF (ELTYPE .EQ. CTRPRG) GO TO 220
      IF (ELTYPE .EQ. CTETRA) GO TO 230
      IF (ELTYPE .EQ. CWEDGE) GO TO 240
      IF (ELTYPE .EQ. CHEXA1) GO TO 250
      IF (ELTYPE .EQ. CHEXA2) GO TO 250
      IF (ELTYPE .EQ. CIHEX1) GO TO 252
      IF (ELTYPE .EQ. CIHEX2) GO TO 254
      IF (ELTYPE .EQ. CIHEX3) GO TO 256
      IF (ELTYPE .EQ. CHBDY ) GO TO 360
  130 CALL FWDREC (*700,EST)
      GO TO 120
C
C     BAR
C
  140 ESTWDS = 42
      GRID1  = 2
      POINTS = 2
      IAREA  = 17
      ITYPE  = 1
      GO TO 260
C
C     ROD AND CONROD
C
  150 ESTWDS = 17
      GRID1  = 2
      POINTS = 2
      IAREA  = 5
      ITYPE  = 1
      GO TO 260
C
C     TUBE
C
  160 ESTWDS = 16
      GRID1  = 2
      POINTS = 2
      IAREA  = 5
      ITYPE  = 1
      GO TO 260
C
C     TRMEM AND TRIA2
C
  170 ESTWDS = 21
      GRID1  = 2
      POINTS = 3
      IAREA  = 7
      ITYPE  = 2
      GO TO 260
C
C     TRIA3
C
  175 ESTWDS = 39
      GRID1  = 2
      POINTS = 3
      IAREA  = 7
      ITYPE  = 2
      GO TO 260
C
C     TRIA1
C
  180 ESTWDS = 27
      GRID1  = 2
      POINTS = 3
      IAREA  = 7
      ITYPE  = 2
      GO TO 260
C
C     QDMEM AND QUAD2
C
  190 ESTWDS = 26
      GRID1  = 2
      POINTS = 4
      IAREA  = 8
      ITYPE  = 2
      GO TO 260
C
C     QUAD4
C
  195 ESTWDS = 45
      GRID1  = 2
      POINTS = 4
      IAREA  = 8
      ITYPE  = 2
      GO TO 260
C
C     QUAD1
C
  200 ESTWDS = 32
      GRID1  = 2
      POINTS = 4
      IAREA  = 8
      ITYPE  = 2
      GO TO 260
C
C     TRIRG
C
  210 ESTWDS = 19
      GRID1  = 2
      POINTS = 3
      IAREA  = 0
      ITYPE  = 3
      GO TO 260
C
C     TRAPRG
C
  220 ESTWDS = 24
      GRID1  = 2
      POINTS = 4
      IAREA  = 0
      ITYPE  = 3
      GO TO 260
C
C     TETRA
C
  230 ESTWDS = 23
      GRID1  = 3
      POINTS = 4
      IAREA  = 0
      ITYPE  = 4
      GO TO 260
C
C     WEDGE
C
  240 ESTWDS = 33
      GRID1  = 3
      POINTS = 6
      IAREA  = 0
      ITYPE  = 4
      GO TO 260
C
C     HEXA1 AND HEXA2
C
  250 ESTWDS = 43
      GRID1  = 3
      POINTS = 8
      IAREA  = 0
      ITYPE  = 4
      GO TO 260
C
C     IHEX1
C
  252 ESTWDS = 55
      GRID1  = 3
      POINTS = 8
      IAREA  = 0
      ITYPE  = 4
      GO TO 260
C
C     IHEX2 AND IHEX3 ARE NOT IMPLEMENTED DUE TO
C        1. ECPT ARRAY TOO SMALL IN THIS ROUTINE
C        2. QVOL ROUTINE CAN NOT HANDLE SOLID ELEMENTS HAVING MORE THAN
C           8 GRID POINTS
C
C     IHEX2
C
  254 ESTWDS = 127
      GRID1  = 3
      POINTS = 20
      IAREA  = 0
      ITYPE  = 4
      GO TO 130
C
C     IHEX3
C
  256 ESTWDS = 199
      GRID1  = 3
      POINTS = 32
      IAREA  = 0
      ITYPE  = 4
      GO TO 130
C
C     MISC. ELEMENTS OF EST FILE.  DO QVOL REFERENCES.
C
  260 IF (TYPE(13,4) .EQ. 0) GO TO 130
      IDQVOL = TYPE(13,4) + 3
      ENTRYS = Z(IDQVOL-2)
      IWORDS = 12
      J1 = IDQVOL
      J2 = J1 + ENTRYS*IWORDS
      IDPTR = 2
      ASSIGN 280 TO IRETRN
  270 CALL READ (*700,*120,EST,ECPT,ESTWDS,NOEOR,IFLAG)
C
C     LOOK FOR THIS ELEMENT ID AMONG QVOL DATA.
C
      CALL BISLOC (*270,ECPT(1),Z(IDQVOL),12,ENTRYS,JPOINT)
C
C     MATCH FOUND ON ID. COMPUTE ZERO POINTER TO ZERO WORD OF QVOL ENTRY
C
      INDEX = IDQVOL + JPOINT - 3
      GO TO 710
C
C     IF COEFICIENT IS NOT AN INTEGER 1 ENTRY HAS BEEN ALTERED BEFORE.
C
  280 DO 350 INDEX = K1,K2,IWORDS
      IF (Z(INDEX+11) .EQ. 1) GO TO 300
      WRITE  (OUTPT,290) UWM,ELTYPE,ECPT(1),Z(I+2)
  290 FORMAT (A25,' 3095, ELEMENT TYPE',I9,' WITH ID =',I9,
     1       ', REFERENCED BY A QVOL CARD IN LOAD SET',I9,1H,, /5X,
     2       'IS NOT BEING USED FOR INTERNAL HEAT GENERATION IN THIS ',
     3       'LOAD SET BECAUSE ANOTHER ELEMENT TYPE WITH THE SAME ID',
     4       /5X,'HAS ALREADY BEEN USED.')
      GO TO 350
C
C     ALTER ENTRY IN PLACE (NOTE THE CONVERSION TABLE ABOVE)
C
C     GET AREA FACTOR FROM ECPT AND REVISE ENTRY.
C
  300 IF (IAREA .EQ. 0) GO TO 310
      AREA = RECPT(IAREA)
      IF (ELTYPE.EQ.CTUBE) AREA = PIOVR4*(AREA**2-(AREA-2.*RECPT(6))**2)
      GO TO 320
  310 AREA = 1.0
  320 I1 = INDEX + 3
      I2 = INDEX + 10
      DO 330 J = I1,I2
      Z(J) = 0
  330 CONTINUE
      I2 = I1 + POINTS - 1
      IGRID = GRID1
      DO 340 J = I1,I2
      Z(J)  = ECPT(IGRID)
      IGRID = IGRID+1
  340 CONTINUE
      RZ(INDEX+11) = RZ(INDEX+1)*AREA
      Z(INDEX + 1) = POINTS
      Z(INDEX +12) = ITYPE
  350 CONTINUE
      GO TO 270
C
C     HBDY ELEMENTS OF EST FILE.  DO QBDY1, QBDY2, AND QVECT REFERENCES.
C
C
C     BUF(3) IS SET TO 0 AS A FLAG TO TELL IF HBDY HAS BEEN CALLED FOR
C     THIS ELEMENT.
C
  360 IF (TYPE(14,4)+TYPE(15,4)+TYPE(16,4) .EQ. 0) GO TO 130
      IDBDY1 = TYPE(14,4) + 3
      IDBDY2 = TYPE(15,4) + 2
      IDQVEC = TYPE(16,4) + 6
      QBDY1S = Z(IDBDY1-2)
      QBDY2S = Z(IDBDY2-1)
      QVECTS = Z(IDQVEC-5)
      ESTWDS = 53
C
C     READ AN HBDY ELEMENT ECPT FROM THE EST.
C
  370 CALL READ (*700,*120,EST,ECPT,ESTWDS,NOEOR,IFLAG)
C
C     LOOK FOR ID AMONG QBDY1 DATA
C
      IF (TYPE(14,4) .EQ. 0) GO TO 410
      IWORDS = 10
      J1 = IDBDY1
      J2 = J1 + QBDY1S*IWORDS
      IDPTR = 2
      ASSIGN 380 TO IRETRN
      CALL BISLOC (*410,ECPT(1),Z(IDBDY1),10,QBDY1S,JPOINT)
C
C     MATCH FOUND.  CHECK FOR PREVIOUS REFERENCE.
C
      INDEX = IDBDY1 + JPOINT - 3
      GO TO 710
  380 DO 400 INDEX = K1,K2,IWORDS
      IF (Z(INDEX+10) .EQ. 1) GO TO 390
      WRITE  (OUTPT,382) UFM,ECPT(1)
  382 FORMAT (A23,' 2362, CHBDY CARDS WITH DUPLICATE IDS FOUND IN EST,',
     1       ' CHBDY ID NUMBER =',I9)
      NOGO = .TRUE.
      GO TO 650
C
C     ALTER ENTRY FOR OUTPUT.  GET AREA FACTORS FOR HBDY ELEMENT.
C
  390 CALL HBDY (ECPT,ECPT,2,RBUF,BUF)
      Z(INDEX +3) = BUF(3)
      Z(INDEX +4) = BUF(4)
      Z(INDEX +5) = BUF(5)
      Z(INDEX +6) = BUF(6)
      RZ(INDEX+7) = RBUF(7)*RZ(INDEX+1)
      RZ(INDEX+8) = RBUF(8)*RZ(INDEX+1)
      RZ(INDEX+9) = RBUF(9)*RZ(INDEX+1)
      RZ(INDEX+10)= RBUF(10)*RZ(INDEX+1)
      Z(INDEX +1) = ECPT(2)
  400 CONTINUE
C
C     LOOK FOR ID AMONG QBDY2 DATA.
C
  410 IF (TYPE(15,4) .EQ. 0) GO TO 450
      IWORDS = 10
      J1 = IDBDY2
      J2 = J1 + QBDY2S*IWORDS
      IDPTR = 1
      ASSIGN 420 TO IRETRN
      CALL BISLOC (*450,ECPT(1),Z(IDBDY2),10,QBDY2S,JPOINT)
C
C     MATCH FOUND.  CHECK FOR PREVIOUS REFERENCE.
C
      INDEX = IDBDY2 + JPOINT - 2
      GO TO 710
  420 DO 440 INDEX = K1,K2,IWORDS
      IF (Z(INDEX+10) .EQ. 1) GO TO 430
      WRITE (OUTPT,382) UFM,ECPT(1)
      NOGO = .TRUE.
      GO TO 650
C
C     ALTER ENTRY FOR OUTPUT.  GET AREA FACTORS FOR HBDY ELEMENT.
C
  430 CALL HBDY (ECPT,ECPT,2,RBUF,BUF)
      RZ(INDEX+7) = RBUF(7)*RZ(INDEX+2)
      RZ(INDEX+8) = RBUF(8)*RZ(INDEX+3)
      RZ(INDEX+9) = RBUF(9)*RZ(INDEX+4)
      RZ(INDEX+10)= RBUF(10)*RZ(INDEX+5)
      Z(INDEX +3) = BUF(3)
      Z(INDEX +4) = BUF(4)
      Z(INDEX +5) = BUF(5)
      Z(INDEX +6) = BUF(6)
      Z(INDEX +2) = ECPT(2)
  440 CONTINUE
C
C     LOOK FOR ID AMONG QVECT DATA
C
  450 IF (TYPE(16,4) .EQ. 0) GO TO 490
      IWORDS = 19
      J1 = IDQVEC
      J2 = J1 + QVECTS*IWORDS
      IDPTR = 5
      ASSIGN 460 TO IRETRN
      CALL BISLOC (*490,ECPT(1),Z(IDQVEC),19,QVECTS,JPOINT)
C
C     MATCH FOUND.  CHECK FOR PREVIOUS REFERENCE.
C
      INDEX = IDQVEC + JPOINT - 6
      GO TO 710
  460 DO 480 INDEX = K1,K2,IWORDS
      IF (Z(INDEX+19) .EQ. 1) GO TO 470
      WRITE (OUTPT,382) UFM,ECPT(1)
      NOGO = .TRUE.
      GO TO 650
C
C     ALTER ENTRY FOR OUTPUT.  GET AREA FACTORS FOR HBDY ELEMENT.
C
  470 CALL HBDY (ECPT,ECPT,3,RBUF,BUF)
      RZ(INDEX+11) = RZ(INDEX+2)
      RZ(INDEX+12) = RZ(INDEX+3)
      RZ(INDEX+13) = RZ(INDEX+4)
      RZ(INDEX+14) = RBUF(11)
      RZ(INDEX+15) = RBUF(12)
      RZ(INDEX+16) = RBUF(13)
      RZ(INDEX+17) = RBUF(14)
      RZ(INDEX+18) = RBUF(15)
      RZ(INDEX+19) = RBUF(16)
      Q0           = RZ(INDEX+1)
      Z(INDEX + 1) = BUF(3)
      Z(INDEX + 2) = BUF(4)
      Z(INDEX + 3) = BUF(5)
      Z(INDEX + 4) = BUF(6)
      Z(INDEX + 6) = ECPT(2)
      RZ(INDEX+ 7) = RBUF(7)*Q0
      RZ(INDEX+ 8) = RBUF(8)*Q0
      RZ(INDEX+ 9) = RBUF(9)*Q0
      RZ(INDEX+10) = RBUF(10)*Q0
  480 CONTINUE
  490 GO TO 370
C
C     EST HAS BEEN PASSED FOR ALL ELEMENTS.  NOW OUTPUT DATA TO NEWSLT.
C
  500 CALL CLOSE (EST,CLSREW)
      DO 590 J = 13,16
      JCORE = TYPE(J,4)
      IF (JCORE) 590,590,510
  510 NWORDS = Z(JCORE+1)*TYPE(J,2) + 2
C
C     INSURE THAT ALL ENTRYS WERE MODIFIED.
C     CHECK WORD 7 FOR NO INTEGER 1 IN TYPES 14,15, AND 16.
C     CHECK WORD 11 FOR NO INTEGER 1 IN TYPE 13.
C
      K = 8
      IF (J .EQ. 13) K = 12
      I1 = JCORE + K
      I2 = I1 + NWORDS - 3
      OUTCNT = TYPE(J,2)
      DO 580 L = I1,I2,OUTCNT
      IF (Z(L) .NE. 1) GO TO 580
      K = J - 12
      GO TO (520,530,540,550), K
  520 ID = L - 9
      GO TO 560
  530 ID = L - 5
      GO TO 560
  540 ID = L - 6
      GO TO 560
  550 ID = L - 2
      GO TO 560
  560 WRITE  (OUTPT,570) UFM,Z(ID)
  570 FORMAT (A23,' 3096, ELEMENT ID =',I9,' AS REFERENCED ON A QVOL, ',
     1       'QBDY1, QBDY2, OR QVECT LOAD CARD,', /5X,'COULD NOT BE ',
     2       'FOUND AMONG ACCEPTABLE ELEMENTS FOR THAT LOAD TYPE.')
      NOGO = .TRUE.
  580 CONTINUE
      CALL WRITE (NEWSLT,Z(JCORE),NWORDS,NOEOR)
  590 CONTINUE
C
C     COMPLETE THIS LOAD SET RECORD ON -NEWSLT-.
C
  600 CALL WRITE (NEWSLT,0,0,EOR)
      I = I+1
      IF (I .LE. NRECS) GO TO 21
C
C     COPY BALANCE OF DATA ON -SLT- TO -NEWSLT- WHATEVER IT BE.
C
  620 CALL READ (*640,*630,SLT,Z,CORE,NOEOR,IWORDS)
      CALL WRITE (NEWSLT,Z,CORE,NOEOR)
      GO TO 620
  630 CALL WRITE (NEWSLT,Z,IWORDS,EOR)
      GO TO 620
C
C     NEWSLT IS COMPLETE.
C
  640 CALL CLOSE (SLT,CLSREW)
      CALL CLOSE (NEWSLT,CLSREW)
  650 IF (NOGO) CALL MESAGE (-61,0,SUBR)
      RETURN
C
C     FATAL FILE ERRORS
C
  660 CALL MESAGE (-1,NEWSLT,SUBR)
  670 CALL MESAGE (-2,SLT   ,SUBR)
  690 CALL MESAGE (-3,EST   ,SUBR)
  700 CALL MESAGE (-2,EST   ,SUBR)
  701 CALL MESAGE (-2,BGPDT ,SUBR)
      RETURN
C
C     INTERNAL ROUTINE TO FIND THE START AND END OF ENTRYS HAVING THE
C     SAME ID IN A GIVEN CARD-TYPE SET.
C
C
C     BACK UP TO FIRST ENTRY OF THIS ID.
C
  710 JINDEX = INDEX + IDPTR - IWORDS
  720 IF (JINDEX .LT. J1) GO TO 730
      IF (Z(JINDEX) .NE. ECPT(1)) GO TO 730
      JINDEX = JINDEX - IWORDS
      GO TO 720
  730 K1 = JINDEX + IWORDS - IDPTR
C
C     FIND LAST ENTRY OF THIS ID.
C
      JINDEX = K1 + IWORDS + IDPTR
  740 IF (JINDEX .GE. J2) GO TO 750
      IF (Z(JINDEX) .NE. ECPT(1)) GO TO 750
      JINDEX = JINDEX + IWORDS
      GO TO 740
  750 K2 = JINDEX - IWORDS - IDPTR
      GO TO IRETRN, (280,380,420,460)
C
C     SPECIAL PROCESSING FOR SPCFLD,CEMLOOP,MDIPOLE, AND GEMLOOP. SET UP
C     A VECTOR FOR ALL BUT SPCFLD CARDS, COMPUTE FIELD AT EACH POINT
C     IN BGPDT. WHEN FINISHED, ALL THE E AND M CARD TYPES WILL BE
C     ACCUMULATED INTO ONE SPCFLD-LIKE CARD WITH FIELD VALUSS AT EACH
C     POINT
C
  800 IF (IFIRST .EQ. 1) GO TO 811
      IFIRST = 1
      JCORE1 = NCORE+1
      JCOREN = NCORE+3*NROWSP
      IF (JCOREN.GT.CORE) CALL MESAGE (-8,0,SUBR)
C
      DO 810 J1 = JCORE1,JCOREN
  810 RZ(J1) = 0.
C
C     ALL E AND M CARDS WILL BE COMBINED INTO ONE LOGICAL CARD OF
C     TYPE=20, 3*NROWSP VALUES HCX,HCY,HCZ AT EACH POINT IN THE MODEL.
C     FOR CEMLOOP AND GEMLOOP, WE MUST PICK UP BGPDT FOREACH POINT AND
C     COMPUTE FIELD FOR EACH LOOP
C *** 10/1/80 WE MUST ALSO FIND HC AT INTEGRATION POINTS AND CENTROIDS.
C     SO ALSO COPY SLT INFO TO NEWSLT FOR USE IN EANDM
C
C
C     1ST OCCURRENCE OF A CARD TYPE. CHECK ON TYPE
C
  811 JTYPE = ITYPE-19
      GO TO (812,840,840,840), JTYPE
C
C     SPCFLD
C
  812 BUF(1) = 20
      BUF(2) = 1
      CALL WRITE (NEWSLT,BUF,2,0)
      DO 830 J1 = 1,ENTRYS
C
C     READ ONE SPCFLD CARD
C
      CALL FREAD (SLT,BUF,5,0)
      IF (BUF(5).NE.-1) GO TO 825
C
C     BUF(1)=CID WHICH IS ASSUMED TO BE 0 FOR NOW
C
C     ALL GRIDS GET HC
C
      DO 820 J2 = JCORE1,JCOREN,3
      RZ(J2  ) = RZ(J2  )+RBUF(2)
      RZ(J2+1) = RZ(J2+1)+RBUF(3)
      RZ(J2+2) = RZ(J2+2)+RBUF(4)
  820 CONTINUE
      GO TO 830
C
  825 ISUB = NCORE+3*BUF(5)-2
      RZ(ISUB  ) = RZ(ISUB  )+RBUF(2)
      RZ(ISUB+1) = RZ(ISUB+1)+RBUF(3)
      RZ(ISUB+2) = RZ(ISUB+2)+RBUF(4)
  830 CONTINUE
C
C     DONE WITH ALL SPCFLD CARDS IN THIS LOAD SET. CHECK FOR OTHER CARD
C     TYPES IN THIS LOAD SET
C
      CALL WRITE (NEWSLT,RZ(JCORE1),3*NROWSP,0)
      GO TO 910
C
C     CEMLOOP,GEMLOOP, OR MDIPOLE
C     CHECK FOR ENOUGH CORE TO READ IN BGPDT. IF NOT, READ ONE POINT AT
C     A TIME
C
  840 IF (BGOPEN) GO TO 850
C
C     IF MODCOM(9) IS NOT SET TO NONZERO, THEN WE WILL NOT COMPUTE HCFLD
C     AT GRID POINTS FOR COILS, ETC.(ONLY SPCFLD) SINCE IT TAKES TIME
C     AND IS NOT NEEDED IN ANY SUBSEQUENT COMPUTATION. (ONLY SPCFLD INFO
C     IS NEEDED LATER. ALL OTHER HC INFO IS COMPUTED LATER) IF MODCOM(9)
C     IS SET TO NONZERO, HCFLD IS COMPUTED AT THE POINTS FOR ALL LOAD
C     TYPES AND CAN BE PRINTED FOR INFORMATIONAL PURPOSES IF DESIRED.
C
      IF (KSYSTM(65) .EQ. 0) GO TO 850
      CALL GOPEN (BGPDT,Z(BUF3),0)
      MCB(1) = BGPDT
      CALL RDTRL (MCB)
      NPTS   = MCB(2)
      BGCORE = .TRUE.
      BGOPEN = .TRUE.
      IF (JCOREN+4*NPTS.GT.CORE) BGCORE=.FALSE.
      NEXT = JCOREN+4*NPTS
      IF (.NOT.BGCORE) NEXT=JCOREN
      IF (BGCORE) CALL FREAD (BGPDT,Z(JCOREN+1),4*NPTS,0)
  850 CONTINUE
      CALL WRITE (NEWSLT,BUF,2,0)
C
      DO 900 J1 = 1,ENTRYS
C
C     READ CEMLOOP, GEMLOOP, OR MDIPOLE ENTRY
C
      IWORDS = 12
      IF (ITYPE .EQ. 22) IWORDS = 48
      IF (ITYPE .EQ. 23) IWORDS = 9
      CALL FREAD (SLT,BUF,IWORDS,0)
      CALL WRITE (NEWSLT,BUF,IWORDS,0)
      IF (KSYSTM(65) .EQ. 0) GO TO 900
C
C
C     DO THIS LOOP FOR ALL POINTS
C
      DO 890 KK = 1,NPTS
      IF (BGCORE) GO TO 880
      CALL FREAD (BGPDT,BUF,4,0)
      IF (BUF(1) .EQ. -1) GO TO 890
      XX = RBUF(2)
      YY = RBUF(3)
      ZZ = RBUF(4)
      GO TO 885
  880 JCOR = JCOREN+4*KK
      IF (Z(JCOR-3) .EQ. -1) GO TO 890
      XX = RZ(JCOR-2)
      YY = RZ(JCOR-1)
      ZZ = RZ(JCOR )
  885 IF (ITYPE .EQ. 21) GO TO 886
      IF (ITYPE .EQ. 23) GO TO 888
      CALL GELOOP (RBUF,BUF,XX,YY,ZZ,HC1,HC2,HC3)
      GO TO 887
  886 CALL AXLOOP (RBUF,BUF,XX,YY,ZZ,HC1,HC2,HC3)
      GO TO 887
  888 CALL DIPOLE (RBUF,BUF,XX,YY,ZZ,HC1,HC2,HC3)
  887 ISUB = NCORE+3*KK-2
      RZ(ISUB  ) = RZ(ISUB  )+HC1
      RZ(ISUB+1) = RZ(ISUB+1)+HC2
      RZ(ISUB+2) = RZ(ISUB+2)+HC3
C
C     GO BACK FOR ANOTHER POINT
C
  890 CONTINUE
      IF (BGCORE) GO TO 900
      CALL REWIND (BGPDT)
      CALL FWDREC (*701,BGPDT)
C
C     GET ANOTHER LOOP OR DIPOLE
C
  900 CONTINUE
C
C     CHECK IF NEXT CARD TYPE IS 21 ,22, OR 23. CARD TYPES ON SLT ARE
C     IN INCREASING CARD TYPE). IF SO, STAY HERE. OTHERWISE, WRITE OUT
C     ALL CARD TYPES GENERATING AN SPCFLD-TYPE CARD AND GOING ONTO
C     HCFLDS MUST HAVE CONSECUTIVE TYPE NUMBERS FOR THIS SPECIAL
C     PROCESSING THE GENERATED SPCFLD AND GO BACK TO NORMAL PROCESSING
C
  910 CALL READ (*670,*920,SLT,BUF,2,NOEOR,IWORDS)
      ITYPE  = BUF(1)
      ENTRYS = BUF(2)
      IF (BUF(1).GE.20 .AND. BUF(1).LE.23) GO TO 811
      IEOR = 0
      GO TO 930
  920 IEOR = 1
  930 BUF(1) =-20
      BUF(2) = 1
      CALL WRITE (NEWSLT,BUF,2,0)
      CALL WRITE (NEWSLT,RZ(JCORE1),3*NROWSP,0)
      IF (BGOPEN) CALL CLOSE (BGPDT,1)
      IF (IEOR .EQ. 1) GO TO 110
      GO TO 35
C
C     REMFLUX PROCESSING. CREATE A VECTOR OF ORDER 3N,N=NUMBER OF
C     ELEMENTS IN MODEL,N IS 1ST TRAILER WORD OF EST. THE VECTOR
C     CONTAINS TOTAL BX,BY,BZ FROM ALL REMFLUX CARDS FOR EACH ELEMENT
C     IN THE ORDER OF ELEMENTS ON EST
C
 1000 CALL GOPEN (EST,Z(BUF3),0)
      MCB(1) = EST
      CALL RDTRL (MCB)
      NEL    = MCB(2)
      JCORE1 = NCORE+1
      JCOREN = NCORE+3*NEL
      JCOREX = JCOREN+5*ENTRYS
      IF (JCOREX .GT. CORE) CALL MESAGE (-8,0,SUBR)
C
      NELS = 0
      DO 1010 J1 = JCORE1,JCOREN
 1010 RZ(J1) = 0.
C
C     READ ALL REMFLUX CARDS
C
      CALL FREAD (SLT,RZ(JCOREN+1),5*ENTRYS,0)
C
 1020 CALL READ (*1050,*690,EST,ELTYPE,1,0,IWORDS)
      IDX = (ELTYPE-1)*INCR
      ESTWDS = NE(IDX+12)
 1025 CALL READ (*700,*1020,EST,ELID,1,0,IWORDS)
      NELS = NELS+1
      ISUB = NCORE+3*NELS-2
      CALL FREAD (EST,DUM,-ESTWDS+1,0)
C
C     CHECK FOR THIS ELID AMONG THE REMFLUX CARDS
C
      DO 1040 J1 = 1,ENTRYS
      ISUB1 = JCOREN+5*J1
      IF (Z(ISUB1) .EQ.   -1) GO TO 1030
      IF (ELID .NE. Z(ISUB1)) GO TO 1040
C
C     MATCH-STORE THIS PERM MAG
C
 1030 RZ(ISUB  ) = RZ(ISUB  )+RZ(ISUB1-3)
      RZ(ISUB+1) = RZ(ISUB+1)+RZ(ISUB1-2)
      RZ(ISUB+2) = RZ(ISUB+2)+RZ(ISUB1-1)
 1040 CONTINUE
C
C     READ ANOTHER ELEMENT ID
C
      GO TO 1025
C
C     EST EXHAUSTED
C
 1050 CALL CLOSE (EST,1)
      BUF(1) = 24
      BUF(2) = 1
      CALL WRITE (NEWSLT,BUF,2,0)
      CALL WRITE (NEWSLT,RZ(JCORE1),3*NEL,0)
      GO TO 30
      END

      SUBROUTINE XCHK
C
C     THE PURPOSE OF THIS ROUTINE IS TO SAVE ON THE NEW PROBLEM NPTP
C     TAPE ALL FILES REQUESTED BY XCHK OSCAR ENTRY TOGETHER WITH ANY
C     OTHER DATA NECESSARY FOR RESTART.
C
C          ... DEFINITION OF PROGRAM VARIABLES ...
C     NPTPNT = POINTER TO GINO BUFFER FOR NEW PROBLEM NPTP TAPE
C     DPPNT  = POINTER TO GINO BUFFER FOR DATA POOL TAPE
C     FPNT   = POINTER TO GINO BUFFER FOR FILES LISTED IN FIAT TABLE
C     IOBUF  = INPUT/OUTPUT BUFFER AREA
C     IOPNT  = POINTER TO IOBUF
C     LIOBUF = LENGTH OF IOBUF
C     DICT   = PRELIMINARY FILE DICTIONARY
C     FDICT  = FINAL FILE DICTIONARY TO BE WRITTEN ON NEW PROBLEM TAPE
C     LDC    = POINTER TO LAST DICT ENTRY MADE.
C     DCPNT  = POINTER TO DICT ENTRY BEING SCANNED.
C     NPTFN  = NEW PROBLEM TAPE (NPTP) FILE NUMBER TO BE ASSIGNED
C     UCBPNT = UCB POINTER FOUND IN FIAT ENTRIES
C     MINFN  = SMALLEST DATA POOL FILE NUMBER
C     DPFCT  = DATA POOL FILE POSITION
C     OSCFN  = DATA POOL FILE NUMBER OF OSCAR FILE
C     EORFLG = END OF RECORD FLAG
C     PURGE  = TABLE OF PURGED CHECKPOINT FILES
C     LPURGE = LENGTH OF PURGE TABLE
C     PRGPNT = POINTER TO LAST PURGE ENTRY
C     REELCT = KEEPS TRACK OF HOW MANY PROBLEM TAPE REELS A FILE IS
C              USING
C     EQFLG  = EQUIVALENCE FLAG
C     DPLFLG = DATA POOL FLAG
C     EOTFLG = END OF TAPE FLAG
C     SETEOR = END OF RECORD FLAG SET
C     FNASS  = NPTP FILE NUMBER ASSIGNED FLAG
C     MASKHI = MASK FOR ALL BITS EXCEPT LOWEST ORDER 16 BITS OF A WORD.
C     NOFLGS = MASK FOR ALL FLAG BITS
C     ALLON  = ALL BITS ON
C     PTDIC  = ARRAY CONTAINING CHECKPOINT DICTIONARY
C     SEQNO  = SEQUENCE NO. OF LAST PTDIC ENTRY THAT WAS PUNCHED OUT.
C     NRLFL  = NEXT REEL/FILE NO. TO BE USED IN PTDIC
C     PTDTOP = POINTER TO FIRST WORD OF FIRST ENTRY IN PTDIC
C     PTDBOT = POINTER TO FIRST WORD OF LAST  ENTRY IN PTDIC
C     LCPTP  = POINTER TO FIRST WORD OF FIRST ENTRY OF NEW GROUP OF
C              ENTRIES TO BE PUT IN PTDIC.
C     LPTDIC = LENGTH (IN WORDS) OF PTDIC
C
      IMPLICIT INTEGER (A-Z)
      EXTERNAL        LSHIFT,RSHIFT,ANDF,ORF,COMPLF
      DIMENSION       BLKCNT(90),DCPARM(2),HEAD(2),PURGE(100),SVFST(2),
     1                PGHDG(1),HDG(32),DICT(400),FDICT(400),PTDIC(1),
     2                NXPTDC(2),IOBUF(1),NXCHK(2),NVPS(2)
      CHARACTER       UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG / UFM,UWM,UIM,SFM
      COMMON /XFIST / FIST(2)
      COMMON /XPFIST/ IPFST
      COMMON /OSCENT/ OSCAR(7)
CWKBR COMMON /XCEITB/ CEITBL(2)
      COMMON /XCEITB/ CEITBL(42)
      COMMON /XFIAT / FIAT(3)
      COMMON /XDPL  / DPL(3)
      COMMON /XVPS  / VPS(2)
      COMMON /ZZZZZZ/ GBUF(1)
      COMMON /SYSTEM/ ZSYS(91)
      COMMON /MACHIN/ MACH
      COMMON /OUTPUT/ PGHDG
      COMMON /STAPID/ TAPID(6)
      COMMON /RESDIC/ IRDICT,IROPEN
CWKBI
C      INCLUDE 'NASNAMES.COM'
      EQUIVALENCE     (ZSYS( 1),BUFSZ ),(ZSYS( 2),OTPE  ),
     1                (ZSYS( 9),NLPP  ),(ZSYS(11),NPAGES),
     2                (ZSYS(12),NLINES),(ZSYS(24),ICFIAT),
     3                (ZSYS(26),CPPGCT),(ZSYS(40),NBPW  )
      EQUIVALENCE     (DCPARM(1),NRLFL),(DCPARM(2),SEQNO),
     1                (GBUF(1),IOBUF(1),PTDIC(1))
      DATA    NPTP  / 4HNPTP/
      DATA    DPT   / 4HPOOL/
      DATA    NBLANK/ 4H    /
      DATA    NOSCAR/ 4HXOSC/
      DATA    NXCHK / 4HXCHK,4H    /
      DATA    NVPS  / 4HXVPS,4H    /
      DATA    NXPTDC/ 4HXPTD,4HIC  /, DCPARM/4H(NON,4HE)  /
      DATA    HDG   / 4H    ,4HADDI,4HTION,4HS TO,4H CHE,4HCKPO,4HINT ,
     1                4HDICT,4HIONA,4HRY  ,22*4H    /
      DATA    BLKCNT/ 90*0  /,      LIMIT /90       /
      DATA    LPURGE/ 100   /
C
C     INITIALIZE
C
      FILCNT = 0
      REELCT = 0
      LDC    =-2
      RECSZ  = 0
      PRGPNT =-1
      CALL SSWTCH (9,DIAG09)
      IF (MACH .LT. 5) CALL XFLSZD (0,BLKSIZ,0)
C
C     MASKHI - O000000077777
      MASKHI = 32767
C
C     DPLFLG - O004000000000
      DPLFLG = LSHIFT(1,29)
C
C     SETEOR - O004000000000
      SETEOR = DPLFLG
C
C     FNASS  - O010000000000
      FNASS  = LSHIFT(1,30)
C
C     EOTFLG - O010000000000
      EOTFLG = FNASS
C
C     ALLON  - O777777777777
      ALLON  = COMPLF(0)
C
C     NOSGN  - O377777777777
      NOSGN  = RSHIFT(ALLON,1)
C
C     EQFLG  - O400000000000
      EQFLG  = COMPLF(NOSGN)
C
C     NOFLGS - O003777777777
      NOFLGS = RSHIFT(ALLON,NBPW-29)
C
C
C     FIND OSCAR FILE NUMBER IN DPL
C
      J1 = DPL(3)*3 + 1
      DO 10 J = 4,J1,3
      IF (DPL(J) .EQ. NOSCAR) GO TO 20
   10 CONTINUE
   20 OSCFN = ANDF(DPL(J+2),MASKHI)
      DPFCT = OSCFN
C
C     ALLOCATE CORE FOR GINO BUFFERS
C
      NPTPNT = KORSZ(GBUF) - BUFSZ - 1
      DPPNT  = NPTPNT - BUFSZ
      FPNT   = DPPNT  - BUFSZ
      IF (FPNT .LT. 1) CALL MESAGE (-8,0,NXCHK)
C
C     INITIALIZE PTDIC PARAMETERS AND LOAD CHECKPOINT DICTIONARY
C
      NGINO = NXPTDC(1)
      CALL OPEN (*905,NXPTDC,GBUF(NPTPNT),0)
      CALL READ (*970,*30,NXPTDC,DCPARM,2,1,RECSZ)
   30 IF (DCPARM(1) .NE. NXPTDC(1)) GO TO 970
      CALL READ (*970,*35,NXPTDC,DCPARM,2,1,RECSZ)
   35 PTDTOP = 1
      LPTDIC = NPTPNT - PTDTOP
      CALL READ (*970,*40,NXPTDC,PTDIC(PTDTOP),LPTDIC,1,RECSZ)
      GO TO 940
   40 PTDBOT = RECSZ  + PTDTOP - 3
      IOPNT  = PTDBOT + 6
      LIOBUF = FPNT - IOPNT
      IF (LIOBUF .LT. 1) CALL MESAGE (-8,0,NXCHK)
      CALL CLOSE (NXPTDC,1)
      LCPTP = PTDBOT + 3
C
C     SAVE CHECKPOINT DMAP SEQ. NO. AND RECORD NO.
C
      PTDIC(LCPTP  ) = NBLANK
      PTDIC(LCPTP+1) = NBLANK
      PTDIC(LCPTP+2) = ORF(OSCAR(2),LSHIFT(ANDF(MASKHI,OSCAR(6))+1,16))
      NPTFN = NRLFL
C
C     GET FIRST/NEXT FILE NAME FROM OSCAR ENTRY
C
      I1 = OSCAR(7)*2 + 6
      DO 200 I = 8,I1,2
C
C     SEE IF FILE IS ALREADY IN DICT
C
      IF (OSCAR(I).EQ.NVPS(1) .AND. OSCAR(I+1).EQ.NVPS(2)) GO TO 200
      IF (LDC .LT. 0) GO TO 110
      DO 100 J = 1,LDC,3
      IF (DICT(J).EQ.OSCAR(I) .AND. DICT(J+1).EQ.OSCAR(I+1)) GO TO 200
  100 CONTINUE
C
C     CHECK FIAT TABLE FOR FILE NAME
C
  110 J1 = FIAT(3)*ICFIAT - 2
      DO 115 J = 4,J1,ICFIAT
      IF (OSCAR(I).EQ.FIAT(J+1) .AND. OSCAR(I+1).EQ.FIAT(J+2)) GO TO 120
  115 CONTINUE
      GO TO 160
C
C     FILE IS IN FIAT - ENTER FILE AND ALL EQUIVALENCED FILES IN DICT
C
  120 IF (ANDF(FIAT(J),MASKHI) .EQ. MASKHI) GO TO 155
C
C     FILE NOT PURGED - CHECK FIAT TRAILER WORDS TO INSURE THAT FILE HAS
C     BEEN GENERATED
C
      IF (FIAT(J+3).NE.0 .OR. FIAT(J+4).NE.0 .OR. FIAT(J+5).NE.0)
     1    GO TO 125
      IF (ICFIAT.EQ.11 .AND. (FIAT(J+8).NE.0 .OR. FIAT(J+9).NE.0 .OR.
     1    FIAT(J+10).NE.0)) GO TO 125
      GO TO 155
  125 IF (FIAT(J) .LT. 0) GO TO 145
      LDC = LDC + 3
      DICT(LDC  ) = FIAT(J+1)
      DICT(LDC+1) = FIAT(J+2)
      DICT(LDC+2) = ORF(LSHIFT(J,16),ANDF(FIAT(J),MASKHI))
C
C     DESTROY ANY EQUIVS TO THIS FILE
C
C     FIND LAST DICTIONARY REFERENCE TO THIS DATA BLOCK NAME
C
      DO 130 J = PTDTOP,PTDBOT,3
      K = PTDBOT - (J-PTDTOP)
      IF (DICT(LDC).EQ.PTDIC(K) .AND. PTDIC(K+1).EQ.DICT(LDC+1))
     1    GO TO 132
  130 CONTINUE
      GO TO 140
C
C     FILE EXISTS IN DICTIONARY SEE IF IT IS EQUIVED
C
  132 CONTINUE
      IF (ANDF(PTDIC(K+2),EQFLG) .EQ. 0) GO TO 140
C
C     FILE IS EQUIVED.  PURGE ALL SUBSEQUENT ENTRIES FOR THIS FILE
C
      IF (K .EQ. PTDBOT) GO TO 140
      DO 135 J = K,PTDBOT,3
      IF (PTDIC(J+2) .NE. PTDIC(K+2)) GO TO 135
C
C     PURGE FILE
C
      PRGPNT = PRGPNT + 2
      IF (LPURGE .LT. PRGPNT+1) GO TO 960
      PURGE(PRGPNT  ) = PTDIC(J  )
      PURGE(PRGPNT+1) = PTDIC(J+1)
  135 CONTINUE
  140 CONTINUE
      GO TO 200
  145 K = ANDF(FIAT(J),ORF(MASKHI,EQFLG))
      DO 150 J = 4,J1,ICFIAT
      IF (ANDF(FIAT(J),ORF(MASKHI,EQFLG)) .NE. K) GO TO 150
      LDC = LDC + 3
C
C     EQUIVALENCED FILE FOUND
C
      DICT(LDC  ) = FIAT(J+1)
      DICT(LDC+1) = FIAT(J+2)
C
C     ENTER EQUIVALENCE FLAG, FIAT POINTER AND UCB POINTER IN DICT
C
      DICT(LDC+2) = ORF(LSHIFT(J,16),K)
  150 CONTINUE
      GO TO 200
C
C     ENTER PURGED FILE IN PURGE TABLE
C
  155 PRGPNT = PRGPNT + 2
      IF (LPURGE .LT. PRGPNT+1) GO TO 960
      PURGE(PRGPNT  ) = OSCAR(I  )
      PURGE(PRGPNT+1) = OSCAR(I+1)
      GO TO 200
C
C     SEE IF FILE IS IN DPL
C
  160 J1 = DPL(3)*3 + 1
      DO 170 J = 4,J1,3
      IF (OSCAR(I).EQ.DPL(J) .AND. OSCAR(I+1).EQ.DPL(J+1)) GO TO 180
  170 CONTINUE
      GO TO 155
C
C     FILE IS IN DPL - ENTER FILE AND ALL EQUIVALENCED FILES IN DICT
C
  180 K = ANDF(DPL(J+2),MASKHI)
      DPFCT = MIN0(OSCFN,K)
      DO 190 J = 4,J1,3
      IF (ANDF(DPL(J+2),MASKHI) .NE. K) GO TO 190
      LDC = LDC + 3
C
C     EQUIVALENCED FILE FOUND
C
      DICT(LDC  ) = DPL(J  )
      DICT(LDC+1) = DPL(J+1)
C
C     ENTER EQUIVALENCE FLAG, DPLFLG AND FILE NO. IN DICT
C
      DICT(LDC+2) = ORF(DPLFLG,ANDF(DPL(J+2),ORF(MASKHI,EQFLG)))
  190 CONTINUE
  200 CONTINUE
C
C     MOVE DICT ENTRIES TO FDICT TABLE
C     GET FIRST NEXT/ENTRY IN DICT
C
      IF (LDC .LT. 1) GO TO 400
      DO 300 I = 1,LDC,3
C
C     IF DICT ENTRY IS EQUIVALENCED - SEE IF IT IS IN PTDIC
C
      IF (ANDF(DICT(I+2),FNASS) .EQ. FNASS) GO TO 300
      IF (DICT(I+2) .GT. 0) GO TO 225
C
C     SEARCH BACKWARD FOR PREVIOUS ENTRY
C
      DO 210 J = PTDTOP,PTDBOT,3
      K = PTDBOT - (J-PTDTOP)
      IF (PTDIC(K).EQ.DICT(I) .AND. PTDIC(K+1).EQ.DICT(I+1) .AND.
     1    PTDIC(K+2).NE.0) GO TO 215
  210 CONTINUE
      GO TO 225
C
C     DICT ENTRY IS IN PTDIC
C
  215 FDICT(I  ) = DICT(I  )
      FDICT(I+1) = DICT(I+1)
      FDICT(I+2) = ORF(PTDIC(K+2),EQFLG)
      UCBPNT     = DICT(I+2)
      DICT(I+2)  = FNASS
C
C     ENTER PTDIC FILE NUMBER IN FDICT ENTRIES THAT ARE EQUIVALENCED TO
C     PTDIC ENTRY
C
      UCBPNT = ANDF(UCBPNT,ORF(MASKHI,DPLFLG))
      DO 220 J = 1,LDC,3
      IF (ANDF(DICT(J+2),ORF(MASKHI,DPLFLG)) .NE. UCBPNT) GO TO 220
      FDICT(J  ) = DICT(J  )
      FDICT(J+1) = DICT(J+1)
      FDICT(J+2) = ORF(EQFLG,PTDIC(K+2))
      DICT(J+2)  = FNASS
  220 CONTINUE
C
C     MOVE DICT ENTRY TO FDICT IF NOT ALREADY MOVED
C
  225 IF (ANDF(DICT(I+2),FNASS) .EQ. FNASS) GO TO 300
      FDICT(I  ) = DICT(I  )
      FDICT(I+1) = DICT(I+1)
      FDICT(I+2) = DICT(I+2)
      IF (ANDF(DICT(I+2),DPLFLG) .EQ. DPLFLG) GO TO 300
C
C     DICT ENTRY IS FIAT FILE - ENTER NPTP FILE NO. IN FDICT
C
      FDICT(I+2) = ORF(ANDF(FDICT(I+2),EQFLG),NPTFN)
      DICT (I+2) = ORF(DICT(I+2),FNASS)
      IF (DICT(I+2) .GT. 0) GO TO 295
C
C     FILE IS EQUIVALENCED - ENTER NPTP FILE NO. IN FDICT FOR FILES THAT
C     THIS ENTRY IS EQUIVALENCED TO.
C
      UCBPNT = ANDF(DICT(I+2),MASKHI)
      J1 = I + 3
      IF (J1 .GT. LDC) GO TO 295
      DO 230 J = J1,LDC,3
      IF (ANDF(DICT(J+2),MASKHI) .NE. UCBPNT) GO TO 230
      FDICT(J  ) = DICT(J  )
      FDICT(J+1) = DICT(J+1)
      FDICT(J+2) = FDICT(I+2)
      DICT(J+2)  = ORF(DICT(J+2),FNASS)
  230 CONTINUE
  295 NPTFN = 1 + NPTFN
  300 CONTINUE
C
C     NOW ASSIGN NPTP FILE NUMBERS TO DATA POOL FILES IN SAME ORDER THAT
C     FILES APPEAR ON DATA POOL TAPE.
C
  310 MINFN = RSHIFT(ALLON,1)
C
C     GET FIRST/NEXT DICT ENTRY
C
      DO 330 I = 1,LDC,3
      IF (ANDF(DICT(I+2),FNASS) .EQ. FNASS) GO TO 330
      MINFN = MIN0(MINFN,ANDF(DICT(I+2),MASKHI))
  330 CONTINUE
      IF (MINFN .EQ. RSHIFT(ALLON,1)) GO TO 400
      DO 350 I = 1,LDC,3
      IF (ANDF(DICT(I+2),FNASS)  .EQ. FNASS) GO TO 350
      IF (ANDF(DICT(I+2),MASKHI) .NE. MINFN) GO TO 350
      FDICT(I+2) = ORF(NPTFN,ANDF(FDICT(I+2),EQFLG))
      DICT (I+2) = ORF(DICT(I+2),FNASS)
  350 CONTINUE
      NPTFN = NPTFN + 1
      GO TO 310
C
C     OPEN DATA POOL TAPE SO IT IS POSITIONED BEFORE FIRST FILE TO
C     CHECKPOINT.
C
  400 IF (DPFCT .LT. OSCFN) GO TO 401
      J = 2
      DPFCT = OSCFN
      GO TO 402
  401 J = 0
      DPFCT = 1
  402 NAME  = DPT
      CALL OPEN (*905,DPT,GBUF(DPPNT),J)
      NAME  = NPTP
C
C     OPEN NEW PROBELM NPTP TAPE FOR WRITE
C
      CALL OPEN (*905,NPTP,GBUF(NPTPNT),3)
C
C     MAKE TEMPORARY ENTRY IN FIST FOR FIAT FILES
C
      IFSTMP   = 2*IPFST + 3
      SVFST(1) = FIST(IFSTMP  )
      SVFST(2) = FIST(IFSTMP+1)
      FIST(2)  = IPFST + 1
      FIST(IFSTMP) = 301
C
C     WRITE FILES ON NEW PROBLEM NPTP TAPE AS SPECIFIED IN FDICT.
C
      N1 = NPTFN - 1
C
C     GET FIRST/NEXT FDICT ENTRY
C
      N = NRLFL
      IF (LDC.LT.1 .OR. N1.LT.N) GO TO 615
  405 DO 410 I = 1,LDC,3
      IF (ANDF(FDICT(I+2),NOFLGS) .EQ. N) GO TO 415
  410 CONTINUE
C
C     FDICT ENTRIES SHOULD ALL BE COPIED - MAKE SURE ALL IS O.K.
C
      DO 412 I = 1,LDC,3
      IF (ANDF(FDICT(I+2),NOFLGS) .GT. N) GO TO 920
  412 CONTINUE
      NPTFN = N
      GO TO 615
C
C     THIS FDICT ENTRY IS NEXT TO GO ON NEW PROBLEM NPTP TAPE.
C
  415 IF (ANDF(DICT(I+2),DPLFLG) .EQ. DPLFLG) GO TO 450
C
C     FILE IS IN FIAT TABLE
C
      K = RSHIFT(ANDF(NOFLGS,DICT(I+2)),16)
      IF (DICT(I+2) .GT. 0) GO TO 418
C
C     GET SMALLEST FIAT POINTER FOR EQUIVALENCED FIAT FILES
C
      DO 416 II = 1,LDC,3
      IF (ANDF(DICT(II+2),DPLFLG) .EQ. DPLFLG) GO TO 416
      IF (ANDF(DICT(I+2),MASKHI)  .EQ. ANDF(DICT(II+2),MASKHI))
     1    K = MIN0(RSHIFT(ANDF(NOFLGS,DICT(II+2)),16),K)
  416 CONTINUE
C
C     INSERT FIAT POINTER IN TEMPORARY FIST ENTRY
C
  418 FIST(IFSTMP+1) = K - 1
C
C     READ FIRST 2 WORDS OF DATA BLOCK, CHECK NAME AND WRITE TO NEW
C     PROBLEM NPTP TAPE SPECIAL HEADER AND 3 OR 6 TRAILER WORDS
C     (TOTAL OF 5 OR 8 WORDS IN THIS NPTP RECORD)
C
      NGINO = FIST(IFSTMP)
      CALL OPEN (*900,NGINO,GBUF(FPNT),0)
      FILCNT = FILCNT + 1
      IF (FILCNT .GT. LIMIT) GO TO 990
      CALL XFLSZD (-1,BLKCNT(FILCNT),NGINO)
      CALL READ (*930,*930,NGINO,HEAD,2,0,RECSZ)
      DO 440 J = I,LDC,3
      IF (HEAD(1).EQ.FDICT(J) .AND. HEAD(2).EQ.FDICT(J+1) .AND.
     1    FDICT(J+2).EQ.FDICT(I+2)) GO TO 445
  440 CONTINUE
      GO TO 930
  445 CALL WRITE (NPTP,HEAD,2,0)
      IF (ICFIAT .EQ. 11) GO TO 447
      CALL WRITE (NPTP,FIAT(K+3),3,1)
      GO TO 448
  447 CALL WRITE (NPTP,FIAT(K+3),3,0)
      CALL WRITE (NPTP,FIAT(K+8),3,1)
C
C     COPY ENTIRE FILE ONTO NEW PROBLEM NPTP TAPE USING CPYFIL
C
  448 CALL WRITE  (NPTP,HEAD,2,0)
      CALL CPYFIL (NGINO,NPTP,IOBUF(IOPNT),LIOBUF,RECSZ)
      CALL CLOSE  (NGINO,1)
      GO TO 600
C
C     FILE IS ON POOL -- POSITION POOL AND COPY FILE USING CPYFIL
C
  450 NGINO = DPT
      K = ANDF(DICT(I+2),MASKHI)
      CALL SKPFIL (DPT,K-DPFCT)
      DPFCT  = K + 1
      FILCNT = FILCNT + 1
      IF (FILCNT .GT. LIMIT) GO TO 990
      CALL XFLSZD (K,BLKCNT(FILCNT),0)
      CALL CPYFIL (DPT,NPTP,IOBUF(IOPNT),LIOBUF,RECSZ)
C
C     GET NEXT FDICT ENTRY
C
  600 CALL EOF (NPTP)
      N = N + 1
      IF (N .LE. N1) GO TO 405
C
C     RESTORE FIST ENTRY
C
      FIST(IFSTMP  ) = SVFST(1)
      FIST(IFSTMP+1) = SVFST(2)
C
C     WRITE VPS TABLE ONTO NEW PROBLEM NPTP TAPE
C     MAKE ENTRY IN FDICT FOR VPS TABLE
C
  615 LDC = LDC + 3
      FDICT(LDC  ) = NVPS(1)
      FDICT(LDC+1) = NBLANK
      FDICT(LDC+2) = NPTFN
      EORFLG = SETEOR
      I = LDC
      CALL WRITE (NPTP,NVPS,5,1)
      CALL WRITE (NPTP,VPS,VPS(2),1)
C
C     WRITE CEITBL TABLE ONTO PROBLEM TAPE
C
      CALL WRITE (NPTP,CEITBL,CEITBL(2),1)
C
C     WRITE /SYSTEM/ ONTO PROBLEM TAPE
C
      CALL WRITE (NPTP,BUFSZ,20,1)
      CALL EOF   (NPTP)
      CALL CLOSE (NPTP,2)
C
C     POSITION DATA POOL TAPE AT CORRECT OSCAR ENTRY FOR RETURN TO XSEM
C
      IF (DPFCT .EQ. OSCFN) GO TO 675
      CALL REWIND (DPT)
      IF (OSCFN .GT. 1) CALL SKPFIL (DPT,OSCFN-1)
      J1 = OSCAR(2)
      DO 670 J = 1,J1
      CALL FWDREC (*910,DPT)
  670 CONTINUE
  675 CALL CLOSE (DPT,2)
C
C     UPDATE PTDIC AND ASSOCIATED VARIABLES
C
      NRLFL  = NPTFN + 1
      PTDBOT = LCPTP
      DO 690 I = 1,LDC,3
      DO 680 J = PTDTOP,PTDBOT,3
C
C     SCAN PTDIC TO SEE IF FILE IS ALREADY THERE
C
      IF (FDICT(I).EQ.PTDIC(J) .AND. FDICT(I+1).EQ.PTDIC(J+1) .AND.
     1    FDICT(I+2).EQ.PTDIC(J+2)) GO TO 690
  680 CONTINUE
C
C     ENTER FILE IN PTDIC
C
      PTDBOT = PTDBOT + 3
      PTDIC(PTDBOT  ) = FDICT(I  )
      PTDIC(PTDBOT+1) = FDICT(I+1)
      PTDIC(PTDBOT+2) = FDICT(I+2)
  690 CONTINUE
C
C     PUT PURGED FILES IN PTDIC
C
      IF (PRGPNT .LT. 1) GO TO 800
      DO 710 I = 1,PRGPNT,2
      DO 700 J = PTDTOP,PTDBOT,3
      IF (PURGE(I).EQ.PTDIC(J) .AND. PURGE(I+1).EQ.PTDIC(J+1) .AND.
     1    PTDIC(J+2).EQ.0) GO TO 710
  700 CONTINUE
      PTDBOT = PTDBOT + 3
      PTDIC(PTDBOT  ) = PURGE(I)
      PTDIC(PTDBOT+1) = PURGE(I+1)
      PTDIC(PTDBOT+2) = 0
  710 CONTINUE
C
C     CHECK FOR PTDIC OVERFLOW
C
  800 IF (PTDBOT+3-PTDTOP .GT. LPTDIC) GO TO 940
C
C
C     PUNCH AND PRINT LATEST ENTRIES IN PTDIC
C     INITIALIZE PAGE HEADING AND CHECK PAGE COUNT
C
      IF (DIAG09 .EQ. 1) GO TO 802
      DO 801 I = 1,32
      PGHDG(I+ 96) = HDG(I)
      PGHDG(I+128) = NBLANK
  801 PGHDG(I+160) = NBLANK
      IF (CPPGCT .NE. NPAGES) CALL PAGE
  802 CONTINUE
      I1 = ((LCPTP  - PTDTOP)/3) + 1
      I2 = ((PTDBOT - PTDTOP)/3) + 1
      DO 810 I = I1,I2
      J1 = (I-1)*3 + PTDTOP
      J2 = J1 + 2
C
C     SEPARATE FLAGS, REEL NO., FILE NO.
C
      NFLAGS = 0
      IF (PTDIC(J2) .LT. 0) NFLAGS = 4
      NFLAGS = ORF(NFLAGS,RSHIFT(ANDF(PTDIC(J2),NOSGN),29))
      NREEL  = RSHIFT(ANDF(PTDIC(J2),NOFLGS),16)
      NFILE  = ANDF(PTDIC(J2),MASKHI)
      SEQNO  = 1 + SEQNO
      IF (PTDIC(J1) .EQ. NBLANK) GO TO 805
C      IF (IROPEN .EQ. 1) GO TO 815
C      OPEN (UNIT=4, FILE=DIC, STATUS='UNKNOWN')
C      IROPEN = 1
  815 WRITE  (IRDICT,820) SEQNO,PTDIC(J1),PTDIC(J1+1),NFLAGS,NREEL,NFILE
  820 FORMAT (I10,4H,   ,2A4,12H,   FLAGS = ,I1,11H,   REEL = ,I2,
     1        11H,   FILE = ,I6)
      IF (DIAG09 .EQ. 1) GO TO 810
      NLINES = NLINES + 1
      IF (MACH.LT.5 .AND. NFILE.NE.0 .AND. PTDIC(J1).NE.NVPS(1))
     1    NLINES = NLINES + 1
      IF (NLINES .GE. NLPP) CALL PAGE
      WRITE  (OTPE,821) SEQNO,PTDIC(J1),PTDIC(J1+1),NFLAGS,NREEL,NFILE
  821 FORMAT (1H ,I9 ,4H,   ,2A4,12H,   FLAGS = ,I1,11H,   REEL = ,I2,
     1        11H,   FILE = ,I6)
      IF (MACH.LT.5 .AND. NFILE.NE.0 .AND. PTDIC(J1).NE.NVPS(1))
     1    WRITE (OTPE,822) PTDIC(J1),PTDIC(J1+1),BLKCNT(I-I1),BLKSIZ
  822 FORMAT (13X,6H FILE ,2A4, 9H CONTAINS, I10,
     1        28H BLOCKS, EACH BLOCK CONTAINS,I5,7H WORDS.)
      GO TO 810
  805 CONTINUE
C      IF (IROPEN .EQ. 1) GO TO 8055
C      OPEN (UNIT=4, FILE=DIC, STATUS='UNKNOWN')
C      IROPEN = 1
C8055  CONTINUE
       WRITE  (IRDICT,806) SEQNO,NREEL
  806 FORMAT (I10,36H,   REENTER AT DMAP SEQUENCE NUMBER ,I5)
      IF (DIAG09 .EQ. 1) GO TO 810
      NLINES = NLINES + 2
      IF (NLINES .GE. NLPP) CALL PAGE
      WRITE  (OTPE,807) SEQNO,NREEL
  807 FORMAT (1H ,/1H ,I9,36H,   REENTER AT DMAP SEQUENCE NUMBER ,I5)
  810 CONTINUE
C
C     WRITE PTDIC ONTO XPTD
C
      NGINO = NXPTDC(1)
      CALL OPEN  (*905,NXPTDC,GBUF(NPTPNT),1)
      CALL WRITE (NXPTDC,NXPTDC,2,1)
      CALL WRITE (NXPTDC,DCPARM,2,1)
      CALL WRITE (NXPTDC,PTDIC(PTDTOP),PTDBOT+3-PTDTOP,1)
      CALL CLOSE (NXPTDC,1)
      CPPGCT = NPAGES
C
      FIST(2) = IPFST
      RETURN
C
C
C     ERRORS -
C
  900 N = 1101
      ASSIGN 901 TO RETURN
      GO TO 980
  901 WRITE  (OTPE,902) FDICT(I),FDICT(I+1)
  902 FORMAT (4X,26HCOULD NOT OPEN FILE NAMED ,2A4)
      GO TO 995
C
  905 N = 1102
      ASSIGN 906 TO RETURN
      GO TO 985
  906 WRITE (OTPE,902) NGINO,NBLANK
      GO TO 995
C
  910 N = 1103
      ASSIGN 911 TO RETURN
      GO TO 985
  911 WRITE  (OTPE,912)
  912 FORMAT (4X,43HUNABLE TO POSITION DATA POOL TAPE CORRECTLY )
      GO TO 995
C
  920 N = 1104
      ASSIGN 921 TO RETURN
      GO TO 985
  921 WRITE  (OTPE,922)
  922 FORMAT (4X,24HFDICT TABLE IS INCORRECT )
      GO TO 995
C
  930 N = 1105
      ASSIGN 931 TO RETURN
      GO TO 980
  931 WRITE  (OTPE,932) FDICT(I),FDICT(I+1),HEAD(1),HEAD(2)
  932 FORMAT (4X,29HCANNOT FIND DATA BLOCK NAMED ,2A4,17H HEADER RECORD
     1= ,2A4)
      GO TO 995
C
  940 N = 1106
      ASSIGN 941 TO RETURN
      GO TO 985
  941 WRITE  (OTPE,942)
  942 FORMAT (4X,32HCHECKPOINT DICTIONARY OVERFLOWED)
      GO TO 995
C
  960 N = 1108
      ASSIGN 961 TO RETURN
      GO TO 985
  962 FORMAT (4X,22HPURGE TABLE OVERFLOWED)
  961 WRITE  (OTPE,962)
      GO TO 995
C
  970 N = 1109
      ASSIGN 971 TO RETURN
      GO TO 985
  971 WRITE (OTPE,932) NXPTDC,DCPARM
      GO TO 995
C
C     USER FATAL ERROR
C
  980 WRITE  (OTPE,981) UFM,N
  981 FORMAT (A23,I5)
      GO TO 987
C
C     SYSTEM FATAL ERROR
C
  985 CALL PAGE2 (3)
      WRITE  (OTPE,986) SFM,N
  986 FORMAT (A25,I5)
  987 GO TO RETURN, (901,906,911,921,931,941,961,971)
C
  990 WRITE  (OTPE,991) SFM
  991 FORMAT (A25,', BLKCNT ARRAY EXCEEDED IN XCHK')
C
  995 CALL MESAGE (-37,0,NXCHK)
      RETURN
      END

      SUBROUTINE ALG1 (LNCT)
C
      DIMENSION       RDATA(4)
      COMMON /GAS   / G,EJ,R,CP,GAMMA,ROJCP
      COMMON /SYSTEM/ SYSBUF,NOUT
      COMMON /ALGINO/ DUM,NALGDB
      COMMON /UD3PRT/ IPRTC
C
      LOG1 = NALGDB
      LOG2 = NOUT
      CALL FREAD (LOG1,RDATA,4,1)
      CP   = RDATA(1)
      R    = RDATA(2)
      G    = RDATA(3)
      EJ   = RDATA(4)
      IF (CP .EQ. 0.0) CP = 0.24
      IF (R  .EQ. 0.0) R  = 53.32
      IF (G  .EQ. 0.0) G  = 32.174
      IF (EJ .EQ. 0.0) EJ = 778.16
      IF (IPRTC .EQ. 1) WRITE(LOG2,10) CP,R,G,EJ
  10  FORMAT (/10X,'SPECIFIC HEAT AT CONSTANT PRESSURE',5X,1H=,F8.5,
     1        /10X,'GAS CONSTANT',27X,1H=,F8.4,
     2        /10X,'GRAVITATIONAL CONSTANT',17X,1H=,F8.4,
     3        /10X,'JOULES EQUIVALENT',22X,1H=,F8.3)
      LNCT  = LNCT + 5
      ROJCP = R/(EJ*CP)
      GAMMA = 1.0/(1.0-ROJCP)
      RETURN
      END

      SUBROUTINE AKAPPA (ARG,BKAPPA)
C
C     SUBROUTINE FOR COMPUTING KAPPA
C
      COMPLEX AI
C
      COMMON/BLK1/SCRK,SPS,SNS,DSTR,AI,PI,DEL,SIGMA,BETA,RES
C
      SCRK1 =  ABS (SCRK)
      ARG1  =  ABS (ARG)
      IF ( SCRK1 .GT. ARG1)  GO TO 10
      GAM=SQRT(ARG**2-SCRK**2)
      S1=SNS*GAM
      C1=BETA*GAM*SIN(S1)
      C2=COS(S1)-COS((ARG-DEL)*SPS+SIGMA)
      BKAPPA=C1/C2
      RETURN
   10 CONTINUE
      GAM=SQRT(SCRK**2-ARG**2)
      S1=SNS*GAM
      C1=-BETA*GAM*SINH(S1)
      C2=COSH(S1)-COS((ARG-DEL)*SPS+SIGMA)
      BKAPPA=C1/C2
      RETURN
      END

      SUBROUTINE FEER4 (IT)
C
C     FEER4 OBTAINS FROM THE REDUCED TRIDIAGONAL MATRIX THE EIGENVALUES
C     AND EIGENVECTORS
C
      LOGICAL           INCORE
      INTEGER           SYSBUF    ,CNDFLG   ,SR2FLE    ,SR6FLE   ,
     1                  SR7FLE    ,SR8FLE   ,IZ(1)     ,NAME(2)
CWKBNB NCL93007 11/94
      INTEGER           SR4FLE    ,SR5FLE   ,REW       ,EOFNRW
     1,                 WRTREW    ,RDREW    ,WRT
CWKBNE NCL93007 11/94
      DOUBLE PRECISION  LAMBDA    ,LMBDA    ,DZ(1)     ,B(2)     ,
     1                  DSM       ,DSCE
      DIMENSION         MCBC(7)   ,ICR(2)   ,SB(2)
      COMMON   /MACHIN/ MACH
      COMMON   /FEERCX/ IFKAA(7)  ,IFMAA(7) ,IFLELM(7),IFLVEC(7) ,
     1                  SR1FLE    ,SR2FLE   ,SR3FLE   ,SR4FLE    ,
     2                  SR5FLE    ,SR6FLE   ,SR7FLE   ,SR8FLE    ,
     3                  DMPFLE    ,NORD     ,XLMBDA   ,NEIG      ,
     4                  MORD      ,IBK      ,CRITF    ,NORTHO    ,
     5                  IFLRVA    ,IFLRVC
      COMMON   /FEERXX/ LAMBDA    ,CNDFLG   ,ITER     ,TIMED     ,
     1                  L16       ,IOPTF    ,EPX      ,ERRC      ,
     2                  IND       ,LMBDA    ,IFSET    ,NZERO     ,
     3                  NONUL     ,IDIAG    ,MRANK    ,ISTART
      COMMON   /ZZZZZZ/ Z(1)
      COMMON   /SYSTEM/ SYSBUF    ,IO       ,SYSTM(52),IPREC
      COMMON   /OPINV / MCBLT(7)  ,MCBSMA(7),MCBVEC(7),MCBRM(7)
      COMMON   /UNPAKX/ IPRC      ,II       ,NN       ,INCR
      COMMON   /PACKX / ITP1      ,ITP2     ,IIP      ,NNP       ,
     1                  INCRP
      COMMON   /NAMES / RD        ,RDREW    ,WRT      ,WRTREW    ,
     1                  REW       ,NOREW    ,EOFNRW
      EQUIVALENCE       (IZ(1),Z(1),DZ(1)), (SB(1),B(1)), (DSCE,SCE)
      DATA      NAME  / 4HFEER,4H4     /,    ICR   / 4HPASS,4HFAIL /
C
C     SR4FLE CONTAINS THE EIGENVECTORS OF THE REDUCED PROBLEM
C     SR5FLE CONTAINS THE TRIDIAGONAL ELEMENTS AND SCRATCH IN FQRWV
C     SR6FLE CONTAINS THE G VECTORS
C     SR7FLE CONTAINS THE ORTHOGONAL VECTORS
C
      CALL SSWTCH (26,L26)
      MDIM = MORD + 1
      DSM  = 10.0D+0**(-2*IT/3)
      SM   = DSM
      IPRC = MCBRM(5)
      NZ   = KORSZ(Z)
      CALL MAKMCB (MCBC(1),SR4FLE,MDIM,2,IPRC)
      MCBC(2) = 0
      MCBC(6) = 0
      M    = 0
C
C     INITIALIZE ALLOCATIONS
C
      IBUF1 = NZ    - SYSBUF
      IBUF2 = IBUF1 - SYSBUF
      IBUF3 = IBUF2 - SYSBUF
      IV1   = 1
      IV2   = IV1 + MDIM
      IV3   = IV2 + MDIM
      IV4   = IV3 + MDIM
      IV5   = IV4 + MDIM
      IV6   = IV5 + MDIM
      IV7   = IV6 + MDIM
      IV8   = IV7 + MDIM
      IV9   = IV8 + MDIM
      IX3   = IV3 - 1
      IX4   = IV4 - 1
      IEND  = IPRC*(8*MDIM+1) + MDIM
      IF (IEND .GT. IBUF3) CALL MESAGE (-8,IEND-IBUF3,NAME)
      CALL GOPEN (SR5FLE,Z(IBUF2),RDREW)
      IF (IPRC .EQ. 2) DZ(IV4+MORD) = ERRC
      IF (IPRC .EQ. 1)  Z(IV4+MORD) = ERRC
      NW = IPRC*2
      DO 10 I = 1,MORD
      CALL READ (*420,*430,SR5FLE,B(1),NW,1,M)
      IF (IPRC .EQ. 1) GO TO 5
      DZ(IX3+I) = B(1)
      DZ(IX4+I) = B(2)
      GO TO 10
    5 Z(IX3+I) = SB(1)
      Z(IX4+I) = SB(2)
   10 CONTINUE
      CALL CLOSE (SR5FLE,REW)
      CALL GOPEN (SR4FLE,Z(IBUF2),WRTREW)
      IF (IPRC .EQ. 1) GO TO 12
      CALL FQRWV (MORD,DZ(IV1),DZ(IV2),DZ(IV3),DZ(IV4),DZ(IV5),DZ(IV6),
     1                 DZ(IV7),DZ(IV8),DZ(IV9),Z(IBUF1),SR5FLE,MCBC(1))
C                                                              SR4FLE
      GO TO 15
   12 CALL FQRW (MORD,Z(IV1),Z(IV2),Z(IV3),Z(IV4),Z(IV5),Z(IV6),
     1                Z(IV7),Z(IV8),Z(IV9),Z(IBUF1),SR5FLE,MCBC(1))
C                                                          SR4FLE
   15 CALL CLOSE (SR4FLE,NOREW)
C
C     RECONFIGURE VECTOR INDEX TO OBTAIN PHYSICAL EIGENVECTORS
C
      IX1 = IV1 - 1
      IX2 = IV2 - 1
      IX3 = IV3 - 1
      IX4 = IV4 - 1
      IX5 = IX4 + NORD
      ISRV = MCBRM(1)
      IFLVEC(1) = IFLRVC
      IFLELM(1) = IFLRVA
      IF (NZERO .NE. 0) GO TO 20
C
C     PREPARE FILES WHEN NO RESTART AND/OR RIGID BODY VECTORS
C
      IFLVEC(2) = 0
      IFLVEC(6) = 0
      CALL GOPEN (IFLRVC,Z(IBUF3),WRTREW)
      CALL CLOSE (IFLRVC,NOREW)
      CALL GOPEN (IFLRVA,Z(IBUF3),WRTREW)
      CALL CLOSE (IFLRVA,NOREW)
   20 ITP1 = IPRC
      ITP2 = 1
      INCRP= 1
      II   = 1
      CALL GOPEN (IFLRVA,Z(IBUF1),WRT)
      MRED = 0
      MFLG = 1
      DO 30 M = 1,MORD
      IF (IPRC .EQ. 1) GO TO 22
      DSCE = 1.0D+0/DZ(IX1+M) - LAMBDA
      IF (L16 .EQ. 0) GO TO 24
      ERF  = 0.0D+0
      IF (DABS(DSCE) .GT. DSM)
     1    ERF = 100.D0*DZ(IX2+M)/DABS(1.D0-DZ(IX1+M)*LAMBDA)
      DZ(IX2+M) = DSCE
      GO TO 23
   22 SCE = 1.0/Z(IX1+M) - LAMBDA
      IF (L16 .EQ. 0) GO TO 24
      ERF = 0.0D+0
      IF (ABS(SCE) .GT. SM)
     1    ERF = 100.0D+0*Z(IX2+M)/DABS(1.0D+0-Z(IX1+M)*LAMBDA)
      Z(IX2+M) = SCE
   23 IF (ERF  .GT. CRITF) MFLG = 2
   24 IF (MFLG .EQ.     2) GO TO 25
      MRED = MRED + 1
      CALL WRITE (IFLRVA,DSCE,IPREC,1)
   25 IF (L16 .EQ. 0) GO TO 30
      CALL PAGE2 (1)
      IF (IPRC .EQ. 2) WRITE (IO,26) M,DSCE,ERF,ICR(MFLG)
      IF (IPRC .EQ. 1) WRITE (IO,26) M, SCE,ERF,ICR(MFLG)
   26 FORMAT (10X,'PHYSICAL EIGENVALUE',I5,1P,E16.8,
     1        '  THEOR ERROR ',E16.8,'  PERCENT',5X,A4)
   30 CONTINUE
      CALL CLOSE (IFLRVA,EOFNRW)
      IF (MORD .EQ. 0) RETURN
C
      CALL GOPEN (ISRV,Z(IBUF1),RDREW)
      CALL GOPEN (SR4FLE,Z(IBUF2),RDREW)
      CALL GOPEN (IFLRVC,Z(IBUF3),WRT)
CWKBNB NCL93007 11/94
      INCORE = .FALSE.
      CALL SSWTCH ( 43, L43 )
      IF ( L43 .NE. 0 ) GO TO 42
      IVW    = IX5 + NORD + 1
      ICREQ  = NORD*MORD*IPRC
      ICAVL  = IBUF3 - IVW - 1
      IF ( ICAVL .GT. ICREQ ) INCORE = .TRUE.
      IF ( .NOT. INCORE ) GO TO 42
      NN = NORD
      DO 41 I = 1, MORD
      IVR = IVW + (I-1)*NORD
      IF ( IPRC .EQ. 1 ) CALL UNPACK ( *41, ISRV,  Z(IVR+1) )  
      IF ( IPRC .EQ. 2 ) CALL UNPACK ( *41, ISRV, DZ(IVR+1) )  
   41 CONTINUE
   42 CONTINUE
CWKBNE NCL93007 11/94
C
C     IF DIAG 26 IS OFF, LIMIT EIGENSOLUTIONS TO NUMBER REQUESTED
C
      IF (MRED.GE.NEIG .AND. L26.NE.0) MRED = NEIG
      IF (IPRC .EQ. 1) GO TO 200
      DO 100 M = 1,MRED
      DO 50  L = 1,NORD
   50 DZ(IX5+L) = 0.0D+0
      NN = MORD
      CALL UNPACK (*75,SR4FLE,DZ(IV3))
      NN = NORD
CWKBI NCL93007 11/94
      IF ( INCORE ) GO TO 72
      DO 70 I = 1,MORD
      CALL UNPACK (*100,ISRV,DZ(IV4))
      DO 60 J = 1,NORD
   60 DZ(IX5+J) = DZ(IX5+J) + DZ(IX4+J)*DZ(IX3+I)
   70 CONTINUE
CWKBNB NCL93007 11/94
      GO TO 73
   72 CONTINUE
      DO 61 I = 1, MORD
      IVR = IVW + (I-1)*NORD
      DO 61 J = 1, NORD
   61 DZ(IX5+J) = DZ(IX5+J) + DZ(IVR+J)*DZ(IX3+I)
   73 CONTINUE
CWKBNE NCL93007 11/94
   75 CONTINUE
      IF (IOPTF .EQ. 0) GO TO 90
      DSCE = 1.0D+0/DSQRT(DABS(DZ(IX1+M)))
      DO 80 L = 1,NORD
   80 DZ(IX5+L) = DSCE*DZ(IX5+L)
   90 CONTINUE
      IIP = 1
      NNP = NORD
      CALL PACK (DZ(IX5+1),IFLRVC,IFLVEC(1))
CWKBI NCL93007 11/94
      IF ( INCORE ) GO TO 100
      CALL REWIND (MCBRM)
      CALL SKPREC (MCBRM,1)
  100 CONTINUE
      GO TO 400
  200 DO 300 M = 1,MRED
      DO 250 L = 1,NORD
  250 Z(IX5+L) = 0.0
      NN = NORD
      CALL UNPACK (*275,SR4FLE,Z(IV3))
      NN = NORD
CWKBI NCL93007 11/94
      IF ( INCORE ) GO TO 272
      DO 270 I = 1,MORD
      CALL UNPACK (*300,ISRV,Z(IV4))
      DO 260 J = 1,NORD
  260 Z(IX5+J) = Z(IX5+J) + Z(IX4+J)*Z(IX3+I)
  270 CONTINUE
CWKBNB NCL93007 11/94
      GO TO 273
  272 CONTINUE
      DO 261 I = 1, MORD
      IVR = IVW + (I-1)*NORD
      DO 261 J = 1, NORD
  261 Z(IX5+J) = Z(IX5+J) + Z(IVR+J)*Z(IX3+I)
  273 CONTINUE
CWKBNE NCL93007 11/94
  275 CONTINUE
      IF (IOPTF .EQ. 0) GO TO 290
      SCE = 1.0/SQRT(ABS(Z(IX1+M)))
      DO 280 L = 1,NORD
  280 Z(IX5+L) = SCE*Z(IX5+L)
  290 CONTINUE
      IIP = 1
      NNP = NORD
      CALL PACK (Z(IX5+1),IFLRVC,IFLVEC(1))
CWKBI NCL93007 11/94
      IF ( INCORE ) GO TO 300
      CALL REWIND (MCBRM)
      CALL SKPREC (MCBRM,1)
  300 CONTINUE
C
  400 CALL CLOSE (IFLRVC,EOFNRW)
      CALL CLOSE (ISRV,REW)
      CALL CLOSE (SR4FLE,REW)
      MORD = MRED
      GO TO 500
  420 IER = 2
      GO TO 440
  430 IER = 3
  440 CNDFLG = 4
      CALL MESAGE (IER,SR5FLE,NAME)
  500 IOPN = IBUF3 - IEND
      IF (L16 .EQ. 1) WRITE (IO,510) IOPN,NAME
  510 FORMAT ('  OPEN CORE NOT USED',I10,2X,2A4)
      RETURN
      END

      SUBROUTINE STRSCN (S OR F)        
C        
C     THIS ROUTINE PERFORMS STRESS AND FORCE OUTPUT SCAN.        
C        
C     ACKNOWLEDGEMENT -        
C        
C     THIS ROUTINE WAS WRITTEN ORIGINALLY BY LOCKHEED/GEORGIA FOR USER  
C     DMAP-ALTER APPLICATION. IT WAS GREATLY MODIFIED BY G.CHAN/SPERRY  
C     SO THAT USERS CAN SPECIFY THE OUTPUT SCAN PARAMETERS FROM THE     
C     CASE CONTROL SECTION VIA THE SCAN INPUT CARD(S).  ONLY A VERY     
C     SMALL PORTION OF THE ORIGINAL PROGRAM REMAINS.  THE DMAP-ALTER    
C     APPLICATION IS STILL AVAILABLE TO THE USER        
C        
C     THIS ROUTINE IS CALLED ONLY BY SCAN        
C     IT DOES NOT OPEN NOR CLOSE ANY FILE        
C        
C     SCAN PARAMETER -        
C        
C          S OR F  - STRESS (1) OR FORCE (2) SCAN FLAG        
C          INFILE  - INPUT FILE, EITHER STRESS OR FORCE OUTPUT FILE     
C          OUFILE  - OUTPUT FILE FROM SCAN OPERATION, TO BE PRINTED     
C                    AGAIN BY OFP        
C          IOPT    - OPTION 1, SCAN BY AMAX-AMIN (.GT.AMAX AND .LT.AMIN)
C                    OPTION 2, SCAN BY NTOP-        
C                  . TOP N LARGEST (TENSION) AND SMALLEST (COMPRESSION) 
C                    IN STRESS SCAN.        
C                  . TOP N LARGEST ONLY IF NO COMPRESSION STRESS PRESENT
C                  . TOP N SMALLEST ONLY IF NO TENSION STRESS PRESENT   
C                  . TOP N VALUES SCAN FOR FORCES IF TOP N IS POSITIVE  
C                  . LEAST N VALUES SCAN FOR FORCES OR MARGIN (STRESS)  
C                    IF TOP N IS NEGATIVE        
C                  - IOPT IS INITIALIZED IN SCAN        
C                  - STRSCN WILL SET IOPT TO A NEGATIVE NUMBER IF INPUT 
C                    FILE IS NOT A STRESS OR FORCE FILE        
C          ISET    - A LIST OF ELEMENT IDS TO BE SCANNED        
C          IEL     - ELEMENT TYPE (CODE) TO BE SCANNED        
C          IELT    - ELEMENT NAME IN 2 BCD WORDS        
C          ICASE   - USED LOCALLY FOR SUBCASE NUMBER.        
C          SUBC    - CURRENT SUBCASE NO. USED IN SCAN AND STRSCN        
C          OSUBC   - SUBCASE NO. PROCESSED PREVIOUSLY        
C          ISORT   - SET LOCALLY TO 1 IF INPUT FILE DATA IS IN SORT1    
C                    TYPE FORMAT, TO 2 IF IN SORT2        
C          DEBUG   - LOCAL DEBUG FLAG, SET BY SCAN        
C          OEL     - ELEMENT TYPE PROCESSED PREVIOUSLY        
C        
C     SEE SUBROUTINE SCAN FOR MORE PARAMETER DEFINITIONS        
C        
C *** IF SCAN IS CALLED BY USER VIA DMAP ALTER, WE HAVE        
C        
C          ISET      =-2        
C          LBEG=LEND = 0, NOT USED        
C          LCSE1 AND = BEGINNING AND ENDING POINTERS TO AN ELEM. LIST   
C          LCSE2       (SORT1, ALL SUBCASES), OR A SUBCASE LIST (SORT2, 
C                      ALL ELEMS) IF THEY ARE GIVEN. OTHERWISE, LCSE1=-1
C                      AND LCSE2=0        
C        
C *** IF SCAN IS CALLED BY RIGID FORMAT, WE HAVE        
C        
C          ISET      =-1  IMPLIES THAT ALL ELEMENTS ARE TE BE SCANNED,  
C                         AND LBEG .GT. LEND        
C          ISET      = N  IMPLIES THAT ELEM. ID SET N IS REQUESTED. THE 
C                         SET DATA IS STORED IN IZ(LBEG) THRU IZ(LEND)  
C          ISET      = 0  NOT DEFINED        
C          LCSE1 AND =    ARE COMPONENT DUPLICATION FLAG (IDUPL) AND    
C          LCSE2          INCREMENT FLAG (INC)        
C                    = 0  IMPLIES NO DUPLICATION/INCR SET BY COMPONENT  
C          LCSE1     =-2  SET AND USE LOCALLY IF SORT2 AND ELEM. SET ARE
C                         INVOLVED.        
C          LBEG AND  =    ARE BEGINNING AND ENDING POINTERS TO THE ELEM.
C          LEND           ID SET, ALL ELEMS. (LBEG .GT. LEND IF ISET=-1)
C        
      LOGICAL         IOPEN,    JOPEN,    ANY,      DEBUG        
      LOGICAL         LAYERD,   STRESS,   FORCE
      CHARACTER*100   CHEAD
      CHARACTER*12    FIELD,    SCNFLD(6)
      INTEGER         OUFILE,   HEAD,     IHEAD(25),ID(50),   IZ(2),    
     1                EOR,      OEL,      NAM(2),   SORTX(3), ISCAN(10),
     2                SUBC,     OSUBC,    QUAD4,    TRIA3,    TOPN, 
     3                S OR F,   IBLANK         
      COMMON /OUTPUT/ HEAD(96)        
      COMMON /XSCANX/ INFILE,   OUFILE,   LCORE,    LBEG,     LEND,     
     1                IOPEN,    JOPEN,    IEL,      IOPT,     ISET,     
     2                ISORT,    ITRL3,    SUBC,     OSUBC,    OEL,      
     3                DEBUG,    LLOOP,    QUAD4,    TRIA3,    STRESS,    
     4                FORCE,    LAYERD
      COMMON /BLANK / IELT(2),  ICOMP,    TOPN,     AMAX,     AMIN,     
     1                LCSE1,    LCSE2,    ICOMPX        
      COMMON /SYSTEM/ IBUF,     NOUT,     SPACE(6), NLPP,     DUM,      
     1                NPAGE,    LINE        
      COMMON /NAMES / RD,       RDREW,    WRT,      WRTREW,   REW,      
     1                NOREW,    EOFNRW        
      COMMON /ZZZZZZ/ Z(2)        
      EQUIVALENCE     (IZ(1),Z(1))        
      EQUIVALENCE     (CHEAD, IHEAD(1))
      DATA            NAM,                SORTX                       / 
     1                4HSTRS,   4HCN  ,   4HSORT,   4H1   ,   4H2     / 
      DATA            T24,      EOR,      NOEOR,    IBLANK            /                       / 
     1                1.E+24,   1,        0    ,    1H                / 
C        
C *** SET ISCAN ARRAY FROM COMPONENT SPECIFICATION        
C        
      CHEAD = ' '
      NSCAN=0        
      NTOP =IABS(TOPN)        
C      PRINT *,' ENTERRING STRSCN,NTOP,ICOMP=',NTOP,ICOMP
      DO 20 I=1,30        
      J=2**(I-1)        
      IF (MOD(ICOMP,2*J) .LT. J) GO TO 10        
      NSCAN=NSCAN+1        
      IF (I .EQ. 1) GO TO 670        
      ISCAN(NSCAN)=I        
 10   IF (ICOMPX .EQ. 0) GO TO 20        
      IF (MOD(ICOMPX,2*J) .LT. J) GO TO 20        
      NSCAN=NSCAN+1        
      ISCAN(NSCAN)=I+31        
 20   CONTINUE        
C      PRINT *,' AFTER 20, ICOMP=',ICOMP
      J=2*J        
      IF (ICOMP .LT. J) GO TO 24        
      NSCAN=NSCAN+1        
      ISCAN(NSCAN)=31        
 24   IF (ICOMPX .LT. J) GO TO 26        
      NSCAN=NSCAN+1        
      ISCAN(NSCAN)=62        
 26   IF (ICOMPX .NE. 0) CALL SORT (0,0,1,1,ISCAN,NSCAN)        
C      DEBUG = .TRUE.
C      PRINT *,' AFTER 26,NSCAN=',NSCAN
C      PRINT *,' AFTER 26,ISCAN=',(ISCAN(KB),KB=1,NSCAN)
      IF (.NOT.DEBUG) GO TO 40        
      WRITE (NOUT,30) IOPEN,JOPEN,IELT,IEL,ISET,ICOMP,ICOMPX,LCSE1,     
     1                LCSE2,ISORT,SUBC,ITRL3,LBEG,LEND,NSCAN        
 30   FORMAT (//2X,12HDEBUG/STRSCN,/,2(2X,L1),2X,2A4,13I8)        
      IF (IOPT .EQ. 2) WRITE (NOUT,33) NTOP,(ISCAN(J),J=1,NSCAN)        
      IF (IOPT .EQ. 1) WRITE (NOUT,35) AMAX,AMIN,(ISCAN(J),J=1,NSCAN)   
 33   FORMAT (5X,I9,31I3)        
 35   FORMAT (5X,2E10.3,31I3)        
      IF (LEND .GT. LBEG) WRITE (NOUT,38) ISET,(IZ(J),J=LBEG,LEND)      
 38   FORMAT (/5X,3HSET,I8, (/5X,15I7))        
      IF (NSCAN .GT. 10) GO TO 590        
      IF (NSCAN .EQ.  0) GO TO 670        
C        
C *** INITIALIZATION        
C        
 40   IDUPL=LCSE1        
      INC  =LCSE2        
      JNC  =0        
      IF (ISET+1) 70,50,60        
 50   LCSE1=0        
      LCSE2=0        
      GO TO 70        
 60   LCSE1=IZ(LBEG)        
      LCSE2=IABS(IZ(LEND))        
 70   NS   =-1        
      IF (LCSE1 .GT. LCSE2) GO TO 640        
      IF (.NOT.IOPEN .OR. .NOT.JOPEN) GO TO 600        
C        
      LBUF1=1        
      LBUF3=0        
      LBUF0=LBUF1-1        
      IL2  =0        
      NREW =0        
      ICASE=-1        
      ANY  =.FALSE.        
      IF (OSUBC .EQ. 0) CALL FWDREC (*610,INFILE)        
      IF (ISET.EQ.-2 .OR. ISORT.EQ.2 .OR. SUBC.NE.OSUBC) GO TO 100      
      DO 80 I=1,3        
      CALL BCKREC (INFILE)        
 80   CONTINUE        
      GO TO 90        
C        
C *** READ INPUT FILE ID RECORD AND SET ISORT FLAG FOR SORT1 OR SORT2   
C     DATA TYPE        
C     AT THIS TIME, ISORT MAY BE ALREADY SET BY PREVIOUS SCAN, OR ZERO  
C        
 85   IF (ISORT.EQ.2 .OR. NREW.GE.2) GO TO 490        
      NREW=NREW+1        
      CALL REWIND (INFILE)        
 90   CALL FWDREC (*610,INFILE)        
 100  CALL READ (*85,*110,INFILE,ID,50,0,IWDS)        
      CALL READ (*610,*620,INFILE,HEAD,96,1,IWDS)        
      ISORT=1        
      IF (ID(2) .GE. 2000) ISORT=2        
      IF (ID(2) .GE. 3000) GO TO 500        
C        
C *** SYNCHRONIZE SUBCASE ID (WHICH MAY NOT BE IN ASCENDING ORDER)      
C        
      IF (ISET.EQ.-2 .OR. ISORT.EQ.2 .OR. ID(4).EQ.SUBC) GO TO 130      
 110  CALL REWIND (INFILE)        
      NREW=NREW+1        
      IF (NREW .GT. 2) GO TO 490        
 120  CALL FWDREC (*610,INFILE)        
      CALL READ (*610,*110,INFILE,ID,10,1,IWDS)        
      IF (ID(4) .NE. SUBC) GO TO 120        
      CALL BCKREC (INFILE)        
      GO TO 100        
C        
C *** SYNCHRONIZE ELEMENT TYPE (WHICH MAY NOT BE IN ASCENDING ORDER)    
C        
 130  IF (ID(3)-IEL) 90,140,90        
 140  OEL =IEL        
      NREW=0        
C        
C *** POSITION DATA BLOCK FOR FIRST CASE AND BEGIN SCAN        
C        
      I=140        
      IF (DEBUG) WRITE (NOUT,145) I,ISET,ISORT,ICASE,LCSE1,LCSE2,SUBC   
 145  FORMAT (/9X,12HDEBUG/STRSCN,I4,1H-,/2X,I9,11I7,3X,L1)        
      NWDS =ID(10)        
CWKBNB 1/3/94 SPR93010 & 93011
      LAYERD = .FALSE.
C FOR LAYERED QUAD4 AND TRIA3 IEL WILL BE EITHER 64 OR 83 RESPECTIVELY
C AND ID(10) WILL BE 10 (10 IS THE NUMBER OF WORDS PER LINE TO BE PRINTED). 
      IF ( (IEL .EQ. 64 .OR. IEL .EQ. 83) .AND. ID(10) .EQ. 10 )
     &         LAYERD = .TRUE.
      IF ( .NOT. LAYERD ) GO TO 144
C TO DETERMINE THE NUMBER OF WORDS PER EACH ELEMENT, WILL NEED TO DETERMINE
C HOW MANY LAYERS ARE PRESENT (Z(LBUF1+1)) AND ALLOW 10 WORDS PER LAYER
C PLUS A THREE WORD HEADER AND TWO EXTRA WORDS ON THE END.
      CALL READ (*610,*340,INFILE,IZ(LBUF1),3,0,IWDS)  
      NWDS = 3 + 10*IZ(LBUF1+1) + 2
C      PRINT *,' COMPUTED NWDS=',NWDS
      CALL BCKREC ( INFILE )
CWKBNE 1/3/94 SPR93010 & 93011
 144  NWDS1=NWDS+1        
      LBUF2=LBUF1+NWDS1        
      LBUF3=LBUF2        
      IH1  =LBUF2        
 146  IH2  =LBUF2+NWDS1*NTOP-1        
      IL1  =IH2+1        
      IL2  =IH2+NWDS1*NTOP        
      IF (IL2 .GT. LCORE) GO TO 660        
      II   =0        
      JJ   =0        
      KK   =0        
      MM   =IH1        
      NN   =IL1        
      IDELM=-1        
      ICASE=0        
      ANY  =.FALSE.        
      IF (LCSE1 .EQ. -2) LCSE1=0        
      IF (LCSE1 .GT. -2) NS=LBEG        
 150  NS=NS-1        
      NS=MIN0(NS,LBEG-1)        
      IF (ISORT.EQ.2 .AND. IDELM.NE.-1) GO TO 90        
 160  CALL READ (*610,*340,INFILE,IZ(LBUF1),NWDS,0,IWDS)        
C        
C *** CHECK WHETHER THIS ELEMENT IS NEEDED FOR SCAN        
C     WALK THROUGH SET ARRAY IF IT IS NECESSARY TO DO SO (R.F. ONLY)    
C     CHECK SUBCASE NO. INSTEAD OF ELEM. ID IF THIS IS A USER DAMP ALTER
C     RUN WITH SORT2 TYPE DATA        
C        
      IF (ISET  .NE. -2) GO TO 170        
      IF (LCSE1 .LE. -1) GO TO 200        
      ICASE=IZ(LBUF1)        
      IF (ISORT .EQ. 1) ICASE=ICASE/10        
      IF (ICASE .GE. LCSE1) IF (ICASE-LCSE2) 200,200,330        
      GO TO 160        
 170  IF (ISET.EQ.-1 .OR. LCSE1.EQ.-2) GO TO 200        
      IDELM=IZ(LBUF1)/10        
      IF (ISORT .EQ. 2) IDELM=ID(5)/10        
 180  NS=NS+1        
      IF (NS .GT. LEND) GO TO 330        
      IZN=IZ(NS)        
      IF (IZN .GE. 0) IF (IDELM-IZN) 150,190,180        
      IZN =IABS(IZN)        
      IF (IDELM .EQ. IZN) GO TO 190        
      IZN1=IZ(NS-1)        
      IF (IZN1.LE.0 .OR. IZN1.GT.IZN) GO TO 640        
      IF (IDELM .GT. IZN ) GO TO 180        
      IF (IDELM .LT. IZN1) GO TO 640        
      NS=NS-1        
 190  IF (ISORT .EQ. 2) LCSE1=-2        
C        
C *** MAKE SURE DEVICE CODE IS SET TO PRINT (SORT1 ONLY)        
C     SET UP COMPONENT DUPLICATION/INC LOOP IF THEY ARE VALID        
C        
 200  IF (ISORT .EQ. 1) IZ(LBUF1)=(IZ(LBUF1)/10)*10 + 1        
      I=200        
      IF (DEBUG) WRITE (NOUT,145) I,IZ(LBUF1),ICASE,LCSE1,LCSE2,IDUPL,  
     1                            INC,NS,ISORT,NWDS,ISET,SUBC,IOPT,ANY  
      JDUPL=1        
      JNC  =0        
      IF (ISET.EQ.-2 .OR. IDUPL.LE.0) GO TO 210        
      JDUPL=IDUPL        
      JNC  =INC        
C        
C *** PICKUP MAX AND MIN OF CURRENT ELEMENT DATA        
C     SAVE THESE MAX, MIN AS KEYS FOR SORTING LATER        
C        
 210  BMAX=-T24        
      BMIN= T24        
C QUAD4 (=64) AND TRIA3 (=83) WILL HAVE JDUPL NE 0 FOR LAMINATED
C CASE (I.E., WHEN LAYERD IS TRUE) FOR STRESS CASES
      IF ( ( IEL .EQ. 64 .OR. IEL .EQ. 83 ) .AND. JDUPL .EQ. 49
     &     .AND. .NOT. LAYERD .AND. STRESS ) GO TO 492
      IF ( ( IEL .EQ. 64 .OR. IEL .EQ. 83 ) .AND. JDUPL .NE. 49
     &     .AND.       LAYERD .AND. STRESS ) GO TO 492
CWKBNB 1/3/94 SPR93010 & 93011
C SET QUAD4 OR TRIA3 TO FALSE TO INDICATE TO SUBROUTINE SCAN THAT 
C DATA FOR THESE ELEMENTS HAS BEEN FOUND IN EITHER OES1 OR OES1L FILES.
      IF ( IEL .EQ. 64 ) QUAD4 = 1
      IF ( IEL .EQ. 83 ) TRIA3 = 1
C IF JDUPL IS 49 THAN THIS IS A QUAD4 OR TRIA3 LAYERED ELEMENT, GET
C VALUE AFTER ELEMENT ID IN RECORD TO DETERMINE THE NUMBER OF LAYERS IN
C IN THE ELEMENT.
      IF ( JDUPL .EQ. 49 ) JDUPL = IZ(LBUF0+2)
CWKBNE 1/3/94 SPR93010 & 93011
C      PRINT *,' BEFORE 230,JDUPL,JNC,NSCAN=',JDUPL,JNC,NSCAN
C      PRINT *,' BEFORE 230,ISCAN=',(ISCAN(KB),KB=1,NSCAN)
      DO 230 J=1,NSCAN        
      I=ISCAN(J)        
      IF (I .GT. NWDS) GO TO 230        
      KK=0        
      DO 220 K=1,JDUPL        
C      WRITE(6,77777)Z(LBUF0+I+KK)
C77777 FORMAT(' HEX OF Z=',Z8)
      ZK=Z(LBUF0+I+KK)        
      IF (ZK .GT. BMAX) BMAX=ZK        
      IF (ZK .LT. BMIN) BMIN=ZK        
 220  KK=KK+JNC        
 230  CONTINUE        
C        
      IF (IOPT .EQ. 2) GO TO 250        
C        
C *** OPTION ONE (IOPT=1, BY MAX-MIN)        
C     ===============================        
C        
C     LBUF2 AND LBUF3 ARE BEGINNING AND ENDING POINTERS TO THE SCANNED  
C     DATA ARRAY        
C        
      IF (BMAX.LT.AMAX .AND. BMIN.GT.AMIN) GO TO 160        
      IF (LBUF3+NWDS1 .GT. LCORE) GO TO 630        
      ANY=.TRUE.        
      DO 240 I=1,NWDS        
      Z(LBUF3+I)=Z(LBUF0+I)        
 240  CONTINUE        
      Z(LBUF3)=BMAX        
      IF (BMIN .LE. AMIN) Z(LBUF3)=BMIN        
      LBUF3=LBUF3+NWDS1        
      GO TO 160        
C        
C *** OPTION TWO (IOPT=2)        
C     ===================        
C        
C     TOP AND BOTTOM N VALUES FOR STRESSES        
C     TOP VALUE SCAN FOR FORCES IF TOPN IS POSITIVE        
C     BOTTEM VALUE SCAN FOR FORCES AND MARGIN ETC. IF TOPN IS NEGATIVE  
C        
C     II AND JJ ARE TOP AND BOTTOM ARRAY COUNTERS        
C     MM IS POINTER TO THE SMALLEST OF THE TOP VALUSES        
C     NN IS POINTER TO THE BIGGEST OF THE BOTTOM VALUSES        
C        
C     WHEN TOP AND BOTTOM ARRAYS ARE FILLED UP COMPLETELY WITH SCANNED  
C     DATA (II=JJ=NTOP), IH1 AND IH2 ARE BEGINNING AND ENDING POINTERS  
C     TO THE TOP VALUES, SIMILARY, IL1 AND IL2 ARE FOR THE BOTTOM VALUES
C        
C     REMEMBER, SORF=1 FOR STRESS SCAN, SORF=2 FOR FORCE SCAN        
C               NTOP=IABS(TOPN)        
C        
 250  ANY=.TRUE.        
      IF ( SORF.EQ.2 .AND. TOPN.LE.0) GO TO 290        
      IF ((SORF.EQ.1 .AND. BMAX.LT.0.0) .OR.        
     1   (II.GE.NTOP .AND. BMAX.LT.Z(MM))) GO TO 290        
      DO 260 I=1,NWDS        
 260  Z(MM+I)=Z(LBUF0+I)        
      Z(MM)=BMAX        
      IF (II .GE. NTOP) GO TO 270        
      II=II+1        
      MM=MM+NWDS1        
      IF (II .LT. NTOP) GO TO 290        
 270  MM  =IH1        
      BMAX=+T24        
      DO 280 I=IH1,IH2,NWDS1        
      IF (Z(I) .GT. BMAX) GO TO 280        
      BMAX=Z(I)        
      MM  =I        
 280  CONTINUE        
C        
 290  IF ( SORF.EQ.2 .AND. TOPN.GE.0) GO TO 160        
      IF ((SORF.EQ.1 .AND. BMIN.GT.0 .AND. TOPN.GT.0) .OR.        
     1   (JJ.GE.NTOP .AND. BMIN.GT.Z(NN))) GO TO 160        
      DO 300 I=1,NWDS        
 300  Z(NN+I)=Z(LBUF0+I)        
      Z(NN)=BMIN        
      IF (JJ .GE. NTOP) GO  TO 310        
      JJ=JJ+1        
      NN=NN+NWDS1        
      IF (JJ .LT. NTOP) GO TO 160        
 310  NN  =IL1        
      BMIN=-T24        
      DO 320 I=IL1,IL2,NWDS1        
      IF (Z(I) .LT. BMIN) GO TO 320        
      BMIN=Z(I)        
      NN  =I        
 320  CONTINUE        
      GO TO 160        
C        
C *** ELEM. ID LIST, OR SUBCASE LIST, HAS BEEN EXHAULSTED        
C     (NOTE - SHOULD RETURN WITHOUT FWDREC HERE.  IF STRSCN IS CALLED   
C             AGAIN, FWDREC WILL BE DONE AT 90)        
C        
 330  I=330        
      IF (DEBUG) WRITE (NOUT,145) I,IDELM,ICASE,ISORT,NS,LBEG,LEND,     
     1                            LCSE1,LCSE2        
      IF (ANY) GO TO 350        
      GO TO 510        
C        
C *** EOR READ (FROM 160)        
C        
 340  ID(11)=0        
      IF (ANY) GO TO 350        
      ID(11)=1        
      ID(10)=1        
      NWDS  =1        
      IL2   =IH1+1        
      IZ(IL2)=01        
      IF (ISORT .EQ. 2) IZ(IL2)=0        
      IZ(  2)=1        
C        
C *** THIS ELEMENT TYPE IS DONE.  BEGIN OUTPUT PROCEDURE        
C     MAKE SURE DEVICE CODE IS SET TO PRINT, ALWAYS        
C     ADD SCAN HEADER TO LABEL LINE        
C        
 350  ID(1)=(ID(1)/10)*10 + 1        
      IF (ISORT .EQ. 2) ID(5)=(ID(5)/10)*10 + 1        
      CALL WRITE (OUFILE,ID(1),50,NOEOR)        
      GO TO 530        
 360  IF (IOPT .EQ. 1) GO TO 370        
      WRITE(CHEAD(69:100), 8004 ) NTOP
8004  FORMAT('TOP AND BOTTOM  ',I4,' VALUES')
      GO TO 380        
 370  WRITE(CHEAD(69:100), 8005 ) AMIN, AMAX
8005  FORMAT('EXCLUDING TO ',2(F8.1))
 380  CONTINUE        
      HEAD(73)=IBLANK        
      DO 400 I = 1, 25
400   HEAD(I+64) = IHEAD(I)
      HEAD(95)=SORTX(1)        
      HEAD(96)=SORTX(2)        
      IF (ISORT .EQ. 2) HEAD(96)=SORTX(3)        
      CALL WRITE (OUFILE,HEAD,96,EOR)        
C        
      KK=1        
      J =2        
      IF (.NOT.ANY) GO TO 460        
C        
C *** (IOPT=2 ONLY) IF TOP AND BOTTOM ARRAYS ARE NOT FULL (I.E. II AND/ 
C     OR JJ ARE  .LT. NTOP), WE NEED TO SQUEEZE OUT SOME EMPTY CELLS IN 
C     THE SPACE FROM Z(IH1) THRU Z(IL2) BEFORE SORTING THE SCANNED DATA 
C        
      IF (IOPT .EQ. 2) GO TO 410        
      IL2=LBUF3        
      GO TO 430        
 410  IF (II+JJ .EQ. 2*NTOP) GO TO 430        
      KK =(NTOP-II)*NWDS1        
      IL2=IH2+JJ*NWDS1        
      DO 420 I=IL1,IL2        
 420  Z(I-KK)=Z(I)        
      IL2=IH1+(II+JJ)*NWDS1-1        
C        
C *** MOVE MAX-MIN KEYS BEHIND IL2 SPACE AND BEGIN A 2-COLUMN SORT      
C     THUS AVOID MASSIVE DATA TRANSFER DURING SORTING IF THE ORIGINAL   
C     MULTI-COLUMNS SCANNED DATA WERE USED.        
C        
 430  KK=(IL2-IH1+1)/NWDS1        
      IF (IL2+2*KK .GT. LCORE) IF (IOPT-1) 630,630,660        
      I =IH1        
      J =IL2-2        
      K =0        
 440  J =J+2        
      K =K+1        
      Z (J+1)=Z(I)        
      IZ(J+2)=K        
      I =I+NWDS1        
      IF (I .LT. IL2) GO TO 440        
      K =2*KK        
      CALL SORTF (0,0,2,1,Z(IL2+1),K)        
C        
C *** BEGIN OUTPUT SCANNED DATA        
C        
      J =J+2        
      IF (DEBUG) WRITE (NOUT,450) J,KK,(Z(IL2+I),IZ(IL2+I+1),I=1,K,2)   
 450  FORMAT (/9X,17HDEBUG/STRSCN 450-,2I7,(/15X,E11.3,I5))        
 460  DO 470 K=1,KK        
      I =IH1+(IZ(J)-1)*NWDS1        
      CALL WRITE (OUFILE,IZ(I+1),NWDS,NOEOR)        
 470  J =J-2        
      CALL WRITE (OUFILE,0,0,EOR)        
      ITRL3=ITRL3+2        
      J    =KK*NWDS        
      IF (DEBUG) WRITE (NOUT,750) J,ITRL3,II,JJ        
      IF (.NOT.ANY) GO TO 680        
C        
C*** EOF ON INPUT FILE (FROM 100)        
C     NEXT ACTION WILL BE LOOP-BACK FOR MORE OR RETURN TO SCAN        
C        
C           R.F. (ISET.NE.-2)        I     USER DMAP ALTER (ISET=-2)    
C     -------------------------------+----------------------------------
C     SORT1 - RETURN TO SCAN FOR     I  SORT1 - LOOP BACK FOR NEXT SUB- 
C             NEXT SUBCASE           I          CASE, DISREGARDING THE  
C                                    I          ELEM ID LIST        
C     SORT2 - LOOP BACK FOR NEXT     I  SORT2 - LOOP BACK FOR NEXT ELEM,
C             ELEM. IF NO ELEM. LIST I          DISREGARDING THE SUBCASE
C           - IF ELEM. LIST EXISTS,  I          LIST        
C             LOOP BACK ONLY IF MORE I        
C             ELEM. TO BE PROCESSED  I        
C             OTHERWISE, RETURN      I        
C        
 480  IF (IL2 .LE. 0) GO TO 510        
      IL2 =-1        
      NREW=0        
      IF (ISET  .EQ. -2) GO TO 100        
      IF (ISORT .EQ.  1) GO TO 510        
      IF (LEND .GT. LBEG) IF (NS-LEND) 100,510,510        
      GO TO 100        
C        
C *** COULD NOT FIND ELEMENT OR SUBCASE        
C        
 490  IF (IL2 .NE. 0) GO TO 510        
CWKBNB 1/4/94 SPR93010 & 93011
 492  IF ( IEL .EQ. 64 .AND. QUAD4 .EQ. 0 ) QUAD4 = -1
      IF ( IEL .EQ. 83 .AND. TRIA3 .EQ. 0 ) TRIA3 = -1
      IF ( IEL .EQ. 64 .OR. IEL .EQ. 83 ) GO TO 510
CWKBNE 1/4/94 SPR93010 & 93011
      CALL FNAME (INFILE,Z(1))        
      WRITE (NOUT,710) IELT,Z(1),Z(2),NREW        
      GO TO 510        
C        
C *** JOB DONE        
C        
 500  IOPT=-ID(2)        
 510  DO 520 I=1,16        
 520  HEAD(I+73)=IBLANK        
      HEAD(  95)=IBLANK        
      HEAD(  96)=IBLANK        
      OSUBC=SUBC        
      RETURN        
C        
C *** INTERNAL ROUTINE TO SYNTHESIZE THE COMPONENTS FOR HEADING  
C        
 530  IF (JNC .LE. 0) GO TO 550        
550   NUMFLD = 0
C      PRINT *,' STRSCN,INC,IDUPL,NSCAN=',INC,IDUPL,NSCAN
C      PRINT *,' ISCAN=',(ISCAN(KB),KB=1,NSCAN)
      DO 580 I = 1, NSCAN
C      PRINT *,' STRSCN CALLING STRNAM,I,ISCAN=',I,ISCAN(I)
      IF ( STRESS ) CALL STRNAM ( IEL, ISCAN(I), FIELD )
      IF ( FORCE  ) CALL FORNAM ( IEL, ISCAN(I), FIELD )
      IF ( FIELD  .EQ. ' ' ) GO TO 580
      IF ( NUMFLD .EQ. 0   ) GO TO 570
      DO 560 K = 1, NUMFLD
      IF ( FIELD .EQ. SCNFLD( K ) ) GO TO 580
560   CONTINUE
570   IF ( NUMFLD .GE. 6 ) GO TO 585
      NUMFLD = NUMFLD + 1
      SCNFLD( NUMFLD ) = FIELD
580   CONTINUE
585   IF ( NUMFLD .EQ. 1 ) CHEAD(1:19) = 'SCANNED BY FIELD:  '
      IF ( NUMFLD .NE. 1 ) CHEAD(1:19) = 'SCANNED BY FIELDS: '
      ISTR = 20
      DO 588 I = 1, NUMFLD
      LEN = INDEX( SCNFLD(I), ' ' )
      IEND = ISTR + LEN - 1
      IF ( IEND .GT. 51 ) GO TO 587
      IF ( I .EQ. 1 ) CHEAD( ISTR:IEND ) = SCNFLD(I)(1:LEN) 
      IF ( I .GT. 1 ) CHEAD( ISTR:IEND+2 ) = ', '//SCNFLD(NUMFLD)(1:LEN)
      ISTR = IEND 
      IF ( I .GT. 1 ) ISTR = IEND + 2
      GO TO 588
587   CHEAD( ISTR:51) = ',...'
      GO TO 589
588   CONTINUE
589   CONTINUE
      IF ( ISET .LE. 0 ) GO TO 360
      WRITE ( CHEAD(52:68), 8001 ) ISET
8001  FORMAT(' SET:',I8 )
      GO TO 360        
C        
C *** FILE ERRORS        
C        
 590  WRITE (NOUT,720) IELT        
      GO TO 670        
 600  WRITE (NOUT,700) IOPEN,JOPEN        
      GO TO 510        
 610  IF (.NOT.ANY) GO TO 680        
      J=-2        
      GO TO 650        
 620  J=-3        
      GO TO 650        
 630  WRITE (NOUT,730) IELT        
      GO TO 510        
 640  WRITE (NOUT,740) ISET,LCSE1,LCSE2,LBEG,LEND,NS,(IZ(J),J=LBEG,LEND)
      GO TO 510        
 650  CALL MESAGE (J,INFILE,NAM)        
      GO TO 510        
 660  J=(LCORE-LBUF2+1)/(2*NWDS1)        
      WRITE (NOUT,760) IELT,NTOP,J        
      NTOP=J        
      GO TO 146        
 670  WRITE (NOUT,770) ICOMP,ICOMPX,IELT        
      GO TO 510        
 680  IF (DEBUG) WRITE (NOUT,780) IELT,SUBC        
      CALL MESAGE (30,220,IELT)        
      GO TO 480        
C        
 700  FORMAT (//5X,52HSYSTEM ERROR/STRSCN.  INPUT OR OUTPUT FILE NOT REA
     1DY, 2(2X,L1))        
 710  FORMAT (//5X, 8HELEMENT ,2A4,32H, OR SUBCASE, NOT IN DATA BLOCK , 
     1  2A4,I7,8H REWINDS)        
 720  FORMAT (//5X,34HTOO MANY COMPONENTS SPECIFIED FOR ,2A4)        
 730  FORMAT (//5X,40HINSUFFICIENT CORE TO PROCESS OUTPUT SCAN,        
     1 /5X,56HSMALL VALUES OF AMAX-AMIN REQUIRE LARGE CORE REQUIREMENT) 
 740  FORMAT (//5X,23HSYSTEM ERROR/STRSCN 740,7X,6I7, /,(5X,12I10))     
 750  FORMAT (/,I9,37H WORDS WRITTEN TO OUTPUT FILE, RECORD,I5,9X,2I5)  
 760  FORMAT (//5X,45HINSUFFICIENT CORE TO PROCESS OUTPUT SCAN FOR ,2A4,
     1 /5X,89HLARGE TOPN VALUE REQUIRES EXCESSIVE CORE REQUIREMENT.  TOP
     2N IS AUTOMATICALLY REDUCED FROM,I5,3H TO,I5)        
 770  FORMAT (//5X,40HFIELD COMPONENT ERROR, CASE ABORT/STRSCN,5X,2I9,  
     1  1X,2A4)        
 780  FORMAT (//5X,37HNO APPLICABLE ELEMT OR SUBCASE/STRSCN,3X,2A4,I8)  
      END        

      SUBROUTINE ALLMAT (A,LAMBDA,H,HL,VECT,MULT,INTH,INT,M,NCAL,IOPT1)
C
C     SUBROUTINE ALLMAT (A,LAMBDA,M,IA,NCAL)
C
C     A ON ENTRY      = MATRIX TO BE ITERATED
C     A    ON RETURN  = EIGENVECTORS  (OPTIONAL)
C     LAMBDA          = EIGENVALUES
C     M               = FIRST DIMENSION OF (A)
C     NCAL ON ENTRY   = FLAG .NE. 0. COMPUTE VECTORS
C                            .EQ. 0. NO VECTORS
C     NCAL ON RETURN  = NUMBER OF EIGENVALUES
C
C
C     PROG. AUTHORS JOHN RINZEL AND R.E.FUNDERLIC, UNION CARBIDE CORP.
C     NUCLEAR DIVISION,CENTRAL DATA PROCESSING FACILITY,
C     OAK RIDGE, TENNESSEE
C
      LOGICAL INTH(1),TWICE
      INTEGER INT(1),R,RP1,RP2
      COMPLEX A(M,M),H(M,M),HL(M,M),LAMBDA(2),VECT(1),MULT(1),
     1        SHIFT(3),TEMP,SIN,COS,TEMP1,TEMP2
C
      NVEC = NCAL
      N    = M
      NCAL = N
      IF (N .NE. 1) GO TO 1
      LAMBDA(1) = A(1,1)
      A(1,1) = 1.
      GO TO 62
    1 ICOUNT = 0
      SHIFT(1) = 0.
      IF (N .NE. 2) GO TO 4
    2 TEMP = (A(1,1)+A(2,2) + CSQRT((A(1,1)+A(2,2))*(A(1,1)+A(2,2)) -
     1        4.*(A(2,2)*A(1,1)-A(2,1)*A(1,2))))/2.
      IF (REAL(TEMP).NE.0. .OR. AIMAG(TEMP).NE.0.) GO TO 3
      LAMBDA(M  ) = SHIFT(1)
      LAMBDA(M-1) = A(1,1) + A(2,2) + SHIFT(1)
      GO TO 37
    3 LAMBDA(M  ) = TEMP + SHIFT(1)
      LAMBDA(M-1) = (A(2,2)*A(1,1)-A(2,1)*A(1,2))/(LAMBDA(M)-SHIFT(1))
     1            + SHIFT(1)
      GO TO 37
C
C     REDUCE MATRIX A TO HESSENBERG FORM
C
    4 NM2 = N - 2
      DO 15 R = 1,NM2
      RP1 = R + 1
      RP2 = R + 2
      ABIG= 0.
      INT(R) = RP1
      DO 5 I = RP1,N
      ABSSQ = REAL(A(I,R))**2 + AIMAG(A(I,R))**2
      IF (ABSSQ .LE. ABIG) GO TO 5
      INT(R) = I
      ABIG   = ABSSQ
    5 CONTINUE
      IF (ABIG .EQ. 0.) GO TO 15
      INTER = INT(R)
      IF (INTER .EQ. RP1) GO TO 8
      DO 6 I = R,N
      TEMP = A(RP1,I)
      A(RP1,I) = A(INTER,I)
    6 A(INTER,I) = TEMP
      DO 7 I = 1,N
      TEMP = A(I,RP1)
      A(I,RP1) = A(I,INTER)
    7 A(I,INTER) = TEMP
    8 DO 9 I  = RP2,N
      MULT(I) = A(I,R)/A(RP1,R)
    9 A(I,R)  = MULT(I)
      DO 11 I = 1,RP1
      TEMP = 0.
      DO 10 J = RP2,N
   10 TEMP = TEMP + A(I,J)*MULT(J)
   11 A(I,RP1) = A(I,RP1) + TEMP
      DO 13 I = RP2,N
      TEMP = 0.
      DO 12 J = RP2,N
   12 TEMP = TEMP + A(I,J)*MULT(J)
   13 A(I,RP1) = A(I,RP1) + TEMP - MULT(I)*A(RP1,RP1)
      DO 14 I = RP2,N
      DO 14 J = RP2,N
   14 A(I,J) = A(I,J) - MULT(I)*A(RP1,J)
   15 CONTINUE
C
C     CALCULATE EPSILON
C
      EPS = 0.
      DO 16 I = 1,N
   16 EPS = EPS + CABS(A(1,I))
      DO 18 I = 2,N
      SUM = 0.
      IM1 = I - 1
      DO 17 J = IM1,N
   17 SUM = SUM + CABS(A(I,J))
   18 IF (SUM .GT. EPS) EPS = SUM
      EPS = SQRT(FLOAT(N))*EPS*1.E-12
      IF (EPS .EQ. 0.) EPS = 1.E-12
      DO 19 I = 1,N
      DO 19 J = 1,N
   19 H(I,J) = A(I,J)
   20 IF (N .NE. 1) GO TO 21
      LAMBDA(M) = A(1,1) + SHIFT(1)
      GO TO 37
   21 IF (N .EQ. 2) GO TO 2
   22 MN1 = M - N + 1
      ARD = REAL (A(N,N))
      AID = AIMAG(A(N,N))
      ARN = REAL (A(N,N-1))
      AIN = AIMAG(A(N,N-1))
      IF (ARD.EQ.0.0 .AND. AID.EQ.0.0) GO TO 23
      TERM1 = ABS(ARD*ARN + AID*AIN)
      TERM2 = ABS(ARD*AIN - AID*ARN)
      TERM3 = ARD*ARD + AID*AID
      IF ((TERM1+TERM2) .LE. 1.0E-9*TERM3) GO TO 24
   23 IF ((ABS(ARN)+ABS(AIN)) .GE. EPS) GO TO 25
   24 LAMBDA(MN1) = A(N,N) + SHIFT(1)
      ICOUNT = 0
      N = N - 1
      GO TO 21
C
C     DETERMINE SHIFT
C
   25 SHIFT(2) = (A(N-1,N-1)+A(N,N) + CSQRT((A(N-1,N-1)+A(N,N))*
     1           (A(N-1,N-1)+A(N,N)) - 4.*(A(N,N)*A(N-1,N-1)-A(N,N-1)*
     2            A(N-1,N))))/2.
      IF (REAL(SHIFT(2)).NE.0. .OR. AIMAG(SHIFT(2)).NE.0.) GO TO 26
      SHIFT(3) = A(N-1,N-1) + A(N,N)
      GO TO 27
   26 SHIFT(3) = (A(N,N)*A(N-1,N-1) - A(N,N-1)*A(N-1,N))/SHIFT(2)
   27 IF (CABS(SHIFT(2)-A(N,N)) .LT. CABS(SHIFT(3)-A(N,N))) GO TO 28
      INDEX = 3
      GO TO 29
   28 INDEX = 2
   29 IF (CABS(A(N-1,N-2)) .GE. EPS) GO TO 30
      LAMBDA(MN1  ) = SHIFT(2) + SHIFT(1)
      LAMBDA(MN1+1) = SHIFT(3) + SHIFT(1)
      ICOUNT = 0
      N = N - 2
      GO TO 20
   30 SHIFT(1) = SHIFT(1) + SHIFT(INDEX)
      DO 31 I = 1,N
   31 A(I,I) = A(I,I) - SHIFT(INDEX)
C
C     PERFORM GIVENS ROTATIONS, QR ITERATES
C
      IF (ICOUNT .LE. 20) GO TO 32
      NCAL  = M - N
      GO TO 37
   32 NM1   = N - 1
      TEMP1 = A(1,1)
      TEMP2 = A(2,1)
      DO 36 R = 1,NM1
      RP1   = R + 1
      RHO   = SQRT(REAL(TEMP1)**2 + AIMAG(TEMP1)**2 +
     1        REAL(TEMP2)**2 + AIMAG(TEMP2)**2)
      IF (RHO .EQ. 0.) GO TO 36
      COS   = TEMP1/RHO
      SIN   = TEMP2/RHO
      INDEX = MAX0(R-1,1)
      DO 33 I = INDEX,N
      TEMP  = CONJG(COS)*A(R,I) + CONJG(SIN)*A(RP1,I)
      A(RP1,I) =-SIN*A(R,I) + COS*A(RP1,I)
   33 A(R,I) = TEMP
      TEMP1  = A(RP1,RP1)
      TEMP2  = A(R+2,R+1)
      DO 34 I = 1,R
      TEMP   = COS*A(I,R) + SIN*A(I,RP1)
      A(I,RP1) =-CONJG(SIN)*A(I,R) + CONJG(COS)*A(I,RP1)
   34 A(I,R) = TEMP
      INDEX  = MIN0(R+2,N)
      DO 35 I = RP1,INDEX
      A(I,R) = SIN*A(I,RP1)
   35 A(I,RP1) = CONJG(COS)*A(I,RP1)
   36 CONTINUE
      ICOUNT = ICOUNT + 1
      GO TO 22
C
C     CALCULATE VECTORS
C
   37 IF (NCAL.EQ.0 .OR. NVEC.EQ.0) GO TO 62
      N   = M
      NM1 = N - 1
      IF (N .NE. 2) GO TO 38
      EPS = AMAX1(CABS(LAMBDA(1)),CABS(LAMBDA(2)))*1.E-8
      IF (EPS .EQ. 0.) EPS = 1.E-12
      H(1,1) = A(1,1)
      H(1,2) = A(1,2)
      H(2,1) = A(2,1)
      H(2,2) = A(2,2)
   38 DO 56 L = 1,NCAL
      DO 40 I = 1,N
      DO 39 J = 1,N
   39 HL(I,J) = H(I,J)
   40 HL(I,I) = HL(I,I) - LAMBDA(L)
      DO 44 I = 1,NM1
      MULT(I) = 0.
      INTH(I) = .FALSE.
      IP1 = I + 1
      IF (CABS(HL(I+1,I)) .LE. CABS(HL(I,I))) GO TO 42
      INTH(I) = .TRUE.
      DO 41 J = I,N
      TEMP = HL(I+1,J)
      HL(I+1,J) = HL(I,J)
   41 HL(I,J  ) = TEMP
   42 IF (REAL(HL(I,I)).EQ.0. .AND. AIMAG(HL(I,I)).EQ.0.) GO TO 44
      MULT(I) = -HL(I+1,I)/HL(I,I)
      DO 43 J = IP1,N
   43 HL(I+1,J) = HL(I+1,J) + MULT(I)*HL(I,J)
   44 CONTINUE
      DO 45 I = 1,N
   45 VECT(I) = 1.
      TWICE = .FALSE.
   46 IF (REAL(HL(N,N)).EQ.0. .AND. AIMAG(HL(N,N)).EQ.0.) HL(N,N) = EPS
      VECT(N) = VECT(N)/HL(N,N)
      DO 48 I = 1,NM1
      K = N - I
      DO 47 J = K,NM1
   47 VECT(K) = VECT(K) - HL(K,J+1)*VECT(J+1)
      IF (REAL(HL(K,K)).EQ.0. .AND. AIMAG(HL(K,K)).EQ.0.) HL(K,K) = EPS
   48 VECT(K) = VECT(K)/HL(K,K)
      BIG = 0.
      DO 49 I = 1,N
      SUM = ABS(REAL(VECT(I))) + ABS(AIMAG(VECT(I)))
   49 IF (SUM .GT. BIG) BIG = SUM
      DO 50 I = 1,N
   50 VECT(I) = VECT(I)/BIG
      IF (TWICE) GO TO 52
      DO 51 I = 1,NM1
      IF (.NOT.INTH(I)) GO TO 51
      TEMP = VECT(I)
      VECT(I  ) = VECT(I+1)
      VECT(I+1) = TEMP
   51 VECT(I+1) = VECT(I+1) + MULT(I)*VECT(I)
      TWICE = .TRUE.
      GO TO 46
   52 IF (N .EQ. 2) GO TO 55
      NM2 = N - 2
      DO 54 I = 1,NM2
      N1I = N - 1 - I
      NI1 = N - I + 1
      DO 53 J = NI1,N
   53 VECT(J) = H(J,N1I)*VECT(N1I+1) + VECT(J)
      INDEX = INT(N1I)
      TEMP  = VECT(N1I+1)
      VECT(N1I+1) = VECT(INDEX)
   54 VECT(INDEX) = TEMP
   55 DO 56 I = 1,N
   56 A(I,L) = VECT(I)
      DO 61 J = 1,NCAL
      TE = 0.
      DO 58 I = 1,N
      TEM = CABS(A(I,J))
      IF (TE .GT. TEM) GO TO 58
      L = I
      TE = TEM
   58 CONTINUE
      TEMP1 = A(L,J)
      DO 60 I = 1,N
   60 A(I,J) = A(I,J)/TEMP1
   61 CONTINUE
   62 RETURN
      END

      SUBROUTINE FA1PKV (AZ,AMK,AMB,N,E1,CZ,BREF,PI,VEL,IBUF)
C
      INTEGER         IBUF(1),IV(6),TRL(7)
      REAL            E1(5),V(6),E(2),AMK(1),AMB(1),CZ(1)
      COMPLEX         AZ(1),CEIG,EIGEN,EIGZ
      COMMON /SYSTEM/ SYSBUF,NOUT,SPACE(6),NLPP,X(2),LINES
      EQUIVALENCE     (V(1),IV(1)),(EIGEN,E(1))
      DATA    ISCR  / 301/, IPASS /0/
C
      EIGZ = (0.0,0.0)
      IF (N .LT. 2) GO TO 1000
      E(1) = E1(1)
      E(2) = E1(2)
      IF (IPASS .NE. 0) GO TO 5
      CALL OPEN (*1000,ISCR,IBUF,1)
      GO TO 9
    5 CALL OPEN (*1000,ISCR,IBUF,3)
    9 IPASS = IPASS + 1
C
C     BUILD A = IP2 + M-1B P + M-1K
C
      CEIG = EIGEN*EIGEN
      K = 0
      DO 10 I = 1,N
      DO 10 J = 1,N
      K = K + 1
      AZ(K) = -AMB(K)*EIGEN - AMK(K)
      IF (I .EQ. J) AZ(K) = AZ(K) + CEIG
   10 CONTINUE
C
C     CORE FOR EGNVCT
C
      N2 = N*2
      NA = 1  + N2*N
      NB = NA + N2
      NC = NB + N2
      ND = NC + N2
      CALL EGNVCT (AZ,CZ(NA),EIGZ,CZ(NB),CZ(NC),CZ(ND),N)
C
C     BUILD ON SCR1 DATA FOR VECTOR OUTPUT
C
      IV(1) = IPASS
      IV(2) = IPASS
      V (3) = E1(1)
      V (4) = E1(2)
      IF (E1(2) .EQ. 0.0) GO TO 20
      V(5)  = E1(3)
      V(6)  = E1(5)
      GO TO 22
   20 V(5)  = 0.0
      V(6)  = (BREF/(.34657*VEL))*E1(1)
   22 CALL WRITE (ISCR,IV,6,1)
      CALL WRITE (ISCR,CZ(NB),N2,1)
C
C     VECTOR IS IN CZ(NB)
C
      LINES = NLPP
      K = 0
      DO 30 I = 1,N
      IF (LINES .LT. NLPP) GO TO 25
      CALL PAGE1
      WRITE  (NOUT,21) EIGEN
   21 FORMAT (1H0,47X,30HEIGENVECTOR FROM THE PK METHOD, /3X,
     1        13HEIGENVALUE = ,1P,E15.5,1P,E15.5, //3X,11HEIGENVECTOR)
      LINES = LINES + 5
   25 LINES = LINES + 1
      WRITE  (NOUT,26) CZ(NB+K),CZ(NB+K+1)
   26 FORMAT (16X,1P,E15.5,1P,E15.5)
      K = K + 2
   30 CONTINUE
      TRL(1) = ISCR
      TRL(2) = 1
      CALL WRTTRL (TRL)
 1000 CALL CLOSE (ISCR,3)
      RETURN
      END

      SUBROUTINE DDCMPS
C
C     DDCMPS IS THE DMAP DRIVER FOR SDCMPS
C
C     SDCMPS   USET,GPL,SIL,KAA/LLL,ULL/SYM=0/DIAGCK=0/DIAGET=20/
C              PDEFCK=0/SING=0/SET=L/CHLSKY=0/DET=0.0D0/MINDIA=0.0D0/
C              POWER=0/SUBNAM=NONE
C
C     SYM      =  1 - USE SYMMETRIC DECOMPOSITION
C                 0 - CHOOSE WHICH DECOMPOSITION BASED ON INPUT MATRIX
C                -1 - USE UNSYMETRIC DECOMPOSITION
C     DIAGCK   =  DIAGONAL SINGULARITY CHECK              (SDCMPS)
C                 - = NO CHECK                            (SDCMPS)
C                 0 = NONFATAL                            (SDCMPS)
C                 + = MAX ALLOWED FATAL                   (SDCMPS)
C     DIAGET   =  DIAGONAL SINGULARITY ERROR TOLERANCE.   (SDCMPS)
C     PDEFCK   =  POSITIVE DEFINATE CHECK                 (SDCMPS)
C                 - = NO CHECK                            (SDCMPS)
C                 0 = NONFATAL                            (SDCMPS)
C                 + = MAX ALLOWED FATAL                   (SDCMPS)
C     SING     =  SINGULARITY OUTPUT FLAG
C                 1 = OK
C                 0 = NONCONSERVATIVE OR ES FAILURE
C                -1 = SINGULAR OR LIMITS EXCEEDED
C     SET      =  SET MATRIX BELONGS TO                   (SDCMPS)
C     CHLSKY   =  1 USE CHOLESKY DECOMPOSITION LLL = C
C     DET      =  DETERMINANT OF KAA
C     MINDIA   =  MINIMUM DIAGONAL OF ULL
C     POWER    =  SCALE FACTOR FOR DET
C     SUBNAM   =  SUBSTRUCTURE NAME                       (SDCMPS)
C
      LOGICAL          OPNSCR   ,FIRST
      INTEGER          BUF6     ,CHLSKY   ,DIAGCK   ,DIAGET   ,NAME(2) ,
     1                 NAM(2)   ,OUTPT    ,PARM     ,PDEFCK   ,POWER   ,
     2                 RECT     ,SET      ,SING     ,SQR      ,SYM     ,
     3                 ULL
      REAL             ZZ(1)    ,ZZZ(1)   ,ZZZZ(1)  ,ZM(1)
      DOUBLE PRECISION CDET     ,CMNDIA   ,MINDIA   ,SDETC    ,MINDS   ,
     1                 DDET     ,DMNDIA   ,SDET
      CHARACTER        UFM*23   ,UWM*25   ,UIM*29   ,SFM*25   ,SWM*27
      COMMON /XMSSG /  UFM      ,UWM      ,UIM      ,SFM      ,SWM
      COMMON /BLANK /  ISYM     ,DIAGCK   ,DIAGET   ,PDEFCK   ,SING    ,
     1                 SET(2)   ,CHLSKY   ,DET(2)   ,MINDIA   ,POWER   ,
     2                 SUBNAM(2)
      COMMON /SDCQ  /  NERR(2)   ,NOGLEV   ,BUF6     ,ISCMSG   ,ISCDIA ,
     1                 ISTSCR    ,KPDFCK   ,KDGCK    ,KDGET    ,KPREC  ,
     2                 PARM(4)   ,OPNSCR   ,FIRST
      COMMON /SFACT /  IFILA(7)  ,IFILL(7) ,IFILU(7) ,KSCR1    ,
     1                 KSCR2     ,NZ       ,SDET     ,SDETC    ,KPOW   ,
     2                 KSCR3     ,MINDS    ,ICHLK
      COMMON /DCOMPX/  IA(7)     ,IL(7)    ,IU(7)    ,ISCR1    ,
     1                 ISCR2     ,ISCR3    ,DDET     ,IPOW     ,
     3                 NZZ       ,DMNDIA   ,IB
      COMMON /CDCMPX/  JA(7)     ,JL(7)    ,JU(7)    ,JSCR1    ,
     1                 JSCR2     ,JSCR3    ,CDET(2)  ,JPOW     ,
     3                 NZZZ      ,CMNDIA   ,JB
      COMMON /NAMES /  KNAMES(19)
      COMMON /SYSTEM/  KSYSTM(69)
      COMMON /ZZZZZZ/  Z(1)
      EQUIVALENCE      (ZZ(1),Z(1))
      EQUIVALENCE      (ZZZ(1),Z(1))
      EQUIVALENCE      (ZZZZ(1),Z(1))
      EQUIVALENCE      (ZM(1),Z(1))
      EQUIVALENCE      (KSYSTM( 1),NBUFSZ) ,(KSYSTM( 2),OUTPT) ,
     1                 (KNAMES(12),SQR   ) ,(KNAMES(13),RECT ) ,
     2                 (KNAMES(17),SYM   )
      DATA    LUSET ,  LGPL ,LSIL ,KAA  ,LLL  ,ULL  ,LSCR1,LSCR2,LSCR3 /
     1        101   ,  102  ,103  ,104  ,201  ,202  ,301  ,302  ,303   /
      DATA    LSCR4 ,  LSCR5,LSCR6/
     1        304   ,  305  ,306  /
      DATA    NAME  /  4HDDCM, 4HPS   /
      DATA    NAM   /  4HSDCM, 4HPS   /
C
C     NOTE SYM DECOMP DOES NOT OUTPUT  ULL
C
C
      OPNSCR = .FALSE.
      FIRST  = .TRUE.
      SING   = 1
      JA(1)  = KAA
      CALL RDTRL (JA)
      IF (JA(1) .LT. 0) GO TO 490
      IFORM  = JA(4)
      IF (ISYM) 10,50,30
   10 IF (IFORM .NE. SYM) GO TO 20
      CALL PAGE2 (2)
      WRITE  (OUTPT,15) SWM,NAM
   15 FORMAT (A27,' 2340, MODULE ',2A4,' HAS BEEN REQUESTED TO DO ',
     1       'UNSYMETRIC DECOMPOSITION OF A SYMETRIC MATRIX')
   20 IFORM = RECT
      IF (JA(2) .EQ. JA(3)) IFORM = SQR
      GO TO 50
C
   30 IF (IFORM .EQ. SYM) GO TO 50
      CALL PAGE2 (2)
      WRITE  (OUTPT,40) SWM,NAM
   40 FORMAT (A27,' 2341, MODULE ',2A4,' HAS BEEN FURNISHED A SQUARE ',
     1       'MATRIX MARKED UNSYMETRIC FOR SYMETRIC DECOMPOSITION.')
      IFORM = SYM
   50 ISYM  = -1
      IF (IFORM .EQ. SYM) ISYM = 1
      JA(4) = IFORM
      I = 0
      IF (JA(2) .EQ. JA(3)) GO TO 60
      CALL PAGE2 (2)
      I = 1
      WRITE  (OUTPT,55) SWM,NAM
   55 FORMAT (A27,' 2375, MODULE ',2A4,' HAS BEEN REQUESTED TO ',
     1       'DECOMPOSE A RECTANGULAR MATRIX')
   60 CONTINUE
      IF (ISYM .LT. 0) GO TO 200
C
C     SET UP CALL TO SDCOMP
C
      IF (I .NE. 0) GO TO 500
      IFILA(1) = KAA
      CALL RDTRL (IFILA)
      IFILL(1) = LLL
      IFILU(1) = LSCR4
      KSCR1 = LSCR1
      KSCR2 = LSCR2
      KSCR3 = LSCR3
      IFILL(5) = IFILA(5)
      ICHLK = CHLSKY
      IF (IFILA(5) .LE. 2) GO TO 100
      NZ = KORSZ (Z)
      CALL SDCOMP (*400,Z,Z,Z)
      GO TO 130
  100 NZ = KORSZ(ZZZZ)
      ISCMSG = LSCR5
      ISCDIA = LSCR6
      KPDFCK = PDEFCK
      KDGCK  = DIAGCK
      KDGET  = DIAGET
      CALL SDCMPS (ZZZZ,ZZZZ,ZZZZ)
      IF (NERR(1)+NERR(2) .EQ. 0) GO TO 110
      BUF6 = KORSZ(ZM) - 2*NBUFSZ + 1
      IF (BUF6+NBUFSZ .LE. 0) GO TO 510
      CALL SDCMM (ZM,SET(1),IFILA(2),IFILA(1),LUSET,LGPL,LSIL,SUBNAM)
      SING = 0
C
C     ONLY ES CHECK AND NONCONSERVATIVE COLUMN CAN EXIT WITH SING = 1
C     OR IF USER DESIRES TO CONTINUE
C
      IF (NOGLEV .GT. 0) SING = -1
  110 CONTINUE
      IF (PARM(1) .NE. 0) CALL MESAGE (PARM(1),PARM(2),PARM(3))
  130 DET(1) = SDET
      DET(2) = SDETC
      MINDIA = MINDS
      POWER  = KPOW
      IFILL(2) = IFILA(2)
      IFILL(3) = IFILA(3)
      IFILL(4) = 4
      IF (SING .GE. 0) CALL WRTTRL (IFILL)
      GO TO 410
C
C     SET UP CALL TO DECOMP
C
  200 CONTINUE
      IF (JA(5) .GT. 2) GO TO 300
      IA(1) = KAA
      CALL RDTRL (IA)
      IL(1) = LLL
      IU(1) = ULL
      NZZ   = KORSZ(ZZ)
      ISCR1 = LSCR1
      ISCR2 = LSCR2
      ISCR3 = LSCR3
      IB    = 0
      IL(5) = 2
      CALL DECOMP (*400,ZZ,ZZ,ZZ)
      IU(5) = 2
      IL(4) = 4
      IU(4) = 5
      IL(3) = IL(2)
      IU(3) = IU(2)
      DET(1)= DDET
      DET(2)= 0.0
      POWER = IPOW
      MINDIA= DMNDIA
      CALL WRTTRL (IU)
      CALL WRTTRL (IL)
      GO TO 410
C
C     SET UP CALL TO CDCOMP
C
  300 CONTINUE
      JL(1) = LLL
      JU(1) = ULL
      JSCR1 = LSCR1
      JSCR2 = LSCR2
      JSCR3 = LSCR3
      NZZZ  = KORSZ(ZZZ)
      JL(5) = 4
      JB    = 0
      CALL CDCOMP (*400,ZZZ,ZZZ,ZZZ)
      JU(5) = 4
      JL(4) = 4
      JU(4) = 5
      JL(3) = JL(2)
      JU(3) = JU(2)
      DET(1)= CDET(1)
      DET(2)= CDET(2)
      MINDIA= CMNDIA
      POWER = JPOW
      CALL WRTTRL (JL)
      CALL WRTTRL (JU)
      GO TO 410
C
  400 SING   = -1
      DET(1) = 0.0
      DET(2) = 0.0
      POWER  = 0
      MINDIA = 0.0
  410 RETURN
C
C     ERROR  MESSAGES
C
C     PURGED INPUT
C
  490 PARM(1) = -1
      PARM(2) = KAA
      GO TO 520
C
C     NUMBER ROWS.NE.COLUMNS
C
  500 PARM(1) = -16
      PARM(2) = KAA
      GO TO 520
C
C     INSUFFICIENT CORE
C
  510 PARM(1) = -8
      PARM(2) = -BUF6 - NBUFSZ
  520 PARM(3) = NAME(1)
      PARM(4) = NAME(2)
      GO TO 110
      END

      SUBROUTINE MRED2P (NUS,NUF,N2)
C
C     THIS SUBROUTINE OUTPUTS THE HAB MATRIX TO THE SOF AS THE HORG ITEM
C     FOR THE MRED2 MODULE.
C
      INTEGER         DRY,GBUF1,OTFILE,Z,TYPIN,TYPOUT,HAB
      DIMENSION       RZ(1),MODNAM(2),ITRLR1(7)
      COMMON /BLANK / IDUM1,DRY,IDUM2,GBUF1,IDUM3(17),OTFILE(6),
     1                ISCR(10),KORLEN,KORBGN,OLDNAM(2),IDUM4(12),NMODES
      COMMON /ZZZZZZ/ Z(1)
      COMMON /PACKX / TYPIN,TYPOUT,IROW,NROW,INCR
      COMMON /SYSTEM/ IDUM5,IPRNTR
      EQUIVALENCE     (HAB,ISCR(2)),(RZ(1),Z(1))
      DATA    MODNAM/ 4HMRED,4H2P  /
      DATA    ITEM  / 4HHORG/
C
C     FORM HAB MATRIX
C
C        **   **   **     **
C        *     *   *   .   *
C        * HAB * = * I . 0 *
C        *     *   *   .   *
C        **   **   **     **
C
      IF (DRY .EQ. -2) GO TO 160
      KOLMNS = NUS + NUF + N2
      IF (N2 .EQ. 0) KOLMNS = KOLMNS + (NMODES - NUF)
      TYPIN  = 1
      TYPOUT = 1
      IROW   = 1
      NROW   = NUS + NUF
      INCR   = 1
      IFORM  = 2
      CALL MAKMCB (ITRLR1,HAB,NROW,IFORM,TYPIN)
      CALL GOPEN (HAB,Z(GBUF1),1)
      DO 20 I = 1,KOLMNS
      DO 10 J = 1,NROW
      RZ(KORBGN+J-1) = 0.0
      IF (I .GT. NUS+NUF) GO TO 10
      IF (J .EQ. I) RZ(KORBGN+J-1) = 1.0
   10 CONTINUE
   20 CALL PACK (Z(KORBGN),HAB,ITRLR1)
      CALL CLOSE (HAB,1)
      CALL WRTTRL (ITRLR1)
C
C     STORE HAB MATRIX AS HORG ON SOF
C
      CALL MTRXO (HAB,OLDNAM,ITEM,0,ITEST)
      IF (ITEST .NE. 3) GO TO 70
      GO TO 160
C
C     PROCESS MODULE FATAL ERRORS
C
   70 GO TO (80,90,100,110,120,140), ITEST
   80 IMSG = -9
      GO TO 150
   90 IMSG = -11
      GO TO 150
  100 IMSG = -1
      GO TO 130
  110 IMSG = -2
      GO TO 130
  120 IMSG = -3
  130 CALL SMSG (IMSG,ITEM,OLDNAM)
      GO TO 160
  140 IMSG = -10
  150 DRY = -2
      CALL SMSG1 (IMSG,ITEM,OLDNAM,MODNAM)
  160 RETURN
      END

      PROGRAM FF
C
CDC   PROGRAM FF (TAPE3)
C
C     LAST MAJOR REVISIONS -  OCT 27, 1989
C                             JUN 25, 1991, FOR UNIX
C
C     A NASTRAN STAND-ALONE PROGRAM TO GENERATE NASTRAN FIX-FIELD INPUT
C     DECK FROM THIS FREE-FIELD INPUT PROGRAM.
C
C     *** THIS PROGRAM MUST BE COMPILED USING THE FOLLOWING COMPILERS
C         IBM VS FORTRAN, UNIVAC ASCII FORTRAN, CDC FORTRAN 5 (ANSI 77),
C         VAX FORTRAN IV-PLUS, AND IBM PC FORTRAN 3.0 OR RMC PROFESSION-
C         AL FORTRAN
C
C     *** VAX ONLY - THE OPEN AND CLOSE FUNCTIONS IN FF AND FFREAD MAY
C                    REQUIRE THE USE OF THE VAX ACCEPTABLE KEYWORDS.
C     (PRESENTLY, THE NON-VAX KEYWORDS ARE ACCEPTABLE BY ALL MACHINES)
C
C
C     WRITTEN BY G.CHAN/UNISYS,  APRIL 1985
C
C     SEE FFREAD SUBROUTINE FOR MORE DETAIL OF FREE-FIELD INPUT.
C
C     FILES ASSIGMENT
C           5 - CARD READER, OR CRT TERMINAL
C           6 - PRINTER, OR CRT TERMINAL
C           7 - PUNCH (IBM,CDC,VAX)
C           1 - PUNCH (UNIVAC ONLY)
C           2 - EQUATES TO USER FILE (ASSIGNED AUTOMATICALLY BY PROGRAM)
C           3 - A SCRATCH FILE TO HOLD THE USER ACTUAL INPUT CARDS
C           4 - USED ONLY IF READFILE IS USED TO READ AN OLD FILE
C
C     LINK THIS MAIN PROGRAM WITH THE FOLLOWING ROUTINES -
C     (THE EXECUTABLE IS CALLED LINKFF)
C
C           FF,FFHELP,FFREAD,UPCASE
C           INT2A8,A82INT,NA12IF,NA12A8,DUMMY
C
C     *** CDC ONLY - PROCEDURE TO LINK FF INTERACTIVELY
C           UPDATE,Q,P=EJPL,C=FF,L=0,N=0.
C           ? *C FF
C           ? <C/R>
C           REWIND,FF.
C           FTN5,STATIC,ARG=0,I=FF,L=0,B=FFLGO,LO=R/A/M/S.
C           ATTACH,NASTLIB/PN=DISC#.
C           LIBRARY,NASTLIB,FTN5LIB,BAMLIB.
C           REWIND,*.
C           LDSET,LIB=NASTLIB,PRESET=ZERO.
C           LDR>? LOAD,FFLGO.
C           LDR>? NOGO,LINKFF.
C
C     *** VAX ONLY - TO LINK FF USING NASTRAN LIBRARY
C           LINK/EXE=LINKFF.EXE NASTRAN.LIB/LIBRARY/INCLUDE=FF
C
C     *** UNIVAC ONLY - TO LINK FF WITH RELOCATABLES IN OBJ FILE
C           @PREP    OBJ.
C           @MAP,IS  TPF$.MAP,NASTRAN.LINKFF
C           LIB      OBJ.
C           IN       FF
C           END
C
C     *** IBM ONLY - LINKAGE EDITOR INPUT CARDS
C           INCLUDE LIB(FF,FFHELP,FFREAD,UPCASE)
C           INCLUDE LIB(INT2A8,A82INT,NA12IF,NA12A8)
C           INCLUDE PRIVLIB(IQZDDN,QQDCBF,QQGETF)
C           ENTRY   FF
C           NAME    LINKFF(R)
C
C           (NOTE - PRIVLIB IS LOCALLY SUPPLIED
C                   SEE THE DESCRIPTIONS OF IZZDDN,QQDCBF,QQGETF BELOW)
C
C     *** UNIX ONLY - TO LINK @LINKFF
C           cd
C           f77 ./mis/ff.f ./lib/nastlib.a -o @LINKFF
C
      LOGICAL         STAR,     PCT,      NOTYET,   PUNCH,    UPFLAG
      INTEGER         SCREEN,   PROM,     FFFLAG,   FACSF,    NC(7),
     1                IBM,      UNIVAC,   CDC,      VAX,      PC,
     2                UNIX
      CHARACTER*1     FN(1),    BK1,      N1,       Y1,       X1,
     1                S1,       W1,       A1,       H1,       CARD1(5),
     2                FX,       MARKQ,    QMARK,    TMP,      RPRN,
     3                SPL(8),   DOT,      D1,       T1
      CHARACTER*2     CARD2,    REPL
      CHARACTER*3     NEW,      OLD,      ODNW
      CHARACTER*4     CARD(20), SAVE(20), BEGN,     HELP,     STOP,
     1                LIST,     BLANK,    END1,     END2,     END3,
     2                CANC1,    CANC2,    ALTER,    CARD4,    FN4,
     3                BBK(2),   KSMB(9)
      CHARACTER*6     FN6,      BEGN6,    HELP6,    STOP6,    CARD6,
     1                MTYPE(7), CNTLWD(3)
      CHARACTER*8     FNAME(4), MYFILE,   BLNK8,    SITE,     CNTRL,
     1                USE(2),   SYM(4),   TAPEO3,   TPF,      FOROO3,
     2                DORK,     KEEP,     SPILL
      CHARACTER*11    F
      CHARACTER*32    FN32
      COMMON /SYSTEM/ IBUF,     NOUT,     NOGO,     IN,       ISYS(15)
      COMMON /MACHIN/ MACH
      COMMON /XXREAD/ INFLAG,   INSAVE,   LOOP4,    IBMCDC
      COMMON /XECHOX/ FFFLAG,   IECHO(3), ISORT(5)
      COMMON /XREADX/ SCREEN,   LOOP,     KOUNT,    PROM,     NOTYET,
     1                STAR,     PCT,      ICONT(36)
      COMMON /QMARKQ/ MARKQ,    TMP(16),  SPILL,    SAVE
      COMMON /UPCASX/ UPFLAG,   UPID(3)
      EQUIVALENCE     (FN(1),FN4,FN6,FN32,FNAME(1)),(XXI,LLI),
     1                (CARD(1),CARD6,CARD1(1),CARD2,CARD4),
     2                (SPL(1),SPILL)
      DATA            BEGN,     HELP,     STOP,     BLANK,    BK1    /
     1                'BEGI',   'HELP',   'STOP',   '    ',   ' '    /
      DATA            BEGN6,    HELP6,    STOP6,    BLNK8,    KEEP   /
     1                'BEGIN ', 'HELP  ', 'STOP  ', '    ',   'KEEP' /
      DATA            END1,     END2,     END3,     N1,       ALTER  /
     1                'ENDD',   'END ',   'ENDA',   'N',      'LTER' /
      DATA            CANC1,    CANC2,    DORK,     LLI,      LLJ    /
     1                'CANC',   'EL  ',   'DELETE', 4H  I ,   4H  J  /
      DATA            CNTRL,    MYFILE,   NEW,      OLD,      Y1     /
     1                'CENTRAL','MIFYLE', 'NEW',    'OLD',    'Y'    /
      DATA            NC/ 12,   7,   28,  7,   28,  0,  28           /
      DATA            UNIVAC,   IBM, CDC, VAX, PC,      UNIX         /
     1                3,        2,   4,   5,   1,       7            /
      DATA            MTYPE                                          /
     1                'IBM PC', '  IBM',  'UNIVAC', '  CDC',  '  VAX',
     2                ' ***  ', '  UNIX'                             /
      DATA            TAPEO3,   TPF,      FOROO3,   F                /
     1                'TAPE3.', 'FF$$.',  'FT03.',  'FF       FF'    /
      DATA            S1,       A1,       BBK,                LIST   /
     1                'S',      'A',      '(BLA', 'NK) ',     'LIST' /
      DATA            W1,       H1,       FX,       RPRN,     ICNTL  /
     1                'O',      'H',      'X',      ')',      0      /
      DATA            DOT,      D1,       T1                         /
     1                '.',      'D',      'T'                        /
      DATA            CNTLWD,                       NCNTL,    REPL   /
     1                'CANCEL', 'PROMPT', 'LIST  ', 3,        'R:'   /
      DATA            KSMB  /   '+C0N',   '+C1N',   '+C2N',   '+C3N' ,
     1                '+C4N',   '+C5N',   '+C6N',   '+C7N',   '+C8N' /
      DATA      USE / '@USE 3.,', 'FF$$ .  '/       PUNCH /   .FALSE./
      DATA      SYM / '@SYM    ', 'PUNCH$,,', '****', ' . '          /
      DATA            QMARK / '?' /
C     QMARK  IS QUESTION MARK -  0/12 PUNCH FOR 26 CODE
C                               0/7/8 PUNCH FOR 29 CODE
C
      J = LLJ - LLI
      MACH = IBM
      IF (J .EQ.   256) MACH = PC
      IF (J .EQ.   512) MACH = UNIVAC
      IF (J .GT. 65535) MACH = VAX
      IF (J .GT. 2**30) MACH = CDC
      IF (MACH.EQ.VAX .AND. (XXI.GT.1.60E-19 .OR. XXI.LT.1.8E-19))
     1    MACH = UNIX
      IF (MACH.EQ.VAX .AND. (XXI.GT.3.40E-20 .OR. XXI.LT.3.39E-20))
     1    MACH = PC
C
      LU      = 2
      LOUT    = 3
      IN      = 5
      NOUT    = 6
      IPUN    = 7
      SCREEN  = 6
      IF (MACH .EQ. VAX) SCREEN = 5
      LOOP    =-1
      KOUNT   = 0
      KONTN   = 10000000
      IKI     = 1
      PROM    =+1
      STAR    =.FALSE.
      PCT     =.FALSE.
      NOTYET  =.FALSE.
      MARKQ   = QMARK
      IECHO(2)=-2
      INSAVE  = IN
      INFLAG  = 0
      FFFLAG  = 0
      UPFLAG  =.FALSE.
      ISYS(15)= 0
      J       = NC(MACH)
      CARD4   = BLANK
      CARD6   = STOP6
      FN4     = STOP
      FN6     = STOP6
      LOOP4   = LOOP - 4
      DO 5 I = 1,20
 5    SAVE(I) = BLANK
      IBMCDC = UNIVAC + VAX + PC
      IF (MACH.EQ.IBM .OR. MACH.EQ.CDC) IBMCDC = 0
C
C     IF MACHINE IS CDC, OPEN INPUT, OUTPUT, AND PUNCH FILES
C
      IF (MACH .NE. CDC) GO TO 20
      OPEN (UNIT=IN  ,FILE='INPUT' ,STATUS='UNKNOWN')
      OPEN (UNIT=NOUT,FILE='OUTPUT',STATUS='UNKNOWN')
      OPEN (UNIT=IPUN,FILE='PUNCH' ,STATUS='UNKNOWN')
      OPEN (UNIT=LOUT,FILE='TAPE3' ,STATUS='UNKNOWN',ERR=15)
      GO TO 20
C
 15   STOP 'SCRATCH FILE ERROR, UNIT 3'
C
 20   WRITE  (NOUT,25) (F,I=1,7),MTYPE(MACH),(F,I=1,4)
 25   FORMAT (/////15X,A11, /14X,A11, 3(/13X,A11), /8X,2(3X,'FFFFFF'),
     1       2(/13X,A11),7X,A6,' VERSION / APRIL 93', /13X,A11,
     2       /12X,A11,10X,'COSMIC, (706) 542-3265', /11X,A11,11X,
     3       'UNIVERSITY OF  GEORGIA', /10X,A11,12X,'ATHENS, GEORGIA',
     4       '  30602')
 30   WRITE  (NOUT,35) J
 35   FORMAT (//,' *** ENTER A BLANK, ''HELP'', OR A FILE NAME (UP TO'
     1,       I3,' CHARACTERS)', /5X,'IF OUTPUT IS TO BE SAVED')
      READ (IN,40,ERR=330,END=330) FNAME
 40   FORMAT (4A8)
      IF (FNAME(1) .EQ. MYFILE) CALL FFHELP (*30,*600,4)
      IF (FNAME(1) .EQ. BLNK8) FNAME(1) = MYFILE
      IF (FN(J+1).NE.BK1 .OR. FN(J+2).NE.BK1 .OR. FN(J+3).NE.BK1)
     1   GO TO 330
      IF (FNAME(2) .NE. BLNK8) GO TO 50
      CALL UPCASE (FNAME,J)
      IF (FN6 .EQ. BEGN6) GO TO 330
      IF (FN6 .EQ. STOP6) GO TO 600
      IF (FN6 .EQ. HELP6) CALL FFHELP (*30,*600,1)
 50   ODNW = OLD
      IF (MACH .NE. VAX) GO TO 60
      DO 52 I = 2,J
      IF (FN(I) .EQ. DOT) GO TO 60
      IF (FN(I) .EQ. BK1) GO TO 55
 52   CONTINUE
      I = J + 1
 55   FN(I  ) = DOT
      FN(I+1) = D1
      FN(I+2) = A1
      FN(I+3) = T1
 60   IF (MACH .NE. IBM) GO TO 65
C
C     IBM ONLY, WE CALL SYSTEM ROUTINES
C         IQZDDN TO DETERMINE WHETHER FILES EXIST OR NOT
C         QQDCBF TO DYNAMICALLY BUILD AN ATTRIBUTE LIST BY DDNAME
C         QQGETF TO DYNAMICALLY ALLOCATE FILES IN TSO OR BATCH
C
      I = IQZDDN(FNAME(1))
      ODNW = OLD
      IF (I .EQ. 0) ODNW = NEW
      IF (ODNW .EQ. NEW) CALL QQDCBF (FNAME(1),0,'F  ',80,80,DA)
      CALL QQGETF (LU,FNAME(1),IERR)
      IF (IERR .NE. 0) GO TO 130
C
 65   IF (IBMCDC.EQ.0) OPEN (UNIT=LU,FILE=FNAME(1),STATUS=ODNW,ERR=130)
      IF (IBMCDC.NE.0) OPEN (UNIT=LU,FILE=FN32    ,STATUS=ODNW,ERR=130)
      IF (ODNW .EQ. NEW) GO TO 140
 70   WRITE  (NOUT,80)
 80   FORMAT (/,' FILE ALREADY EXISTS, ENTER ''STOP'', ''OVERWRITE'',',
     1        ' OR ''APPEND'' -')
      IF (MACH.EQ.CDC .AND. IN.EQ.5) REWIND IN
      READ (IN,90,END=70) X1
 90   FORMAT (A1)
      CALL UPCASE (X1,1)
      IF (X1 .EQ. S1) GO TO 480
      IF (X1 .EQ. W1) GO TO 140
      IF (X1 .NE. A1) GO TO 70
      SAVE(2) = BBK(1)
      SAVE(3) = BBK(2)
 110  READ (LU,180,END=115) SAVE
      IF (SAVE(1).EQ.BEGN .AND. SAVE(4).EQ.BLANK) FFFLAG = 1234
      IF (SAVE(19) .EQ. KSMB(IKI)) IKI = IKI + 1
      GO TO 110
 115  BACKSPACE LU
      IF (FFFLAG .EQ. 1234) WRITE (NOUT,120)
 120  FORMAT (/,' IF EXISTING FILE CONTAINS FREE-FIELD INPUT CARDS, ',
     1        ' THIS PROGRAM WILL NOT', /5X,'EXPAND THEM TO FIXED-',
     2        ' FIELD FORMATS',/)
      WRITE (NOUT,255) SAVE
      IF (FFFLAG.EQ.1234 .AND. INFLAG.EQ.0) CALL FFHELP (*125,*125,5)
 125  CARD(1) = SAVE(1)
      CARD(2) = SAVE(2)
      GO TO 140
 130  IF (ODNW .EQ. NEW) GO TO 310
      ODNW = NEW
      GO TO 60
 140  IF (MACH .EQ. UNIVAC) J = FACSF(USE)
      IF (FNAME(1) .EQ. MYFILE) FNAME(1) = BLNK8
      IF (FNAME(1) .EQ.  BLNK8) WRITE (NOUT,150)
 150  FORMAT (/5X,'*** OUTPUT NOT SAVED ***',//)
      WRITE  (NOUT,160)
 160  FORMAT (//,' *** NASTRAN FREE-FIELD INPUT PROGRAM ***',
     1 /5X,'(THERE WILL BE NO INPUT ECHO UNTIL ''BEGIN BULK'' IS TYPED',
     2 /5X,' TO TERMINATE JOB:  ENTER ''ENDDATA'' OR ''STOP'')',
     3 //5X,'PLEASE BEGIN -',/)
 170  CALL FFREAD (*320,CARD)
      IF (CARD4.EQ.CANC1 .AND. CARD(2).EQ.CANC2) GO TO 230
      IF (CARD4.EQ. LIST .AND. CARD(2).EQ.BLANK) GO TO 230
      IF (CARD2.EQ. REPL .AND. CARD(4).EQ.BLANK) GO TO 350
      IF (CARD4.EQ. STOP .AND. CARD(2).EQ.BLANK) GO TO 400
      IF (CARD4.EQ.BLANK .AND. CARD(2).EQ.BLANK) GO TO 370
      IF (CARD4.EQ. HELP .AND. CARD(2).EQ.BLANK)
     1   CALL FFHELP (*280,*400,2)
      IF (LU .EQ. 2) WRITE (LU,180) CARD
 180  FORMAT (20A4)
      IF (FFFLAG.NE.1234 .AND. INFLAG.EQ.4) WRITE (NOUT,190) CARD
 190  FORMAT (1X,20A4)
      IF (CARD4.EQ.BEGN .AND. CARD(5).EQ.BLANK) GO TO 340
      IF (CARD4.NE.END1 .AND. CARD4.NE.END2 .AND. CARD4.NE.END3)
     1   GO TO 170
      IF (CARD(2).EQ.BLANK .OR. CARD(2).EQ.ALTER) GO TO 170
      GO TO 410
 230  IF (LU .NE. 2) GO TO 290
      J = 1
      IF (CARD(5).EQ.CANC1 .AND. ICONT(1).GT.0) J = ICONT(1) + 1
      IF (CARD(5).EQ. LIST .AND. ICONT(1).GT.0) J = ICONT(1)
      DO 240 I = 1,J
 240  BACKSPACE LU
      ICONT(1) = 0
      IF (CARD(5) .EQ. LIST) GO TO 260
      READ (LU,180) SAVE
      J = J - 1
      WRITE  (NOUT,250) J
 250  FORMAT (1X,I4,' PREVIOUSLY GENERATED CARDS CANCELLED ***')
      IF (J .GT. 0) WRITE (NOUT,255) SAVE
 255  FORMAT (/,' *** LAST CARD WAS:', /1X,20A4)
      GO TO 280
 260  WRITE  (NOUT,265) J
 265  FORMAT (//,' *** PREVIOUS',I4,' CARDS WERE (COLS. 1-79) -',/)
      DO 270 I = 1,J
      READ (LU,180,END=285) SAVE
 270  WRITE  (NOUT,275) SAVE
 275  FORMAT (1X,20A4)
 280  CARD(1) = SAVE(1)
      CARD(2) = SAVE(2)
      GO TO 170
 285  BACKSPACE LU
      SAVE(1) = CARD(1)
      SAVE(2) = CARD(2)
      GO TO 170
 290  WRITE  (NOUT,300) CARD4,CARD(2)
 300  FORMAT (' *** ',A4,A3,'OPTION NOT ACTIVE.  NO SAVE FILE ',
     1        'REQUESTED')
      GO TO 170
 310  WRITE  (NOUT,315) FNAME
 315  FORMAT (' *** CAN NOT ASSIGN FILE - ',4A8)
      GO TO 20
 320  WRITE  (NOUT,325)
 325  FORMAT (' *INPUT ERROR/FF*')
      GO TO 170
 330  WRITE  (NOUT,335)
 335  FORMAT (' *NOT A VALID FILE NAME*')
      IF (MACH.EQ.CDC .AND. IN.EQ.5) REWIND IN
      GO TO 20
 340  FFFLAG = 1234
      IF (INFLAG .EQ. 0) CALL FFHELP (*170,*170,5)
      GO TO 170
C
C ... EDIT PREVIOUS LINE BY R:n)xxx
C
 350  I = 3
      IF (CARD1(5) .EQ. RPRN) I = 4
      READ (CARD1(I),355,ERR=170) II
 355  FORMAT (I1)
      IF (II .EQ. 0) II = 10
      I = I + 2
      DO 360 J = 1,8
      SPL(J) = CARD1(I)
 360  I = I + 1
      SAVE(II) = SPILL
      DO 365 I = 1,10
 365  CARD(I) = SAVE(I)
      BACKSPACE LU
      WRITE (LU,  180) SAVE
      WRITE (NOUT,190) SAVE
      GO TO 170
C
C ... FIRST 2 FIELDS ARE BLANK, OTHER FIELDS NOT, TREAT IT AS A
C     CONTINUATION CARD IF PREVIOUS CARD HAS A BLANK CONTINUATION FIELD
C
 370  IF (LU .NE. 2) GO TO 385
      DO 375 J = 3,18
      IF (CARD(J) .NE. BLANK) GO TO 380
 375  CONTINUE
      GO TO 170
 380  BACKSPACE LU
      READ (LU,180) SAVE
      IF (SAVE(19) .EQ. BLANK) GO TO 390
      WRITE  (NOUT,382)
 382  FORMAT (/,' BAD INPUT - FIRST FIELD BLANK. TRY AGAIN')
      WRITE  (NOUT,383)
 383  FORMAT (13X,'NOT ALLOW. PREVIOUS CARD HAS CONTINUATION FIELD ',
     1        'DEFINED')
      GO TO 170
 385  WRITE  (NOUT,382)
      WRITE  (NOUT,387)
 387  FORMAT (13X,'NOT ALLOW WITHOUT SAVE FILE')
      GO TO 170
 390  KONTN = KONTN + 1
      IF (MOD(KONTN,10000) .EQ. 0) IKI = IKI + 1
      CALL INT2K8 (*385,KONTN,SAVE(19))
      SAVE(19) = KSMB(IKI)
      CARD(1 ) = KSMB(IKI)
      CARD(2 ) = SAVE(20)
      WRITE  (NOUT,395)
 395  FORMAT (' ...PREVIOUS CARDS REPLACED BY:')
      WRITE (NOUT,190) SAVE
      WRITE (NOUT,190) CARD
      BACKSPACE LU
      WRITE (LU,180) SAVE
      WRITE (LU,180) CARD
      GO TO 170
C
 400  BACKSPACE LOUT
 410  ENDFILE LOUT
      IF (LU .NE. 6) ENDFILE LU
      PUNCH =.FALSE.
      SITE  = BLNK8
 420  WRITE  (NOUT,430) QMARK
 430  FORMAT (/,' *** DO YOU WANT TO PUNCH OUT THE NASTRAN DECK',A1,
     1       ' (Y,N,X,HELP) ')
      IF (MACH.EQ.CDC .AND. IN.EQ.5) REWIND IN
      READ (IN,90,END=420) X1
      CALL UPCASE (X1,1)
      IF (X1 .EQ. H1) CALL FFHELP (*420,*480,3)
      IF (X1 .EQ. N1) GO TO 500
      IF (X1.NE.Y1 .AND. X1.NE.FX) GO TO 420
      PUNCH =.TRUE.
      LX = LOUT
      IF (X1 .EQ. FX) LX = LU
      IF (MACH .NE. UNIVAC) GO TO 460
      IPUN = 1
      WRITE  (NOUT,440)
 440  FORMAT (/,' *** ENTER SITE-ID, OR ''CENTRAL'', WHERE CARDS ARE',
     1       ' TO BE PUNCHED ')
 450  READ (IN,40,ERR=450,END=450) SITE
      IF (SITE .EQ. BLNK8) GO TO 490
      CALL UPCASE (SITE,8)
      IF (SITE .EQ. CNTRL) GO TO 460
C
C     SEND PUNCH DECK TO SITE AS REQUESTED BY THE USER - UNIVAC ONLY
C-UNV FACSF IS UNIVAC SYSTEM FUNCTION
C
      SYM(3) = SITE
      J = FACSF(SYM)
 460  REWIND LX
 470  READ (LX,180,END=500) CARD
      DO 475 J = 2,NCNTL
      IF (CARD6 .NE. CNTLWD(J)) GO TO 475
      IF (CARD(4) .EQ. BLANK) GO TO 470
 475  CONTINUE
      IF ((CARD6.EQ.HELP6 .OR. CARD6.EQ.STOP6) .AND. CARD(3).EQ.BLANK)
     1   GO TO 470
      IF (CARD6.EQ.CNTLWD(1) .AND. CARD(4).EQ.BLANK) ICNTL = ICNTL + 1
      WRITE (IPUN,180) CARD
      GO TO 470
C
 480  FNAME(1) = BLNK8
 490  PUNCH    =.FALSE.
 500  WRITE  (NOUT,510)
 510  FORMAT (//10X,'ADIEU MY FRIEND.  IT IS A PLEASURE TO SERVE YOU')
      IF (FNAME(1) .NE. BLNK8) WRITE (NOUT,520) FNAME
 520  FORMAT (10X,'DON''T FORGET - YOUR NASTRAN DECK IS IN FILE -',
     1    /25X,4A8, /10X,'WHICH IS ACCESSIBLE BY THE SYSTEM EDITOR')
      IF (.NOT.PUNCH) GO TO 550
      WRITE  (NOUT,530)
 530  FORMAT (/10X,'AND DON''T FORGET TO PICK UP YOUR PUNCHED CARDS')
      IF (SITE .NE. BLNK8) WRITE (NOUT,535) SITE
      IF (SITE.EQ.BLNK8 .AND. MACH.NE.VAX) WRITE (NOUT,540)
      IF (SITE.EQ.BLNK8 .AND. MACH.EQ.VAX) WRITE (NOUT,545)
 535  FORMAT (10X,'WHEN YOU SIGN OFF',22X,'SITE-ID: ',A8)
 540  FORMAT (10X,'AT THE CENTRAL-SITE')
 545  FORMAT (10X,'IN FORTRAN FILE FOR007.DAT')
 550  IF (FNAME(1) .EQ. BLNK8) GO TO 570
      IF (MACH .EQ. UNIVAC) FOROO3 = TPF
      IF (MACH .EQ.    CDC) FOROO3 = TAPEO3
      WRITE  (NOUT,555)
 555  FORMAT (//10X,'A COPY OF YOUR ACTUAL INPUT CARDS WAS SAVED IN')
      IF (MACH .NE. VAX) WRITE (NOUT,560) FOROO3
      IF (MACH .EQ. VAX) WRITE (NOUT,565)
 560  FORMAT (1H+,56X,'FORTRAN FILE - ',A8)
 565  FORMAT (10X,'FORTRAN FILE FOR003.DAT')
 570  IF (ICNTL .NE. 0) WRITE (NOUT,575)
 575  FORMAT (/4X,'*** WARNING - CANCELLED CARDS IN PUNCHED DECK NEED ',
     1       'TO BE REMOVED', /19X,'OR MODIFIED BEFORE USE')
      IF (FNAME(1) .NE. BLNK8) DORK = KEEP
      CLOSE (UNIT=LU  ,STATUS=DORK)
      CLOSE (UNIT=LOUT,STATUS=DORK)
      IF (DORK.EQ.KEEP .OR. (PUNCH .AND. MACH.EQ.VAX)) WRITE (NOUT,585)
 585  FORMAT (/4X,'*** DON''T FORGET TO DELETE YOUR FILES GENERATED BY',
     1       ' THIS RUN ***')
      WRITE  (NOUT,590)
 590  FORMAT (/26X,'*** JOB DONE ***',/)
 600  CONTINUE
      END

      SUBROUTINE MRGE (LIST, N, STRING, M)
C*****
C MRGE IS A MERGE ROUTINE. GIVEN A SORTED LIST AND A SORTED STRING,
C MRGE ADDS THE ENTRIES IN THE STRING TO THE LIST IN THEIR APPROPRIATE
C POSITIONS.  DUPLICATES ARE DISCARDED.
C
C  ARGUMENTS
C
C     LIST   --- THE ARRAY CONTAINING THE SORTED LIST
C     N      --- THE NUMBER OF TERMS BEFORE AND AFTER THE MERGE
C     STRING --- THE ARRAY CONTAINING THE SORTED STRING
C     M      --- THE NUMBER OF TERMS IN THE STRING
C
C*****
      INTEGER LIST(1), STRING(1)
C
C LOCATE THE POSITION IN THE LIST OF THE FIRST TERM IN THE STRING
C
      KK = 1
      ID = STRING(KK)
      CALL BISLOC (*12, ID, LIST, 1, N, K)
      KSTART = MIN0( K+1, N )
      K2 = 2
      GO TO 13
   12 KSTART = MAX0( 1, K-1 )
      K2 = 1
C
C CREATE A HOLE IN THE LIST BY MOVING THE END OF THE LIST.
C
   13 K = N
   14 LIST(K+M) = LIST(K)
      K = K - 1
      IF( K .GE. KSTART ) GO TO 14
      K1 = KSTART + M
      NM = N + M
      K = KSTART
C
C NOW ADD TO THE LIST BY MERGING FROM THE TWO STRINGS
C
   16 IF( K1 .GT. NM ) GO TO 60
      IF( K2 .GT. M  ) GO TO 50
      IF (LIST(K1) - STRING(K2)) 20, 40, 30
C
C    CHOOSE TERM FROM OLD LIST
C
   20 LIST(K) = LIST(K1)
      K1 = K1 + 1
      K  = K  + 1
      GO TO 16
C
C    CHOOSE TERM FROM STRING
C
   30 LIST(K) = STRING(K2)
      K2 = K2 + 1
      K  = K  + 1
      GO TO 16
C
C    DUPLICATES -- DISCARD TERM FROM STRING
C
   40 K2 = K2 + 1
      GO TO 20
C
C    STRING EXHAUSTED -- COMPLETE LIST FROM OLD LIST
C
   50 DO 52 KX=K1,NM
      LIST(K) = LIST(KX)
      K = K + 1
   52 CONTINUE
      GO TO 68
C
C    OLD LIST EXHAUSTED -- COMPLETE LIST FROM STRING
C
   60 IF( K2 .GT. M ) GO TO 68
      DO 62 KX=K2,M
      LIST(K) = STRING(KX)
      K = K + 1
   62 CONTINUE
C
C RETURN NEW NUMBER OF TERMS IN LIST.
C
   68 N = K - 1
      RETURN
      END

      SUBROUTINE IHEXSS (TYPE,SHP,DSHP,JACOB,DETJ,EID,XI,ETA,ZETA,BXYZ)
C
C     SINGLE PRECISION VERSION
C
C     ISOPARAMETRIC UTILITY ROUTINE.  THIS ROUTINE WILL COMPUTE
C     VALUES OF THE SHAPE FUNCTIONS, THEIR DERIVATIVES WITH RESPECT TO
C     XI,ETA, AND ZETA, THE JACOBIAN MATRIX INVERSE, AND ITS DETERMINANT
C
C                       TYPE = 1       IHEX1
C                       TYPE = 2       IHEX2
C                       TYPE = 3       IHEX3
C
C     SHP    = VALUES OF SHAPE FUNCTIONS
C     DSHP   = DERIVATIVES OF SHAPE FUNCTIONS W.R.T. XI, ETA, ZETA
C     JACOB  = JACOBIAN MATRIX INVERSE
C     DETJ   = DETERMINANT OF JACOBIAN MATRIX
C     XI, ETA, ZETA = ELEMENT COORDINATES AT WHICH THESE COMPUTATIONS
C                     TAKE PLACE
C     BXYZ   = BASIC SYSTEM COORDINATES FOR GRID POINTS
C
C     LOCAL VARIABLES
C     X,Y,Z  = CONSTANTS FOR EACH SHAPE FUNCTION
C     NGP    = NUMBER OF SHAPE FUNCTIONS, ALSO NUMBER OF GRID POINTS
C
      INTEGER         TYPE       ,EID        ,OP
      REAL            BXYZ(3,8)  ,SHP(8)     ,DSHP(3,8)  ,JACOB(3,3) ,
     1                WORK(3,3)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /SYSTEM/ SYSBUF     ,OP
C
      NGP = 12*TYPE - 4
      Y   =-1.0
      Z   =-1.0
      GO TO (100,200,310), TYPE
C
C     LINEAR ELEMENT IHEX1
C
  100 DO 110 J = 1,2
      IF (J .EQ. 2) Z = 1.0
      X = -1.0
      Y = -1.0
      DO 110 I = 1,4
      IF (I .EQ. 3) Y = 1.0
      IF (I .EQ. 2) X = 1.0
      IF (I .EQ. 4) X =-1.0
      K    = I + (J-1)*4
      QXI  = 1.0 + XI*X
      QETA = 1.0 + ETA*Y
      QZETA= 1.0 + ZETA*Z
      SHP(K) = QXI*QETA*QZETA/8.0
      DSHP(1,K) = X*QETA*QZETA/8.0
      DSHP(2,K) = Y*QXI*QZETA/8.0
      DSHP(3,K) = Z*QXI*QETA/8.0
  110 CONTINUE
      GO TO 430
C
C     QUADRATIC ELEMENT IHEX2
C
  200 D = 1.0
      X = 0.0
      DO 300 I = 1,20
C            1   2   3   4   5   6   7   8   9   10
      GO TO (220,210,210,230,230,220,220,240,250,210,
     1       230,220,250,210,210,230,230,220,220,240), I
  210 X = X+D
      GO TO 260
  220 X = X - D
      GO TO 260
  230 Y = Y + D
      GO TO 260
  240 Y = Y - D
      GO TO 260
  250 Z = Z + 1.0
      Y =-1.0
      D = 3.0-D
  260 IF (X .EQ. 0.0) GO TO 270
      IF (Y .EQ. 0.0) GO TO 280
      IF (Z .EQ. 0.0) GO TO 290
C
C     CORNER POINT
C
      QXI   = 1.0 + X*XI
      QETA  = 1.0 + Y*ETA
      QZETA = 1.0 + Z*ZETA
      QXYZ  = X*XI + Y*ETA+Z*ZETA
      SHP(I)= QXI*QETA*QZETA*(QXYZ-2.0)/8.0
      DSHP(1,I) = X*QETA*QZETA*(X*XI+QXYZ-1.0)/8.0
      DSHP(2,I) = Y*QXI*QZETA*(Y*ETA+QXYZ-1.0)/8.0
      DSHP(3,I) = Z*QXI*QETA*(Z*ZETA+QXYZ-1.0)/8.0
      GO TO 300
C
C     MID-EDGE POINT, X = 0.0
C
  270 QXI   = 1.0 - XI**2
      QETA  = 1.0 + Y*ETA
      QZETA = 1.0 + Z*ZETA
      SHP(I)= QXI*QETA*QZETA/4.0
      DSHP(1,I) =-XI*QETA*QZETA/2.0
      DSHP(2,I) = QXI*QZETA*Y/4.0
      DSHP(3,I) = QXI*QETA*Z/4.0
      GO TO 300
C
C     MID-EDGE POINT, Y = 0.0
C
  280 QXI   = 1.0 + X*XI
      QETA  = 1.0 - ETA**2
      QZETA = 1.0 + Z*ZETA
      SHP(I)= QETA*QXI*QZETA/4.0
      DSHP(1,I) = QETA*QZETA*X/4.0
      DSHP(2,I) =-ETA*QZETA*QXI/2.0
      DSHP(3,I) = QETA*QXI*Z/4.0
      GO TO 300
C
C     MID-EDGE POINT, Z = 0.0
C
  290 QXI   = 1.0 + X*XI
      QETA  = 1.0 + Y*ETA
      QZETA = 1.0 - ZETA**2
      SHP(I)= QZETA*QXI*QETA/4.0
      DSHP(1,I) = QZETA*QETA*X/4.0
      DSHP(2,I) = QZETA*QXI*Y/4.0
      DSHP(3,I) =-ZETA*QXI*QETA/2.0
  300 CONTINUE
      GO TO 430
C
C     CUBIC ELEMENT IHEX3
C
  310 D = 2.0/3.0
      X =-1.0/3.0
      DO 420 I = 1,32
C            1   2   3   4   5   6   7   8   9   10
      GO TO (320,330,330,330,340,340,340,320,320,320,
     1       350,350,360,330,340,320,360,330,340,320,
     2       360,330,330,330,340,340,340,320,320,320,
     3       350,350), I
  320 X = X - D
      GO TO 370
  330 X = X + D
      GO TO 370
  340 Y = Y + D
      GO TO 370
  350 Y = Y - D
      GO TO 370
  360 Y =-1.0
      Z = Z + 2.0/3.0
      IF (Z .GT. -1.0) D = 2.0
      IF (Z .GT.  0.4) D = 2.0/3.0
  370 IF (ABS(X) .LT. 0.4) GO TO 390
      IF (ABS(Y) .LT. 0.4) GO TO 400
      IF (ABS(Z) .LT. 0.4) GO TO 410
C
C     CORNER POINT
C
      QXI   = 1.0 + X*XI
      QETA  = 1.0 + Y*ETA
      QZETA = 1.0 + Z*ZETA
      QXYZ  = XI**2 + ETA**2 + ZETA**2 - 19.0/9.0
      SHP(I)= 9.0*QXI*QETA*QZETA*QXYZ/64.0
      DSHP(1,I) = 9.0*QETA*QZETA*(X*(2.0*XI**2+QXYZ)+2.0*XI)/64.0
      DSHP(2,I) = 9.0*QXI*QZETA*(Y*(2.0*ETA**2+QXYZ)+2.0*ETA)/64.0
      DSHP(3,I) = 9.0*QXI*QETA*(Z*(2.0*ZETA**2+QXYZ)+2.0*ZETA)/64.0
      GO TO 420
C
C     MID-EDGE POINT, X = + OR - 1/3
C
  390 QXI   = 9.0*(1.0-XI**2)*(1.0+9.0*X*XI)/64.0
      QETA  = 1.0 + Y*ETA
      QZETA = 1.0 + Z*ZETA
      QXYZ  = 9.0*(-2.0*XI+9.0*X-27.0*XI*X*XI)/64.0
      SHP(I)= QXI*QETA*QZETA
      DSHP(1,I) = QETA*QZETA*QXYZ
      DSHP(2,I) = QXI*QZETA*Y
      DSHP(3,I) = QXI*QETA*Z
      GO TO 420
C
C     MID-EDGE POINT Y =+ OR - 1/3
C
  400 QXI   = 1.0 + X*XI
      QETA  = 9.0*(1.0-ETA**2)*(1.0+9.0*ETA*Y)/64.0
      QZETA = 1.0 + Z*ZETA
      QXYZ  = 9.0*(-2.0*ETA+9.0*Y-27.0*ETA*Y*ETA)/64.0
      SHP(I)= QETA*QXI*QZETA
      DSHP(1,I) = QETA*QZETA*X
      DSHP(2,I) = QXI*QZETA*QXYZ
      DSHP(3,I) = QETA*QXI*Z
      GO TO 420
C
C     MID-EDGE POINTS Z =+ OR - 1/3
C
  410 QXI   = 1.0 + X*XI
      QETA  = 1.0 + Y*ETA
      QZETA = 9.0*(1.0-ZETA**2)*(1.0+9.0*Z*ZETA)/64.0
      QXYZ  = 9.0*(-2.0*ZETA+9.0*Z-27.0*Z*ZETA**2)/64.0
      SHP(I)= QZETA*QXI*QETA
      DSHP(1,I) = QZETA*QETA*X
      DSHP(2,I) = QZETA*QXI*Y
      DSHP(3,I) = QXI*QETA*QXYZ
  420 CONTINUE
C
C     COMPUTE JACOBIAN MATRIX
C
  430 DO 440 I = 1,3
      DO 440 J = 1,3
      JACOB(I,J) = 0.0
      DO 440 K = 1,NGP
      JACOB(I,J) = JACOB(I,J)+DSHP(I,K)*BXYZ(J,K)
  440 CONTINUE
C
C     COMPUTE INVERSE AND DETERMINANT OF JACOBIAN MATRIX
C
      WORK(1,1) = JACOB(2,2)*JACOB(3,3) - JACOB(2,3)*JACOB(3,2)
      WORK(2,1) = JACOB(2,3)*JACOB(3,1) - JACOB(2,1)*JACOB(3,3)
      WORK(3,1) = JACOB(2,1)*JACOB(3,2) - JACOB(2,2)*JACOB(3,1)
      WORK(1,2) = JACOB(1,3)*JACOB(3,2) - JACOB(1,2)*JACOB(3,3)
      WORK(2,2) = JACOB(1,1)*JACOB(3,3) - JACOB(1,3)*JACOB(3,1)
      WORK(3,2) = JACOB(1,2)*JACOB(3,1) - JACOB(1,1)*JACOB(3,2)
      WORK(1,3) = JACOB(1,2)*JACOB(2,3) - JACOB(1,3)*JACOB(2,2)
      WORK(2,3) = JACOB(1,3)*JACOB(2,1) - JACOB(1,1)*JACOB(2,3)
      WORK(3,3) = JACOB(1,1)*JACOB(2,2) - JACOB(1,2)*JACOB(2,1)
      DETJ = 0.0
      DO 450 I = 1,3
      DETJ = DETJ + JACOB(I,2)*WORK(2,I)
  450 CONTINUE
      IF (DETJ .EQ. 0.0) GO TO 470
      DO 460 I = 1,3
      DO 460 J = 1,3
      JACOB(I,J) = WORK(I,J)/DETJ
  460 CONTINUE
      RETURN
C
C     JACOBIAN MATRIX WAS SINGULAR.
C
  470 WRITE  (OP,480) UFM,EID
  480 FORMAT (A23,' 3306, SINGULAR JACOBIAN MATRIX FOR ISOPARAMETRIC ',
     1       'ELEMENT NO.',I9)
      RETURN
      END

      SUBROUTINE MPY3B (Z,IZ,DZ)
C*****
C    PROCESSES A AND PERFORMS FIRST PART OF PRODUCT.
C*****
      DOUBLE PRECISION DZ(1),DA
C
C
C
      INTEGER FILEA,SCR1,SCR2,FILE
      INTEGER PREC,PRECN
      INTEGER ZPNTRS
      INTEGER UTYP,UROW1,UROWN,UINCR
      INTEGER EOL,EOR
      INTEGER PRECK
C
C
C
      LOGICAL FIRST1,FIRST2
C
C
C
      DIMENSION Z(1),IZ(1)
      DIMENSION NAME(2)
C
C
C FILES
      COMMON / MPY3TL / FILEA(7),FILEB(7),FILEE(7),FILEC(7),SCR1,SCR2,
     1                  SCR,LKORE,CODE,PREC,LCORE,SCR3(7),BUF1,BUF2,
     2                  BUF3,BUF4,E
C SUBROUTINE CALL PARAMETERS
      COMMON / MPY3CP / ITRL,ICORE,N,NCB,M,NK,DUMCP(2),ZPNTRS(22),LAEND,
     1                  FIRST1,FIRST2,K,K2,KCOUNT,IFLAG,KA,KB,J,I,NTBU
C UNPACK
      COMMON / UNPAKX / UTYP,UROW1,UROWN,UINCR
C TERMWISE MATRIX READ
      COMMON / ZNTPKX / A(2),DUM(2),IROW,EOL,EOR
C
C
C
      EQUIVALENCE     (A(1),DA)
C OPEN CORE POINTERS
      EQUIVALENCE     (IBCOLS,ZPNTRS(11)),     (IBCID,ZPNTRS(13)),
     *                (IBNTU,ZPNTRS(15)),      (IKTBP,ZPNTRS(17)),
     *                (IAKJ,ZPNTRS(21))
C
C
C
      DATA NAME / 4HMPY3,4HB    /
C*****
C    INITIALIZATION.
C*****
      FILE = SCR1
      UTYP = PREC
      UROW1 = 1
      UROWN = N
      UINCR = 1
      PRECN = PREC*N
C*****
C    READ AND STORE COLUMN OF A.
C*****
      K = 0
      KT = IKTBP - 1
      IF (PREC .EQ. 2) GO TO 20
C SINGLE PRECISION CASE
      KJ = IAKJ - 1
      CALL INTPK(*120,FILEA,0,1,0)
   10 CALL ZNTPKI
      K = K + 1
      KT = KT + 1
      IZ(KT) = IROW
      KJ = KJ + 1
      Z(KJ) = A(1)
      IF (EOL .EQ. 1) GO TO 30
      GO TO 10
C DOUBLE PRECISION CASE
   20 KJ = (IAKJ - 1)/2
      CALL INTPK(*120,FILEA,0,2,0)
   25 CALL ZNTPKI
      K = K + 1
      KT = KT + 1
      IZ(KT) = IROW
      KJ = KJ + 1
      DZ(KJ) = DA
      IF (EOL .EQ. 1) GO TO 30
      GO TO 25
   30 IF (.NOT. FIRST1) GO TO 80
C*****
C    READ COLUMNS OF B INTO CORE.
C*****
      FIRST1 = .FALSE.
      IF (K .GT. NK) GO TO 40
      K2 = K
      GO TO 50
   40 K2 = NK
   50 KT = IKTBP - 1
      KB = IBCOLS - PRECN
      KBC = IBCID - 1
      DO 60 KK=1,K2
      KT = KT + 1
      KKK = IZ(KT)
      CALL FILPOS (SCR1,IZ(KKK))
      KB = KB + PRECN
      CALL UNPACK(*55,SCR1,Z(KB))
      GO TO 59
   55 IB = KB - 1
      DO 57 L=1,PRECN
      IB = IB + 1
   57 Z(IB) = 0.
   59 CONTINUE
      KBC = KBC + 1
      IZ(KBC) = KKK
   60 CONTINUE
C*****
C    BEGIN CALCULATING MATRIX PRODUCT.
C*****
   80 KT = IKTBP - 1
      KCOUNT = 0
      PRECK = PREC*K
      DO 110 KA=1,K
      KT = KT + 1
      KBC = IBCID - 1
      DO 90 KB=1,K2
      KBC = KBC + 1
      IF (IZ(KT) .EQ. IZ(KBC)) GO TO 100
   90 CONTINUE
      GO TO 110
  100 KKB = KB
      CALL MPY3P (Z,Z,Z)
      IZ(KT) = 0
      KCOUNT = KCOUNT + 1
      IF (FIRST2 .OR. ICORE .EQ. 1) GO TO 110
      I = IZ(KBC)
      CALL MPY3NU (Z)
      KBN = IBNTU + KKB - 1
      IZ(KBN) = NTBU
  110 CONTINUE
C*****
C    SET RETURN FLAG.
C*****
      IF (KCOUNT .EQ. K) GO TO 120
      IFLAG = 1
      GO TO 9999
  120 IFLAG = 0
      IF (ICORE .NE. 1 .OR. FIRST2) GO TO 9999
      IF (J .EQ. M) GO TO 9999
      FILE = SCR2
      CALL FWDREC(*902,SCR2)
      GO TO 9999
C*****
C    ERROR MESSAGES.
C*****
  902 NERR = -2
      CALL MESAGE (NERR, FILE, NAME)
C
 9999 RETURN
      END

      SUBROUTINE TDATE (DATE)
C
C     VAX VERSION
C     ===========
C     (ALSO SiliconGraphics, DEC/ultrix, and SUN.
C      CRAY AND HP DO NOT HAVE IDATE)
C
C     THIS ROUTINE OBTAINS THE MONTH, DAY AND YEAR, IN INTEGER FORMAT
C
      INTEGER DATE(3), DATE1(3)
C
      CALL IDATE (DATE1)
C                 DAY   MONTH     YEAR
C     THESE DATES HAD TO BE INTERCHANGED FOR THE SUN
      DATE(1)=DATE1(2)
      DATE(2)=DATE1(1)
CWUT  BAD FIX
      DATE(3)=DATE1(3)-2000
      RETURN
      END

      SUBROUTINE DGREE (NDSTK,NDEG,IOLD,IBW1,IPF1,NU)
C
C     THIS ROUTINE IS USED ONLY IN BANDIT MODULE
C     DGREE COMPUTES THE DEGREE OF EACH NODE IN NDSTK AND STORES
C     IT IN THE ARRAY NDEG.  THE BANDWIDTH AND PROFILE FOR THE ORIGINAL
C     OR INPUT RENUMBERING OF THE GRAPH IS COMPUTED ALSO.
C
C     COMPUTE MAXIMUM DEGREE MM AND STORE IN IDEG.
C
C     INTEGER          BUNPK
      DIMENSION        NDSTK(1), NDEG(1),  IOLD(1),  NU(1)
      COMMON /BANDG /  N,        IDPTH,    IDEG
      COMMON /BANDS /  NN,       MM
C
      IBW1=0
      IPF1=0
      IDEG=MM
      MM=0
      DO 100 I=1,N
      NDEG(I)=0
      IRW=0
      CALL BUNPAK(NDSTK,I,IDEG,NU)
      DO 80 J=1,IDEG
      ITST=NU(J)
      IF (ITST) 90,90,50
   50 NDEG(I)=NDEG(I)+1
      IDIF=IOLD(I)-IOLD(ITST)
      IF (IRW.LT.IDIF) IRW=IDIF
      MM=MAX0(MM,J)
   80 CONTINUE
   90 IPF1=IPF1+IRW
      IF (IRW.GT.IBW1) IBW1=IRW
  100 CONTINUE
      IDEG=MM
C
C     INCLUDE DIAGONAL TERMS IN BANDWIDTH AND PROFILE
      IBW1=IBW1+1
      IPF1=IPF1+N
      RETURN
      END

      SUBROUTINE DELETE (NAME,ITEMX,ITEST)
C
C     DELETES ITEM WHICH BELONGS TO THE SUBSTRUCTURE NAME.  THE MDI IS
C     UPDATED ACCORDINGLY AND THE BLOCKS ON WHICH ITEM WAS WRITTEN ARE
C     RETURNED TO THE LIST OF FREE BLOCKS.  ITEST IS AN OUTPUT PARAMETER
C     WHICH TAKES ON ONE OF THE FOLLOWING VALUES
C
C              1  IF ITEM DOES EXIST
C              2  IF ITEM PSEUDO-EXISTS
C              3  IF ITEM DOES NOT EXIST
C              4  IF NAME DOES NOT EXIST
C              5  IF ITEM IS AN ILLEGAL ITEM NAME
C
C     THE BLOCKS OCCUPIED BY THE ITEM ARE RETURNED TO THE LIST OF FREE
C     BLOCKS IF THEY BELONG TO THE SPECIFIED SUBSTRUCTURE
C
C
      EXTERNAL        RSHIFT,ANDF
      LOGICAL         MDIUP
      INTEGER         BUF,MDI,MDIPBN,MDILBN,MDIBL,BLKSIZ,DIRSIZ,PS,SS,
     1                ANDF,RSHIFT
      DIMENSION       NAME(2),NMSBR(2)
      COMMON /ZZZZZZ/ BUF(1)
      COMMON /SOF   / DITDUM(6),IODUM(8),MDI,MDIPBN,MDILBN,MDIBL,
     1                NXTDUM(15),DITUP,MDIUP
      COMMON /SYS   / BLKSIZ,DIRSIZ,SYS(3),IFRST
      COMMON /ITEMDT/ NITEM,ITEM(7,1)
      DATA    IS,PS , SS/ 1,1,1    /
      DATA    NMSBR / 4HDELE,4HTE  /
C
      CALL CHKOPN (NMSBR(1))
      CALL FDSUB  (NAME(1),K)
      IF (K .EQ. -1) GO TO 500
      CALL FMDI (K,IMDI)
      II  = ITCODE(ITEMX)
      IF (II .EQ. -1) GO TO 510
      ITM = II - IFRST + 1
      IBL = ANDF(BUF(IMDI+II),65535)
C                             55535 = 2**16 - 1
      IF (IBL .NE. 0) GO TO 10
C
C     ITEM DOES NOT EXIST.
C
      ITEST = 3
      RETURN
C
   10 BUF(IMDI+II) = 0
      MDIUP = .TRUE.
      IF (IBL .NE. 65535) GO TO 20
C
C     ITEM PSEUDO-EXISTS.
C
      ITEST = 2
      GO TO 30
C
C     ITEM DOES EXIST.
C
   20 ITEST = 1
   30 IF (ANDF(BUF(IMDI+IS),1073741824) .EQ. 0) GO TO 35
C                           1073741824 = 2**30
C
C     IMAGE SUBSTRUCTURE
C
      IF (ITEST .NE. 1) RETURN
      IF (ITEM(4,ITM) .EQ. 0) GO TO 32
      CALL RETBLK (IBL)
   32 RETURN
C
C     NAME IS A SECONDARY OR A PRIMARY SUBSTRUCTURE
C
   35 ISVPS = ANDF(BUF(IMDI+PS),1023)
C                               1023 = 2**10 - 1
      IF (ISVPS .EQ. 0) GO TO 39
C
C     SECONDARY SUBSTRUCTURE
C
      IF (ITEST .NE. 1) RETURN
      IF (ITEM(5,ITM) .EQ. 0) GO TO 37
      CALL RETBLK (IBL)
   37 RETURN
C
C     PRIMARY SUBSTRUCTURE
C
   39 IF (ITEST .EQ. 1) CALL RETBLK (IBL)
   40 ISVSS = RSHIFT(ANDF(BUF(IMDI+SS),1048575),10)
C                                      1048575 = 2*20 - 1
      IF (ISVSS .EQ. 0) RETURN
      CALL FMDI (ISVSS,IMDI)
      IF (ANDF(BUF(IMDI+II),65535) .NE. IBL) GO TO 40
      BUF(IMDI+II) = 0
      MDIUP = .TRUE.
      GO TO 40
C
C     NAME DOES NOT EXIST.
C
  500 ITEST = 4
      RETURN
C
C     ITEM IS AN ILLEGAL ITEM NAME.
C
  510 ITEST = 5
      RETURN
      END

      SUBROUTINE MPY3C (Z,IZ,DZ)
C*****
C    PERFORMS MULTIPLICATION AND SUMMATION FOR REMAINING TERMS OF COLUMN
C    OF A.
C*****
      INTEGER PREC
      INTEGER SCR1,SCR2,FILE
      INTEGER ZPNTRS
      INTEGER UTYP,UROW1,UROWN,UINCR
      INTEGER PRECN
C
C
C
      LOGICAL FIRST2
C
C
C
      DIMENSION Z(1),IZ(1)
C     DIMENSION NAME(2)
C
C
C FILES
      COMMON / MPY3TL / FILEA(7),FILEB(7),FILEE(7),FILEC(7),SCR1,SCR2,
     1                  SCR,LKORE,CODE,PREC,LCORE,SCR3(7),BUF1,BUF2,
     2                  BUF3,BUF4,E
C SUBROUTINE CALL PARAMETERS
      COMMON / MPY3CP / ITRL,ICORE,N,NCB,M,NK,DUM1(2),ZPNTRS(22),
     1                  DUM2(2),FIRST2,K,K2,KCOUNT,IFLAG,KA,LTBC,J,
     2                  LTAC,NTBU
C UNPACK
      COMMON / UNPAKX / UTYP,UROW1,UROWN,UINCR
C
C
C
      EQUIVALENCE     (IBCOLS,ZPNTRS(11)),     (IBCID,ZPNTRS(13)),
     *                (IBNTU,ZPNTRS(15)),      (IKTBP,ZPNTRS(17)),
     *                (IANTU,ZPNTRS(19))
C
C
C
C     DATA NAME / 4HMPY3,4HC    /
C*****
C    INITIALIZATION.
C*****
      UTYP  = PREC
      UROW1 = 1
      UROWN = N
      UINCR = 1
      PRECN = PREC*N
      FILE  = SCR1
C*****
C    TEST TO SEE IF LESS THAN NK COLUMNS OF B IN CORE.
C*****
      IF (FIRST2) GO TO 30
C*****
C    DETERMINE WHICH COLUMN OF B TO BE PUT INTO CORE.
C*****
      LTA = 0
      IA  = IANTU - 1
      DO 10 I=1,K
      IA = IA + 1
      IF (LTA .GE. IZ(IA)) GO TO 10
      LTA = IZ(IA)
      IK  = IKTBP + I - 1
      LTAC= IZ(IK)
      KA  = I
   10 CONTINUE
C*****
C    DETERMINE WHICH COLUMN OF B TO BE REPLACED.
C*****
      LTB = 0
      IB  = IBNTU - 1
      DO 20 I=1,NK
      IB = IB + 1
      IF (LTB .GE. IZ(IB)) GO TO 20
      LTB  = IZ(IB)
      LTBC = I
   20 CONTINUE
      GO TO 50
C*****
C    LESS THAN NK COLUMNS OF B IN CORE.
C*****
   30 K2  = K2 + 1
      LTBC= K2
      KK  = IKTBP - 1
      DO 40 KA=1,K
      KK  = KK + 1
      IF (IZ(KK) .EQ. 0) GO TO 40
      LTAC = IZ(KK)
      GO TO 50
   40 CONTINUE
C*****
C    ADD OR REPLACE COLUMN OF B INTO CORE.
C*****
   50 CALL FILPOS (SCR1,IZ(LTAC))
      KK = IBCOLS + PRECN*(LTBC - 1)
      CALL UNPACK(*55,SCR1,Z(KK))
      GO TO 59
   55 IK = KK - 1
      DO 57 L=1,PRECN
      IK = IK + 1
   57 Z(IK) = 0.
   59 CONTINUE
      IF (FIRST2) GO TO 70
      IF (ICORE .EQ. 1) GO TO 60
      CALL MPY3NU (Z)
      KK = IBNTU + LTBC - 1
      IZ(KK) = NTBU
   60 KK = IANTU + KA - 1
      IZ(KK) = 0
   70 KK = IBCID + LTBC - 1
      IZ(KK) = LTAC
      KB = LTBC
C*****
C    PERFORM COMPUTATION.
C*****
      CALL MPY3P (Z,Z,Z)
      LTBC = KB
      KK = IKTBP + KA - 1
      IZ(KK) = 0
      KCOUNT = KCOUNT + 1
      RETURN
      END

      SUBROUTINE ELIM (IN1,IN2,IN3,IN4,OUT1,SCR1,SCR2,SCR3)
C
C     ELIM EVALUATES THE MATRIX EQUATION -
C
C     OUT1 = IN1 + IN4(T)*IN2 + IN2(T)*IN4 + IN4(T)*IN3*IN4
C
      INTEGER         OUT1  ,SCR1  ,SCR2  ,SCR3  ,FILEA ,FILEB ,FILEC  ,
     1                FILED ,T     ,SIGNAB,SIGNC ,PREC  ,RDP   ,PLUS   ,
     2                SCRTCH
      DIMENSION       FILEA(7)     ,FILEB(7)     ,FILEC(7)     ,FILED(7)
C    1,               MCB(7)
      COMMON /MPYADX/ FILEA ,FILEB ,FILEC ,FILED ,NZ    ,T     ,SIGNAB ,
     1                SIGNC ,PREC  ,SCRTCH
      COMMON /SYSTEM/ IDUM(54)     ,IPREC
      COMMON /ZZZZZZ/ Z(1)
      DATA    PLUS  / +1 /
C
      RDP = IPREC
C
C     PERFORM GENERAL INITIALIZATION
C
      NZ     = KORSZ(Z)
      SIGNAB = PLUS
      SIGNC  = PLUS
      PREC   = RDP
      SCRTCH = SCR3
C
C     INITIALIZE MATRIX CONTROL BLOCKS FOR IN3,IN4,IN2 AND SCR1
C
      FILEA(1) = IN3
      CALL RDTRL (FILEA)
      FILEB(1) = IN4
      CALL RDTRL (FILEB)
      FILEC(1) = IN2
      CALL RDTRL (FILEC)
      FILED(1) = SCR1
      FILED(3) = FILEC(3)
      FILED(4) = FILEC(4)
      FILED(5) = RDP
C
C     COMPUTE SCR1 = IN3*IN4 + IN2
C
      T = 0
      CALL MPYAD (Z,Z,Z)
C
C     SAVE MATRIX CONTROL BLOCK FOR SCR1
C
C     DO 41 I = 1,7
      CALL WRTTRL (FILED)
C
C     INITIALIZE MATRIX CONTROL BLOCKS FOR IN2, IN4, IN1 AND SCR2
C
      DO 51 I = 1,7
   51 FILEA(I) = FILEC(I)
      FILEC(1) = IN1
      CALL RDTRL (FILEC)
      FILED(1) = SCR2
      FILED(3) = FILEC(3)
      FILED(4) = FILEC(4)
C
C     COMPUTE SCR2 = IN2(T)*IN4 + IN1
C
      T = 1
      CALL MPYAD  (Z,Z,Z)
      CALL WRTTRL (FILED)
C
C     INITIALIZE MATRIX CONTROL BLOCKS FOR IN4,SCR1,SCR2 AND OUT1
C
      FILEA(1) = FILEB(1)
      FILEB(1) = SCR1
      FILEC(1) = FILED(1)
      CALL RDTRL (FILEA)
      CALL RDTRL (FILEB)
      CALL RDTRL (FILEC)
      FILED(1) = OUT1
      FILED(3) = FILEC(3)
      FILED(4) = FILEC(4)
C
C     COMPUTE  OUT1= IN4(T)*SCR1 + SCR2
C
      T = 1
      CALL MPYAD (Z,Z,Z)
C
C     WRITE TRAILER FOR OUT1 AND RETURN
C
      CALL WRTTRL (FILED)
      RETURN
      END

      SUBROUTINE PUSH (IN,BCD,ICOL,NCHAR,FLAG)
C
C     THIS ROUTINE IS USED TO PLACE BCD CHARACTERS OR INTEGERS FROM II
C     ARRAY INTO THE BCD STRING . IF FLAG = 1 AN INTEGER IS INPUT
C
      EXTERNAL        ORF
      LOGICAL         FIRST
      INTEGER         ORF,FLAG,BCD(1),CPERWD,IN(1),II(18),BLANK,
     1                DIGIT,NUMBS(10)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /SYSTEM/ ISYS,IOUT,NOGO,IDUM(35),NBPC,NBPW,NCPW
      DATA    NUMBS / 1H0,1H1,1H2,1H3,1H4,1H5,1H6,1H7,1H8,1H9 /
      DATA    CPERWD/ 4 /, FIRST / .TRUE. /, BLANK /1H  /,
     1        MINUS / 4H-   /
C
      IF (.NOT.FIRST) GO TO 15
      FIRST = .FALSE.
C
C     REMOVE BLANKS FROM NUMBERS, AND ZERO FILL
C
      ISH   = NCPW - 1
      DO 5 I = 1,10
      ISAVE = KRSHFT(NUMBS(I),ISH)
      NUMBS(I) = KLSHFT(ISAVE,ISH)
    5 CONTINUE
      ISAVE = KRSHFT(MINUS,ISH)
      MINUS = KLSHFT(ISAVE,ISH)
      NX    = NCPW - CPERWD
      IXTRA = NX*NBPC
      IBL   = 0
      IF (NX .EQ. 0) GO TO 15
      IB1   = KRSHFT(BLANK,ISH)
      DO 10 I = 1,NX
      IBL   = ORF(IBL,KLSHFT(IB1,I-1))
   10 CONTINUE
C
   15 IF (NCHAR .LE. 0) RETURN
      IF (NCHAR+ICOL .GT. 128) GO TO 70
      NIN   = (NCHAR-1)/CPERWD + 1
      DO 20 I = 1,NIN
   20 II(I) = IN(I)
      IF (FLAG .NE. 1) GO TO 50
C
C     INTEGER HAS BEEN INPUT - 1 WORD ONLY
C
C     FIND POWER OF 10 = NUMBER OF CHARACTERS
C
      IX    = IABS(IN(1))
      DO 25 I = 1,8
      IX    = IX/10
      IF (IX .EQ. 0) GO TO 30
   25 CONTINUE
      GO TO 80
   30 IC    = I
      IF (IN(1) .LT.  0) IC = IC + 1
      IF (IC .GT. NCHAR) GO TO 80
      II(2) = BLANK
      IX    = IABS(IN(1))
      IF (IC .LE. CPERWD) GO TO 40
C
C     NUMBER TAKES TWO WORDS
C
      M     = IC - CPERWD
      II(2) = KRSHFT(BLANK,M)
      DO 35 I = 1,M
      IJ    = IX/10
      DIGIT = IABS(IX-10*IJ) + 1
      IX    = IJ
      IADD  = NUMBS(DIGIT)
      II(2) = ORF(II(2),KRSHFT(IADD,M-I))
   35 CONTINUE
C
      IC    = CPERWD
C
C     FIRST WORD SET HERE FOR BOTH CASES
C
   40 II(1) = KRSHFT(BLANK,IC)
      DO 45 I = 1,IC
      IF (I.EQ.IC .AND. IN(1).LT.0) GO TO 45
      IJ    = IX/10
      DIGIT = IABS(IX-10*IJ) + 1
      IX    = IJ
      IADD  = NUMBS(DIGIT)
      II(1) = ORF(II(1),KRSHFT(IADD,IC-I))
   45 CONTINUE
      IF (IN(1) .LT. 0) II(1) = ORF(II(1),MINUS)
C
   50 IWRD  = (ICOL-1)/CPERWD + 1
      ICL   = ICOL - (IWRD-1)*CPERWD
      LWRD  = (ICOL+NCHAR-2)/CPERWD + 1
      LCOL  = ICOL + NCHAR - (LWRD-1)*CPERWD - 1
      M1    = (ICL-1)*NBPC
      M2    = CPERWD*NBPC - M1
      M3    = M2 + (NCPW-CPERWD)*NBPC
C
C     M1 IS THE NUMBER OF BITS FOR THE  FIRST SET OF CHARACTERS
C     M2 IS THE NUMBER OF BITS FOR THE SECOND SET OF CHARACTERS
C     M3 IS THE NUMBER OF BITS FOR THE RIGHT HALF OF THE WORD
C
C     IADD IS THE CURRENT WORKING WORD, IADD1 IS THE SPILL
C
      ISAVE = KRSHFT(BCD(IWRD),M3/NBPC)
      IADD1 = KLSHFT(ISAVE,M3/NBPC)
      K = 0
      DO 60 I = IWRD,LWRD
      K = K + 1
C
C     SPLIT INPUT WORD INTO TWO SETS
C
C     MOVE LEFT HALF TO RIGHT SIDE OF IADD AND ADD IADD1
C
      ISAVE = KRSHFT(II(K),(M1+IXTRA)/NBPC)
      IADD  = ORF(KLSHFT(ISAVE,IXTRA/NBPC),IADD1)
C
C     IF THIS ISNT THE LAST WORD MOVE THE RIGHT HALF TO IADD1 AND INSERT
C
      IF (I .GE. LWRD) GO TO 60
      ISAVE = KRSHFT(II(K),IXTRA/NBPC)
      IADD1 = KLSHFT(ISAVE,M3/NBPC)
C
      BCD(I) = ORF(IADD,IBL)
C
   60 CONTINUE
C
C     LAST WORD PROCESSED HERE, REMOVE EXTRA CHARACTERS
C
      ISH   = NCPW - LCOL
      ISAVE = KRSHFT(IADD ,ISH)
      IADD  = KLSHFT(ISAVE,ISH)
      ISAVE = KLSHFT(BCD(LWRD),LCOL)
      BCD(LWRD) = ORF(IADD,KRSHFT(ISAVE,LCOL))
      RETURN
C
   70 WRITE  (IOUT,75) UFM,NCHAR,IN
   75 FORMAT (A23,' 6015. TOO MANY CHARACTERS TO BE INSERTED IN A DMAP',
     1       ' LINE', /6X,4H N = , I8 ,6X, 6HWORD =,A4)
      GO TO 90
   80 WRITE  (IOUT,85) UFM,IN
   85 FORMAT (A23,' 6016. TOO MANY DIGITS TO BE INSERTED IN DMAP.',
     1       2X,'VALUE =',I12)
C
   90 NOGO = 1
      RETURN
      END

      SUBROUTINE FDSUB (NAME,I)
C                                                           ** PRETTIED
C     SEARCHES IF THE SUBSTRUCTURE NAME HAS AN ENTRY IN THE DIT. IF IT
C     DOES, THE OUTPUT VALUE OF I WILL INDICATE THAT NAME IS THE ITH
C     SUBSTRUCTURE IN THE DIT.  I WILL BE SET TO -1 IF NAME DOES NOT
C     HAVE AN ENTRY IN THEDIT.
C
      LOGICAL         DITUP
      INTEGER         BUF,DIT,DITPBN,DITLBN,DITSIZ,DITNSB,DITBL,
     1                BLKSIZ,DIRSIZ
      DIMENSION       NAME(2),NMSBR(2)
      COMMON /ZZZZZZ/ BUF(1)
      COMMON /SOF   / DIT,DITPBN,DITLBN,DITSIZ,DITNSB,DITBL,IODUM(8),
     1                MDIDUM(4),NXTDUM(15),DITUP
      COMMON /SYS   / BLKSIZ,DIRSIZ
      DATA    NMSBR / 4HFDUB,4HB   /
C
C     NNMS IS THE NUMBER OF NAMES ON ONE BLOCK OF THE DIT, AND NBLKS IS
C     THE SIZE OF THE DIT IN NUMBER OF BLOCKS.
C
      CALL CHKOPN (NMSBR(1))
      IF (DITNSB .EQ. 0) GO TO 70
      NNMS  = BLKSIZ/2
      NBLKS = DITSIZ/BLKSIZ
      IF (DITSIZ .EQ. NBLKS*BLKSIZ) GO TO 30
      NBLKS = NBLKS + 1
C
C     START LOOKING FOR THE SUBSTRUCTURE NAME.
C
   30 MAX = BLKSIZ
      DO 60 J = 1,NBLKS
      I = 1 + (J-1)*NNMS
      CALL FDIT (I,DUMMY)
      IF (J .NE. NBLKS) GO TO 40
      MAX = DITSIZ - (NBLKS-1)*BLKSIZ
C
C     SEARCH THE BLOCK OF THE DIT WHICH IS PRESENTLY IN CORE.
C
   40 DO 50 K = 1,MAX,2
      IF (BUF(DIT+K).NE.NAME(1) .OR. BUF(DIT+K+1).NE.NAME(2)) GO TO 50
      KK = K
      GO TO 80
   50 CONTINUE
   60 CONTINUE
C
C     DID NOT FIND NAME IN THE DIT.
C
   70 I = -1
      RETURN
C
C     DID FIND NAME IN THE DIT.  RETURN NAME INDEX NUMBER
C
   80 I = (DITLBN-1)*NNMS + (KK+1)/2
      RETURN
      END

      SUBROUTINE DZY (X,Y,Z,SGR,CGR,XI1,XI2,ETA,ZETA,AR,AO,KR,CBAR,
     1                BETA,FMACH,LSH,IDZDY,DZDYR,DZDYI)
C
C     CALCULATION OF THE DZ AND DY MATRICES USED IN SLENDER BODY FLOW
C
C     X        X- COORDINATE OF THE RECEIVING POINT
C     Y        Y - COORDINATE OF THE RECEIVING POINT
C     Z        Z - COORDINATE OF THE RECEIVING POINT
C     SGR      SINE OF THE RECEIVING POINT DIHEDRAL ANGLE
C     CGR      COSINE OF RECEIVING POINT DIHEDRAL ANGLE
C     XI1
C     XI2
C     ETA
C     ZETA
C     AR       ASPECT RATIO OF THE SENDING BODY
C     A0       RADIUS OF THE SENDING BODY
C     KR       REDUCED FREQUENCY
C     CBAR     REFERENCE CHORD LENGTH
C     BETA     SQRT(1.0-M**2)
C     FMACH    MACH NUMBER
C     IDZDY    FLAG INDICATING WHETHER DZ OF DY IS TO BE
C              CALCULATED.  =0  DZ, OTHERWISE DY
C     DZDYR    REAL PART OF DZ OR DY
C     DZDYI    IMAGINARY PART OF DZ OR DY
C
C
      REAL   KD1PR, KD1PI, KD2PR, KD2PI, KD1MR, KD1MI, KD2MR, KD2MI
      DATA   PI16 / 50.265482 /
C
C
C     THE COMPLEX NUMBERS IN THIS ROUTINE ARE TREATED SEPERATLY AS
C     THE REAL PART,  NAME APPENDED BY AN  -R- ,  AND THE
C     IMAGINARY PART, NAME APPENDED BY AN  -I- .
C
      E   = AO*SQRT(ABS(1.0 - AR**2))/2.0
      X01 = X - XI1
      X02 = X - XI2
C
C     CHECK ON INPUT FLAG,  = 0  DZ ,  = 1  DY
C
      IF (IDZDY .EQ. 1) GO TO 200
C
C     **     **
C     *  D Z  *
C     **     **
C
      SGS = 0.0
      CGS = 1.0
      IF (AR .LT. 1.0)  GO TO 400
C
      Z01 = Z - (ZETA+E)
      Z02 = Z - (ZETA-E)
      Y01 = Y - ETA
      Y02 = Y01
      GO TO 300
C
C     **     **
C     *  D Y  *
C     **     **
C
  200 SGS = -1.0
      IF (LSH .EQ. 1) SGS = 1.0
      CGS =  0.0
      IF (AR .GT. 1.0) GO TO 400
C
      Z01 = Z - ZETA
      Z02 = Z01
      Y01 = Y - (ETA+E)
      Y02 = Y - (ETA-E)
C
C     ****  DZ AR .GE. 1  ****
C     ****  DY AR .LE. 1  ****
C
  300 CONTINUE
      L   = 0
      Z0  = Z - ZETA
      Y0  = Y - ETA
C
      R1SQR = Y01**2 + Z01**2
      R2SQR = Y02**2 + Z02**2
      R1FOR = R1SQR**2
      R2FOR = R2SQR**2
C
      CALL FLLD (X01,X02,Y01,Z01,SGR,CGR,SGS,CGS,KR,CBAR,FMACH,E,L,
     1           KD1PR,KD1PI,KD2PR,KD2PI)
C
      IF (AR .NE. 1.0)  GO TO 320
C
C     IDENTICAL RESULTS FROM FLLD, THEREFORE SKIP SECOND CALL
C
      KD1MR = KD1PR
      KD1MI = KD1PI
      KD2MR = KD2PR
      KD2MI = KD2PI
      GO TO 360
  320 CONTINUE
      CALL FLLD (X01,X02,Y02,Z02,SGR,CGR,SGS,CGS,KR,CBAR,FMACH,E,L,
     1           KD1MR,KD1MI,KD2MR,KD2MI)
  360 CONTINUE
      DZDYR = 0.0
      DZDYI = 0.0
      IF (R1SQR.LE.0.0001. OR .R2SQR.LE.0.0001) GO TO 370
C
C     REAL
C
      DZDYR = ((KD1PR/R1SQR+KD1MR/R2SQR) + (KD2PR/R1FOR+KD2MR/R2FOR))
     1        /PI16*(-1.0)
C
C     IMAGINARY
C
      DZDYI = ((KD1PI/R1SQR+KD1MI/R2SQR) + (KD2PI/R1FOR+KD2MI/R2FOR))
     1        /PI16*(-1.0)
  370 CONTINUE
C
      RETURN
C
C     ****   DZ-AR .LT. 1   ****
C     ****   DY-AR .GT. 1   ****
C
  400 SL1 = 0.0
      TL1 = 0.0
      SL2 = 0.0
      TL2 = 0.0
      CL1 = 1.0
      CL2 = 1.0
      E   = 1.732051*E
      Y0  = Y - ETA
      Z0  = Z - ZETA
C
      CALL TVOR (SL1,CL1,TL1,SL2,CL2,TL2,SGS,CGS,SGR,CGR,X01,X02,
     1           Y0,Z0,E,BETA,CBAR,FMACH,KR,DZDYR,DZDYI)
      RETURN
      END

      SUBROUTINE VISCD
C
C     THIS SUBROUTINE COMPUTES THE 12X12 MATRIX BGG FOR A VISCOUS
C     (DASHPOT) ELEMENT
C
C     DOUBLE PRECISION VERSION
C
C     THE ECPT ENTRIES FOR THE VISC ELEMENT ARE
C
C     ECPT
C     ECPT( 1)   ELEMENT ID
C     ECPT( 2)   SIL NUMBER FOR GRID POINT A
C     ECPT( 3)   SIL NUMBER FOR GRID POINT B
C     ECPT( 4)   EXTENSIONAL DAMPING CONSTANT  - C1
C     ECPT( 5)   TORSIONAL DAMPING COEFFICIENT - C2
C     ECPT( 6)   COORD. SYSTEM ID FOR POINT A
C     ECPT( 7)   X1
C     ECPT( 8)   Y1
C     ECPT( 9)   Z1
C     ECPT(10)   COORD. SYSTEM ID FOR POINT B
C     ECPT(11)   X2
C     ECPT(12)   Y2
C     ECPT(13)   Z2
C     ECPT(14)   ELEMENT TEMPERATURE (NOT USED)
C
C
      LOGICAL          NOGO,IDBUG
      INTEGER          IECPT(14),ELID,ESTID,DICT(7),INDX(4),KX(4),KBX(4)
      DOUBLE PRECISION FL,C1,C2,VEC(3),D(64),B(144),TA(9),TB(9)
      CHARACTER        UFM*23
      COMMON /XMSSG /  UFM
      COMMON /SYSTEM/  SKP,IOUTPT,KSYSTM(53),IHEAT
      COMMON /EMGEST/  ECPT(14)
      COMMON /EMGPRM/  IXTRA,JCORE,NCORE,DUM(12),ISTIF,IMASS,IDAMP,
     1                 IPREC,NOGO,HEAT,ICMBAR,LCSTM,LMAT,LHMAT
      COMMON /ZZZZZZ/  XX(1)
      COMMON /EMGDIC/  IDM,LDICT,NGRIDS,ELID,ESTID
      EQUIVALENCE      (ECPT(1),IECPT(1),IELID), (DICT(5),DICT5),
     1                 (INDX(1),IA), (INDX(2),IAB), (INDX(3),IBA),
     2                 (INDX(4),IB)
      DATA    KX    /  1 ,7 ,73 ,79 /
      DATA    KBX   /  40,46,112,118/
C
C     INITIALIZE EMGOUT PARAMETERS
C
      IDBUG   = .TRUE.
      NGRIDS  = 2
      LDICT   = 5 + NGRIDS
      DICT(1) = ESTID
      DICT(2) = 1
      DICT(3) = 12
      DICT(4) = 63
      DICT5   = 0.
      IFILE   = 3
      IP      = IPREC
C
C     NOW COMPUTE THE LENGTH OF THE ROD AND NORMALIZE
C
      FL = 0.
      DO 20 I = 1,3
      VEC(I) = ECPT(I+6) - ECPT(I+10)
   20 FL = FL + VEC(I)**2
      FL = DSQRT(FL)
C
      IF (FL .LE. 0) GO TO 7770
      DO 30 I = 1,3
   30 VEC(I) = VEC(I)/FL
C
C     SET UP THE N MATRIX
C
      DO 40 I = 1,3
      DO 40 J = 1,3
      IX = (I-1)*3 + J
   40 D(IX) = VEC(I)*VEC(J)
C
C     INITIALIZE THE B MATRIX
C
      DO 50 I = 1,144
   50 B(I) = 0.D0
C
C     SWAP INDICES A AND B IF NECESSARY SO MATRIX WILL BE ORDERED
C     BY INCREASING SIL VALUE
C
      IPA = 6
      IPB = 10
      IF (IECPT(2) .LT. IECPT(3)) GO TO 60
      IX  = IPA
      IPA = IPB
      IPB = IPA
C
C     CONVERT GRID POINTS TO BASIC COORDINATES IF NECESSARY
C
   60 IA   = 1
      IAB  = 1
      IF (IECPT(IPA) .EQ. 0) GO TO 70
      IA   = 19
      IAB  = 10
      CALL TRANSD (ECPT(IPA),TA(1))
      CALL GMMATD (TA(1),3,3,1, D(1), 3,3,0, D(10))
      CALL GMMATD (D(10),3,3,0, TA(1),3,3,0, D(19))
C
   70 IB  = 1
      IBA = 1
      IF (IECPT(IPB) .EQ. 0) GO TO 80
      IB  = 28
      IBA = 37
      CALL TRANSD (ECPT(IPB),TB(1))
      CALL GMMATD (TB(1),3,3,1, D(1), 3,3,0, D(37))
      CALL GMMATD (D(37),3,3,0, TB(1),3,3,0, D(28))
C
      IAB = 46
C
   80 IF (IECPT(IPA) .EQ. 0) GO TO 90
      CALL GMMATD (D(IAB),3,3,0, TB(1),3,3,0, D(46))
      IBA = 55
      CALL GMMATD (D(IBA),3,3,0, TA(1),3,3,0, D(55))
C
C     CALCULATE THE DAMPING MATRIX B
C
C                       ****                    ****
C                       *      /     /      /      *
C                       * C D  /   0 /-C D  /  0   *
C                       *  1 AA/     /  1 AB/      *
C                       *--------------------------*
C                       *  0   /C D  /   0  /-C D  *
C                       *      / 2 AA/      /  2 AB*
C         B    =        *--------------------------*
C                       *-C D  /   0 / C D  /  0   *
C                       *  1 BA/     /  1 BB/      *
C                       *------------/-------------*
C                       *  0   /-C D /   0  / C D  *
C                       *      /  2 BA      /  2 BB*
C                       *      /     /      /      *
C                       ****                    ****
C
   90 C1 = ECPT (4)
      C2 = ECPT (5)
C
      DO 120 JTJ = 1,4
      KB  = KX(JTJ)
      KBB = KBX(JTJ)
      J   = 0
      I1  = INDX(JTJ)
      I2  = I1 + 8
      IF (MOD(JTJ,2) .NE. 0) GO TO 100
      C1  = -C1
      C2  = -C2
C
  100 DO 110 I = I1,I2
      B(KB)  = C1*D(I)
      B(KBB) = C2*D(I)
      IF (MOD(I,3) .EQ. 0) J = 9
      KB  = KB  + 1 + J
      KBB = KBB + 1 + J
      J   = 0
  110 CONTINUE
C
  120 CONTINUE
C
C
C     OUTPUT THE MATRIX
C
      CALL EMGOUT (B,B,144,1,DICT,IFILE,IP)
      RETURN
C
C     ERROR EXITS
C
 7770 WRITE  (IOUTPT,7775) UFM,IELID
 7775 FORMAT (A23,' 31XX, ILLEGAL GEOMETRY OR CONNEC TIONS FOR VISC ',
     1        'ELEMENT',I10)
      NOGO = .TRUE.
      RETURN
      END

      SUBROUTINE ASCM11 (NAME,IPHASE,ISOL,NOGO)
C
C     EXIO COMMANDS DMAP DATA
C
      INTEGER        COMND(6,7),SUBNAM(2),RDMAP(18,2),XTRA(4),
     1               PTBS(7,12),ISAVE(21)
      COMMON /ASDBD/ IRDM,NRDM,IXTRA,NXTRA,IOCT,NOCT,IPTBS,NPTBS,
     1               IPH,NPH,IDAT(126)
      DATA    COMND/
     1               4HSOFI    ,  2    ,  4    ,  0    , 12    ,  0  ,
     2               4HSOFO    ,  2    ,  4    ,  0    , 12    ,  0  ,
     3               4HREST    ,  2    ,  4    ,  0    , 12    ,  0  ,
     4               4HDUMP    ,  2    ,  4    ,  0    , 12    ,  0  ,
     5               4HCHEC    ,  2    ,  4    ,  0    , 12    ,  0  ,
     6               4HCOMP    ,  2    ,  4    ,  0    , 12    ,  0  ,
     7               4HAPPE    ,  2    ,  4    ,  0    , 12    ,  0  /
      DATA    SLASH/ 1H/       /
      DATA    ISAVE/
     1   1, 7,1,  1,11,3,  1,13,2,  1,15,1,  2, 6,1,  2,11,3,  2,14,2/
      DATA    RDMAP/
     1 4HEXIO,4H    ,4H  //,4HS,N,,4HDRY/,4HMACH,4H!*DE,4HVI*/,4H*UNI,
     * 4HTNAM,4HE*!*,4HFORM,4H*!*M,4HODE*,4H!*PO,4HSI*/,4H*ITE,4HM*/ ,
     2 4H    ,4H    ,4H  *N,4HAME0,4H001*,4H!*NA,4HME00,4H02*/,4H*NAM,
     * 4HE000,4H3*!*,4HNAME,4H0004,4H*!*N,4HAME0,4H005*,4H $  ,4H    /
      DATA    XTRA / 4HMACH,4HPOSI,4HITEM,4HNAME /
      DATA    PTBS /
     1          1  , 21  , 21  ,  4  ,   101  ,         0  ,  0  ,
     2          1  , 27  , 27  ,  4  ,   102  ,         0  ,  0  ,
     3          1  , 34  , 34  ,  8  ,   103  ,         0  ,  0  ,
     4          1  , 45  , 45  ,  4  ,   104  ,         0  ,  0  ,
     5          1  , 52  , 52  ,  4  ,   105  ,         0  ,  0  ,
     6          1  , 59  , 59  ,  4  ,   106  ,         0  ,  0  ,
     7          1  , 66  , 66  ,  4  ,   107  ,         0  ,  0  ,
     8          2  , 12  , 12  ,  8  ,   108  ,         0  ,  0  ,
     9          2  , 23  , 23  ,  8  ,   109  ,         0  ,  0  ,
     O          2  , 34  , 34  ,  8  ,   110  ,         0  ,  0  ,
     1          2  , 45  , 45  ,  8  ,   111  ,         0  ,  0  ,
     2          2  , 56  , 56  ,  8  ,   112  ,         0  ,  0  /
      DATA SUBNAM  / 4HASCM,2H11  /
C
C     RESTORE TO ORIGINAL DATA BY REPLACEING ! BY / IN RDMAP ARRAY
C     (SEE ASCM01 FOR EXPLANATION))
C
      DO 10 L = 1,21,3
      I = ISAVE(L+1)
      J = ISAVE(L  )
      K = ISAVE(L+2)
      RDMAP(I,J) = KHRFN1(RDMAP(I,J),K,SLASH,1)
   10 CONTINUE
C
C     VALIDATE COMMAND AND SET POINTERS
C
      DO 15 I = 1,7
      IF (NAME .EQ. COMND(1,I)) GO TO 20
   15 CONTINUE
      GO TO 70
   20 ICOMND = I
      IRDM   = 1
      NRDM   = COMND(2,ICOMND)
      IXTRA  = IRDM  + 18*NRDM
      NXTRA  = COMND(3,ICOMND)
      IOCT   = IXTRA + NXTRA
      NOCT   = COMND(4,ICOMND)
      IPTBS  = IOCT  + 3*NOCT
      NPTBS  = COMND(5,ICOMND)
      IPH    = IPTBS + 7*NPTBS
      NPH    = COMND(6,ICOMND)
C
C     MOVE RDMAP DATA
C
      K = 0
      IF (NRDM .EQ. 0) GO TO 35
      DO 30 J = 1,NRDM
      DO 30 I = 1,18
      K = K + 1
   30 IDAT(K) = RDMAP(I,J)
   35 CONTINUE
C
C     MOVE XTRA DATA
C
      IF (NXTRA .EQ. 0) GO TO 45
      DO 40 I = 1,NXTRA
      K = K + 1
   40 IDAT(K) = XTRA(I)
   45 CONTINUE
C
C     MOVE PTBS DATA
C
      IF (NPTBS .EQ. 0) GO TO 65
      DO 60 J = 1,NPTBS
      DO 60 I = 1,7
      K = K + 1
   60 IDAT(K) = PTBS(I,J)
   65 CONTINUE
C
      RETURN
C
C     INPUT ERROR
C
   70 CALL MESAGE (7,0,SUBNAM)
      NOGO = 1
      RETURN
C
      END

      SUBROUTINE SDR3
      INTEGER OFPFIL(6)
C
      COMMON /SYSTEM/ SYSBUF, L
C*****
C  MAIN DRIVER FOR THE SDR3 MODULE...
C*****
      CALL SDR3A( OFPFIL(1) )
C*****
C  IF ANY OF THE SIX DATA-BLOCKS DID NOT COMPLETE SORT2 CALL OFPDMP
C*****
      DO 10 I = 1,6
      IF( OFPFIL(I) .EQ. 0 ) GO TO 10
      WRITE(L,15)I,OFPFIL(I)
   15 FORMAT(1H1,20(131(1H*)/),95H0DUE TO ERRORS MENTIONED PREVIOUSLY, S
     1DR3 IS CALLING THE -OFP- TO OUTPUT SDR3-INPUT-DATA-BLOCK-,I2,17H I
     2N SORT-I FORMAT/ 28H THE SDR3 TRACEBACK NUMBER =,I3//20(131(1H*)/
     3))
      IFILE = I + 100
      CALL OFPDMP( IFILE )
   10 CONTINUE
      RETURN
      END

      SUBROUTINE PARAM (SETID,XX,BUF4)
C
C     THIS PARAM ROUTINE IS CALLED ONLY BY DPLOT, WHICH IS THE DRIVER
C     OF THE PLOT MODULE           ==== == =====
C
C     THE DRIVER FOR THE PARAM MODULE IS QPARAM
C
      LOGICAL TEST
      INTEGER SETID(1),XX(1)    ,BUF4     ,BUF1     ,BUFSIZ   ,TITLE   ,
     1        PRNT    ,PARM     ,PLTBUF   ,CAMERA   ,BFRAMS   ,PLTMOD  ,
     2        TAPDEN  ,PENSIZ   ,PENCLR   ,PAPTYP   ,AXIS     ,DAXIS   ,
     3        FVP     ,PRJECT   ,FOR      ,ORG      ,ORIGIN   ,PLOTER  ,
     4        WORD    ,AWRD(2)  ,ERR(3)   ,BLANK    ,PLTNAM(2),EOR     ,
     5        TRA     ,WHERE    ,DIRECT   ,FSCALE   ,PLTYPE   ,FPLTIT  ,
     6        PLTITL  ,SAVTIT(96),MSG1(20),MSG2(20) ,MSG4(22) ,MSG5(16),
     7        ANTI    ,AXISD(7) ,BOTH     ,BPI      ,BY       ,COLO    ,
     8        COMM    ,DEFO     ,DENS     ,DISP     ,EVEN     ,FILM    ,
     9        FRAM    ,HMODE    ,HPLOT(2) ,HKEY(19) ,HX       ,OESX    ,
     O        NKWD(3) ,ICNDA(20),PLAN     ,POIN     ,PAPE     ,SEPA    ,
     1        SIZE    ,STRE     ,SYMM     ,TYPE     ,Z1       ,Z2      ,
     2        FILL    ,COLOR    ,LAYER    ,OES1     ,OES1L    ,ONRGY1
      REAL    MAXDEF
      DOUBLE PRECISION DWRD
      COMMON /SYSTEM/  KSYSTM(65)
      COMMON /OUTPUT/  TITLE(96)
      COMMON /BLANK /  SKP11(3) ,PRNT     ,SKP12(6) ,PARM     ,SKP2(9) ,
     1                 MERR     ,SKPIT(2) ,OESX
      COMMON /XXPARM/  PLTBUF   ,CAMERA   ,BFRAMS   ,PLTMOD(2),TAPDEN  ,
     1                 NPENS    ,PAPSIZ(2),PAPTYP(2),PENSIZ(8)         ,
     2                 PENCLR(8,2),PENPAP ,SCALE(2) ,FSCALE   ,MAXDEF  ,
     3                 DEFMAX   ,AXIS(3)  ,DAXIS(3) ,VANGLE(3)         ,
     4                 SKPVUE(6),FVP      ,VANPNT(5),D02      ,D03     ,
     5                 PRJECT   ,S0S      ,FOR      ,ORG      ,NORG    ,
     6                 ORIGIN(11),EDGE(11,4),XY(11,3),NCNTR   ,CNTR(50),
     7                 ICNTVL   ,WHERE    ,DIRECT   ,SUBCAS   ,FLAG    ,
     8                 DATA     ,LASSET   ,FPLTIT   ,PLTITL(17)        ,
     9                 COLOR    ,LAYER
      COMMON /PLTDAT/  MODEL    ,PLOTER   ,SKPPLT(17),CHRSCL  ,SKPA(2) ,
     1                 CNTSIN   ,SKPD1(6) ,PLTYPE    ,SKPD2(3),CNTIN3
      EQUIVALENCE      (KSYSTM(1),BUFSIZ) ,(PAPE,HKEY(10))    ,
     1                 (WORD,AWRD(1),DWRD ,FWRD,IWRD)
C
C     THE FOLLOWING ARE THE ALLOWABLE FIRST WORDS ON THE LOGICAL CARD.
C     THE PROJECTION DETERMINES HOW MANY WORDS ARE CHECKED.
C
C     OES1   IS THE NORMAL STRESS FILE, 111
C     OES1L  IS THE LAYER COMPOSITE STRESS FILE, 112
C     ONRGY1 IS THE ELEMENT  STRAIN ENERGY FILE, 113
C
      DATA OES1 , OES1L , ONRGY1 /111,112,113   /
      DATA NKWD / 17,19,19/     , BLANK4 /4H    /
      DATA HKEY / 4HFIND, 4HVIEW, 4HAXES, 4HMAXI, 4HORTH, 4HPERS,
     1            4HSTER, 4HCONT, 4HCAME, 4HPAPE, 4HPEN , 4HBLAN,
     2            4HORIG, 4HSCAL, 4HCSCA, 4HPROJ, 4HPTIT, 4HOCUL,
     3            4HVANT/
C
C     THE FOLLOWING ARE RECOGNIZABLE PARAMETERS
C
      DATA AXISD/ 2HMZ   , 2HMY, 2HMX, 0, 1HX,  1HY,     1HZ        /,
     1     ANTI / 4HANTI/, BOTH/ 4HBOTH/, BPI / 4HBPI /, BY  /4HBY  /,
     2     COLO / 4HCOLO/, DEFO/ 4HDEFO/, DENS/ 4HDENS/, FILM/4HFILM/,
     3     FRAM / 4HFRAM/,HMODE/ 4HMODE/,HPLOT/ 4HPLOT,  4HTER      /,
     4     HX   / 4HX   /, PLAN/ 4HPLAN/, POIN/ 4HPOIN/, SEPA/4HSEPA/,
     5     SIZE / 4HSIZE/, SYMM/ 4HSYMM/, TYPE/ 4HTYPE/,
C
C     CONTOUR PLOTTING
C
     6     DISP / 4HDISP/, STRE/ 4HSTRE/, EVEN/ 4HEVEN/, LAYE/ 4HLAYE/,
     7     LIST / 4HLIST/, Z1  / 2HZ1  /, Z2  / 2HZ2  /, MAX / 3HMAX /,
     8     MID  / 3HMID /, COMM/ 4HCOMM/, LOCA/ 4HLOCA/, FILL/ 4HFILL/
C
      DATA  ICNDA  /4HMAJP, 4HMINP, 4HMAXS, 4HXNOR, 4HYNOR, 4HZNOR,
     1      4HXYSH, 4HXZSH, 4HYZSH, 4HXDIS, 4HYDIS, 4HZDIS, 4HMAGN,
     2      4HNRM1, 4HNRM2, 4HSH12, 4HSH1Z, 4HSH2Z, 4HBDSH, 4HSTRA/
C
      DATA  EOR   , BLANK/ 1000000, 1H  /,
     1      NMSG5 , MSG5 / 16,4H(25X, 4H,31H, 4HMORE, 4H THA, 4HN 50,
     2      4H CON, 4HTOUR,   4HS SP, 4HECIF, 4HIED,, 4H1P,E, 4H14.6,
     3      4H,9H , 4HREJE,   4HCTED, 4H)   /
      DATA  NMSG1 / 20   /
      DATA  MSG1  / 4H(34X  ,4H,45H   ,4HAN A   ,4HTTEM   ,4HPT H   ,
     1              4HAS B  ,4HEEN    ,4HMADE   ,4H TO    ,4HDEFI   ,
     2              4HNE M  ,4HORE    ,4HTHAN   ,4H ,I2   ,4H,17H   ,
     3              4H DIS  ,4HTINC   ,4HT OR   ,4HIGIN   ,4HS)     /
      DATA  NMSG2 / 20   /
      DATA  MSG2  / 4H(30X  ,4H,34H   ,4HAN U   ,4HNREC   ,4HOGNI   ,
     1              4HZABL  ,4HE PL   ,4HOT P   ,4HARAM   ,4HETER   ,
     2              4H (,2  ,4HA4,2   ,4H9H)    ,4HHAS    ,4HBEEN   ,
     3              4H DET  ,4HECTE   ,4HD -    ,4HIGNO   ,4HRED)   /
      DATA  NMSG4 / 22   /
      DATA  MSG4  / 4H(25X  ,4H,4HP   ,4HEN ,   ,4HI4,6   ,4H9H I   ,
     1              4HS NO  ,4HT A    ,4HLEGA   ,4HL PE   ,4HN NU   ,
     2              4HMBER  ,4H FOR   ,4H THI   ,4HS PL   ,4HOTTE   ,
     3              4HR. P  ,4HEN 1   ,4H WIL   ,4HL BE   ,4H RED   ,
     4              4HEFIN  ,4HED.)    /
      DATA  TEST  / .FALSE. /
C
C
C     COMMENTS FROM G.CHAN/UNISYS ABOUT THE NOFIND FLAG       11/1990
C
C     THE NOFIND FLAG WAS TOO CONFUSING BEFORE. I'M SETTING THE NEW RULE
C     HERE
C
C     NOFIND FLAG IS USED IN PARAM AND PLOT ROUTINES ONLY. ITS USE IS
C     TO INDICATE WHETHER SUBROUTINE FIND SHOULD BE CALLED.
C     (SUBROUTINE FIND COMPUTES THE NEW ORIGIN, FRAME SIZE, NEW VIEW,
C     VANTAGE POINT ETC. DUE TO CERTAIN PLOT PARAMETERS).
C     NOFIND FLAG CAN BE SET BY USER VIA THE FIND AND NOFIND COMMANDS,
C     OR IT IS SET AUTOMATICALLY BY THIS PARAM SUBROUTINE.
C
C      NOFIND                  ACTION
C     --------    ----------------------------------------------------
C        -1       FIND ROUTINE SHOULD BE CALLED IN NEXT OPPORTUNITY
C                 BEFORE THE ACTUAL PLOTTING
C        +1       (1) A NOFIND CARD WAS ENCOUNTERED. USER WANTS TO KEEP
C                 ALL PARAMETERS AS IN THE PREVIOUS PLOT CASE, OR
C                 (2) FIND ROUTINE WAS JUST CALLED. PROGRAM SHOULD NOT
C                 CALL FIND AGAIN
C         0       THE CURRENT STATUS OF ALL PARAMETERS THAT WERE FOUND
C                 BY PREVIOUS FIND REMAIN UNCHANGED. HOWEVER, ANY
C                 CHANGE IN THE PLOT PARAMETERS BY THE USER (SCALE,
C                 CSCALE, VIEW, VENTAGE POINT, REGION, ORIGIN, PLOTTER,
C                 MAX.DEFORMATION, PROJECTION AND PAPER SIZE) WILL
C                 CHANGE NOFIND FLAG TO -1
C
C     IF A FIND COMMAND IS ENCOUNTERED, SUBROUTINE FIND IS CALLED
C     IMMEDIATELY AND UNCONDISIONALLY, THEN NOFIND FLAG IS SET TO +1
C
C     IF USER HAS ALREADY ONE OR MORE ORIGINS, AND IF HE USES A FIND
C     CARD TO FIND ANOTHER ORIGIN, BUT THE NEXT PLOT CARD DOES NOT USE
C     THIS NEWLY DEFINED ORIGIN, A WARNING MESSAGE SHOULD BE ISSUED TO
C     INFORM THE USER THAT THE DEFAULT ORIGIN, WHICH IS THE FIRST
C     DEFINDED ORIGIN, IS GOING TO BE USED, NOT THE ONE HE JUST DEFINED
C
      NOFIND = -1
      LASSET = 0
      CALL PLTSET
      BUF1 = BUF4 + 3*BUFSIZ
C
C     SAVE THE TITLE, SUBTITLE AND LABEL IF DEFORMED PLOTS ...
C
      IF (PRNT .GE. 0) GO TO 30
      DO 10 I = 1,96
   10 SAVTIT(I) = TITLE(I)
   20 NOFIND = 0
   30 CALL RDMODX (PARM,MODE,WORD)
   40 CALL READ (*1800,*1800,PARM,MODE,1,0,I)
      IF (MODE) 50,40,60
   50 I = 1
      IF (MODE .EQ. -4) I = 2
      CALL FREAD (PARM,0,-I,0)
      GO TO 40
   60 IF (MODE .LT. EOR) GO TO 70
      CALL FREAD (PARM,0,0,1)
      GO TO 40
   70 MODE = MODE + 1
      CALL RDWORD (MODE,WORD)
      CALL RDWORD (MODE,WORD)
      IF (AWRD(1) .NE. HPLOT(1)) GO TO 160
      IF (AWRD(2) .EQ.    BLANK) GO TO 110
      IF (AWRD(2) .EQ. HPLOT(2)) GO TO 900
      GO TO 1750
C
C     FIND
C
  100 CALL FIND (MODE,BUF1,BUF4,SETID,XX)
      NOFIND = +1
      IF (MODE .GE. 0) GO TO 30
      MODE = MODEX
      GO TO 130
C
C     PLOT
C
  110 IF (TEST) GO TO 130
C
C         WHEN PLOTTER OR PROJECTION WERE HIT
C              FSCALE=FOR=FVP=1
C              PROJECTION=KWRD-4, SOME NUMBER
C         WHEN SCALE IS HIT,       FSCALE SET TO 0
C         WHEN VANTAGE POINT IS HEIT, FVP SET TO 0
C         WHEN ORIGIN IS HIT,         ORG SET TO 0
C
      IF (FSCALE.NE.0 .OR. FOR.NE.0) GO TO 120
      IF (PRJECT.EQ.1 .OR. FVP.EQ.0) GO TO 130
  120 MODEX = MODE
      MODE  = -1
      ORG   = MAX0(1,ORG)
      GO TO 100
  130 CALL PLOT (MODE,BUF1,BUF4,SETID,XX,NOFIND)
      OESX = OES1
      IF (NOFIND .EQ. -1) ORG = MAX0(1,ORG)
      GO TO 20
C
C     PLOT PARAMETER CARD.
C
  140 IF (MODE .LE. 0) CALL RDMODE (*140,*150,*40,MODE,WORD)
  150 CALL RDWORD (MODE,WORD)
  160 I = NKWD(PRJECT)
      DO 170 KWRD = 1,I
      IF (HKEY(KWRD) .EQ. WORD) GO TO 200
  170 CONTINUE
      GO TO 1750
C
  200 GO TO (100, 1230,  250,  500,  230,  230,  230, 1300,  400,  700,
     1       800,  440,  600, 1120, 1700, 1100, 1720,  520, 1200), KWRD
C
C           FIND  VIEW  AXES  MAXI  ORTH  PERS  STER  CONT  CAME  PAPE
C    1       PEN  BLAN  ORIG  SCAL  CSCA  PROJ  PTIT  OCUL  VANT
C
C
C     RECHECK IF PROJECTION CARD
C
  210 DO 220 KWRD = 5,7
      IF (WORD .EQ. HKEY(KWRD)) GO TO 230
  220 CONTINUE
      GO TO 1750
C
C     PROJECTION
C
  230 PRJECT    = KWRD-4
      VANGLE(1) = 0.
      VANGLE(2) =-1.E10
      VANGLE(3) = 34.27
      FSCALE    = 1
      FVP = 1
      FOR = 1
      IF (NOFIND .EQ. 0) NOFIND = -1
      CALL RDWORD (MODE,WORD)
      IF (WORD .NE. HKEY(16)) GO TO 140
C
C     READ SECOND WORD OF ORTHO.,PERS.,OR STERO. SHOULD BE PROJECTION
C
      IF (ORG .EQ. 0) GO TO 140
      DO 240 I  = 1,ORG
      EDGE(I,1) = 0.
      EDGE(I,2) = 0.
      EDGE(I,3) = 1.
      EDGE(I,4) = 1.
  240 CONTINUE
      ORG = 0
      GO TO 140
C
C     AXES
C
  250 DO 290 J = 1,3
      IF (MODE .EQ. 0) CALL RDMODE (*140,*260,*40,MODE,WORD)
  260 CALL RDWORD (MODE,WORD)
      DO 270 I = 1,7
      IF (WORD .EQ. AXISD(I)) GO TO 280
  270 CONTINUE
      GO TO 310
  280 AXIS(J) = I - 4
  290 CONTINUE
      IF (MODE .EQ. 0) CALL RDMODE (*320,*300,*320,MODE,WORD)
  300 CALL RDWORD (MODE,WORD)
  310 IF (WORD .EQ. ANTI) GO TO 330
  320 K = 1
      GO TO 340
  330 K = -1
  340 DO 350 J = 1,3
      DAXIS(J) = K*AXIS(J)
  350 CONTINUE
      IF (MODE .GE. EOR) GO TO 40
      IF (MODE.LT.0 .OR. WORD.EQ.SYMM .OR. WORD.EQ.ANTI) GO TO 140
      GO TO 160
C
C     CAMERA
C
  400 ASSIGN 420 TO TRA
      IF (MODE .LE. 0) CALL RDMODE (*1910,*410,*40,MODE,WORD)
  410 CALL RDWORD (MODE,WORD)
      N = 2
      IF (WORD .EQ. FILM) N = 1
      IF (WORD .EQ. PAPE) N = 2
      IF (WORD .EQ. BOTH) N = 3
      IF (N) 430,1750,430
  420 N = IWRD
  430 CAMERA = N
      GO TO 140
C
C     BLANK FRAMES
C
  440 IF (MODE .EQ. 0) GO TO 1750
      CALL RDWORD (MODE,WORD)
      IF (WORD.NE.FRAM .OR. MODE.NE.0) GO TO 1750
      ASSIGN 450 TO TRA
      GO TO 1900
  450 BFRAMS = IWRD
      GO TO 140
C
C     MAXIMUM DEFORMATION
C
  500 IF (MODE .LE. 0) GO TO 1750
      CALL RDWORD (MODE,WORD)
      IF (WORD.NE.DEFO .OR. MODE.NE.0) GO TO 1750
      ASSIGN 510 TO TRA
      GO TO 1940
  510 MAXDEF = FWRD
      GO TO 140
C
C     OCULAR SEPARATION
C
  520 IF (MODE .LE. 0) GO TO 1750
      CALL RDWORD (MODE,WORD)
      IF (WORD.NE.SEPA .OR. MODE.NE.0) GO TO 1750
      ASSIGN 530 TO TRA
      GO TO 1940
  530 S0S = FWRD
      GO TO 140
C
C     ORIGIN
C
  600 IF (MODE .NE. 0) GO TO 1750
      ASSIGN 610 TO TRA
      GO TO 1900
C
C     ORIGIN ID
C
  610 ID = IWRD
      ASSIGN 620 TO TRA
      GO TO 1940
C
C     HORIZONTAL LOCATION (LEFT EYE - STEREO)
C
  620 X = FWRD*CNTSIN
      ASSIGN 630 TO TRA
      GO TO 1940
C
C     VERTICAL LOCATION
C
  630 Y = FWRD*CNTSIN
      IF (ORG .EQ. 0) GO TO 670
      DO 640 J = 1,ORG
      IF (ORIGIN(J) .EQ. ID) GO TO 680
  640 CONTINUE
      IF (ORG .LT. NORG) GO TO 670
      IF (PRNT .LT.   0) GO TO 650
      ERR(1) = 1
      ERR(2) = NORG
      CALL WRTPRT (MERR,ERR,MSG1,NMSG1)
  650 ORG = NORG
      DO 660 I = 1,2
      EDGE(ORG+1,I+0) = 0.
      EDGE(ORG+1,I+2) = 1.
  660 CONTINUE
  670 ORG = ORG + 1
      J   = ORG
      ORIGIN(J) = ID
      IF (NOFIND .EQ. 0) NOFIND = -1
  680 XY(J,1) = X
      XY(J,3) = Y
      FOR = 0
      ASSIGN 690 TO TRA
      GO TO 1940
C
C     HORIZONTAL LOCATION (RIGHT EYE - STEREO)
C
  690 XY(J,2) = FWRD*CNTSIN
      GO TO 140
C
C     PAPER SIZE, TYPE
C
  700 IF (MODE .LE. 0) GO TO 1750
      CALL RDWORD (MODE,WORD)
      IF (WORD .EQ. TYPE) GO TO 760
      IF (WORD.NE.SIZE .OR. MODE.NE.0) GO TO 1750
      ASSIGN 710 TO TRA
      GO TO 1940
  710 X = FWRD
      CALL RDMODE (*730,*720,*40,MODE,WORD)
  720 CALL RDWORD (MODE,WORD)
      IF (WORD.NE.BY .AND. WORD.NE.HX) GO TO 1750
      IF (MODE .NE. 0) GO TO 1750
  730 ASSIGN 740 TO TRA
      GO TO 1940
  740 PAPSIZ(1) = X
      PAPSIZ(2) = FWRD
      CALL PLTSET
      CALL RDMODE (*140,*750,*40,MODE,WORD)
  750 CALL RDWORD (MODE,WORD)
      IF (WORD .NE. TYPE) GO TO 160
C
C     PAPER TYPE
C
  760 IF (MODE .EQ. 0) GO TO 1750
      CALL RDWORD (MODE,WORD)
      PAPTYP(1) = AWRD(1)
      PAPTYP(2) = AWRD(2)
      IF (MODE) 140,140,700
C
C     PEN SIZE / COLOR
C
  800 IF (MODE .NE. 0) GO TO 1750
      ASSIGN 810 TO TRA
      GO TO 1900
  810 IF (IWRD.NE.1 .AND. IWRD.LE. NPENS) GO TO 820
      ERR(1) = 1
      ERR(2) = IWRD
      CALL WRTPRT (MERR,ERR,MSG4,NMSG4)
      IWRD = 1
  820 ID = IWRD
  830 CALL RDMODE (*140,*840,*40,MODE,WORD)
  840 CALL RDWORD (MODE,WORD)
      IF (WORD .EQ. SIZE) GO TO 850
      IF (WORD .NE. COLO) GO TO 160
      IF (MODE .EQ.    0) GO TO 1750
      CALL RDWORD (MODE,WORD)
      PENCLR(ID,1) = AWRD(1)
      PENCLR(ID,2) = AWRD(2)
      IF (MODE) 140,830,840
C
C     PEN SIZE
C
  850 IF (MODE .NE. 0) GO TO 1750
      ASSIGN 860 TO TRA
      GO TO 1900
  860 PENSIZ(ID) = IWRD
      GO TO 830
C
C     PLOTTER
C
  900 IF (MODE .EQ. 0) GO TO 1750
      CALL RDWORD (MODE,WORD)
      PLTNAM(1) = AWRD(1)
      PLTNAM(2) = AWRD(2)
      PLTMOD(1) = 0
      PLTMOD(2) = 0
      CAMERA = 2
      FSCALE = 1
      FVP = 1
      FOR = 1
      IF (ORG .EQ. 0) GO TO 920
      DO 910 I  = 1,ORG
      EDGE(I,1) = 0.
      EDGE(I,2) = 0.
      EDGE(I,3) = 1.
      EDGE(I,4) = 1.
  910 CONTINUE
      ORG = 0
C
C     CHECK FOR A MODEL NUMBER
C
  920 ASSIGN 960 TO TRA
      J = 1
      IF (MODE .LE. 0) CALL RDMODE (*1910,*930,*970,MODE,WORD)
  930 CALL RDWORD (MODE,WORD)
      IF (WORD .EQ. DENS ) GO TO 970
      IF (WORD .NE. HMODE) GO TO 960
  940 IF (MODE .LE. 0) CALL RDMODE (*1910,*950,*970,MODE,WORD)
  950 CALL RDWORD (MODE,WORD)
      IF (WORD .EQ. DENS) GO TO 970
  960 PLTMOD(J) = WORD
      J = J + 1
      IF (J .EQ. 2) GO TO 940
  970 CALL FNDPLT (ID,N,PLTMOD)
      PLOTER = ID
      MODEL  = N
      CALL PLTSET
      IF (WORD .EQ. DENS) GO TO 1000
      IF (MODE .GE.  EOR) GO TO 40
C
C     TAPE DENSITY ON PLOTTER CARD
C
  980 IF (MODE .LE. 0) CALL RDMODE (*980,*990,*40,MODE,WORD)
  990 CALL RDWORD (MODE,WORD)
 1000 IF (WORD .NE. DENS) GO TO 160
      IF (MODE .NE.    0) GO TO 140
      ASSIGN 1010 TO TRA
      GO TO 1900
 1010 TAPDEN = IWRD
      CALL RDMODE (*140,*1020,*40,MODE,WORD)
 1020 CALL RDWORD (MODE,WORD)
      IF (WORD .EQ. BPI) GO TO 140
      GO TO 160
C
C     PROJECTION PLANE SEPARATION
C
 1100 IF (MODE .EQ. 0) GO TO 1750
      CALL RDWORD (MODE,WORD)
C
C     USER MAY HAVE REVERSE ENGLISH
C
      IF (WORD .NE. PLAN) GO TO 210
      IF (MODE .EQ.    0) GO TO 1750
      CALL RDWORD (MODE,WORD)
      IF (MODE.NE.0 .OR. WORD.NE.SEPA) GO TO 1750
      ASSIGN 1110 TO TRA
      GO TO 1940
 1110 IF (PRJECT .EQ. 2) D02 = FWRD
      IF (PRJECT .EQ. 3) D03 = FWRD
      GO TO 140
C
C     SCALE
C
 1120 IF (MODE .NE. 0) GO TO 1750
      ASSIGN 1130 TO TRA
      GO TO 1940
 1130 IF (FWRD  .EQ. 0.) GO TO 1140
      IF (PRJECT .NE. 3) SCALE(1) = CNTSIN*FWRD
      IF (PRJECT .EQ. 3) SCALE(1) = CNTIN3*FWRD
 1140 FSCALE = 0
      ASSIGN 1150 TO TRA
      GO TO 1940
 1150 IF (FWRD  .NE. 0.) SCALE(2) = FWRD
      IF (NOFIND .EQ. 0) NOFIND = -1
      GO TO 140
C
C     VANTAGE POINT
C
 1200 IF (MODE .EQ. 0) GO TO 1750
      CALL RDWORD (MODE,WORD)
      IF (WORD.NE.POIN .OR. MODE.NE.0) GO TO 1750
      ASSIGN 1220 TO TRA
      J = 0
 1210 J = J + 1
      IF (J .EQ. 3) J = 4
      IF (PRJECT.EQ.3 .AND. J.EQ.6) J = 3
      GO TO 1940
 1220 VANPNT(J) = FWRD
      IF ((PRJECT.NE.3 .AND. J.NE.5) .OR. (PRJECT.EQ.3 .AND. J.NE.3))
     1   GO TO 1210
      FVP =  0
      IF (NOFIND .EQ. 0) NOFIND = -1
      GO TO 140
C
C     VIEW
C
 1230 IF (MODE .NE. 0) GO TO 1750
      ASSIGN 1250 TO TRA
      J = 4
 1240 J = J - 1
      GO TO 1940
 1250 VANGLE(J) = FWRD
      IF (NOFIND .EQ. 0) NOFIND = -1
      IF (J-1) 1240,140,1240
C
C     CONTOUR
C
C     RESTORE DEFAULTS
C
 1300 ICNTVL = 1
      NCNTR  = 10
      COLOR  = 0
      LAYER  = 0
      WHERE  = 1
      DIRECT = 2
      CNTR(1)= 0.0
      CNTR(2)= 0.0
C
C     FLAG AND LASSET SET IN PLOT AND CONPLT
C
 1310 IF (MODE .LE. 0) CALL RDMODE (*1310,*1320,*40,MODE,WORD)
 1320 CALL RDWORD (MODE,WORD)
      IF (WORD.EQ.COLO .OR. WORD.EQ.FILL .OR. WORD.EQ.LAYE) GO TO 1340
      IF (WORD .NE. EVEN) GO TO 1370
      ASSIGN 1330 TO TRA
      GO TO 1900
 1330 NCNTR = MIN0 (50,IWRD)
      GO TO 1310
 1340 IF (WORD .EQ. COLO) ASSIGN 1350 TO TRA
      IF (WORD .EQ. FILL) ASSIGN 1360 TO TRA
      IF (WORD .EQ. LAYE) GO TO 1600
      GO TO 1900
 1350 COLOR = IWRD
      GO TO 1310
 1360 COLOR = -IWRD
      GO TO 1310
C
 1370 IF (WORD .NE. LIST) GO TO 1500
      IF (MODE .GT.    0) GO TO 1580
      NCNTR = 0
      ASSIGN 1390 TO TRA
 1380 CALL RDMODE (*1950,*1320,*40,MODE,WORD)
 1390 IF (NCNTR .LT. 50) GO TO 1400
      IF (PRNT  .LT.  0) GO TO 1380
      ERR(1) = 1
      ERR(2) = IWRD
      CALL WRTPRT (MERR,ERR,MSG5,NMSG5)
      GO TO 1380
 1400 NCNTR = NCNTR + 1
      CNTR(NCNTR) = FWRD
      GO TO 1380
C
 1500 IF (WORD .EQ. Z1  ) GO TO 1510
      IF (WORD .EQ. Z2  ) GO TO 1520
      IF (WORD .EQ. MAX ) GO TO 1530
      IF (WORD .EQ. MID ) GO TO 1540
      IF (WORD .EQ. COMM) GO TO 1550
      IF (WORD .EQ. DISP) GO TO 1310
      IF (WORD .EQ. STRE) GO TO 1310
      IF (WORD .NE. LOCA) GO TO 1560
      DIRECT = 1
      GO TO 1310
 1510 WHERE  = 1
      GO TO 1310
 1520 WHERE  =-1
      GO TO 1310
 1530 WHERE  = 2
      GO TO 1310
 1540 WHERE  = 3
      GO TO 1310
 1550 DIRECT = 2
      GO TO 1310
C
 1560 DO 1570 J = 1,20
      IF (WORD .EQ. ICNDA(J)) GO TO 1590
 1570 CONTINUE
 1580 IF (PRNT .LT. 0) GO TO 1310
      ERR(1) = 2
      ERR(2) = AWRD(1)
      ERR(3) = AWRD(2)
      CALL WRTPRT (MERR,ERR,MSG2,NMSG2)
      GO TO 1310
C
 1590 ICNTVL = J
C
C     SET STRESS FILE TO STRAIN FILE
C
      IF (ICNTVL .EQ. 20) OESX = ONRGY1
      GO TO 1310
C
C     ASSIGN LAYER NUMBER HERE FOR COMPOSITS
C
 1600 ASSIGN 1610 TO TRA
C
C     SET STRESS FILE TO LAYER STRESS
C
      OESX = OES1L
      GO TO 1900
 1610 LAYER = IWRD
      GO TO 1310
C
C     CSCALE
C
 1700 IF (MODE .NE. 0) GO TO 1750
      ASSIGN 1710 TO TRA
      GO TO 1940
 1710 CHRSCL = FWRD
      IF (NOFIND .EQ.   0) NOFIND = -1
      IF (CHRSCL .LT. 1.0) CHRSCL = 1.0
      CALL PLTSET
      GO TO 140
C
C     PTITLE
C
 1720 FPLTIT = 1
      DO 1730 I = 1,17
 1730 PLTITL(I) = BLANK4
      J = COLOR
      DO 1740 I = 1,17,2
      CALL RDWORD (MODE,WORD)
      PLTITL(I  ) = AWRD(1)
      PLTITL(I+1) = AWRD(2)
      IF (MODE .EQ. 0) GO TO 140
 1740 CONTINUE
      COLOR = J
      IF (MODE .NE. 0) CALL RDWORD (MODE,WORD)
      GO TO 140
C
C     UNRECOGNIZABLE PLOT PARAMETER.
C
 1750 IF (PRNT.LT. 0) GO TO 140
      ERR(1) = 2
      ERR(2) = AWRD(1)
      ERR(3) = AWRD(2)
      CALL WRTPRT (MERR,ERR,MSG2,NMSG2)
      GO TO 140
C
C     END OF PLOT INPUT
C
 1800 IF (PRNT .GE. 0) GO TO 1820
      DO 1810 I = 1,96
 1810 TITLE(I) = SAVTIT(I)
 1820 CONTINUE
      RETURN
C
C
C     READ AN INTEGER ON A PARAMETER CARD
C
 1900 CALL RDMODE (*1910,*140,*40,MODE,WORD)
 1910 IF (MODE .EQ. -1) GO TO 1930
      IF (MODE .EQ. -4) GO TO 1920
      IWRD = FWRD
      GO TO 1930
 1920 IWRD = DWRD
 1930 GO TO TRA, (420,450,610,810,860,1330,1350,1360,1610,960,1010)
C
C     READ A DECIMAL NUMBER ON A PARAMETER CARD
C
 1940 CALL RDMODE (*1950,*140,*40,MODE,WORD)
 1950 IF (MODE .EQ. -4) GO TO 1960
      IF (MODE .NE. -1) GO TO 1970
      FWRD = IWRD
      GO TO 1970
 1960 FWRD = DWRD
 1970 GO TO TRA, ( 510, 530, 620, 630, 690, 710, 740,1110,1130,1150,
     1            1220,1250,1390,1710)
C
      END

      SUBROUTINE FVRS1B (BASE,W1,NF)
C
C     SUBROUTINE TO COMPUTE BASE(FI)(3X1) FOR MODFRL=FALSE
C
      COMPLEX BASE(3,NF),Z1,P
C
      DIMENSION W1(NF)
C
      COMMON /CONDAS/ PI,TWOPI,RADEG,DEGRA,S4PIQ
      COMMON /BLANK / DUM(5),IT(6),DUM1(3)
C
      DO 110 K=1,NF
      F=W1(K)/TWOPI
      LT=1
      LP=2
      DO 100 I=1,3
      IF(IT(LT).EQ.-1)GO TO 90
      CALL TAB(IT(LT),F,XO)
      IF(IT(LP).EQ.-1)GO TO 40
      CALL TAB(IT(LP),F,PHI)
      RAD=PHI*DEGRA
      Z1=CMPLX(0.0,RAD)
      P=CEXP(Z1)
      GO TO 50
  40  P=(1.0,0.0)
  50  BASE(I,K)=XO*P
      GO TO 95
  90  BASE(I,K)=(0.0,0.0)
  95  LT=LT+2
      LP=LP+2
 100  CONTINUE
 110  CONTINUE
      RETURN
      END

      SUBROUTINE DBMNAM ( IGNAME, NAME, IFILEX )
C********************************************************************
C  DBMNAM RETURNS THE DMAP NAME AND TRAILER FOR A GIVEN GINO FILE
C     ARGUMENTS
C       IGNAME  (INPUT )   GINO FILE NAME (E.G., 101,201,301)
C       FIST    (INPUT )   COMMON BLOCK /XFIST/
C       FIAT    (INPUT )   COMMON BLOCK /XFIAT/
C       NAME    (OUTPUT)   (2A4) DMAP FILE NAME
C********************************************************************
      INTEGER FIST(100), FIAT(100), NAME(2)
      INTEGER BLANK, POOL
      COMMON / XFIST / FIST
      COMMON / XFIAT / FIAT
      DATA     POOL / 4HPOOL /, BLANK / 4H    /
      IF ( IGNAME .LE. 100 .OR. IGNAME .GE. 400 ) GO TO 100
      LIM  = FIST(2)*2 - 1
      DO 10 I = 1, LIM, 2
      IF ( IGNAME .NE. FIST(2+I) ) GO TO 10
      INDEX     = FIST(3+I)
      NAME(1)   = FIAT( INDEX+2 )
      NAME(2)   = FIAT( INDEX+3 )
      GO TO 700
10    CONTINUE
      NAME(1)   = 0
      NAME(2)   = 0
      GO TO 700
100   NAME(1) = IGNAME
      NAME(2) = BLANK
      IF ( IFILEX .EQ. 22 ) NAME(1) = POOL
700   RETURN
      END

      SUBROUTINE EQMCKS
C
C     THIS SUBROUTINE CALCULATES AND OUTPUTS OVERALL EQUILIBRIUM FORCES
C
C     THE INPUT FILES ARE
C         KSCC - CASE CONTROL     - NOT PREPOSITIONED.
C         KPGG - LOAD VECTORS     - FILE 110 OR SCRATCH4
C         KQG  - SPC CONSTRAINTS  - FILE 111 OR SCRATCH5
C         QMG  - MPC CONSTRAINTS  - SCRATCH3
C         DT   - RIGID BODY TRANS - SCRATCH2
C
      LOGICAL         LSTEIG
      INTEGER         EJECT    ,NAME(2)  ,PARM     ,
     1                RDNRW    ,RDRW     ,WRTNRW   ,WRTRW
      REAL            HEAD(2,4),COR1(8,1),COR3(8,3)
      CHARACTER       UFM*23,UWM*25
      COMMON /XMSSG / UFM,UWM
      COMMON /NAMES / RDNRW,RDRW,WRTNRW,WRTRW,KRW,KNRW,KNERW
CWKBR 3/94 SPR93007      COMMON /SYSTEM/ ISBZ,NOUT        
      COMMON /SYSTEM/ ISBZ,NOUT,DUM(52),IPREC  
      COMMON /BLANK / IOPT,IGPT,NSKIP,SKPB(15),CORE(8,4)
      COMMON /UNPAKX/ IUNPR,IUNRW,NUNRW,IUNINC
      COMMON /MPYADX/ MA(7),MB(7),MC(7),MD(7),MZ,MT,MSAB,MSC,MPR,MSCR
      COMMON /EQMK1 / KSCC,KEQIN(8),KPGG,KQG,KCSTM,KLAMA,KOQM,KSCR(7)
     1,               KMPC,KLOAD,KSPC,PARM(4)
CZZ   COMMON /ZZEQMS/ ZZ(1)
      COMMON /ZZZZZZ/ ZZ(20000)
      EQUIVALENCE     (MB(6),FREQ), (CORE(1,1),COR1(1,1),COR3(1,1))
      DATA    NAME  / 4HEQMC,4HKS    /
      DATA    HEAD  / 4HAPPL,4HIED , 4HSPCF,4HORCE,  4HMPCF,4HORCE
     1,               4H---T,4HOTAL  /
C
      PARM(3) = NAME(1)
      PARM(4) = NAME(2)
      NZZ   = KORSZ (ZZ)
      NZZ3  = NZZ  - 3*ISBZ + 1
      NZZ2  = NZZ3 + ISBZ
      NZZ1  = NZZ2 + ISBZ
C
      NVEC  = 0
      MA(1) = KSCR(2)
      MC(1) = 0
      CALL RDTRL (MA)
      MZ    = NZZ
      MT    = 0
      MSAB  = 1
      MSC   = 1
CWKBR 11/93 SPR93007      MPR   = 1
      MPR = IPREC
      MSCR  = KSCR(1)
C
C     CALCULATE  DT*PG  ON SCRATCH7
C
      IF (KLOAD .LE. 0) GO TO 40
      MB(1) = KPGG
      MD(1) = KSCR(7)
      CALL RDTRL (MB)
      MD(3) = MA(3)
      MD(4) = MB(4)
CWKBR 11/93 SPR93007      MD(5) = 1
      MD(5) = IPREC
      CALL MPYAD (ZZ,ZZ,ZZ)
      IF (MD(3) .EQ. MD(2)) MD(4) = 1
      CALL WRTTRL (MD)
      NVEC  = MD(2)
C
C     CALCULATE DT*QG  ON SCRATCH6
C
   40 IF (KSPC .LE. 0) GO TO 50
      MB(1) = KQG
      MD(1) = KSCR(6)
      CALL RDTRL (MB)
      MD(3) = MA(3)
      MD(4) = MB(4)
CWKBR 11/93 SPR93007      MD(5) = 1
      MD(5) = IPREC
      CALL MPYAD (ZZ,ZZ,ZZ)
      IF (MD(3) .EQ. MD(2)) MD(4) = 1
      CALL WRTTRL (MD)
      NVEC = MAX0(NVEC,MD(2))
C
C     CALCULATE  DT*MPC  ON SCRATCH5
C
   50 IF (KMPC .LE. 0) GO TO 60
      MD(1) = KSCR(5)
      MB(1) = KSCR(3)
      CALL RDTRL (MB)
      PARM(2) = MB(1)
      IF (MB(1) .LE. 0) GO TO 520
      MD(3) = MA(3)
      MD(4) = MB(4)
CWKBR 11/93 SPR93007      MD(5) = 1
      MD(5) = IPREC
      CALL MPYAD (ZZ,ZZ,ZZ)
      IF (MD(3) .EQ. MD(2)) MD(4) = 1
      CALL WRTTRL (MD)
      NVEC  = MAX0(MD(2),NVEC)
   60 IF (NVEC .LE. 0) GO TO 400
C
C     POSITION CASE CONTROL
C
      CALL GOPEN (KSCC,ZZ(NZZ1),RDRW)
      IF (NSKIP .GT. 0) GO TO 70
C
C     RESERVE THIRD BUFFER FOR LAMA
C
      IBFL = NZZ3
      PARM(2) = KLAMA
      CALL GOPEN (KLAMA,ZZ(NZZ3),RDRW)
      CALL FWDREC (*510,KLAMA)
      GO TO 90
   70 IBFL = NZZ2
      IF (NSKIP .LE. 1) GO TO 90
C
C     ASSUME USER MAY MALADJUST NSKIP
C
      J = NSKIP - 1
      PARM(2) = KSCC
      DO 80 I = 1,J
   80 CALL FWDREC (*510,KSCC)
C
C     READ INTO CORE AS MANY (MAXVEC) VECTORS THAT FIT
C
   90 NENTRY = 0
      IF (KLOAD .GT. 0) NENTRY = 6
      IF (KMPC  .GT. 0) NENTRY = NENTRY + 6
      IF (KSPC  .GT. 0) NENTRY = NENTRY + 6
C
      MAXVEC = (IBFL-1)/NENTRY
      IF (MAXVEC .GE. NVEC) GO TO 110
C
C     INSUFFICIENT CORE TO DO ALL VECTORS
C
      CALL PAGE2 (2)
      WRITE  (NOUT,100) UWM,MAXVEC,NAME
  100 FORMAT (A25,' 2374, INSUFFICIENT CORE TO PROCESS MORE THAN',I7,
     1       ' VECTORS IN ',2A4)
C
      IF (MAXVEC .LE. 0) GO TO 400
C
  110 MAXVEC = MIN0 (NVEC,MAXVEC)
      L = 1
      MA(1) = 0
      IF (KLOAD .LE. 0) GO TO 160
      PARM(2) = KSCR(7)
      MA(1) = 1
      ASSIGN 160 TO IRET
C
C     INTERNAL FUNCTION TO LOAD MAXVEC COLUMNS INTO CORE
C
  120 CONTINUE
      CALL GOPEN (PARM(2),ZZ(NZZ2),RDRW)
      IUNPR  = 1
      IUNINC = 1
      IUNRW  = 1
      NUNRW  = 6
C
      DO 150 MT = 1,MAXVEC
      CALL UNPACK (*130,PARM(2),ZZ(L))
      GO TO 150
  130 MPR = L - 1
      DO 140 I = 1,6
      MPR = MPR + 1
  140 ZZ(MPR) = 0.0
  150 L = L + 6
C
      CALL CLOSE (PARM(2),KRW)
      GO TO IRET, (160,170,180)
C
  160 MA(2) = 0
      IF (KSPC .LE. 0) GO TO 170
      PARM(2) = KSCR(6)
      MA(2) = L
      ASSIGN 170 TO IRET
      GO TO 120
C
  170 MA(3) = 0
      IF (KMPC .LE. 0) GO TO 180
      PARM(2) = KSCR(5)
      MA(3) = L
      ASSIGN 180 TO IRET
      GO TO 120
C
  180 IVEC = 0
      LSTEIG = .FALSE.
      CALL PAGE1
C
C     LOOP ON OUTPUT
C
  200 CONTINUE
      IVEC = IVEC + 1
      IF (LSTEIG) GO TO 260
      PARM(2) = KSCC
      CALL READ (*250,*500,KSCC,MB(1),7,1,I)
      I = MB(1)
      IF (IVEC.EQ.1 .OR. EJECT(11).NE.0) WRITE (NOUT,210) IGPT
  210 FORMAT (1H0,20X,'E Q U I L I B R I U M   C H E C K   L O A D S',
     1        /,1H0,16X,'RESULTANT LOADS AT POINT',I7,
     2        ' IN BASIC COORDINATE SYSTEM')
      IF (NSKIP .LE. 0) GO TO 260
C
C     STATICS SUBCASES
C
      IF (MB(4) .EQ. 0) MB(4) = MB(7)
      IF (MB(4) .EQ. 0) MB(4) = MB(6)
      WRITE  (NOUT,220) MB(1),MB(4)
  220 FORMAT (1H0,24X,7HSUBCASE,I8,8H,   LOAD,I8)
      WRITE  (NOUT,230)
  230 FORMAT (1H0,5X,46H-TYPE-        T1             T2             T3,
     1   13X,32HR1             R2             R3)
C
  240 FORMAT (5X,2A4,1P,6E15.6)
C
      GO TO 300
C
C     EOF FOUND
C
  250 CONTINUE
      IF (IVEC .GT. MAXVEC) GO TO 400
      IF (NSKIP .GT. 0) GO TO 510
      LSTEIG = .TRUE.
C
C     EIGENVALUE PROBLEM
C
  260 PARM(2) = KLAMA
      CALL READ (*510,*500,KLAMA,MB(2),7,0,I)
      WRITE  (NOUT,270) MB(1),MB(2),FREQ
  270 FORMAT (1H0,24X,7HSUBCASE,I8,8H,   MODE,I5,13H,   FREQUENCY,
     1        1P,E15.6)
      WRITE  (NOUT,230)
C
C     LOOP ON OUTPUT CATAGORY
C
  300 K = NENTRY/6 + 1
      IHDCNT = 1
      DO 310 I = 3,8
  310 CORE(I,K) = 0.0E0
C
      DO 330 I = 1,3
      IF (MA(I) .EQ. 0) GO TO 330
      CORE(1,IHDCNT) = HEAD(1,I)
      CORE(2,IHDCNT) = HEAD(2,I)
      J = MA(I) + IVEC*6 - 6
C
      DO 320 L = 3,8
      CORE(L,IHDCNT) = ZZ(J)
      CORE(L,K) = CORE(L,K) + ZZ(J)
      J = J + 1
  320 CONTINUE
      IHDCNT = IHDCNT + 1
  330 CONTINUE
C
      CORE(1,K) = HEAD(1,4)
      CORE(2,K) = HEAD(2,4)
      IF (K .EQ. 2) WRITE (NOUT,240) COR1
      IF (K .EQ. 3) WRITE (NOUT,240) COR3
      IF (K .EQ. 4) WRITE (NOUT,240) CORE
      IF (IVEC .LT. MAXVEC) GO TO 200
  400 CALL CLOSE (KSCC,KRW)
      IF (NSKIP .LE. 0) CALL CLOSE (KLAMA,KRW)
      RETURN
C
C     ERROR MESSAGES
C
C     EOR
C
  500 PARM(1) = 3
      GO TO 600
C
C     EOF
C
  510 PARM(1) = 2
      GO TO 600
C
C     ILLEGAL INPUT
C
  520 PARM(1) = 1
      GO TO 600
C
  600 CALL MESAGE (PARM(1),PARM(2),PARM(3))
      GO TO 400
      END

      SUBROUTINE SDCOMPX (*,ZI,ZR,ZD)
C
C     SDCOMP PERFORMS THE TRIANGULAR DECOMPOSITION OF A SYMMETRIC
C     MATRIX. THE MATRIX MAY BE REAL OR COMPLEX AND ITS PRECISION MAY
C     BE SNGL OR DBL
C
      EXTERNAL LSHIFT  ,ANDF    ,ORF
      LOGICAL  GO      ,SPILL   ,SPLOUT  ,SPLIN   ,ROWONE
      INTEGER  PRC     ,WORDS   ,RLCMPX  ,CLOS    ,BUF1    ,BUF2    ,
     1         BUF3    ,BUF4    ,BUF5    ,RC      ,PREC    ,TYPEA   ,
     2         ZI(1)   ,CONFIG  ,POWER   ,DBA     ,DBL     ,DBC     ,
     3         SCR1    ,SCR2    ,SYSBUF  ,FORMA   ,SYM     ,SQR     ,
     4         SCRA    ,SCRB    ,C5MAX   ,BLK     ,PCMAX   ,SAVG    ,
     5         NULL(20),COL     ,C       ,S       ,SPROW   ,STURM   ,
     6         GROUPS  ,CAVG    ,CMAX    ,SC      ,PREVC   ,ROW     ,
     7         FRSTPC  ,PCAVG   ,PCROW   ,PCSQR   ,SX      ,CI      ,
     8         SCR3    ,WB      ,SCRC    ,SCRD    ,SPFLG   ,START   ,
     9         WA      ,CHLSKY  ,BEGN    ,END     ,DBNAME(2)        ,
     O         PCGROU  ,ABLK    ,BBLK    ,SUBNAM(5)                 ,
     1         KEY(1)  ,ORF     ,STATFL  ,ANDF    ,TWO24   ,TWO25   ,
     2         MTYPE(2),IREAL(2),ICMPLX(2)
      REAL     ZR(2)   ,SAVE(6) ,MINDS
      DOUBLE PRECISION  ZD(2)   ,MINDD   ,XDNS(1) ,DDR     ,DDC     ,
     1                  RD      ,DSAVE3
      CHARACTER*10      UNUSE   ,ADDI    ,UNADD
      CHARACTER         UFM*23  ,UWM*25  ,UIM*29  ,SFM*25
      COMMON  /XMSSG /  UFM     ,UWM     ,UIM     ,SFM
      COMMON  /SFACT /  DBA(7)  ,DBL(7)  ,DBC(7)  ,SCR1    ,SCR2    ,
     1                  LCORE   ,DDR     ,DDC     ,POWER   ,SCR3    ,
     2                  MINDD   ,CHLSKY
      COMMON  /NTIME /  NITEMS  ,TMIO    ,TMBPAK  ,TMIPAK  ,TMPAK   ,
     1                  TMUPAK  ,TMGSTR  ,TMPSTR  ,TMT(4)  ,TML(4)
      COMMON  /STURMX/  STURM   ,SHFTPT  ,KEEP    ,PTSHFT  ,NR
      COMMON  /SYSTEM/  KSYSTM(63)
      COMMON  /NAMES /  RDNRW   ,RDREW   ,WRT     ,WRTREW  ,REW     ,
     1                  NOREW   ,EOFNRW  ,RSP     ,RDP     ,CSP     ,
     2                  CDP     ,SQR     ,RECT    ,DIAG    ,LOWTRI  ,
     3                  UPRTRI  ,SYM
      COMMON  /TYPE  /  PRC(2)  ,WORDS(4),RLCMPX(4)
      COMMON  /ZZZZZZ/  XNS(1)
      COMMON  /SDCOMX/  ROW     ,C       ,SPFLG   ,START   ,FRSTPC  ,
     1                  LASTPL  ,LASTI   ,SC      ,IAC     ,NZZADR  ,
     2                  WA      ,WB      ,PREVC   ,NZZZ    ,SPROW   ,
     3                  S       ,BLK(15) ,ABLK(15),BBLK(20)
      COMMON  /PACKX /  ITYPE1  ,ITYPE2  ,I1      ,J1      ,INCR1
      COMMON  /UNPAKX/  ITYPE3  ,I2      ,J2      ,INCR2
      EQUIVALENCE       (NROW,DBA(3)) ,(FORMA,DBA(4)) ,(TYPEA,DBA(5) ) ,
     1                  (JSTR,BLK(5)) ,(COL  ,BLK(4)) ,(NTERMS,BLK(6)) ,
     2                  (XDNS(1),XNS(1)),(ROW,KEY(1)) ,(DSR  ,DDR    ) ,
     3                  (RS  ,RD    ) ,(DSC  ,DDC   ) ,(MINDS,MINDD  )
      EQUIVALENCE       (KSYSTM( 1),SYSBUF)  ,(KSYSTM( 2),NOUT       ) ,
     1                  (KSYSTM(28),CONFIG)  ,(KSYSTM(40),NBPW       ) ,
     2                  (KSYSTM(57),STATFL)  ,(DBNAME( 1),SUBNAM(4)  )
      DATA     SUBNAM/  4HSDCO,2HMP,3*1H   / ,
     1         NKEY  /  6 / ,  BEGN/  4HBEGN/ , END   / 4HEND  /      ,
     2         TWO24 /  16777216   /, TWO25 /   33554432       /
      DATA     IREAL ,  ICMPLX     /  4HREAL,   4H    , 4HCOMP, 4HLEX /
      DATA     UNUSE ,  ADDI       / '    UNUSED',    'ADDITIONAL'    /
C
C     STATEMENT FUNCTIONS
C
      NBRWDS(I) = I + NWDS*(I*(I+1))/2
      SX(X)     = X - SQRT(AMAX1(X*(X+2.) + CMAX*4. - CONS, 1.)) - 1.0
      MAXC(J)   = SQRT(FLOAT(2*J)/FNWDS - FLOAT(4*CMAX)) - 1.0
C
C     BUFFER ALLOCATION
C
      SUBNAM(3) = BEGN
      CALL CONMSG (SUBNAM,5,0)
      BUF1 = LCORE- SYSBUF
      BUF2 = BUF1 - SYSBUF
      BUF3 = BUF2 - SYSBUF
      BUF4 = BUF3 - SYSBUF
      BUF5 = BUF4 - SYSBUF
      X    = 1.0
      RKHR = 1.0E-10
C
C     INITIALIZATION AS A FUNCTION OF TYPE OF A MATRIX
C     RC   = 1 IF A IS REAL, 2 IF A IS COMPLEX
C     PREC = 1 IF A IS SINGLE, 2 IF A IS DOUBLE
C     NOTE - PRC(1) = 1, PRC(2) = 2, AND
C            PRC(3) = WORDS(1) = 1, PRC(4) = WORDS(2) = 2
C
      RC = RLCMPX(TYPEA)
      MTYPE(1) = IREAL(1)
      MTYPE(2) = IREAL(2)
      IF (RC .EQ. 1) GO TO 10
      MTYPE(1) = ICMPLX(1)
      MTYPE(2) = ICMPLX(2)
   10 PREC  = PRC(TYPEA)
      NWDS  = WORDS(TYPEA)
      FNWDS = NWDS
      STURM = 0
C
C     CHECK INPUT PARAMETERS
C
      IF (DBA(2) .NE. DBA(3)) GO TO 2300
      ICRQ = 100 - BUF5
      IF (BUF5 .LT. 100) GO TO 2310
      IF (NROW .EQ.   1) GO TO 1900
C
C     GENERAL INITIALIZATION
C
      LOOP   = 1
      ISPILL = BUF5 - MAX0(100,NROW/100)
      FCMAX  = 0.
   20 ISPILL = ISPILL - (LOOP-1)*NROW/100
      NSPILL = ISPILL
      KROW   = NROW + 1
      ICRQ   =-ISPILL
      IF (ISPILL .LE. 0) GO TO 2310
      ZI(ISPILL) = 0
      PCGROU = 0
      PCAVG  = 0
      PCSQR  = 0
      PCMAX  = 0
      CSQR   = 0.0
      SAVG   = 0
      CLOS   = ALOG(FLOAT(NROW)) + 5.0
      CLOS   = 999999
      PCROW  = -CLOS
      ZI(1)  = -NROW
      ICRQ   = NROW - BUF5
      IF (NROW .GE. BUF5) GO TO 2310
      DO 30 I = 2,NROW
   30 ZI(I)  = 0
      CALL FNAME (DBA,DBNAME)
      POWER  = 0
      SCRA   = SCR3
      SCRB   = IABS(DBC(1))
      GO     =.TRUE.
      SPILL  =.FALSE.
      TIME   = 0.
      GROUPS = 0
      CMAX   = 0
      CONS   = 2*ISPILL/NWDS
      C5MAX  = MAXC(ISPILL)
      DSR    = 1.0
      DSC    = 0.
      MINDS  = 1.E+25
      IF (PREC .EQ. 1) GO TO 40
      DDR    = 1.0
      DDC    = 0.D0
      MINDD  = 1.D+25
   40 CONTINUE
      CAVG   = 0
      CSPILL = 0.
C
C     THE FOLLOWING CODE GENERATES THE ACTIVE COLUMN VECTOR FOR EACH
C     ROW, SPILL GROUPS AND TIMING AND USER INFORMATION ABOUT THE
C     DECOMPOSITION
C
      BLK(1)  = DBA(1)
      ABLK(1) = SCRA
      ABLK(2) = TYPEA
      ABLK(3) = 0
      CALL GOPEN ( DBA,ZI(BUF1),RDREW)
      CALL GOPEN (SCRA,ZI(BUF2),WRTREW)
      JLIST = 1
      ROW   = 1
      JJ    = 0
      KK    = 0
      NLIST = 0
C
C     BEGIN A ROW BY LOCATING THE DIAGONAL ELEMENT
C
   50 BLK(8) = -1
      KR = KROW
   60 CALL GETSTR (*70,BLK)
      IF (PREC .EQ. 2) JSTR = 2*(JSTR-1) + 1
      IF (COL .GT. ROW) GO TO 70
      IF (COL+NTERMS-1 .GE. ROW) GO TO 90
      CALL ENDGET (BLK)
      GO TO 60
   70 KK = KK + 1
      ZI(KK) = ROW
      GO = .FALSE.
   80 IF (BLK(8) .NE. 1) CALL SKPREC (BLK,1)
      ROW = ROW + 1
      IF (ROW .LE. NROW) GO TO 50
      GO TO 600
C
C     DIAGONAL TERM IS LOCATED - COMPLETE ENTRIES IN THE FULL COLUMN
C     VECTOR AND SAVE THE TERMS FROM EACH STRING IN CORE
C
   90 IF (.NOT. GO) GO TO 80
      JSTR   = JSTR + (ROW-COL)*NWDS
      NTERMS = NTERMS - (ROW-COL)
      COL  = ROW
  100 ZI(KR  ) = COL
      ZI(KR+1) = NTERMS
      KR   = KR + 2
      NSTR = JSTR + NTERMS*NWDS - 1
      DO 110 JJ = JSTR,NSTR
      ZR(KR) = XNS(JJ)
      KR = KR + 1
  110 CONTINUE
      N = COL + NTERMS - 1
      DO 170 J = COL,N
      IF (ZI(J)) 120,130,160
  120 M = IABS(ZI(J))
      ZI(J) = ROW
      IF (M .NE. 1) ZI(J+1) = -(M-1)
      GO TO 170
  130 I = J
  140 I = I - 1
      IF (I .LE. 0) GO TO 2000
      IF (ZI(I)) 150,140,2010
  150 M = IABS(ZI(I))
      ZI(I) = -(J-I)
      ZI(J) = ROW
      LEFT  = M - (J-I+1)
      IF (LEFT .GT. 0) ZI(J+1) = -LEFT
      GO TO 170
  160 IF (ZI(J).GT.ROW .AND. ZI(J).LT.TWO24) ZI(J) = ZI(J) +TWO24 +TWO25
  170 CONTINUE
      ICRQ = KR - ISPILL
      IF (KR .GE. ISPILL) GO TO 2310
      CALL ENDGET (BLK)
      CALL GETSTR (*180,BLK)
      IF (PREC .EQ. 2) JSTR = 2*JSTR - 1
      GO TO 100
C
C     EXTRACT ACTIVE COLUMN VECTOR FROM THE FULL COLUMN VECTOR
C
  180 IAC = KR
      I   = IAC
      J   = ROW
      LASTPL = -1
  190 IF (ZI(J)    ) 260,2020,200
  200 IF (ZI(J)-ROW) 210,220,250
  210 ZI(I) = J
      GO TO 230
  220 ZI(I) = -J
      IF (LASTPL .LT. 0) LASTPL = I - IAC
  230 I = I + 1
  240 J = J + 1
      GO TO 270
  250 IF (ZI(J) .LT. TWO24) GO TO 240
      IF (ZI(J) .LT. TWO25) GO TO 210
      ZI(J) = ZI(J) - TWO25
      GO TO 220
  260 J = J - ZI(J)
  270 IF (J .LE. NROW) GO TO 190
      ICRQ = I - ISPILL
      IF (I .GT. ISPILL) GO TO 2310
      C = I - IAC
      CMAX  = MAX0(CMAX,C)
      C5MAX = MAXC(ISPILL)
      NAC   = IAC + C - 1
      IF (LASTPL .LT. 0) LASTPL = C
C
C     MAKE SPILL CALCULATIONS
C
      SPFLG = 0
      FC    = C
      START = 2
      IF (C .EQ. 1) START = 0
      FRSTPC = 0
      IF (.NOT.SPILL) GO TO 370
      IF (ROW .LT. LSTROW) GO TO 290
C
C     *3* CURRENT ROW IS LAST ROW OF A SPILL GROUP. DETERMINE IF ANOTHER
C         SPILL GROUP FOLLOWS AND, IF SO, ITS RANGE
C
  280 CONTINUE
      START = 0
      IF (C .GT. C5MAX) GO TO 380
      SPILL = .FALSE.
      GO TO 420
C
C     *2* CURRENT ROW IS NEITHER FIRST NOR LAST IN CURRENT SPILL GROUP.
C         TEST FOR PASSIVE COL CONDITION. IF SO, TERMINATE SPILL GROUP.
C         TEST FOR POSSIBLE REDEFINITION OF SPILL GROUP. IF SO, TEST FOR
C         OVERFLOW OF REDEFINITION TABLE,  IF SO, TRY A DIFFERENT
C         STRATEGY FOR DEFINING S AND REDO PREFACE UP TO A LIMIT OF 3
C         TIMES.
C
  290 CONTINUE
      IF (IABS(ZI(IAC+1))-ROW .LT. CLOS) GO TO 300
      ASSIGN 430 TO ISWTCH
      LSTROW = ROW
      SPILL  = .FALSE.
      START  = 0
      IF (NSPILL+2 .LT. BUF5) GO TO 350
      GO TO 330
  300 ASSIGN 460 TO ISWTCH
      IF (C .LE. ZI(SPROW)) GO TO 460
      JJ = NAC
  310 IF (IABS(ZI(JJ)) .LE. LSTROW) GO TO 320
      JJ = JJ - 1
      GO TO 310
  320 SC = JJ - IAC
      M  = SX(FC)
      IF (SC .LE. M) GO TO 460
      IF (NSPILL+2 .LT. BUF5) GO TO 340
  330 CONTINUE
      FCMAX = AMAX1(FCMAX,FLOAT(CMAX))
      CALL CLOSE (SCRA,REW)
      CALL CLOSE ( DBA,REW)
      LOOP = LOOP + 1
      IF (LOOP .LE. 3) GO TO 20
      ICRQ = BUF5 - NSPILL - 2
      GO TO 2310
  340 S = M
      IJKL =  MAX0(IAC,JJ-(SC-M))
      LSTROW = IABS(ZI(IJKL))
  350 IF (ZI(NSPILL).NE.0 .AND. ZI(NSPILL).NE.SPROW) NSPILL = NSPILL + 3
      ZI(NSPILL  ) = SPROW
      ZI(NSPILL+1) = S
      ZI(NSPILL+2) = LSTROW
      IF (ROW- LSTROW) 360,280,2070
  360 CONTINUE
      GO TO ISWTCH, (430,460)
C
C     *1* CURRENT ROW IS NOT PART OF A SPILL GROUP. TEST FOR CREATION OF
C         A NEW SPILL GROUP
C
  370 CONTINUE
      IF (C .LE. C5MAX) GO TO 420
  380 SPILL  = .TRUE.
      SPROW  = ROW
      GROUPS = GROUPS + 1
      S  = MIN0(SX(FC),NROW-SPROW)
      IF (LOOP .EQ. 1) GO TO 410
      JJ = IAC + S - 1
  390 IF (IABS(ZI(JJ)) .LE. SPROW+S) GO TO 400
      JJ = JJ - 1
      GO TO 390
  400 S  = JJ - IAC + 1
      IF (LOOP .EQ. 3) S = MIN0(S,SX(FCMAX))
  410 S  = MIN0(S,NROW-SPROW)
      LSTROW = IABS(ZI(IAC+S-1))
      SPFLG  = S
      FRSTPC = LSTROW
      SAVG   = SAVG + S
      GO TO 460
C
C     TEST FOR CONDITION IN WHICH PASSIVE COLUMNS ARE CREATED
C
  420 COL = IABS(ZI(IAC+1))
      IF (ROW-PCROW.LT.CLOS .OR. C.LT.CLOS/2 .OR. COL-ROW.LT.CLOS)
     1    GO TO 460
C
C     CREATE PASSIVE COLUMNS BY CHANGING THEIR FIRST
C     APPEARANCE IN THE FULL COLUMN VECTOR
C
  430 FRSTPC = 2
      PCROW  = ROW
      PCAVG  = PCAVG + C - 1
      PCSQR  = PCSQR + (C-1)**2
      PCMAX  = MAX0(PCMAX,C-1)
      PCGROU = PCGROU + 1
      NAC    = IAC + C - 1
      IJKL   = IAC + 1
      DO 450 I = IJKL,NAC
      JJ     = IABS(ZI(I))
      IF (ZI(JJ) .LE. ROW) GO TO 440
      ZI(JJ) = MIN0(ANDF(ZI(JJ),TWO24-1),COL)
      GO TO 450
  440 ZI(JJ) = COL
  450 CONTINUE
C
C     WRITE ACTIVE COLUMN VECTOR
C
  460 CONTINUE
      CALL WRITE (SCRA,KEY,NKEY,0)
      CALL WRITE (SCRA,ZI(IAC),C,1)
C
C     WRITE ROW OF INPUT MATRIX
C
      ABLK( 8) = -1
      ABLK(12) = ROW
      KR = KROW
  470 ABLK(4) = ZI(KR  )
      NBRSTR  = ZI(KR+1)
      KR = KR + 2
  480 CALL PUTSTR (ABLK)
      ABLK(7) = MIN0(ABLK(6),NBRSTR)
      JSTR = ABLK(5)
      IF (PREC .EQ. 2) JSTR = 2*JSTR - 1
      NSTR = JSTR + ABLK(7)*NWDS - 1
      DO 490 JJ = JSTR,NSTR
      XNS(JJ) = ZR(KR)
      KR = KR + 1
  490 CONTINUE
      IF (KR .GE. IAC) GO TO 500
      CALL ENDPUT (ABLK)
      IF (ABLK(7) .EQ. NBRSTR) GO TO 470
      ABLK(4) = ABLK(4) + ABLK(7)
      NBRSTR  = NBRSTR  - ABLK(7)
      GO TO 480
  500 ABLK(8) = 1
      CALL ENDPUT (ABLK)
C
C     ACCUMULATE TIMING AND STATISTICS INFORMATION
C
      CAVG = CAVG + C
      CSQR = CSQR + C**2
      IF (SPILL) CSPILL = CSPILL + C**2
      ZI(ROW) = C
      IF (ROW .EQ. NROW) GO TO 600
      ROW = ROW + 1
      GO TO 50
C
C     HERE WHEN ALL ROWS PROCESSED - CLOSE FILES AND, IF SINGULAR
C     MATRIX, PRINT SINGULAR COLUMNS AND GIVE ALTERNATE RETURN
C
  600 CALL CLOSE (SCRA,REW)
      CALL CLOSE ( DBA,REW)
      IF (GO) GO TO 620
      CALL CLOSE (DBL,REW)
      CALL PAGE2 (3)
      WRITE  (NOUT,610) UFM,DBNAME,(ZI(I),I=1,KK)
  610 FORMAT (A23,' 3097. SYMMETRIC DECOMPOSITION OF DATA BLOCK ',2A4,
     1       ' ABORTED BECAUSE THE FOLLOWING COLUMNS ARE SINGULAR -',
     2       /,(5X,20I6,/))
      RETURN 1
C
C     CALCULATE TIME ESTIMATE, PRINT USER INFORMATION AND
C     CHECK FOR SUFFICIENT TIME TO COMPLETE DECOMPOSITION
C
  620 DENS  = FLOAT(DBA(7))/10000.
      IF (DENS .LT.  0.01) DENS =  0.01
      IF (DENS .GT. 99.99) DENS = 99.99
      IF (GROUPS .NE.  0) SAVG = SAVG/GROUPS
      SAVG  = MAX0(SAVG,1)
      TIME  = 0.5*TMT(TYPEA)*CSQR + 0.5*(TMPSTR+TMGSTR)*FLOAT(PCSQR) +
     1        TMPSTR*FLOAT(CAVG)  + TMIO*(FNWDS+1.0)*CSPILL/FLOAT(SAVG)
      MORCOR= NBRWDS(CMAX) - ISPILL + 1
C
      CAVG  = CAVG/NROW
      IF (PCGROU .NE. 0) PCAVG = PCAVG/PCGROU
      CALL TMTOGO (IJKL)
      JKLM  = 1.E-6*TIME + 1.0
      ICORE = IABS(MORCOR)
      IF (DBC(1) .LE. 0) GO TO 645
      UNADD = UNUSE
      IF (MORCOR .GT. 0) UNADD = ADDI
      CALL PAGE2 (4)
      WRITE (NOUT,630,ERR=645) UIM, MTYPE, DBNAME, NROW,   DENS,
     1                        JKLM, CAVG,   PCAVG, GROUPS, SAVG,
     2                UNADD, ICORE, CMAX,   PCMAX, PCGROU, LOOP
  630 FORMAT (A29,' 3023 - PARAMETERS FOR ',2A4,
     1        ' SYMMETRIC DECOMPOSITION OF DATA BLOCK ',2A4,
     2         5H (N =,I6, 5H, D =,F6.2,2H%), /14X,
     3        17H  TIME ESTIMATE = , I7, 17H          C AVG = , I6,
     4        17H         PC AVG = , I6,18H    SPILL GROUPS = , I6,
     5        17H          S AVG = , I6,      /14X,
     6        A10 ,      7H CORE = , I9,   15H WORDS  C MAX = , I6,
     7        17H          PCMAX = , I6,18H       PC GROUPS = , I6,
     8        17H  PREFACE LOOPS = , I6 )
      IF (MORCOR .GT. 0) WRITE (NOUT,640)
  640 FORMAT (14X,'(FOR OPTIMAL OPERATION)')
  645 IF (JKLM .GE. IJKL) GO TO 2320
C
C     WRITE A END-OF-MATRIX STRING ON THE PASSIVE COLUMN FILE
C
      CALL GOPEN (SCRB,ZI(BUF2),WRTREW)
      BBLK(1) = SCRB
      BBLK(2) = TYPEA
      BBLK(3) = 0
      BBLK(8) =-1
      BBLK(12)= 1
      CALL PUTSTR(BBLK)
      BBLK(4) = NROW + 1
      BBLK(7) = 1
      BBLK(8) = 1
      CALL ENDPUT (BBLK)
      CALL CLOSE  (SCRB,REW)
C
C     THE STAGE IS SET AT LAST TO PERFORM THE DECOMPOSITION -
C     SO LETS GET THE SHOW UNDERWAY
C
      CALL GOPEN (SCRA,ZI(BUF1),RDREW )
      CALL GOPEN (SCRB,ZI(BUF2),RDREW )
      CALL GOPEN (DBL ,ZI(BUF3),WRTREW)
      SCRC   = SCR1
      SCRD   = SCR2
      IF (ZI(NSPILL) .NE. 0) NSPILL = NSPILL + 3
      ZI(NSPILL) = NROW + 1
      SPLIN  = .FALSE.
      SPLOUT = .FALSE.
      SPILL  = .FALSE.
      IF (GROUPS .NE. 0) SPILL = .TRUE.
      NZZZ   = ORF(ISPILL-1,1)
      ROWONE = .FALSE.
      DBL(2) = 0
      DBL(6) = 0
      DBL(7) = LSHIFT(1,NBPW-2 - (NBPW-32))
C
C     THIS 'NEXT TO SIGN' BIT WILL BE PICKED UP BY WRTTRL. ADD (NBPW-32)
C     SO THAT CRAY, WITH 48-BIT INTEGER, WILL NOT GET INTO TROUBLE
C
      BLK(1) = DBL(1)
      BLK(2) = TYPEA
      BLK(3) = 1
      WA     = NZZZ
      WB     = WA
      PREVC  = 0
      BBLK(8)= -1
      CALL GETSTR (*2080,BBLK)
      KSPILL = ISPILL
C
C     READ KEY WORDS AND ACTIVE COLUMN VECTOR FOR CURRENT ROW
C
  650 NAME = SCRA
      IF (SPLIN) NAME = SCRD
      CALL FREAD (NAME,KEY,NKEY,0)
      IAC = C*NWDS + 1
      CALL FREAD (NAME,ZI(IAC),C,1)
      NAC = IAC + C - 1
      IF (ZI(IAC) .LT. 0) PREVC = 0
      IF (SPLIN) GO TO 700
C
C     READ TERMS FROM THE INPUT MATRIX
C
      ABLK(8) = -1
      CALL GETSTR (*2090,ABLK)
      N = IAC - 1
      DO 670 I = 1,N
      ZR(I) = 0.
  670 CONTINUE
      CALL SDCIN (ABLK,ZI(IAC),C,ZR,ZR)
C
C     IF DEFINED, MERGE ROW FROM PASSIVE COLUMN FILE
C
  680 IF (ROW-BBLK(4)) 710,690,2100
  690 CALL SDCIN (BBLK,ZI(IAC),C,ZR,ZR)
      BBLK(8) = -1
      CALL GETSTR (*2110,BBLK)
      GO TO 680
C
C     READ CURRENT PIVOT ROW FROM SPILL FILE. IF LAST ROW, CLOSE FILE
C
  700 PREVC = 0
      CALL FREAD (SCRD,ZR,C*NWDS,1)
      IF (ROW .LT. LSTSPL) GO TO 710
      CALL CLOSE (SCRD,REW)
C
C     IF 1ST ROW OF A NEW SPILL GROUP, OPEN SCRATCH FILE TO WRITE
C
  710 IF (ROWONE) GO TO 740
      IF (SPLOUT) GO TO 810
      IF (SPFLG .EQ. 0) GO TO 810
      SPLOUT = .TRUE.
      CALL GOPEN (SCRC,ZI(BUF4),WRTREW)
      SPROW  = ROW
      S      = SPFLG
      LSTROW = FRSTPC
      FRSTPC = 0
C
C     IF S WAS REDEFINED, GET NEW DEFINITION
C
      DO 720 I = KSPILL,NSPILL,3
      IF (ROW-ZI(I)) 740,730,720
  720 CONTINUE
      GO TO 740
  730 S = ZI(I+1)
      LSTROW = ZI(I+2)
      KSPILL = I + 3
C
C     WRITE ANY TERMS ALREADY CALCULATED WHICH ARE
C     BEYOND THE RANGE OF THE CURRENT SPILL GROUP
C
  740 IF (.NOT.SPLOUT) GO TO 810
      N    = 0
      IJKL = NAC
  750 IF (IABS(ZI(IJKL)) .LE. LSTROW) GO TO 760
      IJKL = IJKL - 1
      GO TO 750
  760 IJKL = IJKL + 1
      IF (IJKL .GT. NAC) GO TO 780
      DO 770 I = IJKL,NAC
      IF (ZI(I) .GT. 0.) N = N + 1
  770 CONTINUE
      N = NWDS*N*(N+1)/2
  780 CALL WRITE (SCRC,N,1,0)
      CALL WRITE (SCRC,ZR(NZZZ-N),N,1)
C
C     MOVE WA TO ACCOUNT FOR ANY TERMS JUST WRITTEN
C
      IF (N .EQ. 0) GO TO 810
      J = NZZZ
      I = NZZZ - N
      IF (NZZZ-WA .EQ. N) GO TO 800
  790 J = J - 1
      I = I - 1
      ZR(J) = ZR(I)
      IF (I .GT. WA) GO TO 790
  800 WA = J
C
C     IF THE PIVOTAL ROW DID NOT COME FROM THE SPILL FILE, IT IS CREATED
C
  810 IF (SPLIN) GO TO 1110
      I = IAC
      L = WA
      IF (PREC .EQ. 2) L = (WA-1)/2 + 1
      GO TO (820,890,960,1030), TYPEA
C
C     CREATE PIVOT ROW IN RSP, ACCUMULATE DETERMINANT AND MIN DIAGONAL
C
  820 CONTINUE
      IF (ZI(IAC) .LT. 0) GO TO 850
      DO 840 J = 1,C
      IF (ZI(I) .LT. 0) GO TO 830
      ZR(J) = ZR(J) + ZR(L)
      L = L + 1
  830 I = I + 1
  840 CONTINUE
  850 CONTINUE
      ASSIGN 860 TO KHR
      IF (ZR(1)) 860,1820,860
  860 IF (ABS(DSR) .LT. 10.) GO TO 870
      DSR   = DSR/10.
      POWER = POWER + 1
      GO TO 860
  870 IF (ABS(DSR) .GT. 0.1) GO TO 880
      DSR   = DSR*10.
      POWER = POWER - 1
      GO TO 870
  880 DSR   = DSR*ZR(1)
      MINDS = AMIN1(ABS(ZR(1)),MINDS)
C
C     COUNTING SIGN CHANGES OF THE LEADING PRINCIPLE MINORS IN STURM
C     SEQ.
C
      IF (ZR(1) .LT. 0.) STURM = STURM + 1
      GO TO 1100
C
C     CREATE PIVOT ROW IN RDP, ACCUMULATE DETERMINANT AND MIN DIAGONAL
C
  890 CONTINUE
      IF (ZI(IAC) .LT. 0) GO TO 920
      DO 910 J = 1,C
      IF (ZI(I) .LT. 0) GO TO 900
      ZD(J) = ZD(J) + ZD(L)
      L = L + 1
  900 I = I + 1
  910 CONTINUE
  920 CONTINUE
      ASSIGN 930 TO KHR
      IF (ZD(1)) 930,1820,930
  930 IF (DABS(DDR) .LT. 10.0D0) GO TO 940
      DDR   = DDR/10.D0
      POWER = POWER + 1
      GO TO 930
  940 IF (DABS(DDR) .GT. 0.1D0) GO TO 950
      DDR   = DDR*10.D0
      POWER = POWER - 1
      GO TO 940
  950 DDR   = DDR*ZD(1)
      MINDD = DMIN1(DABS(ZD(1)),MINDD)
C
C     COUNTING SIGN CHANGES (STURM SEQUENCE PROPERTY)
C
      IF (ZD(1) .LT. 0.D0) STURM = STURM + 1
      GO TO 1100
C
C     CREATE PIVOT ROW IN CSP, ACCUMULATE DETERMINANT AND MIN DIAGONAL
C
  960 CONTINUE
      IF (ZI(IAC) .LT. 0) GO TO 990
      CI = 2*C - 1
      DO 980 J = 1,CI,2
      IF (ZI(I) .LT. 0) GO TO 970
      ZR(J  ) = ZR(J  ) + ZR(L  )
      ZR(J+1) = ZR(J+1) + ZR(L+1)
      L = L + 2
  970 I = I + 1
  980 CONTINUE
  990 CONTINUE
      SAVE(3) = SQRT(ZR(1)**2 + ZR(2)**2)
      IF (SAVE(3)) 1000,1840,1000
 1000 IF (SQRT(DSR**2+DSC**2) .LT. 10.) GO TO 1010
      DSR = DSR/10.
      DSC = DSC/10.
      POWER = POWER + 1
      GO TO 1000
 1010 IF (SQRT(DSR**2+DSC**2) .GT. 0.1) GO TO 1020
      DSR = DSR*10.
      DSC = DSC*10.
      POWER = POWER - 1
      GO TO 1010
 1020 RS  = DSR*ZR(1) - DSC*ZR(2)
      DSC = DSR*ZR(2) + DSC*ZR(1)
      DRR = RS
      MINDS = AMIN1(SAVE(3),MINDS)
      GO TO 1100
C
C     CREATE PIVOT ROW IN CDP, ACCUMULATE DETERMINANT AND MIN DIAGONAL
C
 1030 CONTINUE
      IF (ZI(IAC) .LT. 0) GO TO 1060
      CI = 2*C - 1
      DO 1050 J = 1,CI,2
      IF (ZI(I) .LT. 0) GO TO 1040
      ZD(J  ) = ZD(J  ) + ZD(L  )
      ZD(J+1) = ZD(J+1) + ZD(L+1)
      L = L + 2
 1040 I = I + 1
 1050 CONTINUE
 1060 CONTINUE
C
C     IN COMPARING THE SOURCE CODES HERE FOR CSP AND CDP COMPUTATION,
C     IT IS DECIDED TO CHANGE THE ORIGINAL LINES (COMMENTED OUT) TO THE
C     NEW LINES USING DSAVE3 INSTEAD OF RD       BY G.CHAN/UNISYS, 8/84
C
      DSAVE3 = DSQRT(ZD(1)**2 + ZD(2)**2)
      IF (DSAVE3) 1070,1840,1070
 1070 IF (DSQRT(DDR**2+DDC**2) .LT. 10.D0) GO TO 1080
      DDR   = DDR/10.D0
      DDC   = DDC/10.D0
      POWER = POWER + 1
      GO TO 1070
 1080 IF (DSQRT(DDR**2+DDC**2) .GT. 0.1D0) GO TO 1090
      DDR   = DDR*10.D0
      DDC   = DDC*10.D0
      POWER = POWER - 1
      GO TO 1080
 1090 RD    = DDR*ZD(1) - DDC*ZD(2)
      DDC   = DDR*ZD(2) + DDC*ZD(1)
      DDR   = RD
      MINDD = DMIN1(DSAVE3,MINDD)
C
C     CALCULATE WB
C
 1100 CONTINUE
 1110 LASTI = 1
      IF (START .EQ. 0) GO TO 1250
      IF (SPLIN ) GO TO 1120
      IF (SPLOUT) GO TO 1130
      CI = C
      SC = C
      GO TO 1160
 1120 CI = C - (START-2)
      SC = CI
      JJ = NAC
      IF (SPLOUT) GO TO 1140
      IF ((CI*(CI+1)+2*C)*NWDS/2+C .GT. NZZZ) GO TO 2120
      GO TO 1160
 1130 CI = C
      SC = LSTROW - SPROW
      JJ = MIN0(NAC,IAC+START+SC-2)
 1140 IF (IABS(ZI(JJ)) .LE. LSTROW) GO TO 1150
      JJ = JJ - 1
      GO TO 1140
 1150 SC = JJ - IAC - START + 2
      IF (SC .GT. 0) GO TO 1160
      SC = 0
      WB = WA
      GO TO 1180
 1160 NTERMS = SC*(CI-1) - (SC*(SC-1))/2
      NWORDS = NTERMS*NWDS
      WB = NZZZ - NWORDS
      IF (PREC .EQ. 2) WB = ORF(WB-1,1)
      IF (WB .LT. IAC+C) GO TO 2060
      IF (WB .GT. WA+NWDS*PREVC) GO TO 2130
 1180 CONTINUE
      IF (SPLIN .AND. ROW.EQ.LSTSPL) SPLIN = .FALSE.
      LASTI = MIN0(START+SC-1,C)
      IF (SC .EQ. 0) GO TO 1250
C
C     NOW CALCULATE CONTRIBUTIONS FROM CURRENT PIVOT ROW TO SECOND TERM
C     IN EQUATION (4) IN MEMO CWM-19. NOTE-TERMS ARE CALCULATED ONLY
C     FOR ROW/COL COMBINATIONS IN THE CURRENT SPILL GROUP
C
      GO TO (1210,1220,1230,1240), TYPEA
 1210 CALL SDCOM1 (ZI,ZI(IAC),ZR(WA+  PREVC),ZR(WB))
      GO TO 1250
 1220 CALL SDCOM2 (ZI,ZI(IAC),ZR(WA+2*PREVC),ZR(WB))
      GO TO 1250
 1230 CALL SDCOM3 (ZI,ZI(IAC),ZR(WA+2*PREVC),ZR(WB))
      GO TO 1250
 1240 CALL SDCOM4 (ZI,ZI(IAC),ZR(WA+4*PREVC),ZR(WB))
C
C     SHIP PIVOT ROW OUT TO EITHER MATRIX OR SPILL FILE
C
 1250 IF (LASTI .EQ. C) GO TO 1290
      IF (.NOT. SPLOUT) GO TO 2030
C
C     PIVOT ROW GOES TO SPILL FILE - SET INDEX WHERE TO BEGIN NEXT AND
C     WRITE ROW AND ACTIVE COLUMNN VECTOR
C
      IJKL   = SPFLG
      II     = FRSTPC
      SPFLG  = 0
      FRSTPC = 0
      START  = LASTI + 1
      CALL WRITE (SCRC,KEY,NKEY, 0)
      CALL WRITE (SCRC,ZI(IAC),C,1)
      CALL WRITE (SCRC,ZR,C*NWDS,1)
      IF (ROW .LT. LSTROW) GO TO 1440
C
C     LAST ROW OF CURRENT SPILL GROUP - REWIND FILE AND OPEN IT TO READ.
C     IF ANOTHER SPILL GROUP, SET IT UP
C
      CALL CLOSE (SCRC,REW)
      JKLM   = SCRC
      SCRC   = SCRD
      SCRD   = JKLM
      CALL GOPEN (SCRD,ZI(BUF5),RDREW)
      LSTSPL = ROW
      SPLIN  =.TRUE.
      SPLOUT =.FALSE.
      IF (IJKL .EQ. 0) GO TO 1280
      SPLOUT =.TRUE.
      SPROW  = ROW
      S      = IJKL
      LSTROW = II
      CALL GOPEN (SCRC,ZI(BUF4),WRTREW)
C
C     IF S WAS REDEFINED, GET NEW DEFINITION
C
      DO 1260 I = KSPILL,NSPILL,3
      IF (ROW-ZI(I)) 1280,1270,1260
 1260 CONTINUE
      GO TO 1280
 1270 S = ZI(I+1)
      LSTROW = ZI(I+2)
      KSPILL = I + 3
C
C     READ ANY TERMS SAVED FROM PREVIOUS SPILL GROUP
C
 1280 IF (ROW .EQ. NROW) GO TO 1500
      CALL FREAD (SCRD,N,1,0)
      WA = NZZZ - N
      CALL FREAD (SCRD,ZR(WA),N,1)
      ROWONE = .TRUE.
      GO TO 650
C
C     PIVOT ROW GOES TO OUTPUT FILE - IF REQUIRED, CONVERT TO CHOLESKY
C
 1290 IF (ROW .NE. DBL(2)+1) GO TO 2040
      IF (CHLSKY .EQ. 0) GO TO 1340
      IF (RC     .EQ. 2) GO TO 2050
      IF (PREC   .EQ. 2) GO TO 1320
      IF (ZR(1) .LT. 0.) GO TO 1800
      ZR(1) = SQRT(ZR(1))
      IF (C .EQ. 1) GO TO 1340
      DO 1310 I = 2,C
      ZR(I) = ZR(I)*ZR(1)
 1310 CONTINUE
      GO TO 1340
 1320 IF (ZD(1) .LT. 0.0D+0) GO TO 1800
      ZD(1) = DSQRT(ZD(1))
      IF (C .EQ. 1) GO TO 1340
      DO 1330 I = 2,C
      ZD(I) = ZD(I)*ZD(1)
 1330 CONTINUE
C
C     WRITE THE ROW WITH PUTSTR/ENDPUT
C
 1340 CALL SDCOUT (BLK,0,ZI(IAC),C,ZR,ZR)
C
C     IF ACTIVE COLUMNS ARE NOW GOING PASSIVE, MERGE ROWS IN CORE
C     WITH THOSE NOW ON THE PC FILE THUS CREATING A NEW PC FILE
C
      IF (FRSTPC .EQ. 0) GO TO 1430
      IF (SPLIN .OR. SPLOUT) GO TO 2140
      CALL GOPEN (SCRC,ZI(BUF4),WRTREW)
      BLK(1) = SCRC
      BLK(3) = 0
      IJKL = IAC + 1
      DO 1390 I = IJKL,NAC
 1360 IF (IABS(ZI(I)) .LE. BBLK(4)) GO TO 1380
      CALL CPYSTR (BBLK,BLK,1,0)
      BBLK(8) = -1
      CALL GETSTR (*2150,BBLK)
      GO TO 1360
 1380 CI = NAC - I + 1
      CALL SDCOUT (BLK,0,ZI(I),CI,ZR(WB),ZR(WB))
      WB = WB + CI*NWDS
 1390 CONTINUE
      ICRQ = WB - ISPILL
      IF (WB .GT. ISPILL) GO TO 2310
 1400 CALL CPYSTR (BBLK,BLK,1,0)
      IF (BBLK(4) .EQ. NROW+1) GO TO 1410
      BBLK(8) = -1
      CALL GETSTR (*2160,BBLK)
      GO TO 1400
 1410 CALL CLOSE (SCRB,REW)
      CALL CLOSE (SCRC,REW)
      I = SCRB
      SCRB = SCRC
      SCRC = I
      CALL GOPEN (SCRB,ZI(BUF2),RDREW)
      BBLK(1) = SCRB
      BBLK(8) = -1
      CALL GETSTR (*2170,BBLK)
      BLK(1) = DBL(1)
      BLK(3) = 1
C
C     ACCUMULATE MCB INFORMATION FOR PIVOT ROW
C
 1430 CONTINUE
      NWORDS = C*NWDS
      DBL(2) = DBL(2) + 1
      DBL(6) = MAX0(DBL(6),NWORDS)
      DBL(7) = DBL(7) + NWORDS
C
C     PREPARE TO PROCESS NEXT ROW.
C
 1440 IF (ROW .EQ. NROW) GO TO 1500
      PREVC  = C - 1
      ROWONE = .FALSE.
      WA = WB
      GO TO 650
C
C     CLOSE FILES AND PUT END MESSAGE IN RUN LOG.
C
 1500 SUBNAM(3) = END
      CALL CONMSG (SUBNAM,5,0)
      CALL CLOSE (SCRA,REW)
      CALL CLOSE (SCRB,REW)
      CALL CLOSE ( DBL,REW)
C
C     PRINT ROOTS INFORMATION IF THIS IS EIGENVALUE PROBLEM, AND KEEP
C     TWO LARGEST SHIFT POINT DATA IF SEVERAL SHIFT POINT MOVINGS ARE
C     INVOLVED.
C
      IF (SHFTPT .GT. 0.) WRITE (NOUT,1510) STURM,SHFTPT
 1510 FORMAT (20X,I5,13H ROOTS BELOW ,1P,E14.6)
      IF (STURM .NE. 0) GO TO 1520
      IF (KEEP  .LE. 0) GO TO 1530
      STURM  = KEEP
      SHFTPT = PTSHFT
      GO TO 1530
 1520 IF (KEEP .GT. STURM) GO TO 1530
      JJ     = KEEP
      RS     = PTSHFT
      KEEP   = STURM
      PTSHFT = SHFTPT
      STURM  = JJ
      SHFTPT = RS
 1530 IF (STATFL .NE. 1) RETURN
C
C     PREPARE AND PRINT STATISTICS REGARDING DECOMPOSITION
C
      IF (2*NROW .LT. BUF2) GO TO 1600
      CALL PAGE2 (2)
      WRITE  (NOUT,1540) UIM
 1540 FORMAT (A29,' 2316. INSUFFICIENT CORE TO PREPARE DECOMPOSITION ',
     1       'STATISTICS.')
      RETURN
C
 1600 CALL GOPEN (SCRA,ZI(BUF1),RDREW)
      CALL GOPEN ( DBL,ZI(BUF2),RDREW)
      ABLK(1) = SCRA
      BBLK(1) = DBL(1)
      ROW = 1
      DO 1610 I = 1,6
      NULL(I) = 0
 1610 CONTINUE
      NN = 2*NROW - 1
      EPSMAX = 0.
      N  = 0
      DO 1710 J = 1,NN,2
      ABLK(8) = -1
      BBLK(8) = -1
      CALL FWDREC (*2220,ABLK)
      CALL GETSTR (*2180,ABLK)
      CALL GETSTR (*2190,BBLK)
      IF (ABLK(4) .NE. ROW) GO TO 2200
      IF (BBLK(4) .NE. ROW) GO TO 2210
      II = ABLK(5)
      JJ = BBLK(5)
      GO TO (1660,1670,1680,1690), TYPEA
 1660 SAVE(2) = XNS(II)
      SAVE(3) = XNS(JJ)
      GO TO 1700
 1670 SAVE(2) = XDNS(II)
      SAVE(3) = XDNS(JJ)
      GO TO 1700
 1680 SAVE(2) = SQRT(XNS(II)**2 + XNS(II+1)**2)
      SAVE(3) = SQRT(XNS(JJ)**2 + XNS(JJ+1)**2)
      GO TO 1700
 1690 SAVE(2) = DSQRT(XDNS(II)**2 + XDNS(II+1)**2)
      SAVE(3) = DSQRT(XDNS(JJ)**2 + XDNS(JJ+1)**2)
 1700 CALL FWDREC (*2220,ABLK)
      CALL FWDREC (*2220,BBLK)
      EPS = ABS(SAVE(2)/SAVE(3))
      ZI(J  ) = ROW
      ZI(J+1) = EPS
      IF (SAVE(3) .LT. 0.) N = N + 1
      EPSMAX = AMAX1(EPSMAX,EPS)
      ROW = ROW + 1
 1710 CONTINUE
      CALL SORT (0,0,2,2,ZI,2*NROW)
      CALL CLOSE (ABLK,REW)
      CALL CLOSE (BBLK,REW)
      SAVE(1) = 0.1*EPSMAX
      DO 1720 I = 2,6
      SAVE(I) = 0.1*SAVE(I-1)
 1720 CONTINUE
      DO 1780 J = 1,NN,2
      IF (ZR(J+1) .GT. SAVE(1)) GO TO 1730
      IF (ZR(J+1) .GT. SAVE(2)) GO TO 1740
      IF (ZR(J+1) .GT. SAVE(3)) GO TO 1750
      IF (ZR(J+1) .GT. SAVE(4)) GO TO 1760
      IF (ZR(J+1) .GT. SAVE(5)) GO TO 1770
      NULL(6) = NULL(6) + 1
      GO TO 1780
 1730 NULL(1) = NULL(1) + 1
      GO TO 1780
 1740 NULL(2) = NULL(2) + 1
      GO TO 1780
 1750 NULL(3) = NULL(3) + 1
      GO TO 1780
 1760 NULL(4) = NULL(4) + 1
      GO TO 1780
 1770 NULL(5) = NULL(5) + 1
 1780 CONTINUE
      I = MAX0(1,NN-8)
      CALL PAGE2 (6)
      WRITE  (NOUT,1790) UIM,DBNAME,N,EPSMAX,(NULL(J),J=1,6),
     1                   (ZI(J),J=I,NN,2)
 1790 FORMAT (A29,' 2314. STATISTICS FOR SYMMETRIC DECOMPOSITION OF ',
     1        'DATA BLOCK ',2A4,7H FOLLOW,
     2        /10X,23HNUMBER OF UII .LT. 0 = ,I5,
     3        /10X,36HMAXIMUM ABSOLUTE VALUE OF AII/UII = ,1P,E12.5,
     4        /10X,13HN1 THRU N6 = ,6I6,
     5        /10X,36HROW NUMBERS OF 5 LARGEST  AII/UII = ,6I6 )
      RETURN
C
C     DIAGONAL ELEMENT .LT. 0.0 IN CHOLESKY DECOMPOSITION
C
 1800 WRITE  (NOUT,1810) UFM
 1810 FORMAT (A23,' 3181, ATTEMPT TO PERFORM CHOLESKY DECOMPOSITION ON',
     1       ' A NEGATIVE DEFINITE MATRIX IN SUBROUTINE SDCOMP.')
      GO TO 2330
C
C     DIAGONAL ELEMENT .EQ. 0.0
C
 1820 ZR(1) = RKHR
      IF (TYPEA .EQ. 2) ZD(1) = RKHR
      CALL PAGE2 (3)
      WRITE  (NOUT,1830) UWM,ROW,RKHR
 1830 FORMAT (A25,' 2396, SDCOMP COMPUTED A ZERO ON THE DIAGONAL DURING'
     1,      ' DECOMPOSITION AT ROW NUMBER',I6,1H., /5X,
     2       'USE OF DIAG 22 OUTPUT SHOULD PERMIT YOU TO CORRELATE THE',
     3       ' ROW WITH A MODEL D.O.F.', /5X,'A VALUE OF ',E13.6,
     4       ' WILL BE USED IN PLACE OF THE ZERO, HOWEVER', /5X,
     5       ' THE ACCURACY OF THE DECOMPOSITION MAY BE IN DOUBT.')
      GO TO KHR, (860,930)
 1840 CALL CLOSE (SCRA,REW)
      CALL CLOSE (SCRB,REW)
      CALL CLOSE ( DBL,REW)
      CALL CLOSE (SCRC,REW)
      CALL CLOSE (SCRD,REW)
      RETURN 1
C
C     DECOMPOSE A 1X1 MATRIX
C
 1900 ITYPE1 = TYPEA
      ITYPE2 = TYPEA
      ITYPE3 = TYPEA
      POWER  = 0
      I1     = 1
      J1     = 1
      I2     = 1
      J2     = 1
      INCR1  = 1
      INCR2  = 1
      KK     = 1
      NULL(1)= 1
      GO     =.FALSE.
      CALL GOPEN  (DBA,ZI(BUF1),RDREW)
      CALL UNPACK (*600,DBA,ZR)
      CALL CLOSE  (DBA,REW)
      CALL GOPEN  (DBL,ZI(BUF1),WRTREW)
      DBL(2) = 0
      DBL(6) = 0
      GO TO (1910,1920,1930,1940), TYPEA
 1910 MINDS = ZR(1)
      DSR   = ZR(1)
      IF (ZR(1)) 1950,600,1950
 1920 MINDD = ZD(1)
      DDR   = ZD(1)
      IF (ZD(1)) 1950,600,1950
 1930 MINDS = SQRT(ZR(1)**2 + ZR(2)**2)
      DSR   = ZR(1)
      DSC   = ZR(2)
      IF (MINDS) 1950,600,1950
 1940 MINDD = DSQRT(ZD(1)**2 + ZD(2)**2)
      DDR   = ZD(1)
      DDC   = ZD(2)
      IF (MINDD) 1950,600,1950
 1950 CALL PACK  (ZR,DBL,DBL)
      CALL CLOSE (DBL,REW)
      RETURN
C
C     VARIOUS ERRORS LAND HERE
C
 2000 KERR = 1045
      GO TO  2230
 2010 KERR = 1046
      GO TO  2230
 2020 KERR = 1051
      GO TO  2230
 2030 KERR = 1310
      GO TO  2230
 2040 KERR = 1320
      GO TO  2230
 2050 KERR = 1300
      GO TO  2230
 2060 KERR = 1288
      GO TO  2230
 2070 KERR = 1065
      GO TO  2230
 2080 KERR = 1204
      GO TO  2230
 2090 KERR = 660
      GO TO  2230
 2100 KERR = 1215
      GO TO  2230
 2110 KERR = 1216
      GO TO  2230
 2120 KERR = 1288
      GO TO  2230
 2130 KERR = 1170
      GO TO  2230
 2140 KERR = 1350
      GO TO  2230
 2150 KERR = 1370
      GO TO  2230
 2160 KERR = 1340
      GO TO  2230
 2170 KERR = 1420
      GO TO  2230
 2180 KERR = 1620
      GO TO  2230
 2190 KERR = 1630
      GO TO  2230
 2200 KERR = 1640
      GO TO  2230
 2210 KERR = 1650
      GO TO  2230
 2220 KERR = 1407
      GO TO  2230
 2230 WRITE  (NOUT,2240) SFM,KERR
 2240 FORMAT (A25,' 3130, LOGIC ERROR',I6,' OCCURRED IN SDCOMP.')
      J = 66
      WRITE  (NOUT,2250) (KEY(I),I=1,J)
 2250 FORMAT (36H0   CONTENTS OF / SDCOMX / FOLLOW -- ,/(1X,10I12))
      GO TO 2330
C
C     ERROR EXITS
C
 2300 IER = -7
      IFL = 0
      GO TO 2340
 2310 IER = -8
      IFL = ICRQ
      GO TO 2340
 2320 IER = -50
      IFL = JKLM
      GO TO 2340
 2330 IER = -37
      IFL = 0
 2340 CALL MESAGE (IER,IFL,SUBNAM)
      RETURN
      END

      SUBROUTINE STPDA (INPUT,AJJL,SKJ)
C
C     DRIVER FOR STRIP THEORY
C
      INTEGER         SYSBUF,IZ(8),AJJL,SKJ,NAME(2),CLAF,LCLAF,LCIRC
      COMPLEX         EKM
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /STRIPC/ NS,BREF,CLAM,FM,NCIRC,NNCIRC,EKR(1),
     1                DUM,BB(4),BETA(4),EKM(4,4)
      COMMON /ZZZZZZ/ Z(1)
      COMMON /SYSTEM/ SYSBUF,NOUT
      COMMON /CONDAS/ PI,TWOPI
      COMMON /AMGMN / MCB(7),NROW,ND,NE,REFC,FMACH,RFK,TSKJ(7),ISK,NSK
      COMMON /BLANK / NK,NJ
      COMMON /PACKX / ITI,IT0,II,NN,INCR
      EQUIVALENCE     (IZ(1),Z(1))
      DATA     NAME / 4HSTPD,4HA   /
C
      ICORE = KORSZ(IZ) - 4*SYSBUF
C
C     BRING IN DATA AND ALLOCATE CORE
C
      CALL FREAD (INPUT,Z,8,0)
      NNJ   = IZ(1)
      CLAF  = IZ(2)
      LCLAF = IZ(3)
      NCIRC = IZ(4)
      LCIRC = IZ(5)
      NNCIRC= NCIRC + 1
      NMACH = IZ(6)
      NS    = IZ(7)
      I8    = 8
      CLAM  = Z(I8)
      FM    = 1.0
      BREF  = REFC / 2.0
      EKR(1)= RFK
      IDY   = 1
      IBLOC = IDY  + NS
      ID    = IBLOC+ NS
      ICA   = ID   + NS
      IGAP  = ICA  + NS
      INSIZE= IGAP + NS
      ICLA  = INSIZE + NS
      IBM   = ICLA + NS
      IGM   = IBM  + 16 * NS
      IPM   = IGM  + 12 * NS
      IOC   = IPM  + 37 * NS
      IF (IOC.GT.ICORE) CALL MESAGE (-8,0,NAME)
C
C     READ IN ARRAYS WHICH ARE FIXED
C
      NW = 6*NS
      CALL FREAD (INPUT,Z,NW,0)
C
C     SET CLA ARRAY OR BB AND BETA
C
      IF (CLAF .EQ. 0) GO TO 40
      IF (CLAF .LT. 0) GO TO 30
C
C     FIND MACH NUMBER FOR CLA
C
      DO 10 I = 1,NMACH
      CALL FREAD (INPUT,RM,1,0)
      IF (RM .EQ. FMACH) GO TO 20
      CALL FREAD (INPUT,Z,-NS,0)
   10 CONTINUE
      GO TO 999
C
C     MACH NUMBER NOT INPUT ON AEFACT CARD CLCAF
C
   20 CALL FREAD (INPUT,Z(ICLA),NS,1)
      GO TO 90
   30 CALL FREAD (INPUT,RM,1,0)
      CALL FREAD (INPUT,Z(ICLA),NS,1)
      DO  35 I = 1,NS
      Z(ICLA+I-1) = Z(ICLA+I-1) * SQRT((1.0-(RM*RM*CLAM*CLAM)) /
     1                           (1.0-(FMACH*FMACH*CLAM*CLAM)))
   35 CONTINUE
      GO TO 90
   40 DO 50 I = 1,NS
   50 Z(ICLA+I-1) = TWOPI
      IF (NCIRC .EQ. 0) GO TO 80
      DO 60 I = 1,NMACH
      CALL FREAD (INPUT,RM,1,0)
      IF (RM .EQ. FMACH) GO TO 70
      CALL FREAD (INPUT,Z,-(2*NCIRC+1),0)
   60 CONTINUE
      GO TO 998
   70 CALL FREAD (INPUT,BB(1),1,0)
      DO 75 I = 2,NNCIRC
      CALL FREAD (INPUT,BB(I),1,0)
      CALL FREAD (INPUT,BETA(I),1,0)
   75 CONTINUE
   80 CALL FREAD (INPUT,Z,0,1)
C
C     OUTPUT SKJ
C
   90 ITI = 1
      IT0 = 3
      II  = ISK
      NSK = NSK+1
      NN  = NSK
      RM  = 1.0
      DO 100 I = 1,NNJ
      CALL PACK (RM,SKJ,TSKJ)
      II  = II+1
      IF (I .EQ. NNJ) GO TO 100
      NN  = NN+1
  100 CONTINUE
      ISK = II
      NSK = NN
      ITI = 3
      IT0 = 3
      CALL STPBG  (Z(IBM),Z(IGM),NS,Z(IBLOC),Z(ID),Z(ICA),Z(INSIZE))
      CALL STPPHI (Z(ICA),Z(IBLOC),Z(IPM),NS)
      CALL STPAIC (Z(IBLOC),Z(IDY),Z(INSIZE),Z(IGAP),Z(IBM),Z(IGM),
     1             Z(IPM),NS,Z(ICLA),AJJL)
      NROW = NROW + NNJ
      RETURN
C
C     ERROR MESSAGES
C
  998 N = LCIRC
      GO TO 1000
  999 N = LCLAF
 1000 WRITE  (NOUT,9999) UFM,FMACH,N
 9999 FORMAT (A23,' 2426, MACH NUMBER ',F10.5,' WAS NOT FOUND ON ',
     1       'AEFACT CARD',I9)
      CALL MESAGE (-61,0,NAME)
      RETURN
      END

      SUBROUTINE RAND8(NFREQ,NPSDL,NTAU,XYCB,LTAB,IFILE,PSDF,AUTO,NFILE)
C
C     THIS ROUTINE COMPUTES RANDOM RESPONSE FOR COUPLED POWER SPECTRAL
C       DENSITY COEFICIENTS
C
      INTEGER  IZ(1),SYSBUF,FILE,XYCB,PSDF,AUTO,IFILE(1),NAME(2),
     1    MCB1(7),MCB2(7),OLDLD
      REAL Q(2)
      REAL DATA(100)
C
      COMMON /CONDAS/    PI       ,TWOPI    ,RADEG    ,DEGRAD   ,
     1                   S4PISQ
      COMMON /SYSTEM/ SYSBUF
      COMMON /ZZZZZZ/  Z(1)
C
      EQUIVALENCE (Z(1),IZ(1))
C
      DATA  NAME,MCB1,MCB2/4HRAND,4H8   ,14*0/
      DATA IPSDF,IAUTO /4001,4002/
C *****
C     DEFINITION OF VARIABLES
C *****
C     NFREQ    NUMBER OF FREQUENCIES
C     NPSDL    NUMBER OF PSDL  CARDS
C     NTAU     NUMBER OF TIMES
C     XYCB     DATA BLOCK CONTAINING XY USER REQUESTS
C     LTAB     LENGTH OF CORE USED FOR TABLES BY PRETAB
C     IFILE    ARRAY CONTAINING FILE NAMES FOR SORT 2 INPUT FILES
C     PSDF     OUTPUT FILE FOR POWER SPECTRAL DENSITY FUNCTIONS
C     AUTO     OUTPUT FILE FOR AUTOCORRELATION FUNCTIONS
C     NFILE    LENGTH OF IFILE ARRAY
C     MCB1     TRAILER FOR PSDF
C     MCB2     TRAILER FOR AUTO
C     IPSDF    OFP ID FOR PSDF
C     IAUTO    OFP ID FOR AUTO
C     LCORE    AVAILABLE CORE FOR  LISTS
C     IBUF1    BUFFER POINTERS
C     IBUF2
C     IBUF3
C     ITAU     POINTER TO FIRST TAU-1
C     ISAA     POINTER TO SAB TABLE -1
C     TAU      TIMES FOR AUTOCORRELATION
C     SAB      POWER SPECTRAL DENSITY FACTORS
C     ICORE    POINTER TO FIRST REQUEST-1
C     SYSBUF   LENGTH OF ONE BUFFER
C     NPOINT   TOTAL NUMBER OF REQUESTS
C     NZ       CORE AVAIABLE FOR STORING H VALUES
C     IP       POINTER TO FIRST POINT OF CURRENT CORE LOAD
C     NDONE    NUMBER OF REQUESTS PROCESSED
C     OLDLD    LOAD ID OF OLD LOAD SET
C     NDO      NUMBER POSSIBLE TO DO IN CORE
C     ICS      POINTER TO FIRST H ARRAY
C     NLOAD    NUMBER OF LOADS      PROCESSED ON CURRENT CORE LOAD
C     ICDONE   NUMBER CURRENTLY DONE -- SEVERAL COMP FROM EACH VALUE
C     LOAD     SUBCASE ID FROM INPUT RECORD
C     IF       FORMAT FLAG IF=0  DATA IS REAL/IMAG  IF .NE. 0 MAG/PHASE
C     LEN      LENGTH OF DATA RECORD
C     Q        MEAN  RESPONSE
C     R        AUTOCORRALATION FUNCTION AT TIME TAU
C     IP1      LOCAL POINT POINTER
C     NUNQ     NUMBER OF UNIQUE LOAD ID-S
C     ILOAD    POINTER TO LOAD LIST-1
C     ISJ      POINTER TO SJ ADD AREA-1
C     ICS      H STORAGE -1
C
C
C
C *****
C     CORE LAYOUTDURING EXECUTION
C *****
C     FREQUENCIES   NFREQ OF THEM
C     RANDPS DATA   NPSDL OF THEM  5 WORDS PER CARD
C                   LOAD ID  LOAD ID   X   Y   TABLE
C     TAUS          NTAU OF THEM
C     TABLE DATA    LTAB OF IT
C     S(AB)         NFREQ OF THEM-- THESE ARE REEVALUATED WHEN LOAD CHAN
C     UNIQUE ID-S   NUNQ  OF THEM
C     REQUESTS      NPOINT OF THEM 5 WORDS PER REQUEST
C                   DB   ID   COMP O.P. P/P
C     H-S           LENGTH = 2*NFREQ --REAL+IMAGINARY
C                   NUNQ  H-S PER SET-- NDO SETS
C     SJ COMPUTE    NFREQ OF IT
C
C
C     BUFFERS       3 NEEDED
C
C
C
C
C     INITIALIZE GENERAL VARIABLES--ASSIGN BUFFERS,ETC
C
      MCB1(1)=PSDF
      MCB2(1)=AUTO
      LCORE=KORSZ(Z)
      IBUF1=LCORE-SYSBUF+1
      IBUF2=IBUF1-SYSBUF
      IBUF3=IBUF2-SYSBUF
      ITAU=NFREQ+5*NPSDL
      ISAA=NTAU+LTAB+ITAU
      LCORE=LCORE-(ISAA+NFREQ+3*SYSBUF)
      ICRQ = -LCORE
      IF(LCORE .LE. 0) GO TO 980
C
C     BUILD LIST OF UNIQUE LOAD ID-S
C         REPLACE LOAD ID OF PSDL WITH POINTER TO LIST
C
      NUNQ=0
      ILOAD=ISAA+NFREQ
      M=ILOAD+1
      K=M-1
      I=NFREQ+1
      JJ=ITAU+1
      J=1
      GO TO 4
C
C         SEARCH LIST OF UNIQUE ID-S
C
    5 DO 3  L=M,K
      IF(IZ(I) .EQ. IZ(L)) GO TO 9
    3 CONTINUE
      GO TO 4
C
C         NEXT PSDL CARD
C
    2 IF(J .EQ. 0) GO TO 7
      I=I+1
      J=0
      GO TO 5
C
C         SAVE LOAD ID
C
    4 K=K+1
      NUNQ=NUNQ+1
      IZ(K)=IZ(I)
      L=K
C
C         REPLACE ID WITH POINTER INTO LIST
C
    9 IZ(I)=L-M+1
      GO TO 2
C
C         NEXT PSDL CARD
C
    7 I=I+4
      J=1
      IF(I .NE. JJ) GO TO 5
C
C         COMPUTE MINIMUM CORE
C
      MINCR=NUNQ*NFREQ*2+NFREQ
      ICORE=ILOAD+NUNQ
      LCORE=LCORE-NUNQ
      ICRQ = MINCR - LCORE
      IF(LCORE-MINCR .LE. 0) GO TO 980
C
C         OPEN OUTPUT FILES
C
      CALL GOPEN(PSDF,Z(IBUF2),1)
      CALL GOPEN(AUTO,Z(IBUF3),1)
C
C         BEGIN LOOP ON EACH FILE
C
      DO 1000  I=1,NFILE
C
C         BUILD POINT LIST FOR FILE(I)
C
      CALL RAND6 (XYCB,Z(IBUF1),NPOINT,IZ(ICORE+1),IFILE(I),LCORE)
      IF(NPOINT .EQ. 0) GO TO 1000
      NZ=LCORE-5*NPOINT
      ICRQ = -NZ
      IF(NZ .LE. 0) GO TO 980
C
C         OPEN INPUT FILE
C
      FILE=IFILE(I)
      CALL OPEN(*1000,FILE,Z(IBUF1),0)
      IP=ICORE+1
      NDONE=0
      OLDLD=0
      ICS=ICORE+5*NPOINT
      LLIST=5*NPOINT
C
C         COMPUTE NUMBER OF POINTS TO DO AT SAME TIME
C
   13 NDO = MIN0(NPOINT-NDONE,NZ/MINCR)
      ICRQ = MAX0(NPOINT-NDONE,MINCR)
      IF(NDO .EQ. 0) GO TO 980
      LLISTS = LLIST
      ICDONE=0
      IPSAVE=IP
      NLOAD =0
C         GET READY TO OBTAIN FIRST VALUE
C
   15 CALL RAND2 (IFILE(I),IZ(IP),LOAD,IF,LEN,LLIST)
      IF(LOAD .EQ. 0) GO TO 159
C
C         CHECK FOR NEW LOAD
C
      IF(LOAD .EQ. OLDLD) GO TO 50
C
C         NEW LOAD -- SEE IF WANTED
C
      DO 10  KK=1,NUNQ
      L=ILOAD+KK
      IF(LOAD .EQ. IZ(L)) GO TO 20
   10 CONTINUE
C
C         REJECT LOAD -- NOT NEEDED
C
      GO TO 15
C
C         GOOD LOAD -- SAVE DATA
C
   20 OLDLD=LOAD
C
C         BRING DATA INTO KK-TH H SAVE AREA
C
      KK = ICS +(KK-1)*NFREQ*2
   50 IF(LEN .GT. 100) GO TO 970
      DO 60  J=1,NFREQ
C
C     ACCESS DATA FROM FILE  INTO DATA  ARRAY
C
      CALL RAND2A( DATA(1))
      IP1=IP
      II=ICDONE
C
C         COMPUTE REAL/IMAG OF CURRENT COMPONENT
C
   52 IF( (LEN-2)/2 .GE. IZ(IP1+2)) GO TO 53
C
C     REQUEST OUT OF RANGE
C
      CALL MESAGE(52,IZ(IP1),IZ(IP1+1))
      IZ(IP1+2) = (LEN-2)/2
   53 JJ = IZ(IP1+2) +2
      K=JJ+LEN/2-1
      IF ( IF .LE. 0) GO TO 51
      X=DATA(JJ)*COS(DEGRAD*DATA(K))
      DATA(K)=DATA(JJ)*SIN(DEGRAD*DATA(K))
      DATA(JJ)=X
   51 L=KK+J*2-1+II*MINCR
      Z(L)=DATA(JJ)
      Z(L+1)=DATA(K)
C
C         TEST FOR CORE OVERFLOW
C
      IF(II .EQ. NDO-1) GO TO 60
C
C         IS NEXT REQUEST FROM SAME POINT
C
      IF(IZ(IP1) .NE. IZ(IP1+5) .OR. IZ(IP1+1) .NE. IZ(IP1+6)) GO TO 60
      II=II+1
      IP1=IP1+5
      GO TO 52
   60 CONTINUE
      ICDONE=II+1
      IP=IP1+5
      LLIST=LLIST-5*ICDONE
C
C         HAVE I DONE ALL REQUESTS (IN CURRENT CORE)
C
      IF(ICDONE .NE. NDO) GO TO 15
C
C         HAVE I ADDED IN ALL LOADS
      NLOAD = NLOAD +1
      IP=IPSAVE
      IF(NLOAD .EQ. NUNQ ) GO TO 100
C
C         START AGAIN ON NEXT LOAD
      LLIST = NDO*5
      ICDONE=0
      GO TO 15
C
C         ALL LOADS FOR CURRENT BUNCH DONE
C              COMPUTE SJ-S
C
C              ZERO ALL SJ-S
C
  100 DO 101  J=1,NDO
      K=ICS+J*MINCR-NFREQ
      DO 102  L=1,NFREQ
      JJ=K+L
      Z(JJ)=0.0
  102 CONTINUE
  101 CONTINUE
C
C         FOR EACH PSDL CARD  1. EVALUATE SAB
C              FOR EACH POINT
C                   IN CORE   2. COMPUTE 2*RE(HI*SIJ*HJBAR)
C                             3. ADD TO SJ AT EACH FREQ.
C
      DO 120  J=1,NPSDL
C
C         EVALUATE SAB
C
      TWO=2.0
      L=NFREQ+(J-1)*5
      IF(IZ(L+1) .EQ. IZ(L+2)) TWO=1.0
      Q(1) = Z(L+3)
      R=Z(L+4)
      DO 103  K=1,NFREQ
      JJ=ISAA+K
C
C
C                TAB     X    F(X)
      CALL TAB (IZ(L+5),Z(K),Z(JJ))
      IF(IZ(L+5) .EQ.0) Z(JJ) =1.0
  103 CONTINUE
C
C         FOR EACH POINT IN CORE
C
      DO 115  K=1,NDO
      L2=ICS+K*MINCR-NFREQ
      L1=ICS+(K-1)*MINCR-1-NFREQ*2
      DO 110  M=1,NFREQ
      IH1=IZ(L+1)*NFREQ*2 +L1  +2*M
      IH2=IZ(L+2)*NFREQ*2 +L1  +2*M
      JJ=ISAA+M
      ISJ=L2+M
      Z(ISJ)=Z(ISJ)+Z(JJ)*TWO*((Z(IH1)*Q(1)-Z(IH1+1)*R)*Z(IH2)
     1  +(Z(IH1+1)*Q(1)+Z(IH1)*R)*Z(IH2+1))
  110 CONTINUE
  115 CONTINUE
  120 CONTINUE
C
C         OUTPUT STUFF IN CORE
C
      JJ=IP
      J=NDO*5+JJ-1
      L=ICS-NFREQ
      DO 150  K=JJ,J,5
      L=L+MINCR
C
C         CONVERT SJ TO ABSOLUTE VALUE
C
      DO 151  LL=1,NFREQ
      KK=L+LL
      Z(KK)=ABS(Z(KK))
  151 CONTINUE
C
C         COMPUTE MEAN RESPONSE
C
      CALL RAND3 (Z(1),Z(L+1),Q,NFREQ)
      IF(IZ(K+3) .EQ. 2) GO TO 155
C
C         PSDF REQUESTED -- PUT OUT ID
C
      MCB1(7)=MCB1(7)+1
      CALL RAND1(PSDF,IPSDF,IZ(K),IZ(K+1),IZ(K+4),Q)
C
C         PUT OUT DATA RECORDED
C
      DO 152  LL=1,NFREQ
      KK=L+LL
      CALL WRITE (PSDF,Z(LL),1,0)
      CALL WRITE (PSDF,Z(KK),1,0)
  152 CONTINUE
      CALL WRITE (PSDF,0,0,1)
  155 IF(IZ(K+3) .EQ. 1) GO TO 150
C
C         AUTO CORRELATION REQUESTED
C
      IF(NTAU .EQ. 0) GO TO 150
      CALL RAND1(AUTO,IAUTO,IZ(K),IZ(K+1),IZ(K+4),Q)
      MCB2(7)=MCB2(7)+1
C
C         PUT OUT DATA RECORD
C
      DO 156  LL=1,NTAU
      KK=ITAU+LL
      CALL WRITE (AUTO,Z(KK),1,0)
C
C         COMPUTE AUTO
C
      CALL RAND4 (Z(1),Z(L+1),Z(KK),R,NFREQ)
      CALL WRITE (AUTO,R,1,0)
  156 CONTINUE
      CALL WRITE (AUTO,0,0,1)
  150 CONTINUE
C
C         END CORE LOAD
C
      CALL REWIND (IFILE(I))
      NDONE=NDONE+NDO
      IF(NDONE .NE. NPOINT) GO TO 200
C
C         FINISHED WITH FILE
C
  159 CALL CLOSE(IFILE(I),1)
      GO TO 1000
C
C         SPILL ON POINT LISTS -- GO AGAIN
C
  200 OLDLD=0
      LLIST=LLISTS-5*NDO
      IP=IPSAVE+5*NDO
      GO TO 13
 1000 CONTINUE
C
C         ALL STUFF DONE -- GET OUT
C
      CALL CLOSE (PSDF,1)
      CALL CLOSE (AUTO,1)
      CALL WRTTRL(MCB1)
      CALL WRTTRL(MCB2)
      RETURN
C
C         FILE + MISC ERRORS
C
  901 CALL MESAGE (IP1,FILE,NAME)
      RETURN
  970 IP1=-7
      GO TO 901
  980 IP1=-8
      FILE = ICRQ
      GO TO 901
      END

      SUBROUTINE DSOCFF ( DSNAME, IUNIT, ISTATUS )
      CHARACTER*80      DSNAME
      COMMON / SYSTEM / SYSBUF, IWR
      COMMON / MACHIN / MAC(3), LQRO
      INCLUDE  'DSIOF.COM'
C  OPEN AND CLOSE FILE IN ORDER TO DELETE SPACE
      OPEN  ( UNIT=IUNIT, FILE=DSNAME    , IOSTAT=ISTATUS, ERR=100
     &,       STATUS='UNKNOWN' )
100   CLOSE ( UNIT=IUNIT, STATUS='DELETE', IOSTAT=ISTATUS, ERR=701 )
C NOW, OPEN FILE AS NEW FOR NASTRAN
c      print *,' dsocff,nbuff=',nbuff
      nbuff4 = nbuff * ( MOD(LQRO,100) / 10 )
      OPEN  ( UNIT=IUNIT, FILE=DSNAME, RECL=NBUFF4, STATUS='NEW'
     &,       access='direct', form='unformatted',IOSTAT=ISTATUS
     &,       ERR=702 )
      GO TO 777
701   WRITE ( IWR, 901 ) IUNIT, ISTATUS, DSNAME
901   FORMAT(//,' FATAL ERROR IN DSOCFF, UNABLE TO CLOSE UNIT=',I4
     &,         ' STATUS='I4
     &,       /,' FILE NAME=',A80 )
      ICCERR = ISTATUS
      CALL DSMSG  ( 101 )
      CALL MESAGE ( -61, 0, 0 )
702   WRITE ( IWR, 902 ) IUNIT, ISTATUS, DSNAME
902   FORMAT(//,' FATAL ERROR IN DSOCFF, UNABLE TO OPEN UNIT=',I4
     &,         ' STATUS=',I4
     &,       /,' FILE NAME=',A80 )
      ICCERR = ISTATUS
      CALL DSMSG  ( 101 )
      CALL MESAGE ( -61, 0, 0 )
777   RETURN
      END

      SUBROUTINE TPZTEM (TI,PG)
C
C     THIS ROUTINE COMPUTES THE THERMAL LOAD FOR THE AXI-SYMMETRIC
C     TRAPEZOIDAL CROSS SECTION RING
C
C     ECPT COMMON BLOCK IS,
C
C     ECPT( 1) = ELEMENT ID                                I
C     ECPT( 2) = SIL A                                     I
C     ECPT( 3) = SIL B                                     I
C     ECPT( 4) = SIL C                                     I
C     ECPT( 5) = SIL D
C     ECPT( 6) = MATERIAL ORIENTATION ANGLE(DEGREES)       R
C     ECPT( 8) = MATERIAL ID                               I
C     ECPT( 9) TO ECPT (22) FOR PHI
C     ECPT(23) = COOR. SYS. FOR GRID POINT A               I
C     ECPT(24) = X-COOR. OF GRID POINT A (IN BASIC COOR)   R
C     ECPT(25) = Z-COOR. OF GRID POINT A (IN BASIC COOR)   R
C     ECPT(26) = 0.0
C     ECPT(27) = COOR. SYS. FOR GRID POINT B
C     ECPT(28) = X-COOR. OF GRID POINT B (IN BASIC COOR)   R
C     ECPT(29) = Z-COOR. OF GRID POINT B (IN BASIC COOR)   R
C     ECPT(30) = 0.0
C     ECPT(31) = COOR. SYS. FOR GRID POINT C               I
C     ECPT(32) = X-COOR. FOR GRID POINT C                  R
C     ECPT(33) = Z-COOR. FOR GRID POINT C                  R
C     ECPT(34) = 0.0
C     ECPT(35) = COOR. SYS. FOR GRID POINT D               I
C     ECPT(36) = X-COOR FOR GRID POINT D                   R
C     ECPT(37) = Z-COOR FOR GRID POINT D                   R
C     ECPT(38) = 0.0
C     ECPT(39) = EL. TEMPERATURE FOR MATERIAL PROP         R
C
      INTEGER         SP(36)
      DIMENSION       TI(4),PG(1),R(4),Z(4),GABABQ(12,12),DELINT(15),
     1                D(144),TEO(21),HTN(12,4),IGP(4),IECPT(39),ICS(4),
     2                H(4,4),AKI(144),TL(12)
      COMMON /TRIMEX/ ECPT(39)
C
C     INPUT AND OUTPUT BLOCKS FOR SUBROUTINE MAT
C
      COMMON /MATIN / MATIDC,MATFLG,ELTEMP,STRESS,SINTH,COSTH
      COMMON /MATOUT/ E(3),ANU(3),RHO,G(3),ALF(3),TZERO,GSUBE,MOSKP(9),
     1                SETMAT
      COMMON /CONDAS/ CONSTS(5)
      COMMON /SYSTEM/ IBUF,IOUT
      EQUIVALENCE     (IECPT(1),ECPT(1)),(Z(1),Z1),(Z(2),Z2),
     1                (Z(3),Z3),(R(1),R1),(R(2),R2),(R(3),R3),
     2                (R(4),R4),(Z(4),Z4),(GABABQ(1,1),AKI(1)),
     3                (CONSTS(1),PI),(CONSTS(4),DEGRAD)
      DATA    IDEL2 , JAX / 0, 4HAX    /
C
C     START EXECUTION
C
C     STORE ECPT PARAMETERS IN LOCAL VARIABLES
C
      IDEL   = IECPT( 1)
      IGP(1) = IECPT( 2)
      IGP(2) = IECPT( 3)
      IGP(3) = IECPT( 4)
      IGP(4) = IECPT( 5)
      MATID  = IECPT( 8)
      ICS(1) = IECPT(23)
      ICS(3) = IECPT(31)
      ICS(2) = IECPT(27)
      R(1)   = ECPT (24)
      R(2)   = ECPT (28)
      R(3)   = ECPT (32)
      ICS(4) = IECPT(35)
      Z(1)   = ECPT (25)
      D(1)   = ECPT (26)
      Z(2)   = ECPT (29)
      D(2)   = ECPT (30)
      Z(3)   = ECPT (33)
      D(3)   = ECPT (34)
      Z(4)   = ECPT (37)
      D(4)   = ECPT (38)
      R(4)   = ECPT (36)
      TEMPE  = ECPT (39)
      DGAMA  = ECPT ( 6)
      IDEL1  = IDEL/1000
C
C     COMPUTE THE ELEMENT COORDINATES
C
      ZMIN = AMIN1(Z1,Z2,Z3,Z4)
      Z1   = Z1 - ZMIN
      Z2   = Z2 - ZMIN
      Z3   = Z3 - ZMIN
      Z4   = Z4 - ZMIN
C
C     FATAL IF RATIO OF RADII IS TOO LARGE FOR GUASS QUADRATURE
C
      RMIN = AMIN1(R1,R2,R3,R4)
      RMAX = AMAX1(R1,R2,R3,R4)
      IF (RMIN .EQ. 0.0) GO TO 206
      IF (RMAX/RMIN .GT. 10.) GO TO 915
C
  206 CONTINUE
      IF (ABS(Z1-Z2) .GT. .001) GO TO 910
      IF (ABS(Z3-Z4) .GT. .001) GO TO 910
      D(5) = (R1+R4)/2.0
      D(6) = (R2+R3)/2.0
      IF (D(5) .EQ. 0.0) GO TO 210
      IF (ABS((R1-R4)/D(5)) .GT. .005) GO TO 210
      R1 = D(5)
      R4 = D(5)
  210 CONTINUE
      IF (D(6) .EQ. 0.0) GO TO 220
      IF (ABS((R2-R3)/D(6)) .GT. .005) GO TO 220
      R2 = D(6)
      R3 = D(6)
  220 CONTINUE
C
C     FORM THE TRANSFORMMATION MATRIX(12X12) FROM FIELD COOR, TO GRID
C     POINT DEGREES OF FREEDOM
C
      DO 300 I = 1, 144
  300 GABABQ( I, 1) = 0.000
      GABABQ( 1, 1) = 1.000
      GABABQ( 2, 1) = R1
      GABABQ( 3, 1) = Z1
      GABABQ( 4, 1) = R1*Z1
      GABABQ( 5, 2) = 1.000
      GABABQ( 6, 2) = R1
      GABABQ( 7, 2) = Z1
      GABABQ( 8, 2) = GABABQ(4,1)
      GABABQ( 9, 3) = 1.000
      GABABQ(10, 3) = R1
      GABABQ(11, 3) = Z1
      GABABQ(12, 3) = GABABQ(4,1)
      GABABQ( 1, 4) = 1.000
      GABABQ( 2, 4) = R2
      GABABQ( 3, 4) = Z2
      GABABQ( 4, 4) = R2*Z2
      GABABQ( 5, 5) = 1.000
      GABABQ( 6, 5) = R2
      GABABQ( 7, 5) = Z2
      GABABQ( 8, 5) = GABABQ(4,4)
      GABABQ( 9, 6) = 1.000
      GABABQ(10, 6) = R2
      GABABQ(11, 6) = Z2
      GABABQ(12, 6) = GABABQ(4,4)
      GABABQ( 1, 7) = 1.000
      GABABQ( 2, 7) = R3
      GABABQ( 3, 7) = Z3
      GABABQ( 4, 7) = R3*Z3
      GABABQ( 5, 8) = 1.000
      GABABQ( 6, 8) = R3
      GABABQ( 7, 8) = Z3
      GABABQ( 8, 8) = GABABQ(4,7)
      GABABQ( 9, 9) = 1.000
      GABABQ(10, 9) = R3
      GABABQ(11, 9) = Z3
      GABABQ(12, 9) = GABABQ(4,7)
      GABABQ( 1,10) = 1.000
      GABABQ( 2,10) = R4
      GABABQ( 3,10) = Z4
      GABABQ( 4,10) = R4*Z4
      GABABQ( 5,11) = 1.000
      GABABQ( 6,11) = R4
      GABABQ( 7,11) = Z4
      GABABQ( 8,11) = GABABQ(4,10)
      GABABQ( 9,12) = 1.000
      GABABQ(10,12) = R4
      GABABQ(11,12) = Z4
      GABABQ(12,12) = GABABQ(4,10)
C
C     NO NEED TO COMPUTE DETERMINANT SINCE IT IS NOT USED SUBSEQUENTLY.
C
      ISING = -1
      CALL INVERS (12,GABABQ,12,D(10),0,D(11),ISING,SP)
C
C     CALCULATE THE INTEGRAL VALUES IN ARRAY DELINT
C
C       DELINT(04) = (0,0)
C       DELINT(05) = (0,1)
C       DELINT(06) = (0,2)
C       DELINT(07) = (1,0)
C       DELINT(08) = (1,1)
C       DELINT(09) = (1,2)
C       DELINT(10) = (2,0)
C       DELINT(11) = (2,1)
C       DELINT(12) = (2,2)
C       DELINT(13) = (3,0)
C       DELINT(14) = (3,1)
C       DELINT(15) = (3,2)
C
      I1 = 3
      DO 320 I = 1,4
      IP = I - 1
      DO 310 J = 1,3
      IQ = J - 1
      I1 = I1 + 1
      DELINT(I1) = RZINTS(IP,IQ,R,Z,4)
  310 CONTINUE
  320 CONTINUE
C
C     LOCATE THE MATERIAL PROPERTIES IN THE MAT1 OR MAT3
C
      MATIDC = MATID
      MATFLG = 7
      ELTEMP = TEMPE
      DGAMR  = DGAMA*DEGRAD
      SINTH  = SIN(DGAMR)
      COSTH  = COS(DGAMR)
      SING   = SINTH
      COSG   = COSTH
      CALL MAT (IDEL)
      IF (SETMAT .EQ. 2.0) GO TO 910
C
C     SET MATERIAL PROPERTIES IN DOUBLE PRECISION VARIABLES
C
      ER  = E(1)
      ET  = E(2)
      EZ  = E(3)
      VRO = ANU(1)
      VOZ = ANU(2)
      VZR = ANU(3)
      GOR = G(1)
      GZO = G(2)
      GRZ = G(3)
      VOR = VRO*ET/ER
      VZO = VOZ*EZ/ET
      VRZ = VZR*ER/EZ
      DELA= 1.0/(1.0 - VRO*VOR - VOZ*VZO - VZR*VRZ - VRO*VOZ*VZR -
     1          VRZ*VOR*VZO)
C
C     COMPUTE ELASTIC CONSTANTS MATRIX FROM MATERIAL TO ELEMENT AXIS
C
      DO 510 I = 1,21
  510 TEO( I) = 0.0
      TEO( 1) = ER*(1.0 - VOZ*VZO)*DELA
      TEO( 2) = ER*(VZR + VZO*VOR)*DELA
      TEO( 3) = EZ*(1.0 - VRO*VOR)*DELA
      TEO( 4) = ER*(VOR + VZR*VOZ)*DELA
      TEO( 5) = ET*(VZO + VRO*VZR)*DELA
      TEO( 6) = ET*(1.0 - VRZ*VZR)*DELA
      TEO(10) = GRZ
      TEO(15) = GOR
      TEO(21) = GZO
      SING2   = SING**2
      COSG2   = COSG**2
      SING4   = SING**4
      COSG4   = COSG**4
      EE01    = TEO(1)*COSG4 + TEO(3)*SING4 + (TEO(2) + 2.0*TEO(10))*2.0
     1          *SING2*COSG2
      EE02    = TEO(2)*(SING4 + COSG4) + (TEO(1) + TEO(3) - 4.0*TEO(10))
     2          *SING2* COSG2
      EE03    = TEO(1)*SING4 + TEO(3)*COSG4 + (2.0*TEO(2) + 4.0*TEO(10))
     3          *SING2*COSG2
      EE04    = TEO(4)*COSG2 + TEO(5)*SING2
      EE05    = TEO(4)*SING2 + TEO(5)*COSG2
      EE06    = TEO(6)
      EE07    = (TEO(1)*COSG2 - TEO(3)*SING2 + (TEO(2) + 2.0*TEO(10))
     7          *(SING2 - COSG2))*SING*COSG
      EE08    = (TEO(1)*SING2 - TEO(3)*COSG2 + (TEO(2) + 2.0*TEO(10))
     8          *(COSG2 - SING2))*SING*COSG
      EE09    = SING*COSG*(TEO(4) - TEO(5))
C
C     COMPUTE HARMONIC COEFFICIENT
C
      AJHO = IECPT(1) - (IECPT(1)/1000)*1000 - 1
C
C     COMPUTE THERMAL LOAD
C
      A1 = EE01*ALF(1) + EE02*ALF(3) + EE04*ALF(2)
      A2 = EE02*ALF(1) + EE03*ALF(3) + EE05*ALF(2)
      A3 = EE04*ALF(1) + EE05*ALF(3) + EE06*ALF(2)
      A4 = EE07*ALF(1) + EE08*ALF(3) + EE09*ALF(2)
C
C     FORM HTN MATRIX
C
      HTN( 1,1) = A3*DELINT(4)
      HTN( 1,2) = A3*DELINT(7)
      HTN( 1,3) = A3*DELINT(5)
      HTN( 1,4) = A3*DELINT(8)
      HTN( 2,1) = (A1+A3)*DELINT(7)
      HTN( 2,2) = (A1+A3)*DELINT(10)
      HTN( 2,3) = (A1+A3)*DELINT(8)
      HTN( 2,4) = (A1+A3)*DELINT(11)
      HTN( 3,1) = A3*DELINT( 5) + A4*DELINT( 7)
      HTN( 3,2) = A3*DELINT( 8) + A4*DELINT(10)
      HTN( 3,3) = A3*DELINT( 6) + A4*DELINT( 8)
      HTN( 3,4) = A3*DELINT( 9) + A4*DELINT(11)
      HTN( 4,1) = (A1+A3)*DELINT( 8) + A4*DELINT(10)
      HTN( 4,2) = (A1+A3)*DELINT(11) + A4*DELINT(13)
      HTN( 4,3) = (A1+A3)*DELINT( 9) + A4*DELINT(11)
      HTN( 4,4) = (A1+A3)*DELINT(12) + A4*DELINT(14)
      HTN( 5,1) = AJHO*A3*DELINT(4)
      HTN( 5,2) = AJHO*A3*DELINT(7)
      HTN( 5,3) = AJHO*A3*DELINT(5)
      HTN( 5,4) = AJHO*A3*DELINT(8)
      HTN( 6,1) = AJHO*A3*DELINT(7)
      HTN( 6,2) = AJHO*A3*DELINT(10)
      HTN( 6,3) = AJHO*A3*DELINT(8)
      HTN( 6,4) = AJHO*A3*DELINT(11)
      HTN( 7,1) = AJHO*A3*DELINT(5)
      HTN( 7,2) = AJHO*A3*DELINT(8)
      HTN( 7,3) = AJHO*A3*DELINT(6)
      HTN( 7,4) = AJHO*A3*DELINT(9)
      HTN( 8,1) = AJHO*A3*DELINT(8)
      HTN( 8,2) = AJHO*A3*DELINT(11)
      HTN( 8,3) = AJHO*A3*DELINT(9)
      HTN( 8,4) = AJHO*A3*DELINT(12)
      HTN( 9,1) = 0.0
      HTN( 9,2) = 0.0
      HTN( 9,3) = 0.0
      HTN( 9,4) = 0.0
      HTN(10,1) = A4*DELINT(7)
      HTN(10,2) = A4*DELINT(10)
      HTN(10,3) = A4*DELINT(8)
      HTN(10,4) = A4*DELINT(11)
      HTN(11,1) = A2*DELINT(7)
      HTN(11,2) = A2*DELINT(10)
      HTN(11,3) = A2*DELINT(8)
      HTN(11,4) = A2*DELINT(11)
      HTN(12,1) = A2*DELINT(10) + A4*DELINT( 8)
      HTN(12,2) = A2*DELINT(13) + A4*DELINT(11)
      HTN(12,3) = A2*DELINT(11) + A4*DELINT( 9)
      HTN(12,4) = A2*DELINT(14) + A4*DELINT(12)
C
C     COMPUTE LITTLE H MATRIX (INVERSE OF PARTITION OF GABABQ)
C
      IF (ABS(R2-R1) .LT. 1.0E-16) GO TO 930
      IF (ABS(R3-R4) .LT. 1.0E-16) GO TO 930
      IF (ABS(Z4-Z1) .LT. 1.0E-16) GO TO 930
      A      = 1.0/((R2-R1)*(R3-R4)*(Z4-Z1))
      R34A   = A*(R3-R4)
      R21A   = A*(R2-R1)
      H(1,1) = R34A*R2*Z4
      H(1,2) =-R1*Z4*R34A
      H(1,3) = R4*Z1*R21A
      H(1,4) =-R3*Z1*R21A
      H(2,1) =-Z4*R34A
      H(2,2) = Z4*R34A
      H(2,3) =-Z1*R21A
      H(2,4) = Z1*R21A
      H(3,1) =-R2*A*(R2-R4)
      H(3,2) = R1*R34A
      H(3,3) =-R4*R21A
      H(3,4) = R3*R21A
      H(4,1) = R34A
      H(4,2) =-R34A
      H(4,3) = R21A
      H(4,4) =-R21A
C
C     COMPUTE TI
C
      DGAMR = TZERO
      IF (AJHO .GT. 0.0) DGAMR = 0.0
      DO 680 I = 1,4
      TI(I) = TI(I) - DGAMR
  680 CONTINUE
C
C     COMPUTE THE THEMAL LOAD IN FIELD COORDINATES
C
      CALL GMMATS (H,  4, 4,1, TI(1),4,1,0, TL(1))
      CALL GMMATS (HTN,4,12,1, TL(1),4,1,0, D(1) )
C
C     TRANSFORM THE THERMAL LOAD TO GRID POINT DEGREES OF FREEDOM
C     ***  COORDINATE SYSTEMS NOT POSSIBLE  *******
C     ***  WITH RINGAX.  THE FOLLOWING CODE WILL IMPLEMENT IT. LRK ***
C     ***  THE FOLLOWING GMMATS HAS D(20) INSTEAD OF TL(1)        ****
C
      CALL GMMATS (GABABQ,12,12,1, D(1),12,1,0,TL(1))
C
C     LOCATE THE TRANSFORMATION MATRICES FOR THE THREE GRID POINTS
C.    DO 750 I = 1,144
C.    AKI (I) = 0.0
C.750 CONTINUE
C.    DO 800 I = 1,4
C.    CALL GBTRAN (ICS(I),IECPT(4*I+20),D)   $ THIS IS WRONG ANYWAY
C.    K = 39*(I-1) + 1
C.    DO 800 J = 1,3
C.    KK = K + 12*(J-1)
C.    JJ = 3*(J-1) + 1
C.    AKI(KK  ) = D(JJ  )
C.    AKI(KK+1) = D(JJ+1)
C.    AKI(KK+2) = D(JJ+2)
C.800 CONTINUE
C
C     ADD THE ELEMENT THERMAL LOAD TO THE STRUCTURE THERMAL LOAD
C
C.    CALL GMMATS ( AKI(1), 12, 12, 1, D(20), 12, 1, 0, TL(1) )
C
      DGAMR = PI
      IF (AJHO .EQ. 0.0) DGAMR = 2.0*PI
C
      DO 850 I = 1,12
      TL(I) = DGAMR*TL(I)
  850 CONTINUE
C
      K = 0
      DO 900 I = 1,4
      L = IGP(I) - 1
      DO 900 J = 1,3
      K = K + 1
      L = L + 1
      PG(L) = PG(L) + TL(K)
  900 CONTINUE
      GO TO 950
C
  910 I = 37
      GO TO 925
  915 I = 218
      GO TO 935
  925 J =-30
      GO TO 945
  930 I = 31
      GO TO 925
  935 J = 30
      IF (IDEL1 .EQ. IDEL2) GO TO 950
      IDEL2 = IDEL1
      SP(2) = JAX
  945 SP(1) = IDEL1
      CALL MESAGE (J,I,SP)
  950 RETURN
      END

      SUBROUTINE TA1H
C
C     FOR LEVEL 16 A MAJOR REVISION HAS BEEN MADE TO TA1B. THE ECPT AND
C     GPCT ARE NO LONGER CONTSTRUCTED BUT, INSTEAD, THE GPECT IS BUILT.
C     THE GPECT IS ESSENTIALLY A TRUNCATED VERSION OF THE OLD ECPT. IT
C     CONTAINS ONE LOGICAL RECORD FOR EACH GRID OR SCALAR POINT IN THE
C     MODEL. EACH LOGICAL RECORD CONTAINS THE CONNECTION DATA FOR EACH
C     ELEMENT CONNECTED TO THE GRID POINT.
C
      EXTERNAL        ANDF
      INTEGER         GENL  ,ECT   ,EPT   ,BGPDT ,SIL   ,GPTT  ,CSTM  ,
     1                EST   ,GEI   ,ECPT  ,GPCT  ,SCR1  ,SCR2  ,SCR3  ,
     2                SCR4  ,Z     ,SYSBUF,TEMPID,ELEM  ,TEMPSZ,ELEMID,
     3                OUTPT ,RD    ,RDREW ,WRT   ,WRTREW,CLSREW,CLS   ,
     4                BUF   ,FLAG  ,BUF1  ,BUF2  ,BUF3  ,OP    ,TWO24 ,
     5                SCRI  ,SCRO  ,BLK   ,OUFILE,ANDF  ,OUT(3),GPECT ,
     6                EQEXIN
      DIMENSION       BUF(50)      ,BUFR(50)     ,NAM(2),BLK(2),ZZ(1)
      COMMON /BLANK / LUSET ,NOSIMP,NOSUP ,NOGENL,GENL  ,COMPS
      COMMON /TA1COM/ NSIL  ,ECT   ,EPT   ,BGPDT ,SIL   ,GPTT  ,CSTM  ,
     1                MPT   ,EST   ,GEI   ,GPECT ,ECPT  ,GPCT  ,MPTX  ,
     2                PCOMPS,EPTX  ,SCR1  ,SCR2  ,SCR3  ,SCR4  ,EQEXIN
      COMMON /SYSTEM/ KSYSTM(65)
      COMMON /GPTA1 / NELEM ,JLAST ,INCR  ,ELEM(1)
      COMMON /NAMES / RD    ,RDREW ,WRT   ,WRTREW,CLSREW,CLS
      COMMON /TA1AB / TEMPSZ
CZZ   COMMON /ZZTAA2/ Z(1)
      COMMON /ZZZZZZ/ Z(20000)
      EQUIVALENCE     (KSYSTM( 1),SYSBUF) ,(KSYSTM(2),OUTPT),
     1                (KSYSTM(10),TEMPID) ,(BUF(1),BUFR(1)) ,
     2                (Z(1),ZZ(1))        ,(BLK(2),N)
      DATA    NAM   / 4HTA1H, 4H    /     ,TWO24  / 4194304 /
C
C     PERFORM GENERAL INITIALIZATION
C
      N2   = 2*NELEM - 1
      N21  = N2 + 1
      BUF1 = KORSZ(Z) - SYSBUF - 2
      BUF2 = BUF1 - SYSBUF
      BUF3 = BUF2 - SYSBUF
CWKBR spr 93012      NEQ1 = NSIL + 1
      NEQ1 = NSIL + 2
      NEQ2 = 0
C
C     THE GRID POINT COUNTER(GPC)HAS ONE ENTRY PER GRID OR SCALAR POINT
C     IN THE STRUCTURE. EACH ENTRY CONTAINS THE NUMBER OF STRUCTURAL
C     ELEMENTS CONNECTED TO THE POINT.
C
      DO 2001 I = 1,NSIL
 2001 Z(I+1) = 0
C
C     OPEN THE ECT. INITIALIZE TO LOOP THRU BY ELEMENT TYPE.
C
      FILE = ECT
      CALL GOPEN (ECT,Z(BUF1),RDREW)
      NOECT = 1
C
C     IGNORE PLOTEL AND REACT ELEMENTS. OTHERWISE, LOCATE AN ELEMENT
C     TYPE. IF PRESENT, READ ALL ELEMENTS OF THAT TYPE AND INCREMENT
C     THE GPC ENTRY FOR EACH POINT TO WHICH THE ELEMENT IS CONNECTED.
C
 2012 CALL ECTLOC (*2026,ECT,BUF,I)
      NOECT = 0
      LX = ELEM(I+12)
      MM = LX+ELEM(I+9) - 1
      M  = ELEM(I+5)
 2021 CALL READ (*3201,*2012,ECT,BUF,M,0,FLAG)
      DO 2022 L = LX,MM
      K  = BUF(L)
      IF (K .NE. 0) Z(K+1) = Z(K+1) + 1
 2022 CONTINUE
      GO TO 2021
 2026 CONTINUE
      IF (NOECT .NE. 0) GO TO 3209
C
C     REPLACE ENTRIES IN THE GPC BY A RUNNING SUM
C     THUS CREATING POINTERS INTO ECPT0
C     QUEUE WARNING MESSAGES FOR GRID PTS. WITH NO ELEMENTS CONNECTED.
C
      Z(1)  = 1
      MAXEL = 0
      DO 2037 I = 1,NSIL
      MAXEL = MAX0(MAXEL,Z(I+1))
      IF (Z(I+1) .NE. 0) GO TO 2037
C
      J = 0
      IF (NEQ2) 2035,2031,2033
 2031 NEQ2 = -1
      Z(NEQ1) = EQEXIN
      CALL RDTRL (Z(NEQ1))
      IF (Z(NEQ1) .LE. 0) GO TO 2035
      FILE = EQEXIN
      CALL GOPEN (EQEXIN,Z(BUF2),RDREW)
      CALL READ (*3200,*2032,EQEXIN,Z(NEQ1),BUF3,1,NEQ2)
 2032 CALL CLOSE (EQEXIN,CLSREW)
      CALL SORT (0,0,2,2,Z(NEQ1),NEQ2)
 2033 J = Z((I-1)*2+NEQ1)
C
 2035 BUF(1) = I
      BUF(2) = J
      CALL MESAGE (30,15,BUF)
 2037 Z(I+1) = Z(I) + Z(I+1)
C
C     DETERMINE BAND OF ENTRIES IN ECPT0 WHICH WILL FIT IN CORE
C     NDX1 = POINTER IN GPC TO 1ST  ENTRY FOR CURRENT PASS.
C     NDX2 = POINTER IN GPC TO LAST ENTRY FOR CURRENT PASS.
C
      NDX1 = 1
      NDX2 = NSIL
      LLX  = 1
      IECPT0 = NSIL + 2
      LENGTH = BUF1 - IECPT0
      OP = WRTREW
 2042 IF (Z(NDX2+1)-Z(NDX1)+2 .LE. LENGTH) GO TO 2050
      NDX2 = NDX2 - 1
      GO TO 2042
C
C     PASS THE ECT. FOR EACH GRID PT IN RANGE ON THIS PASS,
C     STORE ELEMENT POINTER = 2**K * J + WORD POSITION IN ECT RECORD
C     WHERE K=22 FOR LEVEL 16 AND J = ENTRY NBR OF ELEMENT IN /GPTA1/
C     (WHICH IS SAME AS ELEMENT TYPE AS OF LEVEL 15)
C
 2050 FILE = ECT
      CALL GOPEN (ECT,Z(BUF1),RDREW)
      IZERO = Z(NDX1)
 2051 CALL ECTLOC (*2059,ECT,BUF,I)
      J  = (I-1)/INCR + 1
      IDCNTR = TWO24*J
      M  = ELEM(I+5)
      LX = ELEM(I+12)
      MM = LX + ELEM(I+9) - 1
 2052 CALL READ (*3201,*2051,ECT,BUF,M,0,FLAG)
      DO 2054 L = LX,MM
      K  = BUF(L)
      IF (K.LT.NDX1 .OR. K.GT.NDX2) GO TO 2054
      IX = Z(K) - IZERO + IECPT0
      Z(IX) = IDCNTR
      Z(K)  = Z(K) + 1
 2054 CONTINUE
      IDCNTR = IDCNTR + M
      GO TO 2052
 2059 CONTINUE
C
C     WRITE ECPT0 AND TEST FOR ADDITIONAL PASSES
C     ECPT0 CONTAINS ONE LOGICAL RECORD FOR EACH GRID OR SCALAR POINT.
C     EACH LOGICAL RECORD CONTAINS N PAIRS OF(-1,ELEMENT POINTER)WHERE
C     N= NUMBER OF ELEMENTS CONNECTED TO THE PIVOT.
C     IF NO ELEMENTS CONNECTED TO POINT, RECORD IS ONE WORD = 0.
C
      FILE = SCR1
      CALL OPEN (*3200,SCR1,Z(BUF1),OP)
      ELEMID =  1
      BUF(1) = -1
      LJ = IECPT0 - 1
      DO 2062 I = NDX1,NDX2
      M  = Z(I) - LLX
      IF (M .NE. 0) GO TO 2063
      CALL WRITE (SCR1,0,1,1)
      GO TO 2062
 2063 DO 2061 J = 1,M
      LJ = LJ + 1
      BUF(2) = Z(LJ)
 2061 CALL WRITE (SCR1,BUF,2,0)
      CALL WRITE (SCR1,0,0,1)
 2062 LLX = Z(I)
      IF (NDX2 .GE. NSIL) GO TO 2070
      CALL CLOSE (SCR1,CLS)
      NDX1 = NDX2 + 1
      NDX2 = NSIL
      OP   = WRT
      GO TO 2042
C
C     READ AS MUCH OF ECT AS CORE CAN HOLD
C     FIRST N21 CELLS OF CORE CONTAIN A POINTER TABLE WHICH HAS TWO
C     ENTRIES PER ELEMENT TYPE. 1ST ENTRY HAS POINTER TO 1ST WORD OF
C     ECT DATA IN CORE FOR AN ELEMENT TYPE  2ND ENTRY HAS WORD POSITION
C     IN ECT RECORD OF THAT TYPE FOR LAST ENTRY READ ON PREVIOUS PASS.
C
 2070 CALL CLOSE (SCR1,CLSREW)
      SCRI = SCR1
      SCRO = SCR2
      FILE = ECT
      CALL GOPEN (ECT,Z(BUF1),RDREW)
      DO 2071 J = 1,N21
 2071 Z(J) = 0
      L = N21 + 1
 2072 CALL ECTLOC (*2080,ECT,BUF,IELEM)
      I = 2*((IELEM-1)/INCR + 1) - 1
      Z(I) = L
      LL   = 0
      M    = ELEM(IELEM+5)
      LAST = BUF3-M
 2073 IF (L .GT. LAST) GO TO 2080
      CALL READ (*3201,*2074,ECT,Z(L),M,0,FLAG)
      Z(L)   = ELEMID
      ELEMID = ELEMID +1
      L  = L  + M
      LL = LL + M
      GO TO 2073
 2074 CONTINUE
      GO TO 2072
C
C     PASS ECPT0 ENTRIES LINE BY LINE
C     ATTACH EACH REFERENCED ECT ENTRY WHICH IS NOW IN CORE
C
 2080 FILE = SCRI
      CALL OPEN (*3200,SCRI,Z(BUF2),RDREW)
      CALL OPEN (*3200,SCRO,Z(BUF3),WRTREW)
 2082 CALL READ (*2090,*2086,SCRI,BUF,1,0,FLAG)
      IF (BUF(1)) 2083,2087,2085
 2083 CALL READ (*3201,*3202,SCRI,BUF(2),1,0,FLAG)
      KHR = BUF(2)/TWO24
      KTWO24 = KHR*TWO24
      K  = 2*KHR - 1
      IDPTR = BUF(2) - KTWO24
      KK = Z(K) + IDPTR - Z(K+1)
      IF (Z(K).EQ.0 .OR. KK.GT.LAST) GO TO 2084
      J  = (KHR-1)*INCR + 1
      MM = ELEM(J+5)
      BUF(1) = MM
      BUF(2) = ANDF(Z(KK),TWO24-1) + KTWO24
      CALL WRITE (SCRO,BUF,2,0)
      CALL WRITE (SCRO,Z(KK+1),MM-1,0)
      GO TO 2082
 2084 CALL WRITE (SCRO,BUF,2,0)
      GO TO 2082
 2085 CALL READ  (*3201,*3202,SCRI,BUF(2),BUF(1),0,FLAG)
      CALL WRITE (SCRO,BUF,BUF(1)+1,0)
      GO TO 2082
 2086 CALL WRITE (SCRO,0,0,1)
      GO TO 2082
 2087 CALL WRITE (SCRO,0,1,1)
      CALL FWDREC (*3201,SCRI)
      GO TO 2082
C
C     TEST FOR COMPLETION OF STEP
C     IF INCOMPLETE, SET FOR NEXT PASS
C
 2090 CALL CLOSE (SCRI,CLSREW)
      CALL CLOSE (SCRO,CLSREW)
      IF (IELEM .EQ. 0) GO TO 2100
      K = SCRI
      SCRI = SCRO
      SCRO = K
      L = N21 + 1
      DO 2091 J = 1,N21
 2091 Z(J) = 0
      Z(I) = L
      Z(I+1) = LL
      GO TO 2073
C
C     READ THE SIL INTO CORE. OPEN ECPT0 AND GPECT.
C     WRITE HEADER RECORD ON GPECT - 3RD WORD = NO OF ENTRIES IN /GPTA1/
C
 2100 FILE = SIL
      CALL GOPEN (SIL,Z(BUF1),RDREW)
      CALL FREAD (SIL,Z,NSIL,1)
      Z(NSIL+1) = LUSET + 1
      CALL CLOSE (SIL,CLSREW)
      INFILE = SCRO
      OUFILE = GPECT
      MAXDOF = 0
      FILE   = INFILE
      CALL OPEN (*3200,INFILE,Z(BUF1),RDREW)
      CALL OPEN (*3200,OUFILE,Z(BUF2),WRTREW)
      CALL FNAME (OUFILE,BUF)
      BUF(3) = NELEM
      CALL WRITE (OUFILE,BUF,3,1)
C
C     PASS ECPT0 LINE BY LINE. FOR EACH LINE -
C     1. CONVERT GRID NBRS TO SIL VALUES
C     2. SORT SIL NBRS AND DISCARD MISSING ONES
C     3. WRITE LINE ON GPECT
C
      DO 2158 LL = 1,NSIL
C
C     WRITE SIL AND DOF FOR PIVOT
C
      BUF(1) = Z(LL)
      BUF(2) = Z(LL+1) - Z(LL)
      CALL WRITE (OUFILE,BUF,2,0)
C
C     READ AN ECT LINE FROM ECPT0. SET POINTERS AS A FUNCTION OF ELEM
C     TYPE.
C
 2140 CALL READ (*3201,*2154,INFILE,BUF,1,0,FLAG)
      IF (BUF(1)) 3207, 2150, 2142
 2142 CALL READ (*3201,*3202,INFILE,BUF(2),BUF(1),0,FLAG)
      KHR   = BUF(2)/TWO24
      IELEM = (KHR-1)*INCR + 1
      NGRIDS= ELEM(IELEM+9)
      IGR1  = ELEM(IELEM+12) + 1
      IGR2  = IGR1 + NGRIDS - 1
      MAXEL = 0
C
C     CONVERT GRID NUMBERS TO SIL VALUES. DISCARD ANY MISSING (ZERO)
C     GRID POINTS THEN SORT LIST ON SIL VALUE
C
      DO 2146 II = IGR1,IGR2
      K = BUF(II)
      IF (K .NE. 0) GO TO 2145
      BUF(II) = 2147483647
      NGRIDS  = NGRIDS - 1
      GO TO 2146
 2145 BUF(II) = Z(K)
      MAXEL   = MAX0(MAXEL,Z(K+1)-Z(K))
 2146 CONTINUE
      CALL SORT (0,0,1,1,BUF(IGR1),ELEM(IELEM+9))
      MAXDOF = MAX0(MAXDOF,NGRIDS*MAXEL)
C
C     WRITE A LINE ON GPECT.
C     - NUMBER OF WORDS IN ENTRY (NOT INCLUDING THIS WORD)
C       ELEMENT ID
C       ELEMENT TYPE
C       THE SORTED SIL LIST FOR THE GRID POINTS
C
      OUT(1) = -(NGRIDS+2)
      OUT(2) = BUF(2) - KHR*TWO24
      OUT(3) = ELEM(IELEM+2)
      CALL WRITE (OUFILE,OUT,3,0)
      CALL WRITE (OUFILE,BUF(IGR1),NGRIDS,0)
      GO TO 2140
C
C     HERE IF NO ELEMENTS CONNECTED TO PIVOT.
C
 2150 CALL WRITE (OUFILE,0,0,1)
      CALL FWDREC (*3202,INFILE)
      GO TO 2158
C
C     HERE WHEN ALL ELEMENTS COMPLETE FOR CURRENT PIVOT
C
 2154 CALL WRITE (OUFILE,0,0,1)
 2158 CONTINUE
C
C     CLOSE FILES, WRITE TRAILER AND RETURN.
C
      CALL CLOSE (INFILE,CLSREW)
      CALL CLOSE (OUFILE,CLSREW)
      BUF(1) = OUFILE
      BUF(2) = NELEM
      BUF(3) = NSIL
      BUF(4) = MAXEL
      BUF(5) = MAXDOF
      BUF(6) = 0
      BUF(7) = 0
      CALL WRTTRL (BUF)
      RETURN
C
C     FATAL ERROR MESAGES
C
 3200 J = -1
      GO TO 3220
 3201 J = -2
      GO TO 3220
 3202 J = -3
      GO TO 3220
 3207 BUF(1) = 0
      BUF(2) = 0
      CALL MESAGE (-30,14,BUF)
 3209 BUF(1) = 0
      BUF(2) = 0
      CALL MESAGE (-30,13,BUF)
      BUF(1) = TEMPID
      BUF(2) = 0
      N = 44
      GO TO 3219
 3219 CALL MESAGE (-30,N,BUF)
 3220 CALL MESAGE (J,FILE,NAM)
      RETURN
      END

      SUBROUTINE TRIF (XC,YC,ZC,IVECT,JVECT,KVECT,A,B,C,ID,ELEM)
C
C     CALCULATEIONS FOR THE TRIANGLE USED IN TRIM6,TRPLT1,TRSHL - THE HI
C     LEVEL PLATE ELEMENTS.  COMPUTATIONS IN SINGLE PRECISION ONLY
C
C     IVECT, JVECT, AND KVECT ARE UNIT VECTORS OF THE TRIANGLE
C     B IS THE DISTANCE OF THE GRID POINT 1
C     A IS THE DISTANCE OF THE GRID POINT 3
C     C IS THE DISTANCE OF THE GRID POINT 5
C
      LOGICAL         NOGO
      REAL            IVECT(3),JVECT(3),KVECT(3),XC(6),YC(6),ZC(6),
     1                ELEM(2)
      CHARACTER       UFM*23
      COMMON /XMSSG / UFM
      COMMON /SYSTEM/ IBUF,NOUT,NOGO
C
C     EVALUATE DIRECTIONAL COSINES
C
      X1 = XC(3) - XC(1)
      Y1 = YC(3) - YC(1)
      Z1 = ZC(3) - ZC(1)
      X2 = XC(5) - XC(1)
      Y2 = YC(5) - YC(1)
      Z2 = ZC(5) - ZC(1)
      TEMP = X1*X1 + Y1*Y1 + Z1*Z1
      IF (TEMP .LE. 1.0E-10) GO TO 40
      TEMP = SQRT(TEMP)
C
C     I-VECTOR
C
      IVECT(1) = X1/TEMP
      IVECT(2) = Y1/TEMP
      IVECT(3) = Z1/TEMP
      SAVE = TEMP
C
C     NON-NORMALIZED K-VECTOR
C
      KVECT(1) = IVECT(2)*Z2 - Y2*IVECT(3)
      KVECT(2) = IVECT(3)*X2 - Z2*IVECT(1)
      KVECT(3) = IVECT(1)*Y2 - X2*IVECT(2)
      TEMP = SQRT(KVECT(1)**2 + KVECT(2)**2 + KVECT(3)**2)
      IF (TEMP .LE. 1.0E-10) GO TO 50
C
C     NORMALIZE K-VECTOR
C     DISTANCE C OF THE TRAINGLE IS TEMP
C
      KVECT(1) = KVECT(1)/TEMP
      KVECT(2) = KVECT(2)/TEMP
      KVECT(3) = KVECT(3)/TEMP
      C = TEMP
C
C     J-VECTOR = K X I VECTORS
C
      JVECT(1) = KVECT(2)*IVECT(3) - IVECT(2)*KVECT(3)
      JVECT(2) = KVECT(3)*IVECT(1) - IVECT(3)*KVECT(1)
      JVECT(3) = KVECT(1)*IVECT(2) - IVECT(1)*KVECT(2)
      TEMP = SQRT(JVECT(1)**2 + JVECT(2)**2 + JVECT(3)**2)
      IF (TEMP .LE. 1.0E-10) GO TO 60
C
C     NORMALIZE J-VECTOR TO MAKE SURE
C
      JVECT(1) = JVECT(1)/TEMP
      JVECT(2) = JVECT(2)/TEMP
      JVECT(3) = JVECT(3)/TEMP
C
C     DISTANCE B OF THE TRIANGLE IS OBTAINED BY DOTTING (X2,Y2,Z2) WITH
C     THE IVECT UNIT VECTOR
C
      B = X2*IVECT(1) + Y2*IVECT(2) + Z2*IVECT(3)
C
C     THE LOCAL X AND Y COORINATES OF THE SIX GRID PTS. ARE AS FOLLOWS
C
      YC(1) = 0.0
      YC(2) = 0.0
      YC(3) = 0.0
      YC(4) = C*0.5
      YC(5) = C
      YC(6) = YC(4)
C
C     THE TRIANGLE SHOULD BELONG TO
C
C     KASE1 (ACUTE ANGLES AT GRID POINTS 1 AND 3),
C     KASE2 (OBTUSE ANGLE AT GRID POINT 3), OR
C     KASE3 (OBTUSE ANGLE AT GRID POINT 1)
C
C     KASE  = 1
C     IF (B .GT. SAVE) KASE = 2
C     IF (B .LT.  0.0) KASE = 3
      TEMP  = -B
C     IF (KASE .EQ. 3) TEMP = ABS(B)
C     IF (B .LT.  0.0) TEMP = ABS(B)
      XC(1) = TEMP
      XC(2) = TEMP + SAVE*0.5
      XC(3) = TEMP + SAVE
      XC(4) = XC(3)*0.5
      XC(5) = 0.0
      XC(6) = XC(1)*0.5
C
C     RE-SET DISTANCE A AND B
C
      B = ABS(B)
      A = ABS(XC(3))
      RETURN
C
C     GEOMETRY ERRORS
C
 40   WRITE (NOUT,140) UFM,ELEM,ID
      GO TO 80
 50   WRITE (NOUT,150) UFM,ELEM,ID
      GO TO 80
 60   WRITE (NOUT,160) UFM,ELEM,ID
 80   NOGO = .TRUE.
C
 140  FORMAT (A23,' 2404, GRID POINTS 1 AND 3 OF ',A4,A2,
     1       ' WITH ELEMENT ID =',I9,' HAVE SAME COORDINATES.')
 150  FORMAT (A23,' 2405, GRID POINTS 1, 3, AND 5 OF ',A4,A2,' WITH ',
     1       'ELEMENT ID =',I9,' APPEAR TO BE ON A STRAIGHT LINE.')
 160  FORMAT (A23,' 2406, GRID POINTS 1 AND 5 OF ',A4,A2,
     1       ' WITH ELEMENT ID =',I9,' HAVE SAME COORDINATES.')
      RETURN
      END

      SUBROUTINE PRTMSG
C
      COMMON /ZZZZZZ/ BUF(1)
      COMMON /OUTPUT/ TITLE(32,6)
C
      DATA INPREW,MSG,BLANK / 0,101,4H    /
C
      CALL OPEN (*110,MSG,BUF,INPREW)
      CALL READ (*110,*110,MSG,0,0,1,J)
      DO 100 J = 4,6
      DO 100 I = 1,32
      TITLE(I,J) = BLANK
  100 CONTINUE
      CALL WRTMSG (MSG)
  110 RETURN
      END

      SUBROUTINE GKAM1A (MI,PHIDH,SDT,SCR1,SCR2,IOPT,IOUT,NOPP,W,NW,
     1                   NOSDT,LHSET,I2DD,IWS,SCR3)
C
      INTEGER          PHIDH,SDT,SCR1,SCR2,SYSBUF,MCB(7),SCR3,FILE,
     1                 NAME(2),IHH(3)
      DOUBLE PRECISION MD,MC,MA(2),ZERO(2)
      DIMENSION        W(1),ITAB(2),ITABT(13)
      CHARACTER        UFM*23,UWM*25,UIM*29,SFM*25
      COMMON /XMSSG /  UFM,UWM,UIM,SFM
      COMMON /SYSTEM/  KSYSTM(65)
      COMMON /BLANK /  XX(9), KDAMP
      COMMON /CONDAS/  PI,TWOPHI,RADEG,DEGRA,S4PISQ
      COMMON /PACKX /  IT1,IT2,II,JJ,INCR
      COMMON /UNPAKX/  IT11,III,JJJ,INCR1
      EQUIVALENCE      (KSYSTM(1),SYSBUF), (KSYSTM(2),NOUT),
     1                 (KSYSTM(55),IPREC), (MD,MA(1)), (MC,MA(2))
      DATA    ZERO  /  0.0D0,0.0D0  /
      DATA    NAME  /  4HGKAM,4H1A  /
      DATA    IHH   /  4HMHH ,4HBHH ,4HKHH  /
      DATA    G     /  0.0          /
      DATA    ITABT ,  ITAB(1) / 4,15,21,1,25,22,2,35,23,3,45,24,4,0 /
C
C
      MC = 0.0
      IF (NOPP .LT. 0) GO TO 10
C
C     COMPUTE PHIDH(T)*I2DD*PHIDH ONTO SCR2
C
      CALL SSG2B (I2DD,PHIDH,0,SCR1,0,2,1,IOUT)
      CALL SSG2B (PHIDH,SCR1,0,SCR2,1,2,1,IOUT)
      MCB(1) = I2DD
      CALL RDTRL (MCB)
      IF (MCB(4) .NE. 6) GO TO 11
      MCB(1) = SCR2
      CALL RDTRL (MCB)
      MCB(4) = 6
      CALL WRTTRL (MCB)
   11 CONTINUE
      MII = SCR1
   10 IF (NOPP .LT. 0) MII = IOUT
C
C     BUILD  MII  DATA  BLOCK  = MIXF(W)
C
      LC = KORSZ(W(NW+1))
      NZ = LC - SYSBUF
C
C     RESTORE MODES
C     FILE = SCR3
C
      CALL OPEN (*130,SCR3,W(NZ+1),0)
      CALL FREAD (SCR3,W,NW,1)
      CALL CLOSE (SCR3,1)
      FILE = MI
      CALL OPEN (*170,MI,W(NZ+1),0)
      IMI  = 0
      CALL SKPREC (MI,IWS)
   21 CONTINUE
      NZ   = NZ - SYSBUF
      IBUF = NZ - SYSBUF
      ICRQ = -IBUF
      IF (ICRQ .GT. 0) GO TO 150
      CALL GOPEN (MII,W(NZ+1),1)
      CALL MAKMCB (MCB,MII,LHSET,6,IPREC)
      IF (KDAMP .EQ. 1) MCB(5) = MCB(5) + 2
C
C     SET UP FOR  PACK  AND  UNPACK
C
      IT1  = 2
      IF (KDAMP .EQ. 1) IT1 = 4
      IT2  = MCB(5)
      INCR = 1
      IT11 = 2
      INCR1= 1
      DO 90 I = 1,NW
      MC   = 0.0
      K    = IWS + I - 1
      II   = I
      JJ   = I
      III  = K
      JJJ  = K
      IF (IMI .NE. 0) GO TO 85
      CALL UNPACK (*160,MI,MD)
   22 CONTINUE
      GO TO (30,50,40), IOPT
C
C     BUILDING  MHH
C
   30 CALL PACK (MD,MII,MCB)
      GO TO 90
C
C     BUILDING  KHH
C
   40 MD = MD*W(I)*W(I)
      IF (KDAMP .NE. 1) GO TO 30
      ASSIGN 45 TO IRET
      IF (NOSDT .GT. 0) GO TO 70
   45 MC = G*MD
      GO TO 30
C
C     BUILDING  BHH
C
   50 CONTINUE
      IF (KDAMP .EQ. 1) GO TO 61
      ASSIGN 60 TO IRET
      IF (NOSDT .GT. 0) GO TO 70
   60 MD = MD*W(I)*G
      GO TO 30
   61 MD = 0.0
      GO TO 30
C
C     LOOK UP G(W)  IN  SDT
C
   70 IF (ITAB(1) .GT. 0) GO TO 80
      ITAB(1) = 1
      ITAB(2) = NOSDT
      CALL PRETAB (SDT,W(NW+1),W(NW+1),W(IBUF),IBUF-1,IZ,ITAB(1),ITABT)
   80 CALL TAB (ITAB(2),W(I)/TWOPHI,G)
      GO TO IRET, (60,45)
C
C     PICK UP MODAL MASS FROM LAMA
C
   85 CALL FREAD (MI+1,0,-5,0)
      CALL FREAD (MI+1,XMASS,1,0)
      CALL FREAD (MI+1,0,-1,0)
      MD = XMASS
      GO TO 22
C
C     ADD  INTERPOLATION HERE
C
   90 CONTINUE
      CALL CLOSE (MI  ,1)
      CALL CLOSE (MI+1,1)
      NE = LHSET - NW
      IF (NE .LE. 0) GO TO 110
      DO 100 I = 1,NE
      CALL PACK (ZERO,MII,MCB)
  100 CONTINUE
  110 CALL  WRTTRL (MCB)
      CALL  CLOSE (MII,1)
      RETURN
C
C     ERROR MESAGES
C
  130 IP1  = -1
  140 CALL MESAGE (IP1,FILE,NAME)
      RETURN
  150 IP1  = -8
      FILE = ICRQ
      GO TO 140
  160 WRITE  (NOUT,9001) SFM,IHH(IOPT)
 9001 FORMAT (A25,' 2203, NULL COLUMN FOUND IN MI FILE DURING ASSEMBLY',
     1       ' OF ',A4,' MATRIX BY GKAM MODULE.')
      IP1  = -37
      GO TO 140
C
C     USE LAMA RATHER THAN MI
C
  170 CONTINUE
      CALL GOPEN (MI+1,W(NZ+1),0)
      CALL SKPREC (MI+1,1)
      CALL FREAD (MI+1,MCB,-7*(IWS-1),0)
      IMI = 1
      GO TO 21
      END

      SUBROUTINE MELBOW
C
C     THIS ROUTINE COMPUTES THE MASS MATRIX M(NPVT,NPVT) FOR AN ELBOW.
C
C     ECPT FOR THE ELBOW
C
C     ECPT( 1)  -  IELID        ELEMENT ID. NUMBER
C     ECPT( 2)  -  ISILNO(2)    * SCALAR INDEX NOS. OF THE GRID POINTS
C     ECPT( 3)  -    ...        *
C     ECPT( 9)  -  A            CROSS-SECTIONAL AREA
C     ECPT(13)  -  NSM          NON-STRUCTURAL MASS
C     ECPT(29)  -  R            RADIUS OF CURVATURE
C     ECPT(30)  -  BETAR        ANGLE FROM GA TO GB
C
      LOGICAL          HEAT
      INTEGER          IZ(1),EOR,CLSRW,CLSNRW,FROWIC,TNROWS,OUTRW,BGGIND
      REAL             NSM
      DOUBLE PRECISION TA(9),TB(9),DP(6),VECI(3),DELA(6),DELB(6),FL,
     1                 M(36),DUMDP,FM
      DIMENSION        ECPT(9),IECPT(1)
      COMMON /SMA2HT/  HEAT
      COMMON /SMA2IO/  IFCSTM,IFMPT,IFDIT,IDUM1,IFECPT,IGECPT,IFGPCT,
     1                 IGGPCT,IDUM2,IDUM3,IFMGG,IGMGG,IFBGG,IGBGG,
     2                 IDUM4,IDUM5,INRW,OUTRW,CLSNRW,CLSRW,NEOR,EOR,
     3                 MCBMGG(7),MCBBGG(7)
      COMMON /ZZZZZZ/  Z(1)
C
C     SMA2 VARIABLE CORE BOOKKEEPING PARAMETERS
C
      COMMON /SMA2BK/  ICSTM,NCSTM,IGPCT,NGPCT,IPOINT,NPOINT,I6X6M,
     1                 N6X6M,I6X6B,N6X6B
C
C     SMA2 PROGRAM CONTROL PARAMETERS
C
      COMMON /SMA2CL/  IOPT4,BGGIND,NPVT,LEFT,FROWIC,LROWIC,NROWSC,
     1                 TNROWS,JMAX,NLINKS,LINK(10),NOGO
C
C     ECPT COMMON BLOCK
C
      COMMON /SMA2ET/  IELID,ISILNO(2),SMALLV(3),ICSSV,IMATID,A,I1,I2,
     1                 FJ,NSM,FE,DUM(14),R,BETAR,DUMM(8),TEMPEL
C
C     SMA2 LOCAL VARIABLES
C
      COMMON /SMA2DP/  TA,TB,DP,VECI,DELA,DELB,FL,M,DUMDP
C
C     INPUT AND OUTPUT BLOCKS FOR SUBROUTINE MAT
C
      COMMON /MATIN /  MATIDC,MATFLG,ELTEMP,STRESS,SINTH,COSTH
      COMMON /HMTOUT/  CP
      COMMON /MATOUT/  RHO,PROP(8)
      EQUIVALENCE      (Z(1),IZ(1),DZ),(ECPT(1),IECPT(1),IELID)
      DATA    DCR   /  0.01745329/
C
C     COMPUTE LENGTH OF ELBOW, FL
C
      DP(1) = R
      DP(2) = BETAR
      DP(3) = DCR
      FL    = DP(1)*DP(2)*DP(3)
      IF (FL .EQ. 0.0D0) GO TO 200
      IF (HEAT) GO TO 300
C
C     GET RHO FROM MPT BY CALLING MAT
C
      MATIDC = IMATID
      MATFLG = 4
      ELTEMP = TEMPEL
      CALL MAT (ECPT(1))
      DO 40 I = 1,36
   40 M(I) = 0.0D0
      FM = 0.5*FL*(RHO*A + NSM)
C
C     PUT MASS IN M-ARRAY
C
      M(1)  = FM
      M(8)  = M(1)
      M(15) = M(1)
C
C     INSERT THE 6 X 6
C
      CALL SMA2B (M,NPVT,-1,IFMGG,DUMDP)
      RETURN
C
  200 CALL MESAGE (30,26,IECPT(1))
C
C     SET FLAG FOR FATAL ERROR WHILE ALLOWING ERROR MESSAGES TO
C     ACCUMULATE
C
      NOGO = 1
      RETURN
C
C     HEAT FORMULATION
C
C     GET CP USING -HMAT- ROUTINE.
C
  300 MATIDC = IMATID
      MATFLG = 4
      CALL HMAT (IELID)
      M(1) = FL*DBLE(ECPT(9))*DBLE(CP)/2.0D0
C
C     OUTPUT THE MASS FOR HEAT PROBLEM.
C
      CALL SMA2B (M(1),NPVT,NPVT,IFBGG,DUMDP)
      RETURN
      END

@echo off
set cwd=%cd%
if "%nasthome%"=="" goto notset
goto run

:run
echo The current work Directory is - %cwd%
set rfdir=%nasthome%\rf
set nasexec=%nasthome%\sb\nastran.exe
set naschk=%nasthome%\sb\chkfil.exe
set tmp=%nasthome%\test\tmp
set projectdir=%nasthome%\test

set probname=%1
set dbmem=200000000
set ocmem=100000000
set ft01=none
set ft04=%probname%.dic
set ft05=%probname%.inp
set ft06=%probname%.out
set ft08=none
set ft11=%probname%.op2
set plt2=none
::set plt2=%probname%.plt
mkdir %nasthome%\test\tmp
set nasscr=%tmp%
set ft12=none
set ft15=none
set ft16=none
set sof1=none
set sof2=none
set sft12=
set nptp=%probname%.nptp
set lognm=%probname%.log
echo ---
echo Input file        : %ft05%     
echo Output file       : %ft06% 
echo Logfile           : %lognm% 
echo Punch file        : %ft01% 
echo Plot file         : %plt2% 
echo Checkpoint NPTP   : %nptp% 
echo Checkpoint dict.  : %ft04% 
echo Restart OPTP      : %optp% 
echo FTN11 file        : %ft11% 
echo FTN12 file        : %ft12% 
echo SOF1 file         : %sof1% 
echo SOF2 file         : %sof2% 
echo FTN15 file        : %ft15% 
echo FTN16 file        : %ft16% 
echo --- 
echo Memory for Open Core    : %ocmem%
echo In-Memory DB Allocation : %dbmem%
echo Work Directory          : %nasscr% %sdir%

set NPTPNM=%nptp%
set PLTNM=%probname%.plt
set DICTNM=%ft04%
set PUNCHNM=%probname%.pnh
set OUT11=%probname%.out11
set IN12=%probname%.in12
set DIRCTY=%nasscr%
set LOGNM=%lognm%
set RFDIR=%rfdir%
set SOF1=%sof1%
set SOF2=%sof2%
set OPTPNM=none
set FTN11=%ft11%
set FTN12=none
set FTN13=none
set FTN14=none
set FTN17=none
set FTN18=none
set FTN19=none
set FTN20=none
set FTN15=none
set FTN16=none
set FTN21=none
set FTN22=none
set FTN23=none
set DBMEM=%dbmem%
set OCMEM=%ocmem%
set FT05=%ft05%
set FT06=%ft06%
set CWD=%cwd%
set PROJ=%projectdir%
echo ---
echo ==== NASTRAN is beginning execution of %probname% ====
%nasexec%
echo ====   NASTRAN has completed problem %probname%   ====
goto end

:notset
echo nasthome enviroment variable is NOT defined - aborting...

:end

#!/system/bin/sh
# put in here the name of your problem file
progname="beam"
cwd=$(pwd)
echo The current work Directory is - $cwd
# set this to the correct path
nasthome="/storage/emulated/legacy/Download/N95/"
rfdir="$nasthome/rf"
tmp="$nasthome/test/tmp"
ft05="$progname.inp"
ft06="$progname.out"
nptp="$progname.nptp"
echo Input file is: $ft05
sof1="none"
sof2="none"
projectdir="$nasthome/test"
nasexec="$nasthome/sb/nastran.exe"
cp $nasexec /data/data/com.pdaxrom.cctools/root/cctools/home/
nasexec="/data/data/com.pdaxrom.cctools/root/cctools/home/nastran.exe"
chmod 755 $nasexec
#rm -r $tmp
mkdir -p $tmp
nasscr=$tmp
dbmem="14000000"
ocmem="14000000"
echo ==== NASTRAN is beginning execution of $progname ====
NPTPNM=$nptp;export NPTPNM 
PLTNM="$progname.plt";export PLTNM
DICTNM="none";export DICTNM
PUNCHNM="$progname.pnh" ;export PUNCHNM
OUT11="$progname.out11" ;export OUT11
IN12="$progname.in12" ;export IN12
FTN11="none";export FTN11
FTN12="none";export FTN12
DIRCTY=$nasscr ;export DIRCTY
lognm="$progname.log" 
LOGNM=$lognm;export LOGNM
OPTPNM="none";export OPTPNM
RFDIR=$rfdir ;export RFDIR  
FTN13="none";export FTN13
SOF1=$sof1;export SOF1
SOF2=$sof2  ;export SOF2
FTN14="none";export FTN14
FTN17="none";export FTN17
FTN18="none";export FTN18
FTN19="none";export FTN19
FTN20="none";export FTN20
FTN15="none";export FTN15
FTN16="none";export FTB16
FTN21="none";export FTN21
FTN22="none";export FTN22
FTN23="none";export FTN23
DBMEM=$dbmem;export DBMEM
OCMEM=$ocmem ;export OCMEM
FT05=$ft05;export FT05
FT06=$ft06;export FT06
CWD=$cwd;export CWD
PROJ=$projectdir;export PROJ
#printenv
rm $nptp
$nasexec
echo ===== NASTRAN has completed problem $progname =====

export FT06=$1.out
export NPTPNM=$1.nptp
export PLTNM=$1.plt2
export PUNCHNM=$1.pnh
export OUT11=$1.out11
export IN12=$1.plt
export LOGNM=$1.log
export FT05=$1
export RFDIR=../rf
if [ -z "$SOF1" ]; then
	export SOF1=$1.sof1
fi 
export SOF2=$1.sof2
export DICTNM="none"
export FTN11="none"
export FTN12="none"
export FTN13="none"
export FTN14="none"
export FTN15=$1.out15
export FTN16="none"
export FTN17="none"
export FTN18="none"
export FTN19="none"
export FTN20="none"
export FTN21="none"
export FTN22="none"
export FTN23="none"
export DBMEM="14000000"
export OCMEM="14000000"
export PROJ="."

set > /tmp/set.txt
export DIRCTY="${TMPDIR:-/tmp}"
#valgrind --tool=memcheck --error-limit=no --track-origins=yes --max-stackframe=20000000 
#gdb ../mds/nastran
#ddd ../mds/nastran
../mds/nastran

#!/bin/bash

nasthome=$(dirname $(dirname $(readlink -f $0)))

# TEST ARGUMENT

if [ $# == "0" ]; then
    echo "you must pass an argument"
    exit 1
elif [ $# != "1" ]; then
    echo "you must pass an unique argument"
    exit 2
fi

if [ ! -f "$1" ]; then
    echo "passed argument must be a file"
    exit 3
fi

# ENV VARIABLES

export RFDIR=$nasthome/rf
export DIRCTY="${TMPDIR:-/tmp}"

export FT05=$1

export FT06=$1.out
export NPTPNM=$1.nptp
export PLTNM=$1.plt2
export PUNCHNM=$1.pnh
export OUT11=$1.out11
export IN12=$1.plt
export LOGNM=$1.log

if [ -z "$SOF1" ]; then
	export SOF1=$1.sof1
fi 
export SOF2=$1.sof2
export DICTNM="none"
export FTN11="none"
export FTN12="none"
export FTN13="none"
export FTN14="none"
export FTN15=$1.out15
export FTN16="none"
export FTN17="none"
export FTN18="none"
export FTN19="none"
export FTN20="none"
export FTN21="none"
export FTN22="none"
export FTN23="none"
export DBMEM="14000000"
export OCMEM="14000000"
export PROJ="."
# RUN NASTRAN

$nasthome/mds/nastran
#gdb $nasthome/mds/nastran
